
// clang-format off

/*******************************************************************************
* Copyright 2017-2018 Intel Corporation
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*******************************************************************************/
//
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// It takes quite a while to compute the results.
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// To regenerate:
//
//   $ cd <ngraph source dir>/test
//   $ ./update_reference.sh
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
//

#include <cmath>

#include "gtest/gtest.h"

#include "ngraph/ngraph.hpp"
#include "util/test_tools.hpp"
#include "util/autodiff/numeric_compare.hpp"

using namespace std;
using namespace ngraph;


// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_1item)
{
    Shape shape_a{1,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{1,2,2,4};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.30069998f,-0.17359999f,0.64279998f,0.61279998f,-0.46690000f,-0.12880000f,-0.21680000f,0.43640001f,-0.57989997f,-0.15680000f,-0.35619997f,0.57359998f,0.84409999f,-0.44620000f,-1.35880001f,-0.16069996f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_1item_padded_1_1x1_1)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{1,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{1,2,4,6};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{1,1}, // below_pads
                                                                  CoordinateDiff{1,1}, // above_pads
                                                                  Strides{1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.18260000f,0.32729998f,0.00450000f,0.25089999f,-0.09900000f,-0.40499998f,-0.39209999f,0.30069998f,-0.17359999f,0.64279998f,0.61279998f,-0.98999997f,0.40149999f,-0.46690000f,-0.12880000f,-0.21680000f,0.43640001f,-0.33570001f,-0.18479999f,0.75769998f,-0.05540000f,-0.02270000f,-0.78289998f,0.20750000f,0.25730000f,-0.01530000f,0.12690000f,0.09520000f,-0.26580000f,-0.05400000f,-1.12860000f,-0.57989997f,-0.15680000f,-0.35619997f,0.57359998f,0.77759996f,1.25290002f,0.84409999f,-0.44620000f,-1.35880001f,-0.16069996f,0.50100001f,-0.87120000f,-0.66329998f,0.36449999f,1.09620000f,0.54449997f,-0.22499999f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_1item_padded_2_3x4_5)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{1,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{1,2,8,12};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{2,3}, // below_pads
                                                                  CoordinateDiff{4,5}, // above_pads
                                                                  Strides{1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18260000f,0.32729998f,0.00450000f,0.25089999f,-0.09900000f,-0.40499998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.39209999f,0.30069998f,-0.17359999f,0.64279998f,0.61279998f,-0.98999997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.40149999f,-0.46690000f,-0.12880000f,-0.21680000f,0.43640001f,-0.33570001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.18479999f,0.75769998f,-0.05540000f,-0.02270000f,-0.78289998f,0.20750000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.25730000f,-0.01530000f,0.12690000f,0.09520000f,-0.26580000f,-0.05400000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.12860000f,-0.57989997f,-0.15680000f,-0.35619997f,0.57359998f,0.77759996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.25290002f,0.84409999f,-0.44620000f,-1.35880001f,-0.16069996f,0.50100001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.87120000f,-0.66329998f,0.36449999f,1.09620000f,0.54449997f,-0.22499999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_2items)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{2,2,2,4};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.30069998f,-0.17359999f,0.64279998f,0.61279998f,-0.46690000f,-0.12880000f,-0.21680000f,0.43640001f,-0.57989997f,-0.15680000f,-0.35619997f,0.57359998f,0.84409999f,-0.44620000f,-1.35880001f,-0.16069996f,-0.55349999f,-0.80149999f,0.95809998f,-0.32600000f,-0.51049997f,-0.07100000f,0.08210001f,0.76689997f,1.54280002f,0.30129998f,-0.23019998f,0.10889999f,0.45619996f,-0.83430001f,-0.58619999f,0.82200003f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_2items_strided)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{2,2,1,2};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{2,2},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.30069998f,0.64279998f,-0.57989997f,-0.35619997f,-0.55349999f,0.95809998f,1.54280002f,-0.23019998f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_2items_strided_padded)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{2,2,6,7};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{2,2},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{4,2}, // below_pads
                                                                  CoordinateDiff{5,7}, // above_pads
                                                                  Strides{1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.30069998f,0.64279998f,-0.98999997f,0.0f,0.0f,0.0f,0.0f,0.75769998f,-0.02270000f,0.20750000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.57989997f,-0.35619997f,0.77759996f,0.0f,0.0f,0.0f,0.0f,-0.66329998f,1.09620000f,-0.22499999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.55349999f,0.95809998f,-0.35409999f,0.0f,0.0f,0.0f,0.0f,0.05160000f,-0.71069998f,0.77189999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.54280002f,-0.23019998f,-0.02700000f,0.0f,0.0f,0.0f,0.0f,-0.18990000f,0.25919999f,-0.83699998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_2items_strided_padded_same)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{2,2,3,4};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{2,2},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{2,2}, // below_pads
                                                                  CoordinateDiff{2,2}, // above_pads
                                                                  Strides{1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.30069998f,0.64279998f,-0.98999997f,0.0f,0.75769998f,-0.02270000f,0.20750000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.57989997f,-0.35619997f,0.77759996f,0.0f,-0.66329998f,1.09620000f,-0.22499999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.55349999f,0.95809998f,-0.35409999f,0.0f,0.05160000f,-0.71069998f,0.77189999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.54280002f,-0.23019998f,-0.02700000f,0.0f,-0.18990000f,0.25919999f,-0.83699998f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_2items_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{2,2,1,3};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{2,2},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.93539997f,-0.47259998f,0.50499997f,-1.21719996f,-0.30940001f,0.54850001f,-0.78830000f,-0.60840000f,0.49380000f,-0.42060001f,1.36439999f,-0.41189998f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_2items_dilated_padded)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{2,2,10,12};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{2,2},        // filter_dilation
                                                                  CoordinateDiff{4,2}, // below_pads
                                                                  CoordinateDiff{5,7}, // above_pads
                                                                  Strides{1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18260000f,-0.04620000f,0.47249998f,-0.04610000f,0.00450000f,0.09900000f,-0.40499998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.21780000f,0.01320000f,-0.37729999f,0.20300000f,0.02069999f,0.36000000f,-0.24300000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.01930001f,0.01550000f,0.93539997f,-0.47259998f,0.50499997f,-0.21339999f,-0.63449997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.20790000f,-0.01260000f,-0.88679999f,-0.11820000f,0.37070000f,0.66400000f,-0.44820001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.18479999f,0.02730000f,0.78289998f,0.07690000f,-0.25999999f,-0.73039998f,0.20750000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.25730000f,-0.06510000f,0.18930000f,0.05560000f,-0.25200000f,0.01320000f,-0.05400000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.30690001f,0.01860000f,0.03670000f,0.25160001f,-0.14880001f,0.04800000f,-0.03240000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.54889999f,0.16760000f,-1.21719996f,-0.30940001f,0.54850001f,-0.25079999f,0.82499996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.98010002f,-0.05940000f,0.58409998f,-0.84600002f,0.25560003f,-0.71999999f,0.48600001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.87120000f,0.12870000f,-0.54449997f,0.98820000f,-0.02250001f,0.79199997f,-0.22499999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.13420000f,-0.21780000f,-0.10950000f,-0.52029999f,0.33309999f,-0.15300000f,-0.00900000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.14299999f,0.03740000f,-0.19129998f,0.13370000f,0.04200000f,0.11699999f,-0.33749999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.14790000f,0.23210000f,-0.78830000f,-0.60840000f,0.49380000f,-0.09320001f,0.40189999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.13649999f,-0.03570000f,-0.63609997f,0.08650000f,0.53929999f,0.21579999f,-0.62249999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.01890000f,-0.02310000f,0.23220000f,0.00310000f,-0.81779998f,0.34859998f,0.77189999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.18910001f,-0.30690001f,0.19590000f,-0.16480000f,0.03880000f,-0.02040000f,-0.00120000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.20149999f,0.05270000f,0.10360001f,0.09080000f,-0.20490000f,0.01560000f,-0.04500000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.63180002f,1.01420002f,-0.42060001f,1.36439999f,-0.41189998f,0.33119999f,0.07380000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.64349998f,-0.16830000f,0.12959995f,-0.41039999f,0.32850001f,-0.23399999f,0.67499998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.08910000f,-0.10890000f,0.66150001f,-0.51479999f,-0.24570003f,-0.37799998f,-0.83699998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_3d_2items)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,1,3,5,8};
    Shape shape_b{2,1,2,2,3};
    Shape shape_r{2,2,2,4,6};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1,1},        // move_strides
                                                                  Strides{1,1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0,0}, // below_pads
                                                                  CoordinateDiff{0,0,0}, // above_pads
                                                                  Strides{1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.95999995f,-2.32120000f,0.70140004f,2.33690001f,0.55720000f,-0.36289998f,-0.43580002f,-0.93680000f,0.80769997f,0.23889999f,0.05870001f,-2.05439997f,-1.30679997f,0.71310000f,-0.54079996f,-1.59980001f,-1.42619998f,-1.61610003f,-1.59030002f,-1.26379999f,-1.92800005f,-0.83009993f,0.15850003f,0.25269996f,0.80769999f,0.51849995f,1.15269991f,-1.69649998f,0.24099991f,0.81769996f,0.48230004f,2.52069999f,-0.38679998f,1.17890002f,1.15929998f,1.00419998f,2.20250000f,-0.28880007f,1.75840005f,0.03139999f,-1.15669998f,-0.74599995f,-1.70840001f,-1.43969997f,0.88119999f,-0.73339998f,-0.57709999f,0.30950000f,0.55710000f,-1.00549998f,-1.97899998f,-0.18250000f,2.06200002f,0.50440001f,0.58860001f,-0.62910002f,-0.44669998f,0.87269998f,0.94479999f,-0.49060005f,-0.72779999f,-0.82180000f,0.46030001f,1.19809999f,0.17330000f,-0.67330009f,1.44159999f,0.26359998f,0.87129996f,-0.46870001f,-1.73359995f,-1.93010003f,-0.50640002f,1.38590001f,2.69030000f,1.60039998f,-0.35329998f,-1.03040002f,-1.28990001f,-0.19769995f,0.85549999f,-0.02429995f,-0.68819998f,-0.65999999f,0.26880005f,0.65769998f,-0.26030000f,1.51400003f,-0.96089997f,-0.61480001f,0.84900002f,-0.73880005f,1.28099999f,1.74730000f,-0.38380003f,0.50130003f,0.65250001f,0.01079998f,2.59039997f,0.18859993f,1.07799997f,-0.50960005f,0.49929995f,-0.56299998f,-1.03429996f,-1.31119998f,-1.26529991f,1.80000000f,-1.81569999f,-1.76950001f,0.43330009f,0.81029998f,-0.86680000f,1.43450003f,-1.59049995f,-1.19450003f,-2.23879997f,0.87460000f,-1.76930003f,-0.27089995f,0.69180000f,-0.78620007f,0.48560005f,-0.97580006f,-2.13230000f,-0.06789999f,-2.45459996f,3.60360005f,1.13380000f,2.01449995f,-0.41050007f,1.40400007f,2.08089998f,1.63719996f,1.53310003f,-0.22879996f,0.94930002f,0.55449999f,-0.04740002f,0.40570000f,-1.43610003f,-0.38029994f,-0.47220004f,-2.82260000f,-1.98130001f,-1.06060005f,-0.11289994f,1.02850001f,1.26430002f,2.51600000f,1.73159997f,-0.94530002f,-0.47089997f,-0.20330000f,-1.20570000f,0.31289996f,0.96310002f,-0.59620006f,-2.08600003f,0.87600001f,-0.72230001f,0.08000002f,0.74039997f,-0.22990002f,0.12889998f,0.42129999f,1.23740001f,1.54800001f,-0.63670001f,0.99259997f,0.63610004f,0.45880002f,-0.14690004f,1.60530003f,-1.29230005f,-0.90170003f,-0.33839995f,1.05830000f,0.15469995f,0.50270000f,-1.39050001f,0.52310003f,-0.05029998f,0.88209998f,1.45570003f,0.18100004f,-1.32700001f,0.03089996f,2.68339994f,0.64899998f,2.16680009f,-0.38320003f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_4d_2items)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,1,3,5,8,7};
    Shape shape_b{2,1,2,2,3,1};
    Shape shape_r{2,2,2,4,6,7};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1,1,1},        // move_strides
                                                                  Strides{1,1,1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0,0,0}, // below_pads
                                                                  CoordinateDiff{0,0,0,0}, // above_pads
                                                                  Strides{1,1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{-0.19180002f,-0.68540000f,0.78449998f,0.87879997f,-1.43110005f,1.70670004f,-1.24080000f,0.27080005f,1.42800004f,0.01050001f,0.15770004f,-0.84869997f,0.56960001f,-0.00939997f,-0.06090002f,2.24019998f,-1.13669996f,2.58089995f,-0.38829998f,-0.30110001f,0.02580006f,-0.13310003f,-0.32760010f,-0.36289999f,-3.85979998f,0.39169999f,-0.29749998f,-0.96759998f,-2.46889996f,-0.11750000f,-1.55290001f,0.91630006f,-1.21860002f,0.60409993f,-0.04840000f,-1.14710003f,1.38920000f,0.05900000f,1.00710003f,1.95720009f,0.83359995f,-0.91929995f,1.86299997f,-1.43410001f,0.09750006f,-1.29549999f,-0.39859998f,0.61210006f,1.25139998f,0.44310007f,0.46240004f,-0.12700001f,-0.25709996f,-1.07879999f,0.58389998f,-2.66000008f,2.12269999f,-0.82010006f,-0.24199998f,1.87399997f,2.46759996f,-1.03880000f,-0.27889997f,-0.21270001f,0.47350001f,0.58709996f,-1.02480003f,-1.02460007f,0.22249999f,-2.75579999f,-0.18569999f,0.20550006f,0.69419997f,1.02380004f,-0.02640002f,-0.69310007f,-0.95970004f,1.28659995f,0.28719998f,1.98680005f,-0.17550009f,0.65850006f,-0.50939991f,-0.80789993f,-0.97920003f,1.45100004f,-0.66249999f,1.19199998f,2.06660002f,-0.18980001f,1.60369998f,0.30630006f,-2.61480001f,-0.11040005f,-0.06930001f,-0.13670005f,2.86829998f,1.29489994f,1.01129999f,1.75580004f,-0.11340002f,-0.35589996f,0.45460003f,-1.27680003f,-0.06500001f,-0.94139998f,-1.40759997f,-0.61650004f,0.18400001f,1.13169998f,-2.35150001f,-0.22060005f,1.72630001f,-0.32690003f,0.24010005f,-0.74490004f,0.27190004f,-0.86860004f,0.91540008f,-0.16889998f,-3.22969995f,-0.33419998f,0.13499997f,-0.85659996f,-2.01499997f,0.04730003f,0.83029997f,-1.60040005f,-0.21299998f,-0.93970000f,-2.01330001f,-1.06580000f,0.93750000f,-0.10650001f,-0.68959999f,0.88830001f,1.41160005f,0.84450001f,0.19020005f,-0.39809995f,-0.52260005f,-1.64510006f,1.16359999f,0.04500004f,-1.49820005f,0.57309997f,-1.88120002f,0.22100000f,1.65020005f,-0.12329995f,-0.09720005f,0.05180001f,0.13379999f,-2.94569997f,-1.00050006f,0.38729998f,1.21179995f,0.41080003f,0.41999998f,-0.13990000f,-1.60429999f,-2.39579998f,-0.12600001f,-1.74150001f,1.06419998f,0.52420001f,1.25800002f,-0.88839995f,-0.21360004f,1.29139996f,-1.24920001f,1.22990001f,0.94350001f,-0.75859995f,1.71460005f,-0.43310003f,0.08589992f,-0.93040000f,-0.50990008f,0.94650006f,-1.08650000f,3.50819997f,-1.48460001f,-1.27759996f,-1.99730003f,-1.34949998f,-1.21360000f,0.46840000f,-0.27930004f,-0.42579996f,1.51709997f,0.08820006f,-0.50250004f,-0.08219990f,0.06690002f,0.66059999f,0.28679999f,-0.22570002f,1.09389998f,0.94570003f,0.17110001f,-2.68239995f,1.66469999f,1.03059995f,-1.80980002f,-2.05520000f,0.18950006f,-1.50040000f,0.49100004f,-0.04560006f,1.50680003f,0.94859999f,-1.50269996f,-1.09899999f,0.20360001f,-0.44339999f,0.44360003f,0.78090001f,-0.66970000f,-0.09259998f,1.70949994f,-0.97900001f,-0.35630004f,-0.26939997f,1.23749997f,0.11970000f,1.28139995f,-1.98669994f,0.23190000f,-1.65979998f,-1.69320000f,-0.91219999f,-0.26059994f,1.12149994f,1.60879998f,-1.33989998f,1.18020001f,0.05230004f,0.37579998f,1.25230001f,-1.31480003f,1.71630005f,-0.84250001f,1.81890007f,-0.70310003f,-0.63089991f,0.59509995f,-0.71430003f,-1.65310004f,-1.29270003f,0.84409995f,-1.96489999f,1.43410001f,0.78060000f,-1.35189999f,-1.71770002f,-1.91040001f,-0.14650002f,-2.19530001f,0.74860003f,0.44000003f,1.53460002f,-0.54319996f,-0.16489999f,-1.98899995f,3.02139999f,-0.96819999f,1.61870004f,0.51810000f,-1.45379997f,-0.09949996f,2.00510000f,0.80660003f,0.62780001f,1.63340005f,1.40270002f,0.25909999f,0.10429995f,0.43439993f,1.90129994f,2.52099998f,1.62229995f,-0.27130001f,-1.61980002f,1.18660003f,-1.87769999f,1.12059998f,0.95019994f,-0.12479999f,0.35500005f,1.03600008f,0.52489991f,-0.25240000f,0.21139996f,-0.31289994f,-2.45600004f,-0.66909995f,0.37269994f,-0.70400002f,-0.42770006f,-1.48119996f,-1.89070003f,-0.30129992f,0.74119999f,-1.08770002f,1.24360004f,-2.09249998f,1.35849996f,-0.96070000f,0.85380002f,-2.27150000f,-0.58870002f,-0.76850002f,1.69900001f,-0.62560000f,2.06700002f,0.00169995f,-0.38019997f,0.12870002f,1.25130003f,-0.59999998f,0.06930001f,-0.43749995f,-1.88899999f,-1.70030003f,0.14409995f,-0.14769996f,2.12420004f,0.34480001f,1.06889995f,-0.54920002f,0.23390009f,-1.04790002f,1.22789999f,-1.60140006f,2.24319997f,-0.04090005f,0.23329996f,0.55420003f,0.21940000f,1.41599998f,0.41240001f,-0.26160001f,-0.08330001f,-0.26549995f,1.79780001f,-1.41439998f,0.13089993f,1.29240003f,-1.29270003f,1.05450000f,-0.12839996f,-0.27760002f,2.49370002f,0.60650001f,0.79830001f,1.51360003f,0.35780002f,0.78769999f,-1.25830005f,1.22749999f,1.30930003f,-0.30959999f,-0.44309998f,-0.79520000f,-1.05910001f,-1.12379997f,-1.67259997f,0.40379996f,0.39419999f,-0.01060004f,-1.04099998f,1.23489997f,-1.61439998f,-2.24510000f,-1.05169995f,1.65860001f,-0.56399996f,0.11130002f,1.30989998f,0.83979999f,0.91389998f,-0.37650002f,-0.58629999f,0.43990005f,-0.52339997f,-1.48229999f,-0.16540000f,-2.45200000f,-1.30960001f,1.76260006f,1.90899992f,-0.38829996f,1.79049998f,-2.88039998f,1.68739999f,0.04050004f,1.75819999f,1.48590001f,0.48539996f,0.40519993f,-0.93959996f,0.45419999f,2.39509998f,-1.50309994f,-0.28750002f,-0.71739999f,0.09790001f,-0.76219996f,-1.02260000f,0.56949999f,0.66659997f,0.64409996f,-0.34539997f,0.66210003f,-1.77539998f,0.62950002f,-1.53859996f,-1.69880001f,-0.35540003f,0.14819997f,-0.01850000f,0.28210005f,-0.62849999f,0.07030003f,-0.48060003f,1.22479997f,-1.06820004f,-0.72640002f,-2.16150005f,0.20359996f,1.77200004f,1.40260002f,0.61790002f,1.66780005f,-1.35480005f,-0.42500003f,0.98969998f,-0.39640003f,0.49140001f,1.18710003f,-0.66779999f,-0.30900000f,-1.47270003f,0.30179999f,0.83289999f,-0.22180003f,-0.07610001f,-0.81229993f,0.28090005f,-0.22610004f,0.30109999f,1.00350006f,0.50099996f,-1.09169999f,-0.53469999f,-0.53990010f,-0.71600001f,1.90020003f,-1.73190005f,-1.24240000f,-1.49499999f,0.59289997f,0.69329995f,0.07309999f,-0.02499999f,1.89620002f,-0.10330000f,-0.15140002f,1.70690005f,-0.82050004f,-1.44550002f,-0.27430002f,-0.38320001f,-0.85540004f,1.38470002f,0.75199999f,-1.40800005f,1.30279998f,0.54710006f,-0.13950002f,0.66639996f,2.72029998f,-1.15890005f,0.71010006f,0.13439996f,-0.44729995f,-0.03970001f,0.52430001f,0.15730000f,2.50410001f,1.33920003f,2.37540007f,-0.96620004f,0.59689998f,-0.80060002f,0.28929995f,-0.69870003f,0.45350002f,0.77680006f,2.74480005f,-1.46170001f,-0.92020002f,-2.22919996f,2.06470003f,0.65240002f,1.38980000f,0.22510007f,-2.06220002f,-0.12870001f,-1.11740002f,1.01630005f,1.30660000f,0.19710001f,1.96819998f,-1.39159996f,-0.96350002f,0.12790007f,0.07999994f,-0.18380001f,-0.74550002f,-1.04429998f,1.70129997f,-0.78550002f,0.67180002f,-1.00930001f,-0.90309996f,-1.65870002f,0.87639998f,-1.01650001f,1.10919997f,-1.10029999f,-1.32330002f,3.02990001f,0.69380007f,1.37219999f,1.27340005f,0.41669999f,1.68540001f,1.58060001f,-0.58380001f,-0.02050000f,-0.00020005f,-0.89460001f,0.42940000f,-0.45089995f,0.96900003f,1.84000001f,0.73200002f,0.60080002f,-0.20290002f,-0.18259998f,-1.78720004f,0.46370005f,0.28839998f,-1.42560002f,1.44030001f,1.09039997f,0.34750000f,2.39869994f,-0.53060000f,0.36869997f,-1.00680000f,-1.68750001f,0.67970001f,-0.97580002f,1.56630001f,-1.18969997f,-0.52579997f,-0.15810000f,0.00229998f,0.52709996f,-0.67500007f,0.41460001f,-0.02960002f,-0.04959996f,1.80620001f,-0.52500002f,1.21570004f,-1.15849993f,2.26540004f,-0.15830003f,-1.31910000f,-0.96040005f,1.68560003f,-1.44310002f,1.18440006f,-0.54810004f,0.58290003f,0.88439997f,-1.16570003f,-0.72480001f,0.42719999f,2.22359998f,-1.38579998f,0.85400002f,-1.06389998f,-0.76779997f,0.70229994f,0.82859996f,-0.15490000f,-0.04459997f,-1.13140005f,1.07780001f,-1.01390001f,0.53299999f,-0.71339999f,-1.16390000f,-0.47139997f,0.18189998f,0.08500008f,1.21899997f,-0.65799998f,0.38680002f,0.63150001f,0.42600005f,0.14610004f,-0.43559993f,1.83730003f,-0.29630003f,-0.46569996f,0.91809999f,0.95370003f,-1.29369993f,0.73209997f,-0.24389999f,-0.22829997f,-0.37529996f,1.72970000f,0.36519995f,-0.09319996f,-0.30140001f,-0.15430002f,0.26590001f,-0.21350001f,2.31210000f,-0.95989997f,-0.10820003f,-1.55530006f,0.58270002f,-0.39529999f,-0.55049999f,-1.51959998f,-0.49109999f,-0.70660005f,0.38580003f,-0.65660003f,-1.10330007f,-1.57810000f,-0.80759997f,-1.27940002f,-0.65959999f,2.32270004f,0.04549998f,-0.85010003f,-0.31979999f,0.30719994f,0.03889999f,0.66410000f,-0.19409997f,-0.54420002f,1.19549998f,-1.27689996f,0.26520004f,-0.01499998f,1.85560006f,1.11359998f,-2.85200000f,0.86669998f,-0.33140001f,2.38990001f,0.96949999f,-0.85739996f,0.02789999f,-0.23039999f,-0.43500004f,-2.43549998f,-0.33119995f,-1.91679995f,1.58620005f,-0.37590004f,-0.21839999f,0.47040005f,-2.02999994f,0.60659998f,1.01550009f,-0.61560004f,-0.93499997f,-0.50040005f,-1.38559999f,-1.59869997f,2.70889997f,-1.79130007f,-0.05019994f,0.13289994f,0.13610001f,1.02130003f,-1.67549998f,-0.17020002f,-0.68330005f,-0.24630003f,0.34989998f,1.37869992f,-1.42109997f,0.77050000f,0.15489996f,-2.62530001f,-1.86919997f,-1.58050000f,-1.88930002f,0.50190005f,-2.85879996f,-0.64929998f,1.46019999f,1.32609999f,-1.99589998f,2.06670001f,0.54519998f,-1.62679995f,-2.35369997f,-0.17589995f,-1.92350004f,-1.88769998f,-0.46460000f,-2.24740003f,1.22769995f,-0.25349998f,-0.76060004f,0.98660003f,-0.93469992f,0.34260001f,1.24290005f,1.69569997f,-0.25609994f,-0.13830000f,-0.75560001f,0.34649997f,-0.67879996f,1.55630001f,0.85839998f,1.99960004f,-0.05419998f,1.10599998f,-2.09930002f,0.82549995f,-0.03600007f,-1.58279996f,-0.99150004f,0.90450002f,-0.48820004f,-0.82979999f,-0.53360000f,-1.27859999f,3.93079998f,0.40030003f,-0.11570000f,0.05899999f,0.13179997f,-0.30279998f,-1.26659998f,-1.23539997f,-1.82109999f,0.36150002f,0.78039992f,-0.01180006f,-2.34020002f,-1.28499999f,1.50999997f,0.87020001f,0.81649998f,0.80490001f,2.02040004f,1.41590000f,-2.01999996f,-0.18460001f,0.19059999f,0.33899998f,-0.08199997f,-0.07180006f,-2.59540005f,0.97020000f,0.07939996f,0.24599991f,-0.28669998f,-1.70649994f,0.32440006f,-0.02210001f,-1.96180004f,0.15219998f,-0.64980003f,1.93630004f,0.80399999f,0.94250002f,0.05470004f,-0.21190003f,0.86239999f,-2.20290008f,-2.20779997f,1.31939994f,0.31220001f,-0.30569993f,0.64239997f,-0.24169995f,1.20870003f,-0.36009998f,-1.29630002f,-0.38709998f,3.05740001f,0.16630002f,0.57470000f,1.66279992f,-0.01609990f,0.36640001f,0.79060002f,0.17919995f,1.76049995f,2.39210002f,-0.17360002f,0.31020000f,-1.29750004f,-0.09730004f,-0.66799996f,-0.37070000f,1.36019996f,-1.01910006f,-0.12309996f,-1.54309995f,-2.37060003f,0.77560002f,1.47869995f,-1.35090002f,-1.18910000f,-0.01430003f,1.08979995f,-0.51869997f,-0.71359997f,-0.39380001f,-0.74689987f,-1.45390000f,-2.31970000f,-1.02939996f,-0.73369996f,-2.22969997f,1.23050001f,1.23359992f,0.01079997f,-0.18690007f,-0.18279997f,-0.42559993f,1.78279998f,1.17439997f,-1.01460002f,-0.76130001f,-0.80630002f,-0.07919998f,0.86569999f,-0.42259999f,-0.47280001f,0.78550001f,-0.92220004f,2.14949995f,-1.08240005f,0.18860003f,-1.23299994f,-0.91829999f,-0.22640005f,-0.52730004f,-0.69419998f,-0.27359997f,1.48159999f,1.60819999f,0.78989994f,-0.18470000f,0.45900001f,-0.21260001f,0.60339999f,1.06259998f,2.36180003f,-0.79480002f,-1.75700002f,0.05719998f,-0.70479997f,0.34050005f,1.87540002f,-0.91770002f,2.25840004f,-2.06849996f,0.15619994f,1.27900001f,0.29589998f,0.08660000f,0.15849999f,-1.06760003f,0.15510000f,-1.03389997f,-0.09869997f,1.40049998f,-1.22920004f,0.26490001f,1.39150003f,-0.83699998f,-1.40199999f,0.71720001f,-0.50160000f,-1.96059995f,-3.59039999f,-2.19940004f,0.74490005f,0.11150007f,-1.92589996f,0.60789994f,-0.49609999f,0.80970002f,2.24220005f,-1.08100000f,1.03110000f,-0.08450003f,-1.74249999f,-1.73320000f,0.00100003f,0.36349994f,0.32919999f,0.70010005f,-1.07559998f,-0.48569998f,0.37410009f,-0.56390002f,-0.84740004f,-0.14570001f,-0.23900006f,-2.88300002f,0.36240004f,1.21499998f,-0.61420002f,0.94270002f,-1.83849992f,-1.66669999f,-1.73189998f,0.70050006f,-2.37240003f,0.29429998f,-1.35779998f,-0.62470001f,-0.04349994f,1.06609997f,2.01399995f,1.03190003f,-0.50810004f,0.42300005f,-2.18350000f,-0.01030002f,-0.20519998f,-0.42359999f,1.83869991f,-1.64580004f,0.69220010f,0.48579993f,-2.86670005f,3.04560001f,1.06299998f,0.43239998f,0.20369999f,0.04260001f,-0.42239999f,-2.03240000f,0.46189993f,0.71670000f,1.06259998f,0.35830002f,0.39729999f,0.33130001f,2.17430003f,1.73019994f,0.92500005f,1.42689996f,0.60160003f,0.08040000f,0.57830000f,-0.30510006f,2.37919996f,-0.01639995f,-1.58120003f,1.13070003f,-0.64550002f,-0.88670004f,-1.24689998f,-0.09410007f,0.98490001f,0.36460003f,1.55230000f,-1.63740000f,1.86790004f,1.36109997f,2.00520004f,-1.48899995f,1.00480000f,-0.61249994f,-0.40399995f,0.42949998f,-1.61070004f,0.69770006f,-1.04690000f,-1.87500003f,1.57599998f,2.05159996f,1.34699999f,2.81749996f,1.06539995f,-0.05980008f,0.92140001f,2.65849999f,1.70399998f,0.58269999f,-0.30579994f,0.08259998f,-1.13910001f,1.87069999f,0.00790000f,0.57790003f,-0.13240005f,-1.81789992f,-0.33690000f,2.67119999f,-0.22179996f,0.72640002f,-0.53269999f,-0.89020002f,0.83589999f,-0.24849996f,-0.81179994f,-0.24690000f,-1.12700001f,0.32709998f,-0.98040002f,0.43220011f,0.40099999f,1.63899998f,0.40600002f,0.34889999f,-0.73440002f,-0.57110003f,0.65930003f,-0.68500005f,-0.51550000f,0.95999998f,0.65430005f,-1.20259998f,0.76269995f,-1.22119999f,0.34699999f,-0.01889993f,-0.75570000f,1.06450005f,0.31700001f,0.22270001f,-1.69620003f,-2.33170003f,0.19029998f,0.33919992f,-0.20270000f,1.82439999f,-1.38229998f,0.38389998f,-0.93610003f,-1.28369997f,-1.21920001f,2.19290003f,-1.71310004f,0.33609999f,-0.80930002f,0.13409998f,-0.42130001f,1.61759999f,-1.00160000f,1.08310005f,0.99130001f,1.11310005f,-0.21120008f,-0.35410001f,1.94740000f,0.72509997f,0.58340003f,-1.76290000f,-0.32120000f,-0.15569998f,0.75920006f,0.51260001f,0.19490001f,-0.62459999f,-0.38030003f,-1.02530002f,0.46870003f,1.74500003f,0.62930003f,1.80620001f,1.14729998f,-1.73739998f,-1.34740003f,0.00689997f,0.80480004f,-0.73510003f,0.80680000f,0.43370002f,-0.61840003f,1.21359999f,0.07649998f,-0.56240003f,0.01040007f,0.18180006f,-1.60859998f,1.18480000f,-2.30909997f,-0.15709994f,1.56190001f,0.26190003f,-0.23759996f,-0.69970001f,1.02459997f,0.91409996f,-1.53510005f,-0.46099994f,-2.06449999f,-0.39790005f,0.04249995f,-0.28179996f,2.10760000f,0.63130004f,-0.24389998f,-0.21159994f,-1.12410001f,-1.53310004f,-0.28840003f,1.71120001f,-0.42629995f,-0.15719995f,0.54130004f,-0.89720003f,-0.81989999f,-2.77079996f,-1.52959999f,0.41560003f,-0.50270003f,-0.07950000f,-1.43339997f,-1.88110001f,-0.05740002f,-0.02149997f,-2.41109996f,0.16899995f,0.35730005f,1.13869998f,0.12570004f,-0.87269994f,1.54900002f,-0.40659999f,1.58059997f,0.80519999f,0.06139999f,-1.84169998f,-0.24490000f,0.49949999f,-1.79130000f,0.32970001f,-0.17530005f,-0.87620005f,0.07250000f,1.32009992f,0.00650001f,1.51139999f,-0.93120004f,1.13819998f,-1.80030002f,-2.29880000f,-1.83499998f,-2.09900004f,-0.71359998f,0.36630002f,-0.37870003f,-0.66520002f,-0.33849994f,1.58900005f,1.70779998f,1.59539999f,-1.46800000f,-1.02240000f,-0.88240000f,0.00039998f,0.52970001f,0.95329999f,-0.83880002f,-0.19659998f,0.60429998f,0.34390002f,1.12389999f,0.62650000f,0.74650005f,0.73339997f,-0.09260000f,0.45010002f,-1.61419999f,-0.34800001f,1.97019999f,-0.33010002f,-0.21209997f,-1.49239999f,1.10770003f,-1.36660002f,0.59429996f,-0.66950000f,-1.23729995f,0.99610001f,0.59230004f,0.64660009f,0.82980007f,1.77890000f,1.13009999f,-1.12760003f,0.45490003f,0.03249998f,-0.15649998f,-1.14109998f,-0.50839999f,-0.13130002f,1.52469998f,-0.62569997f,-0.22499996f,1.33430004f,-0.56460003f,0.12439997f,-0.34299998f,1.08709998f,-2.11799998f,1.67670003f,1.54120000f,2.26629998f,1.13020006f,-0.27449996f,1.51419997f,1.42609997f,0.17319999f,-0.38940000f,-0.01059999f,-1.16530000f,-1.76439998f,-1.28640003f,0.26799998f,0.62289999f,-0.54199999f,-2.32849999f,-1.62530001f,0.56239995f,-0.07890002f,1.31849998f,1.54069996f,1.12919997f,1.75839996f,1.44969999f,1.05980003f,-0.57429997f,-0.08780002f,-1.26980002f,-1.47550006f,-0.55620002f,-0.17350003f,0.55420001f,1.78779996f,0.85949995f,-1.29060002f,1.71580004f,0.14290000f,-0.67189999f,0.21390000f,1.56189997f,-0.62330000f,-1.77369997f,-0.39870001f,0.18289994f,0.08330004f,0.77749995f,-0.81890002f,-1.16560000f,-0.29609998f,-1.40969999f,0.12299998f,-2.46090000f,0.10850000f,0.89590004f,-0.34779998f,0.47109997f,0.25500003f,0.25219999f,-2.50409999f,-0.80050001f,1.04779999f,-1.62709995f,-0.57019999f,0.51929995f,-0.05230005f,1.15219996f,0.26320001f,0.50770000f,0.48009996f,-2.37960009f,-0.29730000f,-0.02689998f,-1.00130000f,1.02919999f,-0.49340000f,-0.14020001f,-0.41339998f,2.63469999f,-1.63819996f,0.98399996f,1.30630004f,1.28160002f,-0.12829997f,-1.50699999f,0.28480002f,-2.46460001f,-0.11390001f,-0.37110000f,-1.56779998f,0.31919996f,1.56879999f,-0.86410002f,2.28499996f,0.94369995f,-2.43240000f,0.94550001f,0.52359999f,1.93049999f,1.18980000f,-0.83139997f,-0.17720003f,-0.71649996f,-1.53780001f,-0.09129997f,0.59500000f,2.56929996f,-1.60379998f,0.58870003f,0.95780000f,-0.64499999f,0.28149999f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_4d_4items)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{4,3,3,5,8,7};
    Shape shape_b{4,3,2,2,3,1};
    Shape shape_r{4,4,2,4,6,7};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1,1,1},        // move_strides
                                                                  Strides{1,1,1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0,0,0}, // below_pads
                                                                  CoordinateDiff{0,0,0,0}, // above_pads
                                                                  Strides{1,1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f,0.61000000f,0.17000000f,-0.91000000f,-0.48000000f,-0.48000000f,0.12000000f,-0.18000000f,0.08000000f,-0.16000000f,0.54000000f,-0.20000000f,-0.08000000f,0.19000000f,-0.81000000f,0.56000000f,-0.52000000f,0.32000000f,-0.37000000f,-0.17000000f,-0.46000000f,-0.34000000f,0.85000000f,0.11000000f,-0.10000000f,0.98000000f,-0.22000000f,0.68000000f,0.97000000f,-0.93000000f,-0.92000000f,0.32000000f,-0.19000000f,-0.61000000f,0.93000000f,0.54000000f,-0.75000000f,0.63000000f,0.38000000f,0.69000000f,-0.02000000f,0.19000000f,-0.38000000f,-0.44000000f,0.49000000f,-0.62000000f,-0.41000000f,-0.84000000f,0.93000000f,-0.74000000f,-0.57000000f,0.37000000f,-0.86000000f,-0.01000000f,0.58000000f,0.13000000f,-0.42000000f,0.68000000f,-0.05000000f,0.17000000f,0.09000000f,-0.67000000f,0.11000000f,-0.32000000f,0.08000000f,-0.29000000f,0.60000000f,0.69000000f,0.04000000f,0.85000000f,0.46000000f,0.41000000f,-0.78000000f,-0.98000000f,0.50000000f,-0.96000000f,-0.61000000f,-0.58000000f,0.00000000f,0.81000000f,-0.25000000f,-0.74000000f,-0.46000000f,-0.16000000f,0.32000000f,0.56000000f,-0.05000000f,-0.87000000f,0.59000000f,0.08000000f,-0.39000000f,0.67000000f,0.95000000f,0.70000000f,0.00000000f,-0.58000000f,0.85000000f,-0.14000000f,-0.27000000f,-0.63000000f,-0.75000000f,0.61000000f,-0.12000000f,-0.68000000f,-0.83000000f,0.12000000f,0.94000000f,-0.46000000f,0.27000000f,-0.14000000f,-0.96000000f,0.16000000f,-0.57000000f,0.92000000f,-0.24000000f,0.08000000f,0.60000000f,0.23000000f,-0.14000000f,-0.28000000f,0.14000000f,-0.19000000f,0.00000000f,-0.57000000f,0.18000000f,0.42000000f,0.17000000f,0.71000000f,-0.55000000f,0.89000000f,0.26000000f,-0.67000000f,0.68000000f,-0.75000000f,-0.62000000f,0.62000000f,-0.16000000f,-0.69000000f,-0.96000000f,-0.24000000f,0.00000000f,0.63000000f,-0.95000000f,-0.99000000f,0.06000000f,0.02000000f,-0.04000000f,0.95000000f,0.98000000f,0.13000000f,0.96000000f,-0.22000000f,-0.25000000f,-0.77000000f,-0.02000000f,-0.46000000f,0.28000000f,-0.61000000f,-0.56000000f,-0.65000000f,-0.23000000f,-0.41000000f,0.78000000f,-0.46000000f,0.44000000f,0.15000000f,0.46000000f,-0.90000000f,-0.25000000f,0.81000000f,0.28000000f,0.40000000f,0.56000000f,0.62000000f,-0.63000000f,-0.86000000f,-0.97000000f,0.22000000f,-0.58000000f,0.05000000f,0.53000000f,-0.38000000f,0.79000000f,0.60000000f,-0.63000000f,-0.18000000f,0.62000000f,-0.37000000f,0.48000000f,0.86000000f,0.70000000f,-0.52000000f,-0.39000000f,-0.44000000f,-0.69000000f,0.42000000f,-0.69000000f,0.48000000f,0.70000000f,-0.86000000f,-0.90000000f,0.69000000f,0.08000000f,-0.34000000f,-0.86000000f,0.66000000f,0.61000000f,0.47000000f,-0.22000000f,-0.51000000f,-0.29000000f,0.95000000f,-0.30000000f,-0.41000000f,0.85000000f,-0.13000000f,0.70000000f,-0.51000000f,-0.05000000f,-0.50000000f,-0.28000000f,-0.44000000f,0.33000000f,-0.08000000f,-0.88000000f,-0.64000000f,0.24000000f,-0.51000000f,0.67000000f,-0.40000000f,0.48000000f,0.92000000f,-0.64000000f,-0.42000000f,-0.62000000f,-0.77000000f,0.34000000f,0.29000000f,0.49000000f,0.82000000f,-0.30000000f,-0.40000000f,0.27000000f,0.61000000f,-0.75000000f,0.42000000f,0.69000000f,0.46000000f,0.41000000f,0.48000000f,0.14000000f,0.86000000f,-0.46000000f,-0.88000000f,-0.20000000f,-0.09000000f,-0.10000000f,0.70000000f,0.97000000f,-0.99000000f,0.53000000f,-0.51000000f,-0.70000000f,-0.96000000f,0.86000000f,-0.44000000f,-0.66000000f,-0.28000000f,0.08000000f,0.42000000f,-0.45000000f,-0.73000000f,-0.99000000f,-0.33000000f,0.40000000f,-0.86000000f,-0.84000000f,-0.06000000f,0.77000000f,0.96000000f,-0.06000000f,0.24000000f,0.21000000f,0.27000000f,-0.21000000f,-0.01000000f,0.16000000f,0.40000000f,0.06000000f,-0.61000000f,-0.66000000f,0.76000000f,0.43000000f,0.00000000f,0.37000000f,0.70000000f,-0.76000000f,0.50000000f,-0.38000000f,-0.24000000f,-0.80000000f,-0.66000000f,0.09000000f,-0.70000000f,0.83000000f,0.59000000f,-0.39000000f,-0.21000000f,0.84000000f,-0.17000000f,0.50000000f,-0.48000000f,-0.07000000f,-0.54000000f,-0.16000000f,0.99000000f,0.28000000f,0.29000000f,-0.68000000f,-0.49000000f,-0.18000000f,-0.41000000f,0.95000000f,0.72000000f,-0.26000000f,-0.42000000f,-0.27000000f,0.38000000f,-0.47000000f,0.24000000f,-0.38000000f,0.29000000f,0.34000000f,-0.30000000f,-0.64000000f,-0.27000000f,-0.27000000f,-0.94000000f,0.26000000f,0.52000000f,0.92000000f,0.53000000f,-0.80000000f,0.31000000f,0.29000000f,0.16000000f,-0.47000000f,0.61000000f,0.46000000f,-0.75000000f,-0.88000000f,0.95000000f,0.33000000f,-0.97000000f,-0.03000000f,0.43000000f,0.14000000f,0.73000000f,0.97000000f,-0.01000000f,0.45000000f,0.81000000f,0.77000000f,0.45000000f,0.16000000f,-0.66000000f,-0.29000000f,-0.23000000f,0.32000000f,0.22000000f,-0.09000000f,0.65000000f,-0.46000000f,0.65000000f,-0.01000000f,0.61000000f,-0.12000000f,0.36000000f,0.29000000f,-0.87000000f,-0.01000000f,-0.28000000f,-0.95000000f,0.37000000f,0.73000000f,-0.99000000f,0.47000000f,-0.69000000f,-0.31000000f,0.67000000f,-0.78000000f,-0.77000000f,-0.41000000f,0.95000000f,0.61000000f,0.52000000f,0.85000000f,-0.88000000f,0.97000000f,0.54000000f,0.53000000f,0.87000000f,-0.64000000f,-0.62000000f,0.70000000f,-0.11000000f,0.93000000f,-0.52000000f,-0.08000000f,0.03000000f,0.27000000f,-0.30000000f,-0.62000000f,0.00000000f,0.76000000f,0.12000000f,-0.83000000f,-0.60000000f,-0.95000000f,0.51000000f,0.85000000f,-0.27000000f,-0.83000000f,-0.20000000f,-0.45000000f,0.27000000f,-0.09000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.52000000f,-0.43000000f,-0.73000000f,-0.60000000f,-0.89000000f,0.15000000f,-0.12000000f,0.95000000f,0.97000000f,-0.43000000f,0.85000000f,0.43000000f,-0.35000000f,-0.44000000f,0.84000000f,0.94000000f,0.80000000f,-0.88000000f,-0.73000000f,-0.24000000f,0.93000000f,0.77000000f,0.15000000f,-0.63000000f,0.84000000f,0.70000000f,-0.24000000f,-0.01000000f,-0.63000000f,0.44000000f,0.50000000f,-0.29000000f,-0.27000000f,0.64000000f,0.28000000f,-0.18000000f,0.90000000f,-0.87000000f,-0.86000000f,-0.24000000f,0.66000000f,-0.49000000f,0.86000000f,0.19000000f,0.56000000f,-0.18000000f,-0.25000000f,-0.32000000f,-0.09000000f,0.83000000f,0.25000000f,0.92000000f,0.15000000f,0.71000000f,-0.91000000f,0.86000000f,-0.70000000f,0.05000000f,-0.23000000f,0.19000000f,0.32000000f,0.74000000f,-0.79000000f,-0.82000000f,0.44000000f,-0.91000000f,-0.61000000f,-0.99000000f,0.61000000f,-0.19000000f,0.14000000f,-0.46000000f,-0.33000000f,0.93000000f,0.29000000f,0.68000000f,-0.45000000f,0.47000000f,0.19000000f,-0.48000000f,0.03000000f,-0.10000000f,0.73000000f,-0.99000000f,0.72000000f,-0.58000000f,0.45000000f,-0.83000000f,0.07000000f,0.58000000f,0.02000000f,0.60000000f,0.71000000f,0.75000000f,-0.36000000f,0.19000000f,0.92000000f,-0.90000000f,-0.66000000f,0.57000000f,0.38000000f,0.86000000f,0.61000000f,0.31000000f,0.47000000f,-0.14000000f,-0.15000000f,0.27000000f,0.48000000f,0.44000000f,-0.45000000f,-0.83000000f,0.11000000f,0.96000000f,-0.38000000f,-0.12000000f,-0.72000000f,0.07000000f,-0.10000000f,-0.62000000f,0.21000000f,-0.33000000f,0.18000000f,0.18000000f,-0.50000000f,0.15000000f,0.38000000f,0.29000000f,-0.67000000f,-0.16000000f,-0.61000000f,0.36000000f,-0.50000000f,-0.87000000f,0.41000000f,0.41000000f,0.03000000f,0.71000000f,0.75000000f,-0.02000000f,0.13000000f,0.93000000f,0.51000000f,-0.86000000f,-0.43000000f,-0.97000000f,0.16000000f,-0.95000000f,-0.21000000f,-0.15000000f,-0.43000000f,0.53000000f,0.17000000f,0.18000000f,0.12000000f,-0.76000000f,0.56000000f,-0.71000000f,0.25000000f,-0.03000000f,-0.95000000f,0.65000000f,0.11000000f,0.29000000f,0.14000000f,0.04000000f,0.02000000f,-0.20000000f,-0.39000000f,0.23000000f,0.59000000f,0.07000000f,0.73000000f,-0.75000000f,0.67000000f,0.71000000f,-0.11000000f,-0.30000000f,0.26000000f,-0.93000000f,-0.01000000f,0.18000000f,-0.04000000f,-0.73000000f,-0.61000000f,-0.07000000f,0.00000000f,-0.68000000f,-0.58000000f,-0.95000000f,-0.51000000f,0.68000000f,-0.87000000f,0.07000000f,0.21000000f,0.87000000f,0.65000000f,-0.89000000f,0.57000000f,-0.48000000f,0.53000000f,-0.35000000f,-0.61000000f,-0.55000000f,0.62000000f,0.58000000f,-0.68000000f,-0.52000000f,0.33000000f,0.02000000f,0.74000000f,0.03000000f,0.44000000f,0.84000000f,-0.90000000f,-0.02000000f,-0.54000000f,0.55000000f,-0.24000000f,0.63000000f,0.31000000f,-0.67000000f,0.51000000f,0.67000000f,0.85000000f,0.68000000f,0.61000000f,0.04000000f,0.09000000f,0.70000000f,0.35000000f,-0.06000000f,-0.06000000f,-0.49000000f,0.81000000f,-0.24000000f,-0.70000000f,0.44000000f,0.18000000f,0.12000000f,0.17000000f,0.28000000f,0.26000000f,0.81000000f,-0.24000000f,-0.64000000f,0.32000000f,0.49000000f,-0.06000000f,0.13000000f,0.56000000f,-0.17000000f,-0.28000000f,-0.50000000f,0.89000000f,-0.20000000f,-0.34000000f,0.05000000f,0.71000000f,-0.09000000f,0.02000000f,-0.43000000f,-0.00000000f,-0.07000000f,0.25000000f,0.80000000f,0.18000000f,-0.37000000f,-0.16000000f,-0.42000000f,0.33000000f,0.76000000f,-0.81000000f,0.79000000f,0.88000000f,-0.62000000f,-0.49000000f,-0.79000000f,0.16000000f,0.19000000f,0.37000000f,-0.62000000f,-0.72000000f,-0.37000000f,0.39000000f,-0.84000000f,-0.13000000f,0.21000000f,0.88000000f,-0.80000000f,-0.06000000f,0.28000000f,-0.13000000f,-0.83000000f,-0.91000000f,-0.39000000f,0.19000000f,-0.71000000f,-0.08000000f,0.96000000f,0.89000000f,-0.60000000f,-0.79000000f,-0.13000000f,-0.00000000f,0.03000000f,0.97000000f,0.70000000f,-0.96000000f,-0.50000000f,-0.39000000f,0.13000000f,0.09000000f,0.29000000f,-0.43000000f,-0.40000000f,-0.83000000f,0.51000000f,-0.32000000f,-0.53000000f,0.07000000f,0.35000000f,0.43000000f,-0.65000000f,-0.94000000f,0.40000000f,-0.59000000f,0.80000000f,-0.15000000f,-0.22000000f,0.56000000f,0.90000000f,-0.82000000f,-0.74000000f,0.04000000f,-0.24000000f,-0.97000000f,0.96000000f,0.78000000f,0.29000000f,-0.44000000f,0.62000000f,0.92000000f,0.05000000f,-0.74000000f,-0.49000000f,-0.25000000f,0.34000000f,-0.99000000f,0.78000000f,-0.64000000f,0.09000000f,-0.51000000f,0.99000000f,-0.20000000f,0.95000000f,0.13000000f,-0.44000000f,-0.90000000f,-0.82000000f,0.84000000f,0.26000000f,-0.90000000f,0.97000000f,-0.09000000f,0.45000000f,-0.49000000f,0.29000000f,0.13000000f,0.37000000f,-0.03000000f,0.41000000f,-0.47000000f,0.25000000f,0.44000000f,0.31000000f,0.72000000f,0.09000000f,0.67000000f,0.76000000f,-0.79000000f,-0.99000000f,0.62000000f,-0.71000000f,-0.07000000f,0.63000000f,-0.02000000f,-0.28000000f,-0.02000000f,0.98000000f,0.28000000f,0.48000000f,-0.49000000f,0.32000000f,-0.11000000f,-0.45000000f,0.37000000f,-0.58000000f,-0.82000000f,-0.23000000f,-0.55000000f,-0.61000000f,-0.87000000f,-0.96000000f,-0.34000000f,-0.03000000f,-0.15000000f,-0.15000000f,-0.30000000f,-0.53000000f,0.83000000f,0.20000000f,-0.19000000f,-0.19000000f,0.23000000f,0.45000000f,0.50000000f,-0.67000000f,0.71000000f,-0.97000000f,0.42000000f,-0.33000000f,-0.88000000f,0.56000000f,0.78000000f,-0.09000000f,0.17000000f,0.77000000f,0.95000000f,-0.80000000f,-0.72000000f,0.23000000f,0.39000000f,-0.72000000f,-0.15000000f,-0.79000000f,-0.97000000f,0.97000000f,-0.20000000f,-0.56000000f,-0.95000000f,-0.65000000f,0.71000000f,-0.42000000f,0.10000000f,-0.58000000f,-0.14000000f,0.39000000f,-0.95000000f,-0.71000000f,-0.67000000f,0.62000000f,-0.10000000f,-0.11000000f,-0.76000000f,-0.30000000f,-0.62000000f,0.63000000f,-0.11000000f,-0.48000000f,0.37000000f,-0.08000000f,0.73000000f,-0.84000000f,-0.07000000f,-0.82000000f,-0.93000000f,0.63000000f,0.17000000f,-0.58000000f,-0.17000000f,0.83000000f,0.78000000f,-0.49000000f,-0.41000000f,0.29000000f,-0.90000000f,0.78000000f,-0.97000000f,-0.67000000f,0.47000000f,0.64000000f,-0.57000000f,0.89000000f,0.29000000f,-0.24000000f,0.75000000f,0.61000000f,0.45000000f,0.42000000f,0.16000000f,-0.75000000f,0.31000000f,0.66000000f,-0.04000000f,0.11000000f,-0.22000000f,-0.63000000f,-0.81000000f,0.48000000f,0.40000000f,-0.43000000f,0.37000000f,0.58000000f,0.18000000f,0.27000000f,-0.84000000f,0.31000000f,0.67000000f,-0.23000000f,0.74000000f,0.87000000f,-0.60000000f,-0.90000000f,-0.43000000f,0.07000000f,-0.58000000f,-0.01000000f,0.06000000f,-0.57000000f,-0.48000000f,-0.80000000f,0.30000000f,-0.69000000f,-0.37000000f,0.45000000f,0.85000000f,-0.17000000f,0.84000000f,-0.86000000f,0.36000000f,0.30000000f,0.49000000f,0.19000000f,-0.40000000f,-0.68000000f,-0.49000000f,0.61000000f,-0.07000000f,0.25000000f,-0.84000000f,0.42000000f,-0.23000000f,-0.28000000f,0.86000000f,-0.37000000f,0.13000000f,-0.29000000f,-0.93000000f,-0.28000000f,0.23000000f,0.25000000f,0.86000000f,0.33000000f,0.75000000f,0.75000000f,-0.61000000f,0.43000000f,0.09000000f,0.24000000f,-0.80000000f,-0.34000000f,-0.64000000f,0.25000000f,-0.07000000f,0.78000000f,0.29000000f,0.12000000f,0.28000000f,-0.72000000f,-0.72000000f,-0.70000000f,0.23000000f,-0.30000000f,-0.07000000f,-0.94000000f,0.97000000f,0.08000000f,-0.97000000f,0.20000000f,0.70000000f,0.38000000f,0.92000000f,-0.91000000f,-0.93000000f,-0.13000000f,0.05000000f,-0.56000000f,0.15000000f,-0.45000000f,-0.39000000f,-0.53000000f,0.25000000f,0.74000000f,0.85000000f,0.91000000f,0.25000000f,0.75000000f,0.32000000f,0.86000000f,0.99000000f,0.84000000f,0.17000000f,0.38000000f,0.16000000f,0.26000000f,0.37000000f,0.41000000f,-0.36000000f,-0.00000000f,-0.09000000f,0.70000000f,-0.40000000f,0.15000000f,0.76000000f,-0.17000000f,0.40000000f,-0.06000000f,0.14000000f,0.50000000f,-0.91000000f,0.44000000f,0.06000000f,0.30000000f,0.86000000f,0.45000000f,-0.88000000f,-0.06000000f,0.92000000f,-0.39000000f,0.83000000f,0.04000000f,-0.04000000f,0.70000000f,0.99000000f,-0.96000000f,0.02000000f,-0.45000000f,0.47000000f,0.71000000f,-0.50000000f,0.08000000f,0.98000000f,0.30000000f,-0.60000000f,-0.66000000f,0.66000000f,-0.51000000f,-0.86000000f,0.54000000f,0.51000000f,-0.36000000f,-0.48000000f,0.59000000f,-0.93000000f,0.64000000f,0.49000000f,0.23000000f,-0.72000000f,0.82000000f,-0.81000000f,-0.51000000f,-0.06000000f,0.58000000f,0.45000000f,-0.41000000f,-0.60000000f,-0.08000000f,-0.07000000f,0.47000000f,-0.48000000f,0.85000000f,-0.36000000f,-0.92000000f,0.48000000f,-0.36000000f,-0.09000000f,0.09000000f,-0.57000000f,-0.98000000f,0.67000000f,-0.53000000f,0.50000000f,-0.12000000f,-0.62000000f,-0.85000000f,0.37000000f,-0.98000000f,0.56000000f,0.65000000f,0.51000000f,0.54000000f,0.73000000f,-0.89000000f,0.07000000f,0.52000000f,0.92000000f,-0.26000000f,-0.93000000f,-0.82000000f,0.75000000f,0.96000000f,0.26000000f,-0.21000000f,-0.40000000f,-0.88000000f,-0.38000000f,-0.21000000f,-0.43000000f,-0.77000000f,0.48000000f,-0.95000000f,0.40000000f,0.43000000f,-0.24000000f,-0.72000000f,0.49000000f,-0.78000000f,0.82000000f,-0.21000000f,-0.15000000f,-0.56000000f,-0.94000000f,-0.51000000f,-0.10000000f,0.36000000f,0.68000000f,-0.78000000f,0.09000000f,-0.15000000f,-0.55000000f,0.21000000f,-0.11000000f,0.53000000f,-0.23000000f,-0.85000000f,-0.50000000f,0.66000000f,0.44000000f,0.47000000f,0.61000000f,0.22000000f,0.79000000f,0.71000000f,-0.91000000f,0.70000000f,-0.12000000f,-0.78000000f,0.45000000f,-0.40000000f,0.82000000f,0.27000000f,0.39000000f,0.87000000f,-0.23000000f,-0.37000000f,-0.78000000f,-0.19000000f,0.45000000f,0.29000000f,-0.45000000f,-0.30000000f,0.17000000f,-0.70000000f,0.09000000f,-0.85000000f,-0.67000000f,0.41000000f,0.37000000f,-0.12000000f,0.83000000f,0.92000000f,0.70000000f,-0.23000000f,0.62000000f,0.84000000f,0.13000000f,-0.36000000f,0.75000000f,-0.47000000f,-0.93000000f,0.00000000f,-0.71000000f,0.22000000f,-0.13000000f,-0.19000000f,-0.03000000f,-0.94000000f,-0.56000000f,-0.88000000f,-0.27000000f,-0.48000000f,0.98000000f,0.73000000f,0.87000000f,0.10000000f,0.04000000f,0.34000000f,0.51000000f,-0.95000000f,0.84000000f,0.17000000f,0.13000000f,-0.39000000f,0.37000000f,0.89000000f,-0.04000000f,-0.53000000f,-0.38000000f,0.00000000f,-0.00000000f,0.72000000f,0.08000000f,0.32000000f,0.69000000f,0.80000000f,0.00000000f,-0.12000000f,-0.79000000f,-0.75000000f,0.04000000f,-0.45000000f,0.08000000f,-0.96000000f,-0.95000000f,-0.44000000f,0.98000000f,0.10000000f,-0.28000000f,0.99000000f,-0.07000000f,0.53000000f,-0.86000000f,-0.01000000f,0.29000000f,-0.78000000f,-0.01000000f,0.22000000f,0.18000000f,-0.24000000f,-0.89000000f,0.12000000f,-0.67000000f,0.06000000f,-0.02000000f,-0.41000000f,-0.00000000f,0.91000000f,0.40000000f,-0.20000000f,0.25000000f,-0.08000000f,0.04000000f,0.42000000f,0.40000000f,0.39000000f,-0.22000000f,-0.23000000f,0.28000000f,0.48000000f,-0.72000000f,-0.85000000f,-0.22000000f,0.69000000f,-0.25000000f,-0.85000000f,-0.56000000f,0.80000000f,-0.91000000f,0.69000000f,-0.69000000f,0.86000000f,0.94000000f,0.87000000f,-0.47000000f,0.30000000f,-0.51000000f,-0.52000000f,0.74000000f,-0.43000000f,0.03000000f,-0.79000000f,0.76000000f,0.39000000f,0.00000000f,0.32000000f,-0.43000000f,-0.43000000f,-0.27000000f,0.08000000f,-0.20000000f,0.18000000f,0.01000000f,-0.12000000f,-0.22000000f,-0.64000000f,-0.56000000f,0.72000000f,-0.10000000f,-0.52000000f,-0.23000000f,0.93000000f,0.39000000f,0.14000000f,0.23000000f,0.81000000f,-0.37000000f,0.52000000f,-0.10000000f,-0.16000000f,-0.90000000f,0.35000000f,0.18000000f,-0.89000000f,0.72000000f,0.91000000f,-0.03000000f,-0.67000000f,0.43000000f,0.97000000f,-0.32000000f,-0.40000000f,0.85000000f,-0.25000000f,0.71000000f,-0.60000000f,0.71000000f,0.84000000f,0.20000000f,-0.97000000f,-0.66000000f,0.18000000f,0.71000000f,-0.29000000f,-0.73000000f,0.62000000f,0.76000000f,-0.12000000f,-0.80000000f,0.61000000f,0.38000000f,0.74000000f,0.44000000f,0.60000000f,0.23000000f,0.11000000f,-0.06000000f,-0.09000000f,-0.33000000f,-0.38000000f,0.17000000f,0.57000000f,0.91000000f,0.83000000f,0.89000000f,0.88000000f,0.83000000f,0.71000000f,0.97000000f,0.93000000f,0.23000000f,-0.36000000f,-0.21000000f,-0.77000000f,0.14000000f,0.52000000f,-0.48000000f,-0.21000000f,-0.86000000f,-0.39000000f,0.68000000f,0.46000000f,0.48000000f,0.09000000f,-0.10000000f,0.83000000f,0.63000000f,0.53000000f,0.40000000f,0.05000000f,-0.92000000f,0.61000000f,0.23000000f,0.23000000f,-0.49000000f,-0.12000000f,-0.88000000f,-0.03000000f,0.50000000f,-0.27000000f,0.44000000f,-0.59000000f,-0.50000000f,0.93000000f,-0.52000000f,-0.06000000f,-0.02000000f,0.57000000f,0.75000000f,0.56000000f,0.34000000f,-0.71000000f,-0.04000000f,-0.25000000f,0.81000000f,0.77000000f,-0.40000000f,0.69000000f,0.26000000f,0.86000000f,0.32000000f,0.69000000f,-0.64000000f,-0.75000000f,0.73000000f,-0.40000000f,-0.57000000f,0.95000000f,0.03000000f,-0.51000000f,0.15000000f,-0.25000000f,0.87000000f,0.23000000f,-0.61000000f,-0.37000000f,-0.44000000f,-0.04000000f,-0.84000000f,-0.07000000f,0.27000000f,-0.33000000f,0.68000000f,-0.59000000f,0.32000000f,0.06000000f,-0.80000000f,-0.47000000f,0.09000000f,-0.61000000f,-0.85000000f,-0.77000000f,0.78000000f,0.86000000f,-0.75000000f,-0.45000000f,-0.10000000f,-0.68000000f,-0.30000000f,-0.40000000f,0.83000000f,0.62000000f,0.97000000f,-0.71000000f,0.50000000f,-0.15000000f,-0.06000000f,0.99000000f,0.68000000f,-0.45000000f,0.81000000f,-0.82000000f,0.87000000f,-0.65000000f,-0.68000000f,-0.97000000f,0.68000000f,0.64000000f,0.19000000f,0.23000000f,0.51000000f,-0.96000000f,0.16000000f,0.05000000f,0.82000000f,-0.70000000f,0.08000000f,-0.13000000f,0.80000000f,0.87000000f,0.47000000f,0.27000000f,0.38000000f,0.27000000f,-0.61000000f,-0.63000000f,0.60000000f,0.91000000f,-0.03000000f,-0.65000000f,-0.26000000f,-0.59000000f,-0.08000000f,-0.00000000f,0.55000000f,-0.30000000f,0.28000000f,-0.81000000f,0.32000000f,-0.92000000f,-0.34000000f,0.55000000f,0.25000000f,-0.46000000f,0.93000000f,0.34000000f,0.69000000f,-0.59000000f,0.79000000f,0.95000000f,0.97000000f,0.91000000f,-0.53000000f,0.89000000f,0.29000000f,-0.23000000f,-0.49000000f,0.14000000f,-0.53000000f,0.22000000f,0.87000000f,0.10000000f,0.42000000f,0.31000000f,0.98000000f,-0.18000000f,-0.89000000f,-0.98000000f,-0.20000000f,0.31000000f,-0.54000000f,0.32000000f,-0.14000000f,0.16000000f,-0.24000000f,-0.77000000f,0.15000000f,0.76000000f,0.80000000f,0.70000000f,0.93000000f,-0.55000000f,0.25000000f,0.39000000f,0.16000000f,-0.80000000f,-0.64000000f,-0.51000000f,-0.48000000f,0.75000000f,0.50000000f,0.19000000f,-0.42000000f,-0.42000000f,0.75000000f,0.06000000f,0.61000000f,-0.75000000f,0.65000000f,0.27000000f,-0.72000000f,-0.20000000f,0.81000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.56000000f,-0.15000000f,-0.37000000f,0.38000000f,0.83000000f,-0.76000000f,-0.00000000f,-0.95000000f,0.99000000f,-0.51000000f,-0.06000000f,-0.47000000f,0.92000000f,0.03000000f,0.52000000f,-0.67000000f,0.73000000f,0.59000000f,-0.32000000f,-0.97000000f,0.41000000f,-0.37000000f,0.25000000f,0.77000000f,-0.40000000f,-0.01000000f,-0.95000000f,0.77000000f,-0.31000000f,-0.99000000f,-0.23000000f,-0.38000000f,-0.77000000f,-0.15000000f,-0.75000000f,-0.79000000f,0.85000000f,-0.56000000f,-0.80000000f,0.15000000f,0.75000000f,0.69000000f,-0.70000000f,-0.72000000f,-0.83000000f,0.16000000f,0.83000000f,0.95000000f,-0.33000000f,-0.16000000f,-0.56000000f,-0.36000000f,-0.94000000f,0.37000000f,0.51000000f,-0.95000000f,0.92000000f,-0.86000000f,0.88000000f,-0.63000000f,0.77000000f,0.12000000f,0.54000000f,0.99000000f,0.08000000f,0.38000000f,-0.42000000f,0.86000000f,-0.13000000f,0.45000000f,0.75000000f,0.10000000f,0.56000000f,0.78000000f,0.06000000f,-0.93000000f,0.77000000f,-0.47000000f,0.86000000f,-0.34000000f,-0.34000000f,0.61000000f,0.12000000f,-0.56000000f,0.64000000f,0.58000000f,-0.56000000f,0.32000000f,0.01000000f,-0.35000000f,0.10000000f,0.59000000f,-0.40000000f,0.19000000f,-0.02000000f,-0.53000000f,0.87000000f,-0.31000000f,-0.39000000f,0.80000000f,-0.53000000f,0.84000000f,0.69000000f,0.34000000f,0.46000000f,0.61000000f,-0.38000000f,0.85000000f,-0.38000000f,-0.90000000f,-0.57000000f,0.74000000f,0.21000000f,0.13000000f,-0.87000000f,-0.57000000f,-0.81000000f,-0.75000000f,-0.14000000f,0.99000000f,-0.49000000f,-0.65000000f,0.61000000f,-0.58000000f,-0.04000000f,-0.63000000f,-0.96000000f,-0.75000000f,-0.67000000f,-0.72000000f,-0.33000000f,0.50000000f,-0.01000000f,0.64000000f,0.97000000f,-0.08000000f,-0.34000000f,-0.84000000f,0.38000000f,-0.16000000f,0.42000000f,0.96000000f,0.80000000f,-0.53000000f,0.53000000f,0.51000000f,0.77000000f,-0.04000000f,-0.06000000f,0.65000000f,0.72000000f,0.82000000f,0.77000000f,-0.53000000f,-0.66000000f,-0.43000000f,0.95000000f,0.20000000f,0.14000000f,-0.27000000f,-0.13000000f,0.39000000f,-0.77000000f,0.07000000f,-0.14000000f,0.93000000f,0.69000000f,-0.03000000f,0.89000000f,0.51000000f,-0.40000000f,-0.68000000f,0.42000000f,-0.46000000f,-0.50000000f,0.15000000f,-0.81000000f,0.32000000f,-0.10000000f,0.26000000f,-0.10000000f,0.35000000f,-0.33000000f,0.70000000f,-0.35000000f,0.79000000f,0.97000000f,0.01000000f,-0.77000000f,-0.44000000f,-0.24000000f,-0.93000000f,0.21000000f,-0.74000000f,-0.64000000f,-0.25000000f,-0.90000000f,-0.26000000f,0.64000000f,-0.33000000f,0.82000000f,-0.12000000f,0.56000000f,-0.18000000f,-0.78000000f,-0.82000000f,-0.21000000f,-0.84000000f,-0.81000000f,-0.26000000f,0.20000000f,0.74000000f,-0.56000000f,0.86000000f,-0.17000000f,-0.36000000f,-0.02000000f,-0.16000000f,0.21000000f,0.61000000f,0.65000000f,-0.48000000f,0.04000000f,-0.38000000f,0.32000000f,-0.72000000f,0.22000000f,-0.16000000f,0.44000000f,0.25000000f,-0.51000000f,-0.64000000f,0.43000000f,0.72000000f,-0.88000000f,0.97000000f,-0.27000000f,0.40000000f,0.36000000f,0.49000000f,0.38000000f,-0.53000000f,-0.08000000f,-0.06000000f,0.69000000f,-0.27000000f,0.05000000f,0.72000000f,-0.48000000f,0.74000000f,0.80000000f,0.23000000f,0.00000000f,-0.49000000f,-0.85000000f,-0.30000000f,-0.43000000f,0.14000000f,-0.06000000f,0.03000000f,-0.83000000f,0.91000000f,-0.72000000f,0.27000000f,0.42000000f,-0.63000000f,-0.54000000f,0.92000000f,-0.87000000f,-0.49000000f,0.40000000f,0.60000000f,-0.24000000f,0.66000000f,-0.65000000f,-0.67000000f,0.15000000f,0.70000000f,0.89000000f,-0.13000000f,0.81000000f,-0.52000000f,-0.82000000f,-0.58000000f,-0.20000000f,0.08000000f,-0.51000000f,0.18000000f,0.99000000f,-0.80000000f,0.22000000f,-0.17000000f,-0.72000000f,-0.72000000f,0.39000000f,0.81000000f,-0.36000000f,0.92000000f,-0.63000000f,0.36000000f,0.21000000f,0.00000000f,-0.27000000f,-0.72000000f,-0.47000000f,-0.69000000f,0.93000000f,-0.60000000f,0.98000000f,-0.28000000f,-0.69000000f,0.24000000f,-0.32000000f,-0.13000000f,-0.37000000f,0.66000000f,-0.68000000f,0.82000000f,0.23000000f,-0.45000000f,0.19000000f,-0.02000000f,0.90000000f,-0.77000000f,-0.87000000f,0.94000000f,-0.53000000f,0.95000000f,0.90000000f,0.17000000f,0.80000000f,-0.86000000f,0.67000000f,0.58000000f,-0.27000000f,-0.87000000f,-0.15000000f,0.99000000f,-0.65000000f,0.08000000f,0.34000000f,-0.46000000f,-0.94000000f,0.78000000f,0.10000000f,-0.95000000f,0.54000000f,0.46000000f,0.89000000f,0.01000000f,-0.33000000f,0.43000000f,-0.19000000f,-0.87000000f,0.36000000f,0.84000000f,0.70000000f,-0.93000000f,-0.95000000f,0.86000000f,-0.33000000f,-0.60000000f,0.31000000f,0.70000000f,-0.39000000f,0.01000000f,-0.43000000f,-0.11000000f,-0.42000000f,-0.76000000f,0.72000000f,0.33000000f,0.40000000f,0.43000000f,-0.19000000f,-0.49000000f,0.24000000f,-0.45000000f,-0.02000000f,-0.12000000f,-0.50000000f,-0.74000000f,-0.53000000f,0.09000000f,0.39000000f,0.53000000f,0.02000000f,0.14000000f,0.40000000f,-0.81000000f,-0.28000000f,-0.32000000f,-0.00000000f,0.51000000f,0.54000000f,-0.12000000f,-0.30000000f,0.97000000f,-0.04000000f,-0.42000000f,-0.96000000f,-0.39000000f,0.81000000f,0.93000000f,-0.55000000f,0.46000000f,-0.79000000f,-0.99000000f,-0.53000000f,0.00000000f,-0.28000000f,0.08000000f,0.22000000f,0.34000000f,0.03000000f,-0.89000000f,0.36000000f,0.80000000f,-0.68000000f,0.50000000f,-0.08000000f,0.04000000f,0.98000000f,-0.36000000f,-0.97000000f,0.46000000f,-0.02000000f,-0.20000000f,0.66000000f,-0.67000000f,0.58000000f,0.46000000f,-0.14000000f,-0.74000000f,-0.68000000f,-0.22000000f,0.93000000f,-0.86000000f,-0.58000000f,0.66000000f,-0.03000000f,0.40000000f,0.60000000f,-0.65000000f,0.20000000f,0.96000000f,-0.04000000f,0.91000000f,0.95000000f,-0.19000000f,0.04000000f,0.89000000f,0.70000000f,-0.99000000f,0.27000000f,-0.55000000f,0.79000000f,0.99000000f,0.94000000f,-0.16000000f,0.16000000f,0.74000000f,-0.84000000f,-0.91000000f,-0.15000000f,0.70000000f,0.95000000f,-0.19000000f,-0.72000000f,0.23000000f,0.98000000f,-0.77000000f,-0.58000000f,-0.97000000f,0.20000000f,-0.89000000f,0.94000000f,-0.96000000f,0.78000000f,0.17000000f,0.51000000f,0.91000000f,-0.58000000f,-0.90000000f,-0.48000000f,0.03000000f,0.06000000f,-0.58000000f,0.67000000f,0.70000000f,-0.68000000f,0.13000000f,-0.02000000f,0.04000000f,-0.33000000f,0.64000000f,-0.72000000f,0.01000000f,0.71000000f,0.37000000f,0.31000000f,-0.39000000f,0.91000000f,0.19000000f,-0.34000000f,0.45000000f,-0.68000000f,-0.26000000f,-0.78000000f,-0.74000000f,0.43000000f,-0.05000000f,-0.29000000f,-0.98000000f,-0.07000000f,0.61000000f,-0.93000000f,0.05000000f,-0.44000000f,0.44000000f,0.89000000f,-0.08000000f,0.19000000f,0.95000000f,0.90000000f,0.63000000f,0.25000000f,0.09000000f,0.90000000f,-0.66000000f,0.62000000f,0.72000000f,-0.28000000f,0.76000000f,-0.90000000f,0.37000000f,-0.25000000f,0.60000000f,0.92000000f,-0.75000000f,0.86000000f,-0.79000000f,0.17000000f,-0.11000000f,-0.21000000f,-0.99000000f,-0.41000000f,0.18000000f,-0.59000000f,-0.04000000f,0.92000000f,-0.20000000f,-0.82000000f,0.70000000f,0.18000000f,-0.08000000f,0.04000000f,0.84000000f,-0.48000000f,-0.46000000f,-0.94000000f,-0.55000000f,0.64000000f,0.10000000f,-0.74000000f,-0.66000000f,-0.16000000f,0.52000000f,0.33000000f,-0.41000000f,0.24000000f,0.94000000f,0.22000000f,-0.04000000f,-0.90000000f,0.91000000f,0.13000000f,0.46000000f,0.18000000f,-0.33000000f,-0.48000000f,-0.92000000f,-0.54000000f,-0.90000000f,-0.20000000f,0.58000000f,-0.45000000f,-0.52000000f,-0.50000000f,-0.42000000f,-0.18000000f,-0.49000000f,-0.71000000f,0.61000000f,-0.32000000f,0.82000000f,-0.17000000f,-0.82000000f,0.37000000f,-0.73000000f,-0.22000000f,0.97000000f,0.79000000f,0.43000000f,0.75000000f,0.82000000f,-0.88000000f,0.15000000f,0.04000000f,0.50000000f,-0.21000000f,-0.38000000f,0.63000000f,-0.45000000f,-0.39000000f,0.34000000f,0.20000000f,-0.46000000f,-0.24000000f,-0.44000000f,-0.82000000f,0.63000000f,-0.36000000f,-0.03000000f,-0.20000000f,-0.31000000f,-0.51000000f,-0.44000000f,0.03000000f,-0.28000000f,0.86000000f,-0.98000000f,0.67000000f,-0.01000000f,0.37000000f,-0.58000000f,0.83000000f,-0.71000000f,0.88000000f,0.94000000f,-0.97000000f,-0.02000000f,0.53000000f,-0.47000000f,0.43000000f,0.45000000f,0.66000000f,-0.41000000f,0.01000000f,0.66000000f,-0.73000000f,0.98000000f,-0.51000000f,-0.25000000f,0.10000000f,0.86000000f,-0.61000000f,-0.38000000f,0.24000000f,-0.37000000f,-0.76000000f,0.10000000f,0.41000000f,-0.40000000f,0.45000000f,-0.94000000f,0.06000000f,-0.34000000f,-0.77000000f,-0.49000000f,0.10000000f,0.60000000f,0.59000000f,-0.18000000f,-0.29000000f,0.16000000f,0.66000000f,-0.79000000f,0.31000000f,-0.15000000f,-0.36000000f,0.28000000f,-0.83000000f,-0.40000000f,0.79000000f,-0.79000000f,0.01000000f,-0.10000000f,-0.89000000f,0.89000000f,-0.73000000f,-0.94000000f,-0.25000000f,0.90000000f,0.02000000f,0.87000000f,-0.72000000f,0.14000000f,0.01000000f,0.14000000f,0.33000000f,0.70000000f,-0.23000000f,0.31000000f,0.47000000f,-0.99000000f,0.74000000f,-0.94000000f,-0.18000000f,0.29000000f,0.74000000f,0.41000000f,-0.62000000f,-0.55000000f,-0.23000000f,-0.92000000f,-0.83000000f,-0.04000000f,0.62000000f,-0.21000000f,0.18000000f,0.54000000f,0.10000000f,0.01000000f,-0.56000000f,0.20000000f,-0.27000000f,0.95000000f,-0.72000000f,-0.81000000f,-0.37000000f,0.04000000f,0.35000000f,-0.43000000f,0.74000000f,0.96000000f,-0.39000000f,-0.25000000f,0.84000000f,-0.96000000f,0.63000000f,-0.21000000f,0.38000000f,0.08000000f,-0.30000000f,-0.96000000f,0.62000000f,0.52000000f,0.88000000f,0.24000000f,0.20000000f,-0.98000000f,-0.19000000f,0.73000000f,-0.92000000f,-0.26000000f,0.98000000f,0.23000000f,0.02000000f,-0.56000000f,-0.67000000f,0.84000000f,0.80000000f,-0.99000000f,0.90000000f,0.08000000f,0.54000000f,-0.42000000f,0.12000000f,0.61000000f,-0.37000000f,-0.33000000f,0.96000000f,0.77000000f,-0.97000000f,0.69000000f,-0.03000000f,0.32000000f,-0.05000000f,0.38000000f,-0.13000000f,-0.67000000f,-0.29000000f,0.78000000f,0.49000000f,0.06000000f,-0.80000000f,-0.11000000f,0.67000000f,0.22000000f,-0.76000000f,-0.30000000f,-0.78000000f,0.35000000f,0.64000000f,-0.14000000f,-0.56000000f,0.01000000f,-0.67000000f,-0.73000000f,-0.00000000f,0.49000000f,0.49000000f,-0.48000000f,-0.61000000f,0.93000000f,-0.05000000f,0.14000000f,0.47000000f,-0.07000000f,0.83000000f,0.97000000f,0.07000000f,-0.41000000f,-0.19000000f,0.17000000f,0.62000000f,0.58000000f,-0.37000000f,0.48000000f,-0.62000000f,-0.36000000f,0.94000000f,0.07000000f,-0.83000000f,0.49000000f,-0.81000000f,-0.77000000f,-0.21000000f,0.15000000f,-0.48000000f,-0.65000000f,0.88000000f,0.58000000f,0.74000000f,-0.88000000f,-0.78000000f,0.70000000f,-0.18000000f,0.37000000f,-0.84000000f,-0.49000000f,-0.39000000f,0.98000000f,0.06000000f,0.25000000f,0.97000000f,0.39000000f,0.38000000f,-0.67000000f,-0.52000000f,0.65000000f,-0.66000000f,-0.53000000f,0.38000000f,-0.30000000f,-0.51000000f,0.07000000f,-0.07000000f,0.01000000f,0.73000000f,0.38000000f,0.47000000f,-0.56000000f,0.44000000f,0.78000000f,-0.98000000f,-0.99000000f,-0.31000000f,-0.72000000f,0.91000000f,0.18000000f,-0.84000000f,-0.40000000f,-0.53000000f,0.33000000f,0.13000000f,0.37000000f,0.01000000f,0.81000000f,0.00000000f,-0.19000000f,-0.02000000f,-0.73000000f,0.65000000f,0.84000000f,-0.01000000f,0.16000000f,-0.07000000f,0.64000000f,0.22000000f,0.06000000f,0.49000000f,-0.28000000f,-0.84000000f,0.81000000f,-0.94000000f,0.32000000f,-0.07000000f,0.09000000f,0.95000000f,0.99000000f,-0.56000000f,0.64000000f,0.83000000f,0.51000000f,-0.93000000f,0.18000000f,-0.50000000f,0.38000000f,-0.07000000f,0.93000000f,0.63000000f,-0.29000000f,0.87000000f,-0.04000000f,0.63000000f,0.70000000f,-0.76000000f,0.02000000f,0.02000000f,-0.88000000f,-0.63000000f,-0.18000000f,-0.30000000f,-0.48000000f,-0.42000000f,0.93000000f,0.01000000f,0.36000000f,0.97000000f,-0.25000000f,0.93000000f,0.16000000f,0.46000000f,-0.31000000f,-0.32000000f,0.20000000f,0.43000000f,-0.93000000f,0.09000000f,0.97000000f,0.53000000f,-0.86000000f,-0.33000000f,0.77000000f,0.58000000f,-0.11000000f,0.55000000f,0.94000000f,-0.42000000f,-0.48000000f,0.05000000f,0.15000000f,0.58000000f,-0.59000000f,-0.41000000f,-0.53000000f,0.05000000f,0.96000000f,0.00000000f,0.60000000f,0.56000000f,-0.18000000f,0.49000000f,-0.44000000f,0.47000000f,-0.67000000f,-0.85000000f,0.91000000f,-0.28000000f,-0.17000000f,0.62000000f,-0.96000000f,0.81000000f,0.12000000f,0.54000000f,-0.52000000f,-0.12000000f,-0.28000000f,0.82000000f,0.02000000f,-0.11000000f,-0.51000000f,-0.45000000f,0.20000000f,0.69000000f,0.07000000f,0.48000000f,-0.48000000f,-0.01000000f,0.33000000f,0.64000000f,0.15000000f,-0.79000000f,-0.11000000f,0.28000000f,0.48000000f,0.58000000f,0.95000000f,-0.89000000f,0.01000000f,-0.16000000f,-0.66000000f,-0.92000000f,0.89000000f,-0.34000000f,0.50000000f,-0.28000000f,0.08000000f,-0.74000000f,0.29000000f,-0.02000000f,0.68000000f,0.15000000f,0.95000000f,0.21000000f,-0.58000000f,-0.11000000f,0.64000000f,0.73000000f,0.87000000f,-0.96000000f,-0.64000000f,-0.60000000f,-0.79000000f,0.35000000f,-0.54000000f,-0.65000000f,0.14000000f,-0.48000000f,0.02000000f,0.36000000f,-0.45000000f,0.07000000f,0.58000000f,0.62000000f,0.73000000f,-0.92000000f,0.71000000f,-0.73000000f,-0.58000000f,-0.10000000f,0.95000000f,-0.81000000f,0.05000000f,-0.40000000f,-0.70000000f,0.03000000f,-0.45000000f,0.88000000f,-0.89000000f,0.37000000f,-0.30000000f,-0.37000000f,0.07000000f,0.28000000f,-0.11000000f,-0.38000000f,0.32000000f,0.78000000f,0.21000000f,0.43000000f,0.77000000f,-0.57000000f,0.40000000f,-0.93000000f,0.16000000f,-0.66000000f,-0.66000000f,-0.82000000f,-0.13000000f,-0.69000000f,0.77000000f,0.54000000f,0.69000000f,-0.54000000f,0.29000000f,-0.77000000f,0.14000000f,0.25000000f,-0.14000000f,-0.98000000f,0.36000000f,0.00000000f,-0.17000000f,-0.07000000f,-0.25000000f,0.25000000f,-0.30000000f,-0.53000000f,0.79000000f,0.08000000f,-0.80000000f,-0.05000000f,-0.87000000f,0.22000000f,0.35000000f,0.32000000f,0.09000000f,-0.44000000f,-0.82000000f,0.77000000f,-0.17000000f,0.47000000f,-0.89000000f,-0.83000000f,0.33000000f,0.20000000f,0.93000000f,-0.44000000f,0.89000000f,-0.27000000f,-0.95000000f,0.03000000f,-0.23000000f,0.34000000f,0.35000000f,-0.22000000f,0.56000000f,-0.36000000f,0.20000000f,0.86000000f,-0.18000000f,-0.11000000f,-0.27000000f,-0.87000000f,-0.52000000f,-0.85000000f,-0.71000000f,-0.07000000f,-0.42000000f,-0.73000000f,-0.72000000f,-0.45000000f,0.21000000f,0.22000000f,0.35000000f,-0.67000000f,0.47000000f,-0.17000000f,-0.72000000f,-0.48000000f,0.64000000f,0.68000000f,-0.06000000f,-0.60000000f,-0.82000000f,0.84000000f,0.16000000f,0.49000000f,-0.16000000f,-0.57000000f,-0.16000000f,-0.86000000f,0.05000000f,-0.91000000f,-0.02000000f,0.11000000f,0.91000000f,0.64000000f,-0.68000000f,0.93000000f,-0.25000000f,-0.46000000f,0.70000000f,0.87000000f,0.97000000f,-0.75000000f,0.73000000f,-0.70000000f,0.63000000f,-0.08000000f,0.94000000f,0.84000000f,-0.55000000f,0.29000000f,-0.75000000f,-0.18000000f,0.15000000f,0.41000000f,0.33000000f,0.81000000f,-0.95000000f,-0.12000000f,-0.47000000f,0.19000000f,-0.12000000f,-0.49000000f,0.34000000f,0.23000000f,0.36000000f,0.51000000f,-0.45000000f,-0.97000000f,0.09000000f,-0.47000000f,0.54000000f,0.32000000f,0.46000000f,0.90000000f,-0.58000000f,-0.87000000f,-0.48000000f,-0.91000000f,-0.72000000f,-0.19000000f,-0.93000000f,0.30000000f,0.91000000f,-0.78000000f,-0.46000000f,0.19000000f,0.90000000f,-0.22000000f,-0.43000000f,0.56000000f,-0.42000000f,0.99000000f,-0.46000000f,0.18000000f,-0.75000000f,-0.77000000f,0.85000000f,-0.99000000f,0.10000000f,-0.92000000f,0.68000000f,-0.07000000f,-0.81000000f,-0.57000000f,-0.57000000f,-0.31000000f,0.74000000f,-0.01000000f,0.38000000f,0.00000000f,0.05000000f,-0.85000000f,-0.28000000f,0.91000000f,-0.78000000f,0.53000000f,0.02000000f,-0.12000000f,-0.90000000f,0.21000000f,-0.22000000f,-0.01000000f,-0.87000000f,0.45000000f,-0.37000000f,0.09000000f,0.90000000f,0.15000000f,-0.14000000f,0.66000000f,0.32000000f,0.18000000f,0.87000000f,0.74000000f,-0.35000000f,0.95000000f,0.23000000f,-0.89000000f,-0.81000000f,0.95000000f,0.96000000f,-0.43000000f,0.57000000f,-0.16000000f,-0.82000000f,-0.00000000f,-0.64000000f,0.18000000f,0.01000000f,0.19000000f,-0.90000000f,-0.55000000f,0.31000000f,0.41000000f,-0.41000000f,-0.31000000f,-0.32000000f,-0.65000000f,0.08000000f,0.77000000f,0.24000000f,-0.26000000f,0.39000000f,-0.72000000f,0.75000000f,-0.49000000f,0.19000000f,0.58000000f,0.55000000f,-0.71000000f,-0.12000000f,0.96000000f,-0.78000000f,0.73000000f,0.10000000f,-0.31000000f,0.25000000f,0.78000000f,-0.70000000f,-0.11000000f,-0.87000000f,-0.00000000f,0.66000000f,0.26000000f,0.80000000f,-0.21000000f,-0.94000000f,-0.99000000f,0.94000000f,0.78000000f,0.97000000f,-0.41000000f,-0.27000000f,0.23000000f,-0.20000000f,-0.32000000f,-0.86000000f,0.51000000f,0.67000000f,0.95000000f,0.71000000f,-0.63000000f,-0.26000000f,-0.20000000f,0.79000000f,0.34000000f,0.42000000f,0.27000000f,-0.49000000f,0.99000000f,0.59000000f,-0.09000000f,-0.23000000f,-0.10000000f,0.11000000f,-0.37000000f,-0.99000000f,0.73000000f,0.81000000f,-0.38000000f,-0.57000000f,0.90000000f,0.85000000f,-0.21000000f,-0.73000000f,0.74000000f,0.42000000f,-0.77000000f,-0.04000000f,0.16000000f,0.88000000f,-0.27000000f,-0.34000000f,-0.83000000f,-0.91000000f,-0.47000000f,0.18000000f,-0.06000000f,0.40000000f,-0.10000000f,-0.74000000f,-0.45000000f,-0.24000000f,-0.27000000f,-0.44000000f,-0.49000000f,-0.96000000f,-0.46000000f,-0.12000000f,0.76000000f,0.75000000f,-0.11000000f,-0.96000000f,0.54000000f,0.00000000f,-0.26000000f,0.81000000f,0.79000000f,0.67000000f,0.20000000f,0.69000000f,0.68000000f,0.01000000f,0.17000000f,-0.84000000f,-0.28000000f,-0.05000000f,0.49000000f,0.09000000f,0.12000000f,-0.30000000f,-0.02000000f,-0.02000000f,-0.62000000f,-0.12000000f,0.76000000f,-0.24000000f,0.86000000f,0.36000000f,0.36000000f,0.25000000f,-0.34000000f,-0.57000000f,0.92000000f,-0.72000000f,0.05000000f,0.76000000f,-0.36000000f,-0.54000000f,-0.03000000f,-0.66000000f,-0.95000000f,0.52000000f,0.87000000f,0.11000000f,0.17000000f,-0.88000000f,-0.37000000f,-0.13000000f,0.18000000f,0.03000000f,0.50000000f,0.59000000f,-0.15000000f,0.36000000f,0.72000000f,0.49000000f,0.62000000f,-0.12000000f,-0.69000000f,0.15000000f,0.80000000f,0.63000000f,-0.97000000f,0.19000000f,0.59000000f,0.38000000f,-0.14000000f,-0.72000000f,-0.71000000f,-0.08000000f,-0.36000000f,-0.23000000f,0.56000000f,0.34000000f,0.14000000f,0.68000000f,-0.90000000f,-0.15000000f,0.32000000f,0.08000000f,-0.87000000f,-0.89000000f,-0.93000000f,0.39000000f,0.30000000f,0.54000000f,-0.86000000f,-0.32000000f,-0.45000000f,-0.09000000f,-0.10000000f,0.37000000f,0.18000000f,-0.83000000f,-0.38000000f,-0.53000000f,-0.67000000f,0.98000000f,-0.29000000f,-0.03000000f,-0.30000000f,0.90000000f,-0.58000000f,0.39000000f,-0.29000000f,0.10000000f,0.11000000f,0.04000000f,0.80000000f,0.21000000f,0.08000000f,0.00000000f,0.50000000f,-0.25000000f,0.75000000f,0.26000000f,0.28000000f,0.26000000f,-0.59000000f,0.56000000f,0.68000000f,0.02000000f,0.55000000f,0.81000000f,-0.78000000f,0.14000000f,0.90000000f,-0.15000000f,0.48000000f,-0.74000000f,-0.61000000f,0.31000000f,0.72000000f,-0.82000000f,0.28000000f,0.27000000f,0.82000000f,-0.67000000f,0.90000000f,-0.88000000f,0.56000000f,-0.29000000f,0.05000000f,-0.46000000f,0.67000000f,-0.21000000f,-0.33000000f,0.28000000f,0.43000000f,-0.95000000f,0.88000000f,0.97000000f,0.41000000f,-0.68000000f,0.30000000f,0.04000000f,-0.77000000f,0.14000000f,-0.67000000f,-0.96000000f,0.01000000f,-0.92000000f,-0.55000000f,0.44000000f,-0.70000000f,-0.70000000f,0.37000000f,-0.07000000f,0.39000000f,-0.12000000f,-0.27000000f,-0.71000000f,0.06000000f,0.28000000f,0.92000000f,-0.79000000f,-0.82000000f,0.52000000f,0.26000000f,-0.21000000f,0.82000000f,-0.49000000f,0.88000000f,0.47000000f,0.45000000f,0.31000000f,0.44000000f,-0.98000000f,-0.23000000f,0.44000000f,0.13000000f,0.61000000f,-0.20000000f,-0.23000000f,-0.61000000f,-0.34000000f,0.35000000f,0.56000000f,-0.16000000f,0.57000000f,-0.46000000f,-0.56000000f,-0.92000000f,-0.31000000f,0.97000000f,-0.25000000f,-0.48000000f,-0.94000000f,0.74000000f,0.02000000f,-0.61000000f,-0.71000000f,0.57000000f,0.77000000f,0.33000000f,-0.52000000f,0.38000000f,0.78000000f,-0.79000000f,0.20000000f,-0.52000000f,0.44000000f,-0.45000000f,-0.36000000f,-0.93000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.84000000f,-0.83000000f,-0.72000000f,0.39000000f,0.32000000f,-0.87000000f,0.58000000f,-0.47000000f,0.08000000f,0.08000000f,-0.55000000f,0.22000000f,0.63000000f,0.21000000f,-0.15000000f,0.08000000f,-0.79000000f,-0.42000000f,0.49000000f,-0.89000000f,0.14000000f,-0.24000000f,-0.42000000f,0.34000000f,-0.20000000f,-0.26000000f,0.90000000f,0.98000000f,0.89000000f,-0.73000000f,-0.21000000f,-0.73000000f,0.36000000f,-0.51000000f,0.56000000f,-0.67000000f,0.65000000f,0.82000000f,0.39000000f,0.18000000f,0.76000000f,-0.26000000f,-0.75000000f,-0.83000000f,-0.94000000f,-0.04000000f,-0.80000000f,-0.89000000f,0.68000000f,-0.48000000f,-0.50000000f,0.75000000f,0.22000000f,0.87000000f,-0.06000000f,0.40000000f,-0.40000000f,-0.13000000f,0.17000000f,-0.01000000f,-0.40000000f,0.75000000f,0.42000000f,0.77000000f,0.28000000f,-0.41000000f,0.12000000f,0.55000000f,0.72000000f,-0.48000000f,-0.71000000f,0.75000000f,-0.18000000f,-0.51000000f,0.55000000f,0.35000000f,0.57000000f,0.03000000f,0.86000000f,0.52000000f,0.71000000f,0.50000000f,-0.25000000f,0.83000000f,0.57000000f,-0.51000000f,0.81000000f,0.03000000f,-0.81000000f,-0.78000000f,-0.70000000f,0.27000000f,0.55000000f,0.62000000f,0.55000000f,0.68000000f,-0.05000000f,-0.73000000f,-0.28000000f,0.24000000f,-0.33000000f,0.59000000f,-0.89000000f,0.78000000f,-0.91000000f,-0.77000000f,0.11000000f,-0.73000000f,0.57000000f,-0.26000000f,-0.25000000f,0.80000000f,0.47000000f,-0.09000000f,0.71000000f,0.15000000f,0.56000000f,0.27000000f,0.11000000f,-0.27000000f,-0.69000000f,0.45000000f,0.23000000f,0.87000000f,-0.35000000f,-0.31000000f,0.73000000f,-0.30000000f,-0.65000000f,0.36000000f,0.52000000f,-0.80000000f,0.62000000f,0.25000000f,0.31000000f,-0.42000000f,-0.32000000f,0.83000000f,-0.59000000f,-0.22000000f,-0.61000000f,-0.35000000f,-0.60000000f,-0.89000000f,-0.46000000f,-0.38000000f,-0.69000000f,-0.99000000f,0.87000000f,-0.04000000f,0.47000000f,0.31000000f,-0.07000000f,-0.64000000f,0.30000000f,-0.09000000f,-0.57000000f,0.28000000f,0.39000000f,0.75000000f,-0.44000000f,-0.50000000f,0.97000000f,0.74000000f,-0.86000000f,0.59000000f,0.28000000f,-0.48000000f,-0.96000000f,0.59000000f,0.17000000f,0.43000000f,0.84000000f,-0.80000000f,0.14000000f,0.10000000f,-0.25000000f,-0.99000000f,-0.89000000f,0.12000000f,-0.67000000f,-0.24000000f,0.65000000f,-0.20000000f,-0.73000000f,0.66000000f,0.80000000f,-0.46000000f,-0.32000000f,-0.60000000f,0.79000000f,-0.99000000f,0.22000000f,0.30000000f,-0.33000000f,0.49000000f,0.71000000f,-0.59000000f,-0.47000000f,-0.36000000f,0.93000000f,0.67000000f,-0.66000000f,-0.48000000f,0.04000000f,-0.11000000f,0.22000000f,0.55000000f,0.31000000f,0.26000000f,0.17000000f,-0.12000000f,0.39000000f,0.40000000f,-0.13000000f,0.44000000f,-0.36000000f,0.81000000f,0.69000000f,-0.47000000f,-0.07000000f,-0.94000000f,-0.06000000f,0.45000000f,-0.47000000f,0.12000000f,0.30000000f,0.81000000f,-0.50000000f,0.64000000f,0.56000000f,-0.01000000f,0.43000000f,-0.24000000f,0.45000000f,-0.30000000f,0.56000000f,-0.13000000f,0.44000000f,-0.17000000f,0.17000000f,0.76000000f,-0.32000000f,-0.49000000f,-0.13000000f,0.07000000f,-0.43000000f,-0.50000000f,-0.80000000f,-0.07000000f,-0.13000000f,0.93000000f,0.13000000f,-0.29000000f,-0.39000000f,0.53000000f,-0.89000000f,0.67000000f,0.25000000f,0.42000000f,-0.29000000f,0.48000000f,-0.37000000f,0.99000000f,0.99000000f,-0.12000000f,0.36000000f,0.64000000f,-0.79000000f,0.85000000f,-0.97000000f,-0.01000000f,-0.51000000f,-0.54000000f,-0.02000000f,-0.79000000f,-0.70000000f,-0.61000000f,0.24000000f,-0.12000000f,0.82000000f,0.18000000f,-0.91000000f,-0.83000000f,-0.90000000f,-0.32000000f,-0.14000000f,0.51000000f,0.05000000f,-0.63000000f,0.49000000f,0.57000000f,-0.31000000f,-0.97000000f,0.77000000f,-0.48000000f,0.05000000f,-0.75000000f,-0.72000000f,0.47000000f,-0.55000000f,0.19000000f,-0.76000000f,0.39000000f,-0.06000000f,-0.66000000f,0.20000000f,-0.85000000f,-0.09000000f,-0.76000000f,-0.84000000f,0.09000000f,0.74000000f,-0.09000000f,-0.75000000f,-0.69000000f,0.18000000f,0.27000000f,0.74000000f,0.73000000f,0.29000000f,0.70000000f,-0.59000000f,0.91000000f,0.93000000f,0.83000000f,0.40000000f,-0.87000000f,-0.29000000f,-0.93000000f,-0.33000000f,0.88000000f,-0.95000000f,-0.81000000f,-0.71000000f,0.96000000f,-0.37000000f,-0.39000000f,-0.23000000f,0.08000000f,0.71000000f,-0.18000000f,0.23000000f,0.61000000f,0.05000000f,0.19000000f,-0.19000000f,-0.81000000f,-0.05000000f,0.63000000f,0.84000000f,-0.12000000f,-0.33000000f,0.27000000f,0.49000000f,-0.29000000f,-0.30000000f,0.70000000f,-0.82000000f,-0.59000000f,0.59000000f,-0.28000000f,0.10000000f,-0.24000000f,0.13000000f,0.85000000f,-0.54000000f,-0.63000000f,0.65000000f,-0.06000000f,-0.59000000f,-0.97000000f,-0.36000000f,-0.40000000f,-0.34000000f,0.84000000f,-0.25000000f,0.77000000f,0.22000000f,0.87000000f,0.91000000f,-0.78000000f,0.74000000f,-0.13000000f,0.13000000f,0.07000000f,0.15000000f,0.92000000f,0.17000000f,-0.51000000f,0.06000000f,0.79000000f,-0.51000000f,-0.76000000f,-0.19000000f,-0.22000000f,0.74000000f,-0.31000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.97000000f,-0.59000000f,0.39000000f,-0.58000000f,-0.70000000f,-0.29000000f,0.44000000f,-0.71000000f,-0.77000000f,-0.83000000f,0.17000000f,-0.55000000f,-0.47000000f,0.98000000f,0.74000000f,-0.04000000f,0.57000000f,0.05000000f,0.64000000f,-0.53000000f,-0.23000000f,-0.15000000f,0.87000000f,-0.86000000f,0.45000000f,0.50000000f,-0.58000000f,0.35000000f,-0.89000000f,0.59000000f,-0.34000000f,-0.12000000f,-0.56000000f,-0.08000000f,0.93000000f,0.93000000f,0.27000000f,-0.60000000f,0.06000000f,0.47000000f,0.22000000f,0.49000000f,0.67000000f,-0.30000000f,0.83000000f,-0.13000000f,0.86000000f,-0.86000000f,-0.79000000f,-0.41000000f,0.30000000f,0.56000000f,0.88000000f,0.17000000f,0.40000000f,-0.84000000f,0.84000000f,-0.18000000f,0.95000000f,-0.17000000f,-0.52000000f,0.14000000f,0.04000000f,0.96000000f,0.21000000f,-0.42000000f,0.92000000f,0.32000000f,-0.24000000f,-0.11000000f,0.26000000f,-0.60000000f,-0.68000000f,0.91000000f,-0.37000000f,0.11000000f,0.76000000f,0.31000000f,0.39000000f,-0.25000000f,-0.10000000f,0.63000000f,0.20000000f,0.83000000f,-0.49000000f,0.71000000f,0.42000000f,-0.01000000f,0.15000000f,-0.47000000f,-0.13000000f,-0.69000000f,0.17000000f,0.90000000f,-0.21000000f,0.14000000f,0.60000000f,0.39000000f,-0.16000000f,0.23000000f,-0.33000000f,0.88000000f,-0.78000000f,-0.87000000f,0.15000000f,-0.68000000f,0.53000000f,-0.11000000f,0.43000000f,-0.54000000f,-0.57000000f,0.87000000f,0.81000000f,0.13000000f,-0.07000000f,0.18000000f,-0.32000000f,-0.85000000f,0.35000000f,-0.32000000f,0.75000000f,-0.80000000f,0.79000000f,-0.12000000f,0.55000000f,0.06000000f,-0.95000000f,0.50000000f,0.99000000f,-0.88000000f,0.75000000f,-0.69000000f,-0.23000000f,-0.53000000f,0.93000000f,-0.57000000f,0.29000000f,0.58000000f,-0.42000000f,0.75000000f,-0.92000000f,-0.13000000f,-0.16000000f,0.28000000f,-0.90000000f,-0.17000000f,-0.74000000f,-0.55000000f,0.99000000f,-0.82000000f,-0.24000000f,-0.43000000f,-0.52000000f,-0.45000000f,-0.02000000f,-0.70000000f,-0.26000000f,0.74000000f,0.21000000f,0.97000000f,-0.10000000f,-0.65000000f,-0.18000000f,-0.06000000f,-0.60000000f,0.54000000f,-0.76000000f,0.23000000f,0.21000000f,0.44000000f,0.06000000f,-0.80000000f,-0.87000000f,-0.13000000f,0.92000000f,0.97000000f,-0.04000000f,0.35000000f,-0.44000000f,-0.00000000f,-0.78000000f,-0.54000000f,-0.91000000f,0.19000000f,0.97000000f,-0.60000000f,0.35000000f,-0.64000000f,-0.84000000f,0.25000000f,0.90000000f,0.17000000f,-0.26000000f,-0.82000000f,0.59000000f,-0.62000000f,-0.14000000f,0.41000000f,0.62000000f,0.91000000f,-0.73000000f,0.62000000f,0.87000000f,0.50000000f,0.55000000f,-0.72000000f,0.00000000f,-0.19000000f,0.90000000f,0.30000000f,0.09000000f,-0.10000000f,-0.90000000f,0.66000000f,0.77000000f,0.63000000f,-0.07000000f,-0.92000000f,-0.63000000f,-0.86000000f,-0.08000000f,0.09000000f,0.38000000f,0.58000000f,0.76000000f,-0.98000000f,0.83000000f,-0.05000000f,-0.37000000f,0.52000000f,-0.57000000f,-0.31000000f,-0.47000000f,-0.49000000f,0.42000000f,-0.13000000f,-0.79000000f,0.60000000f,-0.08000000f,-0.12000000f,0.65000000f,-0.48000000f,0.79000000f,0.22000000f,0.71000000f,0.70000000f,0.78000000f,-0.25000000f,-0.05000000f,0.48000000f,0.14000000f,-0.85000000f,0.50000000f,-0.86000000f,0.31000000f,0.60000000f,0.72000000f,0.82000000f,-0.46000000f,-0.65000000f,-0.54000000f,0.26000000f,0.17000000f,-0.02000000f,-0.48000000f,0.36000000f,-0.63000000f,0.84000000f,0.62000000f,0.59000000f,-0.74000000f,0.00000000f,0.45000000f,0.08000000f,-0.54000000f,-0.34000000f,0.79000000f,0.38000000f,-0.17000000f,0.41000000f,0.30000000f,0.06000000f,0.22000000f,0.59000000f,0.23000000f,-0.36000000f,0.85000000f,-0.00000000f,-0.93000000f,0.74000000f,0.06000000f,-0.99000000f,-0.06000000f,-0.48000000f,0.27000000f,-0.97000000f,-0.44000000f,-0.12000000f,0.46000000f,-0.63000000f,-0.57000000f,-0.98000000f,0.72000000f,0.59000000f,-0.81000000f,0.96000000f,0.64000000f,-0.59000000f,0.13000000f,-0.80000000f,0.43000000f,0.23000000f,-0.66000000f,-0.74000000f,-0.52000000f,0.39000000f,-0.60000000f,-0.92000000f,0.49000000f,0.03000000f,0.84000000f,-0.72000000f,-0.97000000f,-0.81000000f,0.17000000f,0.79000000f,0.69000000f,-0.66000000f,0.11000000f,0.40000000f,-0.37000000f,0.46000000f,-0.74000000f,-0.50000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.20289988f,0.13020000f,2.98910006f,2.74039992f,0.73939991f,3.32020011f,-1.13710004f,0.26990008f,2.47700002f,0.50800002f,-0.52329987f,-0.52909997f,0.58690015f,-1.81580005f,5.23659996f,4.39350008f,1.20660010f,1.98469997f,-1.14199996f,-1.14160009f,-0.66119988f,-0.31039993f,0.31309994f,-1.71549999f,-3.43670001f,0.02590001f,-0.67029989f,0.20780000f,-1.93989999f,-1.31770003f,-3.15710000f,0.75519997f,-2.43070004f,3.13579996f,-0.11050007f,-1.53700002f,0.41389995f,-0.14940001f,1.06710001f,1.82070000f,0.56239993f,-1.91499994f,2.15450000f,-2.24100007f,3.19020014f,-2.18770003f,0.26500003f,-0.41059995f,-2.50660009f,0.13550006f,0.44190000f,1.12430001f,0.72220002f,-4.08990007f,0.91349994f,-2.13200010f,1.23280001f,-2.21580005f,2.83140006f,-0.04560007f,4.17859995f,-3.29680006f,0.16330003f,0.67140001f,5.52930000f,-0.40780001f,-0.12319996f,2.39729997f,2.38109999f,-3.89060003f,0.65330000f,3.57300007f,-0.55240005f,2.60020017f,-3.29009999f,-1.06230006f,-0.23810005f,3.00950000f,-0.40209998f,2.25290002f,-0.79420007f,-0.66919997f,-2.84469998f,-1.41139988f,-0.34189999f,3.17270001f,2.24920002f,0.85819995f,0.17170006f,1.32019995f,1.12469995f,-1.24859990f,-3.45210001f,1.35089996f,-1.91590001f,-1.54500005f,6.50810000f,-0.54220009f,-1.42240013f,0.77600018f,0.06880005f,-3.75709998f,1.58680005f,-4.44429997f,-0.55259998f,1.08230005f,-1.08529999f,-1.49980002f,-2.91090003f,2.62429996f,-2.01900008f,-2.54970016f,1.95070013f,-3.91780006f,-0.29069999f,-1.20050012f,0.02260002f,1.25809994f,0.42800007f,-2.03180001f,-5.63649988f,-0.63009993f,0.60959993f,1.17660001f,-0.28179996f,-1.05339989f,-1.35129999f,-2.07280003f,-1.55439999f,-3.09450001f,-4.01399991f,-1.85150007f,0.81220006f,-1.02560010f,-2.13259999f,-1.33479996f,-0.96130001f,0.52940002f,3.25250003f,-5.06859991f,1.21139988f,-0.98289999f,2.79529995f,2.08060009f,0.02380003f,0.25030001f,-2.72410001f,-0.38870006f,2.99330006f,-0.06329992f,-1.07030002f,-0.28339999f,-0.16890004f,-6.42990000f,-3.13360000f,-0.41850008f,-1.15290010f,-0.90399987f,0.14589989f,0.35499996f,-2.25870007f,-5.07770000f,0.42659999f,-3.98390005f,-1.48919998f,-1.44719997f,-0.37929998f,-2.12809993f,0.31079999f,2.66679998f,-1.85099997f,2.29890005f,2.87940007f,-0.56439998f,4.82810002f,-3.24129999f,-0.49340010f,-0.05570001f,-1.64650006f,0.82990007f,-0.40140000f,1.98579995f,-0.59800000f,-0.44470000f,-2.21670000f,0.65330004f,-0.85090001f,3.09740002f,-1.04479999f,1.23880005f,2.33519999f,-4.62359995f,0.61429994f,2.06490003f,0.12729997f,-0.82789996f,-0.37490000f,1.11650003f,0.67689990f,0.55319998f,-0.58479995f,-4.66149986f,1.43119990f,0.25819997f,-1.49609985f,1.53400007f,0.97610003f,-0.09049998f,-0.74429999f,1.39939996f,-0.78500001f,1.55529999f,-2.05749994f,-2.46169997f,0.40299999f,0.66439998f,-0.60939988f,-0.19009996f,-0.01079991f,-1.47700001f,1.04029994f,-0.93759995f,-1.41360006f,-3.35709991f,3.71340005f,0.83010002f,3.31619994f,-1.32899992f,-0.54419995f,0.10819995f,-0.75060007f,-2.27390007f,-0.56009997f,1.31949993f,2.64999999f,-1.91179997f,1.54709993f,1.05620002f,-0.80880010f,0.20039997f,-3.57019998f,0.97050001f,0.88499992f,2.72420005f,0.81359993f,1.44110004f,0.37619999f,0.33489995f,1.16099995f,0.45059999f,1.96020003f,-3.65620004f,0.88540002f,-1.92970008f,-3.81169996f,-0.76440004f,-2.30429997f,4.44239992f,-1.18640004f,1.55550004f,2.12500007f,2.19980000f,-0.32659989f,0.30450001f,-1.37619999f,3.21000001f,-3.05459992f,2.08190003f,1.74839992f,-2.14749996f,0.54200003f,-0.47620000f,-0.04129997f,-1.98519996f,1.91180006f,0.97810003f,-1.43779995f,0.78709996f,2.18339997f,2.31790000f,0.43589994f,2.57740000f,-0.97120004f,-4.83550002f,2.13500005f,-1.21489999f,-0.62629994f,2.13089995f,-1.73510003f,1.30629997f,1.65049998f,1.50340000f,0.42289998f,1.02079990f,-1.85560004f,-3.31160006f,-0.61099992f,0.53329999f,1.20029992f,-0.50370013f,-2.66229995f,-0.99880001f,1.72410009f,1.23420007f,2.52710001f,4.19060010f,-0.72399991f,-0.76519999f,-2.26149998f,1.23140005f,-5.35929998f,1.31239998f,1.04059999f,0.03890011f,1.02550001f,3.28500007f,0.40429986f,-0.66520002f,0.84889996f,0.04040000f,1.29520000f,1.15469998f,2.87860007f,0.63140003f,-3.93770009f,0.40879991f,0.25770011f,2.11660001f,-0.05349997f,2.51520000f,2.15399995f,-1.26769988f,-1.50680006f,2.62720006f,-2.32040007f,2.56139998f,-0.96139994f,0.04509996f,-1.22180006f,-1.53849997f,-1.03130002f,-0.05570003f,1.46820000f,1.70999992f,0.61019996f,0.32979997f,1.93869994f,-0.86489996f,-2.44560014f,-2.26259988f,-0.96269998f,1.89649999f,0.12409998f,0.08620000f,1.07889998f,-1.52510005f,-1.51439992f,5.36730000f,0.52669999f,3.18430002f,-0.30189997f,0.43950003f,2.07319997f,-1.09220000f,1.07870001f,2.63400002f,3.10169994f,2.27980013f,-0.41829999f,-1.50370000f,-0.02419997f,0.46290000f,-0.92890002f,1.30949989f,0.51590006f,0.29319992f,-1.99029995f,-1.35750006f,0.51500003f,-0.66979990f,-2.25150001f,-2.05309994f,-1.96419998f,-1.11370008f,0.17890005f,-2.73180003f,-2.27969993f,1.82050000f,-2.32290006f,-2.79039996f,-1.42680000f,-1.85459992f,0.28609988f,-3.00230002f,2.12409993f,-2.53630000f,-2.74569997f,-0.80929997f,-0.39030007f,-1.98589999f,-3.30519994f,1.38709994f,-2.59980006f,-1.79930004f,0.06270006f,-0.56980008f,-0.28560000f,-1.12520004f,0.76350001f,2.10649993f,2.56399998f,-0.38159990f,1.01460003f,1.75389996f,-0.76810005f,-1.06030005f,1.11349989f,3.00319994f,0.11799997f,1.10510002f,-2.81089996f,0.17590003f,-0.17670000f,2.04060002f,1.93999994f,-0.85550006f,-2.98360007f,0.04769994f,-0.64699997f,-0.30319997f,2.49849997f,1.56510003f,-2.13870001f,0.11360000f,-0.43040004f,2.40280000f,-0.38159999f,1.83580008f,0.08100001f,1.83609999f,-0.19419999f,0.50369996f,-1.43190003f,0.96710003f,1.26420008f,-3.99049998f,-3.69700000f,-1.65950001f,0.86629992f,1.19840007f,0.13080004f,-2.81149994f,-0.12790001f,1.13590005f,1.55249997f,-1.57040001f,0.52350004f,0.83089992f,-2.18209993f,-1.06959996f,0.49480000f,1.42569997f,1.51479998f,0.59259995f,-0.13920001f,-1.22189998f,-2.41750007f,3.26440009f,0.51210000f,1.34490001f,6.74220006f,1.53359994f,-1.76959993f,0.03640004f,-2.32749989f,1.31650006f,0.11810016f,0.49809988f,-0.23290000f,0.89570000f,1.41889995f,-0.74649995f,-0.57729990f,0.43100005f,0.49670000f,1.17809999f,2.25999999f,2.03460008f,3.68880001f,4.39400012f,1.03219996f,3.39089996f,2.13889998f,0.79530004f,1.32159993f,-2.02300001f,0.94860011f,-0.01400011f,2.19209993f,1.87670000f,3.31710000f,4.09949993f,-0.59620003f,2.48799992f,0.09719995f,-2.42289997f,-3.70800009f,0.76300005f,2.05920001f,0.88090003f,-3.13949996f,-0.05120005f,-1.28209994f,1.26830007f,-2.72100002f,0.69800000f,0.30739996f,0.58689996f,-0.83419987f,-2.09190000f,2.51410009f,-1.36540005f,-5.05340002f,0.25509996f,-0.27160003f,-1.64059994f,-0.82450010f,4.26180003f,-1.33849991f,-1.93110000f,0.69230003f,0.10959984f,0.19449997f,-2.52609995f,1.12149999f,-0.85449994f,2.57190004f,-1.35470012f,-1.61909994f,1.23859992f,3.78779997f,-3.47369996f,2.37740001f,1.93769994f,-1.00399999f,1.01469998f,-1.08220002f,-3.04839998f,2.14560003f,-0.75479994f,-1.68959995f,-1.41950004f,4.21169996f,1.88029993f,-0.37489996f,-0.04280008f,2.04130003f,-0.86150003f,0.85559998f,0.17920000f,0.47109997f,2.34919992f,0.36619994f,2.24460001f,1.90659999f,-1.29309997f,0.26130002f,-0.72949999f,1.30659994f,0.39469993f,-0.37169994f,-0.29040000f,-1.64459996f,1.88140005f,0.01280004f,0.15190006f,-0.31889994f,-1.68560000f,-0.56709993f,-1.53820001f,-1.43329994f,-2.83429994f,-0.67209997f,-0.00230004f,-4.31040004f,0.73510000f,0.63819990f,0.44890004f,-0.48950000f,1.32870000f,0.52559999f,1.96040004f,2.17759993f,-1.61839990f,-0.88250003f,0.90530006f,-0.73450004f,0.87160004f,-1.21579997f,0.95890001f,0.67590001f,-0.76500007f,0.89390004f,-3.00899999f,-3.90719993f,-1.20650007f,0.35419998f,1.24519995f,-0.14749999f,2.36279999f,-0.86260002f,-3.19219994f,4.52510005f,0.71489992f,2.21489999f,0.90949998f,3.79699996f,2.30769994f,1.56859993f,-0.74550008f,0.02190001f,-0.73279999f,0.41019997f,4.38910002f,1.02509995f,-0.32510003f,-0.60559988f,0.05329999f,-1.16969998f,-1.14229997f,-1.27300001f,2.11870000f,1.95740003f,-0.57000000f,-2.73210004f,-1.60699999f,-0.60969998f,-0.32800000f,-0.98839998f,0.71939995f,1.41400009f,-0.14910003f,-0.03039996f,2.44159992f,1.53580002f,-0.62420004f,1.62150006f,-0.51280003f,-0.93590005f,2.86059999f,2.34839993f,1.64049998f,-4.07230004f,-0.87550001f,-2.11969999f,-2.52199998f,-3.29079998f,-0.72960004f,-1.75510005f,-3.77669996f,1.19719998f,0.97850009f,-0.82320000f,0.03420000f,-0.80979999f,-2.75460001f,-1.68749984f,-1.70890000f,-1.94749998f,-2.02620002f,-2.51850004f,0.65250008f,-1.97559994f,-1.61680004f,-0.42170010f,1.12149998f,-0.39889999f,-2.22260002f,-0.73410004f,0.55610000f,-0.52320004f,-0.74129999f,-0.58289997f,-0.55360006f,1.97800010f,1.04079993f,0.22989987f,1.34900004f,-2.82219997f,0.94800005f,-3.51679996f,1.68389991f,0.56470005f,-0.82020003f,-0.28200002f,1.29439998f,2.01049983f,2.45960020f,-2.28709998f,0.67400011f,0.79979999f,-1.84899993f,-1.41749995f,1.94970003f,0.56090002f,5.60910004f,-1.62220006f,0.26110000f,-0.47090002f,-0.52950000f,-0.57229987f,-2.08959995f,0.68879996f,2.77200004f,1.32879998f,-1.56380006f,3.00689996f,2.67430010f,0.42849995f,-2.37000000f,0.21790009f,3.16750001f,1.24089995f,0.01079996f,-4.27460004f,-2.63870000f,-1.55079994f,-1.67589993f,0.22779999f,-1.60879995f,0.26209993f,3.59199999f,-0.55880003f,-1.02310002f,2.04150014f,0.59919985f,0.50949996f,-0.19599997f,-0.03910004f,2.15910002f,-0.26749996f,-1.00470008f,0.90050008f,-2.09750013f,0.01119988f,2.36110004f,-5.58310007f,3.21949987f,-1.29210003f,-0.06409991f,0.57140007f,1.37880000f,0.05670002f,-0.23030005f,-3.37069984f,0.02990005f,2.73950004f,-0.42209990f,4.88729999f,0.04070005f,0.67020010f,-4.19220001f,2.19360015f,-2.75390000f,-1.22039998f,-0.19190008f,-2.18840010f,-2.29959999f,2.74829997f,0.37879990f,0.03149995f,-1.71129983f,1.90230001f,-0.56759996f,3.93459997f,1.36430005f,4.01300004f,0.59540003f,6.51299987f,0.18150007f,0.87519997f,-0.37870007f,1.38969999f,2.44970005f,1.26930013f,-1.28179988f,0.25289997f,3.05149996f,0.16620005f,-3.07060001f,2.12349994f,3.23639997f,0.50550011f,1.63340010f,-0.30390012f,1.73149993f,-1.37060014f,-0.12539994f,0.64609998f,-0.16950003f,1.45710005f,1.31829997f,-2.89939996f,-1.18700004f,0.17089995f,-1.09160009f,-2.90899982f,-0.51930003f,-0.65599998f,-1.83349999f,2.52900001f,-1.95089990f,0.85429993f,0.05129991f,0.56890007f,-3.12900010f,0.88729990f,-0.12810005f,0.49730003f,-1.00129996f,-0.31779995f,-1.57189999f,1.45309996f,0.47330003f,1.22740000f,-3.73739997f,-2.29909989f,-1.47659986f,-1.79849995f,-1.39469996f,0.79489991f,5.04109997f,0.27990008f,1.60149994f,-1.37599990f,4.29649996f,0.64610005f,-2.85990002f,-0.85079999f,-1.10249991f,-1.44219997f,2.24690001f,1.85170004f,-0.75609993f,0.90889986f,-2.41839996f,3.64729986f,-1.00570004f,-2.29859998f,1.06529997f,3.35949992f,0.83359999f,-2.99789994f,-0.27839988f,-1.36310003f,1.89590008f,-0.59080005f,-1.02560003f,1.41900006f,-0.92299998f,2.55779995f,0.94449994f,-5.12929996f,-2.67789994f,-1.55890003f,-1.25040001f,-1.10250000f,-1.05730001f,-4.73379999f,0.36309996f,0.26790004f,0.35439998f,-0.75370009f,-1.12180000f,3.02570009f,1.06810007f,-1.91670003f,4.42259995f,-1.08120001f,0.04190010f,-1.08290002f,-2.63870005f,-3.69240007f,1.84119999f,-2.32739998f,-2.40120001f,2.37350010f,0.05930000f,-1.38749996f,-2.24059997f,-1.74079998f,-0.23340002f,0.19759997f,0.41750001f,0.46970005f,-2.40289991f,2.76849990f,0.03870002f,-1.17090002f,2.60659993f,-0.72669996f,-0.44670010f,-0.97510001f,0.72310003f,-2.70580003f,-1.46749989f,-1.02380004f,-1.29650003f,-1.22789998f,-2.15150005f,-2.25190007f,-0.96549999f,-0.19579997f,5.16350002f,-0.76809995f,-0.85050004f,2.32739995f,-0.62810007f,0.97289991f,-0.10469998f,1.58519983f,2.01330002f,-0.17859989f,-2.59930000f,-1.96600007f,0.70450007f,-1.86480007f,-3.98680007f,-1.95489995f,-0.86730000f,-1.61980002f,3.54860005f,0.78549993f,2.73730001f,3.35109997f,-4.09029993f,-0.55000006f,-1.38380001f,1.50940005f,1.85479993f,1.35149992f,-0.65609992f,0.50749998f,-1.29939995f,-1.62020018f,-1.47979992f,-2.40330006f,0.24140009f,-1.49149996f,-2.42080001f,0.50979999f,-0.40999998f,-0.82340003f,0.19840007f,-5.00000000f,2.97000010f,0.83499992f,0.49049995f,3.45389999f,0.23870001f,-1.79199993f,0.96469990f,-0.02659992f,-1.13630005f,-1.96149990f,0.21530000f,-0.65690003f,-0.34020007f,-4.25380005f,0.83779990f,-0.79940005f,4.71039996f,-0.82990007f,0.74340009f,1.71699990f,5.08320001f,-0.50099991f,1.15980011f,-3.62050010f,-1.33009994f,-5.56900000f,-0.86280004f,-5.48919997f,0.89179995f,1.83159992f,1.25090006f,-3.07690003f,-2.36859999f,1.94150006f,4.11620012f,-3.89189987f,0.89249990f,3.22169995f,1.97989999f,-1.01850000f,0.49949992f,-2.05240005f,-2.92219995f,0.66820009f,-0.85490003f,-1.68919999f,3.34170003f,1.04770000f,0.88619992f,1.42930007f,-0.56100002f,1.58110007f,1.67029993f,1.95539994f,-1.10469994f,-0.33479999f,-4.70080005f,-2.62160000f,0.70209992f,-2.67780012f,1.50359999f,0.74720001f,2.38330009f,-0.59190003f,-0.24020006f,-0.33700005f,3.54419992f,-3.28559997f,-0.06910001f,0.65269993f,0.10669999f,-0.73310001f,-1.69139999f,4.44409988f,1.24140001f,-2.15079993f,-0.72829992f,-2.97009991f,0.07540002f,-1.84850000f,-0.77930000f,2.65780005f,0.14989997f,1.12109995f,2.26780005f,1.09479999f,-2.85320001f,-2.63979993f,-0.17310002f,0.01239998f,-1.17960002f,2.37249996f,-0.72900001f,-1.13069992f,1.62419993f,1.73600001f,0.58280001f,1.10330001f,4.39710000f,-0.78750005f,-0.24350000f,1.92439996f,0.35509991f,2.63849996f,2.67300003f,-1.54379997f,2.84309997f,-3.65490003f,0.95560008f,-0.08360011f,2.51499988f,-2.61460004f,0.17619999f,0.25210008f,-0.71809999f,-1.27029996f,0.34050004f,-0.84330001f,-0.08029998f,-1.66639996f,-2.29619995f,1.16020009f,2.06350010f,-2.99019987f,-3.78999996f,-0.87529998f,-0.67549988f,-0.96210000f,2.81080008f,-0.55170006f,-2.06160005f,2.98619994f,0.54889997f,-5.03719992f,1.35919992f,0.81499999f,-0.84529991f,-0.94469996f,-0.98049983f,0.64610009f,-1.97830000f,-1.24849999f,-0.09410003f,0.26510005f,-0.61330004f,2.13649993f,-3.85550000f,-1.81090009f,-1.03220001f,-1.47329999f,-2.40730006f,2.08870009f,1.71659998f,-0.28889993f,1.22899992f,-1.25879999f,2.97350008f,1.87179997f,0.06159997f,-0.02309994f,3.94190005f,-0.40270001f,-0.68250009f,-2.40500004f,-2.13099990f,-2.59940005f,5.55989994f,-1.58829999f,1.01039997f,2.43680000f,-1.43760003f,1.36949997f,-0.30010006f,0.65360008f,1.54640006f,0.02569997f,0.41160000f,-0.66919997f,1.03900000f,-1.02739998f,0.91820003f,-1.19929995f,0.36389993f,3.20219989f,2.63220005f,2.08859992f,-1.03119995f,0.13859997f,-2.24160002f,2.01359991f,1.73029995f,3.08839985f,2.11559997f,0.04090004f,-1.75510000f,-0.33489997f,0.13169997f,-0.67789998f,-4.21029999f,-1.80569996f,-1.84029997f,0.74999996f,-4.48010002f,2.03140000f,1.53310013f,-2.14809996f,-1.02770004f,0.04759994f,-0.62509992f,1.14070001f,1.54129994f,-0.05329992f,-1.05449991f,1.69470005f,0.39530007f,-3.06750004f,3.75440001f,1.75530004f,-1.24390004f,2.05829998f,0.49749993f,-3.05729998f,-2.25759996f,-1.60880003f,-0.92210003f,1.54520007f,-0.19310005f,-4.32420001f,-1.22730001f,-1.22139994f,1.93139999f,0.68120003f,-0.73049994f,-0.62399996f,-0.30420002f,3.27809989f,-0.56399996f,0.64959998f,0.40889991f,-1.55690014f,-1.67980004f,0.55580001f,0.36140007f,-3.08590001f,2.24210000f,-0.94660001f,0.18259994f,-0.69729994f,0.31380002f,-1.42029998f,3.55969994f,2.26739991f,0.66150001f,5.00020000f,2.61439992f,0.19779997f,0.97339992f,2.99380011f,2.81419999f,-1.61680003f,-0.19539995f,-0.16949997f,-1.06210001f,0.44639994f,-1.19190002f,1.30310004f,2.55019994f,-0.79790002f,-1.62949989f,1.59249996f,-2.07770008f,-1.94830000f,-1.44689998f,-0.05110003f,-1.05350000f,2.18019999f,2.63770001f,-4.01710002f,-1.62869999f,-3.58120002f,-1.14110012f,0.45810006f,-0.45890004f,-2.76800008f,-3.18869990f,-0.23340002f,1.20290008f,0.11809992f,0.85760006f,1.76180000f,-1.04110003f,1.76359996f,1.33219995f,1.43269995f,1.16960006f,-1.86789993f,0.09390013f,1.19269992f,0.46339990f,0.67949997f,-1.39319995f,-0.18980003f,-1.27300004f,1.56050000f,1.87749998f,0.97890004f,0.87340001f,-0.94690006f,-0.08349998f,-0.23579998f,-3.40490003f,2.33689996f,1.94570004f,-1.48060004f,-0.18869999f,2.79789994f,-1.11370006f,-0.85320008f,0.40989990f,1.27830003f,0.76609990f,-1.19270003f,3.53590005f,-0.35630001f,1.58240001f,2.84269989f,-0.19560003f,-0.30690005f,0.55789999f,2.89309998f,-0.88090001f,-0.16219996f,-0.01389998f,0.08380000f,1.63229997f,-5.20350006f,3.12119997f,0.31350003f,-2.42910007f,-1.56219999f,0.74900018f,0.61700008f,1.04949995f,-3.21389986f,0.28370008f,-0.46370001f,-1.73149999f,4.05350009f,1.72950003f,-0.08930002f,0.91980002f,-5.72590000f,0.71700010f,-1.91989996f,1.20949998f,0.79419995f,0.39180009f,1.63060004f,1.53930002f,1.76210001f,6.17209991f,-0.39759995f,-1.34979999f,-1.17099997f,-1.83509992f,0.73760005f,2.52659994f,2.26370009f,1.87009995f,0.31430005f,0.65360004f,-1.55570006f,3.50280010f,1.30159987f,-0.63240004f,-1.16570012f,1.87690002f,3.42540003f,-1.05770001f,3.28989995f,-0.50319988f,1.59180005f,0.02499997f,1.97840001f,4.68600004f,0.64920000f,-3.36560007f,0.23079996f,-1.99650007f,-0.38710005f,1.49030004f,1.48460001f,-0.60579988f,1.89880002f,2.15619997f,0.59620005f,-1.97660005f,-2.30599996f,0.44920007f,-1.27190006f,0.28520002f,-2.89880009f,-0.98019999f,0.28209994f,2.24769994f,-1.41390003f,2.65739991f,-2.96850000f,-5.71599996f,-1.85059995f,2.87119998f,-1.60309996f,1.91410007f,1.87370000f,-0.32730005f,-0.75719991f,1.51829999f,-0.64009994f,-2.07439989f,1.59630000f,5.37900001f,4.11989997f,1.51470009f,1.24629999f,3.08750005f,1.89760001f,0.18240002f,-1.12130001f,1.81070000f,-0.72359990f,2.68610006f,0.36010007f,-0.97440006f,4.86549996f,4.07219998f,1.01169992f,2.06220000f,0.87910009f,2.35410002f,-3.72849996f,1.51359996f,-1.14980003f,0.01880001f,-0.66130003f,-2.18630001f,-1.03050001f,1.17590005f,1.48900007f,-2.05350004f,-1.86459991f,-0.76350003f,-3.53229999f,-1.21750015f,-2.26379992f,-1.58159994f,-2.33029998f,1.70450011f,-0.53180005f,-0.90200005f,-0.06190007f,2.52959997f,-1.89970007f,-0.06269999f,3.79580005f,-1.43960010f,-0.31390003f,2.94549998f,0.57870002f,0.49250011f,1.84829998f,1.05240002f,1.17390001f,1.23600007f,2.78250008f,-0.91559994f,-0.42239995f,-0.36329998f,0.07449994f,5.50809997f,0.86960005f,1.71470013f,-0.15359995f,0.61130002f,-5.91210009f,1.97939997f,0.18820006f,-2.50999998f,-0.63360005f,1.18000005f,0.20630009f,-3.12999995f,2.32510008f,-0.98120001f,0.75200006f,-3.87550004f,0.43510011f,-0.60939998f,0.49730002f,2.41009989f,0.92849995f,0.22459990f,-0.27719997f,2.18950003f,-2.66060000f,-0.41709993f,-1.33989997f,-0.52860002f,-1.63870001f,1.27970002f,1.49919995f,1.91789997f,4.52379999f,1.38260004f,-0.41829999f,-2.00940012f,-1.00259997f,0.76649995f,-1.02110007f,1.54569999f,-0.29720004f,3.05029996f,-0.84990001f,-0.83019997f,3.40659993f,-1.08790002f,-0.52079996f,0.74739990f,2.88239996f,0.61479992f,-0.99940008f,-1.51709985f,1.58529990f,-0.75490010f,1.42260004f,3.35969997f,-1.98340002f,-1.73979999f,3.94220005f,-1.59310000f,0.39649992f,0.04809988f,1.07240013f,0.29410008f,-0.49090002f,-1.66750001f,3.24279997f,-1.89659999f,-3.37500007f,-0.92830001f,-1.77020009f,-2.22300011f,1.18920000f,1.56529993f,3.20639997f,-1.29959995f,-0.52079995f,-0.99029996f,-2.45769994f,-0.24539990f,0.00739991f,-3.14920001f,-0.43649994f,-0.13099992f,0.65619991f,0.19119981f,2.54850011f,-3.41769992f,-2.13479990f,1.62119998f,6.83490005f,-0.13660012f,-2.89219994f,1.29089997f,1.56820008f,-2.03960004f,-1.68110000f,1.87029996f,3.83549995f,1.16490007f,-2.57130000f,0.89100001f,-0.45050002f,-0.16100006f,3.66589994f,0.77950001f,0.41699996f,0.78590014f,-0.18830007f,-0.56339998f,0.58409999f,-0.62289998f,0.68440005f,-0.28340009f,0.70740000f,1.34660000f,-0.40000001f,-0.20480002f,-3.84520007f,-1.05440006f,-4.10030000f,2.18890007f,2.28780002f,-3.21509994f,1.99390007f,0.00369996f,0.15429996f,-1.25340010f,4.90250003f,-0.51719994f,4.51530001f,2.33610001f,3.38560002f,2.11199993f,-6.62980001f,2.79829998f,1.71139997f,2.63000004f,0.35689993f,3.10780005f,0.09980004f,1.05999995f,-3.89510001f,1.72160003f,-1.80820007f,0.99759998f,0.05150005f,1.23230004f,-0.52140011f,-2.68599993f,4.04999993f,0.43650002f,-0.48670000f,-0.98490003f,2.58700007f,-5.42330004f,3.47250007f,-0.07270008f,1.27609994f,-1.80180004f,-5.76049993f,-4.15580004f,0.09889993f,0.60339999f,1.08010001f,-1.13559991f,0.50480003f,1.08789998f,-0.65199995f,-1.40760008f,2.15020001f,0.60260005f,-0.22420009f,-3.70480002f,-1.23720005f,2.47069991f,2.82450009f,-2.82830001f,2.33840005f,4.66790000f,-1.67219999f,-1.37720006f,0.44040003f,2.21910012f,-4.85420010f,-0.51719987f,-0.00709996f,-0.36810002f,0.99930002f,2.91820005f,-2.10180001f,0.49919992f,-0.52240002f,0.39229996f,2.62929990f,2.62649997f,3.01840002f,-2.38680003f,4.36919997f,-3.52669999f,-2.07930002f,2.19350004f,-3.55359987f,-1.37589996f,-2.41970001f,2.00940004f,-0.57429997f,-0.88690008f,1.05480007f,-1.33580002f,-2.03020001f,1.53460004f,0.64540000f,-0.36380004f,-3.04140005f,-1.43369990f,-0.24329998f,1.10240000f,-1.10769997f,2.45920017f,0.48990009f,3.68959996f,-0.73309998f,0.56050000f,2.40539995f,0.05149997f,-1.82939989f,1.72829998f,-0.52039996f,-0.00039998f,-3.45880006f,-1.32410003f,0.81070008f,0.87350000f,-0.44860003f,-2.54429999f,-1.00410003f,-0.11860001f,2.27060007f,0.90240000f,-1.96780002f,1.30699992f,-0.29360011f,1.60960001f,0.91460002f,-0.81539992f,-0.21179988f,1.64580000f,2.14149995f,-0.83170002f,1.02320011f,2.62470004f,-0.12770002f,0.80900003f,-0.27570004f,0.49729995f,0.33360002f,1.73549992f,2.63019998f,-2.19889993f,-2.67859995f,-1.56719998f,-0.81260001f,1.23990001f,2.11550002f,0.21669994f,-1.21229999f,-1.69140008f,-1.45439990f,-0.64929992f,-2.48750003f,2.55880002f,-1.46960002f,0.68990001f,1.49799997f,0.98700012f,-1.08440003f,-2.51869996f,0.59560001f,0.68840003f,0.85590001f,1.51400001f,-0.54919997f,-0.06009999f,-1.29670001f,-2.71739998f,0.74689999f,0.34129994f,-3.03650004f,1.17790006f,-2.09069999f,-2.40900004f,-0.80720002f,-2.54910002f,0.99860002f,-0.35679993f,-0.63500005f,-2.28039997f,-0.10000000f,0.13550012f,1.08420009f,-0.21409999f,-1.96789998f,-0.58599997f,0.65400001f,-3.56920002f,-0.34829993f,0.20860005f,2.62239996f,-3.12689997f,0.61880006f,-1.49380015f,1.76570003f,0.62209998f,2.11349995f,0.06969994f,-2.09769997f,-2.22899999f,-0.93720000f,-0.83810004f,-1.11209997f,0.25110003f,-1.52349993f,-2.33269989f,0.67559997f,-0.44300006f,1.43739999f,0.92220000f,0.61840003f,-2.95529999f,-0.72790002f,-0.39570001f,-1.62200006f,-2.13569998f,-1.00000001f,-0.46610006f,-0.91319992f,-2.56960002f,2.95179998f,0.18830000f,2.23130005f,-0.32990005f,0.74069995f,0.54360006f,-1.33850001f,0.22009991f,-2.46850007f,1.67240004f,2.44169994f,-0.72679995f,1.10490001f,-0.42180002f,1.48649992f,-0.01230004f,-1.19060003f,1.55979998f,-2.05259989f,0.20039999f,-0.25259999f,1.25149988f,2.18380003f,1.52729996f,3.16449993f,-0.61579989f,0.16200001f,-0.22370008f,0.55090000f,-0.36640003f,-2.54569995f,-0.53090001f,-1.28539994f,0.51060010f,-1.05429995f,0.18229992f,-2.01500002f,1.31429994f,0.04400001f,-1.58689994f,0.80600009f,1.11359996f,0.22880005f,-1.19250002f,1.49290002f,-0.78939985f,-1.96529993f,0.78179998f,1.46720006f,0.11269999f,-0.32349999f,3.53339998f,0.84879994f,-3.86639996f,-2.31810002f,-0.08210010f,1.72280005f,-3.33579997f,-0.28079996f,-3.00469992f,-5.36210005f,-3.97279996f,-0.05080003f,-1.02640001f,0.81869994f,2.73739993f,0.79700010f,0.03340004f,-3.29700005f,-1.16499992f,-0.78789999f,-1.24749999f,0.65479998f,1.16149992f,-0.71289991f,0.18780006f,1.50719998f,1.26930014f,-0.44560003f,0.46510011f,0.58730009f,-1.66880001f,0.81689998f,-1.15569988f,2.08440000f,2.66480000f,2.55040003f,-2.61109996f,0.23089997f,0.28870001f,0.19910002f,0.89429996f,0.98159996f,0.06979998f,0.95479996f,-1.17810003f,-0.46639990f,-0.93879991f,1.13100002f,3.10829994f,-0.57080002f,-1.39030003f,-1.34619993f,-2.56040008f,-3.69819993f,-3.18190002f,0.44029998f,2.33409994f,-0.99200002f,-1.18070002f,-1.51189998f,-3.09609993f,-0.92980002f,1.63579995f,-0.62240002f,-0.23900003f,-5.27650001f,-0.87430001f,2.80550000f,2.24599992f,-0.34069999f,1.68679994f,0.40080000f,0.80359998f,-4.03900006f,2.75960014f,-4.23520005f,0.73809991f,-0.30200005f,-0.29809997f,-3.62700007f,1.33300000f,3.76450002f,-3.05540005f,1.09150000f,0.62319987f,-2.38510001f,-2.46250007f,-1.04030002f,1.99740004f,-0.87980003f,-0.01830006f,0.86160001f,2.71059996f,-1.17239999f,0.51640005f,3.11090001f,-0.29210005f,-0.36429998f,2.15520004f,1.75820000f,-2.77369992f,-2.54350009f,3.93490006f,-1.80039996f,-1.42489995f,0.20889998f,1.24070004f,4.54039990f,1.25580001f,-0.17490006f,-0.56740002f,-3.55139996f,3.06249992f,-0.65540008f,0.62060004f,0.00269992f,0.14200001f,-1.30999994f,-0.70220001f,4.18809995f,-0.32509999f,-1.85929993f,-2.23519993f,3.60110003f,-1.23449987f,1.03349989f,-1.22050002f,0.63080009f,-3.97099999f,0.30150002f,2.83380004f,-0.44599990f,2.59159993f,-0.52440003f,1.32930005f,0.19730005f,0.01059999f,0.18699997f,2.66180002f,0.40199991f,-3.05990005f,-2.03999994f,-1.65079996f,-1.67439999f,2.29450003f,-0.28420002f,1.73830000f,2.90000004f,-1.72860001f,-2.18300006f,2.30039995f,-0.80159994f,-2.80550002f,-0.65170004f,0.70610005f,1.76580004f,-0.09549996f,-1.07019992f,2.18780005f,0.34939996f,1.10559996f,-1.85049991f,3.80589996f,1.46619998f,-0.77999997f,1.68579998f,-1.52420009f,-0.28560006f,-0.39269984f,-0.73630004f,1.07459997f,1.02290000f,-0.06840006f,-0.25310002f,-1.60700005f,1.11210002f,1.75140001f,1.14560000f,-0.06540001f,2.16859993f,-1.09780000f,-0.68370009f,2.13470002f,2.60090005f,0.46560005f,0.38519999f,4.00309986f,-0.77949991f,0.17420006f,1.50010004f,-0.83019993f,0.56589989f,0.15739998f,1.19740007f,-4.32610007f,-2.67590001f,0.41880005f,-1.68689996f,0.82170005f,0.90470007f,-3.59870011f,-0.26029996f,1.54579994f,-3.63800004f,-2.89979995f,-1.76789994f,0.60340003f,0.86870007f,1.14029991f,-0.75340000f,0.66080004f,-0.20080002f,1.16740011f,3.57960000f,-0.45620003f,1.46079992f,-2.25180011f,2.51919993f,-4.28490003f,2.04650005f,-3.58439989f,-3.72509994f,1.15380001f,-3.46079994f,-1.61179991f,3.09839993f,-0.01180001f,1.46570004f,2.63440000f,-1.30029999f,2.43580004f,-1.14410006f,-0.07250007f,4.41109993f,3.35129998f,2.89309983f,-0.10569995f,-0.22650003f,3.56889985f,-0.22690013f,0.74540002f,2.62410005f,-4.91189998f,0.58000008f,0.20529997f,-0.12869993f,0.36709995f,-1.76529985f,2.63560001f,2.39969997f,0.99560000f,0.44849998f,0.93280001f,-1.75799996f,0.12270002f,0.62610011f,-0.55220007f,1.79320008f,0.75680005f,-1.94129993f,2.62630001f,5.49310008f,-0.70399992f,-1.26070000f,3.12660002f,-2.23879991f,0.82149994f,-0.02350005f,0.33289996f,-0.31479995f,4.84129989f,-3.00010004f,1.47599994f,-4.92790002f,-0.98420008f,6.03829996f,0.53300003f,2.96429993f,-1.28639993f,-1.34959995f,-1.43520011f,1.13549996f,-1.38509990f,2.48650000f,2.34160005f,-1.12709991f,-2.48569992f,-0.96949991f,-0.27630001f,-2.42570004f,-2.36130001f,-0.95929998f,3.60540003f,-1.33120002f,-3.87590000f,-3.42069992f,-0.58910009f,-2.26149996f,-0.88100002f,0.51490007f,-0.06699983f,1.78560002f,1.78050001f,1.45130010f,-2.00999993f,-1.76589999f,0.89549991f,-1.77890007f,-0.75990000f,0.05700000f,-3.17890007f,0.58840002f,0.50939998f,0.75109999f,1.84480007f,1.85999992f,2.00050007f,3.22239999f,-0.07230003f,0.08010006f,-1.03059999f,1.59219996f,-0.16210013f,-1.61190008f,1.50949994f,3.22719983f,-0.90880001f,4.40829998f,-1.12139983f,-0.02239998f,-2.16790011f,1.35740006f,1.33010001f,-1.12559999f,-3.03290002f,0.58359995f,-1.92720007f,0.04480002f,2.62109995f,-0.55599994f,-1.31459995f,-0.11099999f,0.78540006f,0.10419999f,1.44809995f,3.65509990f,0.31669984f,-0.24769996f,0.10909991f,-2.44970000f,0.55190005f,-1.30729991f,-1.49349997f,3.37160013f,1.30189998f,1.92300008f,0.34000001f,1.30989994f,1.78519990f,1.06049998f,-3.58320015f,-3.91559994f,-0.78210006f,2.90519995f,0.39619999f,-0.80990000f,-0.27740005f,1.58590005f,4.03329989f,0.92789993f,-2.30619998f,-1.68720003f,1.18129991f,-0.63179999f,-3.95959998f,2.04300000f,3.16339992f,0.38240000f,2.90300007f,1.10720009f,2.69849993f,0.79420012f,3.28419999f,-2.08039990f,-1.60549996f,0.69199983f,-0.68920005f,-3.20490002f,2.24490001f,3.15959993f,-2.01130008f,-4.26539997f,-0.25999993f,-1.05370007f,3.00739999f,4.75870011f,-3.46130012f,-0.21049996f,-2.38390006f,5.38389994f,-2.30569995f,1.06369985f,0.67120002f,-4.40509990f,0.70470008f,2.93260009f,0.69229997f,3.54909998f,2.31830015f,-3.65640007f,0.80290003f,2.88619997f,-0.78230001f,-1.83099992f,1.74049997f,0.10849996f,-5.23239997f,-2.23159998f,3.07430002f,-1.69109987f,0.34719994f,2.27940003f,-2.95399999f,1.98719996f,1.56869995f,0.63090001f,0.85019984f,2.54650005f,-1.45630004f,0.51059995f,-1.47769996f,-1.33100011f,-2.56400008f,-0.04929994f,1.40680002f,-0.65279989f,3.59330001f,4.25910000f,-3.82069995f,1.26019995f,1.14999981f,2.25399997f,1.42590009f,-4.71509987f,-2.61129995f,-3.36359991f,-0.91040003f,3.01450003f,-2.56790002f,3.03830010f,1.17690001f,-0.95849999f,0.66179993f,0.36869999f,-3.26839994f,0.27170016f,-1.41639996f,-1.50890004f,0.78509996f,-2.02319998f,-0.67639999f,-2.27390000f,2.47619987f,1.72729997f,-1.43749986f,0.15880001f,0.99969981f,-0.07640002f,-1.33110005f,2.57850006f,-0.63790010f,-2.43250003f,-1.17530001f,2.05180003f,-0.00730007f,2.12680008f,3.58479995f,2.73550003f,-0.30870008f,3.39049984f,-3.69049999f,3.54679986f,-2.44590002f,-1.36110001f,-1.64809994f,-3.84730000f,-0.30559990f,-0.56239999f,0.08999996f,0.84100000f,-1.18529997f,1.11039989f,2.14159997f,-2.20330001f,-1.18400004f,-1.43919993f,0.02519994f,-0.78760005f,-3.72769998f,-2.24779986f,1.73160000f,1.06939993f,-2.63760009f,-0.62770001f,0.76939985f,0.92239998f,-4.44119996f,-3.71780008f,-0.37279991f,1.21790005f,-0.43939992f,-0.08660005f,-1.60600003f,1.57920003f,1.35559993f,0.21939988f,-0.23460007f,1.41460007f,-1.02150010f,-3.88159995f,-3.81869998f,1.08599984f,-2.54830004f,0.42150009f,-4.52510007f,-0.06109995f,1.94349993f,-1.39099999f,0.69110011f,-1.41289997f,-0.86620000f,-0.98380008f,0.36019988f,-0.83210007f,-1.70399993f,3.13969997f,-1.58989993f,-0.27840008f,1.17300001f,-3.03719997f,-4.59200004f,-3.63050000f,0.34530004f,1.86959996f,-1.78730006f,-2.76600008f,-1.73329997f,1.23289992f,3.18199991f,-0.69879994f,-4.98910012f,4.09910000f,-2.09090005f,1.13590000f,-0.00320000f,2.77369996f,-0.03800006f,1.30879994f,2.07690006f,1.38150002f,-0.34920001f,-0.31899992f,1.04699999f,-0.69990005f,1.61740002f,0.33120000f,1.81409996f,-1.09089998f,2.13159995f,1.32800006f,-1.91339998f,-1.83489995f,-2.76329997f,-1.90600004f,-1.54400005f,-1.32439993f,-0.20989995f,2.27460005f,-3.74540012f,-0.29719994f,-0.64779998f,1.99410005f,3.55079999f,1.17739996f,0.48060008f,-0.45260007f,2.34619995f,-2.29319997f,-2.26840008f,3.55840002f,0.20260009f,-1.61479995f,-0.51469996f,1.11130005f,-1.74749993f,-0.65409997f,2.66910003f,1.55340004f,-1.33870005f,-0.75950003f,-0.70419994f,-0.78720019f,-1.08119989f,-1.75609999f,2.38439991f,0.62859996f,0.68260001f,-3.24290005f,0.49410000f,-1.41889997f,-3.16239997f,4.39530012f,0.72620006f,-0.70009995f,0.24799995f,2.27699986f,-3.50730006f,-0.47149995f,-4.64589999f,2.14239997f,-0.44969993f,-0.05499997f,1.41160005f,2.33650008f,-2.35439999f,-1.41100001f,0.08810007f,-3.00399993f,-0.18709993f,-3.44129993f,1.09460000f,-1.19269997f,1.13119998f,0.45579986f,-3.95420009f,1.00640003f,1.40830003f,1.64700002f,-1.55989995f,1.12129999f,-2.65830009f,-3.08510003f,-2.19010001f,0.58580012f,1.58109994f,1.61159998f,-0.89100006f,-2.02979996f,-2.04750004f,-1.31169996f,1.75540012f,0.68909998f,2.20659996f,5.14719998f,3.27049992f,0.71580005f,0.84010000f,0.76219993f,0.00939996f,-3.61080007f,1.15339995f,-1.38849987f,-0.96280001f,1.22170015f,1.98729998f,2.19990004f,2.81829993f,0.22720001f,-2.26619994f,-1.31199998f,0.14059990f,-0.81359998f,-5.34240004f,0.99499992f,-3.63149996f,1.69649990f,-1.61730001f,1.34750003f,0.21440007f,-1.90680010f,0.58850000f,-1.60169999f,0.09920010f,0.49129992f,-1.39420000f,-3.54120000f,2.57530000f,3.75260009f,1.90659992f,1.04179989f,1.61800004f,0.47769997f,-0.53269996f,0.76920001f,0.86309991f,0.75869993f,-0.47260004f,-0.64570004f,1.15799997f,-1.95560000f,3.37590001f,3.52879996f,1.93419993f,1.02440003f,-0.07889992f,-2.17680004f,3.45920002f,1.71119995f,-0.50269993f,-1.22340006f,0.52249994f,2.12790002f,-2.43919989f,0.99289998f,0.52299990f,2.13830007f,-0.30360006f,-0.27589998f,-1.88790003f,1.08399996f,-4.30030003f,-2.86040001f,-1.08490002f,-3.21490006f,-0.98129993f,-1.11179998f,-2.33270007f,-2.89019998f,0.84269997f,-0.69500003f,0.10879995f,1.59200005f,0.70229993f,-1.64149998f,-0.81599994f,0.04610026f,-1.19430004f,1.72129995f,-0.50860000f,-0.73549994f,0.23839992f,0.41910007f,-1.16710004f,-4.36969997f,-0.41139979f,-2.41639997f,3.08159999f,1.02779988f,-2.22139991f,-3.17260006f,-1.60010008f,0.36099998f,2.77609997f,-0.71989995f,0.15199993f,1.13999988f,-3.37669998f,-2.86589993f,-1.16240003f,2.57529999f,0.37100004f,1.22919999f,-2.37850005f,0.59959998f,-2.27470001f,0.58329995f,-0.71450002f,-2.46869988f,-0.00710002f,-1.38380000f,2.46220012f,0.80530010f,-0.49119991f,-0.61089993f,1.89710004f,2.30759998f,0.67079996f,-0.81440000f,-2.40940001f,-0.57210010f,-1.76329991f,-3.01590004f,-0.59019997f,-0.60450001f,-0.67119999f,-0.88439991f,1.19540011f,3.25979987f,2.81069992f,0.89350004f,-3.04830009f,4.50430001f,-2.61380003f,-1.28839996f,2.35990007f,1.78150000f,1.65019992f,-3.17720002f,0.38690006f,1.27260004f,3.19829997f,0.78690000f,-0.98180010f,0.50180006f,-0.32850001f,-0.39920000f,0.53999995f,0.28520010f,1.48270004f,1.14029996f,-1.26229996f,1.51340002f,-1.92880005f,0.94439998f,-2.94390004f,-3.19849995f,-0.84050006f,-1.45349998f,1.27549986f,1.81559994f,-0.81970000f,-1.25510014f,1.87109994f,4.17559998f,1.01100002f,-1.43920000f,2.35620001f,-0.03399994f,-0.79879997f,2.21810002f,2.44329999f,0.81050004f,0.81400003f,4.79039998f,1.37880002f,-2.61350001f,1.29409998f,1.24600002f,-3.71120002f,1.20529995f,-1.19600001f,-1.90779996f,-3.23910012f,-2.05840003f,2.41210002f,1.70390009f,1.45390010f,1.00330000f,-0.61589992f,-0.12229994f,0.74569994f,-0.07839997f,-4.22850005f,-0.26300004f,3.23509995f,1.09299989f,-0.89260001f,1.09069997f,0.43679996f,2.85120002f,-0.05499990f,2.24679994f,-0.11109996f,-3.13930002f,0.80749999f,-3.52529992f,1.90900006f,0.37710006f,-0.50680001f,0.13899996f,0.42420004f,2.16620001f,2.38469993f,-2.93539998f,0.94930006f,0.73739993f,0.45029994f,-1.16349993f,-2.11760009f,-0.68510000f,-0.86540003f,5.13140005f,3.98289995f,-0.28009996f,-2.90000002f,2.29740008f,1.18600005f,1.98040002f,1.91050001f,-0.23420007f,1.68670001f,-1.31470003f,5.31760011f,-2.46610001f,2.50260001f,1.70469996f,0.34890001f,0.76720000f,-4.09429999f,0.00390000f,2.66129996f,1.65040004f,-0.90809994f,0.54860005f,1.97790011f,-1.52849996f,-3.01429996f,-2.20980008f,2.65319999f,2.96499996f,-2.28770001f,-2.05390000f,-0.44589998f,0.82969995f,-0.83430004f,1.57190004f,0.36629995f,0.69150001f,-1.24789997f,-1.48440000f,-1.95709999f,3.90549999f,-1.30359999f,1.03289999f,0.74449997f,-0.36120002f,2.01719996f,0.43610001f,0.02560007f,3.22590001f,1.25510006f,2.02419993f,0.51820000f,3.07839996f,-2.18010004f,2.94389995f,2.53350003f,1.27749996f,1.07390006f,1.31120004f,2.80589995f,-1.89669998f,1.20219988f,-1.55960002f,0.72739998f,1.81900001f,2.59069999f,1.14719998f,-1.80599997f,1.18059991f,-1.09560003f,-2.89729995f,-1.45380005f,-1.67230000f,-3.50540005f,-1.14130006f,2.54049999f,-1.17379999f,-5.36839989f,-0.07439989f,0.30149997f,0.09860001f,-5.33790001f,-0.40140002f,-1.94590002f,0.73070002f,1.10489999f,-2.89020013f,-0.28899992f,-0.70680005f,3.95510006f,2.71450000f,1.37459991f,-3.41540001f,-2.62130006f,-2.22550005f,0.81270003f,1.96699997f,3.48579997f,-1.66000002f,-3.91379991f,0.41010010f,0.75849995f,-3.33940014f,-2.78019996f,1.62599995f,-0.69200008f,0.90670007f,0.53900005f,-0.61950007f,0.44400003f,0.13649994f,-3.85499989f,-0.05480008f,0.91549996f,-2.04259996f,-0.19279993f,-2.40040000f,0.68590008f,1.36789999f,-0.03760000f,-0.46390001f,-1.40539999f,0.02389995f,2.39710009f,-0.37099998f,1.50630002f,0.73469993f,-0.82460000f,2.48730001f,0.54850001f,1.14389995f,1.45350004f,-0.98210001f,2.07269995f,1.06539999f,-3.67669982f,-1.32680000f,0.05910004f,-0.14940003f,-1.24780005f,-5.48970004f,-1.10769995f,0.30670012f,-3.63800000f,3.00370003f,-3.09190008f,-2.48409991f,-1.11669993f,-0.99980003f,0.14639999f,1.16070004f,1.53479999f,0.51919999f,-0.23279994f,-3.70450000f,-0.92160014f,2.93820004f,0.35500001f,-1.47520002f,2.11029998f,-1.00610001f,-1.58050008f,3.12020003f,0.44529996f,2.48790006f,2.14160001f,-3.17919995f,1.10070004f,2.27669992f,-1.09779997f,-0.38889998f,-2.39879994f,3.13509994f,0.81690013f,-0.75180002f,-2.01600004f,-0.24310010f,0.96250001f,-5.24460000f,-0.37150000f,0.63920005f,-2.20360000f,0.76599989f,-4.56210001f,-0.69379995f,-0.54850004f,-0.24770003f,-1.13740008f,-3.66169999f,0.61680001f,-3.00039995f,-2.62979995f,-1.09160002f,-1.80350005f,1.36840007f,-2.20610002f,-0.92439990f,1.65189998f,-0.21550007f,-0.84569996f,-2.21589995f,-0.48599996f,0.28089990f,1.03039999f,2.32740008f,2.78820002f,4.15920003f,0.60350002f,0.87019994f,0.51160006f,5.57570005f,2.18890011f,3.62249997f,1.43739996f,0.84410005f,-2.41590001f,-0.69830009f,-1.64279994f,0.87970002f,2.60769998f,0.24819988f,1.01250004f,0.50420006f,-4.08550018f,-5.01849988f,0.37459995f,-0.27620002f,4.53930004f,-2.34010000f,-1.49009990f,2.11830006f,2.02540002f,-1.96420004f,-2.21050007f,-1.22390001f,1.75989988f,-0.25159993f,-2.96169995f,-2.76799998f,-0.77179993f,0.12729998f,1.50770002f,1.24220001f,-2.98470006f,-1.44979995f,-1.27810006f,-1.13470008f,0.23420009f,-0.95699994f,1.56500009f,2.73239988f,-0.08700005f,1.05510002f,-0.74189998f,-0.37190002f,-3.46570004f,0.91220001f,-0.53830001f,-1.12290006f,-2.68879989f,0.65280000f,-4.16630001f,0.96889998f,0.16069991f,2.23599999f,-2.00169992f,-1.10489996f,-1.48090003f,-4.07470003f,-0.05260004f,-0.99130000f,1.12379998f,1.53500008f,-0.42999996f,0.58980003f,-1.00839995f,-2.92129999f,0.71150005f,-0.02049996f,2.32260004f,1.13169997f,-1.33330006f,-0.35340003f,1.78669999f,1.33549993f,-2.71930000f,0.65720013f,0.58189995f,1.81079999f,-0.79319999f,-0.04480004f,-1.18429997f,0.75079994f,-2.53650005f,1.98750005f,1.27990000f,0.34189996f,-0.32920003f,2.62680010f,-0.36570001f,-1.47010002f,1.74200000f,-0.71570010f,-1.25000007f,2.88669994f,-4.33660009f,-1.20380001f,0.36909995f,-1.32489991f,-0.71070002f,-4.39819995f,2.96560001f,-0.16710003f,4.20140004f,-3.86809996f,-0.70570007f,3.54619998f,2.64049995f,-1.75780010f,-0.91470004f,-1.28179999f,0.72979991f,-0.98300003f,0.77169987f,-0.41209987f,0.46299995f,-0.38290004f,1.48830006f,0.07869999f,-0.69560008f,-1.16630002f,-2.12409999f,0.90899993f,-1.87219995f,0.96730009f,1.85850008f,2.39709994f,-3.43640005f,-0.42590003f,0.88440005f,-2.39400001f,-0.29759993f,-3.55650005f,-0.11160011f,1.29939990f,-1.04000008f,0.52700008f,-2.46100003f,-0.94219996f,1.45170012f,3.33569999f,-2.10069996f,-0.54619997f,4.70549999f,4.20469997f,-1.37979990f,-1.44720006f,0.22959992f,-0.53229994f,-0.24810002f,1.95869997f,-0.08590003f,3.95839998f,-2.87550001f,-0.93240000f,0.72450005f,1.01159999f,1.49250003f,-3.07459996f,2.09299998f,2.54800003f,-0.71509999f,1.17920001f,-0.84119994f,1.55389996f,2.38160005f,0.14279999f,-1.66549999f,-4.18639999f,-2.09900003f,-1.21000007f,-2.96309997f,0.56059999f,0.62569996f,0.39770002f,-3.18709995f,-0.84609997f,1.68459999f,-2.33870000f,-3.30079998f,-0.06970004f,-0.51070001f,-1.83169988f,2.71610005f,-1.71670003f,1.40899995f,0.81900004f,-0.30870005f,1.36840003f,-0.25440001f,-2.74780002f,-0.53739998f,1.14729993f,5.08249992f,-4.20800001f,-0.09129987f,-0.99269991f,-2.10120001f,-3.83829997f,0.08799999f,0.07970003f,0.19549997f,0.24510001f,-0.56499996f,-1.27540001f,-0.96439998f,0.71820002f,-0.56230000f,0.42710002f,3.52950001f,0.94059997f,1.55570001f,-0.34439991f,0.35530001f,-0.61300003f,-3.59620004f,-2.29480006f,-1.13899993f,-1.58319997f,-1.03549989f,-0.59770000f,3.47839991f,-0.28689998f,-0.81149993f,-2.73710001f,0.35679999f,-0.69129988f,0.98580002f,-1.52679999f,-2.50619989f,-1.14319997f,-2.60489987f,3.58930001f,-2.38359997f,-0.12349992f,0.35090002f,3.35910011f,3.73799995f,0.89029995f,-0.80249997f,0.96929994f,2.26309998f,0.06339993f,1.05540000f,-1.42859998f,5.18179997f,0.22609995f,0.94129996f,-2.44419996f,-0.04720005f,3.11830007f,3.12150002f,-0.66230002f,-4.01469995f,0.04770004f,2.43919995f,-0.02670001f,-0.09550002f,2.40839995f,-0.81849997f,-0.33599992f,1.15390005f,2.82769999f,-1.64349999f,1.65510000f,-3.14780012f,-0.21809998f,-1.09569996f,-1.07419996f,0.51110005f,1.23290007f,2.04839994f,-0.05669995f,-0.90280001f,1.58440001f,2.04759991f,1.18839999f,-0.72020005f,1.62710000f,-1.06440009f,-0.81509992f,1.40840007f,1.54050009f,-2.31079995f,3.69809995f,0.39930004f,-3.91649993f,-2.39850000f,1.92569994f,1.10909995f,-1.27720007f,0.23819994f,-0.76269998f,-2.70250000f,-0.65289983f,4.78850000f,0.68389994f,1.55919996f,-0.03670003f,-1.02479995f,-0.48509996f,0.11410003f,2.25770002f,0.94630005f,0.82460011f,1.56540004f,-0.16370006f,-0.70639998f,-2.77609992f,2.55760003f,-1.09929998f,1.15320004f,0.32080003f,1.67510002f,2.68509994f,0.32149995f,4.09660003f,0.02510006f,1.11540004f,-2.25319997f,1.54199996f,1.37899995f,0.04789994f,0.32929998f,0.80729996f,0.86329994f,1.65780003f,-1.41370001f,1.04079989f,0.79160001f,-4.71030004f,-2.45830004f,-0.85150000f,2.08550000f,1.60450002f,0.24559994f,-1.48750005f,-2.41570000f,-0.46870008f,0.51789998f,-0.48450005f,2.21999991f,-0.79929998f,0.87050000f,-0.56700003f,-1.97130003f,1.85630003f,0.01960002f,-1.17780005f,1.16890007f,-0.15369995f,-0.35590005f,-0.70929996f,1.99550000f,2.16270000f,3.08999996f,1.11610006f,-2.29459996f,0.07200000f,-1.82740001f,3.32189993f,0.22459997f,0.10130003f,-0.70490006f,0.39249999f,0.36859999f,0.96520004f,2.65399997f,0.08390002f,2.15210000f,0.44760004f,0.47450003f,1.25900004f,-0.11680000f,0.64179998f,-0.77140001f,-2.20429989f,-1.18269997f,-0.09880003f,-1.06670007f,-3.29849996f,0.55710006f,1.61100001f,1.26109997f,0.73159996f,-1.55589995f,-0.32660001f,-2.05019996f,3.33210001f,-2.45940001f,2.32779987f,1.77359994f,0.17359995f,-1.81730002f,-3.21449999f,0.62219997f,-0.91799997f,0.50429996f,-1.71980001f,-0.80760008f,3.52740005f,1.68030010f,0.82160008f,-0.13520005f,-1.77210002f,-1.90980003f,1.91190005f,0.96820004f,-0.37359996f,-0.17470000f,-1.68819993f,-0.04100010f,1.62619990f,-0.27110002f,-1.17160002f,-0.22800002f,-1.10189995f,-1.00679998f,-2.67769993f,0.32260009f,-1.33759999f,1.07170002f,1.65850008f,2.30869998f,-1.69100000f,-0.91529997f,-2.06379994f,-0.03340001f,-1.82259992f,-2.11509999f,-1.57860001f,0.60190002f,-1.06280005f,-0.16380001f,1.96930002f,0.59470004f,1.41699997f,0.68869998f,-0.09559986f,-0.52369991f,1.26289992f,3.34110000f,-0.30600007f,-0.54110001f,-0.92130005f,-2.88690002f,-2.16959996f,-1.76799990f,2.78920000f,-0.60259992f,-5.40570018f,1.61719997f,-0.67959992f,-0.97560012f,-3.32110003f,1.79679996f,-2.81190002f,-1.27269997f,1.38450007f,-1.71120003f,-1.08449997f,0.03720007f,-2.39559997f,0.91459991f,2.02829997f,-1.67320000f,-1.44939994f,2.82550005f,0.76689987f,3.12099991f,-4.48700012f,1.42569993f,-0.87880004f,2.02689988f,-0.43930010f,-1.41280002f,-0.51679998f,-0.35080010f,0.87700004f,-6.71280005f,-2.47939999f,0.69099999f,1.13250007f,1.30629997f,0.28379994f,-0.61950013f,-1.35740001f,3.96029996f,-0.00070000f,3.90669998f,3.35959993f,-0.95439998f,0.66890001f,-2.19699998f,-0.50759990f,0.77049989f,-0.97179986f,1.71209992f,0.07800001f,-0.37239981f,-3.15460001f,-1.64230002f,-1.22490001f,3.28749992f,2.48560001f,3.55559995f,0.02420004f,0.74739988f,0.04330004f,0.29390008f,-1.27679998f,2.20699993f,-0.03530016f,0.02040006f,-1.05069998f,2.77589999f,-0.57279997f,0.34989990f,3.21340000f,2.75250009f,4.67329994f,-6.23220000f,1.25430014f,-0.01629995f,0.73270000f,-1.47510010f,3.11469986f,1.63979997f,0.97939991f,-1.67450001f,1.30089988f,-1.40370000f,1.81039996f,-1.73140002f,0.62380001f,-1.47509999f,1.56379993f,1.41759996f,3.31930001f,-1.04299997f,0.34890004f,0.16440006f,0.40729995f,-1.47340002f,1.42190015f,-2.27700000f,-1.62489992f,2.13149994f,-1.10100008f,-4.83549997f,-1.57570003f,0.34349998f,4.50339996f,1.04899990f,1.29889985f,2.00429998f,-3.91229985f,-3.01699988f,0.56989999f,-2.33080006f,0.73199996f,1.02990010f,2.88949996f,-3.42640003f,4.06399991f,-1.06240010f,2.07770001f,-0.67640000f,-2.58060012f,-0.90830006f,4.50299994f,-0.48739998f,-1.17330010f,-5.78299999f,-2.27849997f,0.39430000f,-2.89180000f,0.38500003f,-3.15240000f,1.84860002f,0.04700008f,-2.19929992f,-0.13449993f,0.84199992f,-1.38269997f,-2.10969993f,-0.57290004f,0.91919992f,2.24879998f,1.89579984f,2.63249992f,0.96580012f,-0.08990014f,-0.73320006f,2.18740002f,1.15620000f,-0.94549988f,0.73540000f,-1.96190005f,0.83469998f,2.12130001f,-1.74450013f,1.76010016f,0.84059997f,2.68550004f,2.39890007f,-1.36409999f,-0.88600002f,0.63919997f,0.42180006f,-0.74909996f,-3.36840001f,-1.09799999f,1.19419993f,0.51349990f,3.80480009f,0.80189995f,0.45340003f,-0.81200002f,-1.43870004f,-0.74399998f,0.55349998f,-2.21009997f,-1.32519997f,2.08640004f,-2.61880001f,-2.54400002f,0.36930006f,0.10779994f,0.72709995f,0.20599996f,0.47169995f,-2.97429992f,-0.26530006f,0.41180000f,-2.60900008f,-0.90579990f,-0.83779997f,2.84200011f,1.99920003f,-1.20720005f,0.04890000f,2.84500001f,-1.23180005f,1.24279993f,1.52990011f,1.87400009f,-1.24779999f,1.02820001f,1.15240002f,-4.84539994f,0.56119997f,-1.18359998f,-0.62289995f,-2.62779991f,-1.79729997f,4.03629996f,0.09410014f,-0.08199999f,0.26030002f,0.45840006f,1.74330004f,-1.26770003f,-1.72020002f,-2.19820009f,-0.41040000f,1.76490000f,-0.90539995f,2.04319995f,1.37209997f,1.13430001f,1.23010004f,3.37929989f,1.55199998f,0.42250005f,0.90260004f,-0.64440001f,-1.08839998f,1.02019989f,1.56000009f,1.12430007f,4.47180000f,1.13099989f,3.64199999f,-0.94519995f,-4.53640000f,-0.78510000f,-0.73420009f,3.34370005f,-0.48649994f,-2.01490002f,-4.42040003f,-1.29850003f,2.42650010f,-0.81039997f,-0.57679999f,-1.87780002f,0.50380015f,2.63769992f,-1.17109990f,-0.57410008f,0.03450001f,-1.46900009f,-0.80620010f,1.99299996f,-0.18439990f,-0.69820006f,-1.32460003f,-0.40289992f,0.91100000f,3.02730008f,4.08959997f,1.26769996f,-0.15759999f,1.23129989f,-1.63909996f,0.35269988f,-0.02909994f,0.73890000f,-1.13960001f,-0.97700002f,0.03530006f,1.03110000f,1.76330010f,-1.81360011f,1.86750001f,-0.85209996f,-1.92129996f,2.42390006f,-2.46240006f,-0.38809996f,3.82250000f,-1.79570008f,0.08339988f,-0.01479993f,0.36879995f,-1.85849999f,-4.68609999f,-5.97959996f,1.85430000f,0.40830005f,-3.66960001f,-1.39909998f,2.43110010f,-1.85160006f,-1.75630001f,1.71839993f,-0.91839992f,0.55200003f,0.60250000f,-2.09840004f,0.82730009f,2.40170003f,0.59670004f,1.15120006f,-0.72449994f,0.09299997f,0.55530007f,0.27820009f,1.46489995f,3.38019991f,0.71489987f,-0.28389991f,1.91739996f,-0.84680010f,-0.34659999f,-0.15800003f,-0.99219997f,0.41939994f,-0.41019991f,1.00500002f,0.79910003f,2.11130014f,-2.13950000f,1.73210000f,1.56770001f,3.77300005f,0.85080012f,0.97689992f,0.41169996f,-1.85799991f,2.79889993f,1.43349993f,-2.51240002f,2.16210001f,-0.98150003f,-0.73120004f,-1.03649997f,0.44710002f,-0.21160007f,-0.91819989f,2.29989997f,-2.50560010f,2.57929986f,-1.08640004f,1.16290002f,3.31569991f,3.05289999f,-0.79080003f,-3.25810007f,-0.56079994f,2.31429997f,-2.46200010f,1.64640003f,-1.65830000f,-4.14530003f,-1.78420003f,-0.82920001f,-1.25019992f,-3.49439999f,0.00540002f,1.79130003f,1.70520000f,3.06229997f,1.18369998f,0.65759987f,0.68330003f,-0.33510010f,-1.70859998f,1.03200000f,0.23000007f,-1.12620005f,0.60059997f,0.69279997f,0.08299999f,3.04949997f,1.12580001f,-0.90869996f,0.48890003f,1.90730007f,-0.65100004f,3.65350001f,2.27530003f,0.75340004f,0.24449992f,-0.99180000f,-0.06350004f,-0.18020006f,-0.10889998f,-1.11070001f,-0.01360009f,1.29119999f,-0.73489991f,-1.83640002f,-0.74049999f,-1.35630000f,1.04030000f,3.61709995f,0.34360009f,0.38840000f,0.49739992f,1.58899998f,-4.41289990f,-0.71689999f,2.73270003f,1.08030009f,-0.14610002f,-2.75520006f,4.37099996f,-2.15149987f,0.78580002f,-0.03840001f,-0.82100001f,1.03200007f,0.54660004f,-2.01099997f,-1.36840001f,0.92109989f,2.97429996f,-1.25370002f,-3.93010002f,-2.25060015f,1.65620007f,-0.03549986f,3.35940004f,2.13769994f,-2.10200000f,-1.10270009f,-2.15730003f,-0.16600004f,0.83539995f,2.44869997f,-2.41920005f,1.49060001f,0.26610000f,-0.19279993f,-0.68750005f,-2.64930003f,-2.54519989f,-2.95019991f,0.07990005f,3.41209995f,-2.49950008f,0.78920001f,-1.66870004f,-1.53110008f,0.07780007f,3.77529999f,4.02500004f,1.66559997f,0.46130006f,-1.64780006f,-4.99329996f,-0.27550004f,-0.26310008f,1.13239998f,2.05740008f,-0.45499999f,0.53580002f,0.45370002f,-1.14540003f,-1.59829985f,-1.07940000f,-3.26270002f,-2.44320004f,-0.16390000f,-1.46420001f,-0.14619994f,-0.27520005f,1.35449999f,1.53970004f,0.93379999f,-2.65699999f,-2.02050002f,-1.57320013f,-1.39999995f,-0.22960003f,-1.24139993f,0.75450001f,-1.96449997f,2.49219998f,-0.85049996f,1.41939995f,0.95760007f,1.67989997f,2.70029993f,-0.21579996f,-0.88480002f,1.36150002f,2.76930006f,3.46829994f,1.66339999f,-0.91609997f,-0.56639998f,4.51949993f,-1.00699988f,1.97119990f,-4.24210008f,0.24079995f,-2.63600010f,0.33339999f,2.02249987f,1.35479998f,-1.17169997f,-2.07449999f,1.14569990f,0.14529998f,0.48980003f,-0.22639998f,-0.52379992f,0.40510002f,-2.79610006f,-4.11860000f,-1.68500004f,2.48210002f,-0.36040003f,-1.56729992f,0.96970007f,-2.32599997f,1.46369999f,-2.56300000f,1.60759996f,-0.44859991f,-2.64199998f,-1.44269990f,-1.17419993f,3.84470009f,0.10540007f,-0.63679993f,0.71680009f,0.79939993f,2.22629998f,0.76040003f,0.79340001f,1.99680005f,-2.39880002f,-1.91080011f,0.52610006f,1.22560002f,-0.08909998f,2.19239992f,-2.50980001f,-1.39229999f,-2.06089994f,-0.06409991f,1.49020000f,0.34890002f,1.38610005f,2.20089996f,-0.13870000f,-2.97200001f,1.36629994f,0.29789989f,-4.64000007f,-0.85920002f,3.89420000f,-0.01399998f,-0.45140005f,-4.76510002f,0.89180001f,-2.61469996f,1.08920001f,0.70019992f,3.03129997f,-0.20509990f,2.18690006f,-3.22940003f,-0.37149998f,-2.90439989f,1.03520005f,1.75089991f,-0.68010007f,1.57630006f,-1.82270008f,-1.15080002f,-2.22069998f,0.24489993f,-2.97280005f,2.14000001f,-4.10900005f,-2.81210002f,0.27120002f,1.67410003f,-2.71129993f,0.94060002f,0.76279998f,4.43809993f,-1.78019992f,-1.09010008f,-3.45210003f,3.62550016f,0.66200001f,-0.62109998f,-0.29900003f,0.29330009f,2.86190008f,5.75459997f,-0.02570004f,-0.89090001f,3.16640002f,0.02609988f,-0.27920001f,-0.50320005f,4.41280005f,-0.32710001f,-2.01929993f,-3.30170003f,2.59770000f,-0.33600004f,1.69469998f,-1.43849997f,1.99730005f,0.51929999f,-1.79370005f,-0.85300004f,1.37620000f,2.33470010f,-0.47499994f,-3.09810004f,0.16920000f,-1.48629997f,1.61649998f,-1.51489991f,-0.43050002f,2.57909990f,3.04680001f,-1.22670001f,-1.59570004f,0.20609999f,2.78900010f,-0.34359996f,-1.27630009f,-1.19230004f,0.66660002f,-0.16190006f,0.98529999f,-3.12500014f,-0.14800009f,1.59770004f,1.17559996f,0.31389995f,-0.00270004f,-1.31760005f,-1.94650003f,-0.09289996f,-0.89060002f,-0.52059992f,0.90729998f,-0.11310004f,-3.03509994f,2.49169996f,0.47710010f,-2.17179997f,-0.09510010f,1.82709997f,-1.28959994f,2.56189986f,2.27239997f,2.63069999f,0.35930000f,3.34180009f,-0.65210011f,4.13559998f,1.50820010f,-2.47329999f,-3.09690004f,-3.84840000f,-0.44569996f,1.04300010f,2.10350008f,1.86620007f,1.43720005f,-2.37920008f,2.34640002f,-0.60719998f,0.58349997f,1.59170000f,2.04400009f,2.09780002f,-1.03410013f,2.69210003f,0.07250002f,0.46090003f,-2.01050009f,1.03260002f,0.78789998f,-1.11869994f,-2.16390007f,0.47950000f,0.16490005f,-1.57660002f,0.63640005f,1.23300002f,1.76559994f,-2.09160004f,-0.43520004f,0.73670005f,5.76050008f,-0.42219991f,-1.21839998f,3.17370002f,-0.63840000f,-1.52859997f,-3.20110003f,-1.22879999f,2.26440001f,1.31789994f,-0.90239993f,3.31679995f,-0.79749990f,0.17520005f,0.16659991f,1.18539994f,1.77219992f,3.93710001f,1.36529998f,-0.95199993f,-0.57849999f,2.70860000f,-0.75910003f,2.63899998f,2.06820002f,-1.99619987f,-3.55460000f,-0.08930009f,-3.60599999f,2.54089998f,-1.54539992f,2.08929984f,-2.85960001f,0.52430003f,-0.42079998f,1.06170007f,-1.18380001f,-1.90260003f,3.80410005f,-0.28850003f,-1.86110003f,0.83129990f,0.28660006f,-1.75020006f,-0.52310000f,2.54349991f,2.14389995f,2.68170000f,-1.44259993f,0.58780006f,3.90950001f,0.90049994f,-0.31209993f,-1.36350001f,-0.86059999f,-1.66900003f,-1.06040004f,-2.64679992f,-0.04440005f,-0.97579993f,1.26940005f,-2.21700001f,-0.48569997f,3.21309988f,-0.96659988f,1.22190009f,0.67970013f,-1.99500004f,2.63249995f,0.56930003f,0.14469999f,0.80019994f,0.95960005f,-0.72349998f,-1.00890007f,3.42070000f,1.29919996f,-0.48129998f,-3.47770001f,-0.85110002f,-1.55050000f,-1.26929988f,0.39210002f,2.96150000f,0.34459991f,-1.53339999f,0.88759998f,-1.84120010f,1.35930001f,-3.32510009f,1.22679995f,-1.77180003f,-2.42170006f,-1.06209996f,-2.98639998f,1.05419992f,-4.30659990f,-2.12759995f,-3.32950001f,-0.26520004f,2.35190014f,-0.24879992f,-0.65079998f,-0.05579998f,0.18870016f,3.36579994f,1.44460006f,2.13250002f,1.20960003f,1.82629994f,3.20530001f,-1.35610003f,1.05430002f,0.82889994f,-1.30220008f,2.05740000f,-0.30289994f,3.63529994f,2.27919992f,1.49940003f,-0.81689999f,0.28940007f,-1.21760000f,3.22780000f,-1.69650000f,-0.85499992f,1.92669999f,-1.75870001f,1.15750002f,-0.36240009f,-3.70700002f,-1.80749992f,3.16059998f,-2.50750004f,-1.82060011f,-0.39799996f,-2.71570008f,5.06410003f,-2.51080003f,-2.30860004f,3.72220001f,-2.59639998f,-3.74839998f,-2.37670004f,1.97509994f,-2.23410006f,-2.01850005f,1.09709993f,-1.10399999f,-0.89809990f,5.80079994f,-1.46170006f,-0.46369997f,0.95200005f,3.36610001f,-0.20299996f,-0.90749994f,-0.09660006f,-1.20690005f,-0.74459998f,0.34849995f,-1.78180006f,1.01100008f,-1.90259994f,-1.90099992f,-2.65409998f,0.74289985f,2.61470000f,0.95500019f,0.94320007f,-0.07820008f,0.50350012f,0.36290002f,-1.54700004f,-1.19439994f,-2.22010004f,-0.18819998f,4.54129995f,3.68640004f,-0.65549993f,-4.17060007f,0.86389993f,-0.11370002f,0.60630001f,1.41789992f,0.45040001f,-1.08960002f,-1.23139996f,0.99119995f,-0.10519999f,3.42070000f,-3.03209998f,-0.76529996f,1.12459999f,1.95539992f,0.07310007f,-0.45520003f,0.87509987f,0.09129994f,-2.13290008f,-0.40180002f,0.39749998f,1.11430001f,-1.52269991f,-1.28570002f,-1.24210003f,-1.99170006f,0.67740000f,0.18140001f,-0.22189999f,-2.45260001f,-0.29709993f,1.90499999f,5.07820005f,2.20419992f,3.11919998f,0.16779993f,3.04409990f,-0.95329999f,2.25819996f,4.45089992f,-1.98260000f,-2.64679991f,1.27980006f,1.45249996f,2.24539993f,0.72150001f,1.31909998f,3.45540008f,-0.73619998f,0.84580002f,-1.63310015f,0.43009992f,-2.44820000f,-3.18869999f,1.73540000f,-1.92299999f,3.36820000f,-1.03459995f,-2.62779999f,-2.73380005f,-2.07640006f,0.56999998f,-4.07920011f,-0.23709997f,-1.31369993f,-0.48790001f,-2.03400009f,-2.80339999f,-2.47479993f,0.30910001f,-1.20340000f,-1.60769998f,-1.38920009f,-3.01370004f,3.08089997f,-2.25540011f,2.11440005f,-0.90659996f,-0.88020007f,-1.80290002f,-0.10630005f,2.85099998f,-4.49150004f,2.23399999f,1.83520004f,2.60419991f,0.04309992f,-0.58299995f,0.15569993f,-0.59600001f,1.40060010f,3.09310000f,1.45450004f,0.50300010f,-0.21939996f,-1.64209993f,-1.97780009f,-3.18269999f,1.45949994f,0.26530006f,1.71920002f,1.51569996f,-2.45150001f,1.43080005f,0.32670002f,-1.81769998f,-2.85880007f,0.22819989f,2.42280000f,1.19610009f,-1.65020000f,0.38700002f,0.00670004f,-0.58159999f,-5.00590012f,4.41600006f,-1.04270002f,-0.82700002f,-2.24080002f,0.42759993f,2.85210009f,0.15890004f,-2.09329991f,-5.37800009f,-0.74560008f,2.21149996f,-0.27610022f,0.20210000f,-2.14170005f,0.23860006f,-0.85809992f,-0.25690003f,-0.71960004f,-2.79590005f,-3.14410006f,-2.34220002f,0.50339994f,1.88920001f,0.00110001f,-1.69939996f,2.18730000f,0.67590008f,-3.22289999f,-2.98499995f,2.95019995f,-2.42300003f,-2.93920004f,-1.22950010f,-1.11180000f,-0.97979999f,-0.77750002f,0.30820004f,1.46220006f,0.42789991f,-1.40980000f,-0.85109997f,-0.54750005f,0.70719992f,0.89769990f,-1.40620005f,0.89220001f,-0.69260001f,-2.00799998f,-0.85689998f,-0.13260008f,3.40839994f,1.35979997f,-1.13669997f,-3.52989998f,0.41699996f,-1.78670008f,0.26839992f,0.27280001f,-0.48129999f,3.42590004f,-1.82339997f,-2.02439994f,-1.54600008f,-1.03670004f,2.01950001f,0.33180002f,3.47290002f,-0.93330004f,-0.58230008f,0.20340000f,-0.07160005f,-1.51509997f,0.55380007f,2.77639998f,2.55739992f,1.74470002f,-1.96580007f,-2.64529992f,-1.74540012f,-0.57790003f,-0.99649996f,1.45489998f,-3.81540002f,-2.39710002f,-2.40390001f,-2.92790007f,1.71779997f,0.87979998f,2.31259992f,-0.83430005f,-3.19490007f,0.16809999f,-2.41320011f,0.79749997f,1.26159999f,-0.79899999f,0.23580001f,-0.73299997f,-1.15650001f,-0.01420008f,1.54559995f,-1.59190004f,-2.00689998f,-2.80780002f,-0.91110008f,-2.64330006f,-2.26340000f,-1.45410007f,2.57509999f,1.00799999f,1.48750011f,1.84260007f,2.58010002f,-0.41699989f,0.12760001f,-1.14020007f,-1.71919997f,-0.62960000f,2.72760008f,1.86220003f,0.10040008f,-0.62349999f,-1.39379994f,-0.31899996f,3.25440000f,0.81910003f,0.92939995f,-0.43389993f,0.11999993f,-0.82489999f,-0.01999995f,1.19589995f,-2.98420002f,1.42039996f,0.61309998f,-2.72469997f,1.74470001f,3.05159994f,-1.26290002f,-0.00709998f,3.15110001f,3.25509985f,-1.70039993f,2.14199996f,1.04909998f,-2.27739994f,-0.24099997f,0.83210002f,0.79579997f,-3.08639989f,-2.61410003f,-1.94850008f,-0.83310006f,-1.15560001f,-1.23799997f,0.91590000f,0.79010000f,-0.57829994f,-0.76719999f,0.75079993f,-0.26789992f,-1.91249992f,0.55009998f,-0.83830006f,-1.13540003f,-0.44839999f,0.10859999f,1.11600005f,-1.67479986f,4.82379998f,2.35640000f,-0.04139994f,-0.71620000f,0.44949994f,1.28620005f,-2.29239997f,0.95970006f,-1.58130002f,1.13919998f,2.89310002f,-1.58280004f,-1.32370018f,-0.40379995f,-2.02720002f,1.53480000f,2.85599996f,1.39180004f,-1.66120004f,4.83749998f,-0.98740009f,-2.87679988f,0.94029993f,0.10399996f,2.06410000f,1.17810001f,1.59789996f,0.42119995f,-1.11680002f,1.95079998f,1.22979999f,-1.78430004f,-1.18960010f,0.48669997f,0.51029993f,3.62300000f,-0.00569991f,-0.32810001f,0.98870004f,3.98069995f,-0.83229996f,1.45480006f,-2.10880007f,-1.21530000f,0.81430011f,-0.13280013f,0.46960008f,-2.00649997f,2.18609994f,-1.42860013f,3.95880001f,-4.26059992f,-0.54209999f,-0.56029991f,-0.99409998f,1.41310005f,-0.35189997f,1.53700004f,-1.89280001f,0.91149989f,0.28719995f,-3.33170003f,2.51589999f,-2.35640006f,1.57140010f,0.03260006f,0.64969993f,-1.70759996f,0.63030005f,0.07020006f,-0.06400002f,-1.58949999f,1.19519987f,-0.11609993f,1.34179993f,-0.89509999f,1.51949995f,-0.37609994f,0.93319994f,-2.45130001f,-2.17359989f,-2.89460001f,-0.60559999f,-0.53150007f,1.75599990f,-0.74989997f,-0.49400002f,-2.95109985f,-0.08989994f,0.55280000f,-3.91200001f,0.15130002f,-3.96170008f,2.99870000f,0.32340002f,-3.47220008f,-0.69080008f,1.20029998f,-0.21869994f,-0.61580004f,-0.53520001f,1.75890003f,-1.43119999f,0.11640006f,3.99660000f,-0.11850003f,-1.00939999f,-1.27720000f,0.79440001f,-2.59409992f,-2.27239998f,0.56850008f,-0.02919997f,-3.16630003f,-3.46539990f,-1.53020007f,-0.21119993f,-1.26479992f,0.11370006f,3.27619994f,-1.24610004f,0.37380000f,1.03479991f,0.75020007f,1.53949998f,0.74840009f,0.53969995f,0.41340007f,1.31769996f,4.52409997f,0.18509997f,0.71179992f,1.93880012f,-2.18410001f,3.40150002f,2.54610000f,-1.95530010f,0.35449998f,-0.81749997f,-2.23949998f,-2.76839996f,-3.00100011f,3.42239996f,-2.56200003f,1.38129997f,0.27289996f,0.87470001f,1.17219999f,-1.95540000f,2.88160000f,-0.15429999f,2.06179983f,0.47790003f,3.66979990f,-2.68989994f,1.15670010f,5.54710002f,0.09880003f,2.53879998f,-0.72730001f,-0.32850008f,0.00080000f,2.38330003f,0.41200005f,-0.18659993f,2.53549992f,-1.30459991f,-1.89980005f,0.65950000f,0.15239997f,1.26599998f,1.30130003f,3.82570006f,-0.05509992f,-0.11870008f,-0.98050002f,-0.94460003f,-1.92789997f,1.00860002f,-3.17949990f,3.31759993f,-0.49460004f,1.40270002f,-2.40740013f,0.55390004f,0.31979996f,2.98129999f,0.50030002f,-1.67600007f,-5.28389988f,2.06870001f,0.43739988f,-1.98630003f,0.61620006f,0.35120000f,-0.84990001f,-0.58360002f,3.51700004f,-1.25370000f,2.60370001f,-2.25560007f,-1.68269993f,0.80310002f,2.48529991f,-1.87359993f,3.44959996f,-2.49249999f,4.34039999f,-0.07760005f,-0.58139990f,-1.95710006f,-2.70360001f,-0.37950009f,-0.08170002f,0.71589999f,-1.57250000f,-1.83039996f,-1.82319993f,0.08810007f,0.95310006f,-0.99359996f,-2.30409997f,-0.20890004f,-1.45710006f,-3.09370005f,0.16309998f,3.22140012f,-0.19639987f,1.58240003f,-0.46879998f,1.23640006f,3.15689995f,1.69070008f,0.14809999f,0.45959997f,-1.58689979f,-0.59119997f,-0.62479997f,1.95099998f,-0.50300002f,0.73270010f,-2.72560001f,0.28680009f,0.75149996f,-0.20829996f,3.23989999f,-0.38790004f,2.57440000f,-2.01519996f,5.99759998f,2.11700001f,0.49889997f,0.48449996f,-1.04760001f,0.56270002f,-2.20260005f,-2.62759999f,1.80539991f,-3.29060002f,-4.83590007f,5.98889993f,1.02859999f,-2.56049994f,1.10390003f,-2.21449990f,-0.51610002f,2.66090006f,0.42640004f,-3.49870000f,-2.98239989f,1.88400003f,0.30559993f,-1.19400002f,1.67359992f,2.05879999f,-0.66460008f,1.10509998f,-0.19269994f,-0.77819998f,-0.19100001f,0.45889993f,1.08670005f,1.04889997f,-0.41010015f,1.34719991f,2.50670004f,-3.12780004f,4.15830001f,1.39119997f,-0.85100005f,2.60870006f,0.16060001f,0.68810005f,1.03529994f,-0.15129990f,-0.51570002f,1.04450017f,-1.13170005f,-0.81440001f,1.65760000f,-0.85520005f,0.04060000f,1.16449995f,-4.33920014f,-4.23319989f,-1.20759997f,-0.42449990f,-1.52289997f,-0.21169991f,3.32960009f,-4.05050005f,1.36790005f,0.84420010f,1.78110002f,1.34209986f,4.36969997f,3.15119996f,3.17379984f,-1.25469992f,2.00159991f,2.28989998f,0.72790013f,0.73069998f,-1.44999995f,-0.38039997f,-1.07410000f,0.26910008f,2.99110001f,1.64229991f,0.76040003f,-0.00809992f,-2.60559999f,0.51209998f,4.82789991f,1.87660006f,2.80620001f,-1.17509992f,-0.66000001f,0.43210011f,-0.55899997f,-3.43470010f,-1.31839996f,3.67359990f,0.74440011f,3.60169998f,-3.02679998f,1.90599979f,3.40299987f,-1.61399994f,1.78560009f,-0.37450004f,-1.25029984f,1.50409994f,0.79130016f,2.84410007f,-3.33349996f,4.08550013f,2.20819998f,-2.36760019f,2.88770004f,-1.38049994f,1.69599998f,-0.33109998f,-1.28119994f,-0.18660005f,-0.79449999f,-1.32609999f,1.92460006f,1.79680000f,-2.53640007f,0.44269995f,-4.65949989f,-1.21930004f,-0.72069996f,-0.04570004f,-2.58259997f,5.42420004f,-5.97889993f,-0.90009995f,-0.52389991f,-3.69190011f,2.68819997f,2.14989995f,1.54340005f,-2.12400003f,-2.57209987f,-1.32590001f,0.26420014f,-0.06969999f,0.16040004f,-1.24569992f,1.64719994f,-3.19029992f,2.43270009f,0.70840009f,1.69319998f,-2.58699993f,-1.34110011f,-0.54839986f,3.58739995f,-4.29190014f,-0.10969992f,-0.18980003f,1.63560004f,0.69250000f,0.64119993f,-3.23460002f,2.80300015f,-0.30430003f,1.61029995f,0.30759996f,0.94729993f,-3.52129985f,0.88279998f,-0.58469996f,1.56929998f,5.27809998f,2.69829998f,4.98290007f,3.91969995f,-2.83939998f,3.90009994f,-0.03740000f,0.43350001f,-0.97730006f,1.33510007f,2.40169992f,3.13399988f,0.57889992f,-2.18689999f,0.43899991f,0.91989997f,-0.22830012f,0.75689994f,0.15950002f,0.06140002f,-1.97460001f,1.65209989f,1.15360005f,-0.06890009f,-2.73969995f,-0.34390004f,-0.62909998f,3.15839998f,3.15010002f,-1.69070002f,0.36839998f,-0.45569998f,-2.04049994f,1.91200005f,-3.47220008f,3.82569999f,-0.76360009f,-3.33619991f,-5.51009988f,-1.30630000f,4.67610005f,0.28959999f,1.93200012f,1.44490001f,-2.58869991f,3.09209996f,1.51209988f,-1.31570008f,-1.30700017f,-2.03419996f,-1.51090007f,-0.94380005f,-0.81470002f,3.79050003f,-1.10679998f,-1.72040002f,2.39970001f,-3.26010000f,1.24319984f,1.16579996f,3.05480001f,0.41690002f,-1.08040004f,0.96759999f,-1.02040003f,-0.62809994f,-1.74950000f,-3.29669993f,-1.13319998f,1.32790008f,1.76309995f,1.76470000f,-3.03870006f,-1.58849999f,0.50460001f,0.98719987f,-0.61319995f,-0.89030000f,1.70840002f,0.89180002f,-2.04120007f,-1.34249993f,2.34730006f,2.77110001f,-0.17970019f,-0.26090000f,-2.56150001f,-0.83050004f,0.81029992f,-0.02129993f,-1.18559990f,-0.40100004f,0.16989991f,-1.05980007f,0.36650006f,-1.80939983f,-0.60999997f,0.51790005f,-0.92140009f,-1.78790005f,0.54989997f,1.21509994f,1.16460005f,-0.76050000f,1.38669998f,-0.61049998f,-0.82529997f,1.68430001f,-0.76059997f,0.38579999f,-0.19919992f,2.26709984f,-2.24609992f,4.52090001f,-2.49420009f,-0.90649995f,-0.57639996f,-2.10149998f,-0.90470000f,0.40479998f,0.39790007f,-0.80290005f,-2.83900004f,-3.14749987f,-1.12279999f,-0.38309997f,2.40249993f,-2.40300009f,-2.00819996f,0.59260001f,-3.17070011f,-3.24249994f,-1.64929987f,-1.88840003f,-5.40449989f,-0.85500002f,-5.27989997f,0.73570002f,-0.13350005f,2.44030001f,0.07620009f,0.40509996f,-2.72050001f,-4.44229999f,-1.82499998f,-1.77859998f,4.66160003f,-1.84790002f,-0.01879986f,-1.28880009f,0.45009996f,-0.44580003f,3.02789982f,2.50400012f,-2.81999991f,0.25109993f,-1.28959998f,0.57699997f,2.18370006f,0.25000002f,2.35550001f,-2.58699989f,1.56940000f,2.71110009f,4.22750000f,-2.46409999f,-0.56340006f,-0.39669997f,-1.39659993f,1.61990012f,1.54779994f,-2.95489993f,-4.07800007f,-4.01440001f,-1.52989997f,1.21950000f,-1.37239990f,0.24780001f,-3.47290017f,-1.07440001f,3.11530007f,0.15069990f,-3.61979994f,0.60619997f,1.92619993f,-1.04180002f,3.21920007f,0.79719993f,2.60059998f,1.06079986f,-2.30719996f,0.04299993f,-1.52480010f,4.67879996f,-1.36929987f,-0.32980005f,-0.68430000f,-0.17680006f,4.15219997f,-1.73409997f,-0.25439993f,1.20610003f,-0.59579998f,-1.06360000f,0.75300003f,0.95800002f,-2.46100007f,1.61600005f,1.20089998f,1.30350000f,-0.59289990f,-2.63319993f,-0.69310002f,-2.35320014f,-0.50579985f,1.79879987f,3.06900003f,-1.52029991f,0.10550003f,1.31380003f,2.89659993f,2.74870002f,-0.85309997f,0.41039996f,1.08350001f,1.23549996f,-0.62609987f,1.23199993f,-0.45210003f,3.33750004f,-0.75810013f,-0.51209999f,0.94750001f,2.60649991f,-0.56549994f,-0.21900005f,0.74860023f,0.33380009f,-2.15079999f,-2.16090000f,2.17059997f,1.42329998f,-1.01879993f,-2.23790000f,-1.36089997f,0.88329997f,-0.42820004f,0.62840001f,1.10149989f,-2.66059992f,-1.74500008f,-4.12049999f,0.89880004f,-0.99909992f,1.68170011f,4.23960009f,-3.70380002f,3.05450005f,0.68869993f,-3.36159993f,-0.54250013f,1.80509991f,0.88289995f,2.01220008f,-0.13340002f,-2.19089992f,1.36240000f,-2.64629990f,-4.54219991f,3.33010006f,2.41989998f,-3.46859992f,1.54100008f,4.86479999f,-3.14139987f,-2.36869990f,0.89560008f,0.54330005f,-1.55680014f,2.60759997f,-3.32360004f,-0.78359992f,-1.78970003f,-0.81850001f,0.00390009f,3.06350006f,0.48300005f,-0.17840005f,-3.26759999f,-0.22250014f,-1.18449998f,4.44079995f,1.60779996f,-2.92860000f,0.98019999f,0.69179988f,2.46990005f,-0.95440000f,-5.12070003f,0.73179995f,-0.45350002f,1.15450002f,3.11710001f,1.94370006f,-3.81890003f,-1.69269995f,-0.92050004f,6.18429993f,-0.40519994f,-2.45929999f,0.46279999f,-4.98599999f,-2.29220002f,1.99070001f,1.81570000f,-2.65029987f,-0.90229997f,-2.69500012f,2.67219994f,-1.42490004f,-0.95400005f,-1.51179993f,1.70749986f,-1.57430000f,0.78230007f,-0.66059999f,3.25639992f,2.88140000f,-3.25710001f,4.43880001f,0.64179994f,2.45170002f,0.79020002f,-3.12189995f,-2.01739999f,0.97059986f,1.14479999f,5.28170002f,2.12420001f,-1.70329997f,-3.96250004f,0.77009999f,-0.62659994f,0.77259999f,-1.37040000f,-0.84729996f,-2.94519998f,-1.00489993f,2.17980008f,0.50019999f,0.48739991f,-3.27289991f,-4.00950000f,0.46430003f,0.52059991f,-1.20550008f,-0.89079994f,2.36139995f,-0.36409997f,0.29240005f,0.22889999f,-1.80710000f,1.18419993f,-0.83739997f,-0.62939996f,-0.77960005f,1.21179993f,0.19530008f,0.33119984f,0.49060002f,0.78949996f,-2.54429992f,4.31390005f,-1.51289998f,-1.23079994f,1.43009999f,0.83470006f,3.92360004f,-1.62969985f,3.70050012f,2.24570004f,-0.10329998f,0.44940003f,-2.41870005f,1.06139995f,-1.85189990f,-0.83100001f,-0.56590013f,2.29300002f,0.81149998f,-0.69239998f,-0.46369990f,-1.29029995f,-3.49339999f,1.20070003f,2.23610001f,-0.49469992f,-1.09430005f,-1.73040011f,-0.38750002f,-1.63790007f,-0.66579999f,2.95070002f,0.79780003f,-0.17920004f,4.57810004f,-1.06249998f,-3.63759996f,-4.67989989f,-1.10719999f,2.22909994f,1.79880001f,0.65230000f,0.85979995f,3.89839998f,-0.68959997f,-4.25260008f,1.34990001f,0.84070001f,-1.61329990f,-0.68460004f,3.20380009f,4.15639997f,-1.03129995f,-0.77250010f,0.03150000f,2.21039994f,-0.26580000f,0.45309995f,0.91400000f,-1.87079992f,4.99740007f,-1.52679991f,1.08890001f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_4d_4items_padded_neg)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{4,3,3,5,8,7};
    Shape shape_b{4,3,2,2,3,1};
    Shape shape_r{4,4,2,6,3,6};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1,1,1},        // move_strides
                                                                  Strides{1,1,1,1},        // filter_dilation
                                                                  CoordinateDiff{-1,2,-3,2}, // below_pads
                                                                  CoordinateDiff{1,0,0,-3}, // above_pads
                                                                  Strides{1,1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f,0.61000000f,0.17000000f,-0.91000000f,-0.48000000f,-0.48000000f,0.12000000f,-0.18000000f,0.08000000f,-0.16000000f,0.54000000f,-0.20000000f,-0.08000000f,0.19000000f,-0.81000000f,0.56000000f,-0.52000000f,0.32000000f,-0.37000000f,-0.17000000f,-0.46000000f,-0.34000000f,0.85000000f,0.11000000f,-0.10000000f,0.98000000f,-0.22000000f,0.68000000f,0.97000000f,-0.93000000f,-0.92000000f,0.32000000f,-0.19000000f,-0.61000000f,0.93000000f,0.54000000f,-0.75000000f,0.63000000f,0.38000000f,0.69000000f,-0.02000000f,0.19000000f,-0.38000000f,-0.44000000f,0.49000000f,-0.62000000f,-0.41000000f,-0.84000000f,0.93000000f,-0.74000000f,-0.57000000f,0.37000000f,-0.86000000f,-0.01000000f,0.58000000f,0.13000000f,-0.42000000f,0.68000000f,-0.05000000f,0.17000000f,0.09000000f,-0.67000000f,0.11000000f,-0.32000000f,0.08000000f,-0.29000000f,0.60000000f,0.69000000f,0.04000000f,0.85000000f,0.46000000f,0.41000000f,-0.78000000f,-0.98000000f,0.50000000f,-0.96000000f,-0.61000000f,-0.58000000f,0.00000000f,0.81000000f,-0.25000000f,-0.74000000f,-0.46000000f,-0.16000000f,0.32000000f,0.56000000f,-0.05000000f,-0.87000000f,0.59000000f,0.08000000f,-0.39000000f,0.67000000f,0.95000000f,0.70000000f,0.00000000f,-0.58000000f,0.85000000f,-0.14000000f,-0.27000000f,-0.63000000f,-0.75000000f,0.61000000f,-0.12000000f,-0.68000000f,-0.83000000f,0.12000000f,0.94000000f,-0.46000000f,0.27000000f,-0.14000000f,-0.96000000f,0.16000000f,-0.57000000f,0.92000000f,-0.24000000f,0.08000000f,0.60000000f,0.23000000f,-0.14000000f,-0.28000000f,0.14000000f,-0.19000000f,0.00000000f,-0.57000000f,0.18000000f,0.42000000f,0.17000000f,0.71000000f,-0.55000000f,0.89000000f,0.26000000f,-0.67000000f,0.68000000f,-0.75000000f,-0.62000000f,0.62000000f,-0.16000000f,-0.69000000f,-0.96000000f,-0.24000000f,0.00000000f,0.63000000f,-0.95000000f,-0.99000000f,0.06000000f,0.02000000f,-0.04000000f,0.95000000f,0.98000000f,0.13000000f,0.96000000f,-0.22000000f,-0.25000000f,-0.77000000f,-0.02000000f,-0.46000000f,0.28000000f,-0.61000000f,-0.56000000f,-0.65000000f,-0.23000000f,-0.41000000f,0.78000000f,-0.46000000f,0.44000000f,0.15000000f,0.46000000f,-0.90000000f,-0.25000000f,0.81000000f,0.28000000f,0.40000000f,0.56000000f,0.62000000f,-0.63000000f,-0.86000000f,-0.97000000f,0.22000000f,-0.58000000f,0.05000000f,0.53000000f,-0.38000000f,0.79000000f,0.60000000f,-0.63000000f,-0.18000000f,0.62000000f,-0.37000000f,0.48000000f,0.86000000f,0.70000000f,-0.52000000f,-0.39000000f,-0.44000000f,-0.69000000f,0.42000000f,-0.69000000f,0.48000000f,0.70000000f,-0.86000000f,-0.90000000f,0.69000000f,0.08000000f,-0.34000000f,-0.86000000f,0.66000000f,0.61000000f,0.47000000f,-0.22000000f,-0.51000000f,-0.29000000f,0.95000000f,-0.30000000f,-0.41000000f,0.85000000f,-0.13000000f,0.70000000f,-0.51000000f,-0.05000000f,-0.50000000f,-0.28000000f,-0.44000000f,0.33000000f,-0.08000000f,-0.88000000f,-0.64000000f,0.24000000f,-0.51000000f,0.67000000f,-0.40000000f,0.48000000f,0.92000000f,-0.64000000f,-0.42000000f,-0.62000000f,-0.77000000f,0.34000000f,0.29000000f,0.49000000f,0.82000000f,-0.30000000f,-0.40000000f,0.27000000f,0.61000000f,-0.75000000f,0.42000000f,0.69000000f,0.46000000f,0.41000000f,0.48000000f,0.14000000f,0.86000000f,-0.46000000f,-0.88000000f,-0.20000000f,-0.09000000f,-0.10000000f,0.70000000f,0.97000000f,-0.99000000f,0.53000000f,-0.51000000f,-0.70000000f,-0.96000000f,0.86000000f,-0.44000000f,-0.66000000f,-0.28000000f,0.08000000f,0.42000000f,-0.45000000f,-0.73000000f,-0.99000000f,-0.33000000f,0.40000000f,-0.86000000f,-0.84000000f,-0.06000000f,0.77000000f,0.96000000f,-0.06000000f,0.24000000f,0.21000000f,0.27000000f,-0.21000000f,-0.01000000f,0.16000000f,0.40000000f,0.06000000f,-0.61000000f,-0.66000000f,0.76000000f,0.43000000f,0.00000000f,0.37000000f,0.70000000f,-0.76000000f,0.50000000f,-0.38000000f,-0.24000000f,-0.80000000f,-0.66000000f,0.09000000f,-0.70000000f,0.83000000f,0.59000000f,-0.39000000f,-0.21000000f,0.84000000f,-0.17000000f,0.50000000f,-0.48000000f,-0.07000000f,-0.54000000f,-0.16000000f,0.99000000f,0.28000000f,0.29000000f,-0.68000000f,-0.49000000f,-0.18000000f,-0.41000000f,0.95000000f,0.72000000f,-0.26000000f,-0.42000000f,-0.27000000f,0.38000000f,-0.47000000f,0.24000000f,-0.38000000f,0.29000000f,0.34000000f,-0.30000000f,-0.64000000f,-0.27000000f,-0.27000000f,-0.94000000f,0.26000000f,0.52000000f,0.92000000f,0.53000000f,-0.80000000f,0.31000000f,0.29000000f,0.16000000f,-0.47000000f,0.61000000f,0.46000000f,-0.75000000f,-0.88000000f,0.95000000f,0.33000000f,-0.97000000f,-0.03000000f,0.43000000f,0.14000000f,0.73000000f,0.97000000f,-0.01000000f,0.45000000f,0.81000000f,0.77000000f,0.45000000f,0.16000000f,-0.66000000f,-0.29000000f,-0.23000000f,0.32000000f,0.22000000f,-0.09000000f,0.65000000f,-0.46000000f,0.65000000f,-0.01000000f,0.61000000f,-0.12000000f,0.36000000f,0.29000000f,-0.87000000f,-0.01000000f,-0.28000000f,-0.95000000f,0.37000000f,0.73000000f,-0.99000000f,0.47000000f,-0.69000000f,-0.31000000f,0.67000000f,-0.78000000f,-0.77000000f,-0.41000000f,0.95000000f,0.61000000f,0.52000000f,0.85000000f,-0.88000000f,0.97000000f,0.54000000f,0.53000000f,0.87000000f,-0.64000000f,-0.62000000f,0.70000000f,-0.11000000f,0.93000000f,-0.52000000f,-0.08000000f,0.03000000f,0.27000000f,-0.30000000f,-0.62000000f,0.00000000f,0.76000000f,0.12000000f,-0.83000000f,-0.60000000f,-0.95000000f,0.51000000f,0.85000000f,-0.27000000f,-0.83000000f,-0.20000000f,-0.45000000f,0.27000000f,-0.09000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.52000000f,-0.43000000f,-0.73000000f,-0.60000000f,-0.89000000f,0.15000000f,-0.12000000f,0.95000000f,0.97000000f,-0.43000000f,0.85000000f,0.43000000f,-0.35000000f,-0.44000000f,0.84000000f,0.94000000f,0.80000000f,-0.88000000f,-0.73000000f,-0.24000000f,0.93000000f,0.77000000f,0.15000000f,-0.63000000f,0.84000000f,0.70000000f,-0.24000000f,-0.01000000f,-0.63000000f,0.44000000f,0.50000000f,-0.29000000f,-0.27000000f,0.64000000f,0.28000000f,-0.18000000f,0.90000000f,-0.87000000f,-0.86000000f,-0.24000000f,0.66000000f,-0.49000000f,0.86000000f,0.19000000f,0.56000000f,-0.18000000f,-0.25000000f,-0.32000000f,-0.09000000f,0.83000000f,0.25000000f,0.92000000f,0.15000000f,0.71000000f,-0.91000000f,0.86000000f,-0.70000000f,0.05000000f,-0.23000000f,0.19000000f,0.32000000f,0.74000000f,-0.79000000f,-0.82000000f,0.44000000f,-0.91000000f,-0.61000000f,-0.99000000f,0.61000000f,-0.19000000f,0.14000000f,-0.46000000f,-0.33000000f,0.93000000f,0.29000000f,0.68000000f,-0.45000000f,0.47000000f,0.19000000f,-0.48000000f,0.03000000f,-0.10000000f,0.73000000f,-0.99000000f,0.72000000f,-0.58000000f,0.45000000f,-0.83000000f,0.07000000f,0.58000000f,0.02000000f,0.60000000f,0.71000000f,0.75000000f,-0.36000000f,0.19000000f,0.92000000f,-0.90000000f,-0.66000000f,0.57000000f,0.38000000f,0.86000000f,0.61000000f,0.31000000f,0.47000000f,-0.14000000f,-0.15000000f,0.27000000f,0.48000000f,0.44000000f,-0.45000000f,-0.83000000f,0.11000000f,0.96000000f,-0.38000000f,-0.12000000f,-0.72000000f,0.07000000f,-0.10000000f,-0.62000000f,0.21000000f,-0.33000000f,0.18000000f,0.18000000f,-0.50000000f,0.15000000f,0.38000000f,0.29000000f,-0.67000000f,-0.16000000f,-0.61000000f,0.36000000f,-0.50000000f,-0.87000000f,0.41000000f,0.41000000f,0.03000000f,0.71000000f,0.75000000f,-0.02000000f,0.13000000f,0.93000000f,0.51000000f,-0.86000000f,-0.43000000f,-0.97000000f,0.16000000f,-0.95000000f,-0.21000000f,-0.15000000f,-0.43000000f,0.53000000f,0.17000000f,0.18000000f,0.12000000f,-0.76000000f,0.56000000f,-0.71000000f,0.25000000f,-0.03000000f,-0.95000000f,0.65000000f,0.11000000f,0.29000000f,0.14000000f,0.04000000f,0.02000000f,-0.20000000f,-0.39000000f,0.23000000f,0.59000000f,0.07000000f,0.73000000f,-0.75000000f,0.67000000f,0.71000000f,-0.11000000f,-0.30000000f,0.26000000f,-0.93000000f,-0.01000000f,0.18000000f,-0.04000000f,-0.73000000f,-0.61000000f,-0.07000000f,0.00000000f,-0.68000000f,-0.58000000f,-0.95000000f,-0.51000000f,0.68000000f,-0.87000000f,0.07000000f,0.21000000f,0.87000000f,0.65000000f,-0.89000000f,0.57000000f,-0.48000000f,0.53000000f,-0.35000000f,-0.61000000f,-0.55000000f,0.62000000f,0.58000000f,-0.68000000f,-0.52000000f,0.33000000f,0.02000000f,0.74000000f,0.03000000f,0.44000000f,0.84000000f,-0.90000000f,-0.02000000f,-0.54000000f,0.55000000f,-0.24000000f,0.63000000f,0.31000000f,-0.67000000f,0.51000000f,0.67000000f,0.85000000f,0.68000000f,0.61000000f,0.04000000f,0.09000000f,0.70000000f,0.35000000f,-0.06000000f,-0.06000000f,-0.49000000f,0.81000000f,-0.24000000f,-0.70000000f,0.44000000f,0.18000000f,0.12000000f,0.17000000f,0.28000000f,0.26000000f,0.81000000f,-0.24000000f,-0.64000000f,0.32000000f,0.49000000f,-0.06000000f,0.13000000f,0.56000000f,-0.17000000f,-0.28000000f,-0.50000000f,0.89000000f,-0.20000000f,-0.34000000f,0.05000000f,0.71000000f,-0.09000000f,0.02000000f,-0.43000000f,-0.00000000f,-0.07000000f,0.25000000f,0.80000000f,0.18000000f,-0.37000000f,-0.16000000f,-0.42000000f,0.33000000f,0.76000000f,-0.81000000f,0.79000000f,0.88000000f,-0.62000000f,-0.49000000f,-0.79000000f,0.16000000f,0.19000000f,0.37000000f,-0.62000000f,-0.72000000f,-0.37000000f,0.39000000f,-0.84000000f,-0.13000000f,0.21000000f,0.88000000f,-0.80000000f,-0.06000000f,0.28000000f,-0.13000000f,-0.83000000f,-0.91000000f,-0.39000000f,0.19000000f,-0.71000000f,-0.08000000f,0.96000000f,0.89000000f,-0.60000000f,-0.79000000f,-0.13000000f,-0.00000000f,0.03000000f,0.97000000f,0.70000000f,-0.96000000f,-0.50000000f,-0.39000000f,0.13000000f,0.09000000f,0.29000000f,-0.43000000f,-0.40000000f,-0.83000000f,0.51000000f,-0.32000000f,-0.53000000f,0.07000000f,0.35000000f,0.43000000f,-0.65000000f,-0.94000000f,0.40000000f,-0.59000000f,0.80000000f,-0.15000000f,-0.22000000f,0.56000000f,0.90000000f,-0.82000000f,-0.74000000f,0.04000000f,-0.24000000f,-0.97000000f,0.96000000f,0.78000000f,0.29000000f,-0.44000000f,0.62000000f,0.92000000f,0.05000000f,-0.74000000f,-0.49000000f,-0.25000000f,0.34000000f,-0.99000000f,0.78000000f,-0.64000000f,0.09000000f,-0.51000000f,0.99000000f,-0.20000000f,0.95000000f,0.13000000f,-0.44000000f,-0.90000000f,-0.82000000f,0.84000000f,0.26000000f,-0.90000000f,0.97000000f,-0.09000000f,0.45000000f,-0.49000000f,0.29000000f,0.13000000f,0.37000000f,-0.03000000f,0.41000000f,-0.47000000f,0.25000000f,0.44000000f,0.31000000f,0.72000000f,0.09000000f,0.67000000f,0.76000000f,-0.79000000f,-0.99000000f,0.62000000f,-0.71000000f,-0.07000000f,0.63000000f,-0.02000000f,-0.28000000f,-0.02000000f,0.98000000f,0.28000000f,0.48000000f,-0.49000000f,0.32000000f,-0.11000000f,-0.45000000f,0.37000000f,-0.58000000f,-0.82000000f,-0.23000000f,-0.55000000f,-0.61000000f,-0.87000000f,-0.96000000f,-0.34000000f,-0.03000000f,-0.15000000f,-0.15000000f,-0.30000000f,-0.53000000f,0.83000000f,0.20000000f,-0.19000000f,-0.19000000f,0.23000000f,0.45000000f,0.50000000f,-0.67000000f,0.71000000f,-0.97000000f,0.42000000f,-0.33000000f,-0.88000000f,0.56000000f,0.78000000f,-0.09000000f,0.17000000f,0.77000000f,0.95000000f,-0.80000000f,-0.72000000f,0.23000000f,0.39000000f,-0.72000000f,-0.15000000f,-0.79000000f,-0.97000000f,0.97000000f,-0.20000000f,-0.56000000f,-0.95000000f,-0.65000000f,0.71000000f,-0.42000000f,0.10000000f,-0.58000000f,-0.14000000f,0.39000000f,-0.95000000f,-0.71000000f,-0.67000000f,0.62000000f,-0.10000000f,-0.11000000f,-0.76000000f,-0.30000000f,-0.62000000f,0.63000000f,-0.11000000f,-0.48000000f,0.37000000f,-0.08000000f,0.73000000f,-0.84000000f,-0.07000000f,-0.82000000f,-0.93000000f,0.63000000f,0.17000000f,-0.58000000f,-0.17000000f,0.83000000f,0.78000000f,-0.49000000f,-0.41000000f,0.29000000f,-0.90000000f,0.78000000f,-0.97000000f,-0.67000000f,0.47000000f,0.64000000f,-0.57000000f,0.89000000f,0.29000000f,-0.24000000f,0.75000000f,0.61000000f,0.45000000f,0.42000000f,0.16000000f,-0.75000000f,0.31000000f,0.66000000f,-0.04000000f,0.11000000f,-0.22000000f,-0.63000000f,-0.81000000f,0.48000000f,0.40000000f,-0.43000000f,0.37000000f,0.58000000f,0.18000000f,0.27000000f,-0.84000000f,0.31000000f,0.67000000f,-0.23000000f,0.74000000f,0.87000000f,-0.60000000f,-0.90000000f,-0.43000000f,0.07000000f,-0.58000000f,-0.01000000f,0.06000000f,-0.57000000f,-0.48000000f,-0.80000000f,0.30000000f,-0.69000000f,-0.37000000f,0.45000000f,0.85000000f,-0.17000000f,0.84000000f,-0.86000000f,0.36000000f,0.30000000f,0.49000000f,0.19000000f,-0.40000000f,-0.68000000f,-0.49000000f,0.61000000f,-0.07000000f,0.25000000f,-0.84000000f,0.42000000f,-0.23000000f,-0.28000000f,0.86000000f,-0.37000000f,0.13000000f,-0.29000000f,-0.93000000f,-0.28000000f,0.23000000f,0.25000000f,0.86000000f,0.33000000f,0.75000000f,0.75000000f,-0.61000000f,0.43000000f,0.09000000f,0.24000000f,-0.80000000f,-0.34000000f,-0.64000000f,0.25000000f,-0.07000000f,0.78000000f,0.29000000f,0.12000000f,0.28000000f,-0.72000000f,-0.72000000f,-0.70000000f,0.23000000f,-0.30000000f,-0.07000000f,-0.94000000f,0.97000000f,0.08000000f,-0.97000000f,0.20000000f,0.70000000f,0.38000000f,0.92000000f,-0.91000000f,-0.93000000f,-0.13000000f,0.05000000f,-0.56000000f,0.15000000f,-0.45000000f,-0.39000000f,-0.53000000f,0.25000000f,0.74000000f,0.85000000f,0.91000000f,0.25000000f,0.75000000f,0.32000000f,0.86000000f,0.99000000f,0.84000000f,0.17000000f,0.38000000f,0.16000000f,0.26000000f,0.37000000f,0.41000000f,-0.36000000f,-0.00000000f,-0.09000000f,0.70000000f,-0.40000000f,0.15000000f,0.76000000f,-0.17000000f,0.40000000f,-0.06000000f,0.14000000f,0.50000000f,-0.91000000f,0.44000000f,0.06000000f,0.30000000f,0.86000000f,0.45000000f,-0.88000000f,-0.06000000f,0.92000000f,-0.39000000f,0.83000000f,0.04000000f,-0.04000000f,0.70000000f,0.99000000f,-0.96000000f,0.02000000f,-0.45000000f,0.47000000f,0.71000000f,-0.50000000f,0.08000000f,0.98000000f,0.30000000f,-0.60000000f,-0.66000000f,0.66000000f,-0.51000000f,-0.86000000f,0.54000000f,0.51000000f,-0.36000000f,-0.48000000f,0.59000000f,-0.93000000f,0.64000000f,0.49000000f,0.23000000f,-0.72000000f,0.82000000f,-0.81000000f,-0.51000000f,-0.06000000f,0.58000000f,0.45000000f,-0.41000000f,-0.60000000f,-0.08000000f,-0.07000000f,0.47000000f,-0.48000000f,0.85000000f,-0.36000000f,-0.92000000f,0.48000000f,-0.36000000f,-0.09000000f,0.09000000f,-0.57000000f,-0.98000000f,0.67000000f,-0.53000000f,0.50000000f,-0.12000000f,-0.62000000f,-0.85000000f,0.37000000f,-0.98000000f,0.56000000f,0.65000000f,0.51000000f,0.54000000f,0.73000000f,-0.89000000f,0.07000000f,0.52000000f,0.92000000f,-0.26000000f,-0.93000000f,-0.82000000f,0.75000000f,0.96000000f,0.26000000f,-0.21000000f,-0.40000000f,-0.88000000f,-0.38000000f,-0.21000000f,-0.43000000f,-0.77000000f,0.48000000f,-0.95000000f,0.40000000f,0.43000000f,-0.24000000f,-0.72000000f,0.49000000f,-0.78000000f,0.82000000f,-0.21000000f,-0.15000000f,-0.56000000f,-0.94000000f,-0.51000000f,-0.10000000f,0.36000000f,0.68000000f,-0.78000000f,0.09000000f,-0.15000000f,-0.55000000f,0.21000000f,-0.11000000f,0.53000000f,-0.23000000f,-0.85000000f,-0.50000000f,0.66000000f,0.44000000f,0.47000000f,0.61000000f,0.22000000f,0.79000000f,0.71000000f,-0.91000000f,0.70000000f,-0.12000000f,-0.78000000f,0.45000000f,-0.40000000f,0.82000000f,0.27000000f,0.39000000f,0.87000000f,-0.23000000f,-0.37000000f,-0.78000000f,-0.19000000f,0.45000000f,0.29000000f,-0.45000000f,-0.30000000f,0.17000000f,-0.70000000f,0.09000000f,-0.85000000f,-0.67000000f,0.41000000f,0.37000000f,-0.12000000f,0.83000000f,0.92000000f,0.70000000f,-0.23000000f,0.62000000f,0.84000000f,0.13000000f,-0.36000000f,0.75000000f,-0.47000000f,-0.93000000f,0.00000000f,-0.71000000f,0.22000000f,-0.13000000f,-0.19000000f,-0.03000000f,-0.94000000f,-0.56000000f,-0.88000000f,-0.27000000f,-0.48000000f,0.98000000f,0.73000000f,0.87000000f,0.10000000f,0.04000000f,0.34000000f,0.51000000f,-0.95000000f,0.84000000f,0.17000000f,0.13000000f,-0.39000000f,0.37000000f,0.89000000f,-0.04000000f,-0.53000000f,-0.38000000f,0.00000000f,-0.00000000f,0.72000000f,0.08000000f,0.32000000f,0.69000000f,0.80000000f,0.00000000f,-0.12000000f,-0.79000000f,-0.75000000f,0.04000000f,-0.45000000f,0.08000000f,-0.96000000f,-0.95000000f,-0.44000000f,0.98000000f,0.10000000f,-0.28000000f,0.99000000f,-0.07000000f,0.53000000f,-0.86000000f,-0.01000000f,0.29000000f,-0.78000000f,-0.01000000f,0.22000000f,0.18000000f,-0.24000000f,-0.89000000f,0.12000000f,-0.67000000f,0.06000000f,-0.02000000f,-0.41000000f,-0.00000000f,0.91000000f,0.40000000f,-0.20000000f,0.25000000f,-0.08000000f,0.04000000f,0.42000000f,0.40000000f,0.39000000f,-0.22000000f,-0.23000000f,0.28000000f,0.48000000f,-0.72000000f,-0.85000000f,-0.22000000f,0.69000000f,-0.25000000f,-0.85000000f,-0.56000000f,0.80000000f,-0.91000000f,0.69000000f,-0.69000000f,0.86000000f,0.94000000f,0.87000000f,-0.47000000f,0.30000000f,-0.51000000f,-0.52000000f,0.74000000f,-0.43000000f,0.03000000f,-0.79000000f,0.76000000f,0.39000000f,0.00000000f,0.32000000f,-0.43000000f,-0.43000000f,-0.27000000f,0.08000000f,-0.20000000f,0.18000000f,0.01000000f,-0.12000000f,-0.22000000f,-0.64000000f,-0.56000000f,0.72000000f,-0.10000000f,-0.52000000f,-0.23000000f,0.93000000f,0.39000000f,0.14000000f,0.23000000f,0.81000000f,-0.37000000f,0.52000000f,-0.10000000f,-0.16000000f,-0.90000000f,0.35000000f,0.18000000f,-0.89000000f,0.72000000f,0.91000000f,-0.03000000f,-0.67000000f,0.43000000f,0.97000000f,-0.32000000f,-0.40000000f,0.85000000f,-0.25000000f,0.71000000f,-0.60000000f,0.71000000f,0.84000000f,0.20000000f,-0.97000000f,-0.66000000f,0.18000000f,0.71000000f,-0.29000000f,-0.73000000f,0.62000000f,0.76000000f,-0.12000000f,-0.80000000f,0.61000000f,0.38000000f,0.74000000f,0.44000000f,0.60000000f,0.23000000f,0.11000000f,-0.06000000f,-0.09000000f,-0.33000000f,-0.38000000f,0.17000000f,0.57000000f,0.91000000f,0.83000000f,0.89000000f,0.88000000f,0.83000000f,0.71000000f,0.97000000f,0.93000000f,0.23000000f,-0.36000000f,-0.21000000f,-0.77000000f,0.14000000f,0.52000000f,-0.48000000f,-0.21000000f,-0.86000000f,-0.39000000f,0.68000000f,0.46000000f,0.48000000f,0.09000000f,-0.10000000f,0.83000000f,0.63000000f,0.53000000f,0.40000000f,0.05000000f,-0.92000000f,0.61000000f,0.23000000f,0.23000000f,-0.49000000f,-0.12000000f,-0.88000000f,-0.03000000f,0.50000000f,-0.27000000f,0.44000000f,-0.59000000f,-0.50000000f,0.93000000f,-0.52000000f,-0.06000000f,-0.02000000f,0.57000000f,0.75000000f,0.56000000f,0.34000000f,-0.71000000f,-0.04000000f,-0.25000000f,0.81000000f,0.77000000f,-0.40000000f,0.69000000f,0.26000000f,0.86000000f,0.32000000f,0.69000000f,-0.64000000f,-0.75000000f,0.73000000f,-0.40000000f,-0.57000000f,0.95000000f,0.03000000f,-0.51000000f,0.15000000f,-0.25000000f,0.87000000f,0.23000000f,-0.61000000f,-0.37000000f,-0.44000000f,-0.04000000f,-0.84000000f,-0.07000000f,0.27000000f,-0.33000000f,0.68000000f,-0.59000000f,0.32000000f,0.06000000f,-0.80000000f,-0.47000000f,0.09000000f,-0.61000000f,-0.85000000f,-0.77000000f,0.78000000f,0.86000000f,-0.75000000f,-0.45000000f,-0.10000000f,-0.68000000f,-0.30000000f,-0.40000000f,0.83000000f,0.62000000f,0.97000000f,-0.71000000f,0.50000000f,-0.15000000f,-0.06000000f,0.99000000f,0.68000000f,-0.45000000f,0.81000000f,-0.82000000f,0.87000000f,-0.65000000f,-0.68000000f,-0.97000000f,0.68000000f,0.64000000f,0.19000000f,0.23000000f,0.51000000f,-0.96000000f,0.16000000f,0.05000000f,0.82000000f,-0.70000000f,0.08000000f,-0.13000000f,0.80000000f,0.87000000f,0.47000000f,0.27000000f,0.38000000f,0.27000000f,-0.61000000f,-0.63000000f,0.60000000f,0.91000000f,-0.03000000f,-0.65000000f,-0.26000000f,-0.59000000f,-0.08000000f,-0.00000000f,0.55000000f,-0.30000000f,0.28000000f,-0.81000000f,0.32000000f,-0.92000000f,-0.34000000f,0.55000000f,0.25000000f,-0.46000000f,0.93000000f,0.34000000f,0.69000000f,-0.59000000f,0.79000000f,0.95000000f,0.97000000f,0.91000000f,-0.53000000f,0.89000000f,0.29000000f,-0.23000000f,-0.49000000f,0.14000000f,-0.53000000f,0.22000000f,0.87000000f,0.10000000f,0.42000000f,0.31000000f,0.98000000f,-0.18000000f,-0.89000000f,-0.98000000f,-0.20000000f,0.31000000f,-0.54000000f,0.32000000f,-0.14000000f,0.16000000f,-0.24000000f,-0.77000000f,0.15000000f,0.76000000f,0.80000000f,0.70000000f,0.93000000f,-0.55000000f,0.25000000f,0.39000000f,0.16000000f,-0.80000000f,-0.64000000f,-0.51000000f,-0.48000000f,0.75000000f,0.50000000f,0.19000000f,-0.42000000f,-0.42000000f,0.75000000f,0.06000000f,0.61000000f,-0.75000000f,0.65000000f,0.27000000f,-0.72000000f,-0.20000000f,0.81000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.56000000f,-0.15000000f,-0.37000000f,0.38000000f,0.83000000f,-0.76000000f,-0.00000000f,-0.95000000f,0.99000000f,-0.51000000f,-0.06000000f,-0.47000000f,0.92000000f,0.03000000f,0.52000000f,-0.67000000f,0.73000000f,0.59000000f,-0.32000000f,-0.97000000f,0.41000000f,-0.37000000f,0.25000000f,0.77000000f,-0.40000000f,-0.01000000f,-0.95000000f,0.77000000f,-0.31000000f,-0.99000000f,-0.23000000f,-0.38000000f,-0.77000000f,-0.15000000f,-0.75000000f,-0.79000000f,0.85000000f,-0.56000000f,-0.80000000f,0.15000000f,0.75000000f,0.69000000f,-0.70000000f,-0.72000000f,-0.83000000f,0.16000000f,0.83000000f,0.95000000f,-0.33000000f,-0.16000000f,-0.56000000f,-0.36000000f,-0.94000000f,0.37000000f,0.51000000f,-0.95000000f,0.92000000f,-0.86000000f,0.88000000f,-0.63000000f,0.77000000f,0.12000000f,0.54000000f,0.99000000f,0.08000000f,0.38000000f,-0.42000000f,0.86000000f,-0.13000000f,0.45000000f,0.75000000f,0.10000000f,0.56000000f,0.78000000f,0.06000000f,-0.93000000f,0.77000000f,-0.47000000f,0.86000000f,-0.34000000f,-0.34000000f,0.61000000f,0.12000000f,-0.56000000f,0.64000000f,0.58000000f,-0.56000000f,0.32000000f,0.01000000f,-0.35000000f,0.10000000f,0.59000000f,-0.40000000f,0.19000000f,-0.02000000f,-0.53000000f,0.87000000f,-0.31000000f,-0.39000000f,0.80000000f,-0.53000000f,0.84000000f,0.69000000f,0.34000000f,0.46000000f,0.61000000f,-0.38000000f,0.85000000f,-0.38000000f,-0.90000000f,-0.57000000f,0.74000000f,0.21000000f,0.13000000f,-0.87000000f,-0.57000000f,-0.81000000f,-0.75000000f,-0.14000000f,0.99000000f,-0.49000000f,-0.65000000f,0.61000000f,-0.58000000f,-0.04000000f,-0.63000000f,-0.96000000f,-0.75000000f,-0.67000000f,-0.72000000f,-0.33000000f,0.50000000f,-0.01000000f,0.64000000f,0.97000000f,-0.08000000f,-0.34000000f,-0.84000000f,0.38000000f,-0.16000000f,0.42000000f,0.96000000f,0.80000000f,-0.53000000f,0.53000000f,0.51000000f,0.77000000f,-0.04000000f,-0.06000000f,0.65000000f,0.72000000f,0.82000000f,0.77000000f,-0.53000000f,-0.66000000f,-0.43000000f,0.95000000f,0.20000000f,0.14000000f,-0.27000000f,-0.13000000f,0.39000000f,-0.77000000f,0.07000000f,-0.14000000f,0.93000000f,0.69000000f,-0.03000000f,0.89000000f,0.51000000f,-0.40000000f,-0.68000000f,0.42000000f,-0.46000000f,-0.50000000f,0.15000000f,-0.81000000f,0.32000000f,-0.10000000f,0.26000000f,-0.10000000f,0.35000000f,-0.33000000f,0.70000000f,-0.35000000f,0.79000000f,0.97000000f,0.01000000f,-0.77000000f,-0.44000000f,-0.24000000f,-0.93000000f,0.21000000f,-0.74000000f,-0.64000000f,-0.25000000f,-0.90000000f,-0.26000000f,0.64000000f,-0.33000000f,0.82000000f,-0.12000000f,0.56000000f,-0.18000000f,-0.78000000f,-0.82000000f,-0.21000000f,-0.84000000f,-0.81000000f,-0.26000000f,0.20000000f,0.74000000f,-0.56000000f,0.86000000f,-0.17000000f,-0.36000000f,-0.02000000f,-0.16000000f,0.21000000f,0.61000000f,0.65000000f,-0.48000000f,0.04000000f,-0.38000000f,0.32000000f,-0.72000000f,0.22000000f,-0.16000000f,0.44000000f,0.25000000f,-0.51000000f,-0.64000000f,0.43000000f,0.72000000f,-0.88000000f,0.97000000f,-0.27000000f,0.40000000f,0.36000000f,0.49000000f,0.38000000f,-0.53000000f,-0.08000000f,-0.06000000f,0.69000000f,-0.27000000f,0.05000000f,0.72000000f,-0.48000000f,0.74000000f,0.80000000f,0.23000000f,0.00000000f,-0.49000000f,-0.85000000f,-0.30000000f,-0.43000000f,0.14000000f,-0.06000000f,0.03000000f,-0.83000000f,0.91000000f,-0.72000000f,0.27000000f,0.42000000f,-0.63000000f,-0.54000000f,0.92000000f,-0.87000000f,-0.49000000f,0.40000000f,0.60000000f,-0.24000000f,0.66000000f,-0.65000000f,-0.67000000f,0.15000000f,0.70000000f,0.89000000f,-0.13000000f,0.81000000f,-0.52000000f,-0.82000000f,-0.58000000f,-0.20000000f,0.08000000f,-0.51000000f,0.18000000f,0.99000000f,-0.80000000f,0.22000000f,-0.17000000f,-0.72000000f,-0.72000000f,0.39000000f,0.81000000f,-0.36000000f,0.92000000f,-0.63000000f,0.36000000f,0.21000000f,0.00000000f,-0.27000000f,-0.72000000f,-0.47000000f,-0.69000000f,0.93000000f,-0.60000000f,0.98000000f,-0.28000000f,-0.69000000f,0.24000000f,-0.32000000f,-0.13000000f,-0.37000000f,0.66000000f,-0.68000000f,0.82000000f,0.23000000f,-0.45000000f,0.19000000f,-0.02000000f,0.90000000f,-0.77000000f,-0.87000000f,0.94000000f,-0.53000000f,0.95000000f,0.90000000f,0.17000000f,0.80000000f,-0.86000000f,0.67000000f,0.58000000f,-0.27000000f,-0.87000000f,-0.15000000f,0.99000000f,-0.65000000f,0.08000000f,0.34000000f,-0.46000000f,-0.94000000f,0.78000000f,0.10000000f,-0.95000000f,0.54000000f,0.46000000f,0.89000000f,0.01000000f,-0.33000000f,0.43000000f,-0.19000000f,-0.87000000f,0.36000000f,0.84000000f,0.70000000f,-0.93000000f,-0.95000000f,0.86000000f,-0.33000000f,-0.60000000f,0.31000000f,0.70000000f,-0.39000000f,0.01000000f,-0.43000000f,-0.11000000f,-0.42000000f,-0.76000000f,0.72000000f,0.33000000f,0.40000000f,0.43000000f,-0.19000000f,-0.49000000f,0.24000000f,-0.45000000f,-0.02000000f,-0.12000000f,-0.50000000f,-0.74000000f,-0.53000000f,0.09000000f,0.39000000f,0.53000000f,0.02000000f,0.14000000f,0.40000000f,-0.81000000f,-0.28000000f,-0.32000000f,-0.00000000f,0.51000000f,0.54000000f,-0.12000000f,-0.30000000f,0.97000000f,-0.04000000f,-0.42000000f,-0.96000000f,-0.39000000f,0.81000000f,0.93000000f,-0.55000000f,0.46000000f,-0.79000000f,-0.99000000f,-0.53000000f,0.00000000f,-0.28000000f,0.08000000f,0.22000000f,0.34000000f,0.03000000f,-0.89000000f,0.36000000f,0.80000000f,-0.68000000f,0.50000000f,-0.08000000f,0.04000000f,0.98000000f,-0.36000000f,-0.97000000f,0.46000000f,-0.02000000f,-0.20000000f,0.66000000f,-0.67000000f,0.58000000f,0.46000000f,-0.14000000f,-0.74000000f,-0.68000000f,-0.22000000f,0.93000000f,-0.86000000f,-0.58000000f,0.66000000f,-0.03000000f,0.40000000f,0.60000000f,-0.65000000f,0.20000000f,0.96000000f,-0.04000000f,0.91000000f,0.95000000f,-0.19000000f,0.04000000f,0.89000000f,0.70000000f,-0.99000000f,0.27000000f,-0.55000000f,0.79000000f,0.99000000f,0.94000000f,-0.16000000f,0.16000000f,0.74000000f,-0.84000000f,-0.91000000f,-0.15000000f,0.70000000f,0.95000000f,-0.19000000f,-0.72000000f,0.23000000f,0.98000000f,-0.77000000f,-0.58000000f,-0.97000000f,0.20000000f,-0.89000000f,0.94000000f,-0.96000000f,0.78000000f,0.17000000f,0.51000000f,0.91000000f,-0.58000000f,-0.90000000f,-0.48000000f,0.03000000f,0.06000000f,-0.58000000f,0.67000000f,0.70000000f,-0.68000000f,0.13000000f,-0.02000000f,0.04000000f,-0.33000000f,0.64000000f,-0.72000000f,0.01000000f,0.71000000f,0.37000000f,0.31000000f,-0.39000000f,0.91000000f,0.19000000f,-0.34000000f,0.45000000f,-0.68000000f,-0.26000000f,-0.78000000f,-0.74000000f,0.43000000f,-0.05000000f,-0.29000000f,-0.98000000f,-0.07000000f,0.61000000f,-0.93000000f,0.05000000f,-0.44000000f,0.44000000f,0.89000000f,-0.08000000f,0.19000000f,0.95000000f,0.90000000f,0.63000000f,0.25000000f,0.09000000f,0.90000000f,-0.66000000f,0.62000000f,0.72000000f,-0.28000000f,0.76000000f,-0.90000000f,0.37000000f,-0.25000000f,0.60000000f,0.92000000f,-0.75000000f,0.86000000f,-0.79000000f,0.17000000f,-0.11000000f,-0.21000000f,-0.99000000f,-0.41000000f,0.18000000f,-0.59000000f,-0.04000000f,0.92000000f,-0.20000000f,-0.82000000f,0.70000000f,0.18000000f,-0.08000000f,0.04000000f,0.84000000f,-0.48000000f,-0.46000000f,-0.94000000f,-0.55000000f,0.64000000f,0.10000000f,-0.74000000f,-0.66000000f,-0.16000000f,0.52000000f,0.33000000f,-0.41000000f,0.24000000f,0.94000000f,0.22000000f,-0.04000000f,-0.90000000f,0.91000000f,0.13000000f,0.46000000f,0.18000000f,-0.33000000f,-0.48000000f,-0.92000000f,-0.54000000f,-0.90000000f,-0.20000000f,0.58000000f,-0.45000000f,-0.52000000f,-0.50000000f,-0.42000000f,-0.18000000f,-0.49000000f,-0.71000000f,0.61000000f,-0.32000000f,0.82000000f,-0.17000000f,-0.82000000f,0.37000000f,-0.73000000f,-0.22000000f,0.97000000f,0.79000000f,0.43000000f,0.75000000f,0.82000000f,-0.88000000f,0.15000000f,0.04000000f,0.50000000f,-0.21000000f,-0.38000000f,0.63000000f,-0.45000000f,-0.39000000f,0.34000000f,0.20000000f,-0.46000000f,-0.24000000f,-0.44000000f,-0.82000000f,0.63000000f,-0.36000000f,-0.03000000f,-0.20000000f,-0.31000000f,-0.51000000f,-0.44000000f,0.03000000f,-0.28000000f,0.86000000f,-0.98000000f,0.67000000f,-0.01000000f,0.37000000f,-0.58000000f,0.83000000f,-0.71000000f,0.88000000f,0.94000000f,-0.97000000f,-0.02000000f,0.53000000f,-0.47000000f,0.43000000f,0.45000000f,0.66000000f,-0.41000000f,0.01000000f,0.66000000f,-0.73000000f,0.98000000f,-0.51000000f,-0.25000000f,0.10000000f,0.86000000f,-0.61000000f,-0.38000000f,0.24000000f,-0.37000000f,-0.76000000f,0.10000000f,0.41000000f,-0.40000000f,0.45000000f,-0.94000000f,0.06000000f,-0.34000000f,-0.77000000f,-0.49000000f,0.10000000f,0.60000000f,0.59000000f,-0.18000000f,-0.29000000f,0.16000000f,0.66000000f,-0.79000000f,0.31000000f,-0.15000000f,-0.36000000f,0.28000000f,-0.83000000f,-0.40000000f,0.79000000f,-0.79000000f,0.01000000f,-0.10000000f,-0.89000000f,0.89000000f,-0.73000000f,-0.94000000f,-0.25000000f,0.90000000f,0.02000000f,0.87000000f,-0.72000000f,0.14000000f,0.01000000f,0.14000000f,0.33000000f,0.70000000f,-0.23000000f,0.31000000f,0.47000000f,-0.99000000f,0.74000000f,-0.94000000f,-0.18000000f,0.29000000f,0.74000000f,0.41000000f,-0.62000000f,-0.55000000f,-0.23000000f,-0.92000000f,-0.83000000f,-0.04000000f,0.62000000f,-0.21000000f,0.18000000f,0.54000000f,0.10000000f,0.01000000f,-0.56000000f,0.20000000f,-0.27000000f,0.95000000f,-0.72000000f,-0.81000000f,-0.37000000f,0.04000000f,0.35000000f,-0.43000000f,0.74000000f,0.96000000f,-0.39000000f,-0.25000000f,0.84000000f,-0.96000000f,0.63000000f,-0.21000000f,0.38000000f,0.08000000f,-0.30000000f,-0.96000000f,0.62000000f,0.52000000f,0.88000000f,0.24000000f,0.20000000f,-0.98000000f,-0.19000000f,0.73000000f,-0.92000000f,-0.26000000f,0.98000000f,0.23000000f,0.02000000f,-0.56000000f,-0.67000000f,0.84000000f,0.80000000f,-0.99000000f,0.90000000f,0.08000000f,0.54000000f,-0.42000000f,0.12000000f,0.61000000f,-0.37000000f,-0.33000000f,0.96000000f,0.77000000f,-0.97000000f,0.69000000f,-0.03000000f,0.32000000f,-0.05000000f,0.38000000f,-0.13000000f,-0.67000000f,-0.29000000f,0.78000000f,0.49000000f,0.06000000f,-0.80000000f,-0.11000000f,0.67000000f,0.22000000f,-0.76000000f,-0.30000000f,-0.78000000f,0.35000000f,0.64000000f,-0.14000000f,-0.56000000f,0.01000000f,-0.67000000f,-0.73000000f,-0.00000000f,0.49000000f,0.49000000f,-0.48000000f,-0.61000000f,0.93000000f,-0.05000000f,0.14000000f,0.47000000f,-0.07000000f,0.83000000f,0.97000000f,0.07000000f,-0.41000000f,-0.19000000f,0.17000000f,0.62000000f,0.58000000f,-0.37000000f,0.48000000f,-0.62000000f,-0.36000000f,0.94000000f,0.07000000f,-0.83000000f,0.49000000f,-0.81000000f,-0.77000000f,-0.21000000f,0.15000000f,-0.48000000f,-0.65000000f,0.88000000f,0.58000000f,0.74000000f,-0.88000000f,-0.78000000f,0.70000000f,-0.18000000f,0.37000000f,-0.84000000f,-0.49000000f,-0.39000000f,0.98000000f,0.06000000f,0.25000000f,0.97000000f,0.39000000f,0.38000000f,-0.67000000f,-0.52000000f,0.65000000f,-0.66000000f,-0.53000000f,0.38000000f,-0.30000000f,-0.51000000f,0.07000000f,-0.07000000f,0.01000000f,0.73000000f,0.38000000f,0.47000000f,-0.56000000f,0.44000000f,0.78000000f,-0.98000000f,-0.99000000f,-0.31000000f,-0.72000000f,0.91000000f,0.18000000f,-0.84000000f,-0.40000000f,-0.53000000f,0.33000000f,0.13000000f,0.37000000f,0.01000000f,0.81000000f,0.00000000f,-0.19000000f,-0.02000000f,-0.73000000f,0.65000000f,0.84000000f,-0.01000000f,0.16000000f,-0.07000000f,0.64000000f,0.22000000f,0.06000000f,0.49000000f,-0.28000000f,-0.84000000f,0.81000000f,-0.94000000f,0.32000000f,-0.07000000f,0.09000000f,0.95000000f,0.99000000f,-0.56000000f,0.64000000f,0.83000000f,0.51000000f,-0.93000000f,0.18000000f,-0.50000000f,0.38000000f,-0.07000000f,0.93000000f,0.63000000f,-0.29000000f,0.87000000f,-0.04000000f,0.63000000f,0.70000000f,-0.76000000f,0.02000000f,0.02000000f,-0.88000000f,-0.63000000f,-0.18000000f,-0.30000000f,-0.48000000f,-0.42000000f,0.93000000f,0.01000000f,0.36000000f,0.97000000f,-0.25000000f,0.93000000f,0.16000000f,0.46000000f,-0.31000000f,-0.32000000f,0.20000000f,0.43000000f,-0.93000000f,0.09000000f,0.97000000f,0.53000000f,-0.86000000f,-0.33000000f,0.77000000f,0.58000000f,-0.11000000f,0.55000000f,0.94000000f,-0.42000000f,-0.48000000f,0.05000000f,0.15000000f,0.58000000f,-0.59000000f,-0.41000000f,-0.53000000f,0.05000000f,0.96000000f,0.00000000f,0.60000000f,0.56000000f,-0.18000000f,0.49000000f,-0.44000000f,0.47000000f,-0.67000000f,-0.85000000f,0.91000000f,-0.28000000f,-0.17000000f,0.62000000f,-0.96000000f,0.81000000f,0.12000000f,0.54000000f,-0.52000000f,-0.12000000f,-0.28000000f,0.82000000f,0.02000000f,-0.11000000f,-0.51000000f,-0.45000000f,0.20000000f,0.69000000f,0.07000000f,0.48000000f,-0.48000000f,-0.01000000f,0.33000000f,0.64000000f,0.15000000f,-0.79000000f,-0.11000000f,0.28000000f,0.48000000f,0.58000000f,0.95000000f,-0.89000000f,0.01000000f,-0.16000000f,-0.66000000f,-0.92000000f,0.89000000f,-0.34000000f,0.50000000f,-0.28000000f,0.08000000f,-0.74000000f,0.29000000f,-0.02000000f,0.68000000f,0.15000000f,0.95000000f,0.21000000f,-0.58000000f,-0.11000000f,0.64000000f,0.73000000f,0.87000000f,-0.96000000f,-0.64000000f,-0.60000000f,-0.79000000f,0.35000000f,-0.54000000f,-0.65000000f,0.14000000f,-0.48000000f,0.02000000f,0.36000000f,-0.45000000f,0.07000000f,0.58000000f,0.62000000f,0.73000000f,-0.92000000f,0.71000000f,-0.73000000f,-0.58000000f,-0.10000000f,0.95000000f,-0.81000000f,0.05000000f,-0.40000000f,-0.70000000f,0.03000000f,-0.45000000f,0.88000000f,-0.89000000f,0.37000000f,-0.30000000f,-0.37000000f,0.07000000f,0.28000000f,-0.11000000f,-0.38000000f,0.32000000f,0.78000000f,0.21000000f,0.43000000f,0.77000000f,-0.57000000f,0.40000000f,-0.93000000f,0.16000000f,-0.66000000f,-0.66000000f,-0.82000000f,-0.13000000f,-0.69000000f,0.77000000f,0.54000000f,0.69000000f,-0.54000000f,0.29000000f,-0.77000000f,0.14000000f,0.25000000f,-0.14000000f,-0.98000000f,0.36000000f,0.00000000f,-0.17000000f,-0.07000000f,-0.25000000f,0.25000000f,-0.30000000f,-0.53000000f,0.79000000f,0.08000000f,-0.80000000f,-0.05000000f,-0.87000000f,0.22000000f,0.35000000f,0.32000000f,0.09000000f,-0.44000000f,-0.82000000f,0.77000000f,-0.17000000f,0.47000000f,-0.89000000f,-0.83000000f,0.33000000f,0.20000000f,0.93000000f,-0.44000000f,0.89000000f,-0.27000000f,-0.95000000f,0.03000000f,-0.23000000f,0.34000000f,0.35000000f,-0.22000000f,0.56000000f,-0.36000000f,0.20000000f,0.86000000f,-0.18000000f,-0.11000000f,-0.27000000f,-0.87000000f,-0.52000000f,-0.85000000f,-0.71000000f,-0.07000000f,-0.42000000f,-0.73000000f,-0.72000000f,-0.45000000f,0.21000000f,0.22000000f,0.35000000f,-0.67000000f,0.47000000f,-0.17000000f,-0.72000000f,-0.48000000f,0.64000000f,0.68000000f,-0.06000000f,-0.60000000f,-0.82000000f,0.84000000f,0.16000000f,0.49000000f,-0.16000000f,-0.57000000f,-0.16000000f,-0.86000000f,0.05000000f,-0.91000000f,-0.02000000f,0.11000000f,0.91000000f,0.64000000f,-0.68000000f,0.93000000f,-0.25000000f,-0.46000000f,0.70000000f,0.87000000f,0.97000000f,-0.75000000f,0.73000000f,-0.70000000f,0.63000000f,-0.08000000f,0.94000000f,0.84000000f,-0.55000000f,0.29000000f,-0.75000000f,-0.18000000f,0.15000000f,0.41000000f,0.33000000f,0.81000000f,-0.95000000f,-0.12000000f,-0.47000000f,0.19000000f,-0.12000000f,-0.49000000f,0.34000000f,0.23000000f,0.36000000f,0.51000000f,-0.45000000f,-0.97000000f,0.09000000f,-0.47000000f,0.54000000f,0.32000000f,0.46000000f,0.90000000f,-0.58000000f,-0.87000000f,-0.48000000f,-0.91000000f,-0.72000000f,-0.19000000f,-0.93000000f,0.30000000f,0.91000000f,-0.78000000f,-0.46000000f,0.19000000f,0.90000000f,-0.22000000f,-0.43000000f,0.56000000f,-0.42000000f,0.99000000f,-0.46000000f,0.18000000f,-0.75000000f,-0.77000000f,0.85000000f,-0.99000000f,0.10000000f,-0.92000000f,0.68000000f,-0.07000000f,-0.81000000f,-0.57000000f,-0.57000000f,-0.31000000f,0.74000000f,-0.01000000f,0.38000000f,0.00000000f,0.05000000f,-0.85000000f,-0.28000000f,0.91000000f,-0.78000000f,0.53000000f,0.02000000f,-0.12000000f,-0.90000000f,0.21000000f,-0.22000000f,-0.01000000f,-0.87000000f,0.45000000f,-0.37000000f,0.09000000f,0.90000000f,0.15000000f,-0.14000000f,0.66000000f,0.32000000f,0.18000000f,0.87000000f,0.74000000f,-0.35000000f,0.95000000f,0.23000000f,-0.89000000f,-0.81000000f,0.95000000f,0.96000000f,-0.43000000f,0.57000000f,-0.16000000f,-0.82000000f,-0.00000000f,-0.64000000f,0.18000000f,0.01000000f,0.19000000f,-0.90000000f,-0.55000000f,0.31000000f,0.41000000f,-0.41000000f,-0.31000000f,-0.32000000f,-0.65000000f,0.08000000f,0.77000000f,0.24000000f,-0.26000000f,0.39000000f,-0.72000000f,0.75000000f,-0.49000000f,0.19000000f,0.58000000f,0.55000000f,-0.71000000f,-0.12000000f,0.96000000f,-0.78000000f,0.73000000f,0.10000000f,-0.31000000f,0.25000000f,0.78000000f,-0.70000000f,-0.11000000f,-0.87000000f,-0.00000000f,0.66000000f,0.26000000f,0.80000000f,-0.21000000f,-0.94000000f,-0.99000000f,0.94000000f,0.78000000f,0.97000000f,-0.41000000f,-0.27000000f,0.23000000f,-0.20000000f,-0.32000000f,-0.86000000f,0.51000000f,0.67000000f,0.95000000f,0.71000000f,-0.63000000f,-0.26000000f,-0.20000000f,0.79000000f,0.34000000f,0.42000000f,0.27000000f,-0.49000000f,0.99000000f,0.59000000f,-0.09000000f,-0.23000000f,-0.10000000f,0.11000000f,-0.37000000f,-0.99000000f,0.73000000f,0.81000000f,-0.38000000f,-0.57000000f,0.90000000f,0.85000000f,-0.21000000f,-0.73000000f,0.74000000f,0.42000000f,-0.77000000f,-0.04000000f,0.16000000f,0.88000000f,-0.27000000f,-0.34000000f,-0.83000000f,-0.91000000f,-0.47000000f,0.18000000f,-0.06000000f,0.40000000f,-0.10000000f,-0.74000000f,-0.45000000f,-0.24000000f,-0.27000000f,-0.44000000f,-0.49000000f,-0.96000000f,-0.46000000f,-0.12000000f,0.76000000f,0.75000000f,-0.11000000f,-0.96000000f,0.54000000f,0.00000000f,-0.26000000f,0.81000000f,0.79000000f,0.67000000f,0.20000000f,0.69000000f,0.68000000f,0.01000000f,0.17000000f,-0.84000000f,-0.28000000f,-0.05000000f,0.49000000f,0.09000000f,0.12000000f,-0.30000000f,-0.02000000f,-0.02000000f,-0.62000000f,-0.12000000f,0.76000000f,-0.24000000f,0.86000000f,0.36000000f,0.36000000f,0.25000000f,-0.34000000f,-0.57000000f,0.92000000f,-0.72000000f,0.05000000f,0.76000000f,-0.36000000f,-0.54000000f,-0.03000000f,-0.66000000f,-0.95000000f,0.52000000f,0.87000000f,0.11000000f,0.17000000f,-0.88000000f,-0.37000000f,-0.13000000f,0.18000000f,0.03000000f,0.50000000f,0.59000000f,-0.15000000f,0.36000000f,0.72000000f,0.49000000f,0.62000000f,-0.12000000f,-0.69000000f,0.15000000f,0.80000000f,0.63000000f,-0.97000000f,0.19000000f,0.59000000f,0.38000000f,-0.14000000f,-0.72000000f,-0.71000000f,-0.08000000f,-0.36000000f,-0.23000000f,0.56000000f,0.34000000f,0.14000000f,0.68000000f,-0.90000000f,-0.15000000f,0.32000000f,0.08000000f,-0.87000000f,-0.89000000f,-0.93000000f,0.39000000f,0.30000000f,0.54000000f,-0.86000000f,-0.32000000f,-0.45000000f,-0.09000000f,-0.10000000f,0.37000000f,0.18000000f,-0.83000000f,-0.38000000f,-0.53000000f,-0.67000000f,0.98000000f,-0.29000000f,-0.03000000f,-0.30000000f,0.90000000f,-0.58000000f,0.39000000f,-0.29000000f,0.10000000f,0.11000000f,0.04000000f,0.80000000f,0.21000000f,0.08000000f,0.00000000f,0.50000000f,-0.25000000f,0.75000000f,0.26000000f,0.28000000f,0.26000000f,-0.59000000f,0.56000000f,0.68000000f,0.02000000f,0.55000000f,0.81000000f,-0.78000000f,0.14000000f,0.90000000f,-0.15000000f,0.48000000f,-0.74000000f,-0.61000000f,0.31000000f,0.72000000f,-0.82000000f,0.28000000f,0.27000000f,0.82000000f,-0.67000000f,0.90000000f,-0.88000000f,0.56000000f,-0.29000000f,0.05000000f,-0.46000000f,0.67000000f,-0.21000000f,-0.33000000f,0.28000000f,0.43000000f,-0.95000000f,0.88000000f,0.97000000f,0.41000000f,-0.68000000f,0.30000000f,0.04000000f,-0.77000000f,0.14000000f,-0.67000000f,-0.96000000f,0.01000000f,-0.92000000f,-0.55000000f,0.44000000f,-0.70000000f,-0.70000000f,0.37000000f,-0.07000000f,0.39000000f,-0.12000000f,-0.27000000f,-0.71000000f,0.06000000f,0.28000000f,0.92000000f,-0.79000000f,-0.82000000f,0.52000000f,0.26000000f,-0.21000000f,0.82000000f,-0.49000000f,0.88000000f,0.47000000f,0.45000000f,0.31000000f,0.44000000f,-0.98000000f,-0.23000000f,0.44000000f,0.13000000f,0.61000000f,-0.20000000f,-0.23000000f,-0.61000000f,-0.34000000f,0.35000000f,0.56000000f,-0.16000000f,0.57000000f,-0.46000000f,-0.56000000f,-0.92000000f,-0.31000000f,0.97000000f,-0.25000000f,-0.48000000f,-0.94000000f,0.74000000f,0.02000000f,-0.61000000f,-0.71000000f,0.57000000f,0.77000000f,0.33000000f,-0.52000000f,0.38000000f,0.78000000f,-0.79000000f,0.20000000f,-0.52000000f,0.44000000f,-0.45000000f,-0.36000000f,-0.93000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.84000000f,-0.83000000f,-0.72000000f,0.39000000f,0.32000000f,-0.87000000f,0.58000000f,-0.47000000f,0.08000000f,0.08000000f,-0.55000000f,0.22000000f,0.63000000f,0.21000000f,-0.15000000f,0.08000000f,-0.79000000f,-0.42000000f,0.49000000f,-0.89000000f,0.14000000f,-0.24000000f,-0.42000000f,0.34000000f,-0.20000000f,-0.26000000f,0.90000000f,0.98000000f,0.89000000f,-0.73000000f,-0.21000000f,-0.73000000f,0.36000000f,-0.51000000f,0.56000000f,-0.67000000f,0.65000000f,0.82000000f,0.39000000f,0.18000000f,0.76000000f,-0.26000000f,-0.75000000f,-0.83000000f,-0.94000000f,-0.04000000f,-0.80000000f,-0.89000000f,0.68000000f,-0.48000000f,-0.50000000f,0.75000000f,0.22000000f,0.87000000f,-0.06000000f,0.40000000f,-0.40000000f,-0.13000000f,0.17000000f,-0.01000000f,-0.40000000f,0.75000000f,0.42000000f,0.77000000f,0.28000000f,-0.41000000f,0.12000000f,0.55000000f,0.72000000f,-0.48000000f,-0.71000000f,0.75000000f,-0.18000000f,-0.51000000f,0.55000000f,0.35000000f,0.57000000f,0.03000000f,0.86000000f,0.52000000f,0.71000000f,0.50000000f,-0.25000000f,0.83000000f,0.57000000f,-0.51000000f,0.81000000f,0.03000000f,-0.81000000f,-0.78000000f,-0.70000000f,0.27000000f,0.55000000f,0.62000000f,0.55000000f,0.68000000f,-0.05000000f,-0.73000000f,-0.28000000f,0.24000000f,-0.33000000f,0.59000000f,-0.89000000f,0.78000000f,-0.91000000f,-0.77000000f,0.11000000f,-0.73000000f,0.57000000f,-0.26000000f,-0.25000000f,0.80000000f,0.47000000f,-0.09000000f,0.71000000f,0.15000000f,0.56000000f,0.27000000f,0.11000000f,-0.27000000f,-0.69000000f,0.45000000f,0.23000000f,0.87000000f,-0.35000000f,-0.31000000f,0.73000000f,-0.30000000f,-0.65000000f,0.36000000f,0.52000000f,-0.80000000f,0.62000000f,0.25000000f,0.31000000f,-0.42000000f,-0.32000000f,0.83000000f,-0.59000000f,-0.22000000f,-0.61000000f,-0.35000000f,-0.60000000f,-0.89000000f,-0.46000000f,-0.38000000f,-0.69000000f,-0.99000000f,0.87000000f,-0.04000000f,0.47000000f,0.31000000f,-0.07000000f,-0.64000000f,0.30000000f,-0.09000000f,-0.57000000f,0.28000000f,0.39000000f,0.75000000f,-0.44000000f,-0.50000000f,0.97000000f,0.74000000f,-0.86000000f,0.59000000f,0.28000000f,-0.48000000f,-0.96000000f,0.59000000f,0.17000000f,0.43000000f,0.84000000f,-0.80000000f,0.14000000f,0.10000000f,-0.25000000f,-0.99000000f,-0.89000000f,0.12000000f,-0.67000000f,-0.24000000f,0.65000000f,-0.20000000f,-0.73000000f,0.66000000f,0.80000000f,-0.46000000f,-0.32000000f,-0.60000000f,0.79000000f,-0.99000000f,0.22000000f,0.30000000f,-0.33000000f,0.49000000f,0.71000000f,-0.59000000f,-0.47000000f,-0.36000000f,0.93000000f,0.67000000f,-0.66000000f,-0.48000000f,0.04000000f,-0.11000000f,0.22000000f,0.55000000f,0.31000000f,0.26000000f,0.17000000f,-0.12000000f,0.39000000f,0.40000000f,-0.13000000f,0.44000000f,-0.36000000f,0.81000000f,0.69000000f,-0.47000000f,-0.07000000f,-0.94000000f,-0.06000000f,0.45000000f,-0.47000000f,0.12000000f,0.30000000f,0.81000000f,-0.50000000f,0.64000000f,0.56000000f,-0.01000000f,0.43000000f,-0.24000000f,0.45000000f,-0.30000000f,0.56000000f,-0.13000000f,0.44000000f,-0.17000000f,0.17000000f,0.76000000f,-0.32000000f,-0.49000000f,-0.13000000f,0.07000000f,-0.43000000f,-0.50000000f,-0.80000000f,-0.07000000f,-0.13000000f,0.93000000f,0.13000000f,-0.29000000f,-0.39000000f,0.53000000f,-0.89000000f,0.67000000f,0.25000000f,0.42000000f,-0.29000000f,0.48000000f,-0.37000000f,0.99000000f,0.99000000f,-0.12000000f,0.36000000f,0.64000000f,-0.79000000f,0.85000000f,-0.97000000f,-0.01000000f,-0.51000000f,-0.54000000f,-0.02000000f,-0.79000000f,-0.70000000f,-0.61000000f,0.24000000f,-0.12000000f,0.82000000f,0.18000000f,-0.91000000f,-0.83000000f,-0.90000000f,-0.32000000f,-0.14000000f,0.51000000f,0.05000000f,-0.63000000f,0.49000000f,0.57000000f,-0.31000000f,-0.97000000f,0.77000000f,-0.48000000f,0.05000000f,-0.75000000f,-0.72000000f,0.47000000f,-0.55000000f,0.19000000f,-0.76000000f,0.39000000f,-0.06000000f,-0.66000000f,0.20000000f,-0.85000000f,-0.09000000f,-0.76000000f,-0.84000000f,0.09000000f,0.74000000f,-0.09000000f,-0.75000000f,-0.69000000f,0.18000000f,0.27000000f,0.74000000f,0.73000000f,0.29000000f,0.70000000f,-0.59000000f,0.91000000f,0.93000000f,0.83000000f,0.40000000f,-0.87000000f,-0.29000000f,-0.93000000f,-0.33000000f,0.88000000f,-0.95000000f,-0.81000000f,-0.71000000f,0.96000000f,-0.37000000f,-0.39000000f,-0.23000000f,0.08000000f,0.71000000f,-0.18000000f,0.23000000f,0.61000000f,0.05000000f,0.19000000f,-0.19000000f,-0.81000000f,-0.05000000f,0.63000000f,0.84000000f,-0.12000000f,-0.33000000f,0.27000000f,0.49000000f,-0.29000000f,-0.30000000f,0.70000000f,-0.82000000f,-0.59000000f,0.59000000f,-0.28000000f,0.10000000f,-0.24000000f,0.13000000f,0.85000000f,-0.54000000f,-0.63000000f,0.65000000f,-0.06000000f,-0.59000000f,-0.97000000f,-0.36000000f,-0.40000000f,-0.34000000f,0.84000000f,-0.25000000f,0.77000000f,0.22000000f,0.87000000f,0.91000000f,-0.78000000f,0.74000000f,-0.13000000f,0.13000000f,0.07000000f,0.15000000f,0.92000000f,0.17000000f,-0.51000000f,0.06000000f,0.79000000f,-0.51000000f,-0.76000000f,-0.19000000f,-0.22000000f,0.74000000f,-0.31000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.97000000f,-0.59000000f,0.39000000f,-0.58000000f,-0.70000000f,-0.29000000f,0.44000000f,-0.71000000f,-0.77000000f,-0.83000000f,0.17000000f,-0.55000000f,-0.47000000f,0.98000000f,0.74000000f,-0.04000000f,0.57000000f,0.05000000f,0.64000000f,-0.53000000f,-0.23000000f,-0.15000000f,0.87000000f,-0.86000000f,0.45000000f,0.50000000f,-0.58000000f,0.35000000f,-0.89000000f,0.59000000f,-0.34000000f,-0.12000000f,-0.56000000f,-0.08000000f,0.93000000f,0.93000000f,0.27000000f,-0.60000000f,0.06000000f,0.47000000f,0.22000000f,0.49000000f,0.67000000f,-0.30000000f,0.83000000f,-0.13000000f,0.86000000f,-0.86000000f,-0.79000000f,-0.41000000f,0.30000000f,0.56000000f,0.88000000f,0.17000000f,0.40000000f,-0.84000000f,0.84000000f,-0.18000000f,0.95000000f,-0.17000000f,-0.52000000f,0.14000000f,0.04000000f,0.96000000f,0.21000000f,-0.42000000f,0.92000000f,0.32000000f,-0.24000000f,-0.11000000f,0.26000000f,-0.60000000f,-0.68000000f,0.91000000f,-0.37000000f,0.11000000f,0.76000000f,0.31000000f,0.39000000f,-0.25000000f,-0.10000000f,0.63000000f,0.20000000f,0.83000000f,-0.49000000f,0.71000000f,0.42000000f,-0.01000000f,0.15000000f,-0.47000000f,-0.13000000f,-0.69000000f,0.17000000f,0.90000000f,-0.21000000f,0.14000000f,0.60000000f,0.39000000f,-0.16000000f,0.23000000f,-0.33000000f,0.88000000f,-0.78000000f,-0.87000000f,0.15000000f,-0.68000000f,0.53000000f,-0.11000000f,0.43000000f,-0.54000000f,-0.57000000f,0.87000000f,0.81000000f,0.13000000f,-0.07000000f,0.18000000f,-0.32000000f,-0.85000000f,0.35000000f,-0.32000000f,0.75000000f,-0.80000000f,0.79000000f,-0.12000000f,0.55000000f,0.06000000f,-0.95000000f,0.50000000f,0.99000000f,-0.88000000f,0.75000000f,-0.69000000f,-0.23000000f,-0.53000000f,0.93000000f,-0.57000000f,0.29000000f,0.58000000f,-0.42000000f,0.75000000f,-0.92000000f,-0.13000000f,-0.16000000f,0.28000000f,-0.90000000f,-0.17000000f,-0.74000000f,-0.55000000f,0.99000000f,-0.82000000f,-0.24000000f,-0.43000000f,-0.52000000f,-0.45000000f,-0.02000000f,-0.70000000f,-0.26000000f,0.74000000f,0.21000000f,0.97000000f,-0.10000000f,-0.65000000f,-0.18000000f,-0.06000000f,-0.60000000f,0.54000000f,-0.76000000f,0.23000000f,0.21000000f,0.44000000f,0.06000000f,-0.80000000f,-0.87000000f,-0.13000000f,0.92000000f,0.97000000f,-0.04000000f,0.35000000f,-0.44000000f,-0.00000000f,-0.78000000f,-0.54000000f,-0.91000000f,0.19000000f,0.97000000f,-0.60000000f,0.35000000f,-0.64000000f,-0.84000000f,0.25000000f,0.90000000f,0.17000000f,-0.26000000f,-0.82000000f,0.59000000f,-0.62000000f,-0.14000000f,0.41000000f,0.62000000f,0.91000000f,-0.73000000f,0.62000000f,0.87000000f,0.50000000f,0.55000000f,-0.72000000f,0.00000000f,-0.19000000f,0.90000000f,0.30000000f,0.09000000f,-0.10000000f,-0.90000000f,0.66000000f,0.77000000f,0.63000000f,-0.07000000f,-0.92000000f,-0.63000000f,-0.86000000f,-0.08000000f,0.09000000f,0.38000000f,0.58000000f,0.76000000f,-0.98000000f,0.83000000f,-0.05000000f,-0.37000000f,0.52000000f,-0.57000000f,-0.31000000f,-0.47000000f,-0.49000000f,0.42000000f,-0.13000000f,-0.79000000f,0.60000000f,-0.08000000f,-0.12000000f,0.65000000f,-0.48000000f,0.79000000f,0.22000000f,0.71000000f,0.70000000f,0.78000000f,-0.25000000f,-0.05000000f,0.48000000f,0.14000000f,-0.85000000f,0.50000000f,-0.86000000f,0.31000000f,0.60000000f,0.72000000f,0.82000000f,-0.46000000f,-0.65000000f,-0.54000000f,0.26000000f,0.17000000f,-0.02000000f,-0.48000000f,0.36000000f,-0.63000000f,0.84000000f,0.62000000f,0.59000000f,-0.74000000f,0.00000000f,0.45000000f,0.08000000f,-0.54000000f,-0.34000000f,0.79000000f,0.38000000f,-0.17000000f,0.41000000f,0.30000000f,0.06000000f,0.22000000f,0.59000000f,0.23000000f,-0.36000000f,0.85000000f,-0.00000000f,-0.93000000f,0.74000000f,0.06000000f,-0.99000000f,-0.06000000f,-0.48000000f,0.27000000f,-0.97000000f,-0.44000000f,-0.12000000f,0.46000000f,-0.63000000f,-0.57000000f,-0.98000000f,0.72000000f,0.59000000f,-0.81000000f,0.96000000f,0.64000000f,-0.59000000f,0.13000000f,-0.80000000f,0.43000000f,0.23000000f,-0.66000000f,-0.74000000f,-0.52000000f,0.39000000f,-0.60000000f,-0.92000000f,0.49000000f,0.03000000f,0.84000000f,-0.72000000f,-0.97000000f,-0.81000000f,0.17000000f,0.79000000f,0.69000000f,-0.66000000f,0.11000000f,0.40000000f,-0.37000000f,0.46000000f,-0.74000000f,-0.50000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.01170001f,-1.02729999f,-1.71979997f,-0.00360007f,0.0f,0.0f,-1.89389999f,2.35600001f,1.77720002f,-0.18640009f,0.0f,0.0f,1.48890002f,-0.53959992f,3.72060005f,-2.66530004f,0.0f,0.0f,1.23880005f,2.33519999f,-4.62359995f,0.61429994f,0.0f,0.0f,-0.37490000f,1.11650003f,0.67689990f,0.55319998f,0.0f,0.0f,0.25819997f,-1.49609985f,1.53400007f,0.97610003f,0.0f,0.0f,-2.27390007f,-0.56009997f,1.31949993f,2.64999999f,0.0f,0.0f,-0.80880010f,0.20039997f,-3.57019998f,0.97050001f,0.0f,0.0f,1.44110004f,0.37619999f,0.33489995f,1.16099995f,0.0f,0.0f,-1.98519996f,1.91180006f,0.97810003f,-1.43779995f,0.0f,0.0f,0.43589994f,2.57740000f,-0.97120004f,-4.83550002f,0.0f,0.0f,2.13089995f,-1.73510003f,1.30629997f,1.65049998f,0.0f,0.0f,3.28500007f,0.40429986f,-0.66520002f,0.84889996f,0.0f,0.0f,2.87860007f,0.63140003f,-3.93770009f,0.40879991f,0.0f,0.0f,2.51520000f,2.15399995f,-1.26769988f,-1.50680006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.59130007f,1.68690002f,0.62949998f,-0.45140001f,0.0f,0.0f,0.30709999f,-0.05919997f,0.80029997f,-1.28569998f,0.0f,0.0f,1.02760010f,1.03999990f,-0.60749996f,1.36630001f,0.0f,0.0f,-0.30090004f,1.50479995f,-0.56050003f,-1.71100005f,0.0f,0.0f,2.20589995f,-2.75619995f,1.39890006f,-1.71209995f,0.0f,0.0f,0.43040006f,0.04529993f,-1.78339999f,0.73740003f,0.0f,0.0f,0.81089986f,-0.04740001f,-0.30140006f,-1.00870003f,0.0f,0.0f,0.46580000f,-1.66539998f,1.25800007f,-1.25469994f,0.0f,0.0f,-1.99230000f,-1.06019997f,0.23570003f,-0.75560008f,0.0f,0.0f,0.03409996f,2.18970004f,-1.02170003f,1.83740005f,0.0f,0.0f,-0.23919995f,0.27390000f,2.42959996f,-0.72080002f,0.0f,0.0f,2.16529997f,1.20860000f,-1.62389999f,2.75959998f,0.0f,0.0f,-0.09529997f,1.22750003f,-1.32559996f,0.85709994f,0.0f,0.0f,-0.73430005f,0.97219995f,1.42519999f,-0.29670001f,0.0f,0.0f,-1.27300001f,0.36099999f,-0.22230001f,-2.39970004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,2.04020001f,0.93419999f,-0.20790006f,0.31919998f,0.0f,0.0f,0.96690001f,0.51529998f,-0.80110000f,-2.76969999f,0.0f,0.0f,-1.05699996f,1.19439997f,1.95399996f,0.10320004f,0.0f,0.0f,-1.64059994f,-0.82450010f,4.26180003f,-1.33849991f,0.0f,0.0f,0.19449997f,-2.52609995f,1.12149999f,-0.85449994f,0.0f,0.0f,1.23859992f,3.78779997f,-3.47369996f,2.37740001f,0.0f,0.0f,-0.72949999f,1.30659994f,0.39469993f,-0.37169994f,0.0f,0.0f,0.01280004f,0.15190006f,-0.31889994f,-1.68560000f,0.0f,0.0f,-2.83429994f,-0.67209997f,-0.00230004f,-4.31040004f,0.0f,0.0f,2.36279999f,-0.86260002f,-3.19219994f,4.52510005f,0.0f,0.0f,3.79699996f,2.30769994f,1.56859993f,-0.74550008f,0.0f,0.0f,4.38910002f,1.02509995f,-0.32510003f,-0.60559988f,0.0f,0.0f,1.64049998f,-4.07230004f,-0.87550001f,-2.11969999f,0.0f,0.0f,-1.75510005f,-3.77669996f,1.19719998f,0.97850009f,0.0f,0.0f,-2.75460001f,-1.68749984f,-1.70890000f,-1.94749998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.91239996f,-0.77170004f,-0.76079999f,-0.76340000f,0.0f,0.0f,0.20360003f,-0.75280004f,-1.66589997f,0.39839999f,0.0f,0.0f,0.97289998f,-0.34319997f,-0.15220000f,0.99059998f,0.0f,0.0f,1.85420005f,-0.06370003f,-1.58060001f,-0.24229998f,0.0f,0.0f,-0.74059997f,-0.04860003f,0.09969994f,0.44809999f,0.0f,0.0f,-1.07880000f,-0.60029995f,0.70509996f,-0.54469997f,0.0f,0.0f,1.06740001f,0.01910002f,0.36780003f,-1.28739995f,0.0f,0.0f,-0.18200002f,1.68339999f,-0.82740005f,0.93939995f,0.0f,0.0f,0.22780000f,3.05009992f,0.11259998f,-0.63319999f,0.0f,0.0f,-0.74309997f,0.11259999f,0.83100002f,-0.51050001f,0.0f,0.0f,-0.04730000f,-0.31419999f,-0.91709997f,-0.36340008f,0.0f,0.0f,0.04899999f,-0.64629999f,0.03520000f,1.86289997f,0.0f,0.0f,0.38509996f,0.14349998f,0.88029996f,-0.35419999f,0.0f,0.0f,0.71510001f,-0.35520000f,0.33999999f,0.18480004f,0.0f,0.0f,0.31080004f,-0.99450001f,0.43259996f,-0.68669996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.88129996f,-3.74539999f,0.20239999f,0.09900004f,0.0f,0.0f,0.07190003f,1.27500000f,-1.24710006f,2.35010005f,0.0f,0.0f,-1.65260005f,-1.19309998f,1.57640001f,-0.26510001f,0.0f,0.0f,0.94449994f,-5.12929996f,-2.67789994f,-1.55890003f,0.0f,0.0f,-4.73379999f,0.36309996f,0.26790004f,0.35439998f,0.0f,0.0f,1.06810007f,-1.91670003f,4.42259995f,-1.08120001f,0.0f,0.0f,0.72310003f,-2.70580003f,-1.46749989f,-1.02380004f,0.0f,0.0f,-2.25190007f,-0.96549999f,-0.19579997f,5.16350002f,0.0f,0.0f,-0.62810007f,0.97289991f,-0.10469998f,1.58519983f,0.0f,0.0f,-1.47979992f,-2.40330006f,0.24140009f,-1.49149996f,0.0f,0.0f,-0.82340003f,0.19840007f,-5.00000000f,2.97000010f,0.0f,0.0f,0.23870001f,-1.79199993f,0.96469990f,-0.02659992f,0.0f,0.0f,-2.36859999f,1.94150006f,4.11620012f,-3.89189987f,0.0f,0.0f,-1.01850000f,0.49949992f,-2.05240005f,-2.92219995f,0.0f,0.0f,3.34170003f,1.04770000f,0.88619992f,1.42930007f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.64679996f,0.06230001f,0.66160001f,-0.04909998f,0.0f,0.0f,-1.46410003f,1.09420005f,1.97340000f,-0.97429996f,0.0f,0.0f,1.22580000f,-0.81270000f,0.16380001f,0.44869999f,0.0f,0.0f,-2.38110002f,0.69370001f,1.11819997f,-2.23619996f,0.0f,0.0f,1.94669999f,-0.68639998f,0.76110004f,-0.04179998f,0.0f,0.0f,-0.02690000f,-0.83960006f,-1.46040003f,0.59670000f,0.0f,0.0f,0.83279988f,-0.19809994f,-2.02079998f,0.46370000f,0.0f,0.0f,1.31199998f,-0.25370001f,0.04339999f,0.42830002f,0.0f,0.0f,0.05960003f,-1.97739998f,-0.65160001f,-0.53979996f,0.0f,0.0f,0.42379999f,1.27560004f,-0.04530004f,0.02959996f,0.0f,0.0f,1.26070010f,-1.01599998f,1.73590000f,-0.73380004f,0.0f,0.0f,-0.87830005f,0.19290006f,0.80569997f,-0.12019989f,0.0f,0.0f,-0.05039996f,0.21589997f,1.15630001f,0.68690003f,0.0f,0.0f,-0.66120004f,-0.35570002f,0.61380001f,-1.49650002f,0.0f,0.0f,-1.04660000f,-0.17859998f,0.66170000f,-1.29900003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,3.13790005f,-0.80539996f,3.13989999f,0.77060003f,0.0f,0.0f,-0.56399999f,0.40690000f,-1.12989996f,-0.12209992f,0.0f,0.0f,-0.51700008f,-1.17450006f,-1.46130001f,0.42090000f,0.0f,0.0f,0.36140007f,-3.08590001f,2.24210000f,-0.94660001f,0.0f,0.0f,-1.42029998f,3.55969994f,2.26739991f,0.66150001f,0.0f,0.0f,0.97339992f,2.99380011f,2.81419999f,-1.61680003f,0.0f,0.0f,-3.18869990f,-0.23340002f,1.20290008f,0.11809992f,0.0f,0.0f,1.76359996f,1.33219995f,1.43269995f,1.16960006f,0.0f,0.0f,0.46339990f,0.67949997f,-1.39319995f,-0.18980003f,0.0f,0.0f,-0.19560003f,-0.30690005f,0.55789999f,2.89309998f,0.0f,0.0f,0.08380000f,1.63229997f,-5.20350006f,3.12119997f,0.0f,0.0f,0.74900018f,0.61700008f,1.04949995f,-3.21389986f,0.0f,0.0f,1.87009995f,0.31430005f,0.65360004f,-1.55570006f,0.0f,0.0f,-1.16570012f,1.87690002f,3.42540003f,-1.05770001f,0.0f,0.0f,0.02499997f,1.97840001f,4.68600004f,0.64920000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,2.65879999f,-1.79859997f,-0.63430002f,0.11329998f,0.0f,0.0f,1.08990005f,-0.11120004f,-1.56099997f,1.76649998f,0.0f,0.0f,-1.95480008f,-0.64219994f,0.26239996f,-0.90479999f,0.0f,0.0f,-0.14979995f,-1.51989995f,0.08160009f,0.72580002f,0.0f,0.0f,-2.48789995f,-0.20580002f,-0.76940007f,0.59540002f,0.0f,0.0f,1.35980000f,1.04000006f,-1.00499995f,1.06579990f,0.0f,0.0f,-0.63839992f,-0.25590000f,1.58510000f,0.16309997f,0.0f,0.0f,-0.63029993f,0.49599999f,-1.55139998f,-0.15270002f,0.0f,0.0f,-0.75589998f,0.08150002f,1.02529998f,0.46340001f,0.0f,0.0f,2.25879997f,-3.13919997f,0.34430004f,-0.95679995f,0.0f,0.0f,0.20729997f,0.21840001f,-0.81159998f,-0.68559995f,0.0f,0.0f,0.46420006f,0.42959996f,-0.11049994f,-1.13400002f,0.0f,0.0f,-1.27860002f,-0.66309998f,0.58849991f,0.62920003f,0.0f,0.0f,-1.09280000f,-2.79429992f,-0.06650003f,1.43810003f,0.0f,0.0f,0.59689996f,-0.90370002f,-1.97389991f,3.03639998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.60419996f,-0.22550000f,0.35869999f,0.40499998f,0.0f,0.0f,2.29420002f,1.37569996f,-2.53380009f,-0.80600000f,0.0f,0.0f,-1.28710003f,-1.06950004f,-1.05989997f,-0.19059994f,0.0f,0.0f,1.16490007f,-2.57130000f,0.89100001f,-0.45050002f,0.0f,0.0f,0.41699996f,0.78590014f,-0.18830007f,-0.56339998f,0.0f,0.0f,-0.28340009f,0.70740000f,1.34660000f,-0.40000001f,0.0f,0.0f,1.05999995f,-3.89510001f,1.72160003f,-1.80820007f,0.0f,0.0f,-0.52140011f,-2.68599993f,4.04999993f,0.43650002f,0.0f,0.0f,-5.42330004f,3.47250007f,-0.07270008f,1.27609994f,0.0f,0.0f,2.21910012f,-4.85420010f,-0.51719987f,-0.00709996f,0.0f,0.0f,-2.10180001f,0.49919992f,-0.52240002f,0.39229996f,0.0f,0.0f,-2.38680003f,4.36919997f,-3.52669999f,-2.07930002f,0.0f,0.0f,0.05149997f,-1.82939989f,1.72829998f,-0.52039996f,0.0f,0.0f,0.81070008f,0.87350000f,-0.44860003f,-2.54429999f,0.0f,0.0f,0.90240000f,-1.96780002f,1.30699992f,-0.29360011f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.37859995f,1.18869998f,-0.35519998f,-0.00199996f,0.0f,0.0f,0.41699995f,0.63920004f,2.17830010f,0.43900003f,0.0f,0.0f,-3.57620004f,1.54290001f,1.33990003f,0.71649999f,0.0f,0.0f,-0.50800002f,0.83230005f,1.13370004f,1.73140004f,0.0f,0.0f,-1.43449999f,1.73810001f,0.80830005f,-0.93700005f,0.0f,0.0f,-0.60859993f,-1.11250000f,0.11940000f,-3.55790001f,0.0f,0.0f,-4.34549999f,0.79399995f,0.25059999f,-2.70629994f,0.0f,0.0f,0.16280005f,2.88969997f,1.48959998f,-1.04019998f,0.0f,0.0f,2.48520001f,-1.16350000f,0.98120003f,0.23140005f,0.0f,0.0f,-0.84539998f,-1.59620000f,-0.38579998f,-1.03420004f,0.0f,0.0f,-1.15920005f,1.42740003f,1.00450009f,-1.73420008f,0.0f,0.0f,0.40149999f,0.35450007f,-1.73959995f,0.74900000f,0.0f,0.0f,1.45690000f,-1.82190000f,-1.21260008f,-1.32310000f,0.0f,0.0f,0.19039999f,1.74550002f,0.70500003f,-1.45429999f,0.0f,0.0f,1.35010002f,-0.96839994f,1.93169999f,0.41000003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.27270000f,-1.02629991f,-0.75999995f,-0.35399997f,0.0f,0.0f,-1.43220003f,-1.98099993f,0.44150003f,-0.76300002f,0.0f,0.0f,0.87339997f,-1.76760001f,-0.24750004f,0.63360001f,0.0f,0.0f,-0.93879991f,1.13100002f,3.10829994f,-0.57080002f,0.0f,0.0f,-3.69819993f,-3.18190002f,0.44029998f,2.33409994f,0.0f,0.0f,-3.09609993f,-0.92980002f,1.63579995f,-0.62240002f,0.0f,0.0f,1.99740004f,-0.87980003f,-0.01830006f,0.86160001f,0.0f,0.0f,3.11090001f,-0.29210005f,-0.36429998f,2.15520004f,0.0f,0.0f,3.93490006f,-1.80039996f,-1.42489995f,0.20889998f,0.0f,0.0f,2.83380004f,-0.44599990f,2.59159993f,-0.52440003f,0.0f,0.0f,0.18699997f,2.66180002f,0.40199991f,-3.05990005f,0.0f,0.0f,2.29450003f,-0.28420002f,1.73830000f,2.90000004f,0.0f,0.0f,-0.06840006f,-0.25310002f,-1.60700005f,1.11210002f,0.0f,0.0f,2.16859993f,-1.09780000f,-0.68370009f,2.13470002f,0.0f,0.0f,4.00309986f,-0.77949991f,0.17420006f,1.50010004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.47789999f,-1.85460001f,-0.55029997f,-0.99299999f,0.0f,0.0f,-1.43879996f,-0.11230003f,0.72849998f,-0.79620001f,0.0f,0.0f,-1.19839993f,0.38949999f,0.86819995f,-0.06780003f,0.0f,0.0f,-1.00459998f,-0.40519995f,1.29560000f,0.00469999f,0.0f,0.0f,-0.15600000f,-1.57480001f,-0.70840002f,-2.44999996f,0.0f,0.0f,2.69630002f,-0.55760004f,-2.50549995f,-1.19819999f,0.0f,0.0f,1.04150006f,0.57290001f,0.86899997f,-0.25690001f,0.0f,0.0f,1.49600005f,-2.10309994f,1.17169998f,-0.79599995f,0.0f,0.0f,-0.86680004f,-0.05340001f,-0.37740005f,-0.78689999f,0.0f,0.0f,1.38289997f,2.02990001f,-0.27589999f,0.51559995f,0.0f,0.0f,1.35749997f,-1.04919992f,-1.03269999f,0.84150000f,0.0f,0.0f,0.44700005f,-0.79800001f,-0.02580005f,-2.00419993f,0.0f,0.0f,0.99249998f,0.50869999f,2.07049990f,-1.51349996f,0.0f,0.0f,-0.24299997f,0.61299997f,0.12409989f,1.07520001f,0.0f,0.0f,0.24180000f,1.45929991f,1.85699996f,0.77280001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18180000f,0.57389999f,0.13169998f,2.33009995f,0.0f,0.0f,1.95409999f,0.73880005f,-0.88559998f,0.22990001f,0.0f,0.0f,0.61489992f,0.05040001f,-1.90229999f,0.97690004f,0.0f,0.0f,3.28419999f,-2.08039990f,-1.60549996f,0.69199983f,0.0f,0.0f,3.15959993f,-2.01130008f,-4.26539997f,-0.25999993f,0.0f,0.0f,-3.46130012f,-0.21049996f,-2.38390006f,5.38389994f,0.0f,0.0f,1.56869995f,0.63090001f,0.85019984f,2.54650005f,0.0f,0.0f,-1.33100011f,-2.56400008f,-0.04929994f,1.40680002f,0.0f,0.0f,-3.82069995f,1.26019995f,1.14999981f,2.25399997f,0.0f,0.0f,0.99969981f,-0.07640002f,-1.33110005f,2.57850006f,0.0f,0.0f,2.05180003f,-0.00730007f,2.12680008f,3.58479995f,0.0f,0.0f,-3.69049999f,3.54679986f,-2.44590002f,-1.36110001f,0.0f,0.0f,-0.37279991f,1.21790005f,-0.43939992f,-0.08660005f,0.0f,0.0f,0.21939988f,-0.23460007f,1.41460007f,-1.02150010f,0.0f,0.0f,-2.54830004f,0.42150009f,-4.52510007f,-0.06109995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.14799998f,1.17759999f,-0.36650001f,-0.18580001f,0.0f,0.0f,0.94829998f,-0.01620000f,-0.08210000f,0.93570003f,0.0f,0.0f,0.39390000f,0.81519999f,-0.17030000f,-0.33629997f,0.0f,0.0f,0.79859996f,-1.60649999f,-0.12589997f,0.52950001f,0.0f,0.0f,-0.28130000f,1.12489998f,0.17310001f,0.77189999f,0.0f,0.0f,-0.85959992f,0.89159994f,0.78989996f,-0.66619999f,0.0f,0.0f,-1.59059997f,-0.24080000f,0.93169994f,-0.44649998f,0.0f,0.0f,-0.51810002f,2.13419996f,0.33399997f,-1.51009999f,0.0f,0.0f,2.02919995f,0.19669998f,1.99650002f,-0.42009997f,0.0f,0.0f,-0.21789999f,-0.85749999f,-0.87359998f,0.33810008f,0.0f,0.0f,-0.07169999f,1.12889995f,1.08029994f,0.68879996f,0.0f,0.0f,-0.06229999f,0.20259999f,-1.53189987f,0.75590002f,0.0f,0.0f,-0.68510000f,-1.27709996f,-1.28569998f,-0.32500006f,0.0f,0.0f,0.97569997f,2.41619999f,0.57829998f,-0.23229997f,0.0f,0.0f,1.27400005f,-2.34309994f,-1.58369995f,-1.12599997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.70239993f,1.05570005f,1.54030004f,0.50190003f,0.0f,0.0f,-2.06989999f,-1.18180001f,0.69850004f,0.96440002f,0.0f,0.0f,1.71809998f,-1.69630000f,-0.35590008f,2.63539998f,0.0f,0.0f,-1.88790003f,1.08399996f,-4.30030003f,-2.86040001f,0.0f,0.0f,-1.11179998f,-2.33270007f,-2.89019998f,0.84269997f,0.0f,0.0f,0.70229993f,-1.64149998f,-0.81599994f,0.04610026f,0.0f,0.0f,0.37100004f,1.22919999f,-2.37850005f,0.59959998f,0.0f,0.0f,-2.46869988f,-0.00710002f,-1.38380000f,2.46220012f,0.0f,0.0f,1.89710004f,2.30759998f,0.67079996f,-0.81440000f,0.0f,0.0f,-0.98180010f,0.50180006f,-0.32850001f,-0.39920000f,0.0f,0.0f,1.14029996f,-1.26229996f,1.51340002f,-1.92880005f,0.0f,0.0f,-0.84050006f,-1.45349998f,1.27549986f,1.81559994f,0.0f,0.0f,2.41210002f,1.70390009f,1.45390010f,1.00330000f,0.0f,0.0f,-0.07839997f,-4.22850005f,-0.26300004f,3.23509995f,0.0f,0.0f,0.43679996f,2.85120002f,-0.05499990f,2.24679994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.05619997f,-0.86749997f,1.58910001f,0.21059995f,0.0f,0.0f,-1.16689995f,-0.35720001f,-1.36910006f,-0.57940008f,0.0f,0.0f,2.22100002f,-1.81880000f,-1.68870005f,-0.28390002f,0.0f,0.0f,0.39080000f,1.21459992f,-0.42550003f,-1.81370001f,0.0f,0.0f,0.52720004f,-2.61039998f,0.21349999f,0.18789994f,0.0f,0.0f,-1.59419999f,0.54310005f,1.84470003f,2.13410001f,0.0f,0.0f,5.12199995f,-0.37929998f,-1.93039997f,3.16589995f,0.0f,0.0f,1.53890001f,-1.33860003f,-1.50109993f,2.08769999f,0.0f,0.0f,-0.48109999f,-0.90229996f,-3.91909999f,-1.71450000f,0.0f,0.0f,-1.08089998f,2.34839996f,1.81140005f,-0.09340003f,0.0f,0.0f,1.70750000f,0.56860000f,-0.39980006f,-0.26209990f,0.0f,0.0f,1.51440002f,-1.76539997f,1.09039989f,1.37909999f,0.0f,0.0f,1.13949995f,3.14899997f,-0.52749995f,0.95890010f,0.0f,0.0f,-1.52619994f,-1.57690003f,-1.50759997f,-0.62399993f,0.0f,0.0f,-1.65180004f,1.43969995f,-1.34619999f,-0.65290000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.48580003f,1.67220005f,-2.40849998f,1.15430004f,0.0f,0.0f,-1.90100005f,-0.64720005f,0.12370005f,-1.21000000f,0.0f,0.0f,-0.59950011f,-3.31519999f,-1.83649991f,-1.52529997f,0.0f,0.0f,0.81690013f,-0.75180002f,-2.01600004f,-0.24310010f,0.0f,0.0f,0.63920005f,-2.20360000f,0.76599989f,-4.56210001f,0.0f,0.0f,-1.13740008f,-3.66169999f,0.61680001f,-3.00039995f,0.0f,0.0f,-2.41590001f,-0.69830009f,-1.64279994f,0.87970002f,0.0f,0.0f,0.50420006f,-4.08550018f,-5.01849988f,0.37459995f,0.0f,0.0f,-1.49009990f,2.11830006f,2.02540002f,-1.96420004f,0.0f,0.0f,-0.53830001f,-1.12290006f,-2.68879989f,0.65280000f,0.0f,0.0f,2.23599999f,-2.00169992f,-1.10489996f,-1.48090003f,0.0f,0.0f,1.12379998f,1.53500008f,-0.42999996f,0.58980003f,0.0f,0.0f,-0.36570001f,-1.47010002f,1.74200000f,-0.71570010f,0.0f,0.0f,-1.20380001f,0.36909995f,-1.32489991f,-0.71070002f,0.0f,0.0f,4.20140004f,-3.86809996f,-0.70570007f,3.54619998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.47540005f,-0.30750006f,1.59070001f,-0.10460000f,0.0f,0.0f,-1.02569999f,-2.93610001f,0.05200003f,0.93900006f,0.0f,0.0f,3.69489999f,1.08260002f,-1.99450005f,0.03119997f,0.0f,0.0f,-0.76770002f,-1.34540001f,-0.72330000f,-0.27289997f,0.0f,0.0f,-3.17619998f,-1.72529998f,0.01920009f,0.18570003f,0.0f,0.0f,3.69419998f,0.65020005f,-1.46000010f,0.98189997f,0.0f,0.0f,-2.07320000f,-0.38619996f,-0.19440008f,0.88840005f,0.0f,0.0f,-0.93649995f,3.24980007f,1.80870001f,-1.09809989f,0.0f,0.0f,3.66869998f,1.51400005f,-1.38539996f,-0.42010007f,0.0f,0.0f,-0.77770006f,3.01770007f,-2.34560007f,-0.86190003f,0.0f,0.0f,1.10840000f,1.29469998f,0.21039990f,-1.10919997f,0.0f,0.0f,2.16089997f,0.22360001f,-2.29410000f,1.43479998f,0.0f,0.0f,-2.04519999f,3.03890004f,-0.08400003f,1.16219994f,0.0f,0.0f,0.24769999f,0.53939997f,-2.77220002f,0.75840001f,0.0f,0.0f,1.11540005f,-0.60520003f,-1.43939998f,-0.59019998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.39159996f,-2.16939998f,-0.03870000f,-0.92589997f,0.0f,0.0f,1.55390005f,-2.77329990f,-0.21370001f,-0.50829996f,0.0f,0.0f,-0.18189995f,0.10430005f,1.17509997f,-1.21650002f,0.0f,0.0f,-1.02479995f,-0.48509996f,0.11410003f,2.25770002f,0.0f,0.0f,-0.16370006f,-0.70639998f,-2.77609992f,2.55760003f,0.0f,0.0f,1.67510002f,2.68509994f,0.32149995f,4.09660003f,0.0f,0.0f,2.21999991f,-0.79929998f,0.87050000f,-0.56700003f,0.0f,0.0f,-1.17780005f,1.16890007f,-0.15369995f,-0.35590005f,0.0f,0.0f,3.08999996f,1.11610006f,-2.29459996f,0.07200000f,0.0f,0.0f,1.26109997f,0.73159996f,-1.55589995f,-0.32660001f,0.0f,0.0f,2.32779987f,1.77359994f,0.17359995f,-1.81730002f,0.0f,0.0f,0.50429996f,-1.71980001f,-0.80760008f,3.52740005f,0.0f,0.0f,-0.91529997f,-2.06379994f,-0.03340001f,-1.82259992f,0.0f,0.0f,-1.06280005f,-0.16380001f,1.96930002f,0.59470004f,0.0f,0.0f,-0.52369991f,1.26289992f,3.34110000f,-0.30600007f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.15359998f,-1.21459999f,-0.53720001f,-0.23000003f,0.0f,0.0f,0.55410006f,0.35719997f,-0.67440004f,0.00329995f,0.0f,0.0f,-0.37089998f,0.50259996f,-0.46689997f,-0.00520007f,0.0f,0.0f,1.20250001f,0.59120006f,-0.24730000f,0.00560001f,0.0f,0.0f,1.65249996f,-0.54829991f,1.68249995f,-1.25000003f,0.0f,0.0f,-0.23020000f,0.79750001f,0.00030007f,-2.44979997f,0.0f,0.0f,-0.25869991f,1.21550000f,-1.20389999f,-0.97940000f,0.0f,0.0f,2.12659997f,1.95799998f,-1.41080001f,0.81060001f,0.0f,0.0f,-0.59959998f,0.27129992f,1.54729997f,-1.30899993f,0.0f,0.0f,-0.63009999f,1.47559999f,0.75420004f,-1.36060000f,0.0f,0.0f,-0.76729997f,-0.24990004f,-1.43059995f,0.27529998f,0.0f,0.0f,-0.88369999f,-0.18100002f,0.31880001f,1.54870002f,0.0f,0.0f,1.24470001f,-0.58190006f,-0.97379997f,0.42830003f,0.0f,0.0f,0.52160000f,-1.02760000f,-0.97639993f,0.39209998f,0.0f,0.0f,0.29810007f,-0.78840003f,0.21200002f,0.16779998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.81830008f,1.73240002f,-0.09229989f,1.94930004f,0.0f,0.0f,0.21750002f,3.05720000f,0.67029993f,2.53340005f,0.0f,0.0f,-0.87610005f,-0.08529989f,-0.45629992f,-1.03989996f,0.0f,0.0f,-2.60900008f,-0.90579990f,-0.83779997f,2.84200011f,0.0f,0.0f,2.84500001f,-1.23180005f,1.24279993f,1.52990011f,0.0f,0.0f,1.15240002f,-4.84539994f,0.56119997f,-1.18359998f,0.0f,0.0f,-1.08839998f,1.02019989f,1.56000009f,1.12430007f,0.0f,0.0f,-0.94519995f,-4.53640000f,-0.78510000f,-0.73420009f,0.0f,0.0f,-4.42040003f,-1.29850003f,2.42650010f,-0.81039997f,0.0f,0.0f,-1.13960001f,-0.97700002f,0.03530006f,1.03110000f,0.0f,0.0f,-0.85209996f,-1.92129996f,2.42390006f,-2.46240006f,0.0f,0.0f,0.08339988f,-0.01479993f,0.36879995f,-1.85849999f,0.0f,0.0f,0.71489987f,-0.28389991f,1.91739996f,-0.84680010f,0.0f,0.0f,0.41939994f,-0.41019991f,1.00500002f,0.79910003f,0.0f,0.0f,1.56770001f,3.77300005f,0.85080012f,0.97689992f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.00610003f,0.84870001f,-0.19860003f,0.31680002f,0.0f,0.0f,-1.69370001f,-0.66529998f,1.40030006f,0.56670001f,0.0f,0.0f,0.62399997f,-0.43690002f,-0.76830000f,0.67400001f,0.0f,0.0f,0.08480004f,-2.87599999f,0.37859994f,-2.17560001f,0.0f,0.0f,-0.23629995f,-0.33189999f,-1.76399994f,-0.00160007f,0.0f,0.0f,0.67529991f,0.81359998f,0.38199993f,0.85189998f,0.0f,0.0f,-2.68199996f,-1.17340000f,0.58010001f,0.92759996f,0.0f,0.0f,-1.25869996f,0.49600002f,1.26979997f,-1.14509997f,0.0f,0.0f,1.92519991f,0.80650002f,-1.74529995f,-0.08729998f,0.0f,0.0f,0.84640007f,0.66390004f,-2.02459999f,2.20350001f,0.0f,0.0f,3.22640002f,1.02289997f,1.11029996f,-0.78659996f,0.0f,0.0f,0.89640000f,-0.49130000f,-1.00590001f,-0.14130004f,0.0f,0.0f,-1.28040004f,1.35789997f,1.13809997f,-0.22460004f,0.0f,0.0f,1.15620000f,-0.21129999f,-0.54120000f,1.72969999f,0.0f,0.0f,-2.04939994f,1.50759999f,-2.15349990f,-1.47819996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.29140008f,-1.49920000f,1.90020002f,0.17620007f,0.0f,0.0f,3.11790007f,1.60540008f,0.36309989f,0.70680003f,0.0f,0.0f,-1.01809993f,2.84920003f,1.97350002f,1.64220001f,0.0f,0.0f,1.60759996f,-0.44859991f,-2.64199998f,-1.44269990f,0.0f,0.0f,-0.63679993f,0.71680009f,0.79939993f,2.22629998f,0.0f,0.0f,-2.39880002f,-1.91080011f,0.52610006f,1.22560002f,0.0f,0.0f,3.03129997f,-0.20509990f,2.18690006f,-3.22940003f,0.0f,0.0f,1.75089991f,-0.68010007f,1.57630006f,-1.82270008f,0.0f,0.0f,-2.97280005f,2.14000001f,-4.10900005f,-2.81210002f,0.0f,0.0f,-2.01929993f,-3.30170003f,2.59770000f,-0.33600004f,0.0f,0.0f,0.51929999f,-1.79370005f,-0.85300004f,1.37620000f,0.0f,0.0f,0.16920000f,-1.48629997f,1.61649998f,-1.51489991f,0.0f,0.0f,0.90729998f,-0.11310004f,-3.03509994f,2.49169996f,0.0f,0.0f,1.82709997f,-1.28959994f,2.56189986f,2.27239997f,0.0f,0.0f,-0.65210011f,4.13559998f,1.50820010f,-2.47329999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.49840000f,-0.55800000f,-0.59549998f,-0.26580005f,0.0f,0.0f,2.52220002f,2.51009998f,-1.35470005f,-0.85750009f,0.0f,0.0f,-2.74149998f,0.43910003f,2.20170001f,-1.11930003f,0.0f,0.0f,-0.59980002f,2.06899998f,0.28479999f,2.42599993f,0.0f,0.0f,1.30399994f,0.67580003f,0.02149995f,0.76120001f,0.0f,0.0f,-0.71849997f,0.33359990f,-0.35049997f,1.08959996f,0.0f,0.0f,3.29609998f,1.42460005f,2.01030001f,-0.21229998f,0.0f,0.0f,0.20900005f,-2.09910005f,-0.03749998f,1.16619992f,0.0f,0.0f,-1.20569999f,-2.02959997f,1.49189994f,1.65559996f,0.0f,0.0f,-0.22649996f,-1.77600010f,-0.08270001f,0.06900001f,0.0f,0.0f,-0.95589996f,-0.57210001f,0.38039998f,0.92540007f,0.0f,0.0f,-1.11610003f,0.92409997f,1.15910006f,-0.43190005f,0.0f,0.0f,0.15280007f,-0.89399998f,0.06140002f,-3.22229985f,0.0f,0.0f,-2.62479999f,0.48700002f,3.15539997f,-2.86489999f,0.0f,0.0f,-0.68180006f,0.19780000f,3.83989993f,0.67179993f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.05200001f,-0.93809998f,0.51620001f,-0.46020000f,0.0f,0.0f,-1.05089995f,-2.10890000f,1.68889999f,-0.82059999f,0.0f,0.0f,0.91700012f,1.70080000f,0.82379995f,-0.31850002f,0.0f,0.0f,0.34849995f,-1.78180006f,1.01100008f,-1.90259994f,0.0f,0.0f,2.61470000f,0.95500019f,0.94320007f,-0.07820008f,0.0f,0.0f,-1.19439994f,-2.22010004f,-0.18819998f,4.54129995f,0.0f,0.0f,1.11430001f,-1.52269991f,-1.28570002f,-1.24210003f,0.0f,0.0f,-0.22189999f,-2.45260001f,-0.29709993f,1.90499999f,0.0f,0.0f,0.16779993f,3.04409990f,-0.95329999f,2.25819996f,0.0f,0.0f,-0.23709997f,-1.31369993f,-0.48790001f,-2.03400009f,0.0f,0.0f,-1.20340000f,-1.60769998f,-1.38920009f,-3.01370004f,0.0f,0.0f,-0.90659996f,-0.88020007f,-1.80290002f,-0.10630005f,0.0f,0.0f,-1.81769998f,-2.85880007f,0.22819989f,2.42280000f,0.0f,0.0f,0.00670004f,-0.58159999f,-5.00590012f,4.41600006f,0.0f,0.0f,0.42759993f,2.85210009f,0.15890004f,-2.09329991f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.41920002f,0.89540003f,0.02529997f,-0.68440000f,0.0f,0.0f,-0.29280003f,1.39449993f,0.45690001f,0.83269999f,0.0f,0.0f,1.12590002f,-1.06529998f,-0.08500000f,0.62860001f,0.0f,0.0f,-1.80010003f,-0.10920005f,1.54990006f,-3.21850001f,0.0f,0.0f,-0.03039994f,1.58929994f,-1.11410001f,1.06540005f,0.0f,0.0f,-2.11790005f,-2.77499999f,0.93719997f,3.19810002f,0.0f,0.0f,-2.65980003f,-1.55160006f,1.08050003f,2.33589997f,0.0f,0.0f,-1.68570001f,-4.54229997f,-2.06250000f,2.60990003f,0.0f,0.0f,-0.61880000f,0.86100000f,0.49220000f,0.99569997f,0.0f,0.0f,-2.15370000f,-0.63840002f,1.64229996f,2.49110002f,0.0f,0.0f,-1.81510008f,-3.52660008f,0.16500003f,-2.89869991f,0.0f,0.0f,-0.26759996f,-0.65869994f,2.02430004f,1.17830007f,0.0f,0.0f,-1.48310000f,-1.62410002f,0.89769998f,3.47719999f,0.0f,0.0f,-3.02199999f,-0.60230004f,2.97810007f,-1.54260003f,0.0f,0.0f,-0.12739993f,0.51170009f,1.34669997f,-0.54720005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.06120001f,-0.41079996f,0.05639999f,-0.34209995f,0.0f,0.0f,1.11030000f,-0.88860002f,0.39779998f,0.24450000f,0.0f,0.0f,1.89449995f,-0.41449997f,-0.10749999f,-1.68970000f,0.0f,0.0f,-1.78430004f,-1.18960010f,0.48669997f,0.51029993f,0.0f,0.0f,0.98870004f,3.98069995f,-0.83229996f,1.45480006f,0.0f,0.0f,-0.13280013f,0.46960008f,-2.00649997f,2.18609994f,0.0f,0.0f,-0.11609993f,1.34179993f,-0.89509999f,1.51949995f,0.0f,0.0f,-2.17359989f,-2.89460001f,-0.60559999f,-0.53150007f,0.0f,0.0f,-2.95109985f,-0.08989994f,0.55280000f,-3.91200001f,0.0f,0.0f,-1.53020007f,-0.21119993f,-1.26479992f,0.11370006f,0.0f,0.0f,1.03479991f,0.75020007f,1.53949998f,0.74840009f,0.0f,0.0f,4.52409997f,0.18509997f,0.71179992f,1.93880012f,0.0f,0.0f,0.09880003f,2.53879998f,-0.72730001f,-0.32850008f,0.0f,0.0f,-0.18659993f,2.53549992f,-1.30459991f,-1.89980005f,0.0f,0.0f,1.30130003f,3.82570006f,-0.05509992f,-0.11870008f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.08509995f,0.60419995f,-0.43969998f,-0.25860001f,0.0f,0.0f,-1.03059998f,0.36069997f,-0.65749998f,-0.15050002f,0.0f,0.0f,0.54390002f,1.14999998f,-0.44329998f,0.97309997f,0.0f,0.0f,-0.64040000f,-0.90609997f,0.16820001f,1.15140003f,0.0f,0.0f,-0.42729995f,-1.18709995f,-1.77100002f,1.62790003f,0.0f,0.0f,-1.13029997f,-1.67929993f,-1.78000001f,0.09139999f,0.0f,0.0f,-0.77939997f,-1.70509996f,-1.07330003f,2.41139996f,0.0f,0.0f,-0.16620005f,1.32100004f,-0.51360003f,0.20809993f,0.0f,0.0f,1.74959997f,1.56160004f,-2.61760003f,-0.95150005f,0.0f,0.0f,0.72220001f,-1.59990002f,-0.12019996f,-1.42020001f,0.0f,0.0f,-0.09769996f,-0.27319997f,-0.74579998f,-0.80430005f,0.0f,0.0f,-1.02289995f,1.60440001f,-1.18219998f,0.47329996f,0.0f,0.0f,-0.15199997f,-1.60579993f,0.29079999f,-0.68350005f,0.0f,0.0f,0.74890005f,-0.84919992f,0.80629995f,0.08839997f,0.0f,0.0f,1.50380001f,0.29019993f,-2.35380006f,-0.62840002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,2.37050005f,0.23310010f,-1.36360007f,1.08219999f,0.0f,0.0f,-1.49690008f,-2.26270004f,0.08790003f,-1.17289999f,0.0f,0.0f,-0.41599996f,0.27910003f,1.17739997f,-1.72349996f,0.0f,0.0f,1.92460006f,1.79680000f,-2.53640007f,0.44269995f,0.0f,0.0f,-0.04570004f,-2.58259997f,5.42420004f,-5.97889993f,0.0f,0.0f,2.68819997f,2.14989995f,1.54340005f,-2.12400003f,0.0f,0.0f,1.61029995f,0.30759996f,0.94729993f,-3.52129985f,0.0f,0.0f,5.27809998f,2.69829998f,4.98290007f,3.91969995f,0.0f,0.0f,0.43350001f,-0.97730006f,1.33510007f,2.40169992f,0.0f,0.0f,3.82569999f,-0.76360009f,-3.33619991f,-5.51009988f,0.0f,0.0f,1.93200012f,1.44490001f,-2.58869991f,3.09209996f,0.0f,0.0f,-2.03419996f,-1.51090007f,-0.94380005f,-0.81470002f,0.0f,0.0f,-0.89030000f,1.70840002f,0.89180002f,-2.04120007f,0.0f,0.0f,-0.17970019f,-0.26090000f,-2.56150001f,-0.83050004f,0.0f,0.0f,-0.40100004f,0.16989991f,-1.05980007f,0.36650006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.27730000f,0.34570001f,0.14569998f,-0.21529998f,0.0f,0.0f,0.47620000f,0.53809996f,0.69820000f,0.13859999f,0.0f,0.0f,-0.36520001f,0.29400002f,-0.65450000f,0.28719999f,0.0f,0.0f,-0.41319999f,0.27079992f,1.41300004f,0.51209999f,0.0f,0.0f,0.90800004f,2.70549997f,0.23160001f,-0.87980004f,0.0f,0.0f,0.08839998f,-1.59650003f,-0.19459997f,1.42089995f,0.0f,0.0f,-2.03759994f,2.18800002f,-1.10870001f,-0.25980000f,0.0f,0.0f,-0.02010004f,-2.04679998f,-1.62530000f,3.06659991f,0.0f,0.0f,-1.45909997f,-0.57249999f,0.86729994f,0.71830004f,0.0f,0.0f,-1.26900003f,0.35930006f,-0.20070001f,0.78159994f,0.0f,0.0f,-0.86129996f,-0.69349996f,-0.66230005f,-1.22039997f,0.0f,0.0f,0.57059995f,0.76080000f,1.60230002f,-0.67079996f,0.0f,0.0f,-2.30160000f,-0.76579999f,1.20559993f,2.29379998f,0.0f,0.0f,1.28219999f,-0.44039998f,-0.39699998f,-1.13499993f,0.0f,0.0f,-1.56069998f,0.48560011f,1.93640000f,0.53389996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.39910017f,1.75850003f,-1.46710005f,2.80700004f,0.0f,0.0f,0.66839995f,-1.98210008f,-0.10029998f,0.36030002f,0.0f,0.0f,0.43649993f,0.87400000f,-0.79049998f,-2.01930004f,0.0f,0.0f,-0.17840005f,-3.26759999f,-0.22250014f,-1.18449998f,0.0f,0.0f,0.98019999f,0.69179988f,2.46990005f,-0.95440000f,0.0f,0.0f,1.15450002f,3.11710001f,1.94370006f,-3.81890003f,0.0f,0.0f,4.43880001f,0.64179994f,2.45170002f,0.79020002f,0.0f,0.0f,1.14479999f,5.28170002f,2.12420001f,-1.70329997f,0.0f,0.0f,0.77259999f,-1.37040000f,-0.84729996f,-2.94519998f,0.0f,0.0f,-2.54429992f,4.31390005f,-1.51289998f,-1.23079994f,0.0f,0.0f,-1.62969985f,3.70050012f,2.24570004f,-0.10329998f,0.0f,0.0f,-1.85189990f,-0.83100001f,-0.56590013f,2.29300002f,0.0f,0.0f,0.85979995f,3.89839998f,-0.68959997f,-4.25260008f,0.0f,0.0f,-0.68460004f,3.20380009f,4.15639997f,-1.03129995f,0.0f,0.0f,-0.26580000f,0.45309995f,0.91400000f,-1.87079992f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.17619995f,-0.14860001f,-0.38749997f,1.32489997f,0.0f,0.0f,0.33710001f,-2.05499995f,-0.32140000f,-0.27529997f,0.0f,0.0f,-0.24919999f,0.24209998f,-0.06380001f,-0.87630000f,0.0f,0.0f,-0.82929995f,0.54539998f,-2.64620007f,1.77679999f,0.0f,0.0f,0.54529993f,0.25199999f,-0.32260003f,1.55319997f,0.0f,0.0f,0.40710004f,2.37470001f,-1.18759998f,-1.98300001f,0.0f,0.0f,1.63839995f,0.26769997f,-1.71269996f,-1.76669998f,0.0f,0.0f,-0.60639992f,3.26809999f,0.31789999f,-2.69089996f,0.0f,0.0f,0.73139997f,-0.67789995f,-0.79249992f,0.03420000f,0.0f,0.0f,0.35839997f,-1.23819995f,1.11230001f,0.39499998f,0.0f,0.0f,3.76789993f,1.48720006f,-0.37929992f,2.67669995f,0.0f,0.0f,1.77370002f,1.93249998f,-2.37230008f,0.51689996f,0.0f,0.0f,3.08869998f,0.55969996f,0.39460001f,-3.52860003f,0.0f,0.0f,0.71450000f,-0.42940000f,-2.38780000f,0.63540000f,0.0f,0.0f,1.93719991f,-1.53020005f,-2.09929997f,0.07690004f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_4d_4items_strided)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{4,3,3,5,8,7};
    Shape shape_b{4,3,2,2,3,1};
    Shape shape_r{4,4,1,4,2,4};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{2,1,3,2},        // move_strides
                                                                  Strides{1,1,1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0,0,0}, // below_pads
                                                                  CoordinateDiff{0,0,0,0}, // above_pads
                                                                  Strides{1,1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f,0.61000000f,0.17000000f,-0.91000000f,-0.48000000f,-0.48000000f,0.12000000f,-0.18000000f,0.08000000f,-0.16000000f,0.54000000f,-0.20000000f,-0.08000000f,0.19000000f,-0.81000000f,0.56000000f,-0.52000000f,0.32000000f,-0.37000000f,-0.17000000f,-0.46000000f,-0.34000000f,0.85000000f,0.11000000f,-0.10000000f,0.98000000f,-0.22000000f,0.68000000f,0.97000000f,-0.93000000f,-0.92000000f,0.32000000f,-0.19000000f,-0.61000000f,0.93000000f,0.54000000f,-0.75000000f,0.63000000f,0.38000000f,0.69000000f,-0.02000000f,0.19000000f,-0.38000000f,-0.44000000f,0.49000000f,-0.62000000f,-0.41000000f,-0.84000000f,0.93000000f,-0.74000000f,-0.57000000f,0.37000000f,-0.86000000f,-0.01000000f,0.58000000f,0.13000000f,-0.42000000f,0.68000000f,-0.05000000f,0.17000000f,0.09000000f,-0.67000000f,0.11000000f,-0.32000000f,0.08000000f,-0.29000000f,0.60000000f,0.69000000f,0.04000000f,0.85000000f,0.46000000f,0.41000000f,-0.78000000f,-0.98000000f,0.50000000f,-0.96000000f,-0.61000000f,-0.58000000f,0.00000000f,0.81000000f,-0.25000000f,-0.74000000f,-0.46000000f,-0.16000000f,0.32000000f,0.56000000f,-0.05000000f,-0.87000000f,0.59000000f,0.08000000f,-0.39000000f,0.67000000f,0.95000000f,0.70000000f,0.00000000f,-0.58000000f,0.85000000f,-0.14000000f,-0.27000000f,-0.63000000f,-0.75000000f,0.61000000f,-0.12000000f,-0.68000000f,-0.83000000f,0.12000000f,0.94000000f,-0.46000000f,0.27000000f,-0.14000000f,-0.96000000f,0.16000000f,-0.57000000f,0.92000000f,-0.24000000f,0.08000000f,0.60000000f,0.23000000f,-0.14000000f,-0.28000000f,0.14000000f,-0.19000000f,0.00000000f,-0.57000000f,0.18000000f,0.42000000f,0.17000000f,0.71000000f,-0.55000000f,0.89000000f,0.26000000f,-0.67000000f,0.68000000f,-0.75000000f,-0.62000000f,0.62000000f,-0.16000000f,-0.69000000f,-0.96000000f,-0.24000000f,0.00000000f,0.63000000f,-0.95000000f,-0.99000000f,0.06000000f,0.02000000f,-0.04000000f,0.95000000f,0.98000000f,0.13000000f,0.96000000f,-0.22000000f,-0.25000000f,-0.77000000f,-0.02000000f,-0.46000000f,0.28000000f,-0.61000000f,-0.56000000f,-0.65000000f,-0.23000000f,-0.41000000f,0.78000000f,-0.46000000f,0.44000000f,0.15000000f,0.46000000f,-0.90000000f,-0.25000000f,0.81000000f,0.28000000f,0.40000000f,0.56000000f,0.62000000f,-0.63000000f,-0.86000000f,-0.97000000f,0.22000000f,-0.58000000f,0.05000000f,0.53000000f,-0.38000000f,0.79000000f,0.60000000f,-0.63000000f,-0.18000000f,0.62000000f,-0.37000000f,0.48000000f,0.86000000f,0.70000000f,-0.52000000f,-0.39000000f,-0.44000000f,-0.69000000f,0.42000000f,-0.69000000f,0.48000000f,0.70000000f,-0.86000000f,-0.90000000f,0.69000000f,0.08000000f,-0.34000000f,-0.86000000f,0.66000000f,0.61000000f,0.47000000f,-0.22000000f,-0.51000000f,-0.29000000f,0.95000000f,-0.30000000f,-0.41000000f,0.85000000f,-0.13000000f,0.70000000f,-0.51000000f,-0.05000000f,-0.50000000f,-0.28000000f,-0.44000000f,0.33000000f,-0.08000000f,-0.88000000f,-0.64000000f,0.24000000f,-0.51000000f,0.67000000f,-0.40000000f,0.48000000f,0.92000000f,-0.64000000f,-0.42000000f,-0.62000000f,-0.77000000f,0.34000000f,0.29000000f,0.49000000f,0.82000000f,-0.30000000f,-0.40000000f,0.27000000f,0.61000000f,-0.75000000f,0.42000000f,0.69000000f,0.46000000f,0.41000000f,0.48000000f,0.14000000f,0.86000000f,-0.46000000f,-0.88000000f,-0.20000000f,-0.09000000f,-0.10000000f,0.70000000f,0.97000000f,-0.99000000f,0.53000000f,-0.51000000f,-0.70000000f,-0.96000000f,0.86000000f,-0.44000000f,-0.66000000f,-0.28000000f,0.08000000f,0.42000000f,-0.45000000f,-0.73000000f,-0.99000000f,-0.33000000f,0.40000000f,-0.86000000f,-0.84000000f,-0.06000000f,0.77000000f,0.96000000f,-0.06000000f,0.24000000f,0.21000000f,0.27000000f,-0.21000000f,-0.01000000f,0.16000000f,0.40000000f,0.06000000f,-0.61000000f,-0.66000000f,0.76000000f,0.43000000f,0.00000000f,0.37000000f,0.70000000f,-0.76000000f,0.50000000f,-0.38000000f,-0.24000000f,-0.80000000f,-0.66000000f,0.09000000f,-0.70000000f,0.83000000f,0.59000000f,-0.39000000f,-0.21000000f,0.84000000f,-0.17000000f,0.50000000f,-0.48000000f,-0.07000000f,-0.54000000f,-0.16000000f,0.99000000f,0.28000000f,0.29000000f,-0.68000000f,-0.49000000f,-0.18000000f,-0.41000000f,0.95000000f,0.72000000f,-0.26000000f,-0.42000000f,-0.27000000f,0.38000000f,-0.47000000f,0.24000000f,-0.38000000f,0.29000000f,0.34000000f,-0.30000000f,-0.64000000f,-0.27000000f,-0.27000000f,-0.94000000f,0.26000000f,0.52000000f,0.92000000f,0.53000000f,-0.80000000f,0.31000000f,0.29000000f,0.16000000f,-0.47000000f,0.61000000f,0.46000000f,-0.75000000f,-0.88000000f,0.95000000f,0.33000000f,-0.97000000f,-0.03000000f,0.43000000f,0.14000000f,0.73000000f,0.97000000f,-0.01000000f,0.45000000f,0.81000000f,0.77000000f,0.45000000f,0.16000000f,-0.66000000f,-0.29000000f,-0.23000000f,0.32000000f,0.22000000f,-0.09000000f,0.65000000f,-0.46000000f,0.65000000f,-0.01000000f,0.61000000f,-0.12000000f,0.36000000f,0.29000000f,-0.87000000f,-0.01000000f,-0.28000000f,-0.95000000f,0.37000000f,0.73000000f,-0.99000000f,0.47000000f,-0.69000000f,-0.31000000f,0.67000000f,-0.78000000f,-0.77000000f,-0.41000000f,0.95000000f,0.61000000f,0.52000000f,0.85000000f,-0.88000000f,0.97000000f,0.54000000f,0.53000000f,0.87000000f,-0.64000000f,-0.62000000f,0.70000000f,-0.11000000f,0.93000000f,-0.52000000f,-0.08000000f,0.03000000f,0.27000000f,-0.30000000f,-0.62000000f,0.00000000f,0.76000000f,0.12000000f,-0.83000000f,-0.60000000f,-0.95000000f,0.51000000f,0.85000000f,-0.27000000f,-0.83000000f,-0.20000000f,-0.45000000f,0.27000000f,-0.09000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.52000000f,-0.43000000f,-0.73000000f,-0.60000000f,-0.89000000f,0.15000000f,-0.12000000f,0.95000000f,0.97000000f,-0.43000000f,0.85000000f,0.43000000f,-0.35000000f,-0.44000000f,0.84000000f,0.94000000f,0.80000000f,-0.88000000f,-0.73000000f,-0.24000000f,0.93000000f,0.77000000f,0.15000000f,-0.63000000f,0.84000000f,0.70000000f,-0.24000000f,-0.01000000f,-0.63000000f,0.44000000f,0.50000000f,-0.29000000f,-0.27000000f,0.64000000f,0.28000000f,-0.18000000f,0.90000000f,-0.87000000f,-0.86000000f,-0.24000000f,0.66000000f,-0.49000000f,0.86000000f,0.19000000f,0.56000000f,-0.18000000f,-0.25000000f,-0.32000000f,-0.09000000f,0.83000000f,0.25000000f,0.92000000f,0.15000000f,0.71000000f,-0.91000000f,0.86000000f,-0.70000000f,0.05000000f,-0.23000000f,0.19000000f,0.32000000f,0.74000000f,-0.79000000f,-0.82000000f,0.44000000f,-0.91000000f,-0.61000000f,-0.99000000f,0.61000000f,-0.19000000f,0.14000000f,-0.46000000f,-0.33000000f,0.93000000f,0.29000000f,0.68000000f,-0.45000000f,0.47000000f,0.19000000f,-0.48000000f,0.03000000f,-0.10000000f,0.73000000f,-0.99000000f,0.72000000f,-0.58000000f,0.45000000f,-0.83000000f,0.07000000f,0.58000000f,0.02000000f,0.60000000f,0.71000000f,0.75000000f,-0.36000000f,0.19000000f,0.92000000f,-0.90000000f,-0.66000000f,0.57000000f,0.38000000f,0.86000000f,0.61000000f,0.31000000f,0.47000000f,-0.14000000f,-0.15000000f,0.27000000f,0.48000000f,0.44000000f,-0.45000000f,-0.83000000f,0.11000000f,0.96000000f,-0.38000000f,-0.12000000f,-0.72000000f,0.07000000f,-0.10000000f,-0.62000000f,0.21000000f,-0.33000000f,0.18000000f,0.18000000f,-0.50000000f,0.15000000f,0.38000000f,0.29000000f,-0.67000000f,-0.16000000f,-0.61000000f,0.36000000f,-0.50000000f,-0.87000000f,0.41000000f,0.41000000f,0.03000000f,0.71000000f,0.75000000f,-0.02000000f,0.13000000f,0.93000000f,0.51000000f,-0.86000000f,-0.43000000f,-0.97000000f,0.16000000f,-0.95000000f,-0.21000000f,-0.15000000f,-0.43000000f,0.53000000f,0.17000000f,0.18000000f,0.12000000f,-0.76000000f,0.56000000f,-0.71000000f,0.25000000f,-0.03000000f,-0.95000000f,0.65000000f,0.11000000f,0.29000000f,0.14000000f,0.04000000f,0.02000000f,-0.20000000f,-0.39000000f,0.23000000f,0.59000000f,0.07000000f,0.73000000f,-0.75000000f,0.67000000f,0.71000000f,-0.11000000f,-0.30000000f,0.26000000f,-0.93000000f,-0.01000000f,0.18000000f,-0.04000000f,-0.73000000f,-0.61000000f,-0.07000000f,0.00000000f,-0.68000000f,-0.58000000f,-0.95000000f,-0.51000000f,0.68000000f,-0.87000000f,0.07000000f,0.21000000f,0.87000000f,0.65000000f,-0.89000000f,0.57000000f,-0.48000000f,0.53000000f,-0.35000000f,-0.61000000f,-0.55000000f,0.62000000f,0.58000000f,-0.68000000f,-0.52000000f,0.33000000f,0.02000000f,0.74000000f,0.03000000f,0.44000000f,0.84000000f,-0.90000000f,-0.02000000f,-0.54000000f,0.55000000f,-0.24000000f,0.63000000f,0.31000000f,-0.67000000f,0.51000000f,0.67000000f,0.85000000f,0.68000000f,0.61000000f,0.04000000f,0.09000000f,0.70000000f,0.35000000f,-0.06000000f,-0.06000000f,-0.49000000f,0.81000000f,-0.24000000f,-0.70000000f,0.44000000f,0.18000000f,0.12000000f,0.17000000f,0.28000000f,0.26000000f,0.81000000f,-0.24000000f,-0.64000000f,0.32000000f,0.49000000f,-0.06000000f,0.13000000f,0.56000000f,-0.17000000f,-0.28000000f,-0.50000000f,0.89000000f,-0.20000000f,-0.34000000f,0.05000000f,0.71000000f,-0.09000000f,0.02000000f,-0.43000000f,-0.00000000f,-0.07000000f,0.25000000f,0.80000000f,0.18000000f,-0.37000000f,-0.16000000f,-0.42000000f,0.33000000f,0.76000000f,-0.81000000f,0.79000000f,0.88000000f,-0.62000000f,-0.49000000f,-0.79000000f,0.16000000f,0.19000000f,0.37000000f,-0.62000000f,-0.72000000f,-0.37000000f,0.39000000f,-0.84000000f,-0.13000000f,0.21000000f,0.88000000f,-0.80000000f,-0.06000000f,0.28000000f,-0.13000000f,-0.83000000f,-0.91000000f,-0.39000000f,0.19000000f,-0.71000000f,-0.08000000f,0.96000000f,0.89000000f,-0.60000000f,-0.79000000f,-0.13000000f,-0.00000000f,0.03000000f,0.97000000f,0.70000000f,-0.96000000f,-0.50000000f,-0.39000000f,0.13000000f,0.09000000f,0.29000000f,-0.43000000f,-0.40000000f,-0.83000000f,0.51000000f,-0.32000000f,-0.53000000f,0.07000000f,0.35000000f,0.43000000f,-0.65000000f,-0.94000000f,0.40000000f,-0.59000000f,0.80000000f,-0.15000000f,-0.22000000f,0.56000000f,0.90000000f,-0.82000000f,-0.74000000f,0.04000000f,-0.24000000f,-0.97000000f,0.96000000f,0.78000000f,0.29000000f,-0.44000000f,0.62000000f,0.92000000f,0.05000000f,-0.74000000f,-0.49000000f,-0.25000000f,0.34000000f,-0.99000000f,0.78000000f,-0.64000000f,0.09000000f,-0.51000000f,0.99000000f,-0.20000000f,0.95000000f,0.13000000f,-0.44000000f,-0.90000000f,-0.82000000f,0.84000000f,0.26000000f,-0.90000000f,0.97000000f,-0.09000000f,0.45000000f,-0.49000000f,0.29000000f,0.13000000f,0.37000000f,-0.03000000f,0.41000000f,-0.47000000f,0.25000000f,0.44000000f,0.31000000f,0.72000000f,0.09000000f,0.67000000f,0.76000000f,-0.79000000f,-0.99000000f,0.62000000f,-0.71000000f,-0.07000000f,0.63000000f,-0.02000000f,-0.28000000f,-0.02000000f,0.98000000f,0.28000000f,0.48000000f,-0.49000000f,0.32000000f,-0.11000000f,-0.45000000f,0.37000000f,-0.58000000f,-0.82000000f,-0.23000000f,-0.55000000f,-0.61000000f,-0.87000000f,-0.96000000f,-0.34000000f,-0.03000000f,-0.15000000f,-0.15000000f,-0.30000000f,-0.53000000f,0.83000000f,0.20000000f,-0.19000000f,-0.19000000f,0.23000000f,0.45000000f,0.50000000f,-0.67000000f,0.71000000f,-0.97000000f,0.42000000f,-0.33000000f,-0.88000000f,0.56000000f,0.78000000f,-0.09000000f,0.17000000f,0.77000000f,0.95000000f,-0.80000000f,-0.72000000f,0.23000000f,0.39000000f,-0.72000000f,-0.15000000f,-0.79000000f,-0.97000000f,0.97000000f,-0.20000000f,-0.56000000f,-0.95000000f,-0.65000000f,0.71000000f,-0.42000000f,0.10000000f,-0.58000000f,-0.14000000f,0.39000000f,-0.95000000f,-0.71000000f,-0.67000000f,0.62000000f,-0.10000000f,-0.11000000f,-0.76000000f,-0.30000000f,-0.62000000f,0.63000000f,-0.11000000f,-0.48000000f,0.37000000f,-0.08000000f,0.73000000f,-0.84000000f,-0.07000000f,-0.82000000f,-0.93000000f,0.63000000f,0.17000000f,-0.58000000f,-0.17000000f,0.83000000f,0.78000000f,-0.49000000f,-0.41000000f,0.29000000f,-0.90000000f,0.78000000f,-0.97000000f,-0.67000000f,0.47000000f,0.64000000f,-0.57000000f,0.89000000f,0.29000000f,-0.24000000f,0.75000000f,0.61000000f,0.45000000f,0.42000000f,0.16000000f,-0.75000000f,0.31000000f,0.66000000f,-0.04000000f,0.11000000f,-0.22000000f,-0.63000000f,-0.81000000f,0.48000000f,0.40000000f,-0.43000000f,0.37000000f,0.58000000f,0.18000000f,0.27000000f,-0.84000000f,0.31000000f,0.67000000f,-0.23000000f,0.74000000f,0.87000000f,-0.60000000f,-0.90000000f,-0.43000000f,0.07000000f,-0.58000000f,-0.01000000f,0.06000000f,-0.57000000f,-0.48000000f,-0.80000000f,0.30000000f,-0.69000000f,-0.37000000f,0.45000000f,0.85000000f,-0.17000000f,0.84000000f,-0.86000000f,0.36000000f,0.30000000f,0.49000000f,0.19000000f,-0.40000000f,-0.68000000f,-0.49000000f,0.61000000f,-0.07000000f,0.25000000f,-0.84000000f,0.42000000f,-0.23000000f,-0.28000000f,0.86000000f,-0.37000000f,0.13000000f,-0.29000000f,-0.93000000f,-0.28000000f,0.23000000f,0.25000000f,0.86000000f,0.33000000f,0.75000000f,0.75000000f,-0.61000000f,0.43000000f,0.09000000f,0.24000000f,-0.80000000f,-0.34000000f,-0.64000000f,0.25000000f,-0.07000000f,0.78000000f,0.29000000f,0.12000000f,0.28000000f,-0.72000000f,-0.72000000f,-0.70000000f,0.23000000f,-0.30000000f,-0.07000000f,-0.94000000f,0.97000000f,0.08000000f,-0.97000000f,0.20000000f,0.70000000f,0.38000000f,0.92000000f,-0.91000000f,-0.93000000f,-0.13000000f,0.05000000f,-0.56000000f,0.15000000f,-0.45000000f,-0.39000000f,-0.53000000f,0.25000000f,0.74000000f,0.85000000f,0.91000000f,0.25000000f,0.75000000f,0.32000000f,0.86000000f,0.99000000f,0.84000000f,0.17000000f,0.38000000f,0.16000000f,0.26000000f,0.37000000f,0.41000000f,-0.36000000f,-0.00000000f,-0.09000000f,0.70000000f,-0.40000000f,0.15000000f,0.76000000f,-0.17000000f,0.40000000f,-0.06000000f,0.14000000f,0.50000000f,-0.91000000f,0.44000000f,0.06000000f,0.30000000f,0.86000000f,0.45000000f,-0.88000000f,-0.06000000f,0.92000000f,-0.39000000f,0.83000000f,0.04000000f,-0.04000000f,0.70000000f,0.99000000f,-0.96000000f,0.02000000f,-0.45000000f,0.47000000f,0.71000000f,-0.50000000f,0.08000000f,0.98000000f,0.30000000f,-0.60000000f,-0.66000000f,0.66000000f,-0.51000000f,-0.86000000f,0.54000000f,0.51000000f,-0.36000000f,-0.48000000f,0.59000000f,-0.93000000f,0.64000000f,0.49000000f,0.23000000f,-0.72000000f,0.82000000f,-0.81000000f,-0.51000000f,-0.06000000f,0.58000000f,0.45000000f,-0.41000000f,-0.60000000f,-0.08000000f,-0.07000000f,0.47000000f,-0.48000000f,0.85000000f,-0.36000000f,-0.92000000f,0.48000000f,-0.36000000f,-0.09000000f,0.09000000f,-0.57000000f,-0.98000000f,0.67000000f,-0.53000000f,0.50000000f,-0.12000000f,-0.62000000f,-0.85000000f,0.37000000f,-0.98000000f,0.56000000f,0.65000000f,0.51000000f,0.54000000f,0.73000000f,-0.89000000f,0.07000000f,0.52000000f,0.92000000f,-0.26000000f,-0.93000000f,-0.82000000f,0.75000000f,0.96000000f,0.26000000f,-0.21000000f,-0.40000000f,-0.88000000f,-0.38000000f,-0.21000000f,-0.43000000f,-0.77000000f,0.48000000f,-0.95000000f,0.40000000f,0.43000000f,-0.24000000f,-0.72000000f,0.49000000f,-0.78000000f,0.82000000f,-0.21000000f,-0.15000000f,-0.56000000f,-0.94000000f,-0.51000000f,-0.10000000f,0.36000000f,0.68000000f,-0.78000000f,0.09000000f,-0.15000000f,-0.55000000f,0.21000000f,-0.11000000f,0.53000000f,-0.23000000f,-0.85000000f,-0.50000000f,0.66000000f,0.44000000f,0.47000000f,0.61000000f,0.22000000f,0.79000000f,0.71000000f,-0.91000000f,0.70000000f,-0.12000000f,-0.78000000f,0.45000000f,-0.40000000f,0.82000000f,0.27000000f,0.39000000f,0.87000000f,-0.23000000f,-0.37000000f,-0.78000000f,-0.19000000f,0.45000000f,0.29000000f,-0.45000000f,-0.30000000f,0.17000000f,-0.70000000f,0.09000000f,-0.85000000f,-0.67000000f,0.41000000f,0.37000000f,-0.12000000f,0.83000000f,0.92000000f,0.70000000f,-0.23000000f,0.62000000f,0.84000000f,0.13000000f,-0.36000000f,0.75000000f,-0.47000000f,-0.93000000f,0.00000000f,-0.71000000f,0.22000000f,-0.13000000f,-0.19000000f,-0.03000000f,-0.94000000f,-0.56000000f,-0.88000000f,-0.27000000f,-0.48000000f,0.98000000f,0.73000000f,0.87000000f,0.10000000f,0.04000000f,0.34000000f,0.51000000f,-0.95000000f,0.84000000f,0.17000000f,0.13000000f,-0.39000000f,0.37000000f,0.89000000f,-0.04000000f,-0.53000000f,-0.38000000f,0.00000000f,-0.00000000f,0.72000000f,0.08000000f,0.32000000f,0.69000000f,0.80000000f,0.00000000f,-0.12000000f,-0.79000000f,-0.75000000f,0.04000000f,-0.45000000f,0.08000000f,-0.96000000f,-0.95000000f,-0.44000000f,0.98000000f,0.10000000f,-0.28000000f,0.99000000f,-0.07000000f,0.53000000f,-0.86000000f,-0.01000000f,0.29000000f,-0.78000000f,-0.01000000f,0.22000000f,0.18000000f,-0.24000000f,-0.89000000f,0.12000000f,-0.67000000f,0.06000000f,-0.02000000f,-0.41000000f,-0.00000000f,0.91000000f,0.40000000f,-0.20000000f,0.25000000f,-0.08000000f,0.04000000f,0.42000000f,0.40000000f,0.39000000f,-0.22000000f,-0.23000000f,0.28000000f,0.48000000f,-0.72000000f,-0.85000000f,-0.22000000f,0.69000000f,-0.25000000f,-0.85000000f,-0.56000000f,0.80000000f,-0.91000000f,0.69000000f,-0.69000000f,0.86000000f,0.94000000f,0.87000000f,-0.47000000f,0.30000000f,-0.51000000f,-0.52000000f,0.74000000f,-0.43000000f,0.03000000f,-0.79000000f,0.76000000f,0.39000000f,0.00000000f,0.32000000f,-0.43000000f,-0.43000000f,-0.27000000f,0.08000000f,-0.20000000f,0.18000000f,0.01000000f,-0.12000000f,-0.22000000f,-0.64000000f,-0.56000000f,0.72000000f,-0.10000000f,-0.52000000f,-0.23000000f,0.93000000f,0.39000000f,0.14000000f,0.23000000f,0.81000000f,-0.37000000f,0.52000000f,-0.10000000f,-0.16000000f,-0.90000000f,0.35000000f,0.18000000f,-0.89000000f,0.72000000f,0.91000000f,-0.03000000f,-0.67000000f,0.43000000f,0.97000000f,-0.32000000f,-0.40000000f,0.85000000f,-0.25000000f,0.71000000f,-0.60000000f,0.71000000f,0.84000000f,0.20000000f,-0.97000000f,-0.66000000f,0.18000000f,0.71000000f,-0.29000000f,-0.73000000f,0.62000000f,0.76000000f,-0.12000000f,-0.80000000f,0.61000000f,0.38000000f,0.74000000f,0.44000000f,0.60000000f,0.23000000f,0.11000000f,-0.06000000f,-0.09000000f,-0.33000000f,-0.38000000f,0.17000000f,0.57000000f,0.91000000f,0.83000000f,0.89000000f,0.88000000f,0.83000000f,0.71000000f,0.97000000f,0.93000000f,0.23000000f,-0.36000000f,-0.21000000f,-0.77000000f,0.14000000f,0.52000000f,-0.48000000f,-0.21000000f,-0.86000000f,-0.39000000f,0.68000000f,0.46000000f,0.48000000f,0.09000000f,-0.10000000f,0.83000000f,0.63000000f,0.53000000f,0.40000000f,0.05000000f,-0.92000000f,0.61000000f,0.23000000f,0.23000000f,-0.49000000f,-0.12000000f,-0.88000000f,-0.03000000f,0.50000000f,-0.27000000f,0.44000000f,-0.59000000f,-0.50000000f,0.93000000f,-0.52000000f,-0.06000000f,-0.02000000f,0.57000000f,0.75000000f,0.56000000f,0.34000000f,-0.71000000f,-0.04000000f,-0.25000000f,0.81000000f,0.77000000f,-0.40000000f,0.69000000f,0.26000000f,0.86000000f,0.32000000f,0.69000000f,-0.64000000f,-0.75000000f,0.73000000f,-0.40000000f,-0.57000000f,0.95000000f,0.03000000f,-0.51000000f,0.15000000f,-0.25000000f,0.87000000f,0.23000000f,-0.61000000f,-0.37000000f,-0.44000000f,-0.04000000f,-0.84000000f,-0.07000000f,0.27000000f,-0.33000000f,0.68000000f,-0.59000000f,0.32000000f,0.06000000f,-0.80000000f,-0.47000000f,0.09000000f,-0.61000000f,-0.85000000f,-0.77000000f,0.78000000f,0.86000000f,-0.75000000f,-0.45000000f,-0.10000000f,-0.68000000f,-0.30000000f,-0.40000000f,0.83000000f,0.62000000f,0.97000000f,-0.71000000f,0.50000000f,-0.15000000f,-0.06000000f,0.99000000f,0.68000000f,-0.45000000f,0.81000000f,-0.82000000f,0.87000000f,-0.65000000f,-0.68000000f,-0.97000000f,0.68000000f,0.64000000f,0.19000000f,0.23000000f,0.51000000f,-0.96000000f,0.16000000f,0.05000000f,0.82000000f,-0.70000000f,0.08000000f,-0.13000000f,0.80000000f,0.87000000f,0.47000000f,0.27000000f,0.38000000f,0.27000000f,-0.61000000f,-0.63000000f,0.60000000f,0.91000000f,-0.03000000f,-0.65000000f,-0.26000000f,-0.59000000f,-0.08000000f,-0.00000000f,0.55000000f,-0.30000000f,0.28000000f,-0.81000000f,0.32000000f,-0.92000000f,-0.34000000f,0.55000000f,0.25000000f,-0.46000000f,0.93000000f,0.34000000f,0.69000000f,-0.59000000f,0.79000000f,0.95000000f,0.97000000f,0.91000000f,-0.53000000f,0.89000000f,0.29000000f,-0.23000000f,-0.49000000f,0.14000000f,-0.53000000f,0.22000000f,0.87000000f,0.10000000f,0.42000000f,0.31000000f,0.98000000f,-0.18000000f,-0.89000000f,-0.98000000f,-0.20000000f,0.31000000f,-0.54000000f,0.32000000f,-0.14000000f,0.16000000f,-0.24000000f,-0.77000000f,0.15000000f,0.76000000f,0.80000000f,0.70000000f,0.93000000f,-0.55000000f,0.25000000f,0.39000000f,0.16000000f,-0.80000000f,-0.64000000f,-0.51000000f,-0.48000000f,0.75000000f,0.50000000f,0.19000000f,-0.42000000f,-0.42000000f,0.75000000f,0.06000000f,0.61000000f,-0.75000000f,0.65000000f,0.27000000f,-0.72000000f,-0.20000000f,0.81000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.56000000f,-0.15000000f,-0.37000000f,0.38000000f,0.83000000f,-0.76000000f,-0.00000000f,-0.95000000f,0.99000000f,-0.51000000f,-0.06000000f,-0.47000000f,0.92000000f,0.03000000f,0.52000000f,-0.67000000f,0.73000000f,0.59000000f,-0.32000000f,-0.97000000f,0.41000000f,-0.37000000f,0.25000000f,0.77000000f,-0.40000000f,-0.01000000f,-0.95000000f,0.77000000f,-0.31000000f,-0.99000000f,-0.23000000f,-0.38000000f,-0.77000000f,-0.15000000f,-0.75000000f,-0.79000000f,0.85000000f,-0.56000000f,-0.80000000f,0.15000000f,0.75000000f,0.69000000f,-0.70000000f,-0.72000000f,-0.83000000f,0.16000000f,0.83000000f,0.95000000f,-0.33000000f,-0.16000000f,-0.56000000f,-0.36000000f,-0.94000000f,0.37000000f,0.51000000f,-0.95000000f,0.92000000f,-0.86000000f,0.88000000f,-0.63000000f,0.77000000f,0.12000000f,0.54000000f,0.99000000f,0.08000000f,0.38000000f,-0.42000000f,0.86000000f,-0.13000000f,0.45000000f,0.75000000f,0.10000000f,0.56000000f,0.78000000f,0.06000000f,-0.93000000f,0.77000000f,-0.47000000f,0.86000000f,-0.34000000f,-0.34000000f,0.61000000f,0.12000000f,-0.56000000f,0.64000000f,0.58000000f,-0.56000000f,0.32000000f,0.01000000f,-0.35000000f,0.10000000f,0.59000000f,-0.40000000f,0.19000000f,-0.02000000f,-0.53000000f,0.87000000f,-0.31000000f,-0.39000000f,0.80000000f,-0.53000000f,0.84000000f,0.69000000f,0.34000000f,0.46000000f,0.61000000f,-0.38000000f,0.85000000f,-0.38000000f,-0.90000000f,-0.57000000f,0.74000000f,0.21000000f,0.13000000f,-0.87000000f,-0.57000000f,-0.81000000f,-0.75000000f,-0.14000000f,0.99000000f,-0.49000000f,-0.65000000f,0.61000000f,-0.58000000f,-0.04000000f,-0.63000000f,-0.96000000f,-0.75000000f,-0.67000000f,-0.72000000f,-0.33000000f,0.50000000f,-0.01000000f,0.64000000f,0.97000000f,-0.08000000f,-0.34000000f,-0.84000000f,0.38000000f,-0.16000000f,0.42000000f,0.96000000f,0.80000000f,-0.53000000f,0.53000000f,0.51000000f,0.77000000f,-0.04000000f,-0.06000000f,0.65000000f,0.72000000f,0.82000000f,0.77000000f,-0.53000000f,-0.66000000f,-0.43000000f,0.95000000f,0.20000000f,0.14000000f,-0.27000000f,-0.13000000f,0.39000000f,-0.77000000f,0.07000000f,-0.14000000f,0.93000000f,0.69000000f,-0.03000000f,0.89000000f,0.51000000f,-0.40000000f,-0.68000000f,0.42000000f,-0.46000000f,-0.50000000f,0.15000000f,-0.81000000f,0.32000000f,-0.10000000f,0.26000000f,-0.10000000f,0.35000000f,-0.33000000f,0.70000000f,-0.35000000f,0.79000000f,0.97000000f,0.01000000f,-0.77000000f,-0.44000000f,-0.24000000f,-0.93000000f,0.21000000f,-0.74000000f,-0.64000000f,-0.25000000f,-0.90000000f,-0.26000000f,0.64000000f,-0.33000000f,0.82000000f,-0.12000000f,0.56000000f,-0.18000000f,-0.78000000f,-0.82000000f,-0.21000000f,-0.84000000f,-0.81000000f,-0.26000000f,0.20000000f,0.74000000f,-0.56000000f,0.86000000f,-0.17000000f,-0.36000000f,-0.02000000f,-0.16000000f,0.21000000f,0.61000000f,0.65000000f,-0.48000000f,0.04000000f,-0.38000000f,0.32000000f,-0.72000000f,0.22000000f,-0.16000000f,0.44000000f,0.25000000f,-0.51000000f,-0.64000000f,0.43000000f,0.72000000f,-0.88000000f,0.97000000f,-0.27000000f,0.40000000f,0.36000000f,0.49000000f,0.38000000f,-0.53000000f,-0.08000000f,-0.06000000f,0.69000000f,-0.27000000f,0.05000000f,0.72000000f,-0.48000000f,0.74000000f,0.80000000f,0.23000000f,0.00000000f,-0.49000000f,-0.85000000f,-0.30000000f,-0.43000000f,0.14000000f,-0.06000000f,0.03000000f,-0.83000000f,0.91000000f,-0.72000000f,0.27000000f,0.42000000f,-0.63000000f,-0.54000000f,0.92000000f,-0.87000000f,-0.49000000f,0.40000000f,0.60000000f,-0.24000000f,0.66000000f,-0.65000000f,-0.67000000f,0.15000000f,0.70000000f,0.89000000f,-0.13000000f,0.81000000f,-0.52000000f,-0.82000000f,-0.58000000f,-0.20000000f,0.08000000f,-0.51000000f,0.18000000f,0.99000000f,-0.80000000f,0.22000000f,-0.17000000f,-0.72000000f,-0.72000000f,0.39000000f,0.81000000f,-0.36000000f,0.92000000f,-0.63000000f,0.36000000f,0.21000000f,0.00000000f,-0.27000000f,-0.72000000f,-0.47000000f,-0.69000000f,0.93000000f,-0.60000000f,0.98000000f,-0.28000000f,-0.69000000f,0.24000000f,-0.32000000f,-0.13000000f,-0.37000000f,0.66000000f,-0.68000000f,0.82000000f,0.23000000f,-0.45000000f,0.19000000f,-0.02000000f,0.90000000f,-0.77000000f,-0.87000000f,0.94000000f,-0.53000000f,0.95000000f,0.90000000f,0.17000000f,0.80000000f,-0.86000000f,0.67000000f,0.58000000f,-0.27000000f,-0.87000000f,-0.15000000f,0.99000000f,-0.65000000f,0.08000000f,0.34000000f,-0.46000000f,-0.94000000f,0.78000000f,0.10000000f,-0.95000000f,0.54000000f,0.46000000f,0.89000000f,0.01000000f,-0.33000000f,0.43000000f,-0.19000000f,-0.87000000f,0.36000000f,0.84000000f,0.70000000f,-0.93000000f,-0.95000000f,0.86000000f,-0.33000000f,-0.60000000f,0.31000000f,0.70000000f,-0.39000000f,0.01000000f,-0.43000000f,-0.11000000f,-0.42000000f,-0.76000000f,0.72000000f,0.33000000f,0.40000000f,0.43000000f,-0.19000000f,-0.49000000f,0.24000000f,-0.45000000f,-0.02000000f,-0.12000000f,-0.50000000f,-0.74000000f,-0.53000000f,0.09000000f,0.39000000f,0.53000000f,0.02000000f,0.14000000f,0.40000000f,-0.81000000f,-0.28000000f,-0.32000000f,-0.00000000f,0.51000000f,0.54000000f,-0.12000000f,-0.30000000f,0.97000000f,-0.04000000f,-0.42000000f,-0.96000000f,-0.39000000f,0.81000000f,0.93000000f,-0.55000000f,0.46000000f,-0.79000000f,-0.99000000f,-0.53000000f,0.00000000f,-0.28000000f,0.08000000f,0.22000000f,0.34000000f,0.03000000f,-0.89000000f,0.36000000f,0.80000000f,-0.68000000f,0.50000000f,-0.08000000f,0.04000000f,0.98000000f,-0.36000000f,-0.97000000f,0.46000000f,-0.02000000f,-0.20000000f,0.66000000f,-0.67000000f,0.58000000f,0.46000000f,-0.14000000f,-0.74000000f,-0.68000000f,-0.22000000f,0.93000000f,-0.86000000f,-0.58000000f,0.66000000f,-0.03000000f,0.40000000f,0.60000000f,-0.65000000f,0.20000000f,0.96000000f,-0.04000000f,0.91000000f,0.95000000f,-0.19000000f,0.04000000f,0.89000000f,0.70000000f,-0.99000000f,0.27000000f,-0.55000000f,0.79000000f,0.99000000f,0.94000000f,-0.16000000f,0.16000000f,0.74000000f,-0.84000000f,-0.91000000f,-0.15000000f,0.70000000f,0.95000000f,-0.19000000f,-0.72000000f,0.23000000f,0.98000000f,-0.77000000f,-0.58000000f,-0.97000000f,0.20000000f,-0.89000000f,0.94000000f,-0.96000000f,0.78000000f,0.17000000f,0.51000000f,0.91000000f,-0.58000000f,-0.90000000f,-0.48000000f,0.03000000f,0.06000000f,-0.58000000f,0.67000000f,0.70000000f,-0.68000000f,0.13000000f,-0.02000000f,0.04000000f,-0.33000000f,0.64000000f,-0.72000000f,0.01000000f,0.71000000f,0.37000000f,0.31000000f,-0.39000000f,0.91000000f,0.19000000f,-0.34000000f,0.45000000f,-0.68000000f,-0.26000000f,-0.78000000f,-0.74000000f,0.43000000f,-0.05000000f,-0.29000000f,-0.98000000f,-0.07000000f,0.61000000f,-0.93000000f,0.05000000f,-0.44000000f,0.44000000f,0.89000000f,-0.08000000f,0.19000000f,0.95000000f,0.90000000f,0.63000000f,0.25000000f,0.09000000f,0.90000000f,-0.66000000f,0.62000000f,0.72000000f,-0.28000000f,0.76000000f,-0.90000000f,0.37000000f,-0.25000000f,0.60000000f,0.92000000f,-0.75000000f,0.86000000f,-0.79000000f,0.17000000f,-0.11000000f,-0.21000000f,-0.99000000f,-0.41000000f,0.18000000f,-0.59000000f,-0.04000000f,0.92000000f,-0.20000000f,-0.82000000f,0.70000000f,0.18000000f,-0.08000000f,0.04000000f,0.84000000f,-0.48000000f,-0.46000000f,-0.94000000f,-0.55000000f,0.64000000f,0.10000000f,-0.74000000f,-0.66000000f,-0.16000000f,0.52000000f,0.33000000f,-0.41000000f,0.24000000f,0.94000000f,0.22000000f,-0.04000000f,-0.90000000f,0.91000000f,0.13000000f,0.46000000f,0.18000000f,-0.33000000f,-0.48000000f,-0.92000000f,-0.54000000f,-0.90000000f,-0.20000000f,0.58000000f,-0.45000000f,-0.52000000f,-0.50000000f,-0.42000000f,-0.18000000f,-0.49000000f,-0.71000000f,0.61000000f,-0.32000000f,0.82000000f,-0.17000000f,-0.82000000f,0.37000000f,-0.73000000f,-0.22000000f,0.97000000f,0.79000000f,0.43000000f,0.75000000f,0.82000000f,-0.88000000f,0.15000000f,0.04000000f,0.50000000f,-0.21000000f,-0.38000000f,0.63000000f,-0.45000000f,-0.39000000f,0.34000000f,0.20000000f,-0.46000000f,-0.24000000f,-0.44000000f,-0.82000000f,0.63000000f,-0.36000000f,-0.03000000f,-0.20000000f,-0.31000000f,-0.51000000f,-0.44000000f,0.03000000f,-0.28000000f,0.86000000f,-0.98000000f,0.67000000f,-0.01000000f,0.37000000f,-0.58000000f,0.83000000f,-0.71000000f,0.88000000f,0.94000000f,-0.97000000f,-0.02000000f,0.53000000f,-0.47000000f,0.43000000f,0.45000000f,0.66000000f,-0.41000000f,0.01000000f,0.66000000f,-0.73000000f,0.98000000f,-0.51000000f,-0.25000000f,0.10000000f,0.86000000f,-0.61000000f,-0.38000000f,0.24000000f,-0.37000000f,-0.76000000f,0.10000000f,0.41000000f,-0.40000000f,0.45000000f,-0.94000000f,0.06000000f,-0.34000000f,-0.77000000f,-0.49000000f,0.10000000f,0.60000000f,0.59000000f,-0.18000000f,-0.29000000f,0.16000000f,0.66000000f,-0.79000000f,0.31000000f,-0.15000000f,-0.36000000f,0.28000000f,-0.83000000f,-0.40000000f,0.79000000f,-0.79000000f,0.01000000f,-0.10000000f,-0.89000000f,0.89000000f,-0.73000000f,-0.94000000f,-0.25000000f,0.90000000f,0.02000000f,0.87000000f,-0.72000000f,0.14000000f,0.01000000f,0.14000000f,0.33000000f,0.70000000f,-0.23000000f,0.31000000f,0.47000000f,-0.99000000f,0.74000000f,-0.94000000f,-0.18000000f,0.29000000f,0.74000000f,0.41000000f,-0.62000000f,-0.55000000f,-0.23000000f,-0.92000000f,-0.83000000f,-0.04000000f,0.62000000f,-0.21000000f,0.18000000f,0.54000000f,0.10000000f,0.01000000f,-0.56000000f,0.20000000f,-0.27000000f,0.95000000f,-0.72000000f,-0.81000000f,-0.37000000f,0.04000000f,0.35000000f,-0.43000000f,0.74000000f,0.96000000f,-0.39000000f,-0.25000000f,0.84000000f,-0.96000000f,0.63000000f,-0.21000000f,0.38000000f,0.08000000f,-0.30000000f,-0.96000000f,0.62000000f,0.52000000f,0.88000000f,0.24000000f,0.20000000f,-0.98000000f,-0.19000000f,0.73000000f,-0.92000000f,-0.26000000f,0.98000000f,0.23000000f,0.02000000f,-0.56000000f,-0.67000000f,0.84000000f,0.80000000f,-0.99000000f,0.90000000f,0.08000000f,0.54000000f,-0.42000000f,0.12000000f,0.61000000f,-0.37000000f,-0.33000000f,0.96000000f,0.77000000f,-0.97000000f,0.69000000f,-0.03000000f,0.32000000f,-0.05000000f,0.38000000f,-0.13000000f,-0.67000000f,-0.29000000f,0.78000000f,0.49000000f,0.06000000f,-0.80000000f,-0.11000000f,0.67000000f,0.22000000f,-0.76000000f,-0.30000000f,-0.78000000f,0.35000000f,0.64000000f,-0.14000000f,-0.56000000f,0.01000000f,-0.67000000f,-0.73000000f,-0.00000000f,0.49000000f,0.49000000f,-0.48000000f,-0.61000000f,0.93000000f,-0.05000000f,0.14000000f,0.47000000f,-0.07000000f,0.83000000f,0.97000000f,0.07000000f,-0.41000000f,-0.19000000f,0.17000000f,0.62000000f,0.58000000f,-0.37000000f,0.48000000f,-0.62000000f,-0.36000000f,0.94000000f,0.07000000f,-0.83000000f,0.49000000f,-0.81000000f,-0.77000000f,-0.21000000f,0.15000000f,-0.48000000f,-0.65000000f,0.88000000f,0.58000000f,0.74000000f,-0.88000000f,-0.78000000f,0.70000000f,-0.18000000f,0.37000000f,-0.84000000f,-0.49000000f,-0.39000000f,0.98000000f,0.06000000f,0.25000000f,0.97000000f,0.39000000f,0.38000000f,-0.67000000f,-0.52000000f,0.65000000f,-0.66000000f,-0.53000000f,0.38000000f,-0.30000000f,-0.51000000f,0.07000000f,-0.07000000f,0.01000000f,0.73000000f,0.38000000f,0.47000000f,-0.56000000f,0.44000000f,0.78000000f,-0.98000000f,-0.99000000f,-0.31000000f,-0.72000000f,0.91000000f,0.18000000f,-0.84000000f,-0.40000000f,-0.53000000f,0.33000000f,0.13000000f,0.37000000f,0.01000000f,0.81000000f,0.00000000f,-0.19000000f,-0.02000000f,-0.73000000f,0.65000000f,0.84000000f,-0.01000000f,0.16000000f,-0.07000000f,0.64000000f,0.22000000f,0.06000000f,0.49000000f,-0.28000000f,-0.84000000f,0.81000000f,-0.94000000f,0.32000000f,-0.07000000f,0.09000000f,0.95000000f,0.99000000f,-0.56000000f,0.64000000f,0.83000000f,0.51000000f,-0.93000000f,0.18000000f,-0.50000000f,0.38000000f,-0.07000000f,0.93000000f,0.63000000f,-0.29000000f,0.87000000f,-0.04000000f,0.63000000f,0.70000000f,-0.76000000f,0.02000000f,0.02000000f,-0.88000000f,-0.63000000f,-0.18000000f,-0.30000000f,-0.48000000f,-0.42000000f,0.93000000f,0.01000000f,0.36000000f,0.97000000f,-0.25000000f,0.93000000f,0.16000000f,0.46000000f,-0.31000000f,-0.32000000f,0.20000000f,0.43000000f,-0.93000000f,0.09000000f,0.97000000f,0.53000000f,-0.86000000f,-0.33000000f,0.77000000f,0.58000000f,-0.11000000f,0.55000000f,0.94000000f,-0.42000000f,-0.48000000f,0.05000000f,0.15000000f,0.58000000f,-0.59000000f,-0.41000000f,-0.53000000f,0.05000000f,0.96000000f,0.00000000f,0.60000000f,0.56000000f,-0.18000000f,0.49000000f,-0.44000000f,0.47000000f,-0.67000000f,-0.85000000f,0.91000000f,-0.28000000f,-0.17000000f,0.62000000f,-0.96000000f,0.81000000f,0.12000000f,0.54000000f,-0.52000000f,-0.12000000f,-0.28000000f,0.82000000f,0.02000000f,-0.11000000f,-0.51000000f,-0.45000000f,0.20000000f,0.69000000f,0.07000000f,0.48000000f,-0.48000000f,-0.01000000f,0.33000000f,0.64000000f,0.15000000f,-0.79000000f,-0.11000000f,0.28000000f,0.48000000f,0.58000000f,0.95000000f,-0.89000000f,0.01000000f,-0.16000000f,-0.66000000f,-0.92000000f,0.89000000f,-0.34000000f,0.50000000f,-0.28000000f,0.08000000f,-0.74000000f,0.29000000f,-0.02000000f,0.68000000f,0.15000000f,0.95000000f,0.21000000f,-0.58000000f,-0.11000000f,0.64000000f,0.73000000f,0.87000000f,-0.96000000f,-0.64000000f,-0.60000000f,-0.79000000f,0.35000000f,-0.54000000f,-0.65000000f,0.14000000f,-0.48000000f,0.02000000f,0.36000000f,-0.45000000f,0.07000000f,0.58000000f,0.62000000f,0.73000000f,-0.92000000f,0.71000000f,-0.73000000f,-0.58000000f,-0.10000000f,0.95000000f,-0.81000000f,0.05000000f,-0.40000000f,-0.70000000f,0.03000000f,-0.45000000f,0.88000000f,-0.89000000f,0.37000000f,-0.30000000f,-0.37000000f,0.07000000f,0.28000000f,-0.11000000f,-0.38000000f,0.32000000f,0.78000000f,0.21000000f,0.43000000f,0.77000000f,-0.57000000f,0.40000000f,-0.93000000f,0.16000000f,-0.66000000f,-0.66000000f,-0.82000000f,-0.13000000f,-0.69000000f,0.77000000f,0.54000000f,0.69000000f,-0.54000000f,0.29000000f,-0.77000000f,0.14000000f,0.25000000f,-0.14000000f,-0.98000000f,0.36000000f,0.00000000f,-0.17000000f,-0.07000000f,-0.25000000f,0.25000000f,-0.30000000f,-0.53000000f,0.79000000f,0.08000000f,-0.80000000f,-0.05000000f,-0.87000000f,0.22000000f,0.35000000f,0.32000000f,0.09000000f,-0.44000000f,-0.82000000f,0.77000000f,-0.17000000f,0.47000000f,-0.89000000f,-0.83000000f,0.33000000f,0.20000000f,0.93000000f,-0.44000000f,0.89000000f,-0.27000000f,-0.95000000f,0.03000000f,-0.23000000f,0.34000000f,0.35000000f,-0.22000000f,0.56000000f,-0.36000000f,0.20000000f,0.86000000f,-0.18000000f,-0.11000000f,-0.27000000f,-0.87000000f,-0.52000000f,-0.85000000f,-0.71000000f,-0.07000000f,-0.42000000f,-0.73000000f,-0.72000000f,-0.45000000f,0.21000000f,0.22000000f,0.35000000f,-0.67000000f,0.47000000f,-0.17000000f,-0.72000000f,-0.48000000f,0.64000000f,0.68000000f,-0.06000000f,-0.60000000f,-0.82000000f,0.84000000f,0.16000000f,0.49000000f,-0.16000000f,-0.57000000f,-0.16000000f,-0.86000000f,0.05000000f,-0.91000000f,-0.02000000f,0.11000000f,0.91000000f,0.64000000f,-0.68000000f,0.93000000f,-0.25000000f,-0.46000000f,0.70000000f,0.87000000f,0.97000000f,-0.75000000f,0.73000000f,-0.70000000f,0.63000000f,-0.08000000f,0.94000000f,0.84000000f,-0.55000000f,0.29000000f,-0.75000000f,-0.18000000f,0.15000000f,0.41000000f,0.33000000f,0.81000000f,-0.95000000f,-0.12000000f,-0.47000000f,0.19000000f,-0.12000000f,-0.49000000f,0.34000000f,0.23000000f,0.36000000f,0.51000000f,-0.45000000f,-0.97000000f,0.09000000f,-0.47000000f,0.54000000f,0.32000000f,0.46000000f,0.90000000f,-0.58000000f,-0.87000000f,-0.48000000f,-0.91000000f,-0.72000000f,-0.19000000f,-0.93000000f,0.30000000f,0.91000000f,-0.78000000f,-0.46000000f,0.19000000f,0.90000000f,-0.22000000f,-0.43000000f,0.56000000f,-0.42000000f,0.99000000f,-0.46000000f,0.18000000f,-0.75000000f,-0.77000000f,0.85000000f,-0.99000000f,0.10000000f,-0.92000000f,0.68000000f,-0.07000000f,-0.81000000f,-0.57000000f,-0.57000000f,-0.31000000f,0.74000000f,-0.01000000f,0.38000000f,0.00000000f,0.05000000f,-0.85000000f,-0.28000000f,0.91000000f,-0.78000000f,0.53000000f,0.02000000f,-0.12000000f,-0.90000000f,0.21000000f,-0.22000000f,-0.01000000f,-0.87000000f,0.45000000f,-0.37000000f,0.09000000f,0.90000000f,0.15000000f,-0.14000000f,0.66000000f,0.32000000f,0.18000000f,0.87000000f,0.74000000f,-0.35000000f,0.95000000f,0.23000000f,-0.89000000f,-0.81000000f,0.95000000f,0.96000000f,-0.43000000f,0.57000000f,-0.16000000f,-0.82000000f,-0.00000000f,-0.64000000f,0.18000000f,0.01000000f,0.19000000f,-0.90000000f,-0.55000000f,0.31000000f,0.41000000f,-0.41000000f,-0.31000000f,-0.32000000f,-0.65000000f,0.08000000f,0.77000000f,0.24000000f,-0.26000000f,0.39000000f,-0.72000000f,0.75000000f,-0.49000000f,0.19000000f,0.58000000f,0.55000000f,-0.71000000f,-0.12000000f,0.96000000f,-0.78000000f,0.73000000f,0.10000000f,-0.31000000f,0.25000000f,0.78000000f,-0.70000000f,-0.11000000f,-0.87000000f,-0.00000000f,0.66000000f,0.26000000f,0.80000000f,-0.21000000f,-0.94000000f,-0.99000000f,0.94000000f,0.78000000f,0.97000000f,-0.41000000f,-0.27000000f,0.23000000f,-0.20000000f,-0.32000000f,-0.86000000f,0.51000000f,0.67000000f,0.95000000f,0.71000000f,-0.63000000f,-0.26000000f,-0.20000000f,0.79000000f,0.34000000f,0.42000000f,0.27000000f,-0.49000000f,0.99000000f,0.59000000f,-0.09000000f,-0.23000000f,-0.10000000f,0.11000000f,-0.37000000f,-0.99000000f,0.73000000f,0.81000000f,-0.38000000f,-0.57000000f,0.90000000f,0.85000000f,-0.21000000f,-0.73000000f,0.74000000f,0.42000000f,-0.77000000f,-0.04000000f,0.16000000f,0.88000000f,-0.27000000f,-0.34000000f,-0.83000000f,-0.91000000f,-0.47000000f,0.18000000f,-0.06000000f,0.40000000f,-0.10000000f,-0.74000000f,-0.45000000f,-0.24000000f,-0.27000000f,-0.44000000f,-0.49000000f,-0.96000000f,-0.46000000f,-0.12000000f,0.76000000f,0.75000000f,-0.11000000f,-0.96000000f,0.54000000f,0.00000000f,-0.26000000f,0.81000000f,0.79000000f,0.67000000f,0.20000000f,0.69000000f,0.68000000f,0.01000000f,0.17000000f,-0.84000000f,-0.28000000f,-0.05000000f,0.49000000f,0.09000000f,0.12000000f,-0.30000000f,-0.02000000f,-0.02000000f,-0.62000000f,-0.12000000f,0.76000000f,-0.24000000f,0.86000000f,0.36000000f,0.36000000f,0.25000000f,-0.34000000f,-0.57000000f,0.92000000f,-0.72000000f,0.05000000f,0.76000000f,-0.36000000f,-0.54000000f,-0.03000000f,-0.66000000f,-0.95000000f,0.52000000f,0.87000000f,0.11000000f,0.17000000f,-0.88000000f,-0.37000000f,-0.13000000f,0.18000000f,0.03000000f,0.50000000f,0.59000000f,-0.15000000f,0.36000000f,0.72000000f,0.49000000f,0.62000000f,-0.12000000f,-0.69000000f,0.15000000f,0.80000000f,0.63000000f,-0.97000000f,0.19000000f,0.59000000f,0.38000000f,-0.14000000f,-0.72000000f,-0.71000000f,-0.08000000f,-0.36000000f,-0.23000000f,0.56000000f,0.34000000f,0.14000000f,0.68000000f,-0.90000000f,-0.15000000f,0.32000000f,0.08000000f,-0.87000000f,-0.89000000f,-0.93000000f,0.39000000f,0.30000000f,0.54000000f,-0.86000000f,-0.32000000f,-0.45000000f,-0.09000000f,-0.10000000f,0.37000000f,0.18000000f,-0.83000000f,-0.38000000f,-0.53000000f,-0.67000000f,0.98000000f,-0.29000000f,-0.03000000f,-0.30000000f,0.90000000f,-0.58000000f,0.39000000f,-0.29000000f,0.10000000f,0.11000000f,0.04000000f,0.80000000f,0.21000000f,0.08000000f,0.00000000f,0.50000000f,-0.25000000f,0.75000000f,0.26000000f,0.28000000f,0.26000000f,-0.59000000f,0.56000000f,0.68000000f,0.02000000f,0.55000000f,0.81000000f,-0.78000000f,0.14000000f,0.90000000f,-0.15000000f,0.48000000f,-0.74000000f,-0.61000000f,0.31000000f,0.72000000f,-0.82000000f,0.28000000f,0.27000000f,0.82000000f,-0.67000000f,0.90000000f,-0.88000000f,0.56000000f,-0.29000000f,0.05000000f,-0.46000000f,0.67000000f,-0.21000000f,-0.33000000f,0.28000000f,0.43000000f,-0.95000000f,0.88000000f,0.97000000f,0.41000000f,-0.68000000f,0.30000000f,0.04000000f,-0.77000000f,0.14000000f,-0.67000000f,-0.96000000f,0.01000000f,-0.92000000f,-0.55000000f,0.44000000f,-0.70000000f,-0.70000000f,0.37000000f,-0.07000000f,0.39000000f,-0.12000000f,-0.27000000f,-0.71000000f,0.06000000f,0.28000000f,0.92000000f,-0.79000000f,-0.82000000f,0.52000000f,0.26000000f,-0.21000000f,0.82000000f,-0.49000000f,0.88000000f,0.47000000f,0.45000000f,0.31000000f,0.44000000f,-0.98000000f,-0.23000000f,0.44000000f,0.13000000f,0.61000000f,-0.20000000f,-0.23000000f,-0.61000000f,-0.34000000f,0.35000000f,0.56000000f,-0.16000000f,0.57000000f,-0.46000000f,-0.56000000f,-0.92000000f,-0.31000000f,0.97000000f,-0.25000000f,-0.48000000f,-0.94000000f,0.74000000f,0.02000000f,-0.61000000f,-0.71000000f,0.57000000f,0.77000000f,0.33000000f,-0.52000000f,0.38000000f,0.78000000f,-0.79000000f,0.20000000f,-0.52000000f,0.44000000f,-0.45000000f,-0.36000000f,-0.93000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.84000000f,-0.83000000f,-0.72000000f,0.39000000f,0.32000000f,-0.87000000f,0.58000000f,-0.47000000f,0.08000000f,0.08000000f,-0.55000000f,0.22000000f,0.63000000f,0.21000000f,-0.15000000f,0.08000000f,-0.79000000f,-0.42000000f,0.49000000f,-0.89000000f,0.14000000f,-0.24000000f,-0.42000000f,0.34000000f,-0.20000000f,-0.26000000f,0.90000000f,0.98000000f,0.89000000f,-0.73000000f,-0.21000000f,-0.73000000f,0.36000000f,-0.51000000f,0.56000000f,-0.67000000f,0.65000000f,0.82000000f,0.39000000f,0.18000000f,0.76000000f,-0.26000000f,-0.75000000f,-0.83000000f,-0.94000000f,-0.04000000f,-0.80000000f,-0.89000000f,0.68000000f,-0.48000000f,-0.50000000f,0.75000000f,0.22000000f,0.87000000f,-0.06000000f,0.40000000f,-0.40000000f,-0.13000000f,0.17000000f,-0.01000000f,-0.40000000f,0.75000000f,0.42000000f,0.77000000f,0.28000000f,-0.41000000f,0.12000000f,0.55000000f,0.72000000f,-0.48000000f,-0.71000000f,0.75000000f,-0.18000000f,-0.51000000f,0.55000000f,0.35000000f,0.57000000f,0.03000000f,0.86000000f,0.52000000f,0.71000000f,0.50000000f,-0.25000000f,0.83000000f,0.57000000f,-0.51000000f,0.81000000f,0.03000000f,-0.81000000f,-0.78000000f,-0.70000000f,0.27000000f,0.55000000f,0.62000000f,0.55000000f,0.68000000f,-0.05000000f,-0.73000000f,-0.28000000f,0.24000000f,-0.33000000f,0.59000000f,-0.89000000f,0.78000000f,-0.91000000f,-0.77000000f,0.11000000f,-0.73000000f,0.57000000f,-0.26000000f,-0.25000000f,0.80000000f,0.47000000f,-0.09000000f,0.71000000f,0.15000000f,0.56000000f,0.27000000f,0.11000000f,-0.27000000f,-0.69000000f,0.45000000f,0.23000000f,0.87000000f,-0.35000000f,-0.31000000f,0.73000000f,-0.30000000f,-0.65000000f,0.36000000f,0.52000000f,-0.80000000f,0.62000000f,0.25000000f,0.31000000f,-0.42000000f,-0.32000000f,0.83000000f,-0.59000000f,-0.22000000f,-0.61000000f,-0.35000000f,-0.60000000f,-0.89000000f,-0.46000000f,-0.38000000f,-0.69000000f,-0.99000000f,0.87000000f,-0.04000000f,0.47000000f,0.31000000f,-0.07000000f,-0.64000000f,0.30000000f,-0.09000000f,-0.57000000f,0.28000000f,0.39000000f,0.75000000f,-0.44000000f,-0.50000000f,0.97000000f,0.74000000f,-0.86000000f,0.59000000f,0.28000000f,-0.48000000f,-0.96000000f,0.59000000f,0.17000000f,0.43000000f,0.84000000f,-0.80000000f,0.14000000f,0.10000000f,-0.25000000f,-0.99000000f,-0.89000000f,0.12000000f,-0.67000000f,-0.24000000f,0.65000000f,-0.20000000f,-0.73000000f,0.66000000f,0.80000000f,-0.46000000f,-0.32000000f,-0.60000000f,0.79000000f,-0.99000000f,0.22000000f,0.30000000f,-0.33000000f,0.49000000f,0.71000000f,-0.59000000f,-0.47000000f,-0.36000000f,0.93000000f,0.67000000f,-0.66000000f,-0.48000000f,0.04000000f,-0.11000000f,0.22000000f,0.55000000f,0.31000000f,0.26000000f,0.17000000f,-0.12000000f,0.39000000f,0.40000000f,-0.13000000f,0.44000000f,-0.36000000f,0.81000000f,0.69000000f,-0.47000000f,-0.07000000f,-0.94000000f,-0.06000000f,0.45000000f,-0.47000000f,0.12000000f,0.30000000f,0.81000000f,-0.50000000f,0.64000000f,0.56000000f,-0.01000000f,0.43000000f,-0.24000000f,0.45000000f,-0.30000000f,0.56000000f,-0.13000000f,0.44000000f,-0.17000000f,0.17000000f,0.76000000f,-0.32000000f,-0.49000000f,-0.13000000f,0.07000000f,-0.43000000f,-0.50000000f,-0.80000000f,-0.07000000f,-0.13000000f,0.93000000f,0.13000000f,-0.29000000f,-0.39000000f,0.53000000f,-0.89000000f,0.67000000f,0.25000000f,0.42000000f,-0.29000000f,0.48000000f,-0.37000000f,0.99000000f,0.99000000f,-0.12000000f,0.36000000f,0.64000000f,-0.79000000f,0.85000000f,-0.97000000f,-0.01000000f,-0.51000000f,-0.54000000f,-0.02000000f,-0.79000000f,-0.70000000f,-0.61000000f,0.24000000f,-0.12000000f,0.82000000f,0.18000000f,-0.91000000f,-0.83000000f,-0.90000000f,-0.32000000f,-0.14000000f,0.51000000f,0.05000000f,-0.63000000f,0.49000000f,0.57000000f,-0.31000000f,-0.97000000f,0.77000000f,-0.48000000f,0.05000000f,-0.75000000f,-0.72000000f,0.47000000f,-0.55000000f,0.19000000f,-0.76000000f,0.39000000f,-0.06000000f,-0.66000000f,0.20000000f,-0.85000000f,-0.09000000f,-0.76000000f,-0.84000000f,0.09000000f,0.74000000f,-0.09000000f,-0.75000000f,-0.69000000f,0.18000000f,0.27000000f,0.74000000f,0.73000000f,0.29000000f,0.70000000f,-0.59000000f,0.91000000f,0.93000000f,0.83000000f,0.40000000f,-0.87000000f,-0.29000000f,-0.93000000f,-0.33000000f,0.88000000f,-0.95000000f,-0.81000000f,-0.71000000f,0.96000000f,-0.37000000f,-0.39000000f,-0.23000000f,0.08000000f,0.71000000f,-0.18000000f,0.23000000f,0.61000000f,0.05000000f,0.19000000f,-0.19000000f,-0.81000000f,-0.05000000f,0.63000000f,0.84000000f,-0.12000000f,-0.33000000f,0.27000000f,0.49000000f,-0.29000000f,-0.30000000f,0.70000000f,-0.82000000f,-0.59000000f,0.59000000f,-0.28000000f,0.10000000f,-0.24000000f,0.13000000f,0.85000000f,-0.54000000f,-0.63000000f,0.65000000f,-0.06000000f,-0.59000000f,-0.97000000f,-0.36000000f,-0.40000000f,-0.34000000f,0.84000000f,-0.25000000f,0.77000000f,0.22000000f,0.87000000f,0.91000000f,-0.78000000f,0.74000000f,-0.13000000f,0.13000000f,0.07000000f,0.15000000f,0.92000000f,0.17000000f,-0.51000000f,0.06000000f,0.79000000f,-0.51000000f,-0.76000000f,-0.19000000f,-0.22000000f,0.74000000f,-0.31000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.97000000f,-0.59000000f,0.39000000f,-0.58000000f,-0.70000000f,-0.29000000f,0.44000000f,-0.71000000f,-0.77000000f,-0.83000000f,0.17000000f,-0.55000000f,-0.47000000f,0.98000000f,0.74000000f,-0.04000000f,0.57000000f,0.05000000f,0.64000000f,-0.53000000f,-0.23000000f,-0.15000000f,0.87000000f,-0.86000000f,0.45000000f,0.50000000f,-0.58000000f,0.35000000f,-0.89000000f,0.59000000f,-0.34000000f,-0.12000000f,-0.56000000f,-0.08000000f,0.93000000f,0.93000000f,0.27000000f,-0.60000000f,0.06000000f,0.47000000f,0.22000000f,0.49000000f,0.67000000f,-0.30000000f,0.83000000f,-0.13000000f,0.86000000f,-0.86000000f,-0.79000000f,-0.41000000f,0.30000000f,0.56000000f,0.88000000f,0.17000000f,0.40000000f,-0.84000000f,0.84000000f,-0.18000000f,0.95000000f,-0.17000000f,-0.52000000f,0.14000000f,0.04000000f,0.96000000f,0.21000000f,-0.42000000f,0.92000000f,0.32000000f,-0.24000000f,-0.11000000f,0.26000000f,-0.60000000f,-0.68000000f,0.91000000f,-0.37000000f,0.11000000f,0.76000000f,0.31000000f,0.39000000f,-0.25000000f,-0.10000000f,0.63000000f,0.20000000f,0.83000000f,-0.49000000f,0.71000000f,0.42000000f,-0.01000000f,0.15000000f,-0.47000000f,-0.13000000f,-0.69000000f,0.17000000f,0.90000000f,-0.21000000f,0.14000000f,0.60000000f,0.39000000f,-0.16000000f,0.23000000f,-0.33000000f,0.88000000f,-0.78000000f,-0.87000000f,0.15000000f,-0.68000000f,0.53000000f,-0.11000000f,0.43000000f,-0.54000000f,-0.57000000f,0.87000000f,0.81000000f,0.13000000f,-0.07000000f,0.18000000f,-0.32000000f,-0.85000000f,0.35000000f,-0.32000000f,0.75000000f,-0.80000000f,0.79000000f,-0.12000000f,0.55000000f,0.06000000f,-0.95000000f,0.50000000f,0.99000000f,-0.88000000f,0.75000000f,-0.69000000f,-0.23000000f,-0.53000000f,0.93000000f,-0.57000000f,0.29000000f,0.58000000f,-0.42000000f,0.75000000f,-0.92000000f,-0.13000000f,-0.16000000f,0.28000000f,-0.90000000f,-0.17000000f,-0.74000000f,-0.55000000f,0.99000000f,-0.82000000f,-0.24000000f,-0.43000000f,-0.52000000f,-0.45000000f,-0.02000000f,-0.70000000f,-0.26000000f,0.74000000f,0.21000000f,0.97000000f,-0.10000000f,-0.65000000f,-0.18000000f,-0.06000000f,-0.60000000f,0.54000000f,-0.76000000f,0.23000000f,0.21000000f,0.44000000f,0.06000000f,-0.80000000f,-0.87000000f,-0.13000000f,0.92000000f,0.97000000f,-0.04000000f,0.35000000f,-0.44000000f,-0.00000000f,-0.78000000f,-0.54000000f,-0.91000000f,0.19000000f,0.97000000f,-0.60000000f,0.35000000f,-0.64000000f,-0.84000000f,0.25000000f,0.90000000f,0.17000000f,-0.26000000f,-0.82000000f,0.59000000f,-0.62000000f,-0.14000000f,0.41000000f,0.62000000f,0.91000000f,-0.73000000f,0.62000000f,0.87000000f,0.50000000f,0.55000000f,-0.72000000f,0.00000000f,-0.19000000f,0.90000000f,0.30000000f,0.09000000f,-0.10000000f,-0.90000000f,0.66000000f,0.77000000f,0.63000000f,-0.07000000f,-0.92000000f,-0.63000000f,-0.86000000f,-0.08000000f,0.09000000f,0.38000000f,0.58000000f,0.76000000f,-0.98000000f,0.83000000f,-0.05000000f,-0.37000000f,0.52000000f,-0.57000000f,-0.31000000f,-0.47000000f,-0.49000000f,0.42000000f,-0.13000000f,-0.79000000f,0.60000000f,-0.08000000f,-0.12000000f,0.65000000f,-0.48000000f,0.79000000f,0.22000000f,0.71000000f,0.70000000f,0.78000000f,-0.25000000f,-0.05000000f,0.48000000f,0.14000000f,-0.85000000f,0.50000000f,-0.86000000f,0.31000000f,0.60000000f,0.72000000f,0.82000000f,-0.46000000f,-0.65000000f,-0.54000000f,0.26000000f,0.17000000f,-0.02000000f,-0.48000000f,0.36000000f,-0.63000000f,0.84000000f,0.62000000f,0.59000000f,-0.74000000f,0.00000000f,0.45000000f,0.08000000f,-0.54000000f,-0.34000000f,0.79000000f,0.38000000f,-0.17000000f,0.41000000f,0.30000000f,0.06000000f,0.22000000f,0.59000000f,0.23000000f,-0.36000000f,0.85000000f,-0.00000000f,-0.93000000f,0.74000000f,0.06000000f,-0.99000000f,-0.06000000f,-0.48000000f,0.27000000f,-0.97000000f,-0.44000000f,-0.12000000f,0.46000000f,-0.63000000f,-0.57000000f,-0.98000000f,0.72000000f,0.59000000f,-0.81000000f,0.96000000f,0.64000000f,-0.59000000f,0.13000000f,-0.80000000f,0.43000000f,0.23000000f,-0.66000000f,-0.74000000f,-0.52000000f,0.39000000f,-0.60000000f,-0.92000000f,0.49000000f,0.03000000f,0.84000000f,-0.72000000f,-0.97000000f,-0.81000000f,0.17000000f,0.79000000f,0.69000000f,-0.66000000f,0.11000000f,0.40000000f,-0.37000000f,0.46000000f,-0.74000000f,-0.50000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.20289988f,2.98910006f,0.73939991f,-1.13710004f,-0.31039993f,-1.71549999f,0.02590001f,0.20780000f,2.15450000f,3.19020014f,0.26500003f,-2.50660009f,0.67140001f,-0.40780001f,2.39729997f,-3.89060003f,-0.34189999f,2.24920002f,0.17170006f,1.12469995f,1.08230005f,-1.49980002f,2.62429996f,-2.54970016f,-1.35129999f,-1.55439999f,-4.01399991f,0.81220006f,-0.38870006f,-0.06329992f,-0.28339999f,-6.42990000f,-0.96139994f,-1.22180006f,-1.03130002f,1.46820000f,5.36730000f,3.18430002f,0.43950003f,-1.09220000f,0.51500003f,-2.25150001f,-1.96419998f,0.17890005f,-1.98589999f,1.38709994f,-1.79930004f,-0.56980008f,-2.81089996f,-0.17670000f,1.93999994f,-2.98360007f,0.50369996f,0.96710003f,-3.99049998f,-1.65950001f,1.51479998f,-0.13920001f,-2.41750007f,0.51210000f,0.43100005f,1.17809999f,2.03460008f,4.39400012f,-1.97559994f,-0.42170010f,-0.39889999f,-0.73410004f,-0.82020003f,1.29439998f,2.45960020f,0.67400011f,1.32879998f,3.00689996f,0.42849995f,0.21790009f,0.59919985f,-0.19599997f,2.15910002f,-1.00470008f,2.73950004f,4.88729999f,0.67020010f,2.19360015f,0.59540003f,0.18150007f,-0.37870007f,2.44970005f,0.64609998f,1.45710005f,-2.89939996f,0.17089995f,-1.00129996f,-1.57189999f,0.47330003f,-3.73739997f,1.95539994f,-0.33479999f,-2.62160000f,-2.67780012f,1.24140001f,-0.72829992f,0.07540002f,-0.77930000f,1.73600001f,1.10330001f,-0.78750005f,1.92439996f,0.34050004f,-0.08029998f,-2.29619995f,2.06350010f,-0.94469996f,0.64610009f,-1.24849999f,0.26510005f,0.06159997f,3.94190005f,-0.68250009f,-2.13099990f,-1.02739998f,-1.19929995f,3.20219989f,2.08859992f,-1.84029997f,-4.48010002f,1.53310013f,-1.02770004f,-0.38710005f,1.48460001f,1.89880002f,0.59620005f,2.87119998f,1.91410007f,-0.32730005f,1.51829999f,0.36010007f,4.86549996f,1.01169992f,0.87910009f,-1.21750015f,-1.58159994f,1.70450011f,-0.90200005f,2.78250008f,-0.42239995f,0.07449994f,0.86960005f,-3.87550004f,-0.60939998f,2.41009989f,0.22459990f,-1.00259997f,-1.02110007f,-0.29720004f,-0.84990001f,-1.73979999f,-1.59310000f,0.04809988f,0.29410008f,-0.21179988f,2.14149995f,1.02320011f,-0.12770002f,-1.69140008f,-0.64929992f,2.55880002f,0.68990001f,-3.03650004f,-2.09069999f,-0.80720002f,0.99860002f,-3.12689997f,-1.49380015f,0.62209998f,0.06969994f,-0.72790002f,-1.62200006f,-1.00000001f,-0.91319992f,-0.42180002f,-0.01230004f,1.55979998f,0.20039999f,-1.05429995f,-2.01500002f,0.04400001f,0.80600009f,-0.08210010f,-3.33579997f,-3.00469992f,-3.97279996f,1.19740007f,-2.67590001f,-1.68689996f,0.90470007f,-0.45620003f,-2.25180011f,-4.28490003f,-3.58439989f,2.89309983f,-0.22650003f,-0.22690013f,2.62410005f,-0.55220007f,0.75680005f,2.62630001f,-0.70399992f,2.96429993f,-1.34959995f,1.13549996f,2.48650000f,-0.88100002f,-0.06699983f,1.78050001f,-2.00999993f,0.08010006f,1.59219996f,-1.61190008f,3.22719983f,-1.31459995f,0.78540006f,1.44809995f,0.31669984f,-1.41289997f,-0.98380008f,-0.83210007f,3.13969997f,-4.98910012f,-2.09090005f,-0.00320000f,-0.03800006f,-1.83489995f,-1.90600004f,-1.32439993f,2.27460005f,-0.51469996f,-1.74749993f,2.66910003f,-1.33870005f,-0.70009995f,2.27699986f,-0.47149995f,2.14239997f,-3.95420009f,1.40830003f,-1.55989995f,-2.65830009f,0.71580005f,0.76219993f,-3.61080007f,-1.38849987f,-1.61730001f,0.21440007f,0.58850000f,0.09920010f,-3.52529992f,0.37710006f,0.13899996f,2.16620001f,1.18600005f,1.91050001f,1.68670001f,5.31760011f,-2.20980008f,2.96499996f,-2.05390000f,0.82969995f,0.02560007f,1.25510006f,0.51820000f,-2.18010004f,1.18059991f,-2.89729995f,-1.67230000f,-1.14130006f,3.95510006f,1.37459991f,-2.62130006f,0.81270003f,0.13649994f,-0.05480008f,-2.04259996f,-2.40040000f,1.45350004f,2.07269995f,-3.67669982f,0.05910004f,-1.28179999f,-0.98300003f,-0.41209987f,-0.38290004f,-0.29759993f,-0.11160011f,-1.04000008f,-2.46100003f,3.95839998f,-0.93240000f,1.01159999f,-3.07459996f,0.62569996f,-3.18709995f,1.68459999f,-3.30079998f,-4.20800001f,-0.99269991f,-3.83829997f,0.07970003f,-3.59620004f,-1.13899993f,-1.03549989f,3.47839991f,3.35910011f,0.89029995f,0.96929994f,0.06339993f,-0.09550002f,-0.81849997f,1.15390005f,-1.64349999f,-2.16959996f,2.78920000f,-5.40570018f,-0.67959992f,2.82550005f,3.12099991f,1.42569993f,2.02689988f,-0.00070000f,3.35959993f,0.66890001f,-0.50759990f,0.29390008f,2.20699993f,0.02040006f,2.77589999f,1.30089988f,1.81039996f,0.62380001f,1.56379993f,0.34349998f,1.04899990f,2.00429998f,-3.01699988f,-1.17330010f,-2.27849997f,-2.89180000f,-3.15240000f,-0.73320006f,1.15620000f,0.73540000f,0.83469998f,1.43349993f,2.16210001f,-0.73120004f,0.44710002f,1.64640003f,-4.14530003f,-0.82920001f,-3.49439999f,0.08299999f,1.12580001f,0.48890003f,-0.65100004f,-1.35630000f,3.61709995f,0.38840000f,1.58899998f,-1.36840001f,2.97429996f,-3.93010002f,1.65620007f,-2.64930003f,-2.95019991f,3.41209995f,0.78920001f,0.53580002f,-1.14540003f,-1.07940000f,-2.44320004f,-1.96449997f,-0.85049996f,0.95760007f,2.70029993f,1.04300010f,1.86620007f,-2.37920008f,-0.60719998f,0.16490005f,0.63640005f,1.76559994f,-0.43520004f,0.17520005f,1.18539994f,3.93710001f,-0.95199993f,-0.42079998f,-1.18380001f,3.80410005f,-1.86110003f,-1.66900003f,-2.64679992f,-0.97579993f,-2.21700001f,1.29919996f,-3.47770001f,-1.55050000f,0.39210002f,-2.12759995f,-0.26520004f,-0.24879992f,-0.05579998f,2.27919992f,-0.81689999f,-1.21760000f,-1.69650000f,-0.27610022f,-2.14170005f,-0.85809992f,-0.71960004f,-1.22950010f,-0.97979999f,0.30820004f,0.42789991f,-3.52989998f,-1.78670008f,0.27280001f,3.42590004f,2.55739992f,-1.96580007f,-1.74540012f,-0.99649996f,-0.79899999f,-0.73299997f,-0.01420008f,-1.59190004f,-1.71919997f,2.72760008f,0.10040008f,-1.39379994f,3.05159994f,-0.00709998f,3.25509985f,2.14199996f,-0.76719999f,-0.26789992f,0.55009998f,-1.13540003f,1.00860002f,3.31759993f,1.40270002f,0.55390004f,2.60370001f,-1.68269993f,2.48529991f,3.44959996f,-0.99359996f,-0.20890004f,-3.09370005f,3.22140012f,-2.72560001f,0.75149996f,3.23989999f,2.57440000f,-2.56049994f,-2.21449990f,2.66090006f,-3.49870000f,-0.41010015f,2.50670004f,4.15830001f,-0.85100005f,-4.23319989f,-0.42449990f,-0.21169991f,-4.05050005f,-1.07410000f,2.99110001f,0.76040003f,-2.60559999f,-0.92140009f,0.54989997f,1.16460005f,1.38669998f,0.40479998f,-0.80290005f,-3.14749987f,-0.38309997f,0.07620009f,-2.72050001f,-1.82499998f,4.66160003f,-2.58699989f,2.71110009f,-2.46409999f,-0.39669997f,-3.61979994f,1.92619993f,3.21920007f,2.60059998f,-1.06360000f,0.95800002f,1.61600005f,1.30350000f,1.08350001f,-0.62609987f,-0.45210003f,-0.75810013f,0.88329997f,0.62840001f,-2.66059992f,-4.12049999f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_4d_4items_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{4,3,3,5,8,7};
    Shape shape_b{4,3,2,2,3,1};
    Shape shape_r{4,4,1,4,2,7};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1,1,1},        // move_strides
                                                                  Strides{2,1,3,2},        // filter_dilation
                                                                  CoordinateDiff{0,0,0,0}, // below_pads
                                                                  CoordinateDiff{0,0,0,0}, // above_pads
                                                                  Strides{1,1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f,0.61000000f,0.17000000f,-0.91000000f,-0.48000000f,-0.48000000f,0.12000000f,-0.18000000f,0.08000000f,-0.16000000f,0.54000000f,-0.20000000f,-0.08000000f,0.19000000f,-0.81000000f,0.56000000f,-0.52000000f,0.32000000f,-0.37000000f,-0.17000000f,-0.46000000f,-0.34000000f,0.85000000f,0.11000000f,-0.10000000f,0.98000000f,-0.22000000f,0.68000000f,0.97000000f,-0.93000000f,-0.92000000f,0.32000000f,-0.19000000f,-0.61000000f,0.93000000f,0.54000000f,-0.75000000f,0.63000000f,0.38000000f,0.69000000f,-0.02000000f,0.19000000f,-0.38000000f,-0.44000000f,0.49000000f,-0.62000000f,-0.41000000f,-0.84000000f,0.93000000f,-0.74000000f,-0.57000000f,0.37000000f,-0.86000000f,-0.01000000f,0.58000000f,0.13000000f,-0.42000000f,0.68000000f,-0.05000000f,0.17000000f,0.09000000f,-0.67000000f,0.11000000f,-0.32000000f,0.08000000f,-0.29000000f,0.60000000f,0.69000000f,0.04000000f,0.85000000f,0.46000000f,0.41000000f,-0.78000000f,-0.98000000f,0.50000000f,-0.96000000f,-0.61000000f,-0.58000000f,0.00000000f,0.81000000f,-0.25000000f,-0.74000000f,-0.46000000f,-0.16000000f,0.32000000f,0.56000000f,-0.05000000f,-0.87000000f,0.59000000f,0.08000000f,-0.39000000f,0.67000000f,0.95000000f,0.70000000f,0.00000000f,-0.58000000f,0.85000000f,-0.14000000f,-0.27000000f,-0.63000000f,-0.75000000f,0.61000000f,-0.12000000f,-0.68000000f,-0.83000000f,0.12000000f,0.94000000f,-0.46000000f,0.27000000f,-0.14000000f,-0.96000000f,0.16000000f,-0.57000000f,0.92000000f,-0.24000000f,0.08000000f,0.60000000f,0.23000000f,-0.14000000f,-0.28000000f,0.14000000f,-0.19000000f,0.00000000f,-0.57000000f,0.18000000f,0.42000000f,0.17000000f,0.71000000f,-0.55000000f,0.89000000f,0.26000000f,-0.67000000f,0.68000000f,-0.75000000f,-0.62000000f,0.62000000f,-0.16000000f,-0.69000000f,-0.96000000f,-0.24000000f,0.00000000f,0.63000000f,-0.95000000f,-0.99000000f,0.06000000f,0.02000000f,-0.04000000f,0.95000000f,0.98000000f,0.13000000f,0.96000000f,-0.22000000f,-0.25000000f,-0.77000000f,-0.02000000f,-0.46000000f,0.28000000f,-0.61000000f,-0.56000000f,-0.65000000f,-0.23000000f,-0.41000000f,0.78000000f,-0.46000000f,0.44000000f,0.15000000f,0.46000000f,-0.90000000f,-0.25000000f,0.81000000f,0.28000000f,0.40000000f,0.56000000f,0.62000000f,-0.63000000f,-0.86000000f,-0.97000000f,0.22000000f,-0.58000000f,0.05000000f,0.53000000f,-0.38000000f,0.79000000f,0.60000000f,-0.63000000f,-0.18000000f,0.62000000f,-0.37000000f,0.48000000f,0.86000000f,0.70000000f,-0.52000000f,-0.39000000f,-0.44000000f,-0.69000000f,0.42000000f,-0.69000000f,0.48000000f,0.70000000f,-0.86000000f,-0.90000000f,0.69000000f,0.08000000f,-0.34000000f,-0.86000000f,0.66000000f,0.61000000f,0.47000000f,-0.22000000f,-0.51000000f,-0.29000000f,0.95000000f,-0.30000000f,-0.41000000f,0.85000000f,-0.13000000f,0.70000000f,-0.51000000f,-0.05000000f,-0.50000000f,-0.28000000f,-0.44000000f,0.33000000f,-0.08000000f,-0.88000000f,-0.64000000f,0.24000000f,-0.51000000f,0.67000000f,-0.40000000f,0.48000000f,0.92000000f,-0.64000000f,-0.42000000f,-0.62000000f,-0.77000000f,0.34000000f,0.29000000f,0.49000000f,0.82000000f,-0.30000000f,-0.40000000f,0.27000000f,0.61000000f,-0.75000000f,0.42000000f,0.69000000f,0.46000000f,0.41000000f,0.48000000f,0.14000000f,0.86000000f,-0.46000000f,-0.88000000f,-0.20000000f,-0.09000000f,-0.10000000f,0.70000000f,0.97000000f,-0.99000000f,0.53000000f,-0.51000000f,-0.70000000f,-0.96000000f,0.86000000f,-0.44000000f,-0.66000000f,-0.28000000f,0.08000000f,0.42000000f,-0.45000000f,-0.73000000f,-0.99000000f,-0.33000000f,0.40000000f,-0.86000000f,-0.84000000f,-0.06000000f,0.77000000f,0.96000000f,-0.06000000f,0.24000000f,0.21000000f,0.27000000f,-0.21000000f,-0.01000000f,0.16000000f,0.40000000f,0.06000000f,-0.61000000f,-0.66000000f,0.76000000f,0.43000000f,0.00000000f,0.37000000f,0.70000000f,-0.76000000f,0.50000000f,-0.38000000f,-0.24000000f,-0.80000000f,-0.66000000f,0.09000000f,-0.70000000f,0.83000000f,0.59000000f,-0.39000000f,-0.21000000f,0.84000000f,-0.17000000f,0.50000000f,-0.48000000f,-0.07000000f,-0.54000000f,-0.16000000f,0.99000000f,0.28000000f,0.29000000f,-0.68000000f,-0.49000000f,-0.18000000f,-0.41000000f,0.95000000f,0.72000000f,-0.26000000f,-0.42000000f,-0.27000000f,0.38000000f,-0.47000000f,0.24000000f,-0.38000000f,0.29000000f,0.34000000f,-0.30000000f,-0.64000000f,-0.27000000f,-0.27000000f,-0.94000000f,0.26000000f,0.52000000f,0.92000000f,0.53000000f,-0.80000000f,0.31000000f,0.29000000f,0.16000000f,-0.47000000f,0.61000000f,0.46000000f,-0.75000000f,-0.88000000f,0.95000000f,0.33000000f,-0.97000000f,-0.03000000f,0.43000000f,0.14000000f,0.73000000f,0.97000000f,-0.01000000f,0.45000000f,0.81000000f,0.77000000f,0.45000000f,0.16000000f,-0.66000000f,-0.29000000f,-0.23000000f,0.32000000f,0.22000000f,-0.09000000f,0.65000000f,-0.46000000f,0.65000000f,-0.01000000f,0.61000000f,-0.12000000f,0.36000000f,0.29000000f,-0.87000000f,-0.01000000f,-0.28000000f,-0.95000000f,0.37000000f,0.73000000f,-0.99000000f,0.47000000f,-0.69000000f,-0.31000000f,0.67000000f,-0.78000000f,-0.77000000f,-0.41000000f,0.95000000f,0.61000000f,0.52000000f,0.85000000f,-0.88000000f,0.97000000f,0.54000000f,0.53000000f,0.87000000f,-0.64000000f,-0.62000000f,0.70000000f,-0.11000000f,0.93000000f,-0.52000000f,-0.08000000f,0.03000000f,0.27000000f,-0.30000000f,-0.62000000f,0.00000000f,0.76000000f,0.12000000f,-0.83000000f,-0.60000000f,-0.95000000f,0.51000000f,0.85000000f,-0.27000000f,-0.83000000f,-0.20000000f,-0.45000000f,0.27000000f,-0.09000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.52000000f,-0.43000000f,-0.73000000f,-0.60000000f,-0.89000000f,0.15000000f,-0.12000000f,0.95000000f,0.97000000f,-0.43000000f,0.85000000f,0.43000000f,-0.35000000f,-0.44000000f,0.84000000f,0.94000000f,0.80000000f,-0.88000000f,-0.73000000f,-0.24000000f,0.93000000f,0.77000000f,0.15000000f,-0.63000000f,0.84000000f,0.70000000f,-0.24000000f,-0.01000000f,-0.63000000f,0.44000000f,0.50000000f,-0.29000000f,-0.27000000f,0.64000000f,0.28000000f,-0.18000000f,0.90000000f,-0.87000000f,-0.86000000f,-0.24000000f,0.66000000f,-0.49000000f,0.86000000f,0.19000000f,0.56000000f,-0.18000000f,-0.25000000f,-0.32000000f,-0.09000000f,0.83000000f,0.25000000f,0.92000000f,0.15000000f,0.71000000f,-0.91000000f,0.86000000f,-0.70000000f,0.05000000f,-0.23000000f,0.19000000f,0.32000000f,0.74000000f,-0.79000000f,-0.82000000f,0.44000000f,-0.91000000f,-0.61000000f,-0.99000000f,0.61000000f,-0.19000000f,0.14000000f,-0.46000000f,-0.33000000f,0.93000000f,0.29000000f,0.68000000f,-0.45000000f,0.47000000f,0.19000000f,-0.48000000f,0.03000000f,-0.10000000f,0.73000000f,-0.99000000f,0.72000000f,-0.58000000f,0.45000000f,-0.83000000f,0.07000000f,0.58000000f,0.02000000f,0.60000000f,0.71000000f,0.75000000f,-0.36000000f,0.19000000f,0.92000000f,-0.90000000f,-0.66000000f,0.57000000f,0.38000000f,0.86000000f,0.61000000f,0.31000000f,0.47000000f,-0.14000000f,-0.15000000f,0.27000000f,0.48000000f,0.44000000f,-0.45000000f,-0.83000000f,0.11000000f,0.96000000f,-0.38000000f,-0.12000000f,-0.72000000f,0.07000000f,-0.10000000f,-0.62000000f,0.21000000f,-0.33000000f,0.18000000f,0.18000000f,-0.50000000f,0.15000000f,0.38000000f,0.29000000f,-0.67000000f,-0.16000000f,-0.61000000f,0.36000000f,-0.50000000f,-0.87000000f,0.41000000f,0.41000000f,0.03000000f,0.71000000f,0.75000000f,-0.02000000f,0.13000000f,0.93000000f,0.51000000f,-0.86000000f,-0.43000000f,-0.97000000f,0.16000000f,-0.95000000f,-0.21000000f,-0.15000000f,-0.43000000f,0.53000000f,0.17000000f,0.18000000f,0.12000000f,-0.76000000f,0.56000000f,-0.71000000f,0.25000000f,-0.03000000f,-0.95000000f,0.65000000f,0.11000000f,0.29000000f,0.14000000f,0.04000000f,0.02000000f,-0.20000000f,-0.39000000f,0.23000000f,0.59000000f,0.07000000f,0.73000000f,-0.75000000f,0.67000000f,0.71000000f,-0.11000000f,-0.30000000f,0.26000000f,-0.93000000f,-0.01000000f,0.18000000f,-0.04000000f,-0.73000000f,-0.61000000f,-0.07000000f,0.00000000f,-0.68000000f,-0.58000000f,-0.95000000f,-0.51000000f,0.68000000f,-0.87000000f,0.07000000f,0.21000000f,0.87000000f,0.65000000f,-0.89000000f,0.57000000f,-0.48000000f,0.53000000f,-0.35000000f,-0.61000000f,-0.55000000f,0.62000000f,0.58000000f,-0.68000000f,-0.52000000f,0.33000000f,0.02000000f,0.74000000f,0.03000000f,0.44000000f,0.84000000f,-0.90000000f,-0.02000000f,-0.54000000f,0.55000000f,-0.24000000f,0.63000000f,0.31000000f,-0.67000000f,0.51000000f,0.67000000f,0.85000000f,0.68000000f,0.61000000f,0.04000000f,0.09000000f,0.70000000f,0.35000000f,-0.06000000f,-0.06000000f,-0.49000000f,0.81000000f,-0.24000000f,-0.70000000f,0.44000000f,0.18000000f,0.12000000f,0.17000000f,0.28000000f,0.26000000f,0.81000000f,-0.24000000f,-0.64000000f,0.32000000f,0.49000000f,-0.06000000f,0.13000000f,0.56000000f,-0.17000000f,-0.28000000f,-0.50000000f,0.89000000f,-0.20000000f,-0.34000000f,0.05000000f,0.71000000f,-0.09000000f,0.02000000f,-0.43000000f,-0.00000000f,-0.07000000f,0.25000000f,0.80000000f,0.18000000f,-0.37000000f,-0.16000000f,-0.42000000f,0.33000000f,0.76000000f,-0.81000000f,0.79000000f,0.88000000f,-0.62000000f,-0.49000000f,-0.79000000f,0.16000000f,0.19000000f,0.37000000f,-0.62000000f,-0.72000000f,-0.37000000f,0.39000000f,-0.84000000f,-0.13000000f,0.21000000f,0.88000000f,-0.80000000f,-0.06000000f,0.28000000f,-0.13000000f,-0.83000000f,-0.91000000f,-0.39000000f,0.19000000f,-0.71000000f,-0.08000000f,0.96000000f,0.89000000f,-0.60000000f,-0.79000000f,-0.13000000f,-0.00000000f,0.03000000f,0.97000000f,0.70000000f,-0.96000000f,-0.50000000f,-0.39000000f,0.13000000f,0.09000000f,0.29000000f,-0.43000000f,-0.40000000f,-0.83000000f,0.51000000f,-0.32000000f,-0.53000000f,0.07000000f,0.35000000f,0.43000000f,-0.65000000f,-0.94000000f,0.40000000f,-0.59000000f,0.80000000f,-0.15000000f,-0.22000000f,0.56000000f,0.90000000f,-0.82000000f,-0.74000000f,0.04000000f,-0.24000000f,-0.97000000f,0.96000000f,0.78000000f,0.29000000f,-0.44000000f,0.62000000f,0.92000000f,0.05000000f,-0.74000000f,-0.49000000f,-0.25000000f,0.34000000f,-0.99000000f,0.78000000f,-0.64000000f,0.09000000f,-0.51000000f,0.99000000f,-0.20000000f,0.95000000f,0.13000000f,-0.44000000f,-0.90000000f,-0.82000000f,0.84000000f,0.26000000f,-0.90000000f,0.97000000f,-0.09000000f,0.45000000f,-0.49000000f,0.29000000f,0.13000000f,0.37000000f,-0.03000000f,0.41000000f,-0.47000000f,0.25000000f,0.44000000f,0.31000000f,0.72000000f,0.09000000f,0.67000000f,0.76000000f,-0.79000000f,-0.99000000f,0.62000000f,-0.71000000f,-0.07000000f,0.63000000f,-0.02000000f,-0.28000000f,-0.02000000f,0.98000000f,0.28000000f,0.48000000f,-0.49000000f,0.32000000f,-0.11000000f,-0.45000000f,0.37000000f,-0.58000000f,-0.82000000f,-0.23000000f,-0.55000000f,-0.61000000f,-0.87000000f,-0.96000000f,-0.34000000f,-0.03000000f,-0.15000000f,-0.15000000f,-0.30000000f,-0.53000000f,0.83000000f,0.20000000f,-0.19000000f,-0.19000000f,0.23000000f,0.45000000f,0.50000000f,-0.67000000f,0.71000000f,-0.97000000f,0.42000000f,-0.33000000f,-0.88000000f,0.56000000f,0.78000000f,-0.09000000f,0.17000000f,0.77000000f,0.95000000f,-0.80000000f,-0.72000000f,0.23000000f,0.39000000f,-0.72000000f,-0.15000000f,-0.79000000f,-0.97000000f,0.97000000f,-0.20000000f,-0.56000000f,-0.95000000f,-0.65000000f,0.71000000f,-0.42000000f,0.10000000f,-0.58000000f,-0.14000000f,0.39000000f,-0.95000000f,-0.71000000f,-0.67000000f,0.62000000f,-0.10000000f,-0.11000000f,-0.76000000f,-0.30000000f,-0.62000000f,0.63000000f,-0.11000000f,-0.48000000f,0.37000000f,-0.08000000f,0.73000000f,-0.84000000f,-0.07000000f,-0.82000000f,-0.93000000f,0.63000000f,0.17000000f,-0.58000000f,-0.17000000f,0.83000000f,0.78000000f,-0.49000000f,-0.41000000f,0.29000000f,-0.90000000f,0.78000000f,-0.97000000f,-0.67000000f,0.47000000f,0.64000000f,-0.57000000f,0.89000000f,0.29000000f,-0.24000000f,0.75000000f,0.61000000f,0.45000000f,0.42000000f,0.16000000f,-0.75000000f,0.31000000f,0.66000000f,-0.04000000f,0.11000000f,-0.22000000f,-0.63000000f,-0.81000000f,0.48000000f,0.40000000f,-0.43000000f,0.37000000f,0.58000000f,0.18000000f,0.27000000f,-0.84000000f,0.31000000f,0.67000000f,-0.23000000f,0.74000000f,0.87000000f,-0.60000000f,-0.90000000f,-0.43000000f,0.07000000f,-0.58000000f,-0.01000000f,0.06000000f,-0.57000000f,-0.48000000f,-0.80000000f,0.30000000f,-0.69000000f,-0.37000000f,0.45000000f,0.85000000f,-0.17000000f,0.84000000f,-0.86000000f,0.36000000f,0.30000000f,0.49000000f,0.19000000f,-0.40000000f,-0.68000000f,-0.49000000f,0.61000000f,-0.07000000f,0.25000000f,-0.84000000f,0.42000000f,-0.23000000f,-0.28000000f,0.86000000f,-0.37000000f,0.13000000f,-0.29000000f,-0.93000000f,-0.28000000f,0.23000000f,0.25000000f,0.86000000f,0.33000000f,0.75000000f,0.75000000f,-0.61000000f,0.43000000f,0.09000000f,0.24000000f,-0.80000000f,-0.34000000f,-0.64000000f,0.25000000f,-0.07000000f,0.78000000f,0.29000000f,0.12000000f,0.28000000f,-0.72000000f,-0.72000000f,-0.70000000f,0.23000000f,-0.30000000f,-0.07000000f,-0.94000000f,0.97000000f,0.08000000f,-0.97000000f,0.20000000f,0.70000000f,0.38000000f,0.92000000f,-0.91000000f,-0.93000000f,-0.13000000f,0.05000000f,-0.56000000f,0.15000000f,-0.45000000f,-0.39000000f,-0.53000000f,0.25000000f,0.74000000f,0.85000000f,0.91000000f,0.25000000f,0.75000000f,0.32000000f,0.86000000f,0.99000000f,0.84000000f,0.17000000f,0.38000000f,0.16000000f,0.26000000f,0.37000000f,0.41000000f,-0.36000000f,-0.00000000f,-0.09000000f,0.70000000f,-0.40000000f,0.15000000f,0.76000000f,-0.17000000f,0.40000000f,-0.06000000f,0.14000000f,0.50000000f,-0.91000000f,0.44000000f,0.06000000f,0.30000000f,0.86000000f,0.45000000f,-0.88000000f,-0.06000000f,0.92000000f,-0.39000000f,0.83000000f,0.04000000f,-0.04000000f,0.70000000f,0.99000000f,-0.96000000f,0.02000000f,-0.45000000f,0.47000000f,0.71000000f,-0.50000000f,0.08000000f,0.98000000f,0.30000000f,-0.60000000f,-0.66000000f,0.66000000f,-0.51000000f,-0.86000000f,0.54000000f,0.51000000f,-0.36000000f,-0.48000000f,0.59000000f,-0.93000000f,0.64000000f,0.49000000f,0.23000000f,-0.72000000f,0.82000000f,-0.81000000f,-0.51000000f,-0.06000000f,0.58000000f,0.45000000f,-0.41000000f,-0.60000000f,-0.08000000f,-0.07000000f,0.47000000f,-0.48000000f,0.85000000f,-0.36000000f,-0.92000000f,0.48000000f,-0.36000000f,-0.09000000f,0.09000000f,-0.57000000f,-0.98000000f,0.67000000f,-0.53000000f,0.50000000f,-0.12000000f,-0.62000000f,-0.85000000f,0.37000000f,-0.98000000f,0.56000000f,0.65000000f,0.51000000f,0.54000000f,0.73000000f,-0.89000000f,0.07000000f,0.52000000f,0.92000000f,-0.26000000f,-0.93000000f,-0.82000000f,0.75000000f,0.96000000f,0.26000000f,-0.21000000f,-0.40000000f,-0.88000000f,-0.38000000f,-0.21000000f,-0.43000000f,-0.77000000f,0.48000000f,-0.95000000f,0.40000000f,0.43000000f,-0.24000000f,-0.72000000f,0.49000000f,-0.78000000f,0.82000000f,-0.21000000f,-0.15000000f,-0.56000000f,-0.94000000f,-0.51000000f,-0.10000000f,0.36000000f,0.68000000f,-0.78000000f,0.09000000f,-0.15000000f,-0.55000000f,0.21000000f,-0.11000000f,0.53000000f,-0.23000000f,-0.85000000f,-0.50000000f,0.66000000f,0.44000000f,0.47000000f,0.61000000f,0.22000000f,0.79000000f,0.71000000f,-0.91000000f,0.70000000f,-0.12000000f,-0.78000000f,0.45000000f,-0.40000000f,0.82000000f,0.27000000f,0.39000000f,0.87000000f,-0.23000000f,-0.37000000f,-0.78000000f,-0.19000000f,0.45000000f,0.29000000f,-0.45000000f,-0.30000000f,0.17000000f,-0.70000000f,0.09000000f,-0.85000000f,-0.67000000f,0.41000000f,0.37000000f,-0.12000000f,0.83000000f,0.92000000f,0.70000000f,-0.23000000f,0.62000000f,0.84000000f,0.13000000f,-0.36000000f,0.75000000f,-0.47000000f,-0.93000000f,0.00000000f,-0.71000000f,0.22000000f,-0.13000000f,-0.19000000f,-0.03000000f,-0.94000000f,-0.56000000f,-0.88000000f,-0.27000000f,-0.48000000f,0.98000000f,0.73000000f,0.87000000f,0.10000000f,0.04000000f,0.34000000f,0.51000000f,-0.95000000f,0.84000000f,0.17000000f,0.13000000f,-0.39000000f,0.37000000f,0.89000000f,-0.04000000f,-0.53000000f,-0.38000000f,0.00000000f,-0.00000000f,0.72000000f,0.08000000f,0.32000000f,0.69000000f,0.80000000f,0.00000000f,-0.12000000f,-0.79000000f,-0.75000000f,0.04000000f,-0.45000000f,0.08000000f,-0.96000000f,-0.95000000f,-0.44000000f,0.98000000f,0.10000000f,-0.28000000f,0.99000000f,-0.07000000f,0.53000000f,-0.86000000f,-0.01000000f,0.29000000f,-0.78000000f,-0.01000000f,0.22000000f,0.18000000f,-0.24000000f,-0.89000000f,0.12000000f,-0.67000000f,0.06000000f,-0.02000000f,-0.41000000f,-0.00000000f,0.91000000f,0.40000000f,-0.20000000f,0.25000000f,-0.08000000f,0.04000000f,0.42000000f,0.40000000f,0.39000000f,-0.22000000f,-0.23000000f,0.28000000f,0.48000000f,-0.72000000f,-0.85000000f,-0.22000000f,0.69000000f,-0.25000000f,-0.85000000f,-0.56000000f,0.80000000f,-0.91000000f,0.69000000f,-0.69000000f,0.86000000f,0.94000000f,0.87000000f,-0.47000000f,0.30000000f,-0.51000000f,-0.52000000f,0.74000000f,-0.43000000f,0.03000000f,-0.79000000f,0.76000000f,0.39000000f,0.00000000f,0.32000000f,-0.43000000f,-0.43000000f,-0.27000000f,0.08000000f,-0.20000000f,0.18000000f,0.01000000f,-0.12000000f,-0.22000000f,-0.64000000f,-0.56000000f,0.72000000f,-0.10000000f,-0.52000000f,-0.23000000f,0.93000000f,0.39000000f,0.14000000f,0.23000000f,0.81000000f,-0.37000000f,0.52000000f,-0.10000000f,-0.16000000f,-0.90000000f,0.35000000f,0.18000000f,-0.89000000f,0.72000000f,0.91000000f,-0.03000000f,-0.67000000f,0.43000000f,0.97000000f,-0.32000000f,-0.40000000f,0.85000000f,-0.25000000f,0.71000000f,-0.60000000f,0.71000000f,0.84000000f,0.20000000f,-0.97000000f,-0.66000000f,0.18000000f,0.71000000f,-0.29000000f,-0.73000000f,0.62000000f,0.76000000f,-0.12000000f,-0.80000000f,0.61000000f,0.38000000f,0.74000000f,0.44000000f,0.60000000f,0.23000000f,0.11000000f,-0.06000000f,-0.09000000f,-0.33000000f,-0.38000000f,0.17000000f,0.57000000f,0.91000000f,0.83000000f,0.89000000f,0.88000000f,0.83000000f,0.71000000f,0.97000000f,0.93000000f,0.23000000f,-0.36000000f,-0.21000000f,-0.77000000f,0.14000000f,0.52000000f,-0.48000000f,-0.21000000f,-0.86000000f,-0.39000000f,0.68000000f,0.46000000f,0.48000000f,0.09000000f,-0.10000000f,0.83000000f,0.63000000f,0.53000000f,0.40000000f,0.05000000f,-0.92000000f,0.61000000f,0.23000000f,0.23000000f,-0.49000000f,-0.12000000f,-0.88000000f,-0.03000000f,0.50000000f,-0.27000000f,0.44000000f,-0.59000000f,-0.50000000f,0.93000000f,-0.52000000f,-0.06000000f,-0.02000000f,0.57000000f,0.75000000f,0.56000000f,0.34000000f,-0.71000000f,-0.04000000f,-0.25000000f,0.81000000f,0.77000000f,-0.40000000f,0.69000000f,0.26000000f,0.86000000f,0.32000000f,0.69000000f,-0.64000000f,-0.75000000f,0.73000000f,-0.40000000f,-0.57000000f,0.95000000f,0.03000000f,-0.51000000f,0.15000000f,-0.25000000f,0.87000000f,0.23000000f,-0.61000000f,-0.37000000f,-0.44000000f,-0.04000000f,-0.84000000f,-0.07000000f,0.27000000f,-0.33000000f,0.68000000f,-0.59000000f,0.32000000f,0.06000000f,-0.80000000f,-0.47000000f,0.09000000f,-0.61000000f,-0.85000000f,-0.77000000f,0.78000000f,0.86000000f,-0.75000000f,-0.45000000f,-0.10000000f,-0.68000000f,-0.30000000f,-0.40000000f,0.83000000f,0.62000000f,0.97000000f,-0.71000000f,0.50000000f,-0.15000000f,-0.06000000f,0.99000000f,0.68000000f,-0.45000000f,0.81000000f,-0.82000000f,0.87000000f,-0.65000000f,-0.68000000f,-0.97000000f,0.68000000f,0.64000000f,0.19000000f,0.23000000f,0.51000000f,-0.96000000f,0.16000000f,0.05000000f,0.82000000f,-0.70000000f,0.08000000f,-0.13000000f,0.80000000f,0.87000000f,0.47000000f,0.27000000f,0.38000000f,0.27000000f,-0.61000000f,-0.63000000f,0.60000000f,0.91000000f,-0.03000000f,-0.65000000f,-0.26000000f,-0.59000000f,-0.08000000f,-0.00000000f,0.55000000f,-0.30000000f,0.28000000f,-0.81000000f,0.32000000f,-0.92000000f,-0.34000000f,0.55000000f,0.25000000f,-0.46000000f,0.93000000f,0.34000000f,0.69000000f,-0.59000000f,0.79000000f,0.95000000f,0.97000000f,0.91000000f,-0.53000000f,0.89000000f,0.29000000f,-0.23000000f,-0.49000000f,0.14000000f,-0.53000000f,0.22000000f,0.87000000f,0.10000000f,0.42000000f,0.31000000f,0.98000000f,-0.18000000f,-0.89000000f,-0.98000000f,-0.20000000f,0.31000000f,-0.54000000f,0.32000000f,-0.14000000f,0.16000000f,-0.24000000f,-0.77000000f,0.15000000f,0.76000000f,0.80000000f,0.70000000f,0.93000000f,-0.55000000f,0.25000000f,0.39000000f,0.16000000f,-0.80000000f,-0.64000000f,-0.51000000f,-0.48000000f,0.75000000f,0.50000000f,0.19000000f,-0.42000000f,-0.42000000f,0.75000000f,0.06000000f,0.61000000f,-0.75000000f,0.65000000f,0.27000000f,-0.72000000f,-0.20000000f,0.81000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.56000000f,-0.15000000f,-0.37000000f,0.38000000f,0.83000000f,-0.76000000f,-0.00000000f,-0.95000000f,0.99000000f,-0.51000000f,-0.06000000f,-0.47000000f,0.92000000f,0.03000000f,0.52000000f,-0.67000000f,0.73000000f,0.59000000f,-0.32000000f,-0.97000000f,0.41000000f,-0.37000000f,0.25000000f,0.77000000f,-0.40000000f,-0.01000000f,-0.95000000f,0.77000000f,-0.31000000f,-0.99000000f,-0.23000000f,-0.38000000f,-0.77000000f,-0.15000000f,-0.75000000f,-0.79000000f,0.85000000f,-0.56000000f,-0.80000000f,0.15000000f,0.75000000f,0.69000000f,-0.70000000f,-0.72000000f,-0.83000000f,0.16000000f,0.83000000f,0.95000000f,-0.33000000f,-0.16000000f,-0.56000000f,-0.36000000f,-0.94000000f,0.37000000f,0.51000000f,-0.95000000f,0.92000000f,-0.86000000f,0.88000000f,-0.63000000f,0.77000000f,0.12000000f,0.54000000f,0.99000000f,0.08000000f,0.38000000f,-0.42000000f,0.86000000f,-0.13000000f,0.45000000f,0.75000000f,0.10000000f,0.56000000f,0.78000000f,0.06000000f,-0.93000000f,0.77000000f,-0.47000000f,0.86000000f,-0.34000000f,-0.34000000f,0.61000000f,0.12000000f,-0.56000000f,0.64000000f,0.58000000f,-0.56000000f,0.32000000f,0.01000000f,-0.35000000f,0.10000000f,0.59000000f,-0.40000000f,0.19000000f,-0.02000000f,-0.53000000f,0.87000000f,-0.31000000f,-0.39000000f,0.80000000f,-0.53000000f,0.84000000f,0.69000000f,0.34000000f,0.46000000f,0.61000000f,-0.38000000f,0.85000000f,-0.38000000f,-0.90000000f,-0.57000000f,0.74000000f,0.21000000f,0.13000000f,-0.87000000f,-0.57000000f,-0.81000000f,-0.75000000f,-0.14000000f,0.99000000f,-0.49000000f,-0.65000000f,0.61000000f,-0.58000000f,-0.04000000f,-0.63000000f,-0.96000000f,-0.75000000f,-0.67000000f,-0.72000000f,-0.33000000f,0.50000000f,-0.01000000f,0.64000000f,0.97000000f,-0.08000000f,-0.34000000f,-0.84000000f,0.38000000f,-0.16000000f,0.42000000f,0.96000000f,0.80000000f,-0.53000000f,0.53000000f,0.51000000f,0.77000000f,-0.04000000f,-0.06000000f,0.65000000f,0.72000000f,0.82000000f,0.77000000f,-0.53000000f,-0.66000000f,-0.43000000f,0.95000000f,0.20000000f,0.14000000f,-0.27000000f,-0.13000000f,0.39000000f,-0.77000000f,0.07000000f,-0.14000000f,0.93000000f,0.69000000f,-0.03000000f,0.89000000f,0.51000000f,-0.40000000f,-0.68000000f,0.42000000f,-0.46000000f,-0.50000000f,0.15000000f,-0.81000000f,0.32000000f,-0.10000000f,0.26000000f,-0.10000000f,0.35000000f,-0.33000000f,0.70000000f,-0.35000000f,0.79000000f,0.97000000f,0.01000000f,-0.77000000f,-0.44000000f,-0.24000000f,-0.93000000f,0.21000000f,-0.74000000f,-0.64000000f,-0.25000000f,-0.90000000f,-0.26000000f,0.64000000f,-0.33000000f,0.82000000f,-0.12000000f,0.56000000f,-0.18000000f,-0.78000000f,-0.82000000f,-0.21000000f,-0.84000000f,-0.81000000f,-0.26000000f,0.20000000f,0.74000000f,-0.56000000f,0.86000000f,-0.17000000f,-0.36000000f,-0.02000000f,-0.16000000f,0.21000000f,0.61000000f,0.65000000f,-0.48000000f,0.04000000f,-0.38000000f,0.32000000f,-0.72000000f,0.22000000f,-0.16000000f,0.44000000f,0.25000000f,-0.51000000f,-0.64000000f,0.43000000f,0.72000000f,-0.88000000f,0.97000000f,-0.27000000f,0.40000000f,0.36000000f,0.49000000f,0.38000000f,-0.53000000f,-0.08000000f,-0.06000000f,0.69000000f,-0.27000000f,0.05000000f,0.72000000f,-0.48000000f,0.74000000f,0.80000000f,0.23000000f,0.00000000f,-0.49000000f,-0.85000000f,-0.30000000f,-0.43000000f,0.14000000f,-0.06000000f,0.03000000f,-0.83000000f,0.91000000f,-0.72000000f,0.27000000f,0.42000000f,-0.63000000f,-0.54000000f,0.92000000f,-0.87000000f,-0.49000000f,0.40000000f,0.60000000f,-0.24000000f,0.66000000f,-0.65000000f,-0.67000000f,0.15000000f,0.70000000f,0.89000000f,-0.13000000f,0.81000000f,-0.52000000f,-0.82000000f,-0.58000000f,-0.20000000f,0.08000000f,-0.51000000f,0.18000000f,0.99000000f,-0.80000000f,0.22000000f,-0.17000000f,-0.72000000f,-0.72000000f,0.39000000f,0.81000000f,-0.36000000f,0.92000000f,-0.63000000f,0.36000000f,0.21000000f,0.00000000f,-0.27000000f,-0.72000000f,-0.47000000f,-0.69000000f,0.93000000f,-0.60000000f,0.98000000f,-0.28000000f,-0.69000000f,0.24000000f,-0.32000000f,-0.13000000f,-0.37000000f,0.66000000f,-0.68000000f,0.82000000f,0.23000000f,-0.45000000f,0.19000000f,-0.02000000f,0.90000000f,-0.77000000f,-0.87000000f,0.94000000f,-0.53000000f,0.95000000f,0.90000000f,0.17000000f,0.80000000f,-0.86000000f,0.67000000f,0.58000000f,-0.27000000f,-0.87000000f,-0.15000000f,0.99000000f,-0.65000000f,0.08000000f,0.34000000f,-0.46000000f,-0.94000000f,0.78000000f,0.10000000f,-0.95000000f,0.54000000f,0.46000000f,0.89000000f,0.01000000f,-0.33000000f,0.43000000f,-0.19000000f,-0.87000000f,0.36000000f,0.84000000f,0.70000000f,-0.93000000f,-0.95000000f,0.86000000f,-0.33000000f,-0.60000000f,0.31000000f,0.70000000f,-0.39000000f,0.01000000f,-0.43000000f,-0.11000000f,-0.42000000f,-0.76000000f,0.72000000f,0.33000000f,0.40000000f,0.43000000f,-0.19000000f,-0.49000000f,0.24000000f,-0.45000000f,-0.02000000f,-0.12000000f,-0.50000000f,-0.74000000f,-0.53000000f,0.09000000f,0.39000000f,0.53000000f,0.02000000f,0.14000000f,0.40000000f,-0.81000000f,-0.28000000f,-0.32000000f,-0.00000000f,0.51000000f,0.54000000f,-0.12000000f,-0.30000000f,0.97000000f,-0.04000000f,-0.42000000f,-0.96000000f,-0.39000000f,0.81000000f,0.93000000f,-0.55000000f,0.46000000f,-0.79000000f,-0.99000000f,-0.53000000f,0.00000000f,-0.28000000f,0.08000000f,0.22000000f,0.34000000f,0.03000000f,-0.89000000f,0.36000000f,0.80000000f,-0.68000000f,0.50000000f,-0.08000000f,0.04000000f,0.98000000f,-0.36000000f,-0.97000000f,0.46000000f,-0.02000000f,-0.20000000f,0.66000000f,-0.67000000f,0.58000000f,0.46000000f,-0.14000000f,-0.74000000f,-0.68000000f,-0.22000000f,0.93000000f,-0.86000000f,-0.58000000f,0.66000000f,-0.03000000f,0.40000000f,0.60000000f,-0.65000000f,0.20000000f,0.96000000f,-0.04000000f,0.91000000f,0.95000000f,-0.19000000f,0.04000000f,0.89000000f,0.70000000f,-0.99000000f,0.27000000f,-0.55000000f,0.79000000f,0.99000000f,0.94000000f,-0.16000000f,0.16000000f,0.74000000f,-0.84000000f,-0.91000000f,-0.15000000f,0.70000000f,0.95000000f,-0.19000000f,-0.72000000f,0.23000000f,0.98000000f,-0.77000000f,-0.58000000f,-0.97000000f,0.20000000f,-0.89000000f,0.94000000f,-0.96000000f,0.78000000f,0.17000000f,0.51000000f,0.91000000f,-0.58000000f,-0.90000000f,-0.48000000f,0.03000000f,0.06000000f,-0.58000000f,0.67000000f,0.70000000f,-0.68000000f,0.13000000f,-0.02000000f,0.04000000f,-0.33000000f,0.64000000f,-0.72000000f,0.01000000f,0.71000000f,0.37000000f,0.31000000f,-0.39000000f,0.91000000f,0.19000000f,-0.34000000f,0.45000000f,-0.68000000f,-0.26000000f,-0.78000000f,-0.74000000f,0.43000000f,-0.05000000f,-0.29000000f,-0.98000000f,-0.07000000f,0.61000000f,-0.93000000f,0.05000000f,-0.44000000f,0.44000000f,0.89000000f,-0.08000000f,0.19000000f,0.95000000f,0.90000000f,0.63000000f,0.25000000f,0.09000000f,0.90000000f,-0.66000000f,0.62000000f,0.72000000f,-0.28000000f,0.76000000f,-0.90000000f,0.37000000f,-0.25000000f,0.60000000f,0.92000000f,-0.75000000f,0.86000000f,-0.79000000f,0.17000000f,-0.11000000f,-0.21000000f,-0.99000000f,-0.41000000f,0.18000000f,-0.59000000f,-0.04000000f,0.92000000f,-0.20000000f,-0.82000000f,0.70000000f,0.18000000f,-0.08000000f,0.04000000f,0.84000000f,-0.48000000f,-0.46000000f,-0.94000000f,-0.55000000f,0.64000000f,0.10000000f,-0.74000000f,-0.66000000f,-0.16000000f,0.52000000f,0.33000000f,-0.41000000f,0.24000000f,0.94000000f,0.22000000f,-0.04000000f,-0.90000000f,0.91000000f,0.13000000f,0.46000000f,0.18000000f,-0.33000000f,-0.48000000f,-0.92000000f,-0.54000000f,-0.90000000f,-0.20000000f,0.58000000f,-0.45000000f,-0.52000000f,-0.50000000f,-0.42000000f,-0.18000000f,-0.49000000f,-0.71000000f,0.61000000f,-0.32000000f,0.82000000f,-0.17000000f,-0.82000000f,0.37000000f,-0.73000000f,-0.22000000f,0.97000000f,0.79000000f,0.43000000f,0.75000000f,0.82000000f,-0.88000000f,0.15000000f,0.04000000f,0.50000000f,-0.21000000f,-0.38000000f,0.63000000f,-0.45000000f,-0.39000000f,0.34000000f,0.20000000f,-0.46000000f,-0.24000000f,-0.44000000f,-0.82000000f,0.63000000f,-0.36000000f,-0.03000000f,-0.20000000f,-0.31000000f,-0.51000000f,-0.44000000f,0.03000000f,-0.28000000f,0.86000000f,-0.98000000f,0.67000000f,-0.01000000f,0.37000000f,-0.58000000f,0.83000000f,-0.71000000f,0.88000000f,0.94000000f,-0.97000000f,-0.02000000f,0.53000000f,-0.47000000f,0.43000000f,0.45000000f,0.66000000f,-0.41000000f,0.01000000f,0.66000000f,-0.73000000f,0.98000000f,-0.51000000f,-0.25000000f,0.10000000f,0.86000000f,-0.61000000f,-0.38000000f,0.24000000f,-0.37000000f,-0.76000000f,0.10000000f,0.41000000f,-0.40000000f,0.45000000f,-0.94000000f,0.06000000f,-0.34000000f,-0.77000000f,-0.49000000f,0.10000000f,0.60000000f,0.59000000f,-0.18000000f,-0.29000000f,0.16000000f,0.66000000f,-0.79000000f,0.31000000f,-0.15000000f,-0.36000000f,0.28000000f,-0.83000000f,-0.40000000f,0.79000000f,-0.79000000f,0.01000000f,-0.10000000f,-0.89000000f,0.89000000f,-0.73000000f,-0.94000000f,-0.25000000f,0.90000000f,0.02000000f,0.87000000f,-0.72000000f,0.14000000f,0.01000000f,0.14000000f,0.33000000f,0.70000000f,-0.23000000f,0.31000000f,0.47000000f,-0.99000000f,0.74000000f,-0.94000000f,-0.18000000f,0.29000000f,0.74000000f,0.41000000f,-0.62000000f,-0.55000000f,-0.23000000f,-0.92000000f,-0.83000000f,-0.04000000f,0.62000000f,-0.21000000f,0.18000000f,0.54000000f,0.10000000f,0.01000000f,-0.56000000f,0.20000000f,-0.27000000f,0.95000000f,-0.72000000f,-0.81000000f,-0.37000000f,0.04000000f,0.35000000f,-0.43000000f,0.74000000f,0.96000000f,-0.39000000f,-0.25000000f,0.84000000f,-0.96000000f,0.63000000f,-0.21000000f,0.38000000f,0.08000000f,-0.30000000f,-0.96000000f,0.62000000f,0.52000000f,0.88000000f,0.24000000f,0.20000000f,-0.98000000f,-0.19000000f,0.73000000f,-0.92000000f,-0.26000000f,0.98000000f,0.23000000f,0.02000000f,-0.56000000f,-0.67000000f,0.84000000f,0.80000000f,-0.99000000f,0.90000000f,0.08000000f,0.54000000f,-0.42000000f,0.12000000f,0.61000000f,-0.37000000f,-0.33000000f,0.96000000f,0.77000000f,-0.97000000f,0.69000000f,-0.03000000f,0.32000000f,-0.05000000f,0.38000000f,-0.13000000f,-0.67000000f,-0.29000000f,0.78000000f,0.49000000f,0.06000000f,-0.80000000f,-0.11000000f,0.67000000f,0.22000000f,-0.76000000f,-0.30000000f,-0.78000000f,0.35000000f,0.64000000f,-0.14000000f,-0.56000000f,0.01000000f,-0.67000000f,-0.73000000f,-0.00000000f,0.49000000f,0.49000000f,-0.48000000f,-0.61000000f,0.93000000f,-0.05000000f,0.14000000f,0.47000000f,-0.07000000f,0.83000000f,0.97000000f,0.07000000f,-0.41000000f,-0.19000000f,0.17000000f,0.62000000f,0.58000000f,-0.37000000f,0.48000000f,-0.62000000f,-0.36000000f,0.94000000f,0.07000000f,-0.83000000f,0.49000000f,-0.81000000f,-0.77000000f,-0.21000000f,0.15000000f,-0.48000000f,-0.65000000f,0.88000000f,0.58000000f,0.74000000f,-0.88000000f,-0.78000000f,0.70000000f,-0.18000000f,0.37000000f,-0.84000000f,-0.49000000f,-0.39000000f,0.98000000f,0.06000000f,0.25000000f,0.97000000f,0.39000000f,0.38000000f,-0.67000000f,-0.52000000f,0.65000000f,-0.66000000f,-0.53000000f,0.38000000f,-0.30000000f,-0.51000000f,0.07000000f,-0.07000000f,0.01000000f,0.73000000f,0.38000000f,0.47000000f,-0.56000000f,0.44000000f,0.78000000f,-0.98000000f,-0.99000000f,-0.31000000f,-0.72000000f,0.91000000f,0.18000000f,-0.84000000f,-0.40000000f,-0.53000000f,0.33000000f,0.13000000f,0.37000000f,0.01000000f,0.81000000f,0.00000000f,-0.19000000f,-0.02000000f,-0.73000000f,0.65000000f,0.84000000f,-0.01000000f,0.16000000f,-0.07000000f,0.64000000f,0.22000000f,0.06000000f,0.49000000f,-0.28000000f,-0.84000000f,0.81000000f,-0.94000000f,0.32000000f,-0.07000000f,0.09000000f,0.95000000f,0.99000000f,-0.56000000f,0.64000000f,0.83000000f,0.51000000f,-0.93000000f,0.18000000f,-0.50000000f,0.38000000f,-0.07000000f,0.93000000f,0.63000000f,-0.29000000f,0.87000000f,-0.04000000f,0.63000000f,0.70000000f,-0.76000000f,0.02000000f,0.02000000f,-0.88000000f,-0.63000000f,-0.18000000f,-0.30000000f,-0.48000000f,-0.42000000f,0.93000000f,0.01000000f,0.36000000f,0.97000000f,-0.25000000f,0.93000000f,0.16000000f,0.46000000f,-0.31000000f,-0.32000000f,0.20000000f,0.43000000f,-0.93000000f,0.09000000f,0.97000000f,0.53000000f,-0.86000000f,-0.33000000f,0.77000000f,0.58000000f,-0.11000000f,0.55000000f,0.94000000f,-0.42000000f,-0.48000000f,0.05000000f,0.15000000f,0.58000000f,-0.59000000f,-0.41000000f,-0.53000000f,0.05000000f,0.96000000f,0.00000000f,0.60000000f,0.56000000f,-0.18000000f,0.49000000f,-0.44000000f,0.47000000f,-0.67000000f,-0.85000000f,0.91000000f,-0.28000000f,-0.17000000f,0.62000000f,-0.96000000f,0.81000000f,0.12000000f,0.54000000f,-0.52000000f,-0.12000000f,-0.28000000f,0.82000000f,0.02000000f,-0.11000000f,-0.51000000f,-0.45000000f,0.20000000f,0.69000000f,0.07000000f,0.48000000f,-0.48000000f,-0.01000000f,0.33000000f,0.64000000f,0.15000000f,-0.79000000f,-0.11000000f,0.28000000f,0.48000000f,0.58000000f,0.95000000f,-0.89000000f,0.01000000f,-0.16000000f,-0.66000000f,-0.92000000f,0.89000000f,-0.34000000f,0.50000000f,-0.28000000f,0.08000000f,-0.74000000f,0.29000000f,-0.02000000f,0.68000000f,0.15000000f,0.95000000f,0.21000000f,-0.58000000f,-0.11000000f,0.64000000f,0.73000000f,0.87000000f,-0.96000000f,-0.64000000f,-0.60000000f,-0.79000000f,0.35000000f,-0.54000000f,-0.65000000f,0.14000000f,-0.48000000f,0.02000000f,0.36000000f,-0.45000000f,0.07000000f,0.58000000f,0.62000000f,0.73000000f,-0.92000000f,0.71000000f,-0.73000000f,-0.58000000f,-0.10000000f,0.95000000f,-0.81000000f,0.05000000f,-0.40000000f,-0.70000000f,0.03000000f,-0.45000000f,0.88000000f,-0.89000000f,0.37000000f,-0.30000000f,-0.37000000f,0.07000000f,0.28000000f,-0.11000000f,-0.38000000f,0.32000000f,0.78000000f,0.21000000f,0.43000000f,0.77000000f,-0.57000000f,0.40000000f,-0.93000000f,0.16000000f,-0.66000000f,-0.66000000f,-0.82000000f,-0.13000000f,-0.69000000f,0.77000000f,0.54000000f,0.69000000f,-0.54000000f,0.29000000f,-0.77000000f,0.14000000f,0.25000000f,-0.14000000f,-0.98000000f,0.36000000f,0.00000000f,-0.17000000f,-0.07000000f,-0.25000000f,0.25000000f,-0.30000000f,-0.53000000f,0.79000000f,0.08000000f,-0.80000000f,-0.05000000f,-0.87000000f,0.22000000f,0.35000000f,0.32000000f,0.09000000f,-0.44000000f,-0.82000000f,0.77000000f,-0.17000000f,0.47000000f,-0.89000000f,-0.83000000f,0.33000000f,0.20000000f,0.93000000f,-0.44000000f,0.89000000f,-0.27000000f,-0.95000000f,0.03000000f,-0.23000000f,0.34000000f,0.35000000f,-0.22000000f,0.56000000f,-0.36000000f,0.20000000f,0.86000000f,-0.18000000f,-0.11000000f,-0.27000000f,-0.87000000f,-0.52000000f,-0.85000000f,-0.71000000f,-0.07000000f,-0.42000000f,-0.73000000f,-0.72000000f,-0.45000000f,0.21000000f,0.22000000f,0.35000000f,-0.67000000f,0.47000000f,-0.17000000f,-0.72000000f,-0.48000000f,0.64000000f,0.68000000f,-0.06000000f,-0.60000000f,-0.82000000f,0.84000000f,0.16000000f,0.49000000f,-0.16000000f,-0.57000000f,-0.16000000f,-0.86000000f,0.05000000f,-0.91000000f,-0.02000000f,0.11000000f,0.91000000f,0.64000000f,-0.68000000f,0.93000000f,-0.25000000f,-0.46000000f,0.70000000f,0.87000000f,0.97000000f,-0.75000000f,0.73000000f,-0.70000000f,0.63000000f,-0.08000000f,0.94000000f,0.84000000f,-0.55000000f,0.29000000f,-0.75000000f,-0.18000000f,0.15000000f,0.41000000f,0.33000000f,0.81000000f,-0.95000000f,-0.12000000f,-0.47000000f,0.19000000f,-0.12000000f,-0.49000000f,0.34000000f,0.23000000f,0.36000000f,0.51000000f,-0.45000000f,-0.97000000f,0.09000000f,-0.47000000f,0.54000000f,0.32000000f,0.46000000f,0.90000000f,-0.58000000f,-0.87000000f,-0.48000000f,-0.91000000f,-0.72000000f,-0.19000000f,-0.93000000f,0.30000000f,0.91000000f,-0.78000000f,-0.46000000f,0.19000000f,0.90000000f,-0.22000000f,-0.43000000f,0.56000000f,-0.42000000f,0.99000000f,-0.46000000f,0.18000000f,-0.75000000f,-0.77000000f,0.85000000f,-0.99000000f,0.10000000f,-0.92000000f,0.68000000f,-0.07000000f,-0.81000000f,-0.57000000f,-0.57000000f,-0.31000000f,0.74000000f,-0.01000000f,0.38000000f,0.00000000f,0.05000000f,-0.85000000f,-0.28000000f,0.91000000f,-0.78000000f,0.53000000f,0.02000000f,-0.12000000f,-0.90000000f,0.21000000f,-0.22000000f,-0.01000000f,-0.87000000f,0.45000000f,-0.37000000f,0.09000000f,0.90000000f,0.15000000f,-0.14000000f,0.66000000f,0.32000000f,0.18000000f,0.87000000f,0.74000000f,-0.35000000f,0.95000000f,0.23000000f,-0.89000000f,-0.81000000f,0.95000000f,0.96000000f,-0.43000000f,0.57000000f,-0.16000000f,-0.82000000f,-0.00000000f,-0.64000000f,0.18000000f,0.01000000f,0.19000000f,-0.90000000f,-0.55000000f,0.31000000f,0.41000000f,-0.41000000f,-0.31000000f,-0.32000000f,-0.65000000f,0.08000000f,0.77000000f,0.24000000f,-0.26000000f,0.39000000f,-0.72000000f,0.75000000f,-0.49000000f,0.19000000f,0.58000000f,0.55000000f,-0.71000000f,-0.12000000f,0.96000000f,-0.78000000f,0.73000000f,0.10000000f,-0.31000000f,0.25000000f,0.78000000f,-0.70000000f,-0.11000000f,-0.87000000f,-0.00000000f,0.66000000f,0.26000000f,0.80000000f,-0.21000000f,-0.94000000f,-0.99000000f,0.94000000f,0.78000000f,0.97000000f,-0.41000000f,-0.27000000f,0.23000000f,-0.20000000f,-0.32000000f,-0.86000000f,0.51000000f,0.67000000f,0.95000000f,0.71000000f,-0.63000000f,-0.26000000f,-0.20000000f,0.79000000f,0.34000000f,0.42000000f,0.27000000f,-0.49000000f,0.99000000f,0.59000000f,-0.09000000f,-0.23000000f,-0.10000000f,0.11000000f,-0.37000000f,-0.99000000f,0.73000000f,0.81000000f,-0.38000000f,-0.57000000f,0.90000000f,0.85000000f,-0.21000000f,-0.73000000f,0.74000000f,0.42000000f,-0.77000000f,-0.04000000f,0.16000000f,0.88000000f,-0.27000000f,-0.34000000f,-0.83000000f,-0.91000000f,-0.47000000f,0.18000000f,-0.06000000f,0.40000000f,-0.10000000f,-0.74000000f,-0.45000000f,-0.24000000f,-0.27000000f,-0.44000000f,-0.49000000f,-0.96000000f,-0.46000000f,-0.12000000f,0.76000000f,0.75000000f,-0.11000000f,-0.96000000f,0.54000000f,0.00000000f,-0.26000000f,0.81000000f,0.79000000f,0.67000000f,0.20000000f,0.69000000f,0.68000000f,0.01000000f,0.17000000f,-0.84000000f,-0.28000000f,-0.05000000f,0.49000000f,0.09000000f,0.12000000f,-0.30000000f,-0.02000000f,-0.02000000f,-0.62000000f,-0.12000000f,0.76000000f,-0.24000000f,0.86000000f,0.36000000f,0.36000000f,0.25000000f,-0.34000000f,-0.57000000f,0.92000000f,-0.72000000f,0.05000000f,0.76000000f,-0.36000000f,-0.54000000f,-0.03000000f,-0.66000000f,-0.95000000f,0.52000000f,0.87000000f,0.11000000f,0.17000000f,-0.88000000f,-0.37000000f,-0.13000000f,0.18000000f,0.03000000f,0.50000000f,0.59000000f,-0.15000000f,0.36000000f,0.72000000f,0.49000000f,0.62000000f,-0.12000000f,-0.69000000f,0.15000000f,0.80000000f,0.63000000f,-0.97000000f,0.19000000f,0.59000000f,0.38000000f,-0.14000000f,-0.72000000f,-0.71000000f,-0.08000000f,-0.36000000f,-0.23000000f,0.56000000f,0.34000000f,0.14000000f,0.68000000f,-0.90000000f,-0.15000000f,0.32000000f,0.08000000f,-0.87000000f,-0.89000000f,-0.93000000f,0.39000000f,0.30000000f,0.54000000f,-0.86000000f,-0.32000000f,-0.45000000f,-0.09000000f,-0.10000000f,0.37000000f,0.18000000f,-0.83000000f,-0.38000000f,-0.53000000f,-0.67000000f,0.98000000f,-0.29000000f,-0.03000000f,-0.30000000f,0.90000000f,-0.58000000f,0.39000000f,-0.29000000f,0.10000000f,0.11000000f,0.04000000f,0.80000000f,0.21000000f,0.08000000f,0.00000000f,0.50000000f,-0.25000000f,0.75000000f,0.26000000f,0.28000000f,0.26000000f,-0.59000000f,0.56000000f,0.68000000f,0.02000000f,0.55000000f,0.81000000f,-0.78000000f,0.14000000f,0.90000000f,-0.15000000f,0.48000000f,-0.74000000f,-0.61000000f,0.31000000f,0.72000000f,-0.82000000f,0.28000000f,0.27000000f,0.82000000f,-0.67000000f,0.90000000f,-0.88000000f,0.56000000f,-0.29000000f,0.05000000f,-0.46000000f,0.67000000f,-0.21000000f,-0.33000000f,0.28000000f,0.43000000f,-0.95000000f,0.88000000f,0.97000000f,0.41000000f,-0.68000000f,0.30000000f,0.04000000f,-0.77000000f,0.14000000f,-0.67000000f,-0.96000000f,0.01000000f,-0.92000000f,-0.55000000f,0.44000000f,-0.70000000f,-0.70000000f,0.37000000f,-0.07000000f,0.39000000f,-0.12000000f,-0.27000000f,-0.71000000f,0.06000000f,0.28000000f,0.92000000f,-0.79000000f,-0.82000000f,0.52000000f,0.26000000f,-0.21000000f,0.82000000f,-0.49000000f,0.88000000f,0.47000000f,0.45000000f,0.31000000f,0.44000000f,-0.98000000f,-0.23000000f,0.44000000f,0.13000000f,0.61000000f,-0.20000000f,-0.23000000f,-0.61000000f,-0.34000000f,0.35000000f,0.56000000f,-0.16000000f,0.57000000f,-0.46000000f,-0.56000000f,-0.92000000f,-0.31000000f,0.97000000f,-0.25000000f,-0.48000000f,-0.94000000f,0.74000000f,0.02000000f,-0.61000000f,-0.71000000f,0.57000000f,0.77000000f,0.33000000f,-0.52000000f,0.38000000f,0.78000000f,-0.79000000f,0.20000000f,-0.52000000f,0.44000000f,-0.45000000f,-0.36000000f,-0.93000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.84000000f,-0.83000000f,-0.72000000f,0.39000000f,0.32000000f,-0.87000000f,0.58000000f,-0.47000000f,0.08000000f,0.08000000f,-0.55000000f,0.22000000f,0.63000000f,0.21000000f,-0.15000000f,0.08000000f,-0.79000000f,-0.42000000f,0.49000000f,-0.89000000f,0.14000000f,-0.24000000f,-0.42000000f,0.34000000f,-0.20000000f,-0.26000000f,0.90000000f,0.98000000f,0.89000000f,-0.73000000f,-0.21000000f,-0.73000000f,0.36000000f,-0.51000000f,0.56000000f,-0.67000000f,0.65000000f,0.82000000f,0.39000000f,0.18000000f,0.76000000f,-0.26000000f,-0.75000000f,-0.83000000f,-0.94000000f,-0.04000000f,-0.80000000f,-0.89000000f,0.68000000f,-0.48000000f,-0.50000000f,0.75000000f,0.22000000f,0.87000000f,-0.06000000f,0.40000000f,-0.40000000f,-0.13000000f,0.17000000f,-0.01000000f,-0.40000000f,0.75000000f,0.42000000f,0.77000000f,0.28000000f,-0.41000000f,0.12000000f,0.55000000f,0.72000000f,-0.48000000f,-0.71000000f,0.75000000f,-0.18000000f,-0.51000000f,0.55000000f,0.35000000f,0.57000000f,0.03000000f,0.86000000f,0.52000000f,0.71000000f,0.50000000f,-0.25000000f,0.83000000f,0.57000000f,-0.51000000f,0.81000000f,0.03000000f,-0.81000000f,-0.78000000f,-0.70000000f,0.27000000f,0.55000000f,0.62000000f,0.55000000f,0.68000000f,-0.05000000f,-0.73000000f,-0.28000000f,0.24000000f,-0.33000000f,0.59000000f,-0.89000000f,0.78000000f,-0.91000000f,-0.77000000f,0.11000000f,-0.73000000f,0.57000000f,-0.26000000f,-0.25000000f,0.80000000f,0.47000000f,-0.09000000f,0.71000000f,0.15000000f,0.56000000f,0.27000000f,0.11000000f,-0.27000000f,-0.69000000f,0.45000000f,0.23000000f,0.87000000f,-0.35000000f,-0.31000000f,0.73000000f,-0.30000000f,-0.65000000f,0.36000000f,0.52000000f,-0.80000000f,0.62000000f,0.25000000f,0.31000000f,-0.42000000f,-0.32000000f,0.83000000f,-0.59000000f,-0.22000000f,-0.61000000f,-0.35000000f,-0.60000000f,-0.89000000f,-0.46000000f,-0.38000000f,-0.69000000f,-0.99000000f,0.87000000f,-0.04000000f,0.47000000f,0.31000000f,-0.07000000f,-0.64000000f,0.30000000f,-0.09000000f,-0.57000000f,0.28000000f,0.39000000f,0.75000000f,-0.44000000f,-0.50000000f,0.97000000f,0.74000000f,-0.86000000f,0.59000000f,0.28000000f,-0.48000000f,-0.96000000f,0.59000000f,0.17000000f,0.43000000f,0.84000000f,-0.80000000f,0.14000000f,0.10000000f,-0.25000000f,-0.99000000f,-0.89000000f,0.12000000f,-0.67000000f,-0.24000000f,0.65000000f,-0.20000000f,-0.73000000f,0.66000000f,0.80000000f,-0.46000000f,-0.32000000f,-0.60000000f,0.79000000f,-0.99000000f,0.22000000f,0.30000000f,-0.33000000f,0.49000000f,0.71000000f,-0.59000000f,-0.47000000f,-0.36000000f,0.93000000f,0.67000000f,-0.66000000f,-0.48000000f,0.04000000f,-0.11000000f,0.22000000f,0.55000000f,0.31000000f,0.26000000f,0.17000000f,-0.12000000f,0.39000000f,0.40000000f,-0.13000000f,0.44000000f,-0.36000000f,0.81000000f,0.69000000f,-0.47000000f,-0.07000000f,-0.94000000f,-0.06000000f,0.45000000f,-0.47000000f,0.12000000f,0.30000000f,0.81000000f,-0.50000000f,0.64000000f,0.56000000f,-0.01000000f,0.43000000f,-0.24000000f,0.45000000f,-0.30000000f,0.56000000f,-0.13000000f,0.44000000f,-0.17000000f,0.17000000f,0.76000000f,-0.32000000f,-0.49000000f,-0.13000000f,0.07000000f,-0.43000000f,-0.50000000f,-0.80000000f,-0.07000000f,-0.13000000f,0.93000000f,0.13000000f,-0.29000000f,-0.39000000f,0.53000000f,-0.89000000f,0.67000000f,0.25000000f,0.42000000f,-0.29000000f,0.48000000f,-0.37000000f,0.99000000f,0.99000000f,-0.12000000f,0.36000000f,0.64000000f,-0.79000000f,0.85000000f,-0.97000000f,-0.01000000f,-0.51000000f,-0.54000000f,-0.02000000f,-0.79000000f,-0.70000000f,-0.61000000f,0.24000000f,-0.12000000f,0.82000000f,0.18000000f,-0.91000000f,-0.83000000f,-0.90000000f,-0.32000000f,-0.14000000f,0.51000000f,0.05000000f,-0.63000000f,0.49000000f,0.57000000f,-0.31000000f,-0.97000000f,0.77000000f,-0.48000000f,0.05000000f,-0.75000000f,-0.72000000f,0.47000000f,-0.55000000f,0.19000000f,-0.76000000f,0.39000000f,-0.06000000f,-0.66000000f,0.20000000f,-0.85000000f,-0.09000000f,-0.76000000f,-0.84000000f,0.09000000f,0.74000000f,-0.09000000f,-0.75000000f,-0.69000000f,0.18000000f,0.27000000f,0.74000000f,0.73000000f,0.29000000f,0.70000000f,-0.59000000f,0.91000000f,0.93000000f,0.83000000f,0.40000000f,-0.87000000f,-0.29000000f,-0.93000000f,-0.33000000f,0.88000000f,-0.95000000f,-0.81000000f,-0.71000000f,0.96000000f,-0.37000000f,-0.39000000f,-0.23000000f,0.08000000f,0.71000000f,-0.18000000f,0.23000000f,0.61000000f,0.05000000f,0.19000000f,-0.19000000f,-0.81000000f,-0.05000000f,0.63000000f,0.84000000f,-0.12000000f,-0.33000000f,0.27000000f,0.49000000f,-0.29000000f,-0.30000000f,0.70000000f,-0.82000000f,-0.59000000f,0.59000000f,-0.28000000f,0.10000000f,-0.24000000f,0.13000000f,0.85000000f,-0.54000000f,-0.63000000f,0.65000000f,-0.06000000f,-0.59000000f,-0.97000000f,-0.36000000f,-0.40000000f,-0.34000000f,0.84000000f,-0.25000000f,0.77000000f,0.22000000f,0.87000000f,0.91000000f,-0.78000000f,0.74000000f,-0.13000000f,0.13000000f,0.07000000f,0.15000000f,0.92000000f,0.17000000f,-0.51000000f,0.06000000f,0.79000000f,-0.51000000f,-0.76000000f,-0.19000000f,-0.22000000f,0.74000000f,-0.31000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.97000000f,-0.59000000f,0.39000000f,-0.58000000f,-0.70000000f,-0.29000000f,0.44000000f,-0.71000000f,-0.77000000f,-0.83000000f,0.17000000f,-0.55000000f,-0.47000000f,0.98000000f,0.74000000f,-0.04000000f,0.57000000f,0.05000000f,0.64000000f,-0.53000000f,-0.23000000f,-0.15000000f,0.87000000f,-0.86000000f,0.45000000f,0.50000000f,-0.58000000f,0.35000000f,-0.89000000f,0.59000000f,-0.34000000f,-0.12000000f,-0.56000000f,-0.08000000f,0.93000000f,0.93000000f,0.27000000f,-0.60000000f,0.06000000f,0.47000000f,0.22000000f,0.49000000f,0.67000000f,-0.30000000f,0.83000000f,-0.13000000f,0.86000000f,-0.86000000f,-0.79000000f,-0.41000000f,0.30000000f,0.56000000f,0.88000000f,0.17000000f,0.40000000f,-0.84000000f,0.84000000f,-0.18000000f,0.95000000f,-0.17000000f,-0.52000000f,0.14000000f,0.04000000f,0.96000000f,0.21000000f,-0.42000000f,0.92000000f,0.32000000f,-0.24000000f,-0.11000000f,0.26000000f,-0.60000000f,-0.68000000f,0.91000000f,-0.37000000f,0.11000000f,0.76000000f,0.31000000f,0.39000000f,-0.25000000f,-0.10000000f,0.63000000f,0.20000000f,0.83000000f,-0.49000000f,0.71000000f,0.42000000f,-0.01000000f,0.15000000f,-0.47000000f,-0.13000000f,-0.69000000f,0.17000000f,0.90000000f,-0.21000000f,0.14000000f,0.60000000f,0.39000000f,-0.16000000f,0.23000000f,-0.33000000f,0.88000000f,-0.78000000f,-0.87000000f,0.15000000f,-0.68000000f,0.53000000f,-0.11000000f,0.43000000f,-0.54000000f,-0.57000000f,0.87000000f,0.81000000f,0.13000000f,-0.07000000f,0.18000000f,-0.32000000f,-0.85000000f,0.35000000f,-0.32000000f,0.75000000f,-0.80000000f,0.79000000f,-0.12000000f,0.55000000f,0.06000000f,-0.95000000f,0.50000000f,0.99000000f,-0.88000000f,0.75000000f,-0.69000000f,-0.23000000f,-0.53000000f,0.93000000f,-0.57000000f,0.29000000f,0.58000000f,-0.42000000f,0.75000000f,-0.92000000f,-0.13000000f,-0.16000000f,0.28000000f,-0.90000000f,-0.17000000f,-0.74000000f,-0.55000000f,0.99000000f,-0.82000000f,-0.24000000f,-0.43000000f,-0.52000000f,-0.45000000f,-0.02000000f,-0.70000000f,-0.26000000f,0.74000000f,0.21000000f,0.97000000f,-0.10000000f,-0.65000000f,-0.18000000f,-0.06000000f,-0.60000000f,0.54000000f,-0.76000000f,0.23000000f,0.21000000f,0.44000000f,0.06000000f,-0.80000000f,-0.87000000f,-0.13000000f,0.92000000f,0.97000000f,-0.04000000f,0.35000000f,-0.44000000f,-0.00000000f,-0.78000000f,-0.54000000f,-0.91000000f,0.19000000f,0.97000000f,-0.60000000f,0.35000000f,-0.64000000f,-0.84000000f,0.25000000f,0.90000000f,0.17000000f,-0.26000000f,-0.82000000f,0.59000000f,-0.62000000f,-0.14000000f,0.41000000f,0.62000000f,0.91000000f,-0.73000000f,0.62000000f,0.87000000f,0.50000000f,0.55000000f,-0.72000000f,0.00000000f,-0.19000000f,0.90000000f,0.30000000f,0.09000000f,-0.10000000f,-0.90000000f,0.66000000f,0.77000000f,0.63000000f,-0.07000000f,-0.92000000f,-0.63000000f,-0.86000000f,-0.08000000f,0.09000000f,0.38000000f,0.58000000f,0.76000000f,-0.98000000f,0.83000000f,-0.05000000f,-0.37000000f,0.52000000f,-0.57000000f,-0.31000000f,-0.47000000f,-0.49000000f,0.42000000f,-0.13000000f,-0.79000000f,0.60000000f,-0.08000000f,-0.12000000f,0.65000000f,-0.48000000f,0.79000000f,0.22000000f,0.71000000f,0.70000000f,0.78000000f,-0.25000000f,-0.05000000f,0.48000000f,0.14000000f,-0.85000000f,0.50000000f,-0.86000000f,0.31000000f,0.60000000f,0.72000000f,0.82000000f,-0.46000000f,-0.65000000f,-0.54000000f,0.26000000f,0.17000000f,-0.02000000f,-0.48000000f,0.36000000f,-0.63000000f,0.84000000f,0.62000000f,0.59000000f,-0.74000000f,0.00000000f,0.45000000f,0.08000000f,-0.54000000f,-0.34000000f,0.79000000f,0.38000000f,-0.17000000f,0.41000000f,0.30000000f,0.06000000f,0.22000000f,0.59000000f,0.23000000f,-0.36000000f,0.85000000f,-0.00000000f,-0.93000000f,0.74000000f,0.06000000f,-0.99000000f,-0.06000000f,-0.48000000f,0.27000000f,-0.97000000f,-0.44000000f,-0.12000000f,0.46000000f,-0.63000000f,-0.57000000f,-0.98000000f,0.72000000f,0.59000000f,-0.81000000f,0.96000000f,0.64000000f,-0.59000000f,0.13000000f,-0.80000000f,0.43000000f,0.23000000f,-0.66000000f,-0.74000000f,-0.52000000f,0.39000000f,-0.60000000f,-0.92000000f,0.49000000f,0.03000000f,0.84000000f,-0.72000000f,-0.97000000f,-0.81000000f,0.17000000f,0.79000000f,0.69000000f,-0.66000000f,0.11000000f,0.40000000f,-0.37000000f,0.46000000f,-0.74000000f,-0.50000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{5.41479996f,0.30130006f,-1.75299995f,3.74739996f,-0.21089990f,0.64179999f,-0.13359997f,-2.01010005f,1.27939999f,-2.19269994f,0.24369998f,1.70579990f,2.01920009f,-5.26079996f,2.32880005f,-0.69769999f,1.94730013f,1.03029994f,-0.36630006f,0.05919995f,-0.64590011f,-2.39479999f,-1.77060001f,0.94690000f,-0.02199997f,-0.52660001f,1.67040003f,-1.40240005f,0.47100004f,-2.25430007f,1.19439996f,-2.35719999f,0.27250003f,-0.02350007f,2.38229998f,0.69960008f,-0.72739994f,-0.81469998f,0.20989994f,1.58729995f,3.03290001f,-0.71070002f,-0.79409999f,1.30220002f,-1.43139998f,1.05660014f,1.49029997f,3.91539999f,1.51640006f,1.88949989f,2.02459998f,0.75429999f,-1.78060002f,0.17220000f,1.34449992f,-2.70039993f,-2.14089997f,-1.57490007f,3.45359999f,-0.77319998f,0.44090000f,-1.21950005f,-1.47140006f,2.17409999f,2.27459998f,0.67989998f,2.07830006f,1.13810005f,0.07710000f,1.23840001f,0.65939997f,0.58209995f,1.19530002f,-2.03789998f,-0.70819997f,-1.11389998f,1.00890005f,-0.57119998f,-3.26889988f,-0.89580001f,-1.90220001f,-4.84659993f,-0.65380001f,2.58529998f,-1.81190008f,2.32770007f,-1.91050008f,0.61980003f,3.34470000f,-0.50190000f,1.15419999f,3.27590004f,1.67069999f,-0.44140004f,0.66290013f,-1.22480000f,-0.06940002f,-4.15180002f,-2.58349998f,3.05500002f,0.81300000f,-2.00320007f,-0.58450005f,1.24609996f,-0.64949997f,-1.64340000f,-0.36380001f,1.40069996f,-0.17039994f,-3.62299990f,-1.81149998f,1.81740001f,1.46939985f,-1.21809996f,-0.49300002f,-3.76749999f,1.00589995f,0.06459997f,1.26860000f,0.53100012f,-2.67610002f,2.88689998f,1.08130000f,1.08890005f,-3.54959996f,-0.93259994f,0.59629995f,-4.35429997f,1.69259998f,0.53499993f,-1.56929992f,0.05359994f,-0.22099998f,0.26150014f,-1.16770012f,-4.11379989f,-0.61240004f,-1.36520004f,3.51470006f,1.00130001f,1.41680001f,-3.75679997f,2.94960005f,-1.69720000f,-0.41750002f,-1.96480008f,0.69979986f,0.31540003f,0.04779995f,-1.38779994f,-0.72039999f,-0.30569996f,4.39629998f,2.14330001f,-2.41419997f,1.27879994f,-2.56320009f,-0.25989996f,0.38629998f,-0.03420010f,-1.45160004f,2.79129996f,-0.68949995f,2.67699995f,-1.53559988f,-0.47080004f,3.97459989f,-0.93639994f,0.38369997f,-1.50490000f,1.23479998f,-2.30850006f,2.83040002f,-3.89150011f,1.11959992f,0.14600001f,-1.58849999f,-1.64829998f,1.18770008f,0.79179999f,-0.21090006f,1.93170001f,-1.01529998f,1.12339993f,-0.64839994f,-1.06270001f,-1.19979991f,0.82090009f,0.47620002f,-1.45770004f,4.09449993f,0.32919994f,-1.44649992f,-0.32059994f,1.36180000f,0.92340013f,-0.87219990f,3.93149998f,-4.28669994f,2.91649996f,0.21029997f,-1.61600007f,-0.81789991f,0.93110023f,-4.14460006f,1.85410008f,0.41020012f,0.04059987f,-0.13710001f,-0.42630007f,-1.41099998f,-0.38490004f,-1.64200001f,-1.51970006f,-1.61259996f,-3.04000000f,1.35639992f,-2.13169994f,1.59489996f,-0.94469993f,0.84670006f,2.34830001f,0.07749996f,0.77869992f,-3.37099999f,1.19430001f,-2.50760004f,1.11709997f,1.29199999f,-0.96429993f,0.10759995f,0.59299995f,-2.31559994f,-0.93629995f,-0.59050000f,1.49580010f,1.79930006f,2.70979998f,-1.27160010f,4.37180006f,3.26429996f,-1.63959996f,-0.92679991f,1.26239994f,0.75120005f,0.28309998f,-3.04169991f,-1.22639997f,-0.01640007f,-0.33099998f,1.25770001f,0.69220001f,0.67519994f,1.42910003f,3.07080007f,0.09930005f,-1.97609996f,5.05849994f,0.57750006f,2.12100010f,1.75490003f,-0.84809995f,-3.78830000f,1.74529997f,1.75300003f,-2.31619997f,1.06610006f,1.86140008f,-0.91760004f,2.01289998f,-0.31129992f,0.16640000f,0.79489998f,1.24529997f,1.51280002f,1.41279989f,1.02279993f,-1.02430009f,0.59150011f,2.22189999f,-3.04360001f,0.13810002f,0.54070010f,-2.91999994f,0.45279998f,3.46769997f,4.07240008f,-0.91409991f,0.87840007f,2.36299995f,-2.09599996f,2.36449998f,0.39899996f,-2.83239997f,1.19800004f,0.48079997f,2.42410001f,3.01140001f,-0.00979999f,0.63260002f,1.33209996f,0.86040007f,0.46279998f,-1.88550011f,-0.25460002f,0.34930001f,-0.84590003f,0.99700001f,-1.97170002f,-0.17819999f,-0.86360012f,-0.60850008f,1.52639996f,-2.02160001f,-1.10120001f,1.05429993f,-0.79779998f,-0.09040002f,0.03210001f,-0.00809998f,-1.87260002f,1.01290002f,-0.41369999f,-1.11740014f,-3.62280002f,1.60060007f,2.39319995f,0.15930007f,1.59670001f,-5.98590003f,1.19540007f,-0.09920001f,-0.73589994f,0.12150006f,0.27209999f,-1.63919995f,0.62900003f,0.17489992f,-1.87239993f,5.52209995f,4.21479992f,0.46329983f,-0.76229991f,-3.62290006f,-1.93739999f,-1.25340003f,3.31309982f,-0.05709987f,0.34239996f,0.35560002f,-1.81509996f,0.87150001f,0.38740010f,3.20750004f,4.73080002f,-0.52759991f,-1.90769999f,1.67630006f,1.43950006f,-0.49140015f,1.29780001f,1.35489990f,2.38209992f,0.41780007f,-0.82899995f,2.55369991f,0.88390008f,-0.55000010f,-0.41739999f,0.19530004f,-1.16299994f,0.91519993f,4.81649998f,-3.08380015f,2.12110012f,-1.11720001f,-2.35170005f,-0.97809999f,-0.74220004f,3.15529989f,2.51030010f,1.73349988f,-3.03749990f,-2.95280003f,0.62819999f,-0.95310008f,6.11920002f,0.08439996f,-0.42299998f,-2.07500001f,1.98690003f,1.07179999f,1.85480001f,-1.87449991f,2.38239997f,-1.01990002f,-0.12370002f,1.73239995f,1.90609998f,-3.05050003f,2.25050000f,-0.72110010f,-0.62859995f,0.41169995f,-0.16590000f,-2.93439995f,-3.68589988f,-0.20209996f,-2.16929991f,2.00040004f,-0.53299995f,0.88100007f,1.12169996f,0.62430010f,1.75839994f,-0.48069998f,1.72809998f,0.57879994f,-2.13470001f,1.05159994f,-2.82680000f,-0.80979995f,-1.44280003f,1.81149998f,2.14670007f,2.25229995f,1.00639991f,-2.86840009f,2.13930015f,-3.52299997f,4.22030008f,-1.75680001f,-0.74830001f,2.69490009f,0.24459993f,-1.58199998f,1.85470002f,2.59380008f,2.05019998f,-1.36550013f,2.17630000f,1.15540005f,0.69240012f,2.46100003f,-1.22159998f,4.97209997f,-0.49240003f,-0.48840002f,-2.27700004f,0.51709997f,1.88429999f,-1.67310010f,-1.21819998f,-1.06439995f,-0.38249999f,2.30430006f,3.26930008f,0.65709998f,-1.12320003f,-2.56429995f,1.23439992f,0.99330002f,3.12480004f,2.99510002f,2.77080005f,2.30719995f,2.31150001f,1.52639990f,0.46739999f,1.45049991f,-1.42240005f,0.31799997f,-0.69540000f,-0.16930005f,-1.19080000f,-0.17160008f,3.01799999f,3.27740005f,0.51590005f,-2.71370001f,-0.92010004f,-1.02820007f,-1.46620005f,-1.50040000f,0.18969996f,-0.22979998f,-0.76119999f,-1.48209995f,1.47069996f,-0.86269996f,2.86269996f,-1.69019995f,-2.42250003f,-2.26340009f,-0.50699986f,-3.46689992f,1.23080002f,1.42190010f,-2.61479999f,0.02779995f,-3.15709999f,-1.81749993f,2.01110001f,0.14800006f,-1.26129993f,2.25950001f,-0.02369999f,1.57980003f,0.27570007f,2.54419993f,1.65270008f,-2.48619996f,-4.60760008f,3.32269993f,0.04510005f,0.36040002f,-3.25309994f,-1.41820005f,-0.00679999f,0.03870002f,-3.70160001f,-2.86500002f,2.37859992f,-1.24629998f,-0.71139997f,-0.90460009f,2.08100000f,-1.80539996f,-1.79190001f,-1.96900003f,0.79320002f,-0.75569995f,-4.52690001f,-0.15470007f,-0.10180001f,-2.13080000f,-4.16219995f,-1.51569992f,0.04410007f,1.60890000f,-1.84989993f,-0.95799998f,0.42280002f,-1.00119989f,0.92500007f,-2.02750003f,-1.18559998f,-1.37609998f,-0.67919986f,2.62210011f,-0.90499994f,1.88390002f,1.34330006f,1.19479996f,1.01479992f,0.21069999f,-3.39019999f,-0.18880004f,-2.07450000f,-2.19300000f,2.36469995f,-1.53360004f,-1.95739996f,2.98420004f,-1.81579997f,-2.37650009f,1.36850008f,2.58989997f,-0.35510000f,-0.45519984f,1.06080001f,0.24280002f,0.88860000f,1.75160009f,-0.11909998f,0.08609994f,4.65079999f,2.70429998f,0.42090004f,0.33340003f,4.02930004f,-0.47149995f,-0.58560004f,0.04510005f,-0.68800001f,-2.14500001f,1.25770000f,4.25870003f,3.97839995f,0.80540010f,1.21240000f,-0.20399998f,2.69449995f,-1.16240000f,0.97440004f,2.27689995f,0.02260007f,1.72989998f,-0.12159998f,0.89540006f,2.42920009f,3.09250004f,1.53790000f,-1.34780000f,4.07719993f,0.59840007f,-1.08530000f,-1.76330009f,2.35460005f,2.95460004f,0.21120002f,-1.33259991f,-0.62899992f,-0.43090000f,1.08290005f,1.09199999f,2.61760006f,0.13100011f,1.17600003f,2.61960010f,0.44429998f,0.28499988f,4.20200001f,1.67379987f,-5.49900003f,-3.64530004f,0.58280010f,0.36549989f,-3.14349989f,-1.55819998f,-0.87669996f,-0.87880005f,1.03619999f,-0.42029998f,0.31260003f,1.51710005f,-0.25140006f,-2.32429994f,1.68180006f,0.58809995f,-0.53220008f,-3.92810000f,1.50820002f,3.14260006f,1.37499997f,-0.93210005f,2.77539998f,-0.09179997f,1.29499997f,3.58609998f,3.38710006f,-1.79870002f,-3.16270003f,-1.71419999f,-1.72110001f,5.44529996f,0.02199998f,1.94010008f,-4.52220006f,-0.46239992f,1.41450000f,2.68180006f,0.21999997f,-3.26559998f,2.98910018f,0.62760011f,0.58979998f,-1.40229980f,-0.36420012f,-2.61330002f,1.04869990f,0.82039993f,-2.13550002f,0.21940013f,1.91160011f,0.04659993f,4.00739997f,0.62060004f,-1.24959998f,-2.46010004f,-2.26809997f,1.64160004f,1.71170011f,1.18180000f,-0.94570001f,-2.42570004f,1.75099995f,-1.52020008f,-0.50700013f,-0.92800006f,2.18849989f,0.55239995f,-0.69719993f,-0.95899988f,-0.42620001f,-1.03859998f,-1.16150003f,1.85920008f,-2.14060005f,0.16629993f,2.12799995f,0.38919995f,-1.34790004f,-4.60279998f,2.77959992f,1.00510004f,-0.22069999f,-3.26939997f,1.15329997f,-3.92500007f,0.15130006f,-0.58939999f,-1.27410012f,2.11599990f,0.46620002f,0.27109995f,-2.56380002f,2.31240006f,1.67069995f,0.88050006f,0.48090000f,1.51629997f,1.27730007f,-2.16779998f,2.08460000f,-0.30370007f,1.80280002f,-1.73389999f,3.29240005f,3.72120003f,-3.15450009f,-1.89049991f,0.28749989f,-0.38430003f,-1.95039995f,-0.27419996f,0.67000000f,-0.35630002f,1.08139986f,-0.78200002f,-0.07060002f,-1.12990006f,1.98249998f,-1.34940001f,-0.04100000f,0.87480004f,-0.50790004f,1.48200003f,1.20419992f,-0.43399994f,0.39399993f,-4.42560007f,-0.96570002f,0.50929997f,0.71819996f,0.94830012f,-1.21799994f,-2.28639988f,-1.29219994f,0.86489995f,-0.52790000f,-1.81059994f,-0.69929994f,0.77550004f,0.19579998f,0.49199998f,4.21410005f,1.80079999f,-1.19669996f,-1.65809999f,0.13759992f,1.17039992f,0.44689992f,-1.78930003f,-1.27709994f,1.66880002f,-1.37370000f,-2.09559991f,1.44099998f,1.11040002f,-1.61950001f,-0.75440005f,-0.87430000f,-0.38249992f,-1.70819997f,-1.88820014f,2.08490014f,-0.50030001f,-0.47380006f,2.10360009f,-0.27770012f,7.15929992f,0.89730005f,-0.54199991f,-0.26799995f,1.80339994f,-1.72329997f,1.57680003f,-1.12570007f,0.29269993f,0.63690016f,-0.64119996f,1.20969998f,3.85860014f,0.42779996f,1.86650005f,-1.70540008f,2.30209997f,1.96190008f,-0.45300001f,1.25540010f,-2.35549999f,0.28109994f,0.34330006f,-0.78179992f,-0.98219998f,1.32260002f,1.77049996f,-0.68610002f,2.48360009f,0.66699987f,-3.36280001f,-3.93810001f,0.11469992f,0.14199995f,1.35540006f,0.22619994f,-0.26670011f,2.10419997f,-1.97689996f,4.54090008f,-2.82100001f,-0.89180000f,1.65720004f,-0.64760005f,-1.43769995f,0.42570002f,3.24020005f,0.36390001f,2.82390004f,-0.75640002f,-1.56879988f,-0.94820004f,-0.87539995f,-2.89190002f,0.91609999f,-0.17199987f,2.10920012f,0.16300006f,1.30329999f,-3.37819986f,-2.20779994f,0.38009996f,4.49309991f,-0.88229995f,0.41149999f,0.42580002f,-2.47220003f,0.05780000f,1.24830012f,-0.79100000f,0.74610010f,-1.28899995f,1.52829999f,2.63699998f,-2.69140007f,-0.16690005f,1.60279992f,-0.17139994f,-1.68899999f,2.95439995f,-1.22659996f,1.00470009f,-1.22670001f,1.95250004f,0.90730008f,0.42179996f,1.08319995f,-0.22339992f,1.76390004f,0.16170008f,0.62549998f,-0.26909997f,-1.67609993f,-1.32719992f,-1.72239987f,-0.93170001f,0.77850008f,-1.20029995f,-2.23079987f,2.87289994f,1.08819992f,0.67400000f,1.46280004f,-3.18570006f,1.75020001f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_4d_4items_strided_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{4,3,8,8,8,8};
    Shape shape_b{4,3,2,2,3,1};
    Shape shape_r{4,4,2,4,1,3};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{3,2,2,3},        // move_strides
                                                                  Strides{2,1,3,2},        // filter_dilation
                                                                  CoordinateDiff{0,0,0,0}, // below_pads
                                                                  CoordinateDiff{0,0,0,0}, // above_pads
                                                                  Strides{1,1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f,0.61000000f,0.17000000f,-0.91000000f,-0.48000000f,-0.48000000f,0.12000000f,-0.18000000f,0.08000000f,-0.16000000f,0.54000000f,-0.20000000f,-0.08000000f,0.19000000f,-0.81000000f,0.56000000f,-0.52000000f,0.32000000f,-0.37000000f,-0.17000000f,-0.46000000f,-0.34000000f,0.85000000f,0.11000000f,-0.10000000f,0.98000000f,-0.22000000f,0.68000000f,0.97000000f,-0.93000000f,-0.92000000f,0.32000000f,-0.19000000f,-0.61000000f,0.93000000f,0.54000000f,-0.75000000f,0.63000000f,0.38000000f,0.69000000f,-0.02000000f,0.19000000f,-0.38000000f,-0.44000000f,0.49000000f,-0.62000000f,-0.41000000f,-0.84000000f,0.93000000f,-0.74000000f,-0.57000000f,0.37000000f,-0.86000000f,-0.01000000f,0.58000000f,0.13000000f,-0.42000000f,0.68000000f,-0.05000000f,0.17000000f,0.09000000f,-0.67000000f,0.11000000f,-0.32000000f,0.08000000f,-0.29000000f,0.60000000f,0.69000000f,0.04000000f,0.85000000f,0.46000000f,0.41000000f,-0.78000000f,-0.98000000f,0.50000000f,-0.96000000f,-0.61000000f,-0.58000000f,0.00000000f,0.81000000f,-0.25000000f,-0.74000000f,-0.46000000f,-0.16000000f,0.32000000f,0.56000000f,-0.05000000f,-0.87000000f,0.59000000f,0.08000000f,-0.39000000f,0.67000000f,0.95000000f,0.70000000f,0.00000000f,-0.58000000f,0.85000000f,-0.14000000f,-0.27000000f,-0.63000000f,-0.75000000f,0.61000000f,-0.12000000f,-0.68000000f,-0.83000000f,0.12000000f,0.94000000f,-0.46000000f,0.27000000f,-0.14000000f,-0.96000000f,0.16000000f,-0.57000000f,0.92000000f,-0.24000000f,0.08000000f,0.60000000f,0.23000000f,-0.14000000f,-0.28000000f,0.14000000f,-0.19000000f,0.00000000f,-0.57000000f,0.18000000f,0.42000000f,0.17000000f,0.71000000f,-0.55000000f,0.89000000f,0.26000000f,-0.67000000f,0.68000000f,-0.75000000f,-0.62000000f,0.62000000f,-0.16000000f,-0.69000000f,-0.96000000f,-0.24000000f,0.00000000f,0.63000000f,-0.95000000f,-0.99000000f,0.06000000f,0.02000000f,-0.04000000f,0.95000000f,0.98000000f,0.13000000f,0.96000000f,-0.22000000f,-0.25000000f,-0.77000000f,-0.02000000f,-0.46000000f,0.28000000f,-0.61000000f,-0.56000000f,-0.65000000f,-0.23000000f,-0.41000000f,0.78000000f,-0.46000000f,0.44000000f,0.15000000f,0.46000000f,-0.90000000f,-0.25000000f,0.81000000f,0.28000000f,0.40000000f,0.56000000f,0.62000000f,-0.63000000f,-0.86000000f,-0.97000000f,0.22000000f,-0.58000000f,0.05000000f,0.53000000f,-0.38000000f,0.79000000f,0.60000000f,-0.63000000f,-0.18000000f,0.62000000f,-0.37000000f,0.48000000f,0.86000000f,0.70000000f,-0.52000000f,-0.39000000f,-0.44000000f,-0.69000000f,0.42000000f,-0.69000000f,0.48000000f,0.70000000f,-0.86000000f,-0.90000000f,0.69000000f,0.08000000f,-0.34000000f,-0.86000000f,0.66000000f,0.61000000f,0.47000000f,-0.22000000f,-0.51000000f,-0.29000000f,0.95000000f,-0.30000000f,-0.41000000f,0.85000000f,-0.13000000f,0.70000000f,-0.51000000f,-0.05000000f,-0.50000000f,-0.28000000f,-0.44000000f,0.33000000f,-0.08000000f,-0.88000000f,-0.64000000f,0.24000000f,-0.51000000f,0.67000000f,-0.40000000f,0.48000000f,0.92000000f,-0.64000000f,-0.42000000f,-0.62000000f,-0.77000000f,0.34000000f,0.29000000f,0.49000000f,0.82000000f,-0.30000000f,-0.40000000f,0.27000000f,0.61000000f,-0.75000000f,0.42000000f,0.69000000f,0.46000000f,0.41000000f,0.48000000f,0.14000000f,0.86000000f,-0.46000000f,-0.88000000f,-0.20000000f,-0.09000000f,-0.10000000f,0.70000000f,0.97000000f,-0.99000000f,0.53000000f,-0.51000000f,-0.70000000f,-0.96000000f,0.86000000f,-0.44000000f,-0.66000000f,-0.28000000f,0.08000000f,0.42000000f,-0.45000000f,-0.73000000f,-0.99000000f,-0.33000000f,0.40000000f,-0.86000000f,-0.84000000f,-0.06000000f,0.77000000f,0.96000000f,-0.06000000f,0.24000000f,0.21000000f,0.27000000f,-0.21000000f,-0.01000000f,0.16000000f,0.40000000f,0.06000000f,-0.61000000f,-0.66000000f,0.76000000f,0.43000000f,0.00000000f,0.37000000f,0.70000000f,-0.76000000f,0.50000000f,-0.38000000f,-0.24000000f,-0.80000000f,-0.66000000f,0.09000000f,-0.70000000f,0.83000000f,0.59000000f,-0.39000000f,-0.21000000f,0.84000000f,-0.17000000f,0.50000000f,-0.48000000f,-0.07000000f,-0.54000000f,-0.16000000f,0.99000000f,0.28000000f,0.29000000f,-0.68000000f,-0.49000000f,-0.18000000f,-0.41000000f,0.95000000f,0.72000000f,-0.26000000f,-0.42000000f,-0.27000000f,0.38000000f,-0.47000000f,0.24000000f,-0.38000000f,0.29000000f,0.34000000f,-0.30000000f,-0.64000000f,-0.27000000f,-0.27000000f,-0.94000000f,0.26000000f,0.52000000f,0.92000000f,0.53000000f,-0.80000000f,0.31000000f,0.29000000f,0.16000000f,-0.47000000f,0.61000000f,0.46000000f,-0.75000000f,-0.88000000f,0.95000000f,0.33000000f,-0.97000000f,-0.03000000f,0.43000000f,0.14000000f,0.73000000f,0.97000000f,-0.01000000f,0.45000000f,0.81000000f,0.77000000f,0.45000000f,0.16000000f,-0.66000000f,-0.29000000f,-0.23000000f,0.32000000f,0.22000000f,-0.09000000f,0.65000000f,-0.46000000f,0.65000000f,-0.01000000f,0.61000000f,-0.12000000f,0.36000000f,0.29000000f,-0.87000000f,-0.01000000f,-0.28000000f,-0.95000000f,0.37000000f,0.73000000f,-0.99000000f,0.47000000f,-0.69000000f,-0.31000000f,0.67000000f,-0.78000000f,-0.77000000f,-0.41000000f,0.95000000f,0.61000000f,0.52000000f,0.85000000f,-0.88000000f,0.97000000f,0.54000000f,0.53000000f,0.87000000f,-0.64000000f,-0.62000000f,0.70000000f,-0.11000000f,0.93000000f,-0.52000000f,-0.08000000f,0.03000000f,0.27000000f,-0.30000000f,-0.62000000f,0.00000000f,0.76000000f,0.12000000f,-0.83000000f,-0.60000000f,-0.95000000f,0.51000000f,0.85000000f,-0.27000000f,-0.83000000f,-0.20000000f,-0.45000000f,0.27000000f,-0.09000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.52000000f,-0.43000000f,-0.73000000f,-0.60000000f,-0.89000000f,0.15000000f,-0.12000000f,0.95000000f,0.97000000f,-0.43000000f,0.85000000f,0.43000000f,-0.35000000f,-0.44000000f,0.84000000f,0.94000000f,0.80000000f,-0.88000000f,-0.73000000f,-0.24000000f,0.93000000f,0.77000000f,0.15000000f,-0.63000000f,0.84000000f,0.70000000f,-0.24000000f,-0.01000000f,-0.63000000f,0.44000000f,0.50000000f,-0.29000000f,-0.27000000f,0.64000000f,0.28000000f,-0.18000000f,0.90000000f,-0.87000000f,-0.86000000f,-0.24000000f,0.66000000f,-0.49000000f,0.86000000f,0.19000000f,0.56000000f,-0.18000000f,-0.25000000f,-0.32000000f,-0.09000000f,0.83000000f,0.25000000f,0.92000000f,0.15000000f,0.71000000f,-0.91000000f,0.86000000f,-0.70000000f,0.05000000f,-0.23000000f,0.19000000f,0.32000000f,0.74000000f,-0.79000000f,-0.82000000f,0.44000000f,-0.91000000f,-0.61000000f,-0.99000000f,0.61000000f,-0.19000000f,0.14000000f,-0.46000000f,-0.33000000f,0.93000000f,0.29000000f,0.68000000f,-0.45000000f,0.47000000f,0.19000000f,-0.48000000f,0.03000000f,-0.10000000f,0.73000000f,-0.99000000f,0.72000000f,-0.58000000f,0.45000000f,-0.83000000f,0.07000000f,0.58000000f,0.02000000f,0.60000000f,0.71000000f,0.75000000f,-0.36000000f,0.19000000f,0.92000000f,-0.90000000f,-0.66000000f,0.57000000f,0.38000000f,0.86000000f,0.61000000f,0.31000000f,0.47000000f,-0.14000000f,-0.15000000f,0.27000000f,0.48000000f,0.44000000f,-0.45000000f,-0.83000000f,0.11000000f,0.96000000f,-0.38000000f,-0.12000000f,-0.72000000f,0.07000000f,-0.10000000f,-0.62000000f,0.21000000f,-0.33000000f,0.18000000f,0.18000000f,-0.50000000f,0.15000000f,0.38000000f,0.29000000f,-0.67000000f,-0.16000000f,-0.61000000f,0.36000000f,-0.50000000f,-0.87000000f,0.41000000f,0.41000000f,0.03000000f,0.71000000f,0.75000000f,-0.02000000f,0.13000000f,0.93000000f,0.51000000f,-0.86000000f,-0.43000000f,-0.97000000f,0.16000000f,-0.95000000f,-0.21000000f,-0.15000000f,-0.43000000f,0.53000000f,0.17000000f,0.18000000f,0.12000000f,-0.76000000f,0.56000000f,-0.71000000f,0.25000000f,-0.03000000f,-0.95000000f,0.65000000f,0.11000000f,0.29000000f,0.14000000f,0.04000000f,0.02000000f,-0.20000000f,-0.39000000f,0.23000000f,0.59000000f,0.07000000f,0.73000000f,-0.75000000f,0.67000000f,0.71000000f,-0.11000000f,-0.30000000f,0.26000000f,-0.93000000f,-0.01000000f,0.18000000f,-0.04000000f,-0.73000000f,-0.61000000f,-0.07000000f,0.00000000f,-0.68000000f,-0.58000000f,-0.95000000f,-0.51000000f,0.68000000f,-0.87000000f,0.07000000f,0.21000000f,0.87000000f,0.65000000f,-0.89000000f,0.57000000f,-0.48000000f,0.53000000f,-0.35000000f,-0.61000000f,-0.55000000f,0.62000000f,0.58000000f,-0.68000000f,-0.52000000f,0.33000000f,0.02000000f,0.74000000f,0.03000000f,0.44000000f,0.84000000f,-0.90000000f,-0.02000000f,-0.54000000f,0.55000000f,-0.24000000f,0.63000000f,0.31000000f,-0.67000000f,0.51000000f,0.67000000f,0.85000000f,0.68000000f,0.61000000f,0.04000000f,0.09000000f,0.70000000f,0.35000000f,-0.06000000f,-0.06000000f,-0.49000000f,0.81000000f,-0.24000000f,-0.70000000f,0.44000000f,0.18000000f,0.12000000f,0.17000000f,0.28000000f,0.26000000f,0.81000000f,-0.24000000f,-0.64000000f,0.32000000f,0.49000000f,-0.06000000f,0.13000000f,0.56000000f,-0.17000000f,-0.28000000f,-0.50000000f,0.89000000f,-0.20000000f,-0.34000000f,0.05000000f,0.71000000f,-0.09000000f,0.02000000f,-0.43000000f,-0.00000000f,-0.07000000f,0.25000000f,0.80000000f,0.18000000f,-0.37000000f,-0.16000000f,-0.42000000f,0.33000000f,0.76000000f,-0.81000000f,0.79000000f,0.88000000f,-0.62000000f,-0.49000000f,-0.79000000f,0.16000000f,0.19000000f,0.37000000f,-0.62000000f,-0.72000000f,-0.37000000f,0.39000000f,-0.84000000f,-0.13000000f,0.21000000f,0.88000000f,-0.80000000f,-0.06000000f,0.28000000f,-0.13000000f,-0.83000000f,-0.91000000f,-0.39000000f,0.19000000f,-0.71000000f,-0.08000000f,0.96000000f,0.89000000f,-0.60000000f,-0.79000000f,-0.13000000f,-0.00000000f,0.03000000f,0.97000000f,0.70000000f,-0.96000000f,-0.50000000f,-0.39000000f,0.13000000f,0.09000000f,0.29000000f,-0.43000000f,-0.40000000f,-0.83000000f,0.51000000f,-0.32000000f,-0.53000000f,0.07000000f,0.35000000f,0.43000000f,-0.65000000f,-0.94000000f,0.40000000f,-0.59000000f,0.80000000f,-0.15000000f,-0.22000000f,0.56000000f,0.90000000f,-0.82000000f,-0.74000000f,0.04000000f,-0.24000000f,-0.97000000f,0.96000000f,0.78000000f,0.29000000f,-0.44000000f,0.62000000f,0.92000000f,0.05000000f,-0.74000000f,-0.49000000f,-0.25000000f,0.34000000f,-0.99000000f,0.78000000f,-0.64000000f,0.09000000f,-0.51000000f,0.99000000f,-0.20000000f,0.95000000f,0.13000000f,-0.44000000f,-0.90000000f,-0.82000000f,0.84000000f,0.26000000f,-0.90000000f,0.97000000f,-0.09000000f,0.45000000f,-0.49000000f,0.29000000f,0.13000000f,0.37000000f,-0.03000000f,0.41000000f,-0.47000000f,0.25000000f,0.44000000f,0.31000000f,0.72000000f,0.09000000f,0.67000000f,0.76000000f,-0.79000000f,-0.99000000f,0.62000000f,-0.71000000f,-0.07000000f,0.63000000f,-0.02000000f,-0.28000000f,-0.02000000f,0.98000000f,0.28000000f,0.48000000f,-0.49000000f,0.32000000f,-0.11000000f,-0.45000000f,0.37000000f,-0.58000000f,-0.82000000f,-0.23000000f,-0.55000000f,-0.61000000f,-0.87000000f,-0.96000000f,-0.34000000f,-0.03000000f,-0.15000000f,-0.15000000f,-0.30000000f,-0.53000000f,0.83000000f,0.20000000f,-0.19000000f,-0.19000000f,0.23000000f,0.45000000f,0.50000000f,-0.67000000f,0.71000000f,-0.97000000f,0.42000000f,-0.33000000f,-0.88000000f,0.56000000f,0.78000000f,-0.09000000f,0.17000000f,0.77000000f,0.95000000f,-0.80000000f,-0.72000000f,0.23000000f,0.39000000f,-0.72000000f,-0.15000000f,-0.79000000f,-0.97000000f,0.97000000f,-0.20000000f,-0.56000000f,-0.95000000f,-0.65000000f,0.71000000f,-0.42000000f,0.10000000f,-0.58000000f,-0.14000000f,0.39000000f,-0.95000000f,-0.71000000f,-0.67000000f,0.62000000f,-0.10000000f,-0.11000000f,-0.76000000f,-0.30000000f,-0.62000000f,0.63000000f,-0.11000000f,-0.48000000f,0.37000000f,-0.08000000f,0.73000000f,-0.84000000f,-0.07000000f,-0.82000000f,-0.93000000f,0.63000000f,0.17000000f,-0.58000000f,-0.17000000f,0.83000000f,0.78000000f,-0.49000000f,-0.41000000f,0.29000000f,-0.90000000f,0.78000000f,-0.97000000f,-0.67000000f,0.47000000f,0.64000000f,-0.57000000f,0.89000000f,0.29000000f,-0.24000000f,0.75000000f,0.61000000f,0.45000000f,0.42000000f,0.16000000f,-0.75000000f,0.31000000f,0.66000000f,-0.04000000f,0.11000000f,-0.22000000f,-0.63000000f,-0.81000000f,0.48000000f,0.40000000f,-0.43000000f,0.37000000f,0.58000000f,0.18000000f,0.27000000f,-0.84000000f,0.31000000f,0.67000000f,-0.23000000f,0.74000000f,0.87000000f,-0.60000000f,-0.90000000f,-0.43000000f,0.07000000f,-0.58000000f,-0.01000000f,0.06000000f,-0.57000000f,-0.48000000f,-0.80000000f,0.30000000f,-0.69000000f,-0.37000000f,0.45000000f,0.85000000f,-0.17000000f,0.84000000f,-0.86000000f,0.36000000f,0.30000000f,0.49000000f,0.19000000f,-0.40000000f,-0.68000000f,-0.49000000f,0.61000000f,-0.07000000f,0.25000000f,-0.84000000f,0.42000000f,-0.23000000f,-0.28000000f,0.86000000f,-0.37000000f,0.13000000f,-0.29000000f,-0.93000000f,-0.28000000f,0.23000000f,0.25000000f,0.86000000f,0.33000000f,0.75000000f,0.75000000f,-0.61000000f,0.43000000f,0.09000000f,0.24000000f,-0.80000000f,-0.34000000f,-0.64000000f,0.25000000f,-0.07000000f,0.78000000f,0.29000000f,0.12000000f,0.28000000f,-0.72000000f,-0.72000000f,-0.70000000f,0.23000000f,-0.30000000f,-0.07000000f,-0.94000000f,0.97000000f,0.08000000f,-0.97000000f,0.20000000f,0.70000000f,0.38000000f,0.92000000f,-0.91000000f,-0.93000000f,-0.13000000f,0.05000000f,-0.56000000f,0.15000000f,-0.45000000f,-0.39000000f,-0.53000000f,0.25000000f,0.74000000f,0.85000000f,0.91000000f,0.25000000f,0.75000000f,0.32000000f,0.86000000f,0.99000000f,0.84000000f,0.17000000f,0.38000000f,0.16000000f,0.26000000f,0.37000000f,0.41000000f,-0.36000000f,-0.00000000f,-0.09000000f,0.70000000f,-0.40000000f,0.15000000f,0.76000000f,-0.17000000f,0.40000000f,-0.06000000f,0.14000000f,0.50000000f,-0.91000000f,0.44000000f,0.06000000f,0.30000000f,0.86000000f,0.45000000f,-0.88000000f,-0.06000000f,0.92000000f,-0.39000000f,0.83000000f,0.04000000f,-0.04000000f,0.70000000f,0.99000000f,-0.96000000f,0.02000000f,-0.45000000f,0.47000000f,0.71000000f,-0.50000000f,0.08000000f,0.98000000f,0.30000000f,-0.60000000f,-0.66000000f,0.66000000f,-0.51000000f,-0.86000000f,0.54000000f,0.51000000f,-0.36000000f,-0.48000000f,0.59000000f,-0.93000000f,0.64000000f,0.49000000f,0.23000000f,-0.72000000f,0.82000000f,-0.81000000f,-0.51000000f,-0.06000000f,0.58000000f,0.45000000f,-0.41000000f,-0.60000000f,-0.08000000f,-0.07000000f,0.47000000f,-0.48000000f,0.85000000f,-0.36000000f,-0.92000000f,0.48000000f,-0.36000000f,-0.09000000f,0.09000000f,-0.57000000f,-0.98000000f,0.67000000f,-0.53000000f,0.50000000f,-0.12000000f,-0.62000000f,-0.85000000f,0.37000000f,-0.98000000f,0.56000000f,0.65000000f,0.51000000f,0.54000000f,0.73000000f,-0.89000000f,0.07000000f,0.52000000f,0.92000000f,-0.26000000f,-0.93000000f,-0.82000000f,0.75000000f,0.96000000f,0.26000000f,-0.21000000f,-0.40000000f,-0.88000000f,-0.38000000f,-0.21000000f,-0.43000000f,-0.77000000f,0.48000000f,-0.95000000f,0.40000000f,0.43000000f,-0.24000000f,-0.72000000f,0.49000000f,-0.78000000f,0.82000000f,-0.21000000f,-0.15000000f,-0.56000000f,-0.94000000f,-0.51000000f,-0.10000000f,0.36000000f,0.68000000f,-0.78000000f,0.09000000f,-0.15000000f,-0.55000000f,0.21000000f,-0.11000000f,0.53000000f,-0.23000000f,-0.85000000f,-0.50000000f,0.66000000f,0.44000000f,0.47000000f,0.61000000f,0.22000000f,0.79000000f,0.71000000f,-0.91000000f,0.70000000f,-0.12000000f,-0.78000000f,0.45000000f,-0.40000000f,0.82000000f,0.27000000f,0.39000000f,0.87000000f,-0.23000000f,-0.37000000f,-0.78000000f,-0.19000000f,0.45000000f,0.29000000f,-0.45000000f,-0.30000000f,0.17000000f,-0.70000000f,0.09000000f,-0.85000000f,-0.67000000f,0.41000000f,0.37000000f,-0.12000000f,0.83000000f,0.92000000f,0.70000000f,-0.23000000f,0.62000000f,0.84000000f,0.13000000f,-0.36000000f,0.75000000f,-0.47000000f,-0.93000000f,0.00000000f,-0.71000000f,0.22000000f,-0.13000000f,-0.19000000f,-0.03000000f,-0.94000000f,-0.56000000f,-0.88000000f,-0.27000000f,-0.48000000f,0.98000000f,0.73000000f,0.87000000f,0.10000000f,0.04000000f,0.34000000f,0.51000000f,-0.95000000f,0.84000000f,0.17000000f,0.13000000f,-0.39000000f,0.37000000f,0.89000000f,-0.04000000f,-0.53000000f,-0.38000000f,0.00000000f,-0.00000000f,0.72000000f,0.08000000f,0.32000000f,0.69000000f,0.80000000f,0.00000000f,-0.12000000f,-0.79000000f,-0.75000000f,0.04000000f,-0.45000000f,0.08000000f,-0.96000000f,-0.95000000f,-0.44000000f,0.98000000f,0.10000000f,-0.28000000f,0.99000000f,-0.07000000f,0.53000000f,-0.86000000f,-0.01000000f,0.29000000f,-0.78000000f,-0.01000000f,0.22000000f,0.18000000f,-0.24000000f,-0.89000000f,0.12000000f,-0.67000000f,0.06000000f,-0.02000000f,-0.41000000f,-0.00000000f,0.91000000f,0.40000000f,-0.20000000f,0.25000000f,-0.08000000f,0.04000000f,0.42000000f,0.40000000f,0.39000000f,-0.22000000f,-0.23000000f,0.28000000f,0.48000000f,-0.72000000f,-0.85000000f,-0.22000000f,0.69000000f,-0.25000000f,-0.85000000f,-0.56000000f,0.80000000f,-0.91000000f,0.69000000f,-0.69000000f,0.86000000f,0.94000000f,0.87000000f,-0.47000000f,0.30000000f,-0.51000000f,-0.52000000f,0.74000000f,-0.43000000f,0.03000000f,-0.79000000f,0.76000000f,0.39000000f,0.00000000f,0.32000000f,-0.43000000f,-0.43000000f,-0.27000000f,0.08000000f,-0.20000000f,0.18000000f,0.01000000f,-0.12000000f,-0.22000000f,-0.64000000f,-0.56000000f,0.72000000f,-0.10000000f,-0.52000000f,-0.23000000f,0.93000000f,0.39000000f,0.14000000f,0.23000000f,0.81000000f,-0.37000000f,0.52000000f,-0.10000000f,-0.16000000f,-0.90000000f,0.35000000f,0.18000000f,-0.89000000f,0.72000000f,0.91000000f,-0.03000000f,-0.67000000f,0.43000000f,0.97000000f,-0.32000000f,-0.40000000f,0.85000000f,-0.25000000f,0.71000000f,-0.60000000f,0.71000000f,0.84000000f,0.20000000f,-0.97000000f,-0.66000000f,0.18000000f,0.71000000f,-0.29000000f,-0.73000000f,0.62000000f,0.76000000f,-0.12000000f,-0.80000000f,0.61000000f,0.38000000f,0.74000000f,0.44000000f,0.60000000f,0.23000000f,0.11000000f,-0.06000000f,-0.09000000f,-0.33000000f,-0.38000000f,0.17000000f,0.57000000f,0.91000000f,0.83000000f,0.89000000f,0.88000000f,0.83000000f,0.71000000f,0.97000000f,0.93000000f,0.23000000f,-0.36000000f,-0.21000000f,-0.77000000f,0.14000000f,0.52000000f,-0.48000000f,-0.21000000f,-0.86000000f,-0.39000000f,0.68000000f,0.46000000f,0.48000000f,0.09000000f,-0.10000000f,0.83000000f,0.63000000f,0.53000000f,0.40000000f,0.05000000f,-0.92000000f,0.61000000f,0.23000000f,0.23000000f,-0.49000000f,-0.12000000f,-0.88000000f,-0.03000000f,0.50000000f,-0.27000000f,0.44000000f,-0.59000000f,-0.50000000f,0.93000000f,-0.52000000f,-0.06000000f,-0.02000000f,0.57000000f,0.75000000f,0.56000000f,0.34000000f,-0.71000000f,-0.04000000f,-0.25000000f,0.81000000f,0.77000000f,-0.40000000f,0.69000000f,0.26000000f,0.86000000f,0.32000000f,0.69000000f,-0.64000000f,-0.75000000f,0.73000000f,-0.40000000f,-0.57000000f,0.95000000f,0.03000000f,-0.51000000f,0.15000000f,-0.25000000f,0.87000000f,0.23000000f,-0.61000000f,-0.37000000f,-0.44000000f,-0.04000000f,-0.84000000f,-0.07000000f,0.27000000f,-0.33000000f,0.68000000f,-0.59000000f,0.32000000f,0.06000000f,-0.80000000f,-0.47000000f,0.09000000f,-0.61000000f,-0.85000000f,-0.77000000f,0.78000000f,0.86000000f,-0.75000000f,-0.45000000f,-0.10000000f,-0.68000000f,-0.30000000f,-0.40000000f,0.83000000f,0.62000000f,0.97000000f,-0.71000000f,0.50000000f,-0.15000000f,-0.06000000f,0.99000000f,0.68000000f,-0.45000000f,0.81000000f,-0.82000000f,0.87000000f,-0.65000000f,-0.68000000f,-0.97000000f,0.68000000f,0.64000000f,0.19000000f,0.23000000f,0.51000000f,-0.96000000f,0.16000000f,0.05000000f,0.82000000f,-0.70000000f,0.08000000f,-0.13000000f,0.80000000f,0.87000000f,0.47000000f,0.27000000f,0.38000000f,0.27000000f,-0.61000000f,-0.63000000f,0.60000000f,0.91000000f,-0.03000000f,-0.65000000f,-0.26000000f,-0.59000000f,-0.08000000f,-0.00000000f,0.55000000f,-0.30000000f,0.28000000f,-0.81000000f,0.32000000f,-0.92000000f,-0.34000000f,0.55000000f,0.25000000f,-0.46000000f,0.93000000f,0.34000000f,0.69000000f,-0.59000000f,0.79000000f,0.95000000f,0.97000000f,0.91000000f,-0.53000000f,0.89000000f,0.29000000f,-0.23000000f,-0.49000000f,0.14000000f,-0.53000000f,0.22000000f,0.87000000f,0.10000000f,0.42000000f,0.31000000f,0.98000000f,-0.18000000f,-0.89000000f,-0.98000000f,-0.20000000f,0.31000000f,-0.54000000f,0.32000000f,-0.14000000f,0.16000000f,-0.24000000f,-0.77000000f,0.15000000f,0.76000000f,0.80000000f,0.70000000f,0.93000000f,-0.55000000f,0.25000000f,0.39000000f,0.16000000f,-0.80000000f,-0.64000000f,-0.51000000f,-0.48000000f,0.75000000f,0.50000000f,0.19000000f,-0.42000000f,-0.42000000f,0.75000000f,0.06000000f,0.61000000f,-0.75000000f,0.65000000f,0.27000000f,-0.72000000f,-0.20000000f,0.81000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.56000000f,-0.15000000f,-0.37000000f,0.38000000f,0.83000000f,-0.76000000f,-0.00000000f,-0.95000000f,0.99000000f,-0.51000000f,-0.06000000f,-0.47000000f,0.92000000f,0.03000000f,0.52000000f,-0.67000000f,0.73000000f,0.59000000f,-0.32000000f,-0.97000000f,0.41000000f,-0.37000000f,0.25000000f,0.77000000f,-0.40000000f,-0.01000000f,-0.95000000f,0.77000000f,-0.31000000f,-0.99000000f,-0.23000000f,-0.38000000f,-0.77000000f,-0.15000000f,-0.75000000f,-0.79000000f,0.85000000f,-0.56000000f,-0.80000000f,0.15000000f,0.75000000f,0.69000000f,-0.70000000f,-0.72000000f,-0.83000000f,0.16000000f,0.83000000f,0.95000000f,-0.33000000f,-0.16000000f,-0.56000000f,-0.36000000f,-0.94000000f,0.37000000f,0.51000000f,-0.95000000f,0.92000000f,-0.86000000f,0.88000000f,-0.63000000f,0.77000000f,0.12000000f,0.54000000f,0.99000000f,0.08000000f,0.38000000f,-0.42000000f,0.86000000f,-0.13000000f,0.45000000f,0.75000000f,0.10000000f,0.56000000f,0.78000000f,0.06000000f,-0.93000000f,0.77000000f,-0.47000000f,0.86000000f,-0.34000000f,-0.34000000f,0.61000000f,0.12000000f,-0.56000000f,0.64000000f,0.58000000f,-0.56000000f,0.32000000f,0.01000000f,-0.35000000f,0.10000000f,0.59000000f,-0.40000000f,0.19000000f,-0.02000000f,-0.53000000f,0.87000000f,-0.31000000f,-0.39000000f,0.80000000f,-0.53000000f,0.84000000f,0.69000000f,0.34000000f,0.46000000f,0.61000000f,-0.38000000f,0.85000000f,-0.38000000f,-0.90000000f,-0.57000000f,0.74000000f,0.21000000f,0.13000000f,-0.87000000f,-0.57000000f,-0.81000000f,-0.75000000f,-0.14000000f,0.99000000f,-0.49000000f,-0.65000000f,0.61000000f,-0.58000000f,-0.04000000f,-0.63000000f,-0.96000000f,-0.75000000f,-0.67000000f,-0.72000000f,-0.33000000f,0.50000000f,-0.01000000f,0.64000000f,0.97000000f,-0.08000000f,-0.34000000f,-0.84000000f,0.38000000f,-0.16000000f,0.42000000f,0.96000000f,0.80000000f,-0.53000000f,0.53000000f,0.51000000f,0.77000000f,-0.04000000f,-0.06000000f,0.65000000f,0.72000000f,0.82000000f,0.77000000f,-0.53000000f,-0.66000000f,-0.43000000f,0.95000000f,0.20000000f,0.14000000f,-0.27000000f,-0.13000000f,0.39000000f,-0.77000000f,0.07000000f,-0.14000000f,0.93000000f,0.69000000f,-0.03000000f,0.89000000f,0.51000000f,-0.40000000f,-0.68000000f,0.42000000f,-0.46000000f,-0.50000000f,0.15000000f,-0.81000000f,0.32000000f,-0.10000000f,0.26000000f,-0.10000000f,0.35000000f,-0.33000000f,0.70000000f,-0.35000000f,0.79000000f,0.97000000f,0.01000000f,-0.77000000f,-0.44000000f,-0.24000000f,-0.93000000f,0.21000000f,-0.74000000f,-0.64000000f,-0.25000000f,-0.90000000f,-0.26000000f,0.64000000f,-0.33000000f,0.82000000f,-0.12000000f,0.56000000f,-0.18000000f,-0.78000000f,-0.82000000f,-0.21000000f,-0.84000000f,-0.81000000f,-0.26000000f,0.20000000f,0.74000000f,-0.56000000f,0.86000000f,-0.17000000f,-0.36000000f,-0.02000000f,-0.16000000f,0.21000000f,0.61000000f,0.65000000f,-0.48000000f,0.04000000f,-0.38000000f,0.32000000f,-0.72000000f,0.22000000f,-0.16000000f,0.44000000f,0.25000000f,-0.51000000f,-0.64000000f,0.43000000f,0.72000000f,-0.88000000f,0.97000000f,-0.27000000f,0.40000000f,0.36000000f,0.49000000f,0.38000000f,-0.53000000f,-0.08000000f,-0.06000000f,0.69000000f,-0.27000000f,0.05000000f,0.72000000f,-0.48000000f,0.74000000f,0.80000000f,0.23000000f,0.00000000f,-0.49000000f,-0.85000000f,-0.30000000f,-0.43000000f,0.14000000f,-0.06000000f,0.03000000f,-0.83000000f,0.91000000f,-0.72000000f,0.27000000f,0.42000000f,-0.63000000f,-0.54000000f,0.92000000f,-0.87000000f,-0.49000000f,0.40000000f,0.60000000f,-0.24000000f,0.66000000f,-0.65000000f,-0.67000000f,0.15000000f,0.70000000f,0.89000000f,-0.13000000f,0.81000000f,-0.52000000f,-0.82000000f,-0.58000000f,-0.20000000f,0.08000000f,-0.51000000f,0.18000000f,0.99000000f,-0.80000000f,0.22000000f,-0.17000000f,-0.72000000f,-0.72000000f,0.39000000f,0.81000000f,-0.36000000f,0.92000000f,-0.63000000f,0.36000000f,0.21000000f,0.00000000f,-0.27000000f,-0.72000000f,-0.47000000f,-0.69000000f,0.93000000f,-0.60000000f,0.98000000f,-0.28000000f,-0.69000000f,0.24000000f,-0.32000000f,-0.13000000f,-0.37000000f,0.66000000f,-0.68000000f,0.82000000f,0.23000000f,-0.45000000f,0.19000000f,-0.02000000f,0.90000000f,-0.77000000f,-0.87000000f,0.94000000f,-0.53000000f,0.95000000f,0.90000000f,0.17000000f,0.80000000f,-0.86000000f,0.67000000f,0.58000000f,-0.27000000f,-0.87000000f,-0.15000000f,0.99000000f,-0.65000000f,0.08000000f,0.34000000f,-0.46000000f,-0.94000000f,0.78000000f,0.10000000f,-0.95000000f,0.54000000f,0.46000000f,0.89000000f,0.01000000f,-0.33000000f,0.43000000f,-0.19000000f,-0.87000000f,0.36000000f,0.84000000f,0.70000000f,-0.93000000f,-0.95000000f,0.86000000f,-0.33000000f,-0.60000000f,0.31000000f,0.70000000f,-0.39000000f,0.01000000f,-0.43000000f,-0.11000000f,-0.42000000f,-0.76000000f,0.72000000f,0.33000000f,0.40000000f,0.43000000f,-0.19000000f,-0.49000000f,0.24000000f,-0.45000000f,-0.02000000f,-0.12000000f,-0.50000000f,-0.74000000f,-0.53000000f,0.09000000f,0.39000000f,0.53000000f,0.02000000f,0.14000000f,0.40000000f,-0.81000000f,-0.28000000f,-0.32000000f,-0.00000000f,0.51000000f,0.54000000f,-0.12000000f,-0.30000000f,0.97000000f,-0.04000000f,-0.42000000f,-0.96000000f,-0.39000000f,0.81000000f,0.93000000f,-0.55000000f,0.46000000f,-0.79000000f,-0.99000000f,-0.53000000f,0.00000000f,-0.28000000f,0.08000000f,0.22000000f,0.34000000f,0.03000000f,-0.89000000f,0.36000000f,0.80000000f,-0.68000000f,0.50000000f,-0.08000000f,0.04000000f,0.98000000f,-0.36000000f,-0.97000000f,0.46000000f,-0.02000000f,-0.20000000f,0.66000000f,-0.67000000f,0.58000000f,0.46000000f,-0.14000000f,-0.74000000f,-0.68000000f,-0.22000000f,0.93000000f,-0.86000000f,-0.58000000f,0.66000000f,-0.03000000f,0.40000000f,0.60000000f,-0.65000000f,0.20000000f,0.96000000f,-0.04000000f,0.91000000f,0.95000000f,-0.19000000f,0.04000000f,0.89000000f,0.70000000f,-0.99000000f,0.27000000f,-0.55000000f,0.79000000f,0.99000000f,0.94000000f,-0.16000000f,0.16000000f,0.74000000f,-0.84000000f,-0.91000000f,-0.15000000f,0.70000000f,0.95000000f,-0.19000000f,-0.72000000f,0.23000000f,0.98000000f,-0.77000000f,-0.58000000f,-0.97000000f,0.20000000f,-0.89000000f,0.94000000f,-0.96000000f,0.78000000f,0.17000000f,0.51000000f,0.91000000f,-0.58000000f,-0.90000000f,-0.48000000f,0.03000000f,0.06000000f,-0.58000000f,0.67000000f,0.70000000f,-0.68000000f,0.13000000f,-0.02000000f,0.04000000f,-0.33000000f,0.64000000f,-0.72000000f,0.01000000f,0.71000000f,0.37000000f,0.31000000f,-0.39000000f,0.91000000f,0.19000000f,-0.34000000f,0.45000000f,-0.68000000f,-0.26000000f,-0.78000000f,-0.74000000f,0.43000000f,-0.05000000f,-0.29000000f,-0.98000000f,-0.07000000f,0.61000000f,-0.93000000f,0.05000000f,-0.44000000f,0.44000000f,0.89000000f,-0.08000000f,0.19000000f,0.95000000f,0.90000000f,0.63000000f,0.25000000f,0.09000000f,0.90000000f,-0.66000000f,0.62000000f,0.72000000f,-0.28000000f,0.76000000f,-0.90000000f,0.37000000f,-0.25000000f,0.60000000f,0.92000000f,-0.75000000f,0.86000000f,-0.79000000f,0.17000000f,-0.11000000f,-0.21000000f,-0.99000000f,-0.41000000f,0.18000000f,-0.59000000f,-0.04000000f,0.92000000f,-0.20000000f,-0.82000000f,0.70000000f,0.18000000f,-0.08000000f,0.04000000f,0.84000000f,-0.48000000f,-0.46000000f,-0.94000000f,-0.55000000f,0.64000000f,0.10000000f,-0.74000000f,-0.66000000f,-0.16000000f,0.52000000f,0.33000000f,-0.41000000f,0.24000000f,0.94000000f,0.22000000f,-0.04000000f,-0.90000000f,0.91000000f,0.13000000f,0.46000000f,0.18000000f,-0.33000000f,-0.48000000f,-0.92000000f,-0.54000000f,-0.90000000f,-0.20000000f,0.58000000f,-0.45000000f,-0.52000000f,-0.50000000f,-0.42000000f,-0.18000000f,-0.49000000f,-0.71000000f,0.61000000f,-0.32000000f,0.82000000f,-0.17000000f,-0.82000000f,0.37000000f,-0.73000000f,-0.22000000f,0.97000000f,0.79000000f,0.43000000f,0.75000000f,0.82000000f,-0.88000000f,0.15000000f,0.04000000f,0.50000000f,-0.21000000f,-0.38000000f,0.63000000f,-0.45000000f,-0.39000000f,0.34000000f,0.20000000f,-0.46000000f,-0.24000000f,-0.44000000f,-0.82000000f,0.63000000f,-0.36000000f,-0.03000000f,-0.20000000f,-0.31000000f,-0.51000000f,-0.44000000f,0.03000000f,-0.28000000f,0.86000000f,-0.98000000f,0.67000000f,-0.01000000f,0.37000000f,-0.58000000f,0.83000000f,-0.71000000f,0.88000000f,0.94000000f,-0.97000000f,-0.02000000f,0.53000000f,-0.47000000f,0.43000000f,0.45000000f,0.66000000f,-0.41000000f,0.01000000f,0.66000000f,-0.73000000f,0.98000000f,-0.51000000f,-0.25000000f,0.10000000f,0.86000000f,-0.61000000f,-0.38000000f,0.24000000f,-0.37000000f,-0.76000000f,0.10000000f,0.41000000f,-0.40000000f,0.45000000f,-0.94000000f,0.06000000f,-0.34000000f,-0.77000000f,-0.49000000f,0.10000000f,0.60000000f,0.59000000f,-0.18000000f,-0.29000000f,0.16000000f,0.66000000f,-0.79000000f,0.31000000f,-0.15000000f,-0.36000000f,0.28000000f,-0.83000000f,-0.40000000f,0.79000000f,-0.79000000f,0.01000000f,-0.10000000f,-0.89000000f,0.89000000f,-0.73000000f,-0.94000000f,-0.25000000f,0.90000000f,0.02000000f,0.87000000f,-0.72000000f,0.14000000f,0.01000000f,0.14000000f,0.33000000f,0.70000000f,-0.23000000f,0.31000000f,0.47000000f,-0.99000000f,0.74000000f,-0.94000000f,-0.18000000f,0.29000000f,0.74000000f,0.41000000f,-0.62000000f,-0.55000000f,-0.23000000f,-0.92000000f,-0.83000000f,-0.04000000f,0.62000000f,-0.21000000f,0.18000000f,0.54000000f,0.10000000f,0.01000000f,-0.56000000f,0.20000000f,-0.27000000f,0.95000000f,-0.72000000f,-0.81000000f,-0.37000000f,0.04000000f,0.35000000f,-0.43000000f,0.74000000f,0.96000000f,-0.39000000f,-0.25000000f,0.84000000f,-0.96000000f,0.63000000f,-0.21000000f,0.38000000f,0.08000000f,-0.30000000f,-0.96000000f,0.62000000f,0.52000000f,0.88000000f,0.24000000f,0.20000000f,-0.98000000f,-0.19000000f,0.73000000f,-0.92000000f,-0.26000000f,0.98000000f,0.23000000f,0.02000000f,-0.56000000f,-0.67000000f,0.84000000f,0.80000000f,-0.99000000f,0.90000000f,0.08000000f,0.54000000f,-0.42000000f,0.12000000f,0.61000000f,-0.37000000f,-0.33000000f,0.96000000f,0.77000000f,-0.97000000f,0.69000000f,-0.03000000f,0.32000000f,-0.05000000f,0.38000000f,-0.13000000f,-0.67000000f,-0.29000000f,0.78000000f,0.49000000f,0.06000000f,-0.80000000f,-0.11000000f,0.67000000f,0.22000000f,-0.76000000f,-0.30000000f,-0.78000000f,0.35000000f,0.64000000f,-0.14000000f,-0.56000000f,0.01000000f,-0.67000000f,-0.73000000f,-0.00000000f,0.49000000f,0.49000000f,-0.48000000f,-0.61000000f,0.93000000f,-0.05000000f,0.14000000f,0.47000000f,-0.07000000f,0.83000000f,0.97000000f,0.07000000f,-0.41000000f,-0.19000000f,0.17000000f,0.62000000f,0.58000000f,-0.37000000f,0.48000000f,-0.62000000f,-0.36000000f,0.94000000f,0.07000000f,-0.83000000f,0.49000000f,-0.81000000f,-0.77000000f,-0.21000000f,0.15000000f,-0.48000000f,-0.65000000f,0.88000000f,0.58000000f,0.74000000f,-0.88000000f,-0.78000000f,0.70000000f,-0.18000000f,0.37000000f,-0.84000000f,-0.49000000f,-0.39000000f,0.98000000f,0.06000000f,0.25000000f,0.97000000f,0.39000000f,0.38000000f,-0.67000000f,-0.52000000f,0.65000000f,-0.66000000f,-0.53000000f,0.38000000f,-0.30000000f,-0.51000000f,0.07000000f,-0.07000000f,0.01000000f,0.73000000f,0.38000000f,0.47000000f,-0.56000000f,0.44000000f,0.78000000f,-0.98000000f,-0.99000000f,-0.31000000f,-0.72000000f,0.91000000f,0.18000000f,-0.84000000f,-0.40000000f,-0.53000000f,0.33000000f,0.13000000f,0.37000000f,0.01000000f,0.81000000f,0.00000000f,-0.19000000f,-0.02000000f,-0.73000000f,0.65000000f,0.84000000f,-0.01000000f,0.16000000f,-0.07000000f,0.64000000f,0.22000000f,0.06000000f,0.49000000f,-0.28000000f,-0.84000000f,0.81000000f,-0.94000000f,0.32000000f,-0.07000000f,0.09000000f,0.95000000f,0.99000000f,-0.56000000f,0.64000000f,0.83000000f,0.51000000f,-0.93000000f,0.18000000f,-0.50000000f,0.38000000f,-0.07000000f,0.93000000f,0.63000000f,-0.29000000f,0.87000000f,-0.04000000f,0.63000000f,0.70000000f,-0.76000000f,0.02000000f,0.02000000f,-0.88000000f,-0.63000000f,-0.18000000f,-0.30000000f,-0.48000000f,-0.42000000f,0.93000000f,0.01000000f,0.36000000f,0.97000000f,-0.25000000f,0.93000000f,0.16000000f,0.46000000f,-0.31000000f,-0.32000000f,0.20000000f,0.43000000f,-0.93000000f,0.09000000f,0.97000000f,0.53000000f,-0.86000000f,-0.33000000f,0.77000000f,0.58000000f,-0.11000000f,0.55000000f,0.94000000f,-0.42000000f,-0.48000000f,0.05000000f,0.15000000f,0.58000000f,-0.59000000f,-0.41000000f,-0.53000000f,0.05000000f,0.96000000f,0.00000000f,0.60000000f,0.56000000f,-0.18000000f,0.49000000f,-0.44000000f,0.47000000f,-0.67000000f,-0.85000000f,0.91000000f,-0.28000000f,-0.17000000f,0.62000000f,-0.96000000f,0.81000000f,0.12000000f,0.54000000f,-0.52000000f,-0.12000000f,-0.28000000f,0.82000000f,0.02000000f,-0.11000000f,-0.51000000f,-0.45000000f,0.20000000f,0.69000000f,0.07000000f,0.48000000f,-0.48000000f,-0.01000000f,0.33000000f,0.64000000f,0.15000000f,-0.79000000f,-0.11000000f,0.28000000f,0.48000000f,0.58000000f,0.95000000f,-0.89000000f,0.01000000f,-0.16000000f,-0.66000000f,-0.92000000f,0.89000000f,-0.34000000f,0.50000000f,-0.28000000f,0.08000000f,-0.74000000f,0.29000000f,-0.02000000f,0.68000000f,0.15000000f,0.95000000f,0.21000000f,-0.58000000f,-0.11000000f,0.64000000f,0.73000000f,0.87000000f,-0.96000000f,-0.64000000f,-0.60000000f,-0.79000000f,0.35000000f,-0.54000000f,-0.65000000f,0.14000000f,-0.48000000f,0.02000000f,0.36000000f,-0.45000000f,0.07000000f,0.58000000f,0.62000000f,0.73000000f,-0.92000000f,0.71000000f,-0.73000000f,-0.58000000f,-0.10000000f,0.95000000f,-0.81000000f,0.05000000f,-0.40000000f,-0.70000000f,0.03000000f,-0.45000000f,0.88000000f,-0.89000000f,0.37000000f,-0.30000000f,-0.37000000f,0.07000000f,0.28000000f,-0.11000000f,-0.38000000f,0.32000000f,0.78000000f,0.21000000f,0.43000000f,0.77000000f,-0.57000000f,0.40000000f,-0.93000000f,0.16000000f,-0.66000000f,-0.66000000f,-0.82000000f,-0.13000000f,-0.69000000f,0.77000000f,0.54000000f,0.69000000f,-0.54000000f,0.29000000f,-0.77000000f,0.14000000f,0.25000000f,-0.14000000f,-0.98000000f,0.36000000f,0.00000000f,-0.17000000f,-0.07000000f,-0.25000000f,0.25000000f,-0.30000000f,-0.53000000f,0.79000000f,0.08000000f,-0.80000000f,-0.05000000f,-0.87000000f,0.22000000f,0.35000000f,0.32000000f,0.09000000f,-0.44000000f,-0.82000000f,0.77000000f,-0.17000000f,0.47000000f,-0.89000000f,-0.83000000f,0.33000000f,0.20000000f,0.93000000f,-0.44000000f,0.89000000f,-0.27000000f,-0.95000000f,0.03000000f,-0.23000000f,0.34000000f,0.35000000f,-0.22000000f,0.56000000f,-0.36000000f,0.20000000f,0.86000000f,-0.18000000f,-0.11000000f,-0.27000000f,-0.87000000f,-0.52000000f,-0.85000000f,-0.71000000f,-0.07000000f,-0.42000000f,-0.73000000f,-0.72000000f,-0.45000000f,0.21000000f,0.22000000f,0.35000000f,-0.67000000f,0.47000000f,-0.17000000f,-0.72000000f,-0.48000000f,0.64000000f,0.68000000f,-0.06000000f,-0.60000000f,-0.82000000f,0.84000000f,0.16000000f,0.49000000f,-0.16000000f,-0.57000000f,-0.16000000f,-0.86000000f,0.05000000f,-0.91000000f,-0.02000000f,0.11000000f,0.91000000f,0.64000000f,-0.68000000f,0.93000000f,-0.25000000f,-0.46000000f,0.70000000f,0.87000000f,0.97000000f,-0.75000000f,0.73000000f,-0.70000000f,0.63000000f,-0.08000000f,0.94000000f,0.84000000f,-0.55000000f,0.29000000f,-0.75000000f,-0.18000000f,0.15000000f,0.41000000f,0.33000000f,0.81000000f,-0.95000000f,-0.12000000f,-0.47000000f,0.19000000f,-0.12000000f,-0.49000000f,0.34000000f,0.23000000f,0.36000000f,0.51000000f,-0.45000000f,-0.97000000f,0.09000000f,-0.47000000f,0.54000000f,0.32000000f,0.46000000f,0.90000000f,-0.58000000f,-0.87000000f,-0.48000000f,-0.91000000f,-0.72000000f,-0.19000000f,-0.93000000f,0.30000000f,0.91000000f,-0.78000000f,-0.46000000f,0.19000000f,0.90000000f,-0.22000000f,-0.43000000f,0.56000000f,-0.42000000f,0.99000000f,-0.46000000f,0.18000000f,-0.75000000f,-0.77000000f,0.85000000f,-0.99000000f,0.10000000f,-0.92000000f,0.68000000f,-0.07000000f,-0.81000000f,-0.57000000f,-0.57000000f,-0.31000000f,0.74000000f,-0.01000000f,0.38000000f,0.00000000f,0.05000000f,-0.85000000f,-0.28000000f,0.91000000f,-0.78000000f,0.53000000f,0.02000000f,-0.12000000f,-0.90000000f,0.21000000f,-0.22000000f,-0.01000000f,-0.87000000f,0.45000000f,-0.37000000f,0.09000000f,0.90000000f,0.15000000f,-0.14000000f,0.66000000f,0.32000000f,0.18000000f,0.87000000f,0.74000000f,-0.35000000f,0.95000000f,0.23000000f,-0.89000000f,-0.81000000f,0.95000000f,0.96000000f,-0.43000000f,0.57000000f,-0.16000000f,-0.82000000f,-0.00000000f,-0.64000000f,0.18000000f,0.01000000f,0.19000000f,-0.90000000f,-0.55000000f,0.31000000f,0.41000000f,-0.41000000f,-0.31000000f,-0.32000000f,-0.65000000f,0.08000000f,0.77000000f,0.24000000f,-0.26000000f,0.39000000f,-0.72000000f,0.75000000f,-0.49000000f,0.19000000f,0.58000000f,0.55000000f,-0.71000000f,-0.12000000f,0.96000000f,-0.78000000f,0.73000000f,0.10000000f,-0.31000000f,0.25000000f,0.78000000f,-0.70000000f,-0.11000000f,-0.87000000f,-0.00000000f,0.66000000f,0.26000000f,0.80000000f,-0.21000000f,-0.94000000f,-0.99000000f,0.94000000f,0.78000000f,0.97000000f,-0.41000000f,-0.27000000f,0.23000000f,-0.20000000f,-0.32000000f,-0.86000000f,0.51000000f,0.67000000f,0.95000000f,0.71000000f,-0.63000000f,-0.26000000f,-0.20000000f,0.79000000f,0.34000000f,0.42000000f,0.27000000f,-0.49000000f,0.99000000f,0.59000000f,-0.09000000f,-0.23000000f,-0.10000000f,0.11000000f,-0.37000000f,-0.99000000f,0.73000000f,0.81000000f,-0.38000000f,-0.57000000f,0.90000000f,0.85000000f,-0.21000000f,-0.73000000f,0.74000000f,0.42000000f,-0.77000000f,-0.04000000f,0.16000000f,0.88000000f,-0.27000000f,-0.34000000f,-0.83000000f,-0.91000000f,-0.47000000f,0.18000000f,-0.06000000f,0.40000000f,-0.10000000f,-0.74000000f,-0.45000000f,-0.24000000f,-0.27000000f,-0.44000000f,-0.49000000f,-0.96000000f,-0.46000000f,-0.12000000f,0.76000000f,0.75000000f,-0.11000000f,-0.96000000f,0.54000000f,0.00000000f,-0.26000000f,0.81000000f,0.79000000f,0.67000000f,0.20000000f,0.69000000f,0.68000000f,0.01000000f,0.17000000f,-0.84000000f,-0.28000000f,-0.05000000f,0.49000000f,0.09000000f,0.12000000f,-0.30000000f,-0.02000000f,-0.02000000f,-0.62000000f,-0.12000000f,0.76000000f,-0.24000000f,0.86000000f,0.36000000f,0.36000000f,0.25000000f,-0.34000000f,-0.57000000f,0.92000000f,-0.72000000f,0.05000000f,0.76000000f,-0.36000000f,-0.54000000f,-0.03000000f,-0.66000000f,-0.95000000f,0.52000000f,0.87000000f,0.11000000f,0.17000000f,-0.88000000f,-0.37000000f,-0.13000000f,0.18000000f,0.03000000f,0.50000000f,0.59000000f,-0.15000000f,0.36000000f,0.72000000f,0.49000000f,0.62000000f,-0.12000000f,-0.69000000f,0.15000000f,0.80000000f,0.63000000f,-0.97000000f,0.19000000f,0.59000000f,0.38000000f,-0.14000000f,-0.72000000f,-0.71000000f,-0.08000000f,-0.36000000f,-0.23000000f,0.56000000f,0.34000000f,0.14000000f,0.68000000f,-0.90000000f,-0.15000000f,0.32000000f,0.08000000f,-0.87000000f,-0.89000000f,-0.93000000f,0.39000000f,0.30000000f,0.54000000f,-0.86000000f,-0.32000000f,-0.45000000f,-0.09000000f,-0.10000000f,0.37000000f,0.18000000f,-0.83000000f,-0.38000000f,-0.53000000f,-0.67000000f,0.98000000f,-0.29000000f,-0.03000000f,-0.30000000f,0.90000000f,-0.58000000f,0.39000000f,-0.29000000f,0.10000000f,0.11000000f,0.04000000f,0.80000000f,0.21000000f,0.08000000f,0.00000000f,0.50000000f,-0.25000000f,0.75000000f,0.26000000f,0.28000000f,0.26000000f,-0.59000000f,0.56000000f,0.68000000f,0.02000000f,0.55000000f,0.81000000f,-0.78000000f,0.14000000f,0.90000000f,-0.15000000f,0.48000000f,-0.74000000f,-0.61000000f,0.31000000f,0.72000000f,-0.82000000f,0.28000000f,0.27000000f,0.82000000f,-0.67000000f,0.90000000f,-0.88000000f,0.56000000f,-0.29000000f,0.05000000f,-0.46000000f,0.67000000f,-0.21000000f,-0.33000000f,0.28000000f,0.43000000f,-0.95000000f,0.88000000f,0.97000000f,0.41000000f,-0.68000000f,0.30000000f,0.04000000f,-0.77000000f,0.14000000f,-0.67000000f,-0.96000000f,0.01000000f,-0.92000000f,-0.55000000f,0.44000000f,-0.70000000f,-0.70000000f,0.37000000f,-0.07000000f,0.39000000f,-0.12000000f,-0.27000000f,-0.71000000f,0.06000000f,0.28000000f,0.92000000f,-0.79000000f,-0.82000000f,0.52000000f,0.26000000f,-0.21000000f,0.82000000f,-0.49000000f,0.88000000f,0.47000000f,0.45000000f,0.31000000f,0.44000000f,-0.98000000f,-0.23000000f,0.44000000f,0.13000000f,0.61000000f,-0.20000000f,-0.23000000f,-0.61000000f,-0.34000000f,0.35000000f,0.56000000f,-0.16000000f,0.57000000f,-0.46000000f,-0.56000000f,-0.92000000f,-0.31000000f,0.97000000f,-0.25000000f,-0.48000000f,-0.94000000f,0.74000000f,0.02000000f,-0.61000000f,-0.71000000f,0.57000000f,0.77000000f,0.33000000f,-0.52000000f,0.38000000f,0.78000000f,-0.79000000f,0.20000000f,-0.52000000f,0.44000000f,-0.45000000f,-0.36000000f,-0.93000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.84000000f,-0.83000000f,-0.72000000f,0.39000000f,0.32000000f,-0.87000000f,0.58000000f,-0.47000000f,0.08000000f,0.08000000f,-0.55000000f,0.22000000f,0.63000000f,0.21000000f,-0.15000000f,0.08000000f,-0.79000000f,-0.42000000f,0.49000000f,-0.89000000f,0.14000000f,-0.24000000f,-0.42000000f,0.34000000f,-0.20000000f,-0.26000000f,0.90000000f,0.98000000f,0.89000000f,-0.73000000f,-0.21000000f,-0.73000000f,0.36000000f,-0.51000000f,0.56000000f,-0.67000000f,0.65000000f,0.82000000f,0.39000000f,0.18000000f,0.76000000f,-0.26000000f,-0.75000000f,-0.83000000f,-0.94000000f,-0.04000000f,-0.80000000f,-0.89000000f,0.68000000f,-0.48000000f,-0.50000000f,0.75000000f,0.22000000f,0.87000000f,-0.06000000f,0.40000000f,-0.40000000f,-0.13000000f,0.17000000f,-0.01000000f,-0.40000000f,0.75000000f,0.42000000f,0.77000000f,0.28000000f,-0.41000000f,0.12000000f,0.55000000f,0.72000000f,-0.48000000f,-0.71000000f,0.75000000f,-0.18000000f,-0.51000000f,0.55000000f,0.35000000f,0.57000000f,0.03000000f,0.86000000f,0.52000000f,0.71000000f,0.50000000f,-0.25000000f,0.83000000f,0.57000000f,-0.51000000f,0.81000000f,0.03000000f,-0.81000000f,-0.78000000f,-0.70000000f,0.27000000f,0.55000000f,0.62000000f,0.55000000f,0.68000000f,-0.05000000f,-0.73000000f,-0.28000000f,0.24000000f,-0.33000000f,0.59000000f,-0.89000000f,0.78000000f,-0.91000000f,-0.77000000f,0.11000000f,-0.73000000f,0.57000000f,-0.26000000f,-0.25000000f,0.80000000f,0.47000000f,-0.09000000f,0.71000000f,0.15000000f,0.56000000f,0.27000000f,0.11000000f,-0.27000000f,-0.69000000f,0.45000000f,0.23000000f,0.87000000f,-0.35000000f,-0.31000000f,0.73000000f,-0.30000000f,-0.65000000f,0.36000000f,0.52000000f,-0.80000000f,0.62000000f,0.25000000f,0.31000000f,-0.42000000f,-0.32000000f,0.83000000f,-0.59000000f,-0.22000000f,-0.61000000f,-0.35000000f,-0.60000000f,-0.89000000f,-0.46000000f,-0.38000000f,-0.69000000f,-0.99000000f,0.87000000f,-0.04000000f,0.47000000f,0.31000000f,-0.07000000f,-0.64000000f,0.30000000f,-0.09000000f,-0.57000000f,0.28000000f,0.39000000f,0.75000000f,-0.44000000f,-0.50000000f,0.97000000f,0.74000000f,-0.86000000f,0.59000000f,0.28000000f,-0.48000000f,-0.96000000f,0.59000000f,0.17000000f,0.43000000f,0.84000000f,-0.80000000f,0.14000000f,0.10000000f,-0.25000000f,-0.99000000f,-0.89000000f,0.12000000f,-0.67000000f,-0.24000000f,0.65000000f,-0.20000000f,-0.73000000f,0.66000000f,0.80000000f,-0.46000000f,-0.32000000f,-0.60000000f,0.79000000f,-0.99000000f,0.22000000f,0.30000000f,-0.33000000f,0.49000000f,0.71000000f,-0.59000000f,-0.47000000f,-0.36000000f,0.93000000f,0.67000000f,-0.66000000f,-0.48000000f,0.04000000f,-0.11000000f,0.22000000f,0.55000000f,0.31000000f,0.26000000f,0.17000000f,-0.12000000f,0.39000000f,0.40000000f,-0.13000000f,0.44000000f,-0.36000000f,0.81000000f,0.69000000f,-0.47000000f,-0.07000000f,-0.94000000f,-0.06000000f,0.45000000f,-0.47000000f,0.12000000f,0.30000000f,0.81000000f,-0.50000000f,0.64000000f,0.56000000f,-0.01000000f,0.43000000f,-0.24000000f,0.45000000f,-0.30000000f,0.56000000f,-0.13000000f,0.44000000f,-0.17000000f,0.17000000f,0.76000000f,-0.32000000f,-0.49000000f,-0.13000000f,0.07000000f,-0.43000000f,-0.50000000f,-0.80000000f,-0.07000000f,-0.13000000f,0.93000000f,0.13000000f,-0.29000000f,-0.39000000f,0.53000000f,-0.89000000f,0.67000000f,0.25000000f,0.42000000f,-0.29000000f,0.48000000f,-0.37000000f,0.99000000f,0.99000000f,-0.12000000f,0.36000000f,0.64000000f,-0.79000000f,0.85000000f,-0.97000000f,-0.01000000f,-0.51000000f,-0.54000000f,-0.02000000f,-0.79000000f,-0.70000000f,-0.61000000f,0.24000000f,-0.12000000f,0.82000000f,0.18000000f,-0.91000000f,-0.83000000f,-0.90000000f,-0.32000000f,-0.14000000f,0.51000000f,0.05000000f,-0.63000000f,0.49000000f,0.57000000f,-0.31000000f,-0.97000000f,0.77000000f,-0.48000000f,0.05000000f,-0.75000000f,-0.72000000f,0.47000000f,-0.55000000f,0.19000000f,-0.76000000f,0.39000000f,-0.06000000f,-0.66000000f,0.20000000f,-0.85000000f,-0.09000000f,-0.76000000f,-0.84000000f,0.09000000f,0.74000000f,-0.09000000f,-0.75000000f,-0.69000000f,0.18000000f,0.27000000f,0.74000000f,0.73000000f,0.29000000f,0.70000000f,-0.59000000f,0.91000000f,0.93000000f,0.83000000f,0.40000000f,-0.87000000f,-0.29000000f,-0.93000000f,-0.33000000f,0.88000000f,-0.95000000f,-0.81000000f,-0.71000000f,0.96000000f,-0.37000000f,-0.39000000f,-0.23000000f,0.08000000f,0.71000000f,-0.18000000f,0.23000000f,0.61000000f,0.05000000f,0.19000000f,-0.19000000f,-0.81000000f,-0.05000000f,0.63000000f,0.84000000f,-0.12000000f,-0.33000000f,0.27000000f,0.49000000f,-0.29000000f,-0.30000000f,0.70000000f,-0.82000000f,-0.59000000f,0.59000000f,-0.28000000f,0.10000000f,-0.24000000f,0.13000000f,0.85000000f,-0.54000000f,-0.63000000f,0.65000000f,-0.06000000f,-0.59000000f,-0.97000000f,-0.36000000f,-0.40000000f,-0.34000000f,0.84000000f,-0.25000000f,0.77000000f,0.22000000f,0.87000000f,0.91000000f,-0.78000000f,0.74000000f,-0.13000000f,0.13000000f,0.07000000f,0.15000000f,0.92000000f,0.17000000f,-0.51000000f,0.06000000f,0.79000000f,-0.51000000f,-0.76000000f,-0.19000000f,-0.22000000f,0.74000000f,-0.31000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.97000000f,-0.59000000f,0.39000000f,-0.58000000f,-0.70000000f,-0.29000000f,0.44000000f,-0.71000000f,-0.77000000f,-0.83000000f,0.17000000f,-0.55000000f,-0.47000000f,0.98000000f,0.74000000f,-0.04000000f,0.57000000f,0.05000000f,0.64000000f,-0.53000000f,-0.23000000f,-0.15000000f,0.87000000f,-0.86000000f,0.45000000f,0.50000000f,-0.58000000f,0.35000000f,-0.89000000f,0.59000000f,-0.34000000f,-0.12000000f,-0.56000000f,-0.08000000f,0.93000000f,0.93000000f,0.27000000f,-0.60000000f,0.06000000f,0.47000000f,0.22000000f,0.49000000f,0.67000000f,-0.30000000f,0.83000000f,-0.13000000f,0.86000000f,-0.86000000f,-0.79000000f,-0.41000000f,0.30000000f,0.56000000f,0.88000000f,0.17000000f,0.40000000f,-0.84000000f,0.84000000f,-0.18000000f,0.95000000f,-0.17000000f,-0.52000000f,0.14000000f,0.04000000f,0.96000000f,0.21000000f,-0.42000000f,0.92000000f,0.32000000f,-0.24000000f,-0.11000000f,0.26000000f,-0.60000000f,-0.68000000f,0.91000000f,-0.37000000f,0.11000000f,0.76000000f,0.31000000f,0.39000000f,-0.25000000f,-0.10000000f,0.63000000f,0.20000000f,0.83000000f,-0.49000000f,0.71000000f,0.42000000f,-0.01000000f,0.15000000f,-0.47000000f,-0.13000000f,-0.69000000f,0.17000000f,0.90000000f,-0.21000000f,0.14000000f,0.60000000f,0.39000000f,-0.16000000f,0.23000000f,-0.33000000f,0.88000000f,-0.78000000f,-0.87000000f,0.15000000f,-0.68000000f,0.53000000f,-0.11000000f,0.43000000f,-0.54000000f,-0.57000000f,0.87000000f,0.81000000f,0.13000000f,-0.07000000f,0.18000000f,-0.32000000f,-0.85000000f,0.35000000f,-0.32000000f,0.75000000f,-0.80000000f,0.79000000f,-0.12000000f,0.55000000f,0.06000000f,-0.95000000f,0.50000000f,0.99000000f,-0.88000000f,0.75000000f,-0.69000000f,-0.23000000f,-0.53000000f,0.93000000f,-0.57000000f,0.29000000f,0.58000000f,-0.42000000f,0.75000000f,-0.92000000f,-0.13000000f,-0.16000000f,0.28000000f,-0.90000000f,-0.17000000f,-0.74000000f,-0.55000000f,0.99000000f,-0.82000000f,-0.24000000f,-0.43000000f,-0.52000000f,-0.45000000f,-0.02000000f,-0.70000000f,-0.26000000f,0.74000000f,0.21000000f,0.97000000f,-0.10000000f,-0.65000000f,-0.18000000f,-0.06000000f,-0.60000000f,0.54000000f,-0.76000000f,0.23000000f,0.21000000f,0.44000000f,0.06000000f,-0.80000000f,-0.87000000f,-0.13000000f,0.92000000f,0.97000000f,-0.04000000f,0.35000000f,-0.44000000f,-0.00000000f,-0.78000000f,-0.54000000f,-0.91000000f,0.19000000f,0.97000000f,-0.60000000f,0.35000000f,-0.64000000f,-0.84000000f,0.25000000f,0.90000000f,0.17000000f,-0.26000000f,-0.82000000f,0.59000000f,-0.62000000f,-0.14000000f,0.41000000f,0.62000000f,0.91000000f,-0.73000000f,0.62000000f,0.87000000f,0.50000000f,0.55000000f,-0.72000000f,0.00000000f,-0.19000000f,0.90000000f,0.30000000f,0.09000000f,-0.10000000f,-0.90000000f,0.66000000f,0.77000000f,0.63000000f,-0.07000000f,-0.92000000f,-0.63000000f,-0.86000000f,-0.08000000f,0.09000000f,0.38000000f,0.58000000f,0.76000000f,-0.98000000f,0.83000000f,-0.05000000f,-0.37000000f,0.52000000f,-0.57000000f,-0.31000000f,-0.47000000f,-0.49000000f,0.42000000f,-0.13000000f,-0.79000000f,0.60000000f,-0.08000000f,-0.12000000f,0.65000000f,-0.48000000f,0.79000000f,0.22000000f,0.71000000f,0.70000000f,0.78000000f,-0.25000000f,-0.05000000f,0.48000000f,0.14000000f,-0.85000000f,0.50000000f,-0.86000000f,0.31000000f,0.60000000f,0.72000000f,0.82000000f,-0.46000000f,-0.65000000f,-0.54000000f,0.26000000f,0.17000000f,-0.02000000f,-0.48000000f,0.36000000f,-0.63000000f,0.84000000f,0.62000000f,0.59000000f,-0.74000000f,0.00000000f,0.45000000f,0.08000000f,-0.54000000f,-0.34000000f,0.79000000f,0.38000000f,-0.17000000f,0.41000000f,0.30000000f,0.06000000f,0.22000000f,0.59000000f,0.23000000f,-0.36000000f,0.85000000f,-0.00000000f,-0.93000000f,0.74000000f,0.06000000f,-0.99000000f,-0.06000000f,-0.48000000f,0.27000000f,-0.97000000f,-0.44000000f,-0.12000000f,0.46000000f,-0.63000000f,-0.57000000f,-0.98000000f,0.72000000f,0.59000000f,-0.81000000f,0.96000000f,0.64000000f,-0.59000000f,0.13000000f,-0.80000000f,0.43000000f,0.23000000f,-0.66000000f,-0.74000000f,-0.52000000f,0.39000000f,-0.60000000f,-0.92000000f,0.49000000f,0.03000000f,0.84000000f,-0.72000000f,-0.97000000f,-0.81000000f,0.17000000f,0.79000000f,0.69000000f,-0.66000000f,0.11000000f,0.40000000f,-0.37000000f,0.46000000f,-0.74000000f,-0.50000000f,0.81000000f,-0.90000000f,0.66000000f,-0.06000000f,-0.42000000f,0.47000000f,0.12000000f,0.59000000f,-0.26000000f,0.12000000f,-0.93000000f,0.61000000f,-0.19000000f,-0.96000000f,-0.63000000f,-0.86000000f,-0.96000000f,0.33000000f,-0.80000000f,-0.31000000f,-0.22000000f,-0.73000000f,-0.39000000f,0.69000000f,-0.59000000f,0.17000000f,-0.24000000f,0.75000000f,-0.61000000f,-0.90000000f,0.23000000f,0.75000000f,-0.51000000f,-0.08000000f,-0.47000000f,0.37000000f,-0.30000000f,0.36000000f,0.75000000f,0.93000000f,0.97000000f,0.52000000f,0.64000000f,0.98000000f,-0.05000000f,0.34000000f,-0.66000000f,0.60000000f,0.44000000f,0.48000000f,0.53000000f,-0.61000000f,-0.57000000f,0.18000000f,-0.28000000f,0.80000000f,0.14000000f,0.31000000f,-0.54000000f,-0.56000000f,0.48000000f,0.28000000f,-0.86000000f,-0.04000000f,-0.12000000f,-0.97000000f,0.87000000f,-0.82000000f,-0.33000000f,-0.75000000f,0.67000000f,-0.05000000f,0.83000000f,0.14000000f,0.84000000f,-0.47000000f,0.25000000f,-0.52000000f,-0.48000000f,-0.86000000f,0.15000000f,0.19000000f,-0.45000000f,-0.48000000f,-0.33000000f,-0.98000000f,-0.61000000f,0.13000000f,0.83000000f,-0.45000000f,0.78000000f,0.16000000f,-0.52000000f,0.37000000f,0.07000000f,-0.98000000f,0.78000000f,0.91000000f,-0.26000000f,-0.30000000f,0.10000000f,-0.92000000f,0.17000000f,0.10000000f,0.44000000f,-0.31000000f,-0.50000000f,-0.85000000f,-0.29000000f,0.85000000f,-0.47000000f,0.13000000f,-0.59000000f,-0.71000000f,0.34000000f,0.39000000f,-0.72000000f,-0.46000000f,-0.66000000f,0.44000000f,0.95000000f,0.09000000f,-0.10000000f,0.81000000f,0.37000000f,-0.82000000f,0.24000000f,-0.58000000f,-0.79000000f,0.61000000f,-0.73000000f,0.45000000f,-0.76000000f,-0.55000000f,-0.06000000f,-0.59000000f,-0.04000000f,0.42000000f,0.08000000f,-0.51000000f,-0.87000000f,-0.54000000f,-0.25000000f,0.51000000f,-0.14000000f,0.78000000f,0.06000000f,0.44000000f,-0.40000000f,0.11000000f,-0.47000000f,0.36000000f,0.23000000f,0.12000000f,0.49000000f,-0.40000000f,-0.39000000f,0.45000000f,0.74000000f,-0.99000000f,-0.21000000f,0.03000000f,0.85000000f,0.59000000f,0.67000000f,0.15000000f,0.74000000f,0.34000000f,-0.49000000f,-0.59000000f,-0.82000000f,-0.82000000f,0.60000000f,0.12000000f,-0.61000000f,-0.19000000f,0.52000000f,-0.32000000f,0.96000000f,0.46000000f,0.95000000f,0.27000000f,0.97000000f,-0.01000000f,0.18000000f,0.81000000f,-0.55000000f,0.05000000f,-0.76000000f,-0.74000000f,0.08000000f,0.58000000f,-0.77000000f,0.43000000f,-0.55000000f,-0.78000000f,0.37000000f,0.39000000f,-0.37000000f,-0.03000000f,-0.75000000f,-0.46000000f,0.96000000f,0.50000000f,0.55000000f,-0.81000000f,0.39000000f,-0.54000000f,0.42000000f,-0.92000000f,-0.40000000f,0.31000000f,0.16000000f,-0.87000000f,-0.58000000f,0.41000000f,-0.31000000f,-0.74000000f,-0.36000000f,0.18000000f,0.00000000f,0.32000000f,0.32000000f,0.39000000f,-0.91000000f,0.50000000f,0.75000000f,0.38000000f,0.60000000f,0.11000000f,-0.56000000f,0.61000000f,-0.92000000f,0.38000000f,0.10000000f,-0.30000000f,-0.42000000f,0.35000000f,-0.51000000f,0.58000000f,0.84000000f,-0.37000000f,-0.00000000f,0.82000000f,0.15000000f,0.82000000f,-0.89000000f,0.34000000f,0.29000000f,-0.45000000f,-0.31000000f,-0.54000000f,0.02000000f,-0.69000000f,0.15000000f,-0.77000000f,-0.14000000f,-0.89000000f,-0.19000000f,-0.03000000f,-0.41000000f,0.20000000f,-0.28000000f,-0.60000000f,0.25000000f,-0.18000000f,0.82000000f,-0.38000000f,-0.20000000f,-0.25000000f,-0.18000000f,-0.85000000f,0.88000000f,-0.02000000f,0.97000000f,0.62000000f,-0.97000000f,0.63000000f,0.36000000f,-0.13000000f,-0.93000000f,-0.84000000f,0.63000000f,0.87000000f,-0.18000000f,-0.34000000f,-0.72000000f,0.63000000f,0.13000000f,-0.05000000f,-0.56000000f,0.81000000f,-0.19000000f,-0.89000000f,0.61000000f,0.71000000f,0.22000000f,0.45000000f,-0.44000000f,0.89000000f,0.67000000f,0.47000000f,0.85000000f,-0.50000000f,-0.03000000f,-0.73000000f,0.20000000f,-0.86000000f,0.71000000f,-0.12000000f,-0.16000000f,0.50000000f,0.47000000f,-0.95000000f,-0.37000000f,0.81000000f,0.85000000f,0.69000000f,0.46000000f,-0.77000000f,0.25000000f,0.15000000f,0.09000000f,-0.12000000f,-0.32000000f,0.93000000f,-0.04000000f,-0.66000000f,-0.41000000f,-0.91000000f,-0.84000000f,-0.32000000f,-0.51000000f,0.65000000f,0.09000000f,-0.18000000f,0.80000000f,0.55000000f,-0.30000000f,0.56000000f,0.22000000f,0.28000000f,-0.48000000f,-0.61000000f,-0.15000000f,-0.65000000f,-0.38000000f,0.03000000f,-0.83000000f,0.61000000f,0.83000000f,-0.14000000f,0.39000000f,-0.44000000f,-0.49000000f,-0.70000000f,0.35000000f,-0.72000000f,0.51000000f,0.09000000f,0.31000000f,0.98000000f,0.63000000f,0.74000000f,0.25000000f,-0.30000000f,0.20000000f,0.08000000f,0.81000000f,0.69000000f,0.16000000f,-0.85000000f,0.69000000f,0.20000000f,-0.68000000f,0.99000000f,0.14000000f,-0.65000000f,-0.21000000f,0.03000000f,0.06000000f,-0.16000000f,0.80000000f,0.95000000f,0.90000000f,-0.13000000f,0.05000000f,0.84000000f,0.56000000f,-0.42000000f,-0.58000000f,0.02000000f,-0.16000000f,-0.68000000f,0.03000000f,0.94000000f,-0.20000000f,-0.99000000f,0.99000000f,-0.20000000f,-0.69000000f,0.25000000f,-0.00000000f,0.55000000f,-0.11000000f,0.74000000f,0.96000000f,-0.12000000f,-0.50000000f,0.81000000f,0.97000000f,-0.56000000f,0.40000000f,0.94000000f,0.34000000f,-0.98000000f,-0.04000000f,-0.45000000f,-0.89000000f,-0.04000000f,-0.07000000f,-0.35000000f,0.58000000f,-0.52000000f,0.85000000f,0.94000000f,-0.92000000f,-0.46000000f,-0.51000000f,-0.30000000f,-0.98000000f,0.04000000f,0.45000000f,-0.08000000f,0.53000000f,-0.78000000f,0.43000000f,0.90000000f,-0.48000000f,-0.31000000f,-0.84000000f,-0.70000000f,-0.79000000f,-0.33000000f,0.13000000f,0.68000000f,-0.44000000f,0.21000000f,0.62000000f,0.73000000f,0.15000000f,0.72000000f,0.31000000f,0.21000000f,-0.78000000f,-0.89000000f,-0.96000000f,-0.69000000f,0.12000000f,0.45000000f,-0.47000000f,-0.91000000f,-0.33000000f,0.75000000f,0.87000000f,0.35000000f,-0.33000000f,0.08000000f,0.34000000f,-0.93000000f,0.55000000f,-0.30000000f,0.93000000f,0.60000000f,-0.06000000f,0.89000000f,-0.84000000f,-0.34000000f,0.59000000f,0.20000000f,-0.63000000f,-0.40000000f,0.10000000f,-0.47000000f,-0.79000000f,-0.05000000f,-0.28000000f,-0.97000000f,0.68000000f,0.58000000f,-0.96000000f,-0.32000000f,0.09000000f,-0.14000000f,0.20000000f,0.86000000f,0.33000000f,-0.27000000f,-0.62000000f,0.99000000f,-0.56000000f,0.87000000f,-0.75000000f,-0.53000000f,0.86000000f,-0.44000000f,-0.38000000f,-0.30000000f,-0.73000000f,-0.95000000f,-0.19000000f,0.16000000f,-0.16000000f,-0.87000000f,-0.41000000f,0.77000000f,-0.40000000f,0.90000000f,-0.10000000f,0.67000000f,-0.28000000f,-0.81000000f,0.66000000f,-0.97000000f,-0.21000000f,-0.08000000f,-0.57000000f,-0.80000000f,0.07000000f,-0.86000000f,-0.94000000f,-0.33000000f,-0.43000000f,-0.63000000f,0.52000000f,-0.74000000f,-0.07000000f,-0.17000000f,0.75000000f,0.10000000f,0.97000000f,0.70000000f,-0.01000000f,0.13000000f,0.28000000f,-0.59000000f,-0.25000000f,0.39000000f,0.44000000f,0.18000000f,0.38000000f,-0.95000000f,0.93000000f,-0.80000000f,0.37000000f,0.08000000f,0.42000000f,-0.84000000f,-0.05000000f,0.21000000f,0.96000000f,0.93000000f,-0.60000000f,0.96000000f,-0.50000000f,0.17000000f,-0.74000000f,0.47000000f,-0.16000000f,-0.05000000f,-0.36000000f,-0.46000000f,-0.62000000f,0.95000000f,0.44000000f,-0.45000000f,0.42000000f,-0.31000000f,0.79000000f,0.37000000f,-0.21000000f,-0.78000000f,-0.08000000f,-0.70000000f,-0.83000000f,0.02000000f,0.10000000f,-0.45000000f,-0.12000000f,-0.45000000f,-0.90000000f,0.95000000f,0.60000000f,0.34000000f,-0.38000000f,-0.22000000f,0.37000000f,0.04000000f,-0.21000000f,-0.63000000f,0.10000000f,0.61000000f,-0.76000000f,-0.48000000f,-0.45000000f,0.27000000f,0.96000000f,0.75000000f,0.09000000f,0.77000000f,0.99000000f,-0.35000000f,0.81000000f,0.95000000f,0.14000000f,-0.41000000f,-0.54000000f,-0.43000000f,0.25000000f,0.36000000f,-0.61000000f,-0.11000000f,0.83000000f,0.14000000f,0.56000000f,-0.42000000f,0.80000000f,0.35000000f,0.11000000f,-0.51000000f,-0.68000000f,-0.28000000f,0.05000000f,0.54000000f,-0.01000000f,-0.74000000f,-0.19000000f,-0.91000000f,0.86000000f,-0.05000000f,0.19000000f,-0.71000000f,-0.22000000f,0.39000000f,0.97000000f,0.08000000f,0.92000000f,-0.36000000f,0.29000000f,0.08000000f,0.99000000f,-0.31000000f,-0.94000000f,-0.37000000f,0.17000000f,0.41000000f,0.41000000f,-0.57000000f,-0.56000000f,-0.05000000f,0.88000000f,0.19000000f,0.91000000f,0.34000000f,0.07000000f,0.39000000f,-0.56000000f,0.76000000f,0.87000000f,-0.82000000f,0.79000000f,-0.29000000f,0.29000000f,0.79000000f,-0.00000000f,-0.68000000f,0.22000000f,0.75000000f,-0.29000000f,-0.92000000f,-0.57000000f,0.88000000f,-0.78000000f,-0.99000000f,0.88000000f,0.34000000f,0.82000000f,0.86000000f,-0.17000000f,0.79000000f,0.12000000f,0.42000000f,-0.50000000f,0.23000000f,0.83000000f,0.25000000f,0.77000000f,0.62000000f,-0.81000000f,-0.24000000f,0.47000000f,-0.49000000f,-0.45000000f,0.06000000f,-0.38000000f,-0.01000000f,0.15000000f,-0.16000000f,-0.63000000f,-0.25000000f,-0.99000000f,0.24000000f,0.85000000f,-0.69000000f,-0.37000000f,-0.27000000f,0.01000000f,-0.22000000f,0.73000000f,0.63000000f,-0.48000000f,0.87000000f,0.90000000f,-0.64000000f,0.68000000f,0.59000000f,0.11000000f,-0.83000000f,0.17000000f,0.87000000f,-0.88000000f,0.76000000f,-0.85000000f,-0.20000000f,0.94000000f,0.71000000f,0.16000000f,-0.40000000f,-0.73000000f,0.91000000f,0.61000000f,0.89000000f,-0.73000000f,0.79000000f,-0.48000000f,-0.18000000f,0.74000000f,0.64000000f,-0.74000000f,-0.89000000f,-0.84000000f,-0.28000000f,-0.00000000f,0.45000000f,0.50000000f,0.78000000f,0.84000000f,-0.54000000f,0.66000000f,0.67000000f,-0.58000000f,-0.67000000f,0.09000000f,-0.93000000f,-0.50000000f,-0.71000000f,-0.57000000f,0.44000000f,-0.20000000f,0.42000000f,-0.65000000f,-0.81000000f,0.37000000f,0.21000000f,-0.82000000f,-0.16000000f,0.84000000f,0.04000000f,0.51000000f,0.33000000f,-0.43000000f,0.44000000f,-0.82000000f,0.92000000f,-0.33000000f,-0.92000000f,0.76000000f,-0.33000000f,0.83000000f,-0.21000000f,-0.25000000f,0.28000000f,0.78000000f,0.70000000f,0.04000000f,0.65000000f,-0.44000000f,0.28000000f,-0.61000000f,-0.85000000f,0.26000000f,-0.86000000f,0.41000000f,0.02000000f,-0.44000000f,0.93000000f,0.27000000f,0.79000000f,-0.60000000f,0.91000000f,-0.25000000f,-0.92000000f,0.13000000f,0.87000000f,-0.29000000f,-0.89000000f,-0.56000000f,-0.91000000f,-0.95000000f,-0.72000000f,-0.62000000f,-0.99000000f,-0.89000000f,-0.89000000f,0.64000000f,-0.08000000f,0.70000000f,-0.78000000f,0.82000000f,-0.54000000f,0.97000000f,-0.26000000f,0.12000000f,0.46000000f,-0.26000000f,-0.46000000f,-0.65000000f,0.04000000f,-0.50000000f,0.34000000f,-0.78000000f,-0.54000000f,-0.29000000f,0.13000000f,0.19000000f,0.01000000f,-0.77000000f,-0.20000000f,-0.98000000f,0.43000000f,0.37000000f,0.80000000f,-0.97000000f,-0.99000000f,-0.66000000f,0.55000000f,0.85000000f,0.45000000f,0.58000000f,-0.29000000f,-0.54000000f,-0.95000000f,0.41000000f,0.14000000f,-0.84000000f,0.13000000f,0.06000000f,0.37000000f,0.23000000f,0.76000000f,0.88000000f,0.12000000f,-0.84000000f,-0.53000000f,-0.26000000f,0.26000000f,0.67000000f,-0.24000000f,0.76000000f,0.76000000f,0.12000000f,-0.13000000f,-0.05000000f,-0.12000000f,0.92000000f,0.40000000f,-0.68000000f,0.68000000f,0.00000000f,0.19000000f,-0.72000000f,0.06000000f,-0.66000000f,0.55000000f,0.77000000f,-0.71000000f,0.84000000f,0.59000000f,0.15000000f,0.27000000f,0.38000000f,-0.99000000f,-0.03000000f,0.65000000f,-0.94000000f,0.55000000f,-0.51000000f,0.40000000f,0.32000000f,0.33000000f,-0.93000000f,0.49000000f,0.83000000f,0.98000000f,0.32000000f,-0.45000000f,0.32000000f,-0.22000000f,0.37000000f,-0.35000000f,-0.30000000f,-0.63000000f,-0.72000000f,0.86000000f,-0.95000000f,0.70000000f,0.44000000f,0.12000000f,-0.66000000f,0.39000000f,0.67000000f,-0.56000000f,-0.25000000f,-0.64000000f,-0.15000000f,0.33000000f,0.37000000f,-0.26000000f,0.65000000f,0.13000000f,-0.98000000f,-0.27000000f,-0.94000000f,0.90000000f,-0.30000000f,-0.35000000f,0.24000000f,0.20000000f,-0.93000000f,0.24000000f,-0.17000000f,-0.80000000f,0.24000000f,0.92000000f,-0.81000000f,-0.61000000f,0.05000000f,-0.72000000f,0.12000000f,0.95000000f,-0.07000000f,-0.04000000f,0.74000000f,-0.10000000f,-0.07000000f,-0.55000000f,-0.07000000f,0.21000000f,-0.77000000f,-0.79000000f,0.52000000f,-0.76000000f,-0.02000000f,-0.18000000f,-0.88000000f,-0.76000000f,0.78000000f,-0.74000000f,-0.22000000f,0.26000000f,-0.51000000f,0.91000000f,0.33000000f,0.82000000f,0.67000000f,0.89000000f,-0.57000000f,0.47000000f,-0.30000000f,0.06000000f,0.46000000f,0.40000000f,0.33000000f,0.36000000f,-0.12000000f,0.80000000f,-0.46000000f,0.69000000f,0.60000000f,0.96000000f,0.69000000f,-0.85000000f,-0.16000000f,-0.44000000f,-0.13000000f,-0.58000000f,-0.93000000f,0.05000000f,0.51000000f,-0.02000000f,0.79000000f,-0.36000000f,0.27000000f,0.74000000f,0.67000000f,0.61000000f,-0.67000000f,-0.97000000f,-0.01000000f,0.78000000f,-0.94000000f,0.11000000f,-0.35000000f,-0.45000000f,-0.27000000f,0.51000000f,0.07000000f,-0.34000000f,0.46000000f,0.85000000f,-0.25000000f,0.84000000f,0.40000000f,-0.68000000f,-0.66000000f,-0.89000000f,0.72000000f,-0.52000000f,-0.46000000f,-0.19000000f,0.91000000f,0.09000000f,-0.56000000f,0.16000000f,0.01000000f,-0.29000000f,0.86000000f,-0.05000000f,0.50000000f,-0.98000000f,0.98000000f,-0.25000000f,0.21000000f,-0.52000000f,-0.45000000f,0.07000000f,0.97000000f,0.62000000f,0.51000000f,0.91000000f,-0.42000000f,0.80000000f,-0.33000000f,-0.77000000f,-0.98000000f,0.82000000f,-0.35000000f,0.96000000f,0.25000000f,-0.54000000f,0.50000000f,-0.66000000f,0.54000000f,-0.14000000f,0.53000000f,-0.96000000f,-0.05000000f,-0.85000000f,-0.03000000f,0.12000000f,-0.71000000f,-0.06000000f,0.47000000f,-0.80000000f,0.70000000f,0.88000000f,0.57000000f,-0.07000000f,-0.04000000f,-0.13000000f,0.80000000f,0.59000000f,-0.23000000f,-0.66000000f,-0.34000000f,-0.78000000f,0.95000000f,0.14000000f,0.24000000f,-0.37000000f,-0.29000000f,0.51000000f,-0.94000000f,-0.93000000f,-0.62000000f,-0.68000000f,0.58000000f,-0.13000000f,0.16000000f,0.50000000f,-0.23000000f,-0.01000000f,-0.24000000f,0.82000000f,-0.07000000f,-0.01000000f,-0.49000000f,0.23000000f,-0.00000000f,0.83000000f,-0.60000000f,0.72000000f,0.34000000f,-0.12000000f,-0.11000000f,-0.07000000f,0.01000000f,0.15000000f,-0.23000000f,0.58000000f,-0.60000000f,0.74000000f,0.43000000f,-0.15000000f,-0.41000000f,-0.29000000f,0.66000000f,0.60000000f,0.74000000f,-0.13000000f,0.48000000f,-0.13000000f,-0.35000000f,0.29000000f,-0.64000000f,-0.76000000f,0.27000000f,0.56000000f,0.72000000f,0.51000000f,-0.75000000f,-0.30000000f,0.53000000f,-0.62000000f,0.64000000f,0.11000000f,-0.93000000f,-0.12000000f,-0.43000000f,0.96000000f,0.49000000f,-0.66000000f,0.47000000f,-0.96000000f,-0.60000000f,0.72000000f,0.64000000f,0.39000000f,-0.53000000f,-0.61000000f,-0.37000000f,0.99000000f,-0.74000000f,0.50000000f,-0.32000000f,0.82000000f,-0.98000000f,-0.06000000f,-0.68000000f,0.32000000f,-0.28000000f,-0.64000000f,0.30000000f,-0.44000000f,0.60000000f,0.16000000f,-0.29000000f,-0.21000000f,-0.12000000f,0.19000000f,0.26000000f,-0.32000000f,-0.90000000f,0.88000000f,0.96000000f,-0.28000000f,0.51000000f,-0.86000000f,0.28000000f,0.43000000f,0.82000000f,-0.21000000f,-0.15000000f,0.15000000f,-0.70000000f,-0.70000000f,0.05000000f,-0.82000000f,-0.85000000f,-0.57000000f,0.13000000f,-0.22000000f,0.53000000f,0.80000000f,0.43000000f,0.30000000f,-0.77000000f,-0.95000000f,0.95000000f,0.95000000f,-0.21000000f,0.56000000f,0.56000000f,-0.66000000f,-0.70000000f,-0.03000000f,0.51000000f,0.79000000f,0.00000000f,-0.68000000f,0.25000000f,-0.15000000f,0.12000000f,0.07000000f,-0.18000000f,-0.57000000f,0.81000000f,0.22000000f,-0.80000000f,0.14000000f,0.14000000f,0.19000000f,0.65000000f,-0.06000000f,0.72000000f,-0.96000000f,-0.93000000f,-0.96000000f,-0.35000000f,0.06000000f,0.92000000f,-0.01000000f,-0.16000000f,0.13000000f,0.00000000f,-0.24000000f,0.79000000f,-0.15000000f,-0.29000000f,-0.83000000f,-0.38000000f,-0.91000000f,-0.17000000f,-0.21000000f,-0.89000000f,-0.24000000f,0.40000000f,-0.43000000f,-0.31000000f,0.45000000f,0.74000000f,0.77000000f,-0.98000000f,0.53000000f,0.87000000f,-0.42000000f,-0.37000000f,-0.95000000f,0.02000000f,-0.03000000f,0.21000000f,-0.39000000f,-0.27000000f,-0.66000000f,0.62000000f,-0.34000000f,0.34000000f,0.89000000f,-0.64000000f,-0.65000000f,-0.51000000f,-0.98000000f,0.14000000f,-0.49000000f,0.27000000f,0.10000000f,-0.71000000f,-0.20000000f,-0.01000000f,-0.51000000f,0.50000000f,-0.30000000f,0.98000000f,-0.46000000f,0.10000000f,-0.60000000f,-0.71000000f,-0.95000000f,0.49000000f,0.59000000f,0.00000000f,-0.19000000f,0.11000000f,-0.41000000f,0.08000000f,-0.50000000f,0.48000000f,0.19000000f,-0.80000000f,0.55000000f,-0.27000000f,0.14000000f,-0.66000000f,0.04000000f,-0.16000000f,-0.40000000f,0.18000000f,-0.50000000f,0.89000000f,-0.98000000f,0.27000000f,-0.39000000f,0.91000000f,-0.07000000f,-0.88000000f,-0.76000000f,-0.34000000f,0.10000000f,0.80000000f,-0.05000000f,-0.31000000f,-0.87000000f,0.65000000f,0.26000000f,-0.62000000f,0.55000000f,0.57000000f,-0.98000000f,0.11000000f,0.14000000f,-0.63000000f,-0.39000000f,0.13000000f,-0.87000000f,-0.60000000f,0.92000000f,-0.08000000f,-0.88000000f,0.08000000f,-0.82000000f,-0.12000000f,0.71000000f,0.41000000f,-0.81000000f,0.17000000f,0.16000000f,-0.52000000f,-0.44000000f,-0.58000000f,0.24000000f,-0.16000000f,0.42000000f,-0.87000000f,-0.41000000f,0.86000000f,0.51000000f,-0.42000000f,0.57000000f,0.44000000f,-0.90000000f,-0.37000000f,-0.11000000f,-0.13000000f,0.12000000f,-0.13000000f,-0.80000000f,-0.44000000f,-0.12000000f,0.76000000f,-0.65000000f,-0.00000000f,0.94000000f,-0.49000000f,0.64000000f,-0.20000000f,-0.02000000f,-0.30000000f,-0.70000000f,0.81000000f,0.37000000f,-0.12000000f,0.06000000f,-0.73000000f,-0.99000000f,-0.24000000f,0.66000000f,0.32000000f,-0.94000000f,0.29000000f,0.47000000f,0.32000000f,-0.20000000f,0.90000000f,0.37000000f,0.14000000f,-0.65000000f,-0.30000000f,0.03000000f,-0.81000000f,-0.85000000f,-0.45000000f,0.95000000f,0.52000000f,-0.64000000f,0.70000000f,-0.32000000f,-0.50000000f,0.34000000f,0.33000000f,0.44000000f,0.94000000f,0.39000000f,0.78000000f,-0.99000000f,0.35000000f,-0.04000000f,0.56000000f,-0.65000000f,0.33000000f,-0.57000000f,0.23000000f,-0.17000000f,-0.97000000f,0.70000000f,-0.68000000f,-0.23000000f,-0.60000000f,0.20000000f,-0.93000000f,0.00000000f,0.16000000f,0.92000000f,-0.19000000f,0.72000000f,0.28000000f,0.55000000f,0.97000000f,0.44000000f,-0.40000000f,-0.03000000f,0.86000000f,0.27000000f,0.31000000f,-0.50000000f,0.16000000f,0.03000000f,-0.49000000f,-0.09000000f,-0.64000000f,-0.17000000f,-0.01000000f,0.88000000f,0.07000000f,0.45000000f,-0.45000000f,-0.36000000f,-0.40000000f,0.69000000f,-0.54000000f,-0.44000000f,-0.74000000f,0.00000000f,-0.49000000f,-0.40000000f,-0.92000000f,0.16000000f,-0.21000000f,-0.39000000f,-0.26000000f,-0.63000000f,0.14000000f,-0.53000000f,0.31000000f,-0.83000000f,0.33000000f,0.31000000f,0.06000000f,-0.88000000f,0.12000000f,-0.20000000f,0.63000000f,0.35000000f,0.79000000f,-0.25000000f,0.77000000f,-0.79000000f,0.16000000f,0.64000000f,-0.49000000f,-0.14000000f,0.09000000f,-0.00000000f,0.46000000f,-0.96000000f,-0.00000000f,0.67000000f,0.74000000f,-0.23000000f,-0.25000000f,-0.16000000f,0.45000000f,-0.87000000f,0.73000000f,0.89000000f,-0.40000000f,0.85000000f,0.70000000f,-0.98000000f,0.11000000f,0.27000000f,0.64000000f,0.22000000f,-0.38000000f,0.80000000f,-0.38000000f,0.98000000f,0.87000000f,0.96000000f,0.54000000f,0.88000000f,0.46000000f,0.00000000f,-0.08000000f,0.94000000f,0.02000000f,-0.97000000f,0.16000000f,-0.04000000f,0.44000000f,-0.45000000f,-0.58000000f,0.38000000f,-0.49000000f,0.93000000f,0.78000000f,0.84000000f,-0.35000000f,0.28000000f,0.96000000f,0.16000000f,-0.58000000f,0.32000000f,0.34000000f,-0.43000000f,0.34000000f,0.68000000f,0.92000000f,-0.69000000f,0.48000000f,0.42000000f,-0.13000000f,-0.54000000f,0.09000000f,0.70000000f,-0.85000000f,0.74000000f,-0.55000000f,-0.18000000f,0.45000000f,-0.49000000f,0.12000000f,0.33000000f,-0.49000000f,-0.68000000f,-0.67000000f,0.60000000f,0.61000000f,-0.87000000f,0.13000000f,0.68000000f,-0.56000000f,0.83000000f,-0.16000000f,0.26000000f,-0.18000000f,-0.80000000f,-0.47000000f,0.80000000f,-0.25000000f,0.36000000f,-0.12000000f,-0.98000000f,0.78000000f,-0.58000000f,0.76000000f,-0.25000000f,0.34000000f,0.42000000f,0.76000000f,0.09000000f,-0.97000000f,0.57000000f,0.01000000f,0.82000000f,0.02000000f,-0.67000000f,-0.15000000f,0.99000000f,-0.27000000f,0.19000000f,-0.16000000f,-0.28000000f,-0.70000000f,0.17000000f,0.68000000f,0.00000000f,0.81000000f,-0.88000000f,-0.43000000f,-0.71000000f,-0.90000000f,-0.12000000f,-0.31000000f,-0.15000000f,-0.12000000f,-0.44000000f,0.58000000f,0.26000000f,-0.41000000f,-0.23000000f,-0.06000000f,-0.71000000f,-0.21000000f,0.66000000f,-0.27000000f,0.31000000f,0.55000000f,-0.43000000f,-0.23000000f,-0.98000000f,0.17000000f,-0.03000000f,0.66000000f,0.13000000f,0.41000000f,-0.20000000f,-0.93000000f,-0.33000000f,-0.25000000f,0.23000000f,-0.15000000f,0.19000000f,0.73000000f,0.24000000f,-0.49000000f,0.16000000f,0.24000000f,-0.12000000f,-0.21000000f,-0.61000000f,-0.11000000f,-0.23000000f,-0.98000000f,-0.51000000f,0.19000000f,0.09000000f,0.32000000f,0.99000000f,0.28000000f,0.19000000f,0.66000000f,0.74000000f,0.89000000f,-0.10000000f,0.04000000f,-0.12000000f,0.79000000f,0.36000000f,0.17000000f,0.51000000f,-0.66000000f,-0.09000000f,0.75000000f,-0.88000000f,-0.67000000f,-0.74000000f,-0.63000000f,-0.36000000f,-0.93000000f,0.61000000f,-0.12000000f,-0.00000000f,0.06000000f,0.58000000f,-0.27000000f,0.73000000f,-0.97000000f,-0.03000000f,-0.97000000f,0.99000000f,-0.11000000f,-0.55000000f,-0.59000000f,-0.44000000f,-0.90000000f,-0.13000000f,0.20000000f,0.85000000f,0.90000000f,0.38000000f,-0.46000000f,-0.41000000f,0.18000000f,-0.87000000f,-0.82000000f,0.61000000f,-0.75000000f,0.20000000f,-0.74000000f,-0.68000000f,-0.22000000f,-0.21000000f,0.68000000f,-0.00000000f,0.38000000f,-0.50000000f,-0.21000000f,0.11000000f,0.94000000f,-0.98000000f,0.59000000f,-0.69000000f,-0.36000000f,0.92000000f,-0.76000000f,-0.73000000f,-0.29000000f,0.23000000f,-0.52000000f,0.18000000f,0.26000000f,0.37000000f,0.08000000f,0.35000000f,-0.61000000f,0.71000000f,0.36000000f,0.00000000f,-0.67000000f,0.57000000f,0.63000000f,-0.04000000f,0.06000000f,-0.96000000f,0.40000000f,0.37000000f,0.86000000f,0.05000000f,0.49000000f,0.78000000f,-0.47000000f,-0.90000000f,0.53000000f,-0.30000000f,-0.57000000f,-0.72000000f,0.25000000f,0.06000000f,0.98000000f,0.89000000f,-0.66000000f,-0.83000000f,0.55000000f,0.35000000f,0.84000000f,0.27000000f,-0.56000000f,-0.40000000f,-0.56000000f,-0.40000000f,-0.83000000f,0.69000000f,-0.05000000f,-0.39000000f,0.87000000f,-0.81000000f,-0.29000000f,-0.94000000f,0.10000000f,-0.32000000f,-0.48000000f,0.43000000f,-0.40000000f,-0.64000000f,0.31000000f,0.98000000f,-0.96000000f,-0.99000000f,-0.70000000f,0.23000000f,0.95000000f,-0.59000000f,-0.04000000f,-0.06000000f,0.95000000f,-0.52000000f,0.18000000f,0.79000000f,-0.28000000f,-0.30000000f,-0.23000000f,0.66000000f,0.49000000f,-0.21000000f,-0.84000000f,-0.27000000f,0.85000000f,0.12000000f,0.05000000f,0.39000000f,-0.21000000f,0.49000000f,-0.28000000f,-0.07000000f,0.96000000f,0.00000000f,0.78000000f,-0.54000000f,0.75000000f,0.15000000f,0.14000000f,-0.21000000f,-0.19000000f,0.06000000f,0.42000000f,0.34000000f,-0.41000000f,0.11000000f,0.44000000f,-0.02000000f,0.89000000f,0.56000000f,-0.78000000f,0.75000000f,0.06000000f,-0.22000000f,-0.32000000f,-0.78000000f,-0.52000000f,-0.46000000f,0.64000000f,-0.31000000f,-0.53000000f,-0.20000000f,0.66000000f,0.29000000f,0.91000000f,-0.84000000f,-0.82000000f,0.67000000f,-0.92000000f,-0.56000000f,0.26000000f,-0.42000000f,-0.93000000f,0.13000000f,0.90000000f,-0.20000000f,-0.40000000f,0.56000000f,-0.60000000f,0.39000000f,-0.01000000f,0.67000000f,-0.77000000f,-0.70000000f,0.30000000f,-0.21000000f,0.04000000f,-0.05000000f,-0.70000000f,0.87000000f,-0.99000000f,0.23000000f,-0.11000000f,-0.99000000f,-0.72000000f,0.22000000f,0.82000000f,0.59000000f,-0.20000000f,-0.40000000f,0.28000000f,-0.91000000f,-0.44000000f,-0.49000000f,0.67000000f,0.33000000f,0.15000000f,-0.09000000f,-0.77000000f,-0.65000000f,-0.95000000f,0.39000000f,-0.02000000f,-0.08000000f,-0.60000000f,0.10000000f,-0.72000000f,0.51000000f,-0.17000000f,-0.80000000f,-0.07000000f,0.92000000f,-0.81000000f,0.65000000f,0.86000000f,0.51000000f,-0.99000000f,0.32000000f,-0.47000000f,-0.37000000f,-0.95000000f,0.59000000f,-0.46000000f,-0.63000000f,0.84000000f,0.84000000f,-0.61000000f,0.97000000f,0.17000000f,0.48000000f,0.94000000f,-0.02000000f,0.98000000f,0.19000000f,0.16000000f,0.40000000f,0.16000000f,-0.40000000f,-0.94000000f,-0.61000000f,0.49000000f,-0.60000000f,0.52000000f,-0.62000000f,0.91000000f,0.67000000f,0.25000000f,0.68000000f,-0.03000000f,-0.03000000f,0.31000000f,-0.16000000f,0.72000000f,0.28000000f,-0.13000000f,-0.10000000f,-0.47000000f,-0.49000000f,-0.79000000f,-0.24000000f,-0.39000000f,-0.93000000f,-0.93000000f,-0.64000000f,0.79000000f,0.06000000f,-0.73000000f,-0.05000000f,-0.77000000f,-0.42000000f,-0.10000000f,-0.28000000f,-0.26000000f,0.58000000f,0.07000000f,0.80000000f,0.52000000f,-0.68000000f,0.86000000f,-0.35000000f,0.79000000f,0.50000000f,-0.83000000f,-0.52000000f,0.75000000f,-0.54000000f,0.49000000f,0.17000000f,0.29000000f,0.45000000f,-0.50000000f,-0.08000000f,0.81000000f,0.98000000f,0.57000000f,-0.57000000f,-0.73000000f,-0.54000000f,-0.94000000f,-0.91000000f,0.13000000f,0.74000000f,-0.31000000f,-0.23000000f,-0.85000000f,-0.98000000f,-0.88000000f,-0.98000000f,0.70000000f,-0.92000000f,0.85000000f,-0.96000000f,-0.71000000f,0.46000000f,0.07000000f,-0.41000000f,0.80000000f,0.35000000f,0.64000000f,0.50000000f,-0.57000000f,0.86000000f,0.13000000f,0.09000000f,-0.13000000f,0.78000000f,0.51000000f,0.66000000f,0.18000000f,0.63000000f,0.66000000f,0.05000000f,0.06000000f,-0.87000000f,-0.33000000f,-0.19000000f,-0.55000000f,0.94000000f,-0.52000000f,-0.74000000f,0.21000000f,0.33000000f,0.50000000f,0.90000000f,0.53000000f,0.80000000f,0.53000000f,-0.15000000f,0.02000000f,-0.84000000f,-0.14000000f,0.19000000f,0.51000000f,0.26000000f,0.16000000f,-0.88000000f,0.98000000f,-0.73000000f,0.28000000f,0.64000000f,-0.76000000f,0.20000000f,-0.74000000f,0.09000000f,0.21000000f,-0.67000000f,0.63000000f,-0.74000000f,0.18000000f,-0.03000000f,-0.25000000f,-0.42000000f,0.76000000f,-0.79000000f,0.98000000f,-0.48000000f,0.94000000f,0.10000000f,0.36000000f,0.47000000f,-0.56000000f,-0.69000000f,-0.74000000f,0.37000000f,0.49000000f,0.78000000f,-0.57000000f,0.14000000f,-0.83000000f,0.15000000f,-0.88000000f,0.91000000f,0.25000000f,-0.89000000f,-0.98000000f,-0.67000000f,0.74000000f,0.53000000f,-0.50000000f,-0.54000000f,-0.94000000f,-0.93000000f,0.69000000f,0.15000000f,0.76000000f,0.60000000f,0.86000000f,-0.96000000f,-0.52000000f,0.84000000f,-0.73000000f,0.10000000f,0.35000000f,-0.13000000f,0.53000000f,0.43000000f,0.19000000f,-0.59000000f,-0.02000000f,0.43000000f,0.50000000f,-0.18000000f,0.03000000f,-0.13000000f,-0.21000000f,0.46000000f,-0.07000000f,-0.99000000f,0.94000000f,-0.16000000f,-0.43000000f,0.25000000f,-0.55000000f,-0.77000000f,-0.13000000f,-0.99000000f,0.98000000f,0.69000000f,0.92000000f,-0.77000000f,-0.89000000f,-0.03000000f,0.03000000f,-0.10000000f,0.48000000f,0.47000000f,-0.95000000f,0.87000000f,-0.12000000f,0.56000000f,0.36000000f,0.56000000f,-0.04000000f,-0.97000000f,0.57000000f,-0.85000000f,-0.45000000f,0.48000000f,-0.54000000f,0.90000000f,-0.46000000f,0.49000000f,-0.02000000f,0.25000000f,-0.83000000f,0.77000000f,-0.38000000f,0.09000000f,0.35000000f,0.89000000f,-0.79000000f,-0.79000000f,0.13000000f,-0.14000000f,-0.27000000f,-0.49000000f,0.46000000f,0.43000000f,-0.91000000f,-0.79000000f,-0.67000000f,-0.15000000f,0.73000000f,0.88000000f,0.17000000f,-0.03000000f,0.22000000f,0.43000000f,0.47000000f,-0.72000000f,0.38000000f,0.23000000f,-0.28000000f,-0.14000000f,-0.02000000f,-0.23000000f,0.47000000f,0.48000000f,-0.11000000f,-0.42000000f,-0.19000000f,0.20000000f,-0.84000000f,0.91000000f,-0.17000000f,-0.52000000f,0.46000000f,-0.53000000f,0.55000000f,-0.29000000f,0.80000000f,-0.94000000f,-0.24000000f,0.53000000f,0.18000000f,0.52000000f,-0.91000000f,-0.47000000f,-0.98000000f,0.82000000f,0.81000000f,0.89000000f,-0.94000000f,-0.18000000f,0.26000000f,0.98000000f,-0.97000000f,-0.99000000f,-0.82000000f,0.67000000f,-0.88000000f,0.76000000f,-0.73000000f,0.25000000f,0.82000000f,-0.27000000f,-0.16000000f,0.35000000f,-0.61000000f,0.39000000f,0.79000000f,-0.57000000f,-0.41000000f,-0.56000000f,-0.35000000f,0.26000000f,-0.34000000f,0.74000000f,-0.10000000f,0.98000000f,-0.55000000f,-0.38000000f,-0.91000000f,-0.06000000f,-0.85000000f,0.62000000f,-0.34000000f,0.51000000f,-0.83000000f,0.91000000f,-0.09000000f,-0.54000000f,-0.79000000f,-0.37000000f,0.79000000f,0.74000000f,-0.86000000f,-0.52000000f,0.45000000f,0.04000000f,0.65000000f,-0.26000000f,0.70000000f,0.88000000f,-0.13000000f,0.36000000f,0.23000000f,0.06000000f,0.73000000f,0.16000000f,-0.53000000f,-0.91000000f,-0.56000000f,-0.07000000f,0.72000000f,-0.17000000f,-0.13000000f,0.56000000f,0.11000000f,0.19000000f,0.46000000f,-0.31000000f,0.76000000f,0.95000000f,0.68000000f,0.12000000f,0.60000000f,-0.20000000f,-0.89000000f,0.80000000f,0.78000000f,-0.21000000f,-0.04000000f,0.79000000f,-0.18000000f,0.28000000f,-0.37000000f,-0.39000000f,0.92000000f,-0.73000000f,-0.55000000f,-0.32000000f,-0.15000000f,-0.20000000f,-0.59000000f,0.71000000f,0.57000000f,-0.60000000f,-0.58000000f,-0.36000000f,0.05000000f,0.22000000f,0.08000000f,-0.37000000f,-0.73000000f,0.00000000f,0.99000000f,-0.44000000f,-0.83000000f,0.30000000f,-0.39000000f,-0.49000000f,0.40000000f,-0.33000000f,-0.64000000f,-0.07000000f,0.24000000f,-0.80000000f,0.38000000f,0.65000000f,0.18000000f,0.88000000f,0.99000000f,-0.18000000f,-0.08000000f,0.45000000f,-0.76000000f,-0.30000000f,0.87000000f,0.24000000f,-0.21000000f,-0.28000000f,0.62000000f,-0.71000000f,0.57000000f,0.92000000f,0.01000000f,0.70000000f,0.44000000f,-0.77000000f,-0.47000000f,-0.70000000f,0.72000000f,-0.67000000f,-0.60000000f,0.08000000f,-0.26000000f,0.26000000f,0.16000000f,-0.94000000f,-0.06000000f,0.46000000f,0.98000000f,-0.90000000f,0.17000000f,-0.45000000f,-0.43000000f,-0.00000000f,0.71000000f,-0.82000000f,-0.59000000f,-0.44000000f,0.03000000f,0.98000000f,-0.85000000f,-0.33000000f,0.45000000f,0.22000000f,-0.04000000f,0.59000000f,0.87000000f,0.91000000f,0.97000000f,-0.97000000f,0.69000000f,-0.60000000f,0.61000000f,-0.59000000f,-0.56000000f,-0.71000000f,-0.35000000f,0.13000000f,0.06000000f,0.81000000f,-0.19000000f,0.45000000f,0.56000000f,-0.03000000f,0.09000000f,0.28000000f,-0.75000000f,0.97000000f,0.70000000f,0.98000000f,-0.56000000f,-0.62000000f,0.52000000f,-0.57000000f,0.48000000f,0.04000000f,-0.31000000f,-0.60000000f,-0.22000000f,-0.39000000f,0.05000000f,-0.27000000f,0.15000000f,-0.40000000f,-0.47000000f,0.74000000f,0.14000000f,0.96000000f,-0.35000000f,-0.12000000f,-0.95000000f,0.32000000f,-0.99000000f,0.06000000f,-0.22000000f,-0.82000000f,-0.89000000f,0.89000000f,0.00000000f,0.98000000f,-0.90000000f,0.48000000f,0.79000000f,0.87000000f,0.10000000f,-0.29000000f,0.79000000f,-0.88000000f,-0.07000000f,-0.95000000f,-0.70000000f,0.06000000f,-0.44000000f,0.17000000f,0.94000000f,0.54000000f,0.56000000f,0.83000000f,-0.89000000f,0.80000000f,-0.41000000f,0.40000000f,-0.13000000f,0.44000000f,-0.20000000f,-0.29000000f,0.59000000f,-0.58000000f,-0.80000000f,-0.37000000f,-0.33000000f,-0.10000000f,-0.51000000f,-0.90000000f,-0.16000000f,-0.14000000f,0.97000000f,0.06000000f,0.77000000f,-0.70000000f,-0.70000000f,0.30000000f,-0.36000000f,-0.17000000f,-0.17000000f,0.70000000f,0.25000000f,0.24000000f,-0.14000000f,0.22000000f,0.81000000f,-0.16000000f,0.07000000f,-0.89000000f,0.29000000f,-0.60000000f,-0.95000000f,0.26000000f,-0.20000000f,-0.04000000f,-0.90000000f,0.55000000f,0.80000000f,-0.66000000f,0.51000000f,0.59000000f,0.71000000f,-0.51000000f,0.73000000f,0.89000000f,-0.74000000f,0.88000000f,0.70000000f,0.08000000f,0.61000000f,-0.83000000f,-0.89000000f,-0.93000000f,0.34000000f,-0.41000000f,0.85000000f,-0.74000000f,-0.46000000f,-0.48000000f,0.05000000f,0.86000000f,-0.23000000f,0.82000000f,0.92000000f,-0.41000000f,-0.61000000f,-0.76000000f,0.22000000f,-0.80000000f,-0.29000000f,0.18000000f,-0.05000000f,-0.96000000f,-0.47000000f,0.74000000f,0.81000000f,-0.73000000f,0.69000000f,-0.74000000f,-0.05000000f,-0.80000000f,-0.89000000f,0.13000000f,-0.50000000f,-0.40000000f,0.16000000f,0.03000000f,0.85000000f,-0.23000000f,0.63000000f,0.88000000f,-0.77000000f,-0.58000000f,0.47000000f,-0.70000000f,-0.40000000f,0.61000000f,0.62000000f,-0.23000000f,-0.46000000f,-0.19000000f,0.14000000f,-0.18000000f,0.67000000f,0.21000000f,-0.57000000f,-0.75000000f,-0.04000000f,0.20000000f,0.82000000f,-0.18000000f,-0.44000000f,-0.48000000f,0.11000000f,0.50000000f,-0.60000000f,0.67000000f,-0.60000000f,0.48000000f,0.58000000f,-0.92000000f,0.20000000f,-0.86000000f,0.48000000f,-0.87000000f,0.47000000f,-0.43000000f,0.04000000f,-0.90000000f,-0.50000000f,-0.79000000f,-0.28000000f,-0.25000000f,-0.20000000f,0.49000000f,-0.01000000f,0.28000000f,0.83000000f,-0.03000000f,-0.32000000f,-0.72000000f,0.76000000f,0.80000000f,-0.53000000f,-0.64000000f,-0.34000000f,0.59000000f,-0.81000000f,0.20000000f,0.10000000f,-0.13000000f,-0.40000000f,-0.51000000f,-0.57000000f,0.13000000f,0.93000000f,0.89000000f,-0.03000000f,-0.09000000f,-0.96000000f,-0.41000000f,-0.32000000f,0.14000000f,-0.94000000f,-0.21000000f,0.51000000f,0.03000000f,-0.50000000f,0.54000000f,-0.52000000f,-0.23000000f,0.22000000f,-0.73000000f,-0.49000000f,-0.80000000f,-0.84000000f,-0.26000000f,0.53000000f,-0.61000000f,0.81000000f,-0.80000000f,0.83000000f,0.35000000f,0.49000000f,-0.39000000f,-0.10000000f,0.64000000f,0.12000000f,0.65000000f,0.78000000f,-0.84000000f,-0.32000000f,0.01000000f,-0.38000000f,-0.98000000f,-0.75000000f,0.68000000f,0.16000000f,0.56000000f,-0.23000000f,-0.87000000f,0.37000000f,0.19000000f,0.71000000f,-0.73000000f,0.07000000f,-0.17000000f,0.20000000f,0.08000000f,0.33000000f,-0.49000000f,0.67000000f,-0.58000000f,-0.14000000f,-0.60000000f,-0.89000000f,-0.58000000f,-0.06000000f,0.11000000f,-0.14000000f,0.94000000f,-0.81000000f,-0.54000000f,-0.63000000f,-0.89000000f,-0.35000000f,0.90000000f,0.73000000f,0.67000000f,-0.27000000f,-0.36000000f,0.00000000f,0.11000000f,0.48000000f,0.38000000f,-0.78000000f,0.90000000f,-0.36000000f,-0.74000000f,-0.50000000f,0.90000000f,-0.77000000f,0.78000000f,-0.08000000f,0.76000000f,-0.91000000f,-0.97000000f,-0.38000000f,-0.00000000f,0.59000000f,0.79000000f,-0.53000000f,0.21000000f,0.34000000f,-0.79000000f,0.90000000f,-0.42000000f,-0.14000000f,-0.44000000f,-0.25000000f,-0.29000000f,0.34000000f,-0.08000000f,0.76000000f,0.53000000f,0.24000000f,0.07000000f,0.01000000f,-0.29000000f,-0.76000000f,-0.43000000f,-0.40000000f,0.23000000f,-0.66000000f,0.62000000f,0.79000000f,-0.07000000f,-0.26000000f,0.62000000f,-0.18000000f,-0.66000000f,0.90000000f,0.19000000f,0.58000000f,0.59000000f,-0.24000000f,-0.75000000f,-0.30000000f,0.13000000f,0.68000000f,0.08000000f,0.00000000f,-0.00000000f,0.81000000f,-0.56000000f,0.41000000f,0.58000000f,0.50000000f,-0.40000000f,0.59000000f,-0.45000000f,-0.56000000f,0.66000000f,0.02000000f,0.74000000f,-0.27000000f,0.70000000f,-0.50000000f,-0.76000000f,0.24000000f,0.94000000f,-0.61000000f,0.74000000f,-0.95000000f,0.76000000f,-0.24000000f,0.09000000f,0.87000000f,-0.02000000f,-0.73000000f,-0.43000000f,-0.26000000f,0.39000000f,-0.78000000f,-0.50000000f,-0.52000000f,-0.84000000f,-0.81000000f,-0.51000000f,0.86000000f,-0.27000000f,0.27000000f,-0.92000000f,0.39000000f,0.02000000f,0.12000000f,-0.47000000f,-0.75000000f,-0.69000000f,0.00000000f,-0.46000000f,0.19000000f,0.21000000f,-0.75000000f,0.65000000f,0.12000000f,0.74000000f,-0.92000000f,-0.88000000f,0.68000000f,0.85000000f,-0.38000000f,-0.68000000f,0.43000000f,-0.88000000f,0.12000000f,-0.02000000f,-0.77000000f,0.27000000f,0.40000000f,0.53000000f,0.95000000f,0.99000000f,0.56000000f,0.62000000f,-0.68000000f,-0.69000000f,-0.87000000f,0.09000000f,-0.91000000f,-0.25000000f,-0.66000000f,0.19000000f,-0.69000000f,-0.54000000f,0.46000000f,0.21000000f,-0.76000000f,0.84000000f,-0.83000000f,-0.30000000f,-0.30000000f,0.16000000f,0.38000000f,0.39000000f,-0.04000000f,0.32000000f,-0.68000000f,-0.43000000f,0.27000000f,0.08000000f,0.41000000f,0.93000000f,-0.61000000f,-0.54000000f,0.52000000f,-0.99000000f,0.04000000f,0.74000000f,-0.26000000f,0.25000000f,-0.28000000f,-0.60000000f,0.52000000f,-0.68000000f,0.75000000f,-0.62000000f,-0.32000000f,-0.51000000f,-0.69000000f,-0.61000000f,0.90000000f,-0.71000000f,0.81000000f,-0.20000000f,0.24000000f,0.92000000f,-0.25000000f,-0.76000000f,0.88000000f,0.88000000f,0.42000000f,-0.21000000f,0.11000000f,0.33000000f,-0.09000000f,0.01000000f,-0.72000000f,0.96000000f,0.20000000f,-0.70000000f,-0.59000000f,0.48000000f,-0.03000000f,0.42000000f,0.54000000f,0.67000000f,-0.21000000f,-0.13000000f,0.55000000f,-0.11000000f,0.26000000f,0.52000000f,0.83000000f,0.76000000f,0.21000000f,0.51000000f,-0.35000000f,0.49000000f,0.04000000f,-0.62000000f,0.88000000f,0.04000000f,0.00000000f,0.33000000f,-0.68000000f,0.72000000f,0.78000000f,-0.69000000f,0.54000000f,0.04000000f,-0.69000000f,-0.51000000f,0.56000000f,-0.05000000f,-0.68000000f,0.16000000f,0.62000000f,-0.90000000f,0.77000000f,-0.25000000f,-0.78000000f,0.25000000f,-0.86000000f,0.72000000f,-0.82000000f,-0.13000000f,-0.23000000f,0.77000000f,-0.06000000f,0.13000000f,0.29000000f,-0.79000000f,0.13000000f,-0.77000000f,-0.56000000f,-0.22000000f,-0.17000000f,-0.20000000f,-0.35000000f,0.91000000f,-0.92000000f,0.70000000f,-0.07000000f,0.99000000f,-0.44000000f,0.00000000f,-0.91000000f,0.36000000f,-0.69000000f,-0.97000000f,0.97000000f,-0.15000000f,0.76000000f,0.78000000f,-0.36000000f,-0.46000000f,0.43000000f,0.78000000f,-0.08000000f,-0.36000000f,0.91000000f,-0.15000000f,-0.49000000f,0.89000000f,-0.47000000f,-0.88000000f,0.32000000f,-0.35000000f,0.46000000f,0.86000000f,0.19000000f,0.87000000f,0.76000000f,0.41000000f,0.87000000f,0.71000000f,0.11000000f,0.78000000f,-0.87000000f,0.70000000f,-0.29000000f,-0.32000000f,0.01000000f,-0.68000000f,0.19000000f,-0.59000000f,-0.04000000f,0.89000000f,-0.46000000f,0.46000000f,-0.82000000f,0.02000000f,0.35000000f,-0.93000000f,-0.46000000f,0.58000000f,0.03000000f,-0.81000000f,0.27000000f,-0.90000000f,-0.33000000f,-0.93000000f,-0.47000000f,-0.42000000f,-0.27000000f,-0.49000000f,0.82000000f,0.12000000f,0.82000000f,0.29000000f,-0.35000000f,0.74000000f,0.00000000f,-0.70000000f,0.45000000f,-0.19000000f,0.05000000f,-0.39000000f,-0.84000000f,-0.99000000f,-0.22000000f,-0.71000000f,-0.60000000f,-0.54000000f,0.21000000f,0.61000000f,0.18000000f,0.08000000f,0.19000000f,-0.06000000f,-0.98000000f,0.21000000f,-0.78000000f,0.15000000f,0.68000000f,-0.53000000f,0.31000000f,0.89000000f,-0.01000000f,-0.73000000f,0.02000000f,0.40000000f,-0.37000000f,0.23000000f,-0.95000000f,0.62000000f,0.84000000f,-0.35000000f,-0.63000000f,0.96000000f,-0.47000000f,0.14000000f,0.80000000f,-0.68000000f,0.29000000f,0.99000000f,0.49000000f,-0.01000000f,0.16000000f,0.19000000f,-0.38000000f,0.63000000f,-0.93000000f,-0.31000000f,0.83000000f,-0.64000000f,-0.72000000f,0.49000000f,-0.87000000f,0.09000000f,0.89000000f,-0.76000000f,-0.98000000f,0.36000000f,0.71000000f,0.07000000f,0.99000000f,-0.47000000f,-0.41000000f,0.68000000f,0.86000000f,0.77000000f,0.92000000f,-0.79000000f,-0.22000000f,0.24000000f,0.09000000f,-0.45000000f,0.00000000f,0.22000000f,-0.96000000f,-0.50000000f,0.87000000f,0.06000000f,0.93000000f,-0.39000000f,-0.39000000f,-0.39000000f,-0.36000000f,-0.11000000f,0.77000000f,-0.29000000f,0.32000000f,-0.60000000f,-0.69000000f,-0.35000000f,0.12000000f,-0.30000000f,0.66000000f,0.29000000f,-0.45000000f,-0.18000000f,-0.95000000f,0.75000000f,-0.69000000f,-0.71000000f,-0.93000000f,-0.25000000f,-0.36000000f,0.81000000f,-0.79000000f,0.17000000f,0.93000000f,-0.60000000f,-0.98000000f,0.55000000f,-0.87000000f,-0.67000000f,0.32000000f,0.80000000f,0.79000000f,0.62000000f,0.44000000f,-0.19000000f,-0.48000000f,0.34000000f,0.89000000f,0.72000000f,0.37000000f,-0.82000000f,-0.49000000f,-0.71000000f,-0.40000000f,-0.08000000f,-0.05000000f,-0.30000000f,-0.46000000f,0.50000000f,0.24000000f,0.85000000f,-0.95000000f,-0.62000000f,-0.45000000f,-0.09000000f,0.42000000f,-0.95000000f,-0.20000000f,0.21000000f,-0.50000000f,0.39000000f,-0.38000000f,-0.74000000f,0.69000000f,-0.65000000f,0.43000000f,0.60000000f,-0.48000000f,-0.81000000f,-0.14000000f,-0.90000000f,0.56000000f,0.42000000f,0.39000000f,-0.13000000f,0.76000000f,0.06000000f,-0.46000000f,-0.55000000f,0.60000000f,0.72000000f,-0.05000000f,-0.20000000f,-0.17000000f,-0.40000000f,0.23000000f,-0.55000000f,0.90000000f,-0.49000000f,0.58000000f,0.34000000f,0.72000000f,-0.72000000f,-0.54000000f,-0.43000000f,-0.80000000f,-0.49000000f,-0.76000000f,-0.76000000f,-0.11000000f,0.55000000f,-0.68000000f,0.14000000f,-0.98000000f,0.20000000f,0.93000000f,0.19000000f,0.52000000f,-0.26000000f,0.89000000f,-0.82000000f,-0.02000000f,-0.47000000f,0.74000000f,-0.94000000f,-0.01000000f,0.90000000f,0.68000000f,0.20000000f,0.36000000f,-0.50000000f,-0.99000000f,0.20000000f,0.05000000f,-0.18000000f,-0.06000000f,-0.39000000f,0.60000000f,-0.12000000f,-0.94000000f,0.89000000f,-0.31000000f,0.00000000f,0.35000000f,0.74000000f,-0.24000000f,-0.88000000f,0.41000000f,-0.78000000f,-0.04000000f,0.38000000f,-0.17000000f,0.93000000f,0.48000000f,0.31000000f,0.60000000f,-0.20000000f,-0.78000000f,0.85000000f,-0.03000000f,0.26000000f,0.88000000f,0.17000000f,0.82000000f,0.39000000f,-0.03000000f,0.10000000f,0.13000000f,0.72000000f,0.15000000f,0.40000000f,-0.39000000f,0.32000000f,0.44000000f,-0.75000000f,-0.64000000f,-0.29000000f,0.77000000f,-0.50000000f,0.74000000f,0.71000000f,-0.08000000f,-0.30000000f,-0.42000000f,0.17000000f,-0.52000000f,0.84000000f,-0.07000000f,-0.89000000f,-0.60000000f,-0.04000000f,0.64000000f,-0.73000000f,-0.10000000f,-0.82000000f,0.87000000f,-0.78000000f,0.23000000f,0.67000000f,-0.98000000f,-0.68000000f,0.66000000f,0.82000000f,0.64000000f,0.40000000f,0.55000000f,0.91000000f,-0.02000000f,0.01000000f,0.13000000f,-0.82000000f,-0.86000000f,0.79000000f,-0.06000000f,-0.58000000f,0.75000000f,0.99000000f,-0.05000000f,0.32000000f,-0.07000000f,0.97000000f,0.49000000f,0.40000000f,0.42000000f,0.86000000f,-0.62000000f,0.54000000f,0.57000000f,0.90000000f,-0.76000000f,0.54000000f,-0.61000000f,0.32000000f,0.66000000f,0.21000000f,-0.24000000f,-0.70000000f,0.02000000f,0.27000000f,0.78000000f,-0.45000000f,0.29000000f,0.18000000f,-0.06000000f,0.78000000f,0.38000000f,-0.41000000f,0.14000000f,0.50000000f,-0.43000000f,-0.45000000f,0.68000000f,-0.30000000f,-0.79000000f,-0.88000000f,0.57000000f,-0.06000000f,0.36000000f,0.16000000f,0.14000000f,0.48000000f,-0.27000000f,0.46000000f,-0.78000000f,-0.23000000f,0.20000000f,0.34000000f,0.26000000f,0.34000000f,-0.40000000f,0.07000000f,0.00000000f,0.28000000f,-0.92000000f,-0.23000000f,0.46000000f,-0.60000000f,-0.69000000f,-0.98000000f,0.49000000f,0.21000000f,-0.65000000f,-0.01000000f,0.56000000f,-0.42000000f,0.88000000f,0.96000000f,0.40000000f,0.60000000f,-0.24000000f,-0.93000000f,-0.82000000f,0.64000000f,0.23000000f,-0.24000000f,0.28000000f,-0.50000000f,0.48000000f,0.23000000f,0.52000000f,0.75000000f,0.30000000f,0.59000000f,-0.63000000f,0.46000000f,0.47000000f,-0.91000000f,0.70000000f,0.29000000f,-0.47000000f,0.12000000f,-0.82000000f,0.72000000f,-0.20000000f,-0.48000000f,0.07000000f,0.39000000f,0.72000000f,0.24000000f,0.44000000f,0.79000000f,-0.44000000f,-0.59000000f,0.25000000f,-0.95000000f,-0.60000000f,0.24000000f,-0.40000000f,0.50000000f,-0.05000000f,-0.86000000f,0.49000000f,0.95000000f,0.92000000f,-0.87000000f,0.29000000f,-0.71000000f,-0.14000000f,0.37000000f,0.24000000f,0.91000000f,0.82000000f,-0.64000000f,0.12000000f,-0.39000000f,0.53000000f,-0.95000000f,0.32000000f,0.87000000f,-0.90000000f,0.97000000f,-0.85000000f,0.09000000f,-0.54000000f,-0.75000000f,0.74000000f,-0.59000000f,0.51000000f,-0.23000000f,-0.14000000f,-0.64000000f,0.51000000f,0.39000000f,0.60000000f,0.36000000f,0.16000000f,-0.64000000f,0.27000000f,-0.16000000f,0.32000000f,-0.99000000f,0.77000000f,0.48000000f,-0.71000000f,0.55000000f,0.73000000f,0.44000000f,-0.92000000f,-0.29000000f,0.44000000f,0.10000000f,-0.53000000f,-0.71000000f,-0.09000000f,-0.46000000f,-0.66000000f,-0.31000000f,0.05000000f,0.92000000f,-0.52000000f,0.04000000f,0.94000000f,0.91000000f,0.09000000f,0.03000000f,0.23000000f,-0.88000000f,-0.92000000f,0.91000000f,-0.47000000f,0.04000000f,0.37000000f,-0.75000000f,0.74000000f,0.77000000f,-0.69000000f,-0.02000000f,-0.90000000f,0.64000000f,-0.38000000f,-0.21000000f,0.76000000f,0.71000000f,0.38000000f,-0.89000000f,0.36000000f,-0.17000000f,0.86000000f,0.13000000f,0.45000000f,0.36000000f,-0.06000000f,0.40000000f,0.33000000f,-0.53000000f,-0.47000000f,0.71000000f,0.10000000f,0.63000000f,0.84000000f,-0.22000000f,0.07000000f,0.76000000f,0.98000000f,-0.43000000f,-0.54000000f,0.42000000f,-0.23000000f,-0.75000000f,-0.67000000f,0.62000000f,0.55000000f,0.24000000f,-0.77000000f,-0.45000000f,0.77000000f,0.30000000f,-0.80000000f,-0.47000000f,0.70000000f,0.03000000f,-0.26000000f,-0.10000000f,0.16000000f,0.98000000f,-0.33000000f,-0.64000000f,0.67000000f,0.31000000f,-0.61000000f,-0.09000000f,0.54000000f,-0.23000000f,-0.18000000f,-0.41000000f,-0.32000000f,-0.43000000f,0.35000000f,-0.85000000f,-0.45000000f,0.53000000f,0.24000000f,0.86000000f,-0.45000000f,0.37000000f,0.37000000f,-0.87000000f,-0.44000000f,-0.67000000f,0.66000000f,-0.78000000f,0.84000000f,0.10000000f,0.74000000f,-0.33000000f,-0.74000000f,0.28000000f,0.30000000f,0.43000000f,0.57000000f,0.48000000f,-0.36000000f,-0.84000000f,0.82000000f,0.03000000f,0.36000000f,0.04000000f,0.93000000f,-0.42000000f,0.73000000f,-0.33000000f,0.54000000f,-0.85000000f,0.28000000f,0.19000000f,0.31000000f,-0.06000000f,0.59000000f,0.01000000f,0.46000000f,-0.68000000f,-0.79000000f,-0.91000000f,0.95000000f,-0.04000000f,0.59000000f,0.66000000f,-0.03000000f,-0.35000000f,0.77000000f,0.27000000f,0.48000000f,0.04000000f,-0.91000000f,-0.90000000f,-0.38000000f,-0.43000000f,0.19000000f,0.47000000f,0.10000000f,0.01000000f,-0.15000000f,0.38000000f,0.74000000f,0.24000000f,0.68000000f,0.66000000f,-0.06000000f,-0.09000000f,0.79000000f,0.06000000f,-0.98000000f,-0.26000000f,-0.11000000f,-0.01000000f,-0.63000000f,0.17000000f,-0.20000000f,0.94000000f,0.04000000f,0.15000000f,-0.41000000f,-0.88000000f,0.62000000f,-0.03000000f,-0.95000000f,-0.99000000f,-0.35000000f,-0.79000000f,-0.08000000f,0.13000000f,0.45000000f,-0.79000000f,0.30000000f,-0.97000000f,0.53000000f,-0.87000000f,-0.00000000f,0.41000000f,-0.90000000f,0.46000000f,0.14000000f,-0.71000000f,-0.34000000f,0.06000000f,-0.93000000f,-0.31000000f,-0.91000000f,0.88000000f,0.76000000f,-0.69000000f,0.51000000f,-0.97000000f,0.40000000f,-0.95000000f,0.75000000f,-0.95000000f,-0.33000000f,0.74000000f,-0.86000000f,0.17000000f,0.73000000f,0.70000000f,-0.41000000f,0.11000000f,0.91000000f,0.94000000f,-0.67000000f,0.40000000f,0.18000000f,0.01000000f,0.17000000f,-0.10000000f,0.24000000f,0.54000000f,-0.01000000f,0.30000000f,0.21000000f,0.54000000f,-0.37000000f,-0.56000000f,0.76000000f,-0.57000000f,0.23000000f,-0.87000000f,0.35000000f,0.35000000f,0.84000000f,-0.47000000f,0.32000000f,-0.51000000f,0.45000000f,0.03000000f,0.84000000f,0.02000000f,0.74000000f,0.40000000f,-0.56000000f,0.08000000f,0.36000000f,0.97000000f,0.25000000f,0.03000000f,0.48000000f,-0.03000000f,0.65000000f,0.71000000f,-0.04000000f,0.85000000f,0.05000000f,0.13000000f,-0.08000000f,0.81000000f,0.32000000f,-0.34000000f,-0.79000000f,-0.45000000f,0.77000000f,-0.89000000f,0.79000000f,-0.23000000f,-0.65000000f,-0.43000000f,0.55000000f,0.99000000f,0.68000000f,-0.43000000f,0.25000000f,-0.19000000f,-0.32000000f,-0.03000000f,-0.61000000f,0.01000000f,0.10000000f,0.14000000f,0.82000000f,0.50000000f,0.96000000f,0.24000000f,-0.44000000f,-0.21000000f,0.05000000f,-0.28000000f,0.58000000f,0.29000000f,-0.08000000f,0.83000000f,-0.95000000f,-0.21000000f,-0.49000000f,0.61000000f,-0.37000000f,-0.47000000f,0.50000000f,-0.33000000f,-0.83000000f,0.00000000f,-0.68000000f,0.06000000f,-0.96000000f,-0.74000000f,0.57000000f,0.34000000f,-0.54000000f,-0.77000000f,-0.73000000f,0.84000000f,0.81000000f,-0.90000000f,0.95000000f,0.57000000f,-0.79000000f,0.35000000f,0.54000000f,-0.50000000f,-0.86000000f,0.13000000f,0.16000000f,0.75000000f,0.64000000f,-0.74000000f,-0.72000000f,-0.85000000f,0.87000000f,-0.71000000f,0.43000000f,-0.06000000f,-0.69000000f,0.12000000f,-0.06000000f,0.36000000f,-0.34000000f,0.79000000f,0.02000000f,-0.83000000f,0.91000000f,0.40000000f,0.46000000f,0.90000000f,-0.72000000f,0.02000000f,0.01000000f,-0.45000000f,0.30000000f,-0.12000000f,-0.09000000f,-0.14000000f,0.55000000f,-0.33000000f,0.34000000f,-0.82000000f,0.90000000f,0.45000000f,0.95000000f,-0.62000000f,-0.49000000f,0.06000000f,-0.15000000f,0.66000000f,0.10000000f,-0.92000000f,0.71000000f,0.04000000f,-0.28000000f,-0.83000000f,-0.37000000f,0.18000000f,0.37000000f,0.49000000f,0.82000000f,-0.53000000f,-0.30000000f,0.17000000f,-0.65000000f,-0.06000000f,0.29000000f,-0.89000000f,-0.74000000f,-0.21000000f,-0.85000000f,0.93000000f,-0.51000000f,0.29000000f,-0.86000000f,-0.20000000f,-0.19000000f,0.39000000f,-0.51000000f,0.54000000f,-0.67000000f,0.27000000f,-0.23000000f,0.23000000f,0.43000000f,0.65000000f,0.71000000f,0.95000000f,-0.84000000f,0.84000000f,-0.44000000f,-0.78000000f,0.05000000f,0.84000000f,0.05000000f,-0.54000000f,-0.18000000f,-0.41000000f,-0.80000000f,0.05000000f,-0.41000000f,-0.97000000f,0.34000000f,0.64000000f,-0.94000000f,0.19000000f,0.22000000f,0.85000000f,0.58000000f,0.92000000f,-0.07000000f,-0.41000000f,0.30000000f,-0.01000000f,0.72000000f,-0.28000000f,0.91000000f,0.82000000f,0.92000000f,0.17000000f,-0.08000000f,-0.69000000f,-0.92000000f,0.05000000f,0.45000000f,-0.72000000f,-0.34000000f,0.36000000f,0.35000000f,-0.18000000f,0.55000000f,-0.21000000f,-0.69000000f,-0.60000000f,0.86000000f,0.85000000f,0.47000000f,0.48000000f,0.49000000f,-0.31000000f,0.03000000f,-0.42000000f,-0.28000000f,0.38000000f,-0.94000000f,0.82000000f,0.25000000f,-0.40000000f,-0.95000000f,0.81000000f,-0.21000000f,0.50000000f,-0.55000000f,-0.02000000f,-0.91000000f,-0.10000000f,0.45000000f,-0.30000000f,0.31000000f,0.80000000f,-0.57000000f,0.41000000f,-0.83000000f,0.28000000f,-0.02000000f,0.11000000f,-0.45000000f,0.84000000f,0.03000000f,0.14000000f,0.76000000f,-0.21000000f,-0.04000000f,-0.52000000f,-0.55000000f,-0.03000000f,-0.98000000f,0.48000000f,0.91000000f,-0.39000000f,0.57000000f,0.45000000f,0.29000000f,-0.05000000f,-0.33000000f,-0.65000000f,-0.62000000f,0.98000000f,-0.35000000f,0.61000000f,0.81000000f,0.61000000f,-0.51000000f,0.43000000f,-0.36000000f,0.73000000f,-0.20000000f,-0.18000000f,0.05000000f,0.04000000f,-0.83000000f,0.38000000f,-0.98000000f,-0.62000000f,0.07000000f,0.65000000f,-0.23000000f,0.49000000f,-0.33000000f,-0.85000000f,0.33000000f,-0.51000000f,-0.08000000f,-0.21000000f,0.66000000f,0.84000000f,-0.36000000f,-0.01000000f,0.99000000f,0.48000000f,-0.79000000f,0.18000000f,0.82000000f,0.11000000f,-0.38000000f,-0.49000000f,0.24000000f,0.20000000f,0.16000000f,0.60000000f,-0.33000000f,0.58000000f,0.77000000f,-0.43000000f,-0.65000000f,0.81000000f,0.14000000f,0.36000000f,0.00000000f,-0.87000000f,-0.57000000f,-0.01000000f,-0.02000000f,0.30000000f,0.14000000f,-0.17000000f,0.18000000f,0.17000000f,0.64000000f,0.64000000f,0.57000000f,-0.72000000f,0.12000000f,-0.33000000f,0.73000000f,0.54000000f,-0.36000000f,0.16000000f,0.62000000f,0.01000000f,0.09000000f,0.36000000f,-0.65000000f,-0.72000000f,-0.02000000f,-0.40000000f,0.55000000f,-0.54000000f,-0.20000000f,0.24000000f,0.97000000f,-0.31000000f,0.96000000f,0.74000000f,0.71000000f,0.10000000f,0.79000000f,-0.64000000f,0.17000000f,-0.56000000f,0.27000000f,-0.62000000f,-0.65000000f,0.73000000f,0.17000000f,-0.06000000f,0.67000000f,-0.39000000f,-0.46000000f,0.25000000f,0.64000000f,-0.22000000f,-0.13000000f,0.35000000f,0.70000000f,-0.70000000f,-0.60000000f,-0.14000000f,-0.53000000f,-0.09000000f,0.59000000f,-0.09000000f,-0.12000000f,-0.28000000f,-0.65000000f,0.69000000f,0.48000000f,0.11000000f,-0.82000000f,-0.15000000f,-0.01000000f,0.06000000f,0.96000000f,-0.14000000f,0.51000000f,0.39000000f,0.66000000f,-0.27000000f,-0.52000000f,0.54000000f,-0.87000000f,-0.18000000f,-0.69000000f,-0.19000000f,-0.20000000f,0.19000000f,-0.06000000f,0.27000000f,0.18000000f,-0.26000000f,-0.45000000f,-0.09000000f,0.47000000f,-0.15000000f,-0.05000000f,0.54000000f,0.80000000f,0.86000000f,-0.60000000f,-0.02000000f,0.74000000f,0.07000000f,-0.10000000f,-0.73000000f,0.56000000f,0.67000000f,0.51000000f,0.23000000f,0.69000000f,0.85000000f,0.21000000f,-0.92000000f,0.15000000f,0.53000000f,0.12000000f,0.43000000f,-0.26000000f,-0.50000000f,0.29000000f,0.92000000f,-0.29000000f,-0.25000000f,0.94000000f,-0.92000000f,0.53000000f,0.14000000f,0.93000000f,0.88000000f,0.09000000f,-0.29000000f,0.59000000f,0.98000000f,0.49000000f,0.64000000f,-0.18000000f,-0.75000000f,-0.26000000f,-0.47000000f,0.64000000f,0.87000000f,0.46000000f,-0.51000000f,0.04000000f,-0.46000000f,0.00000000f,-0.67000000f,-0.78000000f,0.05000000f,-0.35000000f,0.21000000f,-0.42000000f,-0.85000000f,0.02000000f,0.78000000f,0.86000000f,-0.93000000f,-0.28000000f,0.54000000f,-0.41000000f,-0.83000000f,0.95000000f,-0.72000000f,0.31000000f,0.67000000f,-0.22000000f,-0.07000000f,0.74000000f,0.26000000f,0.27000000f,-0.78000000f,-0.23000000f,0.57000000f,0.55000000f,-0.27000000f,0.17000000f,0.57000000f,0.63000000f,-0.05000000f,-0.76000000f,-0.25000000f,0.37000000f,-0.29000000f,-0.48000000f,0.92000000f,-0.87000000f,-0.08000000f,-0.68000000f,0.61000000f,0.24000000f,-0.48000000f,-0.70000000f,0.61000000f,-0.01000000f,-0.96000000f,-0.54000000f,0.08000000f,-0.75000000f,0.06000000f,0.60000000f,-0.89000000f,0.34000000f,0.76000000f,-0.25000000f,0.34000000f,-0.94000000f,0.00000000f,0.60000000f,-0.24000000f,-0.10000000f,-0.98000000f,-0.56000000f,-0.74000000f,-0.36000000f,0.27000000f,0.74000000f,0.88000000f,-0.94000000f,0.25000000f,-0.85000000f,-0.39000000f,-0.37000000f,0.25000000f,-0.80000000f,0.10000000f,0.52000000f,-0.53000000f,0.20000000f,0.59000000f,-0.17000000f,-0.57000000f,0.45000000f,0.39000000f,-0.63000000f,0.37000000f,0.45000000f,-0.81000000f,-0.16000000f,0.18000000f,0.66000000f,-0.23000000f,-0.98000000f,-0.81000000f,0.47000000f,0.18000000f,0.24000000f,0.38000000f,-0.79000000f,-0.73000000f,0.28000000f,-0.81000000f,0.39000000f,-0.15000000f,0.93000000f,-0.83000000f,-0.42000000f,-0.70000000f,-0.09000000f,-0.95000000f,0.23000000f,0.25000000f,-0.44000000f,-0.79000000f,-0.68000000f,-0.26000000f,-0.04000000f,0.05000000f,-0.39000000f,-0.23000000f,0.22000000f,-0.25000000f,-0.30000000f,-0.00000000f,-0.03000000f,-0.42000000f,0.94000000f,0.27000000f,0.98000000f,-0.32000000f,0.88000000f,0.49000000f,0.75000000f,0.76000000f,0.02000000f,-0.10000000f,0.26000000f,-0.54000000f,-0.00000000f,-0.91000000f,0.30000000f,0.48000000f,0.30000000f,-0.54000000f,0.58000000f,0.13000000f,0.95000000f,0.43000000f,-0.90000000f,-0.79000000f,0.82000000f,-0.03000000f,0.28000000f,-0.69000000f,0.87000000f,-0.35000000f,-0.34000000f,0.97000000f,-0.17000000f,0.03000000f,0.61000000f,0.32000000f,-0.05000000f,0.47000000f,-0.35000000f,-0.48000000f,-0.50000000f,0.37000000f,0.84000000f,0.50000000f,-0.82000000f,0.26000000f,0.47000000f,-0.36000000f,-0.42000000f,0.58000000f,0.71000000f,0.87000000f,0.59000000f,0.92000000f,0.31000000f,0.66000000f,-0.28000000f,-0.13000000f,-0.19000000f,-0.95000000f,0.57000000f,-0.81000000f,0.95000000f,0.16000000f,0.62000000f,-0.60000000f,-0.03000000f,0.75000000f,0.40000000f,0.40000000f,0.78000000f,0.95000000f,0.59000000f,-0.00000000f,0.79000000f,0.49000000f,-0.76000000f,0.91000000f,-0.76000000f,-0.74000000f,-0.68000000f,0.97000000f,0.98000000f,-0.97000000f,0.91000000f,-0.93000000f,0.47000000f,0.86000000f,0.88000000f,-0.56000000f,0.84000000f,-0.00000000f,0.02000000f,-0.23000000f,0.95000000f,0.58000000f,-0.00000000f,0.84000000f,-0.65000000f,0.77000000f,-0.27000000f,-0.42000000f,-0.54000000f,0.19000000f,-0.77000000f,-0.59000000f,0.81000000f,0.45000000f,0.96000000f,0.39000000f,-0.46000000f,-0.74000000f,-0.59000000f,0.93000000f,-0.12000000f,0.26000000f,-0.74000000f,0.28000000f,-0.83000000f,0.58000000f,0.20000000f,0.25000000f,-0.39000000f,0.85000000f,0.29000000f,0.90000000f,-0.42000000f,0.95000000f,0.49000000f,-0.11000000f,-0.66000000f,0.65000000f,0.91000000f,-0.98000000f,-0.61000000f,-0.72000000f,0.20000000f,0.25000000f,0.39000000f,0.76000000f,-0.13000000f,0.56000000f,0.78000000f,0.90000000f,0.10000000f,0.54000000f,0.49000000f,-0.85000000f,0.50000000f,0.91000000f,-0.72000000f,-0.00000000f,0.80000000f,-0.25000000f,0.07000000f,-0.18000000f,0.87000000f,-0.93000000f,0.02000000f,0.03000000f,-0.15000000f,0.37000000f,0.50000000f,-0.21000000f,-0.17000000f,0.78000000f,-0.40000000f,0.70000000f,-0.96000000f,-0.74000000f,0.05000000f,0.22000000f,-0.04000000f,0.78000000f,0.99000000f,0.65000000f,0.63000000f,0.66000000f,0.40000000f,0.53000000f,-0.91000000f,0.46000000f,0.43000000f,0.18000000f,0.65000000f,-0.58000000f,0.73000000f,0.60000000f,0.57000000f,0.72000000f,0.71000000f,0.15000000f,0.70000000f,-0.47000000f,-0.82000000f,-0.38000000f,0.89000000f,-0.91000000f,0.72000000f,0.13000000f,-0.81000000f,-0.79000000f,-0.58000000f,-0.13000000f,0.28000000f,0.79000000f,0.46000000f,0.34000000f,0.27000000f,0.26000000f,0.00000000f,0.39000000f,0.89000000f,0.24000000f,0.83000000f,0.91000000f,-0.87000000f,-0.49000000f,0.30000000f,-0.11000000f,0.77000000f,-0.97000000f,-0.36000000f,-0.41000000f,-0.68000000f,0.85000000f,0.79000000f,0.30000000f,0.81000000f,-0.57000000f,0.91000000f,-0.04000000f,-0.22000000f,-0.16000000f,0.95000000f,0.60000000f,0.27000000f,-0.73000000f,0.26000000f,-0.18000000f,0.50000000f,-0.79000000f,0.10000000f,-0.69000000f,-0.23000000f,0.07000000f,0.76000000f,-0.41000000f,-0.13000000f,-0.64000000f,-0.15000000f,0.47000000f,-0.03000000f,0.93000000f,0.95000000f,-0.67000000f,0.72000000f,-0.80000000f,-0.17000000f,0.98000000f,0.45000000f,-0.91000000f,0.94000000f,-0.67000000f,0.51000000f,0.81000000f,-0.37000000f,0.49000000f,0.43000000f,0.26000000f,0.83000000f,-0.88000000f,-0.10000000f,0.05000000f,0.41000000f,-0.13000000f,-0.32000000f,0.75000000f,0.37000000f,-0.26000000f,-0.42000000f,-0.41000000f,0.79000000f,0.37000000f,-0.06000000f,0.77000000f,-0.61000000f,0.23000000f,0.57000000f,0.28000000f,0.63000000f,-0.43000000f,-0.09000000f,0.22000000f,-0.86000000f,-0.07000000f,0.22000000f,0.48000000f,-0.05000000f,0.71000000f,-0.98000000f,0.47000000f,0.46000000f,0.02000000f,-0.52000000f,-0.24000000f,0.35000000f,-0.02000000f,-0.30000000f,-0.80000000f,-0.18000000f,-0.81000000f,0.19000000f,-0.74000000f,-0.04000000f,-0.58000000f,-0.51000000f,-0.71000000f,-0.28000000f,0.23000000f,-0.51000000f,-0.05000000f,0.88000000f,-0.55000000f,0.54000000f,0.41000000f,-0.06000000f,-0.58000000f,0.32000000f,0.93000000f,-0.14000000f,-0.61000000f,-0.05000000f,0.13000000f,-0.73000000f,-0.19000000f,-0.49000000f,0.59000000f,0.53000000f,0.97000000f,0.64000000f,0.02000000f,0.39000000f,-0.95000000f,-0.87000000f,-0.87000000f,0.96000000f,-0.90000000f,-0.68000000f,0.74000000f,-0.76000000f,-0.08000000f,-0.19000000f,-0.11000000f,-0.32000000f,0.95000000f,-0.13000000f,0.70000000f,-0.81000000f,0.67000000f,0.09000000f,-0.64000000f,-0.24000000f,0.70000000f,0.46000000f,0.28000000f,0.21000000f,-0.10000000f,0.49000000f,-0.22000000f,0.64000000f,0.34000000f,-0.10000000f,-0.78000000f,-0.11000000f,-0.04000000f,-0.31000000f,-0.63000000f,-0.45000000f,0.12000000f,0.71000000f,0.88000000f,-0.41000000f,0.30000000f,0.51000000f,-0.73000000f,0.54000000f,-0.00000000f,0.39000000f,0.62000000f,0.81000000f,0.65000000f,-0.26000000f,-0.35000000f,0.84000000f,-0.12000000f,0.77000000f,0.65000000f,0.77000000f,-0.42000000f,0.54000000f,0.95000000f,-0.82000000f,0.46000000f,0.83000000f,0.15000000f,-0.11000000f,-0.06000000f,0.41000000f,0.87000000f,-0.74000000f,-0.24000000f,0.37000000f,0.94000000f,-0.42000000f,-0.56000000f,-0.01000000f,-0.15000000f,0.03000000f,0.49000000f,-0.75000000f,0.18000000f,0.42000000f,0.54000000f,0.39000000f,0.70000000f,-0.49000000f,0.08000000f,0.68000000f,-0.25000000f,0.36000000f,0.38000000f,0.44000000f,-0.52000000f,0.86000000f,-0.02000000f,0.69000000f,0.90000000f,0.89000000f,-0.77000000f,0.14000000f,-0.78000000f,-0.64000000f,0.40000000f,-0.09000000f,0.78000000f,-0.81000000f,0.94000000f,0.46000000f,-0.53000000f,0.04000000f,-0.46000000f,0.71000000f,-0.85000000f,0.66000000f,-0.51000000f,-0.09000000f,0.91000000f,0.38000000f,-0.26000000f,0.91000000f,-0.04000000f,-0.86000000f,-0.03000000f,0.83000000f,-0.69000000f,0.35000000f,0.65000000f,-0.03000000f,0.65000000f,0.68000000f,0.56000000f,0.30000000f,-0.46000000f,0.73000000f,0.02000000f,-0.21000000f,0.85000000f,0.48000000f,0.91000000f,0.05000000f,0.15000000f,-0.32000000f,0.39000000f,-0.33000000f,-0.84000000f,-0.66000000f,-0.41000000f,0.98000000f,-0.03000000f,0.56000000f,0.30000000f,0.37000000f,-0.86000000f,0.60000000f,0.47000000f,-0.24000000f,0.53000000f,-0.85000000f,0.66000000f,0.53000000f,-0.31000000f,-0.44000000f,0.88000000f,0.34000000f,-0.73000000f,-0.48000000f,-0.33000000f,-0.73000000f,0.56000000f,0.45000000f,0.18000000f,-0.76000000f,0.56000000f,0.23000000f,-0.83000000f,0.97000000f,-0.48000000f,-0.80000000f,-0.66000000f,0.17000000f,0.74000000f,0.39000000f,-0.02000000f,0.49000000f,-0.33000000f,-0.73000000f,-0.81000000f,0.27000000f,0.21000000f,0.38000000f,-0.68000000f,-0.20000000f,-0.09000000f,-0.96000000f,-0.61000000f,-0.93000000f,-0.99000000f,-0.16000000f,0.15000000f,0.62000000f,0.24000000f,0.74000000f,-0.65000000f,0.35000000f,0.26000000f,0.38000000f,-0.64000000f,-0.67000000f,0.80000000f,0.26000000f,0.30000000f,-0.56000000f,0.20000000f,-0.82000000f,0.06000000f,0.81000000f,0.75000000f,0.82000000f,-0.82000000f,0.55000000f,-0.91000000f,0.37000000f,0.16000000f,-0.03000000f,-0.13000000f,0.09000000f,-0.67000000f,-0.33000000f,-0.18000000f,-0.13000000f,-0.98000000f,-0.81000000f,-0.72000000f,0.49000000f,-0.96000000f,-0.22000000f,0.65000000f,0.35000000f,-0.35000000f,-0.60000000f,-0.64000000f,0.19000000f,-0.57000000f,0.73000000f,-0.70000000f,-0.89000000f,0.46000000f,-0.77000000f,-0.32000000f,0.55000000f,-0.81000000f,-0.61000000f,0.97000000f,-0.49000000f,0.30000000f,0.42000000f,0.66000000f,0.19000000f,0.55000000f,-0.72000000f,-0.95000000f,-0.65000000f,-0.28000000f,-0.75000000f,-0.22000000f,0.29000000f,0.56000000f,-0.02000000f,-0.15000000f,-0.80000000f,0.68000000f,-0.05000000f,-0.35000000f,0.68000000f,-0.84000000f,0.95000000f,-0.14000000f,0.04000000f,0.64000000f,0.49000000f,0.02000000f,0.74000000f,0.57000000f,0.58000000f,0.01000000f,0.62000000f,-0.87000000f,0.76000000f,0.37000000f,0.27000000f,-0.51000000f,0.07000000f,0.31000000f,0.39000000f,0.61000000f,0.60000000f,-0.14000000f,0.62000000f,0.01000000f,-0.10000000f,-0.43000000f,-0.23000000f,-0.91000000f,0.99000000f,0.58000000f,0.81000000f,-0.39000000f,-0.98000000f,0.96000000f,0.02000000f,0.38000000f,-0.94000000f,-0.46000000f,-0.02000000f,0.46000000f,0.48000000f,-0.39000000f,-0.46000000f,0.89000000f,-0.62000000f,0.10000000f,0.81000000f,0.53000000f,-0.96000000f,-0.33000000f,-0.58000000f,-0.17000000f,-0.73000000f,0.12000000f,0.05000000f,0.63000000f,-0.83000000f,0.01000000f,-0.02000000f,-0.00000000f,-0.01000000f,-0.79000000f,0.78000000f,0.48000000f,-0.44000000f,0.46000000f,0.48000000f,-0.72000000f,-0.53000000f,0.08000000f,0.00000000f,-0.12000000f,-0.93000000f,-0.87000000f,-0.32000000f,-0.49000000f,0.35000000f,-0.63000000f,-0.20000000f,0.99000000f,0.01000000f,-0.23000000f,0.41000000f,-0.32000000f,0.12000000f,0.85000000f,0.31000000f,0.43000000f,0.21000000f,0.60000000f,-0.33000000f,-0.71000000f,-0.84000000f,-0.23000000f,-0.06000000f,-0.23000000f,0.08000000f,0.89000000f,0.99000000f,0.64000000f,0.65000000f,-0.55000000f,0.60000000f,-0.07000000f,-0.62000000f,0.74000000f,0.57000000f,0.85000000f,0.27000000f,0.56000000f,-0.87000000f,0.00000000f,-0.37000000f,-0.67000000f,0.07000000f,0.49000000f,0.44000000f,-0.92000000f,0.48000000f,0.70000000f,-0.86000000f,0.33000000f,0.39000000f,0.71000000f,0.43000000f,0.80000000f,-0.52000000f,0.01000000f,-0.54000000f,-0.95000000f,-0.39000000f,0.40000000f,-0.75000000f,0.08000000f,0.76000000f,-0.62000000f,-0.39000000f,0.94000000f,0.31000000f,0.09000000f,-0.15000000f,0.83000000f,-0.77000000f,0.05000000f,0.85000000f,0.68000000f,-0.32000000f,0.94000000f,-0.09000000f,-0.57000000f,0.46000000f,-0.01000000f,-0.77000000f,0.68000000f,0.44000000f,0.01000000f,-0.38000000f,0.82000000f,-0.22000000f,0.74000000f,0.75000000f,-0.43000000f,-0.26000000f,0.01000000f,0.87000000f,0.15000000f,-0.93000000f,-0.51000000f,-0.23000000f,-0.57000000f,0.88000000f,0.76000000f,-0.39000000f,0.78000000f,-0.40000000f,0.78000000f,-0.86000000f,-0.15000000f,0.47000000f,-0.75000000f,-0.26000000f,-0.54000000f,-0.00000000f,-0.42000000f,0.40000000f,0.53000000f,-0.34000000f,0.26000000f,-0.20000000f,-0.09000000f,-0.89000000f,0.96000000f,0.44000000f,-0.56000000f,-0.58000000f,-0.40000000f,-0.69000000f,0.21000000f,-0.74000000f,0.42000000f,0.94000000f,0.95000000f,-0.01000000f,0.93000000f,0.22000000f,-0.40000000f,-0.56000000f,0.42000000f,-0.97000000f,-0.72000000f,0.59000000f,-0.69000000f,0.52000000f,0.62000000f,-0.13000000f,-0.47000000f,0.18000000f,0.00000000f,0.37000000f,0.58000000f,-0.61000000f,0.28000000f,-0.85000000f,0.52000000f,-0.69000000f,-0.62000000f,0.54000000f,-0.90000000f,0.89000000f,0.86000000f,-0.83000000f,-0.57000000f,0.32000000f,0.43000000f,0.35000000f,-0.35000000f,0.02000000f,0.93000000f,0.77000000f,0.32000000f,0.52000000f,0.58000000f,0.76000000f,0.35000000f,-0.55000000f,-0.10000000f,-0.07000000f,-0.82000000f,-0.40000000f,0.25000000f,0.91000000f,0.81000000f,0.60000000f,-0.58000000f,0.64000000f,0.20000000f,0.97000000f,0.61000000f,-0.57000000f,0.93000000f,0.69000000f,-0.42000000f,0.99000000f,-0.80000000f,0.59000000f,0.48000000f,0.13000000f,0.42000000f,-0.78000000f,-0.83000000f,0.72000000f,0.49000000f,0.56000000f,-0.69000000f,-0.89000000f,0.95000000f,-0.45000000f,-0.15000000f,-0.39000000f,0.12000000f,-0.85000000f,-0.85000000f,-0.81000000f,-0.63000000f,0.33000000f,-0.00000000f,0.14000000f,-0.46000000f,-0.13000000f,0.44000000f,0.97000000f,-0.03000000f,0.58000000f,0.91000000f,-0.34000000f,0.56000000f,0.79000000f,0.36000000f,0.34000000f,0.00000000f,-0.16000000f,0.98000000f,-0.32000000f,-0.91000000f,0.51000000f,0.65000000f,-0.71000000f,-0.53000000f,0.00000000f,0.41000000f,0.83000000f,-0.42000000f,-0.52000000f,-0.82000000f,0.46000000f,0.20000000f,-0.61000000f,0.50000000f,0.82000000f,0.43000000f,0.05000000f,-0.29000000f,0.92000000f,0.87000000f,-0.57000000f,-0.56000000f,0.10000000f,0.06000000f,-0.95000000f,-0.26000000f,0.35000000f,-0.83000000f,-0.41000000f,0.85000000f,-0.43000000f,0.61000000f,-0.71000000f,0.70000000f,0.70000000f,-0.50000000f,-0.94000000f,0.89000000f,-0.78000000f,-0.64000000f,0.66000000f,-0.37000000f,-0.24000000f,-0.74000000f,-0.40000000f,0.62000000f,-0.01000000f,0.11000000f,0.47000000f,-0.85000000f,-0.10000000f,-0.11000000f,-0.91000000f,0.48000000f,0.43000000f,0.01000000f,0.71000000f,0.66000000f,0.15000000f,-0.33000000f,-0.07000000f,-0.92000000f,-0.77000000f,-0.44000000f,0.33000000f,-0.89000000f,-0.52000000f,0.46000000f,-0.68000000f,0.37000000f,-0.54000000f,0.11000000f,-0.08000000f,0.60000000f,-0.13000000f,-0.01000000f,-0.38000000f,-0.31000000f,-0.32000000f,0.10000000f,-0.58000000f,-0.12000000f,-0.62000000f,0.97000000f,-0.59000000f,-0.26000000f,-0.26000000f,0.08000000f,-0.59000000f,0.91000000f,0.33000000f,-0.12000000f,-0.22000000f,-0.08000000f,-0.86000000f,0.02000000f,0.65000000f,0.56000000f,-0.13000000f,0.34000000f,0.17000000f,0.59000000f,0.62000000f,0.70000000f,0.57000000f,0.73000000f,-0.86000000f,-0.21000000f,0.64000000f,-0.23000000f,-0.68000000f,0.92000000f,0.75000000f,-0.05000000f,-0.63000000f,-0.61000000f,0.52000000f,0.77000000f,-0.92000000f,-0.71000000f,0.73000000f,-0.62000000f,0.32000000f,-0.38000000f,0.99000000f,-0.58000000f,-0.77000000f,0.58000000f,-0.25000000f,0.08000000f,0.87000000f,0.12000000f,0.03000000f,0.60000000f,-0.07000000f,-0.31000000f,-0.70000000f,0.34000000f,0.71000000f,-0.94000000f,-0.72000000f,0.37000000f,0.18000000f,0.71000000f,0.17000000f,-0.75000000f,-0.90000000f,0.24000000f,-0.53000000f,-0.05000000f,0.68000000f,-0.19000000f,0.62000000f,-0.62000000f,0.67000000f,0.02000000f,0.78000000f,-0.85000000f,0.24000000f,-0.57000000f,0.02000000f,-0.31000000f,-0.23000000f,-0.95000000f,-0.78000000f,-0.51000000f,0.46000000f,0.33000000f,-0.06000000f,-0.05000000f,0.75000000f,-0.07000000f,-0.69000000f,-0.55000000f,-0.79000000f,0.39000000f,-0.28000000f,0.92000000f,-0.47000000f,-0.34000000f,-0.04000000f,0.32000000f,-0.35000000f,0.97000000f,-0.45000000f,0.65000000f,0.51000000f,-0.90000000f,-0.87000000f,0.48000000f,0.40000000f,0.46000000f,0.82000000f,-0.02000000f,-0.55000000f,0.85000000f,0.12000000f,-0.10000000f,0.65000000f,-0.23000000f,0.99000000f,0.91000000f,-0.02000000f,-0.89000000f,-0.67000000f,-0.92000000f,0.06000000f,-0.16000000f,-0.97000000f,-0.17000000f,0.11000000f,0.37000000f,0.59000000f,-0.85000000f,-0.43000000f,-0.24000000f,-0.78000000f,-0.35000000f,0.07000000f,-0.26000000f,0.65000000f,-0.86000000f,-0.29000000f,-0.82000000f,-0.03000000f,0.25000000f,-0.23000000f,0.51000000f,-0.61000000f,0.68000000f,0.88000000f,-0.35000000f,-0.17000000f,0.36000000f,0.36000000f,0.80000000f,-0.80000000f,-0.52000000f,0.90000000f,0.65000000f,0.82000000f,-0.19000000f,-0.10000000f,0.62000000f,0.87000000f,-0.11000000f,-0.67000000f,-0.24000000f,0.28000000f,0.80000000f,0.69000000f,0.36000000f,0.06000000f,0.02000000f,-0.15000000f,-0.85000000f,-0.94000000f,0.18000000f,-0.67000000f,-0.03000000f,0.58000000f,0.95000000f,0.70000000f,0.04000000f,-0.66000000f,-0.21000000f,0.77000000f,-0.87000000f,-0.96000000f,-0.86000000f,-0.96000000f,-0.33000000f,0.46000000f,-0.08000000f,-0.15000000f,0.24000000f,0.83000000f,-0.10000000f,-0.90000000f,-0.47000000f,0.56000000f,-0.10000000f,0.96000000f,-0.13000000f,0.12000000f,0.15000000f,-0.14000000f,-0.88000000f,-0.27000000f,0.86000000f,-0.51000000f,-0.00000000f,0.13000000f,0.56000000f,0.00000000f,0.03000000f,-0.64000000f,0.05000000f,0.44000000f,0.85000000f,0.15000000f,-0.70000000f,0.26000000f,-0.57000000f,-0.59000000f,-0.90000000f,-0.42000000f,0.46000000f,0.90000000f,-0.47000000f,-0.05000000f,-0.29000000f,0.77000000f,-0.47000000f,0.63000000f,-0.72000000f,0.24000000f,-0.90000000f,-0.96000000f,0.61000000f,0.74000000f,-0.90000000f,0.12000000f,-0.92000000f,-0.76000000f,0.34000000f,-0.53000000f,-0.50000000f,0.75000000f,0.78000000f,0.13000000f,0.39000000f,0.10000000f,0.57000000f,-0.10000000f,0.00000000f,0.61000000f,-0.29000000f,0.92000000f,-0.89000000f,0.70000000f,-0.25000000f,0.01000000f,0.56000000f,0.17000000f,-0.51000000f,0.78000000f,0.03000000f,-0.45000000f,0.37000000f,-0.65000000f,0.65000000f,-0.18000000f,0.28000000f,-0.04000000f,-0.68000000f,-0.48000000f,0.06000000f,0.94000000f,0.56000000f,0.92000000f,0.96000000f,-0.46000000f,-0.69000000f,0.89000000f,-0.43000000f,-0.68000000f,0.87000000f,-0.73000000f,0.93000000f,0.02000000f,0.99000000f,0.41000000f,-0.78000000f,0.06000000f,-0.56000000f,0.04000000f,0.68000000f,-0.79000000f,0.26000000f,0.39000000f,0.92000000f,-0.71000000f,-0.17000000f,-0.36000000f,-0.48000000f,-0.17000000f,0.97000000f,-0.94000000f,-0.46000000f,-0.84000000f,-0.79000000f,0.40000000f,0.20000000f,-0.71000000f,-0.70000000f,0.28000000f,-0.27000000f,-0.63000000f,-0.39000000f,-0.36000000f,0.35000000f,-0.69000000f,-0.94000000f,-0.17000000f,-0.97000000f,-0.07000000f,-0.78000000f,0.84000000f,0.17000000f,0.54000000f,0.29000000f,0.76000000f,0.73000000f,-0.58000000f,-0.03000000f,0.27000000f,0.44000000f,-0.03000000f,-0.83000000f,-0.04000000f,-0.93000000f,-0.42000000f,0.82000000f,-0.01000000f,-0.62000000f,-0.01000000f,0.61000000f,-0.05000000f,-0.69000000f,-0.63000000f,-0.02000000f,-0.25000000f,-0.27000000f,0.86000000f,0.48000000f,-0.92000000f,0.71000000f,0.69000000f,-0.93000000f,0.23000000f,-0.48000000f,0.22000000f,0.05000000f,-0.00000000f,-0.97000000f,0.82000000f,-0.47000000f,0.53000000f,0.68000000f,0.65000000f,-0.13000000f,-0.29000000f,-0.74000000f,0.66000000f,-0.47000000f,-0.01000000f,-0.62000000f,0.18000000f,0.78000000f,0.35000000f,0.34000000f,0.34000000f,-0.20000000f,0.65000000f,0.40000000f,-0.78000000f,-0.11000000f,0.81000000f,-0.36000000f,0.74000000f,-0.83000000f,-0.66000000f,-0.26000000f,0.90000000f,0.02000000f,0.55000000f,-0.97000000f,0.54000000f,0.50000000f,0.25000000f,0.57000000f,-0.49000000f,-0.15000000f,-0.45000000f,0.50000000f,-0.79000000f,-0.90000000f,-0.91000000f,0.31000000f,0.97000000f,0.77000000f,0.76000000f,0.73000000f,0.40000000f,-0.04000000f,-0.25000000f,0.71000000f,0.44000000f,0.71000000f,0.59000000f,0.88000000f,0.39000000f,-0.23000000f,0.99000000f,0.94000000f,0.65000000f,0.52000000f,-0.55000000f,-0.30000000f,-0.81000000f,0.21000000f,0.37000000f,0.47000000f,0.26000000f,-0.07000000f,-0.08000000f,0.62000000f,0.99000000f,-0.52000000f,-0.04000000f,0.75000000f,-0.67000000f,-0.23000000f,-0.16000000f,-0.25000000f,0.50000000f,-0.17000000f,-0.09000000f,0.16000000f,-0.92000000f,0.62000000f,0.70000000f,0.28000000f,0.00000000f,0.87000000f,-0.73000000f,0.97000000f,-0.31000000f,0.94000000f,0.56000000f,-0.00000000f,0.37000000f,0.05000000f,-0.70000000f,-0.03000000f,0.80000000f,0.95000000f,0.08000000f,-0.34000000f,0.85000000f,0.88000000f,0.95000000f,0.88000000f,0.14000000f,-0.22000000f,0.94000000f,0.47000000f,-0.85000000f,-0.07000000f,0.67000000f,0.55000000f,0.74000000f,0.87000000f,-0.39000000f,0.99000000f,0.49000000f,-0.14000000f,-0.20000000f,0.79000000f,-0.88000000f,0.79000000f,-0.14000000f,0.40000000f,0.57000000f,-0.32000000f,0.47000000f,-0.93000000f,-0.97000000f,-0.18000000f,0.71000000f,-0.96000000f,-0.50000000f,-0.65000000f,0.69000000f,-0.26000000f,-0.94000000f,-0.07000000f,-0.20000000f,0.55000000f,-0.84000000f,0.14000000f,0.88000000f,-0.94000000f,-0.62000000f,0.42000000f,-0.49000000f,0.70000000f,-0.61000000f,-0.36000000f,-0.92000000f,-0.96000000f,-0.42000000f,-0.15000000f,-0.55000000f,0.51000000f,0.56000000f,-0.03000000f,0.16000000f,0.27000000f,0.06000000f,-0.46000000f,-0.54000000f,-0.74000000f,0.48000000f,0.79000000f,-0.30000000f,-0.31000000f,0.37000000f,-0.63000000f,-0.53000000f,0.65000000f,-0.54000000f,-0.68000000f,0.10000000f,0.19000000f,-0.51000000f,0.68000000f,-0.81000000f,0.20000000f,0.38000000f,0.83000000f,0.14000000f,0.81000000f,0.29000000f,0.95000000f,-0.57000000f,0.83000000f,-0.25000000f,-0.26000000f,0.10000000f,-0.23000000f,0.00000000f,-0.77000000f,-0.47000000f,-0.36000000f,-0.33000000f,-0.38000000f,0.48000000f,0.15000000f,-0.61000000f,-0.07000000f,-0.35000000f,-0.52000000f,0.46000000f,-0.51000000f,-0.56000000f,0.32000000f,-0.51000000f,-0.87000000f,-0.76000000f,0.95000000f,-0.88000000f,-0.53000000f,-0.51000000f,0.18000000f,0.95000000f,-0.72000000f,-0.06000000f,0.85000000f,0.07000000f,-0.84000000f,0.90000000f,-0.19000000f,0.14000000f,0.54000000f,-0.84000000f,-0.57000000f,-0.38000000f,0.23000000f,0.45000000f,0.66000000f,0.73000000f,-0.87000000f,-0.29000000f,0.25000000f,-0.74000000f,-0.87000000f,-0.54000000f,0.08000000f,-0.26000000f,-0.15000000f,0.40000000f,-0.62000000f,-0.73000000f,-0.38000000f,0.13000000f,0.37000000f,0.20000000f,0.61000000f,-0.78000000f,0.84000000f,0.99000000f,0.80000000f,-0.99000000f,0.52000000f,0.85000000f,-0.61000000f,-0.74000000f,-0.52000000f,0.03000000f,-0.17000000f,-0.91000000f,0.64000000f,0.61000000f,0.82000000f,0.49000000f,-0.90000000f,0.13000000f,0.92000000f,0.63000000f,-0.38000000f,0.40000000f,-0.12000000f,-0.46000000f,-0.66000000f,0.45000000f,-0.68000000f,-0.32000000f,-0.41000000f,0.97000000f,-0.78000000f,-0.82000000f,-0.93000000f,-0.19000000f,0.33000000f,-0.56000000f,-0.21000000f,-0.37000000f,0.61000000f,-0.37000000f,-0.59000000f,0.50000000f,0.88000000f,0.39000000f,0.11000000f,0.66000000f,-0.67000000f,0.49000000f,-0.07000000f,0.51000000f,-0.20000000f,0.65000000f,-0.63000000f,-0.87000000f,0.96000000f,-0.58000000f,-0.24000000f,0.29000000f,-0.67000000f,-0.39000000f,-0.18000000f,0.48000000f,0.79000000f,0.97000000f,0.24000000f,0.07000000f,0.19000000f,0.54000000f,-0.45000000f,-0.34000000f,-0.13000000f,0.43000000f,-0.55000000f,-0.31000000f,-0.55000000f,0.77000000f,-0.52000000f,-0.20000000f,0.30000000f,0.81000000f,0.74000000f,0.63000000f,0.01000000f,-0.70000000f,0.17000000f,0.50000000f,0.34000000f,0.73000000f,0.01000000f,-0.74000000f,0.37000000f,0.88000000f,-0.40000000f,0.39000000f,-0.07000000f,-0.03000000f,0.14000000f,0.89000000f,0.70000000f,-0.49000000f,-0.41000000f,-0.66000000f,0.20000000f,0.95000000f,0.34000000f,0.69000000f,-0.01000000f,-0.63000000f,0.57000000f,0.60000000f,0.99000000f,0.49000000f,-0.45000000f,0.77000000f,-0.26000000f,-0.83000000f,0.29000000f,0.69000000f,-0.26000000f,0.97000000f,-0.25000000f,-0.96000000f,0.68000000f,-0.17000000f,0.99000000f,-0.61000000f,0.40000000f,-0.56000000f,0.50000000f,0.07000000f,0.74000000f,-0.16000000f,-0.44000000f,0.72000000f,0.50000000f,0.02000000f,0.74000000f,0.95000000f,-0.14000000f,-0.40000000f,0.82000000f,-0.82000000f,-0.58000000f,0.06000000f,0.77000000f,-0.26000000f,0.63000000f,0.17000000f,-0.44000000f,-0.08000000f,0.72000000f,0.16000000f,-0.91000000f,-0.56000000f,0.86000000f,0.34000000f,0.70000000f,0.85000000f,-0.93000000f,0.99000000f,0.33000000f,0.32000000f,0.23000000f,-0.40000000f,-0.96000000f,0.07000000f,0.01000000f,-0.81000000f,-0.39000000f,-0.82000000f,-0.50000000f,-0.15000000f,0.52000000f,0.34000000f,-0.96000000f,-0.28000000f,0.16000000f,0.72000000f,-0.91000000f,0.03000000f,-0.22000000f,0.27000000f,-0.53000000f,0.27000000f,-0.53000000f,0.95000000f,0.48000000f,0.22000000f,0.61000000f,-0.30000000f,0.67000000f,-0.22000000f,-0.06000000f,-0.56000000f,-0.74000000f,0.98000000f,-0.97000000f,0.15000000f,0.97000000f,-0.71000000f,0.53000000f,-0.09000000f,0.58000000f,-0.80000000f,0.85000000f,-0.96000000f,-0.50000000f,0.22000000f,-0.43000000f,-0.73000000f,0.36000000f,-0.27000000f,0.46000000f,0.36000000f,0.92000000f,0.02000000f,0.00000000f,0.55000000f,-0.00000000f,-0.68000000f,-0.39000000f,-0.67000000f,-0.58000000f,-0.50000000f,0.39000000f,-0.18000000f,0.48000000f,-0.66000000f,0.05000000f,-0.38000000f,-0.48000000f,0.42000000f,-0.72000000f,0.30000000f,0.30000000f,0.13000000f,-0.52000000f,-0.47000000f,-0.07000000f,-0.92000000f,-0.28000000f,0.25000000f,-0.19000000f,0.83000000f,-0.30000000f,0.66000000f,0.57000000f,-0.98000000f,-0.47000000f,0.03000000f,0.22000000f,-0.55000000f,0.14000000f,-0.04000000f,-0.81000000f,0.99000000f,-0.48000000f,-0.36000000f,0.24000000f,0.08000000f,-0.82000000f,-0.74000000f,-0.68000000f,-0.12000000f,-0.57000000f,-0.55000000f,-0.43000000f,-0.57000000f,-0.37000000f,-0.84000000f,-0.83000000f,0.44000000f,0.26000000f,-0.04000000f,0.03000000f,-0.58000000f,-0.84000000f,0.78000000f,-0.30000000f,-0.00000000f,-0.82000000f,0.12000000f,-0.00000000f,0.13000000f,0.49000000f,-0.26000000f,0.11000000f,0.50000000f,-0.44000000f,-0.87000000f,-0.15000000f,-0.22000000f,-0.21000000f,-0.76000000f,-0.79000000f,0.80000000f,0.97000000f,0.97000000f,0.06000000f,0.87000000f,0.13000000f,-0.22000000f,0.49000000f,-0.11000000f,-0.36000000f,-0.12000000f,-0.39000000f,0.43000000f,0.17000000f,0.54000000f,-0.17000000f,0.93000000f,-0.21000000f,0.80000000f,0.60000000f,-0.40000000f,0.02000000f,0.85000000f,0.32000000f,-0.52000000f,-0.62000000f,0.54000000f,0.01000000f,-0.93000000f,0.07000000f,0.97000000f,-0.46000000f,-0.94000000f,-0.94000000f,-0.93000000f,-0.41000000f,0.80000000f,-0.54000000f,-0.23000000f,-0.08000000f,0.60000000f,-0.56000000f,0.26000000f,0.12000000f,-0.48000000f,0.53000000f,0.90000000f,0.93000000f,-0.84000000f,0.71000000f,-0.60000000f,0.18000000f,0.52000000f,-0.59000000f,-0.74000000f,0.36000000f,-0.74000000f,-0.25000000f,-0.77000000f,0.13000000f,-0.88000000f,0.88000000f,-0.23000000f,-0.29000000f,0.82000000f,0.26000000f,0.57000000f,-0.29000000f,0.07000000f,-0.40000000f,0.99000000f,-0.89000000f,0.56000000f,-0.19000000f,0.95000000f,0.50000000f,-0.70000000f,0.31000000f,0.75000000f,0.63000000f,0.70000000f,-0.46000000f,-0.34000000f,0.88000000f,0.03000000f,0.56000000f,0.71000000f,0.34000000f,0.17000000f,-0.79000000f,-0.78000000f,0.47000000f,0.14000000f,0.00000000f,0.49000000f,0.10000000f,0.42000000f,0.35000000f,-0.39000000f,0.02000000f,-0.02000000f,0.19000000f,0.36000000f,-0.71000000f,0.30000000f,-0.58000000f,-0.42000000f,-0.23000000f,0.24000000f,0.17000000f,-0.42000000f,0.77000000f,-0.88000000f,0.07000000f,-0.33000000f,0.20000000f,-0.05000000f,0.37000000f,-0.74000000f,0.87000000f,0.00000000f,-0.23000000f,-0.48000000f,-0.95000000f,-0.97000000f,0.12000000f,-0.86000000f,0.58000000f,-0.92000000f,0.62000000f,0.72000000f,-0.53000000f,0.03000000f,0.70000000f,0.26000000f,0.95000000f,-0.44000000f,0.91000000f,0.09000000f,-0.31000000f,0.53000000f,0.90000000f,0.92000000f,-0.68000000f,0.75000000f,-0.85000000f,-0.04000000f,-0.42000000f,-0.77000000f,-0.67000000f,0.94000000f,-0.57000000f,-0.93000000f,-0.43000000f,-0.74000000f,0.95000000f,-0.53000000f,-0.50000000f,0.69000000f,0.93000000f,0.61000000f,-0.62000000f,0.66000000f,0.44000000f,-0.98000000f,0.54000000f,0.33000000f,-0.61000000f,-0.95000000f,0.92000000f,-0.95000000f,0.63000000f,-0.25000000f,-0.36000000f,-0.70000000f,-0.57000000f,-0.36000000f,-0.42000000f,0.34000000f,-0.01000000f,0.27000000f,-0.76000000f,-0.22000000f,0.46000000f,-0.89000000f,-0.02000000f,0.57000000f,0.82000000f,-0.58000000f,-0.52000000f,0.49000000f,0.02000000f,-0.04000000f,0.73000000f,-0.47000000f,-0.08000000f,0.47000000f,-0.98000000f,0.94000000f,0.82000000f,-0.90000000f,-0.88000000f,-0.82000000f,0.04000000f,0.25000000f,0.84000000f,-0.26000000f,0.19000000f,-0.43000000f,0.32000000f,-0.66000000f,0.25000000f,0.44000000f,0.47000000f,-0.69000000f,-0.14000000f,0.64000000f,-0.15000000f,-0.50000000f,-0.12000000f,0.29000000f,-0.08000000f,0.83000000f,0.48000000f,0.07000000f,-0.51000000f,0.24000000f,-0.81000000f,-0.65000000f,-0.54000000f,0.12000000f,0.52000000f,0.15000000f,-0.55000000f,-0.94000000f,0.47000000f,-0.32000000f,0.04000000f,0.17000000f,-0.13000000f,-0.13000000f,0.46000000f,0.13000000f,-0.85000000f,-0.55000000f,0.41000000f,-0.90000000f,0.84000000f,-0.17000000f,-0.73000000f,0.29000000f,-0.70000000f,0.16000000f,0.38000000f,0.39000000f,-0.93000000f,0.96000000f,-0.45000000f,0.54000000f,-0.76000000f,-0.07000000f,-0.02000000f,0.84000000f,0.91000000f,-0.09000000f,0.94000000f,-0.19000000f,0.88000000f,-0.93000000f,0.74000000f,0.19000000f,-0.39000000f,0.11000000f,-0.36000000f,-0.57000000f,0.01000000f,-0.71000000f,-0.67000000f,-0.54000000f,0.54000000f,-0.22000000f,0.06000000f,-0.67000000f,0.68000000f,-0.45000000f,0.64000000f,0.46000000f,0.69000000f,0.75000000f,0.94000000f,-0.40000000f,-0.05000000f,-0.89000000f,-0.07000000f,-0.47000000f,0.03000000f,-0.31000000f,0.54000000f,-0.88000000f,0.90000000f,-0.37000000f,0.01000000f,-0.23000000f,-0.96000000f,0.12000000f,-0.42000000f,0.91000000f,-0.62000000f,-0.06000000f,0.78000000f,0.63000000f,-0.72000000f,0.28000000f,0.11000000f,0.11000000f,0.15000000f,0.73000000f,-0.91000000f,0.36000000f,0.42000000f,0.25000000f,-0.36000000f,-0.27000000f,0.42000000f,-0.51000000f,-0.44000000f,0.87000000f,0.33000000f,0.47000000f,0.84000000f,0.05000000f,0.37000000f,-0.60000000f,-0.66000000f,0.83000000f,0.84000000f,0.43000000f,0.15000000f,-0.90000000f,-0.48000000f,-0.59000000f,-0.98000000f,0.80000000f,-0.43000000f,-0.01000000f,0.43000000f,0.62000000f,-0.52000000f,0.36000000f,-0.55000000f,0.14000000f,0.08000000f,-0.32000000f,0.65000000f,-0.51000000f,0.26000000f,0.69000000f,-0.71000000f,-0.69000000f,0.28000000f,-0.66000000f,-0.91000000f,-0.15000000f,0.47000000f,0.34000000f,0.56000000f,-0.66000000f,0.26000000f,0.56000000f,0.21000000f,-0.67000000f,0.85000000f,0.30000000f,0.83000000f,0.17000000f,-0.30000000f,0.09000000f,0.23000000f,0.64000000f,0.26000000f,0.78000000f,-0.09000000f,-0.37000000f,-0.45000000f,-0.74000000f,-0.96000000f,-0.13000000f,0.16000000f,-0.94000000f,-0.78000000f,0.75000000f,0.40000000f,0.83000000f,0.99000000f,-0.91000000f,-0.26000000f,0.66000000f,-0.55000000f,0.89000000f,0.86000000f,-0.64000000f,-0.06000000f,0.33000000f,-0.09000000f,-0.87000000f,0.63000000f,-0.40000000f,0.91000000f,-0.89000000f,0.76000000f,-0.39000000f,-0.93000000f,0.77000000f,0.61000000f,-0.10000000f,-0.78000000f,-0.79000000f,-0.93000000f,0.44000000f,0.58000000f,0.16000000f,-0.39000000f,-0.97000000f,-0.90000000f,0.01000000f,-0.36000000f,0.70000000f,0.26000000f,0.90000000f,-0.65000000f,0.94000000f,-0.19000000f,-0.00000000f,0.26000000f,-0.39000000f,0.25000000f,-0.27000000f,0.68000000f,0.06000000f,0.11000000f,0.88000000f,0.73000000f,0.17000000f,0.83000000f,-0.39000000f,-0.16000000f,-0.43000000f,-0.16000000f,0.59000000f,0.68000000f,0.45000000f,0.15000000f,0.53000000f,-0.56000000f,0.99000000f,-0.46000000f,-0.50000000f,-0.47000000f,-0.63000000f,-0.07000000f,0.32000000f,0.09000000f,0.40000000f,-0.42000000f,-0.66000000f,0.89000000f,-0.73000000f,-0.62000000f,0.43000000f,0.67000000f,-0.31000000f,0.65000000f,-0.04000000f,-0.37000000f,0.77000000f,0.10000000f,-0.78000000f,0.67000000f,0.29000000f,-0.37000000f,-0.94000000f,-0.00000000f,-0.79000000f,-0.15000000f,0.08000000f,-0.53000000f,0.88000000f,0.21000000f,0.73000000f,0.17000000f,-0.13000000f,0.93000000f,0.86000000f,-0.65000000f,-0.12000000f,-0.69000000f,0.57000000f,0.23000000f,-0.62000000f,0.03000000f,-0.47000000f,0.02000000f,0.20000000f,-0.42000000f,0.97000000f,0.85000000f,-0.16000000f,-0.87000000f,-0.78000000f,0.50000000f,0.34000000f,-0.81000000f,0.87000000f,0.29000000f,0.61000000f,-0.82000000f,-0.50000000f,-0.86000000f,0.56000000f,-0.14000000f,-0.50000000f,-0.35000000f,-0.55000000f,-0.37000000f,0.37000000f,-0.55000000f,0.59000000f,-0.27000000f,0.47000000f,-0.88000000f,0.78000000f,0.09000000f,-0.61000000f,-0.20000000f,-0.81000000f,0.10000000f,0.11000000f,-0.93000000f,-0.80000000f,0.74000000f,0.65000000f,0.27000000f,-0.97000000f,0.97000000f,-0.04000000f,0.49000000f,-0.77000000f,0.36000000f,0.82000000f,0.09000000f,-0.32000000f,0.08000000f,0.67000000f,0.08000000f,0.48000000f,-0.02000000f,-0.07000000f,0.55000000f,-0.47000000f,0.03000000f,-0.17000000f,-0.72000000f,-0.05000000f,0.79000000f,0.60000000f,-0.86000000f,0.68000000f,0.07000000f,0.77000000f,-0.60000000f,0.83000000f,0.47000000f,0.65000000f,-0.95000000f,-0.00000000f,0.71000000f,0.97000000f,0.63000000f,0.75000000f,0.83000000f,-0.08000000f,-0.89000000f,-0.46000000f,-0.46000000f,-0.51000000f,0.69000000f,0.83000000f,0.33000000f,0.25000000f,0.36000000f,-0.47000000f,-0.57000000f,0.36000000f,-0.15000000f,0.03000000f,0.72000000f,-0.91000000f,-0.46000000f,-0.45000000f,-0.08000000f,0.21000000f,0.39000000f,-0.59000000f,0.73000000f,0.34000000f,-0.42000000f,0.35000000f,-0.11000000f,-0.38000000f,-0.51000000f,0.84000000f,-0.07000000f,-0.21000000f,-0.58000000f,-0.96000000f,-0.91000000f,0.00000000f,-0.85000000f,-0.29000000f,-0.73000000f,-0.45000000f,-0.52000000f,-0.13000000f,-0.44000000f,-0.79000000f,-0.90000000f,0.32000000f,0.67000000f,0.66000000f,0.51000000f,-0.57000000f,-0.31000000f,0.85000000f,-0.46000000f,0.91000000f,-0.03000000f,-0.13000000f,0.81000000f,-0.84000000f,0.07000000f,0.37000000f,-0.51000000f,0.73000000f,-0.11000000f,0.59000000f,-0.38000000f,0.64000000f,-0.41000000f,-0.80000000f,0.72000000f,-0.72000000f,-0.70000000f,0.50000000f,-0.19000000f,-0.42000000f,-0.10000000f,0.59000000f,0.79000000f,-0.69000000f,-0.58000000f,0.15000000f,0.98000000f,0.44000000f,0.19000000f,-0.18000000f,-0.06000000f,0.80000000f,-0.27000000f,-0.02000000f,-0.02000000f,0.25000000f,-0.20000000f,0.29000000f,-0.80000000f,0.39000000f,0.89000000f,0.99000000f,0.47000000f,0.43000000f,0.71000000f,-0.43000000f,-0.26000000f,0.62000000f,0.10000000f,0.79000000f,-0.26000000f,0.18000000f,0.27000000f,-0.75000000f,-0.82000000f,-0.09000000f,-0.63000000f,0.66000000f,-0.29000000f,-0.54000000f,-0.21000000f,-0.83000000f,-0.42000000f,0.85000000f,0.69000000f,-0.95000000f,-0.85000000f,0.04000000f,-0.60000000f,0.02000000f,-0.00000000f,0.19000000f,0.01000000f,0.89000000f,-0.69000000f,0.85000000f,-0.70000000f,0.46000000f,-0.47000000f,-0.43000000f,-0.03000000f,0.37000000f,-0.66000000f,-0.44000000f,0.90000000f,0.03000000f,-0.07000000f,-0.09000000f,0.17000000f,-0.42000000f,0.16000000f,-0.81000000f,-0.05000000f,0.56000000f,-0.19000000f,-0.23000000f,-0.89000000f,-0.20000000f,-0.95000000f,-0.47000000f,-0.84000000f,0.84000000f,-0.91000000f,-0.33000000f,-0.69000000f,0.53000000f,-0.99000000f,0.93000000f,0.03000000f,-0.88000000f,0.03000000f,-0.01000000f,0.88000000f,0.84000000f,-0.71000000f,-0.25000000f,-0.04000000f,-0.15000000f,-0.92000000f,-0.12000000f,-0.74000000f,-0.04000000f,0.08000000f,-0.61000000f,0.18000000f,0.93000000f,-0.30000000f,-0.81000000f,0.94000000f,-0.39000000f,-0.41000000f,0.21000000f,-0.08000000f,-0.97000000f,-0.41000000f,0.10000000f,-0.44000000f,0.14000000f,0.30000000f,-0.75000000f,0.68000000f,-0.09000000f,0.43000000f,0.49000000f,-0.58000000f,0.94000000f,-0.01000000f,0.26000000f,0.75000000f,0.77000000f,-0.26000000f,0.56000000f,0.48000000f,-0.50000000f,-0.45000000f,0.56000000f,-0.13000000f,0.53000000f,-0.75000000f,-0.18000000f,0.05000000f,-0.00000000f,0.66000000f,0.23000000f,-0.50000000f,0.57000000f,0.37000000f,-0.23000000f,0.86000000f,-0.05000000f,-0.61000000f,-0.22000000f,0.72000000f,-0.35000000f,0.47000000f,-0.50000000f,0.78000000f,0.81000000f,0.05000000f,-0.04000000f,-0.05000000f,0.41000000f,-0.74000000f,0.52000000f,0.34000000f,-0.02000000f,0.30000000f,0.91000000f,-0.52000000f,-0.66000000f,-0.57000000f,-0.49000000f,-0.76000000f,-0.29000000f,-0.92000000f,0.87000000f,-0.26000000f,-0.88000000f,-0.78000000f,-0.98000000f,-0.61000000f,-0.72000000f,0.09000000f,0.82000000f,0.47000000f,-0.19000000f,-0.71000000f,0.56000000f,0.15000000f,-0.07000000f,-0.94000000f,0.85000000f,0.85000000f,0.40000000f,-0.13000000f,-0.20000000f,0.23000000f,-0.02000000f,-0.74000000f,0.12000000f,0.99000000f,-0.44000000f,0.34000000f,-0.54000000f,0.90000000f,-0.95000000f,0.54000000f,-0.27000000f,0.36000000f,0.78000000f,-0.86000000f,-0.21000000f,0.17000000f,0.28000000f,-0.15000000f,0.66000000f,-0.43000000f,0.64000000f,0.70000000f,-0.95000000f,0.27000000f,0.71000000f,0.27000000f,-0.99000000f,-0.11000000f,-0.56000000f,0.21000000f,-0.84000000f,-0.64000000f,-0.26000000f,0.05000000f,0.31000000f,0.56000000f,-0.41000000f,-0.77000000f,-0.32000000f,0.72000000f,0.25000000f,0.81000000f,0.06000000f,-0.92000000f,0.89000000f,-0.23000000f,0.42000000f,0.53000000f,-0.15000000f,0.11000000f,0.88000000f,-0.36000000f,-0.43000000f,-0.68000000f,0.37000000f,-0.62000000f,-0.77000000f,-0.03000000f,-0.93000000f,0.50000000f,0.57000000f,-0.90000000f,-0.00000000f,0.82000000f,0.61000000f,-0.62000000f,0.38000000f,-0.06000000f,-0.32000000f,0.31000000f,0.66000000f,-0.25000000f,0.90000000f,0.15000000f,0.12000000f,0.60000000f,0.82000000f,-0.86000000f,0.54000000f,-0.99000000f,0.05000000f,0.92000000f,-0.75000000f,-0.26000000f,-0.32000000f,-0.18000000f,0.41000000f,0.38000000f,-0.32000000f,0.27000000f,0.08000000f,0.74000000f,-0.71000000f,-0.26000000f,0.34000000f,0.99000000f,0.46000000f,0.11000000f,-0.41000000f,-0.09000000f,0.19000000f,-0.83000000f,0.43000000f,0.12000000f,0.74000000f,0.31000000f,-0.35000000f,-0.76000000f,0.13000000f,0.05000000f,0.65000000f,0.32000000f,-0.62000000f,-0.34000000f,-0.37000000f,0.94000000f,-0.18000000f,0.03000000f,-0.30000000f,-0.91000000f,0.95000000f,0.76000000f,0.67000000f,0.85000000f,0.15000000f,0.84000000f,-0.21000000f,0.87000000f,0.83000000f,0.56000000f,-0.67000000f,0.72000000f,0.05000000f,-0.70000000f,-0.28000000f,-0.87000000f,-0.25000000f,0.95000000f,0.34000000f,-0.01000000f,0.20000000f,-0.72000000f,0.57000000f,0.06000000f,0.99000000f,0.05000000f,0.36000000f,0.77000000f,-0.89000000f,-0.52000000f,-0.65000000f,-0.95000000f,-0.49000000f,-0.62000000f,0.12000000f,0.17000000f,-0.89000000f,0.27000000f,-0.72000000f,0.09000000f,0.94000000f,0.46000000f,-0.39000000f,-0.27000000f,-0.34000000f,0.05000000f,-0.43000000f,0.76000000f,0.59000000f,0.41000000f,-0.69000000f,0.50000000f,0.30000000f,0.69000000f,0.31000000f,0.31000000f,0.60000000f,-0.81000000f,-0.34000000f,-0.31000000f,0.32000000f,0.72000000f,-0.37000000f,0.08000000f,-0.61000000f,-0.77000000f,-0.86000000f,0.13000000f,0.52000000f,-0.28000000f,-0.43000000f,-0.70000000f,0.34000000f,0.41000000f,-0.85000000f,-0.19000000f,0.09000000f,0.88000000f,-0.40000000f,-0.92000000f,-0.62000000f,-0.97000000f,0.11000000f,-0.54000000f,-0.51000000f,-0.99000000f,-0.03000000f,0.69000000f,0.57000000f,-0.56000000f,-0.87000000f,0.39000000f,0.37000000f,0.72000000f,0.17000000f,-0.28000000f,-0.86000000f,0.46000000f,-0.77000000f,0.49000000f,-0.73000000f,-0.65000000f,-0.81000000f,-0.78000000f,0.02000000f,0.22000000f,-0.58000000f,0.30000000f,-0.95000000f,-0.91000000f,0.94000000f,-0.73000000f,0.67000000f,0.45000000f,-0.49000000f,0.37000000f,0.48000000f,-0.76000000f,-0.59000000f,0.32000000f,0.97000000f,0.01000000f,0.46000000f,-0.42000000f,0.58000000f,0.26000000f,0.62000000f,0.58000000f,-0.26000000f,-0.52000000f,-0.24000000f,-0.72000000f,-0.88000000f,0.89000000f,0.99000000f,0.20000000f,0.48000000f,0.11000000f,0.82000000f,-0.51000000f,0.46000000f,-0.07000000f,0.19000000f,0.66000000f,-0.22000000f,-0.68000000f,0.37000000f,0.81000000f,0.51000000f,-0.81000000f,-0.75000000f,-0.51000000f,-0.26000000f,-0.13000000f,0.47000000f,0.59000000f,-0.71000000f,-0.43000000f,-0.33000000f,0.82000000f,-0.15000000f,-0.18000000f,0.80000000f,-0.09000000f,0.19000000f,0.75000000f,0.20000000f,0.31000000f,0.28000000f,-0.44000000f,-0.43000000f,0.18000000f,0.53000000f,0.76000000f,0.15000000f,-0.63000000f,-0.39000000f,-0.84000000f,0.01000000f,-0.05000000f,-0.33000000f,0.32000000f,0.10000000f,0.00000000f,0.80000000f,0.46000000f,-0.78000000f,0.84000000f,-0.20000000f,0.60000000f,0.62000000f,0.52000000f,-0.79000000f,0.21000000f,-0.97000000f,-0.94000000f,0.45000000f,-0.46000000f,-0.97000000f,-0.53000000f,-0.37000000f,-0.97000000f,-0.68000000f,0.09000000f,-0.80000000f,0.50000000f,0.09000000f,0.56000000f,0.10000000f,0.81000000f,0.33000000f,0.81000000f,-0.32000000f,-0.51000000f,-0.00000000f,-0.15000000f,0.92000000f,0.94000000f,-0.79000000f,-0.72000000f,0.43000000f,-0.04000000f,0.42000000f,0.21000000f,0.99000000f,0.39000000f,0.06000000f,-0.01000000f,-0.59000000f,0.18000000f,-0.94000000f,-0.50000000f,-0.55000000f,-0.13000000f,0.32000000f,0.94000000f,-0.87000000f,0.08000000f,-0.72000000f,-0.17000000f,-0.37000000f,0.21000000f,0.01000000f,-0.28000000f,0.60000000f,0.05000000f,-0.99000000f,-0.50000000f,-0.74000000f,0.32000000f,0.49000000f,-0.29000000f,0.12000000f,-0.52000000f,-0.90000000f,-0.68000000f,-0.45000000f,0.73000000f,0.52000000f,0.03000000f,-0.71000000f,0.39000000f,0.92000000f,-0.95000000f,0.83000000f,-0.60000000f,-0.44000000f,-0.66000000f,-0.59000000f,-0.76000000f,-0.79000000f,-0.10000000f,-0.77000000f,0.35000000f,0.88000000f,-0.49000000f,0.08000000f,0.06000000f,-0.97000000f,-0.84000000f,-0.47000000f,0.40000000f,0.51000000f,0.13000000f,-0.06000000f,-0.35000000f,0.81000000f,-0.99000000f,-0.09000000f,-0.92000000f,-0.38000000f,-0.78000000f,-0.10000000f,0.76000000f,-0.08000000f,-0.31000000f,-0.59000000f,-0.86000000f,-0.34000000f,-0.86000000f,0.54000000f,0.10000000f,0.16000000f,-0.01000000f,-0.68000000f,-0.22000000f,-0.15000000f,0.46000000f,0.92000000f,-0.75000000f,-0.84000000f,-0.62000000f,-0.74000000f,0.40000000f,0.90000000f,-0.41000000f,-0.14000000f,-0.73000000f,0.27000000f,0.86000000f,0.53000000f,-0.41000000f,0.35000000f,0.96000000f,0.34000000f,0.96000000f,-0.83000000f,0.88000000f,-0.35000000f,0.34000000f,-0.71000000f,-0.27000000f,-0.28000000f,0.38000000f,-0.98000000f,-0.30000000f,-0.67000000f,0.52000000f,-0.03000000f,0.63000000f,-0.54000000f,0.26000000f,0.41000000f,-0.01000000f,-0.10000000f,-0.38000000f,0.61000000f,-0.77000000f,0.92000000f,0.58000000f,-0.98000000f,0.93000000f,-0.27000000f,-0.08000000f,0.78000000f,-0.64000000f,-0.93000000f,0.79000000f,-0.36000000f,0.94000000f,-0.10000000f,0.48000000f,0.73000000f,-0.44000000f,0.00000000f,-0.94000000f,-0.90000000f,0.04000000f,-0.72000000f,0.09000000f,-0.57000000f,0.46000000f,-0.62000000f,-0.41000000f,0.09000000f,-0.21000000f,-0.56000000f,0.79000000f,0.49000000f,-0.78000000f,0.43000000f,0.61000000f,-0.29000000f,-0.10000000f,-0.54000000f,0.64000000f,-0.95000000f,0.35000000f,-0.50000000f,0.99000000f,0.08000000f,-0.07000000f,-0.00000000f,0.31000000f,0.69000000f,0.78000000f,0.68000000f,-0.34000000f,-0.39000000f,0.17000000f,0.51000000f,-0.25000000f,0.71000000f,0.83000000f,0.58000000f,0.87000000f,0.79000000f,0.14000000f,0.26000000f,0.54000000f,0.26000000f,0.06000000f,0.85000000f,-0.29000000f,-0.79000000f,-0.57000000f,-0.02000000f,-0.07000000f,0.77000000f,0.16000000f,0.17000000f,-0.35000000f,0.63000000f,0.61000000f,0.89000000f,0.52000000f,0.14000000f,0.77000000f,0.57000000f,0.80000000f,-0.81000000f,-0.93000000f,-0.18000000f,-0.32000000f,-0.88000000f,0.24000000f,-0.25000000f,-0.75000000f,0.88000000f,0.43000000f,0.09000000f,-0.08000000f,-0.15000000f,0.53000000f,-0.93000000f,0.02000000f,-0.48000000f,0.82000000f,-0.81000000f,0.86000000f,-0.84000000f,0.15000000f,0.64000000f,-0.20000000f,0.92000000f,0.10000000f,0.26000000f,0.75000000f,-0.50000000f,0.50000000f,-0.75000000f,0.48000000f,-0.27000000f,-0.39000000f,-0.82000000f,-0.71000000f,0.60000000f,0.99000000f,-0.84000000f,0.42000000f,-0.01000000f,0.39000000f,-0.86000000f,-0.06000000f,0.66000000f,0.70000000f,0.17000000f,0.75000000f,-0.97000000f,0.57000000f,-0.44000000f,-0.68000000f,0.13000000f,-0.20000000f,-0.69000000f,0.99000000f,0.73000000f,0.38000000f,-0.51000000f,-0.23000000f,0.26000000f,-0.85000000f,0.57000000f,-0.62000000f,0.72000000f,0.69000000f,0.88000000f,-0.09000000f,-0.30000000f,-0.30000000f,0.37000000f,-0.62000000f,-0.74000000f,-0.02000000f,-0.33000000f,-0.69000000f,0.00000000f,-0.53000000f,-0.99000000f,-0.39000000f,-0.88000000f,0.56000000f,0.09000000f,0.33000000f,0.56000000f,0.75000000f,0.01000000f,-0.68000000f,0.87000000f,0.80000000f,-0.23000000f,-0.48000000f,-0.20000000f,0.08000000f,0.64000000f,0.10000000f,-0.14000000f,0.13000000f,0.50000000f,-0.92000000f,0.43000000f,-0.61000000f,-0.04000000f,-0.90000000f,0.65000000f,0.76000000f,0.58000000f,-0.21000000f,0.63000000f,0.93000000f,-0.61000000f,0.01000000f,-0.13000000f,0.09000000f,0.89000000f,0.46000000f,0.82000000f,0.95000000f,0.23000000f,-0.86000000f,-0.16000000f,0.38000000f,0.00000000f,0.70000000f,-0.42000000f,0.56000000f,-0.55000000f,0.05000000f,0.88000000f,-0.22000000f,-0.51000000f,-0.84000000f,0.28000000f,-0.03000000f,0.74000000f,0.53000000f,0.40000000f,-0.98000000f,-0.52000000f,-0.50000000f,-0.67000000f,0.84000000f,-0.72000000f,-0.78000000f,0.14000000f,0.08000000f,-0.44000000f,-0.23000000f,0.38000000f,-0.01000000f,0.76000000f,0.26000000f,0.97000000f,0.80000000f,-0.84000000f,-0.20000000f,-0.19000000f,0.51000000f,0.42000000f,-0.51000000f,-0.81000000f,0.69000000f,0.10000000f,-0.98000000f,-0.62000000f,-0.82000000f,0.09000000f,-0.43000000f,0.54000000f,0.47000000f,0.43000000f,-0.85000000f,0.87000000f,-0.86000000f,0.24000000f,0.23000000f,-0.46000000f,-0.33000000f,0.86000000f,-0.90000000f,0.26000000f,-0.42000000f,-0.48000000f,-0.12000000f,0.55000000f,-0.28000000f,-0.49000000f,-0.40000000f,0.45000000f,0.72000000f,0.69000000f,0.10000000f,-0.20000000f,0.02000000f,0.65000000f,-0.55000000f,0.70000000f,0.27000000f,-0.11000000f,0.44000000f,0.87000000f,-0.83000000f,0.09000000f,0.60000000f,0.11000000f,0.05000000f,-0.33000000f,-0.35000000f,0.74000000f,0.23000000f,-0.91000000f,0.35000000f,-0.47000000f,0.52000000f,-0.70000000f,0.56000000f,0.24000000f,-0.60000000f,-0.60000000f,0.42000000f,-0.40000000f,-0.30000000f,-0.87000000f,0.61000000f,-0.53000000f,0.61000000f,0.85000000f,0.00000000f,-0.19000000f,-0.10000000f,-0.72000000f,-0.07000000f,-0.62000000f,0.46000000f,-0.16000000f,-0.75000000f,-0.96000000f,-0.92000000f,0.87000000f,-0.95000000f,-0.25000000f,-0.40000000f,0.63000000f,0.45000000f,-0.22000000f,-0.49000000f,0.27000000f,0.05000000f,-0.96000000f,-0.89000000f,0.43000000f,0.38000000f,0.50000000f,0.09000000f,0.78000000f,-0.73000000f,0.67000000f,0.55000000f,-0.53000000f,0.89000000f,-0.34000000f,0.99000000f,-0.29000000f,-0.04000000f,-0.42000000f,-0.34000000f,-0.74000000f,-0.36000000f,0.38000000f,0.94000000f,0.29000000f,-0.11000000f,0.10000000f,-0.08000000f,-0.21000000f,-0.18000000f,0.88000000f,-0.64000000f,-0.58000000f,-0.18000000f,0.77000000f,-0.47000000f,-0.53000000f,-0.00000000f,0.13000000f,-0.41000000f,0.71000000f,0.52000000f,-0.39000000f,-0.25000000f,0.15000000f,0.09000000f,0.49000000f,0.99000000f,-0.09000000f,0.97000000f,0.21000000f,-0.24000000f,0.76000000f,-0.25000000f,0.81000000f,-0.44000000f,0.96000000f,-0.85000000f,0.48000000f,-0.86000000f,0.12000000f,0.94000000f,-0.09000000f,-0.69000000f,0.98000000f,0.26000000f,0.63000000f,0.65000000f,0.70000000f,0.95000000f,0.96000000f,0.49000000f,-0.25000000f,0.66000000f,-0.97000000f,-0.62000000f,0.85000000f,0.04000000f,0.16000000f,0.22000000f,0.71000000f,-0.52000000f,-0.55000000f,0.08000000f,-0.85000000f,-0.87000000f,0.73000000f,0.08000000f,0.94000000f,-0.34000000f,-0.82000000f,0.22000000f,-0.25000000f,-0.92000000f,-0.96000000f,0.94000000f,-0.47000000f,0.76000000f,-0.83000000f,0.22000000f,0.42000000f,-0.80000000f,-0.22000000f,-0.84000000f,-0.52000000f,0.15000000f,0.20000000f,0.96000000f,0.20000000f,0.63000000f,-0.32000000f,-0.76000000f,0.32000000f,-0.71000000f,-0.68000000f,0.55000000f,-0.45000000f,0.59000000f,-0.41000000f,-0.10000000f,-0.62000000f,0.56000000f,0.07000000f,-0.22000000f,-0.90000000f,0.39000000f,-0.53000000f,0.98000000f,-0.55000000f,-0.31000000f,-0.48000000f,0.22000000f,-0.78000000f,-0.57000000f,-0.88000000f,-0.97000000f,0.26000000f,-0.74000000f,0.20000000f,-0.82000000f,-0.34000000f,0.27000000f,0.96000000f,-0.14000000f,-0.60000000f,-0.20000000f,-0.34000000f,0.68000000f,-0.00000000f,0.57000000f,0.87000000f,-0.48000000f,0.10000000f,0.39000000f,-0.22000000f,0.97000000f,0.45000000f,-0.41000000f,0.85000000f,-0.18000000f,-0.22000000f,-0.40000000f,0.67000000f,-0.09000000f,-0.61000000f,-0.28000000f,0.71000000f,0.45000000f,-0.27000000f,-0.67000000f,0.50000000f,-0.10000000f,-0.09000000f,-0.75000000f,0.96000000f,0.86000000f,0.27000000f,-0.83000000f,-0.35000000f,-0.30000000f,0.37000000f,0.44000000f,0.78000000f,-0.50000000f,-0.53000000f,-0.40000000f,-0.43000000f,-0.04000000f,0.46000000f,-0.57000000f,-0.60000000f,-0.13000000f,0.90000000f,0.32000000f,0.92000000f,0.79000000f,0.48000000f,-0.76000000f,0.87000000f,0.11000000f,-0.17000000f,-0.50000000f,-0.00000000f,0.02000000f,0.61000000f,0.33000000f,0.64000000f,-0.80000000f,-0.48000000f,0.91000000f,0.81000000f,-0.73000000f,-0.02000000f,0.94000000f,-0.63000000f,0.19000000f,0.39000000f,-0.50000000f,-0.91000000f,-0.99000000f,0.95000000f,-0.75000000f,0.67000000f,0.82000000f,-0.54000000f,-0.76000000f,0.50000000f,0.90000000f,0.46000000f,-0.74000000f,0.69000000f,-0.86000000f,0.72000000f,0.52000000f,0.39000000f,-0.46000000f,-0.36000000f,0.34000000f,0.21000000f,-0.44000000f,0.14000000f,0.35000000f,0.13000000f,-0.84000000f,0.95000000f,0.32000000f,-0.82000000f,-0.62000000f,-0.69000000f,-0.50000000f,0.59000000f,0.47000000f,-0.97000000f,0.15000000f,0.59000000f,0.65000000f,-0.26000000f,0.50000000f,-0.03000000f,-0.96000000f,0.97000000f,-0.99000000f,-0.67000000f,-0.73000000f,-0.48000000f,-0.64000000f,-0.84000000f,-0.94000000f,0.62000000f,0.14000000f,-0.32000000f,-0.47000000f,-0.74000000f,0.07000000f,0.05000000f,0.87000000f,-0.83000000f,0.49000000f,-0.32000000f,-0.32000000f,0.03000000f,0.51000000f,0.06000000f,-0.77000000f,0.75000000f,-0.39000000f,-0.78000000f,0.10000000f,0.95000000f,0.38000000f,-0.08000000f,-0.66000000f,-0.07000000f,0.09000000f,-0.09000000f,-0.09000000f,0.83000000f,-0.12000000f,0.43000000f,-0.65000000f,0.41000000f,0.68000000f,0.93000000f,0.88000000f,-0.24000000f,0.70000000f,-0.97000000f,-0.40000000f,-0.96000000f,-0.45000000f,-0.35000000f,-0.29000000f,0.91000000f,-0.28000000f,0.92000000f,-0.57000000f,-0.37000000f,-0.02000000f,0.37000000f,-0.37000000f,-0.01000000f,-0.48000000f,0.74000000f,-0.28000000f,0.21000000f,0.74000000f,-0.99000000f,0.45000000f,0.91000000f,-0.28000000f,-0.11000000f,-0.86000000f,-0.22000000f,0.48000000f,-0.34000000f,0.52000000f,0.17000000f,0.04000000f,0.23000000f,-0.54000000f,-0.80000000f,-0.60000000f,0.04000000f,0.47000000f,-0.14000000f,0.33000000f,0.57000000f,0.22000000f,-0.67000000f,0.02000000f,0.69000000f,0.93000000f,0.69000000f,0.93000000f,0.99000000f,0.75000000f,0.47000000f,0.21000000f,-0.42000000f,0.02000000f,0.20000000f,0.03000000f,0.12000000f,0.76000000f,0.04000000f,-0.43000000f,-0.10000000f,-0.52000000f,-0.26000000f,-0.10000000f,0.78000000f,-0.81000000f,-0.72000000f,-0.76000000f,0.87000000f,0.88000000f,0.83000000f,-0.27000000f,0.82000000f,-0.97000000f,-0.59000000f,0.80000000f,0.66000000f,0.66000000f,0.59000000f,-0.73000000f,0.03000000f,-0.16000000f,0.69000000f,-0.52000000f,0.22000000f,0.82000000f,-0.11000000f,-0.25000000f,-0.39000000f,0.56000000f,0.93000000f,-0.43000000f,-0.73000000f,-0.28000000f,-0.06000000f,-0.49000000f,-0.95000000f,0.39000000f,0.51000000f,0.29000000f,0.40000000f,-0.46000000f,-0.11000000f,0.60000000f,0.03000000f,-0.57000000f,0.24000000f,-0.55000000f,0.88000000f,-0.33000000f,0.64000000f,-0.79000000f,0.59000000f,-0.05000000f,0.94000000f,0.00000000f,0.74000000f,0.44000000f,-0.86000000f,0.23000000f,-0.03000000f,-0.66000000f,0.45000000f,0.08000000f,-0.53000000f,0.09000000f,0.98000000f,-0.28000000f,-0.10000000f,0.89000000f,0.18000000f,0.45000000f,-0.98000000f,-0.89000000f,0.47000000f,0.78000000f,-0.11000000f,0.53000000f,-0.35000000f,0.46000000f,0.00000000f,0.49000000f,-0.13000000f,-0.58000000f,-0.56000000f,0.73000000f,0.21000000f,0.20000000f,0.72000000f,-0.71000000f,-0.68000000f,-0.54000000f,0.61000000f,-0.80000000f,0.53000000f,0.90000000f,0.20000000f,0.25000000f,-0.29000000f,0.91000000f,-0.88000000f,0.04000000f,0.98000000f,-0.18000000f,-0.16000000f,0.28000000f,0.28000000f,0.60000000f,0.35000000f,-0.32000000f,0.48000000f,-0.99000000f,-0.57000000f,0.41000000f,0.93000000f,-0.33000000f,-0.69000000f,0.68000000f,-0.99000000f,0.40000000f,-0.31000000f,0.58000000f,0.70000000f,-0.95000000f,-0.97000000f,0.59000000f,-0.71000000f,-0.43000000f,0.78000000f,-0.92000000f,-0.01000000f,0.79000000f,-0.34000000f,-0.14000000f,0.25000000f,0.86000000f,0.62000000f,-0.12000000f,-0.53000000f,0.77000000f,-0.30000000f,-0.50000000f,-0.82000000f,0.76000000f,0.27000000f,-0.59000000f,0.69000000f,-0.87000000f,-0.03000000f,0.82000000f,0.05000000f,0.58000000f,0.96000000f,0.52000000f,0.04000000f,0.80000000f,-0.66000000f,-0.06000000f,0.88000000f,-0.59000000f,-0.19000000f,-0.47000000f,0.84000000f,0.15000000f,0.90000000f,-0.08000000f,0.69000000f,-0.34000000f,0.12000000f,0.14000000f,0.86000000f,-0.56000000f,-0.59000000f,0.08000000f,0.27000000f,-0.13000000f,0.00000000f,-0.00000000f,-0.47000000f,0.34000000f,0.44000000f,0.17000000f,-0.57000000f,-0.19000000f,-0.09000000f,-0.31000000f,0.03000000f,-0.60000000f,0.40000000f,0.58000000f,-0.43000000f,-0.81000000f,0.08000000f,0.04000000f,-0.28000000f,0.74000000f,0.00000000f,-0.59000000f,-0.57000000f,-0.82000000f,0.99000000f,-0.36000000f,0.44000000f,-0.51000000f,0.26000000f,0.75000000f,-0.56000000f,-0.86000000f,0.85000000f,-0.63000000f,0.49000000f,0.81000000f,-0.53000000f,0.23000000f,-0.35000000f,-0.25000000f,-0.44000000f,-0.03000000f,0.23000000f,0.98000000f,-0.37000000f,-0.25000000f,-0.60000000f,0.81000000f,0.16000000f,0.95000000f,0.77000000f,-0.18000000f,0.45000000f,-0.35000000f,0.47000000f,0.74000000f,0.65000000f,0.81000000f,-0.02000000f,-0.39000000f,-0.75000000f,0.33000000f,0.35000000f,-0.76000000f,-0.12000000f,-0.62000000f,0.06000000f,0.47000000f,0.47000000f,-0.74000000f,0.58000000f,-0.68000000f,-0.77000000f,-0.12000000f,-0.41000000f,0.26000000f,0.39000000f,-0.37000000f,0.47000000f,0.81000000f,0.00000000f,0.80000000f,-0.59000000f,0.74000000f,-0.11000000f,-0.81000000f,-0.10000000f,-0.03000000f,0.88000000f,-0.65000000f,0.58000000f,-0.93000000f,-0.09000000f,-0.30000000f,0.72000000f,-0.75000000f,-0.10000000f,0.01000000f,0.21000000f,-0.17000000f,0.37000000f,-0.96000000f,-0.44000000f,-0.69000000f,0.36000000f,0.89000000f,0.24000000f,0.06000000f,0.20000000f,-0.51000000f,0.20000000f,-0.25000000f,0.64000000f,0.06000000f,-0.91000000f,0.19000000f,-0.71000000f,-0.09000000f,0.85000000f,0.49000000f,-0.39000000f,0.80000000f,0.42000000f,0.61000000f,-0.52000000f,0.61000000f,-0.13000000f,0.48000000f,0.67000000f,0.60000000f,0.93000000f,-0.02000000f,0.58000000f,0.01000000f,-0.17000000f,-0.50000000f,-0.67000000f,-0.74000000f,-0.12000000f,0.92000000f,-0.61000000f,-0.21000000f,0.30000000f,-0.70000000f,-0.56000000f,-0.91000000f,-0.65000000f,0.13000000f,-0.36000000f,-0.91000000f,0.93000000f,0.69000000f,-0.95000000f,0.67000000f,-0.46000000f,0.26000000f,0.59000000f,0.11000000f,0.64000000f,-0.83000000f,-0.00000000f,-0.85000000f,0.50000000f,0.25000000f,0.80000000f,-0.83000000f,-0.54000000f,-0.96000000f,0.68000000f,-0.39000000f,0.84000000f,0.80000000f,0.84000000f,0.86000000f,-0.60000000f,-0.73000000f,-0.90000000f,0.22000000f,0.52000000f,-0.70000000f,-0.70000000f,0.35000000f,0.57000000f,0.55000000f,-0.94000000f,0.51000000f,0.07000000f,-0.57000000f,-0.20000000f,0.16000000f,0.66000000f,0.71000000f,0.46000000f,-0.03000000f,0.11000000f,-0.61000000f,-0.84000000f,-0.57000000f,0.12000000f,-0.37000000f,-0.97000000f,-0.83000000f,0.47000000f,0.40000000f,0.54000000f,0.79000000f,0.95000000f,0.40000000f,0.23000000f,0.45000000f,0.66000000f,0.33000000f,0.61000000f,0.90000000f,-0.66000000f,-0.18000000f,0.95000000f,0.91000000f,-0.89000000f,-0.66000000f,0.37000000f,-0.80000000f,-0.36000000f,0.02000000f,0.23000000f,-0.57000000f,-0.19000000f,-0.11000000f,-0.01000000f,-0.47000000f,-0.67000000f,-0.64000000f,0.80000000f,-0.34000000f,-0.08000000f,-0.54000000f,0.96000000f,-0.41000000f,-0.43000000f,0.52000000f,0.30000000f,-0.02000000f,0.68000000f,-0.82000000f,-0.06000000f,-0.24000000f,0.53000000f,-0.12000000f,-0.64000000f,-0.57000000f,-0.93000000f,0.17000000f,-0.62000000f,-0.57000000f,-0.18000000f,0.44000000f,-0.93000000f,0.27000000f,0.47000000f,0.02000000f,-0.66000000f,0.84000000f,-0.56000000f,-0.86000000f,-0.30000000f,0.45000000f,-0.87000000f,-0.18000000f,-0.78000000f,-0.58000000f,-0.87000000f,-0.01000000f,-0.39000000f,-0.82000000f,-0.88000000f,0.73000000f,-0.96000000f,-0.08000000f,-0.83000000f,-0.78000000f,-0.40000000f,0.55000000f,-0.96000000f,-0.72000000f,-0.48000000f,-0.58000000f,0.56000000f,0.17000000f,0.51000000f,0.81000000f,-0.72000000f,-0.46000000f,0.98000000f,0.59000000f,-0.78000000f,-0.00000000f,-0.97000000f,0.94000000f,0.53000000f,0.29000000f,0.90000000f,0.85000000f,-0.83000000f,-0.66000000f,-0.22000000f,-0.23000000f,0.41000000f,-0.13000000f,-0.10000000f,0.66000000f,-0.18000000f,0.83000000f,-0.50000000f,-0.14000000f,-0.22000000f,0.75000000f,-0.81000000f,0.56000000f,-0.60000000f,-0.11000000f,-0.24000000f,-0.37000000f,-0.44000000f,0.27000000f,-0.84000000f,0.21000000f,-0.47000000f,0.87000000f,0.91000000f,-0.95000000f,-0.09000000f,0.97000000f,0.08000000f,-0.49000000f,-0.27000000f,0.22000000f,0.50000000f,-0.54000000f,0.41000000f,0.84000000f,0.25000000f,0.24000000f,0.12000000f,0.76000000f,-0.50000000f,0.78000000f,-0.35000000f,0.66000000f,-0.78000000f,0.10000000f,0.81000000f,0.32000000f,-0.41000000f,-0.20000000f,-0.99000000f,0.80000000f,-0.91000000f,-0.80000000f,0.53000000f,0.83000000f,-0.43000000f,-0.12000000f,0.26000000f,-0.28000000f,0.33000000f,-0.88000000f,0.39000000f,0.15000000f,-0.11000000f,-0.35000000f,0.46000000f,-0.47000000f,-0.30000000f,0.42000000f,-0.33000000f,0.95000000f,0.59000000f,-0.43000000f,-0.12000000f,0.57000000f,-0.57000000f,-0.47000000f,0.60000000f,0.34000000f,0.80000000f,0.80000000f,-0.64000000f,-0.72000000f,0.01000000f,0.49000000f,-0.03000000f,0.09000000f,0.38000000f,-0.65000000f,-0.22000000f,0.61000000f,-0.82000000f,0.42000000f,-0.33000000f,0.91000000f,0.55000000f,0.45000000f,0.85000000f,-0.06000000f,-0.58000000f,0.64000000f,0.12000000f,-0.57000000f,0.68000000f,0.24000000f,-0.88000000f,-0.67000000f,-0.65000000f,-0.22000000f,-0.11000000f,-0.83000000f,-0.82000000f,0.76000000f,0.33000000f,-0.14000000f,0.97000000f,-0.18000000f,-0.04000000f,0.97000000f,0.00000000f,0.08000000f,0.15000000f,0.52000000f,-0.19000000f,-0.46000000f,-0.50000000f,-0.59000000f,0.69000000f,0.06000000f,-0.14000000f,0.27000000f,-0.75000000f,0.27000000f,-0.14000000f,0.15000000f,-0.57000000f,-0.42000000f,-0.18000000f,0.43000000f,0.44000000f,-0.65000000f,-0.87000000f,-0.49000000f,-0.37000000f,0.82000000f,-0.72000000f,0.01000000f,-0.88000000f,0.14000000f,-0.92000000f,-0.50000000f,0.83000000f,-0.14000000f,-0.16000000f,-0.50000000f,-0.05000000f,-0.63000000f,-0.90000000f,0.83000000f,0.74000000f,0.00000000f,0.44000000f,-0.66000000f,0.93000000f,0.27000000f,-0.28000000f,0.18000000f,-0.80000000f,-0.54000000f,-0.08000000f,0.22000000f,0.43000000f,0.16000000f,-0.25000000f,-0.14000000f,0.25000000f,0.55000000f,-0.85000000f,0.72000000f,0.33000000f,0.12000000f,-0.65000000f,-0.17000000f,0.26000000f,-0.40000000f,0.78000000f,-0.50000000f,0.07000000f,-0.98000000f,-0.60000000f,-0.38000000f,0.95000000f,0.75000000f,-0.10000000f,-0.30000000f,0.57000000f,-0.67000000f,0.12000000f,0.46000000f,-0.23000000f,-0.93000000f,-0.34000000f,-0.63000000f,0.42000000f,0.20000000f,0.25000000f,-0.83000000f,0.09000000f,-0.35000000f,-0.70000000f,0.73000000f,-0.71000000f,-0.65000000f,0.53000000f,0.93000000f,-0.30000000f,0.42000000f,0.10000000f,0.73000000f,-0.96000000f,-0.08000000f,0.64000000f,0.66000000f,-0.20000000f,0.62000000f,-0.90000000f,-0.63000000f,-0.55000000f,0.72000000f,0.64000000f,-0.42000000f,-0.01000000f,-0.62000000f,-0.82000000f,0.68000000f,-0.86000000f,0.48000000f,-0.04000000f,-0.02000000f,-0.91000000f,-0.99000000f,-0.33000000f,-0.46000000f,-0.06000000f,-0.92000000f,-0.23000000f,0.15000000f,0.26000000f,0.37000000f,0.23000000f,0.08000000f,0.47000000f,-0.78000000f,0.86000000f,0.52000000f,-0.27000000f,-0.01000000f,-0.54000000f,-0.42000000f,-0.25000000f,-0.20000000f,-0.13000000f,0.64000000f,0.32000000f,0.45000000f,0.34000000f,-0.13000000f,0.99000000f,0.45000000f,0.81000000f,-0.63000000f,-0.27000000f,-0.59000000f,-0.29000000f,-0.44000000f,0.89000000f,-0.01000000f,-0.17000000f,0.79000000f,0.08000000f,0.59000000f,-0.01000000f,-0.26000000f,0.10000000f,0.27000000f,0.28000000f,-0.12000000f,-0.73000000f,0.19000000f,0.16000000f,-0.12000000f,0.49000000f,0.43000000f,0.74000000f,0.56000000f,0.90000000f,0.28000000f,-0.46000000f,-0.62000000f,0.47000000f,-0.35000000f,-0.36000000f,-0.99000000f,0.89000000f,-0.64000000f,-0.33000000f,-0.43000000f,0.97000000f,-0.34000000f,0.37000000f,-0.16000000f,-0.39000000f,0.18000000f,-0.95000000f,-0.41000000f,0.41000000f,-0.21000000f,-0.82000000f,-0.93000000f,-0.90000000f,0.53000000f,0.25000000f,0.29000000f,-0.84000000f,-0.39000000f,-0.72000000f,-0.21000000f,-0.78000000f,-0.97000000f,-0.92000000f,-0.34000000f,0.81000000f,-0.08000000f,0.34000000f,0.26000000f,-0.74000000f,-0.26000000f,-0.20000000f,0.71000000f,0.67000000f,-0.08000000f,0.35000000f,-0.63000000f,-0.11000000f,-0.50000000f,-0.71000000f,-0.26000000f,-0.46000000f,0.01000000f,-0.24000000f,0.73000000f,-0.22000000f,-0.85000000f,-0.68000000f,-0.21000000f,-0.56000000f,0.16000000f,-0.04000000f,-0.77000000f,0.24000000f,-0.66000000f,0.77000000f,0.25000000f,-0.27000000f,-0.24000000f,-0.36000000f,0.89000000f,-0.65000000f,0.62000000f,0.00000000f,-0.74000000f,0.22000000f,0.82000000f,0.72000000f,0.58000000f,-0.44000000f,0.72000000f,-0.55000000f,-0.20000000f,0.11000000f,-0.62000000f,0.48000000f,-0.24000000f,-0.02000000f,-0.81000000f,0.69000000f,-0.58000000f,0.26000000f,-0.64000000f,-0.48000000f,0.79000000f,0.38000000f,0.68000000f,0.70000000f,-0.19000000f,0.79000000f,0.89000000f,-0.57000000f,-0.24000000f,-0.57000000f,-0.20000000f,-0.80000000f,0.54000000f,-0.12000000f,-0.94000000f,-0.04000000f,0.40000000f,-0.16000000f,-0.99000000f,0.12000000f,0.73000000f,-0.02000000f,0.63000000f,-0.76000000f,-0.40000000f,-0.82000000f,0.60000000f,0.48000000f,0.26000000f,-0.77000000f,-0.68000000f,0.10000000f,-0.81000000f,0.90000000f,0.97000000f,0.10000000f,-0.12000000f,-0.07000000f,-0.64000000f,0.36000000f,-0.37000000f,0.25000000f,-0.38000000f,-0.65000000f,-0.30000000f,-0.71000000f,0.35000000f,0.69000000f,0.29000000f,-0.60000000f,0.66000000f,0.53000000f,0.69000000f,-0.27000000f,0.04000000f,-0.38000000f,-0.47000000f,-0.00000000f,-0.30000000f,0.71000000f,0.44000000f,-0.50000000f,0.52000000f,0.75000000f,0.18000000f,-0.47000000f,-0.15000000f,0.46000000f,-0.42000000f,0.32000000f,-0.97000000f,0.16000000f,0.67000000f,-0.13000000f,-0.59000000f,0.49000000f,-0.02000000f,-0.91000000f,-0.05000000f,-0.89000000f,0.68000000f,-0.21000000f,0.57000000f,-0.17000000f,0.37000000f,-0.36000000f,-0.44000000f,0.40000000f,0.31000000f,-0.51000000f,-0.56000000f,0.09000000f,0.80000000f,-0.61000000f,-0.36000000f,-0.66000000f,0.29000000f,-0.00000000f,-0.72000000f,0.14000000f,-0.95000000f,-0.18000000f,-0.43000000f,-0.25000000f,0.28000000f,-0.64000000f,-0.37000000f,-0.29000000f,0.15000000f,0.48000000f,0.29000000f,-0.86000000f,0.43000000f,0.85000000f,0.56000000f,-0.66000000f,-0.93000000f,-0.00000000f,0.06000000f,0.00000000f,-0.73000000f,-0.29000000f,-0.29000000f,0.59000000f,-0.60000000f,-0.24000000f,-0.88000000f,0.99000000f,0.39000000f,0.71000000f,-0.58000000f,-0.46000000f,-0.86000000f,-0.65000000f,-0.17000000f,0.28000000f,0.85000000f,0.74000000f,0.32000000f,-0.14000000f,0.59000000f,0.37000000f,-0.94000000f,0.28000000f,-0.50000000f,-0.88000000f,0.36000000f,-0.21000000f,-0.22000000f,0.55000000f,-0.49000000f,-0.22000000f,0.33000000f,0.34000000f,0.59000000f,-0.94000000f,0.82000000f,-0.06000000f,0.82000000f,0.71000000f,0.03000000f,-0.11000000f,-0.02000000f,0.85000000f,-0.25000000f,0.86000000f,-0.30000000f,-0.99000000f,0.27000000f,0.17000000f,0.78000000f,0.24000000f,-0.85000000f,0.97000000f,0.35000000f,0.44000000f,-0.86000000f,0.22000000f,0.69000000f,0.89000000f,-0.11000000f,0.94000000f,-0.97000000f,-0.73000000f,-0.46000000f,-0.85000000f,0.33000000f,-0.01000000f,-0.37000000f,0.23000000f,-0.67000000f,0.02000000f,-0.89000000f,0.99000000f,-0.46000000f,0.40000000f,-0.60000000f,-0.35000000f,-0.13000000f,-0.38000000f,-0.18000000f,-0.50000000f,-0.52000000f,0.06000000f,0.01000000f,0.68000000f,0.69000000f,0.17000000f,-0.36000000f,0.68000000f,-0.01000000f,0.22000000f,0.96000000f,0.58000000f,-0.28000000f,0.10000000f,-0.49000000f,-0.21000000f,-0.74000000f,0.06000000f,-0.03000000f,0.36000000f,0.47000000f,-0.94000000f,-0.13000000f,0.66000000f,-0.03000000f,0.81000000f,-0.10000000f,-0.34000000f,-0.74000000f,-0.02000000f,0.36000000f,0.13000000f,-0.09000000f,-0.23000000f,-0.15000000f,-0.84000000f,0.61000000f,0.63000000f,-0.06000000f,-0.59000000f,0.49000000f,-0.83000000f,0.43000000f,-0.51000000f,-0.26000000f,-0.49000000f,0.79000000f,0.92000000f,0.69000000f,-0.51000000f,0.43000000f,0.57000000f,0.59000000f,0.62000000f,0.04000000f,-0.66000000f,0.12000000f,-0.61000000f,0.15000000f,-0.29000000f,-0.66000000f,-0.05000000f,0.27000000f,0.83000000f,0.62000000f,-0.89000000f,0.37000000f,0.08000000f,-0.41000000f,0.60000000f,0.57000000f,0.27000000f,-0.08000000f,0.62000000f,-0.75000000f,0.71000000f,-0.56000000f,-0.08000000f,0.98000000f,0.63000000f,-0.46000000f,-0.76000000f,0.75000000f,-0.99000000f,-0.80000000f,-0.58000000f,-0.16000000f,-0.55000000f,0.09000000f,0.42000000f,-0.11000000f,0.18000000f,-0.87000000f,-0.89000000f,0.04000000f,0.24000000f,-0.86000000f,-0.20000000f,0.09000000f,-0.76000000f,0.77000000f,-0.39000000f,0.60000000f,-0.61000000f,-0.04000000f,0.16000000f,0.57000000f,-0.39000000f,-0.75000000f,-0.99000000f,-0.77000000f,0.91000000f,0.58000000f,-0.29000000f,0.48000000f,0.22000000f,0.73000000f,-0.29000000f,-0.28000000f,0.93000000f,-0.78000000f,-0.19000000f,0.27000000f,-0.76000000f,-0.93000000f,-0.95000000f,-0.98000000f,0.74000000f,0.50000000f,0.09000000f,-0.76000000f,-0.31000000f,-0.95000000f,0.18000000f,0.95000000f,-0.90000000f,-0.87000000f,0.87000000f,0.39000000f,0.91000000f,0.91000000f,0.43000000f,0.21000000f,-0.33000000f,-0.82000000f,-0.85000000f,0.79000000f,0.25000000f,0.62000000f,0.44000000f,-0.19000000f,0.80000000f,0.77000000f,-0.08000000f,0.74000000f,-0.25000000f,0.90000000f,0.93000000f,0.55000000f,-0.46000000f,-0.63000000f,0.73000000f,0.51000000f,0.31000000f,-0.30000000f,-0.46000000f,-0.26000000f,0.82000000f,-0.44000000f,-0.96000000f,-0.05000000f,0.25000000f,0.67000000f,0.37000000f,-0.96000000f,-0.70000000f,-0.50000000f,-0.33000000f,-0.30000000f,0.19000000f,0.45000000f,0.96000000f,0.18000000f,-0.44000000f,0.10000000f,-0.29000000f,-0.83000000f,0.18000000f,0.14000000f,0.91000000f,-0.76000000f,0.33000000f,-0.75000000f,-0.06000000f,0.35000000f,0.35000000f,-0.22000000f,-0.42000000f,-0.34000000f,0.60000000f,-0.56000000f,0.95000000f,-0.35000000f,-0.13000000f,-0.58000000f,-0.84000000f,0.89000000f,-0.67000000f,-0.84000000f,0.78000000f,-0.29000000f,0.83000000f,-0.03000000f,0.74000000f,-0.98000000f,0.54000000f,-0.33000000f,0.40000000f,0.79000000f,0.78000000f,0.47000000f,-0.60000000f,0.66000000f,0.69000000f,-0.25000000f,-0.38000000f,0.90000000f,0.91000000f,-0.22000000f,0.55000000f,-0.30000000f,-0.48000000f,-0.16000000f,-0.09000000f,-0.23000000f,-0.68000000f,-0.62000000f,0.49000000f,0.34000000f,0.18000000f,0.88000000f,0.08000000f,0.95000000f,-0.59000000f,0.40000000f,0.52000000f,0.19000000f,0.94000000f,0.36000000f,0.96000000f,-0.31000000f,0.71000000f,-0.19000000f,0.67000000f,0.87000000f,-0.39000000f,-0.55000000f,-0.01000000f,-0.14000000f,0.28000000f,-0.75000000f,0.70000000f,-0.17000000f,0.18000000f,0.64000000f,0.50000000f,-0.83000000f,0.85000000f,0.85000000f,0.38000000f,0.04000000f,-0.46000000f,0.41000000f,-0.21000000f,-0.78000000f,0.32000000f,0.46000000f,0.95000000f,-0.16000000f,-0.31000000f,-0.24000000f,0.06000000f,-0.25000000f,-0.94000000f,0.99000000f,0.75000000f,-0.00000000f,-0.42000000f,-0.72000000f,0.61000000f,-0.06000000f,0.78000000f,0.92000000f,0.25000000f,0.90000000f,-0.37000000f,0.72000000f,0.21000000f,-0.72000000f,0.36000000f,0.76000000f,-0.53000000f,-0.36000000f,0.45000000f,-0.28000000f,-0.47000000f,-0.46000000f,0.47000000f,-0.30000000f,0.30000000f,-0.72000000f,0.73000000f,-0.61000000f,-0.39000000f,0.06000000f,0.35000000f,0.77000000f,-0.38000000f,0.52000000f,-0.03000000f,-0.85000000f,-0.20000000f,0.02000000f,0.64000000f,-0.72000000f,0.10000000f,0.11000000f,0.81000000f,-0.07000000f,0.72000000f,0.87000000f,0.81000000f,-0.21000000f,-0.03000000f,-0.86000000f,-0.18000000f,0.01000000f,-0.77000000f,-0.60000000f,0.16000000f,0.32000000f,-0.46000000f,0.00000000f,-0.00000000f,-0.77000000f,-0.04000000f,0.92000000f,0.48000000f,-0.84000000f,-0.65000000f,-0.93000000f,-0.77000000f,-0.11000000f,0.77000000f,0.86000000f,0.96000000f,0.31000000f,-0.18000000f,-0.94000000f,0.66000000f,-0.97000000f,0.51000000f,0.39000000f,-0.66000000f,-0.74000000f,0.82000000f,0.91000000f,0.90000000f,-0.22000000f,-0.89000000f,0.72000000f,0.98000000f,-0.14000000f,0.73000000f,0.68000000f,0.68000000f,-0.20000000f,0.44000000f,-0.76000000f,0.40000000f,-0.93000000f,-0.43000000f,-0.89000000f,-0.74000000f,-0.18000000f,-0.79000000f,-0.69000000f,0.32000000f,0.73000000f,-0.85000000f,-0.06000000f,0.72000000f,-0.25000000f,0.37000000f,0.76000000f,-0.20000000f,-0.70000000f,0.27000000f,-0.94000000f,0.75000000f,-0.29000000f,-0.25000000f,-0.82000000f,0.38000000f,0.50000000f,0.56000000f,0.62000000f,-0.41000000f,-0.10000000f,-0.38000000f,0.76000000f,-0.42000000f,0.89000000f,0.16000000f,-0.83000000f,-0.05000000f,-0.08000000f,-0.41000000f,0.55000000f,0.01000000f,0.93000000f,-0.79000000f,-0.46000000f,0.63000000f,-0.93000000f,-0.26000000f,0.51000000f,0.57000000f,-0.76000000f,-0.94000000f,0.21000000f,-0.83000000f,0.51000000f,-0.38000000f,-0.00000000f,-0.35000000f,-0.94000000f,0.32000000f,-0.70000000f,-0.05000000f,-0.73000000f,0.19000000f,-0.52000000f,0.32000000f,-0.48000000f,0.99000000f,0.18000000f,0.36000000f,-0.73000000f,0.48000000f,0.74000000f,0.53000000f,0.41000000f,0.85000000f,-0.42000000f,0.46000000f,0.18000000f,0.66000000f,0.99000000f,-0.55000000f,-0.02000000f,0.54000000f,-0.89000000f,-0.78000000f,0.68000000f,0.34000000f,0.90000000f,-0.34000000f,0.55000000f,-0.50000000f,-0.80000000f,-0.26000000f,-0.91000000f,-0.72000000f,0.75000000f,0.23000000f,0.87000000f,0.15000000f,0.77000000f,-0.64000000f,-0.78000000f,0.03000000f,-0.29000000f,-0.31000000f,0.02000000f,-0.16000000f,0.01000000f,0.50000000f,-0.35000000f,-0.65000000f,0.22000000f,0.53000000f,-0.25000000f,-0.31000000f,0.61000000f,0.59000000f,-0.83000000f,-0.30000000f,-0.53000000f,-0.76000000f,-0.28000000f,0.71000000f,0.52000000f,-0.77000000f,0.86000000f,-0.01000000f,0.92000000f,0.90000000f,0.20000000f,0.20000000f,0.49000000f,0.38000000f,-0.95000000f,0.59000000f,-0.25000000f,0.42000000f,-0.33000000f,0.29000000f,0.17000000f,-0.17000000f,0.78000000f,-0.75000000f,0.99000000f,-0.43000000f,-0.33000000f,-0.61000000f,0.41000000f,-0.22000000f,-0.25000000f,-0.16000000f,-0.74000000f,-0.06000000f,0.24000000f,0.60000000f,-0.96000000f,0.06000000f,-0.13000000f,-0.27000000f,-0.04000000f,-0.04000000f,0.45000000f,0.25000000f,0.83000000f,-0.31000000f,0.27000000f,-0.06000000f,-0.40000000f,0.68000000f,-0.52000000f,0.92000000f,-0.71000000f,-0.78000000f,0.93000000f,-0.84000000f,-0.51000000f,-0.30000000f,-0.15000000f,0.02000000f,-0.59000000f,-0.64000000f,0.06000000f,-0.18000000f,-0.55000000f,-0.96000000f,0.12000000f,-0.89000000f,0.97000000f,0.91000000f,-0.73000000f,0.06000000f,0.57000000f,-0.82000000f,0.59000000f,-0.86000000f,0.08000000f,0.45000000f,-0.95000000f,0.67000000f,-0.65000000f,-0.29000000f,-0.36000000f,0.04000000f,-0.82000000f,0.10000000f,0.55000000f,0.32000000f,0.55000000f,0.32000000f,0.81000000f,-0.92000000f,0.09000000f,-0.35000000f,0.88000000f,0.31000000f,0.06000000f,0.89000000f,0.00000000f,0.37000000f,-0.45000000f,0.58000000f,0.97000000f,0.95000000f,0.34000000f,-0.41000000f,-0.84000000f,0.45000000f,-0.81000000f,0.73000000f,-0.11000000f,0.06000000f,-0.68000000f,-0.92000000f,0.59000000f,0.80000000f,0.60000000f,-0.04000000f,-0.18000000f,0.44000000f,-0.83000000f,0.71000000f,0.68000000f,0.02000000f,0.62000000f,0.83000000f,0.60000000f,0.81000000f,-0.92000000f,0.86000000f,-0.57000000f,0.26000000f,0.30000000f,-0.26000000f,0.29000000f,-0.74000000f,-0.21000000f,0.65000000f,0.40000000f,0.43000000f,-0.95000000f,0.36000000f,-0.28000000f,0.12000000f,-0.89000000f,-0.23000000f,0.86000000f,-0.11000000f,0.70000000f,0.52000000f,-0.22000000f,-0.83000000f,-0.63000000f,0.08000000f,0.58000000f,-0.88000000f,-0.34000000f,-0.06000000f,0.44000000f,0.10000000f,0.36000000f,0.99000000f,0.04000000f,0.41000000f,-0.73000000f,0.41000000f,0.57000000f,-0.41000000f,0.35000000f,0.36000000f,-0.37000000f,0.64000000f,-0.70000000f,-0.33000000f,-0.57000000f,-0.38000000f,0.09000000f,0.50000000f,-0.09000000f,-0.95000000f,0.59000000f,0.07000000f,0.25000000f,0.75000000f,-0.29000000f,-0.46000000f,-0.69000000f,-0.93000000f,-0.49000000f,-0.03000000f,-0.25000000f,0.65000000f,-0.15000000f,0.79000000f,0.76000000f,-0.73000000f,0.57000000f,-0.90000000f,0.74000000f,0.99000000f,0.20000000f,0.09000000f,0.33000000f,-0.55000000f,0.42000000f,-0.98000000f,-0.26000000f,-0.48000000f,0.96000000f,0.83000000f,-0.75000000f,-0.64000000f,-0.09000000f,-0.73000000f,0.96000000f,-0.26000000f,-0.76000000f,0.83000000f,0.54000000f,0.66000000f,0.54000000f,0.64000000f,-0.58000000f,0.45000000f,-0.67000000f,0.81000000f,0.00000000f,-0.77000000f,0.66000000f,0.36000000f,0.93000000f,0.75000000f,-0.62000000f,0.65000000f,-0.52000000f,0.08000000f,0.02000000f,0.12000000f,0.35000000f,0.85000000f,0.83000000f,-0.07000000f,-0.62000000f,-0.78000000f,-0.98000000f,-0.78000000f,0.43000000f,0.53000000f,-0.55000000f,0.04000000f,0.99000000f,-0.57000000f,-0.52000000f,0.78000000f,0.11000000f,-0.00000000f,0.88000000f,0.10000000f,-0.43000000f,-0.44000000f,-0.51000000f,0.73000000f,-0.74000000f,0.53000000f,-0.26000000f,-0.58000000f,0.07000000f,-0.48000000f,0.23000000f,0.94000000f,-0.47000000f,-0.53000000f,0.04000000f,0.18000000f,-0.16000000f,-0.86000000f,-0.90000000f,-0.04000000f,0.05000000f,0.03000000f,0.53000000f,-0.11000000f,-0.86000000f,0.80000000f,0.34000000f,0.61000000f,-0.00000000f,-0.99000000f,0.55000000f,-0.20000000f,-0.84000000f,0.21000000f,-0.66000000f,-0.43000000f,-0.93000000f,-0.83000000f,0.00000000f,-0.62000000f,-0.59000000f,-0.16000000f,-0.56000000f,-0.11000000f,0.55000000f,-0.30000000f,0.96000000f,-0.67000000f,0.05000000f,0.17000000f,0.30000000f,-0.86000000f,-0.44000000f,0.05000000f,0.75000000f,-0.44000000f,-0.03000000f,-0.61000000f,-0.89000000f,0.40000000f,0.35000000f,-0.42000000f,0.35000000f,-0.97000000f,0.58000000f,0.32000000f,0.84000000f,-0.13000000f,0.01000000f,0.89000000f,0.60000000f,0.06000000f,0.80000000f,0.67000000f,-0.54000000f,0.59000000f,-0.52000000f,0.06000000f,0.86000000f,0.19000000f,0.04000000f,0.75000000f,0.86000000f,0.11000000f,0.00000000f,-0.72000000f,-0.85000000f,0.09000000f,0.78000000f,-0.68000000f,0.90000000f,0.06000000f,0.38000000f,-0.14000000f,0.97000000f,0.07000000f,-0.60000000f,0.60000000f,-0.78000000f,-0.38000000f,0.01000000f,-0.99000000f,0.61000000f,0.53000000f,-0.65000000f,0.16000000f,0.32000000f,0.61000000f,-0.94000000f,0.88000000f,0.75000000f,-0.05000000f,-0.24000000f,-0.84000000f,-0.49000000f,0.89000000f,0.39000000f,0.22000000f,0.20000000f,-0.29000000f,0.74000000f,-0.01000000f,0.08000000f,-0.24000000f,-0.80000000f,0.57000000f,-0.16000000f,0.00000000f,-0.48000000f,0.68000000f,-0.06000000f,0.78000000f,-0.66000000f,-0.91000000f,0.30000000f,-0.72000000f,-0.20000000f,0.28000000f,-0.94000000f,-0.44000000f,-0.29000000f,0.27000000f,-0.84000000f,0.86000000f,-0.47000000f,-0.62000000f,0.29000000f,-0.59000000f,0.71000000f,-0.10000000f,-0.47000000f,-0.40000000f,-0.62000000f,-0.45000000f,0.01000000f,-0.88000000f,-0.47000000f,-0.11000000f,-0.27000000f,0.33000000f,-0.12000000f,0.68000000f,-0.96000000f,0.30000000f,-0.73000000f,0.13000000f,0.70000000f,0.78000000f,0.18000000f,0.35000000f,-0.82000000f,-0.65000000f,-0.72000000f,0.44000000f,-0.03000000f,0.12000000f,-0.68000000f,-0.68000000f,0.48000000f,0.89000000f,-0.32000000f,0.84000000f,0.32000000f,0.14000000f,-0.68000000f,0.44000000f,0.17000000f,0.56000000f,-0.76000000f,0.24000000f,-0.88000000f,0.04000000f,-0.46000000f,-0.34000000f,0.28000000f,-0.31000000f,-0.97000000f,-0.21000000f,-0.78000000f,-0.84000000f,-0.22000000f,-0.73000000f,0.07000000f,-0.56000000f,0.01000000f,-0.75000000f,-0.19000000f,-0.41000000f,0.78000000f,-0.23000000f,0.93000000f,0.91000000f,0.96000000f,-0.41000000f,-0.27000000f,-0.20000000f,-0.59000000f,0.25000000f,0.38000000f,-0.63000000f,0.24000000f,0.62000000f,0.44000000f,0.71000000f,-0.55000000f,0.61000000f,0.50000000f,-0.56000000f,0.77000000f,0.44000000f,0.25000000f,-0.17000000f,-0.32000000f,0.83000000f,-0.33000000f,0.16000000f,0.90000000f,-0.58000000f,-0.63000000f,0.28000000f,-0.65000000f,0.02000000f,0.60000000f,0.67000000f,0.30000000f,0.09000000f,-0.48000000f,0.54000000f,-0.07000000f,0.32000000f,-0.51000000f,-0.83000000f,0.67000000f,0.86000000f,0.48000000f,-0.14000000f,-0.03000000f,-0.49000000f,0.17000000f,-0.59000000f,-0.21000000f,-0.26000000f,-0.93000000f,0.80000000f,-0.35000000f,0.52000000f,-0.40000000f,-0.89000000f,-0.77000000f,-0.53000000f,0.56000000f,-0.58000000f,0.45000000f,0.54000000f,0.81000000f,0.05000000f,0.54000000f,0.11000000f,0.78000000f,0.53000000f,0.88000000f,0.13000000f,-0.95000000f,-0.23000000f,-0.40000000f,0.29000000f,-0.37000000f,-0.57000000f,0.39000000f,0.24000000f,0.14000000f,0.86000000f,0.36000000f,-0.72000000f,0.12000000f,-0.54000000f,0.60000000f,0.22000000f,0.32000000f,-0.02000000f,0.69000000f,-0.43000000f,-0.64000000f,0.92000000f,0.37000000f,0.07000000f,0.16000000f,0.05000000f,0.11000000f,0.19000000f,0.21000000f,-0.60000000f,-0.02000000f,0.43000000f,0.84000000f,-0.97000000f,-0.12000000f,-0.06000000f,-0.11000000f,-0.35000000f,0.77000000f,-0.12000000f,-0.44000000f,-0.02000000f,-0.09000000f,0.34000000f,0.37000000f,0.17000000f,-0.63000000f,0.07000000f,0.74000000f,0.57000000f,-0.97000000f,0.57000000f,0.22000000f,0.47000000f,-0.92000000f,-0.97000000f,-0.01000000f,0.47000000f,0.08000000f,-0.31000000f,0.74000000f,0.79000000f,-0.68000000f,-0.89000000f,-0.10000000f,-0.80000000f,-0.91000000f,0.06000000f,-0.40000000f,0.76000000f,0.27000000f,0.79000000f,0.96000000f,-0.95000000f,0.62000000f,-0.09000000f,0.41000000f,0.03000000f,-0.03000000f,-0.85000000f,-0.51000000f,0.92000000f,-0.67000000f,0.44000000f,0.20000000f,-0.29000000f,-0.01000000f,0.48000000f,0.76000000f,-0.74000000f,-0.95000000f,-0.62000000f,-0.46000000f,0.55000000f,0.61000000f,-0.51000000f,0.26000000f,0.53000000f,-0.99000000f,0.28000000f,0.53000000f,-0.41000000f,-0.92000000f,0.38000000f,-0.53000000f,-0.14000000f,0.87000000f,0.80000000f,0.07000000f,-0.76000000f,0.25000000f,-0.75000000f,-0.83000000f,-0.83000000f,-0.01000000f,-0.08000000f,0.92000000f,-0.33000000f,0.67000000f,0.08000000f,-0.11000000f,0.35000000f,-0.17000000f,0.70000000f,0.23000000f,-0.64000000f,-0.91000000f,0.56000000f,0.82000000f,0.42000000f,-0.48000000f,0.54000000f,-0.04000000f,0.00000000f,0.05000000f,0.00000000f,-0.11000000f,0.02000000f,-0.26000000f,0.46000000f,0.04000000f,0.84000000f,-0.54000000f,-0.33000000f,-0.55000000f,-0.00000000f,-0.90000000f,0.73000000f,-0.19000000f,-0.35000000f,-0.40000000f,-0.09000000f,-0.15000000f,0.92000000f,-0.20000000f,-0.95000000f,-0.85000000f,0.92000000f,0.10000000f,0.61000000f,0.02000000f,-0.01000000f,0.54000000f,0.07000000f,0.85000000f,0.50000000f,-0.84000000f,0.14000000f,-0.38000000f,0.40000000f,0.22000000f,-0.49000000f,0.11000000f,-0.49000000f,-0.23000000f,-0.39000000f,-0.25000000f,-0.31000000f,0.65000000f,-0.52000000f,-0.38000000f,0.46000000f,-0.73000000f,0.91000000f,-0.71000000f,0.77000000f,0.65000000f,-0.05000000f,0.31000000f,-0.60000000f,0.08000000f,-0.26000000f,0.25000000f,0.38000000f,-0.68000000f,0.55000000f,0.83000000f,-0.63000000f,-0.75000000f,-0.55000000f,0.08000000f,-0.42000000f,0.35000000f,-0.33000000f,-0.45000000f,0.00000000f,0.67000000f,0.78000000f,-0.59000000f,0.55000000f,-0.90000000f,-0.47000000f,0.91000000f,0.00000000f,-0.15000000f,0.34000000f,0.75000000f,-0.92000000f,0.15000000f,0.21000000f,0.14000000f,-0.14000000f,0.22000000f,-0.19000000f,0.42000000f,0.31000000f,0.75000000f,-0.66000000f,-0.24000000f,0.37000000f,0.40000000f,0.25000000f,-0.15000000f,0.47000000f,0.03000000f,0.14000000f,-0.32000000f,0.56000000f,-0.58000000f,0.88000000f,-0.67000000f,0.96000000f,0.14000000f,-0.78000000f,0.98000000f,-0.77000000f,-0.52000000f,-0.27000000f,0.94000000f,0.55000000f,0.03000000f,0.90000000f,-0.56000000f,-0.43000000f,-0.58000000f,-0.27000000f,-0.79000000f,-0.87000000f,-0.71000000f,-0.22000000f,-0.48000000f,-0.38000000f,-0.96000000f,0.58000000f,0.24000000f,-0.28000000f,-0.47000000f,0.33000000f,0.10000000f,-0.44000000f,-0.94000000f,0.29000000f,-0.16000000f,0.43000000f,-0.79000000f,0.81000000f,-0.89000000f,-0.63000000f,-0.76000000f,-0.15000000f,-0.71000000f,-0.77000000f,0.13000000f,0.67000000f,-0.15000000f,0.86000000f,0.12000000f,-0.37000000f,0.42000000f,-0.82000000f,-0.64000000f,0.42000000f,0.21000000f,-0.37000000f,-0.88000000f,0.14000000f,-0.80000000f,0.22000000f,0.52000000f,-0.84000000f,-0.39000000f,0.89000000f,0.23000000f,-0.21000000f,-0.62000000f,0.49000000f,0.35000000f,-0.13000000f,-0.40000000f,0.94000000f,-0.10000000f,-0.71000000f,-0.54000000f,0.75000000f,0.28000000f,-0.00000000f,-0.78000000f,-0.12000000f,0.42000000f,0.28000000f,-0.99000000f,0.82000000f,-0.99000000f,-0.97000000f,0.61000000f,0.29000000f,-0.76000000f,0.97000000f,-0.57000000f,-0.50000000f,0.20000000f,0.38000000f,-0.95000000f,0.08000000f,-0.57000000f,-0.98000000f,0.24000000f,-0.41000000f,0.40000000f,0.50000000f,0.59000000f,0.44000000f,-0.76000000f,-0.97000000f,-0.65000000f,-0.07000000f,-0.12000000f,-0.03000000f,0.79000000f,0.87000000f,-0.63000000f,-0.09000000f,0.16000000f,-0.47000000f,0.62000000f,0.55000000f,0.17000000f,0.32000000f,-0.44000000f,0.44000000f,0.61000000f,-0.52000000f,0.51000000f,-0.49000000f,0.87000000f,-0.34000000f,0.63000000f,-0.53000000f,-0.30000000f,-0.50000000f,-0.11000000f,-0.82000000f,-0.63000000f,-0.27000000f,0.31000000f,-0.60000000f,-0.83000000f,0.84000000f,0.90000000f,-0.13000000f,0.61000000f,-0.29000000f,-0.62000000f,0.51000000f,-0.32000000f,0.01000000f,-0.35000000f,-0.22000000f,-0.03000000f,-0.65000000f,0.25000000f,0.23000000f,-0.70000000f,0.09000000f,-0.34000000f,-0.82000000f,-0.60000000f,0.27000000f,0.48000000f,-0.04000000f,0.91000000f,0.40000000f,-0.66000000f,0.85000000f,-0.20000000f,0.85000000f,0.61000000f,-0.96000000f,-0.25000000f,-0.55000000f,-0.75000000f,0.00000000f,0.78000000f,-0.92000000f,0.29000000f,-0.00000000f,0.66000000f,0.03000000f,0.47000000f,-0.44000000f,-0.43000000f,-0.63000000f,0.82000000f,-0.00000000f,-0.88000000f,-0.14000000f,-0.55000000f,0.37000000f,0.00000000f,0.95000000f,0.12000000f,0.95000000f,0.22000000f,-0.98000000f,0.82000000f,-0.44000000f,0.37000000f,-0.09000000f,-0.92000000f,0.52000000f,-0.26000000f,-0.37000000f,0.95000000f,0.74000000f,0.84000000f,-0.97000000f,0.09000000f,-0.33000000f,-0.87000000f,-0.06000000f,0.81000000f,-0.85000000f,-0.68000000f,-0.67000000f,0.65000000f,-0.95000000f,0.60000000f,-0.55000000f,-0.45000000f,0.50000000f,0.54000000f,-0.18000000f,-0.00000000f,-0.53000000f,0.68000000f,0.88000000f,0.36000000f,-0.37000000f,0.58000000f,-0.90000000f,0.69000000f,-0.69000000f,0.10000000f,0.40000000f,-0.88000000f,-0.91000000f,-0.90000000f,-0.18000000f,0.47000000f,-0.60000000f,0.17000000f,-0.13000000f,0.64000000f,-0.24000000f,-0.42000000f,-0.89000000f,-0.47000000f,0.24000000f,-0.09000000f,0.13000000f,0.22000000f,0.35000000f,0.49000000f,0.73000000f,-0.97000000f,-0.58000000f,0.49000000f,0.20000000f,0.21000000f,-0.24000000f,0.16000000f,-0.77000000f,0.02000000f,-0.35000000f,0.06000000f,0.83000000f,-0.04000000f,-0.87000000f,-0.61000000f,0.78000000f,0.25000000f,-0.49000000f,-0.73000000f,-0.13000000f,0.95000000f,-0.59000000f,0.41000000f,-0.97000000f,-0.53000000f,-0.10000000f,-0.45000000f,-0.86000000f,0.57000000f,-0.58000000f,-0.78000000f,0.51000000f,-0.05000000f,-0.57000000f,0.11000000f,0.46000000f,0.66000000f,-0.48000000f,0.51000000f,-0.01000000f,-0.53000000f,-0.76000000f,0.19000000f,-0.01000000f,0.62000000f,-0.76000000f,0.49000000f,0.13000000f,-0.44000000f,0.01000000f,0.98000000f,-0.33000000f,-0.18000000f,-0.00000000f,0.27000000f,0.58000000f,0.94000000f,-0.21000000f,-0.79000000f,0.78000000f,0.15000000f,-0.19000000f,-0.60000000f,0.66000000f,0.53000000f,-0.13000000f,-0.91000000f,-0.96000000f,0.16000000f,-0.19000000f,-0.40000000f,-0.79000000f,-0.18000000f,0.66000000f,-0.17000000f,0.80000000f,0.90000000f,0.91000000f,0.43000000f,-0.83000000f,0.74000000f,-0.88000000f,-0.41000000f,0.07000000f,-0.25000000f,-0.53000000f,-0.75000000f,-0.43000000f,-0.62000000f,-0.35000000f,0.90000000f,-0.05000000f,0.75000000f,-0.76000000f,0.87000000f,-0.51000000f,0.16000000f,0.11000000f,-0.79000000f,0.29000000f,0.36000000f,0.56000000f,-0.85000000f,-0.51000000f,-0.04000000f,0.63000000f,0.75000000f,0.66000000f,-0.65000000f,-0.33000000f,-0.58000000f,0.09000000f,-0.50000000f,-0.70000000f,-0.75000000f,0.45000000f,-0.75000000f,0.21000000f,-0.20000000f,-0.39000000f,0.48000000f,0.97000000f,-0.03000000f,0.24000000f,-0.18000000f,-0.48000000f,0.46000000f,-0.04000000f,-0.71000000f,-0.11000000f,0.89000000f,0.56000000f,-0.52000000f,0.76000000f,0.44000000f,0.19000000f,0.83000000f,0.93000000f,-0.51000000f,0.83000000f,0.73000000f,0.12000000f,0.52000000f,-0.97000000f,0.42000000f,0.91000000f,-0.17000000f,0.13000000f,0.44000000f,-0.03000000f,0.54000000f,0.48000000f,-0.25000000f,-0.92000000f,-0.46000000f,0.39000000f,0.82000000f,-0.23000000f,0.05000000f,0.66000000f,-0.08000000f,0.60000000f,0.14000000f,-0.20000000f,-0.32000000f,-0.10000000f,-0.21000000f,0.12000000f,0.56000000f,-0.73000000f,0.63000000f,0.09000000f,0.97000000f,0.10000000f,-0.88000000f,0.71000000f,0.25000000f,-0.62000000f,-0.30000000f,-0.25000000f,-0.64000000f,0.35000000f,0.91000000f,0.57000000f,0.08000000f,-0.97000000f,-0.41000000f,-0.94000000f,-0.91000000f,-0.11000000f,0.57000000f,-0.68000000f,-0.37000000f,-0.39000000f,0.83000000f,0.31000000f,-0.15000000f,0.81000000f,-0.53000000f,0.63000000f,-0.65000000f,0.92000000f,-0.40000000f,-0.35000000f,0.05000000f,0.84000000f,0.63000000f,0.12000000f,-0.97000000f,0.98000000f,0.21000000f,0.91000000f,-0.86000000f,-0.12000000f,-0.77000000f,0.56000000f,0.66000000f,-0.60000000f,0.67000000f,-0.36000000f,-0.33000000f,0.39000000f,-0.21000000f,0.22000000f,0.82000000f,-0.51000000f,0.86000000f,0.28000000f,-0.07000000f,0.13000000f,-0.91000000f,-0.83000000f,-0.60000000f,-0.88000000f,0.42000000f,0.63000000f,-0.70000000f,0.54000000f,0.70000000f,0.38000000f,-0.71000000f,-0.15000000f,0.87000000f,0.07000000f,0.81000000f,-0.33000000f,-0.87000000f,-0.86000000f,0.85000000f,0.37000000f,-0.17000000f,0.71000000f,0.87000000f,-0.56000000f,0.06000000f,-0.66000000f,0.79000000f,-0.17000000f,0.13000000f,-0.22000000f,-0.75000000f,0.65000000f,0.14000000f,0.25000000f,0.56000000f,0.63000000f,-0.68000000f,-0.11000000f,0.91000000f,0.12000000f,-0.01000000f,-0.25000000f,-0.76000000f,-0.93000000f,0.66000000f,0.55000000f,0.43000000f,-0.35000000f,0.60000000f,-0.01000000f,-0.68000000f,-0.94000000f,-0.34000000f,-0.47000000f,0.87000000f,0.78000000f,0.10000000f,0.61000000f,-0.34000000f,0.19000000f,-0.24000000f,-0.20000000f,0.65000000f,-0.04000000f,-0.46000000f,0.08000000f,0.10000000f,0.54000000f,0.28000000f,-0.33000000f,-0.89000000f,0.88000000f,-0.54000000f,-0.04000000f,0.22000000f,0.53000000f,0.70000000f,0.07000000f,-0.65000000f,-0.86000000f,-0.72000000f,-0.61000000f,0.15000000f,-0.33000000f,-0.46000000f,0.96000000f,0.51000000f,0.86000000f,0.84000000f,0.03000000f,-0.62000000f,0.54000000f,-0.40000000f,-0.73000000f,0.04000000f,-0.40000000f,0.23000000f,-0.40000000f,0.28000000f,-0.66000000f,0.71000000f,0.33000000f,0.00000000f,0.59000000f,0.08000000f,0.81000000f,-0.02000000f,0.35000000f,-0.57000000f,0.92000000f,-0.76000000f,0.55000000f,-0.28000000f,0.53000000f,-0.84000000f,-0.76000000f,0.62000000f,-0.86000000f,0.97000000f,0.33000000f,-0.31000000f,-0.70000000f,0.51000000f,0.21000000f,-0.88000000f,-0.14000000f,0.17000000f,0.93000000f,0.34000000f,-0.38000000f,-0.71000000f,-0.68000000f,-0.99000000f,-0.80000000f,-0.26000000f,0.80000000f,0.39000000f,0.65000000f,0.89000000f,-0.11000000f,0.27000000f,0.59000000f,0.72000000f,0.88000000f,0.41000000f,0.27000000f,-0.54000000f,0.61000000f,-0.24000000f,0.64000000f,0.39000000f,0.06000000f,-0.65000000f,-0.23000000f,-0.43000000f,-0.74000000f,0.23000000f,0.06000000f,-0.18000000f,-0.72000000f,0.30000000f,0.07000000f,-0.90000000f,-0.49000000f,-0.50000000f,0.90000000f,0.73000000f,-0.00000000f,0.12000000f,-0.03000000f,0.50000000f,-0.15000000f,0.70000000f,-0.82000000f,0.54000000f,0.73000000f,-0.49000000f,-0.50000000f,-0.22000000f,-0.57000000f,0.58000000f,-0.73000000f,-0.69000000f,-0.58000000f,-0.81000000f,-0.48000000f,0.92000000f,-0.83000000f,-0.67000000f,-0.43000000f,-0.64000000f,0.53000000f,0.00000000f,-0.71000000f,-0.36000000f,0.38000000f,0.92000000f,0.98000000f,-0.60000000f,-0.52000000f,0.11000000f,0.78000000f,-0.40000000f,0.81000000f,-0.50000000f,-0.93000000f,-0.04000000f,-0.65000000f,0.44000000f,-0.66000000f,-0.23000000f,0.09000000f,-0.14000000f,-0.40000000f,0.26000000f,0.82000000f,0.68000000f,0.61000000f,0.93000000f,0.02000000f,-0.86000000f,-0.74000000f,-0.81000000f,-0.84000000f,-0.64000000f,-0.70000000f,-0.36000000f,0.83000000f,-0.57000000f,-0.74000000f,-0.22000000f,0.51000000f,-0.96000000f,-0.07000000f,-0.57000000f,0.18000000f,0.95000000f,0.25000000f,0.76000000f,-0.59000000f,-0.09000000f,-0.74000000f,0.33000000f,0.64000000f,-0.90000000f,0.62000000f,-0.16000000f,-0.69000000f,0.46000000f,-0.86000000f,0.21000000f,-0.25000000f,0.27000000f,0.66000000f,0.63000000f,-0.19000000f,-0.16000000f,-0.31000000f,-0.37000000f,0.99000000f,0.96000000f,-0.84000000f,-0.05000000f,-0.21000000f,0.05000000f,-0.22000000f,-0.09000000f,0.32000000f,0.61000000f,0.94000000f,-0.30000000f,0.73000000f,-0.79000000f,-0.84000000f,0.36000000f,-0.34000000f,0.00000000f,0.19000000f,0.14000000f,-0.94000000f,-0.98000000f,0.93000000f,0.09000000f,-0.75000000f,0.53000000f,-0.39000000f,-0.95000000f,-0.21000000f,0.17000000f,0.87000000f,0.21000000f,-0.29000000f,0.15000000f,-0.96000000f,-0.30000000f,-0.13000000f,0.43000000f,-0.01000000f,-0.08000000f,0.57000000f,0.77000000f,0.98000000f,-0.74000000f,-0.89000000f,0.79000000f,-0.10000000f,-0.15000000f,0.28000000f,0.47000000f,-0.62000000f,0.86000000f,0.77000000f,0.21000000f,-0.22000000f,0.63000000f,-0.42000000f,-0.10000000f,0.42000000f,0.02000000f,-0.15000000f,-0.74000000f,0.66000000f,-0.69000000f,-0.82000000f,-0.39000000f,0.17000000f,-0.16000000f,-0.04000000f,-0.69000000f,0.97000000f,-0.33000000f,0.74000000f,-0.69000000f,-0.01000000f,-0.87000000f,0.43000000f,0.99000000f,-0.18000000f,-0.37000000f,0.86000000f,-0.96000000f,0.97000000f,-0.62000000f,-0.02000000f,0.81000000f,-0.21000000f,0.78000000f,-0.36000000f,0.79000000f,0.14000000f,0.04000000f,0.13000000f,0.77000000f,0.84000000f,-0.21000000f,-0.24000000f,0.50000000f,-0.46000000f,-0.64000000f,-0.43000000f,-0.26000000f,-0.08000000f,-0.14000000f,-0.70000000f,0.77000000f,-0.59000000f,-0.39000000f,0.60000000f,-0.06000000f,0.42000000f,-0.83000000f,-0.43000000f,0.90000000f,0.76000000f,-0.52000000f,-0.92000000f,-0.22000000f,-0.15000000f,-0.54000000f,0.87000000f,0.20000000f,0.80000000f,0.93000000f,-0.14000000f,-0.33000000f,-0.83000000f,0.20000000f,-0.98000000f,0.18000000f,0.32000000f,-0.65000000f,0.00000000f,-0.22000000f,0.89000000f,-0.07000000f,-0.31000000f,0.05000000f,-0.49000000f,-0.58000000f,0.11000000f,-0.23000000f,0.18000000f,-0.58000000f,-0.30000000f,-0.83000000f,0.39000000f,0.56000000f,-0.49000000f,0.45000000f,-0.79000000f,0.79000000f,-0.67000000f,0.67000000f,-0.15000000f,0.32000000f,-0.91000000f,0.46000000f,0.11000000f,0.49000000f,0.78000000f,0.33000000f,-0.66000000f,-0.64000000f,0.63000000f,-0.42000000f,-0.25000000f,-0.80000000f,-0.24000000f,-0.69000000f,0.56000000f,0.84000000f,0.77000000f,0.74000000f,-0.39000000f,0.54000000f,0.83000000f,0.22000000f,-0.98000000f,0.26000000f,0.17000000f,0.63000000f,0.00000000f,0.55000000f,-0.92000000f,0.94000000f,-0.32000000f,-0.87000000f,-0.74000000f,0.11000000f,0.61000000f,0.55000000f,-0.72000000f,0.19000000f,-0.44000000f,-0.97000000f,-0.25000000f,-0.94000000f,0.75000000f,-0.41000000f,-0.40000000f,-0.83000000f,-0.82000000f,-0.51000000f,-0.26000000f,0.49000000f,0.98000000f,0.26000000f,0.91000000f,0.30000000f,-0.37000000f,0.50000000f,-0.77000000f,0.39000000f,-0.02000000f,0.22000000f,-0.91000000f,0.25000000f,0.98000000f,0.92000000f,0.85000000f,-0.23000000f,-0.00000000f,-0.35000000f,-0.63000000f,0.88000000f,0.39000000f,0.74000000f,-0.04000000f,0.34000000f,0.02000000f,-0.82000000f,0.73000000f,0.33000000f,-0.59000000f,0.47000000f,0.56000000f,0.48000000f,-0.34000000f,0.84000000f,-0.68000000f,-0.28000000f,0.96000000f,-0.06000000f,0.30000000f,-0.75000000f,0.91000000f,0.09000000f,0.29000000f,-0.84000000f,0.97000000f,-0.66000000f,0.52000000f,-0.00000000f,0.56000000f,-0.46000000f,0.29000000f,0.49000000f,0.64000000f,0.77000000f,-0.24000000f,0.20000000f,0.34000000f,0.40000000f,0.20000000f,0.85000000f,-0.80000000f,0.28000000f,0.93000000f,0.72000000f,-0.30000000f,0.62000000f,0.61000000f,-0.63000000f,-0.66000000f,-0.46000000f,0.95000000f,0.05000000f,-0.47000000f,0.83000000f,0.02000000f,-0.33000000f,-0.35000000f,0.38000000f,-0.51000000f,0.11000000f,0.52000000f,0.14000000f,0.87000000f,-0.71000000f,-0.87000000f,-0.22000000f,0.52000000f,0.82000000f,-0.77000000f,0.72000000f,0.48000000f,-0.11000000f,-0.77000000f,0.64000000f,-0.61000000f,0.09000000f,-0.16000000f,-0.30000000f,0.56000000f,0.50000000f,-0.66000000f,-0.39000000f,0.81000000f,0.42000000f,0.29000000f,-0.32000000f,0.67000000f,-0.59000000f,-0.60000000f,0.74000000f,0.93000000f,-0.49000000f,-0.34000000f,-0.35000000f,0.32000000f,-0.75000000f,0.32000000f,-0.03000000f,-0.39000000f,0.61000000f,-0.84000000f,-0.46000000f,-0.33000000f,0.99000000f,-0.71000000f,0.71000000f,-0.48000000f,0.27000000f,0.65000000f,-0.08000000f,0.86000000f,-0.69000000f,0.58000000f,0.10000000f,-0.64000000f,0.82000000f,-0.66000000f,-0.65000000f,0.58000000f,-0.42000000f,0.85000000f,-0.34000000f,0.99000000f,-0.02000000f,-0.05000000f,0.51000000f,-0.40000000f,0.24000000f,0.61000000f,-0.13000000f,-0.78000000f,-0.31000000f,-0.89000000f,0.62000000f,0.30000000f,-0.27000000f,-0.68000000f,-0.41000000f,-0.77000000f,0.64000000f,0.94000000f,0.01000000f,0.29000000f,-0.45000000f,-0.15000000f,-0.73000000f,0.78000000f,-0.27000000f,-0.80000000f,-0.70000000f,-0.30000000f,-0.69000000f,0.38000000f,-0.31000000f,0.37000000f,0.08000000f,0.97000000f,-0.32000000f,-0.01000000f,0.70000000f,0.61000000f,0.39000000f,0.58000000f,0.35000000f,0.32000000f,0.17000000f,0.86000000f,-0.04000000f,-0.75000000f,0.98000000f,0.81000000f,-0.58000000f,0.78000000f,0.94000000f,0.65000000f,0.89000000f,-0.36000000f,-0.43000000f,0.27000000f,0.99000000f,-0.99000000f,0.11000000f,0.04000000f,-0.08000000f,-0.16000000f,0.20000000f,-0.66000000f,0.87000000f,-0.05000000f,-0.57000000f,0.27000000f,0.90000000f,-0.41000000f,-0.60000000f,0.52000000f,-0.95000000f,0.30000000f,0.26000000f,0.54000000f,-0.71000000f,0.44000000f,-0.70000000f,-0.29000000f,-0.84000000f,-0.21000000f,-0.59000000f,0.55000000f,-0.98000000f,-0.85000000f,-0.98000000f,0.84000000f,0.99000000f,0.25000000f,0.14000000f,-0.42000000f,-0.91000000f,-0.48000000f,-0.52000000f,-0.49000000f,0.33000000f,0.05000000f,-0.46000000f,0.97000000f,0.89000000f,-0.12000000f,-0.45000000f,0.91000000f,-0.13000000f,-0.22000000f,-0.74000000f,-0.34000000f,0.00000000f,0.34000000f,0.16000000f,-0.31000000f,-0.11000000f,0.77000000f,-0.70000000f,0.81000000f,0.84000000f,-0.30000000f,0.18000000f,0.98000000f,-0.12000000f,-0.36000000f,0.48000000f,0.26000000f,-0.87000000f,0.21000000f,0.64000000f,0.36000000f,-0.85000000f,-0.04000000f,0.44000000f,-0.89000000f,0.94000000f,-0.98000000f,0.19000000f,-0.40000000f,-0.48000000f,-0.36000000f,0.77000000f,0.29000000f,0.18000000f,-0.02000000f,-0.72000000f,0.44000000f,0.35000000f,0.42000000f,-0.27000000f,0.51000000f,0.94000000f,0.14000000f,0.53000000f,-0.56000000f,-0.07000000f,0.37000000f,-0.33000000f,0.83000000f,-0.53000000f,0.33000000f,0.86000000f,-0.13000000f,-0.52000000f,0.11000000f,-0.23000000f,0.25000000f,-0.65000000f,-0.06000000f,0.42000000f,0.71000000f,0.94000000f,-0.78000000f,0.66000000f,0.96000000f,0.54000000f,0.20000000f,-0.36000000f,-0.52000000f,-0.26000000f,-0.59000000f,0.42000000f,0.34000000f,-0.23000000f,-0.35000000f,0.67000000f,0.49000000f,0.22000000f,-0.31000000f,0.17000000f,-0.34000000f,0.13000000f,0.06000000f,0.78000000f,-0.24000000f,-0.50000000f,0.41000000f,-0.18000000f,-0.93000000f,-0.98000000f,-0.02000000f,-0.16000000f,-0.11000000f,-0.37000000f,-0.66000000f,-0.63000000f,0.14000000f,-0.87000000f,-0.60000000f,0.60000000f,-0.45000000f,0.75000000f,-0.41000000f,0.62000000f,0.24000000f,0.71000000f,0.63000000f,0.77000000f,0.11000000f,-0.99000000f,0.03000000f,0.50000000f,-0.72000000f,-0.77000000f,-0.25000000f,0.00000000f,0.51000000f,-0.77000000f,-0.35000000f,-0.91000000f,0.94000000f,0.40000000f,0.89000000f,0.25000000f,-0.42000000f,-0.24000000f,-0.15000000f,-0.85000000f,0.32000000f,-0.42000000f,0.66000000f,0.57000000f,-0.89000000f,-0.08000000f,0.76000000f,-0.57000000f,0.09000000f,-0.26000000f,-0.30000000f,-0.46000000f,-0.44000000f,-0.06000000f,0.79000000f,0.67000000f,-0.60000000f,-0.59000000f,-0.05000000f,0.11000000f,-0.60000000f,-0.22000000f,-0.99000000f,0.51000000f,-0.30000000f,0.70000000f,0.85000000f,0.00000000f,-0.55000000f,-0.26000000f,-0.28000000f,-0.55000000f,0.85000000f,0.49000000f,-0.33000000f,-0.95000000f,-0.34000000f,-0.26000000f,-0.41000000f,-0.37000000f,-0.07000000f,0.84000000f,-0.94000000f,0.36000000f,-0.97000000f,0.04000000f,0.52000000f,0.36000000f,0.36000000f,-0.41000000f,-0.66000000f,0.91000000f,0.99000000f,-0.70000000f,-0.36000000f,0.20000000f,0.97000000f,-0.87000000f,-0.32000000f,-0.86000000f,-0.85000000f,-0.33000000f,0.69000000f,0.44000000f,-0.25000000f,-0.44000000f,-0.44000000f,-0.90000000f,0.93000000f,0.74000000f,-0.52000000f,0.71000000f,0.97000000f,0.13000000f,0.04000000f,0.42000000f,0.08000000f,-0.71000000f,0.08000000f,0.13000000f,-0.42000000f,-0.08000000f,-0.49000000f,-0.13000000f,0.91000000f,0.08000000f,0.02000000f,0.42000000f,-0.44000000f,-0.32000000f,0.34000000f,0.27000000f,0.70000000f,0.49000000f,-0.30000000f,-0.00000000f,-0.87000000f,0.08000000f,0.29000000f,0.64000000f,0.02000000f,-0.29000000f,0.23000000f,-0.53000000f,-0.93000000f,0.42000000f,-0.47000000f,-0.79000000f,0.66000000f,0.75000000f,-0.30000000f,0.16000000f,0.81000000f,-0.81000000f,0.36000000f,0.71000000f,0.90000000f,0.15000000f,0.98000000f,-0.77000000f,0.96000000f,0.10000000f,0.40000000f,0.05000000f,-0.76000000f,0.71000000f,-0.12000000f,-0.30000000f,0.93000000f,-0.00000000f,-0.53000000f,-0.25000000f,-0.10000000f,0.04000000f,-0.07000000f,0.04000000f,-0.89000000f,0.53000000f,-0.76000000f,0.60000000f,0.07000000f,-0.31000000f,0.06000000f,-0.35000000f,0.33000000f,0.01000000f,-0.25000000f,-0.71000000f,-0.38000000f,-0.39000000f,0.15000000f,-0.28000000f,-0.44000000f,-0.64000000f,-0.80000000f,-0.61000000f,-0.57000000f,0.46000000f,0.61000000f,-0.49000000f,-0.07000000f,-0.17000000f,-0.94000000f,0.73000000f,-0.06000000f,-0.02000000f,0.19000000f,0.54000000f,0.38000000f,0.69000000f,-0.67000000f,-0.27000000f,0.05000000f,0.75000000f,-0.48000000f,-0.13000000f,-0.18000000f,-0.02000000f,0.37000000f,0.63000000f,-0.97000000f,0.30000000f,0.82000000f,0.82000000f,0.88000000f,0.25000000f,-0.64000000f,0.60000000f,-0.41000000f,-0.12000000f,-0.73000000f,-0.65000000f,-0.53000000f,0.02000000f,0.58000000f,-0.36000000f,-0.53000000f,0.88000000f,-0.51000000f,0.66000000f,-0.79000000f,-0.23000000f,0.65000000f,-0.38000000f,0.99000000f,-0.51000000f,-0.62000000f,0.72000000f,-0.31000000f,-0.87000000f,0.56000000f,0.18000000f,0.71000000f,0.01000000f,-0.72000000f,0.59000000f,0.15000000f,-0.73000000f,0.43000000f,-0.81000000f,-0.62000000f,0.08000000f,0.82000000f,0.98000000f,0.94000000f,-0.97000000f,0.97000000f,-0.27000000f,-0.17000000f,-0.41000000f,-0.20000000f,-0.61000000f,0.31000000f,-0.25000000f,-0.58000000f,0.95000000f,-0.36000000f,0.28000000f,-0.54000000f,-0.92000000f,-0.87000000f,-0.61000000f,0.12000000f,-0.24000000f,0.71000000f,0.90000000f,-0.29000000f,-0.75000000f,0.78000000f,0.30000000f,0.51000000f,-0.48000000f,-0.39000000f,0.75000000f,-0.90000000f,0.65000000f,-0.07000000f,0.17000000f,-0.55000000f,0.27000000f,-0.66000000f,-0.23000000f,-0.13000000f,0.06000000f,-0.27000000f,0.13000000f,0.53000000f,-0.06000000f,0.88000000f,0.81000000f,-0.56000000f,-0.09000000f,-0.26000000f,-0.84000000f,-0.22000000f,-0.59000000f,0.23000000f,0.60000000f,-0.60000000f,0.90000000f,-0.86000000f,0.00000000f,-0.43000000f,-0.15000000f,-0.33000000f,-0.89000000f,0.20000000f,-0.08000000f,0.37000000f,0.24000000f,0.86000000f,0.67000000f,-0.52000000f,-0.88000000f,0.45000000f,-0.56000000f,0.00000000f,-0.45000000f,0.07000000f,-0.82000000f,0.08000000f,-0.27000000f,-0.64000000f,-0.88000000f,0.92000000f,-0.99000000f,-0.12000000f,0.89000000f,0.35000000f,-0.29000000f,0.48000000f,-0.35000000f,-0.50000000f,-0.60000000f,0.31000000f,-0.46000000f,0.60000000f,0.47000000f,0.54000000f,0.45000000f,0.86000000f,0.54000000f,-0.99000000f,0.59000000f,-0.01000000f,0.86000000f,-0.10000000f,0.54000000f,-0.76000000f,-0.88000000f,0.75000000f,-0.61000000f,0.40000000f,-0.25000000f,0.92000000f,0.14000000f,-0.18000000f,0.04000000f,-0.31000000f,0.29000000f,-0.80000000f,0.67000000f,-0.60000000f,-0.76000000f,-0.01000000f,-0.19000000f,0.18000000f,0.55000000f,0.03000000f,0.23000000f,-0.30000000f,-0.66000000f,-0.12000000f,-0.16000000f,0.97000000f,0.40000000f,0.52000000f,-0.15000000f,-0.89000000f,0.71000000f,0.31000000f,0.96000000f,0.90000000f,-0.19000000f,-0.35000000f,0.28000000f,-0.64000000f,-0.45000000f,-0.78000000f,-0.98000000f,-0.36000000f,0.00000000f,-0.53000000f,-0.91000000f,-0.41000000f,0.21000000f,0.43000000f,-0.24000000f,-0.37000000f,-0.91000000f,0.66000000f,0.19000000f,0.76000000f,0.72000000f,-0.44000000f,0.55000000f,0.51000000f,0.45000000f,0.68000000f,-0.26000000f,0.09000000f,-0.87000000f,0.16000000f,0.52000000f,0.85000000f,-0.61000000f,-0.28000000f,-0.50000000f,0.32000000f,-0.24000000f,0.09000000f,0.18000000f,0.46000000f,0.80000000f,-0.04000000f,0.07000000f,0.29000000f,-0.57000000f,-0.22000000f,-0.92000000f,-0.49000000f,0.98000000f,0.99000000f,0.61000000f,0.26000000f,0.85000000f,-0.24000000f,0.47000000f,-0.40000000f,-0.59000000f,-0.00000000f,-0.89000000f,-0.33000000f,0.37000000f,0.26000000f,0.31000000f,-0.77000000f,-0.89000000f,-0.03000000f,-0.26000000f,0.85000000f,0.71000000f,-0.12000000f,0.64000000f,0.92000000f,-0.54000000f,0.96000000f,0.42000000f,0.85000000f,-0.85000000f,0.22000000f,0.61000000f,0.64000000f,-0.82000000f,0.01000000f,-0.07000000f,0.58000000f,-0.33000000f,0.25000000f,0.26000000f,-0.52000000f,0.44000000f,-0.84000000f,0.50000000f,-0.02000000f,-0.29000000f,0.57000000f,-0.43000000f,-0.62000000f,0.66000000f,-0.01000000f,-0.86000000f,0.83000000f,0.90000000f,-0.16000000f,0.66000000f,-0.81000000f,-0.30000000f,0.15000000f,-0.62000000f,0.38000000f,0.92000000f,-0.11000000f,0.39000000f,0.51000000f,-0.27000000f,0.62000000f,-0.86000000f,0.00000000f,-0.16000000f,0.70000000f,-0.77000000f,-0.92000000f,-0.73000000f,-0.28000000f,-0.47000000f,-0.70000000f,-0.66000000f,-0.78000000f,-0.86000000f,0.56000000f,0.28000000f,0.31000000f,0.96000000f,-0.64000000f,0.18000000f,0.49000000f,-0.81000000f,-0.56000000f,-0.98000000f,0.99000000f,-0.93000000f,0.04000000f,-0.63000000f,-0.22000000f,-0.63000000f,-0.49000000f,0.08000000f,0.47000000f,0.71000000f,-0.35000000f,-0.76000000f,0.01000000f,-0.92000000f,0.80000000f,0.23000000f,0.69000000f,-0.66000000f,0.14000000f,-0.21000000f,0.11000000f,-0.38000000f,-0.11000000f,-0.12000000f,-0.77000000f,-0.90000000f,-0.24000000f,0.78000000f,0.54000000f,0.84000000f,0.18000000f,-0.26000000f,-0.08000000f,-0.66000000f,-0.83000000f,-0.28000000f,0.90000000f,-0.89000000f,0.98000000f,-0.75000000f,-0.92000000f,-0.56000000f,0.29000000f,0.03000000f,0.25000000f,-0.64000000f,0.23000000f,-0.30000000f,0.44000000f,0.98000000f,-0.48000000f,0.66000000f,0.80000000f,-0.31000000f,0.17000000f,0.45000000f,-0.43000000f,0.59000000f,-0.78000000f,0.10000000f,0.27000000f,0.04000000f,0.85000000f,-0.25000000f,-0.22000000f,-0.07000000f,-0.64000000f,-0.86000000f,-0.39000000f,0.73000000f,0.81000000f,-0.71000000f,0.63000000f,0.87000000f,-0.41000000f,0.45000000f,-0.00000000f,-0.01000000f,0.40000000f,0.10000000f,-0.59000000f,0.13000000f,-0.11000000f,0.13000000f,0.18000000f,-0.06000000f,-0.18000000f,0.28000000f,-0.42000000f,-0.62000000f,-0.82000000f,0.34000000f,-0.61000000f,0.61000000f,-0.47000000f,0.34000000f,-0.68000000f,0.92000000f,-0.08000000f,0.90000000f,0.52000000f,0.71000000f,-0.14000000f,0.73000000f,-0.72000000f,-0.43000000f,0.15000000f,-0.10000000f,0.49000000f,-0.33000000f,0.71000000f,-0.13000000f,-0.48000000f,-0.39000000f,0.08000000f,0.50000000f,0.47000000f,-0.79000000f,-0.21000000f,-0.75000000f,0.89000000f,0.15000000f,0.21000000f,0.62000000f,-0.05000000f,0.62000000f,-0.83000000f,0.87000000f,-0.34000000f,0.61000000f,-0.60000000f,-0.42000000f,0.11000000f,0.03000000f,-0.66000000f,-0.05000000f,0.42000000f,0.19000000f,0.82000000f,0.69000000f,-0.33000000f,-0.92000000f,-0.02000000f,-0.00000000f,0.82000000f,0.83000000f,-0.02000000f,0.44000000f,0.11000000f,0.19000000f,0.01000000f,-0.09000000f,0.38000000f,-0.32000000f,0.30000000f,0.84000000f,-0.65000000f,-0.01000000f,-0.08000000f,-0.02000000f,-0.83000000f,-0.47000000f,0.95000000f,-0.99000000f,0.37000000f,-0.38000000f,0.21000000f,0.35000000f,-0.38000000f,0.92000000f,0.60000000f,0.46000000f,-0.14000000f,0.28000000f,0.20000000f,-0.15000000f,-0.03000000f,0.96000000f,-0.33000000f,0.08000000f,-0.48000000f,-0.56000000f,0.96000000f,-0.03000000f,-0.56000000f,-0.25000000f,0.90000000f,0.16000000f,0.21000000f,-0.45000000f,0.77000000f,0.21000000f,0.61000000f,0.74000000f,-0.07000000f,0.93000000f,-0.35000000f,-0.26000000f,0.52000000f,0.74000000f,-0.91000000f,0.33000000f,0.09000000f,-0.45000000f,0.58000000f,-0.53000000f,0.31000000f,0.42000000f,0.70000000f,-0.85000000f,-0.19000000f,0.63000000f,-0.87000000f,0.67000000f,-0.49000000f,0.51000000f,-0.08000000f,0.96000000f,-0.80000000f,0.00000000f,0.79000000f,0.44000000f,0.69000000f,-0.37000000f,-0.86000000f,-0.63000000f,0.90000000f,0.79000000f,-0.56000000f,-0.26000000f,0.66000000f,0.62000000f,0.22000000f,0.27000000f,0.75000000f,-0.86000000f,0.23000000f,0.34000000f,-0.50000000f,-0.40000000f,-0.05000000f,0.12000000f,-0.26000000f,0.40000000f,-0.74000000f,-0.94000000f,-0.65000000f,-0.36000000f,-0.66000000f,-0.96000000f,-0.34000000f,0.57000000f,-0.44000000f,0.09000000f,-0.88000000f,0.66000000f,-0.04000000f,0.46000000f,-0.33000000f,-0.72000000f,0.69000000f,0.58000000f,-0.57000000f,-0.75000000f,0.48000000f,0.31000000f,-0.04000000f,0.34000000f,-0.95000000f,0.49000000f,-0.63000000f,-0.27000000f,0.61000000f,-0.96000000f,-0.00000000f,-0.27000000f,-0.26000000f,0.26000000f,-0.33000000f,0.30000000f,0.61000000f,0.81000000f,0.12000000f,0.24000000f,0.24000000f,-0.07000000f,-0.23000000f,-0.50000000f,-0.55000000f,-0.22000000f,-0.89000000f,-0.97000000f,0.05000000f,0.46000000f,0.11000000f,0.62000000f,-0.02000000f,-0.34000000f,-0.94000000f,0.04000000f,0.97000000f,0.43000000f,0.58000000f,-0.46000000f,0.59000000f,-0.36000000f,0.47000000f,-0.06000000f,-0.57000000f,-0.57000000f,0.10000000f,0.38000000f,-0.43000000f,0.23000000f,-0.91000000f,0.35000000f,0.09000000f,0.91000000f,0.30000000f,0.84000000f,0.09000000f,0.40000000f,-0.75000000f,0.50000000f,-0.36000000f,-0.95000000f,-0.86000000f,-0.78000000f,-0.69000000f,0.28000000f,0.93000000f,0.19000000f,-0.15000000f,0.90000000f,-0.19000000f,0.71000000f,0.98000000f,0.15000000f,0.31000000f,-0.87000000f,-0.61000000f,0.51000000f,0.71000000f,0.67000000f,-0.40000000f,0.70000000f,0.34000000f,0.61000000f,0.61000000f,0.47000000f,0.49000000f,-0.13000000f,-0.43000000f,0.79000000f,-0.45000000f,-0.57000000f,0.40000000f,-0.23000000f,0.53000000f,0.27000000f,-0.58000000f,0.43000000f,-0.10000000f,-0.72000000f,0.27000000f,-0.09000000f,0.56000000f,0.64000000f,0.11000000f,-0.57000000f,-0.27000000f,0.60000000f,-0.29000000f,0.16000000f,0.77000000f,-0.96000000f,0.40000000f,0.13000000f,0.86000000f,-0.42000000f,0.62000000f,-0.21000000f,-0.11000000f,0.92000000f,0.07000000f,-0.08000000f,0.70000000f,0.34000000f,-0.82000000f,-0.46000000f,0.86000000f,-0.01000000f,-0.42000000f,0.41000000f,0.74000000f,-0.03000000f,-0.69000000f,0.38000000f,0.03000000f,0.94000000f,-0.81000000f,-0.44000000f,0.26000000f,-0.48000000f,-0.01000000f,0.81000000f,0.41000000f,-0.87000000f,-0.35000000f,-0.23000000f,-0.32000000f,0.19000000f,-0.31000000f,-0.36000000f,-0.39000000f,0.96000000f,-0.03000000f,0.64000000f,0.65000000f,-0.40000000f,0.80000000f,0.61000000f,0.83000000f,0.37000000f,0.63000000f,0.42000000f,-0.01000000f,0.95000000f,-0.67000000f,0.59000000f,-0.02000000f,-0.06000000f,0.63000000f,0.20000000f,0.27000000f,-0.15000000f,0.13000000f,0.49000000f,-0.43000000f,0.92000000f,-0.76000000f,0.20000000f,-0.35000000f,0.20000000f,-0.82000000f,-0.79000000f,0.09000000f,-0.62000000f,0.60000000f,-0.20000000f,-0.89000000f,-0.22000000f,-0.63000000f,0.31000000f,0.27000000f,-0.67000000f,0.23000000f,0.13000000f,0.18000000f,-0.82000000f,0.95000000f,0.52000000f,-0.26000000f,0.55000000f,-0.77000000f,-0.29000000f,0.43000000f,-0.34000000f,-0.61000000f,0.72000000f,0.21000000f,-0.21000000f,0.21000000f,0.47000000f,-0.02000000f,-0.13000000f,0.10000000f,0.81000000f,0.73000000f,-0.50000000f,-0.59000000f,-0.32000000f,-0.18000000f,-0.02000000f,0.19000000f,-0.58000000f,-0.35000000f,-0.52000000f,0.40000000f,-0.88000000f,-0.87000000f,0.75000000f,-0.08000000f,-0.36000000f,0.49000000f,0.46000000f,0.72000000f,0.47000000f,-0.69000000f,-0.53000000f,-0.67000000f,0.27000000f,0.51000000f,0.73000000f,-0.70000000f,-0.52000000f,0.83000000f,0.03000000f,-0.03000000f,-0.72000000f,0.22000000f,0.29000000f,-0.92000000f,-0.07000000f,-0.58000000f,0.21000000f,-0.62000000f,0.08000000f,0.52000000f,-0.70000000f,0.68000000f,-0.72000000f,-0.66000000f,0.24000000f,0.80000000f,0.48000000f,0.46000000f,-0.41000000f,-0.47000000f,0.06000000f,-0.11000000f,-0.30000000f,0.92000000f,-0.28000000f,0.53000000f,-0.08000000f,0.28000000f,0.55000000f,0.87000000f,0.65000000f,-0.00000000f,-0.44000000f,-0.17000000f,0.35000000f,-0.43000000f,0.01000000f,-0.92000000f,0.01000000f,-0.33000000f,0.21000000f,0.34000000f,0.67000000f,0.48000000f,-0.23000000f,-0.08000000f,0.07000000f,-0.17000000f,-0.02000000f,-0.62000000f,-0.56000000f,0.47000000f,-0.10000000f,0.49000000f,-0.33000000f,0.04000000f,-0.92000000f,-0.68000000f,0.80000000f,0.49000000f,0.42000000f,0.86000000f,-0.23000000f,-0.74000000f,-0.64000000f,0.83000000f,0.39000000f,-0.53000000f,-0.69000000f,-0.86000000f,-0.30000000f,0.22000000f,-0.85000000f,0.78000000f,0.00000000f,-0.86000000f,0.94000000f,0.33000000f,0.85000000f,0.33000000f,-0.34000000f,0.06000000f,-0.25000000f,0.26000000f,-0.88000000f,0.90000000f,-0.47000000f,-0.29000000f,-0.56000000f,-0.59000000f,0.66000000f,-0.06000000f,-0.03000000f,0.75000000f,-0.64000000f,0.03000000f,-0.15000000f,0.69000000f,-0.59000000f,0.66000000f,0.37000000f,-0.21000000f,0.04000000f,-0.24000000f,0.49000000f,-0.30000000f,-0.27000000f,-0.93000000f,-0.16000000f,0.73000000f,-0.22000000f,-0.63000000f,0.98000000f,-0.47000000f,0.60000000f,-0.67000000f,-0.31000000f,-0.24000000f,-0.57000000f,0.10000000f,0.49000000f,-0.52000000f,-0.81000000f,-0.28000000f,0.13000000f,-0.36000000f,0.87000000f,-0.61000000f,0.38000000f,-0.35000000f,0.05000000f,-0.01000000f,0.38000000f,0.92000000f,-0.43000000f,-0.87000000f,0.35000000f,0.84000000f,0.47000000f,0.19000000f,0.71000000f,-0.16000000f,0.32000000f,0.64000000f,-0.27000000f,0.30000000f,-0.88000000f,0.24000000f,0.97000000f,-0.02000000f,0.59000000f,-0.45000000f,-0.13000000f,0.32000000f,0.40000000f,-0.69000000f,0.24000000f,-0.06000000f,-0.29000000f,-0.74000000f,0.01000000f,0.36000000f,0.16000000f,0.18000000f,-0.89000000f,-0.62000000f,0.63000000f,-0.83000000f,0.37000000f,0.88000000f,0.53000000f,0.43000000f,0.16000000f,0.72000000f,0.94000000f,-0.04000000f,0.86000000f,0.64000000f,0.58000000f,-0.03000000f,-0.83000000f,0.78000000f,-0.96000000f,-0.11000000f,-0.30000000f,0.20000000f,-0.60000000f,-0.02000000f,0.52000000f,0.62000000f,-0.99000000f,-0.96000000f,0.17000000f,-0.79000000f,-0.87000000f,-0.32000000f,0.39000000f,0.31000000f,0.02000000f,-0.84000000f,-0.77000000f,0.49000000f,0.65000000f,0.83000000f,-0.30000000f,0.98000000f,-0.13000000f,-0.94000000f,0.14000000f,0.40000000f,-0.47000000f,0.81000000f,0.88000000f,-0.75000000f,0.88000000f,0.54000000f,0.89000000f,-0.52000000f,0.92000000f,-0.10000000f,0.11000000f,0.83000000f,0.11000000f,-0.99000000f,0.22000000f,-0.41000000f,0.00000000f,0.80000000f,-0.53000000f,0.19000000f,0.26000000f,-0.17000000f,-0.70000000f,-0.56000000f,-0.20000000f,0.26000000f,0.91000000f,-0.83000000f,0.67000000f,0.56000000f,0.83000000f,0.43000000f,-0.39000000f,0.28000000f,0.83000000f,-0.43000000f,0.92000000f,0.88000000f,-0.68000000f,-0.37000000f,0.62000000f,-0.68000000f,0.70000000f,-0.16000000f,-0.78000000f,0.88000000f,-0.84000000f,0.32000000f,-0.22000000f,0.72000000f,0.58000000f,0.40000000f,0.24000000f,0.90000000f,-0.08000000f,-0.03000000f,-0.89000000f,0.55000000f,-0.76000000f,-0.34000000f,-0.15000000f,0.19000000f,0.36000000f,0.46000000f,-0.60000000f,-0.43000000f,0.54000000f,-0.38000000f,-0.02000000f,-0.21000000f,-0.60000000f,-0.74000000f,0.92000000f,0.65000000f,0.47000000f,0.75000000f,0.58000000f,0.95000000f,-0.22000000f,-0.64000000f,-0.28000000f,-0.12000000f,0.84000000f,-0.37000000f,-0.18000000f,-0.50000000f,0.08000000f,0.14000000f,0.31000000f,-0.56000000f,-0.18000000f,0.32000000f,0.52000000f,0.46000000f,0.19000000f,0.31000000f,-0.48000000f,-0.95000000f,-0.31000000f,0.83000000f,-0.31000000f,0.22000000f,0.41000000f,-0.02000000f,0.05000000f,0.60000000f,0.36000000f,0.78000000f,0.50000000f,0.50000000f,0.61000000f,-0.59000000f,-0.00000000f,0.50000000f,0.96000000f,-0.80000000f,-0.56000000f,0.92000000f,-0.00000000f,0.25000000f,0.79000000f,0.76000000f,0.14000000f,-0.00000000f,-0.99000000f,-0.85000000f,0.81000000f,-0.26000000f,-0.58000000f,0.21000000f,-0.68000000f,-0.90000000f,0.68000000f,-0.48000000f,0.59000000f,0.08000000f,0.62000000f,0.38000000f,0.64000000f,-0.54000000f,0.65000000f,0.60000000f,-0.45000000f,-0.54000000f,-0.40000000f,0.13000000f,-0.94000000f,-0.86000000f,-0.67000000f,0.09000000f,-0.53000000f,-0.45000000f,0.23000000f,0.19000000f,0.62000000f,-0.18000000f,-0.51000000f,0.56000000f,0.81000000f,0.55000000f,-0.62000000f,0.60000000f,0.44000000f,0.61000000f,0.58000000f,0.13000000f,0.13000000f,0.46000000f,-0.04000000f,-0.01000000f,-0.61000000f,-0.76000000f,-0.87000000f,-0.25000000f,0.69000000f,-0.29000000f,0.53000000f,-0.59000000f,-0.22000000f,0.22000000f,-0.08000000f,0.77000000f,-0.08000000f,0.65000000f,-0.90000000f,0.19000000f,0.82000000f,-0.26000000f,0.00000000f,0.12000000f,0.22000000f,-0.88000000f,0.52000000f,-0.37000000f,-0.97000000f,0.34000000f,0.94000000f,0.84000000f,0.88000000f,0.35000000f,0.31000000f,-0.22000000f,0.41000000f,-0.96000000f,0.93000000f,-0.43000000f,0.30000000f,-0.20000000f,-0.41000000f,0.96000000f,0.36000000f,-0.88000000f,0.72000000f,0.32000000f,-0.23000000f,0.37000000f,-0.80000000f,0.05000000f,0.52000000f,0.50000000f,-0.94000000f,-0.43000000f,-0.05000000f,-0.44000000f,0.87000000f,-0.11000000f,-0.01000000f,0.85000000f,0.41000000f,0.30000000f,-0.13000000f,-0.02000000f,-0.49000000f,-0.68000000f,-0.15000000f,-0.49000000f,-0.04000000f,-0.40000000f,-0.56000000f,0.32000000f,0.70000000f,-0.38000000f,-0.12000000f,-0.64000000f,-0.69000000f,-0.22000000f,0.40000000f,-0.77000000f,0.44000000f,-0.36000000f,-0.68000000f,-0.45000000f,-0.39000000f,0.00000000f,-0.44000000f,0.73000000f,0.14000000f,-0.21000000f,-0.50000000f,-0.28000000f,0.04000000f,0.25000000f,0.24000000f,-0.70000000f,-0.04000000f,0.78000000f,0.90000000f,-0.37000000f,0.14000000f,-0.31000000f,-0.98000000f,-0.23000000f,0.15000000f,-0.04000000f,-0.43000000f,-0.51000000f,0.34000000f,-0.69000000f,-0.33000000f,-0.00000000f,0.33000000f,0.77000000f,0.55000000f,0.88000000f,0.56000000f,-0.06000000f,0.86000000f,0.61000000f,-0.97000000f,0.42000000f,0.96000000f,-0.23000000f,0.56000000f,-0.82000000f,0.41000000f,0.87000000f,-0.93000000f,-0.40000000f,-0.71000000f,-0.88000000f,0.49000000f,-0.39000000f,-0.66000000f,-0.16000000f,0.57000000f,-0.77000000f,0.15000000f,-0.36000000f,-0.13000000f,0.69000000f,0.36000000f,0.75000000f,-0.84000000f,-0.44000000f,0.77000000f,0.69000000f,-0.89000000f,0.90000000f,-0.91000000f,0.09000000f,0.86000000f,0.27000000f,0.83000000f,0.75000000f,-0.17000000f,0.80000000f,0.40000000f,0.20000000f,-0.40000000f,0.87000000f,-0.85000000f,-0.47000000f,-0.40000000f,-0.47000000f,-0.17000000f,-0.42000000f,-0.14000000f,-0.83000000f,0.04000000f,0.80000000f,0.72000000f,-0.07000000f,-0.24000000f,-0.32000000f,0.91000000f,-0.67000000f,0.27000000f,0.65000000f,0.68000000f,-0.94000000f,-0.88000000f,-0.27000000f,0.74000000f,-0.36000000f,0.88000000f,-0.78000000f,0.44000000f,-0.31000000f,0.21000000f,0.57000000f,0.01000000f,0.25000000f,-0.02000000f,0.44000000f,-0.88000000f,0.96000000f,-0.91000000f,0.66000000f,0.88000000f,0.97000000f,0.53000000f,-0.90000000f,0.07000000f,0.70000000f,-0.41000000f,-0.52000000f,-0.00000000f,-0.48000000f,0.27000000f,-0.19000000f,0.96000000f,-0.00000000f,0.23000000f,0.13000000f,-0.56000000f,-0.69000000f,0.66000000f,0.19000000f,-0.79000000f,0.87000000f,0.91000000f,-0.35000000f,-0.67000000f,0.01000000f,-0.64000000f,-0.48000000f,0.77000000f,0.29000000f,-0.32000000f,-0.36000000f,-0.07000000f,-0.36000000f,-0.03000000f,0.51000000f,-0.99000000f,0.42000000f,-0.95000000f,0.31000000f,0.96000000f,0.58000000f,0.91000000f,0.96000000f,0.42000000f,-0.76000000f,-0.73000000f,-0.52000000f,0.64000000f,0.24000000f,-0.28000000f,-0.50000000f,0.56000000f,0.50000000f,0.41000000f,0.54000000f,0.10000000f,0.10000000f,-0.57000000f,-0.73000000f,0.50000000f,0.36000000f,-0.71000000f,0.49000000f,-0.08000000f,-0.33000000f,-0.78000000f,-0.77000000f,0.84000000f,0.40000000f,0.91000000f,-0.39000000f,0.26000000f,-0.76000000f,-0.25000000f,-0.15000000f,-0.07000000f,-0.34000000f,0.82000000f,-0.94000000f,0.21000000f,-0.99000000f,0.33000000f,0.79000000f,-0.41000000f,0.71000000f,-0.40000000f,0.87000000f,0.82000000f,-0.34000000f,-0.99000000f,0.35000000f,-0.41000000f,0.10000000f,0.60000000f,0.84000000f,-0.28000000f,0.46000000f,0.63000000f,-0.47000000f,-0.24000000f,-0.05000000f,-0.92000000f,0.55000000f,0.59000000f,-0.23000000f,0.92000000f,0.86000000f,-0.16000000f,-0.51000000f,-0.63000000f,-0.34000000f,0.56000000f,-0.98000000f,-0.07000000f,0.64000000f,-0.83000000f,0.71000000f,0.40000000f,-0.47000000f,-0.67000000f,0.80000000f,-0.64000000f,0.86000000f,-0.00000000f,-0.64000000f,-0.54000000f,0.53000000f,-0.54000000f,0.13000000f,-0.73000000f,0.71000000f,0.44000000f,0.62000000f,0.17000000f,0.80000000f,0.82000000f,-0.87000000f,-0.54000000f,-0.56000000f,0.35000000f,0.02000000f,0.18000000f,-0.06000000f,-0.00000000f,0.13000000f,0.16000000f,0.18000000f,-0.11000000f,0.35000000f,0.70000000f,0.84000000f,0.48000000f,-0.03000000f,0.07000000f,0.20000000f,-0.84000000f,-0.18000000f,-0.30000000f,0.79000000f,-0.88000000f,-0.28000000f,0.64000000f,0.70000000f,-0.05000000f,-0.18000000f,0.59000000f,-0.87000000f,-0.98000000f,0.57000000f,0.11000000f,0.84000000f,-0.33000000f,0.55000000f,-0.89000000f,-0.07000000f,-0.64000000f,-0.17000000f,0.74000000f,0.70000000f,-0.54000000f,0.42000000f,-0.64000000f,-0.74000000f,-0.90000000f,-0.40000000f,0.69000000f,0.62000000f,0.26000000f,0.50000000f,-0.61000000f,0.60000000f,0.54000000f,0.23000000f,0.30000000f,0.68000000f,0.96000000f,-0.19000000f,0.38000000f,-0.73000000f,0.04000000f,-0.44000000f,0.51000000f,0.87000000f,0.56000000f,0.72000000f,0.26000000f,-0.61000000f,-0.36000000f,0.67000000f,0.64000000f,-0.67000000f,-0.85000000f,-0.30000000f,0.37000000f,-0.34000000f,-0.00000000f,0.30000000f,0.86000000f,-0.19000000f,0.08000000f,0.46000000f,-0.14000000f,0.45000000f,-0.52000000f,0.40000000f,-0.69000000f,-0.60000000f,-0.53000000f,-0.35000000f,-0.15000000f,-0.01000000f,-0.93000000f,-0.97000000f,0.48000000f,0.10000000f,0.64000000f,0.61000000f,-0.02000000f,-0.32000000f,0.67000000f,0.30000000f,-0.73000000f,-0.75000000f,-0.24000000f,0.43000000f,-0.68000000f,-0.09000000f,0.76000000f,-0.50000000f,-0.85000000f,-0.94000000f,-0.73000000f,0.85000000f,-0.73000000f,-0.93000000f,0.52000000f,-0.67000000f,0.67000000f,0.15000000f,0.25000000f,0.24000000f,-0.06000000f,-0.20000000f,-0.43000000f,0.77000000f,-0.09000000f,0.81000000f,0.28000000f,0.32000000f,-0.34000000f,0.15000000f,0.95000000f,0.48000000f,0.37000000f,-0.39000000f,0.92000000f,0.06000000f,0.97000000f,-0.59000000f,0.93000000f,-0.22000000f,-0.16000000f,-0.29000000f,0.00000000f,0.70000000f,-0.78000000f,0.56000000f,-0.05000000f,0.39000000f,0.23000000f,-0.89000000f,0.29000000f,-0.08000000f,-0.67000000f,-0.51000000f,-0.09000000f,0.64000000f,-0.75000000f,-0.89000000f,0.91000000f,-0.05000000f,-0.33000000f,0.84000000f,-0.74000000f,-0.95000000f,-0.12000000f,0.59000000f,0.27000000f,0.03000000f,0.98000000f,-0.16000000f,0.63000000f,0.24000000f,0.65000000f,-0.64000000f,-0.89000000f,0.27000000f,0.55000000f,-0.22000000f,-0.27000000f,0.68000000f,0.89000000f,-0.78000000f,0.36000000f,-0.98000000f,-0.53000000f,0.44000000f,0.72000000f,-0.00000000f,-0.08000000f,-0.58000000f,0.96000000f,0.05000000f,-0.75000000f,0.69000000f,0.14000000f,-0.55000000f,0.83000000f,-0.66000000f,0.30000000f,-0.85000000f,0.63000000f,0.03000000f,-0.10000000f,0.73000000f,0.04000000f,0.70000000f,-0.95000000f,-0.52000000f,-0.45000000f,0.97000000f,-0.16000000f,-0.31000000f,-0.61000000f,-0.55000000f,0.58000000f,0.20000000f,-0.17000000f,-0.80000000f,0.75000000f,-0.31000000f,-0.48000000f,0.81000000f,-0.61000000f,0.59000000f,-0.21000000f,-0.16000000f,0.15000000f,-0.84000000f,0.90000000f,-0.53000000f,0.82000000f,0.17000000f,-0.75000000f,-0.51000000f,-0.00000000f,-0.00000000f,-0.07000000f,-0.25000000f,-0.40000000f,-0.09000000f,-0.39000000f,0.50000000f,-0.63000000f,0.76000000f,-0.80000000f,0.03000000f,0.44000000f,-0.18000000f,-0.75000000f,0.08000000f,0.55000000f,0.22000000f,-0.88000000f,0.47000000f,0.32000000f,0.40000000f,0.58000000f,-0.08000000f,0.50000000f,0.40000000f,0.41000000f,-0.28000000f,0.40000000f,-0.30000000f,-0.39000000f,0.32000000f,0.78000000f,0.56000000f,-0.55000000f,0.08000000f,-0.50000000f,-0.94000000f,-0.69000000f,0.88000000f,-0.97000000f,-0.67000000f,0.98000000f,0.44000000f,-0.78000000f,0.08000000f,-0.66000000f,0.83000000f,-0.84000000f,0.93000000f,-0.55000000f,0.03000000f,-0.25000000f,-0.91000000f,-0.95000000f,0.88000000f,-0.19000000f,-0.23000000f,0.67000000f,-0.21000000f,-0.03000000f,-0.10000000f,-0.77000000f,-0.27000000f,0.19000000f,-0.37000000f,0.95000000f,0.29000000f,-0.43000000f,0.94000000f,0.47000000f,0.96000000f,-0.92000000f,0.26000000f,-0.20000000f,-0.00000000f,-0.55000000f,0.37000000f,-0.76000000f,-0.02000000f,-0.30000000f,-0.47000000f,0.65000000f,-0.14000000f,0.09000000f,-0.26000000f,-0.19000000f,-0.63000000f,-0.28000000f,0.58000000f,0.87000000f,0.87000000f,0.50000000f,0.73000000f,0.96000000f,-0.16000000f,0.55000000f,0.68000000f,-0.62000000f,-0.81000000f,0.32000000f,-0.47000000f,0.29000000f,0.53000000f,-0.19000000f,-0.98000000f,-0.41000000f,0.29000000f,-0.48000000f,-0.16000000f,0.11000000f,0.09000000f,-0.27000000f,-0.97000000f,0.95000000f,0.36000000f,-0.66000000f,-0.68000000f,0.41000000f,0.01000000f,0.07000000f,-0.85000000f,0.13000000f,-0.02000000f,0.31000000f,-0.53000000f,-0.13000000f,-0.29000000f,-0.43000000f,0.68000000f,0.14000000f,0.85000000f,-0.57000000f,-0.63000000f,-0.46000000f,-0.44000000f,-0.70000000f,-0.27000000f,0.68000000f,0.68000000f,0.90000000f,-0.59000000f,0.33000000f,0.63000000f,0.40000000f,0.69000000f,0.26000000f,0.44000000f,-0.91000000f,-0.00000000f,-0.60000000f,-0.45000000f,-0.51000000f,0.42000000f,0.53000000f,-0.19000000f,-0.97000000f,-0.79000000f,0.98000000f,0.99000000f,-0.05000000f,-0.17000000f,0.16000000f,-0.77000000f,0.14000000f,0.34000000f,0.15000000f,0.15000000f,-0.00000000f,0.27000000f,-0.17000000f,0.68000000f,0.37000000f,0.50000000f,-0.14000000f,-0.03000000f,-0.70000000f,-0.06000000f,-0.33000000f,0.50000000f,0.57000000f,-0.37000000f,-0.96000000f,-0.89000000f,-0.43000000f,-0.45000000f,0.11000000f,-0.33000000f,-0.19000000f,-0.62000000f,0.81000000f,0.56000000f,-0.38000000f,0.69000000f,0.61000000f,-0.30000000f,-0.58000000f,-0.67000000f,-0.72000000f,-0.83000000f,0.64000000f,0.94000000f,-0.61000000f,0.83000000f,-0.43000000f,-0.73000000f,-0.67000000f,0.96000000f,-0.73000000f,0.61000000f,0.89000000f,-0.97000000f,0.80000000f,0.30000000f,-0.42000000f,0.92000000f,0.81000000f,0.03000000f,0.48000000f,0.98000000f,-0.04000000f,-0.68000000f,0.13000000f,0.90000000f,0.17000000f,0.59000000f,0.48000000f,-0.40000000f,-0.70000000f,-0.25000000f,-0.46000000f,0.69000000f,-0.02000000f,-0.53000000f,-0.60000000f,0.55000000f,-0.49000000f,-0.47000000f,-0.83000000f,0.59000000f,-0.26000000f,0.21000000f,0.86000000f,-0.51000000f,-0.26000000f,0.59000000f,-0.18000000f,-0.93000000f,0.55000000f,-0.20000000f,-0.92000000f,0.87000000f,0.95000000f,-0.32000000f,0.84000000f,0.78000000f,0.43000000f,0.56000000f,0.43000000f,0.36000000f,0.14000000f,-0.19000000f,-0.84000000f,-0.30000000f,0.48000000f,0.63000000f,-0.62000000f,-0.54000000f,-0.28000000f,-0.08000000f,0.06000000f,0.71000000f,0.64000000f,0.60000000f,0.88000000f,-0.68000000f,-0.91000000f,-0.03000000f,0.79000000f,0.69000000f,-0.51000000f,-0.24000000f,0.95000000f,-0.41000000f,0.01000000f,0.97000000f,0.94000000f,-0.74000000f,0.28000000f,0.55000000f,-0.48000000f,-0.63000000f,-0.85000000f,-0.70000000f,0.56000000f,0.37000000f,0.96000000f,-0.80000000f,-0.08000000f,0.39000000f,0.92000000f,-0.02000000f,0.85000000f,-0.28000000f,-0.14000000f,0.81000000f,0.35000000f,-0.17000000f,-0.39000000f,0.12000000f,0.36000000f,-0.06000000f,0.88000000f,-0.59000000f,-0.25000000f,-0.50000000f,-0.34000000f,0.71000000f,-0.72000000f,-0.75000000f,0.40000000f,0.29000000f,0.29000000f,0.61000000f,0.49000000f,-0.79000000f,0.05000000f,0.03000000f,0.48000000f,0.58000000f,-0.38000000f,0.98000000f,0.60000000f,-0.79000000f,-0.15000000f,-0.24000000f,0.37000000f,0.51000000f,0.95000000f,-0.94000000f,0.30000000f,-0.58000000f,0.62000000f,0.57000000f,-0.86000000f,0.69000000f,-0.18000000f,-0.29000000f,0.33000000f,0.56000000f,-0.37000000f,0.02000000f,0.12000000f,-0.97000000f,0.80000000f,-0.46000000f,0.55000000f,-0.82000000f,-0.60000000f,-0.86000000f,-0.80000000f,0.60000000f,-0.09000000f,-0.51000000f,-0.46000000f,-0.86000000f,-0.46000000f,-0.30000000f,-0.86000000f,0.33000000f,0.31000000f,-0.73000000f,-0.83000000f,0.33000000f,0.35000000f,-0.26000000f,0.58000000f,0.75000000f,0.89000000f,-0.10000000f,-0.55000000f,-0.37000000f,0.51000000f,0.14000000f,-0.37000000f,0.58000000f,0.08000000f,0.54000000f,0.37000000f,0.43000000f,-0.03000000f,0.18000000f,-0.48000000f,0.27000000f,-0.22000000f,0.57000000f,-0.27000000f,-0.89000000f,0.05000000f,0.53000000f,-0.71000000f,-0.12000000f,-0.53000000f,0.57000000f,-0.38000000f,-0.22000000f,0.49000000f,-0.47000000f,0.58000000f,-0.26000000f,-0.15000000f,0.47000000f,0.32000000f,0.97000000f,-0.82000000f,0.70000000f,0.15000000f,-0.08000000f,0.16000000f,-0.76000000f,0.14000000f,-0.75000000f,-0.49000000f,0.68000000f,-0.31000000f,0.02000000f,0.20000000f,0.66000000f,0.16000000f,-0.10000000f,0.13000000f,-0.48000000f,-0.78000000f,-0.81000000f,-0.61000000f,-0.84000000f,-0.23000000f,-0.65000000f,0.18000000f,0.72000000f,0.50000000f,-0.09000000f,0.56000000f,0.97000000f,-0.98000000f,-0.49000000f,0.59000000f,0.37000000f,0.32000000f,-0.61000000f,0.24000000f,-0.76000000f,-0.36000000f,-0.69000000f,0.02000000f,-0.29000000f,0.22000000f,0.70000000f,0.49000000f,-0.99000000f,-0.88000000f,0.28000000f,-0.38000000f,0.17000000f,0.73000000f,-0.86000000f,-0.17000000f,-0.79000000f,0.84000000f,0.47000000f,0.86000000f,-0.23000000f,-0.03000000f,-0.69000000f,-0.38000000f,-0.92000000f,-0.86000000f,-0.46000000f,-0.11000000f,0.32000000f,0.37000000f,-0.29000000f,-0.41000000f,-0.05000000f,-0.11000000f,0.48000000f,-0.16000000f,-0.74000000f,-0.83000000f,-0.07000000f,-0.04000000f,0.14000000f,0.31000000f,0.39000000f,-0.91000000f,0.64000000f,-0.05000000f,0.22000000f,-0.61000000f,-0.70000000f,-0.82000000f,-0.45000000f,0.31000000f,-0.48000000f,-0.31000000f,0.61000000f,-0.31000000f,0.40000000f,0.86000000f,-0.92000000f,0.16000000f,0.02000000f,0.49000000f,-0.60000000f,-0.72000000f,0.71000000f,0.03000000f,-0.67000000f,0.27000000f,0.94000000f,0.06000000f,0.47000000f,0.24000000f,-0.72000000f,-0.41000000f,0.08000000f,0.83000000f,-0.81000000f,-0.61000000f,-0.48000000f,0.08000000f,-0.06000000f,0.35000000f,-0.65000000f,0.91000000f,-0.77000000f,-0.90000000f,0.38000000f,-0.42000000f,-0.48000000f,0.37000000f,-0.71000000f,0.36000000f,0.57000000f,-0.08000000f,0.36000000f,-0.87000000f,0.70000000f,-0.53000000f,-0.00000000f,0.65000000f,-0.73000000f,0.19000000f,-0.09000000f,0.42000000f,0.74000000f,-0.29000000f,-0.31000000f,-0.66000000f,-0.01000000f,-0.40000000f,0.71000000f,-0.36000000f,0.69000000f,0.67000000f,-0.86000000f,0.64000000f,-0.02000000f,0.06000000f,0.49000000f,0.42000000f,0.34000000f,-0.35000000f,-0.58000000f,-0.94000000f,-0.17000000f,0.54000000f,-0.91000000f,-0.31000000f,0.54000000f,-0.19000000f,0.69000000f,-0.39000000f,0.65000000f,0.18000000f,-0.54000000f,0.64000000f,0.43000000f,-0.12000000f,0.44000000f,-0.95000000f,-0.62000000f,0.15000000f,-0.71000000f,0.00000000f,-0.33000000f,-0.30000000f,-0.32000000f,-0.36000000f,0.44000000f,-0.96000000f,-0.65000000f,0.02000000f,-0.21000000f,0.34000000f,0.03000000f,0.10000000f,-0.13000000f,0.58000000f,0.40000000f,0.10000000f,0.75000000f,-0.32000000f,-0.22000000f,-0.48000000f,0.87000000f,-0.03000000f,-0.02000000f,0.82000000f,0.06000000f,0.56000000f,0.41000000f,0.16000000f,0.41000000f,-0.52000000f,0.38000000f,-0.09000000f,0.07000000f,-0.42000000f,0.70000000f,-0.16000000f,-0.13000000f,0.22000000f,0.83000000f,0.56000000f,-0.03000000f,0.20000000f,-0.34000000f,-0.52000000f,0.50000000f,0.73000000f,0.34000000f,0.05000000f,-0.39000000f,0.61000000f,0.67000000f,-0.63000000f,0.27000000f,-0.73000000f,-0.73000000f,0.84000000f,-0.65000000f,-0.51000000f,-0.05000000f,-0.46000000f,-0.38000000f,-0.00000000f,0.38000000f,-0.40000000f,-0.52000000f,0.51000000f,-0.63000000f,-0.40000000f,-0.02000000f,0.39000000f,0.18000000f,0.60000000f,0.30000000f,0.32000000f,0.23000000f,0.77000000f,0.21000000f,0.12000000f,0.49000000f,0.30000000f,0.72000000f,-0.85000000f,0.96000000f,0.23000000f,-0.08000000f,0.57000000f,0.20000000f,0.87000000f,0.99000000f,0.54000000f,-0.76000000f,0.11000000f,0.97000000f,-0.10000000f,0.19000000f,-0.45000000f,-0.12000000f,0.85000000f,-0.21000000f,0.69000000f,0.71000000f,-0.61000000f,0.01000000f,-0.73000000f,-0.61000000f,0.51000000f,0.33000000f,-0.71000000f,0.76000000f,0.67000000f,0.35000000f,-0.51000000f,-0.62000000f,-0.46000000f,0.28000000f,-0.80000000f,0.62000000f,0.65000000f,-0.11000000f,0.87000000f,0.24000000f,-0.97000000f,0.60000000f,-0.03000000f,-0.83000000f,0.32000000f,-0.49000000f,-0.94000000f,-0.42000000f,-0.47000000f,0.50000000f,0.34000000f,0.84000000f,0.11000000f,-0.86000000f,-0.24000000f,0.69000000f,-0.53000000f,0.89000000f,0.00000000f,0.08000000f,-0.81000000f,-0.07000000f,-0.18000000f,-0.52000000f,-0.39000000f,-0.94000000f,0.04000000f,0.89000000f,-0.30000000f,0.44000000f,-0.68000000f,0.49000000f,0.40000000f,0.65000000f,-0.80000000f,-0.72000000f,0.42000000f,-0.49000000f,0.91000000f,0.45000000f,0.26000000f,0.60000000f,0.00000000f,0.20000000f,0.27000000f,-0.00000000f,0.27000000f,0.91000000f,0.44000000f,0.84000000f,0.81000000f,-0.09000000f,0.38000000f,-0.49000000f,0.56000000f,0.04000000f,0.54000000f,-0.79000000f,0.05000000f,0.56000000f,0.34000000f,-0.20000000f,0.12000000f,0.00000000f,0.48000000f,0.18000000f,0.15000000f,-0.86000000f,0.57000000f,-0.03000000f,-0.12000000f,0.56000000f,-0.33000000f,-0.80000000f,0.03000000f,0.00000000f,0.90000000f,0.00000000f,0.50000000f,0.15000000f,-0.09000000f,-0.43000000f,0.17000000f,-0.28000000f,0.21000000f,-0.86000000f,-0.41000000f,0.69000000f,-0.40000000f,0.11000000f,-0.95000000f,-0.08000000f,-0.98000000f,-0.67000000f,0.73000000f,-0.97000000f,-0.67000000f,-0.09000000f,0.52000000f,-0.25000000f,0.26000000f,0.09000000f,-0.66000000f,-0.16000000f,0.01000000f,0.86000000f,-0.11000000f,-0.78000000f,0.15000000f,-0.02000000f,-0.23000000f,0.18000000f,0.91000000f,0.29000000f,0.21000000f,-0.53000000f,-0.65000000f,0.79000000f,-0.68000000f,0.87000000f,-0.22000000f,-0.07000000f,-0.43000000f,0.50000000f,0.26000000f,0.05000000f,0.55000000f,-0.30000000f,-0.16000000f,-0.43000000f,0.56000000f,-0.16000000f,0.03000000f,-0.92000000f,0.32000000f,-0.69000000f,0.05000000f,-0.34000000f,-0.90000000f,0.67000000f,-0.24000000f,-0.24000000f,0.97000000f,0.18000000f,-0.31000000f,-0.45000000f,-0.98000000f,0.94000000f,0.84000000f,0.52000000f,0.80000000f,0.71000000f,-0.26000000f,0.04000000f,-0.78000000f,0.10000000f,-0.21000000f,-0.21000000f,0.42000000f,-0.36000000f,-0.98000000f,-0.29000000f,-0.79000000f,-0.29000000f,-0.89000000f,-0.82000000f,0.17000000f,-0.11000000f,0.59000000f,-0.30000000f,0.43000000f,0.40000000f,0.54000000f,-0.35000000f,-0.60000000f,-0.30000000f,0.61000000f,0.52000000f,0.20000000f,-0.40000000f,0.07000000f,0.81000000f,0.50000000f,0.00000000f,0.26000000f,0.06000000f,0.01000000f,-0.43000000f,0.68000000f,-0.25000000f,-0.28000000f,0.01000000f,0.29000000f,0.87000000f,0.68000000f,0.18000000f,-0.26000000f,-0.16000000f,-0.43000000f,-0.59000000f,0.74000000f,0.91000000f,0.33000000f,0.88000000f,0.07000000f,-0.67000000f,0.26000000f,-0.88000000f,-0.31000000f,-0.25000000f,0.63000000f,0.08000000f,-0.60000000f,-0.08000000f,-0.29000000f,-0.41000000f,-0.12000000f,-0.65000000f,-0.20000000f,-0.73000000f,0.50000000f,-0.50000000f,-0.55000000f,0.80000000f,0.01000000f,-0.47000000f,-0.33000000f,0.52000000f,-0.59000000f,-0.61000000f,0.99000000f,-0.94000000f,0.32000000f,-0.50000000f,-0.41000000f,0.66000000f,-0.06000000f,-0.30000000f,0.79000000f,0.33000000f,0.21000000f,-0.79000000f,0.09000000f,0.66000000f,-0.13000000f,-0.32000000f,0.05000000f,0.32000000f,0.07000000f,-0.11000000f,-0.16000000f,0.72000000f,0.69000000f,0.76000000f,-0.14000000f,-0.96000000f,-0.26000000f,0.93000000f,0.84000000f,-0.00000000f,0.23000000f,-0.68000000f,0.65000000f,0.64000000f,-0.37000000f,0.94000000f,-0.70000000f,-0.04000000f,-0.39000000f,0.90000000f,-0.62000000f,0.02000000f,0.88000000f,0.77000000f,-0.40000000f,0.01000000f,-0.45000000f,-0.92000000f,-0.18000000f,0.79000000f,0.52000000f,0.86000000f,0.57000000f,-0.39000000f,-0.39000000f,-0.47000000f,0.47000000f,-0.70000000f,-0.10000000f,0.27000000f,0.99000000f,-0.62000000f,-0.11000000f,-0.99000000f,-0.68000000f,0.81000000f,-0.94000000f,0.08000000f,-0.01000000f,0.42000000f,0.50000000f,0.05000000f,0.67000000f,0.87000000f,-0.11000000f,-0.55000000f,-0.20000000f,0.12000000f,-0.77000000f,0.50000000f,-0.46000000f,-0.69000000f,-0.76000000f,-0.21000000f,-0.49000000f,0.08000000f,-0.29000000f,-0.44000000f,0.59000000f,0.17000000f,-0.34000000f,0.57000000f,-0.00000000f,-0.21000000f,0.65000000f,0.04000000f,-0.26000000f,-0.73000000f,0.95000000f,0.28000000f,-0.33000000f,-0.95000000f,-0.55000000f,-0.52000000f,-0.93000000f,0.57000000f,-0.56000000f,-0.50000000f,-0.62000000f,-0.73000000f,0.94000000f,-0.37000000f,0.04000000f,-0.09000000f,-0.12000000f,-0.71000000f,-0.38000000f,-0.08000000f,-0.56000000f,0.27000000f,0.45000000f,-0.47000000f,0.84000000f,0.24000000f,-0.76000000f,-0.10000000f,0.96000000f,0.72000000f,0.67000000f,0.04000000f,0.91000000f,0.50000000f,0.29000000f,-0.34000000f,-0.87000000f,0.00000000f,-0.74000000f,0.76000000f,-0.20000000f,0.38000000f,0.54000000f,-0.69000000f,0.54000000f,-0.24000000f,-0.16000000f,0.79000000f,-0.17000000f,0.53000000f,-0.25000000f,-0.54000000f,0.40000000f,-0.78000000f,-0.41000000f,-0.25000000f,0.85000000f,0.70000000f,-0.77000000f,-0.23000000f,-0.96000000f,0.75000000f,0.52000000f,0.59000000f,-0.85000000f,0.70000000f,-0.23000000f,-0.71000000f,-0.22000000f,0.87000000f,0.44000000f,0.57000000f,0.75000000f,0.44000000f,-0.44000000f,0.45000000f,0.41000000f,-0.90000000f,-0.86000000f,0.51000000f,0.56000000f,-0.41000000f,-0.55000000f,0.53000000f,0.78000000f,-0.71000000f,-0.43000000f,-0.20000000f,0.98000000f,-0.39000000f,-0.42000000f,-0.52000000f,0.40000000f,-0.67000000f,-0.32000000f,0.12000000f,0.95000000f,0.99000000f,-0.75000000f,0.97000000f,-0.33000000f,-0.24000000f,0.31000000f,-0.50000000f,-0.54000000f,-0.20000000f,0.92000000f,-0.81000000f,0.38000000f,-0.62000000f,-0.39000000f,0.82000000f,0.91000000f,-0.75000000f,0.03000000f,-0.06000000f,-0.61000000f,-0.17000000f,-0.91000000f,0.27000000f,0.30000000f,-0.75000000f,-0.51000000f,0.50000000f,0.60000000f,-0.96000000f,-0.91000000f,-0.52000000f,0.34000000f,0.92000000f,0.31000000f,-0.02000000f,0.89000000f,0.93000000f,-0.77000000f,0.53000000f,0.98000000f,0.01000000f,0.45000000f,0.56000000f,-0.41000000f,0.38000000f,-0.96000000f,0.72000000f,-0.11000000f,-0.05000000f,0.88000000f,-0.78000000f,-0.27000000f,-0.68000000f,-0.41000000f,-0.16000000f,-0.08000000f,0.70000000f,0.16000000f,0.13000000f,-0.29000000f,0.53000000f,-0.52000000f,-0.75000000f,0.99000000f,0.73000000f,0.11000000f,0.11000000f,-0.05000000f,0.27000000f,-0.87000000f,-0.19000000f,-0.59000000f,-0.73000000f,0.74000000f,-0.18000000f,0.13000000f,-0.32000000f,0.55000000f,0.03000000f,-0.20000000f,0.45000000f,-0.06000000f,-0.10000000f,-0.86000000f,0.94000000f,-0.63000000f,0.88000000f,0.23000000f,0.28000000f,-0.62000000f,-0.59000000f,0.76000000f,0.41000000f,-0.29000000f,0.55000000f,0.01000000f,0.36000000f,0.33000000f,0.06000000f,0.67000000f,-0.63000000f,-0.36000000f,0.77000000f,-0.72000000f,0.76000000f,-0.87000000f,0.95000000f,-0.28000000f,-0.83000000f,-0.67000000f,-0.64000000f,-0.49000000f,0.55000000f,0.06000000f,0.90000000f,-0.01000000f,-0.58000000f,0.94000000f,-0.76000000f,-0.24000000f,0.58000000f,-0.99000000f,0.17000000f,-0.14000000f,0.65000000f,-0.80000000f,0.77000000f,-0.18000000f,-0.37000000f,0.07000000f,-0.71000000f,-0.31000000f,0.43000000f,0.59000000f,-0.52000000f,-0.73000000f,-0.17000000f,0.04000000f,-0.25000000f,-0.62000000f,0.90000000f,0.40000000f,-0.60000000f,-0.31000000f,0.52000000f,-0.60000000f,0.90000000f,0.78000000f,0.13000000f,-0.27000000f,-0.71000000f,0.71000000f,0.24000000f,0.93000000f,-0.39000000f,0.33000000f,-0.02000000f,0.45000000f,0.61000000f,-0.50000000f,0.81000000f,0.95000000f,-0.70000000f,0.72000000f,0.03000000f,-0.16000000f,0.07000000f,-0.28000000f,-0.83000000f,0.84000000f,-0.48000000f,-0.42000000f,0.62000000f,0.62000000f,0.39000000f,0.88000000f,0.03000000f,-0.41000000f,-0.49000000f,-0.80000000f,-0.60000000f,0.55000000f,0.83000000f,-0.02000000f,-0.69000000f,-0.19000000f,0.65000000f,0.49000000f,-0.32000000f,-0.28000000f,0.05000000f,-0.40000000f,-0.03000000f,-0.39000000f,0.48000000f,-0.75000000f,-0.02000000f,-0.91000000f,-0.25000000f,0.33000000f,0.80000000f,-0.30000000f,-0.14000000f,-0.36000000f,0.61000000f,0.82000000f,0.48000000f,0.31000000f,-0.87000000f,0.45000000f,0.06000000f,0.15000000f,0.08000000f,-0.39000000f,0.10000000f,-0.21000000f,0.63000000f,-0.47000000f,0.55000000f,0.47000000f,0.90000000f,0.32000000f,-0.29000000f,0.79000000f,-0.76000000f,0.75000000f,-0.90000000f,0.56000000f,0.92000000f,-0.04000000f,-0.73000000f,-0.75000000f,-0.68000000f,-0.74000000f,0.99000000f,-0.68000000f,-0.49000000f,0.31000000f,0.76000000f,-0.76000000f,-0.03000000f,-0.95000000f,-0.75000000f,-0.89000000f,-0.32000000f,0.91000000f,-0.34000000f,0.58000000f,-0.43000000f,0.33000000f,-0.88000000f,-0.32000000f,0.90000000f,0.23000000f,-0.40000000f,-0.86000000f,0.81000000f,0.26000000f,-0.90000000f,0.78000000f,-0.61000000f,0.65000000f,-0.75000000f,0.69000000f,-0.29000000f,-0.17000000f,-0.92000000f,0.84000000f,0.80000000f,-0.35000000f,0.53000000f,0.73000000f,-0.60000000f,-0.75000000f,-0.46000000f,-0.68000000f,-0.13000000f,0.80000000f,-0.21000000f,0.38000000f,0.89000000f,-0.53000000f,0.34000000f,-0.32000000f,0.71000000f,0.08000000f,-0.43000000f,0.27000000f,-0.17000000f,0.48000000f,0.75000000f,-0.89000000f,-0.47000000f,-0.94000000f,-0.23000000f,0.52000000f,-0.47000000f,0.34000000f,-0.84000000f,-0.81000000f,-0.14000000f,0.36000000f,-0.73000000f,-0.35000000f,-0.06000000f,-0.66000000f,-0.16000000f,-0.84000000f,-0.95000000f,-0.52000000f,-0.02000000f,-0.28000000f,0.85000000f,0.91000000f,-0.61000000f,-0.16000000f,-0.82000000f,0.10000000f,0.19000000f,-0.51000000f,0.04000000f,-0.23000000f,0.74000000f,-0.18000000f,0.31000000f,-0.63000000f,-0.37000000f,-0.27000000f,-0.95000000f,-0.36000000f,-0.32000000f,-0.85000000f,0.52000000f,0.16000000f,0.75000000f,-0.68000000f,-0.99000000f,-0.18000000f,-0.82000000f,0.90000000f,0.61000000f,-0.96000000f,0.55000000f,0.61000000f,-0.82000000f,0.15000000f,0.21000000f,-0.46000000f,0.06000000f,0.35000000f,0.95000000f,0.25000000f,-0.10000000f,-0.08000000f,0.58000000f,0.14000000f,-0.54000000f,0.21000000f,0.48000000f,0.53000000f,0.09000000f,0.75000000f,0.82000000f,-0.12000000f,-0.45000000f,0.65000000f,0.29000000f,-0.04000000f,0.43000000f,0.84000000f,-0.97000000f,0.04000000f,-0.14000000f,-0.02000000f,0.09000000f,-0.46000000f,0.01000000f,-0.90000000f,-0.54000000f,-0.71000000f,-0.03000000f,-0.45000000f,-0.02000000f,-0.49000000f,-0.71000000f,0.06000000f,-0.48000000f,0.90000000f,0.83000000f,0.20000000f,0.42000000f,-0.99000000f,-0.11000000f,0.53000000f,-0.35000000f,-0.01000000f,0.67000000f,-0.68000000f,-0.08000000f,-0.52000000f,0.44000000f,-0.61000000f,-0.58000000f,-0.15000000f,-0.47000000f,0.90000000f,0.37000000f,-0.05000000f,-0.52000000f,0.54000000f,0.88000000f,0.19000000f,-0.36000000f,0.19000000f,0.82000000f,0.04000000f,-0.37000000f,0.36000000f,0.97000000f,-0.93000000f,0.97000000f,-0.82000000f,0.28000000f,0.17000000f,-0.19000000f,0.17000000f,-0.24000000f,-0.69000000f,0.48000000f,-0.01000000f,0.43000000f,-0.70000000f,0.98000000f,-0.49000000f,-0.51000000f,0.97000000f,0.05000000f,-0.87000000f,0.57000000f,-0.93000000f,-0.45000000f,0.78000000f,-0.22000000f,0.70000000f,0.91000000f,-0.54000000f,0.67000000f,-0.53000000f,-0.01000000f,0.38000000f,0.99000000f,-0.56000000f,0.85000000f,0.67000000f,0.88000000f,-0.02000000f,0.33000000f,-0.00000000f,0.74000000f,0.33000000f,-0.37000000f,-0.92000000f,0.79000000f,-0.93000000f,0.24000000f,0.18000000f,-0.56000000f,-0.83000000f,-0.22000000f,0.79000000f,-0.04000000f,0.54000000f,-0.11000000f,-0.40000000f,0.27000000f,0.44000000f,0.50000000f,0.24000000f,0.96000000f,-0.02000000f,0.24000000f,0.18000000f,-0.95000000f,-0.03000000f,0.93000000f,-0.15000000f,0.86000000f,-0.24000000f,-0.30000000f,0.80000000f,-0.05000000f,0.91000000f,0.55000000f,0.05000000f,0.44000000f,-0.43000000f,0.00000000f,-0.96000000f,-0.55000000f,0.52000000f,-0.11000000f,-0.56000000f,-0.08000000f,0.91000000f,0.05000000f,-0.70000000f,0.13000000f,0.43000000f,0.07000000f,0.81000000f,-0.49000000f,0.14000000f,-0.89000000f,-0.38000000f,0.19000000f,0.57000000f,0.94000000f,0.66000000f,0.98000000f,0.75000000f,0.37000000f,-0.12000000f,0.12000000f,0.96000000f,0.40000000f,-0.10000000f,-0.64000000f,-0.88000000f,-0.64000000f,0.95000000f,-0.81000000f,0.61000000f,-0.97000000f,-0.68000000f,-0.73000000f,-0.00000000f,-0.69000000f,-0.99000000f,0.73000000f,-0.09000000f,-0.49000000f,0.22000000f,0.04000000f,0.77000000f,0.79000000f,-0.06000000f,-0.35000000f,0.06000000f,0.81000000f,-0.03000000f,-0.05000000f,0.47000000f,0.27000000f,-0.74000000f,-0.59000000f,0.82000000f,0.47000000f,0.80000000f,0.80000000f,0.58000000f,-0.87000000f,0.05000000f,0.50000000f,-0.26000000f,-0.50000000f,-0.84000000f,0.12000000f,0.62000000f,0.66000000f,-0.77000000f,-0.10000000f,0.74000000f,0.66000000f,-0.07000000f,0.73000000f,0.74000000f,0.52000000f,0.10000000f,-0.78000000f,0.24000000f,0.92000000f,0.02000000f,-0.12000000f,0.80000000f,0.60000000f,0.76000000f,0.96000000f,0.57000000f,0.94000000f,-0.37000000f,-0.01000000f,-0.20000000f,-0.95000000f,-0.37000000f,-0.61000000f,0.74000000f,0.82000000f,0.31000000f,0.32000000f,-0.47000000f,-0.91000000f,-0.60000000f,-0.78000000f,0.19000000f,-0.65000000f,0.44000000f,-0.63000000f,-0.19000000f,-0.62000000f,0.39000000f,-0.58000000f,-0.80000000f,-0.47000000f,0.29000000f,-0.31000000f,0.19000000f,0.13000000f,0.59000000f,-0.52000000f,0.32000000f,0.71000000f,-0.69000000f,-0.21000000f,-0.94000000f,-0.80000000f,-0.82000000f,-0.81000000f,-0.92000000f,-0.08000000f,-0.68000000f,0.19000000f,0.31000000f,-0.02000000f,-0.60000000f,0.97000000f,-0.71000000f,0.21000000f,-0.18000000f,0.19000000f,0.83000000f,0.79000000f,-0.18000000f,-0.91000000f,-0.77000000f,-0.80000000f,-0.00000000f,0.08000000f,0.30000000f,-0.86000000f,-0.88000000f,-0.01000000f,-0.88000000f,0.71000000f,-0.80000000f,-0.54000000f,0.43000000f,-0.68000000f,-0.56000000f,0.32000000f,0.05000000f,0.21000000f,-0.51000000f,0.17000000f,-0.42000000f,0.01000000f,0.00000000f,0.03000000f,0.16000000f,-0.77000000f,0.62000000f,-0.91000000f,-0.70000000f,-0.42000000f,-0.49000000f,0.46000000f,-0.82000000f,0.97000000f,-0.49000000f,-0.49000000f,0.42000000f,0.23000000f,-0.19000000f,0.23000000f,0.99000000f,-0.57000000f,-0.93000000f,-0.46000000f,0.05000000f,-0.86000000f,0.23000000f,0.94000000f,-0.68000000f,0.73000000f,0.08000000f,0.33000000f,0.63000000f,0.65000000f,0.11000000f,0.41000000f,-0.16000000f,-0.05000000f,0.80000000f,0.65000000f,0.07000000f,-0.76000000f,-0.69000000f,0.34000000f,0.18000000f,0.69000000f,0.58000000f,0.67000000f,0.56000000f,0.02000000f,-0.72000000f,0.07000000f,0.38000000f,-0.30000000f,0.59000000f,0.00000000f,-0.67000000f,0.52000000f,0.40000000f,0.60000000f,-0.26000000f,-0.16000000f,-0.99000000f,-0.89000000f,0.48000000f,0.03000000f,-0.59000000f,-0.62000000f,-0.51000000f,0.10000000f,0.79000000f,0.47000000f,0.66000000f,0.23000000f,-0.51000000f,-0.08000000f,-0.84000000f,-0.38000000f,0.27000000f,0.11000000f,-0.46000000f,0.50000000f,-0.75000000f,-0.49000000f,-0.44000000f,-0.86000000f,-0.46000000f,0.70000000f,-0.21000000f,-0.33000000f,-0.69000000f,0.91000000f,0.79000000f,0.29000000f,-0.90000000f,0.70000000f,-0.92000000f,-0.49000000f,0.85000000f,-0.58000000f,-0.71000000f,0.53000000f,0.88000000f,0.29000000f,0.35000000f,0.75000000f,-0.23000000f,0.90000000f,-0.49000000f,0.04000000f,0.07000000f,0.13000000f,-0.12000000f,-0.84000000f,-0.09000000f,-0.19000000f,-0.26000000f,-0.73000000f,-0.66000000f,-0.83000000f,-0.14000000f,0.38000000f,-0.95000000f,0.39000000f,-0.69000000f,0.46000000f,0.44000000f,0.53000000f,-0.38000000f,0.01000000f,-0.41000000f,0.10000000f,0.90000000f,-0.36000000f,0.58000000f,0.41000000f,0.11000000f,-0.73000000f,0.14000000f,0.97000000f,0.89000000f,-0.24000000f,0.49000000f,0.65000000f,-0.52000000f,0.63000000f,-0.82000000f,0.34000000f,0.95000000f,-0.90000000f,-0.19000000f,-0.48000000f,-0.05000000f,-0.92000000f,-0.48000000f,-0.09000000f,-0.72000000f,0.64000000f,-0.92000000f,0.64000000f,-0.85000000f,-0.78000000f,-0.44000000f,-0.67000000f,-0.48000000f,0.91000000f,-0.45000000f,0.23000000f,-0.35000000f,-0.10000000f,0.49000000f,0.65000000f,0.29000000f,0.03000000f,0.59000000f,-0.92000000f,0.24000000f,0.48000000f,0.86000000f,0.29000000f,0.77000000f,0.40000000f,-0.56000000f,-0.27000000f,-0.99000000f,0.95000000f,0.99000000f,-0.65000000f,0.71000000f,0.21000000f,-0.14000000f,0.51000000f,0.25000000f,-0.31000000f,0.73000000f,0.37000000f,0.62000000f,0.58000000f,-0.81000000f,-0.68000000f,0.41000000f,-0.88000000f,-0.20000000f,0.40000000f,-0.71000000f,-0.71000000f,0.97000000f,-0.28000000f,-0.73000000f,0.36000000f,-0.57000000f,-0.56000000f,-0.33000000f,0.98000000f,-0.32000000f,0.25000000f,-0.85000000f,-0.16000000f,-0.14000000f,-0.17000000f,-0.57000000f,0.12000000f,0.03000000f,-0.77000000f,0.12000000f,-0.58000000f,-0.90000000f,0.51000000f,-0.29000000f,-0.47000000f,0.89000000f,-0.81000000f,0.69000000f,0.70000000f,-0.40000000f,0.15000000f,-0.66000000f,0.54000000f,-0.75000000f,-0.81000000f,-0.87000000f,-0.26000000f,0.31000000f,-0.56000000f,-0.15000000f,0.04000000f,-0.86000000f,0.07000000f,0.19000000f,-0.80000000f,-0.94000000f,0.04000000f,-0.01000000f,0.87000000f,0.83000000f,-0.44000000f,-0.77000000f,-0.73000000f,0.24000000f,-0.87000000f,-0.61000000f,0.85000000f,0.40000000f,-0.83000000f,0.18000000f,-0.88000000f,0.49000000f,-0.27000000f,-0.25000000f,-0.59000000f,-0.47000000f,-0.91000000f,-0.81000000f,-0.60000000f,-0.73000000f,0.78000000f,-0.81000000f,0.70000000f,0.20000000f,0.44000000f,-0.60000000f,-0.82000000f,-0.56000000f,0.90000000f,0.08000000f,-0.00000000f,0.06000000f,0.17000000f,-0.42000000f,0.34000000f,0.80000000f,-0.92000000f,0.02000000f,0.44000000f,-0.54000000f,0.45000000f,0.69000000f,-0.19000000f,-0.06000000f,0.32000000f,-0.38000000f,0.72000000f,0.96000000f,0.47000000f,-0.56000000f,-0.50000000f,0.09000000f,-0.60000000f,-0.92000000f,0.10000000f,-0.34000000f,0.16000000f,0.74000000f,0.03000000f,-0.54000000f,0.63000000f,0.60000000f,0.69000000f,0.20000000f,-0.43000000f,0.31000000f,-0.68000000f,-0.64000000f,-0.46000000f,0.61000000f,-0.74000000f,0.56000000f,0.11000000f,-0.44000000f,-0.02000000f,-0.38000000f,-0.96000000f,0.95000000f,0.38000000f,0.24000000f,-0.74000000f,0.91000000f,-0.54000000f,-0.61000000f,0.67000000f,0.38000000f,0.91000000f,0.05000000f,-0.53000000f,-0.08000000f,0.04000000f,-0.86000000f,-0.90000000f,-0.92000000f,0.08000000f,-0.49000000f,0.22000000f,0.92000000f,0.76000000f,-0.30000000f,0.85000000f,-0.76000000f,0.15000000f,0.28000000f,-0.52000000f,-0.16000000f,0.84000000f,0.48000000f,0.70000000f,0.62000000f,-0.52000000f,0.37000000f,-0.43000000f,0.52000000f,-0.87000000f,0.91000000f,0.13000000f,0.15000000f,0.10000000f,0.62000000f,0.72000000f,-0.69000000f,-0.53000000f,-0.09000000f,-0.37000000f,0.76000000f,-0.76000000f,-0.50000000f,0.86000000f,-0.17000000f,-0.73000000f,-0.39000000f,-0.05000000f,0.91000000f,-0.26000000f,0.39000000f,-0.69000000f,0.26000000f,0.97000000f,-0.23000000f,0.61000000f,0.77000000f,-0.28000000f,0.17000000f,0.32000000f,0.85000000f,-0.80000000f,-0.85000000f,-0.03000000f,-0.59000000f,-0.91000000f,0.28000000f,-0.14000000f,0.46000000f,-0.53000000f,-0.75000000f,-0.84000000f,0.52000000f,-0.35000000f,-0.97000000f,0.94000000f,-0.44000000f,-0.26000000f,0.54000000f,-0.51000000f,0.41000000f,0.41000000f,0.89000000f,-0.54000000f,-0.27000000f,0.72000000f,-0.34000000f,0.01000000f,0.19000000f,0.23000000f,-0.30000000f,-0.61000000f,-0.39000000f,-0.11000000f,0.45000000f,-0.22000000f,-0.66000000f,0.06000000f,0.15000000f,0.46000000f,-0.00000000f,0.91000000f,0.25000000f,0.37000000f,-0.13000000f,0.26000000f,0.08000000f,0.78000000f,-0.77000000f,-0.68000000f,0.21000000f,-0.80000000f,0.02000000f,0.33000000f,0.65000000f,0.33000000f,0.02000000f,-0.97000000f,0.01000000f,-0.47000000f,-0.48000000f,0.46000000f,-0.70000000f,0.47000000f,0.01000000f,-0.98000000f,0.49000000f,-0.12000000f,-0.62000000f,-0.45000000f,0.57000000f,-0.05000000f,0.91000000f,0.29000000f,-0.85000000f,-0.14000000f,-0.51000000f,-0.31000000f,0.48000000f,0.81000000f,-0.11000000f,0.10000000f,0.72000000f,0.27000000f,-0.97000000f,0.24000000f,-0.18000000f,-0.09000000f,-0.77000000f,-0.70000000f,0.98000000f,0.50000000f,0.58000000f,0.10000000f,-0.19000000f,0.12000000f,0.05000000f,0.77000000f,0.17000000f,-0.38000000f,-0.17000000f,0.15000000f,-0.18000000f,0.45000000f,0.10000000f,0.86000000f,0.23000000f,-0.74000000f,-0.18000000f,0.41000000f,0.30000000f,-0.75000000f,-0.25000000f,-0.29000000f,0.86000000f,-0.21000000f,0.34000000f,-0.62000000f,0.89000000f,-0.04000000f,-0.34000000f,-0.04000000f,0.38000000f,-0.59000000f,0.02000000f,0.52000000f,0.84000000f,0.14000000f,0.48000000f,-0.89000000f,-0.86000000f,0.12000000f,-0.07000000f,-0.21000000f,-0.94000000f,-0.36000000f,-0.49000000f,0.26000000f,0.70000000f,0.45000000f,0.16000000f,-0.98000000f,-0.85000000f,-0.38000000f,-0.01000000f,-0.31000000f,-0.23000000f,-0.16000000f,0.93000000f,-0.68000000f,0.12000000f,-0.92000000f,-0.55000000f,-0.15000000f,-0.68000000f,-0.59000000f,-0.57000000f,0.79000000f,-0.21000000f,0.17000000f,-0.14000000f,-0.30000000f,-0.35000000f,0.07000000f,-0.15000000f,-0.25000000f,-0.04000000f,0.01000000f,0.28000000f,-0.54000000f,0.85000000f,-0.59000000f,-0.69000000f,-0.18000000f,0.42000000f,-0.93000000f,-0.02000000f,-0.69000000f,0.94000000f,0.11000000f,-0.33000000f,0.34000000f,0.25000000f,-0.77000000f,-0.82000000f,0.33000000f,-0.29000000f,-0.68000000f,-0.52000000f,-0.49000000f,0.57000000f,0.47000000f,-0.60000000f,-0.45000000f,0.69000000f,0.82000000f,-0.15000000f,-0.83000000f,-0.07000000f,-0.79000000f,-0.63000000f,-0.42000000f,-0.62000000f,-0.25000000f,0.78000000f,0.69000000f,0.32000000f,0.36000000f,0.73000000f,0.52000000f,-0.74000000f,-0.11000000f,0.04000000f,-0.96000000f,-0.50000000f,-0.47000000f,-0.88000000f,-0.26000000f,0.67000000f,-0.59000000f,-0.33000000f,0.78000000f,-0.59000000f,0.21000000f,0.13000000f,-0.31000000f,-0.19000000f,0.15000000f,0.26000000f,-0.40000000f,0.43000000f,-0.96000000f,0.75000000f,-0.61000000f,-0.04000000f,0.66000000f,-0.10000000f,0.65000000f,0.12000000f,-0.20000000f,0.98000000f,0.99000000f,-0.75000000f,0.51000000f,0.93000000f,-0.27000000f,0.02000000f,-0.85000000f,-0.62000000f,-0.35000000f,-0.04000000f,0.96000000f,0.85000000f,0.89000000f,-0.38000000f,-0.68000000f,0.02000000f,-0.88000000f,-0.67000000f,0.00000000f,0.92000000f,-0.88000000f,0.56000000f,0.46000000f,-0.72000000f,0.66000000f,0.80000000f,0.48000000f,0.19000000f,0.27000000f,0.15000000f,-0.77000000f,-0.45000000f,-0.94000000f,0.11000000f,0.37000000f,0.22000000f,-0.54000000f,-0.27000000f,-0.67000000f,-0.76000000f,-0.15000000f,-0.20000000f,0.93000000f,-0.05000000f,0.27000000f,0.20000000f,0.72000000f,-0.40000000f,-0.72000000f,-0.49000000f,0.81000000f,0.06000000f,0.83000000f,0.09000000f,0.08000000f,-0.65000000f,-0.26000000f,0.74000000f,-0.22000000f,-0.96000000f,-0.62000000f,-0.45000000f,0.60000000f,-0.10000000f,0.17000000f,0.12000000f,-0.17000000f,-0.74000000f,0.08000000f,0.12000000f,-0.64000000f,0.68000000f,0.92000000f,0.00000000f,-0.04000000f,0.31000000f,-0.83000000f,-0.47000000f,-0.55000000f,-0.89000000f,-0.42000000f,-0.96000000f,-0.62000000f,0.19000000f,-0.47000000f,0.19000000f,-0.46000000f,-0.70000000f,0.39000000f,-0.10000000f,-0.82000000f,0.19000000f,-0.06000000f,-0.47000000f,-0.03000000f,-0.46000000f,0.22000000f,-0.76000000f,0.34000000f,-0.80000000f,0.31000000f,0.41000000f,0.17000000f,0.90000000f,0.47000000f,0.85000000f,-0.94000000f,0.31000000f,-0.81000000f,0.24000000f,0.42000000f,0.20000000f,0.15000000f,-0.24000000f,-0.69000000f,-0.87000000f,-0.65000000f,0.09000000f,-0.25000000f,0.36000000f,-0.38000000f,0.04000000f,-0.80000000f,0.54000000f,0.82000000f,-0.95000000f,0.86000000f,0.40000000f,0.70000000f,-0.34000000f,-0.58000000f,-0.75000000f,-0.37000000f,0.39000000f,-0.62000000f,0.05000000f,-0.76000000f,-0.91000000f,0.65000000f,0.38000000f,0.76000000f,0.36000000f,-0.73000000f,0.06000000f,-0.01000000f,-0.05000000f,0.41000000f,-0.66000000f,0.75000000f,0.56000000f,0.55000000f,-0.09000000f,0.82000000f,0.49000000f,-0.35000000f,0.91000000f,-0.54000000f,0.63000000f,0.00000000f,-0.34000000f,-0.30000000f,-0.08000000f,0.90000000f,0.76000000f,0.41000000f,-0.48000000f,0.95000000f,0.61000000f,0.28000000f,0.41000000f,-0.86000000f,-0.79000000f,0.25000000f,-0.48000000f,0.35000000f,0.22000000f,-0.38000000f,0.33000000f,0.81000000f,-0.85000000f,-0.60000000f,0.87000000f,0.77000000f,0.13000000f,0.90000000f,0.46000000f,0.74000000f,-0.66000000f,0.31000000f,0.00000000f,0.87000000f,0.60000000f,-0.04000000f,0.30000000f,0.61000000f,0.93000000f,0.59000000f,0.19000000f,0.26000000f,-0.93000000f,0.24000000f,0.64000000f,-0.72000000f,0.62000000f,0.31000000f,-0.11000000f,-0.24000000f,0.00000000f,0.79000000f,0.98000000f,-0.43000000f,-0.60000000f,-0.10000000f,0.31000000f,0.38000000f,-0.21000000f,0.81000000f,-0.96000000f,-0.87000000f,-0.66000000f,0.92000000f,0.21000000f,0.53000000f,0.22000000f,-0.25000000f,-0.20000000f,0.02000000f,0.93000000f,0.39000000f,0.38000000f,0.71000000f,-0.38000000f,0.73000000f,0.58000000f,-0.81000000f,0.78000000f,-0.92000000f,-0.26000000f,0.39000000f,0.83000000f,0.85000000f,0.90000000f,-0.26000000f,0.12000000f,-0.40000000f,-0.17000000f,0.54000000f,0.85000000f,-0.38000000f,-0.68000000f,-0.77000000f,0.90000000f,0.08000000f,0.26000000f,0.93000000f,0.52000000f,-0.05000000f,-0.19000000f,-0.64000000f,0.96000000f,0.92000000f,-0.90000000f,0.77000000f,0.05000000f,-0.27000000f,0.76000000f,0.63000000f,-0.15000000f,0.14000000f,0.24000000f,-0.37000000f,-0.39000000f,0.62000000f,-0.68000000f,-0.46000000f,-0.21000000f,-0.72000000f,0.67000000f,-0.75000000f,-0.48000000f,-0.85000000f,-0.06000000f,-0.37000000f,0.07000000f,0.63000000f,0.94000000f,-0.28000000f,-0.88000000f,-0.16000000f,-0.20000000f,-0.23000000f,0.45000000f,-0.02000000f,-0.78000000f,0.76000000f,-0.63000000f,0.09000000f,-0.35000000f,0.91000000f,0.41000000f,-0.89000000f,0.67000000f,0.57000000f,-0.95000000f,0.41000000f,0.62000000f,-0.61000000f,0.17000000f,-0.24000000f,0.34000000f,0.11000000f,-0.25000000f,-0.29000000f,-0.22000000f,0.99000000f,0.73000000f,-0.54000000f,0.39000000f,-0.74000000f,0.32000000f,0.39000000f,-0.40000000f,0.18000000f,0.94000000f,0.94000000f,0.47000000f,0.27000000f,-0.61000000f,-0.62000000f,0.78000000f,0.77000000f,-0.91000000f,0.41000000f,0.67000000f,-0.17000000f,-0.16000000f,0.86000000f,0.50000000f,0.71000000f,0.68000000f,0.54000000f,0.68000000f,0.27000000f,0.35000000f,-0.84000000f,-0.04000000f,-0.06000000f,0.14000000f,0.64000000f,-0.61000000f,-0.51000000f,-0.17000000f,-0.22000000f,-0.55000000f,0.68000000f,0.52000000f,-0.38000000f,-0.18000000f,0.21000000f,0.34000000f,-0.29000000f,-0.85000000f,-0.88000000f,0.92000000f,0.44000000f,-0.02000000f,0.59000000f,-0.06000000f,-0.62000000f,-0.11000000f,-0.72000000f,-0.88000000f,-0.91000000f,-0.59000000f,-0.77000000f,0.67000000f,0.19000000f,0.34000000f,0.05000000f,0.77000000f,0.09000000f,-0.08000000f,-0.60000000f,0.03000000f,0.02000000f,0.00000000f,0.98000000f,0.75000000f,0.96000000f,0.05000000f,-0.09000000f,0.25000000f,-0.53000000f,0.26000000f,0.00000000f,0.26000000f,0.77000000f,0.74000000f,0.38000000f,0.27000000f,0.49000000f,-0.85000000f,0.67000000f,0.59000000f,0.45000000f,0.70000000f,-0.21000000f,0.78000000f,0.74000000f,-0.83000000f,0.85000000f,-0.38000000f,0.78000000f,-0.82000000f,-0.70000000f,-0.36000000f,0.21000000f,0.32000000f,-0.66000000f,-0.33000000f,0.50000000f,0.26000000f,0.59000000f,-0.13000000f,0.86000000f,-0.01000000f,0.52000000f,-0.65000000f,-0.02000000f,-0.82000000f,0.04000000f,0.64000000f,0.62000000f,0.94000000f,0.70000000f,-0.55000000f,-0.03000000f,0.38000000f,-0.45000000f,0.70000000f,-0.17000000f,0.76000000f,0.35000000f,-0.91000000f,-0.85000000f,0.72000000f,-0.18000000f,-0.09000000f,0.54000000f,-0.54000000f,-0.19000000f,-0.97000000f,-0.98000000f,-0.60000000f,0.38000000f,-0.36000000f,0.58000000f,0.56000000f,0.29000000f,0.16000000f,0.27000000f,-0.91000000f,0.53000000f,-0.06000000f,-0.42000000f,0.05000000f,-0.05000000f,0.25000000f,-0.46000000f,0.92000000f,0.37000000f,-0.87000000f,0.14000000f,0.98000000f,-0.33000000f,0.07000000f,0.98000000f,0.16000000f,-0.19000000f,-0.22000000f,-0.45000000f,0.61000000f,-0.77000000f,0.59000000f,0.32000000f,0.34000000f,0.85000000f,0.98000000f,-0.56000000f,-0.46000000f,-0.83000000f,0.64000000f,-0.78000000f,0.33000000f,0.38000000f,0.49000000f,0.90000000f,-0.73000000f,0.50000000f,0.51000000f,-0.25000000f,-0.80000000f,0.17000000f,-0.88000000f,-0.30000000f,0.57000000f,-0.48000000f,-0.83000000f,-0.05000000f,-0.27000000f,-0.28000000f,0.80000000f,-0.26000000f,-0.17000000f,-0.61000000f,0.25000000f,-0.47000000f,-0.65000000f,-0.29000000f,-0.43000000f,-0.88000000f,-0.02000000f,0.97000000f,0.04000000f,0.94000000f,-0.47000000f,0.46000000f,0.19000000f,-0.00000000f,0.70000000f,0.36000000f,0.93000000f,-0.47000000f,-0.85000000f,-0.44000000f,-0.26000000f,-0.44000000f,0.41000000f,-0.50000000f,-0.77000000f,-0.98000000f,0.30000000f,-0.75000000f,-0.53000000f,-0.77000000f,-0.89000000f,0.92000000f,-0.35000000f,0.22000000f,-0.14000000f,-0.50000000f,0.41000000f,0.78000000f,-0.89000000f,0.59000000f,-0.62000000f,-0.82000000f,0.50000000f,0.98000000f,0.85000000f,0.84000000f,0.63000000f,0.40000000f,0.04000000f,0.15000000f,-0.70000000f,0.95000000f,0.10000000f,0.25000000f,-0.02000000f,-0.70000000f,0.88000000f,-0.56000000f,0.56000000f,-0.58000000f,0.52000000f,-0.11000000f,0.02000000f,-0.35000000f,-0.62000000f,-0.15000000f,-0.06000000f,0.15000000f,0.45000000f,-0.99000000f,0.57000000f,-0.19000000f,0.11000000f,0.84000000f,0.02000000f,-0.05000000f,-0.53000000f,0.74000000f,-0.85000000f,-0.07000000f,0.33000000f,0.45000000f,-0.45000000f,-0.74000000f,0.07000000f,0.38000000f,0.60000000f,0.36000000f,0.57000000f,-0.27000000f,-0.54000000f,-0.01000000f,0.68000000f,-0.97000000f,0.67000000f,-0.06000000f,0.67000000f,0.01000000f,0.03000000f,0.65000000f,0.18000000f,-0.81000000f,0.23000000f,0.06000000f,0.45000000f,0.42000000f,-0.17000000f,0.76000000f,-0.27000000f,-0.29000000f,-0.17000000f,0.02000000f,-0.42000000f,-0.46000000f,-0.93000000f,-0.17000000f,-0.78000000f,-0.43000000f,-0.04000000f,-0.69000000f,0.29000000f,0.35000000f,-0.91000000f,-0.97000000f,0.09000000f,0.63000000f,-0.20000000f,0.15000000f,-0.63000000f,-0.96000000f,-0.95000000f,0.60000000f,0.91000000f,0.09000000f,-0.70000000f,0.50000000f,-0.07000000f,0.44000000f,0.01000000f,0.75000000f,0.73000000f,-0.73000000f,0.16000000f,-0.80000000f,0.52000000f,0.64000000f,-0.02000000f,-0.17000000f,0.04000000f,-0.50000000f,0.72000000f,-0.06000000f,0.80000000f,-0.50000000f,-0.78000000f,-0.37000000f,-0.16000000f,-0.06000000f,-0.73000000f,-0.68000000f,-0.45000000f,0.43000000f,-0.41000000f,-0.01000000f,-0.75000000f,0.41000000f,-0.94000000f,0.86000000f,-0.33000000f,0.65000000f,-0.82000000f,-0.53000000f,-0.19000000f,-0.21000000f,0.75000000f,0.39000000f,-0.52000000f,-0.82000000f,0.05000000f,0.29000000f,-0.84000000f,-0.03000000f,-0.05000000f,-0.92000000f,0.66000000f,0.14000000f,0.19000000f,-0.98000000f,0.09000000f,0.48000000f,0.96000000f,0.39000000f,0.67000000f,-0.49000000f,0.42000000f,0.30000000f,0.84000000f,-0.46000000f,-0.41000000f,0.92000000f,-0.93000000f,0.51000000f,-0.90000000f,-0.54000000f,-0.32000000f,0.18000000f,-0.83000000f,-0.05000000f,0.78000000f,-0.76000000f,0.76000000f,-0.50000000f,-0.94000000f,-0.58000000f,0.52000000f,0.45000000f,-0.17000000f,0.62000000f,0.48000000f,0.85000000f,0.11000000f,0.74000000f,0.99000000f,0.94000000f,-0.77000000f,0.44000000f,-0.89000000f,0.97000000f,-0.77000000f,0.16000000f,-0.35000000f,0.16000000f,-0.45000000f,0.50000000f,-0.96000000f,0.74000000f,-0.52000000f,-0.64000000f,0.13000000f,-0.21000000f,-0.03000000f,-0.16000000f,0.35000000f,0.53000000f,-0.82000000f,0.34000000f,0.52000000f,-0.59000000f,-0.17000000f,-0.53000000f,-0.88000000f,0.67000000f,0.13000000f,-0.21000000f,0.93000000f,-0.45000000f,-0.11000000f,-0.60000000f,0.84000000f,0.16000000f,0.76000000f,0.01000000f,0.89000000f,0.87000000f,0.04000000f,0.86000000f,0.20000000f,0.20000000f,0.61000000f,-0.21000000f,0.04000000f,0.26000000f,0.91000000f,-0.40000000f,0.00000000f,-0.26000000f,-0.12000000f,0.35000000f,0.21000000f,-0.87000000f,0.81000000f,-0.03000000f,-0.82000000f,0.19000000f,-0.71000000f,0.93000000f,0.39000000f,-0.70000000f,-0.97000000f,0.20000000f,0.92000000f,0.13000000f,-0.81000000f,0.88000000f,0.34000000f,-0.27000000f,-0.46000000f,0.78000000f,0.94000000f,-0.50000000f,0.57000000f,0.06000000f,-0.52000000f,0.14000000f,0.33000000f,-0.34000000f,-0.31000000f,-0.05000000f,-0.73000000f,0.13000000f,-0.63000000f,0.88000000f,-0.44000000f,-0.15000000f,0.11000000f,0.90000000f,-0.36000000f,0.51000000f,-0.38000000f,-0.64000000f,-0.21000000f,0.13000000f,0.89000000f,0.81000000f,-0.69000000f,0.15000000f,-0.67000000f,-0.89000000f,-0.47000000f,0.73000000f,-0.15000000f,-0.97000000f,-0.24000000f,-0.57000000f,0.91000000f,-0.64000000f,-0.30000000f,0.67000000f,-0.55000000f,-0.68000000f,0.98000000f,-0.98000000f,0.96000000f,-0.36000000f,-0.55000000f,0.11000000f,-0.73000000f,0.57000000f,0.73000000f,-0.46000000f,-0.11000000f,0.52000000f,0.48000000f,0.06000000f,0.43000000f,-0.41000000f,-0.43000000f,0.58000000f,-0.69000000f,0.57000000f,0.71000000f,-0.73000000f,0.19000000f,-0.45000000f,-0.24000000f,0.96000000f,0.61000000f,0.66000000f,-0.50000000f,-0.46000000f,0.32000000f,0.43000000f,0.15000000f,-0.93000000f,0.77000000f,0.60000000f,-0.27000000f,-0.37000000f,0.31000000f,-0.69000000f,0.20000000f,-0.22000000f,0.90000000f,0.51000000f,-0.56000000f,-0.50000000f,-0.55000000f,0.64000000f,-0.03000000f,0.70000000f,0.90000000f,-0.83000000f,-0.11000000f,-0.70000000f,0.82000000f,0.62000000f,0.66000000f,0.26000000f,0.24000000f,-0.55000000f,0.72000000f,0.42000000f,0.58000000f,0.60000000f,-0.02000000f,-0.29000000f,0.73000000f,-0.04000000f,-0.45000000f,0.01000000f,-0.04000000f,-0.59000000f,0.86000000f,-0.29000000f,0.82000000f,0.56000000f,-0.76000000f,-0.58000000f,0.77000000f,0.96000000f,-0.28000000f,0.71000000f,0.19000000f,-0.26000000f,0.98000000f,0.32000000f,-0.75000000f,-0.24000000f,0.85000000f,-0.26000000f,-0.73000000f,0.49000000f,0.26000000f,-0.74000000f,0.08000000f,-0.53000000f,-0.58000000f,0.52000000f,0.41000000f,0.06000000f,0.20000000f,0.47000000f,-0.41000000f,0.14000000f,0.00000000f,0.94000000f,0.76000000f,-0.41000000f,-0.90000000f,0.92000000f,-0.29000000f,0.52000000f,-0.94000000f,0.37000000f,0.87000000f,-0.06000000f,-0.44000000f,-0.33000000f,-0.04000000f,0.78000000f,-0.55000000f,-0.23000000f,0.25000000f,0.08000000f,0.41000000f,-0.48000000f,0.05000000f,-0.37000000f,0.39000000f,-0.74000000f,-0.89000000f,0.51000000f,-0.80000000f,-0.70000000f,-0.94000000f,0.32000000f,-0.43000000f,-0.75000000f,0.63000000f,-0.33000000f,-0.67000000f,-0.33000000f,0.18000000f,0.65000000f,0.34000000f,0.92000000f,0.08000000f,0.92000000f,0.04000000f,-0.33000000f,-0.59000000f,0.62000000f,0.85000000f,-0.49000000f,0.39000000f,-0.37000000f,-0.04000000f,-0.11000000f,0.23000000f,-0.41000000f,-0.84000000f,0.71000000f,-0.35000000f,0.88000000f,0.70000000f,0.94000000f,0.19000000f,0.85000000f,-0.35000000f,0.84000000f,-0.99000000f,-0.70000000f,0.57000000f,-0.78000000f,-0.96000000f,-0.55000000f,0.79000000f,0.67000000f,0.09000000f,-0.28000000f,-0.11000000f,0.22000000f,0.92000000f,0.79000000f,-0.70000000f,-0.62000000f,0.56000000f,-0.70000000f,-0.15000000f,0.18000000f,0.65000000f,0.97000000f,-0.87000000f,-0.04000000f,-0.75000000f,-0.65000000f,0.12000000f,-0.09000000f,0.85000000f,0.98000000f,0.58000000f,0.09000000f,-0.06000000f,0.70000000f,0.19000000f,-0.89000000f,-0.53000000f,-0.26000000f,-0.79000000f,-0.07000000f,0.19000000f,-0.68000000f,0.72000000f,0.87000000f,-0.10000000f,0.68000000f,-0.12000000f,-0.44000000f,0.26000000f,-0.30000000f,0.36000000f,-0.98000000f,-0.76000000f,-0.93000000f,0.93000000f,-0.68000000f,-0.39000000f,-0.06000000f,0.87000000f,-0.19000000f,0.60000000f,0.96000000f,0.91000000f,0.05000000f,-0.95000000f,0.13000000f,0.35000000f,0.87000000f,0.67000000f,-0.48000000f,0.26000000f,0.19000000f,0.74000000f,-0.53000000f,-0.54000000f,0.60000000f,0.08000000f,0.50000000f,0.18000000f,0.89000000f,0.89000000f,-0.19000000f,0.10000000f,0.72000000f,-0.13000000f,-0.38000000f,-0.45000000f,0.19000000f,0.33000000f,-0.01000000f,-0.34000000f,-0.28000000f,-0.42000000f,-0.39000000f,0.48000000f,0.11000000f,-0.66000000f,0.22000000f,-0.08000000f,0.71000000f,0.86000000f,0.02000000f,-0.02000000f,0.39000000f,-0.86000000f,-0.51000000f,0.50000000f,-0.42000000f,0.12000000f,0.44000000f,-0.47000000f,-0.43000000f,0.11000000f,-0.92000000f,-0.07000000f,0.83000000f,-0.69000000f,-0.28000000f,-0.13000000f,0.05000000f,-0.49000000f,0.07000000f,-0.34000000f,0.18000000f,-0.42000000f,0.57000000f,0.44000000f,0.57000000f,0.45000000f,0.97000000f,-0.57000000f,0.30000000f,-0.87000000f,-0.90000000f,-0.11000000f,-0.14000000f,0.89000000f,0.74000000f,0.35000000f,0.30000000f,-0.16000000f,-0.17000000f,0.23000000f,-0.63000000f,-0.95000000f,0.79000000f,-0.39000000f,0.38000000f,0.34000000f,-0.69000000f,-0.45000000f,-0.34000000f,0.96000000f,-0.02000000f,-0.77000000f,0.15000000f,0.37000000f,-0.61000000f,-0.83000000f,0.48000000f,-0.57000000f,0.52000000f,-0.71000000f,-0.02000000f,-0.83000000f,0.34000000f,0.29000000f,-0.05000000f,0.73000000f,-0.15000000f,0.89000000f,-0.17000000f,-0.81000000f,0.59000000f,0.11000000f,0.92000000f,0.31000000f,0.71000000f,-0.89000000f,-0.70000000f,0.31000000f,0.75000000f,-0.59000000f,-0.89000000f,-0.81000000f,-0.81000000f,0.23000000f,0.12000000f,0.26000000f,0.56000000f,0.01000000f,0.24000000f,-0.26000000f,0.61000000f,-0.58000000f,0.57000000f,-0.95000000f,-0.46000000f,0.78000000f,0.06000000f,-0.32000000f,0.88000000f,0.84000000f,-0.25000000f,-0.25000000f,-0.32000000f,0.48000000f,0.28000000f,-0.14000000f,0.48000000f,0.29000000f,0.67000000f,0.89000000f,0.97000000f,0.54000000f,-0.46000000f,0.19000000f,0.67000000f,-0.27000000f,0.19000000f,-0.64000000f,0.68000000f,0.30000000f,0.24000000f,-0.61000000f,-0.28000000f,-0.26000000f,0.32000000f,-0.30000000f,-0.72000000f,0.01000000f,0.19000000f,-0.35000000f,-0.56000000f,-0.02000000f,0.17000000f,0.45000000f,0.07000000f,-0.07000000f,-0.75000000f,0.21000000f,-0.19000000f,0.21000000f,0.89000000f,-0.13000000f,0.51000000f,0.70000000f,-0.00000000f,-0.92000000f,-0.64000000f,0.26000000f,-0.13000000f,0.69000000f,0.28000000f,-0.47000000f,-0.78000000f,-0.32000000f,0.01000000f,0.15000000f,0.36000000f,-0.28000000f,-0.35000000f,0.31000000f,-0.47000000f,0.53000000f,0.51000000f,0.23000000f,0.35000000f,0.97000000f,0.23000000f,-0.09000000f,0.81000000f,-0.26000000f,0.08000000f,-0.17000000f,-0.41000000f,0.78000000f,-0.51000000f,0.16000000f,-0.27000000f,0.05000000f,-0.30000000f,0.32000000f,0.51000000f,0.19000000f,0.94000000f,0.60000000f,0.10000000f,0.21000000f,0.49000000f,-0.69000000f,0.23000000f,-0.87000000f,0.64000000f,-0.36000000f,-0.53000000f,-0.63000000f,-0.05000000f,-0.95000000f,0.23000000f,0.85000000f,-0.32000000f,-0.11000000f,-0.89000000f,-0.13000000f,0.31000000f,0.28000000f,-0.69000000f,-0.37000000f,-0.47000000f,-0.79000000f,0.78000000f,-0.90000000f,0.91000000f,-0.86000000f,0.05000000f,-0.86000000f,-0.74000000f,0.19000000f,0.68000000f,-0.56000000f,0.04000000f,0.10000000f,-0.35000000f,0.47000000f,-0.79000000f,-0.28000000f,0.46000000f,-0.11000000f,0.60000000f,0.72000000f,-0.47000000f,0.03000000f,0.63000000f,0.75000000f,-0.84000000f,0.40000000f,-0.25000000f,-0.72000000f,0.63000000f,-0.22000000f,-0.96000000f,0.43000000f,-0.61000000f,0.73000000f,-0.58000000f,0.78000000f,-0.11000000f,-0.30000000f,-0.59000000f,-0.11000000f,0.01000000f,0.44000000f,0.35000000f,0.42000000f,-0.84000000f,0.13000000f,0.63000000f,0.37000000f,-0.45000000f,0.86000000f,0.90000000f,0.08000000f,-0.50000000f,0.89000000f,0.54000000f,0.50000000f,-0.17000000f,-0.89000000f,-0.72000000f,0.60000000f,-0.75000000f,0.75000000f,-0.79000000f,0.60000000f,0.56000000f,-0.67000000f,0.75000000f,-0.70000000f,-0.15000000f,-0.09000000f,-0.27000000f,0.44000000f,0.74000000f,-0.97000000f,-0.72000000f,0.47000000f,0.83000000f,0.60000000f,-0.97000000f,0.32000000f,0.24000000f,0.33000000f,0.65000000f,0.74000000f,-0.10000000f,0.19000000f,0.30000000f,-0.94000000f,0.07000000f,-0.04000000f,-0.47000000f,0.56000000f,-0.94000000f,0.01000000f,-0.65000000f,-0.18000000f,0.41000000f,-0.34000000f,-0.42000000f,0.56000000f,0.40000000f,-0.17000000f,-0.98000000f,0.62000000f,0.27000000f,-0.27000000f,0.25000000f,0.26000000f,0.41000000f,-0.17000000f,0.18000000f,-0.67000000f,-0.17000000f,-0.78000000f,0.52000000f,0.83000000f,0.04000000f,-0.14000000f,0.35000000f,0.73000000f,0.14000000f,0.72000000f,-0.26000000f,0.83000000f,-0.60000000f,-0.61000000f,0.89000000f,0.30000000f,0.07000000f,0.82000000f,-0.79000000f,-0.68000000f,-0.42000000f,-0.40000000f,-0.99000000f,-0.86000000f,0.48000000f,0.44000000f,0.50000000f,0.51000000f,0.16000000f,-0.77000000f,-0.15000000f,-0.70000000f,0.64000000f,0.97000000f,-0.71000000f,-0.54000000f,0.23000000f,-0.23000000f,0.83000000f,0.53000000f,-0.58000000f,0.62000000f,-0.32000000f,0.84000000f,-0.66000000f,0.95000000f,0.76000000f,0.92000000f,0.48000000f,-0.81000000f,0.43000000f,0.08000000f,-0.67000000f,0.46000000f,0.30000000f,0.23000000f,0.01000000f,0.55000000f,0.02000000f,0.81000000f,0.56000000f,-0.34000000f,-0.69000000f,0.05000000f,-0.99000000f,0.96000000f,-0.84000000f,0.34000000f,0.88000000f,0.01000000f,0.44000000f,-0.19000000f,0.28000000f,0.39000000f,-0.70000000f,-0.24000000f,-0.83000000f,0.44000000f,0.09000000f,-0.08000000f,0.42000000f,0.09000000f,0.24000000f,-0.86000000f,-0.21000000f,-0.90000000f,-0.87000000f,-0.91000000f,0.29000000f,-0.61000000f,-0.84000000f,0.36000000f,-0.40000000f,-0.45000000f,0.46000000f,0.05000000f,-0.55000000f,0.24000000f,0.99000000f,-0.20000000f,0.18000000f,-0.16000000f,0.45000000f,0.90000000f,0.38000000f,-0.37000000f,0.24000000f,0.90000000f,-0.55000000f,0.09000000f,-0.53000000f,-0.14000000f,0.66000000f,-0.59000000f,-0.70000000f,0.24000000f,0.17000000f,0.24000000f,-0.65000000f,0.76000000f,0.32000000f,0.49000000f,-0.65000000f,0.55000000f,-0.59000000f,-0.31000000f,0.78000000f,-0.67000000f,-0.29000000f,-0.60000000f,0.31000000f,0.26000000f,-0.02000000f,0.87000000f,-0.31000000f,0.95000000f,0.14000000f,0.76000000f,-0.89000000f,0.26000000f,0.74000000f,-0.41000000f,0.10000000f,-0.93000000f,-0.42000000f,-0.60000000f,-0.96000000f,-0.31000000f,0.90000000f,-0.20000000f,0.68000000f,-0.57000000f,0.86000000f,-0.71000000f,0.68000000f,0.26000000f,0.75000000f,0.79000000f,0.09000000f,0.94000000f,0.20000000f,0.11000000f,-0.27000000f,-0.06000000f,0.23000000f,0.43000000f,-0.44000000f,-0.87000000f,0.56000000f,-0.34000000f,0.37000000f,-0.49000000f,-0.47000000f,0.10000000f,0.53000000f,0.80000000f,0.53000000f,-0.44000000f,-0.92000000f,0.79000000f,-0.89000000f,0.50000000f,0.82000000f,-0.09000000f,-0.14000000f,-0.88000000f,0.16000000f,-0.15000000f,0.81000000f,-0.96000000f,0.99000000f,0.30000000f,0.09000000f,-0.84000000f,-0.61000000f,0.41000000f,-0.68000000f,0.54000000f,-0.86000000f,-0.87000000f,-0.55000000f,0.69000000f,0.67000000f,-0.43000000f,0.09000000f,0.47000000f,0.85000000f,-0.36000000f,0.27000000f,-0.10000000f,0.93000000f,0.34000000f,-0.77000000f,0.45000000f,-0.37000000f,0.71000000f,0.82000000f,-0.98000000f,0.42000000f,-0.07000000f,0.50000000f,0.66000000f,0.62000000f,0.13000000f,-0.53000000f,-0.83000000f,-0.38000000f,-0.03000000f,-0.49000000f,-0.10000000f,0.21000000f,0.89000000f,-0.90000000f,0.55000000f,-0.62000000f,0.42000000f,0.45000000f,-0.17000000f,-0.04000000f,-0.22000000f,-0.20000000f,-0.10000000f,0.42000000f,0.97000000f,-0.08000000f,-0.58000000f,-0.25000000f,0.02000000f,-0.08000000f,-0.38000000f,0.89000000f,-0.65000000f,0.46000000f,-0.35000000f,-0.54000000f,0.92000000f,0.03000000f,0.58000000f,-0.00000000f,-0.40000000f,-0.55000000f,0.99000000f,-0.46000000f,-0.17000000f,0.17000000f,-0.05000000f,-0.28000000f,0.57000000f,-0.15000000f,-0.41000000f,0.24000000f,0.64000000f,0.55000000f,-0.43000000f,-0.52000000f,0.79000000f,0.59000000f,0.23000000f,-0.41000000f,-0.87000000f,0.82000000f,-0.26000000f,-0.10000000f,-0.14000000f,-0.93000000f,-0.03000000f,-0.51000000f,0.17000000f,-0.53000000f,-0.27000000f,-0.64000000f,0.28000000f,-0.98000000f,0.03000000f,-0.06000000f,0.22000000f,0.65000000f,0.93000000f,0.18000000f,-0.60000000f,0.74000000f,0.13000000f,0.79000000f,-0.20000000f,-0.12000000f,0.08000000f,-0.93000000f,-0.82000000f,0.61000000f,-0.68000000f,0.17000000f,-0.66000000f,0.23000000f,-0.62000000f,-0.23000000f,0.65000000f,0.42000000f,0.29000000f,-0.46000000f,0.97000000f,-0.42000000f,0.85000000f,-0.18000000f,-0.68000000f,0.13000000f,-0.50000000f,0.83000000f,0.59000000f,-0.44000000f,-0.14000000f,0.74000000f,0.46000000f,-0.27000000f,0.38000000f,-0.06000000f,-0.34000000f,-0.52000000f,0.66000000f,0.95000000f,0.69000000f,-0.09000000f,-0.37000000f,-0.35000000f,0.57000000f,0.19000000f,-0.65000000f,-0.70000000f,0.43000000f,-0.01000000f,0.24000000f,0.83000000f,0.28000000f,0.37000000f,-0.18000000f,-0.50000000f,0.10000000f,0.80000000f,0.04000000f,0.11000000f,0.02000000f,-0.44000000f,0.30000000f,0.91000000f,-0.42000000f,0.04000000f,-0.48000000f,-0.25000000f,-0.79000000f,-0.20000000f,0.33000000f,0.22000000f,-0.55000000f,-0.73000000f,0.25000000f,0.53000000f,0.57000000f,0.40000000f,0.53000000f,-0.69000000f,0.86000000f,0.78000000f,0.90000000f,0.79000000f,-0.52000000f,-0.90000000f,-0.16000000f,0.88000000f,0.40000000f,0.75000000f,0.53000000f,-0.91000000f,-0.39000000f,-0.79000000f,-0.26000000f,0.77000000f,-0.56000000f,-0.82000000f,-0.17000000f,0.94000000f,-0.86000000f,0.57000000f,-0.61000000f,-0.86000000f,0.11000000f,0.90000000f,-0.50000000f,-0.38000000f,0.06000000f,0.46000000f,0.60000000f,-0.81000000f,-0.81000000f,0.64000000f,0.13000000f,0.41000000f,-0.12000000f,-0.44000000f,-0.66000000f,-0.86000000f,-0.08000000f,0.16000000f,0.18000000f,0.45000000f,0.84000000f,-0.18000000f,-0.09000000f,0.78000000f,0.67000000f,0.86000000f,0.08000000f,-0.06000000f,0.77000000f,-0.88000000f,0.45000000f,-0.77000000f,-0.06000000f,-0.48000000f,0.81000000f,-0.48000000f,-0.01000000f,0.75000000f,0.43000000f,-0.63000000f,0.65000000f,-0.52000000f,-0.72000000f,-0.56000000f,-0.05000000f,-0.63000000f,0.08000000f,-0.34000000f,-0.72000000f,-0.70000000f,0.84000000f,-0.84000000f,-0.64000000f,-0.80000000f,0.40000000f,0.19000000f,0.07000000f,0.49000000f,0.62000000f,0.17000000f,-0.79000000f,0.62000000f,-0.59000000f,-0.82000000f,-0.40000000f,-0.07000000f,-0.35000000f,0.42000000f,-0.23000000f,-0.92000000f,0.70000000f,0.12000000f,0.93000000f,0.58000000f,0.94000000f,-0.67000000f,-0.13000000f,-0.96000000f,-0.04000000f,-0.57000000f,0.67000000f,0.36000000f,-0.03000000f,0.51000000f,-0.87000000f,0.58000000f,0.85000000f,0.54000000f,-0.10000000f,-0.98000000f,0.64000000f,-0.33000000f,0.70000000f,0.94000000f,-0.53000000f,-0.44000000f,-0.39000000f,0.17000000f,0.34000000f,0.22000000f,0.50000000f,0.63000000f,-0.61000000f,0.15000000f,-0.82000000f,-0.20000000f,-0.79000000f,-0.24000000f,0.58000000f,-0.48000000f,-0.76000000f,0.39000000f,-0.85000000f,-0.52000000f,-0.90000000f,0.00000000f,0.06000000f,0.40000000f,-0.89000000f,0.17000000f,-0.30000000f,-0.79000000f,-0.86000000f,0.44000000f,0.55000000f,0.49000000f,0.54000000f,0.12000000f,0.72000000f,0.17000000f,0.65000000f,-0.74000000f,-0.33000000f,-0.82000000f,0.30000000f,0.24000000f,-0.39000000f,0.47000000f,0.79000000f,-0.31000000f,0.97000000f,-0.17000000f,0.57000000f,-0.63000000f,0.23000000f,0.43000000f,-0.55000000f,0.61000000f,-0.88000000f,0.51000000f,-0.93000000f,0.26000000f,0.34000000f,-0.32000000f,0.22000000f,-0.38000000f,-0.93000000f,0.76000000f,-0.90000000f,-0.02000000f,0.08000000f,-0.07000000f,-0.71000000f,0.61000000f,-0.80000000f,0.81000000f,-0.26000000f,-0.82000000f,-0.18000000f,0.98000000f,0.57000000f,0.17000000f,-0.93000000f,0.67000000f,-0.80000000f,-0.07000000f,-0.43000000f,0.66000000f,0.17000000f,-0.26000000f,0.35000000f,0.15000000f,0.83000000f,0.74000000f,-0.88000000f,0.01000000f,0.81000000f,-0.90000000f,-0.75000000f,0.59000000f,0.00000000f,-0.42000000f,-0.11000000f,-0.54000000f,-0.99000000f,0.49000000f,0.46000000f,0.45000000f,0.27000000f,0.57000000f,-0.88000000f,0.54000000f,-0.59000000f,0.66000000f,-0.71000000f,-0.79000000f,-0.51000000f,0.73000000f,0.53000000f,-0.00000000f,0.52000000f,-0.84000000f,-0.39000000f,0.58000000f,0.17000000f,-0.29000000f,-0.36000000f,-0.57000000f,-0.25000000f,0.36000000f,0.58000000f,-0.06000000f,-0.71000000f,-0.35000000f,-0.87000000f,-0.38000000f,-0.60000000f,-0.75000000f,0.30000000f,0.97000000f,0.55000000f,0.31000000f,0.61000000f,0.59000000f,-0.24000000f,-0.13000000f,-0.91000000f,-0.07000000f,-0.17000000f,-0.82000000f,-0.40000000f,0.68000000f,0.78000000f,0.96000000f,-0.70000000f,0.19000000f,-0.98000000f,0.83000000f,0.77000000f,-0.17000000f,0.26000000f,-0.98000000f,0.62000000f,-0.43000000f,0.74000000f,0.50000000f,-0.36000000f,-0.78000000f,-0.34000000f,0.42000000f,0.62000000f,0.43000000f,-0.17000000f,0.83000000f,0.25000000f,0.51000000f,0.07000000f,-0.40000000f,0.05000000f,-0.69000000f,0.44000000f,-0.88000000f,0.12000000f,0.53000000f,0.24000000f,0.16000000f,0.08000000f,-0.97000000f,0.00000000f,-0.58000000f,0.19000000f,0.59000000f,0.32000000f,-0.46000000f,0.65000000f,-0.27000000f,-0.30000000f,0.63000000f,-0.85000000f,-0.99000000f,0.76000000f,-0.62000000f,0.90000000f,0.68000000f,-0.98000000f,0.40000000f,0.15000000f,-0.34000000f,-0.03000000f,-0.64000000f,-0.03000000f,0.99000000f,0.14000000f,-0.48000000f,-0.91000000f,-0.29000000f,0.43000000f,-0.40000000f,0.36000000f,0.15000000f,0.73000000f,0.00000000f,-0.39000000f,-0.55000000f,0.15000000f,0.12000000f,0.48000000f,0.47000000f,0.47000000f,-0.25000000f,-0.45000000f,0.68000000f,0.48000000f,-0.92000000f,-0.23000000f,0.36000000f,0.78000000f,-0.20000000f,-0.15000000f,-0.14000000f,0.82000000f,-0.49000000f,-0.91000000f,-0.92000000f,-0.92000000f,-0.25000000f,-0.22000000f,0.77000000f,0.44000000f,-0.86000000f,0.16000000f,0.76000000f,-0.06000000f,0.73000000f,-0.94000000f,-0.99000000f,-0.14000000f,0.52000000f,-0.63000000f,-0.18000000f,0.77000000f,-0.70000000f,-0.92000000f,0.36000000f,0.06000000f,0.57000000f,-0.96000000f,0.10000000f,0.12000000f,-0.64000000f,0.38000000f,-0.75000000f,-0.09000000f,-0.81000000f,-0.17000000f,-0.82000000f,0.39000000f,0.16000000f,-0.49000000f,-0.82000000f,-0.95000000f,0.16000000f,0.20000000f,0.12000000f,0.40000000f,0.26000000f,0.94000000f,0.55000000f,-0.83000000f,0.06000000f,-0.04000000f,0.42000000f,-0.97000000f,0.49000000f,-0.15000000f,-0.18000000f,-0.40000000f,0.43000000f,-0.56000000f,0.33000000f,0.29000000f,-0.94000000f,-0.74000000f,-0.20000000f,0.47000000f,-0.08000000f,-0.95000000f,0.08000000f,-0.32000000f,0.75000000f,-0.67000000f,0.36000000f,-0.29000000f,-0.41000000f,0.85000000f,-0.15000000f,0.09000000f,0.26000000f,-0.40000000f,-0.64000000f,-0.43000000f,-0.45000000f,0.87000000f,-0.62000000f,-0.96000000f,0.26000000f,0.87000000f,-0.36000000f,-0.69000000f,-0.93000000f,-0.32000000f,0.09000000f,0.94000000f,-0.85000000f,0.31000000f,-0.59000000f,-0.08000000f,0.10000000f,0.33000000f,-0.97000000f,-0.54000000f,-0.50000000f,0.25000000f,0.26000000f,0.67000000f,0.30000000f,-0.98000000f,0.67000000f,-0.92000000f,-0.56000000f,-0.80000000f,-0.53000000f,-0.34000000f,-0.68000000f,-0.28000000f,0.59000000f,-0.56000000f,0.94000000f,-0.10000000f,-0.26000000f,-0.93000000f,0.54000000f,0.13000000f,0.23000000f,-0.81000000f,0.36000000f,-0.26000000f,0.90000000f,0.53000000f,-0.43000000f,0.68000000f,0.28000000f,0.31000000f,0.25000000f,0.45000000f,-0.21000000f,0.67000000f,-0.56000000f,-0.63000000f,0.05000000f,0.39000000f,0.81000000f,-0.37000000f,-0.92000000f,0.53000000f,0.40000000f,-0.31000000f,0.23000000f,-0.00000000f,-0.83000000f,0.46000000f,-0.54000000f,0.98000000f,0.09000000f,-0.54000000f,-0.89000000f,0.82000000f,-0.62000000f,-0.09000000f,0.02000000f,-0.24000000f,0.42000000f,-0.85000000f,0.15000000f,-0.59000000f,-0.73000000f,0.73000000f,-0.19000000f,-0.58000000f,-0.45000000f,0.98000000f,-0.12000000f,-0.24000000f,-0.49000000f,-0.49000000f,0.46000000f,0.59000000f,-0.74000000f,0.79000000f,0.22000000f,-0.11000000f,-0.64000000f,-0.68000000f,0.31000000f,0.28000000f,0.23000000f,0.77000000f,-0.36000000f,0.30000000f,0.68000000f,-0.51000000f,-0.52000000f,0.59000000f,0.06000000f,0.29000000f,0.69000000f,-0.11000000f,-0.35000000f,0.67000000f,-0.18000000f,-0.59000000f,-0.77000000f,-0.09000000f,0.30000000f,0.78000000f,-0.36000000f,0.06000000f,-0.08000000f,-0.25000000f,-0.69000000f,0.82000000f,0.64000000f,-0.41000000f,0.40000000f,-0.34000000f,0.01000000f,-0.26000000f,0.40000000f,-0.73000000f,0.84000000f,0.39000000f,-0.42000000f,-0.31000000f,-0.28000000f,-0.96000000f,-0.75000000f,-0.64000000f,0.23000000f,-0.76000000f,-0.42000000f,0.92000000f,0.52000000f,0.92000000f,-0.58000000f,0.69000000f,-0.15000000f,0.24000000f,-0.27000000f,-0.86000000f,-0.09000000f,-0.42000000f,-0.74000000f,-0.01000000f,-0.18000000f,-0.41000000f,0.64000000f,0.92000000f,-0.58000000f,0.66000000f,-0.59000000f,-0.64000000f,0.20000000f,-0.80000000f,-0.58000000f,-0.44000000f,-0.34000000f,-0.11000000f,-0.07000000f,0.18000000f,0.31000000f,-0.05000000f,0.90000000f,-0.10000000f,-0.59000000f,0.33000000f,0.89000000f,-0.78000000f,0.66000000f,0.59000000f,0.76000000f,0.52000000f,0.04000000f,0.37000000f,0.79000000f,0.40000000f,-0.97000000f,-0.41000000f,0.04000000f,0.10000000f,0.72000000f,-0.20000000f,-0.95000000f,0.69000000f,0.26000000f,-0.56000000f,0.88000000f,-0.09000000f,-0.73000000f,-0.61000000f,-0.88000000f,-0.53000000f,-0.61000000f,-0.52000000f,-0.29000000f,0.96000000f,-0.61000000f,-0.63000000f,0.18000000f,0.04000000f,-0.31000000f,0.47000000f,-0.72000000f,0.57000000f,-0.69000000f,-0.30000000f,0.32000000f,0.38000000f,-0.31000000f,-0.05000000f,0.83000000f,-0.17000000f,0.40000000f,0.33000000f,-0.27000000f,0.09000000f,0.85000000f,-0.99000000f,-0.96000000f,-0.57000000f,-0.56000000f,-0.73000000f,0.69000000f,0.42000000f,-0.89000000f,-0.24000000f,0.99000000f,-0.18000000f,0.91000000f,-0.66000000f,-0.63000000f,-0.24000000f,-0.24000000f,-0.63000000f,0.80000000f,0.96000000f,0.94000000f,0.59000000f,-0.76000000f,0.26000000f,0.74000000f,-0.89000000f,0.50000000f,0.16000000f,0.21000000f,-0.48000000f,0.32000000f,-0.33000000f,0.13000000f,-0.61000000f,-0.01000000f,0.63000000f,-0.62000000f,0.45000000f,-0.03000000f,-0.25000000f,0.33000000f,0.09000000f,-0.96000000f,0.00000000f,-0.63000000f,0.41000000f,0.48000000f,0.90000000f,-0.61000000f,0.98000000f,-0.02000000f,-0.45000000f,-0.28000000f,0.14000000f,-0.22000000f,-0.68000000f,-0.46000000f,0.64000000f,-0.95000000f,-0.31000000f,-0.24000000f,0.88000000f,0.34000000f,-0.34000000f,-0.42000000f,0.56000000f,-0.40000000f,-0.27000000f,-0.09000000f,-0.78000000f,0.84000000f,0.25000000f,0.34000000f,-0.74000000f,0.46000000f,-0.95000000f,0.05000000f,-0.72000000f,-0.15000000f,0.12000000f,0.49000000f,-0.74000000f,0.91000000f,0.65000000f,0.89000000f,-0.33000000f,-0.57000000f,-0.49000000f,-0.19000000f,-0.08000000f,-0.36000000f,0.74000000f,-0.48000000f,0.07000000f,0.09000000f,-0.48000000f,-0.16000000f,0.65000000f,-0.29000000f,-0.13000000f,0.04000000f,0.37000000f,-0.66000000f,0.06000000f,-0.38000000f,0.10000000f,0.07000000f,0.92000000f,-0.41000000f,-0.17000000f,0.99000000f,0.36000000f,-0.38000000f,0.21000000f,0.66000000f,-0.25000000f,-0.32000000f,-0.31000000f,0.85000000f,-0.47000000f,-0.38000000f,-0.40000000f,-0.10000000f,0.08000000f,0.27000000f,-0.50000000f,-0.31000000f,0.96000000f,0.51000000f,-0.83000000f,0.63000000f,0.65000000f,-0.70000000f,0.09000000f,-0.48000000f,0.48000000f,0.22000000f,0.72000000f,-0.90000000f,-0.06000000f,0.19000000f,-0.16000000f,0.41000000f,-0.69000000f,-0.16000000f,-0.71000000f,0.78000000f,-0.83000000f,-0.76000000f,-0.20000000f,-0.81000000f,0.64000000f,-0.49000000f,0.08000000f,-0.15000000f,-0.33000000f,0.77000000f,0.51000000f,-0.24000000f,-0.08000000f,0.82000000f,-0.58000000f,0.64000000f,0.49000000f,-0.18000000f,0.43000000f,-0.54000000f,-0.85000000f,-0.24000000f,-0.71000000f,-0.90000000f,0.69000000f,-0.73000000f,0.72000000f,0.47000000f,-0.42000000f,-0.75000000f,-0.51000000f,0.80000000f,0.18000000f,-0.08000000f,-0.41000000f,0.61000000f,-0.31000000f,-0.39000000f,0.97000000f,-0.32000000f,0.51000000f,-0.61000000f,-0.35000000f,0.10000000f,-0.08000000f,-0.28000000f,-0.04000000f,0.94000000f,0.71000000f,0.61000000f,-0.13000000f,0.21000000f,0.96000000f,-0.61000000f,0.85000000f,-0.55000000f,0.96000000f,-0.18000000f,-0.05000000f,-0.85000000f,-0.60000000f,0.92000000f,-0.88000000f,-0.71000000f,-0.40000000f,0.14000000f,0.69000000f,-0.21000000f,0.63000000f,0.86000000f,0.44000000f,-0.25000000f,-0.23000000f,-0.05000000f,-0.29000000f,0.89000000f,-0.53000000f,-0.06000000f,0.03000000f,0.36000000f,-0.83000000f,0.79000000f,-0.40000000f,-0.10000000f,0.90000000f,-0.92000000f,-0.49000000f,-0.38000000f,-0.43000000f,0.02000000f,0.98000000f,-0.99000000f,0.13000000f,-0.75000000f,-0.99000000f,-0.37000000f,0.52000000f,-0.20000000f,-0.56000000f,-0.38000000f,0.80000000f,-0.45000000f,0.13000000f,0.71000000f,-0.60000000f,-0.46000000f,-0.90000000f,0.83000000f,-0.01000000f,-0.47000000f,0.08000000f,-0.52000000f,-0.27000000f,-0.83000000f,-0.06000000f,-0.26000000f,-0.43000000f,0.02000000f,0.71000000f,0.26000000f,-0.39000000f,-0.20000000f,-0.12000000f,0.95000000f,0.15000000f,0.71000000f,-0.82000000f,-0.91000000f,-0.98000000f,0.99000000f,0.60000000f,-0.20000000f,-0.89000000f,-0.33000000f,-0.22000000f,0.25000000f,0.04000000f,0.74000000f,-0.92000000f,-0.19000000f,-0.23000000f,0.84000000f,0.34000000f,0.83000000f,0.41000000f,0.77000000f,0.24000000f,0.32000000f,-0.31000000f,-0.36000000f,-0.08000000f,0.58000000f,-0.45000000f,0.63000000f,-0.28000000f,0.15000000f,-0.19000000f,0.58000000f,0.67000000f,-0.21000000f,-0.79000000f,0.23000000f,-0.33000000f,-0.05000000f,-0.60000000f,-0.09000000f,-0.98000000f,0.73000000f,-0.36000000f,0.18000000f,0.70000000f,0.86000000f,-0.18000000f,-0.36000000f,0.06000000f,-0.30000000f,-0.48000000f,-0.08000000f,0.70000000f,0.57000000f,0.00000000f,0.95000000f,0.69000000f,-0.70000000f,-0.98000000f,-0.30000000f,-0.78000000f,-0.63000000f,-0.91000000f,0.83000000f,0.72000000f,0.45000000f,-0.50000000f,-0.30000000f,-0.41000000f,-0.17000000f,-0.39000000f,-0.65000000f,-0.97000000f,0.25000000f,-0.03000000f,-0.38000000f,-0.24000000f,0.42000000f,0.27000000f,-0.18000000f,0.50000000f,-0.04000000f,-0.33000000f,-0.54000000f,0.69000000f,-0.97000000f,0.45000000f,0.03000000f,0.78000000f,0.83000000f,-0.91000000f,-0.37000000f,-0.55000000f,-0.28000000f,-0.15000000f,-0.19000000f,0.38000000f,0.11000000f,-0.39000000f,-0.63000000f,0.84000000f,-0.19000000f,0.61000000f,-0.36000000f,0.34000000f,-0.54000000f,-0.68000000f,-0.68000000f,0.47000000f,-0.08000000f,0.79000000f,0.21000000f,-0.50000000f,-0.18000000f,-0.40000000f,0.80000000f,0.00000000f,-0.40000000f,-0.90000000f,-0.52000000f,-0.21000000f,-0.10000000f,0.99000000f,0.97000000f,-0.71000000f,-0.98000000f,-0.80000000f,0.20000000f,0.73000000f,0.95000000f,-0.47000000f,0.52000000f,0.98000000f,0.01000000f,0.16000000f,-0.50000000f,0.43000000f,0.51000000f,0.81000000f,0.69000000f,-0.34000000f,-0.49000000f,-0.92000000f,0.68000000f,0.79000000f,-0.56000000f,-0.46000000f,0.69000000f,0.51000000f,-0.45000000f,-0.30000000f,0.95000000f,-0.46000000f,-0.88000000f,-0.92000000f,-0.69000000f,0.91000000f,-0.62000000f,-0.58000000f,0.70000000f,0.51000000f,-0.70000000f,-0.87000000f,-0.01000000f,-0.64000000f,-0.22000000f,-0.81000000f,-0.65000000f,-0.55000000f,-0.06000000f,0.84000000f,0.54000000f,0.29000000f,-0.85000000f,-0.99000000f,0.87000000f,0.98000000f,0.61000000f,0.64000000f,0.25000000f,0.87000000f,0.89000000f,0.48000000f,-0.25000000f,-0.78000000f,-0.77000000f,0.49000000f,0.53000000f,-0.06000000f,-0.93000000f,0.21000000f,0.92000000f,-0.51000000f,0.55000000f,0.83000000f,0.14000000f,0.17000000f,0.42000000f,-0.09000000f,0.52000000f,0.95000000f,0.46000000f,0.81000000f,-0.75000000f,0.88000000f,0.99000000f,-0.53000000f,-0.93000000f,-0.46000000f,-0.67000000f,0.61000000f,-0.02000000f,-0.57000000f,-0.58000000f,0.09000000f,0.29000000f,0.27000000f,0.73000000f,0.90000000f,-0.72000000f,-0.68000000f,-0.00000000f,0.64000000f,0.24000000f,0.18000000f,0.73000000f,0.03000000f,-0.06000000f,-0.84000000f,-0.07000000f,-0.25000000f,-0.61000000f,0.71000000f,-0.10000000f,-0.27000000f,-0.83000000f,0.24000000f,-0.11000000f,-0.97000000f,-0.99000000f,0.13000000f,-0.84000000f,-0.51000000f,0.85000000f,-0.11000000f,-0.67000000f,0.45000000f,0.95000000f,0.76000000f,-0.63000000f,0.95000000f,-0.68000000f,-0.15000000f,0.77000000f,-0.44000000f,0.10000000f,0.11000000f,0.76000000f,0.56000000f,0.48000000f,0.35000000f,-0.11000000f,-0.16000000f,-0.00000000f,0.63000000f,-0.01000000f,0.51000000f,0.13000000f,-0.28000000f,-0.01000000f,0.58000000f,0.89000000f,-0.69000000f,0.43000000f,-0.90000000f,0.28000000f,0.86000000f,0.93000000f,0.22000000f,-0.16000000f,0.47000000f,0.33000000f,-0.56000000f,0.12000000f,-0.26000000f,-0.72000000f,-0.51000000f,0.24000000f,-0.19000000f,-0.88000000f,-0.70000000f,0.45000000f,-0.93000000f,-0.61000000f,-0.76000000f,-0.49000000f,0.27000000f,-0.11000000f,-0.06000000f,0.10000000f,0.04000000f,0.62000000f,0.51000000f,-0.27000000f,-0.19000000f,0.90000000f,-0.39000000f,0.18000000f,-0.10000000f,0.84000000f,0.53000000f,-0.71000000f,0.17000000f,0.29000000f,0.72000000f,-0.80000000f,0.27000000f,0.57000000f,-0.53000000f,-0.95000000f,0.88000000f,0.84000000f,0.09000000f,0.11000000f,-0.13000000f,-0.64000000f,-0.36000000f,-0.48000000f,0.82000000f,0.08000000f,-0.35000000f,0.03000000f,0.76000000f,0.14000000f,0.79000000f,-0.94000000f,-0.35000000f,0.89000000f,-0.25000000f,-0.48000000f,0.37000000f,0.82000000f,-0.30000000f,0.57000000f,0.94000000f,0.47000000f,0.17000000f,-0.39000000f,-0.62000000f,0.65000000f,0.37000000f,0.41000000f,-0.85000000f,0.74000000f,-0.59000000f,0.44000000f,-0.63000000f,0.45000000f,0.90000000f,0.99000000f,-0.73000000f,-0.03000000f,0.00000000f,0.49000000f,-0.29000000f,-0.63000000f,0.59000000f,0.24000000f,0.66000000f,-0.05000000f,0.06000000f,-0.95000000f,0.06000000f,0.62000000f,-0.83000000f,-0.46000000f,-0.25000000f,-0.35000000f,-0.91000000f,0.07000000f,-0.77000000f,0.54000000f,-0.82000000f,0.82000000f,0.68000000f,0.49000000f,-0.63000000f,-0.36000000f,-0.31000000f,-0.48000000f,-0.95000000f,-0.55000000f,-0.62000000f,0.52000000f,0.26000000f,-0.39000000f,0.45000000f,-0.09000000f,-0.07000000f,0.56000000f,0.32000000f,0.37000000f,0.57000000f,-0.83000000f,-0.90000000f,0.03000000f,0.47000000f,0.97000000f,0.26000000f,0.37000000f,-0.24000000f,0.72000000f,0.38000000f,-0.73000000f,0.86000000f,0.88000000f,-0.59000000f,0.17000000f,-0.80000000f,-0.86000000f,0.64000000f,0.83000000f,-0.15000000f,-0.31000000f,-0.87000000f,0.92000000f,-0.24000000f,0.45000000f,0.42000000f,-0.61000000f,-0.37000000f,0.02000000f,0.82000000f,0.84000000f,0.06000000f,0.67000000f,-0.12000000f,0.11000000f,0.94000000f,-0.81000000f,0.75000000f,-0.04000000f,0.72000000f,-0.50000000f,0.30000000f,0.90000000f,0.93000000f,-0.05000000f,-0.10000000f,-0.02000000f,0.51000000f,0.03000000f,-0.67000000f,0.18000000f,0.37000000f,0.65000000f,-0.20000000f,-0.45000000f,0.52000000f,0.46000000f,0.95000000f,-0.78000000f,0.20000000f,0.54000000f,0.92000000f,-0.64000000f,0.51000000f,0.63000000f,-0.58000000f,-0.50000000f,-0.40000000f,0.82000000f,0.15000000f,0.15000000f,0.21000000f,0.01000000f,0.89000000f,0.10000000f,-0.05000000f,-0.92000000f,-0.18000000f,0.30000000f,0.00000000f,-0.12000000f,0.71000000f,-0.58000000f,0.15000000f,0.17000000f,-0.31000000f,-0.36000000f,0.95000000f,-0.21000000f,-0.82000000f,-0.31000000f,-0.78000000f,-0.17000000f,0.47000000f,-0.41000000f,0.90000000f,0.75000000f,0.28000000f,0.57000000f,0.16000000f,-0.73000000f,0.66000000f,-0.27000000f,0.76000000f,-0.74000000f,0.35000000f,-0.21000000f,0.39000000f,-0.70000000f,-0.31000000f,-0.14000000f,-0.85000000f,0.80000000f,0.58000000f,-0.43000000f,0.02000000f,0.01000000f,0.31000000f,-0.89000000f,-0.06000000f,0.04000000f,0.28000000f,-0.00000000f,0.74000000f,0.32000000f,0.66000000f,-0.98000000f,-0.53000000f,-0.40000000f,-0.94000000f,0.35000000f,0.53000000f,-0.57000000f,0.60000000f,0.86000000f,-0.94000000f,-0.67000000f,0.95000000f,-0.35000000f,-0.79000000f,0.56000000f,0.10000000f,-0.28000000f,-0.53000000f,-0.27000000f,0.25000000f,0.83000000f,0.77000000f,0.18000000f,-0.33000000f,0.49000000f,-0.64000000f,0.57000000f,0.80000000f,0.98000000f,0.56000000f,0.03000000f,0.58000000f,0.76000000f,0.87000000f,0.61000000f,0.91000000f,-0.30000000f,-0.60000000f,-0.76000000f,-0.30000000f,0.23000000f,0.06000000f,0.03000000f,0.72000000f,0.11000000f,-0.23000000f,-0.21000000f,-0.20000000f,-0.44000000f,0.78000000f,0.15000000f,0.87000000f,-0.31000000f,0.43000000f,-0.05000000f,-0.16000000f,0.04000000f,-0.79000000f,0.87000000f,0.09000000f,0.32000000f,-0.58000000f,0.65000000f,-0.62000000f,0.23000000f,0.20000000f,-0.29000000f,0.88000000f,-0.58000000f,-0.03000000f,-0.33000000f,-0.48000000f,0.27000000f,0.47000000f,0.81000000f,0.91000000f,-0.41000000f,0.67000000f,-0.94000000f,0.31000000f,0.25000000f,-0.00000000f,0.99000000f,-0.06000000f,0.22000000f,-0.19000000f,0.53000000f,-0.62000000f,-0.63000000f,0.28000000f,-0.49000000f,0.37000000f,-0.69000000f,0.59000000f,-0.30000000f,0.57000000f,0.52000000f,0.55000000f,-0.67000000f,-0.15000000f,0.71000000f,0.11000000f,-0.34000000f,-0.06000000f,0.10000000f,0.70000000f,0.98000000f,0.52000000f,0.16000000f,0.87000000f,-0.62000000f,-0.58000000f,0.57000000f,0.65000000f,-0.35000000f,-0.31000000f,0.96000000f,0.21000000f,0.31000000f,-0.82000000f,0.14000000f,0.57000000f,0.24000000f,-0.26000000f,0.77000000f,-0.09000000f,0.20000000f,0.40000000f,0.12000000f,-0.17000000f,0.65000000f,0.64000000f,-0.63000000f,-0.75000000f,0.50000000f,0.31000000f,-0.06000000f,-0.19000000f,-0.63000000f,0.69000000f,-0.54000000f,0.27000000f,0.95000000f,-0.44000000f,0.18000000f,-0.91000000f,-0.02000000f,0.77000000f,-0.66000000f,-0.33000000f,-0.20000000f,-0.22000000f,0.65000000f,0.31000000f,-0.00000000f,-0.26000000f,0.07000000f,0.05000000f,-0.47000000f,-0.52000000f,-0.06000000f,0.49000000f,0.65000000f,0.54000000f,0.10000000f,-0.10000000f,-0.56000000f,-0.87000000f,0.35000000f,-0.51000000f,0.90000000f,-0.04000000f,-0.90000000f,-0.16000000f,-0.75000000f,-0.06000000f,-0.04000000f,-0.11000000f,0.44000000f,0.73000000f,0.72000000f,0.80000000f,0.73000000f,-0.95000000f,0.83000000f,0.72000000f,0.46000000f,-0.94000000f,-0.56000000f,0.00000000f,-0.41000000f,-0.66000000f,0.56000000f,0.92000000f,-0.23000000f,-0.32000000f,-0.16000000f,-0.04000000f,-0.37000000f,-0.81000000f,-0.29000000f,-0.79000000f,-0.45000000f,-0.37000000f,0.65000000f,-0.07000000f,-0.97000000f,-0.93000000f,0.15000000f,0.01000000f,-0.90000000f,0.05000000f,-0.63000000f,0.43000000f,-0.67000000f,0.04000000f,0.86000000f,-0.64000000f,0.80000000f,0.66000000f,-0.02000000f,0.84000000f,-0.46000000f,0.19000000f,-0.42000000f,-0.20000000f,0.86000000f,0.12000000f,0.32000000f,-0.72000000f,-0.40000000f,-0.32000000f,-0.26000000f,0.85000000f,-0.40000000f,0.15000000f,-0.69000000f,-0.77000000f,-0.48000000f,-0.10000000f,-0.16000000f,0.61000000f,-0.12000000f,-0.76000000f,0.21000000f,-0.15000000f,-0.15000000f,0.00000000f,-0.31000000f,0.74000000f,-0.12000000f,0.75000000f,-0.31000000f,0.89000000f,0.75000000f,-0.17000000f,-0.58000000f,-0.33000000f,-0.72000000f,-0.43000000f,-0.36000000f,-0.74000000f,-0.17000000f,-0.61000000f,-0.53000000f,0.62000000f,-0.24000000f,-0.37000000f,-0.16000000f,-0.74000000f,0.39000000f,-0.41000000f,0.57000000f,-0.64000000f,-0.51000000f,0.65000000f,0.40000000f,0.65000000f,-0.04000000f,-0.08000000f,0.30000000f,-0.86000000f,0.37000000f,-0.49000000f,0.24000000f,0.36000000f,-0.66000000f,0.53000000f,-0.42000000f,0.47000000f,-0.10000000f,-0.41000000f,-0.92000000f,-0.88000000f,0.90000000f,0.59000000f,0.00000000f,0.70000000f,-0.55000000f,0.45000000f,0.81000000f,0.42000000f,-0.81000000f,-0.90000000f,-0.66000000f,0.47000000f,-0.49000000f,-0.21000000f,-0.71000000f,-0.62000000f,0.20000000f,-0.90000000f,-0.49000000f,-0.83000000f,-0.94000000f,0.16000000f,0.04000000f,0.84000000f,-0.49000000f,-0.23000000f,-0.75000000f,-0.13000000f,0.91000000f,0.36000000f,-0.51000000f,0.56000000f,-0.26000000f,-0.34000000f,-0.27000000f,0.13000000f,0.45000000f,-0.89000000f,0.69000000f,-0.42000000f,0.49000000f,-0.93000000f,0.46000000f,0.68000000f,0.63000000f,-0.86000000f,-0.26000000f,0.14000000f,-0.29000000f,0.80000000f,-0.74000000f,0.73000000f,0.19000000f,-0.26000000f,0.01000000f,-0.71000000f,-0.54000000f,-0.64000000f,-0.59000000f,-0.37000000f,0.76000000f,0.15000000f,0.90000000f,-0.28000000f,0.59000000f,0.16000000f,-0.55000000f,0.48000000f,-0.49000000f,-0.43000000f,0.56000000f,-0.30000000f,0.12000000f,0.08000000f,-0.28000000f,0.78000000f,0.73000000f,-0.06000000f,0.13000000f,0.31000000f,-0.30000000f,0.90000000f,0.39000000f,-0.77000000f,-0.89000000f,0.91000000f,-0.09000000f,0.76000000f,0.30000000f,-0.80000000f,0.31000000f,-0.94000000f,0.88000000f,-0.38000000f,-0.10000000f,0.02000000f,-0.93000000f,-0.27000000f,0.83000000f,-0.33000000f,-0.55000000f,0.04000000f,-0.31000000f,-0.21000000f,-0.38000000f,-0.04000000f,-0.21000000f,-0.58000000f,0.57000000f,-0.50000000f,0.45000000f,-0.88000000f,-0.95000000f,0.66000000f,-0.15000000f,-0.65000000f,0.04000000f,-0.91000000f,-0.02000000f,-0.40000000f,0.60000000f,0.17000000f,0.07000000f,-0.11000000f,-0.55000000f,0.36000000f,0.47000000f,0.09000000f,0.37000000f,0.75000000f,-0.98000000f,-0.39000000f,0.79000000f,0.61000000f,-0.75000000f,0.51000000f,-0.49000000f,-0.99000000f,-0.72000000f,-0.56000000f,0.97000000f,-0.42000000f,0.06000000f,-0.14000000f,-0.96000000f,-0.28000000f,-0.48000000f,0.99000000f,0.64000000f,-0.12000000f,0.63000000f,-0.95000000f,-0.09000000f,-0.81000000f,0.83000000f,0.99000000f,-0.01000000f,0.17000000f,0.03000000f,-0.52000000f,0.20000000f,0.77000000f,-0.42000000f,0.96000000f,0.79000000f,-0.64000000f,-0.29000000f,-0.84000000f,-0.79000000f,0.83000000f,-0.88000000f,-0.24000000f,0.22000000f,0.55000000f,0.16000000f,-0.85000000f,0.49000000f,0.61000000f,-0.79000000f,-0.75000000f,0.27000000f,0.36000000f,0.36000000f,-0.98000000f,-0.34000000f,0.13000000f,0.38000000f,-0.25000000f,0.74000000f,0.08000000f,0.46000000f,0.13000000f,0.32000000f,0.78000000f,0.44000000f,0.11000000f,-0.57000000f,-0.34000000f,-0.92000000f,-0.03000000f,-0.74000000f,-0.06000000f,0.30000000f,-0.51000000f,0.06000000f,0.74000000f,0.13000000f,0.34000000f,0.05000000f,0.81000000f,0.43000000f,0.80000000f,-0.77000000f,-0.54000000f,0.59000000f,-0.05000000f,0.14000000f,0.29000000f,-0.70000000f,-0.12000000f,0.03000000f,-0.04000000f,-0.07000000f,-0.84000000f,0.86000000f,0.87000000f,-0.24000000f,0.02000000f,0.71000000f,0.31000000f,-0.62000000f,0.62000000f,-0.65000000f,0.26000000f,0.47000000f,0.57000000f,0.84000000f,0.32000000f,0.54000000f,-0.50000000f,0.93000000f,-0.91000000f,0.35000000f,-0.74000000f,-0.56000000f,-0.46000000f,-0.78000000f,-0.60000000f,-0.89000000f,-0.88000000f,-0.16000000f,-0.83000000f,-0.63000000f,0.59000000f,0.85000000f,0.32000000f,0.74000000f,0.84000000f,-0.83000000f,-0.46000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.95000000f,0.99000000f,-0.87000000f,-0.28000000f,0.66000000f,-0.58000000f,0.20000000f,-0.17000000f,-0.95000000f,0.23000000f,0.86000000f,-0.81000000f,0.93000000f,0.38000000f,0.49000000f,0.68000000f,-0.91000000f,-0.58000000f,-0.41000000f,0.31000000f,0.23000000f,0.92000000f,0.71000000f,0.33000000f,0.18000000f,-0.33000000f,0.64000000f,0.75000000f,-0.72000000f,0.70000000f,-0.49000000f,-0.49000000f,-0.18000000f,-0.59000000f,-0.23000000f,0.71000000f,0.42000000f,-0.53000000f,-0.83000000f,-0.04000000f,-0.75000000f,-0.77000000f,-0.59000000f,0.53000000f,-0.30000000f,0.22000000f,-0.78000000f,0.64000000f,-0.64000000f,-0.37000000f,0.79000000f,0.72000000f,-0.06000000f,0.94000000f,0.93000000f,-0.75000000f,0.90000000f,-0.79000000f,0.96000000f,0.28000000f,-0.74000000f,0.70000000f,-0.81000000f,0.18000000f,-0.96000000f,0.84000000f,-0.18000000f,0.05000000f,-0.23000000f,0.26000000f,-0.85000000f,-0.12000000f,0.50000000f,0.12000000f,-0.94000000f,0.64000000f,0.86000000f,0.81000000f,0.89000000f,-0.62000000f,0.74000000f,-0.19000000f,-0.78000000f,0.67000000f,-0.04000000f,0.36000000f,0.62000000f,-0.02000000f,-0.49000000f,0.72000000f,-0.02000000f,0.42000000f,-0.78000000f,0.79000000f,0.26000000f,-0.63000000f,-0.31000000f,-0.38000000f,-0.37000000f,-0.43000000f,-0.97000000f,0.27000000f,-0.34000000f,-0.59000000f,-0.07000000f,0.44000000f,-0.62000000f,-0.64000000f,-0.09000000f,-0.70000000f,-0.11000000f,-0.89000000f,-0.35000000f,0.49000000f,-0.73000000f,-0.89000000f,0.76000000f,0.90000000f,0.04000000f,0.44000000f,0.58000000f,0.18000000f,-0.06000000f,0.68000000f,0.14000000f,-0.48000000f,-0.15000000f,-0.53000000f,-0.31000000f,0.37000000f,0.71000000f,-0.10000000f,-0.83000000f,-0.88000000f,-0.26000000f,-0.88000000f,0.82000000f,-0.04000000f,0.84000000f,-0.92000000f,-0.10000000f,0.00000000f,0.18000000f,0.21000000f,0.74000000f,-0.25000000f,0.88000000f,-0.75000000f,-0.47000000f,0.72000000f,-0.54000000f,0.04000000f,0.10000000f,0.29000000f,0.20000000f,0.08000000f,-0.17000000f,0.71000000f,-0.46000000f,0.96000000f,-0.21000000f,0.10000000f,0.58000000f,0.65000000f,0.06000000f,0.58000000f,0.68000000f,0.27000000f,-0.07000000f,-0.05000000f,0.97000000f,0.25000000f,-0.42000000f,-0.59000000f,0.42000000f,0.87000000f,-0.06000000f,-0.61000000f,0.06000000f,0.84000000f,0.58000000f,-0.68000000f,0.65000000f,0.40000000f,-0.32000000f,-0.38000000f,0.93000000f,0.58000000f,-0.65000000f,0.73000000f,0.96000000f,-0.97000000f,0.08000000f,0.80000000f,0.39000000f,-0.21000000f,-0.47000000f,0.56000000f,-0.17000000f,-0.46000000f,-0.52000000f,-0.27000000f,0.76000000f,0.60000000f,-0.41000000f,-0.73000000f,0.93000000f,-0.06000000f,0.30000000f,-0.64000000f,-0.02000000f,-0.23000000f,0.08000000f,0.72000000f,-0.58000000f,-0.29000000f,-0.49000000f,0.85000000f,-0.42000000f,0.40000000f,-0.37000000f,-0.74000000f,0.51000000f,-0.52000000f,-0.52000000f,-0.63000000f,-0.66000000f,0.81000000f,-0.39000000f,0.33000000f,-0.46000000f,-0.76000000f,-0.06000000f,0.45000000f,-0.05000000f,-0.64000000f,0.42000000f,0.76000000f,-0.55000000f,-0.98000000f,0.78000000f,-0.82000000f,-0.25000000f,0.24000000f,0.35000000f,0.68000000f,-0.68000000f,0.28000000f,0.60000000f,-0.50000000f,0.20000000f,0.15000000f,-0.92000000f,0.09000000f,-0.99000000f,0.49000000f,0.24000000f,0.69000000f,-0.50000000f,0.47000000f,0.94000000f,-0.30000000f,0.96000000f,-0.45000000f,-0.57000000f,0.25000000f,0.77000000f,0.82000000f,-0.88000000f,-0.33000000f,-0.32000000f,-0.65000000f,-0.85000000f,0.83000000f,0.06000000f,0.71000000f,0.53000000f,-0.42000000f,0.25000000f,-0.50000000f,-0.02000000f,0.76000000f,-0.13000000f,0.39000000f,-0.99000000f,-0.20000000f,0.20000000f,-0.80000000f,-0.59000000f,-0.59000000f,0.13000000f,0.57000000f,0.55000000f,0.44000000f,-0.11000000f,0.30000000f,-0.16000000f,0.78000000f,-0.91000000f,0.02000000f,0.68000000f,0.59000000f,-0.28000000f,-0.79000000f,0.48000000f,-0.17000000f,-0.86000000f,-0.68000000f,0.96000000f,-0.61000000f,-0.69000000f,0.95000000f,0.81000000f,-0.89000000f,0.02000000f,0.97000000f,-0.13000000f,-0.10000000f,0.07000000f,0.67000000f,0.30000000f,-0.26000000f,-0.07000000f,-0.55000000f,-0.58000000f,-0.81000000f,0.06000000f,0.65000000f,0.97000000f,-0.29000000f,0.85000000f,-0.49000000f,-0.01000000f,-0.90000000f,0.23000000f,-0.39000000f,-0.71000000f,0.28000000f,0.38000000f,-0.26000000f,0.19000000f,-0.94000000f,0.38000000f,-0.80000000f,0.15000000f,-0.59000000f,0.18000000f,0.87000000f,-0.54000000f,-0.65000000f,0.47000000f,0.74000000f,0.43000000f,0.30000000f,0.99000000f,-0.66000000f,0.89000000f,-0.72000000f,0.25000000f,0.73000000f,-0.26000000f,-0.60000000f,0.10000000f,0.55000000f,-0.86000000f,-0.96000000f,-0.54000000f,-0.81000000f,0.84000000f,0.67000000f,0.34000000f,0.98000000f,-0.50000000f,-0.64000000f,-0.40000000f,-0.61000000f,-0.72000000f,-0.68000000f,0.80000000f,-0.15000000f,-0.99000000f,-0.79000000f,0.71000000f,-0.66000000f,-0.11000000f,0.06000000f,0.24000000f,-0.58000000f,0.60000000f,-0.21000000f,0.24000000f,-0.75000000f,-0.12000000f,-0.91000000f,-0.67000000f,-0.19000000f,-0.47000000f,-0.87000000f,0.40000000f,0.42000000f,0.69000000f,-0.61000000f,-0.98000000f,-0.63000000f,0.97000000f,0.05000000f,-0.19000000f,-0.47000000f,0.41000000f,-0.45000000f,0.94000000f,0.85000000f,-0.10000000f,0.09000000f,0.00000000f,0.20000000f,0.49000000f,-0.81000000f,0.31000000f,0.94000000f,-0.41000000f,-0.71000000f,0.99000000f,0.82000000f,-0.34000000f,-0.08000000f,0.85000000f,0.61000000f,-0.93000000f,-0.54000000f,0.37000000f,-0.90000000f,-0.67000000f,-0.02000000f,-0.43000000f,-0.52000000f,-0.58000000f,-0.61000000f,0.81000000f,0.53000000f,0.86000000f,-0.09000000f,0.26000000f,0.23000000f,-0.76000000f,-0.58000000f,-0.90000000f,0.33000000f,0.82000000f,-0.44000000f,0.18000000f,-0.18000000f,0.72000000f,0.74000000f,-0.84000000f,0.83000000f,-0.26000000f,-0.32000000f,-0.99000000f,-0.07000000f,0.57000000f,0.71000000f,-0.64000000f,0.56000000f,-0.08000000f,-0.78000000f,0.83000000f,-0.60000000f,-0.54000000f,-0.65000000f,0.26000000f,0.67000000f,0.10000000f,0.72000000f,-0.12000000f,0.71000000f,0.90000000f,-0.37000000f,-0.55000000f,-0.42000000f,-0.89000000f,0.87000000f,0.70000000f,0.47000000f,0.07000000f,0.46000000f,0.48000000f,0.53000000f,-0.95000000f,0.82000000f,0.35000000f,0.48000000f,0.99000000f,-0.64000000f,0.45000000f,-0.33000000f,0.94000000f,0.93000000f,0.55000000f,0.95000000f,0.23000000f,0.71000000f,0.42000000f,0.48000000f,-0.45000000f,0.54000000f,0.38000000f,0.58000000f,0.94000000f,0.82000000f,0.65000000f,-0.51000000f,0.53000000f,-0.47000000f,-0.78000000f,-0.51000000f,0.67000000f,0.72000000f,-0.20000000f,0.09000000f,0.41000000f,0.69000000f,0.21000000f,0.95000000f,-0.26000000f,0.23000000f,-0.04000000f,-0.30000000f,-0.18000000f,-0.78000000f,0.06000000f,0.04000000f,0.83000000f,-0.97000000f,-0.55000000f,-0.86000000f,-0.99000000f,-0.12000000f,0.17000000f,-0.50000000f,-0.77000000f,-0.20000000f,-0.47000000f,-0.95000000f,0.05000000f,-0.37000000f,0.88000000f,0.09000000f,-0.54000000f,-0.64000000f,-0.72000000f,0.57000000f,0.16000000f,-0.31000000f,-0.28000000f,-0.36000000f,0.71000000f,-0.82000000f,0.23000000f,0.88000000f,0.69000000f,0.99000000f,-0.99000000f,0.94000000f,0.24000000f,-0.45000000f,0.61000000f,0.85000000f,-0.92000000f,0.96000000f,0.98000000f,0.34000000f,0.03000000f,-0.25000000f,0.15000000f,-0.71000000f,0.48000000f,-0.02000000f,-0.29000000f,0.34000000f,0.48000000f,-0.14000000f,-0.46000000f,-0.32000000f,0.67000000f,0.04000000f,-0.90000000f,-0.82000000f,0.44000000f,-0.46000000f,-0.33000000f,0.63000000f,-0.46000000f,0.16000000f,0.02000000f,0.57000000f,-0.02000000f,0.50000000f,0.26000000f,0.51000000f,-0.15000000f,0.25000000f,0.07000000f,-0.59000000f,-0.87000000f,0.64000000f,-0.92000000f,0.05000000f,0.79000000f,0.14000000f,-0.34000000f,-0.77000000f,0.72000000f,0.53000000f,-0.42000000f,0.95000000f,-0.86000000f,-0.35000000f,0.90000000f,0.36000000f,0.25000000f,0.63000000f,0.59000000f,-0.32000000f,-0.95000000f,-0.98000000f,-0.84000000f,-0.56000000f,0.65000000f,-0.81000000f,-0.06000000f,-0.45000000f,-0.60000000f,-0.84000000f,0.09000000f,0.77000000f,0.17000000f,0.11000000f,-0.57000000f,-0.67000000f,-0.23000000f,-0.98000000f,0.12000000f,0.32000000f,0.35000000f,0.37000000f,-0.81000000f,-0.07000000f,-0.21000000f,0.72000000f,-0.35000000f,-0.02000000f,0.33000000f,0.58000000f,-0.52000000f,0.17000000f,-0.49000000f,0.30000000f,-0.30000000f,-0.78000000f,-0.38000000f,0.25000000f,0.14000000f,-0.20000000f,0.75000000f,-0.51000000f,0.46000000f,0.15000000f,-0.07000000f,0.19000000f,-0.47000000f,0.70000000f,-0.47000000f,-0.03000000f,0.14000000f,-0.25000000f,0.67000000f,0.83000000f,0.22000000f,-0.80000000f,0.15000000f,0.88000000f,0.42000000f,0.76000000f,-0.53000000f,0.85000000f,0.89000000f,0.92000000f,-0.73000000f,-0.88000000f,0.05000000f,0.09000000f,0.19000000f,0.55000000f,0.74000000f,-0.08000000f,0.41000000f,0.06000000f,-0.35000000f,0.66000000f,0.05000000f,0.36000000f,0.28000000f,0.77000000f,0.65000000f,0.94000000f,-0.28000000f,-0.31000000f,0.47000000f,-0.62000000f,-0.99000000f,0.90000000f,0.70000000f,0.88000000f,-0.68000000f,0.69000000f,-0.23000000f,-0.01000000f,0.97000000f,0.87000000f,0.55000000f,0.07000000f,0.59000000f,-0.16000000f,-0.05000000f,0.28000000f,-0.48000000f,0.56000000f,-0.64000000f,0.22000000f,0.55000000f,-0.66000000f,0.29000000f,0.12000000f,0.73000000f,-0.98000000f,-0.13000000f,-0.39000000f,0.33000000f,0.95000000f,0.38000000f,-0.34000000f,0.73000000f,0.25000000f,0.63000000f,0.13000000f,-0.18000000f,-0.23000000f,-0.68000000f,0.39000000f,0.65000000f,-0.08000000f,-0.96000000f,0.35000000f,-0.06000000f,0.81000000f,-0.34000000f,-0.91000000f,0.96000000f,-0.75000000f,0.61000000f,0.81000000f,-0.21000000f,0.21000000f,-0.89000000f,-0.13000000f,-0.92000000f,-0.11000000f,-0.25000000f,0.28000000f,0.31000000f,0.83000000f,0.96000000f,-0.13000000f,0.54000000f,0.95000000f,0.16000000f,0.49000000f,0.12000000f,0.13000000f,0.20000000f,0.37000000f,0.34000000f,0.87000000f,-0.11000000f,-0.28000000f,-0.05000000f,0.72000000f,-0.27000000f,0.44000000f,0.84000000f,-0.03000000f,0.69000000f,-0.79000000f,0.63000000f,0.81000000f,0.88000000f,0.98000000f,0.51000000f,-0.20000000f,0.54000000f,0.73000000f,-0.95000000f,-0.61000000f,0.33000000f,0.26000000f,0.51000000f,0.46000000f,0.43000000f,-0.04000000f,-0.29000000f,0.77000000f,0.34000000f,-0.43000000f,0.48000000f,0.42000000f,-0.14000000f,0.89000000f,-0.93000000f,-0.40000000f,0.77000000f,-0.04000000f,0.85000000f,0.98000000f,-0.26000000f,0.05000000f,-0.24000000f,-0.22000000f,-0.50000000f,-0.82000000f,-0.42000000f,0.63000000f,0.79000000f,-0.84000000f,-0.60000000f,0.20000000f,-0.41000000f,0.86000000f,0.51000000f,-0.17000000f,-0.20000000f,0.94000000f,-0.89000000f,-0.51000000f,-0.35000000f,0.73000000f,-0.53000000f,0.09000000f,0.49000000f,-0.72000000f,-0.47000000f,-0.72000000f,-0.58000000f,-0.28000000f,0.05000000f,-0.08000000f,-0.86000000f,-0.69000000f,-0.22000000f,-0.32000000f,0.17000000f,-0.58000000f,-0.49000000f,-0.62000000f,0.19000000f,-0.28000000f,-0.40000000f,-0.61000000f,0.75000000f,-0.87000000f,-0.96000000f,-0.47000000f,-0.04000000f,0.64000000f,0.80000000f,0.90000000f,-0.57000000f,0.40000000f,0.34000000f,-0.31000000f,-0.94000000f,0.79000000f,0.12000000f,0.55000000f,0.62000000f,0.44000000f,0.58000000f,-0.10000000f,-0.07000000f,0.35000000f,0.73000000f,0.42000000f,-0.05000000f,-0.16000000f,0.89000000f,-0.05000000f,-0.22000000f,-0.25000000f,-0.81000000f,-0.57000000f,0.78000000f,0.49000000f,0.06000000f,0.87000000f,0.61000000f,-0.01000000f,0.77000000f,0.63000000f,-0.15000000f,-0.17000000f,-0.42000000f,-0.59000000f,0.64000000f,0.85000000f,-0.70000000f,0.03000000f,-0.58000000f,0.25000000f,0.31000000f,0.72000000f,0.26000000f,-0.83000000f,-0.37000000f,-0.10000000f,-0.30000000f,-0.75000000f,-0.54000000f,0.13000000f,0.10000000f,0.75000000f,-0.66000000f,-0.73000000f,-0.41000000f,0.15000000f,0.51000000f,-0.72000000f,0.76000000f,0.98000000f,-0.41000000f,0.61000000f,-0.67000000f,-0.82000000f,-0.90000000f,0.57000000f,0.57000000f,0.82000000f,0.50000000f,0.74000000f,-0.06000000f,-0.19000000f,-0.49000000f,0.71000000f,0.82000000f,0.19000000f,-0.04000000f,0.55000000f,0.03000000f,0.59000000f,-0.65000000f,0.99000000f,0.74000000f,0.81000000f,-0.59000000f,-0.60000000f,0.73000000f,0.47000000f,0.73000000f,0.72000000f,-0.33000000f,0.29000000f,0.66000000f,0.72000000f,-0.21000000f,-0.90000000f,0.69000000f,0.40000000f,0.67000000f,0.07000000f,-0.39000000f,0.34000000f,0.94000000f,0.56000000f,0.61000000f,0.24000000f,-0.76000000f,0.53000000f,-0.15000000f,-0.70000000f,0.93000000f,0.42000000f,-0.12000000f,-0.50000000f,0.67000000f,-0.55000000f,0.73000000f,0.46000000f,-0.74000000f,0.90000000f,-0.68000000f,0.57000000f,-0.62000000f,-0.19000000f,-0.57000000f,0.37000000f,0.81000000f,-0.84000000f,0.73000000f,0.20000000f,-0.89000000f,-0.55000000f,0.01000000f,-0.12000000f,0.24000000f,-0.14000000f,-0.35000000f,0.99000000f,0.40000000f,0.11000000f,-0.83000000f,-0.25000000f,0.84000000f,0.89000000f,-0.51000000f,0.75000000f,0.44000000f,0.45000000f,-0.18000000f,-0.70000000f,0.83000000f,0.02000000f,-0.84000000f,0.46000000f,-0.83000000f,-0.02000000f,0.10000000f,0.44000000f,0.53000000f,-0.96000000f,0.70000000f,0.55000000f,0.37000000f,0.84000000f,-0.64000000f,-0.06000000f,0.94000000f,-0.58000000f,-0.83000000f,0.92000000f,0.11000000f,0.34000000f,-0.67000000f,-0.42000000f,-0.27000000f,-0.55000000f,-0.97000000f,-0.92000000f,-0.81000000f,-0.21000000f,-0.40000000f,0.73000000f,0.49000000f,0.60000000f,-0.56000000f,0.95000000f,-0.09000000f,-0.20000000f,-0.88000000f,-0.09000000f,-0.70000000f,-0.30000000f,-0.85000000f,-0.39000000f,0.94000000f,0.06000000f,0.06000000f,-0.09000000f,0.05000000f,0.61000000f,0.51000000f,0.60000000f,-0.78000000f,-0.89000000f,0.92000000f,-0.03000000f,-0.03000000f,0.41000000f,-0.10000000f,0.97000000f,0.67000000f,0.92000000f,0.70000000f,-0.22000000f,0.63000000f,0.77000000f,-0.46000000f,0.25000000f,0.17000000f,0.00000000f,-0.14000000f,-0.87000000f,0.49000000f,0.99000000f,0.42000000f,-0.67000000f,0.61000000f,0.34000000f,0.25000000f,-0.71000000f,-0.18000000f,0.24000000f,-0.27000000f,0.24000000f,-0.06000000f,-0.05000000f,-0.08000000f,0.70000000f,-0.19000000f,-0.29000000f,0.41000000f,0.78000000f,0.08000000f,-0.88000000f,0.39000000f,0.33000000f,-0.50000000f,0.00000000f,-0.35000000f,0.56000000f,-0.85000000f,0.06000000f,-0.02000000f,-0.91000000f,-0.58000000f,0.18000000f,0.66000000f,0.46000000f,0.96000000f,0.90000000f,0.74000000f,-0.17000000f,-0.80000000f,-0.38000000f,-0.01000000f,0.25000000f,-0.53000000f,0.21000000f,0.26000000f,-0.63000000f,-0.78000000f,0.32000000f,0.42000000f,-0.60000000f,-0.31000000f,-0.93000000f,0.36000000f,0.41000000f,0.47000000f,-0.41000000f,0.03000000f,0.37000000f,-0.93000000f,-0.75000000f,-0.10000000f,-0.44000000f,0.74000000f,0.96000000f,0.47000000f,0.69000000f,0.44000000f,0.07000000f,0.28000000f,-0.84000000f,-0.00000000f,-0.65000000f,0.23000000f,-0.17000000f,0.65000000f,-0.05000000f,-0.32000000f,-0.98000000f,0.67000000f,-0.45000000f,0.16000000f,0.26000000f,0.81000000f,0.81000000f,-0.72000000f,-0.23000000f,0.57000000f,-0.87000000f,0.76000000f,-0.57000000f,0.14000000f,-0.44000000f,0.31000000f,0.80000000f,-0.73000000f,0.83000000f,0.00000000f,-0.54000000f,0.10000000f,0.42000000f,0.54000000f,-0.18000000f,0.56000000f,0.35000000f,0.44000000f,-0.52000000f,0.69000000f,0.69000000f,0.94000000f,0.39000000f,0.96000000f,0.58000000f,-0.71000000f,0.98000000f,-0.92000000f,-0.11000000f,0.98000000f,0.90000000f,0.79000000f,0.63000000f,0.84000000f,-0.95000000f,0.61000000f,-0.52000000f,-0.10000000f,0.33000000f,0.10000000f,0.56000000f,0.74000000f,0.11000000f,-0.27000000f,-0.36000000f,0.88000000f,0.33000000f,-0.30000000f,0.67000000f,0.98000000f,0.19000000f,0.56000000f,0.85000000f,0.13000000f,-0.65000000f,-0.67000000f,0.86000000f,-0.03000000f,0.83000000f,-0.50000000f,-0.54000000f,-0.65000000f,-0.64000000f,-0.73000000f,-0.60000000f,0.68000000f,-0.71000000f,-0.36000000f,-0.81000000f,-0.27000000f,-0.06000000f,-0.04000000f,0.47000000f,-0.99000000f,-0.35000000f,-0.89000000f,0.55000000f,-0.39000000f,-0.94000000f,0.32000000f,-0.23000000f,-0.53000000f,0.37000000f,-0.17000000f,0.85000000f,0.27000000f,-0.10000000f,-0.81000000f,-0.31000000f,-0.22000000f,-0.30000000f,-0.29000000f,0.93000000f,0.08000000f,0.98000000f,0.32000000f,0.97000000f,0.86000000f,0.67000000f,0.39000000f,0.50000000f,0.06000000f,0.25000000f,-0.73000000f,-0.88000000f,-0.02000000f,0.88000000f,0.85000000f,0.38000000f,-0.29000000f,-0.99000000f,0.30000000f,-0.06000000f,0.14000000f,-0.02000000f,0.09000000f,-0.62000000f,0.41000000f,-0.46000000f,0.90000000f,0.06000000f,-0.78000000f,-0.10000000f,0.97000000f,0.66000000f,-0.96000000f,0.46000000f,0.12000000f,0.84000000f,0.89000000f,-0.28000000f,-0.65000000f,-0.71000000f,0.04000000f,0.34000000f,-0.98000000f,-0.27000000f,0.21000000f,0.13000000f,-0.56000000f,0.56000000f,0.71000000f,-0.55000000f,0.14000000f,0.81000000f,0.03000000f,-0.19000000f,0.82000000f,0.48000000f,-0.42000000f,0.73000000f,0.04000000f,0.48000000f,-0.10000000f,-0.78000000f,0.75000000f,-0.89000000f,-0.02000000f,0.60000000f,0.15000000f,-0.88000000f,0.01000000f,0.93000000f,-0.59000000f,0.43000000f,0.57000000f,0.14000000f,0.96000000f,0.75000000f,0.58000000f,0.69000000f,-0.92000000f,0.14000000f,0.94000000f,-0.42000000f,0.54000000f,-0.73000000f,0.91000000f,-0.89000000f,-0.95000000f,0.41000000f,0.26000000f,-0.46000000f,-0.64000000f,-0.65000000f,0.53000000f,-0.61000000f,-0.95000000f,-0.41000000f,-0.28000000f,-0.78000000f,-0.01000000f,-0.55000000f,0.69000000f,0.60000000f,-0.29000000f,0.81000000f,0.74000000f,0.39000000f,0.58000000f,-0.65000000f,0.37000000f,-0.88000000f,-0.11000000f,0.08000000f,-0.78000000f,0.01000000f,-0.46000000f,-0.12000000f,0.38000000f,-0.63000000f,0.66000000f,-0.33000000f,-0.51000000f,-0.16000000f,0.32000000f,0.40000000f,-0.03000000f,-0.35000000f,0.49000000f,-0.52000000f,-0.26000000f,-0.99000000f,-0.94000000f,0.18000000f,0.94000000f,0.37000000f,0.94000000f,0.85000000f,0.36000000f,-0.00000000f,0.36000000f,-0.94000000f,-0.47000000f,0.92000000f,0.75000000f,-0.29000000f,-0.82000000f,0.95000000f,0.29000000f,-0.47000000f,0.12000000f,-0.96000000f,0.06000000f,-0.56000000f,-0.20000000f,0.47000000f,0.15000000f,0.08000000f,-0.20000000f,-0.20000000f,-0.31000000f,0.44000000f,-0.83000000f,-0.03000000f,0.75000000f,-0.87000000f,0.90000000f,-0.39000000f,-0.06000000f,0.56000000f,0.03000000f,-0.03000000f,-0.37000000f,-0.08000000f,-0.25000000f,0.15000000f,-0.90000000f,0.29000000f,-0.94000000f,0.20000000f,0.71000000f,0.14000000f,-0.70000000f,0.98000000f,-0.77000000f,-0.97000000f,-0.43000000f,0.25000000f,-0.30000000f,0.28000000f,-0.04000000f,0.19000000f,0.40000000f,0.56000000f,-0.18000000f,-0.66000000f,0.66000000f,-0.21000000f,-0.48000000f,0.76000000f,0.87000000f,-0.63000000f,-0.12000000f,0.22000000f,-0.48000000f,-0.41000000f,-0.87000000f,-0.16000000f,-0.53000000f,0.25000000f,-0.31000000f,0.45000000f,-0.25000000f,0.46000000f,0.35000000f,0.64000000f,-0.45000000f,0.84000000f,-0.70000000f,0.19000000f,-0.96000000f,-0.68000000f,0.92000000f,-0.07000000f,0.10000000f,0.89000000f,0.25000000f,0.70000000f,0.52000000f,0.63000000f,-0.36000000f,0.11000000f,-0.39000000f,0.77000000f,0.59000000f,-0.01000000f,-0.60000000f,0.66000000f,-0.46000000f,0.64000000f,-0.21000000f,0.37000000f,-0.55000000f,0.27000000f,0.09000000f,-0.35000000f,0.07000000f,0.80000000f,-0.51000000f,-0.80000000f,-0.04000000f,0.59000000f,0.59000000f,-0.96000000f,-0.12000000f,-0.28000000f,0.71000000f,0.17000000f,-0.36000000f,0.35000000f,0.99000000f,-0.30000000f,-0.98000000f,0.52000000f,-0.62000000f,0.69000000f,-0.48000000f,0.34000000f,0.30000000f,-0.78000000f,-0.84000000f,0.46000000f,-0.36000000f,0.31000000f,-0.61000000f,-0.71000000f,0.46000000f,-0.97000000f,-0.97000000f,-0.18000000f,-0.42000000f,-0.22000000f,-0.42000000f,-0.08000000f,0.84000000f,-0.48000000f,-0.22000000f,-0.95000000f,-0.42000000f,-0.45000000f,0.17000000f,-0.58000000f,0.82000000f,-0.81000000f,0.23000000f,0.07000000f,-0.16000000f,0.93000000f,-0.82000000f,-0.78000000f,0.13000000f,-0.80000000f,-0.24000000f,-0.00000000f,0.75000000f,-0.59000000f,0.01000000f,0.71000000f,0.53000000f,0.02000000f,-0.97000000f,0.81000000f,-0.35000000f,0.15000000f,-0.32000000f,-0.11000000f,0.79000000f,-0.08000000f,0.82000000f,-0.99000000f,-0.68000000f,-0.48000000f,-0.08000000f,-0.03000000f,0.64000000f,0.48000000f,-0.69000000f,-0.82000000f,0.98000000f,0.86000000f,-0.32000000f,-0.86000000f,-0.08000000f,0.25000000f,-0.37000000f,-0.56000000f,0.04000000f,-0.53000000f,0.52000000f,0.89000000f,-0.26000000f,0.79000000f,0.97000000f,0.46000000f,0.07000000f,-0.99000000f,-0.91000000f,-0.03000000f,0.81000000f,0.06000000f,-0.56000000f,-0.68000000f,0.14000000f,-0.15000000f,0.33000000f,-0.26000000f,0.94000000f,0.76000000f,0.70000000f,0.70000000f,-0.88000000f,0.20000000f,0.02000000f,-0.32000000f,0.75000000f,0.34000000f,0.47000000f,0.63000000f,0.01000000f,-0.80000000f,0.31000000f,0.01000000f,-0.25000000f,0.20000000f,0.40000000f,-0.95000000f,0.52000000f,0.24000000f,-0.46000000f,0.61000000f,0.58000000f,-0.97000000f,-0.90000000f,-0.24000000f,0.18000000f,0.16000000f,0.56000000f,0.21000000f,-0.71000000f,-0.96000000f,-0.86000000f,0.04000000f,-0.11000000f,-0.09000000f,0.07000000f,-0.01000000f,-0.58000000f,-0.12000000f,-0.43000000f,-0.95000000f,0.45000000f,-0.87000000f,-0.07000000f,0.31000000f,0.02000000f,-0.22000000f,-0.62000000f,0.48000000f,0.19000000f,0.42000000f,-0.23000000f,0.70000000f,-0.56000000f,-0.19000000f,-0.54000000f,-0.15000000f,0.78000000f,-0.39000000f,-0.95000000f,0.36000000f,0.12000000f,-0.31000000f,0.93000000f,0.16000000f,0.92000000f,0.58000000f,-0.80000000f,0.76000000f,-0.16000000f,0.15000000f,0.93000000f,-0.18000000f,0.11000000f,0.97000000f,0.36000000f,-0.29000000f,0.56000000f,0.67000000f,-0.46000000f,-0.94000000f,0.64000000f,-0.87000000f,-0.72000000f,-0.86000000f,0.64000000f,0.34000000f,-0.00000000f,0.03000000f,-0.48000000f,-0.11000000f,0.09000000f,-0.89000000f,-0.85000000f,0.71000000f,-0.36000000f,-0.28000000f,0.04000000f,-0.88000000f,0.91000000f,0.19000000f,0.37000000f,-0.58000000f,0.29000000f,0.17000000f,0.33000000f,-0.62000000f,-0.32000000f,0.83000000f,0.00000000f,-0.95000000f,-0.03000000f,-0.80000000f,0.64000000f,0.10000000f,-0.11000000f,0.46000000f,0.54000000f,0.64000000f,-0.17000000f,-0.31000000f,-0.46000000f,0.85000000f,-0.42000000f,-0.27000000f,0.45000000f,0.06000000f,-0.11000000f,-0.20000000f,-0.30000000f,0.29000000f,0.73000000f,0.43000000f,-0.95000000f,0.46000000f,-0.04000000f,-0.51000000f,0.30000000f,0.82000000f,-0.93000000f,-0.86000000f,0.33000000f,-0.39000000f,-0.07000000f,-0.67000000f,-0.86000000f,-0.61000000f,0.48000000f,-0.35000000f,-0.57000000f,0.31000000f,0.05000000f,-0.72000000f,0.46000000f,-0.62000000f,-0.81000000f,-0.74000000f,0.59000000f,0.79000000f,0.77000000f,-0.31000000f,-0.38000000f,-0.85000000f,0.70000000f,0.39000000f,0.57000000f,0.52000000f,-0.08000000f,0.49000000f,-0.49000000f,-0.53000000f,0.61000000f,-0.21000000f,-0.04000000f,0.03000000f,0.54000000f,-0.49000000f,0.95000000f,-0.45000000f,-0.99000000f,-0.39000000f,0.19000000f,-0.74000000f,-0.43000000f,0.97000000f,-0.46000000f,-0.93000000f,-0.56000000f,0.17000000f,-0.74000000f,-0.87000000f,-0.20000000f,-0.87000000f,-0.60000000f,-0.66000000f,0.12000000f,-0.88000000f,-0.25000000f,-0.27000000f,0.36000000f,-0.22000000f,0.97000000f,-0.24000000f,0.35000000f,-0.30000000f,-0.10000000f,0.66000000f,-0.06000000f,-0.21000000f,-0.20000000f,0.87000000f,-0.13000000f,-0.25000000f,0.10000000f,-0.47000000f,-0.51000000f,0.55000000f,0.20000000f,0.14000000f,0.80000000f,-0.25000000f,0.81000000f,-0.19000000f,-0.04000000f,-0.05000000f,0.63000000f,-0.03000000f,-0.60000000f,0.39000000f,-0.25000000f,0.47000000f,-0.51000000f,-0.42000000f,-0.31000000f,-0.08000000f,0.76000000f,-0.64000000f,0.28000000f,-0.15000000f,0.89000000f,-0.39000000f,0.49000000f,-0.31000000f,0.39000000f,-0.48000000f,-0.24000000f,-0.97000000f,0.76000000f,-0.34000000f,-0.35000000f,-0.83000000f,-0.70000000f,-0.92000000f,0.37000000f,-0.05000000f,0.95000000f,0.49000000f,-0.04000000f,0.51000000f,-0.84000000f,0.56000000f,0.50000000f,0.85000000f,0.78000000f,-0.03000000f,-0.32000000f,0.31000000f,-0.13000000f,-0.38000000f,-0.34000000f,-0.15000000f,0.22000000f,-0.91000000f,0.97000000f,0.12000000f,0.71000000f,0.22000000f,0.98000000f,0.45000000f,-0.21000000f,-0.27000000f,0.31000000f,-0.47000000f,-0.90000000f,-0.90000000f,-0.83000000f,0.07000000f,0.20000000f,0.68000000f,-0.42000000f,-0.36000000f,-0.14000000f,0.29000000f,0.57000000f,0.76000000f,-0.18000000f,-0.89000000f,-0.30000000f,0.92000000f,-0.09000000f,-0.05000000f,0.96000000f,0.29000000f,0.07000000f,-0.65000000f,-0.78000000f,0.55000000f,0.17000000f,-0.39000000f,0.17000000f,0.62000000f,0.51000000f,0.00000000f,-0.61000000f,-0.52000000f,-0.57000000f,-0.99000000f,-0.65000000f,0.94000000f,-0.54000000f,-0.00000000f,0.99000000f,0.40000000f,-0.98000000f,0.38000000f,-0.15000000f,-0.91000000f,-0.47000000f,0.61000000f,-0.67000000f,0.79000000f,-0.01000000f,-0.04000000f,0.27000000f,0.27000000f,0.49000000f,0.71000000f,0.56000000f,-0.98000000f,0.42000000f,-0.30000000f,-0.48000000f,0.85000000f,-0.28000000f,0.02000000f,-0.26000000f,0.27000000f,0.40000000f,-0.61000000f,-0.48000000f,0.79000000f,0.08000000f,-0.04000000f,0.96000000f,0.86000000f,0.99000000f,-0.97000000f,0.79000000f,-0.96000000f,0.53000000f,0.61000000f,-0.16000000f,0.39000000f,0.02000000f,0.76000000f,-0.51000000f,0.19000000f,0.79000000f,0.20000000f,0.76000000f,0.26000000f,-0.95000000f,0.03000000f,0.06000000f,0.86000000f,-0.69000000f,0.46000000f,-0.55000000f,-0.71000000f,-0.91000000f,0.69000000f,0.53000000f,-0.27000000f,-0.02000000f,-0.34000000f,-0.78000000f,0.51000000f,0.04000000f,0.92000000f,-0.72000000f,-0.84000000f,0.01000000f,-0.95000000f,0.58000000f,-0.85000000f,0.86000000f,-0.70000000f,0.34000000f,0.14000000f,-0.22000000f,0.89000000f,0.44000000f,0.91000000f,0.51000000f,0.15000000f,0.56000000f,0.75000000f,-0.10000000f,0.34000000f,0.14000000f,-0.34000000f,-0.55000000f,0.77000000f,0.59000000f,0.11000000f,-0.16000000f,-0.12000000f,-0.89000000f,-0.45000000f,-0.56000000f,-0.93000000f,0.51000000f,-0.19000000f,0.82000000f,0.17000000f,0.65000000f,0.18000000f,0.69000000f,-0.72000000f,0.75000000f,0.40000000f,-0.37000000f,-0.55000000f,0.87000000f,0.58000000f,0.33000000f,-0.78000000f,0.29000000f,-0.17000000f,0.62000000f,-0.05000000f,0.39000000f,0.69000000f,0.90000000f,-0.53000000f,0.98000000f,0.74000000f,-0.34000000f,-0.34000000f,-0.25000000f,0.62000000f,0.96000000f,-0.30000000f,-0.54000000f,0.46000000f,-0.99000000f,0.13000000f,-0.40000000f,0.15000000f,-0.59000000f,-0.85000000f,0.18000000f,0.89000000f,-0.85000000f,0.56000000f,-0.23000000f,0.73000000f,0.17000000f,-0.76000000f,-0.23000000f,0.77000000f,0.82000000f,-0.72000000f,-0.94000000f,-0.95000000f,0.28000000f,0.74000000f,-0.97000000f,0.44000000f,-0.02000000f,0.40000000f,-0.53000000f,-0.83000000f,-0.57000000f,-0.07000000f,0.20000000f,0.27000000f,0.10000000f,-0.19000000f,0.99000000f,0.18000000f,-0.24000000f,0.73000000f,-0.30000000f,-0.83000000f,-0.34000000f,-0.16000000f,-0.23000000f,0.18000000f,-0.69000000f,-0.70000000f,0.52000000f,-0.33000000f,0.45000000f,-0.81000000f,-0.17000000f,0.03000000f,0.49000000f,0.80000000f,0.88000000f,-0.30000000f,0.17000000f,-0.69000000f,0.19000000f,0.67000000f,-0.78000000f,-0.84000000f,-0.75000000f,-0.81000000f,0.65000000f,0.50000000f,0.62000000f,0.19000000f,-0.91000000f,0.26000000f,-0.17000000f,-0.33000000f,0.19000000f,0.13000000f,0.32000000f,0.59000000f,-0.31000000f,0.88000000f,-0.33000000f,-0.42000000f,-0.34000000f,-0.05000000f,-0.35000000f,0.20000000f,0.31000000f,-0.21000000f,-0.30000000f,0.70000000f,0.10000000f,-0.28000000f,-0.27000000f,0.48000000f,0.45000000f,-0.67000000f,-0.14000000f,-0.41000000f,-0.80000000f,0.02000000f,0.03000000f,-0.49000000f,-0.73000000f,-0.94000000f,-0.28000000f,-0.11000000f,0.94000000f,-0.02000000f,0.06000000f,-0.64000000f,-0.87000000f,0.59000000f,-0.99000000f,-0.19000000f,0.50000000f,-0.12000000f,0.84000000f,0.98000000f,-0.69000000f,0.64000000f,0.93000000f,-0.93000000f,-0.42000000f,-0.96000000f,-0.26000000f,0.21000000f,0.48000000f,-0.64000000f,0.58000000f,-0.86000000f,-0.85000000f,-0.73000000f,-0.81000000f,0.08000000f,-0.89000000f,0.00000000f,-0.16000000f,0.78000000f,0.25000000f,-0.87000000f,-0.30000000f,-0.19000000f,0.58000000f,0.30000000f,-0.10000000f,0.54000000f,0.06000000f,-0.52000000f,-0.88000000f,0.63000000f,-0.34000000f,-0.19000000f,-0.92000000f,0.60000000f,-0.90000000f,-0.21000000f,-0.90000000f,-0.28000000f,-0.14000000f,-0.71000000f,0.49000000f,0.80000000f,-0.49000000f,-0.38000000f,0.57000000f,0.10000000f,-0.80000000f,0.25000000f,-0.38000000f,-0.12000000f,-0.52000000f,-0.01000000f,-0.72000000f,0.74000000f,-0.35000000f,0.88000000f,0.02000000f,-0.14000000f,-0.40000000f,-0.42000000f,0.12000000f,0.93000000f,-0.98000000f,0.95000000f,-0.34000000f,0.53000000f,0.00000000f,0.22000000f,0.35000000f,0.90000000f,-0.39000000f,-0.04000000f,-0.27000000f,-0.20000000f,0.90000000f,-0.00000000f,0.36000000f,-0.68000000f,-0.95000000f,0.21000000f,0.76000000f,0.29000000f,0.99000000f,-0.28000000f,0.02000000f,-0.79000000f,-0.39000000f,0.63000000f,-0.25000000f,0.64000000f,0.72000000f,-0.93000000f,-0.64000000f,0.34000000f,0.36000000f,0.76000000f,0.77000000f,0.27000000f,0.63000000f,0.28000000f,0.94000000f,0.80000000f,0.45000000f,0.49000000f,0.09000000f,0.22000000f,0.50000000f,0.44000000f,0.94000000f,-0.85000000f,0.32000000f,0.34000000f,0.02000000f,-0.04000000f,-0.50000000f,-0.54000000f,-0.96000000f,0.77000000f,-0.09000000f,-0.20000000f,-0.24000000f,-0.78000000f,0.36000000f,-0.73000000f,0.87000000f,0.23000000f,-0.99000000f,0.72000000f,-0.56000000f,0.79000000f,0.14000000f,-0.48000000f,0.37000000f,0.69000000f,0.91000000f,-0.58000000f,0.37000000f,-0.86000000f,-0.76000000f,-0.15000000f,-0.60000000f,-0.16000000f,0.13000000f,-0.97000000f,-0.08000000f,0.84000000f,-0.34000000f,-0.46000000f,0.23000000f,0.61000000f,-0.71000000f,0.71000000f,-0.07000000f,-0.72000000f,0.17000000f,-0.25000000f,0.58000000f,0.10000000f,0.90000000f,-0.80000000f,0.26000000f,0.21000000f,0.48000000f,-0.24000000f,-0.28000000f,0.27000000f,-0.80000000f,0.52000000f,-0.76000000f,0.87000000f,-0.71000000f,0.20000000f,-0.14000000f,0.17000000f,0.87000000f,-0.37000000f,-0.87000000f,0.62000000f,0.50000000f,0.89000000f,-0.66000000f,0.43000000f,-0.85000000f,0.70000000f,0.73000000f,-0.69000000f,-0.95000000f,-0.85000000f,-0.43000000f,0.94000000f,-0.15000000f,-0.69000000f,0.23000000f,-0.29000000f,0.76000000f,-0.62000000f,0.05000000f,-0.59000000f,0.59000000f,0.47000000f,0.27000000f,-0.13000000f,0.47000000f,-0.18000000f,-0.20000000f,0.02000000f,-0.43000000f,0.60000000f,0.11000000f,-0.26000000f,-0.41000000f,0.82000000f,0.66000000f,-0.31000000f,-0.32000000f,0.58000000f,0.86000000f,0.49000000f,-0.90000000f,0.40000000f,0.35000000f,-0.16000000f,0.48000000f,-0.46000000f,-0.02000000f,-0.07000000f,0.32000000f,-0.98000000f,-0.33000000f,0.33000000f,0.22000000f,-0.26000000f,0.09000000f,-0.79000000f,0.06000000f,0.54000000f,-0.87000000f,0.02000000f,0.83000000f,-0.33000000f,0.10000000f,0.50000000f,-0.44000000f,-0.45000000f,-0.97000000f,-0.51000000f,-0.90000000f,-0.56000000f,0.79000000f,-0.48000000f,0.41000000f,0.72000000f,-0.23000000f,0.91000000f,-0.07000000f,-0.38000000f,0.77000000f,-0.55000000f,-0.81000000f,-0.55000000f,0.75000000f,0.66000000f,-0.47000000f,0.44000000f,-0.90000000f,-0.06000000f,0.68000000f,-0.31000000f,-0.25000000f,-0.00000000f,0.47000000f,-0.12000000f,0.12000000f,0.99000000f,-0.62000000f,-0.84000000f,0.17000000f,0.92000000f,0.38000000f,-0.19000000f,-0.97000000f,0.48000000f,-0.89000000f,0.30000000f,-0.08000000f,0.03000000f,0.42000000f,0.14000000f,0.36000000f,-0.26000000f,-0.09000000f,0.41000000f,0.76000000f,0.66000000f,-0.11000000f,-0.19000000f,0.22000000f,-0.11000000f,0.39000000f,0.68000000f,-0.81000000f,0.87000000f,0.04000000f,0.54000000f,0.02000000f,0.05000000f,-0.24000000f,0.05000000f,0.57000000f,-0.81000000f,-0.77000000f,-0.09000000f,-0.35000000f,-0.00000000f,-0.61000000f,0.03000000f,-0.48000000f,0.40000000f,-0.22000000f,-0.19000000f,-0.55000000f,-0.53000000f,-0.32000000f,-0.17000000f,-0.08000000f,0.57000000f,0.18000000f,0.41000000f,0.54000000f,0.21000000f,-0.25000000f,0.07000000f,0.76000000f,-0.97000000f,-0.79000000f,-0.03000000f,-0.56000000f,-0.50000000f,-0.55000000f,-0.58000000f,0.59000000f,0.82000000f,-0.18000000f,-0.50000000f,-0.32000000f,-0.83000000f,-0.44000000f,-0.94000000f,-0.70000000f,0.90000000f,-0.23000000f,-0.23000000f,-0.83000000f,0.35000000f,-0.45000000f,0.31000000f,0.52000000f,-0.14000000f,0.79000000f,-0.30000000f,-0.51000000f,0.99000000f,0.47000000f,0.00000000f,-0.42000000f,0.43000000f,-0.52000000f,0.68000000f,-0.11000000f,0.54000000f,0.98000000f,0.66000000f,-0.32000000f,0.13000000f,-0.87000000f,-0.20000000f,0.27000000f,-0.74000000f,0.64000000f,-0.08000000f,-0.68000000f,-0.78000000f,0.45000000f,-0.37000000f,0.23000000f,0.79000000f,-0.03000000f,-0.09000000f,0.27000000f,-0.46000000f,-0.22000000f,-0.39000000f,0.92000000f,0.80000000f,-0.83000000f,0.89000000f,0.42000000f,0.75000000f,-0.59000000f,-0.26000000f,-0.62000000f,-0.37000000f,-0.07000000f,0.97000000f,-0.90000000f,0.39000000f,-0.50000000f,-0.20000000f,-0.54000000f,0.34000000f,-0.43000000f,-0.82000000f,-0.35000000f,0.42000000f,-0.46000000f,0.48000000f,-0.69000000f,0.33000000f,0.19000000f,0.99000000f,0.06000000f,-0.30000000f,-0.99000000f,0.13000000f,0.47000000f,-0.23000000f,-0.47000000f,0.07000000f,0.82000000f,-0.58000000f,0.42000000f,-0.83000000f,-0.19000000f,-0.98000000f,-0.80000000f,0.28000000f,0.15000000f,0.44000000f,-0.87000000f,0.99000000f,-0.46000000f,-0.85000000f,-0.07000000f,-0.46000000f,-0.93000000f,0.87000000f,0.49000000f,-0.09000000f,-0.74000000f,-0.43000000f,-0.94000000f,0.44000000f,0.50000000f,-0.84000000f,-0.51000000f,0.50000000f,-0.33000000f,0.58000000f,0.22000000f,-0.89000000f,-0.65000000f,0.39000000f,0.01000000f,0.94000000f,-0.73000000f,-0.30000000f,0.69000000f,0.47000000f,0.11000000f,-0.30000000f,-0.16000000f,-0.58000000f,0.76000000f,-0.78000000f,-0.84000000f,0.83000000f,0.96000000f,-0.44000000f,-0.40000000f,-0.28000000f,0.76000000f,-0.47000000f,-0.00000000f,0.91000000f,0.12000000f,0.58000000f,0.64000000f,0.61000000f,0.30000000f,-0.55000000f,-0.33000000f,0.40000000f,0.17000000f,0.35000000f,0.93000000f,-0.63000000f,0.33000000f,0.21000000f,-0.03000000f,-0.55000000f,0.37000000f,0.55000000f,-0.14000000f,-0.37000000f,-0.32000000f,-0.41000000f,-0.50000000f,-0.30000000f,0.49000000f,-0.16000000f,-0.13000000f,-0.77000000f,-0.82000000f,-0.16000000f,0.67000000f,-0.83000000f,-0.87000000f,0.17000000f,0.39000000f,-0.72000000f,-0.09000000f,0.28000000f,0.43000000f,0.44000000f,-0.28000000f,0.23000000f,0.33000000f,-0.95000000f,0.94000000f,-0.70000000f,0.03000000f,-0.73000000f,-0.06000000f,0.90000000f,-0.13000000f,0.39000000f,-0.57000000f,0.13000000f,-0.00000000f,0.30000000f,-0.83000000f,0.53000000f,-0.61000000f,0.27000000f,0.84000000f,0.98000000f,0.98000000f,-0.34000000f,-0.83000000f,-0.36000000f,0.16000000f,-0.93000000f,-0.45000000f,0.23000000f,0.22000000f,0.18000000f,0.80000000f,-0.56000000f,-0.34000000f,-0.40000000f,-0.84000000f,-0.63000000f,0.98000000f,-0.07000000f,-0.36000000f,0.52000000f,0.06000000f,-0.61000000f,-0.19000000f,0.10000000f,0.60000000f,0.37000000f,-0.74000000f,0.84000000f,-0.86000000f,0.63000000f,0.75000000f,-0.48000000f,0.93000000f,-0.39000000f,-0.01000000f,0.43000000f,0.24000000f,-0.49000000f,-0.36000000f,-0.97000000f,-0.56000000f,-0.08000000f,0.61000000f,0.38000000f,-0.25000000f,0.81000000f,0.42000000f,0.42000000f,0.95000000f,0.18000000f,-0.14000000f,0.12000000f,-0.32000000f,-0.62000000f,0.84000000f,-0.92000000f,-0.57000000f,0.57000000f,-0.18000000f,-0.70000000f,0.39000000f,0.48000000f,0.37000000f,-0.34000000f,-0.65000000f,-0.42000000f,-0.81000000f,0.50000000f,-0.27000000f,-0.63000000f,0.09000000f,-0.97000000f,0.76000000f,-0.86000000f,-0.93000000f,-0.67000000f,-0.86000000f,-0.69000000f,0.15000000f,-0.21000000f,0.20000000f,-0.52000000f,-0.65000000f,0.80000000f,-0.69000000f,-0.78000000f,0.23000000f,-0.69000000f,-0.84000000f,0.09000000f,0.53000000f,-0.24000000f,0.44000000f,0.16000000f,-0.10000000f,0.46000000f,-0.63000000f,-0.50000000f,-0.08000000f,0.33000000f,0.76000000f,-0.37000000f,-0.16000000f,0.81000000f,0.44000000f,0.02000000f,0.33000000f,-0.73000000f,0.72000000f,-0.08000000f,-0.47000000f,0.59000000f,0.76000000f,-0.83000000f,0.09000000f,-0.90000000f,-0.91000000f,-0.53000000f,0.80000000f,-0.51000000f,0.33000000f,-0.78000000f,0.47000000f,-0.71000000f,-0.58000000f,0.22000000f,0.53000000f,-0.10000000f,-0.00000000f,0.10000000f,-0.71000000f,0.94000000f,0.18000000f,-0.67000000f,-0.10000000f,-0.95000000f,0.52000000f,0.87000000f,-0.45000000f,0.68000000f,-0.00000000f,-0.78000000f,-0.01000000f,-0.04000000f,0.39000000f,0.02000000f,0.77000000f,0.82000000f,-0.98000000f,-0.90000000f,-0.63000000f,-0.31000000f,-0.97000000f,0.29000000f,-0.00000000f,0.55000000f,-0.58000000f,0.97000000f,-0.35000000f,0.16000000f,-0.56000000f,0.06000000f,0.97000000f,0.54000000f,0.80000000f,-0.59000000f,0.87000000f,0.74000000f,-0.31000000f,-0.24000000f,0.39000000f,0.43000000f,0.33000000f,-0.12000000f,-0.30000000f,0.61000000f,0.77000000f,0.23000000f,-0.05000000f,-0.13000000f,0.14000000f,0.76000000f,-0.12000000f,0.53000000f,-0.56000000f,-0.75000000f,-0.84000000f,-0.97000000f,0.33000000f,0.65000000f,0.16000000f,-0.46000000f,0.28000000f,-0.39000000f,0.40000000f,0.03000000f,-0.36000000f,0.97000000f,-0.27000000f,-0.31000000f,-0.34000000f,0.68000000f,-0.15000000f,-0.09000000f,0.84000000f,0.29000000f,0.90000000f,-0.42000000f,-0.82000000f,0.89000000f,0.15000000f,0.20000000f,-0.32000000f,-0.03000000f,0.29000000f,0.61000000f,-0.52000000f,-0.62000000f,-0.93000000f,0.79000000f,0.28000000f,-0.03000000f,0.03000000f,-0.54000000f,-0.61000000f,0.31000000f,-0.91000000f,0.92000000f,-0.18000000f,-0.12000000f,0.79000000f,-0.24000000f,-0.40000000f,0.46000000f,-0.63000000f,-0.93000000f,0.82000000f,0.40000000f,-0.09000000f,0.12000000f,-0.77000000f,-0.13000000f,-0.58000000f,0.86000000f,-0.86000000f,0.50000000f,-0.72000000f,-0.46000000f,-0.81000000f,0.94000000f,-0.66000000f,0.24000000f,-0.78000000f,-0.79000000f,-0.48000000f,0.49000000f,0.47000000f,-0.04000000f,-0.83000000f,-0.49000000f,-0.48000000f,-0.16000000f,-0.18000000f,0.03000000f,-0.90000000f,-0.47000000f,-0.26000000f,0.38000000f,0.90000000f,-0.81000000f,-0.64000000f,-0.29000000f,0.69000000f,0.62000000f,-0.99000000f,0.50000000f,0.94000000f,0.68000000f,-0.00000000f,0.51000000f,0.26000000f,-0.78000000f,-0.71000000f,0.63000000f,-0.81000000f,-0.18000000f,-0.30000000f,0.28000000f,0.18000000f,-0.20000000f,-0.44000000f,0.26000000f,-0.13000000f,-0.86000000f,0.77000000f,0.78000000f,-0.19000000f,-0.15000000f,-0.77000000f,0.37000000f,-0.01000000f,-0.21000000f,-0.07000000f,-0.78000000f,0.54000000f,0.78000000f,0.38000000f,0.69000000f,0.32000000f,0.04000000f,0.42000000f,-0.40000000f,0.06000000f,0.79000000f,-0.26000000f,-0.15000000f,-0.27000000f,0.23000000f,-0.37000000f,0.90000000f,-0.22000000f,0.73000000f,-0.87000000f,0.59000000f,-0.53000000f,-0.35000000f,-0.88000000f,0.82000000f,-0.57000000f,-0.86000000f,-0.38000000f,-0.87000000f,0.72000000f,0.51000000f,0.56000000f,0.32000000f,0.27000000f,0.86000000f,0.96000000f,-0.40000000f,-0.54000000f,-0.54000000f,0.64000000f,0.99000000f,-0.50000000f,0.29000000f,0.58000000f,0.66000000f,-0.58000000f,0.23000000f,0.24000000f,-0.67000000f,-0.23000000f,0.31000000f,0.47000000f,-0.91000000f,0.56000000f,0.97000000f,0.06000000f,-0.68000000f,-0.36000000f,0.47000000f,0.98000000f,0.41000000f,-0.71000000f,-0.38000000f,0.94000000f,-0.28000000f,0.10000000f,0.87000000f,0.63000000f,0.19000000f,-0.93000000f,-0.64000000f,0.35000000f,0.85000000f,-0.33000000f,0.62000000f,-0.54000000f,0.37000000f,0.92000000f,-0.22000000f,-0.55000000f,-0.59000000f,-0.06000000f,-0.81000000f,0.81000000f,-0.05000000f,0.70000000f,0.47000000f,0.62000000f,-0.69000000f,-0.19000000f,0.37000000f,-0.57000000f,0.66000000f,-0.14000000f,-0.97000000f,-0.71000000f,0.57000000f,0.66000000f,-0.46000000f,0.66000000f,-0.11000000f,0.91000000f,0.75000000f,-0.02000000f,0.14000000f,-0.25000000f,-0.32000000f,0.92000000f,-0.58000000f,0.48000000f,0.62000000f,0.23000000f,0.06000000f,0.17000000f,-0.28000000f,0.81000000f,0.78000000f,-0.14000000f,0.09000000f,0.12000000f,0.27000000f,0.36000000f,0.92000000f,-0.06000000f,-0.52000000f,-0.17000000f,0.36000000f,-0.22000000f,-0.41000000f,-0.64000000f,0.64000000f,-0.69000000f,-0.68000000f,-0.07000000f,-0.12000000f,0.73000000f,0.88000000f,-0.49000000f,0.00000000f,-0.93000000f,-0.45000000f,-0.39000000f,0.67000000f,-0.02000000f,-0.55000000f,0.61000000f,0.51000000f,0.41000000f,0.27000000f,0.19000000f,-0.49000000f,0.14000000f,0.16000000f,-0.45000000f,-0.31000000f,0.70000000f,-0.17000000f,0.52000000f,-0.34000000f,0.66000000f,0.84000000f,0.47000000f,-0.90000000f,-0.38000000f,0.21000000f,0.55000000f,0.86000000f,0.86000000f,-0.79000000f,-0.44000000f,-0.51000000f,-0.09000000f,-0.30000000f,-0.39000000f,-0.18000000f,-0.81000000f,0.32000000f,-0.90000000f,-0.14000000f,-0.24000000f,0.77000000f,-0.68000000f,0.09000000f,0.64000000f,0.08000000f,0.15000000f,-0.36000000f,0.51000000f,-0.54000000f,-0.34000000f,-0.73000000f,-0.25000000f,0.66000000f,-0.33000000f,0.23000000f,-0.93000000f,0.40000000f,0.62000000f,0.12000000f,0.23000000f,0.20000000f,0.57000000f,-0.52000000f,0.08000000f,0.53000000f,0.10000000f,0.79000000f,-0.63000000f,0.46000000f,-0.12000000f,0.21000000f,0.60000000f,0.84000000f,0.84000000f,-0.54000000f,-0.24000000f,-0.75000000f,0.71000000f,0.94000000f,0.81000000f,-0.07000000f,-0.96000000f,-0.51000000f,0.40000000f,-0.26000000f,0.34000000f,-0.79000000f,-0.95000000f,-0.58000000f,0.54000000f,-0.48000000f,-0.83000000f,-0.71000000f,-0.45000000f,-0.68000000f,0.05000000f,0.28000000f,0.58000000f,0.16000000f,0.48000000f,0.09000000f,0.09000000f,0.13000000f,0.76000000f,-0.54000000f,0.14000000f,-0.47000000f,0.95000000f,-0.40000000f,0.96000000f,-0.26000000f,-0.38000000f,-0.54000000f,0.05000000f,0.77000000f,-0.84000000f,-0.88000000f,0.81000000f,-0.69000000f,-0.93000000f,-0.03000000f,0.32000000f,0.60000000f,-0.59000000f,-0.07000000f,-0.66000000f,0.68000000f,-0.77000000f,-0.55000000f,0.31000000f,-0.22000000f,-0.20000000f,0.13000000f,0.32000000f,0.32000000f,0.32000000f,-0.86000000f,-0.19000000f,0.12000000f,0.82000000f,0.38000000f,0.73000000f,0.07000000f,0.09000000f,-0.04000000f,-0.62000000f,0.13000000f,-0.51000000f,-0.87000000f,-0.48000000f,0.07000000f,0.13000000f,-0.16000000f,0.68000000f,-0.97000000f,-0.59000000f,0.00000000f,0.24000000f,-0.67000000f,-0.57000000f,0.59000000f,0.64000000f,0.36000000f,-0.50000000f,0.01000000f,0.94000000f,0.33000000f,0.69000000f,0.24000000f,-0.96000000f,0.31000000f,-0.21000000f,0.77000000f,-0.78000000f,-0.87000000f,0.73000000f,0.55000000f,0.46000000f,0.95000000f,0.99000000f,0.64000000f,0.03000000f,0.04000000f,-0.19000000f,-0.03000000f,0.54000000f,0.19000000f,-0.09000000f,0.57000000f,0.25000000f,0.75000000f,-0.22000000f,0.45000000f,0.23000000f,-0.52000000f,-0.27000000f,-0.83000000f,0.01000000f,-0.08000000f,-0.51000000f,0.26000000f,-0.36000000f,-0.30000000f,-0.77000000f,0.17000000f,-0.02000000f,-0.57000000f,-0.29000000f,-0.47000000f,-0.53000000f,0.97000000f,0.49000000f,0.03000000f,0.52000000f,0.93000000f,0.71000000f,0.82000000f,-0.35000000f,0.38000000f,0.47000000f,-0.92000000f,-0.36000000f,0.69000000f,-0.88000000f,0.58000000f,-0.02000000f,-0.80000000f,-0.69000000f,0.56000000f,-0.15000000f,-0.74000000f,0.88000000f,0.35000000f,0.24000000f,0.03000000f,-0.43000000f,-0.03000000f,-0.97000000f,0.17000000f,-0.92000000f,0.44000000f,-0.57000000f,-0.90000000f,0.50000000f,0.26000000f,-0.87000000f,0.25000000f,-0.70000000f,-0.19000000f,0.56000000f,0.92000000f,0.09000000f,0.55000000f,-0.38000000f,0.28000000f,0.91000000f,-0.25000000f,0.55000000f,0.46000000f,-0.80000000f,0.24000000f,-0.66000000f,0.32000000f,-0.05000000f,-0.09000000f,0.12000000f,0.86000000f,0.66000000f,-0.93000000f,0.88000000f,-0.31000000f,-0.13000000f,0.68000000f,0.84000000f,-0.58000000f,0.19000000f,-0.61000000f,-0.06000000f,-0.01000000f,0.10000000f,-0.77000000f,0.36000000f,-0.05000000f,0.96000000f,0.83000000f,-0.66000000f,0.81000000f,0.54000000f,0.46000000f,-0.93000000f,0.19000000f,-0.75000000f,0.85000000f,-0.26000000f,-0.03000000f,-0.77000000f,0.54000000f,-0.54000000f,0.72000000f,-0.05000000f,-0.81000000f,0.58000000f,-0.34000000f,-0.53000000f,0.98000000f,0.96000000f,-0.55000000f,0.99000000f,-0.48000000f,-0.29000000f,-0.01000000f,0.09000000f,-0.02000000f,-0.34000000f,-0.15000000f,0.44000000f,-0.54000000f,-0.82000000f,-0.35000000f,-0.87000000f,-0.45000000f,0.80000000f,0.74000000f,0.86000000f,0.75000000f,0.66000000f,-0.69000000f,-0.29000000f,-0.18000000f,0.17000000f,-0.50000000f,0.66000000f,0.37000000f,0.75000000f,-0.44000000f,-0.07000000f,0.06000000f,-0.36000000f,-0.10000000f,-0.63000000f,0.12000000f,-0.25000000f,-0.71000000f,-0.51000000f,-0.75000000f,-0.46000000f,0.52000000f,-0.36000000f,-0.97000000f,0.75000000f,-0.23000000f,0.26000000f,-0.27000000f,0.78000000f,-0.93000000f,-0.54000000f,0.00000000f,0.73000000f,0.05000000f,0.00000000f,-0.95000000f,0.19000000f,0.53000000f,-0.57000000f,0.82000000f,-0.48000000f,-0.46000000f,0.37000000f,0.74000000f,-0.99000000f,0.46000000f,-0.10000000f,0.91000000f,0.83000000f,-0.45000000f,-0.37000000f,-0.05000000f,-0.75000000f,-0.23000000f,-0.88000000f,-0.16000000f,-0.97000000f,0.80000000f,0.64000000f,-0.57000000f,0.53000000f,-0.70000000f,-0.19000000f,0.96000000f,0.26000000f,-0.70000000f,0.59000000f,-0.32000000f,0.49000000f,-0.25000000f,-0.01000000f,0.57000000f,-0.21000000f,0.04000000f,-0.32000000f,0.23000000f,0.19000000f,-0.17000000f,-0.58000000f,-0.27000000f,-0.50000000f,-0.59000000f,-0.77000000f,0.07000000f,-0.37000000f,0.13000000f,-0.83000000f,0.31000000f,0.63000000f,-0.55000000f,-0.32000000f,-0.66000000f,-0.61000000f,-0.95000000f,0.04000000f,0.58000000f,0.19000000f,0.50000000f,-0.79000000f,0.32000000f,0.89000000f,0.58000000f,-0.28000000f,0.21000000f,-0.36000000f,0.84000000f,0.24000000f,-0.18000000f,0.96000000f,-0.43000000f,0.17000000f,-0.38000000f,-0.07000000f,0.05000000f,0.91000000f,-0.41000000f,-0.24000000f,0.93000000f,-0.46000000f,-0.51000000f,0.93000000f,0.49000000f,0.17000000f,0.72000000f,-0.07000000f,-0.94000000f,-0.04000000f,0.87000000f,0.86000000f,-0.73000000f,-0.76000000f,-0.54000000f,-0.03000000f,0.83000000f,0.62000000f,0.76000000f,-0.72000000f,-0.76000000f,0.95000000f,0.32000000f,0.61000000f,0.45000000f,0.63000000f,0.89000000f,-0.73000000f,0.63000000f,0.30000000f,-0.75000000f,-0.03000000f,0.64000000f,0.48000000f,-0.94000000f,-0.40000000f,0.28000000f,0.91000000f,0.29000000f,-0.02000000f,0.62000000f,-0.06000000f,0.07000000f,0.86000000f,0.31000000f,0.93000000f,0.41000000f,0.58000000f,0.67000000f,-0.30000000f,0.64000000f,0.59000000f,-0.33000000f,-0.77000000f,-0.52000000f,0.74000000f,-0.58000000f,0.93000000f,-0.17000000f,-0.49000000f,-0.91000000f,0.82000000f,-0.57000000f,0.05000000f,0.17000000f,0.44000000f,0.72000000f,-0.95000000f,-0.29000000f,0.70000000f,-0.96000000f,-0.11000000f,0.31000000f,-0.52000000f,-0.97000000f,-0.58000000f,0.46000000f,-0.06000000f,-0.30000000f,0.25000000f,0.16000000f,-0.38000000f,0.72000000f,0.47000000f,0.47000000f,0.84000000f,0.64000000f,-0.61000000f,-0.39000000f,-0.78000000f,0.58000000f,0.19000000f,-0.05000000f,0.38000000f,0.35000000f,0.11000000f,-0.16000000f,0.85000000f,-0.63000000f,0.88000000f,0.22000000f,0.79000000f,0.30000000f,-0.50000000f,-0.90000000f,0.41000000f,0.16000000f,0.40000000f,-0.38000000f,-0.94000000f,-0.61000000f,-0.02000000f,0.13000000f,-0.84000000f,0.86000000f,0.61000000f,0.08000000f,0.00000000f,0.13000000f,-0.58000000f,0.09000000f,-0.10000000f,-0.21000000f,-0.89000000f,-0.53000000f,0.41000000f,0.02000000f,0.93000000f,0.94000000f,-0.95000000f,0.14000000f,-0.81000000f,0.51000000f,0.00000000f,-0.23000000f,0.11000000f,-0.50000000f,-0.62000000f,-0.57000000f,0.46000000f,0.65000000f,0.98000000f,0.61000000f,0.67000000f,-0.32000000f,-0.09000000f,-0.70000000f,0.62000000f,0.40000000f,-0.69000000f,0.15000000f,0.73000000f,0.76000000f,0.49000000f,-0.10000000f,-0.13000000f,0.93000000f,0.72000000f,0.08000000f,0.96000000f,0.44000000f,0.63000000f,-0.68000000f,-0.69000000f,0.35000000f,0.50000000f,-0.73000000f,0.58000000f,0.85000000f,-0.21000000f,0.32000000f,-0.87000000f,0.05000000f,-0.05000000f,0.35000000f,0.63000000f,-0.24000000f,-0.96000000f,-0.42000000f,-0.05000000f,0.75000000f,0.07000000f,-0.91000000f,-0.35000000f,-0.80000000f,-0.48000000f,-0.86000000f,-0.35000000f,0.42000000f,0.88000000f,0.38000000f,0.53000000f,-0.74000000f,-0.61000000f,0.14000000f,-0.43000000f,0.68000000f,-0.02000000f,-0.30000000f,-0.81000000f,-0.39000000f,0.32000000f,-0.39000000f,0.23000000f,-0.82000000f,0.17000000f,-0.05000000f,-0.45000000f,-0.37000000f,0.57000000f,-0.44000000f,0.72000000f,-0.00000000f,0.84000000f,0.98000000f,-0.03000000f,-0.34000000f,-0.51000000f,-0.27000000f,0.46000000f,-0.49000000f,0.86000000f,-0.15000000f,-0.70000000f,0.91000000f,-0.87000000f,-0.44000000f,0.68000000f,0.96000000f,0.20000000f,-0.22000000f,0.96000000f,-0.46000000f,-0.18000000f,0.42000000f,-0.02000000f,-0.66000000f,0.85000000f,0.23000000f,0.03000000f,0.28000000f,-0.56000000f,-0.20000000f,-0.94000000f,0.90000000f,-0.11000000f,-0.63000000f,-0.19000000f,-0.37000000f,0.29000000f,0.18000000f,-0.32000000f,0.41000000f,-0.42000000f,0.95000000f,-0.88000000f,0.74000000f,-0.55000000f,-0.36000000f,-0.70000000f,0.09000000f,0.08000000f,-0.33000000f,0.16000000f,0.67000000f,0.46000000f,-0.94000000f,-0.47000000f,0.94000000f,0.61000000f,-0.40000000f,0.97000000f,-0.08000000f,0.29000000f,0.61000000f,-0.88000000f,0.66000000f,0.83000000f,-0.84000000f,0.61000000f,0.66000000f,0.92000000f,0.26000000f,-0.12000000f,-0.25000000f,-0.01000000f,-0.07000000f,-0.98000000f,-0.45000000f,0.92000000f,-0.29000000f,-0.48000000f,0.08000000f,0.16000000f,0.53000000f,0.96000000f,0.55000000f,0.39000000f,-0.61000000f,0.45000000f,-0.45000000f,-0.09000000f,0.10000000f,-0.07000000f,-0.11000000f,-0.87000000f,-0.43000000f,0.32000000f,0.91000000f,-0.72000000f,-0.75000000f,0.55000000f,-0.80000000f,0.33000000f,0.03000000f,-0.19000000f,-0.93000000f,-0.65000000f,0.92000000f,-0.26000000f,0.89000000f,0.50000000f,0.28000000f,-0.98000000f,-0.55000000f,-0.80000000f,-0.50000000f,0.33000000f,0.08000000f,0.85000000f,-0.33000000f,0.57000000f,-0.59000000f,0.97000000f,0.95000000f,0.51000000f,0.60000000f,-0.80000000f,0.92000000f,-0.55000000f,0.10000000f,0.13000000f,-0.89000000f,0.04000000f,-0.75000000f,0.73000000f,0.80000000f,0.87000000f,0.23000000f,0.59000000f,-0.63000000f,0.70000000f,-0.95000000f,0.82000000f,-0.27000000f,0.54000000f,0.19000000f,0.96000000f,0.95000000f,-0.81000000f,0.02000000f,0.45000000f,0.40000000f,-0.52000000f,-0.74000000f,0.27000000f,0.37000000f,-0.27000000f,-0.23000000f,0.24000000f,0.28000000f,0.27000000f,0.38000000f,0.62000000f,-0.84000000f,0.22000000f,-0.88000000f,-0.77000000f,0.61000000f,-0.22000000f,-0.26000000f,0.59000000f,0.63000000f,0.49000000f,-0.77000000f,0.30000000f,-0.57000000f,0.39000000f,-0.21000000f,-0.68000000f,0.43000000f,0.60000000f,0.30000000f,-0.51000000f,-0.28000000f,0.26000000f,-0.06000000f,-0.68000000f,0.50000000f,-0.07000000f,0.16000000f,0.25000000f,-0.39000000f,-0.08000000f,0.81000000f,0.83000000f,-0.72000000f,-0.67000000f,0.35000000f,-0.08000000f,0.37000000f,-0.24000000f,0.64000000f,0.37000000f,-0.17000000f,0.61000000f,-0.35000000f,0.21000000f,0.72000000f,0.98000000f,0.38000000f,-0.14000000f,0.59000000f,0.45000000f,0.30000000f,0.61000000f,0.62000000f,0.56000000f,-0.66000000f,-0.39000000f,0.11000000f,-0.43000000f,-0.08000000f,0.75000000f,0.31000000f,-0.64000000f,-0.53000000f,0.41000000f,0.48000000f,0.54000000f,0.62000000f,-0.64000000f,-0.58000000f,-0.00000000f,0.05000000f,-0.62000000f,-0.65000000f,0.72000000f,-0.90000000f,0.29000000f,-0.56000000f,-0.68000000f,0.98000000f,0.84000000f,-0.43000000f,0.16000000f,-0.43000000f,0.16000000f,-0.86000000f,0.23000000f,0.70000000f,-0.94000000f,-0.74000000f,0.41000000f,0.20000000f,0.02000000f,-0.35000000f,-0.99000000f,-0.87000000f,-0.65000000f,0.77000000f,0.32000000f,0.92000000f,0.14000000f,0.95000000f,-0.80000000f,-0.14000000f,0.10000000f,0.60000000f,0.06000000f,0.19000000f,0.28000000f,0.32000000f,-0.87000000f,0.32000000f,-0.61000000f,-0.94000000f,-0.76000000f,0.91000000f,-0.77000000f,-0.80000000f,-0.33000000f,0.36000000f,-0.66000000f,0.50000000f,0.06000000f,-0.79000000f,-0.14000000f,0.38000000f,0.54000000f,-0.34000000f,-0.51000000f,-0.35000000f,-0.78000000f,0.40000000f,0.78000000f,-0.55000000f,-0.93000000f,0.77000000f,-0.93000000f,0.69000000f,0.86000000f,-0.07000000f,-0.78000000f,-0.16000000f,0.30000000f,-0.95000000f,-0.53000000f,0.73000000f,-0.75000000f,-0.55000000f,-0.16000000f,-0.30000000f,-0.74000000f,0.95000000f,-0.18000000f,-0.65000000f,0.99000000f,-0.87000000f,0.49000000f,0.24000000f,-0.06000000f,0.58000000f,-0.93000000f,-0.93000000f,-0.36000000f,0.74000000f,0.54000000f,-0.62000000f,0.09000000f,0.09000000f,-0.05000000f,-0.06000000f,0.15000000f,-0.69000000f,-0.22000000f,-0.20000000f,0.70000000f,0.56000000f,-0.30000000f,-0.70000000f,-0.69000000f,-0.10000000f,0.44000000f,-0.01000000f,-0.95000000f,-0.85000000f,0.53000000f,-0.05000000f,0.00000000f,-0.66000000f,0.05000000f,-0.52000000f,0.64000000f,-0.21000000f,0.22000000f,-0.25000000f,-0.22000000f,0.28000000f,-0.70000000f,0.57000000f,-0.90000000f,-0.33000000f,-0.69000000f,-0.14000000f,0.08000000f,-0.38000000f,-0.14000000f,-0.97000000f,0.84000000f,0.69000000f,-0.38000000f,0.36000000f,0.42000000f,-0.39000000f,0.29000000f,0.50000000f,-0.36000000f,-0.58000000f,-0.40000000f,0.88000000f,0.70000000f,0.59000000f,0.88000000f,0.90000000f,-0.10000000f,-0.22000000f,-0.68000000f,-0.92000000f,-0.55000000f,-0.46000000f,0.96000000f,-0.50000000f,0.08000000f,0.92000000f,-0.68000000f,-0.27000000f,0.29000000f,-0.95000000f,0.58000000f,0.69000000f,-0.62000000f,-0.25000000f,0.02000000f,-0.50000000f,0.01000000f,0.33000000f,-0.93000000f,-0.85000000f,-0.51000000f,0.04000000f,0.29000000f,-0.32000000f,-0.66000000f,0.08000000f,0.94000000f,-0.81000000f,-0.70000000f,0.44000000f,-0.13000000f,0.72000000f,-0.81000000f,-0.55000000f,-0.53000000f,-0.27000000f,-0.76000000f,0.04000000f,0.91000000f,0.80000000f,-0.91000000f,-0.79000000f,-0.11000000f,0.17000000f,-0.42000000f,0.57000000f,0.72000000f,-0.52000000f,-0.12000000f,-0.00000000f,-0.17000000f,0.98000000f,-0.30000000f,0.20000000f,0.64000000f,-0.29000000f,-0.42000000f,0.45000000f,0.85000000f,0.53000000f,0.47000000f,-0.29000000f,-0.04000000f,0.97000000f,0.86000000f,-0.13000000f,-0.96000000f,-0.34000000f,0.75000000f,-0.04000000f,-0.21000000f,0.59000000f,0.68000000f,0.36000000f,-0.11000000f,0.76000000f,-0.59000000f,-0.28000000f,0.07000000f,0.49000000f,0.23000000f,-0.01000000f,-0.00000000f,-0.33000000f,-0.14000000f,0.17000000f,0.68000000f,0.41000000f,-0.02000000f,-0.40000000f,0.75000000f,0.39000000f,-0.07000000f,0.11000000f,0.66000000f,0.47000000f,0.90000000f,0.17000000f,-0.15000000f,0.48000000f,-0.10000000f,-0.81000000f,0.47000000f,0.72000000f,0.51000000f,-0.64000000f,0.41000000f,-0.21000000f,0.97000000f,0.42000000f,0.81000000f,0.00000000f,-0.99000000f,0.43000000f,0.83000000f,0.78000000f,-0.92000000f,0.32000000f,0.59000000f,-0.96000000f,-0.46000000f,0.32000000f,0.53000000f,-0.28000000f,-0.00000000f,-0.04000000f,-0.99000000f,0.67000000f,-0.13000000f,-0.43000000f,0.50000000f,-0.65000000f,0.96000000f,0.71000000f,-0.71000000f,-0.40000000f,0.44000000f,0.25000000f,0.90000000f,0.45000000f,0.71000000f,-0.66000000f,0.00000000f,0.52000000f,0.93000000f,0.58000000f,0.29000000f,0.62000000f,0.27000000f,0.56000000f,0.42000000f,0.26000000f,0.78000000f,-0.92000000f,-0.29000000f,0.98000000f,0.97000000f,0.80000000f,0.53000000f,0.40000000f,-0.28000000f,-0.01000000f,-0.15000000f,0.00000000f,0.18000000f,0.01000000f,-0.46000000f,-0.81000000f,-0.42000000f,0.58000000f,-0.47000000f,0.40000000f,-0.81000000f,0.67000000f,0.70000000f,-0.64000000f,0.31000000f,-0.75000000f,-0.07000000f,0.73000000f,0.31000000f,0.20000000f,0.07000000f,-0.31000000f,-0.50000000f,-0.91000000f,-0.53000000f,0.80000000f,0.13000000f,-0.31000000f,0.46000000f,0.99000000f,-0.52000000f,0.09000000f,-0.21000000f,0.46000000f,-0.76000000f,0.27000000f,0.88000000f,0.30000000f,-0.83000000f,-0.85000000f,0.98000000f,-0.34000000f,-0.84000000f,0.50000000f,-0.78000000f,0.17000000f,-0.72000000f,-0.06000000f,-0.53000000f,-0.53000000f,-0.74000000f,0.95000000f,0.42000000f,0.25000000f,-0.73000000f,0.10000000f,-0.06000000f,-0.87000000f,0.01000000f,0.54000000f,0.87000000f,0.68000000f,-0.85000000f,0.53000000f,-0.02000000f,0.86000000f,-0.15000000f,0.23000000f,0.18000000f,-0.34000000f,0.67000000f,-0.82000000f,-0.70000000f,0.35000000f,-0.90000000f,0.09000000f,-0.03000000f,0.94000000f,0.69000000f,0.43000000f,0.60000000f,-0.87000000f,0.45000000f,0.61000000f,-0.31000000f,0.54000000f,-0.91000000f,-0.73000000f,0.58000000f,0.27000000f,-0.81000000f,-0.94000000f,-0.63000000f,-0.91000000f,0.10000000f,0.25000000f,0.08000000f,0.47000000f,-0.75000000f,-0.34000000f,0.69000000f,0.37000000f,0.90000000f,0.21000000f,0.81000000f,-0.53000000f,0.80000000f,-0.67000000f,-0.95000000f,-0.55000000f,0.21000000f,-0.04000000f,-0.12000000f,-0.64000000f,0.78000000f,0.15000000f,-0.49000000f,0.26000000f,-0.29000000f,0.09000000f,-0.84000000f,-0.93000000f,0.11000000f,0.58000000f,-0.67000000f,0.60000000f,-0.40000000f,-0.61000000f,0.72000000f,-0.36000000f,-0.24000000f,-0.89000000f,-0.21000000f,-0.82000000f,-0.37000000f,-0.57000000f,0.72000000f,-0.66000000f,0.63000000f,0.74000000f,0.37000000f,-0.51000000f,0.37000000f,-0.71000000f,0.92000000f,-0.34000000f,0.02000000f,-0.95000000f,-0.37000000f,-0.92000000f,0.04000000f,0.12000000f,-0.26000000f,-0.43000000f,-0.81000000f,-0.26000000f,-0.48000000f,0.44000000f,-0.12000000f,-0.75000000f,0.98000000f,-0.31000000f,-0.01000000f,0.29000000f,0.77000000f,0.29000000f,0.87000000f,0.47000000f,0.18000000f,0.07000000f,-0.99000000f,0.81000000f,0.14000000f,0.53000000f,-0.03000000f,-0.22000000f,0.28000000f,-0.56000000f,-0.86000000f,0.52000000f,0.83000000f,0.89000000f,-0.54000000f,-0.48000000f,-0.91000000f,0.80000000f,-0.12000000f,-0.06000000f,0.09000000f,0.75000000f,-0.36000000f,0.55000000f,0.55000000f,0.46000000f,0.74000000f,0.53000000f,0.99000000f,-0.33000000f,-0.45000000f,-0.06000000f,-0.12000000f,0.19000000f,-0.17000000f,-0.38000000f,-0.78000000f,-0.58000000f,-0.74000000f,-0.65000000f,-0.03000000f,-0.77000000f,-0.38000000f,-0.97000000f,0.24000000f,0.57000000f,0.75000000f,0.45000000f,0.39000000f,0.89000000f,-0.81000000f,-0.42000000f,0.93000000f,-0.87000000f,0.52000000f,0.44000000f,-0.34000000f,-0.16000000f,-0.02000000f,-0.85000000f,0.97000000f,-0.41000000f,-0.57000000f,0.96000000f,-0.94000000f,-0.66000000f,0.92000000f,-0.94000000f,0.23000000f,-0.06000000f,-0.68000000f,0.37000000f,0.30000000f,0.75000000f,-0.51000000f,0.12000000f,0.52000000f,-0.17000000f,0.55000000f,-0.17000000f,0.40000000f,0.60000000f,0.97000000f,0.83000000f,-0.13000000f,-0.28000000f,0.73000000f,-0.77000000f,0.36000000f,-0.03000000f,0.96000000f,0.41000000f,0.97000000f,-0.65000000f,-0.78000000f,-0.68000000f,0.71000000f,-0.25000000f,-0.02000000f,-0.14000000f,0.32000000f,0.48000000f,-0.85000000f,-0.12000000f,-0.11000000f,0.90000000f,-0.59000000f,-0.70000000f,0.19000000f,0.53000000f,-0.83000000f,0.34000000f,-0.22000000f,0.34000000f,-0.37000000f,0.01000000f,-0.64000000f,-0.40000000f,-0.64000000f,-0.04000000f,-0.41000000f,-0.77000000f,-0.63000000f,0.16000000f,-0.17000000f,0.29000000f,-0.19000000f,0.87000000f,0.49000000f,-0.09000000f,0.27000000f,-0.24000000f,0.73000000f,-0.55000000f,0.97000000f,-0.62000000f,0.64000000f,0.27000000f,-0.66000000f,-0.34000000f,0.39000000f,0.81000000f,-0.13000000f,0.14000000f,0.88000000f,-0.43000000f,0.79000000f,-0.88000000f,0.91000000f,-0.25000000f,-0.24000000f,-0.40000000f,-0.51000000f,-0.61000000f,0.11000000f,0.45000000f,0.23000000f,0.60000000f,-0.73000000f,0.20000000f,0.65000000f,-0.25000000f,-0.67000000f,0.76000000f,-0.83000000f,0.64000000f,-0.01000000f,-0.51000000f,-0.27000000f,-0.03000000f,0.33000000f,0.27000000f,-0.69000000f,-0.85000000f,0.06000000f,0.53000000f,-0.78000000f,0.85000000f,-0.26000000f,0.46000000f,-0.79000000f,0.86000000f,-0.25000000f,-0.67000000f,-0.88000000f,-0.69000000f,-0.71000000f,0.58000000f,0.09000000f,-0.60000000f,0.83000000f,0.40000000f,-0.88000000f,-0.15000000f,0.46000000f,0.05000000f,0.37000000f,0.25000000f,-0.85000000f,-0.39000000f,0.69000000f,-0.68000000f,-0.21000000f,0.97000000f,-0.03000000f,-0.13000000f,-0.59000000f,0.65000000f,-0.72000000f,-0.84000000f,-0.80000000f,0.42000000f,-0.36000000f,-0.11000000f,-0.84000000f,-0.27000000f,-0.13000000f,-0.03000000f,0.82000000f,0.33000000f,-0.24000000f,0.30000000f,-0.28000000f,0.41000000f,-0.56000000f,-0.47000000f,-0.18000000f,-0.57000000f,-0.56000000f,-0.87000000f,-0.05000000f,-0.17000000f,-0.31000000f,-0.73000000f,-0.89000000f,0.01000000f,0.20000000f,0.06000000f,-0.85000000f,-0.75000000f,0.78000000f,-0.60000000f,0.87000000f,0.91000000f,-0.13000000f,0.75000000f,-0.49000000f,0.96000000f,-0.60000000f,-0.87000000f,-0.49000000f,0.83000000f,0.42000000f,-0.29000000f,0.32000000f,-0.46000000f,-0.84000000f,0.37000000f,-0.36000000f,0.39000000f,-0.72000000f,0.24000000f,0.28000000f,-0.63000000f,0.40000000f,0.92000000f,-0.75000000f,-0.68000000f,0.74000000f,0.07000000f,0.60000000f,0.22000000f,-0.50000000f,-0.10000000f,-0.08000000f,0.50000000f,-0.34000000f,0.24000000f,-0.77000000f,-0.23000000f,0.77000000f,0.89000000f,-0.20000000f,0.89000000f,-0.95000000f,0.35000000f,0.19000000f,0.70000000f,-0.10000000f,0.07000000f,0.71000000f,0.16000000f,0.33000000f,0.37000000f,0.13000000f,-0.98000000f,-0.12000000f,-0.50000000f,0.68000000f,-0.62000000f,-0.38000000f,0.13000000f,0.86000000f,0.22000000f,-0.56000000f,0.35000000f,-0.98000000f,-0.72000000f,0.86000000f,-0.44000000f,0.73000000f,0.57000000f,0.84000000f,-0.93000000f,-0.62000000f,-0.67000000f,0.14000000f,-0.73000000f,-0.85000000f,-0.38000000f,0.01000000f,-0.87000000f,0.05000000f,-0.98000000f,-0.18000000f,0.56000000f,0.90000000f,-0.66000000f,-0.81000000f,0.09000000f,-0.63000000f,0.04000000f,-0.88000000f,0.74000000f,0.73000000f,0.71000000f,0.68000000f,0.27000000f,-0.52000000f,0.16000000f,-0.72000000f,0.10000000f,-0.71000000f,0.97000000f,-0.55000000f,-0.06000000f,-0.68000000f,-0.74000000f,-0.66000000f,-0.93000000f,0.23000000f,-0.35000000f,0.37000000f,0.54000000f,0.60000000f,0.10000000f,-0.76000000f,0.45000000f,-0.66000000f,-0.08000000f,0.98000000f,-0.09000000f,0.96000000f,-0.54000000f,-0.33000000f,-0.04000000f,0.36000000f,0.86000000f,-0.42000000f,-0.50000000f,0.45000000f,0.33000000f,0.78000000f,0.25000000f,0.58000000f,0.15000000f,-0.89000000f,-0.49000000f,0.42000000f,0.78000000f,-0.86000000f,-0.65000000f,0.81000000f,-0.67000000f,0.62000000f,0.14000000f,0.62000000f,0.05000000f,-0.93000000f,0.34000000f,-0.40000000f,0.01000000f,0.46000000f,-0.34000000f,0.51000000f,-0.86000000f,0.94000000f,-0.20000000f,-0.75000000f,0.27000000f,-0.09000000f,0.41000000f,-0.86000000f,0.80000000f,-0.13000000f,-0.31000000f,0.52000000f,-0.12000000f,0.46000000f,0.58000000f,0.60000000f,-0.12000000f,-0.45000000f,-0.61000000f,-0.33000000f,-0.80000000f,-0.25000000f,-0.00000000f,-0.20000000f,-0.48000000f,-0.98000000f,0.96000000f,-0.86000000f,-0.21000000f,0.30000000f,0.26000000f,0.53000000f,0.83000000f,0.82000000f,-0.39000000f,-0.66000000f,-0.69000000f,-0.42000000f,0.35000000f,-0.88000000f,0.27000000f,-0.34000000f,-0.21000000f,-0.89000000f,0.74000000f,-0.98000000f,-0.35000000f,-0.72000000f,-0.37000000f,-0.32000000f,0.39000000f,-0.24000000f,-0.83000000f,0.95000000f,-0.43000000f,0.72000000f,0.24000000f,-0.85000000f,-0.19000000f,0.55000000f,0.02000000f,0.34000000f,-0.41000000f,-0.08000000f,-0.25000000f,0.40000000f,-0.00000000f,0.58000000f,0.43000000f,0.79000000f,0.29000000f,-0.57000000f,-0.02000000f,-0.31000000f,-0.01000000f,0.33000000f,-0.09000000f,-0.07000000f,0.53000000f,-0.58000000f,0.94000000f,-0.64000000f,0.37000000f,0.63000000f,-0.79000000f,0.21000000f,0.72000000f,0.24000000f,0.09000000f,0.34000000f,0.15000000f,0.41000000f,0.94000000f,0.69000000f,0.51000000f,0.52000000f,-0.03000000f,-0.81000000f,-0.99000000f,-0.76000000f,0.33000000f,0.61000000f,0.03000000f,-0.61000000f,0.78000000f,0.69000000f,0.62000000f,-0.22000000f,-0.70000000f,-0.64000000f,0.55000000f,-0.56000000f,0.24000000f,-0.39000000f,0.33000000f,-0.08000000f,0.92000000f,0.88000000f,-0.94000000f,-0.85000000f,-0.47000000f,-0.96000000f,-0.51000000f,0.22000000f,0.87000000f,-0.85000000f,0.51000000f,0.27000000f,0.12000000f,-0.83000000f,-0.13000000f,-0.63000000f,0.72000000f,0.51000000f,0.35000000f,-0.94000000f,0.60000000f,0.79000000f,-0.57000000f,-0.70000000f,0.21000000f,-0.68000000f,-0.84000000f,0.10000000f,0.76000000f,0.92000000f,0.60000000f,-0.16000000f,0.85000000f,-0.28000000f,-0.00000000f,0.25000000f,0.61000000f,0.69000000f,-0.62000000f,0.17000000f,0.05000000f,0.08000000f,-0.87000000f,0.23000000f,0.95000000f,-0.82000000f,0.84000000f,-0.58000000f,0.76000000f,-0.46000000f,-0.35000000f,0.76000000f,-0.57000000f,0.70000000f,-0.14000000f,0.55000000f,0.57000000f,0.57000000f,-0.28000000f,-0.18000000f,0.46000000f,0.89000000f,0.07000000f,0.45000000f,-0.65000000f,-0.46000000f,0.01000000f,0.32000000f,-0.96000000f,-0.71000000f,0.05000000f,0.35000000f,-0.90000000f,-0.56000000f,0.72000000f,-0.33000000f,-0.48000000f,0.42000000f,0.32000000f,0.16000000f,-0.55000000f,-0.83000000f,0.42000000f,0.74000000f,0.41000000f,0.93000000f,0.61000000f,-0.39000000f,-0.03000000f,-0.81000000f,-0.37000000f,-0.55000000f,-0.06000000f,0.62000000f,0.69000000f,0.74000000f,0.21000000f,0.12000000f,-0.18000000f,0.25000000f,-0.66000000f,0.40000000f,-0.33000000f,0.95000000f,0.72000000f,0.29000000f,0.71000000f,-0.46000000f,-0.56000000f,-0.79000000f,0.59000000f,-0.71000000f,-0.02000000f,0.61000000f,0.66000000f,0.23000000f,-0.44000000f,0.99000000f,0.66000000f,-0.47000000f,0.99000000f,0.68000000f,-0.21000000f,-0.96000000f,-0.67000000f,0.39000000f,0.22000000f,-0.72000000f,0.01000000f,0.62000000f,0.68000000f,-0.87000000f,-0.92000000f,-0.64000000f,-0.60000000f,-0.51000000f,-0.45000000f,0.72000000f,-0.86000000f,0.99000000f,-0.77000000f,0.36000000f,0.20000000f,0.17000000f,-0.32000000f,-0.06000000f,0.10000000f,0.63000000f,-0.08000000f,-0.01000000f,0.58000000f,-0.31000000f,0.18000000f,-0.09000000f,0.10000000f,-0.72000000f,0.98000000f,-0.76000000f,-0.21000000f,-0.61000000f,0.19000000f,-0.52000000f,0.13000000f,0.39000000f,-0.53000000f,-0.86000000f,-0.91000000f,-0.57000000f,0.61000000f,0.47000000f,-0.73000000f,0.63000000f,0.07000000f,0.90000000f,-0.58000000f,0.52000000f,0.45000000f,-0.51000000f,-0.87000000f,0.31000000f,0.25000000f,-0.08000000f,0.53000000f,-0.73000000f,-0.08000000f,-0.86000000f,-0.63000000f,0.63000000f,-0.40000000f,-0.66000000f,-0.40000000f,-0.71000000f,-0.76000000f,0.66000000f,-0.22000000f,-0.58000000f,0.49000000f,-0.97000000f,0.84000000f,0.96000000f,-0.09000000f,-0.92000000f,-0.24000000f,0.01000000f,-0.97000000f,-0.80000000f,0.00000000f,-0.99000000f,0.62000000f,0.62000000f,-0.32000000f,0.11000000f,0.30000000f,0.80000000f,0.62000000f,-0.57000000f,0.89000000f,0.57000000f,-0.87000000f,-0.95000000f,0.74000000f,-0.57000000f,-0.31000000f,0.05000000f,-0.78000000f,-0.51000000f,0.84000000f,-0.40000000f,-0.97000000f,-0.31000000f,0.89000000f,-0.41000000f,0.15000000f,0.52000000f,0.19000000f,-0.33000000f,0.07000000f,0.74000000f,0.06000000f,-0.64000000f,-0.70000000f,0.58000000f,-0.31000000f,-0.99000000f,-0.46000000f,0.28000000f,0.08000000f,-0.73000000f,-0.31000000f,0.70000000f,-0.90000000f,0.28000000f,0.88000000f,-0.92000000f,-0.21000000f,-0.63000000f,0.47000000f,0.72000000f,0.86000000f,0.95000000f,0.79000000f,0.34000000f,0.16000000f,0.91000000f,0.65000000f,-0.86000000f,-0.81000000f,0.67000000f,0.18000000f,-0.58000000f,0.25000000f,-0.49000000f,0.52000000f,-0.86000000f,-0.25000000f,0.11000000f,-0.97000000f,0.44000000f,0.43000000f,0.64000000f,0.27000000f,-0.64000000f,-0.44000000f,0.96000000f,-0.44000000f,-0.79000000f,0.17000000f,-0.21000000f,0.86000000f,-0.61000000f,-0.16000000f,-0.68000000f,0.95000000f,0.67000000f,0.58000000f,0.10000000f,0.61000000f,-0.99000000f,-0.01000000f,0.86000000f,-0.80000000f,0.35000000f,-0.44000000f,0.84000000f,0.92000000f,-0.35000000f,0.62000000f,-0.40000000f,0.71000000f,-0.38000000f,0.43000000f,0.02000000f,0.74000000f,-0.66000000f,0.68000000f,0.29000000f,-0.79000000f,0.36000000f,0.07000000f,-0.04000000f,0.43000000f,-0.51000000f,-0.47000000f,0.55000000f,0.15000000f,0.82000000f,-0.94000000f,-0.59000000f,-0.85000000f,-0.74000000f,0.85000000f,0.41000000f,0.59000000f,0.53000000f,0.91000000f,0.12000000f,0.92000000f,-0.52000000f,0.41000000f,0.41000000f,-0.25000000f,0.64000000f,-0.45000000f,0.25000000f,-0.56000000f,-0.53000000f,0.16000000f,-0.75000000f,-0.85000000f,-0.16000000f,-0.84000000f,-0.85000000f,-0.57000000f,-0.57000000f,-0.00000000f,0.41000000f,-0.96000000f,0.34000000f,0.47000000f,-0.53000000f,-0.84000000f,0.00000000f,0.39000000f,-0.38000000f,0.87000000f,-0.84000000f,0.56000000f,-0.49000000f,0.32000000f,0.23000000f,-0.04000000f,-0.16000000f,-0.01000000f,-0.47000000f,-0.02000000f,0.57000000f,-0.69000000f,-0.71000000f,-0.71000000f,0.72000000f,0.82000000f,0.65000000f,0.73000000f,-0.31000000f,0.76000000f,-0.64000000f,0.15000000f,-0.50000000f,-0.59000000f,-0.94000000f,0.81000000f,0.78000000f,-0.19000000f,-0.56000000f,0.87000000f,-0.71000000f,0.65000000f,0.43000000f,0.79000000f,0.33000000f,0.07000000f,0.33000000f,-0.77000000f,0.11000000f,0.88000000f,0.47000000f,0.66000000f,-0.62000000f,0.89000000f,0.22000000f,-0.49000000f,-0.71000000f,-0.87000000f,0.77000000f,-0.86000000f,0.08000000f,-0.53000000f,-0.58000000f,0.89000000f,0.57000000f,-0.65000000f,-0.25000000f,-0.48000000f,-0.28000000f,-0.59000000f,0.60000000f,-0.56000000f,-0.06000000f,0.33000000f,0.29000000f,-0.00000000f,-0.66000000f,0.86000000f,-0.90000000f,-0.59000000f,-0.32000000f,0.00000000f,-0.16000000f,-0.59000000f,0.23000000f,0.45000000f,-0.86000000f,0.59000000f,0.37000000f,-0.79000000f,-0.57000000f,0.77000000f,0.34000000f,-0.08000000f,-0.98000000f,0.01000000f,0.69000000f,0.28000000f,-0.84000000f,0.74000000f,-0.02000000f,0.49000000f,0.29000000f,0.07000000f,0.09000000f,0.47000000f,0.87000000f,0.25000000f,0.38000000f,-0.31000000f,-0.12000000f,-0.23000000f,0.23000000f,-0.94000000f,-0.48000000f,0.38000000f,-0.12000000f,-0.66000000f,-0.72000000f,-0.21000000f,0.83000000f,0.78000000f,-0.27000000f,0.81000000f,0.58000000f,-0.93000000f,-0.63000000f,-0.42000000f,-0.16000000f,-0.96000000f,-0.73000000f,0.76000000f,0.32000000f,-0.60000000f,0.50000000f,0.24000000f,-0.48000000f,-0.20000000f,0.99000000f,-0.24000000f,0.59000000f,0.07000000f,-0.80000000f,-0.01000000f,0.45000000f,-0.48000000f,0.34000000f,-0.60000000f,0.15000000f,-0.40000000f,0.68000000f,0.69000000f,0.13000000f,-0.99000000f,-0.21000000f,-0.17000000f,0.29000000f,-0.20000000f,0.86000000f,-0.80000000f,0.82000000f,-0.36000000f,0.79000000f,0.75000000f,-0.37000000f,-0.54000000f,0.16000000f,-0.86000000f,0.36000000f,-0.46000000f,0.33000000f,-0.31000000f,0.75000000f,-0.62000000f,0.79000000f,-0.45000000f,0.34000000f,-0.72000000f,-0.67000000f,0.06000000f,0.17000000f,0.57000000f,0.89000000f,-0.08000000f,0.58000000f,-0.01000000f,0.27000000f,0.05000000f,-0.42000000f,-0.22000000f,0.86000000f,0.92000000f,-0.66000000f,-0.01000000f,-0.62000000f,0.62000000f,0.57000000f,0.17000000f,0.47000000f,-0.50000000f,-0.72000000f,-0.90000000f,0.05000000f,-0.40000000f,-0.77000000f,-0.71000000f,-0.03000000f,-0.81000000f,0.11000000f,-0.34000000f,-0.70000000f,0.05000000f,0.74000000f,-0.27000000f,-0.50000000f,-0.47000000f,0.87000000f,-0.15000000f,0.14000000f,0.31000000f,-0.67000000f,0.74000000f,-0.55000000f,0.41000000f,-0.80000000f,0.84000000f,-0.23000000f,0.10000000f,-0.17000000f,0.65000000f,0.79000000f,-0.67000000f,0.67000000f,-0.17000000f,0.32000000f,-0.06000000f,0.44000000f,0.13000000f,0.26000000f,-0.67000000f,0.63000000f,-0.17000000f,0.40000000f,0.26000000f,0.55000000f,0.29000000f,0.62000000f,0.83000000f,-0.41000000f,-0.07000000f,0.40000000f,-0.40000000f,-0.21000000f,0.45000000f,-0.88000000f,-0.83000000f,0.85000000f,-0.84000000f,0.43000000f,0.44000000f,0.24000000f,-0.32000000f,0.29000000f,-0.62000000f,-0.24000000f,0.38000000f,-0.84000000f,-0.97000000f,-0.68000000f,0.44000000f,-0.70000000f,-0.95000000f,-0.70000000f,-0.39000000f,-0.30000000f,-0.72000000f,-0.55000000f,-0.09000000f,-0.15000000f,0.77000000f,0.40000000f,-0.16000000f,-0.94000000f,-0.24000000f,-0.79000000f,-0.94000000f,0.46000000f,-0.35000000f,0.93000000f,0.10000000f,0.39000000f,-0.37000000f,-0.63000000f,0.03000000f,-0.13000000f,0.64000000f,0.49000000f,-0.52000000f,0.24000000f,-0.59000000f,0.13000000f,0.42000000f,-0.19000000f,0.33000000f,-0.33000000f,-0.67000000f,0.43000000f,0.22000000f,-0.85000000f,0.83000000f,-0.51000000f,0.60000000f,0.15000000f,-0.90000000f,-0.24000000f,-0.39000000f,0.90000000f,-0.87000000f,0.39000000f,-0.70000000f,-0.05000000f,-0.09000000f,-0.95000000f,-0.05000000f,-0.08000000f,0.92000000f,0.95000000f,-0.15000000f,-0.85000000f,-0.87000000f,0.53000000f,-0.31000000f,0.49000000f,-0.59000000f,0.92000000f,-0.82000000f,-0.97000000f,0.40000000f,-0.60000000f,0.80000000f,-0.48000000f,-0.68000000f,0.33000000f,0.73000000f,-0.37000000f,-0.31000000f,0.26000000f,0.62000000f,0.11000000f,0.65000000f,-0.73000000f,0.26000000f,-0.88000000f,0.33000000f,-0.03000000f,-0.54000000f,-0.92000000f,-0.74000000f,-0.80000000f,-0.82000000f,-0.61000000f,-0.97000000f,-0.09000000f,-0.81000000f,-0.83000000f,-0.84000000f,0.02000000f,-0.26000000f,0.60000000f,-0.30000000f,0.41000000f,-0.59000000f,-0.07000000f,-0.70000000f,0.74000000f,0.25000000f,-0.50000000f,0.88000000f,0.73000000f,-0.40000000f,0.49000000f,0.84000000f,0.27000000f,0.80000000f,-0.06000000f,-0.26000000f,0.16000000f,-0.87000000f,-0.86000000f,0.19000000f,0.88000000f,0.00000000f,0.19000000f,0.89000000f,0.94000000f,0.11000000f,-0.09000000f,0.04000000f,-0.15000000f,-0.07000000f,0.56000000f,0.71000000f,-0.94000000f,-0.13000000f,0.72000000f,0.50000000f,-0.17000000f,-0.58000000f,-0.35000000f,0.20000000f,-0.18000000f,-0.31000000f,-0.80000000f,-0.95000000f,-0.00000000f,0.84000000f,0.91000000f,0.34000000f,0.89000000f,-0.08000000f,0.90000000f,0.80000000f,-0.41000000f,-0.50000000f,0.95000000f,0.41000000f,0.52000000f,-0.21000000f,-0.99000000f,-0.77000000f,0.41000000f,-0.32000000f,-0.99000000f,0.21000000f,0.29000000f,0.82000000f,0.99000000f,0.57000000f,-0.46000000f,0.77000000f,-0.43000000f,-0.71000000f,0.13000000f,-0.61000000f,-0.38000000f,0.89000000f,-0.15000000f,-0.46000000f,-0.81000000f,-0.75000000f,0.54000000f,0.45000000f,0.88000000f,-0.25000000f,-0.74000000f,0.38000000f,0.52000000f,-0.93000000f,0.54000000f,0.50000000f,0.52000000f,0.41000000f,-0.64000000f,0.64000000f,0.04000000f,0.33000000f,0.38000000f,-0.97000000f,0.08000000f,-0.90000000f,0.49000000f,0.54000000f,-0.09000000f,0.90000000f,0.66000000f,0.20000000f,-0.75000000f,-0.42000000f,0.64000000f,0.33000000f,0.21000000f,-0.08000000f,0.02000000f,0.92000000f,-0.18000000f,-0.28000000f,0.75000000f,0.13000000f,0.37000000f,0.17000000f,0.89000000f,0.23000000f,-0.47000000f,0.90000000f,-0.24000000f,0.13000000f,-0.81000000f,0.73000000f,-0.12000000f,0.76000000f,-0.54000000f,0.19000000f,0.98000000f,0.81000000f,0.99000000f,0.76000000f,-0.33000000f,0.12000000f,0.22000000f,0.02000000f,-0.43000000f,-0.39000000f,-0.74000000f,-0.79000000f,0.26000000f,-0.14000000f,0.52000000f,-0.96000000f,-0.60000000f,-0.79000000f,-0.53000000f,0.11000000f,0.65000000f,-0.12000000f,-0.92000000f,-0.85000000f,-0.06000000f,0.31000000f,-0.55000000f,0.27000000f,-0.87000000f,-0.46000000f,-0.95000000f,0.23000000f,-0.52000000f,-0.96000000f,0.06000000f,-0.22000000f,-0.44000000f,-0.11000000f,0.34000000f,-0.89000000f,0.43000000f,-0.24000000f,0.48000000f,-0.07000000f,0.08000000f,-0.85000000f,-0.25000000f,0.92000000f,-0.27000000f,-0.03000000f,-0.06000000f,-0.85000000f,0.12000000f,-0.55000000f,-0.70000000f,-0.11000000f,0.70000000f,0.69000000f,0.76000000f,-0.91000000f,-0.63000000f,-0.61000000f,-0.98000000f,0.73000000f,-0.90000000f,-0.62000000f,0.68000000f,-0.87000000f,-0.56000000f,-0.27000000f,-0.70000000f,0.99000000f,0.79000000f,-0.41000000f,0.54000000f,-0.64000000f,0.61000000f,-0.35000000f,0.90000000f,-0.33000000f,0.51000000f,-0.59000000f,0.95000000f,-0.73000000f,0.15000000f,-0.22000000f,0.26000000f,0.72000000f,0.51000000f,0.61000000f,-0.00000000f,0.37000000f,0.58000000f,0.26000000f,-0.13000000f,0.41000000f,0.41000000f,-0.95000000f,-0.79000000f,0.58000000f,-0.20000000f,-0.86000000f,-0.20000000f,-0.60000000f,-0.44000000f,0.11000000f,-0.23000000f,0.91000000f,0.01000000f,0.87000000f,-0.19000000f,0.24000000f,0.01000000f,-0.88000000f,0.09000000f,0.08000000f,0.83000000f,0.02000000f,-0.57000000f,-0.21000000f,0.93000000f,0.91000000f,0.51000000f,-0.74000000f,0.29000000f,0.31000000f,0.41000000f,0.55000000f,0.72000000f,-0.93000000f,-0.47000000f,0.95000000f,-0.73000000f,-0.76000000f,-0.98000000f,-0.84000000f,0.31000000f,-0.89000000f,-0.27000000f,-0.70000000f,-0.22000000f,0.39000000f,0.81000000f,-0.85000000f,0.69000000f,-0.50000000f,-0.53000000f,-0.14000000f,-0.02000000f,0.31000000f,-0.74000000f,-0.19000000f,0.84000000f,0.99000000f,-0.92000000f,-0.35000000f,-0.30000000f,0.85000000f,-0.64000000f,-0.84000000f,0.69000000f,0.77000000f,0.91000000f,0.04000000f,0.94000000f,0.44000000f,0.28000000f,0.13000000f,-0.65000000f,-0.84000000f,0.61000000f,0.01000000f,0.78000000f,-0.17000000f,0.27000000f,0.72000000f,-0.14000000f,-0.18000000f,0.70000000f,-0.19000000f,0.57000000f,-0.89000000f,0.48000000f,0.36000000f,0.39000000f,0.46000000f,0.67000000f,0.16000000f,-0.86000000f,-0.52000000f,0.20000000f,-0.18000000f,0.70000000f,-0.11000000f,-0.57000000f,-0.96000000f,-0.27000000f,0.41000000f,0.72000000f,-0.33000000f,-0.93000000f,0.99000000f,-0.90000000f,0.79000000f,0.17000000f,-0.40000000f,-0.13000000f,0.92000000f,0.74000000f,-0.58000000f,-0.76000000f,-0.93000000f,0.65000000f,0.97000000f,0.27000000f,-0.84000000f,-0.61000000f,0.83000000f,-0.56000000f,-0.76000000f,-0.69000000f,-0.44000000f,-0.84000000f,-0.95000000f,0.33000000f,0.88000000f,-0.70000000f,0.30000000f,-0.69000000f,0.50000000f,-0.65000000f,-0.16000000f,-0.51000000f,0.81000000f,0.13000000f,-0.45000000f,0.35000000f,-0.10000000f,0.31000000f,-0.21000000f,0.39000000f,0.49000000f,-0.66000000f,0.44000000f,0.71000000f,0.87000000f,-0.61000000f,0.86000000f,-0.65000000f,0.87000000f,-0.89000000f,0.70000000f,-0.20000000f,-0.83000000f,0.61000000f,0.43000000f,-0.98000000f,-0.09000000f,-0.20000000f,-0.09000000f,0.99000000f,0.45000000f,0.28000000f,-0.28000000f,-0.46000000f,0.05000000f,0.96000000f,0.66000000f,0.72000000f,0.27000000f,-0.07000000f,-0.27000000f,0.54000000f,0.16000000f,0.54000000f,-0.60000000f,-0.50000000f,-0.94000000f,-0.28000000f,-0.05000000f,0.52000000f,0.65000000f,-0.99000000f,0.50000000f,-0.51000000f,0.28000000f,-0.93000000f,-0.15000000f,-0.64000000f,-0.62000000f,0.36000000f,-0.83000000f,0.86000000f,0.42000000f,0.60000000f,0.59000000f,0.42000000f,0.89000000f,0.50000000f,0.73000000f,-0.41000000f,-0.61000000f,-0.51000000f,-0.32000000f,-0.53000000f,0.64000000f,0.98000000f,-0.94000000f,-0.13000000f,0.06000000f,0.20000000f,-0.18000000f,-0.05000000f,0.50000000f,-0.39000000f,-0.08000000f,0.94000000f,-0.22000000f,-0.01000000f,0.51000000f,0.43000000f,-0.18000000f,-0.40000000f,0.08000000f,-0.40000000f,0.44000000f,-0.45000000f,-0.39000000f,0.39000000f,0.02000000f,0.81000000f,-0.75000000f,0.91000000f,-0.83000000f,0.06000000f,-0.36000000f,0.03000000f,0.11000000f,-0.19000000f,-0.29000000f,0.21000000f,-0.61000000f,0.44000000f,-0.86000000f,-0.69000000f,-0.18000000f,0.51000000f,0.90000000f,-0.05000000f,0.39000000f,-0.89000000f,-0.61000000f,0.66000000f,-0.06000000f,0.90000000f,0.20000000f,0.91000000f,-0.50000000f,-0.63000000f,0.68000000f,0.40000000f,-0.30000000f,0.28000000f,0.98000000f,-0.56000000f,-0.13000000f,-0.12000000f,0.29000000f,0.66000000f,0.07000000f,0.48000000f,0.60000000f,0.09000000f,0.09000000f,0.38000000f,0.63000000f,-0.27000000f,0.35000000f,-0.26000000f,-0.83000000f,-0.63000000f,-0.84000000f,0.87000000f,-0.94000000f,0.07000000f,0.17000000f,-0.98000000f,0.76000000f,-0.98000000f,0.81000000f,0.18000000f,-0.77000000f,-0.80000000f,-0.26000000f,0.76000000f,0.41000000f,-0.40000000f,-0.80000000f,0.16000000f,0.96000000f,0.81000000f,0.47000000f,-0.29000000f,0.57000000f,-0.06000000f,-0.04000000f,-0.30000000f,-0.92000000f,-0.18000000f,0.32000000f,-0.66000000f,-0.90000000f,0.74000000f,0.61000000f,0.37000000f,0.34000000f,0.67000000f,0.08000000f,0.80000000f,-0.27000000f,-0.49000000f,-0.15000000f,0.84000000f,-0.71000000f,0.56000000f,0.24000000f,0.89000000f,-0.00000000f,-0.44000000f,0.67000000f,-0.27000000f,0.31000000f,-0.86000000f,0.52000000f,0.87000000f,-0.03000000f,-0.34000000f,-0.38000000f,0.82000000f,0.84000000f,-0.30000000f,-0.13000000f,0.86000000f,-0.35000000f,0.67000000f,0.45000000f,-0.24000000f,0.95000000f,0.70000000f,-0.83000000f,-0.17000000f,-0.09000000f,-0.35000000f,-0.47000000f,0.71000000f,-0.75000000f,0.33000000f,0.64000000f,-0.68000000f,0.43000000f,0.38000000f,0.48000000f,0.21000000f,0.85000000f,-0.77000000f,0.11000000f,-0.19000000f,0.05000000f,-0.17000000f,-0.67000000f,-0.84000000f,-0.54000000f,-0.54000000f,-0.70000000f,-0.39000000f,-0.52000000f,-0.42000000f,-0.78000000f,0.39000000f,0.70000000f,-0.06000000f,-0.79000000f,0.41000000f,0.94000000f,0.83000000f,-0.33000000f,0.98000000f,-0.14000000f,-0.40000000f,-0.72000000f,0.66000000f,0.79000000f,0.79000000f,0.29000000f,-0.14000000f,-0.34000000f,0.40000000f,-0.95000000f,0.90000000f,-0.38000000f,-0.29000000f,0.95000000f,0.72000000f,0.17000000f,-0.54000000f,0.29000000f,-0.10000000f,0.93000000f,0.69000000f,-0.19000000f,0.20000000f,0.02000000f,0.96000000f,-0.05000000f,-0.49000000f,-0.93000000f,0.32000000f,-0.31000000f,0.07000000f,0.71000000f,-0.58000000f,0.08000000f,0.95000000f,-0.55000000f,0.95000000f,0.05000000f,0.42000000f,-0.98000000f,0.95000000f,-0.09000000f,-0.77000000f,0.42000000f,0.60000000f,-0.16000000f,0.29000000f,0.25000000f,0.39000000f,-0.81000000f,-0.90000000f,0.46000000f,-0.30000000f,0.10000000f,0.07000000f,0.81000000f,-0.57000000f,-0.31000000f,-0.21000000f,-0.12000000f,0.01000000f,-0.11000000f,0.66000000f,0.01000000f,0.90000000f,-0.38000000f,0.52000000f,0.08000000f,-0.77000000f,-0.66000000f,-0.54000000f,0.00000000f,-0.44000000f,0.17000000f,0.38000000f,-0.33000000f,0.80000000f,-0.80000000f,0.15000000f,-0.51000000f,-0.23000000f,-0.52000000f,0.37000000f,0.58000000f,-0.35000000f,-0.71000000f,-0.79000000f,-0.47000000f,-0.69000000f,-0.88000000f,-0.48000000f,0.28000000f,0.71000000f,0.46000000f,-0.28000000f,-0.13000000f,0.64000000f,-0.43000000f,-0.44000000f,0.44000000f,-0.11000000f,0.22000000f,0.10000000f,-0.94000000f,0.42000000f,-0.15000000f,0.25000000f,-0.25000000f,-0.88000000f,-0.29000000f,0.92000000f,-0.13000000f,0.06000000f,-0.35000000f,-0.66000000f,-0.77000000f,0.02000000f,-0.55000000f,0.51000000f,-0.57000000f,0.50000000f,0.68000000f,-0.22000000f,0.23000000f,0.00000000f,-0.66000000f,-0.36000000f,0.44000000f,0.25000000f,0.28000000f,0.96000000f,0.68000000f,-0.22000000f,-0.33000000f,-0.67000000f,0.11000000f,-0.33000000f,-0.15000000f,-0.16000000f,-0.87000000f,-0.37000000f,0.18000000f,0.62000000f,-0.25000000f,-0.13000000f,0.65000000f,-0.03000000f,-0.00000000f,0.30000000f,0.77000000f,0.63000000f,0.57000000f,0.93000000f,-0.37000000f,-0.06000000f,-0.72000000f,0.39000000f,0.36000000f,-0.28000000f,0.53000000f,0.00000000f,0.71000000f,-0.57000000f,-0.64000000f,0.30000000f,-0.40000000f,-0.30000000f,0.05000000f,-0.90000000f,0.36000000f,0.87000000f,0.77000000f,0.03000000f,-0.41000000f,-0.91000000f,0.81000000f,0.16000000f,-0.12000000f,-0.18000000f,0.30000000f,-0.51000000f,0.26000000f,-0.46000000f,-0.62000000f,0.79000000f,-0.98000000f,-0.60000000f,-0.90000000f,0.01000000f,-0.52000000f,0.66000000f,-0.49000000f,0.75000000f,-0.68000000f,-0.78000000f,-0.70000000f,0.44000000f,0.07000000f,-0.90000000f,-0.50000000f,0.22000000f,0.04000000f,-0.54000000f,0.35000000f,-0.38000000f,0.18000000f,-0.04000000f,-0.09000000f,-0.83000000f,-0.16000000f,-0.99000000f,-0.78000000f,-0.73000000f,0.71000000f,0.27000000f,0.15000000f,0.19000000f,0.29000000f,-0.20000000f,0.00000000f,0.38000000f,0.84000000f,-0.20000000f,0.28000000f,0.19000000f,-0.02000000f,-0.50000000f,-0.66000000f,-0.23000000f,0.79000000f,0.62000000f,0.20000000f,-0.24000000f,0.60000000f,-0.39000000f,-0.61000000f,-0.53000000f,-0.93000000f,0.99000000f,0.78000000f,-0.92000000f,0.92000000f,0.43000000f,0.46000000f,0.87000000f,0.32000000f,-0.53000000f,0.85000000f,-0.73000000f,-0.71000000f,-0.39000000f,-0.90000000f,-0.63000000f,0.01000000f,-0.38000000f,-0.62000000f,-0.25000000f,-0.37000000f,0.60000000f,-0.01000000f,0.18000000f,0.95000000f,0.99000000f,-0.70000000f,-0.76000000f,-0.15000000f,-0.78000000f,0.02000000f,0.08000000f,0.27000000f,-0.61000000f,0.62000000f,0.59000000f,-0.04000000f,0.46000000f,-0.63000000f,-0.05000000f,0.85000000f,-0.05000000f,-0.84000000f,-0.35000000f,-0.35000000f,0.63000000f,0.55000000f,-0.33000000f,-0.53000000f,0.62000000f,0.64000000f,-0.02000000f,0.06000000f,-0.39000000f,-0.55000000f,-0.09000000f,-0.17000000f,-0.09000000f,-0.84000000f,0.94000000f,-0.08000000f,-0.95000000f,-0.25000000f,0.12000000f,-0.26000000f,-0.94000000f,0.32000000f,-0.60000000f,-0.11000000f,-0.27000000f,-0.32000000f,0.31000000f,0.97000000f,0.64000000f,0.99000000f,-0.99000000f,-0.56000000f,0.96000000f,0.11000000f,-0.57000000f,-0.51000000f,0.82000000f,-0.35000000f,0.13000000f,0.70000000f,-0.97000000f,0.92000000f,0.59000000f,-0.03000000f,0.15000000f,-0.09000000f,0.46000000f,0.28000000f,0.73000000f,-0.17000000f,0.26000000f,-0.23000000f,0.45000000f,-0.96000000f,0.21000000f,-0.28000000f,-0.64000000f,-0.09000000f,0.68000000f,0.49000000f,-0.30000000f,-0.75000000f,0.98000000f,-0.71000000f,-0.42000000f,-0.52000000f,0.19000000f,0.52000000f,0.30000000f,0.92000000f,0.61000000f,-0.53000000f,0.62000000f,-0.15000000f,0.19000000f,0.07000000f,0.67000000f,0.92000000f,0.20000000f,-0.69000000f,-0.29000000f,-0.75000000f,0.54000000f,0.78000000f,0.92000000f,-0.70000000f,-0.70000000f,-0.40000000f,-0.41000000f,0.89000000f,-0.29000000f,0.02000000f,0.34000000f,-0.24000000f,0.48000000f,0.97000000f,0.75000000f,-0.66000000f,0.17000000f,-0.32000000f,-0.41000000f,0.24000000f,0.85000000f,-0.70000000f,0.39000000f,0.46000000f,-0.84000000f,0.86000000f,0.45000000f,-0.78000000f,-0.61000000f,0.74000000f,0.73000000f,0.78000000f,0.66000000f,-0.15000000f,-0.85000000f,0.46000000f,0.46000000f,-0.21000000f,-0.78000000f,-0.16000000f,0.12000000f,0.83000000f,0.05000000f,-0.95000000f,0.41000000f,0.45000000f,-0.02000000f,0.56000000f,-0.91000000f,-0.90000000f,-0.33000000f,-0.94000000f,-0.72000000f,-0.90000000f,-0.22000000f,-0.01000000f,-0.59000000f,0.58000000f,-0.37000000f,0.23000000f,-0.96000000f,0.41000000f,-0.65000000f,0.69000000f,-0.79000000f,0.14000000f,0.39000000f,-0.99000000f,-0.21000000f,-0.73000000f,-0.33000000f,0.53000000f,-0.15000000f,-0.04000000f,-0.00000000f,0.33000000f,0.12000000f,-0.44000000f,-0.88000000f,-0.93000000f,0.05000000f,0.73000000f,-0.66000000f,-0.85000000f,-0.17000000f,-0.47000000f,0.15000000f,0.65000000f,0.91000000f,-0.72000000f,0.32000000f,0.64000000f,-0.30000000f,-0.40000000f,-0.79000000f,-0.77000000f,0.27000000f,0.09000000f,0.65000000f,-0.85000000f,0.37000000f,0.57000000f,-0.79000000f,0.28000000f,0.02000000f,-0.92000000f,0.23000000f,0.66000000f,-0.38000000f,0.24000000f,-0.21000000f,0.84000000f,-0.71000000f,-0.12000000f,0.26000000f,-0.29000000f,0.26000000f,-0.08000000f,0.75000000f,0.54000000f,0.46000000f,0.11000000f,-0.81000000f,-0.53000000f,0.85000000f,-0.24000000f,-0.38000000f,0.95000000f,0.36000000f,0.77000000f,-0.37000000f,0.58000000f,0.91000000f,0.03000000f,0.13000000f,-0.98000000f,0.68000000f,0.74000000f,0.52000000f,0.42000000f,0.83000000f,-0.76000000f,0.52000000f,-0.79000000f,-0.57000000f,0.95000000f,-0.58000000f,-0.11000000f,-0.08000000f,0.57000000f,0.75000000f,-0.80000000f,0.33000000f,0.42000000f,-0.85000000f,-0.74000000f,-0.91000000f,-0.99000000f,-0.08000000f,-0.06000000f,-0.42000000f,0.33000000f,-0.45000000f,-0.09000000f,0.56000000f,-0.95000000f,0.98000000f,-0.24000000f,0.48000000f,-0.85000000f,-0.05000000f,0.73000000f,0.75000000f,0.43000000f,0.00000000f,-0.29000000f,-0.75000000f,-0.39000000f,-0.76000000f,0.35000000f,0.29000000f,-0.19000000f,-0.61000000f,-0.65000000f,-0.35000000f,0.74000000f,-0.12000000f,0.62000000f,0.59000000f,-0.11000000f,-0.36000000f,-0.37000000f,-0.59000000f,0.28000000f,-0.28000000f,-0.00000000f,0.60000000f,-0.40000000f,0.10000000f,-0.94000000f,-0.25000000f,-0.50000000f,-0.12000000f,-0.90000000f,0.13000000f,-0.39000000f,0.30000000f,-0.87000000f,0.76000000f,-0.61000000f,0.55000000f,0.17000000f,0.74000000f,-0.36000000f,0.52000000f,0.71000000f,-0.20000000f,0.07000000f,0.40000000f,0.61000000f,0.06000000f,0.68000000f,0.71000000f,-0.36000000f,-0.52000000f,-0.61000000f,-0.70000000f,-0.40000000f,0.00000000f,0.69000000f,-0.44000000f,-0.15000000f,0.45000000f,-0.63000000f,0.88000000f,0.23000000f,-0.98000000f,0.29000000f,-0.86000000f,-0.24000000f,0.65000000f,-0.61000000f,-0.61000000f,0.81000000f,0.10000000f,0.24000000f,0.84000000f,-0.98000000f,-0.26000000f,-0.17000000f,-0.05000000f,0.88000000f,-0.93000000f,-0.34000000f,0.10000000f,0.89000000f,-0.92000000f,0.88000000f,-0.01000000f,0.30000000f,0.01000000f,0.65000000f,-0.87000000f,-0.51000000f,0.42000000f,0.60000000f,0.02000000f,0.56000000f,-0.56000000f,-0.00000000f,0.63000000f,0.40000000f,0.32000000f,-0.12000000f,0.05000000f,0.61000000f,-0.57000000f,-0.84000000f,0.20000000f,-0.91000000f,0.48000000f,0.64000000f,-0.60000000f,-0.24000000f,0.84000000f,0.21000000f,-0.48000000f,0.26000000f,-0.71000000f,0.31000000f,0.21000000f,0.59000000f,0.90000000f,-0.38000000f,0.56000000f,-0.72000000f,0.22000000f,0.01000000f,0.74000000f,0.19000000f,-0.40000000f,-0.63000000f,0.76000000f,-0.67000000f,0.27000000f,0.09000000f,-0.04000000f,0.49000000f,0.33000000f,0.55000000f,0.73000000f,-0.41000000f,-0.49000000f,0.16000000f,-0.93000000f,0.37000000f,0.62000000f,0.68000000f,-0.51000000f,0.08000000f,0.89000000f,-0.35000000f,0.26000000f,0.77000000f,0.33000000f,0.42000000f,-0.66000000f,0.65000000f,-0.34000000f,0.87000000f,-0.97000000f,-0.16000000f,0.43000000f,-0.93000000f,-0.06000000f,0.00000000f,0.40000000f,0.06000000f,-0.16000000f,0.79000000f,0.46000000f,-0.60000000f,-0.68000000f,0.11000000f,-0.19000000f,0.33000000f,-0.37000000f,-0.94000000f,-0.08000000f,0.11000000f,0.20000000f,0.78000000f,0.34000000f,-0.61000000f,0.60000000f,-0.93000000f,-0.36000000f,0.96000000f,-0.37000000f,-0.79000000f,-0.56000000f,0.86000000f,0.36000000f,-0.68000000f,-0.18000000f,0.54000000f,0.14000000f,0.00000000f,0.23000000f,0.14000000f,0.83000000f,-0.45000000f,0.01000000f,0.59000000f,-0.02000000f,0.43000000f,-0.03000000f,0.97000000f,0.62000000f,-0.12000000f,0.90000000f,-0.90000000f,-0.08000000f,0.36000000f,-0.72000000f,0.02000000f,0.22000000f,-0.24000000f,0.96000000f,-0.33000000f,-0.13000000f,0.44000000f,-0.65000000f,0.95000000f,0.68000000f,-0.76000000f,0.18000000f,-0.06000000f,0.26000000f,0.74000000f,-0.38000000f,-0.08000000f,0.15000000f,0.45000000f,-0.97000000f,0.43000000f,-0.82000000f,-0.84000000f,0.99000000f,-0.55000000f,-0.93000000f,-0.07000000f,-0.29000000f,-0.59000000f,-0.91000000f,0.49000000f,-0.60000000f,-0.56000000f,0.63000000f,0.86000000f,0.49000000f,0.76000000f,0.69000000f,0.12000000f,0.67000000f,0.60000000f,0.12000000f,-0.79000000f,0.78000000f,0.35000000f,0.52000000f,-0.80000000f,-0.12000000f,0.25000000f,0.43000000f,0.69000000f,0.12000000f,-0.01000000f,0.47000000f,0.65000000f,-0.38000000f,0.99000000f,0.28000000f,-0.37000000f,-0.18000000f,0.69000000f,0.56000000f,0.80000000f,0.89000000f,-0.13000000f,0.57000000f,0.45000000f,-0.11000000f,0.62000000f,0.83000000f,0.14000000f,-0.80000000f,-0.12000000f,-0.04000000f,0.25000000f,0.59000000f,-0.17000000f,0.04000000f,-0.75000000f,0.75000000f,-0.56000000f,-0.46000000f,-0.27000000f,0.22000000f,0.53000000f,0.58000000f,0.03000000f,0.44000000f,-0.14000000f,0.26000000f,-0.22000000f,0.74000000f,0.28000000f,0.50000000f,-0.21000000f,-0.51000000f,-0.50000000f,0.73000000f,-0.67000000f,0.19000000f,-0.58000000f,-0.29000000f,0.56000000f,-0.77000000f,0.18000000f,-0.46000000f,0.59000000f,0.80000000f,0.95000000f,-0.66000000f,-0.67000000f,-0.57000000f,0.01000000f,-0.20000000f,0.27000000f,0.67000000f,-0.12000000f,-0.34000000f,0.72000000f,-0.05000000f,0.95000000f,-0.26000000f,0.30000000f,0.87000000f,-0.61000000f,0.91000000f,-0.68000000f,0.20000000f,-0.75000000f,-0.04000000f,0.12000000f,0.37000000f,-0.34000000f,0.06000000f,-0.92000000f,-0.76000000f,-0.04000000f,-0.17000000f,-0.73000000f,0.50000000f,-0.32000000f,-0.77000000f,-0.25000000f,-0.72000000f,-0.32000000f,-0.88000000f,0.97000000f,0.63000000f,-0.05000000f,0.05000000f,0.33000000f,0.46000000f,0.65000000f,-0.38000000f,0.36000000f,0.52000000f,-0.33000000f,-0.09000000f,0.57000000f,-0.44000000f,-0.80000000f,0.18000000f,-0.14000000f,0.83000000f,0.53000000f,0.45000000f,-0.82000000f,0.11000000f,0.24000000f,0.56000000f,-0.47000000f,-0.35000000f,-0.33000000f,0.97000000f,-0.77000000f,-0.42000000f,0.61000000f,-0.45000000f,0.57000000f,0.43000000f,0.69000000f,0.46000000f,0.22000000f,0.10000000f,-0.24000000f,0.52000000f,0.55000000f,-0.97000000f,0.09000000f,-0.52000000f,0.78000000f,0.50000000f,0.87000000f,-0.04000000f,0.21000000f,0.92000000f,0.15000000f,-0.85000000f,-0.64000000f,0.25000000f,0.20000000f,0.35000000f,0.85000000f,-0.95000000f,-0.36000000f,-0.75000000f,0.85000000f,0.62000000f,0.04000000f,-0.87000000f,0.41000000f,-0.07000000f,-0.71000000f,-0.30000000f,0.07000000f,0.37000000f,-0.16000000f,0.39000000f,-0.62000000f,-0.02000000f,0.57000000f,-0.37000000f,0.31000000f,-0.55000000f,-0.41000000f,-0.11000000f,-0.32000000f,-0.19000000f,0.31000000f,0.29000000f,0.44000000f,0.09000000f,-0.54000000f,0.38000000f,0.07000000f,0.10000000f,-0.71000000f,-0.97000000f,-0.48000000f,-0.55000000f,0.49000000f,-0.95000000f,0.92000000f,0.69000000f,0.24000000f,-0.82000000f,0.33000000f,-0.03000000f,-0.20000000f,-0.14000000f,-0.77000000f,-0.16000000f,0.57000000f,0.39000000f,0.84000000f,-0.73000000f,-0.48000000f,0.65000000f,0.33000000f,0.24000000f,-0.56000000f,0.31000000f,0.23000000f,0.44000000f,-0.97000000f,-0.87000000f,0.14000000f,-0.73000000f,-0.02000000f,0.18000000f,-0.09000000f,-0.02000000f,-0.27000000f,0.09000000f,0.96000000f,-0.01000000f,-0.79000000f,0.29000000f,-0.34000000f,0.99000000f,0.87000000f,-0.45000000f,0.55000000f,-0.25000000f,-0.69000000f,-0.75000000f,-0.45000000f,-0.27000000f,-0.00000000f,-0.99000000f,0.26000000f,0.07000000f,-0.60000000f,-0.50000000f,-0.11000000f,0.20000000f,0.01000000f,-0.09000000f,-0.56000000f,0.85000000f,0.96000000f,0.02000000f,0.09000000f,-0.63000000f,0.13000000f,0.61000000f,0.46000000f,-0.97000000f,0.29000000f,0.09000000f,-0.41000000f,-0.73000000f,0.43000000f,-0.49000000f,-0.33000000f,-0.35000000f,-0.36000000f,0.63000000f,0.41000000f,-0.57000000f,-0.39000000f,0.65000000f,-0.03000000f,-0.29000000f,0.06000000f,0.04000000f,0.97000000f,-0.50000000f,-0.54000000f,0.86000000f,-0.41000000f,0.57000000f,-0.12000000f,0.51000000f,-0.41000000f,0.77000000f,-0.89000000f,-0.74000000f,0.45000000f,0.99000000f,0.03000000f,0.96000000f,0.48000000f,0.47000000f,-0.71000000f,-0.85000000f,0.62000000f,-0.83000000f,-0.71000000f,-0.87000000f,0.97000000f,-0.41000000f,-0.20000000f,-0.84000000f,0.55000000f,-0.01000000f,-0.76000000f,0.15000000f,0.55000000f,0.26000000f,0.19000000f,0.70000000f,0.07000000f,-0.56000000f,-0.51000000f,0.48000000f,-0.55000000f,0.14000000f,0.53000000f,-0.53000000f,-0.99000000f,-0.22000000f,-0.61000000f,-0.88000000f,-0.26000000f,0.46000000f,-0.19000000f,-0.22000000f,0.20000000f,-0.02000000f,0.71000000f,-0.82000000f,-0.67000000f,0.80000000f,0.31000000f,-0.58000000f,-0.59000000f,-0.63000000f,0.48000000f,-0.73000000f,0.45000000f,0.49000000f,0.74000000f,0.59000000f,0.72000000f,-0.48000000f,0.18000000f,-0.12000000f,0.30000000f,0.81000000f,0.55000000f,0.97000000f,-0.66000000f,-0.52000000f,-0.99000000f,0.14000000f,-0.62000000f,-0.02000000f,0.90000000f,0.78000000f,0.77000000f,-0.05000000f,-0.06000000f,0.51000000f,-0.26000000f,0.64000000f,0.91000000f,0.66000000f,0.52000000f,0.19000000f,0.21000000f,-0.52000000f,0.96000000f,0.71000000f,0.28000000f,-0.89000000f,-0.01000000f,0.83000000f,0.07000000f,0.39000000f,-0.88000000f,0.28000000f,0.68000000f,-0.81000000f,-0.46000000f,0.42000000f,0.47000000f,-0.43000000f,-0.93000000f,0.43000000f,-0.76000000f,0.15000000f,0.88000000f,0.21000000f,0.30000000f,-0.85000000f,-0.26000000f,-0.12000000f,-0.96000000f,-0.84000000f,-0.97000000f,-0.49000000f,0.64000000f,0.42000000f,-0.50000000f,0.87000000f,0.19000000f,-0.13000000f,-0.46000000f,-0.45000000f,-0.95000000f,0.22000000f,0.41000000f,0.83000000f,-0.14000000f,-0.33000000f,0.87000000f,0.76000000f,-0.06000000f,-0.94000000f,0.72000000f,0.73000000f,-0.78000000f,0.90000000f,0.89000000f,0.84000000f,0.90000000f,0.28000000f,0.88000000f,0.86000000f,-0.62000000f,0.02000000f,-0.81000000f,-0.52000000f,-0.82000000f,-0.14000000f,-0.42000000f,-0.30000000f,-0.02000000f,0.79000000f,0.10000000f,-0.58000000f,-0.00000000f,0.95000000f,0.55000000f,-0.75000000f,-0.09000000f,0.36000000f,0.44000000f,0.30000000f,0.03000000f,-0.49000000f,-0.60000000f,0.95000000f,0.86000000f,-0.67000000f,-0.23000000f,0.28000000f,-0.45000000f,-0.58000000f,-0.52000000f,0.77000000f,-0.19000000f,-0.88000000f,-0.16000000f,0.08000000f,0.82000000f,-0.02000000f,0.45000000f,-0.66000000f,0.73000000f,0.94000000f,-0.55000000f,-0.54000000f,0.02000000f,0.62000000f,0.71000000f,-0.99000000f,0.10000000f,-0.06000000f,0.08000000f,0.79000000f,-0.00000000f,-0.77000000f,-0.47000000f,0.42000000f,0.83000000f,0.21000000f,0.08000000f,-0.43000000f,-0.14000000f,0.22000000f,0.32000000f,-0.03000000f,0.11000000f,0.12000000f,-0.64000000f,-0.58000000f,-0.54000000f,-0.08000000f,-0.38000000f,0.41000000f,0.61000000f,-0.65000000f,0.27000000f,0.98000000f,-0.40000000f,-0.13000000f,0.83000000f,0.74000000f,-0.68000000f,0.22000000f,-0.69000000f,0.42000000f,0.77000000f,-0.87000000f,-0.42000000f,-0.77000000f,-0.11000000f,0.25000000f,-0.69000000f,0.84000000f,-0.25000000f,-0.38000000f,-0.56000000f,-0.20000000f,-0.35000000f,0.83000000f,-0.89000000f,-0.51000000f,0.82000000f,-0.77000000f,0.05000000f,0.78000000f,0.71000000f,0.12000000f,-0.82000000f,-0.32000000f,0.09000000f,0.63000000f,0.70000000f,-0.49000000f,0.80000000f,0.25000000f,-0.85000000f,0.04000000f,-0.72000000f,0.56000000f,0.14000000f,0.62000000f,0.17000000f,-0.88000000f,-0.26000000f,0.20000000f,0.72000000f,-0.55000000f,-0.57000000f,-0.33000000f,0.66000000f,-0.12000000f,0.46000000f,-0.14000000f,-0.87000000f,-0.12000000f,0.08000000f,0.92000000f,0.41000000f,0.36000000f,-0.58000000f,-0.17000000f,0.25000000f,-0.97000000f,-0.87000000f,-0.86000000f,-0.43000000f,0.85000000f,-0.38000000f,-0.45000000f,0.47000000f,0.41000000f,0.98000000f,-0.67000000f,-0.13000000f,-0.36000000f,0.08000000f,-0.33000000f,0.92000000f,-0.96000000f,-0.13000000f,0.71000000f,0.77000000f,0.17000000f,-0.03000000f,-0.92000000f,-0.06000000f,0.00000000f,0.29000000f,-0.14000000f,-0.79000000f,0.64000000f,0.53000000f,0.82000000f,-0.02000000f,-0.39000000f,0.94000000f,-0.97000000f,-0.67000000f,-0.98000000f,-0.38000000f,-0.25000000f,-0.76000000f,0.21000000f,0.80000000f,0.24000000f,-0.69000000f,-0.44000000f,-0.80000000f,0.17000000f,-0.87000000f,0.33000000f,0.72000000f,-0.23000000f,-0.39000000f,0.52000000f,-0.39000000f,-0.14000000f,-0.70000000f,0.86000000f,-0.58000000f,0.05000000f,0.82000000f,0.19000000f,0.58000000f,-0.76000000f,0.00000000f,0.09000000f,0.97000000f,-0.60000000f,0.90000000f,-0.73000000f,-0.47000000f,-0.47000000f,0.18000000f,0.93000000f,-0.53000000f,0.71000000f,0.34000000f,0.48000000f,-0.12000000f,0.94000000f,0.12000000f,-0.44000000f,-0.35000000f,-0.93000000f,-0.00000000f,-0.91000000f,0.40000000f,0.37000000f,-0.87000000f,-0.86000000f,0.68000000f,0.55000000f,0.35000000f,-0.30000000f,0.31000000f,-0.37000000f,0.81000000f,0.89000000f,-0.00000000f,-0.72000000f,-0.24000000f,-0.33000000f,-0.09000000f,-0.79000000f,0.41000000f,0.15000000f,-0.30000000f,-0.99000000f,-0.00000000f,-0.07000000f,-0.55000000f,0.22000000f,0.54000000f,-0.15000000f,-0.45000000f,-0.79000000f,-0.75000000f,-0.50000000f,-0.69000000f,-0.59000000f,-0.67000000f,0.70000000f,0.29000000f,0.74000000f,0.83000000f,-0.83000000f,0.41000000f,-0.04000000f,-0.94000000f,0.59000000f,-0.38000000f,0.85000000f,0.34000000f,-0.06000000f,0.08000000f,0.79000000f,0.41000000f,-0.19000000f,-0.15000000f,0.25000000f,-0.66000000f,0.03000000f,0.57000000f,-0.17000000f,0.69000000f,0.32000000f,0.07000000f,-0.95000000f,0.49000000f,0.42000000f,-0.75000000f,0.70000000f,-0.09000000f,-0.98000000f,-0.93000000f,0.40000000f,-0.38000000f,0.36000000f,-0.49000000f,0.65000000f,-0.30000000f,0.14000000f,-0.99000000f,0.66000000f,-0.27000000f,0.94000000f,0.08000000f,-0.70000000f,0.78000000f,-0.93000000f,-0.97000000f,-0.89000000f,-0.94000000f,-0.77000000f,-0.75000000f,-0.87000000f,0.89000000f,-0.25000000f,0.61000000f,0.59000000f,-0.55000000f,-0.73000000f,0.26000000f,0.93000000f,-0.42000000f,0.66000000f,-0.91000000f,-0.72000000f,0.05000000f,0.26000000f,-0.49000000f,-0.00000000f,-0.88000000f,-0.66000000f,0.34000000f,0.93000000f,0.91000000f,0.94000000f,0.25000000f,0.72000000f,0.13000000f,-0.23000000f,-0.67000000f,-0.99000000f,-0.77000000f,0.45000000f,0.33000000f,0.68000000f,0.34000000f,0.43000000f,0.60000000f,0.36000000f,-0.72000000f,-0.56000000f,-0.41000000f,-0.72000000f,0.65000000f,0.34000000f,0.91000000f,0.95000000f,-0.90000000f,-0.85000000f,0.91000000f,0.80000000f,-0.60000000f,-0.96000000f,0.29000000f,-0.36000000f,-0.54000000f,0.81000000f,-0.95000000f,-0.54000000f,0.67000000f,0.13000000f,0.16000000f,0.73000000f,0.92000000f,0.00000000f,0.08000000f,-0.05000000f,0.84000000f,-0.42000000f,-0.82000000f,-0.31000000f,-0.82000000f,-0.14000000f,-0.65000000f,-0.15000000f,0.55000000f,0.56000000f,-0.93000000f,-0.06000000f,0.59000000f,0.48000000f,0.60000000f,0.08000000f,-0.81000000f,-0.72000000f,-0.69000000f,-0.19000000f,0.02000000f,0.25000000f,-0.38000000f,-0.41000000f,0.31000000f,-0.84000000f,-0.09000000f,0.64000000f,0.62000000f,-0.00000000f,0.78000000f,-0.87000000f,-0.50000000f,-0.85000000f,0.61000000f,-0.90000000f,0.96000000f,0.51000000f,0.99000000f,-0.33000000f,-0.44000000f,-0.23000000f,-0.27000000f,-0.03000000f,-0.75000000f,0.12000000f,-0.78000000f,-0.25000000f,0.44000000f,0.49000000f,0.33000000f,0.33000000f,-0.77000000f,-0.35000000f,-0.39000000f,-0.49000000f,0.00000000f,-0.20000000f,-0.06000000f,-0.78000000f,0.41000000f,0.31000000f,0.62000000f,-0.78000000f,-0.36000000f,0.98000000f,-0.03000000f,-0.41000000f,-0.01000000f,-0.81000000f,0.30000000f,-0.81000000f,0.60000000f,-0.05000000f,0.20000000f,0.70000000f,0.81000000f,0.64000000f,0.78000000f,0.84000000f,0.07000000f,0.86000000f,0.72000000f,0.59000000f,-0.58000000f,-0.85000000f,0.23000000f,0.03000000f,-0.40000000f,-0.29000000f,-0.16000000f,0.59000000f,0.79000000f,0.07000000f,-0.29000000f,0.45000000f,-0.94000000f,-0.48000000f,-0.65000000f,0.57000000f,0.43000000f,-0.31000000f,-0.18000000f,-0.83000000f,-0.85000000f,-0.27000000f,0.28000000f,0.58000000f,-0.07000000f,0.74000000f,0.09000000f,-0.80000000f,0.93000000f,-0.84000000f,0.74000000f,0.37000000f,0.85000000f,0.70000000f,-0.95000000f,0.35000000f,-0.81000000f,-0.54000000f,0.81000000f,0.05000000f,0.02000000f,0.47000000f,-0.70000000f,0.45000000f,0.44000000f,-0.12000000f,0.46000000f,-0.76000000f,0.42000000f,-0.38000000f,-0.47000000f,-0.80000000f,-0.96000000f,-0.97000000f,-0.95000000f,-0.91000000f,0.79000000f,-0.41000000f,-0.87000000f,0.60000000f,0.72000000f,0.19000000f,0.45000000f,0.99000000f,-0.02000000f,-0.70000000f,-0.89000000f,-0.75000000f,-0.54000000f,0.11000000f,-0.69000000f,0.94000000f,-0.86000000f,-0.34000000f,-0.79000000f,-0.75000000f,0.84000000f,-0.56000000f,0.63000000f,0.22000000f,-0.69000000f,0.34000000f,0.34000000f,0.38000000f,0.03000000f,0.43000000f,-0.38000000f,-0.70000000f,-0.34000000f,-0.01000000f,-0.47000000f,-0.88000000f,0.97000000f,-0.99000000f,0.33000000f,-0.79000000f,-0.79000000f,-0.78000000f,-0.14000000f,-0.58000000f,-0.93000000f,0.41000000f,0.14000000f,0.40000000f,-0.06000000f,0.31000000f,-0.69000000f,-0.83000000f,0.29000000f,0.08000000f,0.66000000f,0.71000000f,0.11000000f,0.28000000f,0.98000000f,0.94000000f,0.11000000f,0.91000000f,0.05000000f,-0.07000000f,0.33000000f,-0.97000000f,0.48000000f,-0.77000000f,0.93000000f,0.68000000f,-0.00000000f,0.36000000f,0.37000000f,-0.76000000f,0.51000000f,0.55000000f,-0.92000000f,0.15000000f,0.84000000f,-0.82000000f,0.02000000f,-0.15000000f,0.06000000f,0.05000000f,-0.10000000f,-0.57000000f,0.93000000f,0.03000000f,-0.61000000f,0.47000000f,-0.23000000f,0.39000000f,-0.54000000f,0.33000000f,-0.48000000f,0.45000000f,0.65000000f,0.64000000f,0.35000000f,0.64000000f,-0.39000000f,0.15000000f,0.54000000f,0.97000000f,-0.12000000f,-0.88000000f,0.57000000f,0.95000000f,0.91000000f,0.83000000f,0.64000000f,-0.16000000f,-0.85000000f,0.52000000f,0.03000000f,0.81000000f,0.10000000f,0.47000000f,0.39000000f,-0.66000000f,0.86000000f,0.69000000f,0.29000000f,-0.43000000f,-0.76000000f,0.58000000f,-0.76000000f,-0.89000000f,-0.12000000f,0.37000000f,0.83000000f,-0.02000000f,0.36000000f,0.79000000f,-0.29000000f,0.63000000f,0.18000000f,-0.24000000f,0.62000000f,-0.07000000f,-0.25000000f,0.07000000f,-0.17000000f,-0.60000000f,-0.66000000f,-0.21000000f,0.83000000f,0.04000000f,-0.63000000f,-0.35000000f,0.00000000f,0.22000000f,0.05000000f,-0.18000000f,0.26000000f,0.49000000f,0.51000000f,0.54000000f,-0.43000000f,0.10000000f,0.07000000f,-0.70000000f,0.69000000f,-0.19000000f,-0.24000000f,0.94000000f,0.22000000f,0.16000000f,-0.23000000f,-0.81000000f,-0.72000000f,0.58000000f,0.44000000f,-0.58000000f,-0.89000000f,0.59000000f,0.64000000f,0.72000000f,0.43000000f,0.82000000f,-0.57000000f,0.69000000f,0.27000000f,-0.20000000f,0.24000000f,0.07000000f,0.41000000f,-0.49000000f,0.72000000f,0.27000000f,-0.40000000f,0.11000000f,-0.58000000f,0.78000000f,-0.71000000f,0.97000000f,0.12000000f,0.00000000f,0.76000000f,0.77000000f,-0.70000000f,-0.13000000f,-0.41000000f,0.57000000f,0.42000000f,0.48000000f,0.59000000f,0.47000000f,0.16000000f,-0.10000000f,0.80000000f,0.53000000f,0.50000000f,-0.34000000f,0.78000000f,-0.20000000f,-0.70000000f,0.56000000f,-0.23000000f,-0.11000000f,-0.51000000f,0.44000000f,0.21000000f,-0.59000000f,0.08000000f,-0.43000000f,-0.87000000f,-0.60000000f,-0.35000000f,0.79000000f,-0.62000000f,-0.85000000f,-0.39000000f,-0.39000000f,-0.74000000f,0.80000000f,-0.19000000f,-0.93000000f,0.55000000f,-0.26000000f,-0.86000000f,-0.62000000f,-0.00000000f,-0.20000000f,-0.11000000f,0.95000000f,-0.27000000f,0.59000000f,0.61000000f,-0.78000000f,-0.64000000f,-0.09000000f,-0.51000000f,0.10000000f,0.83000000f,-0.22000000f,0.37000000f,0.40000000f,-0.74000000f,-0.68000000f,-0.22000000f,-0.36000000f,-0.82000000f,0.29000000f,0.29000000f,-0.04000000f,0.88000000f,-0.62000000f,0.49000000f,0.89000000f,-0.87000000f,0.30000000f,0.90000000f,0.54000000f,0.07000000f,-0.52000000f,-0.82000000f,0.65000000f,0.28000000f,0.73000000f,0.43000000f,0.34000000f,0.24000000f,-0.61000000f,-0.20000000f,-0.07000000f,0.85000000f,0.34000000f,-0.33000000f,0.14000000f,0.64000000f,-0.58000000f,0.32000000f,-0.46000000f,0.07000000f,0.88000000f,0.64000000f,0.12000000f,-0.26000000f,-0.11000000f,0.72000000f,-0.58000000f,-0.58000000f,-0.95000000f,0.38000000f,0.11000000f,-0.01000000f,0.15000000f,-0.10000000f,0.50000000f,0.66000000f,0.60000000f,-0.81000000f,0.75000000f,0.48000000f,0.65000000f,-0.83000000f,-0.81000000f,-0.92000000f,-0.31000000f,0.81000000f,-0.35000000f,0.49000000f,0.95000000f,-0.99000000f,0.17000000f,0.34000000f,0.60000000f,0.65000000f,-0.49000000f,-0.18000000f,-0.09000000f,0.35000000f,0.06000000f,0.92000000f,0.78000000f,-0.18000000f,-0.66000000f,0.46000000f,0.58000000f,-0.56000000f,-0.45000000f,0.63000000f,0.03000000f,0.28000000f,-0.84000000f,0.39000000f,0.06000000f,0.85000000f,0.04000000f,-0.50000000f,0.53000000f,0.62000000f,0.46000000f,-0.86000000f,-0.90000000f,-0.72000000f,0.12000000f,0.05000000f,-0.39000000f,-0.41000000f,0.59000000f,-0.19000000f,-0.22000000f,0.50000000f,0.32000000f,0.83000000f,-0.33000000f,-0.83000000f,-0.81000000f,-0.46000000f,-0.63000000f,-0.58000000f,-0.78000000f,-0.49000000f,-0.78000000f,0.19000000f,0.69000000f,-0.66000000f,0.27000000f,-0.10000000f,-0.09000000f,0.88000000f,0.08000000f,0.53000000f,-0.64000000f,-0.38000000f,0.46000000f,-0.64000000f,-0.55000000f,0.33000000f,-0.41000000f,-0.80000000f,0.11000000f,0.37000000f,-0.05000000f,-0.73000000f,-0.57000000f,0.93000000f,0.90000000f,-0.60000000f,0.93000000f,0.81000000f,0.94000000f,0.23000000f,0.06000000f,0.68000000f,-0.06000000f,-0.91000000f,-0.05000000f,0.40000000f,-0.11000000f,-0.83000000f,-0.67000000f,0.96000000f,-0.89000000f,-0.56000000f,0.96000000f,0.82000000f,-0.29000000f,0.80000000f,0.42000000f,0.23000000f,-0.05000000f,-0.06000000f,0.16000000f,-0.54000000f,0.08000000f,0.69000000f,0.97000000f,0.19000000f,-0.65000000f,0.87000000f,0.70000000f,0.67000000f,0.44000000f,0.10000000f,-0.12000000f,0.97000000f,0.07000000f,0.92000000f,-0.00000000f,-0.58000000f,-0.44000000f,0.66000000f,-0.63000000f,-0.32000000f,0.08000000f,0.53000000f,-0.11000000f,0.80000000f,-0.35000000f,0.98000000f,-0.66000000f,-0.63000000f,-0.80000000f,0.87000000f,-0.82000000f,0.09000000f,0.95000000f,-0.25000000f,-0.15000000f,0.72000000f,-0.97000000f,-0.45000000f,0.96000000f,0.49000000f,0.92000000f,-0.19000000f,-0.10000000f,-0.12000000f,-0.00000000f,-0.96000000f,0.76000000f,0.99000000f,-0.37000000f,0.84000000f,0.66000000f,-0.63000000f,-0.41000000f,0.37000000f,-0.29000000f,0.69000000f,0.61000000f,0.54000000f,-0.95000000f,0.97000000f,0.76000000f,0.02000000f,0.06000000f,0.83000000f,-0.94000000f,-0.77000000f,0.04000000f,-0.25000000f,0.57000000f,0.75000000f,0.46000000f,-0.96000000f,-0.49000000f,0.76000000f,0.35000000f,-0.80000000f,-0.74000000f,0.52000000f,-0.57000000f,-0.38000000f,-0.75000000f,-0.88000000f,0.76000000f,-0.69000000f,0.22000000f,-0.64000000f,0.65000000f,0.79000000f,-0.79000000f,0.78000000f,-0.13000000f,0.07000000f,-0.98000000f,0.63000000f,0.94000000f,-0.54000000f,0.52000000f,0.02000000f,-0.64000000f,-0.05000000f,0.04000000f,-0.91000000f,-0.05000000f,-0.54000000f,0.67000000f,0.44000000f,-0.43000000f,-0.37000000f,0.03000000f,0.37000000f,-0.51000000f,-0.36000000f,0.21000000f,0.65000000f,-0.62000000f,0.20000000f,-0.90000000f,-0.37000000f,-0.11000000f,-0.40000000f,-0.11000000f,0.50000000f,0.81000000f,0.46000000f,0.03000000f,-0.09000000f,0.05000000f,-0.20000000f,0.98000000f,0.45000000f,0.26000000f,-0.15000000f,-0.40000000f,0.70000000f,-0.17000000f,-0.59000000f,-0.23000000f,-0.80000000f,0.65000000f,-0.47000000f,0.39000000f,0.68000000f,-0.64000000f,0.15000000f,-0.89000000f,0.98000000f,-0.36000000f,0.15000000f,-0.59000000f,0.88000000f,0.47000000f,-0.01000000f,0.26000000f,-0.94000000f,0.39000000f,-0.76000000f,-0.43000000f,-0.29000000f,-0.88000000f,-0.52000000f,-0.42000000f,0.12000000f,-0.56000000f,0.09000000f,0.38000000f,0.32000000f,-0.22000000f,-0.29000000f,-0.46000000f,0.59000000f,-0.96000000f,0.30000000f,0.95000000f,-0.76000000f,-0.90000000f,-0.76000000f,0.56000000f,0.35000000f,-0.76000000f,0.42000000f,-0.72000000f,-0.67000000f,0.74000000f,-0.60000000f,0.90000000f,0.74000000f,-0.87000000f,-0.36000000f,-0.12000000f,0.29000000f,-0.83000000f,0.60000000f,0.35000000f,0.44000000f,-0.50000000f,0.19000000f,0.19000000f,0.42000000f,-0.47000000f,-0.50000000f,-0.35000000f,0.49000000f,0.41000000f,-0.19000000f,-0.08000000f,-0.70000000f,0.76000000f,-0.44000000f,0.69000000f,0.16000000f,-0.01000000f,0.56000000f,-0.85000000f,-0.11000000f,-0.87000000f,0.11000000f,0.17000000f,-0.05000000f,0.50000000f,0.24000000f,-0.47000000f,0.57000000f,0.59000000f,-0.90000000f,0.95000000f,-0.05000000f,0.02000000f,0.51000000f,0.82000000f,0.28000000f,0.91000000f,-0.59000000f,0.65000000f,-0.42000000f,-0.82000000f,0.84000000f,-0.31000000f,-0.41000000f,0.75000000f,0.68000000f,-0.67000000f,0.52000000f,-0.18000000f,0.79000000f,-0.38000000f,0.63000000f,0.33000000f,-0.93000000f,-0.59000000f,0.76000000f,-0.60000000f,0.03000000f,-0.77000000f,-0.34000000f,0.17000000f,-0.35000000f,0.81000000f,0.50000000f,0.82000000f,0.57000000f,0.61000000f,-0.38000000f,0.69000000f,0.69000000f,0.75000000f,-0.61000000f,-0.73000000f,0.53000000f,0.66000000f,-0.83000000f,-0.69000000f,0.67000000f,-0.41000000f,0.84000000f,-0.23000000f,0.70000000f,0.95000000f,0.66000000f,0.81000000f,0.64000000f,-0.55000000f,-0.80000000f,0.45000000f,-0.11000000f,-0.77000000f,-0.47000000f,-0.36000000f,-0.41000000f,-0.82000000f,-0.60000000f,-0.32000000f,-0.58000000f,0.49000000f,0.32000000f,-0.38000000f,0.35000000f,-0.88000000f,-0.11000000f,0.49000000f,0.24000000f,0.97000000f,0.68000000f,0.90000000f,0.62000000f,-0.40000000f,0.94000000f,-0.16000000f,-0.57000000f,-0.00000000f,-0.18000000f,0.55000000f,-0.88000000f,0.95000000f,-0.49000000f,-0.75000000f,0.54000000f,0.45000000f,0.03000000f,0.59000000f,0.17000000f,-0.22000000f,-0.44000000f,-0.63000000f,0.69000000f,0.08000000f,0.06000000f,-0.43000000f,0.00000000f,-0.50000000f,-0.86000000f,-0.48000000f,0.91000000f,-0.19000000f,-0.18000000f,-0.61000000f,0.85000000f,-0.41000000f,-0.73000000f,0.83000000f,-0.86000000f,0.66000000f,0.94000000f,-0.02000000f,-0.07000000f,0.21000000f,-0.68000000f,-0.33000000f,-0.40000000f,0.13000000f,-0.11000000f,0.59000000f,-0.91000000f,-0.28000000f,0.72000000f,0.18000000f,0.46000000f,-0.20000000f,-0.36000000f,-0.93000000f,-0.38000000f,0.91000000f,-0.03000000f,-0.85000000f,-0.05000000f,0.23000000f,-0.03000000f,-0.28000000f,0.68000000f,0.93000000f,0.07000000f,0.69000000f,-0.76000000f,-0.55000000f,0.42000000f,-0.27000000f,-0.28000000f,0.39000000f,-0.02000000f,0.95000000f,-0.43000000f,0.38000000f,0.70000000f,0.93000000f,-0.55000000f,-0.25000000f,-0.72000000f,-0.44000000f,0.97000000f,-0.72000000f,-0.24000000f,-0.66000000f,-0.99000000f,-0.29000000f,-0.93000000f,0.97000000f,0.64000000f,0.65000000f,0.95000000f,0.58000000f,0.13000000f,0.18000000f,0.42000000f,-0.38000000f,0.11000000f,0.60000000f,0.30000000f,-0.01000000f,0.79000000f,-0.31000000f,-0.70000000f,0.23000000f,-0.17000000f,-0.58000000f,-0.82000000f,0.13000000f,-0.75000000f,-0.44000000f,0.99000000f,0.26000000f,-0.55000000f,0.12000000f,-0.40000000f,0.85000000f,-0.93000000f,0.28000000f,-0.78000000f,-0.94000000f,0.99000000f,-0.71000000f,0.55000000f,-0.30000000f,0.20000000f,0.33000000f,-0.84000000f,-0.93000000f,-0.49000000f,-0.83000000f,-0.30000000f,-0.44000000f,-0.14000000f,0.96000000f,-0.71000000f,-0.68000000f,0.60000000f,0.74000000f,-0.86000000f,-0.10000000f,-0.04000000f,0.07000000f,-0.30000000f,0.28000000f,-0.10000000f,0.15000000f,-0.34000000f,0.94000000f,0.71000000f,0.17000000f,-0.48000000f,-0.53000000f,0.93000000f,0.73000000f,0.29000000f,-0.17000000f,-0.34000000f,-0.61000000f,-0.93000000f,0.94000000f,-0.14000000f,0.27000000f,0.49000000f,0.78000000f,-0.69000000f,0.36000000f,0.38000000f,0.49000000f,-0.93000000f,0.83000000f,-0.85000000f,0.51000000f,0.43000000f,0.61000000f,0.40000000f,-0.95000000f,-0.81000000f,0.09000000f,-0.87000000f,-0.42000000f,-0.85000000f,0.34000000f,-0.43000000f,0.72000000f,-0.40000000f,-0.51000000f,-0.39000000f,-0.50000000f,-0.74000000f,0.91000000f,0.49000000f,0.92000000f,0.84000000f,0.68000000f,-0.63000000f,-0.77000000f,0.25000000f,0.63000000f,-0.60000000f,0.32000000f,-0.94000000f,0.69000000f,-0.81000000f,0.55000000f,0.07000000f,0.58000000f,-0.76000000f,-0.82000000f,0.53000000f,-0.87000000f,-0.97000000f,-0.92000000f,-0.19000000f,0.12000000f,-0.70000000f,0.05000000f,0.99000000f,-0.88000000f,-0.76000000f,-0.81000000f,-0.81000000f,0.94000000f,-0.22000000f,0.44000000f,0.10000000f,-0.09000000f,0.34000000f,-0.72000000f,-0.19000000f,-0.44000000f,0.29000000f,0.74000000f,0.45000000f,0.77000000f,0.36000000f,0.37000000f,-0.59000000f,0.46000000f,0.41000000f,-0.86000000f,-0.10000000f,-0.42000000f,0.66000000f,0.11000000f,0.50000000f,0.17000000f,0.78000000f,0.92000000f,0.93000000f,0.64000000f,0.61000000f,0.53000000f,-0.51000000f,0.75000000f,-0.89000000f,-0.01000000f,0.50000000f,-0.27000000f,-0.40000000f,0.06000000f,0.66000000f,-0.02000000f,-0.70000000f,-0.13000000f,0.03000000f,-0.72000000f,-0.64000000f,0.67000000f,0.12000000f,-0.97000000f,0.97000000f,-0.74000000f,-0.56000000f,-0.11000000f,0.81000000f,-0.13000000f,-0.32000000f,0.06000000f,0.10000000f,0.77000000f,-0.80000000f,-0.68000000f,-0.14000000f,-0.53000000f,-0.70000000f,-0.18000000f,-0.37000000f,-0.61000000f,0.12000000f,0.65000000f,0.40000000f,-0.16000000f,-0.92000000f,0.92000000f,0.94000000f,-0.20000000f,-0.24000000f,0.33000000f,-0.75000000f,0.83000000f,0.67000000f,-0.10000000f,-0.18000000f,0.84000000f,-0.23000000f,-0.80000000f,0.77000000f,-0.80000000f,0.60000000f,-0.51000000f,0.64000000f,-0.63000000f,0.89000000f,-0.61000000f,0.00000000f,0.43000000f,0.86000000f,0.23000000f,-0.51000000f,0.05000000f,-0.23000000f,0.05000000f,0.32000000f,0.36000000f,0.78000000f,0.12000000f,-0.52000000f,0.52000000f,-0.86000000f,-0.37000000f,-0.63000000f,0.50000000f,-0.82000000f,-0.93000000f,0.49000000f,-0.20000000f,-0.35000000f,0.20000000f,-0.03000000f,0.09000000f,0.01000000f,0.26000000f,0.14000000f,0.82000000f,0.15000000f,0.26000000f,-0.83000000f,-0.22000000f,0.36000000f,0.26000000f,-0.40000000f,0.90000000f,0.87000000f,-0.96000000f,0.87000000f,0.73000000f,0.67000000f,0.08000000f,0.46000000f,0.59000000f,0.59000000f,0.82000000f,0.99000000f,-0.13000000f,0.18000000f,-0.04000000f,0.60000000f,-0.60000000f,0.84000000f,-0.80000000f,-0.54000000f,0.40000000f,-0.57000000f,-0.43000000f,-0.08000000f,-0.09000000f,0.62000000f,0.58000000f,0.89000000f,-0.38000000f,0.07000000f,-0.72000000f,-0.15000000f,0.20000000f,0.34000000f,-0.81000000f,-0.04000000f,-0.06000000f,0.77000000f,-0.95000000f,-0.99000000f,-0.05000000f,-0.13000000f,-0.37000000f,-0.21000000f,-0.31000000f,-0.77000000f,-0.82000000f,0.67000000f,0.71000000f,0.03000000f,0.98000000f,0.46000000f,-0.87000000f,0.55000000f,-0.14000000f,0.14000000f,0.26000000f,0.05000000f,0.31000000f,0.67000000f,-0.00000000f,-0.49000000f,-0.71000000f,-0.75000000f,-0.66000000f,0.27000000f,-0.29000000f,0.04000000f,-0.91000000f,0.02000000f,-0.68000000f,-0.03000000f,-0.47000000f,0.34000000f,-0.89000000f,-0.98000000f,-0.00000000f,0.11000000f,-0.52000000f,0.28000000f,-0.42000000f,0.60000000f,0.28000000f,0.42000000f,0.91000000f,-0.09000000f,0.23000000f,-0.44000000f,-0.39000000f,-0.20000000f,0.61000000f,0.82000000f,-0.43000000f,0.57000000f,0.15000000f,-0.03000000f,-0.71000000f,-0.19000000f,0.56000000f,0.54000000f,0.99000000f,-0.59000000f,-0.76000000f,-0.90000000f,0.05000000f,0.00000000f,-0.56000000f,-0.85000000f,-0.74000000f,0.31000000f,-0.92000000f,0.38000000f,0.13000000f,0.44000000f,0.94000000f,0.95000000f,0.35000000f,0.18000000f,0.35000000f,-0.16000000f,0.15000000f,0.21000000f,-0.90000000f,0.80000000f,0.50000000f,-0.68000000f,-0.20000000f,-0.99000000f,0.20000000f,0.71000000f,0.65000000f,0.46000000f,0.21000000f,0.19000000f,-0.64000000f,0.79000000f,-0.23000000f,0.69000000f,-0.71000000f,0.29000000f,-0.55000000f,0.61000000f,-0.31000000f,0.18000000f,-0.00000000f,0.40000000f,-0.89000000f,-0.38000000f,-0.08000000f,-0.43000000f,-0.87000000f,0.53000000f,-0.05000000f,0.55000000f,0.80000000f,-0.60000000f,-0.87000000f,-0.15000000f,-0.22000000f,-0.55000000f,-0.41000000f,-0.43000000f,0.69000000f,0.32000000f,-0.10000000f,-0.29000000f,0.26000000f,0.88000000f,-0.86000000f,-0.16000000f,-0.36000000f,-0.94000000f,0.47000000f,-0.75000000f,-0.15000000f,-0.10000000f,0.97000000f,0.93000000f,0.39000000f,0.29000000f,0.12000000f,0.49000000f,-0.38000000f,0.22000000f,0.24000000f,-0.33000000f,0.18000000f,0.37000000f,-0.80000000f,-0.77000000f,0.28000000f,-0.26000000f,0.05000000f,0.60000000f,-0.85000000f,-0.14000000f,0.90000000f,-0.44000000f,0.36000000f,-0.85000000f,-0.89000000f,0.36000000f,-0.93000000f,0.44000000f,-0.95000000f,-0.18000000f,0.62000000f,-0.50000000f,-0.58000000f,-0.08000000f,0.84000000f,0.33000000f,-0.96000000f,0.92000000f,0.41000000f,-0.61000000f,0.90000000f,0.09000000f,-0.70000000f,-0.73000000f,-0.64000000f,-0.09000000f,-0.09000000f,-0.42000000f,-0.90000000f,0.61000000f,0.71000000f,0.82000000f,-0.42000000f,0.56000000f,0.97000000f,0.64000000f,-0.49000000f,-0.22000000f,-0.94000000f,0.24000000f,-0.29000000f,-0.88000000f,-0.54000000f,0.97000000f,-0.76000000f,0.66000000f,-0.71000000f,-0.64000000f,-0.64000000f,-0.53000000f,0.20000000f,0.23000000f,-0.56000000f,-0.62000000f,-0.55000000f,0.18000000f,0.18000000f,-0.77000000f,0.19000000f,-0.68000000f,0.89000000f,0.50000000f,0.42000000f,-0.10000000f,-0.28000000f,0.41000000f,-0.39000000f,-0.51000000f,0.70000000f,-0.98000000f,0.44000000f,0.04000000f,-0.46000000f,-0.63000000f,-0.93000000f,-0.31000000f,0.41000000f,0.35000000f,0.53000000f,0.77000000f,0.60000000f,0.26000000f,-0.21000000f,0.82000000f,-0.92000000f,0.92000000f,-0.70000000f,-0.10000000f,0.64000000f,-0.83000000f,-0.55000000f,0.61000000f,0.77000000f,-0.72000000f,-0.30000000f,-0.85000000f,0.33000000f,-0.60000000f,0.19000000f,0.86000000f,0.70000000f,0.77000000f,0.21000000f,0.86000000f,0.04000000f,0.22000000f,0.95000000f,0.57000000f,0.36000000f,-0.41000000f,0.37000000f,-0.17000000f,0.29000000f,0.70000000f,-0.40000000f,-0.39000000f,-0.83000000f,-0.11000000f,0.84000000f,-0.43000000f,-0.48000000f,0.13000000f,-0.27000000f,-0.75000000f,-0.54000000f,0.79000000f,0.75000000f,-0.85000000f,0.90000000f,-0.41000000f,0.24000000f,0.29000000f,0.61000000f,0.69000000f,-0.03000000f,-0.72000000f,-0.36000000f,-0.33000000f,-0.32000000f,-0.11000000f,0.19000000f,-0.84000000f,-0.24000000f,-0.77000000f,-0.96000000f,0.70000000f,0.04000000f,0.95000000f,-0.97000000f,-0.11000000f,-0.24000000f,0.69000000f,-0.13000000f,0.85000000f,0.43000000f,-0.41000000f,-0.89000000f,0.70000000f,0.09000000f,-0.63000000f,0.57000000f,0.80000000f,0.56000000f,-0.62000000f,0.32000000f,-0.28000000f,0.54000000f,0.14000000f,-0.67000000f,-0.24000000f,-0.79000000f,0.23000000f,-0.95000000f,-0.16000000f,-0.85000000f,-0.18000000f,0.46000000f,-0.60000000f,0.36000000f,0.22000000f,-0.08000000f,0.15000000f,0.62000000f,-0.20000000f,0.88000000f,-0.26000000f,-0.13000000f,-0.11000000f,0.56000000f,0.17000000f,0.67000000f,-0.56000000f,0.49000000f,0.87000000f,-0.35000000f,-0.73000000f,-0.93000000f,-0.80000000f,-0.06000000f,-0.95000000f,-0.36000000f,-0.26000000f,0.34000000f,0.19000000f,0.57000000f,0.56000000f,-0.65000000f,0.60000000f,0.94000000f,0.86000000f,-0.16000000f,-0.95000000f,0.36000000f,0.12000000f,-0.42000000f,0.34000000f,0.75000000f,-0.14000000f,0.15000000f,0.03000000f,-0.17000000f,0.70000000f,0.95000000f,0.95000000f,0.79000000f,0.11000000f,-0.82000000f,-0.30000000f,0.75000000f,-0.72000000f,-0.91000000f,0.31000000f,-0.07000000f,0.42000000f,0.85000000f,0.00000000f,-0.47000000f,0.37000000f,-0.62000000f,0.22000000f,0.10000000f,0.75000000f,-0.15000000f,-0.13000000f,0.18000000f,-0.21000000f,0.45000000f,-0.35000000f,0.77000000f,-0.40000000f,-0.75000000f,0.59000000f,0.87000000f,-0.62000000f,-0.91000000f,0.55000000f,-0.09000000f,0.06000000f,0.30000000f,0.52000000f,-0.51000000f,-0.03000000f,0.89000000f,-0.05000000f,0.88000000f,0.83000000f,-0.66000000f,-0.01000000f,0.34000000f,-0.83000000f,0.60000000f,0.47000000f,0.65000000f,0.51000000f,0.70000000f,0.62000000f,0.99000000f,0.34000000f,0.41000000f,-0.31000000f,0.75000000f,0.61000000f,0.04000000f,0.54000000f,-0.42000000f,0.47000000f,-0.43000000f,0.39000000f,-0.58000000f,-0.44000000f,-0.02000000f,-0.08000000f,0.38000000f,-0.77000000f,-0.55000000f,-0.20000000f,0.63000000f,-0.93000000f,-0.96000000f,-0.04000000f,-0.26000000f,0.83000000f,0.34000000f,0.31000000f,-0.32000000f,0.37000000f,-0.74000000f,0.60000000f,-0.77000000f,-0.04000000f,0.65000000f,0.94000000f,-0.39000000f,0.01000000f,-0.76000000f,-0.25000000f,0.44000000f,0.87000000f,0.06000000f,-0.58000000f,-0.21000000f,0.67000000f,-0.97000000f,0.22000000f,0.24000000f,-0.16000000f,0.82000000f,-0.19000000f,0.66000000f,0.00000000f,0.50000000f,-0.85000000f,0.32000000f,-0.66000000f,0.11000000f,-0.48000000f,0.66000000f,-0.60000000f,-0.50000000f,0.29000000f,-0.93000000f,0.94000000f,-0.02000000f,0.41000000f,-0.13000000f,-0.04000000f,0.77000000f,0.31000000f,-0.23000000f,0.84000000f,0.25000000f,-0.48000000f,-0.51000000f,0.19000000f,-0.42000000f,-0.03000000f,-0.13000000f,0.78000000f,0.76000000f,0.23000000f,0.63000000f,0.23000000f,-0.82000000f,0.41000000f,0.10000000f,0.73000000f,0.49000000f,-0.94000000f,0.80000000f,-0.40000000f,0.78000000f,-0.12000000f,-0.49000000f,-0.80000000f,0.37000000f,0.96000000f,0.22000000f,-0.93000000f,0.78000000f,-0.74000000f,-0.71000000f,0.46000000f,-0.38000000f,0.86000000f,0.03000000f,0.48000000f,0.22000000f,-0.05000000f,0.13000000f,0.91000000f,-0.20000000f,0.36000000f,0.64000000f,0.26000000f,0.38000000f,-0.10000000f,0.57000000f,-0.14000000f,-0.72000000f,0.08000000f,0.55000000f,-0.91000000f,0.62000000f,0.27000000f,-0.49000000f,-0.22000000f,0.22000000f,-0.12000000f,-0.32000000f,-0.28000000f,0.15000000f,-0.92000000f,0.58000000f,-0.51000000f,-0.07000000f,-0.45000000f,-0.24000000f,-0.73000000f,0.63000000f,-0.70000000f,-0.11000000f,-0.46000000f,-0.75000000f,-0.58000000f,-0.15000000f,0.38000000f,-0.22000000f,0.23000000f,-0.26000000f,0.41000000f,0.14000000f,0.87000000f,0.44000000f,0.26000000f,0.79000000f,0.28000000f,0.19000000f,0.06000000f,0.84000000f,0.19000000f,0.91000000f,-0.25000000f,0.24000000f,0.07000000f,-0.46000000f,-0.57000000f,0.86000000f,0.98000000f,-0.33000000f,0.77000000f,0.04000000f,0.55000000f,-0.04000000f,-0.72000000f,-0.44000000f,0.36000000f,-0.73000000f,0.74000000f,-0.86000000f,0.71000000f,0.89000000f,-0.94000000f,-0.03000000f,0.07000000f,0.12000000f,-0.14000000f,-0.20000000f,-0.71000000f,-0.51000000f,-0.23000000f,-0.35000000f,-0.89000000f,0.75000000f,-0.95000000f,-0.48000000f,-0.34000000f,-0.16000000f,0.45000000f,0.34000000f,-0.50000000f,-0.82000000f,0.12000000f,0.18000000f,0.35000000f,-0.26000000f,-0.16000000f,-0.98000000f,0.80000000f,0.58000000f,-0.65000000f,-0.17000000f,0.77000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.43000000f,-0.88000000f,0.08000000f,0.23000000f,-0.70000000f,-0.69000000f,-0.76000000f,-0.11000000f,0.44000000f,-0.87000000f,0.70000000f,-0.73000000f,-0.55000000f,0.05000000f,0.30000000f,-0.02000000f,0.19000000f,0.20000000f,0.14000000f,0.08000000f,0.16000000f,0.44000000f,0.58000000f,-0.51000000f,-0.63000000f,0.32000000f,0.98000000f,-0.48000000f,-0.66000000f,-0.00000000f,-0.83000000f,0.39000000f,-0.95000000f,-0.32000000f,-0.28000000f,0.60000000f,0.59000000f,-0.94000000f,0.34000000f,-0.68000000f,-0.62000000f,0.46000000f,-0.87000000f,0.25000000f,-0.00000000f,0.12000000f,0.38000000f,0.69000000f,-0.54000000f,0.11000000f,0.03000000f,-0.76000000f,0.92000000f,0.52000000f,-0.33000000f,-0.36000000f,-0.33000000f,0.46000000f,-0.60000000f,0.33000000f,-0.56000000f,-0.77000000f,0.13000000f,0.31000000f,-0.65000000f,-0.67000000f,-0.58000000f,0.54000000f,0.41000000f,0.80000000f,-0.92000000f,0.77000000f,-0.44000000f,0.69000000f,-0.60000000f,0.13000000f,-0.82000000f,0.13000000f,0.27000000f,-0.36000000f,-0.88000000f,-0.77000000f,-0.72000000f,-0.94000000f,0.69000000f,0.18000000f,-0.29000000f,-0.12000000f,-0.81000000f,-0.51000000f,0.72000000f,-0.03000000f,0.32000000f,-0.25000000f,-0.83000000f,0.11000000f,0.14000000f,-0.76000000f,-0.62000000f,0.51000000f,0.87000000f,0.76000000f,-0.23000000f,0.52000000f,0.89000000f,-0.02000000f,-0.57000000f,0.81000000f,-0.83000000f,-0.10000000f,-0.88000000f,0.71000000f,0.30000000f,-0.66000000f,-0.38000000f,-0.56000000f,0.37000000f,0.02000000f,0.08000000f,-0.88000000f,-0.86000000f,0.01000000f,-0.61000000f,-0.44000000f,0.60000000f,0.34000000f,-0.90000000f,-0.50000000f,-0.11000000f,0.52000000f,-0.76000000f,0.04000000f,-0.53000000f,-0.10000000f,0.03000000f,0.07000000f,0.32000000f,0.98000000f,0.28000000f,0.13000000f,0.05000000f,0.62000000f,-0.15000000f,-0.39000000f,0.04000000f,-0.81000000f,0.84000000f,-0.48000000f,0.56000000f,-0.74000000f,0.39000000f,0.79000000f,-0.40000000f,-0.67000000f,-0.52000000f,0.67000000f,-0.68000000f,-0.55000000f,-0.65000000f,0.36000000f,0.27000000f,-0.14000000f,-0.14000000f,-0.58000000f,0.34000000f,0.14000000f,-0.33000000f,-0.67000000f,0.92000000f,-0.73000000f,-0.29000000f,0.96000000f,-0.43000000f,-0.85000000f,0.96000000f,0.65000000f,0.21000000f,0.76000000f,-0.74000000f,0.42000000f,-0.78000000f,-0.06000000f,0.21000000f,-0.03000000f,-0.83000000f,-0.42000000f,0.44000000f,-0.79000000f,-0.55000000f,-0.22000000f,-0.54000000f,-0.24000000f,0.68000000f,0.03000000f,-0.90000000f,0.81000000f,0.68000000f,0.70000000f,-0.84000000f,-0.41000000f,-0.26000000f,-0.67000000f,0.21000000f,-0.49000000f,0.00000000f,-0.99000000f,0.73000000f,0.96000000f,-0.50000000f,0.82000000f,0.83000000f,-0.41000000f,0.83000000f,-0.48000000f,-0.20000000f,0.84000000f,-0.79000000f,-0.93000000f,0.89000000f,-0.24000000f,0.59000000f,-0.10000000f,0.95000000f,0.43000000f,0.44000000f,-0.81000000f,0.61000000f,-0.49000000f,-0.78000000f,-0.97000000f,0.83000000f,-0.33000000f,0.26000000f,0.46000000f,-0.74000000f,-0.64000000f,0.49000000f,0.38000000f,0.92000000f,0.70000000f,0.51000000f,-0.64000000f,0.57000000f,0.55000000f,0.82000000f,-0.91000000f,-0.75000000f,-0.50000000f,-0.39000000f,-0.79000000f,-0.96000000f,-0.72000000f,-0.96000000f,0.78000000f,-0.81000000f,0.07000000f,-0.08000000f,-0.34000000f,-0.90000000f,0.26000000f,0.88000000f,-0.69000000f,-0.64000000f,-0.41000000f,0.46000000f,0.93000000f,-0.60000000f,-0.81000000f,-0.11000000f,-0.50000000f,-0.30000000f,-0.27000000f,0.59000000f,-0.02000000f,-0.71000000f,-0.78000000f,0.72000000f,0.11000000f,-0.84000000f,-0.84000000f,0.52000000f,0.45000000f,-0.90000000f,-0.64000000f,-0.38000000f,0.32000000f,-0.20000000f,0.20000000f,0.33000000f,-0.61000000f,0.79000000f,0.33000000f,-0.75000000f,-0.21000000f,-0.04000000f,0.65000000f,-0.27000000f,0.59000000f,0.60000000f,-0.49000000f,-0.38000000f,0.72000000f,0.87000000f,-0.36000000f,-0.97000000f,0.13000000f,-0.62000000f,-0.86000000f,-0.91000000f,-0.52000000f,0.45000000f,-0.41000000f,-0.38000000f,-0.29000000f,-0.07000000f,-0.69000000f,-0.86000000f,0.46000000f,0.60000000f,0.37000000f,0.14000000f,-0.12000000f,-0.75000000f,0.64000000f,-0.74000000f,0.00000000f,-0.91000000f,-0.44000000f,-0.75000000f,0.94000000f,0.91000000f,-0.12000000f,0.76000000f,0.25000000f,-0.75000000f,-0.42000000f,-0.71000000f,0.41000000f,0.55000000f,-0.99000000f,0.12000000f,0.83000000f,0.98000000f,-0.45000000f,0.16000000f,-0.89000000f,-0.38000000f,-0.36000000f,-0.89000000f,0.36000000f,0.27000000f,0.88000000f,0.64000000f,0.31000000f,-0.51000000f,0.48000000f,-0.31000000f,-0.94000000f,0.83000000f,-0.51000000f,0.51000000f,-0.32000000f,0.45000000f,-0.34000000f,0.62000000f,-0.88000000f,0.37000000f,0.48000000f,-0.25000000f,-0.87000000f,-0.40000000f,-0.35000000f,-0.60000000f,-0.48000000f,-0.62000000f,-0.14000000f,0.16000000f,-0.60000000f,-0.95000000f,0.70000000f,0.57000000f,0.38000000f,-0.42000000f,-0.76000000f,-0.37000000f,-0.13000000f,0.67000000f,0.46000000f,-0.54000000f,0.62000000f,0.87000000f,0.93000000f,-0.72000000f,0.56000000f,0.83000000f,-0.24000000f,-0.34000000f,-0.52000000f,0.65000000f,-0.64000000f,0.10000000f,-0.02000000f,-0.63000000f,-0.59000000f,-0.90000000f,-0.98000000f,0.28000000f,0.52000000f,-0.41000000f,0.27000000f,-0.97000000f,0.53000000f,0.29000000f,-0.58000000f,-0.44000000f,0.87000000f,0.32000000f,-0.02000000f,-0.49000000f,0.33000000f,0.61000000f,0.93000000f,-0.95000000f,0.65000000f,0.37000000f,-0.42000000f,-0.82000000f,0.95000000f,-0.96000000f,0.72000000f,-0.14000000f,-0.07000000f,0.03000000f,0.20000000f,0.87000000f,0.52000000f,-0.40000000f,-0.72000000f,-0.95000000f,0.49000000f,-0.29000000f,0.17000000f,0.93000000f,0.04000000f,-0.55000000f,0.37000000f,0.92000000f,-0.99000000f,0.94000000f,0.24000000f,-0.90000000f,-0.60000000f,-0.87000000f,0.48000000f,0.19000000f,-0.27000000f,0.12000000f,-0.50000000f,-0.97000000f,0.85000000f,-0.02000000f,0.68000000f,0.03000000f,0.30000000f,-0.53000000f,0.66000000f,0.38000000f,0.72000000f,0.12000000f,-0.62000000f,-0.46000000f,-0.61000000f,-0.89000000f,0.24000000f,-0.80000000f,0.13000000f,-0.52000000f,0.45000000f,-0.02000000f,0.13000000f,0.03000000f,0.02000000f,0.22000000f,0.50000000f,0.70000000f,0.46000000f,0.40000000f,-0.00000000f,0.49000000f,-0.96000000f,0.75000000f,-0.31000000f,0.60000000f,0.06000000f,-0.57000000f,0.20000000f,-0.79000000f,-0.70000000f,0.08000000f,0.71000000f,0.89000000f,0.75000000f,-0.65000000f,0.50000000f,-0.89000000f,0.15000000f,0.05000000f,0.95000000f,0.77000000f,-0.03000000f,-0.52000000f,0.52000000f,0.60000000f,0.00000000f,-0.92000000f,0.34000000f,0.38000000f,-0.69000000f,0.26000000f,-0.74000000f,0.29000000f,0.39000000f,0.18000000f,-0.06000000f,0.19000000f,-0.67000000f,-0.79000000f,0.96000000f,-0.63000000f,-0.55000000f,-0.86000000f,-0.29000000f,0.68000000f,-0.57000000f,-0.10000000f,-0.87000000f,0.22000000f,0.70000000f,0.09000000f,0.17000000f,0.27000000f,-0.30000000f,-0.53000000f,0.50000000f,0.80000000f,0.07000000f,0.09000000f,-0.85000000f,0.07000000f,0.52000000f,-0.71000000f,-0.71000000f,0.13000000f,-0.57000000f,0.39000000f,-0.45000000f,0.45000000f,0.93000000f,-0.82000000f,0.09000000f,0.94000000f,-0.77000000f,-0.58000000f,-0.46000000f,-0.40000000f,0.47000000f,-0.85000000f,-0.92000000f,-0.01000000f,-0.35000000f,0.33000000f,-0.74000000f,0.79000000f,0.10000000f,-0.24000000f,0.07000000f,0.97000000f,-0.67000000f,-0.69000000f,-0.64000000f,-0.31000000f,-0.19000000f,0.39000000f,-0.73000000f,0.18000000f,0.10000000f,0.14000000f,-0.97000000f,-0.37000000f,-0.36000000f,-0.33000000f,0.64000000f,-0.16000000f,-0.60000000f,-0.78000000f,0.84000000f,-0.77000000f,-0.40000000f,0.68000000f,-0.49000000f,0.13000000f,0.39000000f,0.98000000f,-0.35000000f,0.05000000f,-0.97000000f,-0.12000000f,0.93000000f,0.88000000f,0.33000000f,0.02000000f,0.17000000f,0.80000000f,-0.71000000f,0.98000000f,0.92000000f,-0.97000000f,0.75000000f,0.48000000f,0.22000000f,0.74000000f,-0.51000000f,0.67000000f,-0.87000000f,0.44000000f,0.84000000f,0.28000000f,-0.04000000f,0.41000000f,0.33000000f,-0.68000000f,0.52000000f,0.55000000f,-0.81000000f,-0.63000000f,0.57000000f,-0.48000000f,-0.29000000f,-0.51000000f,0.76000000f,-0.78000000f,-0.39000000f,-0.15000000f,-0.24000000f,-0.01000000f,-0.37000000f,-0.87000000f,0.64000000f,0.07000000f,0.19000000f,-0.96000000f,0.77000000f,0.48000000f,0.95000000f,0.27000000f,-0.55000000f,-0.47000000f,0.00000000f,-0.99000000f,-0.89000000f,-0.31000000f,0.05000000f,-0.08000000f,-0.56000000f,0.30000000f,0.41000000f,-0.63000000f,0.44000000f,0.80000000f,0.11000000f,0.14000000f,-0.62000000f,-0.41000000f,-0.94000000f,-0.64000000f,0.44000000f,-0.49000000f,-0.89000000f,0.42000000f,-0.82000000f,-0.97000000f,-0.83000000f,-0.41000000f,0.68000000f,0.89000000f,0.40000000f,0.09000000f,0.28000000f,0.09000000f,0.01000000f,0.32000000f,0.33000000f,-0.31000000f,0.29000000f,-0.57000000f,0.26000000f,0.70000000f,0.28000000f,0.34000000f,0.12000000f,-0.39000000f,0.77000000f,0.83000000f,0.30000000f,0.52000000f,-0.97000000f,0.80000000f,-0.94000000f,-0.53000000f,-0.33000000f,-0.38000000f,-0.25000000f,-0.20000000f,-0.22000000f,0.37000000f,-0.64000000f,0.95000000f,-0.26000000f,-0.46000000f,-0.97000000f,-0.86000000f,-0.73000000f,-0.19000000f,0.62000000f,0.45000000f,0.33000000f,-0.14000000f,0.87000000f,-0.41000000f,0.01000000f,-0.67000000f,-0.14000000f,0.59000000f,-0.29000000f,0.20000000f,-0.33000000f,0.19000000f,0.50000000f,0.68000000f,0.60000000f,0.21000000f,0.91000000f,0.29000000f,-0.77000000f,0.48000000f,0.54000000f,-0.72000000f,0.26000000f,0.94000000f,-0.82000000f,0.26000000f,0.08000000f,-0.69000000f,0.20000000f,0.66000000f,0.65000000f,-0.77000000f,0.22000000f,-0.17000000f,-0.31000000f,0.56000000f,0.86000000f,0.53000000f,-0.06000000f,0.73000000f,-0.52000000f,0.27000000f,0.99000000f,-0.73000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.15000000f,-0.14000000f,-0.70000000f,0.86000000f,-0.83000000f,-0.02000000f,-0.18000000f,-0.53000000f,0.53000000f,-0.23000000f,0.94000000f,-0.23000000f,-0.32000000f,0.23000000f,-0.73000000f,-0.43000000f,0.06000000f,-0.75000000f,-0.88000000f,0.43000000f,0.50000000f,-0.74000000f,-0.17000000f,0.03000000f,0.74000000f,-0.18000000f,-0.97000000f,-0.09000000f,0.88000000f,0.63000000f,-0.88000000f,-0.42000000f,0.03000000f,-0.19000000f,0.54000000f,-0.26000000f,0.30000000f,-0.13000000f,0.74000000f,0.36000000f,0.05000000f,-0.31000000f,0.77000000f,-0.24000000f,-0.95000000f,-0.52000000f,0.95000000f,0.23000000f,0.87000000f,-0.09000000f,0.08000000f,0.24000000f,0.16000000f,0.31000000f,0.88000000f,0.48000000f,-0.12000000f,0.30000000f,-0.42000000f,-0.10000000f,0.44000000f,-0.91000000f,-0.43000000f,-0.95000000f,0.62000000f,0.36000000f,0.91000000f,-0.74000000f,0.74000000f,-0.08000000f,0.55000000f,0.12000000f,-0.14000000f,0.82000000f,0.22000000f,0.77000000f,-0.11000000f,0.81000000f,0.29000000f,-0.52000000f,-0.47000000f,0.75000000f,-0.08000000f,0.23000000f,0.45000000f,0.87000000f,0.48000000f,-0.41000000f,0.09000000f,0.46000000f,0.71000000f,0.73000000f,0.23000000f,-0.87000000f,-0.90000000f,-0.38000000f,-0.72000000f,0.23000000f,0.36000000f,0.64000000f,-0.87000000f,-0.82000000f,-0.97000000f,0.96000000f,0.97000000f,-0.63000000f,-0.92000000f,0.73000000f,0.29000000f,-0.54000000f,-0.20000000f,-0.96000000f,-0.15000000f,0.98000000f,-0.50000000f,-0.42000000f,0.29000000f,-0.21000000f,0.71000000f,-0.71000000f,0.58000000f,0.12000000f,-0.61000000f,-0.37000000f,-0.28000000f,-0.00000000f,0.66000000f,-0.80000000f,-0.29000000f,-0.83000000f,-0.15000000f,0.70000000f,0.27000000f,-0.37000000f,0.02000000f,-0.28000000f,0.85000000f,0.14000000f,0.26000000f,0.06000000f,-0.72000000f,0.07000000f,0.33000000f,0.18000000f,-0.56000000f,0.66000000f,0.51000000f,-0.21000000f,0.41000000f,-0.69000000f,-0.38000000f,0.42000000f,-0.04000000f,0.71000000f,0.66000000f,-0.26000000f,0.28000000f,0.74000000f,0.61000000f,0.22000000f,0.47000000f,-0.44000000f,0.49000000f,-0.26000000f,0.61000000f,-0.24000000f,0.07000000f,-0.63000000f,-0.24000000f,-0.44000000f,-0.41000000f,0.74000000f,-0.27000000f,0.60000000f,0.47000000f,-0.69000000f,0.13000000f,-0.10000000f,0.36000000f,-0.54000000f,-0.05000000f,-0.26000000f,0.50000000f,-0.62000000f,0.19000000f,-0.05000000f,0.56000000f,-0.12000000f,0.33000000f,0.60000000f,-0.50000000f,-0.40000000f,0.12000000f,-0.06000000f,0.95000000f,0.06000000f,0.60000000f,0.00000000f,0.32000000f,-0.73000000f,-0.05000000f,0.42000000f,0.24000000f,-0.51000000f,0.37000000f,-0.86000000f,0.49000000f,-0.35000000f,0.07000000f,0.21000000f,-0.03000000f,0.13000000f,-0.03000000f,-0.19000000f,0.48000000f,-0.29000000f,-0.56000000f,-0.35000000f,0.57000000f,-0.98000000f,-0.21000000f,0.50000000f,0.95000000f,0.51000000f,-0.40000000f,0.77000000f,0.26000000f,0.77000000f,0.71000000f,-0.28000000f,0.98000000f,-0.78000000f,0.55000000f,-0.96000000f,-0.30000000f,-0.06000000f,0.72000000f,0.79000000f,0.32000000f,0.46000000f,-0.42000000f,0.38000000f,-0.22000000f,0.82000000f,0.65000000f,0.63000000f,-0.92000000f,-0.99000000f,0.07000000f,-0.28000000f,-0.48000000f,-0.22000000f,0.29000000f,0.61000000f,0.04000000f,0.76000000f,0.77000000f,-0.89000000f,-0.84000000f,-0.18000000f,0.27000000f,-0.14000000f,0.13000000f,0.75000000f,-0.53000000f,0.88000000f,-0.46000000f,0.22000000f,-0.57000000f,-0.19000000f,-0.11000000f,-0.96000000f,0.16000000f,0.69000000f,0.37000000f,0.06000000f,0.59000000f,0.21000000f,-0.74000000f,0.53000000f,0.74000000f,0.68000000f,-0.60000000f,0.81000000f,-0.74000000f,-0.82000000f,-0.84000000f,-0.64000000f,-0.09000000f,0.31000000f,0.54000000f,0.34000000f,0.86000000f,0.30000000f,-0.72000000f,0.25000000f,0.51000000f,0.62000000f,0.47000000f,-0.67000000f,0.33000000f,-0.68000000f,0.63000000f,0.84000000f,0.91000000f,-0.85000000f,-0.24000000f,-0.48000000f,-0.40000000f,0.29000000f,0.24000000f,-0.76000000f,0.27000000f,0.60000000f,-0.51000000f,-0.27000000f,-0.99000000f,0.58000000f,0.87000000f,0.58000000f,-0.42000000f,0.18000000f,0.97000000f,-0.42000000f,-0.96000000f,-0.30000000f,-0.98000000f,-0.05000000f,0.98000000f,0.35000000f,-0.82000000f,-0.55000000f,0.87000000f,0.13000000f,0.13000000f,-0.14000000f,-0.61000000f,-0.75000000f,-0.58000000f,0.24000000f,-0.33000000f,-0.79000000f,0.95000000f,0.19000000f,0.01000000f,0.54000000f,-0.40000000f,-0.60000000f,0.08000000f,-0.59000000f,0.71000000f,-0.98000000f,-0.94000000f,0.73000000f,0.46000000f,-0.54000000f,0.23000000f,0.49000000f,-0.26000000f,0.26000000f,0.63000000f,-0.32000000f,-0.34000000f,-0.14000000f,0.01000000f,0.68000000f,-0.03000000f,0.53000000f,0.40000000f,-0.90000000f,0.70000000f,-0.13000000f,0.31000000f,0.12000000f,-0.57000000f,0.52000000f,-0.55000000f,0.98000000f,-0.71000000f,-0.75000000f,-0.71000000f,-0.23000000f,0.54000000f,0.19000000f,0.78000000f,-0.41000000f,-0.81000000f,-0.34000000f,-0.03000000f,-0.78000000f,-0.71000000f,-0.98000000f,0.69000000f,0.08000000f,0.16000000f,0.64000000f,-0.23000000f,-0.71000000f,0.35000000f,-0.53000000f,-0.45000000f,-0.01000000f,-0.99000000f,0.38000000f,-0.20000000f,-0.62000000f,0.56000000f,0.82000000f,0.98000000f,0.26000000f,0.00000000f,0.36000000f,0.29000000f,-0.78000000f,-0.88000000f,0.46000000f,0.00000000f,0.13000000f,-0.22000000f,0.73000000f,-0.42000000f,0.67000000f,-0.75000000f,0.76000000f,0.72000000f,0.95000000f,0.46000000f,-0.81000000f,-0.98000000f,-0.38000000f,-0.05000000f,-0.02000000f,0.77000000f,-0.53000000f,-0.53000000f,-0.68000000f,-0.98000000f,0.07000000f,-0.08000000f,0.40000000f,-0.59000000f,-0.03000000f,-0.13000000f,0.70000000f,0.07000000f,-0.82000000f,0.06000000f,-0.09000000f,0.66000000f,0.15000000f,0.73000000f,0.39000000f,-0.84000000f,-0.33000000f,-0.48000000f,-0.81000000f,-0.01000000f,-0.43000000f,0.42000000f,0.55000000f,0.31000000f,-0.78000000f,-0.15000000f,-0.04000000f,0.81000000f,0.26000000f,-0.38000000f,0.00000000f,0.54000000f,0.21000000f,-0.60000000f,-0.75000000f,0.92000000f,-0.60000000f,-0.51000000f,0.95000000f,-0.37000000f,-0.81000000f,0.44000000f,0.68000000f,0.71000000f,-0.37000000f,0.61000000f,0.29000000f,-0.27000000f,-0.96000000f,-0.14000000f,-0.06000000f,-0.74000000f,-0.09000000f,0.51000000f,-0.89000000f,0.47000000f,-0.75000000f,0.40000000f,0.50000000f,0.45000000f,-0.68000000f,0.77000000f,0.31000000f,-0.50000000f,-0.45000000f,0.52000000f,0.97000000f,0.05000000f,-0.91000000f,0.61000000f,-0.36000000f,-0.26000000f,-0.36000000f,0.47000000f,-0.34000000f,0.97000000f,-0.45000000f,0.19000000f,-0.08000000f,0.39000000f,0.35000000f,-0.28000000f,0.81000000f,-0.73000000f,0.37000000f,-0.39000000f,0.15000000f,-0.79000000f,-0.73000000f,0.37000000f,-0.65000000f,0.72000000f,-0.47000000f,0.57000000f,-0.57000000f,-0.82000000f,-0.87000000f,-0.62000000f,-0.92000000f,0.92000000f,0.85000000f,-0.32000000f,0.04000000f,-0.79000000f,0.96000000f,0.77000000f,0.13000000f,-0.19000000f,0.44000000f,-0.10000000f,-0.65000000f,-0.49000000f,0.33000000f,0.72000000f,0.96000000f,0.13000000f,-0.66000000f,-0.78000000f,0.76000000f,-0.44000000f,-0.69000000f,0.87000000f,0.67000000f,-0.34000000f,0.87000000f,0.92000000f,0.02000000f,-0.28000000f,-0.21000000f,-0.56000000f,0.36000000f,0.96000000f,0.53000000f,-0.19000000f,-0.15000000f,-0.73000000f,0.39000000f,0.53000000f,-0.78000000f,0.26000000f,-0.56000000f,0.17000000f,0.69000000f,0.20000000f,-0.08000000f,0.45000000f,0.19000000f,0.51000000f,-0.96000000f,-0.42000000f,0.59000000f,0.16000000f,0.48000000f,-0.75000000f,-0.71000000f,0.11000000f,-0.24000000f,-0.31000000f,-0.67000000f,-0.96000000f,-0.05000000f,-0.53000000f,0.62000000f,0.81000000f,0.37000000f,0.07000000f,0.80000000f,0.40000000f,-0.38000000f,-0.84000000f,-0.57000000f,0.96000000f,-0.23000000f,0.62000000f,-0.88000000f,0.49000000f,0.49000000f,0.37000000f,0.82000000f,-0.83000000f,-0.00000000f,0.93000000f,-0.25000000f,0.13000000f,-0.69000000f,0.87000000f,0.94000000f,0.71000000f,0.58000000f,0.51000000f,0.97000000f,-0.44000000f,-0.76000000f,0.48000000f,0.01000000f,0.11000000f,-0.57000000f,0.53000000f,-0.85000000f,-0.45000000f,0.31000000f,-0.02000000f,-0.27000000f,0.39000000f,0.86000000f,-0.42000000f,-0.67000000f,-0.34000000f,0.39000000f,0.42000000f,-0.08000000f,0.25000000f,0.01000000f,-0.45000000f,-0.11000000f,0.65000000f,-0.89000000f,-0.44000000f,0.54000000f,0.66000000f,0.53000000f,-0.96000000f,-0.09000000f,0.57000000f,0.20000000f,-0.16000000f,0.90000000f,-0.02000000f,0.92000000f,0.67000000f,-0.06000000f,0.51000000f,-0.54000000f,-0.79000000f,0.08000000f,0.89000000f,-0.96000000f,0.77000000f,-0.83000000f,-0.72000000f,0.95000000f,0.06000000f,0.38000000f,0.80000000f,0.20000000f,0.17000000f,-0.30000000f,0.76000000f,-0.39000000f,-0.81000000f,-0.59000000f,-0.66000000f,0.35000000f,0.01000000f,-0.53000000f,0.07000000f,0.94000000f,0.88000000f,0.97000000f,-0.18000000f,0.14000000f,0.41000000f,-0.83000000f,-0.00000000f,0.59000000f,-0.05000000f,0.03000000f,0.84000000f,-0.17000000f,-0.32000000f,-0.79000000f,-0.86000000f,-0.55000000f,-0.09000000f,0.57000000f,0.01000000f,0.80000000f,-0.11000000f,0.68000000f,0.92000000f,-0.57000000f,0.60000000f,-0.07000000f,-0.10000000f,0.66000000f,0.47000000f,0.62000000f,0.11000000f,-0.50000000f,0.01000000f,-0.03000000f,0.84000000f,-0.15000000f,-0.45000000f,-0.07000000f,0.19000000f,0.94000000f,-0.10000000f,-0.46000000f,-0.47000000f,-0.78000000f,0.05000000f,0.70000000f,-0.96000000f,0.88000000f,-0.84000000f,0.72000000f,-0.40000000f,0.46000000f,0.44000000f,0.31000000f,0.10000000f,0.36000000f,0.42000000f,0.42000000f,-0.29000000f,-0.87000000f,0.16000000f,-0.24000000f,0.62000000f,0.05000000f,0.13000000f,-0.11000000f,0.80000000f,-0.23000000f,0.18000000f,0.43000000f,-0.91000000f,0.75000000f,0.38000000f,0.84000000f,0.61000000f,-0.83000000f,-0.34000000f,-0.01000000f,0.05000000f,-0.39000000f,0.05000000f,-0.64000000f,0.62000000f,-0.29000000f,0.56000000f,-0.06000000f,0.23000000f,-0.39000000f,0.18000000f,0.44000000f,0.04000000f,0.36000000f,0.89000000f,0.93000000f,0.24000000f,0.42000000f,0.25000000f,-0.45000000f,-0.63000000f,-0.22000000f,0.09000000f,-0.27000000f,0.27000000f,0.28000000f,-0.12000000f,-0.97000000f,-0.20000000f,0.55000000f,-0.43000000f,-0.35000000f,-0.64000000f,0.63000000f,0.42000000f,-0.93000000f,-0.76000000f,-0.98000000f,0.90000000f,0.80000000f,-0.64000000f,-0.92000000f,0.34000000f,-0.81000000f,0.79000000f,-0.77000000f,0.56000000f,0.60000000f,-0.05000000f,-0.63000000f,-0.32000000f,0.51000000f,-0.52000000f,-0.20000000f,0.38000000f,0.80000000f,-0.63000000f,-0.52000000f,-0.13000000f,-0.06000000f,0.01000000f,-0.66000000f,0.14000000f,-0.45000000f,0.78000000f,0.07000000f,0.00000000f,0.17000000f,-0.46000000f,0.47000000f,-0.10000000f,0.31000000f,-0.16000000f,-0.62000000f,-0.32000000f,-0.85000000f,0.24000000f,-0.01000000f,-0.63000000f,0.80000000f,0.92000000f,0.54000000f,-0.85000000f,-0.74000000f,-0.93000000f,-0.98000000f,0.54000000f,-0.23000000f,-0.36000000f,0.20000000f,0.75000000f,0.22000000f,0.71000000f,-0.07000000f,-0.13000000f,0.40000000f,-0.82000000f,0.46000000f,-0.39000000f,0.34000000f,-0.35000000f,0.12000000f,-0.42000000f,0.63000000f,0.68000000f,0.04000000f,0.97000000f,-0.04000000f,-0.38000000f,0.87000000f,0.12000000f,0.02000000f,-0.71000000f,-0.81000000f,-0.43000000f,0.56000000f,0.80000000f,0.88000000f,0.51000000f,-0.78000000f,-0.52000000f,0.35000000f,-0.52000000f,0.21000000f,-0.51000000f,0.19000000f,-0.05000000f,0.64000000f,0.72000000f,-0.69000000f,0.45000000f,-0.94000000f,0.41000000f,-0.80000000f,-0.17000000f,0.67000000f,-0.41000000f,0.08000000f,0.15000000f,-0.55000000f,0.13000000f,-0.25000000f,-0.85000000f,0.77000000f,0.47000000f,-0.44000000f,0.39000000f,-0.71000000f,-0.62000000f,0.65000000f,0.35000000f,0.20000000f,0.25000000f,0.62000000f,-0.53000000f,-0.97000000f,-0.36000000f,-0.12000000f,-0.93000000f,-0.46000000f,0.39000000f,0.07000000f,0.06000000f,-0.88000000f,0.07000000f,0.01000000f,-0.95000000f,-0.02000000f,0.52000000f,0.41000000f,-0.88000000f,0.55000000f,0.99000000f,0.11000000f,0.76000000f,-0.90000000f,0.97000000f,-0.25000000f,-0.92000000f,0.65000000f,0.94000000f,0.71000000f,-0.82000000f,-0.46000000f,0.44000000f,0.21000000f,0.84000000f,-0.49000000f,0.55000000f,-0.20000000f,0.45000000f,0.48000000f,-0.58000000f,0.96000000f,0.52000000f,0.01000000f,0.31000000f,-0.67000000f,0.52000000f,-0.66000000f,-0.77000000f,0.18000000f,0.36000000f,-0.32000000f,0.51000000f,0.23000000f,0.58000000f,-0.45000000f,-0.52000000f,0.22000000f,-0.46000000f,0.79000000f,0.49000000f,0.40000000f,0.81000000f,-0.44000000f,0.79000000f,-0.50000000f,0.90000000f,0.13000000f,0.34000000f,0.93000000f,0.31000000f,0.56000000f,-0.83000000f,0.90000000f,-0.18000000f,0.55000000f,-0.05000000f,-0.82000000f,0.16000000f,0.67000000f,0.08000000f,-0.82000000f,-0.04000000f,-0.05000000f,0.69000000f,0.75000000f,0.74000000f,-0.37000000f,0.09000000f,0.82000000f,-0.32000000f,0.16000000f,0.67000000f,0.50000000f,0.37000000f,0.63000000f,-0.65000000f,0.28000000f,0.34000000f,0.09000000f,0.41000000f,-0.64000000f,0.57000000f,0.80000000f,-0.11000000f,-0.43000000f,-0.16000000f,-0.29000000f,-0.79000000f,-0.52000000f,-0.54000000f,-0.22000000f,-0.94000000f,-0.77000000f,0.36000000f,0.75000000f,-0.42000000f,0.71000000f,-0.53000000f,-0.23000000f,-0.26000000f,-0.23000000f,-0.19000000f,-0.13000000f,0.85000000f,-0.15000000f,0.70000000f,-0.27000000f,-0.43000000f,0.63000000f,0.13000000f,0.95000000f,-0.63000000f,-0.28000000f,-0.42000000f,-0.91000000f,-0.42000000f,0.79000000f,-0.05000000f,-0.43000000f,0.24000000f,0.39000000f,0.22000000f,0.63000000f,-0.40000000f,0.12000000f,0.10000000f,-0.23000000f,-0.86000000f,-0.12000000f,-0.42000000f,0.31000000f,-0.87000000f,-0.38000000f,0.04000000f,0.54000000f,0.37000000f,-0.51000000f,0.09000000f,0.58000000f,0.27000000f,0.27000000f,0.17000000f,-0.16000000f,0.36000000f,0.35000000f,0.88000000f,-0.79000000f,0.34000000f,0.34000000f,-0.51000000f,-0.15000000f,-0.84000000f,0.07000000f,0.46000000f,0.46000000f,0.44000000f,-0.70000000f,-0.41000000f,0.98000000f,0.44000000f,0.66000000f,0.31000000f,0.84000000f,0.95000000f,-0.25000000f,-0.52000000f,-0.07000000f,-0.78000000f,-0.72000000f,-0.55000000f,-0.84000000f,-0.38000000f,-0.77000000f,0.90000000f,-0.08000000f,-0.62000000f,0.74000000f,-0.78000000f,-0.46000000f,-0.71000000f,0.80000000f,0.21000000f,0.66000000f,0.19000000f,0.80000000f,0.05000000f,0.83000000f,0.28000000f,0.46000000f,0.75000000f,0.33000000f,0.31000000f,-0.62000000f,-0.20000000f,0.13000000f,-0.79000000f,-0.17000000f,0.32000000f,-0.26000000f,-0.48000000f,0.40000000f,0.93000000f,-0.08000000f,0.49000000f,0.71000000f,0.34000000f,-0.05000000f,0.62000000f,0.30000000f,0.22000000f,0.12000000f,0.60000000f,-0.02000000f,-0.56000000f,0.39000000f,-0.15000000f,0.78000000f,0.80000000f,-0.11000000f,-0.61000000f,-0.66000000f,-0.25000000f,-0.80000000f,-0.44000000f,-0.39000000f,-0.99000000f,0.05000000f,0.57000000f,-0.36000000f,0.82000000f,-0.74000000f,0.37000000f,-0.50000000f,0.68000000f,-0.37000000f,0.56000000f,0.80000000f,-0.50000000f,0.45000000f,-0.50000000f,0.58000000f,-0.01000000f,0.79000000f,-0.48000000f,0.05000000f,0.97000000f,0.32000000f,0.82000000f,0.46000000f,0.49000000f,-0.12000000f,-0.71000000f,-0.04000000f,-0.65000000f,0.60000000f,-0.81000000f,0.78000000f,-0.85000000f,0.90000000f,-0.95000000f,-0.46000000f,0.62000000f,0.36000000f,-0.43000000f,0.10000000f,0.57000000f,0.52000000f,-0.60000000f,-0.05000000f,-0.11000000f,0.12000000f,0.32000000f,0.52000000f,0.91000000f,0.53000000f,0.24000000f,0.04000000f,-0.44000000f,-0.41000000f,0.89000000f,-0.17000000f,-0.45000000f,-0.83000000f,0.28000000f,-0.70000000f,0.46000000f,0.58000000f,0.81000000f,-0.23000000f,-0.97000000f,-0.61000000f,-0.82000000f,0.83000000f,0.45000000f,0.74000000f,-0.55000000f,-0.51000000f,-0.74000000f,0.56000000f,0.00000000f,0.23000000f,0.76000000f,-0.30000000f,0.07000000f,0.91000000f,0.26000000f,0.82000000f,0.32000000f,-0.40000000f,0.82000000f,0.64000000f,-0.83000000f,-0.99000000f,-0.19000000f,0.34000000f,0.09000000f,0.31000000f,-0.47000000f,0.38000000f,0.33000000f,0.68000000f,0.71000000f,-0.20000000f,-0.86000000f,-0.10000000f,-0.53000000f,-0.04000000f,-0.99000000f,0.35000000f,0.49000000f,0.52000000f,0.81000000f,-0.51000000f,0.76000000f,-0.50000000f,-0.31000000f,-0.93000000f,-0.89000000f,-0.88000000f,0.97000000f,0.22000000f,-0.41000000f,0.25000000f,-0.28000000f,-0.29000000f,-0.60000000f,-0.23000000f,-0.75000000f,-0.39000000f,0.81000000f,0.17000000f,0.18000000f,-0.92000000f,-0.94000000f,0.82000000f,-0.83000000f,-0.71000000f,0.77000000f,-0.65000000f,0.15000000f,0.17000000f,0.09000000f,0.23000000f,0.21000000f,0.05000000f,0.14000000f,-0.56000000f,-0.31000000f,0.32000000f,0.45000000f,-0.41000000f,0.40000000f,-0.01000000f,-0.59000000f,-0.07000000f,0.96000000f,0.15000000f,0.98000000f,-0.32000000f,-0.66000000f,0.58000000f,-0.07000000f,0.01000000f,-0.67000000f,-0.17000000f,-0.37000000f,0.76000000f,-0.57000000f,0.18000000f,-0.97000000f,-0.14000000f,0.78000000f,0.13000000f,0.78000000f,-0.58000000f,0.33000000f,0.45000000f,-0.31000000f,0.29000000f,0.50000000f,-0.20000000f,-0.78000000f,-0.82000000f,-0.55000000f,0.46000000f,0.55000000f,-0.73000000f,-0.63000000f,0.01000000f,0.12000000f,0.62000000f,0.58000000f,0.95000000f,0.08000000f,-0.94000000f,-0.90000000f,-0.70000000f,-0.22000000f,0.57000000f,0.69000000f,0.80000000f,0.52000000f,-0.38000000f,-0.38000000f,0.59000000f,0.17000000f,0.53000000f,0.46000000f,-0.55000000f,0.81000000f,0.59000000f,0.54000000f,0.57000000f,-0.38000000f,0.07000000f,-0.23000000f,0.16000000f,0.18000000f,0.57000000f,-0.94000000f,0.95000000f,-0.83000000f,0.75000000f,-0.75000000f,-0.97000000f,-0.57000000f,-0.61000000f,-0.15000000f,-0.12000000f,-0.67000000f,0.72000000f,-0.90000000f,-0.26000000f,0.39000000f,0.65000000f,-0.34000000f,-0.43000000f,0.13000000f,-0.23000000f,-0.22000000f,-0.80000000f,0.60000000f,-0.54000000f,0.31000000f,-0.98000000f,-0.12000000f,0.48000000f,0.94000000f,-0.96000000f,0.42000000f,-0.33000000f,-0.89000000f,-0.03000000f,0.94000000f,0.04000000f,0.36000000f,-0.75000000f,0.28000000f,0.28000000f,-0.77000000f,0.32000000f,-0.33000000f,-0.09000000f,-0.30000000f,0.96000000f,-0.30000000f,-0.17000000f,0.54000000f,0.48000000f,0.61000000f,-0.50000000f,-0.01000000f,0.49000000f,-0.88000000f,-0.28000000f,0.50000000f,0.66000000f,0.03000000f,-0.19000000f,-0.01000000f,-0.44000000f,-0.73000000f,-0.11000000f,0.07000000f,0.71000000f,0.05000000f,-0.38000000f,-0.50000000f,-0.47000000f,-0.92000000f,0.75000000f,0.48000000f,-0.46000000f,-0.08000000f,-0.15000000f,0.59000000f,0.32000000f,0.87000000f,0.87000000f,0.80000000f,-0.79000000f,0.20000000f,-0.08000000f,-0.64000000f,0.45000000f,-0.26000000f,0.42000000f,-0.95000000f,0.03000000f,0.91000000f,-0.11000000f,0.14000000f,0.63000000f,0.55000000f,0.59000000f,0.04000000f,0.79000000f,0.30000000f,-0.13000000f,0.20000000f,0.48000000f,-0.07000000f,-0.69000000f,0.29000000f,-0.02000000f,0.45000000f,-0.61000000f,-0.52000000f,0.46000000f,-0.28000000f,0.81000000f,-0.93000000f,-0.73000000f,0.43000000f,-0.96000000f,0.45000000f,0.09000000f,0.51000000f,0.56000000f,-0.39000000f,0.20000000f,-0.18000000f,0.16000000f,-0.28000000f,0.02000000f,0.05000000f,-0.45000000f,0.31000000f,-0.61000000f,0.82000000f,-0.92000000f,-0.94000000f,-0.20000000f,0.10000000f,0.44000000f,-0.02000000f,-0.84000000f,0.16000000f,0.08000000f,-0.66000000f,0.06000000f,0.72000000f,0.09000000f,-0.91000000f,0.70000000f,-0.96000000f,0.53000000f,-0.30000000f,0.89000000f,0.76000000f,0.11000000f,0.61000000f,0.89000000f,-0.02000000f,-0.65000000f,-0.98000000f,-0.93000000f,-0.66000000f,-0.11000000f,-0.97000000f,0.52000000f,-0.75000000f,-0.15000000f,0.30000000f,0.39000000f,0.32000000f,0.49000000f,-0.72000000f,0.44000000f,0.62000000f,0.64000000f,-0.76000000f,0.63000000f,-0.18000000f,0.29000000f,-0.74000000f,-0.10000000f,-0.35000000f,-0.11000000f,-0.42000000f,0.29000000f,-0.07000000f,0.06000000f,-0.26000000f,-0.91000000f,0.85000000f,-0.31000000f,-0.73000000f,0.84000000f,0.89000000f,0.46000000f,0.96000000f,0.92000000f,-0.76000000f,0.87000000f,-0.83000000f,-0.57000000f,0.42000000f,-0.79000000f,-0.55000000f,-0.32000000f,-0.14000000f,0.36000000f,-0.37000000f,0.14000000f,0.17000000f,0.60000000f,0.48000000f,-0.66000000f,0.24000000f,-0.27000000f,0.30000000f,-0.76000000f,-0.73000000f,-0.14000000f,-0.86000000f,-0.43000000f,0.93000000f,0.61000000f,-0.03000000f,0.70000000f,0.74000000f,-0.91000000f,0.45000000f,-0.78000000f,-0.07000000f,-0.60000000f,-0.57000000f,0.40000000f,0.51000000f,0.53000000f,-0.02000000f,0.27000000f,0.04000000f,0.94000000f,0.49000000f,-0.16000000f,-0.94000000f,-0.16000000f,0.41000000f,-0.45000000f,0.31000000f,0.56000000f,0.25000000f,-0.56000000f,0.87000000f,0.15000000f,-0.83000000f,-0.66000000f,-0.69000000f,-0.16000000f,0.32000000f,-0.61000000f,0.76000000f,-0.59000000f,-0.69000000f,-0.70000000f,0.42000000f,0.65000000f,0.90000000f,-0.45000000f,0.59000000f,-0.25000000f,-0.94000000f,0.74000000f,-0.87000000f,-0.24000000f,0.69000000f,-0.85000000f,0.33000000f,-0.89000000f,0.35000000f,-0.29000000f,-0.67000000f,-0.28000000f,-0.85000000f,-0.91000000f,-0.68000000f,0.38000000f,0.48000000f,-0.21000000f,-0.00000000f,-0.39000000f,0.93000000f,0.00000000f,-0.43000000f,-0.25000000f,0.67000000f,0.82000000f,0.00000000f,0.27000000f,-0.76000000f,0.44000000f,-0.83000000f,-0.61000000f,-0.80000000f,0.98000000f,-0.07000000f,-0.86000000f,0.03000000f,0.69000000f,-0.88000000f,-0.87000000f,-0.65000000f,0.88000000f,0.61000000f,0.32000000f,-0.82000000f,0.76000000f,-0.57000000f,-0.59000000f,0.02000000f,-0.80000000f,0.34000000f,-0.98000000f,-0.25000000f,-0.34000000f,0.83000000f,0.40000000f,-0.73000000f,-0.63000000f,-0.73000000f,-0.59000000f,-0.15000000f,-0.19000000f,0.07000000f,-0.21000000f,-0.87000000f,-0.52000000f,0.03000000f,0.69000000f,-0.73000000f,0.99000000f,0.25000000f,-0.28000000f,0.50000000f,-0.17000000f,0.81000000f,0.70000000f,-0.62000000f,0.19000000f,-0.64000000f,-0.14000000f,0.87000000f,0.37000000f,-0.98000000f,-0.33000000f,-0.41000000f,-0.21000000f,0.51000000f,0.84000000f,-0.93000000f,-0.44000000f,0.40000000f,0.86000000f,-0.39000000f,-0.46000000f,0.01000000f,-0.06000000f,0.74000000f,0.43000000f,-0.97000000f,0.69000000f,-0.14000000f,0.06000000f,0.46000000f,0.72000000f,0.48000000f,-0.33000000f,0.91000000f,0.85000000f,0.07000000f,0.51000000f,0.34000000f,-0.16000000f,0.46000000f,0.88000000f,-0.24000000f,0.17000000f,0.55000000f,-0.61000000f,0.16000000f,-0.32000000f,0.02000000f,0.53000000f,0.91000000f,0.04000000f,0.26000000f,0.33000000f,-0.64000000f,-0.50000000f,0.32000000f,0.55000000f,-0.47000000f,0.37000000f,0.69000000f,0.09000000f,-0.29000000f,0.75000000f,-0.19000000f,0.93000000f,0.92000000f,0.65000000f,0.85000000f,-0.45000000f,0.17000000f,-0.36000000f,-0.08000000f,-0.01000000f,0.08000000f,0.69000000f,-0.98000000f,-0.46000000f,-0.32000000f,-0.66000000f,0.98000000f,0.08000000f,-0.71000000f,-0.98000000f,-0.51000000f,-0.95000000f,0.23000000f,0.26000000f,-0.35000000f,-0.72000000f,0.69000000f,-0.64000000f,-0.13000000f,-0.23000000f,0.95000000f,-0.74000000f,-0.25000000f,0.34000000f,0.36000000f,0.25000000f,-0.51000000f,0.00000000f,-0.60000000f,-0.92000000f,0.81000000f,-0.84000000f,0.85000000f,-0.55000000f,0.26000000f,0.20000000f,0.18000000f,-0.78000000f,-0.27000000f,0.99000000f,-0.36000000f,-0.97000000f,0.76000000f,0.10000000f,-0.80000000f,0.16000000f,-0.90000000f,0.48000000f,-0.38000000f,-0.15000000f,0.97000000f,0.75000000f,0.17000000f,0.60000000f,0.15000000f,-0.76000000f,-0.58000000f,0.72000000f,0.24000000f,0.16000000f,-0.37000000f,0.07000000f,0.45000000f,-0.29000000f,0.17000000f,-0.30000000f,-0.37000000f,-0.15000000f,0.43000000f,-0.90000000f,-0.33000000f,0.90000000f,-0.29000000f,0.53000000f,0.96000000f,0.83000000f,0.11000000f,0.28000000f,-0.70000000f,0.87000000f,-0.26000000f,0.90000000f,0.17000000f,0.89000000f,-0.25000000f,-0.92000000f,0.62000000f,0.10000000f,0.14000000f,-0.91000000f,-0.59000000f,-0.54000000f,-0.34000000f,0.10000000f,0.25000000f,0.69000000f,-0.60000000f,0.57000000f,0.82000000f,-0.12000000f,-0.97000000f,-0.72000000f,0.34000000f,-0.43000000f,-0.02000000f,-0.16000000f,-0.49000000f,-0.10000000f,-0.22000000f,-0.95000000f,-0.29000000f,0.15000000f,0.15000000f,0.55000000f,-0.55000000f,0.89000000f,-0.28000000f,-0.15000000f,-0.22000000f,-0.63000000f,0.28000000f,0.64000000f,-0.82000000f,-0.09000000f,-0.14000000f,0.96000000f,-0.07000000f,-0.58000000f,-0.29000000f,0.77000000f,0.18000000f,0.47000000f,-0.33000000f,-0.14000000f,-0.80000000f,-0.80000000f,-0.52000000f,0.52000000f,-0.37000000f,-0.09000000f,0.13000000f,0.85000000f,0.01000000f,0.25000000f,0.47000000f,-0.67000000f,0.29000000f,-0.52000000f,0.92000000f,0.87000000f,-0.25000000f,-0.87000000f,0.67000000f,0.44000000f,-0.85000000f,0.81000000f,-0.29000000f,-0.51000000f,-0.11000000f,-0.86000000f,-0.92000000f,0.90000000f,0.87000000f,0.57000000f,0.45000000f,0.74000000f,0.02000000f,0.81000000f,-0.50000000f,-0.32000000f,0.24000000f,-0.70000000f,-0.71000000f,-0.30000000f,0.71000000f,0.56000000f,0.60000000f,-0.64000000f,0.56000000f,-0.88000000f,0.75000000f,-0.04000000f,0.90000000f,0.40000000f,-0.39000000f,-0.16000000f,0.99000000f,-0.55000000f,0.55000000f,0.77000000f,-0.76000000f,0.25000000f,-0.18000000f,-0.78000000f,0.71000000f,0.05000000f,-0.03000000f,0.80000000f,-0.55000000f,-0.13000000f,0.63000000f,-0.33000000f,0.18000000f,-0.66000000f,0.27000000f,-0.83000000f,-0.21000000f,-0.79000000f,-0.46000000f,-0.15000000f,-0.61000000f,-0.28000000f,-0.84000000f,0.58000000f,-0.43000000f,0.85000000f,-0.22000000f,0.54000000f,0.73000000f,-0.87000000f,-0.48000000f,0.53000000f,-0.97000000f,-0.93000000f,0.85000000f,-0.96000000f,0.37000000f,0.78000000f,0.61000000f,0.55000000f,0.43000000f,-0.75000000f,0.09000000f,-0.06000000f,-0.23000000f,0.68000000f,-0.42000000f,-0.88000000f,-0.81000000f,-0.36000000f,0.33000000f,-0.50000000f,0.63000000f,-0.74000000f,-0.61000000f,-0.29000000f,0.14000000f,0.78000000f,-0.19000000f,-0.13000000f,-0.73000000f,0.97000000f,0.87000000f,-0.15000000f,-0.62000000f,-0.16000000f,0.83000000f,-0.78000000f,0.87000000f,0.48000000f,0.32000000f,0.77000000f,0.59000000f,-0.02000000f,0.06000000f,0.72000000f,0.84000000f,0.18000000f,-0.24000000f,-0.53000000f,0.26000000f,0.56000000f,0.50000000f,0.62000000f,-0.29000000f,-0.08000000f,-0.39000000f,-0.29000000f,-0.36000000f,-0.98000000f,0.53000000f,0.53000000f,-0.21000000f,-0.08000000f,0.47000000f,-0.77000000f,-0.73000000f,-0.48000000f,0.84000000f,0.12000000f,0.09000000f,-0.22000000f,0.77000000f,-0.10000000f,-0.69000000f,0.10000000f,0.13000000f,-0.42000000f,0.96000000f,-0.67000000f,-0.78000000f,0.10000000f,0.66000000f,0.85000000f,0.52000000f,0.89000000f,0.50000000f,0.38000000f,-0.03000000f,0.75000000f,0.29000000f,0.53000000f,-0.71000000f,0.99000000f,-0.58000000f,0.75000000f,0.74000000f,-0.66000000f,0.50000000f,0.76000000f,-0.73000000f,-0.84000000f,-0.86000000f,0.71000000f,0.07000000f,-0.82000000f,-0.43000000f,0.96000000f,0.94000000f,-0.36000000f,-0.27000000f,0.43000000f,0.03000000f,-0.60000000f,-0.35000000f,0.41000000f,-0.30000000f,0.06000000f,-0.51000000f,0.49000000f,-0.34000000f,0.99000000f,-0.86000000f,0.99000000f,-0.03000000f,-0.43000000f,-0.27000000f,-0.72000000f,-0.92000000f,0.17000000f,-0.78000000f,0.43000000f,0.93000000f,0.12000000f,-0.15000000f,0.73000000f,0.88000000f,0.44000000f,-0.58000000f,-0.20000000f,0.27000000f,0.45000000f,0.40000000f,0.02000000f,0.94000000f,-0.68000000f,0.88000000f,-0.76000000f,-0.16000000f,0.08000000f,0.92000000f,-0.88000000f,0.03000000f,-0.66000000f,-0.59000000f,-0.05000000f,-0.95000000f,-0.54000000f,0.97000000f,0.94000000f,-0.84000000f,0.24000000f,-0.03000000f,-0.14000000f,0.58000000f,-0.75000000f,0.38000000f,0.00000000f,-0.90000000f,-0.34000000f,-0.70000000f,-0.79000000f,-0.33000000f,0.48000000f,0.92000000f,-0.68000000f,-0.88000000f,0.99000000f,-0.58000000f,0.32000000f,0.81000000f,-0.57000000f,0.23000000f,-0.70000000f,-0.26000000f,0.49000000f,-0.13000000f,0.93000000f,0.66000000f,-0.31000000f,-0.58000000f,0.56000000f,-0.57000000f,-0.38000000f,0.59000000f,0.10000000f,0.10000000f,-0.55000000f,-0.41000000f,0.13000000f,-0.22000000f,-0.53000000f,0.30000000f,0.39000000f,0.66000000f,0.93000000f,-0.38000000f,0.93000000f,0.35000000f,-0.47000000f,0.21000000f,0.14000000f,0.86000000f,0.71000000f,-0.51000000f,-0.99000000f,0.72000000f,-0.37000000f,-0.24000000f,-0.04000000f,0.19000000f,0.03000000f,-0.18000000f,0.38000000f,-0.68000000f,0.88000000f,0.98000000f,-0.57000000f,0.26000000f,-0.18000000f,0.34000000f,0.99000000f,0.04000000f,-0.05000000f,0.84000000f,-0.83000000f,0.45000000f,-0.93000000f,-0.94000000f,-0.65000000f,0.91000000f,-0.23000000f,0.34000000f,-0.34000000f,-0.11000000f,0.10000000f,0.96000000f,0.22000000f,0.59000000f,0.67000000f,0.73000000f,-0.05000000f,0.34000000f,-0.69000000f,-0.74000000f,-0.32000000f,-0.47000000f,0.96000000f,-0.38000000f,-0.77000000f,-0.04000000f,-0.30000000f,-0.29000000f,-0.82000000f,0.22000000f,-0.05000000f,-0.56000000f,0.10000000f,-0.78000000f,-0.06000000f,-0.14000000f,-0.46000000f,-0.11000000f,0.66000000f,0.83000000f,-0.46000000f,-0.26000000f,-0.19000000f,-0.55000000f,0.28000000f,0.00000000f,-0.02000000f,0.02000000f,-0.64000000f,0.14000000f,-0.57000000f,-0.49000000f,0.07000000f,-0.38000000f,0.18000000f,0.75000000f,-0.97000000f,0.20000000f,-0.14000000f,0.26000000f,0.58000000f,-0.31000000f,-0.64000000f,0.90000000f,0.52000000f,-0.49000000f,0.98000000f,0.78000000f,-0.84000000f,-0.36000000f,0.64000000f,-0.63000000f,0.46000000f,-0.95000000f,0.05000000f,0.27000000f,0.65000000f,0.69000000f,-0.80000000f,-0.31000000f,-0.57000000f,0.70000000f,-0.34000000f,-0.65000000f,-0.46000000f,-0.06000000f,-0.12000000f,-0.35000000f,-0.03000000f,-0.49000000f,0.38000000f,-0.07000000f,-0.15000000f,-0.46000000f,0.65000000f,0.70000000f,-0.05000000f,-0.98000000f,-0.75000000f,0.07000000f,-0.61000000f,-0.69000000f,0.05000000f,-0.39000000f,-0.93000000f,-0.93000000f,0.66000000f,-0.68000000f,0.52000000f,0.76000000f,-0.24000000f,-0.78000000f,-0.06000000f,-0.77000000f,0.28000000f,-0.65000000f,-0.74000000f,0.42000000f,-0.04000000f,-0.59000000f,0.97000000f,-0.96000000f,0.87000000f,0.30000000f,-0.31000000f,-0.24000000f,0.99000000f,-0.15000000f,-0.06000000f,0.87000000f,-0.86000000f,0.34000000f,-0.68000000f,-0.15000000f,0.45000000f,-0.83000000f,-0.33000000f,0.56000000f,-0.53000000f,0.45000000f,-0.95000000f,0.48000000f,0.89000000f,0.93000000f,-0.74000000f,-0.21000000f,0.15000000f,-0.17000000f,-0.81000000f,-0.07000000f,0.99000000f,-0.32000000f,-0.66000000f,0.64000000f,-0.89000000f,-0.74000000f,0.14000000f,0.04000000f,-0.82000000f,-0.74000000f,-0.30000000f,0.61000000f,0.35000000f,-0.72000000f,0.52000000f,-0.60000000f,-0.44000000f,0.42000000f,0.58000000f,0.29000000f,0.91000000f,-0.44000000f,0.94000000f,0.65000000f,-0.32000000f,-0.26000000f,-0.02000000f,0.79000000f,0.45000000f,-0.40000000f,0.10000000f,0.53000000f,-0.11000000f,-0.15000000f,-0.99000000f,-0.24000000f,0.86000000f,0.85000000f,-0.42000000f,-0.00000000f,0.28000000f,0.07000000f,-0.86000000f,-0.18000000f,0.75000000f,-0.38000000f,0.16000000f,-0.62000000f,0.97000000f,0.28000000f,0.30000000f,0.80000000f,0.14000000f,0.24000000f,0.82000000f,-0.25000000f,0.55000000f,-0.82000000f,0.42000000f,-0.39000000f,-0.24000000f,-0.58000000f,0.54000000f,0.27000000f,0.95000000f,-0.98000000f,-0.30000000f,-0.55000000f,0.51000000f,-0.52000000f,-0.32000000f,-0.50000000f,0.49000000f,-0.90000000f,-0.15000000f,0.38000000f,-0.92000000f,0.38000000f,-0.48000000f,0.39000000f,0.45000000f,-0.56000000f,-0.96000000f,-0.96000000f,0.72000000f,-0.25000000f,-0.77000000f,-0.31000000f,0.59000000f,-0.89000000f,0.42000000f,0.48000000f,0.62000000f,-0.11000000f,-0.78000000f,0.70000000f,0.46000000f,0.88000000f,-0.32000000f,-0.62000000f,-0.87000000f,-0.61000000f,0.14000000f,0.99000000f,0.44000000f,0.81000000f,-0.66000000f,0.24000000f,-0.56000000f,0.69000000f,-0.97000000f,0.76000000f,-0.75000000f,-0.00000000f,-0.94000000f,0.58000000f,-0.32000000f,0.82000000f,0.74000000f,-0.24000000f,-0.88000000f,0.30000000f,-0.07000000f,0.04000000f,0.75000000f,-0.70000000f,0.70000000f,0.23000000f,-0.21000000f,-0.51000000f,0.36000000f,0.63000000f,-0.70000000f,0.10000000f,0.09000000f,0.64000000f,-0.51000000f,-0.12000000f,-0.23000000f,-0.39000000f,0.35000000f,0.74000000f,-0.58000000f,0.39000000f,-0.84000000f,0.81000000f,-0.93000000f,-0.40000000f,0.31000000f,-0.81000000f,0.41000000f,-0.89000000f,-0.27000000f,-0.39000000f,0.13000000f,-0.51000000f,-0.72000000f,-0.55000000f,0.79000000f,0.49000000f,-0.29000000f,0.00000000f,-0.92000000f,-0.10000000f,-0.77000000f,-0.75000000f,-0.33000000f,-0.20000000f,0.21000000f,0.22000000f,-0.31000000f,0.14000000f,-0.58000000f,0.82000000f,0.38000000f,0.33000000f,-0.01000000f,0.54000000f,-0.67000000f,0.24000000f,0.60000000f,0.53000000f,0.52000000f,0.21000000f,-0.73000000f,-0.72000000f,-0.60000000f,-0.37000000f,-0.34000000f,-0.06000000f,0.15000000f,-0.63000000f,-0.99000000f,-0.28000000f,0.04000000f,-0.36000000f,-0.28000000f,0.35000000f,0.88000000f,0.24000000f,0.52000000f,-0.54000000f,0.55000000f,-0.91000000f,0.36000000f,0.59000000f,0.48000000f,-0.43000000f,-0.54000000f,-0.36000000f,0.12000000f,0.56000000f,-0.72000000f,0.54000000f,-0.75000000f,-0.77000000f,0.12000000f,-0.89000000f,-0.30000000f,0.93000000f,-0.11000000f,-0.18000000f,-0.67000000f,-0.15000000f,0.02000000f,-0.76000000f,-0.51000000f,0.45000000f,0.79000000f,-0.49000000f,0.90000000f,-0.98000000f,-0.70000000f,0.10000000f,0.35000000f,-0.22000000f,0.66000000f,-0.62000000f,0.87000000f,0.44000000f,-0.55000000f,-0.63000000f,0.09000000f,-0.42000000f,-0.38000000f,0.81000000f,0.69000000f,-0.56000000f,-0.51000000f,0.25000000f,0.31000000f,0.06000000f,-0.99000000f,0.45000000f,-0.85000000f,0.84000000f,0.32000000f,0.21000000f,0.61000000f,-0.44000000f,-0.63000000f,0.46000000f,-0.87000000f,-0.03000000f,0.40000000f,-0.52000000f,0.89000000f,-0.92000000f,-0.14000000f,0.30000000f,0.39000000f,0.30000000f,-0.63000000f,-0.01000000f,-0.66000000f,-0.02000000f,-0.51000000f,0.14000000f,0.02000000f,0.28000000f,0.85000000f,0.77000000f,-0.55000000f,0.69000000f,-0.13000000f,-0.72000000f,-0.04000000f,-0.35000000f,0.05000000f,0.40000000f,0.49000000f,0.27000000f,-0.64000000f,-0.46000000f,-0.59000000f,-0.33000000f,0.43000000f,0.53000000f,-0.50000000f,-0.60000000f,0.28000000f,0.82000000f,0.51000000f,0.90000000f,0.48000000f,-0.55000000f,-0.08000000f,-0.32000000f,0.68000000f,-0.93000000f,-0.09000000f,-0.85000000f,-0.29000000f,-0.92000000f,0.15000000f,0.84000000f,-0.97000000f,0.12000000f,0.72000000f,0.81000000f,-0.88000000f,-0.98000000f,-0.26000000f,0.85000000f,0.56000000f,0.95000000f,-0.10000000f,0.67000000f,-0.14000000f,0.03000000f,0.25000000f,0.72000000f,-0.22000000f,0.18000000f,-0.72000000f,-0.85000000f,0.83000000f,0.00000000f,0.98000000f,-0.34000000f,0.35000000f,0.62000000f,-0.65000000f,-0.66000000f,0.78000000f,0.09000000f,-0.09000000f,-0.98000000f,0.89000000f,-0.27000000f,-0.54000000f,-0.82000000f,0.06000000f,-0.12000000f,-0.89000000f,0.45000000f,-0.07000000f,0.73000000f,-0.66000000f,-0.00000000f,-0.67000000f,0.56000000f,-0.41000000f,-0.99000000f,0.09000000f,0.30000000f,-0.30000000f,0.76000000f,-0.33000000f,0.02000000f,0.29000000f,-0.36000000f,0.69000000f,0.83000000f,-0.16000000f,0.76000000f,-0.36000000f,-0.47000000f,-0.22000000f,0.18000000f,-0.49000000f,0.57000000f,-0.02000000f,-0.56000000f,-0.93000000f,-0.19000000f,-0.98000000f,-0.98000000f,-0.17000000f,-0.42000000f,0.55000000f,0.49000000f,-0.37000000f,0.02000000f,-0.22000000f,-0.61000000f,-0.36000000f,0.94000000f,-0.65000000f,-0.87000000f,0.56000000f,-0.93000000f,-0.53000000f,-0.23000000f,-0.30000000f,0.34000000f,0.53000000f,-0.55000000f,-0.62000000f,-0.86000000f,0.22000000f,-0.57000000f,0.47000000f,0.12000000f,-0.93000000f,-0.83000000f,-0.90000000f,0.77000000f,0.36000000f,0.73000000f,-0.59000000f,0.87000000f,0.88000000f,-0.54000000f,0.88000000f,0.39000000f,0.42000000f,0.50000000f,0.68000000f,-0.66000000f,0.07000000f,0.22000000f,-0.39000000f,-0.47000000f,0.41000000f,-0.79000000f,-0.38000000f,0.79000000f,-0.09000000f,0.37000000f,-0.07000000f,0.05000000f,0.66000000f,-0.54000000f,0.45000000f,0.39000000f,0.84000000f,0.72000000f,0.12000000f,0.30000000f,-0.55000000f,0.54000000f,0.42000000f,-0.14000000f,-0.85000000f,-0.56000000f,-0.55000000f,0.27000000f,0.70000000f,0.98000000f,-0.28000000f,-0.29000000f,0.48000000f,-0.02000000f,-0.83000000f,-0.86000000f,-0.92000000f,0.88000000f,-0.11000000f,0.53000000f,0.06000000f,-0.45000000f,0.05000000f,0.78000000f,0.69000000f,0.22000000f,0.52000000f,0.11000000f,0.38000000f,-0.52000000f,0.47000000f,-0.02000000f,-0.43000000f,-0.19000000f,-0.39000000f,-0.45000000f,0.81000000f,0.29000000f,-0.97000000f,-0.04000000f,0.25000000f,-0.29000000f,-0.77000000f,0.46000000f,-0.62000000f,-0.92000000f,0.85000000f,-0.89000000f,-0.84000000f,0.03000000f,0.16000000f,0.47000000f,-0.18000000f,-0.60000000f,0.04000000f,0.71000000f,-0.99000000f,0.57000000f,0.12000000f,-0.83000000f,-0.26000000f,0.29000000f,-0.81000000f,-0.48000000f,0.91000000f,0.01000000f,-0.38000000f,0.50000000f,0.69000000f,0.38000000f,0.18000000f,0.03000000f,-0.64000000f,0.19000000f,0.10000000f,0.76000000f,0.27000000f,-0.34000000f,-0.28000000f,-0.74000000f,-0.26000000f,0.28000000f,-0.60000000f,0.95000000f,0.52000000f,0.84000000f,-0.20000000f,0.97000000f,0.93000000f,-0.56000000f,-0.29000000f,0.87000000f,-0.71000000f,0.20000000f,0.83000000f,-0.83000000f,0.69000000f,-0.86000000f,0.40000000f,0.34000000f,0.78000000f,-0.50000000f,-0.19000000f,0.50000000f,-0.78000000f,-0.11000000f,0.77000000f,-0.80000000f,0.95000000f,-0.22000000f,0.03000000f,-0.68000000f,-0.63000000f,0.74000000f,0.01000000f,-0.70000000f,-0.59000000f,-0.64000000f,-0.72000000f,0.83000000f,0.41000000f,-0.65000000f,-0.16000000f,-0.29000000f,0.55000000f,-0.63000000f,0.80000000f,-0.85000000f,-0.49000000f,0.45000000f,-0.54000000f,-0.00000000f,-0.36000000f,-0.04000000f,0.66000000f,-0.14000000f,0.15000000f,-0.44000000f,0.79000000f,-0.44000000f,0.81000000f,0.90000000f,0.65000000f,0.27000000f,-0.08000000f,0.28000000f,-0.88000000f,0.89000000f,-0.80000000f,-0.96000000f,-0.97000000f,0.56000000f,-0.72000000f,-0.68000000f,-0.26000000f,0.91000000f,0.43000000f,0.93000000f,-0.85000000f,-0.97000000f,-0.00000000f,0.04000000f,-0.68000000f,0.76000000f,0.61000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.95000000f,0.84000000f,0.47000000f,-0.66000000f,-0.92000000f,-0.50000000f,0.11000000f,-0.99000000f,0.22000000f,0.20000000f,0.00000000f,0.33000000f,0.14000000f,-0.35000000f,0.48000000f,0.42000000f,0.30000000f,0.89000000f,-0.93000000f,0.88000000f,-0.44000000f,0.08000000f,0.01000000f,0.03000000f,-0.14000000f,0.71000000f,0.24000000f,-0.17000000f,-0.68000000f,0.17000000f,0.53000000f,0.79000000f,0.97000000f,0.32000000f,0.58000000f,0.40000000f,-0.77000000f,-0.77000000f,0.14000000f,0.38000000f,0.69000000f,0.73000000f,0.88000000f,0.81000000f,0.67000000f,0.13000000f,-0.53000000f,-0.13000000f,-0.79000000f,0.70000000f,0.46000000f,0.71000000f,0.06000000f,-0.42000000f,0.96000000f,0.24000000f,0.02000000f,-0.31000000f,-0.18000000f,-0.87000000f,-0.70000000f,0.05000000f,-0.46000000f,-0.59000000f,-0.84000000f,0.12000000f,0.41000000f,-0.90000000f,0.45000000f,0.11000000f,0.02000000f,-0.49000000f,-0.26000000f,-0.41000000f,0.43000000f,-0.34000000f,-0.19000000f,-0.41000000f,-0.64000000f,-0.20000000f,0.22000000f,-0.20000000f,-0.05000000f,0.33000000f,-0.19000000f,0.69000000f,-0.85000000f,-0.01000000f,0.33000000f,0.07000000f,0.80000000f,-0.45000000f,-0.53000000f,-0.57000000f,0.88000000f,-0.80000000f,0.12000000f,0.60000000f,-0.31000000f,0.11000000f,0.33000000f,-0.10000000f,-0.09000000f,0.21000000f,-0.93000000f,-0.44000000f,0.18000000f,-0.13000000f,-0.33000000f,0.17000000f,0.38000000f,-0.43000000f,0.07000000f,0.30000000f,-0.10000000f,-0.25000000f,0.96000000f,-0.23000000f,0.91000000f,-0.47000000f,0.37000000f,0.52000000f,-0.96000000f,0.33000000f,0.37000000f,-0.75000000f,-0.91000000f,0.33000000f,0.11000000f,-0.92000000f,-0.98000000f,-0.74000000f,-0.26000000f,0.04000000f,-0.06000000f,0.38000000f,-0.73000000f,0.27000000f,0.88000000f,0.25000000f,-0.79000000f,0.48000000f,0.82000000f,0.98000000f,-0.97000000f,0.21000000f,-0.16000000f,0.56000000f,-0.03000000f,-0.53000000f,-0.13000000f,-0.73000000f,-0.31000000f,0.37000000f,-0.68000000f,-0.36000000f,0.42000000f,-0.21000000f,-0.02000000f,-0.57000000f,0.50000000f,0.00000000f,-0.87000000f,0.28000000f,0.27000000f,0.98000000f,-0.96000000f,0.21000000f,0.81000000f,-0.33000000f,-0.94000000f,-0.15000000f,-0.45000000f,0.93000000f,-0.36000000f,0.23000000f,0.64000000f,-0.04000000f,-0.13000000f,0.40000000f,-0.72000000f,0.17000000f,0.87000000f,-0.60000000f,-0.82000000f,-0.20000000f,0.32000000f,0.92000000f,0.99000000f,0.28000000f,-0.47000000f,0.50000000f,0.27000000f,0.58000000f,-0.98000000f,0.36000000f,0.90000000f,0.45000000f,-0.65000000f,0.26000000f,0.54000000f,-0.54000000f,0.35000000f,0.07000000f,-0.94000000f,0.23000000f,0.02000000f,0.87000000f,0.83000000f,0.09000000f,-0.83000000f,0.53000000f,0.44000000f,-0.93000000f,0.35000000f,-0.86000000f,-0.01000000f,0.38000000f,0.56000000f,-0.65000000f,0.72000000f,-0.04000000f,0.09000000f,0.17000000f,0.95000000f,-0.64000000f,0.91000000f,0.34000000f,-0.60000000f,-0.40000000f,0.73000000f,-0.66000000f,-0.65000000f,-0.21000000f,-0.17000000f,-0.12000000f,0.50000000f,0.27000000f,-0.68000000f,-0.74000000f,-0.27000000f,-0.64000000f,-0.75000000f,-0.01000000f,-0.50000000f,0.47000000f,-0.50000000f,-0.08000000f,-0.00000000f,-0.79000000f,0.99000000f,-0.01000000f,-0.69000000f,-0.60000000f,-0.95000000f,-0.11000000f,0.25000000f,-0.52000000f,-0.49000000f,0.31000000f,0.76000000f,-0.83000000f,-0.39000000f,-0.42000000f,-0.18000000f,0.06000000f,-0.04000000f,-0.74000000f,-0.27000000f,-0.23000000f,0.76000000f,0.33000000f,0.59000000f,-0.72000000f,-0.70000000f,-0.04000000f,0.63000000f,-0.21000000f,0.25000000f,0.16000000f,-0.03000000f,0.77000000f,0.03000000f,-0.74000000f,0.94000000f,-0.91000000f,-0.23000000f,0.47000000f,0.90000000f,0.82000000f,-0.58000000f,0.77000000f,-0.37000000f,0.05000000f,-0.51000000f,0.09000000f,-0.80000000f,0.95000000f,0.73000000f,0.28000000f,0.56000000f,-0.74000000f,-0.31000000f,0.37000000f,0.65000000f,0.32000000f,-0.50000000f,-0.52000000f,-0.68000000f,0.78000000f,0.82000000f,0.94000000f,0.27000000f,-0.44000000f,-0.05000000f,0.39000000f,-0.80000000f,-0.88000000f,0.42000000f,0.72000000f,0.02000000f,0.26000000f,-0.58000000f,0.21000000f,-0.90000000f,0.00000000f,0.36000000f,0.77000000f,-0.96000000f,-0.18000000f,0.99000000f,-0.71000000f,0.94000000f,-0.81000000f,-0.08000000f,-0.64000000f,-0.71000000f,-0.84000000f,-0.28000000f,0.44000000f,0.44000000f,0.80000000f,-0.17000000f,-0.50000000f,0.38000000f,0.75000000f,0.29000000f,0.54000000f,-0.56000000f,-0.40000000f,0.35000000f,0.59000000f,0.88000000f,-0.87000000f,0.03000000f,0.88000000f,-0.02000000f,0.26000000f,0.68000000f,0.38000000f,0.24000000f,0.03000000f,0.15000000f,0.28000000f,0.73000000f,0.67000000f,0.94000000f,-0.04000000f,0.18000000f,-0.19000000f,0.68000000f,-0.91000000f,0.41000000f,-0.50000000f,-0.36000000f,0.03000000f,-0.65000000f,0.44000000f,-0.73000000f,-0.18000000f,0.39000000f,0.40000000f,-0.53000000f,-0.94000000f,0.11000000f,0.71000000f,0.82000000f,-0.17000000f,0.65000000f,0.60000000f,0.93000000f,-0.99000000f,-0.11000000f,-0.83000000f,-0.31000000f,-0.09000000f,-0.08000000f,0.91000000f,-0.51000000f,-0.25000000f,0.52000000f,0.54000000f,0.23000000f,-0.00000000f,0.69000000f,0.88000000f,0.49000000f,-0.50000000f,0.99000000f,0.82000000f,-0.56000000f,-0.68000000f,0.18000000f,-0.38000000f,-0.97000000f,0.27000000f,-0.83000000f,0.63000000f,0.98000000f,-0.59000000f,0.43000000f,0.07000000f,-0.68000000f,-0.00000000f,-0.25000000f,-0.69000000f,-0.03000000f,0.86000000f,0.72000000f,0.53000000f,-0.95000000f,-0.88000000f,0.15000000f,0.43000000f,-0.61000000f,-0.03000000f,-0.56000000f,-0.44000000f,-0.35000000f,-0.46000000f,-0.21000000f,-0.80000000f,-0.63000000f,0.39000000f,-0.24000000f,-0.91000000f,0.24000000f,0.32000000f,-0.22000000f,0.73000000f,-0.24000000f,-0.53000000f,-0.22000000f,-0.62000000f,-0.39000000f,-0.40000000f,0.60000000f,0.78000000f,-0.11000000f,0.32000000f,-0.34000000f,0.53000000f,0.60000000f,0.10000000f,-0.59000000f,0.31000000f,0.77000000f,-0.54000000f,0.52000000f,0.68000000f,0.84000000f,-0.55000000f,-0.15000000f,0.16000000f,0.15000000f,-0.64000000f,0.73000000f,0.77000000f,-0.57000000f,-0.05000000f,0.36000000f,-0.03000000f,0.27000000f,0.93000000f,-0.88000000f,0.82000000f,0.40000000f,-0.69000000f,0.23000000f,0.01000000f,0.30000000f,-0.21000000f,0.09000000f,-0.18000000f,0.97000000f,0.33000000f,0.48000000f,-0.15000000f,-0.05000000f,-0.86000000f,0.81000000f,-0.33000000f,-0.92000000f,0.58000000f,0.47000000f,0.22000000f,0.81000000f,0.77000000f,-0.82000000f,-0.15000000f,0.82000000f,-0.53000000f,0.31000000f,0.30000000f,-0.16000000f,-0.24000000f,-0.24000000f,-0.80000000f,0.72000000f,-0.91000000f,-0.53000000f,-0.73000000f,0.85000000f,0.82000000f,-0.97000000f,-0.80000000f,-0.13000000f,-0.20000000f,0.40000000f,-0.70000000f,-0.35000000f,0.88000000f,0.08000000f,-0.48000000f,0.77000000f,0.62000000f,-0.16000000f,-0.47000000f,0.53000000f,0.11000000f,0.43000000f,-0.36000000f,-0.13000000f,-0.01000000f,-0.36000000f,0.88000000f,-0.89000000f,0.03000000f,0.69000000f,-0.36000000f,-0.98000000f,0.52000000f,0.28000000f,0.59000000f,0.27000000f,-0.43000000f,-0.75000000f,0.61000000f,0.67000000f,0.46000000f,-0.50000000f,-0.11000000f,-0.77000000f,-0.43000000f,-0.00000000f,-0.80000000f,0.91000000f,0.22000000f,-0.50000000f,-0.83000000f,-0.52000000f,0.94000000f,-0.92000000f,-0.36000000f,-0.96000000f,-0.40000000f,0.11000000f,-0.37000000f,0.08000000f,0.52000000f,0.53000000f,0.02000000f,-0.83000000f,0.54000000f,-0.48000000f,0.02000000f,-0.05000000f,0.32000000f,-0.78000000f,0.02000000f,-0.79000000f,0.34000000f,-0.54000000f,0.93000000f,-0.80000000f,0.32000000f,0.70000000f,-0.82000000f,0.92000000f,0.04000000f,0.83000000f,-0.26000000f,-0.68000000f,0.76000000f,0.78000000f,0.35000000f,0.71000000f,0.83000000f,0.52000000f,0.57000000f,-0.20000000f,0.12000000f,0.26000000f,-0.99000000f,0.47000000f,0.60000000f,-0.06000000f,-0.17000000f,0.26000000f,-0.60000000f,0.70000000f,-0.22000000f,-0.87000000f,-0.78000000f,0.29000000f,0.47000000f,0.76000000f,0.09000000f,0.73000000f,0.07000000f,-0.91000000f,-0.53000000f,-0.40000000f,0.78000000f,0.81000000f,-0.57000000f,-0.05000000f,-0.54000000f,-0.04000000f,-0.14000000f,0.80000000f,0.11000000f,-0.75000000f,0.56000000f,0.63000000f,-0.73000000f,-0.32000000f,0.86000000f,-0.98000000f,-0.64000000f,0.59000000f,-0.95000000f,0.63000000f,0.10000000f,0.24000000f,-0.83000000f,-0.60000000f,-0.67000000f,0.40000000f,-0.96000000f,-0.30000000f,-0.69000000f,0.70000000f,-0.89000000f,0.40000000f,-0.21000000f,0.83000000f,0.44000000f,0.71000000f,-0.85000000f,-0.05000000f,-0.95000000f,-0.83000000f,0.26000000f,-0.63000000f,0.37000000f,-0.05000000f,-0.76000000f,-0.47000000f,0.37000000f,0.01000000f,0.42000000f,-0.12000000f,0.99000000f,-0.43000000f,0.16000000f,-0.20000000f,-0.17000000f,-0.18000000f,-0.13000000f,-0.98000000f,-0.05000000f,-0.86000000f,0.40000000f,0.70000000f,-0.68000000f,0.93000000f,-0.62000000f,0.08000000f,-0.54000000f,-0.01000000f,0.82000000f,0.05000000f,-0.45000000f,-0.83000000f,-0.22000000f,-0.35000000f,0.54000000f,0.48000000f,0.12000000f,0.27000000f,-0.87000000f,-0.67000000f,-0.15000000f,0.02000000f,-0.67000000f,0.52000000f,0.24000000f,0.08000000f,-0.80000000f,0.09000000f,0.99000000f,0.31000000f,0.01000000f,0.83000000f,-0.99000000f,-0.90000000f,-0.23000000f,0.39000000f,0.75000000f,-0.51000000f,0.75000000f,0.37000000f,-0.28000000f,0.27000000f,-0.72000000f,0.71000000f,0.78000000f,0.95000000f,-0.05000000f,0.08000000f,-0.10000000f,-0.19000000f,0.43000000f,0.38000000f,-0.69000000f,-0.38000000f,0.67000000f,0.58000000f,0.86000000f,0.14000000f,0.86000000f,-0.06000000f,0.41000000f,-0.17000000f,-0.15000000f,0.96000000f,0.10000000f,0.20000000f,0.22000000f,-0.92000000f,-0.51000000f,-0.08000000f,0.84000000f,0.83000000f,-0.90000000f,0.51000000f,-0.07000000f,0.69000000f,0.84000000f,0.30000000f,0.35000000f,-0.01000000f,-0.01000000f,0.85000000f,0.76000000f,0.77000000f,-0.50000000f,0.67000000f,0.65000000f,-0.49000000f,-0.47000000f,-0.64000000f,0.63000000f,-0.12000000f,-0.84000000f,0.76000000f,0.50000000f,0.00000000f,-0.83000000f,-0.71000000f,0.43000000f,-0.10000000f,0.95000000f,0.86000000f,-0.77000000f,0.93000000f,-0.61000000f,-0.67000000f,-0.18000000f,-0.53000000f,-0.12000000f,-0.59000000f,0.95000000f,-0.97000000f,-0.08000000f,-0.20000000f,-0.65000000f,-0.78000000f,-0.02000000f,-0.47000000f,-0.55000000f,-0.77000000f,0.00000000f,-0.01000000f,-0.97000000f,0.29000000f,-0.68000000f,0.66000000f,-0.86000000f,0.70000000f,-0.53000000f,-0.99000000f,-0.29000000f,-0.87000000f,0.34000000f,0.13000000f,-0.12000000f,-0.64000000f,0.65000000f,-0.08000000f,0.80000000f,-0.37000000f,-0.01000000f,0.63000000f,-0.85000000f,0.37000000f,0.23000000f,0.06000000f,-0.57000000f,-0.99000000f,0.28000000f,-0.48000000f,0.70000000f,0.34000000f,0.08000000f,0.96000000f,-0.27000000f,0.36000000f,0.31000000f,-0.39000000f,-0.22000000f,-0.06000000f,-0.67000000f,-0.22000000f,-0.49000000f,0.77000000f,-0.16000000f,0.95000000f,-0.03000000f,-0.40000000f,0.67000000f,0.17000000f,0.73000000f,0.44000000f,-0.69000000f,0.78000000f,0.57000000f,-0.14000000f,-0.61000000f,-0.31000000f,0.73000000f,-0.71000000f,0.03000000f,0.95000000f,0.33000000f,-0.50000000f,0.69000000f,-0.11000000f,0.81000000f,-0.64000000f,0.67000000f,0.66000000f,-0.47000000f,-0.28000000f,-0.11000000f,0.11000000f,0.97000000f,0.67000000f,0.98000000f,0.38000000f,-0.07000000f,-0.38000000f,0.12000000f,-0.59000000f,0.89000000f,0.12000000f,0.05000000f,-0.03000000f,0.58000000f,-0.68000000f,-0.74000000f,0.57000000f,0.81000000f,0.23000000f,-0.35000000f,-0.27000000f,0.29000000f,-0.43000000f,0.03000000f,-0.60000000f,0.18000000f,0.07000000f,0.74000000f,-0.56000000f,0.70000000f,-0.11000000f,0.28000000f,-0.73000000f,0.14000000f,-0.60000000f,0.00000000f,-0.71000000f,-0.38000000f,0.39000000f,0.93000000f,-0.32000000f,0.75000000f,-0.39000000f,0.63000000f,-0.44000000f,-0.10000000f,0.10000000f,0.83000000f,0.56000000f,-0.07000000f,-0.25000000f,0.75000000f,0.96000000f,0.34000000f,-0.78000000f,-0.95000000f,-0.18000000f,0.36000000f,0.57000000f,-0.82000000f,0.44000000f,-0.57000000f,0.65000000f,0.40000000f,-0.02000000f,0.97000000f,0.31000000f,0.06000000f,-0.91000000f,-0.80000000f,-0.74000000f,-0.29000000f,0.46000000f,-0.58000000f,0.47000000f,0.25000000f,-0.06000000f,0.28000000f,0.98000000f,-0.56000000f,-0.13000000f,0.90000000f,0.28000000f,0.99000000f,0.78000000f,-0.46000000f,0.96000000f,-0.34000000f,-0.94000000f,0.22000000f,0.99000000f,-0.48000000f,0.18000000f,0.97000000f,-0.52000000f,0.98000000f,0.74000000f,-0.18000000f,0.04000000f,0.98000000f,-0.85000000f,-0.36000000f,-0.29000000f,-0.18000000f,-0.39000000f,-0.89000000f,0.49000000f,-0.71000000f,0.24000000f,0.59000000f,-0.85000000f,0.58000000f,0.86000000f,-0.68000000f,0.07000000f,0.72000000f,-0.32000000f,-0.76000000f,0.84000000f,0.05000000f,0.16000000f,0.68000000f,-0.76000000f,0.22000000f,-0.65000000f,-0.18000000f,-0.49000000f,-0.17000000f,0.70000000f,-0.42000000f,0.98000000f,0.18000000f,0.18000000f,0.22000000f,0.14000000f,0.35000000f,0.26000000f,-0.36000000f,0.98000000f,0.84000000f,-0.54000000f,0.13000000f,0.90000000f,0.46000000f,0.53000000f,-0.94000000f,-0.15000000f,-0.14000000f,0.77000000f,0.68000000f,0.16000000f,-0.49000000f,-0.43000000f,-0.83000000f,-0.33000000f,0.14000000f,-0.55000000f,-0.39000000f,-0.14000000f,0.08000000f,-0.78000000f,-0.79000000f,-0.65000000f,-0.65000000f,0.73000000f,0.97000000f,0.65000000f,0.50000000f,-0.51000000f,-0.24000000f,-0.88000000f,0.59000000f,0.74000000f,0.03000000f,-0.91000000f,0.33000000f,0.03000000f,-0.66000000f,-0.20000000f,-0.13000000f,0.94000000f,0.46000000f,0.41000000f,0.50000000f,0.45000000f,0.47000000f,-0.10000000f,-0.28000000f,-0.36000000f,-0.02000000f,-0.52000000f,0.11000000f,-0.19000000f,-0.70000000f,0.33000000f,0.20000000f,-0.85000000f,-0.15000000f,-0.89000000f,0.11000000f,0.68000000f,-0.64000000f,-0.70000000f,0.90000000f,-0.02000000f,-0.26000000f,-0.49000000f,0.88000000f,0.46000000f,0.75000000f,0.96000000f,0.46000000f,0.08000000f,0.43000000f,-0.14000000f,-0.17000000f,-0.74000000f,-0.75000000f,-0.19000000f,0.61000000f,-0.87000000f,0.84000000f,-0.04000000f,0.85000000f,0.16000000f,-0.73000000f,0.14000000f,-0.21000000f,0.21000000f,0.73000000f,0.92000000f,0.10000000f,-0.66000000f,0.37000000f,-0.64000000f,0.90000000f,0.32000000f,-0.46000000f,0.04000000f,0.80000000f,0.88000000f,0.13000000f,-0.88000000f,-0.48000000f,0.37000000f,0.42000000f,-0.35000000f,-0.92000000f,-0.16000000f,0.61000000f,-0.15000000f,0.17000000f,0.14000000f,0.89000000f,-0.15000000f,0.18000000f,0.94000000f,-0.13000000f,0.51000000f,-0.67000000f,0.64000000f,0.41000000f,0.45000000f,0.00000000f,-0.81000000f,0.06000000f,-0.06000000f,-0.48000000f,-0.92000000f,-0.42000000f,0.83000000f,-0.87000000f,0.29000000f,0.72000000f,0.70000000f,0.40000000f,0.79000000f,-0.80000000f,0.17000000f,0.32000000f,0.29000000f,-0.30000000f,-0.13000000f,0.82000000f,0.72000000f,-0.96000000f,-0.84000000f,-0.13000000f,-0.36000000f,0.10000000f,0.40000000f,0.59000000f,0.92000000f,-0.30000000f,-0.16000000f,-0.53000000f,-0.47000000f,0.14000000f,-0.82000000f,0.02000000f,0.81000000f,0.27000000f,-0.77000000f,0.63000000f,0.47000000f,0.24000000f,0.19000000f,-0.29000000f,-0.56000000f,-0.49000000f,-0.03000000f,0.60000000f,-0.84000000f,0.10000000f,-0.30000000f,-0.09000000f,0.78000000f,0.31000000f,-0.75000000f,0.19000000f,-0.10000000f,0.02000000f,0.45000000f,0.60000000f,-0.36000000f,0.68000000f,0.49000000f,-0.29000000f,-0.21000000f,0.54000000f,-0.66000000f,0.55000000f,0.03000000f,0.53000000f,0.25000000f,-0.47000000f,-0.13000000f,0.41000000f,0.74000000f,0.02000000f,-0.67000000f,-0.68000000f,-0.61000000f,-0.92000000f,-0.37000000f,-0.65000000f,-0.76000000f,-0.86000000f,0.83000000f,-0.84000000f,-0.79000000f,-0.36000000f,0.09000000f,0.43000000f,0.68000000f,-0.81000000f,-0.25000000f,0.81000000f,-0.66000000f,0.28000000f,0.33000000f,0.74000000f,0.56000000f,-0.29000000f,-0.84000000f,-0.76000000f,0.74000000f,-0.03000000f,0.52000000f,0.30000000f,0.18000000f,0.11000000f,-0.46000000f,0.28000000f,-0.15000000f,-0.27000000f,0.21000000f,0.79000000f,-0.46000000f,-0.41000000f,-0.70000000f,0.60000000f,-0.35000000f,-0.33000000f,-0.56000000f,-0.14000000f,0.17000000f,0.01000000f,-0.81000000f,-0.62000000f,-0.60000000f,0.39000000f,-0.62000000f,0.87000000f,0.83000000f,-0.00000000f,-0.47000000f,-0.39000000f,-0.97000000f,0.11000000f,0.22000000f,-0.32000000f,-0.21000000f,-0.25000000f,0.70000000f,0.70000000f,0.01000000f,0.04000000f,-0.38000000f,-0.12000000f,0.80000000f,0.85000000f,0.40000000f,0.87000000f,-0.59000000f,-0.99000000f,-0.17000000f,0.63000000f,0.30000000f,0.36000000f,0.77000000f,-0.25000000f,-0.50000000f,0.22000000f,-0.26000000f,0.49000000f,-0.97000000f,0.18000000f,-0.29000000f,-0.19000000f,-0.28000000f,0.34000000f,-0.69000000f,-0.15000000f,-0.50000000f,0.18000000f,0.68000000f,-0.31000000f,0.52000000f,-0.18000000f,-0.67000000f,-0.22000000f,0.11000000f,-0.58000000f,-0.17000000f,-0.21000000f,-0.01000000f,0.71000000f,0.93000000f,0.00000000f,0.41000000f,-0.72000000f,-0.66000000f,-0.26000000f,-0.57000000f,-0.06000000f,-0.44000000f,-0.06000000f,-0.79000000f,-0.14000000f,-0.09000000f,0.52000000f,0.67000000f,-0.65000000f,-0.52000000f,-0.85000000f,-0.52000000f,-0.18000000f,-0.70000000f,0.75000000f,-0.51000000f,-0.49000000f,-0.06000000f,0.81000000f,0.06000000f,-0.95000000f,0.53000000f,-0.80000000f,-0.16000000f,0.84000000f,0.97000000f,-0.53000000f,0.00000000f,-0.75000000f,-0.99000000f,-0.38000000f,0.07000000f,-0.44000000f,0.25000000f,0.31000000f,0.16000000f,-0.39000000f,-0.92000000f,-0.17000000f,-0.38000000f,-0.63000000f,0.27000000f,0.53000000f,0.56000000f,-0.82000000f,0.95000000f,0.69000000f,-0.25000000f,0.62000000f,-0.36000000f,-0.21000000f,0.15000000f,-0.82000000f,-0.73000000f,-0.77000000f,-0.78000000f,0.46000000f,-0.15000000f,0.44000000f,0.82000000f,-0.82000000f,-0.50000000f,-0.73000000f,-0.39000000f,-0.85000000f,0.89000000f,-0.30000000f,-0.48000000f,-0.96000000f,0.95000000f,0.66000000f,-0.08000000f,0.82000000f,-0.00000000f,-0.16000000f,0.99000000f,-0.49000000f,0.27000000f,0.88000000f,-0.69000000f,-0.36000000f,-0.81000000f,0.86000000f,-0.53000000f,0.79000000f,0.76000000f,0.56000000f,0.59000000f,-0.70000000f,0.31000000f,0.61000000f,0.80000000f,0.93000000f,0.90000000f,0.05000000f,0.42000000f,0.21000000f,-0.75000000f,-0.87000000f,0.48000000f,-0.83000000f,-0.58000000f,-0.53000000f,-0.20000000f,-0.34000000f,-0.08000000f,0.25000000f,-0.21000000f,-0.18000000f,-0.82000000f,0.59000000f,0.18000000f,-0.73000000f,0.50000000f,0.36000000f,0.01000000f,-0.54000000f,-0.40000000f,0.24000000f,-0.99000000f,-0.30000000f,-0.43000000f,-0.26000000f,0.53000000f,0.98000000f,0.90000000f,-0.68000000f,-0.57000000f,-0.02000000f,0.63000000f,-0.84000000f,-0.96000000f,-0.52000000f,0.32000000f,0.09000000f,-0.98000000f,-0.52000000f,0.64000000f,0.17000000f,0.82000000f,0.07000000f,0.92000000f,0.63000000f,-0.43000000f,-0.52000000f,0.06000000f,-0.85000000f,0.02000000f,-0.71000000f,-0.86000000f,-0.58000000f,-0.32000000f,0.79000000f,0.68000000f,0.02000000f,0.50000000f,-0.76000000f,-0.26000000f,-0.23000000f,0.03000000f,0.42000000f,-0.26000000f,-0.09000000f,-0.40000000f,0.84000000f,0.79000000f,-0.57000000f,-0.07000000f,-0.61000000f,-0.79000000f,-0.97000000f,0.16000000f,0.10000000f,0.45000000f,-0.04000000f,0.66000000f,-0.52000000f,-0.39000000f,-0.77000000f,0.94000000f,0.70000000f,0.61000000f,-0.96000000f,-0.33000000f,0.85000000f,0.53000000f,-0.74000000f,0.30000000f,0.31000000f,-0.33000000f,0.74000000f,-0.56000000f,-0.00000000f,-0.95000000f,-0.91000000f,-0.42000000f,0.85000000f,-0.02000000f,-0.06000000f,-0.73000000f,0.07000000f,-0.52000000f,0.10000000f,0.39000000f,0.90000000f,0.78000000f,-0.11000000f,0.58000000f,0.61000000f,0.30000000f,0.53000000f,0.51000000f,0.06000000f,0.62000000f,0.58000000f,0.39000000f,-0.78000000f,0.47000000f,-0.36000000f,-0.48000000f,0.29000000f,-0.98000000f,0.90000000f,-0.63000000f,-0.40000000f,0.77000000f,0.93000000f,0.32000000f,0.94000000f,0.76000000f,-0.86000000f,0.84000000f,-0.57000000f,-0.35000000f,-0.68000000f,0.58000000f,-0.70000000f,-0.87000000f,-0.13000000f,-0.99000000f,-0.46000000f,0.51000000f,0.28000000f,-0.22000000f,-0.92000000f,-0.02000000f,0.77000000f,0.91000000f,0.41000000f,-0.13000000f,-0.18000000f,-0.80000000f,-0.12000000f,0.99000000f,-0.62000000f,0.71000000f,-0.39000000f,-0.53000000f,-0.75000000f,-0.88000000f,-0.05000000f,0.84000000f,0.32000000f,0.87000000f,0.18000000f,0.71000000f,0.03000000f,-0.48000000f,-0.59000000f,0.43000000f,-0.44000000f,0.23000000f,-0.36000000f,0.79000000f,-0.27000000f,-0.30000000f,-0.35000000f,0.56000000f,0.99000000f,-0.35000000f,-0.89000000f,-0.45000000f,0.45000000f,-0.55000000f,0.27000000f,-0.29000000f,0.90000000f,-0.95000000f,-0.63000000f,0.31000000f,-0.28000000f,-0.56000000f,0.38000000f,-0.08000000f,-0.18000000f,0.51000000f,0.60000000f,-0.93000000f,-0.00000000f,0.89000000f,-0.52000000f,0.08000000f,-0.36000000f,-0.61000000f,0.71000000f,-0.06000000f,0.53000000f,-0.77000000f,-0.46000000f,-0.30000000f,-0.79000000f,-0.36000000f,0.59000000f,-0.32000000f,-0.28000000f,0.88000000f,-0.15000000f,0.99000000f,0.31000000f,0.84000000f,0.72000000f,0.45000000f,0.61000000f,-0.69000000f,0.73000000f,-0.28000000f,0.88000000f,-0.21000000f,0.65000000f,-0.54000000f,-0.76000000f,-0.33000000f,-0.53000000f,0.87000000f,-0.36000000f,0.96000000f,0.60000000f,-0.07000000f,0.43000000f,0.52000000f,0.68000000f,0.72000000f,-0.53000000f,-0.23000000f,0.09000000f,0.47000000f,-0.92000000f,-0.31000000f,-0.63000000f,-0.26000000f,-0.86000000f,0.28000000f,0.77000000f,-0.14000000f,0.63000000f,0.48000000f,0.81000000f,0.31000000f,0.94000000f,0.37000000f,0.93000000f,-0.70000000f,0.64000000f,-0.63000000f,-0.31000000f,-0.10000000f,-0.64000000f,0.61000000f,0.02000000f,-0.86000000f,-0.40000000f,-0.95000000f,-0.80000000f,0.98000000f,0.96000000f,-0.07000000f,0.33000000f,-0.59000000f,-0.13000000f,-0.54000000f,0.67000000f,-0.50000000f,0.14000000f,-0.30000000f,0.30000000f,-0.80000000f,0.71000000f,0.86000000f,0.26000000f,-0.97000000f,-0.57000000f,-0.88000000f,-0.95000000f,0.84000000f,-0.25000000f,0.58000000f,-0.28000000f,-0.61000000f,-0.55000000f,-0.03000000f,0.14000000f,-0.05000000f,0.66000000f,0.98000000f,-0.01000000f,-0.41000000f,0.06000000f,0.74000000f,0.09000000f,0.42000000f,0.34000000f,-0.06000000f,0.27000000f,-0.26000000f,-0.82000000f,-0.07000000f,0.67000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.07000000f,0.05000000f,-0.21000000f,0.35000000f,-0.77000000f,-0.39000000f,0.11000000f,0.15000000f,0.06000000f,0.17000000f,0.69000000f,0.25000000f,-0.89000000f,0.93000000f,-0.29000000f,-0.25000000f,-0.95000000f,0.74000000f,-0.29000000f,-0.22000000f,0.82000000f,-0.71000000f,0.39000000f,-0.54000000f,0.58000000f,0.41000000f,-0.82000000f,-0.65000000f,-0.41000000f,-0.74000000f,-0.09000000f,-0.08000000f,-0.53000000f,-0.06000000f,-0.02000000f,0.51000000f,0.76000000f,0.40000000f,0.23000000f,-0.14000000f,-0.71000000f,-0.59000000f,0.33000000f,0.14000000f,-0.98000000f,-0.01000000f,-0.45000000f,0.25000000f,-0.33000000f,-0.21000000f,0.47000000f,-0.28000000f,-0.43000000f,0.52000000f,-0.04000000f,0.04000000f,-0.63000000f,0.53000000f,-0.15000000f,-0.23000000f,-0.15000000f,0.04000000f,-0.99000000f,-0.69000000f,0.16000000f,0.26000000f,-0.21000000f,0.90000000f,0.99000000f,-0.91000000f,-0.69000000f,0.40000000f,-0.69000000f,-0.52000000f,0.18000000f,0.86000000f,-0.41000000f,0.69000000f,0.44000000f,-0.13000000f,-0.16000000f,0.89000000f,0.60000000f,-0.12000000f,0.06000000f,0.84000000f,-0.58000000f,0.71000000f,0.19000000f,0.81000000f,0.58000000f,-0.64000000f,-0.39000000f,-0.92000000f,-0.70000000f,-0.98000000f,-0.13000000f,0.07000000f,-0.99000000f,0.14000000f,0.69000000f,-0.20000000f,0.18000000f,-0.80000000f,0.34000000f,-0.79000000f,0.94000000f,0.34000000f,-0.81000000f,-0.69000000f,-0.72000000f,-0.07000000f,0.33000000f,0.06000000f,0.87000000f,-0.77000000f,0.72000000f,0.16000000f,0.74000000f,0.87000000f,-0.87000000f,0.57000000f,0.87000000f,0.65000000f,0.63000000f,-0.78000000f,0.71000000f,0.64000000f,-0.94000000f,0.45000000f,0.52000000f,0.61000000f,0.80000000f,0.56000000f,0.89000000f,-0.99000000f,0.31000000f,0.11000000f,-0.63000000f,0.21000000f,0.97000000f,0.04000000f,-0.59000000f,-0.81000000f,0.13000000f,0.46000000f,0.28000000f,0.01000000f,-0.22000000f,0.62000000f,-0.12000000f,0.64000000f,0.82000000f,-0.67000000f,-0.76000000f,0.87000000f,-0.23000000f,-0.43000000f,0.72000000f,-0.64000000f,0.08000000f,0.53000000f,-0.41000000f,-0.03000000f,-0.68000000f,0.62000000f,0.08000000f,0.37000000f,-0.12000000f,-0.52000000f,0.07000000f,0.06000000f,-0.28000000f,0.02000000f,0.35000000f,0.11000000f,0.38000000f,0.90000000f,-0.19000000f,-0.36000000f,0.95000000f,-0.53000000f,-0.66000000f,-0.30000000f,0.46000000f,0.44000000f,0.63000000f,0.15000000f,0.75000000f,-0.88000000f,-0.80000000f,-0.39000000f,-0.33000000f,0.45000000f,0.56000000f,-0.34000000f,0.98000000f,-0.50000000f,0.22000000f,0.15000000f,0.12000000f,0.62000000f,0.06000000f,0.82000000f,-0.40000000f,0.86000000f,0.56000000f,0.18000000f,0.13000000f,-0.30000000f,-0.98000000f,0.57000000f,-0.49000000f,-0.32000000f,-0.74000000f,0.91000000f,-0.07000000f,0.09000000f,0.35000000f,-0.22000000f,-0.42000000f,0.37000000f,0.41000000f,-0.01000000f,-0.45000000f,0.96000000f,-0.97000000f,-0.37000000f,0.58000000f,-0.74000000f,0.61000000f,0.37000000f,-0.25000000f,0.82000000f,0.99000000f,-0.22000000f,0.60000000f,-0.95000000f,0.35000000f,0.63000000f,-0.73000000f,-0.96000000f,0.40000000f,0.17000000f,-0.04000000f,0.01000000f,-0.45000000f,-0.52000000f,0.86000000f,0.32000000f,-0.97000000f,-0.67000000f,0.21000000f,0.60000000f,-0.88000000f,-0.17000000f,0.11000000f,-0.89000000f,0.52000000f,-0.93000000f,-0.17000000f,-0.94000000f,0.72000000f,-0.45000000f,0.81000000f,-0.85000000f,-0.63000000f,0.27000000f,0.72000000f,-0.99000000f,-0.74000000f,-0.70000000f,-0.06000000f,-0.28000000f,0.28000000f,0.89000000f,-0.38000000f,-0.36000000f,0.28000000f,0.51000000f,-0.29000000f,-0.04000000f,-0.22000000f,-0.77000000f,0.62000000f,0.68000000f,0.73000000f,-0.29000000f,0.96000000f,0.26000000f,0.36000000f,-0.79000000f,0.93000000f,0.23000000f,0.06000000f,-0.99000000f,0.93000000f,0.34000000f,-0.40000000f,0.43000000f,-0.80000000f,-0.60000000f,-0.64000000f,-0.17000000f,-0.89000000f,-0.56000000f,-0.81000000f,0.70000000f,-0.67000000f,0.57000000f,0.57000000f,-0.77000000f,-0.28000000f,-0.39000000f,-0.58000000f,-0.35000000f,-0.02000000f,0.21000000f,-0.43000000f,0.60000000f,-0.95000000f,-0.44000000f,0.40000000f,-0.22000000f,0.44000000f,-0.94000000f,0.21000000f,-0.21000000f,-0.38000000f,-0.06000000f,0.43000000f,-0.48000000f,0.49000000f,-0.79000000f,0.31000000f,-0.91000000f,0.34000000f,0.89000000f,0.10000000f,0.50000000f,0.48000000f,0.29000000f,0.00000000f,0.24000000f,0.50000000f,0.56000000f,-0.73000000f,-0.10000000f,0.23000000f,0.29000000f,0.59000000f,-0.02000000f,-0.76000000f,-0.46000000f,-0.97000000f,-0.06000000f,-0.46000000f,0.51000000f,0.14000000f,0.97000000f,-0.37000000f,0.65000000f,-0.74000000f,-0.20000000f,-0.29000000f,0.57000000f,-0.80000000f,-0.34000000f,-0.33000000f,0.17000000f,-0.86000000f,0.58000000f,-0.85000000f,-0.08000000f,0.09000000f,-0.88000000f,0.57000000f,-0.78000000f,-0.55000000f,-0.72000000f,0.18000000f,-0.45000000f,0.37000000f,-0.51000000f,-0.77000000f,0.83000000f,-0.39000000f,0.73000000f,-0.87000000f,-0.18000000f,-0.95000000f,0.94000000f,-0.21000000f,0.70000000f,0.56000000f,0.25000000f,0.99000000f,0.14000000f,0.18000000f,-0.35000000f,0.72000000f,0.09000000f,0.98000000f,0.85000000f,0.10000000f,0.97000000f,0.42000000f,-0.15000000f,-0.85000000f,0.89000000f,0.67000000f,0.99000000f,-0.08000000f,0.32000000f,0.08000000f,0.55000000f,0.96000000f,-0.52000000f,-0.63000000f,-0.21000000f,-0.50000000f,0.79000000f,0.10000000f,0.61000000f,-0.96000000f,-0.47000000f,0.59000000f,-0.02000000f,-0.39000000f,0.89000000f,0.31000000f,0.94000000f,-0.84000000f,0.47000000f,0.79000000f,0.82000000f,-0.18000000f,-0.41000000f,-0.22000000f,-0.99000000f,-0.68000000f,-0.35000000f,0.86000000f,0.16000000f,0.68000000f,0.05000000f,-0.11000000f,-0.65000000f,0.23000000f,-0.81000000f,-0.92000000f,-0.70000000f,0.60000000f,-0.65000000f,-0.37000000f,-0.23000000f,0.10000000f,0.15000000f,0.19000000f,-0.03000000f,0.74000000f,-0.07000000f,0.12000000f,-0.49000000f,0.67000000f,-0.91000000f,0.38000000f,0.53000000f,0.86000000f,-0.41000000f,-0.39000000f,-0.79000000f,-0.48000000f,-0.83000000f,-0.58000000f,0.18000000f,-0.96000000f,-0.77000000f,-0.47000000f,-0.38000000f,0.32000000f,0.23000000f,0.85000000f,0.35000000f,0.40000000f,-0.27000000f,0.66000000f,0.62000000f,0.65000000f,-0.94000000f,-0.69000000f,-0.93000000f,0.69000000f,-0.20000000f,0.05000000f,-0.67000000f,-0.18000000f,-0.36000000f,-0.31000000f,0.15000000f,-0.01000000f,0.86000000f,-0.72000000f,-0.94000000f,0.41000000f,-0.22000000f,-0.86000000f,-0.56000000f,0.69000000f,0.09000000f,-0.00000000f,-0.80000000f,0.05000000f,0.98000000f,0.95000000f,0.46000000f,-0.33000000f,-0.38000000f,-0.04000000f,-0.53000000f,-0.12000000f,0.82000000f,-0.55000000f,-0.79000000f,0.10000000f,-0.14000000f,-0.68000000f,-0.29000000f,0.14000000f,0.93000000f,0.64000000f,0.97000000f,0.37000000f,0.69000000f,0.73000000f,-0.57000000f,0.11000000f,-0.75000000f,-0.07000000f,0.74000000f,0.25000000f,-0.57000000f,0.67000000f,0.60000000f,-0.26000000f,-0.35000000f,-0.19000000f,0.55000000f,0.42000000f,-0.62000000f,0.63000000f,-0.87000000f,-0.82000000f,0.60000000f,-0.10000000f,-0.67000000f,0.89000000f,-0.38000000f,0.29000000f,0.30000000f,0.81000000f,0.95000000f,0.43000000f,-0.64000000f,0.91000000f,0.37000000f,0.96000000f,-0.71000000f,0.55000000f,0.06000000f,-0.95000000f,-0.56000000f,0.34000000f,0.25000000f,0.05000000f,0.26000000f,0.28000000f,0.95000000f,0.68000000f,-0.63000000f,-0.80000000f,0.63000000f,-0.09000000f,-0.06000000f,0.26000000f,-0.34000000f,-0.27000000f,-0.57000000f,0.99000000f,-0.48000000f,0.10000000f,0.96000000f,-0.17000000f,0.70000000f,-0.76000000f,-0.49000000f,0.37000000f,-0.81000000f,-0.05000000f,-0.67000000f,0.70000000f,-0.94000000f,-0.15000000f,-0.98000000f,0.03000000f,-0.77000000f,0.97000000f,-0.61000000f,-0.32000000f,0.63000000f,-0.01000000f,-0.42000000f,-0.89000000f,0.41000000f,0.14000000f,0.11000000f,-0.61000000f,-0.05000000f,0.32000000f,0.21000000f,0.64000000f,0.36000000f,-0.44000000f,0.05000000f,-0.33000000f,0.19000000f,-0.43000000f,-0.40000000f,-0.89000000f,0.90000000f,0.67000000f,0.66000000f,-0.37000000f,-0.67000000f,-0.63000000f,0.93000000f,0.29000000f,0.28000000f,0.41000000f,0.17000000f,-0.76000000f,-0.61000000f,-0.48000000f,-0.86000000f,-0.13000000f,-0.55000000f,0.96000000f,-0.06000000f,-0.14000000f,0.97000000f,0.86000000f,-0.20000000f,0.88000000f,0.40000000f,0.64000000f,0.79000000f,0.47000000f,-0.09000000f,-0.26000000f,-0.31000000f,0.74000000f,-0.09000000f,-0.49000000f,0.64000000f,-0.40000000f,-0.31000000f,-0.87000000f,-0.68000000f,0.40000000f,-0.44000000f,0.19000000f,0.10000000f,-0.69000000f,0.42000000f,-0.59000000f,0.84000000f,-0.39000000f,-0.85000000f,0.33000000f,0.44000000f,0.12000000f,0.69000000f,0.02000000f,-0.71000000f,0.57000000f,-0.16000000f,-0.67000000f,0.53000000f,-0.95000000f,0.37000000f,0.42000000f,0.40000000f,0.76000000f,-0.61000000f,0.02000000f,0.77000000f,0.66000000f,0.54000000f,-0.37000000f,-0.76000000f,-0.56000000f,0.77000000f,0.57000000f,0.99000000f,-0.02000000f,0.00000000f,0.54000000f,0.19000000f,0.89000000f,-0.32000000f,-0.00000000f,-0.74000000f,-0.82000000f,0.43000000f,0.42000000f,0.35000000f,-0.81000000f,0.68000000f,-0.52000000f,-0.17000000f,0.18000000f,0.29000000f,0.76000000f,-0.73000000f,0.01000000f,-0.28000000f,0.04000000f,0.21000000f,0.89000000f,-0.40000000f,0.04000000f,0.13000000f,-0.95000000f,0.33000000f,0.47000000f,0.18000000f,0.61000000f,-0.83000000f,-0.08000000f,-0.08000000f,-0.75000000f,0.30000000f,0.42000000f,0.76000000f,0.25000000f,0.18000000f,-0.84000000f,0.11000000f,-0.94000000f,-0.42000000f,-0.16000000f,-0.97000000f,0.54000000f,0.11000000f,0.37000000f,0.10000000f,-0.39000000f,-0.20000000f,0.09000000f,0.04000000f,-0.92000000f,0.97000000f,0.98000000f,-0.78000000f,0.58000000f,-0.74000000f,0.92000000f,-0.27000000f,0.16000000f,-0.42000000f,-0.31000000f,0.39000000f,0.23000000f,-0.65000000f,0.24000000f,-0.92000000f,0.52000000f,0.98000000f,0.39000000f,0.51000000f,0.98000000f,-0.98000000f,0.34000000f,0.68000000f,-0.84000000f,0.41000000f,-0.87000000f,0.55000000f,0.39000000f,0.16000000f,0.37000000f,0.01000000f,0.82000000f,0.91000000f,-0.82000000f,-0.76000000f,0.65000000f,-0.45000000f,0.44000000f,0.07000000f,-0.46000000f,0.64000000f,-0.63000000f,-0.11000000f,0.54000000f,-0.92000000f,-0.11000000f,-0.94000000f,-0.78000000f,-0.88000000f,0.68000000f,-0.11000000f,0.78000000f,0.28000000f,-0.08000000f,0.99000000f,0.27000000f,0.73000000f,-0.55000000f,0.05000000f,0.69000000f,-0.69000000f,-0.83000000f,0.70000000f,-0.24000000f,0.26000000f,-0.86000000f,0.69000000f,0.91000000f,0.43000000f,0.84000000f,-0.60000000f,0.31000000f,0.74000000f,0.57000000f,-0.93000000f,-0.85000000f,-0.74000000f,0.73000000f,-0.15000000f,0.30000000f,0.70000000f,-0.15000000f,0.09000000f,-0.46000000f,0.59000000f,0.05000000f,0.34000000f,0.33000000f,0.17000000f,-0.08000000f,0.03000000f,-0.60000000f,0.93000000f,0.11000000f,-0.13000000f,-0.65000000f,-0.19000000f,0.49000000f,0.82000000f,-0.77000000f,0.22000000f,-0.02000000f,0.79000000f,0.06000000f,0.16000000f,-0.79000000f,-0.30000000f,-0.48000000f,0.62000000f,-0.12000000f,-0.95000000f,-0.87000000f,-0.94000000f,-0.90000000f,-0.33000000f,0.60000000f,-0.21000000f,0.88000000f,-0.28000000f,0.46000000f,-0.14000000f,0.13000000f,-0.11000000f,-0.17000000f,-0.03000000f,0.19000000f,-0.04000000f,-0.34000000f,-0.14000000f,0.65000000f,-0.35000000f,-0.66000000f,-0.75000000f,0.25000000f,-0.91000000f,-0.45000000f,-0.59000000f,0.32000000f,0.75000000f,-0.24000000f,-0.14000000f,0.10000000f,-0.24000000f,0.03000000f,-0.83000000f,0.90000000f,0.08000000f,0.09000000f,0.65000000f,-0.39000000f,-0.80000000f,0.26000000f,0.36000000f,-0.14000000f,-0.53000000f,0.21000000f,-0.06000000f,0.63000000f,0.94000000f,-0.86000000f,0.30000000f,0.91000000f,-0.01000000f,-0.61000000f,0.67000000f,-0.44000000f,-0.57000000f,0.28000000f,0.83000000f,-0.46000000f,-0.18000000f,-0.27000000f,-0.25000000f,0.43000000f,0.55000000f,-0.74000000f,-0.39000000f,0.51000000f,0.62000000f,0.70000000f,0.17000000f,0.61000000f,-0.87000000f,-0.76000000f,-0.28000000f,0.80000000f,-0.09000000f,0.48000000f,-0.68000000f,0.46000000f,0.76000000f,0.73000000f,-0.06000000f,0.15000000f,0.01000000f,0.84000000f,-0.71000000f,0.43000000f,-0.82000000f,0.77000000f,-0.86000000f,0.30000000f,0.01000000f,-0.03000000f,-0.79000000f,-0.96000000f,0.75000000f,0.36000000f,-0.18000000f,-0.23000000f,0.79000000f,0.36000000f,-0.77000000f,0.96000000f,0.60000000f,0.11000000f,-0.73000000f,-0.44000000f,-0.15000000f,-0.54000000f,0.94000000f,-0.54000000f,0.73000000f,0.43000000f,0.70000000f,-0.02000000f,-0.47000000f,0.14000000f,-0.07000000f,-0.78000000f,-0.12000000f,0.61000000f,-0.65000000f,0.28000000f,-0.66000000f,-0.56000000f,0.76000000f,0.56000000f,0.52000000f,-0.43000000f,0.31000000f,0.11000000f,-0.94000000f,0.04000000f,-0.52000000f,-0.37000000f,0.86000000f,-0.74000000f,-0.38000000f,-0.40000000f,0.41000000f,-0.40000000f,0.09000000f,-0.07000000f,-0.79000000f,-0.08000000f,-0.32000000f,-0.87000000f,-0.31000000f,0.21000000f,-0.58000000f,-0.18000000f,-0.86000000f,0.29000000f,-0.28000000f,0.30000000f,-0.52000000f,0.41000000f,0.66000000f,0.10000000f,-0.40000000f,0.70000000f,0.29000000f,-0.20000000f,-0.25000000f,0.33000000f,0.32000000f,-0.14000000f,0.39000000f,-0.41000000f,0.65000000f,-0.88000000f,0.82000000f,0.34000000f,-0.80000000f,0.06000000f,0.86000000f,-0.69000000f,-0.84000000f,-0.36000000f,0.43000000f,0.25000000f,-0.80000000f,0.84000000f,0.19000000f,-0.80000000f,0.53000000f,-0.53000000f,0.04000000f,-0.54000000f,-0.26000000f,-0.59000000f,0.21000000f,-0.45000000f,0.53000000f,-0.17000000f,0.52000000f,0.35000000f,0.72000000f,0.16000000f,-0.31000000f,0.12000000f,-0.03000000f,-0.92000000f,0.02000000f,0.27000000f,0.52000000f,0.34000000f,-0.66000000f,-0.46000000f,-0.14000000f,0.81000000f,0.00000000f,0.92000000f,-0.49000000f,0.80000000f,0.40000000f,-0.90000000f,0.34000000f,0.12000000f,0.47000000f,0.16000000f,-0.66000000f,-0.83000000f,0.30000000f,0.10000000f,-0.99000000f,0.95000000f,0.61000000f,0.92000000f,0.90000000f,-0.46000000f,0.99000000f,0.38000000f,0.38000000f,0.79000000f,-0.33000000f,0.28000000f,0.69000000f,0.44000000f,-0.18000000f,-0.66000000f,0.07000000f,0.65000000f,-0.06000000f,-0.24000000f,-0.70000000f,0.01000000f,-0.31000000f,-0.40000000f,0.19000000f,0.93000000f,-0.52000000f,-0.29000000f,-0.59000000f,-0.55000000f,-0.57000000f,-0.61000000f,-0.51000000f,0.99000000f,0.22000000f,0.51000000f,0.71000000f,0.39000000f,0.59000000f,0.38000000f,0.02000000f,-0.98000000f,0.56000000f,-0.04000000f,-0.02000000f,0.44000000f,-0.85000000f,-0.70000000f,-0.70000000f,-0.02000000f,-0.09000000f,-0.96000000f,0.72000000f,0.25000000f,-0.20000000f,0.15000000f,0.68000000f,-0.90000000f,-0.91000000f,-0.99000000f,-0.21000000f,-0.59000000f,-0.38000000f,-0.02000000f,-0.84000000f,-0.50000000f,0.68000000f,-0.22000000f,-0.88000000f,0.25000000f,0.98000000f,-0.10000000f,-0.37000000f,-0.14000000f,0.70000000f,0.03000000f,0.45000000f,0.17000000f,-0.01000000f,0.33000000f,-0.15000000f,0.03000000f,-0.66000000f,-0.05000000f,-0.10000000f,0.35000000f,-0.00000000f,-0.12000000f,-0.79000000f,0.76000000f,0.29000000f,-0.27000000f,0.79000000f,-0.57000000f,0.62000000f,0.65000000f,0.84000000f,-0.17000000f,0.23000000f,0.74000000f,0.98000000f,-0.24000000f,-0.96000000f,-0.16000000f,0.76000000f,-0.22000000f,0.35000000f,-0.39000000f,0.67000000f,0.59000000f,0.91000000f,0.88000000f,0.69000000f,-0.72000000f,0.43000000f,0.55000000f,-0.55000000f,0.94000000f,0.34000000f,-0.74000000f,-0.44000000f,-0.48000000f,-0.92000000f,-0.62000000f,0.79000000f,0.52000000f,-0.59000000f,-0.14000000f,-0.20000000f,0.14000000f,0.65000000f,-0.27000000f,0.71000000f,-0.80000000f,0.29000000f,-0.15000000f,0.15000000f,0.30000000f,-0.65000000f,-0.17000000f,-0.72000000f,-0.90000000f,0.99000000f,-0.20000000f,0.40000000f,-0.59000000f,0.46000000f,-0.69000000f,0.97000000f,-0.86000000f,0.35000000f,-0.96000000f,0.22000000f,0.26000000f,-0.87000000f,-0.46000000f,-0.54000000f,0.30000000f,0.28000000f,0.63000000f,0.43000000f,-0.87000000f,-0.16000000f,0.40000000f,0.07000000f,-0.04000000f,0.67000000f,-0.30000000f,-0.45000000f,0.88000000f,0.92000000f,0.05000000f,0.24000000f,0.18000000f,-0.29000000f,0.26000000f,0.57000000f,-0.35000000f,0.49000000f,-0.16000000f,0.32000000f,-0.79000000f,-0.29000000f,-0.87000000f,-0.72000000f,0.40000000f,-0.44000000f,-0.69000000f,-0.93000000f,-0.85000000f,0.92000000f,0.00000000f,0.66000000f,-0.32000000f,0.94000000f,0.40000000f,0.81000000f,0.67000000f,-0.72000000f,-0.11000000f,0.82000000f,-0.83000000f,-0.53000000f,-0.01000000f,0.18000000f,-0.95000000f,-0.41000000f,-0.98000000f,-0.08000000f,0.24000000f,-0.33000000f,0.72000000f,-0.81000000f,0.21000000f,0.46000000f,0.25000000f,-0.74000000f,0.78000000f,0.68000000f,-0.20000000f,-0.66000000f,0.73000000f,-0.09000000f,0.98000000f,0.50000000f,0.38000000f,0.95000000f,-0.79000000f,0.47000000f,0.95000000f,-0.28000000f,-0.03000000f,0.15000000f,0.25000000f,0.61000000f,0.10000000f,-0.42000000f,0.98000000f,-0.93000000f,-0.47000000f,-0.03000000f,0.31000000f,0.50000000f,-0.24000000f,0.42000000f,-0.03000000f,-0.75000000f,0.75000000f,0.86000000f,0.07000000f,0.79000000f,0.39000000f,0.58000000f,-0.09000000f,-0.04000000f,0.63000000f,-0.49000000f,0.89000000f,0.64000000f,0.14000000f,-0.70000000f,0.04000000f,-0.24000000f,0.42000000f,0.98000000f,-0.88000000f,-0.86000000f,0.43000000f,-0.17000000f,-0.79000000f,-0.15000000f,-0.43000000f,0.97000000f,-0.88000000f,-0.97000000f,0.87000000f,-0.61000000f,0.56000000f,0.53000000f,0.94000000f,0.26000000f,-0.71000000f,0.68000000f,-0.19000000f,0.87000000f,0.00000000f,-0.02000000f,0.33000000f,0.91000000f,-0.36000000f,0.60000000f,-0.55000000f,-0.04000000f,-0.58000000f,-0.07000000f,0.18000000f,0.42000000f,-0.77000000f,-0.66000000f,-0.90000000f,-0.23000000f,-0.94000000f,0.90000000f,-0.37000000f,-0.63000000f,0.57000000f,0.98000000f,-0.46000000f,-0.47000000f,0.79000000f,0.63000000f,-0.05000000f,-0.39000000f,-0.51000000f,0.22000000f,0.23000000f,-0.89000000f,-0.01000000f,0.98000000f,-0.59000000f,-0.85000000f,0.12000000f,0.24000000f,0.63000000f,-0.69000000f,0.84000000f,-0.15000000f,0.48000000f,-0.16000000f,0.14000000f,0.78000000f,0.84000000f,0.86000000f,-0.80000000f,-0.05000000f,-0.42000000f,0.32000000f,-0.39000000f,-0.27000000f,0.85000000f,-0.58000000f,0.96000000f,-0.53000000f,-0.40000000f,-0.75000000f,0.76000000f,-0.87000000f,-0.39000000f,0.73000000f,0.48000000f,0.87000000f,-0.49000000f,0.94000000f,-0.25000000f,-0.19000000f,-0.30000000f,0.56000000f,-0.35000000f,0.09000000f,0.62000000f,0.02000000f,0.07000000f,-0.32000000f,0.83000000f,0.87000000f,0.96000000f,0.50000000f,0.16000000f,0.12000000f,-0.21000000f,-0.77000000f,-0.69000000f,0.95000000f,-0.84000000f,-0.93000000f,-0.83000000f,0.68000000f,0.06000000f,0.48000000f,-0.95000000f,0.44000000f,0.62000000f,0.21000000f,-0.62000000f,-0.11000000f,0.21000000f,-0.74000000f,-0.04000000f,0.07000000f,0.47000000f,-0.07000000f,-0.27000000f,0.71000000f,0.70000000f,-0.55000000f,0.13000000f,-0.50000000f,0.63000000f,-0.51000000f,0.48000000f,-0.19000000f,0.17000000f,-0.34000000f,-0.87000000f,-0.28000000f,-0.71000000f,0.16000000f,-0.56000000f,0.39000000f,-0.14000000f,0.26000000f,-0.09000000f,-0.48000000f,-0.10000000f,0.50000000f,-0.83000000f,0.02000000f,-0.39000000f,0.19000000f,0.10000000f,0.73000000f,-0.43000000f,-0.47000000f,0.79000000f,0.75000000f,0.89000000f,-0.38000000f,-0.72000000f,-0.93000000f,-0.22000000f,-0.00000000f,0.43000000f,0.07000000f,-0.96000000f,0.08000000f,0.63000000f,-0.55000000f,-0.55000000f,0.83000000f,-0.12000000f,-0.70000000f,0.03000000f,-0.51000000f,0.61000000f,0.49000000f,0.95000000f,0.93000000f,0.69000000f,0.88000000f,-0.10000000f,0.50000000f,-0.05000000f,-0.59000000f,0.36000000f,-0.85000000f,-0.02000000f,-0.02000000f,0.75000000f,-0.77000000f,-0.49000000f,0.16000000f,0.75000000f,-0.08000000f,-0.44000000f,0.17000000f,-0.87000000f,-0.19000000f,-0.60000000f,0.03000000f,-0.30000000f,-0.21000000f,-0.58000000f,0.08000000f,-0.47000000f,-0.03000000f,0.39000000f,0.61000000f,0.71000000f,0.10000000f,0.18000000f,0.53000000f,-0.62000000f,-0.72000000f,0.72000000f,-0.87000000f,-0.45000000f,-0.57000000f,0.14000000f,0.65000000f,-0.14000000f,-0.65000000f,0.17000000f,-0.89000000f,-0.35000000f,0.22000000f,-0.82000000f,-0.23000000f,-0.56000000f,0.25000000f,0.82000000f,0.98000000f,0.24000000f,0.76000000f,-0.27000000f,-0.97000000f,-0.14000000f,-0.99000000f,0.95000000f,0.73000000f,-0.37000000f,-0.26000000f,0.73000000f,-0.51000000f,0.42000000f,-0.25000000f,0.76000000f,0.59000000f,-0.54000000f,0.18000000f,0.12000000f,0.41000000f,0.41000000f,-0.45000000f,0.44000000f,-0.26000000f,-0.10000000f,-0.21000000f,-0.33000000f,0.82000000f,-0.88000000f,0.33000000f,-0.83000000f,-0.47000000f,0.08000000f,0.36000000f,-0.59000000f,-0.77000000f,0.70000000f,-0.23000000f,0.72000000f,0.77000000f,-0.99000000f,0.36000000f,0.16000000f,0.62000000f,0.35000000f,-0.99000000f,0.99000000f,-0.32000000f,0.39000000f,-0.09000000f,0.15000000f,0.97000000f,-0.42000000f,-0.51000000f,-0.98000000f,-0.23000000f,-0.81000000f,-0.62000000f,0.36000000f,-0.63000000f,0.33000000f,-0.67000000f,-0.84000000f,0.17000000f,0.26000000f,-0.57000000f,0.77000000f,-0.86000000f,0.54000000f,-0.11000000f,0.97000000f,-0.29000000f,0.45000000f,-0.59000000f,-0.39000000f,0.21000000f,-0.40000000f,0.03000000f,0.36000000f,0.41000000f,0.56000000f,0.76000000f,0.71000000f,-0.62000000f,-0.49000000f,0.99000000f,0.03000000f,0.55000000f,-0.15000000f,0.03000000f,0.62000000f,-0.62000000f,-0.02000000f,-0.53000000f,0.64000000f,-0.24000000f,0.14000000f,0.67000000f,-0.58000000f,-0.90000000f,0.66000000f,0.44000000f,-0.15000000f,0.16000000f,0.92000000f,0.84000000f,0.61000000f,0.45000000f,0.01000000f,-0.23000000f,0.51000000f,0.65000000f,-0.04000000f,-0.61000000f,-0.66000000f,0.76000000f,-0.52000000f,0.63000000f,0.82000000f,0.67000000f,0.81000000f,-0.08000000f,0.14000000f,0.91000000f,0.20000000f,-0.82000000f,-0.90000000f,0.70000000f,0.65000000f,0.87000000f,0.38000000f,0.77000000f,0.52000000f,0.40000000f,-0.57000000f,0.19000000f,0.58000000f,0.50000000f,0.78000000f,-0.09000000f,-0.93000000f,0.67000000f,0.06000000f,0.11000000f,0.36000000f,-0.40000000f,0.37000000f,0.53000000f,0.01000000f,-0.09000000f,0.89000000f,-0.87000000f,0.99000000f,-0.54000000f,0.92000000f,-0.45000000f,0.69000000f,-0.22000000f,0.92000000f,-0.01000000f,0.04000000f,0.68000000f,-0.96000000f,-0.56000000f,0.26000000f,0.24000000f,0.77000000f,-0.31000000f,0.23000000f,0.26000000f,-0.09000000f,-0.12000000f,-0.57000000f,0.35000000f,-0.80000000f,0.36000000f,0.36000000f,0.55000000f,0.85000000f,-0.60000000f,0.12000000f,-0.96000000f,-0.54000000f,-0.58000000f,-0.21000000f,0.62000000f,0.60000000f,0.64000000f,0.70000000f,-0.14000000f,-0.63000000f,-0.14000000f,0.55000000f,0.25000000f,0.21000000f,-0.19000000f,0.42000000f,-0.61000000f,-0.08000000f,-0.38000000f,-0.86000000f,0.08000000f,0.48000000f,-0.58000000f,0.82000000f,0.14000000f,0.50000000f,0.81000000f,0.07000000f,0.24000000f,0.03000000f,0.54000000f,0.47000000f,-0.97000000f,-0.80000000f,-0.76000000f,-0.86000000f,0.80000000f,-0.14000000f,-0.04000000f,-0.54000000f,0.61000000f,-0.42000000f,-0.90000000f,0.94000000f,-0.84000000f,0.15000000f,-0.72000000f,0.52000000f,0.10000000f,-0.48000000f,0.42000000f,-0.63000000f,0.93000000f,-0.80000000f,-0.17000000f,-0.29000000f,-0.87000000f,-0.24000000f,0.99000000f,0.75000000f,0.78000000f,-0.39000000f,-0.94000000f,0.46000000f,0.34000000f,-0.93000000f,0.87000000f,-0.18000000f,0.20000000f,0.33000000f,0.91000000f,0.12000000f,0.62000000f,-0.19000000f,-0.50000000f,-0.20000000f,0.73000000f,0.81000000f,-0.04000000f,-0.26000000f,0.16000000f,-0.24000000f,0.60000000f,-0.69000000f,0.59000000f,0.18000000f,0.02000000f,-0.00000000f,-0.28000000f,0.48000000f,-0.29000000f,-0.97000000f,0.11000000f,-0.34000000f,-0.22000000f,0.74000000f,0.53000000f,0.11000000f,-0.97000000f,-0.50000000f,-0.46000000f,-0.96000000f,-0.93000000f,-0.02000000f,-0.23000000f,0.04000000f,-0.30000000f,-0.79000000f,-0.46000000f,0.03000000f,-0.18000000f,0.71000000f,0.73000000f,0.27000000f,0.76000000f,0.65000000f,0.52000000f,0.34000000f,0.54000000f,-0.36000000f,0.02000000f,0.90000000f,-0.24000000f,-0.44000000f,-0.81000000f,-0.22000000f,0.50000000f,-0.25000000f,-0.94000000f,0.91000000f,-0.57000000f,-0.38000000f,0.95000000f,-0.05000000f,0.46000000f,-0.74000000f,-0.88000000f,0.59000000f,0.86000000f,-0.52000000f,-0.32000000f,0.30000000f,-0.43000000f,0.68000000f,0.69000000f,-0.88000000f,0.92000000f,-0.29000000f,-0.78000000f,0.89000000f,-0.96000000f,-0.91000000f,-0.80000000f,0.14000000f,-0.36000000f,-0.86000000f,0.79000000f,-0.39000000f,-0.81000000f,0.86000000f,0.43000000f,-0.77000000f,0.44000000f,-0.40000000f,-0.91000000f,-0.43000000f,-0.29000000f,-0.23000000f,-0.07000000f,-0.76000000f,0.14000000f,0.88000000f,0.59000000f,-0.36000000f,-0.80000000f,-0.81000000f,0.74000000f,0.49000000f,-0.41000000f,0.10000000f,-0.45000000f,0.89000000f,0.99000000f,0.95000000f,-0.84000000f,-0.19000000f,-0.50000000f,-0.00000000f,0.17000000f,-0.27000000f,-0.14000000f,-0.27000000f,-0.34000000f,-0.22000000f,0.10000000f,0.78000000f,-0.90000000f,0.64000000f,0.98000000f,-0.78000000f,0.06000000f,0.61000000f,0.51000000f,-0.34000000f,0.70000000f,-0.17000000f,-0.65000000f,0.84000000f,-0.56000000f,-0.81000000f,0.26000000f,-0.08000000f,0.84000000f,0.64000000f,0.96000000f,-0.26000000f,0.73000000f,0.68000000f,0.71000000f,-0.53000000f,-0.04000000f,0.32000000f,0.99000000f,-0.73000000f,0.65000000f,-0.57000000f,0.44000000f,-0.66000000f,-0.20000000f,-0.43000000f,-0.54000000f,-0.97000000f,0.41000000f,0.24000000f,-0.53000000f,-0.55000000f,-0.26000000f,-0.71000000f,0.51000000f,0.83000000f,0.53000000f,0.01000000f,0.95000000f,0.45000000f,-0.40000000f,0.31000000f,0.59000000f,0.34000000f,-0.45000000f,-0.92000000f,-0.27000000f,0.54000000f,-0.14000000f,-0.87000000f,-0.60000000f,0.72000000f,-0.70000000f,-0.04000000f,0.18000000f,0.91000000f,0.68000000f,-0.15000000f,0.21000000f,0.86000000f,0.54000000f,-0.86000000f,0.70000000f,0.40000000f,0.64000000f,-0.82000000f,-0.70000000f,0.68000000f,0.96000000f,0.71000000f,0.84000000f,-0.89000000f,-0.47000000f,-0.63000000f,-0.75000000f,0.79000000f,-0.77000000f,0.14000000f,0.02000000f,0.19000000f,-0.84000000f,-0.19000000f,0.63000000f,0.32000000f,0.65000000f,-0.16000000f,0.44000000f,-0.23000000f,-0.01000000f,0.67000000f,0.85000000f,0.08000000f,0.32000000f,0.14000000f,0.70000000f,0.40000000f,-0.03000000f,-0.29000000f,0.78000000f,-0.17000000f,-0.68000000f,0.36000000f,0.28000000f,-0.48000000f,0.65000000f,0.74000000f,-0.37000000f,0.81000000f,-0.95000000f,-0.21000000f,0.04000000f,-0.23000000f,-0.24000000f,-0.27000000f,-0.93000000f,0.19000000f,-0.27000000f,-0.83000000f,0.19000000f,-0.21000000f,-0.08000000f,-0.19000000f,0.73000000f,0.26000000f,-0.97000000f,0.51000000f,0.92000000f,-0.53000000f,-0.18000000f,-0.54000000f,0.89000000f,-0.49000000f,-0.61000000f,-0.54000000f,-0.63000000f,-0.01000000f,-0.77000000f,0.96000000f,0.44000000f,-0.64000000f,0.63000000f,0.24000000f,-0.51000000f,0.67000000f,-0.16000000f,-0.99000000f,0.61000000f,0.73000000f,0.53000000f,0.84000000f,-0.06000000f,-0.39000000f,0.13000000f,0.40000000f,-0.26000000f,0.90000000f,0.94000000f,0.15000000f,0.71000000f,0.70000000f,-0.71000000f,-0.53000000f,0.74000000f,0.47000000f,-0.45000000f,0.45000000f,-0.24000000f,0.44000000f,0.90000000f,-0.71000000f,0.22000000f,0.32000000f,-0.61000000f,-0.78000000f,-0.66000000f,-0.44000000f,0.88000000f,-0.58000000f,0.57000000f,0.08000000f,0.57000000f,-0.61000000f,0.71000000f,-0.12000000f,0.49000000f,-0.41000000f,-0.69000000f,-0.47000000f,-0.46000000f,0.73000000f,-0.19000000f,-0.01000000f,0.44000000f,-0.41000000f,0.74000000f,0.15000000f,0.15000000f,0.10000000f,0.10000000f,0.59000000f,0.16000000f,-0.80000000f,-0.75000000f,0.79000000f,-0.22000000f,-0.75000000f,-0.05000000f,0.22000000f,-0.92000000f,-0.11000000f,-0.86000000f,0.81000000f,-0.29000000f,-0.08000000f,-0.78000000f,-0.65000000f,0.19000000f,-0.35000000f,-0.76000000f,0.91000000f,-0.55000000f,-0.39000000f,-0.23000000f,0.34000000f,-0.07000000f,-0.95000000f,0.10000000f,0.98000000f,-0.12000000f,-0.49000000f,-0.79000000f,-0.00000000f,0.57000000f,0.83000000f,0.21000000f,0.28000000f,0.33000000f,-0.87000000f,0.60000000f,-0.00000000f,-0.82000000f,-0.00000000f,0.61000000f,0.06000000f,0.45000000f,0.65000000f,0.75000000f,0.04000000f,-0.21000000f,-0.92000000f,0.25000000f,-0.11000000f,-0.52000000f,0.79000000f,0.19000000f,0.48000000f,-0.79000000f,-0.26000000f,0.47000000f,0.05000000f,0.98000000f,0.89000000f,-0.58000000f,-0.03000000f,0.22000000f,0.20000000f,0.17000000f,-0.96000000f,0.13000000f,0.92000000f,-0.31000000f,-0.81000000f,-0.30000000f,-0.60000000f,0.30000000f,0.78000000f,0.86000000f,-0.40000000f,0.23000000f,-0.36000000f,-0.35000000f,-0.69000000f,0.93000000f,0.94000000f,0.52000000f,0.38000000f,0.33000000f,-0.97000000f,-0.28000000f,0.80000000f,0.47000000f,-0.27000000f,0.06000000f,0.25000000f,-0.74000000f,0.57000000f,0.04000000f,-0.93000000f,0.88000000f,0.65000000f,0.68000000f,0.95000000f,-0.69000000f,0.58000000f,-0.67000000f,0.73000000f,0.85000000f,-0.35000000f,-0.10000000f,-0.38000000f,-0.57000000f,0.67000000f,0.79000000f,-0.24000000f,0.60000000f,0.89000000f,-0.85000000f,0.20000000f,0.11000000f,0.14000000f,-0.02000000f,0.53000000f,-0.56000000f,0.39000000f,-0.27000000f,0.43000000f,0.43000000f,-0.41000000f,-0.25000000f,0.00000000f,-0.13000000f,0.26000000f,0.08000000f,0.39000000f,0.07000000f,0.04000000f,0.70000000f,0.49000000f,-0.28000000f,0.19000000f,-0.48000000f,0.29000000f,0.52000000f,-0.99000000f,0.40000000f,0.04000000f,0.47000000f,0.54000000f,0.32000000f,0.48000000f,0.66000000f,0.51000000f,0.29000000f,-0.58000000f,-0.93000000f,0.03000000f,-0.23000000f,0.62000000f,-0.33000000f,-0.51000000f,-0.63000000f,0.22000000f,0.47000000f,0.26000000f,-0.04000000f,-0.50000000f,0.25000000f,-0.61000000f,0.92000000f,-0.52000000f,0.97000000f,-0.12000000f,0.98000000f,-0.12000000f,0.20000000f,-0.04000000f,-0.78000000f,-0.69000000f,-0.06000000f,-0.55000000f,0.38000000f,-0.19000000f,-0.35000000f,0.84000000f,0.46000000f,0.68000000f,0.17000000f,0.27000000f,0.32000000f,0.79000000f,0.37000000f,-0.16000000f,-0.39000000f,0.55000000f,-0.49000000f,-0.70000000f,-0.67000000f,-0.53000000f,0.80000000f,0.35000000f,-0.96000000f,-0.06000000f,0.63000000f,-0.50000000f,-0.16000000f,0.35000000f,0.39000000f,0.51000000f,0.65000000f,-0.12000000f,0.24000000f,-0.88000000f,0.08000000f,0.56000000f,0.92000000f,-0.77000000f,0.93000000f,0.79000000f,-0.06000000f,-0.82000000f,0.00000000f,-0.67000000f,0.49000000f,0.83000000f,0.35000000f,-0.47000000f,-0.67000000f,-0.94000000f,-0.23000000f,0.71000000f,-0.06000000f,-0.06000000f,0.98000000f,-0.94000000f,-0.79000000f,0.03000000f,-0.43000000f,-0.64000000f,-0.27000000f,-0.32000000f,-0.78000000f,0.40000000f,-0.39000000f,0.96000000f,0.81000000f,0.36000000f,-0.64000000f,0.41000000f,0.97000000f,-0.08000000f,0.01000000f,0.31000000f,-0.08000000f,-0.85000000f,-0.09000000f,-0.40000000f,-0.91000000f,-0.11000000f,-0.29000000f,0.79000000f,-0.40000000f,-0.20000000f,-0.92000000f,0.72000000f,-0.25000000f,0.40000000f,-0.20000000f,0.47000000f,-0.52000000f,0.86000000f,0.68000000f,-0.68000000f,0.15000000f,0.99000000f,0.30000000f,-0.99000000f,-0.51000000f,0.44000000f,-0.96000000f,-0.71000000f,0.83000000f,-0.37000000f,-0.12000000f,-0.58000000f,-0.11000000f,0.60000000f,-0.96000000f,-0.35000000f,-0.13000000f,0.52000000f,0.99000000f,-0.94000000f,-0.49000000f,-0.88000000f,-0.50000000f,0.11000000f,-0.79000000f,-0.04000000f,-0.03000000f,-0.60000000f,-0.16000000f,-0.93000000f,-0.85000000f,-0.73000000f,-0.47000000f,-0.22000000f,-0.27000000f,-0.52000000f,0.19000000f,-0.39000000f,0.96000000f,-0.23000000f,0.72000000f,-0.19000000f,-0.71000000f,0.00000000f,-0.78000000f,0.55000000f,0.90000000f,0.47000000f,-0.33000000f,-0.02000000f,0.04000000f,-0.66000000f,-0.34000000f,-0.32000000f,-0.34000000f,0.34000000f,-0.93000000f,0.38000000f,-0.43000000f,0.70000000f,0.90000000f,-0.76000000f,-0.16000000f,0.54000000f,-0.30000000f,0.57000000f,0.20000000f,-0.68000000f,0.62000000f,0.03000000f,0.58000000f,0.41000000f,-0.59000000f,0.54000000f,0.96000000f,-0.04000000f,-0.84000000f,-0.34000000f,-0.76000000f,0.89000000f,-0.86000000f,-0.84000000f,-0.22000000f,-0.61000000f,-0.64000000f,-0.25000000f,0.07000000f,-0.37000000f,-0.85000000f,-0.41000000f,0.59000000f,0.11000000f,-0.97000000f,0.68000000f,0.28000000f,-0.42000000f,-0.19000000f,0.79000000f,-0.46000000f,0.42000000f,0.83000000f,0.97000000f,-0.18000000f,0.16000000f,-0.04000000f,-0.22000000f,0.04000000f,0.14000000f,0.96000000f,0.61000000f,0.72000000f,-0.71000000f,0.23000000f,-0.85000000f,0.06000000f,0.20000000f,-0.72000000f,0.31000000f,0.84000000f,-0.57000000f,-0.23000000f,-0.31000000f,0.17000000f,0.39000000f,0.56000000f,0.31000000f,0.46000000f,-0.15000000f,-0.11000000f,-0.86000000f,0.51000000f,-0.43000000f,-0.63000000f,0.65000000f,0.51000000f,-0.54000000f,-0.58000000f,0.13000000f,0.55000000f,-0.77000000f,-0.64000000f,-0.81000000f,0.18000000f,-0.08000000f,0.21000000f,-0.13000000f,0.18000000f,0.64000000f,0.55000000f,-0.73000000f,-0.35000000f,0.39000000f,-0.79000000f,0.68000000f,0.52000000f,-0.68000000f,0.69000000f,0.42000000f,-0.64000000f,-0.98000000f,0.76000000f,-0.56000000f,0.76000000f,-0.06000000f,-0.64000000f,-0.99000000f,-0.16000000f,0.19000000f,0.90000000f,-0.31000000f,-0.98000000f,-0.71000000f,-0.36000000f,-0.19000000f,-0.03000000f,0.98000000f,-0.34000000f,-0.50000000f,0.91000000f,-0.38000000f,0.20000000f,-0.13000000f,0.62000000f,-0.09000000f,0.66000000f,-0.69000000f,0.25000000f,-0.81000000f,-0.20000000f,-0.16000000f,-0.23000000f,0.26000000f,0.69000000f,0.05000000f,-0.88000000f,-0.71000000f,-0.02000000f,0.96000000f,0.56000000f,0.48000000f,-0.50000000f,-0.68000000f,-0.83000000f,-0.17000000f,0.38000000f,0.48000000f,0.04000000f,-0.05000000f,-0.47000000f,0.46000000f,0.85000000f,0.13000000f,0.08000000f,0.39000000f,0.89000000f,-0.36000000f,0.05000000f,-0.60000000f,-0.95000000f,-0.95000000f,0.08000000f,0.76000000f,0.82000000f,-0.62000000f,0.32000000f,-0.09000000f,0.55000000f,-0.26000000f,0.08000000f,-0.88000000f,-0.93000000f,-0.96000000f,0.26000000f,0.08000000f,0.98000000f,0.40000000f,0.34000000f,-0.34000000f,-0.38000000f,0.35000000f,0.68000000f,0.28000000f,-0.58000000f,0.66000000f,0.30000000f,-0.66000000f,-0.25000000f,0.42000000f,0.05000000f,-0.19000000f,0.33000000f,0.47000000f,0.39000000f,-0.03000000f,0.63000000f,0.09000000f,0.65000000f,0.83000000f,-0.67000000f,-0.86000000f,0.72000000f,-0.20000000f,0.35000000f,-0.88000000f,-0.37000000f,-0.52000000f,-0.29000000f,-0.83000000f,-0.02000000f,-0.08000000f,0.25000000f,-0.75000000f,0.42000000f,-0.23000000f,-0.37000000f,0.48000000f,-0.75000000f,-0.11000000f,0.87000000f,0.87000000f,0.03000000f,0.33000000f,-0.26000000f,-0.43000000f,0.65000000f,0.45000000f,0.77000000f,0.99000000f,-0.52000000f,0.97000000f,-0.72000000f,0.74000000f,0.38000000f,0.86000000f,-0.26000000f,0.81000000f,0.94000000f,0.28000000f,0.16000000f,-0.69000000f,-0.50000000f,-0.78000000f,-0.40000000f,0.11000000f,-0.10000000f,0.89000000f,0.88000000f,0.57000000f,-0.75000000f,-0.55000000f,-0.49000000f,0.06000000f,0.18000000f,-0.56000000f,0.18000000f,0.92000000f,-0.63000000f,0.94000000f,0.01000000f,0.39000000f,0.46000000f,0.44000000f,0.90000000f,0.16000000f,0.77000000f,-0.58000000f,-0.69000000f,0.88000000f,0.12000000f,0.10000000f,0.27000000f,-0.89000000f,-0.94000000f,-0.64000000f,0.55000000f,-0.87000000f,-0.70000000f,-0.47000000f,0.93000000f,0.73000000f,-0.87000000f,-0.20000000f,-0.21000000f,0.61000000f,-0.98000000f,-0.67000000f,-0.45000000f,0.82000000f,0.77000000f,-0.38000000f,-0.29000000f,-0.61000000f,-0.78000000f,0.93000000f,-0.74000000f,-0.48000000f,0.51000000f,0.03000000f,0.73000000f,-0.53000000f,-0.55000000f,0.99000000f,0.08000000f,0.99000000f,0.88000000f,0.57000000f,0.04000000f,-0.98000000f,0.12000000f,-0.39000000f,0.47000000f,-0.54000000f,-0.65000000f,-0.29000000f,-0.51000000f,-0.92000000f,-0.23000000f,0.73000000f,-0.76000000f,0.50000000f,0.11000000f,0.38000000f,-0.44000000f,0.04000000f,-0.40000000f,-0.27000000f,-0.95000000f,-0.83000000f,0.77000000f,-0.20000000f,-0.27000000f,-0.36000000f,0.59000000f,0.65000000f,-0.69000000f,-0.53000000f,-0.86000000f,-0.55000000f,-0.68000000f,0.80000000f,0.55000000f,0.69000000f,-0.41000000f,-0.49000000f,0.95000000f,0.99000000f,0.01000000f,-0.17000000f,-0.72000000f,-0.70000000f,-0.05000000f,-0.56000000f,0.92000000f,-0.37000000f,0.00000000f,-0.38000000f,-0.18000000f,-0.63000000f,-0.46000000f,-0.45000000f,0.82000000f,0.54000000f,0.31000000f,0.41000000f,-0.00000000f,0.08000000f,-0.91000000f,0.16000000f,0.35000000f,-0.62000000f,-0.36000000f,0.22000000f,0.26000000f,-0.31000000f,-0.91000000f,0.48000000f,0.41000000f,0.87000000f,-0.34000000f,0.69000000f,0.24000000f,-0.83000000f,0.90000000f,0.76000000f,0.17000000f,0.11000000f,0.85000000f,0.03000000f,-0.66000000f,-0.29000000f,0.58000000f,0.31000000f,-0.87000000f,-0.90000000f,-0.48000000f,0.21000000f,-0.34000000f,-0.87000000f,0.60000000f,0.91000000f,-0.85000000f,-0.59000000f,0.20000000f,0.64000000f,-0.55000000f,-0.20000000f,0.77000000f,-0.70000000f,0.36000000f,0.44000000f,-0.66000000f,-0.12000000f,-0.56000000f,-0.47000000f,0.37000000f,-0.45000000f,0.43000000f,0.93000000f,0.76000000f,0.03000000f,-0.42000000f,-0.12000000f,0.91000000f,-0.25000000f,-0.93000000f,-0.71000000f,0.00000000f,0.32000000f,0.41000000f,-0.72000000f,0.38000000f,-0.29000000f,-0.83000000f,0.71000000f,-0.73000000f,-0.68000000f,0.81000000f,0.83000000f,0.08000000f,0.74000000f,-0.37000000f,-0.17000000f,0.01000000f,-0.97000000f,-0.35000000f,-0.79000000f,0.80000000f,-0.27000000f,0.28000000f,-0.50000000f,-0.55000000f,0.70000000f,0.36000000f,0.68000000f,-0.25000000f,-0.08000000f,0.84000000f,-0.28000000f,-0.92000000f,0.54000000f,-0.50000000f,0.82000000f,0.23000000f,-0.01000000f,0.09000000f,0.61000000f,0.42000000f,-0.48000000f,0.01000000f,0.56000000f,0.96000000f,0.28000000f,0.67000000f,-0.48000000f,-0.98000000f,-0.56000000f,-0.05000000f,-0.55000000f,0.91000000f,0.77000000f,-0.98000000f,0.55000000f,0.89000000f,0.56000000f,0.58000000f,0.42000000f,0.87000000f,0.40000000f,0.28000000f,-0.51000000f,0.74000000f,0.99000000f,0.77000000f,0.55000000f,0.48000000f,0.58000000f,-0.28000000f,-0.16000000f,0.69000000f,0.19000000f,-0.15000000f,-0.67000000f,-0.89000000f,-0.63000000f,-0.49000000f,0.69000000f,0.14000000f,0.41000000f,0.37000000f,0.96000000f,0.11000000f,-0.89000000f,-0.19000000f,0.83000000f,0.67000000f,-0.51000000f,0.17000000f,-0.79000000f,0.53000000f,-0.27000000f,-0.41000000f,-0.93000000f,-0.01000000f,0.31000000f,0.17000000f,0.20000000f,0.79000000f,0.84000000f,0.90000000f,-0.02000000f,0.59000000f,-0.77000000f,-0.47000000f,0.59000000f,-0.99000000f,-0.88000000f,0.78000000f,0.43000000f,0.90000000f,0.08000000f,0.71000000f,-0.12000000f,0.91000000f,-0.82000000f,-0.86000000f,-0.61000000f,0.28000000f,0.35000000f,0.60000000f,0.55000000f,-0.60000000f,-0.67000000f,0.67000000f,0.99000000f,-0.30000000f,0.24000000f,0.47000000f,-0.17000000f,-0.82000000f,-0.22000000f,0.40000000f,0.01000000f,-0.75000000f,0.45000000f,0.38000000f,0.70000000f,-0.44000000f,0.96000000f,0.72000000f,0.12000000f,-0.58000000f,0.96000000f,-0.41000000f,-0.56000000f,-0.49000000f,-0.95000000f,-0.36000000f,0.62000000f,-0.10000000f,-0.65000000f,-0.51000000f,-0.13000000f,-0.44000000f,0.21000000f,0.75000000f,-0.82000000f,0.75000000f,-0.76000000f,0.20000000f,-0.63000000f,-0.95000000f,-0.10000000f,-0.30000000f,0.85000000f,0.59000000f,-0.76000000f,-0.36000000f,0.75000000f,-0.05000000f,-0.47000000f,-0.67000000f,-0.84000000f,-0.24000000f,-0.22000000f,0.24000000f,0.88000000f,-0.33000000f,-0.60000000f,-0.81000000f,-0.22000000f,-0.55000000f,-0.10000000f,0.84000000f,-0.52000000f,0.31000000f,0.31000000f,0.73000000f,-0.47000000f,0.08000000f,-0.78000000f,0.59000000f,0.27000000f,0.06000000f,0.74000000f,-0.58000000f,0.48000000f,-0.74000000f,-0.60000000f,-0.57000000f,0.16000000f,-0.91000000f,0.48000000f,-0.08000000f,0.42000000f,0.56000000f,-0.31000000f,-0.42000000f,-0.33000000f,0.88000000f,0.84000000f,0.72000000f,0.92000000f,0.36000000f,0.95000000f,-0.40000000f,0.77000000f,0.12000000f,-0.63000000f,-0.67000000f,-0.02000000f,-0.65000000f,0.53000000f,-0.98000000f,0.23000000f,-0.92000000f,-0.88000000f,-0.64000000f,0.84000000f,0.44000000f,-0.08000000f,-0.62000000f,-0.85000000f,-0.16000000f,0.61000000f,-0.11000000f,0.23000000f,0.01000000f,-0.37000000f,-0.36000000f,0.42000000f,-0.73000000f,0.43000000f,0.96000000f,-0.67000000f,0.41000000f,0.94000000f,-0.27000000f,0.04000000f,-0.46000000f,0.26000000f,0.01000000f,0.75000000f,-0.10000000f,-0.41000000f,-0.28000000f,0.57000000f,-0.55000000f,0.18000000f,-0.36000000f,-0.96000000f,-0.15000000f,-0.04000000f,0.80000000f,0.09000000f,-0.84000000f,0.06000000f,-0.63000000f,0.82000000f,0.47000000f,-0.17000000f,0.01000000f,-0.81000000f,0.44000000f,0.19000000f,-0.26000000f,0.88000000f,0.57000000f,-0.14000000f,-0.00000000f,0.34000000f,0.44000000f,-0.20000000f,-0.58000000f,-0.32000000f,0.17000000f,-0.98000000f,-0.29000000f,-0.08000000f,-0.53000000f,0.89000000f,-0.96000000f,-0.43000000f,0.87000000f,0.90000000f,0.25000000f,-0.00000000f,0.55000000f,0.73000000f,-0.28000000f,0.63000000f,-0.73000000f,0.61000000f,0.14000000f,0.51000000f,-0.15000000f,0.90000000f,0.15000000f,-0.24000000f,0.48000000f,-0.74000000f,0.54000000f,0.75000000f,-0.59000000f,-0.22000000f,0.54000000f,-0.99000000f,0.29000000f,0.47000000f,0.87000000f,-0.05000000f,0.65000000f,0.46000000f,0.76000000f,-0.89000000f,0.63000000f,0.65000000f,-0.28000000f,-0.63000000f,0.54000000f,0.37000000f,0.03000000f,0.05000000f,-0.16000000f,-0.38000000f,0.60000000f,0.70000000f,-0.74000000f,0.86000000f,-0.41000000f,0.22000000f,-0.45000000f,0.75000000f,-0.30000000f,0.32000000f,-0.03000000f,0.42000000f,0.48000000f,0.01000000f,-0.79000000f,-0.87000000f,-0.76000000f,-0.51000000f,-0.02000000f,0.00000000f,0.40000000f,0.35000000f,0.78000000f,-0.89000000f,-0.66000000f,-0.15000000f,-0.41000000f,-0.28000000f,0.41000000f,0.37000000f,0.47000000f,-0.56000000f,0.27000000f,0.58000000f,-0.44000000f,0.73000000f,-0.55000000f,-0.54000000f,0.87000000f,-0.67000000f,-0.62000000f,-0.95000000f,0.52000000f,-0.20000000f,0.81000000f,-0.34000000f,-0.48000000f,0.49000000f,-0.23000000f,0.62000000f,0.74000000f,-0.60000000f,-0.39000000f,-0.60000000f,0.34000000f,-0.81000000f,0.17000000f,0.63000000f,0.37000000f,0.11000000f,-0.74000000f,0.60000000f,-0.47000000f,-0.96000000f,-0.42000000f,-0.54000000f,0.20000000f,0.85000000f,0.13000000f,0.83000000f,0.17000000f,-0.56000000f,-0.25000000f,0.69000000f,-0.11000000f,0.11000000f,0.09000000f,-0.83000000f,-0.02000000f,-0.44000000f,-0.50000000f,-0.00000000f,-0.35000000f,0.25000000f,-0.41000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.61819995f,-0.06389990f,-3.89999999f,-1.45050005f,-2.17999985f,-0.51189987f,3.57769991f,-2.25020001f,-2.50990003f,-0.67300002f,0.70230001f,2.12269990f,-0.77009996f,1.67020009f,0.45079993f,-3.26519995f,-0.48610003f,-2.04860005f,0.70730007f,1.63290003f,1.24629994f,-0.58370008f,-0.53960002f,0.85940006f,-1.08160002f,1.68950002f,3.77339998f,-1.22459998f,-2.73200011f,-0.02049996f,0.58750005f,-0.47420001f,0.64729999f,-1.46890009f,2.16949998f,-3.03649997f,3.71999998f,-0.85819999f,0.55040004f,1.05969993f,-0.79369990f,-2.89350008f,3.57270000f,-1.95539994f,0.08450006f,-0.51820002f,0.70910005f,1.39389998f,-0.57229991f,0.30039993f,-0.58559991f,1.73479996f,0.00689996f,0.35139998f,-0.41490005f,3.53700004f,1.35300002f,-0.07159998f,1.43839995f,0.38930003f,0.58009988f,0.45249995f,-2.91520002f,-0.92110004f,0.16759992f,-3.47370003f,-3.37330007f,0.42939996f,3.02649987f,-1.36779992f,-0.31170002f,0.58139997f,-4.13679992f,0.67540003f,3.25619997f,-1.28059996f,0.71290006f,0.69760001f,-0.20609992f,-2.87419997f,-1.42419995f,-2.73390009f,-1.42459994f,-0.50550002f,0.10220004f,1.04699997f,-1.32049992f,1.60740007f,0.92960002f,-1.56700003f,0.09930008f,0.84640008f,-0.60460003f,0.99280001f,3.27279996f,-0.83259996f,3.74240002f,-4.38640005f,-0.94230000f,-0.31340002f,-1.99830005f,-0.03610004f,1.80619997f,0.21709998f,-1.44250000f,1.31049996f,2.97999995f,3.43839995f,-1.14350001f,-0.29189998f,-3.27290005f,0.21590010f,2.15219992f,0.23229999f,0.07089999f,-0.79559992f,6.18510003f,0.70479992f,-3.40090000f,-1.64809999f,-1.56519998f,1.48060005f,1.27650000f,-0.89809997f,1.49709997f,-1.86090000f,-0.13640000f,-0.40520001f,-4.20810010f,2.43529998f,-0.16389994f,-2.96709981f,-0.89449990f,0.15100001f,-0.46139999f,-2.16170001f,-0.47490001f,-4.24599995f,-2.50069993f,-1.03849998f,-1.09490002f,0.66899997f,3.16739996f,-0.49690004f,1.79379991f,-0.10179997f,-0.04729993f,-2.46970000f,-2.70700011f,3.21850010f,3.67969992f,0.97239997f,-1.16269990f,-1.31039995f,-2.58080014f,0.94589990f,0.39809998f,-0.73740002f,-0.77149994f,-0.22239993f,-1.38059994f,1.83509993f,0.67709991f,0.27269999f,2.68880000f,3.72510005f,-1.04179994f,1.99119999f,-3.09219999f,3.31120006f,0.32489992f,1.52509991f,0.92580006f,2.29149988f,-2.94289983f,-4.64360003f,-2.64750002f,-2.12309992f,-0.74130002f,1.65280003f,1.61050007f,2.91700000f,1.70160003f,2.01079994f,1.84119991f,2.43419993f,0.33039997f,0.17869995f,-0.26189994f,-2.57299996f,0.43049996f,-2.08899996f,2.43820008f,0.80720000f,-0.33489993f,1.73080007f,2.95009998f,1.91020002f,0.47409998f,1.77200003f,0.33269990f,-1.46809996f,4.53400004f,-1.32310009f,-2.26949997f,0.80380002f,-2.11779995f,0.62529994f,-1.76629994f,0.21489997f,0.68789999f,0.56029998f,-2.08429990f,1.49390011f,1.24320001f,-0.36800005f,-2.39830003f,-1.32800003f,0.32959993f,-0.22229996f,-0.61490000f,1.19910005f,2.13230010f,-1.49859992f,1.32059996f,3.81920000f,-0.58529997f,-0.12109997f,3.87679996f,-0.25769996f,1.69409994f,-2.23180001f,-0.93489993f,1.75130003f,2.47389993f,-4.21829997f,-1.26809997f,1.07439987f,-0.59820005f,-2.37299995f,3.85600000f,-3.64580002f,-0.42799995f,-0.03789998f,2.55979999f,1.40339987f,-0.08860002f,-0.53700004f,2.53320010f,-3.00810003f,-0.18530012f,-2.89240010f,-3.47219995f,-0.40069996f,-2.02489993f,3.28270001f,1.76870006f,0.78890006f,-2.56249993f,-1.21750009f,0.35030013f,1.95900001f,2.17769996f,0.09570001f,0.81099997f,-1.08460001f,2.31709995f,-0.64419995f,-0.04250003f,-0.78699998f,-0.35859991f,1.68799992f,-0.79720005f,0.42069999f,-1.98610005f,-0.47610004f,0.54520003f,-0.69659997f,-1.80350017f,1.37490000f,2.27740009f,-0.61260007f,-1.01050004f,0.13309995f,3.47839991f,-0.89699996f,0.46599999f,0.73980006f,-0.29430009f,-1.10999994f,-1.64939998f,-2.05630002f,0.83560001f,0.47389988f,-0.41130009f,0.55980013f,7.37160004f,-1.62599998f,-1.95459999f,4.25379989f,1.44920000f,-4.15690000f,-3.77289998f,-1.34140005f,0.00020000f,-2.43400010f,-0.09130007f,0.94899994f,0.93779989f,-2.37620007f,3.02689997f,-0.73139996f,-1.83219998f,-0.83990002f,-0.14950005f,1.68040002f,1.16919999f,-2.45220000f,0.23239998f,-0.82630000f,0.46369985f,-1.44690002f,4.80200007f,0.57949995f,-0.72020002f,1.75620000f,-0.34589997f,-1.92510000f,-0.66120007f,0.24749999f,-0.05649998f,-2.76010001f,-2.26959998f,-1.94519998f,0.54160000f,0.42410005f,1.64880005f,0.21120001f,3.11149997f,-4.21050000f,-4.32100017f,-1.59809998f,-1.57369993f,1.96390002f,1.78679990f,1.68940007f,-2.38549996f,3.17379994f,-0.96079995f,0.69360010f,-2.74479986f,1.38939998f,-0.50479995f,2.43779998f,-0.31899994f,-2.64520002f,-0.52249994f,1.25359995f,-0.93760007f,-3.65660004f,0.86660005f,0.35090004f,2.05210002f,-0.22270005f,0.80309979f,-0.54639992f,-0.31140011f,2.93779999f,-5.17990005f,2.75419989f,0.06279997f,-1.01799998f,-2.53190008f,-1.36739997f,3.84519989f,-1.65570004f,-1.62920002f,1.56520007f,-2.55429997f,-1.64360003f,-2.15910003f,1.04570001f,2.49510009f,1.82480000f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_4d_4items_strided_dilated_padded)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{4,3,8,8,8,8};
    Shape shape_b{4,3,2,2,3,1};
    Shape shape_r{4,4,3,7,7,8};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{3,2,2,3},        // move_strides
                                                                  Strides{2,1,3,2},        // filter_dilation
                                                                  CoordinateDiff{2,4,6,8}, // below_pads
                                                                  CoordinateDiff{1,3,5,7}, // above_pads
                                                                  Strides{1,1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f,0.61000000f,0.17000000f,-0.91000000f,-0.48000000f,-0.48000000f,0.12000000f,-0.18000000f,0.08000000f,-0.16000000f,0.54000000f,-0.20000000f,-0.08000000f,0.19000000f,-0.81000000f,0.56000000f,-0.52000000f,0.32000000f,-0.37000000f,-0.17000000f,-0.46000000f,-0.34000000f,0.85000000f,0.11000000f,-0.10000000f,0.98000000f,-0.22000000f,0.68000000f,0.97000000f,-0.93000000f,-0.92000000f,0.32000000f,-0.19000000f,-0.61000000f,0.93000000f,0.54000000f,-0.75000000f,0.63000000f,0.38000000f,0.69000000f,-0.02000000f,0.19000000f,-0.38000000f,-0.44000000f,0.49000000f,-0.62000000f,-0.41000000f,-0.84000000f,0.93000000f,-0.74000000f,-0.57000000f,0.37000000f,-0.86000000f,-0.01000000f,0.58000000f,0.13000000f,-0.42000000f,0.68000000f,-0.05000000f,0.17000000f,0.09000000f,-0.67000000f,0.11000000f,-0.32000000f,0.08000000f,-0.29000000f,0.60000000f,0.69000000f,0.04000000f,0.85000000f,0.46000000f,0.41000000f,-0.78000000f,-0.98000000f,0.50000000f,-0.96000000f,-0.61000000f,-0.58000000f,0.00000000f,0.81000000f,-0.25000000f,-0.74000000f,-0.46000000f,-0.16000000f,0.32000000f,0.56000000f,-0.05000000f,-0.87000000f,0.59000000f,0.08000000f,-0.39000000f,0.67000000f,0.95000000f,0.70000000f,0.00000000f,-0.58000000f,0.85000000f,-0.14000000f,-0.27000000f,-0.63000000f,-0.75000000f,0.61000000f,-0.12000000f,-0.68000000f,-0.83000000f,0.12000000f,0.94000000f,-0.46000000f,0.27000000f,-0.14000000f,-0.96000000f,0.16000000f,-0.57000000f,0.92000000f,-0.24000000f,0.08000000f,0.60000000f,0.23000000f,-0.14000000f,-0.28000000f,0.14000000f,-0.19000000f,0.00000000f,-0.57000000f,0.18000000f,0.42000000f,0.17000000f,0.71000000f,-0.55000000f,0.89000000f,0.26000000f,-0.67000000f,0.68000000f,-0.75000000f,-0.62000000f,0.62000000f,-0.16000000f,-0.69000000f,-0.96000000f,-0.24000000f,0.00000000f,0.63000000f,-0.95000000f,-0.99000000f,0.06000000f,0.02000000f,-0.04000000f,0.95000000f,0.98000000f,0.13000000f,0.96000000f,-0.22000000f,-0.25000000f,-0.77000000f,-0.02000000f,-0.46000000f,0.28000000f,-0.61000000f,-0.56000000f,-0.65000000f,-0.23000000f,-0.41000000f,0.78000000f,-0.46000000f,0.44000000f,0.15000000f,0.46000000f,-0.90000000f,-0.25000000f,0.81000000f,0.28000000f,0.40000000f,0.56000000f,0.62000000f,-0.63000000f,-0.86000000f,-0.97000000f,0.22000000f,-0.58000000f,0.05000000f,0.53000000f,-0.38000000f,0.79000000f,0.60000000f,-0.63000000f,-0.18000000f,0.62000000f,-0.37000000f,0.48000000f,0.86000000f,0.70000000f,-0.52000000f,-0.39000000f,-0.44000000f,-0.69000000f,0.42000000f,-0.69000000f,0.48000000f,0.70000000f,-0.86000000f,-0.90000000f,0.69000000f,0.08000000f,-0.34000000f,-0.86000000f,0.66000000f,0.61000000f,0.47000000f,-0.22000000f,-0.51000000f,-0.29000000f,0.95000000f,-0.30000000f,-0.41000000f,0.85000000f,-0.13000000f,0.70000000f,-0.51000000f,-0.05000000f,-0.50000000f,-0.28000000f,-0.44000000f,0.33000000f,-0.08000000f,-0.88000000f,-0.64000000f,0.24000000f,-0.51000000f,0.67000000f,-0.40000000f,0.48000000f,0.92000000f,-0.64000000f,-0.42000000f,-0.62000000f,-0.77000000f,0.34000000f,0.29000000f,0.49000000f,0.82000000f,-0.30000000f,-0.40000000f,0.27000000f,0.61000000f,-0.75000000f,0.42000000f,0.69000000f,0.46000000f,0.41000000f,0.48000000f,0.14000000f,0.86000000f,-0.46000000f,-0.88000000f,-0.20000000f,-0.09000000f,-0.10000000f,0.70000000f,0.97000000f,-0.99000000f,0.53000000f,-0.51000000f,-0.70000000f,-0.96000000f,0.86000000f,-0.44000000f,-0.66000000f,-0.28000000f,0.08000000f,0.42000000f,-0.45000000f,-0.73000000f,-0.99000000f,-0.33000000f,0.40000000f,-0.86000000f,-0.84000000f,-0.06000000f,0.77000000f,0.96000000f,-0.06000000f,0.24000000f,0.21000000f,0.27000000f,-0.21000000f,-0.01000000f,0.16000000f,0.40000000f,0.06000000f,-0.61000000f,-0.66000000f,0.76000000f,0.43000000f,0.00000000f,0.37000000f,0.70000000f,-0.76000000f,0.50000000f,-0.38000000f,-0.24000000f,-0.80000000f,-0.66000000f,0.09000000f,-0.70000000f,0.83000000f,0.59000000f,-0.39000000f,-0.21000000f,0.84000000f,-0.17000000f,0.50000000f,-0.48000000f,-0.07000000f,-0.54000000f,-0.16000000f,0.99000000f,0.28000000f,0.29000000f,-0.68000000f,-0.49000000f,-0.18000000f,-0.41000000f,0.95000000f,0.72000000f,-0.26000000f,-0.42000000f,-0.27000000f,0.38000000f,-0.47000000f,0.24000000f,-0.38000000f,0.29000000f,0.34000000f,-0.30000000f,-0.64000000f,-0.27000000f,-0.27000000f,-0.94000000f,0.26000000f,0.52000000f,0.92000000f,0.53000000f,-0.80000000f,0.31000000f,0.29000000f,0.16000000f,-0.47000000f,0.61000000f,0.46000000f,-0.75000000f,-0.88000000f,0.95000000f,0.33000000f,-0.97000000f,-0.03000000f,0.43000000f,0.14000000f,0.73000000f,0.97000000f,-0.01000000f,0.45000000f,0.81000000f,0.77000000f,0.45000000f,0.16000000f,-0.66000000f,-0.29000000f,-0.23000000f,0.32000000f,0.22000000f,-0.09000000f,0.65000000f,-0.46000000f,0.65000000f,-0.01000000f,0.61000000f,-0.12000000f,0.36000000f,0.29000000f,-0.87000000f,-0.01000000f,-0.28000000f,-0.95000000f,0.37000000f,0.73000000f,-0.99000000f,0.47000000f,-0.69000000f,-0.31000000f,0.67000000f,-0.78000000f,-0.77000000f,-0.41000000f,0.95000000f,0.61000000f,0.52000000f,0.85000000f,-0.88000000f,0.97000000f,0.54000000f,0.53000000f,0.87000000f,-0.64000000f,-0.62000000f,0.70000000f,-0.11000000f,0.93000000f,-0.52000000f,-0.08000000f,0.03000000f,0.27000000f,-0.30000000f,-0.62000000f,0.00000000f,0.76000000f,0.12000000f,-0.83000000f,-0.60000000f,-0.95000000f,0.51000000f,0.85000000f,-0.27000000f,-0.83000000f,-0.20000000f,-0.45000000f,0.27000000f,-0.09000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.52000000f,-0.43000000f,-0.73000000f,-0.60000000f,-0.89000000f,0.15000000f,-0.12000000f,0.95000000f,0.97000000f,-0.43000000f,0.85000000f,0.43000000f,-0.35000000f,-0.44000000f,0.84000000f,0.94000000f,0.80000000f,-0.88000000f,-0.73000000f,-0.24000000f,0.93000000f,0.77000000f,0.15000000f,-0.63000000f,0.84000000f,0.70000000f,-0.24000000f,-0.01000000f,-0.63000000f,0.44000000f,0.50000000f,-0.29000000f,-0.27000000f,0.64000000f,0.28000000f,-0.18000000f,0.90000000f,-0.87000000f,-0.86000000f,-0.24000000f,0.66000000f,-0.49000000f,0.86000000f,0.19000000f,0.56000000f,-0.18000000f,-0.25000000f,-0.32000000f,-0.09000000f,0.83000000f,0.25000000f,0.92000000f,0.15000000f,0.71000000f,-0.91000000f,0.86000000f,-0.70000000f,0.05000000f,-0.23000000f,0.19000000f,0.32000000f,0.74000000f,-0.79000000f,-0.82000000f,0.44000000f,-0.91000000f,-0.61000000f,-0.99000000f,0.61000000f,-0.19000000f,0.14000000f,-0.46000000f,-0.33000000f,0.93000000f,0.29000000f,0.68000000f,-0.45000000f,0.47000000f,0.19000000f,-0.48000000f,0.03000000f,-0.10000000f,0.73000000f,-0.99000000f,0.72000000f,-0.58000000f,0.45000000f,-0.83000000f,0.07000000f,0.58000000f,0.02000000f,0.60000000f,0.71000000f,0.75000000f,-0.36000000f,0.19000000f,0.92000000f,-0.90000000f,-0.66000000f,0.57000000f,0.38000000f,0.86000000f,0.61000000f,0.31000000f,0.47000000f,-0.14000000f,-0.15000000f,0.27000000f,0.48000000f,0.44000000f,-0.45000000f,-0.83000000f,0.11000000f,0.96000000f,-0.38000000f,-0.12000000f,-0.72000000f,0.07000000f,-0.10000000f,-0.62000000f,0.21000000f,-0.33000000f,0.18000000f,0.18000000f,-0.50000000f,0.15000000f,0.38000000f,0.29000000f,-0.67000000f,-0.16000000f,-0.61000000f,0.36000000f,-0.50000000f,-0.87000000f,0.41000000f,0.41000000f,0.03000000f,0.71000000f,0.75000000f,-0.02000000f,0.13000000f,0.93000000f,0.51000000f,-0.86000000f,-0.43000000f,-0.97000000f,0.16000000f,-0.95000000f,-0.21000000f,-0.15000000f,-0.43000000f,0.53000000f,0.17000000f,0.18000000f,0.12000000f,-0.76000000f,0.56000000f,-0.71000000f,0.25000000f,-0.03000000f,-0.95000000f,0.65000000f,0.11000000f,0.29000000f,0.14000000f,0.04000000f,0.02000000f,-0.20000000f,-0.39000000f,0.23000000f,0.59000000f,0.07000000f,0.73000000f,-0.75000000f,0.67000000f,0.71000000f,-0.11000000f,-0.30000000f,0.26000000f,-0.93000000f,-0.01000000f,0.18000000f,-0.04000000f,-0.73000000f,-0.61000000f,-0.07000000f,0.00000000f,-0.68000000f,-0.58000000f,-0.95000000f,-0.51000000f,0.68000000f,-0.87000000f,0.07000000f,0.21000000f,0.87000000f,0.65000000f,-0.89000000f,0.57000000f,-0.48000000f,0.53000000f,-0.35000000f,-0.61000000f,-0.55000000f,0.62000000f,0.58000000f,-0.68000000f,-0.52000000f,0.33000000f,0.02000000f,0.74000000f,0.03000000f,0.44000000f,0.84000000f,-0.90000000f,-0.02000000f,-0.54000000f,0.55000000f,-0.24000000f,0.63000000f,0.31000000f,-0.67000000f,0.51000000f,0.67000000f,0.85000000f,0.68000000f,0.61000000f,0.04000000f,0.09000000f,0.70000000f,0.35000000f,-0.06000000f,-0.06000000f,-0.49000000f,0.81000000f,-0.24000000f,-0.70000000f,0.44000000f,0.18000000f,0.12000000f,0.17000000f,0.28000000f,0.26000000f,0.81000000f,-0.24000000f,-0.64000000f,0.32000000f,0.49000000f,-0.06000000f,0.13000000f,0.56000000f,-0.17000000f,-0.28000000f,-0.50000000f,0.89000000f,-0.20000000f,-0.34000000f,0.05000000f,0.71000000f,-0.09000000f,0.02000000f,-0.43000000f,-0.00000000f,-0.07000000f,0.25000000f,0.80000000f,0.18000000f,-0.37000000f,-0.16000000f,-0.42000000f,0.33000000f,0.76000000f,-0.81000000f,0.79000000f,0.88000000f,-0.62000000f,-0.49000000f,-0.79000000f,0.16000000f,0.19000000f,0.37000000f,-0.62000000f,-0.72000000f,-0.37000000f,0.39000000f,-0.84000000f,-0.13000000f,0.21000000f,0.88000000f,-0.80000000f,-0.06000000f,0.28000000f,-0.13000000f,-0.83000000f,-0.91000000f,-0.39000000f,0.19000000f,-0.71000000f,-0.08000000f,0.96000000f,0.89000000f,-0.60000000f,-0.79000000f,-0.13000000f,-0.00000000f,0.03000000f,0.97000000f,0.70000000f,-0.96000000f,-0.50000000f,-0.39000000f,0.13000000f,0.09000000f,0.29000000f,-0.43000000f,-0.40000000f,-0.83000000f,0.51000000f,-0.32000000f,-0.53000000f,0.07000000f,0.35000000f,0.43000000f,-0.65000000f,-0.94000000f,0.40000000f,-0.59000000f,0.80000000f,-0.15000000f,-0.22000000f,0.56000000f,0.90000000f,-0.82000000f,-0.74000000f,0.04000000f,-0.24000000f,-0.97000000f,0.96000000f,0.78000000f,0.29000000f,-0.44000000f,0.62000000f,0.92000000f,0.05000000f,-0.74000000f,-0.49000000f,-0.25000000f,0.34000000f,-0.99000000f,0.78000000f,-0.64000000f,0.09000000f,-0.51000000f,0.99000000f,-0.20000000f,0.95000000f,0.13000000f,-0.44000000f,-0.90000000f,-0.82000000f,0.84000000f,0.26000000f,-0.90000000f,0.97000000f,-0.09000000f,0.45000000f,-0.49000000f,0.29000000f,0.13000000f,0.37000000f,-0.03000000f,0.41000000f,-0.47000000f,0.25000000f,0.44000000f,0.31000000f,0.72000000f,0.09000000f,0.67000000f,0.76000000f,-0.79000000f,-0.99000000f,0.62000000f,-0.71000000f,-0.07000000f,0.63000000f,-0.02000000f,-0.28000000f,-0.02000000f,0.98000000f,0.28000000f,0.48000000f,-0.49000000f,0.32000000f,-0.11000000f,-0.45000000f,0.37000000f,-0.58000000f,-0.82000000f,-0.23000000f,-0.55000000f,-0.61000000f,-0.87000000f,-0.96000000f,-0.34000000f,-0.03000000f,-0.15000000f,-0.15000000f,-0.30000000f,-0.53000000f,0.83000000f,0.20000000f,-0.19000000f,-0.19000000f,0.23000000f,0.45000000f,0.50000000f,-0.67000000f,0.71000000f,-0.97000000f,0.42000000f,-0.33000000f,-0.88000000f,0.56000000f,0.78000000f,-0.09000000f,0.17000000f,0.77000000f,0.95000000f,-0.80000000f,-0.72000000f,0.23000000f,0.39000000f,-0.72000000f,-0.15000000f,-0.79000000f,-0.97000000f,0.97000000f,-0.20000000f,-0.56000000f,-0.95000000f,-0.65000000f,0.71000000f,-0.42000000f,0.10000000f,-0.58000000f,-0.14000000f,0.39000000f,-0.95000000f,-0.71000000f,-0.67000000f,0.62000000f,-0.10000000f,-0.11000000f,-0.76000000f,-0.30000000f,-0.62000000f,0.63000000f,-0.11000000f,-0.48000000f,0.37000000f,-0.08000000f,0.73000000f,-0.84000000f,-0.07000000f,-0.82000000f,-0.93000000f,0.63000000f,0.17000000f,-0.58000000f,-0.17000000f,0.83000000f,0.78000000f,-0.49000000f,-0.41000000f,0.29000000f,-0.90000000f,0.78000000f,-0.97000000f,-0.67000000f,0.47000000f,0.64000000f,-0.57000000f,0.89000000f,0.29000000f,-0.24000000f,0.75000000f,0.61000000f,0.45000000f,0.42000000f,0.16000000f,-0.75000000f,0.31000000f,0.66000000f,-0.04000000f,0.11000000f,-0.22000000f,-0.63000000f,-0.81000000f,0.48000000f,0.40000000f,-0.43000000f,0.37000000f,0.58000000f,0.18000000f,0.27000000f,-0.84000000f,0.31000000f,0.67000000f,-0.23000000f,0.74000000f,0.87000000f,-0.60000000f,-0.90000000f,-0.43000000f,0.07000000f,-0.58000000f,-0.01000000f,0.06000000f,-0.57000000f,-0.48000000f,-0.80000000f,0.30000000f,-0.69000000f,-0.37000000f,0.45000000f,0.85000000f,-0.17000000f,0.84000000f,-0.86000000f,0.36000000f,0.30000000f,0.49000000f,0.19000000f,-0.40000000f,-0.68000000f,-0.49000000f,0.61000000f,-0.07000000f,0.25000000f,-0.84000000f,0.42000000f,-0.23000000f,-0.28000000f,0.86000000f,-0.37000000f,0.13000000f,-0.29000000f,-0.93000000f,-0.28000000f,0.23000000f,0.25000000f,0.86000000f,0.33000000f,0.75000000f,0.75000000f,-0.61000000f,0.43000000f,0.09000000f,0.24000000f,-0.80000000f,-0.34000000f,-0.64000000f,0.25000000f,-0.07000000f,0.78000000f,0.29000000f,0.12000000f,0.28000000f,-0.72000000f,-0.72000000f,-0.70000000f,0.23000000f,-0.30000000f,-0.07000000f,-0.94000000f,0.97000000f,0.08000000f,-0.97000000f,0.20000000f,0.70000000f,0.38000000f,0.92000000f,-0.91000000f,-0.93000000f,-0.13000000f,0.05000000f,-0.56000000f,0.15000000f,-0.45000000f,-0.39000000f,-0.53000000f,0.25000000f,0.74000000f,0.85000000f,0.91000000f,0.25000000f,0.75000000f,0.32000000f,0.86000000f,0.99000000f,0.84000000f,0.17000000f,0.38000000f,0.16000000f,0.26000000f,0.37000000f,0.41000000f,-0.36000000f,-0.00000000f,-0.09000000f,0.70000000f,-0.40000000f,0.15000000f,0.76000000f,-0.17000000f,0.40000000f,-0.06000000f,0.14000000f,0.50000000f,-0.91000000f,0.44000000f,0.06000000f,0.30000000f,0.86000000f,0.45000000f,-0.88000000f,-0.06000000f,0.92000000f,-0.39000000f,0.83000000f,0.04000000f,-0.04000000f,0.70000000f,0.99000000f,-0.96000000f,0.02000000f,-0.45000000f,0.47000000f,0.71000000f,-0.50000000f,0.08000000f,0.98000000f,0.30000000f,-0.60000000f,-0.66000000f,0.66000000f,-0.51000000f,-0.86000000f,0.54000000f,0.51000000f,-0.36000000f,-0.48000000f,0.59000000f,-0.93000000f,0.64000000f,0.49000000f,0.23000000f,-0.72000000f,0.82000000f,-0.81000000f,-0.51000000f,-0.06000000f,0.58000000f,0.45000000f,-0.41000000f,-0.60000000f,-0.08000000f,-0.07000000f,0.47000000f,-0.48000000f,0.85000000f,-0.36000000f,-0.92000000f,0.48000000f,-0.36000000f,-0.09000000f,0.09000000f,-0.57000000f,-0.98000000f,0.67000000f,-0.53000000f,0.50000000f,-0.12000000f,-0.62000000f,-0.85000000f,0.37000000f,-0.98000000f,0.56000000f,0.65000000f,0.51000000f,0.54000000f,0.73000000f,-0.89000000f,0.07000000f,0.52000000f,0.92000000f,-0.26000000f,-0.93000000f,-0.82000000f,0.75000000f,0.96000000f,0.26000000f,-0.21000000f,-0.40000000f,-0.88000000f,-0.38000000f,-0.21000000f,-0.43000000f,-0.77000000f,0.48000000f,-0.95000000f,0.40000000f,0.43000000f,-0.24000000f,-0.72000000f,0.49000000f,-0.78000000f,0.82000000f,-0.21000000f,-0.15000000f,-0.56000000f,-0.94000000f,-0.51000000f,-0.10000000f,0.36000000f,0.68000000f,-0.78000000f,0.09000000f,-0.15000000f,-0.55000000f,0.21000000f,-0.11000000f,0.53000000f,-0.23000000f,-0.85000000f,-0.50000000f,0.66000000f,0.44000000f,0.47000000f,0.61000000f,0.22000000f,0.79000000f,0.71000000f,-0.91000000f,0.70000000f,-0.12000000f,-0.78000000f,0.45000000f,-0.40000000f,0.82000000f,0.27000000f,0.39000000f,0.87000000f,-0.23000000f,-0.37000000f,-0.78000000f,-0.19000000f,0.45000000f,0.29000000f,-0.45000000f,-0.30000000f,0.17000000f,-0.70000000f,0.09000000f,-0.85000000f,-0.67000000f,0.41000000f,0.37000000f,-0.12000000f,0.83000000f,0.92000000f,0.70000000f,-0.23000000f,0.62000000f,0.84000000f,0.13000000f,-0.36000000f,0.75000000f,-0.47000000f,-0.93000000f,0.00000000f,-0.71000000f,0.22000000f,-0.13000000f,-0.19000000f,-0.03000000f,-0.94000000f,-0.56000000f,-0.88000000f,-0.27000000f,-0.48000000f,0.98000000f,0.73000000f,0.87000000f,0.10000000f,0.04000000f,0.34000000f,0.51000000f,-0.95000000f,0.84000000f,0.17000000f,0.13000000f,-0.39000000f,0.37000000f,0.89000000f,-0.04000000f,-0.53000000f,-0.38000000f,0.00000000f,-0.00000000f,0.72000000f,0.08000000f,0.32000000f,0.69000000f,0.80000000f,0.00000000f,-0.12000000f,-0.79000000f,-0.75000000f,0.04000000f,-0.45000000f,0.08000000f,-0.96000000f,-0.95000000f,-0.44000000f,0.98000000f,0.10000000f,-0.28000000f,0.99000000f,-0.07000000f,0.53000000f,-0.86000000f,-0.01000000f,0.29000000f,-0.78000000f,-0.01000000f,0.22000000f,0.18000000f,-0.24000000f,-0.89000000f,0.12000000f,-0.67000000f,0.06000000f,-0.02000000f,-0.41000000f,-0.00000000f,0.91000000f,0.40000000f,-0.20000000f,0.25000000f,-0.08000000f,0.04000000f,0.42000000f,0.40000000f,0.39000000f,-0.22000000f,-0.23000000f,0.28000000f,0.48000000f,-0.72000000f,-0.85000000f,-0.22000000f,0.69000000f,-0.25000000f,-0.85000000f,-0.56000000f,0.80000000f,-0.91000000f,0.69000000f,-0.69000000f,0.86000000f,0.94000000f,0.87000000f,-0.47000000f,0.30000000f,-0.51000000f,-0.52000000f,0.74000000f,-0.43000000f,0.03000000f,-0.79000000f,0.76000000f,0.39000000f,0.00000000f,0.32000000f,-0.43000000f,-0.43000000f,-0.27000000f,0.08000000f,-0.20000000f,0.18000000f,0.01000000f,-0.12000000f,-0.22000000f,-0.64000000f,-0.56000000f,0.72000000f,-0.10000000f,-0.52000000f,-0.23000000f,0.93000000f,0.39000000f,0.14000000f,0.23000000f,0.81000000f,-0.37000000f,0.52000000f,-0.10000000f,-0.16000000f,-0.90000000f,0.35000000f,0.18000000f,-0.89000000f,0.72000000f,0.91000000f,-0.03000000f,-0.67000000f,0.43000000f,0.97000000f,-0.32000000f,-0.40000000f,0.85000000f,-0.25000000f,0.71000000f,-0.60000000f,0.71000000f,0.84000000f,0.20000000f,-0.97000000f,-0.66000000f,0.18000000f,0.71000000f,-0.29000000f,-0.73000000f,0.62000000f,0.76000000f,-0.12000000f,-0.80000000f,0.61000000f,0.38000000f,0.74000000f,0.44000000f,0.60000000f,0.23000000f,0.11000000f,-0.06000000f,-0.09000000f,-0.33000000f,-0.38000000f,0.17000000f,0.57000000f,0.91000000f,0.83000000f,0.89000000f,0.88000000f,0.83000000f,0.71000000f,0.97000000f,0.93000000f,0.23000000f,-0.36000000f,-0.21000000f,-0.77000000f,0.14000000f,0.52000000f,-0.48000000f,-0.21000000f,-0.86000000f,-0.39000000f,0.68000000f,0.46000000f,0.48000000f,0.09000000f,-0.10000000f,0.83000000f,0.63000000f,0.53000000f,0.40000000f,0.05000000f,-0.92000000f,0.61000000f,0.23000000f,0.23000000f,-0.49000000f,-0.12000000f,-0.88000000f,-0.03000000f,0.50000000f,-0.27000000f,0.44000000f,-0.59000000f,-0.50000000f,0.93000000f,-0.52000000f,-0.06000000f,-0.02000000f,0.57000000f,0.75000000f,0.56000000f,0.34000000f,-0.71000000f,-0.04000000f,-0.25000000f,0.81000000f,0.77000000f,-0.40000000f,0.69000000f,0.26000000f,0.86000000f,0.32000000f,0.69000000f,-0.64000000f,-0.75000000f,0.73000000f,-0.40000000f,-0.57000000f,0.95000000f,0.03000000f,-0.51000000f,0.15000000f,-0.25000000f,0.87000000f,0.23000000f,-0.61000000f,-0.37000000f,-0.44000000f,-0.04000000f,-0.84000000f,-0.07000000f,0.27000000f,-0.33000000f,0.68000000f,-0.59000000f,0.32000000f,0.06000000f,-0.80000000f,-0.47000000f,0.09000000f,-0.61000000f,-0.85000000f,-0.77000000f,0.78000000f,0.86000000f,-0.75000000f,-0.45000000f,-0.10000000f,-0.68000000f,-0.30000000f,-0.40000000f,0.83000000f,0.62000000f,0.97000000f,-0.71000000f,0.50000000f,-0.15000000f,-0.06000000f,0.99000000f,0.68000000f,-0.45000000f,0.81000000f,-0.82000000f,0.87000000f,-0.65000000f,-0.68000000f,-0.97000000f,0.68000000f,0.64000000f,0.19000000f,0.23000000f,0.51000000f,-0.96000000f,0.16000000f,0.05000000f,0.82000000f,-0.70000000f,0.08000000f,-0.13000000f,0.80000000f,0.87000000f,0.47000000f,0.27000000f,0.38000000f,0.27000000f,-0.61000000f,-0.63000000f,0.60000000f,0.91000000f,-0.03000000f,-0.65000000f,-0.26000000f,-0.59000000f,-0.08000000f,-0.00000000f,0.55000000f,-0.30000000f,0.28000000f,-0.81000000f,0.32000000f,-0.92000000f,-0.34000000f,0.55000000f,0.25000000f,-0.46000000f,0.93000000f,0.34000000f,0.69000000f,-0.59000000f,0.79000000f,0.95000000f,0.97000000f,0.91000000f,-0.53000000f,0.89000000f,0.29000000f,-0.23000000f,-0.49000000f,0.14000000f,-0.53000000f,0.22000000f,0.87000000f,0.10000000f,0.42000000f,0.31000000f,0.98000000f,-0.18000000f,-0.89000000f,-0.98000000f,-0.20000000f,0.31000000f,-0.54000000f,0.32000000f,-0.14000000f,0.16000000f,-0.24000000f,-0.77000000f,0.15000000f,0.76000000f,0.80000000f,0.70000000f,0.93000000f,-0.55000000f,0.25000000f,0.39000000f,0.16000000f,-0.80000000f,-0.64000000f,-0.51000000f,-0.48000000f,0.75000000f,0.50000000f,0.19000000f,-0.42000000f,-0.42000000f,0.75000000f,0.06000000f,0.61000000f,-0.75000000f,0.65000000f,0.27000000f,-0.72000000f,-0.20000000f,0.81000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.56000000f,-0.15000000f,-0.37000000f,0.38000000f,0.83000000f,-0.76000000f,-0.00000000f,-0.95000000f,0.99000000f,-0.51000000f,-0.06000000f,-0.47000000f,0.92000000f,0.03000000f,0.52000000f,-0.67000000f,0.73000000f,0.59000000f,-0.32000000f,-0.97000000f,0.41000000f,-0.37000000f,0.25000000f,0.77000000f,-0.40000000f,-0.01000000f,-0.95000000f,0.77000000f,-0.31000000f,-0.99000000f,-0.23000000f,-0.38000000f,-0.77000000f,-0.15000000f,-0.75000000f,-0.79000000f,0.85000000f,-0.56000000f,-0.80000000f,0.15000000f,0.75000000f,0.69000000f,-0.70000000f,-0.72000000f,-0.83000000f,0.16000000f,0.83000000f,0.95000000f,-0.33000000f,-0.16000000f,-0.56000000f,-0.36000000f,-0.94000000f,0.37000000f,0.51000000f,-0.95000000f,0.92000000f,-0.86000000f,0.88000000f,-0.63000000f,0.77000000f,0.12000000f,0.54000000f,0.99000000f,0.08000000f,0.38000000f,-0.42000000f,0.86000000f,-0.13000000f,0.45000000f,0.75000000f,0.10000000f,0.56000000f,0.78000000f,0.06000000f,-0.93000000f,0.77000000f,-0.47000000f,0.86000000f,-0.34000000f,-0.34000000f,0.61000000f,0.12000000f,-0.56000000f,0.64000000f,0.58000000f,-0.56000000f,0.32000000f,0.01000000f,-0.35000000f,0.10000000f,0.59000000f,-0.40000000f,0.19000000f,-0.02000000f,-0.53000000f,0.87000000f,-0.31000000f,-0.39000000f,0.80000000f,-0.53000000f,0.84000000f,0.69000000f,0.34000000f,0.46000000f,0.61000000f,-0.38000000f,0.85000000f,-0.38000000f,-0.90000000f,-0.57000000f,0.74000000f,0.21000000f,0.13000000f,-0.87000000f,-0.57000000f,-0.81000000f,-0.75000000f,-0.14000000f,0.99000000f,-0.49000000f,-0.65000000f,0.61000000f,-0.58000000f,-0.04000000f,-0.63000000f,-0.96000000f,-0.75000000f,-0.67000000f,-0.72000000f,-0.33000000f,0.50000000f,-0.01000000f,0.64000000f,0.97000000f,-0.08000000f,-0.34000000f,-0.84000000f,0.38000000f,-0.16000000f,0.42000000f,0.96000000f,0.80000000f,-0.53000000f,0.53000000f,0.51000000f,0.77000000f,-0.04000000f,-0.06000000f,0.65000000f,0.72000000f,0.82000000f,0.77000000f,-0.53000000f,-0.66000000f,-0.43000000f,0.95000000f,0.20000000f,0.14000000f,-0.27000000f,-0.13000000f,0.39000000f,-0.77000000f,0.07000000f,-0.14000000f,0.93000000f,0.69000000f,-0.03000000f,0.89000000f,0.51000000f,-0.40000000f,-0.68000000f,0.42000000f,-0.46000000f,-0.50000000f,0.15000000f,-0.81000000f,0.32000000f,-0.10000000f,0.26000000f,-0.10000000f,0.35000000f,-0.33000000f,0.70000000f,-0.35000000f,0.79000000f,0.97000000f,0.01000000f,-0.77000000f,-0.44000000f,-0.24000000f,-0.93000000f,0.21000000f,-0.74000000f,-0.64000000f,-0.25000000f,-0.90000000f,-0.26000000f,0.64000000f,-0.33000000f,0.82000000f,-0.12000000f,0.56000000f,-0.18000000f,-0.78000000f,-0.82000000f,-0.21000000f,-0.84000000f,-0.81000000f,-0.26000000f,0.20000000f,0.74000000f,-0.56000000f,0.86000000f,-0.17000000f,-0.36000000f,-0.02000000f,-0.16000000f,0.21000000f,0.61000000f,0.65000000f,-0.48000000f,0.04000000f,-0.38000000f,0.32000000f,-0.72000000f,0.22000000f,-0.16000000f,0.44000000f,0.25000000f,-0.51000000f,-0.64000000f,0.43000000f,0.72000000f,-0.88000000f,0.97000000f,-0.27000000f,0.40000000f,0.36000000f,0.49000000f,0.38000000f,-0.53000000f,-0.08000000f,-0.06000000f,0.69000000f,-0.27000000f,0.05000000f,0.72000000f,-0.48000000f,0.74000000f,0.80000000f,0.23000000f,0.00000000f,-0.49000000f,-0.85000000f,-0.30000000f,-0.43000000f,0.14000000f,-0.06000000f,0.03000000f,-0.83000000f,0.91000000f,-0.72000000f,0.27000000f,0.42000000f,-0.63000000f,-0.54000000f,0.92000000f,-0.87000000f,-0.49000000f,0.40000000f,0.60000000f,-0.24000000f,0.66000000f,-0.65000000f,-0.67000000f,0.15000000f,0.70000000f,0.89000000f,-0.13000000f,0.81000000f,-0.52000000f,-0.82000000f,-0.58000000f,-0.20000000f,0.08000000f,-0.51000000f,0.18000000f,0.99000000f,-0.80000000f,0.22000000f,-0.17000000f,-0.72000000f,-0.72000000f,0.39000000f,0.81000000f,-0.36000000f,0.92000000f,-0.63000000f,0.36000000f,0.21000000f,0.00000000f,-0.27000000f,-0.72000000f,-0.47000000f,-0.69000000f,0.93000000f,-0.60000000f,0.98000000f,-0.28000000f,-0.69000000f,0.24000000f,-0.32000000f,-0.13000000f,-0.37000000f,0.66000000f,-0.68000000f,0.82000000f,0.23000000f,-0.45000000f,0.19000000f,-0.02000000f,0.90000000f,-0.77000000f,-0.87000000f,0.94000000f,-0.53000000f,0.95000000f,0.90000000f,0.17000000f,0.80000000f,-0.86000000f,0.67000000f,0.58000000f,-0.27000000f,-0.87000000f,-0.15000000f,0.99000000f,-0.65000000f,0.08000000f,0.34000000f,-0.46000000f,-0.94000000f,0.78000000f,0.10000000f,-0.95000000f,0.54000000f,0.46000000f,0.89000000f,0.01000000f,-0.33000000f,0.43000000f,-0.19000000f,-0.87000000f,0.36000000f,0.84000000f,0.70000000f,-0.93000000f,-0.95000000f,0.86000000f,-0.33000000f,-0.60000000f,0.31000000f,0.70000000f,-0.39000000f,0.01000000f,-0.43000000f,-0.11000000f,-0.42000000f,-0.76000000f,0.72000000f,0.33000000f,0.40000000f,0.43000000f,-0.19000000f,-0.49000000f,0.24000000f,-0.45000000f,-0.02000000f,-0.12000000f,-0.50000000f,-0.74000000f,-0.53000000f,0.09000000f,0.39000000f,0.53000000f,0.02000000f,0.14000000f,0.40000000f,-0.81000000f,-0.28000000f,-0.32000000f,-0.00000000f,0.51000000f,0.54000000f,-0.12000000f,-0.30000000f,0.97000000f,-0.04000000f,-0.42000000f,-0.96000000f,-0.39000000f,0.81000000f,0.93000000f,-0.55000000f,0.46000000f,-0.79000000f,-0.99000000f,-0.53000000f,0.00000000f,-0.28000000f,0.08000000f,0.22000000f,0.34000000f,0.03000000f,-0.89000000f,0.36000000f,0.80000000f,-0.68000000f,0.50000000f,-0.08000000f,0.04000000f,0.98000000f,-0.36000000f,-0.97000000f,0.46000000f,-0.02000000f,-0.20000000f,0.66000000f,-0.67000000f,0.58000000f,0.46000000f,-0.14000000f,-0.74000000f,-0.68000000f,-0.22000000f,0.93000000f,-0.86000000f,-0.58000000f,0.66000000f,-0.03000000f,0.40000000f,0.60000000f,-0.65000000f,0.20000000f,0.96000000f,-0.04000000f,0.91000000f,0.95000000f,-0.19000000f,0.04000000f,0.89000000f,0.70000000f,-0.99000000f,0.27000000f,-0.55000000f,0.79000000f,0.99000000f,0.94000000f,-0.16000000f,0.16000000f,0.74000000f,-0.84000000f,-0.91000000f,-0.15000000f,0.70000000f,0.95000000f,-0.19000000f,-0.72000000f,0.23000000f,0.98000000f,-0.77000000f,-0.58000000f,-0.97000000f,0.20000000f,-0.89000000f,0.94000000f,-0.96000000f,0.78000000f,0.17000000f,0.51000000f,0.91000000f,-0.58000000f,-0.90000000f,-0.48000000f,0.03000000f,0.06000000f,-0.58000000f,0.67000000f,0.70000000f,-0.68000000f,0.13000000f,-0.02000000f,0.04000000f,-0.33000000f,0.64000000f,-0.72000000f,0.01000000f,0.71000000f,0.37000000f,0.31000000f,-0.39000000f,0.91000000f,0.19000000f,-0.34000000f,0.45000000f,-0.68000000f,-0.26000000f,-0.78000000f,-0.74000000f,0.43000000f,-0.05000000f,-0.29000000f,-0.98000000f,-0.07000000f,0.61000000f,-0.93000000f,0.05000000f,-0.44000000f,0.44000000f,0.89000000f,-0.08000000f,0.19000000f,0.95000000f,0.90000000f,0.63000000f,0.25000000f,0.09000000f,0.90000000f,-0.66000000f,0.62000000f,0.72000000f,-0.28000000f,0.76000000f,-0.90000000f,0.37000000f,-0.25000000f,0.60000000f,0.92000000f,-0.75000000f,0.86000000f,-0.79000000f,0.17000000f,-0.11000000f,-0.21000000f,-0.99000000f,-0.41000000f,0.18000000f,-0.59000000f,-0.04000000f,0.92000000f,-0.20000000f,-0.82000000f,0.70000000f,0.18000000f,-0.08000000f,0.04000000f,0.84000000f,-0.48000000f,-0.46000000f,-0.94000000f,-0.55000000f,0.64000000f,0.10000000f,-0.74000000f,-0.66000000f,-0.16000000f,0.52000000f,0.33000000f,-0.41000000f,0.24000000f,0.94000000f,0.22000000f,-0.04000000f,-0.90000000f,0.91000000f,0.13000000f,0.46000000f,0.18000000f,-0.33000000f,-0.48000000f,-0.92000000f,-0.54000000f,-0.90000000f,-0.20000000f,0.58000000f,-0.45000000f,-0.52000000f,-0.50000000f,-0.42000000f,-0.18000000f,-0.49000000f,-0.71000000f,0.61000000f,-0.32000000f,0.82000000f,-0.17000000f,-0.82000000f,0.37000000f,-0.73000000f,-0.22000000f,0.97000000f,0.79000000f,0.43000000f,0.75000000f,0.82000000f,-0.88000000f,0.15000000f,0.04000000f,0.50000000f,-0.21000000f,-0.38000000f,0.63000000f,-0.45000000f,-0.39000000f,0.34000000f,0.20000000f,-0.46000000f,-0.24000000f,-0.44000000f,-0.82000000f,0.63000000f,-0.36000000f,-0.03000000f,-0.20000000f,-0.31000000f,-0.51000000f,-0.44000000f,0.03000000f,-0.28000000f,0.86000000f,-0.98000000f,0.67000000f,-0.01000000f,0.37000000f,-0.58000000f,0.83000000f,-0.71000000f,0.88000000f,0.94000000f,-0.97000000f,-0.02000000f,0.53000000f,-0.47000000f,0.43000000f,0.45000000f,0.66000000f,-0.41000000f,0.01000000f,0.66000000f,-0.73000000f,0.98000000f,-0.51000000f,-0.25000000f,0.10000000f,0.86000000f,-0.61000000f,-0.38000000f,0.24000000f,-0.37000000f,-0.76000000f,0.10000000f,0.41000000f,-0.40000000f,0.45000000f,-0.94000000f,0.06000000f,-0.34000000f,-0.77000000f,-0.49000000f,0.10000000f,0.60000000f,0.59000000f,-0.18000000f,-0.29000000f,0.16000000f,0.66000000f,-0.79000000f,0.31000000f,-0.15000000f,-0.36000000f,0.28000000f,-0.83000000f,-0.40000000f,0.79000000f,-0.79000000f,0.01000000f,-0.10000000f,-0.89000000f,0.89000000f,-0.73000000f,-0.94000000f,-0.25000000f,0.90000000f,0.02000000f,0.87000000f,-0.72000000f,0.14000000f,0.01000000f,0.14000000f,0.33000000f,0.70000000f,-0.23000000f,0.31000000f,0.47000000f,-0.99000000f,0.74000000f,-0.94000000f,-0.18000000f,0.29000000f,0.74000000f,0.41000000f,-0.62000000f,-0.55000000f,-0.23000000f,-0.92000000f,-0.83000000f,-0.04000000f,0.62000000f,-0.21000000f,0.18000000f,0.54000000f,0.10000000f,0.01000000f,-0.56000000f,0.20000000f,-0.27000000f,0.95000000f,-0.72000000f,-0.81000000f,-0.37000000f,0.04000000f,0.35000000f,-0.43000000f,0.74000000f,0.96000000f,-0.39000000f,-0.25000000f,0.84000000f,-0.96000000f,0.63000000f,-0.21000000f,0.38000000f,0.08000000f,-0.30000000f,-0.96000000f,0.62000000f,0.52000000f,0.88000000f,0.24000000f,0.20000000f,-0.98000000f,-0.19000000f,0.73000000f,-0.92000000f,-0.26000000f,0.98000000f,0.23000000f,0.02000000f,-0.56000000f,-0.67000000f,0.84000000f,0.80000000f,-0.99000000f,0.90000000f,0.08000000f,0.54000000f,-0.42000000f,0.12000000f,0.61000000f,-0.37000000f,-0.33000000f,0.96000000f,0.77000000f,-0.97000000f,0.69000000f,-0.03000000f,0.32000000f,-0.05000000f,0.38000000f,-0.13000000f,-0.67000000f,-0.29000000f,0.78000000f,0.49000000f,0.06000000f,-0.80000000f,-0.11000000f,0.67000000f,0.22000000f,-0.76000000f,-0.30000000f,-0.78000000f,0.35000000f,0.64000000f,-0.14000000f,-0.56000000f,0.01000000f,-0.67000000f,-0.73000000f,-0.00000000f,0.49000000f,0.49000000f,-0.48000000f,-0.61000000f,0.93000000f,-0.05000000f,0.14000000f,0.47000000f,-0.07000000f,0.83000000f,0.97000000f,0.07000000f,-0.41000000f,-0.19000000f,0.17000000f,0.62000000f,0.58000000f,-0.37000000f,0.48000000f,-0.62000000f,-0.36000000f,0.94000000f,0.07000000f,-0.83000000f,0.49000000f,-0.81000000f,-0.77000000f,-0.21000000f,0.15000000f,-0.48000000f,-0.65000000f,0.88000000f,0.58000000f,0.74000000f,-0.88000000f,-0.78000000f,0.70000000f,-0.18000000f,0.37000000f,-0.84000000f,-0.49000000f,-0.39000000f,0.98000000f,0.06000000f,0.25000000f,0.97000000f,0.39000000f,0.38000000f,-0.67000000f,-0.52000000f,0.65000000f,-0.66000000f,-0.53000000f,0.38000000f,-0.30000000f,-0.51000000f,0.07000000f,-0.07000000f,0.01000000f,0.73000000f,0.38000000f,0.47000000f,-0.56000000f,0.44000000f,0.78000000f,-0.98000000f,-0.99000000f,-0.31000000f,-0.72000000f,0.91000000f,0.18000000f,-0.84000000f,-0.40000000f,-0.53000000f,0.33000000f,0.13000000f,0.37000000f,0.01000000f,0.81000000f,0.00000000f,-0.19000000f,-0.02000000f,-0.73000000f,0.65000000f,0.84000000f,-0.01000000f,0.16000000f,-0.07000000f,0.64000000f,0.22000000f,0.06000000f,0.49000000f,-0.28000000f,-0.84000000f,0.81000000f,-0.94000000f,0.32000000f,-0.07000000f,0.09000000f,0.95000000f,0.99000000f,-0.56000000f,0.64000000f,0.83000000f,0.51000000f,-0.93000000f,0.18000000f,-0.50000000f,0.38000000f,-0.07000000f,0.93000000f,0.63000000f,-0.29000000f,0.87000000f,-0.04000000f,0.63000000f,0.70000000f,-0.76000000f,0.02000000f,0.02000000f,-0.88000000f,-0.63000000f,-0.18000000f,-0.30000000f,-0.48000000f,-0.42000000f,0.93000000f,0.01000000f,0.36000000f,0.97000000f,-0.25000000f,0.93000000f,0.16000000f,0.46000000f,-0.31000000f,-0.32000000f,0.20000000f,0.43000000f,-0.93000000f,0.09000000f,0.97000000f,0.53000000f,-0.86000000f,-0.33000000f,0.77000000f,0.58000000f,-0.11000000f,0.55000000f,0.94000000f,-0.42000000f,-0.48000000f,0.05000000f,0.15000000f,0.58000000f,-0.59000000f,-0.41000000f,-0.53000000f,0.05000000f,0.96000000f,0.00000000f,0.60000000f,0.56000000f,-0.18000000f,0.49000000f,-0.44000000f,0.47000000f,-0.67000000f,-0.85000000f,0.91000000f,-0.28000000f,-0.17000000f,0.62000000f,-0.96000000f,0.81000000f,0.12000000f,0.54000000f,-0.52000000f,-0.12000000f,-0.28000000f,0.82000000f,0.02000000f,-0.11000000f,-0.51000000f,-0.45000000f,0.20000000f,0.69000000f,0.07000000f,0.48000000f,-0.48000000f,-0.01000000f,0.33000000f,0.64000000f,0.15000000f,-0.79000000f,-0.11000000f,0.28000000f,0.48000000f,0.58000000f,0.95000000f,-0.89000000f,0.01000000f,-0.16000000f,-0.66000000f,-0.92000000f,0.89000000f,-0.34000000f,0.50000000f,-0.28000000f,0.08000000f,-0.74000000f,0.29000000f,-0.02000000f,0.68000000f,0.15000000f,0.95000000f,0.21000000f,-0.58000000f,-0.11000000f,0.64000000f,0.73000000f,0.87000000f,-0.96000000f,-0.64000000f,-0.60000000f,-0.79000000f,0.35000000f,-0.54000000f,-0.65000000f,0.14000000f,-0.48000000f,0.02000000f,0.36000000f,-0.45000000f,0.07000000f,0.58000000f,0.62000000f,0.73000000f,-0.92000000f,0.71000000f,-0.73000000f,-0.58000000f,-0.10000000f,0.95000000f,-0.81000000f,0.05000000f,-0.40000000f,-0.70000000f,0.03000000f,-0.45000000f,0.88000000f,-0.89000000f,0.37000000f,-0.30000000f,-0.37000000f,0.07000000f,0.28000000f,-0.11000000f,-0.38000000f,0.32000000f,0.78000000f,0.21000000f,0.43000000f,0.77000000f,-0.57000000f,0.40000000f,-0.93000000f,0.16000000f,-0.66000000f,-0.66000000f,-0.82000000f,-0.13000000f,-0.69000000f,0.77000000f,0.54000000f,0.69000000f,-0.54000000f,0.29000000f,-0.77000000f,0.14000000f,0.25000000f,-0.14000000f,-0.98000000f,0.36000000f,0.00000000f,-0.17000000f,-0.07000000f,-0.25000000f,0.25000000f,-0.30000000f,-0.53000000f,0.79000000f,0.08000000f,-0.80000000f,-0.05000000f,-0.87000000f,0.22000000f,0.35000000f,0.32000000f,0.09000000f,-0.44000000f,-0.82000000f,0.77000000f,-0.17000000f,0.47000000f,-0.89000000f,-0.83000000f,0.33000000f,0.20000000f,0.93000000f,-0.44000000f,0.89000000f,-0.27000000f,-0.95000000f,0.03000000f,-0.23000000f,0.34000000f,0.35000000f,-0.22000000f,0.56000000f,-0.36000000f,0.20000000f,0.86000000f,-0.18000000f,-0.11000000f,-0.27000000f,-0.87000000f,-0.52000000f,-0.85000000f,-0.71000000f,-0.07000000f,-0.42000000f,-0.73000000f,-0.72000000f,-0.45000000f,0.21000000f,0.22000000f,0.35000000f,-0.67000000f,0.47000000f,-0.17000000f,-0.72000000f,-0.48000000f,0.64000000f,0.68000000f,-0.06000000f,-0.60000000f,-0.82000000f,0.84000000f,0.16000000f,0.49000000f,-0.16000000f,-0.57000000f,-0.16000000f,-0.86000000f,0.05000000f,-0.91000000f,-0.02000000f,0.11000000f,0.91000000f,0.64000000f,-0.68000000f,0.93000000f,-0.25000000f,-0.46000000f,0.70000000f,0.87000000f,0.97000000f,-0.75000000f,0.73000000f,-0.70000000f,0.63000000f,-0.08000000f,0.94000000f,0.84000000f,-0.55000000f,0.29000000f,-0.75000000f,-0.18000000f,0.15000000f,0.41000000f,0.33000000f,0.81000000f,-0.95000000f,-0.12000000f,-0.47000000f,0.19000000f,-0.12000000f,-0.49000000f,0.34000000f,0.23000000f,0.36000000f,0.51000000f,-0.45000000f,-0.97000000f,0.09000000f,-0.47000000f,0.54000000f,0.32000000f,0.46000000f,0.90000000f,-0.58000000f,-0.87000000f,-0.48000000f,-0.91000000f,-0.72000000f,-0.19000000f,-0.93000000f,0.30000000f,0.91000000f,-0.78000000f,-0.46000000f,0.19000000f,0.90000000f,-0.22000000f,-0.43000000f,0.56000000f,-0.42000000f,0.99000000f,-0.46000000f,0.18000000f,-0.75000000f,-0.77000000f,0.85000000f,-0.99000000f,0.10000000f,-0.92000000f,0.68000000f,-0.07000000f,-0.81000000f,-0.57000000f,-0.57000000f,-0.31000000f,0.74000000f,-0.01000000f,0.38000000f,0.00000000f,0.05000000f,-0.85000000f,-0.28000000f,0.91000000f,-0.78000000f,0.53000000f,0.02000000f,-0.12000000f,-0.90000000f,0.21000000f,-0.22000000f,-0.01000000f,-0.87000000f,0.45000000f,-0.37000000f,0.09000000f,0.90000000f,0.15000000f,-0.14000000f,0.66000000f,0.32000000f,0.18000000f,0.87000000f,0.74000000f,-0.35000000f,0.95000000f,0.23000000f,-0.89000000f,-0.81000000f,0.95000000f,0.96000000f,-0.43000000f,0.57000000f,-0.16000000f,-0.82000000f,-0.00000000f,-0.64000000f,0.18000000f,0.01000000f,0.19000000f,-0.90000000f,-0.55000000f,0.31000000f,0.41000000f,-0.41000000f,-0.31000000f,-0.32000000f,-0.65000000f,0.08000000f,0.77000000f,0.24000000f,-0.26000000f,0.39000000f,-0.72000000f,0.75000000f,-0.49000000f,0.19000000f,0.58000000f,0.55000000f,-0.71000000f,-0.12000000f,0.96000000f,-0.78000000f,0.73000000f,0.10000000f,-0.31000000f,0.25000000f,0.78000000f,-0.70000000f,-0.11000000f,-0.87000000f,-0.00000000f,0.66000000f,0.26000000f,0.80000000f,-0.21000000f,-0.94000000f,-0.99000000f,0.94000000f,0.78000000f,0.97000000f,-0.41000000f,-0.27000000f,0.23000000f,-0.20000000f,-0.32000000f,-0.86000000f,0.51000000f,0.67000000f,0.95000000f,0.71000000f,-0.63000000f,-0.26000000f,-0.20000000f,0.79000000f,0.34000000f,0.42000000f,0.27000000f,-0.49000000f,0.99000000f,0.59000000f,-0.09000000f,-0.23000000f,-0.10000000f,0.11000000f,-0.37000000f,-0.99000000f,0.73000000f,0.81000000f,-0.38000000f,-0.57000000f,0.90000000f,0.85000000f,-0.21000000f,-0.73000000f,0.74000000f,0.42000000f,-0.77000000f,-0.04000000f,0.16000000f,0.88000000f,-0.27000000f,-0.34000000f,-0.83000000f,-0.91000000f,-0.47000000f,0.18000000f,-0.06000000f,0.40000000f,-0.10000000f,-0.74000000f,-0.45000000f,-0.24000000f,-0.27000000f,-0.44000000f,-0.49000000f,-0.96000000f,-0.46000000f,-0.12000000f,0.76000000f,0.75000000f,-0.11000000f,-0.96000000f,0.54000000f,0.00000000f,-0.26000000f,0.81000000f,0.79000000f,0.67000000f,0.20000000f,0.69000000f,0.68000000f,0.01000000f,0.17000000f,-0.84000000f,-0.28000000f,-0.05000000f,0.49000000f,0.09000000f,0.12000000f,-0.30000000f,-0.02000000f,-0.02000000f,-0.62000000f,-0.12000000f,0.76000000f,-0.24000000f,0.86000000f,0.36000000f,0.36000000f,0.25000000f,-0.34000000f,-0.57000000f,0.92000000f,-0.72000000f,0.05000000f,0.76000000f,-0.36000000f,-0.54000000f,-0.03000000f,-0.66000000f,-0.95000000f,0.52000000f,0.87000000f,0.11000000f,0.17000000f,-0.88000000f,-0.37000000f,-0.13000000f,0.18000000f,0.03000000f,0.50000000f,0.59000000f,-0.15000000f,0.36000000f,0.72000000f,0.49000000f,0.62000000f,-0.12000000f,-0.69000000f,0.15000000f,0.80000000f,0.63000000f,-0.97000000f,0.19000000f,0.59000000f,0.38000000f,-0.14000000f,-0.72000000f,-0.71000000f,-0.08000000f,-0.36000000f,-0.23000000f,0.56000000f,0.34000000f,0.14000000f,0.68000000f,-0.90000000f,-0.15000000f,0.32000000f,0.08000000f,-0.87000000f,-0.89000000f,-0.93000000f,0.39000000f,0.30000000f,0.54000000f,-0.86000000f,-0.32000000f,-0.45000000f,-0.09000000f,-0.10000000f,0.37000000f,0.18000000f,-0.83000000f,-0.38000000f,-0.53000000f,-0.67000000f,0.98000000f,-0.29000000f,-0.03000000f,-0.30000000f,0.90000000f,-0.58000000f,0.39000000f,-0.29000000f,0.10000000f,0.11000000f,0.04000000f,0.80000000f,0.21000000f,0.08000000f,0.00000000f,0.50000000f,-0.25000000f,0.75000000f,0.26000000f,0.28000000f,0.26000000f,-0.59000000f,0.56000000f,0.68000000f,0.02000000f,0.55000000f,0.81000000f,-0.78000000f,0.14000000f,0.90000000f,-0.15000000f,0.48000000f,-0.74000000f,-0.61000000f,0.31000000f,0.72000000f,-0.82000000f,0.28000000f,0.27000000f,0.82000000f,-0.67000000f,0.90000000f,-0.88000000f,0.56000000f,-0.29000000f,0.05000000f,-0.46000000f,0.67000000f,-0.21000000f,-0.33000000f,0.28000000f,0.43000000f,-0.95000000f,0.88000000f,0.97000000f,0.41000000f,-0.68000000f,0.30000000f,0.04000000f,-0.77000000f,0.14000000f,-0.67000000f,-0.96000000f,0.01000000f,-0.92000000f,-0.55000000f,0.44000000f,-0.70000000f,-0.70000000f,0.37000000f,-0.07000000f,0.39000000f,-0.12000000f,-0.27000000f,-0.71000000f,0.06000000f,0.28000000f,0.92000000f,-0.79000000f,-0.82000000f,0.52000000f,0.26000000f,-0.21000000f,0.82000000f,-0.49000000f,0.88000000f,0.47000000f,0.45000000f,0.31000000f,0.44000000f,-0.98000000f,-0.23000000f,0.44000000f,0.13000000f,0.61000000f,-0.20000000f,-0.23000000f,-0.61000000f,-0.34000000f,0.35000000f,0.56000000f,-0.16000000f,0.57000000f,-0.46000000f,-0.56000000f,-0.92000000f,-0.31000000f,0.97000000f,-0.25000000f,-0.48000000f,-0.94000000f,0.74000000f,0.02000000f,-0.61000000f,-0.71000000f,0.57000000f,0.77000000f,0.33000000f,-0.52000000f,0.38000000f,0.78000000f,-0.79000000f,0.20000000f,-0.52000000f,0.44000000f,-0.45000000f,-0.36000000f,-0.93000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.84000000f,-0.83000000f,-0.72000000f,0.39000000f,0.32000000f,-0.87000000f,0.58000000f,-0.47000000f,0.08000000f,0.08000000f,-0.55000000f,0.22000000f,0.63000000f,0.21000000f,-0.15000000f,0.08000000f,-0.79000000f,-0.42000000f,0.49000000f,-0.89000000f,0.14000000f,-0.24000000f,-0.42000000f,0.34000000f,-0.20000000f,-0.26000000f,0.90000000f,0.98000000f,0.89000000f,-0.73000000f,-0.21000000f,-0.73000000f,0.36000000f,-0.51000000f,0.56000000f,-0.67000000f,0.65000000f,0.82000000f,0.39000000f,0.18000000f,0.76000000f,-0.26000000f,-0.75000000f,-0.83000000f,-0.94000000f,-0.04000000f,-0.80000000f,-0.89000000f,0.68000000f,-0.48000000f,-0.50000000f,0.75000000f,0.22000000f,0.87000000f,-0.06000000f,0.40000000f,-0.40000000f,-0.13000000f,0.17000000f,-0.01000000f,-0.40000000f,0.75000000f,0.42000000f,0.77000000f,0.28000000f,-0.41000000f,0.12000000f,0.55000000f,0.72000000f,-0.48000000f,-0.71000000f,0.75000000f,-0.18000000f,-0.51000000f,0.55000000f,0.35000000f,0.57000000f,0.03000000f,0.86000000f,0.52000000f,0.71000000f,0.50000000f,-0.25000000f,0.83000000f,0.57000000f,-0.51000000f,0.81000000f,0.03000000f,-0.81000000f,-0.78000000f,-0.70000000f,0.27000000f,0.55000000f,0.62000000f,0.55000000f,0.68000000f,-0.05000000f,-0.73000000f,-0.28000000f,0.24000000f,-0.33000000f,0.59000000f,-0.89000000f,0.78000000f,-0.91000000f,-0.77000000f,0.11000000f,-0.73000000f,0.57000000f,-0.26000000f,-0.25000000f,0.80000000f,0.47000000f,-0.09000000f,0.71000000f,0.15000000f,0.56000000f,0.27000000f,0.11000000f,-0.27000000f,-0.69000000f,0.45000000f,0.23000000f,0.87000000f,-0.35000000f,-0.31000000f,0.73000000f,-0.30000000f,-0.65000000f,0.36000000f,0.52000000f,-0.80000000f,0.62000000f,0.25000000f,0.31000000f,-0.42000000f,-0.32000000f,0.83000000f,-0.59000000f,-0.22000000f,-0.61000000f,-0.35000000f,-0.60000000f,-0.89000000f,-0.46000000f,-0.38000000f,-0.69000000f,-0.99000000f,0.87000000f,-0.04000000f,0.47000000f,0.31000000f,-0.07000000f,-0.64000000f,0.30000000f,-0.09000000f,-0.57000000f,0.28000000f,0.39000000f,0.75000000f,-0.44000000f,-0.50000000f,0.97000000f,0.74000000f,-0.86000000f,0.59000000f,0.28000000f,-0.48000000f,-0.96000000f,0.59000000f,0.17000000f,0.43000000f,0.84000000f,-0.80000000f,0.14000000f,0.10000000f,-0.25000000f,-0.99000000f,-0.89000000f,0.12000000f,-0.67000000f,-0.24000000f,0.65000000f,-0.20000000f,-0.73000000f,0.66000000f,0.80000000f,-0.46000000f,-0.32000000f,-0.60000000f,0.79000000f,-0.99000000f,0.22000000f,0.30000000f,-0.33000000f,0.49000000f,0.71000000f,-0.59000000f,-0.47000000f,-0.36000000f,0.93000000f,0.67000000f,-0.66000000f,-0.48000000f,0.04000000f,-0.11000000f,0.22000000f,0.55000000f,0.31000000f,0.26000000f,0.17000000f,-0.12000000f,0.39000000f,0.40000000f,-0.13000000f,0.44000000f,-0.36000000f,0.81000000f,0.69000000f,-0.47000000f,-0.07000000f,-0.94000000f,-0.06000000f,0.45000000f,-0.47000000f,0.12000000f,0.30000000f,0.81000000f,-0.50000000f,0.64000000f,0.56000000f,-0.01000000f,0.43000000f,-0.24000000f,0.45000000f,-0.30000000f,0.56000000f,-0.13000000f,0.44000000f,-0.17000000f,0.17000000f,0.76000000f,-0.32000000f,-0.49000000f,-0.13000000f,0.07000000f,-0.43000000f,-0.50000000f,-0.80000000f,-0.07000000f,-0.13000000f,0.93000000f,0.13000000f,-0.29000000f,-0.39000000f,0.53000000f,-0.89000000f,0.67000000f,0.25000000f,0.42000000f,-0.29000000f,0.48000000f,-0.37000000f,0.99000000f,0.99000000f,-0.12000000f,0.36000000f,0.64000000f,-0.79000000f,0.85000000f,-0.97000000f,-0.01000000f,-0.51000000f,-0.54000000f,-0.02000000f,-0.79000000f,-0.70000000f,-0.61000000f,0.24000000f,-0.12000000f,0.82000000f,0.18000000f,-0.91000000f,-0.83000000f,-0.90000000f,-0.32000000f,-0.14000000f,0.51000000f,0.05000000f,-0.63000000f,0.49000000f,0.57000000f,-0.31000000f,-0.97000000f,0.77000000f,-0.48000000f,0.05000000f,-0.75000000f,-0.72000000f,0.47000000f,-0.55000000f,0.19000000f,-0.76000000f,0.39000000f,-0.06000000f,-0.66000000f,0.20000000f,-0.85000000f,-0.09000000f,-0.76000000f,-0.84000000f,0.09000000f,0.74000000f,-0.09000000f,-0.75000000f,-0.69000000f,0.18000000f,0.27000000f,0.74000000f,0.73000000f,0.29000000f,0.70000000f,-0.59000000f,0.91000000f,0.93000000f,0.83000000f,0.40000000f,-0.87000000f,-0.29000000f,-0.93000000f,-0.33000000f,0.88000000f,-0.95000000f,-0.81000000f,-0.71000000f,0.96000000f,-0.37000000f,-0.39000000f,-0.23000000f,0.08000000f,0.71000000f,-0.18000000f,0.23000000f,0.61000000f,0.05000000f,0.19000000f,-0.19000000f,-0.81000000f,-0.05000000f,0.63000000f,0.84000000f,-0.12000000f,-0.33000000f,0.27000000f,0.49000000f,-0.29000000f,-0.30000000f,0.70000000f,-0.82000000f,-0.59000000f,0.59000000f,-0.28000000f,0.10000000f,-0.24000000f,0.13000000f,0.85000000f,-0.54000000f,-0.63000000f,0.65000000f,-0.06000000f,-0.59000000f,-0.97000000f,-0.36000000f,-0.40000000f,-0.34000000f,0.84000000f,-0.25000000f,0.77000000f,0.22000000f,0.87000000f,0.91000000f,-0.78000000f,0.74000000f,-0.13000000f,0.13000000f,0.07000000f,0.15000000f,0.92000000f,0.17000000f,-0.51000000f,0.06000000f,0.79000000f,-0.51000000f,-0.76000000f,-0.19000000f,-0.22000000f,0.74000000f,-0.31000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.97000000f,-0.59000000f,0.39000000f,-0.58000000f,-0.70000000f,-0.29000000f,0.44000000f,-0.71000000f,-0.77000000f,-0.83000000f,0.17000000f,-0.55000000f,-0.47000000f,0.98000000f,0.74000000f,-0.04000000f,0.57000000f,0.05000000f,0.64000000f,-0.53000000f,-0.23000000f,-0.15000000f,0.87000000f,-0.86000000f,0.45000000f,0.50000000f,-0.58000000f,0.35000000f,-0.89000000f,0.59000000f,-0.34000000f,-0.12000000f,-0.56000000f,-0.08000000f,0.93000000f,0.93000000f,0.27000000f,-0.60000000f,0.06000000f,0.47000000f,0.22000000f,0.49000000f,0.67000000f,-0.30000000f,0.83000000f,-0.13000000f,0.86000000f,-0.86000000f,-0.79000000f,-0.41000000f,0.30000000f,0.56000000f,0.88000000f,0.17000000f,0.40000000f,-0.84000000f,0.84000000f,-0.18000000f,0.95000000f,-0.17000000f,-0.52000000f,0.14000000f,0.04000000f,0.96000000f,0.21000000f,-0.42000000f,0.92000000f,0.32000000f,-0.24000000f,-0.11000000f,0.26000000f,-0.60000000f,-0.68000000f,0.91000000f,-0.37000000f,0.11000000f,0.76000000f,0.31000000f,0.39000000f,-0.25000000f,-0.10000000f,0.63000000f,0.20000000f,0.83000000f,-0.49000000f,0.71000000f,0.42000000f,-0.01000000f,0.15000000f,-0.47000000f,-0.13000000f,-0.69000000f,0.17000000f,0.90000000f,-0.21000000f,0.14000000f,0.60000000f,0.39000000f,-0.16000000f,0.23000000f,-0.33000000f,0.88000000f,-0.78000000f,-0.87000000f,0.15000000f,-0.68000000f,0.53000000f,-0.11000000f,0.43000000f,-0.54000000f,-0.57000000f,0.87000000f,0.81000000f,0.13000000f,-0.07000000f,0.18000000f,-0.32000000f,-0.85000000f,0.35000000f,-0.32000000f,0.75000000f,-0.80000000f,0.79000000f,-0.12000000f,0.55000000f,0.06000000f,-0.95000000f,0.50000000f,0.99000000f,-0.88000000f,0.75000000f,-0.69000000f,-0.23000000f,-0.53000000f,0.93000000f,-0.57000000f,0.29000000f,0.58000000f,-0.42000000f,0.75000000f,-0.92000000f,-0.13000000f,-0.16000000f,0.28000000f,-0.90000000f,-0.17000000f,-0.74000000f,-0.55000000f,0.99000000f,-0.82000000f,-0.24000000f,-0.43000000f,-0.52000000f,-0.45000000f,-0.02000000f,-0.70000000f,-0.26000000f,0.74000000f,0.21000000f,0.97000000f,-0.10000000f,-0.65000000f,-0.18000000f,-0.06000000f,-0.60000000f,0.54000000f,-0.76000000f,0.23000000f,0.21000000f,0.44000000f,0.06000000f,-0.80000000f,-0.87000000f,-0.13000000f,0.92000000f,0.97000000f,-0.04000000f,0.35000000f,-0.44000000f,-0.00000000f,-0.78000000f,-0.54000000f,-0.91000000f,0.19000000f,0.97000000f,-0.60000000f,0.35000000f,-0.64000000f,-0.84000000f,0.25000000f,0.90000000f,0.17000000f,-0.26000000f,-0.82000000f,0.59000000f,-0.62000000f,-0.14000000f,0.41000000f,0.62000000f,0.91000000f,-0.73000000f,0.62000000f,0.87000000f,0.50000000f,0.55000000f,-0.72000000f,0.00000000f,-0.19000000f,0.90000000f,0.30000000f,0.09000000f,-0.10000000f,-0.90000000f,0.66000000f,0.77000000f,0.63000000f,-0.07000000f,-0.92000000f,-0.63000000f,-0.86000000f,-0.08000000f,0.09000000f,0.38000000f,0.58000000f,0.76000000f,-0.98000000f,0.83000000f,-0.05000000f,-0.37000000f,0.52000000f,-0.57000000f,-0.31000000f,-0.47000000f,-0.49000000f,0.42000000f,-0.13000000f,-0.79000000f,0.60000000f,-0.08000000f,-0.12000000f,0.65000000f,-0.48000000f,0.79000000f,0.22000000f,0.71000000f,0.70000000f,0.78000000f,-0.25000000f,-0.05000000f,0.48000000f,0.14000000f,-0.85000000f,0.50000000f,-0.86000000f,0.31000000f,0.60000000f,0.72000000f,0.82000000f,-0.46000000f,-0.65000000f,-0.54000000f,0.26000000f,0.17000000f,-0.02000000f,-0.48000000f,0.36000000f,-0.63000000f,0.84000000f,0.62000000f,0.59000000f,-0.74000000f,0.00000000f,0.45000000f,0.08000000f,-0.54000000f,-0.34000000f,0.79000000f,0.38000000f,-0.17000000f,0.41000000f,0.30000000f,0.06000000f,0.22000000f,0.59000000f,0.23000000f,-0.36000000f,0.85000000f,-0.00000000f,-0.93000000f,0.74000000f,0.06000000f,-0.99000000f,-0.06000000f,-0.48000000f,0.27000000f,-0.97000000f,-0.44000000f,-0.12000000f,0.46000000f,-0.63000000f,-0.57000000f,-0.98000000f,0.72000000f,0.59000000f,-0.81000000f,0.96000000f,0.64000000f,-0.59000000f,0.13000000f,-0.80000000f,0.43000000f,0.23000000f,-0.66000000f,-0.74000000f,-0.52000000f,0.39000000f,-0.60000000f,-0.92000000f,0.49000000f,0.03000000f,0.84000000f,-0.72000000f,-0.97000000f,-0.81000000f,0.17000000f,0.79000000f,0.69000000f,-0.66000000f,0.11000000f,0.40000000f,-0.37000000f,0.46000000f,-0.74000000f,-0.50000000f,0.81000000f,-0.90000000f,0.66000000f,-0.06000000f,-0.42000000f,0.47000000f,0.12000000f,0.59000000f,-0.26000000f,0.12000000f,-0.93000000f,0.61000000f,-0.19000000f,-0.96000000f,-0.63000000f,-0.86000000f,-0.96000000f,0.33000000f,-0.80000000f,-0.31000000f,-0.22000000f,-0.73000000f,-0.39000000f,0.69000000f,-0.59000000f,0.17000000f,-0.24000000f,0.75000000f,-0.61000000f,-0.90000000f,0.23000000f,0.75000000f,-0.51000000f,-0.08000000f,-0.47000000f,0.37000000f,-0.30000000f,0.36000000f,0.75000000f,0.93000000f,0.97000000f,0.52000000f,0.64000000f,0.98000000f,-0.05000000f,0.34000000f,-0.66000000f,0.60000000f,0.44000000f,0.48000000f,0.53000000f,-0.61000000f,-0.57000000f,0.18000000f,-0.28000000f,0.80000000f,0.14000000f,0.31000000f,-0.54000000f,-0.56000000f,0.48000000f,0.28000000f,-0.86000000f,-0.04000000f,-0.12000000f,-0.97000000f,0.87000000f,-0.82000000f,-0.33000000f,-0.75000000f,0.67000000f,-0.05000000f,0.83000000f,0.14000000f,0.84000000f,-0.47000000f,0.25000000f,-0.52000000f,-0.48000000f,-0.86000000f,0.15000000f,0.19000000f,-0.45000000f,-0.48000000f,-0.33000000f,-0.98000000f,-0.61000000f,0.13000000f,0.83000000f,-0.45000000f,0.78000000f,0.16000000f,-0.52000000f,0.37000000f,0.07000000f,-0.98000000f,0.78000000f,0.91000000f,-0.26000000f,-0.30000000f,0.10000000f,-0.92000000f,0.17000000f,0.10000000f,0.44000000f,-0.31000000f,-0.50000000f,-0.85000000f,-0.29000000f,0.85000000f,-0.47000000f,0.13000000f,-0.59000000f,-0.71000000f,0.34000000f,0.39000000f,-0.72000000f,-0.46000000f,-0.66000000f,0.44000000f,0.95000000f,0.09000000f,-0.10000000f,0.81000000f,0.37000000f,-0.82000000f,0.24000000f,-0.58000000f,-0.79000000f,0.61000000f,-0.73000000f,0.45000000f,-0.76000000f,-0.55000000f,-0.06000000f,-0.59000000f,-0.04000000f,0.42000000f,0.08000000f,-0.51000000f,-0.87000000f,-0.54000000f,-0.25000000f,0.51000000f,-0.14000000f,0.78000000f,0.06000000f,0.44000000f,-0.40000000f,0.11000000f,-0.47000000f,0.36000000f,0.23000000f,0.12000000f,0.49000000f,-0.40000000f,-0.39000000f,0.45000000f,0.74000000f,-0.99000000f,-0.21000000f,0.03000000f,0.85000000f,0.59000000f,0.67000000f,0.15000000f,0.74000000f,0.34000000f,-0.49000000f,-0.59000000f,-0.82000000f,-0.82000000f,0.60000000f,0.12000000f,-0.61000000f,-0.19000000f,0.52000000f,-0.32000000f,0.96000000f,0.46000000f,0.95000000f,0.27000000f,0.97000000f,-0.01000000f,0.18000000f,0.81000000f,-0.55000000f,0.05000000f,-0.76000000f,-0.74000000f,0.08000000f,0.58000000f,-0.77000000f,0.43000000f,-0.55000000f,-0.78000000f,0.37000000f,0.39000000f,-0.37000000f,-0.03000000f,-0.75000000f,-0.46000000f,0.96000000f,0.50000000f,0.55000000f,-0.81000000f,0.39000000f,-0.54000000f,0.42000000f,-0.92000000f,-0.40000000f,0.31000000f,0.16000000f,-0.87000000f,-0.58000000f,0.41000000f,-0.31000000f,-0.74000000f,-0.36000000f,0.18000000f,0.00000000f,0.32000000f,0.32000000f,0.39000000f,-0.91000000f,0.50000000f,0.75000000f,0.38000000f,0.60000000f,0.11000000f,-0.56000000f,0.61000000f,-0.92000000f,0.38000000f,0.10000000f,-0.30000000f,-0.42000000f,0.35000000f,-0.51000000f,0.58000000f,0.84000000f,-0.37000000f,-0.00000000f,0.82000000f,0.15000000f,0.82000000f,-0.89000000f,0.34000000f,0.29000000f,-0.45000000f,-0.31000000f,-0.54000000f,0.02000000f,-0.69000000f,0.15000000f,-0.77000000f,-0.14000000f,-0.89000000f,-0.19000000f,-0.03000000f,-0.41000000f,0.20000000f,-0.28000000f,-0.60000000f,0.25000000f,-0.18000000f,0.82000000f,-0.38000000f,-0.20000000f,-0.25000000f,-0.18000000f,-0.85000000f,0.88000000f,-0.02000000f,0.97000000f,0.62000000f,-0.97000000f,0.63000000f,0.36000000f,-0.13000000f,-0.93000000f,-0.84000000f,0.63000000f,0.87000000f,-0.18000000f,-0.34000000f,-0.72000000f,0.63000000f,0.13000000f,-0.05000000f,-0.56000000f,0.81000000f,-0.19000000f,-0.89000000f,0.61000000f,0.71000000f,0.22000000f,0.45000000f,-0.44000000f,0.89000000f,0.67000000f,0.47000000f,0.85000000f,-0.50000000f,-0.03000000f,-0.73000000f,0.20000000f,-0.86000000f,0.71000000f,-0.12000000f,-0.16000000f,0.50000000f,0.47000000f,-0.95000000f,-0.37000000f,0.81000000f,0.85000000f,0.69000000f,0.46000000f,-0.77000000f,0.25000000f,0.15000000f,0.09000000f,-0.12000000f,-0.32000000f,0.93000000f,-0.04000000f,-0.66000000f,-0.41000000f,-0.91000000f,-0.84000000f,-0.32000000f,-0.51000000f,0.65000000f,0.09000000f,-0.18000000f,0.80000000f,0.55000000f,-0.30000000f,0.56000000f,0.22000000f,0.28000000f,-0.48000000f,-0.61000000f,-0.15000000f,-0.65000000f,-0.38000000f,0.03000000f,-0.83000000f,0.61000000f,0.83000000f,-0.14000000f,0.39000000f,-0.44000000f,-0.49000000f,-0.70000000f,0.35000000f,-0.72000000f,0.51000000f,0.09000000f,0.31000000f,0.98000000f,0.63000000f,0.74000000f,0.25000000f,-0.30000000f,0.20000000f,0.08000000f,0.81000000f,0.69000000f,0.16000000f,-0.85000000f,0.69000000f,0.20000000f,-0.68000000f,0.99000000f,0.14000000f,-0.65000000f,-0.21000000f,0.03000000f,0.06000000f,-0.16000000f,0.80000000f,0.95000000f,0.90000000f,-0.13000000f,0.05000000f,0.84000000f,0.56000000f,-0.42000000f,-0.58000000f,0.02000000f,-0.16000000f,-0.68000000f,0.03000000f,0.94000000f,-0.20000000f,-0.99000000f,0.99000000f,-0.20000000f,-0.69000000f,0.25000000f,-0.00000000f,0.55000000f,-0.11000000f,0.74000000f,0.96000000f,-0.12000000f,-0.50000000f,0.81000000f,0.97000000f,-0.56000000f,0.40000000f,0.94000000f,0.34000000f,-0.98000000f,-0.04000000f,-0.45000000f,-0.89000000f,-0.04000000f,-0.07000000f,-0.35000000f,0.58000000f,-0.52000000f,0.85000000f,0.94000000f,-0.92000000f,-0.46000000f,-0.51000000f,-0.30000000f,-0.98000000f,0.04000000f,0.45000000f,-0.08000000f,0.53000000f,-0.78000000f,0.43000000f,0.90000000f,-0.48000000f,-0.31000000f,-0.84000000f,-0.70000000f,-0.79000000f,-0.33000000f,0.13000000f,0.68000000f,-0.44000000f,0.21000000f,0.62000000f,0.73000000f,0.15000000f,0.72000000f,0.31000000f,0.21000000f,-0.78000000f,-0.89000000f,-0.96000000f,-0.69000000f,0.12000000f,0.45000000f,-0.47000000f,-0.91000000f,-0.33000000f,0.75000000f,0.87000000f,0.35000000f,-0.33000000f,0.08000000f,0.34000000f,-0.93000000f,0.55000000f,-0.30000000f,0.93000000f,0.60000000f,-0.06000000f,0.89000000f,-0.84000000f,-0.34000000f,0.59000000f,0.20000000f,-0.63000000f,-0.40000000f,0.10000000f,-0.47000000f,-0.79000000f,-0.05000000f,-0.28000000f,-0.97000000f,0.68000000f,0.58000000f,-0.96000000f,-0.32000000f,0.09000000f,-0.14000000f,0.20000000f,0.86000000f,0.33000000f,-0.27000000f,-0.62000000f,0.99000000f,-0.56000000f,0.87000000f,-0.75000000f,-0.53000000f,0.86000000f,-0.44000000f,-0.38000000f,-0.30000000f,-0.73000000f,-0.95000000f,-0.19000000f,0.16000000f,-0.16000000f,-0.87000000f,-0.41000000f,0.77000000f,-0.40000000f,0.90000000f,-0.10000000f,0.67000000f,-0.28000000f,-0.81000000f,0.66000000f,-0.97000000f,-0.21000000f,-0.08000000f,-0.57000000f,-0.80000000f,0.07000000f,-0.86000000f,-0.94000000f,-0.33000000f,-0.43000000f,-0.63000000f,0.52000000f,-0.74000000f,-0.07000000f,-0.17000000f,0.75000000f,0.10000000f,0.97000000f,0.70000000f,-0.01000000f,0.13000000f,0.28000000f,-0.59000000f,-0.25000000f,0.39000000f,0.44000000f,0.18000000f,0.38000000f,-0.95000000f,0.93000000f,-0.80000000f,0.37000000f,0.08000000f,0.42000000f,-0.84000000f,-0.05000000f,0.21000000f,0.96000000f,0.93000000f,-0.60000000f,0.96000000f,-0.50000000f,0.17000000f,-0.74000000f,0.47000000f,-0.16000000f,-0.05000000f,-0.36000000f,-0.46000000f,-0.62000000f,0.95000000f,0.44000000f,-0.45000000f,0.42000000f,-0.31000000f,0.79000000f,0.37000000f,-0.21000000f,-0.78000000f,-0.08000000f,-0.70000000f,-0.83000000f,0.02000000f,0.10000000f,-0.45000000f,-0.12000000f,-0.45000000f,-0.90000000f,0.95000000f,0.60000000f,0.34000000f,-0.38000000f,-0.22000000f,0.37000000f,0.04000000f,-0.21000000f,-0.63000000f,0.10000000f,0.61000000f,-0.76000000f,-0.48000000f,-0.45000000f,0.27000000f,0.96000000f,0.75000000f,0.09000000f,0.77000000f,0.99000000f,-0.35000000f,0.81000000f,0.95000000f,0.14000000f,-0.41000000f,-0.54000000f,-0.43000000f,0.25000000f,0.36000000f,-0.61000000f,-0.11000000f,0.83000000f,0.14000000f,0.56000000f,-0.42000000f,0.80000000f,0.35000000f,0.11000000f,-0.51000000f,-0.68000000f,-0.28000000f,0.05000000f,0.54000000f,-0.01000000f,-0.74000000f,-0.19000000f,-0.91000000f,0.86000000f,-0.05000000f,0.19000000f,-0.71000000f,-0.22000000f,0.39000000f,0.97000000f,0.08000000f,0.92000000f,-0.36000000f,0.29000000f,0.08000000f,0.99000000f,-0.31000000f,-0.94000000f,-0.37000000f,0.17000000f,0.41000000f,0.41000000f,-0.57000000f,-0.56000000f,-0.05000000f,0.88000000f,0.19000000f,0.91000000f,0.34000000f,0.07000000f,0.39000000f,-0.56000000f,0.76000000f,0.87000000f,-0.82000000f,0.79000000f,-0.29000000f,0.29000000f,0.79000000f,-0.00000000f,-0.68000000f,0.22000000f,0.75000000f,-0.29000000f,-0.92000000f,-0.57000000f,0.88000000f,-0.78000000f,-0.99000000f,0.88000000f,0.34000000f,0.82000000f,0.86000000f,-0.17000000f,0.79000000f,0.12000000f,0.42000000f,-0.50000000f,0.23000000f,0.83000000f,0.25000000f,0.77000000f,0.62000000f,-0.81000000f,-0.24000000f,0.47000000f,-0.49000000f,-0.45000000f,0.06000000f,-0.38000000f,-0.01000000f,0.15000000f,-0.16000000f,-0.63000000f,-0.25000000f,-0.99000000f,0.24000000f,0.85000000f,-0.69000000f,-0.37000000f,-0.27000000f,0.01000000f,-0.22000000f,0.73000000f,0.63000000f,-0.48000000f,0.87000000f,0.90000000f,-0.64000000f,0.68000000f,0.59000000f,0.11000000f,-0.83000000f,0.17000000f,0.87000000f,-0.88000000f,0.76000000f,-0.85000000f,-0.20000000f,0.94000000f,0.71000000f,0.16000000f,-0.40000000f,-0.73000000f,0.91000000f,0.61000000f,0.89000000f,-0.73000000f,0.79000000f,-0.48000000f,-0.18000000f,0.74000000f,0.64000000f,-0.74000000f,-0.89000000f,-0.84000000f,-0.28000000f,-0.00000000f,0.45000000f,0.50000000f,0.78000000f,0.84000000f,-0.54000000f,0.66000000f,0.67000000f,-0.58000000f,-0.67000000f,0.09000000f,-0.93000000f,-0.50000000f,-0.71000000f,-0.57000000f,0.44000000f,-0.20000000f,0.42000000f,-0.65000000f,-0.81000000f,0.37000000f,0.21000000f,-0.82000000f,-0.16000000f,0.84000000f,0.04000000f,0.51000000f,0.33000000f,-0.43000000f,0.44000000f,-0.82000000f,0.92000000f,-0.33000000f,-0.92000000f,0.76000000f,-0.33000000f,0.83000000f,-0.21000000f,-0.25000000f,0.28000000f,0.78000000f,0.70000000f,0.04000000f,0.65000000f,-0.44000000f,0.28000000f,-0.61000000f,-0.85000000f,0.26000000f,-0.86000000f,0.41000000f,0.02000000f,-0.44000000f,0.93000000f,0.27000000f,0.79000000f,-0.60000000f,0.91000000f,-0.25000000f,-0.92000000f,0.13000000f,0.87000000f,-0.29000000f,-0.89000000f,-0.56000000f,-0.91000000f,-0.95000000f,-0.72000000f,-0.62000000f,-0.99000000f,-0.89000000f,-0.89000000f,0.64000000f,-0.08000000f,0.70000000f,-0.78000000f,0.82000000f,-0.54000000f,0.97000000f,-0.26000000f,0.12000000f,0.46000000f,-0.26000000f,-0.46000000f,-0.65000000f,0.04000000f,-0.50000000f,0.34000000f,-0.78000000f,-0.54000000f,-0.29000000f,0.13000000f,0.19000000f,0.01000000f,-0.77000000f,-0.20000000f,-0.98000000f,0.43000000f,0.37000000f,0.80000000f,-0.97000000f,-0.99000000f,-0.66000000f,0.55000000f,0.85000000f,0.45000000f,0.58000000f,-0.29000000f,-0.54000000f,-0.95000000f,0.41000000f,0.14000000f,-0.84000000f,0.13000000f,0.06000000f,0.37000000f,0.23000000f,0.76000000f,0.88000000f,0.12000000f,-0.84000000f,-0.53000000f,-0.26000000f,0.26000000f,0.67000000f,-0.24000000f,0.76000000f,0.76000000f,0.12000000f,-0.13000000f,-0.05000000f,-0.12000000f,0.92000000f,0.40000000f,-0.68000000f,0.68000000f,0.00000000f,0.19000000f,-0.72000000f,0.06000000f,-0.66000000f,0.55000000f,0.77000000f,-0.71000000f,0.84000000f,0.59000000f,0.15000000f,0.27000000f,0.38000000f,-0.99000000f,-0.03000000f,0.65000000f,-0.94000000f,0.55000000f,-0.51000000f,0.40000000f,0.32000000f,0.33000000f,-0.93000000f,0.49000000f,0.83000000f,0.98000000f,0.32000000f,-0.45000000f,0.32000000f,-0.22000000f,0.37000000f,-0.35000000f,-0.30000000f,-0.63000000f,-0.72000000f,0.86000000f,-0.95000000f,0.70000000f,0.44000000f,0.12000000f,-0.66000000f,0.39000000f,0.67000000f,-0.56000000f,-0.25000000f,-0.64000000f,-0.15000000f,0.33000000f,0.37000000f,-0.26000000f,0.65000000f,0.13000000f,-0.98000000f,-0.27000000f,-0.94000000f,0.90000000f,-0.30000000f,-0.35000000f,0.24000000f,0.20000000f,-0.93000000f,0.24000000f,-0.17000000f,-0.80000000f,0.24000000f,0.92000000f,-0.81000000f,-0.61000000f,0.05000000f,-0.72000000f,0.12000000f,0.95000000f,-0.07000000f,-0.04000000f,0.74000000f,-0.10000000f,-0.07000000f,-0.55000000f,-0.07000000f,0.21000000f,-0.77000000f,-0.79000000f,0.52000000f,-0.76000000f,-0.02000000f,-0.18000000f,-0.88000000f,-0.76000000f,0.78000000f,-0.74000000f,-0.22000000f,0.26000000f,-0.51000000f,0.91000000f,0.33000000f,0.82000000f,0.67000000f,0.89000000f,-0.57000000f,0.47000000f,-0.30000000f,0.06000000f,0.46000000f,0.40000000f,0.33000000f,0.36000000f,-0.12000000f,0.80000000f,-0.46000000f,0.69000000f,0.60000000f,0.96000000f,0.69000000f,-0.85000000f,-0.16000000f,-0.44000000f,-0.13000000f,-0.58000000f,-0.93000000f,0.05000000f,0.51000000f,-0.02000000f,0.79000000f,-0.36000000f,0.27000000f,0.74000000f,0.67000000f,0.61000000f,-0.67000000f,-0.97000000f,-0.01000000f,0.78000000f,-0.94000000f,0.11000000f,-0.35000000f,-0.45000000f,-0.27000000f,0.51000000f,0.07000000f,-0.34000000f,0.46000000f,0.85000000f,-0.25000000f,0.84000000f,0.40000000f,-0.68000000f,-0.66000000f,-0.89000000f,0.72000000f,-0.52000000f,-0.46000000f,-0.19000000f,0.91000000f,0.09000000f,-0.56000000f,0.16000000f,0.01000000f,-0.29000000f,0.86000000f,-0.05000000f,0.50000000f,-0.98000000f,0.98000000f,-0.25000000f,0.21000000f,-0.52000000f,-0.45000000f,0.07000000f,0.97000000f,0.62000000f,0.51000000f,0.91000000f,-0.42000000f,0.80000000f,-0.33000000f,-0.77000000f,-0.98000000f,0.82000000f,-0.35000000f,0.96000000f,0.25000000f,-0.54000000f,0.50000000f,-0.66000000f,0.54000000f,-0.14000000f,0.53000000f,-0.96000000f,-0.05000000f,-0.85000000f,-0.03000000f,0.12000000f,-0.71000000f,-0.06000000f,0.47000000f,-0.80000000f,0.70000000f,0.88000000f,0.57000000f,-0.07000000f,-0.04000000f,-0.13000000f,0.80000000f,0.59000000f,-0.23000000f,-0.66000000f,-0.34000000f,-0.78000000f,0.95000000f,0.14000000f,0.24000000f,-0.37000000f,-0.29000000f,0.51000000f,-0.94000000f,-0.93000000f,-0.62000000f,-0.68000000f,0.58000000f,-0.13000000f,0.16000000f,0.50000000f,-0.23000000f,-0.01000000f,-0.24000000f,0.82000000f,-0.07000000f,-0.01000000f,-0.49000000f,0.23000000f,-0.00000000f,0.83000000f,-0.60000000f,0.72000000f,0.34000000f,-0.12000000f,-0.11000000f,-0.07000000f,0.01000000f,0.15000000f,-0.23000000f,0.58000000f,-0.60000000f,0.74000000f,0.43000000f,-0.15000000f,-0.41000000f,-0.29000000f,0.66000000f,0.60000000f,0.74000000f,-0.13000000f,0.48000000f,-0.13000000f,-0.35000000f,0.29000000f,-0.64000000f,-0.76000000f,0.27000000f,0.56000000f,0.72000000f,0.51000000f,-0.75000000f,-0.30000000f,0.53000000f,-0.62000000f,0.64000000f,0.11000000f,-0.93000000f,-0.12000000f,-0.43000000f,0.96000000f,0.49000000f,-0.66000000f,0.47000000f,-0.96000000f,-0.60000000f,0.72000000f,0.64000000f,0.39000000f,-0.53000000f,-0.61000000f,-0.37000000f,0.99000000f,-0.74000000f,0.50000000f,-0.32000000f,0.82000000f,-0.98000000f,-0.06000000f,-0.68000000f,0.32000000f,-0.28000000f,-0.64000000f,0.30000000f,-0.44000000f,0.60000000f,0.16000000f,-0.29000000f,-0.21000000f,-0.12000000f,0.19000000f,0.26000000f,-0.32000000f,-0.90000000f,0.88000000f,0.96000000f,-0.28000000f,0.51000000f,-0.86000000f,0.28000000f,0.43000000f,0.82000000f,-0.21000000f,-0.15000000f,0.15000000f,-0.70000000f,-0.70000000f,0.05000000f,-0.82000000f,-0.85000000f,-0.57000000f,0.13000000f,-0.22000000f,0.53000000f,0.80000000f,0.43000000f,0.30000000f,-0.77000000f,-0.95000000f,0.95000000f,0.95000000f,-0.21000000f,0.56000000f,0.56000000f,-0.66000000f,-0.70000000f,-0.03000000f,0.51000000f,0.79000000f,0.00000000f,-0.68000000f,0.25000000f,-0.15000000f,0.12000000f,0.07000000f,-0.18000000f,-0.57000000f,0.81000000f,0.22000000f,-0.80000000f,0.14000000f,0.14000000f,0.19000000f,0.65000000f,-0.06000000f,0.72000000f,-0.96000000f,-0.93000000f,-0.96000000f,-0.35000000f,0.06000000f,0.92000000f,-0.01000000f,-0.16000000f,0.13000000f,0.00000000f,-0.24000000f,0.79000000f,-0.15000000f,-0.29000000f,-0.83000000f,-0.38000000f,-0.91000000f,-0.17000000f,-0.21000000f,-0.89000000f,-0.24000000f,0.40000000f,-0.43000000f,-0.31000000f,0.45000000f,0.74000000f,0.77000000f,-0.98000000f,0.53000000f,0.87000000f,-0.42000000f,-0.37000000f,-0.95000000f,0.02000000f,-0.03000000f,0.21000000f,-0.39000000f,-0.27000000f,-0.66000000f,0.62000000f,-0.34000000f,0.34000000f,0.89000000f,-0.64000000f,-0.65000000f,-0.51000000f,-0.98000000f,0.14000000f,-0.49000000f,0.27000000f,0.10000000f,-0.71000000f,-0.20000000f,-0.01000000f,-0.51000000f,0.50000000f,-0.30000000f,0.98000000f,-0.46000000f,0.10000000f,-0.60000000f,-0.71000000f,-0.95000000f,0.49000000f,0.59000000f,0.00000000f,-0.19000000f,0.11000000f,-0.41000000f,0.08000000f,-0.50000000f,0.48000000f,0.19000000f,-0.80000000f,0.55000000f,-0.27000000f,0.14000000f,-0.66000000f,0.04000000f,-0.16000000f,-0.40000000f,0.18000000f,-0.50000000f,0.89000000f,-0.98000000f,0.27000000f,-0.39000000f,0.91000000f,-0.07000000f,-0.88000000f,-0.76000000f,-0.34000000f,0.10000000f,0.80000000f,-0.05000000f,-0.31000000f,-0.87000000f,0.65000000f,0.26000000f,-0.62000000f,0.55000000f,0.57000000f,-0.98000000f,0.11000000f,0.14000000f,-0.63000000f,-0.39000000f,0.13000000f,-0.87000000f,-0.60000000f,0.92000000f,-0.08000000f,-0.88000000f,0.08000000f,-0.82000000f,-0.12000000f,0.71000000f,0.41000000f,-0.81000000f,0.17000000f,0.16000000f,-0.52000000f,-0.44000000f,-0.58000000f,0.24000000f,-0.16000000f,0.42000000f,-0.87000000f,-0.41000000f,0.86000000f,0.51000000f,-0.42000000f,0.57000000f,0.44000000f,-0.90000000f,-0.37000000f,-0.11000000f,-0.13000000f,0.12000000f,-0.13000000f,-0.80000000f,-0.44000000f,-0.12000000f,0.76000000f,-0.65000000f,-0.00000000f,0.94000000f,-0.49000000f,0.64000000f,-0.20000000f,-0.02000000f,-0.30000000f,-0.70000000f,0.81000000f,0.37000000f,-0.12000000f,0.06000000f,-0.73000000f,-0.99000000f,-0.24000000f,0.66000000f,0.32000000f,-0.94000000f,0.29000000f,0.47000000f,0.32000000f,-0.20000000f,0.90000000f,0.37000000f,0.14000000f,-0.65000000f,-0.30000000f,0.03000000f,-0.81000000f,-0.85000000f,-0.45000000f,0.95000000f,0.52000000f,-0.64000000f,0.70000000f,-0.32000000f,-0.50000000f,0.34000000f,0.33000000f,0.44000000f,0.94000000f,0.39000000f,0.78000000f,-0.99000000f,0.35000000f,-0.04000000f,0.56000000f,-0.65000000f,0.33000000f,-0.57000000f,0.23000000f,-0.17000000f,-0.97000000f,0.70000000f,-0.68000000f,-0.23000000f,-0.60000000f,0.20000000f,-0.93000000f,0.00000000f,0.16000000f,0.92000000f,-0.19000000f,0.72000000f,0.28000000f,0.55000000f,0.97000000f,0.44000000f,-0.40000000f,-0.03000000f,0.86000000f,0.27000000f,0.31000000f,-0.50000000f,0.16000000f,0.03000000f,-0.49000000f,-0.09000000f,-0.64000000f,-0.17000000f,-0.01000000f,0.88000000f,0.07000000f,0.45000000f,-0.45000000f,-0.36000000f,-0.40000000f,0.69000000f,-0.54000000f,-0.44000000f,-0.74000000f,0.00000000f,-0.49000000f,-0.40000000f,-0.92000000f,0.16000000f,-0.21000000f,-0.39000000f,-0.26000000f,-0.63000000f,0.14000000f,-0.53000000f,0.31000000f,-0.83000000f,0.33000000f,0.31000000f,0.06000000f,-0.88000000f,0.12000000f,-0.20000000f,0.63000000f,0.35000000f,0.79000000f,-0.25000000f,0.77000000f,-0.79000000f,0.16000000f,0.64000000f,-0.49000000f,-0.14000000f,0.09000000f,-0.00000000f,0.46000000f,-0.96000000f,-0.00000000f,0.67000000f,0.74000000f,-0.23000000f,-0.25000000f,-0.16000000f,0.45000000f,-0.87000000f,0.73000000f,0.89000000f,-0.40000000f,0.85000000f,0.70000000f,-0.98000000f,0.11000000f,0.27000000f,0.64000000f,0.22000000f,-0.38000000f,0.80000000f,-0.38000000f,0.98000000f,0.87000000f,0.96000000f,0.54000000f,0.88000000f,0.46000000f,0.00000000f,-0.08000000f,0.94000000f,0.02000000f,-0.97000000f,0.16000000f,-0.04000000f,0.44000000f,-0.45000000f,-0.58000000f,0.38000000f,-0.49000000f,0.93000000f,0.78000000f,0.84000000f,-0.35000000f,0.28000000f,0.96000000f,0.16000000f,-0.58000000f,0.32000000f,0.34000000f,-0.43000000f,0.34000000f,0.68000000f,0.92000000f,-0.69000000f,0.48000000f,0.42000000f,-0.13000000f,-0.54000000f,0.09000000f,0.70000000f,-0.85000000f,0.74000000f,-0.55000000f,-0.18000000f,0.45000000f,-0.49000000f,0.12000000f,0.33000000f,-0.49000000f,-0.68000000f,-0.67000000f,0.60000000f,0.61000000f,-0.87000000f,0.13000000f,0.68000000f,-0.56000000f,0.83000000f,-0.16000000f,0.26000000f,-0.18000000f,-0.80000000f,-0.47000000f,0.80000000f,-0.25000000f,0.36000000f,-0.12000000f,-0.98000000f,0.78000000f,-0.58000000f,0.76000000f,-0.25000000f,0.34000000f,0.42000000f,0.76000000f,0.09000000f,-0.97000000f,0.57000000f,0.01000000f,0.82000000f,0.02000000f,-0.67000000f,-0.15000000f,0.99000000f,-0.27000000f,0.19000000f,-0.16000000f,-0.28000000f,-0.70000000f,0.17000000f,0.68000000f,0.00000000f,0.81000000f,-0.88000000f,-0.43000000f,-0.71000000f,-0.90000000f,-0.12000000f,-0.31000000f,-0.15000000f,-0.12000000f,-0.44000000f,0.58000000f,0.26000000f,-0.41000000f,-0.23000000f,-0.06000000f,-0.71000000f,-0.21000000f,0.66000000f,-0.27000000f,0.31000000f,0.55000000f,-0.43000000f,-0.23000000f,-0.98000000f,0.17000000f,-0.03000000f,0.66000000f,0.13000000f,0.41000000f,-0.20000000f,-0.93000000f,-0.33000000f,-0.25000000f,0.23000000f,-0.15000000f,0.19000000f,0.73000000f,0.24000000f,-0.49000000f,0.16000000f,0.24000000f,-0.12000000f,-0.21000000f,-0.61000000f,-0.11000000f,-0.23000000f,-0.98000000f,-0.51000000f,0.19000000f,0.09000000f,0.32000000f,0.99000000f,0.28000000f,0.19000000f,0.66000000f,0.74000000f,0.89000000f,-0.10000000f,0.04000000f,-0.12000000f,0.79000000f,0.36000000f,0.17000000f,0.51000000f,-0.66000000f,-0.09000000f,0.75000000f,-0.88000000f,-0.67000000f,-0.74000000f,-0.63000000f,-0.36000000f,-0.93000000f,0.61000000f,-0.12000000f,-0.00000000f,0.06000000f,0.58000000f,-0.27000000f,0.73000000f,-0.97000000f,-0.03000000f,-0.97000000f,0.99000000f,-0.11000000f,-0.55000000f,-0.59000000f,-0.44000000f,-0.90000000f,-0.13000000f,0.20000000f,0.85000000f,0.90000000f,0.38000000f,-0.46000000f,-0.41000000f,0.18000000f,-0.87000000f,-0.82000000f,0.61000000f,-0.75000000f,0.20000000f,-0.74000000f,-0.68000000f,-0.22000000f,-0.21000000f,0.68000000f,-0.00000000f,0.38000000f,-0.50000000f,-0.21000000f,0.11000000f,0.94000000f,-0.98000000f,0.59000000f,-0.69000000f,-0.36000000f,0.92000000f,-0.76000000f,-0.73000000f,-0.29000000f,0.23000000f,-0.52000000f,0.18000000f,0.26000000f,0.37000000f,0.08000000f,0.35000000f,-0.61000000f,0.71000000f,0.36000000f,0.00000000f,-0.67000000f,0.57000000f,0.63000000f,-0.04000000f,0.06000000f,-0.96000000f,0.40000000f,0.37000000f,0.86000000f,0.05000000f,0.49000000f,0.78000000f,-0.47000000f,-0.90000000f,0.53000000f,-0.30000000f,-0.57000000f,-0.72000000f,0.25000000f,0.06000000f,0.98000000f,0.89000000f,-0.66000000f,-0.83000000f,0.55000000f,0.35000000f,0.84000000f,0.27000000f,-0.56000000f,-0.40000000f,-0.56000000f,-0.40000000f,-0.83000000f,0.69000000f,-0.05000000f,-0.39000000f,0.87000000f,-0.81000000f,-0.29000000f,-0.94000000f,0.10000000f,-0.32000000f,-0.48000000f,0.43000000f,-0.40000000f,-0.64000000f,0.31000000f,0.98000000f,-0.96000000f,-0.99000000f,-0.70000000f,0.23000000f,0.95000000f,-0.59000000f,-0.04000000f,-0.06000000f,0.95000000f,-0.52000000f,0.18000000f,0.79000000f,-0.28000000f,-0.30000000f,-0.23000000f,0.66000000f,0.49000000f,-0.21000000f,-0.84000000f,-0.27000000f,0.85000000f,0.12000000f,0.05000000f,0.39000000f,-0.21000000f,0.49000000f,-0.28000000f,-0.07000000f,0.96000000f,0.00000000f,0.78000000f,-0.54000000f,0.75000000f,0.15000000f,0.14000000f,-0.21000000f,-0.19000000f,0.06000000f,0.42000000f,0.34000000f,-0.41000000f,0.11000000f,0.44000000f,-0.02000000f,0.89000000f,0.56000000f,-0.78000000f,0.75000000f,0.06000000f,-0.22000000f,-0.32000000f,-0.78000000f,-0.52000000f,-0.46000000f,0.64000000f,-0.31000000f,-0.53000000f,-0.20000000f,0.66000000f,0.29000000f,0.91000000f,-0.84000000f,-0.82000000f,0.67000000f,-0.92000000f,-0.56000000f,0.26000000f,-0.42000000f,-0.93000000f,0.13000000f,0.90000000f,-0.20000000f,-0.40000000f,0.56000000f,-0.60000000f,0.39000000f,-0.01000000f,0.67000000f,-0.77000000f,-0.70000000f,0.30000000f,-0.21000000f,0.04000000f,-0.05000000f,-0.70000000f,0.87000000f,-0.99000000f,0.23000000f,-0.11000000f,-0.99000000f,-0.72000000f,0.22000000f,0.82000000f,0.59000000f,-0.20000000f,-0.40000000f,0.28000000f,-0.91000000f,-0.44000000f,-0.49000000f,0.67000000f,0.33000000f,0.15000000f,-0.09000000f,-0.77000000f,-0.65000000f,-0.95000000f,0.39000000f,-0.02000000f,-0.08000000f,-0.60000000f,0.10000000f,-0.72000000f,0.51000000f,-0.17000000f,-0.80000000f,-0.07000000f,0.92000000f,-0.81000000f,0.65000000f,0.86000000f,0.51000000f,-0.99000000f,0.32000000f,-0.47000000f,-0.37000000f,-0.95000000f,0.59000000f,-0.46000000f,-0.63000000f,0.84000000f,0.84000000f,-0.61000000f,0.97000000f,0.17000000f,0.48000000f,0.94000000f,-0.02000000f,0.98000000f,0.19000000f,0.16000000f,0.40000000f,0.16000000f,-0.40000000f,-0.94000000f,-0.61000000f,0.49000000f,-0.60000000f,0.52000000f,-0.62000000f,0.91000000f,0.67000000f,0.25000000f,0.68000000f,-0.03000000f,-0.03000000f,0.31000000f,-0.16000000f,0.72000000f,0.28000000f,-0.13000000f,-0.10000000f,-0.47000000f,-0.49000000f,-0.79000000f,-0.24000000f,-0.39000000f,-0.93000000f,-0.93000000f,-0.64000000f,0.79000000f,0.06000000f,-0.73000000f,-0.05000000f,-0.77000000f,-0.42000000f,-0.10000000f,-0.28000000f,-0.26000000f,0.58000000f,0.07000000f,0.80000000f,0.52000000f,-0.68000000f,0.86000000f,-0.35000000f,0.79000000f,0.50000000f,-0.83000000f,-0.52000000f,0.75000000f,-0.54000000f,0.49000000f,0.17000000f,0.29000000f,0.45000000f,-0.50000000f,-0.08000000f,0.81000000f,0.98000000f,0.57000000f,-0.57000000f,-0.73000000f,-0.54000000f,-0.94000000f,-0.91000000f,0.13000000f,0.74000000f,-0.31000000f,-0.23000000f,-0.85000000f,-0.98000000f,-0.88000000f,-0.98000000f,0.70000000f,-0.92000000f,0.85000000f,-0.96000000f,-0.71000000f,0.46000000f,0.07000000f,-0.41000000f,0.80000000f,0.35000000f,0.64000000f,0.50000000f,-0.57000000f,0.86000000f,0.13000000f,0.09000000f,-0.13000000f,0.78000000f,0.51000000f,0.66000000f,0.18000000f,0.63000000f,0.66000000f,0.05000000f,0.06000000f,-0.87000000f,-0.33000000f,-0.19000000f,-0.55000000f,0.94000000f,-0.52000000f,-0.74000000f,0.21000000f,0.33000000f,0.50000000f,0.90000000f,0.53000000f,0.80000000f,0.53000000f,-0.15000000f,0.02000000f,-0.84000000f,-0.14000000f,0.19000000f,0.51000000f,0.26000000f,0.16000000f,-0.88000000f,0.98000000f,-0.73000000f,0.28000000f,0.64000000f,-0.76000000f,0.20000000f,-0.74000000f,0.09000000f,0.21000000f,-0.67000000f,0.63000000f,-0.74000000f,0.18000000f,-0.03000000f,-0.25000000f,-0.42000000f,0.76000000f,-0.79000000f,0.98000000f,-0.48000000f,0.94000000f,0.10000000f,0.36000000f,0.47000000f,-0.56000000f,-0.69000000f,-0.74000000f,0.37000000f,0.49000000f,0.78000000f,-0.57000000f,0.14000000f,-0.83000000f,0.15000000f,-0.88000000f,0.91000000f,0.25000000f,-0.89000000f,-0.98000000f,-0.67000000f,0.74000000f,0.53000000f,-0.50000000f,-0.54000000f,-0.94000000f,-0.93000000f,0.69000000f,0.15000000f,0.76000000f,0.60000000f,0.86000000f,-0.96000000f,-0.52000000f,0.84000000f,-0.73000000f,0.10000000f,0.35000000f,-0.13000000f,0.53000000f,0.43000000f,0.19000000f,-0.59000000f,-0.02000000f,0.43000000f,0.50000000f,-0.18000000f,0.03000000f,-0.13000000f,-0.21000000f,0.46000000f,-0.07000000f,-0.99000000f,0.94000000f,-0.16000000f,-0.43000000f,0.25000000f,-0.55000000f,-0.77000000f,-0.13000000f,-0.99000000f,0.98000000f,0.69000000f,0.92000000f,-0.77000000f,-0.89000000f,-0.03000000f,0.03000000f,-0.10000000f,0.48000000f,0.47000000f,-0.95000000f,0.87000000f,-0.12000000f,0.56000000f,0.36000000f,0.56000000f,-0.04000000f,-0.97000000f,0.57000000f,-0.85000000f,-0.45000000f,0.48000000f,-0.54000000f,0.90000000f,-0.46000000f,0.49000000f,-0.02000000f,0.25000000f,-0.83000000f,0.77000000f,-0.38000000f,0.09000000f,0.35000000f,0.89000000f,-0.79000000f,-0.79000000f,0.13000000f,-0.14000000f,-0.27000000f,-0.49000000f,0.46000000f,0.43000000f,-0.91000000f,-0.79000000f,-0.67000000f,-0.15000000f,0.73000000f,0.88000000f,0.17000000f,-0.03000000f,0.22000000f,0.43000000f,0.47000000f,-0.72000000f,0.38000000f,0.23000000f,-0.28000000f,-0.14000000f,-0.02000000f,-0.23000000f,0.47000000f,0.48000000f,-0.11000000f,-0.42000000f,-0.19000000f,0.20000000f,-0.84000000f,0.91000000f,-0.17000000f,-0.52000000f,0.46000000f,-0.53000000f,0.55000000f,-0.29000000f,0.80000000f,-0.94000000f,-0.24000000f,0.53000000f,0.18000000f,0.52000000f,-0.91000000f,-0.47000000f,-0.98000000f,0.82000000f,0.81000000f,0.89000000f,-0.94000000f,-0.18000000f,0.26000000f,0.98000000f,-0.97000000f,-0.99000000f,-0.82000000f,0.67000000f,-0.88000000f,0.76000000f,-0.73000000f,0.25000000f,0.82000000f,-0.27000000f,-0.16000000f,0.35000000f,-0.61000000f,0.39000000f,0.79000000f,-0.57000000f,-0.41000000f,-0.56000000f,-0.35000000f,0.26000000f,-0.34000000f,0.74000000f,-0.10000000f,0.98000000f,-0.55000000f,-0.38000000f,-0.91000000f,-0.06000000f,-0.85000000f,0.62000000f,-0.34000000f,0.51000000f,-0.83000000f,0.91000000f,-0.09000000f,-0.54000000f,-0.79000000f,-0.37000000f,0.79000000f,0.74000000f,-0.86000000f,-0.52000000f,0.45000000f,0.04000000f,0.65000000f,-0.26000000f,0.70000000f,0.88000000f,-0.13000000f,0.36000000f,0.23000000f,0.06000000f,0.73000000f,0.16000000f,-0.53000000f,-0.91000000f,-0.56000000f,-0.07000000f,0.72000000f,-0.17000000f,-0.13000000f,0.56000000f,0.11000000f,0.19000000f,0.46000000f,-0.31000000f,0.76000000f,0.95000000f,0.68000000f,0.12000000f,0.60000000f,-0.20000000f,-0.89000000f,0.80000000f,0.78000000f,-0.21000000f,-0.04000000f,0.79000000f,-0.18000000f,0.28000000f,-0.37000000f,-0.39000000f,0.92000000f,-0.73000000f,-0.55000000f,-0.32000000f,-0.15000000f,-0.20000000f,-0.59000000f,0.71000000f,0.57000000f,-0.60000000f,-0.58000000f,-0.36000000f,0.05000000f,0.22000000f,0.08000000f,-0.37000000f,-0.73000000f,0.00000000f,0.99000000f,-0.44000000f,-0.83000000f,0.30000000f,-0.39000000f,-0.49000000f,0.40000000f,-0.33000000f,-0.64000000f,-0.07000000f,0.24000000f,-0.80000000f,0.38000000f,0.65000000f,0.18000000f,0.88000000f,0.99000000f,-0.18000000f,-0.08000000f,0.45000000f,-0.76000000f,-0.30000000f,0.87000000f,0.24000000f,-0.21000000f,-0.28000000f,0.62000000f,-0.71000000f,0.57000000f,0.92000000f,0.01000000f,0.70000000f,0.44000000f,-0.77000000f,-0.47000000f,-0.70000000f,0.72000000f,-0.67000000f,-0.60000000f,0.08000000f,-0.26000000f,0.26000000f,0.16000000f,-0.94000000f,-0.06000000f,0.46000000f,0.98000000f,-0.90000000f,0.17000000f,-0.45000000f,-0.43000000f,-0.00000000f,0.71000000f,-0.82000000f,-0.59000000f,-0.44000000f,0.03000000f,0.98000000f,-0.85000000f,-0.33000000f,0.45000000f,0.22000000f,-0.04000000f,0.59000000f,0.87000000f,0.91000000f,0.97000000f,-0.97000000f,0.69000000f,-0.60000000f,0.61000000f,-0.59000000f,-0.56000000f,-0.71000000f,-0.35000000f,0.13000000f,0.06000000f,0.81000000f,-0.19000000f,0.45000000f,0.56000000f,-0.03000000f,0.09000000f,0.28000000f,-0.75000000f,0.97000000f,0.70000000f,0.98000000f,-0.56000000f,-0.62000000f,0.52000000f,-0.57000000f,0.48000000f,0.04000000f,-0.31000000f,-0.60000000f,-0.22000000f,-0.39000000f,0.05000000f,-0.27000000f,0.15000000f,-0.40000000f,-0.47000000f,0.74000000f,0.14000000f,0.96000000f,-0.35000000f,-0.12000000f,-0.95000000f,0.32000000f,-0.99000000f,0.06000000f,-0.22000000f,-0.82000000f,-0.89000000f,0.89000000f,0.00000000f,0.98000000f,-0.90000000f,0.48000000f,0.79000000f,0.87000000f,0.10000000f,-0.29000000f,0.79000000f,-0.88000000f,-0.07000000f,-0.95000000f,-0.70000000f,0.06000000f,-0.44000000f,0.17000000f,0.94000000f,0.54000000f,0.56000000f,0.83000000f,-0.89000000f,0.80000000f,-0.41000000f,0.40000000f,-0.13000000f,0.44000000f,-0.20000000f,-0.29000000f,0.59000000f,-0.58000000f,-0.80000000f,-0.37000000f,-0.33000000f,-0.10000000f,-0.51000000f,-0.90000000f,-0.16000000f,-0.14000000f,0.97000000f,0.06000000f,0.77000000f,-0.70000000f,-0.70000000f,0.30000000f,-0.36000000f,-0.17000000f,-0.17000000f,0.70000000f,0.25000000f,0.24000000f,-0.14000000f,0.22000000f,0.81000000f,-0.16000000f,0.07000000f,-0.89000000f,0.29000000f,-0.60000000f,-0.95000000f,0.26000000f,-0.20000000f,-0.04000000f,-0.90000000f,0.55000000f,0.80000000f,-0.66000000f,0.51000000f,0.59000000f,0.71000000f,-0.51000000f,0.73000000f,0.89000000f,-0.74000000f,0.88000000f,0.70000000f,0.08000000f,0.61000000f,-0.83000000f,-0.89000000f,-0.93000000f,0.34000000f,-0.41000000f,0.85000000f,-0.74000000f,-0.46000000f,-0.48000000f,0.05000000f,0.86000000f,-0.23000000f,0.82000000f,0.92000000f,-0.41000000f,-0.61000000f,-0.76000000f,0.22000000f,-0.80000000f,-0.29000000f,0.18000000f,-0.05000000f,-0.96000000f,-0.47000000f,0.74000000f,0.81000000f,-0.73000000f,0.69000000f,-0.74000000f,-0.05000000f,-0.80000000f,-0.89000000f,0.13000000f,-0.50000000f,-0.40000000f,0.16000000f,0.03000000f,0.85000000f,-0.23000000f,0.63000000f,0.88000000f,-0.77000000f,-0.58000000f,0.47000000f,-0.70000000f,-0.40000000f,0.61000000f,0.62000000f,-0.23000000f,-0.46000000f,-0.19000000f,0.14000000f,-0.18000000f,0.67000000f,0.21000000f,-0.57000000f,-0.75000000f,-0.04000000f,0.20000000f,0.82000000f,-0.18000000f,-0.44000000f,-0.48000000f,0.11000000f,0.50000000f,-0.60000000f,0.67000000f,-0.60000000f,0.48000000f,0.58000000f,-0.92000000f,0.20000000f,-0.86000000f,0.48000000f,-0.87000000f,0.47000000f,-0.43000000f,0.04000000f,-0.90000000f,-0.50000000f,-0.79000000f,-0.28000000f,-0.25000000f,-0.20000000f,0.49000000f,-0.01000000f,0.28000000f,0.83000000f,-0.03000000f,-0.32000000f,-0.72000000f,0.76000000f,0.80000000f,-0.53000000f,-0.64000000f,-0.34000000f,0.59000000f,-0.81000000f,0.20000000f,0.10000000f,-0.13000000f,-0.40000000f,-0.51000000f,-0.57000000f,0.13000000f,0.93000000f,0.89000000f,-0.03000000f,-0.09000000f,-0.96000000f,-0.41000000f,-0.32000000f,0.14000000f,-0.94000000f,-0.21000000f,0.51000000f,0.03000000f,-0.50000000f,0.54000000f,-0.52000000f,-0.23000000f,0.22000000f,-0.73000000f,-0.49000000f,-0.80000000f,-0.84000000f,-0.26000000f,0.53000000f,-0.61000000f,0.81000000f,-0.80000000f,0.83000000f,0.35000000f,0.49000000f,-0.39000000f,-0.10000000f,0.64000000f,0.12000000f,0.65000000f,0.78000000f,-0.84000000f,-0.32000000f,0.01000000f,-0.38000000f,-0.98000000f,-0.75000000f,0.68000000f,0.16000000f,0.56000000f,-0.23000000f,-0.87000000f,0.37000000f,0.19000000f,0.71000000f,-0.73000000f,0.07000000f,-0.17000000f,0.20000000f,0.08000000f,0.33000000f,-0.49000000f,0.67000000f,-0.58000000f,-0.14000000f,-0.60000000f,-0.89000000f,-0.58000000f,-0.06000000f,0.11000000f,-0.14000000f,0.94000000f,-0.81000000f,-0.54000000f,-0.63000000f,-0.89000000f,-0.35000000f,0.90000000f,0.73000000f,0.67000000f,-0.27000000f,-0.36000000f,0.00000000f,0.11000000f,0.48000000f,0.38000000f,-0.78000000f,0.90000000f,-0.36000000f,-0.74000000f,-0.50000000f,0.90000000f,-0.77000000f,0.78000000f,-0.08000000f,0.76000000f,-0.91000000f,-0.97000000f,-0.38000000f,-0.00000000f,0.59000000f,0.79000000f,-0.53000000f,0.21000000f,0.34000000f,-0.79000000f,0.90000000f,-0.42000000f,-0.14000000f,-0.44000000f,-0.25000000f,-0.29000000f,0.34000000f,-0.08000000f,0.76000000f,0.53000000f,0.24000000f,0.07000000f,0.01000000f,-0.29000000f,-0.76000000f,-0.43000000f,-0.40000000f,0.23000000f,-0.66000000f,0.62000000f,0.79000000f,-0.07000000f,-0.26000000f,0.62000000f,-0.18000000f,-0.66000000f,0.90000000f,0.19000000f,0.58000000f,0.59000000f,-0.24000000f,-0.75000000f,-0.30000000f,0.13000000f,0.68000000f,0.08000000f,0.00000000f,-0.00000000f,0.81000000f,-0.56000000f,0.41000000f,0.58000000f,0.50000000f,-0.40000000f,0.59000000f,-0.45000000f,-0.56000000f,0.66000000f,0.02000000f,0.74000000f,-0.27000000f,0.70000000f,-0.50000000f,-0.76000000f,0.24000000f,0.94000000f,-0.61000000f,0.74000000f,-0.95000000f,0.76000000f,-0.24000000f,0.09000000f,0.87000000f,-0.02000000f,-0.73000000f,-0.43000000f,-0.26000000f,0.39000000f,-0.78000000f,-0.50000000f,-0.52000000f,-0.84000000f,-0.81000000f,-0.51000000f,0.86000000f,-0.27000000f,0.27000000f,-0.92000000f,0.39000000f,0.02000000f,0.12000000f,-0.47000000f,-0.75000000f,-0.69000000f,0.00000000f,-0.46000000f,0.19000000f,0.21000000f,-0.75000000f,0.65000000f,0.12000000f,0.74000000f,-0.92000000f,-0.88000000f,0.68000000f,0.85000000f,-0.38000000f,-0.68000000f,0.43000000f,-0.88000000f,0.12000000f,-0.02000000f,-0.77000000f,0.27000000f,0.40000000f,0.53000000f,0.95000000f,0.99000000f,0.56000000f,0.62000000f,-0.68000000f,-0.69000000f,-0.87000000f,0.09000000f,-0.91000000f,-0.25000000f,-0.66000000f,0.19000000f,-0.69000000f,-0.54000000f,0.46000000f,0.21000000f,-0.76000000f,0.84000000f,-0.83000000f,-0.30000000f,-0.30000000f,0.16000000f,0.38000000f,0.39000000f,-0.04000000f,0.32000000f,-0.68000000f,-0.43000000f,0.27000000f,0.08000000f,0.41000000f,0.93000000f,-0.61000000f,-0.54000000f,0.52000000f,-0.99000000f,0.04000000f,0.74000000f,-0.26000000f,0.25000000f,-0.28000000f,-0.60000000f,0.52000000f,-0.68000000f,0.75000000f,-0.62000000f,-0.32000000f,-0.51000000f,-0.69000000f,-0.61000000f,0.90000000f,-0.71000000f,0.81000000f,-0.20000000f,0.24000000f,0.92000000f,-0.25000000f,-0.76000000f,0.88000000f,0.88000000f,0.42000000f,-0.21000000f,0.11000000f,0.33000000f,-0.09000000f,0.01000000f,-0.72000000f,0.96000000f,0.20000000f,-0.70000000f,-0.59000000f,0.48000000f,-0.03000000f,0.42000000f,0.54000000f,0.67000000f,-0.21000000f,-0.13000000f,0.55000000f,-0.11000000f,0.26000000f,0.52000000f,0.83000000f,0.76000000f,0.21000000f,0.51000000f,-0.35000000f,0.49000000f,0.04000000f,-0.62000000f,0.88000000f,0.04000000f,0.00000000f,0.33000000f,-0.68000000f,0.72000000f,0.78000000f,-0.69000000f,0.54000000f,0.04000000f,-0.69000000f,-0.51000000f,0.56000000f,-0.05000000f,-0.68000000f,0.16000000f,0.62000000f,-0.90000000f,0.77000000f,-0.25000000f,-0.78000000f,0.25000000f,-0.86000000f,0.72000000f,-0.82000000f,-0.13000000f,-0.23000000f,0.77000000f,-0.06000000f,0.13000000f,0.29000000f,-0.79000000f,0.13000000f,-0.77000000f,-0.56000000f,-0.22000000f,-0.17000000f,-0.20000000f,-0.35000000f,0.91000000f,-0.92000000f,0.70000000f,-0.07000000f,0.99000000f,-0.44000000f,0.00000000f,-0.91000000f,0.36000000f,-0.69000000f,-0.97000000f,0.97000000f,-0.15000000f,0.76000000f,0.78000000f,-0.36000000f,-0.46000000f,0.43000000f,0.78000000f,-0.08000000f,-0.36000000f,0.91000000f,-0.15000000f,-0.49000000f,0.89000000f,-0.47000000f,-0.88000000f,0.32000000f,-0.35000000f,0.46000000f,0.86000000f,0.19000000f,0.87000000f,0.76000000f,0.41000000f,0.87000000f,0.71000000f,0.11000000f,0.78000000f,-0.87000000f,0.70000000f,-0.29000000f,-0.32000000f,0.01000000f,-0.68000000f,0.19000000f,-0.59000000f,-0.04000000f,0.89000000f,-0.46000000f,0.46000000f,-0.82000000f,0.02000000f,0.35000000f,-0.93000000f,-0.46000000f,0.58000000f,0.03000000f,-0.81000000f,0.27000000f,-0.90000000f,-0.33000000f,-0.93000000f,-0.47000000f,-0.42000000f,-0.27000000f,-0.49000000f,0.82000000f,0.12000000f,0.82000000f,0.29000000f,-0.35000000f,0.74000000f,0.00000000f,-0.70000000f,0.45000000f,-0.19000000f,0.05000000f,-0.39000000f,-0.84000000f,-0.99000000f,-0.22000000f,-0.71000000f,-0.60000000f,-0.54000000f,0.21000000f,0.61000000f,0.18000000f,0.08000000f,0.19000000f,-0.06000000f,-0.98000000f,0.21000000f,-0.78000000f,0.15000000f,0.68000000f,-0.53000000f,0.31000000f,0.89000000f,-0.01000000f,-0.73000000f,0.02000000f,0.40000000f,-0.37000000f,0.23000000f,-0.95000000f,0.62000000f,0.84000000f,-0.35000000f,-0.63000000f,0.96000000f,-0.47000000f,0.14000000f,0.80000000f,-0.68000000f,0.29000000f,0.99000000f,0.49000000f,-0.01000000f,0.16000000f,0.19000000f,-0.38000000f,0.63000000f,-0.93000000f,-0.31000000f,0.83000000f,-0.64000000f,-0.72000000f,0.49000000f,-0.87000000f,0.09000000f,0.89000000f,-0.76000000f,-0.98000000f,0.36000000f,0.71000000f,0.07000000f,0.99000000f,-0.47000000f,-0.41000000f,0.68000000f,0.86000000f,0.77000000f,0.92000000f,-0.79000000f,-0.22000000f,0.24000000f,0.09000000f,-0.45000000f,0.00000000f,0.22000000f,-0.96000000f,-0.50000000f,0.87000000f,0.06000000f,0.93000000f,-0.39000000f,-0.39000000f,-0.39000000f,-0.36000000f,-0.11000000f,0.77000000f,-0.29000000f,0.32000000f,-0.60000000f,-0.69000000f,-0.35000000f,0.12000000f,-0.30000000f,0.66000000f,0.29000000f,-0.45000000f,-0.18000000f,-0.95000000f,0.75000000f,-0.69000000f,-0.71000000f,-0.93000000f,-0.25000000f,-0.36000000f,0.81000000f,-0.79000000f,0.17000000f,0.93000000f,-0.60000000f,-0.98000000f,0.55000000f,-0.87000000f,-0.67000000f,0.32000000f,0.80000000f,0.79000000f,0.62000000f,0.44000000f,-0.19000000f,-0.48000000f,0.34000000f,0.89000000f,0.72000000f,0.37000000f,-0.82000000f,-0.49000000f,-0.71000000f,-0.40000000f,-0.08000000f,-0.05000000f,-0.30000000f,-0.46000000f,0.50000000f,0.24000000f,0.85000000f,-0.95000000f,-0.62000000f,-0.45000000f,-0.09000000f,0.42000000f,-0.95000000f,-0.20000000f,0.21000000f,-0.50000000f,0.39000000f,-0.38000000f,-0.74000000f,0.69000000f,-0.65000000f,0.43000000f,0.60000000f,-0.48000000f,-0.81000000f,-0.14000000f,-0.90000000f,0.56000000f,0.42000000f,0.39000000f,-0.13000000f,0.76000000f,0.06000000f,-0.46000000f,-0.55000000f,0.60000000f,0.72000000f,-0.05000000f,-0.20000000f,-0.17000000f,-0.40000000f,0.23000000f,-0.55000000f,0.90000000f,-0.49000000f,0.58000000f,0.34000000f,0.72000000f,-0.72000000f,-0.54000000f,-0.43000000f,-0.80000000f,-0.49000000f,-0.76000000f,-0.76000000f,-0.11000000f,0.55000000f,-0.68000000f,0.14000000f,-0.98000000f,0.20000000f,0.93000000f,0.19000000f,0.52000000f,-0.26000000f,0.89000000f,-0.82000000f,-0.02000000f,-0.47000000f,0.74000000f,-0.94000000f,-0.01000000f,0.90000000f,0.68000000f,0.20000000f,0.36000000f,-0.50000000f,-0.99000000f,0.20000000f,0.05000000f,-0.18000000f,-0.06000000f,-0.39000000f,0.60000000f,-0.12000000f,-0.94000000f,0.89000000f,-0.31000000f,0.00000000f,0.35000000f,0.74000000f,-0.24000000f,-0.88000000f,0.41000000f,-0.78000000f,-0.04000000f,0.38000000f,-0.17000000f,0.93000000f,0.48000000f,0.31000000f,0.60000000f,-0.20000000f,-0.78000000f,0.85000000f,-0.03000000f,0.26000000f,0.88000000f,0.17000000f,0.82000000f,0.39000000f,-0.03000000f,0.10000000f,0.13000000f,0.72000000f,0.15000000f,0.40000000f,-0.39000000f,0.32000000f,0.44000000f,-0.75000000f,-0.64000000f,-0.29000000f,0.77000000f,-0.50000000f,0.74000000f,0.71000000f,-0.08000000f,-0.30000000f,-0.42000000f,0.17000000f,-0.52000000f,0.84000000f,-0.07000000f,-0.89000000f,-0.60000000f,-0.04000000f,0.64000000f,-0.73000000f,-0.10000000f,-0.82000000f,0.87000000f,-0.78000000f,0.23000000f,0.67000000f,-0.98000000f,-0.68000000f,0.66000000f,0.82000000f,0.64000000f,0.40000000f,0.55000000f,0.91000000f,-0.02000000f,0.01000000f,0.13000000f,-0.82000000f,-0.86000000f,0.79000000f,-0.06000000f,-0.58000000f,0.75000000f,0.99000000f,-0.05000000f,0.32000000f,-0.07000000f,0.97000000f,0.49000000f,0.40000000f,0.42000000f,0.86000000f,-0.62000000f,0.54000000f,0.57000000f,0.90000000f,-0.76000000f,0.54000000f,-0.61000000f,0.32000000f,0.66000000f,0.21000000f,-0.24000000f,-0.70000000f,0.02000000f,0.27000000f,0.78000000f,-0.45000000f,0.29000000f,0.18000000f,-0.06000000f,0.78000000f,0.38000000f,-0.41000000f,0.14000000f,0.50000000f,-0.43000000f,-0.45000000f,0.68000000f,-0.30000000f,-0.79000000f,-0.88000000f,0.57000000f,-0.06000000f,0.36000000f,0.16000000f,0.14000000f,0.48000000f,-0.27000000f,0.46000000f,-0.78000000f,-0.23000000f,0.20000000f,0.34000000f,0.26000000f,0.34000000f,-0.40000000f,0.07000000f,0.00000000f,0.28000000f,-0.92000000f,-0.23000000f,0.46000000f,-0.60000000f,-0.69000000f,-0.98000000f,0.49000000f,0.21000000f,-0.65000000f,-0.01000000f,0.56000000f,-0.42000000f,0.88000000f,0.96000000f,0.40000000f,0.60000000f,-0.24000000f,-0.93000000f,-0.82000000f,0.64000000f,0.23000000f,-0.24000000f,0.28000000f,-0.50000000f,0.48000000f,0.23000000f,0.52000000f,0.75000000f,0.30000000f,0.59000000f,-0.63000000f,0.46000000f,0.47000000f,-0.91000000f,0.70000000f,0.29000000f,-0.47000000f,0.12000000f,-0.82000000f,0.72000000f,-0.20000000f,-0.48000000f,0.07000000f,0.39000000f,0.72000000f,0.24000000f,0.44000000f,0.79000000f,-0.44000000f,-0.59000000f,0.25000000f,-0.95000000f,-0.60000000f,0.24000000f,-0.40000000f,0.50000000f,-0.05000000f,-0.86000000f,0.49000000f,0.95000000f,0.92000000f,-0.87000000f,0.29000000f,-0.71000000f,-0.14000000f,0.37000000f,0.24000000f,0.91000000f,0.82000000f,-0.64000000f,0.12000000f,-0.39000000f,0.53000000f,-0.95000000f,0.32000000f,0.87000000f,-0.90000000f,0.97000000f,-0.85000000f,0.09000000f,-0.54000000f,-0.75000000f,0.74000000f,-0.59000000f,0.51000000f,-0.23000000f,-0.14000000f,-0.64000000f,0.51000000f,0.39000000f,0.60000000f,0.36000000f,0.16000000f,-0.64000000f,0.27000000f,-0.16000000f,0.32000000f,-0.99000000f,0.77000000f,0.48000000f,-0.71000000f,0.55000000f,0.73000000f,0.44000000f,-0.92000000f,-0.29000000f,0.44000000f,0.10000000f,-0.53000000f,-0.71000000f,-0.09000000f,-0.46000000f,-0.66000000f,-0.31000000f,0.05000000f,0.92000000f,-0.52000000f,0.04000000f,0.94000000f,0.91000000f,0.09000000f,0.03000000f,0.23000000f,-0.88000000f,-0.92000000f,0.91000000f,-0.47000000f,0.04000000f,0.37000000f,-0.75000000f,0.74000000f,0.77000000f,-0.69000000f,-0.02000000f,-0.90000000f,0.64000000f,-0.38000000f,-0.21000000f,0.76000000f,0.71000000f,0.38000000f,-0.89000000f,0.36000000f,-0.17000000f,0.86000000f,0.13000000f,0.45000000f,0.36000000f,-0.06000000f,0.40000000f,0.33000000f,-0.53000000f,-0.47000000f,0.71000000f,0.10000000f,0.63000000f,0.84000000f,-0.22000000f,0.07000000f,0.76000000f,0.98000000f,-0.43000000f,-0.54000000f,0.42000000f,-0.23000000f,-0.75000000f,-0.67000000f,0.62000000f,0.55000000f,0.24000000f,-0.77000000f,-0.45000000f,0.77000000f,0.30000000f,-0.80000000f,-0.47000000f,0.70000000f,0.03000000f,-0.26000000f,-0.10000000f,0.16000000f,0.98000000f,-0.33000000f,-0.64000000f,0.67000000f,0.31000000f,-0.61000000f,-0.09000000f,0.54000000f,-0.23000000f,-0.18000000f,-0.41000000f,-0.32000000f,-0.43000000f,0.35000000f,-0.85000000f,-0.45000000f,0.53000000f,0.24000000f,0.86000000f,-0.45000000f,0.37000000f,0.37000000f,-0.87000000f,-0.44000000f,-0.67000000f,0.66000000f,-0.78000000f,0.84000000f,0.10000000f,0.74000000f,-0.33000000f,-0.74000000f,0.28000000f,0.30000000f,0.43000000f,0.57000000f,0.48000000f,-0.36000000f,-0.84000000f,0.82000000f,0.03000000f,0.36000000f,0.04000000f,0.93000000f,-0.42000000f,0.73000000f,-0.33000000f,0.54000000f,-0.85000000f,0.28000000f,0.19000000f,0.31000000f,-0.06000000f,0.59000000f,0.01000000f,0.46000000f,-0.68000000f,-0.79000000f,-0.91000000f,0.95000000f,-0.04000000f,0.59000000f,0.66000000f,-0.03000000f,-0.35000000f,0.77000000f,0.27000000f,0.48000000f,0.04000000f,-0.91000000f,-0.90000000f,-0.38000000f,-0.43000000f,0.19000000f,0.47000000f,0.10000000f,0.01000000f,-0.15000000f,0.38000000f,0.74000000f,0.24000000f,0.68000000f,0.66000000f,-0.06000000f,-0.09000000f,0.79000000f,0.06000000f,-0.98000000f,-0.26000000f,-0.11000000f,-0.01000000f,-0.63000000f,0.17000000f,-0.20000000f,0.94000000f,0.04000000f,0.15000000f,-0.41000000f,-0.88000000f,0.62000000f,-0.03000000f,-0.95000000f,-0.99000000f,-0.35000000f,-0.79000000f,-0.08000000f,0.13000000f,0.45000000f,-0.79000000f,0.30000000f,-0.97000000f,0.53000000f,-0.87000000f,-0.00000000f,0.41000000f,-0.90000000f,0.46000000f,0.14000000f,-0.71000000f,-0.34000000f,0.06000000f,-0.93000000f,-0.31000000f,-0.91000000f,0.88000000f,0.76000000f,-0.69000000f,0.51000000f,-0.97000000f,0.40000000f,-0.95000000f,0.75000000f,-0.95000000f,-0.33000000f,0.74000000f,-0.86000000f,0.17000000f,0.73000000f,0.70000000f,-0.41000000f,0.11000000f,0.91000000f,0.94000000f,-0.67000000f,0.40000000f,0.18000000f,0.01000000f,0.17000000f,-0.10000000f,0.24000000f,0.54000000f,-0.01000000f,0.30000000f,0.21000000f,0.54000000f,-0.37000000f,-0.56000000f,0.76000000f,-0.57000000f,0.23000000f,-0.87000000f,0.35000000f,0.35000000f,0.84000000f,-0.47000000f,0.32000000f,-0.51000000f,0.45000000f,0.03000000f,0.84000000f,0.02000000f,0.74000000f,0.40000000f,-0.56000000f,0.08000000f,0.36000000f,0.97000000f,0.25000000f,0.03000000f,0.48000000f,-0.03000000f,0.65000000f,0.71000000f,-0.04000000f,0.85000000f,0.05000000f,0.13000000f,-0.08000000f,0.81000000f,0.32000000f,-0.34000000f,-0.79000000f,-0.45000000f,0.77000000f,-0.89000000f,0.79000000f,-0.23000000f,-0.65000000f,-0.43000000f,0.55000000f,0.99000000f,0.68000000f,-0.43000000f,0.25000000f,-0.19000000f,-0.32000000f,-0.03000000f,-0.61000000f,0.01000000f,0.10000000f,0.14000000f,0.82000000f,0.50000000f,0.96000000f,0.24000000f,-0.44000000f,-0.21000000f,0.05000000f,-0.28000000f,0.58000000f,0.29000000f,-0.08000000f,0.83000000f,-0.95000000f,-0.21000000f,-0.49000000f,0.61000000f,-0.37000000f,-0.47000000f,0.50000000f,-0.33000000f,-0.83000000f,0.00000000f,-0.68000000f,0.06000000f,-0.96000000f,-0.74000000f,0.57000000f,0.34000000f,-0.54000000f,-0.77000000f,-0.73000000f,0.84000000f,0.81000000f,-0.90000000f,0.95000000f,0.57000000f,-0.79000000f,0.35000000f,0.54000000f,-0.50000000f,-0.86000000f,0.13000000f,0.16000000f,0.75000000f,0.64000000f,-0.74000000f,-0.72000000f,-0.85000000f,0.87000000f,-0.71000000f,0.43000000f,-0.06000000f,-0.69000000f,0.12000000f,-0.06000000f,0.36000000f,-0.34000000f,0.79000000f,0.02000000f,-0.83000000f,0.91000000f,0.40000000f,0.46000000f,0.90000000f,-0.72000000f,0.02000000f,0.01000000f,-0.45000000f,0.30000000f,-0.12000000f,-0.09000000f,-0.14000000f,0.55000000f,-0.33000000f,0.34000000f,-0.82000000f,0.90000000f,0.45000000f,0.95000000f,-0.62000000f,-0.49000000f,0.06000000f,-0.15000000f,0.66000000f,0.10000000f,-0.92000000f,0.71000000f,0.04000000f,-0.28000000f,-0.83000000f,-0.37000000f,0.18000000f,0.37000000f,0.49000000f,0.82000000f,-0.53000000f,-0.30000000f,0.17000000f,-0.65000000f,-0.06000000f,0.29000000f,-0.89000000f,-0.74000000f,-0.21000000f,-0.85000000f,0.93000000f,-0.51000000f,0.29000000f,-0.86000000f,-0.20000000f,-0.19000000f,0.39000000f,-0.51000000f,0.54000000f,-0.67000000f,0.27000000f,-0.23000000f,0.23000000f,0.43000000f,0.65000000f,0.71000000f,0.95000000f,-0.84000000f,0.84000000f,-0.44000000f,-0.78000000f,0.05000000f,0.84000000f,0.05000000f,-0.54000000f,-0.18000000f,-0.41000000f,-0.80000000f,0.05000000f,-0.41000000f,-0.97000000f,0.34000000f,0.64000000f,-0.94000000f,0.19000000f,0.22000000f,0.85000000f,0.58000000f,0.92000000f,-0.07000000f,-0.41000000f,0.30000000f,-0.01000000f,0.72000000f,-0.28000000f,0.91000000f,0.82000000f,0.92000000f,0.17000000f,-0.08000000f,-0.69000000f,-0.92000000f,0.05000000f,0.45000000f,-0.72000000f,-0.34000000f,0.36000000f,0.35000000f,-0.18000000f,0.55000000f,-0.21000000f,-0.69000000f,-0.60000000f,0.86000000f,0.85000000f,0.47000000f,0.48000000f,0.49000000f,-0.31000000f,0.03000000f,-0.42000000f,-0.28000000f,0.38000000f,-0.94000000f,0.82000000f,0.25000000f,-0.40000000f,-0.95000000f,0.81000000f,-0.21000000f,0.50000000f,-0.55000000f,-0.02000000f,-0.91000000f,-0.10000000f,0.45000000f,-0.30000000f,0.31000000f,0.80000000f,-0.57000000f,0.41000000f,-0.83000000f,0.28000000f,-0.02000000f,0.11000000f,-0.45000000f,0.84000000f,0.03000000f,0.14000000f,0.76000000f,-0.21000000f,-0.04000000f,-0.52000000f,-0.55000000f,-0.03000000f,-0.98000000f,0.48000000f,0.91000000f,-0.39000000f,0.57000000f,0.45000000f,0.29000000f,-0.05000000f,-0.33000000f,-0.65000000f,-0.62000000f,0.98000000f,-0.35000000f,0.61000000f,0.81000000f,0.61000000f,-0.51000000f,0.43000000f,-0.36000000f,0.73000000f,-0.20000000f,-0.18000000f,0.05000000f,0.04000000f,-0.83000000f,0.38000000f,-0.98000000f,-0.62000000f,0.07000000f,0.65000000f,-0.23000000f,0.49000000f,-0.33000000f,-0.85000000f,0.33000000f,-0.51000000f,-0.08000000f,-0.21000000f,0.66000000f,0.84000000f,-0.36000000f,-0.01000000f,0.99000000f,0.48000000f,-0.79000000f,0.18000000f,0.82000000f,0.11000000f,-0.38000000f,-0.49000000f,0.24000000f,0.20000000f,0.16000000f,0.60000000f,-0.33000000f,0.58000000f,0.77000000f,-0.43000000f,-0.65000000f,0.81000000f,0.14000000f,0.36000000f,0.00000000f,-0.87000000f,-0.57000000f,-0.01000000f,-0.02000000f,0.30000000f,0.14000000f,-0.17000000f,0.18000000f,0.17000000f,0.64000000f,0.64000000f,0.57000000f,-0.72000000f,0.12000000f,-0.33000000f,0.73000000f,0.54000000f,-0.36000000f,0.16000000f,0.62000000f,0.01000000f,0.09000000f,0.36000000f,-0.65000000f,-0.72000000f,-0.02000000f,-0.40000000f,0.55000000f,-0.54000000f,-0.20000000f,0.24000000f,0.97000000f,-0.31000000f,0.96000000f,0.74000000f,0.71000000f,0.10000000f,0.79000000f,-0.64000000f,0.17000000f,-0.56000000f,0.27000000f,-0.62000000f,-0.65000000f,0.73000000f,0.17000000f,-0.06000000f,0.67000000f,-0.39000000f,-0.46000000f,0.25000000f,0.64000000f,-0.22000000f,-0.13000000f,0.35000000f,0.70000000f,-0.70000000f,-0.60000000f,-0.14000000f,-0.53000000f,-0.09000000f,0.59000000f,-0.09000000f,-0.12000000f,-0.28000000f,-0.65000000f,0.69000000f,0.48000000f,0.11000000f,-0.82000000f,-0.15000000f,-0.01000000f,0.06000000f,0.96000000f,-0.14000000f,0.51000000f,0.39000000f,0.66000000f,-0.27000000f,-0.52000000f,0.54000000f,-0.87000000f,-0.18000000f,-0.69000000f,-0.19000000f,-0.20000000f,0.19000000f,-0.06000000f,0.27000000f,0.18000000f,-0.26000000f,-0.45000000f,-0.09000000f,0.47000000f,-0.15000000f,-0.05000000f,0.54000000f,0.80000000f,0.86000000f,-0.60000000f,-0.02000000f,0.74000000f,0.07000000f,-0.10000000f,-0.73000000f,0.56000000f,0.67000000f,0.51000000f,0.23000000f,0.69000000f,0.85000000f,0.21000000f,-0.92000000f,0.15000000f,0.53000000f,0.12000000f,0.43000000f,-0.26000000f,-0.50000000f,0.29000000f,0.92000000f,-0.29000000f,-0.25000000f,0.94000000f,-0.92000000f,0.53000000f,0.14000000f,0.93000000f,0.88000000f,0.09000000f,-0.29000000f,0.59000000f,0.98000000f,0.49000000f,0.64000000f,-0.18000000f,-0.75000000f,-0.26000000f,-0.47000000f,0.64000000f,0.87000000f,0.46000000f,-0.51000000f,0.04000000f,-0.46000000f,0.00000000f,-0.67000000f,-0.78000000f,0.05000000f,-0.35000000f,0.21000000f,-0.42000000f,-0.85000000f,0.02000000f,0.78000000f,0.86000000f,-0.93000000f,-0.28000000f,0.54000000f,-0.41000000f,-0.83000000f,0.95000000f,-0.72000000f,0.31000000f,0.67000000f,-0.22000000f,-0.07000000f,0.74000000f,0.26000000f,0.27000000f,-0.78000000f,-0.23000000f,0.57000000f,0.55000000f,-0.27000000f,0.17000000f,0.57000000f,0.63000000f,-0.05000000f,-0.76000000f,-0.25000000f,0.37000000f,-0.29000000f,-0.48000000f,0.92000000f,-0.87000000f,-0.08000000f,-0.68000000f,0.61000000f,0.24000000f,-0.48000000f,-0.70000000f,0.61000000f,-0.01000000f,-0.96000000f,-0.54000000f,0.08000000f,-0.75000000f,0.06000000f,0.60000000f,-0.89000000f,0.34000000f,0.76000000f,-0.25000000f,0.34000000f,-0.94000000f,0.00000000f,0.60000000f,-0.24000000f,-0.10000000f,-0.98000000f,-0.56000000f,-0.74000000f,-0.36000000f,0.27000000f,0.74000000f,0.88000000f,-0.94000000f,0.25000000f,-0.85000000f,-0.39000000f,-0.37000000f,0.25000000f,-0.80000000f,0.10000000f,0.52000000f,-0.53000000f,0.20000000f,0.59000000f,-0.17000000f,-0.57000000f,0.45000000f,0.39000000f,-0.63000000f,0.37000000f,0.45000000f,-0.81000000f,-0.16000000f,0.18000000f,0.66000000f,-0.23000000f,-0.98000000f,-0.81000000f,0.47000000f,0.18000000f,0.24000000f,0.38000000f,-0.79000000f,-0.73000000f,0.28000000f,-0.81000000f,0.39000000f,-0.15000000f,0.93000000f,-0.83000000f,-0.42000000f,-0.70000000f,-0.09000000f,-0.95000000f,0.23000000f,0.25000000f,-0.44000000f,-0.79000000f,-0.68000000f,-0.26000000f,-0.04000000f,0.05000000f,-0.39000000f,-0.23000000f,0.22000000f,-0.25000000f,-0.30000000f,-0.00000000f,-0.03000000f,-0.42000000f,0.94000000f,0.27000000f,0.98000000f,-0.32000000f,0.88000000f,0.49000000f,0.75000000f,0.76000000f,0.02000000f,-0.10000000f,0.26000000f,-0.54000000f,-0.00000000f,-0.91000000f,0.30000000f,0.48000000f,0.30000000f,-0.54000000f,0.58000000f,0.13000000f,0.95000000f,0.43000000f,-0.90000000f,-0.79000000f,0.82000000f,-0.03000000f,0.28000000f,-0.69000000f,0.87000000f,-0.35000000f,-0.34000000f,0.97000000f,-0.17000000f,0.03000000f,0.61000000f,0.32000000f,-0.05000000f,0.47000000f,-0.35000000f,-0.48000000f,-0.50000000f,0.37000000f,0.84000000f,0.50000000f,-0.82000000f,0.26000000f,0.47000000f,-0.36000000f,-0.42000000f,0.58000000f,0.71000000f,0.87000000f,0.59000000f,0.92000000f,0.31000000f,0.66000000f,-0.28000000f,-0.13000000f,-0.19000000f,-0.95000000f,0.57000000f,-0.81000000f,0.95000000f,0.16000000f,0.62000000f,-0.60000000f,-0.03000000f,0.75000000f,0.40000000f,0.40000000f,0.78000000f,0.95000000f,0.59000000f,-0.00000000f,0.79000000f,0.49000000f,-0.76000000f,0.91000000f,-0.76000000f,-0.74000000f,-0.68000000f,0.97000000f,0.98000000f,-0.97000000f,0.91000000f,-0.93000000f,0.47000000f,0.86000000f,0.88000000f,-0.56000000f,0.84000000f,-0.00000000f,0.02000000f,-0.23000000f,0.95000000f,0.58000000f,-0.00000000f,0.84000000f,-0.65000000f,0.77000000f,-0.27000000f,-0.42000000f,-0.54000000f,0.19000000f,-0.77000000f,-0.59000000f,0.81000000f,0.45000000f,0.96000000f,0.39000000f,-0.46000000f,-0.74000000f,-0.59000000f,0.93000000f,-0.12000000f,0.26000000f,-0.74000000f,0.28000000f,-0.83000000f,0.58000000f,0.20000000f,0.25000000f,-0.39000000f,0.85000000f,0.29000000f,0.90000000f,-0.42000000f,0.95000000f,0.49000000f,-0.11000000f,-0.66000000f,0.65000000f,0.91000000f,-0.98000000f,-0.61000000f,-0.72000000f,0.20000000f,0.25000000f,0.39000000f,0.76000000f,-0.13000000f,0.56000000f,0.78000000f,0.90000000f,0.10000000f,0.54000000f,0.49000000f,-0.85000000f,0.50000000f,0.91000000f,-0.72000000f,-0.00000000f,0.80000000f,-0.25000000f,0.07000000f,-0.18000000f,0.87000000f,-0.93000000f,0.02000000f,0.03000000f,-0.15000000f,0.37000000f,0.50000000f,-0.21000000f,-0.17000000f,0.78000000f,-0.40000000f,0.70000000f,-0.96000000f,-0.74000000f,0.05000000f,0.22000000f,-0.04000000f,0.78000000f,0.99000000f,0.65000000f,0.63000000f,0.66000000f,0.40000000f,0.53000000f,-0.91000000f,0.46000000f,0.43000000f,0.18000000f,0.65000000f,-0.58000000f,0.73000000f,0.60000000f,0.57000000f,0.72000000f,0.71000000f,0.15000000f,0.70000000f,-0.47000000f,-0.82000000f,-0.38000000f,0.89000000f,-0.91000000f,0.72000000f,0.13000000f,-0.81000000f,-0.79000000f,-0.58000000f,-0.13000000f,0.28000000f,0.79000000f,0.46000000f,0.34000000f,0.27000000f,0.26000000f,0.00000000f,0.39000000f,0.89000000f,0.24000000f,0.83000000f,0.91000000f,-0.87000000f,-0.49000000f,0.30000000f,-0.11000000f,0.77000000f,-0.97000000f,-0.36000000f,-0.41000000f,-0.68000000f,0.85000000f,0.79000000f,0.30000000f,0.81000000f,-0.57000000f,0.91000000f,-0.04000000f,-0.22000000f,-0.16000000f,0.95000000f,0.60000000f,0.27000000f,-0.73000000f,0.26000000f,-0.18000000f,0.50000000f,-0.79000000f,0.10000000f,-0.69000000f,-0.23000000f,0.07000000f,0.76000000f,-0.41000000f,-0.13000000f,-0.64000000f,-0.15000000f,0.47000000f,-0.03000000f,0.93000000f,0.95000000f,-0.67000000f,0.72000000f,-0.80000000f,-0.17000000f,0.98000000f,0.45000000f,-0.91000000f,0.94000000f,-0.67000000f,0.51000000f,0.81000000f,-0.37000000f,0.49000000f,0.43000000f,0.26000000f,0.83000000f,-0.88000000f,-0.10000000f,0.05000000f,0.41000000f,-0.13000000f,-0.32000000f,0.75000000f,0.37000000f,-0.26000000f,-0.42000000f,-0.41000000f,0.79000000f,0.37000000f,-0.06000000f,0.77000000f,-0.61000000f,0.23000000f,0.57000000f,0.28000000f,0.63000000f,-0.43000000f,-0.09000000f,0.22000000f,-0.86000000f,-0.07000000f,0.22000000f,0.48000000f,-0.05000000f,0.71000000f,-0.98000000f,0.47000000f,0.46000000f,0.02000000f,-0.52000000f,-0.24000000f,0.35000000f,-0.02000000f,-0.30000000f,-0.80000000f,-0.18000000f,-0.81000000f,0.19000000f,-0.74000000f,-0.04000000f,-0.58000000f,-0.51000000f,-0.71000000f,-0.28000000f,0.23000000f,-0.51000000f,-0.05000000f,0.88000000f,-0.55000000f,0.54000000f,0.41000000f,-0.06000000f,-0.58000000f,0.32000000f,0.93000000f,-0.14000000f,-0.61000000f,-0.05000000f,0.13000000f,-0.73000000f,-0.19000000f,-0.49000000f,0.59000000f,0.53000000f,0.97000000f,0.64000000f,0.02000000f,0.39000000f,-0.95000000f,-0.87000000f,-0.87000000f,0.96000000f,-0.90000000f,-0.68000000f,0.74000000f,-0.76000000f,-0.08000000f,-0.19000000f,-0.11000000f,-0.32000000f,0.95000000f,-0.13000000f,0.70000000f,-0.81000000f,0.67000000f,0.09000000f,-0.64000000f,-0.24000000f,0.70000000f,0.46000000f,0.28000000f,0.21000000f,-0.10000000f,0.49000000f,-0.22000000f,0.64000000f,0.34000000f,-0.10000000f,-0.78000000f,-0.11000000f,-0.04000000f,-0.31000000f,-0.63000000f,-0.45000000f,0.12000000f,0.71000000f,0.88000000f,-0.41000000f,0.30000000f,0.51000000f,-0.73000000f,0.54000000f,-0.00000000f,0.39000000f,0.62000000f,0.81000000f,0.65000000f,-0.26000000f,-0.35000000f,0.84000000f,-0.12000000f,0.77000000f,0.65000000f,0.77000000f,-0.42000000f,0.54000000f,0.95000000f,-0.82000000f,0.46000000f,0.83000000f,0.15000000f,-0.11000000f,-0.06000000f,0.41000000f,0.87000000f,-0.74000000f,-0.24000000f,0.37000000f,0.94000000f,-0.42000000f,-0.56000000f,-0.01000000f,-0.15000000f,0.03000000f,0.49000000f,-0.75000000f,0.18000000f,0.42000000f,0.54000000f,0.39000000f,0.70000000f,-0.49000000f,0.08000000f,0.68000000f,-0.25000000f,0.36000000f,0.38000000f,0.44000000f,-0.52000000f,0.86000000f,-0.02000000f,0.69000000f,0.90000000f,0.89000000f,-0.77000000f,0.14000000f,-0.78000000f,-0.64000000f,0.40000000f,-0.09000000f,0.78000000f,-0.81000000f,0.94000000f,0.46000000f,-0.53000000f,0.04000000f,-0.46000000f,0.71000000f,-0.85000000f,0.66000000f,-0.51000000f,-0.09000000f,0.91000000f,0.38000000f,-0.26000000f,0.91000000f,-0.04000000f,-0.86000000f,-0.03000000f,0.83000000f,-0.69000000f,0.35000000f,0.65000000f,-0.03000000f,0.65000000f,0.68000000f,0.56000000f,0.30000000f,-0.46000000f,0.73000000f,0.02000000f,-0.21000000f,0.85000000f,0.48000000f,0.91000000f,0.05000000f,0.15000000f,-0.32000000f,0.39000000f,-0.33000000f,-0.84000000f,-0.66000000f,-0.41000000f,0.98000000f,-0.03000000f,0.56000000f,0.30000000f,0.37000000f,-0.86000000f,0.60000000f,0.47000000f,-0.24000000f,0.53000000f,-0.85000000f,0.66000000f,0.53000000f,-0.31000000f,-0.44000000f,0.88000000f,0.34000000f,-0.73000000f,-0.48000000f,-0.33000000f,-0.73000000f,0.56000000f,0.45000000f,0.18000000f,-0.76000000f,0.56000000f,0.23000000f,-0.83000000f,0.97000000f,-0.48000000f,-0.80000000f,-0.66000000f,0.17000000f,0.74000000f,0.39000000f,-0.02000000f,0.49000000f,-0.33000000f,-0.73000000f,-0.81000000f,0.27000000f,0.21000000f,0.38000000f,-0.68000000f,-0.20000000f,-0.09000000f,-0.96000000f,-0.61000000f,-0.93000000f,-0.99000000f,-0.16000000f,0.15000000f,0.62000000f,0.24000000f,0.74000000f,-0.65000000f,0.35000000f,0.26000000f,0.38000000f,-0.64000000f,-0.67000000f,0.80000000f,0.26000000f,0.30000000f,-0.56000000f,0.20000000f,-0.82000000f,0.06000000f,0.81000000f,0.75000000f,0.82000000f,-0.82000000f,0.55000000f,-0.91000000f,0.37000000f,0.16000000f,-0.03000000f,-0.13000000f,0.09000000f,-0.67000000f,-0.33000000f,-0.18000000f,-0.13000000f,-0.98000000f,-0.81000000f,-0.72000000f,0.49000000f,-0.96000000f,-0.22000000f,0.65000000f,0.35000000f,-0.35000000f,-0.60000000f,-0.64000000f,0.19000000f,-0.57000000f,0.73000000f,-0.70000000f,-0.89000000f,0.46000000f,-0.77000000f,-0.32000000f,0.55000000f,-0.81000000f,-0.61000000f,0.97000000f,-0.49000000f,0.30000000f,0.42000000f,0.66000000f,0.19000000f,0.55000000f,-0.72000000f,-0.95000000f,-0.65000000f,-0.28000000f,-0.75000000f,-0.22000000f,0.29000000f,0.56000000f,-0.02000000f,-0.15000000f,-0.80000000f,0.68000000f,-0.05000000f,-0.35000000f,0.68000000f,-0.84000000f,0.95000000f,-0.14000000f,0.04000000f,0.64000000f,0.49000000f,0.02000000f,0.74000000f,0.57000000f,0.58000000f,0.01000000f,0.62000000f,-0.87000000f,0.76000000f,0.37000000f,0.27000000f,-0.51000000f,0.07000000f,0.31000000f,0.39000000f,0.61000000f,0.60000000f,-0.14000000f,0.62000000f,0.01000000f,-0.10000000f,-0.43000000f,-0.23000000f,-0.91000000f,0.99000000f,0.58000000f,0.81000000f,-0.39000000f,-0.98000000f,0.96000000f,0.02000000f,0.38000000f,-0.94000000f,-0.46000000f,-0.02000000f,0.46000000f,0.48000000f,-0.39000000f,-0.46000000f,0.89000000f,-0.62000000f,0.10000000f,0.81000000f,0.53000000f,-0.96000000f,-0.33000000f,-0.58000000f,-0.17000000f,-0.73000000f,0.12000000f,0.05000000f,0.63000000f,-0.83000000f,0.01000000f,-0.02000000f,-0.00000000f,-0.01000000f,-0.79000000f,0.78000000f,0.48000000f,-0.44000000f,0.46000000f,0.48000000f,-0.72000000f,-0.53000000f,0.08000000f,0.00000000f,-0.12000000f,-0.93000000f,-0.87000000f,-0.32000000f,-0.49000000f,0.35000000f,-0.63000000f,-0.20000000f,0.99000000f,0.01000000f,-0.23000000f,0.41000000f,-0.32000000f,0.12000000f,0.85000000f,0.31000000f,0.43000000f,0.21000000f,0.60000000f,-0.33000000f,-0.71000000f,-0.84000000f,-0.23000000f,-0.06000000f,-0.23000000f,0.08000000f,0.89000000f,0.99000000f,0.64000000f,0.65000000f,-0.55000000f,0.60000000f,-0.07000000f,-0.62000000f,0.74000000f,0.57000000f,0.85000000f,0.27000000f,0.56000000f,-0.87000000f,0.00000000f,-0.37000000f,-0.67000000f,0.07000000f,0.49000000f,0.44000000f,-0.92000000f,0.48000000f,0.70000000f,-0.86000000f,0.33000000f,0.39000000f,0.71000000f,0.43000000f,0.80000000f,-0.52000000f,0.01000000f,-0.54000000f,-0.95000000f,-0.39000000f,0.40000000f,-0.75000000f,0.08000000f,0.76000000f,-0.62000000f,-0.39000000f,0.94000000f,0.31000000f,0.09000000f,-0.15000000f,0.83000000f,-0.77000000f,0.05000000f,0.85000000f,0.68000000f,-0.32000000f,0.94000000f,-0.09000000f,-0.57000000f,0.46000000f,-0.01000000f,-0.77000000f,0.68000000f,0.44000000f,0.01000000f,-0.38000000f,0.82000000f,-0.22000000f,0.74000000f,0.75000000f,-0.43000000f,-0.26000000f,0.01000000f,0.87000000f,0.15000000f,-0.93000000f,-0.51000000f,-0.23000000f,-0.57000000f,0.88000000f,0.76000000f,-0.39000000f,0.78000000f,-0.40000000f,0.78000000f,-0.86000000f,-0.15000000f,0.47000000f,-0.75000000f,-0.26000000f,-0.54000000f,-0.00000000f,-0.42000000f,0.40000000f,0.53000000f,-0.34000000f,0.26000000f,-0.20000000f,-0.09000000f,-0.89000000f,0.96000000f,0.44000000f,-0.56000000f,-0.58000000f,-0.40000000f,-0.69000000f,0.21000000f,-0.74000000f,0.42000000f,0.94000000f,0.95000000f,-0.01000000f,0.93000000f,0.22000000f,-0.40000000f,-0.56000000f,0.42000000f,-0.97000000f,-0.72000000f,0.59000000f,-0.69000000f,0.52000000f,0.62000000f,-0.13000000f,-0.47000000f,0.18000000f,0.00000000f,0.37000000f,0.58000000f,-0.61000000f,0.28000000f,-0.85000000f,0.52000000f,-0.69000000f,-0.62000000f,0.54000000f,-0.90000000f,0.89000000f,0.86000000f,-0.83000000f,-0.57000000f,0.32000000f,0.43000000f,0.35000000f,-0.35000000f,0.02000000f,0.93000000f,0.77000000f,0.32000000f,0.52000000f,0.58000000f,0.76000000f,0.35000000f,-0.55000000f,-0.10000000f,-0.07000000f,-0.82000000f,-0.40000000f,0.25000000f,0.91000000f,0.81000000f,0.60000000f,-0.58000000f,0.64000000f,0.20000000f,0.97000000f,0.61000000f,-0.57000000f,0.93000000f,0.69000000f,-0.42000000f,0.99000000f,-0.80000000f,0.59000000f,0.48000000f,0.13000000f,0.42000000f,-0.78000000f,-0.83000000f,0.72000000f,0.49000000f,0.56000000f,-0.69000000f,-0.89000000f,0.95000000f,-0.45000000f,-0.15000000f,-0.39000000f,0.12000000f,-0.85000000f,-0.85000000f,-0.81000000f,-0.63000000f,0.33000000f,-0.00000000f,0.14000000f,-0.46000000f,-0.13000000f,0.44000000f,0.97000000f,-0.03000000f,0.58000000f,0.91000000f,-0.34000000f,0.56000000f,0.79000000f,0.36000000f,0.34000000f,0.00000000f,-0.16000000f,0.98000000f,-0.32000000f,-0.91000000f,0.51000000f,0.65000000f,-0.71000000f,-0.53000000f,0.00000000f,0.41000000f,0.83000000f,-0.42000000f,-0.52000000f,-0.82000000f,0.46000000f,0.20000000f,-0.61000000f,0.50000000f,0.82000000f,0.43000000f,0.05000000f,-0.29000000f,0.92000000f,0.87000000f,-0.57000000f,-0.56000000f,0.10000000f,0.06000000f,-0.95000000f,-0.26000000f,0.35000000f,-0.83000000f,-0.41000000f,0.85000000f,-0.43000000f,0.61000000f,-0.71000000f,0.70000000f,0.70000000f,-0.50000000f,-0.94000000f,0.89000000f,-0.78000000f,-0.64000000f,0.66000000f,-0.37000000f,-0.24000000f,-0.74000000f,-0.40000000f,0.62000000f,-0.01000000f,0.11000000f,0.47000000f,-0.85000000f,-0.10000000f,-0.11000000f,-0.91000000f,0.48000000f,0.43000000f,0.01000000f,0.71000000f,0.66000000f,0.15000000f,-0.33000000f,-0.07000000f,-0.92000000f,-0.77000000f,-0.44000000f,0.33000000f,-0.89000000f,-0.52000000f,0.46000000f,-0.68000000f,0.37000000f,-0.54000000f,0.11000000f,-0.08000000f,0.60000000f,-0.13000000f,-0.01000000f,-0.38000000f,-0.31000000f,-0.32000000f,0.10000000f,-0.58000000f,-0.12000000f,-0.62000000f,0.97000000f,-0.59000000f,-0.26000000f,-0.26000000f,0.08000000f,-0.59000000f,0.91000000f,0.33000000f,-0.12000000f,-0.22000000f,-0.08000000f,-0.86000000f,0.02000000f,0.65000000f,0.56000000f,-0.13000000f,0.34000000f,0.17000000f,0.59000000f,0.62000000f,0.70000000f,0.57000000f,0.73000000f,-0.86000000f,-0.21000000f,0.64000000f,-0.23000000f,-0.68000000f,0.92000000f,0.75000000f,-0.05000000f,-0.63000000f,-0.61000000f,0.52000000f,0.77000000f,-0.92000000f,-0.71000000f,0.73000000f,-0.62000000f,0.32000000f,-0.38000000f,0.99000000f,-0.58000000f,-0.77000000f,0.58000000f,-0.25000000f,0.08000000f,0.87000000f,0.12000000f,0.03000000f,0.60000000f,-0.07000000f,-0.31000000f,-0.70000000f,0.34000000f,0.71000000f,-0.94000000f,-0.72000000f,0.37000000f,0.18000000f,0.71000000f,0.17000000f,-0.75000000f,-0.90000000f,0.24000000f,-0.53000000f,-0.05000000f,0.68000000f,-0.19000000f,0.62000000f,-0.62000000f,0.67000000f,0.02000000f,0.78000000f,-0.85000000f,0.24000000f,-0.57000000f,0.02000000f,-0.31000000f,-0.23000000f,-0.95000000f,-0.78000000f,-0.51000000f,0.46000000f,0.33000000f,-0.06000000f,-0.05000000f,0.75000000f,-0.07000000f,-0.69000000f,-0.55000000f,-0.79000000f,0.39000000f,-0.28000000f,0.92000000f,-0.47000000f,-0.34000000f,-0.04000000f,0.32000000f,-0.35000000f,0.97000000f,-0.45000000f,0.65000000f,0.51000000f,-0.90000000f,-0.87000000f,0.48000000f,0.40000000f,0.46000000f,0.82000000f,-0.02000000f,-0.55000000f,0.85000000f,0.12000000f,-0.10000000f,0.65000000f,-0.23000000f,0.99000000f,0.91000000f,-0.02000000f,-0.89000000f,-0.67000000f,-0.92000000f,0.06000000f,-0.16000000f,-0.97000000f,-0.17000000f,0.11000000f,0.37000000f,0.59000000f,-0.85000000f,-0.43000000f,-0.24000000f,-0.78000000f,-0.35000000f,0.07000000f,-0.26000000f,0.65000000f,-0.86000000f,-0.29000000f,-0.82000000f,-0.03000000f,0.25000000f,-0.23000000f,0.51000000f,-0.61000000f,0.68000000f,0.88000000f,-0.35000000f,-0.17000000f,0.36000000f,0.36000000f,0.80000000f,-0.80000000f,-0.52000000f,0.90000000f,0.65000000f,0.82000000f,-0.19000000f,-0.10000000f,0.62000000f,0.87000000f,-0.11000000f,-0.67000000f,-0.24000000f,0.28000000f,0.80000000f,0.69000000f,0.36000000f,0.06000000f,0.02000000f,-0.15000000f,-0.85000000f,-0.94000000f,0.18000000f,-0.67000000f,-0.03000000f,0.58000000f,0.95000000f,0.70000000f,0.04000000f,-0.66000000f,-0.21000000f,0.77000000f,-0.87000000f,-0.96000000f,-0.86000000f,-0.96000000f,-0.33000000f,0.46000000f,-0.08000000f,-0.15000000f,0.24000000f,0.83000000f,-0.10000000f,-0.90000000f,-0.47000000f,0.56000000f,-0.10000000f,0.96000000f,-0.13000000f,0.12000000f,0.15000000f,-0.14000000f,-0.88000000f,-0.27000000f,0.86000000f,-0.51000000f,-0.00000000f,0.13000000f,0.56000000f,0.00000000f,0.03000000f,-0.64000000f,0.05000000f,0.44000000f,0.85000000f,0.15000000f,-0.70000000f,0.26000000f,-0.57000000f,-0.59000000f,-0.90000000f,-0.42000000f,0.46000000f,0.90000000f,-0.47000000f,-0.05000000f,-0.29000000f,0.77000000f,-0.47000000f,0.63000000f,-0.72000000f,0.24000000f,-0.90000000f,-0.96000000f,0.61000000f,0.74000000f,-0.90000000f,0.12000000f,-0.92000000f,-0.76000000f,0.34000000f,-0.53000000f,-0.50000000f,0.75000000f,0.78000000f,0.13000000f,0.39000000f,0.10000000f,0.57000000f,-0.10000000f,0.00000000f,0.61000000f,-0.29000000f,0.92000000f,-0.89000000f,0.70000000f,-0.25000000f,0.01000000f,0.56000000f,0.17000000f,-0.51000000f,0.78000000f,0.03000000f,-0.45000000f,0.37000000f,-0.65000000f,0.65000000f,-0.18000000f,0.28000000f,-0.04000000f,-0.68000000f,-0.48000000f,0.06000000f,0.94000000f,0.56000000f,0.92000000f,0.96000000f,-0.46000000f,-0.69000000f,0.89000000f,-0.43000000f,-0.68000000f,0.87000000f,-0.73000000f,0.93000000f,0.02000000f,0.99000000f,0.41000000f,-0.78000000f,0.06000000f,-0.56000000f,0.04000000f,0.68000000f,-0.79000000f,0.26000000f,0.39000000f,0.92000000f,-0.71000000f,-0.17000000f,-0.36000000f,-0.48000000f,-0.17000000f,0.97000000f,-0.94000000f,-0.46000000f,-0.84000000f,-0.79000000f,0.40000000f,0.20000000f,-0.71000000f,-0.70000000f,0.28000000f,-0.27000000f,-0.63000000f,-0.39000000f,-0.36000000f,0.35000000f,-0.69000000f,-0.94000000f,-0.17000000f,-0.97000000f,-0.07000000f,-0.78000000f,0.84000000f,0.17000000f,0.54000000f,0.29000000f,0.76000000f,0.73000000f,-0.58000000f,-0.03000000f,0.27000000f,0.44000000f,-0.03000000f,-0.83000000f,-0.04000000f,-0.93000000f,-0.42000000f,0.82000000f,-0.01000000f,-0.62000000f,-0.01000000f,0.61000000f,-0.05000000f,-0.69000000f,-0.63000000f,-0.02000000f,-0.25000000f,-0.27000000f,0.86000000f,0.48000000f,-0.92000000f,0.71000000f,0.69000000f,-0.93000000f,0.23000000f,-0.48000000f,0.22000000f,0.05000000f,-0.00000000f,-0.97000000f,0.82000000f,-0.47000000f,0.53000000f,0.68000000f,0.65000000f,-0.13000000f,-0.29000000f,-0.74000000f,0.66000000f,-0.47000000f,-0.01000000f,-0.62000000f,0.18000000f,0.78000000f,0.35000000f,0.34000000f,0.34000000f,-0.20000000f,0.65000000f,0.40000000f,-0.78000000f,-0.11000000f,0.81000000f,-0.36000000f,0.74000000f,-0.83000000f,-0.66000000f,-0.26000000f,0.90000000f,0.02000000f,0.55000000f,-0.97000000f,0.54000000f,0.50000000f,0.25000000f,0.57000000f,-0.49000000f,-0.15000000f,-0.45000000f,0.50000000f,-0.79000000f,-0.90000000f,-0.91000000f,0.31000000f,0.97000000f,0.77000000f,0.76000000f,0.73000000f,0.40000000f,-0.04000000f,-0.25000000f,0.71000000f,0.44000000f,0.71000000f,0.59000000f,0.88000000f,0.39000000f,-0.23000000f,0.99000000f,0.94000000f,0.65000000f,0.52000000f,-0.55000000f,-0.30000000f,-0.81000000f,0.21000000f,0.37000000f,0.47000000f,0.26000000f,-0.07000000f,-0.08000000f,0.62000000f,0.99000000f,-0.52000000f,-0.04000000f,0.75000000f,-0.67000000f,-0.23000000f,-0.16000000f,-0.25000000f,0.50000000f,-0.17000000f,-0.09000000f,0.16000000f,-0.92000000f,0.62000000f,0.70000000f,0.28000000f,0.00000000f,0.87000000f,-0.73000000f,0.97000000f,-0.31000000f,0.94000000f,0.56000000f,-0.00000000f,0.37000000f,0.05000000f,-0.70000000f,-0.03000000f,0.80000000f,0.95000000f,0.08000000f,-0.34000000f,0.85000000f,0.88000000f,0.95000000f,0.88000000f,0.14000000f,-0.22000000f,0.94000000f,0.47000000f,-0.85000000f,-0.07000000f,0.67000000f,0.55000000f,0.74000000f,0.87000000f,-0.39000000f,0.99000000f,0.49000000f,-0.14000000f,-0.20000000f,0.79000000f,-0.88000000f,0.79000000f,-0.14000000f,0.40000000f,0.57000000f,-0.32000000f,0.47000000f,-0.93000000f,-0.97000000f,-0.18000000f,0.71000000f,-0.96000000f,-0.50000000f,-0.65000000f,0.69000000f,-0.26000000f,-0.94000000f,-0.07000000f,-0.20000000f,0.55000000f,-0.84000000f,0.14000000f,0.88000000f,-0.94000000f,-0.62000000f,0.42000000f,-0.49000000f,0.70000000f,-0.61000000f,-0.36000000f,-0.92000000f,-0.96000000f,-0.42000000f,-0.15000000f,-0.55000000f,0.51000000f,0.56000000f,-0.03000000f,0.16000000f,0.27000000f,0.06000000f,-0.46000000f,-0.54000000f,-0.74000000f,0.48000000f,0.79000000f,-0.30000000f,-0.31000000f,0.37000000f,-0.63000000f,-0.53000000f,0.65000000f,-0.54000000f,-0.68000000f,0.10000000f,0.19000000f,-0.51000000f,0.68000000f,-0.81000000f,0.20000000f,0.38000000f,0.83000000f,0.14000000f,0.81000000f,0.29000000f,0.95000000f,-0.57000000f,0.83000000f,-0.25000000f,-0.26000000f,0.10000000f,-0.23000000f,0.00000000f,-0.77000000f,-0.47000000f,-0.36000000f,-0.33000000f,-0.38000000f,0.48000000f,0.15000000f,-0.61000000f,-0.07000000f,-0.35000000f,-0.52000000f,0.46000000f,-0.51000000f,-0.56000000f,0.32000000f,-0.51000000f,-0.87000000f,-0.76000000f,0.95000000f,-0.88000000f,-0.53000000f,-0.51000000f,0.18000000f,0.95000000f,-0.72000000f,-0.06000000f,0.85000000f,0.07000000f,-0.84000000f,0.90000000f,-0.19000000f,0.14000000f,0.54000000f,-0.84000000f,-0.57000000f,-0.38000000f,0.23000000f,0.45000000f,0.66000000f,0.73000000f,-0.87000000f,-0.29000000f,0.25000000f,-0.74000000f,-0.87000000f,-0.54000000f,0.08000000f,-0.26000000f,-0.15000000f,0.40000000f,-0.62000000f,-0.73000000f,-0.38000000f,0.13000000f,0.37000000f,0.20000000f,0.61000000f,-0.78000000f,0.84000000f,0.99000000f,0.80000000f,-0.99000000f,0.52000000f,0.85000000f,-0.61000000f,-0.74000000f,-0.52000000f,0.03000000f,-0.17000000f,-0.91000000f,0.64000000f,0.61000000f,0.82000000f,0.49000000f,-0.90000000f,0.13000000f,0.92000000f,0.63000000f,-0.38000000f,0.40000000f,-0.12000000f,-0.46000000f,-0.66000000f,0.45000000f,-0.68000000f,-0.32000000f,-0.41000000f,0.97000000f,-0.78000000f,-0.82000000f,-0.93000000f,-0.19000000f,0.33000000f,-0.56000000f,-0.21000000f,-0.37000000f,0.61000000f,-0.37000000f,-0.59000000f,0.50000000f,0.88000000f,0.39000000f,0.11000000f,0.66000000f,-0.67000000f,0.49000000f,-0.07000000f,0.51000000f,-0.20000000f,0.65000000f,-0.63000000f,-0.87000000f,0.96000000f,-0.58000000f,-0.24000000f,0.29000000f,-0.67000000f,-0.39000000f,-0.18000000f,0.48000000f,0.79000000f,0.97000000f,0.24000000f,0.07000000f,0.19000000f,0.54000000f,-0.45000000f,-0.34000000f,-0.13000000f,0.43000000f,-0.55000000f,-0.31000000f,-0.55000000f,0.77000000f,-0.52000000f,-0.20000000f,0.30000000f,0.81000000f,0.74000000f,0.63000000f,0.01000000f,-0.70000000f,0.17000000f,0.50000000f,0.34000000f,0.73000000f,0.01000000f,-0.74000000f,0.37000000f,0.88000000f,-0.40000000f,0.39000000f,-0.07000000f,-0.03000000f,0.14000000f,0.89000000f,0.70000000f,-0.49000000f,-0.41000000f,-0.66000000f,0.20000000f,0.95000000f,0.34000000f,0.69000000f,-0.01000000f,-0.63000000f,0.57000000f,0.60000000f,0.99000000f,0.49000000f,-0.45000000f,0.77000000f,-0.26000000f,-0.83000000f,0.29000000f,0.69000000f,-0.26000000f,0.97000000f,-0.25000000f,-0.96000000f,0.68000000f,-0.17000000f,0.99000000f,-0.61000000f,0.40000000f,-0.56000000f,0.50000000f,0.07000000f,0.74000000f,-0.16000000f,-0.44000000f,0.72000000f,0.50000000f,0.02000000f,0.74000000f,0.95000000f,-0.14000000f,-0.40000000f,0.82000000f,-0.82000000f,-0.58000000f,0.06000000f,0.77000000f,-0.26000000f,0.63000000f,0.17000000f,-0.44000000f,-0.08000000f,0.72000000f,0.16000000f,-0.91000000f,-0.56000000f,0.86000000f,0.34000000f,0.70000000f,0.85000000f,-0.93000000f,0.99000000f,0.33000000f,0.32000000f,0.23000000f,-0.40000000f,-0.96000000f,0.07000000f,0.01000000f,-0.81000000f,-0.39000000f,-0.82000000f,-0.50000000f,-0.15000000f,0.52000000f,0.34000000f,-0.96000000f,-0.28000000f,0.16000000f,0.72000000f,-0.91000000f,0.03000000f,-0.22000000f,0.27000000f,-0.53000000f,0.27000000f,-0.53000000f,0.95000000f,0.48000000f,0.22000000f,0.61000000f,-0.30000000f,0.67000000f,-0.22000000f,-0.06000000f,-0.56000000f,-0.74000000f,0.98000000f,-0.97000000f,0.15000000f,0.97000000f,-0.71000000f,0.53000000f,-0.09000000f,0.58000000f,-0.80000000f,0.85000000f,-0.96000000f,-0.50000000f,0.22000000f,-0.43000000f,-0.73000000f,0.36000000f,-0.27000000f,0.46000000f,0.36000000f,0.92000000f,0.02000000f,0.00000000f,0.55000000f,-0.00000000f,-0.68000000f,-0.39000000f,-0.67000000f,-0.58000000f,-0.50000000f,0.39000000f,-0.18000000f,0.48000000f,-0.66000000f,0.05000000f,-0.38000000f,-0.48000000f,0.42000000f,-0.72000000f,0.30000000f,0.30000000f,0.13000000f,-0.52000000f,-0.47000000f,-0.07000000f,-0.92000000f,-0.28000000f,0.25000000f,-0.19000000f,0.83000000f,-0.30000000f,0.66000000f,0.57000000f,-0.98000000f,-0.47000000f,0.03000000f,0.22000000f,-0.55000000f,0.14000000f,-0.04000000f,-0.81000000f,0.99000000f,-0.48000000f,-0.36000000f,0.24000000f,0.08000000f,-0.82000000f,-0.74000000f,-0.68000000f,-0.12000000f,-0.57000000f,-0.55000000f,-0.43000000f,-0.57000000f,-0.37000000f,-0.84000000f,-0.83000000f,0.44000000f,0.26000000f,-0.04000000f,0.03000000f,-0.58000000f,-0.84000000f,0.78000000f,-0.30000000f,-0.00000000f,-0.82000000f,0.12000000f,-0.00000000f,0.13000000f,0.49000000f,-0.26000000f,0.11000000f,0.50000000f,-0.44000000f,-0.87000000f,-0.15000000f,-0.22000000f,-0.21000000f,-0.76000000f,-0.79000000f,0.80000000f,0.97000000f,0.97000000f,0.06000000f,0.87000000f,0.13000000f,-0.22000000f,0.49000000f,-0.11000000f,-0.36000000f,-0.12000000f,-0.39000000f,0.43000000f,0.17000000f,0.54000000f,-0.17000000f,0.93000000f,-0.21000000f,0.80000000f,0.60000000f,-0.40000000f,0.02000000f,0.85000000f,0.32000000f,-0.52000000f,-0.62000000f,0.54000000f,0.01000000f,-0.93000000f,0.07000000f,0.97000000f,-0.46000000f,-0.94000000f,-0.94000000f,-0.93000000f,-0.41000000f,0.80000000f,-0.54000000f,-0.23000000f,-0.08000000f,0.60000000f,-0.56000000f,0.26000000f,0.12000000f,-0.48000000f,0.53000000f,0.90000000f,0.93000000f,-0.84000000f,0.71000000f,-0.60000000f,0.18000000f,0.52000000f,-0.59000000f,-0.74000000f,0.36000000f,-0.74000000f,-0.25000000f,-0.77000000f,0.13000000f,-0.88000000f,0.88000000f,-0.23000000f,-0.29000000f,0.82000000f,0.26000000f,0.57000000f,-0.29000000f,0.07000000f,-0.40000000f,0.99000000f,-0.89000000f,0.56000000f,-0.19000000f,0.95000000f,0.50000000f,-0.70000000f,0.31000000f,0.75000000f,0.63000000f,0.70000000f,-0.46000000f,-0.34000000f,0.88000000f,0.03000000f,0.56000000f,0.71000000f,0.34000000f,0.17000000f,-0.79000000f,-0.78000000f,0.47000000f,0.14000000f,0.00000000f,0.49000000f,0.10000000f,0.42000000f,0.35000000f,-0.39000000f,0.02000000f,-0.02000000f,0.19000000f,0.36000000f,-0.71000000f,0.30000000f,-0.58000000f,-0.42000000f,-0.23000000f,0.24000000f,0.17000000f,-0.42000000f,0.77000000f,-0.88000000f,0.07000000f,-0.33000000f,0.20000000f,-0.05000000f,0.37000000f,-0.74000000f,0.87000000f,0.00000000f,-0.23000000f,-0.48000000f,-0.95000000f,-0.97000000f,0.12000000f,-0.86000000f,0.58000000f,-0.92000000f,0.62000000f,0.72000000f,-0.53000000f,0.03000000f,0.70000000f,0.26000000f,0.95000000f,-0.44000000f,0.91000000f,0.09000000f,-0.31000000f,0.53000000f,0.90000000f,0.92000000f,-0.68000000f,0.75000000f,-0.85000000f,-0.04000000f,-0.42000000f,-0.77000000f,-0.67000000f,0.94000000f,-0.57000000f,-0.93000000f,-0.43000000f,-0.74000000f,0.95000000f,-0.53000000f,-0.50000000f,0.69000000f,0.93000000f,0.61000000f,-0.62000000f,0.66000000f,0.44000000f,-0.98000000f,0.54000000f,0.33000000f,-0.61000000f,-0.95000000f,0.92000000f,-0.95000000f,0.63000000f,-0.25000000f,-0.36000000f,-0.70000000f,-0.57000000f,-0.36000000f,-0.42000000f,0.34000000f,-0.01000000f,0.27000000f,-0.76000000f,-0.22000000f,0.46000000f,-0.89000000f,-0.02000000f,0.57000000f,0.82000000f,-0.58000000f,-0.52000000f,0.49000000f,0.02000000f,-0.04000000f,0.73000000f,-0.47000000f,-0.08000000f,0.47000000f,-0.98000000f,0.94000000f,0.82000000f,-0.90000000f,-0.88000000f,-0.82000000f,0.04000000f,0.25000000f,0.84000000f,-0.26000000f,0.19000000f,-0.43000000f,0.32000000f,-0.66000000f,0.25000000f,0.44000000f,0.47000000f,-0.69000000f,-0.14000000f,0.64000000f,-0.15000000f,-0.50000000f,-0.12000000f,0.29000000f,-0.08000000f,0.83000000f,0.48000000f,0.07000000f,-0.51000000f,0.24000000f,-0.81000000f,-0.65000000f,-0.54000000f,0.12000000f,0.52000000f,0.15000000f,-0.55000000f,-0.94000000f,0.47000000f,-0.32000000f,0.04000000f,0.17000000f,-0.13000000f,-0.13000000f,0.46000000f,0.13000000f,-0.85000000f,-0.55000000f,0.41000000f,-0.90000000f,0.84000000f,-0.17000000f,-0.73000000f,0.29000000f,-0.70000000f,0.16000000f,0.38000000f,0.39000000f,-0.93000000f,0.96000000f,-0.45000000f,0.54000000f,-0.76000000f,-0.07000000f,-0.02000000f,0.84000000f,0.91000000f,-0.09000000f,0.94000000f,-0.19000000f,0.88000000f,-0.93000000f,0.74000000f,0.19000000f,-0.39000000f,0.11000000f,-0.36000000f,-0.57000000f,0.01000000f,-0.71000000f,-0.67000000f,-0.54000000f,0.54000000f,-0.22000000f,0.06000000f,-0.67000000f,0.68000000f,-0.45000000f,0.64000000f,0.46000000f,0.69000000f,0.75000000f,0.94000000f,-0.40000000f,-0.05000000f,-0.89000000f,-0.07000000f,-0.47000000f,0.03000000f,-0.31000000f,0.54000000f,-0.88000000f,0.90000000f,-0.37000000f,0.01000000f,-0.23000000f,-0.96000000f,0.12000000f,-0.42000000f,0.91000000f,-0.62000000f,-0.06000000f,0.78000000f,0.63000000f,-0.72000000f,0.28000000f,0.11000000f,0.11000000f,0.15000000f,0.73000000f,-0.91000000f,0.36000000f,0.42000000f,0.25000000f,-0.36000000f,-0.27000000f,0.42000000f,-0.51000000f,-0.44000000f,0.87000000f,0.33000000f,0.47000000f,0.84000000f,0.05000000f,0.37000000f,-0.60000000f,-0.66000000f,0.83000000f,0.84000000f,0.43000000f,0.15000000f,-0.90000000f,-0.48000000f,-0.59000000f,-0.98000000f,0.80000000f,-0.43000000f,-0.01000000f,0.43000000f,0.62000000f,-0.52000000f,0.36000000f,-0.55000000f,0.14000000f,0.08000000f,-0.32000000f,0.65000000f,-0.51000000f,0.26000000f,0.69000000f,-0.71000000f,-0.69000000f,0.28000000f,-0.66000000f,-0.91000000f,-0.15000000f,0.47000000f,0.34000000f,0.56000000f,-0.66000000f,0.26000000f,0.56000000f,0.21000000f,-0.67000000f,0.85000000f,0.30000000f,0.83000000f,0.17000000f,-0.30000000f,0.09000000f,0.23000000f,0.64000000f,0.26000000f,0.78000000f,-0.09000000f,-0.37000000f,-0.45000000f,-0.74000000f,-0.96000000f,-0.13000000f,0.16000000f,-0.94000000f,-0.78000000f,0.75000000f,0.40000000f,0.83000000f,0.99000000f,-0.91000000f,-0.26000000f,0.66000000f,-0.55000000f,0.89000000f,0.86000000f,-0.64000000f,-0.06000000f,0.33000000f,-0.09000000f,-0.87000000f,0.63000000f,-0.40000000f,0.91000000f,-0.89000000f,0.76000000f,-0.39000000f,-0.93000000f,0.77000000f,0.61000000f,-0.10000000f,-0.78000000f,-0.79000000f,-0.93000000f,0.44000000f,0.58000000f,0.16000000f,-0.39000000f,-0.97000000f,-0.90000000f,0.01000000f,-0.36000000f,0.70000000f,0.26000000f,0.90000000f,-0.65000000f,0.94000000f,-0.19000000f,-0.00000000f,0.26000000f,-0.39000000f,0.25000000f,-0.27000000f,0.68000000f,0.06000000f,0.11000000f,0.88000000f,0.73000000f,0.17000000f,0.83000000f,-0.39000000f,-0.16000000f,-0.43000000f,-0.16000000f,0.59000000f,0.68000000f,0.45000000f,0.15000000f,0.53000000f,-0.56000000f,0.99000000f,-0.46000000f,-0.50000000f,-0.47000000f,-0.63000000f,-0.07000000f,0.32000000f,0.09000000f,0.40000000f,-0.42000000f,-0.66000000f,0.89000000f,-0.73000000f,-0.62000000f,0.43000000f,0.67000000f,-0.31000000f,0.65000000f,-0.04000000f,-0.37000000f,0.77000000f,0.10000000f,-0.78000000f,0.67000000f,0.29000000f,-0.37000000f,-0.94000000f,-0.00000000f,-0.79000000f,-0.15000000f,0.08000000f,-0.53000000f,0.88000000f,0.21000000f,0.73000000f,0.17000000f,-0.13000000f,0.93000000f,0.86000000f,-0.65000000f,-0.12000000f,-0.69000000f,0.57000000f,0.23000000f,-0.62000000f,0.03000000f,-0.47000000f,0.02000000f,0.20000000f,-0.42000000f,0.97000000f,0.85000000f,-0.16000000f,-0.87000000f,-0.78000000f,0.50000000f,0.34000000f,-0.81000000f,0.87000000f,0.29000000f,0.61000000f,-0.82000000f,-0.50000000f,-0.86000000f,0.56000000f,-0.14000000f,-0.50000000f,-0.35000000f,-0.55000000f,-0.37000000f,0.37000000f,-0.55000000f,0.59000000f,-0.27000000f,0.47000000f,-0.88000000f,0.78000000f,0.09000000f,-0.61000000f,-0.20000000f,-0.81000000f,0.10000000f,0.11000000f,-0.93000000f,-0.80000000f,0.74000000f,0.65000000f,0.27000000f,-0.97000000f,0.97000000f,-0.04000000f,0.49000000f,-0.77000000f,0.36000000f,0.82000000f,0.09000000f,-0.32000000f,0.08000000f,0.67000000f,0.08000000f,0.48000000f,-0.02000000f,-0.07000000f,0.55000000f,-0.47000000f,0.03000000f,-0.17000000f,-0.72000000f,-0.05000000f,0.79000000f,0.60000000f,-0.86000000f,0.68000000f,0.07000000f,0.77000000f,-0.60000000f,0.83000000f,0.47000000f,0.65000000f,-0.95000000f,-0.00000000f,0.71000000f,0.97000000f,0.63000000f,0.75000000f,0.83000000f,-0.08000000f,-0.89000000f,-0.46000000f,-0.46000000f,-0.51000000f,0.69000000f,0.83000000f,0.33000000f,0.25000000f,0.36000000f,-0.47000000f,-0.57000000f,0.36000000f,-0.15000000f,0.03000000f,0.72000000f,-0.91000000f,-0.46000000f,-0.45000000f,-0.08000000f,0.21000000f,0.39000000f,-0.59000000f,0.73000000f,0.34000000f,-0.42000000f,0.35000000f,-0.11000000f,-0.38000000f,-0.51000000f,0.84000000f,-0.07000000f,-0.21000000f,-0.58000000f,-0.96000000f,-0.91000000f,0.00000000f,-0.85000000f,-0.29000000f,-0.73000000f,-0.45000000f,-0.52000000f,-0.13000000f,-0.44000000f,-0.79000000f,-0.90000000f,0.32000000f,0.67000000f,0.66000000f,0.51000000f,-0.57000000f,-0.31000000f,0.85000000f,-0.46000000f,0.91000000f,-0.03000000f,-0.13000000f,0.81000000f,-0.84000000f,0.07000000f,0.37000000f,-0.51000000f,0.73000000f,-0.11000000f,0.59000000f,-0.38000000f,0.64000000f,-0.41000000f,-0.80000000f,0.72000000f,-0.72000000f,-0.70000000f,0.50000000f,-0.19000000f,-0.42000000f,-0.10000000f,0.59000000f,0.79000000f,-0.69000000f,-0.58000000f,0.15000000f,0.98000000f,0.44000000f,0.19000000f,-0.18000000f,-0.06000000f,0.80000000f,-0.27000000f,-0.02000000f,-0.02000000f,0.25000000f,-0.20000000f,0.29000000f,-0.80000000f,0.39000000f,0.89000000f,0.99000000f,0.47000000f,0.43000000f,0.71000000f,-0.43000000f,-0.26000000f,0.62000000f,0.10000000f,0.79000000f,-0.26000000f,0.18000000f,0.27000000f,-0.75000000f,-0.82000000f,-0.09000000f,-0.63000000f,0.66000000f,-0.29000000f,-0.54000000f,-0.21000000f,-0.83000000f,-0.42000000f,0.85000000f,0.69000000f,-0.95000000f,-0.85000000f,0.04000000f,-0.60000000f,0.02000000f,-0.00000000f,0.19000000f,0.01000000f,0.89000000f,-0.69000000f,0.85000000f,-0.70000000f,0.46000000f,-0.47000000f,-0.43000000f,-0.03000000f,0.37000000f,-0.66000000f,-0.44000000f,0.90000000f,0.03000000f,-0.07000000f,-0.09000000f,0.17000000f,-0.42000000f,0.16000000f,-0.81000000f,-0.05000000f,0.56000000f,-0.19000000f,-0.23000000f,-0.89000000f,-0.20000000f,-0.95000000f,-0.47000000f,-0.84000000f,0.84000000f,-0.91000000f,-0.33000000f,-0.69000000f,0.53000000f,-0.99000000f,0.93000000f,0.03000000f,-0.88000000f,0.03000000f,-0.01000000f,0.88000000f,0.84000000f,-0.71000000f,-0.25000000f,-0.04000000f,-0.15000000f,-0.92000000f,-0.12000000f,-0.74000000f,-0.04000000f,0.08000000f,-0.61000000f,0.18000000f,0.93000000f,-0.30000000f,-0.81000000f,0.94000000f,-0.39000000f,-0.41000000f,0.21000000f,-0.08000000f,-0.97000000f,-0.41000000f,0.10000000f,-0.44000000f,0.14000000f,0.30000000f,-0.75000000f,0.68000000f,-0.09000000f,0.43000000f,0.49000000f,-0.58000000f,0.94000000f,-0.01000000f,0.26000000f,0.75000000f,0.77000000f,-0.26000000f,0.56000000f,0.48000000f,-0.50000000f,-0.45000000f,0.56000000f,-0.13000000f,0.53000000f,-0.75000000f,-0.18000000f,0.05000000f,-0.00000000f,0.66000000f,0.23000000f,-0.50000000f,0.57000000f,0.37000000f,-0.23000000f,0.86000000f,-0.05000000f,-0.61000000f,-0.22000000f,0.72000000f,-0.35000000f,0.47000000f,-0.50000000f,0.78000000f,0.81000000f,0.05000000f,-0.04000000f,-0.05000000f,0.41000000f,-0.74000000f,0.52000000f,0.34000000f,-0.02000000f,0.30000000f,0.91000000f,-0.52000000f,-0.66000000f,-0.57000000f,-0.49000000f,-0.76000000f,-0.29000000f,-0.92000000f,0.87000000f,-0.26000000f,-0.88000000f,-0.78000000f,-0.98000000f,-0.61000000f,-0.72000000f,0.09000000f,0.82000000f,0.47000000f,-0.19000000f,-0.71000000f,0.56000000f,0.15000000f,-0.07000000f,-0.94000000f,0.85000000f,0.85000000f,0.40000000f,-0.13000000f,-0.20000000f,0.23000000f,-0.02000000f,-0.74000000f,0.12000000f,0.99000000f,-0.44000000f,0.34000000f,-0.54000000f,0.90000000f,-0.95000000f,0.54000000f,-0.27000000f,0.36000000f,0.78000000f,-0.86000000f,-0.21000000f,0.17000000f,0.28000000f,-0.15000000f,0.66000000f,-0.43000000f,0.64000000f,0.70000000f,-0.95000000f,0.27000000f,0.71000000f,0.27000000f,-0.99000000f,-0.11000000f,-0.56000000f,0.21000000f,-0.84000000f,-0.64000000f,-0.26000000f,0.05000000f,0.31000000f,0.56000000f,-0.41000000f,-0.77000000f,-0.32000000f,0.72000000f,0.25000000f,0.81000000f,0.06000000f,-0.92000000f,0.89000000f,-0.23000000f,0.42000000f,0.53000000f,-0.15000000f,0.11000000f,0.88000000f,-0.36000000f,-0.43000000f,-0.68000000f,0.37000000f,-0.62000000f,-0.77000000f,-0.03000000f,-0.93000000f,0.50000000f,0.57000000f,-0.90000000f,-0.00000000f,0.82000000f,0.61000000f,-0.62000000f,0.38000000f,-0.06000000f,-0.32000000f,0.31000000f,0.66000000f,-0.25000000f,0.90000000f,0.15000000f,0.12000000f,0.60000000f,0.82000000f,-0.86000000f,0.54000000f,-0.99000000f,0.05000000f,0.92000000f,-0.75000000f,-0.26000000f,-0.32000000f,-0.18000000f,0.41000000f,0.38000000f,-0.32000000f,0.27000000f,0.08000000f,0.74000000f,-0.71000000f,-0.26000000f,0.34000000f,0.99000000f,0.46000000f,0.11000000f,-0.41000000f,-0.09000000f,0.19000000f,-0.83000000f,0.43000000f,0.12000000f,0.74000000f,0.31000000f,-0.35000000f,-0.76000000f,0.13000000f,0.05000000f,0.65000000f,0.32000000f,-0.62000000f,-0.34000000f,-0.37000000f,0.94000000f,-0.18000000f,0.03000000f,-0.30000000f,-0.91000000f,0.95000000f,0.76000000f,0.67000000f,0.85000000f,0.15000000f,0.84000000f,-0.21000000f,0.87000000f,0.83000000f,0.56000000f,-0.67000000f,0.72000000f,0.05000000f,-0.70000000f,-0.28000000f,-0.87000000f,-0.25000000f,0.95000000f,0.34000000f,-0.01000000f,0.20000000f,-0.72000000f,0.57000000f,0.06000000f,0.99000000f,0.05000000f,0.36000000f,0.77000000f,-0.89000000f,-0.52000000f,-0.65000000f,-0.95000000f,-0.49000000f,-0.62000000f,0.12000000f,0.17000000f,-0.89000000f,0.27000000f,-0.72000000f,0.09000000f,0.94000000f,0.46000000f,-0.39000000f,-0.27000000f,-0.34000000f,0.05000000f,-0.43000000f,0.76000000f,0.59000000f,0.41000000f,-0.69000000f,0.50000000f,0.30000000f,0.69000000f,0.31000000f,0.31000000f,0.60000000f,-0.81000000f,-0.34000000f,-0.31000000f,0.32000000f,0.72000000f,-0.37000000f,0.08000000f,-0.61000000f,-0.77000000f,-0.86000000f,0.13000000f,0.52000000f,-0.28000000f,-0.43000000f,-0.70000000f,0.34000000f,0.41000000f,-0.85000000f,-0.19000000f,0.09000000f,0.88000000f,-0.40000000f,-0.92000000f,-0.62000000f,-0.97000000f,0.11000000f,-0.54000000f,-0.51000000f,-0.99000000f,-0.03000000f,0.69000000f,0.57000000f,-0.56000000f,-0.87000000f,0.39000000f,0.37000000f,0.72000000f,0.17000000f,-0.28000000f,-0.86000000f,0.46000000f,-0.77000000f,0.49000000f,-0.73000000f,-0.65000000f,-0.81000000f,-0.78000000f,0.02000000f,0.22000000f,-0.58000000f,0.30000000f,-0.95000000f,-0.91000000f,0.94000000f,-0.73000000f,0.67000000f,0.45000000f,-0.49000000f,0.37000000f,0.48000000f,-0.76000000f,-0.59000000f,0.32000000f,0.97000000f,0.01000000f,0.46000000f,-0.42000000f,0.58000000f,0.26000000f,0.62000000f,0.58000000f,-0.26000000f,-0.52000000f,-0.24000000f,-0.72000000f,-0.88000000f,0.89000000f,0.99000000f,0.20000000f,0.48000000f,0.11000000f,0.82000000f,-0.51000000f,0.46000000f,-0.07000000f,0.19000000f,0.66000000f,-0.22000000f,-0.68000000f,0.37000000f,0.81000000f,0.51000000f,-0.81000000f,-0.75000000f,-0.51000000f,-0.26000000f,-0.13000000f,0.47000000f,0.59000000f,-0.71000000f,-0.43000000f,-0.33000000f,0.82000000f,-0.15000000f,-0.18000000f,0.80000000f,-0.09000000f,0.19000000f,0.75000000f,0.20000000f,0.31000000f,0.28000000f,-0.44000000f,-0.43000000f,0.18000000f,0.53000000f,0.76000000f,0.15000000f,-0.63000000f,-0.39000000f,-0.84000000f,0.01000000f,-0.05000000f,-0.33000000f,0.32000000f,0.10000000f,0.00000000f,0.80000000f,0.46000000f,-0.78000000f,0.84000000f,-0.20000000f,0.60000000f,0.62000000f,0.52000000f,-0.79000000f,0.21000000f,-0.97000000f,-0.94000000f,0.45000000f,-0.46000000f,-0.97000000f,-0.53000000f,-0.37000000f,-0.97000000f,-0.68000000f,0.09000000f,-0.80000000f,0.50000000f,0.09000000f,0.56000000f,0.10000000f,0.81000000f,0.33000000f,0.81000000f,-0.32000000f,-0.51000000f,-0.00000000f,-0.15000000f,0.92000000f,0.94000000f,-0.79000000f,-0.72000000f,0.43000000f,-0.04000000f,0.42000000f,0.21000000f,0.99000000f,0.39000000f,0.06000000f,-0.01000000f,-0.59000000f,0.18000000f,-0.94000000f,-0.50000000f,-0.55000000f,-0.13000000f,0.32000000f,0.94000000f,-0.87000000f,0.08000000f,-0.72000000f,-0.17000000f,-0.37000000f,0.21000000f,0.01000000f,-0.28000000f,0.60000000f,0.05000000f,-0.99000000f,-0.50000000f,-0.74000000f,0.32000000f,0.49000000f,-0.29000000f,0.12000000f,-0.52000000f,-0.90000000f,-0.68000000f,-0.45000000f,0.73000000f,0.52000000f,0.03000000f,-0.71000000f,0.39000000f,0.92000000f,-0.95000000f,0.83000000f,-0.60000000f,-0.44000000f,-0.66000000f,-0.59000000f,-0.76000000f,-0.79000000f,-0.10000000f,-0.77000000f,0.35000000f,0.88000000f,-0.49000000f,0.08000000f,0.06000000f,-0.97000000f,-0.84000000f,-0.47000000f,0.40000000f,0.51000000f,0.13000000f,-0.06000000f,-0.35000000f,0.81000000f,-0.99000000f,-0.09000000f,-0.92000000f,-0.38000000f,-0.78000000f,-0.10000000f,0.76000000f,-0.08000000f,-0.31000000f,-0.59000000f,-0.86000000f,-0.34000000f,-0.86000000f,0.54000000f,0.10000000f,0.16000000f,-0.01000000f,-0.68000000f,-0.22000000f,-0.15000000f,0.46000000f,0.92000000f,-0.75000000f,-0.84000000f,-0.62000000f,-0.74000000f,0.40000000f,0.90000000f,-0.41000000f,-0.14000000f,-0.73000000f,0.27000000f,0.86000000f,0.53000000f,-0.41000000f,0.35000000f,0.96000000f,0.34000000f,0.96000000f,-0.83000000f,0.88000000f,-0.35000000f,0.34000000f,-0.71000000f,-0.27000000f,-0.28000000f,0.38000000f,-0.98000000f,-0.30000000f,-0.67000000f,0.52000000f,-0.03000000f,0.63000000f,-0.54000000f,0.26000000f,0.41000000f,-0.01000000f,-0.10000000f,-0.38000000f,0.61000000f,-0.77000000f,0.92000000f,0.58000000f,-0.98000000f,0.93000000f,-0.27000000f,-0.08000000f,0.78000000f,-0.64000000f,-0.93000000f,0.79000000f,-0.36000000f,0.94000000f,-0.10000000f,0.48000000f,0.73000000f,-0.44000000f,0.00000000f,-0.94000000f,-0.90000000f,0.04000000f,-0.72000000f,0.09000000f,-0.57000000f,0.46000000f,-0.62000000f,-0.41000000f,0.09000000f,-0.21000000f,-0.56000000f,0.79000000f,0.49000000f,-0.78000000f,0.43000000f,0.61000000f,-0.29000000f,-0.10000000f,-0.54000000f,0.64000000f,-0.95000000f,0.35000000f,-0.50000000f,0.99000000f,0.08000000f,-0.07000000f,-0.00000000f,0.31000000f,0.69000000f,0.78000000f,0.68000000f,-0.34000000f,-0.39000000f,0.17000000f,0.51000000f,-0.25000000f,0.71000000f,0.83000000f,0.58000000f,0.87000000f,0.79000000f,0.14000000f,0.26000000f,0.54000000f,0.26000000f,0.06000000f,0.85000000f,-0.29000000f,-0.79000000f,-0.57000000f,-0.02000000f,-0.07000000f,0.77000000f,0.16000000f,0.17000000f,-0.35000000f,0.63000000f,0.61000000f,0.89000000f,0.52000000f,0.14000000f,0.77000000f,0.57000000f,0.80000000f,-0.81000000f,-0.93000000f,-0.18000000f,-0.32000000f,-0.88000000f,0.24000000f,-0.25000000f,-0.75000000f,0.88000000f,0.43000000f,0.09000000f,-0.08000000f,-0.15000000f,0.53000000f,-0.93000000f,0.02000000f,-0.48000000f,0.82000000f,-0.81000000f,0.86000000f,-0.84000000f,0.15000000f,0.64000000f,-0.20000000f,0.92000000f,0.10000000f,0.26000000f,0.75000000f,-0.50000000f,0.50000000f,-0.75000000f,0.48000000f,-0.27000000f,-0.39000000f,-0.82000000f,-0.71000000f,0.60000000f,0.99000000f,-0.84000000f,0.42000000f,-0.01000000f,0.39000000f,-0.86000000f,-0.06000000f,0.66000000f,0.70000000f,0.17000000f,0.75000000f,-0.97000000f,0.57000000f,-0.44000000f,-0.68000000f,0.13000000f,-0.20000000f,-0.69000000f,0.99000000f,0.73000000f,0.38000000f,-0.51000000f,-0.23000000f,0.26000000f,-0.85000000f,0.57000000f,-0.62000000f,0.72000000f,0.69000000f,0.88000000f,-0.09000000f,-0.30000000f,-0.30000000f,0.37000000f,-0.62000000f,-0.74000000f,-0.02000000f,-0.33000000f,-0.69000000f,0.00000000f,-0.53000000f,-0.99000000f,-0.39000000f,-0.88000000f,0.56000000f,0.09000000f,0.33000000f,0.56000000f,0.75000000f,0.01000000f,-0.68000000f,0.87000000f,0.80000000f,-0.23000000f,-0.48000000f,-0.20000000f,0.08000000f,0.64000000f,0.10000000f,-0.14000000f,0.13000000f,0.50000000f,-0.92000000f,0.43000000f,-0.61000000f,-0.04000000f,-0.90000000f,0.65000000f,0.76000000f,0.58000000f,-0.21000000f,0.63000000f,0.93000000f,-0.61000000f,0.01000000f,-0.13000000f,0.09000000f,0.89000000f,0.46000000f,0.82000000f,0.95000000f,0.23000000f,-0.86000000f,-0.16000000f,0.38000000f,0.00000000f,0.70000000f,-0.42000000f,0.56000000f,-0.55000000f,0.05000000f,0.88000000f,-0.22000000f,-0.51000000f,-0.84000000f,0.28000000f,-0.03000000f,0.74000000f,0.53000000f,0.40000000f,-0.98000000f,-0.52000000f,-0.50000000f,-0.67000000f,0.84000000f,-0.72000000f,-0.78000000f,0.14000000f,0.08000000f,-0.44000000f,-0.23000000f,0.38000000f,-0.01000000f,0.76000000f,0.26000000f,0.97000000f,0.80000000f,-0.84000000f,-0.20000000f,-0.19000000f,0.51000000f,0.42000000f,-0.51000000f,-0.81000000f,0.69000000f,0.10000000f,-0.98000000f,-0.62000000f,-0.82000000f,0.09000000f,-0.43000000f,0.54000000f,0.47000000f,0.43000000f,-0.85000000f,0.87000000f,-0.86000000f,0.24000000f,0.23000000f,-0.46000000f,-0.33000000f,0.86000000f,-0.90000000f,0.26000000f,-0.42000000f,-0.48000000f,-0.12000000f,0.55000000f,-0.28000000f,-0.49000000f,-0.40000000f,0.45000000f,0.72000000f,0.69000000f,0.10000000f,-0.20000000f,0.02000000f,0.65000000f,-0.55000000f,0.70000000f,0.27000000f,-0.11000000f,0.44000000f,0.87000000f,-0.83000000f,0.09000000f,0.60000000f,0.11000000f,0.05000000f,-0.33000000f,-0.35000000f,0.74000000f,0.23000000f,-0.91000000f,0.35000000f,-0.47000000f,0.52000000f,-0.70000000f,0.56000000f,0.24000000f,-0.60000000f,-0.60000000f,0.42000000f,-0.40000000f,-0.30000000f,-0.87000000f,0.61000000f,-0.53000000f,0.61000000f,0.85000000f,0.00000000f,-0.19000000f,-0.10000000f,-0.72000000f,-0.07000000f,-0.62000000f,0.46000000f,-0.16000000f,-0.75000000f,-0.96000000f,-0.92000000f,0.87000000f,-0.95000000f,-0.25000000f,-0.40000000f,0.63000000f,0.45000000f,-0.22000000f,-0.49000000f,0.27000000f,0.05000000f,-0.96000000f,-0.89000000f,0.43000000f,0.38000000f,0.50000000f,0.09000000f,0.78000000f,-0.73000000f,0.67000000f,0.55000000f,-0.53000000f,0.89000000f,-0.34000000f,0.99000000f,-0.29000000f,-0.04000000f,-0.42000000f,-0.34000000f,-0.74000000f,-0.36000000f,0.38000000f,0.94000000f,0.29000000f,-0.11000000f,0.10000000f,-0.08000000f,-0.21000000f,-0.18000000f,0.88000000f,-0.64000000f,-0.58000000f,-0.18000000f,0.77000000f,-0.47000000f,-0.53000000f,-0.00000000f,0.13000000f,-0.41000000f,0.71000000f,0.52000000f,-0.39000000f,-0.25000000f,0.15000000f,0.09000000f,0.49000000f,0.99000000f,-0.09000000f,0.97000000f,0.21000000f,-0.24000000f,0.76000000f,-0.25000000f,0.81000000f,-0.44000000f,0.96000000f,-0.85000000f,0.48000000f,-0.86000000f,0.12000000f,0.94000000f,-0.09000000f,-0.69000000f,0.98000000f,0.26000000f,0.63000000f,0.65000000f,0.70000000f,0.95000000f,0.96000000f,0.49000000f,-0.25000000f,0.66000000f,-0.97000000f,-0.62000000f,0.85000000f,0.04000000f,0.16000000f,0.22000000f,0.71000000f,-0.52000000f,-0.55000000f,0.08000000f,-0.85000000f,-0.87000000f,0.73000000f,0.08000000f,0.94000000f,-0.34000000f,-0.82000000f,0.22000000f,-0.25000000f,-0.92000000f,-0.96000000f,0.94000000f,-0.47000000f,0.76000000f,-0.83000000f,0.22000000f,0.42000000f,-0.80000000f,-0.22000000f,-0.84000000f,-0.52000000f,0.15000000f,0.20000000f,0.96000000f,0.20000000f,0.63000000f,-0.32000000f,-0.76000000f,0.32000000f,-0.71000000f,-0.68000000f,0.55000000f,-0.45000000f,0.59000000f,-0.41000000f,-0.10000000f,-0.62000000f,0.56000000f,0.07000000f,-0.22000000f,-0.90000000f,0.39000000f,-0.53000000f,0.98000000f,-0.55000000f,-0.31000000f,-0.48000000f,0.22000000f,-0.78000000f,-0.57000000f,-0.88000000f,-0.97000000f,0.26000000f,-0.74000000f,0.20000000f,-0.82000000f,-0.34000000f,0.27000000f,0.96000000f,-0.14000000f,-0.60000000f,-0.20000000f,-0.34000000f,0.68000000f,-0.00000000f,0.57000000f,0.87000000f,-0.48000000f,0.10000000f,0.39000000f,-0.22000000f,0.97000000f,0.45000000f,-0.41000000f,0.85000000f,-0.18000000f,-0.22000000f,-0.40000000f,0.67000000f,-0.09000000f,-0.61000000f,-0.28000000f,0.71000000f,0.45000000f,-0.27000000f,-0.67000000f,0.50000000f,-0.10000000f,-0.09000000f,-0.75000000f,0.96000000f,0.86000000f,0.27000000f,-0.83000000f,-0.35000000f,-0.30000000f,0.37000000f,0.44000000f,0.78000000f,-0.50000000f,-0.53000000f,-0.40000000f,-0.43000000f,-0.04000000f,0.46000000f,-0.57000000f,-0.60000000f,-0.13000000f,0.90000000f,0.32000000f,0.92000000f,0.79000000f,0.48000000f,-0.76000000f,0.87000000f,0.11000000f,-0.17000000f,-0.50000000f,-0.00000000f,0.02000000f,0.61000000f,0.33000000f,0.64000000f,-0.80000000f,-0.48000000f,0.91000000f,0.81000000f,-0.73000000f,-0.02000000f,0.94000000f,-0.63000000f,0.19000000f,0.39000000f,-0.50000000f,-0.91000000f,-0.99000000f,0.95000000f,-0.75000000f,0.67000000f,0.82000000f,-0.54000000f,-0.76000000f,0.50000000f,0.90000000f,0.46000000f,-0.74000000f,0.69000000f,-0.86000000f,0.72000000f,0.52000000f,0.39000000f,-0.46000000f,-0.36000000f,0.34000000f,0.21000000f,-0.44000000f,0.14000000f,0.35000000f,0.13000000f,-0.84000000f,0.95000000f,0.32000000f,-0.82000000f,-0.62000000f,-0.69000000f,-0.50000000f,0.59000000f,0.47000000f,-0.97000000f,0.15000000f,0.59000000f,0.65000000f,-0.26000000f,0.50000000f,-0.03000000f,-0.96000000f,0.97000000f,-0.99000000f,-0.67000000f,-0.73000000f,-0.48000000f,-0.64000000f,-0.84000000f,-0.94000000f,0.62000000f,0.14000000f,-0.32000000f,-0.47000000f,-0.74000000f,0.07000000f,0.05000000f,0.87000000f,-0.83000000f,0.49000000f,-0.32000000f,-0.32000000f,0.03000000f,0.51000000f,0.06000000f,-0.77000000f,0.75000000f,-0.39000000f,-0.78000000f,0.10000000f,0.95000000f,0.38000000f,-0.08000000f,-0.66000000f,-0.07000000f,0.09000000f,-0.09000000f,-0.09000000f,0.83000000f,-0.12000000f,0.43000000f,-0.65000000f,0.41000000f,0.68000000f,0.93000000f,0.88000000f,-0.24000000f,0.70000000f,-0.97000000f,-0.40000000f,-0.96000000f,-0.45000000f,-0.35000000f,-0.29000000f,0.91000000f,-0.28000000f,0.92000000f,-0.57000000f,-0.37000000f,-0.02000000f,0.37000000f,-0.37000000f,-0.01000000f,-0.48000000f,0.74000000f,-0.28000000f,0.21000000f,0.74000000f,-0.99000000f,0.45000000f,0.91000000f,-0.28000000f,-0.11000000f,-0.86000000f,-0.22000000f,0.48000000f,-0.34000000f,0.52000000f,0.17000000f,0.04000000f,0.23000000f,-0.54000000f,-0.80000000f,-0.60000000f,0.04000000f,0.47000000f,-0.14000000f,0.33000000f,0.57000000f,0.22000000f,-0.67000000f,0.02000000f,0.69000000f,0.93000000f,0.69000000f,0.93000000f,0.99000000f,0.75000000f,0.47000000f,0.21000000f,-0.42000000f,0.02000000f,0.20000000f,0.03000000f,0.12000000f,0.76000000f,0.04000000f,-0.43000000f,-0.10000000f,-0.52000000f,-0.26000000f,-0.10000000f,0.78000000f,-0.81000000f,-0.72000000f,-0.76000000f,0.87000000f,0.88000000f,0.83000000f,-0.27000000f,0.82000000f,-0.97000000f,-0.59000000f,0.80000000f,0.66000000f,0.66000000f,0.59000000f,-0.73000000f,0.03000000f,-0.16000000f,0.69000000f,-0.52000000f,0.22000000f,0.82000000f,-0.11000000f,-0.25000000f,-0.39000000f,0.56000000f,0.93000000f,-0.43000000f,-0.73000000f,-0.28000000f,-0.06000000f,-0.49000000f,-0.95000000f,0.39000000f,0.51000000f,0.29000000f,0.40000000f,-0.46000000f,-0.11000000f,0.60000000f,0.03000000f,-0.57000000f,0.24000000f,-0.55000000f,0.88000000f,-0.33000000f,0.64000000f,-0.79000000f,0.59000000f,-0.05000000f,0.94000000f,0.00000000f,0.74000000f,0.44000000f,-0.86000000f,0.23000000f,-0.03000000f,-0.66000000f,0.45000000f,0.08000000f,-0.53000000f,0.09000000f,0.98000000f,-0.28000000f,-0.10000000f,0.89000000f,0.18000000f,0.45000000f,-0.98000000f,-0.89000000f,0.47000000f,0.78000000f,-0.11000000f,0.53000000f,-0.35000000f,0.46000000f,0.00000000f,0.49000000f,-0.13000000f,-0.58000000f,-0.56000000f,0.73000000f,0.21000000f,0.20000000f,0.72000000f,-0.71000000f,-0.68000000f,-0.54000000f,0.61000000f,-0.80000000f,0.53000000f,0.90000000f,0.20000000f,0.25000000f,-0.29000000f,0.91000000f,-0.88000000f,0.04000000f,0.98000000f,-0.18000000f,-0.16000000f,0.28000000f,0.28000000f,0.60000000f,0.35000000f,-0.32000000f,0.48000000f,-0.99000000f,-0.57000000f,0.41000000f,0.93000000f,-0.33000000f,-0.69000000f,0.68000000f,-0.99000000f,0.40000000f,-0.31000000f,0.58000000f,0.70000000f,-0.95000000f,-0.97000000f,0.59000000f,-0.71000000f,-0.43000000f,0.78000000f,-0.92000000f,-0.01000000f,0.79000000f,-0.34000000f,-0.14000000f,0.25000000f,0.86000000f,0.62000000f,-0.12000000f,-0.53000000f,0.77000000f,-0.30000000f,-0.50000000f,-0.82000000f,0.76000000f,0.27000000f,-0.59000000f,0.69000000f,-0.87000000f,-0.03000000f,0.82000000f,0.05000000f,0.58000000f,0.96000000f,0.52000000f,0.04000000f,0.80000000f,-0.66000000f,-0.06000000f,0.88000000f,-0.59000000f,-0.19000000f,-0.47000000f,0.84000000f,0.15000000f,0.90000000f,-0.08000000f,0.69000000f,-0.34000000f,0.12000000f,0.14000000f,0.86000000f,-0.56000000f,-0.59000000f,0.08000000f,0.27000000f,-0.13000000f,0.00000000f,-0.00000000f,-0.47000000f,0.34000000f,0.44000000f,0.17000000f,-0.57000000f,-0.19000000f,-0.09000000f,-0.31000000f,0.03000000f,-0.60000000f,0.40000000f,0.58000000f,-0.43000000f,-0.81000000f,0.08000000f,0.04000000f,-0.28000000f,0.74000000f,0.00000000f,-0.59000000f,-0.57000000f,-0.82000000f,0.99000000f,-0.36000000f,0.44000000f,-0.51000000f,0.26000000f,0.75000000f,-0.56000000f,-0.86000000f,0.85000000f,-0.63000000f,0.49000000f,0.81000000f,-0.53000000f,0.23000000f,-0.35000000f,-0.25000000f,-0.44000000f,-0.03000000f,0.23000000f,0.98000000f,-0.37000000f,-0.25000000f,-0.60000000f,0.81000000f,0.16000000f,0.95000000f,0.77000000f,-0.18000000f,0.45000000f,-0.35000000f,0.47000000f,0.74000000f,0.65000000f,0.81000000f,-0.02000000f,-0.39000000f,-0.75000000f,0.33000000f,0.35000000f,-0.76000000f,-0.12000000f,-0.62000000f,0.06000000f,0.47000000f,0.47000000f,-0.74000000f,0.58000000f,-0.68000000f,-0.77000000f,-0.12000000f,-0.41000000f,0.26000000f,0.39000000f,-0.37000000f,0.47000000f,0.81000000f,0.00000000f,0.80000000f,-0.59000000f,0.74000000f,-0.11000000f,-0.81000000f,-0.10000000f,-0.03000000f,0.88000000f,-0.65000000f,0.58000000f,-0.93000000f,-0.09000000f,-0.30000000f,0.72000000f,-0.75000000f,-0.10000000f,0.01000000f,0.21000000f,-0.17000000f,0.37000000f,-0.96000000f,-0.44000000f,-0.69000000f,0.36000000f,0.89000000f,0.24000000f,0.06000000f,0.20000000f,-0.51000000f,0.20000000f,-0.25000000f,0.64000000f,0.06000000f,-0.91000000f,0.19000000f,-0.71000000f,-0.09000000f,0.85000000f,0.49000000f,-0.39000000f,0.80000000f,0.42000000f,0.61000000f,-0.52000000f,0.61000000f,-0.13000000f,0.48000000f,0.67000000f,0.60000000f,0.93000000f,-0.02000000f,0.58000000f,0.01000000f,-0.17000000f,-0.50000000f,-0.67000000f,-0.74000000f,-0.12000000f,0.92000000f,-0.61000000f,-0.21000000f,0.30000000f,-0.70000000f,-0.56000000f,-0.91000000f,-0.65000000f,0.13000000f,-0.36000000f,-0.91000000f,0.93000000f,0.69000000f,-0.95000000f,0.67000000f,-0.46000000f,0.26000000f,0.59000000f,0.11000000f,0.64000000f,-0.83000000f,-0.00000000f,-0.85000000f,0.50000000f,0.25000000f,0.80000000f,-0.83000000f,-0.54000000f,-0.96000000f,0.68000000f,-0.39000000f,0.84000000f,0.80000000f,0.84000000f,0.86000000f,-0.60000000f,-0.73000000f,-0.90000000f,0.22000000f,0.52000000f,-0.70000000f,-0.70000000f,0.35000000f,0.57000000f,0.55000000f,-0.94000000f,0.51000000f,0.07000000f,-0.57000000f,-0.20000000f,0.16000000f,0.66000000f,0.71000000f,0.46000000f,-0.03000000f,0.11000000f,-0.61000000f,-0.84000000f,-0.57000000f,0.12000000f,-0.37000000f,-0.97000000f,-0.83000000f,0.47000000f,0.40000000f,0.54000000f,0.79000000f,0.95000000f,0.40000000f,0.23000000f,0.45000000f,0.66000000f,0.33000000f,0.61000000f,0.90000000f,-0.66000000f,-0.18000000f,0.95000000f,0.91000000f,-0.89000000f,-0.66000000f,0.37000000f,-0.80000000f,-0.36000000f,0.02000000f,0.23000000f,-0.57000000f,-0.19000000f,-0.11000000f,-0.01000000f,-0.47000000f,-0.67000000f,-0.64000000f,0.80000000f,-0.34000000f,-0.08000000f,-0.54000000f,0.96000000f,-0.41000000f,-0.43000000f,0.52000000f,0.30000000f,-0.02000000f,0.68000000f,-0.82000000f,-0.06000000f,-0.24000000f,0.53000000f,-0.12000000f,-0.64000000f,-0.57000000f,-0.93000000f,0.17000000f,-0.62000000f,-0.57000000f,-0.18000000f,0.44000000f,-0.93000000f,0.27000000f,0.47000000f,0.02000000f,-0.66000000f,0.84000000f,-0.56000000f,-0.86000000f,-0.30000000f,0.45000000f,-0.87000000f,-0.18000000f,-0.78000000f,-0.58000000f,-0.87000000f,-0.01000000f,-0.39000000f,-0.82000000f,-0.88000000f,0.73000000f,-0.96000000f,-0.08000000f,-0.83000000f,-0.78000000f,-0.40000000f,0.55000000f,-0.96000000f,-0.72000000f,-0.48000000f,-0.58000000f,0.56000000f,0.17000000f,0.51000000f,0.81000000f,-0.72000000f,-0.46000000f,0.98000000f,0.59000000f,-0.78000000f,-0.00000000f,-0.97000000f,0.94000000f,0.53000000f,0.29000000f,0.90000000f,0.85000000f,-0.83000000f,-0.66000000f,-0.22000000f,-0.23000000f,0.41000000f,-0.13000000f,-0.10000000f,0.66000000f,-0.18000000f,0.83000000f,-0.50000000f,-0.14000000f,-0.22000000f,0.75000000f,-0.81000000f,0.56000000f,-0.60000000f,-0.11000000f,-0.24000000f,-0.37000000f,-0.44000000f,0.27000000f,-0.84000000f,0.21000000f,-0.47000000f,0.87000000f,0.91000000f,-0.95000000f,-0.09000000f,0.97000000f,0.08000000f,-0.49000000f,-0.27000000f,0.22000000f,0.50000000f,-0.54000000f,0.41000000f,0.84000000f,0.25000000f,0.24000000f,0.12000000f,0.76000000f,-0.50000000f,0.78000000f,-0.35000000f,0.66000000f,-0.78000000f,0.10000000f,0.81000000f,0.32000000f,-0.41000000f,-0.20000000f,-0.99000000f,0.80000000f,-0.91000000f,-0.80000000f,0.53000000f,0.83000000f,-0.43000000f,-0.12000000f,0.26000000f,-0.28000000f,0.33000000f,-0.88000000f,0.39000000f,0.15000000f,-0.11000000f,-0.35000000f,0.46000000f,-0.47000000f,-0.30000000f,0.42000000f,-0.33000000f,0.95000000f,0.59000000f,-0.43000000f,-0.12000000f,0.57000000f,-0.57000000f,-0.47000000f,0.60000000f,0.34000000f,0.80000000f,0.80000000f,-0.64000000f,-0.72000000f,0.01000000f,0.49000000f,-0.03000000f,0.09000000f,0.38000000f,-0.65000000f,-0.22000000f,0.61000000f,-0.82000000f,0.42000000f,-0.33000000f,0.91000000f,0.55000000f,0.45000000f,0.85000000f,-0.06000000f,-0.58000000f,0.64000000f,0.12000000f,-0.57000000f,0.68000000f,0.24000000f,-0.88000000f,-0.67000000f,-0.65000000f,-0.22000000f,-0.11000000f,-0.83000000f,-0.82000000f,0.76000000f,0.33000000f,-0.14000000f,0.97000000f,-0.18000000f,-0.04000000f,0.97000000f,0.00000000f,0.08000000f,0.15000000f,0.52000000f,-0.19000000f,-0.46000000f,-0.50000000f,-0.59000000f,0.69000000f,0.06000000f,-0.14000000f,0.27000000f,-0.75000000f,0.27000000f,-0.14000000f,0.15000000f,-0.57000000f,-0.42000000f,-0.18000000f,0.43000000f,0.44000000f,-0.65000000f,-0.87000000f,-0.49000000f,-0.37000000f,0.82000000f,-0.72000000f,0.01000000f,-0.88000000f,0.14000000f,-0.92000000f,-0.50000000f,0.83000000f,-0.14000000f,-0.16000000f,-0.50000000f,-0.05000000f,-0.63000000f,-0.90000000f,0.83000000f,0.74000000f,0.00000000f,0.44000000f,-0.66000000f,0.93000000f,0.27000000f,-0.28000000f,0.18000000f,-0.80000000f,-0.54000000f,-0.08000000f,0.22000000f,0.43000000f,0.16000000f,-0.25000000f,-0.14000000f,0.25000000f,0.55000000f,-0.85000000f,0.72000000f,0.33000000f,0.12000000f,-0.65000000f,-0.17000000f,0.26000000f,-0.40000000f,0.78000000f,-0.50000000f,0.07000000f,-0.98000000f,-0.60000000f,-0.38000000f,0.95000000f,0.75000000f,-0.10000000f,-0.30000000f,0.57000000f,-0.67000000f,0.12000000f,0.46000000f,-0.23000000f,-0.93000000f,-0.34000000f,-0.63000000f,0.42000000f,0.20000000f,0.25000000f,-0.83000000f,0.09000000f,-0.35000000f,-0.70000000f,0.73000000f,-0.71000000f,-0.65000000f,0.53000000f,0.93000000f,-0.30000000f,0.42000000f,0.10000000f,0.73000000f,-0.96000000f,-0.08000000f,0.64000000f,0.66000000f,-0.20000000f,0.62000000f,-0.90000000f,-0.63000000f,-0.55000000f,0.72000000f,0.64000000f,-0.42000000f,-0.01000000f,-0.62000000f,-0.82000000f,0.68000000f,-0.86000000f,0.48000000f,-0.04000000f,-0.02000000f,-0.91000000f,-0.99000000f,-0.33000000f,-0.46000000f,-0.06000000f,-0.92000000f,-0.23000000f,0.15000000f,0.26000000f,0.37000000f,0.23000000f,0.08000000f,0.47000000f,-0.78000000f,0.86000000f,0.52000000f,-0.27000000f,-0.01000000f,-0.54000000f,-0.42000000f,-0.25000000f,-0.20000000f,-0.13000000f,0.64000000f,0.32000000f,0.45000000f,0.34000000f,-0.13000000f,0.99000000f,0.45000000f,0.81000000f,-0.63000000f,-0.27000000f,-0.59000000f,-0.29000000f,-0.44000000f,0.89000000f,-0.01000000f,-0.17000000f,0.79000000f,0.08000000f,0.59000000f,-0.01000000f,-0.26000000f,0.10000000f,0.27000000f,0.28000000f,-0.12000000f,-0.73000000f,0.19000000f,0.16000000f,-0.12000000f,0.49000000f,0.43000000f,0.74000000f,0.56000000f,0.90000000f,0.28000000f,-0.46000000f,-0.62000000f,0.47000000f,-0.35000000f,-0.36000000f,-0.99000000f,0.89000000f,-0.64000000f,-0.33000000f,-0.43000000f,0.97000000f,-0.34000000f,0.37000000f,-0.16000000f,-0.39000000f,0.18000000f,-0.95000000f,-0.41000000f,0.41000000f,-0.21000000f,-0.82000000f,-0.93000000f,-0.90000000f,0.53000000f,0.25000000f,0.29000000f,-0.84000000f,-0.39000000f,-0.72000000f,-0.21000000f,-0.78000000f,-0.97000000f,-0.92000000f,-0.34000000f,0.81000000f,-0.08000000f,0.34000000f,0.26000000f,-0.74000000f,-0.26000000f,-0.20000000f,0.71000000f,0.67000000f,-0.08000000f,0.35000000f,-0.63000000f,-0.11000000f,-0.50000000f,-0.71000000f,-0.26000000f,-0.46000000f,0.01000000f,-0.24000000f,0.73000000f,-0.22000000f,-0.85000000f,-0.68000000f,-0.21000000f,-0.56000000f,0.16000000f,-0.04000000f,-0.77000000f,0.24000000f,-0.66000000f,0.77000000f,0.25000000f,-0.27000000f,-0.24000000f,-0.36000000f,0.89000000f,-0.65000000f,0.62000000f,0.00000000f,-0.74000000f,0.22000000f,0.82000000f,0.72000000f,0.58000000f,-0.44000000f,0.72000000f,-0.55000000f,-0.20000000f,0.11000000f,-0.62000000f,0.48000000f,-0.24000000f,-0.02000000f,-0.81000000f,0.69000000f,-0.58000000f,0.26000000f,-0.64000000f,-0.48000000f,0.79000000f,0.38000000f,0.68000000f,0.70000000f,-0.19000000f,0.79000000f,0.89000000f,-0.57000000f,-0.24000000f,-0.57000000f,-0.20000000f,-0.80000000f,0.54000000f,-0.12000000f,-0.94000000f,-0.04000000f,0.40000000f,-0.16000000f,-0.99000000f,0.12000000f,0.73000000f,-0.02000000f,0.63000000f,-0.76000000f,-0.40000000f,-0.82000000f,0.60000000f,0.48000000f,0.26000000f,-0.77000000f,-0.68000000f,0.10000000f,-0.81000000f,0.90000000f,0.97000000f,0.10000000f,-0.12000000f,-0.07000000f,-0.64000000f,0.36000000f,-0.37000000f,0.25000000f,-0.38000000f,-0.65000000f,-0.30000000f,-0.71000000f,0.35000000f,0.69000000f,0.29000000f,-0.60000000f,0.66000000f,0.53000000f,0.69000000f,-0.27000000f,0.04000000f,-0.38000000f,-0.47000000f,-0.00000000f,-0.30000000f,0.71000000f,0.44000000f,-0.50000000f,0.52000000f,0.75000000f,0.18000000f,-0.47000000f,-0.15000000f,0.46000000f,-0.42000000f,0.32000000f,-0.97000000f,0.16000000f,0.67000000f,-0.13000000f,-0.59000000f,0.49000000f,-0.02000000f,-0.91000000f,-0.05000000f,-0.89000000f,0.68000000f,-0.21000000f,0.57000000f,-0.17000000f,0.37000000f,-0.36000000f,-0.44000000f,0.40000000f,0.31000000f,-0.51000000f,-0.56000000f,0.09000000f,0.80000000f,-0.61000000f,-0.36000000f,-0.66000000f,0.29000000f,-0.00000000f,-0.72000000f,0.14000000f,-0.95000000f,-0.18000000f,-0.43000000f,-0.25000000f,0.28000000f,-0.64000000f,-0.37000000f,-0.29000000f,0.15000000f,0.48000000f,0.29000000f,-0.86000000f,0.43000000f,0.85000000f,0.56000000f,-0.66000000f,-0.93000000f,-0.00000000f,0.06000000f,0.00000000f,-0.73000000f,-0.29000000f,-0.29000000f,0.59000000f,-0.60000000f,-0.24000000f,-0.88000000f,0.99000000f,0.39000000f,0.71000000f,-0.58000000f,-0.46000000f,-0.86000000f,-0.65000000f,-0.17000000f,0.28000000f,0.85000000f,0.74000000f,0.32000000f,-0.14000000f,0.59000000f,0.37000000f,-0.94000000f,0.28000000f,-0.50000000f,-0.88000000f,0.36000000f,-0.21000000f,-0.22000000f,0.55000000f,-0.49000000f,-0.22000000f,0.33000000f,0.34000000f,0.59000000f,-0.94000000f,0.82000000f,-0.06000000f,0.82000000f,0.71000000f,0.03000000f,-0.11000000f,-0.02000000f,0.85000000f,-0.25000000f,0.86000000f,-0.30000000f,-0.99000000f,0.27000000f,0.17000000f,0.78000000f,0.24000000f,-0.85000000f,0.97000000f,0.35000000f,0.44000000f,-0.86000000f,0.22000000f,0.69000000f,0.89000000f,-0.11000000f,0.94000000f,-0.97000000f,-0.73000000f,-0.46000000f,-0.85000000f,0.33000000f,-0.01000000f,-0.37000000f,0.23000000f,-0.67000000f,0.02000000f,-0.89000000f,0.99000000f,-0.46000000f,0.40000000f,-0.60000000f,-0.35000000f,-0.13000000f,-0.38000000f,-0.18000000f,-0.50000000f,-0.52000000f,0.06000000f,0.01000000f,0.68000000f,0.69000000f,0.17000000f,-0.36000000f,0.68000000f,-0.01000000f,0.22000000f,0.96000000f,0.58000000f,-0.28000000f,0.10000000f,-0.49000000f,-0.21000000f,-0.74000000f,0.06000000f,-0.03000000f,0.36000000f,0.47000000f,-0.94000000f,-0.13000000f,0.66000000f,-0.03000000f,0.81000000f,-0.10000000f,-0.34000000f,-0.74000000f,-0.02000000f,0.36000000f,0.13000000f,-0.09000000f,-0.23000000f,-0.15000000f,-0.84000000f,0.61000000f,0.63000000f,-0.06000000f,-0.59000000f,0.49000000f,-0.83000000f,0.43000000f,-0.51000000f,-0.26000000f,-0.49000000f,0.79000000f,0.92000000f,0.69000000f,-0.51000000f,0.43000000f,0.57000000f,0.59000000f,0.62000000f,0.04000000f,-0.66000000f,0.12000000f,-0.61000000f,0.15000000f,-0.29000000f,-0.66000000f,-0.05000000f,0.27000000f,0.83000000f,0.62000000f,-0.89000000f,0.37000000f,0.08000000f,-0.41000000f,0.60000000f,0.57000000f,0.27000000f,-0.08000000f,0.62000000f,-0.75000000f,0.71000000f,-0.56000000f,-0.08000000f,0.98000000f,0.63000000f,-0.46000000f,-0.76000000f,0.75000000f,-0.99000000f,-0.80000000f,-0.58000000f,-0.16000000f,-0.55000000f,0.09000000f,0.42000000f,-0.11000000f,0.18000000f,-0.87000000f,-0.89000000f,0.04000000f,0.24000000f,-0.86000000f,-0.20000000f,0.09000000f,-0.76000000f,0.77000000f,-0.39000000f,0.60000000f,-0.61000000f,-0.04000000f,0.16000000f,0.57000000f,-0.39000000f,-0.75000000f,-0.99000000f,-0.77000000f,0.91000000f,0.58000000f,-0.29000000f,0.48000000f,0.22000000f,0.73000000f,-0.29000000f,-0.28000000f,0.93000000f,-0.78000000f,-0.19000000f,0.27000000f,-0.76000000f,-0.93000000f,-0.95000000f,-0.98000000f,0.74000000f,0.50000000f,0.09000000f,-0.76000000f,-0.31000000f,-0.95000000f,0.18000000f,0.95000000f,-0.90000000f,-0.87000000f,0.87000000f,0.39000000f,0.91000000f,0.91000000f,0.43000000f,0.21000000f,-0.33000000f,-0.82000000f,-0.85000000f,0.79000000f,0.25000000f,0.62000000f,0.44000000f,-0.19000000f,0.80000000f,0.77000000f,-0.08000000f,0.74000000f,-0.25000000f,0.90000000f,0.93000000f,0.55000000f,-0.46000000f,-0.63000000f,0.73000000f,0.51000000f,0.31000000f,-0.30000000f,-0.46000000f,-0.26000000f,0.82000000f,-0.44000000f,-0.96000000f,-0.05000000f,0.25000000f,0.67000000f,0.37000000f,-0.96000000f,-0.70000000f,-0.50000000f,-0.33000000f,-0.30000000f,0.19000000f,0.45000000f,0.96000000f,0.18000000f,-0.44000000f,0.10000000f,-0.29000000f,-0.83000000f,0.18000000f,0.14000000f,0.91000000f,-0.76000000f,0.33000000f,-0.75000000f,-0.06000000f,0.35000000f,0.35000000f,-0.22000000f,-0.42000000f,-0.34000000f,0.60000000f,-0.56000000f,0.95000000f,-0.35000000f,-0.13000000f,-0.58000000f,-0.84000000f,0.89000000f,-0.67000000f,-0.84000000f,0.78000000f,-0.29000000f,0.83000000f,-0.03000000f,0.74000000f,-0.98000000f,0.54000000f,-0.33000000f,0.40000000f,0.79000000f,0.78000000f,0.47000000f,-0.60000000f,0.66000000f,0.69000000f,-0.25000000f,-0.38000000f,0.90000000f,0.91000000f,-0.22000000f,0.55000000f,-0.30000000f,-0.48000000f,-0.16000000f,-0.09000000f,-0.23000000f,-0.68000000f,-0.62000000f,0.49000000f,0.34000000f,0.18000000f,0.88000000f,0.08000000f,0.95000000f,-0.59000000f,0.40000000f,0.52000000f,0.19000000f,0.94000000f,0.36000000f,0.96000000f,-0.31000000f,0.71000000f,-0.19000000f,0.67000000f,0.87000000f,-0.39000000f,-0.55000000f,-0.01000000f,-0.14000000f,0.28000000f,-0.75000000f,0.70000000f,-0.17000000f,0.18000000f,0.64000000f,0.50000000f,-0.83000000f,0.85000000f,0.85000000f,0.38000000f,0.04000000f,-0.46000000f,0.41000000f,-0.21000000f,-0.78000000f,0.32000000f,0.46000000f,0.95000000f,-0.16000000f,-0.31000000f,-0.24000000f,0.06000000f,-0.25000000f,-0.94000000f,0.99000000f,0.75000000f,-0.00000000f,-0.42000000f,-0.72000000f,0.61000000f,-0.06000000f,0.78000000f,0.92000000f,0.25000000f,0.90000000f,-0.37000000f,0.72000000f,0.21000000f,-0.72000000f,0.36000000f,0.76000000f,-0.53000000f,-0.36000000f,0.45000000f,-0.28000000f,-0.47000000f,-0.46000000f,0.47000000f,-0.30000000f,0.30000000f,-0.72000000f,0.73000000f,-0.61000000f,-0.39000000f,0.06000000f,0.35000000f,0.77000000f,-0.38000000f,0.52000000f,-0.03000000f,-0.85000000f,-0.20000000f,0.02000000f,0.64000000f,-0.72000000f,0.10000000f,0.11000000f,0.81000000f,-0.07000000f,0.72000000f,0.87000000f,0.81000000f,-0.21000000f,-0.03000000f,-0.86000000f,-0.18000000f,0.01000000f,-0.77000000f,-0.60000000f,0.16000000f,0.32000000f,-0.46000000f,0.00000000f,-0.00000000f,-0.77000000f,-0.04000000f,0.92000000f,0.48000000f,-0.84000000f,-0.65000000f,-0.93000000f,-0.77000000f,-0.11000000f,0.77000000f,0.86000000f,0.96000000f,0.31000000f,-0.18000000f,-0.94000000f,0.66000000f,-0.97000000f,0.51000000f,0.39000000f,-0.66000000f,-0.74000000f,0.82000000f,0.91000000f,0.90000000f,-0.22000000f,-0.89000000f,0.72000000f,0.98000000f,-0.14000000f,0.73000000f,0.68000000f,0.68000000f,-0.20000000f,0.44000000f,-0.76000000f,0.40000000f,-0.93000000f,-0.43000000f,-0.89000000f,-0.74000000f,-0.18000000f,-0.79000000f,-0.69000000f,0.32000000f,0.73000000f,-0.85000000f,-0.06000000f,0.72000000f,-0.25000000f,0.37000000f,0.76000000f,-0.20000000f,-0.70000000f,0.27000000f,-0.94000000f,0.75000000f,-0.29000000f,-0.25000000f,-0.82000000f,0.38000000f,0.50000000f,0.56000000f,0.62000000f,-0.41000000f,-0.10000000f,-0.38000000f,0.76000000f,-0.42000000f,0.89000000f,0.16000000f,-0.83000000f,-0.05000000f,-0.08000000f,-0.41000000f,0.55000000f,0.01000000f,0.93000000f,-0.79000000f,-0.46000000f,0.63000000f,-0.93000000f,-0.26000000f,0.51000000f,0.57000000f,-0.76000000f,-0.94000000f,0.21000000f,-0.83000000f,0.51000000f,-0.38000000f,-0.00000000f,-0.35000000f,-0.94000000f,0.32000000f,-0.70000000f,-0.05000000f,-0.73000000f,0.19000000f,-0.52000000f,0.32000000f,-0.48000000f,0.99000000f,0.18000000f,0.36000000f,-0.73000000f,0.48000000f,0.74000000f,0.53000000f,0.41000000f,0.85000000f,-0.42000000f,0.46000000f,0.18000000f,0.66000000f,0.99000000f,-0.55000000f,-0.02000000f,0.54000000f,-0.89000000f,-0.78000000f,0.68000000f,0.34000000f,0.90000000f,-0.34000000f,0.55000000f,-0.50000000f,-0.80000000f,-0.26000000f,-0.91000000f,-0.72000000f,0.75000000f,0.23000000f,0.87000000f,0.15000000f,0.77000000f,-0.64000000f,-0.78000000f,0.03000000f,-0.29000000f,-0.31000000f,0.02000000f,-0.16000000f,0.01000000f,0.50000000f,-0.35000000f,-0.65000000f,0.22000000f,0.53000000f,-0.25000000f,-0.31000000f,0.61000000f,0.59000000f,-0.83000000f,-0.30000000f,-0.53000000f,-0.76000000f,-0.28000000f,0.71000000f,0.52000000f,-0.77000000f,0.86000000f,-0.01000000f,0.92000000f,0.90000000f,0.20000000f,0.20000000f,0.49000000f,0.38000000f,-0.95000000f,0.59000000f,-0.25000000f,0.42000000f,-0.33000000f,0.29000000f,0.17000000f,-0.17000000f,0.78000000f,-0.75000000f,0.99000000f,-0.43000000f,-0.33000000f,-0.61000000f,0.41000000f,-0.22000000f,-0.25000000f,-0.16000000f,-0.74000000f,-0.06000000f,0.24000000f,0.60000000f,-0.96000000f,0.06000000f,-0.13000000f,-0.27000000f,-0.04000000f,-0.04000000f,0.45000000f,0.25000000f,0.83000000f,-0.31000000f,0.27000000f,-0.06000000f,-0.40000000f,0.68000000f,-0.52000000f,0.92000000f,-0.71000000f,-0.78000000f,0.93000000f,-0.84000000f,-0.51000000f,-0.30000000f,-0.15000000f,0.02000000f,-0.59000000f,-0.64000000f,0.06000000f,-0.18000000f,-0.55000000f,-0.96000000f,0.12000000f,-0.89000000f,0.97000000f,0.91000000f,-0.73000000f,0.06000000f,0.57000000f,-0.82000000f,0.59000000f,-0.86000000f,0.08000000f,0.45000000f,-0.95000000f,0.67000000f,-0.65000000f,-0.29000000f,-0.36000000f,0.04000000f,-0.82000000f,0.10000000f,0.55000000f,0.32000000f,0.55000000f,0.32000000f,0.81000000f,-0.92000000f,0.09000000f,-0.35000000f,0.88000000f,0.31000000f,0.06000000f,0.89000000f,0.00000000f,0.37000000f,-0.45000000f,0.58000000f,0.97000000f,0.95000000f,0.34000000f,-0.41000000f,-0.84000000f,0.45000000f,-0.81000000f,0.73000000f,-0.11000000f,0.06000000f,-0.68000000f,-0.92000000f,0.59000000f,0.80000000f,0.60000000f,-0.04000000f,-0.18000000f,0.44000000f,-0.83000000f,0.71000000f,0.68000000f,0.02000000f,0.62000000f,0.83000000f,0.60000000f,0.81000000f,-0.92000000f,0.86000000f,-0.57000000f,0.26000000f,0.30000000f,-0.26000000f,0.29000000f,-0.74000000f,-0.21000000f,0.65000000f,0.40000000f,0.43000000f,-0.95000000f,0.36000000f,-0.28000000f,0.12000000f,-0.89000000f,-0.23000000f,0.86000000f,-0.11000000f,0.70000000f,0.52000000f,-0.22000000f,-0.83000000f,-0.63000000f,0.08000000f,0.58000000f,-0.88000000f,-0.34000000f,-0.06000000f,0.44000000f,0.10000000f,0.36000000f,0.99000000f,0.04000000f,0.41000000f,-0.73000000f,0.41000000f,0.57000000f,-0.41000000f,0.35000000f,0.36000000f,-0.37000000f,0.64000000f,-0.70000000f,-0.33000000f,-0.57000000f,-0.38000000f,0.09000000f,0.50000000f,-0.09000000f,-0.95000000f,0.59000000f,0.07000000f,0.25000000f,0.75000000f,-0.29000000f,-0.46000000f,-0.69000000f,-0.93000000f,-0.49000000f,-0.03000000f,-0.25000000f,0.65000000f,-0.15000000f,0.79000000f,0.76000000f,-0.73000000f,0.57000000f,-0.90000000f,0.74000000f,0.99000000f,0.20000000f,0.09000000f,0.33000000f,-0.55000000f,0.42000000f,-0.98000000f,-0.26000000f,-0.48000000f,0.96000000f,0.83000000f,-0.75000000f,-0.64000000f,-0.09000000f,-0.73000000f,0.96000000f,-0.26000000f,-0.76000000f,0.83000000f,0.54000000f,0.66000000f,0.54000000f,0.64000000f,-0.58000000f,0.45000000f,-0.67000000f,0.81000000f,0.00000000f,-0.77000000f,0.66000000f,0.36000000f,0.93000000f,0.75000000f,-0.62000000f,0.65000000f,-0.52000000f,0.08000000f,0.02000000f,0.12000000f,0.35000000f,0.85000000f,0.83000000f,-0.07000000f,-0.62000000f,-0.78000000f,-0.98000000f,-0.78000000f,0.43000000f,0.53000000f,-0.55000000f,0.04000000f,0.99000000f,-0.57000000f,-0.52000000f,0.78000000f,0.11000000f,-0.00000000f,0.88000000f,0.10000000f,-0.43000000f,-0.44000000f,-0.51000000f,0.73000000f,-0.74000000f,0.53000000f,-0.26000000f,-0.58000000f,0.07000000f,-0.48000000f,0.23000000f,0.94000000f,-0.47000000f,-0.53000000f,0.04000000f,0.18000000f,-0.16000000f,-0.86000000f,-0.90000000f,-0.04000000f,0.05000000f,0.03000000f,0.53000000f,-0.11000000f,-0.86000000f,0.80000000f,0.34000000f,0.61000000f,-0.00000000f,-0.99000000f,0.55000000f,-0.20000000f,-0.84000000f,0.21000000f,-0.66000000f,-0.43000000f,-0.93000000f,-0.83000000f,0.00000000f,-0.62000000f,-0.59000000f,-0.16000000f,-0.56000000f,-0.11000000f,0.55000000f,-0.30000000f,0.96000000f,-0.67000000f,0.05000000f,0.17000000f,0.30000000f,-0.86000000f,-0.44000000f,0.05000000f,0.75000000f,-0.44000000f,-0.03000000f,-0.61000000f,-0.89000000f,0.40000000f,0.35000000f,-0.42000000f,0.35000000f,-0.97000000f,0.58000000f,0.32000000f,0.84000000f,-0.13000000f,0.01000000f,0.89000000f,0.60000000f,0.06000000f,0.80000000f,0.67000000f,-0.54000000f,0.59000000f,-0.52000000f,0.06000000f,0.86000000f,0.19000000f,0.04000000f,0.75000000f,0.86000000f,0.11000000f,0.00000000f,-0.72000000f,-0.85000000f,0.09000000f,0.78000000f,-0.68000000f,0.90000000f,0.06000000f,0.38000000f,-0.14000000f,0.97000000f,0.07000000f,-0.60000000f,0.60000000f,-0.78000000f,-0.38000000f,0.01000000f,-0.99000000f,0.61000000f,0.53000000f,-0.65000000f,0.16000000f,0.32000000f,0.61000000f,-0.94000000f,0.88000000f,0.75000000f,-0.05000000f,-0.24000000f,-0.84000000f,-0.49000000f,0.89000000f,0.39000000f,0.22000000f,0.20000000f,-0.29000000f,0.74000000f,-0.01000000f,0.08000000f,-0.24000000f,-0.80000000f,0.57000000f,-0.16000000f,0.00000000f,-0.48000000f,0.68000000f,-0.06000000f,0.78000000f,-0.66000000f,-0.91000000f,0.30000000f,-0.72000000f,-0.20000000f,0.28000000f,-0.94000000f,-0.44000000f,-0.29000000f,0.27000000f,-0.84000000f,0.86000000f,-0.47000000f,-0.62000000f,0.29000000f,-0.59000000f,0.71000000f,-0.10000000f,-0.47000000f,-0.40000000f,-0.62000000f,-0.45000000f,0.01000000f,-0.88000000f,-0.47000000f,-0.11000000f,-0.27000000f,0.33000000f,-0.12000000f,0.68000000f,-0.96000000f,0.30000000f,-0.73000000f,0.13000000f,0.70000000f,0.78000000f,0.18000000f,0.35000000f,-0.82000000f,-0.65000000f,-0.72000000f,0.44000000f,-0.03000000f,0.12000000f,-0.68000000f,-0.68000000f,0.48000000f,0.89000000f,-0.32000000f,0.84000000f,0.32000000f,0.14000000f,-0.68000000f,0.44000000f,0.17000000f,0.56000000f,-0.76000000f,0.24000000f,-0.88000000f,0.04000000f,-0.46000000f,-0.34000000f,0.28000000f,-0.31000000f,-0.97000000f,-0.21000000f,-0.78000000f,-0.84000000f,-0.22000000f,-0.73000000f,0.07000000f,-0.56000000f,0.01000000f,-0.75000000f,-0.19000000f,-0.41000000f,0.78000000f,-0.23000000f,0.93000000f,0.91000000f,0.96000000f,-0.41000000f,-0.27000000f,-0.20000000f,-0.59000000f,0.25000000f,0.38000000f,-0.63000000f,0.24000000f,0.62000000f,0.44000000f,0.71000000f,-0.55000000f,0.61000000f,0.50000000f,-0.56000000f,0.77000000f,0.44000000f,0.25000000f,-0.17000000f,-0.32000000f,0.83000000f,-0.33000000f,0.16000000f,0.90000000f,-0.58000000f,-0.63000000f,0.28000000f,-0.65000000f,0.02000000f,0.60000000f,0.67000000f,0.30000000f,0.09000000f,-0.48000000f,0.54000000f,-0.07000000f,0.32000000f,-0.51000000f,-0.83000000f,0.67000000f,0.86000000f,0.48000000f,-0.14000000f,-0.03000000f,-0.49000000f,0.17000000f,-0.59000000f,-0.21000000f,-0.26000000f,-0.93000000f,0.80000000f,-0.35000000f,0.52000000f,-0.40000000f,-0.89000000f,-0.77000000f,-0.53000000f,0.56000000f,-0.58000000f,0.45000000f,0.54000000f,0.81000000f,0.05000000f,0.54000000f,0.11000000f,0.78000000f,0.53000000f,0.88000000f,0.13000000f,-0.95000000f,-0.23000000f,-0.40000000f,0.29000000f,-0.37000000f,-0.57000000f,0.39000000f,0.24000000f,0.14000000f,0.86000000f,0.36000000f,-0.72000000f,0.12000000f,-0.54000000f,0.60000000f,0.22000000f,0.32000000f,-0.02000000f,0.69000000f,-0.43000000f,-0.64000000f,0.92000000f,0.37000000f,0.07000000f,0.16000000f,0.05000000f,0.11000000f,0.19000000f,0.21000000f,-0.60000000f,-0.02000000f,0.43000000f,0.84000000f,-0.97000000f,-0.12000000f,-0.06000000f,-0.11000000f,-0.35000000f,0.77000000f,-0.12000000f,-0.44000000f,-0.02000000f,-0.09000000f,0.34000000f,0.37000000f,0.17000000f,-0.63000000f,0.07000000f,0.74000000f,0.57000000f,-0.97000000f,0.57000000f,0.22000000f,0.47000000f,-0.92000000f,-0.97000000f,-0.01000000f,0.47000000f,0.08000000f,-0.31000000f,0.74000000f,0.79000000f,-0.68000000f,-0.89000000f,-0.10000000f,-0.80000000f,-0.91000000f,0.06000000f,-0.40000000f,0.76000000f,0.27000000f,0.79000000f,0.96000000f,-0.95000000f,0.62000000f,-0.09000000f,0.41000000f,0.03000000f,-0.03000000f,-0.85000000f,-0.51000000f,0.92000000f,-0.67000000f,0.44000000f,0.20000000f,-0.29000000f,-0.01000000f,0.48000000f,0.76000000f,-0.74000000f,-0.95000000f,-0.62000000f,-0.46000000f,0.55000000f,0.61000000f,-0.51000000f,0.26000000f,0.53000000f,-0.99000000f,0.28000000f,0.53000000f,-0.41000000f,-0.92000000f,0.38000000f,-0.53000000f,-0.14000000f,0.87000000f,0.80000000f,0.07000000f,-0.76000000f,0.25000000f,-0.75000000f,-0.83000000f,-0.83000000f,-0.01000000f,-0.08000000f,0.92000000f,-0.33000000f,0.67000000f,0.08000000f,-0.11000000f,0.35000000f,-0.17000000f,0.70000000f,0.23000000f,-0.64000000f,-0.91000000f,0.56000000f,0.82000000f,0.42000000f,-0.48000000f,0.54000000f,-0.04000000f,0.00000000f,0.05000000f,0.00000000f,-0.11000000f,0.02000000f,-0.26000000f,0.46000000f,0.04000000f,0.84000000f,-0.54000000f,-0.33000000f,-0.55000000f,-0.00000000f,-0.90000000f,0.73000000f,-0.19000000f,-0.35000000f,-0.40000000f,-0.09000000f,-0.15000000f,0.92000000f,-0.20000000f,-0.95000000f,-0.85000000f,0.92000000f,0.10000000f,0.61000000f,0.02000000f,-0.01000000f,0.54000000f,0.07000000f,0.85000000f,0.50000000f,-0.84000000f,0.14000000f,-0.38000000f,0.40000000f,0.22000000f,-0.49000000f,0.11000000f,-0.49000000f,-0.23000000f,-0.39000000f,-0.25000000f,-0.31000000f,0.65000000f,-0.52000000f,-0.38000000f,0.46000000f,-0.73000000f,0.91000000f,-0.71000000f,0.77000000f,0.65000000f,-0.05000000f,0.31000000f,-0.60000000f,0.08000000f,-0.26000000f,0.25000000f,0.38000000f,-0.68000000f,0.55000000f,0.83000000f,-0.63000000f,-0.75000000f,-0.55000000f,0.08000000f,-0.42000000f,0.35000000f,-0.33000000f,-0.45000000f,0.00000000f,0.67000000f,0.78000000f,-0.59000000f,0.55000000f,-0.90000000f,-0.47000000f,0.91000000f,0.00000000f,-0.15000000f,0.34000000f,0.75000000f,-0.92000000f,0.15000000f,0.21000000f,0.14000000f,-0.14000000f,0.22000000f,-0.19000000f,0.42000000f,0.31000000f,0.75000000f,-0.66000000f,-0.24000000f,0.37000000f,0.40000000f,0.25000000f,-0.15000000f,0.47000000f,0.03000000f,0.14000000f,-0.32000000f,0.56000000f,-0.58000000f,0.88000000f,-0.67000000f,0.96000000f,0.14000000f,-0.78000000f,0.98000000f,-0.77000000f,-0.52000000f,-0.27000000f,0.94000000f,0.55000000f,0.03000000f,0.90000000f,-0.56000000f,-0.43000000f,-0.58000000f,-0.27000000f,-0.79000000f,-0.87000000f,-0.71000000f,-0.22000000f,-0.48000000f,-0.38000000f,-0.96000000f,0.58000000f,0.24000000f,-0.28000000f,-0.47000000f,0.33000000f,0.10000000f,-0.44000000f,-0.94000000f,0.29000000f,-0.16000000f,0.43000000f,-0.79000000f,0.81000000f,-0.89000000f,-0.63000000f,-0.76000000f,-0.15000000f,-0.71000000f,-0.77000000f,0.13000000f,0.67000000f,-0.15000000f,0.86000000f,0.12000000f,-0.37000000f,0.42000000f,-0.82000000f,-0.64000000f,0.42000000f,0.21000000f,-0.37000000f,-0.88000000f,0.14000000f,-0.80000000f,0.22000000f,0.52000000f,-0.84000000f,-0.39000000f,0.89000000f,0.23000000f,-0.21000000f,-0.62000000f,0.49000000f,0.35000000f,-0.13000000f,-0.40000000f,0.94000000f,-0.10000000f,-0.71000000f,-0.54000000f,0.75000000f,0.28000000f,-0.00000000f,-0.78000000f,-0.12000000f,0.42000000f,0.28000000f,-0.99000000f,0.82000000f,-0.99000000f,-0.97000000f,0.61000000f,0.29000000f,-0.76000000f,0.97000000f,-0.57000000f,-0.50000000f,0.20000000f,0.38000000f,-0.95000000f,0.08000000f,-0.57000000f,-0.98000000f,0.24000000f,-0.41000000f,0.40000000f,0.50000000f,0.59000000f,0.44000000f,-0.76000000f,-0.97000000f,-0.65000000f,-0.07000000f,-0.12000000f,-0.03000000f,0.79000000f,0.87000000f,-0.63000000f,-0.09000000f,0.16000000f,-0.47000000f,0.62000000f,0.55000000f,0.17000000f,0.32000000f,-0.44000000f,0.44000000f,0.61000000f,-0.52000000f,0.51000000f,-0.49000000f,0.87000000f,-0.34000000f,0.63000000f,-0.53000000f,-0.30000000f,-0.50000000f,-0.11000000f,-0.82000000f,-0.63000000f,-0.27000000f,0.31000000f,-0.60000000f,-0.83000000f,0.84000000f,0.90000000f,-0.13000000f,0.61000000f,-0.29000000f,-0.62000000f,0.51000000f,-0.32000000f,0.01000000f,-0.35000000f,-0.22000000f,-0.03000000f,-0.65000000f,0.25000000f,0.23000000f,-0.70000000f,0.09000000f,-0.34000000f,-0.82000000f,-0.60000000f,0.27000000f,0.48000000f,-0.04000000f,0.91000000f,0.40000000f,-0.66000000f,0.85000000f,-0.20000000f,0.85000000f,0.61000000f,-0.96000000f,-0.25000000f,-0.55000000f,-0.75000000f,0.00000000f,0.78000000f,-0.92000000f,0.29000000f,-0.00000000f,0.66000000f,0.03000000f,0.47000000f,-0.44000000f,-0.43000000f,-0.63000000f,0.82000000f,-0.00000000f,-0.88000000f,-0.14000000f,-0.55000000f,0.37000000f,0.00000000f,0.95000000f,0.12000000f,0.95000000f,0.22000000f,-0.98000000f,0.82000000f,-0.44000000f,0.37000000f,-0.09000000f,-0.92000000f,0.52000000f,-0.26000000f,-0.37000000f,0.95000000f,0.74000000f,0.84000000f,-0.97000000f,0.09000000f,-0.33000000f,-0.87000000f,-0.06000000f,0.81000000f,-0.85000000f,-0.68000000f,-0.67000000f,0.65000000f,-0.95000000f,0.60000000f,-0.55000000f,-0.45000000f,0.50000000f,0.54000000f,-0.18000000f,-0.00000000f,-0.53000000f,0.68000000f,0.88000000f,0.36000000f,-0.37000000f,0.58000000f,-0.90000000f,0.69000000f,-0.69000000f,0.10000000f,0.40000000f,-0.88000000f,-0.91000000f,-0.90000000f,-0.18000000f,0.47000000f,-0.60000000f,0.17000000f,-0.13000000f,0.64000000f,-0.24000000f,-0.42000000f,-0.89000000f,-0.47000000f,0.24000000f,-0.09000000f,0.13000000f,0.22000000f,0.35000000f,0.49000000f,0.73000000f,-0.97000000f,-0.58000000f,0.49000000f,0.20000000f,0.21000000f,-0.24000000f,0.16000000f,-0.77000000f,0.02000000f,-0.35000000f,0.06000000f,0.83000000f,-0.04000000f,-0.87000000f,-0.61000000f,0.78000000f,0.25000000f,-0.49000000f,-0.73000000f,-0.13000000f,0.95000000f,-0.59000000f,0.41000000f,-0.97000000f,-0.53000000f,-0.10000000f,-0.45000000f,-0.86000000f,0.57000000f,-0.58000000f,-0.78000000f,0.51000000f,-0.05000000f,-0.57000000f,0.11000000f,0.46000000f,0.66000000f,-0.48000000f,0.51000000f,-0.01000000f,-0.53000000f,-0.76000000f,0.19000000f,-0.01000000f,0.62000000f,-0.76000000f,0.49000000f,0.13000000f,-0.44000000f,0.01000000f,0.98000000f,-0.33000000f,-0.18000000f,-0.00000000f,0.27000000f,0.58000000f,0.94000000f,-0.21000000f,-0.79000000f,0.78000000f,0.15000000f,-0.19000000f,-0.60000000f,0.66000000f,0.53000000f,-0.13000000f,-0.91000000f,-0.96000000f,0.16000000f,-0.19000000f,-0.40000000f,-0.79000000f,-0.18000000f,0.66000000f,-0.17000000f,0.80000000f,0.90000000f,0.91000000f,0.43000000f,-0.83000000f,0.74000000f,-0.88000000f,-0.41000000f,0.07000000f,-0.25000000f,-0.53000000f,-0.75000000f,-0.43000000f,-0.62000000f,-0.35000000f,0.90000000f,-0.05000000f,0.75000000f,-0.76000000f,0.87000000f,-0.51000000f,0.16000000f,0.11000000f,-0.79000000f,0.29000000f,0.36000000f,0.56000000f,-0.85000000f,-0.51000000f,-0.04000000f,0.63000000f,0.75000000f,0.66000000f,-0.65000000f,-0.33000000f,-0.58000000f,0.09000000f,-0.50000000f,-0.70000000f,-0.75000000f,0.45000000f,-0.75000000f,0.21000000f,-0.20000000f,-0.39000000f,0.48000000f,0.97000000f,-0.03000000f,0.24000000f,-0.18000000f,-0.48000000f,0.46000000f,-0.04000000f,-0.71000000f,-0.11000000f,0.89000000f,0.56000000f,-0.52000000f,0.76000000f,0.44000000f,0.19000000f,0.83000000f,0.93000000f,-0.51000000f,0.83000000f,0.73000000f,0.12000000f,0.52000000f,-0.97000000f,0.42000000f,0.91000000f,-0.17000000f,0.13000000f,0.44000000f,-0.03000000f,0.54000000f,0.48000000f,-0.25000000f,-0.92000000f,-0.46000000f,0.39000000f,0.82000000f,-0.23000000f,0.05000000f,0.66000000f,-0.08000000f,0.60000000f,0.14000000f,-0.20000000f,-0.32000000f,-0.10000000f,-0.21000000f,0.12000000f,0.56000000f,-0.73000000f,0.63000000f,0.09000000f,0.97000000f,0.10000000f,-0.88000000f,0.71000000f,0.25000000f,-0.62000000f,-0.30000000f,-0.25000000f,-0.64000000f,0.35000000f,0.91000000f,0.57000000f,0.08000000f,-0.97000000f,-0.41000000f,-0.94000000f,-0.91000000f,-0.11000000f,0.57000000f,-0.68000000f,-0.37000000f,-0.39000000f,0.83000000f,0.31000000f,-0.15000000f,0.81000000f,-0.53000000f,0.63000000f,-0.65000000f,0.92000000f,-0.40000000f,-0.35000000f,0.05000000f,0.84000000f,0.63000000f,0.12000000f,-0.97000000f,0.98000000f,0.21000000f,0.91000000f,-0.86000000f,-0.12000000f,-0.77000000f,0.56000000f,0.66000000f,-0.60000000f,0.67000000f,-0.36000000f,-0.33000000f,0.39000000f,-0.21000000f,0.22000000f,0.82000000f,-0.51000000f,0.86000000f,0.28000000f,-0.07000000f,0.13000000f,-0.91000000f,-0.83000000f,-0.60000000f,-0.88000000f,0.42000000f,0.63000000f,-0.70000000f,0.54000000f,0.70000000f,0.38000000f,-0.71000000f,-0.15000000f,0.87000000f,0.07000000f,0.81000000f,-0.33000000f,-0.87000000f,-0.86000000f,0.85000000f,0.37000000f,-0.17000000f,0.71000000f,0.87000000f,-0.56000000f,0.06000000f,-0.66000000f,0.79000000f,-0.17000000f,0.13000000f,-0.22000000f,-0.75000000f,0.65000000f,0.14000000f,0.25000000f,0.56000000f,0.63000000f,-0.68000000f,-0.11000000f,0.91000000f,0.12000000f,-0.01000000f,-0.25000000f,-0.76000000f,-0.93000000f,0.66000000f,0.55000000f,0.43000000f,-0.35000000f,0.60000000f,-0.01000000f,-0.68000000f,-0.94000000f,-0.34000000f,-0.47000000f,0.87000000f,0.78000000f,0.10000000f,0.61000000f,-0.34000000f,0.19000000f,-0.24000000f,-0.20000000f,0.65000000f,-0.04000000f,-0.46000000f,0.08000000f,0.10000000f,0.54000000f,0.28000000f,-0.33000000f,-0.89000000f,0.88000000f,-0.54000000f,-0.04000000f,0.22000000f,0.53000000f,0.70000000f,0.07000000f,-0.65000000f,-0.86000000f,-0.72000000f,-0.61000000f,0.15000000f,-0.33000000f,-0.46000000f,0.96000000f,0.51000000f,0.86000000f,0.84000000f,0.03000000f,-0.62000000f,0.54000000f,-0.40000000f,-0.73000000f,0.04000000f,-0.40000000f,0.23000000f,-0.40000000f,0.28000000f,-0.66000000f,0.71000000f,0.33000000f,0.00000000f,0.59000000f,0.08000000f,0.81000000f,-0.02000000f,0.35000000f,-0.57000000f,0.92000000f,-0.76000000f,0.55000000f,-0.28000000f,0.53000000f,-0.84000000f,-0.76000000f,0.62000000f,-0.86000000f,0.97000000f,0.33000000f,-0.31000000f,-0.70000000f,0.51000000f,0.21000000f,-0.88000000f,-0.14000000f,0.17000000f,0.93000000f,0.34000000f,-0.38000000f,-0.71000000f,-0.68000000f,-0.99000000f,-0.80000000f,-0.26000000f,0.80000000f,0.39000000f,0.65000000f,0.89000000f,-0.11000000f,0.27000000f,0.59000000f,0.72000000f,0.88000000f,0.41000000f,0.27000000f,-0.54000000f,0.61000000f,-0.24000000f,0.64000000f,0.39000000f,0.06000000f,-0.65000000f,-0.23000000f,-0.43000000f,-0.74000000f,0.23000000f,0.06000000f,-0.18000000f,-0.72000000f,0.30000000f,0.07000000f,-0.90000000f,-0.49000000f,-0.50000000f,0.90000000f,0.73000000f,-0.00000000f,0.12000000f,-0.03000000f,0.50000000f,-0.15000000f,0.70000000f,-0.82000000f,0.54000000f,0.73000000f,-0.49000000f,-0.50000000f,-0.22000000f,-0.57000000f,0.58000000f,-0.73000000f,-0.69000000f,-0.58000000f,-0.81000000f,-0.48000000f,0.92000000f,-0.83000000f,-0.67000000f,-0.43000000f,-0.64000000f,0.53000000f,0.00000000f,-0.71000000f,-0.36000000f,0.38000000f,0.92000000f,0.98000000f,-0.60000000f,-0.52000000f,0.11000000f,0.78000000f,-0.40000000f,0.81000000f,-0.50000000f,-0.93000000f,-0.04000000f,-0.65000000f,0.44000000f,-0.66000000f,-0.23000000f,0.09000000f,-0.14000000f,-0.40000000f,0.26000000f,0.82000000f,0.68000000f,0.61000000f,0.93000000f,0.02000000f,-0.86000000f,-0.74000000f,-0.81000000f,-0.84000000f,-0.64000000f,-0.70000000f,-0.36000000f,0.83000000f,-0.57000000f,-0.74000000f,-0.22000000f,0.51000000f,-0.96000000f,-0.07000000f,-0.57000000f,0.18000000f,0.95000000f,0.25000000f,0.76000000f,-0.59000000f,-0.09000000f,-0.74000000f,0.33000000f,0.64000000f,-0.90000000f,0.62000000f,-0.16000000f,-0.69000000f,0.46000000f,-0.86000000f,0.21000000f,-0.25000000f,0.27000000f,0.66000000f,0.63000000f,-0.19000000f,-0.16000000f,-0.31000000f,-0.37000000f,0.99000000f,0.96000000f,-0.84000000f,-0.05000000f,-0.21000000f,0.05000000f,-0.22000000f,-0.09000000f,0.32000000f,0.61000000f,0.94000000f,-0.30000000f,0.73000000f,-0.79000000f,-0.84000000f,0.36000000f,-0.34000000f,0.00000000f,0.19000000f,0.14000000f,-0.94000000f,-0.98000000f,0.93000000f,0.09000000f,-0.75000000f,0.53000000f,-0.39000000f,-0.95000000f,-0.21000000f,0.17000000f,0.87000000f,0.21000000f,-0.29000000f,0.15000000f,-0.96000000f,-0.30000000f,-0.13000000f,0.43000000f,-0.01000000f,-0.08000000f,0.57000000f,0.77000000f,0.98000000f,-0.74000000f,-0.89000000f,0.79000000f,-0.10000000f,-0.15000000f,0.28000000f,0.47000000f,-0.62000000f,0.86000000f,0.77000000f,0.21000000f,-0.22000000f,0.63000000f,-0.42000000f,-0.10000000f,0.42000000f,0.02000000f,-0.15000000f,-0.74000000f,0.66000000f,-0.69000000f,-0.82000000f,-0.39000000f,0.17000000f,-0.16000000f,-0.04000000f,-0.69000000f,0.97000000f,-0.33000000f,0.74000000f,-0.69000000f,-0.01000000f,-0.87000000f,0.43000000f,0.99000000f,-0.18000000f,-0.37000000f,0.86000000f,-0.96000000f,0.97000000f,-0.62000000f,-0.02000000f,0.81000000f,-0.21000000f,0.78000000f,-0.36000000f,0.79000000f,0.14000000f,0.04000000f,0.13000000f,0.77000000f,0.84000000f,-0.21000000f,-0.24000000f,0.50000000f,-0.46000000f,-0.64000000f,-0.43000000f,-0.26000000f,-0.08000000f,-0.14000000f,-0.70000000f,0.77000000f,-0.59000000f,-0.39000000f,0.60000000f,-0.06000000f,0.42000000f,-0.83000000f,-0.43000000f,0.90000000f,0.76000000f,-0.52000000f,-0.92000000f,-0.22000000f,-0.15000000f,-0.54000000f,0.87000000f,0.20000000f,0.80000000f,0.93000000f,-0.14000000f,-0.33000000f,-0.83000000f,0.20000000f,-0.98000000f,0.18000000f,0.32000000f,-0.65000000f,0.00000000f,-0.22000000f,0.89000000f,-0.07000000f,-0.31000000f,0.05000000f,-0.49000000f,-0.58000000f,0.11000000f,-0.23000000f,0.18000000f,-0.58000000f,-0.30000000f,-0.83000000f,0.39000000f,0.56000000f,-0.49000000f,0.45000000f,-0.79000000f,0.79000000f,-0.67000000f,0.67000000f,-0.15000000f,0.32000000f,-0.91000000f,0.46000000f,0.11000000f,0.49000000f,0.78000000f,0.33000000f,-0.66000000f,-0.64000000f,0.63000000f,-0.42000000f,-0.25000000f,-0.80000000f,-0.24000000f,-0.69000000f,0.56000000f,0.84000000f,0.77000000f,0.74000000f,-0.39000000f,0.54000000f,0.83000000f,0.22000000f,-0.98000000f,0.26000000f,0.17000000f,0.63000000f,0.00000000f,0.55000000f,-0.92000000f,0.94000000f,-0.32000000f,-0.87000000f,-0.74000000f,0.11000000f,0.61000000f,0.55000000f,-0.72000000f,0.19000000f,-0.44000000f,-0.97000000f,-0.25000000f,-0.94000000f,0.75000000f,-0.41000000f,-0.40000000f,-0.83000000f,-0.82000000f,-0.51000000f,-0.26000000f,0.49000000f,0.98000000f,0.26000000f,0.91000000f,0.30000000f,-0.37000000f,0.50000000f,-0.77000000f,0.39000000f,-0.02000000f,0.22000000f,-0.91000000f,0.25000000f,0.98000000f,0.92000000f,0.85000000f,-0.23000000f,-0.00000000f,-0.35000000f,-0.63000000f,0.88000000f,0.39000000f,0.74000000f,-0.04000000f,0.34000000f,0.02000000f,-0.82000000f,0.73000000f,0.33000000f,-0.59000000f,0.47000000f,0.56000000f,0.48000000f,-0.34000000f,0.84000000f,-0.68000000f,-0.28000000f,0.96000000f,-0.06000000f,0.30000000f,-0.75000000f,0.91000000f,0.09000000f,0.29000000f,-0.84000000f,0.97000000f,-0.66000000f,0.52000000f,-0.00000000f,0.56000000f,-0.46000000f,0.29000000f,0.49000000f,0.64000000f,0.77000000f,-0.24000000f,0.20000000f,0.34000000f,0.40000000f,0.20000000f,0.85000000f,-0.80000000f,0.28000000f,0.93000000f,0.72000000f,-0.30000000f,0.62000000f,0.61000000f,-0.63000000f,-0.66000000f,-0.46000000f,0.95000000f,0.05000000f,-0.47000000f,0.83000000f,0.02000000f,-0.33000000f,-0.35000000f,0.38000000f,-0.51000000f,0.11000000f,0.52000000f,0.14000000f,0.87000000f,-0.71000000f,-0.87000000f,-0.22000000f,0.52000000f,0.82000000f,-0.77000000f,0.72000000f,0.48000000f,-0.11000000f,-0.77000000f,0.64000000f,-0.61000000f,0.09000000f,-0.16000000f,-0.30000000f,0.56000000f,0.50000000f,-0.66000000f,-0.39000000f,0.81000000f,0.42000000f,0.29000000f,-0.32000000f,0.67000000f,-0.59000000f,-0.60000000f,0.74000000f,0.93000000f,-0.49000000f,-0.34000000f,-0.35000000f,0.32000000f,-0.75000000f,0.32000000f,-0.03000000f,-0.39000000f,0.61000000f,-0.84000000f,-0.46000000f,-0.33000000f,0.99000000f,-0.71000000f,0.71000000f,-0.48000000f,0.27000000f,0.65000000f,-0.08000000f,0.86000000f,-0.69000000f,0.58000000f,0.10000000f,-0.64000000f,0.82000000f,-0.66000000f,-0.65000000f,0.58000000f,-0.42000000f,0.85000000f,-0.34000000f,0.99000000f,-0.02000000f,-0.05000000f,0.51000000f,-0.40000000f,0.24000000f,0.61000000f,-0.13000000f,-0.78000000f,-0.31000000f,-0.89000000f,0.62000000f,0.30000000f,-0.27000000f,-0.68000000f,-0.41000000f,-0.77000000f,0.64000000f,0.94000000f,0.01000000f,0.29000000f,-0.45000000f,-0.15000000f,-0.73000000f,0.78000000f,-0.27000000f,-0.80000000f,-0.70000000f,-0.30000000f,-0.69000000f,0.38000000f,-0.31000000f,0.37000000f,0.08000000f,0.97000000f,-0.32000000f,-0.01000000f,0.70000000f,0.61000000f,0.39000000f,0.58000000f,0.35000000f,0.32000000f,0.17000000f,0.86000000f,-0.04000000f,-0.75000000f,0.98000000f,0.81000000f,-0.58000000f,0.78000000f,0.94000000f,0.65000000f,0.89000000f,-0.36000000f,-0.43000000f,0.27000000f,0.99000000f,-0.99000000f,0.11000000f,0.04000000f,-0.08000000f,-0.16000000f,0.20000000f,-0.66000000f,0.87000000f,-0.05000000f,-0.57000000f,0.27000000f,0.90000000f,-0.41000000f,-0.60000000f,0.52000000f,-0.95000000f,0.30000000f,0.26000000f,0.54000000f,-0.71000000f,0.44000000f,-0.70000000f,-0.29000000f,-0.84000000f,-0.21000000f,-0.59000000f,0.55000000f,-0.98000000f,-0.85000000f,-0.98000000f,0.84000000f,0.99000000f,0.25000000f,0.14000000f,-0.42000000f,-0.91000000f,-0.48000000f,-0.52000000f,-0.49000000f,0.33000000f,0.05000000f,-0.46000000f,0.97000000f,0.89000000f,-0.12000000f,-0.45000000f,0.91000000f,-0.13000000f,-0.22000000f,-0.74000000f,-0.34000000f,0.00000000f,0.34000000f,0.16000000f,-0.31000000f,-0.11000000f,0.77000000f,-0.70000000f,0.81000000f,0.84000000f,-0.30000000f,0.18000000f,0.98000000f,-0.12000000f,-0.36000000f,0.48000000f,0.26000000f,-0.87000000f,0.21000000f,0.64000000f,0.36000000f,-0.85000000f,-0.04000000f,0.44000000f,-0.89000000f,0.94000000f,-0.98000000f,0.19000000f,-0.40000000f,-0.48000000f,-0.36000000f,0.77000000f,0.29000000f,0.18000000f,-0.02000000f,-0.72000000f,0.44000000f,0.35000000f,0.42000000f,-0.27000000f,0.51000000f,0.94000000f,0.14000000f,0.53000000f,-0.56000000f,-0.07000000f,0.37000000f,-0.33000000f,0.83000000f,-0.53000000f,0.33000000f,0.86000000f,-0.13000000f,-0.52000000f,0.11000000f,-0.23000000f,0.25000000f,-0.65000000f,-0.06000000f,0.42000000f,0.71000000f,0.94000000f,-0.78000000f,0.66000000f,0.96000000f,0.54000000f,0.20000000f,-0.36000000f,-0.52000000f,-0.26000000f,-0.59000000f,0.42000000f,0.34000000f,-0.23000000f,-0.35000000f,0.67000000f,0.49000000f,0.22000000f,-0.31000000f,0.17000000f,-0.34000000f,0.13000000f,0.06000000f,0.78000000f,-0.24000000f,-0.50000000f,0.41000000f,-0.18000000f,-0.93000000f,-0.98000000f,-0.02000000f,-0.16000000f,-0.11000000f,-0.37000000f,-0.66000000f,-0.63000000f,0.14000000f,-0.87000000f,-0.60000000f,0.60000000f,-0.45000000f,0.75000000f,-0.41000000f,0.62000000f,0.24000000f,0.71000000f,0.63000000f,0.77000000f,0.11000000f,-0.99000000f,0.03000000f,0.50000000f,-0.72000000f,-0.77000000f,-0.25000000f,0.00000000f,0.51000000f,-0.77000000f,-0.35000000f,-0.91000000f,0.94000000f,0.40000000f,0.89000000f,0.25000000f,-0.42000000f,-0.24000000f,-0.15000000f,-0.85000000f,0.32000000f,-0.42000000f,0.66000000f,0.57000000f,-0.89000000f,-0.08000000f,0.76000000f,-0.57000000f,0.09000000f,-0.26000000f,-0.30000000f,-0.46000000f,-0.44000000f,-0.06000000f,0.79000000f,0.67000000f,-0.60000000f,-0.59000000f,-0.05000000f,0.11000000f,-0.60000000f,-0.22000000f,-0.99000000f,0.51000000f,-0.30000000f,0.70000000f,0.85000000f,0.00000000f,-0.55000000f,-0.26000000f,-0.28000000f,-0.55000000f,0.85000000f,0.49000000f,-0.33000000f,-0.95000000f,-0.34000000f,-0.26000000f,-0.41000000f,-0.37000000f,-0.07000000f,0.84000000f,-0.94000000f,0.36000000f,-0.97000000f,0.04000000f,0.52000000f,0.36000000f,0.36000000f,-0.41000000f,-0.66000000f,0.91000000f,0.99000000f,-0.70000000f,-0.36000000f,0.20000000f,0.97000000f,-0.87000000f,-0.32000000f,-0.86000000f,-0.85000000f,-0.33000000f,0.69000000f,0.44000000f,-0.25000000f,-0.44000000f,-0.44000000f,-0.90000000f,0.93000000f,0.74000000f,-0.52000000f,0.71000000f,0.97000000f,0.13000000f,0.04000000f,0.42000000f,0.08000000f,-0.71000000f,0.08000000f,0.13000000f,-0.42000000f,-0.08000000f,-0.49000000f,-0.13000000f,0.91000000f,0.08000000f,0.02000000f,0.42000000f,-0.44000000f,-0.32000000f,0.34000000f,0.27000000f,0.70000000f,0.49000000f,-0.30000000f,-0.00000000f,-0.87000000f,0.08000000f,0.29000000f,0.64000000f,0.02000000f,-0.29000000f,0.23000000f,-0.53000000f,-0.93000000f,0.42000000f,-0.47000000f,-0.79000000f,0.66000000f,0.75000000f,-0.30000000f,0.16000000f,0.81000000f,-0.81000000f,0.36000000f,0.71000000f,0.90000000f,0.15000000f,0.98000000f,-0.77000000f,0.96000000f,0.10000000f,0.40000000f,0.05000000f,-0.76000000f,0.71000000f,-0.12000000f,-0.30000000f,0.93000000f,-0.00000000f,-0.53000000f,-0.25000000f,-0.10000000f,0.04000000f,-0.07000000f,0.04000000f,-0.89000000f,0.53000000f,-0.76000000f,0.60000000f,0.07000000f,-0.31000000f,0.06000000f,-0.35000000f,0.33000000f,0.01000000f,-0.25000000f,-0.71000000f,-0.38000000f,-0.39000000f,0.15000000f,-0.28000000f,-0.44000000f,-0.64000000f,-0.80000000f,-0.61000000f,-0.57000000f,0.46000000f,0.61000000f,-0.49000000f,-0.07000000f,-0.17000000f,-0.94000000f,0.73000000f,-0.06000000f,-0.02000000f,0.19000000f,0.54000000f,0.38000000f,0.69000000f,-0.67000000f,-0.27000000f,0.05000000f,0.75000000f,-0.48000000f,-0.13000000f,-0.18000000f,-0.02000000f,0.37000000f,0.63000000f,-0.97000000f,0.30000000f,0.82000000f,0.82000000f,0.88000000f,0.25000000f,-0.64000000f,0.60000000f,-0.41000000f,-0.12000000f,-0.73000000f,-0.65000000f,-0.53000000f,0.02000000f,0.58000000f,-0.36000000f,-0.53000000f,0.88000000f,-0.51000000f,0.66000000f,-0.79000000f,-0.23000000f,0.65000000f,-0.38000000f,0.99000000f,-0.51000000f,-0.62000000f,0.72000000f,-0.31000000f,-0.87000000f,0.56000000f,0.18000000f,0.71000000f,0.01000000f,-0.72000000f,0.59000000f,0.15000000f,-0.73000000f,0.43000000f,-0.81000000f,-0.62000000f,0.08000000f,0.82000000f,0.98000000f,0.94000000f,-0.97000000f,0.97000000f,-0.27000000f,-0.17000000f,-0.41000000f,-0.20000000f,-0.61000000f,0.31000000f,-0.25000000f,-0.58000000f,0.95000000f,-0.36000000f,0.28000000f,-0.54000000f,-0.92000000f,-0.87000000f,-0.61000000f,0.12000000f,-0.24000000f,0.71000000f,0.90000000f,-0.29000000f,-0.75000000f,0.78000000f,0.30000000f,0.51000000f,-0.48000000f,-0.39000000f,0.75000000f,-0.90000000f,0.65000000f,-0.07000000f,0.17000000f,-0.55000000f,0.27000000f,-0.66000000f,-0.23000000f,-0.13000000f,0.06000000f,-0.27000000f,0.13000000f,0.53000000f,-0.06000000f,0.88000000f,0.81000000f,-0.56000000f,-0.09000000f,-0.26000000f,-0.84000000f,-0.22000000f,-0.59000000f,0.23000000f,0.60000000f,-0.60000000f,0.90000000f,-0.86000000f,0.00000000f,-0.43000000f,-0.15000000f,-0.33000000f,-0.89000000f,0.20000000f,-0.08000000f,0.37000000f,0.24000000f,0.86000000f,0.67000000f,-0.52000000f,-0.88000000f,0.45000000f,-0.56000000f,0.00000000f,-0.45000000f,0.07000000f,-0.82000000f,0.08000000f,-0.27000000f,-0.64000000f,-0.88000000f,0.92000000f,-0.99000000f,-0.12000000f,0.89000000f,0.35000000f,-0.29000000f,0.48000000f,-0.35000000f,-0.50000000f,-0.60000000f,0.31000000f,-0.46000000f,0.60000000f,0.47000000f,0.54000000f,0.45000000f,0.86000000f,0.54000000f,-0.99000000f,0.59000000f,-0.01000000f,0.86000000f,-0.10000000f,0.54000000f,-0.76000000f,-0.88000000f,0.75000000f,-0.61000000f,0.40000000f,-0.25000000f,0.92000000f,0.14000000f,-0.18000000f,0.04000000f,-0.31000000f,0.29000000f,-0.80000000f,0.67000000f,-0.60000000f,-0.76000000f,-0.01000000f,-0.19000000f,0.18000000f,0.55000000f,0.03000000f,0.23000000f,-0.30000000f,-0.66000000f,-0.12000000f,-0.16000000f,0.97000000f,0.40000000f,0.52000000f,-0.15000000f,-0.89000000f,0.71000000f,0.31000000f,0.96000000f,0.90000000f,-0.19000000f,-0.35000000f,0.28000000f,-0.64000000f,-0.45000000f,-0.78000000f,-0.98000000f,-0.36000000f,0.00000000f,-0.53000000f,-0.91000000f,-0.41000000f,0.21000000f,0.43000000f,-0.24000000f,-0.37000000f,-0.91000000f,0.66000000f,0.19000000f,0.76000000f,0.72000000f,-0.44000000f,0.55000000f,0.51000000f,0.45000000f,0.68000000f,-0.26000000f,0.09000000f,-0.87000000f,0.16000000f,0.52000000f,0.85000000f,-0.61000000f,-0.28000000f,-0.50000000f,0.32000000f,-0.24000000f,0.09000000f,0.18000000f,0.46000000f,0.80000000f,-0.04000000f,0.07000000f,0.29000000f,-0.57000000f,-0.22000000f,-0.92000000f,-0.49000000f,0.98000000f,0.99000000f,0.61000000f,0.26000000f,0.85000000f,-0.24000000f,0.47000000f,-0.40000000f,-0.59000000f,-0.00000000f,-0.89000000f,-0.33000000f,0.37000000f,0.26000000f,0.31000000f,-0.77000000f,-0.89000000f,-0.03000000f,-0.26000000f,0.85000000f,0.71000000f,-0.12000000f,0.64000000f,0.92000000f,-0.54000000f,0.96000000f,0.42000000f,0.85000000f,-0.85000000f,0.22000000f,0.61000000f,0.64000000f,-0.82000000f,0.01000000f,-0.07000000f,0.58000000f,-0.33000000f,0.25000000f,0.26000000f,-0.52000000f,0.44000000f,-0.84000000f,0.50000000f,-0.02000000f,-0.29000000f,0.57000000f,-0.43000000f,-0.62000000f,0.66000000f,-0.01000000f,-0.86000000f,0.83000000f,0.90000000f,-0.16000000f,0.66000000f,-0.81000000f,-0.30000000f,0.15000000f,-0.62000000f,0.38000000f,0.92000000f,-0.11000000f,0.39000000f,0.51000000f,-0.27000000f,0.62000000f,-0.86000000f,0.00000000f,-0.16000000f,0.70000000f,-0.77000000f,-0.92000000f,-0.73000000f,-0.28000000f,-0.47000000f,-0.70000000f,-0.66000000f,-0.78000000f,-0.86000000f,0.56000000f,0.28000000f,0.31000000f,0.96000000f,-0.64000000f,0.18000000f,0.49000000f,-0.81000000f,-0.56000000f,-0.98000000f,0.99000000f,-0.93000000f,0.04000000f,-0.63000000f,-0.22000000f,-0.63000000f,-0.49000000f,0.08000000f,0.47000000f,0.71000000f,-0.35000000f,-0.76000000f,0.01000000f,-0.92000000f,0.80000000f,0.23000000f,0.69000000f,-0.66000000f,0.14000000f,-0.21000000f,0.11000000f,-0.38000000f,-0.11000000f,-0.12000000f,-0.77000000f,-0.90000000f,-0.24000000f,0.78000000f,0.54000000f,0.84000000f,0.18000000f,-0.26000000f,-0.08000000f,-0.66000000f,-0.83000000f,-0.28000000f,0.90000000f,-0.89000000f,0.98000000f,-0.75000000f,-0.92000000f,-0.56000000f,0.29000000f,0.03000000f,0.25000000f,-0.64000000f,0.23000000f,-0.30000000f,0.44000000f,0.98000000f,-0.48000000f,0.66000000f,0.80000000f,-0.31000000f,0.17000000f,0.45000000f,-0.43000000f,0.59000000f,-0.78000000f,0.10000000f,0.27000000f,0.04000000f,0.85000000f,-0.25000000f,-0.22000000f,-0.07000000f,-0.64000000f,-0.86000000f,-0.39000000f,0.73000000f,0.81000000f,-0.71000000f,0.63000000f,0.87000000f,-0.41000000f,0.45000000f,-0.00000000f,-0.01000000f,0.40000000f,0.10000000f,-0.59000000f,0.13000000f,-0.11000000f,0.13000000f,0.18000000f,-0.06000000f,-0.18000000f,0.28000000f,-0.42000000f,-0.62000000f,-0.82000000f,0.34000000f,-0.61000000f,0.61000000f,-0.47000000f,0.34000000f,-0.68000000f,0.92000000f,-0.08000000f,0.90000000f,0.52000000f,0.71000000f,-0.14000000f,0.73000000f,-0.72000000f,-0.43000000f,0.15000000f,-0.10000000f,0.49000000f,-0.33000000f,0.71000000f,-0.13000000f,-0.48000000f,-0.39000000f,0.08000000f,0.50000000f,0.47000000f,-0.79000000f,-0.21000000f,-0.75000000f,0.89000000f,0.15000000f,0.21000000f,0.62000000f,-0.05000000f,0.62000000f,-0.83000000f,0.87000000f,-0.34000000f,0.61000000f,-0.60000000f,-0.42000000f,0.11000000f,0.03000000f,-0.66000000f,-0.05000000f,0.42000000f,0.19000000f,0.82000000f,0.69000000f,-0.33000000f,-0.92000000f,-0.02000000f,-0.00000000f,0.82000000f,0.83000000f,-0.02000000f,0.44000000f,0.11000000f,0.19000000f,0.01000000f,-0.09000000f,0.38000000f,-0.32000000f,0.30000000f,0.84000000f,-0.65000000f,-0.01000000f,-0.08000000f,-0.02000000f,-0.83000000f,-0.47000000f,0.95000000f,-0.99000000f,0.37000000f,-0.38000000f,0.21000000f,0.35000000f,-0.38000000f,0.92000000f,0.60000000f,0.46000000f,-0.14000000f,0.28000000f,0.20000000f,-0.15000000f,-0.03000000f,0.96000000f,-0.33000000f,0.08000000f,-0.48000000f,-0.56000000f,0.96000000f,-0.03000000f,-0.56000000f,-0.25000000f,0.90000000f,0.16000000f,0.21000000f,-0.45000000f,0.77000000f,0.21000000f,0.61000000f,0.74000000f,-0.07000000f,0.93000000f,-0.35000000f,-0.26000000f,0.52000000f,0.74000000f,-0.91000000f,0.33000000f,0.09000000f,-0.45000000f,0.58000000f,-0.53000000f,0.31000000f,0.42000000f,0.70000000f,-0.85000000f,-0.19000000f,0.63000000f,-0.87000000f,0.67000000f,-0.49000000f,0.51000000f,-0.08000000f,0.96000000f,-0.80000000f,0.00000000f,0.79000000f,0.44000000f,0.69000000f,-0.37000000f,-0.86000000f,-0.63000000f,0.90000000f,0.79000000f,-0.56000000f,-0.26000000f,0.66000000f,0.62000000f,0.22000000f,0.27000000f,0.75000000f,-0.86000000f,0.23000000f,0.34000000f,-0.50000000f,-0.40000000f,-0.05000000f,0.12000000f,-0.26000000f,0.40000000f,-0.74000000f,-0.94000000f,-0.65000000f,-0.36000000f,-0.66000000f,-0.96000000f,-0.34000000f,0.57000000f,-0.44000000f,0.09000000f,-0.88000000f,0.66000000f,-0.04000000f,0.46000000f,-0.33000000f,-0.72000000f,0.69000000f,0.58000000f,-0.57000000f,-0.75000000f,0.48000000f,0.31000000f,-0.04000000f,0.34000000f,-0.95000000f,0.49000000f,-0.63000000f,-0.27000000f,0.61000000f,-0.96000000f,-0.00000000f,-0.27000000f,-0.26000000f,0.26000000f,-0.33000000f,0.30000000f,0.61000000f,0.81000000f,0.12000000f,0.24000000f,0.24000000f,-0.07000000f,-0.23000000f,-0.50000000f,-0.55000000f,-0.22000000f,-0.89000000f,-0.97000000f,0.05000000f,0.46000000f,0.11000000f,0.62000000f,-0.02000000f,-0.34000000f,-0.94000000f,0.04000000f,0.97000000f,0.43000000f,0.58000000f,-0.46000000f,0.59000000f,-0.36000000f,0.47000000f,-0.06000000f,-0.57000000f,-0.57000000f,0.10000000f,0.38000000f,-0.43000000f,0.23000000f,-0.91000000f,0.35000000f,0.09000000f,0.91000000f,0.30000000f,0.84000000f,0.09000000f,0.40000000f,-0.75000000f,0.50000000f,-0.36000000f,-0.95000000f,-0.86000000f,-0.78000000f,-0.69000000f,0.28000000f,0.93000000f,0.19000000f,-0.15000000f,0.90000000f,-0.19000000f,0.71000000f,0.98000000f,0.15000000f,0.31000000f,-0.87000000f,-0.61000000f,0.51000000f,0.71000000f,0.67000000f,-0.40000000f,0.70000000f,0.34000000f,0.61000000f,0.61000000f,0.47000000f,0.49000000f,-0.13000000f,-0.43000000f,0.79000000f,-0.45000000f,-0.57000000f,0.40000000f,-0.23000000f,0.53000000f,0.27000000f,-0.58000000f,0.43000000f,-0.10000000f,-0.72000000f,0.27000000f,-0.09000000f,0.56000000f,0.64000000f,0.11000000f,-0.57000000f,-0.27000000f,0.60000000f,-0.29000000f,0.16000000f,0.77000000f,-0.96000000f,0.40000000f,0.13000000f,0.86000000f,-0.42000000f,0.62000000f,-0.21000000f,-0.11000000f,0.92000000f,0.07000000f,-0.08000000f,0.70000000f,0.34000000f,-0.82000000f,-0.46000000f,0.86000000f,-0.01000000f,-0.42000000f,0.41000000f,0.74000000f,-0.03000000f,-0.69000000f,0.38000000f,0.03000000f,0.94000000f,-0.81000000f,-0.44000000f,0.26000000f,-0.48000000f,-0.01000000f,0.81000000f,0.41000000f,-0.87000000f,-0.35000000f,-0.23000000f,-0.32000000f,0.19000000f,-0.31000000f,-0.36000000f,-0.39000000f,0.96000000f,-0.03000000f,0.64000000f,0.65000000f,-0.40000000f,0.80000000f,0.61000000f,0.83000000f,0.37000000f,0.63000000f,0.42000000f,-0.01000000f,0.95000000f,-0.67000000f,0.59000000f,-0.02000000f,-0.06000000f,0.63000000f,0.20000000f,0.27000000f,-0.15000000f,0.13000000f,0.49000000f,-0.43000000f,0.92000000f,-0.76000000f,0.20000000f,-0.35000000f,0.20000000f,-0.82000000f,-0.79000000f,0.09000000f,-0.62000000f,0.60000000f,-0.20000000f,-0.89000000f,-0.22000000f,-0.63000000f,0.31000000f,0.27000000f,-0.67000000f,0.23000000f,0.13000000f,0.18000000f,-0.82000000f,0.95000000f,0.52000000f,-0.26000000f,0.55000000f,-0.77000000f,-0.29000000f,0.43000000f,-0.34000000f,-0.61000000f,0.72000000f,0.21000000f,-0.21000000f,0.21000000f,0.47000000f,-0.02000000f,-0.13000000f,0.10000000f,0.81000000f,0.73000000f,-0.50000000f,-0.59000000f,-0.32000000f,-0.18000000f,-0.02000000f,0.19000000f,-0.58000000f,-0.35000000f,-0.52000000f,0.40000000f,-0.88000000f,-0.87000000f,0.75000000f,-0.08000000f,-0.36000000f,0.49000000f,0.46000000f,0.72000000f,0.47000000f,-0.69000000f,-0.53000000f,-0.67000000f,0.27000000f,0.51000000f,0.73000000f,-0.70000000f,-0.52000000f,0.83000000f,0.03000000f,-0.03000000f,-0.72000000f,0.22000000f,0.29000000f,-0.92000000f,-0.07000000f,-0.58000000f,0.21000000f,-0.62000000f,0.08000000f,0.52000000f,-0.70000000f,0.68000000f,-0.72000000f,-0.66000000f,0.24000000f,0.80000000f,0.48000000f,0.46000000f,-0.41000000f,-0.47000000f,0.06000000f,-0.11000000f,-0.30000000f,0.92000000f,-0.28000000f,0.53000000f,-0.08000000f,0.28000000f,0.55000000f,0.87000000f,0.65000000f,-0.00000000f,-0.44000000f,-0.17000000f,0.35000000f,-0.43000000f,0.01000000f,-0.92000000f,0.01000000f,-0.33000000f,0.21000000f,0.34000000f,0.67000000f,0.48000000f,-0.23000000f,-0.08000000f,0.07000000f,-0.17000000f,-0.02000000f,-0.62000000f,-0.56000000f,0.47000000f,-0.10000000f,0.49000000f,-0.33000000f,0.04000000f,-0.92000000f,-0.68000000f,0.80000000f,0.49000000f,0.42000000f,0.86000000f,-0.23000000f,-0.74000000f,-0.64000000f,0.83000000f,0.39000000f,-0.53000000f,-0.69000000f,-0.86000000f,-0.30000000f,0.22000000f,-0.85000000f,0.78000000f,0.00000000f,-0.86000000f,0.94000000f,0.33000000f,0.85000000f,0.33000000f,-0.34000000f,0.06000000f,-0.25000000f,0.26000000f,-0.88000000f,0.90000000f,-0.47000000f,-0.29000000f,-0.56000000f,-0.59000000f,0.66000000f,-0.06000000f,-0.03000000f,0.75000000f,-0.64000000f,0.03000000f,-0.15000000f,0.69000000f,-0.59000000f,0.66000000f,0.37000000f,-0.21000000f,0.04000000f,-0.24000000f,0.49000000f,-0.30000000f,-0.27000000f,-0.93000000f,-0.16000000f,0.73000000f,-0.22000000f,-0.63000000f,0.98000000f,-0.47000000f,0.60000000f,-0.67000000f,-0.31000000f,-0.24000000f,-0.57000000f,0.10000000f,0.49000000f,-0.52000000f,-0.81000000f,-0.28000000f,0.13000000f,-0.36000000f,0.87000000f,-0.61000000f,0.38000000f,-0.35000000f,0.05000000f,-0.01000000f,0.38000000f,0.92000000f,-0.43000000f,-0.87000000f,0.35000000f,0.84000000f,0.47000000f,0.19000000f,0.71000000f,-0.16000000f,0.32000000f,0.64000000f,-0.27000000f,0.30000000f,-0.88000000f,0.24000000f,0.97000000f,-0.02000000f,0.59000000f,-0.45000000f,-0.13000000f,0.32000000f,0.40000000f,-0.69000000f,0.24000000f,-0.06000000f,-0.29000000f,-0.74000000f,0.01000000f,0.36000000f,0.16000000f,0.18000000f,-0.89000000f,-0.62000000f,0.63000000f,-0.83000000f,0.37000000f,0.88000000f,0.53000000f,0.43000000f,0.16000000f,0.72000000f,0.94000000f,-0.04000000f,0.86000000f,0.64000000f,0.58000000f,-0.03000000f,-0.83000000f,0.78000000f,-0.96000000f,-0.11000000f,-0.30000000f,0.20000000f,-0.60000000f,-0.02000000f,0.52000000f,0.62000000f,-0.99000000f,-0.96000000f,0.17000000f,-0.79000000f,-0.87000000f,-0.32000000f,0.39000000f,0.31000000f,0.02000000f,-0.84000000f,-0.77000000f,0.49000000f,0.65000000f,0.83000000f,-0.30000000f,0.98000000f,-0.13000000f,-0.94000000f,0.14000000f,0.40000000f,-0.47000000f,0.81000000f,0.88000000f,-0.75000000f,0.88000000f,0.54000000f,0.89000000f,-0.52000000f,0.92000000f,-0.10000000f,0.11000000f,0.83000000f,0.11000000f,-0.99000000f,0.22000000f,-0.41000000f,0.00000000f,0.80000000f,-0.53000000f,0.19000000f,0.26000000f,-0.17000000f,-0.70000000f,-0.56000000f,-0.20000000f,0.26000000f,0.91000000f,-0.83000000f,0.67000000f,0.56000000f,0.83000000f,0.43000000f,-0.39000000f,0.28000000f,0.83000000f,-0.43000000f,0.92000000f,0.88000000f,-0.68000000f,-0.37000000f,0.62000000f,-0.68000000f,0.70000000f,-0.16000000f,-0.78000000f,0.88000000f,-0.84000000f,0.32000000f,-0.22000000f,0.72000000f,0.58000000f,0.40000000f,0.24000000f,0.90000000f,-0.08000000f,-0.03000000f,-0.89000000f,0.55000000f,-0.76000000f,-0.34000000f,-0.15000000f,0.19000000f,0.36000000f,0.46000000f,-0.60000000f,-0.43000000f,0.54000000f,-0.38000000f,-0.02000000f,-0.21000000f,-0.60000000f,-0.74000000f,0.92000000f,0.65000000f,0.47000000f,0.75000000f,0.58000000f,0.95000000f,-0.22000000f,-0.64000000f,-0.28000000f,-0.12000000f,0.84000000f,-0.37000000f,-0.18000000f,-0.50000000f,0.08000000f,0.14000000f,0.31000000f,-0.56000000f,-0.18000000f,0.32000000f,0.52000000f,0.46000000f,0.19000000f,0.31000000f,-0.48000000f,-0.95000000f,-0.31000000f,0.83000000f,-0.31000000f,0.22000000f,0.41000000f,-0.02000000f,0.05000000f,0.60000000f,0.36000000f,0.78000000f,0.50000000f,0.50000000f,0.61000000f,-0.59000000f,-0.00000000f,0.50000000f,0.96000000f,-0.80000000f,-0.56000000f,0.92000000f,-0.00000000f,0.25000000f,0.79000000f,0.76000000f,0.14000000f,-0.00000000f,-0.99000000f,-0.85000000f,0.81000000f,-0.26000000f,-0.58000000f,0.21000000f,-0.68000000f,-0.90000000f,0.68000000f,-0.48000000f,0.59000000f,0.08000000f,0.62000000f,0.38000000f,0.64000000f,-0.54000000f,0.65000000f,0.60000000f,-0.45000000f,-0.54000000f,-0.40000000f,0.13000000f,-0.94000000f,-0.86000000f,-0.67000000f,0.09000000f,-0.53000000f,-0.45000000f,0.23000000f,0.19000000f,0.62000000f,-0.18000000f,-0.51000000f,0.56000000f,0.81000000f,0.55000000f,-0.62000000f,0.60000000f,0.44000000f,0.61000000f,0.58000000f,0.13000000f,0.13000000f,0.46000000f,-0.04000000f,-0.01000000f,-0.61000000f,-0.76000000f,-0.87000000f,-0.25000000f,0.69000000f,-0.29000000f,0.53000000f,-0.59000000f,-0.22000000f,0.22000000f,-0.08000000f,0.77000000f,-0.08000000f,0.65000000f,-0.90000000f,0.19000000f,0.82000000f,-0.26000000f,0.00000000f,0.12000000f,0.22000000f,-0.88000000f,0.52000000f,-0.37000000f,-0.97000000f,0.34000000f,0.94000000f,0.84000000f,0.88000000f,0.35000000f,0.31000000f,-0.22000000f,0.41000000f,-0.96000000f,0.93000000f,-0.43000000f,0.30000000f,-0.20000000f,-0.41000000f,0.96000000f,0.36000000f,-0.88000000f,0.72000000f,0.32000000f,-0.23000000f,0.37000000f,-0.80000000f,0.05000000f,0.52000000f,0.50000000f,-0.94000000f,-0.43000000f,-0.05000000f,-0.44000000f,0.87000000f,-0.11000000f,-0.01000000f,0.85000000f,0.41000000f,0.30000000f,-0.13000000f,-0.02000000f,-0.49000000f,-0.68000000f,-0.15000000f,-0.49000000f,-0.04000000f,-0.40000000f,-0.56000000f,0.32000000f,0.70000000f,-0.38000000f,-0.12000000f,-0.64000000f,-0.69000000f,-0.22000000f,0.40000000f,-0.77000000f,0.44000000f,-0.36000000f,-0.68000000f,-0.45000000f,-0.39000000f,0.00000000f,-0.44000000f,0.73000000f,0.14000000f,-0.21000000f,-0.50000000f,-0.28000000f,0.04000000f,0.25000000f,0.24000000f,-0.70000000f,-0.04000000f,0.78000000f,0.90000000f,-0.37000000f,0.14000000f,-0.31000000f,-0.98000000f,-0.23000000f,0.15000000f,-0.04000000f,-0.43000000f,-0.51000000f,0.34000000f,-0.69000000f,-0.33000000f,-0.00000000f,0.33000000f,0.77000000f,0.55000000f,0.88000000f,0.56000000f,-0.06000000f,0.86000000f,0.61000000f,-0.97000000f,0.42000000f,0.96000000f,-0.23000000f,0.56000000f,-0.82000000f,0.41000000f,0.87000000f,-0.93000000f,-0.40000000f,-0.71000000f,-0.88000000f,0.49000000f,-0.39000000f,-0.66000000f,-0.16000000f,0.57000000f,-0.77000000f,0.15000000f,-0.36000000f,-0.13000000f,0.69000000f,0.36000000f,0.75000000f,-0.84000000f,-0.44000000f,0.77000000f,0.69000000f,-0.89000000f,0.90000000f,-0.91000000f,0.09000000f,0.86000000f,0.27000000f,0.83000000f,0.75000000f,-0.17000000f,0.80000000f,0.40000000f,0.20000000f,-0.40000000f,0.87000000f,-0.85000000f,-0.47000000f,-0.40000000f,-0.47000000f,-0.17000000f,-0.42000000f,-0.14000000f,-0.83000000f,0.04000000f,0.80000000f,0.72000000f,-0.07000000f,-0.24000000f,-0.32000000f,0.91000000f,-0.67000000f,0.27000000f,0.65000000f,0.68000000f,-0.94000000f,-0.88000000f,-0.27000000f,0.74000000f,-0.36000000f,0.88000000f,-0.78000000f,0.44000000f,-0.31000000f,0.21000000f,0.57000000f,0.01000000f,0.25000000f,-0.02000000f,0.44000000f,-0.88000000f,0.96000000f,-0.91000000f,0.66000000f,0.88000000f,0.97000000f,0.53000000f,-0.90000000f,0.07000000f,0.70000000f,-0.41000000f,-0.52000000f,-0.00000000f,-0.48000000f,0.27000000f,-0.19000000f,0.96000000f,-0.00000000f,0.23000000f,0.13000000f,-0.56000000f,-0.69000000f,0.66000000f,0.19000000f,-0.79000000f,0.87000000f,0.91000000f,-0.35000000f,-0.67000000f,0.01000000f,-0.64000000f,-0.48000000f,0.77000000f,0.29000000f,-0.32000000f,-0.36000000f,-0.07000000f,-0.36000000f,-0.03000000f,0.51000000f,-0.99000000f,0.42000000f,-0.95000000f,0.31000000f,0.96000000f,0.58000000f,0.91000000f,0.96000000f,0.42000000f,-0.76000000f,-0.73000000f,-0.52000000f,0.64000000f,0.24000000f,-0.28000000f,-0.50000000f,0.56000000f,0.50000000f,0.41000000f,0.54000000f,0.10000000f,0.10000000f,-0.57000000f,-0.73000000f,0.50000000f,0.36000000f,-0.71000000f,0.49000000f,-0.08000000f,-0.33000000f,-0.78000000f,-0.77000000f,0.84000000f,0.40000000f,0.91000000f,-0.39000000f,0.26000000f,-0.76000000f,-0.25000000f,-0.15000000f,-0.07000000f,-0.34000000f,0.82000000f,-0.94000000f,0.21000000f,-0.99000000f,0.33000000f,0.79000000f,-0.41000000f,0.71000000f,-0.40000000f,0.87000000f,0.82000000f,-0.34000000f,-0.99000000f,0.35000000f,-0.41000000f,0.10000000f,0.60000000f,0.84000000f,-0.28000000f,0.46000000f,0.63000000f,-0.47000000f,-0.24000000f,-0.05000000f,-0.92000000f,0.55000000f,0.59000000f,-0.23000000f,0.92000000f,0.86000000f,-0.16000000f,-0.51000000f,-0.63000000f,-0.34000000f,0.56000000f,-0.98000000f,-0.07000000f,0.64000000f,-0.83000000f,0.71000000f,0.40000000f,-0.47000000f,-0.67000000f,0.80000000f,-0.64000000f,0.86000000f,-0.00000000f,-0.64000000f,-0.54000000f,0.53000000f,-0.54000000f,0.13000000f,-0.73000000f,0.71000000f,0.44000000f,0.62000000f,0.17000000f,0.80000000f,0.82000000f,-0.87000000f,-0.54000000f,-0.56000000f,0.35000000f,0.02000000f,0.18000000f,-0.06000000f,-0.00000000f,0.13000000f,0.16000000f,0.18000000f,-0.11000000f,0.35000000f,0.70000000f,0.84000000f,0.48000000f,-0.03000000f,0.07000000f,0.20000000f,-0.84000000f,-0.18000000f,-0.30000000f,0.79000000f,-0.88000000f,-0.28000000f,0.64000000f,0.70000000f,-0.05000000f,-0.18000000f,0.59000000f,-0.87000000f,-0.98000000f,0.57000000f,0.11000000f,0.84000000f,-0.33000000f,0.55000000f,-0.89000000f,-0.07000000f,-0.64000000f,-0.17000000f,0.74000000f,0.70000000f,-0.54000000f,0.42000000f,-0.64000000f,-0.74000000f,-0.90000000f,-0.40000000f,0.69000000f,0.62000000f,0.26000000f,0.50000000f,-0.61000000f,0.60000000f,0.54000000f,0.23000000f,0.30000000f,0.68000000f,0.96000000f,-0.19000000f,0.38000000f,-0.73000000f,0.04000000f,-0.44000000f,0.51000000f,0.87000000f,0.56000000f,0.72000000f,0.26000000f,-0.61000000f,-0.36000000f,0.67000000f,0.64000000f,-0.67000000f,-0.85000000f,-0.30000000f,0.37000000f,-0.34000000f,-0.00000000f,0.30000000f,0.86000000f,-0.19000000f,0.08000000f,0.46000000f,-0.14000000f,0.45000000f,-0.52000000f,0.40000000f,-0.69000000f,-0.60000000f,-0.53000000f,-0.35000000f,-0.15000000f,-0.01000000f,-0.93000000f,-0.97000000f,0.48000000f,0.10000000f,0.64000000f,0.61000000f,-0.02000000f,-0.32000000f,0.67000000f,0.30000000f,-0.73000000f,-0.75000000f,-0.24000000f,0.43000000f,-0.68000000f,-0.09000000f,0.76000000f,-0.50000000f,-0.85000000f,-0.94000000f,-0.73000000f,0.85000000f,-0.73000000f,-0.93000000f,0.52000000f,-0.67000000f,0.67000000f,0.15000000f,0.25000000f,0.24000000f,-0.06000000f,-0.20000000f,-0.43000000f,0.77000000f,-0.09000000f,0.81000000f,0.28000000f,0.32000000f,-0.34000000f,0.15000000f,0.95000000f,0.48000000f,0.37000000f,-0.39000000f,0.92000000f,0.06000000f,0.97000000f,-0.59000000f,0.93000000f,-0.22000000f,-0.16000000f,-0.29000000f,0.00000000f,0.70000000f,-0.78000000f,0.56000000f,-0.05000000f,0.39000000f,0.23000000f,-0.89000000f,0.29000000f,-0.08000000f,-0.67000000f,-0.51000000f,-0.09000000f,0.64000000f,-0.75000000f,-0.89000000f,0.91000000f,-0.05000000f,-0.33000000f,0.84000000f,-0.74000000f,-0.95000000f,-0.12000000f,0.59000000f,0.27000000f,0.03000000f,0.98000000f,-0.16000000f,0.63000000f,0.24000000f,0.65000000f,-0.64000000f,-0.89000000f,0.27000000f,0.55000000f,-0.22000000f,-0.27000000f,0.68000000f,0.89000000f,-0.78000000f,0.36000000f,-0.98000000f,-0.53000000f,0.44000000f,0.72000000f,-0.00000000f,-0.08000000f,-0.58000000f,0.96000000f,0.05000000f,-0.75000000f,0.69000000f,0.14000000f,-0.55000000f,0.83000000f,-0.66000000f,0.30000000f,-0.85000000f,0.63000000f,0.03000000f,-0.10000000f,0.73000000f,0.04000000f,0.70000000f,-0.95000000f,-0.52000000f,-0.45000000f,0.97000000f,-0.16000000f,-0.31000000f,-0.61000000f,-0.55000000f,0.58000000f,0.20000000f,-0.17000000f,-0.80000000f,0.75000000f,-0.31000000f,-0.48000000f,0.81000000f,-0.61000000f,0.59000000f,-0.21000000f,-0.16000000f,0.15000000f,-0.84000000f,0.90000000f,-0.53000000f,0.82000000f,0.17000000f,-0.75000000f,-0.51000000f,-0.00000000f,-0.00000000f,-0.07000000f,-0.25000000f,-0.40000000f,-0.09000000f,-0.39000000f,0.50000000f,-0.63000000f,0.76000000f,-0.80000000f,0.03000000f,0.44000000f,-0.18000000f,-0.75000000f,0.08000000f,0.55000000f,0.22000000f,-0.88000000f,0.47000000f,0.32000000f,0.40000000f,0.58000000f,-0.08000000f,0.50000000f,0.40000000f,0.41000000f,-0.28000000f,0.40000000f,-0.30000000f,-0.39000000f,0.32000000f,0.78000000f,0.56000000f,-0.55000000f,0.08000000f,-0.50000000f,-0.94000000f,-0.69000000f,0.88000000f,-0.97000000f,-0.67000000f,0.98000000f,0.44000000f,-0.78000000f,0.08000000f,-0.66000000f,0.83000000f,-0.84000000f,0.93000000f,-0.55000000f,0.03000000f,-0.25000000f,-0.91000000f,-0.95000000f,0.88000000f,-0.19000000f,-0.23000000f,0.67000000f,-0.21000000f,-0.03000000f,-0.10000000f,-0.77000000f,-0.27000000f,0.19000000f,-0.37000000f,0.95000000f,0.29000000f,-0.43000000f,0.94000000f,0.47000000f,0.96000000f,-0.92000000f,0.26000000f,-0.20000000f,-0.00000000f,-0.55000000f,0.37000000f,-0.76000000f,-0.02000000f,-0.30000000f,-0.47000000f,0.65000000f,-0.14000000f,0.09000000f,-0.26000000f,-0.19000000f,-0.63000000f,-0.28000000f,0.58000000f,0.87000000f,0.87000000f,0.50000000f,0.73000000f,0.96000000f,-0.16000000f,0.55000000f,0.68000000f,-0.62000000f,-0.81000000f,0.32000000f,-0.47000000f,0.29000000f,0.53000000f,-0.19000000f,-0.98000000f,-0.41000000f,0.29000000f,-0.48000000f,-0.16000000f,0.11000000f,0.09000000f,-0.27000000f,-0.97000000f,0.95000000f,0.36000000f,-0.66000000f,-0.68000000f,0.41000000f,0.01000000f,0.07000000f,-0.85000000f,0.13000000f,-0.02000000f,0.31000000f,-0.53000000f,-0.13000000f,-0.29000000f,-0.43000000f,0.68000000f,0.14000000f,0.85000000f,-0.57000000f,-0.63000000f,-0.46000000f,-0.44000000f,-0.70000000f,-0.27000000f,0.68000000f,0.68000000f,0.90000000f,-0.59000000f,0.33000000f,0.63000000f,0.40000000f,0.69000000f,0.26000000f,0.44000000f,-0.91000000f,-0.00000000f,-0.60000000f,-0.45000000f,-0.51000000f,0.42000000f,0.53000000f,-0.19000000f,-0.97000000f,-0.79000000f,0.98000000f,0.99000000f,-0.05000000f,-0.17000000f,0.16000000f,-0.77000000f,0.14000000f,0.34000000f,0.15000000f,0.15000000f,-0.00000000f,0.27000000f,-0.17000000f,0.68000000f,0.37000000f,0.50000000f,-0.14000000f,-0.03000000f,-0.70000000f,-0.06000000f,-0.33000000f,0.50000000f,0.57000000f,-0.37000000f,-0.96000000f,-0.89000000f,-0.43000000f,-0.45000000f,0.11000000f,-0.33000000f,-0.19000000f,-0.62000000f,0.81000000f,0.56000000f,-0.38000000f,0.69000000f,0.61000000f,-0.30000000f,-0.58000000f,-0.67000000f,-0.72000000f,-0.83000000f,0.64000000f,0.94000000f,-0.61000000f,0.83000000f,-0.43000000f,-0.73000000f,-0.67000000f,0.96000000f,-0.73000000f,0.61000000f,0.89000000f,-0.97000000f,0.80000000f,0.30000000f,-0.42000000f,0.92000000f,0.81000000f,0.03000000f,0.48000000f,0.98000000f,-0.04000000f,-0.68000000f,0.13000000f,0.90000000f,0.17000000f,0.59000000f,0.48000000f,-0.40000000f,-0.70000000f,-0.25000000f,-0.46000000f,0.69000000f,-0.02000000f,-0.53000000f,-0.60000000f,0.55000000f,-0.49000000f,-0.47000000f,-0.83000000f,0.59000000f,-0.26000000f,0.21000000f,0.86000000f,-0.51000000f,-0.26000000f,0.59000000f,-0.18000000f,-0.93000000f,0.55000000f,-0.20000000f,-0.92000000f,0.87000000f,0.95000000f,-0.32000000f,0.84000000f,0.78000000f,0.43000000f,0.56000000f,0.43000000f,0.36000000f,0.14000000f,-0.19000000f,-0.84000000f,-0.30000000f,0.48000000f,0.63000000f,-0.62000000f,-0.54000000f,-0.28000000f,-0.08000000f,0.06000000f,0.71000000f,0.64000000f,0.60000000f,0.88000000f,-0.68000000f,-0.91000000f,-0.03000000f,0.79000000f,0.69000000f,-0.51000000f,-0.24000000f,0.95000000f,-0.41000000f,0.01000000f,0.97000000f,0.94000000f,-0.74000000f,0.28000000f,0.55000000f,-0.48000000f,-0.63000000f,-0.85000000f,-0.70000000f,0.56000000f,0.37000000f,0.96000000f,-0.80000000f,-0.08000000f,0.39000000f,0.92000000f,-0.02000000f,0.85000000f,-0.28000000f,-0.14000000f,0.81000000f,0.35000000f,-0.17000000f,-0.39000000f,0.12000000f,0.36000000f,-0.06000000f,0.88000000f,-0.59000000f,-0.25000000f,-0.50000000f,-0.34000000f,0.71000000f,-0.72000000f,-0.75000000f,0.40000000f,0.29000000f,0.29000000f,0.61000000f,0.49000000f,-0.79000000f,0.05000000f,0.03000000f,0.48000000f,0.58000000f,-0.38000000f,0.98000000f,0.60000000f,-0.79000000f,-0.15000000f,-0.24000000f,0.37000000f,0.51000000f,0.95000000f,-0.94000000f,0.30000000f,-0.58000000f,0.62000000f,0.57000000f,-0.86000000f,0.69000000f,-0.18000000f,-0.29000000f,0.33000000f,0.56000000f,-0.37000000f,0.02000000f,0.12000000f,-0.97000000f,0.80000000f,-0.46000000f,0.55000000f,-0.82000000f,-0.60000000f,-0.86000000f,-0.80000000f,0.60000000f,-0.09000000f,-0.51000000f,-0.46000000f,-0.86000000f,-0.46000000f,-0.30000000f,-0.86000000f,0.33000000f,0.31000000f,-0.73000000f,-0.83000000f,0.33000000f,0.35000000f,-0.26000000f,0.58000000f,0.75000000f,0.89000000f,-0.10000000f,-0.55000000f,-0.37000000f,0.51000000f,0.14000000f,-0.37000000f,0.58000000f,0.08000000f,0.54000000f,0.37000000f,0.43000000f,-0.03000000f,0.18000000f,-0.48000000f,0.27000000f,-0.22000000f,0.57000000f,-0.27000000f,-0.89000000f,0.05000000f,0.53000000f,-0.71000000f,-0.12000000f,-0.53000000f,0.57000000f,-0.38000000f,-0.22000000f,0.49000000f,-0.47000000f,0.58000000f,-0.26000000f,-0.15000000f,0.47000000f,0.32000000f,0.97000000f,-0.82000000f,0.70000000f,0.15000000f,-0.08000000f,0.16000000f,-0.76000000f,0.14000000f,-0.75000000f,-0.49000000f,0.68000000f,-0.31000000f,0.02000000f,0.20000000f,0.66000000f,0.16000000f,-0.10000000f,0.13000000f,-0.48000000f,-0.78000000f,-0.81000000f,-0.61000000f,-0.84000000f,-0.23000000f,-0.65000000f,0.18000000f,0.72000000f,0.50000000f,-0.09000000f,0.56000000f,0.97000000f,-0.98000000f,-0.49000000f,0.59000000f,0.37000000f,0.32000000f,-0.61000000f,0.24000000f,-0.76000000f,-0.36000000f,-0.69000000f,0.02000000f,-0.29000000f,0.22000000f,0.70000000f,0.49000000f,-0.99000000f,-0.88000000f,0.28000000f,-0.38000000f,0.17000000f,0.73000000f,-0.86000000f,-0.17000000f,-0.79000000f,0.84000000f,0.47000000f,0.86000000f,-0.23000000f,-0.03000000f,-0.69000000f,-0.38000000f,-0.92000000f,-0.86000000f,-0.46000000f,-0.11000000f,0.32000000f,0.37000000f,-0.29000000f,-0.41000000f,-0.05000000f,-0.11000000f,0.48000000f,-0.16000000f,-0.74000000f,-0.83000000f,-0.07000000f,-0.04000000f,0.14000000f,0.31000000f,0.39000000f,-0.91000000f,0.64000000f,-0.05000000f,0.22000000f,-0.61000000f,-0.70000000f,-0.82000000f,-0.45000000f,0.31000000f,-0.48000000f,-0.31000000f,0.61000000f,-0.31000000f,0.40000000f,0.86000000f,-0.92000000f,0.16000000f,0.02000000f,0.49000000f,-0.60000000f,-0.72000000f,0.71000000f,0.03000000f,-0.67000000f,0.27000000f,0.94000000f,0.06000000f,0.47000000f,0.24000000f,-0.72000000f,-0.41000000f,0.08000000f,0.83000000f,-0.81000000f,-0.61000000f,-0.48000000f,0.08000000f,-0.06000000f,0.35000000f,-0.65000000f,0.91000000f,-0.77000000f,-0.90000000f,0.38000000f,-0.42000000f,-0.48000000f,0.37000000f,-0.71000000f,0.36000000f,0.57000000f,-0.08000000f,0.36000000f,-0.87000000f,0.70000000f,-0.53000000f,-0.00000000f,0.65000000f,-0.73000000f,0.19000000f,-0.09000000f,0.42000000f,0.74000000f,-0.29000000f,-0.31000000f,-0.66000000f,-0.01000000f,-0.40000000f,0.71000000f,-0.36000000f,0.69000000f,0.67000000f,-0.86000000f,0.64000000f,-0.02000000f,0.06000000f,0.49000000f,0.42000000f,0.34000000f,-0.35000000f,-0.58000000f,-0.94000000f,-0.17000000f,0.54000000f,-0.91000000f,-0.31000000f,0.54000000f,-0.19000000f,0.69000000f,-0.39000000f,0.65000000f,0.18000000f,-0.54000000f,0.64000000f,0.43000000f,-0.12000000f,0.44000000f,-0.95000000f,-0.62000000f,0.15000000f,-0.71000000f,0.00000000f,-0.33000000f,-0.30000000f,-0.32000000f,-0.36000000f,0.44000000f,-0.96000000f,-0.65000000f,0.02000000f,-0.21000000f,0.34000000f,0.03000000f,0.10000000f,-0.13000000f,0.58000000f,0.40000000f,0.10000000f,0.75000000f,-0.32000000f,-0.22000000f,-0.48000000f,0.87000000f,-0.03000000f,-0.02000000f,0.82000000f,0.06000000f,0.56000000f,0.41000000f,0.16000000f,0.41000000f,-0.52000000f,0.38000000f,-0.09000000f,0.07000000f,-0.42000000f,0.70000000f,-0.16000000f,-0.13000000f,0.22000000f,0.83000000f,0.56000000f,-0.03000000f,0.20000000f,-0.34000000f,-0.52000000f,0.50000000f,0.73000000f,0.34000000f,0.05000000f,-0.39000000f,0.61000000f,0.67000000f,-0.63000000f,0.27000000f,-0.73000000f,-0.73000000f,0.84000000f,-0.65000000f,-0.51000000f,-0.05000000f,-0.46000000f,-0.38000000f,-0.00000000f,0.38000000f,-0.40000000f,-0.52000000f,0.51000000f,-0.63000000f,-0.40000000f,-0.02000000f,0.39000000f,0.18000000f,0.60000000f,0.30000000f,0.32000000f,0.23000000f,0.77000000f,0.21000000f,0.12000000f,0.49000000f,0.30000000f,0.72000000f,-0.85000000f,0.96000000f,0.23000000f,-0.08000000f,0.57000000f,0.20000000f,0.87000000f,0.99000000f,0.54000000f,-0.76000000f,0.11000000f,0.97000000f,-0.10000000f,0.19000000f,-0.45000000f,-0.12000000f,0.85000000f,-0.21000000f,0.69000000f,0.71000000f,-0.61000000f,0.01000000f,-0.73000000f,-0.61000000f,0.51000000f,0.33000000f,-0.71000000f,0.76000000f,0.67000000f,0.35000000f,-0.51000000f,-0.62000000f,-0.46000000f,0.28000000f,-0.80000000f,0.62000000f,0.65000000f,-0.11000000f,0.87000000f,0.24000000f,-0.97000000f,0.60000000f,-0.03000000f,-0.83000000f,0.32000000f,-0.49000000f,-0.94000000f,-0.42000000f,-0.47000000f,0.50000000f,0.34000000f,0.84000000f,0.11000000f,-0.86000000f,-0.24000000f,0.69000000f,-0.53000000f,0.89000000f,0.00000000f,0.08000000f,-0.81000000f,-0.07000000f,-0.18000000f,-0.52000000f,-0.39000000f,-0.94000000f,0.04000000f,0.89000000f,-0.30000000f,0.44000000f,-0.68000000f,0.49000000f,0.40000000f,0.65000000f,-0.80000000f,-0.72000000f,0.42000000f,-0.49000000f,0.91000000f,0.45000000f,0.26000000f,0.60000000f,0.00000000f,0.20000000f,0.27000000f,-0.00000000f,0.27000000f,0.91000000f,0.44000000f,0.84000000f,0.81000000f,-0.09000000f,0.38000000f,-0.49000000f,0.56000000f,0.04000000f,0.54000000f,-0.79000000f,0.05000000f,0.56000000f,0.34000000f,-0.20000000f,0.12000000f,0.00000000f,0.48000000f,0.18000000f,0.15000000f,-0.86000000f,0.57000000f,-0.03000000f,-0.12000000f,0.56000000f,-0.33000000f,-0.80000000f,0.03000000f,0.00000000f,0.90000000f,0.00000000f,0.50000000f,0.15000000f,-0.09000000f,-0.43000000f,0.17000000f,-0.28000000f,0.21000000f,-0.86000000f,-0.41000000f,0.69000000f,-0.40000000f,0.11000000f,-0.95000000f,-0.08000000f,-0.98000000f,-0.67000000f,0.73000000f,-0.97000000f,-0.67000000f,-0.09000000f,0.52000000f,-0.25000000f,0.26000000f,0.09000000f,-0.66000000f,-0.16000000f,0.01000000f,0.86000000f,-0.11000000f,-0.78000000f,0.15000000f,-0.02000000f,-0.23000000f,0.18000000f,0.91000000f,0.29000000f,0.21000000f,-0.53000000f,-0.65000000f,0.79000000f,-0.68000000f,0.87000000f,-0.22000000f,-0.07000000f,-0.43000000f,0.50000000f,0.26000000f,0.05000000f,0.55000000f,-0.30000000f,-0.16000000f,-0.43000000f,0.56000000f,-0.16000000f,0.03000000f,-0.92000000f,0.32000000f,-0.69000000f,0.05000000f,-0.34000000f,-0.90000000f,0.67000000f,-0.24000000f,-0.24000000f,0.97000000f,0.18000000f,-0.31000000f,-0.45000000f,-0.98000000f,0.94000000f,0.84000000f,0.52000000f,0.80000000f,0.71000000f,-0.26000000f,0.04000000f,-0.78000000f,0.10000000f,-0.21000000f,-0.21000000f,0.42000000f,-0.36000000f,-0.98000000f,-0.29000000f,-0.79000000f,-0.29000000f,-0.89000000f,-0.82000000f,0.17000000f,-0.11000000f,0.59000000f,-0.30000000f,0.43000000f,0.40000000f,0.54000000f,-0.35000000f,-0.60000000f,-0.30000000f,0.61000000f,0.52000000f,0.20000000f,-0.40000000f,0.07000000f,0.81000000f,0.50000000f,0.00000000f,0.26000000f,0.06000000f,0.01000000f,-0.43000000f,0.68000000f,-0.25000000f,-0.28000000f,0.01000000f,0.29000000f,0.87000000f,0.68000000f,0.18000000f,-0.26000000f,-0.16000000f,-0.43000000f,-0.59000000f,0.74000000f,0.91000000f,0.33000000f,0.88000000f,0.07000000f,-0.67000000f,0.26000000f,-0.88000000f,-0.31000000f,-0.25000000f,0.63000000f,0.08000000f,-0.60000000f,-0.08000000f,-0.29000000f,-0.41000000f,-0.12000000f,-0.65000000f,-0.20000000f,-0.73000000f,0.50000000f,-0.50000000f,-0.55000000f,0.80000000f,0.01000000f,-0.47000000f,-0.33000000f,0.52000000f,-0.59000000f,-0.61000000f,0.99000000f,-0.94000000f,0.32000000f,-0.50000000f,-0.41000000f,0.66000000f,-0.06000000f,-0.30000000f,0.79000000f,0.33000000f,0.21000000f,-0.79000000f,0.09000000f,0.66000000f,-0.13000000f,-0.32000000f,0.05000000f,0.32000000f,0.07000000f,-0.11000000f,-0.16000000f,0.72000000f,0.69000000f,0.76000000f,-0.14000000f,-0.96000000f,-0.26000000f,0.93000000f,0.84000000f,-0.00000000f,0.23000000f,-0.68000000f,0.65000000f,0.64000000f,-0.37000000f,0.94000000f,-0.70000000f,-0.04000000f,-0.39000000f,0.90000000f,-0.62000000f,0.02000000f,0.88000000f,0.77000000f,-0.40000000f,0.01000000f,-0.45000000f,-0.92000000f,-0.18000000f,0.79000000f,0.52000000f,0.86000000f,0.57000000f,-0.39000000f,-0.39000000f,-0.47000000f,0.47000000f,-0.70000000f,-0.10000000f,0.27000000f,0.99000000f,-0.62000000f,-0.11000000f,-0.99000000f,-0.68000000f,0.81000000f,-0.94000000f,0.08000000f,-0.01000000f,0.42000000f,0.50000000f,0.05000000f,0.67000000f,0.87000000f,-0.11000000f,-0.55000000f,-0.20000000f,0.12000000f,-0.77000000f,0.50000000f,-0.46000000f,-0.69000000f,-0.76000000f,-0.21000000f,-0.49000000f,0.08000000f,-0.29000000f,-0.44000000f,0.59000000f,0.17000000f,-0.34000000f,0.57000000f,-0.00000000f,-0.21000000f,0.65000000f,0.04000000f,-0.26000000f,-0.73000000f,0.95000000f,0.28000000f,-0.33000000f,-0.95000000f,-0.55000000f,-0.52000000f,-0.93000000f,0.57000000f,-0.56000000f,-0.50000000f,-0.62000000f,-0.73000000f,0.94000000f,-0.37000000f,0.04000000f,-0.09000000f,-0.12000000f,-0.71000000f,-0.38000000f,-0.08000000f,-0.56000000f,0.27000000f,0.45000000f,-0.47000000f,0.84000000f,0.24000000f,-0.76000000f,-0.10000000f,0.96000000f,0.72000000f,0.67000000f,0.04000000f,0.91000000f,0.50000000f,0.29000000f,-0.34000000f,-0.87000000f,0.00000000f,-0.74000000f,0.76000000f,-0.20000000f,0.38000000f,0.54000000f,-0.69000000f,0.54000000f,-0.24000000f,-0.16000000f,0.79000000f,-0.17000000f,0.53000000f,-0.25000000f,-0.54000000f,0.40000000f,-0.78000000f,-0.41000000f,-0.25000000f,0.85000000f,0.70000000f,-0.77000000f,-0.23000000f,-0.96000000f,0.75000000f,0.52000000f,0.59000000f,-0.85000000f,0.70000000f,-0.23000000f,-0.71000000f,-0.22000000f,0.87000000f,0.44000000f,0.57000000f,0.75000000f,0.44000000f,-0.44000000f,0.45000000f,0.41000000f,-0.90000000f,-0.86000000f,0.51000000f,0.56000000f,-0.41000000f,-0.55000000f,0.53000000f,0.78000000f,-0.71000000f,-0.43000000f,-0.20000000f,0.98000000f,-0.39000000f,-0.42000000f,-0.52000000f,0.40000000f,-0.67000000f,-0.32000000f,0.12000000f,0.95000000f,0.99000000f,-0.75000000f,0.97000000f,-0.33000000f,-0.24000000f,0.31000000f,-0.50000000f,-0.54000000f,-0.20000000f,0.92000000f,-0.81000000f,0.38000000f,-0.62000000f,-0.39000000f,0.82000000f,0.91000000f,-0.75000000f,0.03000000f,-0.06000000f,-0.61000000f,-0.17000000f,-0.91000000f,0.27000000f,0.30000000f,-0.75000000f,-0.51000000f,0.50000000f,0.60000000f,-0.96000000f,-0.91000000f,-0.52000000f,0.34000000f,0.92000000f,0.31000000f,-0.02000000f,0.89000000f,0.93000000f,-0.77000000f,0.53000000f,0.98000000f,0.01000000f,0.45000000f,0.56000000f,-0.41000000f,0.38000000f,-0.96000000f,0.72000000f,-0.11000000f,-0.05000000f,0.88000000f,-0.78000000f,-0.27000000f,-0.68000000f,-0.41000000f,-0.16000000f,-0.08000000f,0.70000000f,0.16000000f,0.13000000f,-0.29000000f,0.53000000f,-0.52000000f,-0.75000000f,0.99000000f,0.73000000f,0.11000000f,0.11000000f,-0.05000000f,0.27000000f,-0.87000000f,-0.19000000f,-0.59000000f,-0.73000000f,0.74000000f,-0.18000000f,0.13000000f,-0.32000000f,0.55000000f,0.03000000f,-0.20000000f,0.45000000f,-0.06000000f,-0.10000000f,-0.86000000f,0.94000000f,-0.63000000f,0.88000000f,0.23000000f,0.28000000f,-0.62000000f,-0.59000000f,0.76000000f,0.41000000f,-0.29000000f,0.55000000f,0.01000000f,0.36000000f,0.33000000f,0.06000000f,0.67000000f,-0.63000000f,-0.36000000f,0.77000000f,-0.72000000f,0.76000000f,-0.87000000f,0.95000000f,-0.28000000f,-0.83000000f,-0.67000000f,-0.64000000f,-0.49000000f,0.55000000f,0.06000000f,0.90000000f,-0.01000000f,-0.58000000f,0.94000000f,-0.76000000f,-0.24000000f,0.58000000f,-0.99000000f,0.17000000f,-0.14000000f,0.65000000f,-0.80000000f,0.77000000f,-0.18000000f,-0.37000000f,0.07000000f,-0.71000000f,-0.31000000f,0.43000000f,0.59000000f,-0.52000000f,-0.73000000f,-0.17000000f,0.04000000f,-0.25000000f,-0.62000000f,0.90000000f,0.40000000f,-0.60000000f,-0.31000000f,0.52000000f,-0.60000000f,0.90000000f,0.78000000f,0.13000000f,-0.27000000f,-0.71000000f,0.71000000f,0.24000000f,0.93000000f,-0.39000000f,0.33000000f,-0.02000000f,0.45000000f,0.61000000f,-0.50000000f,0.81000000f,0.95000000f,-0.70000000f,0.72000000f,0.03000000f,-0.16000000f,0.07000000f,-0.28000000f,-0.83000000f,0.84000000f,-0.48000000f,-0.42000000f,0.62000000f,0.62000000f,0.39000000f,0.88000000f,0.03000000f,-0.41000000f,-0.49000000f,-0.80000000f,-0.60000000f,0.55000000f,0.83000000f,-0.02000000f,-0.69000000f,-0.19000000f,0.65000000f,0.49000000f,-0.32000000f,-0.28000000f,0.05000000f,-0.40000000f,-0.03000000f,-0.39000000f,0.48000000f,-0.75000000f,-0.02000000f,-0.91000000f,-0.25000000f,0.33000000f,0.80000000f,-0.30000000f,-0.14000000f,-0.36000000f,0.61000000f,0.82000000f,0.48000000f,0.31000000f,-0.87000000f,0.45000000f,0.06000000f,0.15000000f,0.08000000f,-0.39000000f,0.10000000f,-0.21000000f,0.63000000f,-0.47000000f,0.55000000f,0.47000000f,0.90000000f,0.32000000f,-0.29000000f,0.79000000f,-0.76000000f,0.75000000f,-0.90000000f,0.56000000f,0.92000000f,-0.04000000f,-0.73000000f,-0.75000000f,-0.68000000f,-0.74000000f,0.99000000f,-0.68000000f,-0.49000000f,0.31000000f,0.76000000f,-0.76000000f,-0.03000000f,-0.95000000f,-0.75000000f,-0.89000000f,-0.32000000f,0.91000000f,-0.34000000f,0.58000000f,-0.43000000f,0.33000000f,-0.88000000f,-0.32000000f,0.90000000f,0.23000000f,-0.40000000f,-0.86000000f,0.81000000f,0.26000000f,-0.90000000f,0.78000000f,-0.61000000f,0.65000000f,-0.75000000f,0.69000000f,-0.29000000f,-0.17000000f,-0.92000000f,0.84000000f,0.80000000f,-0.35000000f,0.53000000f,0.73000000f,-0.60000000f,-0.75000000f,-0.46000000f,-0.68000000f,-0.13000000f,0.80000000f,-0.21000000f,0.38000000f,0.89000000f,-0.53000000f,0.34000000f,-0.32000000f,0.71000000f,0.08000000f,-0.43000000f,0.27000000f,-0.17000000f,0.48000000f,0.75000000f,-0.89000000f,-0.47000000f,-0.94000000f,-0.23000000f,0.52000000f,-0.47000000f,0.34000000f,-0.84000000f,-0.81000000f,-0.14000000f,0.36000000f,-0.73000000f,-0.35000000f,-0.06000000f,-0.66000000f,-0.16000000f,-0.84000000f,-0.95000000f,-0.52000000f,-0.02000000f,-0.28000000f,0.85000000f,0.91000000f,-0.61000000f,-0.16000000f,-0.82000000f,0.10000000f,0.19000000f,-0.51000000f,0.04000000f,-0.23000000f,0.74000000f,-0.18000000f,0.31000000f,-0.63000000f,-0.37000000f,-0.27000000f,-0.95000000f,-0.36000000f,-0.32000000f,-0.85000000f,0.52000000f,0.16000000f,0.75000000f,-0.68000000f,-0.99000000f,-0.18000000f,-0.82000000f,0.90000000f,0.61000000f,-0.96000000f,0.55000000f,0.61000000f,-0.82000000f,0.15000000f,0.21000000f,-0.46000000f,0.06000000f,0.35000000f,0.95000000f,0.25000000f,-0.10000000f,-0.08000000f,0.58000000f,0.14000000f,-0.54000000f,0.21000000f,0.48000000f,0.53000000f,0.09000000f,0.75000000f,0.82000000f,-0.12000000f,-0.45000000f,0.65000000f,0.29000000f,-0.04000000f,0.43000000f,0.84000000f,-0.97000000f,0.04000000f,-0.14000000f,-0.02000000f,0.09000000f,-0.46000000f,0.01000000f,-0.90000000f,-0.54000000f,-0.71000000f,-0.03000000f,-0.45000000f,-0.02000000f,-0.49000000f,-0.71000000f,0.06000000f,-0.48000000f,0.90000000f,0.83000000f,0.20000000f,0.42000000f,-0.99000000f,-0.11000000f,0.53000000f,-0.35000000f,-0.01000000f,0.67000000f,-0.68000000f,-0.08000000f,-0.52000000f,0.44000000f,-0.61000000f,-0.58000000f,-0.15000000f,-0.47000000f,0.90000000f,0.37000000f,-0.05000000f,-0.52000000f,0.54000000f,0.88000000f,0.19000000f,-0.36000000f,0.19000000f,0.82000000f,0.04000000f,-0.37000000f,0.36000000f,0.97000000f,-0.93000000f,0.97000000f,-0.82000000f,0.28000000f,0.17000000f,-0.19000000f,0.17000000f,-0.24000000f,-0.69000000f,0.48000000f,-0.01000000f,0.43000000f,-0.70000000f,0.98000000f,-0.49000000f,-0.51000000f,0.97000000f,0.05000000f,-0.87000000f,0.57000000f,-0.93000000f,-0.45000000f,0.78000000f,-0.22000000f,0.70000000f,0.91000000f,-0.54000000f,0.67000000f,-0.53000000f,-0.01000000f,0.38000000f,0.99000000f,-0.56000000f,0.85000000f,0.67000000f,0.88000000f,-0.02000000f,0.33000000f,-0.00000000f,0.74000000f,0.33000000f,-0.37000000f,-0.92000000f,0.79000000f,-0.93000000f,0.24000000f,0.18000000f,-0.56000000f,-0.83000000f,-0.22000000f,0.79000000f,-0.04000000f,0.54000000f,-0.11000000f,-0.40000000f,0.27000000f,0.44000000f,0.50000000f,0.24000000f,0.96000000f,-0.02000000f,0.24000000f,0.18000000f,-0.95000000f,-0.03000000f,0.93000000f,-0.15000000f,0.86000000f,-0.24000000f,-0.30000000f,0.80000000f,-0.05000000f,0.91000000f,0.55000000f,0.05000000f,0.44000000f,-0.43000000f,0.00000000f,-0.96000000f,-0.55000000f,0.52000000f,-0.11000000f,-0.56000000f,-0.08000000f,0.91000000f,0.05000000f,-0.70000000f,0.13000000f,0.43000000f,0.07000000f,0.81000000f,-0.49000000f,0.14000000f,-0.89000000f,-0.38000000f,0.19000000f,0.57000000f,0.94000000f,0.66000000f,0.98000000f,0.75000000f,0.37000000f,-0.12000000f,0.12000000f,0.96000000f,0.40000000f,-0.10000000f,-0.64000000f,-0.88000000f,-0.64000000f,0.95000000f,-0.81000000f,0.61000000f,-0.97000000f,-0.68000000f,-0.73000000f,-0.00000000f,-0.69000000f,-0.99000000f,0.73000000f,-0.09000000f,-0.49000000f,0.22000000f,0.04000000f,0.77000000f,0.79000000f,-0.06000000f,-0.35000000f,0.06000000f,0.81000000f,-0.03000000f,-0.05000000f,0.47000000f,0.27000000f,-0.74000000f,-0.59000000f,0.82000000f,0.47000000f,0.80000000f,0.80000000f,0.58000000f,-0.87000000f,0.05000000f,0.50000000f,-0.26000000f,-0.50000000f,-0.84000000f,0.12000000f,0.62000000f,0.66000000f,-0.77000000f,-0.10000000f,0.74000000f,0.66000000f,-0.07000000f,0.73000000f,0.74000000f,0.52000000f,0.10000000f,-0.78000000f,0.24000000f,0.92000000f,0.02000000f,-0.12000000f,0.80000000f,0.60000000f,0.76000000f,0.96000000f,0.57000000f,0.94000000f,-0.37000000f,-0.01000000f,-0.20000000f,-0.95000000f,-0.37000000f,-0.61000000f,0.74000000f,0.82000000f,0.31000000f,0.32000000f,-0.47000000f,-0.91000000f,-0.60000000f,-0.78000000f,0.19000000f,-0.65000000f,0.44000000f,-0.63000000f,-0.19000000f,-0.62000000f,0.39000000f,-0.58000000f,-0.80000000f,-0.47000000f,0.29000000f,-0.31000000f,0.19000000f,0.13000000f,0.59000000f,-0.52000000f,0.32000000f,0.71000000f,-0.69000000f,-0.21000000f,-0.94000000f,-0.80000000f,-0.82000000f,-0.81000000f,-0.92000000f,-0.08000000f,-0.68000000f,0.19000000f,0.31000000f,-0.02000000f,-0.60000000f,0.97000000f,-0.71000000f,0.21000000f,-0.18000000f,0.19000000f,0.83000000f,0.79000000f,-0.18000000f,-0.91000000f,-0.77000000f,-0.80000000f,-0.00000000f,0.08000000f,0.30000000f,-0.86000000f,-0.88000000f,-0.01000000f,-0.88000000f,0.71000000f,-0.80000000f,-0.54000000f,0.43000000f,-0.68000000f,-0.56000000f,0.32000000f,0.05000000f,0.21000000f,-0.51000000f,0.17000000f,-0.42000000f,0.01000000f,0.00000000f,0.03000000f,0.16000000f,-0.77000000f,0.62000000f,-0.91000000f,-0.70000000f,-0.42000000f,-0.49000000f,0.46000000f,-0.82000000f,0.97000000f,-0.49000000f,-0.49000000f,0.42000000f,0.23000000f,-0.19000000f,0.23000000f,0.99000000f,-0.57000000f,-0.93000000f,-0.46000000f,0.05000000f,-0.86000000f,0.23000000f,0.94000000f,-0.68000000f,0.73000000f,0.08000000f,0.33000000f,0.63000000f,0.65000000f,0.11000000f,0.41000000f,-0.16000000f,-0.05000000f,0.80000000f,0.65000000f,0.07000000f,-0.76000000f,-0.69000000f,0.34000000f,0.18000000f,0.69000000f,0.58000000f,0.67000000f,0.56000000f,0.02000000f,-0.72000000f,0.07000000f,0.38000000f,-0.30000000f,0.59000000f,0.00000000f,-0.67000000f,0.52000000f,0.40000000f,0.60000000f,-0.26000000f,-0.16000000f,-0.99000000f,-0.89000000f,0.48000000f,0.03000000f,-0.59000000f,-0.62000000f,-0.51000000f,0.10000000f,0.79000000f,0.47000000f,0.66000000f,0.23000000f,-0.51000000f,-0.08000000f,-0.84000000f,-0.38000000f,0.27000000f,0.11000000f,-0.46000000f,0.50000000f,-0.75000000f,-0.49000000f,-0.44000000f,-0.86000000f,-0.46000000f,0.70000000f,-0.21000000f,-0.33000000f,-0.69000000f,0.91000000f,0.79000000f,0.29000000f,-0.90000000f,0.70000000f,-0.92000000f,-0.49000000f,0.85000000f,-0.58000000f,-0.71000000f,0.53000000f,0.88000000f,0.29000000f,0.35000000f,0.75000000f,-0.23000000f,0.90000000f,-0.49000000f,0.04000000f,0.07000000f,0.13000000f,-0.12000000f,-0.84000000f,-0.09000000f,-0.19000000f,-0.26000000f,-0.73000000f,-0.66000000f,-0.83000000f,-0.14000000f,0.38000000f,-0.95000000f,0.39000000f,-0.69000000f,0.46000000f,0.44000000f,0.53000000f,-0.38000000f,0.01000000f,-0.41000000f,0.10000000f,0.90000000f,-0.36000000f,0.58000000f,0.41000000f,0.11000000f,-0.73000000f,0.14000000f,0.97000000f,0.89000000f,-0.24000000f,0.49000000f,0.65000000f,-0.52000000f,0.63000000f,-0.82000000f,0.34000000f,0.95000000f,-0.90000000f,-0.19000000f,-0.48000000f,-0.05000000f,-0.92000000f,-0.48000000f,-0.09000000f,-0.72000000f,0.64000000f,-0.92000000f,0.64000000f,-0.85000000f,-0.78000000f,-0.44000000f,-0.67000000f,-0.48000000f,0.91000000f,-0.45000000f,0.23000000f,-0.35000000f,-0.10000000f,0.49000000f,0.65000000f,0.29000000f,0.03000000f,0.59000000f,-0.92000000f,0.24000000f,0.48000000f,0.86000000f,0.29000000f,0.77000000f,0.40000000f,-0.56000000f,-0.27000000f,-0.99000000f,0.95000000f,0.99000000f,-0.65000000f,0.71000000f,0.21000000f,-0.14000000f,0.51000000f,0.25000000f,-0.31000000f,0.73000000f,0.37000000f,0.62000000f,0.58000000f,-0.81000000f,-0.68000000f,0.41000000f,-0.88000000f,-0.20000000f,0.40000000f,-0.71000000f,-0.71000000f,0.97000000f,-0.28000000f,-0.73000000f,0.36000000f,-0.57000000f,-0.56000000f,-0.33000000f,0.98000000f,-0.32000000f,0.25000000f,-0.85000000f,-0.16000000f,-0.14000000f,-0.17000000f,-0.57000000f,0.12000000f,0.03000000f,-0.77000000f,0.12000000f,-0.58000000f,-0.90000000f,0.51000000f,-0.29000000f,-0.47000000f,0.89000000f,-0.81000000f,0.69000000f,0.70000000f,-0.40000000f,0.15000000f,-0.66000000f,0.54000000f,-0.75000000f,-0.81000000f,-0.87000000f,-0.26000000f,0.31000000f,-0.56000000f,-0.15000000f,0.04000000f,-0.86000000f,0.07000000f,0.19000000f,-0.80000000f,-0.94000000f,0.04000000f,-0.01000000f,0.87000000f,0.83000000f,-0.44000000f,-0.77000000f,-0.73000000f,0.24000000f,-0.87000000f,-0.61000000f,0.85000000f,0.40000000f,-0.83000000f,0.18000000f,-0.88000000f,0.49000000f,-0.27000000f,-0.25000000f,-0.59000000f,-0.47000000f,-0.91000000f,-0.81000000f,-0.60000000f,-0.73000000f,0.78000000f,-0.81000000f,0.70000000f,0.20000000f,0.44000000f,-0.60000000f,-0.82000000f,-0.56000000f,0.90000000f,0.08000000f,-0.00000000f,0.06000000f,0.17000000f,-0.42000000f,0.34000000f,0.80000000f,-0.92000000f,0.02000000f,0.44000000f,-0.54000000f,0.45000000f,0.69000000f,-0.19000000f,-0.06000000f,0.32000000f,-0.38000000f,0.72000000f,0.96000000f,0.47000000f,-0.56000000f,-0.50000000f,0.09000000f,-0.60000000f,-0.92000000f,0.10000000f,-0.34000000f,0.16000000f,0.74000000f,0.03000000f,-0.54000000f,0.63000000f,0.60000000f,0.69000000f,0.20000000f,-0.43000000f,0.31000000f,-0.68000000f,-0.64000000f,-0.46000000f,0.61000000f,-0.74000000f,0.56000000f,0.11000000f,-0.44000000f,-0.02000000f,-0.38000000f,-0.96000000f,0.95000000f,0.38000000f,0.24000000f,-0.74000000f,0.91000000f,-0.54000000f,-0.61000000f,0.67000000f,0.38000000f,0.91000000f,0.05000000f,-0.53000000f,-0.08000000f,0.04000000f,-0.86000000f,-0.90000000f,-0.92000000f,0.08000000f,-0.49000000f,0.22000000f,0.92000000f,0.76000000f,-0.30000000f,0.85000000f,-0.76000000f,0.15000000f,0.28000000f,-0.52000000f,-0.16000000f,0.84000000f,0.48000000f,0.70000000f,0.62000000f,-0.52000000f,0.37000000f,-0.43000000f,0.52000000f,-0.87000000f,0.91000000f,0.13000000f,0.15000000f,0.10000000f,0.62000000f,0.72000000f,-0.69000000f,-0.53000000f,-0.09000000f,-0.37000000f,0.76000000f,-0.76000000f,-0.50000000f,0.86000000f,-0.17000000f,-0.73000000f,-0.39000000f,-0.05000000f,0.91000000f,-0.26000000f,0.39000000f,-0.69000000f,0.26000000f,0.97000000f,-0.23000000f,0.61000000f,0.77000000f,-0.28000000f,0.17000000f,0.32000000f,0.85000000f,-0.80000000f,-0.85000000f,-0.03000000f,-0.59000000f,-0.91000000f,0.28000000f,-0.14000000f,0.46000000f,-0.53000000f,-0.75000000f,-0.84000000f,0.52000000f,-0.35000000f,-0.97000000f,0.94000000f,-0.44000000f,-0.26000000f,0.54000000f,-0.51000000f,0.41000000f,0.41000000f,0.89000000f,-0.54000000f,-0.27000000f,0.72000000f,-0.34000000f,0.01000000f,0.19000000f,0.23000000f,-0.30000000f,-0.61000000f,-0.39000000f,-0.11000000f,0.45000000f,-0.22000000f,-0.66000000f,0.06000000f,0.15000000f,0.46000000f,-0.00000000f,0.91000000f,0.25000000f,0.37000000f,-0.13000000f,0.26000000f,0.08000000f,0.78000000f,-0.77000000f,-0.68000000f,0.21000000f,-0.80000000f,0.02000000f,0.33000000f,0.65000000f,0.33000000f,0.02000000f,-0.97000000f,0.01000000f,-0.47000000f,-0.48000000f,0.46000000f,-0.70000000f,0.47000000f,0.01000000f,-0.98000000f,0.49000000f,-0.12000000f,-0.62000000f,-0.45000000f,0.57000000f,-0.05000000f,0.91000000f,0.29000000f,-0.85000000f,-0.14000000f,-0.51000000f,-0.31000000f,0.48000000f,0.81000000f,-0.11000000f,0.10000000f,0.72000000f,0.27000000f,-0.97000000f,0.24000000f,-0.18000000f,-0.09000000f,-0.77000000f,-0.70000000f,0.98000000f,0.50000000f,0.58000000f,0.10000000f,-0.19000000f,0.12000000f,0.05000000f,0.77000000f,0.17000000f,-0.38000000f,-0.17000000f,0.15000000f,-0.18000000f,0.45000000f,0.10000000f,0.86000000f,0.23000000f,-0.74000000f,-0.18000000f,0.41000000f,0.30000000f,-0.75000000f,-0.25000000f,-0.29000000f,0.86000000f,-0.21000000f,0.34000000f,-0.62000000f,0.89000000f,-0.04000000f,-0.34000000f,-0.04000000f,0.38000000f,-0.59000000f,0.02000000f,0.52000000f,0.84000000f,0.14000000f,0.48000000f,-0.89000000f,-0.86000000f,0.12000000f,-0.07000000f,-0.21000000f,-0.94000000f,-0.36000000f,-0.49000000f,0.26000000f,0.70000000f,0.45000000f,0.16000000f,-0.98000000f,-0.85000000f,-0.38000000f,-0.01000000f,-0.31000000f,-0.23000000f,-0.16000000f,0.93000000f,-0.68000000f,0.12000000f,-0.92000000f,-0.55000000f,-0.15000000f,-0.68000000f,-0.59000000f,-0.57000000f,0.79000000f,-0.21000000f,0.17000000f,-0.14000000f,-0.30000000f,-0.35000000f,0.07000000f,-0.15000000f,-0.25000000f,-0.04000000f,0.01000000f,0.28000000f,-0.54000000f,0.85000000f,-0.59000000f,-0.69000000f,-0.18000000f,0.42000000f,-0.93000000f,-0.02000000f,-0.69000000f,0.94000000f,0.11000000f,-0.33000000f,0.34000000f,0.25000000f,-0.77000000f,-0.82000000f,0.33000000f,-0.29000000f,-0.68000000f,-0.52000000f,-0.49000000f,0.57000000f,0.47000000f,-0.60000000f,-0.45000000f,0.69000000f,0.82000000f,-0.15000000f,-0.83000000f,-0.07000000f,-0.79000000f,-0.63000000f,-0.42000000f,-0.62000000f,-0.25000000f,0.78000000f,0.69000000f,0.32000000f,0.36000000f,0.73000000f,0.52000000f,-0.74000000f,-0.11000000f,0.04000000f,-0.96000000f,-0.50000000f,-0.47000000f,-0.88000000f,-0.26000000f,0.67000000f,-0.59000000f,-0.33000000f,0.78000000f,-0.59000000f,0.21000000f,0.13000000f,-0.31000000f,-0.19000000f,0.15000000f,0.26000000f,-0.40000000f,0.43000000f,-0.96000000f,0.75000000f,-0.61000000f,-0.04000000f,0.66000000f,-0.10000000f,0.65000000f,0.12000000f,-0.20000000f,0.98000000f,0.99000000f,-0.75000000f,0.51000000f,0.93000000f,-0.27000000f,0.02000000f,-0.85000000f,-0.62000000f,-0.35000000f,-0.04000000f,0.96000000f,0.85000000f,0.89000000f,-0.38000000f,-0.68000000f,0.02000000f,-0.88000000f,-0.67000000f,0.00000000f,0.92000000f,-0.88000000f,0.56000000f,0.46000000f,-0.72000000f,0.66000000f,0.80000000f,0.48000000f,0.19000000f,0.27000000f,0.15000000f,-0.77000000f,-0.45000000f,-0.94000000f,0.11000000f,0.37000000f,0.22000000f,-0.54000000f,-0.27000000f,-0.67000000f,-0.76000000f,-0.15000000f,-0.20000000f,0.93000000f,-0.05000000f,0.27000000f,0.20000000f,0.72000000f,-0.40000000f,-0.72000000f,-0.49000000f,0.81000000f,0.06000000f,0.83000000f,0.09000000f,0.08000000f,-0.65000000f,-0.26000000f,0.74000000f,-0.22000000f,-0.96000000f,-0.62000000f,-0.45000000f,0.60000000f,-0.10000000f,0.17000000f,0.12000000f,-0.17000000f,-0.74000000f,0.08000000f,0.12000000f,-0.64000000f,0.68000000f,0.92000000f,0.00000000f,-0.04000000f,0.31000000f,-0.83000000f,-0.47000000f,-0.55000000f,-0.89000000f,-0.42000000f,-0.96000000f,-0.62000000f,0.19000000f,-0.47000000f,0.19000000f,-0.46000000f,-0.70000000f,0.39000000f,-0.10000000f,-0.82000000f,0.19000000f,-0.06000000f,-0.47000000f,-0.03000000f,-0.46000000f,0.22000000f,-0.76000000f,0.34000000f,-0.80000000f,0.31000000f,0.41000000f,0.17000000f,0.90000000f,0.47000000f,0.85000000f,-0.94000000f,0.31000000f,-0.81000000f,0.24000000f,0.42000000f,0.20000000f,0.15000000f,-0.24000000f,-0.69000000f,-0.87000000f,-0.65000000f,0.09000000f,-0.25000000f,0.36000000f,-0.38000000f,0.04000000f,-0.80000000f,0.54000000f,0.82000000f,-0.95000000f,0.86000000f,0.40000000f,0.70000000f,-0.34000000f,-0.58000000f,-0.75000000f,-0.37000000f,0.39000000f,-0.62000000f,0.05000000f,-0.76000000f,-0.91000000f,0.65000000f,0.38000000f,0.76000000f,0.36000000f,-0.73000000f,0.06000000f,-0.01000000f,-0.05000000f,0.41000000f,-0.66000000f,0.75000000f,0.56000000f,0.55000000f,-0.09000000f,0.82000000f,0.49000000f,-0.35000000f,0.91000000f,-0.54000000f,0.63000000f,0.00000000f,-0.34000000f,-0.30000000f,-0.08000000f,0.90000000f,0.76000000f,0.41000000f,-0.48000000f,0.95000000f,0.61000000f,0.28000000f,0.41000000f,-0.86000000f,-0.79000000f,0.25000000f,-0.48000000f,0.35000000f,0.22000000f,-0.38000000f,0.33000000f,0.81000000f,-0.85000000f,-0.60000000f,0.87000000f,0.77000000f,0.13000000f,0.90000000f,0.46000000f,0.74000000f,-0.66000000f,0.31000000f,0.00000000f,0.87000000f,0.60000000f,-0.04000000f,0.30000000f,0.61000000f,0.93000000f,0.59000000f,0.19000000f,0.26000000f,-0.93000000f,0.24000000f,0.64000000f,-0.72000000f,0.62000000f,0.31000000f,-0.11000000f,-0.24000000f,0.00000000f,0.79000000f,0.98000000f,-0.43000000f,-0.60000000f,-0.10000000f,0.31000000f,0.38000000f,-0.21000000f,0.81000000f,-0.96000000f,-0.87000000f,-0.66000000f,0.92000000f,0.21000000f,0.53000000f,0.22000000f,-0.25000000f,-0.20000000f,0.02000000f,0.93000000f,0.39000000f,0.38000000f,0.71000000f,-0.38000000f,0.73000000f,0.58000000f,-0.81000000f,0.78000000f,-0.92000000f,-0.26000000f,0.39000000f,0.83000000f,0.85000000f,0.90000000f,-0.26000000f,0.12000000f,-0.40000000f,-0.17000000f,0.54000000f,0.85000000f,-0.38000000f,-0.68000000f,-0.77000000f,0.90000000f,0.08000000f,0.26000000f,0.93000000f,0.52000000f,-0.05000000f,-0.19000000f,-0.64000000f,0.96000000f,0.92000000f,-0.90000000f,0.77000000f,0.05000000f,-0.27000000f,0.76000000f,0.63000000f,-0.15000000f,0.14000000f,0.24000000f,-0.37000000f,-0.39000000f,0.62000000f,-0.68000000f,-0.46000000f,-0.21000000f,-0.72000000f,0.67000000f,-0.75000000f,-0.48000000f,-0.85000000f,-0.06000000f,-0.37000000f,0.07000000f,0.63000000f,0.94000000f,-0.28000000f,-0.88000000f,-0.16000000f,-0.20000000f,-0.23000000f,0.45000000f,-0.02000000f,-0.78000000f,0.76000000f,-0.63000000f,0.09000000f,-0.35000000f,0.91000000f,0.41000000f,-0.89000000f,0.67000000f,0.57000000f,-0.95000000f,0.41000000f,0.62000000f,-0.61000000f,0.17000000f,-0.24000000f,0.34000000f,0.11000000f,-0.25000000f,-0.29000000f,-0.22000000f,0.99000000f,0.73000000f,-0.54000000f,0.39000000f,-0.74000000f,0.32000000f,0.39000000f,-0.40000000f,0.18000000f,0.94000000f,0.94000000f,0.47000000f,0.27000000f,-0.61000000f,-0.62000000f,0.78000000f,0.77000000f,-0.91000000f,0.41000000f,0.67000000f,-0.17000000f,-0.16000000f,0.86000000f,0.50000000f,0.71000000f,0.68000000f,0.54000000f,0.68000000f,0.27000000f,0.35000000f,-0.84000000f,-0.04000000f,-0.06000000f,0.14000000f,0.64000000f,-0.61000000f,-0.51000000f,-0.17000000f,-0.22000000f,-0.55000000f,0.68000000f,0.52000000f,-0.38000000f,-0.18000000f,0.21000000f,0.34000000f,-0.29000000f,-0.85000000f,-0.88000000f,0.92000000f,0.44000000f,-0.02000000f,0.59000000f,-0.06000000f,-0.62000000f,-0.11000000f,-0.72000000f,-0.88000000f,-0.91000000f,-0.59000000f,-0.77000000f,0.67000000f,0.19000000f,0.34000000f,0.05000000f,0.77000000f,0.09000000f,-0.08000000f,-0.60000000f,0.03000000f,0.02000000f,0.00000000f,0.98000000f,0.75000000f,0.96000000f,0.05000000f,-0.09000000f,0.25000000f,-0.53000000f,0.26000000f,0.00000000f,0.26000000f,0.77000000f,0.74000000f,0.38000000f,0.27000000f,0.49000000f,-0.85000000f,0.67000000f,0.59000000f,0.45000000f,0.70000000f,-0.21000000f,0.78000000f,0.74000000f,-0.83000000f,0.85000000f,-0.38000000f,0.78000000f,-0.82000000f,-0.70000000f,-0.36000000f,0.21000000f,0.32000000f,-0.66000000f,-0.33000000f,0.50000000f,0.26000000f,0.59000000f,-0.13000000f,0.86000000f,-0.01000000f,0.52000000f,-0.65000000f,-0.02000000f,-0.82000000f,0.04000000f,0.64000000f,0.62000000f,0.94000000f,0.70000000f,-0.55000000f,-0.03000000f,0.38000000f,-0.45000000f,0.70000000f,-0.17000000f,0.76000000f,0.35000000f,-0.91000000f,-0.85000000f,0.72000000f,-0.18000000f,-0.09000000f,0.54000000f,-0.54000000f,-0.19000000f,-0.97000000f,-0.98000000f,-0.60000000f,0.38000000f,-0.36000000f,0.58000000f,0.56000000f,0.29000000f,0.16000000f,0.27000000f,-0.91000000f,0.53000000f,-0.06000000f,-0.42000000f,0.05000000f,-0.05000000f,0.25000000f,-0.46000000f,0.92000000f,0.37000000f,-0.87000000f,0.14000000f,0.98000000f,-0.33000000f,0.07000000f,0.98000000f,0.16000000f,-0.19000000f,-0.22000000f,-0.45000000f,0.61000000f,-0.77000000f,0.59000000f,0.32000000f,0.34000000f,0.85000000f,0.98000000f,-0.56000000f,-0.46000000f,-0.83000000f,0.64000000f,-0.78000000f,0.33000000f,0.38000000f,0.49000000f,0.90000000f,-0.73000000f,0.50000000f,0.51000000f,-0.25000000f,-0.80000000f,0.17000000f,-0.88000000f,-0.30000000f,0.57000000f,-0.48000000f,-0.83000000f,-0.05000000f,-0.27000000f,-0.28000000f,0.80000000f,-0.26000000f,-0.17000000f,-0.61000000f,0.25000000f,-0.47000000f,-0.65000000f,-0.29000000f,-0.43000000f,-0.88000000f,-0.02000000f,0.97000000f,0.04000000f,0.94000000f,-0.47000000f,0.46000000f,0.19000000f,-0.00000000f,0.70000000f,0.36000000f,0.93000000f,-0.47000000f,-0.85000000f,-0.44000000f,-0.26000000f,-0.44000000f,0.41000000f,-0.50000000f,-0.77000000f,-0.98000000f,0.30000000f,-0.75000000f,-0.53000000f,-0.77000000f,-0.89000000f,0.92000000f,-0.35000000f,0.22000000f,-0.14000000f,-0.50000000f,0.41000000f,0.78000000f,-0.89000000f,0.59000000f,-0.62000000f,-0.82000000f,0.50000000f,0.98000000f,0.85000000f,0.84000000f,0.63000000f,0.40000000f,0.04000000f,0.15000000f,-0.70000000f,0.95000000f,0.10000000f,0.25000000f,-0.02000000f,-0.70000000f,0.88000000f,-0.56000000f,0.56000000f,-0.58000000f,0.52000000f,-0.11000000f,0.02000000f,-0.35000000f,-0.62000000f,-0.15000000f,-0.06000000f,0.15000000f,0.45000000f,-0.99000000f,0.57000000f,-0.19000000f,0.11000000f,0.84000000f,0.02000000f,-0.05000000f,-0.53000000f,0.74000000f,-0.85000000f,-0.07000000f,0.33000000f,0.45000000f,-0.45000000f,-0.74000000f,0.07000000f,0.38000000f,0.60000000f,0.36000000f,0.57000000f,-0.27000000f,-0.54000000f,-0.01000000f,0.68000000f,-0.97000000f,0.67000000f,-0.06000000f,0.67000000f,0.01000000f,0.03000000f,0.65000000f,0.18000000f,-0.81000000f,0.23000000f,0.06000000f,0.45000000f,0.42000000f,-0.17000000f,0.76000000f,-0.27000000f,-0.29000000f,-0.17000000f,0.02000000f,-0.42000000f,-0.46000000f,-0.93000000f,-0.17000000f,-0.78000000f,-0.43000000f,-0.04000000f,-0.69000000f,0.29000000f,0.35000000f,-0.91000000f,-0.97000000f,0.09000000f,0.63000000f,-0.20000000f,0.15000000f,-0.63000000f,-0.96000000f,-0.95000000f,0.60000000f,0.91000000f,0.09000000f,-0.70000000f,0.50000000f,-0.07000000f,0.44000000f,0.01000000f,0.75000000f,0.73000000f,-0.73000000f,0.16000000f,-0.80000000f,0.52000000f,0.64000000f,-0.02000000f,-0.17000000f,0.04000000f,-0.50000000f,0.72000000f,-0.06000000f,0.80000000f,-0.50000000f,-0.78000000f,-0.37000000f,-0.16000000f,-0.06000000f,-0.73000000f,-0.68000000f,-0.45000000f,0.43000000f,-0.41000000f,-0.01000000f,-0.75000000f,0.41000000f,-0.94000000f,0.86000000f,-0.33000000f,0.65000000f,-0.82000000f,-0.53000000f,-0.19000000f,-0.21000000f,0.75000000f,0.39000000f,-0.52000000f,-0.82000000f,0.05000000f,0.29000000f,-0.84000000f,-0.03000000f,-0.05000000f,-0.92000000f,0.66000000f,0.14000000f,0.19000000f,-0.98000000f,0.09000000f,0.48000000f,0.96000000f,0.39000000f,0.67000000f,-0.49000000f,0.42000000f,0.30000000f,0.84000000f,-0.46000000f,-0.41000000f,0.92000000f,-0.93000000f,0.51000000f,-0.90000000f,-0.54000000f,-0.32000000f,0.18000000f,-0.83000000f,-0.05000000f,0.78000000f,-0.76000000f,0.76000000f,-0.50000000f,-0.94000000f,-0.58000000f,0.52000000f,0.45000000f,-0.17000000f,0.62000000f,0.48000000f,0.85000000f,0.11000000f,0.74000000f,0.99000000f,0.94000000f,-0.77000000f,0.44000000f,-0.89000000f,0.97000000f,-0.77000000f,0.16000000f,-0.35000000f,0.16000000f,-0.45000000f,0.50000000f,-0.96000000f,0.74000000f,-0.52000000f,-0.64000000f,0.13000000f,-0.21000000f,-0.03000000f,-0.16000000f,0.35000000f,0.53000000f,-0.82000000f,0.34000000f,0.52000000f,-0.59000000f,-0.17000000f,-0.53000000f,-0.88000000f,0.67000000f,0.13000000f,-0.21000000f,0.93000000f,-0.45000000f,-0.11000000f,-0.60000000f,0.84000000f,0.16000000f,0.76000000f,0.01000000f,0.89000000f,0.87000000f,0.04000000f,0.86000000f,0.20000000f,0.20000000f,0.61000000f,-0.21000000f,0.04000000f,0.26000000f,0.91000000f,-0.40000000f,0.00000000f,-0.26000000f,-0.12000000f,0.35000000f,0.21000000f,-0.87000000f,0.81000000f,-0.03000000f,-0.82000000f,0.19000000f,-0.71000000f,0.93000000f,0.39000000f,-0.70000000f,-0.97000000f,0.20000000f,0.92000000f,0.13000000f,-0.81000000f,0.88000000f,0.34000000f,-0.27000000f,-0.46000000f,0.78000000f,0.94000000f,-0.50000000f,0.57000000f,0.06000000f,-0.52000000f,0.14000000f,0.33000000f,-0.34000000f,-0.31000000f,-0.05000000f,-0.73000000f,0.13000000f,-0.63000000f,0.88000000f,-0.44000000f,-0.15000000f,0.11000000f,0.90000000f,-0.36000000f,0.51000000f,-0.38000000f,-0.64000000f,-0.21000000f,0.13000000f,0.89000000f,0.81000000f,-0.69000000f,0.15000000f,-0.67000000f,-0.89000000f,-0.47000000f,0.73000000f,-0.15000000f,-0.97000000f,-0.24000000f,-0.57000000f,0.91000000f,-0.64000000f,-0.30000000f,0.67000000f,-0.55000000f,-0.68000000f,0.98000000f,-0.98000000f,0.96000000f,-0.36000000f,-0.55000000f,0.11000000f,-0.73000000f,0.57000000f,0.73000000f,-0.46000000f,-0.11000000f,0.52000000f,0.48000000f,0.06000000f,0.43000000f,-0.41000000f,-0.43000000f,0.58000000f,-0.69000000f,0.57000000f,0.71000000f,-0.73000000f,0.19000000f,-0.45000000f,-0.24000000f,0.96000000f,0.61000000f,0.66000000f,-0.50000000f,-0.46000000f,0.32000000f,0.43000000f,0.15000000f,-0.93000000f,0.77000000f,0.60000000f,-0.27000000f,-0.37000000f,0.31000000f,-0.69000000f,0.20000000f,-0.22000000f,0.90000000f,0.51000000f,-0.56000000f,-0.50000000f,-0.55000000f,0.64000000f,-0.03000000f,0.70000000f,0.90000000f,-0.83000000f,-0.11000000f,-0.70000000f,0.82000000f,0.62000000f,0.66000000f,0.26000000f,0.24000000f,-0.55000000f,0.72000000f,0.42000000f,0.58000000f,0.60000000f,-0.02000000f,-0.29000000f,0.73000000f,-0.04000000f,-0.45000000f,0.01000000f,-0.04000000f,-0.59000000f,0.86000000f,-0.29000000f,0.82000000f,0.56000000f,-0.76000000f,-0.58000000f,0.77000000f,0.96000000f,-0.28000000f,0.71000000f,0.19000000f,-0.26000000f,0.98000000f,0.32000000f,-0.75000000f,-0.24000000f,0.85000000f,-0.26000000f,-0.73000000f,0.49000000f,0.26000000f,-0.74000000f,0.08000000f,-0.53000000f,-0.58000000f,0.52000000f,0.41000000f,0.06000000f,0.20000000f,0.47000000f,-0.41000000f,0.14000000f,0.00000000f,0.94000000f,0.76000000f,-0.41000000f,-0.90000000f,0.92000000f,-0.29000000f,0.52000000f,-0.94000000f,0.37000000f,0.87000000f,-0.06000000f,-0.44000000f,-0.33000000f,-0.04000000f,0.78000000f,-0.55000000f,-0.23000000f,0.25000000f,0.08000000f,0.41000000f,-0.48000000f,0.05000000f,-0.37000000f,0.39000000f,-0.74000000f,-0.89000000f,0.51000000f,-0.80000000f,-0.70000000f,-0.94000000f,0.32000000f,-0.43000000f,-0.75000000f,0.63000000f,-0.33000000f,-0.67000000f,-0.33000000f,0.18000000f,0.65000000f,0.34000000f,0.92000000f,0.08000000f,0.92000000f,0.04000000f,-0.33000000f,-0.59000000f,0.62000000f,0.85000000f,-0.49000000f,0.39000000f,-0.37000000f,-0.04000000f,-0.11000000f,0.23000000f,-0.41000000f,-0.84000000f,0.71000000f,-0.35000000f,0.88000000f,0.70000000f,0.94000000f,0.19000000f,0.85000000f,-0.35000000f,0.84000000f,-0.99000000f,-0.70000000f,0.57000000f,-0.78000000f,-0.96000000f,-0.55000000f,0.79000000f,0.67000000f,0.09000000f,-0.28000000f,-0.11000000f,0.22000000f,0.92000000f,0.79000000f,-0.70000000f,-0.62000000f,0.56000000f,-0.70000000f,-0.15000000f,0.18000000f,0.65000000f,0.97000000f,-0.87000000f,-0.04000000f,-0.75000000f,-0.65000000f,0.12000000f,-0.09000000f,0.85000000f,0.98000000f,0.58000000f,0.09000000f,-0.06000000f,0.70000000f,0.19000000f,-0.89000000f,-0.53000000f,-0.26000000f,-0.79000000f,-0.07000000f,0.19000000f,-0.68000000f,0.72000000f,0.87000000f,-0.10000000f,0.68000000f,-0.12000000f,-0.44000000f,0.26000000f,-0.30000000f,0.36000000f,-0.98000000f,-0.76000000f,-0.93000000f,0.93000000f,-0.68000000f,-0.39000000f,-0.06000000f,0.87000000f,-0.19000000f,0.60000000f,0.96000000f,0.91000000f,0.05000000f,-0.95000000f,0.13000000f,0.35000000f,0.87000000f,0.67000000f,-0.48000000f,0.26000000f,0.19000000f,0.74000000f,-0.53000000f,-0.54000000f,0.60000000f,0.08000000f,0.50000000f,0.18000000f,0.89000000f,0.89000000f,-0.19000000f,0.10000000f,0.72000000f,-0.13000000f,-0.38000000f,-0.45000000f,0.19000000f,0.33000000f,-0.01000000f,-0.34000000f,-0.28000000f,-0.42000000f,-0.39000000f,0.48000000f,0.11000000f,-0.66000000f,0.22000000f,-0.08000000f,0.71000000f,0.86000000f,0.02000000f,-0.02000000f,0.39000000f,-0.86000000f,-0.51000000f,0.50000000f,-0.42000000f,0.12000000f,0.44000000f,-0.47000000f,-0.43000000f,0.11000000f,-0.92000000f,-0.07000000f,0.83000000f,-0.69000000f,-0.28000000f,-0.13000000f,0.05000000f,-0.49000000f,0.07000000f,-0.34000000f,0.18000000f,-0.42000000f,0.57000000f,0.44000000f,0.57000000f,0.45000000f,0.97000000f,-0.57000000f,0.30000000f,-0.87000000f,-0.90000000f,-0.11000000f,-0.14000000f,0.89000000f,0.74000000f,0.35000000f,0.30000000f,-0.16000000f,-0.17000000f,0.23000000f,-0.63000000f,-0.95000000f,0.79000000f,-0.39000000f,0.38000000f,0.34000000f,-0.69000000f,-0.45000000f,-0.34000000f,0.96000000f,-0.02000000f,-0.77000000f,0.15000000f,0.37000000f,-0.61000000f,-0.83000000f,0.48000000f,-0.57000000f,0.52000000f,-0.71000000f,-0.02000000f,-0.83000000f,0.34000000f,0.29000000f,-0.05000000f,0.73000000f,-0.15000000f,0.89000000f,-0.17000000f,-0.81000000f,0.59000000f,0.11000000f,0.92000000f,0.31000000f,0.71000000f,-0.89000000f,-0.70000000f,0.31000000f,0.75000000f,-0.59000000f,-0.89000000f,-0.81000000f,-0.81000000f,0.23000000f,0.12000000f,0.26000000f,0.56000000f,0.01000000f,0.24000000f,-0.26000000f,0.61000000f,-0.58000000f,0.57000000f,-0.95000000f,-0.46000000f,0.78000000f,0.06000000f,-0.32000000f,0.88000000f,0.84000000f,-0.25000000f,-0.25000000f,-0.32000000f,0.48000000f,0.28000000f,-0.14000000f,0.48000000f,0.29000000f,0.67000000f,0.89000000f,0.97000000f,0.54000000f,-0.46000000f,0.19000000f,0.67000000f,-0.27000000f,0.19000000f,-0.64000000f,0.68000000f,0.30000000f,0.24000000f,-0.61000000f,-0.28000000f,-0.26000000f,0.32000000f,-0.30000000f,-0.72000000f,0.01000000f,0.19000000f,-0.35000000f,-0.56000000f,-0.02000000f,0.17000000f,0.45000000f,0.07000000f,-0.07000000f,-0.75000000f,0.21000000f,-0.19000000f,0.21000000f,0.89000000f,-0.13000000f,0.51000000f,0.70000000f,-0.00000000f,-0.92000000f,-0.64000000f,0.26000000f,-0.13000000f,0.69000000f,0.28000000f,-0.47000000f,-0.78000000f,-0.32000000f,0.01000000f,0.15000000f,0.36000000f,-0.28000000f,-0.35000000f,0.31000000f,-0.47000000f,0.53000000f,0.51000000f,0.23000000f,0.35000000f,0.97000000f,0.23000000f,-0.09000000f,0.81000000f,-0.26000000f,0.08000000f,-0.17000000f,-0.41000000f,0.78000000f,-0.51000000f,0.16000000f,-0.27000000f,0.05000000f,-0.30000000f,0.32000000f,0.51000000f,0.19000000f,0.94000000f,0.60000000f,0.10000000f,0.21000000f,0.49000000f,-0.69000000f,0.23000000f,-0.87000000f,0.64000000f,-0.36000000f,-0.53000000f,-0.63000000f,-0.05000000f,-0.95000000f,0.23000000f,0.85000000f,-0.32000000f,-0.11000000f,-0.89000000f,-0.13000000f,0.31000000f,0.28000000f,-0.69000000f,-0.37000000f,-0.47000000f,-0.79000000f,0.78000000f,-0.90000000f,0.91000000f,-0.86000000f,0.05000000f,-0.86000000f,-0.74000000f,0.19000000f,0.68000000f,-0.56000000f,0.04000000f,0.10000000f,-0.35000000f,0.47000000f,-0.79000000f,-0.28000000f,0.46000000f,-0.11000000f,0.60000000f,0.72000000f,-0.47000000f,0.03000000f,0.63000000f,0.75000000f,-0.84000000f,0.40000000f,-0.25000000f,-0.72000000f,0.63000000f,-0.22000000f,-0.96000000f,0.43000000f,-0.61000000f,0.73000000f,-0.58000000f,0.78000000f,-0.11000000f,-0.30000000f,-0.59000000f,-0.11000000f,0.01000000f,0.44000000f,0.35000000f,0.42000000f,-0.84000000f,0.13000000f,0.63000000f,0.37000000f,-0.45000000f,0.86000000f,0.90000000f,0.08000000f,-0.50000000f,0.89000000f,0.54000000f,0.50000000f,-0.17000000f,-0.89000000f,-0.72000000f,0.60000000f,-0.75000000f,0.75000000f,-0.79000000f,0.60000000f,0.56000000f,-0.67000000f,0.75000000f,-0.70000000f,-0.15000000f,-0.09000000f,-0.27000000f,0.44000000f,0.74000000f,-0.97000000f,-0.72000000f,0.47000000f,0.83000000f,0.60000000f,-0.97000000f,0.32000000f,0.24000000f,0.33000000f,0.65000000f,0.74000000f,-0.10000000f,0.19000000f,0.30000000f,-0.94000000f,0.07000000f,-0.04000000f,-0.47000000f,0.56000000f,-0.94000000f,0.01000000f,-0.65000000f,-0.18000000f,0.41000000f,-0.34000000f,-0.42000000f,0.56000000f,0.40000000f,-0.17000000f,-0.98000000f,0.62000000f,0.27000000f,-0.27000000f,0.25000000f,0.26000000f,0.41000000f,-0.17000000f,0.18000000f,-0.67000000f,-0.17000000f,-0.78000000f,0.52000000f,0.83000000f,0.04000000f,-0.14000000f,0.35000000f,0.73000000f,0.14000000f,0.72000000f,-0.26000000f,0.83000000f,-0.60000000f,-0.61000000f,0.89000000f,0.30000000f,0.07000000f,0.82000000f,-0.79000000f,-0.68000000f,-0.42000000f,-0.40000000f,-0.99000000f,-0.86000000f,0.48000000f,0.44000000f,0.50000000f,0.51000000f,0.16000000f,-0.77000000f,-0.15000000f,-0.70000000f,0.64000000f,0.97000000f,-0.71000000f,-0.54000000f,0.23000000f,-0.23000000f,0.83000000f,0.53000000f,-0.58000000f,0.62000000f,-0.32000000f,0.84000000f,-0.66000000f,0.95000000f,0.76000000f,0.92000000f,0.48000000f,-0.81000000f,0.43000000f,0.08000000f,-0.67000000f,0.46000000f,0.30000000f,0.23000000f,0.01000000f,0.55000000f,0.02000000f,0.81000000f,0.56000000f,-0.34000000f,-0.69000000f,0.05000000f,-0.99000000f,0.96000000f,-0.84000000f,0.34000000f,0.88000000f,0.01000000f,0.44000000f,-0.19000000f,0.28000000f,0.39000000f,-0.70000000f,-0.24000000f,-0.83000000f,0.44000000f,0.09000000f,-0.08000000f,0.42000000f,0.09000000f,0.24000000f,-0.86000000f,-0.21000000f,-0.90000000f,-0.87000000f,-0.91000000f,0.29000000f,-0.61000000f,-0.84000000f,0.36000000f,-0.40000000f,-0.45000000f,0.46000000f,0.05000000f,-0.55000000f,0.24000000f,0.99000000f,-0.20000000f,0.18000000f,-0.16000000f,0.45000000f,0.90000000f,0.38000000f,-0.37000000f,0.24000000f,0.90000000f,-0.55000000f,0.09000000f,-0.53000000f,-0.14000000f,0.66000000f,-0.59000000f,-0.70000000f,0.24000000f,0.17000000f,0.24000000f,-0.65000000f,0.76000000f,0.32000000f,0.49000000f,-0.65000000f,0.55000000f,-0.59000000f,-0.31000000f,0.78000000f,-0.67000000f,-0.29000000f,-0.60000000f,0.31000000f,0.26000000f,-0.02000000f,0.87000000f,-0.31000000f,0.95000000f,0.14000000f,0.76000000f,-0.89000000f,0.26000000f,0.74000000f,-0.41000000f,0.10000000f,-0.93000000f,-0.42000000f,-0.60000000f,-0.96000000f,-0.31000000f,0.90000000f,-0.20000000f,0.68000000f,-0.57000000f,0.86000000f,-0.71000000f,0.68000000f,0.26000000f,0.75000000f,0.79000000f,0.09000000f,0.94000000f,0.20000000f,0.11000000f,-0.27000000f,-0.06000000f,0.23000000f,0.43000000f,-0.44000000f,-0.87000000f,0.56000000f,-0.34000000f,0.37000000f,-0.49000000f,-0.47000000f,0.10000000f,0.53000000f,0.80000000f,0.53000000f,-0.44000000f,-0.92000000f,0.79000000f,-0.89000000f,0.50000000f,0.82000000f,-0.09000000f,-0.14000000f,-0.88000000f,0.16000000f,-0.15000000f,0.81000000f,-0.96000000f,0.99000000f,0.30000000f,0.09000000f,-0.84000000f,-0.61000000f,0.41000000f,-0.68000000f,0.54000000f,-0.86000000f,-0.87000000f,-0.55000000f,0.69000000f,0.67000000f,-0.43000000f,0.09000000f,0.47000000f,0.85000000f,-0.36000000f,0.27000000f,-0.10000000f,0.93000000f,0.34000000f,-0.77000000f,0.45000000f,-0.37000000f,0.71000000f,0.82000000f,-0.98000000f,0.42000000f,-0.07000000f,0.50000000f,0.66000000f,0.62000000f,0.13000000f,-0.53000000f,-0.83000000f,-0.38000000f,-0.03000000f,-0.49000000f,-0.10000000f,0.21000000f,0.89000000f,-0.90000000f,0.55000000f,-0.62000000f,0.42000000f,0.45000000f,-0.17000000f,-0.04000000f,-0.22000000f,-0.20000000f,-0.10000000f,0.42000000f,0.97000000f,-0.08000000f,-0.58000000f,-0.25000000f,0.02000000f,-0.08000000f,-0.38000000f,0.89000000f,-0.65000000f,0.46000000f,-0.35000000f,-0.54000000f,0.92000000f,0.03000000f,0.58000000f,-0.00000000f,-0.40000000f,-0.55000000f,0.99000000f,-0.46000000f,-0.17000000f,0.17000000f,-0.05000000f,-0.28000000f,0.57000000f,-0.15000000f,-0.41000000f,0.24000000f,0.64000000f,0.55000000f,-0.43000000f,-0.52000000f,0.79000000f,0.59000000f,0.23000000f,-0.41000000f,-0.87000000f,0.82000000f,-0.26000000f,-0.10000000f,-0.14000000f,-0.93000000f,-0.03000000f,-0.51000000f,0.17000000f,-0.53000000f,-0.27000000f,-0.64000000f,0.28000000f,-0.98000000f,0.03000000f,-0.06000000f,0.22000000f,0.65000000f,0.93000000f,0.18000000f,-0.60000000f,0.74000000f,0.13000000f,0.79000000f,-0.20000000f,-0.12000000f,0.08000000f,-0.93000000f,-0.82000000f,0.61000000f,-0.68000000f,0.17000000f,-0.66000000f,0.23000000f,-0.62000000f,-0.23000000f,0.65000000f,0.42000000f,0.29000000f,-0.46000000f,0.97000000f,-0.42000000f,0.85000000f,-0.18000000f,-0.68000000f,0.13000000f,-0.50000000f,0.83000000f,0.59000000f,-0.44000000f,-0.14000000f,0.74000000f,0.46000000f,-0.27000000f,0.38000000f,-0.06000000f,-0.34000000f,-0.52000000f,0.66000000f,0.95000000f,0.69000000f,-0.09000000f,-0.37000000f,-0.35000000f,0.57000000f,0.19000000f,-0.65000000f,-0.70000000f,0.43000000f,-0.01000000f,0.24000000f,0.83000000f,0.28000000f,0.37000000f,-0.18000000f,-0.50000000f,0.10000000f,0.80000000f,0.04000000f,0.11000000f,0.02000000f,-0.44000000f,0.30000000f,0.91000000f,-0.42000000f,0.04000000f,-0.48000000f,-0.25000000f,-0.79000000f,-0.20000000f,0.33000000f,0.22000000f,-0.55000000f,-0.73000000f,0.25000000f,0.53000000f,0.57000000f,0.40000000f,0.53000000f,-0.69000000f,0.86000000f,0.78000000f,0.90000000f,0.79000000f,-0.52000000f,-0.90000000f,-0.16000000f,0.88000000f,0.40000000f,0.75000000f,0.53000000f,-0.91000000f,-0.39000000f,-0.79000000f,-0.26000000f,0.77000000f,-0.56000000f,-0.82000000f,-0.17000000f,0.94000000f,-0.86000000f,0.57000000f,-0.61000000f,-0.86000000f,0.11000000f,0.90000000f,-0.50000000f,-0.38000000f,0.06000000f,0.46000000f,0.60000000f,-0.81000000f,-0.81000000f,0.64000000f,0.13000000f,0.41000000f,-0.12000000f,-0.44000000f,-0.66000000f,-0.86000000f,-0.08000000f,0.16000000f,0.18000000f,0.45000000f,0.84000000f,-0.18000000f,-0.09000000f,0.78000000f,0.67000000f,0.86000000f,0.08000000f,-0.06000000f,0.77000000f,-0.88000000f,0.45000000f,-0.77000000f,-0.06000000f,-0.48000000f,0.81000000f,-0.48000000f,-0.01000000f,0.75000000f,0.43000000f,-0.63000000f,0.65000000f,-0.52000000f,-0.72000000f,-0.56000000f,-0.05000000f,-0.63000000f,0.08000000f,-0.34000000f,-0.72000000f,-0.70000000f,0.84000000f,-0.84000000f,-0.64000000f,-0.80000000f,0.40000000f,0.19000000f,0.07000000f,0.49000000f,0.62000000f,0.17000000f,-0.79000000f,0.62000000f,-0.59000000f,-0.82000000f,-0.40000000f,-0.07000000f,-0.35000000f,0.42000000f,-0.23000000f,-0.92000000f,0.70000000f,0.12000000f,0.93000000f,0.58000000f,0.94000000f,-0.67000000f,-0.13000000f,-0.96000000f,-0.04000000f,-0.57000000f,0.67000000f,0.36000000f,-0.03000000f,0.51000000f,-0.87000000f,0.58000000f,0.85000000f,0.54000000f,-0.10000000f,-0.98000000f,0.64000000f,-0.33000000f,0.70000000f,0.94000000f,-0.53000000f,-0.44000000f,-0.39000000f,0.17000000f,0.34000000f,0.22000000f,0.50000000f,0.63000000f,-0.61000000f,0.15000000f,-0.82000000f,-0.20000000f,-0.79000000f,-0.24000000f,0.58000000f,-0.48000000f,-0.76000000f,0.39000000f,-0.85000000f,-0.52000000f,-0.90000000f,0.00000000f,0.06000000f,0.40000000f,-0.89000000f,0.17000000f,-0.30000000f,-0.79000000f,-0.86000000f,0.44000000f,0.55000000f,0.49000000f,0.54000000f,0.12000000f,0.72000000f,0.17000000f,0.65000000f,-0.74000000f,-0.33000000f,-0.82000000f,0.30000000f,0.24000000f,-0.39000000f,0.47000000f,0.79000000f,-0.31000000f,0.97000000f,-0.17000000f,0.57000000f,-0.63000000f,0.23000000f,0.43000000f,-0.55000000f,0.61000000f,-0.88000000f,0.51000000f,-0.93000000f,0.26000000f,0.34000000f,-0.32000000f,0.22000000f,-0.38000000f,-0.93000000f,0.76000000f,-0.90000000f,-0.02000000f,0.08000000f,-0.07000000f,-0.71000000f,0.61000000f,-0.80000000f,0.81000000f,-0.26000000f,-0.82000000f,-0.18000000f,0.98000000f,0.57000000f,0.17000000f,-0.93000000f,0.67000000f,-0.80000000f,-0.07000000f,-0.43000000f,0.66000000f,0.17000000f,-0.26000000f,0.35000000f,0.15000000f,0.83000000f,0.74000000f,-0.88000000f,0.01000000f,0.81000000f,-0.90000000f,-0.75000000f,0.59000000f,0.00000000f,-0.42000000f,-0.11000000f,-0.54000000f,-0.99000000f,0.49000000f,0.46000000f,0.45000000f,0.27000000f,0.57000000f,-0.88000000f,0.54000000f,-0.59000000f,0.66000000f,-0.71000000f,-0.79000000f,-0.51000000f,0.73000000f,0.53000000f,-0.00000000f,0.52000000f,-0.84000000f,-0.39000000f,0.58000000f,0.17000000f,-0.29000000f,-0.36000000f,-0.57000000f,-0.25000000f,0.36000000f,0.58000000f,-0.06000000f,-0.71000000f,-0.35000000f,-0.87000000f,-0.38000000f,-0.60000000f,-0.75000000f,0.30000000f,0.97000000f,0.55000000f,0.31000000f,0.61000000f,0.59000000f,-0.24000000f,-0.13000000f,-0.91000000f,-0.07000000f,-0.17000000f,-0.82000000f,-0.40000000f,0.68000000f,0.78000000f,0.96000000f,-0.70000000f,0.19000000f,-0.98000000f,0.83000000f,0.77000000f,-0.17000000f,0.26000000f,-0.98000000f,0.62000000f,-0.43000000f,0.74000000f,0.50000000f,-0.36000000f,-0.78000000f,-0.34000000f,0.42000000f,0.62000000f,0.43000000f,-0.17000000f,0.83000000f,0.25000000f,0.51000000f,0.07000000f,-0.40000000f,0.05000000f,-0.69000000f,0.44000000f,-0.88000000f,0.12000000f,0.53000000f,0.24000000f,0.16000000f,0.08000000f,-0.97000000f,0.00000000f,-0.58000000f,0.19000000f,0.59000000f,0.32000000f,-0.46000000f,0.65000000f,-0.27000000f,-0.30000000f,0.63000000f,-0.85000000f,-0.99000000f,0.76000000f,-0.62000000f,0.90000000f,0.68000000f,-0.98000000f,0.40000000f,0.15000000f,-0.34000000f,-0.03000000f,-0.64000000f,-0.03000000f,0.99000000f,0.14000000f,-0.48000000f,-0.91000000f,-0.29000000f,0.43000000f,-0.40000000f,0.36000000f,0.15000000f,0.73000000f,0.00000000f,-0.39000000f,-0.55000000f,0.15000000f,0.12000000f,0.48000000f,0.47000000f,0.47000000f,-0.25000000f,-0.45000000f,0.68000000f,0.48000000f,-0.92000000f,-0.23000000f,0.36000000f,0.78000000f,-0.20000000f,-0.15000000f,-0.14000000f,0.82000000f,-0.49000000f,-0.91000000f,-0.92000000f,-0.92000000f,-0.25000000f,-0.22000000f,0.77000000f,0.44000000f,-0.86000000f,0.16000000f,0.76000000f,-0.06000000f,0.73000000f,-0.94000000f,-0.99000000f,-0.14000000f,0.52000000f,-0.63000000f,-0.18000000f,0.77000000f,-0.70000000f,-0.92000000f,0.36000000f,0.06000000f,0.57000000f,-0.96000000f,0.10000000f,0.12000000f,-0.64000000f,0.38000000f,-0.75000000f,-0.09000000f,-0.81000000f,-0.17000000f,-0.82000000f,0.39000000f,0.16000000f,-0.49000000f,-0.82000000f,-0.95000000f,0.16000000f,0.20000000f,0.12000000f,0.40000000f,0.26000000f,0.94000000f,0.55000000f,-0.83000000f,0.06000000f,-0.04000000f,0.42000000f,-0.97000000f,0.49000000f,-0.15000000f,-0.18000000f,-0.40000000f,0.43000000f,-0.56000000f,0.33000000f,0.29000000f,-0.94000000f,-0.74000000f,-0.20000000f,0.47000000f,-0.08000000f,-0.95000000f,0.08000000f,-0.32000000f,0.75000000f,-0.67000000f,0.36000000f,-0.29000000f,-0.41000000f,0.85000000f,-0.15000000f,0.09000000f,0.26000000f,-0.40000000f,-0.64000000f,-0.43000000f,-0.45000000f,0.87000000f,-0.62000000f,-0.96000000f,0.26000000f,0.87000000f,-0.36000000f,-0.69000000f,-0.93000000f,-0.32000000f,0.09000000f,0.94000000f,-0.85000000f,0.31000000f,-0.59000000f,-0.08000000f,0.10000000f,0.33000000f,-0.97000000f,-0.54000000f,-0.50000000f,0.25000000f,0.26000000f,0.67000000f,0.30000000f,-0.98000000f,0.67000000f,-0.92000000f,-0.56000000f,-0.80000000f,-0.53000000f,-0.34000000f,-0.68000000f,-0.28000000f,0.59000000f,-0.56000000f,0.94000000f,-0.10000000f,-0.26000000f,-0.93000000f,0.54000000f,0.13000000f,0.23000000f,-0.81000000f,0.36000000f,-0.26000000f,0.90000000f,0.53000000f,-0.43000000f,0.68000000f,0.28000000f,0.31000000f,0.25000000f,0.45000000f,-0.21000000f,0.67000000f,-0.56000000f,-0.63000000f,0.05000000f,0.39000000f,0.81000000f,-0.37000000f,-0.92000000f,0.53000000f,0.40000000f,-0.31000000f,0.23000000f,-0.00000000f,-0.83000000f,0.46000000f,-0.54000000f,0.98000000f,0.09000000f,-0.54000000f,-0.89000000f,0.82000000f,-0.62000000f,-0.09000000f,0.02000000f,-0.24000000f,0.42000000f,-0.85000000f,0.15000000f,-0.59000000f,-0.73000000f,0.73000000f,-0.19000000f,-0.58000000f,-0.45000000f,0.98000000f,-0.12000000f,-0.24000000f,-0.49000000f,-0.49000000f,0.46000000f,0.59000000f,-0.74000000f,0.79000000f,0.22000000f,-0.11000000f,-0.64000000f,-0.68000000f,0.31000000f,0.28000000f,0.23000000f,0.77000000f,-0.36000000f,0.30000000f,0.68000000f,-0.51000000f,-0.52000000f,0.59000000f,0.06000000f,0.29000000f,0.69000000f,-0.11000000f,-0.35000000f,0.67000000f,-0.18000000f,-0.59000000f,-0.77000000f,-0.09000000f,0.30000000f,0.78000000f,-0.36000000f,0.06000000f,-0.08000000f,-0.25000000f,-0.69000000f,0.82000000f,0.64000000f,-0.41000000f,0.40000000f,-0.34000000f,0.01000000f,-0.26000000f,0.40000000f,-0.73000000f,0.84000000f,0.39000000f,-0.42000000f,-0.31000000f,-0.28000000f,-0.96000000f,-0.75000000f,-0.64000000f,0.23000000f,-0.76000000f,-0.42000000f,0.92000000f,0.52000000f,0.92000000f,-0.58000000f,0.69000000f,-0.15000000f,0.24000000f,-0.27000000f,-0.86000000f,-0.09000000f,-0.42000000f,-0.74000000f,-0.01000000f,-0.18000000f,-0.41000000f,0.64000000f,0.92000000f,-0.58000000f,0.66000000f,-0.59000000f,-0.64000000f,0.20000000f,-0.80000000f,-0.58000000f,-0.44000000f,-0.34000000f,-0.11000000f,-0.07000000f,0.18000000f,0.31000000f,-0.05000000f,0.90000000f,-0.10000000f,-0.59000000f,0.33000000f,0.89000000f,-0.78000000f,0.66000000f,0.59000000f,0.76000000f,0.52000000f,0.04000000f,0.37000000f,0.79000000f,0.40000000f,-0.97000000f,-0.41000000f,0.04000000f,0.10000000f,0.72000000f,-0.20000000f,-0.95000000f,0.69000000f,0.26000000f,-0.56000000f,0.88000000f,-0.09000000f,-0.73000000f,-0.61000000f,-0.88000000f,-0.53000000f,-0.61000000f,-0.52000000f,-0.29000000f,0.96000000f,-0.61000000f,-0.63000000f,0.18000000f,0.04000000f,-0.31000000f,0.47000000f,-0.72000000f,0.57000000f,-0.69000000f,-0.30000000f,0.32000000f,0.38000000f,-0.31000000f,-0.05000000f,0.83000000f,-0.17000000f,0.40000000f,0.33000000f,-0.27000000f,0.09000000f,0.85000000f,-0.99000000f,-0.96000000f,-0.57000000f,-0.56000000f,-0.73000000f,0.69000000f,0.42000000f,-0.89000000f,-0.24000000f,0.99000000f,-0.18000000f,0.91000000f,-0.66000000f,-0.63000000f,-0.24000000f,-0.24000000f,-0.63000000f,0.80000000f,0.96000000f,0.94000000f,0.59000000f,-0.76000000f,0.26000000f,0.74000000f,-0.89000000f,0.50000000f,0.16000000f,0.21000000f,-0.48000000f,0.32000000f,-0.33000000f,0.13000000f,-0.61000000f,-0.01000000f,0.63000000f,-0.62000000f,0.45000000f,-0.03000000f,-0.25000000f,0.33000000f,0.09000000f,-0.96000000f,0.00000000f,-0.63000000f,0.41000000f,0.48000000f,0.90000000f,-0.61000000f,0.98000000f,-0.02000000f,-0.45000000f,-0.28000000f,0.14000000f,-0.22000000f,-0.68000000f,-0.46000000f,0.64000000f,-0.95000000f,-0.31000000f,-0.24000000f,0.88000000f,0.34000000f,-0.34000000f,-0.42000000f,0.56000000f,-0.40000000f,-0.27000000f,-0.09000000f,-0.78000000f,0.84000000f,0.25000000f,0.34000000f,-0.74000000f,0.46000000f,-0.95000000f,0.05000000f,-0.72000000f,-0.15000000f,0.12000000f,0.49000000f,-0.74000000f,0.91000000f,0.65000000f,0.89000000f,-0.33000000f,-0.57000000f,-0.49000000f,-0.19000000f,-0.08000000f,-0.36000000f,0.74000000f,-0.48000000f,0.07000000f,0.09000000f,-0.48000000f,-0.16000000f,0.65000000f,-0.29000000f,-0.13000000f,0.04000000f,0.37000000f,-0.66000000f,0.06000000f,-0.38000000f,0.10000000f,0.07000000f,0.92000000f,-0.41000000f,-0.17000000f,0.99000000f,0.36000000f,-0.38000000f,0.21000000f,0.66000000f,-0.25000000f,-0.32000000f,-0.31000000f,0.85000000f,-0.47000000f,-0.38000000f,-0.40000000f,-0.10000000f,0.08000000f,0.27000000f,-0.50000000f,-0.31000000f,0.96000000f,0.51000000f,-0.83000000f,0.63000000f,0.65000000f,-0.70000000f,0.09000000f,-0.48000000f,0.48000000f,0.22000000f,0.72000000f,-0.90000000f,-0.06000000f,0.19000000f,-0.16000000f,0.41000000f,-0.69000000f,-0.16000000f,-0.71000000f,0.78000000f,-0.83000000f,-0.76000000f,-0.20000000f,-0.81000000f,0.64000000f,-0.49000000f,0.08000000f,-0.15000000f,-0.33000000f,0.77000000f,0.51000000f,-0.24000000f,-0.08000000f,0.82000000f,-0.58000000f,0.64000000f,0.49000000f,-0.18000000f,0.43000000f,-0.54000000f,-0.85000000f,-0.24000000f,-0.71000000f,-0.90000000f,0.69000000f,-0.73000000f,0.72000000f,0.47000000f,-0.42000000f,-0.75000000f,-0.51000000f,0.80000000f,0.18000000f,-0.08000000f,-0.41000000f,0.61000000f,-0.31000000f,-0.39000000f,0.97000000f,-0.32000000f,0.51000000f,-0.61000000f,-0.35000000f,0.10000000f,-0.08000000f,-0.28000000f,-0.04000000f,0.94000000f,0.71000000f,0.61000000f,-0.13000000f,0.21000000f,0.96000000f,-0.61000000f,0.85000000f,-0.55000000f,0.96000000f,-0.18000000f,-0.05000000f,-0.85000000f,-0.60000000f,0.92000000f,-0.88000000f,-0.71000000f,-0.40000000f,0.14000000f,0.69000000f,-0.21000000f,0.63000000f,0.86000000f,0.44000000f,-0.25000000f,-0.23000000f,-0.05000000f,-0.29000000f,0.89000000f,-0.53000000f,-0.06000000f,0.03000000f,0.36000000f,-0.83000000f,0.79000000f,-0.40000000f,-0.10000000f,0.90000000f,-0.92000000f,-0.49000000f,-0.38000000f,-0.43000000f,0.02000000f,0.98000000f,-0.99000000f,0.13000000f,-0.75000000f,-0.99000000f,-0.37000000f,0.52000000f,-0.20000000f,-0.56000000f,-0.38000000f,0.80000000f,-0.45000000f,0.13000000f,0.71000000f,-0.60000000f,-0.46000000f,-0.90000000f,0.83000000f,-0.01000000f,-0.47000000f,0.08000000f,-0.52000000f,-0.27000000f,-0.83000000f,-0.06000000f,-0.26000000f,-0.43000000f,0.02000000f,0.71000000f,0.26000000f,-0.39000000f,-0.20000000f,-0.12000000f,0.95000000f,0.15000000f,0.71000000f,-0.82000000f,-0.91000000f,-0.98000000f,0.99000000f,0.60000000f,-0.20000000f,-0.89000000f,-0.33000000f,-0.22000000f,0.25000000f,0.04000000f,0.74000000f,-0.92000000f,-0.19000000f,-0.23000000f,0.84000000f,0.34000000f,0.83000000f,0.41000000f,0.77000000f,0.24000000f,0.32000000f,-0.31000000f,-0.36000000f,-0.08000000f,0.58000000f,-0.45000000f,0.63000000f,-0.28000000f,0.15000000f,-0.19000000f,0.58000000f,0.67000000f,-0.21000000f,-0.79000000f,0.23000000f,-0.33000000f,-0.05000000f,-0.60000000f,-0.09000000f,-0.98000000f,0.73000000f,-0.36000000f,0.18000000f,0.70000000f,0.86000000f,-0.18000000f,-0.36000000f,0.06000000f,-0.30000000f,-0.48000000f,-0.08000000f,0.70000000f,0.57000000f,0.00000000f,0.95000000f,0.69000000f,-0.70000000f,-0.98000000f,-0.30000000f,-0.78000000f,-0.63000000f,-0.91000000f,0.83000000f,0.72000000f,0.45000000f,-0.50000000f,-0.30000000f,-0.41000000f,-0.17000000f,-0.39000000f,-0.65000000f,-0.97000000f,0.25000000f,-0.03000000f,-0.38000000f,-0.24000000f,0.42000000f,0.27000000f,-0.18000000f,0.50000000f,-0.04000000f,-0.33000000f,-0.54000000f,0.69000000f,-0.97000000f,0.45000000f,0.03000000f,0.78000000f,0.83000000f,-0.91000000f,-0.37000000f,-0.55000000f,-0.28000000f,-0.15000000f,-0.19000000f,0.38000000f,0.11000000f,-0.39000000f,-0.63000000f,0.84000000f,-0.19000000f,0.61000000f,-0.36000000f,0.34000000f,-0.54000000f,-0.68000000f,-0.68000000f,0.47000000f,-0.08000000f,0.79000000f,0.21000000f,-0.50000000f,-0.18000000f,-0.40000000f,0.80000000f,0.00000000f,-0.40000000f,-0.90000000f,-0.52000000f,-0.21000000f,-0.10000000f,0.99000000f,0.97000000f,-0.71000000f,-0.98000000f,-0.80000000f,0.20000000f,0.73000000f,0.95000000f,-0.47000000f,0.52000000f,0.98000000f,0.01000000f,0.16000000f,-0.50000000f,0.43000000f,0.51000000f,0.81000000f,0.69000000f,-0.34000000f,-0.49000000f,-0.92000000f,0.68000000f,0.79000000f,-0.56000000f,-0.46000000f,0.69000000f,0.51000000f,-0.45000000f,-0.30000000f,0.95000000f,-0.46000000f,-0.88000000f,-0.92000000f,-0.69000000f,0.91000000f,-0.62000000f,-0.58000000f,0.70000000f,0.51000000f,-0.70000000f,-0.87000000f,-0.01000000f,-0.64000000f,-0.22000000f,-0.81000000f,-0.65000000f,-0.55000000f,-0.06000000f,0.84000000f,0.54000000f,0.29000000f,-0.85000000f,-0.99000000f,0.87000000f,0.98000000f,0.61000000f,0.64000000f,0.25000000f,0.87000000f,0.89000000f,0.48000000f,-0.25000000f,-0.78000000f,-0.77000000f,0.49000000f,0.53000000f,-0.06000000f,-0.93000000f,0.21000000f,0.92000000f,-0.51000000f,0.55000000f,0.83000000f,0.14000000f,0.17000000f,0.42000000f,-0.09000000f,0.52000000f,0.95000000f,0.46000000f,0.81000000f,-0.75000000f,0.88000000f,0.99000000f,-0.53000000f,-0.93000000f,-0.46000000f,-0.67000000f,0.61000000f,-0.02000000f,-0.57000000f,-0.58000000f,0.09000000f,0.29000000f,0.27000000f,0.73000000f,0.90000000f,-0.72000000f,-0.68000000f,-0.00000000f,0.64000000f,0.24000000f,0.18000000f,0.73000000f,0.03000000f,-0.06000000f,-0.84000000f,-0.07000000f,-0.25000000f,-0.61000000f,0.71000000f,-0.10000000f,-0.27000000f,-0.83000000f,0.24000000f,-0.11000000f,-0.97000000f,-0.99000000f,0.13000000f,-0.84000000f,-0.51000000f,0.85000000f,-0.11000000f,-0.67000000f,0.45000000f,0.95000000f,0.76000000f,-0.63000000f,0.95000000f,-0.68000000f,-0.15000000f,0.77000000f,-0.44000000f,0.10000000f,0.11000000f,0.76000000f,0.56000000f,0.48000000f,0.35000000f,-0.11000000f,-0.16000000f,-0.00000000f,0.63000000f,-0.01000000f,0.51000000f,0.13000000f,-0.28000000f,-0.01000000f,0.58000000f,0.89000000f,-0.69000000f,0.43000000f,-0.90000000f,0.28000000f,0.86000000f,0.93000000f,0.22000000f,-0.16000000f,0.47000000f,0.33000000f,-0.56000000f,0.12000000f,-0.26000000f,-0.72000000f,-0.51000000f,0.24000000f,-0.19000000f,-0.88000000f,-0.70000000f,0.45000000f,-0.93000000f,-0.61000000f,-0.76000000f,-0.49000000f,0.27000000f,-0.11000000f,-0.06000000f,0.10000000f,0.04000000f,0.62000000f,0.51000000f,-0.27000000f,-0.19000000f,0.90000000f,-0.39000000f,0.18000000f,-0.10000000f,0.84000000f,0.53000000f,-0.71000000f,0.17000000f,0.29000000f,0.72000000f,-0.80000000f,0.27000000f,0.57000000f,-0.53000000f,-0.95000000f,0.88000000f,0.84000000f,0.09000000f,0.11000000f,-0.13000000f,-0.64000000f,-0.36000000f,-0.48000000f,0.82000000f,0.08000000f,-0.35000000f,0.03000000f,0.76000000f,0.14000000f,0.79000000f,-0.94000000f,-0.35000000f,0.89000000f,-0.25000000f,-0.48000000f,0.37000000f,0.82000000f,-0.30000000f,0.57000000f,0.94000000f,0.47000000f,0.17000000f,-0.39000000f,-0.62000000f,0.65000000f,0.37000000f,0.41000000f,-0.85000000f,0.74000000f,-0.59000000f,0.44000000f,-0.63000000f,0.45000000f,0.90000000f,0.99000000f,-0.73000000f,-0.03000000f,0.00000000f,0.49000000f,-0.29000000f,-0.63000000f,0.59000000f,0.24000000f,0.66000000f,-0.05000000f,0.06000000f,-0.95000000f,0.06000000f,0.62000000f,-0.83000000f,-0.46000000f,-0.25000000f,-0.35000000f,-0.91000000f,0.07000000f,-0.77000000f,0.54000000f,-0.82000000f,0.82000000f,0.68000000f,0.49000000f,-0.63000000f,-0.36000000f,-0.31000000f,-0.48000000f,-0.95000000f,-0.55000000f,-0.62000000f,0.52000000f,0.26000000f,-0.39000000f,0.45000000f,-0.09000000f,-0.07000000f,0.56000000f,0.32000000f,0.37000000f,0.57000000f,-0.83000000f,-0.90000000f,0.03000000f,0.47000000f,0.97000000f,0.26000000f,0.37000000f,-0.24000000f,0.72000000f,0.38000000f,-0.73000000f,0.86000000f,0.88000000f,-0.59000000f,0.17000000f,-0.80000000f,-0.86000000f,0.64000000f,0.83000000f,-0.15000000f,-0.31000000f,-0.87000000f,0.92000000f,-0.24000000f,0.45000000f,0.42000000f,-0.61000000f,-0.37000000f,0.02000000f,0.82000000f,0.84000000f,0.06000000f,0.67000000f,-0.12000000f,0.11000000f,0.94000000f,-0.81000000f,0.75000000f,-0.04000000f,0.72000000f,-0.50000000f,0.30000000f,0.90000000f,0.93000000f,-0.05000000f,-0.10000000f,-0.02000000f,0.51000000f,0.03000000f,-0.67000000f,0.18000000f,0.37000000f,0.65000000f,-0.20000000f,-0.45000000f,0.52000000f,0.46000000f,0.95000000f,-0.78000000f,0.20000000f,0.54000000f,0.92000000f,-0.64000000f,0.51000000f,0.63000000f,-0.58000000f,-0.50000000f,-0.40000000f,0.82000000f,0.15000000f,0.15000000f,0.21000000f,0.01000000f,0.89000000f,0.10000000f,-0.05000000f,-0.92000000f,-0.18000000f,0.30000000f,0.00000000f,-0.12000000f,0.71000000f,-0.58000000f,0.15000000f,0.17000000f,-0.31000000f,-0.36000000f,0.95000000f,-0.21000000f,-0.82000000f,-0.31000000f,-0.78000000f,-0.17000000f,0.47000000f,-0.41000000f,0.90000000f,0.75000000f,0.28000000f,0.57000000f,0.16000000f,-0.73000000f,0.66000000f,-0.27000000f,0.76000000f,-0.74000000f,0.35000000f,-0.21000000f,0.39000000f,-0.70000000f,-0.31000000f,-0.14000000f,-0.85000000f,0.80000000f,0.58000000f,-0.43000000f,0.02000000f,0.01000000f,0.31000000f,-0.89000000f,-0.06000000f,0.04000000f,0.28000000f,-0.00000000f,0.74000000f,0.32000000f,0.66000000f,-0.98000000f,-0.53000000f,-0.40000000f,-0.94000000f,0.35000000f,0.53000000f,-0.57000000f,0.60000000f,0.86000000f,-0.94000000f,-0.67000000f,0.95000000f,-0.35000000f,-0.79000000f,0.56000000f,0.10000000f,-0.28000000f,-0.53000000f,-0.27000000f,0.25000000f,0.83000000f,0.77000000f,0.18000000f,-0.33000000f,0.49000000f,-0.64000000f,0.57000000f,0.80000000f,0.98000000f,0.56000000f,0.03000000f,0.58000000f,0.76000000f,0.87000000f,0.61000000f,0.91000000f,-0.30000000f,-0.60000000f,-0.76000000f,-0.30000000f,0.23000000f,0.06000000f,0.03000000f,0.72000000f,0.11000000f,-0.23000000f,-0.21000000f,-0.20000000f,-0.44000000f,0.78000000f,0.15000000f,0.87000000f,-0.31000000f,0.43000000f,-0.05000000f,-0.16000000f,0.04000000f,-0.79000000f,0.87000000f,0.09000000f,0.32000000f,-0.58000000f,0.65000000f,-0.62000000f,0.23000000f,0.20000000f,-0.29000000f,0.88000000f,-0.58000000f,-0.03000000f,-0.33000000f,-0.48000000f,0.27000000f,0.47000000f,0.81000000f,0.91000000f,-0.41000000f,0.67000000f,-0.94000000f,0.31000000f,0.25000000f,-0.00000000f,0.99000000f,-0.06000000f,0.22000000f,-0.19000000f,0.53000000f,-0.62000000f,-0.63000000f,0.28000000f,-0.49000000f,0.37000000f,-0.69000000f,0.59000000f,-0.30000000f,0.57000000f,0.52000000f,0.55000000f,-0.67000000f,-0.15000000f,0.71000000f,0.11000000f,-0.34000000f,-0.06000000f,0.10000000f,0.70000000f,0.98000000f,0.52000000f,0.16000000f,0.87000000f,-0.62000000f,-0.58000000f,0.57000000f,0.65000000f,-0.35000000f,-0.31000000f,0.96000000f,0.21000000f,0.31000000f,-0.82000000f,0.14000000f,0.57000000f,0.24000000f,-0.26000000f,0.77000000f,-0.09000000f,0.20000000f,0.40000000f,0.12000000f,-0.17000000f,0.65000000f,0.64000000f,-0.63000000f,-0.75000000f,0.50000000f,0.31000000f,-0.06000000f,-0.19000000f,-0.63000000f,0.69000000f,-0.54000000f,0.27000000f,0.95000000f,-0.44000000f,0.18000000f,-0.91000000f,-0.02000000f,0.77000000f,-0.66000000f,-0.33000000f,-0.20000000f,-0.22000000f,0.65000000f,0.31000000f,-0.00000000f,-0.26000000f,0.07000000f,0.05000000f,-0.47000000f,-0.52000000f,-0.06000000f,0.49000000f,0.65000000f,0.54000000f,0.10000000f,-0.10000000f,-0.56000000f,-0.87000000f,0.35000000f,-0.51000000f,0.90000000f,-0.04000000f,-0.90000000f,-0.16000000f,-0.75000000f,-0.06000000f,-0.04000000f,-0.11000000f,0.44000000f,0.73000000f,0.72000000f,0.80000000f,0.73000000f,-0.95000000f,0.83000000f,0.72000000f,0.46000000f,-0.94000000f,-0.56000000f,0.00000000f,-0.41000000f,-0.66000000f,0.56000000f,0.92000000f,-0.23000000f,-0.32000000f,-0.16000000f,-0.04000000f,-0.37000000f,-0.81000000f,-0.29000000f,-0.79000000f,-0.45000000f,-0.37000000f,0.65000000f,-0.07000000f,-0.97000000f,-0.93000000f,0.15000000f,0.01000000f,-0.90000000f,0.05000000f,-0.63000000f,0.43000000f,-0.67000000f,0.04000000f,0.86000000f,-0.64000000f,0.80000000f,0.66000000f,-0.02000000f,0.84000000f,-0.46000000f,0.19000000f,-0.42000000f,-0.20000000f,0.86000000f,0.12000000f,0.32000000f,-0.72000000f,-0.40000000f,-0.32000000f,-0.26000000f,0.85000000f,-0.40000000f,0.15000000f,-0.69000000f,-0.77000000f,-0.48000000f,-0.10000000f,-0.16000000f,0.61000000f,-0.12000000f,-0.76000000f,0.21000000f,-0.15000000f,-0.15000000f,0.00000000f,-0.31000000f,0.74000000f,-0.12000000f,0.75000000f,-0.31000000f,0.89000000f,0.75000000f,-0.17000000f,-0.58000000f,-0.33000000f,-0.72000000f,-0.43000000f,-0.36000000f,-0.74000000f,-0.17000000f,-0.61000000f,-0.53000000f,0.62000000f,-0.24000000f,-0.37000000f,-0.16000000f,-0.74000000f,0.39000000f,-0.41000000f,0.57000000f,-0.64000000f,-0.51000000f,0.65000000f,0.40000000f,0.65000000f,-0.04000000f,-0.08000000f,0.30000000f,-0.86000000f,0.37000000f,-0.49000000f,0.24000000f,0.36000000f,-0.66000000f,0.53000000f,-0.42000000f,0.47000000f,-0.10000000f,-0.41000000f,-0.92000000f,-0.88000000f,0.90000000f,0.59000000f,0.00000000f,0.70000000f,-0.55000000f,0.45000000f,0.81000000f,0.42000000f,-0.81000000f,-0.90000000f,-0.66000000f,0.47000000f,-0.49000000f,-0.21000000f,-0.71000000f,-0.62000000f,0.20000000f,-0.90000000f,-0.49000000f,-0.83000000f,-0.94000000f,0.16000000f,0.04000000f,0.84000000f,-0.49000000f,-0.23000000f,-0.75000000f,-0.13000000f,0.91000000f,0.36000000f,-0.51000000f,0.56000000f,-0.26000000f,-0.34000000f,-0.27000000f,0.13000000f,0.45000000f,-0.89000000f,0.69000000f,-0.42000000f,0.49000000f,-0.93000000f,0.46000000f,0.68000000f,0.63000000f,-0.86000000f,-0.26000000f,0.14000000f,-0.29000000f,0.80000000f,-0.74000000f,0.73000000f,0.19000000f,-0.26000000f,0.01000000f,-0.71000000f,-0.54000000f,-0.64000000f,-0.59000000f,-0.37000000f,0.76000000f,0.15000000f,0.90000000f,-0.28000000f,0.59000000f,0.16000000f,-0.55000000f,0.48000000f,-0.49000000f,-0.43000000f,0.56000000f,-0.30000000f,0.12000000f,0.08000000f,-0.28000000f,0.78000000f,0.73000000f,-0.06000000f,0.13000000f,0.31000000f,-0.30000000f,0.90000000f,0.39000000f,-0.77000000f,-0.89000000f,0.91000000f,-0.09000000f,0.76000000f,0.30000000f,-0.80000000f,0.31000000f,-0.94000000f,0.88000000f,-0.38000000f,-0.10000000f,0.02000000f,-0.93000000f,-0.27000000f,0.83000000f,-0.33000000f,-0.55000000f,0.04000000f,-0.31000000f,-0.21000000f,-0.38000000f,-0.04000000f,-0.21000000f,-0.58000000f,0.57000000f,-0.50000000f,0.45000000f,-0.88000000f,-0.95000000f,0.66000000f,-0.15000000f,-0.65000000f,0.04000000f,-0.91000000f,-0.02000000f,-0.40000000f,0.60000000f,0.17000000f,0.07000000f,-0.11000000f,-0.55000000f,0.36000000f,0.47000000f,0.09000000f,0.37000000f,0.75000000f,-0.98000000f,-0.39000000f,0.79000000f,0.61000000f,-0.75000000f,0.51000000f,-0.49000000f,-0.99000000f,-0.72000000f,-0.56000000f,0.97000000f,-0.42000000f,0.06000000f,-0.14000000f,-0.96000000f,-0.28000000f,-0.48000000f,0.99000000f,0.64000000f,-0.12000000f,0.63000000f,-0.95000000f,-0.09000000f,-0.81000000f,0.83000000f,0.99000000f,-0.01000000f,0.17000000f,0.03000000f,-0.52000000f,0.20000000f,0.77000000f,-0.42000000f,0.96000000f,0.79000000f,-0.64000000f,-0.29000000f,-0.84000000f,-0.79000000f,0.83000000f,-0.88000000f,-0.24000000f,0.22000000f,0.55000000f,0.16000000f,-0.85000000f,0.49000000f,0.61000000f,-0.79000000f,-0.75000000f,0.27000000f,0.36000000f,0.36000000f,-0.98000000f,-0.34000000f,0.13000000f,0.38000000f,-0.25000000f,0.74000000f,0.08000000f,0.46000000f,0.13000000f,0.32000000f,0.78000000f,0.44000000f,0.11000000f,-0.57000000f,-0.34000000f,-0.92000000f,-0.03000000f,-0.74000000f,-0.06000000f,0.30000000f,-0.51000000f,0.06000000f,0.74000000f,0.13000000f,0.34000000f,0.05000000f,0.81000000f,0.43000000f,0.80000000f,-0.77000000f,-0.54000000f,0.59000000f,-0.05000000f,0.14000000f,0.29000000f,-0.70000000f,-0.12000000f,0.03000000f,-0.04000000f,-0.07000000f,-0.84000000f,0.86000000f,0.87000000f,-0.24000000f,0.02000000f,0.71000000f,0.31000000f,-0.62000000f,0.62000000f,-0.65000000f,0.26000000f,0.47000000f,0.57000000f,0.84000000f,0.32000000f,0.54000000f,-0.50000000f,0.93000000f,-0.91000000f,0.35000000f,-0.74000000f,-0.56000000f,-0.46000000f,-0.78000000f,-0.60000000f,-0.89000000f,-0.88000000f,-0.16000000f,-0.83000000f,-0.63000000f,0.59000000f,0.85000000f,0.32000000f,0.74000000f,0.84000000f,-0.83000000f,-0.46000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.95000000f,0.99000000f,-0.87000000f,-0.28000000f,0.66000000f,-0.58000000f,0.20000000f,-0.17000000f,-0.95000000f,0.23000000f,0.86000000f,-0.81000000f,0.93000000f,0.38000000f,0.49000000f,0.68000000f,-0.91000000f,-0.58000000f,-0.41000000f,0.31000000f,0.23000000f,0.92000000f,0.71000000f,0.33000000f,0.18000000f,-0.33000000f,0.64000000f,0.75000000f,-0.72000000f,0.70000000f,-0.49000000f,-0.49000000f,-0.18000000f,-0.59000000f,-0.23000000f,0.71000000f,0.42000000f,-0.53000000f,-0.83000000f,-0.04000000f,-0.75000000f,-0.77000000f,-0.59000000f,0.53000000f,-0.30000000f,0.22000000f,-0.78000000f,0.64000000f,-0.64000000f,-0.37000000f,0.79000000f,0.72000000f,-0.06000000f,0.94000000f,0.93000000f,-0.75000000f,0.90000000f,-0.79000000f,0.96000000f,0.28000000f,-0.74000000f,0.70000000f,-0.81000000f,0.18000000f,-0.96000000f,0.84000000f,-0.18000000f,0.05000000f,-0.23000000f,0.26000000f,-0.85000000f,-0.12000000f,0.50000000f,0.12000000f,-0.94000000f,0.64000000f,0.86000000f,0.81000000f,0.89000000f,-0.62000000f,0.74000000f,-0.19000000f,-0.78000000f,0.67000000f,-0.04000000f,0.36000000f,0.62000000f,-0.02000000f,-0.49000000f,0.72000000f,-0.02000000f,0.42000000f,-0.78000000f,0.79000000f,0.26000000f,-0.63000000f,-0.31000000f,-0.38000000f,-0.37000000f,-0.43000000f,-0.97000000f,0.27000000f,-0.34000000f,-0.59000000f,-0.07000000f,0.44000000f,-0.62000000f,-0.64000000f,-0.09000000f,-0.70000000f,-0.11000000f,-0.89000000f,-0.35000000f,0.49000000f,-0.73000000f,-0.89000000f,0.76000000f,0.90000000f,0.04000000f,0.44000000f,0.58000000f,0.18000000f,-0.06000000f,0.68000000f,0.14000000f,-0.48000000f,-0.15000000f,-0.53000000f,-0.31000000f,0.37000000f,0.71000000f,-0.10000000f,-0.83000000f,-0.88000000f,-0.26000000f,-0.88000000f,0.82000000f,-0.04000000f,0.84000000f,-0.92000000f,-0.10000000f,0.00000000f,0.18000000f,0.21000000f,0.74000000f,-0.25000000f,0.88000000f,-0.75000000f,-0.47000000f,0.72000000f,-0.54000000f,0.04000000f,0.10000000f,0.29000000f,0.20000000f,0.08000000f,-0.17000000f,0.71000000f,-0.46000000f,0.96000000f,-0.21000000f,0.10000000f,0.58000000f,0.65000000f,0.06000000f,0.58000000f,0.68000000f,0.27000000f,-0.07000000f,-0.05000000f,0.97000000f,0.25000000f,-0.42000000f,-0.59000000f,0.42000000f,0.87000000f,-0.06000000f,-0.61000000f,0.06000000f,0.84000000f,0.58000000f,-0.68000000f,0.65000000f,0.40000000f,-0.32000000f,-0.38000000f,0.93000000f,0.58000000f,-0.65000000f,0.73000000f,0.96000000f,-0.97000000f,0.08000000f,0.80000000f,0.39000000f,-0.21000000f,-0.47000000f,0.56000000f,-0.17000000f,-0.46000000f,-0.52000000f,-0.27000000f,0.76000000f,0.60000000f,-0.41000000f,-0.73000000f,0.93000000f,-0.06000000f,0.30000000f,-0.64000000f,-0.02000000f,-0.23000000f,0.08000000f,0.72000000f,-0.58000000f,-0.29000000f,-0.49000000f,0.85000000f,-0.42000000f,0.40000000f,-0.37000000f,-0.74000000f,0.51000000f,-0.52000000f,-0.52000000f,-0.63000000f,-0.66000000f,0.81000000f,-0.39000000f,0.33000000f,-0.46000000f,-0.76000000f,-0.06000000f,0.45000000f,-0.05000000f,-0.64000000f,0.42000000f,0.76000000f,-0.55000000f,-0.98000000f,0.78000000f,-0.82000000f,-0.25000000f,0.24000000f,0.35000000f,0.68000000f,-0.68000000f,0.28000000f,0.60000000f,-0.50000000f,0.20000000f,0.15000000f,-0.92000000f,0.09000000f,-0.99000000f,0.49000000f,0.24000000f,0.69000000f,-0.50000000f,0.47000000f,0.94000000f,-0.30000000f,0.96000000f,-0.45000000f,-0.57000000f,0.25000000f,0.77000000f,0.82000000f,-0.88000000f,-0.33000000f,-0.32000000f,-0.65000000f,-0.85000000f,0.83000000f,0.06000000f,0.71000000f,0.53000000f,-0.42000000f,0.25000000f,-0.50000000f,-0.02000000f,0.76000000f,-0.13000000f,0.39000000f,-0.99000000f,-0.20000000f,0.20000000f,-0.80000000f,-0.59000000f,-0.59000000f,0.13000000f,0.57000000f,0.55000000f,0.44000000f,-0.11000000f,0.30000000f,-0.16000000f,0.78000000f,-0.91000000f,0.02000000f,0.68000000f,0.59000000f,-0.28000000f,-0.79000000f,0.48000000f,-0.17000000f,-0.86000000f,-0.68000000f,0.96000000f,-0.61000000f,-0.69000000f,0.95000000f,0.81000000f,-0.89000000f,0.02000000f,0.97000000f,-0.13000000f,-0.10000000f,0.07000000f,0.67000000f,0.30000000f,-0.26000000f,-0.07000000f,-0.55000000f,-0.58000000f,-0.81000000f,0.06000000f,0.65000000f,0.97000000f,-0.29000000f,0.85000000f,-0.49000000f,-0.01000000f,-0.90000000f,0.23000000f,-0.39000000f,-0.71000000f,0.28000000f,0.38000000f,-0.26000000f,0.19000000f,-0.94000000f,0.38000000f,-0.80000000f,0.15000000f,-0.59000000f,0.18000000f,0.87000000f,-0.54000000f,-0.65000000f,0.47000000f,0.74000000f,0.43000000f,0.30000000f,0.99000000f,-0.66000000f,0.89000000f,-0.72000000f,0.25000000f,0.73000000f,-0.26000000f,-0.60000000f,0.10000000f,0.55000000f,-0.86000000f,-0.96000000f,-0.54000000f,-0.81000000f,0.84000000f,0.67000000f,0.34000000f,0.98000000f,-0.50000000f,-0.64000000f,-0.40000000f,-0.61000000f,-0.72000000f,-0.68000000f,0.80000000f,-0.15000000f,-0.99000000f,-0.79000000f,0.71000000f,-0.66000000f,-0.11000000f,0.06000000f,0.24000000f,-0.58000000f,0.60000000f,-0.21000000f,0.24000000f,-0.75000000f,-0.12000000f,-0.91000000f,-0.67000000f,-0.19000000f,-0.47000000f,-0.87000000f,0.40000000f,0.42000000f,0.69000000f,-0.61000000f,-0.98000000f,-0.63000000f,0.97000000f,0.05000000f,-0.19000000f,-0.47000000f,0.41000000f,-0.45000000f,0.94000000f,0.85000000f,-0.10000000f,0.09000000f,0.00000000f,0.20000000f,0.49000000f,-0.81000000f,0.31000000f,0.94000000f,-0.41000000f,-0.71000000f,0.99000000f,0.82000000f,-0.34000000f,-0.08000000f,0.85000000f,0.61000000f,-0.93000000f,-0.54000000f,0.37000000f,-0.90000000f,-0.67000000f,-0.02000000f,-0.43000000f,-0.52000000f,-0.58000000f,-0.61000000f,0.81000000f,0.53000000f,0.86000000f,-0.09000000f,0.26000000f,0.23000000f,-0.76000000f,-0.58000000f,-0.90000000f,0.33000000f,0.82000000f,-0.44000000f,0.18000000f,-0.18000000f,0.72000000f,0.74000000f,-0.84000000f,0.83000000f,-0.26000000f,-0.32000000f,-0.99000000f,-0.07000000f,0.57000000f,0.71000000f,-0.64000000f,0.56000000f,-0.08000000f,-0.78000000f,0.83000000f,-0.60000000f,-0.54000000f,-0.65000000f,0.26000000f,0.67000000f,0.10000000f,0.72000000f,-0.12000000f,0.71000000f,0.90000000f,-0.37000000f,-0.55000000f,-0.42000000f,-0.89000000f,0.87000000f,0.70000000f,0.47000000f,0.07000000f,0.46000000f,0.48000000f,0.53000000f,-0.95000000f,0.82000000f,0.35000000f,0.48000000f,0.99000000f,-0.64000000f,0.45000000f,-0.33000000f,0.94000000f,0.93000000f,0.55000000f,0.95000000f,0.23000000f,0.71000000f,0.42000000f,0.48000000f,-0.45000000f,0.54000000f,0.38000000f,0.58000000f,0.94000000f,0.82000000f,0.65000000f,-0.51000000f,0.53000000f,-0.47000000f,-0.78000000f,-0.51000000f,0.67000000f,0.72000000f,-0.20000000f,0.09000000f,0.41000000f,0.69000000f,0.21000000f,0.95000000f,-0.26000000f,0.23000000f,-0.04000000f,-0.30000000f,-0.18000000f,-0.78000000f,0.06000000f,0.04000000f,0.83000000f,-0.97000000f,-0.55000000f,-0.86000000f,-0.99000000f,-0.12000000f,0.17000000f,-0.50000000f,-0.77000000f,-0.20000000f,-0.47000000f,-0.95000000f,0.05000000f,-0.37000000f,0.88000000f,0.09000000f,-0.54000000f,-0.64000000f,-0.72000000f,0.57000000f,0.16000000f,-0.31000000f,-0.28000000f,-0.36000000f,0.71000000f,-0.82000000f,0.23000000f,0.88000000f,0.69000000f,0.99000000f,-0.99000000f,0.94000000f,0.24000000f,-0.45000000f,0.61000000f,0.85000000f,-0.92000000f,0.96000000f,0.98000000f,0.34000000f,0.03000000f,-0.25000000f,0.15000000f,-0.71000000f,0.48000000f,-0.02000000f,-0.29000000f,0.34000000f,0.48000000f,-0.14000000f,-0.46000000f,-0.32000000f,0.67000000f,0.04000000f,-0.90000000f,-0.82000000f,0.44000000f,-0.46000000f,-0.33000000f,0.63000000f,-0.46000000f,0.16000000f,0.02000000f,0.57000000f,-0.02000000f,0.50000000f,0.26000000f,0.51000000f,-0.15000000f,0.25000000f,0.07000000f,-0.59000000f,-0.87000000f,0.64000000f,-0.92000000f,0.05000000f,0.79000000f,0.14000000f,-0.34000000f,-0.77000000f,0.72000000f,0.53000000f,-0.42000000f,0.95000000f,-0.86000000f,-0.35000000f,0.90000000f,0.36000000f,0.25000000f,0.63000000f,0.59000000f,-0.32000000f,-0.95000000f,-0.98000000f,-0.84000000f,-0.56000000f,0.65000000f,-0.81000000f,-0.06000000f,-0.45000000f,-0.60000000f,-0.84000000f,0.09000000f,0.77000000f,0.17000000f,0.11000000f,-0.57000000f,-0.67000000f,-0.23000000f,-0.98000000f,0.12000000f,0.32000000f,0.35000000f,0.37000000f,-0.81000000f,-0.07000000f,-0.21000000f,0.72000000f,-0.35000000f,-0.02000000f,0.33000000f,0.58000000f,-0.52000000f,0.17000000f,-0.49000000f,0.30000000f,-0.30000000f,-0.78000000f,-0.38000000f,0.25000000f,0.14000000f,-0.20000000f,0.75000000f,-0.51000000f,0.46000000f,0.15000000f,-0.07000000f,0.19000000f,-0.47000000f,0.70000000f,-0.47000000f,-0.03000000f,0.14000000f,-0.25000000f,0.67000000f,0.83000000f,0.22000000f,-0.80000000f,0.15000000f,0.88000000f,0.42000000f,0.76000000f,-0.53000000f,0.85000000f,0.89000000f,0.92000000f,-0.73000000f,-0.88000000f,0.05000000f,0.09000000f,0.19000000f,0.55000000f,0.74000000f,-0.08000000f,0.41000000f,0.06000000f,-0.35000000f,0.66000000f,0.05000000f,0.36000000f,0.28000000f,0.77000000f,0.65000000f,0.94000000f,-0.28000000f,-0.31000000f,0.47000000f,-0.62000000f,-0.99000000f,0.90000000f,0.70000000f,0.88000000f,-0.68000000f,0.69000000f,-0.23000000f,-0.01000000f,0.97000000f,0.87000000f,0.55000000f,0.07000000f,0.59000000f,-0.16000000f,-0.05000000f,0.28000000f,-0.48000000f,0.56000000f,-0.64000000f,0.22000000f,0.55000000f,-0.66000000f,0.29000000f,0.12000000f,0.73000000f,-0.98000000f,-0.13000000f,-0.39000000f,0.33000000f,0.95000000f,0.38000000f,-0.34000000f,0.73000000f,0.25000000f,0.63000000f,0.13000000f,-0.18000000f,-0.23000000f,-0.68000000f,0.39000000f,0.65000000f,-0.08000000f,-0.96000000f,0.35000000f,-0.06000000f,0.81000000f,-0.34000000f,-0.91000000f,0.96000000f,-0.75000000f,0.61000000f,0.81000000f,-0.21000000f,0.21000000f,-0.89000000f,-0.13000000f,-0.92000000f,-0.11000000f,-0.25000000f,0.28000000f,0.31000000f,0.83000000f,0.96000000f,-0.13000000f,0.54000000f,0.95000000f,0.16000000f,0.49000000f,0.12000000f,0.13000000f,0.20000000f,0.37000000f,0.34000000f,0.87000000f,-0.11000000f,-0.28000000f,-0.05000000f,0.72000000f,-0.27000000f,0.44000000f,0.84000000f,-0.03000000f,0.69000000f,-0.79000000f,0.63000000f,0.81000000f,0.88000000f,0.98000000f,0.51000000f,-0.20000000f,0.54000000f,0.73000000f,-0.95000000f,-0.61000000f,0.33000000f,0.26000000f,0.51000000f,0.46000000f,0.43000000f,-0.04000000f,-0.29000000f,0.77000000f,0.34000000f,-0.43000000f,0.48000000f,0.42000000f,-0.14000000f,0.89000000f,-0.93000000f,-0.40000000f,0.77000000f,-0.04000000f,0.85000000f,0.98000000f,-0.26000000f,0.05000000f,-0.24000000f,-0.22000000f,-0.50000000f,-0.82000000f,-0.42000000f,0.63000000f,0.79000000f,-0.84000000f,-0.60000000f,0.20000000f,-0.41000000f,0.86000000f,0.51000000f,-0.17000000f,-0.20000000f,0.94000000f,-0.89000000f,-0.51000000f,-0.35000000f,0.73000000f,-0.53000000f,0.09000000f,0.49000000f,-0.72000000f,-0.47000000f,-0.72000000f,-0.58000000f,-0.28000000f,0.05000000f,-0.08000000f,-0.86000000f,-0.69000000f,-0.22000000f,-0.32000000f,0.17000000f,-0.58000000f,-0.49000000f,-0.62000000f,0.19000000f,-0.28000000f,-0.40000000f,-0.61000000f,0.75000000f,-0.87000000f,-0.96000000f,-0.47000000f,-0.04000000f,0.64000000f,0.80000000f,0.90000000f,-0.57000000f,0.40000000f,0.34000000f,-0.31000000f,-0.94000000f,0.79000000f,0.12000000f,0.55000000f,0.62000000f,0.44000000f,0.58000000f,-0.10000000f,-0.07000000f,0.35000000f,0.73000000f,0.42000000f,-0.05000000f,-0.16000000f,0.89000000f,-0.05000000f,-0.22000000f,-0.25000000f,-0.81000000f,-0.57000000f,0.78000000f,0.49000000f,0.06000000f,0.87000000f,0.61000000f,-0.01000000f,0.77000000f,0.63000000f,-0.15000000f,-0.17000000f,-0.42000000f,-0.59000000f,0.64000000f,0.85000000f,-0.70000000f,0.03000000f,-0.58000000f,0.25000000f,0.31000000f,0.72000000f,0.26000000f,-0.83000000f,-0.37000000f,-0.10000000f,-0.30000000f,-0.75000000f,-0.54000000f,0.13000000f,0.10000000f,0.75000000f,-0.66000000f,-0.73000000f,-0.41000000f,0.15000000f,0.51000000f,-0.72000000f,0.76000000f,0.98000000f,-0.41000000f,0.61000000f,-0.67000000f,-0.82000000f,-0.90000000f,0.57000000f,0.57000000f,0.82000000f,0.50000000f,0.74000000f,-0.06000000f,-0.19000000f,-0.49000000f,0.71000000f,0.82000000f,0.19000000f,-0.04000000f,0.55000000f,0.03000000f,0.59000000f,-0.65000000f,0.99000000f,0.74000000f,0.81000000f,-0.59000000f,-0.60000000f,0.73000000f,0.47000000f,0.73000000f,0.72000000f,-0.33000000f,0.29000000f,0.66000000f,0.72000000f,-0.21000000f,-0.90000000f,0.69000000f,0.40000000f,0.67000000f,0.07000000f,-0.39000000f,0.34000000f,0.94000000f,0.56000000f,0.61000000f,0.24000000f,-0.76000000f,0.53000000f,-0.15000000f,-0.70000000f,0.93000000f,0.42000000f,-0.12000000f,-0.50000000f,0.67000000f,-0.55000000f,0.73000000f,0.46000000f,-0.74000000f,0.90000000f,-0.68000000f,0.57000000f,-0.62000000f,-0.19000000f,-0.57000000f,0.37000000f,0.81000000f,-0.84000000f,0.73000000f,0.20000000f,-0.89000000f,-0.55000000f,0.01000000f,-0.12000000f,0.24000000f,-0.14000000f,-0.35000000f,0.99000000f,0.40000000f,0.11000000f,-0.83000000f,-0.25000000f,0.84000000f,0.89000000f,-0.51000000f,0.75000000f,0.44000000f,0.45000000f,-0.18000000f,-0.70000000f,0.83000000f,0.02000000f,-0.84000000f,0.46000000f,-0.83000000f,-0.02000000f,0.10000000f,0.44000000f,0.53000000f,-0.96000000f,0.70000000f,0.55000000f,0.37000000f,0.84000000f,-0.64000000f,-0.06000000f,0.94000000f,-0.58000000f,-0.83000000f,0.92000000f,0.11000000f,0.34000000f,-0.67000000f,-0.42000000f,-0.27000000f,-0.55000000f,-0.97000000f,-0.92000000f,-0.81000000f,-0.21000000f,-0.40000000f,0.73000000f,0.49000000f,0.60000000f,-0.56000000f,0.95000000f,-0.09000000f,-0.20000000f,-0.88000000f,-0.09000000f,-0.70000000f,-0.30000000f,-0.85000000f,-0.39000000f,0.94000000f,0.06000000f,0.06000000f,-0.09000000f,0.05000000f,0.61000000f,0.51000000f,0.60000000f,-0.78000000f,-0.89000000f,0.92000000f,-0.03000000f,-0.03000000f,0.41000000f,-0.10000000f,0.97000000f,0.67000000f,0.92000000f,0.70000000f,-0.22000000f,0.63000000f,0.77000000f,-0.46000000f,0.25000000f,0.17000000f,0.00000000f,-0.14000000f,-0.87000000f,0.49000000f,0.99000000f,0.42000000f,-0.67000000f,0.61000000f,0.34000000f,0.25000000f,-0.71000000f,-0.18000000f,0.24000000f,-0.27000000f,0.24000000f,-0.06000000f,-0.05000000f,-0.08000000f,0.70000000f,-0.19000000f,-0.29000000f,0.41000000f,0.78000000f,0.08000000f,-0.88000000f,0.39000000f,0.33000000f,-0.50000000f,0.00000000f,-0.35000000f,0.56000000f,-0.85000000f,0.06000000f,-0.02000000f,-0.91000000f,-0.58000000f,0.18000000f,0.66000000f,0.46000000f,0.96000000f,0.90000000f,0.74000000f,-0.17000000f,-0.80000000f,-0.38000000f,-0.01000000f,0.25000000f,-0.53000000f,0.21000000f,0.26000000f,-0.63000000f,-0.78000000f,0.32000000f,0.42000000f,-0.60000000f,-0.31000000f,-0.93000000f,0.36000000f,0.41000000f,0.47000000f,-0.41000000f,0.03000000f,0.37000000f,-0.93000000f,-0.75000000f,-0.10000000f,-0.44000000f,0.74000000f,0.96000000f,0.47000000f,0.69000000f,0.44000000f,0.07000000f,0.28000000f,-0.84000000f,-0.00000000f,-0.65000000f,0.23000000f,-0.17000000f,0.65000000f,-0.05000000f,-0.32000000f,-0.98000000f,0.67000000f,-0.45000000f,0.16000000f,0.26000000f,0.81000000f,0.81000000f,-0.72000000f,-0.23000000f,0.57000000f,-0.87000000f,0.76000000f,-0.57000000f,0.14000000f,-0.44000000f,0.31000000f,0.80000000f,-0.73000000f,0.83000000f,0.00000000f,-0.54000000f,0.10000000f,0.42000000f,0.54000000f,-0.18000000f,0.56000000f,0.35000000f,0.44000000f,-0.52000000f,0.69000000f,0.69000000f,0.94000000f,0.39000000f,0.96000000f,0.58000000f,-0.71000000f,0.98000000f,-0.92000000f,-0.11000000f,0.98000000f,0.90000000f,0.79000000f,0.63000000f,0.84000000f,-0.95000000f,0.61000000f,-0.52000000f,-0.10000000f,0.33000000f,0.10000000f,0.56000000f,0.74000000f,0.11000000f,-0.27000000f,-0.36000000f,0.88000000f,0.33000000f,-0.30000000f,0.67000000f,0.98000000f,0.19000000f,0.56000000f,0.85000000f,0.13000000f,-0.65000000f,-0.67000000f,0.86000000f,-0.03000000f,0.83000000f,-0.50000000f,-0.54000000f,-0.65000000f,-0.64000000f,-0.73000000f,-0.60000000f,0.68000000f,-0.71000000f,-0.36000000f,-0.81000000f,-0.27000000f,-0.06000000f,-0.04000000f,0.47000000f,-0.99000000f,-0.35000000f,-0.89000000f,0.55000000f,-0.39000000f,-0.94000000f,0.32000000f,-0.23000000f,-0.53000000f,0.37000000f,-0.17000000f,0.85000000f,0.27000000f,-0.10000000f,-0.81000000f,-0.31000000f,-0.22000000f,-0.30000000f,-0.29000000f,0.93000000f,0.08000000f,0.98000000f,0.32000000f,0.97000000f,0.86000000f,0.67000000f,0.39000000f,0.50000000f,0.06000000f,0.25000000f,-0.73000000f,-0.88000000f,-0.02000000f,0.88000000f,0.85000000f,0.38000000f,-0.29000000f,-0.99000000f,0.30000000f,-0.06000000f,0.14000000f,-0.02000000f,0.09000000f,-0.62000000f,0.41000000f,-0.46000000f,0.90000000f,0.06000000f,-0.78000000f,-0.10000000f,0.97000000f,0.66000000f,-0.96000000f,0.46000000f,0.12000000f,0.84000000f,0.89000000f,-0.28000000f,-0.65000000f,-0.71000000f,0.04000000f,0.34000000f,-0.98000000f,-0.27000000f,0.21000000f,0.13000000f,-0.56000000f,0.56000000f,0.71000000f,-0.55000000f,0.14000000f,0.81000000f,0.03000000f,-0.19000000f,0.82000000f,0.48000000f,-0.42000000f,0.73000000f,0.04000000f,0.48000000f,-0.10000000f,-0.78000000f,0.75000000f,-0.89000000f,-0.02000000f,0.60000000f,0.15000000f,-0.88000000f,0.01000000f,0.93000000f,-0.59000000f,0.43000000f,0.57000000f,0.14000000f,0.96000000f,0.75000000f,0.58000000f,0.69000000f,-0.92000000f,0.14000000f,0.94000000f,-0.42000000f,0.54000000f,-0.73000000f,0.91000000f,-0.89000000f,-0.95000000f,0.41000000f,0.26000000f,-0.46000000f,-0.64000000f,-0.65000000f,0.53000000f,-0.61000000f,-0.95000000f,-0.41000000f,-0.28000000f,-0.78000000f,-0.01000000f,-0.55000000f,0.69000000f,0.60000000f,-0.29000000f,0.81000000f,0.74000000f,0.39000000f,0.58000000f,-0.65000000f,0.37000000f,-0.88000000f,-0.11000000f,0.08000000f,-0.78000000f,0.01000000f,-0.46000000f,-0.12000000f,0.38000000f,-0.63000000f,0.66000000f,-0.33000000f,-0.51000000f,-0.16000000f,0.32000000f,0.40000000f,-0.03000000f,-0.35000000f,0.49000000f,-0.52000000f,-0.26000000f,-0.99000000f,-0.94000000f,0.18000000f,0.94000000f,0.37000000f,0.94000000f,0.85000000f,0.36000000f,-0.00000000f,0.36000000f,-0.94000000f,-0.47000000f,0.92000000f,0.75000000f,-0.29000000f,-0.82000000f,0.95000000f,0.29000000f,-0.47000000f,0.12000000f,-0.96000000f,0.06000000f,-0.56000000f,-0.20000000f,0.47000000f,0.15000000f,0.08000000f,-0.20000000f,-0.20000000f,-0.31000000f,0.44000000f,-0.83000000f,-0.03000000f,0.75000000f,-0.87000000f,0.90000000f,-0.39000000f,-0.06000000f,0.56000000f,0.03000000f,-0.03000000f,-0.37000000f,-0.08000000f,-0.25000000f,0.15000000f,-0.90000000f,0.29000000f,-0.94000000f,0.20000000f,0.71000000f,0.14000000f,-0.70000000f,0.98000000f,-0.77000000f,-0.97000000f,-0.43000000f,0.25000000f,-0.30000000f,0.28000000f,-0.04000000f,0.19000000f,0.40000000f,0.56000000f,-0.18000000f,-0.66000000f,0.66000000f,-0.21000000f,-0.48000000f,0.76000000f,0.87000000f,-0.63000000f,-0.12000000f,0.22000000f,-0.48000000f,-0.41000000f,-0.87000000f,-0.16000000f,-0.53000000f,0.25000000f,-0.31000000f,0.45000000f,-0.25000000f,0.46000000f,0.35000000f,0.64000000f,-0.45000000f,0.84000000f,-0.70000000f,0.19000000f,-0.96000000f,-0.68000000f,0.92000000f,-0.07000000f,0.10000000f,0.89000000f,0.25000000f,0.70000000f,0.52000000f,0.63000000f,-0.36000000f,0.11000000f,-0.39000000f,0.77000000f,0.59000000f,-0.01000000f,-0.60000000f,0.66000000f,-0.46000000f,0.64000000f,-0.21000000f,0.37000000f,-0.55000000f,0.27000000f,0.09000000f,-0.35000000f,0.07000000f,0.80000000f,-0.51000000f,-0.80000000f,-0.04000000f,0.59000000f,0.59000000f,-0.96000000f,-0.12000000f,-0.28000000f,0.71000000f,0.17000000f,-0.36000000f,0.35000000f,0.99000000f,-0.30000000f,-0.98000000f,0.52000000f,-0.62000000f,0.69000000f,-0.48000000f,0.34000000f,0.30000000f,-0.78000000f,-0.84000000f,0.46000000f,-0.36000000f,0.31000000f,-0.61000000f,-0.71000000f,0.46000000f,-0.97000000f,-0.97000000f,-0.18000000f,-0.42000000f,-0.22000000f,-0.42000000f,-0.08000000f,0.84000000f,-0.48000000f,-0.22000000f,-0.95000000f,-0.42000000f,-0.45000000f,0.17000000f,-0.58000000f,0.82000000f,-0.81000000f,0.23000000f,0.07000000f,-0.16000000f,0.93000000f,-0.82000000f,-0.78000000f,0.13000000f,-0.80000000f,-0.24000000f,-0.00000000f,0.75000000f,-0.59000000f,0.01000000f,0.71000000f,0.53000000f,0.02000000f,-0.97000000f,0.81000000f,-0.35000000f,0.15000000f,-0.32000000f,-0.11000000f,0.79000000f,-0.08000000f,0.82000000f,-0.99000000f,-0.68000000f,-0.48000000f,-0.08000000f,-0.03000000f,0.64000000f,0.48000000f,-0.69000000f,-0.82000000f,0.98000000f,0.86000000f,-0.32000000f,-0.86000000f,-0.08000000f,0.25000000f,-0.37000000f,-0.56000000f,0.04000000f,-0.53000000f,0.52000000f,0.89000000f,-0.26000000f,0.79000000f,0.97000000f,0.46000000f,0.07000000f,-0.99000000f,-0.91000000f,-0.03000000f,0.81000000f,0.06000000f,-0.56000000f,-0.68000000f,0.14000000f,-0.15000000f,0.33000000f,-0.26000000f,0.94000000f,0.76000000f,0.70000000f,0.70000000f,-0.88000000f,0.20000000f,0.02000000f,-0.32000000f,0.75000000f,0.34000000f,0.47000000f,0.63000000f,0.01000000f,-0.80000000f,0.31000000f,0.01000000f,-0.25000000f,0.20000000f,0.40000000f,-0.95000000f,0.52000000f,0.24000000f,-0.46000000f,0.61000000f,0.58000000f,-0.97000000f,-0.90000000f,-0.24000000f,0.18000000f,0.16000000f,0.56000000f,0.21000000f,-0.71000000f,-0.96000000f,-0.86000000f,0.04000000f,-0.11000000f,-0.09000000f,0.07000000f,-0.01000000f,-0.58000000f,-0.12000000f,-0.43000000f,-0.95000000f,0.45000000f,-0.87000000f,-0.07000000f,0.31000000f,0.02000000f,-0.22000000f,-0.62000000f,0.48000000f,0.19000000f,0.42000000f,-0.23000000f,0.70000000f,-0.56000000f,-0.19000000f,-0.54000000f,-0.15000000f,0.78000000f,-0.39000000f,-0.95000000f,0.36000000f,0.12000000f,-0.31000000f,0.93000000f,0.16000000f,0.92000000f,0.58000000f,-0.80000000f,0.76000000f,-0.16000000f,0.15000000f,0.93000000f,-0.18000000f,0.11000000f,0.97000000f,0.36000000f,-0.29000000f,0.56000000f,0.67000000f,-0.46000000f,-0.94000000f,0.64000000f,-0.87000000f,-0.72000000f,-0.86000000f,0.64000000f,0.34000000f,-0.00000000f,0.03000000f,-0.48000000f,-0.11000000f,0.09000000f,-0.89000000f,-0.85000000f,0.71000000f,-0.36000000f,-0.28000000f,0.04000000f,-0.88000000f,0.91000000f,0.19000000f,0.37000000f,-0.58000000f,0.29000000f,0.17000000f,0.33000000f,-0.62000000f,-0.32000000f,0.83000000f,0.00000000f,-0.95000000f,-0.03000000f,-0.80000000f,0.64000000f,0.10000000f,-0.11000000f,0.46000000f,0.54000000f,0.64000000f,-0.17000000f,-0.31000000f,-0.46000000f,0.85000000f,-0.42000000f,-0.27000000f,0.45000000f,0.06000000f,-0.11000000f,-0.20000000f,-0.30000000f,0.29000000f,0.73000000f,0.43000000f,-0.95000000f,0.46000000f,-0.04000000f,-0.51000000f,0.30000000f,0.82000000f,-0.93000000f,-0.86000000f,0.33000000f,-0.39000000f,-0.07000000f,-0.67000000f,-0.86000000f,-0.61000000f,0.48000000f,-0.35000000f,-0.57000000f,0.31000000f,0.05000000f,-0.72000000f,0.46000000f,-0.62000000f,-0.81000000f,-0.74000000f,0.59000000f,0.79000000f,0.77000000f,-0.31000000f,-0.38000000f,-0.85000000f,0.70000000f,0.39000000f,0.57000000f,0.52000000f,-0.08000000f,0.49000000f,-0.49000000f,-0.53000000f,0.61000000f,-0.21000000f,-0.04000000f,0.03000000f,0.54000000f,-0.49000000f,0.95000000f,-0.45000000f,-0.99000000f,-0.39000000f,0.19000000f,-0.74000000f,-0.43000000f,0.97000000f,-0.46000000f,-0.93000000f,-0.56000000f,0.17000000f,-0.74000000f,-0.87000000f,-0.20000000f,-0.87000000f,-0.60000000f,-0.66000000f,0.12000000f,-0.88000000f,-0.25000000f,-0.27000000f,0.36000000f,-0.22000000f,0.97000000f,-0.24000000f,0.35000000f,-0.30000000f,-0.10000000f,0.66000000f,-0.06000000f,-0.21000000f,-0.20000000f,0.87000000f,-0.13000000f,-0.25000000f,0.10000000f,-0.47000000f,-0.51000000f,0.55000000f,0.20000000f,0.14000000f,0.80000000f,-0.25000000f,0.81000000f,-0.19000000f,-0.04000000f,-0.05000000f,0.63000000f,-0.03000000f,-0.60000000f,0.39000000f,-0.25000000f,0.47000000f,-0.51000000f,-0.42000000f,-0.31000000f,-0.08000000f,0.76000000f,-0.64000000f,0.28000000f,-0.15000000f,0.89000000f,-0.39000000f,0.49000000f,-0.31000000f,0.39000000f,-0.48000000f,-0.24000000f,-0.97000000f,0.76000000f,-0.34000000f,-0.35000000f,-0.83000000f,-0.70000000f,-0.92000000f,0.37000000f,-0.05000000f,0.95000000f,0.49000000f,-0.04000000f,0.51000000f,-0.84000000f,0.56000000f,0.50000000f,0.85000000f,0.78000000f,-0.03000000f,-0.32000000f,0.31000000f,-0.13000000f,-0.38000000f,-0.34000000f,-0.15000000f,0.22000000f,-0.91000000f,0.97000000f,0.12000000f,0.71000000f,0.22000000f,0.98000000f,0.45000000f,-0.21000000f,-0.27000000f,0.31000000f,-0.47000000f,-0.90000000f,-0.90000000f,-0.83000000f,0.07000000f,0.20000000f,0.68000000f,-0.42000000f,-0.36000000f,-0.14000000f,0.29000000f,0.57000000f,0.76000000f,-0.18000000f,-0.89000000f,-0.30000000f,0.92000000f,-0.09000000f,-0.05000000f,0.96000000f,0.29000000f,0.07000000f,-0.65000000f,-0.78000000f,0.55000000f,0.17000000f,-0.39000000f,0.17000000f,0.62000000f,0.51000000f,0.00000000f,-0.61000000f,-0.52000000f,-0.57000000f,-0.99000000f,-0.65000000f,0.94000000f,-0.54000000f,-0.00000000f,0.99000000f,0.40000000f,-0.98000000f,0.38000000f,-0.15000000f,-0.91000000f,-0.47000000f,0.61000000f,-0.67000000f,0.79000000f,-0.01000000f,-0.04000000f,0.27000000f,0.27000000f,0.49000000f,0.71000000f,0.56000000f,-0.98000000f,0.42000000f,-0.30000000f,-0.48000000f,0.85000000f,-0.28000000f,0.02000000f,-0.26000000f,0.27000000f,0.40000000f,-0.61000000f,-0.48000000f,0.79000000f,0.08000000f,-0.04000000f,0.96000000f,0.86000000f,0.99000000f,-0.97000000f,0.79000000f,-0.96000000f,0.53000000f,0.61000000f,-0.16000000f,0.39000000f,0.02000000f,0.76000000f,-0.51000000f,0.19000000f,0.79000000f,0.20000000f,0.76000000f,0.26000000f,-0.95000000f,0.03000000f,0.06000000f,0.86000000f,-0.69000000f,0.46000000f,-0.55000000f,-0.71000000f,-0.91000000f,0.69000000f,0.53000000f,-0.27000000f,-0.02000000f,-0.34000000f,-0.78000000f,0.51000000f,0.04000000f,0.92000000f,-0.72000000f,-0.84000000f,0.01000000f,-0.95000000f,0.58000000f,-0.85000000f,0.86000000f,-0.70000000f,0.34000000f,0.14000000f,-0.22000000f,0.89000000f,0.44000000f,0.91000000f,0.51000000f,0.15000000f,0.56000000f,0.75000000f,-0.10000000f,0.34000000f,0.14000000f,-0.34000000f,-0.55000000f,0.77000000f,0.59000000f,0.11000000f,-0.16000000f,-0.12000000f,-0.89000000f,-0.45000000f,-0.56000000f,-0.93000000f,0.51000000f,-0.19000000f,0.82000000f,0.17000000f,0.65000000f,0.18000000f,0.69000000f,-0.72000000f,0.75000000f,0.40000000f,-0.37000000f,-0.55000000f,0.87000000f,0.58000000f,0.33000000f,-0.78000000f,0.29000000f,-0.17000000f,0.62000000f,-0.05000000f,0.39000000f,0.69000000f,0.90000000f,-0.53000000f,0.98000000f,0.74000000f,-0.34000000f,-0.34000000f,-0.25000000f,0.62000000f,0.96000000f,-0.30000000f,-0.54000000f,0.46000000f,-0.99000000f,0.13000000f,-0.40000000f,0.15000000f,-0.59000000f,-0.85000000f,0.18000000f,0.89000000f,-0.85000000f,0.56000000f,-0.23000000f,0.73000000f,0.17000000f,-0.76000000f,-0.23000000f,0.77000000f,0.82000000f,-0.72000000f,-0.94000000f,-0.95000000f,0.28000000f,0.74000000f,-0.97000000f,0.44000000f,-0.02000000f,0.40000000f,-0.53000000f,-0.83000000f,-0.57000000f,-0.07000000f,0.20000000f,0.27000000f,0.10000000f,-0.19000000f,0.99000000f,0.18000000f,-0.24000000f,0.73000000f,-0.30000000f,-0.83000000f,-0.34000000f,-0.16000000f,-0.23000000f,0.18000000f,-0.69000000f,-0.70000000f,0.52000000f,-0.33000000f,0.45000000f,-0.81000000f,-0.17000000f,0.03000000f,0.49000000f,0.80000000f,0.88000000f,-0.30000000f,0.17000000f,-0.69000000f,0.19000000f,0.67000000f,-0.78000000f,-0.84000000f,-0.75000000f,-0.81000000f,0.65000000f,0.50000000f,0.62000000f,0.19000000f,-0.91000000f,0.26000000f,-0.17000000f,-0.33000000f,0.19000000f,0.13000000f,0.32000000f,0.59000000f,-0.31000000f,0.88000000f,-0.33000000f,-0.42000000f,-0.34000000f,-0.05000000f,-0.35000000f,0.20000000f,0.31000000f,-0.21000000f,-0.30000000f,0.70000000f,0.10000000f,-0.28000000f,-0.27000000f,0.48000000f,0.45000000f,-0.67000000f,-0.14000000f,-0.41000000f,-0.80000000f,0.02000000f,0.03000000f,-0.49000000f,-0.73000000f,-0.94000000f,-0.28000000f,-0.11000000f,0.94000000f,-0.02000000f,0.06000000f,-0.64000000f,-0.87000000f,0.59000000f,-0.99000000f,-0.19000000f,0.50000000f,-0.12000000f,0.84000000f,0.98000000f,-0.69000000f,0.64000000f,0.93000000f,-0.93000000f,-0.42000000f,-0.96000000f,-0.26000000f,0.21000000f,0.48000000f,-0.64000000f,0.58000000f,-0.86000000f,-0.85000000f,-0.73000000f,-0.81000000f,0.08000000f,-0.89000000f,0.00000000f,-0.16000000f,0.78000000f,0.25000000f,-0.87000000f,-0.30000000f,-0.19000000f,0.58000000f,0.30000000f,-0.10000000f,0.54000000f,0.06000000f,-0.52000000f,-0.88000000f,0.63000000f,-0.34000000f,-0.19000000f,-0.92000000f,0.60000000f,-0.90000000f,-0.21000000f,-0.90000000f,-0.28000000f,-0.14000000f,-0.71000000f,0.49000000f,0.80000000f,-0.49000000f,-0.38000000f,0.57000000f,0.10000000f,-0.80000000f,0.25000000f,-0.38000000f,-0.12000000f,-0.52000000f,-0.01000000f,-0.72000000f,0.74000000f,-0.35000000f,0.88000000f,0.02000000f,-0.14000000f,-0.40000000f,-0.42000000f,0.12000000f,0.93000000f,-0.98000000f,0.95000000f,-0.34000000f,0.53000000f,0.00000000f,0.22000000f,0.35000000f,0.90000000f,-0.39000000f,-0.04000000f,-0.27000000f,-0.20000000f,0.90000000f,-0.00000000f,0.36000000f,-0.68000000f,-0.95000000f,0.21000000f,0.76000000f,0.29000000f,0.99000000f,-0.28000000f,0.02000000f,-0.79000000f,-0.39000000f,0.63000000f,-0.25000000f,0.64000000f,0.72000000f,-0.93000000f,-0.64000000f,0.34000000f,0.36000000f,0.76000000f,0.77000000f,0.27000000f,0.63000000f,0.28000000f,0.94000000f,0.80000000f,0.45000000f,0.49000000f,0.09000000f,0.22000000f,0.50000000f,0.44000000f,0.94000000f,-0.85000000f,0.32000000f,0.34000000f,0.02000000f,-0.04000000f,-0.50000000f,-0.54000000f,-0.96000000f,0.77000000f,-0.09000000f,-0.20000000f,-0.24000000f,-0.78000000f,0.36000000f,-0.73000000f,0.87000000f,0.23000000f,-0.99000000f,0.72000000f,-0.56000000f,0.79000000f,0.14000000f,-0.48000000f,0.37000000f,0.69000000f,0.91000000f,-0.58000000f,0.37000000f,-0.86000000f,-0.76000000f,-0.15000000f,-0.60000000f,-0.16000000f,0.13000000f,-0.97000000f,-0.08000000f,0.84000000f,-0.34000000f,-0.46000000f,0.23000000f,0.61000000f,-0.71000000f,0.71000000f,-0.07000000f,-0.72000000f,0.17000000f,-0.25000000f,0.58000000f,0.10000000f,0.90000000f,-0.80000000f,0.26000000f,0.21000000f,0.48000000f,-0.24000000f,-0.28000000f,0.27000000f,-0.80000000f,0.52000000f,-0.76000000f,0.87000000f,-0.71000000f,0.20000000f,-0.14000000f,0.17000000f,0.87000000f,-0.37000000f,-0.87000000f,0.62000000f,0.50000000f,0.89000000f,-0.66000000f,0.43000000f,-0.85000000f,0.70000000f,0.73000000f,-0.69000000f,-0.95000000f,-0.85000000f,-0.43000000f,0.94000000f,-0.15000000f,-0.69000000f,0.23000000f,-0.29000000f,0.76000000f,-0.62000000f,0.05000000f,-0.59000000f,0.59000000f,0.47000000f,0.27000000f,-0.13000000f,0.47000000f,-0.18000000f,-0.20000000f,0.02000000f,-0.43000000f,0.60000000f,0.11000000f,-0.26000000f,-0.41000000f,0.82000000f,0.66000000f,-0.31000000f,-0.32000000f,0.58000000f,0.86000000f,0.49000000f,-0.90000000f,0.40000000f,0.35000000f,-0.16000000f,0.48000000f,-0.46000000f,-0.02000000f,-0.07000000f,0.32000000f,-0.98000000f,-0.33000000f,0.33000000f,0.22000000f,-0.26000000f,0.09000000f,-0.79000000f,0.06000000f,0.54000000f,-0.87000000f,0.02000000f,0.83000000f,-0.33000000f,0.10000000f,0.50000000f,-0.44000000f,-0.45000000f,-0.97000000f,-0.51000000f,-0.90000000f,-0.56000000f,0.79000000f,-0.48000000f,0.41000000f,0.72000000f,-0.23000000f,0.91000000f,-0.07000000f,-0.38000000f,0.77000000f,-0.55000000f,-0.81000000f,-0.55000000f,0.75000000f,0.66000000f,-0.47000000f,0.44000000f,-0.90000000f,-0.06000000f,0.68000000f,-0.31000000f,-0.25000000f,-0.00000000f,0.47000000f,-0.12000000f,0.12000000f,0.99000000f,-0.62000000f,-0.84000000f,0.17000000f,0.92000000f,0.38000000f,-0.19000000f,-0.97000000f,0.48000000f,-0.89000000f,0.30000000f,-0.08000000f,0.03000000f,0.42000000f,0.14000000f,0.36000000f,-0.26000000f,-0.09000000f,0.41000000f,0.76000000f,0.66000000f,-0.11000000f,-0.19000000f,0.22000000f,-0.11000000f,0.39000000f,0.68000000f,-0.81000000f,0.87000000f,0.04000000f,0.54000000f,0.02000000f,0.05000000f,-0.24000000f,0.05000000f,0.57000000f,-0.81000000f,-0.77000000f,-0.09000000f,-0.35000000f,-0.00000000f,-0.61000000f,0.03000000f,-0.48000000f,0.40000000f,-0.22000000f,-0.19000000f,-0.55000000f,-0.53000000f,-0.32000000f,-0.17000000f,-0.08000000f,0.57000000f,0.18000000f,0.41000000f,0.54000000f,0.21000000f,-0.25000000f,0.07000000f,0.76000000f,-0.97000000f,-0.79000000f,-0.03000000f,-0.56000000f,-0.50000000f,-0.55000000f,-0.58000000f,0.59000000f,0.82000000f,-0.18000000f,-0.50000000f,-0.32000000f,-0.83000000f,-0.44000000f,-0.94000000f,-0.70000000f,0.90000000f,-0.23000000f,-0.23000000f,-0.83000000f,0.35000000f,-0.45000000f,0.31000000f,0.52000000f,-0.14000000f,0.79000000f,-0.30000000f,-0.51000000f,0.99000000f,0.47000000f,0.00000000f,-0.42000000f,0.43000000f,-0.52000000f,0.68000000f,-0.11000000f,0.54000000f,0.98000000f,0.66000000f,-0.32000000f,0.13000000f,-0.87000000f,-0.20000000f,0.27000000f,-0.74000000f,0.64000000f,-0.08000000f,-0.68000000f,-0.78000000f,0.45000000f,-0.37000000f,0.23000000f,0.79000000f,-0.03000000f,-0.09000000f,0.27000000f,-0.46000000f,-0.22000000f,-0.39000000f,0.92000000f,0.80000000f,-0.83000000f,0.89000000f,0.42000000f,0.75000000f,-0.59000000f,-0.26000000f,-0.62000000f,-0.37000000f,-0.07000000f,0.97000000f,-0.90000000f,0.39000000f,-0.50000000f,-0.20000000f,-0.54000000f,0.34000000f,-0.43000000f,-0.82000000f,-0.35000000f,0.42000000f,-0.46000000f,0.48000000f,-0.69000000f,0.33000000f,0.19000000f,0.99000000f,0.06000000f,-0.30000000f,-0.99000000f,0.13000000f,0.47000000f,-0.23000000f,-0.47000000f,0.07000000f,0.82000000f,-0.58000000f,0.42000000f,-0.83000000f,-0.19000000f,-0.98000000f,-0.80000000f,0.28000000f,0.15000000f,0.44000000f,-0.87000000f,0.99000000f,-0.46000000f,-0.85000000f,-0.07000000f,-0.46000000f,-0.93000000f,0.87000000f,0.49000000f,-0.09000000f,-0.74000000f,-0.43000000f,-0.94000000f,0.44000000f,0.50000000f,-0.84000000f,-0.51000000f,0.50000000f,-0.33000000f,0.58000000f,0.22000000f,-0.89000000f,-0.65000000f,0.39000000f,0.01000000f,0.94000000f,-0.73000000f,-0.30000000f,0.69000000f,0.47000000f,0.11000000f,-0.30000000f,-0.16000000f,-0.58000000f,0.76000000f,-0.78000000f,-0.84000000f,0.83000000f,0.96000000f,-0.44000000f,-0.40000000f,-0.28000000f,0.76000000f,-0.47000000f,-0.00000000f,0.91000000f,0.12000000f,0.58000000f,0.64000000f,0.61000000f,0.30000000f,-0.55000000f,-0.33000000f,0.40000000f,0.17000000f,0.35000000f,0.93000000f,-0.63000000f,0.33000000f,0.21000000f,-0.03000000f,-0.55000000f,0.37000000f,0.55000000f,-0.14000000f,-0.37000000f,-0.32000000f,-0.41000000f,-0.50000000f,-0.30000000f,0.49000000f,-0.16000000f,-0.13000000f,-0.77000000f,-0.82000000f,-0.16000000f,0.67000000f,-0.83000000f,-0.87000000f,0.17000000f,0.39000000f,-0.72000000f,-0.09000000f,0.28000000f,0.43000000f,0.44000000f,-0.28000000f,0.23000000f,0.33000000f,-0.95000000f,0.94000000f,-0.70000000f,0.03000000f,-0.73000000f,-0.06000000f,0.90000000f,-0.13000000f,0.39000000f,-0.57000000f,0.13000000f,-0.00000000f,0.30000000f,-0.83000000f,0.53000000f,-0.61000000f,0.27000000f,0.84000000f,0.98000000f,0.98000000f,-0.34000000f,-0.83000000f,-0.36000000f,0.16000000f,-0.93000000f,-0.45000000f,0.23000000f,0.22000000f,0.18000000f,0.80000000f,-0.56000000f,-0.34000000f,-0.40000000f,-0.84000000f,-0.63000000f,0.98000000f,-0.07000000f,-0.36000000f,0.52000000f,0.06000000f,-0.61000000f,-0.19000000f,0.10000000f,0.60000000f,0.37000000f,-0.74000000f,0.84000000f,-0.86000000f,0.63000000f,0.75000000f,-0.48000000f,0.93000000f,-0.39000000f,-0.01000000f,0.43000000f,0.24000000f,-0.49000000f,-0.36000000f,-0.97000000f,-0.56000000f,-0.08000000f,0.61000000f,0.38000000f,-0.25000000f,0.81000000f,0.42000000f,0.42000000f,0.95000000f,0.18000000f,-0.14000000f,0.12000000f,-0.32000000f,-0.62000000f,0.84000000f,-0.92000000f,-0.57000000f,0.57000000f,-0.18000000f,-0.70000000f,0.39000000f,0.48000000f,0.37000000f,-0.34000000f,-0.65000000f,-0.42000000f,-0.81000000f,0.50000000f,-0.27000000f,-0.63000000f,0.09000000f,-0.97000000f,0.76000000f,-0.86000000f,-0.93000000f,-0.67000000f,-0.86000000f,-0.69000000f,0.15000000f,-0.21000000f,0.20000000f,-0.52000000f,-0.65000000f,0.80000000f,-0.69000000f,-0.78000000f,0.23000000f,-0.69000000f,-0.84000000f,0.09000000f,0.53000000f,-0.24000000f,0.44000000f,0.16000000f,-0.10000000f,0.46000000f,-0.63000000f,-0.50000000f,-0.08000000f,0.33000000f,0.76000000f,-0.37000000f,-0.16000000f,0.81000000f,0.44000000f,0.02000000f,0.33000000f,-0.73000000f,0.72000000f,-0.08000000f,-0.47000000f,0.59000000f,0.76000000f,-0.83000000f,0.09000000f,-0.90000000f,-0.91000000f,-0.53000000f,0.80000000f,-0.51000000f,0.33000000f,-0.78000000f,0.47000000f,-0.71000000f,-0.58000000f,0.22000000f,0.53000000f,-0.10000000f,-0.00000000f,0.10000000f,-0.71000000f,0.94000000f,0.18000000f,-0.67000000f,-0.10000000f,-0.95000000f,0.52000000f,0.87000000f,-0.45000000f,0.68000000f,-0.00000000f,-0.78000000f,-0.01000000f,-0.04000000f,0.39000000f,0.02000000f,0.77000000f,0.82000000f,-0.98000000f,-0.90000000f,-0.63000000f,-0.31000000f,-0.97000000f,0.29000000f,-0.00000000f,0.55000000f,-0.58000000f,0.97000000f,-0.35000000f,0.16000000f,-0.56000000f,0.06000000f,0.97000000f,0.54000000f,0.80000000f,-0.59000000f,0.87000000f,0.74000000f,-0.31000000f,-0.24000000f,0.39000000f,0.43000000f,0.33000000f,-0.12000000f,-0.30000000f,0.61000000f,0.77000000f,0.23000000f,-0.05000000f,-0.13000000f,0.14000000f,0.76000000f,-0.12000000f,0.53000000f,-0.56000000f,-0.75000000f,-0.84000000f,-0.97000000f,0.33000000f,0.65000000f,0.16000000f,-0.46000000f,0.28000000f,-0.39000000f,0.40000000f,0.03000000f,-0.36000000f,0.97000000f,-0.27000000f,-0.31000000f,-0.34000000f,0.68000000f,-0.15000000f,-0.09000000f,0.84000000f,0.29000000f,0.90000000f,-0.42000000f,-0.82000000f,0.89000000f,0.15000000f,0.20000000f,-0.32000000f,-0.03000000f,0.29000000f,0.61000000f,-0.52000000f,-0.62000000f,-0.93000000f,0.79000000f,0.28000000f,-0.03000000f,0.03000000f,-0.54000000f,-0.61000000f,0.31000000f,-0.91000000f,0.92000000f,-0.18000000f,-0.12000000f,0.79000000f,-0.24000000f,-0.40000000f,0.46000000f,-0.63000000f,-0.93000000f,0.82000000f,0.40000000f,-0.09000000f,0.12000000f,-0.77000000f,-0.13000000f,-0.58000000f,0.86000000f,-0.86000000f,0.50000000f,-0.72000000f,-0.46000000f,-0.81000000f,0.94000000f,-0.66000000f,0.24000000f,-0.78000000f,-0.79000000f,-0.48000000f,0.49000000f,0.47000000f,-0.04000000f,-0.83000000f,-0.49000000f,-0.48000000f,-0.16000000f,-0.18000000f,0.03000000f,-0.90000000f,-0.47000000f,-0.26000000f,0.38000000f,0.90000000f,-0.81000000f,-0.64000000f,-0.29000000f,0.69000000f,0.62000000f,-0.99000000f,0.50000000f,0.94000000f,0.68000000f,-0.00000000f,0.51000000f,0.26000000f,-0.78000000f,-0.71000000f,0.63000000f,-0.81000000f,-0.18000000f,-0.30000000f,0.28000000f,0.18000000f,-0.20000000f,-0.44000000f,0.26000000f,-0.13000000f,-0.86000000f,0.77000000f,0.78000000f,-0.19000000f,-0.15000000f,-0.77000000f,0.37000000f,-0.01000000f,-0.21000000f,-0.07000000f,-0.78000000f,0.54000000f,0.78000000f,0.38000000f,0.69000000f,0.32000000f,0.04000000f,0.42000000f,-0.40000000f,0.06000000f,0.79000000f,-0.26000000f,-0.15000000f,-0.27000000f,0.23000000f,-0.37000000f,0.90000000f,-0.22000000f,0.73000000f,-0.87000000f,0.59000000f,-0.53000000f,-0.35000000f,-0.88000000f,0.82000000f,-0.57000000f,-0.86000000f,-0.38000000f,-0.87000000f,0.72000000f,0.51000000f,0.56000000f,0.32000000f,0.27000000f,0.86000000f,0.96000000f,-0.40000000f,-0.54000000f,-0.54000000f,0.64000000f,0.99000000f,-0.50000000f,0.29000000f,0.58000000f,0.66000000f,-0.58000000f,0.23000000f,0.24000000f,-0.67000000f,-0.23000000f,0.31000000f,0.47000000f,-0.91000000f,0.56000000f,0.97000000f,0.06000000f,-0.68000000f,-0.36000000f,0.47000000f,0.98000000f,0.41000000f,-0.71000000f,-0.38000000f,0.94000000f,-0.28000000f,0.10000000f,0.87000000f,0.63000000f,0.19000000f,-0.93000000f,-0.64000000f,0.35000000f,0.85000000f,-0.33000000f,0.62000000f,-0.54000000f,0.37000000f,0.92000000f,-0.22000000f,-0.55000000f,-0.59000000f,-0.06000000f,-0.81000000f,0.81000000f,-0.05000000f,0.70000000f,0.47000000f,0.62000000f,-0.69000000f,-0.19000000f,0.37000000f,-0.57000000f,0.66000000f,-0.14000000f,-0.97000000f,-0.71000000f,0.57000000f,0.66000000f,-0.46000000f,0.66000000f,-0.11000000f,0.91000000f,0.75000000f,-0.02000000f,0.14000000f,-0.25000000f,-0.32000000f,0.92000000f,-0.58000000f,0.48000000f,0.62000000f,0.23000000f,0.06000000f,0.17000000f,-0.28000000f,0.81000000f,0.78000000f,-0.14000000f,0.09000000f,0.12000000f,0.27000000f,0.36000000f,0.92000000f,-0.06000000f,-0.52000000f,-0.17000000f,0.36000000f,-0.22000000f,-0.41000000f,-0.64000000f,0.64000000f,-0.69000000f,-0.68000000f,-0.07000000f,-0.12000000f,0.73000000f,0.88000000f,-0.49000000f,0.00000000f,-0.93000000f,-0.45000000f,-0.39000000f,0.67000000f,-0.02000000f,-0.55000000f,0.61000000f,0.51000000f,0.41000000f,0.27000000f,0.19000000f,-0.49000000f,0.14000000f,0.16000000f,-0.45000000f,-0.31000000f,0.70000000f,-0.17000000f,0.52000000f,-0.34000000f,0.66000000f,0.84000000f,0.47000000f,-0.90000000f,-0.38000000f,0.21000000f,0.55000000f,0.86000000f,0.86000000f,-0.79000000f,-0.44000000f,-0.51000000f,-0.09000000f,-0.30000000f,-0.39000000f,-0.18000000f,-0.81000000f,0.32000000f,-0.90000000f,-0.14000000f,-0.24000000f,0.77000000f,-0.68000000f,0.09000000f,0.64000000f,0.08000000f,0.15000000f,-0.36000000f,0.51000000f,-0.54000000f,-0.34000000f,-0.73000000f,-0.25000000f,0.66000000f,-0.33000000f,0.23000000f,-0.93000000f,0.40000000f,0.62000000f,0.12000000f,0.23000000f,0.20000000f,0.57000000f,-0.52000000f,0.08000000f,0.53000000f,0.10000000f,0.79000000f,-0.63000000f,0.46000000f,-0.12000000f,0.21000000f,0.60000000f,0.84000000f,0.84000000f,-0.54000000f,-0.24000000f,-0.75000000f,0.71000000f,0.94000000f,0.81000000f,-0.07000000f,-0.96000000f,-0.51000000f,0.40000000f,-0.26000000f,0.34000000f,-0.79000000f,-0.95000000f,-0.58000000f,0.54000000f,-0.48000000f,-0.83000000f,-0.71000000f,-0.45000000f,-0.68000000f,0.05000000f,0.28000000f,0.58000000f,0.16000000f,0.48000000f,0.09000000f,0.09000000f,0.13000000f,0.76000000f,-0.54000000f,0.14000000f,-0.47000000f,0.95000000f,-0.40000000f,0.96000000f,-0.26000000f,-0.38000000f,-0.54000000f,0.05000000f,0.77000000f,-0.84000000f,-0.88000000f,0.81000000f,-0.69000000f,-0.93000000f,-0.03000000f,0.32000000f,0.60000000f,-0.59000000f,-0.07000000f,-0.66000000f,0.68000000f,-0.77000000f,-0.55000000f,0.31000000f,-0.22000000f,-0.20000000f,0.13000000f,0.32000000f,0.32000000f,0.32000000f,-0.86000000f,-0.19000000f,0.12000000f,0.82000000f,0.38000000f,0.73000000f,0.07000000f,0.09000000f,-0.04000000f,-0.62000000f,0.13000000f,-0.51000000f,-0.87000000f,-0.48000000f,0.07000000f,0.13000000f,-0.16000000f,0.68000000f,-0.97000000f,-0.59000000f,0.00000000f,0.24000000f,-0.67000000f,-0.57000000f,0.59000000f,0.64000000f,0.36000000f,-0.50000000f,0.01000000f,0.94000000f,0.33000000f,0.69000000f,0.24000000f,-0.96000000f,0.31000000f,-0.21000000f,0.77000000f,-0.78000000f,-0.87000000f,0.73000000f,0.55000000f,0.46000000f,0.95000000f,0.99000000f,0.64000000f,0.03000000f,0.04000000f,-0.19000000f,-0.03000000f,0.54000000f,0.19000000f,-0.09000000f,0.57000000f,0.25000000f,0.75000000f,-0.22000000f,0.45000000f,0.23000000f,-0.52000000f,-0.27000000f,-0.83000000f,0.01000000f,-0.08000000f,-0.51000000f,0.26000000f,-0.36000000f,-0.30000000f,-0.77000000f,0.17000000f,-0.02000000f,-0.57000000f,-0.29000000f,-0.47000000f,-0.53000000f,0.97000000f,0.49000000f,0.03000000f,0.52000000f,0.93000000f,0.71000000f,0.82000000f,-0.35000000f,0.38000000f,0.47000000f,-0.92000000f,-0.36000000f,0.69000000f,-0.88000000f,0.58000000f,-0.02000000f,-0.80000000f,-0.69000000f,0.56000000f,-0.15000000f,-0.74000000f,0.88000000f,0.35000000f,0.24000000f,0.03000000f,-0.43000000f,-0.03000000f,-0.97000000f,0.17000000f,-0.92000000f,0.44000000f,-0.57000000f,-0.90000000f,0.50000000f,0.26000000f,-0.87000000f,0.25000000f,-0.70000000f,-0.19000000f,0.56000000f,0.92000000f,0.09000000f,0.55000000f,-0.38000000f,0.28000000f,0.91000000f,-0.25000000f,0.55000000f,0.46000000f,-0.80000000f,0.24000000f,-0.66000000f,0.32000000f,-0.05000000f,-0.09000000f,0.12000000f,0.86000000f,0.66000000f,-0.93000000f,0.88000000f,-0.31000000f,-0.13000000f,0.68000000f,0.84000000f,-0.58000000f,0.19000000f,-0.61000000f,-0.06000000f,-0.01000000f,0.10000000f,-0.77000000f,0.36000000f,-0.05000000f,0.96000000f,0.83000000f,-0.66000000f,0.81000000f,0.54000000f,0.46000000f,-0.93000000f,0.19000000f,-0.75000000f,0.85000000f,-0.26000000f,-0.03000000f,-0.77000000f,0.54000000f,-0.54000000f,0.72000000f,-0.05000000f,-0.81000000f,0.58000000f,-0.34000000f,-0.53000000f,0.98000000f,0.96000000f,-0.55000000f,0.99000000f,-0.48000000f,-0.29000000f,-0.01000000f,0.09000000f,-0.02000000f,-0.34000000f,-0.15000000f,0.44000000f,-0.54000000f,-0.82000000f,-0.35000000f,-0.87000000f,-0.45000000f,0.80000000f,0.74000000f,0.86000000f,0.75000000f,0.66000000f,-0.69000000f,-0.29000000f,-0.18000000f,0.17000000f,-0.50000000f,0.66000000f,0.37000000f,0.75000000f,-0.44000000f,-0.07000000f,0.06000000f,-0.36000000f,-0.10000000f,-0.63000000f,0.12000000f,-0.25000000f,-0.71000000f,-0.51000000f,-0.75000000f,-0.46000000f,0.52000000f,-0.36000000f,-0.97000000f,0.75000000f,-0.23000000f,0.26000000f,-0.27000000f,0.78000000f,-0.93000000f,-0.54000000f,0.00000000f,0.73000000f,0.05000000f,0.00000000f,-0.95000000f,0.19000000f,0.53000000f,-0.57000000f,0.82000000f,-0.48000000f,-0.46000000f,0.37000000f,0.74000000f,-0.99000000f,0.46000000f,-0.10000000f,0.91000000f,0.83000000f,-0.45000000f,-0.37000000f,-0.05000000f,-0.75000000f,-0.23000000f,-0.88000000f,-0.16000000f,-0.97000000f,0.80000000f,0.64000000f,-0.57000000f,0.53000000f,-0.70000000f,-0.19000000f,0.96000000f,0.26000000f,-0.70000000f,0.59000000f,-0.32000000f,0.49000000f,-0.25000000f,-0.01000000f,0.57000000f,-0.21000000f,0.04000000f,-0.32000000f,0.23000000f,0.19000000f,-0.17000000f,-0.58000000f,-0.27000000f,-0.50000000f,-0.59000000f,-0.77000000f,0.07000000f,-0.37000000f,0.13000000f,-0.83000000f,0.31000000f,0.63000000f,-0.55000000f,-0.32000000f,-0.66000000f,-0.61000000f,-0.95000000f,0.04000000f,0.58000000f,0.19000000f,0.50000000f,-0.79000000f,0.32000000f,0.89000000f,0.58000000f,-0.28000000f,0.21000000f,-0.36000000f,0.84000000f,0.24000000f,-0.18000000f,0.96000000f,-0.43000000f,0.17000000f,-0.38000000f,-0.07000000f,0.05000000f,0.91000000f,-0.41000000f,-0.24000000f,0.93000000f,-0.46000000f,-0.51000000f,0.93000000f,0.49000000f,0.17000000f,0.72000000f,-0.07000000f,-0.94000000f,-0.04000000f,0.87000000f,0.86000000f,-0.73000000f,-0.76000000f,-0.54000000f,-0.03000000f,0.83000000f,0.62000000f,0.76000000f,-0.72000000f,-0.76000000f,0.95000000f,0.32000000f,0.61000000f,0.45000000f,0.63000000f,0.89000000f,-0.73000000f,0.63000000f,0.30000000f,-0.75000000f,-0.03000000f,0.64000000f,0.48000000f,-0.94000000f,-0.40000000f,0.28000000f,0.91000000f,0.29000000f,-0.02000000f,0.62000000f,-0.06000000f,0.07000000f,0.86000000f,0.31000000f,0.93000000f,0.41000000f,0.58000000f,0.67000000f,-0.30000000f,0.64000000f,0.59000000f,-0.33000000f,-0.77000000f,-0.52000000f,0.74000000f,-0.58000000f,0.93000000f,-0.17000000f,-0.49000000f,-0.91000000f,0.82000000f,-0.57000000f,0.05000000f,0.17000000f,0.44000000f,0.72000000f,-0.95000000f,-0.29000000f,0.70000000f,-0.96000000f,-0.11000000f,0.31000000f,-0.52000000f,-0.97000000f,-0.58000000f,0.46000000f,-0.06000000f,-0.30000000f,0.25000000f,0.16000000f,-0.38000000f,0.72000000f,0.47000000f,0.47000000f,0.84000000f,0.64000000f,-0.61000000f,-0.39000000f,-0.78000000f,0.58000000f,0.19000000f,-0.05000000f,0.38000000f,0.35000000f,0.11000000f,-0.16000000f,0.85000000f,-0.63000000f,0.88000000f,0.22000000f,0.79000000f,0.30000000f,-0.50000000f,-0.90000000f,0.41000000f,0.16000000f,0.40000000f,-0.38000000f,-0.94000000f,-0.61000000f,-0.02000000f,0.13000000f,-0.84000000f,0.86000000f,0.61000000f,0.08000000f,0.00000000f,0.13000000f,-0.58000000f,0.09000000f,-0.10000000f,-0.21000000f,-0.89000000f,-0.53000000f,0.41000000f,0.02000000f,0.93000000f,0.94000000f,-0.95000000f,0.14000000f,-0.81000000f,0.51000000f,0.00000000f,-0.23000000f,0.11000000f,-0.50000000f,-0.62000000f,-0.57000000f,0.46000000f,0.65000000f,0.98000000f,0.61000000f,0.67000000f,-0.32000000f,-0.09000000f,-0.70000000f,0.62000000f,0.40000000f,-0.69000000f,0.15000000f,0.73000000f,0.76000000f,0.49000000f,-0.10000000f,-0.13000000f,0.93000000f,0.72000000f,0.08000000f,0.96000000f,0.44000000f,0.63000000f,-0.68000000f,-0.69000000f,0.35000000f,0.50000000f,-0.73000000f,0.58000000f,0.85000000f,-0.21000000f,0.32000000f,-0.87000000f,0.05000000f,-0.05000000f,0.35000000f,0.63000000f,-0.24000000f,-0.96000000f,-0.42000000f,-0.05000000f,0.75000000f,0.07000000f,-0.91000000f,-0.35000000f,-0.80000000f,-0.48000000f,-0.86000000f,-0.35000000f,0.42000000f,0.88000000f,0.38000000f,0.53000000f,-0.74000000f,-0.61000000f,0.14000000f,-0.43000000f,0.68000000f,-0.02000000f,-0.30000000f,-0.81000000f,-0.39000000f,0.32000000f,-0.39000000f,0.23000000f,-0.82000000f,0.17000000f,-0.05000000f,-0.45000000f,-0.37000000f,0.57000000f,-0.44000000f,0.72000000f,-0.00000000f,0.84000000f,0.98000000f,-0.03000000f,-0.34000000f,-0.51000000f,-0.27000000f,0.46000000f,-0.49000000f,0.86000000f,-0.15000000f,-0.70000000f,0.91000000f,-0.87000000f,-0.44000000f,0.68000000f,0.96000000f,0.20000000f,-0.22000000f,0.96000000f,-0.46000000f,-0.18000000f,0.42000000f,-0.02000000f,-0.66000000f,0.85000000f,0.23000000f,0.03000000f,0.28000000f,-0.56000000f,-0.20000000f,-0.94000000f,0.90000000f,-0.11000000f,-0.63000000f,-0.19000000f,-0.37000000f,0.29000000f,0.18000000f,-0.32000000f,0.41000000f,-0.42000000f,0.95000000f,-0.88000000f,0.74000000f,-0.55000000f,-0.36000000f,-0.70000000f,0.09000000f,0.08000000f,-0.33000000f,0.16000000f,0.67000000f,0.46000000f,-0.94000000f,-0.47000000f,0.94000000f,0.61000000f,-0.40000000f,0.97000000f,-0.08000000f,0.29000000f,0.61000000f,-0.88000000f,0.66000000f,0.83000000f,-0.84000000f,0.61000000f,0.66000000f,0.92000000f,0.26000000f,-0.12000000f,-0.25000000f,-0.01000000f,-0.07000000f,-0.98000000f,-0.45000000f,0.92000000f,-0.29000000f,-0.48000000f,0.08000000f,0.16000000f,0.53000000f,0.96000000f,0.55000000f,0.39000000f,-0.61000000f,0.45000000f,-0.45000000f,-0.09000000f,0.10000000f,-0.07000000f,-0.11000000f,-0.87000000f,-0.43000000f,0.32000000f,0.91000000f,-0.72000000f,-0.75000000f,0.55000000f,-0.80000000f,0.33000000f,0.03000000f,-0.19000000f,-0.93000000f,-0.65000000f,0.92000000f,-0.26000000f,0.89000000f,0.50000000f,0.28000000f,-0.98000000f,-0.55000000f,-0.80000000f,-0.50000000f,0.33000000f,0.08000000f,0.85000000f,-0.33000000f,0.57000000f,-0.59000000f,0.97000000f,0.95000000f,0.51000000f,0.60000000f,-0.80000000f,0.92000000f,-0.55000000f,0.10000000f,0.13000000f,-0.89000000f,0.04000000f,-0.75000000f,0.73000000f,0.80000000f,0.87000000f,0.23000000f,0.59000000f,-0.63000000f,0.70000000f,-0.95000000f,0.82000000f,-0.27000000f,0.54000000f,0.19000000f,0.96000000f,0.95000000f,-0.81000000f,0.02000000f,0.45000000f,0.40000000f,-0.52000000f,-0.74000000f,0.27000000f,0.37000000f,-0.27000000f,-0.23000000f,0.24000000f,0.28000000f,0.27000000f,0.38000000f,0.62000000f,-0.84000000f,0.22000000f,-0.88000000f,-0.77000000f,0.61000000f,-0.22000000f,-0.26000000f,0.59000000f,0.63000000f,0.49000000f,-0.77000000f,0.30000000f,-0.57000000f,0.39000000f,-0.21000000f,-0.68000000f,0.43000000f,0.60000000f,0.30000000f,-0.51000000f,-0.28000000f,0.26000000f,-0.06000000f,-0.68000000f,0.50000000f,-0.07000000f,0.16000000f,0.25000000f,-0.39000000f,-0.08000000f,0.81000000f,0.83000000f,-0.72000000f,-0.67000000f,0.35000000f,-0.08000000f,0.37000000f,-0.24000000f,0.64000000f,0.37000000f,-0.17000000f,0.61000000f,-0.35000000f,0.21000000f,0.72000000f,0.98000000f,0.38000000f,-0.14000000f,0.59000000f,0.45000000f,0.30000000f,0.61000000f,0.62000000f,0.56000000f,-0.66000000f,-0.39000000f,0.11000000f,-0.43000000f,-0.08000000f,0.75000000f,0.31000000f,-0.64000000f,-0.53000000f,0.41000000f,0.48000000f,0.54000000f,0.62000000f,-0.64000000f,-0.58000000f,-0.00000000f,0.05000000f,-0.62000000f,-0.65000000f,0.72000000f,-0.90000000f,0.29000000f,-0.56000000f,-0.68000000f,0.98000000f,0.84000000f,-0.43000000f,0.16000000f,-0.43000000f,0.16000000f,-0.86000000f,0.23000000f,0.70000000f,-0.94000000f,-0.74000000f,0.41000000f,0.20000000f,0.02000000f,-0.35000000f,-0.99000000f,-0.87000000f,-0.65000000f,0.77000000f,0.32000000f,0.92000000f,0.14000000f,0.95000000f,-0.80000000f,-0.14000000f,0.10000000f,0.60000000f,0.06000000f,0.19000000f,0.28000000f,0.32000000f,-0.87000000f,0.32000000f,-0.61000000f,-0.94000000f,-0.76000000f,0.91000000f,-0.77000000f,-0.80000000f,-0.33000000f,0.36000000f,-0.66000000f,0.50000000f,0.06000000f,-0.79000000f,-0.14000000f,0.38000000f,0.54000000f,-0.34000000f,-0.51000000f,-0.35000000f,-0.78000000f,0.40000000f,0.78000000f,-0.55000000f,-0.93000000f,0.77000000f,-0.93000000f,0.69000000f,0.86000000f,-0.07000000f,-0.78000000f,-0.16000000f,0.30000000f,-0.95000000f,-0.53000000f,0.73000000f,-0.75000000f,-0.55000000f,-0.16000000f,-0.30000000f,-0.74000000f,0.95000000f,-0.18000000f,-0.65000000f,0.99000000f,-0.87000000f,0.49000000f,0.24000000f,-0.06000000f,0.58000000f,-0.93000000f,-0.93000000f,-0.36000000f,0.74000000f,0.54000000f,-0.62000000f,0.09000000f,0.09000000f,-0.05000000f,-0.06000000f,0.15000000f,-0.69000000f,-0.22000000f,-0.20000000f,0.70000000f,0.56000000f,-0.30000000f,-0.70000000f,-0.69000000f,-0.10000000f,0.44000000f,-0.01000000f,-0.95000000f,-0.85000000f,0.53000000f,-0.05000000f,0.00000000f,-0.66000000f,0.05000000f,-0.52000000f,0.64000000f,-0.21000000f,0.22000000f,-0.25000000f,-0.22000000f,0.28000000f,-0.70000000f,0.57000000f,-0.90000000f,-0.33000000f,-0.69000000f,-0.14000000f,0.08000000f,-0.38000000f,-0.14000000f,-0.97000000f,0.84000000f,0.69000000f,-0.38000000f,0.36000000f,0.42000000f,-0.39000000f,0.29000000f,0.50000000f,-0.36000000f,-0.58000000f,-0.40000000f,0.88000000f,0.70000000f,0.59000000f,0.88000000f,0.90000000f,-0.10000000f,-0.22000000f,-0.68000000f,-0.92000000f,-0.55000000f,-0.46000000f,0.96000000f,-0.50000000f,0.08000000f,0.92000000f,-0.68000000f,-0.27000000f,0.29000000f,-0.95000000f,0.58000000f,0.69000000f,-0.62000000f,-0.25000000f,0.02000000f,-0.50000000f,0.01000000f,0.33000000f,-0.93000000f,-0.85000000f,-0.51000000f,0.04000000f,0.29000000f,-0.32000000f,-0.66000000f,0.08000000f,0.94000000f,-0.81000000f,-0.70000000f,0.44000000f,-0.13000000f,0.72000000f,-0.81000000f,-0.55000000f,-0.53000000f,-0.27000000f,-0.76000000f,0.04000000f,0.91000000f,0.80000000f,-0.91000000f,-0.79000000f,-0.11000000f,0.17000000f,-0.42000000f,0.57000000f,0.72000000f,-0.52000000f,-0.12000000f,-0.00000000f,-0.17000000f,0.98000000f,-0.30000000f,0.20000000f,0.64000000f,-0.29000000f,-0.42000000f,0.45000000f,0.85000000f,0.53000000f,0.47000000f,-0.29000000f,-0.04000000f,0.97000000f,0.86000000f,-0.13000000f,-0.96000000f,-0.34000000f,0.75000000f,-0.04000000f,-0.21000000f,0.59000000f,0.68000000f,0.36000000f,-0.11000000f,0.76000000f,-0.59000000f,-0.28000000f,0.07000000f,0.49000000f,0.23000000f,-0.01000000f,-0.00000000f,-0.33000000f,-0.14000000f,0.17000000f,0.68000000f,0.41000000f,-0.02000000f,-0.40000000f,0.75000000f,0.39000000f,-0.07000000f,0.11000000f,0.66000000f,0.47000000f,0.90000000f,0.17000000f,-0.15000000f,0.48000000f,-0.10000000f,-0.81000000f,0.47000000f,0.72000000f,0.51000000f,-0.64000000f,0.41000000f,-0.21000000f,0.97000000f,0.42000000f,0.81000000f,0.00000000f,-0.99000000f,0.43000000f,0.83000000f,0.78000000f,-0.92000000f,0.32000000f,0.59000000f,-0.96000000f,-0.46000000f,0.32000000f,0.53000000f,-0.28000000f,-0.00000000f,-0.04000000f,-0.99000000f,0.67000000f,-0.13000000f,-0.43000000f,0.50000000f,-0.65000000f,0.96000000f,0.71000000f,-0.71000000f,-0.40000000f,0.44000000f,0.25000000f,0.90000000f,0.45000000f,0.71000000f,-0.66000000f,0.00000000f,0.52000000f,0.93000000f,0.58000000f,0.29000000f,0.62000000f,0.27000000f,0.56000000f,0.42000000f,0.26000000f,0.78000000f,-0.92000000f,-0.29000000f,0.98000000f,0.97000000f,0.80000000f,0.53000000f,0.40000000f,-0.28000000f,-0.01000000f,-0.15000000f,0.00000000f,0.18000000f,0.01000000f,-0.46000000f,-0.81000000f,-0.42000000f,0.58000000f,-0.47000000f,0.40000000f,-0.81000000f,0.67000000f,0.70000000f,-0.64000000f,0.31000000f,-0.75000000f,-0.07000000f,0.73000000f,0.31000000f,0.20000000f,0.07000000f,-0.31000000f,-0.50000000f,-0.91000000f,-0.53000000f,0.80000000f,0.13000000f,-0.31000000f,0.46000000f,0.99000000f,-0.52000000f,0.09000000f,-0.21000000f,0.46000000f,-0.76000000f,0.27000000f,0.88000000f,0.30000000f,-0.83000000f,-0.85000000f,0.98000000f,-0.34000000f,-0.84000000f,0.50000000f,-0.78000000f,0.17000000f,-0.72000000f,-0.06000000f,-0.53000000f,-0.53000000f,-0.74000000f,0.95000000f,0.42000000f,0.25000000f,-0.73000000f,0.10000000f,-0.06000000f,-0.87000000f,0.01000000f,0.54000000f,0.87000000f,0.68000000f,-0.85000000f,0.53000000f,-0.02000000f,0.86000000f,-0.15000000f,0.23000000f,0.18000000f,-0.34000000f,0.67000000f,-0.82000000f,-0.70000000f,0.35000000f,-0.90000000f,0.09000000f,-0.03000000f,0.94000000f,0.69000000f,0.43000000f,0.60000000f,-0.87000000f,0.45000000f,0.61000000f,-0.31000000f,0.54000000f,-0.91000000f,-0.73000000f,0.58000000f,0.27000000f,-0.81000000f,-0.94000000f,-0.63000000f,-0.91000000f,0.10000000f,0.25000000f,0.08000000f,0.47000000f,-0.75000000f,-0.34000000f,0.69000000f,0.37000000f,0.90000000f,0.21000000f,0.81000000f,-0.53000000f,0.80000000f,-0.67000000f,-0.95000000f,-0.55000000f,0.21000000f,-0.04000000f,-0.12000000f,-0.64000000f,0.78000000f,0.15000000f,-0.49000000f,0.26000000f,-0.29000000f,0.09000000f,-0.84000000f,-0.93000000f,0.11000000f,0.58000000f,-0.67000000f,0.60000000f,-0.40000000f,-0.61000000f,0.72000000f,-0.36000000f,-0.24000000f,-0.89000000f,-0.21000000f,-0.82000000f,-0.37000000f,-0.57000000f,0.72000000f,-0.66000000f,0.63000000f,0.74000000f,0.37000000f,-0.51000000f,0.37000000f,-0.71000000f,0.92000000f,-0.34000000f,0.02000000f,-0.95000000f,-0.37000000f,-0.92000000f,0.04000000f,0.12000000f,-0.26000000f,-0.43000000f,-0.81000000f,-0.26000000f,-0.48000000f,0.44000000f,-0.12000000f,-0.75000000f,0.98000000f,-0.31000000f,-0.01000000f,0.29000000f,0.77000000f,0.29000000f,0.87000000f,0.47000000f,0.18000000f,0.07000000f,-0.99000000f,0.81000000f,0.14000000f,0.53000000f,-0.03000000f,-0.22000000f,0.28000000f,-0.56000000f,-0.86000000f,0.52000000f,0.83000000f,0.89000000f,-0.54000000f,-0.48000000f,-0.91000000f,0.80000000f,-0.12000000f,-0.06000000f,0.09000000f,0.75000000f,-0.36000000f,0.55000000f,0.55000000f,0.46000000f,0.74000000f,0.53000000f,0.99000000f,-0.33000000f,-0.45000000f,-0.06000000f,-0.12000000f,0.19000000f,-0.17000000f,-0.38000000f,-0.78000000f,-0.58000000f,-0.74000000f,-0.65000000f,-0.03000000f,-0.77000000f,-0.38000000f,-0.97000000f,0.24000000f,0.57000000f,0.75000000f,0.45000000f,0.39000000f,0.89000000f,-0.81000000f,-0.42000000f,0.93000000f,-0.87000000f,0.52000000f,0.44000000f,-0.34000000f,-0.16000000f,-0.02000000f,-0.85000000f,0.97000000f,-0.41000000f,-0.57000000f,0.96000000f,-0.94000000f,-0.66000000f,0.92000000f,-0.94000000f,0.23000000f,-0.06000000f,-0.68000000f,0.37000000f,0.30000000f,0.75000000f,-0.51000000f,0.12000000f,0.52000000f,-0.17000000f,0.55000000f,-0.17000000f,0.40000000f,0.60000000f,0.97000000f,0.83000000f,-0.13000000f,-0.28000000f,0.73000000f,-0.77000000f,0.36000000f,-0.03000000f,0.96000000f,0.41000000f,0.97000000f,-0.65000000f,-0.78000000f,-0.68000000f,0.71000000f,-0.25000000f,-0.02000000f,-0.14000000f,0.32000000f,0.48000000f,-0.85000000f,-0.12000000f,-0.11000000f,0.90000000f,-0.59000000f,-0.70000000f,0.19000000f,0.53000000f,-0.83000000f,0.34000000f,-0.22000000f,0.34000000f,-0.37000000f,0.01000000f,-0.64000000f,-0.40000000f,-0.64000000f,-0.04000000f,-0.41000000f,-0.77000000f,-0.63000000f,0.16000000f,-0.17000000f,0.29000000f,-0.19000000f,0.87000000f,0.49000000f,-0.09000000f,0.27000000f,-0.24000000f,0.73000000f,-0.55000000f,0.97000000f,-0.62000000f,0.64000000f,0.27000000f,-0.66000000f,-0.34000000f,0.39000000f,0.81000000f,-0.13000000f,0.14000000f,0.88000000f,-0.43000000f,0.79000000f,-0.88000000f,0.91000000f,-0.25000000f,-0.24000000f,-0.40000000f,-0.51000000f,-0.61000000f,0.11000000f,0.45000000f,0.23000000f,0.60000000f,-0.73000000f,0.20000000f,0.65000000f,-0.25000000f,-0.67000000f,0.76000000f,-0.83000000f,0.64000000f,-0.01000000f,-0.51000000f,-0.27000000f,-0.03000000f,0.33000000f,0.27000000f,-0.69000000f,-0.85000000f,0.06000000f,0.53000000f,-0.78000000f,0.85000000f,-0.26000000f,0.46000000f,-0.79000000f,0.86000000f,-0.25000000f,-0.67000000f,-0.88000000f,-0.69000000f,-0.71000000f,0.58000000f,0.09000000f,-0.60000000f,0.83000000f,0.40000000f,-0.88000000f,-0.15000000f,0.46000000f,0.05000000f,0.37000000f,0.25000000f,-0.85000000f,-0.39000000f,0.69000000f,-0.68000000f,-0.21000000f,0.97000000f,-0.03000000f,-0.13000000f,-0.59000000f,0.65000000f,-0.72000000f,-0.84000000f,-0.80000000f,0.42000000f,-0.36000000f,-0.11000000f,-0.84000000f,-0.27000000f,-0.13000000f,-0.03000000f,0.82000000f,0.33000000f,-0.24000000f,0.30000000f,-0.28000000f,0.41000000f,-0.56000000f,-0.47000000f,-0.18000000f,-0.57000000f,-0.56000000f,-0.87000000f,-0.05000000f,-0.17000000f,-0.31000000f,-0.73000000f,-0.89000000f,0.01000000f,0.20000000f,0.06000000f,-0.85000000f,-0.75000000f,0.78000000f,-0.60000000f,0.87000000f,0.91000000f,-0.13000000f,0.75000000f,-0.49000000f,0.96000000f,-0.60000000f,-0.87000000f,-0.49000000f,0.83000000f,0.42000000f,-0.29000000f,0.32000000f,-0.46000000f,-0.84000000f,0.37000000f,-0.36000000f,0.39000000f,-0.72000000f,0.24000000f,0.28000000f,-0.63000000f,0.40000000f,0.92000000f,-0.75000000f,-0.68000000f,0.74000000f,0.07000000f,0.60000000f,0.22000000f,-0.50000000f,-0.10000000f,-0.08000000f,0.50000000f,-0.34000000f,0.24000000f,-0.77000000f,-0.23000000f,0.77000000f,0.89000000f,-0.20000000f,0.89000000f,-0.95000000f,0.35000000f,0.19000000f,0.70000000f,-0.10000000f,0.07000000f,0.71000000f,0.16000000f,0.33000000f,0.37000000f,0.13000000f,-0.98000000f,-0.12000000f,-0.50000000f,0.68000000f,-0.62000000f,-0.38000000f,0.13000000f,0.86000000f,0.22000000f,-0.56000000f,0.35000000f,-0.98000000f,-0.72000000f,0.86000000f,-0.44000000f,0.73000000f,0.57000000f,0.84000000f,-0.93000000f,-0.62000000f,-0.67000000f,0.14000000f,-0.73000000f,-0.85000000f,-0.38000000f,0.01000000f,-0.87000000f,0.05000000f,-0.98000000f,-0.18000000f,0.56000000f,0.90000000f,-0.66000000f,-0.81000000f,0.09000000f,-0.63000000f,0.04000000f,-0.88000000f,0.74000000f,0.73000000f,0.71000000f,0.68000000f,0.27000000f,-0.52000000f,0.16000000f,-0.72000000f,0.10000000f,-0.71000000f,0.97000000f,-0.55000000f,-0.06000000f,-0.68000000f,-0.74000000f,-0.66000000f,-0.93000000f,0.23000000f,-0.35000000f,0.37000000f,0.54000000f,0.60000000f,0.10000000f,-0.76000000f,0.45000000f,-0.66000000f,-0.08000000f,0.98000000f,-0.09000000f,0.96000000f,-0.54000000f,-0.33000000f,-0.04000000f,0.36000000f,0.86000000f,-0.42000000f,-0.50000000f,0.45000000f,0.33000000f,0.78000000f,0.25000000f,0.58000000f,0.15000000f,-0.89000000f,-0.49000000f,0.42000000f,0.78000000f,-0.86000000f,-0.65000000f,0.81000000f,-0.67000000f,0.62000000f,0.14000000f,0.62000000f,0.05000000f,-0.93000000f,0.34000000f,-0.40000000f,0.01000000f,0.46000000f,-0.34000000f,0.51000000f,-0.86000000f,0.94000000f,-0.20000000f,-0.75000000f,0.27000000f,-0.09000000f,0.41000000f,-0.86000000f,0.80000000f,-0.13000000f,-0.31000000f,0.52000000f,-0.12000000f,0.46000000f,0.58000000f,0.60000000f,-0.12000000f,-0.45000000f,-0.61000000f,-0.33000000f,-0.80000000f,-0.25000000f,-0.00000000f,-0.20000000f,-0.48000000f,-0.98000000f,0.96000000f,-0.86000000f,-0.21000000f,0.30000000f,0.26000000f,0.53000000f,0.83000000f,0.82000000f,-0.39000000f,-0.66000000f,-0.69000000f,-0.42000000f,0.35000000f,-0.88000000f,0.27000000f,-0.34000000f,-0.21000000f,-0.89000000f,0.74000000f,-0.98000000f,-0.35000000f,-0.72000000f,-0.37000000f,-0.32000000f,0.39000000f,-0.24000000f,-0.83000000f,0.95000000f,-0.43000000f,0.72000000f,0.24000000f,-0.85000000f,-0.19000000f,0.55000000f,0.02000000f,0.34000000f,-0.41000000f,-0.08000000f,-0.25000000f,0.40000000f,-0.00000000f,0.58000000f,0.43000000f,0.79000000f,0.29000000f,-0.57000000f,-0.02000000f,-0.31000000f,-0.01000000f,0.33000000f,-0.09000000f,-0.07000000f,0.53000000f,-0.58000000f,0.94000000f,-0.64000000f,0.37000000f,0.63000000f,-0.79000000f,0.21000000f,0.72000000f,0.24000000f,0.09000000f,0.34000000f,0.15000000f,0.41000000f,0.94000000f,0.69000000f,0.51000000f,0.52000000f,-0.03000000f,-0.81000000f,-0.99000000f,-0.76000000f,0.33000000f,0.61000000f,0.03000000f,-0.61000000f,0.78000000f,0.69000000f,0.62000000f,-0.22000000f,-0.70000000f,-0.64000000f,0.55000000f,-0.56000000f,0.24000000f,-0.39000000f,0.33000000f,-0.08000000f,0.92000000f,0.88000000f,-0.94000000f,-0.85000000f,-0.47000000f,-0.96000000f,-0.51000000f,0.22000000f,0.87000000f,-0.85000000f,0.51000000f,0.27000000f,0.12000000f,-0.83000000f,-0.13000000f,-0.63000000f,0.72000000f,0.51000000f,0.35000000f,-0.94000000f,0.60000000f,0.79000000f,-0.57000000f,-0.70000000f,0.21000000f,-0.68000000f,-0.84000000f,0.10000000f,0.76000000f,0.92000000f,0.60000000f,-0.16000000f,0.85000000f,-0.28000000f,-0.00000000f,0.25000000f,0.61000000f,0.69000000f,-0.62000000f,0.17000000f,0.05000000f,0.08000000f,-0.87000000f,0.23000000f,0.95000000f,-0.82000000f,0.84000000f,-0.58000000f,0.76000000f,-0.46000000f,-0.35000000f,0.76000000f,-0.57000000f,0.70000000f,-0.14000000f,0.55000000f,0.57000000f,0.57000000f,-0.28000000f,-0.18000000f,0.46000000f,0.89000000f,0.07000000f,0.45000000f,-0.65000000f,-0.46000000f,0.01000000f,0.32000000f,-0.96000000f,-0.71000000f,0.05000000f,0.35000000f,-0.90000000f,-0.56000000f,0.72000000f,-0.33000000f,-0.48000000f,0.42000000f,0.32000000f,0.16000000f,-0.55000000f,-0.83000000f,0.42000000f,0.74000000f,0.41000000f,0.93000000f,0.61000000f,-0.39000000f,-0.03000000f,-0.81000000f,-0.37000000f,-0.55000000f,-0.06000000f,0.62000000f,0.69000000f,0.74000000f,0.21000000f,0.12000000f,-0.18000000f,0.25000000f,-0.66000000f,0.40000000f,-0.33000000f,0.95000000f,0.72000000f,0.29000000f,0.71000000f,-0.46000000f,-0.56000000f,-0.79000000f,0.59000000f,-0.71000000f,-0.02000000f,0.61000000f,0.66000000f,0.23000000f,-0.44000000f,0.99000000f,0.66000000f,-0.47000000f,0.99000000f,0.68000000f,-0.21000000f,-0.96000000f,-0.67000000f,0.39000000f,0.22000000f,-0.72000000f,0.01000000f,0.62000000f,0.68000000f,-0.87000000f,-0.92000000f,-0.64000000f,-0.60000000f,-0.51000000f,-0.45000000f,0.72000000f,-0.86000000f,0.99000000f,-0.77000000f,0.36000000f,0.20000000f,0.17000000f,-0.32000000f,-0.06000000f,0.10000000f,0.63000000f,-0.08000000f,-0.01000000f,0.58000000f,-0.31000000f,0.18000000f,-0.09000000f,0.10000000f,-0.72000000f,0.98000000f,-0.76000000f,-0.21000000f,-0.61000000f,0.19000000f,-0.52000000f,0.13000000f,0.39000000f,-0.53000000f,-0.86000000f,-0.91000000f,-0.57000000f,0.61000000f,0.47000000f,-0.73000000f,0.63000000f,0.07000000f,0.90000000f,-0.58000000f,0.52000000f,0.45000000f,-0.51000000f,-0.87000000f,0.31000000f,0.25000000f,-0.08000000f,0.53000000f,-0.73000000f,-0.08000000f,-0.86000000f,-0.63000000f,0.63000000f,-0.40000000f,-0.66000000f,-0.40000000f,-0.71000000f,-0.76000000f,0.66000000f,-0.22000000f,-0.58000000f,0.49000000f,-0.97000000f,0.84000000f,0.96000000f,-0.09000000f,-0.92000000f,-0.24000000f,0.01000000f,-0.97000000f,-0.80000000f,0.00000000f,-0.99000000f,0.62000000f,0.62000000f,-0.32000000f,0.11000000f,0.30000000f,0.80000000f,0.62000000f,-0.57000000f,0.89000000f,0.57000000f,-0.87000000f,-0.95000000f,0.74000000f,-0.57000000f,-0.31000000f,0.05000000f,-0.78000000f,-0.51000000f,0.84000000f,-0.40000000f,-0.97000000f,-0.31000000f,0.89000000f,-0.41000000f,0.15000000f,0.52000000f,0.19000000f,-0.33000000f,0.07000000f,0.74000000f,0.06000000f,-0.64000000f,-0.70000000f,0.58000000f,-0.31000000f,-0.99000000f,-0.46000000f,0.28000000f,0.08000000f,-0.73000000f,-0.31000000f,0.70000000f,-0.90000000f,0.28000000f,0.88000000f,-0.92000000f,-0.21000000f,-0.63000000f,0.47000000f,0.72000000f,0.86000000f,0.95000000f,0.79000000f,0.34000000f,0.16000000f,0.91000000f,0.65000000f,-0.86000000f,-0.81000000f,0.67000000f,0.18000000f,-0.58000000f,0.25000000f,-0.49000000f,0.52000000f,-0.86000000f,-0.25000000f,0.11000000f,-0.97000000f,0.44000000f,0.43000000f,0.64000000f,0.27000000f,-0.64000000f,-0.44000000f,0.96000000f,-0.44000000f,-0.79000000f,0.17000000f,-0.21000000f,0.86000000f,-0.61000000f,-0.16000000f,-0.68000000f,0.95000000f,0.67000000f,0.58000000f,0.10000000f,0.61000000f,-0.99000000f,-0.01000000f,0.86000000f,-0.80000000f,0.35000000f,-0.44000000f,0.84000000f,0.92000000f,-0.35000000f,0.62000000f,-0.40000000f,0.71000000f,-0.38000000f,0.43000000f,0.02000000f,0.74000000f,-0.66000000f,0.68000000f,0.29000000f,-0.79000000f,0.36000000f,0.07000000f,-0.04000000f,0.43000000f,-0.51000000f,-0.47000000f,0.55000000f,0.15000000f,0.82000000f,-0.94000000f,-0.59000000f,-0.85000000f,-0.74000000f,0.85000000f,0.41000000f,0.59000000f,0.53000000f,0.91000000f,0.12000000f,0.92000000f,-0.52000000f,0.41000000f,0.41000000f,-0.25000000f,0.64000000f,-0.45000000f,0.25000000f,-0.56000000f,-0.53000000f,0.16000000f,-0.75000000f,-0.85000000f,-0.16000000f,-0.84000000f,-0.85000000f,-0.57000000f,-0.57000000f,-0.00000000f,0.41000000f,-0.96000000f,0.34000000f,0.47000000f,-0.53000000f,-0.84000000f,0.00000000f,0.39000000f,-0.38000000f,0.87000000f,-0.84000000f,0.56000000f,-0.49000000f,0.32000000f,0.23000000f,-0.04000000f,-0.16000000f,-0.01000000f,-0.47000000f,-0.02000000f,0.57000000f,-0.69000000f,-0.71000000f,-0.71000000f,0.72000000f,0.82000000f,0.65000000f,0.73000000f,-0.31000000f,0.76000000f,-0.64000000f,0.15000000f,-0.50000000f,-0.59000000f,-0.94000000f,0.81000000f,0.78000000f,-0.19000000f,-0.56000000f,0.87000000f,-0.71000000f,0.65000000f,0.43000000f,0.79000000f,0.33000000f,0.07000000f,0.33000000f,-0.77000000f,0.11000000f,0.88000000f,0.47000000f,0.66000000f,-0.62000000f,0.89000000f,0.22000000f,-0.49000000f,-0.71000000f,-0.87000000f,0.77000000f,-0.86000000f,0.08000000f,-0.53000000f,-0.58000000f,0.89000000f,0.57000000f,-0.65000000f,-0.25000000f,-0.48000000f,-0.28000000f,-0.59000000f,0.60000000f,-0.56000000f,-0.06000000f,0.33000000f,0.29000000f,-0.00000000f,-0.66000000f,0.86000000f,-0.90000000f,-0.59000000f,-0.32000000f,0.00000000f,-0.16000000f,-0.59000000f,0.23000000f,0.45000000f,-0.86000000f,0.59000000f,0.37000000f,-0.79000000f,-0.57000000f,0.77000000f,0.34000000f,-0.08000000f,-0.98000000f,0.01000000f,0.69000000f,0.28000000f,-0.84000000f,0.74000000f,-0.02000000f,0.49000000f,0.29000000f,0.07000000f,0.09000000f,0.47000000f,0.87000000f,0.25000000f,0.38000000f,-0.31000000f,-0.12000000f,-0.23000000f,0.23000000f,-0.94000000f,-0.48000000f,0.38000000f,-0.12000000f,-0.66000000f,-0.72000000f,-0.21000000f,0.83000000f,0.78000000f,-0.27000000f,0.81000000f,0.58000000f,-0.93000000f,-0.63000000f,-0.42000000f,-0.16000000f,-0.96000000f,-0.73000000f,0.76000000f,0.32000000f,-0.60000000f,0.50000000f,0.24000000f,-0.48000000f,-0.20000000f,0.99000000f,-0.24000000f,0.59000000f,0.07000000f,-0.80000000f,-0.01000000f,0.45000000f,-0.48000000f,0.34000000f,-0.60000000f,0.15000000f,-0.40000000f,0.68000000f,0.69000000f,0.13000000f,-0.99000000f,-0.21000000f,-0.17000000f,0.29000000f,-0.20000000f,0.86000000f,-0.80000000f,0.82000000f,-0.36000000f,0.79000000f,0.75000000f,-0.37000000f,-0.54000000f,0.16000000f,-0.86000000f,0.36000000f,-0.46000000f,0.33000000f,-0.31000000f,0.75000000f,-0.62000000f,0.79000000f,-0.45000000f,0.34000000f,-0.72000000f,-0.67000000f,0.06000000f,0.17000000f,0.57000000f,0.89000000f,-0.08000000f,0.58000000f,-0.01000000f,0.27000000f,0.05000000f,-0.42000000f,-0.22000000f,0.86000000f,0.92000000f,-0.66000000f,-0.01000000f,-0.62000000f,0.62000000f,0.57000000f,0.17000000f,0.47000000f,-0.50000000f,-0.72000000f,-0.90000000f,0.05000000f,-0.40000000f,-0.77000000f,-0.71000000f,-0.03000000f,-0.81000000f,0.11000000f,-0.34000000f,-0.70000000f,0.05000000f,0.74000000f,-0.27000000f,-0.50000000f,-0.47000000f,0.87000000f,-0.15000000f,0.14000000f,0.31000000f,-0.67000000f,0.74000000f,-0.55000000f,0.41000000f,-0.80000000f,0.84000000f,-0.23000000f,0.10000000f,-0.17000000f,0.65000000f,0.79000000f,-0.67000000f,0.67000000f,-0.17000000f,0.32000000f,-0.06000000f,0.44000000f,0.13000000f,0.26000000f,-0.67000000f,0.63000000f,-0.17000000f,0.40000000f,0.26000000f,0.55000000f,0.29000000f,0.62000000f,0.83000000f,-0.41000000f,-0.07000000f,0.40000000f,-0.40000000f,-0.21000000f,0.45000000f,-0.88000000f,-0.83000000f,0.85000000f,-0.84000000f,0.43000000f,0.44000000f,0.24000000f,-0.32000000f,0.29000000f,-0.62000000f,-0.24000000f,0.38000000f,-0.84000000f,-0.97000000f,-0.68000000f,0.44000000f,-0.70000000f,-0.95000000f,-0.70000000f,-0.39000000f,-0.30000000f,-0.72000000f,-0.55000000f,-0.09000000f,-0.15000000f,0.77000000f,0.40000000f,-0.16000000f,-0.94000000f,-0.24000000f,-0.79000000f,-0.94000000f,0.46000000f,-0.35000000f,0.93000000f,0.10000000f,0.39000000f,-0.37000000f,-0.63000000f,0.03000000f,-0.13000000f,0.64000000f,0.49000000f,-0.52000000f,0.24000000f,-0.59000000f,0.13000000f,0.42000000f,-0.19000000f,0.33000000f,-0.33000000f,-0.67000000f,0.43000000f,0.22000000f,-0.85000000f,0.83000000f,-0.51000000f,0.60000000f,0.15000000f,-0.90000000f,-0.24000000f,-0.39000000f,0.90000000f,-0.87000000f,0.39000000f,-0.70000000f,-0.05000000f,-0.09000000f,-0.95000000f,-0.05000000f,-0.08000000f,0.92000000f,0.95000000f,-0.15000000f,-0.85000000f,-0.87000000f,0.53000000f,-0.31000000f,0.49000000f,-0.59000000f,0.92000000f,-0.82000000f,-0.97000000f,0.40000000f,-0.60000000f,0.80000000f,-0.48000000f,-0.68000000f,0.33000000f,0.73000000f,-0.37000000f,-0.31000000f,0.26000000f,0.62000000f,0.11000000f,0.65000000f,-0.73000000f,0.26000000f,-0.88000000f,0.33000000f,-0.03000000f,-0.54000000f,-0.92000000f,-0.74000000f,-0.80000000f,-0.82000000f,-0.61000000f,-0.97000000f,-0.09000000f,-0.81000000f,-0.83000000f,-0.84000000f,0.02000000f,-0.26000000f,0.60000000f,-0.30000000f,0.41000000f,-0.59000000f,-0.07000000f,-0.70000000f,0.74000000f,0.25000000f,-0.50000000f,0.88000000f,0.73000000f,-0.40000000f,0.49000000f,0.84000000f,0.27000000f,0.80000000f,-0.06000000f,-0.26000000f,0.16000000f,-0.87000000f,-0.86000000f,0.19000000f,0.88000000f,0.00000000f,0.19000000f,0.89000000f,0.94000000f,0.11000000f,-0.09000000f,0.04000000f,-0.15000000f,-0.07000000f,0.56000000f,0.71000000f,-0.94000000f,-0.13000000f,0.72000000f,0.50000000f,-0.17000000f,-0.58000000f,-0.35000000f,0.20000000f,-0.18000000f,-0.31000000f,-0.80000000f,-0.95000000f,-0.00000000f,0.84000000f,0.91000000f,0.34000000f,0.89000000f,-0.08000000f,0.90000000f,0.80000000f,-0.41000000f,-0.50000000f,0.95000000f,0.41000000f,0.52000000f,-0.21000000f,-0.99000000f,-0.77000000f,0.41000000f,-0.32000000f,-0.99000000f,0.21000000f,0.29000000f,0.82000000f,0.99000000f,0.57000000f,-0.46000000f,0.77000000f,-0.43000000f,-0.71000000f,0.13000000f,-0.61000000f,-0.38000000f,0.89000000f,-0.15000000f,-0.46000000f,-0.81000000f,-0.75000000f,0.54000000f,0.45000000f,0.88000000f,-0.25000000f,-0.74000000f,0.38000000f,0.52000000f,-0.93000000f,0.54000000f,0.50000000f,0.52000000f,0.41000000f,-0.64000000f,0.64000000f,0.04000000f,0.33000000f,0.38000000f,-0.97000000f,0.08000000f,-0.90000000f,0.49000000f,0.54000000f,-0.09000000f,0.90000000f,0.66000000f,0.20000000f,-0.75000000f,-0.42000000f,0.64000000f,0.33000000f,0.21000000f,-0.08000000f,0.02000000f,0.92000000f,-0.18000000f,-0.28000000f,0.75000000f,0.13000000f,0.37000000f,0.17000000f,0.89000000f,0.23000000f,-0.47000000f,0.90000000f,-0.24000000f,0.13000000f,-0.81000000f,0.73000000f,-0.12000000f,0.76000000f,-0.54000000f,0.19000000f,0.98000000f,0.81000000f,0.99000000f,0.76000000f,-0.33000000f,0.12000000f,0.22000000f,0.02000000f,-0.43000000f,-0.39000000f,-0.74000000f,-0.79000000f,0.26000000f,-0.14000000f,0.52000000f,-0.96000000f,-0.60000000f,-0.79000000f,-0.53000000f,0.11000000f,0.65000000f,-0.12000000f,-0.92000000f,-0.85000000f,-0.06000000f,0.31000000f,-0.55000000f,0.27000000f,-0.87000000f,-0.46000000f,-0.95000000f,0.23000000f,-0.52000000f,-0.96000000f,0.06000000f,-0.22000000f,-0.44000000f,-0.11000000f,0.34000000f,-0.89000000f,0.43000000f,-0.24000000f,0.48000000f,-0.07000000f,0.08000000f,-0.85000000f,-0.25000000f,0.92000000f,-0.27000000f,-0.03000000f,-0.06000000f,-0.85000000f,0.12000000f,-0.55000000f,-0.70000000f,-0.11000000f,0.70000000f,0.69000000f,0.76000000f,-0.91000000f,-0.63000000f,-0.61000000f,-0.98000000f,0.73000000f,-0.90000000f,-0.62000000f,0.68000000f,-0.87000000f,-0.56000000f,-0.27000000f,-0.70000000f,0.99000000f,0.79000000f,-0.41000000f,0.54000000f,-0.64000000f,0.61000000f,-0.35000000f,0.90000000f,-0.33000000f,0.51000000f,-0.59000000f,0.95000000f,-0.73000000f,0.15000000f,-0.22000000f,0.26000000f,0.72000000f,0.51000000f,0.61000000f,-0.00000000f,0.37000000f,0.58000000f,0.26000000f,-0.13000000f,0.41000000f,0.41000000f,-0.95000000f,-0.79000000f,0.58000000f,-0.20000000f,-0.86000000f,-0.20000000f,-0.60000000f,-0.44000000f,0.11000000f,-0.23000000f,0.91000000f,0.01000000f,0.87000000f,-0.19000000f,0.24000000f,0.01000000f,-0.88000000f,0.09000000f,0.08000000f,0.83000000f,0.02000000f,-0.57000000f,-0.21000000f,0.93000000f,0.91000000f,0.51000000f,-0.74000000f,0.29000000f,0.31000000f,0.41000000f,0.55000000f,0.72000000f,-0.93000000f,-0.47000000f,0.95000000f,-0.73000000f,-0.76000000f,-0.98000000f,-0.84000000f,0.31000000f,-0.89000000f,-0.27000000f,-0.70000000f,-0.22000000f,0.39000000f,0.81000000f,-0.85000000f,0.69000000f,-0.50000000f,-0.53000000f,-0.14000000f,-0.02000000f,0.31000000f,-0.74000000f,-0.19000000f,0.84000000f,0.99000000f,-0.92000000f,-0.35000000f,-0.30000000f,0.85000000f,-0.64000000f,-0.84000000f,0.69000000f,0.77000000f,0.91000000f,0.04000000f,0.94000000f,0.44000000f,0.28000000f,0.13000000f,-0.65000000f,-0.84000000f,0.61000000f,0.01000000f,0.78000000f,-0.17000000f,0.27000000f,0.72000000f,-0.14000000f,-0.18000000f,0.70000000f,-0.19000000f,0.57000000f,-0.89000000f,0.48000000f,0.36000000f,0.39000000f,0.46000000f,0.67000000f,0.16000000f,-0.86000000f,-0.52000000f,0.20000000f,-0.18000000f,0.70000000f,-0.11000000f,-0.57000000f,-0.96000000f,-0.27000000f,0.41000000f,0.72000000f,-0.33000000f,-0.93000000f,0.99000000f,-0.90000000f,0.79000000f,0.17000000f,-0.40000000f,-0.13000000f,0.92000000f,0.74000000f,-0.58000000f,-0.76000000f,-0.93000000f,0.65000000f,0.97000000f,0.27000000f,-0.84000000f,-0.61000000f,0.83000000f,-0.56000000f,-0.76000000f,-0.69000000f,-0.44000000f,-0.84000000f,-0.95000000f,0.33000000f,0.88000000f,-0.70000000f,0.30000000f,-0.69000000f,0.50000000f,-0.65000000f,-0.16000000f,-0.51000000f,0.81000000f,0.13000000f,-0.45000000f,0.35000000f,-0.10000000f,0.31000000f,-0.21000000f,0.39000000f,0.49000000f,-0.66000000f,0.44000000f,0.71000000f,0.87000000f,-0.61000000f,0.86000000f,-0.65000000f,0.87000000f,-0.89000000f,0.70000000f,-0.20000000f,-0.83000000f,0.61000000f,0.43000000f,-0.98000000f,-0.09000000f,-0.20000000f,-0.09000000f,0.99000000f,0.45000000f,0.28000000f,-0.28000000f,-0.46000000f,0.05000000f,0.96000000f,0.66000000f,0.72000000f,0.27000000f,-0.07000000f,-0.27000000f,0.54000000f,0.16000000f,0.54000000f,-0.60000000f,-0.50000000f,-0.94000000f,-0.28000000f,-0.05000000f,0.52000000f,0.65000000f,-0.99000000f,0.50000000f,-0.51000000f,0.28000000f,-0.93000000f,-0.15000000f,-0.64000000f,-0.62000000f,0.36000000f,-0.83000000f,0.86000000f,0.42000000f,0.60000000f,0.59000000f,0.42000000f,0.89000000f,0.50000000f,0.73000000f,-0.41000000f,-0.61000000f,-0.51000000f,-0.32000000f,-0.53000000f,0.64000000f,0.98000000f,-0.94000000f,-0.13000000f,0.06000000f,0.20000000f,-0.18000000f,-0.05000000f,0.50000000f,-0.39000000f,-0.08000000f,0.94000000f,-0.22000000f,-0.01000000f,0.51000000f,0.43000000f,-0.18000000f,-0.40000000f,0.08000000f,-0.40000000f,0.44000000f,-0.45000000f,-0.39000000f,0.39000000f,0.02000000f,0.81000000f,-0.75000000f,0.91000000f,-0.83000000f,0.06000000f,-0.36000000f,0.03000000f,0.11000000f,-0.19000000f,-0.29000000f,0.21000000f,-0.61000000f,0.44000000f,-0.86000000f,-0.69000000f,-0.18000000f,0.51000000f,0.90000000f,-0.05000000f,0.39000000f,-0.89000000f,-0.61000000f,0.66000000f,-0.06000000f,0.90000000f,0.20000000f,0.91000000f,-0.50000000f,-0.63000000f,0.68000000f,0.40000000f,-0.30000000f,0.28000000f,0.98000000f,-0.56000000f,-0.13000000f,-0.12000000f,0.29000000f,0.66000000f,0.07000000f,0.48000000f,0.60000000f,0.09000000f,0.09000000f,0.38000000f,0.63000000f,-0.27000000f,0.35000000f,-0.26000000f,-0.83000000f,-0.63000000f,-0.84000000f,0.87000000f,-0.94000000f,0.07000000f,0.17000000f,-0.98000000f,0.76000000f,-0.98000000f,0.81000000f,0.18000000f,-0.77000000f,-0.80000000f,-0.26000000f,0.76000000f,0.41000000f,-0.40000000f,-0.80000000f,0.16000000f,0.96000000f,0.81000000f,0.47000000f,-0.29000000f,0.57000000f,-0.06000000f,-0.04000000f,-0.30000000f,-0.92000000f,-0.18000000f,0.32000000f,-0.66000000f,-0.90000000f,0.74000000f,0.61000000f,0.37000000f,0.34000000f,0.67000000f,0.08000000f,0.80000000f,-0.27000000f,-0.49000000f,-0.15000000f,0.84000000f,-0.71000000f,0.56000000f,0.24000000f,0.89000000f,-0.00000000f,-0.44000000f,0.67000000f,-0.27000000f,0.31000000f,-0.86000000f,0.52000000f,0.87000000f,-0.03000000f,-0.34000000f,-0.38000000f,0.82000000f,0.84000000f,-0.30000000f,-0.13000000f,0.86000000f,-0.35000000f,0.67000000f,0.45000000f,-0.24000000f,0.95000000f,0.70000000f,-0.83000000f,-0.17000000f,-0.09000000f,-0.35000000f,-0.47000000f,0.71000000f,-0.75000000f,0.33000000f,0.64000000f,-0.68000000f,0.43000000f,0.38000000f,0.48000000f,0.21000000f,0.85000000f,-0.77000000f,0.11000000f,-0.19000000f,0.05000000f,-0.17000000f,-0.67000000f,-0.84000000f,-0.54000000f,-0.54000000f,-0.70000000f,-0.39000000f,-0.52000000f,-0.42000000f,-0.78000000f,0.39000000f,0.70000000f,-0.06000000f,-0.79000000f,0.41000000f,0.94000000f,0.83000000f,-0.33000000f,0.98000000f,-0.14000000f,-0.40000000f,-0.72000000f,0.66000000f,0.79000000f,0.79000000f,0.29000000f,-0.14000000f,-0.34000000f,0.40000000f,-0.95000000f,0.90000000f,-0.38000000f,-0.29000000f,0.95000000f,0.72000000f,0.17000000f,-0.54000000f,0.29000000f,-0.10000000f,0.93000000f,0.69000000f,-0.19000000f,0.20000000f,0.02000000f,0.96000000f,-0.05000000f,-0.49000000f,-0.93000000f,0.32000000f,-0.31000000f,0.07000000f,0.71000000f,-0.58000000f,0.08000000f,0.95000000f,-0.55000000f,0.95000000f,0.05000000f,0.42000000f,-0.98000000f,0.95000000f,-0.09000000f,-0.77000000f,0.42000000f,0.60000000f,-0.16000000f,0.29000000f,0.25000000f,0.39000000f,-0.81000000f,-0.90000000f,0.46000000f,-0.30000000f,0.10000000f,0.07000000f,0.81000000f,-0.57000000f,-0.31000000f,-0.21000000f,-0.12000000f,0.01000000f,-0.11000000f,0.66000000f,0.01000000f,0.90000000f,-0.38000000f,0.52000000f,0.08000000f,-0.77000000f,-0.66000000f,-0.54000000f,0.00000000f,-0.44000000f,0.17000000f,0.38000000f,-0.33000000f,0.80000000f,-0.80000000f,0.15000000f,-0.51000000f,-0.23000000f,-0.52000000f,0.37000000f,0.58000000f,-0.35000000f,-0.71000000f,-0.79000000f,-0.47000000f,-0.69000000f,-0.88000000f,-0.48000000f,0.28000000f,0.71000000f,0.46000000f,-0.28000000f,-0.13000000f,0.64000000f,-0.43000000f,-0.44000000f,0.44000000f,-0.11000000f,0.22000000f,0.10000000f,-0.94000000f,0.42000000f,-0.15000000f,0.25000000f,-0.25000000f,-0.88000000f,-0.29000000f,0.92000000f,-0.13000000f,0.06000000f,-0.35000000f,-0.66000000f,-0.77000000f,0.02000000f,-0.55000000f,0.51000000f,-0.57000000f,0.50000000f,0.68000000f,-0.22000000f,0.23000000f,0.00000000f,-0.66000000f,-0.36000000f,0.44000000f,0.25000000f,0.28000000f,0.96000000f,0.68000000f,-0.22000000f,-0.33000000f,-0.67000000f,0.11000000f,-0.33000000f,-0.15000000f,-0.16000000f,-0.87000000f,-0.37000000f,0.18000000f,0.62000000f,-0.25000000f,-0.13000000f,0.65000000f,-0.03000000f,-0.00000000f,0.30000000f,0.77000000f,0.63000000f,0.57000000f,0.93000000f,-0.37000000f,-0.06000000f,-0.72000000f,0.39000000f,0.36000000f,-0.28000000f,0.53000000f,0.00000000f,0.71000000f,-0.57000000f,-0.64000000f,0.30000000f,-0.40000000f,-0.30000000f,0.05000000f,-0.90000000f,0.36000000f,0.87000000f,0.77000000f,0.03000000f,-0.41000000f,-0.91000000f,0.81000000f,0.16000000f,-0.12000000f,-0.18000000f,0.30000000f,-0.51000000f,0.26000000f,-0.46000000f,-0.62000000f,0.79000000f,-0.98000000f,-0.60000000f,-0.90000000f,0.01000000f,-0.52000000f,0.66000000f,-0.49000000f,0.75000000f,-0.68000000f,-0.78000000f,-0.70000000f,0.44000000f,0.07000000f,-0.90000000f,-0.50000000f,0.22000000f,0.04000000f,-0.54000000f,0.35000000f,-0.38000000f,0.18000000f,-0.04000000f,-0.09000000f,-0.83000000f,-0.16000000f,-0.99000000f,-0.78000000f,-0.73000000f,0.71000000f,0.27000000f,0.15000000f,0.19000000f,0.29000000f,-0.20000000f,0.00000000f,0.38000000f,0.84000000f,-0.20000000f,0.28000000f,0.19000000f,-0.02000000f,-0.50000000f,-0.66000000f,-0.23000000f,0.79000000f,0.62000000f,0.20000000f,-0.24000000f,0.60000000f,-0.39000000f,-0.61000000f,-0.53000000f,-0.93000000f,0.99000000f,0.78000000f,-0.92000000f,0.92000000f,0.43000000f,0.46000000f,0.87000000f,0.32000000f,-0.53000000f,0.85000000f,-0.73000000f,-0.71000000f,-0.39000000f,-0.90000000f,-0.63000000f,0.01000000f,-0.38000000f,-0.62000000f,-0.25000000f,-0.37000000f,0.60000000f,-0.01000000f,0.18000000f,0.95000000f,0.99000000f,-0.70000000f,-0.76000000f,-0.15000000f,-0.78000000f,0.02000000f,0.08000000f,0.27000000f,-0.61000000f,0.62000000f,0.59000000f,-0.04000000f,0.46000000f,-0.63000000f,-0.05000000f,0.85000000f,-0.05000000f,-0.84000000f,-0.35000000f,-0.35000000f,0.63000000f,0.55000000f,-0.33000000f,-0.53000000f,0.62000000f,0.64000000f,-0.02000000f,0.06000000f,-0.39000000f,-0.55000000f,-0.09000000f,-0.17000000f,-0.09000000f,-0.84000000f,0.94000000f,-0.08000000f,-0.95000000f,-0.25000000f,0.12000000f,-0.26000000f,-0.94000000f,0.32000000f,-0.60000000f,-0.11000000f,-0.27000000f,-0.32000000f,0.31000000f,0.97000000f,0.64000000f,0.99000000f,-0.99000000f,-0.56000000f,0.96000000f,0.11000000f,-0.57000000f,-0.51000000f,0.82000000f,-0.35000000f,0.13000000f,0.70000000f,-0.97000000f,0.92000000f,0.59000000f,-0.03000000f,0.15000000f,-0.09000000f,0.46000000f,0.28000000f,0.73000000f,-0.17000000f,0.26000000f,-0.23000000f,0.45000000f,-0.96000000f,0.21000000f,-0.28000000f,-0.64000000f,-0.09000000f,0.68000000f,0.49000000f,-0.30000000f,-0.75000000f,0.98000000f,-0.71000000f,-0.42000000f,-0.52000000f,0.19000000f,0.52000000f,0.30000000f,0.92000000f,0.61000000f,-0.53000000f,0.62000000f,-0.15000000f,0.19000000f,0.07000000f,0.67000000f,0.92000000f,0.20000000f,-0.69000000f,-0.29000000f,-0.75000000f,0.54000000f,0.78000000f,0.92000000f,-0.70000000f,-0.70000000f,-0.40000000f,-0.41000000f,0.89000000f,-0.29000000f,0.02000000f,0.34000000f,-0.24000000f,0.48000000f,0.97000000f,0.75000000f,-0.66000000f,0.17000000f,-0.32000000f,-0.41000000f,0.24000000f,0.85000000f,-0.70000000f,0.39000000f,0.46000000f,-0.84000000f,0.86000000f,0.45000000f,-0.78000000f,-0.61000000f,0.74000000f,0.73000000f,0.78000000f,0.66000000f,-0.15000000f,-0.85000000f,0.46000000f,0.46000000f,-0.21000000f,-0.78000000f,-0.16000000f,0.12000000f,0.83000000f,0.05000000f,-0.95000000f,0.41000000f,0.45000000f,-0.02000000f,0.56000000f,-0.91000000f,-0.90000000f,-0.33000000f,-0.94000000f,-0.72000000f,-0.90000000f,-0.22000000f,-0.01000000f,-0.59000000f,0.58000000f,-0.37000000f,0.23000000f,-0.96000000f,0.41000000f,-0.65000000f,0.69000000f,-0.79000000f,0.14000000f,0.39000000f,-0.99000000f,-0.21000000f,-0.73000000f,-0.33000000f,0.53000000f,-0.15000000f,-0.04000000f,-0.00000000f,0.33000000f,0.12000000f,-0.44000000f,-0.88000000f,-0.93000000f,0.05000000f,0.73000000f,-0.66000000f,-0.85000000f,-0.17000000f,-0.47000000f,0.15000000f,0.65000000f,0.91000000f,-0.72000000f,0.32000000f,0.64000000f,-0.30000000f,-0.40000000f,-0.79000000f,-0.77000000f,0.27000000f,0.09000000f,0.65000000f,-0.85000000f,0.37000000f,0.57000000f,-0.79000000f,0.28000000f,0.02000000f,-0.92000000f,0.23000000f,0.66000000f,-0.38000000f,0.24000000f,-0.21000000f,0.84000000f,-0.71000000f,-0.12000000f,0.26000000f,-0.29000000f,0.26000000f,-0.08000000f,0.75000000f,0.54000000f,0.46000000f,0.11000000f,-0.81000000f,-0.53000000f,0.85000000f,-0.24000000f,-0.38000000f,0.95000000f,0.36000000f,0.77000000f,-0.37000000f,0.58000000f,0.91000000f,0.03000000f,0.13000000f,-0.98000000f,0.68000000f,0.74000000f,0.52000000f,0.42000000f,0.83000000f,-0.76000000f,0.52000000f,-0.79000000f,-0.57000000f,0.95000000f,-0.58000000f,-0.11000000f,-0.08000000f,0.57000000f,0.75000000f,-0.80000000f,0.33000000f,0.42000000f,-0.85000000f,-0.74000000f,-0.91000000f,-0.99000000f,-0.08000000f,-0.06000000f,-0.42000000f,0.33000000f,-0.45000000f,-0.09000000f,0.56000000f,-0.95000000f,0.98000000f,-0.24000000f,0.48000000f,-0.85000000f,-0.05000000f,0.73000000f,0.75000000f,0.43000000f,0.00000000f,-0.29000000f,-0.75000000f,-0.39000000f,-0.76000000f,0.35000000f,0.29000000f,-0.19000000f,-0.61000000f,-0.65000000f,-0.35000000f,0.74000000f,-0.12000000f,0.62000000f,0.59000000f,-0.11000000f,-0.36000000f,-0.37000000f,-0.59000000f,0.28000000f,-0.28000000f,-0.00000000f,0.60000000f,-0.40000000f,0.10000000f,-0.94000000f,-0.25000000f,-0.50000000f,-0.12000000f,-0.90000000f,0.13000000f,-0.39000000f,0.30000000f,-0.87000000f,0.76000000f,-0.61000000f,0.55000000f,0.17000000f,0.74000000f,-0.36000000f,0.52000000f,0.71000000f,-0.20000000f,0.07000000f,0.40000000f,0.61000000f,0.06000000f,0.68000000f,0.71000000f,-0.36000000f,-0.52000000f,-0.61000000f,-0.70000000f,-0.40000000f,0.00000000f,0.69000000f,-0.44000000f,-0.15000000f,0.45000000f,-0.63000000f,0.88000000f,0.23000000f,-0.98000000f,0.29000000f,-0.86000000f,-0.24000000f,0.65000000f,-0.61000000f,-0.61000000f,0.81000000f,0.10000000f,0.24000000f,0.84000000f,-0.98000000f,-0.26000000f,-0.17000000f,-0.05000000f,0.88000000f,-0.93000000f,-0.34000000f,0.10000000f,0.89000000f,-0.92000000f,0.88000000f,-0.01000000f,0.30000000f,0.01000000f,0.65000000f,-0.87000000f,-0.51000000f,0.42000000f,0.60000000f,0.02000000f,0.56000000f,-0.56000000f,-0.00000000f,0.63000000f,0.40000000f,0.32000000f,-0.12000000f,0.05000000f,0.61000000f,-0.57000000f,-0.84000000f,0.20000000f,-0.91000000f,0.48000000f,0.64000000f,-0.60000000f,-0.24000000f,0.84000000f,0.21000000f,-0.48000000f,0.26000000f,-0.71000000f,0.31000000f,0.21000000f,0.59000000f,0.90000000f,-0.38000000f,0.56000000f,-0.72000000f,0.22000000f,0.01000000f,0.74000000f,0.19000000f,-0.40000000f,-0.63000000f,0.76000000f,-0.67000000f,0.27000000f,0.09000000f,-0.04000000f,0.49000000f,0.33000000f,0.55000000f,0.73000000f,-0.41000000f,-0.49000000f,0.16000000f,-0.93000000f,0.37000000f,0.62000000f,0.68000000f,-0.51000000f,0.08000000f,0.89000000f,-0.35000000f,0.26000000f,0.77000000f,0.33000000f,0.42000000f,-0.66000000f,0.65000000f,-0.34000000f,0.87000000f,-0.97000000f,-0.16000000f,0.43000000f,-0.93000000f,-0.06000000f,0.00000000f,0.40000000f,0.06000000f,-0.16000000f,0.79000000f,0.46000000f,-0.60000000f,-0.68000000f,0.11000000f,-0.19000000f,0.33000000f,-0.37000000f,-0.94000000f,-0.08000000f,0.11000000f,0.20000000f,0.78000000f,0.34000000f,-0.61000000f,0.60000000f,-0.93000000f,-0.36000000f,0.96000000f,-0.37000000f,-0.79000000f,-0.56000000f,0.86000000f,0.36000000f,-0.68000000f,-0.18000000f,0.54000000f,0.14000000f,0.00000000f,0.23000000f,0.14000000f,0.83000000f,-0.45000000f,0.01000000f,0.59000000f,-0.02000000f,0.43000000f,-0.03000000f,0.97000000f,0.62000000f,-0.12000000f,0.90000000f,-0.90000000f,-0.08000000f,0.36000000f,-0.72000000f,0.02000000f,0.22000000f,-0.24000000f,0.96000000f,-0.33000000f,-0.13000000f,0.44000000f,-0.65000000f,0.95000000f,0.68000000f,-0.76000000f,0.18000000f,-0.06000000f,0.26000000f,0.74000000f,-0.38000000f,-0.08000000f,0.15000000f,0.45000000f,-0.97000000f,0.43000000f,-0.82000000f,-0.84000000f,0.99000000f,-0.55000000f,-0.93000000f,-0.07000000f,-0.29000000f,-0.59000000f,-0.91000000f,0.49000000f,-0.60000000f,-0.56000000f,0.63000000f,0.86000000f,0.49000000f,0.76000000f,0.69000000f,0.12000000f,0.67000000f,0.60000000f,0.12000000f,-0.79000000f,0.78000000f,0.35000000f,0.52000000f,-0.80000000f,-0.12000000f,0.25000000f,0.43000000f,0.69000000f,0.12000000f,-0.01000000f,0.47000000f,0.65000000f,-0.38000000f,0.99000000f,0.28000000f,-0.37000000f,-0.18000000f,0.69000000f,0.56000000f,0.80000000f,0.89000000f,-0.13000000f,0.57000000f,0.45000000f,-0.11000000f,0.62000000f,0.83000000f,0.14000000f,-0.80000000f,-0.12000000f,-0.04000000f,0.25000000f,0.59000000f,-0.17000000f,0.04000000f,-0.75000000f,0.75000000f,-0.56000000f,-0.46000000f,-0.27000000f,0.22000000f,0.53000000f,0.58000000f,0.03000000f,0.44000000f,-0.14000000f,0.26000000f,-0.22000000f,0.74000000f,0.28000000f,0.50000000f,-0.21000000f,-0.51000000f,-0.50000000f,0.73000000f,-0.67000000f,0.19000000f,-0.58000000f,-0.29000000f,0.56000000f,-0.77000000f,0.18000000f,-0.46000000f,0.59000000f,0.80000000f,0.95000000f,-0.66000000f,-0.67000000f,-0.57000000f,0.01000000f,-0.20000000f,0.27000000f,0.67000000f,-0.12000000f,-0.34000000f,0.72000000f,-0.05000000f,0.95000000f,-0.26000000f,0.30000000f,0.87000000f,-0.61000000f,0.91000000f,-0.68000000f,0.20000000f,-0.75000000f,-0.04000000f,0.12000000f,0.37000000f,-0.34000000f,0.06000000f,-0.92000000f,-0.76000000f,-0.04000000f,-0.17000000f,-0.73000000f,0.50000000f,-0.32000000f,-0.77000000f,-0.25000000f,-0.72000000f,-0.32000000f,-0.88000000f,0.97000000f,0.63000000f,-0.05000000f,0.05000000f,0.33000000f,0.46000000f,0.65000000f,-0.38000000f,0.36000000f,0.52000000f,-0.33000000f,-0.09000000f,0.57000000f,-0.44000000f,-0.80000000f,0.18000000f,-0.14000000f,0.83000000f,0.53000000f,0.45000000f,-0.82000000f,0.11000000f,0.24000000f,0.56000000f,-0.47000000f,-0.35000000f,-0.33000000f,0.97000000f,-0.77000000f,-0.42000000f,0.61000000f,-0.45000000f,0.57000000f,0.43000000f,0.69000000f,0.46000000f,0.22000000f,0.10000000f,-0.24000000f,0.52000000f,0.55000000f,-0.97000000f,0.09000000f,-0.52000000f,0.78000000f,0.50000000f,0.87000000f,-0.04000000f,0.21000000f,0.92000000f,0.15000000f,-0.85000000f,-0.64000000f,0.25000000f,0.20000000f,0.35000000f,0.85000000f,-0.95000000f,-0.36000000f,-0.75000000f,0.85000000f,0.62000000f,0.04000000f,-0.87000000f,0.41000000f,-0.07000000f,-0.71000000f,-0.30000000f,0.07000000f,0.37000000f,-0.16000000f,0.39000000f,-0.62000000f,-0.02000000f,0.57000000f,-0.37000000f,0.31000000f,-0.55000000f,-0.41000000f,-0.11000000f,-0.32000000f,-0.19000000f,0.31000000f,0.29000000f,0.44000000f,0.09000000f,-0.54000000f,0.38000000f,0.07000000f,0.10000000f,-0.71000000f,-0.97000000f,-0.48000000f,-0.55000000f,0.49000000f,-0.95000000f,0.92000000f,0.69000000f,0.24000000f,-0.82000000f,0.33000000f,-0.03000000f,-0.20000000f,-0.14000000f,-0.77000000f,-0.16000000f,0.57000000f,0.39000000f,0.84000000f,-0.73000000f,-0.48000000f,0.65000000f,0.33000000f,0.24000000f,-0.56000000f,0.31000000f,0.23000000f,0.44000000f,-0.97000000f,-0.87000000f,0.14000000f,-0.73000000f,-0.02000000f,0.18000000f,-0.09000000f,-0.02000000f,-0.27000000f,0.09000000f,0.96000000f,-0.01000000f,-0.79000000f,0.29000000f,-0.34000000f,0.99000000f,0.87000000f,-0.45000000f,0.55000000f,-0.25000000f,-0.69000000f,-0.75000000f,-0.45000000f,-0.27000000f,-0.00000000f,-0.99000000f,0.26000000f,0.07000000f,-0.60000000f,-0.50000000f,-0.11000000f,0.20000000f,0.01000000f,-0.09000000f,-0.56000000f,0.85000000f,0.96000000f,0.02000000f,0.09000000f,-0.63000000f,0.13000000f,0.61000000f,0.46000000f,-0.97000000f,0.29000000f,0.09000000f,-0.41000000f,-0.73000000f,0.43000000f,-0.49000000f,-0.33000000f,-0.35000000f,-0.36000000f,0.63000000f,0.41000000f,-0.57000000f,-0.39000000f,0.65000000f,-0.03000000f,-0.29000000f,0.06000000f,0.04000000f,0.97000000f,-0.50000000f,-0.54000000f,0.86000000f,-0.41000000f,0.57000000f,-0.12000000f,0.51000000f,-0.41000000f,0.77000000f,-0.89000000f,-0.74000000f,0.45000000f,0.99000000f,0.03000000f,0.96000000f,0.48000000f,0.47000000f,-0.71000000f,-0.85000000f,0.62000000f,-0.83000000f,-0.71000000f,-0.87000000f,0.97000000f,-0.41000000f,-0.20000000f,-0.84000000f,0.55000000f,-0.01000000f,-0.76000000f,0.15000000f,0.55000000f,0.26000000f,0.19000000f,0.70000000f,0.07000000f,-0.56000000f,-0.51000000f,0.48000000f,-0.55000000f,0.14000000f,0.53000000f,-0.53000000f,-0.99000000f,-0.22000000f,-0.61000000f,-0.88000000f,-0.26000000f,0.46000000f,-0.19000000f,-0.22000000f,0.20000000f,-0.02000000f,0.71000000f,-0.82000000f,-0.67000000f,0.80000000f,0.31000000f,-0.58000000f,-0.59000000f,-0.63000000f,0.48000000f,-0.73000000f,0.45000000f,0.49000000f,0.74000000f,0.59000000f,0.72000000f,-0.48000000f,0.18000000f,-0.12000000f,0.30000000f,0.81000000f,0.55000000f,0.97000000f,-0.66000000f,-0.52000000f,-0.99000000f,0.14000000f,-0.62000000f,-0.02000000f,0.90000000f,0.78000000f,0.77000000f,-0.05000000f,-0.06000000f,0.51000000f,-0.26000000f,0.64000000f,0.91000000f,0.66000000f,0.52000000f,0.19000000f,0.21000000f,-0.52000000f,0.96000000f,0.71000000f,0.28000000f,-0.89000000f,-0.01000000f,0.83000000f,0.07000000f,0.39000000f,-0.88000000f,0.28000000f,0.68000000f,-0.81000000f,-0.46000000f,0.42000000f,0.47000000f,-0.43000000f,-0.93000000f,0.43000000f,-0.76000000f,0.15000000f,0.88000000f,0.21000000f,0.30000000f,-0.85000000f,-0.26000000f,-0.12000000f,-0.96000000f,-0.84000000f,-0.97000000f,-0.49000000f,0.64000000f,0.42000000f,-0.50000000f,0.87000000f,0.19000000f,-0.13000000f,-0.46000000f,-0.45000000f,-0.95000000f,0.22000000f,0.41000000f,0.83000000f,-0.14000000f,-0.33000000f,0.87000000f,0.76000000f,-0.06000000f,-0.94000000f,0.72000000f,0.73000000f,-0.78000000f,0.90000000f,0.89000000f,0.84000000f,0.90000000f,0.28000000f,0.88000000f,0.86000000f,-0.62000000f,0.02000000f,-0.81000000f,-0.52000000f,-0.82000000f,-0.14000000f,-0.42000000f,-0.30000000f,-0.02000000f,0.79000000f,0.10000000f,-0.58000000f,-0.00000000f,0.95000000f,0.55000000f,-0.75000000f,-0.09000000f,0.36000000f,0.44000000f,0.30000000f,0.03000000f,-0.49000000f,-0.60000000f,0.95000000f,0.86000000f,-0.67000000f,-0.23000000f,0.28000000f,-0.45000000f,-0.58000000f,-0.52000000f,0.77000000f,-0.19000000f,-0.88000000f,-0.16000000f,0.08000000f,0.82000000f,-0.02000000f,0.45000000f,-0.66000000f,0.73000000f,0.94000000f,-0.55000000f,-0.54000000f,0.02000000f,0.62000000f,0.71000000f,-0.99000000f,0.10000000f,-0.06000000f,0.08000000f,0.79000000f,-0.00000000f,-0.77000000f,-0.47000000f,0.42000000f,0.83000000f,0.21000000f,0.08000000f,-0.43000000f,-0.14000000f,0.22000000f,0.32000000f,-0.03000000f,0.11000000f,0.12000000f,-0.64000000f,-0.58000000f,-0.54000000f,-0.08000000f,-0.38000000f,0.41000000f,0.61000000f,-0.65000000f,0.27000000f,0.98000000f,-0.40000000f,-0.13000000f,0.83000000f,0.74000000f,-0.68000000f,0.22000000f,-0.69000000f,0.42000000f,0.77000000f,-0.87000000f,-0.42000000f,-0.77000000f,-0.11000000f,0.25000000f,-0.69000000f,0.84000000f,-0.25000000f,-0.38000000f,-0.56000000f,-0.20000000f,-0.35000000f,0.83000000f,-0.89000000f,-0.51000000f,0.82000000f,-0.77000000f,0.05000000f,0.78000000f,0.71000000f,0.12000000f,-0.82000000f,-0.32000000f,0.09000000f,0.63000000f,0.70000000f,-0.49000000f,0.80000000f,0.25000000f,-0.85000000f,0.04000000f,-0.72000000f,0.56000000f,0.14000000f,0.62000000f,0.17000000f,-0.88000000f,-0.26000000f,0.20000000f,0.72000000f,-0.55000000f,-0.57000000f,-0.33000000f,0.66000000f,-0.12000000f,0.46000000f,-0.14000000f,-0.87000000f,-0.12000000f,0.08000000f,0.92000000f,0.41000000f,0.36000000f,-0.58000000f,-0.17000000f,0.25000000f,-0.97000000f,-0.87000000f,-0.86000000f,-0.43000000f,0.85000000f,-0.38000000f,-0.45000000f,0.47000000f,0.41000000f,0.98000000f,-0.67000000f,-0.13000000f,-0.36000000f,0.08000000f,-0.33000000f,0.92000000f,-0.96000000f,-0.13000000f,0.71000000f,0.77000000f,0.17000000f,-0.03000000f,-0.92000000f,-0.06000000f,0.00000000f,0.29000000f,-0.14000000f,-0.79000000f,0.64000000f,0.53000000f,0.82000000f,-0.02000000f,-0.39000000f,0.94000000f,-0.97000000f,-0.67000000f,-0.98000000f,-0.38000000f,-0.25000000f,-0.76000000f,0.21000000f,0.80000000f,0.24000000f,-0.69000000f,-0.44000000f,-0.80000000f,0.17000000f,-0.87000000f,0.33000000f,0.72000000f,-0.23000000f,-0.39000000f,0.52000000f,-0.39000000f,-0.14000000f,-0.70000000f,0.86000000f,-0.58000000f,0.05000000f,0.82000000f,0.19000000f,0.58000000f,-0.76000000f,0.00000000f,0.09000000f,0.97000000f,-0.60000000f,0.90000000f,-0.73000000f,-0.47000000f,-0.47000000f,0.18000000f,0.93000000f,-0.53000000f,0.71000000f,0.34000000f,0.48000000f,-0.12000000f,0.94000000f,0.12000000f,-0.44000000f,-0.35000000f,-0.93000000f,-0.00000000f,-0.91000000f,0.40000000f,0.37000000f,-0.87000000f,-0.86000000f,0.68000000f,0.55000000f,0.35000000f,-0.30000000f,0.31000000f,-0.37000000f,0.81000000f,0.89000000f,-0.00000000f,-0.72000000f,-0.24000000f,-0.33000000f,-0.09000000f,-0.79000000f,0.41000000f,0.15000000f,-0.30000000f,-0.99000000f,-0.00000000f,-0.07000000f,-0.55000000f,0.22000000f,0.54000000f,-0.15000000f,-0.45000000f,-0.79000000f,-0.75000000f,-0.50000000f,-0.69000000f,-0.59000000f,-0.67000000f,0.70000000f,0.29000000f,0.74000000f,0.83000000f,-0.83000000f,0.41000000f,-0.04000000f,-0.94000000f,0.59000000f,-0.38000000f,0.85000000f,0.34000000f,-0.06000000f,0.08000000f,0.79000000f,0.41000000f,-0.19000000f,-0.15000000f,0.25000000f,-0.66000000f,0.03000000f,0.57000000f,-0.17000000f,0.69000000f,0.32000000f,0.07000000f,-0.95000000f,0.49000000f,0.42000000f,-0.75000000f,0.70000000f,-0.09000000f,-0.98000000f,-0.93000000f,0.40000000f,-0.38000000f,0.36000000f,-0.49000000f,0.65000000f,-0.30000000f,0.14000000f,-0.99000000f,0.66000000f,-0.27000000f,0.94000000f,0.08000000f,-0.70000000f,0.78000000f,-0.93000000f,-0.97000000f,-0.89000000f,-0.94000000f,-0.77000000f,-0.75000000f,-0.87000000f,0.89000000f,-0.25000000f,0.61000000f,0.59000000f,-0.55000000f,-0.73000000f,0.26000000f,0.93000000f,-0.42000000f,0.66000000f,-0.91000000f,-0.72000000f,0.05000000f,0.26000000f,-0.49000000f,-0.00000000f,-0.88000000f,-0.66000000f,0.34000000f,0.93000000f,0.91000000f,0.94000000f,0.25000000f,0.72000000f,0.13000000f,-0.23000000f,-0.67000000f,-0.99000000f,-0.77000000f,0.45000000f,0.33000000f,0.68000000f,0.34000000f,0.43000000f,0.60000000f,0.36000000f,-0.72000000f,-0.56000000f,-0.41000000f,-0.72000000f,0.65000000f,0.34000000f,0.91000000f,0.95000000f,-0.90000000f,-0.85000000f,0.91000000f,0.80000000f,-0.60000000f,-0.96000000f,0.29000000f,-0.36000000f,-0.54000000f,0.81000000f,-0.95000000f,-0.54000000f,0.67000000f,0.13000000f,0.16000000f,0.73000000f,0.92000000f,0.00000000f,0.08000000f,-0.05000000f,0.84000000f,-0.42000000f,-0.82000000f,-0.31000000f,-0.82000000f,-0.14000000f,-0.65000000f,-0.15000000f,0.55000000f,0.56000000f,-0.93000000f,-0.06000000f,0.59000000f,0.48000000f,0.60000000f,0.08000000f,-0.81000000f,-0.72000000f,-0.69000000f,-0.19000000f,0.02000000f,0.25000000f,-0.38000000f,-0.41000000f,0.31000000f,-0.84000000f,-0.09000000f,0.64000000f,0.62000000f,-0.00000000f,0.78000000f,-0.87000000f,-0.50000000f,-0.85000000f,0.61000000f,-0.90000000f,0.96000000f,0.51000000f,0.99000000f,-0.33000000f,-0.44000000f,-0.23000000f,-0.27000000f,-0.03000000f,-0.75000000f,0.12000000f,-0.78000000f,-0.25000000f,0.44000000f,0.49000000f,0.33000000f,0.33000000f,-0.77000000f,-0.35000000f,-0.39000000f,-0.49000000f,0.00000000f,-0.20000000f,-0.06000000f,-0.78000000f,0.41000000f,0.31000000f,0.62000000f,-0.78000000f,-0.36000000f,0.98000000f,-0.03000000f,-0.41000000f,-0.01000000f,-0.81000000f,0.30000000f,-0.81000000f,0.60000000f,-0.05000000f,0.20000000f,0.70000000f,0.81000000f,0.64000000f,0.78000000f,0.84000000f,0.07000000f,0.86000000f,0.72000000f,0.59000000f,-0.58000000f,-0.85000000f,0.23000000f,0.03000000f,-0.40000000f,-0.29000000f,-0.16000000f,0.59000000f,0.79000000f,0.07000000f,-0.29000000f,0.45000000f,-0.94000000f,-0.48000000f,-0.65000000f,0.57000000f,0.43000000f,-0.31000000f,-0.18000000f,-0.83000000f,-0.85000000f,-0.27000000f,0.28000000f,0.58000000f,-0.07000000f,0.74000000f,0.09000000f,-0.80000000f,0.93000000f,-0.84000000f,0.74000000f,0.37000000f,0.85000000f,0.70000000f,-0.95000000f,0.35000000f,-0.81000000f,-0.54000000f,0.81000000f,0.05000000f,0.02000000f,0.47000000f,-0.70000000f,0.45000000f,0.44000000f,-0.12000000f,0.46000000f,-0.76000000f,0.42000000f,-0.38000000f,-0.47000000f,-0.80000000f,-0.96000000f,-0.97000000f,-0.95000000f,-0.91000000f,0.79000000f,-0.41000000f,-0.87000000f,0.60000000f,0.72000000f,0.19000000f,0.45000000f,0.99000000f,-0.02000000f,-0.70000000f,-0.89000000f,-0.75000000f,-0.54000000f,0.11000000f,-0.69000000f,0.94000000f,-0.86000000f,-0.34000000f,-0.79000000f,-0.75000000f,0.84000000f,-0.56000000f,0.63000000f,0.22000000f,-0.69000000f,0.34000000f,0.34000000f,0.38000000f,0.03000000f,0.43000000f,-0.38000000f,-0.70000000f,-0.34000000f,-0.01000000f,-0.47000000f,-0.88000000f,0.97000000f,-0.99000000f,0.33000000f,-0.79000000f,-0.79000000f,-0.78000000f,-0.14000000f,-0.58000000f,-0.93000000f,0.41000000f,0.14000000f,0.40000000f,-0.06000000f,0.31000000f,-0.69000000f,-0.83000000f,0.29000000f,0.08000000f,0.66000000f,0.71000000f,0.11000000f,0.28000000f,0.98000000f,0.94000000f,0.11000000f,0.91000000f,0.05000000f,-0.07000000f,0.33000000f,-0.97000000f,0.48000000f,-0.77000000f,0.93000000f,0.68000000f,-0.00000000f,0.36000000f,0.37000000f,-0.76000000f,0.51000000f,0.55000000f,-0.92000000f,0.15000000f,0.84000000f,-0.82000000f,0.02000000f,-0.15000000f,0.06000000f,0.05000000f,-0.10000000f,-0.57000000f,0.93000000f,0.03000000f,-0.61000000f,0.47000000f,-0.23000000f,0.39000000f,-0.54000000f,0.33000000f,-0.48000000f,0.45000000f,0.65000000f,0.64000000f,0.35000000f,0.64000000f,-0.39000000f,0.15000000f,0.54000000f,0.97000000f,-0.12000000f,-0.88000000f,0.57000000f,0.95000000f,0.91000000f,0.83000000f,0.64000000f,-0.16000000f,-0.85000000f,0.52000000f,0.03000000f,0.81000000f,0.10000000f,0.47000000f,0.39000000f,-0.66000000f,0.86000000f,0.69000000f,0.29000000f,-0.43000000f,-0.76000000f,0.58000000f,-0.76000000f,-0.89000000f,-0.12000000f,0.37000000f,0.83000000f,-0.02000000f,0.36000000f,0.79000000f,-0.29000000f,0.63000000f,0.18000000f,-0.24000000f,0.62000000f,-0.07000000f,-0.25000000f,0.07000000f,-0.17000000f,-0.60000000f,-0.66000000f,-0.21000000f,0.83000000f,0.04000000f,-0.63000000f,-0.35000000f,0.00000000f,0.22000000f,0.05000000f,-0.18000000f,0.26000000f,0.49000000f,0.51000000f,0.54000000f,-0.43000000f,0.10000000f,0.07000000f,-0.70000000f,0.69000000f,-0.19000000f,-0.24000000f,0.94000000f,0.22000000f,0.16000000f,-0.23000000f,-0.81000000f,-0.72000000f,0.58000000f,0.44000000f,-0.58000000f,-0.89000000f,0.59000000f,0.64000000f,0.72000000f,0.43000000f,0.82000000f,-0.57000000f,0.69000000f,0.27000000f,-0.20000000f,0.24000000f,0.07000000f,0.41000000f,-0.49000000f,0.72000000f,0.27000000f,-0.40000000f,0.11000000f,-0.58000000f,0.78000000f,-0.71000000f,0.97000000f,0.12000000f,0.00000000f,0.76000000f,0.77000000f,-0.70000000f,-0.13000000f,-0.41000000f,0.57000000f,0.42000000f,0.48000000f,0.59000000f,0.47000000f,0.16000000f,-0.10000000f,0.80000000f,0.53000000f,0.50000000f,-0.34000000f,0.78000000f,-0.20000000f,-0.70000000f,0.56000000f,-0.23000000f,-0.11000000f,-0.51000000f,0.44000000f,0.21000000f,-0.59000000f,0.08000000f,-0.43000000f,-0.87000000f,-0.60000000f,-0.35000000f,0.79000000f,-0.62000000f,-0.85000000f,-0.39000000f,-0.39000000f,-0.74000000f,0.80000000f,-0.19000000f,-0.93000000f,0.55000000f,-0.26000000f,-0.86000000f,-0.62000000f,-0.00000000f,-0.20000000f,-0.11000000f,0.95000000f,-0.27000000f,0.59000000f,0.61000000f,-0.78000000f,-0.64000000f,-0.09000000f,-0.51000000f,0.10000000f,0.83000000f,-0.22000000f,0.37000000f,0.40000000f,-0.74000000f,-0.68000000f,-0.22000000f,-0.36000000f,-0.82000000f,0.29000000f,0.29000000f,-0.04000000f,0.88000000f,-0.62000000f,0.49000000f,0.89000000f,-0.87000000f,0.30000000f,0.90000000f,0.54000000f,0.07000000f,-0.52000000f,-0.82000000f,0.65000000f,0.28000000f,0.73000000f,0.43000000f,0.34000000f,0.24000000f,-0.61000000f,-0.20000000f,-0.07000000f,0.85000000f,0.34000000f,-0.33000000f,0.14000000f,0.64000000f,-0.58000000f,0.32000000f,-0.46000000f,0.07000000f,0.88000000f,0.64000000f,0.12000000f,-0.26000000f,-0.11000000f,0.72000000f,-0.58000000f,-0.58000000f,-0.95000000f,0.38000000f,0.11000000f,-0.01000000f,0.15000000f,-0.10000000f,0.50000000f,0.66000000f,0.60000000f,-0.81000000f,0.75000000f,0.48000000f,0.65000000f,-0.83000000f,-0.81000000f,-0.92000000f,-0.31000000f,0.81000000f,-0.35000000f,0.49000000f,0.95000000f,-0.99000000f,0.17000000f,0.34000000f,0.60000000f,0.65000000f,-0.49000000f,-0.18000000f,-0.09000000f,0.35000000f,0.06000000f,0.92000000f,0.78000000f,-0.18000000f,-0.66000000f,0.46000000f,0.58000000f,-0.56000000f,-0.45000000f,0.63000000f,0.03000000f,0.28000000f,-0.84000000f,0.39000000f,0.06000000f,0.85000000f,0.04000000f,-0.50000000f,0.53000000f,0.62000000f,0.46000000f,-0.86000000f,-0.90000000f,-0.72000000f,0.12000000f,0.05000000f,-0.39000000f,-0.41000000f,0.59000000f,-0.19000000f,-0.22000000f,0.50000000f,0.32000000f,0.83000000f,-0.33000000f,-0.83000000f,-0.81000000f,-0.46000000f,-0.63000000f,-0.58000000f,-0.78000000f,-0.49000000f,-0.78000000f,0.19000000f,0.69000000f,-0.66000000f,0.27000000f,-0.10000000f,-0.09000000f,0.88000000f,0.08000000f,0.53000000f,-0.64000000f,-0.38000000f,0.46000000f,-0.64000000f,-0.55000000f,0.33000000f,-0.41000000f,-0.80000000f,0.11000000f,0.37000000f,-0.05000000f,-0.73000000f,-0.57000000f,0.93000000f,0.90000000f,-0.60000000f,0.93000000f,0.81000000f,0.94000000f,0.23000000f,0.06000000f,0.68000000f,-0.06000000f,-0.91000000f,-0.05000000f,0.40000000f,-0.11000000f,-0.83000000f,-0.67000000f,0.96000000f,-0.89000000f,-0.56000000f,0.96000000f,0.82000000f,-0.29000000f,0.80000000f,0.42000000f,0.23000000f,-0.05000000f,-0.06000000f,0.16000000f,-0.54000000f,0.08000000f,0.69000000f,0.97000000f,0.19000000f,-0.65000000f,0.87000000f,0.70000000f,0.67000000f,0.44000000f,0.10000000f,-0.12000000f,0.97000000f,0.07000000f,0.92000000f,-0.00000000f,-0.58000000f,-0.44000000f,0.66000000f,-0.63000000f,-0.32000000f,0.08000000f,0.53000000f,-0.11000000f,0.80000000f,-0.35000000f,0.98000000f,-0.66000000f,-0.63000000f,-0.80000000f,0.87000000f,-0.82000000f,0.09000000f,0.95000000f,-0.25000000f,-0.15000000f,0.72000000f,-0.97000000f,-0.45000000f,0.96000000f,0.49000000f,0.92000000f,-0.19000000f,-0.10000000f,-0.12000000f,-0.00000000f,-0.96000000f,0.76000000f,0.99000000f,-0.37000000f,0.84000000f,0.66000000f,-0.63000000f,-0.41000000f,0.37000000f,-0.29000000f,0.69000000f,0.61000000f,0.54000000f,-0.95000000f,0.97000000f,0.76000000f,0.02000000f,0.06000000f,0.83000000f,-0.94000000f,-0.77000000f,0.04000000f,-0.25000000f,0.57000000f,0.75000000f,0.46000000f,-0.96000000f,-0.49000000f,0.76000000f,0.35000000f,-0.80000000f,-0.74000000f,0.52000000f,-0.57000000f,-0.38000000f,-0.75000000f,-0.88000000f,0.76000000f,-0.69000000f,0.22000000f,-0.64000000f,0.65000000f,0.79000000f,-0.79000000f,0.78000000f,-0.13000000f,0.07000000f,-0.98000000f,0.63000000f,0.94000000f,-0.54000000f,0.52000000f,0.02000000f,-0.64000000f,-0.05000000f,0.04000000f,-0.91000000f,-0.05000000f,-0.54000000f,0.67000000f,0.44000000f,-0.43000000f,-0.37000000f,0.03000000f,0.37000000f,-0.51000000f,-0.36000000f,0.21000000f,0.65000000f,-0.62000000f,0.20000000f,-0.90000000f,-0.37000000f,-0.11000000f,-0.40000000f,-0.11000000f,0.50000000f,0.81000000f,0.46000000f,0.03000000f,-0.09000000f,0.05000000f,-0.20000000f,0.98000000f,0.45000000f,0.26000000f,-0.15000000f,-0.40000000f,0.70000000f,-0.17000000f,-0.59000000f,-0.23000000f,-0.80000000f,0.65000000f,-0.47000000f,0.39000000f,0.68000000f,-0.64000000f,0.15000000f,-0.89000000f,0.98000000f,-0.36000000f,0.15000000f,-0.59000000f,0.88000000f,0.47000000f,-0.01000000f,0.26000000f,-0.94000000f,0.39000000f,-0.76000000f,-0.43000000f,-0.29000000f,-0.88000000f,-0.52000000f,-0.42000000f,0.12000000f,-0.56000000f,0.09000000f,0.38000000f,0.32000000f,-0.22000000f,-0.29000000f,-0.46000000f,0.59000000f,-0.96000000f,0.30000000f,0.95000000f,-0.76000000f,-0.90000000f,-0.76000000f,0.56000000f,0.35000000f,-0.76000000f,0.42000000f,-0.72000000f,-0.67000000f,0.74000000f,-0.60000000f,0.90000000f,0.74000000f,-0.87000000f,-0.36000000f,-0.12000000f,0.29000000f,-0.83000000f,0.60000000f,0.35000000f,0.44000000f,-0.50000000f,0.19000000f,0.19000000f,0.42000000f,-0.47000000f,-0.50000000f,-0.35000000f,0.49000000f,0.41000000f,-0.19000000f,-0.08000000f,-0.70000000f,0.76000000f,-0.44000000f,0.69000000f,0.16000000f,-0.01000000f,0.56000000f,-0.85000000f,-0.11000000f,-0.87000000f,0.11000000f,0.17000000f,-0.05000000f,0.50000000f,0.24000000f,-0.47000000f,0.57000000f,0.59000000f,-0.90000000f,0.95000000f,-0.05000000f,0.02000000f,0.51000000f,0.82000000f,0.28000000f,0.91000000f,-0.59000000f,0.65000000f,-0.42000000f,-0.82000000f,0.84000000f,-0.31000000f,-0.41000000f,0.75000000f,0.68000000f,-0.67000000f,0.52000000f,-0.18000000f,0.79000000f,-0.38000000f,0.63000000f,0.33000000f,-0.93000000f,-0.59000000f,0.76000000f,-0.60000000f,0.03000000f,-0.77000000f,-0.34000000f,0.17000000f,-0.35000000f,0.81000000f,0.50000000f,0.82000000f,0.57000000f,0.61000000f,-0.38000000f,0.69000000f,0.69000000f,0.75000000f,-0.61000000f,-0.73000000f,0.53000000f,0.66000000f,-0.83000000f,-0.69000000f,0.67000000f,-0.41000000f,0.84000000f,-0.23000000f,0.70000000f,0.95000000f,0.66000000f,0.81000000f,0.64000000f,-0.55000000f,-0.80000000f,0.45000000f,-0.11000000f,-0.77000000f,-0.47000000f,-0.36000000f,-0.41000000f,-0.82000000f,-0.60000000f,-0.32000000f,-0.58000000f,0.49000000f,0.32000000f,-0.38000000f,0.35000000f,-0.88000000f,-0.11000000f,0.49000000f,0.24000000f,0.97000000f,0.68000000f,0.90000000f,0.62000000f,-0.40000000f,0.94000000f,-0.16000000f,-0.57000000f,-0.00000000f,-0.18000000f,0.55000000f,-0.88000000f,0.95000000f,-0.49000000f,-0.75000000f,0.54000000f,0.45000000f,0.03000000f,0.59000000f,0.17000000f,-0.22000000f,-0.44000000f,-0.63000000f,0.69000000f,0.08000000f,0.06000000f,-0.43000000f,0.00000000f,-0.50000000f,-0.86000000f,-0.48000000f,0.91000000f,-0.19000000f,-0.18000000f,-0.61000000f,0.85000000f,-0.41000000f,-0.73000000f,0.83000000f,-0.86000000f,0.66000000f,0.94000000f,-0.02000000f,-0.07000000f,0.21000000f,-0.68000000f,-0.33000000f,-0.40000000f,0.13000000f,-0.11000000f,0.59000000f,-0.91000000f,-0.28000000f,0.72000000f,0.18000000f,0.46000000f,-0.20000000f,-0.36000000f,-0.93000000f,-0.38000000f,0.91000000f,-0.03000000f,-0.85000000f,-0.05000000f,0.23000000f,-0.03000000f,-0.28000000f,0.68000000f,0.93000000f,0.07000000f,0.69000000f,-0.76000000f,-0.55000000f,0.42000000f,-0.27000000f,-0.28000000f,0.39000000f,-0.02000000f,0.95000000f,-0.43000000f,0.38000000f,0.70000000f,0.93000000f,-0.55000000f,-0.25000000f,-0.72000000f,-0.44000000f,0.97000000f,-0.72000000f,-0.24000000f,-0.66000000f,-0.99000000f,-0.29000000f,-0.93000000f,0.97000000f,0.64000000f,0.65000000f,0.95000000f,0.58000000f,0.13000000f,0.18000000f,0.42000000f,-0.38000000f,0.11000000f,0.60000000f,0.30000000f,-0.01000000f,0.79000000f,-0.31000000f,-0.70000000f,0.23000000f,-0.17000000f,-0.58000000f,-0.82000000f,0.13000000f,-0.75000000f,-0.44000000f,0.99000000f,0.26000000f,-0.55000000f,0.12000000f,-0.40000000f,0.85000000f,-0.93000000f,0.28000000f,-0.78000000f,-0.94000000f,0.99000000f,-0.71000000f,0.55000000f,-0.30000000f,0.20000000f,0.33000000f,-0.84000000f,-0.93000000f,-0.49000000f,-0.83000000f,-0.30000000f,-0.44000000f,-0.14000000f,0.96000000f,-0.71000000f,-0.68000000f,0.60000000f,0.74000000f,-0.86000000f,-0.10000000f,-0.04000000f,0.07000000f,-0.30000000f,0.28000000f,-0.10000000f,0.15000000f,-0.34000000f,0.94000000f,0.71000000f,0.17000000f,-0.48000000f,-0.53000000f,0.93000000f,0.73000000f,0.29000000f,-0.17000000f,-0.34000000f,-0.61000000f,-0.93000000f,0.94000000f,-0.14000000f,0.27000000f,0.49000000f,0.78000000f,-0.69000000f,0.36000000f,0.38000000f,0.49000000f,-0.93000000f,0.83000000f,-0.85000000f,0.51000000f,0.43000000f,0.61000000f,0.40000000f,-0.95000000f,-0.81000000f,0.09000000f,-0.87000000f,-0.42000000f,-0.85000000f,0.34000000f,-0.43000000f,0.72000000f,-0.40000000f,-0.51000000f,-0.39000000f,-0.50000000f,-0.74000000f,0.91000000f,0.49000000f,0.92000000f,0.84000000f,0.68000000f,-0.63000000f,-0.77000000f,0.25000000f,0.63000000f,-0.60000000f,0.32000000f,-0.94000000f,0.69000000f,-0.81000000f,0.55000000f,0.07000000f,0.58000000f,-0.76000000f,-0.82000000f,0.53000000f,-0.87000000f,-0.97000000f,-0.92000000f,-0.19000000f,0.12000000f,-0.70000000f,0.05000000f,0.99000000f,-0.88000000f,-0.76000000f,-0.81000000f,-0.81000000f,0.94000000f,-0.22000000f,0.44000000f,0.10000000f,-0.09000000f,0.34000000f,-0.72000000f,-0.19000000f,-0.44000000f,0.29000000f,0.74000000f,0.45000000f,0.77000000f,0.36000000f,0.37000000f,-0.59000000f,0.46000000f,0.41000000f,-0.86000000f,-0.10000000f,-0.42000000f,0.66000000f,0.11000000f,0.50000000f,0.17000000f,0.78000000f,0.92000000f,0.93000000f,0.64000000f,0.61000000f,0.53000000f,-0.51000000f,0.75000000f,-0.89000000f,-0.01000000f,0.50000000f,-0.27000000f,-0.40000000f,0.06000000f,0.66000000f,-0.02000000f,-0.70000000f,-0.13000000f,0.03000000f,-0.72000000f,-0.64000000f,0.67000000f,0.12000000f,-0.97000000f,0.97000000f,-0.74000000f,-0.56000000f,-0.11000000f,0.81000000f,-0.13000000f,-0.32000000f,0.06000000f,0.10000000f,0.77000000f,-0.80000000f,-0.68000000f,-0.14000000f,-0.53000000f,-0.70000000f,-0.18000000f,-0.37000000f,-0.61000000f,0.12000000f,0.65000000f,0.40000000f,-0.16000000f,-0.92000000f,0.92000000f,0.94000000f,-0.20000000f,-0.24000000f,0.33000000f,-0.75000000f,0.83000000f,0.67000000f,-0.10000000f,-0.18000000f,0.84000000f,-0.23000000f,-0.80000000f,0.77000000f,-0.80000000f,0.60000000f,-0.51000000f,0.64000000f,-0.63000000f,0.89000000f,-0.61000000f,0.00000000f,0.43000000f,0.86000000f,0.23000000f,-0.51000000f,0.05000000f,-0.23000000f,0.05000000f,0.32000000f,0.36000000f,0.78000000f,0.12000000f,-0.52000000f,0.52000000f,-0.86000000f,-0.37000000f,-0.63000000f,0.50000000f,-0.82000000f,-0.93000000f,0.49000000f,-0.20000000f,-0.35000000f,0.20000000f,-0.03000000f,0.09000000f,0.01000000f,0.26000000f,0.14000000f,0.82000000f,0.15000000f,0.26000000f,-0.83000000f,-0.22000000f,0.36000000f,0.26000000f,-0.40000000f,0.90000000f,0.87000000f,-0.96000000f,0.87000000f,0.73000000f,0.67000000f,0.08000000f,0.46000000f,0.59000000f,0.59000000f,0.82000000f,0.99000000f,-0.13000000f,0.18000000f,-0.04000000f,0.60000000f,-0.60000000f,0.84000000f,-0.80000000f,-0.54000000f,0.40000000f,-0.57000000f,-0.43000000f,-0.08000000f,-0.09000000f,0.62000000f,0.58000000f,0.89000000f,-0.38000000f,0.07000000f,-0.72000000f,-0.15000000f,0.20000000f,0.34000000f,-0.81000000f,-0.04000000f,-0.06000000f,0.77000000f,-0.95000000f,-0.99000000f,-0.05000000f,-0.13000000f,-0.37000000f,-0.21000000f,-0.31000000f,-0.77000000f,-0.82000000f,0.67000000f,0.71000000f,0.03000000f,0.98000000f,0.46000000f,-0.87000000f,0.55000000f,-0.14000000f,0.14000000f,0.26000000f,0.05000000f,0.31000000f,0.67000000f,-0.00000000f,-0.49000000f,-0.71000000f,-0.75000000f,-0.66000000f,0.27000000f,-0.29000000f,0.04000000f,-0.91000000f,0.02000000f,-0.68000000f,-0.03000000f,-0.47000000f,0.34000000f,-0.89000000f,-0.98000000f,-0.00000000f,0.11000000f,-0.52000000f,0.28000000f,-0.42000000f,0.60000000f,0.28000000f,0.42000000f,0.91000000f,-0.09000000f,0.23000000f,-0.44000000f,-0.39000000f,-0.20000000f,0.61000000f,0.82000000f,-0.43000000f,0.57000000f,0.15000000f,-0.03000000f,-0.71000000f,-0.19000000f,0.56000000f,0.54000000f,0.99000000f,-0.59000000f,-0.76000000f,-0.90000000f,0.05000000f,0.00000000f,-0.56000000f,-0.85000000f,-0.74000000f,0.31000000f,-0.92000000f,0.38000000f,0.13000000f,0.44000000f,0.94000000f,0.95000000f,0.35000000f,0.18000000f,0.35000000f,-0.16000000f,0.15000000f,0.21000000f,-0.90000000f,0.80000000f,0.50000000f,-0.68000000f,-0.20000000f,-0.99000000f,0.20000000f,0.71000000f,0.65000000f,0.46000000f,0.21000000f,0.19000000f,-0.64000000f,0.79000000f,-0.23000000f,0.69000000f,-0.71000000f,0.29000000f,-0.55000000f,0.61000000f,-0.31000000f,0.18000000f,-0.00000000f,0.40000000f,-0.89000000f,-0.38000000f,-0.08000000f,-0.43000000f,-0.87000000f,0.53000000f,-0.05000000f,0.55000000f,0.80000000f,-0.60000000f,-0.87000000f,-0.15000000f,-0.22000000f,-0.55000000f,-0.41000000f,-0.43000000f,0.69000000f,0.32000000f,-0.10000000f,-0.29000000f,0.26000000f,0.88000000f,-0.86000000f,-0.16000000f,-0.36000000f,-0.94000000f,0.47000000f,-0.75000000f,-0.15000000f,-0.10000000f,0.97000000f,0.93000000f,0.39000000f,0.29000000f,0.12000000f,0.49000000f,-0.38000000f,0.22000000f,0.24000000f,-0.33000000f,0.18000000f,0.37000000f,-0.80000000f,-0.77000000f,0.28000000f,-0.26000000f,0.05000000f,0.60000000f,-0.85000000f,-0.14000000f,0.90000000f,-0.44000000f,0.36000000f,-0.85000000f,-0.89000000f,0.36000000f,-0.93000000f,0.44000000f,-0.95000000f,-0.18000000f,0.62000000f,-0.50000000f,-0.58000000f,-0.08000000f,0.84000000f,0.33000000f,-0.96000000f,0.92000000f,0.41000000f,-0.61000000f,0.90000000f,0.09000000f,-0.70000000f,-0.73000000f,-0.64000000f,-0.09000000f,-0.09000000f,-0.42000000f,-0.90000000f,0.61000000f,0.71000000f,0.82000000f,-0.42000000f,0.56000000f,0.97000000f,0.64000000f,-0.49000000f,-0.22000000f,-0.94000000f,0.24000000f,-0.29000000f,-0.88000000f,-0.54000000f,0.97000000f,-0.76000000f,0.66000000f,-0.71000000f,-0.64000000f,-0.64000000f,-0.53000000f,0.20000000f,0.23000000f,-0.56000000f,-0.62000000f,-0.55000000f,0.18000000f,0.18000000f,-0.77000000f,0.19000000f,-0.68000000f,0.89000000f,0.50000000f,0.42000000f,-0.10000000f,-0.28000000f,0.41000000f,-0.39000000f,-0.51000000f,0.70000000f,-0.98000000f,0.44000000f,0.04000000f,-0.46000000f,-0.63000000f,-0.93000000f,-0.31000000f,0.41000000f,0.35000000f,0.53000000f,0.77000000f,0.60000000f,0.26000000f,-0.21000000f,0.82000000f,-0.92000000f,0.92000000f,-0.70000000f,-0.10000000f,0.64000000f,-0.83000000f,-0.55000000f,0.61000000f,0.77000000f,-0.72000000f,-0.30000000f,-0.85000000f,0.33000000f,-0.60000000f,0.19000000f,0.86000000f,0.70000000f,0.77000000f,0.21000000f,0.86000000f,0.04000000f,0.22000000f,0.95000000f,0.57000000f,0.36000000f,-0.41000000f,0.37000000f,-0.17000000f,0.29000000f,0.70000000f,-0.40000000f,-0.39000000f,-0.83000000f,-0.11000000f,0.84000000f,-0.43000000f,-0.48000000f,0.13000000f,-0.27000000f,-0.75000000f,-0.54000000f,0.79000000f,0.75000000f,-0.85000000f,0.90000000f,-0.41000000f,0.24000000f,0.29000000f,0.61000000f,0.69000000f,-0.03000000f,-0.72000000f,-0.36000000f,-0.33000000f,-0.32000000f,-0.11000000f,0.19000000f,-0.84000000f,-0.24000000f,-0.77000000f,-0.96000000f,0.70000000f,0.04000000f,0.95000000f,-0.97000000f,-0.11000000f,-0.24000000f,0.69000000f,-0.13000000f,0.85000000f,0.43000000f,-0.41000000f,-0.89000000f,0.70000000f,0.09000000f,-0.63000000f,0.57000000f,0.80000000f,0.56000000f,-0.62000000f,0.32000000f,-0.28000000f,0.54000000f,0.14000000f,-0.67000000f,-0.24000000f,-0.79000000f,0.23000000f,-0.95000000f,-0.16000000f,-0.85000000f,-0.18000000f,0.46000000f,-0.60000000f,0.36000000f,0.22000000f,-0.08000000f,0.15000000f,0.62000000f,-0.20000000f,0.88000000f,-0.26000000f,-0.13000000f,-0.11000000f,0.56000000f,0.17000000f,0.67000000f,-0.56000000f,0.49000000f,0.87000000f,-0.35000000f,-0.73000000f,-0.93000000f,-0.80000000f,-0.06000000f,-0.95000000f,-0.36000000f,-0.26000000f,0.34000000f,0.19000000f,0.57000000f,0.56000000f,-0.65000000f,0.60000000f,0.94000000f,0.86000000f,-0.16000000f,-0.95000000f,0.36000000f,0.12000000f,-0.42000000f,0.34000000f,0.75000000f,-0.14000000f,0.15000000f,0.03000000f,-0.17000000f,0.70000000f,0.95000000f,0.95000000f,0.79000000f,0.11000000f,-0.82000000f,-0.30000000f,0.75000000f,-0.72000000f,-0.91000000f,0.31000000f,-0.07000000f,0.42000000f,0.85000000f,0.00000000f,-0.47000000f,0.37000000f,-0.62000000f,0.22000000f,0.10000000f,0.75000000f,-0.15000000f,-0.13000000f,0.18000000f,-0.21000000f,0.45000000f,-0.35000000f,0.77000000f,-0.40000000f,-0.75000000f,0.59000000f,0.87000000f,-0.62000000f,-0.91000000f,0.55000000f,-0.09000000f,0.06000000f,0.30000000f,0.52000000f,-0.51000000f,-0.03000000f,0.89000000f,-0.05000000f,0.88000000f,0.83000000f,-0.66000000f,-0.01000000f,0.34000000f,-0.83000000f,0.60000000f,0.47000000f,0.65000000f,0.51000000f,0.70000000f,0.62000000f,0.99000000f,0.34000000f,0.41000000f,-0.31000000f,0.75000000f,0.61000000f,0.04000000f,0.54000000f,-0.42000000f,0.47000000f,-0.43000000f,0.39000000f,-0.58000000f,-0.44000000f,-0.02000000f,-0.08000000f,0.38000000f,-0.77000000f,-0.55000000f,-0.20000000f,0.63000000f,-0.93000000f,-0.96000000f,-0.04000000f,-0.26000000f,0.83000000f,0.34000000f,0.31000000f,-0.32000000f,0.37000000f,-0.74000000f,0.60000000f,-0.77000000f,-0.04000000f,0.65000000f,0.94000000f,-0.39000000f,0.01000000f,-0.76000000f,-0.25000000f,0.44000000f,0.87000000f,0.06000000f,-0.58000000f,-0.21000000f,0.67000000f,-0.97000000f,0.22000000f,0.24000000f,-0.16000000f,0.82000000f,-0.19000000f,0.66000000f,0.00000000f,0.50000000f,-0.85000000f,0.32000000f,-0.66000000f,0.11000000f,-0.48000000f,0.66000000f,-0.60000000f,-0.50000000f,0.29000000f,-0.93000000f,0.94000000f,-0.02000000f,0.41000000f,-0.13000000f,-0.04000000f,0.77000000f,0.31000000f,-0.23000000f,0.84000000f,0.25000000f,-0.48000000f,-0.51000000f,0.19000000f,-0.42000000f,-0.03000000f,-0.13000000f,0.78000000f,0.76000000f,0.23000000f,0.63000000f,0.23000000f,-0.82000000f,0.41000000f,0.10000000f,0.73000000f,0.49000000f,-0.94000000f,0.80000000f,-0.40000000f,0.78000000f,-0.12000000f,-0.49000000f,-0.80000000f,0.37000000f,0.96000000f,0.22000000f,-0.93000000f,0.78000000f,-0.74000000f,-0.71000000f,0.46000000f,-0.38000000f,0.86000000f,0.03000000f,0.48000000f,0.22000000f,-0.05000000f,0.13000000f,0.91000000f,-0.20000000f,0.36000000f,0.64000000f,0.26000000f,0.38000000f,-0.10000000f,0.57000000f,-0.14000000f,-0.72000000f,0.08000000f,0.55000000f,-0.91000000f,0.62000000f,0.27000000f,-0.49000000f,-0.22000000f,0.22000000f,-0.12000000f,-0.32000000f,-0.28000000f,0.15000000f,-0.92000000f,0.58000000f,-0.51000000f,-0.07000000f,-0.45000000f,-0.24000000f,-0.73000000f,0.63000000f,-0.70000000f,-0.11000000f,-0.46000000f,-0.75000000f,-0.58000000f,-0.15000000f,0.38000000f,-0.22000000f,0.23000000f,-0.26000000f,0.41000000f,0.14000000f,0.87000000f,0.44000000f,0.26000000f,0.79000000f,0.28000000f,0.19000000f,0.06000000f,0.84000000f,0.19000000f,0.91000000f,-0.25000000f,0.24000000f,0.07000000f,-0.46000000f,-0.57000000f,0.86000000f,0.98000000f,-0.33000000f,0.77000000f,0.04000000f,0.55000000f,-0.04000000f,-0.72000000f,-0.44000000f,0.36000000f,-0.73000000f,0.74000000f,-0.86000000f,0.71000000f,0.89000000f,-0.94000000f,-0.03000000f,0.07000000f,0.12000000f,-0.14000000f,-0.20000000f,-0.71000000f,-0.51000000f,-0.23000000f,-0.35000000f,-0.89000000f,0.75000000f,-0.95000000f,-0.48000000f,-0.34000000f,-0.16000000f,0.45000000f,0.34000000f,-0.50000000f,-0.82000000f,0.12000000f,0.18000000f,0.35000000f,-0.26000000f,-0.16000000f,-0.98000000f,0.80000000f,0.58000000f,-0.65000000f,-0.17000000f,0.77000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.43000000f,-0.88000000f,0.08000000f,0.23000000f,-0.70000000f,-0.69000000f,-0.76000000f,-0.11000000f,0.44000000f,-0.87000000f,0.70000000f,-0.73000000f,-0.55000000f,0.05000000f,0.30000000f,-0.02000000f,0.19000000f,0.20000000f,0.14000000f,0.08000000f,0.16000000f,0.44000000f,0.58000000f,-0.51000000f,-0.63000000f,0.32000000f,0.98000000f,-0.48000000f,-0.66000000f,-0.00000000f,-0.83000000f,0.39000000f,-0.95000000f,-0.32000000f,-0.28000000f,0.60000000f,0.59000000f,-0.94000000f,0.34000000f,-0.68000000f,-0.62000000f,0.46000000f,-0.87000000f,0.25000000f,-0.00000000f,0.12000000f,0.38000000f,0.69000000f,-0.54000000f,0.11000000f,0.03000000f,-0.76000000f,0.92000000f,0.52000000f,-0.33000000f,-0.36000000f,-0.33000000f,0.46000000f,-0.60000000f,0.33000000f,-0.56000000f,-0.77000000f,0.13000000f,0.31000000f,-0.65000000f,-0.67000000f,-0.58000000f,0.54000000f,0.41000000f,0.80000000f,-0.92000000f,0.77000000f,-0.44000000f,0.69000000f,-0.60000000f,0.13000000f,-0.82000000f,0.13000000f,0.27000000f,-0.36000000f,-0.88000000f,-0.77000000f,-0.72000000f,-0.94000000f,0.69000000f,0.18000000f,-0.29000000f,-0.12000000f,-0.81000000f,-0.51000000f,0.72000000f,-0.03000000f,0.32000000f,-0.25000000f,-0.83000000f,0.11000000f,0.14000000f,-0.76000000f,-0.62000000f,0.51000000f,0.87000000f,0.76000000f,-0.23000000f,0.52000000f,0.89000000f,-0.02000000f,-0.57000000f,0.81000000f,-0.83000000f,-0.10000000f,-0.88000000f,0.71000000f,0.30000000f,-0.66000000f,-0.38000000f,-0.56000000f,0.37000000f,0.02000000f,0.08000000f,-0.88000000f,-0.86000000f,0.01000000f,-0.61000000f,-0.44000000f,0.60000000f,0.34000000f,-0.90000000f,-0.50000000f,-0.11000000f,0.52000000f,-0.76000000f,0.04000000f,-0.53000000f,-0.10000000f,0.03000000f,0.07000000f,0.32000000f,0.98000000f,0.28000000f,0.13000000f,0.05000000f,0.62000000f,-0.15000000f,-0.39000000f,0.04000000f,-0.81000000f,0.84000000f,-0.48000000f,0.56000000f,-0.74000000f,0.39000000f,0.79000000f,-0.40000000f,-0.67000000f,-0.52000000f,0.67000000f,-0.68000000f,-0.55000000f,-0.65000000f,0.36000000f,0.27000000f,-0.14000000f,-0.14000000f,-0.58000000f,0.34000000f,0.14000000f,-0.33000000f,-0.67000000f,0.92000000f,-0.73000000f,-0.29000000f,0.96000000f,-0.43000000f,-0.85000000f,0.96000000f,0.65000000f,0.21000000f,0.76000000f,-0.74000000f,0.42000000f,-0.78000000f,-0.06000000f,0.21000000f,-0.03000000f,-0.83000000f,-0.42000000f,0.44000000f,-0.79000000f,-0.55000000f,-0.22000000f,-0.54000000f,-0.24000000f,0.68000000f,0.03000000f,-0.90000000f,0.81000000f,0.68000000f,0.70000000f,-0.84000000f,-0.41000000f,-0.26000000f,-0.67000000f,0.21000000f,-0.49000000f,0.00000000f,-0.99000000f,0.73000000f,0.96000000f,-0.50000000f,0.82000000f,0.83000000f,-0.41000000f,0.83000000f,-0.48000000f,-0.20000000f,0.84000000f,-0.79000000f,-0.93000000f,0.89000000f,-0.24000000f,0.59000000f,-0.10000000f,0.95000000f,0.43000000f,0.44000000f,-0.81000000f,0.61000000f,-0.49000000f,-0.78000000f,-0.97000000f,0.83000000f,-0.33000000f,0.26000000f,0.46000000f,-0.74000000f,-0.64000000f,0.49000000f,0.38000000f,0.92000000f,0.70000000f,0.51000000f,-0.64000000f,0.57000000f,0.55000000f,0.82000000f,-0.91000000f,-0.75000000f,-0.50000000f,-0.39000000f,-0.79000000f,-0.96000000f,-0.72000000f,-0.96000000f,0.78000000f,-0.81000000f,0.07000000f,-0.08000000f,-0.34000000f,-0.90000000f,0.26000000f,0.88000000f,-0.69000000f,-0.64000000f,-0.41000000f,0.46000000f,0.93000000f,-0.60000000f,-0.81000000f,-0.11000000f,-0.50000000f,-0.30000000f,-0.27000000f,0.59000000f,-0.02000000f,-0.71000000f,-0.78000000f,0.72000000f,0.11000000f,-0.84000000f,-0.84000000f,0.52000000f,0.45000000f,-0.90000000f,-0.64000000f,-0.38000000f,0.32000000f,-0.20000000f,0.20000000f,0.33000000f,-0.61000000f,0.79000000f,0.33000000f,-0.75000000f,-0.21000000f,-0.04000000f,0.65000000f,-0.27000000f,0.59000000f,0.60000000f,-0.49000000f,-0.38000000f,0.72000000f,0.87000000f,-0.36000000f,-0.97000000f,0.13000000f,-0.62000000f,-0.86000000f,-0.91000000f,-0.52000000f,0.45000000f,-0.41000000f,-0.38000000f,-0.29000000f,-0.07000000f,-0.69000000f,-0.86000000f,0.46000000f,0.60000000f,0.37000000f,0.14000000f,-0.12000000f,-0.75000000f,0.64000000f,-0.74000000f,0.00000000f,-0.91000000f,-0.44000000f,-0.75000000f,0.94000000f,0.91000000f,-0.12000000f,0.76000000f,0.25000000f,-0.75000000f,-0.42000000f,-0.71000000f,0.41000000f,0.55000000f,-0.99000000f,0.12000000f,0.83000000f,0.98000000f,-0.45000000f,0.16000000f,-0.89000000f,-0.38000000f,-0.36000000f,-0.89000000f,0.36000000f,0.27000000f,0.88000000f,0.64000000f,0.31000000f,-0.51000000f,0.48000000f,-0.31000000f,-0.94000000f,0.83000000f,-0.51000000f,0.51000000f,-0.32000000f,0.45000000f,-0.34000000f,0.62000000f,-0.88000000f,0.37000000f,0.48000000f,-0.25000000f,-0.87000000f,-0.40000000f,-0.35000000f,-0.60000000f,-0.48000000f,-0.62000000f,-0.14000000f,0.16000000f,-0.60000000f,-0.95000000f,0.70000000f,0.57000000f,0.38000000f,-0.42000000f,-0.76000000f,-0.37000000f,-0.13000000f,0.67000000f,0.46000000f,-0.54000000f,0.62000000f,0.87000000f,0.93000000f,-0.72000000f,0.56000000f,0.83000000f,-0.24000000f,-0.34000000f,-0.52000000f,0.65000000f,-0.64000000f,0.10000000f,-0.02000000f,-0.63000000f,-0.59000000f,-0.90000000f,-0.98000000f,0.28000000f,0.52000000f,-0.41000000f,0.27000000f,-0.97000000f,0.53000000f,0.29000000f,-0.58000000f,-0.44000000f,0.87000000f,0.32000000f,-0.02000000f,-0.49000000f,0.33000000f,0.61000000f,0.93000000f,-0.95000000f,0.65000000f,0.37000000f,-0.42000000f,-0.82000000f,0.95000000f,-0.96000000f,0.72000000f,-0.14000000f,-0.07000000f,0.03000000f,0.20000000f,0.87000000f,0.52000000f,-0.40000000f,-0.72000000f,-0.95000000f,0.49000000f,-0.29000000f,0.17000000f,0.93000000f,0.04000000f,-0.55000000f,0.37000000f,0.92000000f,-0.99000000f,0.94000000f,0.24000000f,-0.90000000f,-0.60000000f,-0.87000000f,0.48000000f,0.19000000f,-0.27000000f,0.12000000f,-0.50000000f,-0.97000000f,0.85000000f,-0.02000000f,0.68000000f,0.03000000f,0.30000000f,-0.53000000f,0.66000000f,0.38000000f,0.72000000f,0.12000000f,-0.62000000f,-0.46000000f,-0.61000000f,-0.89000000f,0.24000000f,-0.80000000f,0.13000000f,-0.52000000f,0.45000000f,-0.02000000f,0.13000000f,0.03000000f,0.02000000f,0.22000000f,0.50000000f,0.70000000f,0.46000000f,0.40000000f,-0.00000000f,0.49000000f,-0.96000000f,0.75000000f,-0.31000000f,0.60000000f,0.06000000f,-0.57000000f,0.20000000f,-0.79000000f,-0.70000000f,0.08000000f,0.71000000f,0.89000000f,0.75000000f,-0.65000000f,0.50000000f,-0.89000000f,0.15000000f,0.05000000f,0.95000000f,0.77000000f,-0.03000000f,-0.52000000f,0.52000000f,0.60000000f,0.00000000f,-0.92000000f,0.34000000f,0.38000000f,-0.69000000f,0.26000000f,-0.74000000f,0.29000000f,0.39000000f,0.18000000f,-0.06000000f,0.19000000f,-0.67000000f,-0.79000000f,0.96000000f,-0.63000000f,-0.55000000f,-0.86000000f,-0.29000000f,0.68000000f,-0.57000000f,-0.10000000f,-0.87000000f,0.22000000f,0.70000000f,0.09000000f,0.17000000f,0.27000000f,-0.30000000f,-0.53000000f,0.50000000f,0.80000000f,0.07000000f,0.09000000f,-0.85000000f,0.07000000f,0.52000000f,-0.71000000f,-0.71000000f,0.13000000f,-0.57000000f,0.39000000f,-0.45000000f,0.45000000f,0.93000000f,-0.82000000f,0.09000000f,0.94000000f,-0.77000000f,-0.58000000f,-0.46000000f,-0.40000000f,0.47000000f,-0.85000000f,-0.92000000f,-0.01000000f,-0.35000000f,0.33000000f,-0.74000000f,0.79000000f,0.10000000f,-0.24000000f,0.07000000f,0.97000000f,-0.67000000f,-0.69000000f,-0.64000000f,-0.31000000f,-0.19000000f,0.39000000f,-0.73000000f,0.18000000f,0.10000000f,0.14000000f,-0.97000000f,-0.37000000f,-0.36000000f,-0.33000000f,0.64000000f,-0.16000000f,-0.60000000f,-0.78000000f,0.84000000f,-0.77000000f,-0.40000000f,0.68000000f,-0.49000000f,0.13000000f,0.39000000f,0.98000000f,-0.35000000f,0.05000000f,-0.97000000f,-0.12000000f,0.93000000f,0.88000000f,0.33000000f,0.02000000f,0.17000000f,0.80000000f,-0.71000000f,0.98000000f,0.92000000f,-0.97000000f,0.75000000f,0.48000000f,0.22000000f,0.74000000f,-0.51000000f,0.67000000f,-0.87000000f,0.44000000f,0.84000000f,0.28000000f,-0.04000000f,0.41000000f,0.33000000f,-0.68000000f,0.52000000f,0.55000000f,-0.81000000f,-0.63000000f,0.57000000f,-0.48000000f,-0.29000000f,-0.51000000f,0.76000000f,-0.78000000f,-0.39000000f,-0.15000000f,-0.24000000f,-0.01000000f,-0.37000000f,-0.87000000f,0.64000000f,0.07000000f,0.19000000f,-0.96000000f,0.77000000f,0.48000000f,0.95000000f,0.27000000f,-0.55000000f,-0.47000000f,0.00000000f,-0.99000000f,-0.89000000f,-0.31000000f,0.05000000f,-0.08000000f,-0.56000000f,0.30000000f,0.41000000f,-0.63000000f,0.44000000f,0.80000000f,0.11000000f,0.14000000f,-0.62000000f,-0.41000000f,-0.94000000f,-0.64000000f,0.44000000f,-0.49000000f,-0.89000000f,0.42000000f,-0.82000000f,-0.97000000f,-0.83000000f,-0.41000000f,0.68000000f,0.89000000f,0.40000000f,0.09000000f,0.28000000f,0.09000000f,0.01000000f,0.32000000f,0.33000000f,-0.31000000f,0.29000000f,-0.57000000f,0.26000000f,0.70000000f,0.28000000f,0.34000000f,0.12000000f,-0.39000000f,0.77000000f,0.83000000f,0.30000000f,0.52000000f,-0.97000000f,0.80000000f,-0.94000000f,-0.53000000f,-0.33000000f,-0.38000000f,-0.25000000f,-0.20000000f,-0.22000000f,0.37000000f,-0.64000000f,0.95000000f,-0.26000000f,-0.46000000f,-0.97000000f,-0.86000000f,-0.73000000f,-0.19000000f,0.62000000f,0.45000000f,0.33000000f,-0.14000000f,0.87000000f,-0.41000000f,0.01000000f,-0.67000000f,-0.14000000f,0.59000000f,-0.29000000f,0.20000000f,-0.33000000f,0.19000000f,0.50000000f,0.68000000f,0.60000000f,0.21000000f,0.91000000f,0.29000000f,-0.77000000f,0.48000000f,0.54000000f,-0.72000000f,0.26000000f,0.94000000f,-0.82000000f,0.26000000f,0.08000000f,-0.69000000f,0.20000000f,0.66000000f,0.65000000f,-0.77000000f,0.22000000f,-0.17000000f,-0.31000000f,0.56000000f,0.86000000f,0.53000000f,-0.06000000f,0.73000000f,-0.52000000f,0.27000000f,0.99000000f,-0.73000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.15000000f,-0.14000000f,-0.70000000f,0.86000000f,-0.83000000f,-0.02000000f,-0.18000000f,-0.53000000f,0.53000000f,-0.23000000f,0.94000000f,-0.23000000f,-0.32000000f,0.23000000f,-0.73000000f,-0.43000000f,0.06000000f,-0.75000000f,-0.88000000f,0.43000000f,0.50000000f,-0.74000000f,-0.17000000f,0.03000000f,0.74000000f,-0.18000000f,-0.97000000f,-0.09000000f,0.88000000f,0.63000000f,-0.88000000f,-0.42000000f,0.03000000f,-0.19000000f,0.54000000f,-0.26000000f,0.30000000f,-0.13000000f,0.74000000f,0.36000000f,0.05000000f,-0.31000000f,0.77000000f,-0.24000000f,-0.95000000f,-0.52000000f,0.95000000f,0.23000000f,0.87000000f,-0.09000000f,0.08000000f,0.24000000f,0.16000000f,0.31000000f,0.88000000f,0.48000000f,-0.12000000f,0.30000000f,-0.42000000f,-0.10000000f,0.44000000f,-0.91000000f,-0.43000000f,-0.95000000f,0.62000000f,0.36000000f,0.91000000f,-0.74000000f,0.74000000f,-0.08000000f,0.55000000f,0.12000000f,-0.14000000f,0.82000000f,0.22000000f,0.77000000f,-0.11000000f,0.81000000f,0.29000000f,-0.52000000f,-0.47000000f,0.75000000f,-0.08000000f,0.23000000f,0.45000000f,0.87000000f,0.48000000f,-0.41000000f,0.09000000f,0.46000000f,0.71000000f,0.73000000f,0.23000000f,-0.87000000f,-0.90000000f,-0.38000000f,-0.72000000f,0.23000000f,0.36000000f,0.64000000f,-0.87000000f,-0.82000000f,-0.97000000f,0.96000000f,0.97000000f,-0.63000000f,-0.92000000f,0.73000000f,0.29000000f,-0.54000000f,-0.20000000f,-0.96000000f,-0.15000000f,0.98000000f,-0.50000000f,-0.42000000f,0.29000000f,-0.21000000f,0.71000000f,-0.71000000f,0.58000000f,0.12000000f,-0.61000000f,-0.37000000f,-0.28000000f,-0.00000000f,0.66000000f,-0.80000000f,-0.29000000f,-0.83000000f,-0.15000000f,0.70000000f,0.27000000f,-0.37000000f,0.02000000f,-0.28000000f,0.85000000f,0.14000000f,0.26000000f,0.06000000f,-0.72000000f,0.07000000f,0.33000000f,0.18000000f,-0.56000000f,0.66000000f,0.51000000f,-0.21000000f,0.41000000f,-0.69000000f,-0.38000000f,0.42000000f,-0.04000000f,0.71000000f,0.66000000f,-0.26000000f,0.28000000f,0.74000000f,0.61000000f,0.22000000f,0.47000000f,-0.44000000f,0.49000000f,-0.26000000f,0.61000000f,-0.24000000f,0.07000000f,-0.63000000f,-0.24000000f,-0.44000000f,-0.41000000f,0.74000000f,-0.27000000f,0.60000000f,0.47000000f,-0.69000000f,0.13000000f,-0.10000000f,0.36000000f,-0.54000000f,-0.05000000f,-0.26000000f,0.50000000f,-0.62000000f,0.19000000f,-0.05000000f,0.56000000f,-0.12000000f,0.33000000f,0.60000000f,-0.50000000f,-0.40000000f,0.12000000f,-0.06000000f,0.95000000f,0.06000000f,0.60000000f,0.00000000f,0.32000000f,-0.73000000f,-0.05000000f,0.42000000f,0.24000000f,-0.51000000f,0.37000000f,-0.86000000f,0.49000000f,-0.35000000f,0.07000000f,0.21000000f,-0.03000000f,0.13000000f,-0.03000000f,-0.19000000f,0.48000000f,-0.29000000f,-0.56000000f,-0.35000000f,0.57000000f,-0.98000000f,-0.21000000f,0.50000000f,0.95000000f,0.51000000f,-0.40000000f,0.77000000f,0.26000000f,0.77000000f,0.71000000f,-0.28000000f,0.98000000f,-0.78000000f,0.55000000f,-0.96000000f,-0.30000000f,-0.06000000f,0.72000000f,0.79000000f,0.32000000f,0.46000000f,-0.42000000f,0.38000000f,-0.22000000f,0.82000000f,0.65000000f,0.63000000f,-0.92000000f,-0.99000000f,0.07000000f,-0.28000000f,-0.48000000f,-0.22000000f,0.29000000f,0.61000000f,0.04000000f,0.76000000f,0.77000000f,-0.89000000f,-0.84000000f,-0.18000000f,0.27000000f,-0.14000000f,0.13000000f,0.75000000f,-0.53000000f,0.88000000f,-0.46000000f,0.22000000f,-0.57000000f,-0.19000000f,-0.11000000f,-0.96000000f,0.16000000f,0.69000000f,0.37000000f,0.06000000f,0.59000000f,0.21000000f,-0.74000000f,0.53000000f,0.74000000f,0.68000000f,-0.60000000f,0.81000000f,-0.74000000f,-0.82000000f,-0.84000000f,-0.64000000f,-0.09000000f,0.31000000f,0.54000000f,0.34000000f,0.86000000f,0.30000000f,-0.72000000f,0.25000000f,0.51000000f,0.62000000f,0.47000000f,-0.67000000f,0.33000000f,-0.68000000f,0.63000000f,0.84000000f,0.91000000f,-0.85000000f,-0.24000000f,-0.48000000f,-0.40000000f,0.29000000f,0.24000000f,-0.76000000f,0.27000000f,0.60000000f,-0.51000000f,-0.27000000f,-0.99000000f,0.58000000f,0.87000000f,0.58000000f,-0.42000000f,0.18000000f,0.97000000f,-0.42000000f,-0.96000000f,-0.30000000f,-0.98000000f,-0.05000000f,0.98000000f,0.35000000f,-0.82000000f,-0.55000000f,0.87000000f,0.13000000f,0.13000000f,-0.14000000f,-0.61000000f,-0.75000000f,-0.58000000f,0.24000000f,-0.33000000f,-0.79000000f,0.95000000f,0.19000000f,0.01000000f,0.54000000f,-0.40000000f,-0.60000000f,0.08000000f,-0.59000000f,0.71000000f,-0.98000000f,-0.94000000f,0.73000000f,0.46000000f,-0.54000000f,0.23000000f,0.49000000f,-0.26000000f,0.26000000f,0.63000000f,-0.32000000f,-0.34000000f,-0.14000000f,0.01000000f,0.68000000f,-0.03000000f,0.53000000f,0.40000000f,-0.90000000f,0.70000000f,-0.13000000f,0.31000000f,0.12000000f,-0.57000000f,0.52000000f,-0.55000000f,0.98000000f,-0.71000000f,-0.75000000f,-0.71000000f,-0.23000000f,0.54000000f,0.19000000f,0.78000000f,-0.41000000f,-0.81000000f,-0.34000000f,-0.03000000f,-0.78000000f,-0.71000000f,-0.98000000f,0.69000000f,0.08000000f,0.16000000f,0.64000000f,-0.23000000f,-0.71000000f,0.35000000f,-0.53000000f,-0.45000000f,-0.01000000f,-0.99000000f,0.38000000f,-0.20000000f,-0.62000000f,0.56000000f,0.82000000f,0.98000000f,0.26000000f,0.00000000f,0.36000000f,0.29000000f,-0.78000000f,-0.88000000f,0.46000000f,0.00000000f,0.13000000f,-0.22000000f,0.73000000f,-0.42000000f,0.67000000f,-0.75000000f,0.76000000f,0.72000000f,0.95000000f,0.46000000f,-0.81000000f,-0.98000000f,-0.38000000f,-0.05000000f,-0.02000000f,0.77000000f,-0.53000000f,-0.53000000f,-0.68000000f,-0.98000000f,0.07000000f,-0.08000000f,0.40000000f,-0.59000000f,-0.03000000f,-0.13000000f,0.70000000f,0.07000000f,-0.82000000f,0.06000000f,-0.09000000f,0.66000000f,0.15000000f,0.73000000f,0.39000000f,-0.84000000f,-0.33000000f,-0.48000000f,-0.81000000f,-0.01000000f,-0.43000000f,0.42000000f,0.55000000f,0.31000000f,-0.78000000f,-0.15000000f,-0.04000000f,0.81000000f,0.26000000f,-0.38000000f,0.00000000f,0.54000000f,0.21000000f,-0.60000000f,-0.75000000f,0.92000000f,-0.60000000f,-0.51000000f,0.95000000f,-0.37000000f,-0.81000000f,0.44000000f,0.68000000f,0.71000000f,-0.37000000f,0.61000000f,0.29000000f,-0.27000000f,-0.96000000f,-0.14000000f,-0.06000000f,-0.74000000f,-0.09000000f,0.51000000f,-0.89000000f,0.47000000f,-0.75000000f,0.40000000f,0.50000000f,0.45000000f,-0.68000000f,0.77000000f,0.31000000f,-0.50000000f,-0.45000000f,0.52000000f,0.97000000f,0.05000000f,-0.91000000f,0.61000000f,-0.36000000f,-0.26000000f,-0.36000000f,0.47000000f,-0.34000000f,0.97000000f,-0.45000000f,0.19000000f,-0.08000000f,0.39000000f,0.35000000f,-0.28000000f,0.81000000f,-0.73000000f,0.37000000f,-0.39000000f,0.15000000f,-0.79000000f,-0.73000000f,0.37000000f,-0.65000000f,0.72000000f,-0.47000000f,0.57000000f,-0.57000000f,-0.82000000f,-0.87000000f,-0.62000000f,-0.92000000f,0.92000000f,0.85000000f,-0.32000000f,0.04000000f,-0.79000000f,0.96000000f,0.77000000f,0.13000000f,-0.19000000f,0.44000000f,-0.10000000f,-0.65000000f,-0.49000000f,0.33000000f,0.72000000f,0.96000000f,0.13000000f,-0.66000000f,-0.78000000f,0.76000000f,-0.44000000f,-0.69000000f,0.87000000f,0.67000000f,-0.34000000f,0.87000000f,0.92000000f,0.02000000f,-0.28000000f,-0.21000000f,-0.56000000f,0.36000000f,0.96000000f,0.53000000f,-0.19000000f,-0.15000000f,-0.73000000f,0.39000000f,0.53000000f,-0.78000000f,0.26000000f,-0.56000000f,0.17000000f,0.69000000f,0.20000000f,-0.08000000f,0.45000000f,0.19000000f,0.51000000f,-0.96000000f,-0.42000000f,0.59000000f,0.16000000f,0.48000000f,-0.75000000f,-0.71000000f,0.11000000f,-0.24000000f,-0.31000000f,-0.67000000f,-0.96000000f,-0.05000000f,-0.53000000f,0.62000000f,0.81000000f,0.37000000f,0.07000000f,0.80000000f,0.40000000f,-0.38000000f,-0.84000000f,-0.57000000f,0.96000000f,-0.23000000f,0.62000000f,-0.88000000f,0.49000000f,0.49000000f,0.37000000f,0.82000000f,-0.83000000f,-0.00000000f,0.93000000f,-0.25000000f,0.13000000f,-0.69000000f,0.87000000f,0.94000000f,0.71000000f,0.58000000f,0.51000000f,0.97000000f,-0.44000000f,-0.76000000f,0.48000000f,0.01000000f,0.11000000f,-0.57000000f,0.53000000f,-0.85000000f,-0.45000000f,0.31000000f,-0.02000000f,-0.27000000f,0.39000000f,0.86000000f,-0.42000000f,-0.67000000f,-0.34000000f,0.39000000f,0.42000000f,-0.08000000f,0.25000000f,0.01000000f,-0.45000000f,-0.11000000f,0.65000000f,-0.89000000f,-0.44000000f,0.54000000f,0.66000000f,0.53000000f,-0.96000000f,-0.09000000f,0.57000000f,0.20000000f,-0.16000000f,0.90000000f,-0.02000000f,0.92000000f,0.67000000f,-0.06000000f,0.51000000f,-0.54000000f,-0.79000000f,0.08000000f,0.89000000f,-0.96000000f,0.77000000f,-0.83000000f,-0.72000000f,0.95000000f,0.06000000f,0.38000000f,0.80000000f,0.20000000f,0.17000000f,-0.30000000f,0.76000000f,-0.39000000f,-0.81000000f,-0.59000000f,-0.66000000f,0.35000000f,0.01000000f,-0.53000000f,0.07000000f,0.94000000f,0.88000000f,0.97000000f,-0.18000000f,0.14000000f,0.41000000f,-0.83000000f,-0.00000000f,0.59000000f,-0.05000000f,0.03000000f,0.84000000f,-0.17000000f,-0.32000000f,-0.79000000f,-0.86000000f,-0.55000000f,-0.09000000f,0.57000000f,0.01000000f,0.80000000f,-0.11000000f,0.68000000f,0.92000000f,-0.57000000f,0.60000000f,-0.07000000f,-0.10000000f,0.66000000f,0.47000000f,0.62000000f,0.11000000f,-0.50000000f,0.01000000f,-0.03000000f,0.84000000f,-0.15000000f,-0.45000000f,-0.07000000f,0.19000000f,0.94000000f,-0.10000000f,-0.46000000f,-0.47000000f,-0.78000000f,0.05000000f,0.70000000f,-0.96000000f,0.88000000f,-0.84000000f,0.72000000f,-0.40000000f,0.46000000f,0.44000000f,0.31000000f,0.10000000f,0.36000000f,0.42000000f,0.42000000f,-0.29000000f,-0.87000000f,0.16000000f,-0.24000000f,0.62000000f,0.05000000f,0.13000000f,-0.11000000f,0.80000000f,-0.23000000f,0.18000000f,0.43000000f,-0.91000000f,0.75000000f,0.38000000f,0.84000000f,0.61000000f,-0.83000000f,-0.34000000f,-0.01000000f,0.05000000f,-0.39000000f,0.05000000f,-0.64000000f,0.62000000f,-0.29000000f,0.56000000f,-0.06000000f,0.23000000f,-0.39000000f,0.18000000f,0.44000000f,0.04000000f,0.36000000f,0.89000000f,0.93000000f,0.24000000f,0.42000000f,0.25000000f,-0.45000000f,-0.63000000f,-0.22000000f,0.09000000f,-0.27000000f,0.27000000f,0.28000000f,-0.12000000f,-0.97000000f,-0.20000000f,0.55000000f,-0.43000000f,-0.35000000f,-0.64000000f,0.63000000f,0.42000000f,-0.93000000f,-0.76000000f,-0.98000000f,0.90000000f,0.80000000f,-0.64000000f,-0.92000000f,0.34000000f,-0.81000000f,0.79000000f,-0.77000000f,0.56000000f,0.60000000f,-0.05000000f,-0.63000000f,-0.32000000f,0.51000000f,-0.52000000f,-0.20000000f,0.38000000f,0.80000000f,-0.63000000f,-0.52000000f,-0.13000000f,-0.06000000f,0.01000000f,-0.66000000f,0.14000000f,-0.45000000f,0.78000000f,0.07000000f,0.00000000f,0.17000000f,-0.46000000f,0.47000000f,-0.10000000f,0.31000000f,-0.16000000f,-0.62000000f,-0.32000000f,-0.85000000f,0.24000000f,-0.01000000f,-0.63000000f,0.80000000f,0.92000000f,0.54000000f,-0.85000000f,-0.74000000f,-0.93000000f,-0.98000000f,0.54000000f,-0.23000000f,-0.36000000f,0.20000000f,0.75000000f,0.22000000f,0.71000000f,-0.07000000f,-0.13000000f,0.40000000f,-0.82000000f,0.46000000f,-0.39000000f,0.34000000f,-0.35000000f,0.12000000f,-0.42000000f,0.63000000f,0.68000000f,0.04000000f,0.97000000f,-0.04000000f,-0.38000000f,0.87000000f,0.12000000f,0.02000000f,-0.71000000f,-0.81000000f,-0.43000000f,0.56000000f,0.80000000f,0.88000000f,0.51000000f,-0.78000000f,-0.52000000f,0.35000000f,-0.52000000f,0.21000000f,-0.51000000f,0.19000000f,-0.05000000f,0.64000000f,0.72000000f,-0.69000000f,0.45000000f,-0.94000000f,0.41000000f,-0.80000000f,-0.17000000f,0.67000000f,-0.41000000f,0.08000000f,0.15000000f,-0.55000000f,0.13000000f,-0.25000000f,-0.85000000f,0.77000000f,0.47000000f,-0.44000000f,0.39000000f,-0.71000000f,-0.62000000f,0.65000000f,0.35000000f,0.20000000f,0.25000000f,0.62000000f,-0.53000000f,-0.97000000f,-0.36000000f,-0.12000000f,-0.93000000f,-0.46000000f,0.39000000f,0.07000000f,0.06000000f,-0.88000000f,0.07000000f,0.01000000f,-0.95000000f,-0.02000000f,0.52000000f,0.41000000f,-0.88000000f,0.55000000f,0.99000000f,0.11000000f,0.76000000f,-0.90000000f,0.97000000f,-0.25000000f,-0.92000000f,0.65000000f,0.94000000f,0.71000000f,-0.82000000f,-0.46000000f,0.44000000f,0.21000000f,0.84000000f,-0.49000000f,0.55000000f,-0.20000000f,0.45000000f,0.48000000f,-0.58000000f,0.96000000f,0.52000000f,0.01000000f,0.31000000f,-0.67000000f,0.52000000f,-0.66000000f,-0.77000000f,0.18000000f,0.36000000f,-0.32000000f,0.51000000f,0.23000000f,0.58000000f,-0.45000000f,-0.52000000f,0.22000000f,-0.46000000f,0.79000000f,0.49000000f,0.40000000f,0.81000000f,-0.44000000f,0.79000000f,-0.50000000f,0.90000000f,0.13000000f,0.34000000f,0.93000000f,0.31000000f,0.56000000f,-0.83000000f,0.90000000f,-0.18000000f,0.55000000f,-0.05000000f,-0.82000000f,0.16000000f,0.67000000f,0.08000000f,-0.82000000f,-0.04000000f,-0.05000000f,0.69000000f,0.75000000f,0.74000000f,-0.37000000f,0.09000000f,0.82000000f,-0.32000000f,0.16000000f,0.67000000f,0.50000000f,0.37000000f,0.63000000f,-0.65000000f,0.28000000f,0.34000000f,0.09000000f,0.41000000f,-0.64000000f,0.57000000f,0.80000000f,-0.11000000f,-0.43000000f,-0.16000000f,-0.29000000f,-0.79000000f,-0.52000000f,-0.54000000f,-0.22000000f,-0.94000000f,-0.77000000f,0.36000000f,0.75000000f,-0.42000000f,0.71000000f,-0.53000000f,-0.23000000f,-0.26000000f,-0.23000000f,-0.19000000f,-0.13000000f,0.85000000f,-0.15000000f,0.70000000f,-0.27000000f,-0.43000000f,0.63000000f,0.13000000f,0.95000000f,-0.63000000f,-0.28000000f,-0.42000000f,-0.91000000f,-0.42000000f,0.79000000f,-0.05000000f,-0.43000000f,0.24000000f,0.39000000f,0.22000000f,0.63000000f,-0.40000000f,0.12000000f,0.10000000f,-0.23000000f,-0.86000000f,-0.12000000f,-0.42000000f,0.31000000f,-0.87000000f,-0.38000000f,0.04000000f,0.54000000f,0.37000000f,-0.51000000f,0.09000000f,0.58000000f,0.27000000f,0.27000000f,0.17000000f,-0.16000000f,0.36000000f,0.35000000f,0.88000000f,-0.79000000f,0.34000000f,0.34000000f,-0.51000000f,-0.15000000f,-0.84000000f,0.07000000f,0.46000000f,0.46000000f,0.44000000f,-0.70000000f,-0.41000000f,0.98000000f,0.44000000f,0.66000000f,0.31000000f,0.84000000f,0.95000000f,-0.25000000f,-0.52000000f,-0.07000000f,-0.78000000f,-0.72000000f,-0.55000000f,-0.84000000f,-0.38000000f,-0.77000000f,0.90000000f,-0.08000000f,-0.62000000f,0.74000000f,-0.78000000f,-0.46000000f,-0.71000000f,0.80000000f,0.21000000f,0.66000000f,0.19000000f,0.80000000f,0.05000000f,0.83000000f,0.28000000f,0.46000000f,0.75000000f,0.33000000f,0.31000000f,-0.62000000f,-0.20000000f,0.13000000f,-0.79000000f,-0.17000000f,0.32000000f,-0.26000000f,-0.48000000f,0.40000000f,0.93000000f,-0.08000000f,0.49000000f,0.71000000f,0.34000000f,-0.05000000f,0.62000000f,0.30000000f,0.22000000f,0.12000000f,0.60000000f,-0.02000000f,-0.56000000f,0.39000000f,-0.15000000f,0.78000000f,0.80000000f,-0.11000000f,-0.61000000f,-0.66000000f,-0.25000000f,-0.80000000f,-0.44000000f,-0.39000000f,-0.99000000f,0.05000000f,0.57000000f,-0.36000000f,0.82000000f,-0.74000000f,0.37000000f,-0.50000000f,0.68000000f,-0.37000000f,0.56000000f,0.80000000f,-0.50000000f,0.45000000f,-0.50000000f,0.58000000f,-0.01000000f,0.79000000f,-0.48000000f,0.05000000f,0.97000000f,0.32000000f,0.82000000f,0.46000000f,0.49000000f,-0.12000000f,-0.71000000f,-0.04000000f,-0.65000000f,0.60000000f,-0.81000000f,0.78000000f,-0.85000000f,0.90000000f,-0.95000000f,-0.46000000f,0.62000000f,0.36000000f,-0.43000000f,0.10000000f,0.57000000f,0.52000000f,-0.60000000f,-0.05000000f,-0.11000000f,0.12000000f,0.32000000f,0.52000000f,0.91000000f,0.53000000f,0.24000000f,0.04000000f,-0.44000000f,-0.41000000f,0.89000000f,-0.17000000f,-0.45000000f,-0.83000000f,0.28000000f,-0.70000000f,0.46000000f,0.58000000f,0.81000000f,-0.23000000f,-0.97000000f,-0.61000000f,-0.82000000f,0.83000000f,0.45000000f,0.74000000f,-0.55000000f,-0.51000000f,-0.74000000f,0.56000000f,0.00000000f,0.23000000f,0.76000000f,-0.30000000f,0.07000000f,0.91000000f,0.26000000f,0.82000000f,0.32000000f,-0.40000000f,0.82000000f,0.64000000f,-0.83000000f,-0.99000000f,-0.19000000f,0.34000000f,0.09000000f,0.31000000f,-0.47000000f,0.38000000f,0.33000000f,0.68000000f,0.71000000f,-0.20000000f,-0.86000000f,-0.10000000f,-0.53000000f,-0.04000000f,-0.99000000f,0.35000000f,0.49000000f,0.52000000f,0.81000000f,-0.51000000f,0.76000000f,-0.50000000f,-0.31000000f,-0.93000000f,-0.89000000f,-0.88000000f,0.97000000f,0.22000000f,-0.41000000f,0.25000000f,-0.28000000f,-0.29000000f,-0.60000000f,-0.23000000f,-0.75000000f,-0.39000000f,0.81000000f,0.17000000f,0.18000000f,-0.92000000f,-0.94000000f,0.82000000f,-0.83000000f,-0.71000000f,0.77000000f,-0.65000000f,0.15000000f,0.17000000f,0.09000000f,0.23000000f,0.21000000f,0.05000000f,0.14000000f,-0.56000000f,-0.31000000f,0.32000000f,0.45000000f,-0.41000000f,0.40000000f,-0.01000000f,-0.59000000f,-0.07000000f,0.96000000f,0.15000000f,0.98000000f,-0.32000000f,-0.66000000f,0.58000000f,-0.07000000f,0.01000000f,-0.67000000f,-0.17000000f,-0.37000000f,0.76000000f,-0.57000000f,0.18000000f,-0.97000000f,-0.14000000f,0.78000000f,0.13000000f,0.78000000f,-0.58000000f,0.33000000f,0.45000000f,-0.31000000f,0.29000000f,0.50000000f,-0.20000000f,-0.78000000f,-0.82000000f,-0.55000000f,0.46000000f,0.55000000f,-0.73000000f,-0.63000000f,0.01000000f,0.12000000f,0.62000000f,0.58000000f,0.95000000f,0.08000000f,-0.94000000f,-0.90000000f,-0.70000000f,-0.22000000f,0.57000000f,0.69000000f,0.80000000f,0.52000000f,-0.38000000f,-0.38000000f,0.59000000f,0.17000000f,0.53000000f,0.46000000f,-0.55000000f,0.81000000f,0.59000000f,0.54000000f,0.57000000f,-0.38000000f,0.07000000f,-0.23000000f,0.16000000f,0.18000000f,0.57000000f,-0.94000000f,0.95000000f,-0.83000000f,0.75000000f,-0.75000000f,-0.97000000f,-0.57000000f,-0.61000000f,-0.15000000f,-0.12000000f,-0.67000000f,0.72000000f,-0.90000000f,-0.26000000f,0.39000000f,0.65000000f,-0.34000000f,-0.43000000f,0.13000000f,-0.23000000f,-0.22000000f,-0.80000000f,0.60000000f,-0.54000000f,0.31000000f,-0.98000000f,-0.12000000f,0.48000000f,0.94000000f,-0.96000000f,0.42000000f,-0.33000000f,-0.89000000f,-0.03000000f,0.94000000f,0.04000000f,0.36000000f,-0.75000000f,0.28000000f,0.28000000f,-0.77000000f,0.32000000f,-0.33000000f,-0.09000000f,-0.30000000f,0.96000000f,-0.30000000f,-0.17000000f,0.54000000f,0.48000000f,0.61000000f,-0.50000000f,-0.01000000f,0.49000000f,-0.88000000f,-0.28000000f,0.50000000f,0.66000000f,0.03000000f,-0.19000000f,-0.01000000f,-0.44000000f,-0.73000000f,-0.11000000f,0.07000000f,0.71000000f,0.05000000f,-0.38000000f,-0.50000000f,-0.47000000f,-0.92000000f,0.75000000f,0.48000000f,-0.46000000f,-0.08000000f,-0.15000000f,0.59000000f,0.32000000f,0.87000000f,0.87000000f,0.80000000f,-0.79000000f,0.20000000f,-0.08000000f,-0.64000000f,0.45000000f,-0.26000000f,0.42000000f,-0.95000000f,0.03000000f,0.91000000f,-0.11000000f,0.14000000f,0.63000000f,0.55000000f,0.59000000f,0.04000000f,0.79000000f,0.30000000f,-0.13000000f,0.20000000f,0.48000000f,-0.07000000f,-0.69000000f,0.29000000f,-0.02000000f,0.45000000f,-0.61000000f,-0.52000000f,0.46000000f,-0.28000000f,0.81000000f,-0.93000000f,-0.73000000f,0.43000000f,-0.96000000f,0.45000000f,0.09000000f,0.51000000f,0.56000000f,-0.39000000f,0.20000000f,-0.18000000f,0.16000000f,-0.28000000f,0.02000000f,0.05000000f,-0.45000000f,0.31000000f,-0.61000000f,0.82000000f,-0.92000000f,-0.94000000f,-0.20000000f,0.10000000f,0.44000000f,-0.02000000f,-0.84000000f,0.16000000f,0.08000000f,-0.66000000f,0.06000000f,0.72000000f,0.09000000f,-0.91000000f,0.70000000f,-0.96000000f,0.53000000f,-0.30000000f,0.89000000f,0.76000000f,0.11000000f,0.61000000f,0.89000000f,-0.02000000f,-0.65000000f,-0.98000000f,-0.93000000f,-0.66000000f,-0.11000000f,-0.97000000f,0.52000000f,-0.75000000f,-0.15000000f,0.30000000f,0.39000000f,0.32000000f,0.49000000f,-0.72000000f,0.44000000f,0.62000000f,0.64000000f,-0.76000000f,0.63000000f,-0.18000000f,0.29000000f,-0.74000000f,-0.10000000f,-0.35000000f,-0.11000000f,-0.42000000f,0.29000000f,-0.07000000f,0.06000000f,-0.26000000f,-0.91000000f,0.85000000f,-0.31000000f,-0.73000000f,0.84000000f,0.89000000f,0.46000000f,0.96000000f,0.92000000f,-0.76000000f,0.87000000f,-0.83000000f,-0.57000000f,0.42000000f,-0.79000000f,-0.55000000f,-0.32000000f,-0.14000000f,0.36000000f,-0.37000000f,0.14000000f,0.17000000f,0.60000000f,0.48000000f,-0.66000000f,0.24000000f,-0.27000000f,0.30000000f,-0.76000000f,-0.73000000f,-0.14000000f,-0.86000000f,-0.43000000f,0.93000000f,0.61000000f,-0.03000000f,0.70000000f,0.74000000f,-0.91000000f,0.45000000f,-0.78000000f,-0.07000000f,-0.60000000f,-0.57000000f,0.40000000f,0.51000000f,0.53000000f,-0.02000000f,0.27000000f,0.04000000f,0.94000000f,0.49000000f,-0.16000000f,-0.94000000f,-0.16000000f,0.41000000f,-0.45000000f,0.31000000f,0.56000000f,0.25000000f,-0.56000000f,0.87000000f,0.15000000f,-0.83000000f,-0.66000000f,-0.69000000f,-0.16000000f,0.32000000f,-0.61000000f,0.76000000f,-0.59000000f,-0.69000000f,-0.70000000f,0.42000000f,0.65000000f,0.90000000f,-0.45000000f,0.59000000f,-0.25000000f,-0.94000000f,0.74000000f,-0.87000000f,-0.24000000f,0.69000000f,-0.85000000f,0.33000000f,-0.89000000f,0.35000000f,-0.29000000f,-0.67000000f,-0.28000000f,-0.85000000f,-0.91000000f,-0.68000000f,0.38000000f,0.48000000f,-0.21000000f,-0.00000000f,-0.39000000f,0.93000000f,0.00000000f,-0.43000000f,-0.25000000f,0.67000000f,0.82000000f,0.00000000f,0.27000000f,-0.76000000f,0.44000000f,-0.83000000f,-0.61000000f,-0.80000000f,0.98000000f,-0.07000000f,-0.86000000f,0.03000000f,0.69000000f,-0.88000000f,-0.87000000f,-0.65000000f,0.88000000f,0.61000000f,0.32000000f,-0.82000000f,0.76000000f,-0.57000000f,-0.59000000f,0.02000000f,-0.80000000f,0.34000000f,-0.98000000f,-0.25000000f,-0.34000000f,0.83000000f,0.40000000f,-0.73000000f,-0.63000000f,-0.73000000f,-0.59000000f,-0.15000000f,-0.19000000f,0.07000000f,-0.21000000f,-0.87000000f,-0.52000000f,0.03000000f,0.69000000f,-0.73000000f,0.99000000f,0.25000000f,-0.28000000f,0.50000000f,-0.17000000f,0.81000000f,0.70000000f,-0.62000000f,0.19000000f,-0.64000000f,-0.14000000f,0.87000000f,0.37000000f,-0.98000000f,-0.33000000f,-0.41000000f,-0.21000000f,0.51000000f,0.84000000f,-0.93000000f,-0.44000000f,0.40000000f,0.86000000f,-0.39000000f,-0.46000000f,0.01000000f,-0.06000000f,0.74000000f,0.43000000f,-0.97000000f,0.69000000f,-0.14000000f,0.06000000f,0.46000000f,0.72000000f,0.48000000f,-0.33000000f,0.91000000f,0.85000000f,0.07000000f,0.51000000f,0.34000000f,-0.16000000f,0.46000000f,0.88000000f,-0.24000000f,0.17000000f,0.55000000f,-0.61000000f,0.16000000f,-0.32000000f,0.02000000f,0.53000000f,0.91000000f,0.04000000f,0.26000000f,0.33000000f,-0.64000000f,-0.50000000f,0.32000000f,0.55000000f,-0.47000000f,0.37000000f,0.69000000f,0.09000000f,-0.29000000f,0.75000000f,-0.19000000f,0.93000000f,0.92000000f,0.65000000f,0.85000000f,-0.45000000f,0.17000000f,-0.36000000f,-0.08000000f,-0.01000000f,0.08000000f,0.69000000f,-0.98000000f,-0.46000000f,-0.32000000f,-0.66000000f,0.98000000f,0.08000000f,-0.71000000f,-0.98000000f,-0.51000000f,-0.95000000f,0.23000000f,0.26000000f,-0.35000000f,-0.72000000f,0.69000000f,-0.64000000f,-0.13000000f,-0.23000000f,0.95000000f,-0.74000000f,-0.25000000f,0.34000000f,0.36000000f,0.25000000f,-0.51000000f,0.00000000f,-0.60000000f,-0.92000000f,0.81000000f,-0.84000000f,0.85000000f,-0.55000000f,0.26000000f,0.20000000f,0.18000000f,-0.78000000f,-0.27000000f,0.99000000f,-0.36000000f,-0.97000000f,0.76000000f,0.10000000f,-0.80000000f,0.16000000f,-0.90000000f,0.48000000f,-0.38000000f,-0.15000000f,0.97000000f,0.75000000f,0.17000000f,0.60000000f,0.15000000f,-0.76000000f,-0.58000000f,0.72000000f,0.24000000f,0.16000000f,-0.37000000f,0.07000000f,0.45000000f,-0.29000000f,0.17000000f,-0.30000000f,-0.37000000f,-0.15000000f,0.43000000f,-0.90000000f,-0.33000000f,0.90000000f,-0.29000000f,0.53000000f,0.96000000f,0.83000000f,0.11000000f,0.28000000f,-0.70000000f,0.87000000f,-0.26000000f,0.90000000f,0.17000000f,0.89000000f,-0.25000000f,-0.92000000f,0.62000000f,0.10000000f,0.14000000f,-0.91000000f,-0.59000000f,-0.54000000f,-0.34000000f,0.10000000f,0.25000000f,0.69000000f,-0.60000000f,0.57000000f,0.82000000f,-0.12000000f,-0.97000000f,-0.72000000f,0.34000000f,-0.43000000f,-0.02000000f,-0.16000000f,-0.49000000f,-0.10000000f,-0.22000000f,-0.95000000f,-0.29000000f,0.15000000f,0.15000000f,0.55000000f,-0.55000000f,0.89000000f,-0.28000000f,-0.15000000f,-0.22000000f,-0.63000000f,0.28000000f,0.64000000f,-0.82000000f,-0.09000000f,-0.14000000f,0.96000000f,-0.07000000f,-0.58000000f,-0.29000000f,0.77000000f,0.18000000f,0.47000000f,-0.33000000f,-0.14000000f,-0.80000000f,-0.80000000f,-0.52000000f,0.52000000f,-0.37000000f,-0.09000000f,0.13000000f,0.85000000f,0.01000000f,0.25000000f,0.47000000f,-0.67000000f,0.29000000f,-0.52000000f,0.92000000f,0.87000000f,-0.25000000f,-0.87000000f,0.67000000f,0.44000000f,-0.85000000f,0.81000000f,-0.29000000f,-0.51000000f,-0.11000000f,-0.86000000f,-0.92000000f,0.90000000f,0.87000000f,0.57000000f,0.45000000f,0.74000000f,0.02000000f,0.81000000f,-0.50000000f,-0.32000000f,0.24000000f,-0.70000000f,-0.71000000f,-0.30000000f,0.71000000f,0.56000000f,0.60000000f,-0.64000000f,0.56000000f,-0.88000000f,0.75000000f,-0.04000000f,0.90000000f,0.40000000f,-0.39000000f,-0.16000000f,0.99000000f,-0.55000000f,0.55000000f,0.77000000f,-0.76000000f,0.25000000f,-0.18000000f,-0.78000000f,0.71000000f,0.05000000f,-0.03000000f,0.80000000f,-0.55000000f,-0.13000000f,0.63000000f,-0.33000000f,0.18000000f,-0.66000000f,0.27000000f,-0.83000000f,-0.21000000f,-0.79000000f,-0.46000000f,-0.15000000f,-0.61000000f,-0.28000000f,-0.84000000f,0.58000000f,-0.43000000f,0.85000000f,-0.22000000f,0.54000000f,0.73000000f,-0.87000000f,-0.48000000f,0.53000000f,-0.97000000f,-0.93000000f,0.85000000f,-0.96000000f,0.37000000f,0.78000000f,0.61000000f,0.55000000f,0.43000000f,-0.75000000f,0.09000000f,-0.06000000f,-0.23000000f,0.68000000f,-0.42000000f,-0.88000000f,-0.81000000f,-0.36000000f,0.33000000f,-0.50000000f,0.63000000f,-0.74000000f,-0.61000000f,-0.29000000f,0.14000000f,0.78000000f,-0.19000000f,-0.13000000f,-0.73000000f,0.97000000f,0.87000000f,-0.15000000f,-0.62000000f,-0.16000000f,0.83000000f,-0.78000000f,0.87000000f,0.48000000f,0.32000000f,0.77000000f,0.59000000f,-0.02000000f,0.06000000f,0.72000000f,0.84000000f,0.18000000f,-0.24000000f,-0.53000000f,0.26000000f,0.56000000f,0.50000000f,0.62000000f,-0.29000000f,-0.08000000f,-0.39000000f,-0.29000000f,-0.36000000f,-0.98000000f,0.53000000f,0.53000000f,-0.21000000f,-0.08000000f,0.47000000f,-0.77000000f,-0.73000000f,-0.48000000f,0.84000000f,0.12000000f,0.09000000f,-0.22000000f,0.77000000f,-0.10000000f,-0.69000000f,0.10000000f,0.13000000f,-0.42000000f,0.96000000f,-0.67000000f,-0.78000000f,0.10000000f,0.66000000f,0.85000000f,0.52000000f,0.89000000f,0.50000000f,0.38000000f,-0.03000000f,0.75000000f,0.29000000f,0.53000000f,-0.71000000f,0.99000000f,-0.58000000f,0.75000000f,0.74000000f,-0.66000000f,0.50000000f,0.76000000f,-0.73000000f,-0.84000000f,-0.86000000f,0.71000000f,0.07000000f,-0.82000000f,-0.43000000f,0.96000000f,0.94000000f,-0.36000000f,-0.27000000f,0.43000000f,0.03000000f,-0.60000000f,-0.35000000f,0.41000000f,-0.30000000f,0.06000000f,-0.51000000f,0.49000000f,-0.34000000f,0.99000000f,-0.86000000f,0.99000000f,-0.03000000f,-0.43000000f,-0.27000000f,-0.72000000f,-0.92000000f,0.17000000f,-0.78000000f,0.43000000f,0.93000000f,0.12000000f,-0.15000000f,0.73000000f,0.88000000f,0.44000000f,-0.58000000f,-0.20000000f,0.27000000f,0.45000000f,0.40000000f,0.02000000f,0.94000000f,-0.68000000f,0.88000000f,-0.76000000f,-0.16000000f,0.08000000f,0.92000000f,-0.88000000f,0.03000000f,-0.66000000f,-0.59000000f,-0.05000000f,-0.95000000f,-0.54000000f,0.97000000f,0.94000000f,-0.84000000f,0.24000000f,-0.03000000f,-0.14000000f,0.58000000f,-0.75000000f,0.38000000f,0.00000000f,-0.90000000f,-0.34000000f,-0.70000000f,-0.79000000f,-0.33000000f,0.48000000f,0.92000000f,-0.68000000f,-0.88000000f,0.99000000f,-0.58000000f,0.32000000f,0.81000000f,-0.57000000f,0.23000000f,-0.70000000f,-0.26000000f,0.49000000f,-0.13000000f,0.93000000f,0.66000000f,-0.31000000f,-0.58000000f,0.56000000f,-0.57000000f,-0.38000000f,0.59000000f,0.10000000f,0.10000000f,-0.55000000f,-0.41000000f,0.13000000f,-0.22000000f,-0.53000000f,0.30000000f,0.39000000f,0.66000000f,0.93000000f,-0.38000000f,0.93000000f,0.35000000f,-0.47000000f,0.21000000f,0.14000000f,0.86000000f,0.71000000f,-0.51000000f,-0.99000000f,0.72000000f,-0.37000000f,-0.24000000f,-0.04000000f,0.19000000f,0.03000000f,-0.18000000f,0.38000000f,-0.68000000f,0.88000000f,0.98000000f,-0.57000000f,0.26000000f,-0.18000000f,0.34000000f,0.99000000f,0.04000000f,-0.05000000f,0.84000000f,-0.83000000f,0.45000000f,-0.93000000f,-0.94000000f,-0.65000000f,0.91000000f,-0.23000000f,0.34000000f,-0.34000000f,-0.11000000f,0.10000000f,0.96000000f,0.22000000f,0.59000000f,0.67000000f,0.73000000f,-0.05000000f,0.34000000f,-0.69000000f,-0.74000000f,-0.32000000f,-0.47000000f,0.96000000f,-0.38000000f,-0.77000000f,-0.04000000f,-0.30000000f,-0.29000000f,-0.82000000f,0.22000000f,-0.05000000f,-0.56000000f,0.10000000f,-0.78000000f,-0.06000000f,-0.14000000f,-0.46000000f,-0.11000000f,0.66000000f,0.83000000f,-0.46000000f,-0.26000000f,-0.19000000f,-0.55000000f,0.28000000f,0.00000000f,-0.02000000f,0.02000000f,-0.64000000f,0.14000000f,-0.57000000f,-0.49000000f,0.07000000f,-0.38000000f,0.18000000f,0.75000000f,-0.97000000f,0.20000000f,-0.14000000f,0.26000000f,0.58000000f,-0.31000000f,-0.64000000f,0.90000000f,0.52000000f,-0.49000000f,0.98000000f,0.78000000f,-0.84000000f,-0.36000000f,0.64000000f,-0.63000000f,0.46000000f,-0.95000000f,0.05000000f,0.27000000f,0.65000000f,0.69000000f,-0.80000000f,-0.31000000f,-0.57000000f,0.70000000f,-0.34000000f,-0.65000000f,-0.46000000f,-0.06000000f,-0.12000000f,-0.35000000f,-0.03000000f,-0.49000000f,0.38000000f,-0.07000000f,-0.15000000f,-0.46000000f,0.65000000f,0.70000000f,-0.05000000f,-0.98000000f,-0.75000000f,0.07000000f,-0.61000000f,-0.69000000f,0.05000000f,-0.39000000f,-0.93000000f,-0.93000000f,0.66000000f,-0.68000000f,0.52000000f,0.76000000f,-0.24000000f,-0.78000000f,-0.06000000f,-0.77000000f,0.28000000f,-0.65000000f,-0.74000000f,0.42000000f,-0.04000000f,-0.59000000f,0.97000000f,-0.96000000f,0.87000000f,0.30000000f,-0.31000000f,-0.24000000f,0.99000000f,-0.15000000f,-0.06000000f,0.87000000f,-0.86000000f,0.34000000f,-0.68000000f,-0.15000000f,0.45000000f,-0.83000000f,-0.33000000f,0.56000000f,-0.53000000f,0.45000000f,-0.95000000f,0.48000000f,0.89000000f,0.93000000f,-0.74000000f,-0.21000000f,0.15000000f,-0.17000000f,-0.81000000f,-0.07000000f,0.99000000f,-0.32000000f,-0.66000000f,0.64000000f,-0.89000000f,-0.74000000f,0.14000000f,0.04000000f,-0.82000000f,-0.74000000f,-0.30000000f,0.61000000f,0.35000000f,-0.72000000f,0.52000000f,-0.60000000f,-0.44000000f,0.42000000f,0.58000000f,0.29000000f,0.91000000f,-0.44000000f,0.94000000f,0.65000000f,-0.32000000f,-0.26000000f,-0.02000000f,0.79000000f,0.45000000f,-0.40000000f,0.10000000f,0.53000000f,-0.11000000f,-0.15000000f,-0.99000000f,-0.24000000f,0.86000000f,0.85000000f,-0.42000000f,-0.00000000f,0.28000000f,0.07000000f,-0.86000000f,-0.18000000f,0.75000000f,-0.38000000f,0.16000000f,-0.62000000f,0.97000000f,0.28000000f,0.30000000f,0.80000000f,0.14000000f,0.24000000f,0.82000000f,-0.25000000f,0.55000000f,-0.82000000f,0.42000000f,-0.39000000f,-0.24000000f,-0.58000000f,0.54000000f,0.27000000f,0.95000000f,-0.98000000f,-0.30000000f,-0.55000000f,0.51000000f,-0.52000000f,-0.32000000f,-0.50000000f,0.49000000f,-0.90000000f,-0.15000000f,0.38000000f,-0.92000000f,0.38000000f,-0.48000000f,0.39000000f,0.45000000f,-0.56000000f,-0.96000000f,-0.96000000f,0.72000000f,-0.25000000f,-0.77000000f,-0.31000000f,0.59000000f,-0.89000000f,0.42000000f,0.48000000f,0.62000000f,-0.11000000f,-0.78000000f,0.70000000f,0.46000000f,0.88000000f,-0.32000000f,-0.62000000f,-0.87000000f,-0.61000000f,0.14000000f,0.99000000f,0.44000000f,0.81000000f,-0.66000000f,0.24000000f,-0.56000000f,0.69000000f,-0.97000000f,0.76000000f,-0.75000000f,-0.00000000f,-0.94000000f,0.58000000f,-0.32000000f,0.82000000f,0.74000000f,-0.24000000f,-0.88000000f,0.30000000f,-0.07000000f,0.04000000f,0.75000000f,-0.70000000f,0.70000000f,0.23000000f,-0.21000000f,-0.51000000f,0.36000000f,0.63000000f,-0.70000000f,0.10000000f,0.09000000f,0.64000000f,-0.51000000f,-0.12000000f,-0.23000000f,-0.39000000f,0.35000000f,0.74000000f,-0.58000000f,0.39000000f,-0.84000000f,0.81000000f,-0.93000000f,-0.40000000f,0.31000000f,-0.81000000f,0.41000000f,-0.89000000f,-0.27000000f,-0.39000000f,0.13000000f,-0.51000000f,-0.72000000f,-0.55000000f,0.79000000f,0.49000000f,-0.29000000f,0.00000000f,-0.92000000f,-0.10000000f,-0.77000000f,-0.75000000f,-0.33000000f,-0.20000000f,0.21000000f,0.22000000f,-0.31000000f,0.14000000f,-0.58000000f,0.82000000f,0.38000000f,0.33000000f,-0.01000000f,0.54000000f,-0.67000000f,0.24000000f,0.60000000f,0.53000000f,0.52000000f,0.21000000f,-0.73000000f,-0.72000000f,-0.60000000f,-0.37000000f,-0.34000000f,-0.06000000f,0.15000000f,-0.63000000f,-0.99000000f,-0.28000000f,0.04000000f,-0.36000000f,-0.28000000f,0.35000000f,0.88000000f,0.24000000f,0.52000000f,-0.54000000f,0.55000000f,-0.91000000f,0.36000000f,0.59000000f,0.48000000f,-0.43000000f,-0.54000000f,-0.36000000f,0.12000000f,0.56000000f,-0.72000000f,0.54000000f,-0.75000000f,-0.77000000f,0.12000000f,-0.89000000f,-0.30000000f,0.93000000f,-0.11000000f,-0.18000000f,-0.67000000f,-0.15000000f,0.02000000f,-0.76000000f,-0.51000000f,0.45000000f,0.79000000f,-0.49000000f,0.90000000f,-0.98000000f,-0.70000000f,0.10000000f,0.35000000f,-0.22000000f,0.66000000f,-0.62000000f,0.87000000f,0.44000000f,-0.55000000f,-0.63000000f,0.09000000f,-0.42000000f,-0.38000000f,0.81000000f,0.69000000f,-0.56000000f,-0.51000000f,0.25000000f,0.31000000f,0.06000000f,-0.99000000f,0.45000000f,-0.85000000f,0.84000000f,0.32000000f,0.21000000f,0.61000000f,-0.44000000f,-0.63000000f,0.46000000f,-0.87000000f,-0.03000000f,0.40000000f,-0.52000000f,0.89000000f,-0.92000000f,-0.14000000f,0.30000000f,0.39000000f,0.30000000f,-0.63000000f,-0.01000000f,-0.66000000f,-0.02000000f,-0.51000000f,0.14000000f,0.02000000f,0.28000000f,0.85000000f,0.77000000f,-0.55000000f,0.69000000f,-0.13000000f,-0.72000000f,-0.04000000f,-0.35000000f,0.05000000f,0.40000000f,0.49000000f,0.27000000f,-0.64000000f,-0.46000000f,-0.59000000f,-0.33000000f,0.43000000f,0.53000000f,-0.50000000f,-0.60000000f,0.28000000f,0.82000000f,0.51000000f,0.90000000f,0.48000000f,-0.55000000f,-0.08000000f,-0.32000000f,0.68000000f,-0.93000000f,-0.09000000f,-0.85000000f,-0.29000000f,-0.92000000f,0.15000000f,0.84000000f,-0.97000000f,0.12000000f,0.72000000f,0.81000000f,-0.88000000f,-0.98000000f,-0.26000000f,0.85000000f,0.56000000f,0.95000000f,-0.10000000f,0.67000000f,-0.14000000f,0.03000000f,0.25000000f,0.72000000f,-0.22000000f,0.18000000f,-0.72000000f,-0.85000000f,0.83000000f,0.00000000f,0.98000000f,-0.34000000f,0.35000000f,0.62000000f,-0.65000000f,-0.66000000f,0.78000000f,0.09000000f,-0.09000000f,-0.98000000f,0.89000000f,-0.27000000f,-0.54000000f,-0.82000000f,0.06000000f,-0.12000000f,-0.89000000f,0.45000000f,-0.07000000f,0.73000000f,-0.66000000f,-0.00000000f,-0.67000000f,0.56000000f,-0.41000000f,-0.99000000f,0.09000000f,0.30000000f,-0.30000000f,0.76000000f,-0.33000000f,0.02000000f,0.29000000f,-0.36000000f,0.69000000f,0.83000000f,-0.16000000f,0.76000000f,-0.36000000f,-0.47000000f,-0.22000000f,0.18000000f,-0.49000000f,0.57000000f,-0.02000000f,-0.56000000f,-0.93000000f,-0.19000000f,-0.98000000f,-0.98000000f,-0.17000000f,-0.42000000f,0.55000000f,0.49000000f,-0.37000000f,0.02000000f,-0.22000000f,-0.61000000f,-0.36000000f,0.94000000f,-0.65000000f,-0.87000000f,0.56000000f,-0.93000000f,-0.53000000f,-0.23000000f,-0.30000000f,0.34000000f,0.53000000f,-0.55000000f,-0.62000000f,-0.86000000f,0.22000000f,-0.57000000f,0.47000000f,0.12000000f,-0.93000000f,-0.83000000f,-0.90000000f,0.77000000f,0.36000000f,0.73000000f,-0.59000000f,0.87000000f,0.88000000f,-0.54000000f,0.88000000f,0.39000000f,0.42000000f,0.50000000f,0.68000000f,-0.66000000f,0.07000000f,0.22000000f,-0.39000000f,-0.47000000f,0.41000000f,-0.79000000f,-0.38000000f,0.79000000f,-0.09000000f,0.37000000f,-0.07000000f,0.05000000f,0.66000000f,-0.54000000f,0.45000000f,0.39000000f,0.84000000f,0.72000000f,0.12000000f,0.30000000f,-0.55000000f,0.54000000f,0.42000000f,-0.14000000f,-0.85000000f,-0.56000000f,-0.55000000f,0.27000000f,0.70000000f,0.98000000f,-0.28000000f,-0.29000000f,0.48000000f,-0.02000000f,-0.83000000f,-0.86000000f,-0.92000000f,0.88000000f,-0.11000000f,0.53000000f,0.06000000f,-0.45000000f,0.05000000f,0.78000000f,0.69000000f,0.22000000f,0.52000000f,0.11000000f,0.38000000f,-0.52000000f,0.47000000f,-0.02000000f,-0.43000000f,-0.19000000f,-0.39000000f,-0.45000000f,0.81000000f,0.29000000f,-0.97000000f,-0.04000000f,0.25000000f,-0.29000000f,-0.77000000f,0.46000000f,-0.62000000f,-0.92000000f,0.85000000f,-0.89000000f,-0.84000000f,0.03000000f,0.16000000f,0.47000000f,-0.18000000f,-0.60000000f,0.04000000f,0.71000000f,-0.99000000f,0.57000000f,0.12000000f,-0.83000000f,-0.26000000f,0.29000000f,-0.81000000f,-0.48000000f,0.91000000f,0.01000000f,-0.38000000f,0.50000000f,0.69000000f,0.38000000f,0.18000000f,0.03000000f,-0.64000000f,0.19000000f,0.10000000f,0.76000000f,0.27000000f,-0.34000000f,-0.28000000f,-0.74000000f,-0.26000000f,0.28000000f,-0.60000000f,0.95000000f,0.52000000f,0.84000000f,-0.20000000f,0.97000000f,0.93000000f,-0.56000000f,-0.29000000f,0.87000000f,-0.71000000f,0.20000000f,0.83000000f,-0.83000000f,0.69000000f,-0.86000000f,0.40000000f,0.34000000f,0.78000000f,-0.50000000f,-0.19000000f,0.50000000f,-0.78000000f,-0.11000000f,0.77000000f,-0.80000000f,0.95000000f,-0.22000000f,0.03000000f,-0.68000000f,-0.63000000f,0.74000000f,0.01000000f,-0.70000000f,-0.59000000f,-0.64000000f,-0.72000000f,0.83000000f,0.41000000f,-0.65000000f,-0.16000000f,-0.29000000f,0.55000000f,-0.63000000f,0.80000000f,-0.85000000f,-0.49000000f,0.45000000f,-0.54000000f,-0.00000000f,-0.36000000f,-0.04000000f,0.66000000f,-0.14000000f,0.15000000f,-0.44000000f,0.79000000f,-0.44000000f,0.81000000f,0.90000000f,0.65000000f,0.27000000f,-0.08000000f,0.28000000f,-0.88000000f,0.89000000f,-0.80000000f,-0.96000000f,-0.97000000f,0.56000000f,-0.72000000f,-0.68000000f,-0.26000000f,0.91000000f,0.43000000f,0.93000000f,-0.85000000f,-0.97000000f,-0.00000000f,0.04000000f,-0.68000000f,0.76000000f,0.61000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.95000000f,0.84000000f,0.47000000f,-0.66000000f,-0.92000000f,-0.50000000f,0.11000000f,-0.99000000f,0.22000000f,0.20000000f,0.00000000f,0.33000000f,0.14000000f,-0.35000000f,0.48000000f,0.42000000f,0.30000000f,0.89000000f,-0.93000000f,0.88000000f,-0.44000000f,0.08000000f,0.01000000f,0.03000000f,-0.14000000f,0.71000000f,0.24000000f,-0.17000000f,-0.68000000f,0.17000000f,0.53000000f,0.79000000f,0.97000000f,0.32000000f,0.58000000f,0.40000000f,-0.77000000f,-0.77000000f,0.14000000f,0.38000000f,0.69000000f,0.73000000f,0.88000000f,0.81000000f,0.67000000f,0.13000000f,-0.53000000f,-0.13000000f,-0.79000000f,0.70000000f,0.46000000f,0.71000000f,0.06000000f,-0.42000000f,0.96000000f,0.24000000f,0.02000000f,-0.31000000f,-0.18000000f,-0.87000000f,-0.70000000f,0.05000000f,-0.46000000f,-0.59000000f,-0.84000000f,0.12000000f,0.41000000f,-0.90000000f,0.45000000f,0.11000000f,0.02000000f,-0.49000000f,-0.26000000f,-0.41000000f,0.43000000f,-0.34000000f,-0.19000000f,-0.41000000f,-0.64000000f,-0.20000000f,0.22000000f,-0.20000000f,-0.05000000f,0.33000000f,-0.19000000f,0.69000000f,-0.85000000f,-0.01000000f,0.33000000f,0.07000000f,0.80000000f,-0.45000000f,-0.53000000f,-0.57000000f,0.88000000f,-0.80000000f,0.12000000f,0.60000000f,-0.31000000f,0.11000000f,0.33000000f,-0.10000000f,-0.09000000f,0.21000000f,-0.93000000f,-0.44000000f,0.18000000f,-0.13000000f,-0.33000000f,0.17000000f,0.38000000f,-0.43000000f,0.07000000f,0.30000000f,-0.10000000f,-0.25000000f,0.96000000f,-0.23000000f,0.91000000f,-0.47000000f,0.37000000f,0.52000000f,-0.96000000f,0.33000000f,0.37000000f,-0.75000000f,-0.91000000f,0.33000000f,0.11000000f,-0.92000000f,-0.98000000f,-0.74000000f,-0.26000000f,0.04000000f,-0.06000000f,0.38000000f,-0.73000000f,0.27000000f,0.88000000f,0.25000000f,-0.79000000f,0.48000000f,0.82000000f,0.98000000f,-0.97000000f,0.21000000f,-0.16000000f,0.56000000f,-0.03000000f,-0.53000000f,-0.13000000f,-0.73000000f,-0.31000000f,0.37000000f,-0.68000000f,-0.36000000f,0.42000000f,-0.21000000f,-0.02000000f,-0.57000000f,0.50000000f,0.00000000f,-0.87000000f,0.28000000f,0.27000000f,0.98000000f,-0.96000000f,0.21000000f,0.81000000f,-0.33000000f,-0.94000000f,-0.15000000f,-0.45000000f,0.93000000f,-0.36000000f,0.23000000f,0.64000000f,-0.04000000f,-0.13000000f,0.40000000f,-0.72000000f,0.17000000f,0.87000000f,-0.60000000f,-0.82000000f,-0.20000000f,0.32000000f,0.92000000f,0.99000000f,0.28000000f,-0.47000000f,0.50000000f,0.27000000f,0.58000000f,-0.98000000f,0.36000000f,0.90000000f,0.45000000f,-0.65000000f,0.26000000f,0.54000000f,-0.54000000f,0.35000000f,0.07000000f,-0.94000000f,0.23000000f,0.02000000f,0.87000000f,0.83000000f,0.09000000f,-0.83000000f,0.53000000f,0.44000000f,-0.93000000f,0.35000000f,-0.86000000f,-0.01000000f,0.38000000f,0.56000000f,-0.65000000f,0.72000000f,-0.04000000f,0.09000000f,0.17000000f,0.95000000f,-0.64000000f,0.91000000f,0.34000000f,-0.60000000f,-0.40000000f,0.73000000f,-0.66000000f,-0.65000000f,-0.21000000f,-0.17000000f,-0.12000000f,0.50000000f,0.27000000f,-0.68000000f,-0.74000000f,-0.27000000f,-0.64000000f,-0.75000000f,-0.01000000f,-0.50000000f,0.47000000f,-0.50000000f,-0.08000000f,-0.00000000f,-0.79000000f,0.99000000f,-0.01000000f,-0.69000000f,-0.60000000f,-0.95000000f,-0.11000000f,0.25000000f,-0.52000000f,-0.49000000f,0.31000000f,0.76000000f,-0.83000000f,-0.39000000f,-0.42000000f,-0.18000000f,0.06000000f,-0.04000000f,-0.74000000f,-0.27000000f,-0.23000000f,0.76000000f,0.33000000f,0.59000000f,-0.72000000f,-0.70000000f,-0.04000000f,0.63000000f,-0.21000000f,0.25000000f,0.16000000f,-0.03000000f,0.77000000f,0.03000000f,-0.74000000f,0.94000000f,-0.91000000f,-0.23000000f,0.47000000f,0.90000000f,0.82000000f,-0.58000000f,0.77000000f,-0.37000000f,0.05000000f,-0.51000000f,0.09000000f,-0.80000000f,0.95000000f,0.73000000f,0.28000000f,0.56000000f,-0.74000000f,-0.31000000f,0.37000000f,0.65000000f,0.32000000f,-0.50000000f,-0.52000000f,-0.68000000f,0.78000000f,0.82000000f,0.94000000f,0.27000000f,-0.44000000f,-0.05000000f,0.39000000f,-0.80000000f,-0.88000000f,0.42000000f,0.72000000f,0.02000000f,0.26000000f,-0.58000000f,0.21000000f,-0.90000000f,0.00000000f,0.36000000f,0.77000000f,-0.96000000f,-0.18000000f,0.99000000f,-0.71000000f,0.94000000f,-0.81000000f,-0.08000000f,-0.64000000f,-0.71000000f,-0.84000000f,-0.28000000f,0.44000000f,0.44000000f,0.80000000f,-0.17000000f,-0.50000000f,0.38000000f,0.75000000f,0.29000000f,0.54000000f,-0.56000000f,-0.40000000f,0.35000000f,0.59000000f,0.88000000f,-0.87000000f,0.03000000f,0.88000000f,-0.02000000f,0.26000000f,0.68000000f,0.38000000f,0.24000000f,0.03000000f,0.15000000f,0.28000000f,0.73000000f,0.67000000f,0.94000000f,-0.04000000f,0.18000000f,-0.19000000f,0.68000000f,-0.91000000f,0.41000000f,-0.50000000f,-0.36000000f,0.03000000f,-0.65000000f,0.44000000f,-0.73000000f,-0.18000000f,0.39000000f,0.40000000f,-0.53000000f,-0.94000000f,0.11000000f,0.71000000f,0.82000000f,-0.17000000f,0.65000000f,0.60000000f,0.93000000f,-0.99000000f,-0.11000000f,-0.83000000f,-0.31000000f,-0.09000000f,-0.08000000f,0.91000000f,-0.51000000f,-0.25000000f,0.52000000f,0.54000000f,0.23000000f,-0.00000000f,0.69000000f,0.88000000f,0.49000000f,-0.50000000f,0.99000000f,0.82000000f,-0.56000000f,-0.68000000f,0.18000000f,-0.38000000f,-0.97000000f,0.27000000f,-0.83000000f,0.63000000f,0.98000000f,-0.59000000f,0.43000000f,0.07000000f,-0.68000000f,-0.00000000f,-0.25000000f,-0.69000000f,-0.03000000f,0.86000000f,0.72000000f,0.53000000f,-0.95000000f,-0.88000000f,0.15000000f,0.43000000f,-0.61000000f,-0.03000000f,-0.56000000f,-0.44000000f,-0.35000000f,-0.46000000f,-0.21000000f,-0.80000000f,-0.63000000f,0.39000000f,-0.24000000f,-0.91000000f,0.24000000f,0.32000000f,-0.22000000f,0.73000000f,-0.24000000f,-0.53000000f,-0.22000000f,-0.62000000f,-0.39000000f,-0.40000000f,0.60000000f,0.78000000f,-0.11000000f,0.32000000f,-0.34000000f,0.53000000f,0.60000000f,0.10000000f,-0.59000000f,0.31000000f,0.77000000f,-0.54000000f,0.52000000f,0.68000000f,0.84000000f,-0.55000000f,-0.15000000f,0.16000000f,0.15000000f,-0.64000000f,0.73000000f,0.77000000f,-0.57000000f,-0.05000000f,0.36000000f,-0.03000000f,0.27000000f,0.93000000f,-0.88000000f,0.82000000f,0.40000000f,-0.69000000f,0.23000000f,0.01000000f,0.30000000f,-0.21000000f,0.09000000f,-0.18000000f,0.97000000f,0.33000000f,0.48000000f,-0.15000000f,-0.05000000f,-0.86000000f,0.81000000f,-0.33000000f,-0.92000000f,0.58000000f,0.47000000f,0.22000000f,0.81000000f,0.77000000f,-0.82000000f,-0.15000000f,0.82000000f,-0.53000000f,0.31000000f,0.30000000f,-0.16000000f,-0.24000000f,-0.24000000f,-0.80000000f,0.72000000f,-0.91000000f,-0.53000000f,-0.73000000f,0.85000000f,0.82000000f,-0.97000000f,-0.80000000f,-0.13000000f,-0.20000000f,0.40000000f,-0.70000000f,-0.35000000f,0.88000000f,0.08000000f,-0.48000000f,0.77000000f,0.62000000f,-0.16000000f,-0.47000000f,0.53000000f,0.11000000f,0.43000000f,-0.36000000f,-0.13000000f,-0.01000000f,-0.36000000f,0.88000000f,-0.89000000f,0.03000000f,0.69000000f,-0.36000000f,-0.98000000f,0.52000000f,0.28000000f,0.59000000f,0.27000000f,-0.43000000f,-0.75000000f,0.61000000f,0.67000000f,0.46000000f,-0.50000000f,-0.11000000f,-0.77000000f,-0.43000000f,-0.00000000f,-0.80000000f,0.91000000f,0.22000000f,-0.50000000f,-0.83000000f,-0.52000000f,0.94000000f,-0.92000000f,-0.36000000f,-0.96000000f,-0.40000000f,0.11000000f,-0.37000000f,0.08000000f,0.52000000f,0.53000000f,0.02000000f,-0.83000000f,0.54000000f,-0.48000000f,0.02000000f,-0.05000000f,0.32000000f,-0.78000000f,0.02000000f,-0.79000000f,0.34000000f,-0.54000000f,0.93000000f,-0.80000000f,0.32000000f,0.70000000f,-0.82000000f,0.92000000f,0.04000000f,0.83000000f,-0.26000000f,-0.68000000f,0.76000000f,0.78000000f,0.35000000f,0.71000000f,0.83000000f,0.52000000f,0.57000000f,-0.20000000f,0.12000000f,0.26000000f,-0.99000000f,0.47000000f,0.60000000f,-0.06000000f,-0.17000000f,0.26000000f,-0.60000000f,0.70000000f,-0.22000000f,-0.87000000f,-0.78000000f,0.29000000f,0.47000000f,0.76000000f,0.09000000f,0.73000000f,0.07000000f,-0.91000000f,-0.53000000f,-0.40000000f,0.78000000f,0.81000000f,-0.57000000f,-0.05000000f,-0.54000000f,-0.04000000f,-0.14000000f,0.80000000f,0.11000000f,-0.75000000f,0.56000000f,0.63000000f,-0.73000000f,-0.32000000f,0.86000000f,-0.98000000f,-0.64000000f,0.59000000f,-0.95000000f,0.63000000f,0.10000000f,0.24000000f,-0.83000000f,-0.60000000f,-0.67000000f,0.40000000f,-0.96000000f,-0.30000000f,-0.69000000f,0.70000000f,-0.89000000f,0.40000000f,-0.21000000f,0.83000000f,0.44000000f,0.71000000f,-0.85000000f,-0.05000000f,-0.95000000f,-0.83000000f,0.26000000f,-0.63000000f,0.37000000f,-0.05000000f,-0.76000000f,-0.47000000f,0.37000000f,0.01000000f,0.42000000f,-0.12000000f,0.99000000f,-0.43000000f,0.16000000f,-0.20000000f,-0.17000000f,-0.18000000f,-0.13000000f,-0.98000000f,-0.05000000f,-0.86000000f,0.40000000f,0.70000000f,-0.68000000f,0.93000000f,-0.62000000f,0.08000000f,-0.54000000f,-0.01000000f,0.82000000f,0.05000000f,-0.45000000f,-0.83000000f,-0.22000000f,-0.35000000f,0.54000000f,0.48000000f,0.12000000f,0.27000000f,-0.87000000f,-0.67000000f,-0.15000000f,0.02000000f,-0.67000000f,0.52000000f,0.24000000f,0.08000000f,-0.80000000f,0.09000000f,0.99000000f,0.31000000f,0.01000000f,0.83000000f,-0.99000000f,-0.90000000f,-0.23000000f,0.39000000f,0.75000000f,-0.51000000f,0.75000000f,0.37000000f,-0.28000000f,0.27000000f,-0.72000000f,0.71000000f,0.78000000f,0.95000000f,-0.05000000f,0.08000000f,-0.10000000f,-0.19000000f,0.43000000f,0.38000000f,-0.69000000f,-0.38000000f,0.67000000f,0.58000000f,0.86000000f,0.14000000f,0.86000000f,-0.06000000f,0.41000000f,-0.17000000f,-0.15000000f,0.96000000f,0.10000000f,0.20000000f,0.22000000f,-0.92000000f,-0.51000000f,-0.08000000f,0.84000000f,0.83000000f,-0.90000000f,0.51000000f,-0.07000000f,0.69000000f,0.84000000f,0.30000000f,0.35000000f,-0.01000000f,-0.01000000f,0.85000000f,0.76000000f,0.77000000f,-0.50000000f,0.67000000f,0.65000000f,-0.49000000f,-0.47000000f,-0.64000000f,0.63000000f,-0.12000000f,-0.84000000f,0.76000000f,0.50000000f,0.00000000f,-0.83000000f,-0.71000000f,0.43000000f,-0.10000000f,0.95000000f,0.86000000f,-0.77000000f,0.93000000f,-0.61000000f,-0.67000000f,-0.18000000f,-0.53000000f,-0.12000000f,-0.59000000f,0.95000000f,-0.97000000f,-0.08000000f,-0.20000000f,-0.65000000f,-0.78000000f,-0.02000000f,-0.47000000f,-0.55000000f,-0.77000000f,0.00000000f,-0.01000000f,-0.97000000f,0.29000000f,-0.68000000f,0.66000000f,-0.86000000f,0.70000000f,-0.53000000f,-0.99000000f,-0.29000000f,-0.87000000f,0.34000000f,0.13000000f,-0.12000000f,-0.64000000f,0.65000000f,-0.08000000f,0.80000000f,-0.37000000f,-0.01000000f,0.63000000f,-0.85000000f,0.37000000f,0.23000000f,0.06000000f,-0.57000000f,-0.99000000f,0.28000000f,-0.48000000f,0.70000000f,0.34000000f,0.08000000f,0.96000000f,-0.27000000f,0.36000000f,0.31000000f,-0.39000000f,-0.22000000f,-0.06000000f,-0.67000000f,-0.22000000f,-0.49000000f,0.77000000f,-0.16000000f,0.95000000f,-0.03000000f,-0.40000000f,0.67000000f,0.17000000f,0.73000000f,0.44000000f,-0.69000000f,0.78000000f,0.57000000f,-0.14000000f,-0.61000000f,-0.31000000f,0.73000000f,-0.71000000f,0.03000000f,0.95000000f,0.33000000f,-0.50000000f,0.69000000f,-0.11000000f,0.81000000f,-0.64000000f,0.67000000f,0.66000000f,-0.47000000f,-0.28000000f,-0.11000000f,0.11000000f,0.97000000f,0.67000000f,0.98000000f,0.38000000f,-0.07000000f,-0.38000000f,0.12000000f,-0.59000000f,0.89000000f,0.12000000f,0.05000000f,-0.03000000f,0.58000000f,-0.68000000f,-0.74000000f,0.57000000f,0.81000000f,0.23000000f,-0.35000000f,-0.27000000f,0.29000000f,-0.43000000f,0.03000000f,-0.60000000f,0.18000000f,0.07000000f,0.74000000f,-0.56000000f,0.70000000f,-0.11000000f,0.28000000f,-0.73000000f,0.14000000f,-0.60000000f,0.00000000f,-0.71000000f,-0.38000000f,0.39000000f,0.93000000f,-0.32000000f,0.75000000f,-0.39000000f,0.63000000f,-0.44000000f,-0.10000000f,0.10000000f,0.83000000f,0.56000000f,-0.07000000f,-0.25000000f,0.75000000f,0.96000000f,0.34000000f,-0.78000000f,-0.95000000f,-0.18000000f,0.36000000f,0.57000000f,-0.82000000f,0.44000000f,-0.57000000f,0.65000000f,0.40000000f,-0.02000000f,0.97000000f,0.31000000f,0.06000000f,-0.91000000f,-0.80000000f,-0.74000000f,-0.29000000f,0.46000000f,-0.58000000f,0.47000000f,0.25000000f,-0.06000000f,0.28000000f,0.98000000f,-0.56000000f,-0.13000000f,0.90000000f,0.28000000f,0.99000000f,0.78000000f,-0.46000000f,0.96000000f,-0.34000000f,-0.94000000f,0.22000000f,0.99000000f,-0.48000000f,0.18000000f,0.97000000f,-0.52000000f,0.98000000f,0.74000000f,-0.18000000f,0.04000000f,0.98000000f,-0.85000000f,-0.36000000f,-0.29000000f,-0.18000000f,-0.39000000f,-0.89000000f,0.49000000f,-0.71000000f,0.24000000f,0.59000000f,-0.85000000f,0.58000000f,0.86000000f,-0.68000000f,0.07000000f,0.72000000f,-0.32000000f,-0.76000000f,0.84000000f,0.05000000f,0.16000000f,0.68000000f,-0.76000000f,0.22000000f,-0.65000000f,-0.18000000f,-0.49000000f,-0.17000000f,0.70000000f,-0.42000000f,0.98000000f,0.18000000f,0.18000000f,0.22000000f,0.14000000f,0.35000000f,0.26000000f,-0.36000000f,0.98000000f,0.84000000f,-0.54000000f,0.13000000f,0.90000000f,0.46000000f,0.53000000f,-0.94000000f,-0.15000000f,-0.14000000f,0.77000000f,0.68000000f,0.16000000f,-0.49000000f,-0.43000000f,-0.83000000f,-0.33000000f,0.14000000f,-0.55000000f,-0.39000000f,-0.14000000f,0.08000000f,-0.78000000f,-0.79000000f,-0.65000000f,-0.65000000f,0.73000000f,0.97000000f,0.65000000f,0.50000000f,-0.51000000f,-0.24000000f,-0.88000000f,0.59000000f,0.74000000f,0.03000000f,-0.91000000f,0.33000000f,0.03000000f,-0.66000000f,-0.20000000f,-0.13000000f,0.94000000f,0.46000000f,0.41000000f,0.50000000f,0.45000000f,0.47000000f,-0.10000000f,-0.28000000f,-0.36000000f,-0.02000000f,-0.52000000f,0.11000000f,-0.19000000f,-0.70000000f,0.33000000f,0.20000000f,-0.85000000f,-0.15000000f,-0.89000000f,0.11000000f,0.68000000f,-0.64000000f,-0.70000000f,0.90000000f,-0.02000000f,-0.26000000f,-0.49000000f,0.88000000f,0.46000000f,0.75000000f,0.96000000f,0.46000000f,0.08000000f,0.43000000f,-0.14000000f,-0.17000000f,-0.74000000f,-0.75000000f,-0.19000000f,0.61000000f,-0.87000000f,0.84000000f,-0.04000000f,0.85000000f,0.16000000f,-0.73000000f,0.14000000f,-0.21000000f,0.21000000f,0.73000000f,0.92000000f,0.10000000f,-0.66000000f,0.37000000f,-0.64000000f,0.90000000f,0.32000000f,-0.46000000f,0.04000000f,0.80000000f,0.88000000f,0.13000000f,-0.88000000f,-0.48000000f,0.37000000f,0.42000000f,-0.35000000f,-0.92000000f,-0.16000000f,0.61000000f,-0.15000000f,0.17000000f,0.14000000f,0.89000000f,-0.15000000f,0.18000000f,0.94000000f,-0.13000000f,0.51000000f,-0.67000000f,0.64000000f,0.41000000f,0.45000000f,0.00000000f,-0.81000000f,0.06000000f,-0.06000000f,-0.48000000f,-0.92000000f,-0.42000000f,0.83000000f,-0.87000000f,0.29000000f,0.72000000f,0.70000000f,0.40000000f,0.79000000f,-0.80000000f,0.17000000f,0.32000000f,0.29000000f,-0.30000000f,-0.13000000f,0.82000000f,0.72000000f,-0.96000000f,-0.84000000f,-0.13000000f,-0.36000000f,0.10000000f,0.40000000f,0.59000000f,0.92000000f,-0.30000000f,-0.16000000f,-0.53000000f,-0.47000000f,0.14000000f,-0.82000000f,0.02000000f,0.81000000f,0.27000000f,-0.77000000f,0.63000000f,0.47000000f,0.24000000f,0.19000000f,-0.29000000f,-0.56000000f,-0.49000000f,-0.03000000f,0.60000000f,-0.84000000f,0.10000000f,-0.30000000f,-0.09000000f,0.78000000f,0.31000000f,-0.75000000f,0.19000000f,-0.10000000f,0.02000000f,0.45000000f,0.60000000f,-0.36000000f,0.68000000f,0.49000000f,-0.29000000f,-0.21000000f,0.54000000f,-0.66000000f,0.55000000f,0.03000000f,0.53000000f,0.25000000f,-0.47000000f,-0.13000000f,0.41000000f,0.74000000f,0.02000000f,-0.67000000f,-0.68000000f,-0.61000000f,-0.92000000f,-0.37000000f,-0.65000000f,-0.76000000f,-0.86000000f,0.83000000f,-0.84000000f,-0.79000000f,-0.36000000f,0.09000000f,0.43000000f,0.68000000f,-0.81000000f,-0.25000000f,0.81000000f,-0.66000000f,0.28000000f,0.33000000f,0.74000000f,0.56000000f,-0.29000000f,-0.84000000f,-0.76000000f,0.74000000f,-0.03000000f,0.52000000f,0.30000000f,0.18000000f,0.11000000f,-0.46000000f,0.28000000f,-0.15000000f,-0.27000000f,0.21000000f,0.79000000f,-0.46000000f,-0.41000000f,-0.70000000f,0.60000000f,-0.35000000f,-0.33000000f,-0.56000000f,-0.14000000f,0.17000000f,0.01000000f,-0.81000000f,-0.62000000f,-0.60000000f,0.39000000f,-0.62000000f,0.87000000f,0.83000000f,-0.00000000f,-0.47000000f,-0.39000000f,-0.97000000f,0.11000000f,0.22000000f,-0.32000000f,-0.21000000f,-0.25000000f,0.70000000f,0.70000000f,0.01000000f,0.04000000f,-0.38000000f,-0.12000000f,0.80000000f,0.85000000f,0.40000000f,0.87000000f,-0.59000000f,-0.99000000f,-0.17000000f,0.63000000f,0.30000000f,0.36000000f,0.77000000f,-0.25000000f,-0.50000000f,0.22000000f,-0.26000000f,0.49000000f,-0.97000000f,0.18000000f,-0.29000000f,-0.19000000f,-0.28000000f,0.34000000f,-0.69000000f,-0.15000000f,-0.50000000f,0.18000000f,0.68000000f,-0.31000000f,0.52000000f,-0.18000000f,-0.67000000f,-0.22000000f,0.11000000f,-0.58000000f,-0.17000000f,-0.21000000f,-0.01000000f,0.71000000f,0.93000000f,0.00000000f,0.41000000f,-0.72000000f,-0.66000000f,-0.26000000f,-0.57000000f,-0.06000000f,-0.44000000f,-0.06000000f,-0.79000000f,-0.14000000f,-0.09000000f,0.52000000f,0.67000000f,-0.65000000f,-0.52000000f,-0.85000000f,-0.52000000f,-0.18000000f,-0.70000000f,0.75000000f,-0.51000000f,-0.49000000f,-0.06000000f,0.81000000f,0.06000000f,-0.95000000f,0.53000000f,-0.80000000f,-0.16000000f,0.84000000f,0.97000000f,-0.53000000f,0.00000000f,-0.75000000f,-0.99000000f,-0.38000000f,0.07000000f,-0.44000000f,0.25000000f,0.31000000f,0.16000000f,-0.39000000f,-0.92000000f,-0.17000000f,-0.38000000f,-0.63000000f,0.27000000f,0.53000000f,0.56000000f,-0.82000000f,0.95000000f,0.69000000f,-0.25000000f,0.62000000f,-0.36000000f,-0.21000000f,0.15000000f,-0.82000000f,-0.73000000f,-0.77000000f,-0.78000000f,0.46000000f,-0.15000000f,0.44000000f,0.82000000f,-0.82000000f,-0.50000000f,-0.73000000f,-0.39000000f,-0.85000000f,0.89000000f,-0.30000000f,-0.48000000f,-0.96000000f,0.95000000f,0.66000000f,-0.08000000f,0.82000000f,-0.00000000f,-0.16000000f,0.99000000f,-0.49000000f,0.27000000f,0.88000000f,-0.69000000f,-0.36000000f,-0.81000000f,0.86000000f,-0.53000000f,0.79000000f,0.76000000f,0.56000000f,0.59000000f,-0.70000000f,0.31000000f,0.61000000f,0.80000000f,0.93000000f,0.90000000f,0.05000000f,0.42000000f,0.21000000f,-0.75000000f,-0.87000000f,0.48000000f,-0.83000000f,-0.58000000f,-0.53000000f,-0.20000000f,-0.34000000f,-0.08000000f,0.25000000f,-0.21000000f,-0.18000000f,-0.82000000f,0.59000000f,0.18000000f,-0.73000000f,0.50000000f,0.36000000f,0.01000000f,-0.54000000f,-0.40000000f,0.24000000f,-0.99000000f,-0.30000000f,-0.43000000f,-0.26000000f,0.53000000f,0.98000000f,0.90000000f,-0.68000000f,-0.57000000f,-0.02000000f,0.63000000f,-0.84000000f,-0.96000000f,-0.52000000f,0.32000000f,0.09000000f,-0.98000000f,-0.52000000f,0.64000000f,0.17000000f,0.82000000f,0.07000000f,0.92000000f,0.63000000f,-0.43000000f,-0.52000000f,0.06000000f,-0.85000000f,0.02000000f,-0.71000000f,-0.86000000f,-0.58000000f,-0.32000000f,0.79000000f,0.68000000f,0.02000000f,0.50000000f,-0.76000000f,-0.26000000f,-0.23000000f,0.03000000f,0.42000000f,-0.26000000f,-0.09000000f,-0.40000000f,0.84000000f,0.79000000f,-0.57000000f,-0.07000000f,-0.61000000f,-0.79000000f,-0.97000000f,0.16000000f,0.10000000f,0.45000000f,-0.04000000f,0.66000000f,-0.52000000f,-0.39000000f,-0.77000000f,0.94000000f,0.70000000f,0.61000000f,-0.96000000f,-0.33000000f,0.85000000f,0.53000000f,-0.74000000f,0.30000000f,0.31000000f,-0.33000000f,0.74000000f,-0.56000000f,-0.00000000f,-0.95000000f,-0.91000000f,-0.42000000f,0.85000000f,-0.02000000f,-0.06000000f,-0.73000000f,0.07000000f,-0.52000000f,0.10000000f,0.39000000f,0.90000000f,0.78000000f,-0.11000000f,0.58000000f,0.61000000f,0.30000000f,0.53000000f,0.51000000f,0.06000000f,0.62000000f,0.58000000f,0.39000000f,-0.78000000f,0.47000000f,-0.36000000f,-0.48000000f,0.29000000f,-0.98000000f,0.90000000f,-0.63000000f,-0.40000000f,0.77000000f,0.93000000f,0.32000000f,0.94000000f,0.76000000f,-0.86000000f,0.84000000f,-0.57000000f,-0.35000000f,-0.68000000f,0.58000000f,-0.70000000f,-0.87000000f,-0.13000000f,-0.99000000f,-0.46000000f,0.51000000f,0.28000000f,-0.22000000f,-0.92000000f,-0.02000000f,0.77000000f,0.91000000f,0.41000000f,-0.13000000f,-0.18000000f,-0.80000000f,-0.12000000f,0.99000000f,-0.62000000f,0.71000000f,-0.39000000f,-0.53000000f,-0.75000000f,-0.88000000f,-0.05000000f,0.84000000f,0.32000000f,0.87000000f,0.18000000f,0.71000000f,0.03000000f,-0.48000000f,-0.59000000f,0.43000000f,-0.44000000f,0.23000000f,-0.36000000f,0.79000000f,-0.27000000f,-0.30000000f,-0.35000000f,0.56000000f,0.99000000f,-0.35000000f,-0.89000000f,-0.45000000f,0.45000000f,-0.55000000f,0.27000000f,-0.29000000f,0.90000000f,-0.95000000f,-0.63000000f,0.31000000f,-0.28000000f,-0.56000000f,0.38000000f,-0.08000000f,-0.18000000f,0.51000000f,0.60000000f,-0.93000000f,-0.00000000f,0.89000000f,-0.52000000f,0.08000000f,-0.36000000f,-0.61000000f,0.71000000f,-0.06000000f,0.53000000f,-0.77000000f,-0.46000000f,-0.30000000f,-0.79000000f,-0.36000000f,0.59000000f,-0.32000000f,-0.28000000f,0.88000000f,-0.15000000f,0.99000000f,0.31000000f,0.84000000f,0.72000000f,0.45000000f,0.61000000f,-0.69000000f,0.73000000f,-0.28000000f,0.88000000f,-0.21000000f,0.65000000f,-0.54000000f,-0.76000000f,-0.33000000f,-0.53000000f,0.87000000f,-0.36000000f,0.96000000f,0.60000000f,-0.07000000f,0.43000000f,0.52000000f,0.68000000f,0.72000000f,-0.53000000f,-0.23000000f,0.09000000f,0.47000000f,-0.92000000f,-0.31000000f,-0.63000000f,-0.26000000f,-0.86000000f,0.28000000f,0.77000000f,-0.14000000f,0.63000000f,0.48000000f,0.81000000f,0.31000000f,0.94000000f,0.37000000f,0.93000000f,-0.70000000f,0.64000000f,-0.63000000f,-0.31000000f,-0.10000000f,-0.64000000f,0.61000000f,0.02000000f,-0.86000000f,-0.40000000f,-0.95000000f,-0.80000000f,0.98000000f,0.96000000f,-0.07000000f,0.33000000f,-0.59000000f,-0.13000000f,-0.54000000f,0.67000000f,-0.50000000f,0.14000000f,-0.30000000f,0.30000000f,-0.80000000f,0.71000000f,0.86000000f,0.26000000f,-0.97000000f,-0.57000000f,-0.88000000f,-0.95000000f,0.84000000f,-0.25000000f,0.58000000f,-0.28000000f,-0.61000000f,-0.55000000f,-0.03000000f,0.14000000f,-0.05000000f,0.66000000f,0.98000000f,-0.01000000f,-0.41000000f,0.06000000f,0.74000000f,0.09000000f,0.42000000f,0.34000000f,-0.06000000f,0.27000000f,-0.26000000f,-0.82000000f,-0.07000000f,0.67000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.07000000f,0.05000000f,-0.21000000f,0.35000000f,-0.77000000f,-0.39000000f,0.11000000f,0.15000000f,0.06000000f,0.17000000f,0.69000000f,0.25000000f,-0.89000000f,0.93000000f,-0.29000000f,-0.25000000f,-0.95000000f,0.74000000f,-0.29000000f,-0.22000000f,0.82000000f,-0.71000000f,0.39000000f,-0.54000000f,0.58000000f,0.41000000f,-0.82000000f,-0.65000000f,-0.41000000f,-0.74000000f,-0.09000000f,-0.08000000f,-0.53000000f,-0.06000000f,-0.02000000f,0.51000000f,0.76000000f,0.40000000f,0.23000000f,-0.14000000f,-0.71000000f,-0.59000000f,0.33000000f,0.14000000f,-0.98000000f,-0.01000000f,-0.45000000f,0.25000000f,-0.33000000f,-0.21000000f,0.47000000f,-0.28000000f,-0.43000000f,0.52000000f,-0.04000000f,0.04000000f,-0.63000000f,0.53000000f,-0.15000000f,-0.23000000f,-0.15000000f,0.04000000f,-0.99000000f,-0.69000000f,0.16000000f,0.26000000f,-0.21000000f,0.90000000f,0.99000000f,-0.91000000f,-0.69000000f,0.40000000f,-0.69000000f,-0.52000000f,0.18000000f,0.86000000f,-0.41000000f,0.69000000f,0.44000000f,-0.13000000f,-0.16000000f,0.89000000f,0.60000000f,-0.12000000f,0.06000000f,0.84000000f,-0.58000000f,0.71000000f,0.19000000f,0.81000000f,0.58000000f,-0.64000000f,-0.39000000f,-0.92000000f,-0.70000000f,-0.98000000f,-0.13000000f,0.07000000f,-0.99000000f,0.14000000f,0.69000000f,-0.20000000f,0.18000000f,-0.80000000f,0.34000000f,-0.79000000f,0.94000000f,0.34000000f,-0.81000000f,-0.69000000f,-0.72000000f,-0.07000000f,0.33000000f,0.06000000f,0.87000000f,-0.77000000f,0.72000000f,0.16000000f,0.74000000f,0.87000000f,-0.87000000f,0.57000000f,0.87000000f,0.65000000f,0.63000000f,-0.78000000f,0.71000000f,0.64000000f,-0.94000000f,0.45000000f,0.52000000f,0.61000000f,0.80000000f,0.56000000f,0.89000000f,-0.99000000f,0.31000000f,0.11000000f,-0.63000000f,0.21000000f,0.97000000f,0.04000000f,-0.59000000f,-0.81000000f,0.13000000f,0.46000000f,0.28000000f,0.01000000f,-0.22000000f,0.62000000f,-0.12000000f,0.64000000f,0.82000000f,-0.67000000f,-0.76000000f,0.87000000f,-0.23000000f,-0.43000000f,0.72000000f,-0.64000000f,0.08000000f,0.53000000f,-0.41000000f,-0.03000000f,-0.68000000f,0.62000000f,0.08000000f,0.37000000f,-0.12000000f,-0.52000000f,0.07000000f,0.06000000f,-0.28000000f,0.02000000f,0.35000000f,0.11000000f,0.38000000f,0.90000000f,-0.19000000f,-0.36000000f,0.95000000f,-0.53000000f,-0.66000000f,-0.30000000f,0.46000000f,0.44000000f,0.63000000f,0.15000000f,0.75000000f,-0.88000000f,-0.80000000f,-0.39000000f,-0.33000000f,0.45000000f,0.56000000f,-0.34000000f,0.98000000f,-0.50000000f,0.22000000f,0.15000000f,0.12000000f,0.62000000f,0.06000000f,0.82000000f,-0.40000000f,0.86000000f,0.56000000f,0.18000000f,0.13000000f,-0.30000000f,-0.98000000f,0.57000000f,-0.49000000f,-0.32000000f,-0.74000000f,0.91000000f,-0.07000000f,0.09000000f,0.35000000f,-0.22000000f,-0.42000000f,0.37000000f,0.41000000f,-0.01000000f,-0.45000000f,0.96000000f,-0.97000000f,-0.37000000f,0.58000000f,-0.74000000f,0.61000000f,0.37000000f,-0.25000000f,0.82000000f,0.99000000f,-0.22000000f,0.60000000f,-0.95000000f,0.35000000f,0.63000000f,-0.73000000f,-0.96000000f,0.40000000f,0.17000000f,-0.04000000f,0.01000000f,-0.45000000f,-0.52000000f,0.86000000f,0.32000000f,-0.97000000f,-0.67000000f,0.21000000f,0.60000000f,-0.88000000f,-0.17000000f,0.11000000f,-0.89000000f,0.52000000f,-0.93000000f,-0.17000000f,-0.94000000f,0.72000000f,-0.45000000f,0.81000000f,-0.85000000f,-0.63000000f,0.27000000f,0.72000000f,-0.99000000f,-0.74000000f,-0.70000000f,-0.06000000f,-0.28000000f,0.28000000f,0.89000000f,-0.38000000f,-0.36000000f,0.28000000f,0.51000000f,-0.29000000f,-0.04000000f,-0.22000000f,-0.77000000f,0.62000000f,0.68000000f,0.73000000f,-0.29000000f,0.96000000f,0.26000000f,0.36000000f,-0.79000000f,0.93000000f,0.23000000f,0.06000000f,-0.99000000f,0.93000000f,0.34000000f,-0.40000000f,0.43000000f,-0.80000000f,-0.60000000f,-0.64000000f,-0.17000000f,-0.89000000f,-0.56000000f,-0.81000000f,0.70000000f,-0.67000000f,0.57000000f,0.57000000f,-0.77000000f,-0.28000000f,-0.39000000f,-0.58000000f,-0.35000000f,-0.02000000f,0.21000000f,-0.43000000f,0.60000000f,-0.95000000f,-0.44000000f,0.40000000f,-0.22000000f,0.44000000f,-0.94000000f,0.21000000f,-0.21000000f,-0.38000000f,-0.06000000f,0.43000000f,-0.48000000f,0.49000000f,-0.79000000f,0.31000000f,-0.91000000f,0.34000000f,0.89000000f,0.10000000f,0.50000000f,0.48000000f,0.29000000f,0.00000000f,0.24000000f,0.50000000f,0.56000000f,-0.73000000f,-0.10000000f,0.23000000f,0.29000000f,0.59000000f,-0.02000000f,-0.76000000f,-0.46000000f,-0.97000000f,-0.06000000f,-0.46000000f,0.51000000f,0.14000000f,0.97000000f,-0.37000000f,0.65000000f,-0.74000000f,-0.20000000f,-0.29000000f,0.57000000f,-0.80000000f,-0.34000000f,-0.33000000f,0.17000000f,-0.86000000f,0.58000000f,-0.85000000f,-0.08000000f,0.09000000f,-0.88000000f,0.57000000f,-0.78000000f,-0.55000000f,-0.72000000f,0.18000000f,-0.45000000f,0.37000000f,-0.51000000f,-0.77000000f,0.83000000f,-0.39000000f,0.73000000f,-0.87000000f,-0.18000000f,-0.95000000f,0.94000000f,-0.21000000f,0.70000000f,0.56000000f,0.25000000f,0.99000000f,0.14000000f,0.18000000f,-0.35000000f,0.72000000f,0.09000000f,0.98000000f,0.85000000f,0.10000000f,0.97000000f,0.42000000f,-0.15000000f,-0.85000000f,0.89000000f,0.67000000f,0.99000000f,-0.08000000f,0.32000000f,0.08000000f,0.55000000f,0.96000000f,-0.52000000f,-0.63000000f,-0.21000000f,-0.50000000f,0.79000000f,0.10000000f,0.61000000f,-0.96000000f,-0.47000000f,0.59000000f,-0.02000000f,-0.39000000f,0.89000000f,0.31000000f,0.94000000f,-0.84000000f,0.47000000f,0.79000000f,0.82000000f,-0.18000000f,-0.41000000f,-0.22000000f,-0.99000000f,-0.68000000f,-0.35000000f,0.86000000f,0.16000000f,0.68000000f,0.05000000f,-0.11000000f,-0.65000000f,0.23000000f,-0.81000000f,-0.92000000f,-0.70000000f,0.60000000f,-0.65000000f,-0.37000000f,-0.23000000f,0.10000000f,0.15000000f,0.19000000f,-0.03000000f,0.74000000f,-0.07000000f,0.12000000f,-0.49000000f,0.67000000f,-0.91000000f,0.38000000f,0.53000000f,0.86000000f,-0.41000000f,-0.39000000f,-0.79000000f,-0.48000000f,-0.83000000f,-0.58000000f,0.18000000f,-0.96000000f,-0.77000000f,-0.47000000f,-0.38000000f,0.32000000f,0.23000000f,0.85000000f,0.35000000f,0.40000000f,-0.27000000f,0.66000000f,0.62000000f,0.65000000f,-0.94000000f,-0.69000000f,-0.93000000f,0.69000000f,-0.20000000f,0.05000000f,-0.67000000f,-0.18000000f,-0.36000000f,-0.31000000f,0.15000000f,-0.01000000f,0.86000000f,-0.72000000f,-0.94000000f,0.41000000f,-0.22000000f,-0.86000000f,-0.56000000f,0.69000000f,0.09000000f,-0.00000000f,-0.80000000f,0.05000000f,0.98000000f,0.95000000f,0.46000000f,-0.33000000f,-0.38000000f,-0.04000000f,-0.53000000f,-0.12000000f,0.82000000f,-0.55000000f,-0.79000000f,0.10000000f,-0.14000000f,-0.68000000f,-0.29000000f,0.14000000f,0.93000000f,0.64000000f,0.97000000f,0.37000000f,0.69000000f,0.73000000f,-0.57000000f,0.11000000f,-0.75000000f,-0.07000000f,0.74000000f,0.25000000f,-0.57000000f,0.67000000f,0.60000000f,-0.26000000f,-0.35000000f,-0.19000000f,0.55000000f,0.42000000f,-0.62000000f,0.63000000f,-0.87000000f,-0.82000000f,0.60000000f,-0.10000000f,-0.67000000f,0.89000000f,-0.38000000f,0.29000000f,0.30000000f,0.81000000f,0.95000000f,0.43000000f,-0.64000000f,0.91000000f,0.37000000f,0.96000000f,-0.71000000f,0.55000000f,0.06000000f,-0.95000000f,-0.56000000f,0.34000000f,0.25000000f,0.05000000f,0.26000000f,0.28000000f,0.95000000f,0.68000000f,-0.63000000f,-0.80000000f,0.63000000f,-0.09000000f,-0.06000000f,0.26000000f,-0.34000000f,-0.27000000f,-0.57000000f,0.99000000f,-0.48000000f,0.10000000f,0.96000000f,-0.17000000f,0.70000000f,-0.76000000f,-0.49000000f,0.37000000f,-0.81000000f,-0.05000000f,-0.67000000f,0.70000000f,-0.94000000f,-0.15000000f,-0.98000000f,0.03000000f,-0.77000000f,0.97000000f,-0.61000000f,-0.32000000f,0.63000000f,-0.01000000f,-0.42000000f,-0.89000000f,0.41000000f,0.14000000f,0.11000000f,-0.61000000f,-0.05000000f,0.32000000f,0.21000000f,0.64000000f,0.36000000f,-0.44000000f,0.05000000f,-0.33000000f,0.19000000f,-0.43000000f,-0.40000000f,-0.89000000f,0.90000000f,0.67000000f,0.66000000f,-0.37000000f,-0.67000000f,-0.63000000f,0.93000000f,0.29000000f,0.28000000f,0.41000000f,0.17000000f,-0.76000000f,-0.61000000f,-0.48000000f,-0.86000000f,-0.13000000f,-0.55000000f,0.96000000f,-0.06000000f,-0.14000000f,0.97000000f,0.86000000f,-0.20000000f,0.88000000f,0.40000000f,0.64000000f,0.79000000f,0.47000000f,-0.09000000f,-0.26000000f,-0.31000000f,0.74000000f,-0.09000000f,-0.49000000f,0.64000000f,-0.40000000f,-0.31000000f,-0.87000000f,-0.68000000f,0.40000000f,-0.44000000f,0.19000000f,0.10000000f,-0.69000000f,0.42000000f,-0.59000000f,0.84000000f,-0.39000000f,-0.85000000f,0.33000000f,0.44000000f,0.12000000f,0.69000000f,0.02000000f,-0.71000000f,0.57000000f,-0.16000000f,-0.67000000f,0.53000000f,-0.95000000f,0.37000000f,0.42000000f,0.40000000f,0.76000000f,-0.61000000f,0.02000000f,0.77000000f,0.66000000f,0.54000000f,-0.37000000f,-0.76000000f,-0.56000000f,0.77000000f,0.57000000f,0.99000000f,-0.02000000f,0.00000000f,0.54000000f,0.19000000f,0.89000000f,-0.32000000f,-0.00000000f,-0.74000000f,-0.82000000f,0.43000000f,0.42000000f,0.35000000f,-0.81000000f,0.68000000f,-0.52000000f,-0.17000000f,0.18000000f,0.29000000f,0.76000000f,-0.73000000f,0.01000000f,-0.28000000f,0.04000000f,0.21000000f,0.89000000f,-0.40000000f,0.04000000f,0.13000000f,-0.95000000f,0.33000000f,0.47000000f,0.18000000f,0.61000000f,-0.83000000f,-0.08000000f,-0.08000000f,-0.75000000f,0.30000000f,0.42000000f,0.76000000f,0.25000000f,0.18000000f,-0.84000000f,0.11000000f,-0.94000000f,-0.42000000f,-0.16000000f,-0.97000000f,0.54000000f,0.11000000f,0.37000000f,0.10000000f,-0.39000000f,-0.20000000f,0.09000000f,0.04000000f,-0.92000000f,0.97000000f,0.98000000f,-0.78000000f,0.58000000f,-0.74000000f,0.92000000f,-0.27000000f,0.16000000f,-0.42000000f,-0.31000000f,0.39000000f,0.23000000f,-0.65000000f,0.24000000f,-0.92000000f,0.52000000f,0.98000000f,0.39000000f,0.51000000f,0.98000000f,-0.98000000f,0.34000000f,0.68000000f,-0.84000000f,0.41000000f,-0.87000000f,0.55000000f,0.39000000f,0.16000000f,0.37000000f,0.01000000f,0.82000000f,0.91000000f,-0.82000000f,-0.76000000f,0.65000000f,-0.45000000f,0.44000000f,0.07000000f,-0.46000000f,0.64000000f,-0.63000000f,-0.11000000f,0.54000000f,-0.92000000f,-0.11000000f,-0.94000000f,-0.78000000f,-0.88000000f,0.68000000f,-0.11000000f,0.78000000f,0.28000000f,-0.08000000f,0.99000000f,0.27000000f,0.73000000f,-0.55000000f,0.05000000f,0.69000000f,-0.69000000f,-0.83000000f,0.70000000f,-0.24000000f,0.26000000f,-0.86000000f,0.69000000f,0.91000000f,0.43000000f,0.84000000f,-0.60000000f,0.31000000f,0.74000000f,0.57000000f,-0.93000000f,-0.85000000f,-0.74000000f,0.73000000f,-0.15000000f,0.30000000f,0.70000000f,-0.15000000f,0.09000000f,-0.46000000f,0.59000000f,0.05000000f,0.34000000f,0.33000000f,0.17000000f,-0.08000000f,0.03000000f,-0.60000000f,0.93000000f,0.11000000f,-0.13000000f,-0.65000000f,-0.19000000f,0.49000000f,0.82000000f,-0.77000000f,0.22000000f,-0.02000000f,0.79000000f,0.06000000f,0.16000000f,-0.79000000f,-0.30000000f,-0.48000000f,0.62000000f,-0.12000000f,-0.95000000f,-0.87000000f,-0.94000000f,-0.90000000f,-0.33000000f,0.60000000f,-0.21000000f,0.88000000f,-0.28000000f,0.46000000f,-0.14000000f,0.13000000f,-0.11000000f,-0.17000000f,-0.03000000f,0.19000000f,-0.04000000f,-0.34000000f,-0.14000000f,0.65000000f,-0.35000000f,-0.66000000f,-0.75000000f,0.25000000f,-0.91000000f,-0.45000000f,-0.59000000f,0.32000000f,0.75000000f,-0.24000000f,-0.14000000f,0.10000000f,-0.24000000f,0.03000000f,-0.83000000f,0.90000000f,0.08000000f,0.09000000f,0.65000000f,-0.39000000f,-0.80000000f,0.26000000f,0.36000000f,-0.14000000f,-0.53000000f,0.21000000f,-0.06000000f,0.63000000f,0.94000000f,-0.86000000f,0.30000000f,0.91000000f,-0.01000000f,-0.61000000f,0.67000000f,-0.44000000f,-0.57000000f,0.28000000f,0.83000000f,-0.46000000f,-0.18000000f,-0.27000000f,-0.25000000f,0.43000000f,0.55000000f,-0.74000000f,-0.39000000f,0.51000000f,0.62000000f,0.70000000f,0.17000000f,0.61000000f,-0.87000000f,-0.76000000f,-0.28000000f,0.80000000f,-0.09000000f,0.48000000f,-0.68000000f,0.46000000f,0.76000000f,0.73000000f,-0.06000000f,0.15000000f,0.01000000f,0.84000000f,-0.71000000f,0.43000000f,-0.82000000f,0.77000000f,-0.86000000f,0.30000000f,0.01000000f,-0.03000000f,-0.79000000f,-0.96000000f,0.75000000f,0.36000000f,-0.18000000f,-0.23000000f,0.79000000f,0.36000000f,-0.77000000f,0.96000000f,0.60000000f,0.11000000f,-0.73000000f,-0.44000000f,-0.15000000f,-0.54000000f,0.94000000f,-0.54000000f,0.73000000f,0.43000000f,0.70000000f,-0.02000000f,-0.47000000f,0.14000000f,-0.07000000f,-0.78000000f,-0.12000000f,0.61000000f,-0.65000000f,0.28000000f,-0.66000000f,-0.56000000f,0.76000000f,0.56000000f,0.52000000f,-0.43000000f,0.31000000f,0.11000000f,-0.94000000f,0.04000000f,-0.52000000f,-0.37000000f,0.86000000f,-0.74000000f,-0.38000000f,-0.40000000f,0.41000000f,-0.40000000f,0.09000000f,-0.07000000f,-0.79000000f,-0.08000000f,-0.32000000f,-0.87000000f,-0.31000000f,0.21000000f,-0.58000000f,-0.18000000f,-0.86000000f,0.29000000f,-0.28000000f,0.30000000f,-0.52000000f,0.41000000f,0.66000000f,0.10000000f,-0.40000000f,0.70000000f,0.29000000f,-0.20000000f,-0.25000000f,0.33000000f,0.32000000f,-0.14000000f,0.39000000f,-0.41000000f,0.65000000f,-0.88000000f,0.82000000f,0.34000000f,-0.80000000f,0.06000000f,0.86000000f,-0.69000000f,-0.84000000f,-0.36000000f,0.43000000f,0.25000000f,-0.80000000f,0.84000000f,0.19000000f,-0.80000000f,0.53000000f,-0.53000000f,0.04000000f,-0.54000000f,-0.26000000f,-0.59000000f,0.21000000f,-0.45000000f,0.53000000f,-0.17000000f,0.52000000f,0.35000000f,0.72000000f,0.16000000f,-0.31000000f,0.12000000f,-0.03000000f,-0.92000000f,0.02000000f,0.27000000f,0.52000000f,0.34000000f,-0.66000000f,-0.46000000f,-0.14000000f,0.81000000f,0.00000000f,0.92000000f,-0.49000000f,0.80000000f,0.40000000f,-0.90000000f,0.34000000f,0.12000000f,0.47000000f,0.16000000f,-0.66000000f,-0.83000000f,0.30000000f,0.10000000f,-0.99000000f,0.95000000f,0.61000000f,0.92000000f,0.90000000f,-0.46000000f,0.99000000f,0.38000000f,0.38000000f,0.79000000f,-0.33000000f,0.28000000f,0.69000000f,0.44000000f,-0.18000000f,-0.66000000f,0.07000000f,0.65000000f,-0.06000000f,-0.24000000f,-0.70000000f,0.01000000f,-0.31000000f,-0.40000000f,0.19000000f,0.93000000f,-0.52000000f,-0.29000000f,-0.59000000f,-0.55000000f,-0.57000000f,-0.61000000f,-0.51000000f,0.99000000f,0.22000000f,0.51000000f,0.71000000f,0.39000000f,0.59000000f,0.38000000f,0.02000000f,-0.98000000f,0.56000000f,-0.04000000f,-0.02000000f,0.44000000f,-0.85000000f,-0.70000000f,-0.70000000f,-0.02000000f,-0.09000000f,-0.96000000f,0.72000000f,0.25000000f,-0.20000000f,0.15000000f,0.68000000f,-0.90000000f,-0.91000000f,-0.99000000f,-0.21000000f,-0.59000000f,-0.38000000f,-0.02000000f,-0.84000000f,-0.50000000f,0.68000000f,-0.22000000f,-0.88000000f,0.25000000f,0.98000000f,-0.10000000f,-0.37000000f,-0.14000000f,0.70000000f,0.03000000f,0.45000000f,0.17000000f,-0.01000000f,0.33000000f,-0.15000000f,0.03000000f,-0.66000000f,-0.05000000f,-0.10000000f,0.35000000f,-0.00000000f,-0.12000000f,-0.79000000f,0.76000000f,0.29000000f,-0.27000000f,0.79000000f,-0.57000000f,0.62000000f,0.65000000f,0.84000000f,-0.17000000f,0.23000000f,0.74000000f,0.98000000f,-0.24000000f,-0.96000000f,-0.16000000f,0.76000000f,-0.22000000f,0.35000000f,-0.39000000f,0.67000000f,0.59000000f,0.91000000f,0.88000000f,0.69000000f,-0.72000000f,0.43000000f,0.55000000f,-0.55000000f,0.94000000f,0.34000000f,-0.74000000f,-0.44000000f,-0.48000000f,-0.92000000f,-0.62000000f,0.79000000f,0.52000000f,-0.59000000f,-0.14000000f,-0.20000000f,0.14000000f,0.65000000f,-0.27000000f,0.71000000f,-0.80000000f,0.29000000f,-0.15000000f,0.15000000f,0.30000000f,-0.65000000f,-0.17000000f,-0.72000000f,-0.90000000f,0.99000000f,-0.20000000f,0.40000000f,-0.59000000f,0.46000000f,-0.69000000f,0.97000000f,-0.86000000f,0.35000000f,-0.96000000f,0.22000000f,0.26000000f,-0.87000000f,-0.46000000f,-0.54000000f,0.30000000f,0.28000000f,0.63000000f,0.43000000f,-0.87000000f,-0.16000000f,0.40000000f,0.07000000f,-0.04000000f,0.67000000f,-0.30000000f,-0.45000000f,0.88000000f,0.92000000f,0.05000000f,0.24000000f,0.18000000f,-0.29000000f,0.26000000f,0.57000000f,-0.35000000f,0.49000000f,-0.16000000f,0.32000000f,-0.79000000f,-0.29000000f,-0.87000000f,-0.72000000f,0.40000000f,-0.44000000f,-0.69000000f,-0.93000000f,-0.85000000f,0.92000000f,0.00000000f,0.66000000f,-0.32000000f,0.94000000f,0.40000000f,0.81000000f,0.67000000f,-0.72000000f,-0.11000000f,0.82000000f,-0.83000000f,-0.53000000f,-0.01000000f,0.18000000f,-0.95000000f,-0.41000000f,-0.98000000f,-0.08000000f,0.24000000f,-0.33000000f,0.72000000f,-0.81000000f,0.21000000f,0.46000000f,0.25000000f,-0.74000000f,0.78000000f,0.68000000f,-0.20000000f,-0.66000000f,0.73000000f,-0.09000000f,0.98000000f,0.50000000f,0.38000000f,0.95000000f,-0.79000000f,0.47000000f,0.95000000f,-0.28000000f,-0.03000000f,0.15000000f,0.25000000f,0.61000000f,0.10000000f,-0.42000000f,0.98000000f,-0.93000000f,-0.47000000f,-0.03000000f,0.31000000f,0.50000000f,-0.24000000f,0.42000000f,-0.03000000f,-0.75000000f,0.75000000f,0.86000000f,0.07000000f,0.79000000f,0.39000000f,0.58000000f,-0.09000000f,-0.04000000f,0.63000000f,-0.49000000f,0.89000000f,0.64000000f,0.14000000f,-0.70000000f,0.04000000f,-0.24000000f,0.42000000f,0.98000000f,-0.88000000f,-0.86000000f,0.43000000f,-0.17000000f,-0.79000000f,-0.15000000f,-0.43000000f,0.97000000f,-0.88000000f,-0.97000000f,0.87000000f,-0.61000000f,0.56000000f,0.53000000f,0.94000000f,0.26000000f,-0.71000000f,0.68000000f,-0.19000000f,0.87000000f,0.00000000f,-0.02000000f,0.33000000f,0.91000000f,-0.36000000f,0.60000000f,-0.55000000f,-0.04000000f,-0.58000000f,-0.07000000f,0.18000000f,0.42000000f,-0.77000000f,-0.66000000f,-0.90000000f,-0.23000000f,-0.94000000f,0.90000000f,-0.37000000f,-0.63000000f,0.57000000f,0.98000000f,-0.46000000f,-0.47000000f,0.79000000f,0.63000000f,-0.05000000f,-0.39000000f,-0.51000000f,0.22000000f,0.23000000f,-0.89000000f,-0.01000000f,0.98000000f,-0.59000000f,-0.85000000f,0.12000000f,0.24000000f,0.63000000f,-0.69000000f,0.84000000f,-0.15000000f,0.48000000f,-0.16000000f,0.14000000f,0.78000000f,0.84000000f,0.86000000f,-0.80000000f,-0.05000000f,-0.42000000f,0.32000000f,-0.39000000f,-0.27000000f,0.85000000f,-0.58000000f,0.96000000f,-0.53000000f,-0.40000000f,-0.75000000f,0.76000000f,-0.87000000f,-0.39000000f,0.73000000f,0.48000000f,0.87000000f,-0.49000000f,0.94000000f,-0.25000000f,-0.19000000f,-0.30000000f,0.56000000f,-0.35000000f,0.09000000f,0.62000000f,0.02000000f,0.07000000f,-0.32000000f,0.83000000f,0.87000000f,0.96000000f,0.50000000f,0.16000000f,0.12000000f,-0.21000000f,-0.77000000f,-0.69000000f,0.95000000f,-0.84000000f,-0.93000000f,-0.83000000f,0.68000000f,0.06000000f,0.48000000f,-0.95000000f,0.44000000f,0.62000000f,0.21000000f,-0.62000000f,-0.11000000f,0.21000000f,-0.74000000f,-0.04000000f,0.07000000f,0.47000000f,-0.07000000f,-0.27000000f,0.71000000f,0.70000000f,-0.55000000f,0.13000000f,-0.50000000f,0.63000000f,-0.51000000f,0.48000000f,-0.19000000f,0.17000000f,-0.34000000f,-0.87000000f,-0.28000000f,-0.71000000f,0.16000000f,-0.56000000f,0.39000000f,-0.14000000f,0.26000000f,-0.09000000f,-0.48000000f,-0.10000000f,0.50000000f,-0.83000000f,0.02000000f,-0.39000000f,0.19000000f,0.10000000f,0.73000000f,-0.43000000f,-0.47000000f,0.79000000f,0.75000000f,0.89000000f,-0.38000000f,-0.72000000f,-0.93000000f,-0.22000000f,-0.00000000f,0.43000000f,0.07000000f,-0.96000000f,0.08000000f,0.63000000f,-0.55000000f,-0.55000000f,0.83000000f,-0.12000000f,-0.70000000f,0.03000000f,-0.51000000f,0.61000000f,0.49000000f,0.95000000f,0.93000000f,0.69000000f,0.88000000f,-0.10000000f,0.50000000f,-0.05000000f,-0.59000000f,0.36000000f,-0.85000000f,-0.02000000f,-0.02000000f,0.75000000f,-0.77000000f,-0.49000000f,0.16000000f,0.75000000f,-0.08000000f,-0.44000000f,0.17000000f,-0.87000000f,-0.19000000f,-0.60000000f,0.03000000f,-0.30000000f,-0.21000000f,-0.58000000f,0.08000000f,-0.47000000f,-0.03000000f,0.39000000f,0.61000000f,0.71000000f,0.10000000f,0.18000000f,0.53000000f,-0.62000000f,-0.72000000f,0.72000000f,-0.87000000f,-0.45000000f,-0.57000000f,0.14000000f,0.65000000f,-0.14000000f,-0.65000000f,0.17000000f,-0.89000000f,-0.35000000f,0.22000000f,-0.82000000f,-0.23000000f,-0.56000000f,0.25000000f,0.82000000f,0.98000000f,0.24000000f,0.76000000f,-0.27000000f,-0.97000000f,-0.14000000f,-0.99000000f,0.95000000f,0.73000000f,-0.37000000f,-0.26000000f,0.73000000f,-0.51000000f,0.42000000f,-0.25000000f,0.76000000f,0.59000000f,-0.54000000f,0.18000000f,0.12000000f,0.41000000f,0.41000000f,-0.45000000f,0.44000000f,-0.26000000f,-0.10000000f,-0.21000000f,-0.33000000f,0.82000000f,-0.88000000f,0.33000000f,-0.83000000f,-0.47000000f,0.08000000f,0.36000000f,-0.59000000f,-0.77000000f,0.70000000f,-0.23000000f,0.72000000f,0.77000000f,-0.99000000f,0.36000000f,0.16000000f,0.62000000f,0.35000000f,-0.99000000f,0.99000000f,-0.32000000f,0.39000000f,-0.09000000f,0.15000000f,0.97000000f,-0.42000000f,-0.51000000f,-0.98000000f,-0.23000000f,-0.81000000f,-0.62000000f,0.36000000f,-0.63000000f,0.33000000f,-0.67000000f,-0.84000000f,0.17000000f,0.26000000f,-0.57000000f,0.77000000f,-0.86000000f,0.54000000f,-0.11000000f,0.97000000f,-0.29000000f,0.45000000f,-0.59000000f,-0.39000000f,0.21000000f,-0.40000000f,0.03000000f,0.36000000f,0.41000000f,0.56000000f,0.76000000f,0.71000000f,-0.62000000f,-0.49000000f,0.99000000f,0.03000000f,0.55000000f,-0.15000000f,0.03000000f,0.62000000f,-0.62000000f,-0.02000000f,-0.53000000f,0.64000000f,-0.24000000f,0.14000000f,0.67000000f,-0.58000000f,-0.90000000f,0.66000000f,0.44000000f,-0.15000000f,0.16000000f,0.92000000f,0.84000000f,0.61000000f,0.45000000f,0.01000000f,-0.23000000f,0.51000000f,0.65000000f,-0.04000000f,-0.61000000f,-0.66000000f,0.76000000f,-0.52000000f,0.63000000f,0.82000000f,0.67000000f,0.81000000f,-0.08000000f,0.14000000f,0.91000000f,0.20000000f,-0.82000000f,-0.90000000f,0.70000000f,0.65000000f,0.87000000f,0.38000000f,0.77000000f,0.52000000f,0.40000000f,-0.57000000f,0.19000000f,0.58000000f,0.50000000f,0.78000000f,-0.09000000f,-0.93000000f,0.67000000f,0.06000000f,0.11000000f,0.36000000f,-0.40000000f,0.37000000f,0.53000000f,0.01000000f,-0.09000000f,0.89000000f,-0.87000000f,0.99000000f,-0.54000000f,0.92000000f,-0.45000000f,0.69000000f,-0.22000000f,0.92000000f,-0.01000000f,0.04000000f,0.68000000f,-0.96000000f,-0.56000000f,0.26000000f,0.24000000f,0.77000000f,-0.31000000f,0.23000000f,0.26000000f,-0.09000000f,-0.12000000f,-0.57000000f,0.35000000f,-0.80000000f,0.36000000f,0.36000000f,0.55000000f,0.85000000f,-0.60000000f,0.12000000f,-0.96000000f,-0.54000000f,-0.58000000f,-0.21000000f,0.62000000f,0.60000000f,0.64000000f,0.70000000f,-0.14000000f,-0.63000000f,-0.14000000f,0.55000000f,0.25000000f,0.21000000f,-0.19000000f,0.42000000f,-0.61000000f,-0.08000000f,-0.38000000f,-0.86000000f,0.08000000f,0.48000000f,-0.58000000f,0.82000000f,0.14000000f,0.50000000f,0.81000000f,0.07000000f,0.24000000f,0.03000000f,0.54000000f,0.47000000f,-0.97000000f,-0.80000000f,-0.76000000f,-0.86000000f,0.80000000f,-0.14000000f,-0.04000000f,-0.54000000f,0.61000000f,-0.42000000f,-0.90000000f,0.94000000f,-0.84000000f,0.15000000f,-0.72000000f,0.52000000f,0.10000000f,-0.48000000f,0.42000000f,-0.63000000f,0.93000000f,-0.80000000f,-0.17000000f,-0.29000000f,-0.87000000f,-0.24000000f,0.99000000f,0.75000000f,0.78000000f,-0.39000000f,-0.94000000f,0.46000000f,0.34000000f,-0.93000000f,0.87000000f,-0.18000000f,0.20000000f,0.33000000f,0.91000000f,0.12000000f,0.62000000f,-0.19000000f,-0.50000000f,-0.20000000f,0.73000000f,0.81000000f,-0.04000000f,-0.26000000f,0.16000000f,-0.24000000f,0.60000000f,-0.69000000f,0.59000000f,0.18000000f,0.02000000f,-0.00000000f,-0.28000000f,0.48000000f,-0.29000000f,-0.97000000f,0.11000000f,-0.34000000f,-0.22000000f,0.74000000f,0.53000000f,0.11000000f,-0.97000000f,-0.50000000f,-0.46000000f,-0.96000000f,-0.93000000f,-0.02000000f,-0.23000000f,0.04000000f,-0.30000000f,-0.79000000f,-0.46000000f,0.03000000f,-0.18000000f,0.71000000f,0.73000000f,0.27000000f,0.76000000f,0.65000000f,0.52000000f,0.34000000f,0.54000000f,-0.36000000f,0.02000000f,0.90000000f,-0.24000000f,-0.44000000f,-0.81000000f,-0.22000000f,0.50000000f,-0.25000000f,-0.94000000f,0.91000000f,-0.57000000f,-0.38000000f,0.95000000f,-0.05000000f,0.46000000f,-0.74000000f,-0.88000000f,0.59000000f,0.86000000f,-0.52000000f,-0.32000000f,0.30000000f,-0.43000000f,0.68000000f,0.69000000f,-0.88000000f,0.92000000f,-0.29000000f,-0.78000000f,0.89000000f,-0.96000000f,-0.91000000f,-0.80000000f,0.14000000f,-0.36000000f,-0.86000000f,0.79000000f,-0.39000000f,-0.81000000f,0.86000000f,0.43000000f,-0.77000000f,0.44000000f,-0.40000000f,-0.91000000f,-0.43000000f,-0.29000000f,-0.23000000f,-0.07000000f,-0.76000000f,0.14000000f,0.88000000f,0.59000000f,-0.36000000f,-0.80000000f,-0.81000000f,0.74000000f,0.49000000f,-0.41000000f,0.10000000f,-0.45000000f,0.89000000f,0.99000000f,0.95000000f,-0.84000000f,-0.19000000f,-0.50000000f,-0.00000000f,0.17000000f,-0.27000000f,-0.14000000f,-0.27000000f,-0.34000000f,-0.22000000f,0.10000000f,0.78000000f,-0.90000000f,0.64000000f,0.98000000f,-0.78000000f,0.06000000f,0.61000000f,0.51000000f,-0.34000000f,0.70000000f,-0.17000000f,-0.65000000f,0.84000000f,-0.56000000f,-0.81000000f,0.26000000f,-0.08000000f,0.84000000f,0.64000000f,0.96000000f,-0.26000000f,0.73000000f,0.68000000f,0.71000000f,-0.53000000f,-0.04000000f,0.32000000f,0.99000000f,-0.73000000f,0.65000000f,-0.57000000f,0.44000000f,-0.66000000f,-0.20000000f,-0.43000000f,-0.54000000f,-0.97000000f,0.41000000f,0.24000000f,-0.53000000f,-0.55000000f,-0.26000000f,-0.71000000f,0.51000000f,0.83000000f,0.53000000f,0.01000000f,0.95000000f,0.45000000f,-0.40000000f,0.31000000f,0.59000000f,0.34000000f,-0.45000000f,-0.92000000f,-0.27000000f,0.54000000f,-0.14000000f,-0.87000000f,-0.60000000f,0.72000000f,-0.70000000f,-0.04000000f,0.18000000f,0.91000000f,0.68000000f,-0.15000000f,0.21000000f,0.86000000f,0.54000000f,-0.86000000f,0.70000000f,0.40000000f,0.64000000f,-0.82000000f,-0.70000000f,0.68000000f,0.96000000f,0.71000000f,0.84000000f,-0.89000000f,-0.47000000f,-0.63000000f,-0.75000000f,0.79000000f,-0.77000000f,0.14000000f,0.02000000f,0.19000000f,-0.84000000f,-0.19000000f,0.63000000f,0.32000000f,0.65000000f,-0.16000000f,0.44000000f,-0.23000000f,-0.01000000f,0.67000000f,0.85000000f,0.08000000f,0.32000000f,0.14000000f,0.70000000f,0.40000000f,-0.03000000f,-0.29000000f,0.78000000f,-0.17000000f,-0.68000000f,0.36000000f,0.28000000f,-0.48000000f,0.65000000f,0.74000000f,-0.37000000f,0.81000000f,-0.95000000f,-0.21000000f,0.04000000f,-0.23000000f,-0.24000000f,-0.27000000f,-0.93000000f,0.19000000f,-0.27000000f,-0.83000000f,0.19000000f,-0.21000000f,-0.08000000f,-0.19000000f,0.73000000f,0.26000000f,-0.97000000f,0.51000000f,0.92000000f,-0.53000000f,-0.18000000f,-0.54000000f,0.89000000f,-0.49000000f,-0.61000000f,-0.54000000f,-0.63000000f,-0.01000000f,-0.77000000f,0.96000000f,0.44000000f,-0.64000000f,0.63000000f,0.24000000f,-0.51000000f,0.67000000f,-0.16000000f,-0.99000000f,0.61000000f,0.73000000f,0.53000000f,0.84000000f,-0.06000000f,-0.39000000f,0.13000000f,0.40000000f,-0.26000000f,0.90000000f,0.94000000f,0.15000000f,0.71000000f,0.70000000f,-0.71000000f,-0.53000000f,0.74000000f,0.47000000f,-0.45000000f,0.45000000f,-0.24000000f,0.44000000f,0.90000000f,-0.71000000f,0.22000000f,0.32000000f,-0.61000000f,-0.78000000f,-0.66000000f,-0.44000000f,0.88000000f,-0.58000000f,0.57000000f,0.08000000f,0.57000000f,-0.61000000f,0.71000000f,-0.12000000f,0.49000000f,-0.41000000f,-0.69000000f,-0.47000000f,-0.46000000f,0.73000000f,-0.19000000f,-0.01000000f,0.44000000f,-0.41000000f,0.74000000f,0.15000000f,0.15000000f,0.10000000f,0.10000000f,0.59000000f,0.16000000f,-0.80000000f,-0.75000000f,0.79000000f,-0.22000000f,-0.75000000f,-0.05000000f,0.22000000f,-0.92000000f,-0.11000000f,-0.86000000f,0.81000000f,-0.29000000f,-0.08000000f,-0.78000000f,-0.65000000f,0.19000000f,-0.35000000f,-0.76000000f,0.91000000f,-0.55000000f,-0.39000000f,-0.23000000f,0.34000000f,-0.07000000f,-0.95000000f,0.10000000f,0.98000000f,-0.12000000f,-0.49000000f,-0.79000000f,-0.00000000f,0.57000000f,0.83000000f,0.21000000f,0.28000000f,0.33000000f,-0.87000000f,0.60000000f,-0.00000000f,-0.82000000f,-0.00000000f,0.61000000f,0.06000000f,0.45000000f,0.65000000f,0.75000000f,0.04000000f,-0.21000000f,-0.92000000f,0.25000000f,-0.11000000f,-0.52000000f,0.79000000f,0.19000000f,0.48000000f,-0.79000000f,-0.26000000f,0.47000000f,0.05000000f,0.98000000f,0.89000000f,-0.58000000f,-0.03000000f,0.22000000f,0.20000000f,0.17000000f,-0.96000000f,0.13000000f,0.92000000f,-0.31000000f,-0.81000000f,-0.30000000f,-0.60000000f,0.30000000f,0.78000000f,0.86000000f,-0.40000000f,0.23000000f,-0.36000000f,-0.35000000f,-0.69000000f,0.93000000f,0.94000000f,0.52000000f,0.38000000f,0.33000000f,-0.97000000f,-0.28000000f,0.80000000f,0.47000000f,-0.27000000f,0.06000000f,0.25000000f,-0.74000000f,0.57000000f,0.04000000f,-0.93000000f,0.88000000f,0.65000000f,0.68000000f,0.95000000f,-0.69000000f,0.58000000f,-0.67000000f,0.73000000f,0.85000000f,-0.35000000f,-0.10000000f,-0.38000000f,-0.57000000f,0.67000000f,0.79000000f,-0.24000000f,0.60000000f,0.89000000f,-0.85000000f,0.20000000f,0.11000000f,0.14000000f,-0.02000000f,0.53000000f,-0.56000000f,0.39000000f,-0.27000000f,0.43000000f,0.43000000f,-0.41000000f,-0.25000000f,0.00000000f,-0.13000000f,0.26000000f,0.08000000f,0.39000000f,0.07000000f,0.04000000f,0.70000000f,0.49000000f,-0.28000000f,0.19000000f,-0.48000000f,0.29000000f,0.52000000f,-0.99000000f,0.40000000f,0.04000000f,0.47000000f,0.54000000f,0.32000000f,0.48000000f,0.66000000f,0.51000000f,0.29000000f,-0.58000000f,-0.93000000f,0.03000000f,-0.23000000f,0.62000000f,-0.33000000f,-0.51000000f,-0.63000000f,0.22000000f,0.47000000f,0.26000000f,-0.04000000f,-0.50000000f,0.25000000f,-0.61000000f,0.92000000f,-0.52000000f,0.97000000f,-0.12000000f,0.98000000f,-0.12000000f,0.20000000f,-0.04000000f,-0.78000000f,-0.69000000f,-0.06000000f,-0.55000000f,0.38000000f,-0.19000000f,-0.35000000f,0.84000000f,0.46000000f,0.68000000f,0.17000000f,0.27000000f,0.32000000f,0.79000000f,0.37000000f,-0.16000000f,-0.39000000f,0.55000000f,-0.49000000f,-0.70000000f,-0.67000000f,-0.53000000f,0.80000000f,0.35000000f,-0.96000000f,-0.06000000f,0.63000000f,-0.50000000f,-0.16000000f,0.35000000f,0.39000000f,0.51000000f,0.65000000f,-0.12000000f,0.24000000f,-0.88000000f,0.08000000f,0.56000000f,0.92000000f,-0.77000000f,0.93000000f,0.79000000f,-0.06000000f,-0.82000000f,0.00000000f,-0.67000000f,0.49000000f,0.83000000f,0.35000000f,-0.47000000f,-0.67000000f,-0.94000000f,-0.23000000f,0.71000000f,-0.06000000f,-0.06000000f,0.98000000f,-0.94000000f,-0.79000000f,0.03000000f,-0.43000000f,-0.64000000f,-0.27000000f,-0.32000000f,-0.78000000f,0.40000000f,-0.39000000f,0.96000000f,0.81000000f,0.36000000f,-0.64000000f,0.41000000f,0.97000000f,-0.08000000f,0.01000000f,0.31000000f,-0.08000000f,-0.85000000f,-0.09000000f,-0.40000000f,-0.91000000f,-0.11000000f,-0.29000000f,0.79000000f,-0.40000000f,-0.20000000f,-0.92000000f,0.72000000f,-0.25000000f,0.40000000f,-0.20000000f,0.47000000f,-0.52000000f,0.86000000f,0.68000000f,-0.68000000f,0.15000000f,0.99000000f,0.30000000f,-0.99000000f,-0.51000000f,0.44000000f,-0.96000000f,-0.71000000f,0.83000000f,-0.37000000f,-0.12000000f,-0.58000000f,-0.11000000f,0.60000000f,-0.96000000f,-0.35000000f,-0.13000000f,0.52000000f,0.99000000f,-0.94000000f,-0.49000000f,-0.88000000f,-0.50000000f,0.11000000f,-0.79000000f,-0.04000000f,-0.03000000f,-0.60000000f,-0.16000000f,-0.93000000f,-0.85000000f,-0.73000000f,-0.47000000f,-0.22000000f,-0.27000000f,-0.52000000f,0.19000000f,-0.39000000f,0.96000000f,-0.23000000f,0.72000000f,-0.19000000f,-0.71000000f,0.00000000f,-0.78000000f,0.55000000f,0.90000000f,0.47000000f,-0.33000000f,-0.02000000f,0.04000000f,-0.66000000f,-0.34000000f,-0.32000000f,-0.34000000f,0.34000000f,-0.93000000f,0.38000000f,-0.43000000f,0.70000000f,0.90000000f,-0.76000000f,-0.16000000f,0.54000000f,-0.30000000f,0.57000000f,0.20000000f,-0.68000000f,0.62000000f,0.03000000f,0.58000000f,0.41000000f,-0.59000000f,0.54000000f,0.96000000f,-0.04000000f,-0.84000000f,-0.34000000f,-0.76000000f,0.89000000f,-0.86000000f,-0.84000000f,-0.22000000f,-0.61000000f,-0.64000000f,-0.25000000f,0.07000000f,-0.37000000f,-0.85000000f,-0.41000000f,0.59000000f,0.11000000f,-0.97000000f,0.68000000f,0.28000000f,-0.42000000f,-0.19000000f,0.79000000f,-0.46000000f,0.42000000f,0.83000000f,0.97000000f,-0.18000000f,0.16000000f,-0.04000000f,-0.22000000f,0.04000000f,0.14000000f,0.96000000f,0.61000000f,0.72000000f,-0.71000000f,0.23000000f,-0.85000000f,0.06000000f,0.20000000f,-0.72000000f,0.31000000f,0.84000000f,-0.57000000f,-0.23000000f,-0.31000000f,0.17000000f,0.39000000f,0.56000000f,0.31000000f,0.46000000f,-0.15000000f,-0.11000000f,-0.86000000f,0.51000000f,-0.43000000f,-0.63000000f,0.65000000f,0.51000000f,-0.54000000f,-0.58000000f,0.13000000f,0.55000000f,-0.77000000f,-0.64000000f,-0.81000000f,0.18000000f,-0.08000000f,0.21000000f,-0.13000000f,0.18000000f,0.64000000f,0.55000000f,-0.73000000f,-0.35000000f,0.39000000f,-0.79000000f,0.68000000f,0.52000000f,-0.68000000f,0.69000000f,0.42000000f,-0.64000000f,-0.98000000f,0.76000000f,-0.56000000f,0.76000000f,-0.06000000f,-0.64000000f,-0.99000000f,-0.16000000f,0.19000000f,0.90000000f,-0.31000000f,-0.98000000f,-0.71000000f,-0.36000000f,-0.19000000f,-0.03000000f,0.98000000f,-0.34000000f,-0.50000000f,0.91000000f,-0.38000000f,0.20000000f,-0.13000000f,0.62000000f,-0.09000000f,0.66000000f,-0.69000000f,0.25000000f,-0.81000000f,-0.20000000f,-0.16000000f,-0.23000000f,0.26000000f,0.69000000f,0.05000000f,-0.88000000f,-0.71000000f,-0.02000000f,0.96000000f,0.56000000f,0.48000000f,-0.50000000f,-0.68000000f,-0.83000000f,-0.17000000f,0.38000000f,0.48000000f,0.04000000f,-0.05000000f,-0.47000000f,0.46000000f,0.85000000f,0.13000000f,0.08000000f,0.39000000f,0.89000000f,-0.36000000f,0.05000000f,-0.60000000f,-0.95000000f,-0.95000000f,0.08000000f,0.76000000f,0.82000000f,-0.62000000f,0.32000000f,-0.09000000f,0.55000000f,-0.26000000f,0.08000000f,-0.88000000f,-0.93000000f,-0.96000000f,0.26000000f,0.08000000f,0.98000000f,0.40000000f,0.34000000f,-0.34000000f,-0.38000000f,0.35000000f,0.68000000f,0.28000000f,-0.58000000f,0.66000000f,0.30000000f,-0.66000000f,-0.25000000f,0.42000000f,0.05000000f,-0.19000000f,0.33000000f,0.47000000f,0.39000000f,-0.03000000f,0.63000000f,0.09000000f,0.65000000f,0.83000000f,-0.67000000f,-0.86000000f,0.72000000f,-0.20000000f,0.35000000f,-0.88000000f,-0.37000000f,-0.52000000f,-0.29000000f,-0.83000000f,-0.02000000f,-0.08000000f,0.25000000f,-0.75000000f,0.42000000f,-0.23000000f,-0.37000000f,0.48000000f,-0.75000000f,-0.11000000f,0.87000000f,0.87000000f,0.03000000f,0.33000000f,-0.26000000f,-0.43000000f,0.65000000f,0.45000000f,0.77000000f,0.99000000f,-0.52000000f,0.97000000f,-0.72000000f,0.74000000f,0.38000000f,0.86000000f,-0.26000000f,0.81000000f,0.94000000f,0.28000000f,0.16000000f,-0.69000000f,-0.50000000f,-0.78000000f,-0.40000000f,0.11000000f,-0.10000000f,0.89000000f,0.88000000f,0.57000000f,-0.75000000f,-0.55000000f,-0.49000000f,0.06000000f,0.18000000f,-0.56000000f,0.18000000f,0.92000000f,-0.63000000f,0.94000000f,0.01000000f,0.39000000f,0.46000000f,0.44000000f,0.90000000f,0.16000000f,0.77000000f,-0.58000000f,-0.69000000f,0.88000000f,0.12000000f,0.10000000f,0.27000000f,-0.89000000f,-0.94000000f,-0.64000000f,0.55000000f,-0.87000000f,-0.70000000f,-0.47000000f,0.93000000f,0.73000000f,-0.87000000f,-0.20000000f,-0.21000000f,0.61000000f,-0.98000000f,-0.67000000f,-0.45000000f,0.82000000f,0.77000000f,-0.38000000f,-0.29000000f,-0.61000000f,-0.78000000f,0.93000000f,-0.74000000f,-0.48000000f,0.51000000f,0.03000000f,0.73000000f,-0.53000000f,-0.55000000f,0.99000000f,0.08000000f,0.99000000f,0.88000000f,0.57000000f,0.04000000f,-0.98000000f,0.12000000f,-0.39000000f,0.47000000f,-0.54000000f,-0.65000000f,-0.29000000f,-0.51000000f,-0.92000000f,-0.23000000f,0.73000000f,-0.76000000f,0.50000000f,0.11000000f,0.38000000f,-0.44000000f,0.04000000f,-0.40000000f,-0.27000000f,-0.95000000f,-0.83000000f,0.77000000f,-0.20000000f,-0.27000000f,-0.36000000f,0.59000000f,0.65000000f,-0.69000000f,-0.53000000f,-0.86000000f,-0.55000000f,-0.68000000f,0.80000000f,0.55000000f,0.69000000f,-0.41000000f,-0.49000000f,0.95000000f,0.99000000f,0.01000000f,-0.17000000f,-0.72000000f,-0.70000000f,-0.05000000f,-0.56000000f,0.92000000f,-0.37000000f,0.00000000f,-0.38000000f,-0.18000000f,-0.63000000f,-0.46000000f,-0.45000000f,0.82000000f,0.54000000f,0.31000000f,0.41000000f,-0.00000000f,0.08000000f,-0.91000000f,0.16000000f,0.35000000f,-0.62000000f,-0.36000000f,0.22000000f,0.26000000f,-0.31000000f,-0.91000000f,0.48000000f,0.41000000f,0.87000000f,-0.34000000f,0.69000000f,0.24000000f,-0.83000000f,0.90000000f,0.76000000f,0.17000000f,0.11000000f,0.85000000f,0.03000000f,-0.66000000f,-0.29000000f,0.58000000f,0.31000000f,-0.87000000f,-0.90000000f,-0.48000000f,0.21000000f,-0.34000000f,-0.87000000f,0.60000000f,0.91000000f,-0.85000000f,-0.59000000f,0.20000000f,0.64000000f,-0.55000000f,-0.20000000f,0.77000000f,-0.70000000f,0.36000000f,0.44000000f,-0.66000000f,-0.12000000f,-0.56000000f,-0.47000000f,0.37000000f,-0.45000000f,0.43000000f,0.93000000f,0.76000000f,0.03000000f,-0.42000000f,-0.12000000f,0.91000000f,-0.25000000f,-0.93000000f,-0.71000000f,0.00000000f,0.32000000f,0.41000000f,-0.72000000f,0.38000000f,-0.29000000f,-0.83000000f,0.71000000f,-0.73000000f,-0.68000000f,0.81000000f,0.83000000f,0.08000000f,0.74000000f,-0.37000000f,-0.17000000f,0.01000000f,-0.97000000f,-0.35000000f,-0.79000000f,0.80000000f,-0.27000000f,0.28000000f,-0.50000000f,-0.55000000f,0.70000000f,0.36000000f,0.68000000f,-0.25000000f,-0.08000000f,0.84000000f,-0.28000000f,-0.92000000f,0.54000000f,-0.50000000f,0.82000000f,0.23000000f,-0.01000000f,0.09000000f,0.61000000f,0.42000000f,-0.48000000f,0.01000000f,0.56000000f,0.96000000f,0.28000000f,0.67000000f,-0.48000000f,-0.98000000f,-0.56000000f,-0.05000000f,-0.55000000f,0.91000000f,0.77000000f,-0.98000000f,0.55000000f,0.89000000f,0.56000000f,0.58000000f,0.42000000f,0.87000000f,0.40000000f,0.28000000f,-0.51000000f,0.74000000f,0.99000000f,0.77000000f,0.55000000f,0.48000000f,0.58000000f,-0.28000000f,-0.16000000f,0.69000000f,0.19000000f,-0.15000000f,-0.67000000f,-0.89000000f,-0.63000000f,-0.49000000f,0.69000000f,0.14000000f,0.41000000f,0.37000000f,0.96000000f,0.11000000f,-0.89000000f,-0.19000000f,0.83000000f,0.67000000f,-0.51000000f,0.17000000f,-0.79000000f,0.53000000f,-0.27000000f,-0.41000000f,-0.93000000f,-0.01000000f,0.31000000f,0.17000000f,0.20000000f,0.79000000f,0.84000000f,0.90000000f,-0.02000000f,0.59000000f,-0.77000000f,-0.47000000f,0.59000000f,-0.99000000f,-0.88000000f,0.78000000f,0.43000000f,0.90000000f,0.08000000f,0.71000000f,-0.12000000f,0.91000000f,-0.82000000f,-0.86000000f,-0.61000000f,0.28000000f,0.35000000f,0.60000000f,0.55000000f,-0.60000000f,-0.67000000f,0.67000000f,0.99000000f,-0.30000000f,0.24000000f,0.47000000f,-0.17000000f,-0.82000000f,-0.22000000f,0.40000000f,0.01000000f,-0.75000000f,0.45000000f,0.38000000f,0.70000000f,-0.44000000f,0.96000000f,0.72000000f,0.12000000f,-0.58000000f,0.96000000f,-0.41000000f,-0.56000000f,-0.49000000f,-0.95000000f,-0.36000000f,0.62000000f,-0.10000000f,-0.65000000f,-0.51000000f,-0.13000000f,-0.44000000f,0.21000000f,0.75000000f,-0.82000000f,0.75000000f,-0.76000000f,0.20000000f,-0.63000000f,-0.95000000f,-0.10000000f,-0.30000000f,0.85000000f,0.59000000f,-0.76000000f,-0.36000000f,0.75000000f,-0.05000000f,-0.47000000f,-0.67000000f,-0.84000000f,-0.24000000f,-0.22000000f,0.24000000f,0.88000000f,-0.33000000f,-0.60000000f,-0.81000000f,-0.22000000f,-0.55000000f,-0.10000000f,0.84000000f,-0.52000000f,0.31000000f,0.31000000f,0.73000000f,-0.47000000f,0.08000000f,-0.78000000f,0.59000000f,0.27000000f,0.06000000f,0.74000000f,-0.58000000f,0.48000000f,-0.74000000f,-0.60000000f,-0.57000000f,0.16000000f,-0.91000000f,0.48000000f,-0.08000000f,0.42000000f,0.56000000f,-0.31000000f,-0.42000000f,-0.33000000f,0.88000000f,0.84000000f,0.72000000f,0.92000000f,0.36000000f,0.95000000f,-0.40000000f,0.77000000f,0.12000000f,-0.63000000f,-0.67000000f,-0.02000000f,-0.65000000f,0.53000000f,-0.98000000f,0.23000000f,-0.92000000f,-0.88000000f,-0.64000000f,0.84000000f,0.44000000f,-0.08000000f,-0.62000000f,-0.85000000f,-0.16000000f,0.61000000f,-0.11000000f,0.23000000f,0.01000000f,-0.37000000f,-0.36000000f,0.42000000f,-0.73000000f,0.43000000f,0.96000000f,-0.67000000f,0.41000000f,0.94000000f,-0.27000000f,0.04000000f,-0.46000000f,0.26000000f,0.01000000f,0.75000000f,-0.10000000f,-0.41000000f,-0.28000000f,0.57000000f,-0.55000000f,0.18000000f,-0.36000000f,-0.96000000f,-0.15000000f,-0.04000000f,0.80000000f,0.09000000f,-0.84000000f,0.06000000f,-0.63000000f,0.82000000f,0.47000000f,-0.17000000f,0.01000000f,-0.81000000f,0.44000000f,0.19000000f,-0.26000000f,0.88000000f,0.57000000f,-0.14000000f,-0.00000000f,0.34000000f,0.44000000f,-0.20000000f,-0.58000000f,-0.32000000f,0.17000000f,-0.98000000f,-0.29000000f,-0.08000000f,-0.53000000f,0.89000000f,-0.96000000f,-0.43000000f,0.87000000f,0.90000000f,0.25000000f,-0.00000000f,0.55000000f,0.73000000f,-0.28000000f,0.63000000f,-0.73000000f,0.61000000f,0.14000000f,0.51000000f,-0.15000000f,0.90000000f,0.15000000f,-0.24000000f,0.48000000f,-0.74000000f,0.54000000f,0.75000000f,-0.59000000f,-0.22000000f,0.54000000f,-0.99000000f,0.29000000f,0.47000000f,0.87000000f,-0.05000000f,0.65000000f,0.46000000f,0.76000000f,-0.89000000f,0.63000000f,0.65000000f,-0.28000000f,-0.63000000f,0.54000000f,0.37000000f,0.03000000f,0.05000000f,-0.16000000f,-0.38000000f,0.60000000f,0.70000000f,-0.74000000f,0.86000000f,-0.41000000f,0.22000000f,-0.45000000f,0.75000000f,-0.30000000f,0.32000000f,-0.03000000f,0.42000000f,0.48000000f,0.01000000f,-0.79000000f,-0.87000000f,-0.76000000f,-0.51000000f,-0.02000000f,0.00000000f,0.40000000f,0.35000000f,0.78000000f,-0.89000000f,-0.66000000f,-0.15000000f,-0.41000000f,-0.28000000f,0.41000000f,0.37000000f,0.47000000f,-0.56000000f,0.27000000f,0.58000000f,-0.44000000f,0.73000000f,-0.55000000f,-0.54000000f,0.87000000f,-0.67000000f,-0.62000000f,-0.95000000f,0.52000000f,-0.20000000f,0.81000000f,-0.34000000f,-0.48000000f,0.49000000f,-0.23000000f,0.62000000f,0.74000000f,-0.60000000f,-0.39000000f,-0.60000000f,0.34000000f,-0.81000000f,0.17000000f,0.63000000f,0.37000000f,0.11000000f,-0.74000000f,0.60000000f,-0.47000000f,-0.96000000f,-0.42000000f,-0.54000000f,0.20000000f,0.85000000f,0.13000000f,0.83000000f,0.17000000f,-0.56000000f,-0.25000000f,0.69000000f,-0.11000000f,0.11000000f,0.09000000f,-0.83000000f,-0.02000000f,-0.44000000f,-0.50000000f,-0.00000000f,-0.35000000f,0.25000000f,-0.41000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.19930001f,-0.95679997f,0.33320001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.22530002f,-1.46970000f,-0.40580000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.43200003f,-1.15859995f,1.75729998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.24609996f,-1.01540000f,0.52740000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.88760002f,0.44020005f,-1.05200002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.10139998f,-0.72790005f,2.23990002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.25830007f,-0.61610000f,1.11350003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.10279999f,-0.46310000f,1.03859998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.42969998f,-0.17410002f,0.11460005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.27410003f,0.61489999f,-0.81110000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.29990001f,-0.15209997f,0.52780001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.32169999f,-0.88870008f,-0.30750002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.03289998f,1.09890007f,1.35340002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.40490006f,0.50740003f,-0.94680001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.12100002f,-0.64790003f,0.36290000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.78319998f,-0.06859998f,0.23090000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.80570001f,0.11130003f,-0.10880002f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.48089999f,2.30689995f,1.00370007f,0.0f,0.0f,0.0f,0.0f,0.0f,0.34580003f,0.33169996f,-0.99849997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.36840000f,0.58380002f,-1.43739999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.16060001f,-0.33479999f,-0.53609998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.00730001f,-1.47100000f,0.21660003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.26529999f,-0.45649997f,0.43830003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35760000f,-0.37230001f,-1.48370001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.66729998f,-1.47939989f,0.28320000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.81929999f,-0.42440006f,-1.71390003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.50639991f,0.98440005f,-0.94360003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.45260000f,-0.91130000f,-0.73750003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.07960000f,-0.03149998f,0.00090003f,0.0f,0.0f,0.0f,0.0f,0.0f,2.10739999f,-0.97680000f,-0.51250004f,0.0f,0.0f,0.0f,0.0f,0.0f,2.18370002f,1.48719992f,-0.33309997f,0.0f,0.0f,0.0f,0.0f,0.0f,2.78879995f,-1.68319995f,0.42569996f,0.0f,0.0f,0.0f,0.0f,0.0f,2.08069993f,0.66469996f,-0.14649998f,0.0f,0.0f,0.0f,0.0f,0.0f,2.04770001f,0.12399999f,-1.46440001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.47570004f,-0.40380000f,1.65120006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.48160004f,-0.50199998f,0.82100002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.41349997f,-0.08200004f,-1.80490000f,0.0f,0.0f,0.0f,0.0f,0.0f,3.37800005f,-2.45599994f,1.42579995f,0.0f,0.0f,0.0f,0.0f,0.0f,-4.70130010f,0.66229992f,-2.16639994f,0.0f,0.0f,0.0f,0.0f,0.0f,1.80109999f,-1.21519995f,2.48679999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.93079994f,-1.82110003f,0.14899999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.78320007f,1.28539999f,0.33779995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.36520004f,-0.20030002f,1.51110000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.78920001f,0.93280002f,0.70290002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.52530005f,2.66319989f,-0.95100001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.78679998f,-0.25840007f,-2.38219992f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.99000003f,-1.26889994f,-0.90299993f,0.0f,0.0f,0.0f,0.0f,0.0f,0.55320004f,1.39710002f,0.89810009f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.41029998f,-1.47420000f,1.00469998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.44180004f,-1.22630001f,-1.53230006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.16079994f,-1.30210000f,0.31630004f,0.0f,0.0f,0.0f,0.0f,0.0f,2.23890001f,1.64349999f,0.84669993f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.70129997f,-0.25649980f,0.30950010f,0.0f,0.0f,0.0f,0.0f,0.0f,0.24489998f,0.41340006f,-1.39920000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.62650010f,2.04920004f,3.45630004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.43250005f,-0.53879997f,-0.84849998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.34030007f,-0.81310006f,0.33469995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.47190003f,-0.67300002f,-0.91479995f,0.0f,0.0f,0.0f,0.0f,0.0f,1.21170001f,-2.65779998f,-0.23740001f,0.0f,0.0f,0.0f,0.0f,0.0f,2.47679992f,0.25910015f,2.17350007f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59419999f,3.46639999f,1.05320003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.40690002f,-0.20940000f,-0.27620000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.93600004f,-0.50480003f,-0.51049999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.01849997f,-1.87399994f,0.54749999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.10920001f,1.22919996f,-0.56409998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.12139990f,0.17039992f,2.48229994f,0.0f,0.0f,0.0f,0.0f,0.0f,2.32949991f,-2.14240011f,0.34330004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.85100000f,1.69769990f,-0.12719999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.59129998f,0.81009996f,0.59019999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.67929999f,0.26310000f,0.74360001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.55820001f,0.82830001f,1.17110000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.31560004f,0.90380003f,-0.04990002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.56029996f,-0.34350005f,-3.71630002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.52699998f,-0.83560000f,-1.77969991f,0.0f,0.0f,0.0f,0.0f,0.0f,0.09589999f,-1.44870015f,1.08439998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.71069996f,-1.37339997f,1.76370004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.40420000f,-0.21620001f,-1.08400003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.94789997f,-1.51250002f,1.56190007f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.06499996f,0.71749996f,0.68310001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.33500000f,-3.02289998f,0.64839999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.90030008f,-0.59090000f,-5.80310015f,0.0f,0.0f,0.0f,0.0f,0.0f,1.78499996f,-0.75100006f,0.13209998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.34849991f,-0.45190001f,0.06949996f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.45830002f,1.43059998f,0.93719999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.32710001f,1.08530008f,-0.50180001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.91990003f,-0.81880001f,1.08590001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.32680003f,1.68199998f,0.86600000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.51479997f,2.68550000f,-1.94329997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.85129995f,-0.21840004f,1.70040001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.38859998f,0.53920003f,-0.40180000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.19790002f,0.99150001f,-1.34320001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.39930003f,-0.86099999f,0.38419996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.36799998f,-0.55639997f,1.28019997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.84919995f,0.21019997f,1.24209997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.15140002f,-0.34040002f,0.60490002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.77330003f,1.67890004f,2.03889997f,0.0f,0.0f,0.0f,0.0f,0.0f,1.15540000f,-0.95950000f,-0.57409999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.46390001f,-0.77190002f,0.49959998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.81130005f,-1.21140000f,0.05000001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.87060002f,-0.69830001f,0.11980003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.66829996f,0.19560000f,-1.03219995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.99549998f,-1.62900001f,-0.62360002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.02679997f,1.26550005f,-0.63680004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.18299999f,0.15080003f,2.44289994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.58269998f,-0.46750003f,-0.10940006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.11050001f,0.09059998f,0.12370001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.06629999f,0.42820001f,0.75890001f,0.0f,0.0f,0.0f,0.0f,0.0f,2.59710003f,0.21690001f,-1.01259998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.36879995f,2.27380000f,-1.24020002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.08119999f,1.26170002f,1.17180001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.52960007f,-1.33630006f,1.75169998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.63650001f,0.74819998f,1.05920003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.88749999f,1.32820006f,1.86610000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.19180004f,0.80840002f,-1.71349999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.16000002f,-0.71419998f,-1.45450001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.45479988f,2.56350003f,0.96519993f,0.0f,0.0f,0.0f,0.0f,0.0f,-4.95229990f,0.55509998f,-1.83129997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.19530002f,1.51240003f,-0.09249997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.70680000f,0.72909995f,-0.72360003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.96720003f,0.08640000f,-1.12730005f,0.0f,0.0f,0.0f,0.0f,0.0f,2.64079998f,-0.79069998f,1.40370002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.26240002f,-0.30840003f,-1.72340001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.58610008f,0.11500008f,-1.39609992f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.48679998f,-1.31019994f,-0.03340000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.40970001f,-1.49060000f,-1.54299998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.44720000f,-1.51280001f,0.96049999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.66429997f,1.08940004f,1.89200002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.83750004f,-1.01639997f,0.79380002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.00870002f,0.50639998f,0.25300007f,0.0f,0.0f,0.0f,0.0f,0.0f,1.60290005f,-1.87759995f,3.04929998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.87799999f,-1.62760005f,0.01629992f,0.0f,0.0f,0.0f,0.0f,0.0f,0.35609995f,0.71909994f,-2.07400002f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.58749997f,0.75750002f,-0.47670000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.63720003f,-0.68199998f,1.53340006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.96500001f,0.70160000f,-1.65749997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.50600008f,0.13069996f,-1.35089997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.38400003f,0.05639990f,0.56659994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.01219995f,2.11489995f,-1.26210004f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.26720002f,-0.12049996f,-0.55159996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.69130003f,0.72039997f,-0.59120002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.54749997f,-1.68329999f,0.24389997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.45260000f,0.67420000f,-1.51189999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.10709998f,2.40309998f,-1.35390014f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.42889998f,1.72779996f,-3.83109985f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.03929996f,-0.28889999f,-2.08000004f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.18749999f,0.35209997f,-1.08000000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.83190004f,0.66770001f,0.03420000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.26919999f,-0.76080002f,0.48230004f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.67880006f,1.60680004f,0.09769996f,0.0f,0.0f,0.0f,0.0f,0.0f,3.14600000f,-2.85139992f,0.25859994f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.28659992f,2.30700003f,1.93149991f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.09549994f,2.27699998f,0.65749995f,0.0f,0.0f,0.0f,0.0f,0.0f,2.28610002f,-1.44779997f,-2.91499998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.11619996f,-1.65910003f,-0.80300001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.20170002f,-1.45709999f,1.82360002f,0.0f,0.0f,0.0f,0.0f,0.0f,2.22290002f,-0.09789999f,-0.44740000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.77410004f,-1.19990003f,0.79520004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.68240004f,0.57750005f,1.16659999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.53150000f,-0.63919999f,0.98210008f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.71439999f,0.78409996f,0.65779996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.84789998f,0.42959998f,0.12810002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.38039999f,-0.42889997f,1.13239999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.48890007f,-1.08200000f,1.43400000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.05960010f,0.10050001f,-0.30020002f,0.0f,0.0f,0.0f,0.0f,0.0f,4.60259996f,1.70000005f,1.05840003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.91229998f,-2.40819999f,-0.17840007f,0.0f,0.0f,0.0f,0.0f,0.0f,0.80239999f,1.56170001f,0.13289993f,0.0f,0.0f,0.0f,0.0f,0.0f,1.81920000f,-0.60709997f,0.42169998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.21190000f,1.27480005f,-0.74830004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.88379995f,1.45739998f,-0.38919997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.42490001f,-2.26800001f,-3.17850000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.19359998f,-0.02729998f,1.48579998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.01500002f,-1.11030000f,-2.76450004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.55550005f,-1.80849999f,-1.21660002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.21430003f,0.84380002f,0.44750002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.84660005f,-0.22360000f,-0.57890001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.64269999f,-0.60829996f,-1.34190001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.63860000f,1.28599998f,-0.51740001f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.62780001f,0.47899992f,3.03439997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.60800001f,-1.31229994f,-0.16770002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.22959994f,0.09439995f,1.47679995f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.45250002f,1.15859999f,-1.22789996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.44760003f,1.19150002f,0.92390000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.12630000f,-0.75730006f,0.80650002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.38330005f,2.75039993f,-0.97499994f,0.0f,0.0f,0.0f,0.0f,0.0f,1.30750011f,1.34160005f,1.73990006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.34740001f,-0.57090011f,2.81700002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.66959998f,1.15059999f,-0.84180004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.19429999f,-0.23839999f,-0.55549990f,0.0f,0.0f,0.0f,0.0f,0.0f,0.73550003f,1.98860004f,0.91889998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.51889999f,0.35830000f,-1.12650002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.09280003f,-1.52560000f,-0.02739996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.20890000f,-0.24999998f,1.85860015f,0.0f,0.0f,0.0f,0.0f,0.0f,0.42300003f,-0.41319998f,-0.81709999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.88790001f,2.39460006f,0.50310005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.29489999f,-1.25340002f,0.94780004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.91480002f,-2.23450002f,0.31210010f,0.0f,0.0f,0.0f,0.0f,0.0f,0.29160000f,0.20390003f,0.04490001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.42370005f,-0.86509996f,0.50489994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.25179993f,-3.56699992f,2.65849999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.93149993f,-3.05509997f,2.92219998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.45100001f,-0.30080003f,-5.05560005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.82099996f,-1.27479997f,0.18040000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.03640001f,1.14550002f,-0.94210006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.87040002f,0.13790000f,2.01420006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.04459992f,0.25969992f,2.82270000f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.93429997f,1.54210006f,-2.48889997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.91810000f,-3.16899997f,1.53590008f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.94549996f,-2.83130000f,-0.55789997f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.25569996f,1.12170000f,0.49549998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.02679996f,1.60490006f,-1.47759993f,0.0f,0.0f,0.0f,0.0f,0.0f,0.63490002f,1.29809996f,1.55720003f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.06509994f,-1.14250006f,-1.05580005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.91460007f,-0.93799997f,-1.90529996f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.67720003f,0.45640005f,-3.00059991f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.93609992f,-0.83610005f,2.03100001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.51249998f,-0.13800002f,-0.49720002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.55609999f,0.51480002f,-1.21829995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.96260003f,0.90140002f,-0.07329997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05149991f,-0.76279999f,0.17039998f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.92330003f,-1.94650002f,-3.74509998f,0.0f,0.0f,0.0f,0.0f,0.0f,2.23720000f,1.29830001f,1.05840003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.86170000f,0.43259999f,0.42739993f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.04460001f,-0.35950000f,-0.28439999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.20520000f,-0.32230006f,0.02799996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.68019998f,-0.27350000f,0.32029999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.24850001f,-0.43459998f,-1.10929994f,0.0f,0.0f,0.0f,0.0f,0.0f,3.41829998f,0.59630006f,0.88909993f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.08699996f,0.32910002f,1.27610000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.19260006f,-0.59819990f,0.13299995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.19940001f,0.43650000f,-0.26340002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.68220000f,0.63949999f,-0.13929995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.81719993f,-2.42419996f,-0.61800001f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.11690002f,4.18299998f,1.58010006f,0.0f,0.0f,0.0f,0.0f,0.0f,-4.12250003f,-1.73719998f,-0.30180002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.45040007f,-1.42740001f,-1.49379999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.68310007f,-1.23270001f,1.43420004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.15410000f,0.48080000f,0.19479999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.39060000f,0.11189996f,0.18260000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.24749994f,-2.01130000f,-0.73670001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05780004f,0.65230007f,2.49019994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.05930005f,-3.36819997f,-2.02669993f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.25149989f,-2.92289999f,1.27479998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.37620012f,-0.55949994f,-3.03630000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.70460010f,-0.61650000f,-1.20459999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.06799997f,-0.37059999f,1.22319996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.01000002f,1.64859998f,-0.19419996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.52469993f,0.16309998f,2.23119993f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.43340002f,-0.11440006f,-0.94619977f,0.0f,0.0f,0.0f,0.0f,0.0f,0.61440008f,-0.15880002f,1.19940003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.48540000f,1.09040002f,-1.56879993f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.25480004f,1.88139999f,-1.23150001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.38600002f,1.08280004f,0.03669997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.09640003f,1.15500001f,0.92899999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.38889995f,-1.22800001f,-0.83369999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.41689999f,-0.35500008f,1.20320005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.16679998f,-0.54510007f,-2.59660003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.69580000f,-0.78590000f,-0.00940005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.92760005f,0.44880001f,0.16209998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.07930001f,-0.58420001f,-0.65860000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.82129998f,-0.76430000f,0.13769997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.88060004f,0.08700002f,0.10679995f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.08590006f,-0.93250006f,2.39210006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.04819998f,0.54349995f,-0.46780003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.10249994f,0.17300001f,0.01140004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.37990003f,1.21610000f,-1.51970003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.75140003f,-0.20999999f,0.58350004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.30770003f,-0.87140003f,-0.28099998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.57380002f,0.50069995f,-0.95320000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.49339995f,0.39239999f,0.70750007f,0.0f,0.0f,0.0f,0.0f,0.0f,1.24260005f,-1.40220002f,1.78780002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.30170000f,0.54880003f,-0.78009998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.66940000f,0.19739999f,0.13409998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.42170003f,1.31190001f,1.00330001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.40990001f,0.28400000f,-0.42840003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.46490002f,-0.22250001f,-0.40160004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.01950001f,0.55290010f,1.24060003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.53950001f,0.48449995f,-1.04630001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31370008f,0.66430004f,-0.20059997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.64689998f,-1.64390005f,0.97200001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.21950001f,1.59690004f,0.22959998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.02220005f,0.17240000f,-0.67300003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.85849997f,-2.36669997f,-0.91489999f,0.0f,0.0f,0.0f,0.0f,0.0f,3.44080000f,-0.95800000f,1.70130002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.93980005f,0.97319989f,2.03789997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.86680006f,-2.50210004f,-2.36959999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.28790005f,-1.13859998f,-1.57390000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.15200004f,1.70100002f,-1.91570002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.12119999f,-1.43799993f,2.72790002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.41990002f,-2.22180002f,-1.54249996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.75289999f,0.44889997f,-0.40740006f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.09849999f,0.66989998f,-2.47929997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.86040001f,-0.17580001f,1.61439994f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.29979999f,-0.08539999f,0.39089999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.47940005f,0.26799997f,-0.93199994f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.07500000f,-1.22139994f,0.86410003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.94319998f,-1.95939994f,3.16979998f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.25499997f,-0.89080000f,2.10479999f,0.0f,0.0f,0.0f,0.0f,0.0f,2.15819999f,1.25450005f,-2.25050003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.11860002f,0.05249999f,1.86219997f,0.0f,0.0f,0.0f,0.0f,0.0f,1.15489999f,-1.05789995f,-0.59880001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.19590004f,1.77160001f,1.41930004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05080005f,0.01470000f,-1.18820001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.47669996f,0.08190003f,-0.32730003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.64269996f,1.44640003f,-0.33590005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.78080004f,1.32440006f,-0.12610005f,0.0f,0.0f,0.0f,0.0f,0.0f,1.32329999f,0.76779998f,1.61339996f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.18930005f,-1.03830001f,-0.40160004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05220002f,1.08180001f,-0.05560004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.32680001f,1.79559999f,1.05359994f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.23449997f,0.33540007f,-2.76000004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.64899995f,-1.39000005f,1.05740000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.07460001f,0.80120000f,-3.63120002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.09079999f,-1.33899999f,3.54110004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.33720004f,1.42330000f,-0.07270002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.90459998f,0.35629995f,-0.06400001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.96120006f,-0.86070000f,2.09469995f,0.0f,0.0f,0.0f,0.0f,0.0f,1.61459995f,1.62040001f,-0.43699998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.48999995f,2.05140005f,-0.45910012f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.26720007f,-1.85680003f,-1.43839996f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.09120001f,0.27280002f,-1.18630007f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.07230000f,-0.30960001f,-1.16979995f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.02679997f,-0.36999995f,-0.15069991f,0.0f,0.0f,0.0f,0.0f,0.0f,1.09350003f,0.32079999f,-1.28999999f,0.0f,0.0f,0.0f,0.0f,0.0f,2.15180002f,1.35160000f,3.86780006f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.25469987f,1.07819995f,-0.40339992f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.51299994f,0.06610004f,-0.25599993f,0.0f,0.0f,0.0f,0.0f,0.0f,2.15289995f,-0.77729997f,-4.45079997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.36650003f,-0.07889999f,-0.68360003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.10100001f,-0.67590007f,-0.43569998f,0.0f,0.0f,0.0f,0.0f,0.0f,2.77790002f,-1.41909998f,1.83120003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.58600001f,1.83170002f,0.18500003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.68149996f,1.24329990f,-1.71329995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.30370000f,-1.20720004f,0.94519998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.21520001f,-2.07460003f,-0.96459997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.69600005f,0.59670001f,-0.43969997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.04989999f,-0.43099999f,-0.23280005f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.60319995f,1.58270001f,-0.25459999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.29389997f,0.05010005f,0.30219998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.14700004f,0.09070010f,0.82910002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.28040001f,-1.20870000f,-1.45140002f,0.0f,0.0f,0.0f,0.0f,0.0f,2.28800004f,-0.31480002f,0.44850004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.16450004f,-0.03500001f,0.98690001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.06730000f,1.27919999f,-0.28779995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.32810003f,-0.70539999f,0.95019999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.43980003f,-0.26650001f,0.07760005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.45960000f,-0.73979995f,0.59919994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.06290002f,1.43770002f,0.35790004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05689997f,0.50380004f,-0.70060001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.10960001f,-0.65120001f,1.15300002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.44790000f,-0.07759998f,-1.05440002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.16320000f,1.20720002f,-0.15560000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.18520002f,1.04419998f,-0.70370001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.69289995f,-2.96180005f,1.05229999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.84709999f,-0.16500001f,2.24020000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.40160002f,-0.55540003f,0.89510000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.34760001f,-0.42580002f,0.06509999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.77039999f,0.67140001f,-0.54149998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.28819999f,-0.28949998f,-0.28070002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.46489997f,1.28779996f,2.61989997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.70620004f,1.25870012f,-0.96710002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31750002f,-0.32600001f,0.26520002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.44850005f,3.22870001f,1.81500003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.07249999f,0.53000004f,-1.16370004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.89680004f,-1.52760002f,0.23480000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.28120000f,-0.05629996f,-0.98909999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.01930003f,0.09860011f,-1.14689998f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.40139988f,0.56640001f,1.72570005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.54360006f,0.28939991f,0.62649999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.65709996f,-0.98520001f,-0.91169998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.73139996f,-0.10879995f,0.22719999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.30929995f,0.67220006f,-0.57950001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.22560000f,1.85610005f,0.22880005f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.49649997f,2.55860000f,0.78419994f,0.0f,0.0f,0.0f,0.0f,0.0f,3.30260000f,2.92989998f,1.38429995f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.22450002f,-1.01280001f,-1.78370009f,0.0f,0.0f,0.0f,0.0f,0.0f,0.31210009f,-2.47400003f,3.24010003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.54700004f,0.15870003f,0.58860001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.32799998f,0.28749999f,-1.71620004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.03760005f,-0.20500002f,0.35070000f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.21620000f,-0.61540002f,-1.54590001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.82940000f,2.08759999f,-0.65520008f,0.0f,0.0f,0.0f,0.0f,0.0f,1.26859997f,2.85520007f,2.06969995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.93189989f,0.51080002f,0.34120006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.49350003f,-0.55730001f,0.74360001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.36230003f,-1.48669999f,-1.07910002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.40450004f,-1.23170003f,0.42089998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.39259996f,2.28609994f,-2.42719993f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.17780002f,-0.97870005f,1.28040000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.18229997f,0.40890003f,-1.79090007f,0.0f,0.0f,0.0f,0.0f,0.0f,0.37779995f,-3.90750002f,1.13999992f,0.0f,0.0f,0.0f,0.0f,0.0f,2.13930002f,-1.20080006f,0.87660005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.48119996f,0.75130005f,-0.05470005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.19300000f,2.35969998f,0.96809999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.51000000f,-1.39800003f,1.51679997f,0.0f,0.0f,0.0f,0.0f,0.0f,1.87060005f,-1.93110002f,0.82690007f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.42849998f,-0.22410002f,1.19309999f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.71300002f,0.71559994f,1.79979991f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.47140003f,-0.74979999f,0.56590002f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.05999999f,-0.88150000f,0.50420002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.89850001f,0.98750003f,-1.60149997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.81030001f,-3.98250001f,1.22269995f,0.0f,0.0f,0.0f,0.0f,0.0f,1.26010004f,2.73389996f,-1.42610006f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.04390000f,-3.07099994f,0.61019992f,0.0f,0.0f,0.0f,0.0f,0.0f,0.03889999f,1.23439997f,0.23490005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.53109995f,0.39959993f,0.36730003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.24490000f,-0.99199998f,-2.41819999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.70110003f,0.70680000f,1.92179996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.95060004f,1.90759995f,-2.26839997f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.45259995f,-0.77370012f,0.30789990f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.07650003f,-0.79720006f,1.28890002f,0.0f,0.0f,0.0f,0.0f,0.0f,2.89760008f,-0.68079993f,0.25490002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.37199999f,-0.03010000f,1.43330006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.03009996f,-0.25730003f,-1.40810000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.51700001f,2.11570001f,-1.19979999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.20549998f,1.04590006f,-0.18369998f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.28409998f,2.28490001f,5.99129993f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.99070001f,-2.54480002f,1.24030000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.30950000f,-2.54790004f,2.86500002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.23570003f,0.94290002f,-0.59200006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.38470002f,0.58049998f,-1.18800000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.42000002f,-0.08079996f,0.14750002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.21750000f,2.43640004f,-0.57490000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.41369996f,-0.80040005f,0.24799990f,0.0f,0.0f,0.0f,0.0f,0.0f,0.30449997f,1.34349999f,1.49349994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.39860003f,0.38639997f,0.05410000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.61020001f,-0.21199998f,-0.78549997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.25759997f,1.68710004f,0.38299997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.44659997f,0.20369998f,0.60510006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.40990002f,0.47629995f,0.50180001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.09430005f,0.11659997f,1.49260009f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.61810003f,-0.07740001f,-1.17570000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.34020005f,-0.12890003f,2.62439997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.04290000f,1.53690001f,-1.21630000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.31709999f,0.21670002f,0.17570001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05549999f,1.04719999f,0.14080001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.17300002f,-1.70050000f,-1.12189998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.76180003f,2.22069999f,0.32600002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.02590002f,1.05169996f,-0.48569998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.74940002f,0.11620000f,0.90300002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.46870001f,0.39570001f,-0.76240003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.36940002f,0.29070000f,0.61560004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.55909996f,0.37159999f,-0.21570000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.00149999f,0.03099998f,-1.94070005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.07380000f,-0.43960001f,1.79360003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.49259999f,1.56310001f,-0.23610000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.02250002f,-2.67789999f,-0.43630000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.02650000f,-0.99520002f,1.17730001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.60959999f,1.73870000f,-1.35999997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.62020001f,1.05680004f,-0.31910003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.32810002f,-0.13110010f,1.24170007f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.55139994f,-0.23259998f,3.31819998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.37419992f,0.10130004f,-0.25140004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.41999992f,-1.13259997f,0.03989999f,0.0f,0.0f,0.0f,0.0f,0.0f,2.48900004f,1.03249998f,-0.22729998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.61500000f,2.45550005f,-0.38270002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.88030002f,0.74089995f,0.30979998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.82700003f,-1.57480004f,-1.29800003f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.58970003f,0.30830006f,-1.91099990f,0.0f,0.0f,0.0f,0.0f,0.0f,3.52960000f,0.60420004f,1.78780001f,0.0f,0.0f,0.0f,0.0f,0.0f,2.45659995f,2.03790004f,0.88329998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.70380001f,-0.75869996f,0.62710001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.94439999f,-0.15650002f,-1.95160005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.91210001f,1.22159999f,-0.75590003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.36640012f,0.92140005f,3.21050006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.95399999f,-4.79719992f,-0.76969997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.02740004f,-0.31990004f,-0.05229995f,0.0f,0.0f,0.0f,0.0f,0.0f,1.62829997f,1.57540001f,1.05909997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.05599995f,0.71440003f,0.42450000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.33890006f,-0.43739994f,0.12720005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.24500002f,-0.54219999f,-0.09860006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.18960005f,-2.23969997f,3.74739996f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.68600006f,-0.36799995f,0.48660003f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.11239991f,0.03059996f,0.90320004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.29470003f,0.86160002f,0.02150004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.79900001f,1.52580001f,0.79889998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.18459998f,0.61860000f,-1.23180006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.11780000f,-0.51350004f,-0.15810003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.76510000f,-0.34960001f,-0.83880010f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35849997f,1.21280003f,-0.23090003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.76130004f,0.41220004f,-0.50060000f,0.0f,0.0f,0.0f,0.0f,0.0f,2.43269999f,-0.36140000f,-1.33749993f,0.0f,0.0f,0.0f,0.0f,0.0f,0.10780000f,0.64079999f,-0.05460002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.27499999f,-0.88170000f,2.03630000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.41500003f,0.61080002f,-0.01109997f,0.0f,0.0f,0.0f,0.0f,0.0f,2.60109994f,0.90810010f,0.78290003f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.40760007f,-0.14969996f,-2.46880004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.06939999f,-1.61719992f,0.98620006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.16230008f,-0.11940004f,-1.41650002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.20040001f,1.09839998f,-0.19009999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.55320001f,0.04249998f,0.62400000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.18300001f,-1.26060002f,1.59459997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.24330000f,-1.34329999f,1.77839999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.36979992f,-1.29360013f,1.60039998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.22329995f,-0.73149998f,-1.40780004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.37670000f,0.36739994f,1.19000002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.12199998f,-0.36439998f,-0.59779999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.17080004f,1.17350000f,-0.28420001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.61760002f,0.55489999f,0.38339998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.25859996f,-0.28139996f,1.61429999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.60970009f,-1.50760001f,-3.71479991f,0.0f,0.0f,0.0f,0.0f,0.0f,1.08280002f,-0.57599999f,-1.34799999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.26889994f,0.34060010f,0.88629997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.36490003f,-0.68179999f,-1.85219998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.33040003f,1.31270003f,-0.42819992f,0.0f,0.0f,0.0f,0.0f,0.0f,1.45309998f,-2.11050002f,0.12250002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.69990000f,-2.44150000f,0.85960004f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.13570000f,1.23869996f,0.09510004f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.41400000f,-1.83780006f,-0.34719996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.20500002f,0.91330001f,-0.16330007f,0.0f,0.0f,0.0f,0.0f,0.0f,0.21749996f,0.14969995f,1.13160001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.63099997f,-0.72159995f,-0.61620006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.92490001f,0.79360000f,0.31410002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.57990003f,-0.05370001f,-0.79710002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.17979996f,-1.32879995f,-0.87610001f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.02849994f,-0.08790001f,0.62120009f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05659991f,0.55380002f,-2.57149992f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.62589997f,0.50789996f,0.67530001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.66709998f,-1.48090000f,0.37140007f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.93149999f,-1.38570000f,0.58030001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.80619996f,-0.12410002f,2.33849997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.65289993f,-3.51290011f,-0.94020002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.70270004f,-0.54889999f,2.09029999f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.45650002f,0.79399996f,-1.93009995f,0.0f,0.0f,0.0f,0.0f,0.0f,1.18960000f,-1.47280000f,-1.05090010f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.61200001f,0.54309996f,0.61720000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.29669999f,-1.14549998f,0.83460003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.81300004f,-2.16419999f,0.52249994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.40619993f,1.02530003f,-1.81220001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.60779999f,-1.30010012f,0.78559996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.50079996f,0.14430003f,1.42039998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.14330004f,-0.49939997f,-0.77520002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.26880001f,-0.41369997f,0.83340003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.59259995f,-1.05979998f,-0.54100004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.97600000f,1.09589988f,-1.50490000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.11199993f,-1.83179998f,1.63100005f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.07679997f,-1.45799996f,0.90089990f,0.0f,0.0f,0.0f,0.0f,0.0f,1.91449994f,0.03419999f,-1.96879997f,0.0f,0.0f,0.0f,0.0f,0.0f,1.37569999f,0.05680007f,0.19620005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.16470003f,-0.53929994f,1.48330003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.64480003f,1.18970001f,-0.67479997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.11629993f,1.06239995f,-0.74870002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.37049998f,0.29409993f,1.01670000f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.37220004f,1.74090001f,0.78250006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.13529996f,-3.30570003f,2.98279998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.39890009f,0.83819999f,1.39620004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.16269992f,1.35319994f,-0.15449999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59699995f,-0.02649997f,0.66509990f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.36429997f,-3.03910001f,-1.29399998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.93460009f,2.10679977f,2.67719988f,0.0f,0.0f,0.0f,0.0f,0.0f,1.21780004f,0.76489995f,0.90289992f,0.0f,0.0f,0.0f,0.0f,0.0f,0.12309998f,-1.39699994f,-1.79089999f,0.0f,0.0f,0.0f,0.0f,0.0f,2.20970004f,-0.84070000f,0.51550003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.28379999f,-0.78189994f,0.36380001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.14999997f,-0.78620000f,-0.32240001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.91559991f,3.36059993f,-0.55419989f,0.0f,0.0f,0.0f,0.0f,0.0f,0.47340008f,-4.05730001f,-0.73839997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.25590013f,-0.99249999f,-2.46880013f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.74180003f,-0.29290002f,2.14959992f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31590008f,-1.00120002f,-0.78949997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.54310007f,-1.39780002f,1.57760001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.32020002f,0.28449997f,-1.23820004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.07459999f,-1.58879994f,1.86359997f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.36050005f,-2.25380003f,-3.91299997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.80699994f,0.98170001f,3.02669994f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.43600007f,-2.66239995f,-0.35000000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.24130000f,-0.30749994f,0.46769999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.63659998f,-1.09639999f,0.58080003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59369993f,-0.01210008f,1.06380002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.02010005f,0.32199998f,0.03260001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.83660009f,-1.65199992f,-0.79360002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.02439994f,-2.23109992f,0.98340001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.36560008f,-1.46229996f,-0.67689990f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.15500004f,-1.17660005f,-0.10919999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.00530005f,-2.29199994f,1.07950007f,0.0f,0.0f,0.0f,0.0f,0.0f,0.50830005f,-0.45720004f,-0.67799990f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.15590007f,-4.30949997f,-0.31489991f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.30989993f,-3.55639999f,1.16140003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.89439999f,1.21459998f,0.33610012f,0.0f,0.0f,0.0f,0.0f,0.0f,0.88609989f,-3.62979993f,1.31360003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.67650002f,-0.42600009f,1.97919997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.07660004f,-0.95439996f,1.70210000f,0.0f,0.0f,0.0f,0.0f,0.0f,3.25470002f,0.35589998f,0.22939996f,0.0f,0.0f,0.0f,0.0f,0.0f,1.24529990f,0.35829993f,2.38200000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.36179994f,0.13480010f,4.50039990f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.46799997f,0.16520007f,2.88219989f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.41009999f,-2.32329999f,3.79419996f,0.0f,0.0f,0.0f,0.0f,0.0f,1.51750000f,1.40299999f,-0.93909998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.01640001f,0.83420002f,-0.83749999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.75819999f,-1.17779997f,0.44210000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.24589998f,-0.48490003f,1.13970000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.54940010f,-0.74729999f,0.36639997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.80090004f,-1.23229999f,-0.12560001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.33630000f,0.71649999f,-1.30619998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.33009999f,-0.19609998f,0.80140004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.08039998f,0.61430005f,0.25229995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.79260005f,0.55479999f,0.88230009f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18930000f,-0.62390000f,0.58430002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.29899995f,-2.14619997f,-0.41189999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.12119994f,-0.02880001f,0.32370004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.69759989f,0.71200005f,-1.72749997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.46689997f,0.24880001f,-0.00389998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.14580000f,-0.09810002f,0.16780000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.10820000f,-0.91000004f,0.00520000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.57740001f,-0.57400001f,1.81990004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.59659996f,-2.38990001f,-0.02269997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.66990002f,-0.21419995f,1.75650002f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.25100001f,0.17280004f,-0.27960003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.23480000f,-1.61419999f,-0.95890006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.85819999f,0.42120002f,0.90180001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.20080000f,-0.70680005f,-0.00770001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.15460003f,-0.86040000f,0.42839996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31679995f,1.99300006f,-0.15310009f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.74679994f,-0.72550000f,0.30560000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.87109998f,0.62190006f,0.92590002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.97799999f,-1.19259998f,-0.82510004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.52780003f,2.34000007f,1.22390003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.43840002f,-0.20730002f,-1.33290007f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.81590001f,-2.28349992f,-0.39470003f,0.0f,0.0f,0.0f,0.0f,0.0f,4.75619990f,-0.02850007f,-1.61329993f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.21850003f,2.07400001f,-1.96959993f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.89279999f,0.06160008f,1.37949998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.40239996f,-1.70169998f,-0.41090000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.15100000f,0.03999994f,0.18410000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.89780006f,-0.59649997f,0.62109995f,0.0f,0.0f,0.0f,0.0f,0.0f,3.39539996f,-1.34120003f,-0.12129994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.45009993f,1.24469991f,-0.03330003f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.55229998f,1.75560005f,-0.10569996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.14399996f,-2.30329998f,-0.92689995f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.58700001f,0.18340004f,2.09560001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.48109999f,-0.24150000f,1.23569995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.33400004f,0.62270003f,-0.62080002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.79359996f,2.87760005f,-0.64379994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.14550005f,0.11030001f,-0.14040000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.78639991f,-2.66850000f,-0.78590004f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.70579995f,-0.22910003f,0.95160002f,0.0f,0.0f,0.0f,0.0f,0.0f,2.46819999f,0.16269995f,1.67870007f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.05440001f,0.35129994f,0.46560002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.42960004f,1.10549997f,-2.95430005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18990001f,-1.48399997f,1.40339998f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.65319998f,-1.78120008f,1.01030008f,0.0f,0.0f,0.0f,0.0f,0.0f,1.40239996f,-2.21060000f,-0.32179999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.62129997f,2.16630002f,0.18460002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.69639996f,-0.99330001f,-0.56240001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.28650002f,-2.01990005f,-2.01169996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.83489998f,-3.17179998f,-0.11760007f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.55540003f,0.95180006f,-2.60059997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.19340005f,-0.90229996f,0.57389992f,0.0f,0.0f,0.0f,0.0f,0.0f,1.05940007f,2.81129996f,-1.22330006f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.88489995f,-2.96120009f,-0.20079992f,0.0f,0.0f,0.0f,0.0f,0.0f,0.25309998f,-0.41999991f,0.40160001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.38379998f,0.43569996f,-0.62659998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.66750004f,1.52250000f,1.81789999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.11769998f,1.64259998f,-0.75489999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.92819996f,0.51539994f,-1.27669997f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.89129998f,-0.59990001f,-2.28809997f,0.0f,0.0f,0.0f,0.0f,0.0f,1.23550008f,-3.45630001f,2.60649995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.16919998f,-0.05680003f,0.83710003f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.27470004f,-0.44500006f,2.94630004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.74070003f,-0.78390003f,-0.91089995f,0.0f,0.0f,0.0f,0.0f,0.0f,2.39559995f,-2.94940001f,0.30040002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.66950005f,-4.69899993f,0.88950002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.34430006f,0.94119991f,0.40240005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.83340002f,-0.83850001f,0.67070004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.24479994f,0.26660002f,0.70050000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.52090000f,1.57280003f,2.07670002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.66480004f,-0.04459998f,1.76259999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.79810000f,-0.03620005f,2.58810008f,0.0f,0.0f,0.0f,0.0f,0.0f,2.38979996f,-1.73329996f,-3.23969999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.46299998f,-1.62020002f,0.82940000f,0.0f,0.0f,0.0f,0.0f,0.0f,2.09109987f,0.76600001f,1.45479991f,0.0f,0.0f,0.0f,0.0f,0.0f,0.28429995f,-0.36669998f,0.33680000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.29140000f,0.36220002f,0.07640004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.22619999f,-0.96539999f,-0.54259998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.36820001f,-0.30680001f,-0.93839997f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.15970002f,-0.99780000f,-0.94010000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.07380004f,0.50010003f,0.91949998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.71959999f,-0.54930001f,1.88850001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.67660005f,-0.25730001f,-0.75370004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.19999998f,0.42350000f,-0.33760001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.17160001f,-0.36370000f,-0.71989999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.15489997f,-0.66740000f,-0.32359998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.26320007f,0.32649998f,-0.73659994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.67540001f,-0.90630004f,-0.63079998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.31230002f,0.51309998f,0.39830003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.09449998f,-0.31519999f,0.15199999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.38509997f,0.52390000f,0.90780000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31700002f,-0.85009998f,0.17230002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.59409997f,0.65239998f,0.42330003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.66320003f,-0.17699994f,1.39120003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.38880006f,-1.12040001f,-0.10640002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.30230001f,0.69399997f,-0.88370000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.91840002f,0.30180000f,0.01139999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18789997f,-1.18999998f,0.57159999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.06220002f,-0.94460002f,-0.39679999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.12830001f,-0.51020001f,1.17000000f,0.0f,0.0f,0.0f,0.0f,0.0f,2.36180002f,0.46049997f,2.08790005f,0.0f,0.0f,0.0f,0.0f,0.0f,1.11180003f,-1.00189997f,-0.01900005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.09079999f,-0.29650003f,1.03080002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.65190003f,0.70040003f,-0.58470003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.35259997f,-2.01259995f,-0.13940002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59779996f,0.23180000f,3.16580001f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.09949999f,-0.80820009f,1.56010009f,0.0f,0.0f,0.0f,0.0f,0.0f,1.61579997f,-1.75580003f,-0.32740007f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.53899998f,-0.11229994f,0.12890000f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.76399999f,0.34729994f,-0.75910010f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.70530006f,0.32430009f,0.62520002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.10549995f,-1.52559994f,2.37489994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.30249998f,0.48989999f,-1.69649992f,0.0f,0.0f,0.0f,0.0f,0.0f,2.95510000f,-0.28460010f,-0.53960007f,0.0f,0.0f,0.0f,0.0f,0.0f,0.17360005f,0.66190001f,-1.84649995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.09090003f,-2.26100005f,1.52139993f,0.0f,0.0f,0.0f,0.0f,0.0f,1.40749998f,-2.83330002f,0.80180002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.93380003f,0.53850006f,0.10950002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.35179997f,0.88140001f,-0.10680002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.11589999f,-0.46609999f,0.10069996f,0.0f,0.0f,0.0f,0.0f,0.0f,1.28600001f,-0.29979999f,-0.73749998f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.33159989f,0.98939996f,2.65550006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.13790002f,-0.48140001f,1.29939997f,0.0f,0.0f,0.0f,0.0f,0.0f,1.46349995f,0.51859995f,0.65130012f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.25199996f,-0.47779998f,0.27520001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.99519997f,1.02689998f,-1.33210000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.10169997f,0.83439998f,0.52930002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.52880004f,2.75350005f,-1.05810005f,0.0f,0.0f,0.0f,0.0f,0.0f,5.31899993f,1.63210004f,4.88850000f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.20530002f,-0.47469999f,0.10280006f,0.0f,0.0f,0.0f,0.0f,0.0f,3.10540005f,-1.67340006f,2.47240007f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.87190005f,-1.20410002f,0.66130002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.37129993f,0.63030004f,0.88440001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.88920000f,-0.33540002f,0.05849997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.30879997f,3.08440003f,-0.87089992f,0.0f,0.0f,0.0f,0.0f,0.0f,1.35530009f,-2.69970003f,-0.24419999f,0.0f,0.0f,0.0f,0.0f,0.0f,2.06779999f,-0.98100002f,3.59989993f,0.0f,0.0f,0.0f,0.0f,0.0f,0.92789997f,1.09060007f,-1.82309999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05429999f,0.66489998f,-0.25490005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.89430000f,1.07969998f,0.00960004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.07170000f,0.17410002f,-1.43310003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59660002f,-1.13380004f,-3.47780001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.17130011f,2.71269996f,1.54520006f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.75909993f,-1.33340002f,1.39529998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.04629995f,2.50780008f,1.24590005f,0.0f,0.0f,0.0f,0.0f,0.0f,3.22710001f,2.14509997f,-0.05829996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.40170002f,-0.58059996f,-1.28480003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.71649993f,-1.23689996f,0.09790002f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.15179996f,0.68060003f,0.65120001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.46599999f,0.52479999f,-3.94170008f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.71180001f,-1.47340006f,-2.88109991f,0.0f,0.0f,0.0f,0.0f,0.0f,0.49740002f,-1.21110002f,0.47369997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.43300004f,-0.74599999f,1.13740007f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.05620001f,1.12020004f,-1.30739996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.39189996f,-1.48779996f,0.40540007f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.14760000f,0.56809998f,-1.10500006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.53520013f,-1.20340001f,-1.16189998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.31680006f,0.63510000f,-0.13730004f,0.0f,0.0f,0.0f,0.0f,0.0f,-4.69670002f,0.43290002f,2.80919994f,0.0f,0.0f,0.0f,0.0f,0.0f,1.83280001f,-0.23739998f,0.16619999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.55180000f,-0.66959999f,0.63940000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.24040002f,0.66060004f,0.99169997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.39740002f,-0.02370001f,0.71710002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.38560000f,-0.10040003f,2.20799996f,0.0f,0.0f,0.0f,0.0f,0.0f,1.14620002f,0.19349997f,-1.03930000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.15230001f,-1.01769999f,-1.06129997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.53640000f,0.82370003f,1.25740003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.14489999f,1.19770003f,-0.47030001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.28929998f,2.18420002f,-1.40680002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.82779997f,-0.60109993f,-0.00360004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.17699999f,2.17200004f,-1.56910003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59999999f,0.24210004f,1.05730001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05500001f,0.18540007f,-0.62799998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.28270000f,0.57230000f,0.08370003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.63330001f,-0.62600002f,0.80189997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.06839999f,-0.62800000f,1.25229996f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.02679996f,-0.70580001f,-2.31520000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.02080002f,0.24249994f,-1.36070001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.61990001f,1.03229997f,0.79180003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.62539999f,1.45249998f,0.62410001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.92469999f,0.03530002f,-0.65680001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.14020000f,-1.19390002f,-0.55550007f,0.0f,0.0f,0.0f,0.0f,0.0f,1.81679997f,0.01709999f,-0.39139998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.39780000f,-0.61419995f,-0.98120003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35139997f,0.64840003f,-0.36559998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.31880000f,1.89170001f,-0.44349997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.95290001f,-0.17909997f,-0.19740000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.82870002f,-1.35120004f,0.15959997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.18500001f,-0.98049999f,0.43839998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.55959999f,-0.30010002f,-0.59999998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.96009998f,-0.25319996f,-0.46940000f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.37640001f,-0.20450011f,-0.54420005f,0.0f,0.0f,0.0f,0.0f,0.0f,1.68990001f,-0.31670003f,-1.63639998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.29820000f,0.16660009f,1.16779997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.87770004f,-1.77560005f,0.61410003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.63880000f,0.73089998f,-0.56819998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.37110000f,0.42109996f,3.22420004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.72869993f,-2.75279991f,-1.44349996f,0.0f,0.0f,0.0f,0.0f,0.0f,1.52509999f,1.90649989f,1.06000007f,0.0f,0.0f,0.0f,0.0f,0.0f,2.22020003f,2.38149995f,0.33220004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.29859997f,-1.16599997f,0.49050006f,0.0f,0.0f,0.0f,0.0f,0.0f,2.03420007f,-0.03120001f,0.73720000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.56949994f,-0.66600006f,-0.69440004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.85010004f,1.13880005f,1.71710002f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.19269991f,1.78549997f,2.32719999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.04150004f,3.02159999f,-2.71420005f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.45549990f,-0.59219995f,0.44479998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.19040002f,-1.66200003f,1.89389991f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.34169993f,0.19710000f,-1.61499998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.34259999f,-0.95040002f,-0.78910001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.93030003f,-0.56229996f,-1.39070002f,0.0f,0.0f,0.0f,0.0f,0.0f,2.78570004f,1.28020002f,-1.95559998f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.12300001f,0.08939994f,0.40769992f,0.0f,0.0f,0.0f,0.0f,0.0f,2.17980003f,-0.15590002f,-2.53909996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.64049998f,-0.97049990f,-1.42790002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.40729996f,-1.41180003f,-0.56080001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.32129999f,0.27079995f,0.89939997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.80520005f,-1.39220004f,0.26839996f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.09999998f,-1.00869996f,-0.97849998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.96729999f,-1.32630002f,-0.14589998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.56729997f,-1.89509996f,0.03349999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.08370001f,-2.16839999f,2.10380004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.24440002f,0.21929997f,0.67760000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.22969996f,-0.00520002f,-0.06969996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.03399997f,0.92619998f,-1.82590002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.31930004f,0.32210001f,0.25760003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.85299997f,2.75880003f,0.12159998f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.20810000f,1.15850006f,-2.07450000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.77579993f,0.56669994f,0.29940001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.22170000f,-0.97729996f,-0.80210002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.03780005f,2.00390001f,0.09160002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.50790003f,0.21520002f,-1.38390004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.47270002f,1.46950002f,-2.12019999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.08470003f,1.01969993f,0.45810004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.85640005f,1.01799995f,0.78879988f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.66910008f,-1.92929998f,1.04430001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.69969998f,-0.07160002f,-0.44449998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.51160001f,1.29029999f,-0.48560000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.08220001f,0.39230002f,-1.40030002f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.56369998f,-3.20730001f,0.86040000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.97220004f,-1.17730007f,0.91309997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.24239996f,0.95569998f,0.20269999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.44380001f,1.47380005f,-2.27589996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.98090000f,-1.54540002f,0.43920001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.25500003f,-0.48790004f,-0.77250002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.39290001f,1.52640006f,0.46610001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.08420001f,0.82409996f,0.56560000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.62650009f,1.28229995f,-4.03959998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.08169998f,0.35110001f,1.51159994f,0.0f,0.0f,0.0f,0.0f,0.0f,2.04790004f,-0.29750004f,2.38809999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.79900004f,0.36249998f,-0.52360003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.19489999f,-0.39859998f,0.66180000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.05829995f,0.24770005f,0.02589997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.96109999f,-0.23049996f,-1.01649994f,0.0f,0.0f,0.0f,0.0f,0.0f,3.06670005f,0.14730002f,2.77420000f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.16089998f,-1.93530007f,-1.31470003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.58670003f,2.06189998f,3.25579996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.73670003f,1.08380006f,-0.00320003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.43559997f,-0.92360002f,-0.60149998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.48250001f,0.68249999f,-0.68669999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.48939995f,-0.41420002f,2.33090001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.44209994f,-1.06049999f,0.10400003f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.96309998f,0.51520002f,-1.27039997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.15340005f,-0.24690002f,0.54670002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.02159999f,0.29310000f,-0.78650001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.84509998f,0.77559993f,-0.61040005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.48020005f,0.89580005f,0.06080000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.09189999f,1.13080004f,2.73699995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.70610004f,0.56679998f,-2.93330010f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31029994f,0.74659998f,1.63150002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.68160002f,-0.69449994f,2.03240001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31069996f,-0.08530000f,-1.37200001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,2.52500004f,-0.75160002f,-0.72479996f,0.0f,0.0f,0.0f,0.0f,0.0f,1.46509996f,-0.57409999f,-0.42430007f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.00129998f,0.13830002f,-0.36559994f,0.0f,0.0f,0.0f,0.0f,0.0f,2.72550004f,-1.08739997f,-0.53560003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.32799996f,1.29570004f,-2.19330002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.47210002f,-1.32950006f,-0.01610006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.55990001f,0.58520001f,1.65469998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.13739993f,-0.83289993f,0.49429998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.04040002f,-0.42699998f,-1.18749998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.58179989f,-0.84800008f,0.00050001f,0.0f,0.0f,0.0f,0.0f,0.0f,2.03990008f,2.92090002f,0.38640003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.45370008f,-0.21230001f,-0.85420001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.22699999f,-1.42430006f,0.81859999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.42160005f,1.12989999f,0.90960010f,0.0f,0.0f,0.0f,0.0f,0.0f,1.08299993f,-1.83930004f,-1.34479999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.82210002f,-0.58210001f,-0.91509996f,0.0f,0.0f,0.0f,0.0f,0.0f,5.30599983f,-0.49820003f,-2.26989998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.99300000f,-1.46460004f,1.35910004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.25630006f,0.29709990f,0.29990006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.34069999f,2.70179998f,1.52219994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.69720004f,0.08229999f,0.24310005f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.63160001f,-2.45720000f,-0.84690006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.64029995f,-0.22880000f,0.17639997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.16540004f,1.69190005f,3.54959998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.39690016f,-1.16300002f,1.84369997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.89630004f,-2.17340004f,-0.04759991f,0.0f,0.0f,0.0f,0.0f,0.0f,0.21329995f,4.04089999f,-0.34399998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.14710004f,-1.22379994f,0.71110003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.83410004f,-1.35529998f,-0.13969997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.32640000f,0.32870005f,0.37170003f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.26699985f,0.73779996f,-0.11629995f,0.0f,0.0f,0.0f,0.0f,0.0f,1.32390000f,-3.08429998f,0.66010008f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.02450006f,0.15940005f,1.91630001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.30110002f,-2.11150000f,0.85130000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.69259998f,0.34379997f,-1.73770004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.13369995f,-3.24100006f,0.51319998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.03500001f,-0.95350001f,2.29459994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.56120002f,-0.78119993f,-0.37619991f,0.0f,0.0f,0.0f,0.0f,0.0f,1.79490013f,1.88999975f,-3.09539994f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.08990007f,-0.08739996f,1.41149995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.24430000f,-1.01699995f,1.18780006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.16730001f,0.57820004f,1.05580004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.50120005f,-0.36829996f,1.46950005f,0.0f,0.0f,0.0f,0.0f,0.0f,1.19260005f,-1.31349990f,-0.90690006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.94110009f,-1.04160000f,-0.03480000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.96699997f,2.96710006f,-1.11270008f,0.0f,0.0f,0.0f,0.0f,0.0f,0.57240012f,-1.54809993f,-1.06100004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.00129994f,1.93439997f,1.81229995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.30450002f,0.67589999f,0.73779997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.64419994f,0.07380006f,-1.30740000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.13670004f,0.82720001f,0.19369995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.01419994f,0.45309999f,0.04799999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.46769996f,4.32910005f,-0.98490000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.21029993f,0.95910007f,0.32839996f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.39679994f,-0.39030011f,0.40140001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.53459998f,0.67100003f,1.16659993f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.09290001f,-0.89250001f,0.08299999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.17910000f,1.36140004f,0.94989999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.95279998f,0.47599999f,-0.23119994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.64680001f,-0.17510000f,-2.02940006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.13409997f,0.04679997f,0.04800000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.10950003f,-0.67500007f,2.47540002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.13670004f,0.07120004f,-0.62610000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.28069999f,0.37940001f,0.06420000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.81769998f,1.89120004f,-0.74530003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.57349997f,-0.05920001f,-0.38890001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.99460008f,0.16430002f,0.82739999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.86760002f,-1.77150006f,-1.15689996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.14230005f,2.22299998f,1.33440004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.59670001f,0.59019999f,-0.21649999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.10260003f,-0.05860000f,-0.39660001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.41690003f,-0.45720001f,0.20539998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.05160001f,-1.40680004f,1.06010000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.50120003f,-0.24339994f,0.03840005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.80500005f,0.75689999f,-0.56070000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59049996f,0.34050001f,0.52440000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.02730000f,0.07089998f,-0.44699999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.82020001f,0.02609995f,0.15700001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.90389999f,0.17860000f,-0.00190000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.64370001f,0.83809995f,1.37229995f,0.0f,0.0f,0.0f,0.0f,0.0f,1.62410003f,0.02590001f,-1.92750000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.27479999f,0.22890001f,1.29709998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31439998f,-0.07230000f,0.89240004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.68699996f,-0.28779999f,-0.67910001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.05089994f,1.29619998f,-0.24139999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.06520005f,-0.13010005f,-2.39189998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.69159999f,1.81769999f,0.05369997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.85489994f,-3.54409998f,-1.05239994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.75679998f,-1.30489996f,-3.60520002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.43119988f,-0.95850004f,-0.31009998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.16840004f,0.56550003f,-0.53870000f,0.0f,0.0f,0.0f,0.0f,0.0f,2.45399998f,2.73029996f,-2.23929995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31000001f,-1.86630001f,3.73789995f,0.0f,0.0f,0.0f,0.0f,0.0f,1.35820000f,0.30169994f,0.18110004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.39889999f,-2.77089986f,1.25960002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.84230007f,-1.39709989f,-2.14150000f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.11500004f,0.83499995f,-0.17720003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.00779999f,0.26910000f,0.02830002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.20300007f,-0.07490001f,0.52189998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.51400008f,0.73080000f,2.04600004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.77899999f,-1.73839997f,0.60930000f,0.0f,0.0f,0.0f,0.0f,0.0f,2.81649997f,1.51129999f,-2.98509999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35029995f,-0.14059999f,1.70160002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.35199996f,-2.77419992f,-0.86609995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.94909993f,-2.29870001f,1.76240003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.78280003f,-1.60640006f,1.48829998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.72429999f,-0.30619999f,-0.68390005f,0.0f,0.0f,0.0f,0.0f,0.0f,3.37690008f,0.49909995f,2.01210000f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.44780003f,-2.17269997f,-1.66240002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.88239994f,-1.07250000f,1.26150001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.82810003f,2.14560001f,0.32279997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35580001f,-0.87550004f,0.74739998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.21780003f,-0.76189998f,0.11000000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.61450002f,-1.58249995f,-0.03609998f,0.0f,0.0f,0.0f,0.0f,0.0f,2.70050006f,-0.35350010f,1.14539999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.14230000f,-2.29889999f,-2.17710002f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.36830004f,1.83940007f,-1.59950001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.84960002f,3.64900001f,2.21540000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.62040004f,0.37209999f,-1.64210001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.27610002f,-2.31460007f,-0.88189999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.55099997f,-0.56389998f,-0.30719999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.39520006f,1.86309996f,0.45640002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.78690005f,1.68159996f,-2.06049988f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.61780002f,-0.94699993f,-0.29450002f,0.0f,0.0f,0.0f,0.0f,0.0f,2.07469990f,0.36899998f,0.44100008f,0.0f,0.0f,0.0f,0.0f,0.0f,0.79270002f,0.32260002f,1.02800000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.40389998f,0.54459995f,1.02690001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.72149999f,-0.17159997f,-0.21580003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.32929993f,0.73109992f,-0.87460005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.15180002f,-1.72049995f,1.11009997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31410001f,-0.12119996f,-3.60079997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.04310008f,2.07670000f,1.95740008f,0.0f,0.0f,0.0f,0.0f,0.0f,0.74560000f,-0.54459997f,0.51600000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.47439998f,-1.78520004f,1.19660000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.91749999f,1.02290001f,1.04269998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35129996f,-0.26720007f,-0.04550000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.40429999f,0.09430006f,-0.57130011f,0.0f,0.0f,0.0f,0.0f,0.0f,0.71990002f,0.90829998f,-0.05629992f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.18709998f,2.20639995f,1.27010001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.88689999f,1.18780006f,0.63070008f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.30900004f,0.50880002f,0.47690000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.00699999f,-0.66070001f,0.97100002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.29080004f,1.56600003f,-0.49330004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.14440000f,-2.00429993f,1.17149998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.37900001f,0.87169996f,0.54760003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.92590000f,-0.34929999f,-0.64440002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.23020000f,-0.63710001f,0.57009999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.11810002f,-0.64020000f,0.55739997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.12020000f,0.62160001f,0.64100004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.60679994f,-1.13859997f,-0.65760003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.82970002f,-1.28019998f,-0.38220001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.40689999f,-1.72850002f,0.48480001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.08199999f,-0.73230004f,0.23680004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.49760002f,-0.36250004f,-1.12310006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.11430001f,-0.42000001f,0.32520002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.96289995f,-0.04590002f,-0.72309999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.01799999f,0.25950002f,2.75250000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.47570004f,1.04130005f,-0.26719996f,0.0f,0.0f,0.0f,0.0f,0.0f,2.17910005f,1.56369998f,0.75690002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.69520002f,0.27639996f,-1.29130000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.22470007f,0.21250005f,0.25090001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.93660001f,-0.02029999f,0.24490000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.57499997f,1.21140000f,0.41800000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.62849997f,1.83959997f,-0.61160001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35540007f,0.97540002f,0.90810002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.43830006f,0.64580001f,1.41520002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.81109997f,1.47480000f,0.39970000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.97880002f,-1.16950005f,0.46560002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.65970000f,0.26349994f,2.00170003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.51069998f,0.32380000f,1.37640001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.28140001f,0.15999996f,1.33600000f,0.0f,0.0f,0.0f,0.0f,0.0f,2.70320001f,2.25200004f,-1.64739999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.21209994f,-0.23199995f,-2.80689997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.30870007f,-1.38999995f,-0.73810004f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.08780003f,-0.06369994f,-0.49260006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.26670000f,0.88039996f,0.15570002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.66060000f,-3.08690000f,-1.67879998f,0.0f,0.0f,0.0f,0.0f,0.0f,2.23449997f,0.69620000f,-2.97819999f,0.0f,0.0f,0.0f,0.0f,0.0f,2.84459993f,1.05450010f,-1.03990003f,0.0f,0.0f,0.0f,0.0f,0.0f,2.53120004f,0.64969992f,-0.25280002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.21250009f,-0.72350002f,-1.09979999f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.16539997f,0.51670000f,-1.08220000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.68800003f,-2.49979999f,-1.07200001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.64420005f,0.91540004f,-1.42650000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.20959997f,-0.68069997f,1.47769995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.76399994f,1.13999990f,-2.09490002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.71630002f,-1.40449994f,0.63790002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.85200001f,0.72130001f,-0.22580008f,0.0f,0.0f,0.0f,0.0f,0.0f,0.65639996f,1.63050007f,0.76630003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.09659997f,-0.21909999f,0.81229999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.71950001f,-1.50660004f,-0.11979996f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.17019996f,-1.37719999f,0.28480001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.31870008f,-1.77199992f,2.62699996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.32090002f,-1.23860000f,0.09189995f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.97360003f,3.14139992f,1.91940002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.12360001f,-0.13549996f,-0.13350004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.61630008f,0.77179999f,1.39589998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.53890002f,-0.63100003f,-2.91700002f,0.0f,0.0f,0.0f,0.0f,0.0f,2.82499997f,2.99289998f,-1.64629998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.28289996f,0.42030001f,-0.10529996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.07420000f,-0.95759996f,1.94920007f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.15090000f,-0.74929999f,3.72230002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.02170005f,-0.13490003f,-0.42890005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.91950002f,1.84909997f,0.69539991f,0.0f,0.0f,0.0f,0.0f,0.0f,1.92779999f,-1.01630006f,0.72249997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18830003f,-0.32699997f,0.83550000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.09699990f,4.44940009f,3.10549996f,0.0f,0.0f,0.0f,0.0f,0.0f,2.00780000f,-0.15199998f,0.75719996f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.54609992f,1.71289991f,-0.23990007f,0.0f,0.0f,0.0f,0.0f,0.0f,1.41070003f,-0.08310002f,0.02030006f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.10799996f,0.75860000f,1.45970005f,0.0f,0.0f,0.0f,0.0f,0.0f,1.47940002f,0.46109997f,0.31930000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.28650001f,3.06139993f,-2.08979996f,0.0f,0.0f,0.0f,0.0f,0.0f,2.49679991f,-2.05909994f,-0.58290009f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.92789998f,0.76630006f,-1.06249996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.65609991f,0.67459998f,-1.99149995f,0.0f,0.0f,0.0f,0.0f,0.0f,1.59560004f,-1.88850004f,0.33370004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.13959998f,-1.87369999f,0.36150001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.43549998f,-0.75640003f,-0.23330000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.17410003f,-2.39179998f,0.55030005f,0.0f,0.0f,0.0f,0.0f,0.0f,1.33670002f,2.30290009f,-2.22020001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.94760001f,1.53959990f,-2.25810002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.93060000f,-1.71380008f,0.38819999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.70059996f,-2.05070001f,-0.47130001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.95850002f,0.09600001f,-0.09790001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.67260003f,-1.42319997f,1.18190001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.72690000f,-0.26980002f,-1.18420004f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.86910003f,0.61410001f,-1.55900004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.11399999f,-0.51259996f,-2.97000004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.47659995f,1.89819995f,0.01670000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.63350002f,1.13020002f,-0.30839997f,0.0f,0.0f,0.0f,0.0f,0.0f,1.67870000f,-0.27559999f,-0.91739999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.45620000f,0.15069997f,1.96540001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.72599998f,0.66129994f,-1.54669995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.82590010f,1.60230001f,-1.25339999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.28789997f,1.79229999f,-0.29709996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.01440002f,1.15910003f,0.93939999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.33970004f,-0.10589996f,1.70410005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.44210000f,0.24219999f,0.79879999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.37340000f,0.62080004f,-0.59199999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.89800004f,1.44689994f,0.01750002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.26019997f,1.59939994f,-0.81709998f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.74310003f,0.42020003f,1.49009999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.86059999f,1.77670002f,1.10019997f,0.0f,0.0f,0.0f,0.0f,0.0f,1.00700002f,0.72459998f,0.38399999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.55580000f,-0.26330004f,0.11159997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.17309996f,1.31230000f,0.38010000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.93649997f,0.61930001f,-0.37880000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.85880004f,0.54720008f,1.71670000f,0.0f,0.0f,0.0f,0.0f,0.0f,2.85730000f,-0.19289998f,-0.08429999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.58670002f,-1.58470000f,-0.57739998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.46359997f,0.80050003f,0.23240001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.15030002f,-0.69149998f,0.44460000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.69439999f,1.94500001f,-0.15439997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.21769995f,-0.25500001f,-1.50389999f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.63819995f,0.52270008f,2.60239999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35890000f,-0.36249997f,1.70149996f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.41680006f,0.04509999f,0.15919999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.89590003f,-0.79970000f,0.61259998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.38550001f,-0.55880001f,1.46310000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.09790002f,0.55230004f,-0.01849998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.29160001f,0.86420002f,1.97180006f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.34429996f,0.34680008f,1.57019996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.87819997f,0.95629999f,-0.05879999f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.92679998f,0.67700007f,3.91430001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.50499999f,0.37829999f,-1.64680000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.07430003f,0.28280003f,0.29999999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.26239998f,-0.90019996f,1.09520000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.58920000f,1.52879997f,0.03780006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.06250006f,1.62560001f,4.15589999f,0.0f,0.0f,0.0f,0.0f,0.0f,2.87389995f,0.44330000f,-0.88829999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.43649999f,0.40190002f,-0.49989993f,0.0f,0.0f,0.0f,0.0f,0.0f,0.34030001f,-0.83010006f,0.68060004f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59119994f,0.19380002f,0.02940004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.69940005f,1.04970007f,1.05700000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.52930000f,0.73210000f,-1.94610001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.83509999f,-1.11039999f,-4.84459993f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.08069999f,0.42270007f,-0.52380000f,0.0f,0.0f,0.0f,0.0f,0.0f,3.91520004f,0.26349998f,-2.89690000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.62980003f,-0.38250004f,0.96609995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.07470001f,0.74400001f,1.23270001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.30179995f,-0.47959996f,1.27060003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.88549995f,0.16560003f,-1.02330000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.48299998f,3.42749994f,0.89649999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.61969999f,-0.12510006f,0.05249997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.99799997f,-0.35900011f,-2.32520001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.07450000f,-0.67889998f,1.98429995f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.53069999f,0.41359997f,0.81059997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.59739999f,-0.67699999f,0.41970003f,0.0f,0.0f,0.0f,0.0f,0.0f,2.01849998f,-0.53350000f,-0.32060001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.45479996f,1.53989989f,-3.40159985f,0.0f,0.0f,0.0f,0.0f,0.0f,-4.21789994f,-0.64510002f,-1.01960003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.20030000f,1.68790007f,1.56339999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.19860009f,0.66170001f,-0.29710005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.96190001f,0.93560001f,1.28820003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.40499999f,-0.34969998f,-2.78249997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.10769999f,-1.40370004f,1.02800003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.51889999f,1.08359993f,1.32490003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.00260006f,-2.12300002f,-1.01649996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.27669995f,-1.30999997f,0.11289993f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.16970003f,-0.54149995f,-0.92289998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.23310002f,2.11649997f,-1.44030005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18220003f,0.30390003f,-0.13020001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18609998f,4.34749999f,-1.51140002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.92420005f,-0.20329996f,-1.03010003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.96139993f,-2.42599995f,-0.62399993f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.48779995f,0.55500003f,-2.03559994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35740000f,0.63400000f,1.43210002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.49840005f,-0.61120004f,-0.73190001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.97800005f,0.48699995f,-0.43300000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.43450002f,-0.08619998f,-1.05439992f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.31360002f,0.34329998f,0.54389991f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.47760005f,0.79269992f,1.13879997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.12020010f,-1.34600002f,-1.44569996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.63190007f,0.23700003f,-0.17520006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.64530004f,-0.03449997f,0.07950003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.56720002f,-1.56079999f,0.21740001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.27660003f,-1.14290005f,0.10859999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.76970011f,1.50939999f,0.02150006f,0.0f,0.0f,0.0f,0.0f,0.0f,2.15760001f,-1.97279999f,0.21920003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.60739996f,-0.59850002f,1.05899995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.92540000f,-0.48599997f,-0.06770001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.21329998f,1.51090000f,-0.07950002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.19719996f,1.13300003f,0.54779997f,0.0f,0.0f,0.0f,0.0f,0.0f,1.66090002f,-2.01220003f,-1.71560002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.14339990f,-0.25139994f,0.49049996f,0.0f,0.0f,0.0f,0.0f,0.0f,1.10239992f,0.17690001f,-2.13130001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.32359995f,-0.15750008f,-1.45209999f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.05240001f,0.22340001f,0.90449998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.04510002f,-0.10300001f,-0.73280003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.27049999f,-0.54209999f,-0.63700000f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.22149996f,-0.35210004f,1.98029993f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.11830008f,1.70059998f,0.41199993f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.68030002f,0.44450000f,-1.25190005f,0.0f,0.0f,0.0f,0.0f,0.0f,1.58429998f,-0.39179996f,-0.25180012f,0.0f,0.0f,0.0f,0.0f,0.0f,0.50630001f,-0.89710001f,1.09069999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,3.20849998f,0.88500004f,-1.84220003f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.00370003f,-0.31079996f,0.63529996f,0.0f,0.0f,0.0f,0.0f,0.0f,-4.53230004f,0.92370007f,0.53309999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.36659990f,2.43470005f,-1.74669995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.65359994f,1.06270002f,-1.66049989f,0.0f,0.0f,0.0f,0.0f,0.0f,1.77980003f,0.98460005f,-2.07060001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.07059998f,1.02410008f,0.59000000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.50820001f,1.23449994f,-2.36989996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.31379999f,0.38900004f,-0.56999996f,0.0f,0.0f,0.0f,0.0f,0.0f,2.16859996f,-0.69579993f,-2.94489998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.46409993f,2.00129999f,-0.73629998f,0.0f,0.0f,0.0f,0.0f,0.0f,1.39009993f,-1.10440001f,1.98420006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.61559999f,-0.31920003f,-3.40559996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.55520011f,2.61280001f,-0.01080000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.15590003f,0.98709999f,-0.43609998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.10680005f,1.92359998f,0.69630007f,0.0f,0.0f,0.0f,0.0f,0.0f,1.05959999f,-3.15320000f,0.97580003f,0.0f,0.0f,0.0f,0.0f,0.0f,1.81090007f,1.15150009f,-0.51710008f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.16840004f,-0.45050001f,2.93439998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18169997f,-0.37900008f,-1.37519996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.20410000f,0.56970000f,0.40730004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.59490000f,1.26820002f,-1.55160001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.71999999f,0.54730005f,-1.45979998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.66659998f,-0.15819997f,1.50590010f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.38269995f,-1.22179998f,0.60819994f,0.0f,0.0f,0.0f,0.0f,0.0f,3.32610004f,1.07010000f,-1.31809999f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.70609997f,-1.85249996f,3.24490006f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.03579995f,0.88180007f,0.30130008f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.30039998f,-1.74360002f,0.05000001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.18099999f,0.32880001f,0.38730010f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.96620008f,-6.03930002f,-0.04900000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.85690001f,1.03220003f,3.94289999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.09369999f,-2.23569998f,-0.74919994f,0.0f,0.0f,0.0f,0.0f,0.0f,1.67499995f,1.42149995f,2.64670002f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.04220003f,-1.80119998f,-0.75680000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.08760007f,0.67950006f,2.08790005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.45860000f,0.17950002f,0.23149999f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.44929996f,0.27629998f,0.64519990f,0.0f,0.0f,0.0f,0.0f,0.0f,3.47319996f,-1.70449984f,4.38320007f,0.0f,0.0f,0.0f,0.0f,0.0f,2.93139998f,-0.84050008f,1.11959997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.01950000f,0.60879998f,-1.52549990f,0.0f,0.0f,0.0f,0.0f,0.0f,0.96960000f,0.76910002f,-0.20179996f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.17259998f,0.14759993f,0.18930001f,0.0f,0.0f,0.0f,0.0f,0.0f,1.51680001f,0.87219997f,0.96219998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.44059994f,1.39369985f,-0.63569991f,0.0f,0.0f,0.0f,0.0f,0.0f,1.83049996f,-2.99590003f,-0.90019997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.37479995f,-1.53679994f,0.69319998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.52770003f,-2.49149997f,-1.56049995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.03950003f,-1.28110007f,-0.02259997f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.38949999f,-0.42000000f,-0.52240007f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.02559995f,-2.04290001f,0.05449996f,0.0f,0.0f,0.0f,0.0f,0.0f,1.42329989f,-2.75169999f,-0.73449998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.96789999f,0.55030007f,4.33129998f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.59299998f,-0.61720005f,-2.77119996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.09680001f,-0.64390000f,1.36029993f,0.0f,0.0f,0.0f,0.0f,0.0f,0.87780004f,0.72550004f,-0.45540003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.54450001f,-0.70380002f,-0.95610003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.95040001f,-0.13209999f,0.47610002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35480002f,-0.32790001f,-0.74290001f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.37470005f,0.25200005f,0.62039997f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.14649994f,0.98579991f,-0.09220008f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.30070004f,-1.52659998f,0.41750000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.09550000f,0.12009998f,-0.22699999f,0.0f,0.0f,0.0f,0.0f,0.0f,1.27190004f,0.11190000f,-1.07829999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.71610001f,-0.60800000f,0.88900003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.29689998f,-0.76390002f,0.36059997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35350004f,2.13870002f,1.40600000f,0.0f,0.0f,0.0f,0.0f,0.0f,1.80219997f,-0.58139997f,0.51510002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.57669999f,-0.88530002f,0.77709999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.88980002f,-0.74070003f,0.36879999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.14740000f,1.10320001f,0.42220000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.05839995f,1.02470006f,0.22510000f,0.0f,0.0f,0.0f,0.0f,0.0f,2.03199999f,-1.87910004f,-0.34330004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.12899993f,1.54930007f,-0.67650006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.36950001f,1.20729996f,-0.68510003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.23950003f,-0.12560000f,-1.38930000f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.12840003f,-0.42009999f,1.09259999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.09230003f,-0.77430004f,-0.70840003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.42829999f,0.00790001f,0.30230003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.84920000f,-0.77639997f,0.27410002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.61429995f,3.11140003f,0.26539997f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.00640004f,0.89950002f,-0.21740004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.76820006f,0.15009998f,0.45709997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.13350002f,-1.32910006f,0.34050004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.90930007f,1.49560002f,-0.89320005f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.88020002f,1.44070002f,0.38750005f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.24250000f,-1.31519992f,-3.04489995f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.85419996f,2.87729996f,2.92789988f,0.0f,0.0f,0.0f,0.0f,0.0f,0.84010001f,-0.91070004f,-0.51040000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.14069997f,1.37479998f,0.73770003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.73549994f,0.82940002f,-1.28190000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.31360006f,-1.78509993f,1.64439998f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.15920003f,1.41410002f,1.02339997f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.02149997f,-0.26160003f,4.23930003f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.82179987f,1.04790002f,-0.22530002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.63149999f,-2.79519991f,0.76050008f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.72930003f,0.28240000f,-2.21410006f,0.0f,0.0f,0.0f,0.0f,0.0f,1.52680001f,1.39840002f,1.50789997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.15079999f,0.59530006f,0.76499999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.69840010f,-0.37529995f,1.00280001f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.29560000f,-0.43710000f,-0.30859999f,0.0f,0.0f,0.0f,0.0f,0.0f,2.46659998f,-0.53859995f,1.55530002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.08120002f,0.76839995f,0.35280001f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.13800000f,-1.09659996f,0.38769994f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59030004f,-0.80989999f,-0.84429989f,0.0f,0.0f,0.0f,0.0f,0.0f,1.46540005f,0.47810000f,-1.13949999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.25139998f,0.66849997f,0.88359998f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.03099993f,0.11389999f,-0.73910001f,0.0f,0.0f,0.0f,0.0f,0.0f,2.54380002f,2.71820001f,-0.30069997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.99770006f,1.44250002f,-0.14660003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.15910004f,-1.13190002f,1.58829986f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.22279996f,0.87110006f,0.08599999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.11120003f,0.67210001f,0.88309999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.58990002f,0.03830004f,1.86390000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.26590000f,-0.86570005f,0.82789997f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.13400001f,-2.43630000f,-0.12220002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.70339994f,0.11080002f,0.01319989f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.35100002f,-0.88640004f,-0.30449999f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.97990004f,-0.40530001f,-0.14899999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.92270005f,-0.68379992f,-1.36929997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.54910002f,0.14189999f,-1.14079992f,0.0f,0.0f,0.0f,0.0f,0.0f,1.76149999f,0.44400003f,-2.42560002f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.27439995f,-1.71470004f,3.07210004f,0.0f,0.0f,0.0f,0.0f,0.0f,1.70890003f,-0.94220002f,-4.93579987f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.68630002f,-2.24709995f,-0.25590000f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.32970000f,0.81140003f,0.63560002f,0.0f,0.0f,0.0f,0.0f,0.0f,1.94709999f,-0.04390001f,0.19130002f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.68609994f,-0.34709995f,-0.20350002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.27559997f,-1.00629998f,0.06430006f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.94549996f,0.84049985f,0.47960003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.14499996f,-0.10010007f,4.30120003f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.10550001f,0.15130002f,0.09429997f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.33969996f,-1.89980001f,-0.48680006f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.89749996f,2.97000001f,-0.28800005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.79610001f,-0.14090004f,-0.99619998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.53120001f,2.10989989f,-1.08359997f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.00199998f,-0.89920002f,-0.59460001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.99989999f,-1.38750008f,-0.51740003f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.71059998f,0.58679993f,3.96469993f,0.0f,0.0f,0.0f,0.0f,0.0f,1.01640003f,0.63549999f,-0.49399998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_4d_4items_strided_dilated_padded_neg)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{4,3,8,8,8,8};
    Shape shape_b{4,3,2,2,3,1};
    Shape shape_r{4,4,2,7,1,3};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{3,2,2,3},        // move_strides
                                                                  Strides{2,1,3,2},        // filter_dilation
                                                                  CoordinateDiff{-2,4,0,5}, // below_pads
                                                                  CoordinateDiff{1,3,-1,-4}, // above_pads
                                                                  Strides{1,1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f,0.61000000f,0.17000000f,-0.91000000f,-0.48000000f,-0.48000000f,0.12000000f,-0.18000000f,0.08000000f,-0.16000000f,0.54000000f,-0.20000000f,-0.08000000f,0.19000000f,-0.81000000f,0.56000000f,-0.52000000f,0.32000000f,-0.37000000f,-0.17000000f,-0.46000000f,-0.34000000f,0.85000000f,0.11000000f,-0.10000000f,0.98000000f,-0.22000000f,0.68000000f,0.97000000f,-0.93000000f,-0.92000000f,0.32000000f,-0.19000000f,-0.61000000f,0.93000000f,0.54000000f,-0.75000000f,0.63000000f,0.38000000f,0.69000000f,-0.02000000f,0.19000000f,-0.38000000f,-0.44000000f,0.49000000f,-0.62000000f,-0.41000000f,-0.84000000f,0.93000000f,-0.74000000f,-0.57000000f,0.37000000f,-0.86000000f,-0.01000000f,0.58000000f,0.13000000f,-0.42000000f,0.68000000f,-0.05000000f,0.17000000f,0.09000000f,-0.67000000f,0.11000000f,-0.32000000f,0.08000000f,-0.29000000f,0.60000000f,0.69000000f,0.04000000f,0.85000000f,0.46000000f,0.41000000f,-0.78000000f,-0.98000000f,0.50000000f,-0.96000000f,-0.61000000f,-0.58000000f,0.00000000f,0.81000000f,-0.25000000f,-0.74000000f,-0.46000000f,-0.16000000f,0.32000000f,0.56000000f,-0.05000000f,-0.87000000f,0.59000000f,0.08000000f,-0.39000000f,0.67000000f,0.95000000f,0.70000000f,0.00000000f,-0.58000000f,0.85000000f,-0.14000000f,-0.27000000f,-0.63000000f,-0.75000000f,0.61000000f,-0.12000000f,-0.68000000f,-0.83000000f,0.12000000f,0.94000000f,-0.46000000f,0.27000000f,-0.14000000f,-0.96000000f,0.16000000f,-0.57000000f,0.92000000f,-0.24000000f,0.08000000f,0.60000000f,0.23000000f,-0.14000000f,-0.28000000f,0.14000000f,-0.19000000f,0.00000000f,-0.57000000f,0.18000000f,0.42000000f,0.17000000f,0.71000000f,-0.55000000f,0.89000000f,0.26000000f,-0.67000000f,0.68000000f,-0.75000000f,-0.62000000f,0.62000000f,-0.16000000f,-0.69000000f,-0.96000000f,-0.24000000f,0.00000000f,0.63000000f,-0.95000000f,-0.99000000f,0.06000000f,0.02000000f,-0.04000000f,0.95000000f,0.98000000f,0.13000000f,0.96000000f,-0.22000000f,-0.25000000f,-0.77000000f,-0.02000000f,-0.46000000f,0.28000000f,-0.61000000f,-0.56000000f,-0.65000000f,-0.23000000f,-0.41000000f,0.78000000f,-0.46000000f,0.44000000f,0.15000000f,0.46000000f,-0.90000000f,-0.25000000f,0.81000000f,0.28000000f,0.40000000f,0.56000000f,0.62000000f,-0.63000000f,-0.86000000f,-0.97000000f,0.22000000f,-0.58000000f,0.05000000f,0.53000000f,-0.38000000f,0.79000000f,0.60000000f,-0.63000000f,-0.18000000f,0.62000000f,-0.37000000f,0.48000000f,0.86000000f,0.70000000f,-0.52000000f,-0.39000000f,-0.44000000f,-0.69000000f,0.42000000f,-0.69000000f,0.48000000f,0.70000000f,-0.86000000f,-0.90000000f,0.69000000f,0.08000000f,-0.34000000f,-0.86000000f,0.66000000f,0.61000000f,0.47000000f,-0.22000000f,-0.51000000f,-0.29000000f,0.95000000f,-0.30000000f,-0.41000000f,0.85000000f,-0.13000000f,0.70000000f,-0.51000000f,-0.05000000f,-0.50000000f,-0.28000000f,-0.44000000f,0.33000000f,-0.08000000f,-0.88000000f,-0.64000000f,0.24000000f,-0.51000000f,0.67000000f,-0.40000000f,0.48000000f,0.92000000f,-0.64000000f,-0.42000000f,-0.62000000f,-0.77000000f,0.34000000f,0.29000000f,0.49000000f,0.82000000f,-0.30000000f,-0.40000000f,0.27000000f,0.61000000f,-0.75000000f,0.42000000f,0.69000000f,0.46000000f,0.41000000f,0.48000000f,0.14000000f,0.86000000f,-0.46000000f,-0.88000000f,-0.20000000f,-0.09000000f,-0.10000000f,0.70000000f,0.97000000f,-0.99000000f,0.53000000f,-0.51000000f,-0.70000000f,-0.96000000f,0.86000000f,-0.44000000f,-0.66000000f,-0.28000000f,0.08000000f,0.42000000f,-0.45000000f,-0.73000000f,-0.99000000f,-0.33000000f,0.40000000f,-0.86000000f,-0.84000000f,-0.06000000f,0.77000000f,0.96000000f,-0.06000000f,0.24000000f,0.21000000f,0.27000000f,-0.21000000f,-0.01000000f,0.16000000f,0.40000000f,0.06000000f,-0.61000000f,-0.66000000f,0.76000000f,0.43000000f,0.00000000f,0.37000000f,0.70000000f,-0.76000000f,0.50000000f,-0.38000000f,-0.24000000f,-0.80000000f,-0.66000000f,0.09000000f,-0.70000000f,0.83000000f,0.59000000f,-0.39000000f,-0.21000000f,0.84000000f,-0.17000000f,0.50000000f,-0.48000000f,-0.07000000f,-0.54000000f,-0.16000000f,0.99000000f,0.28000000f,0.29000000f,-0.68000000f,-0.49000000f,-0.18000000f,-0.41000000f,0.95000000f,0.72000000f,-0.26000000f,-0.42000000f,-0.27000000f,0.38000000f,-0.47000000f,0.24000000f,-0.38000000f,0.29000000f,0.34000000f,-0.30000000f,-0.64000000f,-0.27000000f,-0.27000000f,-0.94000000f,0.26000000f,0.52000000f,0.92000000f,0.53000000f,-0.80000000f,0.31000000f,0.29000000f,0.16000000f,-0.47000000f,0.61000000f,0.46000000f,-0.75000000f,-0.88000000f,0.95000000f,0.33000000f,-0.97000000f,-0.03000000f,0.43000000f,0.14000000f,0.73000000f,0.97000000f,-0.01000000f,0.45000000f,0.81000000f,0.77000000f,0.45000000f,0.16000000f,-0.66000000f,-0.29000000f,-0.23000000f,0.32000000f,0.22000000f,-0.09000000f,0.65000000f,-0.46000000f,0.65000000f,-0.01000000f,0.61000000f,-0.12000000f,0.36000000f,0.29000000f,-0.87000000f,-0.01000000f,-0.28000000f,-0.95000000f,0.37000000f,0.73000000f,-0.99000000f,0.47000000f,-0.69000000f,-0.31000000f,0.67000000f,-0.78000000f,-0.77000000f,-0.41000000f,0.95000000f,0.61000000f,0.52000000f,0.85000000f,-0.88000000f,0.97000000f,0.54000000f,0.53000000f,0.87000000f,-0.64000000f,-0.62000000f,0.70000000f,-0.11000000f,0.93000000f,-0.52000000f,-0.08000000f,0.03000000f,0.27000000f,-0.30000000f,-0.62000000f,0.00000000f,0.76000000f,0.12000000f,-0.83000000f,-0.60000000f,-0.95000000f,0.51000000f,0.85000000f,-0.27000000f,-0.83000000f,-0.20000000f,-0.45000000f,0.27000000f,-0.09000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.52000000f,-0.43000000f,-0.73000000f,-0.60000000f,-0.89000000f,0.15000000f,-0.12000000f,0.95000000f,0.97000000f,-0.43000000f,0.85000000f,0.43000000f,-0.35000000f,-0.44000000f,0.84000000f,0.94000000f,0.80000000f,-0.88000000f,-0.73000000f,-0.24000000f,0.93000000f,0.77000000f,0.15000000f,-0.63000000f,0.84000000f,0.70000000f,-0.24000000f,-0.01000000f,-0.63000000f,0.44000000f,0.50000000f,-0.29000000f,-0.27000000f,0.64000000f,0.28000000f,-0.18000000f,0.90000000f,-0.87000000f,-0.86000000f,-0.24000000f,0.66000000f,-0.49000000f,0.86000000f,0.19000000f,0.56000000f,-0.18000000f,-0.25000000f,-0.32000000f,-0.09000000f,0.83000000f,0.25000000f,0.92000000f,0.15000000f,0.71000000f,-0.91000000f,0.86000000f,-0.70000000f,0.05000000f,-0.23000000f,0.19000000f,0.32000000f,0.74000000f,-0.79000000f,-0.82000000f,0.44000000f,-0.91000000f,-0.61000000f,-0.99000000f,0.61000000f,-0.19000000f,0.14000000f,-0.46000000f,-0.33000000f,0.93000000f,0.29000000f,0.68000000f,-0.45000000f,0.47000000f,0.19000000f,-0.48000000f,0.03000000f,-0.10000000f,0.73000000f,-0.99000000f,0.72000000f,-0.58000000f,0.45000000f,-0.83000000f,0.07000000f,0.58000000f,0.02000000f,0.60000000f,0.71000000f,0.75000000f,-0.36000000f,0.19000000f,0.92000000f,-0.90000000f,-0.66000000f,0.57000000f,0.38000000f,0.86000000f,0.61000000f,0.31000000f,0.47000000f,-0.14000000f,-0.15000000f,0.27000000f,0.48000000f,0.44000000f,-0.45000000f,-0.83000000f,0.11000000f,0.96000000f,-0.38000000f,-0.12000000f,-0.72000000f,0.07000000f,-0.10000000f,-0.62000000f,0.21000000f,-0.33000000f,0.18000000f,0.18000000f,-0.50000000f,0.15000000f,0.38000000f,0.29000000f,-0.67000000f,-0.16000000f,-0.61000000f,0.36000000f,-0.50000000f,-0.87000000f,0.41000000f,0.41000000f,0.03000000f,0.71000000f,0.75000000f,-0.02000000f,0.13000000f,0.93000000f,0.51000000f,-0.86000000f,-0.43000000f,-0.97000000f,0.16000000f,-0.95000000f,-0.21000000f,-0.15000000f,-0.43000000f,0.53000000f,0.17000000f,0.18000000f,0.12000000f,-0.76000000f,0.56000000f,-0.71000000f,0.25000000f,-0.03000000f,-0.95000000f,0.65000000f,0.11000000f,0.29000000f,0.14000000f,0.04000000f,0.02000000f,-0.20000000f,-0.39000000f,0.23000000f,0.59000000f,0.07000000f,0.73000000f,-0.75000000f,0.67000000f,0.71000000f,-0.11000000f,-0.30000000f,0.26000000f,-0.93000000f,-0.01000000f,0.18000000f,-0.04000000f,-0.73000000f,-0.61000000f,-0.07000000f,0.00000000f,-0.68000000f,-0.58000000f,-0.95000000f,-0.51000000f,0.68000000f,-0.87000000f,0.07000000f,0.21000000f,0.87000000f,0.65000000f,-0.89000000f,0.57000000f,-0.48000000f,0.53000000f,-0.35000000f,-0.61000000f,-0.55000000f,0.62000000f,0.58000000f,-0.68000000f,-0.52000000f,0.33000000f,0.02000000f,0.74000000f,0.03000000f,0.44000000f,0.84000000f,-0.90000000f,-0.02000000f,-0.54000000f,0.55000000f,-0.24000000f,0.63000000f,0.31000000f,-0.67000000f,0.51000000f,0.67000000f,0.85000000f,0.68000000f,0.61000000f,0.04000000f,0.09000000f,0.70000000f,0.35000000f,-0.06000000f,-0.06000000f,-0.49000000f,0.81000000f,-0.24000000f,-0.70000000f,0.44000000f,0.18000000f,0.12000000f,0.17000000f,0.28000000f,0.26000000f,0.81000000f,-0.24000000f,-0.64000000f,0.32000000f,0.49000000f,-0.06000000f,0.13000000f,0.56000000f,-0.17000000f,-0.28000000f,-0.50000000f,0.89000000f,-0.20000000f,-0.34000000f,0.05000000f,0.71000000f,-0.09000000f,0.02000000f,-0.43000000f,-0.00000000f,-0.07000000f,0.25000000f,0.80000000f,0.18000000f,-0.37000000f,-0.16000000f,-0.42000000f,0.33000000f,0.76000000f,-0.81000000f,0.79000000f,0.88000000f,-0.62000000f,-0.49000000f,-0.79000000f,0.16000000f,0.19000000f,0.37000000f,-0.62000000f,-0.72000000f,-0.37000000f,0.39000000f,-0.84000000f,-0.13000000f,0.21000000f,0.88000000f,-0.80000000f,-0.06000000f,0.28000000f,-0.13000000f,-0.83000000f,-0.91000000f,-0.39000000f,0.19000000f,-0.71000000f,-0.08000000f,0.96000000f,0.89000000f,-0.60000000f,-0.79000000f,-0.13000000f,-0.00000000f,0.03000000f,0.97000000f,0.70000000f,-0.96000000f,-0.50000000f,-0.39000000f,0.13000000f,0.09000000f,0.29000000f,-0.43000000f,-0.40000000f,-0.83000000f,0.51000000f,-0.32000000f,-0.53000000f,0.07000000f,0.35000000f,0.43000000f,-0.65000000f,-0.94000000f,0.40000000f,-0.59000000f,0.80000000f,-0.15000000f,-0.22000000f,0.56000000f,0.90000000f,-0.82000000f,-0.74000000f,0.04000000f,-0.24000000f,-0.97000000f,0.96000000f,0.78000000f,0.29000000f,-0.44000000f,0.62000000f,0.92000000f,0.05000000f,-0.74000000f,-0.49000000f,-0.25000000f,0.34000000f,-0.99000000f,0.78000000f,-0.64000000f,0.09000000f,-0.51000000f,0.99000000f,-0.20000000f,0.95000000f,0.13000000f,-0.44000000f,-0.90000000f,-0.82000000f,0.84000000f,0.26000000f,-0.90000000f,0.97000000f,-0.09000000f,0.45000000f,-0.49000000f,0.29000000f,0.13000000f,0.37000000f,-0.03000000f,0.41000000f,-0.47000000f,0.25000000f,0.44000000f,0.31000000f,0.72000000f,0.09000000f,0.67000000f,0.76000000f,-0.79000000f,-0.99000000f,0.62000000f,-0.71000000f,-0.07000000f,0.63000000f,-0.02000000f,-0.28000000f,-0.02000000f,0.98000000f,0.28000000f,0.48000000f,-0.49000000f,0.32000000f,-0.11000000f,-0.45000000f,0.37000000f,-0.58000000f,-0.82000000f,-0.23000000f,-0.55000000f,-0.61000000f,-0.87000000f,-0.96000000f,-0.34000000f,-0.03000000f,-0.15000000f,-0.15000000f,-0.30000000f,-0.53000000f,0.83000000f,0.20000000f,-0.19000000f,-0.19000000f,0.23000000f,0.45000000f,0.50000000f,-0.67000000f,0.71000000f,-0.97000000f,0.42000000f,-0.33000000f,-0.88000000f,0.56000000f,0.78000000f,-0.09000000f,0.17000000f,0.77000000f,0.95000000f,-0.80000000f,-0.72000000f,0.23000000f,0.39000000f,-0.72000000f,-0.15000000f,-0.79000000f,-0.97000000f,0.97000000f,-0.20000000f,-0.56000000f,-0.95000000f,-0.65000000f,0.71000000f,-0.42000000f,0.10000000f,-0.58000000f,-0.14000000f,0.39000000f,-0.95000000f,-0.71000000f,-0.67000000f,0.62000000f,-0.10000000f,-0.11000000f,-0.76000000f,-0.30000000f,-0.62000000f,0.63000000f,-0.11000000f,-0.48000000f,0.37000000f,-0.08000000f,0.73000000f,-0.84000000f,-0.07000000f,-0.82000000f,-0.93000000f,0.63000000f,0.17000000f,-0.58000000f,-0.17000000f,0.83000000f,0.78000000f,-0.49000000f,-0.41000000f,0.29000000f,-0.90000000f,0.78000000f,-0.97000000f,-0.67000000f,0.47000000f,0.64000000f,-0.57000000f,0.89000000f,0.29000000f,-0.24000000f,0.75000000f,0.61000000f,0.45000000f,0.42000000f,0.16000000f,-0.75000000f,0.31000000f,0.66000000f,-0.04000000f,0.11000000f,-0.22000000f,-0.63000000f,-0.81000000f,0.48000000f,0.40000000f,-0.43000000f,0.37000000f,0.58000000f,0.18000000f,0.27000000f,-0.84000000f,0.31000000f,0.67000000f,-0.23000000f,0.74000000f,0.87000000f,-0.60000000f,-0.90000000f,-0.43000000f,0.07000000f,-0.58000000f,-0.01000000f,0.06000000f,-0.57000000f,-0.48000000f,-0.80000000f,0.30000000f,-0.69000000f,-0.37000000f,0.45000000f,0.85000000f,-0.17000000f,0.84000000f,-0.86000000f,0.36000000f,0.30000000f,0.49000000f,0.19000000f,-0.40000000f,-0.68000000f,-0.49000000f,0.61000000f,-0.07000000f,0.25000000f,-0.84000000f,0.42000000f,-0.23000000f,-0.28000000f,0.86000000f,-0.37000000f,0.13000000f,-0.29000000f,-0.93000000f,-0.28000000f,0.23000000f,0.25000000f,0.86000000f,0.33000000f,0.75000000f,0.75000000f,-0.61000000f,0.43000000f,0.09000000f,0.24000000f,-0.80000000f,-0.34000000f,-0.64000000f,0.25000000f,-0.07000000f,0.78000000f,0.29000000f,0.12000000f,0.28000000f,-0.72000000f,-0.72000000f,-0.70000000f,0.23000000f,-0.30000000f,-0.07000000f,-0.94000000f,0.97000000f,0.08000000f,-0.97000000f,0.20000000f,0.70000000f,0.38000000f,0.92000000f,-0.91000000f,-0.93000000f,-0.13000000f,0.05000000f,-0.56000000f,0.15000000f,-0.45000000f,-0.39000000f,-0.53000000f,0.25000000f,0.74000000f,0.85000000f,0.91000000f,0.25000000f,0.75000000f,0.32000000f,0.86000000f,0.99000000f,0.84000000f,0.17000000f,0.38000000f,0.16000000f,0.26000000f,0.37000000f,0.41000000f,-0.36000000f,-0.00000000f,-0.09000000f,0.70000000f,-0.40000000f,0.15000000f,0.76000000f,-0.17000000f,0.40000000f,-0.06000000f,0.14000000f,0.50000000f,-0.91000000f,0.44000000f,0.06000000f,0.30000000f,0.86000000f,0.45000000f,-0.88000000f,-0.06000000f,0.92000000f,-0.39000000f,0.83000000f,0.04000000f,-0.04000000f,0.70000000f,0.99000000f,-0.96000000f,0.02000000f,-0.45000000f,0.47000000f,0.71000000f,-0.50000000f,0.08000000f,0.98000000f,0.30000000f,-0.60000000f,-0.66000000f,0.66000000f,-0.51000000f,-0.86000000f,0.54000000f,0.51000000f,-0.36000000f,-0.48000000f,0.59000000f,-0.93000000f,0.64000000f,0.49000000f,0.23000000f,-0.72000000f,0.82000000f,-0.81000000f,-0.51000000f,-0.06000000f,0.58000000f,0.45000000f,-0.41000000f,-0.60000000f,-0.08000000f,-0.07000000f,0.47000000f,-0.48000000f,0.85000000f,-0.36000000f,-0.92000000f,0.48000000f,-0.36000000f,-0.09000000f,0.09000000f,-0.57000000f,-0.98000000f,0.67000000f,-0.53000000f,0.50000000f,-0.12000000f,-0.62000000f,-0.85000000f,0.37000000f,-0.98000000f,0.56000000f,0.65000000f,0.51000000f,0.54000000f,0.73000000f,-0.89000000f,0.07000000f,0.52000000f,0.92000000f,-0.26000000f,-0.93000000f,-0.82000000f,0.75000000f,0.96000000f,0.26000000f,-0.21000000f,-0.40000000f,-0.88000000f,-0.38000000f,-0.21000000f,-0.43000000f,-0.77000000f,0.48000000f,-0.95000000f,0.40000000f,0.43000000f,-0.24000000f,-0.72000000f,0.49000000f,-0.78000000f,0.82000000f,-0.21000000f,-0.15000000f,-0.56000000f,-0.94000000f,-0.51000000f,-0.10000000f,0.36000000f,0.68000000f,-0.78000000f,0.09000000f,-0.15000000f,-0.55000000f,0.21000000f,-0.11000000f,0.53000000f,-0.23000000f,-0.85000000f,-0.50000000f,0.66000000f,0.44000000f,0.47000000f,0.61000000f,0.22000000f,0.79000000f,0.71000000f,-0.91000000f,0.70000000f,-0.12000000f,-0.78000000f,0.45000000f,-0.40000000f,0.82000000f,0.27000000f,0.39000000f,0.87000000f,-0.23000000f,-0.37000000f,-0.78000000f,-0.19000000f,0.45000000f,0.29000000f,-0.45000000f,-0.30000000f,0.17000000f,-0.70000000f,0.09000000f,-0.85000000f,-0.67000000f,0.41000000f,0.37000000f,-0.12000000f,0.83000000f,0.92000000f,0.70000000f,-0.23000000f,0.62000000f,0.84000000f,0.13000000f,-0.36000000f,0.75000000f,-0.47000000f,-0.93000000f,0.00000000f,-0.71000000f,0.22000000f,-0.13000000f,-0.19000000f,-0.03000000f,-0.94000000f,-0.56000000f,-0.88000000f,-0.27000000f,-0.48000000f,0.98000000f,0.73000000f,0.87000000f,0.10000000f,0.04000000f,0.34000000f,0.51000000f,-0.95000000f,0.84000000f,0.17000000f,0.13000000f,-0.39000000f,0.37000000f,0.89000000f,-0.04000000f,-0.53000000f,-0.38000000f,0.00000000f,-0.00000000f,0.72000000f,0.08000000f,0.32000000f,0.69000000f,0.80000000f,0.00000000f,-0.12000000f,-0.79000000f,-0.75000000f,0.04000000f,-0.45000000f,0.08000000f,-0.96000000f,-0.95000000f,-0.44000000f,0.98000000f,0.10000000f,-0.28000000f,0.99000000f,-0.07000000f,0.53000000f,-0.86000000f,-0.01000000f,0.29000000f,-0.78000000f,-0.01000000f,0.22000000f,0.18000000f,-0.24000000f,-0.89000000f,0.12000000f,-0.67000000f,0.06000000f,-0.02000000f,-0.41000000f,-0.00000000f,0.91000000f,0.40000000f,-0.20000000f,0.25000000f,-0.08000000f,0.04000000f,0.42000000f,0.40000000f,0.39000000f,-0.22000000f,-0.23000000f,0.28000000f,0.48000000f,-0.72000000f,-0.85000000f,-0.22000000f,0.69000000f,-0.25000000f,-0.85000000f,-0.56000000f,0.80000000f,-0.91000000f,0.69000000f,-0.69000000f,0.86000000f,0.94000000f,0.87000000f,-0.47000000f,0.30000000f,-0.51000000f,-0.52000000f,0.74000000f,-0.43000000f,0.03000000f,-0.79000000f,0.76000000f,0.39000000f,0.00000000f,0.32000000f,-0.43000000f,-0.43000000f,-0.27000000f,0.08000000f,-0.20000000f,0.18000000f,0.01000000f,-0.12000000f,-0.22000000f,-0.64000000f,-0.56000000f,0.72000000f,-0.10000000f,-0.52000000f,-0.23000000f,0.93000000f,0.39000000f,0.14000000f,0.23000000f,0.81000000f,-0.37000000f,0.52000000f,-0.10000000f,-0.16000000f,-0.90000000f,0.35000000f,0.18000000f,-0.89000000f,0.72000000f,0.91000000f,-0.03000000f,-0.67000000f,0.43000000f,0.97000000f,-0.32000000f,-0.40000000f,0.85000000f,-0.25000000f,0.71000000f,-0.60000000f,0.71000000f,0.84000000f,0.20000000f,-0.97000000f,-0.66000000f,0.18000000f,0.71000000f,-0.29000000f,-0.73000000f,0.62000000f,0.76000000f,-0.12000000f,-0.80000000f,0.61000000f,0.38000000f,0.74000000f,0.44000000f,0.60000000f,0.23000000f,0.11000000f,-0.06000000f,-0.09000000f,-0.33000000f,-0.38000000f,0.17000000f,0.57000000f,0.91000000f,0.83000000f,0.89000000f,0.88000000f,0.83000000f,0.71000000f,0.97000000f,0.93000000f,0.23000000f,-0.36000000f,-0.21000000f,-0.77000000f,0.14000000f,0.52000000f,-0.48000000f,-0.21000000f,-0.86000000f,-0.39000000f,0.68000000f,0.46000000f,0.48000000f,0.09000000f,-0.10000000f,0.83000000f,0.63000000f,0.53000000f,0.40000000f,0.05000000f,-0.92000000f,0.61000000f,0.23000000f,0.23000000f,-0.49000000f,-0.12000000f,-0.88000000f,-0.03000000f,0.50000000f,-0.27000000f,0.44000000f,-0.59000000f,-0.50000000f,0.93000000f,-0.52000000f,-0.06000000f,-0.02000000f,0.57000000f,0.75000000f,0.56000000f,0.34000000f,-0.71000000f,-0.04000000f,-0.25000000f,0.81000000f,0.77000000f,-0.40000000f,0.69000000f,0.26000000f,0.86000000f,0.32000000f,0.69000000f,-0.64000000f,-0.75000000f,0.73000000f,-0.40000000f,-0.57000000f,0.95000000f,0.03000000f,-0.51000000f,0.15000000f,-0.25000000f,0.87000000f,0.23000000f,-0.61000000f,-0.37000000f,-0.44000000f,-0.04000000f,-0.84000000f,-0.07000000f,0.27000000f,-0.33000000f,0.68000000f,-0.59000000f,0.32000000f,0.06000000f,-0.80000000f,-0.47000000f,0.09000000f,-0.61000000f,-0.85000000f,-0.77000000f,0.78000000f,0.86000000f,-0.75000000f,-0.45000000f,-0.10000000f,-0.68000000f,-0.30000000f,-0.40000000f,0.83000000f,0.62000000f,0.97000000f,-0.71000000f,0.50000000f,-0.15000000f,-0.06000000f,0.99000000f,0.68000000f,-0.45000000f,0.81000000f,-0.82000000f,0.87000000f,-0.65000000f,-0.68000000f,-0.97000000f,0.68000000f,0.64000000f,0.19000000f,0.23000000f,0.51000000f,-0.96000000f,0.16000000f,0.05000000f,0.82000000f,-0.70000000f,0.08000000f,-0.13000000f,0.80000000f,0.87000000f,0.47000000f,0.27000000f,0.38000000f,0.27000000f,-0.61000000f,-0.63000000f,0.60000000f,0.91000000f,-0.03000000f,-0.65000000f,-0.26000000f,-0.59000000f,-0.08000000f,-0.00000000f,0.55000000f,-0.30000000f,0.28000000f,-0.81000000f,0.32000000f,-0.92000000f,-0.34000000f,0.55000000f,0.25000000f,-0.46000000f,0.93000000f,0.34000000f,0.69000000f,-0.59000000f,0.79000000f,0.95000000f,0.97000000f,0.91000000f,-0.53000000f,0.89000000f,0.29000000f,-0.23000000f,-0.49000000f,0.14000000f,-0.53000000f,0.22000000f,0.87000000f,0.10000000f,0.42000000f,0.31000000f,0.98000000f,-0.18000000f,-0.89000000f,-0.98000000f,-0.20000000f,0.31000000f,-0.54000000f,0.32000000f,-0.14000000f,0.16000000f,-0.24000000f,-0.77000000f,0.15000000f,0.76000000f,0.80000000f,0.70000000f,0.93000000f,-0.55000000f,0.25000000f,0.39000000f,0.16000000f,-0.80000000f,-0.64000000f,-0.51000000f,-0.48000000f,0.75000000f,0.50000000f,0.19000000f,-0.42000000f,-0.42000000f,0.75000000f,0.06000000f,0.61000000f,-0.75000000f,0.65000000f,0.27000000f,-0.72000000f,-0.20000000f,0.81000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.56000000f,-0.15000000f,-0.37000000f,0.38000000f,0.83000000f,-0.76000000f,-0.00000000f,-0.95000000f,0.99000000f,-0.51000000f,-0.06000000f,-0.47000000f,0.92000000f,0.03000000f,0.52000000f,-0.67000000f,0.73000000f,0.59000000f,-0.32000000f,-0.97000000f,0.41000000f,-0.37000000f,0.25000000f,0.77000000f,-0.40000000f,-0.01000000f,-0.95000000f,0.77000000f,-0.31000000f,-0.99000000f,-0.23000000f,-0.38000000f,-0.77000000f,-0.15000000f,-0.75000000f,-0.79000000f,0.85000000f,-0.56000000f,-0.80000000f,0.15000000f,0.75000000f,0.69000000f,-0.70000000f,-0.72000000f,-0.83000000f,0.16000000f,0.83000000f,0.95000000f,-0.33000000f,-0.16000000f,-0.56000000f,-0.36000000f,-0.94000000f,0.37000000f,0.51000000f,-0.95000000f,0.92000000f,-0.86000000f,0.88000000f,-0.63000000f,0.77000000f,0.12000000f,0.54000000f,0.99000000f,0.08000000f,0.38000000f,-0.42000000f,0.86000000f,-0.13000000f,0.45000000f,0.75000000f,0.10000000f,0.56000000f,0.78000000f,0.06000000f,-0.93000000f,0.77000000f,-0.47000000f,0.86000000f,-0.34000000f,-0.34000000f,0.61000000f,0.12000000f,-0.56000000f,0.64000000f,0.58000000f,-0.56000000f,0.32000000f,0.01000000f,-0.35000000f,0.10000000f,0.59000000f,-0.40000000f,0.19000000f,-0.02000000f,-0.53000000f,0.87000000f,-0.31000000f,-0.39000000f,0.80000000f,-0.53000000f,0.84000000f,0.69000000f,0.34000000f,0.46000000f,0.61000000f,-0.38000000f,0.85000000f,-0.38000000f,-0.90000000f,-0.57000000f,0.74000000f,0.21000000f,0.13000000f,-0.87000000f,-0.57000000f,-0.81000000f,-0.75000000f,-0.14000000f,0.99000000f,-0.49000000f,-0.65000000f,0.61000000f,-0.58000000f,-0.04000000f,-0.63000000f,-0.96000000f,-0.75000000f,-0.67000000f,-0.72000000f,-0.33000000f,0.50000000f,-0.01000000f,0.64000000f,0.97000000f,-0.08000000f,-0.34000000f,-0.84000000f,0.38000000f,-0.16000000f,0.42000000f,0.96000000f,0.80000000f,-0.53000000f,0.53000000f,0.51000000f,0.77000000f,-0.04000000f,-0.06000000f,0.65000000f,0.72000000f,0.82000000f,0.77000000f,-0.53000000f,-0.66000000f,-0.43000000f,0.95000000f,0.20000000f,0.14000000f,-0.27000000f,-0.13000000f,0.39000000f,-0.77000000f,0.07000000f,-0.14000000f,0.93000000f,0.69000000f,-0.03000000f,0.89000000f,0.51000000f,-0.40000000f,-0.68000000f,0.42000000f,-0.46000000f,-0.50000000f,0.15000000f,-0.81000000f,0.32000000f,-0.10000000f,0.26000000f,-0.10000000f,0.35000000f,-0.33000000f,0.70000000f,-0.35000000f,0.79000000f,0.97000000f,0.01000000f,-0.77000000f,-0.44000000f,-0.24000000f,-0.93000000f,0.21000000f,-0.74000000f,-0.64000000f,-0.25000000f,-0.90000000f,-0.26000000f,0.64000000f,-0.33000000f,0.82000000f,-0.12000000f,0.56000000f,-0.18000000f,-0.78000000f,-0.82000000f,-0.21000000f,-0.84000000f,-0.81000000f,-0.26000000f,0.20000000f,0.74000000f,-0.56000000f,0.86000000f,-0.17000000f,-0.36000000f,-0.02000000f,-0.16000000f,0.21000000f,0.61000000f,0.65000000f,-0.48000000f,0.04000000f,-0.38000000f,0.32000000f,-0.72000000f,0.22000000f,-0.16000000f,0.44000000f,0.25000000f,-0.51000000f,-0.64000000f,0.43000000f,0.72000000f,-0.88000000f,0.97000000f,-0.27000000f,0.40000000f,0.36000000f,0.49000000f,0.38000000f,-0.53000000f,-0.08000000f,-0.06000000f,0.69000000f,-0.27000000f,0.05000000f,0.72000000f,-0.48000000f,0.74000000f,0.80000000f,0.23000000f,0.00000000f,-0.49000000f,-0.85000000f,-0.30000000f,-0.43000000f,0.14000000f,-0.06000000f,0.03000000f,-0.83000000f,0.91000000f,-0.72000000f,0.27000000f,0.42000000f,-0.63000000f,-0.54000000f,0.92000000f,-0.87000000f,-0.49000000f,0.40000000f,0.60000000f,-0.24000000f,0.66000000f,-0.65000000f,-0.67000000f,0.15000000f,0.70000000f,0.89000000f,-0.13000000f,0.81000000f,-0.52000000f,-0.82000000f,-0.58000000f,-0.20000000f,0.08000000f,-0.51000000f,0.18000000f,0.99000000f,-0.80000000f,0.22000000f,-0.17000000f,-0.72000000f,-0.72000000f,0.39000000f,0.81000000f,-0.36000000f,0.92000000f,-0.63000000f,0.36000000f,0.21000000f,0.00000000f,-0.27000000f,-0.72000000f,-0.47000000f,-0.69000000f,0.93000000f,-0.60000000f,0.98000000f,-0.28000000f,-0.69000000f,0.24000000f,-0.32000000f,-0.13000000f,-0.37000000f,0.66000000f,-0.68000000f,0.82000000f,0.23000000f,-0.45000000f,0.19000000f,-0.02000000f,0.90000000f,-0.77000000f,-0.87000000f,0.94000000f,-0.53000000f,0.95000000f,0.90000000f,0.17000000f,0.80000000f,-0.86000000f,0.67000000f,0.58000000f,-0.27000000f,-0.87000000f,-0.15000000f,0.99000000f,-0.65000000f,0.08000000f,0.34000000f,-0.46000000f,-0.94000000f,0.78000000f,0.10000000f,-0.95000000f,0.54000000f,0.46000000f,0.89000000f,0.01000000f,-0.33000000f,0.43000000f,-0.19000000f,-0.87000000f,0.36000000f,0.84000000f,0.70000000f,-0.93000000f,-0.95000000f,0.86000000f,-0.33000000f,-0.60000000f,0.31000000f,0.70000000f,-0.39000000f,0.01000000f,-0.43000000f,-0.11000000f,-0.42000000f,-0.76000000f,0.72000000f,0.33000000f,0.40000000f,0.43000000f,-0.19000000f,-0.49000000f,0.24000000f,-0.45000000f,-0.02000000f,-0.12000000f,-0.50000000f,-0.74000000f,-0.53000000f,0.09000000f,0.39000000f,0.53000000f,0.02000000f,0.14000000f,0.40000000f,-0.81000000f,-0.28000000f,-0.32000000f,-0.00000000f,0.51000000f,0.54000000f,-0.12000000f,-0.30000000f,0.97000000f,-0.04000000f,-0.42000000f,-0.96000000f,-0.39000000f,0.81000000f,0.93000000f,-0.55000000f,0.46000000f,-0.79000000f,-0.99000000f,-0.53000000f,0.00000000f,-0.28000000f,0.08000000f,0.22000000f,0.34000000f,0.03000000f,-0.89000000f,0.36000000f,0.80000000f,-0.68000000f,0.50000000f,-0.08000000f,0.04000000f,0.98000000f,-0.36000000f,-0.97000000f,0.46000000f,-0.02000000f,-0.20000000f,0.66000000f,-0.67000000f,0.58000000f,0.46000000f,-0.14000000f,-0.74000000f,-0.68000000f,-0.22000000f,0.93000000f,-0.86000000f,-0.58000000f,0.66000000f,-0.03000000f,0.40000000f,0.60000000f,-0.65000000f,0.20000000f,0.96000000f,-0.04000000f,0.91000000f,0.95000000f,-0.19000000f,0.04000000f,0.89000000f,0.70000000f,-0.99000000f,0.27000000f,-0.55000000f,0.79000000f,0.99000000f,0.94000000f,-0.16000000f,0.16000000f,0.74000000f,-0.84000000f,-0.91000000f,-0.15000000f,0.70000000f,0.95000000f,-0.19000000f,-0.72000000f,0.23000000f,0.98000000f,-0.77000000f,-0.58000000f,-0.97000000f,0.20000000f,-0.89000000f,0.94000000f,-0.96000000f,0.78000000f,0.17000000f,0.51000000f,0.91000000f,-0.58000000f,-0.90000000f,-0.48000000f,0.03000000f,0.06000000f,-0.58000000f,0.67000000f,0.70000000f,-0.68000000f,0.13000000f,-0.02000000f,0.04000000f,-0.33000000f,0.64000000f,-0.72000000f,0.01000000f,0.71000000f,0.37000000f,0.31000000f,-0.39000000f,0.91000000f,0.19000000f,-0.34000000f,0.45000000f,-0.68000000f,-0.26000000f,-0.78000000f,-0.74000000f,0.43000000f,-0.05000000f,-0.29000000f,-0.98000000f,-0.07000000f,0.61000000f,-0.93000000f,0.05000000f,-0.44000000f,0.44000000f,0.89000000f,-0.08000000f,0.19000000f,0.95000000f,0.90000000f,0.63000000f,0.25000000f,0.09000000f,0.90000000f,-0.66000000f,0.62000000f,0.72000000f,-0.28000000f,0.76000000f,-0.90000000f,0.37000000f,-0.25000000f,0.60000000f,0.92000000f,-0.75000000f,0.86000000f,-0.79000000f,0.17000000f,-0.11000000f,-0.21000000f,-0.99000000f,-0.41000000f,0.18000000f,-0.59000000f,-0.04000000f,0.92000000f,-0.20000000f,-0.82000000f,0.70000000f,0.18000000f,-0.08000000f,0.04000000f,0.84000000f,-0.48000000f,-0.46000000f,-0.94000000f,-0.55000000f,0.64000000f,0.10000000f,-0.74000000f,-0.66000000f,-0.16000000f,0.52000000f,0.33000000f,-0.41000000f,0.24000000f,0.94000000f,0.22000000f,-0.04000000f,-0.90000000f,0.91000000f,0.13000000f,0.46000000f,0.18000000f,-0.33000000f,-0.48000000f,-0.92000000f,-0.54000000f,-0.90000000f,-0.20000000f,0.58000000f,-0.45000000f,-0.52000000f,-0.50000000f,-0.42000000f,-0.18000000f,-0.49000000f,-0.71000000f,0.61000000f,-0.32000000f,0.82000000f,-0.17000000f,-0.82000000f,0.37000000f,-0.73000000f,-0.22000000f,0.97000000f,0.79000000f,0.43000000f,0.75000000f,0.82000000f,-0.88000000f,0.15000000f,0.04000000f,0.50000000f,-0.21000000f,-0.38000000f,0.63000000f,-0.45000000f,-0.39000000f,0.34000000f,0.20000000f,-0.46000000f,-0.24000000f,-0.44000000f,-0.82000000f,0.63000000f,-0.36000000f,-0.03000000f,-0.20000000f,-0.31000000f,-0.51000000f,-0.44000000f,0.03000000f,-0.28000000f,0.86000000f,-0.98000000f,0.67000000f,-0.01000000f,0.37000000f,-0.58000000f,0.83000000f,-0.71000000f,0.88000000f,0.94000000f,-0.97000000f,-0.02000000f,0.53000000f,-0.47000000f,0.43000000f,0.45000000f,0.66000000f,-0.41000000f,0.01000000f,0.66000000f,-0.73000000f,0.98000000f,-0.51000000f,-0.25000000f,0.10000000f,0.86000000f,-0.61000000f,-0.38000000f,0.24000000f,-0.37000000f,-0.76000000f,0.10000000f,0.41000000f,-0.40000000f,0.45000000f,-0.94000000f,0.06000000f,-0.34000000f,-0.77000000f,-0.49000000f,0.10000000f,0.60000000f,0.59000000f,-0.18000000f,-0.29000000f,0.16000000f,0.66000000f,-0.79000000f,0.31000000f,-0.15000000f,-0.36000000f,0.28000000f,-0.83000000f,-0.40000000f,0.79000000f,-0.79000000f,0.01000000f,-0.10000000f,-0.89000000f,0.89000000f,-0.73000000f,-0.94000000f,-0.25000000f,0.90000000f,0.02000000f,0.87000000f,-0.72000000f,0.14000000f,0.01000000f,0.14000000f,0.33000000f,0.70000000f,-0.23000000f,0.31000000f,0.47000000f,-0.99000000f,0.74000000f,-0.94000000f,-0.18000000f,0.29000000f,0.74000000f,0.41000000f,-0.62000000f,-0.55000000f,-0.23000000f,-0.92000000f,-0.83000000f,-0.04000000f,0.62000000f,-0.21000000f,0.18000000f,0.54000000f,0.10000000f,0.01000000f,-0.56000000f,0.20000000f,-0.27000000f,0.95000000f,-0.72000000f,-0.81000000f,-0.37000000f,0.04000000f,0.35000000f,-0.43000000f,0.74000000f,0.96000000f,-0.39000000f,-0.25000000f,0.84000000f,-0.96000000f,0.63000000f,-0.21000000f,0.38000000f,0.08000000f,-0.30000000f,-0.96000000f,0.62000000f,0.52000000f,0.88000000f,0.24000000f,0.20000000f,-0.98000000f,-0.19000000f,0.73000000f,-0.92000000f,-0.26000000f,0.98000000f,0.23000000f,0.02000000f,-0.56000000f,-0.67000000f,0.84000000f,0.80000000f,-0.99000000f,0.90000000f,0.08000000f,0.54000000f,-0.42000000f,0.12000000f,0.61000000f,-0.37000000f,-0.33000000f,0.96000000f,0.77000000f,-0.97000000f,0.69000000f,-0.03000000f,0.32000000f,-0.05000000f,0.38000000f,-0.13000000f,-0.67000000f,-0.29000000f,0.78000000f,0.49000000f,0.06000000f,-0.80000000f,-0.11000000f,0.67000000f,0.22000000f,-0.76000000f,-0.30000000f,-0.78000000f,0.35000000f,0.64000000f,-0.14000000f,-0.56000000f,0.01000000f,-0.67000000f,-0.73000000f,-0.00000000f,0.49000000f,0.49000000f,-0.48000000f,-0.61000000f,0.93000000f,-0.05000000f,0.14000000f,0.47000000f,-0.07000000f,0.83000000f,0.97000000f,0.07000000f,-0.41000000f,-0.19000000f,0.17000000f,0.62000000f,0.58000000f,-0.37000000f,0.48000000f,-0.62000000f,-0.36000000f,0.94000000f,0.07000000f,-0.83000000f,0.49000000f,-0.81000000f,-0.77000000f,-0.21000000f,0.15000000f,-0.48000000f,-0.65000000f,0.88000000f,0.58000000f,0.74000000f,-0.88000000f,-0.78000000f,0.70000000f,-0.18000000f,0.37000000f,-0.84000000f,-0.49000000f,-0.39000000f,0.98000000f,0.06000000f,0.25000000f,0.97000000f,0.39000000f,0.38000000f,-0.67000000f,-0.52000000f,0.65000000f,-0.66000000f,-0.53000000f,0.38000000f,-0.30000000f,-0.51000000f,0.07000000f,-0.07000000f,0.01000000f,0.73000000f,0.38000000f,0.47000000f,-0.56000000f,0.44000000f,0.78000000f,-0.98000000f,-0.99000000f,-0.31000000f,-0.72000000f,0.91000000f,0.18000000f,-0.84000000f,-0.40000000f,-0.53000000f,0.33000000f,0.13000000f,0.37000000f,0.01000000f,0.81000000f,0.00000000f,-0.19000000f,-0.02000000f,-0.73000000f,0.65000000f,0.84000000f,-0.01000000f,0.16000000f,-0.07000000f,0.64000000f,0.22000000f,0.06000000f,0.49000000f,-0.28000000f,-0.84000000f,0.81000000f,-0.94000000f,0.32000000f,-0.07000000f,0.09000000f,0.95000000f,0.99000000f,-0.56000000f,0.64000000f,0.83000000f,0.51000000f,-0.93000000f,0.18000000f,-0.50000000f,0.38000000f,-0.07000000f,0.93000000f,0.63000000f,-0.29000000f,0.87000000f,-0.04000000f,0.63000000f,0.70000000f,-0.76000000f,0.02000000f,0.02000000f,-0.88000000f,-0.63000000f,-0.18000000f,-0.30000000f,-0.48000000f,-0.42000000f,0.93000000f,0.01000000f,0.36000000f,0.97000000f,-0.25000000f,0.93000000f,0.16000000f,0.46000000f,-0.31000000f,-0.32000000f,0.20000000f,0.43000000f,-0.93000000f,0.09000000f,0.97000000f,0.53000000f,-0.86000000f,-0.33000000f,0.77000000f,0.58000000f,-0.11000000f,0.55000000f,0.94000000f,-0.42000000f,-0.48000000f,0.05000000f,0.15000000f,0.58000000f,-0.59000000f,-0.41000000f,-0.53000000f,0.05000000f,0.96000000f,0.00000000f,0.60000000f,0.56000000f,-0.18000000f,0.49000000f,-0.44000000f,0.47000000f,-0.67000000f,-0.85000000f,0.91000000f,-0.28000000f,-0.17000000f,0.62000000f,-0.96000000f,0.81000000f,0.12000000f,0.54000000f,-0.52000000f,-0.12000000f,-0.28000000f,0.82000000f,0.02000000f,-0.11000000f,-0.51000000f,-0.45000000f,0.20000000f,0.69000000f,0.07000000f,0.48000000f,-0.48000000f,-0.01000000f,0.33000000f,0.64000000f,0.15000000f,-0.79000000f,-0.11000000f,0.28000000f,0.48000000f,0.58000000f,0.95000000f,-0.89000000f,0.01000000f,-0.16000000f,-0.66000000f,-0.92000000f,0.89000000f,-0.34000000f,0.50000000f,-0.28000000f,0.08000000f,-0.74000000f,0.29000000f,-0.02000000f,0.68000000f,0.15000000f,0.95000000f,0.21000000f,-0.58000000f,-0.11000000f,0.64000000f,0.73000000f,0.87000000f,-0.96000000f,-0.64000000f,-0.60000000f,-0.79000000f,0.35000000f,-0.54000000f,-0.65000000f,0.14000000f,-0.48000000f,0.02000000f,0.36000000f,-0.45000000f,0.07000000f,0.58000000f,0.62000000f,0.73000000f,-0.92000000f,0.71000000f,-0.73000000f,-0.58000000f,-0.10000000f,0.95000000f,-0.81000000f,0.05000000f,-0.40000000f,-0.70000000f,0.03000000f,-0.45000000f,0.88000000f,-0.89000000f,0.37000000f,-0.30000000f,-0.37000000f,0.07000000f,0.28000000f,-0.11000000f,-0.38000000f,0.32000000f,0.78000000f,0.21000000f,0.43000000f,0.77000000f,-0.57000000f,0.40000000f,-0.93000000f,0.16000000f,-0.66000000f,-0.66000000f,-0.82000000f,-0.13000000f,-0.69000000f,0.77000000f,0.54000000f,0.69000000f,-0.54000000f,0.29000000f,-0.77000000f,0.14000000f,0.25000000f,-0.14000000f,-0.98000000f,0.36000000f,0.00000000f,-0.17000000f,-0.07000000f,-0.25000000f,0.25000000f,-0.30000000f,-0.53000000f,0.79000000f,0.08000000f,-0.80000000f,-0.05000000f,-0.87000000f,0.22000000f,0.35000000f,0.32000000f,0.09000000f,-0.44000000f,-0.82000000f,0.77000000f,-0.17000000f,0.47000000f,-0.89000000f,-0.83000000f,0.33000000f,0.20000000f,0.93000000f,-0.44000000f,0.89000000f,-0.27000000f,-0.95000000f,0.03000000f,-0.23000000f,0.34000000f,0.35000000f,-0.22000000f,0.56000000f,-0.36000000f,0.20000000f,0.86000000f,-0.18000000f,-0.11000000f,-0.27000000f,-0.87000000f,-0.52000000f,-0.85000000f,-0.71000000f,-0.07000000f,-0.42000000f,-0.73000000f,-0.72000000f,-0.45000000f,0.21000000f,0.22000000f,0.35000000f,-0.67000000f,0.47000000f,-0.17000000f,-0.72000000f,-0.48000000f,0.64000000f,0.68000000f,-0.06000000f,-0.60000000f,-0.82000000f,0.84000000f,0.16000000f,0.49000000f,-0.16000000f,-0.57000000f,-0.16000000f,-0.86000000f,0.05000000f,-0.91000000f,-0.02000000f,0.11000000f,0.91000000f,0.64000000f,-0.68000000f,0.93000000f,-0.25000000f,-0.46000000f,0.70000000f,0.87000000f,0.97000000f,-0.75000000f,0.73000000f,-0.70000000f,0.63000000f,-0.08000000f,0.94000000f,0.84000000f,-0.55000000f,0.29000000f,-0.75000000f,-0.18000000f,0.15000000f,0.41000000f,0.33000000f,0.81000000f,-0.95000000f,-0.12000000f,-0.47000000f,0.19000000f,-0.12000000f,-0.49000000f,0.34000000f,0.23000000f,0.36000000f,0.51000000f,-0.45000000f,-0.97000000f,0.09000000f,-0.47000000f,0.54000000f,0.32000000f,0.46000000f,0.90000000f,-0.58000000f,-0.87000000f,-0.48000000f,-0.91000000f,-0.72000000f,-0.19000000f,-0.93000000f,0.30000000f,0.91000000f,-0.78000000f,-0.46000000f,0.19000000f,0.90000000f,-0.22000000f,-0.43000000f,0.56000000f,-0.42000000f,0.99000000f,-0.46000000f,0.18000000f,-0.75000000f,-0.77000000f,0.85000000f,-0.99000000f,0.10000000f,-0.92000000f,0.68000000f,-0.07000000f,-0.81000000f,-0.57000000f,-0.57000000f,-0.31000000f,0.74000000f,-0.01000000f,0.38000000f,0.00000000f,0.05000000f,-0.85000000f,-0.28000000f,0.91000000f,-0.78000000f,0.53000000f,0.02000000f,-0.12000000f,-0.90000000f,0.21000000f,-0.22000000f,-0.01000000f,-0.87000000f,0.45000000f,-0.37000000f,0.09000000f,0.90000000f,0.15000000f,-0.14000000f,0.66000000f,0.32000000f,0.18000000f,0.87000000f,0.74000000f,-0.35000000f,0.95000000f,0.23000000f,-0.89000000f,-0.81000000f,0.95000000f,0.96000000f,-0.43000000f,0.57000000f,-0.16000000f,-0.82000000f,-0.00000000f,-0.64000000f,0.18000000f,0.01000000f,0.19000000f,-0.90000000f,-0.55000000f,0.31000000f,0.41000000f,-0.41000000f,-0.31000000f,-0.32000000f,-0.65000000f,0.08000000f,0.77000000f,0.24000000f,-0.26000000f,0.39000000f,-0.72000000f,0.75000000f,-0.49000000f,0.19000000f,0.58000000f,0.55000000f,-0.71000000f,-0.12000000f,0.96000000f,-0.78000000f,0.73000000f,0.10000000f,-0.31000000f,0.25000000f,0.78000000f,-0.70000000f,-0.11000000f,-0.87000000f,-0.00000000f,0.66000000f,0.26000000f,0.80000000f,-0.21000000f,-0.94000000f,-0.99000000f,0.94000000f,0.78000000f,0.97000000f,-0.41000000f,-0.27000000f,0.23000000f,-0.20000000f,-0.32000000f,-0.86000000f,0.51000000f,0.67000000f,0.95000000f,0.71000000f,-0.63000000f,-0.26000000f,-0.20000000f,0.79000000f,0.34000000f,0.42000000f,0.27000000f,-0.49000000f,0.99000000f,0.59000000f,-0.09000000f,-0.23000000f,-0.10000000f,0.11000000f,-0.37000000f,-0.99000000f,0.73000000f,0.81000000f,-0.38000000f,-0.57000000f,0.90000000f,0.85000000f,-0.21000000f,-0.73000000f,0.74000000f,0.42000000f,-0.77000000f,-0.04000000f,0.16000000f,0.88000000f,-0.27000000f,-0.34000000f,-0.83000000f,-0.91000000f,-0.47000000f,0.18000000f,-0.06000000f,0.40000000f,-0.10000000f,-0.74000000f,-0.45000000f,-0.24000000f,-0.27000000f,-0.44000000f,-0.49000000f,-0.96000000f,-0.46000000f,-0.12000000f,0.76000000f,0.75000000f,-0.11000000f,-0.96000000f,0.54000000f,0.00000000f,-0.26000000f,0.81000000f,0.79000000f,0.67000000f,0.20000000f,0.69000000f,0.68000000f,0.01000000f,0.17000000f,-0.84000000f,-0.28000000f,-0.05000000f,0.49000000f,0.09000000f,0.12000000f,-0.30000000f,-0.02000000f,-0.02000000f,-0.62000000f,-0.12000000f,0.76000000f,-0.24000000f,0.86000000f,0.36000000f,0.36000000f,0.25000000f,-0.34000000f,-0.57000000f,0.92000000f,-0.72000000f,0.05000000f,0.76000000f,-0.36000000f,-0.54000000f,-0.03000000f,-0.66000000f,-0.95000000f,0.52000000f,0.87000000f,0.11000000f,0.17000000f,-0.88000000f,-0.37000000f,-0.13000000f,0.18000000f,0.03000000f,0.50000000f,0.59000000f,-0.15000000f,0.36000000f,0.72000000f,0.49000000f,0.62000000f,-0.12000000f,-0.69000000f,0.15000000f,0.80000000f,0.63000000f,-0.97000000f,0.19000000f,0.59000000f,0.38000000f,-0.14000000f,-0.72000000f,-0.71000000f,-0.08000000f,-0.36000000f,-0.23000000f,0.56000000f,0.34000000f,0.14000000f,0.68000000f,-0.90000000f,-0.15000000f,0.32000000f,0.08000000f,-0.87000000f,-0.89000000f,-0.93000000f,0.39000000f,0.30000000f,0.54000000f,-0.86000000f,-0.32000000f,-0.45000000f,-0.09000000f,-0.10000000f,0.37000000f,0.18000000f,-0.83000000f,-0.38000000f,-0.53000000f,-0.67000000f,0.98000000f,-0.29000000f,-0.03000000f,-0.30000000f,0.90000000f,-0.58000000f,0.39000000f,-0.29000000f,0.10000000f,0.11000000f,0.04000000f,0.80000000f,0.21000000f,0.08000000f,0.00000000f,0.50000000f,-0.25000000f,0.75000000f,0.26000000f,0.28000000f,0.26000000f,-0.59000000f,0.56000000f,0.68000000f,0.02000000f,0.55000000f,0.81000000f,-0.78000000f,0.14000000f,0.90000000f,-0.15000000f,0.48000000f,-0.74000000f,-0.61000000f,0.31000000f,0.72000000f,-0.82000000f,0.28000000f,0.27000000f,0.82000000f,-0.67000000f,0.90000000f,-0.88000000f,0.56000000f,-0.29000000f,0.05000000f,-0.46000000f,0.67000000f,-0.21000000f,-0.33000000f,0.28000000f,0.43000000f,-0.95000000f,0.88000000f,0.97000000f,0.41000000f,-0.68000000f,0.30000000f,0.04000000f,-0.77000000f,0.14000000f,-0.67000000f,-0.96000000f,0.01000000f,-0.92000000f,-0.55000000f,0.44000000f,-0.70000000f,-0.70000000f,0.37000000f,-0.07000000f,0.39000000f,-0.12000000f,-0.27000000f,-0.71000000f,0.06000000f,0.28000000f,0.92000000f,-0.79000000f,-0.82000000f,0.52000000f,0.26000000f,-0.21000000f,0.82000000f,-0.49000000f,0.88000000f,0.47000000f,0.45000000f,0.31000000f,0.44000000f,-0.98000000f,-0.23000000f,0.44000000f,0.13000000f,0.61000000f,-0.20000000f,-0.23000000f,-0.61000000f,-0.34000000f,0.35000000f,0.56000000f,-0.16000000f,0.57000000f,-0.46000000f,-0.56000000f,-0.92000000f,-0.31000000f,0.97000000f,-0.25000000f,-0.48000000f,-0.94000000f,0.74000000f,0.02000000f,-0.61000000f,-0.71000000f,0.57000000f,0.77000000f,0.33000000f,-0.52000000f,0.38000000f,0.78000000f,-0.79000000f,0.20000000f,-0.52000000f,0.44000000f,-0.45000000f,-0.36000000f,-0.93000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.84000000f,-0.83000000f,-0.72000000f,0.39000000f,0.32000000f,-0.87000000f,0.58000000f,-0.47000000f,0.08000000f,0.08000000f,-0.55000000f,0.22000000f,0.63000000f,0.21000000f,-0.15000000f,0.08000000f,-0.79000000f,-0.42000000f,0.49000000f,-0.89000000f,0.14000000f,-0.24000000f,-0.42000000f,0.34000000f,-0.20000000f,-0.26000000f,0.90000000f,0.98000000f,0.89000000f,-0.73000000f,-0.21000000f,-0.73000000f,0.36000000f,-0.51000000f,0.56000000f,-0.67000000f,0.65000000f,0.82000000f,0.39000000f,0.18000000f,0.76000000f,-0.26000000f,-0.75000000f,-0.83000000f,-0.94000000f,-0.04000000f,-0.80000000f,-0.89000000f,0.68000000f,-0.48000000f,-0.50000000f,0.75000000f,0.22000000f,0.87000000f,-0.06000000f,0.40000000f,-0.40000000f,-0.13000000f,0.17000000f,-0.01000000f,-0.40000000f,0.75000000f,0.42000000f,0.77000000f,0.28000000f,-0.41000000f,0.12000000f,0.55000000f,0.72000000f,-0.48000000f,-0.71000000f,0.75000000f,-0.18000000f,-0.51000000f,0.55000000f,0.35000000f,0.57000000f,0.03000000f,0.86000000f,0.52000000f,0.71000000f,0.50000000f,-0.25000000f,0.83000000f,0.57000000f,-0.51000000f,0.81000000f,0.03000000f,-0.81000000f,-0.78000000f,-0.70000000f,0.27000000f,0.55000000f,0.62000000f,0.55000000f,0.68000000f,-0.05000000f,-0.73000000f,-0.28000000f,0.24000000f,-0.33000000f,0.59000000f,-0.89000000f,0.78000000f,-0.91000000f,-0.77000000f,0.11000000f,-0.73000000f,0.57000000f,-0.26000000f,-0.25000000f,0.80000000f,0.47000000f,-0.09000000f,0.71000000f,0.15000000f,0.56000000f,0.27000000f,0.11000000f,-0.27000000f,-0.69000000f,0.45000000f,0.23000000f,0.87000000f,-0.35000000f,-0.31000000f,0.73000000f,-0.30000000f,-0.65000000f,0.36000000f,0.52000000f,-0.80000000f,0.62000000f,0.25000000f,0.31000000f,-0.42000000f,-0.32000000f,0.83000000f,-0.59000000f,-0.22000000f,-0.61000000f,-0.35000000f,-0.60000000f,-0.89000000f,-0.46000000f,-0.38000000f,-0.69000000f,-0.99000000f,0.87000000f,-0.04000000f,0.47000000f,0.31000000f,-0.07000000f,-0.64000000f,0.30000000f,-0.09000000f,-0.57000000f,0.28000000f,0.39000000f,0.75000000f,-0.44000000f,-0.50000000f,0.97000000f,0.74000000f,-0.86000000f,0.59000000f,0.28000000f,-0.48000000f,-0.96000000f,0.59000000f,0.17000000f,0.43000000f,0.84000000f,-0.80000000f,0.14000000f,0.10000000f,-0.25000000f,-0.99000000f,-0.89000000f,0.12000000f,-0.67000000f,-0.24000000f,0.65000000f,-0.20000000f,-0.73000000f,0.66000000f,0.80000000f,-0.46000000f,-0.32000000f,-0.60000000f,0.79000000f,-0.99000000f,0.22000000f,0.30000000f,-0.33000000f,0.49000000f,0.71000000f,-0.59000000f,-0.47000000f,-0.36000000f,0.93000000f,0.67000000f,-0.66000000f,-0.48000000f,0.04000000f,-0.11000000f,0.22000000f,0.55000000f,0.31000000f,0.26000000f,0.17000000f,-0.12000000f,0.39000000f,0.40000000f,-0.13000000f,0.44000000f,-0.36000000f,0.81000000f,0.69000000f,-0.47000000f,-0.07000000f,-0.94000000f,-0.06000000f,0.45000000f,-0.47000000f,0.12000000f,0.30000000f,0.81000000f,-0.50000000f,0.64000000f,0.56000000f,-0.01000000f,0.43000000f,-0.24000000f,0.45000000f,-0.30000000f,0.56000000f,-0.13000000f,0.44000000f,-0.17000000f,0.17000000f,0.76000000f,-0.32000000f,-0.49000000f,-0.13000000f,0.07000000f,-0.43000000f,-0.50000000f,-0.80000000f,-0.07000000f,-0.13000000f,0.93000000f,0.13000000f,-0.29000000f,-0.39000000f,0.53000000f,-0.89000000f,0.67000000f,0.25000000f,0.42000000f,-0.29000000f,0.48000000f,-0.37000000f,0.99000000f,0.99000000f,-0.12000000f,0.36000000f,0.64000000f,-0.79000000f,0.85000000f,-0.97000000f,-0.01000000f,-0.51000000f,-0.54000000f,-0.02000000f,-0.79000000f,-0.70000000f,-0.61000000f,0.24000000f,-0.12000000f,0.82000000f,0.18000000f,-0.91000000f,-0.83000000f,-0.90000000f,-0.32000000f,-0.14000000f,0.51000000f,0.05000000f,-0.63000000f,0.49000000f,0.57000000f,-0.31000000f,-0.97000000f,0.77000000f,-0.48000000f,0.05000000f,-0.75000000f,-0.72000000f,0.47000000f,-0.55000000f,0.19000000f,-0.76000000f,0.39000000f,-0.06000000f,-0.66000000f,0.20000000f,-0.85000000f,-0.09000000f,-0.76000000f,-0.84000000f,0.09000000f,0.74000000f,-0.09000000f,-0.75000000f,-0.69000000f,0.18000000f,0.27000000f,0.74000000f,0.73000000f,0.29000000f,0.70000000f,-0.59000000f,0.91000000f,0.93000000f,0.83000000f,0.40000000f,-0.87000000f,-0.29000000f,-0.93000000f,-0.33000000f,0.88000000f,-0.95000000f,-0.81000000f,-0.71000000f,0.96000000f,-0.37000000f,-0.39000000f,-0.23000000f,0.08000000f,0.71000000f,-0.18000000f,0.23000000f,0.61000000f,0.05000000f,0.19000000f,-0.19000000f,-0.81000000f,-0.05000000f,0.63000000f,0.84000000f,-0.12000000f,-0.33000000f,0.27000000f,0.49000000f,-0.29000000f,-0.30000000f,0.70000000f,-0.82000000f,-0.59000000f,0.59000000f,-0.28000000f,0.10000000f,-0.24000000f,0.13000000f,0.85000000f,-0.54000000f,-0.63000000f,0.65000000f,-0.06000000f,-0.59000000f,-0.97000000f,-0.36000000f,-0.40000000f,-0.34000000f,0.84000000f,-0.25000000f,0.77000000f,0.22000000f,0.87000000f,0.91000000f,-0.78000000f,0.74000000f,-0.13000000f,0.13000000f,0.07000000f,0.15000000f,0.92000000f,0.17000000f,-0.51000000f,0.06000000f,0.79000000f,-0.51000000f,-0.76000000f,-0.19000000f,-0.22000000f,0.74000000f,-0.31000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.97000000f,-0.59000000f,0.39000000f,-0.58000000f,-0.70000000f,-0.29000000f,0.44000000f,-0.71000000f,-0.77000000f,-0.83000000f,0.17000000f,-0.55000000f,-0.47000000f,0.98000000f,0.74000000f,-0.04000000f,0.57000000f,0.05000000f,0.64000000f,-0.53000000f,-0.23000000f,-0.15000000f,0.87000000f,-0.86000000f,0.45000000f,0.50000000f,-0.58000000f,0.35000000f,-0.89000000f,0.59000000f,-0.34000000f,-0.12000000f,-0.56000000f,-0.08000000f,0.93000000f,0.93000000f,0.27000000f,-0.60000000f,0.06000000f,0.47000000f,0.22000000f,0.49000000f,0.67000000f,-0.30000000f,0.83000000f,-0.13000000f,0.86000000f,-0.86000000f,-0.79000000f,-0.41000000f,0.30000000f,0.56000000f,0.88000000f,0.17000000f,0.40000000f,-0.84000000f,0.84000000f,-0.18000000f,0.95000000f,-0.17000000f,-0.52000000f,0.14000000f,0.04000000f,0.96000000f,0.21000000f,-0.42000000f,0.92000000f,0.32000000f,-0.24000000f,-0.11000000f,0.26000000f,-0.60000000f,-0.68000000f,0.91000000f,-0.37000000f,0.11000000f,0.76000000f,0.31000000f,0.39000000f,-0.25000000f,-0.10000000f,0.63000000f,0.20000000f,0.83000000f,-0.49000000f,0.71000000f,0.42000000f,-0.01000000f,0.15000000f,-0.47000000f,-0.13000000f,-0.69000000f,0.17000000f,0.90000000f,-0.21000000f,0.14000000f,0.60000000f,0.39000000f,-0.16000000f,0.23000000f,-0.33000000f,0.88000000f,-0.78000000f,-0.87000000f,0.15000000f,-0.68000000f,0.53000000f,-0.11000000f,0.43000000f,-0.54000000f,-0.57000000f,0.87000000f,0.81000000f,0.13000000f,-0.07000000f,0.18000000f,-0.32000000f,-0.85000000f,0.35000000f,-0.32000000f,0.75000000f,-0.80000000f,0.79000000f,-0.12000000f,0.55000000f,0.06000000f,-0.95000000f,0.50000000f,0.99000000f,-0.88000000f,0.75000000f,-0.69000000f,-0.23000000f,-0.53000000f,0.93000000f,-0.57000000f,0.29000000f,0.58000000f,-0.42000000f,0.75000000f,-0.92000000f,-0.13000000f,-0.16000000f,0.28000000f,-0.90000000f,-0.17000000f,-0.74000000f,-0.55000000f,0.99000000f,-0.82000000f,-0.24000000f,-0.43000000f,-0.52000000f,-0.45000000f,-0.02000000f,-0.70000000f,-0.26000000f,0.74000000f,0.21000000f,0.97000000f,-0.10000000f,-0.65000000f,-0.18000000f,-0.06000000f,-0.60000000f,0.54000000f,-0.76000000f,0.23000000f,0.21000000f,0.44000000f,0.06000000f,-0.80000000f,-0.87000000f,-0.13000000f,0.92000000f,0.97000000f,-0.04000000f,0.35000000f,-0.44000000f,-0.00000000f,-0.78000000f,-0.54000000f,-0.91000000f,0.19000000f,0.97000000f,-0.60000000f,0.35000000f,-0.64000000f,-0.84000000f,0.25000000f,0.90000000f,0.17000000f,-0.26000000f,-0.82000000f,0.59000000f,-0.62000000f,-0.14000000f,0.41000000f,0.62000000f,0.91000000f,-0.73000000f,0.62000000f,0.87000000f,0.50000000f,0.55000000f,-0.72000000f,0.00000000f,-0.19000000f,0.90000000f,0.30000000f,0.09000000f,-0.10000000f,-0.90000000f,0.66000000f,0.77000000f,0.63000000f,-0.07000000f,-0.92000000f,-0.63000000f,-0.86000000f,-0.08000000f,0.09000000f,0.38000000f,0.58000000f,0.76000000f,-0.98000000f,0.83000000f,-0.05000000f,-0.37000000f,0.52000000f,-0.57000000f,-0.31000000f,-0.47000000f,-0.49000000f,0.42000000f,-0.13000000f,-0.79000000f,0.60000000f,-0.08000000f,-0.12000000f,0.65000000f,-0.48000000f,0.79000000f,0.22000000f,0.71000000f,0.70000000f,0.78000000f,-0.25000000f,-0.05000000f,0.48000000f,0.14000000f,-0.85000000f,0.50000000f,-0.86000000f,0.31000000f,0.60000000f,0.72000000f,0.82000000f,-0.46000000f,-0.65000000f,-0.54000000f,0.26000000f,0.17000000f,-0.02000000f,-0.48000000f,0.36000000f,-0.63000000f,0.84000000f,0.62000000f,0.59000000f,-0.74000000f,0.00000000f,0.45000000f,0.08000000f,-0.54000000f,-0.34000000f,0.79000000f,0.38000000f,-0.17000000f,0.41000000f,0.30000000f,0.06000000f,0.22000000f,0.59000000f,0.23000000f,-0.36000000f,0.85000000f,-0.00000000f,-0.93000000f,0.74000000f,0.06000000f,-0.99000000f,-0.06000000f,-0.48000000f,0.27000000f,-0.97000000f,-0.44000000f,-0.12000000f,0.46000000f,-0.63000000f,-0.57000000f,-0.98000000f,0.72000000f,0.59000000f,-0.81000000f,0.96000000f,0.64000000f,-0.59000000f,0.13000000f,-0.80000000f,0.43000000f,0.23000000f,-0.66000000f,-0.74000000f,-0.52000000f,0.39000000f,-0.60000000f,-0.92000000f,0.49000000f,0.03000000f,0.84000000f,-0.72000000f,-0.97000000f,-0.81000000f,0.17000000f,0.79000000f,0.69000000f,-0.66000000f,0.11000000f,0.40000000f,-0.37000000f,0.46000000f,-0.74000000f,-0.50000000f,0.81000000f,-0.90000000f,0.66000000f,-0.06000000f,-0.42000000f,0.47000000f,0.12000000f,0.59000000f,-0.26000000f,0.12000000f,-0.93000000f,0.61000000f,-0.19000000f,-0.96000000f,-0.63000000f,-0.86000000f,-0.96000000f,0.33000000f,-0.80000000f,-0.31000000f,-0.22000000f,-0.73000000f,-0.39000000f,0.69000000f,-0.59000000f,0.17000000f,-0.24000000f,0.75000000f,-0.61000000f,-0.90000000f,0.23000000f,0.75000000f,-0.51000000f,-0.08000000f,-0.47000000f,0.37000000f,-0.30000000f,0.36000000f,0.75000000f,0.93000000f,0.97000000f,0.52000000f,0.64000000f,0.98000000f,-0.05000000f,0.34000000f,-0.66000000f,0.60000000f,0.44000000f,0.48000000f,0.53000000f,-0.61000000f,-0.57000000f,0.18000000f,-0.28000000f,0.80000000f,0.14000000f,0.31000000f,-0.54000000f,-0.56000000f,0.48000000f,0.28000000f,-0.86000000f,-0.04000000f,-0.12000000f,-0.97000000f,0.87000000f,-0.82000000f,-0.33000000f,-0.75000000f,0.67000000f,-0.05000000f,0.83000000f,0.14000000f,0.84000000f,-0.47000000f,0.25000000f,-0.52000000f,-0.48000000f,-0.86000000f,0.15000000f,0.19000000f,-0.45000000f,-0.48000000f,-0.33000000f,-0.98000000f,-0.61000000f,0.13000000f,0.83000000f,-0.45000000f,0.78000000f,0.16000000f,-0.52000000f,0.37000000f,0.07000000f,-0.98000000f,0.78000000f,0.91000000f,-0.26000000f,-0.30000000f,0.10000000f,-0.92000000f,0.17000000f,0.10000000f,0.44000000f,-0.31000000f,-0.50000000f,-0.85000000f,-0.29000000f,0.85000000f,-0.47000000f,0.13000000f,-0.59000000f,-0.71000000f,0.34000000f,0.39000000f,-0.72000000f,-0.46000000f,-0.66000000f,0.44000000f,0.95000000f,0.09000000f,-0.10000000f,0.81000000f,0.37000000f,-0.82000000f,0.24000000f,-0.58000000f,-0.79000000f,0.61000000f,-0.73000000f,0.45000000f,-0.76000000f,-0.55000000f,-0.06000000f,-0.59000000f,-0.04000000f,0.42000000f,0.08000000f,-0.51000000f,-0.87000000f,-0.54000000f,-0.25000000f,0.51000000f,-0.14000000f,0.78000000f,0.06000000f,0.44000000f,-0.40000000f,0.11000000f,-0.47000000f,0.36000000f,0.23000000f,0.12000000f,0.49000000f,-0.40000000f,-0.39000000f,0.45000000f,0.74000000f,-0.99000000f,-0.21000000f,0.03000000f,0.85000000f,0.59000000f,0.67000000f,0.15000000f,0.74000000f,0.34000000f,-0.49000000f,-0.59000000f,-0.82000000f,-0.82000000f,0.60000000f,0.12000000f,-0.61000000f,-0.19000000f,0.52000000f,-0.32000000f,0.96000000f,0.46000000f,0.95000000f,0.27000000f,0.97000000f,-0.01000000f,0.18000000f,0.81000000f,-0.55000000f,0.05000000f,-0.76000000f,-0.74000000f,0.08000000f,0.58000000f,-0.77000000f,0.43000000f,-0.55000000f,-0.78000000f,0.37000000f,0.39000000f,-0.37000000f,-0.03000000f,-0.75000000f,-0.46000000f,0.96000000f,0.50000000f,0.55000000f,-0.81000000f,0.39000000f,-0.54000000f,0.42000000f,-0.92000000f,-0.40000000f,0.31000000f,0.16000000f,-0.87000000f,-0.58000000f,0.41000000f,-0.31000000f,-0.74000000f,-0.36000000f,0.18000000f,0.00000000f,0.32000000f,0.32000000f,0.39000000f,-0.91000000f,0.50000000f,0.75000000f,0.38000000f,0.60000000f,0.11000000f,-0.56000000f,0.61000000f,-0.92000000f,0.38000000f,0.10000000f,-0.30000000f,-0.42000000f,0.35000000f,-0.51000000f,0.58000000f,0.84000000f,-0.37000000f,-0.00000000f,0.82000000f,0.15000000f,0.82000000f,-0.89000000f,0.34000000f,0.29000000f,-0.45000000f,-0.31000000f,-0.54000000f,0.02000000f,-0.69000000f,0.15000000f,-0.77000000f,-0.14000000f,-0.89000000f,-0.19000000f,-0.03000000f,-0.41000000f,0.20000000f,-0.28000000f,-0.60000000f,0.25000000f,-0.18000000f,0.82000000f,-0.38000000f,-0.20000000f,-0.25000000f,-0.18000000f,-0.85000000f,0.88000000f,-0.02000000f,0.97000000f,0.62000000f,-0.97000000f,0.63000000f,0.36000000f,-0.13000000f,-0.93000000f,-0.84000000f,0.63000000f,0.87000000f,-0.18000000f,-0.34000000f,-0.72000000f,0.63000000f,0.13000000f,-0.05000000f,-0.56000000f,0.81000000f,-0.19000000f,-0.89000000f,0.61000000f,0.71000000f,0.22000000f,0.45000000f,-0.44000000f,0.89000000f,0.67000000f,0.47000000f,0.85000000f,-0.50000000f,-0.03000000f,-0.73000000f,0.20000000f,-0.86000000f,0.71000000f,-0.12000000f,-0.16000000f,0.50000000f,0.47000000f,-0.95000000f,-0.37000000f,0.81000000f,0.85000000f,0.69000000f,0.46000000f,-0.77000000f,0.25000000f,0.15000000f,0.09000000f,-0.12000000f,-0.32000000f,0.93000000f,-0.04000000f,-0.66000000f,-0.41000000f,-0.91000000f,-0.84000000f,-0.32000000f,-0.51000000f,0.65000000f,0.09000000f,-0.18000000f,0.80000000f,0.55000000f,-0.30000000f,0.56000000f,0.22000000f,0.28000000f,-0.48000000f,-0.61000000f,-0.15000000f,-0.65000000f,-0.38000000f,0.03000000f,-0.83000000f,0.61000000f,0.83000000f,-0.14000000f,0.39000000f,-0.44000000f,-0.49000000f,-0.70000000f,0.35000000f,-0.72000000f,0.51000000f,0.09000000f,0.31000000f,0.98000000f,0.63000000f,0.74000000f,0.25000000f,-0.30000000f,0.20000000f,0.08000000f,0.81000000f,0.69000000f,0.16000000f,-0.85000000f,0.69000000f,0.20000000f,-0.68000000f,0.99000000f,0.14000000f,-0.65000000f,-0.21000000f,0.03000000f,0.06000000f,-0.16000000f,0.80000000f,0.95000000f,0.90000000f,-0.13000000f,0.05000000f,0.84000000f,0.56000000f,-0.42000000f,-0.58000000f,0.02000000f,-0.16000000f,-0.68000000f,0.03000000f,0.94000000f,-0.20000000f,-0.99000000f,0.99000000f,-0.20000000f,-0.69000000f,0.25000000f,-0.00000000f,0.55000000f,-0.11000000f,0.74000000f,0.96000000f,-0.12000000f,-0.50000000f,0.81000000f,0.97000000f,-0.56000000f,0.40000000f,0.94000000f,0.34000000f,-0.98000000f,-0.04000000f,-0.45000000f,-0.89000000f,-0.04000000f,-0.07000000f,-0.35000000f,0.58000000f,-0.52000000f,0.85000000f,0.94000000f,-0.92000000f,-0.46000000f,-0.51000000f,-0.30000000f,-0.98000000f,0.04000000f,0.45000000f,-0.08000000f,0.53000000f,-0.78000000f,0.43000000f,0.90000000f,-0.48000000f,-0.31000000f,-0.84000000f,-0.70000000f,-0.79000000f,-0.33000000f,0.13000000f,0.68000000f,-0.44000000f,0.21000000f,0.62000000f,0.73000000f,0.15000000f,0.72000000f,0.31000000f,0.21000000f,-0.78000000f,-0.89000000f,-0.96000000f,-0.69000000f,0.12000000f,0.45000000f,-0.47000000f,-0.91000000f,-0.33000000f,0.75000000f,0.87000000f,0.35000000f,-0.33000000f,0.08000000f,0.34000000f,-0.93000000f,0.55000000f,-0.30000000f,0.93000000f,0.60000000f,-0.06000000f,0.89000000f,-0.84000000f,-0.34000000f,0.59000000f,0.20000000f,-0.63000000f,-0.40000000f,0.10000000f,-0.47000000f,-0.79000000f,-0.05000000f,-0.28000000f,-0.97000000f,0.68000000f,0.58000000f,-0.96000000f,-0.32000000f,0.09000000f,-0.14000000f,0.20000000f,0.86000000f,0.33000000f,-0.27000000f,-0.62000000f,0.99000000f,-0.56000000f,0.87000000f,-0.75000000f,-0.53000000f,0.86000000f,-0.44000000f,-0.38000000f,-0.30000000f,-0.73000000f,-0.95000000f,-0.19000000f,0.16000000f,-0.16000000f,-0.87000000f,-0.41000000f,0.77000000f,-0.40000000f,0.90000000f,-0.10000000f,0.67000000f,-0.28000000f,-0.81000000f,0.66000000f,-0.97000000f,-0.21000000f,-0.08000000f,-0.57000000f,-0.80000000f,0.07000000f,-0.86000000f,-0.94000000f,-0.33000000f,-0.43000000f,-0.63000000f,0.52000000f,-0.74000000f,-0.07000000f,-0.17000000f,0.75000000f,0.10000000f,0.97000000f,0.70000000f,-0.01000000f,0.13000000f,0.28000000f,-0.59000000f,-0.25000000f,0.39000000f,0.44000000f,0.18000000f,0.38000000f,-0.95000000f,0.93000000f,-0.80000000f,0.37000000f,0.08000000f,0.42000000f,-0.84000000f,-0.05000000f,0.21000000f,0.96000000f,0.93000000f,-0.60000000f,0.96000000f,-0.50000000f,0.17000000f,-0.74000000f,0.47000000f,-0.16000000f,-0.05000000f,-0.36000000f,-0.46000000f,-0.62000000f,0.95000000f,0.44000000f,-0.45000000f,0.42000000f,-0.31000000f,0.79000000f,0.37000000f,-0.21000000f,-0.78000000f,-0.08000000f,-0.70000000f,-0.83000000f,0.02000000f,0.10000000f,-0.45000000f,-0.12000000f,-0.45000000f,-0.90000000f,0.95000000f,0.60000000f,0.34000000f,-0.38000000f,-0.22000000f,0.37000000f,0.04000000f,-0.21000000f,-0.63000000f,0.10000000f,0.61000000f,-0.76000000f,-0.48000000f,-0.45000000f,0.27000000f,0.96000000f,0.75000000f,0.09000000f,0.77000000f,0.99000000f,-0.35000000f,0.81000000f,0.95000000f,0.14000000f,-0.41000000f,-0.54000000f,-0.43000000f,0.25000000f,0.36000000f,-0.61000000f,-0.11000000f,0.83000000f,0.14000000f,0.56000000f,-0.42000000f,0.80000000f,0.35000000f,0.11000000f,-0.51000000f,-0.68000000f,-0.28000000f,0.05000000f,0.54000000f,-0.01000000f,-0.74000000f,-0.19000000f,-0.91000000f,0.86000000f,-0.05000000f,0.19000000f,-0.71000000f,-0.22000000f,0.39000000f,0.97000000f,0.08000000f,0.92000000f,-0.36000000f,0.29000000f,0.08000000f,0.99000000f,-0.31000000f,-0.94000000f,-0.37000000f,0.17000000f,0.41000000f,0.41000000f,-0.57000000f,-0.56000000f,-0.05000000f,0.88000000f,0.19000000f,0.91000000f,0.34000000f,0.07000000f,0.39000000f,-0.56000000f,0.76000000f,0.87000000f,-0.82000000f,0.79000000f,-0.29000000f,0.29000000f,0.79000000f,-0.00000000f,-0.68000000f,0.22000000f,0.75000000f,-0.29000000f,-0.92000000f,-0.57000000f,0.88000000f,-0.78000000f,-0.99000000f,0.88000000f,0.34000000f,0.82000000f,0.86000000f,-0.17000000f,0.79000000f,0.12000000f,0.42000000f,-0.50000000f,0.23000000f,0.83000000f,0.25000000f,0.77000000f,0.62000000f,-0.81000000f,-0.24000000f,0.47000000f,-0.49000000f,-0.45000000f,0.06000000f,-0.38000000f,-0.01000000f,0.15000000f,-0.16000000f,-0.63000000f,-0.25000000f,-0.99000000f,0.24000000f,0.85000000f,-0.69000000f,-0.37000000f,-0.27000000f,0.01000000f,-0.22000000f,0.73000000f,0.63000000f,-0.48000000f,0.87000000f,0.90000000f,-0.64000000f,0.68000000f,0.59000000f,0.11000000f,-0.83000000f,0.17000000f,0.87000000f,-0.88000000f,0.76000000f,-0.85000000f,-0.20000000f,0.94000000f,0.71000000f,0.16000000f,-0.40000000f,-0.73000000f,0.91000000f,0.61000000f,0.89000000f,-0.73000000f,0.79000000f,-0.48000000f,-0.18000000f,0.74000000f,0.64000000f,-0.74000000f,-0.89000000f,-0.84000000f,-0.28000000f,-0.00000000f,0.45000000f,0.50000000f,0.78000000f,0.84000000f,-0.54000000f,0.66000000f,0.67000000f,-0.58000000f,-0.67000000f,0.09000000f,-0.93000000f,-0.50000000f,-0.71000000f,-0.57000000f,0.44000000f,-0.20000000f,0.42000000f,-0.65000000f,-0.81000000f,0.37000000f,0.21000000f,-0.82000000f,-0.16000000f,0.84000000f,0.04000000f,0.51000000f,0.33000000f,-0.43000000f,0.44000000f,-0.82000000f,0.92000000f,-0.33000000f,-0.92000000f,0.76000000f,-0.33000000f,0.83000000f,-0.21000000f,-0.25000000f,0.28000000f,0.78000000f,0.70000000f,0.04000000f,0.65000000f,-0.44000000f,0.28000000f,-0.61000000f,-0.85000000f,0.26000000f,-0.86000000f,0.41000000f,0.02000000f,-0.44000000f,0.93000000f,0.27000000f,0.79000000f,-0.60000000f,0.91000000f,-0.25000000f,-0.92000000f,0.13000000f,0.87000000f,-0.29000000f,-0.89000000f,-0.56000000f,-0.91000000f,-0.95000000f,-0.72000000f,-0.62000000f,-0.99000000f,-0.89000000f,-0.89000000f,0.64000000f,-0.08000000f,0.70000000f,-0.78000000f,0.82000000f,-0.54000000f,0.97000000f,-0.26000000f,0.12000000f,0.46000000f,-0.26000000f,-0.46000000f,-0.65000000f,0.04000000f,-0.50000000f,0.34000000f,-0.78000000f,-0.54000000f,-0.29000000f,0.13000000f,0.19000000f,0.01000000f,-0.77000000f,-0.20000000f,-0.98000000f,0.43000000f,0.37000000f,0.80000000f,-0.97000000f,-0.99000000f,-0.66000000f,0.55000000f,0.85000000f,0.45000000f,0.58000000f,-0.29000000f,-0.54000000f,-0.95000000f,0.41000000f,0.14000000f,-0.84000000f,0.13000000f,0.06000000f,0.37000000f,0.23000000f,0.76000000f,0.88000000f,0.12000000f,-0.84000000f,-0.53000000f,-0.26000000f,0.26000000f,0.67000000f,-0.24000000f,0.76000000f,0.76000000f,0.12000000f,-0.13000000f,-0.05000000f,-0.12000000f,0.92000000f,0.40000000f,-0.68000000f,0.68000000f,0.00000000f,0.19000000f,-0.72000000f,0.06000000f,-0.66000000f,0.55000000f,0.77000000f,-0.71000000f,0.84000000f,0.59000000f,0.15000000f,0.27000000f,0.38000000f,-0.99000000f,-0.03000000f,0.65000000f,-0.94000000f,0.55000000f,-0.51000000f,0.40000000f,0.32000000f,0.33000000f,-0.93000000f,0.49000000f,0.83000000f,0.98000000f,0.32000000f,-0.45000000f,0.32000000f,-0.22000000f,0.37000000f,-0.35000000f,-0.30000000f,-0.63000000f,-0.72000000f,0.86000000f,-0.95000000f,0.70000000f,0.44000000f,0.12000000f,-0.66000000f,0.39000000f,0.67000000f,-0.56000000f,-0.25000000f,-0.64000000f,-0.15000000f,0.33000000f,0.37000000f,-0.26000000f,0.65000000f,0.13000000f,-0.98000000f,-0.27000000f,-0.94000000f,0.90000000f,-0.30000000f,-0.35000000f,0.24000000f,0.20000000f,-0.93000000f,0.24000000f,-0.17000000f,-0.80000000f,0.24000000f,0.92000000f,-0.81000000f,-0.61000000f,0.05000000f,-0.72000000f,0.12000000f,0.95000000f,-0.07000000f,-0.04000000f,0.74000000f,-0.10000000f,-0.07000000f,-0.55000000f,-0.07000000f,0.21000000f,-0.77000000f,-0.79000000f,0.52000000f,-0.76000000f,-0.02000000f,-0.18000000f,-0.88000000f,-0.76000000f,0.78000000f,-0.74000000f,-0.22000000f,0.26000000f,-0.51000000f,0.91000000f,0.33000000f,0.82000000f,0.67000000f,0.89000000f,-0.57000000f,0.47000000f,-0.30000000f,0.06000000f,0.46000000f,0.40000000f,0.33000000f,0.36000000f,-0.12000000f,0.80000000f,-0.46000000f,0.69000000f,0.60000000f,0.96000000f,0.69000000f,-0.85000000f,-0.16000000f,-0.44000000f,-0.13000000f,-0.58000000f,-0.93000000f,0.05000000f,0.51000000f,-0.02000000f,0.79000000f,-0.36000000f,0.27000000f,0.74000000f,0.67000000f,0.61000000f,-0.67000000f,-0.97000000f,-0.01000000f,0.78000000f,-0.94000000f,0.11000000f,-0.35000000f,-0.45000000f,-0.27000000f,0.51000000f,0.07000000f,-0.34000000f,0.46000000f,0.85000000f,-0.25000000f,0.84000000f,0.40000000f,-0.68000000f,-0.66000000f,-0.89000000f,0.72000000f,-0.52000000f,-0.46000000f,-0.19000000f,0.91000000f,0.09000000f,-0.56000000f,0.16000000f,0.01000000f,-0.29000000f,0.86000000f,-0.05000000f,0.50000000f,-0.98000000f,0.98000000f,-0.25000000f,0.21000000f,-0.52000000f,-0.45000000f,0.07000000f,0.97000000f,0.62000000f,0.51000000f,0.91000000f,-0.42000000f,0.80000000f,-0.33000000f,-0.77000000f,-0.98000000f,0.82000000f,-0.35000000f,0.96000000f,0.25000000f,-0.54000000f,0.50000000f,-0.66000000f,0.54000000f,-0.14000000f,0.53000000f,-0.96000000f,-0.05000000f,-0.85000000f,-0.03000000f,0.12000000f,-0.71000000f,-0.06000000f,0.47000000f,-0.80000000f,0.70000000f,0.88000000f,0.57000000f,-0.07000000f,-0.04000000f,-0.13000000f,0.80000000f,0.59000000f,-0.23000000f,-0.66000000f,-0.34000000f,-0.78000000f,0.95000000f,0.14000000f,0.24000000f,-0.37000000f,-0.29000000f,0.51000000f,-0.94000000f,-0.93000000f,-0.62000000f,-0.68000000f,0.58000000f,-0.13000000f,0.16000000f,0.50000000f,-0.23000000f,-0.01000000f,-0.24000000f,0.82000000f,-0.07000000f,-0.01000000f,-0.49000000f,0.23000000f,-0.00000000f,0.83000000f,-0.60000000f,0.72000000f,0.34000000f,-0.12000000f,-0.11000000f,-0.07000000f,0.01000000f,0.15000000f,-0.23000000f,0.58000000f,-0.60000000f,0.74000000f,0.43000000f,-0.15000000f,-0.41000000f,-0.29000000f,0.66000000f,0.60000000f,0.74000000f,-0.13000000f,0.48000000f,-0.13000000f,-0.35000000f,0.29000000f,-0.64000000f,-0.76000000f,0.27000000f,0.56000000f,0.72000000f,0.51000000f,-0.75000000f,-0.30000000f,0.53000000f,-0.62000000f,0.64000000f,0.11000000f,-0.93000000f,-0.12000000f,-0.43000000f,0.96000000f,0.49000000f,-0.66000000f,0.47000000f,-0.96000000f,-0.60000000f,0.72000000f,0.64000000f,0.39000000f,-0.53000000f,-0.61000000f,-0.37000000f,0.99000000f,-0.74000000f,0.50000000f,-0.32000000f,0.82000000f,-0.98000000f,-0.06000000f,-0.68000000f,0.32000000f,-0.28000000f,-0.64000000f,0.30000000f,-0.44000000f,0.60000000f,0.16000000f,-0.29000000f,-0.21000000f,-0.12000000f,0.19000000f,0.26000000f,-0.32000000f,-0.90000000f,0.88000000f,0.96000000f,-0.28000000f,0.51000000f,-0.86000000f,0.28000000f,0.43000000f,0.82000000f,-0.21000000f,-0.15000000f,0.15000000f,-0.70000000f,-0.70000000f,0.05000000f,-0.82000000f,-0.85000000f,-0.57000000f,0.13000000f,-0.22000000f,0.53000000f,0.80000000f,0.43000000f,0.30000000f,-0.77000000f,-0.95000000f,0.95000000f,0.95000000f,-0.21000000f,0.56000000f,0.56000000f,-0.66000000f,-0.70000000f,-0.03000000f,0.51000000f,0.79000000f,0.00000000f,-0.68000000f,0.25000000f,-0.15000000f,0.12000000f,0.07000000f,-0.18000000f,-0.57000000f,0.81000000f,0.22000000f,-0.80000000f,0.14000000f,0.14000000f,0.19000000f,0.65000000f,-0.06000000f,0.72000000f,-0.96000000f,-0.93000000f,-0.96000000f,-0.35000000f,0.06000000f,0.92000000f,-0.01000000f,-0.16000000f,0.13000000f,0.00000000f,-0.24000000f,0.79000000f,-0.15000000f,-0.29000000f,-0.83000000f,-0.38000000f,-0.91000000f,-0.17000000f,-0.21000000f,-0.89000000f,-0.24000000f,0.40000000f,-0.43000000f,-0.31000000f,0.45000000f,0.74000000f,0.77000000f,-0.98000000f,0.53000000f,0.87000000f,-0.42000000f,-0.37000000f,-0.95000000f,0.02000000f,-0.03000000f,0.21000000f,-0.39000000f,-0.27000000f,-0.66000000f,0.62000000f,-0.34000000f,0.34000000f,0.89000000f,-0.64000000f,-0.65000000f,-0.51000000f,-0.98000000f,0.14000000f,-0.49000000f,0.27000000f,0.10000000f,-0.71000000f,-0.20000000f,-0.01000000f,-0.51000000f,0.50000000f,-0.30000000f,0.98000000f,-0.46000000f,0.10000000f,-0.60000000f,-0.71000000f,-0.95000000f,0.49000000f,0.59000000f,0.00000000f,-0.19000000f,0.11000000f,-0.41000000f,0.08000000f,-0.50000000f,0.48000000f,0.19000000f,-0.80000000f,0.55000000f,-0.27000000f,0.14000000f,-0.66000000f,0.04000000f,-0.16000000f,-0.40000000f,0.18000000f,-0.50000000f,0.89000000f,-0.98000000f,0.27000000f,-0.39000000f,0.91000000f,-0.07000000f,-0.88000000f,-0.76000000f,-0.34000000f,0.10000000f,0.80000000f,-0.05000000f,-0.31000000f,-0.87000000f,0.65000000f,0.26000000f,-0.62000000f,0.55000000f,0.57000000f,-0.98000000f,0.11000000f,0.14000000f,-0.63000000f,-0.39000000f,0.13000000f,-0.87000000f,-0.60000000f,0.92000000f,-0.08000000f,-0.88000000f,0.08000000f,-0.82000000f,-0.12000000f,0.71000000f,0.41000000f,-0.81000000f,0.17000000f,0.16000000f,-0.52000000f,-0.44000000f,-0.58000000f,0.24000000f,-0.16000000f,0.42000000f,-0.87000000f,-0.41000000f,0.86000000f,0.51000000f,-0.42000000f,0.57000000f,0.44000000f,-0.90000000f,-0.37000000f,-0.11000000f,-0.13000000f,0.12000000f,-0.13000000f,-0.80000000f,-0.44000000f,-0.12000000f,0.76000000f,-0.65000000f,-0.00000000f,0.94000000f,-0.49000000f,0.64000000f,-0.20000000f,-0.02000000f,-0.30000000f,-0.70000000f,0.81000000f,0.37000000f,-0.12000000f,0.06000000f,-0.73000000f,-0.99000000f,-0.24000000f,0.66000000f,0.32000000f,-0.94000000f,0.29000000f,0.47000000f,0.32000000f,-0.20000000f,0.90000000f,0.37000000f,0.14000000f,-0.65000000f,-0.30000000f,0.03000000f,-0.81000000f,-0.85000000f,-0.45000000f,0.95000000f,0.52000000f,-0.64000000f,0.70000000f,-0.32000000f,-0.50000000f,0.34000000f,0.33000000f,0.44000000f,0.94000000f,0.39000000f,0.78000000f,-0.99000000f,0.35000000f,-0.04000000f,0.56000000f,-0.65000000f,0.33000000f,-0.57000000f,0.23000000f,-0.17000000f,-0.97000000f,0.70000000f,-0.68000000f,-0.23000000f,-0.60000000f,0.20000000f,-0.93000000f,0.00000000f,0.16000000f,0.92000000f,-0.19000000f,0.72000000f,0.28000000f,0.55000000f,0.97000000f,0.44000000f,-0.40000000f,-0.03000000f,0.86000000f,0.27000000f,0.31000000f,-0.50000000f,0.16000000f,0.03000000f,-0.49000000f,-0.09000000f,-0.64000000f,-0.17000000f,-0.01000000f,0.88000000f,0.07000000f,0.45000000f,-0.45000000f,-0.36000000f,-0.40000000f,0.69000000f,-0.54000000f,-0.44000000f,-0.74000000f,0.00000000f,-0.49000000f,-0.40000000f,-0.92000000f,0.16000000f,-0.21000000f,-0.39000000f,-0.26000000f,-0.63000000f,0.14000000f,-0.53000000f,0.31000000f,-0.83000000f,0.33000000f,0.31000000f,0.06000000f,-0.88000000f,0.12000000f,-0.20000000f,0.63000000f,0.35000000f,0.79000000f,-0.25000000f,0.77000000f,-0.79000000f,0.16000000f,0.64000000f,-0.49000000f,-0.14000000f,0.09000000f,-0.00000000f,0.46000000f,-0.96000000f,-0.00000000f,0.67000000f,0.74000000f,-0.23000000f,-0.25000000f,-0.16000000f,0.45000000f,-0.87000000f,0.73000000f,0.89000000f,-0.40000000f,0.85000000f,0.70000000f,-0.98000000f,0.11000000f,0.27000000f,0.64000000f,0.22000000f,-0.38000000f,0.80000000f,-0.38000000f,0.98000000f,0.87000000f,0.96000000f,0.54000000f,0.88000000f,0.46000000f,0.00000000f,-0.08000000f,0.94000000f,0.02000000f,-0.97000000f,0.16000000f,-0.04000000f,0.44000000f,-0.45000000f,-0.58000000f,0.38000000f,-0.49000000f,0.93000000f,0.78000000f,0.84000000f,-0.35000000f,0.28000000f,0.96000000f,0.16000000f,-0.58000000f,0.32000000f,0.34000000f,-0.43000000f,0.34000000f,0.68000000f,0.92000000f,-0.69000000f,0.48000000f,0.42000000f,-0.13000000f,-0.54000000f,0.09000000f,0.70000000f,-0.85000000f,0.74000000f,-0.55000000f,-0.18000000f,0.45000000f,-0.49000000f,0.12000000f,0.33000000f,-0.49000000f,-0.68000000f,-0.67000000f,0.60000000f,0.61000000f,-0.87000000f,0.13000000f,0.68000000f,-0.56000000f,0.83000000f,-0.16000000f,0.26000000f,-0.18000000f,-0.80000000f,-0.47000000f,0.80000000f,-0.25000000f,0.36000000f,-0.12000000f,-0.98000000f,0.78000000f,-0.58000000f,0.76000000f,-0.25000000f,0.34000000f,0.42000000f,0.76000000f,0.09000000f,-0.97000000f,0.57000000f,0.01000000f,0.82000000f,0.02000000f,-0.67000000f,-0.15000000f,0.99000000f,-0.27000000f,0.19000000f,-0.16000000f,-0.28000000f,-0.70000000f,0.17000000f,0.68000000f,0.00000000f,0.81000000f,-0.88000000f,-0.43000000f,-0.71000000f,-0.90000000f,-0.12000000f,-0.31000000f,-0.15000000f,-0.12000000f,-0.44000000f,0.58000000f,0.26000000f,-0.41000000f,-0.23000000f,-0.06000000f,-0.71000000f,-0.21000000f,0.66000000f,-0.27000000f,0.31000000f,0.55000000f,-0.43000000f,-0.23000000f,-0.98000000f,0.17000000f,-0.03000000f,0.66000000f,0.13000000f,0.41000000f,-0.20000000f,-0.93000000f,-0.33000000f,-0.25000000f,0.23000000f,-0.15000000f,0.19000000f,0.73000000f,0.24000000f,-0.49000000f,0.16000000f,0.24000000f,-0.12000000f,-0.21000000f,-0.61000000f,-0.11000000f,-0.23000000f,-0.98000000f,-0.51000000f,0.19000000f,0.09000000f,0.32000000f,0.99000000f,0.28000000f,0.19000000f,0.66000000f,0.74000000f,0.89000000f,-0.10000000f,0.04000000f,-0.12000000f,0.79000000f,0.36000000f,0.17000000f,0.51000000f,-0.66000000f,-0.09000000f,0.75000000f,-0.88000000f,-0.67000000f,-0.74000000f,-0.63000000f,-0.36000000f,-0.93000000f,0.61000000f,-0.12000000f,-0.00000000f,0.06000000f,0.58000000f,-0.27000000f,0.73000000f,-0.97000000f,-0.03000000f,-0.97000000f,0.99000000f,-0.11000000f,-0.55000000f,-0.59000000f,-0.44000000f,-0.90000000f,-0.13000000f,0.20000000f,0.85000000f,0.90000000f,0.38000000f,-0.46000000f,-0.41000000f,0.18000000f,-0.87000000f,-0.82000000f,0.61000000f,-0.75000000f,0.20000000f,-0.74000000f,-0.68000000f,-0.22000000f,-0.21000000f,0.68000000f,-0.00000000f,0.38000000f,-0.50000000f,-0.21000000f,0.11000000f,0.94000000f,-0.98000000f,0.59000000f,-0.69000000f,-0.36000000f,0.92000000f,-0.76000000f,-0.73000000f,-0.29000000f,0.23000000f,-0.52000000f,0.18000000f,0.26000000f,0.37000000f,0.08000000f,0.35000000f,-0.61000000f,0.71000000f,0.36000000f,0.00000000f,-0.67000000f,0.57000000f,0.63000000f,-0.04000000f,0.06000000f,-0.96000000f,0.40000000f,0.37000000f,0.86000000f,0.05000000f,0.49000000f,0.78000000f,-0.47000000f,-0.90000000f,0.53000000f,-0.30000000f,-0.57000000f,-0.72000000f,0.25000000f,0.06000000f,0.98000000f,0.89000000f,-0.66000000f,-0.83000000f,0.55000000f,0.35000000f,0.84000000f,0.27000000f,-0.56000000f,-0.40000000f,-0.56000000f,-0.40000000f,-0.83000000f,0.69000000f,-0.05000000f,-0.39000000f,0.87000000f,-0.81000000f,-0.29000000f,-0.94000000f,0.10000000f,-0.32000000f,-0.48000000f,0.43000000f,-0.40000000f,-0.64000000f,0.31000000f,0.98000000f,-0.96000000f,-0.99000000f,-0.70000000f,0.23000000f,0.95000000f,-0.59000000f,-0.04000000f,-0.06000000f,0.95000000f,-0.52000000f,0.18000000f,0.79000000f,-0.28000000f,-0.30000000f,-0.23000000f,0.66000000f,0.49000000f,-0.21000000f,-0.84000000f,-0.27000000f,0.85000000f,0.12000000f,0.05000000f,0.39000000f,-0.21000000f,0.49000000f,-0.28000000f,-0.07000000f,0.96000000f,0.00000000f,0.78000000f,-0.54000000f,0.75000000f,0.15000000f,0.14000000f,-0.21000000f,-0.19000000f,0.06000000f,0.42000000f,0.34000000f,-0.41000000f,0.11000000f,0.44000000f,-0.02000000f,0.89000000f,0.56000000f,-0.78000000f,0.75000000f,0.06000000f,-0.22000000f,-0.32000000f,-0.78000000f,-0.52000000f,-0.46000000f,0.64000000f,-0.31000000f,-0.53000000f,-0.20000000f,0.66000000f,0.29000000f,0.91000000f,-0.84000000f,-0.82000000f,0.67000000f,-0.92000000f,-0.56000000f,0.26000000f,-0.42000000f,-0.93000000f,0.13000000f,0.90000000f,-0.20000000f,-0.40000000f,0.56000000f,-0.60000000f,0.39000000f,-0.01000000f,0.67000000f,-0.77000000f,-0.70000000f,0.30000000f,-0.21000000f,0.04000000f,-0.05000000f,-0.70000000f,0.87000000f,-0.99000000f,0.23000000f,-0.11000000f,-0.99000000f,-0.72000000f,0.22000000f,0.82000000f,0.59000000f,-0.20000000f,-0.40000000f,0.28000000f,-0.91000000f,-0.44000000f,-0.49000000f,0.67000000f,0.33000000f,0.15000000f,-0.09000000f,-0.77000000f,-0.65000000f,-0.95000000f,0.39000000f,-0.02000000f,-0.08000000f,-0.60000000f,0.10000000f,-0.72000000f,0.51000000f,-0.17000000f,-0.80000000f,-0.07000000f,0.92000000f,-0.81000000f,0.65000000f,0.86000000f,0.51000000f,-0.99000000f,0.32000000f,-0.47000000f,-0.37000000f,-0.95000000f,0.59000000f,-0.46000000f,-0.63000000f,0.84000000f,0.84000000f,-0.61000000f,0.97000000f,0.17000000f,0.48000000f,0.94000000f,-0.02000000f,0.98000000f,0.19000000f,0.16000000f,0.40000000f,0.16000000f,-0.40000000f,-0.94000000f,-0.61000000f,0.49000000f,-0.60000000f,0.52000000f,-0.62000000f,0.91000000f,0.67000000f,0.25000000f,0.68000000f,-0.03000000f,-0.03000000f,0.31000000f,-0.16000000f,0.72000000f,0.28000000f,-0.13000000f,-0.10000000f,-0.47000000f,-0.49000000f,-0.79000000f,-0.24000000f,-0.39000000f,-0.93000000f,-0.93000000f,-0.64000000f,0.79000000f,0.06000000f,-0.73000000f,-0.05000000f,-0.77000000f,-0.42000000f,-0.10000000f,-0.28000000f,-0.26000000f,0.58000000f,0.07000000f,0.80000000f,0.52000000f,-0.68000000f,0.86000000f,-0.35000000f,0.79000000f,0.50000000f,-0.83000000f,-0.52000000f,0.75000000f,-0.54000000f,0.49000000f,0.17000000f,0.29000000f,0.45000000f,-0.50000000f,-0.08000000f,0.81000000f,0.98000000f,0.57000000f,-0.57000000f,-0.73000000f,-0.54000000f,-0.94000000f,-0.91000000f,0.13000000f,0.74000000f,-0.31000000f,-0.23000000f,-0.85000000f,-0.98000000f,-0.88000000f,-0.98000000f,0.70000000f,-0.92000000f,0.85000000f,-0.96000000f,-0.71000000f,0.46000000f,0.07000000f,-0.41000000f,0.80000000f,0.35000000f,0.64000000f,0.50000000f,-0.57000000f,0.86000000f,0.13000000f,0.09000000f,-0.13000000f,0.78000000f,0.51000000f,0.66000000f,0.18000000f,0.63000000f,0.66000000f,0.05000000f,0.06000000f,-0.87000000f,-0.33000000f,-0.19000000f,-0.55000000f,0.94000000f,-0.52000000f,-0.74000000f,0.21000000f,0.33000000f,0.50000000f,0.90000000f,0.53000000f,0.80000000f,0.53000000f,-0.15000000f,0.02000000f,-0.84000000f,-0.14000000f,0.19000000f,0.51000000f,0.26000000f,0.16000000f,-0.88000000f,0.98000000f,-0.73000000f,0.28000000f,0.64000000f,-0.76000000f,0.20000000f,-0.74000000f,0.09000000f,0.21000000f,-0.67000000f,0.63000000f,-0.74000000f,0.18000000f,-0.03000000f,-0.25000000f,-0.42000000f,0.76000000f,-0.79000000f,0.98000000f,-0.48000000f,0.94000000f,0.10000000f,0.36000000f,0.47000000f,-0.56000000f,-0.69000000f,-0.74000000f,0.37000000f,0.49000000f,0.78000000f,-0.57000000f,0.14000000f,-0.83000000f,0.15000000f,-0.88000000f,0.91000000f,0.25000000f,-0.89000000f,-0.98000000f,-0.67000000f,0.74000000f,0.53000000f,-0.50000000f,-0.54000000f,-0.94000000f,-0.93000000f,0.69000000f,0.15000000f,0.76000000f,0.60000000f,0.86000000f,-0.96000000f,-0.52000000f,0.84000000f,-0.73000000f,0.10000000f,0.35000000f,-0.13000000f,0.53000000f,0.43000000f,0.19000000f,-0.59000000f,-0.02000000f,0.43000000f,0.50000000f,-0.18000000f,0.03000000f,-0.13000000f,-0.21000000f,0.46000000f,-0.07000000f,-0.99000000f,0.94000000f,-0.16000000f,-0.43000000f,0.25000000f,-0.55000000f,-0.77000000f,-0.13000000f,-0.99000000f,0.98000000f,0.69000000f,0.92000000f,-0.77000000f,-0.89000000f,-0.03000000f,0.03000000f,-0.10000000f,0.48000000f,0.47000000f,-0.95000000f,0.87000000f,-0.12000000f,0.56000000f,0.36000000f,0.56000000f,-0.04000000f,-0.97000000f,0.57000000f,-0.85000000f,-0.45000000f,0.48000000f,-0.54000000f,0.90000000f,-0.46000000f,0.49000000f,-0.02000000f,0.25000000f,-0.83000000f,0.77000000f,-0.38000000f,0.09000000f,0.35000000f,0.89000000f,-0.79000000f,-0.79000000f,0.13000000f,-0.14000000f,-0.27000000f,-0.49000000f,0.46000000f,0.43000000f,-0.91000000f,-0.79000000f,-0.67000000f,-0.15000000f,0.73000000f,0.88000000f,0.17000000f,-0.03000000f,0.22000000f,0.43000000f,0.47000000f,-0.72000000f,0.38000000f,0.23000000f,-0.28000000f,-0.14000000f,-0.02000000f,-0.23000000f,0.47000000f,0.48000000f,-0.11000000f,-0.42000000f,-0.19000000f,0.20000000f,-0.84000000f,0.91000000f,-0.17000000f,-0.52000000f,0.46000000f,-0.53000000f,0.55000000f,-0.29000000f,0.80000000f,-0.94000000f,-0.24000000f,0.53000000f,0.18000000f,0.52000000f,-0.91000000f,-0.47000000f,-0.98000000f,0.82000000f,0.81000000f,0.89000000f,-0.94000000f,-0.18000000f,0.26000000f,0.98000000f,-0.97000000f,-0.99000000f,-0.82000000f,0.67000000f,-0.88000000f,0.76000000f,-0.73000000f,0.25000000f,0.82000000f,-0.27000000f,-0.16000000f,0.35000000f,-0.61000000f,0.39000000f,0.79000000f,-0.57000000f,-0.41000000f,-0.56000000f,-0.35000000f,0.26000000f,-0.34000000f,0.74000000f,-0.10000000f,0.98000000f,-0.55000000f,-0.38000000f,-0.91000000f,-0.06000000f,-0.85000000f,0.62000000f,-0.34000000f,0.51000000f,-0.83000000f,0.91000000f,-0.09000000f,-0.54000000f,-0.79000000f,-0.37000000f,0.79000000f,0.74000000f,-0.86000000f,-0.52000000f,0.45000000f,0.04000000f,0.65000000f,-0.26000000f,0.70000000f,0.88000000f,-0.13000000f,0.36000000f,0.23000000f,0.06000000f,0.73000000f,0.16000000f,-0.53000000f,-0.91000000f,-0.56000000f,-0.07000000f,0.72000000f,-0.17000000f,-0.13000000f,0.56000000f,0.11000000f,0.19000000f,0.46000000f,-0.31000000f,0.76000000f,0.95000000f,0.68000000f,0.12000000f,0.60000000f,-0.20000000f,-0.89000000f,0.80000000f,0.78000000f,-0.21000000f,-0.04000000f,0.79000000f,-0.18000000f,0.28000000f,-0.37000000f,-0.39000000f,0.92000000f,-0.73000000f,-0.55000000f,-0.32000000f,-0.15000000f,-0.20000000f,-0.59000000f,0.71000000f,0.57000000f,-0.60000000f,-0.58000000f,-0.36000000f,0.05000000f,0.22000000f,0.08000000f,-0.37000000f,-0.73000000f,0.00000000f,0.99000000f,-0.44000000f,-0.83000000f,0.30000000f,-0.39000000f,-0.49000000f,0.40000000f,-0.33000000f,-0.64000000f,-0.07000000f,0.24000000f,-0.80000000f,0.38000000f,0.65000000f,0.18000000f,0.88000000f,0.99000000f,-0.18000000f,-0.08000000f,0.45000000f,-0.76000000f,-0.30000000f,0.87000000f,0.24000000f,-0.21000000f,-0.28000000f,0.62000000f,-0.71000000f,0.57000000f,0.92000000f,0.01000000f,0.70000000f,0.44000000f,-0.77000000f,-0.47000000f,-0.70000000f,0.72000000f,-0.67000000f,-0.60000000f,0.08000000f,-0.26000000f,0.26000000f,0.16000000f,-0.94000000f,-0.06000000f,0.46000000f,0.98000000f,-0.90000000f,0.17000000f,-0.45000000f,-0.43000000f,-0.00000000f,0.71000000f,-0.82000000f,-0.59000000f,-0.44000000f,0.03000000f,0.98000000f,-0.85000000f,-0.33000000f,0.45000000f,0.22000000f,-0.04000000f,0.59000000f,0.87000000f,0.91000000f,0.97000000f,-0.97000000f,0.69000000f,-0.60000000f,0.61000000f,-0.59000000f,-0.56000000f,-0.71000000f,-0.35000000f,0.13000000f,0.06000000f,0.81000000f,-0.19000000f,0.45000000f,0.56000000f,-0.03000000f,0.09000000f,0.28000000f,-0.75000000f,0.97000000f,0.70000000f,0.98000000f,-0.56000000f,-0.62000000f,0.52000000f,-0.57000000f,0.48000000f,0.04000000f,-0.31000000f,-0.60000000f,-0.22000000f,-0.39000000f,0.05000000f,-0.27000000f,0.15000000f,-0.40000000f,-0.47000000f,0.74000000f,0.14000000f,0.96000000f,-0.35000000f,-0.12000000f,-0.95000000f,0.32000000f,-0.99000000f,0.06000000f,-0.22000000f,-0.82000000f,-0.89000000f,0.89000000f,0.00000000f,0.98000000f,-0.90000000f,0.48000000f,0.79000000f,0.87000000f,0.10000000f,-0.29000000f,0.79000000f,-0.88000000f,-0.07000000f,-0.95000000f,-0.70000000f,0.06000000f,-0.44000000f,0.17000000f,0.94000000f,0.54000000f,0.56000000f,0.83000000f,-0.89000000f,0.80000000f,-0.41000000f,0.40000000f,-0.13000000f,0.44000000f,-0.20000000f,-0.29000000f,0.59000000f,-0.58000000f,-0.80000000f,-0.37000000f,-0.33000000f,-0.10000000f,-0.51000000f,-0.90000000f,-0.16000000f,-0.14000000f,0.97000000f,0.06000000f,0.77000000f,-0.70000000f,-0.70000000f,0.30000000f,-0.36000000f,-0.17000000f,-0.17000000f,0.70000000f,0.25000000f,0.24000000f,-0.14000000f,0.22000000f,0.81000000f,-0.16000000f,0.07000000f,-0.89000000f,0.29000000f,-0.60000000f,-0.95000000f,0.26000000f,-0.20000000f,-0.04000000f,-0.90000000f,0.55000000f,0.80000000f,-0.66000000f,0.51000000f,0.59000000f,0.71000000f,-0.51000000f,0.73000000f,0.89000000f,-0.74000000f,0.88000000f,0.70000000f,0.08000000f,0.61000000f,-0.83000000f,-0.89000000f,-0.93000000f,0.34000000f,-0.41000000f,0.85000000f,-0.74000000f,-0.46000000f,-0.48000000f,0.05000000f,0.86000000f,-0.23000000f,0.82000000f,0.92000000f,-0.41000000f,-0.61000000f,-0.76000000f,0.22000000f,-0.80000000f,-0.29000000f,0.18000000f,-0.05000000f,-0.96000000f,-0.47000000f,0.74000000f,0.81000000f,-0.73000000f,0.69000000f,-0.74000000f,-0.05000000f,-0.80000000f,-0.89000000f,0.13000000f,-0.50000000f,-0.40000000f,0.16000000f,0.03000000f,0.85000000f,-0.23000000f,0.63000000f,0.88000000f,-0.77000000f,-0.58000000f,0.47000000f,-0.70000000f,-0.40000000f,0.61000000f,0.62000000f,-0.23000000f,-0.46000000f,-0.19000000f,0.14000000f,-0.18000000f,0.67000000f,0.21000000f,-0.57000000f,-0.75000000f,-0.04000000f,0.20000000f,0.82000000f,-0.18000000f,-0.44000000f,-0.48000000f,0.11000000f,0.50000000f,-0.60000000f,0.67000000f,-0.60000000f,0.48000000f,0.58000000f,-0.92000000f,0.20000000f,-0.86000000f,0.48000000f,-0.87000000f,0.47000000f,-0.43000000f,0.04000000f,-0.90000000f,-0.50000000f,-0.79000000f,-0.28000000f,-0.25000000f,-0.20000000f,0.49000000f,-0.01000000f,0.28000000f,0.83000000f,-0.03000000f,-0.32000000f,-0.72000000f,0.76000000f,0.80000000f,-0.53000000f,-0.64000000f,-0.34000000f,0.59000000f,-0.81000000f,0.20000000f,0.10000000f,-0.13000000f,-0.40000000f,-0.51000000f,-0.57000000f,0.13000000f,0.93000000f,0.89000000f,-0.03000000f,-0.09000000f,-0.96000000f,-0.41000000f,-0.32000000f,0.14000000f,-0.94000000f,-0.21000000f,0.51000000f,0.03000000f,-0.50000000f,0.54000000f,-0.52000000f,-0.23000000f,0.22000000f,-0.73000000f,-0.49000000f,-0.80000000f,-0.84000000f,-0.26000000f,0.53000000f,-0.61000000f,0.81000000f,-0.80000000f,0.83000000f,0.35000000f,0.49000000f,-0.39000000f,-0.10000000f,0.64000000f,0.12000000f,0.65000000f,0.78000000f,-0.84000000f,-0.32000000f,0.01000000f,-0.38000000f,-0.98000000f,-0.75000000f,0.68000000f,0.16000000f,0.56000000f,-0.23000000f,-0.87000000f,0.37000000f,0.19000000f,0.71000000f,-0.73000000f,0.07000000f,-0.17000000f,0.20000000f,0.08000000f,0.33000000f,-0.49000000f,0.67000000f,-0.58000000f,-0.14000000f,-0.60000000f,-0.89000000f,-0.58000000f,-0.06000000f,0.11000000f,-0.14000000f,0.94000000f,-0.81000000f,-0.54000000f,-0.63000000f,-0.89000000f,-0.35000000f,0.90000000f,0.73000000f,0.67000000f,-0.27000000f,-0.36000000f,0.00000000f,0.11000000f,0.48000000f,0.38000000f,-0.78000000f,0.90000000f,-0.36000000f,-0.74000000f,-0.50000000f,0.90000000f,-0.77000000f,0.78000000f,-0.08000000f,0.76000000f,-0.91000000f,-0.97000000f,-0.38000000f,-0.00000000f,0.59000000f,0.79000000f,-0.53000000f,0.21000000f,0.34000000f,-0.79000000f,0.90000000f,-0.42000000f,-0.14000000f,-0.44000000f,-0.25000000f,-0.29000000f,0.34000000f,-0.08000000f,0.76000000f,0.53000000f,0.24000000f,0.07000000f,0.01000000f,-0.29000000f,-0.76000000f,-0.43000000f,-0.40000000f,0.23000000f,-0.66000000f,0.62000000f,0.79000000f,-0.07000000f,-0.26000000f,0.62000000f,-0.18000000f,-0.66000000f,0.90000000f,0.19000000f,0.58000000f,0.59000000f,-0.24000000f,-0.75000000f,-0.30000000f,0.13000000f,0.68000000f,0.08000000f,0.00000000f,-0.00000000f,0.81000000f,-0.56000000f,0.41000000f,0.58000000f,0.50000000f,-0.40000000f,0.59000000f,-0.45000000f,-0.56000000f,0.66000000f,0.02000000f,0.74000000f,-0.27000000f,0.70000000f,-0.50000000f,-0.76000000f,0.24000000f,0.94000000f,-0.61000000f,0.74000000f,-0.95000000f,0.76000000f,-0.24000000f,0.09000000f,0.87000000f,-0.02000000f,-0.73000000f,-0.43000000f,-0.26000000f,0.39000000f,-0.78000000f,-0.50000000f,-0.52000000f,-0.84000000f,-0.81000000f,-0.51000000f,0.86000000f,-0.27000000f,0.27000000f,-0.92000000f,0.39000000f,0.02000000f,0.12000000f,-0.47000000f,-0.75000000f,-0.69000000f,0.00000000f,-0.46000000f,0.19000000f,0.21000000f,-0.75000000f,0.65000000f,0.12000000f,0.74000000f,-0.92000000f,-0.88000000f,0.68000000f,0.85000000f,-0.38000000f,-0.68000000f,0.43000000f,-0.88000000f,0.12000000f,-0.02000000f,-0.77000000f,0.27000000f,0.40000000f,0.53000000f,0.95000000f,0.99000000f,0.56000000f,0.62000000f,-0.68000000f,-0.69000000f,-0.87000000f,0.09000000f,-0.91000000f,-0.25000000f,-0.66000000f,0.19000000f,-0.69000000f,-0.54000000f,0.46000000f,0.21000000f,-0.76000000f,0.84000000f,-0.83000000f,-0.30000000f,-0.30000000f,0.16000000f,0.38000000f,0.39000000f,-0.04000000f,0.32000000f,-0.68000000f,-0.43000000f,0.27000000f,0.08000000f,0.41000000f,0.93000000f,-0.61000000f,-0.54000000f,0.52000000f,-0.99000000f,0.04000000f,0.74000000f,-0.26000000f,0.25000000f,-0.28000000f,-0.60000000f,0.52000000f,-0.68000000f,0.75000000f,-0.62000000f,-0.32000000f,-0.51000000f,-0.69000000f,-0.61000000f,0.90000000f,-0.71000000f,0.81000000f,-0.20000000f,0.24000000f,0.92000000f,-0.25000000f,-0.76000000f,0.88000000f,0.88000000f,0.42000000f,-0.21000000f,0.11000000f,0.33000000f,-0.09000000f,0.01000000f,-0.72000000f,0.96000000f,0.20000000f,-0.70000000f,-0.59000000f,0.48000000f,-0.03000000f,0.42000000f,0.54000000f,0.67000000f,-0.21000000f,-0.13000000f,0.55000000f,-0.11000000f,0.26000000f,0.52000000f,0.83000000f,0.76000000f,0.21000000f,0.51000000f,-0.35000000f,0.49000000f,0.04000000f,-0.62000000f,0.88000000f,0.04000000f,0.00000000f,0.33000000f,-0.68000000f,0.72000000f,0.78000000f,-0.69000000f,0.54000000f,0.04000000f,-0.69000000f,-0.51000000f,0.56000000f,-0.05000000f,-0.68000000f,0.16000000f,0.62000000f,-0.90000000f,0.77000000f,-0.25000000f,-0.78000000f,0.25000000f,-0.86000000f,0.72000000f,-0.82000000f,-0.13000000f,-0.23000000f,0.77000000f,-0.06000000f,0.13000000f,0.29000000f,-0.79000000f,0.13000000f,-0.77000000f,-0.56000000f,-0.22000000f,-0.17000000f,-0.20000000f,-0.35000000f,0.91000000f,-0.92000000f,0.70000000f,-0.07000000f,0.99000000f,-0.44000000f,0.00000000f,-0.91000000f,0.36000000f,-0.69000000f,-0.97000000f,0.97000000f,-0.15000000f,0.76000000f,0.78000000f,-0.36000000f,-0.46000000f,0.43000000f,0.78000000f,-0.08000000f,-0.36000000f,0.91000000f,-0.15000000f,-0.49000000f,0.89000000f,-0.47000000f,-0.88000000f,0.32000000f,-0.35000000f,0.46000000f,0.86000000f,0.19000000f,0.87000000f,0.76000000f,0.41000000f,0.87000000f,0.71000000f,0.11000000f,0.78000000f,-0.87000000f,0.70000000f,-0.29000000f,-0.32000000f,0.01000000f,-0.68000000f,0.19000000f,-0.59000000f,-0.04000000f,0.89000000f,-0.46000000f,0.46000000f,-0.82000000f,0.02000000f,0.35000000f,-0.93000000f,-0.46000000f,0.58000000f,0.03000000f,-0.81000000f,0.27000000f,-0.90000000f,-0.33000000f,-0.93000000f,-0.47000000f,-0.42000000f,-0.27000000f,-0.49000000f,0.82000000f,0.12000000f,0.82000000f,0.29000000f,-0.35000000f,0.74000000f,0.00000000f,-0.70000000f,0.45000000f,-0.19000000f,0.05000000f,-0.39000000f,-0.84000000f,-0.99000000f,-0.22000000f,-0.71000000f,-0.60000000f,-0.54000000f,0.21000000f,0.61000000f,0.18000000f,0.08000000f,0.19000000f,-0.06000000f,-0.98000000f,0.21000000f,-0.78000000f,0.15000000f,0.68000000f,-0.53000000f,0.31000000f,0.89000000f,-0.01000000f,-0.73000000f,0.02000000f,0.40000000f,-0.37000000f,0.23000000f,-0.95000000f,0.62000000f,0.84000000f,-0.35000000f,-0.63000000f,0.96000000f,-0.47000000f,0.14000000f,0.80000000f,-0.68000000f,0.29000000f,0.99000000f,0.49000000f,-0.01000000f,0.16000000f,0.19000000f,-0.38000000f,0.63000000f,-0.93000000f,-0.31000000f,0.83000000f,-0.64000000f,-0.72000000f,0.49000000f,-0.87000000f,0.09000000f,0.89000000f,-0.76000000f,-0.98000000f,0.36000000f,0.71000000f,0.07000000f,0.99000000f,-0.47000000f,-0.41000000f,0.68000000f,0.86000000f,0.77000000f,0.92000000f,-0.79000000f,-0.22000000f,0.24000000f,0.09000000f,-0.45000000f,0.00000000f,0.22000000f,-0.96000000f,-0.50000000f,0.87000000f,0.06000000f,0.93000000f,-0.39000000f,-0.39000000f,-0.39000000f,-0.36000000f,-0.11000000f,0.77000000f,-0.29000000f,0.32000000f,-0.60000000f,-0.69000000f,-0.35000000f,0.12000000f,-0.30000000f,0.66000000f,0.29000000f,-0.45000000f,-0.18000000f,-0.95000000f,0.75000000f,-0.69000000f,-0.71000000f,-0.93000000f,-0.25000000f,-0.36000000f,0.81000000f,-0.79000000f,0.17000000f,0.93000000f,-0.60000000f,-0.98000000f,0.55000000f,-0.87000000f,-0.67000000f,0.32000000f,0.80000000f,0.79000000f,0.62000000f,0.44000000f,-0.19000000f,-0.48000000f,0.34000000f,0.89000000f,0.72000000f,0.37000000f,-0.82000000f,-0.49000000f,-0.71000000f,-0.40000000f,-0.08000000f,-0.05000000f,-0.30000000f,-0.46000000f,0.50000000f,0.24000000f,0.85000000f,-0.95000000f,-0.62000000f,-0.45000000f,-0.09000000f,0.42000000f,-0.95000000f,-0.20000000f,0.21000000f,-0.50000000f,0.39000000f,-0.38000000f,-0.74000000f,0.69000000f,-0.65000000f,0.43000000f,0.60000000f,-0.48000000f,-0.81000000f,-0.14000000f,-0.90000000f,0.56000000f,0.42000000f,0.39000000f,-0.13000000f,0.76000000f,0.06000000f,-0.46000000f,-0.55000000f,0.60000000f,0.72000000f,-0.05000000f,-0.20000000f,-0.17000000f,-0.40000000f,0.23000000f,-0.55000000f,0.90000000f,-0.49000000f,0.58000000f,0.34000000f,0.72000000f,-0.72000000f,-0.54000000f,-0.43000000f,-0.80000000f,-0.49000000f,-0.76000000f,-0.76000000f,-0.11000000f,0.55000000f,-0.68000000f,0.14000000f,-0.98000000f,0.20000000f,0.93000000f,0.19000000f,0.52000000f,-0.26000000f,0.89000000f,-0.82000000f,-0.02000000f,-0.47000000f,0.74000000f,-0.94000000f,-0.01000000f,0.90000000f,0.68000000f,0.20000000f,0.36000000f,-0.50000000f,-0.99000000f,0.20000000f,0.05000000f,-0.18000000f,-0.06000000f,-0.39000000f,0.60000000f,-0.12000000f,-0.94000000f,0.89000000f,-0.31000000f,0.00000000f,0.35000000f,0.74000000f,-0.24000000f,-0.88000000f,0.41000000f,-0.78000000f,-0.04000000f,0.38000000f,-0.17000000f,0.93000000f,0.48000000f,0.31000000f,0.60000000f,-0.20000000f,-0.78000000f,0.85000000f,-0.03000000f,0.26000000f,0.88000000f,0.17000000f,0.82000000f,0.39000000f,-0.03000000f,0.10000000f,0.13000000f,0.72000000f,0.15000000f,0.40000000f,-0.39000000f,0.32000000f,0.44000000f,-0.75000000f,-0.64000000f,-0.29000000f,0.77000000f,-0.50000000f,0.74000000f,0.71000000f,-0.08000000f,-0.30000000f,-0.42000000f,0.17000000f,-0.52000000f,0.84000000f,-0.07000000f,-0.89000000f,-0.60000000f,-0.04000000f,0.64000000f,-0.73000000f,-0.10000000f,-0.82000000f,0.87000000f,-0.78000000f,0.23000000f,0.67000000f,-0.98000000f,-0.68000000f,0.66000000f,0.82000000f,0.64000000f,0.40000000f,0.55000000f,0.91000000f,-0.02000000f,0.01000000f,0.13000000f,-0.82000000f,-0.86000000f,0.79000000f,-0.06000000f,-0.58000000f,0.75000000f,0.99000000f,-0.05000000f,0.32000000f,-0.07000000f,0.97000000f,0.49000000f,0.40000000f,0.42000000f,0.86000000f,-0.62000000f,0.54000000f,0.57000000f,0.90000000f,-0.76000000f,0.54000000f,-0.61000000f,0.32000000f,0.66000000f,0.21000000f,-0.24000000f,-0.70000000f,0.02000000f,0.27000000f,0.78000000f,-0.45000000f,0.29000000f,0.18000000f,-0.06000000f,0.78000000f,0.38000000f,-0.41000000f,0.14000000f,0.50000000f,-0.43000000f,-0.45000000f,0.68000000f,-0.30000000f,-0.79000000f,-0.88000000f,0.57000000f,-0.06000000f,0.36000000f,0.16000000f,0.14000000f,0.48000000f,-0.27000000f,0.46000000f,-0.78000000f,-0.23000000f,0.20000000f,0.34000000f,0.26000000f,0.34000000f,-0.40000000f,0.07000000f,0.00000000f,0.28000000f,-0.92000000f,-0.23000000f,0.46000000f,-0.60000000f,-0.69000000f,-0.98000000f,0.49000000f,0.21000000f,-0.65000000f,-0.01000000f,0.56000000f,-0.42000000f,0.88000000f,0.96000000f,0.40000000f,0.60000000f,-0.24000000f,-0.93000000f,-0.82000000f,0.64000000f,0.23000000f,-0.24000000f,0.28000000f,-0.50000000f,0.48000000f,0.23000000f,0.52000000f,0.75000000f,0.30000000f,0.59000000f,-0.63000000f,0.46000000f,0.47000000f,-0.91000000f,0.70000000f,0.29000000f,-0.47000000f,0.12000000f,-0.82000000f,0.72000000f,-0.20000000f,-0.48000000f,0.07000000f,0.39000000f,0.72000000f,0.24000000f,0.44000000f,0.79000000f,-0.44000000f,-0.59000000f,0.25000000f,-0.95000000f,-0.60000000f,0.24000000f,-0.40000000f,0.50000000f,-0.05000000f,-0.86000000f,0.49000000f,0.95000000f,0.92000000f,-0.87000000f,0.29000000f,-0.71000000f,-0.14000000f,0.37000000f,0.24000000f,0.91000000f,0.82000000f,-0.64000000f,0.12000000f,-0.39000000f,0.53000000f,-0.95000000f,0.32000000f,0.87000000f,-0.90000000f,0.97000000f,-0.85000000f,0.09000000f,-0.54000000f,-0.75000000f,0.74000000f,-0.59000000f,0.51000000f,-0.23000000f,-0.14000000f,-0.64000000f,0.51000000f,0.39000000f,0.60000000f,0.36000000f,0.16000000f,-0.64000000f,0.27000000f,-0.16000000f,0.32000000f,-0.99000000f,0.77000000f,0.48000000f,-0.71000000f,0.55000000f,0.73000000f,0.44000000f,-0.92000000f,-0.29000000f,0.44000000f,0.10000000f,-0.53000000f,-0.71000000f,-0.09000000f,-0.46000000f,-0.66000000f,-0.31000000f,0.05000000f,0.92000000f,-0.52000000f,0.04000000f,0.94000000f,0.91000000f,0.09000000f,0.03000000f,0.23000000f,-0.88000000f,-0.92000000f,0.91000000f,-0.47000000f,0.04000000f,0.37000000f,-0.75000000f,0.74000000f,0.77000000f,-0.69000000f,-0.02000000f,-0.90000000f,0.64000000f,-0.38000000f,-0.21000000f,0.76000000f,0.71000000f,0.38000000f,-0.89000000f,0.36000000f,-0.17000000f,0.86000000f,0.13000000f,0.45000000f,0.36000000f,-0.06000000f,0.40000000f,0.33000000f,-0.53000000f,-0.47000000f,0.71000000f,0.10000000f,0.63000000f,0.84000000f,-0.22000000f,0.07000000f,0.76000000f,0.98000000f,-0.43000000f,-0.54000000f,0.42000000f,-0.23000000f,-0.75000000f,-0.67000000f,0.62000000f,0.55000000f,0.24000000f,-0.77000000f,-0.45000000f,0.77000000f,0.30000000f,-0.80000000f,-0.47000000f,0.70000000f,0.03000000f,-0.26000000f,-0.10000000f,0.16000000f,0.98000000f,-0.33000000f,-0.64000000f,0.67000000f,0.31000000f,-0.61000000f,-0.09000000f,0.54000000f,-0.23000000f,-0.18000000f,-0.41000000f,-0.32000000f,-0.43000000f,0.35000000f,-0.85000000f,-0.45000000f,0.53000000f,0.24000000f,0.86000000f,-0.45000000f,0.37000000f,0.37000000f,-0.87000000f,-0.44000000f,-0.67000000f,0.66000000f,-0.78000000f,0.84000000f,0.10000000f,0.74000000f,-0.33000000f,-0.74000000f,0.28000000f,0.30000000f,0.43000000f,0.57000000f,0.48000000f,-0.36000000f,-0.84000000f,0.82000000f,0.03000000f,0.36000000f,0.04000000f,0.93000000f,-0.42000000f,0.73000000f,-0.33000000f,0.54000000f,-0.85000000f,0.28000000f,0.19000000f,0.31000000f,-0.06000000f,0.59000000f,0.01000000f,0.46000000f,-0.68000000f,-0.79000000f,-0.91000000f,0.95000000f,-0.04000000f,0.59000000f,0.66000000f,-0.03000000f,-0.35000000f,0.77000000f,0.27000000f,0.48000000f,0.04000000f,-0.91000000f,-0.90000000f,-0.38000000f,-0.43000000f,0.19000000f,0.47000000f,0.10000000f,0.01000000f,-0.15000000f,0.38000000f,0.74000000f,0.24000000f,0.68000000f,0.66000000f,-0.06000000f,-0.09000000f,0.79000000f,0.06000000f,-0.98000000f,-0.26000000f,-0.11000000f,-0.01000000f,-0.63000000f,0.17000000f,-0.20000000f,0.94000000f,0.04000000f,0.15000000f,-0.41000000f,-0.88000000f,0.62000000f,-0.03000000f,-0.95000000f,-0.99000000f,-0.35000000f,-0.79000000f,-0.08000000f,0.13000000f,0.45000000f,-0.79000000f,0.30000000f,-0.97000000f,0.53000000f,-0.87000000f,-0.00000000f,0.41000000f,-0.90000000f,0.46000000f,0.14000000f,-0.71000000f,-0.34000000f,0.06000000f,-0.93000000f,-0.31000000f,-0.91000000f,0.88000000f,0.76000000f,-0.69000000f,0.51000000f,-0.97000000f,0.40000000f,-0.95000000f,0.75000000f,-0.95000000f,-0.33000000f,0.74000000f,-0.86000000f,0.17000000f,0.73000000f,0.70000000f,-0.41000000f,0.11000000f,0.91000000f,0.94000000f,-0.67000000f,0.40000000f,0.18000000f,0.01000000f,0.17000000f,-0.10000000f,0.24000000f,0.54000000f,-0.01000000f,0.30000000f,0.21000000f,0.54000000f,-0.37000000f,-0.56000000f,0.76000000f,-0.57000000f,0.23000000f,-0.87000000f,0.35000000f,0.35000000f,0.84000000f,-0.47000000f,0.32000000f,-0.51000000f,0.45000000f,0.03000000f,0.84000000f,0.02000000f,0.74000000f,0.40000000f,-0.56000000f,0.08000000f,0.36000000f,0.97000000f,0.25000000f,0.03000000f,0.48000000f,-0.03000000f,0.65000000f,0.71000000f,-0.04000000f,0.85000000f,0.05000000f,0.13000000f,-0.08000000f,0.81000000f,0.32000000f,-0.34000000f,-0.79000000f,-0.45000000f,0.77000000f,-0.89000000f,0.79000000f,-0.23000000f,-0.65000000f,-0.43000000f,0.55000000f,0.99000000f,0.68000000f,-0.43000000f,0.25000000f,-0.19000000f,-0.32000000f,-0.03000000f,-0.61000000f,0.01000000f,0.10000000f,0.14000000f,0.82000000f,0.50000000f,0.96000000f,0.24000000f,-0.44000000f,-0.21000000f,0.05000000f,-0.28000000f,0.58000000f,0.29000000f,-0.08000000f,0.83000000f,-0.95000000f,-0.21000000f,-0.49000000f,0.61000000f,-0.37000000f,-0.47000000f,0.50000000f,-0.33000000f,-0.83000000f,0.00000000f,-0.68000000f,0.06000000f,-0.96000000f,-0.74000000f,0.57000000f,0.34000000f,-0.54000000f,-0.77000000f,-0.73000000f,0.84000000f,0.81000000f,-0.90000000f,0.95000000f,0.57000000f,-0.79000000f,0.35000000f,0.54000000f,-0.50000000f,-0.86000000f,0.13000000f,0.16000000f,0.75000000f,0.64000000f,-0.74000000f,-0.72000000f,-0.85000000f,0.87000000f,-0.71000000f,0.43000000f,-0.06000000f,-0.69000000f,0.12000000f,-0.06000000f,0.36000000f,-0.34000000f,0.79000000f,0.02000000f,-0.83000000f,0.91000000f,0.40000000f,0.46000000f,0.90000000f,-0.72000000f,0.02000000f,0.01000000f,-0.45000000f,0.30000000f,-0.12000000f,-0.09000000f,-0.14000000f,0.55000000f,-0.33000000f,0.34000000f,-0.82000000f,0.90000000f,0.45000000f,0.95000000f,-0.62000000f,-0.49000000f,0.06000000f,-0.15000000f,0.66000000f,0.10000000f,-0.92000000f,0.71000000f,0.04000000f,-0.28000000f,-0.83000000f,-0.37000000f,0.18000000f,0.37000000f,0.49000000f,0.82000000f,-0.53000000f,-0.30000000f,0.17000000f,-0.65000000f,-0.06000000f,0.29000000f,-0.89000000f,-0.74000000f,-0.21000000f,-0.85000000f,0.93000000f,-0.51000000f,0.29000000f,-0.86000000f,-0.20000000f,-0.19000000f,0.39000000f,-0.51000000f,0.54000000f,-0.67000000f,0.27000000f,-0.23000000f,0.23000000f,0.43000000f,0.65000000f,0.71000000f,0.95000000f,-0.84000000f,0.84000000f,-0.44000000f,-0.78000000f,0.05000000f,0.84000000f,0.05000000f,-0.54000000f,-0.18000000f,-0.41000000f,-0.80000000f,0.05000000f,-0.41000000f,-0.97000000f,0.34000000f,0.64000000f,-0.94000000f,0.19000000f,0.22000000f,0.85000000f,0.58000000f,0.92000000f,-0.07000000f,-0.41000000f,0.30000000f,-0.01000000f,0.72000000f,-0.28000000f,0.91000000f,0.82000000f,0.92000000f,0.17000000f,-0.08000000f,-0.69000000f,-0.92000000f,0.05000000f,0.45000000f,-0.72000000f,-0.34000000f,0.36000000f,0.35000000f,-0.18000000f,0.55000000f,-0.21000000f,-0.69000000f,-0.60000000f,0.86000000f,0.85000000f,0.47000000f,0.48000000f,0.49000000f,-0.31000000f,0.03000000f,-0.42000000f,-0.28000000f,0.38000000f,-0.94000000f,0.82000000f,0.25000000f,-0.40000000f,-0.95000000f,0.81000000f,-0.21000000f,0.50000000f,-0.55000000f,-0.02000000f,-0.91000000f,-0.10000000f,0.45000000f,-0.30000000f,0.31000000f,0.80000000f,-0.57000000f,0.41000000f,-0.83000000f,0.28000000f,-0.02000000f,0.11000000f,-0.45000000f,0.84000000f,0.03000000f,0.14000000f,0.76000000f,-0.21000000f,-0.04000000f,-0.52000000f,-0.55000000f,-0.03000000f,-0.98000000f,0.48000000f,0.91000000f,-0.39000000f,0.57000000f,0.45000000f,0.29000000f,-0.05000000f,-0.33000000f,-0.65000000f,-0.62000000f,0.98000000f,-0.35000000f,0.61000000f,0.81000000f,0.61000000f,-0.51000000f,0.43000000f,-0.36000000f,0.73000000f,-0.20000000f,-0.18000000f,0.05000000f,0.04000000f,-0.83000000f,0.38000000f,-0.98000000f,-0.62000000f,0.07000000f,0.65000000f,-0.23000000f,0.49000000f,-0.33000000f,-0.85000000f,0.33000000f,-0.51000000f,-0.08000000f,-0.21000000f,0.66000000f,0.84000000f,-0.36000000f,-0.01000000f,0.99000000f,0.48000000f,-0.79000000f,0.18000000f,0.82000000f,0.11000000f,-0.38000000f,-0.49000000f,0.24000000f,0.20000000f,0.16000000f,0.60000000f,-0.33000000f,0.58000000f,0.77000000f,-0.43000000f,-0.65000000f,0.81000000f,0.14000000f,0.36000000f,0.00000000f,-0.87000000f,-0.57000000f,-0.01000000f,-0.02000000f,0.30000000f,0.14000000f,-0.17000000f,0.18000000f,0.17000000f,0.64000000f,0.64000000f,0.57000000f,-0.72000000f,0.12000000f,-0.33000000f,0.73000000f,0.54000000f,-0.36000000f,0.16000000f,0.62000000f,0.01000000f,0.09000000f,0.36000000f,-0.65000000f,-0.72000000f,-0.02000000f,-0.40000000f,0.55000000f,-0.54000000f,-0.20000000f,0.24000000f,0.97000000f,-0.31000000f,0.96000000f,0.74000000f,0.71000000f,0.10000000f,0.79000000f,-0.64000000f,0.17000000f,-0.56000000f,0.27000000f,-0.62000000f,-0.65000000f,0.73000000f,0.17000000f,-0.06000000f,0.67000000f,-0.39000000f,-0.46000000f,0.25000000f,0.64000000f,-0.22000000f,-0.13000000f,0.35000000f,0.70000000f,-0.70000000f,-0.60000000f,-0.14000000f,-0.53000000f,-0.09000000f,0.59000000f,-0.09000000f,-0.12000000f,-0.28000000f,-0.65000000f,0.69000000f,0.48000000f,0.11000000f,-0.82000000f,-0.15000000f,-0.01000000f,0.06000000f,0.96000000f,-0.14000000f,0.51000000f,0.39000000f,0.66000000f,-0.27000000f,-0.52000000f,0.54000000f,-0.87000000f,-0.18000000f,-0.69000000f,-0.19000000f,-0.20000000f,0.19000000f,-0.06000000f,0.27000000f,0.18000000f,-0.26000000f,-0.45000000f,-0.09000000f,0.47000000f,-0.15000000f,-0.05000000f,0.54000000f,0.80000000f,0.86000000f,-0.60000000f,-0.02000000f,0.74000000f,0.07000000f,-0.10000000f,-0.73000000f,0.56000000f,0.67000000f,0.51000000f,0.23000000f,0.69000000f,0.85000000f,0.21000000f,-0.92000000f,0.15000000f,0.53000000f,0.12000000f,0.43000000f,-0.26000000f,-0.50000000f,0.29000000f,0.92000000f,-0.29000000f,-0.25000000f,0.94000000f,-0.92000000f,0.53000000f,0.14000000f,0.93000000f,0.88000000f,0.09000000f,-0.29000000f,0.59000000f,0.98000000f,0.49000000f,0.64000000f,-0.18000000f,-0.75000000f,-0.26000000f,-0.47000000f,0.64000000f,0.87000000f,0.46000000f,-0.51000000f,0.04000000f,-0.46000000f,0.00000000f,-0.67000000f,-0.78000000f,0.05000000f,-0.35000000f,0.21000000f,-0.42000000f,-0.85000000f,0.02000000f,0.78000000f,0.86000000f,-0.93000000f,-0.28000000f,0.54000000f,-0.41000000f,-0.83000000f,0.95000000f,-0.72000000f,0.31000000f,0.67000000f,-0.22000000f,-0.07000000f,0.74000000f,0.26000000f,0.27000000f,-0.78000000f,-0.23000000f,0.57000000f,0.55000000f,-0.27000000f,0.17000000f,0.57000000f,0.63000000f,-0.05000000f,-0.76000000f,-0.25000000f,0.37000000f,-0.29000000f,-0.48000000f,0.92000000f,-0.87000000f,-0.08000000f,-0.68000000f,0.61000000f,0.24000000f,-0.48000000f,-0.70000000f,0.61000000f,-0.01000000f,-0.96000000f,-0.54000000f,0.08000000f,-0.75000000f,0.06000000f,0.60000000f,-0.89000000f,0.34000000f,0.76000000f,-0.25000000f,0.34000000f,-0.94000000f,0.00000000f,0.60000000f,-0.24000000f,-0.10000000f,-0.98000000f,-0.56000000f,-0.74000000f,-0.36000000f,0.27000000f,0.74000000f,0.88000000f,-0.94000000f,0.25000000f,-0.85000000f,-0.39000000f,-0.37000000f,0.25000000f,-0.80000000f,0.10000000f,0.52000000f,-0.53000000f,0.20000000f,0.59000000f,-0.17000000f,-0.57000000f,0.45000000f,0.39000000f,-0.63000000f,0.37000000f,0.45000000f,-0.81000000f,-0.16000000f,0.18000000f,0.66000000f,-0.23000000f,-0.98000000f,-0.81000000f,0.47000000f,0.18000000f,0.24000000f,0.38000000f,-0.79000000f,-0.73000000f,0.28000000f,-0.81000000f,0.39000000f,-0.15000000f,0.93000000f,-0.83000000f,-0.42000000f,-0.70000000f,-0.09000000f,-0.95000000f,0.23000000f,0.25000000f,-0.44000000f,-0.79000000f,-0.68000000f,-0.26000000f,-0.04000000f,0.05000000f,-0.39000000f,-0.23000000f,0.22000000f,-0.25000000f,-0.30000000f,-0.00000000f,-0.03000000f,-0.42000000f,0.94000000f,0.27000000f,0.98000000f,-0.32000000f,0.88000000f,0.49000000f,0.75000000f,0.76000000f,0.02000000f,-0.10000000f,0.26000000f,-0.54000000f,-0.00000000f,-0.91000000f,0.30000000f,0.48000000f,0.30000000f,-0.54000000f,0.58000000f,0.13000000f,0.95000000f,0.43000000f,-0.90000000f,-0.79000000f,0.82000000f,-0.03000000f,0.28000000f,-0.69000000f,0.87000000f,-0.35000000f,-0.34000000f,0.97000000f,-0.17000000f,0.03000000f,0.61000000f,0.32000000f,-0.05000000f,0.47000000f,-0.35000000f,-0.48000000f,-0.50000000f,0.37000000f,0.84000000f,0.50000000f,-0.82000000f,0.26000000f,0.47000000f,-0.36000000f,-0.42000000f,0.58000000f,0.71000000f,0.87000000f,0.59000000f,0.92000000f,0.31000000f,0.66000000f,-0.28000000f,-0.13000000f,-0.19000000f,-0.95000000f,0.57000000f,-0.81000000f,0.95000000f,0.16000000f,0.62000000f,-0.60000000f,-0.03000000f,0.75000000f,0.40000000f,0.40000000f,0.78000000f,0.95000000f,0.59000000f,-0.00000000f,0.79000000f,0.49000000f,-0.76000000f,0.91000000f,-0.76000000f,-0.74000000f,-0.68000000f,0.97000000f,0.98000000f,-0.97000000f,0.91000000f,-0.93000000f,0.47000000f,0.86000000f,0.88000000f,-0.56000000f,0.84000000f,-0.00000000f,0.02000000f,-0.23000000f,0.95000000f,0.58000000f,-0.00000000f,0.84000000f,-0.65000000f,0.77000000f,-0.27000000f,-0.42000000f,-0.54000000f,0.19000000f,-0.77000000f,-0.59000000f,0.81000000f,0.45000000f,0.96000000f,0.39000000f,-0.46000000f,-0.74000000f,-0.59000000f,0.93000000f,-0.12000000f,0.26000000f,-0.74000000f,0.28000000f,-0.83000000f,0.58000000f,0.20000000f,0.25000000f,-0.39000000f,0.85000000f,0.29000000f,0.90000000f,-0.42000000f,0.95000000f,0.49000000f,-0.11000000f,-0.66000000f,0.65000000f,0.91000000f,-0.98000000f,-0.61000000f,-0.72000000f,0.20000000f,0.25000000f,0.39000000f,0.76000000f,-0.13000000f,0.56000000f,0.78000000f,0.90000000f,0.10000000f,0.54000000f,0.49000000f,-0.85000000f,0.50000000f,0.91000000f,-0.72000000f,-0.00000000f,0.80000000f,-0.25000000f,0.07000000f,-0.18000000f,0.87000000f,-0.93000000f,0.02000000f,0.03000000f,-0.15000000f,0.37000000f,0.50000000f,-0.21000000f,-0.17000000f,0.78000000f,-0.40000000f,0.70000000f,-0.96000000f,-0.74000000f,0.05000000f,0.22000000f,-0.04000000f,0.78000000f,0.99000000f,0.65000000f,0.63000000f,0.66000000f,0.40000000f,0.53000000f,-0.91000000f,0.46000000f,0.43000000f,0.18000000f,0.65000000f,-0.58000000f,0.73000000f,0.60000000f,0.57000000f,0.72000000f,0.71000000f,0.15000000f,0.70000000f,-0.47000000f,-0.82000000f,-0.38000000f,0.89000000f,-0.91000000f,0.72000000f,0.13000000f,-0.81000000f,-0.79000000f,-0.58000000f,-0.13000000f,0.28000000f,0.79000000f,0.46000000f,0.34000000f,0.27000000f,0.26000000f,0.00000000f,0.39000000f,0.89000000f,0.24000000f,0.83000000f,0.91000000f,-0.87000000f,-0.49000000f,0.30000000f,-0.11000000f,0.77000000f,-0.97000000f,-0.36000000f,-0.41000000f,-0.68000000f,0.85000000f,0.79000000f,0.30000000f,0.81000000f,-0.57000000f,0.91000000f,-0.04000000f,-0.22000000f,-0.16000000f,0.95000000f,0.60000000f,0.27000000f,-0.73000000f,0.26000000f,-0.18000000f,0.50000000f,-0.79000000f,0.10000000f,-0.69000000f,-0.23000000f,0.07000000f,0.76000000f,-0.41000000f,-0.13000000f,-0.64000000f,-0.15000000f,0.47000000f,-0.03000000f,0.93000000f,0.95000000f,-0.67000000f,0.72000000f,-0.80000000f,-0.17000000f,0.98000000f,0.45000000f,-0.91000000f,0.94000000f,-0.67000000f,0.51000000f,0.81000000f,-0.37000000f,0.49000000f,0.43000000f,0.26000000f,0.83000000f,-0.88000000f,-0.10000000f,0.05000000f,0.41000000f,-0.13000000f,-0.32000000f,0.75000000f,0.37000000f,-0.26000000f,-0.42000000f,-0.41000000f,0.79000000f,0.37000000f,-0.06000000f,0.77000000f,-0.61000000f,0.23000000f,0.57000000f,0.28000000f,0.63000000f,-0.43000000f,-0.09000000f,0.22000000f,-0.86000000f,-0.07000000f,0.22000000f,0.48000000f,-0.05000000f,0.71000000f,-0.98000000f,0.47000000f,0.46000000f,0.02000000f,-0.52000000f,-0.24000000f,0.35000000f,-0.02000000f,-0.30000000f,-0.80000000f,-0.18000000f,-0.81000000f,0.19000000f,-0.74000000f,-0.04000000f,-0.58000000f,-0.51000000f,-0.71000000f,-0.28000000f,0.23000000f,-0.51000000f,-0.05000000f,0.88000000f,-0.55000000f,0.54000000f,0.41000000f,-0.06000000f,-0.58000000f,0.32000000f,0.93000000f,-0.14000000f,-0.61000000f,-0.05000000f,0.13000000f,-0.73000000f,-0.19000000f,-0.49000000f,0.59000000f,0.53000000f,0.97000000f,0.64000000f,0.02000000f,0.39000000f,-0.95000000f,-0.87000000f,-0.87000000f,0.96000000f,-0.90000000f,-0.68000000f,0.74000000f,-0.76000000f,-0.08000000f,-0.19000000f,-0.11000000f,-0.32000000f,0.95000000f,-0.13000000f,0.70000000f,-0.81000000f,0.67000000f,0.09000000f,-0.64000000f,-0.24000000f,0.70000000f,0.46000000f,0.28000000f,0.21000000f,-0.10000000f,0.49000000f,-0.22000000f,0.64000000f,0.34000000f,-0.10000000f,-0.78000000f,-0.11000000f,-0.04000000f,-0.31000000f,-0.63000000f,-0.45000000f,0.12000000f,0.71000000f,0.88000000f,-0.41000000f,0.30000000f,0.51000000f,-0.73000000f,0.54000000f,-0.00000000f,0.39000000f,0.62000000f,0.81000000f,0.65000000f,-0.26000000f,-0.35000000f,0.84000000f,-0.12000000f,0.77000000f,0.65000000f,0.77000000f,-0.42000000f,0.54000000f,0.95000000f,-0.82000000f,0.46000000f,0.83000000f,0.15000000f,-0.11000000f,-0.06000000f,0.41000000f,0.87000000f,-0.74000000f,-0.24000000f,0.37000000f,0.94000000f,-0.42000000f,-0.56000000f,-0.01000000f,-0.15000000f,0.03000000f,0.49000000f,-0.75000000f,0.18000000f,0.42000000f,0.54000000f,0.39000000f,0.70000000f,-0.49000000f,0.08000000f,0.68000000f,-0.25000000f,0.36000000f,0.38000000f,0.44000000f,-0.52000000f,0.86000000f,-0.02000000f,0.69000000f,0.90000000f,0.89000000f,-0.77000000f,0.14000000f,-0.78000000f,-0.64000000f,0.40000000f,-0.09000000f,0.78000000f,-0.81000000f,0.94000000f,0.46000000f,-0.53000000f,0.04000000f,-0.46000000f,0.71000000f,-0.85000000f,0.66000000f,-0.51000000f,-0.09000000f,0.91000000f,0.38000000f,-0.26000000f,0.91000000f,-0.04000000f,-0.86000000f,-0.03000000f,0.83000000f,-0.69000000f,0.35000000f,0.65000000f,-0.03000000f,0.65000000f,0.68000000f,0.56000000f,0.30000000f,-0.46000000f,0.73000000f,0.02000000f,-0.21000000f,0.85000000f,0.48000000f,0.91000000f,0.05000000f,0.15000000f,-0.32000000f,0.39000000f,-0.33000000f,-0.84000000f,-0.66000000f,-0.41000000f,0.98000000f,-0.03000000f,0.56000000f,0.30000000f,0.37000000f,-0.86000000f,0.60000000f,0.47000000f,-0.24000000f,0.53000000f,-0.85000000f,0.66000000f,0.53000000f,-0.31000000f,-0.44000000f,0.88000000f,0.34000000f,-0.73000000f,-0.48000000f,-0.33000000f,-0.73000000f,0.56000000f,0.45000000f,0.18000000f,-0.76000000f,0.56000000f,0.23000000f,-0.83000000f,0.97000000f,-0.48000000f,-0.80000000f,-0.66000000f,0.17000000f,0.74000000f,0.39000000f,-0.02000000f,0.49000000f,-0.33000000f,-0.73000000f,-0.81000000f,0.27000000f,0.21000000f,0.38000000f,-0.68000000f,-0.20000000f,-0.09000000f,-0.96000000f,-0.61000000f,-0.93000000f,-0.99000000f,-0.16000000f,0.15000000f,0.62000000f,0.24000000f,0.74000000f,-0.65000000f,0.35000000f,0.26000000f,0.38000000f,-0.64000000f,-0.67000000f,0.80000000f,0.26000000f,0.30000000f,-0.56000000f,0.20000000f,-0.82000000f,0.06000000f,0.81000000f,0.75000000f,0.82000000f,-0.82000000f,0.55000000f,-0.91000000f,0.37000000f,0.16000000f,-0.03000000f,-0.13000000f,0.09000000f,-0.67000000f,-0.33000000f,-0.18000000f,-0.13000000f,-0.98000000f,-0.81000000f,-0.72000000f,0.49000000f,-0.96000000f,-0.22000000f,0.65000000f,0.35000000f,-0.35000000f,-0.60000000f,-0.64000000f,0.19000000f,-0.57000000f,0.73000000f,-0.70000000f,-0.89000000f,0.46000000f,-0.77000000f,-0.32000000f,0.55000000f,-0.81000000f,-0.61000000f,0.97000000f,-0.49000000f,0.30000000f,0.42000000f,0.66000000f,0.19000000f,0.55000000f,-0.72000000f,-0.95000000f,-0.65000000f,-0.28000000f,-0.75000000f,-0.22000000f,0.29000000f,0.56000000f,-0.02000000f,-0.15000000f,-0.80000000f,0.68000000f,-0.05000000f,-0.35000000f,0.68000000f,-0.84000000f,0.95000000f,-0.14000000f,0.04000000f,0.64000000f,0.49000000f,0.02000000f,0.74000000f,0.57000000f,0.58000000f,0.01000000f,0.62000000f,-0.87000000f,0.76000000f,0.37000000f,0.27000000f,-0.51000000f,0.07000000f,0.31000000f,0.39000000f,0.61000000f,0.60000000f,-0.14000000f,0.62000000f,0.01000000f,-0.10000000f,-0.43000000f,-0.23000000f,-0.91000000f,0.99000000f,0.58000000f,0.81000000f,-0.39000000f,-0.98000000f,0.96000000f,0.02000000f,0.38000000f,-0.94000000f,-0.46000000f,-0.02000000f,0.46000000f,0.48000000f,-0.39000000f,-0.46000000f,0.89000000f,-0.62000000f,0.10000000f,0.81000000f,0.53000000f,-0.96000000f,-0.33000000f,-0.58000000f,-0.17000000f,-0.73000000f,0.12000000f,0.05000000f,0.63000000f,-0.83000000f,0.01000000f,-0.02000000f,-0.00000000f,-0.01000000f,-0.79000000f,0.78000000f,0.48000000f,-0.44000000f,0.46000000f,0.48000000f,-0.72000000f,-0.53000000f,0.08000000f,0.00000000f,-0.12000000f,-0.93000000f,-0.87000000f,-0.32000000f,-0.49000000f,0.35000000f,-0.63000000f,-0.20000000f,0.99000000f,0.01000000f,-0.23000000f,0.41000000f,-0.32000000f,0.12000000f,0.85000000f,0.31000000f,0.43000000f,0.21000000f,0.60000000f,-0.33000000f,-0.71000000f,-0.84000000f,-0.23000000f,-0.06000000f,-0.23000000f,0.08000000f,0.89000000f,0.99000000f,0.64000000f,0.65000000f,-0.55000000f,0.60000000f,-0.07000000f,-0.62000000f,0.74000000f,0.57000000f,0.85000000f,0.27000000f,0.56000000f,-0.87000000f,0.00000000f,-0.37000000f,-0.67000000f,0.07000000f,0.49000000f,0.44000000f,-0.92000000f,0.48000000f,0.70000000f,-0.86000000f,0.33000000f,0.39000000f,0.71000000f,0.43000000f,0.80000000f,-0.52000000f,0.01000000f,-0.54000000f,-0.95000000f,-0.39000000f,0.40000000f,-0.75000000f,0.08000000f,0.76000000f,-0.62000000f,-0.39000000f,0.94000000f,0.31000000f,0.09000000f,-0.15000000f,0.83000000f,-0.77000000f,0.05000000f,0.85000000f,0.68000000f,-0.32000000f,0.94000000f,-0.09000000f,-0.57000000f,0.46000000f,-0.01000000f,-0.77000000f,0.68000000f,0.44000000f,0.01000000f,-0.38000000f,0.82000000f,-0.22000000f,0.74000000f,0.75000000f,-0.43000000f,-0.26000000f,0.01000000f,0.87000000f,0.15000000f,-0.93000000f,-0.51000000f,-0.23000000f,-0.57000000f,0.88000000f,0.76000000f,-0.39000000f,0.78000000f,-0.40000000f,0.78000000f,-0.86000000f,-0.15000000f,0.47000000f,-0.75000000f,-0.26000000f,-0.54000000f,-0.00000000f,-0.42000000f,0.40000000f,0.53000000f,-0.34000000f,0.26000000f,-0.20000000f,-0.09000000f,-0.89000000f,0.96000000f,0.44000000f,-0.56000000f,-0.58000000f,-0.40000000f,-0.69000000f,0.21000000f,-0.74000000f,0.42000000f,0.94000000f,0.95000000f,-0.01000000f,0.93000000f,0.22000000f,-0.40000000f,-0.56000000f,0.42000000f,-0.97000000f,-0.72000000f,0.59000000f,-0.69000000f,0.52000000f,0.62000000f,-0.13000000f,-0.47000000f,0.18000000f,0.00000000f,0.37000000f,0.58000000f,-0.61000000f,0.28000000f,-0.85000000f,0.52000000f,-0.69000000f,-0.62000000f,0.54000000f,-0.90000000f,0.89000000f,0.86000000f,-0.83000000f,-0.57000000f,0.32000000f,0.43000000f,0.35000000f,-0.35000000f,0.02000000f,0.93000000f,0.77000000f,0.32000000f,0.52000000f,0.58000000f,0.76000000f,0.35000000f,-0.55000000f,-0.10000000f,-0.07000000f,-0.82000000f,-0.40000000f,0.25000000f,0.91000000f,0.81000000f,0.60000000f,-0.58000000f,0.64000000f,0.20000000f,0.97000000f,0.61000000f,-0.57000000f,0.93000000f,0.69000000f,-0.42000000f,0.99000000f,-0.80000000f,0.59000000f,0.48000000f,0.13000000f,0.42000000f,-0.78000000f,-0.83000000f,0.72000000f,0.49000000f,0.56000000f,-0.69000000f,-0.89000000f,0.95000000f,-0.45000000f,-0.15000000f,-0.39000000f,0.12000000f,-0.85000000f,-0.85000000f,-0.81000000f,-0.63000000f,0.33000000f,-0.00000000f,0.14000000f,-0.46000000f,-0.13000000f,0.44000000f,0.97000000f,-0.03000000f,0.58000000f,0.91000000f,-0.34000000f,0.56000000f,0.79000000f,0.36000000f,0.34000000f,0.00000000f,-0.16000000f,0.98000000f,-0.32000000f,-0.91000000f,0.51000000f,0.65000000f,-0.71000000f,-0.53000000f,0.00000000f,0.41000000f,0.83000000f,-0.42000000f,-0.52000000f,-0.82000000f,0.46000000f,0.20000000f,-0.61000000f,0.50000000f,0.82000000f,0.43000000f,0.05000000f,-0.29000000f,0.92000000f,0.87000000f,-0.57000000f,-0.56000000f,0.10000000f,0.06000000f,-0.95000000f,-0.26000000f,0.35000000f,-0.83000000f,-0.41000000f,0.85000000f,-0.43000000f,0.61000000f,-0.71000000f,0.70000000f,0.70000000f,-0.50000000f,-0.94000000f,0.89000000f,-0.78000000f,-0.64000000f,0.66000000f,-0.37000000f,-0.24000000f,-0.74000000f,-0.40000000f,0.62000000f,-0.01000000f,0.11000000f,0.47000000f,-0.85000000f,-0.10000000f,-0.11000000f,-0.91000000f,0.48000000f,0.43000000f,0.01000000f,0.71000000f,0.66000000f,0.15000000f,-0.33000000f,-0.07000000f,-0.92000000f,-0.77000000f,-0.44000000f,0.33000000f,-0.89000000f,-0.52000000f,0.46000000f,-0.68000000f,0.37000000f,-0.54000000f,0.11000000f,-0.08000000f,0.60000000f,-0.13000000f,-0.01000000f,-0.38000000f,-0.31000000f,-0.32000000f,0.10000000f,-0.58000000f,-0.12000000f,-0.62000000f,0.97000000f,-0.59000000f,-0.26000000f,-0.26000000f,0.08000000f,-0.59000000f,0.91000000f,0.33000000f,-0.12000000f,-0.22000000f,-0.08000000f,-0.86000000f,0.02000000f,0.65000000f,0.56000000f,-0.13000000f,0.34000000f,0.17000000f,0.59000000f,0.62000000f,0.70000000f,0.57000000f,0.73000000f,-0.86000000f,-0.21000000f,0.64000000f,-0.23000000f,-0.68000000f,0.92000000f,0.75000000f,-0.05000000f,-0.63000000f,-0.61000000f,0.52000000f,0.77000000f,-0.92000000f,-0.71000000f,0.73000000f,-0.62000000f,0.32000000f,-0.38000000f,0.99000000f,-0.58000000f,-0.77000000f,0.58000000f,-0.25000000f,0.08000000f,0.87000000f,0.12000000f,0.03000000f,0.60000000f,-0.07000000f,-0.31000000f,-0.70000000f,0.34000000f,0.71000000f,-0.94000000f,-0.72000000f,0.37000000f,0.18000000f,0.71000000f,0.17000000f,-0.75000000f,-0.90000000f,0.24000000f,-0.53000000f,-0.05000000f,0.68000000f,-0.19000000f,0.62000000f,-0.62000000f,0.67000000f,0.02000000f,0.78000000f,-0.85000000f,0.24000000f,-0.57000000f,0.02000000f,-0.31000000f,-0.23000000f,-0.95000000f,-0.78000000f,-0.51000000f,0.46000000f,0.33000000f,-0.06000000f,-0.05000000f,0.75000000f,-0.07000000f,-0.69000000f,-0.55000000f,-0.79000000f,0.39000000f,-0.28000000f,0.92000000f,-0.47000000f,-0.34000000f,-0.04000000f,0.32000000f,-0.35000000f,0.97000000f,-0.45000000f,0.65000000f,0.51000000f,-0.90000000f,-0.87000000f,0.48000000f,0.40000000f,0.46000000f,0.82000000f,-0.02000000f,-0.55000000f,0.85000000f,0.12000000f,-0.10000000f,0.65000000f,-0.23000000f,0.99000000f,0.91000000f,-0.02000000f,-0.89000000f,-0.67000000f,-0.92000000f,0.06000000f,-0.16000000f,-0.97000000f,-0.17000000f,0.11000000f,0.37000000f,0.59000000f,-0.85000000f,-0.43000000f,-0.24000000f,-0.78000000f,-0.35000000f,0.07000000f,-0.26000000f,0.65000000f,-0.86000000f,-0.29000000f,-0.82000000f,-0.03000000f,0.25000000f,-0.23000000f,0.51000000f,-0.61000000f,0.68000000f,0.88000000f,-0.35000000f,-0.17000000f,0.36000000f,0.36000000f,0.80000000f,-0.80000000f,-0.52000000f,0.90000000f,0.65000000f,0.82000000f,-0.19000000f,-0.10000000f,0.62000000f,0.87000000f,-0.11000000f,-0.67000000f,-0.24000000f,0.28000000f,0.80000000f,0.69000000f,0.36000000f,0.06000000f,0.02000000f,-0.15000000f,-0.85000000f,-0.94000000f,0.18000000f,-0.67000000f,-0.03000000f,0.58000000f,0.95000000f,0.70000000f,0.04000000f,-0.66000000f,-0.21000000f,0.77000000f,-0.87000000f,-0.96000000f,-0.86000000f,-0.96000000f,-0.33000000f,0.46000000f,-0.08000000f,-0.15000000f,0.24000000f,0.83000000f,-0.10000000f,-0.90000000f,-0.47000000f,0.56000000f,-0.10000000f,0.96000000f,-0.13000000f,0.12000000f,0.15000000f,-0.14000000f,-0.88000000f,-0.27000000f,0.86000000f,-0.51000000f,-0.00000000f,0.13000000f,0.56000000f,0.00000000f,0.03000000f,-0.64000000f,0.05000000f,0.44000000f,0.85000000f,0.15000000f,-0.70000000f,0.26000000f,-0.57000000f,-0.59000000f,-0.90000000f,-0.42000000f,0.46000000f,0.90000000f,-0.47000000f,-0.05000000f,-0.29000000f,0.77000000f,-0.47000000f,0.63000000f,-0.72000000f,0.24000000f,-0.90000000f,-0.96000000f,0.61000000f,0.74000000f,-0.90000000f,0.12000000f,-0.92000000f,-0.76000000f,0.34000000f,-0.53000000f,-0.50000000f,0.75000000f,0.78000000f,0.13000000f,0.39000000f,0.10000000f,0.57000000f,-0.10000000f,0.00000000f,0.61000000f,-0.29000000f,0.92000000f,-0.89000000f,0.70000000f,-0.25000000f,0.01000000f,0.56000000f,0.17000000f,-0.51000000f,0.78000000f,0.03000000f,-0.45000000f,0.37000000f,-0.65000000f,0.65000000f,-0.18000000f,0.28000000f,-0.04000000f,-0.68000000f,-0.48000000f,0.06000000f,0.94000000f,0.56000000f,0.92000000f,0.96000000f,-0.46000000f,-0.69000000f,0.89000000f,-0.43000000f,-0.68000000f,0.87000000f,-0.73000000f,0.93000000f,0.02000000f,0.99000000f,0.41000000f,-0.78000000f,0.06000000f,-0.56000000f,0.04000000f,0.68000000f,-0.79000000f,0.26000000f,0.39000000f,0.92000000f,-0.71000000f,-0.17000000f,-0.36000000f,-0.48000000f,-0.17000000f,0.97000000f,-0.94000000f,-0.46000000f,-0.84000000f,-0.79000000f,0.40000000f,0.20000000f,-0.71000000f,-0.70000000f,0.28000000f,-0.27000000f,-0.63000000f,-0.39000000f,-0.36000000f,0.35000000f,-0.69000000f,-0.94000000f,-0.17000000f,-0.97000000f,-0.07000000f,-0.78000000f,0.84000000f,0.17000000f,0.54000000f,0.29000000f,0.76000000f,0.73000000f,-0.58000000f,-0.03000000f,0.27000000f,0.44000000f,-0.03000000f,-0.83000000f,-0.04000000f,-0.93000000f,-0.42000000f,0.82000000f,-0.01000000f,-0.62000000f,-0.01000000f,0.61000000f,-0.05000000f,-0.69000000f,-0.63000000f,-0.02000000f,-0.25000000f,-0.27000000f,0.86000000f,0.48000000f,-0.92000000f,0.71000000f,0.69000000f,-0.93000000f,0.23000000f,-0.48000000f,0.22000000f,0.05000000f,-0.00000000f,-0.97000000f,0.82000000f,-0.47000000f,0.53000000f,0.68000000f,0.65000000f,-0.13000000f,-0.29000000f,-0.74000000f,0.66000000f,-0.47000000f,-0.01000000f,-0.62000000f,0.18000000f,0.78000000f,0.35000000f,0.34000000f,0.34000000f,-0.20000000f,0.65000000f,0.40000000f,-0.78000000f,-0.11000000f,0.81000000f,-0.36000000f,0.74000000f,-0.83000000f,-0.66000000f,-0.26000000f,0.90000000f,0.02000000f,0.55000000f,-0.97000000f,0.54000000f,0.50000000f,0.25000000f,0.57000000f,-0.49000000f,-0.15000000f,-0.45000000f,0.50000000f,-0.79000000f,-0.90000000f,-0.91000000f,0.31000000f,0.97000000f,0.77000000f,0.76000000f,0.73000000f,0.40000000f,-0.04000000f,-0.25000000f,0.71000000f,0.44000000f,0.71000000f,0.59000000f,0.88000000f,0.39000000f,-0.23000000f,0.99000000f,0.94000000f,0.65000000f,0.52000000f,-0.55000000f,-0.30000000f,-0.81000000f,0.21000000f,0.37000000f,0.47000000f,0.26000000f,-0.07000000f,-0.08000000f,0.62000000f,0.99000000f,-0.52000000f,-0.04000000f,0.75000000f,-0.67000000f,-0.23000000f,-0.16000000f,-0.25000000f,0.50000000f,-0.17000000f,-0.09000000f,0.16000000f,-0.92000000f,0.62000000f,0.70000000f,0.28000000f,0.00000000f,0.87000000f,-0.73000000f,0.97000000f,-0.31000000f,0.94000000f,0.56000000f,-0.00000000f,0.37000000f,0.05000000f,-0.70000000f,-0.03000000f,0.80000000f,0.95000000f,0.08000000f,-0.34000000f,0.85000000f,0.88000000f,0.95000000f,0.88000000f,0.14000000f,-0.22000000f,0.94000000f,0.47000000f,-0.85000000f,-0.07000000f,0.67000000f,0.55000000f,0.74000000f,0.87000000f,-0.39000000f,0.99000000f,0.49000000f,-0.14000000f,-0.20000000f,0.79000000f,-0.88000000f,0.79000000f,-0.14000000f,0.40000000f,0.57000000f,-0.32000000f,0.47000000f,-0.93000000f,-0.97000000f,-0.18000000f,0.71000000f,-0.96000000f,-0.50000000f,-0.65000000f,0.69000000f,-0.26000000f,-0.94000000f,-0.07000000f,-0.20000000f,0.55000000f,-0.84000000f,0.14000000f,0.88000000f,-0.94000000f,-0.62000000f,0.42000000f,-0.49000000f,0.70000000f,-0.61000000f,-0.36000000f,-0.92000000f,-0.96000000f,-0.42000000f,-0.15000000f,-0.55000000f,0.51000000f,0.56000000f,-0.03000000f,0.16000000f,0.27000000f,0.06000000f,-0.46000000f,-0.54000000f,-0.74000000f,0.48000000f,0.79000000f,-0.30000000f,-0.31000000f,0.37000000f,-0.63000000f,-0.53000000f,0.65000000f,-0.54000000f,-0.68000000f,0.10000000f,0.19000000f,-0.51000000f,0.68000000f,-0.81000000f,0.20000000f,0.38000000f,0.83000000f,0.14000000f,0.81000000f,0.29000000f,0.95000000f,-0.57000000f,0.83000000f,-0.25000000f,-0.26000000f,0.10000000f,-0.23000000f,0.00000000f,-0.77000000f,-0.47000000f,-0.36000000f,-0.33000000f,-0.38000000f,0.48000000f,0.15000000f,-0.61000000f,-0.07000000f,-0.35000000f,-0.52000000f,0.46000000f,-0.51000000f,-0.56000000f,0.32000000f,-0.51000000f,-0.87000000f,-0.76000000f,0.95000000f,-0.88000000f,-0.53000000f,-0.51000000f,0.18000000f,0.95000000f,-0.72000000f,-0.06000000f,0.85000000f,0.07000000f,-0.84000000f,0.90000000f,-0.19000000f,0.14000000f,0.54000000f,-0.84000000f,-0.57000000f,-0.38000000f,0.23000000f,0.45000000f,0.66000000f,0.73000000f,-0.87000000f,-0.29000000f,0.25000000f,-0.74000000f,-0.87000000f,-0.54000000f,0.08000000f,-0.26000000f,-0.15000000f,0.40000000f,-0.62000000f,-0.73000000f,-0.38000000f,0.13000000f,0.37000000f,0.20000000f,0.61000000f,-0.78000000f,0.84000000f,0.99000000f,0.80000000f,-0.99000000f,0.52000000f,0.85000000f,-0.61000000f,-0.74000000f,-0.52000000f,0.03000000f,-0.17000000f,-0.91000000f,0.64000000f,0.61000000f,0.82000000f,0.49000000f,-0.90000000f,0.13000000f,0.92000000f,0.63000000f,-0.38000000f,0.40000000f,-0.12000000f,-0.46000000f,-0.66000000f,0.45000000f,-0.68000000f,-0.32000000f,-0.41000000f,0.97000000f,-0.78000000f,-0.82000000f,-0.93000000f,-0.19000000f,0.33000000f,-0.56000000f,-0.21000000f,-0.37000000f,0.61000000f,-0.37000000f,-0.59000000f,0.50000000f,0.88000000f,0.39000000f,0.11000000f,0.66000000f,-0.67000000f,0.49000000f,-0.07000000f,0.51000000f,-0.20000000f,0.65000000f,-0.63000000f,-0.87000000f,0.96000000f,-0.58000000f,-0.24000000f,0.29000000f,-0.67000000f,-0.39000000f,-0.18000000f,0.48000000f,0.79000000f,0.97000000f,0.24000000f,0.07000000f,0.19000000f,0.54000000f,-0.45000000f,-0.34000000f,-0.13000000f,0.43000000f,-0.55000000f,-0.31000000f,-0.55000000f,0.77000000f,-0.52000000f,-0.20000000f,0.30000000f,0.81000000f,0.74000000f,0.63000000f,0.01000000f,-0.70000000f,0.17000000f,0.50000000f,0.34000000f,0.73000000f,0.01000000f,-0.74000000f,0.37000000f,0.88000000f,-0.40000000f,0.39000000f,-0.07000000f,-0.03000000f,0.14000000f,0.89000000f,0.70000000f,-0.49000000f,-0.41000000f,-0.66000000f,0.20000000f,0.95000000f,0.34000000f,0.69000000f,-0.01000000f,-0.63000000f,0.57000000f,0.60000000f,0.99000000f,0.49000000f,-0.45000000f,0.77000000f,-0.26000000f,-0.83000000f,0.29000000f,0.69000000f,-0.26000000f,0.97000000f,-0.25000000f,-0.96000000f,0.68000000f,-0.17000000f,0.99000000f,-0.61000000f,0.40000000f,-0.56000000f,0.50000000f,0.07000000f,0.74000000f,-0.16000000f,-0.44000000f,0.72000000f,0.50000000f,0.02000000f,0.74000000f,0.95000000f,-0.14000000f,-0.40000000f,0.82000000f,-0.82000000f,-0.58000000f,0.06000000f,0.77000000f,-0.26000000f,0.63000000f,0.17000000f,-0.44000000f,-0.08000000f,0.72000000f,0.16000000f,-0.91000000f,-0.56000000f,0.86000000f,0.34000000f,0.70000000f,0.85000000f,-0.93000000f,0.99000000f,0.33000000f,0.32000000f,0.23000000f,-0.40000000f,-0.96000000f,0.07000000f,0.01000000f,-0.81000000f,-0.39000000f,-0.82000000f,-0.50000000f,-0.15000000f,0.52000000f,0.34000000f,-0.96000000f,-0.28000000f,0.16000000f,0.72000000f,-0.91000000f,0.03000000f,-0.22000000f,0.27000000f,-0.53000000f,0.27000000f,-0.53000000f,0.95000000f,0.48000000f,0.22000000f,0.61000000f,-0.30000000f,0.67000000f,-0.22000000f,-0.06000000f,-0.56000000f,-0.74000000f,0.98000000f,-0.97000000f,0.15000000f,0.97000000f,-0.71000000f,0.53000000f,-0.09000000f,0.58000000f,-0.80000000f,0.85000000f,-0.96000000f,-0.50000000f,0.22000000f,-0.43000000f,-0.73000000f,0.36000000f,-0.27000000f,0.46000000f,0.36000000f,0.92000000f,0.02000000f,0.00000000f,0.55000000f,-0.00000000f,-0.68000000f,-0.39000000f,-0.67000000f,-0.58000000f,-0.50000000f,0.39000000f,-0.18000000f,0.48000000f,-0.66000000f,0.05000000f,-0.38000000f,-0.48000000f,0.42000000f,-0.72000000f,0.30000000f,0.30000000f,0.13000000f,-0.52000000f,-0.47000000f,-0.07000000f,-0.92000000f,-0.28000000f,0.25000000f,-0.19000000f,0.83000000f,-0.30000000f,0.66000000f,0.57000000f,-0.98000000f,-0.47000000f,0.03000000f,0.22000000f,-0.55000000f,0.14000000f,-0.04000000f,-0.81000000f,0.99000000f,-0.48000000f,-0.36000000f,0.24000000f,0.08000000f,-0.82000000f,-0.74000000f,-0.68000000f,-0.12000000f,-0.57000000f,-0.55000000f,-0.43000000f,-0.57000000f,-0.37000000f,-0.84000000f,-0.83000000f,0.44000000f,0.26000000f,-0.04000000f,0.03000000f,-0.58000000f,-0.84000000f,0.78000000f,-0.30000000f,-0.00000000f,-0.82000000f,0.12000000f,-0.00000000f,0.13000000f,0.49000000f,-0.26000000f,0.11000000f,0.50000000f,-0.44000000f,-0.87000000f,-0.15000000f,-0.22000000f,-0.21000000f,-0.76000000f,-0.79000000f,0.80000000f,0.97000000f,0.97000000f,0.06000000f,0.87000000f,0.13000000f,-0.22000000f,0.49000000f,-0.11000000f,-0.36000000f,-0.12000000f,-0.39000000f,0.43000000f,0.17000000f,0.54000000f,-0.17000000f,0.93000000f,-0.21000000f,0.80000000f,0.60000000f,-0.40000000f,0.02000000f,0.85000000f,0.32000000f,-0.52000000f,-0.62000000f,0.54000000f,0.01000000f,-0.93000000f,0.07000000f,0.97000000f,-0.46000000f,-0.94000000f,-0.94000000f,-0.93000000f,-0.41000000f,0.80000000f,-0.54000000f,-0.23000000f,-0.08000000f,0.60000000f,-0.56000000f,0.26000000f,0.12000000f,-0.48000000f,0.53000000f,0.90000000f,0.93000000f,-0.84000000f,0.71000000f,-0.60000000f,0.18000000f,0.52000000f,-0.59000000f,-0.74000000f,0.36000000f,-0.74000000f,-0.25000000f,-0.77000000f,0.13000000f,-0.88000000f,0.88000000f,-0.23000000f,-0.29000000f,0.82000000f,0.26000000f,0.57000000f,-0.29000000f,0.07000000f,-0.40000000f,0.99000000f,-0.89000000f,0.56000000f,-0.19000000f,0.95000000f,0.50000000f,-0.70000000f,0.31000000f,0.75000000f,0.63000000f,0.70000000f,-0.46000000f,-0.34000000f,0.88000000f,0.03000000f,0.56000000f,0.71000000f,0.34000000f,0.17000000f,-0.79000000f,-0.78000000f,0.47000000f,0.14000000f,0.00000000f,0.49000000f,0.10000000f,0.42000000f,0.35000000f,-0.39000000f,0.02000000f,-0.02000000f,0.19000000f,0.36000000f,-0.71000000f,0.30000000f,-0.58000000f,-0.42000000f,-0.23000000f,0.24000000f,0.17000000f,-0.42000000f,0.77000000f,-0.88000000f,0.07000000f,-0.33000000f,0.20000000f,-0.05000000f,0.37000000f,-0.74000000f,0.87000000f,0.00000000f,-0.23000000f,-0.48000000f,-0.95000000f,-0.97000000f,0.12000000f,-0.86000000f,0.58000000f,-0.92000000f,0.62000000f,0.72000000f,-0.53000000f,0.03000000f,0.70000000f,0.26000000f,0.95000000f,-0.44000000f,0.91000000f,0.09000000f,-0.31000000f,0.53000000f,0.90000000f,0.92000000f,-0.68000000f,0.75000000f,-0.85000000f,-0.04000000f,-0.42000000f,-0.77000000f,-0.67000000f,0.94000000f,-0.57000000f,-0.93000000f,-0.43000000f,-0.74000000f,0.95000000f,-0.53000000f,-0.50000000f,0.69000000f,0.93000000f,0.61000000f,-0.62000000f,0.66000000f,0.44000000f,-0.98000000f,0.54000000f,0.33000000f,-0.61000000f,-0.95000000f,0.92000000f,-0.95000000f,0.63000000f,-0.25000000f,-0.36000000f,-0.70000000f,-0.57000000f,-0.36000000f,-0.42000000f,0.34000000f,-0.01000000f,0.27000000f,-0.76000000f,-0.22000000f,0.46000000f,-0.89000000f,-0.02000000f,0.57000000f,0.82000000f,-0.58000000f,-0.52000000f,0.49000000f,0.02000000f,-0.04000000f,0.73000000f,-0.47000000f,-0.08000000f,0.47000000f,-0.98000000f,0.94000000f,0.82000000f,-0.90000000f,-0.88000000f,-0.82000000f,0.04000000f,0.25000000f,0.84000000f,-0.26000000f,0.19000000f,-0.43000000f,0.32000000f,-0.66000000f,0.25000000f,0.44000000f,0.47000000f,-0.69000000f,-0.14000000f,0.64000000f,-0.15000000f,-0.50000000f,-0.12000000f,0.29000000f,-0.08000000f,0.83000000f,0.48000000f,0.07000000f,-0.51000000f,0.24000000f,-0.81000000f,-0.65000000f,-0.54000000f,0.12000000f,0.52000000f,0.15000000f,-0.55000000f,-0.94000000f,0.47000000f,-0.32000000f,0.04000000f,0.17000000f,-0.13000000f,-0.13000000f,0.46000000f,0.13000000f,-0.85000000f,-0.55000000f,0.41000000f,-0.90000000f,0.84000000f,-0.17000000f,-0.73000000f,0.29000000f,-0.70000000f,0.16000000f,0.38000000f,0.39000000f,-0.93000000f,0.96000000f,-0.45000000f,0.54000000f,-0.76000000f,-0.07000000f,-0.02000000f,0.84000000f,0.91000000f,-0.09000000f,0.94000000f,-0.19000000f,0.88000000f,-0.93000000f,0.74000000f,0.19000000f,-0.39000000f,0.11000000f,-0.36000000f,-0.57000000f,0.01000000f,-0.71000000f,-0.67000000f,-0.54000000f,0.54000000f,-0.22000000f,0.06000000f,-0.67000000f,0.68000000f,-0.45000000f,0.64000000f,0.46000000f,0.69000000f,0.75000000f,0.94000000f,-0.40000000f,-0.05000000f,-0.89000000f,-0.07000000f,-0.47000000f,0.03000000f,-0.31000000f,0.54000000f,-0.88000000f,0.90000000f,-0.37000000f,0.01000000f,-0.23000000f,-0.96000000f,0.12000000f,-0.42000000f,0.91000000f,-0.62000000f,-0.06000000f,0.78000000f,0.63000000f,-0.72000000f,0.28000000f,0.11000000f,0.11000000f,0.15000000f,0.73000000f,-0.91000000f,0.36000000f,0.42000000f,0.25000000f,-0.36000000f,-0.27000000f,0.42000000f,-0.51000000f,-0.44000000f,0.87000000f,0.33000000f,0.47000000f,0.84000000f,0.05000000f,0.37000000f,-0.60000000f,-0.66000000f,0.83000000f,0.84000000f,0.43000000f,0.15000000f,-0.90000000f,-0.48000000f,-0.59000000f,-0.98000000f,0.80000000f,-0.43000000f,-0.01000000f,0.43000000f,0.62000000f,-0.52000000f,0.36000000f,-0.55000000f,0.14000000f,0.08000000f,-0.32000000f,0.65000000f,-0.51000000f,0.26000000f,0.69000000f,-0.71000000f,-0.69000000f,0.28000000f,-0.66000000f,-0.91000000f,-0.15000000f,0.47000000f,0.34000000f,0.56000000f,-0.66000000f,0.26000000f,0.56000000f,0.21000000f,-0.67000000f,0.85000000f,0.30000000f,0.83000000f,0.17000000f,-0.30000000f,0.09000000f,0.23000000f,0.64000000f,0.26000000f,0.78000000f,-0.09000000f,-0.37000000f,-0.45000000f,-0.74000000f,-0.96000000f,-0.13000000f,0.16000000f,-0.94000000f,-0.78000000f,0.75000000f,0.40000000f,0.83000000f,0.99000000f,-0.91000000f,-0.26000000f,0.66000000f,-0.55000000f,0.89000000f,0.86000000f,-0.64000000f,-0.06000000f,0.33000000f,-0.09000000f,-0.87000000f,0.63000000f,-0.40000000f,0.91000000f,-0.89000000f,0.76000000f,-0.39000000f,-0.93000000f,0.77000000f,0.61000000f,-0.10000000f,-0.78000000f,-0.79000000f,-0.93000000f,0.44000000f,0.58000000f,0.16000000f,-0.39000000f,-0.97000000f,-0.90000000f,0.01000000f,-0.36000000f,0.70000000f,0.26000000f,0.90000000f,-0.65000000f,0.94000000f,-0.19000000f,-0.00000000f,0.26000000f,-0.39000000f,0.25000000f,-0.27000000f,0.68000000f,0.06000000f,0.11000000f,0.88000000f,0.73000000f,0.17000000f,0.83000000f,-0.39000000f,-0.16000000f,-0.43000000f,-0.16000000f,0.59000000f,0.68000000f,0.45000000f,0.15000000f,0.53000000f,-0.56000000f,0.99000000f,-0.46000000f,-0.50000000f,-0.47000000f,-0.63000000f,-0.07000000f,0.32000000f,0.09000000f,0.40000000f,-0.42000000f,-0.66000000f,0.89000000f,-0.73000000f,-0.62000000f,0.43000000f,0.67000000f,-0.31000000f,0.65000000f,-0.04000000f,-0.37000000f,0.77000000f,0.10000000f,-0.78000000f,0.67000000f,0.29000000f,-0.37000000f,-0.94000000f,-0.00000000f,-0.79000000f,-0.15000000f,0.08000000f,-0.53000000f,0.88000000f,0.21000000f,0.73000000f,0.17000000f,-0.13000000f,0.93000000f,0.86000000f,-0.65000000f,-0.12000000f,-0.69000000f,0.57000000f,0.23000000f,-0.62000000f,0.03000000f,-0.47000000f,0.02000000f,0.20000000f,-0.42000000f,0.97000000f,0.85000000f,-0.16000000f,-0.87000000f,-0.78000000f,0.50000000f,0.34000000f,-0.81000000f,0.87000000f,0.29000000f,0.61000000f,-0.82000000f,-0.50000000f,-0.86000000f,0.56000000f,-0.14000000f,-0.50000000f,-0.35000000f,-0.55000000f,-0.37000000f,0.37000000f,-0.55000000f,0.59000000f,-0.27000000f,0.47000000f,-0.88000000f,0.78000000f,0.09000000f,-0.61000000f,-0.20000000f,-0.81000000f,0.10000000f,0.11000000f,-0.93000000f,-0.80000000f,0.74000000f,0.65000000f,0.27000000f,-0.97000000f,0.97000000f,-0.04000000f,0.49000000f,-0.77000000f,0.36000000f,0.82000000f,0.09000000f,-0.32000000f,0.08000000f,0.67000000f,0.08000000f,0.48000000f,-0.02000000f,-0.07000000f,0.55000000f,-0.47000000f,0.03000000f,-0.17000000f,-0.72000000f,-0.05000000f,0.79000000f,0.60000000f,-0.86000000f,0.68000000f,0.07000000f,0.77000000f,-0.60000000f,0.83000000f,0.47000000f,0.65000000f,-0.95000000f,-0.00000000f,0.71000000f,0.97000000f,0.63000000f,0.75000000f,0.83000000f,-0.08000000f,-0.89000000f,-0.46000000f,-0.46000000f,-0.51000000f,0.69000000f,0.83000000f,0.33000000f,0.25000000f,0.36000000f,-0.47000000f,-0.57000000f,0.36000000f,-0.15000000f,0.03000000f,0.72000000f,-0.91000000f,-0.46000000f,-0.45000000f,-0.08000000f,0.21000000f,0.39000000f,-0.59000000f,0.73000000f,0.34000000f,-0.42000000f,0.35000000f,-0.11000000f,-0.38000000f,-0.51000000f,0.84000000f,-0.07000000f,-0.21000000f,-0.58000000f,-0.96000000f,-0.91000000f,0.00000000f,-0.85000000f,-0.29000000f,-0.73000000f,-0.45000000f,-0.52000000f,-0.13000000f,-0.44000000f,-0.79000000f,-0.90000000f,0.32000000f,0.67000000f,0.66000000f,0.51000000f,-0.57000000f,-0.31000000f,0.85000000f,-0.46000000f,0.91000000f,-0.03000000f,-0.13000000f,0.81000000f,-0.84000000f,0.07000000f,0.37000000f,-0.51000000f,0.73000000f,-0.11000000f,0.59000000f,-0.38000000f,0.64000000f,-0.41000000f,-0.80000000f,0.72000000f,-0.72000000f,-0.70000000f,0.50000000f,-0.19000000f,-0.42000000f,-0.10000000f,0.59000000f,0.79000000f,-0.69000000f,-0.58000000f,0.15000000f,0.98000000f,0.44000000f,0.19000000f,-0.18000000f,-0.06000000f,0.80000000f,-0.27000000f,-0.02000000f,-0.02000000f,0.25000000f,-0.20000000f,0.29000000f,-0.80000000f,0.39000000f,0.89000000f,0.99000000f,0.47000000f,0.43000000f,0.71000000f,-0.43000000f,-0.26000000f,0.62000000f,0.10000000f,0.79000000f,-0.26000000f,0.18000000f,0.27000000f,-0.75000000f,-0.82000000f,-0.09000000f,-0.63000000f,0.66000000f,-0.29000000f,-0.54000000f,-0.21000000f,-0.83000000f,-0.42000000f,0.85000000f,0.69000000f,-0.95000000f,-0.85000000f,0.04000000f,-0.60000000f,0.02000000f,-0.00000000f,0.19000000f,0.01000000f,0.89000000f,-0.69000000f,0.85000000f,-0.70000000f,0.46000000f,-0.47000000f,-0.43000000f,-0.03000000f,0.37000000f,-0.66000000f,-0.44000000f,0.90000000f,0.03000000f,-0.07000000f,-0.09000000f,0.17000000f,-0.42000000f,0.16000000f,-0.81000000f,-0.05000000f,0.56000000f,-0.19000000f,-0.23000000f,-0.89000000f,-0.20000000f,-0.95000000f,-0.47000000f,-0.84000000f,0.84000000f,-0.91000000f,-0.33000000f,-0.69000000f,0.53000000f,-0.99000000f,0.93000000f,0.03000000f,-0.88000000f,0.03000000f,-0.01000000f,0.88000000f,0.84000000f,-0.71000000f,-0.25000000f,-0.04000000f,-0.15000000f,-0.92000000f,-0.12000000f,-0.74000000f,-0.04000000f,0.08000000f,-0.61000000f,0.18000000f,0.93000000f,-0.30000000f,-0.81000000f,0.94000000f,-0.39000000f,-0.41000000f,0.21000000f,-0.08000000f,-0.97000000f,-0.41000000f,0.10000000f,-0.44000000f,0.14000000f,0.30000000f,-0.75000000f,0.68000000f,-0.09000000f,0.43000000f,0.49000000f,-0.58000000f,0.94000000f,-0.01000000f,0.26000000f,0.75000000f,0.77000000f,-0.26000000f,0.56000000f,0.48000000f,-0.50000000f,-0.45000000f,0.56000000f,-0.13000000f,0.53000000f,-0.75000000f,-0.18000000f,0.05000000f,-0.00000000f,0.66000000f,0.23000000f,-0.50000000f,0.57000000f,0.37000000f,-0.23000000f,0.86000000f,-0.05000000f,-0.61000000f,-0.22000000f,0.72000000f,-0.35000000f,0.47000000f,-0.50000000f,0.78000000f,0.81000000f,0.05000000f,-0.04000000f,-0.05000000f,0.41000000f,-0.74000000f,0.52000000f,0.34000000f,-0.02000000f,0.30000000f,0.91000000f,-0.52000000f,-0.66000000f,-0.57000000f,-0.49000000f,-0.76000000f,-0.29000000f,-0.92000000f,0.87000000f,-0.26000000f,-0.88000000f,-0.78000000f,-0.98000000f,-0.61000000f,-0.72000000f,0.09000000f,0.82000000f,0.47000000f,-0.19000000f,-0.71000000f,0.56000000f,0.15000000f,-0.07000000f,-0.94000000f,0.85000000f,0.85000000f,0.40000000f,-0.13000000f,-0.20000000f,0.23000000f,-0.02000000f,-0.74000000f,0.12000000f,0.99000000f,-0.44000000f,0.34000000f,-0.54000000f,0.90000000f,-0.95000000f,0.54000000f,-0.27000000f,0.36000000f,0.78000000f,-0.86000000f,-0.21000000f,0.17000000f,0.28000000f,-0.15000000f,0.66000000f,-0.43000000f,0.64000000f,0.70000000f,-0.95000000f,0.27000000f,0.71000000f,0.27000000f,-0.99000000f,-0.11000000f,-0.56000000f,0.21000000f,-0.84000000f,-0.64000000f,-0.26000000f,0.05000000f,0.31000000f,0.56000000f,-0.41000000f,-0.77000000f,-0.32000000f,0.72000000f,0.25000000f,0.81000000f,0.06000000f,-0.92000000f,0.89000000f,-0.23000000f,0.42000000f,0.53000000f,-0.15000000f,0.11000000f,0.88000000f,-0.36000000f,-0.43000000f,-0.68000000f,0.37000000f,-0.62000000f,-0.77000000f,-0.03000000f,-0.93000000f,0.50000000f,0.57000000f,-0.90000000f,-0.00000000f,0.82000000f,0.61000000f,-0.62000000f,0.38000000f,-0.06000000f,-0.32000000f,0.31000000f,0.66000000f,-0.25000000f,0.90000000f,0.15000000f,0.12000000f,0.60000000f,0.82000000f,-0.86000000f,0.54000000f,-0.99000000f,0.05000000f,0.92000000f,-0.75000000f,-0.26000000f,-0.32000000f,-0.18000000f,0.41000000f,0.38000000f,-0.32000000f,0.27000000f,0.08000000f,0.74000000f,-0.71000000f,-0.26000000f,0.34000000f,0.99000000f,0.46000000f,0.11000000f,-0.41000000f,-0.09000000f,0.19000000f,-0.83000000f,0.43000000f,0.12000000f,0.74000000f,0.31000000f,-0.35000000f,-0.76000000f,0.13000000f,0.05000000f,0.65000000f,0.32000000f,-0.62000000f,-0.34000000f,-0.37000000f,0.94000000f,-0.18000000f,0.03000000f,-0.30000000f,-0.91000000f,0.95000000f,0.76000000f,0.67000000f,0.85000000f,0.15000000f,0.84000000f,-0.21000000f,0.87000000f,0.83000000f,0.56000000f,-0.67000000f,0.72000000f,0.05000000f,-0.70000000f,-0.28000000f,-0.87000000f,-0.25000000f,0.95000000f,0.34000000f,-0.01000000f,0.20000000f,-0.72000000f,0.57000000f,0.06000000f,0.99000000f,0.05000000f,0.36000000f,0.77000000f,-0.89000000f,-0.52000000f,-0.65000000f,-0.95000000f,-0.49000000f,-0.62000000f,0.12000000f,0.17000000f,-0.89000000f,0.27000000f,-0.72000000f,0.09000000f,0.94000000f,0.46000000f,-0.39000000f,-0.27000000f,-0.34000000f,0.05000000f,-0.43000000f,0.76000000f,0.59000000f,0.41000000f,-0.69000000f,0.50000000f,0.30000000f,0.69000000f,0.31000000f,0.31000000f,0.60000000f,-0.81000000f,-0.34000000f,-0.31000000f,0.32000000f,0.72000000f,-0.37000000f,0.08000000f,-0.61000000f,-0.77000000f,-0.86000000f,0.13000000f,0.52000000f,-0.28000000f,-0.43000000f,-0.70000000f,0.34000000f,0.41000000f,-0.85000000f,-0.19000000f,0.09000000f,0.88000000f,-0.40000000f,-0.92000000f,-0.62000000f,-0.97000000f,0.11000000f,-0.54000000f,-0.51000000f,-0.99000000f,-0.03000000f,0.69000000f,0.57000000f,-0.56000000f,-0.87000000f,0.39000000f,0.37000000f,0.72000000f,0.17000000f,-0.28000000f,-0.86000000f,0.46000000f,-0.77000000f,0.49000000f,-0.73000000f,-0.65000000f,-0.81000000f,-0.78000000f,0.02000000f,0.22000000f,-0.58000000f,0.30000000f,-0.95000000f,-0.91000000f,0.94000000f,-0.73000000f,0.67000000f,0.45000000f,-0.49000000f,0.37000000f,0.48000000f,-0.76000000f,-0.59000000f,0.32000000f,0.97000000f,0.01000000f,0.46000000f,-0.42000000f,0.58000000f,0.26000000f,0.62000000f,0.58000000f,-0.26000000f,-0.52000000f,-0.24000000f,-0.72000000f,-0.88000000f,0.89000000f,0.99000000f,0.20000000f,0.48000000f,0.11000000f,0.82000000f,-0.51000000f,0.46000000f,-0.07000000f,0.19000000f,0.66000000f,-0.22000000f,-0.68000000f,0.37000000f,0.81000000f,0.51000000f,-0.81000000f,-0.75000000f,-0.51000000f,-0.26000000f,-0.13000000f,0.47000000f,0.59000000f,-0.71000000f,-0.43000000f,-0.33000000f,0.82000000f,-0.15000000f,-0.18000000f,0.80000000f,-0.09000000f,0.19000000f,0.75000000f,0.20000000f,0.31000000f,0.28000000f,-0.44000000f,-0.43000000f,0.18000000f,0.53000000f,0.76000000f,0.15000000f,-0.63000000f,-0.39000000f,-0.84000000f,0.01000000f,-0.05000000f,-0.33000000f,0.32000000f,0.10000000f,0.00000000f,0.80000000f,0.46000000f,-0.78000000f,0.84000000f,-0.20000000f,0.60000000f,0.62000000f,0.52000000f,-0.79000000f,0.21000000f,-0.97000000f,-0.94000000f,0.45000000f,-0.46000000f,-0.97000000f,-0.53000000f,-0.37000000f,-0.97000000f,-0.68000000f,0.09000000f,-0.80000000f,0.50000000f,0.09000000f,0.56000000f,0.10000000f,0.81000000f,0.33000000f,0.81000000f,-0.32000000f,-0.51000000f,-0.00000000f,-0.15000000f,0.92000000f,0.94000000f,-0.79000000f,-0.72000000f,0.43000000f,-0.04000000f,0.42000000f,0.21000000f,0.99000000f,0.39000000f,0.06000000f,-0.01000000f,-0.59000000f,0.18000000f,-0.94000000f,-0.50000000f,-0.55000000f,-0.13000000f,0.32000000f,0.94000000f,-0.87000000f,0.08000000f,-0.72000000f,-0.17000000f,-0.37000000f,0.21000000f,0.01000000f,-0.28000000f,0.60000000f,0.05000000f,-0.99000000f,-0.50000000f,-0.74000000f,0.32000000f,0.49000000f,-0.29000000f,0.12000000f,-0.52000000f,-0.90000000f,-0.68000000f,-0.45000000f,0.73000000f,0.52000000f,0.03000000f,-0.71000000f,0.39000000f,0.92000000f,-0.95000000f,0.83000000f,-0.60000000f,-0.44000000f,-0.66000000f,-0.59000000f,-0.76000000f,-0.79000000f,-0.10000000f,-0.77000000f,0.35000000f,0.88000000f,-0.49000000f,0.08000000f,0.06000000f,-0.97000000f,-0.84000000f,-0.47000000f,0.40000000f,0.51000000f,0.13000000f,-0.06000000f,-0.35000000f,0.81000000f,-0.99000000f,-0.09000000f,-0.92000000f,-0.38000000f,-0.78000000f,-0.10000000f,0.76000000f,-0.08000000f,-0.31000000f,-0.59000000f,-0.86000000f,-0.34000000f,-0.86000000f,0.54000000f,0.10000000f,0.16000000f,-0.01000000f,-0.68000000f,-0.22000000f,-0.15000000f,0.46000000f,0.92000000f,-0.75000000f,-0.84000000f,-0.62000000f,-0.74000000f,0.40000000f,0.90000000f,-0.41000000f,-0.14000000f,-0.73000000f,0.27000000f,0.86000000f,0.53000000f,-0.41000000f,0.35000000f,0.96000000f,0.34000000f,0.96000000f,-0.83000000f,0.88000000f,-0.35000000f,0.34000000f,-0.71000000f,-0.27000000f,-0.28000000f,0.38000000f,-0.98000000f,-0.30000000f,-0.67000000f,0.52000000f,-0.03000000f,0.63000000f,-0.54000000f,0.26000000f,0.41000000f,-0.01000000f,-0.10000000f,-0.38000000f,0.61000000f,-0.77000000f,0.92000000f,0.58000000f,-0.98000000f,0.93000000f,-0.27000000f,-0.08000000f,0.78000000f,-0.64000000f,-0.93000000f,0.79000000f,-0.36000000f,0.94000000f,-0.10000000f,0.48000000f,0.73000000f,-0.44000000f,0.00000000f,-0.94000000f,-0.90000000f,0.04000000f,-0.72000000f,0.09000000f,-0.57000000f,0.46000000f,-0.62000000f,-0.41000000f,0.09000000f,-0.21000000f,-0.56000000f,0.79000000f,0.49000000f,-0.78000000f,0.43000000f,0.61000000f,-0.29000000f,-0.10000000f,-0.54000000f,0.64000000f,-0.95000000f,0.35000000f,-0.50000000f,0.99000000f,0.08000000f,-0.07000000f,-0.00000000f,0.31000000f,0.69000000f,0.78000000f,0.68000000f,-0.34000000f,-0.39000000f,0.17000000f,0.51000000f,-0.25000000f,0.71000000f,0.83000000f,0.58000000f,0.87000000f,0.79000000f,0.14000000f,0.26000000f,0.54000000f,0.26000000f,0.06000000f,0.85000000f,-0.29000000f,-0.79000000f,-0.57000000f,-0.02000000f,-0.07000000f,0.77000000f,0.16000000f,0.17000000f,-0.35000000f,0.63000000f,0.61000000f,0.89000000f,0.52000000f,0.14000000f,0.77000000f,0.57000000f,0.80000000f,-0.81000000f,-0.93000000f,-0.18000000f,-0.32000000f,-0.88000000f,0.24000000f,-0.25000000f,-0.75000000f,0.88000000f,0.43000000f,0.09000000f,-0.08000000f,-0.15000000f,0.53000000f,-0.93000000f,0.02000000f,-0.48000000f,0.82000000f,-0.81000000f,0.86000000f,-0.84000000f,0.15000000f,0.64000000f,-0.20000000f,0.92000000f,0.10000000f,0.26000000f,0.75000000f,-0.50000000f,0.50000000f,-0.75000000f,0.48000000f,-0.27000000f,-0.39000000f,-0.82000000f,-0.71000000f,0.60000000f,0.99000000f,-0.84000000f,0.42000000f,-0.01000000f,0.39000000f,-0.86000000f,-0.06000000f,0.66000000f,0.70000000f,0.17000000f,0.75000000f,-0.97000000f,0.57000000f,-0.44000000f,-0.68000000f,0.13000000f,-0.20000000f,-0.69000000f,0.99000000f,0.73000000f,0.38000000f,-0.51000000f,-0.23000000f,0.26000000f,-0.85000000f,0.57000000f,-0.62000000f,0.72000000f,0.69000000f,0.88000000f,-0.09000000f,-0.30000000f,-0.30000000f,0.37000000f,-0.62000000f,-0.74000000f,-0.02000000f,-0.33000000f,-0.69000000f,0.00000000f,-0.53000000f,-0.99000000f,-0.39000000f,-0.88000000f,0.56000000f,0.09000000f,0.33000000f,0.56000000f,0.75000000f,0.01000000f,-0.68000000f,0.87000000f,0.80000000f,-0.23000000f,-0.48000000f,-0.20000000f,0.08000000f,0.64000000f,0.10000000f,-0.14000000f,0.13000000f,0.50000000f,-0.92000000f,0.43000000f,-0.61000000f,-0.04000000f,-0.90000000f,0.65000000f,0.76000000f,0.58000000f,-0.21000000f,0.63000000f,0.93000000f,-0.61000000f,0.01000000f,-0.13000000f,0.09000000f,0.89000000f,0.46000000f,0.82000000f,0.95000000f,0.23000000f,-0.86000000f,-0.16000000f,0.38000000f,0.00000000f,0.70000000f,-0.42000000f,0.56000000f,-0.55000000f,0.05000000f,0.88000000f,-0.22000000f,-0.51000000f,-0.84000000f,0.28000000f,-0.03000000f,0.74000000f,0.53000000f,0.40000000f,-0.98000000f,-0.52000000f,-0.50000000f,-0.67000000f,0.84000000f,-0.72000000f,-0.78000000f,0.14000000f,0.08000000f,-0.44000000f,-0.23000000f,0.38000000f,-0.01000000f,0.76000000f,0.26000000f,0.97000000f,0.80000000f,-0.84000000f,-0.20000000f,-0.19000000f,0.51000000f,0.42000000f,-0.51000000f,-0.81000000f,0.69000000f,0.10000000f,-0.98000000f,-0.62000000f,-0.82000000f,0.09000000f,-0.43000000f,0.54000000f,0.47000000f,0.43000000f,-0.85000000f,0.87000000f,-0.86000000f,0.24000000f,0.23000000f,-0.46000000f,-0.33000000f,0.86000000f,-0.90000000f,0.26000000f,-0.42000000f,-0.48000000f,-0.12000000f,0.55000000f,-0.28000000f,-0.49000000f,-0.40000000f,0.45000000f,0.72000000f,0.69000000f,0.10000000f,-0.20000000f,0.02000000f,0.65000000f,-0.55000000f,0.70000000f,0.27000000f,-0.11000000f,0.44000000f,0.87000000f,-0.83000000f,0.09000000f,0.60000000f,0.11000000f,0.05000000f,-0.33000000f,-0.35000000f,0.74000000f,0.23000000f,-0.91000000f,0.35000000f,-0.47000000f,0.52000000f,-0.70000000f,0.56000000f,0.24000000f,-0.60000000f,-0.60000000f,0.42000000f,-0.40000000f,-0.30000000f,-0.87000000f,0.61000000f,-0.53000000f,0.61000000f,0.85000000f,0.00000000f,-0.19000000f,-0.10000000f,-0.72000000f,-0.07000000f,-0.62000000f,0.46000000f,-0.16000000f,-0.75000000f,-0.96000000f,-0.92000000f,0.87000000f,-0.95000000f,-0.25000000f,-0.40000000f,0.63000000f,0.45000000f,-0.22000000f,-0.49000000f,0.27000000f,0.05000000f,-0.96000000f,-0.89000000f,0.43000000f,0.38000000f,0.50000000f,0.09000000f,0.78000000f,-0.73000000f,0.67000000f,0.55000000f,-0.53000000f,0.89000000f,-0.34000000f,0.99000000f,-0.29000000f,-0.04000000f,-0.42000000f,-0.34000000f,-0.74000000f,-0.36000000f,0.38000000f,0.94000000f,0.29000000f,-0.11000000f,0.10000000f,-0.08000000f,-0.21000000f,-0.18000000f,0.88000000f,-0.64000000f,-0.58000000f,-0.18000000f,0.77000000f,-0.47000000f,-0.53000000f,-0.00000000f,0.13000000f,-0.41000000f,0.71000000f,0.52000000f,-0.39000000f,-0.25000000f,0.15000000f,0.09000000f,0.49000000f,0.99000000f,-0.09000000f,0.97000000f,0.21000000f,-0.24000000f,0.76000000f,-0.25000000f,0.81000000f,-0.44000000f,0.96000000f,-0.85000000f,0.48000000f,-0.86000000f,0.12000000f,0.94000000f,-0.09000000f,-0.69000000f,0.98000000f,0.26000000f,0.63000000f,0.65000000f,0.70000000f,0.95000000f,0.96000000f,0.49000000f,-0.25000000f,0.66000000f,-0.97000000f,-0.62000000f,0.85000000f,0.04000000f,0.16000000f,0.22000000f,0.71000000f,-0.52000000f,-0.55000000f,0.08000000f,-0.85000000f,-0.87000000f,0.73000000f,0.08000000f,0.94000000f,-0.34000000f,-0.82000000f,0.22000000f,-0.25000000f,-0.92000000f,-0.96000000f,0.94000000f,-0.47000000f,0.76000000f,-0.83000000f,0.22000000f,0.42000000f,-0.80000000f,-0.22000000f,-0.84000000f,-0.52000000f,0.15000000f,0.20000000f,0.96000000f,0.20000000f,0.63000000f,-0.32000000f,-0.76000000f,0.32000000f,-0.71000000f,-0.68000000f,0.55000000f,-0.45000000f,0.59000000f,-0.41000000f,-0.10000000f,-0.62000000f,0.56000000f,0.07000000f,-0.22000000f,-0.90000000f,0.39000000f,-0.53000000f,0.98000000f,-0.55000000f,-0.31000000f,-0.48000000f,0.22000000f,-0.78000000f,-0.57000000f,-0.88000000f,-0.97000000f,0.26000000f,-0.74000000f,0.20000000f,-0.82000000f,-0.34000000f,0.27000000f,0.96000000f,-0.14000000f,-0.60000000f,-0.20000000f,-0.34000000f,0.68000000f,-0.00000000f,0.57000000f,0.87000000f,-0.48000000f,0.10000000f,0.39000000f,-0.22000000f,0.97000000f,0.45000000f,-0.41000000f,0.85000000f,-0.18000000f,-0.22000000f,-0.40000000f,0.67000000f,-0.09000000f,-0.61000000f,-0.28000000f,0.71000000f,0.45000000f,-0.27000000f,-0.67000000f,0.50000000f,-0.10000000f,-0.09000000f,-0.75000000f,0.96000000f,0.86000000f,0.27000000f,-0.83000000f,-0.35000000f,-0.30000000f,0.37000000f,0.44000000f,0.78000000f,-0.50000000f,-0.53000000f,-0.40000000f,-0.43000000f,-0.04000000f,0.46000000f,-0.57000000f,-0.60000000f,-0.13000000f,0.90000000f,0.32000000f,0.92000000f,0.79000000f,0.48000000f,-0.76000000f,0.87000000f,0.11000000f,-0.17000000f,-0.50000000f,-0.00000000f,0.02000000f,0.61000000f,0.33000000f,0.64000000f,-0.80000000f,-0.48000000f,0.91000000f,0.81000000f,-0.73000000f,-0.02000000f,0.94000000f,-0.63000000f,0.19000000f,0.39000000f,-0.50000000f,-0.91000000f,-0.99000000f,0.95000000f,-0.75000000f,0.67000000f,0.82000000f,-0.54000000f,-0.76000000f,0.50000000f,0.90000000f,0.46000000f,-0.74000000f,0.69000000f,-0.86000000f,0.72000000f,0.52000000f,0.39000000f,-0.46000000f,-0.36000000f,0.34000000f,0.21000000f,-0.44000000f,0.14000000f,0.35000000f,0.13000000f,-0.84000000f,0.95000000f,0.32000000f,-0.82000000f,-0.62000000f,-0.69000000f,-0.50000000f,0.59000000f,0.47000000f,-0.97000000f,0.15000000f,0.59000000f,0.65000000f,-0.26000000f,0.50000000f,-0.03000000f,-0.96000000f,0.97000000f,-0.99000000f,-0.67000000f,-0.73000000f,-0.48000000f,-0.64000000f,-0.84000000f,-0.94000000f,0.62000000f,0.14000000f,-0.32000000f,-0.47000000f,-0.74000000f,0.07000000f,0.05000000f,0.87000000f,-0.83000000f,0.49000000f,-0.32000000f,-0.32000000f,0.03000000f,0.51000000f,0.06000000f,-0.77000000f,0.75000000f,-0.39000000f,-0.78000000f,0.10000000f,0.95000000f,0.38000000f,-0.08000000f,-0.66000000f,-0.07000000f,0.09000000f,-0.09000000f,-0.09000000f,0.83000000f,-0.12000000f,0.43000000f,-0.65000000f,0.41000000f,0.68000000f,0.93000000f,0.88000000f,-0.24000000f,0.70000000f,-0.97000000f,-0.40000000f,-0.96000000f,-0.45000000f,-0.35000000f,-0.29000000f,0.91000000f,-0.28000000f,0.92000000f,-0.57000000f,-0.37000000f,-0.02000000f,0.37000000f,-0.37000000f,-0.01000000f,-0.48000000f,0.74000000f,-0.28000000f,0.21000000f,0.74000000f,-0.99000000f,0.45000000f,0.91000000f,-0.28000000f,-0.11000000f,-0.86000000f,-0.22000000f,0.48000000f,-0.34000000f,0.52000000f,0.17000000f,0.04000000f,0.23000000f,-0.54000000f,-0.80000000f,-0.60000000f,0.04000000f,0.47000000f,-0.14000000f,0.33000000f,0.57000000f,0.22000000f,-0.67000000f,0.02000000f,0.69000000f,0.93000000f,0.69000000f,0.93000000f,0.99000000f,0.75000000f,0.47000000f,0.21000000f,-0.42000000f,0.02000000f,0.20000000f,0.03000000f,0.12000000f,0.76000000f,0.04000000f,-0.43000000f,-0.10000000f,-0.52000000f,-0.26000000f,-0.10000000f,0.78000000f,-0.81000000f,-0.72000000f,-0.76000000f,0.87000000f,0.88000000f,0.83000000f,-0.27000000f,0.82000000f,-0.97000000f,-0.59000000f,0.80000000f,0.66000000f,0.66000000f,0.59000000f,-0.73000000f,0.03000000f,-0.16000000f,0.69000000f,-0.52000000f,0.22000000f,0.82000000f,-0.11000000f,-0.25000000f,-0.39000000f,0.56000000f,0.93000000f,-0.43000000f,-0.73000000f,-0.28000000f,-0.06000000f,-0.49000000f,-0.95000000f,0.39000000f,0.51000000f,0.29000000f,0.40000000f,-0.46000000f,-0.11000000f,0.60000000f,0.03000000f,-0.57000000f,0.24000000f,-0.55000000f,0.88000000f,-0.33000000f,0.64000000f,-0.79000000f,0.59000000f,-0.05000000f,0.94000000f,0.00000000f,0.74000000f,0.44000000f,-0.86000000f,0.23000000f,-0.03000000f,-0.66000000f,0.45000000f,0.08000000f,-0.53000000f,0.09000000f,0.98000000f,-0.28000000f,-0.10000000f,0.89000000f,0.18000000f,0.45000000f,-0.98000000f,-0.89000000f,0.47000000f,0.78000000f,-0.11000000f,0.53000000f,-0.35000000f,0.46000000f,0.00000000f,0.49000000f,-0.13000000f,-0.58000000f,-0.56000000f,0.73000000f,0.21000000f,0.20000000f,0.72000000f,-0.71000000f,-0.68000000f,-0.54000000f,0.61000000f,-0.80000000f,0.53000000f,0.90000000f,0.20000000f,0.25000000f,-0.29000000f,0.91000000f,-0.88000000f,0.04000000f,0.98000000f,-0.18000000f,-0.16000000f,0.28000000f,0.28000000f,0.60000000f,0.35000000f,-0.32000000f,0.48000000f,-0.99000000f,-0.57000000f,0.41000000f,0.93000000f,-0.33000000f,-0.69000000f,0.68000000f,-0.99000000f,0.40000000f,-0.31000000f,0.58000000f,0.70000000f,-0.95000000f,-0.97000000f,0.59000000f,-0.71000000f,-0.43000000f,0.78000000f,-0.92000000f,-0.01000000f,0.79000000f,-0.34000000f,-0.14000000f,0.25000000f,0.86000000f,0.62000000f,-0.12000000f,-0.53000000f,0.77000000f,-0.30000000f,-0.50000000f,-0.82000000f,0.76000000f,0.27000000f,-0.59000000f,0.69000000f,-0.87000000f,-0.03000000f,0.82000000f,0.05000000f,0.58000000f,0.96000000f,0.52000000f,0.04000000f,0.80000000f,-0.66000000f,-0.06000000f,0.88000000f,-0.59000000f,-0.19000000f,-0.47000000f,0.84000000f,0.15000000f,0.90000000f,-0.08000000f,0.69000000f,-0.34000000f,0.12000000f,0.14000000f,0.86000000f,-0.56000000f,-0.59000000f,0.08000000f,0.27000000f,-0.13000000f,0.00000000f,-0.00000000f,-0.47000000f,0.34000000f,0.44000000f,0.17000000f,-0.57000000f,-0.19000000f,-0.09000000f,-0.31000000f,0.03000000f,-0.60000000f,0.40000000f,0.58000000f,-0.43000000f,-0.81000000f,0.08000000f,0.04000000f,-0.28000000f,0.74000000f,0.00000000f,-0.59000000f,-0.57000000f,-0.82000000f,0.99000000f,-0.36000000f,0.44000000f,-0.51000000f,0.26000000f,0.75000000f,-0.56000000f,-0.86000000f,0.85000000f,-0.63000000f,0.49000000f,0.81000000f,-0.53000000f,0.23000000f,-0.35000000f,-0.25000000f,-0.44000000f,-0.03000000f,0.23000000f,0.98000000f,-0.37000000f,-0.25000000f,-0.60000000f,0.81000000f,0.16000000f,0.95000000f,0.77000000f,-0.18000000f,0.45000000f,-0.35000000f,0.47000000f,0.74000000f,0.65000000f,0.81000000f,-0.02000000f,-0.39000000f,-0.75000000f,0.33000000f,0.35000000f,-0.76000000f,-0.12000000f,-0.62000000f,0.06000000f,0.47000000f,0.47000000f,-0.74000000f,0.58000000f,-0.68000000f,-0.77000000f,-0.12000000f,-0.41000000f,0.26000000f,0.39000000f,-0.37000000f,0.47000000f,0.81000000f,0.00000000f,0.80000000f,-0.59000000f,0.74000000f,-0.11000000f,-0.81000000f,-0.10000000f,-0.03000000f,0.88000000f,-0.65000000f,0.58000000f,-0.93000000f,-0.09000000f,-0.30000000f,0.72000000f,-0.75000000f,-0.10000000f,0.01000000f,0.21000000f,-0.17000000f,0.37000000f,-0.96000000f,-0.44000000f,-0.69000000f,0.36000000f,0.89000000f,0.24000000f,0.06000000f,0.20000000f,-0.51000000f,0.20000000f,-0.25000000f,0.64000000f,0.06000000f,-0.91000000f,0.19000000f,-0.71000000f,-0.09000000f,0.85000000f,0.49000000f,-0.39000000f,0.80000000f,0.42000000f,0.61000000f,-0.52000000f,0.61000000f,-0.13000000f,0.48000000f,0.67000000f,0.60000000f,0.93000000f,-0.02000000f,0.58000000f,0.01000000f,-0.17000000f,-0.50000000f,-0.67000000f,-0.74000000f,-0.12000000f,0.92000000f,-0.61000000f,-0.21000000f,0.30000000f,-0.70000000f,-0.56000000f,-0.91000000f,-0.65000000f,0.13000000f,-0.36000000f,-0.91000000f,0.93000000f,0.69000000f,-0.95000000f,0.67000000f,-0.46000000f,0.26000000f,0.59000000f,0.11000000f,0.64000000f,-0.83000000f,-0.00000000f,-0.85000000f,0.50000000f,0.25000000f,0.80000000f,-0.83000000f,-0.54000000f,-0.96000000f,0.68000000f,-0.39000000f,0.84000000f,0.80000000f,0.84000000f,0.86000000f,-0.60000000f,-0.73000000f,-0.90000000f,0.22000000f,0.52000000f,-0.70000000f,-0.70000000f,0.35000000f,0.57000000f,0.55000000f,-0.94000000f,0.51000000f,0.07000000f,-0.57000000f,-0.20000000f,0.16000000f,0.66000000f,0.71000000f,0.46000000f,-0.03000000f,0.11000000f,-0.61000000f,-0.84000000f,-0.57000000f,0.12000000f,-0.37000000f,-0.97000000f,-0.83000000f,0.47000000f,0.40000000f,0.54000000f,0.79000000f,0.95000000f,0.40000000f,0.23000000f,0.45000000f,0.66000000f,0.33000000f,0.61000000f,0.90000000f,-0.66000000f,-0.18000000f,0.95000000f,0.91000000f,-0.89000000f,-0.66000000f,0.37000000f,-0.80000000f,-0.36000000f,0.02000000f,0.23000000f,-0.57000000f,-0.19000000f,-0.11000000f,-0.01000000f,-0.47000000f,-0.67000000f,-0.64000000f,0.80000000f,-0.34000000f,-0.08000000f,-0.54000000f,0.96000000f,-0.41000000f,-0.43000000f,0.52000000f,0.30000000f,-0.02000000f,0.68000000f,-0.82000000f,-0.06000000f,-0.24000000f,0.53000000f,-0.12000000f,-0.64000000f,-0.57000000f,-0.93000000f,0.17000000f,-0.62000000f,-0.57000000f,-0.18000000f,0.44000000f,-0.93000000f,0.27000000f,0.47000000f,0.02000000f,-0.66000000f,0.84000000f,-0.56000000f,-0.86000000f,-0.30000000f,0.45000000f,-0.87000000f,-0.18000000f,-0.78000000f,-0.58000000f,-0.87000000f,-0.01000000f,-0.39000000f,-0.82000000f,-0.88000000f,0.73000000f,-0.96000000f,-0.08000000f,-0.83000000f,-0.78000000f,-0.40000000f,0.55000000f,-0.96000000f,-0.72000000f,-0.48000000f,-0.58000000f,0.56000000f,0.17000000f,0.51000000f,0.81000000f,-0.72000000f,-0.46000000f,0.98000000f,0.59000000f,-0.78000000f,-0.00000000f,-0.97000000f,0.94000000f,0.53000000f,0.29000000f,0.90000000f,0.85000000f,-0.83000000f,-0.66000000f,-0.22000000f,-0.23000000f,0.41000000f,-0.13000000f,-0.10000000f,0.66000000f,-0.18000000f,0.83000000f,-0.50000000f,-0.14000000f,-0.22000000f,0.75000000f,-0.81000000f,0.56000000f,-0.60000000f,-0.11000000f,-0.24000000f,-0.37000000f,-0.44000000f,0.27000000f,-0.84000000f,0.21000000f,-0.47000000f,0.87000000f,0.91000000f,-0.95000000f,-0.09000000f,0.97000000f,0.08000000f,-0.49000000f,-0.27000000f,0.22000000f,0.50000000f,-0.54000000f,0.41000000f,0.84000000f,0.25000000f,0.24000000f,0.12000000f,0.76000000f,-0.50000000f,0.78000000f,-0.35000000f,0.66000000f,-0.78000000f,0.10000000f,0.81000000f,0.32000000f,-0.41000000f,-0.20000000f,-0.99000000f,0.80000000f,-0.91000000f,-0.80000000f,0.53000000f,0.83000000f,-0.43000000f,-0.12000000f,0.26000000f,-0.28000000f,0.33000000f,-0.88000000f,0.39000000f,0.15000000f,-0.11000000f,-0.35000000f,0.46000000f,-0.47000000f,-0.30000000f,0.42000000f,-0.33000000f,0.95000000f,0.59000000f,-0.43000000f,-0.12000000f,0.57000000f,-0.57000000f,-0.47000000f,0.60000000f,0.34000000f,0.80000000f,0.80000000f,-0.64000000f,-0.72000000f,0.01000000f,0.49000000f,-0.03000000f,0.09000000f,0.38000000f,-0.65000000f,-0.22000000f,0.61000000f,-0.82000000f,0.42000000f,-0.33000000f,0.91000000f,0.55000000f,0.45000000f,0.85000000f,-0.06000000f,-0.58000000f,0.64000000f,0.12000000f,-0.57000000f,0.68000000f,0.24000000f,-0.88000000f,-0.67000000f,-0.65000000f,-0.22000000f,-0.11000000f,-0.83000000f,-0.82000000f,0.76000000f,0.33000000f,-0.14000000f,0.97000000f,-0.18000000f,-0.04000000f,0.97000000f,0.00000000f,0.08000000f,0.15000000f,0.52000000f,-0.19000000f,-0.46000000f,-0.50000000f,-0.59000000f,0.69000000f,0.06000000f,-0.14000000f,0.27000000f,-0.75000000f,0.27000000f,-0.14000000f,0.15000000f,-0.57000000f,-0.42000000f,-0.18000000f,0.43000000f,0.44000000f,-0.65000000f,-0.87000000f,-0.49000000f,-0.37000000f,0.82000000f,-0.72000000f,0.01000000f,-0.88000000f,0.14000000f,-0.92000000f,-0.50000000f,0.83000000f,-0.14000000f,-0.16000000f,-0.50000000f,-0.05000000f,-0.63000000f,-0.90000000f,0.83000000f,0.74000000f,0.00000000f,0.44000000f,-0.66000000f,0.93000000f,0.27000000f,-0.28000000f,0.18000000f,-0.80000000f,-0.54000000f,-0.08000000f,0.22000000f,0.43000000f,0.16000000f,-0.25000000f,-0.14000000f,0.25000000f,0.55000000f,-0.85000000f,0.72000000f,0.33000000f,0.12000000f,-0.65000000f,-0.17000000f,0.26000000f,-0.40000000f,0.78000000f,-0.50000000f,0.07000000f,-0.98000000f,-0.60000000f,-0.38000000f,0.95000000f,0.75000000f,-0.10000000f,-0.30000000f,0.57000000f,-0.67000000f,0.12000000f,0.46000000f,-0.23000000f,-0.93000000f,-0.34000000f,-0.63000000f,0.42000000f,0.20000000f,0.25000000f,-0.83000000f,0.09000000f,-0.35000000f,-0.70000000f,0.73000000f,-0.71000000f,-0.65000000f,0.53000000f,0.93000000f,-0.30000000f,0.42000000f,0.10000000f,0.73000000f,-0.96000000f,-0.08000000f,0.64000000f,0.66000000f,-0.20000000f,0.62000000f,-0.90000000f,-0.63000000f,-0.55000000f,0.72000000f,0.64000000f,-0.42000000f,-0.01000000f,-0.62000000f,-0.82000000f,0.68000000f,-0.86000000f,0.48000000f,-0.04000000f,-0.02000000f,-0.91000000f,-0.99000000f,-0.33000000f,-0.46000000f,-0.06000000f,-0.92000000f,-0.23000000f,0.15000000f,0.26000000f,0.37000000f,0.23000000f,0.08000000f,0.47000000f,-0.78000000f,0.86000000f,0.52000000f,-0.27000000f,-0.01000000f,-0.54000000f,-0.42000000f,-0.25000000f,-0.20000000f,-0.13000000f,0.64000000f,0.32000000f,0.45000000f,0.34000000f,-0.13000000f,0.99000000f,0.45000000f,0.81000000f,-0.63000000f,-0.27000000f,-0.59000000f,-0.29000000f,-0.44000000f,0.89000000f,-0.01000000f,-0.17000000f,0.79000000f,0.08000000f,0.59000000f,-0.01000000f,-0.26000000f,0.10000000f,0.27000000f,0.28000000f,-0.12000000f,-0.73000000f,0.19000000f,0.16000000f,-0.12000000f,0.49000000f,0.43000000f,0.74000000f,0.56000000f,0.90000000f,0.28000000f,-0.46000000f,-0.62000000f,0.47000000f,-0.35000000f,-0.36000000f,-0.99000000f,0.89000000f,-0.64000000f,-0.33000000f,-0.43000000f,0.97000000f,-0.34000000f,0.37000000f,-0.16000000f,-0.39000000f,0.18000000f,-0.95000000f,-0.41000000f,0.41000000f,-0.21000000f,-0.82000000f,-0.93000000f,-0.90000000f,0.53000000f,0.25000000f,0.29000000f,-0.84000000f,-0.39000000f,-0.72000000f,-0.21000000f,-0.78000000f,-0.97000000f,-0.92000000f,-0.34000000f,0.81000000f,-0.08000000f,0.34000000f,0.26000000f,-0.74000000f,-0.26000000f,-0.20000000f,0.71000000f,0.67000000f,-0.08000000f,0.35000000f,-0.63000000f,-0.11000000f,-0.50000000f,-0.71000000f,-0.26000000f,-0.46000000f,0.01000000f,-0.24000000f,0.73000000f,-0.22000000f,-0.85000000f,-0.68000000f,-0.21000000f,-0.56000000f,0.16000000f,-0.04000000f,-0.77000000f,0.24000000f,-0.66000000f,0.77000000f,0.25000000f,-0.27000000f,-0.24000000f,-0.36000000f,0.89000000f,-0.65000000f,0.62000000f,0.00000000f,-0.74000000f,0.22000000f,0.82000000f,0.72000000f,0.58000000f,-0.44000000f,0.72000000f,-0.55000000f,-0.20000000f,0.11000000f,-0.62000000f,0.48000000f,-0.24000000f,-0.02000000f,-0.81000000f,0.69000000f,-0.58000000f,0.26000000f,-0.64000000f,-0.48000000f,0.79000000f,0.38000000f,0.68000000f,0.70000000f,-0.19000000f,0.79000000f,0.89000000f,-0.57000000f,-0.24000000f,-0.57000000f,-0.20000000f,-0.80000000f,0.54000000f,-0.12000000f,-0.94000000f,-0.04000000f,0.40000000f,-0.16000000f,-0.99000000f,0.12000000f,0.73000000f,-0.02000000f,0.63000000f,-0.76000000f,-0.40000000f,-0.82000000f,0.60000000f,0.48000000f,0.26000000f,-0.77000000f,-0.68000000f,0.10000000f,-0.81000000f,0.90000000f,0.97000000f,0.10000000f,-0.12000000f,-0.07000000f,-0.64000000f,0.36000000f,-0.37000000f,0.25000000f,-0.38000000f,-0.65000000f,-0.30000000f,-0.71000000f,0.35000000f,0.69000000f,0.29000000f,-0.60000000f,0.66000000f,0.53000000f,0.69000000f,-0.27000000f,0.04000000f,-0.38000000f,-0.47000000f,-0.00000000f,-0.30000000f,0.71000000f,0.44000000f,-0.50000000f,0.52000000f,0.75000000f,0.18000000f,-0.47000000f,-0.15000000f,0.46000000f,-0.42000000f,0.32000000f,-0.97000000f,0.16000000f,0.67000000f,-0.13000000f,-0.59000000f,0.49000000f,-0.02000000f,-0.91000000f,-0.05000000f,-0.89000000f,0.68000000f,-0.21000000f,0.57000000f,-0.17000000f,0.37000000f,-0.36000000f,-0.44000000f,0.40000000f,0.31000000f,-0.51000000f,-0.56000000f,0.09000000f,0.80000000f,-0.61000000f,-0.36000000f,-0.66000000f,0.29000000f,-0.00000000f,-0.72000000f,0.14000000f,-0.95000000f,-0.18000000f,-0.43000000f,-0.25000000f,0.28000000f,-0.64000000f,-0.37000000f,-0.29000000f,0.15000000f,0.48000000f,0.29000000f,-0.86000000f,0.43000000f,0.85000000f,0.56000000f,-0.66000000f,-0.93000000f,-0.00000000f,0.06000000f,0.00000000f,-0.73000000f,-0.29000000f,-0.29000000f,0.59000000f,-0.60000000f,-0.24000000f,-0.88000000f,0.99000000f,0.39000000f,0.71000000f,-0.58000000f,-0.46000000f,-0.86000000f,-0.65000000f,-0.17000000f,0.28000000f,0.85000000f,0.74000000f,0.32000000f,-0.14000000f,0.59000000f,0.37000000f,-0.94000000f,0.28000000f,-0.50000000f,-0.88000000f,0.36000000f,-0.21000000f,-0.22000000f,0.55000000f,-0.49000000f,-0.22000000f,0.33000000f,0.34000000f,0.59000000f,-0.94000000f,0.82000000f,-0.06000000f,0.82000000f,0.71000000f,0.03000000f,-0.11000000f,-0.02000000f,0.85000000f,-0.25000000f,0.86000000f,-0.30000000f,-0.99000000f,0.27000000f,0.17000000f,0.78000000f,0.24000000f,-0.85000000f,0.97000000f,0.35000000f,0.44000000f,-0.86000000f,0.22000000f,0.69000000f,0.89000000f,-0.11000000f,0.94000000f,-0.97000000f,-0.73000000f,-0.46000000f,-0.85000000f,0.33000000f,-0.01000000f,-0.37000000f,0.23000000f,-0.67000000f,0.02000000f,-0.89000000f,0.99000000f,-0.46000000f,0.40000000f,-0.60000000f,-0.35000000f,-0.13000000f,-0.38000000f,-0.18000000f,-0.50000000f,-0.52000000f,0.06000000f,0.01000000f,0.68000000f,0.69000000f,0.17000000f,-0.36000000f,0.68000000f,-0.01000000f,0.22000000f,0.96000000f,0.58000000f,-0.28000000f,0.10000000f,-0.49000000f,-0.21000000f,-0.74000000f,0.06000000f,-0.03000000f,0.36000000f,0.47000000f,-0.94000000f,-0.13000000f,0.66000000f,-0.03000000f,0.81000000f,-0.10000000f,-0.34000000f,-0.74000000f,-0.02000000f,0.36000000f,0.13000000f,-0.09000000f,-0.23000000f,-0.15000000f,-0.84000000f,0.61000000f,0.63000000f,-0.06000000f,-0.59000000f,0.49000000f,-0.83000000f,0.43000000f,-0.51000000f,-0.26000000f,-0.49000000f,0.79000000f,0.92000000f,0.69000000f,-0.51000000f,0.43000000f,0.57000000f,0.59000000f,0.62000000f,0.04000000f,-0.66000000f,0.12000000f,-0.61000000f,0.15000000f,-0.29000000f,-0.66000000f,-0.05000000f,0.27000000f,0.83000000f,0.62000000f,-0.89000000f,0.37000000f,0.08000000f,-0.41000000f,0.60000000f,0.57000000f,0.27000000f,-0.08000000f,0.62000000f,-0.75000000f,0.71000000f,-0.56000000f,-0.08000000f,0.98000000f,0.63000000f,-0.46000000f,-0.76000000f,0.75000000f,-0.99000000f,-0.80000000f,-0.58000000f,-0.16000000f,-0.55000000f,0.09000000f,0.42000000f,-0.11000000f,0.18000000f,-0.87000000f,-0.89000000f,0.04000000f,0.24000000f,-0.86000000f,-0.20000000f,0.09000000f,-0.76000000f,0.77000000f,-0.39000000f,0.60000000f,-0.61000000f,-0.04000000f,0.16000000f,0.57000000f,-0.39000000f,-0.75000000f,-0.99000000f,-0.77000000f,0.91000000f,0.58000000f,-0.29000000f,0.48000000f,0.22000000f,0.73000000f,-0.29000000f,-0.28000000f,0.93000000f,-0.78000000f,-0.19000000f,0.27000000f,-0.76000000f,-0.93000000f,-0.95000000f,-0.98000000f,0.74000000f,0.50000000f,0.09000000f,-0.76000000f,-0.31000000f,-0.95000000f,0.18000000f,0.95000000f,-0.90000000f,-0.87000000f,0.87000000f,0.39000000f,0.91000000f,0.91000000f,0.43000000f,0.21000000f,-0.33000000f,-0.82000000f,-0.85000000f,0.79000000f,0.25000000f,0.62000000f,0.44000000f,-0.19000000f,0.80000000f,0.77000000f,-0.08000000f,0.74000000f,-0.25000000f,0.90000000f,0.93000000f,0.55000000f,-0.46000000f,-0.63000000f,0.73000000f,0.51000000f,0.31000000f,-0.30000000f,-0.46000000f,-0.26000000f,0.82000000f,-0.44000000f,-0.96000000f,-0.05000000f,0.25000000f,0.67000000f,0.37000000f,-0.96000000f,-0.70000000f,-0.50000000f,-0.33000000f,-0.30000000f,0.19000000f,0.45000000f,0.96000000f,0.18000000f,-0.44000000f,0.10000000f,-0.29000000f,-0.83000000f,0.18000000f,0.14000000f,0.91000000f,-0.76000000f,0.33000000f,-0.75000000f,-0.06000000f,0.35000000f,0.35000000f,-0.22000000f,-0.42000000f,-0.34000000f,0.60000000f,-0.56000000f,0.95000000f,-0.35000000f,-0.13000000f,-0.58000000f,-0.84000000f,0.89000000f,-0.67000000f,-0.84000000f,0.78000000f,-0.29000000f,0.83000000f,-0.03000000f,0.74000000f,-0.98000000f,0.54000000f,-0.33000000f,0.40000000f,0.79000000f,0.78000000f,0.47000000f,-0.60000000f,0.66000000f,0.69000000f,-0.25000000f,-0.38000000f,0.90000000f,0.91000000f,-0.22000000f,0.55000000f,-0.30000000f,-0.48000000f,-0.16000000f,-0.09000000f,-0.23000000f,-0.68000000f,-0.62000000f,0.49000000f,0.34000000f,0.18000000f,0.88000000f,0.08000000f,0.95000000f,-0.59000000f,0.40000000f,0.52000000f,0.19000000f,0.94000000f,0.36000000f,0.96000000f,-0.31000000f,0.71000000f,-0.19000000f,0.67000000f,0.87000000f,-0.39000000f,-0.55000000f,-0.01000000f,-0.14000000f,0.28000000f,-0.75000000f,0.70000000f,-0.17000000f,0.18000000f,0.64000000f,0.50000000f,-0.83000000f,0.85000000f,0.85000000f,0.38000000f,0.04000000f,-0.46000000f,0.41000000f,-0.21000000f,-0.78000000f,0.32000000f,0.46000000f,0.95000000f,-0.16000000f,-0.31000000f,-0.24000000f,0.06000000f,-0.25000000f,-0.94000000f,0.99000000f,0.75000000f,-0.00000000f,-0.42000000f,-0.72000000f,0.61000000f,-0.06000000f,0.78000000f,0.92000000f,0.25000000f,0.90000000f,-0.37000000f,0.72000000f,0.21000000f,-0.72000000f,0.36000000f,0.76000000f,-0.53000000f,-0.36000000f,0.45000000f,-0.28000000f,-0.47000000f,-0.46000000f,0.47000000f,-0.30000000f,0.30000000f,-0.72000000f,0.73000000f,-0.61000000f,-0.39000000f,0.06000000f,0.35000000f,0.77000000f,-0.38000000f,0.52000000f,-0.03000000f,-0.85000000f,-0.20000000f,0.02000000f,0.64000000f,-0.72000000f,0.10000000f,0.11000000f,0.81000000f,-0.07000000f,0.72000000f,0.87000000f,0.81000000f,-0.21000000f,-0.03000000f,-0.86000000f,-0.18000000f,0.01000000f,-0.77000000f,-0.60000000f,0.16000000f,0.32000000f,-0.46000000f,0.00000000f,-0.00000000f,-0.77000000f,-0.04000000f,0.92000000f,0.48000000f,-0.84000000f,-0.65000000f,-0.93000000f,-0.77000000f,-0.11000000f,0.77000000f,0.86000000f,0.96000000f,0.31000000f,-0.18000000f,-0.94000000f,0.66000000f,-0.97000000f,0.51000000f,0.39000000f,-0.66000000f,-0.74000000f,0.82000000f,0.91000000f,0.90000000f,-0.22000000f,-0.89000000f,0.72000000f,0.98000000f,-0.14000000f,0.73000000f,0.68000000f,0.68000000f,-0.20000000f,0.44000000f,-0.76000000f,0.40000000f,-0.93000000f,-0.43000000f,-0.89000000f,-0.74000000f,-0.18000000f,-0.79000000f,-0.69000000f,0.32000000f,0.73000000f,-0.85000000f,-0.06000000f,0.72000000f,-0.25000000f,0.37000000f,0.76000000f,-0.20000000f,-0.70000000f,0.27000000f,-0.94000000f,0.75000000f,-0.29000000f,-0.25000000f,-0.82000000f,0.38000000f,0.50000000f,0.56000000f,0.62000000f,-0.41000000f,-0.10000000f,-0.38000000f,0.76000000f,-0.42000000f,0.89000000f,0.16000000f,-0.83000000f,-0.05000000f,-0.08000000f,-0.41000000f,0.55000000f,0.01000000f,0.93000000f,-0.79000000f,-0.46000000f,0.63000000f,-0.93000000f,-0.26000000f,0.51000000f,0.57000000f,-0.76000000f,-0.94000000f,0.21000000f,-0.83000000f,0.51000000f,-0.38000000f,-0.00000000f,-0.35000000f,-0.94000000f,0.32000000f,-0.70000000f,-0.05000000f,-0.73000000f,0.19000000f,-0.52000000f,0.32000000f,-0.48000000f,0.99000000f,0.18000000f,0.36000000f,-0.73000000f,0.48000000f,0.74000000f,0.53000000f,0.41000000f,0.85000000f,-0.42000000f,0.46000000f,0.18000000f,0.66000000f,0.99000000f,-0.55000000f,-0.02000000f,0.54000000f,-0.89000000f,-0.78000000f,0.68000000f,0.34000000f,0.90000000f,-0.34000000f,0.55000000f,-0.50000000f,-0.80000000f,-0.26000000f,-0.91000000f,-0.72000000f,0.75000000f,0.23000000f,0.87000000f,0.15000000f,0.77000000f,-0.64000000f,-0.78000000f,0.03000000f,-0.29000000f,-0.31000000f,0.02000000f,-0.16000000f,0.01000000f,0.50000000f,-0.35000000f,-0.65000000f,0.22000000f,0.53000000f,-0.25000000f,-0.31000000f,0.61000000f,0.59000000f,-0.83000000f,-0.30000000f,-0.53000000f,-0.76000000f,-0.28000000f,0.71000000f,0.52000000f,-0.77000000f,0.86000000f,-0.01000000f,0.92000000f,0.90000000f,0.20000000f,0.20000000f,0.49000000f,0.38000000f,-0.95000000f,0.59000000f,-0.25000000f,0.42000000f,-0.33000000f,0.29000000f,0.17000000f,-0.17000000f,0.78000000f,-0.75000000f,0.99000000f,-0.43000000f,-0.33000000f,-0.61000000f,0.41000000f,-0.22000000f,-0.25000000f,-0.16000000f,-0.74000000f,-0.06000000f,0.24000000f,0.60000000f,-0.96000000f,0.06000000f,-0.13000000f,-0.27000000f,-0.04000000f,-0.04000000f,0.45000000f,0.25000000f,0.83000000f,-0.31000000f,0.27000000f,-0.06000000f,-0.40000000f,0.68000000f,-0.52000000f,0.92000000f,-0.71000000f,-0.78000000f,0.93000000f,-0.84000000f,-0.51000000f,-0.30000000f,-0.15000000f,0.02000000f,-0.59000000f,-0.64000000f,0.06000000f,-0.18000000f,-0.55000000f,-0.96000000f,0.12000000f,-0.89000000f,0.97000000f,0.91000000f,-0.73000000f,0.06000000f,0.57000000f,-0.82000000f,0.59000000f,-0.86000000f,0.08000000f,0.45000000f,-0.95000000f,0.67000000f,-0.65000000f,-0.29000000f,-0.36000000f,0.04000000f,-0.82000000f,0.10000000f,0.55000000f,0.32000000f,0.55000000f,0.32000000f,0.81000000f,-0.92000000f,0.09000000f,-0.35000000f,0.88000000f,0.31000000f,0.06000000f,0.89000000f,0.00000000f,0.37000000f,-0.45000000f,0.58000000f,0.97000000f,0.95000000f,0.34000000f,-0.41000000f,-0.84000000f,0.45000000f,-0.81000000f,0.73000000f,-0.11000000f,0.06000000f,-0.68000000f,-0.92000000f,0.59000000f,0.80000000f,0.60000000f,-0.04000000f,-0.18000000f,0.44000000f,-0.83000000f,0.71000000f,0.68000000f,0.02000000f,0.62000000f,0.83000000f,0.60000000f,0.81000000f,-0.92000000f,0.86000000f,-0.57000000f,0.26000000f,0.30000000f,-0.26000000f,0.29000000f,-0.74000000f,-0.21000000f,0.65000000f,0.40000000f,0.43000000f,-0.95000000f,0.36000000f,-0.28000000f,0.12000000f,-0.89000000f,-0.23000000f,0.86000000f,-0.11000000f,0.70000000f,0.52000000f,-0.22000000f,-0.83000000f,-0.63000000f,0.08000000f,0.58000000f,-0.88000000f,-0.34000000f,-0.06000000f,0.44000000f,0.10000000f,0.36000000f,0.99000000f,0.04000000f,0.41000000f,-0.73000000f,0.41000000f,0.57000000f,-0.41000000f,0.35000000f,0.36000000f,-0.37000000f,0.64000000f,-0.70000000f,-0.33000000f,-0.57000000f,-0.38000000f,0.09000000f,0.50000000f,-0.09000000f,-0.95000000f,0.59000000f,0.07000000f,0.25000000f,0.75000000f,-0.29000000f,-0.46000000f,-0.69000000f,-0.93000000f,-0.49000000f,-0.03000000f,-0.25000000f,0.65000000f,-0.15000000f,0.79000000f,0.76000000f,-0.73000000f,0.57000000f,-0.90000000f,0.74000000f,0.99000000f,0.20000000f,0.09000000f,0.33000000f,-0.55000000f,0.42000000f,-0.98000000f,-0.26000000f,-0.48000000f,0.96000000f,0.83000000f,-0.75000000f,-0.64000000f,-0.09000000f,-0.73000000f,0.96000000f,-0.26000000f,-0.76000000f,0.83000000f,0.54000000f,0.66000000f,0.54000000f,0.64000000f,-0.58000000f,0.45000000f,-0.67000000f,0.81000000f,0.00000000f,-0.77000000f,0.66000000f,0.36000000f,0.93000000f,0.75000000f,-0.62000000f,0.65000000f,-0.52000000f,0.08000000f,0.02000000f,0.12000000f,0.35000000f,0.85000000f,0.83000000f,-0.07000000f,-0.62000000f,-0.78000000f,-0.98000000f,-0.78000000f,0.43000000f,0.53000000f,-0.55000000f,0.04000000f,0.99000000f,-0.57000000f,-0.52000000f,0.78000000f,0.11000000f,-0.00000000f,0.88000000f,0.10000000f,-0.43000000f,-0.44000000f,-0.51000000f,0.73000000f,-0.74000000f,0.53000000f,-0.26000000f,-0.58000000f,0.07000000f,-0.48000000f,0.23000000f,0.94000000f,-0.47000000f,-0.53000000f,0.04000000f,0.18000000f,-0.16000000f,-0.86000000f,-0.90000000f,-0.04000000f,0.05000000f,0.03000000f,0.53000000f,-0.11000000f,-0.86000000f,0.80000000f,0.34000000f,0.61000000f,-0.00000000f,-0.99000000f,0.55000000f,-0.20000000f,-0.84000000f,0.21000000f,-0.66000000f,-0.43000000f,-0.93000000f,-0.83000000f,0.00000000f,-0.62000000f,-0.59000000f,-0.16000000f,-0.56000000f,-0.11000000f,0.55000000f,-0.30000000f,0.96000000f,-0.67000000f,0.05000000f,0.17000000f,0.30000000f,-0.86000000f,-0.44000000f,0.05000000f,0.75000000f,-0.44000000f,-0.03000000f,-0.61000000f,-0.89000000f,0.40000000f,0.35000000f,-0.42000000f,0.35000000f,-0.97000000f,0.58000000f,0.32000000f,0.84000000f,-0.13000000f,0.01000000f,0.89000000f,0.60000000f,0.06000000f,0.80000000f,0.67000000f,-0.54000000f,0.59000000f,-0.52000000f,0.06000000f,0.86000000f,0.19000000f,0.04000000f,0.75000000f,0.86000000f,0.11000000f,0.00000000f,-0.72000000f,-0.85000000f,0.09000000f,0.78000000f,-0.68000000f,0.90000000f,0.06000000f,0.38000000f,-0.14000000f,0.97000000f,0.07000000f,-0.60000000f,0.60000000f,-0.78000000f,-0.38000000f,0.01000000f,-0.99000000f,0.61000000f,0.53000000f,-0.65000000f,0.16000000f,0.32000000f,0.61000000f,-0.94000000f,0.88000000f,0.75000000f,-0.05000000f,-0.24000000f,-0.84000000f,-0.49000000f,0.89000000f,0.39000000f,0.22000000f,0.20000000f,-0.29000000f,0.74000000f,-0.01000000f,0.08000000f,-0.24000000f,-0.80000000f,0.57000000f,-0.16000000f,0.00000000f,-0.48000000f,0.68000000f,-0.06000000f,0.78000000f,-0.66000000f,-0.91000000f,0.30000000f,-0.72000000f,-0.20000000f,0.28000000f,-0.94000000f,-0.44000000f,-0.29000000f,0.27000000f,-0.84000000f,0.86000000f,-0.47000000f,-0.62000000f,0.29000000f,-0.59000000f,0.71000000f,-0.10000000f,-0.47000000f,-0.40000000f,-0.62000000f,-0.45000000f,0.01000000f,-0.88000000f,-0.47000000f,-0.11000000f,-0.27000000f,0.33000000f,-0.12000000f,0.68000000f,-0.96000000f,0.30000000f,-0.73000000f,0.13000000f,0.70000000f,0.78000000f,0.18000000f,0.35000000f,-0.82000000f,-0.65000000f,-0.72000000f,0.44000000f,-0.03000000f,0.12000000f,-0.68000000f,-0.68000000f,0.48000000f,0.89000000f,-0.32000000f,0.84000000f,0.32000000f,0.14000000f,-0.68000000f,0.44000000f,0.17000000f,0.56000000f,-0.76000000f,0.24000000f,-0.88000000f,0.04000000f,-0.46000000f,-0.34000000f,0.28000000f,-0.31000000f,-0.97000000f,-0.21000000f,-0.78000000f,-0.84000000f,-0.22000000f,-0.73000000f,0.07000000f,-0.56000000f,0.01000000f,-0.75000000f,-0.19000000f,-0.41000000f,0.78000000f,-0.23000000f,0.93000000f,0.91000000f,0.96000000f,-0.41000000f,-0.27000000f,-0.20000000f,-0.59000000f,0.25000000f,0.38000000f,-0.63000000f,0.24000000f,0.62000000f,0.44000000f,0.71000000f,-0.55000000f,0.61000000f,0.50000000f,-0.56000000f,0.77000000f,0.44000000f,0.25000000f,-0.17000000f,-0.32000000f,0.83000000f,-0.33000000f,0.16000000f,0.90000000f,-0.58000000f,-0.63000000f,0.28000000f,-0.65000000f,0.02000000f,0.60000000f,0.67000000f,0.30000000f,0.09000000f,-0.48000000f,0.54000000f,-0.07000000f,0.32000000f,-0.51000000f,-0.83000000f,0.67000000f,0.86000000f,0.48000000f,-0.14000000f,-0.03000000f,-0.49000000f,0.17000000f,-0.59000000f,-0.21000000f,-0.26000000f,-0.93000000f,0.80000000f,-0.35000000f,0.52000000f,-0.40000000f,-0.89000000f,-0.77000000f,-0.53000000f,0.56000000f,-0.58000000f,0.45000000f,0.54000000f,0.81000000f,0.05000000f,0.54000000f,0.11000000f,0.78000000f,0.53000000f,0.88000000f,0.13000000f,-0.95000000f,-0.23000000f,-0.40000000f,0.29000000f,-0.37000000f,-0.57000000f,0.39000000f,0.24000000f,0.14000000f,0.86000000f,0.36000000f,-0.72000000f,0.12000000f,-0.54000000f,0.60000000f,0.22000000f,0.32000000f,-0.02000000f,0.69000000f,-0.43000000f,-0.64000000f,0.92000000f,0.37000000f,0.07000000f,0.16000000f,0.05000000f,0.11000000f,0.19000000f,0.21000000f,-0.60000000f,-0.02000000f,0.43000000f,0.84000000f,-0.97000000f,-0.12000000f,-0.06000000f,-0.11000000f,-0.35000000f,0.77000000f,-0.12000000f,-0.44000000f,-0.02000000f,-0.09000000f,0.34000000f,0.37000000f,0.17000000f,-0.63000000f,0.07000000f,0.74000000f,0.57000000f,-0.97000000f,0.57000000f,0.22000000f,0.47000000f,-0.92000000f,-0.97000000f,-0.01000000f,0.47000000f,0.08000000f,-0.31000000f,0.74000000f,0.79000000f,-0.68000000f,-0.89000000f,-0.10000000f,-0.80000000f,-0.91000000f,0.06000000f,-0.40000000f,0.76000000f,0.27000000f,0.79000000f,0.96000000f,-0.95000000f,0.62000000f,-0.09000000f,0.41000000f,0.03000000f,-0.03000000f,-0.85000000f,-0.51000000f,0.92000000f,-0.67000000f,0.44000000f,0.20000000f,-0.29000000f,-0.01000000f,0.48000000f,0.76000000f,-0.74000000f,-0.95000000f,-0.62000000f,-0.46000000f,0.55000000f,0.61000000f,-0.51000000f,0.26000000f,0.53000000f,-0.99000000f,0.28000000f,0.53000000f,-0.41000000f,-0.92000000f,0.38000000f,-0.53000000f,-0.14000000f,0.87000000f,0.80000000f,0.07000000f,-0.76000000f,0.25000000f,-0.75000000f,-0.83000000f,-0.83000000f,-0.01000000f,-0.08000000f,0.92000000f,-0.33000000f,0.67000000f,0.08000000f,-0.11000000f,0.35000000f,-0.17000000f,0.70000000f,0.23000000f,-0.64000000f,-0.91000000f,0.56000000f,0.82000000f,0.42000000f,-0.48000000f,0.54000000f,-0.04000000f,0.00000000f,0.05000000f,0.00000000f,-0.11000000f,0.02000000f,-0.26000000f,0.46000000f,0.04000000f,0.84000000f,-0.54000000f,-0.33000000f,-0.55000000f,-0.00000000f,-0.90000000f,0.73000000f,-0.19000000f,-0.35000000f,-0.40000000f,-0.09000000f,-0.15000000f,0.92000000f,-0.20000000f,-0.95000000f,-0.85000000f,0.92000000f,0.10000000f,0.61000000f,0.02000000f,-0.01000000f,0.54000000f,0.07000000f,0.85000000f,0.50000000f,-0.84000000f,0.14000000f,-0.38000000f,0.40000000f,0.22000000f,-0.49000000f,0.11000000f,-0.49000000f,-0.23000000f,-0.39000000f,-0.25000000f,-0.31000000f,0.65000000f,-0.52000000f,-0.38000000f,0.46000000f,-0.73000000f,0.91000000f,-0.71000000f,0.77000000f,0.65000000f,-0.05000000f,0.31000000f,-0.60000000f,0.08000000f,-0.26000000f,0.25000000f,0.38000000f,-0.68000000f,0.55000000f,0.83000000f,-0.63000000f,-0.75000000f,-0.55000000f,0.08000000f,-0.42000000f,0.35000000f,-0.33000000f,-0.45000000f,0.00000000f,0.67000000f,0.78000000f,-0.59000000f,0.55000000f,-0.90000000f,-0.47000000f,0.91000000f,0.00000000f,-0.15000000f,0.34000000f,0.75000000f,-0.92000000f,0.15000000f,0.21000000f,0.14000000f,-0.14000000f,0.22000000f,-0.19000000f,0.42000000f,0.31000000f,0.75000000f,-0.66000000f,-0.24000000f,0.37000000f,0.40000000f,0.25000000f,-0.15000000f,0.47000000f,0.03000000f,0.14000000f,-0.32000000f,0.56000000f,-0.58000000f,0.88000000f,-0.67000000f,0.96000000f,0.14000000f,-0.78000000f,0.98000000f,-0.77000000f,-0.52000000f,-0.27000000f,0.94000000f,0.55000000f,0.03000000f,0.90000000f,-0.56000000f,-0.43000000f,-0.58000000f,-0.27000000f,-0.79000000f,-0.87000000f,-0.71000000f,-0.22000000f,-0.48000000f,-0.38000000f,-0.96000000f,0.58000000f,0.24000000f,-0.28000000f,-0.47000000f,0.33000000f,0.10000000f,-0.44000000f,-0.94000000f,0.29000000f,-0.16000000f,0.43000000f,-0.79000000f,0.81000000f,-0.89000000f,-0.63000000f,-0.76000000f,-0.15000000f,-0.71000000f,-0.77000000f,0.13000000f,0.67000000f,-0.15000000f,0.86000000f,0.12000000f,-0.37000000f,0.42000000f,-0.82000000f,-0.64000000f,0.42000000f,0.21000000f,-0.37000000f,-0.88000000f,0.14000000f,-0.80000000f,0.22000000f,0.52000000f,-0.84000000f,-0.39000000f,0.89000000f,0.23000000f,-0.21000000f,-0.62000000f,0.49000000f,0.35000000f,-0.13000000f,-0.40000000f,0.94000000f,-0.10000000f,-0.71000000f,-0.54000000f,0.75000000f,0.28000000f,-0.00000000f,-0.78000000f,-0.12000000f,0.42000000f,0.28000000f,-0.99000000f,0.82000000f,-0.99000000f,-0.97000000f,0.61000000f,0.29000000f,-0.76000000f,0.97000000f,-0.57000000f,-0.50000000f,0.20000000f,0.38000000f,-0.95000000f,0.08000000f,-0.57000000f,-0.98000000f,0.24000000f,-0.41000000f,0.40000000f,0.50000000f,0.59000000f,0.44000000f,-0.76000000f,-0.97000000f,-0.65000000f,-0.07000000f,-0.12000000f,-0.03000000f,0.79000000f,0.87000000f,-0.63000000f,-0.09000000f,0.16000000f,-0.47000000f,0.62000000f,0.55000000f,0.17000000f,0.32000000f,-0.44000000f,0.44000000f,0.61000000f,-0.52000000f,0.51000000f,-0.49000000f,0.87000000f,-0.34000000f,0.63000000f,-0.53000000f,-0.30000000f,-0.50000000f,-0.11000000f,-0.82000000f,-0.63000000f,-0.27000000f,0.31000000f,-0.60000000f,-0.83000000f,0.84000000f,0.90000000f,-0.13000000f,0.61000000f,-0.29000000f,-0.62000000f,0.51000000f,-0.32000000f,0.01000000f,-0.35000000f,-0.22000000f,-0.03000000f,-0.65000000f,0.25000000f,0.23000000f,-0.70000000f,0.09000000f,-0.34000000f,-0.82000000f,-0.60000000f,0.27000000f,0.48000000f,-0.04000000f,0.91000000f,0.40000000f,-0.66000000f,0.85000000f,-0.20000000f,0.85000000f,0.61000000f,-0.96000000f,-0.25000000f,-0.55000000f,-0.75000000f,0.00000000f,0.78000000f,-0.92000000f,0.29000000f,-0.00000000f,0.66000000f,0.03000000f,0.47000000f,-0.44000000f,-0.43000000f,-0.63000000f,0.82000000f,-0.00000000f,-0.88000000f,-0.14000000f,-0.55000000f,0.37000000f,0.00000000f,0.95000000f,0.12000000f,0.95000000f,0.22000000f,-0.98000000f,0.82000000f,-0.44000000f,0.37000000f,-0.09000000f,-0.92000000f,0.52000000f,-0.26000000f,-0.37000000f,0.95000000f,0.74000000f,0.84000000f,-0.97000000f,0.09000000f,-0.33000000f,-0.87000000f,-0.06000000f,0.81000000f,-0.85000000f,-0.68000000f,-0.67000000f,0.65000000f,-0.95000000f,0.60000000f,-0.55000000f,-0.45000000f,0.50000000f,0.54000000f,-0.18000000f,-0.00000000f,-0.53000000f,0.68000000f,0.88000000f,0.36000000f,-0.37000000f,0.58000000f,-0.90000000f,0.69000000f,-0.69000000f,0.10000000f,0.40000000f,-0.88000000f,-0.91000000f,-0.90000000f,-0.18000000f,0.47000000f,-0.60000000f,0.17000000f,-0.13000000f,0.64000000f,-0.24000000f,-0.42000000f,-0.89000000f,-0.47000000f,0.24000000f,-0.09000000f,0.13000000f,0.22000000f,0.35000000f,0.49000000f,0.73000000f,-0.97000000f,-0.58000000f,0.49000000f,0.20000000f,0.21000000f,-0.24000000f,0.16000000f,-0.77000000f,0.02000000f,-0.35000000f,0.06000000f,0.83000000f,-0.04000000f,-0.87000000f,-0.61000000f,0.78000000f,0.25000000f,-0.49000000f,-0.73000000f,-0.13000000f,0.95000000f,-0.59000000f,0.41000000f,-0.97000000f,-0.53000000f,-0.10000000f,-0.45000000f,-0.86000000f,0.57000000f,-0.58000000f,-0.78000000f,0.51000000f,-0.05000000f,-0.57000000f,0.11000000f,0.46000000f,0.66000000f,-0.48000000f,0.51000000f,-0.01000000f,-0.53000000f,-0.76000000f,0.19000000f,-0.01000000f,0.62000000f,-0.76000000f,0.49000000f,0.13000000f,-0.44000000f,0.01000000f,0.98000000f,-0.33000000f,-0.18000000f,-0.00000000f,0.27000000f,0.58000000f,0.94000000f,-0.21000000f,-0.79000000f,0.78000000f,0.15000000f,-0.19000000f,-0.60000000f,0.66000000f,0.53000000f,-0.13000000f,-0.91000000f,-0.96000000f,0.16000000f,-0.19000000f,-0.40000000f,-0.79000000f,-0.18000000f,0.66000000f,-0.17000000f,0.80000000f,0.90000000f,0.91000000f,0.43000000f,-0.83000000f,0.74000000f,-0.88000000f,-0.41000000f,0.07000000f,-0.25000000f,-0.53000000f,-0.75000000f,-0.43000000f,-0.62000000f,-0.35000000f,0.90000000f,-0.05000000f,0.75000000f,-0.76000000f,0.87000000f,-0.51000000f,0.16000000f,0.11000000f,-0.79000000f,0.29000000f,0.36000000f,0.56000000f,-0.85000000f,-0.51000000f,-0.04000000f,0.63000000f,0.75000000f,0.66000000f,-0.65000000f,-0.33000000f,-0.58000000f,0.09000000f,-0.50000000f,-0.70000000f,-0.75000000f,0.45000000f,-0.75000000f,0.21000000f,-0.20000000f,-0.39000000f,0.48000000f,0.97000000f,-0.03000000f,0.24000000f,-0.18000000f,-0.48000000f,0.46000000f,-0.04000000f,-0.71000000f,-0.11000000f,0.89000000f,0.56000000f,-0.52000000f,0.76000000f,0.44000000f,0.19000000f,0.83000000f,0.93000000f,-0.51000000f,0.83000000f,0.73000000f,0.12000000f,0.52000000f,-0.97000000f,0.42000000f,0.91000000f,-0.17000000f,0.13000000f,0.44000000f,-0.03000000f,0.54000000f,0.48000000f,-0.25000000f,-0.92000000f,-0.46000000f,0.39000000f,0.82000000f,-0.23000000f,0.05000000f,0.66000000f,-0.08000000f,0.60000000f,0.14000000f,-0.20000000f,-0.32000000f,-0.10000000f,-0.21000000f,0.12000000f,0.56000000f,-0.73000000f,0.63000000f,0.09000000f,0.97000000f,0.10000000f,-0.88000000f,0.71000000f,0.25000000f,-0.62000000f,-0.30000000f,-0.25000000f,-0.64000000f,0.35000000f,0.91000000f,0.57000000f,0.08000000f,-0.97000000f,-0.41000000f,-0.94000000f,-0.91000000f,-0.11000000f,0.57000000f,-0.68000000f,-0.37000000f,-0.39000000f,0.83000000f,0.31000000f,-0.15000000f,0.81000000f,-0.53000000f,0.63000000f,-0.65000000f,0.92000000f,-0.40000000f,-0.35000000f,0.05000000f,0.84000000f,0.63000000f,0.12000000f,-0.97000000f,0.98000000f,0.21000000f,0.91000000f,-0.86000000f,-0.12000000f,-0.77000000f,0.56000000f,0.66000000f,-0.60000000f,0.67000000f,-0.36000000f,-0.33000000f,0.39000000f,-0.21000000f,0.22000000f,0.82000000f,-0.51000000f,0.86000000f,0.28000000f,-0.07000000f,0.13000000f,-0.91000000f,-0.83000000f,-0.60000000f,-0.88000000f,0.42000000f,0.63000000f,-0.70000000f,0.54000000f,0.70000000f,0.38000000f,-0.71000000f,-0.15000000f,0.87000000f,0.07000000f,0.81000000f,-0.33000000f,-0.87000000f,-0.86000000f,0.85000000f,0.37000000f,-0.17000000f,0.71000000f,0.87000000f,-0.56000000f,0.06000000f,-0.66000000f,0.79000000f,-0.17000000f,0.13000000f,-0.22000000f,-0.75000000f,0.65000000f,0.14000000f,0.25000000f,0.56000000f,0.63000000f,-0.68000000f,-0.11000000f,0.91000000f,0.12000000f,-0.01000000f,-0.25000000f,-0.76000000f,-0.93000000f,0.66000000f,0.55000000f,0.43000000f,-0.35000000f,0.60000000f,-0.01000000f,-0.68000000f,-0.94000000f,-0.34000000f,-0.47000000f,0.87000000f,0.78000000f,0.10000000f,0.61000000f,-0.34000000f,0.19000000f,-0.24000000f,-0.20000000f,0.65000000f,-0.04000000f,-0.46000000f,0.08000000f,0.10000000f,0.54000000f,0.28000000f,-0.33000000f,-0.89000000f,0.88000000f,-0.54000000f,-0.04000000f,0.22000000f,0.53000000f,0.70000000f,0.07000000f,-0.65000000f,-0.86000000f,-0.72000000f,-0.61000000f,0.15000000f,-0.33000000f,-0.46000000f,0.96000000f,0.51000000f,0.86000000f,0.84000000f,0.03000000f,-0.62000000f,0.54000000f,-0.40000000f,-0.73000000f,0.04000000f,-0.40000000f,0.23000000f,-0.40000000f,0.28000000f,-0.66000000f,0.71000000f,0.33000000f,0.00000000f,0.59000000f,0.08000000f,0.81000000f,-0.02000000f,0.35000000f,-0.57000000f,0.92000000f,-0.76000000f,0.55000000f,-0.28000000f,0.53000000f,-0.84000000f,-0.76000000f,0.62000000f,-0.86000000f,0.97000000f,0.33000000f,-0.31000000f,-0.70000000f,0.51000000f,0.21000000f,-0.88000000f,-0.14000000f,0.17000000f,0.93000000f,0.34000000f,-0.38000000f,-0.71000000f,-0.68000000f,-0.99000000f,-0.80000000f,-0.26000000f,0.80000000f,0.39000000f,0.65000000f,0.89000000f,-0.11000000f,0.27000000f,0.59000000f,0.72000000f,0.88000000f,0.41000000f,0.27000000f,-0.54000000f,0.61000000f,-0.24000000f,0.64000000f,0.39000000f,0.06000000f,-0.65000000f,-0.23000000f,-0.43000000f,-0.74000000f,0.23000000f,0.06000000f,-0.18000000f,-0.72000000f,0.30000000f,0.07000000f,-0.90000000f,-0.49000000f,-0.50000000f,0.90000000f,0.73000000f,-0.00000000f,0.12000000f,-0.03000000f,0.50000000f,-0.15000000f,0.70000000f,-0.82000000f,0.54000000f,0.73000000f,-0.49000000f,-0.50000000f,-0.22000000f,-0.57000000f,0.58000000f,-0.73000000f,-0.69000000f,-0.58000000f,-0.81000000f,-0.48000000f,0.92000000f,-0.83000000f,-0.67000000f,-0.43000000f,-0.64000000f,0.53000000f,0.00000000f,-0.71000000f,-0.36000000f,0.38000000f,0.92000000f,0.98000000f,-0.60000000f,-0.52000000f,0.11000000f,0.78000000f,-0.40000000f,0.81000000f,-0.50000000f,-0.93000000f,-0.04000000f,-0.65000000f,0.44000000f,-0.66000000f,-0.23000000f,0.09000000f,-0.14000000f,-0.40000000f,0.26000000f,0.82000000f,0.68000000f,0.61000000f,0.93000000f,0.02000000f,-0.86000000f,-0.74000000f,-0.81000000f,-0.84000000f,-0.64000000f,-0.70000000f,-0.36000000f,0.83000000f,-0.57000000f,-0.74000000f,-0.22000000f,0.51000000f,-0.96000000f,-0.07000000f,-0.57000000f,0.18000000f,0.95000000f,0.25000000f,0.76000000f,-0.59000000f,-0.09000000f,-0.74000000f,0.33000000f,0.64000000f,-0.90000000f,0.62000000f,-0.16000000f,-0.69000000f,0.46000000f,-0.86000000f,0.21000000f,-0.25000000f,0.27000000f,0.66000000f,0.63000000f,-0.19000000f,-0.16000000f,-0.31000000f,-0.37000000f,0.99000000f,0.96000000f,-0.84000000f,-0.05000000f,-0.21000000f,0.05000000f,-0.22000000f,-0.09000000f,0.32000000f,0.61000000f,0.94000000f,-0.30000000f,0.73000000f,-0.79000000f,-0.84000000f,0.36000000f,-0.34000000f,0.00000000f,0.19000000f,0.14000000f,-0.94000000f,-0.98000000f,0.93000000f,0.09000000f,-0.75000000f,0.53000000f,-0.39000000f,-0.95000000f,-0.21000000f,0.17000000f,0.87000000f,0.21000000f,-0.29000000f,0.15000000f,-0.96000000f,-0.30000000f,-0.13000000f,0.43000000f,-0.01000000f,-0.08000000f,0.57000000f,0.77000000f,0.98000000f,-0.74000000f,-0.89000000f,0.79000000f,-0.10000000f,-0.15000000f,0.28000000f,0.47000000f,-0.62000000f,0.86000000f,0.77000000f,0.21000000f,-0.22000000f,0.63000000f,-0.42000000f,-0.10000000f,0.42000000f,0.02000000f,-0.15000000f,-0.74000000f,0.66000000f,-0.69000000f,-0.82000000f,-0.39000000f,0.17000000f,-0.16000000f,-0.04000000f,-0.69000000f,0.97000000f,-0.33000000f,0.74000000f,-0.69000000f,-0.01000000f,-0.87000000f,0.43000000f,0.99000000f,-0.18000000f,-0.37000000f,0.86000000f,-0.96000000f,0.97000000f,-0.62000000f,-0.02000000f,0.81000000f,-0.21000000f,0.78000000f,-0.36000000f,0.79000000f,0.14000000f,0.04000000f,0.13000000f,0.77000000f,0.84000000f,-0.21000000f,-0.24000000f,0.50000000f,-0.46000000f,-0.64000000f,-0.43000000f,-0.26000000f,-0.08000000f,-0.14000000f,-0.70000000f,0.77000000f,-0.59000000f,-0.39000000f,0.60000000f,-0.06000000f,0.42000000f,-0.83000000f,-0.43000000f,0.90000000f,0.76000000f,-0.52000000f,-0.92000000f,-0.22000000f,-0.15000000f,-0.54000000f,0.87000000f,0.20000000f,0.80000000f,0.93000000f,-0.14000000f,-0.33000000f,-0.83000000f,0.20000000f,-0.98000000f,0.18000000f,0.32000000f,-0.65000000f,0.00000000f,-0.22000000f,0.89000000f,-0.07000000f,-0.31000000f,0.05000000f,-0.49000000f,-0.58000000f,0.11000000f,-0.23000000f,0.18000000f,-0.58000000f,-0.30000000f,-0.83000000f,0.39000000f,0.56000000f,-0.49000000f,0.45000000f,-0.79000000f,0.79000000f,-0.67000000f,0.67000000f,-0.15000000f,0.32000000f,-0.91000000f,0.46000000f,0.11000000f,0.49000000f,0.78000000f,0.33000000f,-0.66000000f,-0.64000000f,0.63000000f,-0.42000000f,-0.25000000f,-0.80000000f,-0.24000000f,-0.69000000f,0.56000000f,0.84000000f,0.77000000f,0.74000000f,-0.39000000f,0.54000000f,0.83000000f,0.22000000f,-0.98000000f,0.26000000f,0.17000000f,0.63000000f,0.00000000f,0.55000000f,-0.92000000f,0.94000000f,-0.32000000f,-0.87000000f,-0.74000000f,0.11000000f,0.61000000f,0.55000000f,-0.72000000f,0.19000000f,-0.44000000f,-0.97000000f,-0.25000000f,-0.94000000f,0.75000000f,-0.41000000f,-0.40000000f,-0.83000000f,-0.82000000f,-0.51000000f,-0.26000000f,0.49000000f,0.98000000f,0.26000000f,0.91000000f,0.30000000f,-0.37000000f,0.50000000f,-0.77000000f,0.39000000f,-0.02000000f,0.22000000f,-0.91000000f,0.25000000f,0.98000000f,0.92000000f,0.85000000f,-0.23000000f,-0.00000000f,-0.35000000f,-0.63000000f,0.88000000f,0.39000000f,0.74000000f,-0.04000000f,0.34000000f,0.02000000f,-0.82000000f,0.73000000f,0.33000000f,-0.59000000f,0.47000000f,0.56000000f,0.48000000f,-0.34000000f,0.84000000f,-0.68000000f,-0.28000000f,0.96000000f,-0.06000000f,0.30000000f,-0.75000000f,0.91000000f,0.09000000f,0.29000000f,-0.84000000f,0.97000000f,-0.66000000f,0.52000000f,-0.00000000f,0.56000000f,-0.46000000f,0.29000000f,0.49000000f,0.64000000f,0.77000000f,-0.24000000f,0.20000000f,0.34000000f,0.40000000f,0.20000000f,0.85000000f,-0.80000000f,0.28000000f,0.93000000f,0.72000000f,-0.30000000f,0.62000000f,0.61000000f,-0.63000000f,-0.66000000f,-0.46000000f,0.95000000f,0.05000000f,-0.47000000f,0.83000000f,0.02000000f,-0.33000000f,-0.35000000f,0.38000000f,-0.51000000f,0.11000000f,0.52000000f,0.14000000f,0.87000000f,-0.71000000f,-0.87000000f,-0.22000000f,0.52000000f,0.82000000f,-0.77000000f,0.72000000f,0.48000000f,-0.11000000f,-0.77000000f,0.64000000f,-0.61000000f,0.09000000f,-0.16000000f,-0.30000000f,0.56000000f,0.50000000f,-0.66000000f,-0.39000000f,0.81000000f,0.42000000f,0.29000000f,-0.32000000f,0.67000000f,-0.59000000f,-0.60000000f,0.74000000f,0.93000000f,-0.49000000f,-0.34000000f,-0.35000000f,0.32000000f,-0.75000000f,0.32000000f,-0.03000000f,-0.39000000f,0.61000000f,-0.84000000f,-0.46000000f,-0.33000000f,0.99000000f,-0.71000000f,0.71000000f,-0.48000000f,0.27000000f,0.65000000f,-0.08000000f,0.86000000f,-0.69000000f,0.58000000f,0.10000000f,-0.64000000f,0.82000000f,-0.66000000f,-0.65000000f,0.58000000f,-0.42000000f,0.85000000f,-0.34000000f,0.99000000f,-0.02000000f,-0.05000000f,0.51000000f,-0.40000000f,0.24000000f,0.61000000f,-0.13000000f,-0.78000000f,-0.31000000f,-0.89000000f,0.62000000f,0.30000000f,-0.27000000f,-0.68000000f,-0.41000000f,-0.77000000f,0.64000000f,0.94000000f,0.01000000f,0.29000000f,-0.45000000f,-0.15000000f,-0.73000000f,0.78000000f,-0.27000000f,-0.80000000f,-0.70000000f,-0.30000000f,-0.69000000f,0.38000000f,-0.31000000f,0.37000000f,0.08000000f,0.97000000f,-0.32000000f,-0.01000000f,0.70000000f,0.61000000f,0.39000000f,0.58000000f,0.35000000f,0.32000000f,0.17000000f,0.86000000f,-0.04000000f,-0.75000000f,0.98000000f,0.81000000f,-0.58000000f,0.78000000f,0.94000000f,0.65000000f,0.89000000f,-0.36000000f,-0.43000000f,0.27000000f,0.99000000f,-0.99000000f,0.11000000f,0.04000000f,-0.08000000f,-0.16000000f,0.20000000f,-0.66000000f,0.87000000f,-0.05000000f,-0.57000000f,0.27000000f,0.90000000f,-0.41000000f,-0.60000000f,0.52000000f,-0.95000000f,0.30000000f,0.26000000f,0.54000000f,-0.71000000f,0.44000000f,-0.70000000f,-0.29000000f,-0.84000000f,-0.21000000f,-0.59000000f,0.55000000f,-0.98000000f,-0.85000000f,-0.98000000f,0.84000000f,0.99000000f,0.25000000f,0.14000000f,-0.42000000f,-0.91000000f,-0.48000000f,-0.52000000f,-0.49000000f,0.33000000f,0.05000000f,-0.46000000f,0.97000000f,0.89000000f,-0.12000000f,-0.45000000f,0.91000000f,-0.13000000f,-0.22000000f,-0.74000000f,-0.34000000f,0.00000000f,0.34000000f,0.16000000f,-0.31000000f,-0.11000000f,0.77000000f,-0.70000000f,0.81000000f,0.84000000f,-0.30000000f,0.18000000f,0.98000000f,-0.12000000f,-0.36000000f,0.48000000f,0.26000000f,-0.87000000f,0.21000000f,0.64000000f,0.36000000f,-0.85000000f,-0.04000000f,0.44000000f,-0.89000000f,0.94000000f,-0.98000000f,0.19000000f,-0.40000000f,-0.48000000f,-0.36000000f,0.77000000f,0.29000000f,0.18000000f,-0.02000000f,-0.72000000f,0.44000000f,0.35000000f,0.42000000f,-0.27000000f,0.51000000f,0.94000000f,0.14000000f,0.53000000f,-0.56000000f,-0.07000000f,0.37000000f,-0.33000000f,0.83000000f,-0.53000000f,0.33000000f,0.86000000f,-0.13000000f,-0.52000000f,0.11000000f,-0.23000000f,0.25000000f,-0.65000000f,-0.06000000f,0.42000000f,0.71000000f,0.94000000f,-0.78000000f,0.66000000f,0.96000000f,0.54000000f,0.20000000f,-0.36000000f,-0.52000000f,-0.26000000f,-0.59000000f,0.42000000f,0.34000000f,-0.23000000f,-0.35000000f,0.67000000f,0.49000000f,0.22000000f,-0.31000000f,0.17000000f,-0.34000000f,0.13000000f,0.06000000f,0.78000000f,-0.24000000f,-0.50000000f,0.41000000f,-0.18000000f,-0.93000000f,-0.98000000f,-0.02000000f,-0.16000000f,-0.11000000f,-0.37000000f,-0.66000000f,-0.63000000f,0.14000000f,-0.87000000f,-0.60000000f,0.60000000f,-0.45000000f,0.75000000f,-0.41000000f,0.62000000f,0.24000000f,0.71000000f,0.63000000f,0.77000000f,0.11000000f,-0.99000000f,0.03000000f,0.50000000f,-0.72000000f,-0.77000000f,-0.25000000f,0.00000000f,0.51000000f,-0.77000000f,-0.35000000f,-0.91000000f,0.94000000f,0.40000000f,0.89000000f,0.25000000f,-0.42000000f,-0.24000000f,-0.15000000f,-0.85000000f,0.32000000f,-0.42000000f,0.66000000f,0.57000000f,-0.89000000f,-0.08000000f,0.76000000f,-0.57000000f,0.09000000f,-0.26000000f,-0.30000000f,-0.46000000f,-0.44000000f,-0.06000000f,0.79000000f,0.67000000f,-0.60000000f,-0.59000000f,-0.05000000f,0.11000000f,-0.60000000f,-0.22000000f,-0.99000000f,0.51000000f,-0.30000000f,0.70000000f,0.85000000f,0.00000000f,-0.55000000f,-0.26000000f,-0.28000000f,-0.55000000f,0.85000000f,0.49000000f,-0.33000000f,-0.95000000f,-0.34000000f,-0.26000000f,-0.41000000f,-0.37000000f,-0.07000000f,0.84000000f,-0.94000000f,0.36000000f,-0.97000000f,0.04000000f,0.52000000f,0.36000000f,0.36000000f,-0.41000000f,-0.66000000f,0.91000000f,0.99000000f,-0.70000000f,-0.36000000f,0.20000000f,0.97000000f,-0.87000000f,-0.32000000f,-0.86000000f,-0.85000000f,-0.33000000f,0.69000000f,0.44000000f,-0.25000000f,-0.44000000f,-0.44000000f,-0.90000000f,0.93000000f,0.74000000f,-0.52000000f,0.71000000f,0.97000000f,0.13000000f,0.04000000f,0.42000000f,0.08000000f,-0.71000000f,0.08000000f,0.13000000f,-0.42000000f,-0.08000000f,-0.49000000f,-0.13000000f,0.91000000f,0.08000000f,0.02000000f,0.42000000f,-0.44000000f,-0.32000000f,0.34000000f,0.27000000f,0.70000000f,0.49000000f,-0.30000000f,-0.00000000f,-0.87000000f,0.08000000f,0.29000000f,0.64000000f,0.02000000f,-0.29000000f,0.23000000f,-0.53000000f,-0.93000000f,0.42000000f,-0.47000000f,-0.79000000f,0.66000000f,0.75000000f,-0.30000000f,0.16000000f,0.81000000f,-0.81000000f,0.36000000f,0.71000000f,0.90000000f,0.15000000f,0.98000000f,-0.77000000f,0.96000000f,0.10000000f,0.40000000f,0.05000000f,-0.76000000f,0.71000000f,-0.12000000f,-0.30000000f,0.93000000f,-0.00000000f,-0.53000000f,-0.25000000f,-0.10000000f,0.04000000f,-0.07000000f,0.04000000f,-0.89000000f,0.53000000f,-0.76000000f,0.60000000f,0.07000000f,-0.31000000f,0.06000000f,-0.35000000f,0.33000000f,0.01000000f,-0.25000000f,-0.71000000f,-0.38000000f,-0.39000000f,0.15000000f,-0.28000000f,-0.44000000f,-0.64000000f,-0.80000000f,-0.61000000f,-0.57000000f,0.46000000f,0.61000000f,-0.49000000f,-0.07000000f,-0.17000000f,-0.94000000f,0.73000000f,-0.06000000f,-0.02000000f,0.19000000f,0.54000000f,0.38000000f,0.69000000f,-0.67000000f,-0.27000000f,0.05000000f,0.75000000f,-0.48000000f,-0.13000000f,-0.18000000f,-0.02000000f,0.37000000f,0.63000000f,-0.97000000f,0.30000000f,0.82000000f,0.82000000f,0.88000000f,0.25000000f,-0.64000000f,0.60000000f,-0.41000000f,-0.12000000f,-0.73000000f,-0.65000000f,-0.53000000f,0.02000000f,0.58000000f,-0.36000000f,-0.53000000f,0.88000000f,-0.51000000f,0.66000000f,-0.79000000f,-0.23000000f,0.65000000f,-0.38000000f,0.99000000f,-0.51000000f,-0.62000000f,0.72000000f,-0.31000000f,-0.87000000f,0.56000000f,0.18000000f,0.71000000f,0.01000000f,-0.72000000f,0.59000000f,0.15000000f,-0.73000000f,0.43000000f,-0.81000000f,-0.62000000f,0.08000000f,0.82000000f,0.98000000f,0.94000000f,-0.97000000f,0.97000000f,-0.27000000f,-0.17000000f,-0.41000000f,-0.20000000f,-0.61000000f,0.31000000f,-0.25000000f,-0.58000000f,0.95000000f,-0.36000000f,0.28000000f,-0.54000000f,-0.92000000f,-0.87000000f,-0.61000000f,0.12000000f,-0.24000000f,0.71000000f,0.90000000f,-0.29000000f,-0.75000000f,0.78000000f,0.30000000f,0.51000000f,-0.48000000f,-0.39000000f,0.75000000f,-0.90000000f,0.65000000f,-0.07000000f,0.17000000f,-0.55000000f,0.27000000f,-0.66000000f,-0.23000000f,-0.13000000f,0.06000000f,-0.27000000f,0.13000000f,0.53000000f,-0.06000000f,0.88000000f,0.81000000f,-0.56000000f,-0.09000000f,-0.26000000f,-0.84000000f,-0.22000000f,-0.59000000f,0.23000000f,0.60000000f,-0.60000000f,0.90000000f,-0.86000000f,0.00000000f,-0.43000000f,-0.15000000f,-0.33000000f,-0.89000000f,0.20000000f,-0.08000000f,0.37000000f,0.24000000f,0.86000000f,0.67000000f,-0.52000000f,-0.88000000f,0.45000000f,-0.56000000f,0.00000000f,-0.45000000f,0.07000000f,-0.82000000f,0.08000000f,-0.27000000f,-0.64000000f,-0.88000000f,0.92000000f,-0.99000000f,-0.12000000f,0.89000000f,0.35000000f,-0.29000000f,0.48000000f,-0.35000000f,-0.50000000f,-0.60000000f,0.31000000f,-0.46000000f,0.60000000f,0.47000000f,0.54000000f,0.45000000f,0.86000000f,0.54000000f,-0.99000000f,0.59000000f,-0.01000000f,0.86000000f,-0.10000000f,0.54000000f,-0.76000000f,-0.88000000f,0.75000000f,-0.61000000f,0.40000000f,-0.25000000f,0.92000000f,0.14000000f,-0.18000000f,0.04000000f,-0.31000000f,0.29000000f,-0.80000000f,0.67000000f,-0.60000000f,-0.76000000f,-0.01000000f,-0.19000000f,0.18000000f,0.55000000f,0.03000000f,0.23000000f,-0.30000000f,-0.66000000f,-0.12000000f,-0.16000000f,0.97000000f,0.40000000f,0.52000000f,-0.15000000f,-0.89000000f,0.71000000f,0.31000000f,0.96000000f,0.90000000f,-0.19000000f,-0.35000000f,0.28000000f,-0.64000000f,-0.45000000f,-0.78000000f,-0.98000000f,-0.36000000f,0.00000000f,-0.53000000f,-0.91000000f,-0.41000000f,0.21000000f,0.43000000f,-0.24000000f,-0.37000000f,-0.91000000f,0.66000000f,0.19000000f,0.76000000f,0.72000000f,-0.44000000f,0.55000000f,0.51000000f,0.45000000f,0.68000000f,-0.26000000f,0.09000000f,-0.87000000f,0.16000000f,0.52000000f,0.85000000f,-0.61000000f,-0.28000000f,-0.50000000f,0.32000000f,-0.24000000f,0.09000000f,0.18000000f,0.46000000f,0.80000000f,-0.04000000f,0.07000000f,0.29000000f,-0.57000000f,-0.22000000f,-0.92000000f,-0.49000000f,0.98000000f,0.99000000f,0.61000000f,0.26000000f,0.85000000f,-0.24000000f,0.47000000f,-0.40000000f,-0.59000000f,-0.00000000f,-0.89000000f,-0.33000000f,0.37000000f,0.26000000f,0.31000000f,-0.77000000f,-0.89000000f,-0.03000000f,-0.26000000f,0.85000000f,0.71000000f,-0.12000000f,0.64000000f,0.92000000f,-0.54000000f,0.96000000f,0.42000000f,0.85000000f,-0.85000000f,0.22000000f,0.61000000f,0.64000000f,-0.82000000f,0.01000000f,-0.07000000f,0.58000000f,-0.33000000f,0.25000000f,0.26000000f,-0.52000000f,0.44000000f,-0.84000000f,0.50000000f,-0.02000000f,-0.29000000f,0.57000000f,-0.43000000f,-0.62000000f,0.66000000f,-0.01000000f,-0.86000000f,0.83000000f,0.90000000f,-0.16000000f,0.66000000f,-0.81000000f,-0.30000000f,0.15000000f,-0.62000000f,0.38000000f,0.92000000f,-0.11000000f,0.39000000f,0.51000000f,-0.27000000f,0.62000000f,-0.86000000f,0.00000000f,-0.16000000f,0.70000000f,-0.77000000f,-0.92000000f,-0.73000000f,-0.28000000f,-0.47000000f,-0.70000000f,-0.66000000f,-0.78000000f,-0.86000000f,0.56000000f,0.28000000f,0.31000000f,0.96000000f,-0.64000000f,0.18000000f,0.49000000f,-0.81000000f,-0.56000000f,-0.98000000f,0.99000000f,-0.93000000f,0.04000000f,-0.63000000f,-0.22000000f,-0.63000000f,-0.49000000f,0.08000000f,0.47000000f,0.71000000f,-0.35000000f,-0.76000000f,0.01000000f,-0.92000000f,0.80000000f,0.23000000f,0.69000000f,-0.66000000f,0.14000000f,-0.21000000f,0.11000000f,-0.38000000f,-0.11000000f,-0.12000000f,-0.77000000f,-0.90000000f,-0.24000000f,0.78000000f,0.54000000f,0.84000000f,0.18000000f,-0.26000000f,-0.08000000f,-0.66000000f,-0.83000000f,-0.28000000f,0.90000000f,-0.89000000f,0.98000000f,-0.75000000f,-0.92000000f,-0.56000000f,0.29000000f,0.03000000f,0.25000000f,-0.64000000f,0.23000000f,-0.30000000f,0.44000000f,0.98000000f,-0.48000000f,0.66000000f,0.80000000f,-0.31000000f,0.17000000f,0.45000000f,-0.43000000f,0.59000000f,-0.78000000f,0.10000000f,0.27000000f,0.04000000f,0.85000000f,-0.25000000f,-0.22000000f,-0.07000000f,-0.64000000f,-0.86000000f,-0.39000000f,0.73000000f,0.81000000f,-0.71000000f,0.63000000f,0.87000000f,-0.41000000f,0.45000000f,-0.00000000f,-0.01000000f,0.40000000f,0.10000000f,-0.59000000f,0.13000000f,-0.11000000f,0.13000000f,0.18000000f,-0.06000000f,-0.18000000f,0.28000000f,-0.42000000f,-0.62000000f,-0.82000000f,0.34000000f,-0.61000000f,0.61000000f,-0.47000000f,0.34000000f,-0.68000000f,0.92000000f,-0.08000000f,0.90000000f,0.52000000f,0.71000000f,-0.14000000f,0.73000000f,-0.72000000f,-0.43000000f,0.15000000f,-0.10000000f,0.49000000f,-0.33000000f,0.71000000f,-0.13000000f,-0.48000000f,-0.39000000f,0.08000000f,0.50000000f,0.47000000f,-0.79000000f,-0.21000000f,-0.75000000f,0.89000000f,0.15000000f,0.21000000f,0.62000000f,-0.05000000f,0.62000000f,-0.83000000f,0.87000000f,-0.34000000f,0.61000000f,-0.60000000f,-0.42000000f,0.11000000f,0.03000000f,-0.66000000f,-0.05000000f,0.42000000f,0.19000000f,0.82000000f,0.69000000f,-0.33000000f,-0.92000000f,-0.02000000f,-0.00000000f,0.82000000f,0.83000000f,-0.02000000f,0.44000000f,0.11000000f,0.19000000f,0.01000000f,-0.09000000f,0.38000000f,-0.32000000f,0.30000000f,0.84000000f,-0.65000000f,-0.01000000f,-0.08000000f,-0.02000000f,-0.83000000f,-0.47000000f,0.95000000f,-0.99000000f,0.37000000f,-0.38000000f,0.21000000f,0.35000000f,-0.38000000f,0.92000000f,0.60000000f,0.46000000f,-0.14000000f,0.28000000f,0.20000000f,-0.15000000f,-0.03000000f,0.96000000f,-0.33000000f,0.08000000f,-0.48000000f,-0.56000000f,0.96000000f,-0.03000000f,-0.56000000f,-0.25000000f,0.90000000f,0.16000000f,0.21000000f,-0.45000000f,0.77000000f,0.21000000f,0.61000000f,0.74000000f,-0.07000000f,0.93000000f,-0.35000000f,-0.26000000f,0.52000000f,0.74000000f,-0.91000000f,0.33000000f,0.09000000f,-0.45000000f,0.58000000f,-0.53000000f,0.31000000f,0.42000000f,0.70000000f,-0.85000000f,-0.19000000f,0.63000000f,-0.87000000f,0.67000000f,-0.49000000f,0.51000000f,-0.08000000f,0.96000000f,-0.80000000f,0.00000000f,0.79000000f,0.44000000f,0.69000000f,-0.37000000f,-0.86000000f,-0.63000000f,0.90000000f,0.79000000f,-0.56000000f,-0.26000000f,0.66000000f,0.62000000f,0.22000000f,0.27000000f,0.75000000f,-0.86000000f,0.23000000f,0.34000000f,-0.50000000f,-0.40000000f,-0.05000000f,0.12000000f,-0.26000000f,0.40000000f,-0.74000000f,-0.94000000f,-0.65000000f,-0.36000000f,-0.66000000f,-0.96000000f,-0.34000000f,0.57000000f,-0.44000000f,0.09000000f,-0.88000000f,0.66000000f,-0.04000000f,0.46000000f,-0.33000000f,-0.72000000f,0.69000000f,0.58000000f,-0.57000000f,-0.75000000f,0.48000000f,0.31000000f,-0.04000000f,0.34000000f,-0.95000000f,0.49000000f,-0.63000000f,-0.27000000f,0.61000000f,-0.96000000f,-0.00000000f,-0.27000000f,-0.26000000f,0.26000000f,-0.33000000f,0.30000000f,0.61000000f,0.81000000f,0.12000000f,0.24000000f,0.24000000f,-0.07000000f,-0.23000000f,-0.50000000f,-0.55000000f,-0.22000000f,-0.89000000f,-0.97000000f,0.05000000f,0.46000000f,0.11000000f,0.62000000f,-0.02000000f,-0.34000000f,-0.94000000f,0.04000000f,0.97000000f,0.43000000f,0.58000000f,-0.46000000f,0.59000000f,-0.36000000f,0.47000000f,-0.06000000f,-0.57000000f,-0.57000000f,0.10000000f,0.38000000f,-0.43000000f,0.23000000f,-0.91000000f,0.35000000f,0.09000000f,0.91000000f,0.30000000f,0.84000000f,0.09000000f,0.40000000f,-0.75000000f,0.50000000f,-0.36000000f,-0.95000000f,-0.86000000f,-0.78000000f,-0.69000000f,0.28000000f,0.93000000f,0.19000000f,-0.15000000f,0.90000000f,-0.19000000f,0.71000000f,0.98000000f,0.15000000f,0.31000000f,-0.87000000f,-0.61000000f,0.51000000f,0.71000000f,0.67000000f,-0.40000000f,0.70000000f,0.34000000f,0.61000000f,0.61000000f,0.47000000f,0.49000000f,-0.13000000f,-0.43000000f,0.79000000f,-0.45000000f,-0.57000000f,0.40000000f,-0.23000000f,0.53000000f,0.27000000f,-0.58000000f,0.43000000f,-0.10000000f,-0.72000000f,0.27000000f,-0.09000000f,0.56000000f,0.64000000f,0.11000000f,-0.57000000f,-0.27000000f,0.60000000f,-0.29000000f,0.16000000f,0.77000000f,-0.96000000f,0.40000000f,0.13000000f,0.86000000f,-0.42000000f,0.62000000f,-0.21000000f,-0.11000000f,0.92000000f,0.07000000f,-0.08000000f,0.70000000f,0.34000000f,-0.82000000f,-0.46000000f,0.86000000f,-0.01000000f,-0.42000000f,0.41000000f,0.74000000f,-0.03000000f,-0.69000000f,0.38000000f,0.03000000f,0.94000000f,-0.81000000f,-0.44000000f,0.26000000f,-0.48000000f,-0.01000000f,0.81000000f,0.41000000f,-0.87000000f,-0.35000000f,-0.23000000f,-0.32000000f,0.19000000f,-0.31000000f,-0.36000000f,-0.39000000f,0.96000000f,-0.03000000f,0.64000000f,0.65000000f,-0.40000000f,0.80000000f,0.61000000f,0.83000000f,0.37000000f,0.63000000f,0.42000000f,-0.01000000f,0.95000000f,-0.67000000f,0.59000000f,-0.02000000f,-0.06000000f,0.63000000f,0.20000000f,0.27000000f,-0.15000000f,0.13000000f,0.49000000f,-0.43000000f,0.92000000f,-0.76000000f,0.20000000f,-0.35000000f,0.20000000f,-0.82000000f,-0.79000000f,0.09000000f,-0.62000000f,0.60000000f,-0.20000000f,-0.89000000f,-0.22000000f,-0.63000000f,0.31000000f,0.27000000f,-0.67000000f,0.23000000f,0.13000000f,0.18000000f,-0.82000000f,0.95000000f,0.52000000f,-0.26000000f,0.55000000f,-0.77000000f,-0.29000000f,0.43000000f,-0.34000000f,-0.61000000f,0.72000000f,0.21000000f,-0.21000000f,0.21000000f,0.47000000f,-0.02000000f,-0.13000000f,0.10000000f,0.81000000f,0.73000000f,-0.50000000f,-0.59000000f,-0.32000000f,-0.18000000f,-0.02000000f,0.19000000f,-0.58000000f,-0.35000000f,-0.52000000f,0.40000000f,-0.88000000f,-0.87000000f,0.75000000f,-0.08000000f,-0.36000000f,0.49000000f,0.46000000f,0.72000000f,0.47000000f,-0.69000000f,-0.53000000f,-0.67000000f,0.27000000f,0.51000000f,0.73000000f,-0.70000000f,-0.52000000f,0.83000000f,0.03000000f,-0.03000000f,-0.72000000f,0.22000000f,0.29000000f,-0.92000000f,-0.07000000f,-0.58000000f,0.21000000f,-0.62000000f,0.08000000f,0.52000000f,-0.70000000f,0.68000000f,-0.72000000f,-0.66000000f,0.24000000f,0.80000000f,0.48000000f,0.46000000f,-0.41000000f,-0.47000000f,0.06000000f,-0.11000000f,-0.30000000f,0.92000000f,-0.28000000f,0.53000000f,-0.08000000f,0.28000000f,0.55000000f,0.87000000f,0.65000000f,-0.00000000f,-0.44000000f,-0.17000000f,0.35000000f,-0.43000000f,0.01000000f,-0.92000000f,0.01000000f,-0.33000000f,0.21000000f,0.34000000f,0.67000000f,0.48000000f,-0.23000000f,-0.08000000f,0.07000000f,-0.17000000f,-0.02000000f,-0.62000000f,-0.56000000f,0.47000000f,-0.10000000f,0.49000000f,-0.33000000f,0.04000000f,-0.92000000f,-0.68000000f,0.80000000f,0.49000000f,0.42000000f,0.86000000f,-0.23000000f,-0.74000000f,-0.64000000f,0.83000000f,0.39000000f,-0.53000000f,-0.69000000f,-0.86000000f,-0.30000000f,0.22000000f,-0.85000000f,0.78000000f,0.00000000f,-0.86000000f,0.94000000f,0.33000000f,0.85000000f,0.33000000f,-0.34000000f,0.06000000f,-0.25000000f,0.26000000f,-0.88000000f,0.90000000f,-0.47000000f,-0.29000000f,-0.56000000f,-0.59000000f,0.66000000f,-0.06000000f,-0.03000000f,0.75000000f,-0.64000000f,0.03000000f,-0.15000000f,0.69000000f,-0.59000000f,0.66000000f,0.37000000f,-0.21000000f,0.04000000f,-0.24000000f,0.49000000f,-0.30000000f,-0.27000000f,-0.93000000f,-0.16000000f,0.73000000f,-0.22000000f,-0.63000000f,0.98000000f,-0.47000000f,0.60000000f,-0.67000000f,-0.31000000f,-0.24000000f,-0.57000000f,0.10000000f,0.49000000f,-0.52000000f,-0.81000000f,-0.28000000f,0.13000000f,-0.36000000f,0.87000000f,-0.61000000f,0.38000000f,-0.35000000f,0.05000000f,-0.01000000f,0.38000000f,0.92000000f,-0.43000000f,-0.87000000f,0.35000000f,0.84000000f,0.47000000f,0.19000000f,0.71000000f,-0.16000000f,0.32000000f,0.64000000f,-0.27000000f,0.30000000f,-0.88000000f,0.24000000f,0.97000000f,-0.02000000f,0.59000000f,-0.45000000f,-0.13000000f,0.32000000f,0.40000000f,-0.69000000f,0.24000000f,-0.06000000f,-0.29000000f,-0.74000000f,0.01000000f,0.36000000f,0.16000000f,0.18000000f,-0.89000000f,-0.62000000f,0.63000000f,-0.83000000f,0.37000000f,0.88000000f,0.53000000f,0.43000000f,0.16000000f,0.72000000f,0.94000000f,-0.04000000f,0.86000000f,0.64000000f,0.58000000f,-0.03000000f,-0.83000000f,0.78000000f,-0.96000000f,-0.11000000f,-0.30000000f,0.20000000f,-0.60000000f,-0.02000000f,0.52000000f,0.62000000f,-0.99000000f,-0.96000000f,0.17000000f,-0.79000000f,-0.87000000f,-0.32000000f,0.39000000f,0.31000000f,0.02000000f,-0.84000000f,-0.77000000f,0.49000000f,0.65000000f,0.83000000f,-0.30000000f,0.98000000f,-0.13000000f,-0.94000000f,0.14000000f,0.40000000f,-0.47000000f,0.81000000f,0.88000000f,-0.75000000f,0.88000000f,0.54000000f,0.89000000f,-0.52000000f,0.92000000f,-0.10000000f,0.11000000f,0.83000000f,0.11000000f,-0.99000000f,0.22000000f,-0.41000000f,0.00000000f,0.80000000f,-0.53000000f,0.19000000f,0.26000000f,-0.17000000f,-0.70000000f,-0.56000000f,-0.20000000f,0.26000000f,0.91000000f,-0.83000000f,0.67000000f,0.56000000f,0.83000000f,0.43000000f,-0.39000000f,0.28000000f,0.83000000f,-0.43000000f,0.92000000f,0.88000000f,-0.68000000f,-0.37000000f,0.62000000f,-0.68000000f,0.70000000f,-0.16000000f,-0.78000000f,0.88000000f,-0.84000000f,0.32000000f,-0.22000000f,0.72000000f,0.58000000f,0.40000000f,0.24000000f,0.90000000f,-0.08000000f,-0.03000000f,-0.89000000f,0.55000000f,-0.76000000f,-0.34000000f,-0.15000000f,0.19000000f,0.36000000f,0.46000000f,-0.60000000f,-0.43000000f,0.54000000f,-0.38000000f,-0.02000000f,-0.21000000f,-0.60000000f,-0.74000000f,0.92000000f,0.65000000f,0.47000000f,0.75000000f,0.58000000f,0.95000000f,-0.22000000f,-0.64000000f,-0.28000000f,-0.12000000f,0.84000000f,-0.37000000f,-0.18000000f,-0.50000000f,0.08000000f,0.14000000f,0.31000000f,-0.56000000f,-0.18000000f,0.32000000f,0.52000000f,0.46000000f,0.19000000f,0.31000000f,-0.48000000f,-0.95000000f,-0.31000000f,0.83000000f,-0.31000000f,0.22000000f,0.41000000f,-0.02000000f,0.05000000f,0.60000000f,0.36000000f,0.78000000f,0.50000000f,0.50000000f,0.61000000f,-0.59000000f,-0.00000000f,0.50000000f,0.96000000f,-0.80000000f,-0.56000000f,0.92000000f,-0.00000000f,0.25000000f,0.79000000f,0.76000000f,0.14000000f,-0.00000000f,-0.99000000f,-0.85000000f,0.81000000f,-0.26000000f,-0.58000000f,0.21000000f,-0.68000000f,-0.90000000f,0.68000000f,-0.48000000f,0.59000000f,0.08000000f,0.62000000f,0.38000000f,0.64000000f,-0.54000000f,0.65000000f,0.60000000f,-0.45000000f,-0.54000000f,-0.40000000f,0.13000000f,-0.94000000f,-0.86000000f,-0.67000000f,0.09000000f,-0.53000000f,-0.45000000f,0.23000000f,0.19000000f,0.62000000f,-0.18000000f,-0.51000000f,0.56000000f,0.81000000f,0.55000000f,-0.62000000f,0.60000000f,0.44000000f,0.61000000f,0.58000000f,0.13000000f,0.13000000f,0.46000000f,-0.04000000f,-0.01000000f,-0.61000000f,-0.76000000f,-0.87000000f,-0.25000000f,0.69000000f,-0.29000000f,0.53000000f,-0.59000000f,-0.22000000f,0.22000000f,-0.08000000f,0.77000000f,-0.08000000f,0.65000000f,-0.90000000f,0.19000000f,0.82000000f,-0.26000000f,0.00000000f,0.12000000f,0.22000000f,-0.88000000f,0.52000000f,-0.37000000f,-0.97000000f,0.34000000f,0.94000000f,0.84000000f,0.88000000f,0.35000000f,0.31000000f,-0.22000000f,0.41000000f,-0.96000000f,0.93000000f,-0.43000000f,0.30000000f,-0.20000000f,-0.41000000f,0.96000000f,0.36000000f,-0.88000000f,0.72000000f,0.32000000f,-0.23000000f,0.37000000f,-0.80000000f,0.05000000f,0.52000000f,0.50000000f,-0.94000000f,-0.43000000f,-0.05000000f,-0.44000000f,0.87000000f,-0.11000000f,-0.01000000f,0.85000000f,0.41000000f,0.30000000f,-0.13000000f,-0.02000000f,-0.49000000f,-0.68000000f,-0.15000000f,-0.49000000f,-0.04000000f,-0.40000000f,-0.56000000f,0.32000000f,0.70000000f,-0.38000000f,-0.12000000f,-0.64000000f,-0.69000000f,-0.22000000f,0.40000000f,-0.77000000f,0.44000000f,-0.36000000f,-0.68000000f,-0.45000000f,-0.39000000f,0.00000000f,-0.44000000f,0.73000000f,0.14000000f,-0.21000000f,-0.50000000f,-0.28000000f,0.04000000f,0.25000000f,0.24000000f,-0.70000000f,-0.04000000f,0.78000000f,0.90000000f,-0.37000000f,0.14000000f,-0.31000000f,-0.98000000f,-0.23000000f,0.15000000f,-0.04000000f,-0.43000000f,-0.51000000f,0.34000000f,-0.69000000f,-0.33000000f,-0.00000000f,0.33000000f,0.77000000f,0.55000000f,0.88000000f,0.56000000f,-0.06000000f,0.86000000f,0.61000000f,-0.97000000f,0.42000000f,0.96000000f,-0.23000000f,0.56000000f,-0.82000000f,0.41000000f,0.87000000f,-0.93000000f,-0.40000000f,-0.71000000f,-0.88000000f,0.49000000f,-0.39000000f,-0.66000000f,-0.16000000f,0.57000000f,-0.77000000f,0.15000000f,-0.36000000f,-0.13000000f,0.69000000f,0.36000000f,0.75000000f,-0.84000000f,-0.44000000f,0.77000000f,0.69000000f,-0.89000000f,0.90000000f,-0.91000000f,0.09000000f,0.86000000f,0.27000000f,0.83000000f,0.75000000f,-0.17000000f,0.80000000f,0.40000000f,0.20000000f,-0.40000000f,0.87000000f,-0.85000000f,-0.47000000f,-0.40000000f,-0.47000000f,-0.17000000f,-0.42000000f,-0.14000000f,-0.83000000f,0.04000000f,0.80000000f,0.72000000f,-0.07000000f,-0.24000000f,-0.32000000f,0.91000000f,-0.67000000f,0.27000000f,0.65000000f,0.68000000f,-0.94000000f,-0.88000000f,-0.27000000f,0.74000000f,-0.36000000f,0.88000000f,-0.78000000f,0.44000000f,-0.31000000f,0.21000000f,0.57000000f,0.01000000f,0.25000000f,-0.02000000f,0.44000000f,-0.88000000f,0.96000000f,-0.91000000f,0.66000000f,0.88000000f,0.97000000f,0.53000000f,-0.90000000f,0.07000000f,0.70000000f,-0.41000000f,-0.52000000f,-0.00000000f,-0.48000000f,0.27000000f,-0.19000000f,0.96000000f,-0.00000000f,0.23000000f,0.13000000f,-0.56000000f,-0.69000000f,0.66000000f,0.19000000f,-0.79000000f,0.87000000f,0.91000000f,-0.35000000f,-0.67000000f,0.01000000f,-0.64000000f,-0.48000000f,0.77000000f,0.29000000f,-0.32000000f,-0.36000000f,-0.07000000f,-0.36000000f,-0.03000000f,0.51000000f,-0.99000000f,0.42000000f,-0.95000000f,0.31000000f,0.96000000f,0.58000000f,0.91000000f,0.96000000f,0.42000000f,-0.76000000f,-0.73000000f,-0.52000000f,0.64000000f,0.24000000f,-0.28000000f,-0.50000000f,0.56000000f,0.50000000f,0.41000000f,0.54000000f,0.10000000f,0.10000000f,-0.57000000f,-0.73000000f,0.50000000f,0.36000000f,-0.71000000f,0.49000000f,-0.08000000f,-0.33000000f,-0.78000000f,-0.77000000f,0.84000000f,0.40000000f,0.91000000f,-0.39000000f,0.26000000f,-0.76000000f,-0.25000000f,-0.15000000f,-0.07000000f,-0.34000000f,0.82000000f,-0.94000000f,0.21000000f,-0.99000000f,0.33000000f,0.79000000f,-0.41000000f,0.71000000f,-0.40000000f,0.87000000f,0.82000000f,-0.34000000f,-0.99000000f,0.35000000f,-0.41000000f,0.10000000f,0.60000000f,0.84000000f,-0.28000000f,0.46000000f,0.63000000f,-0.47000000f,-0.24000000f,-0.05000000f,-0.92000000f,0.55000000f,0.59000000f,-0.23000000f,0.92000000f,0.86000000f,-0.16000000f,-0.51000000f,-0.63000000f,-0.34000000f,0.56000000f,-0.98000000f,-0.07000000f,0.64000000f,-0.83000000f,0.71000000f,0.40000000f,-0.47000000f,-0.67000000f,0.80000000f,-0.64000000f,0.86000000f,-0.00000000f,-0.64000000f,-0.54000000f,0.53000000f,-0.54000000f,0.13000000f,-0.73000000f,0.71000000f,0.44000000f,0.62000000f,0.17000000f,0.80000000f,0.82000000f,-0.87000000f,-0.54000000f,-0.56000000f,0.35000000f,0.02000000f,0.18000000f,-0.06000000f,-0.00000000f,0.13000000f,0.16000000f,0.18000000f,-0.11000000f,0.35000000f,0.70000000f,0.84000000f,0.48000000f,-0.03000000f,0.07000000f,0.20000000f,-0.84000000f,-0.18000000f,-0.30000000f,0.79000000f,-0.88000000f,-0.28000000f,0.64000000f,0.70000000f,-0.05000000f,-0.18000000f,0.59000000f,-0.87000000f,-0.98000000f,0.57000000f,0.11000000f,0.84000000f,-0.33000000f,0.55000000f,-0.89000000f,-0.07000000f,-0.64000000f,-0.17000000f,0.74000000f,0.70000000f,-0.54000000f,0.42000000f,-0.64000000f,-0.74000000f,-0.90000000f,-0.40000000f,0.69000000f,0.62000000f,0.26000000f,0.50000000f,-0.61000000f,0.60000000f,0.54000000f,0.23000000f,0.30000000f,0.68000000f,0.96000000f,-0.19000000f,0.38000000f,-0.73000000f,0.04000000f,-0.44000000f,0.51000000f,0.87000000f,0.56000000f,0.72000000f,0.26000000f,-0.61000000f,-0.36000000f,0.67000000f,0.64000000f,-0.67000000f,-0.85000000f,-0.30000000f,0.37000000f,-0.34000000f,-0.00000000f,0.30000000f,0.86000000f,-0.19000000f,0.08000000f,0.46000000f,-0.14000000f,0.45000000f,-0.52000000f,0.40000000f,-0.69000000f,-0.60000000f,-0.53000000f,-0.35000000f,-0.15000000f,-0.01000000f,-0.93000000f,-0.97000000f,0.48000000f,0.10000000f,0.64000000f,0.61000000f,-0.02000000f,-0.32000000f,0.67000000f,0.30000000f,-0.73000000f,-0.75000000f,-0.24000000f,0.43000000f,-0.68000000f,-0.09000000f,0.76000000f,-0.50000000f,-0.85000000f,-0.94000000f,-0.73000000f,0.85000000f,-0.73000000f,-0.93000000f,0.52000000f,-0.67000000f,0.67000000f,0.15000000f,0.25000000f,0.24000000f,-0.06000000f,-0.20000000f,-0.43000000f,0.77000000f,-0.09000000f,0.81000000f,0.28000000f,0.32000000f,-0.34000000f,0.15000000f,0.95000000f,0.48000000f,0.37000000f,-0.39000000f,0.92000000f,0.06000000f,0.97000000f,-0.59000000f,0.93000000f,-0.22000000f,-0.16000000f,-0.29000000f,0.00000000f,0.70000000f,-0.78000000f,0.56000000f,-0.05000000f,0.39000000f,0.23000000f,-0.89000000f,0.29000000f,-0.08000000f,-0.67000000f,-0.51000000f,-0.09000000f,0.64000000f,-0.75000000f,-0.89000000f,0.91000000f,-0.05000000f,-0.33000000f,0.84000000f,-0.74000000f,-0.95000000f,-0.12000000f,0.59000000f,0.27000000f,0.03000000f,0.98000000f,-0.16000000f,0.63000000f,0.24000000f,0.65000000f,-0.64000000f,-0.89000000f,0.27000000f,0.55000000f,-0.22000000f,-0.27000000f,0.68000000f,0.89000000f,-0.78000000f,0.36000000f,-0.98000000f,-0.53000000f,0.44000000f,0.72000000f,-0.00000000f,-0.08000000f,-0.58000000f,0.96000000f,0.05000000f,-0.75000000f,0.69000000f,0.14000000f,-0.55000000f,0.83000000f,-0.66000000f,0.30000000f,-0.85000000f,0.63000000f,0.03000000f,-0.10000000f,0.73000000f,0.04000000f,0.70000000f,-0.95000000f,-0.52000000f,-0.45000000f,0.97000000f,-0.16000000f,-0.31000000f,-0.61000000f,-0.55000000f,0.58000000f,0.20000000f,-0.17000000f,-0.80000000f,0.75000000f,-0.31000000f,-0.48000000f,0.81000000f,-0.61000000f,0.59000000f,-0.21000000f,-0.16000000f,0.15000000f,-0.84000000f,0.90000000f,-0.53000000f,0.82000000f,0.17000000f,-0.75000000f,-0.51000000f,-0.00000000f,-0.00000000f,-0.07000000f,-0.25000000f,-0.40000000f,-0.09000000f,-0.39000000f,0.50000000f,-0.63000000f,0.76000000f,-0.80000000f,0.03000000f,0.44000000f,-0.18000000f,-0.75000000f,0.08000000f,0.55000000f,0.22000000f,-0.88000000f,0.47000000f,0.32000000f,0.40000000f,0.58000000f,-0.08000000f,0.50000000f,0.40000000f,0.41000000f,-0.28000000f,0.40000000f,-0.30000000f,-0.39000000f,0.32000000f,0.78000000f,0.56000000f,-0.55000000f,0.08000000f,-0.50000000f,-0.94000000f,-0.69000000f,0.88000000f,-0.97000000f,-0.67000000f,0.98000000f,0.44000000f,-0.78000000f,0.08000000f,-0.66000000f,0.83000000f,-0.84000000f,0.93000000f,-0.55000000f,0.03000000f,-0.25000000f,-0.91000000f,-0.95000000f,0.88000000f,-0.19000000f,-0.23000000f,0.67000000f,-0.21000000f,-0.03000000f,-0.10000000f,-0.77000000f,-0.27000000f,0.19000000f,-0.37000000f,0.95000000f,0.29000000f,-0.43000000f,0.94000000f,0.47000000f,0.96000000f,-0.92000000f,0.26000000f,-0.20000000f,-0.00000000f,-0.55000000f,0.37000000f,-0.76000000f,-0.02000000f,-0.30000000f,-0.47000000f,0.65000000f,-0.14000000f,0.09000000f,-0.26000000f,-0.19000000f,-0.63000000f,-0.28000000f,0.58000000f,0.87000000f,0.87000000f,0.50000000f,0.73000000f,0.96000000f,-0.16000000f,0.55000000f,0.68000000f,-0.62000000f,-0.81000000f,0.32000000f,-0.47000000f,0.29000000f,0.53000000f,-0.19000000f,-0.98000000f,-0.41000000f,0.29000000f,-0.48000000f,-0.16000000f,0.11000000f,0.09000000f,-0.27000000f,-0.97000000f,0.95000000f,0.36000000f,-0.66000000f,-0.68000000f,0.41000000f,0.01000000f,0.07000000f,-0.85000000f,0.13000000f,-0.02000000f,0.31000000f,-0.53000000f,-0.13000000f,-0.29000000f,-0.43000000f,0.68000000f,0.14000000f,0.85000000f,-0.57000000f,-0.63000000f,-0.46000000f,-0.44000000f,-0.70000000f,-0.27000000f,0.68000000f,0.68000000f,0.90000000f,-0.59000000f,0.33000000f,0.63000000f,0.40000000f,0.69000000f,0.26000000f,0.44000000f,-0.91000000f,-0.00000000f,-0.60000000f,-0.45000000f,-0.51000000f,0.42000000f,0.53000000f,-0.19000000f,-0.97000000f,-0.79000000f,0.98000000f,0.99000000f,-0.05000000f,-0.17000000f,0.16000000f,-0.77000000f,0.14000000f,0.34000000f,0.15000000f,0.15000000f,-0.00000000f,0.27000000f,-0.17000000f,0.68000000f,0.37000000f,0.50000000f,-0.14000000f,-0.03000000f,-0.70000000f,-0.06000000f,-0.33000000f,0.50000000f,0.57000000f,-0.37000000f,-0.96000000f,-0.89000000f,-0.43000000f,-0.45000000f,0.11000000f,-0.33000000f,-0.19000000f,-0.62000000f,0.81000000f,0.56000000f,-0.38000000f,0.69000000f,0.61000000f,-0.30000000f,-0.58000000f,-0.67000000f,-0.72000000f,-0.83000000f,0.64000000f,0.94000000f,-0.61000000f,0.83000000f,-0.43000000f,-0.73000000f,-0.67000000f,0.96000000f,-0.73000000f,0.61000000f,0.89000000f,-0.97000000f,0.80000000f,0.30000000f,-0.42000000f,0.92000000f,0.81000000f,0.03000000f,0.48000000f,0.98000000f,-0.04000000f,-0.68000000f,0.13000000f,0.90000000f,0.17000000f,0.59000000f,0.48000000f,-0.40000000f,-0.70000000f,-0.25000000f,-0.46000000f,0.69000000f,-0.02000000f,-0.53000000f,-0.60000000f,0.55000000f,-0.49000000f,-0.47000000f,-0.83000000f,0.59000000f,-0.26000000f,0.21000000f,0.86000000f,-0.51000000f,-0.26000000f,0.59000000f,-0.18000000f,-0.93000000f,0.55000000f,-0.20000000f,-0.92000000f,0.87000000f,0.95000000f,-0.32000000f,0.84000000f,0.78000000f,0.43000000f,0.56000000f,0.43000000f,0.36000000f,0.14000000f,-0.19000000f,-0.84000000f,-0.30000000f,0.48000000f,0.63000000f,-0.62000000f,-0.54000000f,-0.28000000f,-0.08000000f,0.06000000f,0.71000000f,0.64000000f,0.60000000f,0.88000000f,-0.68000000f,-0.91000000f,-0.03000000f,0.79000000f,0.69000000f,-0.51000000f,-0.24000000f,0.95000000f,-0.41000000f,0.01000000f,0.97000000f,0.94000000f,-0.74000000f,0.28000000f,0.55000000f,-0.48000000f,-0.63000000f,-0.85000000f,-0.70000000f,0.56000000f,0.37000000f,0.96000000f,-0.80000000f,-0.08000000f,0.39000000f,0.92000000f,-0.02000000f,0.85000000f,-0.28000000f,-0.14000000f,0.81000000f,0.35000000f,-0.17000000f,-0.39000000f,0.12000000f,0.36000000f,-0.06000000f,0.88000000f,-0.59000000f,-0.25000000f,-0.50000000f,-0.34000000f,0.71000000f,-0.72000000f,-0.75000000f,0.40000000f,0.29000000f,0.29000000f,0.61000000f,0.49000000f,-0.79000000f,0.05000000f,0.03000000f,0.48000000f,0.58000000f,-0.38000000f,0.98000000f,0.60000000f,-0.79000000f,-0.15000000f,-0.24000000f,0.37000000f,0.51000000f,0.95000000f,-0.94000000f,0.30000000f,-0.58000000f,0.62000000f,0.57000000f,-0.86000000f,0.69000000f,-0.18000000f,-0.29000000f,0.33000000f,0.56000000f,-0.37000000f,0.02000000f,0.12000000f,-0.97000000f,0.80000000f,-0.46000000f,0.55000000f,-0.82000000f,-0.60000000f,-0.86000000f,-0.80000000f,0.60000000f,-0.09000000f,-0.51000000f,-0.46000000f,-0.86000000f,-0.46000000f,-0.30000000f,-0.86000000f,0.33000000f,0.31000000f,-0.73000000f,-0.83000000f,0.33000000f,0.35000000f,-0.26000000f,0.58000000f,0.75000000f,0.89000000f,-0.10000000f,-0.55000000f,-0.37000000f,0.51000000f,0.14000000f,-0.37000000f,0.58000000f,0.08000000f,0.54000000f,0.37000000f,0.43000000f,-0.03000000f,0.18000000f,-0.48000000f,0.27000000f,-0.22000000f,0.57000000f,-0.27000000f,-0.89000000f,0.05000000f,0.53000000f,-0.71000000f,-0.12000000f,-0.53000000f,0.57000000f,-0.38000000f,-0.22000000f,0.49000000f,-0.47000000f,0.58000000f,-0.26000000f,-0.15000000f,0.47000000f,0.32000000f,0.97000000f,-0.82000000f,0.70000000f,0.15000000f,-0.08000000f,0.16000000f,-0.76000000f,0.14000000f,-0.75000000f,-0.49000000f,0.68000000f,-0.31000000f,0.02000000f,0.20000000f,0.66000000f,0.16000000f,-0.10000000f,0.13000000f,-0.48000000f,-0.78000000f,-0.81000000f,-0.61000000f,-0.84000000f,-0.23000000f,-0.65000000f,0.18000000f,0.72000000f,0.50000000f,-0.09000000f,0.56000000f,0.97000000f,-0.98000000f,-0.49000000f,0.59000000f,0.37000000f,0.32000000f,-0.61000000f,0.24000000f,-0.76000000f,-0.36000000f,-0.69000000f,0.02000000f,-0.29000000f,0.22000000f,0.70000000f,0.49000000f,-0.99000000f,-0.88000000f,0.28000000f,-0.38000000f,0.17000000f,0.73000000f,-0.86000000f,-0.17000000f,-0.79000000f,0.84000000f,0.47000000f,0.86000000f,-0.23000000f,-0.03000000f,-0.69000000f,-0.38000000f,-0.92000000f,-0.86000000f,-0.46000000f,-0.11000000f,0.32000000f,0.37000000f,-0.29000000f,-0.41000000f,-0.05000000f,-0.11000000f,0.48000000f,-0.16000000f,-0.74000000f,-0.83000000f,-0.07000000f,-0.04000000f,0.14000000f,0.31000000f,0.39000000f,-0.91000000f,0.64000000f,-0.05000000f,0.22000000f,-0.61000000f,-0.70000000f,-0.82000000f,-0.45000000f,0.31000000f,-0.48000000f,-0.31000000f,0.61000000f,-0.31000000f,0.40000000f,0.86000000f,-0.92000000f,0.16000000f,0.02000000f,0.49000000f,-0.60000000f,-0.72000000f,0.71000000f,0.03000000f,-0.67000000f,0.27000000f,0.94000000f,0.06000000f,0.47000000f,0.24000000f,-0.72000000f,-0.41000000f,0.08000000f,0.83000000f,-0.81000000f,-0.61000000f,-0.48000000f,0.08000000f,-0.06000000f,0.35000000f,-0.65000000f,0.91000000f,-0.77000000f,-0.90000000f,0.38000000f,-0.42000000f,-0.48000000f,0.37000000f,-0.71000000f,0.36000000f,0.57000000f,-0.08000000f,0.36000000f,-0.87000000f,0.70000000f,-0.53000000f,-0.00000000f,0.65000000f,-0.73000000f,0.19000000f,-0.09000000f,0.42000000f,0.74000000f,-0.29000000f,-0.31000000f,-0.66000000f,-0.01000000f,-0.40000000f,0.71000000f,-0.36000000f,0.69000000f,0.67000000f,-0.86000000f,0.64000000f,-0.02000000f,0.06000000f,0.49000000f,0.42000000f,0.34000000f,-0.35000000f,-0.58000000f,-0.94000000f,-0.17000000f,0.54000000f,-0.91000000f,-0.31000000f,0.54000000f,-0.19000000f,0.69000000f,-0.39000000f,0.65000000f,0.18000000f,-0.54000000f,0.64000000f,0.43000000f,-0.12000000f,0.44000000f,-0.95000000f,-0.62000000f,0.15000000f,-0.71000000f,0.00000000f,-0.33000000f,-0.30000000f,-0.32000000f,-0.36000000f,0.44000000f,-0.96000000f,-0.65000000f,0.02000000f,-0.21000000f,0.34000000f,0.03000000f,0.10000000f,-0.13000000f,0.58000000f,0.40000000f,0.10000000f,0.75000000f,-0.32000000f,-0.22000000f,-0.48000000f,0.87000000f,-0.03000000f,-0.02000000f,0.82000000f,0.06000000f,0.56000000f,0.41000000f,0.16000000f,0.41000000f,-0.52000000f,0.38000000f,-0.09000000f,0.07000000f,-0.42000000f,0.70000000f,-0.16000000f,-0.13000000f,0.22000000f,0.83000000f,0.56000000f,-0.03000000f,0.20000000f,-0.34000000f,-0.52000000f,0.50000000f,0.73000000f,0.34000000f,0.05000000f,-0.39000000f,0.61000000f,0.67000000f,-0.63000000f,0.27000000f,-0.73000000f,-0.73000000f,0.84000000f,-0.65000000f,-0.51000000f,-0.05000000f,-0.46000000f,-0.38000000f,-0.00000000f,0.38000000f,-0.40000000f,-0.52000000f,0.51000000f,-0.63000000f,-0.40000000f,-0.02000000f,0.39000000f,0.18000000f,0.60000000f,0.30000000f,0.32000000f,0.23000000f,0.77000000f,0.21000000f,0.12000000f,0.49000000f,0.30000000f,0.72000000f,-0.85000000f,0.96000000f,0.23000000f,-0.08000000f,0.57000000f,0.20000000f,0.87000000f,0.99000000f,0.54000000f,-0.76000000f,0.11000000f,0.97000000f,-0.10000000f,0.19000000f,-0.45000000f,-0.12000000f,0.85000000f,-0.21000000f,0.69000000f,0.71000000f,-0.61000000f,0.01000000f,-0.73000000f,-0.61000000f,0.51000000f,0.33000000f,-0.71000000f,0.76000000f,0.67000000f,0.35000000f,-0.51000000f,-0.62000000f,-0.46000000f,0.28000000f,-0.80000000f,0.62000000f,0.65000000f,-0.11000000f,0.87000000f,0.24000000f,-0.97000000f,0.60000000f,-0.03000000f,-0.83000000f,0.32000000f,-0.49000000f,-0.94000000f,-0.42000000f,-0.47000000f,0.50000000f,0.34000000f,0.84000000f,0.11000000f,-0.86000000f,-0.24000000f,0.69000000f,-0.53000000f,0.89000000f,0.00000000f,0.08000000f,-0.81000000f,-0.07000000f,-0.18000000f,-0.52000000f,-0.39000000f,-0.94000000f,0.04000000f,0.89000000f,-0.30000000f,0.44000000f,-0.68000000f,0.49000000f,0.40000000f,0.65000000f,-0.80000000f,-0.72000000f,0.42000000f,-0.49000000f,0.91000000f,0.45000000f,0.26000000f,0.60000000f,0.00000000f,0.20000000f,0.27000000f,-0.00000000f,0.27000000f,0.91000000f,0.44000000f,0.84000000f,0.81000000f,-0.09000000f,0.38000000f,-0.49000000f,0.56000000f,0.04000000f,0.54000000f,-0.79000000f,0.05000000f,0.56000000f,0.34000000f,-0.20000000f,0.12000000f,0.00000000f,0.48000000f,0.18000000f,0.15000000f,-0.86000000f,0.57000000f,-0.03000000f,-0.12000000f,0.56000000f,-0.33000000f,-0.80000000f,0.03000000f,0.00000000f,0.90000000f,0.00000000f,0.50000000f,0.15000000f,-0.09000000f,-0.43000000f,0.17000000f,-0.28000000f,0.21000000f,-0.86000000f,-0.41000000f,0.69000000f,-0.40000000f,0.11000000f,-0.95000000f,-0.08000000f,-0.98000000f,-0.67000000f,0.73000000f,-0.97000000f,-0.67000000f,-0.09000000f,0.52000000f,-0.25000000f,0.26000000f,0.09000000f,-0.66000000f,-0.16000000f,0.01000000f,0.86000000f,-0.11000000f,-0.78000000f,0.15000000f,-0.02000000f,-0.23000000f,0.18000000f,0.91000000f,0.29000000f,0.21000000f,-0.53000000f,-0.65000000f,0.79000000f,-0.68000000f,0.87000000f,-0.22000000f,-0.07000000f,-0.43000000f,0.50000000f,0.26000000f,0.05000000f,0.55000000f,-0.30000000f,-0.16000000f,-0.43000000f,0.56000000f,-0.16000000f,0.03000000f,-0.92000000f,0.32000000f,-0.69000000f,0.05000000f,-0.34000000f,-0.90000000f,0.67000000f,-0.24000000f,-0.24000000f,0.97000000f,0.18000000f,-0.31000000f,-0.45000000f,-0.98000000f,0.94000000f,0.84000000f,0.52000000f,0.80000000f,0.71000000f,-0.26000000f,0.04000000f,-0.78000000f,0.10000000f,-0.21000000f,-0.21000000f,0.42000000f,-0.36000000f,-0.98000000f,-0.29000000f,-0.79000000f,-0.29000000f,-0.89000000f,-0.82000000f,0.17000000f,-0.11000000f,0.59000000f,-0.30000000f,0.43000000f,0.40000000f,0.54000000f,-0.35000000f,-0.60000000f,-0.30000000f,0.61000000f,0.52000000f,0.20000000f,-0.40000000f,0.07000000f,0.81000000f,0.50000000f,0.00000000f,0.26000000f,0.06000000f,0.01000000f,-0.43000000f,0.68000000f,-0.25000000f,-0.28000000f,0.01000000f,0.29000000f,0.87000000f,0.68000000f,0.18000000f,-0.26000000f,-0.16000000f,-0.43000000f,-0.59000000f,0.74000000f,0.91000000f,0.33000000f,0.88000000f,0.07000000f,-0.67000000f,0.26000000f,-0.88000000f,-0.31000000f,-0.25000000f,0.63000000f,0.08000000f,-0.60000000f,-0.08000000f,-0.29000000f,-0.41000000f,-0.12000000f,-0.65000000f,-0.20000000f,-0.73000000f,0.50000000f,-0.50000000f,-0.55000000f,0.80000000f,0.01000000f,-0.47000000f,-0.33000000f,0.52000000f,-0.59000000f,-0.61000000f,0.99000000f,-0.94000000f,0.32000000f,-0.50000000f,-0.41000000f,0.66000000f,-0.06000000f,-0.30000000f,0.79000000f,0.33000000f,0.21000000f,-0.79000000f,0.09000000f,0.66000000f,-0.13000000f,-0.32000000f,0.05000000f,0.32000000f,0.07000000f,-0.11000000f,-0.16000000f,0.72000000f,0.69000000f,0.76000000f,-0.14000000f,-0.96000000f,-0.26000000f,0.93000000f,0.84000000f,-0.00000000f,0.23000000f,-0.68000000f,0.65000000f,0.64000000f,-0.37000000f,0.94000000f,-0.70000000f,-0.04000000f,-0.39000000f,0.90000000f,-0.62000000f,0.02000000f,0.88000000f,0.77000000f,-0.40000000f,0.01000000f,-0.45000000f,-0.92000000f,-0.18000000f,0.79000000f,0.52000000f,0.86000000f,0.57000000f,-0.39000000f,-0.39000000f,-0.47000000f,0.47000000f,-0.70000000f,-0.10000000f,0.27000000f,0.99000000f,-0.62000000f,-0.11000000f,-0.99000000f,-0.68000000f,0.81000000f,-0.94000000f,0.08000000f,-0.01000000f,0.42000000f,0.50000000f,0.05000000f,0.67000000f,0.87000000f,-0.11000000f,-0.55000000f,-0.20000000f,0.12000000f,-0.77000000f,0.50000000f,-0.46000000f,-0.69000000f,-0.76000000f,-0.21000000f,-0.49000000f,0.08000000f,-0.29000000f,-0.44000000f,0.59000000f,0.17000000f,-0.34000000f,0.57000000f,-0.00000000f,-0.21000000f,0.65000000f,0.04000000f,-0.26000000f,-0.73000000f,0.95000000f,0.28000000f,-0.33000000f,-0.95000000f,-0.55000000f,-0.52000000f,-0.93000000f,0.57000000f,-0.56000000f,-0.50000000f,-0.62000000f,-0.73000000f,0.94000000f,-0.37000000f,0.04000000f,-0.09000000f,-0.12000000f,-0.71000000f,-0.38000000f,-0.08000000f,-0.56000000f,0.27000000f,0.45000000f,-0.47000000f,0.84000000f,0.24000000f,-0.76000000f,-0.10000000f,0.96000000f,0.72000000f,0.67000000f,0.04000000f,0.91000000f,0.50000000f,0.29000000f,-0.34000000f,-0.87000000f,0.00000000f,-0.74000000f,0.76000000f,-0.20000000f,0.38000000f,0.54000000f,-0.69000000f,0.54000000f,-0.24000000f,-0.16000000f,0.79000000f,-0.17000000f,0.53000000f,-0.25000000f,-0.54000000f,0.40000000f,-0.78000000f,-0.41000000f,-0.25000000f,0.85000000f,0.70000000f,-0.77000000f,-0.23000000f,-0.96000000f,0.75000000f,0.52000000f,0.59000000f,-0.85000000f,0.70000000f,-0.23000000f,-0.71000000f,-0.22000000f,0.87000000f,0.44000000f,0.57000000f,0.75000000f,0.44000000f,-0.44000000f,0.45000000f,0.41000000f,-0.90000000f,-0.86000000f,0.51000000f,0.56000000f,-0.41000000f,-0.55000000f,0.53000000f,0.78000000f,-0.71000000f,-0.43000000f,-0.20000000f,0.98000000f,-0.39000000f,-0.42000000f,-0.52000000f,0.40000000f,-0.67000000f,-0.32000000f,0.12000000f,0.95000000f,0.99000000f,-0.75000000f,0.97000000f,-0.33000000f,-0.24000000f,0.31000000f,-0.50000000f,-0.54000000f,-0.20000000f,0.92000000f,-0.81000000f,0.38000000f,-0.62000000f,-0.39000000f,0.82000000f,0.91000000f,-0.75000000f,0.03000000f,-0.06000000f,-0.61000000f,-0.17000000f,-0.91000000f,0.27000000f,0.30000000f,-0.75000000f,-0.51000000f,0.50000000f,0.60000000f,-0.96000000f,-0.91000000f,-0.52000000f,0.34000000f,0.92000000f,0.31000000f,-0.02000000f,0.89000000f,0.93000000f,-0.77000000f,0.53000000f,0.98000000f,0.01000000f,0.45000000f,0.56000000f,-0.41000000f,0.38000000f,-0.96000000f,0.72000000f,-0.11000000f,-0.05000000f,0.88000000f,-0.78000000f,-0.27000000f,-0.68000000f,-0.41000000f,-0.16000000f,-0.08000000f,0.70000000f,0.16000000f,0.13000000f,-0.29000000f,0.53000000f,-0.52000000f,-0.75000000f,0.99000000f,0.73000000f,0.11000000f,0.11000000f,-0.05000000f,0.27000000f,-0.87000000f,-0.19000000f,-0.59000000f,-0.73000000f,0.74000000f,-0.18000000f,0.13000000f,-0.32000000f,0.55000000f,0.03000000f,-0.20000000f,0.45000000f,-0.06000000f,-0.10000000f,-0.86000000f,0.94000000f,-0.63000000f,0.88000000f,0.23000000f,0.28000000f,-0.62000000f,-0.59000000f,0.76000000f,0.41000000f,-0.29000000f,0.55000000f,0.01000000f,0.36000000f,0.33000000f,0.06000000f,0.67000000f,-0.63000000f,-0.36000000f,0.77000000f,-0.72000000f,0.76000000f,-0.87000000f,0.95000000f,-0.28000000f,-0.83000000f,-0.67000000f,-0.64000000f,-0.49000000f,0.55000000f,0.06000000f,0.90000000f,-0.01000000f,-0.58000000f,0.94000000f,-0.76000000f,-0.24000000f,0.58000000f,-0.99000000f,0.17000000f,-0.14000000f,0.65000000f,-0.80000000f,0.77000000f,-0.18000000f,-0.37000000f,0.07000000f,-0.71000000f,-0.31000000f,0.43000000f,0.59000000f,-0.52000000f,-0.73000000f,-0.17000000f,0.04000000f,-0.25000000f,-0.62000000f,0.90000000f,0.40000000f,-0.60000000f,-0.31000000f,0.52000000f,-0.60000000f,0.90000000f,0.78000000f,0.13000000f,-0.27000000f,-0.71000000f,0.71000000f,0.24000000f,0.93000000f,-0.39000000f,0.33000000f,-0.02000000f,0.45000000f,0.61000000f,-0.50000000f,0.81000000f,0.95000000f,-0.70000000f,0.72000000f,0.03000000f,-0.16000000f,0.07000000f,-0.28000000f,-0.83000000f,0.84000000f,-0.48000000f,-0.42000000f,0.62000000f,0.62000000f,0.39000000f,0.88000000f,0.03000000f,-0.41000000f,-0.49000000f,-0.80000000f,-0.60000000f,0.55000000f,0.83000000f,-0.02000000f,-0.69000000f,-0.19000000f,0.65000000f,0.49000000f,-0.32000000f,-0.28000000f,0.05000000f,-0.40000000f,-0.03000000f,-0.39000000f,0.48000000f,-0.75000000f,-0.02000000f,-0.91000000f,-0.25000000f,0.33000000f,0.80000000f,-0.30000000f,-0.14000000f,-0.36000000f,0.61000000f,0.82000000f,0.48000000f,0.31000000f,-0.87000000f,0.45000000f,0.06000000f,0.15000000f,0.08000000f,-0.39000000f,0.10000000f,-0.21000000f,0.63000000f,-0.47000000f,0.55000000f,0.47000000f,0.90000000f,0.32000000f,-0.29000000f,0.79000000f,-0.76000000f,0.75000000f,-0.90000000f,0.56000000f,0.92000000f,-0.04000000f,-0.73000000f,-0.75000000f,-0.68000000f,-0.74000000f,0.99000000f,-0.68000000f,-0.49000000f,0.31000000f,0.76000000f,-0.76000000f,-0.03000000f,-0.95000000f,-0.75000000f,-0.89000000f,-0.32000000f,0.91000000f,-0.34000000f,0.58000000f,-0.43000000f,0.33000000f,-0.88000000f,-0.32000000f,0.90000000f,0.23000000f,-0.40000000f,-0.86000000f,0.81000000f,0.26000000f,-0.90000000f,0.78000000f,-0.61000000f,0.65000000f,-0.75000000f,0.69000000f,-0.29000000f,-0.17000000f,-0.92000000f,0.84000000f,0.80000000f,-0.35000000f,0.53000000f,0.73000000f,-0.60000000f,-0.75000000f,-0.46000000f,-0.68000000f,-0.13000000f,0.80000000f,-0.21000000f,0.38000000f,0.89000000f,-0.53000000f,0.34000000f,-0.32000000f,0.71000000f,0.08000000f,-0.43000000f,0.27000000f,-0.17000000f,0.48000000f,0.75000000f,-0.89000000f,-0.47000000f,-0.94000000f,-0.23000000f,0.52000000f,-0.47000000f,0.34000000f,-0.84000000f,-0.81000000f,-0.14000000f,0.36000000f,-0.73000000f,-0.35000000f,-0.06000000f,-0.66000000f,-0.16000000f,-0.84000000f,-0.95000000f,-0.52000000f,-0.02000000f,-0.28000000f,0.85000000f,0.91000000f,-0.61000000f,-0.16000000f,-0.82000000f,0.10000000f,0.19000000f,-0.51000000f,0.04000000f,-0.23000000f,0.74000000f,-0.18000000f,0.31000000f,-0.63000000f,-0.37000000f,-0.27000000f,-0.95000000f,-0.36000000f,-0.32000000f,-0.85000000f,0.52000000f,0.16000000f,0.75000000f,-0.68000000f,-0.99000000f,-0.18000000f,-0.82000000f,0.90000000f,0.61000000f,-0.96000000f,0.55000000f,0.61000000f,-0.82000000f,0.15000000f,0.21000000f,-0.46000000f,0.06000000f,0.35000000f,0.95000000f,0.25000000f,-0.10000000f,-0.08000000f,0.58000000f,0.14000000f,-0.54000000f,0.21000000f,0.48000000f,0.53000000f,0.09000000f,0.75000000f,0.82000000f,-0.12000000f,-0.45000000f,0.65000000f,0.29000000f,-0.04000000f,0.43000000f,0.84000000f,-0.97000000f,0.04000000f,-0.14000000f,-0.02000000f,0.09000000f,-0.46000000f,0.01000000f,-0.90000000f,-0.54000000f,-0.71000000f,-0.03000000f,-0.45000000f,-0.02000000f,-0.49000000f,-0.71000000f,0.06000000f,-0.48000000f,0.90000000f,0.83000000f,0.20000000f,0.42000000f,-0.99000000f,-0.11000000f,0.53000000f,-0.35000000f,-0.01000000f,0.67000000f,-0.68000000f,-0.08000000f,-0.52000000f,0.44000000f,-0.61000000f,-0.58000000f,-0.15000000f,-0.47000000f,0.90000000f,0.37000000f,-0.05000000f,-0.52000000f,0.54000000f,0.88000000f,0.19000000f,-0.36000000f,0.19000000f,0.82000000f,0.04000000f,-0.37000000f,0.36000000f,0.97000000f,-0.93000000f,0.97000000f,-0.82000000f,0.28000000f,0.17000000f,-0.19000000f,0.17000000f,-0.24000000f,-0.69000000f,0.48000000f,-0.01000000f,0.43000000f,-0.70000000f,0.98000000f,-0.49000000f,-0.51000000f,0.97000000f,0.05000000f,-0.87000000f,0.57000000f,-0.93000000f,-0.45000000f,0.78000000f,-0.22000000f,0.70000000f,0.91000000f,-0.54000000f,0.67000000f,-0.53000000f,-0.01000000f,0.38000000f,0.99000000f,-0.56000000f,0.85000000f,0.67000000f,0.88000000f,-0.02000000f,0.33000000f,-0.00000000f,0.74000000f,0.33000000f,-0.37000000f,-0.92000000f,0.79000000f,-0.93000000f,0.24000000f,0.18000000f,-0.56000000f,-0.83000000f,-0.22000000f,0.79000000f,-0.04000000f,0.54000000f,-0.11000000f,-0.40000000f,0.27000000f,0.44000000f,0.50000000f,0.24000000f,0.96000000f,-0.02000000f,0.24000000f,0.18000000f,-0.95000000f,-0.03000000f,0.93000000f,-0.15000000f,0.86000000f,-0.24000000f,-0.30000000f,0.80000000f,-0.05000000f,0.91000000f,0.55000000f,0.05000000f,0.44000000f,-0.43000000f,0.00000000f,-0.96000000f,-0.55000000f,0.52000000f,-0.11000000f,-0.56000000f,-0.08000000f,0.91000000f,0.05000000f,-0.70000000f,0.13000000f,0.43000000f,0.07000000f,0.81000000f,-0.49000000f,0.14000000f,-0.89000000f,-0.38000000f,0.19000000f,0.57000000f,0.94000000f,0.66000000f,0.98000000f,0.75000000f,0.37000000f,-0.12000000f,0.12000000f,0.96000000f,0.40000000f,-0.10000000f,-0.64000000f,-0.88000000f,-0.64000000f,0.95000000f,-0.81000000f,0.61000000f,-0.97000000f,-0.68000000f,-0.73000000f,-0.00000000f,-0.69000000f,-0.99000000f,0.73000000f,-0.09000000f,-0.49000000f,0.22000000f,0.04000000f,0.77000000f,0.79000000f,-0.06000000f,-0.35000000f,0.06000000f,0.81000000f,-0.03000000f,-0.05000000f,0.47000000f,0.27000000f,-0.74000000f,-0.59000000f,0.82000000f,0.47000000f,0.80000000f,0.80000000f,0.58000000f,-0.87000000f,0.05000000f,0.50000000f,-0.26000000f,-0.50000000f,-0.84000000f,0.12000000f,0.62000000f,0.66000000f,-0.77000000f,-0.10000000f,0.74000000f,0.66000000f,-0.07000000f,0.73000000f,0.74000000f,0.52000000f,0.10000000f,-0.78000000f,0.24000000f,0.92000000f,0.02000000f,-0.12000000f,0.80000000f,0.60000000f,0.76000000f,0.96000000f,0.57000000f,0.94000000f,-0.37000000f,-0.01000000f,-0.20000000f,-0.95000000f,-0.37000000f,-0.61000000f,0.74000000f,0.82000000f,0.31000000f,0.32000000f,-0.47000000f,-0.91000000f,-0.60000000f,-0.78000000f,0.19000000f,-0.65000000f,0.44000000f,-0.63000000f,-0.19000000f,-0.62000000f,0.39000000f,-0.58000000f,-0.80000000f,-0.47000000f,0.29000000f,-0.31000000f,0.19000000f,0.13000000f,0.59000000f,-0.52000000f,0.32000000f,0.71000000f,-0.69000000f,-0.21000000f,-0.94000000f,-0.80000000f,-0.82000000f,-0.81000000f,-0.92000000f,-0.08000000f,-0.68000000f,0.19000000f,0.31000000f,-0.02000000f,-0.60000000f,0.97000000f,-0.71000000f,0.21000000f,-0.18000000f,0.19000000f,0.83000000f,0.79000000f,-0.18000000f,-0.91000000f,-0.77000000f,-0.80000000f,-0.00000000f,0.08000000f,0.30000000f,-0.86000000f,-0.88000000f,-0.01000000f,-0.88000000f,0.71000000f,-0.80000000f,-0.54000000f,0.43000000f,-0.68000000f,-0.56000000f,0.32000000f,0.05000000f,0.21000000f,-0.51000000f,0.17000000f,-0.42000000f,0.01000000f,0.00000000f,0.03000000f,0.16000000f,-0.77000000f,0.62000000f,-0.91000000f,-0.70000000f,-0.42000000f,-0.49000000f,0.46000000f,-0.82000000f,0.97000000f,-0.49000000f,-0.49000000f,0.42000000f,0.23000000f,-0.19000000f,0.23000000f,0.99000000f,-0.57000000f,-0.93000000f,-0.46000000f,0.05000000f,-0.86000000f,0.23000000f,0.94000000f,-0.68000000f,0.73000000f,0.08000000f,0.33000000f,0.63000000f,0.65000000f,0.11000000f,0.41000000f,-0.16000000f,-0.05000000f,0.80000000f,0.65000000f,0.07000000f,-0.76000000f,-0.69000000f,0.34000000f,0.18000000f,0.69000000f,0.58000000f,0.67000000f,0.56000000f,0.02000000f,-0.72000000f,0.07000000f,0.38000000f,-0.30000000f,0.59000000f,0.00000000f,-0.67000000f,0.52000000f,0.40000000f,0.60000000f,-0.26000000f,-0.16000000f,-0.99000000f,-0.89000000f,0.48000000f,0.03000000f,-0.59000000f,-0.62000000f,-0.51000000f,0.10000000f,0.79000000f,0.47000000f,0.66000000f,0.23000000f,-0.51000000f,-0.08000000f,-0.84000000f,-0.38000000f,0.27000000f,0.11000000f,-0.46000000f,0.50000000f,-0.75000000f,-0.49000000f,-0.44000000f,-0.86000000f,-0.46000000f,0.70000000f,-0.21000000f,-0.33000000f,-0.69000000f,0.91000000f,0.79000000f,0.29000000f,-0.90000000f,0.70000000f,-0.92000000f,-0.49000000f,0.85000000f,-0.58000000f,-0.71000000f,0.53000000f,0.88000000f,0.29000000f,0.35000000f,0.75000000f,-0.23000000f,0.90000000f,-0.49000000f,0.04000000f,0.07000000f,0.13000000f,-0.12000000f,-0.84000000f,-0.09000000f,-0.19000000f,-0.26000000f,-0.73000000f,-0.66000000f,-0.83000000f,-0.14000000f,0.38000000f,-0.95000000f,0.39000000f,-0.69000000f,0.46000000f,0.44000000f,0.53000000f,-0.38000000f,0.01000000f,-0.41000000f,0.10000000f,0.90000000f,-0.36000000f,0.58000000f,0.41000000f,0.11000000f,-0.73000000f,0.14000000f,0.97000000f,0.89000000f,-0.24000000f,0.49000000f,0.65000000f,-0.52000000f,0.63000000f,-0.82000000f,0.34000000f,0.95000000f,-0.90000000f,-0.19000000f,-0.48000000f,-0.05000000f,-0.92000000f,-0.48000000f,-0.09000000f,-0.72000000f,0.64000000f,-0.92000000f,0.64000000f,-0.85000000f,-0.78000000f,-0.44000000f,-0.67000000f,-0.48000000f,0.91000000f,-0.45000000f,0.23000000f,-0.35000000f,-0.10000000f,0.49000000f,0.65000000f,0.29000000f,0.03000000f,0.59000000f,-0.92000000f,0.24000000f,0.48000000f,0.86000000f,0.29000000f,0.77000000f,0.40000000f,-0.56000000f,-0.27000000f,-0.99000000f,0.95000000f,0.99000000f,-0.65000000f,0.71000000f,0.21000000f,-0.14000000f,0.51000000f,0.25000000f,-0.31000000f,0.73000000f,0.37000000f,0.62000000f,0.58000000f,-0.81000000f,-0.68000000f,0.41000000f,-0.88000000f,-0.20000000f,0.40000000f,-0.71000000f,-0.71000000f,0.97000000f,-0.28000000f,-0.73000000f,0.36000000f,-0.57000000f,-0.56000000f,-0.33000000f,0.98000000f,-0.32000000f,0.25000000f,-0.85000000f,-0.16000000f,-0.14000000f,-0.17000000f,-0.57000000f,0.12000000f,0.03000000f,-0.77000000f,0.12000000f,-0.58000000f,-0.90000000f,0.51000000f,-0.29000000f,-0.47000000f,0.89000000f,-0.81000000f,0.69000000f,0.70000000f,-0.40000000f,0.15000000f,-0.66000000f,0.54000000f,-0.75000000f,-0.81000000f,-0.87000000f,-0.26000000f,0.31000000f,-0.56000000f,-0.15000000f,0.04000000f,-0.86000000f,0.07000000f,0.19000000f,-0.80000000f,-0.94000000f,0.04000000f,-0.01000000f,0.87000000f,0.83000000f,-0.44000000f,-0.77000000f,-0.73000000f,0.24000000f,-0.87000000f,-0.61000000f,0.85000000f,0.40000000f,-0.83000000f,0.18000000f,-0.88000000f,0.49000000f,-0.27000000f,-0.25000000f,-0.59000000f,-0.47000000f,-0.91000000f,-0.81000000f,-0.60000000f,-0.73000000f,0.78000000f,-0.81000000f,0.70000000f,0.20000000f,0.44000000f,-0.60000000f,-0.82000000f,-0.56000000f,0.90000000f,0.08000000f,-0.00000000f,0.06000000f,0.17000000f,-0.42000000f,0.34000000f,0.80000000f,-0.92000000f,0.02000000f,0.44000000f,-0.54000000f,0.45000000f,0.69000000f,-0.19000000f,-0.06000000f,0.32000000f,-0.38000000f,0.72000000f,0.96000000f,0.47000000f,-0.56000000f,-0.50000000f,0.09000000f,-0.60000000f,-0.92000000f,0.10000000f,-0.34000000f,0.16000000f,0.74000000f,0.03000000f,-0.54000000f,0.63000000f,0.60000000f,0.69000000f,0.20000000f,-0.43000000f,0.31000000f,-0.68000000f,-0.64000000f,-0.46000000f,0.61000000f,-0.74000000f,0.56000000f,0.11000000f,-0.44000000f,-0.02000000f,-0.38000000f,-0.96000000f,0.95000000f,0.38000000f,0.24000000f,-0.74000000f,0.91000000f,-0.54000000f,-0.61000000f,0.67000000f,0.38000000f,0.91000000f,0.05000000f,-0.53000000f,-0.08000000f,0.04000000f,-0.86000000f,-0.90000000f,-0.92000000f,0.08000000f,-0.49000000f,0.22000000f,0.92000000f,0.76000000f,-0.30000000f,0.85000000f,-0.76000000f,0.15000000f,0.28000000f,-0.52000000f,-0.16000000f,0.84000000f,0.48000000f,0.70000000f,0.62000000f,-0.52000000f,0.37000000f,-0.43000000f,0.52000000f,-0.87000000f,0.91000000f,0.13000000f,0.15000000f,0.10000000f,0.62000000f,0.72000000f,-0.69000000f,-0.53000000f,-0.09000000f,-0.37000000f,0.76000000f,-0.76000000f,-0.50000000f,0.86000000f,-0.17000000f,-0.73000000f,-0.39000000f,-0.05000000f,0.91000000f,-0.26000000f,0.39000000f,-0.69000000f,0.26000000f,0.97000000f,-0.23000000f,0.61000000f,0.77000000f,-0.28000000f,0.17000000f,0.32000000f,0.85000000f,-0.80000000f,-0.85000000f,-0.03000000f,-0.59000000f,-0.91000000f,0.28000000f,-0.14000000f,0.46000000f,-0.53000000f,-0.75000000f,-0.84000000f,0.52000000f,-0.35000000f,-0.97000000f,0.94000000f,-0.44000000f,-0.26000000f,0.54000000f,-0.51000000f,0.41000000f,0.41000000f,0.89000000f,-0.54000000f,-0.27000000f,0.72000000f,-0.34000000f,0.01000000f,0.19000000f,0.23000000f,-0.30000000f,-0.61000000f,-0.39000000f,-0.11000000f,0.45000000f,-0.22000000f,-0.66000000f,0.06000000f,0.15000000f,0.46000000f,-0.00000000f,0.91000000f,0.25000000f,0.37000000f,-0.13000000f,0.26000000f,0.08000000f,0.78000000f,-0.77000000f,-0.68000000f,0.21000000f,-0.80000000f,0.02000000f,0.33000000f,0.65000000f,0.33000000f,0.02000000f,-0.97000000f,0.01000000f,-0.47000000f,-0.48000000f,0.46000000f,-0.70000000f,0.47000000f,0.01000000f,-0.98000000f,0.49000000f,-0.12000000f,-0.62000000f,-0.45000000f,0.57000000f,-0.05000000f,0.91000000f,0.29000000f,-0.85000000f,-0.14000000f,-0.51000000f,-0.31000000f,0.48000000f,0.81000000f,-0.11000000f,0.10000000f,0.72000000f,0.27000000f,-0.97000000f,0.24000000f,-0.18000000f,-0.09000000f,-0.77000000f,-0.70000000f,0.98000000f,0.50000000f,0.58000000f,0.10000000f,-0.19000000f,0.12000000f,0.05000000f,0.77000000f,0.17000000f,-0.38000000f,-0.17000000f,0.15000000f,-0.18000000f,0.45000000f,0.10000000f,0.86000000f,0.23000000f,-0.74000000f,-0.18000000f,0.41000000f,0.30000000f,-0.75000000f,-0.25000000f,-0.29000000f,0.86000000f,-0.21000000f,0.34000000f,-0.62000000f,0.89000000f,-0.04000000f,-0.34000000f,-0.04000000f,0.38000000f,-0.59000000f,0.02000000f,0.52000000f,0.84000000f,0.14000000f,0.48000000f,-0.89000000f,-0.86000000f,0.12000000f,-0.07000000f,-0.21000000f,-0.94000000f,-0.36000000f,-0.49000000f,0.26000000f,0.70000000f,0.45000000f,0.16000000f,-0.98000000f,-0.85000000f,-0.38000000f,-0.01000000f,-0.31000000f,-0.23000000f,-0.16000000f,0.93000000f,-0.68000000f,0.12000000f,-0.92000000f,-0.55000000f,-0.15000000f,-0.68000000f,-0.59000000f,-0.57000000f,0.79000000f,-0.21000000f,0.17000000f,-0.14000000f,-0.30000000f,-0.35000000f,0.07000000f,-0.15000000f,-0.25000000f,-0.04000000f,0.01000000f,0.28000000f,-0.54000000f,0.85000000f,-0.59000000f,-0.69000000f,-0.18000000f,0.42000000f,-0.93000000f,-0.02000000f,-0.69000000f,0.94000000f,0.11000000f,-0.33000000f,0.34000000f,0.25000000f,-0.77000000f,-0.82000000f,0.33000000f,-0.29000000f,-0.68000000f,-0.52000000f,-0.49000000f,0.57000000f,0.47000000f,-0.60000000f,-0.45000000f,0.69000000f,0.82000000f,-0.15000000f,-0.83000000f,-0.07000000f,-0.79000000f,-0.63000000f,-0.42000000f,-0.62000000f,-0.25000000f,0.78000000f,0.69000000f,0.32000000f,0.36000000f,0.73000000f,0.52000000f,-0.74000000f,-0.11000000f,0.04000000f,-0.96000000f,-0.50000000f,-0.47000000f,-0.88000000f,-0.26000000f,0.67000000f,-0.59000000f,-0.33000000f,0.78000000f,-0.59000000f,0.21000000f,0.13000000f,-0.31000000f,-0.19000000f,0.15000000f,0.26000000f,-0.40000000f,0.43000000f,-0.96000000f,0.75000000f,-0.61000000f,-0.04000000f,0.66000000f,-0.10000000f,0.65000000f,0.12000000f,-0.20000000f,0.98000000f,0.99000000f,-0.75000000f,0.51000000f,0.93000000f,-0.27000000f,0.02000000f,-0.85000000f,-0.62000000f,-0.35000000f,-0.04000000f,0.96000000f,0.85000000f,0.89000000f,-0.38000000f,-0.68000000f,0.02000000f,-0.88000000f,-0.67000000f,0.00000000f,0.92000000f,-0.88000000f,0.56000000f,0.46000000f,-0.72000000f,0.66000000f,0.80000000f,0.48000000f,0.19000000f,0.27000000f,0.15000000f,-0.77000000f,-0.45000000f,-0.94000000f,0.11000000f,0.37000000f,0.22000000f,-0.54000000f,-0.27000000f,-0.67000000f,-0.76000000f,-0.15000000f,-0.20000000f,0.93000000f,-0.05000000f,0.27000000f,0.20000000f,0.72000000f,-0.40000000f,-0.72000000f,-0.49000000f,0.81000000f,0.06000000f,0.83000000f,0.09000000f,0.08000000f,-0.65000000f,-0.26000000f,0.74000000f,-0.22000000f,-0.96000000f,-0.62000000f,-0.45000000f,0.60000000f,-0.10000000f,0.17000000f,0.12000000f,-0.17000000f,-0.74000000f,0.08000000f,0.12000000f,-0.64000000f,0.68000000f,0.92000000f,0.00000000f,-0.04000000f,0.31000000f,-0.83000000f,-0.47000000f,-0.55000000f,-0.89000000f,-0.42000000f,-0.96000000f,-0.62000000f,0.19000000f,-0.47000000f,0.19000000f,-0.46000000f,-0.70000000f,0.39000000f,-0.10000000f,-0.82000000f,0.19000000f,-0.06000000f,-0.47000000f,-0.03000000f,-0.46000000f,0.22000000f,-0.76000000f,0.34000000f,-0.80000000f,0.31000000f,0.41000000f,0.17000000f,0.90000000f,0.47000000f,0.85000000f,-0.94000000f,0.31000000f,-0.81000000f,0.24000000f,0.42000000f,0.20000000f,0.15000000f,-0.24000000f,-0.69000000f,-0.87000000f,-0.65000000f,0.09000000f,-0.25000000f,0.36000000f,-0.38000000f,0.04000000f,-0.80000000f,0.54000000f,0.82000000f,-0.95000000f,0.86000000f,0.40000000f,0.70000000f,-0.34000000f,-0.58000000f,-0.75000000f,-0.37000000f,0.39000000f,-0.62000000f,0.05000000f,-0.76000000f,-0.91000000f,0.65000000f,0.38000000f,0.76000000f,0.36000000f,-0.73000000f,0.06000000f,-0.01000000f,-0.05000000f,0.41000000f,-0.66000000f,0.75000000f,0.56000000f,0.55000000f,-0.09000000f,0.82000000f,0.49000000f,-0.35000000f,0.91000000f,-0.54000000f,0.63000000f,0.00000000f,-0.34000000f,-0.30000000f,-0.08000000f,0.90000000f,0.76000000f,0.41000000f,-0.48000000f,0.95000000f,0.61000000f,0.28000000f,0.41000000f,-0.86000000f,-0.79000000f,0.25000000f,-0.48000000f,0.35000000f,0.22000000f,-0.38000000f,0.33000000f,0.81000000f,-0.85000000f,-0.60000000f,0.87000000f,0.77000000f,0.13000000f,0.90000000f,0.46000000f,0.74000000f,-0.66000000f,0.31000000f,0.00000000f,0.87000000f,0.60000000f,-0.04000000f,0.30000000f,0.61000000f,0.93000000f,0.59000000f,0.19000000f,0.26000000f,-0.93000000f,0.24000000f,0.64000000f,-0.72000000f,0.62000000f,0.31000000f,-0.11000000f,-0.24000000f,0.00000000f,0.79000000f,0.98000000f,-0.43000000f,-0.60000000f,-0.10000000f,0.31000000f,0.38000000f,-0.21000000f,0.81000000f,-0.96000000f,-0.87000000f,-0.66000000f,0.92000000f,0.21000000f,0.53000000f,0.22000000f,-0.25000000f,-0.20000000f,0.02000000f,0.93000000f,0.39000000f,0.38000000f,0.71000000f,-0.38000000f,0.73000000f,0.58000000f,-0.81000000f,0.78000000f,-0.92000000f,-0.26000000f,0.39000000f,0.83000000f,0.85000000f,0.90000000f,-0.26000000f,0.12000000f,-0.40000000f,-0.17000000f,0.54000000f,0.85000000f,-0.38000000f,-0.68000000f,-0.77000000f,0.90000000f,0.08000000f,0.26000000f,0.93000000f,0.52000000f,-0.05000000f,-0.19000000f,-0.64000000f,0.96000000f,0.92000000f,-0.90000000f,0.77000000f,0.05000000f,-0.27000000f,0.76000000f,0.63000000f,-0.15000000f,0.14000000f,0.24000000f,-0.37000000f,-0.39000000f,0.62000000f,-0.68000000f,-0.46000000f,-0.21000000f,-0.72000000f,0.67000000f,-0.75000000f,-0.48000000f,-0.85000000f,-0.06000000f,-0.37000000f,0.07000000f,0.63000000f,0.94000000f,-0.28000000f,-0.88000000f,-0.16000000f,-0.20000000f,-0.23000000f,0.45000000f,-0.02000000f,-0.78000000f,0.76000000f,-0.63000000f,0.09000000f,-0.35000000f,0.91000000f,0.41000000f,-0.89000000f,0.67000000f,0.57000000f,-0.95000000f,0.41000000f,0.62000000f,-0.61000000f,0.17000000f,-0.24000000f,0.34000000f,0.11000000f,-0.25000000f,-0.29000000f,-0.22000000f,0.99000000f,0.73000000f,-0.54000000f,0.39000000f,-0.74000000f,0.32000000f,0.39000000f,-0.40000000f,0.18000000f,0.94000000f,0.94000000f,0.47000000f,0.27000000f,-0.61000000f,-0.62000000f,0.78000000f,0.77000000f,-0.91000000f,0.41000000f,0.67000000f,-0.17000000f,-0.16000000f,0.86000000f,0.50000000f,0.71000000f,0.68000000f,0.54000000f,0.68000000f,0.27000000f,0.35000000f,-0.84000000f,-0.04000000f,-0.06000000f,0.14000000f,0.64000000f,-0.61000000f,-0.51000000f,-0.17000000f,-0.22000000f,-0.55000000f,0.68000000f,0.52000000f,-0.38000000f,-0.18000000f,0.21000000f,0.34000000f,-0.29000000f,-0.85000000f,-0.88000000f,0.92000000f,0.44000000f,-0.02000000f,0.59000000f,-0.06000000f,-0.62000000f,-0.11000000f,-0.72000000f,-0.88000000f,-0.91000000f,-0.59000000f,-0.77000000f,0.67000000f,0.19000000f,0.34000000f,0.05000000f,0.77000000f,0.09000000f,-0.08000000f,-0.60000000f,0.03000000f,0.02000000f,0.00000000f,0.98000000f,0.75000000f,0.96000000f,0.05000000f,-0.09000000f,0.25000000f,-0.53000000f,0.26000000f,0.00000000f,0.26000000f,0.77000000f,0.74000000f,0.38000000f,0.27000000f,0.49000000f,-0.85000000f,0.67000000f,0.59000000f,0.45000000f,0.70000000f,-0.21000000f,0.78000000f,0.74000000f,-0.83000000f,0.85000000f,-0.38000000f,0.78000000f,-0.82000000f,-0.70000000f,-0.36000000f,0.21000000f,0.32000000f,-0.66000000f,-0.33000000f,0.50000000f,0.26000000f,0.59000000f,-0.13000000f,0.86000000f,-0.01000000f,0.52000000f,-0.65000000f,-0.02000000f,-0.82000000f,0.04000000f,0.64000000f,0.62000000f,0.94000000f,0.70000000f,-0.55000000f,-0.03000000f,0.38000000f,-0.45000000f,0.70000000f,-0.17000000f,0.76000000f,0.35000000f,-0.91000000f,-0.85000000f,0.72000000f,-0.18000000f,-0.09000000f,0.54000000f,-0.54000000f,-0.19000000f,-0.97000000f,-0.98000000f,-0.60000000f,0.38000000f,-0.36000000f,0.58000000f,0.56000000f,0.29000000f,0.16000000f,0.27000000f,-0.91000000f,0.53000000f,-0.06000000f,-0.42000000f,0.05000000f,-0.05000000f,0.25000000f,-0.46000000f,0.92000000f,0.37000000f,-0.87000000f,0.14000000f,0.98000000f,-0.33000000f,0.07000000f,0.98000000f,0.16000000f,-0.19000000f,-0.22000000f,-0.45000000f,0.61000000f,-0.77000000f,0.59000000f,0.32000000f,0.34000000f,0.85000000f,0.98000000f,-0.56000000f,-0.46000000f,-0.83000000f,0.64000000f,-0.78000000f,0.33000000f,0.38000000f,0.49000000f,0.90000000f,-0.73000000f,0.50000000f,0.51000000f,-0.25000000f,-0.80000000f,0.17000000f,-0.88000000f,-0.30000000f,0.57000000f,-0.48000000f,-0.83000000f,-0.05000000f,-0.27000000f,-0.28000000f,0.80000000f,-0.26000000f,-0.17000000f,-0.61000000f,0.25000000f,-0.47000000f,-0.65000000f,-0.29000000f,-0.43000000f,-0.88000000f,-0.02000000f,0.97000000f,0.04000000f,0.94000000f,-0.47000000f,0.46000000f,0.19000000f,-0.00000000f,0.70000000f,0.36000000f,0.93000000f,-0.47000000f,-0.85000000f,-0.44000000f,-0.26000000f,-0.44000000f,0.41000000f,-0.50000000f,-0.77000000f,-0.98000000f,0.30000000f,-0.75000000f,-0.53000000f,-0.77000000f,-0.89000000f,0.92000000f,-0.35000000f,0.22000000f,-0.14000000f,-0.50000000f,0.41000000f,0.78000000f,-0.89000000f,0.59000000f,-0.62000000f,-0.82000000f,0.50000000f,0.98000000f,0.85000000f,0.84000000f,0.63000000f,0.40000000f,0.04000000f,0.15000000f,-0.70000000f,0.95000000f,0.10000000f,0.25000000f,-0.02000000f,-0.70000000f,0.88000000f,-0.56000000f,0.56000000f,-0.58000000f,0.52000000f,-0.11000000f,0.02000000f,-0.35000000f,-0.62000000f,-0.15000000f,-0.06000000f,0.15000000f,0.45000000f,-0.99000000f,0.57000000f,-0.19000000f,0.11000000f,0.84000000f,0.02000000f,-0.05000000f,-0.53000000f,0.74000000f,-0.85000000f,-0.07000000f,0.33000000f,0.45000000f,-0.45000000f,-0.74000000f,0.07000000f,0.38000000f,0.60000000f,0.36000000f,0.57000000f,-0.27000000f,-0.54000000f,-0.01000000f,0.68000000f,-0.97000000f,0.67000000f,-0.06000000f,0.67000000f,0.01000000f,0.03000000f,0.65000000f,0.18000000f,-0.81000000f,0.23000000f,0.06000000f,0.45000000f,0.42000000f,-0.17000000f,0.76000000f,-0.27000000f,-0.29000000f,-0.17000000f,0.02000000f,-0.42000000f,-0.46000000f,-0.93000000f,-0.17000000f,-0.78000000f,-0.43000000f,-0.04000000f,-0.69000000f,0.29000000f,0.35000000f,-0.91000000f,-0.97000000f,0.09000000f,0.63000000f,-0.20000000f,0.15000000f,-0.63000000f,-0.96000000f,-0.95000000f,0.60000000f,0.91000000f,0.09000000f,-0.70000000f,0.50000000f,-0.07000000f,0.44000000f,0.01000000f,0.75000000f,0.73000000f,-0.73000000f,0.16000000f,-0.80000000f,0.52000000f,0.64000000f,-0.02000000f,-0.17000000f,0.04000000f,-0.50000000f,0.72000000f,-0.06000000f,0.80000000f,-0.50000000f,-0.78000000f,-0.37000000f,-0.16000000f,-0.06000000f,-0.73000000f,-0.68000000f,-0.45000000f,0.43000000f,-0.41000000f,-0.01000000f,-0.75000000f,0.41000000f,-0.94000000f,0.86000000f,-0.33000000f,0.65000000f,-0.82000000f,-0.53000000f,-0.19000000f,-0.21000000f,0.75000000f,0.39000000f,-0.52000000f,-0.82000000f,0.05000000f,0.29000000f,-0.84000000f,-0.03000000f,-0.05000000f,-0.92000000f,0.66000000f,0.14000000f,0.19000000f,-0.98000000f,0.09000000f,0.48000000f,0.96000000f,0.39000000f,0.67000000f,-0.49000000f,0.42000000f,0.30000000f,0.84000000f,-0.46000000f,-0.41000000f,0.92000000f,-0.93000000f,0.51000000f,-0.90000000f,-0.54000000f,-0.32000000f,0.18000000f,-0.83000000f,-0.05000000f,0.78000000f,-0.76000000f,0.76000000f,-0.50000000f,-0.94000000f,-0.58000000f,0.52000000f,0.45000000f,-0.17000000f,0.62000000f,0.48000000f,0.85000000f,0.11000000f,0.74000000f,0.99000000f,0.94000000f,-0.77000000f,0.44000000f,-0.89000000f,0.97000000f,-0.77000000f,0.16000000f,-0.35000000f,0.16000000f,-0.45000000f,0.50000000f,-0.96000000f,0.74000000f,-0.52000000f,-0.64000000f,0.13000000f,-0.21000000f,-0.03000000f,-0.16000000f,0.35000000f,0.53000000f,-0.82000000f,0.34000000f,0.52000000f,-0.59000000f,-0.17000000f,-0.53000000f,-0.88000000f,0.67000000f,0.13000000f,-0.21000000f,0.93000000f,-0.45000000f,-0.11000000f,-0.60000000f,0.84000000f,0.16000000f,0.76000000f,0.01000000f,0.89000000f,0.87000000f,0.04000000f,0.86000000f,0.20000000f,0.20000000f,0.61000000f,-0.21000000f,0.04000000f,0.26000000f,0.91000000f,-0.40000000f,0.00000000f,-0.26000000f,-0.12000000f,0.35000000f,0.21000000f,-0.87000000f,0.81000000f,-0.03000000f,-0.82000000f,0.19000000f,-0.71000000f,0.93000000f,0.39000000f,-0.70000000f,-0.97000000f,0.20000000f,0.92000000f,0.13000000f,-0.81000000f,0.88000000f,0.34000000f,-0.27000000f,-0.46000000f,0.78000000f,0.94000000f,-0.50000000f,0.57000000f,0.06000000f,-0.52000000f,0.14000000f,0.33000000f,-0.34000000f,-0.31000000f,-0.05000000f,-0.73000000f,0.13000000f,-0.63000000f,0.88000000f,-0.44000000f,-0.15000000f,0.11000000f,0.90000000f,-0.36000000f,0.51000000f,-0.38000000f,-0.64000000f,-0.21000000f,0.13000000f,0.89000000f,0.81000000f,-0.69000000f,0.15000000f,-0.67000000f,-0.89000000f,-0.47000000f,0.73000000f,-0.15000000f,-0.97000000f,-0.24000000f,-0.57000000f,0.91000000f,-0.64000000f,-0.30000000f,0.67000000f,-0.55000000f,-0.68000000f,0.98000000f,-0.98000000f,0.96000000f,-0.36000000f,-0.55000000f,0.11000000f,-0.73000000f,0.57000000f,0.73000000f,-0.46000000f,-0.11000000f,0.52000000f,0.48000000f,0.06000000f,0.43000000f,-0.41000000f,-0.43000000f,0.58000000f,-0.69000000f,0.57000000f,0.71000000f,-0.73000000f,0.19000000f,-0.45000000f,-0.24000000f,0.96000000f,0.61000000f,0.66000000f,-0.50000000f,-0.46000000f,0.32000000f,0.43000000f,0.15000000f,-0.93000000f,0.77000000f,0.60000000f,-0.27000000f,-0.37000000f,0.31000000f,-0.69000000f,0.20000000f,-0.22000000f,0.90000000f,0.51000000f,-0.56000000f,-0.50000000f,-0.55000000f,0.64000000f,-0.03000000f,0.70000000f,0.90000000f,-0.83000000f,-0.11000000f,-0.70000000f,0.82000000f,0.62000000f,0.66000000f,0.26000000f,0.24000000f,-0.55000000f,0.72000000f,0.42000000f,0.58000000f,0.60000000f,-0.02000000f,-0.29000000f,0.73000000f,-0.04000000f,-0.45000000f,0.01000000f,-0.04000000f,-0.59000000f,0.86000000f,-0.29000000f,0.82000000f,0.56000000f,-0.76000000f,-0.58000000f,0.77000000f,0.96000000f,-0.28000000f,0.71000000f,0.19000000f,-0.26000000f,0.98000000f,0.32000000f,-0.75000000f,-0.24000000f,0.85000000f,-0.26000000f,-0.73000000f,0.49000000f,0.26000000f,-0.74000000f,0.08000000f,-0.53000000f,-0.58000000f,0.52000000f,0.41000000f,0.06000000f,0.20000000f,0.47000000f,-0.41000000f,0.14000000f,0.00000000f,0.94000000f,0.76000000f,-0.41000000f,-0.90000000f,0.92000000f,-0.29000000f,0.52000000f,-0.94000000f,0.37000000f,0.87000000f,-0.06000000f,-0.44000000f,-0.33000000f,-0.04000000f,0.78000000f,-0.55000000f,-0.23000000f,0.25000000f,0.08000000f,0.41000000f,-0.48000000f,0.05000000f,-0.37000000f,0.39000000f,-0.74000000f,-0.89000000f,0.51000000f,-0.80000000f,-0.70000000f,-0.94000000f,0.32000000f,-0.43000000f,-0.75000000f,0.63000000f,-0.33000000f,-0.67000000f,-0.33000000f,0.18000000f,0.65000000f,0.34000000f,0.92000000f,0.08000000f,0.92000000f,0.04000000f,-0.33000000f,-0.59000000f,0.62000000f,0.85000000f,-0.49000000f,0.39000000f,-0.37000000f,-0.04000000f,-0.11000000f,0.23000000f,-0.41000000f,-0.84000000f,0.71000000f,-0.35000000f,0.88000000f,0.70000000f,0.94000000f,0.19000000f,0.85000000f,-0.35000000f,0.84000000f,-0.99000000f,-0.70000000f,0.57000000f,-0.78000000f,-0.96000000f,-0.55000000f,0.79000000f,0.67000000f,0.09000000f,-0.28000000f,-0.11000000f,0.22000000f,0.92000000f,0.79000000f,-0.70000000f,-0.62000000f,0.56000000f,-0.70000000f,-0.15000000f,0.18000000f,0.65000000f,0.97000000f,-0.87000000f,-0.04000000f,-0.75000000f,-0.65000000f,0.12000000f,-0.09000000f,0.85000000f,0.98000000f,0.58000000f,0.09000000f,-0.06000000f,0.70000000f,0.19000000f,-0.89000000f,-0.53000000f,-0.26000000f,-0.79000000f,-0.07000000f,0.19000000f,-0.68000000f,0.72000000f,0.87000000f,-0.10000000f,0.68000000f,-0.12000000f,-0.44000000f,0.26000000f,-0.30000000f,0.36000000f,-0.98000000f,-0.76000000f,-0.93000000f,0.93000000f,-0.68000000f,-0.39000000f,-0.06000000f,0.87000000f,-0.19000000f,0.60000000f,0.96000000f,0.91000000f,0.05000000f,-0.95000000f,0.13000000f,0.35000000f,0.87000000f,0.67000000f,-0.48000000f,0.26000000f,0.19000000f,0.74000000f,-0.53000000f,-0.54000000f,0.60000000f,0.08000000f,0.50000000f,0.18000000f,0.89000000f,0.89000000f,-0.19000000f,0.10000000f,0.72000000f,-0.13000000f,-0.38000000f,-0.45000000f,0.19000000f,0.33000000f,-0.01000000f,-0.34000000f,-0.28000000f,-0.42000000f,-0.39000000f,0.48000000f,0.11000000f,-0.66000000f,0.22000000f,-0.08000000f,0.71000000f,0.86000000f,0.02000000f,-0.02000000f,0.39000000f,-0.86000000f,-0.51000000f,0.50000000f,-0.42000000f,0.12000000f,0.44000000f,-0.47000000f,-0.43000000f,0.11000000f,-0.92000000f,-0.07000000f,0.83000000f,-0.69000000f,-0.28000000f,-0.13000000f,0.05000000f,-0.49000000f,0.07000000f,-0.34000000f,0.18000000f,-0.42000000f,0.57000000f,0.44000000f,0.57000000f,0.45000000f,0.97000000f,-0.57000000f,0.30000000f,-0.87000000f,-0.90000000f,-0.11000000f,-0.14000000f,0.89000000f,0.74000000f,0.35000000f,0.30000000f,-0.16000000f,-0.17000000f,0.23000000f,-0.63000000f,-0.95000000f,0.79000000f,-0.39000000f,0.38000000f,0.34000000f,-0.69000000f,-0.45000000f,-0.34000000f,0.96000000f,-0.02000000f,-0.77000000f,0.15000000f,0.37000000f,-0.61000000f,-0.83000000f,0.48000000f,-0.57000000f,0.52000000f,-0.71000000f,-0.02000000f,-0.83000000f,0.34000000f,0.29000000f,-0.05000000f,0.73000000f,-0.15000000f,0.89000000f,-0.17000000f,-0.81000000f,0.59000000f,0.11000000f,0.92000000f,0.31000000f,0.71000000f,-0.89000000f,-0.70000000f,0.31000000f,0.75000000f,-0.59000000f,-0.89000000f,-0.81000000f,-0.81000000f,0.23000000f,0.12000000f,0.26000000f,0.56000000f,0.01000000f,0.24000000f,-0.26000000f,0.61000000f,-0.58000000f,0.57000000f,-0.95000000f,-0.46000000f,0.78000000f,0.06000000f,-0.32000000f,0.88000000f,0.84000000f,-0.25000000f,-0.25000000f,-0.32000000f,0.48000000f,0.28000000f,-0.14000000f,0.48000000f,0.29000000f,0.67000000f,0.89000000f,0.97000000f,0.54000000f,-0.46000000f,0.19000000f,0.67000000f,-0.27000000f,0.19000000f,-0.64000000f,0.68000000f,0.30000000f,0.24000000f,-0.61000000f,-0.28000000f,-0.26000000f,0.32000000f,-0.30000000f,-0.72000000f,0.01000000f,0.19000000f,-0.35000000f,-0.56000000f,-0.02000000f,0.17000000f,0.45000000f,0.07000000f,-0.07000000f,-0.75000000f,0.21000000f,-0.19000000f,0.21000000f,0.89000000f,-0.13000000f,0.51000000f,0.70000000f,-0.00000000f,-0.92000000f,-0.64000000f,0.26000000f,-0.13000000f,0.69000000f,0.28000000f,-0.47000000f,-0.78000000f,-0.32000000f,0.01000000f,0.15000000f,0.36000000f,-0.28000000f,-0.35000000f,0.31000000f,-0.47000000f,0.53000000f,0.51000000f,0.23000000f,0.35000000f,0.97000000f,0.23000000f,-0.09000000f,0.81000000f,-0.26000000f,0.08000000f,-0.17000000f,-0.41000000f,0.78000000f,-0.51000000f,0.16000000f,-0.27000000f,0.05000000f,-0.30000000f,0.32000000f,0.51000000f,0.19000000f,0.94000000f,0.60000000f,0.10000000f,0.21000000f,0.49000000f,-0.69000000f,0.23000000f,-0.87000000f,0.64000000f,-0.36000000f,-0.53000000f,-0.63000000f,-0.05000000f,-0.95000000f,0.23000000f,0.85000000f,-0.32000000f,-0.11000000f,-0.89000000f,-0.13000000f,0.31000000f,0.28000000f,-0.69000000f,-0.37000000f,-0.47000000f,-0.79000000f,0.78000000f,-0.90000000f,0.91000000f,-0.86000000f,0.05000000f,-0.86000000f,-0.74000000f,0.19000000f,0.68000000f,-0.56000000f,0.04000000f,0.10000000f,-0.35000000f,0.47000000f,-0.79000000f,-0.28000000f,0.46000000f,-0.11000000f,0.60000000f,0.72000000f,-0.47000000f,0.03000000f,0.63000000f,0.75000000f,-0.84000000f,0.40000000f,-0.25000000f,-0.72000000f,0.63000000f,-0.22000000f,-0.96000000f,0.43000000f,-0.61000000f,0.73000000f,-0.58000000f,0.78000000f,-0.11000000f,-0.30000000f,-0.59000000f,-0.11000000f,0.01000000f,0.44000000f,0.35000000f,0.42000000f,-0.84000000f,0.13000000f,0.63000000f,0.37000000f,-0.45000000f,0.86000000f,0.90000000f,0.08000000f,-0.50000000f,0.89000000f,0.54000000f,0.50000000f,-0.17000000f,-0.89000000f,-0.72000000f,0.60000000f,-0.75000000f,0.75000000f,-0.79000000f,0.60000000f,0.56000000f,-0.67000000f,0.75000000f,-0.70000000f,-0.15000000f,-0.09000000f,-0.27000000f,0.44000000f,0.74000000f,-0.97000000f,-0.72000000f,0.47000000f,0.83000000f,0.60000000f,-0.97000000f,0.32000000f,0.24000000f,0.33000000f,0.65000000f,0.74000000f,-0.10000000f,0.19000000f,0.30000000f,-0.94000000f,0.07000000f,-0.04000000f,-0.47000000f,0.56000000f,-0.94000000f,0.01000000f,-0.65000000f,-0.18000000f,0.41000000f,-0.34000000f,-0.42000000f,0.56000000f,0.40000000f,-0.17000000f,-0.98000000f,0.62000000f,0.27000000f,-0.27000000f,0.25000000f,0.26000000f,0.41000000f,-0.17000000f,0.18000000f,-0.67000000f,-0.17000000f,-0.78000000f,0.52000000f,0.83000000f,0.04000000f,-0.14000000f,0.35000000f,0.73000000f,0.14000000f,0.72000000f,-0.26000000f,0.83000000f,-0.60000000f,-0.61000000f,0.89000000f,0.30000000f,0.07000000f,0.82000000f,-0.79000000f,-0.68000000f,-0.42000000f,-0.40000000f,-0.99000000f,-0.86000000f,0.48000000f,0.44000000f,0.50000000f,0.51000000f,0.16000000f,-0.77000000f,-0.15000000f,-0.70000000f,0.64000000f,0.97000000f,-0.71000000f,-0.54000000f,0.23000000f,-0.23000000f,0.83000000f,0.53000000f,-0.58000000f,0.62000000f,-0.32000000f,0.84000000f,-0.66000000f,0.95000000f,0.76000000f,0.92000000f,0.48000000f,-0.81000000f,0.43000000f,0.08000000f,-0.67000000f,0.46000000f,0.30000000f,0.23000000f,0.01000000f,0.55000000f,0.02000000f,0.81000000f,0.56000000f,-0.34000000f,-0.69000000f,0.05000000f,-0.99000000f,0.96000000f,-0.84000000f,0.34000000f,0.88000000f,0.01000000f,0.44000000f,-0.19000000f,0.28000000f,0.39000000f,-0.70000000f,-0.24000000f,-0.83000000f,0.44000000f,0.09000000f,-0.08000000f,0.42000000f,0.09000000f,0.24000000f,-0.86000000f,-0.21000000f,-0.90000000f,-0.87000000f,-0.91000000f,0.29000000f,-0.61000000f,-0.84000000f,0.36000000f,-0.40000000f,-0.45000000f,0.46000000f,0.05000000f,-0.55000000f,0.24000000f,0.99000000f,-0.20000000f,0.18000000f,-0.16000000f,0.45000000f,0.90000000f,0.38000000f,-0.37000000f,0.24000000f,0.90000000f,-0.55000000f,0.09000000f,-0.53000000f,-0.14000000f,0.66000000f,-0.59000000f,-0.70000000f,0.24000000f,0.17000000f,0.24000000f,-0.65000000f,0.76000000f,0.32000000f,0.49000000f,-0.65000000f,0.55000000f,-0.59000000f,-0.31000000f,0.78000000f,-0.67000000f,-0.29000000f,-0.60000000f,0.31000000f,0.26000000f,-0.02000000f,0.87000000f,-0.31000000f,0.95000000f,0.14000000f,0.76000000f,-0.89000000f,0.26000000f,0.74000000f,-0.41000000f,0.10000000f,-0.93000000f,-0.42000000f,-0.60000000f,-0.96000000f,-0.31000000f,0.90000000f,-0.20000000f,0.68000000f,-0.57000000f,0.86000000f,-0.71000000f,0.68000000f,0.26000000f,0.75000000f,0.79000000f,0.09000000f,0.94000000f,0.20000000f,0.11000000f,-0.27000000f,-0.06000000f,0.23000000f,0.43000000f,-0.44000000f,-0.87000000f,0.56000000f,-0.34000000f,0.37000000f,-0.49000000f,-0.47000000f,0.10000000f,0.53000000f,0.80000000f,0.53000000f,-0.44000000f,-0.92000000f,0.79000000f,-0.89000000f,0.50000000f,0.82000000f,-0.09000000f,-0.14000000f,-0.88000000f,0.16000000f,-0.15000000f,0.81000000f,-0.96000000f,0.99000000f,0.30000000f,0.09000000f,-0.84000000f,-0.61000000f,0.41000000f,-0.68000000f,0.54000000f,-0.86000000f,-0.87000000f,-0.55000000f,0.69000000f,0.67000000f,-0.43000000f,0.09000000f,0.47000000f,0.85000000f,-0.36000000f,0.27000000f,-0.10000000f,0.93000000f,0.34000000f,-0.77000000f,0.45000000f,-0.37000000f,0.71000000f,0.82000000f,-0.98000000f,0.42000000f,-0.07000000f,0.50000000f,0.66000000f,0.62000000f,0.13000000f,-0.53000000f,-0.83000000f,-0.38000000f,-0.03000000f,-0.49000000f,-0.10000000f,0.21000000f,0.89000000f,-0.90000000f,0.55000000f,-0.62000000f,0.42000000f,0.45000000f,-0.17000000f,-0.04000000f,-0.22000000f,-0.20000000f,-0.10000000f,0.42000000f,0.97000000f,-0.08000000f,-0.58000000f,-0.25000000f,0.02000000f,-0.08000000f,-0.38000000f,0.89000000f,-0.65000000f,0.46000000f,-0.35000000f,-0.54000000f,0.92000000f,0.03000000f,0.58000000f,-0.00000000f,-0.40000000f,-0.55000000f,0.99000000f,-0.46000000f,-0.17000000f,0.17000000f,-0.05000000f,-0.28000000f,0.57000000f,-0.15000000f,-0.41000000f,0.24000000f,0.64000000f,0.55000000f,-0.43000000f,-0.52000000f,0.79000000f,0.59000000f,0.23000000f,-0.41000000f,-0.87000000f,0.82000000f,-0.26000000f,-0.10000000f,-0.14000000f,-0.93000000f,-0.03000000f,-0.51000000f,0.17000000f,-0.53000000f,-0.27000000f,-0.64000000f,0.28000000f,-0.98000000f,0.03000000f,-0.06000000f,0.22000000f,0.65000000f,0.93000000f,0.18000000f,-0.60000000f,0.74000000f,0.13000000f,0.79000000f,-0.20000000f,-0.12000000f,0.08000000f,-0.93000000f,-0.82000000f,0.61000000f,-0.68000000f,0.17000000f,-0.66000000f,0.23000000f,-0.62000000f,-0.23000000f,0.65000000f,0.42000000f,0.29000000f,-0.46000000f,0.97000000f,-0.42000000f,0.85000000f,-0.18000000f,-0.68000000f,0.13000000f,-0.50000000f,0.83000000f,0.59000000f,-0.44000000f,-0.14000000f,0.74000000f,0.46000000f,-0.27000000f,0.38000000f,-0.06000000f,-0.34000000f,-0.52000000f,0.66000000f,0.95000000f,0.69000000f,-0.09000000f,-0.37000000f,-0.35000000f,0.57000000f,0.19000000f,-0.65000000f,-0.70000000f,0.43000000f,-0.01000000f,0.24000000f,0.83000000f,0.28000000f,0.37000000f,-0.18000000f,-0.50000000f,0.10000000f,0.80000000f,0.04000000f,0.11000000f,0.02000000f,-0.44000000f,0.30000000f,0.91000000f,-0.42000000f,0.04000000f,-0.48000000f,-0.25000000f,-0.79000000f,-0.20000000f,0.33000000f,0.22000000f,-0.55000000f,-0.73000000f,0.25000000f,0.53000000f,0.57000000f,0.40000000f,0.53000000f,-0.69000000f,0.86000000f,0.78000000f,0.90000000f,0.79000000f,-0.52000000f,-0.90000000f,-0.16000000f,0.88000000f,0.40000000f,0.75000000f,0.53000000f,-0.91000000f,-0.39000000f,-0.79000000f,-0.26000000f,0.77000000f,-0.56000000f,-0.82000000f,-0.17000000f,0.94000000f,-0.86000000f,0.57000000f,-0.61000000f,-0.86000000f,0.11000000f,0.90000000f,-0.50000000f,-0.38000000f,0.06000000f,0.46000000f,0.60000000f,-0.81000000f,-0.81000000f,0.64000000f,0.13000000f,0.41000000f,-0.12000000f,-0.44000000f,-0.66000000f,-0.86000000f,-0.08000000f,0.16000000f,0.18000000f,0.45000000f,0.84000000f,-0.18000000f,-0.09000000f,0.78000000f,0.67000000f,0.86000000f,0.08000000f,-0.06000000f,0.77000000f,-0.88000000f,0.45000000f,-0.77000000f,-0.06000000f,-0.48000000f,0.81000000f,-0.48000000f,-0.01000000f,0.75000000f,0.43000000f,-0.63000000f,0.65000000f,-0.52000000f,-0.72000000f,-0.56000000f,-0.05000000f,-0.63000000f,0.08000000f,-0.34000000f,-0.72000000f,-0.70000000f,0.84000000f,-0.84000000f,-0.64000000f,-0.80000000f,0.40000000f,0.19000000f,0.07000000f,0.49000000f,0.62000000f,0.17000000f,-0.79000000f,0.62000000f,-0.59000000f,-0.82000000f,-0.40000000f,-0.07000000f,-0.35000000f,0.42000000f,-0.23000000f,-0.92000000f,0.70000000f,0.12000000f,0.93000000f,0.58000000f,0.94000000f,-0.67000000f,-0.13000000f,-0.96000000f,-0.04000000f,-0.57000000f,0.67000000f,0.36000000f,-0.03000000f,0.51000000f,-0.87000000f,0.58000000f,0.85000000f,0.54000000f,-0.10000000f,-0.98000000f,0.64000000f,-0.33000000f,0.70000000f,0.94000000f,-0.53000000f,-0.44000000f,-0.39000000f,0.17000000f,0.34000000f,0.22000000f,0.50000000f,0.63000000f,-0.61000000f,0.15000000f,-0.82000000f,-0.20000000f,-0.79000000f,-0.24000000f,0.58000000f,-0.48000000f,-0.76000000f,0.39000000f,-0.85000000f,-0.52000000f,-0.90000000f,0.00000000f,0.06000000f,0.40000000f,-0.89000000f,0.17000000f,-0.30000000f,-0.79000000f,-0.86000000f,0.44000000f,0.55000000f,0.49000000f,0.54000000f,0.12000000f,0.72000000f,0.17000000f,0.65000000f,-0.74000000f,-0.33000000f,-0.82000000f,0.30000000f,0.24000000f,-0.39000000f,0.47000000f,0.79000000f,-0.31000000f,0.97000000f,-0.17000000f,0.57000000f,-0.63000000f,0.23000000f,0.43000000f,-0.55000000f,0.61000000f,-0.88000000f,0.51000000f,-0.93000000f,0.26000000f,0.34000000f,-0.32000000f,0.22000000f,-0.38000000f,-0.93000000f,0.76000000f,-0.90000000f,-0.02000000f,0.08000000f,-0.07000000f,-0.71000000f,0.61000000f,-0.80000000f,0.81000000f,-0.26000000f,-0.82000000f,-0.18000000f,0.98000000f,0.57000000f,0.17000000f,-0.93000000f,0.67000000f,-0.80000000f,-0.07000000f,-0.43000000f,0.66000000f,0.17000000f,-0.26000000f,0.35000000f,0.15000000f,0.83000000f,0.74000000f,-0.88000000f,0.01000000f,0.81000000f,-0.90000000f,-0.75000000f,0.59000000f,0.00000000f,-0.42000000f,-0.11000000f,-0.54000000f,-0.99000000f,0.49000000f,0.46000000f,0.45000000f,0.27000000f,0.57000000f,-0.88000000f,0.54000000f,-0.59000000f,0.66000000f,-0.71000000f,-0.79000000f,-0.51000000f,0.73000000f,0.53000000f,-0.00000000f,0.52000000f,-0.84000000f,-0.39000000f,0.58000000f,0.17000000f,-0.29000000f,-0.36000000f,-0.57000000f,-0.25000000f,0.36000000f,0.58000000f,-0.06000000f,-0.71000000f,-0.35000000f,-0.87000000f,-0.38000000f,-0.60000000f,-0.75000000f,0.30000000f,0.97000000f,0.55000000f,0.31000000f,0.61000000f,0.59000000f,-0.24000000f,-0.13000000f,-0.91000000f,-0.07000000f,-0.17000000f,-0.82000000f,-0.40000000f,0.68000000f,0.78000000f,0.96000000f,-0.70000000f,0.19000000f,-0.98000000f,0.83000000f,0.77000000f,-0.17000000f,0.26000000f,-0.98000000f,0.62000000f,-0.43000000f,0.74000000f,0.50000000f,-0.36000000f,-0.78000000f,-0.34000000f,0.42000000f,0.62000000f,0.43000000f,-0.17000000f,0.83000000f,0.25000000f,0.51000000f,0.07000000f,-0.40000000f,0.05000000f,-0.69000000f,0.44000000f,-0.88000000f,0.12000000f,0.53000000f,0.24000000f,0.16000000f,0.08000000f,-0.97000000f,0.00000000f,-0.58000000f,0.19000000f,0.59000000f,0.32000000f,-0.46000000f,0.65000000f,-0.27000000f,-0.30000000f,0.63000000f,-0.85000000f,-0.99000000f,0.76000000f,-0.62000000f,0.90000000f,0.68000000f,-0.98000000f,0.40000000f,0.15000000f,-0.34000000f,-0.03000000f,-0.64000000f,-0.03000000f,0.99000000f,0.14000000f,-0.48000000f,-0.91000000f,-0.29000000f,0.43000000f,-0.40000000f,0.36000000f,0.15000000f,0.73000000f,0.00000000f,-0.39000000f,-0.55000000f,0.15000000f,0.12000000f,0.48000000f,0.47000000f,0.47000000f,-0.25000000f,-0.45000000f,0.68000000f,0.48000000f,-0.92000000f,-0.23000000f,0.36000000f,0.78000000f,-0.20000000f,-0.15000000f,-0.14000000f,0.82000000f,-0.49000000f,-0.91000000f,-0.92000000f,-0.92000000f,-0.25000000f,-0.22000000f,0.77000000f,0.44000000f,-0.86000000f,0.16000000f,0.76000000f,-0.06000000f,0.73000000f,-0.94000000f,-0.99000000f,-0.14000000f,0.52000000f,-0.63000000f,-0.18000000f,0.77000000f,-0.70000000f,-0.92000000f,0.36000000f,0.06000000f,0.57000000f,-0.96000000f,0.10000000f,0.12000000f,-0.64000000f,0.38000000f,-0.75000000f,-0.09000000f,-0.81000000f,-0.17000000f,-0.82000000f,0.39000000f,0.16000000f,-0.49000000f,-0.82000000f,-0.95000000f,0.16000000f,0.20000000f,0.12000000f,0.40000000f,0.26000000f,0.94000000f,0.55000000f,-0.83000000f,0.06000000f,-0.04000000f,0.42000000f,-0.97000000f,0.49000000f,-0.15000000f,-0.18000000f,-0.40000000f,0.43000000f,-0.56000000f,0.33000000f,0.29000000f,-0.94000000f,-0.74000000f,-0.20000000f,0.47000000f,-0.08000000f,-0.95000000f,0.08000000f,-0.32000000f,0.75000000f,-0.67000000f,0.36000000f,-0.29000000f,-0.41000000f,0.85000000f,-0.15000000f,0.09000000f,0.26000000f,-0.40000000f,-0.64000000f,-0.43000000f,-0.45000000f,0.87000000f,-0.62000000f,-0.96000000f,0.26000000f,0.87000000f,-0.36000000f,-0.69000000f,-0.93000000f,-0.32000000f,0.09000000f,0.94000000f,-0.85000000f,0.31000000f,-0.59000000f,-0.08000000f,0.10000000f,0.33000000f,-0.97000000f,-0.54000000f,-0.50000000f,0.25000000f,0.26000000f,0.67000000f,0.30000000f,-0.98000000f,0.67000000f,-0.92000000f,-0.56000000f,-0.80000000f,-0.53000000f,-0.34000000f,-0.68000000f,-0.28000000f,0.59000000f,-0.56000000f,0.94000000f,-0.10000000f,-0.26000000f,-0.93000000f,0.54000000f,0.13000000f,0.23000000f,-0.81000000f,0.36000000f,-0.26000000f,0.90000000f,0.53000000f,-0.43000000f,0.68000000f,0.28000000f,0.31000000f,0.25000000f,0.45000000f,-0.21000000f,0.67000000f,-0.56000000f,-0.63000000f,0.05000000f,0.39000000f,0.81000000f,-0.37000000f,-0.92000000f,0.53000000f,0.40000000f,-0.31000000f,0.23000000f,-0.00000000f,-0.83000000f,0.46000000f,-0.54000000f,0.98000000f,0.09000000f,-0.54000000f,-0.89000000f,0.82000000f,-0.62000000f,-0.09000000f,0.02000000f,-0.24000000f,0.42000000f,-0.85000000f,0.15000000f,-0.59000000f,-0.73000000f,0.73000000f,-0.19000000f,-0.58000000f,-0.45000000f,0.98000000f,-0.12000000f,-0.24000000f,-0.49000000f,-0.49000000f,0.46000000f,0.59000000f,-0.74000000f,0.79000000f,0.22000000f,-0.11000000f,-0.64000000f,-0.68000000f,0.31000000f,0.28000000f,0.23000000f,0.77000000f,-0.36000000f,0.30000000f,0.68000000f,-0.51000000f,-0.52000000f,0.59000000f,0.06000000f,0.29000000f,0.69000000f,-0.11000000f,-0.35000000f,0.67000000f,-0.18000000f,-0.59000000f,-0.77000000f,-0.09000000f,0.30000000f,0.78000000f,-0.36000000f,0.06000000f,-0.08000000f,-0.25000000f,-0.69000000f,0.82000000f,0.64000000f,-0.41000000f,0.40000000f,-0.34000000f,0.01000000f,-0.26000000f,0.40000000f,-0.73000000f,0.84000000f,0.39000000f,-0.42000000f,-0.31000000f,-0.28000000f,-0.96000000f,-0.75000000f,-0.64000000f,0.23000000f,-0.76000000f,-0.42000000f,0.92000000f,0.52000000f,0.92000000f,-0.58000000f,0.69000000f,-0.15000000f,0.24000000f,-0.27000000f,-0.86000000f,-0.09000000f,-0.42000000f,-0.74000000f,-0.01000000f,-0.18000000f,-0.41000000f,0.64000000f,0.92000000f,-0.58000000f,0.66000000f,-0.59000000f,-0.64000000f,0.20000000f,-0.80000000f,-0.58000000f,-0.44000000f,-0.34000000f,-0.11000000f,-0.07000000f,0.18000000f,0.31000000f,-0.05000000f,0.90000000f,-0.10000000f,-0.59000000f,0.33000000f,0.89000000f,-0.78000000f,0.66000000f,0.59000000f,0.76000000f,0.52000000f,0.04000000f,0.37000000f,0.79000000f,0.40000000f,-0.97000000f,-0.41000000f,0.04000000f,0.10000000f,0.72000000f,-0.20000000f,-0.95000000f,0.69000000f,0.26000000f,-0.56000000f,0.88000000f,-0.09000000f,-0.73000000f,-0.61000000f,-0.88000000f,-0.53000000f,-0.61000000f,-0.52000000f,-0.29000000f,0.96000000f,-0.61000000f,-0.63000000f,0.18000000f,0.04000000f,-0.31000000f,0.47000000f,-0.72000000f,0.57000000f,-0.69000000f,-0.30000000f,0.32000000f,0.38000000f,-0.31000000f,-0.05000000f,0.83000000f,-0.17000000f,0.40000000f,0.33000000f,-0.27000000f,0.09000000f,0.85000000f,-0.99000000f,-0.96000000f,-0.57000000f,-0.56000000f,-0.73000000f,0.69000000f,0.42000000f,-0.89000000f,-0.24000000f,0.99000000f,-0.18000000f,0.91000000f,-0.66000000f,-0.63000000f,-0.24000000f,-0.24000000f,-0.63000000f,0.80000000f,0.96000000f,0.94000000f,0.59000000f,-0.76000000f,0.26000000f,0.74000000f,-0.89000000f,0.50000000f,0.16000000f,0.21000000f,-0.48000000f,0.32000000f,-0.33000000f,0.13000000f,-0.61000000f,-0.01000000f,0.63000000f,-0.62000000f,0.45000000f,-0.03000000f,-0.25000000f,0.33000000f,0.09000000f,-0.96000000f,0.00000000f,-0.63000000f,0.41000000f,0.48000000f,0.90000000f,-0.61000000f,0.98000000f,-0.02000000f,-0.45000000f,-0.28000000f,0.14000000f,-0.22000000f,-0.68000000f,-0.46000000f,0.64000000f,-0.95000000f,-0.31000000f,-0.24000000f,0.88000000f,0.34000000f,-0.34000000f,-0.42000000f,0.56000000f,-0.40000000f,-0.27000000f,-0.09000000f,-0.78000000f,0.84000000f,0.25000000f,0.34000000f,-0.74000000f,0.46000000f,-0.95000000f,0.05000000f,-0.72000000f,-0.15000000f,0.12000000f,0.49000000f,-0.74000000f,0.91000000f,0.65000000f,0.89000000f,-0.33000000f,-0.57000000f,-0.49000000f,-0.19000000f,-0.08000000f,-0.36000000f,0.74000000f,-0.48000000f,0.07000000f,0.09000000f,-0.48000000f,-0.16000000f,0.65000000f,-0.29000000f,-0.13000000f,0.04000000f,0.37000000f,-0.66000000f,0.06000000f,-0.38000000f,0.10000000f,0.07000000f,0.92000000f,-0.41000000f,-0.17000000f,0.99000000f,0.36000000f,-0.38000000f,0.21000000f,0.66000000f,-0.25000000f,-0.32000000f,-0.31000000f,0.85000000f,-0.47000000f,-0.38000000f,-0.40000000f,-0.10000000f,0.08000000f,0.27000000f,-0.50000000f,-0.31000000f,0.96000000f,0.51000000f,-0.83000000f,0.63000000f,0.65000000f,-0.70000000f,0.09000000f,-0.48000000f,0.48000000f,0.22000000f,0.72000000f,-0.90000000f,-0.06000000f,0.19000000f,-0.16000000f,0.41000000f,-0.69000000f,-0.16000000f,-0.71000000f,0.78000000f,-0.83000000f,-0.76000000f,-0.20000000f,-0.81000000f,0.64000000f,-0.49000000f,0.08000000f,-0.15000000f,-0.33000000f,0.77000000f,0.51000000f,-0.24000000f,-0.08000000f,0.82000000f,-0.58000000f,0.64000000f,0.49000000f,-0.18000000f,0.43000000f,-0.54000000f,-0.85000000f,-0.24000000f,-0.71000000f,-0.90000000f,0.69000000f,-0.73000000f,0.72000000f,0.47000000f,-0.42000000f,-0.75000000f,-0.51000000f,0.80000000f,0.18000000f,-0.08000000f,-0.41000000f,0.61000000f,-0.31000000f,-0.39000000f,0.97000000f,-0.32000000f,0.51000000f,-0.61000000f,-0.35000000f,0.10000000f,-0.08000000f,-0.28000000f,-0.04000000f,0.94000000f,0.71000000f,0.61000000f,-0.13000000f,0.21000000f,0.96000000f,-0.61000000f,0.85000000f,-0.55000000f,0.96000000f,-0.18000000f,-0.05000000f,-0.85000000f,-0.60000000f,0.92000000f,-0.88000000f,-0.71000000f,-0.40000000f,0.14000000f,0.69000000f,-0.21000000f,0.63000000f,0.86000000f,0.44000000f,-0.25000000f,-0.23000000f,-0.05000000f,-0.29000000f,0.89000000f,-0.53000000f,-0.06000000f,0.03000000f,0.36000000f,-0.83000000f,0.79000000f,-0.40000000f,-0.10000000f,0.90000000f,-0.92000000f,-0.49000000f,-0.38000000f,-0.43000000f,0.02000000f,0.98000000f,-0.99000000f,0.13000000f,-0.75000000f,-0.99000000f,-0.37000000f,0.52000000f,-0.20000000f,-0.56000000f,-0.38000000f,0.80000000f,-0.45000000f,0.13000000f,0.71000000f,-0.60000000f,-0.46000000f,-0.90000000f,0.83000000f,-0.01000000f,-0.47000000f,0.08000000f,-0.52000000f,-0.27000000f,-0.83000000f,-0.06000000f,-0.26000000f,-0.43000000f,0.02000000f,0.71000000f,0.26000000f,-0.39000000f,-0.20000000f,-0.12000000f,0.95000000f,0.15000000f,0.71000000f,-0.82000000f,-0.91000000f,-0.98000000f,0.99000000f,0.60000000f,-0.20000000f,-0.89000000f,-0.33000000f,-0.22000000f,0.25000000f,0.04000000f,0.74000000f,-0.92000000f,-0.19000000f,-0.23000000f,0.84000000f,0.34000000f,0.83000000f,0.41000000f,0.77000000f,0.24000000f,0.32000000f,-0.31000000f,-0.36000000f,-0.08000000f,0.58000000f,-0.45000000f,0.63000000f,-0.28000000f,0.15000000f,-0.19000000f,0.58000000f,0.67000000f,-0.21000000f,-0.79000000f,0.23000000f,-0.33000000f,-0.05000000f,-0.60000000f,-0.09000000f,-0.98000000f,0.73000000f,-0.36000000f,0.18000000f,0.70000000f,0.86000000f,-0.18000000f,-0.36000000f,0.06000000f,-0.30000000f,-0.48000000f,-0.08000000f,0.70000000f,0.57000000f,0.00000000f,0.95000000f,0.69000000f,-0.70000000f,-0.98000000f,-0.30000000f,-0.78000000f,-0.63000000f,-0.91000000f,0.83000000f,0.72000000f,0.45000000f,-0.50000000f,-0.30000000f,-0.41000000f,-0.17000000f,-0.39000000f,-0.65000000f,-0.97000000f,0.25000000f,-0.03000000f,-0.38000000f,-0.24000000f,0.42000000f,0.27000000f,-0.18000000f,0.50000000f,-0.04000000f,-0.33000000f,-0.54000000f,0.69000000f,-0.97000000f,0.45000000f,0.03000000f,0.78000000f,0.83000000f,-0.91000000f,-0.37000000f,-0.55000000f,-0.28000000f,-0.15000000f,-0.19000000f,0.38000000f,0.11000000f,-0.39000000f,-0.63000000f,0.84000000f,-0.19000000f,0.61000000f,-0.36000000f,0.34000000f,-0.54000000f,-0.68000000f,-0.68000000f,0.47000000f,-0.08000000f,0.79000000f,0.21000000f,-0.50000000f,-0.18000000f,-0.40000000f,0.80000000f,0.00000000f,-0.40000000f,-0.90000000f,-0.52000000f,-0.21000000f,-0.10000000f,0.99000000f,0.97000000f,-0.71000000f,-0.98000000f,-0.80000000f,0.20000000f,0.73000000f,0.95000000f,-0.47000000f,0.52000000f,0.98000000f,0.01000000f,0.16000000f,-0.50000000f,0.43000000f,0.51000000f,0.81000000f,0.69000000f,-0.34000000f,-0.49000000f,-0.92000000f,0.68000000f,0.79000000f,-0.56000000f,-0.46000000f,0.69000000f,0.51000000f,-0.45000000f,-0.30000000f,0.95000000f,-0.46000000f,-0.88000000f,-0.92000000f,-0.69000000f,0.91000000f,-0.62000000f,-0.58000000f,0.70000000f,0.51000000f,-0.70000000f,-0.87000000f,-0.01000000f,-0.64000000f,-0.22000000f,-0.81000000f,-0.65000000f,-0.55000000f,-0.06000000f,0.84000000f,0.54000000f,0.29000000f,-0.85000000f,-0.99000000f,0.87000000f,0.98000000f,0.61000000f,0.64000000f,0.25000000f,0.87000000f,0.89000000f,0.48000000f,-0.25000000f,-0.78000000f,-0.77000000f,0.49000000f,0.53000000f,-0.06000000f,-0.93000000f,0.21000000f,0.92000000f,-0.51000000f,0.55000000f,0.83000000f,0.14000000f,0.17000000f,0.42000000f,-0.09000000f,0.52000000f,0.95000000f,0.46000000f,0.81000000f,-0.75000000f,0.88000000f,0.99000000f,-0.53000000f,-0.93000000f,-0.46000000f,-0.67000000f,0.61000000f,-0.02000000f,-0.57000000f,-0.58000000f,0.09000000f,0.29000000f,0.27000000f,0.73000000f,0.90000000f,-0.72000000f,-0.68000000f,-0.00000000f,0.64000000f,0.24000000f,0.18000000f,0.73000000f,0.03000000f,-0.06000000f,-0.84000000f,-0.07000000f,-0.25000000f,-0.61000000f,0.71000000f,-0.10000000f,-0.27000000f,-0.83000000f,0.24000000f,-0.11000000f,-0.97000000f,-0.99000000f,0.13000000f,-0.84000000f,-0.51000000f,0.85000000f,-0.11000000f,-0.67000000f,0.45000000f,0.95000000f,0.76000000f,-0.63000000f,0.95000000f,-0.68000000f,-0.15000000f,0.77000000f,-0.44000000f,0.10000000f,0.11000000f,0.76000000f,0.56000000f,0.48000000f,0.35000000f,-0.11000000f,-0.16000000f,-0.00000000f,0.63000000f,-0.01000000f,0.51000000f,0.13000000f,-0.28000000f,-0.01000000f,0.58000000f,0.89000000f,-0.69000000f,0.43000000f,-0.90000000f,0.28000000f,0.86000000f,0.93000000f,0.22000000f,-0.16000000f,0.47000000f,0.33000000f,-0.56000000f,0.12000000f,-0.26000000f,-0.72000000f,-0.51000000f,0.24000000f,-0.19000000f,-0.88000000f,-0.70000000f,0.45000000f,-0.93000000f,-0.61000000f,-0.76000000f,-0.49000000f,0.27000000f,-0.11000000f,-0.06000000f,0.10000000f,0.04000000f,0.62000000f,0.51000000f,-0.27000000f,-0.19000000f,0.90000000f,-0.39000000f,0.18000000f,-0.10000000f,0.84000000f,0.53000000f,-0.71000000f,0.17000000f,0.29000000f,0.72000000f,-0.80000000f,0.27000000f,0.57000000f,-0.53000000f,-0.95000000f,0.88000000f,0.84000000f,0.09000000f,0.11000000f,-0.13000000f,-0.64000000f,-0.36000000f,-0.48000000f,0.82000000f,0.08000000f,-0.35000000f,0.03000000f,0.76000000f,0.14000000f,0.79000000f,-0.94000000f,-0.35000000f,0.89000000f,-0.25000000f,-0.48000000f,0.37000000f,0.82000000f,-0.30000000f,0.57000000f,0.94000000f,0.47000000f,0.17000000f,-0.39000000f,-0.62000000f,0.65000000f,0.37000000f,0.41000000f,-0.85000000f,0.74000000f,-0.59000000f,0.44000000f,-0.63000000f,0.45000000f,0.90000000f,0.99000000f,-0.73000000f,-0.03000000f,0.00000000f,0.49000000f,-0.29000000f,-0.63000000f,0.59000000f,0.24000000f,0.66000000f,-0.05000000f,0.06000000f,-0.95000000f,0.06000000f,0.62000000f,-0.83000000f,-0.46000000f,-0.25000000f,-0.35000000f,-0.91000000f,0.07000000f,-0.77000000f,0.54000000f,-0.82000000f,0.82000000f,0.68000000f,0.49000000f,-0.63000000f,-0.36000000f,-0.31000000f,-0.48000000f,-0.95000000f,-0.55000000f,-0.62000000f,0.52000000f,0.26000000f,-0.39000000f,0.45000000f,-0.09000000f,-0.07000000f,0.56000000f,0.32000000f,0.37000000f,0.57000000f,-0.83000000f,-0.90000000f,0.03000000f,0.47000000f,0.97000000f,0.26000000f,0.37000000f,-0.24000000f,0.72000000f,0.38000000f,-0.73000000f,0.86000000f,0.88000000f,-0.59000000f,0.17000000f,-0.80000000f,-0.86000000f,0.64000000f,0.83000000f,-0.15000000f,-0.31000000f,-0.87000000f,0.92000000f,-0.24000000f,0.45000000f,0.42000000f,-0.61000000f,-0.37000000f,0.02000000f,0.82000000f,0.84000000f,0.06000000f,0.67000000f,-0.12000000f,0.11000000f,0.94000000f,-0.81000000f,0.75000000f,-0.04000000f,0.72000000f,-0.50000000f,0.30000000f,0.90000000f,0.93000000f,-0.05000000f,-0.10000000f,-0.02000000f,0.51000000f,0.03000000f,-0.67000000f,0.18000000f,0.37000000f,0.65000000f,-0.20000000f,-0.45000000f,0.52000000f,0.46000000f,0.95000000f,-0.78000000f,0.20000000f,0.54000000f,0.92000000f,-0.64000000f,0.51000000f,0.63000000f,-0.58000000f,-0.50000000f,-0.40000000f,0.82000000f,0.15000000f,0.15000000f,0.21000000f,0.01000000f,0.89000000f,0.10000000f,-0.05000000f,-0.92000000f,-0.18000000f,0.30000000f,0.00000000f,-0.12000000f,0.71000000f,-0.58000000f,0.15000000f,0.17000000f,-0.31000000f,-0.36000000f,0.95000000f,-0.21000000f,-0.82000000f,-0.31000000f,-0.78000000f,-0.17000000f,0.47000000f,-0.41000000f,0.90000000f,0.75000000f,0.28000000f,0.57000000f,0.16000000f,-0.73000000f,0.66000000f,-0.27000000f,0.76000000f,-0.74000000f,0.35000000f,-0.21000000f,0.39000000f,-0.70000000f,-0.31000000f,-0.14000000f,-0.85000000f,0.80000000f,0.58000000f,-0.43000000f,0.02000000f,0.01000000f,0.31000000f,-0.89000000f,-0.06000000f,0.04000000f,0.28000000f,-0.00000000f,0.74000000f,0.32000000f,0.66000000f,-0.98000000f,-0.53000000f,-0.40000000f,-0.94000000f,0.35000000f,0.53000000f,-0.57000000f,0.60000000f,0.86000000f,-0.94000000f,-0.67000000f,0.95000000f,-0.35000000f,-0.79000000f,0.56000000f,0.10000000f,-0.28000000f,-0.53000000f,-0.27000000f,0.25000000f,0.83000000f,0.77000000f,0.18000000f,-0.33000000f,0.49000000f,-0.64000000f,0.57000000f,0.80000000f,0.98000000f,0.56000000f,0.03000000f,0.58000000f,0.76000000f,0.87000000f,0.61000000f,0.91000000f,-0.30000000f,-0.60000000f,-0.76000000f,-0.30000000f,0.23000000f,0.06000000f,0.03000000f,0.72000000f,0.11000000f,-0.23000000f,-0.21000000f,-0.20000000f,-0.44000000f,0.78000000f,0.15000000f,0.87000000f,-0.31000000f,0.43000000f,-0.05000000f,-0.16000000f,0.04000000f,-0.79000000f,0.87000000f,0.09000000f,0.32000000f,-0.58000000f,0.65000000f,-0.62000000f,0.23000000f,0.20000000f,-0.29000000f,0.88000000f,-0.58000000f,-0.03000000f,-0.33000000f,-0.48000000f,0.27000000f,0.47000000f,0.81000000f,0.91000000f,-0.41000000f,0.67000000f,-0.94000000f,0.31000000f,0.25000000f,-0.00000000f,0.99000000f,-0.06000000f,0.22000000f,-0.19000000f,0.53000000f,-0.62000000f,-0.63000000f,0.28000000f,-0.49000000f,0.37000000f,-0.69000000f,0.59000000f,-0.30000000f,0.57000000f,0.52000000f,0.55000000f,-0.67000000f,-0.15000000f,0.71000000f,0.11000000f,-0.34000000f,-0.06000000f,0.10000000f,0.70000000f,0.98000000f,0.52000000f,0.16000000f,0.87000000f,-0.62000000f,-0.58000000f,0.57000000f,0.65000000f,-0.35000000f,-0.31000000f,0.96000000f,0.21000000f,0.31000000f,-0.82000000f,0.14000000f,0.57000000f,0.24000000f,-0.26000000f,0.77000000f,-0.09000000f,0.20000000f,0.40000000f,0.12000000f,-0.17000000f,0.65000000f,0.64000000f,-0.63000000f,-0.75000000f,0.50000000f,0.31000000f,-0.06000000f,-0.19000000f,-0.63000000f,0.69000000f,-0.54000000f,0.27000000f,0.95000000f,-0.44000000f,0.18000000f,-0.91000000f,-0.02000000f,0.77000000f,-0.66000000f,-0.33000000f,-0.20000000f,-0.22000000f,0.65000000f,0.31000000f,-0.00000000f,-0.26000000f,0.07000000f,0.05000000f,-0.47000000f,-0.52000000f,-0.06000000f,0.49000000f,0.65000000f,0.54000000f,0.10000000f,-0.10000000f,-0.56000000f,-0.87000000f,0.35000000f,-0.51000000f,0.90000000f,-0.04000000f,-0.90000000f,-0.16000000f,-0.75000000f,-0.06000000f,-0.04000000f,-0.11000000f,0.44000000f,0.73000000f,0.72000000f,0.80000000f,0.73000000f,-0.95000000f,0.83000000f,0.72000000f,0.46000000f,-0.94000000f,-0.56000000f,0.00000000f,-0.41000000f,-0.66000000f,0.56000000f,0.92000000f,-0.23000000f,-0.32000000f,-0.16000000f,-0.04000000f,-0.37000000f,-0.81000000f,-0.29000000f,-0.79000000f,-0.45000000f,-0.37000000f,0.65000000f,-0.07000000f,-0.97000000f,-0.93000000f,0.15000000f,0.01000000f,-0.90000000f,0.05000000f,-0.63000000f,0.43000000f,-0.67000000f,0.04000000f,0.86000000f,-0.64000000f,0.80000000f,0.66000000f,-0.02000000f,0.84000000f,-0.46000000f,0.19000000f,-0.42000000f,-0.20000000f,0.86000000f,0.12000000f,0.32000000f,-0.72000000f,-0.40000000f,-0.32000000f,-0.26000000f,0.85000000f,-0.40000000f,0.15000000f,-0.69000000f,-0.77000000f,-0.48000000f,-0.10000000f,-0.16000000f,0.61000000f,-0.12000000f,-0.76000000f,0.21000000f,-0.15000000f,-0.15000000f,0.00000000f,-0.31000000f,0.74000000f,-0.12000000f,0.75000000f,-0.31000000f,0.89000000f,0.75000000f,-0.17000000f,-0.58000000f,-0.33000000f,-0.72000000f,-0.43000000f,-0.36000000f,-0.74000000f,-0.17000000f,-0.61000000f,-0.53000000f,0.62000000f,-0.24000000f,-0.37000000f,-0.16000000f,-0.74000000f,0.39000000f,-0.41000000f,0.57000000f,-0.64000000f,-0.51000000f,0.65000000f,0.40000000f,0.65000000f,-0.04000000f,-0.08000000f,0.30000000f,-0.86000000f,0.37000000f,-0.49000000f,0.24000000f,0.36000000f,-0.66000000f,0.53000000f,-0.42000000f,0.47000000f,-0.10000000f,-0.41000000f,-0.92000000f,-0.88000000f,0.90000000f,0.59000000f,0.00000000f,0.70000000f,-0.55000000f,0.45000000f,0.81000000f,0.42000000f,-0.81000000f,-0.90000000f,-0.66000000f,0.47000000f,-0.49000000f,-0.21000000f,-0.71000000f,-0.62000000f,0.20000000f,-0.90000000f,-0.49000000f,-0.83000000f,-0.94000000f,0.16000000f,0.04000000f,0.84000000f,-0.49000000f,-0.23000000f,-0.75000000f,-0.13000000f,0.91000000f,0.36000000f,-0.51000000f,0.56000000f,-0.26000000f,-0.34000000f,-0.27000000f,0.13000000f,0.45000000f,-0.89000000f,0.69000000f,-0.42000000f,0.49000000f,-0.93000000f,0.46000000f,0.68000000f,0.63000000f,-0.86000000f,-0.26000000f,0.14000000f,-0.29000000f,0.80000000f,-0.74000000f,0.73000000f,0.19000000f,-0.26000000f,0.01000000f,-0.71000000f,-0.54000000f,-0.64000000f,-0.59000000f,-0.37000000f,0.76000000f,0.15000000f,0.90000000f,-0.28000000f,0.59000000f,0.16000000f,-0.55000000f,0.48000000f,-0.49000000f,-0.43000000f,0.56000000f,-0.30000000f,0.12000000f,0.08000000f,-0.28000000f,0.78000000f,0.73000000f,-0.06000000f,0.13000000f,0.31000000f,-0.30000000f,0.90000000f,0.39000000f,-0.77000000f,-0.89000000f,0.91000000f,-0.09000000f,0.76000000f,0.30000000f,-0.80000000f,0.31000000f,-0.94000000f,0.88000000f,-0.38000000f,-0.10000000f,0.02000000f,-0.93000000f,-0.27000000f,0.83000000f,-0.33000000f,-0.55000000f,0.04000000f,-0.31000000f,-0.21000000f,-0.38000000f,-0.04000000f,-0.21000000f,-0.58000000f,0.57000000f,-0.50000000f,0.45000000f,-0.88000000f,-0.95000000f,0.66000000f,-0.15000000f,-0.65000000f,0.04000000f,-0.91000000f,-0.02000000f,-0.40000000f,0.60000000f,0.17000000f,0.07000000f,-0.11000000f,-0.55000000f,0.36000000f,0.47000000f,0.09000000f,0.37000000f,0.75000000f,-0.98000000f,-0.39000000f,0.79000000f,0.61000000f,-0.75000000f,0.51000000f,-0.49000000f,-0.99000000f,-0.72000000f,-0.56000000f,0.97000000f,-0.42000000f,0.06000000f,-0.14000000f,-0.96000000f,-0.28000000f,-0.48000000f,0.99000000f,0.64000000f,-0.12000000f,0.63000000f,-0.95000000f,-0.09000000f,-0.81000000f,0.83000000f,0.99000000f,-0.01000000f,0.17000000f,0.03000000f,-0.52000000f,0.20000000f,0.77000000f,-0.42000000f,0.96000000f,0.79000000f,-0.64000000f,-0.29000000f,-0.84000000f,-0.79000000f,0.83000000f,-0.88000000f,-0.24000000f,0.22000000f,0.55000000f,0.16000000f,-0.85000000f,0.49000000f,0.61000000f,-0.79000000f,-0.75000000f,0.27000000f,0.36000000f,0.36000000f,-0.98000000f,-0.34000000f,0.13000000f,0.38000000f,-0.25000000f,0.74000000f,0.08000000f,0.46000000f,0.13000000f,0.32000000f,0.78000000f,0.44000000f,0.11000000f,-0.57000000f,-0.34000000f,-0.92000000f,-0.03000000f,-0.74000000f,-0.06000000f,0.30000000f,-0.51000000f,0.06000000f,0.74000000f,0.13000000f,0.34000000f,0.05000000f,0.81000000f,0.43000000f,0.80000000f,-0.77000000f,-0.54000000f,0.59000000f,-0.05000000f,0.14000000f,0.29000000f,-0.70000000f,-0.12000000f,0.03000000f,-0.04000000f,-0.07000000f,-0.84000000f,0.86000000f,0.87000000f,-0.24000000f,0.02000000f,0.71000000f,0.31000000f,-0.62000000f,0.62000000f,-0.65000000f,0.26000000f,0.47000000f,0.57000000f,0.84000000f,0.32000000f,0.54000000f,-0.50000000f,0.93000000f,-0.91000000f,0.35000000f,-0.74000000f,-0.56000000f,-0.46000000f,-0.78000000f,-0.60000000f,-0.89000000f,-0.88000000f,-0.16000000f,-0.83000000f,-0.63000000f,0.59000000f,0.85000000f,0.32000000f,0.74000000f,0.84000000f,-0.83000000f,-0.46000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.95000000f,0.99000000f,-0.87000000f,-0.28000000f,0.66000000f,-0.58000000f,0.20000000f,-0.17000000f,-0.95000000f,0.23000000f,0.86000000f,-0.81000000f,0.93000000f,0.38000000f,0.49000000f,0.68000000f,-0.91000000f,-0.58000000f,-0.41000000f,0.31000000f,0.23000000f,0.92000000f,0.71000000f,0.33000000f,0.18000000f,-0.33000000f,0.64000000f,0.75000000f,-0.72000000f,0.70000000f,-0.49000000f,-0.49000000f,-0.18000000f,-0.59000000f,-0.23000000f,0.71000000f,0.42000000f,-0.53000000f,-0.83000000f,-0.04000000f,-0.75000000f,-0.77000000f,-0.59000000f,0.53000000f,-0.30000000f,0.22000000f,-0.78000000f,0.64000000f,-0.64000000f,-0.37000000f,0.79000000f,0.72000000f,-0.06000000f,0.94000000f,0.93000000f,-0.75000000f,0.90000000f,-0.79000000f,0.96000000f,0.28000000f,-0.74000000f,0.70000000f,-0.81000000f,0.18000000f,-0.96000000f,0.84000000f,-0.18000000f,0.05000000f,-0.23000000f,0.26000000f,-0.85000000f,-0.12000000f,0.50000000f,0.12000000f,-0.94000000f,0.64000000f,0.86000000f,0.81000000f,0.89000000f,-0.62000000f,0.74000000f,-0.19000000f,-0.78000000f,0.67000000f,-0.04000000f,0.36000000f,0.62000000f,-0.02000000f,-0.49000000f,0.72000000f,-0.02000000f,0.42000000f,-0.78000000f,0.79000000f,0.26000000f,-0.63000000f,-0.31000000f,-0.38000000f,-0.37000000f,-0.43000000f,-0.97000000f,0.27000000f,-0.34000000f,-0.59000000f,-0.07000000f,0.44000000f,-0.62000000f,-0.64000000f,-0.09000000f,-0.70000000f,-0.11000000f,-0.89000000f,-0.35000000f,0.49000000f,-0.73000000f,-0.89000000f,0.76000000f,0.90000000f,0.04000000f,0.44000000f,0.58000000f,0.18000000f,-0.06000000f,0.68000000f,0.14000000f,-0.48000000f,-0.15000000f,-0.53000000f,-0.31000000f,0.37000000f,0.71000000f,-0.10000000f,-0.83000000f,-0.88000000f,-0.26000000f,-0.88000000f,0.82000000f,-0.04000000f,0.84000000f,-0.92000000f,-0.10000000f,0.00000000f,0.18000000f,0.21000000f,0.74000000f,-0.25000000f,0.88000000f,-0.75000000f,-0.47000000f,0.72000000f,-0.54000000f,0.04000000f,0.10000000f,0.29000000f,0.20000000f,0.08000000f,-0.17000000f,0.71000000f,-0.46000000f,0.96000000f,-0.21000000f,0.10000000f,0.58000000f,0.65000000f,0.06000000f,0.58000000f,0.68000000f,0.27000000f,-0.07000000f,-0.05000000f,0.97000000f,0.25000000f,-0.42000000f,-0.59000000f,0.42000000f,0.87000000f,-0.06000000f,-0.61000000f,0.06000000f,0.84000000f,0.58000000f,-0.68000000f,0.65000000f,0.40000000f,-0.32000000f,-0.38000000f,0.93000000f,0.58000000f,-0.65000000f,0.73000000f,0.96000000f,-0.97000000f,0.08000000f,0.80000000f,0.39000000f,-0.21000000f,-0.47000000f,0.56000000f,-0.17000000f,-0.46000000f,-0.52000000f,-0.27000000f,0.76000000f,0.60000000f,-0.41000000f,-0.73000000f,0.93000000f,-0.06000000f,0.30000000f,-0.64000000f,-0.02000000f,-0.23000000f,0.08000000f,0.72000000f,-0.58000000f,-0.29000000f,-0.49000000f,0.85000000f,-0.42000000f,0.40000000f,-0.37000000f,-0.74000000f,0.51000000f,-0.52000000f,-0.52000000f,-0.63000000f,-0.66000000f,0.81000000f,-0.39000000f,0.33000000f,-0.46000000f,-0.76000000f,-0.06000000f,0.45000000f,-0.05000000f,-0.64000000f,0.42000000f,0.76000000f,-0.55000000f,-0.98000000f,0.78000000f,-0.82000000f,-0.25000000f,0.24000000f,0.35000000f,0.68000000f,-0.68000000f,0.28000000f,0.60000000f,-0.50000000f,0.20000000f,0.15000000f,-0.92000000f,0.09000000f,-0.99000000f,0.49000000f,0.24000000f,0.69000000f,-0.50000000f,0.47000000f,0.94000000f,-0.30000000f,0.96000000f,-0.45000000f,-0.57000000f,0.25000000f,0.77000000f,0.82000000f,-0.88000000f,-0.33000000f,-0.32000000f,-0.65000000f,-0.85000000f,0.83000000f,0.06000000f,0.71000000f,0.53000000f,-0.42000000f,0.25000000f,-0.50000000f,-0.02000000f,0.76000000f,-0.13000000f,0.39000000f,-0.99000000f,-0.20000000f,0.20000000f,-0.80000000f,-0.59000000f,-0.59000000f,0.13000000f,0.57000000f,0.55000000f,0.44000000f,-0.11000000f,0.30000000f,-0.16000000f,0.78000000f,-0.91000000f,0.02000000f,0.68000000f,0.59000000f,-0.28000000f,-0.79000000f,0.48000000f,-0.17000000f,-0.86000000f,-0.68000000f,0.96000000f,-0.61000000f,-0.69000000f,0.95000000f,0.81000000f,-0.89000000f,0.02000000f,0.97000000f,-0.13000000f,-0.10000000f,0.07000000f,0.67000000f,0.30000000f,-0.26000000f,-0.07000000f,-0.55000000f,-0.58000000f,-0.81000000f,0.06000000f,0.65000000f,0.97000000f,-0.29000000f,0.85000000f,-0.49000000f,-0.01000000f,-0.90000000f,0.23000000f,-0.39000000f,-0.71000000f,0.28000000f,0.38000000f,-0.26000000f,0.19000000f,-0.94000000f,0.38000000f,-0.80000000f,0.15000000f,-0.59000000f,0.18000000f,0.87000000f,-0.54000000f,-0.65000000f,0.47000000f,0.74000000f,0.43000000f,0.30000000f,0.99000000f,-0.66000000f,0.89000000f,-0.72000000f,0.25000000f,0.73000000f,-0.26000000f,-0.60000000f,0.10000000f,0.55000000f,-0.86000000f,-0.96000000f,-0.54000000f,-0.81000000f,0.84000000f,0.67000000f,0.34000000f,0.98000000f,-0.50000000f,-0.64000000f,-0.40000000f,-0.61000000f,-0.72000000f,-0.68000000f,0.80000000f,-0.15000000f,-0.99000000f,-0.79000000f,0.71000000f,-0.66000000f,-0.11000000f,0.06000000f,0.24000000f,-0.58000000f,0.60000000f,-0.21000000f,0.24000000f,-0.75000000f,-0.12000000f,-0.91000000f,-0.67000000f,-0.19000000f,-0.47000000f,-0.87000000f,0.40000000f,0.42000000f,0.69000000f,-0.61000000f,-0.98000000f,-0.63000000f,0.97000000f,0.05000000f,-0.19000000f,-0.47000000f,0.41000000f,-0.45000000f,0.94000000f,0.85000000f,-0.10000000f,0.09000000f,0.00000000f,0.20000000f,0.49000000f,-0.81000000f,0.31000000f,0.94000000f,-0.41000000f,-0.71000000f,0.99000000f,0.82000000f,-0.34000000f,-0.08000000f,0.85000000f,0.61000000f,-0.93000000f,-0.54000000f,0.37000000f,-0.90000000f,-0.67000000f,-0.02000000f,-0.43000000f,-0.52000000f,-0.58000000f,-0.61000000f,0.81000000f,0.53000000f,0.86000000f,-0.09000000f,0.26000000f,0.23000000f,-0.76000000f,-0.58000000f,-0.90000000f,0.33000000f,0.82000000f,-0.44000000f,0.18000000f,-0.18000000f,0.72000000f,0.74000000f,-0.84000000f,0.83000000f,-0.26000000f,-0.32000000f,-0.99000000f,-0.07000000f,0.57000000f,0.71000000f,-0.64000000f,0.56000000f,-0.08000000f,-0.78000000f,0.83000000f,-0.60000000f,-0.54000000f,-0.65000000f,0.26000000f,0.67000000f,0.10000000f,0.72000000f,-0.12000000f,0.71000000f,0.90000000f,-0.37000000f,-0.55000000f,-0.42000000f,-0.89000000f,0.87000000f,0.70000000f,0.47000000f,0.07000000f,0.46000000f,0.48000000f,0.53000000f,-0.95000000f,0.82000000f,0.35000000f,0.48000000f,0.99000000f,-0.64000000f,0.45000000f,-0.33000000f,0.94000000f,0.93000000f,0.55000000f,0.95000000f,0.23000000f,0.71000000f,0.42000000f,0.48000000f,-0.45000000f,0.54000000f,0.38000000f,0.58000000f,0.94000000f,0.82000000f,0.65000000f,-0.51000000f,0.53000000f,-0.47000000f,-0.78000000f,-0.51000000f,0.67000000f,0.72000000f,-0.20000000f,0.09000000f,0.41000000f,0.69000000f,0.21000000f,0.95000000f,-0.26000000f,0.23000000f,-0.04000000f,-0.30000000f,-0.18000000f,-0.78000000f,0.06000000f,0.04000000f,0.83000000f,-0.97000000f,-0.55000000f,-0.86000000f,-0.99000000f,-0.12000000f,0.17000000f,-0.50000000f,-0.77000000f,-0.20000000f,-0.47000000f,-0.95000000f,0.05000000f,-0.37000000f,0.88000000f,0.09000000f,-0.54000000f,-0.64000000f,-0.72000000f,0.57000000f,0.16000000f,-0.31000000f,-0.28000000f,-0.36000000f,0.71000000f,-0.82000000f,0.23000000f,0.88000000f,0.69000000f,0.99000000f,-0.99000000f,0.94000000f,0.24000000f,-0.45000000f,0.61000000f,0.85000000f,-0.92000000f,0.96000000f,0.98000000f,0.34000000f,0.03000000f,-0.25000000f,0.15000000f,-0.71000000f,0.48000000f,-0.02000000f,-0.29000000f,0.34000000f,0.48000000f,-0.14000000f,-0.46000000f,-0.32000000f,0.67000000f,0.04000000f,-0.90000000f,-0.82000000f,0.44000000f,-0.46000000f,-0.33000000f,0.63000000f,-0.46000000f,0.16000000f,0.02000000f,0.57000000f,-0.02000000f,0.50000000f,0.26000000f,0.51000000f,-0.15000000f,0.25000000f,0.07000000f,-0.59000000f,-0.87000000f,0.64000000f,-0.92000000f,0.05000000f,0.79000000f,0.14000000f,-0.34000000f,-0.77000000f,0.72000000f,0.53000000f,-0.42000000f,0.95000000f,-0.86000000f,-0.35000000f,0.90000000f,0.36000000f,0.25000000f,0.63000000f,0.59000000f,-0.32000000f,-0.95000000f,-0.98000000f,-0.84000000f,-0.56000000f,0.65000000f,-0.81000000f,-0.06000000f,-0.45000000f,-0.60000000f,-0.84000000f,0.09000000f,0.77000000f,0.17000000f,0.11000000f,-0.57000000f,-0.67000000f,-0.23000000f,-0.98000000f,0.12000000f,0.32000000f,0.35000000f,0.37000000f,-0.81000000f,-0.07000000f,-0.21000000f,0.72000000f,-0.35000000f,-0.02000000f,0.33000000f,0.58000000f,-0.52000000f,0.17000000f,-0.49000000f,0.30000000f,-0.30000000f,-0.78000000f,-0.38000000f,0.25000000f,0.14000000f,-0.20000000f,0.75000000f,-0.51000000f,0.46000000f,0.15000000f,-0.07000000f,0.19000000f,-0.47000000f,0.70000000f,-0.47000000f,-0.03000000f,0.14000000f,-0.25000000f,0.67000000f,0.83000000f,0.22000000f,-0.80000000f,0.15000000f,0.88000000f,0.42000000f,0.76000000f,-0.53000000f,0.85000000f,0.89000000f,0.92000000f,-0.73000000f,-0.88000000f,0.05000000f,0.09000000f,0.19000000f,0.55000000f,0.74000000f,-0.08000000f,0.41000000f,0.06000000f,-0.35000000f,0.66000000f,0.05000000f,0.36000000f,0.28000000f,0.77000000f,0.65000000f,0.94000000f,-0.28000000f,-0.31000000f,0.47000000f,-0.62000000f,-0.99000000f,0.90000000f,0.70000000f,0.88000000f,-0.68000000f,0.69000000f,-0.23000000f,-0.01000000f,0.97000000f,0.87000000f,0.55000000f,0.07000000f,0.59000000f,-0.16000000f,-0.05000000f,0.28000000f,-0.48000000f,0.56000000f,-0.64000000f,0.22000000f,0.55000000f,-0.66000000f,0.29000000f,0.12000000f,0.73000000f,-0.98000000f,-0.13000000f,-0.39000000f,0.33000000f,0.95000000f,0.38000000f,-0.34000000f,0.73000000f,0.25000000f,0.63000000f,0.13000000f,-0.18000000f,-0.23000000f,-0.68000000f,0.39000000f,0.65000000f,-0.08000000f,-0.96000000f,0.35000000f,-0.06000000f,0.81000000f,-0.34000000f,-0.91000000f,0.96000000f,-0.75000000f,0.61000000f,0.81000000f,-0.21000000f,0.21000000f,-0.89000000f,-0.13000000f,-0.92000000f,-0.11000000f,-0.25000000f,0.28000000f,0.31000000f,0.83000000f,0.96000000f,-0.13000000f,0.54000000f,0.95000000f,0.16000000f,0.49000000f,0.12000000f,0.13000000f,0.20000000f,0.37000000f,0.34000000f,0.87000000f,-0.11000000f,-0.28000000f,-0.05000000f,0.72000000f,-0.27000000f,0.44000000f,0.84000000f,-0.03000000f,0.69000000f,-0.79000000f,0.63000000f,0.81000000f,0.88000000f,0.98000000f,0.51000000f,-0.20000000f,0.54000000f,0.73000000f,-0.95000000f,-0.61000000f,0.33000000f,0.26000000f,0.51000000f,0.46000000f,0.43000000f,-0.04000000f,-0.29000000f,0.77000000f,0.34000000f,-0.43000000f,0.48000000f,0.42000000f,-0.14000000f,0.89000000f,-0.93000000f,-0.40000000f,0.77000000f,-0.04000000f,0.85000000f,0.98000000f,-0.26000000f,0.05000000f,-0.24000000f,-0.22000000f,-0.50000000f,-0.82000000f,-0.42000000f,0.63000000f,0.79000000f,-0.84000000f,-0.60000000f,0.20000000f,-0.41000000f,0.86000000f,0.51000000f,-0.17000000f,-0.20000000f,0.94000000f,-0.89000000f,-0.51000000f,-0.35000000f,0.73000000f,-0.53000000f,0.09000000f,0.49000000f,-0.72000000f,-0.47000000f,-0.72000000f,-0.58000000f,-0.28000000f,0.05000000f,-0.08000000f,-0.86000000f,-0.69000000f,-0.22000000f,-0.32000000f,0.17000000f,-0.58000000f,-0.49000000f,-0.62000000f,0.19000000f,-0.28000000f,-0.40000000f,-0.61000000f,0.75000000f,-0.87000000f,-0.96000000f,-0.47000000f,-0.04000000f,0.64000000f,0.80000000f,0.90000000f,-0.57000000f,0.40000000f,0.34000000f,-0.31000000f,-0.94000000f,0.79000000f,0.12000000f,0.55000000f,0.62000000f,0.44000000f,0.58000000f,-0.10000000f,-0.07000000f,0.35000000f,0.73000000f,0.42000000f,-0.05000000f,-0.16000000f,0.89000000f,-0.05000000f,-0.22000000f,-0.25000000f,-0.81000000f,-0.57000000f,0.78000000f,0.49000000f,0.06000000f,0.87000000f,0.61000000f,-0.01000000f,0.77000000f,0.63000000f,-0.15000000f,-0.17000000f,-0.42000000f,-0.59000000f,0.64000000f,0.85000000f,-0.70000000f,0.03000000f,-0.58000000f,0.25000000f,0.31000000f,0.72000000f,0.26000000f,-0.83000000f,-0.37000000f,-0.10000000f,-0.30000000f,-0.75000000f,-0.54000000f,0.13000000f,0.10000000f,0.75000000f,-0.66000000f,-0.73000000f,-0.41000000f,0.15000000f,0.51000000f,-0.72000000f,0.76000000f,0.98000000f,-0.41000000f,0.61000000f,-0.67000000f,-0.82000000f,-0.90000000f,0.57000000f,0.57000000f,0.82000000f,0.50000000f,0.74000000f,-0.06000000f,-0.19000000f,-0.49000000f,0.71000000f,0.82000000f,0.19000000f,-0.04000000f,0.55000000f,0.03000000f,0.59000000f,-0.65000000f,0.99000000f,0.74000000f,0.81000000f,-0.59000000f,-0.60000000f,0.73000000f,0.47000000f,0.73000000f,0.72000000f,-0.33000000f,0.29000000f,0.66000000f,0.72000000f,-0.21000000f,-0.90000000f,0.69000000f,0.40000000f,0.67000000f,0.07000000f,-0.39000000f,0.34000000f,0.94000000f,0.56000000f,0.61000000f,0.24000000f,-0.76000000f,0.53000000f,-0.15000000f,-0.70000000f,0.93000000f,0.42000000f,-0.12000000f,-0.50000000f,0.67000000f,-0.55000000f,0.73000000f,0.46000000f,-0.74000000f,0.90000000f,-0.68000000f,0.57000000f,-0.62000000f,-0.19000000f,-0.57000000f,0.37000000f,0.81000000f,-0.84000000f,0.73000000f,0.20000000f,-0.89000000f,-0.55000000f,0.01000000f,-0.12000000f,0.24000000f,-0.14000000f,-0.35000000f,0.99000000f,0.40000000f,0.11000000f,-0.83000000f,-0.25000000f,0.84000000f,0.89000000f,-0.51000000f,0.75000000f,0.44000000f,0.45000000f,-0.18000000f,-0.70000000f,0.83000000f,0.02000000f,-0.84000000f,0.46000000f,-0.83000000f,-0.02000000f,0.10000000f,0.44000000f,0.53000000f,-0.96000000f,0.70000000f,0.55000000f,0.37000000f,0.84000000f,-0.64000000f,-0.06000000f,0.94000000f,-0.58000000f,-0.83000000f,0.92000000f,0.11000000f,0.34000000f,-0.67000000f,-0.42000000f,-0.27000000f,-0.55000000f,-0.97000000f,-0.92000000f,-0.81000000f,-0.21000000f,-0.40000000f,0.73000000f,0.49000000f,0.60000000f,-0.56000000f,0.95000000f,-0.09000000f,-0.20000000f,-0.88000000f,-0.09000000f,-0.70000000f,-0.30000000f,-0.85000000f,-0.39000000f,0.94000000f,0.06000000f,0.06000000f,-0.09000000f,0.05000000f,0.61000000f,0.51000000f,0.60000000f,-0.78000000f,-0.89000000f,0.92000000f,-0.03000000f,-0.03000000f,0.41000000f,-0.10000000f,0.97000000f,0.67000000f,0.92000000f,0.70000000f,-0.22000000f,0.63000000f,0.77000000f,-0.46000000f,0.25000000f,0.17000000f,0.00000000f,-0.14000000f,-0.87000000f,0.49000000f,0.99000000f,0.42000000f,-0.67000000f,0.61000000f,0.34000000f,0.25000000f,-0.71000000f,-0.18000000f,0.24000000f,-0.27000000f,0.24000000f,-0.06000000f,-0.05000000f,-0.08000000f,0.70000000f,-0.19000000f,-0.29000000f,0.41000000f,0.78000000f,0.08000000f,-0.88000000f,0.39000000f,0.33000000f,-0.50000000f,0.00000000f,-0.35000000f,0.56000000f,-0.85000000f,0.06000000f,-0.02000000f,-0.91000000f,-0.58000000f,0.18000000f,0.66000000f,0.46000000f,0.96000000f,0.90000000f,0.74000000f,-0.17000000f,-0.80000000f,-0.38000000f,-0.01000000f,0.25000000f,-0.53000000f,0.21000000f,0.26000000f,-0.63000000f,-0.78000000f,0.32000000f,0.42000000f,-0.60000000f,-0.31000000f,-0.93000000f,0.36000000f,0.41000000f,0.47000000f,-0.41000000f,0.03000000f,0.37000000f,-0.93000000f,-0.75000000f,-0.10000000f,-0.44000000f,0.74000000f,0.96000000f,0.47000000f,0.69000000f,0.44000000f,0.07000000f,0.28000000f,-0.84000000f,-0.00000000f,-0.65000000f,0.23000000f,-0.17000000f,0.65000000f,-0.05000000f,-0.32000000f,-0.98000000f,0.67000000f,-0.45000000f,0.16000000f,0.26000000f,0.81000000f,0.81000000f,-0.72000000f,-0.23000000f,0.57000000f,-0.87000000f,0.76000000f,-0.57000000f,0.14000000f,-0.44000000f,0.31000000f,0.80000000f,-0.73000000f,0.83000000f,0.00000000f,-0.54000000f,0.10000000f,0.42000000f,0.54000000f,-0.18000000f,0.56000000f,0.35000000f,0.44000000f,-0.52000000f,0.69000000f,0.69000000f,0.94000000f,0.39000000f,0.96000000f,0.58000000f,-0.71000000f,0.98000000f,-0.92000000f,-0.11000000f,0.98000000f,0.90000000f,0.79000000f,0.63000000f,0.84000000f,-0.95000000f,0.61000000f,-0.52000000f,-0.10000000f,0.33000000f,0.10000000f,0.56000000f,0.74000000f,0.11000000f,-0.27000000f,-0.36000000f,0.88000000f,0.33000000f,-0.30000000f,0.67000000f,0.98000000f,0.19000000f,0.56000000f,0.85000000f,0.13000000f,-0.65000000f,-0.67000000f,0.86000000f,-0.03000000f,0.83000000f,-0.50000000f,-0.54000000f,-0.65000000f,-0.64000000f,-0.73000000f,-0.60000000f,0.68000000f,-0.71000000f,-0.36000000f,-0.81000000f,-0.27000000f,-0.06000000f,-0.04000000f,0.47000000f,-0.99000000f,-0.35000000f,-0.89000000f,0.55000000f,-0.39000000f,-0.94000000f,0.32000000f,-0.23000000f,-0.53000000f,0.37000000f,-0.17000000f,0.85000000f,0.27000000f,-0.10000000f,-0.81000000f,-0.31000000f,-0.22000000f,-0.30000000f,-0.29000000f,0.93000000f,0.08000000f,0.98000000f,0.32000000f,0.97000000f,0.86000000f,0.67000000f,0.39000000f,0.50000000f,0.06000000f,0.25000000f,-0.73000000f,-0.88000000f,-0.02000000f,0.88000000f,0.85000000f,0.38000000f,-0.29000000f,-0.99000000f,0.30000000f,-0.06000000f,0.14000000f,-0.02000000f,0.09000000f,-0.62000000f,0.41000000f,-0.46000000f,0.90000000f,0.06000000f,-0.78000000f,-0.10000000f,0.97000000f,0.66000000f,-0.96000000f,0.46000000f,0.12000000f,0.84000000f,0.89000000f,-0.28000000f,-0.65000000f,-0.71000000f,0.04000000f,0.34000000f,-0.98000000f,-0.27000000f,0.21000000f,0.13000000f,-0.56000000f,0.56000000f,0.71000000f,-0.55000000f,0.14000000f,0.81000000f,0.03000000f,-0.19000000f,0.82000000f,0.48000000f,-0.42000000f,0.73000000f,0.04000000f,0.48000000f,-0.10000000f,-0.78000000f,0.75000000f,-0.89000000f,-0.02000000f,0.60000000f,0.15000000f,-0.88000000f,0.01000000f,0.93000000f,-0.59000000f,0.43000000f,0.57000000f,0.14000000f,0.96000000f,0.75000000f,0.58000000f,0.69000000f,-0.92000000f,0.14000000f,0.94000000f,-0.42000000f,0.54000000f,-0.73000000f,0.91000000f,-0.89000000f,-0.95000000f,0.41000000f,0.26000000f,-0.46000000f,-0.64000000f,-0.65000000f,0.53000000f,-0.61000000f,-0.95000000f,-0.41000000f,-0.28000000f,-0.78000000f,-0.01000000f,-0.55000000f,0.69000000f,0.60000000f,-0.29000000f,0.81000000f,0.74000000f,0.39000000f,0.58000000f,-0.65000000f,0.37000000f,-0.88000000f,-0.11000000f,0.08000000f,-0.78000000f,0.01000000f,-0.46000000f,-0.12000000f,0.38000000f,-0.63000000f,0.66000000f,-0.33000000f,-0.51000000f,-0.16000000f,0.32000000f,0.40000000f,-0.03000000f,-0.35000000f,0.49000000f,-0.52000000f,-0.26000000f,-0.99000000f,-0.94000000f,0.18000000f,0.94000000f,0.37000000f,0.94000000f,0.85000000f,0.36000000f,-0.00000000f,0.36000000f,-0.94000000f,-0.47000000f,0.92000000f,0.75000000f,-0.29000000f,-0.82000000f,0.95000000f,0.29000000f,-0.47000000f,0.12000000f,-0.96000000f,0.06000000f,-0.56000000f,-0.20000000f,0.47000000f,0.15000000f,0.08000000f,-0.20000000f,-0.20000000f,-0.31000000f,0.44000000f,-0.83000000f,-0.03000000f,0.75000000f,-0.87000000f,0.90000000f,-0.39000000f,-0.06000000f,0.56000000f,0.03000000f,-0.03000000f,-0.37000000f,-0.08000000f,-0.25000000f,0.15000000f,-0.90000000f,0.29000000f,-0.94000000f,0.20000000f,0.71000000f,0.14000000f,-0.70000000f,0.98000000f,-0.77000000f,-0.97000000f,-0.43000000f,0.25000000f,-0.30000000f,0.28000000f,-0.04000000f,0.19000000f,0.40000000f,0.56000000f,-0.18000000f,-0.66000000f,0.66000000f,-0.21000000f,-0.48000000f,0.76000000f,0.87000000f,-0.63000000f,-0.12000000f,0.22000000f,-0.48000000f,-0.41000000f,-0.87000000f,-0.16000000f,-0.53000000f,0.25000000f,-0.31000000f,0.45000000f,-0.25000000f,0.46000000f,0.35000000f,0.64000000f,-0.45000000f,0.84000000f,-0.70000000f,0.19000000f,-0.96000000f,-0.68000000f,0.92000000f,-0.07000000f,0.10000000f,0.89000000f,0.25000000f,0.70000000f,0.52000000f,0.63000000f,-0.36000000f,0.11000000f,-0.39000000f,0.77000000f,0.59000000f,-0.01000000f,-0.60000000f,0.66000000f,-0.46000000f,0.64000000f,-0.21000000f,0.37000000f,-0.55000000f,0.27000000f,0.09000000f,-0.35000000f,0.07000000f,0.80000000f,-0.51000000f,-0.80000000f,-0.04000000f,0.59000000f,0.59000000f,-0.96000000f,-0.12000000f,-0.28000000f,0.71000000f,0.17000000f,-0.36000000f,0.35000000f,0.99000000f,-0.30000000f,-0.98000000f,0.52000000f,-0.62000000f,0.69000000f,-0.48000000f,0.34000000f,0.30000000f,-0.78000000f,-0.84000000f,0.46000000f,-0.36000000f,0.31000000f,-0.61000000f,-0.71000000f,0.46000000f,-0.97000000f,-0.97000000f,-0.18000000f,-0.42000000f,-0.22000000f,-0.42000000f,-0.08000000f,0.84000000f,-0.48000000f,-0.22000000f,-0.95000000f,-0.42000000f,-0.45000000f,0.17000000f,-0.58000000f,0.82000000f,-0.81000000f,0.23000000f,0.07000000f,-0.16000000f,0.93000000f,-0.82000000f,-0.78000000f,0.13000000f,-0.80000000f,-0.24000000f,-0.00000000f,0.75000000f,-0.59000000f,0.01000000f,0.71000000f,0.53000000f,0.02000000f,-0.97000000f,0.81000000f,-0.35000000f,0.15000000f,-0.32000000f,-0.11000000f,0.79000000f,-0.08000000f,0.82000000f,-0.99000000f,-0.68000000f,-0.48000000f,-0.08000000f,-0.03000000f,0.64000000f,0.48000000f,-0.69000000f,-0.82000000f,0.98000000f,0.86000000f,-0.32000000f,-0.86000000f,-0.08000000f,0.25000000f,-0.37000000f,-0.56000000f,0.04000000f,-0.53000000f,0.52000000f,0.89000000f,-0.26000000f,0.79000000f,0.97000000f,0.46000000f,0.07000000f,-0.99000000f,-0.91000000f,-0.03000000f,0.81000000f,0.06000000f,-0.56000000f,-0.68000000f,0.14000000f,-0.15000000f,0.33000000f,-0.26000000f,0.94000000f,0.76000000f,0.70000000f,0.70000000f,-0.88000000f,0.20000000f,0.02000000f,-0.32000000f,0.75000000f,0.34000000f,0.47000000f,0.63000000f,0.01000000f,-0.80000000f,0.31000000f,0.01000000f,-0.25000000f,0.20000000f,0.40000000f,-0.95000000f,0.52000000f,0.24000000f,-0.46000000f,0.61000000f,0.58000000f,-0.97000000f,-0.90000000f,-0.24000000f,0.18000000f,0.16000000f,0.56000000f,0.21000000f,-0.71000000f,-0.96000000f,-0.86000000f,0.04000000f,-0.11000000f,-0.09000000f,0.07000000f,-0.01000000f,-0.58000000f,-0.12000000f,-0.43000000f,-0.95000000f,0.45000000f,-0.87000000f,-0.07000000f,0.31000000f,0.02000000f,-0.22000000f,-0.62000000f,0.48000000f,0.19000000f,0.42000000f,-0.23000000f,0.70000000f,-0.56000000f,-0.19000000f,-0.54000000f,-0.15000000f,0.78000000f,-0.39000000f,-0.95000000f,0.36000000f,0.12000000f,-0.31000000f,0.93000000f,0.16000000f,0.92000000f,0.58000000f,-0.80000000f,0.76000000f,-0.16000000f,0.15000000f,0.93000000f,-0.18000000f,0.11000000f,0.97000000f,0.36000000f,-0.29000000f,0.56000000f,0.67000000f,-0.46000000f,-0.94000000f,0.64000000f,-0.87000000f,-0.72000000f,-0.86000000f,0.64000000f,0.34000000f,-0.00000000f,0.03000000f,-0.48000000f,-0.11000000f,0.09000000f,-0.89000000f,-0.85000000f,0.71000000f,-0.36000000f,-0.28000000f,0.04000000f,-0.88000000f,0.91000000f,0.19000000f,0.37000000f,-0.58000000f,0.29000000f,0.17000000f,0.33000000f,-0.62000000f,-0.32000000f,0.83000000f,0.00000000f,-0.95000000f,-0.03000000f,-0.80000000f,0.64000000f,0.10000000f,-0.11000000f,0.46000000f,0.54000000f,0.64000000f,-0.17000000f,-0.31000000f,-0.46000000f,0.85000000f,-0.42000000f,-0.27000000f,0.45000000f,0.06000000f,-0.11000000f,-0.20000000f,-0.30000000f,0.29000000f,0.73000000f,0.43000000f,-0.95000000f,0.46000000f,-0.04000000f,-0.51000000f,0.30000000f,0.82000000f,-0.93000000f,-0.86000000f,0.33000000f,-0.39000000f,-0.07000000f,-0.67000000f,-0.86000000f,-0.61000000f,0.48000000f,-0.35000000f,-0.57000000f,0.31000000f,0.05000000f,-0.72000000f,0.46000000f,-0.62000000f,-0.81000000f,-0.74000000f,0.59000000f,0.79000000f,0.77000000f,-0.31000000f,-0.38000000f,-0.85000000f,0.70000000f,0.39000000f,0.57000000f,0.52000000f,-0.08000000f,0.49000000f,-0.49000000f,-0.53000000f,0.61000000f,-0.21000000f,-0.04000000f,0.03000000f,0.54000000f,-0.49000000f,0.95000000f,-0.45000000f,-0.99000000f,-0.39000000f,0.19000000f,-0.74000000f,-0.43000000f,0.97000000f,-0.46000000f,-0.93000000f,-0.56000000f,0.17000000f,-0.74000000f,-0.87000000f,-0.20000000f,-0.87000000f,-0.60000000f,-0.66000000f,0.12000000f,-0.88000000f,-0.25000000f,-0.27000000f,0.36000000f,-0.22000000f,0.97000000f,-0.24000000f,0.35000000f,-0.30000000f,-0.10000000f,0.66000000f,-0.06000000f,-0.21000000f,-0.20000000f,0.87000000f,-0.13000000f,-0.25000000f,0.10000000f,-0.47000000f,-0.51000000f,0.55000000f,0.20000000f,0.14000000f,0.80000000f,-0.25000000f,0.81000000f,-0.19000000f,-0.04000000f,-0.05000000f,0.63000000f,-0.03000000f,-0.60000000f,0.39000000f,-0.25000000f,0.47000000f,-0.51000000f,-0.42000000f,-0.31000000f,-0.08000000f,0.76000000f,-0.64000000f,0.28000000f,-0.15000000f,0.89000000f,-0.39000000f,0.49000000f,-0.31000000f,0.39000000f,-0.48000000f,-0.24000000f,-0.97000000f,0.76000000f,-0.34000000f,-0.35000000f,-0.83000000f,-0.70000000f,-0.92000000f,0.37000000f,-0.05000000f,0.95000000f,0.49000000f,-0.04000000f,0.51000000f,-0.84000000f,0.56000000f,0.50000000f,0.85000000f,0.78000000f,-0.03000000f,-0.32000000f,0.31000000f,-0.13000000f,-0.38000000f,-0.34000000f,-0.15000000f,0.22000000f,-0.91000000f,0.97000000f,0.12000000f,0.71000000f,0.22000000f,0.98000000f,0.45000000f,-0.21000000f,-0.27000000f,0.31000000f,-0.47000000f,-0.90000000f,-0.90000000f,-0.83000000f,0.07000000f,0.20000000f,0.68000000f,-0.42000000f,-0.36000000f,-0.14000000f,0.29000000f,0.57000000f,0.76000000f,-0.18000000f,-0.89000000f,-0.30000000f,0.92000000f,-0.09000000f,-0.05000000f,0.96000000f,0.29000000f,0.07000000f,-0.65000000f,-0.78000000f,0.55000000f,0.17000000f,-0.39000000f,0.17000000f,0.62000000f,0.51000000f,0.00000000f,-0.61000000f,-0.52000000f,-0.57000000f,-0.99000000f,-0.65000000f,0.94000000f,-0.54000000f,-0.00000000f,0.99000000f,0.40000000f,-0.98000000f,0.38000000f,-0.15000000f,-0.91000000f,-0.47000000f,0.61000000f,-0.67000000f,0.79000000f,-0.01000000f,-0.04000000f,0.27000000f,0.27000000f,0.49000000f,0.71000000f,0.56000000f,-0.98000000f,0.42000000f,-0.30000000f,-0.48000000f,0.85000000f,-0.28000000f,0.02000000f,-0.26000000f,0.27000000f,0.40000000f,-0.61000000f,-0.48000000f,0.79000000f,0.08000000f,-0.04000000f,0.96000000f,0.86000000f,0.99000000f,-0.97000000f,0.79000000f,-0.96000000f,0.53000000f,0.61000000f,-0.16000000f,0.39000000f,0.02000000f,0.76000000f,-0.51000000f,0.19000000f,0.79000000f,0.20000000f,0.76000000f,0.26000000f,-0.95000000f,0.03000000f,0.06000000f,0.86000000f,-0.69000000f,0.46000000f,-0.55000000f,-0.71000000f,-0.91000000f,0.69000000f,0.53000000f,-0.27000000f,-0.02000000f,-0.34000000f,-0.78000000f,0.51000000f,0.04000000f,0.92000000f,-0.72000000f,-0.84000000f,0.01000000f,-0.95000000f,0.58000000f,-0.85000000f,0.86000000f,-0.70000000f,0.34000000f,0.14000000f,-0.22000000f,0.89000000f,0.44000000f,0.91000000f,0.51000000f,0.15000000f,0.56000000f,0.75000000f,-0.10000000f,0.34000000f,0.14000000f,-0.34000000f,-0.55000000f,0.77000000f,0.59000000f,0.11000000f,-0.16000000f,-0.12000000f,-0.89000000f,-0.45000000f,-0.56000000f,-0.93000000f,0.51000000f,-0.19000000f,0.82000000f,0.17000000f,0.65000000f,0.18000000f,0.69000000f,-0.72000000f,0.75000000f,0.40000000f,-0.37000000f,-0.55000000f,0.87000000f,0.58000000f,0.33000000f,-0.78000000f,0.29000000f,-0.17000000f,0.62000000f,-0.05000000f,0.39000000f,0.69000000f,0.90000000f,-0.53000000f,0.98000000f,0.74000000f,-0.34000000f,-0.34000000f,-0.25000000f,0.62000000f,0.96000000f,-0.30000000f,-0.54000000f,0.46000000f,-0.99000000f,0.13000000f,-0.40000000f,0.15000000f,-0.59000000f,-0.85000000f,0.18000000f,0.89000000f,-0.85000000f,0.56000000f,-0.23000000f,0.73000000f,0.17000000f,-0.76000000f,-0.23000000f,0.77000000f,0.82000000f,-0.72000000f,-0.94000000f,-0.95000000f,0.28000000f,0.74000000f,-0.97000000f,0.44000000f,-0.02000000f,0.40000000f,-0.53000000f,-0.83000000f,-0.57000000f,-0.07000000f,0.20000000f,0.27000000f,0.10000000f,-0.19000000f,0.99000000f,0.18000000f,-0.24000000f,0.73000000f,-0.30000000f,-0.83000000f,-0.34000000f,-0.16000000f,-0.23000000f,0.18000000f,-0.69000000f,-0.70000000f,0.52000000f,-0.33000000f,0.45000000f,-0.81000000f,-0.17000000f,0.03000000f,0.49000000f,0.80000000f,0.88000000f,-0.30000000f,0.17000000f,-0.69000000f,0.19000000f,0.67000000f,-0.78000000f,-0.84000000f,-0.75000000f,-0.81000000f,0.65000000f,0.50000000f,0.62000000f,0.19000000f,-0.91000000f,0.26000000f,-0.17000000f,-0.33000000f,0.19000000f,0.13000000f,0.32000000f,0.59000000f,-0.31000000f,0.88000000f,-0.33000000f,-0.42000000f,-0.34000000f,-0.05000000f,-0.35000000f,0.20000000f,0.31000000f,-0.21000000f,-0.30000000f,0.70000000f,0.10000000f,-0.28000000f,-0.27000000f,0.48000000f,0.45000000f,-0.67000000f,-0.14000000f,-0.41000000f,-0.80000000f,0.02000000f,0.03000000f,-0.49000000f,-0.73000000f,-0.94000000f,-0.28000000f,-0.11000000f,0.94000000f,-0.02000000f,0.06000000f,-0.64000000f,-0.87000000f,0.59000000f,-0.99000000f,-0.19000000f,0.50000000f,-0.12000000f,0.84000000f,0.98000000f,-0.69000000f,0.64000000f,0.93000000f,-0.93000000f,-0.42000000f,-0.96000000f,-0.26000000f,0.21000000f,0.48000000f,-0.64000000f,0.58000000f,-0.86000000f,-0.85000000f,-0.73000000f,-0.81000000f,0.08000000f,-0.89000000f,0.00000000f,-0.16000000f,0.78000000f,0.25000000f,-0.87000000f,-0.30000000f,-0.19000000f,0.58000000f,0.30000000f,-0.10000000f,0.54000000f,0.06000000f,-0.52000000f,-0.88000000f,0.63000000f,-0.34000000f,-0.19000000f,-0.92000000f,0.60000000f,-0.90000000f,-0.21000000f,-0.90000000f,-0.28000000f,-0.14000000f,-0.71000000f,0.49000000f,0.80000000f,-0.49000000f,-0.38000000f,0.57000000f,0.10000000f,-0.80000000f,0.25000000f,-0.38000000f,-0.12000000f,-0.52000000f,-0.01000000f,-0.72000000f,0.74000000f,-0.35000000f,0.88000000f,0.02000000f,-0.14000000f,-0.40000000f,-0.42000000f,0.12000000f,0.93000000f,-0.98000000f,0.95000000f,-0.34000000f,0.53000000f,0.00000000f,0.22000000f,0.35000000f,0.90000000f,-0.39000000f,-0.04000000f,-0.27000000f,-0.20000000f,0.90000000f,-0.00000000f,0.36000000f,-0.68000000f,-0.95000000f,0.21000000f,0.76000000f,0.29000000f,0.99000000f,-0.28000000f,0.02000000f,-0.79000000f,-0.39000000f,0.63000000f,-0.25000000f,0.64000000f,0.72000000f,-0.93000000f,-0.64000000f,0.34000000f,0.36000000f,0.76000000f,0.77000000f,0.27000000f,0.63000000f,0.28000000f,0.94000000f,0.80000000f,0.45000000f,0.49000000f,0.09000000f,0.22000000f,0.50000000f,0.44000000f,0.94000000f,-0.85000000f,0.32000000f,0.34000000f,0.02000000f,-0.04000000f,-0.50000000f,-0.54000000f,-0.96000000f,0.77000000f,-0.09000000f,-0.20000000f,-0.24000000f,-0.78000000f,0.36000000f,-0.73000000f,0.87000000f,0.23000000f,-0.99000000f,0.72000000f,-0.56000000f,0.79000000f,0.14000000f,-0.48000000f,0.37000000f,0.69000000f,0.91000000f,-0.58000000f,0.37000000f,-0.86000000f,-0.76000000f,-0.15000000f,-0.60000000f,-0.16000000f,0.13000000f,-0.97000000f,-0.08000000f,0.84000000f,-0.34000000f,-0.46000000f,0.23000000f,0.61000000f,-0.71000000f,0.71000000f,-0.07000000f,-0.72000000f,0.17000000f,-0.25000000f,0.58000000f,0.10000000f,0.90000000f,-0.80000000f,0.26000000f,0.21000000f,0.48000000f,-0.24000000f,-0.28000000f,0.27000000f,-0.80000000f,0.52000000f,-0.76000000f,0.87000000f,-0.71000000f,0.20000000f,-0.14000000f,0.17000000f,0.87000000f,-0.37000000f,-0.87000000f,0.62000000f,0.50000000f,0.89000000f,-0.66000000f,0.43000000f,-0.85000000f,0.70000000f,0.73000000f,-0.69000000f,-0.95000000f,-0.85000000f,-0.43000000f,0.94000000f,-0.15000000f,-0.69000000f,0.23000000f,-0.29000000f,0.76000000f,-0.62000000f,0.05000000f,-0.59000000f,0.59000000f,0.47000000f,0.27000000f,-0.13000000f,0.47000000f,-0.18000000f,-0.20000000f,0.02000000f,-0.43000000f,0.60000000f,0.11000000f,-0.26000000f,-0.41000000f,0.82000000f,0.66000000f,-0.31000000f,-0.32000000f,0.58000000f,0.86000000f,0.49000000f,-0.90000000f,0.40000000f,0.35000000f,-0.16000000f,0.48000000f,-0.46000000f,-0.02000000f,-0.07000000f,0.32000000f,-0.98000000f,-0.33000000f,0.33000000f,0.22000000f,-0.26000000f,0.09000000f,-0.79000000f,0.06000000f,0.54000000f,-0.87000000f,0.02000000f,0.83000000f,-0.33000000f,0.10000000f,0.50000000f,-0.44000000f,-0.45000000f,-0.97000000f,-0.51000000f,-0.90000000f,-0.56000000f,0.79000000f,-0.48000000f,0.41000000f,0.72000000f,-0.23000000f,0.91000000f,-0.07000000f,-0.38000000f,0.77000000f,-0.55000000f,-0.81000000f,-0.55000000f,0.75000000f,0.66000000f,-0.47000000f,0.44000000f,-0.90000000f,-0.06000000f,0.68000000f,-0.31000000f,-0.25000000f,-0.00000000f,0.47000000f,-0.12000000f,0.12000000f,0.99000000f,-0.62000000f,-0.84000000f,0.17000000f,0.92000000f,0.38000000f,-0.19000000f,-0.97000000f,0.48000000f,-0.89000000f,0.30000000f,-0.08000000f,0.03000000f,0.42000000f,0.14000000f,0.36000000f,-0.26000000f,-0.09000000f,0.41000000f,0.76000000f,0.66000000f,-0.11000000f,-0.19000000f,0.22000000f,-0.11000000f,0.39000000f,0.68000000f,-0.81000000f,0.87000000f,0.04000000f,0.54000000f,0.02000000f,0.05000000f,-0.24000000f,0.05000000f,0.57000000f,-0.81000000f,-0.77000000f,-0.09000000f,-0.35000000f,-0.00000000f,-0.61000000f,0.03000000f,-0.48000000f,0.40000000f,-0.22000000f,-0.19000000f,-0.55000000f,-0.53000000f,-0.32000000f,-0.17000000f,-0.08000000f,0.57000000f,0.18000000f,0.41000000f,0.54000000f,0.21000000f,-0.25000000f,0.07000000f,0.76000000f,-0.97000000f,-0.79000000f,-0.03000000f,-0.56000000f,-0.50000000f,-0.55000000f,-0.58000000f,0.59000000f,0.82000000f,-0.18000000f,-0.50000000f,-0.32000000f,-0.83000000f,-0.44000000f,-0.94000000f,-0.70000000f,0.90000000f,-0.23000000f,-0.23000000f,-0.83000000f,0.35000000f,-0.45000000f,0.31000000f,0.52000000f,-0.14000000f,0.79000000f,-0.30000000f,-0.51000000f,0.99000000f,0.47000000f,0.00000000f,-0.42000000f,0.43000000f,-0.52000000f,0.68000000f,-0.11000000f,0.54000000f,0.98000000f,0.66000000f,-0.32000000f,0.13000000f,-0.87000000f,-0.20000000f,0.27000000f,-0.74000000f,0.64000000f,-0.08000000f,-0.68000000f,-0.78000000f,0.45000000f,-0.37000000f,0.23000000f,0.79000000f,-0.03000000f,-0.09000000f,0.27000000f,-0.46000000f,-0.22000000f,-0.39000000f,0.92000000f,0.80000000f,-0.83000000f,0.89000000f,0.42000000f,0.75000000f,-0.59000000f,-0.26000000f,-0.62000000f,-0.37000000f,-0.07000000f,0.97000000f,-0.90000000f,0.39000000f,-0.50000000f,-0.20000000f,-0.54000000f,0.34000000f,-0.43000000f,-0.82000000f,-0.35000000f,0.42000000f,-0.46000000f,0.48000000f,-0.69000000f,0.33000000f,0.19000000f,0.99000000f,0.06000000f,-0.30000000f,-0.99000000f,0.13000000f,0.47000000f,-0.23000000f,-0.47000000f,0.07000000f,0.82000000f,-0.58000000f,0.42000000f,-0.83000000f,-0.19000000f,-0.98000000f,-0.80000000f,0.28000000f,0.15000000f,0.44000000f,-0.87000000f,0.99000000f,-0.46000000f,-0.85000000f,-0.07000000f,-0.46000000f,-0.93000000f,0.87000000f,0.49000000f,-0.09000000f,-0.74000000f,-0.43000000f,-0.94000000f,0.44000000f,0.50000000f,-0.84000000f,-0.51000000f,0.50000000f,-0.33000000f,0.58000000f,0.22000000f,-0.89000000f,-0.65000000f,0.39000000f,0.01000000f,0.94000000f,-0.73000000f,-0.30000000f,0.69000000f,0.47000000f,0.11000000f,-0.30000000f,-0.16000000f,-0.58000000f,0.76000000f,-0.78000000f,-0.84000000f,0.83000000f,0.96000000f,-0.44000000f,-0.40000000f,-0.28000000f,0.76000000f,-0.47000000f,-0.00000000f,0.91000000f,0.12000000f,0.58000000f,0.64000000f,0.61000000f,0.30000000f,-0.55000000f,-0.33000000f,0.40000000f,0.17000000f,0.35000000f,0.93000000f,-0.63000000f,0.33000000f,0.21000000f,-0.03000000f,-0.55000000f,0.37000000f,0.55000000f,-0.14000000f,-0.37000000f,-0.32000000f,-0.41000000f,-0.50000000f,-0.30000000f,0.49000000f,-0.16000000f,-0.13000000f,-0.77000000f,-0.82000000f,-0.16000000f,0.67000000f,-0.83000000f,-0.87000000f,0.17000000f,0.39000000f,-0.72000000f,-0.09000000f,0.28000000f,0.43000000f,0.44000000f,-0.28000000f,0.23000000f,0.33000000f,-0.95000000f,0.94000000f,-0.70000000f,0.03000000f,-0.73000000f,-0.06000000f,0.90000000f,-0.13000000f,0.39000000f,-0.57000000f,0.13000000f,-0.00000000f,0.30000000f,-0.83000000f,0.53000000f,-0.61000000f,0.27000000f,0.84000000f,0.98000000f,0.98000000f,-0.34000000f,-0.83000000f,-0.36000000f,0.16000000f,-0.93000000f,-0.45000000f,0.23000000f,0.22000000f,0.18000000f,0.80000000f,-0.56000000f,-0.34000000f,-0.40000000f,-0.84000000f,-0.63000000f,0.98000000f,-0.07000000f,-0.36000000f,0.52000000f,0.06000000f,-0.61000000f,-0.19000000f,0.10000000f,0.60000000f,0.37000000f,-0.74000000f,0.84000000f,-0.86000000f,0.63000000f,0.75000000f,-0.48000000f,0.93000000f,-0.39000000f,-0.01000000f,0.43000000f,0.24000000f,-0.49000000f,-0.36000000f,-0.97000000f,-0.56000000f,-0.08000000f,0.61000000f,0.38000000f,-0.25000000f,0.81000000f,0.42000000f,0.42000000f,0.95000000f,0.18000000f,-0.14000000f,0.12000000f,-0.32000000f,-0.62000000f,0.84000000f,-0.92000000f,-0.57000000f,0.57000000f,-0.18000000f,-0.70000000f,0.39000000f,0.48000000f,0.37000000f,-0.34000000f,-0.65000000f,-0.42000000f,-0.81000000f,0.50000000f,-0.27000000f,-0.63000000f,0.09000000f,-0.97000000f,0.76000000f,-0.86000000f,-0.93000000f,-0.67000000f,-0.86000000f,-0.69000000f,0.15000000f,-0.21000000f,0.20000000f,-0.52000000f,-0.65000000f,0.80000000f,-0.69000000f,-0.78000000f,0.23000000f,-0.69000000f,-0.84000000f,0.09000000f,0.53000000f,-0.24000000f,0.44000000f,0.16000000f,-0.10000000f,0.46000000f,-0.63000000f,-0.50000000f,-0.08000000f,0.33000000f,0.76000000f,-0.37000000f,-0.16000000f,0.81000000f,0.44000000f,0.02000000f,0.33000000f,-0.73000000f,0.72000000f,-0.08000000f,-0.47000000f,0.59000000f,0.76000000f,-0.83000000f,0.09000000f,-0.90000000f,-0.91000000f,-0.53000000f,0.80000000f,-0.51000000f,0.33000000f,-0.78000000f,0.47000000f,-0.71000000f,-0.58000000f,0.22000000f,0.53000000f,-0.10000000f,-0.00000000f,0.10000000f,-0.71000000f,0.94000000f,0.18000000f,-0.67000000f,-0.10000000f,-0.95000000f,0.52000000f,0.87000000f,-0.45000000f,0.68000000f,-0.00000000f,-0.78000000f,-0.01000000f,-0.04000000f,0.39000000f,0.02000000f,0.77000000f,0.82000000f,-0.98000000f,-0.90000000f,-0.63000000f,-0.31000000f,-0.97000000f,0.29000000f,-0.00000000f,0.55000000f,-0.58000000f,0.97000000f,-0.35000000f,0.16000000f,-0.56000000f,0.06000000f,0.97000000f,0.54000000f,0.80000000f,-0.59000000f,0.87000000f,0.74000000f,-0.31000000f,-0.24000000f,0.39000000f,0.43000000f,0.33000000f,-0.12000000f,-0.30000000f,0.61000000f,0.77000000f,0.23000000f,-0.05000000f,-0.13000000f,0.14000000f,0.76000000f,-0.12000000f,0.53000000f,-0.56000000f,-0.75000000f,-0.84000000f,-0.97000000f,0.33000000f,0.65000000f,0.16000000f,-0.46000000f,0.28000000f,-0.39000000f,0.40000000f,0.03000000f,-0.36000000f,0.97000000f,-0.27000000f,-0.31000000f,-0.34000000f,0.68000000f,-0.15000000f,-0.09000000f,0.84000000f,0.29000000f,0.90000000f,-0.42000000f,-0.82000000f,0.89000000f,0.15000000f,0.20000000f,-0.32000000f,-0.03000000f,0.29000000f,0.61000000f,-0.52000000f,-0.62000000f,-0.93000000f,0.79000000f,0.28000000f,-0.03000000f,0.03000000f,-0.54000000f,-0.61000000f,0.31000000f,-0.91000000f,0.92000000f,-0.18000000f,-0.12000000f,0.79000000f,-0.24000000f,-0.40000000f,0.46000000f,-0.63000000f,-0.93000000f,0.82000000f,0.40000000f,-0.09000000f,0.12000000f,-0.77000000f,-0.13000000f,-0.58000000f,0.86000000f,-0.86000000f,0.50000000f,-0.72000000f,-0.46000000f,-0.81000000f,0.94000000f,-0.66000000f,0.24000000f,-0.78000000f,-0.79000000f,-0.48000000f,0.49000000f,0.47000000f,-0.04000000f,-0.83000000f,-0.49000000f,-0.48000000f,-0.16000000f,-0.18000000f,0.03000000f,-0.90000000f,-0.47000000f,-0.26000000f,0.38000000f,0.90000000f,-0.81000000f,-0.64000000f,-0.29000000f,0.69000000f,0.62000000f,-0.99000000f,0.50000000f,0.94000000f,0.68000000f,-0.00000000f,0.51000000f,0.26000000f,-0.78000000f,-0.71000000f,0.63000000f,-0.81000000f,-0.18000000f,-0.30000000f,0.28000000f,0.18000000f,-0.20000000f,-0.44000000f,0.26000000f,-0.13000000f,-0.86000000f,0.77000000f,0.78000000f,-0.19000000f,-0.15000000f,-0.77000000f,0.37000000f,-0.01000000f,-0.21000000f,-0.07000000f,-0.78000000f,0.54000000f,0.78000000f,0.38000000f,0.69000000f,0.32000000f,0.04000000f,0.42000000f,-0.40000000f,0.06000000f,0.79000000f,-0.26000000f,-0.15000000f,-0.27000000f,0.23000000f,-0.37000000f,0.90000000f,-0.22000000f,0.73000000f,-0.87000000f,0.59000000f,-0.53000000f,-0.35000000f,-0.88000000f,0.82000000f,-0.57000000f,-0.86000000f,-0.38000000f,-0.87000000f,0.72000000f,0.51000000f,0.56000000f,0.32000000f,0.27000000f,0.86000000f,0.96000000f,-0.40000000f,-0.54000000f,-0.54000000f,0.64000000f,0.99000000f,-0.50000000f,0.29000000f,0.58000000f,0.66000000f,-0.58000000f,0.23000000f,0.24000000f,-0.67000000f,-0.23000000f,0.31000000f,0.47000000f,-0.91000000f,0.56000000f,0.97000000f,0.06000000f,-0.68000000f,-0.36000000f,0.47000000f,0.98000000f,0.41000000f,-0.71000000f,-0.38000000f,0.94000000f,-0.28000000f,0.10000000f,0.87000000f,0.63000000f,0.19000000f,-0.93000000f,-0.64000000f,0.35000000f,0.85000000f,-0.33000000f,0.62000000f,-0.54000000f,0.37000000f,0.92000000f,-0.22000000f,-0.55000000f,-0.59000000f,-0.06000000f,-0.81000000f,0.81000000f,-0.05000000f,0.70000000f,0.47000000f,0.62000000f,-0.69000000f,-0.19000000f,0.37000000f,-0.57000000f,0.66000000f,-0.14000000f,-0.97000000f,-0.71000000f,0.57000000f,0.66000000f,-0.46000000f,0.66000000f,-0.11000000f,0.91000000f,0.75000000f,-0.02000000f,0.14000000f,-0.25000000f,-0.32000000f,0.92000000f,-0.58000000f,0.48000000f,0.62000000f,0.23000000f,0.06000000f,0.17000000f,-0.28000000f,0.81000000f,0.78000000f,-0.14000000f,0.09000000f,0.12000000f,0.27000000f,0.36000000f,0.92000000f,-0.06000000f,-0.52000000f,-0.17000000f,0.36000000f,-0.22000000f,-0.41000000f,-0.64000000f,0.64000000f,-0.69000000f,-0.68000000f,-0.07000000f,-0.12000000f,0.73000000f,0.88000000f,-0.49000000f,0.00000000f,-0.93000000f,-0.45000000f,-0.39000000f,0.67000000f,-0.02000000f,-0.55000000f,0.61000000f,0.51000000f,0.41000000f,0.27000000f,0.19000000f,-0.49000000f,0.14000000f,0.16000000f,-0.45000000f,-0.31000000f,0.70000000f,-0.17000000f,0.52000000f,-0.34000000f,0.66000000f,0.84000000f,0.47000000f,-0.90000000f,-0.38000000f,0.21000000f,0.55000000f,0.86000000f,0.86000000f,-0.79000000f,-0.44000000f,-0.51000000f,-0.09000000f,-0.30000000f,-0.39000000f,-0.18000000f,-0.81000000f,0.32000000f,-0.90000000f,-0.14000000f,-0.24000000f,0.77000000f,-0.68000000f,0.09000000f,0.64000000f,0.08000000f,0.15000000f,-0.36000000f,0.51000000f,-0.54000000f,-0.34000000f,-0.73000000f,-0.25000000f,0.66000000f,-0.33000000f,0.23000000f,-0.93000000f,0.40000000f,0.62000000f,0.12000000f,0.23000000f,0.20000000f,0.57000000f,-0.52000000f,0.08000000f,0.53000000f,0.10000000f,0.79000000f,-0.63000000f,0.46000000f,-0.12000000f,0.21000000f,0.60000000f,0.84000000f,0.84000000f,-0.54000000f,-0.24000000f,-0.75000000f,0.71000000f,0.94000000f,0.81000000f,-0.07000000f,-0.96000000f,-0.51000000f,0.40000000f,-0.26000000f,0.34000000f,-0.79000000f,-0.95000000f,-0.58000000f,0.54000000f,-0.48000000f,-0.83000000f,-0.71000000f,-0.45000000f,-0.68000000f,0.05000000f,0.28000000f,0.58000000f,0.16000000f,0.48000000f,0.09000000f,0.09000000f,0.13000000f,0.76000000f,-0.54000000f,0.14000000f,-0.47000000f,0.95000000f,-0.40000000f,0.96000000f,-0.26000000f,-0.38000000f,-0.54000000f,0.05000000f,0.77000000f,-0.84000000f,-0.88000000f,0.81000000f,-0.69000000f,-0.93000000f,-0.03000000f,0.32000000f,0.60000000f,-0.59000000f,-0.07000000f,-0.66000000f,0.68000000f,-0.77000000f,-0.55000000f,0.31000000f,-0.22000000f,-0.20000000f,0.13000000f,0.32000000f,0.32000000f,0.32000000f,-0.86000000f,-0.19000000f,0.12000000f,0.82000000f,0.38000000f,0.73000000f,0.07000000f,0.09000000f,-0.04000000f,-0.62000000f,0.13000000f,-0.51000000f,-0.87000000f,-0.48000000f,0.07000000f,0.13000000f,-0.16000000f,0.68000000f,-0.97000000f,-0.59000000f,0.00000000f,0.24000000f,-0.67000000f,-0.57000000f,0.59000000f,0.64000000f,0.36000000f,-0.50000000f,0.01000000f,0.94000000f,0.33000000f,0.69000000f,0.24000000f,-0.96000000f,0.31000000f,-0.21000000f,0.77000000f,-0.78000000f,-0.87000000f,0.73000000f,0.55000000f,0.46000000f,0.95000000f,0.99000000f,0.64000000f,0.03000000f,0.04000000f,-0.19000000f,-0.03000000f,0.54000000f,0.19000000f,-0.09000000f,0.57000000f,0.25000000f,0.75000000f,-0.22000000f,0.45000000f,0.23000000f,-0.52000000f,-0.27000000f,-0.83000000f,0.01000000f,-0.08000000f,-0.51000000f,0.26000000f,-0.36000000f,-0.30000000f,-0.77000000f,0.17000000f,-0.02000000f,-0.57000000f,-0.29000000f,-0.47000000f,-0.53000000f,0.97000000f,0.49000000f,0.03000000f,0.52000000f,0.93000000f,0.71000000f,0.82000000f,-0.35000000f,0.38000000f,0.47000000f,-0.92000000f,-0.36000000f,0.69000000f,-0.88000000f,0.58000000f,-0.02000000f,-0.80000000f,-0.69000000f,0.56000000f,-0.15000000f,-0.74000000f,0.88000000f,0.35000000f,0.24000000f,0.03000000f,-0.43000000f,-0.03000000f,-0.97000000f,0.17000000f,-0.92000000f,0.44000000f,-0.57000000f,-0.90000000f,0.50000000f,0.26000000f,-0.87000000f,0.25000000f,-0.70000000f,-0.19000000f,0.56000000f,0.92000000f,0.09000000f,0.55000000f,-0.38000000f,0.28000000f,0.91000000f,-0.25000000f,0.55000000f,0.46000000f,-0.80000000f,0.24000000f,-0.66000000f,0.32000000f,-0.05000000f,-0.09000000f,0.12000000f,0.86000000f,0.66000000f,-0.93000000f,0.88000000f,-0.31000000f,-0.13000000f,0.68000000f,0.84000000f,-0.58000000f,0.19000000f,-0.61000000f,-0.06000000f,-0.01000000f,0.10000000f,-0.77000000f,0.36000000f,-0.05000000f,0.96000000f,0.83000000f,-0.66000000f,0.81000000f,0.54000000f,0.46000000f,-0.93000000f,0.19000000f,-0.75000000f,0.85000000f,-0.26000000f,-0.03000000f,-0.77000000f,0.54000000f,-0.54000000f,0.72000000f,-0.05000000f,-0.81000000f,0.58000000f,-0.34000000f,-0.53000000f,0.98000000f,0.96000000f,-0.55000000f,0.99000000f,-0.48000000f,-0.29000000f,-0.01000000f,0.09000000f,-0.02000000f,-0.34000000f,-0.15000000f,0.44000000f,-0.54000000f,-0.82000000f,-0.35000000f,-0.87000000f,-0.45000000f,0.80000000f,0.74000000f,0.86000000f,0.75000000f,0.66000000f,-0.69000000f,-0.29000000f,-0.18000000f,0.17000000f,-0.50000000f,0.66000000f,0.37000000f,0.75000000f,-0.44000000f,-0.07000000f,0.06000000f,-0.36000000f,-0.10000000f,-0.63000000f,0.12000000f,-0.25000000f,-0.71000000f,-0.51000000f,-0.75000000f,-0.46000000f,0.52000000f,-0.36000000f,-0.97000000f,0.75000000f,-0.23000000f,0.26000000f,-0.27000000f,0.78000000f,-0.93000000f,-0.54000000f,0.00000000f,0.73000000f,0.05000000f,0.00000000f,-0.95000000f,0.19000000f,0.53000000f,-0.57000000f,0.82000000f,-0.48000000f,-0.46000000f,0.37000000f,0.74000000f,-0.99000000f,0.46000000f,-0.10000000f,0.91000000f,0.83000000f,-0.45000000f,-0.37000000f,-0.05000000f,-0.75000000f,-0.23000000f,-0.88000000f,-0.16000000f,-0.97000000f,0.80000000f,0.64000000f,-0.57000000f,0.53000000f,-0.70000000f,-0.19000000f,0.96000000f,0.26000000f,-0.70000000f,0.59000000f,-0.32000000f,0.49000000f,-0.25000000f,-0.01000000f,0.57000000f,-0.21000000f,0.04000000f,-0.32000000f,0.23000000f,0.19000000f,-0.17000000f,-0.58000000f,-0.27000000f,-0.50000000f,-0.59000000f,-0.77000000f,0.07000000f,-0.37000000f,0.13000000f,-0.83000000f,0.31000000f,0.63000000f,-0.55000000f,-0.32000000f,-0.66000000f,-0.61000000f,-0.95000000f,0.04000000f,0.58000000f,0.19000000f,0.50000000f,-0.79000000f,0.32000000f,0.89000000f,0.58000000f,-0.28000000f,0.21000000f,-0.36000000f,0.84000000f,0.24000000f,-0.18000000f,0.96000000f,-0.43000000f,0.17000000f,-0.38000000f,-0.07000000f,0.05000000f,0.91000000f,-0.41000000f,-0.24000000f,0.93000000f,-0.46000000f,-0.51000000f,0.93000000f,0.49000000f,0.17000000f,0.72000000f,-0.07000000f,-0.94000000f,-0.04000000f,0.87000000f,0.86000000f,-0.73000000f,-0.76000000f,-0.54000000f,-0.03000000f,0.83000000f,0.62000000f,0.76000000f,-0.72000000f,-0.76000000f,0.95000000f,0.32000000f,0.61000000f,0.45000000f,0.63000000f,0.89000000f,-0.73000000f,0.63000000f,0.30000000f,-0.75000000f,-0.03000000f,0.64000000f,0.48000000f,-0.94000000f,-0.40000000f,0.28000000f,0.91000000f,0.29000000f,-0.02000000f,0.62000000f,-0.06000000f,0.07000000f,0.86000000f,0.31000000f,0.93000000f,0.41000000f,0.58000000f,0.67000000f,-0.30000000f,0.64000000f,0.59000000f,-0.33000000f,-0.77000000f,-0.52000000f,0.74000000f,-0.58000000f,0.93000000f,-0.17000000f,-0.49000000f,-0.91000000f,0.82000000f,-0.57000000f,0.05000000f,0.17000000f,0.44000000f,0.72000000f,-0.95000000f,-0.29000000f,0.70000000f,-0.96000000f,-0.11000000f,0.31000000f,-0.52000000f,-0.97000000f,-0.58000000f,0.46000000f,-0.06000000f,-0.30000000f,0.25000000f,0.16000000f,-0.38000000f,0.72000000f,0.47000000f,0.47000000f,0.84000000f,0.64000000f,-0.61000000f,-0.39000000f,-0.78000000f,0.58000000f,0.19000000f,-0.05000000f,0.38000000f,0.35000000f,0.11000000f,-0.16000000f,0.85000000f,-0.63000000f,0.88000000f,0.22000000f,0.79000000f,0.30000000f,-0.50000000f,-0.90000000f,0.41000000f,0.16000000f,0.40000000f,-0.38000000f,-0.94000000f,-0.61000000f,-0.02000000f,0.13000000f,-0.84000000f,0.86000000f,0.61000000f,0.08000000f,0.00000000f,0.13000000f,-0.58000000f,0.09000000f,-0.10000000f,-0.21000000f,-0.89000000f,-0.53000000f,0.41000000f,0.02000000f,0.93000000f,0.94000000f,-0.95000000f,0.14000000f,-0.81000000f,0.51000000f,0.00000000f,-0.23000000f,0.11000000f,-0.50000000f,-0.62000000f,-0.57000000f,0.46000000f,0.65000000f,0.98000000f,0.61000000f,0.67000000f,-0.32000000f,-0.09000000f,-0.70000000f,0.62000000f,0.40000000f,-0.69000000f,0.15000000f,0.73000000f,0.76000000f,0.49000000f,-0.10000000f,-0.13000000f,0.93000000f,0.72000000f,0.08000000f,0.96000000f,0.44000000f,0.63000000f,-0.68000000f,-0.69000000f,0.35000000f,0.50000000f,-0.73000000f,0.58000000f,0.85000000f,-0.21000000f,0.32000000f,-0.87000000f,0.05000000f,-0.05000000f,0.35000000f,0.63000000f,-0.24000000f,-0.96000000f,-0.42000000f,-0.05000000f,0.75000000f,0.07000000f,-0.91000000f,-0.35000000f,-0.80000000f,-0.48000000f,-0.86000000f,-0.35000000f,0.42000000f,0.88000000f,0.38000000f,0.53000000f,-0.74000000f,-0.61000000f,0.14000000f,-0.43000000f,0.68000000f,-0.02000000f,-0.30000000f,-0.81000000f,-0.39000000f,0.32000000f,-0.39000000f,0.23000000f,-0.82000000f,0.17000000f,-0.05000000f,-0.45000000f,-0.37000000f,0.57000000f,-0.44000000f,0.72000000f,-0.00000000f,0.84000000f,0.98000000f,-0.03000000f,-0.34000000f,-0.51000000f,-0.27000000f,0.46000000f,-0.49000000f,0.86000000f,-0.15000000f,-0.70000000f,0.91000000f,-0.87000000f,-0.44000000f,0.68000000f,0.96000000f,0.20000000f,-0.22000000f,0.96000000f,-0.46000000f,-0.18000000f,0.42000000f,-0.02000000f,-0.66000000f,0.85000000f,0.23000000f,0.03000000f,0.28000000f,-0.56000000f,-0.20000000f,-0.94000000f,0.90000000f,-0.11000000f,-0.63000000f,-0.19000000f,-0.37000000f,0.29000000f,0.18000000f,-0.32000000f,0.41000000f,-0.42000000f,0.95000000f,-0.88000000f,0.74000000f,-0.55000000f,-0.36000000f,-0.70000000f,0.09000000f,0.08000000f,-0.33000000f,0.16000000f,0.67000000f,0.46000000f,-0.94000000f,-0.47000000f,0.94000000f,0.61000000f,-0.40000000f,0.97000000f,-0.08000000f,0.29000000f,0.61000000f,-0.88000000f,0.66000000f,0.83000000f,-0.84000000f,0.61000000f,0.66000000f,0.92000000f,0.26000000f,-0.12000000f,-0.25000000f,-0.01000000f,-0.07000000f,-0.98000000f,-0.45000000f,0.92000000f,-0.29000000f,-0.48000000f,0.08000000f,0.16000000f,0.53000000f,0.96000000f,0.55000000f,0.39000000f,-0.61000000f,0.45000000f,-0.45000000f,-0.09000000f,0.10000000f,-0.07000000f,-0.11000000f,-0.87000000f,-0.43000000f,0.32000000f,0.91000000f,-0.72000000f,-0.75000000f,0.55000000f,-0.80000000f,0.33000000f,0.03000000f,-0.19000000f,-0.93000000f,-0.65000000f,0.92000000f,-0.26000000f,0.89000000f,0.50000000f,0.28000000f,-0.98000000f,-0.55000000f,-0.80000000f,-0.50000000f,0.33000000f,0.08000000f,0.85000000f,-0.33000000f,0.57000000f,-0.59000000f,0.97000000f,0.95000000f,0.51000000f,0.60000000f,-0.80000000f,0.92000000f,-0.55000000f,0.10000000f,0.13000000f,-0.89000000f,0.04000000f,-0.75000000f,0.73000000f,0.80000000f,0.87000000f,0.23000000f,0.59000000f,-0.63000000f,0.70000000f,-0.95000000f,0.82000000f,-0.27000000f,0.54000000f,0.19000000f,0.96000000f,0.95000000f,-0.81000000f,0.02000000f,0.45000000f,0.40000000f,-0.52000000f,-0.74000000f,0.27000000f,0.37000000f,-0.27000000f,-0.23000000f,0.24000000f,0.28000000f,0.27000000f,0.38000000f,0.62000000f,-0.84000000f,0.22000000f,-0.88000000f,-0.77000000f,0.61000000f,-0.22000000f,-0.26000000f,0.59000000f,0.63000000f,0.49000000f,-0.77000000f,0.30000000f,-0.57000000f,0.39000000f,-0.21000000f,-0.68000000f,0.43000000f,0.60000000f,0.30000000f,-0.51000000f,-0.28000000f,0.26000000f,-0.06000000f,-0.68000000f,0.50000000f,-0.07000000f,0.16000000f,0.25000000f,-0.39000000f,-0.08000000f,0.81000000f,0.83000000f,-0.72000000f,-0.67000000f,0.35000000f,-0.08000000f,0.37000000f,-0.24000000f,0.64000000f,0.37000000f,-0.17000000f,0.61000000f,-0.35000000f,0.21000000f,0.72000000f,0.98000000f,0.38000000f,-0.14000000f,0.59000000f,0.45000000f,0.30000000f,0.61000000f,0.62000000f,0.56000000f,-0.66000000f,-0.39000000f,0.11000000f,-0.43000000f,-0.08000000f,0.75000000f,0.31000000f,-0.64000000f,-0.53000000f,0.41000000f,0.48000000f,0.54000000f,0.62000000f,-0.64000000f,-0.58000000f,-0.00000000f,0.05000000f,-0.62000000f,-0.65000000f,0.72000000f,-0.90000000f,0.29000000f,-0.56000000f,-0.68000000f,0.98000000f,0.84000000f,-0.43000000f,0.16000000f,-0.43000000f,0.16000000f,-0.86000000f,0.23000000f,0.70000000f,-0.94000000f,-0.74000000f,0.41000000f,0.20000000f,0.02000000f,-0.35000000f,-0.99000000f,-0.87000000f,-0.65000000f,0.77000000f,0.32000000f,0.92000000f,0.14000000f,0.95000000f,-0.80000000f,-0.14000000f,0.10000000f,0.60000000f,0.06000000f,0.19000000f,0.28000000f,0.32000000f,-0.87000000f,0.32000000f,-0.61000000f,-0.94000000f,-0.76000000f,0.91000000f,-0.77000000f,-0.80000000f,-0.33000000f,0.36000000f,-0.66000000f,0.50000000f,0.06000000f,-0.79000000f,-0.14000000f,0.38000000f,0.54000000f,-0.34000000f,-0.51000000f,-0.35000000f,-0.78000000f,0.40000000f,0.78000000f,-0.55000000f,-0.93000000f,0.77000000f,-0.93000000f,0.69000000f,0.86000000f,-0.07000000f,-0.78000000f,-0.16000000f,0.30000000f,-0.95000000f,-0.53000000f,0.73000000f,-0.75000000f,-0.55000000f,-0.16000000f,-0.30000000f,-0.74000000f,0.95000000f,-0.18000000f,-0.65000000f,0.99000000f,-0.87000000f,0.49000000f,0.24000000f,-0.06000000f,0.58000000f,-0.93000000f,-0.93000000f,-0.36000000f,0.74000000f,0.54000000f,-0.62000000f,0.09000000f,0.09000000f,-0.05000000f,-0.06000000f,0.15000000f,-0.69000000f,-0.22000000f,-0.20000000f,0.70000000f,0.56000000f,-0.30000000f,-0.70000000f,-0.69000000f,-0.10000000f,0.44000000f,-0.01000000f,-0.95000000f,-0.85000000f,0.53000000f,-0.05000000f,0.00000000f,-0.66000000f,0.05000000f,-0.52000000f,0.64000000f,-0.21000000f,0.22000000f,-0.25000000f,-0.22000000f,0.28000000f,-0.70000000f,0.57000000f,-0.90000000f,-0.33000000f,-0.69000000f,-0.14000000f,0.08000000f,-0.38000000f,-0.14000000f,-0.97000000f,0.84000000f,0.69000000f,-0.38000000f,0.36000000f,0.42000000f,-0.39000000f,0.29000000f,0.50000000f,-0.36000000f,-0.58000000f,-0.40000000f,0.88000000f,0.70000000f,0.59000000f,0.88000000f,0.90000000f,-0.10000000f,-0.22000000f,-0.68000000f,-0.92000000f,-0.55000000f,-0.46000000f,0.96000000f,-0.50000000f,0.08000000f,0.92000000f,-0.68000000f,-0.27000000f,0.29000000f,-0.95000000f,0.58000000f,0.69000000f,-0.62000000f,-0.25000000f,0.02000000f,-0.50000000f,0.01000000f,0.33000000f,-0.93000000f,-0.85000000f,-0.51000000f,0.04000000f,0.29000000f,-0.32000000f,-0.66000000f,0.08000000f,0.94000000f,-0.81000000f,-0.70000000f,0.44000000f,-0.13000000f,0.72000000f,-0.81000000f,-0.55000000f,-0.53000000f,-0.27000000f,-0.76000000f,0.04000000f,0.91000000f,0.80000000f,-0.91000000f,-0.79000000f,-0.11000000f,0.17000000f,-0.42000000f,0.57000000f,0.72000000f,-0.52000000f,-0.12000000f,-0.00000000f,-0.17000000f,0.98000000f,-0.30000000f,0.20000000f,0.64000000f,-0.29000000f,-0.42000000f,0.45000000f,0.85000000f,0.53000000f,0.47000000f,-0.29000000f,-0.04000000f,0.97000000f,0.86000000f,-0.13000000f,-0.96000000f,-0.34000000f,0.75000000f,-0.04000000f,-0.21000000f,0.59000000f,0.68000000f,0.36000000f,-0.11000000f,0.76000000f,-0.59000000f,-0.28000000f,0.07000000f,0.49000000f,0.23000000f,-0.01000000f,-0.00000000f,-0.33000000f,-0.14000000f,0.17000000f,0.68000000f,0.41000000f,-0.02000000f,-0.40000000f,0.75000000f,0.39000000f,-0.07000000f,0.11000000f,0.66000000f,0.47000000f,0.90000000f,0.17000000f,-0.15000000f,0.48000000f,-0.10000000f,-0.81000000f,0.47000000f,0.72000000f,0.51000000f,-0.64000000f,0.41000000f,-0.21000000f,0.97000000f,0.42000000f,0.81000000f,0.00000000f,-0.99000000f,0.43000000f,0.83000000f,0.78000000f,-0.92000000f,0.32000000f,0.59000000f,-0.96000000f,-0.46000000f,0.32000000f,0.53000000f,-0.28000000f,-0.00000000f,-0.04000000f,-0.99000000f,0.67000000f,-0.13000000f,-0.43000000f,0.50000000f,-0.65000000f,0.96000000f,0.71000000f,-0.71000000f,-0.40000000f,0.44000000f,0.25000000f,0.90000000f,0.45000000f,0.71000000f,-0.66000000f,0.00000000f,0.52000000f,0.93000000f,0.58000000f,0.29000000f,0.62000000f,0.27000000f,0.56000000f,0.42000000f,0.26000000f,0.78000000f,-0.92000000f,-0.29000000f,0.98000000f,0.97000000f,0.80000000f,0.53000000f,0.40000000f,-0.28000000f,-0.01000000f,-0.15000000f,0.00000000f,0.18000000f,0.01000000f,-0.46000000f,-0.81000000f,-0.42000000f,0.58000000f,-0.47000000f,0.40000000f,-0.81000000f,0.67000000f,0.70000000f,-0.64000000f,0.31000000f,-0.75000000f,-0.07000000f,0.73000000f,0.31000000f,0.20000000f,0.07000000f,-0.31000000f,-0.50000000f,-0.91000000f,-0.53000000f,0.80000000f,0.13000000f,-0.31000000f,0.46000000f,0.99000000f,-0.52000000f,0.09000000f,-0.21000000f,0.46000000f,-0.76000000f,0.27000000f,0.88000000f,0.30000000f,-0.83000000f,-0.85000000f,0.98000000f,-0.34000000f,-0.84000000f,0.50000000f,-0.78000000f,0.17000000f,-0.72000000f,-0.06000000f,-0.53000000f,-0.53000000f,-0.74000000f,0.95000000f,0.42000000f,0.25000000f,-0.73000000f,0.10000000f,-0.06000000f,-0.87000000f,0.01000000f,0.54000000f,0.87000000f,0.68000000f,-0.85000000f,0.53000000f,-0.02000000f,0.86000000f,-0.15000000f,0.23000000f,0.18000000f,-0.34000000f,0.67000000f,-0.82000000f,-0.70000000f,0.35000000f,-0.90000000f,0.09000000f,-0.03000000f,0.94000000f,0.69000000f,0.43000000f,0.60000000f,-0.87000000f,0.45000000f,0.61000000f,-0.31000000f,0.54000000f,-0.91000000f,-0.73000000f,0.58000000f,0.27000000f,-0.81000000f,-0.94000000f,-0.63000000f,-0.91000000f,0.10000000f,0.25000000f,0.08000000f,0.47000000f,-0.75000000f,-0.34000000f,0.69000000f,0.37000000f,0.90000000f,0.21000000f,0.81000000f,-0.53000000f,0.80000000f,-0.67000000f,-0.95000000f,-0.55000000f,0.21000000f,-0.04000000f,-0.12000000f,-0.64000000f,0.78000000f,0.15000000f,-0.49000000f,0.26000000f,-0.29000000f,0.09000000f,-0.84000000f,-0.93000000f,0.11000000f,0.58000000f,-0.67000000f,0.60000000f,-0.40000000f,-0.61000000f,0.72000000f,-0.36000000f,-0.24000000f,-0.89000000f,-0.21000000f,-0.82000000f,-0.37000000f,-0.57000000f,0.72000000f,-0.66000000f,0.63000000f,0.74000000f,0.37000000f,-0.51000000f,0.37000000f,-0.71000000f,0.92000000f,-0.34000000f,0.02000000f,-0.95000000f,-0.37000000f,-0.92000000f,0.04000000f,0.12000000f,-0.26000000f,-0.43000000f,-0.81000000f,-0.26000000f,-0.48000000f,0.44000000f,-0.12000000f,-0.75000000f,0.98000000f,-0.31000000f,-0.01000000f,0.29000000f,0.77000000f,0.29000000f,0.87000000f,0.47000000f,0.18000000f,0.07000000f,-0.99000000f,0.81000000f,0.14000000f,0.53000000f,-0.03000000f,-0.22000000f,0.28000000f,-0.56000000f,-0.86000000f,0.52000000f,0.83000000f,0.89000000f,-0.54000000f,-0.48000000f,-0.91000000f,0.80000000f,-0.12000000f,-0.06000000f,0.09000000f,0.75000000f,-0.36000000f,0.55000000f,0.55000000f,0.46000000f,0.74000000f,0.53000000f,0.99000000f,-0.33000000f,-0.45000000f,-0.06000000f,-0.12000000f,0.19000000f,-0.17000000f,-0.38000000f,-0.78000000f,-0.58000000f,-0.74000000f,-0.65000000f,-0.03000000f,-0.77000000f,-0.38000000f,-0.97000000f,0.24000000f,0.57000000f,0.75000000f,0.45000000f,0.39000000f,0.89000000f,-0.81000000f,-0.42000000f,0.93000000f,-0.87000000f,0.52000000f,0.44000000f,-0.34000000f,-0.16000000f,-0.02000000f,-0.85000000f,0.97000000f,-0.41000000f,-0.57000000f,0.96000000f,-0.94000000f,-0.66000000f,0.92000000f,-0.94000000f,0.23000000f,-0.06000000f,-0.68000000f,0.37000000f,0.30000000f,0.75000000f,-0.51000000f,0.12000000f,0.52000000f,-0.17000000f,0.55000000f,-0.17000000f,0.40000000f,0.60000000f,0.97000000f,0.83000000f,-0.13000000f,-0.28000000f,0.73000000f,-0.77000000f,0.36000000f,-0.03000000f,0.96000000f,0.41000000f,0.97000000f,-0.65000000f,-0.78000000f,-0.68000000f,0.71000000f,-0.25000000f,-0.02000000f,-0.14000000f,0.32000000f,0.48000000f,-0.85000000f,-0.12000000f,-0.11000000f,0.90000000f,-0.59000000f,-0.70000000f,0.19000000f,0.53000000f,-0.83000000f,0.34000000f,-0.22000000f,0.34000000f,-0.37000000f,0.01000000f,-0.64000000f,-0.40000000f,-0.64000000f,-0.04000000f,-0.41000000f,-0.77000000f,-0.63000000f,0.16000000f,-0.17000000f,0.29000000f,-0.19000000f,0.87000000f,0.49000000f,-0.09000000f,0.27000000f,-0.24000000f,0.73000000f,-0.55000000f,0.97000000f,-0.62000000f,0.64000000f,0.27000000f,-0.66000000f,-0.34000000f,0.39000000f,0.81000000f,-0.13000000f,0.14000000f,0.88000000f,-0.43000000f,0.79000000f,-0.88000000f,0.91000000f,-0.25000000f,-0.24000000f,-0.40000000f,-0.51000000f,-0.61000000f,0.11000000f,0.45000000f,0.23000000f,0.60000000f,-0.73000000f,0.20000000f,0.65000000f,-0.25000000f,-0.67000000f,0.76000000f,-0.83000000f,0.64000000f,-0.01000000f,-0.51000000f,-0.27000000f,-0.03000000f,0.33000000f,0.27000000f,-0.69000000f,-0.85000000f,0.06000000f,0.53000000f,-0.78000000f,0.85000000f,-0.26000000f,0.46000000f,-0.79000000f,0.86000000f,-0.25000000f,-0.67000000f,-0.88000000f,-0.69000000f,-0.71000000f,0.58000000f,0.09000000f,-0.60000000f,0.83000000f,0.40000000f,-0.88000000f,-0.15000000f,0.46000000f,0.05000000f,0.37000000f,0.25000000f,-0.85000000f,-0.39000000f,0.69000000f,-0.68000000f,-0.21000000f,0.97000000f,-0.03000000f,-0.13000000f,-0.59000000f,0.65000000f,-0.72000000f,-0.84000000f,-0.80000000f,0.42000000f,-0.36000000f,-0.11000000f,-0.84000000f,-0.27000000f,-0.13000000f,-0.03000000f,0.82000000f,0.33000000f,-0.24000000f,0.30000000f,-0.28000000f,0.41000000f,-0.56000000f,-0.47000000f,-0.18000000f,-0.57000000f,-0.56000000f,-0.87000000f,-0.05000000f,-0.17000000f,-0.31000000f,-0.73000000f,-0.89000000f,0.01000000f,0.20000000f,0.06000000f,-0.85000000f,-0.75000000f,0.78000000f,-0.60000000f,0.87000000f,0.91000000f,-0.13000000f,0.75000000f,-0.49000000f,0.96000000f,-0.60000000f,-0.87000000f,-0.49000000f,0.83000000f,0.42000000f,-0.29000000f,0.32000000f,-0.46000000f,-0.84000000f,0.37000000f,-0.36000000f,0.39000000f,-0.72000000f,0.24000000f,0.28000000f,-0.63000000f,0.40000000f,0.92000000f,-0.75000000f,-0.68000000f,0.74000000f,0.07000000f,0.60000000f,0.22000000f,-0.50000000f,-0.10000000f,-0.08000000f,0.50000000f,-0.34000000f,0.24000000f,-0.77000000f,-0.23000000f,0.77000000f,0.89000000f,-0.20000000f,0.89000000f,-0.95000000f,0.35000000f,0.19000000f,0.70000000f,-0.10000000f,0.07000000f,0.71000000f,0.16000000f,0.33000000f,0.37000000f,0.13000000f,-0.98000000f,-0.12000000f,-0.50000000f,0.68000000f,-0.62000000f,-0.38000000f,0.13000000f,0.86000000f,0.22000000f,-0.56000000f,0.35000000f,-0.98000000f,-0.72000000f,0.86000000f,-0.44000000f,0.73000000f,0.57000000f,0.84000000f,-0.93000000f,-0.62000000f,-0.67000000f,0.14000000f,-0.73000000f,-0.85000000f,-0.38000000f,0.01000000f,-0.87000000f,0.05000000f,-0.98000000f,-0.18000000f,0.56000000f,0.90000000f,-0.66000000f,-0.81000000f,0.09000000f,-0.63000000f,0.04000000f,-0.88000000f,0.74000000f,0.73000000f,0.71000000f,0.68000000f,0.27000000f,-0.52000000f,0.16000000f,-0.72000000f,0.10000000f,-0.71000000f,0.97000000f,-0.55000000f,-0.06000000f,-0.68000000f,-0.74000000f,-0.66000000f,-0.93000000f,0.23000000f,-0.35000000f,0.37000000f,0.54000000f,0.60000000f,0.10000000f,-0.76000000f,0.45000000f,-0.66000000f,-0.08000000f,0.98000000f,-0.09000000f,0.96000000f,-0.54000000f,-0.33000000f,-0.04000000f,0.36000000f,0.86000000f,-0.42000000f,-0.50000000f,0.45000000f,0.33000000f,0.78000000f,0.25000000f,0.58000000f,0.15000000f,-0.89000000f,-0.49000000f,0.42000000f,0.78000000f,-0.86000000f,-0.65000000f,0.81000000f,-0.67000000f,0.62000000f,0.14000000f,0.62000000f,0.05000000f,-0.93000000f,0.34000000f,-0.40000000f,0.01000000f,0.46000000f,-0.34000000f,0.51000000f,-0.86000000f,0.94000000f,-0.20000000f,-0.75000000f,0.27000000f,-0.09000000f,0.41000000f,-0.86000000f,0.80000000f,-0.13000000f,-0.31000000f,0.52000000f,-0.12000000f,0.46000000f,0.58000000f,0.60000000f,-0.12000000f,-0.45000000f,-0.61000000f,-0.33000000f,-0.80000000f,-0.25000000f,-0.00000000f,-0.20000000f,-0.48000000f,-0.98000000f,0.96000000f,-0.86000000f,-0.21000000f,0.30000000f,0.26000000f,0.53000000f,0.83000000f,0.82000000f,-0.39000000f,-0.66000000f,-0.69000000f,-0.42000000f,0.35000000f,-0.88000000f,0.27000000f,-0.34000000f,-0.21000000f,-0.89000000f,0.74000000f,-0.98000000f,-0.35000000f,-0.72000000f,-0.37000000f,-0.32000000f,0.39000000f,-0.24000000f,-0.83000000f,0.95000000f,-0.43000000f,0.72000000f,0.24000000f,-0.85000000f,-0.19000000f,0.55000000f,0.02000000f,0.34000000f,-0.41000000f,-0.08000000f,-0.25000000f,0.40000000f,-0.00000000f,0.58000000f,0.43000000f,0.79000000f,0.29000000f,-0.57000000f,-0.02000000f,-0.31000000f,-0.01000000f,0.33000000f,-0.09000000f,-0.07000000f,0.53000000f,-0.58000000f,0.94000000f,-0.64000000f,0.37000000f,0.63000000f,-0.79000000f,0.21000000f,0.72000000f,0.24000000f,0.09000000f,0.34000000f,0.15000000f,0.41000000f,0.94000000f,0.69000000f,0.51000000f,0.52000000f,-0.03000000f,-0.81000000f,-0.99000000f,-0.76000000f,0.33000000f,0.61000000f,0.03000000f,-0.61000000f,0.78000000f,0.69000000f,0.62000000f,-0.22000000f,-0.70000000f,-0.64000000f,0.55000000f,-0.56000000f,0.24000000f,-0.39000000f,0.33000000f,-0.08000000f,0.92000000f,0.88000000f,-0.94000000f,-0.85000000f,-0.47000000f,-0.96000000f,-0.51000000f,0.22000000f,0.87000000f,-0.85000000f,0.51000000f,0.27000000f,0.12000000f,-0.83000000f,-0.13000000f,-0.63000000f,0.72000000f,0.51000000f,0.35000000f,-0.94000000f,0.60000000f,0.79000000f,-0.57000000f,-0.70000000f,0.21000000f,-0.68000000f,-0.84000000f,0.10000000f,0.76000000f,0.92000000f,0.60000000f,-0.16000000f,0.85000000f,-0.28000000f,-0.00000000f,0.25000000f,0.61000000f,0.69000000f,-0.62000000f,0.17000000f,0.05000000f,0.08000000f,-0.87000000f,0.23000000f,0.95000000f,-0.82000000f,0.84000000f,-0.58000000f,0.76000000f,-0.46000000f,-0.35000000f,0.76000000f,-0.57000000f,0.70000000f,-0.14000000f,0.55000000f,0.57000000f,0.57000000f,-0.28000000f,-0.18000000f,0.46000000f,0.89000000f,0.07000000f,0.45000000f,-0.65000000f,-0.46000000f,0.01000000f,0.32000000f,-0.96000000f,-0.71000000f,0.05000000f,0.35000000f,-0.90000000f,-0.56000000f,0.72000000f,-0.33000000f,-0.48000000f,0.42000000f,0.32000000f,0.16000000f,-0.55000000f,-0.83000000f,0.42000000f,0.74000000f,0.41000000f,0.93000000f,0.61000000f,-0.39000000f,-0.03000000f,-0.81000000f,-0.37000000f,-0.55000000f,-0.06000000f,0.62000000f,0.69000000f,0.74000000f,0.21000000f,0.12000000f,-0.18000000f,0.25000000f,-0.66000000f,0.40000000f,-0.33000000f,0.95000000f,0.72000000f,0.29000000f,0.71000000f,-0.46000000f,-0.56000000f,-0.79000000f,0.59000000f,-0.71000000f,-0.02000000f,0.61000000f,0.66000000f,0.23000000f,-0.44000000f,0.99000000f,0.66000000f,-0.47000000f,0.99000000f,0.68000000f,-0.21000000f,-0.96000000f,-0.67000000f,0.39000000f,0.22000000f,-0.72000000f,0.01000000f,0.62000000f,0.68000000f,-0.87000000f,-0.92000000f,-0.64000000f,-0.60000000f,-0.51000000f,-0.45000000f,0.72000000f,-0.86000000f,0.99000000f,-0.77000000f,0.36000000f,0.20000000f,0.17000000f,-0.32000000f,-0.06000000f,0.10000000f,0.63000000f,-0.08000000f,-0.01000000f,0.58000000f,-0.31000000f,0.18000000f,-0.09000000f,0.10000000f,-0.72000000f,0.98000000f,-0.76000000f,-0.21000000f,-0.61000000f,0.19000000f,-0.52000000f,0.13000000f,0.39000000f,-0.53000000f,-0.86000000f,-0.91000000f,-0.57000000f,0.61000000f,0.47000000f,-0.73000000f,0.63000000f,0.07000000f,0.90000000f,-0.58000000f,0.52000000f,0.45000000f,-0.51000000f,-0.87000000f,0.31000000f,0.25000000f,-0.08000000f,0.53000000f,-0.73000000f,-0.08000000f,-0.86000000f,-0.63000000f,0.63000000f,-0.40000000f,-0.66000000f,-0.40000000f,-0.71000000f,-0.76000000f,0.66000000f,-0.22000000f,-0.58000000f,0.49000000f,-0.97000000f,0.84000000f,0.96000000f,-0.09000000f,-0.92000000f,-0.24000000f,0.01000000f,-0.97000000f,-0.80000000f,0.00000000f,-0.99000000f,0.62000000f,0.62000000f,-0.32000000f,0.11000000f,0.30000000f,0.80000000f,0.62000000f,-0.57000000f,0.89000000f,0.57000000f,-0.87000000f,-0.95000000f,0.74000000f,-0.57000000f,-0.31000000f,0.05000000f,-0.78000000f,-0.51000000f,0.84000000f,-0.40000000f,-0.97000000f,-0.31000000f,0.89000000f,-0.41000000f,0.15000000f,0.52000000f,0.19000000f,-0.33000000f,0.07000000f,0.74000000f,0.06000000f,-0.64000000f,-0.70000000f,0.58000000f,-0.31000000f,-0.99000000f,-0.46000000f,0.28000000f,0.08000000f,-0.73000000f,-0.31000000f,0.70000000f,-0.90000000f,0.28000000f,0.88000000f,-0.92000000f,-0.21000000f,-0.63000000f,0.47000000f,0.72000000f,0.86000000f,0.95000000f,0.79000000f,0.34000000f,0.16000000f,0.91000000f,0.65000000f,-0.86000000f,-0.81000000f,0.67000000f,0.18000000f,-0.58000000f,0.25000000f,-0.49000000f,0.52000000f,-0.86000000f,-0.25000000f,0.11000000f,-0.97000000f,0.44000000f,0.43000000f,0.64000000f,0.27000000f,-0.64000000f,-0.44000000f,0.96000000f,-0.44000000f,-0.79000000f,0.17000000f,-0.21000000f,0.86000000f,-0.61000000f,-0.16000000f,-0.68000000f,0.95000000f,0.67000000f,0.58000000f,0.10000000f,0.61000000f,-0.99000000f,-0.01000000f,0.86000000f,-0.80000000f,0.35000000f,-0.44000000f,0.84000000f,0.92000000f,-0.35000000f,0.62000000f,-0.40000000f,0.71000000f,-0.38000000f,0.43000000f,0.02000000f,0.74000000f,-0.66000000f,0.68000000f,0.29000000f,-0.79000000f,0.36000000f,0.07000000f,-0.04000000f,0.43000000f,-0.51000000f,-0.47000000f,0.55000000f,0.15000000f,0.82000000f,-0.94000000f,-0.59000000f,-0.85000000f,-0.74000000f,0.85000000f,0.41000000f,0.59000000f,0.53000000f,0.91000000f,0.12000000f,0.92000000f,-0.52000000f,0.41000000f,0.41000000f,-0.25000000f,0.64000000f,-0.45000000f,0.25000000f,-0.56000000f,-0.53000000f,0.16000000f,-0.75000000f,-0.85000000f,-0.16000000f,-0.84000000f,-0.85000000f,-0.57000000f,-0.57000000f,-0.00000000f,0.41000000f,-0.96000000f,0.34000000f,0.47000000f,-0.53000000f,-0.84000000f,0.00000000f,0.39000000f,-0.38000000f,0.87000000f,-0.84000000f,0.56000000f,-0.49000000f,0.32000000f,0.23000000f,-0.04000000f,-0.16000000f,-0.01000000f,-0.47000000f,-0.02000000f,0.57000000f,-0.69000000f,-0.71000000f,-0.71000000f,0.72000000f,0.82000000f,0.65000000f,0.73000000f,-0.31000000f,0.76000000f,-0.64000000f,0.15000000f,-0.50000000f,-0.59000000f,-0.94000000f,0.81000000f,0.78000000f,-0.19000000f,-0.56000000f,0.87000000f,-0.71000000f,0.65000000f,0.43000000f,0.79000000f,0.33000000f,0.07000000f,0.33000000f,-0.77000000f,0.11000000f,0.88000000f,0.47000000f,0.66000000f,-0.62000000f,0.89000000f,0.22000000f,-0.49000000f,-0.71000000f,-0.87000000f,0.77000000f,-0.86000000f,0.08000000f,-0.53000000f,-0.58000000f,0.89000000f,0.57000000f,-0.65000000f,-0.25000000f,-0.48000000f,-0.28000000f,-0.59000000f,0.60000000f,-0.56000000f,-0.06000000f,0.33000000f,0.29000000f,-0.00000000f,-0.66000000f,0.86000000f,-0.90000000f,-0.59000000f,-0.32000000f,0.00000000f,-0.16000000f,-0.59000000f,0.23000000f,0.45000000f,-0.86000000f,0.59000000f,0.37000000f,-0.79000000f,-0.57000000f,0.77000000f,0.34000000f,-0.08000000f,-0.98000000f,0.01000000f,0.69000000f,0.28000000f,-0.84000000f,0.74000000f,-0.02000000f,0.49000000f,0.29000000f,0.07000000f,0.09000000f,0.47000000f,0.87000000f,0.25000000f,0.38000000f,-0.31000000f,-0.12000000f,-0.23000000f,0.23000000f,-0.94000000f,-0.48000000f,0.38000000f,-0.12000000f,-0.66000000f,-0.72000000f,-0.21000000f,0.83000000f,0.78000000f,-0.27000000f,0.81000000f,0.58000000f,-0.93000000f,-0.63000000f,-0.42000000f,-0.16000000f,-0.96000000f,-0.73000000f,0.76000000f,0.32000000f,-0.60000000f,0.50000000f,0.24000000f,-0.48000000f,-0.20000000f,0.99000000f,-0.24000000f,0.59000000f,0.07000000f,-0.80000000f,-0.01000000f,0.45000000f,-0.48000000f,0.34000000f,-0.60000000f,0.15000000f,-0.40000000f,0.68000000f,0.69000000f,0.13000000f,-0.99000000f,-0.21000000f,-0.17000000f,0.29000000f,-0.20000000f,0.86000000f,-0.80000000f,0.82000000f,-0.36000000f,0.79000000f,0.75000000f,-0.37000000f,-0.54000000f,0.16000000f,-0.86000000f,0.36000000f,-0.46000000f,0.33000000f,-0.31000000f,0.75000000f,-0.62000000f,0.79000000f,-0.45000000f,0.34000000f,-0.72000000f,-0.67000000f,0.06000000f,0.17000000f,0.57000000f,0.89000000f,-0.08000000f,0.58000000f,-0.01000000f,0.27000000f,0.05000000f,-0.42000000f,-0.22000000f,0.86000000f,0.92000000f,-0.66000000f,-0.01000000f,-0.62000000f,0.62000000f,0.57000000f,0.17000000f,0.47000000f,-0.50000000f,-0.72000000f,-0.90000000f,0.05000000f,-0.40000000f,-0.77000000f,-0.71000000f,-0.03000000f,-0.81000000f,0.11000000f,-0.34000000f,-0.70000000f,0.05000000f,0.74000000f,-0.27000000f,-0.50000000f,-0.47000000f,0.87000000f,-0.15000000f,0.14000000f,0.31000000f,-0.67000000f,0.74000000f,-0.55000000f,0.41000000f,-0.80000000f,0.84000000f,-0.23000000f,0.10000000f,-0.17000000f,0.65000000f,0.79000000f,-0.67000000f,0.67000000f,-0.17000000f,0.32000000f,-0.06000000f,0.44000000f,0.13000000f,0.26000000f,-0.67000000f,0.63000000f,-0.17000000f,0.40000000f,0.26000000f,0.55000000f,0.29000000f,0.62000000f,0.83000000f,-0.41000000f,-0.07000000f,0.40000000f,-0.40000000f,-0.21000000f,0.45000000f,-0.88000000f,-0.83000000f,0.85000000f,-0.84000000f,0.43000000f,0.44000000f,0.24000000f,-0.32000000f,0.29000000f,-0.62000000f,-0.24000000f,0.38000000f,-0.84000000f,-0.97000000f,-0.68000000f,0.44000000f,-0.70000000f,-0.95000000f,-0.70000000f,-0.39000000f,-0.30000000f,-0.72000000f,-0.55000000f,-0.09000000f,-0.15000000f,0.77000000f,0.40000000f,-0.16000000f,-0.94000000f,-0.24000000f,-0.79000000f,-0.94000000f,0.46000000f,-0.35000000f,0.93000000f,0.10000000f,0.39000000f,-0.37000000f,-0.63000000f,0.03000000f,-0.13000000f,0.64000000f,0.49000000f,-0.52000000f,0.24000000f,-0.59000000f,0.13000000f,0.42000000f,-0.19000000f,0.33000000f,-0.33000000f,-0.67000000f,0.43000000f,0.22000000f,-0.85000000f,0.83000000f,-0.51000000f,0.60000000f,0.15000000f,-0.90000000f,-0.24000000f,-0.39000000f,0.90000000f,-0.87000000f,0.39000000f,-0.70000000f,-0.05000000f,-0.09000000f,-0.95000000f,-0.05000000f,-0.08000000f,0.92000000f,0.95000000f,-0.15000000f,-0.85000000f,-0.87000000f,0.53000000f,-0.31000000f,0.49000000f,-0.59000000f,0.92000000f,-0.82000000f,-0.97000000f,0.40000000f,-0.60000000f,0.80000000f,-0.48000000f,-0.68000000f,0.33000000f,0.73000000f,-0.37000000f,-0.31000000f,0.26000000f,0.62000000f,0.11000000f,0.65000000f,-0.73000000f,0.26000000f,-0.88000000f,0.33000000f,-0.03000000f,-0.54000000f,-0.92000000f,-0.74000000f,-0.80000000f,-0.82000000f,-0.61000000f,-0.97000000f,-0.09000000f,-0.81000000f,-0.83000000f,-0.84000000f,0.02000000f,-0.26000000f,0.60000000f,-0.30000000f,0.41000000f,-0.59000000f,-0.07000000f,-0.70000000f,0.74000000f,0.25000000f,-0.50000000f,0.88000000f,0.73000000f,-0.40000000f,0.49000000f,0.84000000f,0.27000000f,0.80000000f,-0.06000000f,-0.26000000f,0.16000000f,-0.87000000f,-0.86000000f,0.19000000f,0.88000000f,0.00000000f,0.19000000f,0.89000000f,0.94000000f,0.11000000f,-0.09000000f,0.04000000f,-0.15000000f,-0.07000000f,0.56000000f,0.71000000f,-0.94000000f,-0.13000000f,0.72000000f,0.50000000f,-0.17000000f,-0.58000000f,-0.35000000f,0.20000000f,-0.18000000f,-0.31000000f,-0.80000000f,-0.95000000f,-0.00000000f,0.84000000f,0.91000000f,0.34000000f,0.89000000f,-0.08000000f,0.90000000f,0.80000000f,-0.41000000f,-0.50000000f,0.95000000f,0.41000000f,0.52000000f,-0.21000000f,-0.99000000f,-0.77000000f,0.41000000f,-0.32000000f,-0.99000000f,0.21000000f,0.29000000f,0.82000000f,0.99000000f,0.57000000f,-0.46000000f,0.77000000f,-0.43000000f,-0.71000000f,0.13000000f,-0.61000000f,-0.38000000f,0.89000000f,-0.15000000f,-0.46000000f,-0.81000000f,-0.75000000f,0.54000000f,0.45000000f,0.88000000f,-0.25000000f,-0.74000000f,0.38000000f,0.52000000f,-0.93000000f,0.54000000f,0.50000000f,0.52000000f,0.41000000f,-0.64000000f,0.64000000f,0.04000000f,0.33000000f,0.38000000f,-0.97000000f,0.08000000f,-0.90000000f,0.49000000f,0.54000000f,-0.09000000f,0.90000000f,0.66000000f,0.20000000f,-0.75000000f,-0.42000000f,0.64000000f,0.33000000f,0.21000000f,-0.08000000f,0.02000000f,0.92000000f,-0.18000000f,-0.28000000f,0.75000000f,0.13000000f,0.37000000f,0.17000000f,0.89000000f,0.23000000f,-0.47000000f,0.90000000f,-0.24000000f,0.13000000f,-0.81000000f,0.73000000f,-0.12000000f,0.76000000f,-0.54000000f,0.19000000f,0.98000000f,0.81000000f,0.99000000f,0.76000000f,-0.33000000f,0.12000000f,0.22000000f,0.02000000f,-0.43000000f,-0.39000000f,-0.74000000f,-0.79000000f,0.26000000f,-0.14000000f,0.52000000f,-0.96000000f,-0.60000000f,-0.79000000f,-0.53000000f,0.11000000f,0.65000000f,-0.12000000f,-0.92000000f,-0.85000000f,-0.06000000f,0.31000000f,-0.55000000f,0.27000000f,-0.87000000f,-0.46000000f,-0.95000000f,0.23000000f,-0.52000000f,-0.96000000f,0.06000000f,-0.22000000f,-0.44000000f,-0.11000000f,0.34000000f,-0.89000000f,0.43000000f,-0.24000000f,0.48000000f,-0.07000000f,0.08000000f,-0.85000000f,-0.25000000f,0.92000000f,-0.27000000f,-0.03000000f,-0.06000000f,-0.85000000f,0.12000000f,-0.55000000f,-0.70000000f,-0.11000000f,0.70000000f,0.69000000f,0.76000000f,-0.91000000f,-0.63000000f,-0.61000000f,-0.98000000f,0.73000000f,-0.90000000f,-0.62000000f,0.68000000f,-0.87000000f,-0.56000000f,-0.27000000f,-0.70000000f,0.99000000f,0.79000000f,-0.41000000f,0.54000000f,-0.64000000f,0.61000000f,-0.35000000f,0.90000000f,-0.33000000f,0.51000000f,-0.59000000f,0.95000000f,-0.73000000f,0.15000000f,-0.22000000f,0.26000000f,0.72000000f,0.51000000f,0.61000000f,-0.00000000f,0.37000000f,0.58000000f,0.26000000f,-0.13000000f,0.41000000f,0.41000000f,-0.95000000f,-0.79000000f,0.58000000f,-0.20000000f,-0.86000000f,-0.20000000f,-0.60000000f,-0.44000000f,0.11000000f,-0.23000000f,0.91000000f,0.01000000f,0.87000000f,-0.19000000f,0.24000000f,0.01000000f,-0.88000000f,0.09000000f,0.08000000f,0.83000000f,0.02000000f,-0.57000000f,-0.21000000f,0.93000000f,0.91000000f,0.51000000f,-0.74000000f,0.29000000f,0.31000000f,0.41000000f,0.55000000f,0.72000000f,-0.93000000f,-0.47000000f,0.95000000f,-0.73000000f,-0.76000000f,-0.98000000f,-0.84000000f,0.31000000f,-0.89000000f,-0.27000000f,-0.70000000f,-0.22000000f,0.39000000f,0.81000000f,-0.85000000f,0.69000000f,-0.50000000f,-0.53000000f,-0.14000000f,-0.02000000f,0.31000000f,-0.74000000f,-0.19000000f,0.84000000f,0.99000000f,-0.92000000f,-0.35000000f,-0.30000000f,0.85000000f,-0.64000000f,-0.84000000f,0.69000000f,0.77000000f,0.91000000f,0.04000000f,0.94000000f,0.44000000f,0.28000000f,0.13000000f,-0.65000000f,-0.84000000f,0.61000000f,0.01000000f,0.78000000f,-0.17000000f,0.27000000f,0.72000000f,-0.14000000f,-0.18000000f,0.70000000f,-0.19000000f,0.57000000f,-0.89000000f,0.48000000f,0.36000000f,0.39000000f,0.46000000f,0.67000000f,0.16000000f,-0.86000000f,-0.52000000f,0.20000000f,-0.18000000f,0.70000000f,-0.11000000f,-0.57000000f,-0.96000000f,-0.27000000f,0.41000000f,0.72000000f,-0.33000000f,-0.93000000f,0.99000000f,-0.90000000f,0.79000000f,0.17000000f,-0.40000000f,-0.13000000f,0.92000000f,0.74000000f,-0.58000000f,-0.76000000f,-0.93000000f,0.65000000f,0.97000000f,0.27000000f,-0.84000000f,-0.61000000f,0.83000000f,-0.56000000f,-0.76000000f,-0.69000000f,-0.44000000f,-0.84000000f,-0.95000000f,0.33000000f,0.88000000f,-0.70000000f,0.30000000f,-0.69000000f,0.50000000f,-0.65000000f,-0.16000000f,-0.51000000f,0.81000000f,0.13000000f,-0.45000000f,0.35000000f,-0.10000000f,0.31000000f,-0.21000000f,0.39000000f,0.49000000f,-0.66000000f,0.44000000f,0.71000000f,0.87000000f,-0.61000000f,0.86000000f,-0.65000000f,0.87000000f,-0.89000000f,0.70000000f,-0.20000000f,-0.83000000f,0.61000000f,0.43000000f,-0.98000000f,-0.09000000f,-0.20000000f,-0.09000000f,0.99000000f,0.45000000f,0.28000000f,-0.28000000f,-0.46000000f,0.05000000f,0.96000000f,0.66000000f,0.72000000f,0.27000000f,-0.07000000f,-0.27000000f,0.54000000f,0.16000000f,0.54000000f,-0.60000000f,-0.50000000f,-0.94000000f,-0.28000000f,-0.05000000f,0.52000000f,0.65000000f,-0.99000000f,0.50000000f,-0.51000000f,0.28000000f,-0.93000000f,-0.15000000f,-0.64000000f,-0.62000000f,0.36000000f,-0.83000000f,0.86000000f,0.42000000f,0.60000000f,0.59000000f,0.42000000f,0.89000000f,0.50000000f,0.73000000f,-0.41000000f,-0.61000000f,-0.51000000f,-0.32000000f,-0.53000000f,0.64000000f,0.98000000f,-0.94000000f,-0.13000000f,0.06000000f,0.20000000f,-0.18000000f,-0.05000000f,0.50000000f,-0.39000000f,-0.08000000f,0.94000000f,-0.22000000f,-0.01000000f,0.51000000f,0.43000000f,-0.18000000f,-0.40000000f,0.08000000f,-0.40000000f,0.44000000f,-0.45000000f,-0.39000000f,0.39000000f,0.02000000f,0.81000000f,-0.75000000f,0.91000000f,-0.83000000f,0.06000000f,-0.36000000f,0.03000000f,0.11000000f,-0.19000000f,-0.29000000f,0.21000000f,-0.61000000f,0.44000000f,-0.86000000f,-0.69000000f,-0.18000000f,0.51000000f,0.90000000f,-0.05000000f,0.39000000f,-0.89000000f,-0.61000000f,0.66000000f,-0.06000000f,0.90000000f,0.20000000f,0.91000000f,-0.50000000f,-0.63000000f,0.68000000f,0.40000000f,-0.30000000f,0.28000000f,0.98000000f,-0.56000000f,-0.13000000f,-0.12000000f,0.29000000f,0.66000000f,0.07000000f,0.48000000f,0.60000000f,0.09000000f,0.09000000f,0.38000000f,0.63000000f,-0.27000000f,0.35000000f,-0.26000000f,-0.83000000f,-0.63000000f,-0.84000000f,0.87000000f,-0.94000000f,0.07000000f,0.17000000f,-0.98000000f,0.76000000f,-0.98000000f,0.81000000f,0.18000000f,-0.77000000f,-0.80000000f,-0.26000000f,0.76000000f,0.41000000f,-0.40000000f,-0.80000000f,0.16000000f,0.96000000f,0.81000000f,0.47000000f,-0.29000000f,0.57000000f,-0.06000000f,-0.04000000f,-0.30000000f,-0.92000000f,-0.18000000f,0.32000000f,-0.66000000f,-0.90000000f,0.74000000f,0.61000000f,0.37000000f,0.34000000f,0.67000000f,0.08000000f,0.80000000f,-0.27000000f,-0.49000000f,-0.15000000f,0.84000000f,-0.71000000f,0.56000000f,0.24000000f,0.89000000f,-0.00000000f,-0.44000000f,0.67000000f,-0.27000000f,0.31000000f,-0.86000000f,0.52000000f,0.87000000f,-0.03000000f,-0.34000000f,-0.38000000f,0.82000000f,0.84000000f,-0.30000000f,-0.13000000f,0.86000000f,-0.35000000f,0.67000000f,0.45000000f,-0.24000000f,0.95000000f,0.70000000f,-0.83000000f,-0.17000000f,-0.09000000f,-0.35000000f,-0.47000000f,0.71000000f,-0.75000000f,0.33000000f,0.64000000f,-0.68000000f,0.43000000f,0.38000000f,0.48000000f,0.21000000f,0.85000000f,-0.77000000f,0.11000000f,-0.19000000f,0.05000000f,-0.17000000f,-0.67000000f,-0.84000000f,-0.54000000f,-0.54000000f,-0.70000000f,-0.39000000f,-0.52000000f,-0.42000000f,-0.78000000f,0.39000000f,0.70000000f,-0.06000000f,-0.79000000f,0.41000000f,0.94000000f,0.83000000f,-0.33000000f,0.98000000f,-0.14000000f,-0.40000000f,-0.72000000f,0.66000000f,0.79000000f,0.79000000f,0.29000000f,-0.14000000f,-0.34000000f,0.40000000f,-0.95000000f,0.90000000f,-0.38000000f,-0.29000000f,0.95000000f,0.72000000f,0.17000000f,-0.54000000f,0.29000000f,-0.10000000f,0.93000000f,0.69000000f,-0.19000000f,0.20000000f,0.02000000f,0.96000000f,-0.05000000f,-0.49000000f,-0.93000000f,0.32000000f,-0.31000000f,0.07000000f,0.71000000f,-0.58000000f,0.08000000f,0.95000000f,-0.55000000f,0.95000000f,0.05000000f,0.42000000f,-0.98000000f,0.95000000f,-0.09000000f,-0.77000000f,0.42000000f,0.60000000f,-0.16000000f,0.29000000f,0.25000000f,0.39000000f,-0.81000000f,-0.90000000f,0.46000000f,-0.30000000f,0.10000000f,0.07000000f,0.81000000f,-0.57000000f,-0.31000000f,-0.21000000f,-0.12000000f,0.01000000f,-0.11000000f,0.66000000f,0.01000000f,0.90000000f,-0.38000000f,0.52000000f,0.08000000f,-0.77000000f,-0.66000000f,-0.54000000f,0.00000000f,-0.44000000f,0.17000000f,0.38000000f,-0.33000000f,0.80000000f,-0.80000000f,0.15000000f,-0.51000000f,-0.23000000f,-0.52000000f,0.37000000f,0.58000000f,-0.35000000f,-0.71000000f,-0.79000000f,-0.47000000f,-0.69000000f,-0.88000000f,-0.48000000f,0.28000000f,0.71000000f,0.46000000f,-0.28000000f,-0.13000000f,0.64000000f,-0.43000000f,-0.44000000f,0.44000000f,-0.11000000f,0.22000000f,0.10000000f,-0.94000000f,0.42000000f,-0.15000000f,0.25000000f,-0.25000000f,-0.88000000f,-0.29000000f,0.92000000f,-0.13000000f,0.06000000f,-0.35000000f,-0.66000000f,-0.77000000f,0.02000000f,-0.55000000f,0.51000000f,-0.57000000f,0.50000000f,0.68000000f,-0.22000000f,0.23000000f,0.00000000f,-0.66000000f,-0.36000000f,0.44000000f,0.25000000f,0.28000000f,0.96000000f,0.68000000f,-0.22000000f,-0.33000000f,-0.67000000f,0.11000000f,-0.33000000f,-0.15000000f,-0.16000000f,-0.87000000f,-0.37000000f,0.18000000f,0.62000000f,-0.25000000f,-0.13000000f,0.65000000f,-0.03000000f,-0.00000000f,0.30000000f,0.77000000f,0.63000000f,0.57000000f,0.93000000f,-0.37000000f,-0.06000000f,-0.72000000f,0.39000000f,0.36000000f,-0.28000000f,0.53000000f,0.00000000f,0.71000000f,-0.57000000f,-0.64000000f,0.30000000f,-0.40000000f,-0.30000000f,0.05000000f,-0.90000000f,0.36000000f,0.87000000f,0.77000000f,0.03000000f,-0.41000000f,-0.91000000f,0.81000000f,0.16000000f,-0.12000000f,-0.18000000f,0.30000000f,-0.51000000f,0.26000000f,-0.46000000f,-0.62000000f,0.79000000f,-0.98000000f,-0.60000000f,-0.90000000f,0.01000000f,-0.52000000f,0.66000000f,-0.49000000f,0.75000000f,-0.68000000f,-0.78000000f,-0.70000000f,0.44000000f,0.07000000f,-0.90000000f,-0.50000000f,0.22000000f,0.04000000f,-0.54000000f,0.35000000f,-0.38000000f,0.18000000f,-0.04000000f,-0.09000000f,-0.83000000f,-0.16000000f,-0.99000000f,-0.78000000f,-0.73000000f,0.71000000f,0.27000000f,0.15000000f,0.19000000f,0.29000000f,-0.20000000f,0.00000000f,0.38000000f,0.84000000f,-0.20000000f,0.28000000f,0.19000000f,-0.02000000f,-0.50000000f,-0.66000000f,-0.23000000f,0.79000000f,0.62000000f,0.20000000f,-0.24000000f,0.60000000f,-0.39000000f,-0.61000000f,-0.53000000f,-0.93000000f,0.99000000f,0.78000000f,-0.92000000f,0.92000000f,0.43000000f,0.46000000f,0.87000000f,0.32000000f,-0.53000000f,0.85000000f,-0.73000000f,-0.71000000f,-0.39000000f,-0.90000000f,-0.63000000f,0.01000000f,-0.38000000f,-0.62000000f,-0.25000000f,-0.37000000f,0.60000000f,-0.01000000f,0.18000000f,0.95000000f,0.99000000f,-0.70000000f,-0.76000000f,-0.15000000f,-0.78000000f,0.02000000f,0.08000000f,0.27000000f,-0.61000000f,0.62000000f,0.59000000f,-0.04000000f,0.46000000f,-0.63000000f,-0.05000000f,0.85000000f,-0.05000000f,-0.84000000f,-0.35000000f,-0.35000000f,0.63000000f,0.55000000f,-0.33000000f,-0.53000000f,0.62000000f,0.64000000f,-0.02000000f,0.06000000f,-0.39000000f,-0.55000000f,-0.09000000f,-0.17000000f,-0.09000000f,-0.84000000f,0.94000000f,-0.08000000f,-0.95000000f,-0.25000000f,0.12000000f,-0.26000000f,-0.94000000f,0.32000000f,-0.60000000f,-0.11000000f,-0.27000000f,-0.32000000f,0.31000000f,0.97000000f,0.64000000f,0.99000000f,-0.99000000f,-0.56000000f,0.96000000f,0.11000000f,-0.57000000f,-0.51000000f,0.82000000f,-0.35000000f,0.13000000f,0.70000000f,-0.97000000f,0.92000000f,0.59000000f,-0.03000000f,0.15000000f,-0.09000000f,0.46000000f,0.28000000f,0.73000000f,-0.17000000f,0.26000000f,-0.23000000f,0.45000000f,-0.96000000f,0.21000000f,-0.28000000f,-0.64000000f,-0.09000000f,0.68000000f,0.49000000f,-0.30000000f,-0.75000000f,0.98000000f,-0.71000000f,-0.42000000f,-0.52000000f,0.19000000f,0.52000000f,0.30000000f,0.92000000f,0.61000000f,-0.53000000f,0.62000000f,-0.15000000f,0.19000000f,0.07000000f,0.67000000f,0.92000000f,0.20000000f,-0.69000000f,-0.29000000f,-0.75000000f,0.54000000f,0.78000000f,0.92000000f,-0.70000000f,-0.70000000f,-0.40000000f,-0.41000000f,0.89000000f,-0.29000000f,0.02000000f,0.34000000f,-0.24000000f,0.48000000f,0.97000000f,0.75000000f,-0.66000000f,0.17000000f,-0.32000000f,-0.41000000f,0.24000000f,0.85000000f,-0.70000000f,0.39000000f,0.46000000f,-0.84000000f,0.86000000f,0.45000000f,-0.78000000f,-0.61000000f,0.74000000f,0.73000000f,0.78000000f,0.66000000f,-0.15000000f,-0.85000000f,0.46000000f,0.46000000f,-0.21000000f,-0.78000000f,-0.16000000f,0.12000000f,0.83000000f,0.05000000f,-0.95000000f,0.41000000f,0.45000000f,-0.02000000f,0.56000000f,-0.91000000f,-0.90000000f,-0.33000000f,-0.94000000f,-0.72000000f,-0.90000000f,-0.22000000f,-0.01000000f,-0.59000000f,0.58000000f,-0.37000000f,0.23000000f,-0.96000000f,0.41000000f,-0.65000000f,0.69000000f,-0.79000000f,0.14000000f,0.39000000f,-0.99000000f,-0.21000000f,-0.73000000f,-0.33000000f,0.53000000f,-0.15000000f,-0.04000000f,-0.00000000f,0.33000000f,0.12000000f,-0.44000000f,-0.88000000f,-0.93000000f,0.05000000f,0.73000000f,-0.66000000f,-0.85000000f,-0.17000000f,-0.47000000f,0.15000000f,0.65000000f,0.91000000f,-0.72000000f,0.32000000f,0.64000000f,-0.30000000f,-0.40000000f,-0.79000000f,-0.77000000f,0.27000000f,0.09000000f,0.65000000f,-0.85000000f,0.37000000f,0.57000000f,-0.79000000f,0.28000000f,0.02000000f,-0.92000000f,0.23000000f,0.66000000f,-0.38000000f,0.24000000f,-0.21000000f,0.84000000f,-0.71000000f,-0.12000000f,0.26000000f,-0.29000000f,0.26000000f,-0.08000000f,0.75000000f,0.54000000f,0.46000000f,0.11000000f,-0.81000000f,-0.53000000f,0.85000000f,-0.24000000f,-0.38000000f,0.95000000f,0.36000000f,0.77000000f,-0.37000000f,0.58000000f,0.91000000f,0.03000000f,0.13000000f,-0.98000000f,0.68000000f,0.74000000f,0.52000000f,0.42000000f,0.83000000f,-0.76000000f,0.52000000f,-0.79000000f,-0.57000000f,0.95000000f,-0.58000000f,-0.11000000f,-0.08000000f,0.57000000f,0.75000000f,-0.80000000f,0.33000000f,0.42000000f,-0.85000000f,-0.74000000f,-0.91000000f,-0.99000000f,-0.08000000f,-0.06000000f,-0.42000000f,0.33000000f,-0.45000000f,-0.09000000f,0.56000000f,-0.95000000f,0.98000000f,-0.24000000f,0.48000000f,-0.85000000f,-0.05000000f,0.73000000f,0.75000000f,0.43000000f,0.00000000f,-0.29000000f,-0.75000000f,-0.39000000f,-0.76000000f,0.35000000f,0.29000000f,-0.19000000f,-0.61000000f,-0.65000000f,-0.35000000f,0.74000000f,-0.12000000f,0.62000000f,0.59000000f,-0.11000000f,-0.36000000f,-0.37000000f,-0.59000000f,0.28000000f,-0.28000000f,-0.00000000f,0.60000000f,-0.40000000f,0.10000000f,-0.94000000f,-0.25000000f,-0.50000000f,-0.12000000f,-0.90000000f,0.13000000f,-0.39000000f,0.30000000f,-0.87000000f,0.76000000f,-0.61000000f,0.55000000f,0.17000000f,0.74000000f,-0.36000000f,0.52000000f,0.71000000f,-0.20000000f,0.07000000f,0.40000000f,0.61000000f,0.06000000f,0.68000000f,0.71000000f,-0.36000000f,-0.52000000f,-0.61000000f,-0.70000000f,-0.40000000f,0.00000000f,0.69000000f,-0.44000000f,-0.15000000f,0.45000000f,-0.63000000f,0.88000000f,0.23000000f,-0.98000000f,0.29000000f,-0.86000000f,-0.24000000f,0.65000000f,-0.61000000f,-0.61000000f,0.81000000f,0.10000000f,0.24000000f,0.84000000f,-0.98000000f,-0.26000000f,-0.17000000f,-0.05000000f,0.88000000f,-0.93000000f,-0.34000000f,0.10000000f,0.89000000f,-0.92000000f,0.88000000f,-0.01000000f,0.30000000f,0.01000000f,0.65000000f,-0.87000000f,-0.51000000f,0.42000000f,0.60000000f,0.02000000f,0.56000000f,-0.56000000f,-0.00000000f,0.63000000f,0.40000000f,0.32000000f,-0.12000000f,0.05000000f,0.61000000f,-0.57000000f,-0.84000000f,0.20000000f,-0.91000000f,0.48000000f,0.64000000f,-0.60000000f,-0.24000000f,0.84000000f,0.21000000f,-0.48000000f,0.26000000f,-0.71000000f,0.31000000f,0.21000000f,0.59000000f,0.90000000f,-0.38000000f,0.56000000f,-0.72000000f,0.22000000f,0.01000000f,0.74000000f,0.19000000f,-0.40000000f,-0.63000000f,0.76000000f,-0.67000000f,0.27000000f,0.09000000f,-0.04000000f,0.49000000f,0.33000000f,0.55000000f,0.73000000f,-0.41000000f,-0.49000000f,0.16000000f,-0.93000000f,0.37000000f,0.62000000f,0.68000000f,-0.51000000f,0.08000000f,0.89000000f,-0.35000000f,0.26000000f,0.77000000f,0.33000000f,0.42000000f,-0.66000000f,0.65000000f,-0.34000000f,0.87000000f,-0.97000000f,-0.16000000f,0.43000000f,-0.93000000f,-0.06000000f,0.00000000f,0.40000000f,0.06000000f,-0.16000000f,0.79000000f,0.46000000f,-0.60000000f,-0.68000000f,0.11000000f,-0.19000000f,0.33000000f,-0.37000000f,-0.94000000f,-0.08000000f,0.11000000f,0.20000000f,0.78000000f,0.34000000f,-0.61000000f,0.60000000f,-0.93000000f,-0.36000000f,0.96000000f,-0.37000000f,-0.79000000f,-0.56000000f,0.86000000f,0.36000000f,-0.68000000f,-0.18000000f,0.54000000f,0.14000000f,0.00000000f,0.23000000f,0.14000000f,0.83000000f,-0.45000000f,0.01000000f,0.59000000f,-0.02000000f,0.43000000f,-0.03000000f,0.97000000f,0.62000000f,-0.12000000f,0.90000000f,-0.90000000f,-0.08000000f,0.36000000f,-0.72000000f,0.02000000f,0.22000000f,-0.24000000f,0.96000000f,-0.33000000f,-0.13000000f,0.44000000f,-0.65000000f,0.95000000f,0.68000000f,-0.76000000f,0.18000000f,-0.06000000f,0.26000000f,0.74000000f,-0.38000000f,-0.08000000f,0.15000000f,0.45000000f,-0.97000000f,0.43000000f,-0.82000000f,-0.84000000f,0.99000000f,-0.55000000f,-0.93000000f,-0.07000000f,-0.29000000f,-0.59000000f,-0.91000000f,0.49000000f,-0.60000000f,-0.56000000f,0.63000000f,0.86000000f,0.49000000f,0.76000000f,0.69000000f,0.12000000f,0.67000000f,0.60000000f,0.12000000f,-0.79000000f,0.78000000f,0.35000000f,0.52000000f,-0.80000000f,-0.12000000f,0.25000000f,0.43000000f,0.69000000f,0.12000000f,-0.01000000f,0.47000000f,0.65000000f,-0.38000000f,0.99000000f,0.28000000f,-0.37000000f,-0.18000000f,0.69000000f,0.56000000f,0.80000000f,0.89000000f,-0.13000000f,0.57000000f,0.45000000f,-0.11000000f,0.62000000f,0.83000000f,0.14000000f,-0.80000000f,-0.12000000f,-0.04000000f,0.25000000f,0.59000000f,-0.17000000f,0.04000000f,-0.75000000f,0.75000000f,-0.56000000f,-0.46000000f,-0.27000000f,0.22000000f,0.53000000f,0.58000000f,0.03000000f,0.44000000f,-0.14000000f,0.26000000f,-0.22000000f,0.74000000f,0.28000000f,0.50000000f,-0.21000000f,-0.51000000f,-0.50000000f,0.73000000f,-0.67000000f,0.19000000f,-0.58000000f,-0.29000000f,0.56000000f,-0.77000000f,0.18000000f,-0.46000000f,0.59000000f,0.80000000f,0.95000000f,-0.66000000f,-0.67000000f,-0.57000000f,0.01000000f,-0.20000000f,0.27000000f,0.67000000f,-0.12000000f,-0.34000000f,0.72000000f,-0.05000000f,0.95000000f,-0.26000000f,0.30000000f,0.87000000f,-0.61000000f,0.91000000f,-0.68000000f,0.20000000f,-0.75000000f,-0.04000000f,0.12000000f,0.37000000f,-0.34000000f,0.06000000f,-0.92000000f,-0.76000000f,-0.04000000f,-0.17000000f,-0.73000000f,0.50000000f,-0.32000000f,-0.77000000f,-0.25000000f,-0.72000000f,-0.32000000f,-0.88000000f,0.97000000f,0.63000000f,-0.05000000f,0.05000000f,0.33000000f,0.46000000f,0.65000000f,-0.38000000f,0.36000000f,0.52000000f,-0.33000000f,-0.09000000f,0.57000000f,-0.44000000f,-0.80000000f,0.18000000f,-0.14000000f,0.83000000f,0.53000000f,0.45000000f,-0.82000000f,0.11000000f,0.24000000f,0.56000000f,-0.47000000f,-0.35000000f,-0.33000000f,0.97000000f,-0.77000000f,-0.42000000f,0.61000000f,-0.45000000f,0.57000000f,0.43000000f,0.69000000f,0.46000000f,0.22000000f,0.10000000f,-0.24000000f,0.52000000f,0.55000000f,-0.97000000f,0.09000000f,-0.52000000f,0.78000000f,0.50000000f,0.87000000f,-0.04000000f,0.21000000f,0.92000000f,0.15000000f,-0.85000000f,-0.64000000f,0.25000000f,0.20000000f,0.35000000f,0.85000000f,-0.95000000f,-0.36000000f,-0.75000000f,0.85000000f,0.62000000f,0.04000000f,-0.87000000f,0.41000000f,-0.07000000f,-0.71000000f,-0.30000000f,0.07000000f,0.37000000f,-0.16000000f,0.39000000f,-0.62000000f,-0.02000000f,0.57000000f,-0.37000000f,0.31000000f,-0.55000000f,-0.41000000f,-0.11000000f,-0.32000000f,-0.19000000f,0.31000000f,0.29000000f,0.44000000f,0.09000000f,-0.54000000f,0.38000000f,0.07000000f,0.10000000f,-0.71000000f,-0.97000000f,-0.48000000f,-0.55000000f,0.49000000f,-0.95000000f,0.92000000f,0.69000000f,0.24000000f,-0.82000000f,0.33000000f,-0.03000000f,-0.20000000f,-0.14000000f,-0.77000000f,-0.16000000f,0.57000000f,0.39000000f,0.84000000f,-0.73000000f,-0.48000000f,0.65000000f,0.33000000f,0.24000000f,-0.56000000f,0.31000000f,0.23000000f,0.44000000f,-0.97000000f,-0.87000000f,0.14000000f,-0.73000000f,-0.02000000f,0.18000000f,-0.09000000f,-0.02000000f,-0.27000000f,0.09000000f,0.96000000f,-0.01000000f,-0.79000000f,0.29000000f,-0.34000000f,0.99000000f,0.87000000f,-0.45000000f,0.55000000f,-0.25000000f,-0.69000000f,-0.75000000f,-0.45000000f,-0.27000000f,-0.00000000f,-0.99000000f,0.26000000f,0.07000000f,-0.60000000f,-0.50000000f,-0.11000000f,0.20000000f,0.01000000f,-0.09000000f,-0.56000000f,0.85000000f,0.96000000f,0.02000000f,0.09000000f,-0.63000000f,0.13000000f,0.61000000f,0.46000000f,-0.97000000f,0.29000000f,0.09000000f,-0.41000000f,-0.73000000f,0.43000000f,-0.49000000f,-0.33000000f,-0.35000000f,-0.36000000f,0.63000000f,0.41000000f,-0.57000000f,-0.39000000f,0.65000000f,-0.03000000f,-0.29000000f,0.06000000f,0.04000000f,0.97000000f,-0.50000000f,-0.54000000f,0.86000000f,-0.41000000f,0.57000000f,-0.12000000f,0.51000000f,-0.41000000f,0.77000000f,-0.89000000f,-0.74000000f,0.45000000f,0.99000000f,0.03000000f,0.96000000f,0.48000000f,0.47000000f,-0.71000000f,-0.85000000f,0.62000000f,-0.83000000f,-0.71000000f,-0.87000000f,0.97000000f,-0.41000000f,-0.20000000f,-0.84000000f,0.55000000f,-0.01000000f,-0.76000000f,0.15000000f,0.55000000f,0.26000000f,0.19000000f,0.70000000f,0.07000000f,-0.56000000f,-0.51000000f,0.48000000f,-0.55000000f,0.14000000f,0.53000000f,-0.53000000f,-0.99000000f,-0.22000000f,-0.61000000f,-0.88000000f,-0.26000000f,0.46000000f,-0.19000000f,-0.22000000f,0.20000000f,-0.02000000f,0.71000000f,-0.82000000f,-0.67000000f,0.80000000f,0.31000000f,-0.58000000f,-0.59000000f,-0.63000000f,0.48000000f,-0.73000000f,0.45000000f,0.49000000f,0.74000000f,0.59000000f,0.72000000f,-0.48000000f,0.18000000f,-0.12000000f,0.30000000f,0.81000000f,0.55000000f,0.97000000f,-0.66000000f,-0.52000000f,-0.99000000f,0.14000000f,-0.62000000f,-0.02000000f,0.90000000f,0.78000000f,0.77000000f,-0.05000000f,-0.06000000f,0.51000000f,-0.26000000f,0.64000000f,0.91000000f,0.66000000f,0.52000000f,0.19000000f,0.21000000f,-0.52000000f,0.96000000f,0.71000000f,0.28000000f,-0.89000000f,-0.01000000f,0.83000000f,0.07000000f,0.39000000f,-0.88000000f,0.28000000f,0.68000000f,-0.81000000f,-0.46000000f,0.42000000f,0.47000000f,-0.43000000f,-0.93000000f,0.43000000f,-0.76000000f,0.15000000f,0.88000000f,0.21000000f,0.30000000f,-0.85000000f,-0.26000000f,-0.12000000f,-0.96000000f,-0.84000000f,-0.97000000f,-0.49000000f,0.64000000f,0.42000000f,-0.50000000f,0.87000000f,0.19000000f,-0.13000000f,-0.46000000f,-0.45000000f,-0.95000000f,0.22000000f,0.41000000f,0.83000000f,-0.14000000f,-0.33000000f,0.87000000f,0.76000000f,-0.06000000f,-0.94000000f,0.72000000f,0.73000000f,-0.78000000f,0.90000000f,0.89000000f,0.84000000f,0.90000000f,0.28000000f,0.88000000f,0.86000000f,-0.62000000f,0.02000000f,-0.81000000f,-0.52000000f,-0.82000000f,-0.14000000f,-0.42000000f,-0.30000000f,-0.02000000f,0.79000000f,0.10000000f,-0.58000000f,-0.00000000f,0.95000000f,0.55000000f,-0.75000000f,-0.09000000f,0.36000000f,0.44000000f,0.30000000f,0.03000000f,-0.49000000f,-0.60000000f,0.95000000f,0.86000000f,-0.67000000f,-0.23000000f,0.28000000f,-0.45000000f,-0.58000000f,-0.52000000f,0.77000000f,-0.19000000f,-0.88000000f,-0.16000000f,0.08000000f,0.82000000f,-0.02000000f,0.45000000f,-0.66000000f,0.73000000f,0.94000000f,-0.55000000f,-0.54000000f,0.02000000f,0.62000000f,0.71000000f,-0.99000000f,0.10000000f,-0.06000000f,0.08000000f,0.79000000f,-0.00000000f,-0.77000000f,-0.47000000f,0.42000000f,0.83000000f,0.21000000f,0.08000000f,-0.43000000f,-0.14000000f,0.22000000f,0.32000000f,-0.03000000f,0.11000000f,0.12000000f,-0.64000000f,-0.58000000f,-0.54000000f,-0.08000000f,-0.38000000f,0.41000000f,0.61000000f,-0.65000000f,0.27000000f,0.98000000f,-0.40000000f,-0.13000000f,0.83000000f,0.74000000f,-0.68000000f,0.22000000f,-0.69000000f,0.42000000f,0.77000000f,-0.87000000f,-0.42000000f,-0.77000000f,-0.11000000f,0.25000000f,-0.69000000f,0.84000000f,-0.25000000f,-0.38000000f,-0.56000000f,-0.20000000f,-0.35000000f,0.83000000f,-0.89000000f,-0.51000000f,0.82000000f,-0.77000000f,0.05000000f,0.78000000f,0.71000000f,0.12000000f,-0.82000000f,-0.32000000f,0.09000000f,0.63000000f,0.70000000f,-0.49000000f,0.80000000f,0.25000000f,-0.85000000f,0.04000000f,-0.72000000f,0.56000000f,0.14000000f,0.62000000f,0.17000000f,-0.88000000f,-0.26000000f,0.20000000f,0.72000000f,-0.55000000f,-0.57000000f,-0.33000000f,0.66000000f,-0.12000000f,0.46000000f,-0.14000000f,-0.87000000f,-0.12000000f,0.08000000f,0.92000000f,0.41000000f,0.36000000f,-0.58000000f,-0.17000000f,0.25000000f,-0.97000000f,-0.87000000f,-0.86000000f,-0.43000000f,0.85000000f,-0.38000000f,-0.45000000f,0.47000000f,0.41000000f,0.98000000f,-0.67000000f,-0.13000000f,-0.36000000f,0.08000000f,-0.33000000f,0.92000000f,-0.96000000f,-0.13000000f,0.71000000f,0.77000000f,0.17000000f,-0.03000000f,-0.92000000f,-0.06000000f,0.00000000f,0.29000000f,-0.14000000f,-0.79000000f,0.64000000f,0.53000000f,0.82000000f,-0.02000000f,-0.39000000f,0.94000000f,-0.97000000f,-0.67000000f,-0.98000000f,-0.38000000f,-0.25000000f,-0.76000000f,0.21000000f,0.80000000f,0.24000000f,-0.69000000f,-0.44000000f,-0.80000000f,0.17000000f,-0.87000000f,0.33000000f,0.72000000f,-0.23000000f,-0.39000000f,0.52000000f,-0.39000000f,-0.14000000f,-0.70000000f,0.86000000f,-0.58000000f,0.05000000f,0.82000000f,0.19000000f,0.58000000f,-0.76000000f,0.00000000f,0.09000000f,0.97000000f,-0.60000000f,0.90000000f,-0.73000000f,-0.47000000f,-0.47000000f,0.18000000f,0.93000000f,-0.53000000f,0.71000000f,0.34000000f,0.48000000f,-0.12000000f,0.94000000f,0.12000000f,-0.44000000f,-0.35000000f,-0.93000000f,-0.00000000f,-0.91000000f,0.40000000f,0.37000000f,-0.87000000f,-0.86000000f,0.68000000f,0.55000000f,0.35000000f,-0.30000000f,0.31000000f,-0.37000000f,0.81000000f,0.89000000f,-0.00000000f,-0.72000000f,-0.24000000f,-0.33000000f,-0.09000000f,-0.79000000f,0.41000000f,0.15000000f,-0.30000000f,-0.99000000f,-0.00000000f,-0.07000000f,-0.55000000f,0.22000000f,0.54000000f,-0.15000000f,-0.45000000f,-0.79000000f,-0.75000000f,-0.50000000f,-0.69000000f,-0.59000000f,-0.67000000f,0.70000000f,0.29000000f,0.74000000f,0.83000000f,-0.83000000f,0.41000000f,-0.04000000f,-0.94000000f,0.59000000f,-0.38000000f,0.85000000f,0.34000000f,-0.06000000f,0.08000000f,0.79000000f,0.41000000f,-0.19000000f,-0.15000000f,0.25000000f,-0.66000000f,0.03000000f,0.57000000f,-0.17000000f,0.69000000f,0.32000000f,0.07000000f,-0.95000000f,0.49000000f,0.42000000f,-0.75000000f,0.70000000f,-0.09000000f,-0.98000000f,-0.93000000f,0.40000000f,-0.38000000f,0.36000000f,-0.49000000f,0.65000000f,-0.30000000f,0.14000000f,-0.99000000f,0.66000000f,-0.27000000f,0.94000000f,0.08000000f,-0.70000000f,0.78000000f,-0.93000000f,-0.97000000f,-0.89000000f,-0.94000000f,-0.77000000f,-0.75000000f,-0.87000000f,0.89000000f,-0.25000000f,0.61000000f,0.59000000f,-0.55000000f,-0.73000000f,0.26000000f,0.93000000f,-0.42000000f,0.66000000f,-0.91000000f,-0.72000000f,0.05000000f,0.26000000f,-0.49000000f,-0.00000000f,-0.88000000f,-0.66000000f,0.34000000f,0.93000000f,0.91000000f,0.94000000f,0.25000000f,0.72000000f,0.13000000f,-0.23000000f,-0.67000000f,-0.99000000f,-0.77000000f,0.45000000f,0.33000000f,0.68000000f,0.34000000f,0.43000000f,0.60000000f,0.36000000f,-0.72000000f,-0.56000000f,-0.41000000f,-0.72000000f,0.65000000f,0.34000000f,0.91000000f,0.95000000f,-0.90000000f,-0.85000000f,0.91000000f,0.80000000f,-0.60000000f,-0.96000000f,0.29000000f,-0.36000000f,-0.54000000f,0.81000000f,-0.95000000f,-0.54000000f,0.67000000f,0.13000000f,0.16000000f,0.73000000f,0.92000000f,0.00000000f,0.08000000f,-0.05000000f,0.84000000f,-0.42000000f,-0.82000000f,-0.31000000f,-0.82000000f,-0.14000000f,-0.65000000f,-0.15000000f,0.55000000f,0.56000000f,-0.93000000f,-0.06000000f,0.59000000f,0.48000000f,0.60000000f,0.08000000f,-0.81000000f,-0.72000000f,-0.69000000f,-0.19000000f,0.02000000f,0.25000000f,-0.38000000f,-0.41000000f,0.31000000f,-0.84000000f,-0.09000000f,0.64000000f,0.62000000f,-0.00000000f,0.78000000f,-0.87000000f,-0.50000000f,-0.85000000f,0.61000000f,-0.90000000f,0.96000000f,0.51000000f,0.99000000f,-0.33000000f,-0.44000000f,-0.23000000f,-0.27000000f,-0.03000000f,-0.75000000f,0.12000000f,-0.78000000f,-0.25000000f,0.44000000f,0.49000000f,0.33000000f,0.33000000f,-0.77000000f,-0.35000000f,-0.39000000f,-0.49000000f,0.00000000f,-0.20000000f,-0.06000000f,-0.78000000f,0.41000000f,0.31000000f,0.62000000f,-0.78000000f,-0.36000000f,0.98000000f,-0.03000000f,-0.41000000f,-0.01000000f,-0.81000000f,0.30000000f,-0.81000000f,0.60000000f,-0.05000000f,0.20000000f,0.70000000f,0.81000000f,0.64000000f,0.78000000f,0.84000000f,0.07000000f,0.86000000f,0.72000000f,0.59000000f,-0.58000000f,-0.85000000f,0.23000000f,0.03000000f,-0.40000000f,-0.29000000f,-0.16000000f,0.59000000f,0.79000000f,0.07000000f,-0.29000000f,0.45000000f,-0.94000000f,-0.48000000f,-0.65000000f,0.57000000f,0.43000000f,-0.31000000f,-0.18000000f,-0.83000000f,-0.85000000f,-0.27000000f,0.28000000f,0.58000000f,-0.07000000f,0.74000000f,0.09000000f,-0.80000000f,0.93000000f,-0.84000000f,0.74000000f,0.37000000f,0.85000000f,0.70000000f,-0.95000000f,0.35000000f,-0.81000000f,-0.54000000f,0.81000000f,0.05000000f,0.02000000f,0.47000000f,-0.70000000f,0.45000000f,0.44000000f,-0.12000000f,0.46000000f,-0.76000000f,0.42000000f,-0.38000000f,-0.47000000f,-0.80000000f,-0.96000000f,-0.97000000f,-0.95000000f,-0.91000000f,0.79000000f,-0.41000000f,-0.87000000f,0.60000000f,0.72000000f,0.19000000f,0.45000000f,0.99000000f,-0.02000000f,-0.70000000f,-0.89000000f,-0.75000000f,-0.54000000f,0.11000000f,-0.69000000f,0.94000000f,-0.86000000f,-0.34000000f,-0.79000000f,-0.75000000f,0.84000000f,-0.56000000f,0.63000000f,0.22000000f,-0.69000000f,0.34000000f,0.34000000f,0.38000000f,0.03000000f,0.43000000f,-0.38000000f,-0.70000000f,-0.34000000f,-0.01000000f,-0.47000000f,-0.88000000f,0.97000000f,-0.99000000f,0.33000000f,-0.79000000f,-0.79000000f,-0.78000000f,-0.14000000f,-0.58000000f,-0.93000000f,0.41000000f,0.14000000f,0.40000000f,-0.06000000f,0.31000000f,-0.69000000f,-0.83000000f,0.29000000f,0.08000000f,0.66000000f,0.71000000f,0.11000000f,0.28000000f,0.98000000f,0.94000000f,0.11000000f,0.91000000f,0.05000000f,-0.07000000f,0.33000000f,-0.97000000f,0.48000000f,-0.77000000f,0.93000000f,0.68000000f,-0.00000000f,0.36000000f,0.37000000f,-0.76000000f,0.51000000f,0.55000000f,-0.92000000f,0.15000000f,0.84000000f,-0.82000000f,0.02000000f,-0.15000000f,0.06000000f,0.05000000f,-0.10000000f,-0.57000000f,0.93000000f,0.03000000f,-0.61000000f,0.47000000f,-0.23000000f,0.39000000f,-0.54000000f,0.33000000f,-0.48000000f,0.45000000f,0.65000000f,0.64000000f,0.35000000f,0.64000000f,-0.39000000f,0.15000000f,0.54000000f,0.97000000f,-0.12000000f,-0.88000000f,0.57000000f,0.95000000f,0.91000000f,0.83000000f,0.64000000f,-0.16000000f,-0.85000000f,0.52000000f,0.03000000f,0.81000000f,0.10000000f,0.47000000f,0.39000000f,-0.66000000f,0.86000000f,0.69000000f,0.29000000f,-0.43000000f,-0.76000000f,0.58000000f,-0.76000000f,-0.89000000f,-0.12000000f,0.37000000f,0.83000000f,-0.02000000f,0.36000000f,0.79000000f,-0.29000000f,0.63000000f,0.18000000f,-0.24000000f,0.62000000f,-0.07000000f,-0.25000000f,0.07000000f,-0.17000000f,-0.60000000f,-0.66000000f,-0.21000000f,0.83000000f,0.04000000f,-0.63000000f,-0.35000000f,0.00000000f,0.22000000f,0.05000000f,-0.18000000f,0.26000000f,0.49000000f,0.51000000f,0.54000000f,-0.43000000f,0.10000000f,0.07000000f,-0.70000000f,0.69000000f,-0.19000000f,-0.24000000f,0.94000000f,0.22000000f,0.16000000f,-0.23000000f,-0.81000000f,-0.72000000f,0.58000000f,0.44000000f,-0.58000000f,-0.89000000f,0.59000000f,0.64000000f,0.72000000f,0.43000000f,0.82000000f,-0.57000000f,0.69000000f,0.27000000f,-0.20000000f,0.24000000f,0.07000000f,0.41000000f,-0.49000000f,0.72000000f,0.27000000f,-0.40000000f,0.11000000f,-0.58000000f,0.78000000f,-0.71000000f,0.97000000f,0.12000000f,0.00000000f,0.76000000f,0.77000000f,-0.70000000f,-0.13000000f,-0.41000000f,0.57000000f,0.42000000f,0.48000000f,0.59000000f,0.47000000f,0.16000000f,-0.10000000f,0.80000000f,0.53000000f,0.50000000f,-0.34000000f,0.78000000f,-0.20000000f,-0.70000000f,0.56000000f,-0.23000000f,-0.11000000f,-0.51000000f,0.44000000f,0.21000000f,-0.59000000f,0.08000000f,-0.43000000f,-0.87000000f,-0.60000000f,-0.35000000f,0.79000000f,-0.62000000f,-0.85000000f,-0.39000000f,-0.39000000f,-0.74000000f,0.80000000f,-0.19000000f,-0.93000000f,0.55000000f,-0.26000000f,-0.86000000f,-0.62000000f,-0.00000000f,-0.20000000f,-0.11000000f,0.95000000f,-0.27000000f,0.59000000f,0.61000000f,-0.78000000f,-0.64000000f,-0.09000000f,-0.51000000f,0.10000000f,0.83000000f,-0.22000000f,0.37000000f,0.40000000f,-0.74000000f,-0.68000000f,-0.22000000f,-0.36000000f,-0.82000000f,0.29000000f,0.29000000f,-0.04000000f,0.88000000f,-0.62000000f,0.49000000f,0.89000000f,-0.87000000f,0.30000000f,0.90000000f,0.54000000f,0.07000000f,-0.52000000f,-0.82000000f,0.65000000f,0.28000000f,0.73000000f,0.43000000f,0.34000000f,0.24000000f,-0.61000000f,-0.20000000f,-0.07000000f,0.85000000f,0.34000000f,-0.33000000f,0.14000000f,0.64000000f,-0.58000000f,0.32000000f,-0.46000000f,0.07000000f,0.88000000f,0.64000000f,0.12000000f,-0.26000000f,-0.11000000f,0.72000000f,-0.58000000f,-0.58000000f,-0.95000000f,0.38000000f,0.11000000f,-0.01000000f,0.15000000f,-0.10000000f,0.50000000f,0.66000000f,0.60000000f,-0.81000000f,0.75000000f,0.48000000f,0.65000000f,-0.83000000f,-0.81000000f,-0.92000000f,-0.31000000f,0.81000000f,-0.35000000f,0.49000000f,0.95000000f,-0.99000000f,0.17000000f,0.34000000f,0.60000000f,0.65000000f,-0.49000000f,-0.18000000f,-0.09000000f,0.35000000f,0.06000000f,0.92000000f,0.78000000f,-0.18000000f,-0.66000000f,0.46000000f,0.58000000f,-0.56000000f,-0.45000000f,0.63000000f,0.03000000f,0.28000000f,-0.84000000f,0.39000000f,0.06000000f,0.85000000f,0.04000000f,-0.50000000f,0.53000000f,0.62000000f,0.46000000f,-0.86000000f,-0.90000000f,-0.72000000f,0.12000000f,0.05000000f,-0.39000000f,-0.41000000f,0.59000000f,-0.19000000f,-0.22000000f,0.50000000f,0.32000000f,0.83000000f,-0.33000000f,-0.83000000f,-0.81000000f,-0.46000000f,-0.63000000f,-0.58000000f,-0.78000000f,-0.49000000f,-0.78000000f,0.19000000f,0.69000000f,-0.66000000f,0.27000000f,-0.10000000f,-0.09000000f,0.88000000f,0.08000000f,0.53000000f,-0.64000000f,-0.38000000f,0.46000000f,-0.64000000f,-0.55000000f,0.33000000f,-0.41000000f,-0.80000000f,0.11000000f,0.37000000f,-0.05000000f,-0.73000000f,-0.57000000f,0.93000000f,0.90000000f,-0.60000000f,0.93000000f,0.81000000f,0.94000000f,0.23000000f,0.06000000f,0.68000000f,-0.06000000f,-0.91000000f,-0.05000000f,0.40000000f,-0.11000000f,-0.83000000f,-0.67000000f,0.96000000f,-0.89000000f,-0.56000000f,0.96000000f,0.82000000f,-0.29000000f,0.80000000f,0.42000000f,0.23000000f,-0.05000000f,-0.06000000f,0.16000000f,-0.54000000f,0.08000000f,0.69000000f,0.97000000f,0.19000000f,-0.65000000f,0.87000000f,0.70000000f,0.67000000f,0.44000000f,0.10000000f,-0.12000000f,0.97000000f,0.07000000f,0.92000000f,-0.00000000f,-0.58000000f,-0.44000000f,0.66000000f,-0.63000000f,-0.32000000f,0.08000000f,0.53000000f,-0.11000000f,0.80000000f,-0.35000000f,0.98000000f,-0.66000000f,-0.63000000f,-0.80000000f,0.87000000f,-0.82000000f,0.09000000f,0.95000000f,-0.25000000f,-0.15000000f,0.72000000f,-0.97000000f,-0.45000000f,0.96000000f,0.49000000f,0.92000000f,-0.19000000f,-0.10000000f,-0.12000000f,-0.00000000f,-0.96000000f,0.76000000f,0.99000000f,-0.37000000f,0.84000000f,0.66000000f,-0.63000000f,-0.41000000f,0.37000000f,-0.29000000f,0.69000000f,0.61000000f,0.54000000f,-0.95000000f,0.97000000f,0.76000000f,0.02000000f,0.06000000f,0.83000000f,-0.94000000f,-0.77000000f,0.04000000f,-0.25000000f,0.57000000f,0.75000000f,0.46000000f,-0.96000000f,-0.49000000f,0.76000000f,0.35000000f,-0.80000000f,-0.74000000f,0.52000000f,-0.57000000f,-0.38000000f,-0.75000000f,-0.88000000f,0.76000000f,-0.69000000f,0.22000000f,-0.64000000f,0.65000000f,0.79000000f,-0.79000000f,0.78000000f,-0.13000000f,0.07000000f,-0.98000000f,0.63000000f,0.94000000f,-0.54000000f,0.52000000f,0.02000000f,-0.64000000f,-0.05000000f,0.04000000f,-0.91000000f,-0.05000000f,-0.54000000f,0.67000000f,0.44000000f,-0.43000000f,-0.37000000f,0.03000000f,0.37000000f,-0.51000000f,-0.36000000f,0.21000000f,0.65000000f,-0.62000000f,0.20000000f,-0.90000000f,-0.37000000f,-0.11000000f,-0.40000000f,-0.11000000f,0.50000000f,0.81000000f,0.46000000f,0.03000000f,-0.09000000f,0.05000000f,-0.20000000f,0.98000000f,0.45000000f,0.26000000f,-0.15000000f,-0.40000000f,0.70000000f,-0.17000000f,-0.59000000f,-0.23000000f,-0.80000000f,0.65000000f,-0.47000000f,0.39000000f,0.68000000f,-0.64000000f,0.15000000f,-0.89000000f,0.98000000f,-0.36000000f,0.15000000f,-0.59000000f,0.88000000f,0.47000000f,-0.01000000f,0.26000000f,-0.94000000f,0.39000000f,-0.76000000f,-0.43000000f,-0.29000000f,-0.88000000f,-0.52000000f,-0.42000000f,0.12000000f,-0.56000000f,0.09000000f,0.38000000f,0.32000000f,-0.22000000f,-0.29000000f,-0.46000000f,0.59000000f,-0.96000000f,0.30000000f,0.95000000f,-0.76000000f,-0.90000000f,-0.76000000f,0.56000000f,0.35000000f,-0.76000000f,0.42000000f,-0.72000000f,-0.67000000f,0.74000000f,-0.60000000f,0.90000000f,0.74000000f,-0.87000000f,-0.36000000f,-0.12000000f,0.29000000f,-0.83000000f,0.60000000f,0.35000000f,0.44000000f,-0.50000000f,0.19000000f,0.19000000f,0.42000000f,-0.47000000f,-0.50000000f,-0.35000000f,0.49000000f,0.41000000f,-0.19000000f,-0.08000000f,-0.70000000f,0.76000000f,-0.44000000f,0.69000000f,0.16000000f,-0.01000000f,0.56000000f,-0.85000000f,-0.11000000f,-0.87000000f,0.11000000f,0.17000000f,-0.05000000f,0.50000000f,0.24000000f,-0.47000000f,0.57000000f,0.59000000f,-0.90000000f,0.95000000f,-0.05000000f,0.02000000f,0.51000000f,0.82000000f,0.28000000f,0.91000000f,-0.59000000f,0.65000000f,-0.42000000f,-0.82000000f,0.84000000f,-0.31000000f,-0.41000000f,0.75000000f,0.68000000f,-0.67000000f,0.52000000f,-0.18000000f,0.79000000f,-0.38000000f,0.63000000f,0.33000000f,-0.93000000f,-0.59000000f,0.76000000f,-0.60000000f,0.03000000f,-0.77000000f,-0.34000000f,0.17000000f,-0.35000000f,0.81000000f,0.50000000f,0.82000000f,0.57000000f,0.61000000f,-0.38000000f,0.69000000f,0.69000000f,0.75000000f,-0.61000000f,-0.73000000f,0.53000000f,0.66000000f,-0.83000000f,-0.69000000f,0.67000000f,-0.41000000f,0.84000000f,-0.23000000f,0.70000000f,0.95000000f,0.66000000f,0.81000000f,0.64000000f,-0.55000000f,-0.80000000f,0.45000000f,-0.11000000f,-0.77000000f,-0.47000000f,-0.36000000f,-0.41000000f,-0.82000000f,-0.60000000f,-0.32000000f,-0.58000000f,0.49000000f,0.32000000f,-0.38000000f,0.35000000f,-0.88000000f,-0.11000000f,0.49000000f,0.24000000f,0.97000000f,0.68000000f,0.90000000f,0.62000000f,-0.40000000f,0.94000000f,-0.16000000f,-0.57000000f,-0.00000000f,-0.18000000f,0.55000000f,-0.88000000f,0.95000000f,-0.49000000f,-0.75000000f,0.54000000f,0.45000000f,0.03000000f,0.59000000f,0.17000000f,-0.22000000f,-0.44000000f,-0.63000000f,0.69000000f,0.08000000f,0.06000000f,-0.43000000f,0.00000000f,-0.50000000f,-0.86000000f,-0.48000000f,0.91000000f,-0.19000000f,-0.18000000f,-0.61000000f,0.85000000f,-0.41000000f,-0.73000000f,0.83000000f,-0.86000000f,0.66000000f,0.94000000f,-0.02000000f,-0.07000000f,0.21000000f,-0.68000000f,-0.33000000f,-0.40000000f,0.13000000f,-0.11000000f,0.59000000f,-0.91000000f,-0.28000000f,0.72000000f,0.18000000f,0.46000000f,-0.20000000f,-0.36000000f,-0.93000000f,-0.38000000f,0.91000000f,-0.03000000f,-0.85000000f,-0.05000000f,0.23000000f,-0.03000000f,-0.28000000f,0.68000000f,0.93000000f,0.07000000f,0.69000000f,-0.76000000f,-0.55000000f,0.42000000f,-0.27000000f,-0.28000000f,0.39000000f,-0.02000000f,0.95000000f,-0.43000000f,0.38000000f,0.70000000f,0.93000000f,-0.55000000f,-0.25000000f,-0.72000000f,-0.44000000f,0.97000000f,-0.72000000f,-0.24000000f,-0.66000000f,-0.99000000f,-0.29000000f,-0.93000000f,0.97000000f,0.64000000f,0.65000000f,0.95000000f,0.58000000f,0.13000000f,0.18000000f,0.42000000f,-0.38000000f,0.11000000f,0.60000000f,0.30000000f,-0.01000000f,0.79000000f,-0.31000000f,-0.70000000f,0.23000000f,-0.17000000f,-0.58000000f,-0.82000000f,0.13000000f,-0.75000000f,-0.44000000f,0.99000000f,0.26000000f,-0.55000000f,0.12000000f,-0.40000000f,0.85000000f,-0.93000000f,0.28000000f,-0.78000000f,-0.94000000f,0.99000000f,-0.71000000f,0.55000000f,-0.30000000f,0.20000000f,0.33000000f,-0.84000000f,-0.93000000f,-0.49000000f,-0.83000000f,-0.30000000f,-0.44000000f,-0.14000000f,0.96000000f,-0.71000000f,-0.68000000f,0.60000000f,0.74000000f,-0.86000000f,-0.10000000f,-0.04000000f,0.07000000f,-0.30000000f,0.28000000f,-0.10000000f,0.15000000f,-0.34000000f,0.94000000f,0.71000000f,0.17000000f,-0.48000000f,-0.53000000f,0.93000000f,0.73000000f,0.29000000f,-0.17000000f,-0.34000000f,-0.61000000f,-0.93000000f,0.94000000f,-0.14000000f,0.27000000f,0.49000000f,0.78000000f,-0.69000000f,0.36000000f,0.38000000f,0.49000000f,-0.93000000f,0.83000000f,-0.85000000f,0.51000000f,0.43000000f,0.61000000f,0.40000000f,-0.95000000f,-0.81000000f,0.09000000f,-0.87000000f,-0.42000000f,-0.85000000f,0.34000000f,-0.43000000f,0.72000000f,-0.40000000f,-0.51000000f,-0.39000000f,-0.50000000f,-0.74000000f,0.91000000f,0.49000000f,0.92000000f,0.84000000f,0.68000000f,-0.63000000f,-0.77000000f,0.25000000f,0.63000000f,-0.60000000f,0.32000000f,-0.94000000f,0.69000000f,-0.81000000f,0.55000000f,0.07000000f,0.58000000f,-0.76000000f,-0.82000000f,0.53000000f,-0.87000000f,-0.97000000f,-0.92000000f,-0.19000000f,0.12000000f,-0.70000000f,0.05000000f,0.99000000f,-0.88000000f,-0.76000000f,-0.81000000f,-0.81000000f,0.94000000f,-0.22000000f,0.44000000f,0.10000000f,-0.09000000f,0.34000000f,-0.72000000f,-0.19000000f,-0.44000000f,0.29000000f,0.74000000f,0.45000000f,0.77000000f,0.36000000f,0.37000000f,-0.59000000f,0.46000000f,0.41000000f,-0.86000000f,-0.10000000f,-0.42000000f,0.66000000f,0.11000000f,0.50000000f,0.17000000f,0.78000000f,0.92000000f,0.93000000f,0.64000000f,0.61000000f,0.53000000f,-0.51000000f,0.75000000f,-0.89000000f,-0.01000000f,0.50000000f,-0.27000000f,-0.40000000f,0.06000000f,0.66000000f,-0.02000000f,-0.70000000f,-0.13000000f,0.03000000f,-0.72000000f,-0.64000000f,0.67000000f,0.12000000f,-0.97000000f,0.97000000f,-0.74000000f,-0.56000000f,-0.11000000f,0.81000000f,-0.13000000f,-0.32000000f,0.06000000f,0.10000000f,0.77000000f,-0.80000000f,-0.68000000f,-0.14000000f,-0.53000000f,-0.70000000f,-0.18000000f,-0.37000000f,-0.61000000f,0.12000000f,0.65000000f,0.40000000f,-0.16000000f,-0.92000000f,0.92000000f,0.94000000f,-0.20000000f,-0.24000000f,0.33000000f,-0.75000000f,0.83000000f,0.67000000f,-0.10000000f,-0.18000000f,0.84000000f,-0.23000000f,-0.80000000f,0.77000000f,-0.80000000f,0.60000000f,-0.51000000f,0.64000000f,-0.63000000f,0.89000000f,-0.61000000f,0.00000000f,0.43000000f,0.86000000f,0.23000000f,-0.51000000f,0.05000000f,-0.23000000f,0.05000000f,0.32000000f,0.36000000f,0.78000000f,0.12000000f,-0.52000000f,0.52000000f,-0.86000000f,-0.37000000f,-0.63000000f,0.50000000f,-0.82000000f,-0.93000000f,0.49000000f,-0.20000000f,-0.35000000f,0.20000000f,-0.03000000f,0.09000000f,0.01000000f,0.26000000f,0.14000000f,0.82000000f,0.15000000f,0.26000000f,-0.83000000f,-0.22000000f,0.36000000f,0.26000000f,-0.40000000f,0.90000000f,0.87000000f,-0.96000000f,0.87000000f,0.73000000f,0.67000000f,0.08000000f,0.46000000f,0.59000000f,0.59000000f,0.82000000f,0.99000000f,-0.13000000f,0.18000000f,-0.04000000f,0.60000000f,-0.60000000f,0.84000000f,-0.80000000f,-0.54000000f,0.40000000f,-0.57000000f,-0.43000000f,-0.08000000f,-0.09000000f,0.62000000f,0.58000000f,0.89000000f,-0.38000000f,0.07000000f,-0.72000000f,-0.15000000f,0.20000000f,0.34000000f,-0.81000000f,-0.04000000f,-0.06000000f,0.77000000f,-0.95000000f,-0.99000000f,-0.05000000f,-0.13000000f,-0.37000000f,-0.21000000f,-0.31000000f,-0.77000000f,-0.82000000f,0.67000000f,0.71000000f,0.03000000f,0.98000000f,0.46000000f,-0.87000000f,0.55000000f,-0.14000000f,0.14000000f,0.26000000f,0.05000000f,0.31000000f,0.67000000f,-0.00000000f,-0.49000000f,-0.71000000f,-0.75000000f,-0.66000000f,0.27000000f,-0.29000000f,0.04000000f,-0.91000000f,0.02000000f,-0.68000000f,-0.03000000f,-0.47000000f,0.34000000f,-0.89000000f,-0.98000000f,-0.00000000f,0.11000000f,-0.52000000f,0.28000000f,-0.42000000f,0.60000000f,0.28000000f,0.42000000f,0.91000000f,-0.09000000f,0.23000000f,-0.44000000f,-0.39000000f,-0.20000000f,0.61000000f,0.82000000f,-0.43000000f,0.57000000f,0.15000000f,-0.03000000f,-0.71000000f,-0.19000000f,0.56000000f,0.54000000f,0.99000000f,-0.59000000f,-0.76000000f,-0.90000000f,0.05000000f,0.00000000f,-0.56000000f,-0.85000000f,-0.74000000f,0.31000000f,-0.92000000f,0.38000000f,0.13000000f,0.44000000f,0.94000000f,0.95000000f,0.35000000f,0.18000000f,0.35000000f,-0.16000000f,0.15000000f,0.21000000f,-0.90000000f,0.80000000f,0.50000000f,-0.68000000f,-0.20000000f,-0.99000000f,0.20000000f,0.71000000f,0.65000000f,0.46000000f,0.21000000f,0.19000000f,-0.64000000f,0.79000000f,-0.23000000f,0.69000000f,-0.71000000f,0.29000000f,-0.55000000f,0.61000000f,-0.31000000f,0.18000000f,-0.00000000f,0.40000000f,-0.89000000f,-0.38000000f,-0.08000000f,-0.43000000f,-0.87000000f,0.53000000f,-0.05000000f,0.55000000f,0.80000000f,-0.60000000f,-0.87000000f,-0.15000000f,-0.22000000f,-0.55000000f,-0.41000000f,-0.43000000f,0.69000000f,0.32000000f,-0.10000000f,-0.29000000f,0.26000000f,0.88000000f,-0.86000000f,-0.16000000f,-0.36000000f,-0.94000000f,0.47000000f,-0.75000000f,-0.15000000f,-0.10000000f,0.97000000f,0.93000000f,0.39000000f,0.29000000f,0.12000000f,0.49000000f,-0.38000000f,0.22000000f,0.24000000f,-0.33000000f,0.18000000f,0.37000000f,-0.80000000f,-0.77000000f,0.28000000f,-0.26000000f,0.05000000f,0.60000000f,-0.85000000f,-0.14000000f,0.90000000f,-0.44000000f,0.36000000f,-0.85000000f,-0.89000000f,0.36000000f,-0.93000000f,0.44000000f,-0.95000000f,-0.18000000f,0.62000000f,-0.50000000f,-0.58000000f,-0.08000000f,0.84000000f,0.33000000f,-0.96000000f,0.92000000f,0.41000000f,-0.61000000f,0.90000000f,0.09000000f,-0.70000000f,-0.73000000f,-0.64000000f,-0.09000000f,-0.09000000f,-0.42000000f,-0.90000000f,0.61000000f,0.71000000f,0.82000000f,-0.42000000f,0.56000000f,0.97000000f,0.64000000f,-0.49000000f,-0.22000000f,-0.94000000f,0.24000000f,-0.29000000f,-0.88000000f,-0.54000000f,0.97000000f,-0.76000000f,0.66000000f,-0.71000000f,-0.64000000f,-0.64000000f,-0.53000000f,0.20000000f,0.23000000f,-0.56000000f,-0.62000000f,-0.55000000f,0.18000000f,0.18000000f,-0.77000000f,0.19000000f,-0.68000000f,0.89000000f,0.50000000f,0.42000000f,-0.10000000f,-0.28000000f,0.41000000f,-0.39000000f,-0.51000000f,0.70000000f,-0.98000000f,0.44000000f,0.04000000f,-0.46000000f,-0.63000000f,-0.93000000f,-0.31000000f,0.41000000f,0.35000000f,0.53000000f,0.77000000f,0.60000000f,0.26000000f,-0.21000000f,0.82000000f,-0.92000000f,0.92000000f,-0.70000000f,-0.10000000f,0.64000000f,-0.83000000f,-0.55000000f,0.61000000f,0.77000000f,-0.72000000f,-0.30000000f,-0.85000000f,0.33000000f,-0.60000000f,0.19000000f,0.86000000f,0.70000000f,0.77000000f,0.21000000f,0.86000000f,0.04000000f,0.22000000f,0.95000000f,0.57000000f,0.36000000f,-0.41000000f,0.37000000f,-0.17000000f,0.29000000f,0.70000000f,-0.40000000f,-0.39000000f,-0.83000000f,-0.11000000f,0.84000000f,-0.43000000f,-0.48000000f,0.13000000f,-0.27000000f,-0.75000000f,-0.54000000f,0.79000000f,0.75000000f,-0.85000000f,0.90000000f,-0.41000000f,0.24000000f,0.29000000f,0.61000000f,0.69000000f,-0.03000000f,-0.72000000f,-0.36000000f,-0.33000000f,-0.32000000f,-0.11000000f,0.19000000f,-0.84000000f,-0.24000000f,-0.77000000f,-0.96000000f,0.70000000f,0.04000000f,0.95000000f,-0.97000000f,-0.11000000f,-0.24000000f,0.69000000f,-0.13000000f,0.85000000f,0.43000000f,-0.41000000f,-0.89000000f,0.70000000f,0.09000000f,-0.63000000f,0.57000000f,0.80000000f,0.56000000f,-0.62000000f,0.32000000f,-0.28000000f,0.54000000f,0.14000000f,-0.67000000f,-0.24000000f,-0.79000000f,0.23000000f,-0.95000000f,-0.16000000f,-0.85000000f,-0.18000000f,0.46000000f,-0.60000000f,0.36000000f,0.22000000f,-0.08000000f,0.15000000f,0.62000000f,-0.20000000f,0.88000000f,-0.26000000f,-0.13000000f,-0.11000000f,0.56000000f,0.17000000f,0.67000000f,-0.56000000f,0.49000000f,0.87000000f,-0.35000000f,-0.73000000f,-0.93000000f,-0.80000000f,-0.06000000f,-0.95000000f,-0.36000000f,-0.26000000f,0.34000000f,0.19000000f,0.57000000f,0.56000000f,-0.65000000f,0.60000000f,0.94000000f,0.86000000f,-0.16000000f,-0.95000000f,0.36000000f,0.12000000f,-0.42000000f,0.34000000f,0.75000000f,-0.14000000f,0.15000000f,0.03000000f,-0.17000000f,0.70000000f,0.95000000f,0.95000000f,0.79000000f,0.11000000f,-0.82000000f,-0.30000000f,0.75000000f,-0.72000000f,-0.91000000f,0.31000000f,-0.07000000f,0.42000000f,0.85000000f,0.00000000f,-0.47000000f,0.37000000f,-0.62000000f,0.22000000f,0.10000000f,0.75000000f,-0.15000000f,-0.13000000f,0.18000000f,-0.21000000f,0.45000000f,-0.35000000f,0.77000000f,-0.40000000f,-0.75000000f,0.59000000f,0.87000000f,-0.62000000f,-0.91000000f,0.55000000f,-0.09000000f,0.06000000f,0.30000000f,0.52000000f,-0.51000000f,-0.03000000f,0.89000000f,-0.05000000f,0.88000000f,0.83000000f,-0.66000000f,-0.01000000f,0.34000000f,-0.83000000f,0.60000000f,0.47000000f,0.65000000f,0.51000000f,0.70000000f,0.62000000f,0.99000000f,0.34000000f,0.41000000f,-0.31000000f,0.75000000f,0.61000000f,0.04000000f,0.54000000f,-0.42000000f,0.47000000f,-0.43000000f,0.39000000f,-0.58000000f,-0.44000000f,-0.02000000f,-0.08000000f,0.38000000f,-0.77000000f,-0.55000000f,-0.20000000f,0.63000000f,-0.93000000f,-0.96000000f,-0.04000000f,-0.26000000f,0.83000000f,0.34000000f,0.31000000f,-0.32000000f,0.37000000f,-0.74000000f,0.60000000f,-0.77000000f,-0.04000000f,0.65000000f,0.94000000f,-0.39000000f,0.01000000f,-0.76000000f,-0.25000000f,0.44000000f,0.87000000f,0.06000000f,-0.58000000f,-0.21000000f,0.67000000f,-0.97000000f,0.22000000f,0.24000000f,-0.16000000f,0.82000000f,-0.19000000f,0.66000000f,0.00000000f,0.50000000f,-0.85000000f,0.32000000f,-0.66000000f,0.11000000f,-0.48000000f,0.66000000f,-0.60000000f,-0.50000000f,0.29000000f,-0.93000000f,0.94000000f,-0.02000000f,0.41000000f,-0.13000000f,-0.04000000f,0.77000000f,0.31000000f,-0.23000000f,0.84000000f,0.25000000f,-0.48000000f,-0.51000000f,0.19000000f,-0.42000000f,-0.03000000f,-0.13000000f,0.78000000f,0.76000000f,0.23000000f,0.63000000f,0.23000000f,-0.82000000f,0.41000000f,0.10000000f,0.73000000f,0.49000000f,-0.94000000f,0.80000000f,-0.40000000f,0.78000000f,-0.12000000f,-0.49000000f,-0.80000000f,0.37000000f,0.96000000f,0.22000000f,-0.93000000f,0.78000000f,-0.74000000f,-0.71000000f,0.46000000f,-0.38000000f,0.86000000f,0.03000000f,0.48000000f,0.22000000f,-0.05000000f,0.13000000f,0.91000000f,-0.20000000f,0.36000000f,0.64000000f,0.26000000f,0.38000000f,-0.10000000f,0.57000000f,-0.14000000f,-0.72000000f,0.08000000f,0.55000000f,-0.91000000f,0.62000000f,0.27000000f,-0.49000000f,-0.22000000f,0.22000000f,-0.12000000f,-0.32000000f,-0.28000000f,0.15000000f,-0.92000000f,0.58000000f,-0.51000000f,-0.07000000f,-0.45000000f,-0.24000000f,-0.73000000f,0.63000000f,-0.70000000f,-0.11000000f,-0.46000000f,-0.75000000f,-0.58000000f,-0.15000000f,0.38000000f,-0.22000000f,0.23000000f,-0.26000000f,0.41000000f,0.14000000f,0.87000000f,0.44000000f,0.26000000f,0.79000000f,0.28000000f,0.19000000f,0.06000000f,0.84000000f,0.19000000f,0.91000000f,-0.25000000f,0.24000000f,0.07000000f,-0.46000000f,-0.57000000f,0.86000000f,0.98000000f,-0.33000000f,0.77000000f,0.04000000f,0.55000000f,-0.04000000f,-0.72000000f,-0.44000000f,0.36000000f,-0.73000000f,0.74000000f,-0.86000000f,0.71000000f,0.89000000f,-0.94000000f,-0.03000000f,0.07000000f,0.12000000f,-0.14000000f,-0.20000000f,-0.71000000f,-0.51000000f,-0.23000000f,-0.35000000f,-0.89000000f,0.75000000f,-0.95000000f,-0.48000000f,-0.34000000f,-0.16000000f,0.45000000f,0.34000000f,-0.50000000f,-0.82000000f,0.12000000f,0.18000000f,0.35000000f,-0.26000000f,-0.16000000f,-0.98000000f,0.80000000f,0.58000000f,-0.65000000f,-0.17000000f,0.77000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.43000000f,-0.88000000f,0.08000000f,0.23000000f,-0.70000000f,-0.69000000f,-0.76000000f,-0.11000000f,0.44000000f,-0.87000000f,0.70000000f,-0.73000000f,-0.55000000f,0.05000000f,0.30000000f,-0.02000000f,0.19000000f,0.20000000f,0.14000000f,0.08000000f,0.16000000f,0.44000000f,0.58000000f,-0.51000000f,-0.63000000f,0.32000000f,0.98000000f,-0.48000000f,-0.66000000f,-0.00000000f,-0.83000000f,0.39000000f,-0.95000000f,-0.32000000f,-0.28000000f,0.60000000f,0.59000000f,-0.94000000f,0.34000000f,-0.68000000f,-0.62000000f,0.46000000f,-0.87000000f,0.25000000f,-0.00000000f,0.12000000f,0.38000000f,0.69000000f,-0.54000000f,0.11000000f,0.03000000f,-0.76000000f,0.92000000f,0.52000000f,-0.33000000f,-0.36000000f,-0.33000000f,0.46000000f,-0.60000000f,0.33000000f,-0.56000000f,-0.77000000f,0.13000000f,0.31000000f,-0.65000000f,-0.67000000f,-0.58000000f,0.54000000f,0.41000000f,0.80000000f,-0.92000000f,0.77000000f,-0.44000000f,0.69000000f,-0.60000000f,0.13000000f,-0.82000000f,0.13000000f,0.27000000f,-0.36000000f,-0.88000000f,-0.77000000f,-0.72000000f,-0.94000000f,0.69000000f,0.18000000f,-0.29000000f,-0.12000000f,-0.81000000f,-0.51000000f,0.72000000f,-0.03000000f,0.32000000f,-0.25000000f,-0.83000000f,0.11000000f,0.14000000f,-0.76000000f,-0.62000000f,0.51000000f,0.87000000f,0.76000000f,-0.23000000f,0.52000000f,0.89000000f,-0.02000000f,-0.57000000f,0.81000000f,-0.83000000f,-0.10000000f,-0.88000000f,0.71000000f,0.30000000f,-0.66000000f,-0.38000000f,-0.56000000f,0.37000000f,0.02000000f,0.08000000f,-0.88000000f,-0.86000000f,0.01000000f,-0.61000000f,-0.44000000f,0.60000000f,0.34000000f,-0.90000000f,-0.50000000f,-0.11000000f,0.52000000f,-0.76000000f,0.04000000f,-0.53000000f,-0.10000000f,0.03000000f,0.07000000f,0.32000000f,0.98000000f,0.28000000f,0.13000000f,0.05000000f,0.62000000f,-0.15000000f,-0.39000000f,0.04000000f,-0.81000000f,0.84000000f,-0.48000000f,0.56000000f,-0.74000000f,0.39000000f,0.79000000f,-0.40000000f,-0.67000000f,-0.52000000f,0.67000000f,-0.68000000f,-0.55000000f,-0.65000000f,0.36000000f,0.27000000f,-0.14000000f,-0.14000000f,-0.58000000f,0.34000000f,0.14000000f,-0.33000000f,-0.67000000f,0.92000000f,-0.73000000f,-0.29000000f,0.96000000f,-0.43000000f,-0.85000000f,0.96000000f,0.65000000f,0.21000000f,0.76000000f,-0.74000000f,0.42000000f,-0.78000000f,-0.06000000f,0.21000000f,-0.03000000f,-0.83000000f,-0.42000000f,0.44000000f,-0.79000000f,-0.55000000f,-0.22000000f,-0.54000000f,-0.24000000f,0.68000000f,0.03000000f,-0.90000000f,0.81000000f,0.68000000f,0.70000000f,-0.84000000f,-0.41000000f,-0.26000000f,-0.67000000f,0.21000000f,-0.49000000f,0.00000000f,-0.99000000f,0.73000000f,0.96000000f,-0.50000000f,0.82000000f,0.83000000f,-0.41000000f,0.83000000f,-0.48000000f,-0.20000000f,0.84000000f,-0.79000000f,-0.93000000f,0.89000000f,-0.24000000f,0.59000000f,-0.10000000f,0.95000000f,0.43000000f,0.44000000f,-0.81000000f,0.61000000f,-0.49000000f,-0.78000000f,-0.97000000f,0.83000000f,-0.33000000f,0.26000000f,0.46000000f,-0.74000000f,-0.64000000f,0.49000000f,0.38000000f,0.92000000f,0.70000000f,0.51000000f,-0.64000000f,0.57000000f,0.55000000f,0.82000000f,-0.91000000f,-0.75000000f,-0.50000000f,-0.39000000f,-0.79000000f,-0.96000000f,-0.72000000f,-0.96000000f,0.78000000f,-0.81000000f,0.07000000f,-0.08000000f,-0.34000000f,-0.90000000f,0.26000000f,0.88000000f,-0.69000000f,-0.64000000f,-0.41000000f,0.46000000f,0.93000000f,-0.60000000f,-0.81000000f,-0.11000000f,-0.50000000f,-0.30000000f,-0.27000000f,0.59000000f,-0.02000000f,-0.71000000f,-0.78000000f,0.72000000f,0.11000000f,-0.84000000f,-0.84000000f,0.52000000f,0.45000000f,-0.90000000f,-0.64000000f,-0.38000000f,0.32000000f,-0.20000000f,0.20000000f,0.33000000f,-0.61000000f,0.79000000f,0.33000000f,-0.75000000f,-0.21000000f,-0.04000000f,0.65000000f,-0.27000000f,0.59000000f,0.60000000f,-0.49000000f,-0.38000000f,0.72000000f,0.87000000f,-0.36000000f,-0.97000000f,0.13000000f,-0.62000000f,-0.86000000f,-0.91000000f,-0.52000000f,0.45000000f,-0.41000000f,-0.38000000f,-0.29000000f,-0.07000000f,-0.69000000f,-0.86000000f,0.46000000f,0.60000000f,0.37000000f,0.14000000f,-0.12000000f,-0.75000000f,0.64000000f,-0.74000000f,0.00000000f,-0.91000000f,-0.44000000f,-0.75000000f,0.94000000f,0.91000000f,-0.12000000f,0.76000000f,0.25000000f,-0.75000000f,-0.42000000f,-0.71000000f,0.41000000f,0.55000000f,-0.99000000f,0.12000000f,0.83000000f,0.98000000f,-0.45000000f,0.16000000f,-0.89000000f,-0.38000000f,-0.36000000f,-0.89000000f,0.36000000f,0.27000000f,0.88000000f,0.64000000f,0.31000000f,-0.51000000f,0.48000000f,-0.31000000f,-0.94000000f,0.83000000f,-0.51000000f,0.51000000f,-0.32000000f,0.45000000f,-0.34000000f,0.62000000f,-0.88000000f,0.37000000f,0.48000000f,-0.25000000f,-0.87000000f,-0.40000000f,-0.35000000f,-0.60000000f,-0.48000000f,-0.62000000f,-0.14000000f,0.16000000f,-0.60000000f,-0.95000000f,0.70000000f,0.57000000f,0.38000000f,-0.42000000f,-0.76000000f,-0.37000000f,-0.13000000f,0.67000000f,0.46000000f,-0.54000000f,0.62000000f,0.87000000f,0.93000000f,-0.72000000f,0.56000000f,0.83000000f,-0.24000000f,-0.34000000f,-0.52000000f,0.65000000f,-0.64000000f,0.10000000f,-0.02000000f,-0.63000000f,-0.59000000f,-0.90000000f,-0.98000000f,0.28000000f,0.52000000f,-0.41000000f,0.27000000f,-0.97000000f,0.53000000f,0.29000000f,-0.58000000f,-0.44000000f,0.87000000f,0.32000000f,-0.02000000f,-0.49000000f,0.33000000f,0.61000000f,0.93000000f,-0.95000000f,0.65000000f,0.37000000f,-0.42000000f,-0.82000000f,0.95000000f,-0.96000000f,0.72000000f,-0.14000000f,-0.07000000f,0.03000000f,0.20000000f,0.87000000f,0.52000000f,-0.40000000f,-0.72000000f,-0.95000000f,0.49000000f,-0.29000000f,0.17000000f,0.93000000f,0.04000000f,-0.55000000f,0.37000000f,0.92000000f,-0.99000000f,0.94000000f,0.24000000f,-0.90000000f,-0.60000000f,-0.87000000f,0.48000000f,0.19000000f,-0.27000000f,0.12000000f,-0.50000000f,-0.97000000f,0.85000000f,-0.02000000f,0.68000000f,0.03000000f,0.30000000f,-0.53000000f,0.66000000f,0.38000000f,0.72000000f,0.12000000f,-0.62000000f,-0.46000000f,-0.61000000f,-0.89000000f,0.24000000f,-0.80000000f,0.13000000f,-0.52000000f,0.45000000f,-0.02000000f,0.13000000f,0.03000000f,0.02000000f,0.22000000f,0.50000000f,0.70000000f,0.46000000f,0.40000000f,-0.00000000f,0.49000000f,-0.96000000f,0.75000000f,-0.31000000f,0.60000000f,0.06000000f,-0.57000000f,0.20000000f,-0.79000000f,-0.70000000f,0.08000000f,0.71000000f,0.89000000f,0.75000000f,-0.65000000f,0.50000000f,-0.89000000f,0.15000000f,0.05000000f,0.95000000f,0.77000000f,-0.03000000f,-0.52000000f,0.52000000f,0.60000000f,0.00000000f,-0.92000000f,0.34000000f,0.38000000f,-0.69000000f,0.26000000f,-0.74000000f,0.29000000f,0.39000000f,0.18000000f,-0.06000000f,0.19000000f,-0.67000000f,-0.79000000f,0.96000000f,-0.63000000f,-0.55000000f,-0.86000000f,-0.29000000f,0.68000000f,-0.57000000f,-0.10000000f,-0.87000000f,0.22000000f,0.70000000f,0.09000000f,0.17000000f,0.27000000f,-0.30000000f,-0.53000000f,0.50000000f,0.80000000f,0.07000000f,0.09000000f,-0.85000000f,0.07000000f,0.52000000f,-0.71000000f,-0.71000000f,0.13000000f,-0.57000000f,0.39000000f,-0.45000000f,0.45000000f,0.93000000f,-0.82000000f,0.09000000f,0.94000000f,-0.77000000f,-0.58000000f,-0.46000000f,-0.40000000f,0.47000000f,-0.85000000f,-0.92000000f,-0.01000000f,-0.35000000f,0.33000000f,-0.74000000f,0.79000000f,0.10000000f,-0.24000000f,0.07000000f,0.97000000f,-0.67000000f,-0.69000000f,-0.64000000f,-0.31000000f,-0.19000000f,0.39000000f,-0.73000000f,0.18000000f,0.10000000f,0.14000000f,-0.97000000f,-0.37000000f,-0.36000000f,-0.33000000f,0.64000000f,-0.16000000f,-0.60000000f,-0.78000000f,0.84000000f,-0.77000000f,-0.40000000f,0.68000000f,-0.49000000f,0.13000000f,0.39000000f,0.98000000f,-0.35000000f,0.05000000f,-0.97000000f,-0.12000000f,0.93000000f,0.88000000f,0.33000000f,0.02000000f,0.17000000f,0.80000000f,-0.71000000f,0.98000000f,0.92000000f,-0.97000000f,0.75000000f,0.48000000f,0.22000000f,0.74000000f,-0.51000000f,0.67000000f,-0.87000000f,0.44000000f,0.84000000f,0.28000000f,-0.04000000f,0.41000000f,0.33000000f,-0.68000000f,0.52000000f,0.55000000f,-0.81000000f,-0.63000000f,0.57000000f,-0.48000000f,-0.29000000f,-0.51000000f,0.76000000f,-0.78000000f,-0.39000000f,-0.15000000f,-0.24000000f,-0.01000000f,-0.37000000f,-0.87000000f,0.64000000f,0.07000000f,0.19000000f,-0.96000000f,0.77000000f,0.48000000f,0.95000000f,0.27000000f,-0.55000000f,-0.47000000f,0.00000000f,-0.99000000f,-0.89000000f,-0.31000000f,0.05000000f,-0.08000000f,-0.56000000f,0.30000000f,0.41000000f,-0.63000000f,0.44000000f,0.80000000f,0.11000000f,0.14000000f,-0.62000000f,-0.41000000f,-0.94000000f,-0.64000000f,0.44000000f,-0.49000000f,-0.89000000f,0.42000000f,-0.82000000f,-0.97000000f,-0.83000000f,-0.41000000f,0.68000000f,0.89000000f,0.40000000f,0.09000000f,0.28000000f,0.09000000f,0.01000000f,0.32000000f,0.33000000f,-0.31000000f,0.29000000f,-0.57000000f,0.26000000f,0.70000000f,0.28000000f,0.34000000f,0.12000000f,-0.39000000f,0.77000000f,0.83000000f,0.30000000f,0.52000000f,-0.97000000f,0.80000000f,-0.94000000f,-0.53000000f,-0.33000000f,-0.38000000f,-0.25000000f,-0.20000000f,-0.22000000f,0.37000000f,-0.64000000f,0.95000000f,-0.26000000f,-0.46000000f,-0.97000000f,-0.86000000f,-0.73000000f,-0.19000000f,0.62000000f,0.45000000f,0.33000000f,-0.14000000f,0.87000000f,-0.41000000f,0.01000000f,-0.67000000f,-0.14000000f,0.59000000f,-0.29000000f,0.20000000f,-0.33000000f,0.19000000f,0.50000000f,0.68000000f,0.60000000f,0.21000000f,0.91000000f,0.29000000f,-0.77000000f,0.48000000f,0.54000000f,-0.72000000f,0.26000000f,0.94000000f,-0.82000000f,0.26000000f,0.08000000f,-0.69000000f,0.20000000f,0.66000000f,0.65000000f,-0.77000000f,0.22000000f,-0.17000000f,-0.31000000f,0.56000000f,0.86000000f,0.53000000f,-0.06000000f,0.73000000f,-0.52000000f,0.27000000f,0.99000000f,-0.73000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.15000000f,-0.14000000f,-0.70000000f,0.86000000f,-0.83000000f,-0.02000000f,-0.18000000f,-0.53000000f,0.53000000f,-0.23000000f,0.94000000f,-0.23000000f,-0.32000000f,0.23000000f,-0.73000000f,-0.43000000f,0.06000000f,-0.75000000f,-0.88000000f,0.43000000f,0.50000000f,-0.74000000f,-0.17000000f,0.03000000f,0.74000000f,-0.18000000f,-0.97000000f,-0.09000000f,0.88000000f,0.63000000f,-0.88000000f,-0.42000000f,0.03000000f,-0.19000000f,0.54000000f,-0.26000000f,0.30000000f,-0.13000000f,0.74000000f,0.36000000f,0.05000000f,-0.31000000f,0.77000000f,-0.24000000f,-0.95000000f,-0.52000000f,0.95000000f,0.23000000f,0.87000000f,-0.09000000f,0.08000000f,0.24000000f,0.16000000f,0.31000000f,0.88000000f,0.48000000f,-0.12000000f,0.30000000f,-0.42000000f,-0.10000000f,0.44000000f,-0.91000000f,-0.43000000f,-0.95000000f,0.62000000f,0.36000000f,0.91000000f,-0.74000000f,0.74000000f,-0.08000000f,0.55000000f,0.12000000f,-0.14000000f,0.82000000f,0.22000000f,0.77000000f,-0.11000000f,0.81000000f,0.29000000f,-0.52000000f,-0.47000000f,0.75000000f,-0.08000000f,0.23000000f,0.45000000f,0.87000000f,0.48000000f,-0.41000000f,0.09000000f,0.46000000f,0.71000000f,0.73000000f,0.23000000f,-0.87000000f,-0.90000000f,-0.38000000f,-0.72000000f,0.23000000f,0.36000000f,0.64000000f,-0.87000000f,-0.82000000f,-0.97000000f,0.96000000f,0.97000000f,-0.63000000f,-0.92000000f,0.73000000f,0.29000000f,-0.54000000f,-0.20000000f,-0.96000000f,-0.15000000f,0.98000000f,-0.50000000f,-0.42000000f,0.29000000f,-0.21000000f,0.71000000f,-0.71000000f,0.58000000f,0.12000000f,-0.61000000f,-0.37000000f,-0.28000000f,-0.00000000f,0.66000000f,-0.80000000f,-0.29000000f,-0.83000000f,-0.15000000f,0.70000000f,0.27000000f,-0.37000000f,0.02000000f,-0.28000000f,0.85000000f,0.14000000f,0.26000000f,0.06000000f,-0.72000000f,0.07000000f,0.33000000f,0.18000000f,-0.56000000f,0.66000000f,0.51000000f,-0.21000000f,0.41000000f,-0.69000000f,-0.38000000f,0.42000000f,-0.04000000f,0.71000000f,0.66000000f,-0.26000000f,0.28000000f,0.74000000f,0.61000000f,0.22000000f,0.47000000f,-0.44000000f,0.49000000f,-0.26000000f,0.61000000f,-0.24000000f,0.07000000f,-0.63000000f,-0.24000000f,-0.44000000f,-0.41000000f,0.74000000f,-0.27000000f,0.60000000f,0.47000000f,-0.69000000f,0.13000000f,-0.10000000f,0.36000000f,-0.54000000f,-0.05000000f,-0.26000000f,0.50000000f,-0.62000000f,0.19000000f,-0.05000000f,0.56000000f,-0.12000000f,0.33000000f,0.60000000f,-0.50000000f,-0.40000000f,0.12000000f,-0.06000000f,0.95000000f,0.06000000f,0.60000000f,0.00000000f,0.32000000f,-0.73000000f,-0.05000000f,0.42000000f,0.24000000f,-0.51000000f,0.37000000f,-0.86000000f,0.49000000f,-0.35000000f,0.07000000f,0.21000000f,-0.03000000f,0.13000000f,-0.03000000f,-0.19000000f,0.48000000f,-0.29000000f,-0.56000000f,-0.35000000f,0.57000000f,-0.98000000f,-0.21000000f,0.50000000f,0.95000000f,0.51000000f,-0.40000000f,0.77000000f,0.26000000f,0.77000000f,0.71000000f,-0.28000000f,0.98000000f,-0.78000000f,0.55000000f,-0.96000000f,-0.30000000f,-0.06000000f,0.72000000f,0.79000000f,0.32000000f,0.46000000f,-0.42000000f,0.38000000f,-0.22000000f,0.82000000f,0.65000000f,0.63000000f,-0.92000000f,-0.99000000f,0.07000000f,-0.28000000f,-0.48000000f,-0.22000000f,0.29000000f,0.61000000f,0.04000000f,0.76000000f,0.77000000f,-0.89000000f,-0.84000000f,-0.18000000f,0.27000000f,-0.14000000f,0.13000000f,0.75000000f,-0.53000000f,0.88000000f,-0.46000000f,0.22000000f,-0.57000000f,-0.19000000f,-0.11000000f,-0.96000000f,0.16000000f,0.69000000f,0.37000000f,0.06000000f,0.59000000f,0.21000000f,-0.74000000f,0.53000000f,0.74000000f,0.68000000f,-0.60000000f,0.81000000f,-0.74000000f,-0.82000000f,-0.84000000f,-0.64000000f,-0.09000000f,0.31000000f,0.54000000f,0.34000000f,0.86000000f,0.30000000f,-0.72000000f,0.25000000f,0.51000000f,0.62000000f,0.47000000f,-0.67000000f,0.33000000f,-0.68000000f,0.63000000f,0.84000000f,0.91000000f,-0.85000000f,-0.24000000f,-0.48000000f,-0.40000000f,0.29000000f,0.24000000f,-0.76000000f,0.27000000f,0.60000000f,-0.51000000f,-0.27000000f,-0.99000000f,0.58000000f,0.87000000f,0.58000000f,-0.42000000f,0.18000000f,0.97000000f,-0.42000000f,-0.96000000f,-0.30000000f,-0.98000000f,-0.05000000f,0.98000000f,0.35000000f,-0.82000000f,-0.55000000f,0.87000000f,0.13000000f,0.13000000f,-0.14000000f,-0.61000000f,-0.75000000f,-0.58000000f,0.24000000f,-0.33000000f,-0.79000000f,0.95000000f,0.19000000f,0.01000000f,0.54000000f,-0.40000000f,-0.60000000f,0.08000000f,-0.59000000f,0.71000000f,-0.98000000f,-0.94000000f,0.73000000f,0.46000000f,-0.54000000f,0.23000000f,0.49000000f,-0.26000000f,0.26000000f,0.63000000f,-0.32000000f,-0.34000000f,-0.14000000f,0.01000000f,0.68000000f,-0.03000000f,0.53000000f,0.40000000f,-0.90000000f,0.70000000f,-0.13000000f,0.31000000f,0.12000000f,-0.57000000f,0.52000000f,-0.55000000f,0.98000000f,-0.71000000f,-0.75000000f,-0.71000000f,-0.23000000f,0.54000000f,0.19000000f,0.78000000f,-0.41000000f,-0.81000000f,-0.34000000f,-0.03000000f,-0.78000000f,-0.71000000f,-0.98000000f,0.69000000f,0.08000000f,0.16000000f,0.64000000f,-0.23000000f,-0.71000000f,0.35000000f,-0.53000000f,-0.45000000f,-0.01000000f,-0.99000000f,0.38000000f,-0.20000000f,-0.62000000f,0.56000000f,0.82000000f,0.98000000f,0.26000000f,0.00000000f,0.36000000f,0.29000000f,-0.78000000f,-0.88000000f,0.46000000f,0.00000000f,0.13000000f,-0.22000000f,0.73000000f,-0.42000000f,0.67000000f,-0.75000000f,0.76000000f,0.72000000f,0.95000000f,0.46000000f,-0.81000000f,-0.98000000f,-0.38000000f,-0.05000000f,-0.02000000f,0.77000000f,-0.53000000f,-0.53000000f,-0.68000000f,-0.98000000f,0.07000000f,-0.08000000f,0.40000000f,-0.59000000f,-0.03000000f,-0.13000000f,0.70000000f,0.07000000f,-0.82000000f,0.06000000f,-0.09000000f,0.66000000f,0.15000000f,0.73000000f,0.39000000f,-0.84000000f,-0.33000000f,-0.48000000f,-0.81000000f,-0.01000000f,-0.43000000f,0.42000000f,0.55000000f,0.31000000f,-0.78000000f,-0.15000000f,-0.04000000f,0.81000000f,0.26000000f,-0.38000000f,0.00000000f,0.54000000f,0.21000000f,-0.60000000f,-0.75000000f,0.92000000f,-0.60000000f,-0.51000000f,0.95000000f,-0.37000000f,-0.81000000f,0.44000000f,0.68000000f,0.71000000f,-0.37000000f,0.61000000f,0.29000000f,-0.27000000f,-0.96000000f,-0.14000000f,-0.06000000f,-0.74000000f,-0.09000000f,0.51000000f,-0.89000000f,0.47000000f,-0.75000000f,0.40000000f,0.50000000f,0.45000000f,-0.68000000f,0.77000000f,0.31000000f,-0.50000000f,-0.45000000f,0.52000000f,0.97000000f,0.05000000f,-0.91000000f,0.61000000f,-0.36000000f,-0.26000000f,-0.36000000f,0.47000000f,-0.34000000f,0.97000000f,-0.45000000f,0.19000000f,-0.08000000f,0.39000000f,0.35000000f,-0.28000000f,0.81000000f,-0.73000000f,0.37000000f,-0.39000000f,0.15000000f,-0.79000000f,-0.73000000f,0.37000000f,-0.65000000f,0.72000000f,-0.47000000f,0.57000000f,-0.57000000f,-0.82000000f,-0.87000000f,-0.62000000f,-0.92000000f,0.92000000f,0.85000000f,-0.32000000f,0.04000000f,-0.79000000f,0.96000000f,0.77000000f,0.13000000f,-0.19000000f,0.44000000f,-0.10000000f,-0.65000000f,-0.49000000f,0.33000000f,0.72000000f,0.96000000f,0.13000000f,-0.66000000f,-0.78000000f,0.76000000f,-0.44000000f,-0.69000000f,0.87000000f,0.67000000f,-0.34000000f,0.87000000f,0.92000000f,0.02000000f,-0.28000000f,-0.21000000f,-0.56000000f,0.36000000f,0.96000000f,0.53000000f,-0.19000000f,-0.15000000f,-0.73000000f,0.39000000f,0.53000000f,-0.78000000f,0.26000000f,-0.56000000f,0.17000000f,0.69000000f,0.20000000f,-0.08000000f,0.45000000f,0.19000000f,0.51000000f,-0.96000000f,-0.42000000f,0.59000000f,0.16000000f,0.48000000f,-0.75000000f,-0.71000000f,0.11000000f,-0.24000000f,-0.31000000f,-0.67000000f,-0.96000000f,-0.05000000f,-0.53000000f,0.62000000f,0.81000000f,0.37000000f,0.07000000f,0.80000000f,0.40000000f,-0.38000000f,-0.84000000f,-0.57000000f,0.96000000f,-0.23000000f,0.62000000f,-0.88000000f,0.49000000f,0.49000000f,0.37000000f,0.82000000f,-0.83000000f,-0.00000000f,0.93000000f,-0.25000000f,0.13000000f,-0.69000000f,0.87000000f,0.94000000f,0.71000000f,0.58000000f,0.51000000f,0.97000000f,-0.44000000f,-0.76000000f,0.48000000f,0.01000000f,0.11000000f,-0.57000000f,0.53000000f,-0.85000000f,-0.45000000f,0.31000000f,-0.02000000f,-0.27000000f,0.39000000f,0.86000000f,-0.42000000f,-0.67000000f,-0.34000000f,0.39000000f,0.42000000f,-0.08000000f,0.25000000f,0.01000000f,-0.45000000f,-0.11000000f,0.65000000f,-0.89000000f,-0.44000000f,0.54000000f,0.66000000f,0.53000000f,-0.96000000f,-0.09000000f,0.57000000f,0.20000000f,-0.16000000f,0.90000000f,-0.02000000f,0.92000000f,0.67000000f,-0.06000000f,0.51000000f,-0.54000000f,-0.79000000f,0.08000000f,0.89000000f,-0.96000000f,0.77000000f,-0.83000000f,-0.72000000f,0.95000000f,0.06000000f,0.38000000f,0.80000000f,0.20000000f,0.17000000f,-0.30000000f,0.76000000f,-0.39000000f,-0.81000000f,-0.59000000f,-0.66000000f,0.35000000f,0.01000000f,-0.53000000f,0.07000000f,0.94000000f,0.88000000f,0.97000000f,-0.18000000f,0.14000000f,0.41000000f,-0.83000000f,-0.00000000f,0.59000000f,-0.05000000f,0.03000000f,0.84000000f,-0.17000000f,-0.32000000f,-0.79000000f,-0.86000000f,-0.55000000f,-0.09000000f,0.57000000f,0.01000000f,0.80000000f,-0.11000000f,0.68000000f,0.92000000f,-0.57000000f,0.60000000f,-0.07000000f,-0.10000000f,0.66000000f,0.47000000f,0.62000000f,0.11000000f,-0.50000000f,0.01000000f,-0.03000000f,0.84000000f,-0.15000000f,-0.45000000f,-0.07000000f,0.19000000f,0.94000000f,-0.10000000f,-0.46000000f,-0.47000000f,-0.78000000f,0.05000000f,0.70000000f,-0.96000000f,0.88000000f,-0.84000000f,0.72000000f,-0.40000000f,0.46000000f,0.44000000f,0.31000000f,0.10000000f,0.36000000f,0.42000000f,0.42000000f,-0.29000000f,-0.87000000f,0.16000000f,-0.24000000f,0.62000000f,0.05000000f,0.13000000f,-0.11000000f,0.80000000f,-0.23000000f,0.18000000f,0.43000000f,-0.91000000f,0.75000000f,0.38000000f,0.84000000f,0.61000000f,-0.83000000f,-0.34000000f,-0.01000000f,0.05000000f,-0.39000000f,0.05000000f,-0.64000000f,0.62000000f,-0.29000000f,0.56000000f,-0.06000000f,0.23000000f,-0.39000000f,0.18000000f,0.44000000f,0.04000000f,0.36000000f,0.89000000f,0.93000000f,0.24000000f,0.42000000f,0.25000000f,-0.45000000f,-0.63000000f,-0.22000000f,0.09000000f,-0.27000000f,0.27000000f,0.28000000f,-0.12000000f,-0.97000000f,-0.20000000f,0.55000000f,-0.43000000f,-0.35000000f,-0.64000000f,0.63000000f,0.42000000f,-0.93000000f,-0.76000000f,-0.98000000f,0.90000000f,0.80000000f,-0.64000000f,-0.92000000f,0.34000000f,-0.81000000f,0.79000000f,-0.77000000f,0.56000000f,0.60000000f,-0.05000000f,-0.63000000f,-0.32000000f,0.51000000f,-0.52000000f,-0.20000000f,0.38000000f,0.80000000f,-0.63000000f,-0.52000000f,-0.13000000f,-0.06000000f,0.01000000f,-0.66000000f,0.14000000f,-0.45000000f,0.78000000f,0.07000000f,0.00000000f,0.17000000f,-0.46000000f,0.47000000f,-0.10000000f,0.31000000f,-0.16000000f,-0.62000000f,-0.32000000f,-0.85000000f,0.24000000f,-0.01000000f,-0.63000000f,0.80000000f,0.92000000f,0.54000000f,-0.85000000f,-0.74000000f,-0.93000000f,-0.98000000f,0.54000000f,-0.23000000f,-0.36000000f,0.20000000f,0.75000000f,0.22000000f,0.71000000f,-0.07000000f,-0.13000000f,0.40000000f,-0.82000000f,0.46000000f,-0.39000000f,0.34000000f,-0.35000000f,0.12000000f,-0.42000000f,0.63000000f,0.68000000f,0.04000000f,0.97000000f,-0.04000000f,-0.38000000f,0.87000000f,0.12000000f,0.02000000f,-0.71000000f,-0.81000000f,-0.43000000f,0.56000000f,0.80000000f,0.88000000f,0.51000000f,-0.78000000f,-0.52000000f,0.35000000f,-0.52000000f,0.21000000f,-0.51000000f,0.19000000f,-0.05000000f,0.64000000f,0.72000000f,-0.69000000f,0.45000000f,-0.94000000f,0.41000000f,-0.80000000f,-0.17000000f,0.67000000f,-0.41000000f,0.08000000f,0.15000000f,-0.55000000f,0.13000000f,-0.25000000f,-0.85000000f,0.77000000f,0.47000000f,-0.44000000f,0.39000000f,-0.71000000f,-0.62000000f,0.65000000f,0.35000000f,0.20000000f,0.25000000f,0.62000000f,-0.53000000f,-0.97000000f,-0.36000000f,-0.12000000f,-0.93000000f,-0.46000000f,0.39000000f,0.07000000f,0.06000000f,-0.88000000f,0.07000000f,0.01000000f,-0.95000000f,-0.02000000f,0.52000000f,0.41000000f,-0.88000000f,0.55000000f,0.99000000f,0.11000000f,0.76000000f,-0.90000000f,0.97000000f,-0.25000000f,-0.92000000f,0.65000000f,0.94000000f,0.71000000f,-0.82000000f,-0.46000000f,0.44000000f,0.21000000f,0.84000000f,-0.49000000f,0.55000000f,-0.20000000f,0.45000000f,0.48000000f,-0.58000000f,0.96000000f,0.52000000f,0.01000000f,0.31000000f,-0.67000000f,0.52000000f,-0.66000000f,-0.77000000f,0.18000000f,0.36000000f,-0.32000000f,0.51000000f,0.23000000f,0.58000000f,-0.45000000f,-0.52000000f,0.22000000f,-0.46000000f,0.79000000f,0.49000000f,0.40000000f,0.81000000f,-0.44000000f,0.79000000f,-0.50000000f,0.90000000f,0.13000000f,0.34000000f,0.93000000f,0.31000000f,0.56000000f,-0.83000000f,0.90000000f,-0.18000000f,0.55000000f,-0.05000000f,-0.82000000f,0.16000000f,0.67000000f,0.08000000f,-0.82000000f,-0.04000000f,-0.05000000f,0.69000000f,0.75000000f,0.74000000f,-0.37000000f,0.09000000f,0.82000000f,-0.32000000f,0.16000000f,0.67000000f,0.50000000f,0.37000000f,0.63000000f,-0.65000000f,0.28000000f,0.34000000f,0.09000000f,0.41000000f,-0.64000000f,0.57000000f,0.80000000f,-0.11000000f,-0.43000000f,-0.16000000f,-0.29000000f,-0.79000000f,-0.52000000f,-0.54000000f,-0.22000000f,-0.94000000f,-0.77000000f,0.36000000f,0.75000000f,-0.42000000f,0.71000000f,-0.53000000f,-0.23000000f,-0.26000000f,-0.23000000f,-0.19000000f,-0.13000000f,0.85000000f,-0.15000000f,0.70000000f,-0.27000000f,-0.43000000f,0.63000000f,0.13000000f,0.95000000f,-0.63000000f,-0.28000000f,-0.42000000f,-0.91000000f,-0.42000000f,0.79000000f,-0.05000000f,-0.43000000f,0.24000000f,0.39000000f,0.22000000f,0.63000000f,-0.40000000f,0.12000000f,0.10000000f,-0.23000000f,-0.86000000f,-0.12000000f,-0.42000000f,0.31000000f,-0.87000000f,-0.38000000f,0.04000000f,0.54000000f,0.37000000f,-0.51000000f,0.09000000f,0.58000000f,0.27000000f,0.27000000f,0.17000000f,-0.16000000f,0.36000000f,0.35000000f,0.88000000f,-0.79000000f,0.34000000f,0.34000000f,-0.51000000f,-0.15000000f,-0.84000000f,0.07000000f,0.46000000f,0.46000000f,0.44000000f,-0.70000000f,-0.41000000f,0.98000000f,0.44000000f,0.66000000f,0.31000000f,0.84000000f,0.95000000f,-0.25000000f,-0.52000000f,-0.07000000f,-0.78000000f,-0.72000000f,-0.55000000f,-0.84000000f,-0.38000000f,-0.77000000f,0.90000000f,-0.08000000f,-0.62000000f,0.74000000f,-0.78000000f,-0.46000000f,-0.71000000f,0.80000000f,0.21000000f,0.66000000f,0.19000000f,0.80000000f,0.05000000f,0.83000000f,0.28000000f,0.46000000f,0.75000000f,0.33000000f,0.31000000f,-0.62000000f,-0.20000000f,0.13000000f,-0.79000000f,-0.17000000f,0.32000000f,-0.26000000f,-0.48000000f,0.40000000f,0.93000000f,-0.08000000f,0.49000000f,0.71000000f,0.34000000f,-0.05000000f,0.62000000f,0.30000000f,0.22000000f,0.12000000f,0.60000000f,-0.02000000f,-0.56000000f,0.39000000f,-0.15000000f,0.78000000f,0.80000000f,-0.11000000f,-0.61000000f,-0.66000000f,-0.25000000f,-0.80000000f,-0.44000000f,-0.39000000f,-0.99000000f,0.05000000f,0.57000000f,-0.36000000f,0.82000000f,-0.74000000f,0.37000000f,-0.50000000f,0.68000000f,-0.37000000f,0.56000000f,0.80000000f,-0.50000000f,0.45000000f,-0.50000000f,0.58000000f,-0.01000000f,0.79000000f,-0.48000000f,0.05000000f,0.97000000f,0.32000000f,0.82000000f,0.46000000f,0.49000000f,-0.12000000f,-0.71000000f,-0.04000000f,-0.65000000f,0.60000000f,-0.81000000f,0.78000000f,-0.85000000f,0.90000000f,-0.95000000f,-0.46000000f,0.62000000f,0.36000000f,-0.43000000f,0.10000000f,0.57000000f,0.52000000f,-0.60000000f,-0.05000000f,-0.11000000f,0.12000000f,0.32000000f,0.52000000f,0.91000000f,0.53000000f,0.24000000f,0.04000000f,-0.44000000f,-0.41000000f,0.89000000f,-0.17000000f,-0.45000000f,-0.83000000f,0.28000000f,-0.70000000f,0.46000000f,0.58000000f,0.81000000f,-0.23000000f,-0.97000000f,-0.61000000f,-0.82000000f,0.83000000f,0.45000000f,0.74000000f,-0.55000000f,-0.51000000f,-0.74000000f,0.56000000f,0.00000000f,0.23000000f,0.76000000f,-0.30000000f,0.07000000f,0.91000000f,0.26000000f,0.82000000f,0.32000000f,-0.40000000f,0.82000000f,0.64000000f,-0.83000000f,-0.99000000f,-0.19000000f,0.34000000f,0.09000000f,0.31000000f,-0.47000000f,0.38000000f,0.33000000f,0.68000000f,0.71000000f,-0.20000000f,-0.86000000f,-0.10000000f,-0.53000000f,-0.04000000f,-0.99000000f,0.35000000f,0.49000000f,0.52000000f,0.81000000f,-0.51000000f,0.76000000f,-0.50000000f,-0.31000000f,-0.93000000f,-0.89000000f,-0.88000000f,0.97000000f,0.22000000f,-0.41000000f,0.25000000f,-0.28000000f,-0.29000000f,-0.60000000f,-0.23000000f,-0.75000000f,-0.39000000f,0.81000000f,0.17000000f,0.18000000f,-0.92000000f,-0.94000000f,0.82000000f,-0.83000000f,-0.71000000f,0.77000000f,-0.65000000f,0.15000000f,0.17000000f,0.09000000f,0.23000000f,0.21000000f,0.05000000f,0.14000000f,-0.56000000f,-0.31000000f,0.32000000f,0.45000000f,-0.41000000f,0.40000000f,-0.01000000f,-0.59000000f,-0.07000000f,0.96000000f,0.15000000f,0.98000000f,-0.32000000f,-0.66000000f,0.58000000f,-0.07000000f,0.01000000f,-0.67000000f,-0.17000000f,-0.37000000f,0.76000000f,-0.57000000f,0.18000000f,-0.97000000f,-0.14000000f,0.78000000f,0.13000000f,0.78000000f,-0.58000000f,0.33000000f,0.45000000f,-0.31000000f,0.29000000f,0.50000000f,-0.20000000f,-0.78000000f,-0.82000000f,-0.55000000f,0.46000000f,0.55000000f,-0.73000000f,-0.63000000f,0.01000000f,0.12000000f,0.62000000f,0.58000000f,0.95000000f,0.08000000f,-0.94000000f,-0.90000000f,-0.70000000f,-0.22000000f,0.57000000f,0.69000000f,0.80000000f,0.52000000f,-0.38000000f,-0.38000000f,0.59000000f,0.17000000f,0.53000000f,0.46000000f,-0.55000000f,0.81000000f,0.59000000f,0.54000000f,0.57000000f,-0.38000000f,0.07000000f,-0.23000000f,0.16000000f,0.18000000f,0.57000000f,-0.94000000f,0.95000000f,-0.83000000f,0.75000000f,-0.75000000f,-0.97000000f,-0.57000000f,-0.61000000f,-0.15000000f,-0.12000000f,-0.67000000f,0.72000000f,-0.90000000f,-0.26000000f,0.39000000f,0.65000000f,-0.34000000f,-0.43000000f,0.13000000f,-0.23000000f,-0.22000000f,-0.80000000f,0.60000000f,-0.54000000f,0.31000000f,-0.98000000f,-0.12000000f,0.48000000f,0.94000000f,-0.96000000f,0.42000000f,-0.33000000f,-0.89000000f,-0.03000000f,0.94000000f,0.04000000f,0.36000000f,-0.75000000f,0.28000000f,0.28000000f,-0.77000000f,0.32000000f,-0.33000000f,-0.09000000f,-0.30000000f,0.96000000f,-0.30000000f,-0.17000000f,0.54000000f,0.48000000f,0.61000000f,-0.50000000f,-0.01000000f,0.49000000f,-0.88000000f,-0.28000000f,0.50000000f,0.66000000f,0.03000000f,-0.19000000f,-0.01000000f,-0.44000000f,-0.73000000f,-0.11000000f,0.07000000f,0.71000000f,0.05000000f,-0.38000000f,-0.50000000f,-0.47000000f,-0.92000000f,0.75000000f,0.48000000f,-0.46000000f,-0.08000000f,-0.15000000f,0.59000000f,0.32000000f,0.87000000f,0.87000000f,0.80000000f,-0.79000000f,0.20000000f,-0.08000000f,-0.64000000f,0.45000000f,-0.26000000f,0.42000000f,-0.95000000f,0.03000000f,0.91000000f,-0.11000000f,0.14000000f,0.63000000f,0.55000000f,0.59000000f,0.04000000f,0.79000000f,0.30000000f,-0.13000000f,0.20000000f,0.48000000f,-0.07000000f,-0.69000000f,0.29000000f,-0.02000000f,0.45000000f,-0.61000000f,-0.52000000f,0.46000000f,-0.28000000f,0.81000000f,-0.93000000f,-0.73000000f,0.43000000f,-0.96000000f,0.45000000f,0.09000000f,0.51000000f,0.56000000f,-0.39000000f,0.20000000f,-0.18000000f,0.16000000f,-0.28000000f,0.02000000f,0.05000000f,-0.45000000f,0.31000000f,-0.61000000f,0.82000000f,-0.92000000f,-0.94000000f,-0.20000000f,0.10000000f,0.44000000f,-0.02000000f,-0.84000000f,0.16000000f,0.08000000f,-0.66000000f,0.06000000f,0.72000000f,0.09000000f,-0.91000000f,0.70000000f,-0.96000000f,0.53000000f,-0.30000000f,0.89000000f,0.76000000f,0.11000000f,0.61000000f,0.89000000f,-0.02000000f,-0.65000000f,-0.98000000f,-0.93000000f,-0.66000000f,-0.11000000f,-0.97000000f,0.52000000f,-0.75000000f,-0.15000000f,0.30000000f,0.39000000f,0.32000000f,0.49000000f,-0.72000000f,0.44000000f,0.62000000f,0.64000000f,-0.76000000f,0.63000000f,-0.18000000f,0.29000000f,-0.74000000f,-0.10000000f,-0.35000000f,-0.11000000f,-0.42000000f,0.29000000f,-0.07000000f,0.06000000f,-0.26000000f,-0.91000000f,0.85000000f,-0.31000000f,-0.73000000f,0.84000000f,0.89000000f,0.46000000f,0.96000000f,0.92000000f,-0.76000000f,0.87000000f,-0.83000000f,-0.57000000f,0.42000000f,-0.79000000f,-0.55000000f,-0.32000000f,-0.14000000f,0.36000000f,-0.37000000f,0.14000000f,0.17000000f,0.60000000f,0.48000000f,-0.66000000f,0.24000000f,-0.27000000f,0.30000000f,-0.76000000f,-0.73000000f,-0.14000000f,-0.86000000f,-0.43000000f,0.93000000f,0.61000000f,-0.03000000f,0.70000000f,0.74000000f,-0.91000000f,0.45000000f,-0.78000000f,-0.07000000f,-0.60000000f,-0.57000000f,0.40000000f,0.51000000f,0.53000000f,-0.02000000f,0.27000000f,0.04000000f,0.94000000f,0.49000000f,-0.16000000f,-0.94000000f,-0.16000000f,0.41000000f,-0.45000000f,0.31000000f,0.56000000f,0.25000000f,-0.56000000f,0.87000000f,0.15000000f,-0.83000000f,-0.66000000f,-0.69000000f,-0.16000000f,0.32000000f,-0.61000000f,0.76000000f,-0.59000000f,-0.69000000f,-0.70000000f,0.42000000f,0.65000000f,0.90000000f,-0.45000000f,0.59000000f,-0.25000000f,-0.94000000f,0.74000000f,-0.87000000f,-0.24000000f,0.69000000f,-0.85000000f,0.33000000f,-0.89000000f,0.35000000f,-0.29000000f,-0.67000000f,-0.28000000f,-0.85000000f,-0.91000000f,-0.68000000f,0.38000000f,0.48000000f,-0.21000000f,-0.00000000f,-0.39000000f,0.93000000f,0.00000000f,-0.43000000f,-0.25000000f,0.67000000f,0.82000000f,0.00000000f,0.27000000f,-0.76000000f,0.44000000f,-0.83000000f,-0.61000000f,-0.80000000f,0.98000000f,-0.07000000f,-0.86000000f,0.03000000f,0.69000000f,-0.88000000f,-0.87000000f,-0.65000000f,0.88000000f,0.61000000f,0.32000000f,-0.82000000f,0.76000000f,-0.57000000f,-0.59000000f,0.02000000f,-0.80000000f,0.34000000f,-0.98000000f,-0.25000000f,-0.34000000f,0.83000000f,0.40000000f,-0.73000000f,-0.63000000f,-0.73000000f,-0.59000000f,-0.15000000f,-0.19000000f,0.07000000f,-0.21000000f,-0.87000000f,-0.52000000f,0.03000000f,0.69000000f,-0.73000000f,0.99000000f,0.25000000f,-0.28000000f,0.50000000f,-0.17000000f,0.81000000f,0.70000000f,-0.62000000f,0.19000000f,-0.64000000f,-0.14000000f,0.87000000f,0.37000000f,-0.98000000f,-0.33000000f,-0.41000000f,-0.21000000f,0.51000000f,0.84000000f,-0.93000000f,-0.44000000f,0.40000000f,0.86000000f,-0.39000000f,-0.46000000f,0.01000000f,-0.06000000f,0.74000000f,0.43000000f,-0.97000000f,0.69000000f,-0.14000000f,0.06000000f,0.46000000f,0.72000000f,0.48000000f,-0.33000000f,0.91000000f,0.85000000f,0.07000000f,0.51000000f,0.34000000f,-0.16000000f,0.46000000f,0.88000000f,-0.24000000f,0.17000000f,0.55000000f,-0.61000000f,0.16000000f,-0.32000000f,0.02000000f,0.53000000f,0.91000000f,0.04000000f,0.26000000f,0.33000000f,-0.64000000f,-0.50000000f,0.32000000f,0.55000000f,-0.47000000f,0.37000000f,0.69000000f,0.09000000f,-0.29000000f,0.75000000f,-0.19000000f,0.93000000f,0.92000000f,0.65000000f,0.85000000f,-0.45000000f,0.17000000f,-0.36000000f,-0.08000000f,-0.01000000f,0.08000000f,0.69000000f,-0.98000000f,-0.46000000f,-0.32000000f,-0.66000000f,0.98000000f,0.08000000f,-0.71000000f,-0.98000000f,-0.51000000f,-0.95000000f,0.23000000f,0.26000000f,-0.35000000f,-0.72000000f,0.69000000f,-0.64000000f,-0.13000000f,-0.23000000f,0.95000000f,-0.74000000f,-0.25000000f,0.34000000f,0.36000000f,0.25000000f,-0.51000000f,0.00000000f,-0.60000000f,-0.92000000f,0.81000000f,-0.84000000f,0.85000000f,-0.55000000f,0.26000000f,0.20000000f,0.18000000f,-0.78000000f,-0.27000000f,0.99000000f,-0.36000000f,-0.97000000f,0.76000000f,0.10000000f,-0.80000000f,0.16000000f,-0.90000000f,0.48000000f,-0.38000000f,-0.15000000f,0.97000000f,0.75000000f,0.17000000f,0.60000000f,0.15000000f,-0.76000000f,-0.58000000f,0.72000000f,0.24000000f,0.16000000f,-0.37000000f,0.07000000f,0.45000000f,-0.29000000f,0.17000000f,-0.30000000f,-0.37000000f,-0.15000000f,0.43000000f,-0.90000000f,-0.33000000f,0.90000000f,-0.29000000f,0.53000000f,0.96000000f,0.83000000f,0.11000000f,0.28000000f,-0.70000000f,0.87000000f,-0.26000000f,0.90000000f,0.17000000f,0.89000000f,-0.25000000f,-0.92000000f,0.62000000f,0.10000000f,0.14000000f,-0.91000000f,-0.59000000f,-0.54000000f,-0.34000000f,0.10000000f,0.25000000f,0.69000000f,-0.60000000f,0.57000000f,0.82000000f,-0.12000000f,-0.97000000f,-0.72000000f,0.34000000f,-0.43000000f,-0.02000000f,-0.16000000f,-0.49000000f,-0.10000000f,-0.22000000f,-0.95000000f,-0.29000000f,0.15000000f,0.15000000f,0.55000000f,-0.55000000f,0.89000000f,-0.28000000f,-0.15000000f,-0.22000000f,-0.63000000f,0.28000000f,0.64000000f,-0.82000000f,-0.09000000f,-0.14000000f,0.96000000f,-0.07000000f,-0.58000000f,-0.29000000f,0.77000000f,0.18000000f,0.47000000f,-0.33000000f,-0.14000000f,-0.80000000f,-0.80000000f,-0.52000000f,0.52000000f,-0.37000000f,-0.09000000f,0.13000000f,0.85000000f,0.01000000f,0.25000000f,0.47000000f,-0.67000000f,0.29000000f,-0.52000000f,0.92000000f,0.87000000f,-0.25000000f,-0.87000000f,0.67000000f,0.44000000f,-0.85000000f,0.81000000f,-0.29000000f,-0.51000000f,-0.11000000f,-0.86000000f,-0.92000000f,0.90000000f,0.87000000f,0.57000000f,0.45000000f,0.74000000f,0.02000000f,0.81000000f,-0.50000000f,-0.32000000f,0.24000000f,-0.70000000f,-0.71000000f,-0.30000000f,0.71000000f,0.56000000f,0.60000000f,-0.64000000f,0.56000000f,-0.88000000f,0.75000000f,-0.04000000f,0.90000000f,0.40000000f,-0.39000000f,-0.16000000f,0.99000000f,-0.55000000f,0.55000000f,0.77000000f,-0.76000000f,0.25000000f,-0.18000000f,-0.78000000f,0.71000000f,0.05000000f,-0.03000000f,0.80000000f,-0.55000000f,-0.13000000f,0.63000000f,-0.33000000f,0.18000000f,-0.66000000f,0.27000000f,-0.83000000f,-0.21000000f,-0.79000000f,-0.46000000f,-0.15000000f,-0.61000000f,-0.28000000f,-0.84000000f,0.58000000f,-0.43000000f,0.85000000f,-0.22000000f,0.54000000f,0.73000000f,-0.87000000f,-0.48000000f,0.53000000f,-0.97000000f,-0.93000000f,0.85000000f,-0.96000000f,0.37000000f,0.78000000f,0.61000000f,0.55000000f,0.43000000f,-0.75000000f,0.09000000f,-0.06000000f,-0.23000000f,0.68000000f,-0.42000000f,-0.88000000f,-0.81000000f,-0.36000000f,0.33000000f,-0.50000000f,0.63000000f,-0.74000000f,-0.61000000f,-0.29000000f,0.14000000f,0.78000000f,-0.19000000f,-0.13000000f,-0.73000000f,0.97000000f,0.87000000f,-0.15000000f,-0.62000000f,-0.16000000f,0.83000000f,-0.78000000f,0.87000000f,0.48000000f,0.32000000f,0.77000000f,0.59000000f,-0.02000000f,0.06000000f,0.72000000f,0.84000000f,0.18000000f,-0.24000000f,-0.53000000f,0.26000000f,0.56000000f,0.50000000f,0.62000000f,-0.29000000f,-0.08000000f,-0.39000000f,-0.29000000f,-0.36000000f,-0.98000000f,0.53000000f,0.53000000f,-0.21000000f,-0.08000000f,0.47000000f,-0.77000000f,-0.73000000f,-0.48000000f,0.84000000f,0.12000000f,0.09000000f,-0.22000000f,0.77000000f,-0.10000000f,-0.69000000f,0.10000000f,0.13000000f,-0.42000000f,0.96000000f,-0.67000000f,-0.78000000f,0.10000000f,0.66000000f,0.85000000f,0.52000000f,0.89000000f,0.50000000f,0.38000000f,-0.03000000f,0.75000000f,0.29000000f,0.53000000f,-0.71000000f,0.99000000f,-0.58000000f,0.75000000f,0.74000000f,-0.66000000f,0.50000000f,0.76000000f,-0.73000000f,-0.84000000f,-0.86000000f,0.71000000f,0.07000000f,-0.82000000f,-0.43000000f,0.96000000f,0.94000000f,-0.36000000f,-0.27000000f,0.43000000f,0.03000000f,-0.60000000f,-0.35000000f,0.41000000f,-0.30000000f,0.06000000f,-0.51000000f,0.49000000f,-0.34000000f,0.99000000f,-0.86000000f,0.99000000f,-0.03000000f,-0.43000000f,-0.27000000f,-0.72000000f,-0.92000000f,0.17000000f,-0.78000000f,0.43000000f,0.93000000f,0.12000000f,-0.15000000f,0.73000000f,0.88000000f,0.44000000f,-0.58000000f,-0.20000000f,0.27000000f,0.45000000f,0.40000000f,0.02000000f,0.94000000f,-0.68000000f,0.88000000f,-0.76000000f,-0.16000000f,0.08000000f,0.92000000f,-0.88000000f,0.03000000f,-0.66000000f,-0.59000000f,-0.05000000f,-0.95000000f,-0.54000000f,0.97000000f,0.94000000f,-0.84000000f,0.24000000f,-0.03000000f,-0.14000000f,0.58000000f,-0.75000000f,0.38000000f,0.00000000f,-0.90000000f,-0.34000000f,-0.70000000f,-0.79000000f,-0.33000000f,0.48000000f,0.92000000f,-0.68000000f,-0.88000000f,0.99000000f,-0.58000000f,0.32000000f,0.81000000f,-0.57000000f,0.23000000f,-0.70000000f,-0.26000000f,0.49000000f,-0.13000000f,0.93000000f,0.66000000f,-0.31000000f,-0.58000000f,0.56000000f,-0.57000000f,-0.38000000f,0.59000000f,0.10000000f,0.10000000f,-0.55000000f,-0.41000000f,0.13000000f,-0.22000000f,-0.53000000f,0.30000000f,0.39000000f,0.66000000f,0.93000000f,-0.38000000f,0.93000000f,0.35000000f,-0.47000000f,0.21000000f,0.14000000f,0.86000000f,0.71000000f,-0.51000000f,-0.99000000f,0.72000000f,-0.37000000f,-0.24000000f,-0.04000000f,0.19000000f,0.03000000f,-0.18000000f,0.38000000f,-0.68000000f,0.88000000f,0.98000000f,-0.57000000f,0.26000000f,-0.18000000f,0.34000000f,0.99000000f,0.04000000f,-0.05000000f,0.84000000f,-0.83000000f,0.45000000f,-0.93000000f,-0.94000000f,-0.65000000f,0.91000000f,-0.23000000f,0.34000000f,-0.34000000f,-0.11000000f,0.10000000f,0.96000000f,0.22000000f,0.59000000f,0.67000000f,0.73000000f,-0.05000000f,0.34000000f,-0.69000000f,-0.74000000f,-0.32000000f,-0.47000000f,0.96000000f,-0.38000000f,-0.77000000f,-0.04000000f,-0.30000000f,-0.29000000f,-0.82000000f,0.22000000f,-0.05000000f,-0.56000000f,0.10000000f,-0.78000000f,-0.06000000f,-0.14000000f,-0.46000000f,-0.11000000f,0.66000000f,0.83000000f,-0.46000000f,-0.26000000f,-0.19000000f,-0.55000000f,0.28000000f,0.00000000f,-0.02000000f,0.02000000f,-0.64000000f,0.14000000f,-0.57000000f,-0.49000000f,0.07000000f,-0.38000000f,0.18000000f,0.75000000f,-0.97000000f,0.20000000f,-0.14000000f,0.26000000f,0.58000000f,-0.31000000f,-0.64000000f,0.90000000f,0.52000000f,-0.49000000f,0.98000000f,0.78000000f,-0.84000000f,-0.36000000f,0.64000000f,-0.63000000f,0.46000000f,-0.95000000f,0.05000000f,0.27000000f,0.65000000f,0.69000000f,-0.80000000f,-0.31000000f,-0.57000000f,0.70000000f,-0.34000000f,-0.65000000f,-0.46000000f,-0.06000000f,-0.12000000f,-0.35000000f,-0.03000000f,-0.49000000f,0.38000000f,-0.07000000f,-0.15000000f,-0.46000000f,0.65000000f,0.70000000f,-0.05000000f,-0.98000000f,-0.75000000f,0.07000000f,-0.61000000f,-0.69000000f,0.05000000f,-0.39000000f,-0.93000000f,-0.93000000f,0.66000000f,-0.68000000f,0.52000000f,0.76000000f,-0.24000000f,-0.78000000f,-0.06000000f,-0.77000000f,0.28000000f,-0.65000000f,-0.74000000f,0.42000000f,-0.04000000f,-0.59000000f,0.97000000f,-0.96000000f,0.87000000f,0.30000000f,-0.31000000f,-0.24000000f,0.99000000f,-0.15000000f,-0.06000000f,0.87000000f,-0.86000000f,0.34000000f,-0.68000000f,-0.15000000f,0.45000000f,-0.83000000f,-0.33000000f,0.56000000f,-0.53000000f,0.45000000f,-0.95000000f,0.48000000f,0.89000000f,0.93000000f,-0.74000000f,-0.21000000f,0.15000000f,-0.17000000f,-0.81000000f,-0.07000000f,0.99000000f,-0.32000000f,-0.66000000f,0.64000000f,-0.89000000f,-0.74000000f,0.14000000f,0.04000000f,-0.82000000f,-0.74000000f,-0.30000000f,0.61000000f,0.35000000f,-0.72000000f,0.52000000f,-0.60000000f,-0.44000000f,0.42000000f,0.58000000f,0.29000000f,0.91000000f,-0.44000000f,0.94000000f,0.65000000f,-0.32000000f,-0.26000000f,-0.02000000f,0.79000000f,0.45000000f,-0.40000000f,0.10000000f,0.53000000f,-0.11000000f,-0.15000000f,-0.99000000f,-0.24000000f,0.86000000f,0.85000000f,-0.42000000f,-0.00000000f,0.28000000f,0.07000000f,-0.86000000f,-0.18000000f,0.75000000f,-0.38000000f,0.16000000f,-0.62000000f,0.97000000f,0.28000000f,0.30000000f,0.80000000f,0.14000000f,0.24000000f,0.82000000f,-0.25000000f,0.55000000f,-0.82000000f,0.42000000f,-0.39000000f,-0.24000000f,-0.58000000f,0.54000000f,0.27000000f,0.95000000f,-0.98000000f,-0.30000000f,-0.55000000f,0.51000000f,-0.52000000f,-0.32000000f,-0.50000000f,0.49000000f,-0.90000000f,-0.15000000f,0.38000000f,-0.92000000f,0.38000000f,-0.48000000f,0.39000000f,0.45000000f,-0.56000000f,-0.96000000f,-0.96000000f,0.72000000f,-0.25000000f,-0.77000000f,-0.31000000f,0.59000000f,-0.89000000f,0.42000000f,0.48000000f,0.62000000f,-0.11000000f,-0.78000000f,0.70000000f,0.46000000f,0.88000000f,-0.32000000f,-0.62000000f,-0.87000000f,-0.61000000f,0.14000000f,0.99000000f,0.44000000f,0.81000000f,-0.66000000f,0.24000000f,-0.56000000f,0.69000000f,-0.97000000f,0.76000000f,-0.75000000f,-0.00000000f,-0.94000000f,0.58000000f,-0.32000000f,0.82000000f,0.74000000f,-0.24000000f,-0.88000000f,0.30000000f,-0.07000000f,0.04000000f,0.75000000f,-0.70000000f,0.70000000f,0.23000000f,-0.21000000f,-0.51000000f,0.36000000f,0.63000000f,-0.70000000f,0.10000000f,0.09000000f,0.64000000f,-0.51000000f,-0.12000000f,-0.23000000f,-0.39000000f,0.35000000f,0.74000000f,-0.58000000f,0.39000000f,-0.84000000f,0.81000000f,-0.93000000f,-0.40000000f,0.31000000f,-0.81000000f,0.41000000f,-0.89000000f,-0.27000000f,-0.39000000f,0.13000000f,-0.51000000f,-0.72000000f,-0.55000000f,0.79000000f,0.49000000f,-0.29000000f,0.00000000f,-0.92000000f,-0.10000000f,-0.77000000f,-0.75000000f,-0.33000000f,-0.20000000f,0.21000000f,0.22000000f,-0.31000000f,0.14000000f,-0.58000000f,0.82000000f,0.38000000f,0.33000000f,-0.01000000f,0.54000000f,-0.67000000f,0.24000000f,0.60000000f,0.53000000f,0.52000000f,0.21000000f,-0.73000000f,-0.72000000f,-0.60000000f,-0.37000000f,-0.34000000f,-0.06000000f,0.15000000f,-0.63000000f,-0.99000000f,-0.28000000f,0.04000000f,-0.36000000f,-0.28000000f,0.35000000f,0.88000000f,0.24000000f,0.52000000f,-0.54000000f,0.55000000f,-0.91000000f,0.36000000f,0.59000000f,0.48000000f,-0.43000000f,-0.54000000f,-0.36000000f,0.12000000f,0.56000000f,-0.72000000f,0.54000000f,-0.75000000f,-0.77000000f,0.12000000f,-0.89000000f,-0.30000000f,0.93000000f,-0.11000000f,-0.18000000f,-0.67000000f,-0.15000000f,0.02000000f,-0.76000000f,-0.51000000f,0.45000000f,0.79000000f,-0.49000000f,0.90000000f,-0.98000000f,-0.70000000f,0.10000000f,0.35000000f,-0.22000000f,0.66000000f,-0.62000000f,0.87000000f,0.44000000f,-0.55000000f,-0.63000000f,0.09000000f,-0.42000000f,-0.38000000f,0.81000000f,0.69000000f,-0.56000000f,-0.51000000f,0.25000000f,0.31000000f,0.06000000f,-0.99000000f,0.45000000f,-0.85000000f,0.84000000f,0.32000000f,0.21000000f,0.61000000f,-0.44000000f,-0.63000000f,0.46000000f,-0.87000000f,-0.03000000f,0.40000000f,-0.52000000f,0.89000000f,-0.92000000f,-0.14000000f,0.30000000f,0.39000000f,0.30000000f,-0.63000000f,-0.01000000f,-0.66000000f,-0.02000000f,-0.51000000f,0.14000000f,0.02000000f,0.28000000f,0.85000000f,0.77000000f,-0.55000000f,0.69000000f,-0.13000000f,-0.72000000f,-0.04000000f,-0.35000000f,0.05000000f,0.40000000f,0.49000000f,0.27000000f,-0.64000000f,-0.46000000f,-0.59000000f,-0.33000000f,0.43000000f,0.53000000f,-0.50000000f,-0.60000000f,0.28000000f,0.82000000f,0.51000000f,0.90000000f,0.48000000f,-0.55000000f,-0.08000000f,-0.32000000f,0.68000000f,-0.93000000f,-0.09000000f,-0.85000000f,-0.29000000f,-0.92000000f,0.15000000f,0.84000000f,-0.97000000f,0.12000000f,0.72000000f,0.81000000f,-0.88000000f,-0.98000000f,-0.26000000f,0.85000000f,0.56000000f,0.95000000f,-0.10000000f,0.67000000f,-0.14000000f,0.03000000f,0.25000000f,0.72000000f,-0.22000000f,0.18000000f,-0.72000000f,-0.85000000f,0.83000000f,0.00000000f,0.98000000f,-0.34000000f,0.35000000f,0.62000000f,-0.65000000f,-0.66000000f,0.78000000f,0.09000000f,-0.09000000f,-0.98000000f,0.89000000f,-0.27000000f,-0.54000000f,-0.82000000f,0.06000000f,-0.12000000f,-0.89000000f,0.45000000f,-0.07000000f,0.73000000f,-0.66000000f,-0.00000000f,-0.67000000f,0.56000000f,-0.41000000f,-0.99000000f,0.09000000f,0.30000000f,-0.30000000f,0.76000000f,-0.33000000f,0.02000000f,0.29000000f,-0.36000000f,0.69000000f,0.83000000f,-0.16000000f,0.76000000f,-0.36000000f,-0.47000000f,-0.22000000f,0.18000000f,-0.49000000f,0.57000000f,-0.02000000f,-0.56000000f,-0.93000000f,-0.19000000f,-0.98000000f,-0.98000000f,-0.17000000f,-0.42000000f,0.55000000f,0.49000000f,-0.37000000f,0.02000000f,-0.22000000f,-0.61000000f,-0.36000000f,0.94000000f,-0.65000000f,-0.87000000f,0.56000000f,-0.93000000f,-0.53000000f,-0.23000000f,-0.30000000f,0.34000000f,0.53000000f,-0.55000000f,-0.62000000f,-0.86000000f,0.22000000f,-0.57000000f,0.47000000f,0.12000000f,-0.93000000f,-0.83000000f,-0.90000000f,0.77000000f,0.36000000f,0.73000000f,-0.59000000f,0.87000000f,0.88000000f,-0.54000000f,0.88000000f,0.39000000f,0.42000000f,0.50000000f,0.68000000f,-0.66000000f,0.07000000f,0.22000000f,-0.39000000f,-0.47000000f,0.41000000f,-0.79000000f,-0.38000000f,0.79000000f,-0.09000000f,0.37000000f,-0.07000000f,0.05000000f,0.66000000f,-0.54000000f,0.45000000f,0.39000000f,0.84000000f,0.72000000f,0.12000000f,0.30000000f,-0.55000000f,0.54000000f,0.42000000f,-0.14000000f,-0.85000000f,-0.56000000f,-0.55000000f,0.27000000f,0.70000000f,0.98000000f,-0.28000000f,-0.29000000f,0.48000000f,-0.02000000f,-0.83000000f,-0.86000000f,-0.92000000f,0.88000000f,-0.11000000f,0.53000000f,0.06000000f,-0.45000000f,0.05000000f,0.78000000f,0.69000000f,0.22000000f,0.52000000f,0.11000000f,0.38000000f,-0.52000000f,0.47000000f,-0.02000000f,-0.43000000f,-0.19000000f,-0.39000000f,-0.45000000f,0.81000000f,0.29000000f,-0.97000000f,-0.04000000f,0.25000000f,-0.29000000f,-0.77000000f,0.46000000f,-0.62000000f,-0.92000000f,0.85000000f,-0.89000000f,-0.84000000f,0.03000000f,0.16000000f,0.47000000f,-0.18000000f,-0.60000000f,0.04000000f,0.71000000f,-0.99000000f,0.57000000f,0.12000000f,-0.83000000f,-0.26000000f,0.29000000f,-0.81000000f,-0.48000000f,0.91000000f,0.01000000f,-0.38000000f,0.50000000f,0.69000000f,0.38000000f,0.18000000f,0.03000000f,-0.64000000f,0.19000000f,0.10000000f,0.76000000f,0.27000000f,-0.34000000f,-0.28000000f,-0.74000000f,-0.26000000f,0.28000000f,-0.60000000f,0.95000000f,0.52000000f,0.84000000f,-0.20000000f,0.97000000f,0.93000000f,-0.56000000f,-0.29000000f,0.87000000f,-0.71000000f,0.20000000f,0.83000000f,-0.83000000f,0.69000000f,-0.86000000f,0.40000000f,0.34000000f,0.78000000f,-0.50000000f,-0.19000000f,0.50000000f,-0.78000000f,-0.11000000f,0.77000000f,-0.80000000f,0.95000000f,-0.22000000f,0.03000000f,-0.68000000f,-0.63000000f,0.74000000f,0.01000000f,-0.70000000f,-0.59000000f,-0.64000000f,-0.72000000f,0.83000000f,0.41000000f,-0.65000000f,-0.16000000f,-0.29000000f,0.55000000f,-0.63000000f,0.80000000f,-0.85000000f,-0.49000000f,0.45000000f,-0.54000000f,-0.00000000f,-0.36000000f,-0.04000000f,0.66000000f,-0.14000000f,0.15000000f,-0.44000000f,0.79000000f,-0.44000000f,0.81000000f,0.90000000f,0.65000000f,0.27000000f,-0.08000000f,0.28000000f,-0.88000000f,0.89000000f,-0.80000000f,-0.96000000f,-0.97000000f,0.56000000f,-0.72000000f,-0.68000000f,-0.26000000f,0.91000000f,0.43000000f,0.93000000f,-0.85000000f,-0.97000000f,-0.00000000f,0.04000000f,-0.68000000f,0.76000000f,0.61000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.95000000f,0.84000000f,0.47000000f,-0.66000000f,-0.92000000f,-0.50000000f,0.11000000f,-0.99000000f,0.22000000f,0.20000000f,0.00000000f,0.33000000f,0.14000000f,-0.35000000f,0.48000000f,0.42000000f,0.30000000f,0.89000000f,-0.93000000f,0.88000000f,-0.44000000f,0.08000000f,0.01000000f,0.03000000f,-0.14000000f,0.71000000f,0.24000000f,-0.17000000f,-0.68000000f,0.17000000f,0.53000000f,0.79000000f,0.97000000f,0.32000000f,0.58000000f,0.40000000f,-0.77000000f,-0.77000000f,0.14000000f,0.38000000f,0.69000000f,0.73000000f,0.88000000f,0.81000000f,0.67000000f,0.13000000f,-0.53000000f,-0.13000000f,-0.79000000f,0.70000000f,0.46000000f,0.71000000f,0.06000000f,-0.42000000f,0.96000000f,0.24000000f,0.02000000f,-0.31000000f,-0.18000000f,-0.87000000f,-0.70000000f,0.05000000f,-0.46000000f,-0.59000000f,-0.84000000f,0.12000000f,0.41000000f,-0.90000000f,0.45000000f,0.11000000f,0.02000000f,-0.49000000f,-0.26000000f,-0.41000000f,0.43000000f,-0.34000000f,-0.19000000f,-0.41000000f,-0.64000000f,-0.20000000f,0.22000000f,-0.20000000f,-0.05000000f,0.33000000f,-0.19000000f,0.69000000f,-0.85000000f,-0.01000000f,0.33000000f,0.07000000f,0.80000000f,-0.45000000f,-0.53000000f,-0.57000000f,0.88000000f,-0.80000000f,0.12000000f,0.60000000f,-0.31000000f,0.11000000f,0.33000000f,-0.10000000f,-0.09000000f,0.21000000f,-0.93000000f,-0.44000000f,0.18000000f,-0.13000000f,-0.33000000f,0.17000000f,0.38000000f,-0.43000000f,0.07000000f,0.30000000f,-0.10000000f,-0.25000000f,0.96000000f,-0.23000000f,0.91000000f,-0.47000000f,0.37000000f,0.52000000f,-0.96000000f,0.33000000f,0.37000000f,-0.75000000f,-0.91000000f,0.33000000f,0.11000000f,-0.92000000f,-0.98000000f,-0.74000000f,-0.26000000f,0.04000000f,-0.06000000f,0.38000000f,-0.73000000f,0.27000000f,0.88000000f,0.25000000f,-0.79000000f,0.48000000f,0.82000000f,0.98000000f,-0.97000000f,0.21000000f,-0.16000000f,0.56000000f,-0.03000000f,-0.53000000f,-0.13000000f,-0.73000000f,-0.31000000f,0.37000000f,-0.68000000f,-0.36000000f,0.42000000f,-0.21000000f,-0.02000000f,-0.57000000f,0.50000000f,0.00000000f,-0.87000000f,0.28000000f,0.27000000f,0.98000000f,-0.96000000f,0.21000000f,0.81000000f,-0.33000000f,-0.94000000f,-0.15000000f,-0.45000000f,0.93000000f,-0.36000000f,0.23000000f,0.64000000f,-0.04000000f,-0.13000000f,0.40000000f,-0.72000000f,0.17000000f,0.87000000f,-0.60000000f,-0.82000000f,-0.20000000f,0.32000000f,0.92000000f,0.99000000f,0.28000000f,-0.47000000f,0.50000000f,0.27000000f,0.58000000f,-0.98000000f,0.36000000f,0.90000000f,0.45000000f,-0.65000000f,0.26000000f,0.54000000f,-0.54000000f,0.35000000f,0.07000000f,-0.94000000f,0.23000000f,0.02000000f,0.87000000f,0.83000000f,0.09000000f,-0.83000000f,0.53000000f,0.44000000f,-0.93000000f,0.35000000f,-0.86000000f,-0.01000000f,0.38000000f,0.56000000f,-0.65000000f,0.72000000f,-0.04000000f,0.09000000f,0.17000000f,0.95000000f,-0.64000000f,0.91000000f,0.34000000f,-0.60000000f,-0.40000000f,0.73000000f,-0.66000000f,-0.65000000f,-0.21000000f,-0.17000000f,-0.12000000f,0.50000000f,0.27000000f,-0.68000000f,-0.74000000f,-0.27000000f,-0.64000000f,-0.75000000f,-0.01000000f,-0.50000000f,0.47000000f,-0.50000000f,-0.08000000f,-0.00000000f,-0.79000000f,0.99000000f,-0.01000000f,-0.69000000f,-0.60000000f,-0.95000000f,-0.11000000f,0.25000000f,-0.52000000f,-0.49000000f,0.31000000f,0.76000000f,-0.83000000f,-0.39000000f,-0.42000000f,-0.18000000f,0.06000000f,-0.04000000f,-0.74000000f,-0.27000000f,-0.23000000f,0.76000000f,0.33000000f,0.59000000f,-0.72000000f,-0.70000000f,-0.04000000f,0.63000000f,-0.21000000f,0.25000000f,0.16000000f,-0.03000000f,0.77000000f,0.03000000f,-0.74000000f,0.94000000f,-0.91000000f,-0.23000000f,0.47000000f,0.90000000f,0.82000000f,-0.58000000f,0.77000000f,-0.37000000f,0.05000000f,-0.51000000f,0.09000000f,-0.80000000f,0.95000000f,0.73000000f,0.28000000f,0.56000000f,-0.74000000f,-0.31000000f,0.37000000f,0.65000000f,0.32000000f,-0.50000000f,-0.52000000f,-0.68000000f,0.78000000f,0.82000000f,0.94000000f,0.27000000f,-0.44000000f,-0.05000000f,0.39000000f,-0.80000000f,-0.88000000f,0.42000000f,0.72000000f,0.02000000f,0.26000000f,-0.58000000f,0.21000000f,-0.90000000f,0.00000000f,0.36000000f,0.77000000f,-0.96000000f,-0.18000000f,0.99000000f,-0.71000000f,0.94000000f,-0.81000000f,-0.08000000f,-0.64000000f,-0.71000000f,-0.84000000f,-0.28000000f,0.44000000f,0.44000000f,0.80000000f,-0.17000000f,-0.50000000f,0.38000000f,0.75000000f,0.29000000f,0.54000000f,-0.56000000f,-0.40000000f,0.35000000f,0.59000000f,0.88000000f,-0.87000000f,0.03000000f,0.88000000f,-0.02000000f,0.26000000f,0.68000000f,0.38000000f,0.24000000f,0.03000000f,0.15000000f,0.28000000f,0.73000000f,0.67000000f,0.94000000f,-0.04000000f,0.18000000f,-0.19000000f,0.68000000f,-0.91000000f,0.41000000f,-0.50000000f,-0.36000000f,0.03000000f,-0.65000000f,0.44000000f,-0.73000000f,-0.18000000f,0.39000000f,0.40000000f,-0.53000000f,-0.94000000f,0.11000000f,0.71000000f,0.82000000f,-0.17000000f,0.65000000f,0.60000000f,0.93000000f,-0.99000000f,-0.11000000f,-0.83000000f,-0.31000000f,-0.09000000f,-0.08000000f,0.91000000f,-0.51000000f,-0.25000000f,0.52000000f,0.54000000f,0.23000000f,-0.00000000f,0.69000000f,0.88000000f,0.49000000f,-0.50000000f,0.99000000f,0.82000000f,-0.56000000f,-0.68000000f,0.18000000f,-0.38000000f,-0.97000000f,0.27000000f,-0.83000000f,0.63000000f,0.98000000f,-0.59000000f,0.43000000f,0.07000000f,-0.68000000f,-0.00000000f,-0.25000000f,-0.69000000f,-0.03000000f,0.86000000f,0.72000000f,0.53000000f,-0.95000000f,-0.88000000f,0.15000000f,0.43000000f,-0.61000000f,-0.03000000f,-0.56000000f,-0.44000000f,-0.35000000f,-0.46000000f,-0.21000000f,-0.80000000f,-0.63000000f,0.39000000f,-0.24000000f,-0.91000000f,0.24000000f,0.32000000f,-0.22000000f,0.73000000f,-0.24000000f,-0.53000000f,-0.22000000f,-0.62000000f,-0.39000000f,-0.40000000f,0.60000000f,0.78000000f,-0.11000000f,0.32000000f,-0.34000000f,0.53000000f,0.60000000f,0.10000000f,-0.59000000f,0.31000000f,0.77000000f,-0.54000000f,0.52000000f,0.68000000f,0.84000000f,-0.55000000f,-0.15000000f,0.16000000f,0.15000000f,-0.64000000f,0.73000000f,0.77000000f,-0.57000000f,-0.05000000f,0.36000000f,-0.03000000f,0.27000000f,0.93000000f,-0.88000000f,0.82000000f,0.40000000f,-0.69000000f,0.23000000f,0.01000000f,0.30000000f,-0.21000000f,0.09000000f,-0.18000000f,0.97000000f,0.33000000f,0.48000000f,-0.15000000f,-0.05000000f,-0.86000000f,0.81000000f,-0.33000000f,-0.92000000f,0.58000000f,0.47000000f,0.22000000f,0.81000000f,0.77000000f,-0.82000000f,-0.15000000f,0.82000000f,-0.53000000f,0.31000000f,0.30000000f,-0.16000000f,-0.24000000f,-0.24000000f,-0.80000000f,0.72000000f,-0.91000000f,-0.53000000f,-0.73000000f,0.85000000f,0.82000000f,-0.97000000f,-0.80000000f,-0.13000000f,-0.20000000f,0.40000000f,-0.70000000f,-0.35000000f,0.88000000f,0.08000000f,-0.48000000f,0.77000000f,0.62000000f,-0.16000000f,-0.47000000f,0.53000000f,0.11000000f,0.43000000f,-0.36000000f,-0.13000000f,-0.01000000f,-0.36000000f,0.88000000f,-0.89000000f,0.03000000f,0.69000000f,-0.36000000f,-0.98000000f,0.52000000f,0.28000000f,0.59000000f,0.27000000f,-0.43000000f,-0.75000000f,0.61000000f,0.67000000f,0.46000000f,-0.50000000f,-0.11000000f,-0.77000000f,-0.43000000f,-0.00000000f,-0.80000000f,0.91000000f,0.22000000f,-0.50000000f,-0.83000000f,-0.52000000f,0.94000000f,-0.92000000f,-0.36000000f,-0.96000000f,-0.40000000f,0.11000000f,-0.37000000f,0.08000000f,0.52000000f,0.53000000f,0.02000000f,-0.83000000f,0.54000000f,-0.48000000f,0.02000000f,-0.05000000f,0.32000000f,-0.78000000f,0.02000000f,-0.79000000f,0.34000000f,-0.54000000f,0.93000000f,-0.80000000f,0.32000000f,0.70000000f,-0.82000000f,0.92000000f,0.04000000f,0.83000000f,-0.26000000f,-0.68000000f,0.76000000f,0.78000000f,0.35000000f,0.71000000f,0.83000000f,0.52000000f,0.57000000f,-0.20000000f,0.12000000f,0.26000000f,-0.99000000f,0.47000000f,0.60000000f,-0.06000000f,-0.17000000f,0.26000000f,-0.60000000f,0.70000000f,-0.22000000f,-0.87000000f,-0.78000000f,0.29000000f,0.47000000f,0.76000000f,0.09000000f,0.73000000f,0.07000000f,-0.91000000f,-0.53000000f,-0.40000000f,0.78000000f,0.81000000f,-0.57000000f,-0.05000000f,-0.54000000f,-0.04000000f,-0.14000000f,0.80000000f,0.11000000f,-0.75000000f,0.56000000f,0.63000000f,-0.73000000f,-0.32000000f,0.86000000f,-0.98000000f,-0.64000000f,0.59000000f,-0.95000000f,0.63000000f,0.10000000f,0.24000000f,-0.83000000f,-0.60000000f,-0.67000000f,0.40000000f,-0.96000000f,-0.30000000f,-0.69000000f,0.70000000f,-0.89000000f,0.40000000f,-0.21000000f,0.83000000f,0.44000000f,0.71000000f,-0.85000000f,-0.05000000f,-0.95000000f,-0.83000000f,0.26000000f,-0.63000000f,0.37000000f,-0.05000000f,-0.76000000f,-0.47000000f,0.37000000f,0.01000000f,0.42000000f,-0.12000000f,0.99000000f,-0.43000000f,0.16000000f,-0.20000000f,-0.17000000f,-0.18000000f,-0.13000000f,-0.98000000f,-0.05000000f,-0.86000000f,0.40000000f,0.70000000f,-0.68000000f,0.93000000f,-0.62000000f,0.08000000f,-0.54000000f,-0.01000000f,0.82000000f,0.05000000f,-0.45000000f,-0.83000000f,-0.22000000f,-0.35000000f,0.54000000f,0.48000000f,0.12000000f,0.27000000f,-0.87000000f,-0.67000000f,-0.15000000f,0.02000000f,-0.67000000f,0.52000000f,0.24000000f,0.08000000f,-0.80000000f,0.09000000f,0.99000000f,0.31000000f,0.01000000f,0.83000000f,-0.99000000f,-0.90000000f,-0.23000000f,0.39000000f,0.75000000f,-0.51000000f,0.75000000f,0.37000000f,-0.28000000f,0.27000000f,-0.72000000f,0.71000000f,0.78000000f,0.95000000f,-0.05000000f,0.08000000f,-0.10000000f,-0.19000000f,0.43000000f,0.38000000f,-0.69000000f,-0.38000000f,0.67000000f,0.58000000f,0.86000000f,0.14000000f,0.86000000f,-0.06000000f,0.41000000f,-0.17000000f,-0.15000000f,0.96000000f,0.10000000f,0.20000000f,0.22000000f,-0.92000000f,-0.51000000f,-0.08000000f,0.84000000f,0.83000000f,-0.90000000f,0.51000000f,-0.07000000f,0.69000000f,0.84000000f,0.30000000f,0.35000000f,-0.01000000f,-0.01000000f,0.85000000f,0.76000000f,0.77000000f,-0.50000000f,0.67000000f,0.65000000f,-0.49000000f,-0.47000000f,-0.64000000f,0.63000000f,-0.12000000f,-0.84000000f,0.76000000f,0.50000000f,0.00000000f,-0.83000000f,-0.71000000f,0.43000000f,-0.10000000f,0.95000000f,0.86000000f,-0.77000000f,0.93000000f,-0.61000000f,-0.67000000f,-0.18000000f,-0.53000000f,-0.12000000f,-0.59000000f,0.95000000f,-0.97000000f,-0.08000000f,-0.20000000f,-0.65000000f,-0.78000000f,-0.02000000f,-0.47000000f,-0.55000000f,-0.77000000f,0.00000000f,-0.01000000f,-0.97000000f,0.29000000f,-0.68000000f,0.66000000f,-0.86000000f,0.70000000f,-0.53000000f,-0.99000000f,-0.29000000f,-0.87000000f,0.34000000f,0.13000000f,-0.12000000f,-0.64000000f,0.65000000f,-0.08000000f,0.80000000f,-0.37000000f,-0.01000000f,0.63000000f,-0.85000000f,0.37000000f,0.23000000f,0.06000000f,-0.57000000f,-0.99000000f,0.28000000f,-0.48000000f,0.70000000f,0.34000000f,0.08000000f,0.96000000f,-0.27000000f,0.36000000f,0.31000000f,-0.39000000f,-0.22000000f,-0.06000000f,-0.67000000f,-0.22000000f,-0.49000000f,0.77000000f,-0.16000000f,0.95000000f,-0.03000000f,-0.40000000f,0.67000000f,0.17000000f,0.73000000f,0.44000000f,-0.69000000f,0.78000000f,0.57000000f,-0.14000000f,-0.61000000f,-0.31000000f,0.73000000f,-0.71000000f,0.03000000f,0.95000000f,0.33000000f,-0.50000000f,0.69000000f,-0.11000000f,0.81000000f,-0.64000000f,0.67000000f,0.66000000f,-0.47000000f,-0.28000000f,-0.11000000f,0.11000000f,0.97000000f,0.67000000f,0.98000000f,0.38000000f,-0.07000000f,-0.38000000f,0.12000000f,-0.59000000f,0.89000000f,0.12000000f,0.05000000f,-0.03000000f,0.58000000f,-0.68000000f,-0.74000000f,0.57000000f,0.81000000f,0.23000000f,-0.35000000f,-0.27000000f,0.29000000f,-0.43000000f,0.03000000f,-0.60000000f,0.18000000f,0.07000000f,0.74000000f,-0.56000000f,0.70000000f,-0.11000000f,0.28000000f,-0.73000000f,0.14000000f,-0.60000000f,0.00000000f,-0.71000000f,-0.38000000f,0.39000000f,0.93000000f,-0.32000000f,0.75000000f,-0.39000000f,0.63000000f,-0.44000000f,-0.10000000f,0.10000000f,0.83000000f,0.56000000f,-0.07000000f,-0.25000000f,0.75000000f,0.96000000f,0.34000000f,-0.78000000f,-0.95000000f,-0.18000000f,0.36000000f,0.57000000f,-0.82000000f,0.44000000f,-0.57000000f,0.65000000f,0.40000000f,-0.02000000f,0.97000000f,0.31000000f,0.06000000f,-0.91000000f,-0.80000000f,-0.74000000f,-0.29000000f,0.46000000f,-0.58000000f,0.47000000f,0.25000000f,-0.06000000f,0.28000000f,0.98000000f,-0.56000000f,-0.13000000f,0.90000000f,0.28000000f,0.99000000f,0.78000000f,-0.46000000f,0.96000000f,-0.34000000f,-0.94000000f,0.22000000f,0.99000000f,-0.48000000f,0.18000000f,0.97000000f,-0.52000000f,0.98000000f,0.74000000f,-0.18000000f,0.04000000f,0.98000000f,-0.85000000f,-0.36000000f,-0.29000000f,-0.18000000f,-0.39000000f,-0.89000000f,0.49000000f,-0.71000000f,0.24000000f,0.59000000f,-0.85000000f,0.58000000f,0.86000000f,-0.68000000f,0.07000000f,0.72000000f,-0.32000000f,-0.76000000f,0.84000000f,0.05000000f,0.16000000f,0.68000000f,-0.76000000f,0.22000000f,-0.65000000f,-0.18000000f,-0.49000000f,-0.17000000f,0.70000000f,-0.42000000f,0.98000000f,0.18000000f,0.18000000f,0.22000000f,0.14000000f,0.35000000f,0.26000000f,-0.36000000f,0.98000000f,0.84000000f,-0.54000000f,0.13000000f,0.90000000f,0.46000000f,0.53000000f,-0.94000000f,-0.15000000f,-0.14000000f,0.77000000f,0.68000000f,0.16000000f,-0.49000000f,-0.43000000f,-0.83000000f,-0.33000000f,0.14000000f,-0.55000000f,-0.39000000f,-0.14000000f,0.08000000f,-0.78000000f,-0.79000000f,-0.65000000f,-0.65000000f,0.73000000f,0.97000000f,0.65000000f,0.50000000f,-0.51000000f,-0.24000000f,-0.88000000f,0.59000000f,0.74000000f,0.03000000f,-0.91000000f,0.33000000f,0.03000000f,-0.66000000f,-0.20000000f,-0.13000000f,0.94000000f,0.46000000f,0.41000000f,0.50000000f,0.45000000f,0.47000000f,-0.10000000f,-0.28000000f,-0.36000000f,-0.02000000f,-0.52000000f,0.11000000f,-0.19000000f,-0.70000000f,0.33000000f,0.20000000f,-0.85000000f,-0.15000000f,-0.89000000f,0.11000000f,0.68000000f,-0.64000000f,-0.70000000f,0.90000000f,-0.02000000f,-0.26000000f,-0.49000000f,0.88000000f,0.46000000f,0.75000000f,0.96000000f,0.46000000f,0.08000000f,0.43000000f,-0.14000000f,-0.17000000f,-0.74000000f,-0.75000000f,-0.19000000f,0.61000000f,-0.87000000f,0.84000000f,-0.04000000f,0.85000000f,0.16000000f,-0.73000000f,0.14000000f,-0.21000000f,0.21000000f,0.73000000f,0.92000000f,0.10000000f,-0.66000000f,0.37000000f,-0.64000000f,0.90000000f,0.32000000f,-0.46000000f,0.04000000f,0.80000000f,0.88000000f,0.13000000f,-0.88000000f,-0.48000000f,0.37000000f,0.42000000f,-0.35000000f,-0.92000000f,-0.16000000f,0.61000000f,-0.15000000f,0.17000000f,0.14000000f,0.89000000f,-0.15000000f,0.18000000f,0.94000000f,-0.13000000f,0.51000000f,-0.67000000f,0.64000000f,0.41000000f,0.45000000f,0.00000000f,-0.81000000f,0.06000000f,-0.06000000f,-0.48000000f,-0.92000000f,-0.42000000f,0.83000000f,-0.87000000f,0.29000000f,0.72000000f,0.70000000f,0.40000000f,0.79000000f,-0.80000000f,0.17000000f,0.32000000f,0.29000000f,-0.30000000f,-0.13000000f,0.82000000f,0.72000000f,-0.96000000f,-0.84000000f,-0.13000000f,-0.36000000f,0.10000000f,0.40000000f,0.59000000f,0.92000000f,-0.30000000f,-0.16000000f,-0.53000000f,-0.47000000f,0.14000000f,-0.82000000f,0.02000000f,0.81000000f,0.27000000f,-0.77000000f,0.63000000f,0.47000000f,0.24000000f,0.19000000f,-0.29000000f,-0.56000000f,-0.49000000f,-0.03000000f,0.60000000f,-0.84000000f,0.10000000f,-0.30000000f,-0.09000000f,0.78000000f,0.31000000f,-0.75000000f,0.19000000f,-0.10000000f,0.02000000f,0.45000000f,0.60000000f,-0.36000000f,0.68000000f,0.49000000f,-0.29000000f,-0.21000000f,0.54000000f,-0.66000000f,0.55000000f,0.03000000f,0.53000000f,0.25000000f,-0.47000000f,-0.13000000f,0.41000000f,0.74000000f,0.02000000f,-0.67000000f,-0.68000000f,-0.61000000f,-0.92000000f,-0.37000000f,-0.65000000f,-0.76000000f,-0.86000000f,0.83000000f,-0.84000000f,-0.79000000f,-0.36000000f,0.09000000f,0.43000000f,0.68000000f,-0.81000000f,-0.25000000f,0.81000000f,-0.66000000f,0.28000000f,0.33000000f,0.74000000f,0.56000000f,-0.29000000f,-0.84000000f,-0.76000000f,0.74000000f,-0.03000000f,0.52000000f,0.30000000f,0.18000000f,0.11000000f,-0.46000000f,0.28000000f,-0.15000000f,-0.27000000f,0.21000000f,0.79000000f,-0.46000000f,-0.41000000f,-0.70000000f,0.60000000f,-0.35000000f,-0.33000000f,-0.56000000f,-0.14000000f,0.17000000f,0.01000000f,-0.81000000f,-0.62000000f,-0.60000000f,0.39000000f,-0.62000000f,0.87000000f,0.83000000f,-0.00000000f,-0.47000000f,-0.39000000f,-0.97000000f,0.11000000f,0.22000000f,-0.32000000f,-0.21000000f,-0.25000000f,0.70000000f,0.70000000f,0.01000000f,0.04000000f,-0.38000000f,-0.12000000f,0.80000000f,0.85000000f,0.40000000f,0.87000000f,-0.59000000f,-0.99000000f,-0.17000000f,0.63000000f,0.30000000f,0.36000000f,0.77000000f,-0.25000000f,-0.50000000f,0.22000000f,-0.26000000f,0.49000000f,-0.97000000f,0.18000000f,-0.29000000f,-0.19000000f,-0.28000000f,0.34000000f,-0.69000000f,-0.15000000f,-0.50000000f,0.18000000f,0.68000000f,-0.31000000f,0.52000000f,-0.18000000f,-0.67000000f,-0.22000000f,0.11000000f,-0.58000000f,-0.17000000f,-0.21000000f,-0.01000000f,0.71000000f,0.93000000f,0.00000000f,0.41000000f,-0.72000000f,-0.66000000f,-0.26000000f,-0.57000000f,-0.06000000f,-0.44000000f,-0.06000000f,-0.79000000f,-0.14000000f,-0.09000000f,0.52000000f,0.67000000f,-0.65000000f,-0.52000000f,-0.85000000f,-0.52000000f,-0.18000000f,-0.70000000f,0.75000000f,-0.51000000f,-0.49000000f,-0.06000000f,0.81000000f,0.06000000f,-0.95000000f,0.53000000f,-0.80000000f,-0.16000000f,0.84000000f,0.97000000f,-0.53000000f,0.00000000f,-0.75000000f,-0.99000000f,-0.38000000f,0.07000000f,-0.44000000f,0.25000000f,0.31000000f,0.16000000f,-0.39000000f,-0.92000000f,-0.17000000f,-0.38000000f,-0.63000000f,0.27000000f,0.53000000f,0.56000000f,-0.82000000f,0.95000000f,0.69000000f,-0.25000000f,0.62000000f,-0.36000000f,-0.21000000f,0.15000000f,-0.82000000f,-0.73000000f,-0.77000000f,-0.78000000f,0.46000000f,-0.15000000f,0.44000000f,0.82000000f,-0.82000000f,-0.50000000f,-0.73000000f,-0.39000000f,-0.85000000f,0.89000000f,-0.30000000f,-0.48000000f,-0.96000000f,0.95000000f,0.66000000f,-0.08000000f,0.82000000f,-0.00000000f,-0.16000000f,0.99000000f,-0.49000000f,0.27000000f,0.88000000f,-0.69000000f,-0.36000000f,-0.81000000f,0.86000000f,-0.53000000f,0.79000000f,0.76000000f,0.56000000f,0.59000000f,-0.70000000f,0.31000000f,0.61000000f,0.80000000f,0.93000000f,0.90000000f,0.05000000f,0.42000000f,0.21000000f,-0.75000000f,-0.87000000f,0.48000000f,-0.83000000f,-0.58000000f,-0.53000000f,-0.20000000f,-0.34000000f,-0.08000000f,0.25000000f,-0.21000000f,-0.18000000f,-0.82000000f,0.59000000f,0.18000000f,-0.73000000f,0.50000000f,0.36000000f,0.01000000f,-0.54000000f,-0.40000000f,0.24000000f,-0.99000000f,-0.30000000f,-0.43000000f,-0.26000000f,0.53000000f,0.98000000f,0.90000000f,-0.68000000f,-0.57000000f,-0.02000000f,0.63000000f,-0.84000000f,-0.96000000f,-0.52000000f,0.32000000f,0.09000000f,-0.98000000f,-0.52000000f,0.64000000f,0.17000000f,0.82000000f,0.07000000f,0.92000000f,0.63000000f,-0.43000000f,-0.52000000f,0.06000000f,-0.85000000f,0.02000000f,-0.71000000f,-0.86000000f,-0.58000000f,-0.32000000f,0.79000000f,0.68000000f,0.02000000f,0.50000000f,-0.76000000f,-0.26000000f,-0.23000000f,0.03000000f,0.42000000f,-0.26000000f,-0.09000000f,-0.40000000f,0.84000000f,0.79000000f,-0.57000000f,-0.07000000f,-0.61000000f,-0.79000000f,-0.97000000f,0.16000000f,0.10000000f,0.45000000f,-0.04000000f,0.66000000f,-0.52000000f,-0.39000000f,-0.77000000f,0.94000000f,0.70000000f,0.61000000f,-0.96000000f,-0.33000000f,0.85000000f,0.53000000f,-0.74000000f,0.30000000f,0.31000000f,-0.33000000f,0.74000000f,-0.56000000f,-0.00000000f,-0.95000000f,-0.91000000f,-0.42000000f,0.85000000f,-0.02000000f,-0.06000000f,-0.73000000f,0.07000000f,-0.52000000f,0.10000000f,0.39000000f,0.90000000f,0.78000000f,-0.11000000f,0.58000000f,0.61000000f,0.30000000f,0.53000000f,0.51000000f,0.06000000f,0.62000000f,0.58000000f,0.39000000f,-0.78000000f,0.47000000f,-0.36000000f,-0.48000000f,0.29000000f,-0.98000000f,0.90000000f,-0.63000000f,-0.40000000f,0.77000000f,0.93000000f,0.32000000f,0.94000000f,0.76000000f,-0.86000000f,0.84000000f,-0.57000000f,-0.35000000f,-0.68000000f,0.58000000f,-0.70000000f,-0.87000000f,-0.13000000f,-0.99000000f,-0.46000000f,0.51000000f,0.28000000f,-0.22000000f,-0.92000000f,-0.02000000f,0.77000000f,0.91000000f,0.41000000f,-0.13000000f,-0.18000000f,-0.80000000f,-0.12000000f,0.99000000f,-0.62000000f,0.71000000f,-0.39000000f,-0.53000000f,-0.75000000f,-0.88000000f,-0.05000000f,0.84000000f,0.32000000f,0.87000000f,0.18000000f,0.71000000f,0.03000000f,-0.48000000f,-0.59000000f,0.43000000f,-0.44000000f,0.23000000f,-0.36000000f,0.79000000f,-0.27000000f,-0.30000000f,-0.35000000f,0.56000000f,0.99000000f,-0.35000000f,-0.89000000f,-0.45000000f,0.45000000f,-0.55000000f,0.27000000f,-0.29000000f,0.90000000f,-0.95000000f,-0.63000000f,0.31000000f,-0.28000000f,-0.56000000f,0.38000000f,-0.08000000f,-0.18000000f,0.51000000f,0.60000000f,-0.93000000f,-0.00000000f,0.89000000f,-0.52000000f,0.08000000f,-0.36000000f,-0.61000000f,0.71000000f,-0.06000000f,0.53000000f,-0.77000000f,-0.46000000f,-0.30000000f,-0.79000000f,-0.36000000f,0.59000000f,-0.32000000f,-0.28000000f,0.88000000f,-0.15000000f,0.99000000f,0.31000000f,0.84000000f,0.72000000f,0.45000000f,0.61000000f,-0.69000000f,0.73000000f,-0.28000000f,0.88000000f,-0.21000000f,0.65000000f,-0.54000000f,-0.76000000f,-0.33000000f,-0.53000000f,0.87000000f,-0.36000000f,0.96000000f,0.60000000f,-0.07000000f,0.43000000f,0.52000000f,0.68000000f,0.72000000f,-0.53000000f,-0.23000000f,0.09000000f,0.47000000f,-0.92000000f,-0.31000000f,-0.63000000f,-0.26000000f,-0.86000000f,0.28000000f,0.77000000f,-0.14000000f,0.63000000f,0.48000000f,0.81000000f,0.31000000f,0.94000000f,0.37000000f,0.93000000f,-0.70000000f,0.64000000f,-0.63000000f,-0.31000000f,-0.10000000f,-0.64000000f,0.61000000f,0.02000000f,-0.86000000f,-0.40000000f,-0.95000000f,-0.80000000f,0.98000000f,0.96000000f,-0.07000000f,0.33000000f,-0.59000000f,-0.13000000f,-0.54000000f,0.67000000f,-0.50000000f,0.14000000f,-0.30000000f,0.30000000f,-0.80000000f,0.71000000f,0.86000000f,0.26000000f,-0.97000000f,-0.57000000f,-0.88000000f,-0.95000000f,0.84000000f,-0.25000000f,0.58000000f,-0.28000000f,-0.61000000f,-0.55000000f,-0.03000000f,0.14000000f,-0.05000000f,0.66000000f,0.98000000f,-0.01000000f,-0.41000000f,0.06000000f,0.74000000f,0.09000000f,0.42000000f,0.34000000f,-0.06000000f,0.27000000f,-0.26000000f,-0.82000000f,-0.07000000f,0.67000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.07000000f,0.05000000f,-0.21000000f,0.35000000f,-0.77000000f,-0.39000000f,0.11000000f,0.15000000f,0.06000000f,0.17000000f,0.69000000f,0.25000000f,-0.89000000f,0.93000000f,-0.29000000f,-0.25000000f,-0.95000000f,0.74000000f,-0.29000000f,-0.22000000f,0.82000000f,-0.71000000f,0.39000000f,-0.54000000f,0.58000000f,0.41000000f,-0.82000000f,-0.65000000f,-0.41000000f,-0.74000000f,-0.09000000f,-0.08000000f,-0.53000000f,-0.06000000f,-0.02000000f,0.51000000f,0.76000000f,0.40000000f,0.23000000f,-0.14000000f,-0.71000000f,-0.59000000f,0.33000000f,0.14000000f,-0.98000000f,-0.01000000f,-0.45000000f,0.25000000f,-0.33000000f,-0.21000000f,0.47000000f,-0.28000000f,-0.43000000f,0.52000000f,-0.04000000f,0.04000000f,-0.63000000f,0.53000000f,-0.15000000f,-0.23000000f,-0.15000000f,0.04000000f,-0.99000000f,-0.69000000f,0.16000000f,0.26000000f,-0.21000000f,0.90000000f,0.99000000f,-0.91000000f,-0.69000000f,0.40000000f,-0.69000000f,-0.52000000f,0.18000000f,0.86000000f,-0.41000000f,0.69000000f,0.44000000f,-0.13000000f,-0.16000000f,0.89000000f,0.60000000f,-0.12000000f,0.06000000f,0.84000000f,-0.58000000f,0.71000000f,0.19000000f,0.81000000f,0.58000000f,-0.64000000f,-0.39000000f,-0.92000000f,-0.70000000f,-0.98000000f,-0.13000000f,0.07000000f,-0.99000000f,0.14000000f,0.69000000f,-0.20000000f,0.18000000f,-0.80000000f,0.34000000f,-0.79000000f,0.94000000f,0.34000000f,-0.81000000f,-0.69000000f,-0.72000000f,-0.07000000f,0.33000000f,0.06000000f,0.87000000f,-0.77000000f,0.72000000f,0.16000000f,0.74000000f,0.87000000f,-0.87000000f,0.57000000f,0.87000000f,0.65000000f,0.63000000f,-0.78000000f,0.71000000f,0.64000000f,-0.94000000f,0.45000000f,0.52000000f,0.61000000f,0.80000000f,0.56000000f,0.89000000f,-0.99000000f,0.31000000f,0.11000000f,-0.63000000f,0.21000000f,0.97000000f,0.04000000f,-0.59000000f,-0.81000000f,0.13000000f,0.46000000f,0.28000000f,0.01000000f,-0.22000000f,0.62000000f,-0.12000000f,0.64000000f,0.82000000f,-0.67000000f,-0.76000000f,0.87000000f,-0.23000000f,-0.43000000f,0.72000000f,-0.64000000f,0.08000000f,0.53000000f,-0.41000000f,-0.03000000f,-0.68000000f,0.62000000f,0.08000000f,0.37000000f,-0.12000000f,-0.52000000f,0.07000000f,0.06000000f,-0.28000000f,0.02000000f,0.35000000f,0.11000000f,0.38000000f,0.90000000f,-0.19000000f,-0.36000000f,0.95000000f,-0.53000000f,-0.66000000f,-0.30000000f,0.46000000f,0.44000000f,0.63000000f,0.15000000f,0.75000000f,-0.88000000f,-0.80000000f,-0.39000000f,-0.33000000f,0.45000000f,0.56000000f,-0.34000000f,0.98000000f,-0.50000000f,0.22000000f,0.15000000f,0.12000000f,0.62000000f,0.06000000f,0.82000000f,-0.40000000f,0.86000000f,0.56000000f,0.18000000f,0.13000000f,-0.30000000f,-0.98000000f,0.57000000f,-0.49000000f,-0.32000000f,-0.74000000f,0.91000000f,-0.07000000f,0.09000000f,0.35000000f,-0.22000000f,-0.42000000f,0.37000000f,0.41000000f,-0.01000000f,-0.45000000f,0.96000000f,-0.97000000f,-0.37000000f,0.58000000f,-0.74000000f,0.61000000f,0.37000000f,-0.25000000f,0.82000000f,0.99000000f,-0.22000000f,0.60000000f,-0.95000000f,0.35000000f,0.63000000f,-0.73000000f,-0.96000000f,0.40000000f,0.17000000f,-0.04000000f,0.01000000f,-0.45000000f,-0.52000000f,0.86000000f,0.32000000f,-0.97000000f,-0.67000000f,0.21000000f,0.60000000f,-0.88000000f,-0.17000000f,0.11000000f,-0.89000000f,0.52000000f,-0.93000000f,-0.17000000f,-0.94000000f,0.72000000f,-0.45000000f,0.81000000f,-0.85000000f,-0.63000000f,0.27000000f,0.72000000f,-0.99000000f,-0.74000000f,-0.70000000f,-0.06000000f,-0.28000000f,0.28000000f,0.89000000f,-0.38000000f,-0.36000000f,0.28000000f,0.51000000f,-0.29000000f,-0.04000000f,-0.22000000f,-0.77000000f,0.62000000f,0.68000000f,0.73000000f,-0.29000000f,0.96000000f,0.26000000f,0.36000000f,-0.79000000f,0.93000000f,0.23000000f,0.06000000f,-0.99000000f,0.93000000f,0.34000000f,-0.40000000f,0.43000000f,-0.80000000f,-0.60000000f,-0.64000000f,-0.17000000f,-0.89000000f,-0.56000000f,-0.81000000f,0.70000000f,-0.67000000f,0.57000000f,0.57000000f,-0.77000000f,-0.28000000f,-0.39000000f,-0.58000000f,-0.35000000f,-0.02000000f,0.21000000f,-0.43000000f,0.60000000f,-0.95000000f,-0.44000000f,0.40000000f,-0.22000000f,0.44000000f,-0.94000000f,0.21000000f,-0.21000000f,-0.38000000f,-0.06000000f,0.43000000f,-0.48000000f,0.49000000f,-0.79000000f,0.31000000f,-0.91000000f,0.34000000f,0.89000000f,0.10000000f,0.50000000f,0.48000000f,0.29000000f,0.00000000f,0.24000000f,0.50000000f,0.56000000f,-0.73000000f,-0.10000000f,0.23000000f,0.29000000f,0.59000000f,-0.02000000f,-0.76000000f,-0.46000000f,-0.97000000f,-0.06000000f,-0.46000000f,0.51000000f,0.14000000f,0.97000000f,-0.37000000f,0.65000000f,-0.74000000f,-0.20000000f,-0.29000000f,0.57000000f,-0.80000000f,-0.34000000f,-0.33000000f,0.17000000f,-0.86000000f,0.58000000f,-0.85000000f,-0.08000000f,0.09000000f,-0.88000000f,0.57000000f,-0.78000000f,-0.55000000f,-0.72000000f,0.18000000f,-0.45000000f,0.37000000f,-0.51000000f,-0.77000000f,0.83000000f,-0.39000000f,0.73000000f,-0.87000000f,-0.18000000f,-0.95000000f,0.94000000f,-0.21000000f,0.70000000f,0.56000000f,0.25000000f,0.99000000f,0.14000000f,0.18000000f,-0.35000000f,0.72000000f,0.09000000f,0.98000000f,0.85000000f,0.10000000f,0.97000000f,0.42000000f,-0.15000000f,-0.85000000f,0.89000000f,0.67000000f,0.99000000f,-0.08000000f,0.32000000f,0.08000000f,0.55000000f,0.96000000f,-0.52000000f,-0.63000000f,-0.21000000f,-0.50000000f,0.79000000f,0.10000000f,0.61000000f,-0.96000000f,-0.47000000f,0.59000000f,-0.02000000f,-0.39000000f,0.89000000f,0.31000000f,0.94000000f,-0.84000000f,0.47000000f,0.79000000f,0.82000000f,-0.18000000f,-0.41000000f,-0.22000000f,-0.99000000f,-0.68000000f,-0.35000000f,0.86000000f,0.16000000f,0.68000000f,0.05000000f,-0.11000000f,-0.65000000f,0.23000000f,-0.81000000f,-0.92000000f,-0.70000000f,0.60000000f,-0.65000000f,-0.37000000f,-0.23000000f,0.10000000f,0.15000000f,0.19000000f,-0.03000000f,0.74000000f,-0.07000000f,0.12000000f,-0.49000000f,0.67000000f,-0.91000000f,0.38000000f,0.53000000f,0.86000000f,-0.41000000f,-0.39000000f,-0.79000000f,-0.48000000f,-0.83000000f,-0.58000000f,0.18000000f,-0.96000000f,-0.77000000f,-0.47000000f,-0.38000000f,0.32000000f,0.23000000f,0.85000000f,0.35000000f,0.40000000f,-0.27000000f,0.66000000f,0.62000000f,0.65000000f,-0.94000000f,-0.69000000f,-0.93000000f,0.69000000f,-0.20000000f,0.05000000f,-0.67000000f,-0.18000000f,-0.36000000f,-0.31000000f,0.15000000f,-0.01000000f,0.86000000f,-0.72000000f,-0.94000000f,0.41000000f,-0.22000000f,-0.86000000f,-0.56000000f,0.69000000f,0.09000000f,-0.00000000f,-0.80000000f,0.05000000f,0.98000000f,0.95000000f,0.46000000f,-0.33000000f,-0.38000000f,-0.04000000f,-0.53000000f,-0.12000000f,0.82000000f,-0.55000000f,-0.79000000f,0.10000000f,-0.14000000f,-0.68000000f,-0.29000000f,0.14000000f,0.93000000f,0.64000000f,0.97000000f,0.37000000f,0.69000000f,0.73000000f,-0.57000000f,0.11000000f,-0.75000000f,-0.07000000f,0.74000000f,0.25000000f,-0.57000000f,0.67000000f,0.60000000f,-0.26000000f,-0.35000000f,-0.19000000f,0.55000000f,0.42000000f,-0.62000000f,0.63000000f,-0.87000000f,-0.82000000f,0.60000000f,-0.10000000f,-0.67000000f,0.89000000f,-0.38000000f,0.29000000f,0.30000000f,0.81000000f,0.95000000f,0.43000000f,-0.64000000f,0.91000000f,0.37000000f,0.96000000f,-0.71000000f,0.55000000f,0.06000000f,-0.95000000f,-0.56000000f,0.34000000f,0.25000000f,0.05000000f,0.26000000f,0.28000000f,0.95000000f,0.68000000f,-0.63000000f,-0.80000000f,0.63000000f,-0.09000000f,-0.06000000f,0.26000000f,-0.34000000f,-0.27000000f,-0.57000000f,0.99000000f,-0.48000000f,0.10000000f,0.96000000f,-0.17000000f,0.70000000f,-0.76000000f,-0.49000000f,0.37000000f,-0.81000000f,-0.05000000f,-0.67000000f,0.70000000f,-0.94000000f,-0.15000000f,-0.98000000f,0.03000000f,-0.77000000f,0.97000000f,-0.61000000f,-0.32000000f,0.63000000f,-0.01000000f,-0.42000000f,-0.89000000f,0.41000000f,0.14000000f,0.11000000f,-0.61000000f,-0.05000000f,0.32000000f,0.21000000f,0.64000000f,0.36000000f,-0.44000000f,0.05000000f,-0.33000000f,0.19000000f,-0.43000000f,-0.40000000f,-0.89000000f,0.90000000f,0.67000000f,0.66000000f,-0.37000000f,-0.67000000f,-0.63000000f,0.93000000f,0.29000000f,0.28000000f,0.41000000f,0.17000000f,-0.76000000f,-0.61000000f,-0.48000000f,-0.86000000f,-0.13000000f,-0.55000000f,0.96000000f,-0.06000000f,-0.14000000f,0.97000000f,0.86000000f,-0.20000000f,0.88000000f,0.40000000f,0.64000000f,0.79000000f,0.47000000f,-0.09000000f,-0.26000000f,-0.31000000f,0.74000000f,-0.09000000f,-0.49000000f,0.64000000f,-0.40000000f,-0.31000000f,-0.87000000f,-0.68000000f,0.40000000f,-0.44000000f,0.19000000f,0.10000000f,-0.69000000f,0.42000000f,-0.59000000f,0.84000000f,-0.39000000f,-0.85000000f,0.33000000f,0.44000000f,0.12000000f,0.69000000f,0.02000000f,-0.71000000f,0.57000000f,-0.16000000f,-0.67000000f,0.53000000f,-0.95000000f,0.37000000f,0.42000000f,0.40000000f,0.76000000f,-0.61000000f,0.02000000f,0.77000000f,0.66000000f,0.54000000f,-0.37000000f,-0.76000000f,-0.56000000f,0.77000000f,0.57000000f,0.99000000f,-0.02000000f,0.00000000f,0.54000000f,0.19000000f,0.89000000f,-0.32000000f,-0.00000000f,-0.74000000f,-0.82000000f,0.43000000f,0.42000000f,0.35000000f,-0.81000000f,0.68000000f,-0.52000000f,-0.17000000f,0.18000000f,0.29000000f,0.76000000f,-0.73000000f,0.01000000f,-0.28000000f,0.04000000f,0.21000000f,0.89000000f,-0.40000000f,0.04000000f,0.13000000f,-0.95000000f,0.33000000f,0.47000000f,0.18000000f,0.61000000f,-0.83000000f,-0.08000000f,-0.08000000f,-0.75000000f,0.30000000f,0.42000000f,0.76000000f,0.25000000f,0.18000000f,-0.84000000f,0.11000000f,-0.94000000f,-0.42000000f,-0.16000000f,-0.97000000f,0.54000000f,0.11000000f,0.37000000f,0.10000000f,-0.39000000f,-0.20000000f,0.09000000f,0.04000000f,-0.92000000f,0.97000000f,0.98000000f,-0.78000000f,0.58000000f,-0.74000000f,0.92000000f,-0.27000000f,0.16000000f,-0.42000000f,-0.31000000f,0.39000000f,0.23000000f,-0.65000000f,0.24000000f,-0.92000000f,0.52000000f,0.98000000f,0.39000000f,0.51000000f,0.98000000f,-0.98000000f,0.34000000f,0.68000000f,-0.84000000f,0.41000000f,-0.87000000f,0.55000000f,0.39000000f,0.16000000f,0.37000000f,0.01000000f,0.82000000f,0.91000000f,-0.82000000f,-0.76000000f,0.65000000f,-0.45000000f,0.44000000f,0.07000000f,-0.46000000f,0.64000000f,-0.63000000f,-0.11000000f,0.54000000f,-0.92000000f,-0.11000000f,-0.94000000f,-0.78000000f,-0.88000000f,0.68000000f,-0.11000000f,0.78000000f,0.28000000f,-0.08000000f,0.99000000f,0.27000000f,0.73000000f,-0.55000000f,0.05000000f,0.69000000f,-0.69000000f,-0.83000000f,0.70000000f,-0.24000000f,0.26000000f,-0.86000000f,0.69000000f,0.91000000f,0.43000000f,0.84000000f,-0.60000000f,0.31000000f,0.74000000f,0.57000000f,-0.93000000f,-0.85000000f,-0.74000000f,0.73000000f,-0.15000000f,0.30000000f,0.70000000f,-0.15000000f,0.09000000f,-0.46000000f,0.59000000f,0.05000000f,0.34000000f,0.33000000f,0.17000000f,-0.08000000f,0.03000000f,-0.60000000f,0.93000000f,0.11000000f,-0.13000000f,-0.65000000f,-0.19000000f,0.49000000f,0.82000000f,-0.77000000f,0.22000000f,-0.02000000f,0.79000000f,0.06000000f,0.16000000f,-0.79000000f,-0.30000000f,-0.48000000f,0.62000000f,-0.12000000f,-0.95000000f,-0.87000000f,-0.94000000f,-0.90000000f,-0.33000000f,0.60000000f,-0.21000000f,0.88000000f,-0.28000000f,0.46000000f,-0.14000000f,0.13000000f,-0.11000000f,-0.17000000f,-0.03000000f,0.19000000f,-0.04000000f,-0.34000000f,-0.14000000f,0.65000000f,-0.35000000f,-0.66000000f,-0.75000000f,0.25000000f,-0.91000000f,-0.45000000f,-0.59000000f,0.32000000f,0.75000000f,-0.24000000f,-0.14000000f,0.10000000f,-0.24000000f,0.03000000f,-0.83000000f,0.90000000f,0.08000000f,0.09000000f,0.65000000f,-0.39000000f,-0.80000000f,0.26000000f,0.36000000f,-0.14000000f,-0.53000000f,0.21000000f,-0.06000000f,0.63000000f,0.94000000f,-0.86000000f,0.30000000f,0.91000000f,-0.01000000f,-0.61000000f,0.67000000f,-0.44000000f,-0.57000000f,0.28000000f,0.83000000f,-0.46000000f,-0.18000000f,-0.27000000f,-0.25000000f,0.43000000f,0.55000000f,-0.74000000f,-0.39000000f,0.51000000f,0.62000000f,0.70000000f,0.17000000f,0.61000000f,-0.87000000f,-0.76000000f,-0.28000000f,0.80000000f,-0.09000000f,0.48000000f,-0.68000000f,0.46000000f,0.76000000f,0.73000000f,-0.06000000f,0.15000000f,0.01000000f,0.84000000f,-0.71000000f,0.43000000f,-0.82000000f,0.77000000f,-0.86000000f,0.30000000f,0.01000000f,-0.03000000f,-0.79000000f,-0.96000000f,0.75000000f,0.36000000f,-0.18000000f,-0.23000000f,0.79000000f,0.36000000f,-0.77000000f,0.96000000f,0.60000000f,0.11000000f,-0.73000000f,-0.44000000f,-0.15000000f,-0.54000000f,0.94000000f,-0.54000000f,0.73000000f,0.43000000f,0.70000000f,-0.02000000f,-0.47000000f,0.14000000f,-0.07000000f,-0.78000000f,-0.12000000f,0.61000000f,-0.65000000f,0.28000000f,-0.66000000f,-0.56000000f,0.76000000f,0.56000000f,0.52000000f,-0.43000000f,0.31000000f,0.11000000f,-0.94000000f,0.04000000f,-0.52000000f,-0.37000000f,0.86000000f,-0.74000000f,-0.38000000f,-0.40000000f,0.41000000f,-0.40000000f,0.09000000f,-0.07000000f,-0.79000000f,-0.08000000f,-0.32000000f,-0.87000000f,-0.31000000f,0.21000000f,-0.58000000f,-0.18000000f,-0.86000000f,0.29000000f,-0.28000000f,0.30000000f,-0.52000000f,0.41000000f,0.66000000f,0.10000000f,-0.40000000f,0.70000000f,0.29000000f,-0.20000000f,-0.25000000f,0.33000000f,0.32000000f,-0.14000000f,0.39000000f,-0.41000000f,0.65000000f,-0.88000000f,0.82000000f,0.34000000f,-0.80000000f,0.06000000f,0.86000000f,-0.69000000f,-0.84000000f,-0.36000000f,0.43000000f,0.25000000f,-0.80000000f,0.84000000f,0.19000000f,-0.80000000f,0.53000000f,-0.53000000f,0.04000000f,-0.54000000f,-0.26000000f,-0.59000000f,0.21000000f,-0.45000000f,0.53000000f,-0.17000000f,0.52000000f,0.35000000f,0.72000000f,0.16000000f,-0.31000000f,0.12000000f,-0.03000000f,-0.92000000f,0.02000000f,0.27000000f,0.52000000f,0.34000000f,-0.66000000f,-0.46000000f,-0.14000000f,0.81000000f,0.00000000f,0.92000000f,-0.49000000f,0.80000000f,0.40000000f,-0.90000000f,0.34000000f,0.12000000f,0.47000000f,0.16000000f,-0.66000000f,-0.83000000f,0.30000000f,0.10000000f,-0.99000000f,0.95000000f,0.61000000f,0.92000000f,0.90000000f,-0.46000000f,0.99000000f,0.38000000f,0.38000000f,0.79000000f,-0.33000000f,0.28000000f,0.69000000f,0.44000000f,-0.18000000f,-0.66000000f,0.07000000f,0.65000000f,-0.06000000f,-0.24000000f,-0.70000000f,0.01000000f,-0.31000000f,-0.40000000f,0.19000000f,0.93000000f,-0.52000000f,-0.29000000f,-0.59000000f,-0.55000000f,-0.57000000f,-0.61000000f,-0.51000000f,0.99000000f,0.22000000f,0.51000000f,0.71000000f,0.39000000f,0.59000000f,0.38000000f,0.02000000f,-0.98000000f,0.56000000f,-0.04000000f,-0.02000000f,0.44000000f,-0.85000000f,-0.70000000f,-0.70000000f,-0.02000000f,-0.09000000f,-0.96000000f,0.72000000f,0.25000000f,-0.20000000f,0.15000000f,0.68000000f,-0.90000000f,-0.91000000f,-0.99000000f,-0.21000000f,-0.59000000f,-0.38000000f,-0.02000000f,-0.84000000f,-0.50000000f,0.68000000f,-0.22000000f,-0.88000000f,0.25000000f,0.98000000f,-0.10000000f,-0.37000000f,-0.14000000f,0.70000000f,0.03000000f,0.45000000f,0.17000000f,-0.01000000f,0.33000000f,-0.15000000f,0.03000000f,-0.66000000f,-0.05000000f,-0.10000000f,0.35000000f,-0.00000000f,-0.12000000f,-0.79000000f,0.76000000f,0.29000000f,-0.27000000f,0.79000000f,-0.57000000f,0.62000000f,0.65000000f,0.84000000f,-0.17000000f,0.23000000f,0.74000000f,0.98000000f,-0.24000000f,-0.96000000f,-0.16000000f,0.76000000f,-0.22000000f,0.35000000f,-0.39000000f,0.67000000f,0.59000000f,0.91000000f,0.88000000f,0.69000000f,-0.72000000f,0.43000000f,0.55000000f,-0.55000000f,0.94000000f,0.34000000f,-0.74000000f,-0.44000000f,-0.48000000f,-0.92000000f,-0.62000000f,0.79000000f,0.52000000f,-0.59000000f,-0.14000000f,-0.20000000f,0.14000000f,0.65000000f,-0.27000000f,0.71000000f,-0.80000000f,0.29000000f,-0.15000000f,0.15000000f,0.30000000f,-0.65000000f,-0.17000000f,-0.72000000f,-0.90000000f,0.99000000f,-0.20000000f,0.40000000f,-0.59000000f,0.46000000f,-0.69000000f,0.97000000f,-0.86000000f,0.35000000f,-0.96000000f,0.22000000f,0.26000000f,-0.87000000f,-0.46000000f,-0.54000000f,0.30000000f,0.28000000f,0.63000000f,0.43000000f,-0.87000000f,-0.16000000f,0.40000000f,0.07000000f,-0.04000000f,0.67000000f,-0.30000000f,-0.45000000f,0.88000000f,0.92000000f,0.05000000f,0.24000000f,0.18000000f,-0.29000000f,0.26000000f,0.57000000f,-0.35000000f,0.49000000f,-0.16000000f,0.32000000f,-0.79000000f,-0.29000000f,-0.87000000f,-0.72000000f,0.40000000f,-0.44000000f,-0.69000000f,-0.93000000f,-0.85000000f,0.92000000f,0.00000000f,0.66000000f,-0.32000000f,0.94000000f,0.40000000f,0.81000000f,0.67000000f,-0.72000000f,-0.11000000f,0.82000000f,-0.83000000f,-0.53000000f,-0.01000000f,0.18000000f,-0.95000000f,-0.41000000f,-0.98000000f,-0.08000000f,0.24000000f,-0.33000000f,0.72000000f,-0.81000000f,0.21000000f,0.46000000f,0.25000000f,-0.74000000f,0.78000000f,0.68000000f,-0.20000000f,-0.66000000f,0.73000000f,-0.09000000f,0.98000000f,0.50000000f,0.38000000f,0.95000000f,-0.79000000f,0.47000000f,0.95000000f,-0.28000000f,-0.03000000f,0.15000000f,0.25000000f,0.61000000f,0.10000000f,-0.42000000f,0.98000000f,-0.93000000f,-0.47000000f,-0.03000000f,0.31000000f,0.50000000f,-0.24000000f,0.42000000f,-0.03000000f,-0.75000000f,0.75000000f,0.86000000f,0.07000000f,0.79000000f,0.39000000f,0.58000000f,-0.09000000f,-0.04000000f,0.63000000f,-0.49000000f,0.89000000f,0.64000000f,0.14000000f,-0.70000000f,0.04000000f,-0.24000000f,0.42000000f,0.98000000f,-0.88000000f,-0.86000000f,0.43000000f,-0.17000000f,-0.79000000f,-0.15000000f,-0.43000000f,0.97000000f,-0.88000000f,-0.97000000f,0.87000000f,-0.61000000f,0.56000000f,0.53000000f,0.94000000f,0.26000000f,-0.71000000f,0.68000000f,-0.19000000f,0.87000000f,0.00000000f,-0.02000000f,0.33000000f,0.91000000f,-0.36000000f,0.60000000f,-0.55000000f,-0.04000000f,-0.58000000f,-0.07000000f,0.18000000f,0.42000000f,-0.77000000f,-0.66000000f,-0.90000000f,-0.23000000f,-0.94000000f,0.90000000f,-0.37000000f,-0.63000000f,0.57000000f,0.98000000f,-0.46000000f,-0.47000000f,0.79000000f,0.63000000f,-0.05000000f,-0.39000000f,-0.51000000f,0.22000000f,0.23000000f,-0.89000000f,-0.01000000f,0.98000000f,-0.59000000f,-0.85000000f,0.12000000f,0.24000000f,0.63000000f,-0.69000000f,0.84000000f,-0.15000000f,0.48000000f,-0.16000000f,0.14000000f,0.78000000f,0.84000000f,0.86000000f,-0.80000000f,-0.05000000f,-0.42000000f,0.32000000f,-0.39000000f,-0.27000000f,0.85000000f,-0.58000000f,0.96000000f,-0.53000000f,-0.40000000f,-0.75000000f,0.76000000f,-0.87000000f,-0.39000000f,0.73000000f,0.48000000f,0.87000000f,-0.49000000f,0.94000000f,-0.25000000f,-0.19000000f,-0.30000000f,0.56000000f,-0.35000000f,0.09000000f,0.62000000f,0.02000000f,0.07000000f,-0.32000000f,0.83000000f,0.87000000f,0.96000000f,0.50000000f,0.16000000f,0.12000000f,-0.21000000f,-0.77000000f,-0.69000000f,0.95000000f,-0.84000000f,-0.93000000f,-0.83000000f,0.68000000f,0.06000000f,0.48000000f,-0.95000000f,0.44000000f,0.62000000f,0.21000000f,-0.62000000f,-0.11000000f,0.21000000f,-0.74000000f,-0.04000000f,0.07000000f,0.47000000f,-0.07000000f,-0.27000000f,0.71000000f,0.70000000f,-0.55000000f,0.13000000f,-0.50000000f,0.63000000f,-0.51000000f,0.48000000f,-0.19000000f,0.17000000f,-0.34000000f,-0.87000000f,-0.28000000f,-0.71000000f,0.16000000f,-0.56000000f,0.39000000f,-0.14000000f,0.26000000f,-0.09000000f,-0.48000000f,-0.10000000f,0.50000000f,-0.83000000f,0.02000000f,-0.39000000f,0.19000000f,0.10000000f,0.73000000f,-0.43000000f,-0.47000000f,0.79000000f,0.75000000f,0.89000000f,-0.38000000f,-0.72000000f,-0.93000000f,-0.22000000f,-0.00000000f,0.43000000f,0.07000000f,-0.96000000f,0.08000000f,0.63000000f,-0.55000000f,-0.55000000f,0.83000000f,-0.12000000f,-0.70000000f,0.03000000f,-0.51000000f,0.61000000f,0.49000000f,0.95000000f,0.93000000f,0.69000000f,0.88000000f,-0.10000000f,0.50000000f,-0.05000000f,-0.59000000f,0.36000000f,-0.85000000f,-0.02000000f,-0.02000000f,0.75000000f,-0.77000000f,-0.49000000f,0.16000000f,0.75000000f,-0.08000000f,-0.44000000f,0.17000000f,-0.87000000f,-0.19000000f,-0.60000000f,0.03000000f,-0.30000000f,-0.21000000f,-0.58000000f,0.08000000f,-0.47000000f,-0.03000000f,0.39000000f,0.61000000f,0.71000000f,0.10000000f,0.18000000f,0.53000000f,-0.62000000f,-0.72000000f,0.72000000f,-0.87000000f,-0.45000000f,-0.57000000f,0.14000000f,0.65000000f,-0.14000000f,-0.65000000f,0.17000000f,-0.89000000f,-0.35000000f,0.22000000f,-0.82000000f,-0.23000000f,-0.56000000f,0.25000000f,0.82000000f,0.98000000f,0.24000000f,0.76000000f,-0.27000000f,-0.97000000f,-0.14000000f,-0.99000000f,0.95000000f,0.73000000f,-0.37000000f,-0.26000000f,0.73000000f,-0.51000000f,0.42000000f,-0.25000000f,0.76000000f,0.59000000f,-0.54000000f,0.18000000f,0.12000000f,0.41000000f,0.41000000f,-0.45000000f,0.44000000f,-0.26000000f,-0.10000000f,-0.21000000f,-0.33000000f,0.82000000f,-0.88000000f,0.33000000f,-0.83000000f,-0.47000000f,0.08000000f,0.36000000f,-0.59000000f,-0.77000000f,0.70000000f,-0.23000000f,0.72000000f,0.77000000f,-0.99000000f,0.36000000f,0.16000000f,0.62000000f,0.35000000f,-0.99000000f,0.99000000f,-0.32000000f,0.39000000f,-0.09000000f,0.15000000f,0.97000000f,-0.42000000f,-0.51000000f,-0.98000000f,-0.23000000f,-0.81000000f,-0.62000000f,0.36000000f,-0.63000000f,0.33000000f,-0.67000000f,-0.84000000f,0.17000000f,0.26000000f,-0.57000000f,0.77000000f,-0.86000000f,0.54000000f,-0.11000000f,0.97000000f,-0.29000000f,0.45000000f,-0.59000000f,-0.39000000f,0.21000000f,-0.40000000f,0.03000000f,0.36000000f,0.41000000f,0.56000000f,0.76000000f,0.71000000f,-0.62000000f,-0.49000000f,0.99000000f,0.03000000f,0.55000000f,-0.15000000f,0.03000000f,0.62000000f,-0.62000000f,-0.02000000f,-0.53000000f,0.64000000f,-0.24000000f,0.14000000f,0.67000000f,-0.58000000f,-0.90000000f,0.66000000f,0.44000000f,-0.15000000f,0.16000000f,0.92000000f,0.84000000f,0.61000000f,0.45000000f,0.01000000f,-0.23000000f,0.51000000f,0.65000000f,-0.04000000f,-0.61000000f,-0.66000000f,0.76000000f,-0.52000000f,0.63000000f,0.82000000f,0.67000000f,0.81000000f,-0.08000000f,0.14000000f,0.91000000f,0.20000000f,-0.82000000f,-0.90000000f,0.70000000f,0.65000000f,0.87000000f,0.38000000f,0.77000000f,0.52000000f,0.40000000f,-0.57000000f,0.19000000f,0.58000000f,0.50000000f,0.78000000f,-0.09000000f,-0.93000000f,0.67000000f,0.06000000f,0.11000000f,0.36000000f,-0.40000000f,0.37000000f,0.53000000f,0.01000000f,-0.09000000f,0.89000000f,-0.87000000f,0.99000000f,-0.54000000f,0.92000000f,-0.45000000f,0.69000000f,-0.22000000f,0.92000000f,-0.01000000f,0.04000000f,0.68000000f,-0.96000000f,-0.56000000f,0.26000000f,0.24000000f,0.77000000f,-0.31000000f,0.23000000f,0.26000000f,-0.09000000f,-0.12000000f,-0.57000000f,0.35000000f,-0.80000000f,0.36000000f,0.36000000f,0.55000000f,0.85000000f,-0.60000000f,0.12000000f,-0.96000000f,-0.54000000f,-0.58000000f,-0.21000000f,0.62000000f,0.60000000f,0.64000000f,0.70000000f,-0.14000000f,-0.63000000f,-0.14000000f,0.55000000f,0.25000000f,0.21000000f,-0.19000000f,0.42000000f,-0.61000000f,-0.08000000f,-0.38000000f,-0.86000000f,0.08000000f,0.48000000f,-0.58000000f,0.82000000f,0.14000000f,0.50000000f,0.81000000f,0.07000000f,0.24000000f,0.03000000f,0.54000000f,0.47000000f,-0.97000000f,-0.80000000f,-0.76000000f,-0.86000000f,0.80000000f,-0.14000000f,-0.04000000f,-0.54000000f,0.61000000f,-0.42000000f,-0.90000000f,0.94000000f,-0.84000000f,0.15000000f,-0.72000000f,0.52000000f,0.10000000f,-0.48000000f,0.42000000f,-0.63000000f,0.93000000f,-0.80000000f,-0.17000000f,-0.29000000f,-0.87000000f,-0.24000000f,0.99000000f,0.75000000f,0.78000000f,-0.39000000f,-0.94000000f,0.46000000f,0.34000000f,-0.93000000f,0.87000000f,-0.18000000f,0.20000000f,0.33000000f,0.91000000f,0.12000000f,0.62000000f,-0.19000000f,-0.50000000f,-0.20000000f,0.73000000f,0.81000000f,-0.04000000f,-0.26000000f,0.16000000f,-0.24000000f,0.60000000f,-0.69000000f,0.59000000f,0.18000000f,0.02000000f,-0.00000000f,-0.28000000f,0.48000000f,-0.29000000f,-0.97000000f,0.11000000f,-0.34000000f,-0.22000000f,0.74000000f,0.53000000f,0.11000000f,-0.97000000f,-0.50000000f,-0.46000000f,-0.96000000f,-0.93000000f,-0.02000000f,-0.23000000f,0.04000000f,-0.30000000f,-0.79000000f,-0.46000000f,0.03000000f,-0.18000000f,0.71000000f,0.73000000f,0.27000000f,0.76000000f,0.65000000f,0.52000000f,0.34000000f,0.54000000f,-0.36000000f,0.02000000f,0.90000000f,-0.24000000f,-0.44000000f,-0.81000000f,-0.22000000f,0.50000000f,-0.25000000f,-0.94000000f,0.91000000f,-0.57000000f,-0.38000000f,0.95000000f,-0.05000000f,0.46000000f,-0.74000000f,-0.88000000f,0.59000000f,0.86000000f,-0.52000000f,-0.32000000f,0.30000000f,-0.43000000f,0.68000000f,0.69000000f,-0.88000000f,0.92000000f,-0.29000000f,-0.78000000f,0.89000000f,-0.96000000f,-0.91000000f,-0.80000000f,0.14000000f,-0.36000000f,-0.86000000f,0.79000000f,-0.39000000f,-0.81000000f,0.86000000f,0.43000000f,-0.77000000f,0.44000000f,-0.40000000f,-0.91000000f,-0.43000000f,-0.29000000f,-0.23000000f,-0.07000000f,-0.76000000f,0.14000000f,0.88000000f,0.59000000f,-0.36000000f,-0.80000000f,-0.81000000f,0.74000000f,0.49000000f,-0.41000000f,0.10000000f,-0.45000000f,0.89000000f,0.99000000f,0.95000000f,-0.84000000f,-0.19000000f,-0.50000000f,-0.00000000f,0.17000000f,-0.27000000f,-0.14000000f,-0.27000000f,-0.34000000f,-0.22000000f,0.10000000f,0.78000000f,-0.90000000f,0.64000000f,0.98000000f,-0.78000000f,0.06000000f,0.61000000f,0.51000000f,-0.34000000f,0.70000000f,-0.17000000f,-0.65000000f,0.84000000f,-0.56000000f,-0.81000000f,0.26000000f,-0.08000000f,0.84000000f,0.64000000f,0.96000000f,-0.26000000f,0.73000000f,0.68000000f,0.71000000f,-0.53000000f,-0.04000000f,0.32000000f,0.99000000f,-0.73000000f,0.65000000f,-0.57000000f,0.44000000f,-0.66000000f,-0.20000000f,-0.43000000f,-0.54000000f,-0.97000000f,0.41000000f,0.24000000f,-0.53000000f,-0.55000000f,-0.26000000f,-0.71000000f,0.51000000f,0.83000000f,0.53000000f,0.01000000f,0.95000000f,0.45000000f,-0.40000000f,0.31000000f,0.59000000f,0.34000000f,-0.45000000f,-0.92000000f,-0.27000000f,0.54000000f,-0.14000000f,-0.87000000f,-0.60000000f,0.72000000f,-0.70000000f,-0.04000000f,0.18000000f,0.91000000f,0.68000000f,-0.15000000f,0.21000000f,0.86000000f,0.54000000f,-0.86000000f,0.70000000f,0.40000000f,0.64000000f,-0.82000000f,-0.70000000f,0.68000000f,0.96000000f,0.71000000f,0.84000000f,-0.89000000f,-0.47000000f,-0.63000000f,-0.75000000f,0.79000000f,-0.77000000f,0.14000000f,0.02000000f,0.19000000f,-0.84000000f,-0.19000000f,0.63000000f,0.32000000f,0.65000000f,-0.16000000f,0.44000000f,-0.23000000f,-0.01000000f,0.67000000f,0.85000000f,0.08000000f,0.32000000f,0.14000000f,0.70000000f,0.40000000f,-0.03000000f,-0.29000000f,0.78000000f,-0.17000000f,-0.68000000f,0.36000000f,0.28000000f,-0.48000000f,0.65000000f,0.74000000f,-0.37000000f,0.81000000f,-0.95000000f,-0.21000000f,0.04000000f,-0.23000000f,-0.24000000f,-0.27000000f,-0.93000000f,0.19000000f,-0.27000000f,-0.83000000f,0.19000000f,-0.21000000f,-0.08000000f,-0.19000000f,0.73000000f,0.26000000f,-0.97000000f,0.51000000f,0.92000000f,-0.53000000f,-0.18000000f,-0.54000000f,0.89000000f,-0.49000000f,-0.61000000f,-0.54000000f,-0.63000000f,-0.01000000f,-0.77000000f,0.96000000f,0.44000000f,-0.64000000f,0.63000000f,0.24000000f,-0.51000000f,0.67000000f,-0.16000000f,-0.99000000f,0.61000000f,0.73000000f,0.53000000f,0.84000000f,-0.06000000f,-0.39000000f,0.13000000f,0.40000000f,-0.26000000f,0.90000000f,0.94000000f,0.15000000f,0.71000000f,0.70000000f,-0.71000000f,-0.53000000f,0.74000000f,0.47000000f,-0.45000000f,0.45000000f,-0.24000000f,0.44000000f,0.90000000f,-0.71000000f,0.22000000f,0.32000000f,-0.61000000f,-0.78000000f,-0.66000000f,-0.44000000f,0.88000000f,-0.58000000f,0.57000000f,0.08000000f,0.57000000f,-0.61000000f,0.71000000f,-0.12000000f,0.49000000f,-0.41000000f,-0.69000000f,-0.47000000f,-0.46000000f,0.73000000f,-0.19000000f,-0.01000000f,0.44000000f,-0.41000000f,0.74000000f,0.15000000f,0.15000000f,0.10000000f,0.10000000f,0.59000000f,0.16000000f,-0.80000000f,-0.75000000f,0.79000000f,-0.22000000f,-0.75000000f,-0.05000000f,0.22000000f,-0.92000000f,-0.11000000f,-0.86000000f,0.81000000f,-0.29000000f,-0.08000000f,-0.78000000f,-0.65000000f,0.19000000f,-0.35000000f,-0.76000000f,0.91000000f,-0.55000000f,-0.39000000f,-0.23000000f,0.34000000f,-0.07000000f,-0.95000000f,0.10000000f,0.98000000f,-0.12000000f,-0.49000000f,-0.79000000f,-0.00000000f,0.57000000f,0.83000000f,0.21000000f,0.28000000f,0.33000000f,-0.87000000f,0.60000000f,-0.00000000f,-0.82000000f,-0.00000000f,0.61000000f,0.06000000f,0.45000000f,0.65000000f,0.75000000f,0.04000000f,-0.21000000f,-0.92000000f,0.25000000f,-0.11000000f,-0.52000000f,0.79000000f,0.19000000f,0.48000000f,-0.79000000f,-0.26000000f,0.47000000f,0.05000000f,0.98000000f,0.89000000f,-0.58000000f,-0.03000000f,0.22000000f,0.20000000f,0.17000000f,-0.96000000f,0.13000000f,0.92000000f,-0.31000000f,-0.81000000f,-0.30000000f,-0.60000000f,0.30000000f,0.78000000f,0.86000000f,-0.40000000f,0.23000000f,-0.36000000f,-0.35000000f,-0.69000000f,0.93000000f,0.94000000f,0.52000000f,0.38000000f,0.33000000f,-0.97000000f,-0.28000000f,0.80000000f,0.47000000f,-0.27000000f,0.06000000f,0.25000000f,-0.74000000f,0.57000000f,0.04000000f,-0.93000000f,0.88000000f,0.65000000f,0.68000000f,0.95000000f,-0.69000000f,0.58000000f,-0.67000000f,0.73000000f,0.85000000f,-0.35000000f,-0.10000000f,-0.38000000f,-0.57000000f,0.67000000f,0.79000000f,-0.24000000f,0.60000000f,0.89000000f,-0.85000000f,0.20000000f,0.11000000f,0.14000000f,-0.02000000f,0.53000000f,-0.56000000f,0.39000000f,-0.27000000f,0.43000000f,0.43000000f,-0.41000000f,-0.25000000f,0.00000000f,-0.13000000f,0.26000000f,0.08000000f,0.39000000f,0.07000000f,0.04000000f,0.70000000f,0.49000000f,-0.28000000f,0.19000000f,-0.48000000f,0.29000000f,0.52000000f,-0.99000000f,0.40000000f,0.04000000f,0.47000000f,0.54000000f,0.32000000f,0.48000000f,0.66000000f,0.51000000f,0.29000000f,-0.58000000f,-0.93000000f,0.03000000f,-0.23000000f,0.62000000f,-0.33000000f,-0.51000000f,-0.63000000f,0.22000000f,0.47000000f,0.26000000f,-0.04000000f,-0.50000000f,0.25000000f,-0.61000000f,0.92000000f,-0.52000000f,0.97000000f,-0.12000000f,0.98000000f,-0.12000000f,0.20000000f,-0.04000000f,-0.78000000f,-0.69000000f,-0.06000000f,-0.55000000f,0.38000000f,-0.19000000f,-0.35000000f,0.84000000f,0.46000000f,0.68000000f,0.17000000f,0.27000000f,0.32000000f,0.79000000f,0.37000000f,-0.16000000f,-0.39000000f,0.55000000f,-0.49000000f,-0.70000000f,-0.67000000f,-0.53000000f,0.80000000f,0.35000000f,-0.96000000f,-0.06000000f,0.63000000f,-0.50000000f,-0.16000000f,0.35000000f,0.39000000f,0.51000000f,0.65000000f,-0.12000000f,0.24000000f,-0.88000000f,0.08000000f,0.56000000f,0.92000000f,-0.77000000f,0.93000000f,0.79000000f,-0.06000000f,-0.82000000f,0.00000000f,-0.67000000f,0.49000000f,0.83000000f,0.35000000f,-0.47000000f,-0.67000000f,-0.94000000f,-0.23000000f,0.71000000f,-0.06000000f,-0.06000000f,0.98000000f,-0.94000000f,-0.79000000f,0.03000000f,-0.43000000f,-0.64000000f,-0.27000000f,-0.32000000f,-0.78000000f,0.40000000f,-0.39000000f,0.96000000f,0.81000000f,0.36000000f,-0.64000000f,0.41000000f,0.97000000f,-0.08000000f,0.01000000f,0.31000000f,-0.08000000f,-0.85000000f,-0.09000000f,-0.40000000f,-0.91000000f,-0.11000000f,-0.29000000f,0.79000000f,-0.40000000f,-0.20000000f,-0.92000000f,0.72000000f,-0.25000000f,0.40000000f,-0.20000000f,0.47000000f,-0.52000000f,0.86000000f,0.68000000f,-0.68000000f,0.15000000f,0.99000000f,0.30000000f,-0.99000000f,-0.51000000f,0.44000000f,-0.96000000f,-0.71000000f,0.83000000f,-0.37000000f,-0.12000000f,-0.58000000f,-0.11000000f,0.60000000f,-0.96000000f,-0.35000000f,-0.13000000f,0.52000000f,0.99000000f,-0.94000000f,-0.49000000f,-0.88000000f,-0.50000000f,0.11000000f,-0.79000000f,-0.04000000f,-0.03000000f,-0.60000000f,-0.16000000f,-0.93000000f,-0.85000000f,-0.73000000f,-0.47000000f,-0.22000000f,-0.27000000f,-0.52000000f,0.19000000f,-0.39000000f,0.96000000f,-0.23000000f,0.72000000f,-0.19000000f,-0.71000000f,0.00000000f,-0.78000000f,0.55000000f,0.90000000f,0.47000000f,-0.33000000f,-0.02000000f,0.04000000f,-0.66000000f,-0.34000000f,-0.32000000f,-0.34000000f,0.34000000f,-0.93000000f,0.38000000f,-0.43000000f,0.70000000f,0.90000000f,-0.76000000f,-0.16000000f,0.54000000f,-0.30000000f,0.57000000f,0.20000000f,-0.68000000f,0.62000000f,0.03000000f,0.58000000f,0.41000000f,-0.59000000f,0.54000000f,0.96000000f,-0.04000000f,-0.84000000f,-0.34000000f,-0.76000000f,0.89000000f,-0.86000000f,-0.84000000f,-0.22000000f,-0.61000000f,-0.64000000f,-0.25000000f,0.07000000f,-0.37000000f,-0.85000000f,-0.41000000f,0.59000000f,0.11000000f,-0.97000000f,0.68000000f,0.28000000f,-0.42000000f,-0.19000000f,0.79000000f,-0.46000000f,0.42000000f,0.83000000f,0.97000000f,-0.18000000f,0.16000000f,-0.04000000f,-0.22000000f,0.04000000f,0.14000000f,0.96000000f,0.61000000f,0.72000000f,-0.71000000f,0.23000000f,-0.85000000f,0.06000000f,0.20000000f,-0.72000000f,0.31000000f,0.84000000f,-0.57000000f,-0.23000000f,-0.31000000f,0.17000000f,0.39000000f,0.56000000f,0.31000000f,0.46000000f,-0.15000000f,-0.11000000f,-0.86000000f,0.51000000f,-0.43000000f,-0.63000000f,0.65000000f,0.51000000f,-0.54000000f,-0.58000000f,0.13000000f,0.55000000f,-0.77000000f,-0.64000000f,-0.81000000f,0.18000000f,-0.08000000f,0.21000000f,-0.13000000f,0.18000000f,0.64000000f,0.55000000f,-0.73000000f,-0.35000000f,0.39000000f,-0.79000000f,0.68000000f,0.52000000f,-0.68000000f,0.69000000f,0.42000000f,-0.64000000f,-0.98000000f,0.76000000f,-0.56000000f,0.76000000f,-0.06000000f,-0.64000000f,-0.99000000f,-0.16000000f,0.19000000f,0.90000000f,-0.31000000f,-0.98000000f,-0.71000000f,-0.36000000f,-0.19000000f,-0.03000000f,0.98000000f,-0.34000000f,-0.50000000f,0.91000000f,-0.38000000f,0.20000000f,-0.13000000f,0.62000000f,-0.09000000f,0.66000000f,-0.69000000f,0.25000000f,-0.81000000f,-0.20000000f,-0.16000000f,-0.23000000f,0.26000000f,0.69000000f,0.05000000f,-0.88000000f,-0.71000000f,-0.02000000f,0.96000000f,0.56000000f,0.48000000f,-0.50000000f,-0.68000000f,-0.83000000f,-0.17000000f,0.38000000f,0.48000000f,0.04000000f,-0.05000000f,-0.47000000f,0.46000000f,0.85000000f,0.13000000f,0.08000000f,0.39000000f,0.89000000f,-0.36000000f,0.05000000f,-0.60000000f,-0.95000000f,-0.95000000f,0.08000000f,0.76000000f,0.82000000f,-0.62000000f,0.32000000f,-0.09000000f,0.55000000f,-0.26000000f,0.08000000f,-0.88000000f,-0.93000000f,-0.96000000f,0.26000000f,0.08000000f,0.98000000f,0.40000000f,0.34000000f,-0.34000000f,-0.38000000f,0.35000000f,0.68000000f,0.28000000f,-0.58000000f,0.66000000f,0.30000000f,-0.66000000f,-0.25000000f,0.42000000f,0.05000000f,-0.19000000f,0.33000000f,0.47000000f,0.39000000f,-0.03000000f,0.63000000f,0.09000000f,0.65000000f,0.83000000f,-0.67000000f,-0.86000000f,0.72000000f,-0.20000000f,0.35000000f,-0.88000000f,-0.37000000f,-0.52000000f,-0.29000000f,-0.83000000f,-0.02000000f,-0.08000000f,0.25000000f,-0.75000000f,0.42000000f,-0.23000000f,-0.37000000f,0.48000000f,-0.75000000f,-0.11000000f,0.87000000f,0.87000000f,0.03000000f,0.33000000f,-0.26000000f,-0.43000000f,0.65000000f,0.45000000f,0.77000000f,0.99000000f,-0.52000000f,0.97000000f,-0.72000000f,0.74000000f,0.38000000f,0.86000000f,-0.26000000f,0.81000000f,0.94000000f,0.28000000f,0.16000000f,-0.69000000f,-0.50000000f,-0.78000000f,-0.40000000f,0.11000000f,-0.10000000f,0.89000000f,0.88000000f,0.57000000f,-0.75000000f,-0.55000000f,-0.49000000f,0.06000000f,0.18000000f,-0.56000000f,0.18000000f,0.92000000f,-0.63000000f,0.94000000f,0.01000000f,0.39000000f,0.46000000f,0.44000000f,0.90000000f,0.16000000f,0.77000000f,-0.58000000f,-0.69000000f,0.88000000f,0.12000000f,0.10000000f,0.27000000f,-0.89000000f,-0.94000000f,-0.64000000f,0.55000000f,-0.87000000f,-0.70000000f,-0.47000000f,0.93000000f,0.73000000f,-0.87000000f,-0.20000000f,-0.21000000f,0.61000000f,-0.98000000f,-0.67000000f,-0.45000000f,0.82000000f,0.77000000f,-0.38000000f,-0.29000000f,-0.61000000f,-0.78000000f,0.93000000f,-0.74000000f,-0.48000000f,0.51000000f,0.03000000f,0.73000000f,-0.53000000f,-0.55000000f,0.99000000f,0.08000000f,0.99000000f,0.88000000f,0.57000000f,0.04000000f,-0.98000000f,0.12000000f,-0.39000000f,0.47000000f,-0.54000000f,-0.65000000f,-0.29000000f,-0.51000000f,-0.92000000f,-0.23000000f,0.73000000f,-0.76000000f,0.50000000f,0.11000000f,0.38000000f,-0.44000000f,0.04000000f,-0.40000000f,-0.27000000f,-0.95000000f,-0.83000000f,0.77000000f,-0.20000000f,-0.27000000f,-0.36000000f,0.59000000f,0.65000000f,-0.69000000f,-0.53000000f,-0.86000000f,-0.55000000f,-0.68000000f,0.80000000f,0.55000000f,0.69000000f,-0.41000000f,-0.49000000f,0.95000000f,0.99000000f,0.01000000f,-0.17000000f,-0.72000000f,-0.70000000f,-0.05000000f,-0.56000000f,0.92000000f,-0.37000000f,0.00000000f,-0.38000000f,-0.18000000f,-0.63000000f,-0.46000000f,-0.45000000f,0.82000000f,0.54000000f,0.31000000f,0.41000000f,-0.00000000f,0.08000000f,-0.91000000f,0.16000000f,0.35000000f,-0.62000000f,-0.36000000f,0.22000000f,0.26000000f,-0.31000000f,-0.91000000f,0.48000000f,0.41000000f,0.87000000f,-0.34000000f,0.69000000f,0.24000000f,-0.83000000f,0.90000000f,0.76000000f,0.17000000f,0.11000000f,0.85000000f,0.03000000f,-0.66000000f,-0.29000000f,0.58000000f,0.31000000f,-0.87000000f,-0.90000000f,-0.48000000f,0.21000000f,-0.34000000f,-0.87000000f,0.60000000f,0.91000000f,-0.85000000f,-0.59000000f,0.20000000f,0.64000000f,-0.55000000f,-0.20000000f,0.77000000f,-0.70000000f,0.36000000f,0.44000000f,-0.66000000f,-0.12000000f,-0.56000000f,-0.47000000f,0.37000000f,-0.45000000f,0.43000000f,0.93000000f,0.76000000f,0.03000000f,-0.42000000f,-0.12000000f,0.91000000f,-0.25000000f,-0.93000000f,-0.71000000f,0.00000000f,0.32000000f,0.41000000f,-0.72000000f,0.38000000f,-0.29000000f,-0.83000000f,0.71000000f,-0.73000000f,-0.68000000f,0.81000000f,0.83000000f,0.08000000f,0.74000000f,-0.37000000f,-0.17000000f,0.01000000f,-0.97000000f,-0.35000000f,-0.79000000f,0.80000000f,-0.27000000f,0.28000000f,-0.50000000f,-0.55000000f,0.70000000f,0.36000000f,0.68000000f,-0.25000000f,-0.08000000f,0.84000000f,-0.28000000f,-0.92000000f,0.54000000f,-0.50000000f,0.82000000f,0.23000000f,-0.01000000f,0.09000000f,0.61000000f,0.42000000f,-0.48000000f,0.01000000f,0.56000000f,0.96000000f,0.28000000f,0.67000000f,-0.48000000f,-0.98000000f,-0.56000000f,-0.05000000f,-0.55000000f,0.91000000f,0.77000000f,-0.98000000f,0.55000000f,0.89000000f,0.56000000f,0.58000000f,0.42000000f,0.87000000f,0.40000000f,0.28000000f,-0.51000000f,0.74000000f,0.99000000f,0.77000000f,0.55000000f,0.48000000f,0.58000000f,-0.28000000f,-0.16000000f,0.69000000f,0.19000000f,-0.15000000f,-0.67000000f,-0.89000000f,-0.63000000f,-0.49000000f,0.69000000f,0.14000000f,0.41000000f,0.37000000f,0.96000000f,0.11000000f,-0.89000000f,-0.19000000f,0.83000000f,0.67000000f,-0.51000000f,0.17000000f,-0.79000000f,0.53000000f,-0.27000000f,-0.41000000f,-0.93000000f,-0.01000000f,0.31000000f,0.17000000f,0.20000000f,0.79000000f,0.84000000f,0.90000000f,-0.02000000f,0.59000000f,-0.77000000f,-0.47000000f,0.59000000f,-0.99000000f,-0.88000000f,0.78000000f,0.43000000f,0.90000000f,0.08000000f,0.71000000f,-0.12000000f,0.91000000f,-0.82000000f,-0.86000000f,-0.61000000f,0.28000000f,0.35000000f,0.60000000f,0.55000000f,-0.60000000f,-0.67000000f,0.67000000f,0.99000000f,-0.30000000f,0.24000000f,0.47000000f,-0.17000000f,-0.82000000f,-0.22000000f,0.40000000f,0.01000000f,-0.75000000f,0.45000000f,0.38000000f,0.70000000f,-0.44000000f,0.96000000f,0.72000000f,0.12000000f,-0.58000000f,0.96000000f,-0.41000000f,-0.56000000f,-0.49000000f,-0.95000000f,-0.36000000f,0.62000000f,-0.10000000f,-0.65000000f,-0.51000000f,-0.13000000f,-0.44000000f,0.21000000f,0.75000000f,-0.82000000f,0.75000000f,-0.76000000f,0.20000000f,-0.63000000f,-0.95000000f,-0.10000000f,-0.30000000f,0.85000000f,0.59000000f,-0.76000000f,-0.36000000f,0.75000000f,-0.05000000f,-0.47000000f,-0.67000000f,-0.84000000f,-0.24000000f,-0.22000000f,0.24000000f,0.88000000f,-0.33000000f,-0.60000000f,-0.81000000f,-0.22000000f,-0.55000000f,-0.10000000f,0.84000000f,-0.52000000f,0.31000000f,0.31000000f,0.73000000f,-0.47000000f,0.08000000f,-0.78000000f,0.59000000f,0.27000000f,0.06000000f,0.74000000f,-0.58000000f,0.48000000f,-0.74000000f,-0.60000000f,-0.57000000f,0.16000000f,-0.91000000f,0.48000000f,-0.08000000f,0.42000000f,0.56000000f,-0.31000000f,-0.42000000f,-0.33000000f,0.88000000f,0.84000000f,0.72000000f,0.92000000f,0.36000000f,0.95000000f,-0.40000000f,0.77000000f,0.12000000f,-0.63000000f,-0.67000000f,-0.02000000f,-0.65000000f,0.53000000f,-0.98000000f,0.23000000f,-0.92000000f,-0.88000000f,-0.64000000f,0.84000000f,0.44000000f,-0.08000000f,-0.62000000f,-0.85000000f,-0.16000000f,0.61000000f,-0.11000000f,0.23000000f,0.01000000f,-0.37000000f,-0.36000000f,0.42000000f,-0.73000000f,0.43000000f,0.96000000f,-0.67000000f,0.41000000f,0.94000000f,-0.27000000f,0.04000000f,-0.46000000f,0.26000000f,0.01000000f,0.75000000f,-0.10000000f,-0.41000000f,-0.28000000f,0.57000000f,-0.55000000f,0.18000000f,-0.36000000f,-0.96000000f,-0.15000000f,-0.04000000f,0.80000000f,0.09000000f,-0.84000000f,0.06000000f,-0.63000000f,0.82000000f,0.47000000f,-0.17000000f,0.01000000f,-0.81000000f,0.44000000f,0.19000000f,-0.26000000f,0.88000000f,0.57000000f,-0.14000000f,-0.00000000f,0.34000000f,0.44000000f,-0.20000000f,-0.58000000f,-0.32000000f,0.17000000f,-0.98000000f,-0.29000000f,-0.08000000f,-0.53000000f,0.89000000f,-0.96000000f,-0.43000000f,0.87000000f,0.90000000f,0.25000000f,-0.00000000f,0.55000000f,0.73000000f,-0.28000000f,0.63000000f,-0.73000000f,0.61000000f,0.14000000f,0.51000000f,-0.15000000f,0.90000000f,0.15000000f,-0.24000000f,0.48000000f,-0.74000000f,0.54000000f,0.75000000f,-0.59000000f,-0.22000000f,0.54000000f,-0.99000000f,0.29000000f,0.47000000f,0.87000000f,-0.05000000f,0.65000000f,0.46000000f,0.76000000f,-0.89000000f,0.63000000f,0.65000000f,-0.28000000f,-0.63000000f,0.54000000f,0.37000000f,0.03000000f,0.05000000f,-0.16000000f,-0.38000000f,0.60000000f,0.70000000f,-0.74000000f,0.86000000f,-0.41000000f,0.22000000f,-0.45000000f,0.75000000f,-0.30000000f,0.32000000f,-0.03000000f,0.42000000f,0.48000000f,0.01000000f,-0.79000000f,-0.87000000f,-0.76000000f,-0.51000000f,-0.02000000f,0.00000000f,0.40000000f,0.35000000f,0.78000000f,-0.89000000f,-0.66000000f,-0.15000000f,-0.41000000f,-0.28000000f,0.41000000f,0.37000000f,0.47000000f,-0.56000000f,0.27000000f,0.58000000f,-0.44000000f,0.73000000f,-0.55000000f,-0.54000000f,0.87000000f,-0.67000000f,-0.62000000f,-0.95000000f,0.52000000f,-0.20000000f,0.81000000f,-0.34000000f,-0.48000000f,0.49000000f,-0.23000000f,0.62000000f,0.74000000f,-0.60000000f,-0.39000000f,-0.60000000f,0.34000000f,-0.81000000f,0.17000000f,0.63000000f,0.37000000f,0.11000000f,-0.74000000f,0.60000000f,-0.47000000f,-0.96000000f,-0.42000000f,-0.54000000f,0.20000000f,0.85000000f,0.13000000f,0.83000000f,0.17000000f,-0.56000000f,-0.25000000f,0.69000000f,-0.11000000f,0.11000000f,0.09000000f,-0.83000000f,-0.02000000f,-0.44000000f,-0.50000000f,-0.00000000f,-0.35000000f,0.25000000f,-0.41000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.74480001f,0.0f,0.0f,-3.46160002f,0.0f,0.0f,0.57800002f,0.0f,0.0f,2.40179996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,5.01200005f,0.0f,0.0f,-2.60720007f,0.0f,0.0f,2.10360008f,0.0f,0.0f,2.89149998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.61950009f,0.0f,0.0f,2.65469999f,0.0f,0.0f,-1.24570005f,0.0f,0.0f,-0.29900000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-4.87460007f,0.0f,0.0f,-2.41709998f,0.0f,0.0f,-2.67750005f,0.0f,0.0f,-0.27509989f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.00899997f,0.0f,0.0f,-1.42209991f,0.0f,0.0f,1.15910001f,0.0f,0.0f,-1.45970003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.74470002f,0.0f,0.0f,-1.14980000f,0.0f,0.0f,4.48340007f,0.0f,0.0f,3.95709998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.07550004f,0.0f,0.0f,1.43380008f,0.0f,0.0f,-0.83460010f,0.0f,0.0f,-1.83049998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.90720002f,0.0f,0.0f,0.34909994f,0.0f,0.0f,-0.41279993f,0.0f,0.0f,0.18740003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.15309993f,0.0f,0.0f,-0.35900007f,0.0f,0.0f,1.13290005f,0.0f,0.0f,-1.00789989f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.64930002f,0.0f,0.0f,0.01360006f,0.0f,0.0f,1.50950002f,0.0f,0.0f,0.77279997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,3.86279998f,0.0f,0.0f,-1.16960001f,0.0f,0.0f,-0.17030010f,0.0f,0.0f,2.15169997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.27430002f,0.0f,0.0f,-2.66479998f,0.0f,0.0f,1.16100004f,0.0f,0.0f,0.93779999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.09559994f,0.0f,0.0f,0.41139992f,0.0f,0.0f,1.25449994f,0.0f,0.0f,0.80870012f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.44679990f,0.0f,0.0f,0.18299998f,0.0f,0.0f,-1.87580004f,0.0f,0.0f,-1.72270001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.00619992f,0.0f,0.0f,-0.90169992f,0.0f,0.0f,0.27749999f,0.0f,0.0f,0.56109997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.04200005f,0.0f,0.0f,-2.42820006f,0.0f,0.0f,-2.69760015f,0.0f,0.0f,-2.84559989f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.33319997f,0.0f,0.0f,3.46300004f,0.0f,0.0f,0.52630002f,0.0f,0.0f,0.40109999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.02539996f,0.0f,0.0f,2.58930007f,0.0f,0.0f,2.36389996f,0.0f,0.0f,-1.48039994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.05269996f,0.0f,0.0f,1.44929989f,0.0f,0.0f,-0.32290000f,0.0f,0.0f,-1.44899999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-3.06600006f,0.0f,0.0f,-2.95550003f,0.0f,0.0f,1.14579990f,0.0f,0.0f,1.16029997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.61740002f,0.0f,0.0f,-0.26230001f,0.0f,0.0f,-0.14360009f,0.0f,0.0f,-3.25119999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.73210002f,0.0f,0.0f,0.35159989f,0.0f,0.0f,-0.34170009f,0.0f,0.0f,3.11259998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.02429984f,0.0f,0.0f,-1.33280000f,0.0f,0.0f,-0.78849992f,0.0f,0.0f,-2.08880005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.69209996f,0.0f,0.0f,-0.13609988f,0.0f,0.0f,-2.68980003f,0.0f,0.0f,1.98840011f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.15599996f,0.0f,0.0f,-2.18379999f,0.0f,0.0f,-1.36070010f,0.0f,0.0f,-3.19259999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,2.69010002f,0.0f,0.0f,-1.71760000f,0.0f,0.0f,-1.17410005f,0.0f,0.0f,-1.14889997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.85469999f,0.0f,0.0f,3.07979999f,0.0f,0.0f,-1.37000000f,0.0f,0.0f,-0.35720004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.56640007f,0.0f,0.0f,1.99269996f,0.0f,0.0f,-1.09749999f,0.0f,0.0f,1.01279992f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.62610016f,0.0f,0.0f,0.26299995f,0.0f,0.0f,-0.41990002f,0.0f,0.0f,2.34489996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.31199993f,0.0f,0.0f,-2.41130005f,0.0f,0.0f,1.22890003f,0.0f,0.0f,-2.34050005f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.22730007f,0.0f,0.0f,1.85010002f,0.0f,0.0f,-3.64409995f,0.0f,0.0f,-1.55839997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.53550008f,0.0f,0.0f,-3.78600002f,0.0f,0.0f,1.56670006f,0.0f,0.0f,-1.83770008f,0.0f,0.0f,0.0f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_4d_4items_strided_dilated_padded_same)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{4,3,8,8,8,8};
    Shape shape_b{4,3,2,2,3,1};
    Shape shape_r{4,4,4,7,4,5};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{3,2,2,3},        // move_strides
                                                                  Strides{2,1,3,2},        // filter_dilation
                                                                  CoordinateDiff{3,3,3,3}, // below_pads
                                                                  CoordinateDiff{3,3,3,3}, // above_pads
                                                                  Strides{1,1,1,1}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f,0.61000000f,0.17000000f,-0.91000000f,-0.48000000f,-0.48000000f,0.12000000f,-0.18000000f,0.08000000f,-0.16000000f,0.54000000f,-0.20000000f,-0.08000000f,0.19000000f,-0.81000000f,0.56000000f,-0.52000000f,0.32000000f,-0.37000000f,-0.17000000f,-0.46000000f,-0.34000000f,0.85000000f,0.11000000f,-0.10000000f,0.98000000f,-0.22000000f,0.68000000f,0.97000000f,-0.93000000f,-0.92000000f,0.32000000f,-0.19000000f,-0.61000000f,0.93000000f,0.54000000f,-0.75000000f,0.63000000f,0.38000000f,0.69000000f,-0.02000000f,0.19000000f,-0.38000000f,-0.44000000f,0.49000000f,-0.62000000f,-0.41000000f,-0.84000000f,0.93000000f,-0.74000000f,-0.57000000f,0.37000000f,-0.86000000f,-0.01000000f,0.58000000f,0.13000000f,-0.42000000f,0.68000000f,-0.05000000f,0.17000000f,0.09000000f,-0.67000000f,0.11000000f,-0.32000000f,0.08000000f,-0.29000000f,0.60000000f,0.69000000f,0.04000000f,0.85000000f,0.46000000f,0.41000000f,-0.78000000f,-0.98000000f,0.50000000f,-0.96000000f,-0.61000000f,-0.58000000f,0.00000000f,0.81000000f,-0.25000000f,-0.74000000f,-0.46000000f,-0.16000000f,0.32000000f,0.56000000f,-0.05000000f,-0.87000000f,0.59000000f,0.08000000f,-0.39000000f,0.67000000f,0.95000000f,0.70000000f,0.00000000f,-0.58000000f,0.85000000f,-0.14000000f,-0.27000000f,-0.63000000f,-0.75000000f,0.61000000f,-0.12000000f,-0.68000000f,-0.83000000f,0.12000000f,0.94000000f,-0.46000000f,0.27000000f,-0.14000000f,-0.96000000f,0.16000000f,-0.57000000f,0.92000000f,-0.24000000f,0.08000000f,0.60000000f,0.23000000f,-0.14000000f,-0.28000000f,0.14000000f,-0.19000000f,0.00000000f,-0.57000000f,0.18000000f,0.42000000f,0.17000000f,0.71000000f,-0.55000000f,0.89000000f,0.26000000f,-0.67000000f,0.68000000f,-0.75000000f,-0.62000000f,0.62000000f,-0.16000000f,-0.69000000f,-0.96000000f,-0.24000000f,0.00000000f,0.63000000f,-0.95000000f,-0.99000000f,0.06000000f,0.02000000f,-0.04000000f,0.95000000f,0.98000000f,0.13000000f,0.96000000f,-0.22000000f,-0.25000000f,-0.77000000f,-0.02000000f,-0.46000000f,0.28000000f,-0.61000000f,-0.56000000f,-0.65000000f,-0.23000000f,-0.41000000f,0.78000000f,-0.46000000f,0.44000000f,0.15000000f,0.46000000f,-0.90000000f,-0.25000000f,0.81000000f,0.28000000f,0.40000000f,0.56000000f,0.62000000f,-0.63000000f,-0.86000000f,-0.97000000f,0.22000000f,-0.58000000f,0.05000000f,0.53000000f,-0.38000000f,0.79000000f,0.60000000f,-0.63000000f,-0.18000000f,0.62000000f,-0.37000000f,0.48000000f,0.86000000f,0.70000000f,-0.52000000f,-0.39000000f,-0.44000000f,-0.69000000f,0.42000000f,-0.69000000f,0.48000000f,0.70000000f,-0.86000000f,-0.90000000f,0.69000000f,0.08000000f,-0.34000000f,-0.86000000f,0.66000000f,0.61000000f,0.47000000f,-0.22000000f,-0.51000000f,-0.29000000f,0.95000000f,-0.30000000f,-0.41000000f,0.85000000f,-0.13000000f,0.70000000f,-0.51000000f,-0.05000000f,-0.50000000f,-0.28000000f,-0.44000000f,0.33000000f,-0.08000000f,-0.88000000f,-0.64000000f,0.24000000f,-0.51000000f,0.67000000f,-0.40000000f,0.48000000f,0.92000000f,-0.64000000f,-0.42000000f,-0.62000000f,-0.77000000f,0.34000000f,0.29000000f,0.49000000f,0.82000000f,-0.30000000f,-0.40000000f,0.27000000f,0.61000000f,-0.75000000f,0.42000000f,0.69000000f,0.46000000f,0.41000000f,0.48000000f,0.14000000f,0.86000000f,-0.46000000f,-0.88000000f,-0.20000000f,-0.09000000f,-0.10000000f,0.70000000f,0.97000000f,-0.99000000f,0.53000000f,-0.51000000f,-0.70000000f,-0.96000000f,0.86000000f,-0.44000000f,-0.66000000f,-0.28000000f,0.08000000f,0.42000000f,-0.45000000f,-0.73000000f,-0.99000000f,-0.33000000f,0.40000000f,-0.86000000f,-0.84000000f,-0.06000000f,0.77000000f,0.96000000f,-0.06000000f,0.24000000f,0.21000000f,0.27000000f,-0.21000000f,-0.01000000f,0.16000000f,0.40000000f,0.06000000f,-0.61000000f,-0.66000000f,0.76000000f,0.43000000f,0.00000000f,0.37000000f,0.70000000f,-0.76000000f,0.50000000f,-0.38000000f,-0.24000000f,-0.80000000f,-0.66000000f,0.09000000f,-0.70000000f,0.83000000f,0.59000000f,-0.39000000f,-0.21000000f,0.84000000f,-0.17000000f,0.50000000f,-0.48000000f,-0.07000000f,-0.54000000f,-0.16000000f,0.99000000f,0.28000000f,0.29000000f,-0.68000000f,-0.49000000f,-0.18000000f,-0.41000000f,0.95000000f,0.72000000f,-0.26000000f,-0.42000000f,-0.27000000f,0.38000000f,-0.47000000f,0.24000000f,-0.38000000f,0.29000000f,0.34000000f,-0.30000000f,-0.64000000f,-0.27000000f,-0.27000000f,-0.94000000f,0.26000000f,0.52000000f,0.92000000f,0.53000000f,-0.80000000f,0.31000000f,0.29000000f,0.16000000f,-0.47000000f,0.61000000f,0.46000000f,-0.75000000f,-0.88000000f,0.95000000f,0.33000000f,-0.97000000f,-0.03000000f,0.43000000f,0.14000000f,0.73000000f,0.97000000f,-0.01000000f,0.45000000f,0.81000000f,0.77000000f,0.45000000f,0.16000000f,-0.66000000f,-0.29000000f,-0.23000000f,0.32000000f,0.22000000f,-0.09000000f,0.65000000f,-0.46000000f,0.65000000f,-0.01000000f,0.61000000f,-0.12000000f,0.36000000f,0.29000000f,-0.87000000f,-0.01000000f,-0.28000000f,-0.95000000f,0.37000000f,0.73000000f,-0.99000000f,0.47000000f,-0.69000000f,-0.31000000f,0.67000000f,-0.78000000f,-0.77000000f,-0.41000000f,0.95000000f,0.61000000f,0.52000000f,0.85000000f,-0.88000000f,0.97000000f,0.54000000f,0.53000000f,0.87000000f,-0.64000000f,-0.62000000f,0.70000000f,-0.11000000f,0.93000000f,-0.52000000f,-0.08000000f,0.03000000f,0.27000000f,-0.30000000f,-0.62000000f,0.00000000f,0.76000000f,0.12000000f,-0.83000000f,-0.60000000f,-0.95000000f,0.51000000f,0.85000000f,-0.27000000f,-0.83000000f,-0.20000000f,-0.45000000f,0.27000000f,-0.09000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.52000000f,-0.43000000f,-0.73000000f,-0.60000000f,-0.89000000f,0.15000000f,-0.12000000f,0.95000000f,0.97000000f,-0.43000000f,0.85000000f,0.43000000f,-0.35000000f,-0.44000000f,0.84000000f,0.94000000f,0.80000000f,-0.88000000f,-0.73000000f,-0.24000000f,0.93000000f,0.77000000f,0.15000000f,-0.63000000f,0.84000000f,0.70000000f,-0.24000000f,-0.01000000f,-0.63000000f,0.44000000f,0.50000000f,-0.29000000f,-0.27000000f,0.64000000f,0.28000000f,-0.18000000f,0.90000000f,-0.87000000f,-0.86000000f,-0.24000000f,0.66000000f,-0.49000000f,0.86000000f,0.19000000f,0.56000000f,-0.18000000f,-0.25000000f,-0.32000000f,-0.09000000f,0.83000000f,0.25000000f,0.92000000f,0.15000000f,0.71000000f,-0.91000000f,0.86000000f,-0.70000000f,0.05000000f,-0.23000000f,0.19000000f,0.32000000f,0.74000000f,-0.79000000f,-0.82000000f,0.44000000f,-0.91000000f,-0.61000000f,-0.99000000f,0.61000000f,-0.19000000f,0.14000000f,-0.46000000f,-0.33000000f,0.93000000f,0.29000000f,0.68000000f,-0.45000000f,0.47000000f,0.19000000f,-0.48000000f,0.03000000f,-0.10000000f,0.73000000f,-0.99000000f,0.72000000f,-0.58000000f,0.45000000f,-0.83000000f,0.07000000f,0.58000000f,0.02000000f,0.60000000f,0.71000000f,0.75000000f,-0.36000000f,0.19000000f,0.92000000f,-0.90000000f,-0.66000000f,0.57000000f,0.38000000f,0.86000000f,0.61000000f,0.31000000f,0.47000000f,-0.14000000f,-0.15000000f,0.27000000f,0.48000000f,0.44000000f,-0.45000000f,-0.83000000f,0.11000000f,0.96000000f,-0.38000000f,-0.12000000f,-0.72000000f,0.07000000f,-0.10000000f,-0.62000000f,0.21000000f,-0.33000000f,0.18000000f,0.18000000f,-0.50000000f,0.15000000f,0.38000000f,0.29000000f,-0.67000000f,-0.16000000f,-0.61000000f,0.36000000f,-0.50000000f,-0.87000000f,0.41000000f,0.41000000f,0.03000000f,0.71000000f,0.75000000f,-0.02000000f,0.13000000f,0.93000000f,0.51000000f,-0.86000000f,-0.43000000f,-0.97000000f,0.16000000f,-0.95000000f,-0.21000000f,-0.15000000f,-0.43000000f,0.53000000f,0.17000000f,0.18000000f,0.12000000f,-0.76000000f,0.56000000f,-0.71000000f,0.25000000f,-0.03000000f,-0.95000000f,0.65000000f,0.11000000f,0.29000000f,0.14000000f,0.04000000f,0.02000000f,-0.20000000f,-0.39000000f,0.23000000f,0.59000000f,0.07000000f,0.73000000f,-0.75000000f,0.67000000f,0.71000000f,-0.11000000f,-0.30000000f,0.26000000f,-0.93000000f,-0.01000000f,0.18000000f,-0.04000000f,-0.73000000f,-0.61000000f,-0.07000000f,0.00000000f,-0.68000000f,-0.58000000f,-0.95000000f,-0.51000000f,0.68000000f,-0.87000000f,0.07000000f,0.21000000f,0.87000000f,0.65000000f,-0.89000000f,0.57000000f,-0.48000000f,0.53000000f,-0.35000000f,-0.61000000f,-0.55000000f,0.62000000f,0.58000000f,-0.68000000f,-0.52000000f,0.33000000f,0.02000000f,0.74000000f,0.03000000f,0.44000000f,0.84000000f,-0.90000000f,-0.02000000f,-0.54000000f,0.55000000f,-0.24000000f,0.63000000f,0.31000000f,-0.67000000f,0.51000000f,0.67000000f,0.85000000f,0.68000000f,0.61000000f,0.04000000f,0.09000000f,0.70000000f,0.35000000f,-0.06000000f,-0.06000000f,-0.49000000f,0.81000000f,-0.24000000f,-0.70000000f,0.44000000f,0.18000000f,0.12000000f,0.17000000f,0.28000000f,0.26000000f,0.81000000f,-0.24000000f,-0.64000000f,0.32000000f,0.49000000f,-0.06000000f,0.13000000f,0.56000000f,-0.17000000f,-0.28000000f,-0.50000000f,0.89000000f,-0.20000000f,-0.34000000f,0.05000000f,0.71000000f,-0.09000000f,0.02000000f,-0.43000000f,-0.00000000f,-0.07000000f,0.25000000f,0.80000000f,0.18000000f,-0.37000000f,-0.16000000f,-0.42000000f,0.33000000f,0.76000000f,-0.81000000f,0.79000000f,0.88000000f,-0.62000000f,-0.49000000f,-0.79000000f,0.16000000f,0.19000000f,0.37000000f,-0.62000000f,-0.72000000f,-0.37000000f,0.39000000f,-0.84000000f,-0.13000000f,0.21000000f,0.88000000f,-0.80000000f,-0.06000000f,0.28000000f,-0.13000000f,-0.83000000f,-0.91000000f,-0.39000000f,0.19000000f,-0.71000000f,-0.08000000f,0.96000000f,0.89000000f,-0.60000000f,-0.79000000f,-0.13000000f,-0.00000000f,0.03000000f,0.97000000f,0.70000000f,-0.96000000f,-0.50000000f,-0.39000000f,0.13000000f,0.09000000f,0.29000000f,-0.43000000f,-0.40000000f,-0.83000000f,0.51000000f,-0.32000000f,-0.53000000f,0.07000000f,0.35000000f,0.43000000f,-0.65000000f,-0.94000000f,0.40000000f,-0.59000000f,0.80000000f,-0.15000000f,-0.22000000f,0.56000000f,0.90000000f,-0.82000000f,-0.74000000f,0.04000000f,-0.24000000f,-0.97000000f,0.96000000f,0.78000000f,0.29000000f,-0.44000000f,0.62000000f,0.92000000f,0.05000000f,-0.74000000f,-0.49000000f,-0.25000000f,0.34000000f,-0.99000000f,0.78000000f,-0.64000000f,0.09000000f,-0.51000000f,0.99000000f,-0.20000000f,0.95000000f,0.13000000f,-0.44000000f,-0.90000000f,-0.82000000f,0.84000000f,0.26000000f,-0.90000000f,0.97000000f,-0.09000000f,0.45000000f,-0.49000000f,0.29000000f,0.13000000f,0.37000000f,-0.03000000f,0.41000000f,-0.47000000f,0.25000000f,0.44000000f,0.31000000f,0.72000000f,0.09000000f,0.67000000f,0.76000000f,-0.79000000f,-0.99000000f,0.62000000f,-0.71000000f,-0.07000000f,0.63000000f,-0.02000000f,-0.28000000f,-0.02000000f,0.98000000f,0.28000000f,0.48000000f,-0.49000000f,0.32000000f,-0.11000000f,-0.45000000f,0.37000000f,-0.58000000f,-0.82000000f,-0.23000000f,-0.55000000f,-0.61000000f,-0.87000000f,-0.96000000f,-0.34000000f,-0.03000000f,-0.15000000f,-0.15000000f,-0.30000000f,-0.53000000f,0.83000000f,0.20000000f,-0.19000000f,-0.19000000f,0.23000000f,0.45000000f,0.50000000f,-0.67000000f,0.71000000f,-0.97000000f,0.42000000f,-0.33000000f,-0.88000000f,0.56000000f,0.78000000f,-0.09000000f,0.17000000f,0.77000000f,0.95000000f,-0.80000000f,-0.72000000f,0.23000000f,0.39000000f,-0.72000000f,-0.15000000f,-0.79000000f,-0.97000000f,0.97000000f,-0.20000000f,-0.56000000f,-0.95000000f,-0.65000000f,0.71000000f,-0.42000000f,0.10000000f,-0.58000000f,-0.14000000f,0.39000000f,-0.95000000f,-0.71000000f,-0.67000000f,0.62000000f,-0.10000000f,-0.11000000f,-0.76000000f,-0.30000000f,-0.62000000f,0.63000000f,-0.11000000f,-0.48000000f,0.37000000f,-0.08000000f,0.73000000f,-0.84000000f,-0.07000000f,-0.82000000f,-0.93000000f,0.63000000f,0.17000000f,-0.58000000f,-0.17000000f,0.83000000f,0.78000000f,-0.49000000f,-0.41000000f,0.29000000f,-0.90000000f,0.78000000f,-0.97000000f,-0.67000000f,0.47000000f,0.64000000f,-0.57000000f,0.89000000f,0.29000000f,-0.24000000f,0.75000000f,0.61000000f,0.45000000f,0.42000000f,0.16000000f,-0.75000000f,0.31000000f,0.66000000f,-0.04000000f,0.11000000f,-0.22000000f,-0.63000000f,-0.81000000f,0.48000000f,0.40000000f,-0.43000000f,0.37000000f,0.58000000f,0.18000000f,0.27000000f,-0.84000000f,0.31000000f,0.67000000f,-0.23000000f,0.74000000f,0.87000000f,-0.60000000f,-0.90000000f,-0.43000000f,0.07000000f,-0.58000000f,-0.01000000f,0.06000000f,-0.57000000f,-0.48000000f,-0.80000000f,0.30000000f,-0.69000000f,-0.37000000f,0.45000000f,0.85000000f,-0.17000000f,0.84000000f,-0.86000000f,0.36000000f,0.30000000f,0.49000000f,0.19000000f,-0.40000000f,-0.68000000f,-0.49000000f,0.61000000f,-0.07000000f,0.25000000f,-0.84000000f,0.42000000f,-0.23000000f,-0.28000000f,0.86000000f,-0.37000000f,0.13000000f,-0.29000000f,-0.93000000f,-0.28000000f,0.23000000f,0.25000000f,0.86000000f,0.33000000f,0.75000000f,0.75000000f,-0.61000000f,0.43000000f,0.09000000f,0.24000000f,-0.80000000f,-0.34000000f,-0.64000000f,0.25000000f,-0.07000000f,0.78000000f,0.29000000f,0.12000000f,0.28000000f,-0.72000000f,-0.72000000f,-0.70000000f,0.23000000f,-0.30000000f,-0.07000000f,-0.94000000f,0.97000000f,0.08000000f,-0.97000000f,0.20000000f,0.70000000f,0.38000000f,0.92000000f,-0.91000000f,-0.93000000f,-0.13000000f,0.05000000f,-0.56000000f,0.15000000f,-0.45000000f,-0.39000000f,-0.53000000f,0.25000000f,0.74000000f,0.85000000f,0.91000000f,0.25000000f,0.75000000f,0.32000000f,0.86000000f,0.99000000f,0.84000000f,0.17000000f,0.38000000f,0.16000000f,0.26000000f,0.37000000f,0.41000000f,-0.36000000f,-0.00000000f,-0.09000000f,0.70000000f,-0.40000000f,0.15000000f,0.76000000f,-0.17000000f,0.40000000f,-0.06000000f,0.14000000f,0.50000000f,-0.91000000f,0.44000000f,0.06000000f,0.30000000f,0.86000000f,0.45000000f,-0.88000000f,-0.06000000f,0.92000000f,-0.39000000f,0.83000000f,0.04000000f,-0.04000000f,0.70000000f,0.99000000f,-0.96000000f,0.02000000f,-0.45000000f,0.47000000f,0.71000000f,-0.50000000f,0.08000000f,0.98000000f,0.30000000f,-0.60000000f,-0.66000000f,0.66000000f,-0.51000000f,-0.86000000f,0.54000000f,0.51000000f,-0.36000000f,-0.48000000f,0.59000000f,-0.93000000f,0.64000000f,0.49000000f,0.23000000f,-0.72000000f,0.82000000f,-0.81000000f,-0.51000000f,-0.06000000f,0.58000000f,0.45000000f,-0.41000000f,-0.60000000f,-0.08000000f,-0.07000000f,0.47000000f,-0.48000000f,0.85000000f,-0.36000000f,-0.92000000f,0.48000000f,-0.36000000f,-0.09000000f,0.09000000f,-0.57000000f,-0.98000000f,0.67000000f,-0.53000000f,0.50000000f,-0.12000000f,-0.62000000f,-0.85000000f,0.37000000f,-0.98000000f,0.56000000f,0.65000000f,0.51000000f,0.54000000f,0.73000000f,-0.89000000f,0.07000000f,0.52000000f,0.92000000f,-0.26000000f,-0.93000000f,-0.82000000f,0.75000000f,0.96000000f,0.26000000f,-0.21000000f,-0.40000000f,-0.88000000f,-0.38000000f,-0.21000000f,-0.43000000f,-0.77000000f,0.48000000f,-0.95000000f,0.40000000f,0.43000000f,-0.24000000f,-0.72000000f,0.49000000f,-0.78000000f,0.82000000f,-0.21000000f,-0.15000000f,-0.56000000f,-0.94000000f,-0.51000000f,-0.10000000f,0.36000000f,0.68000000f,-0.78000000f,0.09000000f,-0.15000000f,-0.55000000f,0.21000000f,-0.11000000f,0.53000000f,-0.23000000f,-0.85000000f,-0.50000000f,0.66000000f,0.44000000f,0.47000000f,0.61000000f,0.22000000f,0.79000000f,0.71000000f,-0.91000000f,0.70000000f,-0.12000000f,-0.78000000f,0.45000000f,-0.40000000f,0.82000000f,0.27000000f,0.39000000f,0.87000000f,-0.23000000f,-0.37000000f,-0.78000000f,-0.19000000f,0.45000000f,0.29000000f,-0.45000000f,-0.30000000f,0.17000000f,-0.70000000f,0.09000000f,-0.85000000f,-0.67000000f,0.41000000f,0.37000000f,-0.12000000f,0.83000000f,0.92000000f,0.70000000f,-0.23000000f,0.62000000f,0.84000000f,0.13000000f,-0.36000000f,0.75000000f,-0.47000000f,-0.93000000f,0.00000000f,-0.71000000f,0.22000000f,-0.13000000f,-0.19000000f,-0.03000000f,-0.94000000f,-0.56000000f,-0.88000000f,-0.27000000f,-0.48000000f,0.98000000f,0.73000000f,0.87000000f,0.10000000f,0.04000000f,0.34000000f,0.51000000f,-0.95000000f,0.84000000f,0.17000000f,0.13000000f,-0.39000000f,0.37000000f,0.89000000f,-0.04000000f,-0.53000000f,-0.38000000f,0.00000000f,-0.00000000f,0.72000000f,0.08000000f,0.32000000f,0.69000000f,0.80000000f,0.00000000f,-0.12000000f,-0.79000000f,-0.75000000f,0.04000000f,-0.45000000f,0.08000000f,-0.96000000f,-0.95000000f,-0.44000000f,0.98000000f,0.10000000f,-0.28000000f,0.99000000f,-0.07000000f,0.53000000f,-0.86000000f,-0.01000000f,0.29000000f,-0.78000000f,-0.01000000f,0.22000000f,0.18000000f,-0.24000000f,-0.89000000f,0.12000000f,-0.67000000f,0.06000000f,-0.02000000f,-0.41000000f,-0.00000000f,0.91000000f,0.40000000f,-0.20000000f,0.25000000f,-0.08000000f,0.04000000f,0.42000000f,0.40000000f,0.39000000f,-0.22000000f,-0.23000000f,0.28000000f,0.48000000f,-0.72000000f,-0.85000000f,-0.22000000f,0.69000000f,-0.25000000f,-0.85000000f,-0.56000000f,0.80000000f,-0.91000000f,0.69000000f,-0.69000000f,0.86000000f,0.94000000f,0.87000000f,-0.47000000f,0.30000000f,-0.51000000f,-0.52000000f,0.74000000f,-0.43000000f,0.03000000f,-0.79000000f,0.76000000f,0.39000000f,0.00000000f,0.32000000f,-0.43000000f,-0.43000000f,-0.27000000f,0.08000000f,-0.20000000f,0.18000000f,0.01000000f,-0.12000000f,-0.22000000f,-0.64000000f,-0.56000000f,0.72000000f,-0.10000000f,-0.52000000f,-0.23000000f,0.93000000f,0.39000000f,0.14000000f,0.23000000f,0.81000000f,-0.37000000f,0.52000000f,-0.10000000f,-0.16000000f,-0.90000000f,0.35000000f,0.18000000f,-0.89000000f,0.72000000f,0.91000000f,-0.03000000f,-0.67000000f,0.43000000f,0.97000000f,-0.32000000f,-0.40000000f,0.85000000f,-0.25000000f,0.71000000f,-0.60000000f,0.71000000f,0.84000000f,0.20000000f,-0.97000000f,-0.66000000f,0.18000000f,0.71000000f,-0.29000000f,-0.73000000f,0.62000000f,0.76000000f,-0.12000000f,-0.80000000f,0.61000000f,0.38000000f,0.74000000f,0.44000000f,0.60000000f,0.23000000f,0.11000000f,-0.06000000f,-0.09000000f,-0.33000000f,-0.38000000f,0.17000000f,0.57000000f,0.91000000f,0.83000000f,0.89000000f,0.88000000f,0.83000000f,0.71000000f,0.97000000f,0.93000000f,0.23000000f,-0.36000000f,-0.21000000f,-0.77000000f,0.14000000f,0.52000000f,-0.48000000f,-0.21000000f,-0.86000000f,-0.39000000f,0.68000000f,0.46000000f,0.48000000f,0.09000000f,-0.10000000f,0.83000000f,0.63000000f,0.53000000f,0.40000000f,0.05000000f,-0.92000000f,0.61000000f,0.23000000f,0.23000000f,-0.49000000f,-0.12000000f,-0.88000000f,-0.03000000f,0.50000000f,-0.27000000f,0.44000000f,-0.59000000f,-0.50000000f,0.93000000f,-0.52000000f,-0.06000000f,-0.02000000f,0.57000000f,0.75000000f,0.56000000f,0.34000000f,-0.71000000f,-0.04000000f,-0.25000000f,0.81000000f,0.77000000f,-0.40000000f,0.69000000f,0.26000000f,0.86000000f,0.32000000f,0.69000000f,-0.64000000f,-0.75000000f,0.73000000f,-0.40000000f,-0.57000000f,0.95000000f,0.03000000f,-0.51000000f,0.15000000f,-0.25000000f,0.87000000f,0.23000000f,-0.61000000f,-0.37000000f,-0.44000000f,-0.04000000f,-0.84000000f,-0.07000000f,0.27000000f,-0.33000000f,0.68000000f,-0.59000000f,0.32000000f,0.06000000f,-0.80000000f,-0.47000000f,0.09000000f,-0.61000000f,-0.85000000f,-0.77000000f,0.78000000f,0.86000000f,-0.75000000f,-0.45000000f,-0.10000000f,-0.68000000f,-0.30000000f,-0.40000000f,0.83000000f,0.62000000f,0.97000000f,-0.71000000f,0.50000000f,-0.15000000f,-0.06000000f,0.99000000f,0.68000000f,-0.45000000f,0.81000000f,-0.82000000f,0.87000000f,-0.65000000f,-0.68000000f,-0.97000000f,0.68000000f,0.64000000f,0.19000000f,0.23000000f,0.51000000f,-0.96000000f,0.16000000f,0.05000000f,0.82000000f,-0.70000000f,0.08000000f,-0.13000000f,0.80000000f,0.87000000f,0.47000000f,0.27000000f,0.38000000f,0.27000000f,-0.61000000f,-0.63000000f,0.60000000f,0.91000000f,-0.03000000f,-0.65000000f,-0.26000000f,-0.59000000f,-0.08000000f,-0.00000000f,0.55000000f,-0.30000000f,0.28000000f,-0.81000000f,0.32000000f,-0.92000000f,-0.34000000f,0.55000000f,0.25000000f,-0.46000000f,0.93000000f,0.34000000f,0.69000000f,-0.59000000f,0.79000000f,0.95000000f,0.97000000f,0.91000000f,-0.53000000f,0.89000000f,0.29000000f,-0.23000000f,-0.49000000f,0.14000000f,-0.53000000f,0.22000000f,0.87000000f,0.10000000f,0.42000000f,0.31000000f,0.98000000f,-0.18000000f,-0.89000000f,-0.98000000f,-0.20000000f,0.31000000f,-0.54000000f,0.32000000f,-0.14000000f,0.16000000f,-0.24000000f,-0.77000000f,0.15000000f,0.76000000f,0.80000000f,0.70000000f,0.93000000f,-0.55000000f,0.25000000f,0.39000000f,0.16000000f,-0.80000000f,-0.64000000f,-0.51000000f,-0.48000000f,0.75000000f,0.50000000f,0.19000000f,-0.42000000f,-0.42000000f,0.75000000f,0.06000000f,0.61000000f,-0.75000000f,0.65000000f,0.27000000f,-0.72000000f,-0.20000000f,0.81000000f,0.30000000f,-0.34000000f,-0.38000000f,-0.56000000f,-0.15000000f,-0.37000000f,0.38000000f,0.83000000f,-0.76000000f,-0.00000000f,-0.95000000f,0.99000000f,-0.51000000f,-0.06000000f,-0.47000000f,0.92000000f,0.03000000f,0.52000000f,-0.67000000f,0.73000000f,0.59000000f,-0.32000000f,-0.97000000f,0.41000000f,-0.37000000f,0.25000000f,0.77000000f,-0.40000000f,-0.01000000f,-0.95000000f,0.77000000f,-0.31000000f,-0.99000000f,-0.23000000f,-0.38000000f,-0.77000000f,-0.15000000f,-0.75000000f,-0.79000000f,0.85000000f,-0.56000000f,-0.80000000f,0.15000000f,0.75000000f,0.69000000f,-0.70000000f,-0.72000000f,-0.83000000f,0.16000000f,0.83000000f,0.95000000f,-0.33000000f,-0.16000000f,-0.56000000f,-0.36000000f,-0.94000000f,0.37000000f,0.51000000f,-0.95000000f,0.92000000f,-0.86000000f,0.88000000f,-0.63000000f,0.77000000f,0.12000000f,0.54000000f,0.99000000f,0.08000000f,0.38000000f,-0.42000000f,0.86000000f,-0.13000000f,0.45000000f,0.75000000f,0.10000000f,0.56000000f,0.78000000f,0.06000000f,-0.93000000f,0.77000000f,-0.47000000f,0.86000000f,-0.34000000f,-0.34000000f,0.61000000f,0.12000000f,-0.56000000f,0.64000000f,0.58000000f,-0.56000000f,0.32000000f,0.01000000f,-0.35000000f,0.10000000f,0.59000000f,-0.40000000f,0.19000000f,-0.02000000f,-0.53000000f,0.87000000f,-0.31000000f,-0.39000000f,0.80000000f,-0.53000000f,0.84000000f,0.69000000f,0.34000000f,0.46000000f,0.61000000f,-0.38000000f,0.85000000f,-0.38000000f,-0.90000000f,-0.57000000f,0.74000000f,0.21000000f,0.13000000f,-0.87000000f,-0.57000000f,-0.81000000f,-0.75000000f,-0.14000000f,0.99000000f,-0.49000000f,-0.65000000f,0.61000000f,-0.58000000f,-0.04000000f,-0.63000000f,-0.96000000f,-0.75000000f,-0.67000000f,-0.72000000f,-0.33000000f,0.50000000f,-0.01000000f,0.64000000f,0.97000000f,-0.08000000f,-0.34000000f,-0.84000000f,0.38000000f,-0.16000000f,0.42000000f,0.96000000f,0.80000000f,-0.53000000f,0.53000000f,0.51000000f,0.77000000f,-0.04000000f,-0.06000000f,0.65000000f,0.72000000f,0.82000000f,0.77000000f,-0.53000000f,-0.66000000f,-0.43000000f,0.95000000f,0.20000000f,0.14000000f,-0.27000000f,-0.13000000f,0.39000000f,-0.77000000f,0.07000000f,-0.14000000f,0.93000000f,0.69000000f,-0.03000000f,0.89000000f,0.51000000f,-0.40000000f,-0.68000000f,0.42000000f,-0.46000000f,-0.50000000f,0.15000000f,-0.81000000f,0.32000000f,-0.10000000f,0.26000000f,-0.10000000f,0.35000000f,-0.33000000f,0.70000000f,-0.35000000f,0.79000000f,0.97000000f,0.01000000f,-0.77000000f,-0.44000000f,-0.24000000f,-0.93000000f,0.21000000f,-0.74000000f,-0.64000000f,-0.25000000f,-0.90000000f,-0.26000000f,0.64000000f,-0.33000000f,0.82000000f,-0.12000000f,0.56000000f,-0.18000000f,-0.78000000f,-0.82000000f,-0.21000000f,-0.84000000f,-0.81000000f,-0.26000000f,0.20000000f,0.74000000f,-0.56000000f,0.86000000f,-0.17000000f,-0.36000000f,-0.02000000f,-0.16000000f,0.21000000f,0.61000000f,0.65000000f,-0.48000000f,0.04000000f,-0.38000000f,0.32000000f,-0.72000000f,0.22000000f,-0.16000000f,0.44000000f,0.25000000f,-0.51000000f,-0.64000000f,0.43000000f,0.72000000f,-0.88000000f,0.97000000f,-0.27000000f,0.40000000f,0.36000000f,0.49000000f,0.38000000f,-0.53000000f,-0.08000000f,-0.06000000f,0.69000000f,-0.27000000f,0.05000000f,0.72000000f,-0.48000000f,0.74000000f,0.80000000f,0.23000000f,0.00000000f,-0.49000000f,-0.85000000f,-0.30000000f,-0.43000000f,0.14000000f,-0.06000000f,0.03000000f,-0.83000000f,0.91000000f,-0.72000000f,0.27000000f,0.42000000f,-0.63000000f,-0.54000000f,0.92000000f,-0.87000000f,-0.49000000f,0.40000000f,0.60000000f,-0.24000000f,0.66000000f,-0.65000000f,-0.67000000f,0.15000000f,0.70000000f,0.89000000f,-0.13000000f,0.81000000f,-0.52000000f,-0.82000000f,-0.58000000f,-0.20000000f,0.08000000f,-0.51000000f,0.18000000f,0.99000000f,-0.80000000f,0.22000000f,-0.17000000f,-0.72000000f,-0.72000000f,0.39000000f,0.81000000f,-0.36000000f,0.92000000f,-0.63000000f,0.36000000f,0.21000000f,0.00000000f,-0.27000000f,-0.72000000f,-0.47000000f,-0.69000000f,0.93000000f,-0.60000000f,0.98000000f,-0.28000000f,-0.69000000f,0.24000000f,-0.32000000f,-0.13000000f,-0.37000000f,0.66000000f,-0.68000000f,0.82000000f,0.23000000f,-0.45000000f,0.19000000f,-0.02000000f,0.90000000f,-0.77000000f,-0.87000000f,0.94000000f,-0.53000000f,0.95000000f,0.90000000f,0.17000000f,0.80000000f,-0.86000000f,0.67000000f,0.58000000f,-0.27000000f,-0.87000000f,-0.15000000f,0.99000000f,-0.65000000f,0.08000000f,0.34000000f,-0.46000000f,-0.94000000f,0.78000000f,0.10000000f,-0.95000000f,0.54000000f,0.46000000f,0.89000000f,0.01000000f,-0.33000000f,0.43000000f,-0.19000000f,-0.87000000f,0.36000000f,0.84000000f,0.70000000f,-0.93000000f,-0.95000000f,0.86000000f,-0.33000000f,-0.60000000f,0.31000000f,0.70000000f,-0.39000000f,0.01000000f,-0.43000000f,-0.11000000f,-0.42000000f,-0.76000000f,0.72000000f,0.33000000f,0.40000000f,0.43000000f,-0.19000000f,-0.49000000f,0.24000000f,-0.45000000f,-0.02000000f,-0.12000000f,-0.50000000f,-0.74000000f,-0.53000000f,0.09000000f,0.39000000f,0.53000000f,0.02000000f,0.14000000f,0.40000000f,-0.81000000f,-0.28000000f,-0.32000000f,-0.00000000f,0.51000000f,0.54000000f,-0.12000000f,-0.30000000f,0.97000000f,-0.04000000f,-0.42000000f,-0.96000000f,-0.39000000f,0.81000000f,0.93000000f,-0.55000000f,0.46000000f,-0.79000000f,-0.99000000f,-0.53000000f,0.00000000f,-0.28000000f,0.08000000f,0.22000000f,0.34000000f,0.03000000f,-0.89000000f,0.36000000f,0.80000000f,-0.68000000f,0.50000000f,-0.08000000f,0.04000000f,0.98000000f,-0.36000000f,-0.97000000f,0.46000000f,-0.02000000f,-0.20000000f,0.66000000f,-0.67000000f,0.58000000f,0.46000000f,-0.14000000f,-0.74000000f,-0.68000000f,-0.22000000f,0.93000000f,-0.86000000f,-0.58000000f,0.66000000f,-0.03000000f,0.40000000f,0.60000000f,-0.65000000f,0.20000000f,0.96000000f,-0.04000000f,0.91000000f,0.95000000f,-0.19000000f,0.04000000f,0.89000000f,0.70000000f,-0.99000000f,0.27000000f,-0.55000000f,0.79000000f,0.99000000f,0.94000000f,-0.16000000f,0.16000000f,0.74000000f,-0.84000000f,-0.91000000f,-0.15000000f,0.70000000f,0.95000000f,-0.19000000f,-0.72000000f,0.23000000f,0.98000000f,-0.77000000f,-0.58000000f,-0.97000000f,0.20000000f,-0.89000000f,0.94000000f,-0.96000000f,0.78000000f,0.17000000f,0.51000000f,0.91000000f,-0.58000000f,-0.90000000f,-0.48000000f,0.03000000f,0.06000000f,-0.58000000f,0.67000000f,0.70000000f,-0.68000000f,0.13000000f,-0.02000000f,0.04000000f,-0.33000000f,0.64000000f,-0.72000000f,0.01000000f,0.71000000f,0.37000000f,0.31000000f,-0.39000000f,0.91000000f,0.19000000f,-0.34000000f,0.45000000f,-0.68000000f,-0.26000000f,-0.78000000f,-0.74000000f,0.43000000f,-0.05000000f,-0.29000000f,-0.98000000f,-0.07000000f,0.61000000f,-0.93000000f,0.05000000f,-0.44000000f,0.44000000f,0.89000000f,-0.08000000f,0.19000000f,0.95000000f,0.90000000f,0.63000000f,0.25000000f,0.09000000f,0.90000000f,-0.66000000f,0.62000000f,0.72000000f,-0.28000000f,0.76000000f,-0.90000000f,0.37000000f,-0.25000000f,0.60000000f,0.92000000f,-0.75000000f,0.86000000f,-0.79000000f,0.17000000f,-0.11000000f,-0.21000000f,-0.99000000f,-0.41000000f,0.18000000f,-0.59000000f,-0.04000000f,0.92000000f,-0.20000000f,-0.82000000f,0.70000000f,0.18000000f,-0.08000000f,0.04000000f,0.84000000f,-0.48000000f,-0.46000000f,-0.94000000f,-0.55000000f,0.64000000f,0.10000000f,-0.74000000f,-0.66000000f,-0.16000000f,0.52000000f,0.33000000f,-0.41000000f,0.24000000f,0.94000000f,0.22000000f,-0.04000000f,-0.90000000f,0.91000000f,0.13000000f,0.46000000f,0.18000000f,-0.33000000f,-0.48000000f,-0.92000000f,-0.54000000f,-0.90000000f,-0.20000000f,0.58000000f,-0.45000000f,-0.52000000f,-0.50000000f,-0.42000000f,-0.18000000f,-0.49000000f,-0.71000000f,0.61000000f,-0.32000000f,0.82000000f,-0.17000000f,-0.82000000f,0.37000000f,-0.73000000f,-0.22000000f,0.97000000f,0.79000000f,0.43000000f,0.75000000f,0.82000000f,-0.88000000f,0.15000000f,0.04000000f,0.50000000f,-0.21000000f,-0.38000000f,0.63000000f,-0.45000000f,-0.39000000f,0.34000000f,0.20000000f,-0.46000000f,-0.24000000f,-0.44000000f,-0.82000000f,0.63000000f,-0.36000000f,-0.03000000f,-0.20000000f,-0.31000000f,-0.51000000f,-0.44000000f,0.03000000f,-0.28000000f,0.86000000f,-0.98000000f,0.67000000f,-0.01000000f,0.37000000f,-0.58000000f,0.83000000f,-0.71000000f,0.88000000f,0.94000000f,-0.97000000f,-0.02000000f,0.53000000f,-0.47000000f,0.43000000f,0.45000000f,0.66000000f,-0.41000000f,0.01000000f,0.66000000f,-0.73000000f,0.98000000f,-0.51000000f,-0.25000000f,0.10000000f,0.86000000f,-0.61000000f,-0.38000000f,0.24000000f,-0.37000000f,-0.76000000f,0.10000000f,0.41000000f,-0.40000000f,0.45000000f,-0.94000000f,0.06000000f,-0.34000000f,-0.77000000f,-0.49000000f,0.10000000f,0.60000000f,0.59000000f,-0.18000000f,-0.29000000f,0.16000000f,0.66000000f,-0.79000000f,0.31000000f,-0.15000000f,-0.36000000f,0.28000000f,-0.83000000f,-0.40000000f,0.79000000f,-0.79000000f,0.01000000f,-0.10000000f,-0.89000000f,0.89000000f,-0.73000000f,-0.94000000f,-0.25000000f,0.90000000f,0.02000000f,0.87000000f,-0.72000000f,0.14000000f,0.01000000f,0.14000000f,0.33000000f,0.70000000f,-0.23000000f,0.31000000f,0.47000000f,-0.99000000f,0.74000000f,-0.94000000f,-0.18000000f,0.29000000f,0.74000000f,0.41000000f,-0.62000000f,-0.55000000f,-0.23000000f,-0.92000000f,-0.83000000f,-0.04000000f,0.62000000f,-0.21000000f,0.18000000f,0.54000000f,0.10000000f,0.01000000f,-0.56000000f,0.20000000f,-0.27000000f,0.95000000f,-0.72000000f,-0.81000000f,-0.37000000f,0.04000000f,0.35000000f,-0.43000000f,0.74000000f,0.96000000f,-0.39000000f,-0.25000000f,0.84000000f,-0.96000000f,0.63000000f,-0.21000000f,0.38000000f,0.08000000f,-0.30000000f,-0.96000000f,0.62000000f,0.52000000f,0.88000000f,0.24000000f,0.20000000f,-0.98000000f,-0.19000000f,0.73000000f,-0.92000000f,-0.26000000f,0.98000000f,0.23000000f,0.02000000f,-0.56000000f,-0.67000000f,0.84000000f,0.80000000f,-0.99000000f,0.90000000f,0.08000000f,0.54000000f,-0.42000000f,0.12000000f,0.61000000f,-0.37000000f,-0.33000000f,0.96000000f,0.77000000f,-0.97000000f,0.69000000f,-0.03000000f,0.32000000f,-0.05000000f,0.38000000f,-0.13000000f,-0.67000000f,-0.29000000f,0.78000000f,0.49000000f,0.06000000f,-0.80000000f,-0.11000000f,0.67000000f,0.22000000f,-0.76000000f,-0.30000000f,-0.78000000f,0.35000000f,0.64000000f,-0.14000000f,-0.56000000f,0.01000000f,-0.67000000f,-0.73000000f,-0.00000000f,0.49000000f,0.49000000f,-0.48000000f,-0.61000000f,0.93000000f,-0.05000000f,0.14000000f,0.47000000f,-0.07000000f,0.83000000f,0.97000000f,0.07000000f,-0.41000000f,-0.19000000f,0.17000000f,0.62000000f,0.58000000f,-0.37000000f,0.48000000f,-0.62000000f,-0.36000000f,0.94000000f,0.07000000f,-0.83000000f,0.49000000f,-0.81000000f,-0.77000000f,-0.21000000f,0.15000000f,-0.48000000f,-0.65000000f,0.88000000f,0.58000000f,0.74000000f,-0.88000000f,-0.78000000f,0.70000000f,-0.18000000f,0.37000000f,-0.84000000f,-0.49000000f,-0.39000000f,0.98000000f,0.06000000f,0.25000000f,0.97000000f,0.39000000f,0.38000000f,-0.67000000f,-0.52000000f,0.65000000f,-0.66000000f,-0.53000000f,0.38000000f,-0.30000000f,-0.51000000f,0.07000000f,-0.07000000f,0.01000000f,0.73000000f,0.38000000f,0.47000000f,-0.56000000f,0.44000000f,0.78000000f,-0.98000000f,-0.99000000f,-0.31000000f,-0.72000000f,0.91000000f,0.18000000f,-0.84000000f,-0.40000000f,-0.53000000f,0.33000000f,0.13000000f,0.37000000f,0.01000000f,0.81000000f,0.00000000f,-0.19000000f,-0.02000000f,-0.73000000f,0.65000000f,0.84000000f,-0.01000000f,0.16000000f,-0.07000000f,0.64000000f,0.22000000f,0.06000000f,0.49000000f,-0.28000000f,-0.84000000f,0.81000000f,-0.94000000f,0.32000000f,-0.07000000f,0.09000000f,0.95000000f,0.99000000f,-0.56000000f,0.64000000f,0.83000000f,0.51000000f,-0.93000000f,0.18000000f,-0.50000000f,0.38000000f,-0.07000000f,0.93000000f,0.63000000f,-0.29000000f,0.87000000f,-0.04000000f,0.63000000f,0.70000000f,-0.76000000f,0.02000000f,0.02000000f,-0.88000000f,-0.63000000f,-0.18000000f,-0.30000000f,-0.48000000f,-0.42000000f,0.93000000f,0.01000000f,0.36000000f,0.97000000f,-0.25000000f,0.93000000f,0.16000000f,0.46000000f,-0.31000000f,-0.32000000f,0.20000000f,0.43000000f,-0.93000000f,0.09000000f,0.97000000f,0.53000000f,-0.86000000f,-0.33000000f,0.77000000f,0.58000000f,-0.11000000f,0.55000000f,0.94000000f,-0.42000000f,-0.48000000f,0.05000000f,0.15000000f,0.58000000f,-0.59000000f,-0.41000000f,-0.53000000f,0.05000000f,0.96000000f,0.00000000f,0.60000000f,0.56000000f,-0.18000000f,0.49000000f,-0.44000000f,0.47000000f,-0.67000000f,-0.85000000f,0.91000000f,-0.28000000f,-0.17000000f,0.62000000f,-0.96000000f,0.81000000f,0.12000000f,0.54000000f,-0.52000000f,-0.12000000f,-0.28000000f,0.82000000f,0.02000000f,-0.11000000f,-0.51000000f,-0.45000000f,0.20000000f,0.69000000f,0.07000000f,0.48000000f,-0.48000000f,-0.01000000f,0.33000000f,0.64000000f,0.15000000f,-0.79000000f,-0.11000000f,0.28000000f,0.48000000f,0.58000000f,0.95000000f,-0.89000000f,0.01000000f,-0.16000000f,-0.66000000f,-0.92000000f,0.89000000f,-0.34000000f,0.50000000f,-0.28000000f,0.08000000f,-0.74000000f,0.29000000f,-0.02000000f,0.68000000f,0.15000000f,0.95000000f,0.21000000f,-0.58000000f,-0.11000000f,0.64000000f,0.73000000f,0.87000000f,-0.96000000f,-0.64000000f,-0.60000000f,-0.79000000f,0.35000000f,-0.54000000f,-0.65000000f,0.14000000f,-0.48000000f,0.02000000f,0.36000000f,-0.45000000f,0.07000000f,0.58000000f,0.62000000f,0.73000000f,-0.92000000f,0.71000000f,-0.73000000f,-0.58000000f,-0.10000000f,0.95000000f,-0.81000000f,0.05000000f,-0.40000000f,-0.70000000f,0.03000000f,-0.45000000f,0.88000000f,-0.89000000f,0.37000000f,-0.30000000f,-0.37000000f,0.07000000f,0.28000000f,-0.11000000f,-0.38000000f,0.32000000f,0.78000000f,0.21000000f,0.43000000f,0.77000000f,-0.57000000f,0.40000000f,-0.93000000f,0.16000000f,-0.66000000f,-0.66000000f,-0.82000000f,-0.13000000f,-0.69000000f,0.77000000f,0.54000000f,0.69000000f,-0.54000000f,0.29000000f,-0.77000000f,0.14000000f,0.25000000f,-0.14000000f,-0.98000000f,0.36000000f,0.00000000f,-0.17000000f,-0.07000000f,-0.25000000f,0.25000000f,-0.30000000f,-0.53000000f,0.79000000f,0.08000000f,-0.80000000f,-0.05000000f,-0.87000000f,0.22000000f,0.35000000f,0.32000000f,0.09000000f,-0.44000000f,-0.82000000f,0.77000000f,-0.17000000f,0.47000000f,-0.89000000f,-0.83000000f,0.33000000f,0.20000000f,0.93000000f,-0.44000000f,0.89000000f,-0.27000000f,-0.95000000f,0.03000000f,-0.23000000f,0.34000000f,0.35000000f,-0.22000000f,0.56000000f,-0.36000000f,0.20000000f,0.86000000f,-0.18000000f,-0.11000000f,-0.27000000f,-0.87000000f,-0.52000000f,-0.85000000f,-0.71000000f,-0.07000000f,-0.42000000f,-0.73000000f,-0.72000000f,-0.45000000f,0.21000000f,0.22000000f,0.35000000f,-0.67000000f,0.47000000f,-0.17000000f,-0.72000000f,-0.48000000f,0.64000000f,0.68000000f,-0.06000000f,-0.60000000f,-0.82000000f,0.84000000f,0.16000000f,0.49000000f,-0.16000000f,-0.57000000f,-0.16000000f,-0.86000000f,0.05000000f,-0.91000000f,-0.02000000f,0.11000000f,0.91000000f,0.64000000f,-0.68000000f,0.93000000f,-0.25000000f,-0.46000000f,0.70000000f,0.87000000f,0.97000000f,-0.75000000f,0.73000000f,-0.70000000f,0.63000000f,-0.08000000f,0.94000000f,0.84000000f,-0.55000000f,0.29000000f,-0.75000000f,-0.18000000f,0.15000000f,0.41000000f,0.33000000f,0.81000000f,-0.95000000f,-0.12000000f,-0.47000000f,0.19000000f,-0.12000000f,-0.49000000f,0.34000000f,0.23000000f,0.36000000f,0.51000000f,-0.45000000f,-0.97000000f,0.09000000f,-0.47000000f,0.54000000f,0.32000000f,0.46000000f,0.90000000f,-0.58000000f,-0.87000000f,-0.48000000f,-0.91000000f,-0.72000000f,-0.19000000f,-0.93000000f,0.30000000f,0.91000000f,-0.78000000f,-0.46000000f,0.19000000f,0.90000000f,-0.22000000f,-0.43000000f,0.56000000f,-0.42000000f,0.99000000f,-0.46000000f,0.18000000f,-0.75000000f,-0.77000000f,0.85000000f,-0.99000000f,0.10000000f,-0.92000000f,0.68000000f,-0.07000000f,-0.81000000f,-0.57000000f,-0.57000000f,-0.31000000f,0.74000000f,-0.01000000f,0.38000000f,0.00000000f,0.05000000f,-0.85000000f,-0.28000000f,0.91000000f,-0.78000000f,0.53000000f,0.02000000f,-0.12000000f,-0.90000000f,0.21000000f,-0.22000000f,-0.01000000f,-0.87000000f,0.45000000f,-0.37000000f,0.09000000f,0.90000000f,0.15000000f,-0.14000000f,0.66000000f,0.32000000f,0.18000000f,0.87000000f,0.74000000f,-0.35000000f,0.95000000f,0.23000000f,-0.89000000f,-0.81000000f,0.95000000f,0.96000000f,-0.43000000f,0.57000000f,-0.16000000f,-0.82000000f,-0.00000000f,-0.64000000f,0.18000000f,0.01000000f,0.19000000f,-0.90000000f,-0.55000000f,0.31000000f,0.41000000f,-0.41000000f,-0.31000000f,-0.32000000f,-0.65000000f,0.08000000f,0.77000000f,0.24000000f,-0.26000000f,0.39000000f,-0.72000000f,0.75000000f,-0.49000000f,0.19000000f,0.58000000f,0.55000000f,-0.71000000f,-0.12000000f,0.96000000f,-0.78000000f,0.73000000f,0.10000000f,-0.31000000f,0.25000000f,0.78000000f,-0.70000000f,-0.11000000f,-0.87000000f,-0.00000000f,0.66000000f,0.26000000f,0.80000000f,-0.21000000f,-0.94000000f,-0.99000000f,0.94000000f,0.78000000f,0.97000000f,-0.41000000f,-0.27000000f,0.23000000f,-0.20000000f,-0.32000000f,-0.86000000f,0.51000000f,0.67000000f,0.95000000f,0.71000000f,-0.63000000f,-0.26000000f,-0.20000000f,0.79000000f,0.34000000f,0.42000000f,0.27000000f,-0.49000000f,0.99000000f,0.59000000f,-0.09000000f,-0.23000000f,-0.10000000f,0.11000000f,-0.37000000f,-0.99000000f,0.73000000f,0.81000000f,-0.38000000f,-0.57000000f,0.90000000f,0.85000000f,-0.21000000f,-0.73000000f,0.74000000f,0.42000000f,-0.77000000f,-0.04000000f,0.16000000f,0.88000000f,-0.27000000f,-0.34000000f,-0.83000000f,-0.91000000f,-0.47000000f,0.18000000f,-0.06000000f,0.40000000f,-0.10000000f,-0.74000000f,-0.45000000f,-0.24000000f,-0.27000000f,-0.44000000f,-0.49000000f,-0.96000000f,-0.46000000f,-0.12000000f,0.76000000f,0.75000000f,-0.11000000f,-0.96000000f,0.54000000f,0.00000000f,-0.26000000f,0.81000000f,0.79000000f,0.67000000f,0.20000000f,0.69000000f,0.68000000f,0.01000000f,0.17000000f,-0.84000000f,-0.28000000f,-0.05000000f,0.49000000f,0.09000000f,0.12000000f,-0.30000000f,-0.02000000f,-0.02000000f,-0.62000000f,-0.12000000f,0.76000000f,-0.24000000f,0.86000000f,0.36000000f,0.36000000f,0.25000000f,-0.34000000f,-0.57000000f,0.92000000f,-0.72000000f,0.05000000f,0.76000000f,-0.36000000f,-0.54000000f,-0.03000000f,-0.66000000f,-0.95000000f,0.52000000f,0.87000000f,0.11000000f,0.17000000f,-0.88000000f,-0.37000000f,-0.13000000f,0.18000000f,0.03000000f,0.50000000f,0.59000000f,-0.15000000f,0.36000000f,0.72000000f,0.49000000f,0.62000000f,-0.12000000f,-0.69000000f,0.15000000f,0.80000000f,0.63000000f,-0.97000000f,0.19000000f,0.59000000f,0.38000000f,-0.14000000f,-0.72000000f,-0.71000000f,-0.08000000f,-0.36000000f,-0.23000000f,0.56000000f,0.34000000f,0.14000000f,0.68000000f,-0.90000000f,-0.15000000f,0.32000000f,0.08000000f,-0.87000000f,-0.89000000f,-0.93000000f,0.39000000f,0.30000000f,0.54000000f,-0.86000000f,-0.32000000f,-0.45000000f,-0.09000000f,-0.10000000f,0.37000000f,0.18000000f,-0.83000000f,-0.38000000f,-0.53000000f,-0.67000000f,0.98000000f,-0.29000000f,-0.03000000f,-0.30000000f,0.90000000f,-0.58000000f,0.39000000f,-0.29000000f,0.10000000f,0.11000000f,0.04000000f,0.80000000f,0.21000000f,0.08000000f,0.00000000f,0.50000000f,-0.25000000f,0.75000000f,0.26000000f,0.28000000f,0.26000000f,-0.59000000f,0.56000000f,0.68000000f,0.02000000f,0.55000000f,0.81000000f,-0.78000000f,0.14000000f,0.90000000f,-0.15000000f,0.48000000f,-0.74000000f,-0.61000000f,0.31000000f,0.72000000f,-0.82000000f,0.28000000f,0.27000000f,0.82000000f,-0.67000000f,0.90000000f,-0.88000000f,0.56000000f,-0.29000000f,0.05000000f,-0.46000000f,0.67000000f,-0.21000000f,-0.33000000f,0.28000000f,0.43000000f,-0.95000000f,0.88000000f,0.97000000f,0.41000000f,-0.68000000f,0.30000000f,0.04000000f,-0.77000000f,0.14000000f,-0.67000000f,-0.96000000f,0.01000000f,-0.92000000f,-0.55000000f,0.44000000f,-0.70000000f,-0.70000000f,0.37000000f,-0.07000000f,0.39000000f,-0.12000000f,-0.27000000f,-0.71000000f,0.06000000f,0.28000000f,0.92000000f,-0.79000000f,-0.82000000f,0.52000000f,0.26000000f,-0.21000000f,0.82000000f,-0.49000000f,0.88000000f,0.47000000f,0.45000000f,0.31000000f,0.44000000f,-0.98000000f,-0.23000000f,0.44000000f,0.13000000f,0.61000000f,-0.20000000f,-0.23000000f,-0.61000000f,-0.34000000f,0.35000000f,0.56000000f,-0.16000000f,0.57000000f,-0.46000000f,-0.56000000f,-0.92000000f,-0.31000000f,0.97000000f,-0.25000000f,-0.48000000f,-0.94000000f,0.74000000f,0.02000000f,-0.61000000f,-0.71000000f,0.57000000f,0.77000000f,0.33000000f,-0.52000000f,0.38000000f,0.78000000f,-0.79000000f,0.20000000f,-0.52000000f,0.44000000f,-0.45000000f,-0.36000000f,-0.93000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.84000000f,-0.83000000f,-0.72000000f,0.39000000f,0.32000000f,-0.87000000f,0.58000000f,-0.47000000f,0.08000000f,0.08000000f,-0.55000000f,0.22000000f,0.63000000f,0.21000000f,-0.15000000f,0.08000000f,-0.79000000f,-0.42000000f,0.49000000f,-0.89000000f,0.14000000f,-0.24000000f,-0.42000000f,0.34000000f,-0.20000000f,-0.26000000f,0.90000000f,0.98000000f,0.89000000f,-0.73000000f,-0.21000000f,-0.73000000f,0.36000000f,-0.51000000f,0.56000000f,-0.67000000f,0.65000000f,0.82000000f,0.39000000f,0.18000000f,0.76000000f,-0.26000000f,-0.75000000f,-0.83000000f,-0.94000000f,-0.04000000f,-0.80000000f,-0.89000000f,0.68000000f,-0.48000000f,-0.50000000f,0.75000000f,0.22000000f,0.87000000f,-0.06000000f,0.40000000f,-0.40000000f,-0.13000000f,0.17000000f,-0.01000000f,-0.40000000f,0.75000000f,0.42000000f,0.77000000f,0.28000000f,-0.41000000f,0.12000000f,0.55000000f,0.72000000f,-0.48000000f,-0.71000000f,0.75000000f,-0.18000000f,-0.51000000f,0.55000000f,0.35000000f,0.57000000f,0.03000000f,0.86000000f,0.52000000f,0.71000000f,0.50000000f,-0.25000000f,0.83000000f,0.57000000f,-0.51000000f,0.81000000f,0.03000000f,-0.81000000f,-0.78000000f,-0.70000000f,0.27000000f,0.55000000f,0.62000000f,0.55000000f,0.68000000f,-0.05000000f,-0.73000000f,-0.28000000f,0.24000000f,-0.33000000f,0.59000000f,-0.89000000f,0.78000000f,-0.91000000f,-0.77000000f,0.11000000f,-0.73000000f,0.57000000f,-0.26000000f,-0.25000000f,0.80000000f,0.47000000f,-0.09000000f,0.71000000f,0.15000000f,0.56000000f,0.27000000f,0.11000000f,-0.27000000f,-0.69000000f,0.45000000f,0.23000000f,0.87000000f,-0.35000000f,-0.31000000f,0.73000000f,-0.30000000f,-0.65000000f,0.36000000f,0.52000000f,-0.80000000f,0.62000000f,0.25000000f,0.31000000f,-0.42000000f,-0.32000000f,0.83000000f,-0.59000000f,-0.22000000f,-0.61000000f,-0.35000000f,-0.60000000f,-0.89000000f,-0.46000000f,-0.38000000f,-0.69000000f,-0.99000000f,0.87000000f,-0.04000000f,0.47000000f,0.31000000f,-0.07000000f,-0.64000000f,0.30000000f,-0.09000000f,-0.57000000f,0.28000000f,0.39000000f,0.75000000f,-0.44000000f,-0.50000000f,0.97000000f,0.74000000f,-0.86000000f,0.59000000f,0.28000000f,-0.48000000f,-0.96000000f,0.59000000f,0.17000000f,0.43000000f,0.84000000f,-0.80000000f,0.14000000f,0.10000000f,-0.25000000f,-0.99000000f,-0.89000000f,0.12000000f,-0.67000000f,-0.24000000f,0.65000000f,-0.20000000f,-0.73000000f,0.66000000f,0.80000000f,-0.46000000f,-0.32000000f,-0.60000000f,0.79000000f,-0.99000000f,0.22000000f,0.30000000f,-0.33000000f,0.49000000f,0.71000000f,-0.59000000f,-0.47000000f,-0.36000000f,0.93000000f,0.67000000f,-0.66000000f,-0.48000000f,0.04000000f,-0.11000000f,0.22000000f,0.55000000f,0.31000000f,0.26000000f,0.17000000f,-0.12000000f,0.39000000f,0.40000000f,-0.13000000f,0.44000000f,-0.36000000f,0.81000000f,0.69000000f,-0.47000000f,-0.07000000f,-0.94000000f,-0.06000000f,0.45000000f,-0.47000000f,0.12000000f,0.30000000f,0.81000000f,-0.50000000f,0.64000000f,0.56000000f,-0.01000000f,0.43000000f,-0.24000000f,0.45000000f,-0.30000000f,0.56000000f,-0.13000000f,0.44000000f,-0.17000000f,0.17000000f,0.76000000f,-0.32000000f,-0.49000000f,-0.13000000f,0.07000000f,-0.43000000f,-0.50000000f,-0.80000000f,-0.07000000f,-0.13000000f,0.93000000f,0.13000000f,-0.29000000f,-0.39000000f,0.53000000f,-0.89000000f,0.67000000f,0.25000000f,0.42000000f,-0.29000000f,0.48000000f,-0.37000000f,0.99000000f,0.99000000f,-0.12000000f,0.36000000f,0.64000000f,-0.79000000f,0.85000000f,-0.97000000f,-0.01000000f,-0.51000000f,-0.54000000f,-0.02000000f,-0.79000000f,-0.70000000f,-0.61000000f,0.24000000f,-0.12000000f,0.82000000f,0.18000000f,-0.91000000f,-0.83000000f,-0.90000000f,-0.32000000f,-0.14000000f,0.51000000f,0.05000000f,-0.63000000f,0.49000000f,0.57000000f,-0.31000000f,-0.97000000f,0.77000000f,-0.48000000f,0.05000000f,-0.75000000f,-0.72000000f,0.47000000f,-0.55000000f,0.19000000f,-0.76000000f,0.39000000f,-0.06000000f,-0.66000000f,0.20000000f,-0.85000000f,-0.09000000f,-0.76000000f,-0.84000000f,0.09000000f,0.74000000f,-0.09000000f,-0.75000000f,-0.69000000f,0.18000000f,0.27000000f,0.74000000f,0.73000000f,0.29000000f,0.70000000f,-0.59000000f,0.91000000f,0.93000000f,0.83000000f,0.40000000f,-0.87000000f,-0.29000000f,-0.93000000f,-0.33000000f,0.88000000f,-0.95000000f,-0.81000000f,-0.71000000f,0.96000000f,-0.37000000f,-0.39000000f,-0.23000000f,0.08000000f,0.71000000f,-0.18000000f,0.23000000f,0.61000000f,0.05000000f,0.19000000f,-0.19000000f,-0.81000000f,-0.05000000f,0.63000000f,0.84000000f,-0.12000000f,-0.33000000f,0.27000000f,0.49000000f,-0.29000000f,-0.30000000f,0.70000000f,-0.82000000f,-0.59000000f,0.59000000f,-0.28000000f,0.10000000f,-0.24000000f,0.13000000f,0.85000000f,-0.54000000f,-0.63000000f,0.65000000f,-0.06000000f,-0.59000000f,-0.97000000f,-0.36000000f,-0.40000000f,-0.34000000f,0.84000000f,-0.25000000f,0.77000000f,0.22000000f,0.87000000f,0.91000000f,-0.78000000f,0.74000000f,-0.13000000f,0.13000000f,0.07000000f,0.15000000f,0.92000000f,0.17000000f,-0.51000000f,0.06000000f,0.79000000f,-0.51000000f,-0.76000000f,-0.19000000f,-0.22000000f,0.74000000f,-0.31000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.97000000f,-0.59000000f,0.39000000f,-0.58000000f,-0.70000000f,-0.29000000f,0.44000000f,-0.71000000f,-0.77000000f,-0.83000000f,0.17000000f,-0.55000000f,-0.47000000f,0.98000000f,0.74000000f,-0.04000000f,0.57000000f,0.05000000f,0.64000000f,-0.53000000f,-0.23000000f,-0.15000000f,0.87000000f,-0.86000000f,0.45000000f,0.50000000f,-0.58000000f,0.35000000f,-0.89000000f,0.59000000f,-0.34000000f,-0.12000000f,-0.56000000f,-0.08000000f,0.93000000f,0.93000000f,0.27000000f,-0.60000000f,0.06000000f,0.47000000f,0.22000000f,0.49000000f,0.67000000f,-0.30000000f,0.83000000f,-0.13000000f,0.86000000f,-0.86000000f,-0.79000000f,-0.41000000f,0.30000000f,0.56000000f,0.88000000f,0.17000000f,0.40000000f,-0.84000000f,0.84000000f,-0.18000000f,0.95000000f,-0.17000000f,-0.52000000f,0.14000000f,0.04000000f,0.96000000f,0.21000000f,-0.42000000f,0.92000000f,0.32000000f,-0.24000000f,-0.11000000f,0.26000000f,-0.60000000f,-0.68000000f,0.91000000f,-0.37000000f,0.11000000f,0.76000000f,0.31000000f,0.39000000f,-0.25000000f,-0.10000000f,0.63000000f,0.20000000f,0.83000000f,-0.49000000f,0.71000000f,0.42000000f,-0.01000000f,0.15000000f,-0.47000000f,-0.13000000f,-0.69000000f,0.17000000f,0.90000000f,-0.21000000f,0.14000000f,0.60000000f,0.39000000f,-0.16000000f,0.23000000f,-0.33000000f,0.88000000f,-0.78000000f,-0.87000000f,0.15000000f,-0.68000000f,0.53000000f,-0.11000000f,0.43000000f,-0.54000000f,-0.57000000f,0.87000000f,0.81000000f,0.13000000f,-0.07000000f,0.18000000f,-0.32000000f,-0.85000000f,0.35000000f,-0.32000000f,0.75000000f,-0.80000000f,0.79000000f,-0.12000000f,0.55000000f,0.06000000f,-0.95000000f,0.50000000f,0.99000000f,-0.88000000f,0.75000000f,-0.69000000f,-0.23000000f,-0.53000000f,0.93000000f,-0.57000000f,0.29000000f,0.58000000f,-0.42000000f,0.75000000f,-0.92000000f,-0.13000000f,-0.16000000f,0.28000000f,-0.90000000f,-0.17000000f,-0.74000000f,-0.55000000f,0.99000000f,-0.82000000f,-0.24000000f,-0.43000000f,-0.52000000f,-0.45000000f,-0.02000000f,-0.70000000f,-0.26000000f,0.74000000f,0.21000000f,0.97000000f,-0.10000000f,-0.65000000f,-0.18000000f,-0.06000000f,-0.60000000f,0.54000000f,-0.76000000f,0.23000000f,0.21000000f,0.44000000f,0.06000000f,-0.80000000f,-0.87000000f,-0.13000000f,0.92000000f,0.97000000f,-0.04000000f,0.35000000f,-0.44000000f,-0.00000000f,-0.78000000f,-0.54000000f,-0.91000000f,0.19000000f,0.97000000f,-0.60000000f,0.35000000f,-0.64000000f,-0.84000000f,0.25000000f,0.90000000f,0.17000000f,-0.26000000f,-0.82000000f,0.59000000f,-0.62000000f,-0.14000000f,0.41000000f,0.62000000f,0.91000000f,-0.73000000f,0.62000000f,0.87000000f,0.50000000f,0.55000000f,-0.72000000f,0.00000000f,-0.19000000f,0.90000000f,0.30000000f,0.09000000f,-0.10000000f,-0.90000000f,0.66000000f,0.77000000f,0.63000000f,-0.07000000f,-0.92000000f,-0.63000000f,-0.86000000f,-0.08000000f,0.09000000f,0.38000000f,0.58000000f,0.76000000f,-0.98000000f,0.83000000f,-0.05000000f,-0.37000000f,0.52000000f,-0.57000000f,-0.31000000f,-0.47000000f,-0.49000000f,0.42000000f,-0.13000000f,-0.79000000f,0.60000000f,-0.08000000f,-0.12000000f,0.65000000f,-0.48000000f,0.79000000f,0.22000000f,0.71000000f,0.70000000f,0.78000000f,-0.25000000f,-0.05000000f,0.48000000f,0.14000000f,-0.85000000f,0.50000000f,-0.86000000f,0.31000000f,0.60000000f,0.72000000f,0.82000000f,-0.46000000f,-0.65000000f,-0.54000000f,0.26000000f,0.17000000f,-0.02000000f,-0.48000000f,0.36000000f,-0.63000000f,0.84000000f,0.62000000f,0.59000000f,-0.74000000f,0.00000000f,0.45000000f,0.08000000f,-0.54000000f,-0.34000000f,0.79000000f,0.38000000f,-0.17000000f,0.41000000f,0.30000000f,0.06000000f,0.22000000f,0.59000000f,0.23000000f,-0.36000000f,0.85000000f,-0.00000000f,-0.93000000f,0.74000000f,0.06000000f,-0.99000000f,-0.06000000f,-0.48000000f,0.27000000f,-0.97000000f,-0.44000000f,-0.12000000f,0.46000000f,-0.63000000f,-0.57000000f,-0.98000000f,0.72000000f,0.59000000f,-0.81000000f,0.96000000f,0.64000000f,-0.59000000f,0.13000000f,-0.80000000f,0.43000000f,0.23000000f,-0.66000000f,-0.74000000f,-0.52000000f,0.39000000f,-0.60000000f,-0.92000000f,0.49000000f,0.03000000f,0.84000000f,-0.72000000f,-0.97000000f,-0.81000000f,0.17000000f,0.79000000f,0.69000000f,-0.66000000f,0.11000000f,0.40000000f,-0.37000000f,0.46000000f,-0.74000000f,-0.50000000f,0.81000000f,-0.90000000f,0.66000000f,-0.06000000f,-0.42000000f,0.47000000f,0.12000000f,0.59000000f,-0.26000000f,0.12000000f,-0.93000000f,0.61000000f,-0.19000000f,-0.96000000f,-0.63000000f,-0.86000000f,-0.96000000f,0.33000000f,-0.80000000f,-0.31000000f,-0.22000000f,-0.73000000f,-0.39000000f,0.69000000f,-0.59000000f,0.17000000f,-0.24000000f,0.75000000f,-0.61000000f,-0.90000000f,0.23000000f,0.75000000f,-0.51000000f,-0.08000000f,-0.47000000f,0.37000000f,-0.30000000f,0.36000000f,0.75000000f,0.93000000f,0.97000000f,0.52000000f,0.64000000f,0.98000000f,-0.05000000f,0.34000000f,-0.66000000f,0.60000000f,0.44000000f,0.48000000f,0.53000000f,-0.61000000f,-0.57000000f,0.18000000f,-0.28000000f,0.80000000f,0.14000000f,0.31000000f,-0.54000000f,-0.56000000f,0.48000000f,0.28000000f,-0.86000000f,-0.04000000f,-0.12000000f,-0.97000000f,0.87000000f,-0.82000000f,-0.33000000f,-0.75000000f,0.67000000f,-0.05000000f,0.83000000f,0.14000000f,0.84000000f,-0.47000000f,0.25000000f,-0.52000000f,-0.48000000f,-0.86000000f,0.15000000f,0.19000000f,-0.45000000f,-0.48000000f,-0.33000000f,-0.98000000f,-0.61000000f,0.13000000f,0.83000000f,-0.45000000f,0.78000000f,0.16000000f,-0.52000000f,0.37000000f,0.07000000f,-0.98000000f,0.78000000f,0.91000000f,-0.26000000f,-0.30000000f,0.10000000f,-0.92000000f,0.17000000f,0.10000000f,0.44000000f,-0.31000000f,-0.50000000f,-0.85000000f,-0.29000000f,0.85000000f,-0.47000000f,0.13000000f,-0.59000000f,-0.71000000f,0.34000000f,0.39000000f,-0.72000000f,-0.46000000f,-0.66000000f,0.44000000f,0.95000000f,0.09000000f,-0.10000000f,0.81000000f,0.37000000f,-0.82000000f,0.24000000f,-0.58000000f,-0.79000000f,0.61000000f,-0.73000000f,0.45000000f,-0.76000000f,-0.55000000f,-0.06000000f,-0.59000000f,-0.04000000f,0.42000000f,0.08000000f,-0.51000000f,-0.87000000f,-0.54000000f,-0.25000000f,0.51000000f,-0.14000000f,0.78000000f,0.06000000f,0.44000000f,-0.40000000f,0.11000000f,-0.47000000f,0.36000000f,0.23000000f,0.12000000f,0.49000000f,-0.40000000f,-0.39000000f,0.45000000f,0.74000000f,-0.99000000f,-0.21000000f,0.03000000f,0.85000000f,0.59000000f,0.67000000f,0.15000000f,0.74000000f,0.34000000f,-0.49000000f,-0.59000000f,-0.82000000f,-0.82000000f,0.60000000f,0.12000000f,-0.61000000f,-0.19000000f,0.52000000f,-0.32000000f,0.96000000f,0.46000000f,0.95000000f,0.27000000f,0.97000000f,-0.01000000f,0.18000000f,0.81000000f,-0.55000000f,0.05000000f,-0.76000000f,-0.74000000f,0.08000000f,0.58000000f,-0.77000000f,0.43000000f,-0.55000000f,-0.78000000f,0.37000000f,0.39000000f,-0.37000000f,-0.03000000f,-0.75000000f,-0.46000000f,0.96000000f,0.50000000f,0.55000000f,-0.81000000f,0.39000000f,-0.54000000f,0.42000000f,-0.92000000f,-0.40000000f,0.31000000f,0.16000000f,-0.87000000f,-0.58000000f,0.41000000f,-0.31000000f,-0.74000000f,-0.36000000f,0.18000000f,0.00000000f,0.32000000f,0.32000000f,0.39000000f,-0.91000000f,0.50000000f,0.75000000f,0.38000000f,0.60000000f,0.11000000f,-0.56000000f,0.61000000f,-0.92000000f,0.38000000f,0.10000000f,-0.30000000f,-0.42000000f,0.35000000f,-0.51000000f,0.58000000f,0.84000000f,-0.37000000f,-0.00000000f,0.82000000f,0.15000000f,0.82000000f,-0.89000000f,0.34000000f,0.29000000f,-0.45000000f,-0.31000000f,-0.54000000f,0.02000000f,-0.69000000f,0.15000000f,-0.77000000f,-0.14000000f,-0.89000000f,-0.19000000f,-0.03000000f,-0.41000000f,0.20000000f,-0.28000000f,-0.60000000f,0.25000000f,-0.18000000f,0.82000000f,-0.38000000f,-0.20000000f,-0.25000000f,-0.18000000f,-0.85000000f,0.88000000f,-0.02000000f,0.97000000f,0.62000000f,-0.97000000f,0.63000000f,0.36000000f,-0.13000000f,-0.93000000f,-0.84000000f,0.63000000f,0.87000000f,-0.18000000f,-0.34000000f,-0.72000000f,0.63000000f,0.13000000f,-0.05000000f,-0.56000000f,0.81000000f,-0.19000000f,-0.89000000f,0.61000000f,0.71000000f,0.22000000f,0.45000000f,-0.44000000f,0.89000000f,0.67000000f,0.47000000f,0.85000000f,-0.50000000f,-0.03000000f,-0.73000000f,0.20000000f,-0.86000000f,0.71000000f,-0.12000000f,-0.16000000f,0.50000000f,0.47000000f,-0.95000000f,-0.37000000f,0.81000000f,0.85000000f,0.69000000f,0.46000000f,-0.77000000f,0.25000000f,0.15000000f,0.09000000f,-0.12000000f,-0.32000000f,0.93000000f,-0.04000000f,-0.66000000f,-0.41000000f,-0.91000000f,-0.84000000f,-0.32000000f,-0.51000000f,0.65000000f,0.09000000f,-0.18000000f,0.80000000f,0.55000000f,-0.30000000f,0.56000000f,0.22000000f,0.28000000f,-0.48000000f,-0.61000000f,-0.15000000f,-0.65000000f,-0.38000000f,0.03000000f,-0.83000000f,0.61000000f,0.83000000f,-0.14000000f,0.39000000f,-0.44000000f,-0.49000000f,-0.70000000f,0.35000000f,-0.72000000f,0.51000000f,0.09000000f,0.31000000f,0.98000000f,0.63000000f,0.74000000f,0.25000000f,-0.30000000f,0.20000000f,0.08000000f,0.81000000f,0.69000000f,0.16000000f,-0.85000000f,0.69000000f,0.20000000f,-0.68000000f,0.99000000f,0.14000000f,-0.65000000f,-0.21000000f,0.03000000f,0.06000000f,-0.16000000f,0.80000000f,0.95000000f,0.90000000f,-0.13000000f,0.05000000f,0.84000000f,0.56000000f,-0.42000000f,-0.58000000f,0.02000000f,-0.16000000f,-0.68000000f,0.03000000f,0.94000000f,-0.20000000f,-0.99000000f,0.99000000f,-0.20000000f,-0.69000000f,0.25000000f,-0.00000000f,0.55000000f,-0.11000000f,0.74000000f,0.96000000f,-0.12000000f,-0.50000000f,0.81000000f,0.97000000f,-0.56000000f,0.40000000f,0.94000000f,0.34000000f,-0.98000000f,-0.04000000f,-0.45000000f,-0.89000000f,-0.04000000f,-0.07000000f,-0.35000000f,0.58000000f,-0.52000000f,0.85000000f,0.94000000f,-0.92000000f,-0.46000000f,-0.51000000f,-0.30000000f,-0.98000000f,0.04000000f,0.45000000f,-0.08000000f,0.53000000f,-0.78000000f,0.43000000f,0.90000000f,-0.48000000f,-0.31000000f,-0.84000000f,-0.70000000f,-0.79000000f,-0.33000000f,0.13000000f,0.68000000f,-0.44000000f,0.21000000f,0.62000000f,0.73000000f,0.15000000f,0.72000000f,0.31000000f,0.21000000f,-0.78000000f,-0.89000000f,-0.96000000f,-0.69000000f,0.12000000f,0.45000000f,-0.47000000f,-0.91000000f,-0.33000000f,0.75000000f,0.87000000f,0.35000000f,-0.33000000f,0.08000000f,0.34000000f,-0.93000000f,0.55000000f,-0.30000000f,0.93000000f,0.60000000f,-0.06000000f,0.89000000f,-0.84000000f,-0.34000000f,0.59000000f,0.20000000f,-0.63000000f,-0.40000000f,0.10000000f,-0.47000000f,-0.79000000f,-0.05000000f,-0.28000000f,-0.97000000f,0.68000000f,0.58000000f,-0.96000000f,-0.32000000f,0.09000000f,-0.14000000f,0.20000000f,0.86000000f,0.33000000f,-0.27000000f,-0.62000000f,0.99000000f,-0.56000000f,0.87000000f,-0.75000000f,-0.53000000f,0.86000000f,-0.44000000f,-0.38000000f,-0.30000000f,-0.73000000f,-0.95000000f,-0.19000000f,0.16000000f,-0.16000000f,-0.87000000f,-0.41000000f,0.77000000f,-0.40000000f,0.90000000f,-0.10000000f,0.67000000f,-0.28000000f,-0.81000000f,0.66000000f,-0.97000000f,-0.21000000f,-0.08000000f,-0.57000000f,-0.80000000f,0.07000000f,-0.86000000f,-0.94000000f,-0.33000000f,-0.43000000f,-0.63000000f,0.52000000f,-0.74000000f,-0.07000000f,-0.17000000f,0.75000000f,0.10000000f,0.97000000f,0.70000000f,-0.01000000f,0.13000000f,0.28000000f,-0.59000000f,-0.25000000f,0.39000000f,0.44000000f,0.18000000f,0.38000000f,-0.95000000f,0.93000000f,-0.80000000f,0.37000000f,0.08000000f,0.42000000f,-0.84000000f,-0.05000000f,0.21000000f,0.96000000f,0.93000000f,-0.60000000f,0.96000000f,-0.50000000f,0.17000000f,-0.74000000f,0.47000000f,-0.16000000f,-0.05000000f,-0.36000000f,-0.46000000f,-0.62000000f,0.95000000f,0.44000000f,-0.45000000f,0.42000000f,-0.31000000f,0.79000000f,0.37000000f,-0.21000000f,-0.78000000f,-0.08000000f,-0.70000000f,-0.83000000f,0.02000000f,0.10000000f,-0.45000000f,-0.12000000f,-0.45000000f,-0.90000000f,0.95000000f,0.60000000f,0.34000000f,-0.38000000f,-0.22000000f,0.37000000f,0.04000000f,-0.21000000f,-0.63000000f,0.10000000f,0.61000000f,-0.76000000f,-0.48000000f,-0.45000000f,0.27000000f,0.96000000f,0.75000000f,0.09000000f,0.77000000f,0.99000000f,-0.35000000f,0.81000000f,0.95000000f,0.14000000f,-0.41000000f,-0.54000000f,-0.43000000f,0.25000000f,0.36000000f,-0.61000000f,-0.11000000f,0.83000000f,0.14000000f,0.56000000f,-0.42000000f,0.80000000f,0.35000000f,0.11000000f,-0.51000000f,-0.68000000f,-0.28000000f,0.05000000f,0.54000000f,-0.01000000f,-0.74000000f,-0.19000000f,-0.91000000f,0.86000000f,-0.05000000f,0.19000000f,-0.71000000f,-0.22000000f,0.39000000f,0.97000000f,0.08000000f,0.92000000f,-0.36000000f,0.29000000f,0.08000000f,0.99000000f,-0.31000000f,-0.94000000f,-0.37000000f,0.17000000f,0.41000000f,0.41000000f,-0.57000000f,-0.56000000f,-0.05000000f,0.88000000f,0.19000000f,0.91000000f,0.34000000f,0.07000000f,0.39000000f,-0.56000000f,0.76000000f,0.87000000f,-0.82000000f,0.79000000f,-0.29000000f,0.29000000f,0.79000000f,-0.00000000f,-0.68000000f,0.22000000f,0.75000000f,-0.29000000f,-0.92000000f,-0.57000000f,0.88000000f,-0.78000000f,-0.99000000f,0.88000000f,0.34000000f,0.82000000f,0.86000000f,-0.17000000f,0.79000000f,0.12000000f,0.42000000f,-0.50000000f,0.23000000f,0.83000000f,0.25000000f,0.77000000f,0.62000000f,-0.81000000f,-0.24000000f,0.47000000f,-0.49000000f,-0.45000000f,0.06000000f,-0.38000000f,-0.01000000f,0.15000000f,-0.16000000f,-0.63000000f,-0.25000000f,-0.99000000f,0.24000000f,0.85000000f,-0.69000000f,-0.37000000f,-0.27000000f,0.01000000f,-0.22000000f,0.73000000f,0.63000000f,-0.48000000f,0.87000000f,0.90000000f,-0.64000000f,0.68000000f,0.59000000f,0.11000000f,-0.83000000f,0.17000000f,0.87000000f,-0.88000000f,0.76000000f,-0.85000000f,-0.20000000f,0.94000000f,0.71000000f,0.16000000f,-0.40000000f,-0.73000000f,0.91000000f,0.61000000f,0.89000000f,-0.73000000f,0.79000000f,-0.48000000f,-0.18000000f,0.74000000f,0.64000000f,-0.74000000f,-0.89000000f,-0.84000000f,-0.28000000f,-0.00000000f,0.45000000f,0.50000000f,0.78000000f,0.84000000f,-0.54000000f,0.66000000f,0.67000000f,-0.58000000f,-0.67000000f,0.09000000f,-0.93000000f,-0.50000000f,-0.71000000f,-0.57000000f,0.44000000f,-0.20000000f,0.42000000f,-0.65000000f,-0.81000000f,0.37000000f,0.21000000f,-0.82000000f,-0.16000000f,0.84000000f,0.04000000f,0.51000000f,0.33000000f,-0.43000000f,0.44000000f,-0.82000000f,0.92000000f,-0.33000000f,-0.92000000f,0.76000000f,-0.33000000f,0.83000000f,-0.21000000f,-0.25000000f,0.28000000f,0.78000000f,0.70000000f,0.04000000f,0.65000000f,-0.44000000f,0.28000000f,-0.61000000f,-0.85000000f,0.26000000f,-0.86000000f,0.41000000f,0.02000000f,-0.44000000f,0.93000000f,0.27000000f,0.79000000f,-0.60000000f,0.91000000f,-0.25000000f,-0.92000000f,0.13000000f,0.87000000f,-0.29000000f,-0.89000000f,-0.56000000f,-0.91000000f,-0.95000000f,-0.72000000f,-0.62000000f,-0.99000000f,-0.89000000f,-0.89000000f,0.64000000f,-0.08000000f,0.70000000f,-0.78000000f,0.82000000f,-0.54000000f,0.97000000f,-0.26000000f,0.12000000f,0.46000000f,-0.26000000f,-0.46000000f,-0.65000000f,0.04000000f,-0.50000000f,0.34000000f,-0.78000000f,-0.54000000f,-0.29000000f,0.13000000f,0.19000000f,0.01000000f,-0.77000000f,-0.20000000f,-0.98000000f,0.43000000f,0.37000000f,0.80000000f,-0.97000000f,-0.99000000f,-0.66000000f,0.55000000f,0.85000000f,0.45000000f,0.58000000f,-0.29000000f,-0.54000000f,-0.95000000f,0.41000000f,0.14000000f,-0.84000000f,0.13000000f,0.06000000f,0.37000000f,0.23000000f,0.76000000f,0.88000000f,0.12000000f,-0.84000000f,-0.53000000f,-0.26000000f,0.26000000f,0.67000000f,-0.24000000f,0.76000000f,0.76000000f,0.12000000f,-0.13000000f,-0.05000000f,-0.12000000f,0.92000000f,0.40000000f,-0.68000000f,0.68000000f,0.00000000f,0.19000000f,-0.72000000f,0.06000000f,-0.66000000f,0.55000000f,0.77000000f,-0.71000000f,0.84000000f,0.59000000f,0.15000000f,0.27000000f,0.38000000f,-0.99000000f,-0.03000000f,0.65000000f,-0.94000000f,0.55000000f,-0.51000000f,0.40000000f,0.32000000f,0.33000000f,-0.93000000f,0.49000000f,0.83000000f,0.98000000f,0.32000000f,-0.45000000f,0.32000000f,-0.22000000f,0.37000000f,-0.35000000f,-0.30000000f,-0.63000000f,-0.72000000f,0.86000000f,-0.95000000f,0.70000000f,0.44000000f,0.12000000f,-0.66000000f,0.39000000f,0.67000000f,-0.56000000f,-0.25000000f,-0.64000000f,-0.15000000f,0.33000000f,0.37000000f,-0.26000000f,0.65000000f,0.13000000f,-0.98000000f,-0.27000000f,-0.94000000f,0.90000000f,-0.30000000f,-0.35000000f,0.24000000f,0.20000000f,-0.93000000f,0.24000000f,-0.17000000f,-0.80000000f,0.24000000f,0.92000000f,-0.81000000f,-0.61000000f,0.05000000f,-0.72000000f,0.12000000f,0.95000000f,-0.07000000f,-0.04000000f,0.74000000f,-0.10000000f,-0.07000000f,-0.55000000f,-0.07000000f,0.21000000f,-0.77000000f,-0.79000000f,0.52000000f,-0.76000000f,-0.02000000f,-0.18000000f,-0.88000000f,-0.76000000f,0.78000000f,-0.74000000f,-0.22000000f,0.26000000f,-0.51000000f,0.91000000f,0.33000000f,0.82000000f,0.67000000f,0.89000000f,-0.57000000f,0.47000000f,-0.30000000f,0.06000000f,0.46000000f,0.40000000f,0.33000000f,0.36000000f,-0.12000000f,0.80000000f,-0.46000000f,0.69000000f,0.60000000f,0.96000000f,0.69000000f,-0.85000000f,-0.16000000f,-0.44000000f,-0.13000000f,-0.58000000f,-0.93000000f,0.05000000f,0.51000000f,-0.02000000f,0.79000000f,-0.36000000f,0.27000000f,0.74000000f,0.67000000f,0.61000000f,-0.67000000f,-0.97000000f,-0.01000000f,0.78000000f,-0.94000000f,0.11000000f,-0.35000000f,-0.45000000f,-0.27000000f,0.51000000f,0.07000000f,-0.34000000f,0.46000000f,0.85000000f,-0.25000000f,0.84000000f,0.40000000f,-0.68000000f,-0.66000000f,-0.89000000f,0.72000000f,-0.52000000f,-0.46000000f,-0.19000000f,0.91000000f,0.09000000f,-0.56000000f,0.16000000f,0.01000000f,-0.29000000f,0.86000000f,-0.05000000f,0.50000000f,-0.98000000f,0.98000000f,-0.25000000f,0.21000000f,-0.52000000f,-0.45000000f,0.07000000f,0.97000000f,0.62000000f,0.51000000f,0.91000000f,-0.42000000f,0.80000000f,-0.33000000f,-0.77000000f,-0.98000000f,0.82000000f,-0.35000000f,0.96000000f,0.25000000f,-0.54000000f,0.50000000f,-0.66000000f,0.54000000f,-0.14000000f,0.53000000f,-0.96000000f,-0.05000000f,-0.85000000f,-0.03000000f,0.12000000f,-0.71000000f,-0.06000000f,0.47000000f,-0.80000000f,0.70000000f,0.88000000f,0.57000000f,-0.07000000f,-0.04000000f,-0.13000000f,0.80000000f,0.59000000f,-0.23000000f,-0.66000000f,-0.34000000f,-0.78000000f,0.95000000f,0.14000000f,0.24000000f,-0.37000000f,-0.29000000f,0.51000000f,-0.94000000f,-0.93000000f,-0.62000000f,-0.68000000f,0.58000000f,-0.13000000f,0.16000000f,0.50000000f,-0.23000000f,-0.01000000f,-0.24000000f,0.82000000f,-0.07000000f,-0.01000000f,-0.49000000f,0.23000000f,-0.00000000f,0.83000000f,-0.60000000f,0.72000000f,0.34000000f,-0.12000000f,-0.11000000f,-0.07000000f,0.01000000f,0.15000000f,-0.23000000f,0.58000000f,-0.60000000f,0.74000000f,0.43000000f,-0.15000000f,-0.41000000f,-0.29000000f,0.66000000f,0.60000000f,0.74000000f,-0.13000000f,0.48000000f,-0.13000000f,-0.35000000f,0.29000000f,-0.64000000f,-0.76000000f,0.27000000f,0.56000000f,0.72000000f,0.51000000f,-0.75000000f,-0.30000000f,0.53000000f,-0.62000000f,0.64000000f,0.11000000f,-0.93000000f,-0.12000000f,-0.43000000f,0.96000000f,0.49000000f,-0.66000000f,0.47000000f,-0.96000000f,-0.60000000f,0.72000000f,0.64000000f,0.39000000f,-0.53000000f,-0.61000000f,-0.37000000f,0.99000000f,-0.74000000f,0.50000000f,-0.32000000f,0.82000000f,-0.98000000f,-0.06000000f,-0.68000000f,0.32000000f,-0.28000000f,-0.64000000f,0.30000000f,-0.44000000f,0.60000000f,0.16000000f,-0.29000000f,-0.21000000f,-0.12000000f,0.19000000f,0.26000000f,-0.32000000f,-0.90000000f,0.88000000f,0.96000000f,-0.28000000f,0.51000000f,-0.86000000f,0.28000000f,0.43000000f,0.82000000f,-0.21000000f,-0.15000000f,0.15000000f,-0.70000000f,-0.70000000f,0.05000000f,-0.82000000f,-0.85000000f,-0.57000000f,0.13000000f,-0.22000000f,0.53000000f,0.80000000f,0.43000000f,0.30000000f,-0.77000000f,-0.95000000f,0.95000000f,0.95000000f,-0.21000000f,0.56000000f,0.56000000f,-0.66000000f,-0.70000000f,-0.03000000f,0.51000000f,0.79000000f,0.00000000f,-0.68000000f,0.25000000f,-0.15000000f,0.12000000f,0.07000000f,-0.18000000f,-0.57000000f,0.81000000f,0.22000000f,-0.80000000f,0.14000000f,0.14000000f,0.19000000f,0.65000000f,-0.06000000f,0.72000000f,-0.96000000f,-0.93000000f,-0.96000000f,-0.35000000f,0.06000000f,0.92000000f,-0.01000000f,-0.16000000f,0.13000000f,0.00000000f,-0.24000000f,0.79000000f,-0.15000000f,-0.29000000f,-0.83000000f,-0.38000000f,-0.91000000f,-0.17000000f,-0.21000000f,-0.89000000f,-0.24000000f,0.40000000f,-0.43000000f,-0.31000000f,0.45000000f,0.74000000f,0.77000000f,-0.98000000f,0.53000000f,0.87000000f,-0.42000000f,-0.37000000f,-0.95000000f,0.02000000f,-0.03000000f,0.21000000f,-0.39000000f,-0.27000000f,-0.66000000f,0.62000000f,-0.34000000f,0.34000000f,0.89000000f,-0.64000000f,-0.65000000f,-0.51000000f,-0.98000000f,0.14000000f,-0.49000000f,0.27000000f,0.10000000f,-0.71000000f,-0.20000000f,-0.01000000f,-0.51000000f,0.50000000f,-0.30000000f,0.98000000f,-0.46000000f,0.10000000f,-0.60000000f,-0.71000000f,-0.95000000f,0.49000000f,0.59000000f,0.00000000f,-0.19000000f,0.11000000f,-0.41000000f,0.08000000f,-0.50000000f,0.48000000f,0.19000000f,-0.80000000f,0.55000000f,-0.27000000f,0.14000000f,-0.66000000f,0.04000000f,-0.16000000f,-0.40000000f,0.18000000f,-0.50000000f,0.89000000f,-0.98000000f,0.27000000f,-0.39000000f,0.91000000f,-0.07000000f,-0.88000000f,-0.76000000f,-0.34000000f,0.10000000f,0.80000000f,-0.05000000f,-0.31000000f,-0.87000000f,0.65000000f,0.26000000f,-0.62000000f,0.55000000f,0.57000000f,-0.98000000f,0.11000000f,0.14000000f,-0.63000000f,-0.39000000f,0.13000000f,-0.87000000f,-0.60000000f,0.92000000f,-0.08000000f,-0.88000000f,0.08000000f,-0.82000000f,-0.12000000f,0.71000000f,0.41000000f,-0.81000000f,0.17000000f,0.16000000f,-0.52000000f,-0.44000000f,-0.58000000f,0.24000000f,-0.16000000f,0.42000000f,-0.87000000f,-0.41000000f,0.86000000f,0.51000000f,-0.42000000f,0.57000000f,0.44000000f,-0.90000000f,-0.37000000f,-0.11000000f,-0.13000000f,0.12000000f,-0.13000000f,-0.80000000f,-0.44000000f,-0.12000000f,0.76000000f,-0.65000000f,-0.00000000f,0.94000000f,-0.49000000f,0.64000000f,-0.20000000f,-0.02000000f,-0.30000000f,-0.70000000f,0.81000000f,0.37000000f,-0.12000000f,0.06000000f,-0.73000000f,-0.99000000f,-0.24000000f,0.66000000f,0.32000000f,-0.94000000f,0.29000000f,0.47000000f,0.32000000f,-0.20000000f,0.90000000f,0.37000000f,0.14000000f,-0.65000000f,-0.30000000f,0.03000000f,-0.81000000f,-0.85000000f,-0.45000000f,0.95000000f,0.52000000f,-0.64000000f,0.70000000f,-0.32000000f,-0.50000000f,0.34000000f,0.33000000f,0.44000000f,0.94000000f,0.39000000f,0.78000000f,-0.99000000f,0.35000000f,-0.04000000f,0.56000000f,-0.65000000f,0.33000000f,-0.57000000f,0.23000000f,-0.17000000f,-0.97000000f,0.70000000f,-0.68000000f,-0.23000000f,-0.60000000f,0.20000000f,-0.93000000f,0.00000000f,0.16000000f,0.92000000f,-0.19000000f,0.72000000f,0.28000000f,0.55000000f,0.97000000f,0.44000000f,-0.40000000f,-0.03000000f,0.86000000f,0.27000000f,0.31000000f,-0.50000000f,0.16000000f,0.03000000f,-0.49000000f,-0.09000000f,-0.64000000f,-0.17000000f,-0.01000000f,0.88000000f,0.07000000f,0.45000000f,-0.45000000f,-0.36000000f,-0.40000000f,0.69000000f,-0.54000000f,-0.44000000f,-0.74000000f,0.00000000f,-0.49000000f,-0.40000000f,-0.92000000f,0.16000000f,-0.21000000f,-0.39000000f,-0.26000000f,-0.63000000f,0.14000000f,-0.53000000f,0.31000000f,-0.83000000f,0.33000000f,0.31000000f,0.06000000f,-0.88000000f,0.12000000f,-0.20000000f,0.63000000f,0.35000000f,0.79000000f,-0.25000000f,0.77000000f,-0.79000000f,0.16000000f,0.64000000f,-0.49000000f,-0.14000000f,0.09000000f,-0.00000000f,0.46000000f,-0.96000000f,-0.00000000f,0.67000000f,0.74000000f,-0.23000000f,-0.25000000f,-0.16000000f,0.45000000f,-0.87000000f,0.73000000f,0.89000000f,-0.40000000f,0.85000000f,0.70000000f,-0.98000000f,0.11000000f,0.27000000f,0.64000000f,0.22000000f,-0.38000000f,0.80000000f,-0.38000000f,0.98000000f,0.87000000f,0.96000000f,0.54000000f,0.88000000f,0.46000000f,0.00000000f,-0.08000000f,0.94000000f,0.02000000f,-0.97000000f,0.16000000f,-0.04000000f,0.44000000f,-0.45000000f,-0.58000000f,0.38000000f,-0.49000000f,0.93000000f,0.78000000f,0.84000000f,-0.35000000f,0.28000000f,0.96000000f,0.16000000f,-0.58000000f,0.32000000f,0.34000000f,-0.43000000f,0.34000000f,0.68000000f,0.92000000f,-0.69000000f,0.48000000f,0.42000000f,-0.13000000f,-0.54000000f,0.09000000f,0.70000000f,-0.85000000f,0.74000000f,-0.55000000f,-0.18000000f,0.45000000f,-0.49000000f,0.12000000f,0.33000000f,-0.49000000f,-0.68000000f,-0.67000000f,0.60000000f,0.61000000f,-0.87000000f,0.13000000f,0.68000000f,-0.56000000f,0.83000000f,-0.16000000f,0.26000000f,-0.18000000f,-0.80000000f,-0.47000000f,0.80000000f,-0.25000000f,0.36000000f,-0.12000000f,-0.98000000f,0.78000000f,-0.58000000f,0.76000000f,-0.25000000f,0.34000000f,0.42000000f,0.76000000f,0.09000000f,-0.97000000f,0.57000000f,0.01000000f,0.82000000f,0.02000000f,-0.67000000f,-0.15000000f,0.99000000f,-0.27000000f,0.19000000f,-0.16000000f,-0.28000000f,-0.70000000f,0.17000000f,0.68000000f,0.00000000f,0.81000000f,-0.88000000f,-0.43000000f,-0.71000000f,-0.90000000f,-0.12000000f,-0.31000000f,-0.15000000f,-0.12000000f,-0.44000000f,0.58000000f,0.26000000f,-0.41000000f,-0.23000000f,-0.06000000f,-0.71000000f,-0.21000000f,0.66000000f,-0.27000000f,0.31000000f,0.55000000f,-0.43000000f,-0.23000000f,-0.98000000f,0.17000000f,-0.03000000f,0.66000000f,0.13000000f,0.41000000f,-0.20000000f,-0.93000000f,-0.33000000f,-0.25000000f,0.23000000f,-0.15000000f,0.19000000f,0.73000000f,0.24000000f,-0.49000000f,0.16000000f,0.24000000f,-0.12000000f,-0.21000000f,-0.61000000f,-0.11000000f,-0.23000000f,-0.98000000f,-0.51000000f,0.19000000f,0.09000000f,0.32000000f,0.99000000f,0.28000000f,0.19000000f,0.66000000f,0.74000000f,0.89000000f,-0.10000000f,0.04000000f,-0.12000000f,0.79000000f,0.36000000f,0.17000000f,0.51000000f,-0.66000000f,-0.09000000f,0.75000000f,-0.88000000f,-0.67000000f,-0.74000000f,-0.63000000f,-0.36000000f,-0.93000000f,0.61000000f,-0.12000000f,-0.00000000f,0.06000000f,0.58000000f,-0.27000000f,0.73000000f,-0.97000000f,-0.03000000f,-0.97000000f,0.99000000f,-0.11000000f,-0.55000000f,-0.59000000f,-0.44000000f,-0.90000000f,-0.13000000f,0.20000000f,0.85000000f,0.90000000f,0.38000000f,-0.46000000f,-0.41000000f,0.18000000f,-0.87000000f,-0.82000000f,0.61000000f,-0.75000000f,0.20000000f,-0.74000000f,-0.68000000f,-0.22000000f,-0.21000000f,0.68000000f,-0.00000000f,0.38000000f,-0.50000000f,-0.21000000f,0.11000000f,0.94000000f,-0.98000000f,0.59000000f,-0.69000000f,-0.36000000f,0.92000000f,-0.76000000f,-0.73000000f,-0.29000000f,0.23000000f,-0.52000000f,0.18000000f,0.26000000f,0.37000000f,0.08000000f,0.35000000f,-0.61000000f,0.71000000f,0.36000000f,0.00000000f,-0.67000000f,0.57000000f,0.63000000f,-0.04000000f,0.06000000f,-0.96000000f,0.40000000f,0.37000000f,0.86000000f,0.05000000f,0.49000000f,0.78000000f,-0.47000000f,-0.90000000f,0.53000000f,-0.30000000f,-0.57000000f,-0.72000000f,0.25000000f,0.06000000f,0.98000000f,0.89000000f,-0.66000000f,-0.83000000f,0.55000000f,0.35000000f,0.84000000f,0.27000000f,-0.56000000f,-0.40000000f,-0.56000000f,-0.40000000f,-0.83000000f,0.69000000f,-0.05000000f,-0.39000000f,0.87000000f,-0.81000000f,-0.29000000f,-0.94000000f,0.10000000f,-0.32000000f,-0.48000000f,0.43000000f,-0.40000000f,-0.64000000f,0.31000000f,0.98000000f,-0.96000000f,-0.99000000f,-0.70000000f,0.23000000f,0.95000000f,-0.59000000f,-0.04000000f,-0.06000000f,0.95000000f,-0.52000000f,0.18000000f,0.79000000f,-0.28000000f,-0.30000000f,-0.23000000f,0.66000000f,0.49000000f,-0.21000000f,-0.84000000f,-0.27000000f,0.85000000f,0.12000000f,0.05000000f,0.39000000f,-0.21000000f,0.49000000f,-0.28000000f,-0.07000000f,0.96000000f,0.00000000f,0.78000000f,-0.54000000f,0.75000000f,0.15000000f,0.14000000f,-0.21000000f,-0.19000000f,0.06000000f,0.42000000f,0.34000000f,-0.41000000f,0.11000000f,0.44000000f,-0.02000000f,0.89000000f,0.56000000f,-0.78000000f,0.75000000f,0.06000000f,-0.22000000f,-0.32000000f,-0.78000000f,-0.52000000f,-0.46000000f,0.64000000f,-0.31000000f,-0.53000000f,-0.20000000f,0.66000000f,0.29000000f,0.91000000f,-0.84000000f,-0.82000000f,0.67000000f,-0.92000000f,-0.56000000f,0.26000000f,-0.42000000f,-0.93000000f,0.13000000f,0.90000000f,-0.20000000f,-0.40000000f,0.56000000f,-0.60000000f,0.39000000f,-0.01000000f,0.67000000f,-0.77000000f,-0.70000000f,0.30000000f,-0.21000000f,0.04000000f,-0.05000000f,-0.70000000f,0.87000000f,-0.99000000f,0.23000000f,-0.11000000f,-0.99000000f,-0.72000000f,0.22000000f,0.82000000f,0.59000000f,-0.20000000f,-0.40000000f,0.28000000f,-0.91000000f,-0.44000000f,-0.49000000f,0.67000000f,0.33000000f,0.15000000f,-0.09000000f,-0.77000000f,-0.65000000f,-0.95000000f,0.39000000f,-0.02000000f,-0.08000000f,-0.60000000f,0.10000000f,-0.72000000f,0.51000000f,-0.17000000f,-0.80000000f,-0.07000000f,0.92000000f,-0.81000000f,0.65000000f,0.86000000f,0.51000000f,-0.99000000f,0.32000000f,-0.47000000f,-0.37000000f,-0.95000000f,0.59000000f,-0.46000000f,-0.63000000f,0.84000000f,0.84000000f,-0.61000000f,0.97000000f,0.17000000f,0.48000000f,0.94000000f,-0.02000000f,0.98000000f,0.19000000f,0.16000000f,0.40000000f,0.16000000f,-0.40000000f,-0.94000000f,-0.61000000f,0.49000000f,-0.60000000f,0.52000000f,-0.62000000f,0.91000000f,0.67000000f,0.25000000f,0.68000000f,-0.03000000f,-0.03000000f,0.31000000f,-0.16000000f,0.72000000f,0.28000000f,-0.13000000f,-0.10000000f,-0.47000000f,-0.49000000f,-0.79000000f,-0.24000000f,-0.39000000f,-0.93000000f,-0.93000000f,-0.64000000f,0.79000000f,0.06000000f,-0.73000000f,-0.05000000f,-0.77000000f,-0.42000000f,-0.10000000f,-0.28000000f,-0.26000000f,0.58000000f,0.07000000f,0.80000000f,0.52000000f,-0.68000000f,0.86000000f,-0.35000000f,0.79000000f,0.50000000f,-0.83000000f,-0.52000000f,0.75000000f,-0.54000000f,0.49000000f,0.17000000f,0.29000000f,0.45000000f,-0.50000000f,-0.08000000f,0.81000000f,0.98000000f,0.57000000f,-0.57000000f,-0.73000000f,-0.54000000f,-0.94000000f,-0.91000000f,0.13000000f,0.74000000f,-0.31000000f,-0.23000000f,-0.85000000f,-0.98000000f,-0.88000000f,-0.98000000f,0.70000000f,-0.92000000f,0.85000000f,-0.96000000f,-0.71000000f,0.46000000f,0.07000000f,-0.41000000f,0.80000000f,0.35000000f,0.64000000f,0.50000000f,-0.57000000f,0.86000000f,0.13000000f,0.09000000f,-0.13000000f,0.78000000f,0.51000000f,0.66000000f,0.18000000f,0.63000000f,0.66000000f,0.05000000f,0.06000000f,-0.87000000f,-0.33000000f,-0.19000000f,-0.55000000f,0.94000000f,-0.52000000f,-0.74000000f,0.21000000f,0.33000000f,0.50000000f,0.90000000f,0.53000000f,0.80000000f,0.53000000f,-0.15000000f,0.02000000f,-0.84000000f,-0.14000000f,0.19000000f,0.51000000f,0.26000000f,0.16000000f,-0.88000000f,0.98000000f,-0.73000000f,0.28000000f,0.64000000f,-0.76000000f,0.20000000f,-0.74000000f,0.09000000f,0.21000000f,-0.67000000f,0.63000000f,-0.74000000f,0.18000000f,-0.03000000f,-0.25000000f,-0.42000000f,0.76000000f,-0.79000000f,0.98000000f,-0.48000000f,0.94000000f,0.10000000f,0.36000000f,0.47000000f,-0.56000000f,-0.69000000f,-0.74000000f,0.37000000f,0.49000000f,0.78000000f,-0.57000000f,0.14000000f,-0.83000000f,0.15000000f,-0.88000000f,0.91000000f,0.25000000f,-0.89000000f,-0.98000000f,-0.67000000f,0.74000000f,0.53000000f,-0.50000000f,-0.54000000f,-0.94000000f,-0.93000000f,0.69000000f,0.15000000f,0.76000000f,0.60000000f,0.86000000f,-0.96000000f,-0.52000000f,0.84000000f,-0.73000000f,0.10000000f,0.35000000f,-0.13000000f,0.53000000f,0.43000000f,0.19000000f,-0.59000000f,-0.02000000f,0.43000000f,0.50000000f,-0.18000000f,0.03000000f,-0.13000000f,-0.21000000f,0.46000000f,-0.07000000f,-0.99000000f,0.94000000f,-0.16000000f,-0.43000000f,0.25000000f,-0.55000000f,-0.77000000f,-0.13000000f,-0.99000000f,0.98000000f,0.69000000f,0.92000000f,-0.77000000f,-0.89000000f,-0.03000000f,0.03000000f,-0.10000000f,0.48000000f,0.47000000f,-0.95000000f,0.87000000f,-0.12000000f,0.56000000f,0.36000000f,0.56000000f,-0.04000000f,-0.97000000f,0.57000000f,-0.85000000f,-0.45000000f,0.48000000f,-0.54000000f,0.90000000f,-0.46000000f,0.49000000f,-0.02000000f,0.25000000f,-0.83000000f,0.77000000f,-0.38000000f,0.09000000f,0.35000000f,0.89000000f,-0.79000000f,-0.79000000f,0.13000000f,-0.14000000f,-0.27000000f,-0.49000000f,0.46000000f,0.43000000f,-0.91000000f,-0.79000000f,-0.67000000f,-0.15000000f,0.73000000f,0.88000000f,0.17000000f,-0.03000000f,0.22000000f,0.43000000f,0.47000000f,-0.72000000f,0.38000000f,0.23000000f,-0.28000000f,-0.14000000f,-0.02000000f,-0.23000000f,0.47000000f,0.48000000f,-0.11000000f,-0.42000000f,-0.19000000f,0.20000000f,-0.84000000f,0.91000000f,-0.17000000f,-0.52000000f,0.46000000f,-0.53000000f,0.55000000f,-0.29000000f,0.80000000f,-0.94000000f,-0.24000000f,0.53000000f,0.18000000f,0.52000000f,-0.91000000f,-0.47000000f,-0.98000000f,0.82000000f,0.81000000f,0.89000000f,-0.94000000f,-0.18000000f,0.26000000f,0.98000000f,-0.97000000f,-0.99000000f,-0.82000000f,0.67000000f,-0.88000000f,0.76000000f,-0.73000000f,0.25000000f,0.82000000f,-0.27000000f,-0.16000000f,0.35000000f,-0.61000000f,0.39000000f,0.79000000f,-0.57000000f,-0.41000000f,-0.56000000f,-0.35000000f,0.26000000f,-0.34000000f,0.74000000f,-0.10000000f,0.98000000f,-0.55000000f,-0.38000000f,-0.91000000f,-0.06000000f,-0.85000000f,0.62000000f,-0.34000000f,0.51000000f,-0.83000000f,0.91000000f,-0.09000000f,-0.54000000f,-0.79000000f,-0.37000000f,0.79000000f,0.74000000f,-0.86000000f,-0.52000000f,0.45000000f,0.04000000f,0.65000000f,-0.26000000f,0.70000000f,0.88000000f,-0.13000000f,0.36000000f,0.23000000f,0.06000000f,0.73000000f,0.16000000f,-0.53000000f,-0.91000000f,-0.56000000f,-0.07000000f,0.72000000f,-0.17000000f,-0.13000000f,0.56000000f,0.11000000f,0.19000000f,0.46000000f,-0.31000000f,0.76000000f,0.95000000f,0.68000000f,0.12000000f,0.60000000f,-0.20000000f,-0.89000000f,0.80000000f,0.78000000f,-0.21000000f,-0.04000000f,0.79000000f,-0.18000000f,0.28000000f,-0.37000000f,-0.39000000f,0.92000000f,-0.73000000f,-0.55000000f,-0.32000000f,-0.15000000f,-0.20000000f,-0.59000000f,0.71000000f,0.57000000f,-0.60000000f,-0.58000000f,-0.36000000f,0.05000000f,0.22000000f,0.08000000f,-0.37000000f,-0.73000000f,0.00000000f,0.99000000f,-0.44000000f,-0.83000000f,0.30000000f,-0.39000000f,-0.49000000f,0.40000000f,-0.33000000f,-0.64000000f,-0.07000000f,0.24000000f,-0.80000000f,0.38000000f,0.65000000f,0.18000000f,0.88000000f,0.99000000f,-0.18000000f,-0.08000000f,0.45000000f,-0.76000000f,-0.30000000f,0.87000000f,0.24000000f,-0.21000000f,-0.28000000f,0.62000000f,-0.71000000f,0.57000000f,0.92000000f,0.01000000f,0.70000000f,0.44000000f,-0.77000000f,-0.47000000f,-0.70000000f,0.72000000f,-0.67000000f,-0.60000000f,0.08000000f,-0.26000000f,0.26000000f,0.16000000f,-0.94000000f,-0.06000000f,0.46000000f,0.98000000f,-0.90000000f,0.17000000f,-0.45000000f,-0.43000000f,-0.00000000f,0.71000000f,-0.82000000f,-0.59000000f,-0.44000000f,0.03000000f,0.98000000f,-0.85000000f,-0.33000000f,0.45000000f,0.22000000f,-0.04000000f,0.59000000f,0.87000000f,0.91000000f,0.97000000f,-0.97000000f,0.69000000f,-0.60000000f,0.61000000f,-0.59000000f,-0.56000000f,-0.71000000f,-0.35000000f,0.13000000f,0.06000000f,0.81000000f,-0.19000000f,0.45000000f,0.56000000f,-0.03000000f,0.09000000f,0.28000000f,-0.75000000f,0.97000000f,0.70000000f,0.98000000f,-0.56000000f,-0.62000000f,0.52000000f,-0.57000000f,0.48000000f,0.04000000f,-0.31000000f,-0.60000000f,-0.22000000f,-0.39000000f,0.05000000f,-0.27000000f,0.15000000f,-0.40000000f,-0.47000000f,0.74000000f,0.14000000f,0.96000000f,-0.35000000f,-0.12000000f,-0.95000000f,0.32000000f,-0.99000000f,0.06000000f,-0.22000000f,-0.82000000f,-0.89000000f,0.89000000f,0.00000000f,0.98000000f,-0.90000000f,0.48000000f,0.79000000f,0.87000000f,0.10000000f,-0.29000000f,0.79000000f,-0.88000000f,-0.07000000f,-0.95000000f,-0.70000000f,0.06000000f,-0.44000000f,0.17000000f,0.94000000f,0.54000000f,0.56000000f,0.83000000f,-0.89000000f,0.80000000f,-0.41000000f,0.40000000f,-0.13000000f,0.44000000f,-0.20000000f,-0.29000000f,0.59000000f,-0.58000000f,-0.80000000f,-0.37000000f,-0.33000000f,-0.10000000f,-0.51000000f,-0.90000000f,-0.16000000f,-0.14000000f,0.97000000f,0.06000000f,0.77000000f,-0.70000000f,-0.70000000f,0.30000000f,-0.36000000f,-0.17000000f,-0.17000000f,0.70000000f,0.25000000f,0.24000000f,-0.14000000f,0.22000000f,0.81000000f,-0.16000000f,0.07000000f,-0.89000000f,0.29000000f,-0.60000000f,-0.95000000f,0.26000000f,-0.20000000f,-0.04000000f,-0.90000000f,0.55000000f,0.80000000f,-0.66000000f,0.51000000f,0.59000000f,0.71000000f,-0.51000000f,0.73000000f,0.89000000f,-0.74000000f,0.88000000f,0.70000000f,0.08000000f,0.61000000f,-0.83000000f,-0.89000000f,-0.93000000f,0.34000000f,-0.41000000f,0.85000000f,-0.74000000f,-0.46000000f,-0.48000000f,0.05000000f,0.86000000f,-0.23000000f,0.82000000f,0.92000000f,-0.41000000f,-0.61000000f,-0.76000000f,0.22000000f,-0.80000000f,-0.29000000f,0.18000000f,-0.05000000f,-0.96000000f,-0.47000000f,0.74000000f,0.81000000f,-0.73000000f,0.69000000f,-0.74000000f,-0.05000000f,-0.80000000f,-0.89000000f,0.13000000f,-0.50000000f,-0.40000000f,0.16000000f,0.03000000f,0.85000000f,-0.23000000f,0.63000000f,0.88000000f,-0.77000000f,-0.58000000f,0.47000000f,-0.70000000f,-0.40000000f,0.61000000f,0.62000000f,-0.23000000f,-0.46000000f,-0.19000000f,0.14000000f,-0.18000000f,0.67000000f,0.21000000f,-0.57000000f,-0.75000000f,-0.04000000f,0.20000000f,0.82000000f,-0.18000000f,-0.44000000f,-0.48000000f,0.11000000f,0.50000000f,-0.60000000f,0.67000000f,-0.60000000f,0.48000000f,0.58000000f,-0.92000000f,0.20000000f,-0.86000000f,0.48000000f,-0.87000000f,0.47000000f,-0.43000000f,0.04000000f,-0.90000000f,-0.50000000f,-0.79000000f,-0.28000000f,-0.25000000f,-0.20000000f,0.49000000f,-0.01000000f,0.28000000f,0.83000000f,-0.03000000f,-0.32000000f,-0.72000000f,0.76000000f,0.80000000f,-0.53000000f,-0.64000000f,-0.34000000f,0.59000000f,-0.81000000f,0.20000000f,0.10000000f,-0.13000000f,-0.40000000f,-0.51000000f,-0.57000000f,0.13000000f,0.93000000f,0.89000000f,-0.03000000f,-0.09000000f,-0.96000000f,-0.41000000f,-0.32000000f,0.14000000f,-0.94000000f,-0.21000000f,0.51000000f,0.03000000f,-0.50000000f,0.54000000f,-0.52000000f,-0.23000000f,0.22000000f,-0.73000000f,-0.49000000f,-0.80000000f,-0.84000000f,-0.26000000f,0.53000000f,-0.61000000f,0.81000000f,-0.80000000f,0.83000000f,0.35000000f,0.49000000f,-0.39000000f,-0.10000000f,0.64000000f,0.12000000f,0.65000000f,0.78000000f,-0.84000000f,-0.32000000f,0.01000000f,-0.38000000f,-0.98000000f,-0.75000000f,0.68000000f,0.16000000f,0.56000000f,-0.23000000f,-0.87000000f,0.37000000f,0.19000000f,0.71000000f,-0.73000000f,0.07000000f,-0.17000000f,0.20000000f,0.08000000f,0.33000000f,-0.49000000f,0.67000000f,-0.58000000f,-0.14000000f,-0.60000000f,-0.89000000f,-0.58000000f,-0.06000000f,0.11000000f,-0.14000000f,0.94000000f,-0.81000000f,-0.54000000f,-0.63000000f,-0.89000000f,-0.35000000f,0.90000000f,0.73000000f,0.67000000f,-0.27000000f,-0.36000000f,0.00000000f,0.11000000f,0.48000000f,0.38000000f,-0.78000000f,0.90000000f,-0.36000000f,-0.74000000f,-0.50000000f,0.90000000f,-0.77000000f,0.78000000f,-0.08000000f,0.76000000f,-0.91000000f,-0.97000000f,-0.38000000f,-0.00000000f,0.59000000f,0.79000000f,-0.53000000f,0.21000000f,0.34000000f,-0.79000000f,0.90000000f,-0.42000000f,-0.14000000f,-0.44000000f,-0.25000000f,-0.29000000f,0.34000000f,-0.08000000f,0.76000000f,0.53000000f,0.24000000f,0.07000000f,0.01000000f,-0.29000000f,-0.76000000f,-0.43000000f,-0.40000000f,0.23000000f,-0.66000000f,0.62000000f,0.79000000f,-0.07000000f,-0.26000000f,0.62000000f,-0.18000000f,-0.66000000f,0.90000000f,0.19000000f,0.58000000f,0.59000000f,-0.24000000f,-0.75000000f,-0.30000000f,0.13000000f,0.68000000f,0.08000000f,0.00000000f,-0.00000000f,0.81000000f,-0.56000000f,0.41000000f,0.58000000f,0.50000000f,-0.40000000f,0.59000000f,-0.45000000f,-0.56000000f,0.66000000f,0.02000000f,0.74000000f,-0.27000000f,0.70000000f,-0.50000000f,-0.76000000f,0.24000000f,0.94000000f,-0.61000000f,0.74000000f,-0.95000000f,0.76000000f,-0.24000000f,0.09000000f,0.87000000f,-0.02000000f,-0.73000000f,-0.43000000f,-0.26000000f,0.39000000f,-0.78000000f,-0.50000000f,-0.52000000f,-0.84000000f,-0.81000000f,-0.51000000f,0.86000000f,-0.27000000f,0.27000000f,-0.92000000f,0.39000000f,0.02000000f,0.12000000f,-0.47000000f,-0.75000000f,-0.69000000f,0.00000000f,-0.46000000f,0.19000000f,0.21000000f,-0.75000000f,0.65000000f,0.12000000f,0.74000000f,-0.92000000f,-0.88000000f,0.68000000f,0.85000000f,-0.38000000f,-0.68000000f,0.43000000f,-0.88000000f,0.12000000f,-0.02000000f,-0.77000000f,0.27000000f,0.40000000f,0.53000000f,0.95000000f,0.99000000f,0.56000000f,0.62000000f,-0.68000000f,-0.69000000f,-0.87000000f,0.09000000f,-0.91000000f,-0.25000000f,-0.66000000f,0.19000000f,-0.69000000f,-0.54000000f,0.46000000f,0.21000000f,-0.76000000f,0.84000000f,-0.83000000f,-0.30000000f,-0.30000000f,0.16000000f,0.38000000f,0.39000000f,-0.04000000f,0.32000000f,-0.68000000f,-0.43000000f,0.27000000f,0.08000000f,0.41000000f,0.93000000f,-0.61000000f,-0.54000000f,0.52000000f,-0.99000000f,0.04000000f,0.74000000f,-0.26000000f,0.25000000f,-0.28000000f,-0.60000000f,0.52000000f,-0.68000000f,0.75000000f,-0.62000000f,-0.32000000f,-0.51000000f,-0.69000000f,-0.61000000f,0.90000000f,-0.71000000f,0.81000000f,-0.20000000f,0.24000000f,0.92000000f,-0.25000000f,-0.76000000f,0.88000000f,0.88000000f,0.42000000f,-0.21000000f,0.11000000f,0.33000000f,-0.09000000f,0.01000000f,-0.72000000f,0.96000000f,0.20000000f,-0.70000000f,-0.59000000f,0.48000000f,-0.03000000f,0.42000000f,0.54000000f,0.67000000f,-0.21000000f,-0.13000000f,0.55000000f,-0.11000000f,0.26000000f,0.52000000f,0.83000000f,0.76000000f,0.21000000f,0.51000000f,-0.35000000f,0.49000000f,0.04000000f,-0.62000000f,0.88000000f,0.04000000f,0.00000000f,0.33000000f,-0.68000000f,0.72000000f,0.78000000f,-0.69000000f,0.54000000f,0.04000000f,-0.69000000f,-0.51000000f,0.56000000f,-0.05000000f,-0.68000000f,0.16000000f,0.62000000f,-0.90000000f,0.77000000f,-0.25000000f,-0.78000000f,0.25000000f,-0.86000000f,0.72000000f,-0.82000000f,-0.13000000f,-0.23000000f,0.77000000f,-0.06000000f,0.13000000f,0.29000000f,-0.79000000f,0.13000000f,-0.77000000f,-0.56000000f,-0.22000000f,-0.17000000f,-0.20000000f,-0.35000000f,0.91000000f,-0.92000000f,0.70000000f,-0.07000000f,0.99000000f,-0.44000000f,0.00000000f,-0.91000000f,0.36000000f,-0.69000000f,-0.97000000f,0.97000000f,-0.15000000f,0.76000000f,0.78000000f,-0.36000000f,-0.46000000f,0.43000000f,0.78000000f,-0.08000000f,-0.36000000f,0.91000000f,-0.15000000f,-0.49000000f,0.89000000f,-0.47000000f,-0.88000000f,0.32000000f,-0.35000000f,0.46000000f,0.86000000f,0.19000000f,0.87000000f,0.76000000f,0.41000000f,0.87000000f,0.71000000f,0.11000000f,0.78000000f,-0.87000000f,0.70000000f,-0.29000000f,-0.32000000f,0.01000000f,-0.68000000f,0.19000000f,-0.59000000f,-0.04000000f,0.89000000f,-0.46000000f,0.46000000f,-0.82000000f,0.02000000f,0.35000000f,-0.93000000f,-0.46000000f,0.58000000f,0.03000000f,-0.81000000f,0.27000000f,-0.90000000f,-0.33000000f,-0.93000000f,-0.47000000f,-0.42000000f,-0.27000000f,-0.49000000f,0.82000000f,0.12000000f,0.82000000f,0.29000000f,-0.35000000f,0.74000000f,0.00000000f,-0.70000000f,0.45000000f,-0.19000000f,0.05000000f,-0.39000000f,-0.84000000f,-0.99000000f,-0.22000000f,-0.71000000f,-0.60000000f,-0.54000000f,0.21000000f,0.61000000f,0.18000000f,0.08000000f,0.19000000f,-0.06000000f,-0.98000000f,0.21000000f,-0.78000000f,0.15000000f,0.68000000f,-0.53000000f,0.31000000f,0.89000000f,-0.01000000f,-0.73000000f,0.02000000f,0.40000000f,-0.37000000f,0.23000000f,-0.95000000f,0.62000000f,0.84000000f,-0.35000000f,-0.63000000f,0.96000000f,-0.47000000f,0.14000000f,0.80000000f,-0.68000000f,0.29000000f,0.99000000f,0.49000000f,-0.01000000f,0.16000000f,0.19000000f,-0.38000000f,0.63000000f,-0.93000000f,-0.31000000f,0.83000000f,-0.64000000f,-0.72000000f,0.49000000f,-0.87000000f,0.09000000f,0.89000000f,-0.76000000f,-0.98000000f,0.36000000f,0.71000000f,0.07000000f,0.99000000f,-0.47000000f,-0.41000000f,0.68000000f,0.86000000f,0.77000000f,0.92000000f,-0.79000000f,-0.22000000f,0.24000000f,0.09000000f,-0.45000000f,0.00000000f,0.22000000f,-0.96000000f,-0.50000000f,0.87000000f,0.06000000f,0.93000000f,-0.39000000f,-0.39000000f,-0.39000000f,-0.36000000f,-0.11000000f,0.77000000f,-0.29000000f,0.32000000f,-0.60000000f,-0.69000000f,-0.35000000f,0.12000000f,-0.30000000f,0.66000000f,0.29000000f,-0.45000000f,-0.18000000f,-0.95000000f,0.75000000f,-0.69000000f,-0.71000000f,-0.93000000f,-0.25000000f,-0.36000000f,0.81000000f,-0.79000000f,0.17000000f,0.93000000f,-0.60000000f,-0.98000000f,0.55000000f,-0.87000000f,-0.67000000f,0.32000000f,0.80000000f,0.79000000f,0.62000000f,0.44000000f,-0.19000000f,-0.48000000f,0.34000000f,0.89000000f,0.72000000f,0.37000000f,-0.82000000f,-0.49000000f,-0.71000000f,-0.40000000f,-0.08000000f,-0.05000000f,-0.30000000f,-0.46000000f,0.50000000f,0.24000000f,0.85000000f,-0.95000000f,-0.62000000f,-0.45000000f,-0.09000000f,0.42000000f,-0.95000000f,-0.20000000f,0.21000000f,-0.50000000f,0.39000000f,-0.38000000f,-0.74000000f,0.69000000f,-0.65000000f,0.43000000f,0.60000000f,-0.48000000f,-0.81000000f,-0.14000000f,-0.90000000f,0.56000000f,0.42000000f,0.39000000f,-0.13000000f,0.76000000f,0.06000000f,-0.46000000f,-0.55000000f,0.60000000f,0.72000000f,-0.05000000f,-0.20000000f,-0.17000000f,-0.40000000f,0.23000000f,-0.55000000f,0.90000000f,-0.49000000f,0.58000000f,0.34000000f,0.72000000f,-0.72000000f,-0.54000000f,-0.43000000f,-0.80000000f,-0.49000000f,-0.76000000f,-0.76000000f,-0.11000000f,0.55000000f,-0.68000000f,0.14000000f,-0.98000000f,0.20000000f,0.93000000f,0.19000000f,0.52000000f,-0.26000000f,0.89000000f,-0.82000000f,-0.02000000f,-0.47000000f,0.74000000f,-0.94000000f,-0.01000000f,0.90000000f,0.68000000f,0.20000000f,0.36000000f,-0.50000000f,-0.99000000f,0.20000000f,0.05000000f,-0.18000000f,-0.06000000f,-0.39000000f,0.60000000f,-0.12000000f,-0.94000000f,0.89000000f,-0.31000000f,0.00000000f,0.35000000f,0.74000000f,-0.24000000f,-0.88000000f,0.41000000f,-0.78000000f,-0.04000000f,0.38000000f,-0.17000000f,0.93000000f,0.48000000f,0.31000000f,0.60000000f,-0.20000000f,-0.78000000f,0.85000000f,-0.03000000f,0.26000000f,0.88000000f,0.17000000f,0.82000000f,0.39000000f,-0.03000000f,0.10000000f,0.13000000f,0.72000000f,0.15000000f,0.40000000f,-0.39000000f,0.32000000f,0.44000000f,-0.75000000f,-0.64000000f,-0.29000000f,0.77000000f,-0.50000000f,0.74000000f,0.71000000f,-0.08000000f,-0.30000000f,-0.42000000f,0.17000000f,-0.52000000f,0.84000000f,-0.07000000f,-0.89000000f,-0.60000000f,-0.04000000f,0.64000000f,-0.73000000f,-0.10000000f,-0.82000000f,0.87000000f,-0.78000000f,0.23000000f,0.67000000f,-0.98000000f,-0.68000000f,0.66000000f,0.82000000f,0.64000000f,0.40000000f,0.55000000f,0.91000000f,-0.02000000f,0.01000000f,0.13000000f,-0.82000000f,-0.86000000f,0.79000000f,-0.06000000f,-0.58000000f,0.75000000f,0.99000000f,-0.05000000f,0.32000000f,-0.07000000f,0.97000000f,0.49000000f,0.40000000f,0.42000000f,0.86000000f,-0.62000000f,0.54000000f,0.57000000f,0.90000000f,-0.76000000f,0.54000000f,-0.61000000f,0.32000000f,0.66000000f,0.21000000f,-0.24000000f,-0.70000000f,0.02000000f,0.27000000f,0.78000000f,-0.45000000f,0.29000000f,0.18000000f,-0.06000000f,0.78000000f,0.38000000f,-0.41000000f,0.14000000f,0.50000000f,-0.43000000f,-0.45000000f,0.68000000f,-0.30000000f,-0.79000000f,-0.88000000f,0.57000000f,-0.06000000f,0.36000000f,0.16000000f,0.14000000f,0.48000000f,-0.27000000f,0.46000000f,-0.78000000f,-0.23000000f,0.20000000f,0.34000000f,0.26000000f,0.34000000f,-0.40000000f,0.07000000f,0.00000000f,0.28000000f,-0.92000000f,-0.23000000f,0.46000000f,-0.60000000f,-0.69000000f,-0.98000000f,0.49000000f,0.21000000f,-0.65000000f,-0.01000000f,0.56000000f,-0.42000000f,0.88000000f,0.96000000f,0.40000000f,0.60000000f,-0.24000000f,-0.93000000f,-0.82000000f,0.64000000f,0.23000000f,-0.24000000f,0.28000000f,-0.50000000f,0.48000000f,0.23000000f,0.52000000f,0.75000000f,0.30000000f,0.59000000f,-0.63000000f,0.46000000f,0.47000000f,-0.91000000f,0.70000000f,0.29000000f,-0.47000000f,0.12000000f,-0.82000000f,0.72000000f,-0.20000000f,-0.48000000f,0.07000000f,0.39000000f,0.72000000f,0.24000000f,0.44000000f,0.79000000f,-0.44000000f,-0.59000000f,0.25000000f,-0.95000000f,-0.60000000f,0.24000000f,-0.40000000f,0.50000000f,-0.05000000f,-0.86000000f,0.49000000f,0.95000000f,0.92000000f,-0.87000000f,0.29000000f,-0.71000000f,-0.14000000f,0.37000000f,0.24000000f,0.91000000f,0.82000000f,-0.64000000f,0.12000000f,-0.39000000f,0.53000000f,-0.95000000f,0.32000000f,0.87000000f,-0.90000000f,0.97000000f,-0.85000000f,0.09000000f,-0.54000000f,-0.75000000f,0.74000000f,-0.59000000f,0.51000000f,-0.23000000f,-0.14000000f,-0.64000000f,0.51000000f,0.39000000f,0.60000000f,0.36000000f,0.16000000f,-0.64000000f,0.27000000f,-0.16000000f,0.32000000f,-0.99000000f,0.77000000f,0.48000000f,-0.71000000f,0.55000000f,0.73000000f,0.44000000f,-0.92000000f,-0.29000000f,0.44000000f,0.10000000f,-0.53000000f,-0.71000000f,-0.09000000f,-0.46000000f,-0.66000000f,-0.31000000f,0.05000000f,0.92000000f,-0.52000000f,0.04000000f,0.94000000f,0.91000000f,0.09000000f,0.03000000f,0.23000000f,-0.88000000f,-0.92000000f,0.91000000f,-0.47000000f,0.04000000f,0.37000000f,-0.75000000f,0.74000000f,0.77000000f,-0.69000000f,-0.02000000f,-0.90000000f,0.64000000f,-0.38000000f,-0.21000000f,0.76000000f,0.71000000f,0.38000000f,-0.89000000f,0.36000000f,-0.17000000f,0.86000000f,0.13000000f,0.45000000f,0.36000000f,-0.06000000f,0.40000000f,0.33000000f,-0.53000000f,-0.47000000f,0.71000000f,0.10000000f,0.63000000f,0.84000000f,-0.22000000f,0.07000000f,0.76000000f,0.98000000f,-0.43000000f,-0.54000000f,0.42000000f,-0.23000000f,-0.75000000f,-0.67000000f,0.62000000f,0.55000000f,0.24000000f,-0.77000000f,-0.45000000f,0.77000000f,0.30000000f,-0.80000000f,-0.47000000f,0.70000000f,0.03000000f,-0.26000000f,-0.10000000f,0.16000000f,0.98000000f,-0.33000000f,-0.64000000f,0.67000000f,0.31000000f,-0.61000000f,-0.09000000f,0.54000000f,-0.23000000f,-0.18000000f,-0.41000000f,-0.32000000f,-0.43000000f,0.35000000f,-0.85000000f,-0.45000000f,0.53000000f,0.24000000f,0.86000000f,-0.45000000f,0.37000000f,0.37000000f,-0.87000000f,-0.44000000f,-0.67000000f,0.66000000f,-0.78000000f,0.84000000f,0.10000000f,0.74000000f,-0.33000000f,-0.74000000f,0.28000000f,0.30000000f,0.43000000f,0.57000000f,0.48000000f,-0.36000000f,-0.84000000f,0.82000000f,0.03000000f,0.36000000f,0.04000000f,0.93000000f,-0.42000000f,0.73000000f,-0.33000000f,0.54000000f,-0.85000000f,0.28000000f,0.19000000f,0.31000000f,-0.06000000f,0.59000000f,0.01000000f,0.46000000f,-0.68000000f,-0.79000000f,-0.91000000f,0.95000000f,-0.04000000f,0.59000000f,0.66000000f,-0.03000000f,-0.35000000f,0.77000000f,0.27000000f,0.48000000f,0.04000000f,-0.91000000f,-0.90000000f,-0.38000000f,-0.43000000f,0.19000000f,0.47000000f,0.10000000f,0.01000000f,-0.15000000f,0.38000000f,0.74000000f,0.24000000f,0.68000000f,0.66000000f,-0.06000000f,-0.09000000f,0.79000000f,0.06000000f,-0.98000000f,-0.26000000f,-0.11000000f,-0.01000000f,-0.63000000f,0.17000000f,-0.20000000f,0.94000000f,0.04000000f,0.15000000f,-0.41000000f,-0.88000000f,0.62000000f,-0.03000000f,-0.95000000f,-0.99000000f,-0.35000000f,-0.79000000f,-0.08000000f,0.13000000f,0.45000000f,-0.79000000f,0.30000000f,-0.97000000f,0.53000000f,-0.87000000f,-0.00000000f,0.41000000f,-0.90000000f,0.46000000f,0.14000000f,-0.71000000f,-0.34000000f,0.06000000f,-0.93000000f,-0.31000000f,-0.91000000f,0.88000000f,0.76000000f,-0.69000000f,0.51000000f,-0.97000000f,0.40000000f,-0.95000000f,0.75000000f,-0.95000000f,-0.33000000f,0.74000000f,-0.86000000f,0.17000000f,0.73000000f,0.70000000f,-0.41000000f,0.11000000f,0.91000000f,0.94000000f,-0.67000000f,0.40000000f,0.18000000f,0.01000000f,0.17000000f,-0.10000000f,0.24000000f,0.54000000f,-0.01000000f,0.30000000f,0.21000000f,0.54000000f,-0.37000000f,-0.56000000f,0.76000000f,-0.57000000f,0.23000000f,-0.87000000f,0.35000000f,0.35000000f,0.84000000f,-0.47000000f,0.32000000f,-0.51000000f,0.45000000f,0.03000000f,0.84000000f,0.02000000f,0.74000000f,0.40000000f,-0.56000000f,0.08000000f,0.36000000f,0.97000000f,0.25000000f,0.03000000f,0.48000000f,-0.03000000f,0.65000000f,0.71000000f,-0.04000000f,0.85000000f,0.05000000f,0.13000000f,-0.08000000f,0.81000000f,0.32000000f,-0.34000000f,-0.79000000f,-0.45000000f,0.77000000f,-0.89000000f,0.79000000f,-0.23000000f,-0.65000000f,-0.43000000f,0.55000000f,0.99000000f,0.68000000f,-0.43000000f,0.25000000f,-0.19000000f,-0.32000000f,-0.03000000f,-0.61000000f,0.01000000f,0.10000000f,0.14000000f,0.82000000f,0.50000000f,0.96000000f,0.24000000f,-0.44000000f,-0.21000000f,0.05000000f,-0.28000000f,0.58000000f,0.29000000f,-0.08000000f,0.83000000f,-0.95000000f,-0.21000000f,-0.49000000f,0.61000000f,-0.37000000f,-0.47000000f,0.50000000f,-0.33000000f,-0.83000000f,0.00000000f,-0.68000000f,0.06000000f,-0.96000000f,-0.74000000f,0.57000000f,0.34000000f,-0.54000000f,-0.77000000f,-0.73000000f,0.84000000f,0.81000000f,-0.90000000f,0.95000000f,0.57000000f,-0.79000000f,0.35000000f,0.54000000f,-0.50000000f,-0.86000000f,0.13000000f,0.16000000f,0.75000000f,0.64000000f,-0.74000000f,-0.72000000f,-0.85000000f,0.87000000f,-0.71000000f,0.43000000f,-0.06000000f,-0.69000000f,0.12000000f,-0.06000000f,0.36000000f,-0.34000000f,0.79000000f,0.02000000f,-0.83000000f,0.91000000f,0.40000000f,0.46000000f,0.90000000f,-0.72000000f,0.02000000f,0.01000000f,-0.45000000f,0.30000000f,-0.12000000f,-0.09000000f,-0.14000000f,0.55000000f,-0.33000000f,0.34000000f,-0.82000000f,0.90000000f,0.45000000f,0.95000000f,-0.62000000f,-0.49000000f,0.06000000f,-0.15000000f,0.66000000f,0.10000000f,-0.92000000f,0.71000000f,0.04000000f,-0.28000000f,-0.83000000f,-0.37000000f,0.18000000f,0.37000000f,0.49000000f,0.82000000f,-0.53000000f,-0.30000000f,0.17000000f,-0.65000000f,-0.06000000f,0.29000000f,-0.89000000f,-0.74000000f,-0.21000000f,-0.85000000f,0.93000000f,-0.51000000f,0.29000000f,-0.86000000f,-0.20000000f,-0.19000000f,0.39000000f,-0.51000000f,0.54000000f,-0.67000000f,0.27000000f,-0.23000000f,0.23000000f,0.43000000f,0.65000000f,0.71000000f,0.95000000f,-0.84000000f,0.84000000f,-0.44000000f,-0.78000000f,0.05000000f,0.84000000f,0.05000000f,-0.54000000f,-0.18000000f,-0.41000000f,-0.80000000f,0.05000000f,-0.41000000f,-0.97000000f,0.34000000f,0.64000000f,-0.94000000f,0.19000000f,0.22000000f,0.85000000f,0.58000000f,0.92000000f,-0.07000000f,-0.41000000f,0.30000000f,-0.01000000f,0.72000000f,-0.28000000f,0.91000000f,0.82000000f,0.92000000f,0.17000000f,-0.08000000f,-0.69000000f,-0.92000000f,0.05000000f,0.45000000f,-0.72000000f,-0.34000000f,0.36000000f,0.35000000f,-0.18000000f,0.55000000f,-0.21000000f,-0.69000000f,-0.60000000f,0.86000000f,0.85000000f,0.47000000f,0.48000000f,0.49000000f,-0.31000000f,0.03000000f,-0.42000000f,-0.28000000f,0.38000000f,-0.94000000f,0.82000000f,0.25000000f,-0.40000000f,-0.95000000f,0.81000000f,-0.21000000f,0.50000000f,-0.55000000f,-0.02000000f,-0.91000000f,-0.10000000f,0.45000000f,-0.30000000f,0.31000000f,0.80000000f,-0.57000000f,0.41000000f,-0.83000000f,0.28000000f,-0.02000000f,0.11000000f,-0.45000000f,0.84000000f,0.03000000f,0.14000000f,0.76000000f,-0.21000000f,-0.04000000f,-0.52000000f,-0.55000000f,-0.03000000f,-0.98000000f,0.48000000f,0.91000000f,-0.39000000f,0.57000000f,0.45000000f,0.29000000f,-0.05000000f,-0.33000000f,-0.65000000f,-0.62000000f,0.98000000f,-0.35000000f,0.61000000f,0.81000000f,0.61000000f,-0.51000000f,0.43000000f,-0.36000000f,0.73000000f,-0.20000000f,-0.18000000f,0.05000000f,0.04000000f,-0.83000000f,0.38000000f,-0.98000000f,-0.62000000f,0.07000000f,0.65000000f,-0.23000000f,0.49000000f,-0.33000000f,-0.85000000f,0.33000000f,-0.51000000f,-0.08000000f,-0.21000000f,0.66000000f,0.84000000f,-0.36000000f,-0.01000000f,0.99000000f,0.48000000f,-0.79000000f,0.18000000f,0.82000000f,0.11000000f,-0.38000000f,-0.49000000f,0.24000000f,0.20000000f,0.16000000f,0.60000000f,-0.33000000f,0.58000000f,0.77000000f,-0.43000000f,-0.65000000f,0.81000000f,0.14000000f,0.36000000f,0.00000000f,-0.87000000f,-0.57000000f,-0.01000000f,-0.02000000f,0.30000000f,0.14000000f,-0.17000000f,0.18000000f,0.17000000f,0.64000000f,0.64000000f,0.57000000f,-0.72000000f,0.12000000f,-0.33000000f,0.73000000f,0.54000000f,-0.36000000f,0.16000000f,0.62000000f,0.01000000f,0.09000000f,0.36000000f,-0.65000000f,-0.72000000f,-0.02000000f,-0.40000000f,0.55000000f,-0.54000000f,-0.20000000f,0.24000000f,0.97000000f,-0.31000000f,0.96000000f,0.74000000f,0.71000000f,0.10000000f,0.79000000f,-0.64000000f,0.17000000f,-0.56000000f,0.27000000f,-0.62000000f,-0.65000000f,0.73000000f,0.17000000f,-0.06000000f,0.67000000f,-0.39000000f,-0.46000000f,0.25000000f,0.64000000f,-0.22000000f,-0.13000000f,0.35000000f,0.70000000f,-0.70000000f,-0.60000000f,-0.14000000f,-0.53000000f,-0.09000000f,0.59000000f,-0.09000000f,-0.12000000f,-0.28000000f,-0.65000000f,0.69000000f,0.48000000f,0.11000000f,-0.82000000f,-0.15000000f,-0.01000000f,0.06000000f,0.96000000f,-0.14000000f,0.51000000f,0.39000000f,0.66000000f,-0.27000000f,-0.52000000f,0.54000000f,-0.87000000f,-0.18000000f,-0.69000000f,-0.19000000f,-0.20000000f,0.19000000f,-0.06000000f,0.27000000f,0.18000000f,-0.26000000f,-0.45000000f,-0.09000000f,0.47000000f,-0.15000000f,-0.05000000f,0.54000000f,0.80000000f,0.86000000f,-0.60000000f,-0.02000000f,0.74000000f,0.07000000f,-0.10000000f,-0.73000000f,0.56000000f,0.67000000f,0.51000000f,0.23000000f,0.69000000f,0.85000000f,0.21000000f,-0.92000000f,0.15000000f,0.53000000f,0.12000000f,0.43000000f,-0.26000000f,-0.50000000f,0.29000000f,0.92000000f,-0.29000000f,-0.25000000f,0.94000000f,-0.92000000f,0.53000000f,0.14000000f,0.93000000f,0.88000000f,0.09000000f,-0.29000000f,0.59000000f,0.98000000f,0.49000000f,0.64000000f,-0.18000000f,-0.75000000f,-0.26000000f,-0.47000000f,0.64000000f,0.87000000f,0.46000000f,-0.51000000f,0.04000000f,-0.46000000f,0.00000000f,-0.67000000f,-0.78000000f,0.05000000f,-0.35000000f,0.21000000f,-0.42000000f,-0.85000000f,0.02000000f,0.78000000f,0.86000000f,-0.93000000f,-0.28000000f,0.54000000f,-0.41000000f,-0.83000000f,0.95000000f,-0.72000000f,0.31000000f,0.67000000f,-0.22000000f,-0.07000000f,0.74000000f,0.26000000f,0.27000000f,-0.78000000f,-0.23000000f,0.57000000f,0.55000000f,-0.27000000f,0.17000000f,0.57000000f,0.63000000f,-0.05000000f,-0.76000000f,-0.25000000f,0.37000000f,-0.29000000f,-0.48000000f,0.92000000f,-0.87000000f,-0.08000000f,-0.68000000f,0.61000000f,0.24000000f,-0.48000000f,-0.70000000f,0.61000000f,-0.01000000f,-0.96000000f,-0.54000000f,0.08000000f,-0.75000000f,0.06000000f,0.60000000f,-0.89000000f,0.34000000f,0.76000000f,-0.25000000f,0.34000000f,-0.94000000f,0.00000000f,0.60000000f,-0.24000000f,-0.10000000f,-0.98000000f,-0.56000000f,-0.74000000f,-0.36000000f,0.27000000f,0.74000000f,0.88000000f,-0.94000000f,0.25000000f,-0.85000000f,-0.39000000f,-0.37000000f,0.25000000f,-0.80000000f,0.10000000f,0.52000000f,-0.53000000f,0.20000000f,0.59000000f,-0.17000000f,-0.57000000f,0.45000000f,0.39000000f,-0.63000000f,0.37000000f,0.45000000f,-0.81000000f,-0.16000000f,0.18000000f,0.66000000f,-0.23000000f,-0.98000000f,-0.81000000f,0.47000000f,0.18000000f,0.24000000f,0.38000000f,-0.79000000f,-0.73000000f,0.28000000f,-0.81000000f,0.39000000f,-0.15000000f,0.93000000f,-0.83000000f,-0.42000000f,-0.70000000f,-0.09000000f,-0.95000000f,0.23000000f,0.25000000f,-0.44000000f,-0.79000000f,-0.68000000f,-0.26000000f,-0.04000000f,0.05000000f,-0.39000000f,-0.23000000f,0.22000000f,-0.25000000f,-0.30000000f,-0.00000000f,-0.03000000f,-0.42000000f,0.94000000f,0.27000000f,0.98000000f,-0.32000000f,0.88000000f,0.49000000f,0.75000000f,0.76000000f,0.02000000f,-0.10000000f,0.26000000f,-0.54000000f,-0.00000000f,-0.91000000f,0.30000000f,0.48000000f,0.30000000f,-0.54000000f,0.58000000f,0.13000000f,0.95000000f,0.43000000f,-0.90000000f,-0.79000000f,0.82000000f,-0.03000000f,0.28000000f,-0.69000000f,0.87000000f,-0.35000000f,-0.34000000f,0.97000000f,-0.17000000f,0.03000000f,0.61000000f,0.32000000f,-0.05000000f,0.47000000f,-0.35000000f,-0.48000000f,-0.50000000f,0.37000000f,0.84000000f,0.50000000f,-0.82000000f,0.26000000f,0.47000000f,-0.36000000f,-0.42000000f,0.58000000f,0.71000000f,0.87000000f,0.59000000f,0.92000000f,0.31000000f,0.66000000f,-0.28000000f,-0.13000000f,-0.19000000f,-0.95000000f,0.57000000f,-0.81000000f,0.95000000f,0.16000000f,0.62000000f,-0.60000000f,-0.03000000f,0.75000000f,0.40000000f,0.40000000f,0.78000000f,0.95000000f,0.59000000f,-0.00000000f,0.79000000f,0.49000000f,-0.76000000f,0.91000000f,-0.76000000f,-0.74000000f,-0.68000000f,0.97000000f,0.98000000f,-0.97000000f,0.91000000f,-0.93000000f,0.47000000f,0.86000000f,0.88000000f,-0.56000000f,0.84000000f,-0.00000000f,0.02000000f,-0.23000000f,0.95000000f,0.58000000f,-0.00000000f,0.84000000f,-0.65000000f,0.77000000f,-0.27000000f,-0.42000000f,-0.54000000f,0.19000000f,-0.77000000f,-0.59000000f,0.81000000f,0.45000000f,0.96000000f,0.39000000f,-0.46000000f,-0.74000000f,-0.59000000f,0.93000000f,-0.12000000f,0.26000000f,-0.74000000f,0.28000000f,-0.83000000f,0.58000000f,0.20000000f,0.25000000f,-0.39000000f,0.85000000f,0.29000000f,0.90000000f,-0.42000000f,0.95000000f,0.49000000f,-0.11000000f,-0.66000000f,0.65000000f,0.91000000f,-0.98000000f,-0.61000000f,-0.72000000f,0.20000000f,0.25000000f,0.39000000f,0.76000000f,-0.13000000f,0.56000000f,0.78000000f,0.90000000f,0.10000000f,0.54000000f,0.49000000f,-0.85000000f,0.50000000f,0.91000000f,-0.72000000f,-0.00000000f,0.80000000f,-0.25000000f,0.07000000f,-0.18000000f,0.87000000f,-0.93000000f,0.02000000f,0.03000000f,-0.15000000f,0.37000000f,0.50000000f,-0.21000000f,-0.17000000f,0.78000000f,-0.40000000f,0.70000000f,-0.96000000f,-0.74000000f,0.05000000f,0.22000000f,-0.04000000f,0.78000000f,0.99000000f,0.65000000f,0.63000000f,0.66000000f,0.40000000f,0.53000000f,-0.91000000f,0.46000000f,0.43000000f,0.18000000f,0.65000000f,-0.58000000f,0.73000000f,0.60000000f,0.57000000f,0.72000000f,0.71000000f,0.15000000f,0.70000000f,-0.47000000f,-0.82000000f,-0.38000000f,0.89000000f,-0.91000000f,0.72000000f,0.13000000f,-0.81000000f,-0.79000000f,-0.58000000f,-0.13000000f,0.28000000f,0.79000000f,0.46000000f,0.34000000f,0.27000000f,0.26000000f,0.00000000f,0.39000000f,0.89000000f,0.24000000f,0.83000000f,0.91000000f,-0.87000000f,-0.49000000f,0.30000000f,-0.11000000f,0.77000000f,-0.97000000f,-0.36000000f,-0.41000000f,-0.68000000f,0.85000000f,0.79000000f,0.30000000f,0.81000000f,-0.57000000f,0.91000000f,-0.04000000f,-0.22000000f,-0.16000000f,0.95000000f,0.60000000f,0.27000000f,-0.73000000f,0.26000000f,-0.18000000f,0.50000000f,-0.79000000f,0.10000000f,-0.69000000f,-0.23000000f,0.07000000f,0.76000000f,-0.41000000f,-0.13000000f,-0.64000000f,-0.15000000f,0.47000000f,-0.03000000f,0.93000000f,0.95000000f,-0.67000000f,0.72000000f,-0.80000000f,-0.17000000f,0.98000000f,0.45000000f,-0.91000000f,0.94000000f,-0.67000000f,0.51000000f,0.81000000f,-0.37000000f,0.49000000f,0.43000000f,0.26000000f,0.83000000f,-0.88000000f,-0.10000000f,0.05000000f,0.41000000f,-0.13000000f,-0.32000000f,0.75000000f,0.37000000f,-0.26000000f,-0.42000000f,-0.41000000f,0.79000000f,0.37000000f,-0.06000000f,0.77000000f,-0.61000000f,0.23000000f,0.57000000f,0.28000000f,0.63000000f,-0.43000000f,-0.09000000f,0.22000000f,-0.86000000f,-0.07000000f,0.22000000f,0.48000000f,-0.05000000f,0.71000000f,-0.98000000f,0.47000000f,0.46000000f,0.02000000f,-0.52000000f,-0.24000000f,0.35000000f,-0.02000000f,-0.30000000f,-0.80000000f,-0.18000000f,-0.81000000f,0.19000000f,-0.74000000f,-0.04000000f,-0.58000000f,-0.51000000f,-0.71000000f,-0.28000000f,0.23000000f,-0.51000000f,-0.05000000f,0.88000000f,-0.55000000f,0.54000000f,0.41000000f,-0.06000000f,-0.58000000f,0.32000000f,0.93000000f,-0.14000000f,-0.61000000f,-0.05000000f,0.13000000f,-0.73000000f,-0.19000000f,-0.49000000f,0.59000000f,0.53000000f,0.97000000f,0.64000000f,0.02000000f,0.39000000f,-0.95000000f,-0.87000000f,-0.87000000f,0.96000000f,-0.90000000f,-0.68000000f,0.74000000f,-0.76000000f,-0.08000000f,-0.19000000f,-0.11000000f,-0.32000000f,0.95000000f,-0.13000000f,0.70000000f,-0.81000000f,0.67000000f,0.09000000f,-0.64000000f,-0.24000000f,0.70000000f,0.46000000f,0.28000000f,0.21000000f,-0.10000000f,0.49000000f,-0.22000000f,0.64000000f,0.34000000f,-0.10000000f,-0.78000000f,-0.11000000f,-0.04000000f,-0.31000000f,-0.63000000f,-0.45000000f,0.12000000f,0.71000000f,0.88000000f,-0.41000000f,0.30000000f,0.51000000f,-0.73000000f,0.54000000f,-0.00000000f,0.39000000f,0.62000000f,0.81000000f,0.65000000f,-0.26000000f,-0.35000000f,0.84000000f,-0.12000000f,0.77000000f,0.65000000f,0.77000000f,-0.42000000f,0.54000000f,0.95000000f,-0.82000000f,0.46000000f,0.83000000f,0.15000000f,-0.11000000f,-0.06000000f,0.41000000f,0.87000000f,-0.74000000f,-0.24000000f,0.37000000f,0.94000000f,-0.42000000f,-0.56000000f,-0.01000000f,-0.15000000f,0.03000000f,0.49000000f,-0.75000000f,0.18000000f,0.42000000f,0.54000000f,0.39000000f,0.70000000f,-0.49000000f,0.08000000f,0.68000000f,-0.25000000f,0.36000000f,0.38000000f,0.44000000f,-0.52000000f,0.86000000f,-0.02000000f,0.69000000f,0.90000000f,0.89000000f,-0.77000000f,0.14000000f,-0.78000000f,-0.64000000f,0.40000000f,-0.09000000f,0.78000000f,-0.81000000f,0.94000000f,0.46000000f,-0.53000000f,0.04000000f,-0.46000000f,0.71000000f,-0.85000000f,0.66000000f,-0.51000000f,-0.09000000f,0.91000000f,0.38000000f,-0.26000000f,0.91000000f,-0.04000000f,-0.86000000f,-0.03000000f,0.83000000f,-0.69000000f,0.35000000f,0.65000000f,-0.03000000f,0.65000000f,0.68000000f,0.56000000f,0.30000000f,-0.46000000f,0.73000000f,0.02000000f,-0.21000000f,0.85000000f,0.48000000f,0.91000000f,0.05000000f,0.15000000f,-0.32000000f,0.39000000f,-0.33000000f,-0.84000000f,-0.66000000f,-0.41000000f,0.98000000f,-0.03000000f,0.56000000f,0.30000000f,0.37000000f,-0.86000000f,0.60000000f,0.47000000f,-0.24000000f,0.53000000f,-0.85000000f,0.66000000f,0.53000000f,-0.31000000f,-0.44000000f,0.88000000f,0.34000000f,-0.73000000f,-0.48000000f,-0.33000000f,-0.73000000f,0.56000000f,0.45000000f,0.18000000f,-0.76000000f,0.56000000f,0.23000000f,-0.83000000f,0.97000000f,-0.48000000f,-0.80000000f,-0.66000000f,0.17000000f,0.74000000f,0.39000000f,-0.02000000f,0.49000000f,-0.33000000f,-0.73000000f,-0.81000000f,0.27000000f,0.21000000f,0.38000000f,-0.68000000f,-0.20000000f,-0.09000000f,-0.96000000f,-0.61000000f,-0.93000000f,-0.99000000f,-0.16000000f,0.15000000f,0.62000000f,0.24000000f,0.74000000f,-0.65000000f,0.35000000f,0.26000000f,0.38000000f,-0.64000000f,-0.67000000f,0.80000000f,0.26000000f,0.30000000f,-0.56000000f,0.20000000f,-0.82000000f,0.06000000f,0.81000000f,0.75000000f,0.82000000f,-0.82000000f,0.55000000f,-0.91000000f,0.37000000f,0.16000000f,-0.03000000f,-0.13000000f,0.09000000f,-0.67000000f,-0.33000000f,-0.18000000f,-0.13000000f,-0.98000000f,-0.81000000f,-0.72000000f,0.49000000f,-0.96000000f,-0.22000000f,0.65000000f,0.35000000f,-0.35000000f,-0.60000000f,-0.64000000f,0.19000000f,-0.57000000f,0.73000000f,-0.70000000f,-0.89000000f,0.46000000f,-0.77000000f,-0.32000000f,0.55000000f,-0.81000000f,-0.61000000f,0.97000000f,-0.49000000f,0.30000000f,0.42000000f,0.66000000f,0.19000000f,0.55000000f,-0.72000000f,-0.95000000f,-0.65000000f,-0.28000000f,-0.75000000f,-0.22000000f,0.29000000f,0.56000000f,-0.02000000f,-0.15000000f,-0.80000000f,0.68000000f,-0.05000000f,-0.35000000f,0.68000000f,-0.84000000f,0.95000000f,-0.14000000f,0.04000000f,0.64000000f,0.49000000f,0.02000000f,0.74000000f,0.57000000f,0.58000000f,0.01000000f,0.62000000f,-0.87000000f,0.76000000f,0.37000000f,0.27000000f,-0.51000000f,0.07000000f,0.31000000f,0.39000000f,0.61000000f,0.60000000f,-0.14000000f,0.62000000f,0.01000000f,-0.10000000f,-0.43000000f,-0.23000000f,-0.91000000f,0.99000000f,0.58000000f,0.81000000f,-0.39000000f,-0.98000000f,0.96000000f,0.02000000f,0.38000000f,-0.94000000f,-0.46000000f,-0.02000000f,0.46000000f,0.48000000f,-0.39000000f,-0.46000000f,0.89000000f,-0.62000000f,0.10000000f,0.81000000f,0.53000000f,-0.96000000f,-0.33000000f,-0.58000000f,-0.17000000f,-0.73000000f,0.12000000f,0.05000000f,0.63000000f,-0.83000000f,0.01000000f,-0.02000000f,-0.00000000f,-0.01000000f,-0.79000000f,0.78000000f,0.48000000f,-0.44000000f,0.46000000f,0.48000000f,-0.72000000f,-0.53000000f,0.08000000f,0.00000000f,-0.12000000f,-0.93000000f,-0.87000000f,-0.32000000f,-0.49000000f,0.35000000f,-0.63000000f,-0.20000000f,0.99000000f,0.01000000f,-0.23000000f,0.41000000f,-0.32000000f,0.12000000f,0.85000000f,0.31000000f,0.43000000f,0.21000000f,0.60000000f,-0.33000000f,-0.71000000f,-0.84000000f,-0.23000000f,-0.06000000f,-0.23000000f,0.08000000f,0.89000000f,0.99000000f,0.64000000f,0.65000000f,-0.55000000f,0.60000000f,-0.07000000f,-0.62000000f,0.74000000f,0.57000000f,0.85000000f,0.27000000f,0.56000000f,-0.87000000f,0.00000000f,-0.37000000f,-0.67000000f,0.07000000f,0.49000000f,0.44000000f,-0.92000000f,0.48000000f,0.70000000f,-0.86000000f,0.33000000f,0.39000000f,0.71000000f,0.43000000f,0.80000000f,-0.52000000f,0.01000000f,-0.54000000f,-0.95000000f,-0.39000000f,0.40000000f,-0.75000000f,0.08000000f,0.76000000f,-0.62000000f,-0.39000000f,0.94000000f,0.31000000f,0.09000000f,-0.15000000f,0.83000000f,-0.77000000f,0.05000000f,0.85000000f,0.68000000f,-0.32000000f,0.94000000f,-0.09000000f,-0.57000000f,0.46000000f,-0.01000000f,-0.77000000f,0.68000000f,0.44000000f,0.01000000f,-0.38000000f,0.82000000f,-0.22000000f,0.74000000f,0.75000000f,-0.43000000f,-0.26000000f,0.01000000f,0.87000000f,0.15000000f,-0.93000000f,-0.51000000f,-0.23000000f,-0.57000000f,0.88000000f,0.76000000f,-0.39000000f,0.78000000f,-0.40000000f,0.78000000f,-0.86000000f,-0.15000000f,0.47000000f,-0.75000000f,-0.26000000f,-0.54000000f,-0.00000000f,-0.42000000f,0.40000000f,0.53000000f,-0.34000000f,0.26000000f,-0.20000000f,-0.09000000f,-0.89000000f,0.96000000f,0.44000000f,-0.56000000f,-0.58000000f,-0.40000000f,-0.69000000f,0.21000000f,-0.74000000f,0.42000000f,0.94000000f,0.95000000f,-0.01000000f,0.93000000f,0.22000000f,-0.40000000f,-0.56000000f,0.42000000f,-0.97000000f,-0.72000000f,0.59000000f,-0.69000000f,0.52000000f,0.62000000f,-0.13000000f,-0.47000000f,0.18000000f,0.00000000f,0.37000000f,0.58000000f,-0.61000000f,0.28000000f,-0.85000000f,0.52000000f,-0.69000000f,-0.62000000f,0.54000000f,-0.90000000f,0.89000000f,0.86000000f,-0.83000000f,-0.57000000f,0.32000000f,0.43000000f,0.35000000f,-0.35000000f,0.02000000f,0.93000000f,0.77000000f,0.32000000f,0.52000000f,0.58000000f,0.76000000f,0.35000000f,-0.55000000f,-0.10000000f,-0.07000000f,-0.82000000f,-0.40000000f,0.25000000f,0.91000000f,0.81000000f,0.60000000f,-0.58000000f,0.64000000f,0.20000000f,0.97000000f,0.61000000f,-0.57000000f,0.93000000f,0.69000000f,-0.42000000f,0.99000000f,-0.80000000f,0.59000000f,0.48000000f,0.13000000f,0.42000000f,-0.78000000f,-0.83000000f,0.72000000f,0.49000000f,0.56000000f,-0.69000000f,-0.89000000f,0.95000000f,-0.45000000f,-0.15000000f,-0.39000000f,0.12000000f,-0.85000000f,-0.85000000f,-0.81000000f,-0.63000000f,0.33000000f,-0.00000000f,0.14000000f,-0.46000000f,-0.13000000f,0.44000000f,0.97000000f,-0.03000000f,0.58000000f,0.91000000f,-0.34000000f,0.56000000f,0.79000000f,0.36000000f,0.34000000f,0.00000000f,-0.16000000f,0.98000000f,-0.32000000f,-0.91000000f,0.51000000f,0.65000000f,-0.71000000f,-0.53000000f,0.00000000f,0.41000000f,0.83000000f,-0.42000000f,-0.52000000f,-0.82000000f,0.46000000f,0.20000000f,-0.61000000f,0.50000000f,0.82000000f,0.43000000f,0.05000000f,-0.29000000f,0.92000000f,0.87000000f,-0.57000000f,-0.56000000f,0.10000000f,0.06000000f,-0.95000000f,-0.26000000f,0.35000000f,-0.83000000f,-0.41000000f,0.85000000f,-0.43000000f,0.61000000f,-0.71000000f,0.70000000f,0.70000000f,-0.50000000f,-0.94000000f,0.89000000f,-0.78000000f,-0.64000000f,0.66000000f,-0.37000000f,-0.24000000f,-0.74000000f,-0.40000000f,0.62000000f,-0.01000000f,0.11000000f,0.47000000f,-0.85000000f,-0.10000000f,-0.11000000f,-0.91000000f,0.48000000f,0.43000000f,0.01000000f,0.71000000f,0.66000000f,0.15000000f,-0.33000000f,-0.07000000f,-0.92000000f,-0.77000000f,-0.44000000f,0.33000000f,-0.89000000f,-0.52000000f,0.46000000f,-0.68000000f,0.37000000f,-0.54000000f,0.11000000f,-0.08000000f,0.60000000f,-0.13000000f,-0.01000000f,-0.38000000f,-0.31000000f,-0.32000000f,0.10000000f,-0.58000000f,-0.12000000f,-0.62000000f,0.97000000f,-0.59000000f,-0.26000000f,-0.26000000f,0.08000000f,-0.59000000f,0.91000000f,0.33000000f,-0.12000000f,-0.22000000f,-0.08000000f,-0.86000000f,0.02000000f,0.65000000f,0.56000000f,-0.13000000f,0.34000000f,0.17000000f,0.59000000f,0.62000000f,0.70000000f,0.57000000f,0.73000000f,-0.86000000f,-0.21000000f,0.64000000f,-0.23000000f,-0.68000000f,0.92000000f,0.75000000f,-0.05000000f,-0.63000000f,-0.61000000f,0.52000000f,0.77000000f,-0.92000000f,-0.71000000f,0.73000000f,-0.62000000f,0.32000000f,-0.38000000f,0.99000000f,-0.58000000f,-0.77000000f,0.58000000f,-0.25000000f,0.08000000f,0.87000000f,0.12000000f,0.03000000f,0.60000000f,-0.07000000f,-0.31000000f,-0.70000000f,0.34000000f,0.71000000f,-0.94000000f,-0.72000000f,0.37000000f,0.18000000f,0.71000000f,0.17000000f,-0.75000000f,-0.90000000f,0.24000000f,-0.53000000f,-0.05000000f,0.68000000f,-0.19000000f,0.62000000f,-0.62000000f,0.67000000f,0.02000000f,0.78000000f,-0.85000000f,0.24000000f,-0.57000000f,0.02000000f,-0.31000000f,-0.23000000f,-0.95000000f,-0.78000000f,-0.51000000f,0.46000000f,0.33000000f,-0.06000000f,-0.05000000f,0.75000000f,-0.07000000f,-0.69000000f,-0.55000000f,-0.79000000f,0.39000000f,-0.28000000f,0.92000000f,-0.47000000f,-0.34000000f,-0.04000000f,0.32000000f,-0.35000000f,0.97000000f,-0.45000000f,0.65000000f,0.51000000f,-0.90000000f,-0.87000000f,0.48000000f,0.40000000f,0.46000000f,0.82000000f,-0.02000000f,-0.55000000f,0.85000000f,0.12000000f,-0.10000000f,0.65000000f,-0.23000000f,0.99000000f,0.91000000f,-0.02000000f,-0.89000000f,-0.67000000f,-0.92000000f,0.06000000f,-0.16000000f,-0.97000000f,-0.17000000f,0.11000000f,0.37000000f,0.59000000f,-0.85000000f,-0.43000000f,-0.24000000f,-0.78000000f,-0.35000000f,0.07000000f,-0.26000000f,0.65000000f,-0.86000000f,-0.29000000f,-0.82000000f,-0.03000000f,0.25000000f,-0.23000000f,0.51000000f,-0.61000000f,0.68000000f,0.88000000f,-0.35000000f,-0.17000000f,0.36000000f,0.36000000f,0.80000000f,-0.80000000f,-0.52000000f,0.90000000f,0.65000000f,0.82000000f,-0.19000000f,-0.10000000f,0.62000000f,0.87000000f,-0.11000000f,-0.67000000f,-0.24000000f,0.28000000f,0.80000000f,0.69000000f,0.36000000f,0.06000000f,0.02000000f,-0.15000000f,-0.85000000f,-0.94000000f,0.18000000f,-0.67000000f,-0.03000000f,0.58000000f,0.95000000f,0.70000000f,0.04000000f,-0.66000000f,-0.21000000f,0.77000000f,-0.87000000f,-0.96000000f,-0.86000000f,-0.96000000f,-0.33000000f,0.46000000f,-0.08000000f,-0.15000000f,0.24000000f,0.83000000f,-0.10000000f,-0.90000000f,-0.47000000f,0.56000000f,-0.10000000f,0.96000000f,-0.13000000f,0.12000000f,0.15000000f,-0.14000000f,-0.88000000f,-0.27000000f,0.86000000f,-0.51000000f,-0.00000000f,0.13000000f,0.56000000f,0.00000000f,0.03000000f,-0.64000000f,0.05000000f,0.44000000f,0.85000000f,0.15000000f,-0.70000000f,0.26000000f,-0.57000000f,-0.59000000f,-0.90000000f,-0.42000000f,0.46000000f,0.90000000f,-0.47000000f,-0.05000000f,-0.29000000f,0.77000000f,-0.47000000f,0.63000000f,-0.72000000f,0.24000000f,-0.90000000f,-0.96000000f,0.61000000f,0.74000000f,-0.90000000f,0.12000000f,-0.92000000f,-0.76000000f,0.34000000f,-0.53000000f,-0.50000000f,0.75000000f,0.78000000f,0.13000000f,0.39000000f,0.10000000f,0.57000000f,-0.10000000f,0.00000000f,0.61000000f,-0.29000000f,0.92000000f,-0.89000000f,0.70000000f,-0.25000000f,0.01000000f,0.56000000f,0.17000000f,-0.51000000f,0.78000000f,0.03000000f,-0.45000000f,0.37000000f,-0.65000000f,0.65000000f,-0.18000000f,0.28000000f,-0.04000000f,-0.68000000f,-0.48000000f,0.06000000f,0.94000000f,0.56000000f,0.92000000f,0.96000000f,-0.46000000f,-0.69000000f,0.89000000f,-0.43000000f,-0.68000000f,0.87000000f,-0.73000000f,0.93000000f,0.02000000f,0.99000000f,0.41000000f,-0.78000000f,0.06000000f,-0.56000000f,0.04000000f,0.68000000f,-0.79000000f,0.26000000f,0.39000000f,0.92000000f,-0.71000000f,-0.17000000f,-0.36000000f,-0.48000000f,-0.17000000f,0.97000000f,-0.94000000f,-0.46000000f,-0.84000000f,-0.79000000f,0.40000000f,0.20000000f,-0.71000000f,-0.70000000f,0.28000000f,-0.27000000f,-0.63000000f,-0.39000000f,-0.36000000f,0.35000000f,-0.69000000f,-0.94000000f,-0.17000000f,-0.97000000f,-0.07000000f,-0.78000000f,0.84000000f,0.17000000f,0.54000000f,0.29000000f,0.76000000f,0.73000000f,-0.58000000f,-0.03000000f,0.27000000f,0.44000000f,-0.03000000f,-0.83000000f,-0.04000000f,-0.93000000f,-0.42000000f,0.82000000f,-0.01000000f,-0.62000000f,-0.01000000f,0.61000000f,-0.05000000f,-0.69000000f,-0.63000000f,-0.02000000f,-0.25000000f,-0.27000000f,0.86000000f,0.48000000f,-0.92000000f,0.71000000f,0.69000000f,-0.93000000f,0.23000000f,-0.48000000f,0.22000000f,0.05000000f,-0.00000000f,-0.97000000f,0.82000000f,-0.47000000f,0.53000000f,0.68000000f,0.65000000f,-0.13000000f,-0.29000000f,-0.74000000f,0.66000000f,-0.47000000f,-0.01000000f,-0.62000000f,0.18000000f,0.78000000f,0.35000000f,0.34000000f,0.34000000f,-0.20000000f,0.65000000f,0.40000000f,-0.78000000f,-0.11000000f,0.81000000f,-0.36000000f,0.74000000f,-0.83000000f,-0.66000000f,-0.26000000f,0.90000000f,0.02000000f,0.55000000f,-0.97000000f,0.54000000f,0.50000000f,0.25000000f,0.57000000f,-0.49000000f,-0.15000000f,-0.45000000f,0.50000000f,-0.79000000f,-0.90000000f,-0.91000000f,0.31000000f,0.97000000f,0.77000000f,0.76000000f,0.73000000f,0.40000000f,-0.04000000f,-0.25000000f,0.71000000f,0.44000000f,0.71000000f,0.59000000f,0.88000000f,0.39000000f,-0.23000000f,0.99000000f,0.94000000f,0.65000000f,0.52000000f,-0.55000000f,-0.30000000f,-0.81000000f,0.21000000f,0.37000000f,0.47000000f,0.26000000f,-0.07000000f,-0.08000000f,0.62000000f,0.99000000f,-0.52000000f,-0.04000000f,0.75000000f,-0.67000000f,-0.23000000f,-0.16000000f,-0.25000000f,0.50000000f,-0.17000000f,-0.09000000f,0.16000000f,-0.92000000f,0.62000000f,0.70000000f,0.28000000f,0.00000000f,0.87000000f,-0.73000000f,0.97000000f,-0.31000000f,0.94000000f,0.56000000f,-0.00000000f,0.37000000f,0.05000000f,-0.70000000f,-0.03000000f,0.80000000f,0.95000000f,0.08000000f,-0.34000000f,0.85000000f,0.88000000f,0.95000000f,0.88000000f,0.14000000f,-0.22000000f,0.94000000f,0.47000000f,-0.85000000f,-0.07000000f,0.67000000f,0.55000000f,0.74000000f,0.87000000f,-0.39000000f,0.99000000f,0.49000000f,-0.14000000f,-0.20000000f,0.79000000f,-0.88000000f,0.79000000f,-0.14000000f,0.40000000f,0.57000000f,-0.32000000f,0.47000000f,-0.93000000f,-0.97000000f,-0.18000000f,0.71000000f,-0.96000000f,-0.50000000f,-0.65000000f,0.69000000f,-0.26000000f,-0.94000000f,-0.07000000f,-0.20000000f,0.55000000f,-0.84000000f,0.14000000f,0.88000000f,-0.94000000f,-0.62000000f,0.42000000f,-0.49000000f,0.70000000f,-0.61000000f,-0.36000000f,-0.92000000f,-0.96000000f,-0.42000000f,-0.15000000f,-0.55000000f,0.51000000f,0.56000000f,-0.03000000f,0.16000000f,0.27000000f,0.06000000f,-0.46000000f,-0.54000000f,-0.74000000f,0.48000000f,0.79000000f,-0.30000000f,-0.31000000f,0.37000000f,-0.63000000f,-0.53000000f,0.65000000f,-0.54000000f,-0.68000000f,0.10000000f,0.19000000f,-0.51000000f,0.68000000f,-0.81000000f,0.20000000f,0.38000000f,0.83000000f,0.14000000f,0.81000000f,0.29000000f,0.95000000f,-0.57000000f,0.83000000f,-0.25000000f,-0.26000000f,0.10000000f,-0.23000000f,0.00000000f,-0.77000000f,-0.47000000f,-0.36000000f,-0.33000000f,-0.38000000f,0.48000000f,0.15000000f,-0.61000000f,-0.07000000f,-0.35000000f,-0.52000000f,0.46000000f,-0.51000000f,-0.56000000f,0.32000000f,-0.51000000f,-0.87000000f,-0.76000000f,0.95000000f,-0.88000000f,-0.53000000f,-0.51000000f,0.18000000f,0.95000000f,-0.72000000f,-0.06000000f,0.85000000f,0.07000000f,-0.84000000f,0.90000000f,-0.19000000f,0.14000000f,0.54000000f,-0.84000000f,-0.57000000f,-0.38000000f,0.23000000f,0.45000000f,0.66000000f,0.73000000f,-0.87000000f,-0.29000000f,0.25000000f,-0.74000000f,-0.87000000f,-0.54000000f,0.08000000f,-0.26000000f,-0.15000000f,0.40000000f,-0.62000000f,-0.73000000f,-0.38000000f,0.13000000f,0.37000000f,0.20000000f,0.61000000f,-0.78000000f,0.84000000f,0.99000000f,0.80000000f,-0.99000000f,0.52000000f,0.85000000f,-0.61000000f,-0.74000000f,-0.52000000f,0.03000000f,-0.17000000f,-0.91000000f,0.64000000f,0.61000000f,0.82000000f,0.49000000f,-0.90000000f,0.13000000f,0.92000000f,0.63000000f,-0.38000000f,0.40000000f,-0.12000000f,-0.46000000f,-0.66000000f,0.45000000f,-0.68000000f,-0.32000000f,-0.41000000f,0.97000000f,-0.78000000f,-0.82000000f,-0.93000000f,-0.19000000f,0.33000000f,-0.56000000f,-0.21000000f,-0.37000000f,0.61000000f,-0.37000000f,-0.59000000f,0.50000000f,0.88000000f,0.39000000f,0.11000000f,0.66000000f,-0.67000000f,0.49000000f,-0.07000000f,0.51000000f,-0.20000000f,0.65000000f,-0.63000000f,-0.87000000f,0.96000000f,-0.58000000f,-0.24000000f,0.29000000f,-0.67000000f,-0.39000000f,-0.18000000f,0.48000000f,0.79000000f,0.97000000f,0.24000000f,0.07000000f,0.19000000f,0.54000000f,-0.45000000f,-0.34000000f,-0.13000000f,0.43000000f,-0.55000000f,-0.31000000f,-0.55000000f,0.77000000f,-0.52000000f,-0.20000000f,0.30000000f,0.81000000f,0.74000000f,0.63000000f,0.01000000f,-0.70000000f,0.17000000f,0.50000000f,0.34000000f,0.73000000f,0.01000000f,-0.74000000f,0.37000000f,0.88000000f,-0.40000000f,0.39000000f,-0.07000000f,-0.03000000f,0.14000000f,0.89000000f,0.70000000f,-0.49000000f,-0.41000000f,-0.66000000f,0.20000000f,0.95000000f,0.34000000f,0.69000000f,-0.01000000f,-0.63000000f,0.57000000f,0.60000000f,0.99000000f,0.49000000f,-0.45000000f,0.77000000f,-0.26000000f,-0.83000000f,0.29000000f,0.69000000f,-0.26000000f,0.97000000f,-0.25000000f,-0.96000000f,0.68000000f,-0.17000000f,0.99000000f,-0.61000000f,0.40000000f,-0.56000000f,0.50000000f,0.07000000f,0.74000000f,-0.16000000f,-0.44000000f,0.72000000f,0.50000000f,0.02000000f,0.74000000f,0.95000000f,-0.14000000f,-0.40000000f,0.82000000f,-0.82000000f,-0.58000000f,0.06000000f,0.77000000f,-0.26000000f,0.63000000f,0.17000000f,-0.44000000f,-0.08000000f,0.72000000f,0.16000000f,-0.91000000f,-0.56000000f,0.86000000f,0.34000000f,0.70000000f,0.85000000f,-0.93000000f,0.99000000f,0.33000000f,0.32000000f,0.23000000f,-0.40000000f,-0.96000000f,0.07000000f,0.01000000f,-0.81000000f,-0.39000000f,-0.82000000f,-0.50000000f,-0.15000000f,0.52000000f,0.34000000f,-0.96000000f,-0.28000000f,0.16000000f,0.72000000f,-0.91000000f,0.03000000f,-0.22000000f,0.27000000f,-0.53000000f,0.27000000f,-0.53000000f,0.95000000f,0.48000000f,0.22000000f,0.61000000f,-0.30000000f,0.67000000f,-0.22000000f,-0.06000000f,-0.56000000f,-0.74000000f,0.98000000f,-0.97000000f,0.15000000f,0.97000000f,-0.71000000f,0.53000000f,-0.09000000f,0.58000000f,-0.80000000f,0.85000000f,-0.96000000f,-0.50000000f,0.22000000f,-0.43000000f,-0.73000000f,0.36000000f,-0.27000000f,0.46000000f,0.36000000f,0.92000000f,0.02000000f,0.00000000f,0.55000000f,-0.00000000f,-0.68000000f,-0.39000000f,-0.67000000f,-0.58000000f,-0.50000000f,0.39000000f,-0.18000000f,0.48000000f,-0.66000000f,0.05000000f,-0.38000000f,-0.48000000f,0.42000000f,-0.72000000f,0.30000000f,0.30000000f,0.13000000f,-0.52000000f,-0.47000000f,-0.07000000f,-0.92000000f,-0.28000000f,0.25000000f,-0.19000000f,0.83000000f,-0.30000000f,0.66000000f,0.57000000f,-0.98000000f,-0.47000000f,0.03000000f,0.22000000f,-0.55000000f,0.14000000f,-0.04000000f,-0.81000000f,0.99000000f,-0.48000000f,-0.36000000f,0.24000000f,0.08000000f,-0.82000000f,-0.74000000f,-0.68000000f,-0.12000000f,-0.57000000f,-0.55000000f,-0.43000000f,-0.57000000f,-0.37000000f,-0.84000000f,-0.83000000f,0.44000000f,0.26000000f,-0.04000000f,0.03000000f,-0.58000000f,-0.84000000f,0.78000000f,-0.30000000f,-0.00000000f,-0.82000000f,0.12000000f,-0.00000000f,0.13000000f,0.49000000f,-0.26000000f,0.11000000f,0.50000000f,-0.44000000f,-0.87000000f,-0.15000000f,-0.22000000f,-0.21000000f,-0.76000000f,-0.79000000f,0.80000000f,0.97000000f,0.97000000f,0.06000000f,0.87000000f,0.13000000f,-0.22000000f,0.49000000f,-0.11000000f,-0.36000000f,-0.12000000f,-0.39000000f,0.43000000f,0.17000000f,0.54000000f,-0.17000000f,0.93000000f,-0.21000000f,0.80000000f,0.60000000f,-0.40000000f,0.02000000f,0.85000000f,0.32000000f,-0.52000000f,-0.62000000f,0.54000000f,0.01000000f,-0.93000000f,0.07000000f,0.97000000f,-0.46000000f,-0.94000000f,-0.94000000f,-0.93000000f,-0.41000000f,0.80000000f,-0.54000000f,-0.23000000f,-0.08000000f,0.60000000f,-0.56000000f,0.26000000f,0.12000000f,-0.48000000f,0.53000000f,0.90000000f,0.93000000f,-0.84000000f,0.71000000f,-0.60000000f,0.18000000f,0.52000000f,-0.59000000f,-0.74000000f,0.36000000f,-0.74000000f,-0.25000000f,-0.77000000f,0.13000000f,-0.88000000f,0.88000000f,-0.23000000f,-0.29000000f,0.82000000f,0.26000000f,0.57000000f,-0.29000000f,0.07000000f,-0.40000000f,0.99000000f,-0.89000000f,0.56000000f,-0.19000000f,0.95000000f,0.50000000f,-0.70000000f,0.31000000f,0.75000000f,0.63000000f,0.70000000f,-0.46000000f,-0.34000000f,0.88000000f,0.03000000f,0.56000000f,0.71000000f,0.34000000f,0.17000000f,-0.79000000f,-0.78000000f,0.47000000f,0.14000000f,0.00000000f,0.49000000f,0.10000000f,0.42000000f,0.35000000f,-0.39000000f,0.02000000f,-0.02000000f,0.19000000f,0.36000000f,-0.71000000f,0.30000000f,-0.58000000f,-0.42000000f,-0.23000000f,0.24000000f,0.17000000f,-0.42000000f,0.77000000f,-0.88000000f,0.07000000f,-0.33000000f,0.20000000f,-0.05000000f,0.37000000f,-0.74000000f,0.87000000f,0.00000000f,-0.23000000f,-0.48000000f,-0.95000000f,-0.97000000f,0.12000000f,-0.86000000f,0.58000000f,-0.92000000f,0.62000000f,0.72000000f,-0.53000000f,0.03000000f,0.70000000f,0.26000000f,0.95000000f,-0.44000000f,0.91000000f,0.09000000f,-0.31000000f,0.53000000f,0.90000000f,0.92000000f,-0.68000000f,0.75000000f,-0.85000000f,-0.04000000f,-0.42000000f,-0.77000000f,-0.67000000f,0.94000000f,-0.57000000f,-0.93000000f,-0.43000000f,-0.74000000f,0.95000000f,-0.53000000f,-0.50000000f,0.69000000f,0.93000000f,0.61000000f,-0.62000000f,0.66000000f,0.44000000f,-0.98000000f,0.54000000f,0.33000000f,-0.61000000f,-0.95000000f,0.92000000f,-0.95000000f,0.63000000f,-0.25000000f,-0.36000000f,-0.70000000f,-0.57000000f,-0.36000000f,-0.42000000f,0.34000000f,-0.01000000f,0.27000000f,-0.76000000f,-0.22000000f,0.46000000f,-0.89000000f,-0.02000000f,0.57000000f,0.82000000f,-0.58000000f,-0.52000000f,0.49000000f,0.02000000f,-0.04000000f,0.73000000f,-0.47000000f,-0.08000000f,0.47000000f,-0.98000000f,0.94000000f,0.82000000f,-0.90000000f,-0.88000000f,-0.82000000f,0.04000000f,0.25000000f,0.84000000f,-0.26000000f,0.19000000f,-0.43000000f,0.32000000f,-0.66000000f,0.25000000f,0.44000000f,0.47000000f,-0.69000000f,-0.14000000f,0.64000000f,-0.15000000f,-0.50000000f,-0.12000000f,0.29000000f,-0.08000000f,0.83000000f,0.48000000f,0.07000000f,-0.51000000f,0.24000000f,-0.81000000f,-0.65000000f,-0.54000000f,0.12000000f,0.52000000f,0.15000000f,-0.55000000f,-0.94000000f,0.47000000f,-0.32000000f,0.04000000f,0.17000000f,-0.13000000f,-0.13000000f,0.46000000f,0.13000000f,-0.85000000f,-0.55000000f,0.41000000f,-0.90000000f,0.84000000f,-0.17000000f,-0.73000000f,0.29000000f,-0.70000000f,0.16000000f,0.38000000f,0.39000000f,-0.93000000f,0.96000000f,-0.45000000f,0.54000000f,-0.76000000f,-0.07000000f,-0.02000000f,0.84000000f,0.91000000f,-0.09000000f,0.94000000f,-0.19000000f,0.88000000f,-0.93000000f,0.74000000f,0.19000000f,-0.39000000f,0.11000000f,-0.36000000f,-0.57000000f,0.01000000f,-0.71000000f,-0.67000000f,-0.54000000f,0.54000000f,-0.22000000f,0.06000000f,-0.67000000f,0.68000000f,-0.45000000f,0.64000000f,0.46000000f,0.69000000f,0.75000000f,0.94000000f,-0.40000000f,-0.05000000f,-0.89000000f,-0.07000000f,-0.47000000f,0.03000000f,-0.31000000f,0.54000000f,-0.88000000f,0.90000000f,-0.37000000f,0.01000000f,-0.23000000f,-0.96000000f,0.12000000f,-0.42000000f,0.91000000f,-0.62000000f,-0.06000000f,0.78000000f,0.63000000f,-0.72000000f,0.28000000f,0.11000000f,0.11000000f,0.15000000f,0.73000000f,-0.91000000f,0.36000000f,0.42000000f,0.25000000f,-0.36000000f,-0.27000000f,0.42000000f,-0.51000000f,-0.44000000f,0.87000000f,0.33000000f,0.47000000f,0.84000000f,0.05000000f,0.37000000f,-0.60000000f,-0.66000000f,0.83000000f,0.84000000f,0.43000000f,0.15000000f,-0.90000000f,-0.48000000f,-0.59000000f,-0.98000000f,0.80000000f,-0.43000000f,-0.01000000f,0.43000000f,0.62000000f,-0.52000000f,0.36000000f,-0.55000000f,0.14000000f,0.08000000f,-0.32000000f,0.65000000f,-0.51000000f,0.26000000f,0.69000000f,-0.71000000f,-0.69000000f,0.28000000f,-0.66000000f,-0.91000000f,-0.15000000f,0.47000000f,0.34000000f,0.56000000f,-0.66000000f,0.26000000f,0.56000000f,0.21000000f,-0.67000000f,0.85000000f,0.30000000f,0.83000000f,0.17000000f,-0.30000000f,0.09000000f,0.23000000f,0.64000000f,0.26000000f,0.78000000f,-0.09000000f,-0.37000000f,-0.45000000f,-0.74000000f,-0.96000000f,-0.13000000f,0.16000000f,-0.94000000f,-0.78000000f,0.75000000f,0.40000000f,0.83000000f,0.99000000f,-0.91000000f,-0.26000000f,0.66000000f,-0.55000000f,0.89000000f,0.86000000f,-0.64000000f,-0.06000000f,0.33000000f,-0.09000000f,-0.87000000f,0.63000000f,-0.40000000f,0.91000000f,-0.89000000f,0.76000000f,-0.39000000f,-0.93000000f,0.77000000f,0.61000000f,-0.10000000f,-0.78000000f,-0.79000000f,-0.93000000f,0.44000000f,0.58000000f,0.16000000f,-0.39000000f,-0.97000000f,-0.90000000f,0.01000000f,-0.36000000f,0.70000000f,0.26000000f,0.90000000f,-0.65000000f,0.94000000f,-0.19000000f,-0.00000000f,0.26000000f,-0.39000000f,0.25000000f,-0.27000000f,0.68000000f,0.06000000f,0.11000000f,0.88000000f,0.73000000f,0.17000000f,0.83000000f,-0.39000000f,-0.16000000f,-0.43000000f,-0.16000000f,0.59000000f,0.68000000f,0.45000000f,0.15000000f,0.53000000f,-0.56000000f,0.99000000f,-0.46000000f,-0.50000000f,-0.47000000f,-0.63000000f,-0.07000000f,0.32000000f,0.09000000f,0.40000000f,-0.42000000f,-0.66000000f,0.89000000f,-0.73000000f,-0.62000000f,0.43000000f,0.67000000f,-0.31000000f,0.65000000f,-0.04000000f,-0.37000000f,0.77000000f,0.10000000f,-0.78000000f,0.67000000f,0.29000000f,-0.37000000f,-0.94000000f,-0.00000000f,-0.79000000f,-0.15000000f,0.08000000f,-0.53000000f,0.88000000f,0.21000000f,0.73000000f,0.17000000f,-0.13000000f,0.93000000f,0.86000000f,-0.65000000f,-0.12000000f,-0.69000000f,0.57000000f,0.23000000f,-0.62000000f,0.03000000f,-0.47000000f,0.02000000f,0.20000000f,-0.42000000f,0.97000000f,0.85000000f,-0.16000000f,-0.87000000f,-0.78000000f,0.50000000f,0.34000000f,-0.81000000f,0.87000000f,0.29000000f,0.61000000f,-0.82000000f,-0.50000000f,-0.86000000f,0.56000000f,-0.14000000f,-0.50000000f,-0.35000000f,-0.55000000f,-0.37000000f,0.37000000f,-0.55000000f,0.59000000f,-0.27000000f,0.47000000f,-0.88000000f,0.78000000f,0.09000000f,-0.61000000f,-0.20000000f,-0.81000000f,0.10000000f,0.11000000f,-0.93000000f,-0.80000000f,0.74000000f,0.65000000f,0.27000000f,-0.97000000f,0.97000000f,-0.04000000f,0.49000000f,-0.77000000f,0.36000000f,0.82000000f,0.09000000f,-0.32000000f,0.08000000f,0.67000000f,0.08000000f,0.48000000f,-0.02000000f,-0.07000000f,0.55000000f,-0.47000000f,0.03000000f,-0.17000000f,-0.72000000f,-0.05000000f,0.79000000f,0.60000000f,-0.86000000f,0.68000000f,0.07000000f,0.77000000f,-0.60000000f,0.83000000f,0.47000000f,0.65000000f,-0.95000000f,-0.00000000f,0.71000000f,0.97000000f,0.63000000f,0.75000000f,0.83000000f,-0.08000000f,-0.89000000f,-0.46000000f,-0.46000000f,-0.51000000f,0.69000000f,0.83000000f,0.33000000f,0.25000000f,0.36000000f,-0.47000000f,-0.57000000f,0.36000000f,-0.15000000f,0.03000000f,0.72000000f,-0.91000000f,-0.46000000f,-0.45000000f,-0.08000000f,0.21000000f,0.39000000f,-0.59000000f,0.73000000f,0.34000000f,-0.42000000f,0.35000000f,-0.11000000f,-0.38000000f,-0.51000000f,0.84000000f,-0.07000000f,-0.21000000f,-0.58000000f,-0.96000000f,-0.91000000f,0.00000000f,-0.85000000f,-0.29000000f,-0.73000000f,-0.45000000f,-0.52000000f,-0.13000000f,-0.44000000f,-0.79000000f,-0.90000000f,0.32000000f,0.67000000f,0.66000000f,0.51000000f,-0.57000000f,-0.31000000f,0.85000000f,-0.46000000f,0.91000000f,-0.03000000f,-0.13000000f,0.81000000f,-0.84000000f,0.07000000f,0.37000000f,-0.51000000f,0.73000000f,-0.11000000f,0.59000000f,-0.38000000f,0.64000000f,-0.41000000f,-0.80000000f,0.72000000f,-0.72000000f,-0.70000000f,0.50000000f,-0.19000000f,-0.42000000f,-0.10000000f,0.59000000f,0.79000000f,-0.69000000f,-0.58000000f,0.15000000f,0.98000000f,0.44000000f,0.19000000f,-0.18000000f,-0.06000000f,0.80000000f,-0.27000000f,-0.02000000f,-0.02000000f,0.25000000f,-0.20000000f,0.29000000f,-0.80000000f,0.39000000f,0.89000000f,0.99000000f,0.47000000f,0.43000000f,0.71000000f,-0.43000000f,-0.26000000f,0.62000000f,0.10000000f,0.79000000f,-0.26000000f,0.18000000f,0.27000000f,-0.75000000f,-0.82000000f,-0.09000000f,-0.63000000f,0.66000000f,-0.29000000f,-0.54000000f,-0.21000000f,-0.83000000f,-0.42000000f,0.85000000f,0.69000000f,-0.95000000f,-0.85000000f,0.04000000f,-0.60000000f,0.02000000f,-0.00000000f,0.19000000f,0.01000000f,0.89000000f,-0.69000000f,0.85000000f,-0.70000000f,0.46000000f,-0.47000000f,-0.43000000f,-0.03000000f,0.37000000f,-0.66000000f,-0.44000000f,0.90000000f,0.03000000f,-0.07000000f,-0.09000000f,0.17000000f,-0.42000000f,0.16000000f,-0.81000000f,-0.05000000f,0.56000000f,-0.19000000f,-0.23000000f,-0.89000000f,-0.20000000f,-0.95000000f,-0.47000000f,-0.84000000f,0.84000000f,-0.91000000f,-0.33000000f,-0.69000000f,0.53000000f,-0.99000000f,0.93000000f,0.03000000f,-0.88000000f,0.03000000f,-0.01000000f,0.88000000f,0.84000000f,-0.71000000f,-0.25000000f,-0.04000000f,-0.15000000f,-0.92000000f,-0.12000000f,-0.74000000f,-0.04000000f,0.08000000f,-0.61000000f,0.18000000f,0.93000000f,-0.30000000f,-0.81000000f,0.94000000f,-0.39000000f,-0.41000000f,0.21000000f,-0.08000000f,-0.97000000f,-0.41000000f,0.10000000f,-0.44000000f,0.14000000f,0.30000000f,-0.75000000f,0.68000000f,-0.09000000f,0.43000000f,0.49000000f,-0.58000000f,0.94000000f,-0.01000000f,0.26000000f,0.75000000f,0.77000000f,-0.26000000f,0.56000000f,0.48000000f,-0.50000000f,-0.45000000f,0.56000000f,-0.13000000f,0.53000000f,-0.75000000f,-0.18000000f,0.05000000f,-0.00000000f,0.66000000f,0.23000000f,-0.50000000f,0.57000000f,0.37000000f,-0.23000000f,0.86000000f,-0.05000000f,-0.61000000f,-0.22000000f,0.72000000f,-0.35000000f,0.47000000f,-0.50000000f,0.78000000f,0.81000000f,0.05000000f,-0.04000000f,-0.05000000f,0.41000000f,-0.74000000f,0.52000000f,0.34000000f,-0.02000000f,0.30000000f,0.91000000f,-0.52000000f,-0.66000000f,-0.57000000f,-0.49000000f,-0.76000000f,-0.29000000f,-0.92000000f,0.87000000f,-0.26000000f,-0.88000000f,-0.78000000f,-0.98000000f,-0.61000000f,-0.72000000f,0.09000000f,0.82000000f,0.47000000f,-0.19000000f,-0.71000000f,0.56000000f,0.15000000f,-0.07000000f,-0.94000000f,0.85000000f,0.85000000f,0.40000000f,-0.13000000f,-0.20000000f,0.23000000f,-0.02000000f,-0.74000000f,0.12000000f,0.99000000f,-0.44000000f,0.34000000f,-0.54000000f,0.90000000f,-0.95000000f,0.54000000f,-0.27000000f,0.36000000f,0.78000000f,-0.86000000f,-0.21000000f,0.17000000f,0.28000000f,-0.15000000f,0.66000000f,-0.43000000f,0.64000000f,0.70000000f,-0.95000000f,0.27000000f,0.71000000f,0.27000000f,-0.99000000f,-0.11000000f,-0.56000000f,0.21000000f,-0.84000000f,-0.64000000f,-0.26000000f,0.05000000f,0.31000000f,0.56000000f,-0.41000000f,-0.77000000f,-0.32000000f,0.72000000f,0.25000000f,0.81000000f,0.06000000f,-0.92000000f,0.89000000f,-0.23000000f,0.42000000f,0.53000000f,-0.15000000f,0.11000000f,0.88000000f,-0.36000000f,-0.43000000f,-0.68000000f,0.37000000f,-0.62000000f,-0.77000000f,-0.03000000f,-0.93000000f,0.50000000f,0.57000000f,-0.90000000f,-0.00000000f,0.82000000f,0.61000000f,-0.62000000f,0.38000000f,-0.06000000f,-0.32000000f,0.31000000f,0.66000000f,-0.25000000f,0.90000000f,0.15000000f,0.12000000f,0.60000000f,0.82000000f,-0.86000000f,0.54000000f,-0.99000000f,0.05000000f,0.92000000f,-0.75000000f,-0.26000000f,-0.32000000f,-0.18000000f,0.41000000f,0.38000000f,-0.32000000f,0.27000000f,0.08000000f,0.74000000f,-0.71000000f,-0.26000000f,0.34000000f,0.99000000f,0.46000000f,0.11000000f,-0.41000000f,-0.09000000f,0.19000000f,-0.83000000f,0.43000000f,0.12000000f,0.74000000f,0.31000000f,-0.35000000f,-0.76000000f,0.13000000f,0.05000000f,0.65000000f,0.32000000f,-0.62000000f,-0.34000000f,-0.37000000f,0.94000000f,-0.18000000f,0.03000000f,-0.30000000f,-0.91000000f,0.95000000f,0.76000000f,0.67000000f,0.85000000f,0.15000000f,0.84000000f,-0.21000000f,0.87000000f,0.83000000f,0.56000000f,-0.67000000f,0.72000000f,0.05000000f,-0.70000000f,-0.28000000f,-0.87000000f,-0.25000000f,0.95000000f,0.34000000f,-0.01000000f,0.20000000f,-0.72000000f,0.57000000f,0.06000000f,0.99000000f,0.05000000f,0.36000000f,0.77000000f,-0.89000000f,-0.52000000f,-0.65000000f,-0.95000000f,-0.49000000f,-0.62000000f,0.12000000f,0.17000000f,-0.89000000f,0.27000000f,-0.72000000f,0.09000000f,0.94000000f,0.46000000f,-0.39000000f,-0.27000000f,-0.34000000f,0.05000000f,-0.43000000f,0.76000000f,0.59000000f,0.41000000f,-0.69000000f,0.50000000f,0.30000000f,0.69000000f,0.31000000f,0.31000000f,0.60000000f,-0.81000000f,-0.34000000f,-0.31000000f,0.32000000f,0.72000000f,-0.37000000f,0.08000000f,-0.61000000f,-0.77000000f,-0.86000000f,0.13000000f,0.52000000f,-0.28000000f,-0.43000000f,-0.70000000f,0.34000000f,0.41000000f,-0.85000000f,-0.19000000f,0.09000000f,0.88000000f,-0.40000000f,-0.92000000f,-0.62000000f,-0.97000000f,0.11000000f,-0.54000000f,-0.51000000f,-0.99000000f,-0.03000000f,0.69000000f,0.57000000f,-0.56000000f,-0.87000000f,0.39000000f,0.37000000f,0.72000000f,0.17000000f,-0.28000000f,-0.86000000f,0.46000000f,-0.77000000f,0.49000000f,-0.73000000f,-0.65000000f,-0.81000000f,-0.78000000f,0.02000000f,0.22000000f,-0.58000000f,0.30000000f,-0.95000000f,-0.91000000f,0.94000000f,-0.73000000f,0.67000000f,0.45000000f,-0.49000000f,0.37000000f,0.48000000f,-0.76000000f,-0.59000000f,0.32000000f,0.97000000f,0.01000000f,0.46000000f,-0.42000000f,0.58000000f,0.26000000f,0.62000000f,0.58000000f,-0.26000000f,-0.52000000f,-0.24000000f,-0.72000000f,-0.88000000f,0.89000000f,0.99000000f,0.20000000f,0.48000000f,0.11000000f,0.82000000f,-0.51000000f,0.46000000f,-0.07000000f,0.19000000f,0.66000000f,-0.22000000f,-0.68000000f,0.37000000f,0.81000000f,0.51000000f,-0.81000000f,-0.75000000f,-0.51000000f,-0.26000000f,-0.13000000f,0.47000000f,0.59000000f,-0.71000000f,-0.43000000f,-0.33000000f,0.82000000f,-0.15000000f,-0.18000000f,0.80000000f,-0.09000000f,0.19000000f,0.75000000f,0.20000000f,0.31000000f,0.28000000f,-0.44000000f,-0.43000000f,0.18000000f,0.53000000f,0.76000000f,0.15000000f,-0.63000000f,-0.39000000f,-0.84000000f,0.01000000f,-0.05000000f,-0.33000000f,0.32000000f,0.10000000f,0.00000000f,0.80000000f,0.46000000f,-0.78000000f,0.84000000f,-0.20000000f,0.60000000f,0.62000000f,0.52000000f,-0.79000000f,0.21000000f,-0.97000000f,-0.94000000f,0.45000000f,-0.46000000f,-0.97000000f,-0.53000000f,-0.37000000f,-0.97000000f,-0.68000000f,0.09000000f,-0.80000000f,0.50000000f,0.09000000f,0.56000000f,0.10000000f,0.81000000f,0.33000000f,0.81000000f,-0.32000000f,-0.51000000f,-0.00000000f,-0.15000000f,0.92000000f,0.94000000f,-0.79000000f,-0.72000000f,0.43000000f,-0.04000000f,0.42000000f,0.21000000f,0.99000000f,0.39000000f,0.06000000f,-0.01000000f,-0.59000000f,0.18000000f,-0.94000000f,-0.50000000f,-0.55000000f,-0.13000000f,0.32000000f,0.94000000f,-0.87000000f,0.08000000f,-0.72000000f,-0.17000000f,-0.37000000f,0.21000000f,0.01000000f,-0.28000000f,0.60000000f,0.05000000f,-0.99000000f,-0.50000000f,-0.74000000f,0.32000000f,0.49000000f,-0.29000000f,0.12000000f,-0.52000000f,-0.90000000f,-0.68000000f,-0.45000000f,0.73000000f,0.52000000f,0.03000000f,-0.71000000f,0.39000000f,0.92000000f,-0.95000000f,0.83000000f,-0.60000000f,-0.44000000f,-0.66000000f,-0.59000000f,-0.76000000f,-0.79000000f,-0.10000000f,-0.77000000f,0.35000000f,0.88000000f,-0.49000000f,0.08000000f,0.06000000f,-0.97000000f,-0.84000000f,-0.47000000f,0.40000000f,0.51000000f,0.13000000f,-0.06000000f,-0.35000000f,0.81000000f,-0.99000000f,-0.09000000f,-0.92000000f,-0.38000000f,-0.78000000f,-0.10000000f,0.76000000f,-0.08000000f,-0.31000000f,-0.59000000f,-0.86000000f,-0.34000000f,-0.86000000f,0.54000000f,0.10000000f,0.16000000f,-0.01000000f,-0.68000000f,-0.22000000f,-0.15000000f,0.46000000f,0.92000000f,-0.75000000f,-0.84000000f,-0.62000000f,-0.74000000f,0.40000000f,0.90000000f,-0.41000000f,-0.14000000f,-0.73000000f,0.27000000f,0.86000000f,0.53000000f,-0.41000000f,0.35000000f,0.96000000f,0.34000000f,0.96000000f,-0.83000000f,0.88000000f,-0.35000000f,0.34000000f,-0.71000000f,-0.27000000f,-0.28000000f,0.38000000f,-0.98000000f,-0.30000000f,-0.67000000f,0.52000000f,-0.03000000f,0.63000000f,-0.54000000f,0.26000000f,0.41000000f,-0.01000000f,-0.10000000f,-0.38000000f,0.61000000f,-0.77000000f,0.92000000f,0.58000000f,-0.98000000f,0.93000000f,-0.27000000f,-0.08000000f,0.78000000f,-0.64000000f,-0.93000000f,0.79000000f,-0.36000000f,0.94000000f,-0.10000000f,0.48000000f,0.73000000f,-0.44000000f,0.00000000f,-0.94000000f,-0.90000000f,0.04000000f,-0.72000000f,0.09000000f,-0.57000000f,0.46000000f,-0.62000000f,-0.41000000f,0.09000000f,-0.21000000f,-0.56000000f,0.79000000f,0.49000000f,-0.78000000f,0.43000000f,0.61000000f,-0.29000000f,-0.10000000f,-0.54000000f,0.64000000f,-0.95000000f,0.35000000f,-0.50000000f,0.99000000f,0.08000000f,-0.07000000f,-0.00000000f,0.31000000f,0.69000000f,0.78000000f,0.68000000f,-0.34000000f,-0.39000000f,0.17000000f,0.51000000f,-0.25000000f,0.71000000f,0.83000000f,0.58000000f,0.87000000f,0.79000000f,0.14000000f,0.26000000f,0.54000000f,0.26000000f,0.06000000f,0.85000000f,-0.29000000f,-0.79000000f,-0.57000000f,-0.02000000f,-0.07000000f,0.77000000f,0.16000000f,0.17000000f,-0.35000000f,0.63000000f,0.61000000f,0.89000000f,0.52000000f,0.14000000f,0.77000000f,0.57000000f,0.80000000f,-0.81000000f,-0.93000000f,-0.18000000f,-0.32000000f,-0.88000000f,0.24000000f,-0.25000000f,-0.75000000f,0.88000000f,0.43000000f,0.09000000f,-0.08000000f,-0.15000000f,0.53000000f,-0.93000000f,0.02000000f,-0.48000000f,0.82000000f,-0.81000000f,0.86000000f,-0.84000000f,0.15000000f,0.64000000f,-0.20000000f,0.92000000f,0.10000000f,0.26000000f,0.75000000f,-0.50000000f,0.50000000f,-0.75000000f,0.48000000f,-0.27000000f,-0.39000000f,-0.82000000f,-0.71000000f,0.60000000f,0.99000000f,-0.84000000f,0.42000000f,-0.01000000f,0.39000000f,-0.86000000f,-0.06000000f,0.66000000f,0.70000000f,0.17000000f,0.75000000f,-0.97000000f,0.57000000f,-0.44000000f,-0.68000000f,0.13000000f,-0.20000000f,-0.69000000f,0.99000000f,0.73000000f,0.38000000f,-0.51000000f,-0.23000000f,0.26000000f,-0.85000000f,0.57000000f,-0.62000000f,0.72000000f,0.69000000f,0.88000000f,-0.09000000f,-0.30000000f,-0.30000000f,0.37000000f,-0.62000000f,-0.74000000f,-0.02000000f,-0.33000000f,-0.69000000f,0.00000000f,-0.53000000f,-0.99000000f,-0.39000000f,-0.88000000f,0.56000000f,0.09000000f,0.33000000f,0.56000000f,0.75000000f,0.01000000f,-0.68000000f,0.87000000f,0.80000000f,-0.23000000f,-0.48000000f,-0.20000000f,0.08000000f,0.64000000f,0.10000000f,-0.14000000f,0.13000000f,0.50000000f,-0.92000000f,0.43000000f,-0.61000000f,-0.04000000f,-0.90000000f,0.65000000f,0.76000000f,0.58000000f,-0.21000000f,0.63000000f,0.93000000f,-0.61000000f,0.01000000f,-0.13000000f,0.09000000f,0.89000000f,0.46000000f,0.82000000f,0.95000000f,0.23000000f,-0.86000000f,-0.16000000f,0.38000000f,0.00000000f,0.70000000f,-0.42000000f,0.56000000f,-0.55000000f,0.05000000f,0.88000000f,-0.22000000f,-0.51000000f,-0.84000000f,0.28000000f,-0.03000000f,0.74000000f,0.53000000f,0.40000000f,-0.98000000f,-0.52000000f,-0.50000000f,-0.67000000f,0.84000000f,-0.72000000f,-0.78000000f,0.14000000f,0.08000000f,-0.44000000f,-0.23000000f,0.38000000f,-0.01000000f,0.76000000f,0.26000000f,0.97000000f,0.80000000f,-0.84000000f,-0.20000000f,-0.19000000f,0.51000000f,0.42000000f,-0.51000000f,-0.81000000f,0.69000000f,0.10000000f,-0.98000000f,-0.62000000f,-0.82000000f,0.09000000f,-0.43000000f,0.54000000f,0.47000000f,0.43000000f,-0.85000000f,0.87000000f,-0.86000000f,0.24000000f,0.23000000f,-0.46000000f,-0.33000000f,0.86000000f,-0.90000000f,0.26000000f,-0.42000000f,-0.48000000f,-0.12000000f,0.55000000f,-0.28000000f,-0.49000000f,-0.40000000f,0.45000000f,0.72000000f,0.69000000f,0.10000000f,-0.20000000f,0.02000000f,0.65000000f,-0.55000000f,0.70000000f,0.27000000f,-0.11000000f,0.44000000f,0.87000000f,-0.83000000f,0.09000000f,0.60000000f,0.11000000f,0.05000000f,-0.33000000f,-0.35000000f,0.74000000f,0.23000000f,-0.91000000f,0.35000000f,-0.47000000f,0.52000000f,-0.70000000f,0.56000000f,0.24000000f,-0.60000000f,-0.60000000f,0.42000000f,-0.40000000f,-0.30000000f,-0.87000000f,0.61000000f,-0.53000000f,0.61000000f,0.85000000f,0.00000000f,-0.19000000f,-0.10000000f,-0.72000000f,-0.07000000f,-0.62000000f,0.46000000f,-0.16000000f,-0.75000000f,-0.96000000f,-0.92000000f,0.87000000f,-0.95000000f,-0.25000000f,-0.40000000f,0.63000000f,0.45000000f,-0.22000000f,-0.49000000f,0.27000000f,0.05000000f,-0.96000000f,-0.89000000f,0.43000000f,0.38000000f,0.50000000f,0.09000000f,0.78000000f,-0.73000000f,0.67000000f,0.55000000f,-0.53000000f,0.89000000f,-0.34000000f,0.99000000f,-0.29000000f,-0.04000000f,-0.42000000f,-0.34000000f,-0.74000000f,-0.36000000f,0.38000000f,0.94000000f,0.29000000f,-0.11000000f,0.10000000f,-0.08000000f,-0.21000000f,-0.18000000f,0.88000000f,-0.64000000f,-0.58000000f,-0.18000000f,0.77000000f,-0.47000000f,-0.53000000f,-0.00000000f,0.13000000f,-0.41000000f,0.71000000f,0.52000000f,-0.39000000f,-0.25000000f,0.15000000f,0.09000000f,0.49000000f,0.99000000f,-0.09000000f,0.97000000f,0.21000000f,-0.24000000f,0.76000000f,-0.25000000f,0.81000000f,-0.44000000f,0.96000000f,-0.85000000f,0.48000000f,-0.86000000f,0.12000000f,0.94000000f,-0.09000000f,-0.69000000f,0.98000000f,0.26000000f,0.63000000f,0.65000000f,0.70000000f,0.95000000f,0.96000000f,0.49000000f,-0.25000000f,0.66000000f,-0.97000000f,-0.62000000f,0.85000000f,0.04000000f,0.16000000f,0.22000000f,0.71000000f,-0.52000000f,-0.55000000f,0.08000000f,-0.85000000f,-0.87000000f,0.73000000f,0.08000000f,0.94000000f,-0.34000000f,-0.82000000f,0.22000000f,-0.25000000f,-0.92000000f,-0.96000000f,0.94000000f,-0.47000000f,0.76000000f,-0.83000000f,0.22000000f,0.42000000f,-0.80000000f,-0.22000000f,-0.84000000f,-0.52000000f,0.15000000f,0.20000000f,0.96000000f,0.20000000f,0.63000000f,-0.32000000f,-0.76000000f,0.32000000f,-0.71000000f,-0.68000000f,0.55000000f,-0.45000000f,0.59000000f,-0.41000000f,-0.10000000f,-0.62000000f,0.56000000f,0.07000000f,-0.22000000f,-0.90000000f,0.39000000f,-0.53000000f,0.98000000f,-0.55000000f,-0.31000000f,-0.48000000f,0.22000000f,-0.78000000f,-0.57000000f,-0.88000000f,-0.97000000f,0.26000000f,-0.74000000f,0.20000000f,-0.82000000f,-0.34000000f,0.27000000f,0.96000000f,-0.14000000f,-0.60000000f,-0.20000000f,-0.34000000f,0.68000000f,-0.00000000f,0.57000000f,0.87000000f,-0.48000000f,0.10000000f,0.39000000f,-0.22000000f,0.97000000f,0.45000000f,-0.41000000f,0.85000000f,-0.18000000f,-0.22000000f,-0.40000000f,0.67000000f,-0.09000000f,-0.61000000f,-0.28000000f,0.71000000f,0.45000000f,-0.27000000f,-0.67000000f,0.50000000f,-0.10000000f,-0.09000000f,-0.75000000f,0.96000000f,0.86000000f,0.27000000f,-0.83000000f,-0.35000000f,-0.30000000f,0.37000000f,0.44000000f,0.78000000f,-0.50000000f,-0.53000000f,-0.40000000f,-0.43000000f,-0.04000000f,0.46000000f,-0.57000000f,-0.60000000f,-0.13000000f,0.90000000f,0.32000000f,0.92000000f,0.79000000f,0.48000000f,-0.76000000f,0.87000000f,0.11000000f,-0.17000000f,-0.50000000f,-0.00000000f,0.02000000f,0.61000000f,0.33000000f,0.64000000f,-0.80000000f,-0.48000000f,0.91000000f,0.81000000f,-0.73000000f,-0.02000000f,0.94000000f,-0.63000000f,0.19000000f,0.39000000f,-0.50000000f,-0.91000000f,-0.99000000f,0.95000000f,-0.75000000f,0.67000000f,0.82000000f,-0.54000000f,-0.76000000f,0.50000000f,0.90000000f,0.46000000f,-0.74000000f,0.69000000f,-0.86000000f,0.72000000f,0.52000000f,0.39000000f,-0.46000000f,-0.36000000f,0.34000000f,0.21000000f,-0.44000000f,0.14000000f,0.35000000f,0.13000000f,-0.84000000f,0.95000000f,0.32000000f,-0.82000000f,-0.62000000f,-0.69000000f,-0.50000000f,0.59000000f,0.47000000f,-0.97000000f,0.15000000f,0.59000000f,0.65000000f,-0.26000000f,0.50000000f,-0.03000000f,-0.96000000f,0.97000000f,-0.99000000f,-0.67000000f,-0.73000000f,-0.48000000f,-0.64000000f,-0.84000000f,-0.94000000f,0.62000000f,0.14000000f,-0.32000000f,-0.47000000f,-0.74000000f,0.07000000f,0.05000000f,0.87000000f,-0.83000000f,0.49000000f,-0.32000000f,-0.32000000f,0.03000000f,0.51000000f,0.06000000f,-0.77000000f,0.75000000f,-0.39000000f,-0.78000000f,0.10000000f,0.95000000f,0.38000000f,-0.08000000f,-0.66000000f,-0.07000000f,0.09000000f,-0.09000000f,-0.09000000f,0.83000000f,-0.12000000f,0.43000000f,-0.65000000f,0.41000000f,0.68000000f,0.93000000f,0.88000000f,-0.24000000f,0.70000000f,-0.97000000f,-0.40000000f,-0.96000000f,-0.45000000f,-0.35000000f,-0.29000000f,0.91000000f,-0.28000000f,0.92000000f,-0.57000000f,-0.37000000f,-0.02000000f,0.37000000f,-0.37000000f,-0.01000000f,-0.48000000f,0.74000000f,-0.28000000f,0.21000000f,0.74000000f,-0.99000000f,0.45000000f,0.91000000f,-0.28000000f,-0.11000000f,-0.86000000f,-0.22000000f,0.48000000f,-0.34000000f,0.52000000f,0.17000000f,0.04000000f,0.23000000f,-0.54000000f,-0.80000000f,-0.60000000f,0.04000000f,0.47000000f,-0.14000000f,0.33000000f,0.57000000f,0.22000000f,-0.67000000f,0.02000000f,0.69000000f,0.93000000f,0.69000000f,0.93000000f,0.99000000f,0.75000000f,0.47000000f,0.21000000f,-0.42000000f,0.02000000f,0.20000000f,0.03000000f,0.12000000f,0.76000000f,0.04000000f,-0.43000000f,-0.10000000f,-0.52000000f,-0.26000000f,-0.10000000f,0.78000000f,-0.81000000f,-0.72000000f,-0.76000000f,0.87000000f,0.88000000f,0.83000000f,-0.27000000f,0.82000000f,-0.97000000f,-0.59000000f,0.80000000f,0.66000000f,0.66000000f,0.59000000f,-0.73000000f,0.03000000f,-0.16000000f,0.69000000f,-0.52000000f,0.22000000f,0.82000000f,-0.11000000f,-0.25000000f,-0.39000000f,0.56000000f,0.93000000f,-0.43000000f,-0.73000000f,-0.28000000f,-0.06000000f,-0.49000000f,-0.95000000f,0.39000000f,0.51000000f,0.29000000f,0.40000000f,-0.46000000f,-0.11000000f,0.60000000f,0.03000000f,-0.57000000f,0.24000000f,-0.55000000f,0.88000000f,-0.33000000f,0.64000000f,-0.79000000f,0.59000000f,-0.05000000f,0.94000000f,0.00000000f,0.74000000f,0.44000000f,-0.86000000f,0.23000000f,-0.03000000f,-0.66000000f,0.45000000f,0.08000000f,-0.53000000f,0.09000000f,0.98000000f,-0.28000000f,-0.10000000f,0.89000000f,0.18000000f,0.45000000f,-0.98000000f,-0.89000000f,0.47000000f,0.78000000f,-0.11000000f,0.53000000f,-0.35000000f,0.46000000f,0.00000000f,0.49000000f,-0.13000000f,-0.58000000f,-0.56000000f,0.73000000f,0.21000000f,0.20000000f,0.72000000f,-0.71000000f,-0.68000000f,-0.54000000f,0.61000000f,-0.80000000f,0.53000000f,0.90000000f,0.20000000f,0.25000000f,-0.29000000f,0.91000000f,-0.88000000f,0.04000000f,0.98000000f,-0.18000000f,-0.16000000f,0.28000000f,0.28000000f,0.60000000f,0.35000000f,-0.32000000f,0.48000000f,-0.99000000f,-0.57000000f,0.41000000f,0.93000000f,-0.33000000f,-0.69000000f,0.68000000f,-0.99000000f,0.40000000f,-0.31000000f,0.58000000f,0.70000000f,-0.95000000f,-0.97000000f,0.59000000f,-0.71000000f,-0.43000000f,0.78000000f,-0.92000000f,-0.01000000f,0.79000000f,-0.34000000f,-0.14000000f,0.25000000f,0.86000000f,0.62000000f,-0.12000000f,-0.53000000f,0.77000000f,-0.30000000f,-0.50000000f,-0.82000000f,0.76000000f,0.27000000f,-0.59000000f,0.69000000f,-0.87000000f,-0.03000000f,0.82000000f,0.05000000f,0.58000000f,0.96000000f,0.52000000f,0.04000000f,0.80000000f,-0.66000000f,-0.06000000f,0.88000000f,-0.59000000f,-0.19000000f,-0.47000000f,0.84000000f,0.15000000f,0.90000000f,-0.08000000f,0.69000000f,-0.34000000f,0.12000000f,0.14000000f,0.86000000f,-0.56000000f,-0.59000000f,0.08000000f,0.27000000f,-0.13000000f,0.00000000f,-0.00000000f,-0.47000000f,0.34000000f,0.44000000f,0.17000000f,-0.57000000f,-0.19000000f,-0.09000000f,-0.31000000f,0.03000000f,-0.60000000f,0.40000000f,0.58000000f,-0.43000000f,-0.81000000f,0.08000000f,0.04000000f,-0.28000000f,0.74000000f,0.00000000f,-0.59000000f,-0.57000000f,-0.82000000f,0.99000000f,-0.36000000f,0.44000000f,-0.51000000f,0.26000000f,0.75000000f,-0.56000000f,-0.86000000f,0.85000000f,-0.63000000f,0.49000000f,0.81000000f,-0.53000000f,0.23000000f,-0.35000000f,-0.25000000f,-0.44000000f,-0.03000000f,0.23000000f,0.98000000f,-0.37000000f,-0.25000000f,-0.60000000f,0.81000000f,0.16000000f,0.95000000f,0.77000000f,-0.18000000f,0.45000000f,-0.35000000f,0.47000000f,0.74000000f,0.65000000f,0.81000000f,-0.02000000f,-0.39000000f,-0.75000000f,0.33000000f,0.35000000f,-0.76000000f,-0.12000000f,-0.62000000f,0.06000000f,0.47000000f,0.47000000f,-0.74000000f,0.58000000f,-0.68000000f,-0.77000000f,-0.12000000f,-0.41000000f,0.26000000f,0.39000000f,-0.37000000f,0.47000000f,0.81000000f,0.00000000f,0.80000000f,-0.59000000f,0.74000000f,-0.11000000f,-0.81000000f,-0.10000000f,-0.03000000f,0.88000000f,-0.65000000f,0.58000000f,-0.93000000f,-0.09000000f,-0.30000000f,0.72000000f,-0.75000000f,-0.10000000f,0.01000000f,0.21000000f,-0.17000000f,0.37000000f,-0.96000000f,-0.44000000f,-0.69000000f,0.36000000f,0.89000000f,0.24000000f,0.06000000f,0.20000000f,-0.51000000f,0.20000000f,-0.25000000f,0.64000000f,0.06000000f,-0.91000000f,0.19000000f,-0.71000000f,-0.09000000f,0.85000000f,0.49000000f,-0.39000000f,0.80000000f,0.42000000f,0.61000000f,-0.52000000f,0.61000000f,-0.13000000f,0.48000000f,0.67000000f,0.60000000f,0.93000000f,-0.02000000f,0.58000000f,0.01000000f,-0.17000000f,-0.50000000f,-0.67000000f,-0.74000000f,-0.12000000f,0.92000000f,-0.61000000f,-0.21000000f,0.30000000f,-0.70000000f,-0.56000000f,-0.91000000f,-0.65000000f,0.13000000f,-0.36000000f,-0.91000000f,0.93000000f,0.69000000f,-0.95000000f,0.67000000f,-0.46000000f,0.26000000f,0.59000000f,0.11000000f,0.64000000f,-0.83000000f,-0.00000000f,-0.85000000f,0.50000000f,0.25000000f,0.80000000f,-0.83000000f,-0.54000000f,-0.96000000f,0.68000000f,-0.39000000f,0.84000000f,0.80000000f,0.84000000f,0.86000000f,-0.60000000f,-0.73000000f,-0.90000000f,0.22000000f,0.52000000f,-0.70000000f,-0.70000000f,0.35000000f,0.57000000f,0.55000000f,-0.94000000f,0.51000000f,0.07000000f,-0.57000000f,-0.20000000f,0.16000000f,0.66000000f,0.71000000f,0.46000000f,-0.03000000f,0.11000000f,-0.61000000f,-0.84000000f,-0.57000000f,0.12000000f,-0.37000000f,-0.97000000f,-0.83000000f,0.47000000f,0.40000000f,0.54000000f,0.79000000f,0.95000000f,0.40000000f,0.23000000f,0.45000000f,0.66000000f,0.33000000f,0.61000000f,0.90000000f,-0.66000000f,-0.18000000f,0.95000000f,0.91000000f,-0.89000000f,-0.66000000f,0.37000000f,-0.80000000f,-0.36000000f,0.02000000f,0.23000000f,-0.57000000f,-0.19000000f,-0.11000000f,-0.01000000f,-0.47000000f,-0.67000000f,-0.64000000f,0.80000000f,-0.34000000f,-0.08000000f,-0.54000000f,0.96000000f,-0.41000000f,-0.43000000f,0.52000000f,0.30000000f,-0.02000000f,0.68000000f,-0.82000000f,-0.06000000f,-0.24000000f,0.53000000f,-0.12000000f,-0.64000000f,-0.57000000f,-0.93000000f,0.17000000f,-0.62000000f,-0.57000000f,-0.18000000f,0.44000000f,-0.93000000f,0.27000000f,0.47000000f,0.02000000f,-0.66000000f,0.84000000f,-0.56000000f,-0.86000000f,-0.30000000f,0.45000000f,-0.87000000f,-0.18000000f,-0.78000000f,-0.58000000f,-0.87000000f,-0.01000000f,-0.39000000f,-0.82000000f,-0.88000000f,0.73000000f,-0.96000000f,-0.08000000f,-0.83000000f,-0.78000000f,-0.40000000f,0.55000000f,-0.96000000f,-0.72000000f,-0.48000000f,-0.58000000f,0.56000000f,0.17000000f,0.51000000f,0.81000000f,-0.72000000f,-0.46000000f,0.98000000f,0.59000000f,-0.78000000f,-0.00000000f,-0.97000000f,0.94000000f,0.53000000f,0.29000000f,0.90000000f,0.85000000f,-0.83000000f,-0.66000000f,-0.22000000f,-0.23000000f,0.41000000f,-0.13000000f,-0.10000000f,0.66000000f,-0.18000000f,0.83000000f,-0.50000000f,-0.14000000f,-0.22000000f,0.75000000f,-0.81000000f,0.56000000f,-0.60000000f,-0.11000000f,-0.24000000f,-0.37000000f,-0.44000000f,0.27000000f,-0.84000000f,0.21000000f,-0.47000000f,0.87000000f,0.91000000f,-0.95000000f,-0.09000000f,0.97000000f,0.08000000f,-0.49000000f,-0.27000000f,0.22000000f,0.50000000f,-0.54000000f,0.41000000f,0.84000000f,0.25000000f,0.24000000f,0.12000000f,0.76000000f,-0.50000000f,0.78000000f,-0.35000000f,0.66000000f,-0.78000000f,0.10000000f,0.81000000f,0.32000000f,-0.41000000f,-0.20000000f,-0.99000000f,0.80000000f,-0.91000000f,-0.80000000f,0.53000000f,0.83000000f,-0.43000000f,-0.12000000f,0.26000000f,-0.28000000f,0.33000000f,-0.88000000f,0.39000000f,0.15000000f,-0.11000000f,-0.35000000f,0.46000000f,-0.47000000f,-0.30000000f,0.42000000f,-0.33000000f,0.95000000f,0.59000000f,-0.43000000f,-0.12000000f,0.57000000f,-0.57000000f,-0.47000000f,0.60000000f,0.34000000f,0.80000000f,0.80000000f,-0.64000000f,-0.72000000f,0.01000000f,0.49000000f,-0.03000000f,0.09000000f,0.38000000f,-0.65000000f,-0.22000000f,0.61000000f,-0.82000000f,0.42000000f,-0.33000000f,0.91000000f,0.55000000f,0.45000000f,0.85000000f,-0.06000000f,-0.58000000f,0.64000000f,0.12000000f,-0.57000000f,0.68000000f,0.24000000f,-0.88000000f,-0.67000000f,-0.65000000f,-0.22000000f,-0.11000000f,-0.83000000f,-0.82000000f,0.76000000f,0.33000000f,-0.14000000f,0.97000000f,-0.18000000f,-0.04000000f,0.97000000f,0.00000000f,0.08000000f,0.15000000f,0.52000000f,-0.19000000f,-0.46000000f,-0.50000000f,-0.59000000f,0.69000000f,0.06000000f,-0.14000000f,0.27000000f,-0.75000000f,0.27000000f,-0.14000000f,0.15000000f,-0.57000000f,-0.42000000f,-0.18000000f,0.43000000f,0.44000000f,-0.65000000f,-0.87000000f,-0.49000000f,-0.37000000f,0.82000000f,-0.72000000f,0.01000000f,-0.88000000f,0.14000000f,-0.92000000f,-0.50000000f,0.83000000f,-0.14000000f,-0.16000000f,-0.50000000f,-0.05000000f,-0.63000000f,-0.90000000f,0.83000000f,0.74000000f,0.00000000f,0.44000000f,-0.66000000f,0.93000000f,0.27000000f,-0.28000000f,0.18000000f,-0.80000000f,-0.54000000f,-0.08000000f,0.22000000f,0.43000000f,0.16000000f,-0.25000000f,-0.14000000f,0.25000000f,0.55000000f,-0.85000000f,0.72000000f,0.33000000f,0.12000000f,-0.65000000f,-0.17000000f,0.26000000f,-0.40000000f,0.78000000f,-0.50000000f,0.07000000f,-0.98000000f,-0.60000000f,-0.38000000f,0.95000000f,0.75000000f,-0.10000000f,-0.30000000f,0.57000000f,-0.67000000f,0.12000000f,0.46000000f,-0.23000000f,-0.93000000f,-0.34000000f,-0.63000000f,0.42000000f,0.20000000f,0.25000000f,-0.83000000f,0.09000000f,-0.35000000f,-0.70000000f,0.73000000f,-0.71000000f,-0.65000000f,0.53000000f,0.93000000f,-0.30000000f,0.42000000f,0.10000000f,0.73000000f,-0.96000000f,-0.08000000f,0.64000000f,0.66000000f,-0.20000000f,0.62000000f,-0.90000000f,-0.63000000f,-0.55000000f,0.72000000f,0.64000000f,-0.42000000f,-0.01000000f,-0.62000000f,-0.82000000f,0.68000000f,-0.86000000f,0.48000000f,-0.04000000f,-0.02000000f,-0.91000000f,-0.99000000f,-0.33000000f,-0.46000000f,-0.06000000f,-0.92000000f,-0.23000000f,0.15000000f,0.26000000f,0.37000000f,0.23000000f,0.08000000f,0.47000000f,-0.78000000f,0.86000000f,0.52000000f,-0.27000000f,-0.01000000f,-0.54000000f,-0.42000000f,-0.25000000f,-0.20000000f,-0.13000000f,0.64000000f,0.32000000f,0.45000000f,0.34000000f,-0.13000000f,0.99000000f,0.45000000f,0.81000000f,-0.63000000f,-0.27000000f,-0.59000000f,-0.29000000f,-0.44000000f,0.89000000f,-0.01000000f,-0.17000000f,0.79000000f,0.08000000f,0.59000000f,-0.01000000f,-0.26000000f,0.10000000f,0.27000000f,0.28000000f,-0.12000000f,-0.73000000f,0.19000000f,0.16000000f,-0.12000000f,0.49000000f,0.43000000f,0.74000000f,0.56000000f,0.90000000f,0.28000000f,-0.46000000f,-0.62000000f,0.47000000f,-0.35000000f,-0.36000000f,-0.99000000f,0.89000000f,-0.64000000f,-0.33000000f,-0.43000000f,0.97000000f,-0.34000000f,0.37000000f,-0.16000000f,-0.39000000f,0.18000000f,-0.95000000f,-0.41000000f,0.41000000f,-0.21000000f,-0.82000000f,-0.93000000f,-0.90000000f,0.53000000f,0.25000000f,0.29000000f,-0.84000000f,-0.39000000f,-0.72000000f,-0.21000000f,-0.78000000f,-0.97000000f,-0.92000000f,-0.34000000f,0.81000000f,-0.08000000f,0.34000000f,0.26000000f,-0.74000000f,-0.26000000f,-0.20000000f,0.71000000f,0.67000000f,-0.08000000f,0.35000000f,-0.63000000f,-0.11000000f,-0.50000000f,-0.71000000f,-0.26000000f,-0.46000000f,0.01000000f,-0.24000000f,0.73000000f,-0.22000000f,-0.85000000f,-0.68000000f,-0.21000000f,-0.56000000f,0.16000000f,-0.04000000f,-0.77000000f,0.24000000f,-0.66000000f,0.77000000f,0.25000000f,-0.27000000f,-0.24000000f,-0.36000000f,0.89000000f,-0.65000000f,0.62000000f,0.00000000f,-0.74000000f,0.22000000f,0.82000000f,0.72000000f,0.58000000f,-0.44000000f,0.72000000f,-0.55000000f,-0.20000000f,0.11000000f,-0.62000000f,0.48000000f,-0.24000000f,-0.02000000f,-0.81000000f,0.69000000f,-0.58000000f,0.26000000f,-0.64000000f,-0.48000000f,0.79000000f,0.38000000f,0.68000000f,0.70000000f,-0.19000000f,0.79000000f,0.89000000f,-0.57000000f,-0.24000000f,-0.57000000f,-0.20000000f,-0.80000000f,0.54000000f,-0.12000000f,-0.94000000f,-0.04000000f,0.40000000f,-0.16000000f,-0.99000000f,0.12000000f,0.73000000f,-0.02000000f,0.63000000f,-0.76000000f,-0.40000000f,-0.82000000f,0.60000000f,0.48000000f,0.26000000f,-0.77000000f,-0.68000000f,0.10000000f,-0.81000000f,0.90000000f,0.97000000f,0.10000000f,-0.12000000f,-0.07000000f,-0.64000000f,0.36000000f,-0.37000000f,0.25000000f,-0.38000000f,-0.65000000f,-0.30000000f,-0.71000000f,0.35000000f,0.69000000f,0.29000000f,-0.60000000f,0.66000000f,0.53000000f,0.69000000f,-0.27000000f,0.04000000f,-0.38000000f,-0.47000000f,-0.00000000f,-0.30000000f,0.71000000f,0.44000000f,-0.50000000f,0.52000000f,0.75000000f,0.18000000f,-0.47000000f,-0.15000000f,0.46000000f,-0.42000000f,0.32000000f,-0.97000000f,0.16000000f,0.67000000f,-0.13000000f,-0.59000000f,0.49000000f,-0.02000000f,-0.91000000f,-0.05000000f,-0.89000000f,0.68000000f,-0.21000000f,0.57000000f,-0.17000000f,0.37000000f,-0.36000000f,-0.44000000f,0.40000000f,0.31000000f,-0.51000000f,-0.56000000f,0.09000000f,0.80000000f,-0.61000000f,-0.36000000f,-0.66000000f,0.29000000f,-0.00000000f,-0.72000000f,0.14000000f,-0.95000000f,-0.18000000f,-0.43000000f,-0.25000000f,0.28000000f,-0.64000000f,-0.37000000f,-0.29000000f,0.15000000f,0.48000000f,0.29000000f,-0.86000000f,0.43000000f,0.85000000f,0.56000000f,-0.66000000f,-0.93000000f,-0.00000000f,0.06000000f,0.00000000f,-0.73000000f,-0.29000000f,-0.29000000f,0.59000000f,-0.60000000f,-0.24000000f,-0.88000000f,0.99000000f,0.39000000f,0.71000000f,-0.58000000f,-0.46000000f,-0.86000000f,-0.65000000f,-0.17000000f,0.28000000f,0.85000000f,0.74000000f,0.32000000f,-0.14000000f,0.59000000f,0.37000000f,-0.94000000f,0.28000000f,-0.50000000f,-0.88000000f,0.36000000f,-0.21000000f,-0.22000000f,0.55000000f,-0.49000000f,-0.22000000f,0.33000000f,0.34000000f,0.59000000f,-0.94000000f,0.82000000f,-0.06000000f,0.82000000f,0.71000000f,0.03000000f,-0.11000000f,-0.02000000f,0.85000000f,-0.25000000f,0.86000000f,-0.30000000f,-0.99000000f,0.27000000f,0.17000000f,0.78000000f,0.24000000f,-0.85000000f,0.97000000f,0.35000000f,0.44000000f,-0.86000000f,0.22000000f,0.69000000f,0.89000000f,-0.11000000f,0.94000000f,-0.97000000f,-0.73000000f,-0.46000000f,-0.85000000f,0.33000000f,-0.01000000f,-0.37000000f,0.23000000f,-0.67000000f,0.02000000f,-0.89000000f,0.99000000f,-0.46000000f,0.40000000f,-0.60000000f,-0.35000000f,-0.13000000f,-0.38000000f,-0.18000000f,-0.50000000f,-0.52000000f,0.06000000f,0.01000000f,0.68000000f,0.69000000f,0.17000000f,-0.36000000f,0.68000000f,-0.01000000f,0.22000000f,0.96000000f,0.58000000f,-0.28000000f,0.10000000f,-0.49000000f,-0.21000000f,-0.74000000f,0.06000000f,-0.03000000f,0.36000000f,0.47000000f,-0.94000000f,-0.13000000f,0.66000000f,-0.03000000f,0.81000000f,-0.10000000f,-0.34000000f,-0.74000000f,-0.02000000f,0.36000000f,0.13000000f,-0.09000000f,-0.23000000f,-0.15000000f,-0.84000000f,0.61000000f,0.63000000f,-0.06000000f,-0.59000000f,0.49000000f,-0.83000000f,0.43000000f,-0.51000000f,-0.26000000f,-0.49000000f,0.79000000f,0.92000000f,0.69000000f,-0.51000000f,0.43000000f,0.57000000f,0.59000000f,0.62000000f,0.04000000f,-0.66000000f,0.12000000f,-0.61000000f,0.15000000f,-0.29000000f,-0.66000000f,-0.05000000f,0.27000000f,0.83000000f,0.62000000f,-0.89000000f,0.37000000f,0.08000000f,-0.41000000f,0.60000000f,0.57000000f,0.27000000f,-0.08000000f,0.62000000f,-0.75000000f,0.71000000f,-0.56000000f,-0.08000000f,0.98000000f,0.63000000f,-0.46000000f,-0.76000000f,0.75000000f,-0.99000000f,-0.80000000f,-0.58000000f,-0.16000000f,-0.55000000f,0.09000000f,0.42000000f,-0.11000000f,0.18000000f,-0.87000000f,-0.89000000f,0.04000000f,0.24000000f,-0.86000000f,-0.20000000f,0.09000000f,-0.76000000f,0.77000000f,-0.39000000f,0.60000000f,-0.61000000f,-0.04000000f,0.16000000f,0.57000000f,-0.39000000f,-0.75000000f,-0.99000000f,-0.77000000f,0.91000000f,0.58000000f,-0.29000000f,0.48000000f,0.22000000f,0.73000000f,-0.29000000f,-0.28000000f,0.93000000f,-0.78000000f,-0.19000000f,0.27000000f,-0.76000000f,-0.93000000f,-0.95000000f,-0.98000000f,0.74000000f,0.50000000f,0.09000000f,-0.76000000f,-0.31000000f,-0.95000000f,0.18000000f,0.95000000f,-0.90000000f,-0.87000000f,0.87000000f,0.39000000f,0.91000000f,0.91000000f,0.43000000f,0.21000000f,-0.33000000f,-0.82000000f,-0.85000000f,0.79000000f,0.25000000f,0.62000000f,0.44000000f,-0.19000000f,0.80000000f,0.77000000f,-0.08000000f,0.74000000f,-0.25000000f,0.90000000f,0.93000000f,0.55000000f,-0.46000000f,-0.63000000f,0.73000000f,0.51000000f,0.31000000f,-0.30000000f,-0.46000000f,-0.26000000f,0.82000000f,-0.44000000f,-0.96000000f,-0.05000000f,0.25000000f,0.67000000f,0.37000000f,-0.96000000f,-0.70000000f,-0.50000000f,-0.33000000f,-0.30000000f,0.19000000f,0.45000000f,0.96000000f,0.18000000f,-0.44000000f,0.10000000f,-0.29000000f,-0.83000000f,0.18000000f,0.14000000f,0.91000000f,-0.76000000f,0.33000000f,-0.75000000f,-0.06000000f,0.35000000f,0.35000000f,-0.22000000f,-0.42000000f,-0.34000000f,0.60000000f,-0.56000000f,0.95000000f,-0.35000000f,-0.13000000f,-0.58000000f,-0.84000000f,0.89000000f,-0.67000000f,-0.84000000f,0.78000000f,-0.29000000f,0.83000000f,-0.03000000f,0.74000000f,-0.98000000f,0.54000000f,-0.33000000f,0.40000000f,0.79000000f,0.78000000f,0.47000000f,-0.60000000f,0.66000000f,0.69000000f,-0.25000000f,-0.38000000f,0.90000000f,0.91000000f,-0.22000000f,0.55000000f,-0.30000000f,-0.48000000f,-0.16000000f,-0.09000000f,-0.23000000f,-0.68000000f,-0.62000000f,0.49000000f,0.34000000f,0.18000000f,0.88000000f,0.08000000f,0.95000000f,-0.59000000f,0.40000000f,0.52000000f,0.19000000f,0.94000000f,0.36000000f,0.96000000f,-0.31000000f,0.71000000f,-0.19000000f,0.67000000f,0.87000000f,-0.39000000f,-0.55000000f,-0.01000000f,-0.14000000f,0.28000000f,-0.75000000f,0.70000000f,-0.17000000f,0.18000000f,0.64000000f,0.50000000f,-0.83000000f,0.85000000f,0.85000000f,0.38000000f,0.04000000f,-0.46000000f,0.41000000f,-0.21000000f,-0.78000000f,0.32000000f,0.46000000f,0.95000000f,-0.16000000f,-0.31000000f,-0.24000000f,0.06000000f,-0.25000000f,-0.94000000f,0.99000000f,0.75000000f,-0.00000000f,-0.42000000f,-0.72000000f,0.61000000f,-0.06000000f,0.78000000f,0.92000000f,0.25000000f,0.90000000f,-0.37000000f,0.72000000f,0.21000000f,-0.72000000f,0.36000000f,0.76000000f,-0.53000000f,-0.36000000f,0.45000000f,-0.28000000f,-0.47000000f,-0.46000000f,0.47000000f,-0.30000000f,0.30000000f,-0.72000000f,0.73000000f,-0.61000000f,-0.39000000f,0.06000000f,0.35000000f,0.77000000f,-0.38000000f,0.52000000f,-0.03000000f,-0.85000000f,-0.20000000f,0.02000000f,0.64000000f,-0.72000000f,0.10000000f,0.11000000f,0.81000000f,-0.07000000f,0.72000000f,0.87000000f,0.81000000f,-0.21000000f,-0.03000000f,-0.86000000f,-0.18000000f,0.01000000f,-0.77000000f,-0.60000000f,0.16000000f,0.32000000f,-0.46000000f,0.00000000f,-0.00000000f,-0.77000000f,-0.04000000f,0.92000000f,0.48000000f,-0.84000000f,-0.65000000f,-0.93000000f,-0.77000000f,-0.11000000f,0.77000000f,0.86000000f,0.96000000f,0.31000000f,-0.18000000f,-0.94000000f,0.66000000f,-0.97000000f,0.51000000f,0.39000000f,-0.66000000f,-0.74000000f,0.82000000f,0.91000000f,0.90000000f,-0.22000000f,-0.89000000f,0.72000000f,0.98000000f,-0.14000000f,0.73000000f,0.68000000f,0.68000000f,-0.20000000f,0.44000000f,-0.76000000f,0.40000000f,-0.93000000f,-0.43000000f,-0.89000000f,-0.74000000f,-0.18000000f,-0.79000000f,-0.69000000f,0.32000000f,0.73000000f,-0.85000000f,-0.06000000f,0.72000000f,-0.25000000f,0.37000000f,0.76000000f,-0.20000000f,-0.70000000f,0.27000000f,-0.94000000f,0.75000000f,-0.29000000f,-0.25000000f,-0.82000000f,0.38000000f,0.50000000f,0.56000000f,0.62000000f,-0.41000000f,-0.10000000f,-0.38000000f,0.76000000f,-0.42000000f,0.89000000f,0.16000000f,-0.83000000f,-0.05000000f,-0.08000000f,-0.41000000f,0.55000000f,0.01000000f,0.93000000f,-0.79000000f,-0.46000000f,0.63000000f,-0.93000000f,-0.26000000f,0.51000000f,0.57000000f,-0.76000000f,-0.94000000f,0.21000000f,-0.83000000f,0.51000000f,-0.38000000f,-0.00000000f,-0.35000000f,-0.94000000f,0.32000000f,-0.70000000f,-0.05000000f,-0.73000000f,0.19000000f,-0.52000000f,0.32000000f,-0.48000000f,0.99000000f,0.18000000f,0.36000000f,-0.73000000f,0.48000000f,0.74000000f,0.53000000f,0.41000000f,0.85000000f,-0.42000000f,0.46000000f,0.18000000f,0.66000000f,0.99000000f,-0.55000000f,-0.02000000f,0.54000000f,-0.89000000f,-0.78000000f,0.68000000f,0.34000000f,0.90000000f,-0.34000000f,0.55000000f,-0.50000000f,-0.80000000f,-0.26000000f,-0.91000000f,-0.72000000f,0.75000000f,0.23000000f,0.87000000f,0.15000000f,0.77000000f,-0.64000000f,-0.78000000f,0.03000000f,-0.29000000f,-0.31000000f,0.02000000f,-0.16000000f,0.01000000f,0.50000000f,-0.35000000f,-0.65000000f,0.22000000f,0.53000000f,-0.25000000f,-0.31000000f,0.61000000f,0.59000000f,-0.83000000f,-0.30000000f,-0.53000000f,-0.76000000f,-0.28000000f,0.71000000f,0.52000000f,-0.77000000f,0.86000000f,-0.01000000f,0.92000000f,0.90000000f,0.20000000f,0.20000000f,0.49000000f,0.38000000f,-0.95000000f,0.59000000f,-0.25000000f,0.42000000f,-0.33000000f,0.29000000f,0.17000000f,-0.17000000f,0.78000000f,-0.75000000f,0.99000000f,-0.43000000f,-0.33000000f,-0.61000000f,0.41000000f,-0.22000000f,-0.25000000f,-0.16000000f,-0.74000000f,-0.06000000f,0.24000000f,0.60000000f,-0.96000000f,0.06000000f,-0.13000000f,-0.27000000f,-0.04000000f,-0.04000000f,0.45000000f,0.25000000f,0.83000000f,-0.31000000f,0.27000000f,-0.06000000f,-0.40000000f,0.68000000f,-0.52000000f,0.92000000f,-0.71000000f,-0.78000000f,0.93000000f,-0.84000000f,-0.51000000f,-0.30000000f,-0.15000000f,0.02000000f,-0.59000000f,-0.64000000f,0.06000000f,-0.18000000f,-0.55000000f,-0.96000000f,0.12000000f,-0.89000000f,0.97000000f,0.91000000f,-0.73000000f,0.06000000f,0.57000000f,-0.82000000f,0.59000000f,-0.86000000f,0.08000000f,0.45000000f,-0.95000000f,0.67000000f,-0.65000000f,-0.29000000f,-0.36000000f,0.04000000f,-0.82000000f,0.10000000f,0.55000000f,0.32000000f,0.55000000f,0.32000000f,0.81000000f,-0.92000000f,0.09000000f,-0.35000000f,0.88000000f,0.31000000f,0.06000000f,0.89000000f,0.00000000f,0.37000000f,-0.45000000f,0.58000000f,0.97000000f,0.95000000f,0.34000000f,-0.41000000f,-0.84000000f,0.45000000f,-0.81000000f,0.73000000f,-0.11000000f,0.06000000f,-0.68000000f,-0.92000000f,0.59000000f,0.80000000f,0.60000000f,-0.04000000f,-0.18000000f,0.44000000f,-0.83000000f,0.71000000f,0.68000000f,0.02000000f,0.62000000f,0.83000000f,0.60000000f,0.81000000f,-0.92000000f,0.86000000f,-0.57000000f,0.26000000f,0.30000000f,-0.26000000f,0.29000000f,-0.74000000f,-0.21000000f,0.65000000f,0.40000000f,0.43000000f,-0.95000000f,0.36000000f,-0.28000000f,0.12000000f,-0.89000000f,-0.23000000f,0.86000000f,-0.11000000f,0.70000000f,0.52000000f,-0.22000000f,-0.83000000f,-0.63000000f,0.08000000f,0.58000000f,-0.88000000f,-0.34000000f,-0.06000000f,0.44000000f,0.10000000f,0.36000000f,0.99000000f,0.04000000f,0.41000000f,-0.73000000f,0.41000000f,0.57000000f,-0.41000000f,0.35000000f,0.36000000f,-0.37000000f,0.64000000f,-0.70000000f,-0.33000000f,-0.57000000f,-0.38000000f,0.09000000f,0.50000000f,-0.09000000f,-0.95000000f,0.59000000f,0.07000000f,0.25000000f,0.75000000f,-0.29000000f,-0.46000000f,-0.69000000f,-0.93000000f,-0.49000000f,-0.03000000f,-0.25000000f,0.65000000f,-0.15000000f,0.79000000f,0.76000000f,-0.73000000f,0.57000000f,-0.90000000f,0.74000000f,0.99000000f,0.20000000f,0.09000000f,0.33000000f,-0.55000000f,0.42000000f,-0.98000000f,-0.26000000f,-0.48000000f,0.96000000f,0.83000000f,-0.75000000f,-0.64000000f,-0.09000000f,-0.73000000f,0.96000000f,-0.26000000f,-0.76000000f,0.83000000f,0.54000000f,0.66000000f,0.54000000f,0.64000000f,-0.58000000f,0.45000000f,-0.67000000f,0.81000000f,0.00000000f,-0.77000000f,0.66000000f,0.36000000f,0.93000000f,0.75000000f,-0.62000000f,0.65000000f,-0.52000000f,0.08000000f,0.02000000f,0.12000000f,0.35000000f,0.85000000f,0.83000000f,-0.07000000f,-0.62000000f,-0.78000000f,-0.98000000f,-0.78000000f,0.43000000f,0.53000000f,-0.55000000f,0.04000000f,0.99000000f,-0.57000000f,-0.52000000f,0.78000000f,0.11000000f,-0.00000000f,0.88000000f,0.10000000f,-0.43000000f,-0.44000000f,-0.51000000f,0.73000000f,-0.74000000f,0.53000000f,-0.26000000f,-0.58000000f,0.07000000f,-0.48000000f,0.23000000f,0.94000000f,-0.47000000f,-0.53000000f,0.04000000f,0.18000000f,-0.16000000f,-0.86000000f,-0.90000000f,-0.04000000f,0.05000000f,0.03000000f,0.53000000f,-0.11000000f,-0.86000000f,0.80000000f,0.34000000f,0.61000000f,-0.00000000f,-0.99000000f,0.55000000f,-0.20000000f,-0.84000000f,0.21000000f,-0.66000000f,-0.43000000f,-0.93000000f,-0.83000000f,0.00000000f,-0.62000000f,-0.59000000f,-0.16000000f,-0.56000000f,-0.11000000f,0.55000000f,-0.30000000f,0.96000000f,-0.67000000f,0.05000000f,0.17000000f,0.30000000f,-0.86000000f,-0.44000000f,0.05000000f,0.75000000f,-0.44000000f,-0.03000000f,-0.61000000f,-0.89000000f,0.40000000f,0.35000000f,-0.42000000f,0.35000000f,-0.97000000f,0.58000000f,0.32000000f,0.84000000f,-0.13000000f,0.01000000f,0.89000000f,0.60000000f,0.06000000f,0.80000000f,0.67000000f,-0.54000000f,0.59000000f,-0.52000000f,0.06000000f,0.86000000f,0.19000000f,0.04000000f,0.75000000f,0.86000000f,0.11000000f,0.00000000f,-0.72000000f,-0.85000000f,0.09000000f,0.78000000f,-0.68000000f,0.90000000f,0.06000000f,0.38000000f,-0.14000000f,0.97000000f,0.07000000f,-0.60000000f,0.60000000f,-0.78000000f,-0.38000000f,0.01000000f,-0.99000000f,0.61000000f,0.53000000f,-0.65000000f,0.16000000f,0.32000000f,0.61000000f,-0.94000000f,0.88000000f,0.75000000f,-0.05000000f,-0.24000000f,-0.84000000f,-0.49000000f,0.89000000f,0.39000000f,0.22000000f,0.20000000f,-0.29000000f,0.74000000f,-0.01000000f,0.08000000f,-0.24000000f,-0.80000000f,0.57000000f,-0.16000000f,0.00000000f,-0.48000000f,0.68000000f,-0.06000000f,0.78000000f,-0.66000000f,-0.91000000f,0.30000000f,-0.72000000f,-0.20000000f,0.28000000f,-0.94000000f,-0.44000000f,-0.29000000f,0.27000000f,-0.84000000f,0.86000000f,-0.47000000f,-0.62000000f,0.29000000f,-0.59000000f,0.71000000f,-0.10000000f,-0.47000000f,-0.40000000f,-0.62000000f,-0.45000000f,0.01000000f,-0.88000000f,-0.47000000f,-0.11000000f,-0.27000000f,0.33000000f,-0.12000000f,0.68000000f,-0.96000000f,0.30000000f,-0.73000000f,0.13000000f,0.70000000f,0.78000000f,0.18000000f,0.35000000f,-0.82000000f,-0.65000000f,-0.72000000f,0.44000000f,-0.03000000f,0.12000000f,-0.68000000f,-0.68000000f,0.48000000f,0.89000000f,-0.32000000f,0.84000000f,0.32000000f,0.14000000f,-0.68000000f,0.44000000f,0.17000000f,0.56000000f,-0.76000000f,0.24000000f,-0.88000000f,0.04000000f,-0.46000000f,-0.34000000f,0.28000000f,-0.31000000f,-0.97000000f,-0.21000000f,-0.78000000f,-0.84000000f,-0.22000000f,-0.73000000f,0.07000000f,-0.56000000f,0.01000000f,-0.75000000f,-0.19000000f,-0.41000000f,0.78000000f,-0.23000000f,0.93000000f,0.91000000f,0.96000000f,-0.41000000f,-0.27000000f,-0.20000000f,-0.59000000f,0.25000000f,0.38000000f,-0.63000000f,0.24000000f,0.62000000f,0.44000000f,0.71000000f,-0.55000000f,0.61000000f,0.50000000f,-0.56000000f,0.77000000f,0.44000000f,0.25000000f,-0.17000000f,-0.32000000f,0.83000000f,-0.33000000f,0.16000000f,0.90000000f,-0.58000000f,-0.63000000f,0.28000000f,-0.65000000f,0.02000000f,0.60000000f,0.67000000f,0.30000000f,0.09000000f,-0.48000000f,0.54000000f,-0.07000000f,0.32000000f,-0.51000000f,-0.83000000f,0.67000000f,0.86000000f,0.48000000f,-0.14000000f,-0.03000000f,-0.49000000f,0.17000000f,-0.59000000f,-0.21000000f,-0.26000000f,-0.93000000f,0.80000000f,-0.35000000f,0.52000000f,-0.40000000f,-0.89000000f,-0.77000000f,-0.53000000f,0.56000000f,-0.58000000f,0.45000000f,0.54000000f,0.81000000f,0.05000000f,0.54000000f,0.11000000f,0.78000000f,0.53000000f,0.88000000f,0.13000000f,-0.95000000f,-0.23000000f,-0.40000000f,0.29000000f,-0.37000000f,-0.57000000f,0.39000000f,0.24000000f,0.14000000f,0.86000000f,0.36000000f,-0.72000000f,0.12000000f,-0.54000000f,0.60000000f,0.22000000f,0.32000000f,-0.02000000f,0.69000000f,-0.43000000f,-0.64000000f,0.92000000f,0.37000000f,0.07000000f,0.16000000f,0.05000000f,0.11000000f,0.19000000f,0.21000000f,-0.60000000f,-0.02000000f,0.43000000f,0.84000000f,-0.97000000f,-0.12000000f,-0.06000000f,-0.11000000f,-0.35000000f,0.77000000f,-0.12000000f,-0.44000000f,-0.02000000f,-0.09000000f,0.34000000f,0.37000000f,0.17000000f,-0.63000000f,0.07000000f,0.74000000f,0.57000000f,-0.97000000f,0.57000000f,0.22000000f,0.47000000f,-0.92000000f,-0.97000000f,-0.01000000f,0.47000000f,0.08000000f,-0.31000000f,0.74000000f,0.79000000f,-0.68000000f,-0.89000000f,-0.10000000f,-0.80000000f,-0.91000000f,0.06000000f,-0.40000000f,0.76000000f,0.27000000f,0.79000000f,0.96000000f,-0.95000000f,0.62000000f,-0.09000000f,0.41000000f,0.03000000f,-0.03000000f,-0.85000000f,-0.51000000f,0.92000000f,-0.67000000f,0.44000000f,0.20000000f,-0.29000000f,-0.01000000f,0.48000000f,0.76000000f,-0.74000000f,-0.95000000f,-0.62000000f,-0.46000000f,0.55000000f,0.61000000f,-0.51000000f,0.26000000f,0.53000000f,-0.99000000f,0.28000000f,0.53000000f,-0.41000000f,-0.92000000f,0.38000000f,-0.53000000f,-0.14000000f,0.87000000f,0.80000000f,0.07000000f,-0.76000000f,0.25000000f,-0.75000000f,-0.83000000f,-0.83000000f,-0.01000000f,-0.08000000f,0.92000000f,-0.33000000f,0.67000000f,0.08000000f,-0.11000000f,0.35000000f,-0.17000000f,0.70000000f,0.23000000f,-0.64000000f,-0.91000000f,0.56000000f,0.82000000f,0.42000000f,-0.48000000f,0.54000000f,-0.04000000f,0.00000000f,0.05000000f,0.00000000f,-0.11000000f,0.02000000f,-0.26000000f,0.46000000f,0.04000000f,0.84000000f,-0.54000000f,-0.33000000f,-0.55000000f,-0.00000000f,-0.90000000f,0.73000000f,-0.19000000f,-0.35000000f,-0.40000000f,-0.09000000f,-0.15000000f,0.92000000f,-0.20000000f,-0.95000000f,-0.85000000f,0.92000000f,0.10000000f,0.61000000f,0.02000000f,-0.01000000f,0.54000000f,0.07000000f,0.85000000f,0.50000000f,-0.84000000f,0.14000000f,-0.38000000f,0.40000000f,0.22000000f,-0.49000000f,0.11000000f,-0.49000000f,-0.23000000f,-0.39000000f,-0.25000000f,-0.31000000f,0.65000000f,-0.52000000f,-0.38000000f,0.46000000f,-0.73000000f,0.91000000f,-0.71000000f,0.77000000f,0.65000000f,-0.05000000f,0.31000000f,-0.60000000f,0.08000000f,-0.26000000f,0.25000000f,0.38000000f,-0.68000000f,0.55000000f,0.83000000f,-0.63000000f,-0.75000000f,-0.55000000f,0.08000000f,-0.42000000f,0.35000000f,-0.33000000f,-0.45000000f,0.00000000f,0.67000000f,0.78000000f,-0.59000000f,0.55000000f,-0.90000000f,-0.47000000f,0.91000000f,0.00000000f,-0.15000000f,0.34000000f,0.75000000f,-0.92000000f,0.15000000f,0.21000000f,0.14000000f,-0.14000000f,0.22000000f,-0.19000000f,0.42000000f,0.31000000f,0.75000000f,-0.66000000f,-0.24000000f,0.37000000f,0.40000000f,0.25000000f,-0.15000000f,0.47000000f,0.03000000f,0.14000000f,-0.32000000f,0.56000000f,-0.58000000f,0.88000000f,-0.67000000f,0.96000000f,0.14000000f,-0.78000000f,0.98000000f,-0.77000000f,-0.52000000f,-0.27000000f,0.94000000f,0.55000000f,0.03000000f,0.90000000f,-0.56000000f,-0.43000000f,-0.58000000f,-0.27000000f,-0.79000000f,-0.87000000f,-0.71000000f,-0.22000000f,-0.48000000f,-0.38000000f,-0.96000000f,0.58000000f,0.24000000f,-0.28000000f,-0.47000000f,0.33000000f,0.10000000f,-0.44000000f,-0.94000000f,0.29000000f,-0.16000000f,0.43000000f,-0.79000000f,0.81000000f,-0.89000000f,-0.63000000f,-0.76000000f,-0.15000000f,-0.71000000f,-0.77000000f,0.13000000f,0.67000000f,-0.15000000f,0.86000000f,0.12000000f,-0.37000000f,0.42000000f,-0.82000000f,-0.64000000f,0.42000000f,0.21000000f,-0.37000000f,-0.88000000f,0.14000000f,-0.80000000f,0.22000000f,0.52000000f,-0.84000000f,-0.39000000f,0.89000000f,0.23000000f,-0.21000000f,-0.62000000f,0.49000000f,0.35000000f,-0.13000000f,-0.40000000f,0.94000000f,-0.10000000f,-0.71000000f,-0.54000000f,0.75000000f,0.28000000f,-0.00000000f,-0.78000000f,-0.12000000f,0.42000000f,0.28000000f,-0.99000000f,0.82000000f,-0.99000000f,-0.97000000f,0.61000000f,0.29000000f,-0.76000000f,0.97000000f,-0.57000000f,-0.50000000f,0.20000000f,0.38000000f,-0.95000000f,0.08000000f,-0.57000000f,-0.98000000f,0.24000000f,-0.41000000f,0.40000000f,0.50000000f,0.59000000f,0.44000000f,-0.76000000f,-0.97000000f,-0.65000000f,-0.07000000f,-0.12000000f,-0.03000000f,0.79000000f,0.87000000f,-0.63000000f,-0.09000000f,0.16000000f,-0.47000000f,0.62000000f,0.55000000f,0.17000000f,0.32000000f,-0.44000000f,0.44000000f,0.61000000f,-0.52000000f,0.51000000f,-0.49000000f,0.87000000f,-0.34000000f,0.63000000f,-0.53000000f,-0.30000000f,-0.50000000f,-0.11000000f,-0.82000000f,-0.63000000f,-0.27000000f,0.31000000f,-0.60000000f,-0.83000000f,0.84000000f,0.90000000f,-0.13000000f,0.61000000f,-0.29000000f,-0.62000000f,0.51000000f,-0.32000000f,0.01000000f,-0.35000000f,-0.22000000f,-0.03000000f,-0.65000000f,0.25000000f,0.23000000f,-0.70000000f,0.09000000f,-0.34000000f,-0.82000000f,-0.60000000f,0.27000000f,0.48000000f,-0.04000000f,0.91000000f,0.40000000f,-0.66000000f,0.85000000f,-0.20000000f,0.85000000f,0.61000000f,-0.96000000f,-0.25000000f,-0.55000000f,-0.75000000f,0.00000000f,0.78000000f,-0.92000000f,0.29000000f,-0.00000000f,0.66000000f,0.03000000f,0.47000000f,-0.44000000f,-0.43000000f,-0.63000000f,0.82000000f,-0.00000000f,-0.88000000f,-0.14000000f,-0.55000000f,0.37000000f,0.00000000f,0.95000000f,0.12000000f,0.95000000f,0.22000000f,-0.98000000f,0.82000000f,-0.44000000f,0.37000000f,-0.09000000f,-0.92000000f,0.52000000f,-0.26000000f,-0.37000000f,0.95000000f,0.74000000f,0.84000000f,-0.97000000f,0.09000000f,-0.33000000f,-0.87000000f,-0.06000000f,0.81000000f,-0.85000000f,-0.68000000f,-0.67000000f,0.65000000f,-0.95000000f,0.60000000f,-0.55000000f,-0.45000000f,0.50000000f,0.54000000f,-0.18000000f,-0.00000000f,-0.53000000f,0.68000000f,0.88000000f,0.36000000f,-0.37000000f,0.58000000f,-0.90000000f,0.69000000f,-0.69000000f,0.10000000f,0.40000000f,-0.88000000f,-0.91000000f,-0.90000000f,-0.18000000f,0.47000000f,-0.60000000f,0.17000000f,-0.13000000f,0.64000000f,-0.24000000f,-0.42000000f,-0.89000000f,-0.47000000f,0.24000000f,-0.09000000f,0.13000000f,0.22000000f,0.35000000f,0.49000000f,0.73000000f,-0.97000000f,-0.58000000f,0.49000000f,0.20000000f,0.21000000f,-0.24000000f,0.16000000f,-0.77000000f,0.02000000f,-0.35000000f,0.06000000f,0.83000000f,-0.04000000f,-0.87000000f,-0.61000000f,0.78000000f,0.25000000f,-0.49000000f,-0.73000000f,-0.13000000f,0.95000000f,-0.59000000f,0.41000000f,-0.97000000f,-0.53000000f,-0.10000000f,-0.45000000f,-0.86000000f,0.57000000f,-0.58000000f,-0.78000000f,0.51000000f,-0.05000000f,-0.57000000f,0.11000000f,0.46000000f,0.66000000f,-0.48000000f,0.51000000f,-0.01000000f,-0.53000000f,-0.76000000f,0.19000000f,-0.01000000f,0.62000000f,-0.76000000f,0.49000000f,0.13000000f,-0.44000000f,0.01000000f,0.98000000f,-0.33000000f,-0.18000000f,-0.00000000f,0.27000000f,0.58000000f,0.94000000f,-0.21000000f,-0.79000000f,0.78000000f,0.15000000f,-0.19000000f,-0.60000000f,0.66000000f,0.53000000f,-0.13000000f,-0.91000000f,-0.96000000f,0.16000000f,-0.19000000f,-0.40000000f,-0.79000000f,-0.18000000f,0.66000000f,-0.17000000f,0.80000000f,0.90000000f,0.91000000f,0.43000000f,-0.83000000f,0.74000000f,-0.88000000f,-0.41000000f,0.07000000f,-0.25000000f,-0.53000000f,-0.75000000f,-0.43000000f,-0.62000000f,-0.35000000f,0.90000000f,-0.05000000f,0.75000000f,-0.76000000f,0.87000000f,-0.51000000f,0.16000000f,0.11000000f,-0.79000000f,0.29000000f,0.36000000f,0.56000000f,-0.85000000f,-0.51000000f,-0.04000000f,0.63000000f,0.75000000f,0.66000000f,-0.65000000f,-0.33000000f,-0.58000000f,0.09000000f,-0.50000000f,-0.70000000f,-0.75000000f,0.45000000f,-0.75000000f,0.21000000f,-0.20000000f,-0.39000000f,0.48000000f,0.97000000f,-0.03000000f,0.24000000f,-0.18000000f,-0.48000000f,0.46000000f,-0.04000000f,-0.71000000f,-0.11000000f,0.89000000f,0.56000000f,-0.52000000f,0.76000000f,0.44000000f,0.19000000f,0.83000000f,0.93000000f,-0.51000000f,0.83000000f,0.73000000f,0.12000000f,0.52000000f,-0.97000000f,0.42000000f,0.91000000f,-0.17000000f,0.13000000f,0.44000000f,-0.03000000f,0.54000000f,0.48000000f,-0.25000000f,-0.92000000f,-0.46000000f,0.39000000f,0.82000000f,-0.23000000f,0.05000000f,0.66000000f,-0.08000000f,0.60000000f,0.14000000f,-0.20000000f,-0.32000000f,-0.10000000f,-0.21000000f,0.12000000f,0.56000000f,-0.73000000f,0.63000000f,0.09000000f,0.97000000f,0.10000000f,-0.88000000f,0.71000000f,0.25000000f,-0.62000000f,-0.30000000f,-0.25000000f,-0.64000000f,0.35000000f,0.91000000f,0.57000000f,0.08000000f,-0.97000000f,-0.41000000f,-0.94000000f,-0.91000000f,-0.11000000f,0.57000000f,-0.68000000f,-0.37000000f,-0.39000000f,0.83000000f,0.31000000f,-0.15000000f,0.81000000f,-0.53000000f,0.63000000f,-0.65000000f,0.92000000f,-0.40000000f,-0.35000000f,0.05000000f,0.84000000f,0.63000000f,0.12000000f,-0.97000000f,0.98000000f,0.21000000f,0.91000000f,-0.86000000f,-0.12000000f,-0.77000000f,0.56000000f,0.66000000f,-0.60000000f,0.67000000f,-0.36000000f,-0.33000000f,0.39000000f,-0.21000000f,0.22000000f,0.82000000f,-0.51000000f,0.86000000f,0.28000000f,-0.07000000f,0.13000000f,-0.91000000f,-0.83000000f,-0.60000000f,-0.88000000f,0.42000000f,0.63000000f,-0.70000000f,0.54000000f,0.70000000f,0.38000000f,-0.71000000f,-0.15000000f,0.87000000f,0.07000000f,0.81000000f,-0.33000000f,-0.87000000f,-0.86000000f,0.85000000f,0.37000000f,-0.17000000f,0.71000000f,0.87000000f,-0.56000000f,0.06000000f,-0.66000000f,0.79000000f,-0.17000000f,0.13000000f,-0.22000000f,-0.75000000f,0.65000000f,0.14000000f,0.25000000f,0.56000000f,0.63000000f,-0.68000000f,-0.11000000f,0.91000000f,0.12000000f,-0.01000000f,-0.25000000f,-0.76000000f,-0.93000000f,0.66000000f,0.55000000f,0.43000000f,-0.35000000f,0.60000000f,-0.01000000f,-0.68000000f,-0.94000000f,-0.34000000f,-0.47000000f,0.87000000f,0.78000000f,0.10000000f,0.61000000f,-0.34000000f,0.19000000f,-0.24000000f,-0.20000000f,0.65000000f,-0.04000000f,-0.46000000f,0.08000000f,0.10000000f,0.54000000f,0.28000000f,-0.33000000f,-0.89000000f,0.88000000f,-0.54000000f,-0.04000000f,0.22000000f,0.53000000f,0.70000000f,0.07000000f,-0.65000000f,-0.86000000f,-0.72000000f,-0.61000000f,0.15000000f,-0.33000000f,-0.46000000f,0.96000000f,0.51000000f,0.86000000f,0.84000000f,0.03000000f,-0.62000000f,0.54000000f,-0.40000000f,-0.73000000f,0.04000000f,-0.40000000f,0.23000000f,-0.40000000f,0.28000000f,-0.66000000f,0.71000000f,0.33000000f,0.00000000f,0.59000000f,0.08000000f,0.81000000f,-0.02000000f,0.35000000f,-0.57000000f,0.92000000f,-0.76000000f,0.55000000f,-0.28000000f,0.53000000f,-0.84000000f,-0.76000000f,0.62000000f,-0.86000000f,0.97000000f,0.33000000f,-0.31000000f,-0.70000000f,0.51000000f,0.21000000f,-0.88000000f,-0.14000000f,0.17000000f,0.93000000f,0.34000000f,-0.38000000f,-0.71000000f,-0.68000000f,-0.99000000f,-0.80000000f,-0.26000000f,0.80000000f,0.39000000f,0.65000000f,0.89000000f,-0.11000000f,0.27000000f,0.59000000f,0.72000000f,0.88000000f,0.41000000f,0.27000000f,-0.54000000f,0.61000000f,-0.24000000f,0.64000000f,0.39000000f,0.06000000f,-0.65000000f,-0.23000000f,-0.43000000f,-0.74000000f,0.23000000f,0.06000000f,-0.18000000f,-0.72000000f,0.30000000f,0.07000000f,-0.90000000f,-0.49000000f,-0.50000000f,0.90000000f,0.73000000f,-0.00000000f,0.12000000f,-0.03000000f,0.50000000f,-0.15000000f,0.70000000f,-0.82000000f,0.54000000f,0.73000000f,-0.49000000f,-0.50000000f,-0.22000000f,-0.57000000f,0.58000000f,-0.73000000f,-0.69000000f,-0.58000000f,-0.81000000f,-0.48000000f,0.92000000f,-0.83000000f,-0.67000000f,-0.43000000f,-0.64000000f,0.53000000f,0.00000000f,-0.71000000f,-0.36000000f,0.38000000f,0.92000000f,0.98000000f,-0.60000000f,-0.52000000f,0.11000000f,0.78000000f,-0.40000000f,0.81000000f,-0.50000000f,-0.93000000f,-0.04000000f,-0.65000000f,0.44000000f,-0.66000000f,-0.23000000f,0.09000000f,-0.14000000f,-0.40000000f,0.26000000f,0.82000000f,0.68000000f,0.61000000f,0.93000000f,0.02000000f,-0.86000000f,-0.74000000f,-0.81000000f,-0.84000000f,-0.64000000f,-0.70000000f,-0.36000000f,0.83000000f,-0.57000000f,-0.74000000f,-0.22000000f,0.51000000f,-0.96000000f,-0.07000000f,-0.57000000f,0.18000000f,0.95000000f,0.25000000f,0.76000000f,-0.59000000f,-0.09000000f,-0.74000000f,0.33000000f,0.64000000f,-0.90000000f,0.62000000f,-0.16000000f,-0.69000000f,0.46000000f,-0.86000000f,0.21000000f,-0.25000000f,0.27000000f,0.66000000f,0.63000000f,-0.19000000f,-0.16000000f,-0.31000000f,-0.37000000f,0.99000000f,0.96000000f,-0.84000000f,-0.05000000f,-0.21000000f,0.05000000f,-0.22000000f,-0.09000000f,0.32000000f,0.61000000f,0.94000000f,-0.30000000f,0.73000000f,-0.79000000f,-0.84000000f,0.36000000f,-0.34000000f,0.00000000f,0.19000000f,0.14000000f,-0.94000000f,-0.98000000f,0.93000000f,0.09000000f,-0.75000000f,0.53000000f,-0.39000000f,-0.95000000f,-0.21000000f,0.17000000f,0.87000000f,0.21000000f,-0.29000000f,0.15000000f,-0.96000000f,-0.30000000f,-0.13000000f,0.43000000f,-0.01000000f,-0.08000000f,0.57000000f,0.77000000f,0.98000000f,-0.74000000f,-0.89000000f,0.79000000f,-0.10000000f,-0.15000000f,0.28000000f,0.47000000f,-0.62000000f,0.86000000f,0.77000000f,0.21000000f,-0.22000000f,0.63000000f,-0.42000000f,-0.10000000f,0.42000000f,0.02000000f,-0.15000000f,-0.74000000f,0.66000000f,-0.69000000f,-0.82000000f,-0.39000000f,0.17000000f,-0.16000000f,-0.04000000f,-0.69000000f,0.97000000f,-0.33000000f,0.74000000f,-0.69000000f,-0.01000000f,-0.87000000f,0.43000000f,0.99000000f,-0.18000000f,-0.37000000f,0.86000000f,-0.96000000f,0.97000000f,-0.62000000f,-0.02000000f,0.81000000f,-0.21000000f,0.78000000f,-0.36000000f,0.79000000f,0.14000000f,0.04000000f,0.13000000f,0.77000000f,0.84000000f,-0.21000000f,-0.24000000f,0.50000000f,-0.46000000f,-0.64000000f,-0.43000000f,-0.26000000f,-0.08000000f,-0.14000000f,-0.70000000f,0.77000000f,-0.59000000f,-0.39000000f,0.60000000f,-0.06000000f,0.42000000f,-0.83000000f,-0.43000000f,0.90000000f,0.76000000f,-0.52000000f,-0.92000000f,-0.22000000f,-0.15000000f,-0.54000000f,0.87000000f,0.20000000f,0.80000000f,0.93000000f,-0.14000000f,-0.33000000f,-0.83000000f,0.20000000f,-0.98000000f,0.18000000f,0.32000000f,-0.65000000f,0.00000000f,-0.22000000f,0.89000000f,-0.07000000f,-0.31000000f,0.05000000f,-0.49000000f,-0.58000000f,0.11000000f,-0.23000000f,0.18000000f,-0.58000000f,-0.30000000f,-0.83000000f,0.39000000f,0.56000000f,-0.49000000f,0.45000000f,-0.79000000f,0.79000000f,-0.67000000f,0.67000000f,-0.15000000f,0.32000000f,-0.91000000f,0.46000000f,0.11000000f,0.49000000f,0.78000000f,0.33000000f,-0.66000000f,-0.64000000f,0.63000000f,-0.42000000f,-0.25000000f,-0.80000000f,-0.24000000f,-0.69000000f,0.56000000f,0.84000000f,0.77000000f,0.74000000f,-0.39000000f,0.54000000f,0.83000000f,0.22000000f,-0.98000000f,0.26000000f,0.17000000f,0.63000000f,0.00000000f,0.55000000f,-0.92000000f,0.94000000f,-0.32000000f,-0.87000000f,-0.74000000f,0.11000000f,0.61000000f,0.55000000f,-0.72000000f,0.19000000f,-0.44000000f,-0.97000000f,-0.25000000f,-0.94000000f,0.75000000f,-0.41000000f,-0.40000000f,-0.83000000f,-0.82000000f,-0.51000000f,-0.26000000f,0.49000000f,0.98000000f,0.26000000f,0.91000000f,0.30000000f,-0.37000000f,0.50000000f,-0.77000000f,0.39000000f,-0.02000000f,0.22000000f,-0.91000000f,0.25000000f,0.98000000f,0.92000000f,0.85000000f,-0.23000000f,-0.00000000f,-0.35000000f,-0.63000000f,0.88000000f,0.39000000f,0.74000000f,-0.04000000f,0.34000000f,0.02000000f,-0.82000000f,0.73000000f,0.33000000f,-0.59000000f,0.47000000f,0.56000000f,0.48000000f,-0.34000000f,0.84000000f,-0.68000000f,-0.28000000f,0.96000000f,-0.06000000f,0.30000000f,-0.75000000f,0.91000000f,0.09000000f,0.29000000f,-0.84000000f,0.97000000f,-0.66000000f,0.52000000f,-0.00000000f,0.56000000f,-0.46000000f,0.29000000f,0.49000000f,0.64000000f,0.77000000f,-0.24000000f,0.20000000f,0.34000000f,0.40000000f,0.20000000f,0.85000000f,-0.80000000f,0.28000000f,0.93000000f,0.72000000f,-0.30000000f,0.62000000f,0.61000000f,-0.63000000f,-0.66000000f,-0.46000000f,0.95000000f,0.05000000f,-0.47000000f,0.83000000f,0.02000000f,-0.33000000f,-0.35000000f,0.38000000f,-0.51000000f,0.11000000f,0.52000000f,0.14000000f,0.87000000f,-0.71000000f,-0.87000000f,-0.22000000f,0.52000000f,0.82000000f,-0.77000000f,0.72000000f,0.48000000f,-0.11000000f,-0.77000000f,0.64000000f,-0.61000000f,0.09000000f,-0.16000000f,-0.30000000f,0.56000000f,0.50000000f,-0.66000000f,-0.39000000f,0.81000000f,0.42000000f,0.29000000f,-0.32000000f,0.67000000f,-0.59000000f,-0.60000000f,0.74000000f,0.93000000f,-0.49000000f,-0.34000000f,-0.35000000f,0.32000000f,-0.75000000f,0.32000000f,-0.03000000f,-0.39000000f,0.61000000f,-0.84000000f,-0.46000000f,-0.33000000f,0.99000000f,-0.71000000f,0.71000000f,-0.48000000f,0.27000000f,0.65000000f,-0.08000000f,0.86000000f,-0.69000000f,0.58000000f,0.10000000f,-0.64000000f,0.82000000f,-0.66000000f,-0.65000000f,0.58000000f,-0.42000000f,0.85000000f,-0.34000000f,0.99000000f,-0.02000000f,-0.05000000f,0.51000000f,-0.40000000f,0.24000000f,0.61000000f,-0.13000000f,-0.78000000f,-0.31000000f,-0.89000000f,0.62000000f,0.30000000f,-0.27000000f,-0.68000000f,-0.41000000f,-0.77000000f,0.64000000f,0.94000000f,0.01000000f,0.29000000f,-0.45000000f,-0.15000000f,-0.73000000f,0.78000000f,-0.27000000f,-0.80000000f,-0.70000000f,-0.30000000f,-0.69000000f,0.38000000f,-0.31000000f,0.37000000f,0.08000000f,0.97000000f,-0.32000000f,-0.01000000f,0.70000000f,0.61000000f,0.39000000f,0.58000000f,0.35000000f,0.32000000f,0.17000000f,0.86000000f,-0.04000000f,-0.75000000f,0.98000000f,0.81000000f,-0.58000000f,0.78000000f,0.94000000f,0.65000000f,0.89000000f,-0.36000000f,-0.43000000f,0.27000000f,0.99000000f,-0.99000000f,0.11000000f,0.04000000f,-0.08000000f,-0.16000000f,0.20000000f,-0.66000000f,0.87000000f,-0.05000000f,-0.57000000f,0.27000000f,0.90000000f,-0.41000000f,-0.60000000f,0.52000000f,-0.95000000f,0.30000000f,0.26000000f,0.54000000f,-0.71000000f,0.44000000f,-0.70000000f,-0.29000000f,-0.84000000f,-0.21000000f,-0.59000000f,0.55000000f,-0.98000000f,-0.85000000f,-0.98000000f,0.84000000f,0.99000000f,0.25000000f,0.14000000f,-0.42000000f,-0.91000000f,-0.48000000f,-0.52000000f,-0.49000000f,0.33000000f,0.05000000f,-0.46000000f,0.97000000f,0.89000000f,-0.12000000f,-0.45000000f,0.91000000f,-0.13000000f,-0.22000000f,-0.74000000f,-0.34000000f,0.00000000f,0.34000000f,0.16000000f,-0.31000000f,-0.11000000f,0.77000000f,-0.70000000f,0.81000000f,0.84000000f,-0.30000000f,0.18000000f,0.98000000f,-0.12000000f,-0.36000000f,0.48000000f,0.26000000f,-0.87000000f,0.21000000f,0.64000000f,0.36000000f,-0.85000000f,-0.04000000f,0.44000000f,-0.89000000f,0.94000000f,-0.98000000f,0.19000000f,-0.40000000f,-0.48000000f,-0.36000000f,0.77000000f,0.29000000f,0.18000000f,-0.02000000f,-0.72000000f,0.44000000f,0.35000000f,0.42000000f,-0.27000000f,0.51000000f,0.94000000f,0.14000000f,0.53000000f,-0.56000000f,-0.07000000f,0.37000000f,-0.33000000f,0.83000000f,-0.53000000f,0.33000000f,0.86000000f,-0.13000000f,-0.52000000f,0.11000000f,-0.23000000f,0.25000000f,-0.65000000f,-0.06000000f,0.42000000f,0.71000000f,0.94000000f,-0.78000000f,0.66000000f,0.96000000f,0.54000000f,0.20000000f,-0.36000000f,-0.52000000f,-0.26000000f,-0.59000000f,0.42000000f,0.34000000f,-0.23000000f,-0.35000000f,0.67000000f,0.49000000f,0.22000000f,-0.31000000f,0.17000000f,-0.34000000f,0.13000000f,0.06000000f,0.78000000f,-0.24000000f,-0.50000000f,0.41000000f,-0.18000000f,-0.93000000f,-0.98000000f,-0.02000000f,-0.16000000f,-0.11000000f,-0.37000000f,-0.66000000f,-0.63000000f,0.14000000f,-0.87000000f,-0.60000000f,0.60000000f,-0.45000000f,0.75000000f,-0.41000000f,0.62000000f,0.24000000f,0.71000000f,0.63000000f,0.77000000f,0.11000000f,-0.99000000f,0.03000000f,0.50000000f,-0.72000000f,-0.77000000f,-0.25000000f,0.00000000f,0.51000000f,-0.77000000f,-0.35000000f,-0.91000000f,0.94000000f,0.40000000f,0.89000000f,0.25000000f,-0.42000000f,-0.24000000f,-0.15000000f,-0.85000000f,0.32000000f,-0.42000000f,0.66000000f,0.57000000f,-0.89000000f,-0.08000000f,0.76000000f,-0.57000000f,0.09000000f,-0.26000000f,-0.30000000f,-0.46000000f,-0.44000000f,-0.06000000f,0.79000000f,0.67000000f,-0.60000000f,-0.59000000f,-0.05000000f,0.11000000f,-0.60000000f,-0.22000000f,-0.99000000f,0.51000000f,-0.30000000f,0.70000000f,0.85000000f,0.00000000f,-0.55000000f,-0.26000000f,-0.28000000f,-0.55000000f,0.85000000f,0.49000000f,-0.33000000f,-0.95000000f,-0.34000000f,-0.26000000f,-0.41000000f,-0.37000000f,-0.07000000f,0.84000000f,-0.94000000f,0.36000000f,-0.97000000f,0.04000000f,0.52000000f,0.36000000f,0.36000000f,-0.41000000f,-0.66000000f,0.91000000f,0.99000000f,-0.70000000f,-0.36000000f,0.20000000f,0.97000000f,-0.87000000f,-0.32000000f,-0.86000000f,-0.85000000f,-0.33000000f,0.69000000f,0.44000000f,-0.25000000f,-0.44000000f,-0.44000000f,-0.90000000f,0.93000000f,0.74000000f,-0.52000000f,0.71000000f,0.97000000f,0.13000000f,0.04000000f,0.42000000f,0.08000000f,-0.71000000f,0.08000000f,0.13000000f,-0.42000000f,-0.08000000f,-0.49000000f,-0.13000000f,0.91000000f,0.08000000f,0.02000000f,0.42000000f,-0.44000000f,-0.32000000f,0.34000000f,0.27000000f,0.70000000f,0.49000000f,-0.30000000f,-0.00000000f,-0.87000000f,0.08000000f,0.29000000f,0.64000000f,0.02000000f,-0.29000000f,0.23000000f,-0.53000000f,-0.93000000f,0.42000000f,-0.47000000f,-0.79000000f,0.66000000f,0.75000000f,-0.30000000f,0.16000000f,0.81000000f,-0.81000000f,0.36000000f,0.71000000f,0.90000000f,0.15000000f,0.98000000f,-0.77000000f,0.96000000f,0.10000000f,0.40000000f,0.05000000f,-0.76000000f,0.71000000f,-0.12000000f,-0.30000000f,0.93000000f,-0.00000000f,-0.53000000f,-0.25000000f,-0.10000000f,0.04000000f,-0.07000000f,0.04000000f,-0.89000000f,0.53000000f,-0.76000000f,0.60000000f,0.07000000f,-0.31000000f,0.06000000f,-0.35000000f,0.33000000f,0.01000000f,-0.25000000f,-0.71000000f,-0.38000000f,-0.39000000f,0.15000000f,-0.28000000f,-0.44000000f,-0.64000000f,-0.80000000f,-0.61000000f,-0.57000000f,0.46000000f,0.61000000f,-0.49000000f,-0.07000000f,-0.17000000f,-0.94000000f,0.73000000f,-0.06000000f,-0.02000000f,0.19000000f,0.54000000f,0.38000000f,0.69000000f,-0.67000000f,-0.27000000f,0.05000000f,0.75000000f,-0.48000000f,-0.13000000f,-0.18000000f,-0.02000000f,0.37000000f,0.63000000f,-0.97000000f,0.30000000f,0.82000000f,0.82000000f,0.88000000f,0.25000000f,-0.64000000f,0.60000000f,-0.41000000f,-0.12000000f,-0.73000000f,-0.65000000f,-0.53000000f,0.02000000f,0.58000000f,-0.36000000f,-0.53000000f,0.88000000f,-0.51000000f,0.66000000f,-0.79000000f,-0.23000000f,0.65000000f,-0.38000000f,0.99000000f,-0.51000000f,-0.62000000f,0.72000000f,-0.31000000f,-0.87000000f,0.56000000f,0.18000000f,0.71000000f,0.01000000f,-0.72000000f,0.59000000f,0.15000000f,-0.73000000f,0.43000000f,-0.81000000f,-0.62000000f,0.08000000f,0.82000000f,0.98000000f,0.94000000f,-0.97000000f,0.97000000f,-0.27000000f,-0.17000000f,-0.41000000f,-0.20000000f,-0.61000000f,0.31000000f,-0.25000000f,-0.58000000f,0.95000000f,-0.36000000f,0.28000000f,-0.54000000f,-0.92000000f,-0.87000000f,-0.61000000f,0.12000000f,-0.24000000f,0.71000000f,0.90000000f,-0.29000000f,-0.75000000f,0.78000000f,0.30000000f,0.51000000f,-0.48000000f,-0.39000000f,0.75000000f,-0.90000000f,0.65000000f,-0.07000000f,0.17000000f,-0.55000000f,0.27000000f,-0.66000000f,-0.23000000f,-0.13000000f,0.06000000f,-0.27000000f,0.13000000f,0.53000000f,-0.06000000f,0.88000000f,0.81000000f,-0.56000000f,-0.09000000f,-0.26000000f,-0.84000000f,-0.22000000f,-0.59000000f,0.23000000f,0.60000000f,-0.60000000f,0.90000000f,-0.86000000f,0.00000000f,-0.43000000f,-0.15000000f,-0.33000000f,-0.89000000f,0.20000000f,-0.08000000f,0.37000000f,0.24000000f,0.86000000f,0.67000000f,-0.52000000f,-0.88000000f,0.45000000f,-0.56000000f,0.00000000f,-0.45000000f,0.07000000f,-0.82000000f,0.08000000f,-0.27000000f,-0.64000000f,-0.88000000f,0.92000000f,-0.99000000f,-0.12000000f,0.89000000f,0.35000000f,-0.29000000f,0.48000000f,-0.35000000f,-0.50000000f,-0.60000000f,0.31000000f,-0.46000000f,0.60000000f,0.47000000f,0.54000000f,0.45000000f,0.86000000f,0.54000000f,-0.99000000f,0.59000000f,-0.01000000f,0.86000000f,-0.10000000f,0.54000000f,-0.76000000f,-0.88000000f,0.75000000f,-0.61000000f,0.40000000f,-0.25000000f,0.92000000f,0.14000000f,-0.18000000f,0.04000000f,-0.31000000f,0.29000000f,-0.80000000f,0.67000000f,-0.60000000f,-0.76000000f,-0.01000000f,-0.19000000f,0.18000000f,0.55000000f,0.03000000f,0.23000000f,-0.30000000f,-0.66000000f,-0.12000000f,-0.16000000f,0.97000000f,0.40000000f,0.52000000f,-0.15000000f,-0.89000000f,0.71000000f,0.31000000f,0.96000000f,0.90000000f,-0.19000000f,-0.35000000f,0.28000000f,-0.64000000f,-0.45000000f,-0.78000000f,-0.98000000f,-0.36000000f,0.00000000f,-0.53000000f,-0.91000000f,-0.41000000f,0.21000000f,0.43000000f,-0.24000000f,-0.37000000f,-0.91000000f,0.66000000f,0.19000000f,0.76000000f,0.72000000f,-0.44000000f,0.55000000f,0.51000000f,0.45000000f,0.68000000f,-0.26000000f,0.09000000f,-0.87000000f,0.16000000f,0.52000000f,0.85000000f,-0.61000000f,-0.28000000f,-0.50000000f,0.32000000f,-0.24000000f,0.09000000f,0.18000000f,0.46000000f,0.80000000f,-0.04000000f,0.07000000f,0.29000000f,-0.57000000f,-0.22000000f,-0.92000000f,-0.49000000f,0.98000000f,0.99000000f,0.61000000f,0.26000000f,0.85000000f,-0.24000000f,0.47000000f,-0.40000000f,-0.59000000f,-0.00000000f,-0.89000000f,-0.33000000f,0.37000000f,0.26000000f,0.31000000f,-0.77000000f,-0.89000000f,-0.03000000f,-0.26000000f,0.85000000f,0.71000000f,-0.12000000f,0.64000000f,0.92000000f,-0.54000000f,0.96000000f,0.42000000f,0.85000000f,-0.85000000f,0.22000000f,0.61000000f,0.64000000f,-0.82000000f,0.01000000f,-0.07000000f,0.58000000f,-0.33000000f,0.25000000f,0.26000000f,-0.52000000f,0.44000000f,-0.84000000f,0.50000000f,-0.02000000f,-0.29000000f,0.57000000f,-0.43000000f,-0.62000000f,0.66000000f,-0.01000000f,-0.86000000f,0.83000000f,0.90000000f,-0.16000000f,0.66000000f,-0.81000000f,-0.30000000f,0.15000000f,-0.62000000f,0.38000000f,0.92000000f,-0.11000000f,0.39000000f,0.51000000f,-0.27000000f,0.62000000f,-0.86000000f,0.00000000f,-0.16000000f,0.70000000f,-0.77000000f,-0.92000000f,-0.73000000f,-0.28000000f,-0.47000000f,-0.70000000f,-0.66000000f,-0.78000000f,-0.86000000f,0.56000000f,0.28000000f,0.31000000f,0.96000000f,-0.64000000f,0.18000000f,0.49000000f,-0.81000000f,-0.56000000f,-0.98000000f,0.99000000f,-0.93000000f,0.04000000f,-0.63000000f,-0.22000000f,-0.63000000f,-0.49000000f,0.08000000f,0.47000000f,0.71000000f,-0.35000000f,-0.76000000f,0.01000000f,-0.92000000f,0.80000000f,0.23000000f,0.69000000f,-0.66000000f,0.14000000f,-0.21000000f,0.11000000f,-0.38000000f,-0.11000000f,-0.12000000f,-0.77000000f,-0.90000000f,-0.24000000f,0.78000000f,0.54000000f,0.84000000f,0.18000000f,-0.26000000f,-0.08000000f,-0.66000000f,-0.83000000f,-0.28000000f,0.90000000f,-0.89000000f,0.98000000f,-0.75000000f,-0.92000000f,-0.56000000f,0.29000000f,0.03000000f,0.25000000f,-0.64000000f,0.23000000f,-0.30000000f,0.44000000f,0.98000000f,-0.48000000f,0.66000000f,0.80000000f,-0.31000000f,0.17000000f,0.45000000f,-0.43000000f,0.59000000f,-0.78000000f,0.10000000f,0.27000000f,0.04000000f,0.85000000f,-0.25000000f,-0.22000000f,-0.07000000f,-0.64000000f,-0.86000000f,-0.39000000f,0.73000000f,0.81000000f,-0.71000000f,0.63000000f,0.87000000f,-0.41000000f,0.45000000f,-0.00000000f,-0.01000000f,0.40000000f,0.10000000f,-0.59000000f,0.13000000f,-0.11000000f,0.13000000f,0.18000000f,-0.06000000f,-0.18000000f,0.28000000f,-0.42000000f,-0.62000000f,-0.82000000f,0.34000000f,-0.61000000f,0.61000000f,-0.47000000f,0.34000000f,-0.68000000f,0.92000000f,-0.08000000f,0.90000000f,0.52000000f,0.71000000f,-0.14000000f,0.73000000f,-0.72000000f,-0.43000000f,0.15000000f,-0.10000000f,0.49000000f,-0.33000000f,0.71000000f,-0.13000000f,-0.48000000f,-0.39000000f,0.08000000f,0.50000000f,0.47000000f,-0.79000000f,-0.21000000f,-0.75000000f,0.89000000f,0.15000000f,0.21000000f,0.62000000f,-0.05000000f,0.62000000f,-0.83000000f,0.87000000f,-0.34000000f,0.61000000f,-0.60000000f,-0.42000000f,0.11000000f,0.03000000f,-0.66000000f,-0.05000000f,0.42000000f,0.19000000f,0.82000000f,0.69000000f,-0.33000000f,-0.92000000f,-0.02000000f,-0.00000000f,0.82000000f,0.83000000f,-0.02000000f,0.44000000f,0.11000000f,0.19000000f,0.01000000f,-0.09000000f,0.38000000f,-0.32000000f,0.30000000f,0.84000000f,-0.65000000f,-0.01000000f,-0.08000000f,-0.02000000f,-0.83000000f,-0.47000000f,0.95000000f,-0.99000000f,0.37000000f,-0.38000000f,0.21000000f,0.35000000f,-0.38000000f,0.92000000f,0.60000000f,0.46000000f,-0.14000000f,0.28000000f,0.20000000f,-0.15000000f,-0.03000000f,0.96000000f,-0.33000000f,0.08000000f,-0.48000000f,-0.56000000f,0.96000000f,-0.03000000f,-0.56000000f,-0.25000000f,0.90000000f,0.16000000f,0.21000000f,-0.45000000f,0.77000000f,0.21000000f,0.61000000f,0.74000000f,-0.07000000f,0.93000000f,-0.35000000f,-0.26000000f,0.52000000f,0.74000000f,-0.91000000f,0.33000000f,0.09000000f,-0.45000000f,0.58000000f,-0.53000000f,0.31000000f,0.42000000f,0.70000000f,-0.85000000f,-0.19000000f,0.63000000f,-0.87000000f,0.67000000f,-0.49000000f,0.51000000f,-0.08000000f,0.96000000f,-0.80000000f,0.00000000f,0.79000000f,0.44000000f,0.69000000f,-0.37000000f,-0.86000000f,-0.63000000f,0.90000000f,0.79000000f,-0.56000000f,-0.26000000f,0.66000000f,0.62000000f,0.22000000f,0.27000000f,0.75000000f,-0.86000000f,0.23000000f,0.34000000f,-0.50000000f,-0.40000000f,-0.05000000f,0.12000000f,-0.26000000f,0.40000000f,-0.74000000f,-0.94000000f,-0.65000000f,-0.36000000f,-0.66000000f,-0.96000000f,-0.34000000f,0.57000000f,-0.44000000f,0.09000000f,-0.88000000f,0.66000000f,-0.04000000f,0.46000000f,-0.33000000f,-0.72000000f,0.69000000f,0.58000000f,-0.57000000f,-0.75000000f,0.48000000f,0.31000000f,-0.04000000f,0.34000000f,-0.95000000f,0.49000000f,-0.63000000f,-0.27000000f,0.61000000f,-0.96000000f,-0.00000000f,-0.27000000f,-0.26000000f,0.26000000f,-0.33000000f,0.30000000f,0.61000000f,0.81000000f,0.12000000f,0.24000000f,0.24000000f,-0.07000000f,-0.23000000f,-0.50000000f,-0.55000000f,-0.22000000f,-0.89000000f,-0.97000000f,0.05000000f,0.46000000f,0.11000000f,0.62000000f,-0.02000000f,-0.34000000f,-0.94000000f,0.04000000f,0.97000000f,0.43000000f,0.58000000f,-0.46000000f,0.59000000f,-0.36000000f,0.47000000f,-0.06000000f,-0.57000000f,-0.57000000f,0.10000000f,0.38000000f,-0.43000000f,0.23000000f,-0.91000000f,0.35000000f,0.09000000f,0.91000000f,0.30000000f,0.84000000f,0.09000000f,0.40000000f,-0.75000000f,0.50000000f,-0.36000000f,-0.95000000f,-0.86000000f,-0.78000000f,-0.69000000f,0.28000000f,0.93000000f,0.19000000f,-0.15000000f,0.90000000f,-0.19000000f,0.71000000f,0.98000000f,0.15000000f,0.31000000f,-0.87000000f,-0.61000000f,0.51000000f,0.71000000f,0.67000000f,-0.40000000f,0.70000000f,0.34000000f,0.61000000f,0.61000000f,0.47000000f,0.49000000f,-0.13000000f,-0.43000000f,0.79000000f,-0.45000000f,-0.57000000f,0.40000000f,-0.23000000f,0.53000000f,0.27000000f,-0.58000000f,0.43000000f,-0.10000000f,-0.72000000f,0.27000000f,-0.09000000f,0.56000000f,0.64000000f,0.11000000f,-0.57000000f,-0.27000000f,0.60000000f,-0.29000000f,0.16000000f,0.77000000f,-0.96000000f,0.40000000f,0.13000000f,0.86000000f,-0.42000000f,0.62000000f,-0.21000000f,-0.11000000f,0.92000000f,0.07000000f,-0.08000000f,0.70000000f,0.34000000f,-0.82000000f,-0.46000000f,0.86000000f,-0.01000000f,-0.42000000f,0.41000000f,0.74000000f,-0.03000000f,-0.69000000f,0.38000000f,0.03000000f,0.94000000f,-0.81000000f,-0.44000000f,0.26000000f,-0.48000000f,-0.01000000f,0.81000000f,0.41000000f,-0.87000000f,-0.35000000f,-0.23000000f,-0.32000000f,0.19000000f,-0.31000000f,-0.36000000f,-0.39000000f,0.96000000f,-0.03000000f,0.64000000f,0.65000000f,-0.40000000f,0.80000000f,0.61000000f,0.83000000f,0.37000000f,0.63000000f,0.42000000f,-0.01000000f,0.95000000f,-0.67000000f,0.59000000f,-0.02000000f,-0.06000000f,0.63000000f,0.20000000f,0.27000000f,-0.15000000f,0.13000000f,0.49000000f,-0.43000000f,0.92000000f,-0.76000000f,0.20000000f,-0.35000000f,0.20000000f,-0.82000000f,-0.79000000f,0.09000000f,-0.62000000f,0.60000000f,-0.20000000f,-0.89000000f,-0.22000000f,-0.63000000f,0.31000000f,0.27000000f,-0.67000000f,0.23000000f,0.13000000f,0.18000000f,-0.82000000f,0.95000000f,0.52000000f,-0.26000000f,0.55000000f,-0.77000000f,-0.29000000f,0.43000000f,-0.34000000f,-0.61000000f,0.72000000f,0.21000000f,-0.21000000f,0.21000000f,0.47000000f,-0.02000000f,-0.13000000f,0.10000000f,0.81000000f,0.73000000f,-0.50000000f,-0.59000000f,-0.32000000f,-0.18000000f,-0.02000000f,0.19000000f,-0.58000000f,-0.35000000f,-0.52000000f,0.40000000f,-0.88000000f,-0.87000000f,0.75000000f,-0.08000000f,-0.36000000f,0.49000000f,0.46000000f,0.72000000f,0.47000000f,-0.69000000f,-0.53000000f,-0.67000000f,0.27000000f,0.51000000f,0.73000000f,-0.70000000f,-0.52000000f,0.83000000f,0.03000000f,-0.03000000f,-0.72000000f,0.22000000f,0.29000000f,-0.92000000f,-0.07000000f,-0.58000000f,0.21000000f,-0.62000000f,0.08000000f,0.52000000f,-0.70000000f,0.68000000f,-0.72000000f,-0.66000000f,0.24000000f,0.80000000f,0.48000000f,0.46000000f,-0.41000000f,-0.47000000f,0.06000000f,-0.11000000f,-0.30000000f,0.92000000f,-0.28000000f,0.53000000f,-0.08000000f,0.28000000f,0.55000000f,0.87000000f,0.65000000f,-0.00000000f,-0.44000000f,-0.17000000f,0.35000000f,-0.43000000f,0.01000000f,-0.92000000f,0.01000000f,-0.33000000f,0.21000000f,0.34000000f,0.67000000f,0.48000000f,-0.23000000f,-0.08000000f,0.07000000f,-0.17000000f,-0.02000000f,-0.62000000f,-0.56000000f,0.47000000f,-0.10000000f,0.49000000f,-0.33000000f,0.04000000f,-0.92000000f,-0.68000000f,0.80000000f,0.49000000f,0.42000000f,0.86000000f,-0.23000000f,-0.74000000f,-0.64000000f,0.83000000f,0.39000000f,-0.53000000f,-0.69000000f,-0.86000000f,-0.30000000f,0.22000000f,-0.85000000f,0.78000000f,0.00000000f,-0.86000000f,0.94000000f,0.33000000f,0.85000000f,0.33000000f,-0.34000000f,0.06000000f,-0.25000000f,0.26000000f,-0.88000000f,0.90000000f,-0.47000000f,-0.29000000f,-0.56000000f,-0.59000000f,0.66000000f,-0.06000000f,-0.03000000f,0.75000000f,-0.64000000f,0.03000000f,-0.15000000f,0.69000000f,-0.59000000f,0.66000000f,0.37000000f,-0.21000000f,0.04000000f,-0.24000000f,0.49000000f,-0.30000000f,-0.27000000f,-0.93000000f,-0.16000000f,0.73000000f,-0.22000000f,-0.63000000f,0.98000000f,-0.47000000f,0.60000000f,-0.67000000f,-0.31000000f,-0.24000000f,-0.57000000f,0.10000000f,0.49000000f,-0.52000000f,-0.81000000f,-0.28000000f,0.13000000f,-0.36000000f,0.87000000f,-0.61000000f,0.38000000f,-0.35000000f,0.05000000f,-0.01000000f,0.38000000f,0.92000000f,-0.43000000f,-0.87000000f,0.35000000f,0.84000000f,0.47000000f,0.19000000f,0.71000000f,-0.16000000f,0.32000000f,0.64000000f,-0.27000000f,0.30000000f,-0.88000000f,0.24000000f,0.97000000f,-0.02000000f,0.59000000f,-0.45000000f,-0.13000000f,0.32000000f,0.40000000f,-0.69000000f,0.24000000f,-0.06000000f,-0.29000000f,-0.74000000f,0.01000000f,0.36000000f,0.16000000f,0.18000000f,-0.89000000f,-0.62000000f,0.63000000f,-0.83000000f,0.37000000f,0.88000000f,0.53000000f,0.43000000f,0.16000000f,0.72000000f,0.94000000f,-0.04000000f,0.86000000f,0.64000000f,0.58000000f,-0.03000000f,-0.83000000f,0.78000000f,-0.96000000f,-0.11000000f,-0.30000000f,0.20000000f,-0.60000000f,-0.02000000f,0.52000000f,0.62000000f,-0.99000000f,-0.96000000f,0.17000000f,-0.79000000f,-0.87000000f,-0.32000000f,0.39000000f,0.31000000f,0.02000000f,-0.84000000f,-0.77000000f,0.49000000f,0.65000000f,0.83000000f,-0.30000000f,0.98000000f,-0.13000000f,-0.94000000f,0.14000000f,0.40000000f,-0.47000000f,0.81000000f,0.88000000f,-0.75000000f,0.88000000f,0.54000000f,0.89000000f,-0.52000000f,0.92000000f,-0.10000000f,0.11000000f,0.83000000f,0.11000000f,-0.99000000f,0.22000000f,-0.41000000f,0.00000000f,0.80000000f,-0.53000000f,0.19000000f,0.26000000f,-0.17000000f,-0.70000000f,-0.56000000f,-0.20000000f,0.26000000f,0.91000000f,-0.83000000f,0.67000000f,0.56000000f,0.83000000f,0.43000000f,-0.39000000f,0.28000000f,0.83000000f,-0.43000000f,0.92000000f,0.88000000f,-0.68000000f,-0.37000000f,0.62000000f,-0.68000000f,0.70000000f,-0.16000000f,-0.78000000f,0.88000000f,-0.84000000f,0.32000000f,-0.22000000f,0.72000000f,0.58000000f,0.40000000f,0.24000000f,0.90000000f,-0.08000000f,-0.03000000f,-0.89000000f,0.55000000f,-0.76000000f,-0.34000000f,-0.15000000f,0.19000000f,0.36000000f,0.46000000f,-0.60000000f,-0.43000000f,0.54000000f,-0.38000000f,-0.02000000f,-0.21000000f,-0.60000000f,-0.74000000f,0.92000000f,0.65000000f,0.47000000f,0.75000000f,0.58000000f,0.95000000f,-0.22000000f,-0.64000000f,-0.28000000f,-0.12000000f,0.84000000f,-0.37000000f,-0.18000000f,-0.50000000f,0.08000000f,0.14000000f,0.31000000f,-0.56000000f,-0.18000000f,0.32000000f,0.52000000f,0.46000000f,0.19000000f,0.31000000f,-0.48000000f,-0.95000000f,-0.31000000f,0.83000000f,-0.31000000f,0.22000000f,0.41000000f,-0.02000000f,0.05000000f,0.60000000f,0.36000000f,0.78000000f,0.50000000f,0.50000000f,0.61000000f,-0.59000000f,-0.00000000f,0.50000000f,0.96000000f,-0.80000000f,-0.56000000f,0.92000000f,-0.00000000f,0.25000000f,0.79000000f,0.76000000f,0.14000000f,-0.00000000f,-0.99000000f,-0.85000000f,0.81000000f,-0.26000000f,-0.58000000f,0.21000000f,-0.68000000f,-0.90000000f,0.68000000f,-0.48000000f,0.59000000f,0.08000000f,0.62000000f,0.38000000f,0.64000000f,-0.54000000f,0.65000000f,0.60000000f,-0.45000000f,-0.54000000f,-0.40000000f,0.13000000f,-0.94000000f,-0.86000000f,-0.67000000f,0.09000000f,-0.53000000f,-0.45000000f,0.23000000f,0.19000000f,0.62000000f,-0.18000000f,-0.51000000f,0.56000000f,0.81000000f,0.55000000f,-0.62000000f,0.60000000f,0.44000000f,0.61000000f,0.58000000f,0.13000000f,0.13000000f,0.46000000f,-0.04000000f,-0.01000000f,-0.61000000f,-0.76000000f,-0.87000000f,-0.25000000f,0.69000000f,-0.29000000f,0.53000000f,-0.59000000f,-0.22000000f,0.22000000f,-0.08000000f,0.77000000f,-0.08000000f,0.65000000f,-0.90000000f,0.19000000f,0.82000000f,-0.26000000f,0.00000000f,0.12000000f,0.22000000f,-0.88000000f,0.52000000f,-0.37000000f,-0.97000000f,0.34000000f,0.94000000f,0.84000000f,0.88000000f,0.35000000f,0.31000000f,-0.22000000f,0.41000000f,-0.96000000f,0.93000000f,-0.43000000f,0.30000000f,-0.20000000f,-0.41000000f,0.96000000f,0.36000000f,-0.88000000f,0.72000000f,0.32000000f,-0.23000000f,0.37000000f,-0.80000000f,0.05000000f,0.52000000f,0.50000000f,-0.94000000f,-0.43000000f,-0.05000000f,-0.44000000f,0.87000000f,-0.11000000f,-0.01000000f,0.85000000f,0.41000000f,0.30000000f,-0.13000000f,-0.02000000f,-0.49000000f,-0.68000000f,-0.15000000f,-0.49000000f,-0.04000000f,-0.40000000f,-0.56000000f,0.32000000f,0.70000000f,-0.38000000f,-0.12000000f,-0.64000000f,-0.69000000f,-0.22000000f,0.40000000f,-0.77000000f,0.44000000f,-0.36000000f,-0.68000000f,-0.45000000f,-0.39000000f,0.00000000f,-0.44000000f,0.73000000f,0.14000000f,-0.21000000f,-0.50000000f,-0.28000000f,0.04000000f,0.25000000f,0.24000000f,-0.70000000f,-0.04000000f,0.78000000f,0.90000000f,-0.37000000f,0.14000000f,-0.31000000f,-0.98000000f,-0.23000000f,0.15000000f,-0.04000000f,-0.43000000f,-0.51000000f,0.34000000f,-0.69000000f,-0.33000000f,-0.00000000f,0.33000000f,0.77000000f,0.55000000f,0.88000000f,0.56000000f,-0.06000000f,0.86000000f,0.61000000f,-0.97000000f,0.42000000f,0.96000000f,-0.23000000f,0.56000000f,-0.82000000f,0.41000000f,0.87000000f,-0.93000000f,-0.40000000f,-0.71000000f,-0.88000000f,0.49000000f,-0.39000000f,-0.66000000f,-0.16000000f,0.57000000f,-0.77000000f,0.15000000f,-0.36000000f,-0.13000000f,0.69000000f,0.36000000f,0.75000000f,-0.84000000f,-0.44000000f,0.77000000f,0.69000000f,-0.89000000f,0.90000000f,-0.91000000f,0.09000000f,0.86000000f,0.27000000f,0.83000000f,0.75000000f,-0.17000000f,0.80000000f,0.40000000f,0.20000000f,-0.40000000f,0.87000000f,-0.85000000f,-0.47000000f,-0.40000000f,-0.47000000f,-0.17000000f,-0.42000000f,-0.14000000f,-0.83000000f,0.04000000f,0.80000000f,0.72000000f,-0.07000000f,-0.24000000f,-0.32000000f,0.91000000f,-0.67000000f,0.27000000f,0.65000000f,0.68000000f,-0.94000000f,-0.88000000f,-0.27000000f,0.74000000f,-0.36000000f,0.88000000f,-0.78000000f,0.44000000f,-0.31000000f,0.21000000f,0.57000000f,0.01000000f,0.25000000f,-0.02000000f,0.44000000f,-0.88000000f,0.96000000f,-0.91000000f,0.66000000f,0.88000000f,0.97000000f,0.53000000f,-0.90000000f,0.07000000f,0.70000000f,-0.41000000f,-0.52000000f,-0.00000000f,-0.48000000f,0.27000000f,-0.19000000f,0.96000000f,-0.00000000f,0.23000000f,0.13000000f,-0.56000000f,-0.69000000f,0.66000000f,0.19000000f,-0.79000000f,0.87000000f,0.91000000f,-0.35000000f,-0.67000000f,0.01000000f,-0.64000000f,-0.48000000f,0.77000000f,0.29000000f,-0.32000000f,-0.36000000f,-0.07000000f,-0.36000000f,-0.03000000f,0.51000000f,-0.99000000f,0.42000000f,-0.95000000f,0.31000000f,0.96000000f,0.58000000f,0.91000000f,0.96000000f,0.42000000f,-0.76000000f,-0.73000000f,-0.52000000f,0.64000000f,0.24000000f,-0.28000000f,-0.50000000f,0.56000000f,0.50000000f,0.41000000f,0.54000000f,0.10000000f,0.10000000f,-0.57000000f,-0.73000000f,0.50000000f,0.36000000f,-0.71000000f,0.49000000f,-0.08000000f,-0.33000000f,-0.78000000f,-0.77000000f,0.84000000f,0.40000000f,0.91000000f,-0.39000000f,0.26000000f,-0.76000000f,-0.25000000f,-0.15000000f,-0.07000000f,-0.34000000f,0.82000000f,-0.94000000f,0.21000000f,-0.99000000f,0.33000000f,0.79000000f,-0.41000000f,0.71000000f,-0.40000000f,0.87000000f,0.82000000f,-0.34000000f,-0.99000000f,0.35000000f,-0.41000000f,0.10000000f,0.60000000f,0.84000000f,-0.28000000f,0.46000000f,0.63000000f,-0.47000000f,-0.24000000f,-0.05000000f,-0.92000000f,0.55000000f,0.59000000f,-0.23000000f,0.92000000f,0.86000000f,-0.16000000f,-0.51000000f,-0.63000000f,-0.34000000f,0.56000000f,-0.98000000f,-0.07000000f,0.64000000f,-0.83000000f,0.71000000f,0.40000000f,-0.47000000f,-0.67000000f,0.80000000f,-0.64000000f,0.86000000f,-0.00000000f,-0.64000000f,-0.54000000f,0.53000000f,-0.54000000f,0.13000000f,-0.73000000f,0.71000000f,0.44000000f,0.62000000f,0.17000000f,0.80000000f,0.82000000f,-0.87000000f,-0.54000000f,-0.56000000f,0.35000000f,0.02000000f,0.18000000f,-0.06000000f,-0.00000000f,0.13000000f,0.16000000f,0.18000000f,-0.11000000f,0.35000000f,0.70000000f,0.84000000f,0.48000000f,-0.03000000f,0.07000000f,0.20000000f,-0.84000000f,-0.18000000f,-0.30000000f,0.79000000f,-0.88000000f,-0.28000000f,0.64000000f,0.70000000f,-0.05000000f,-0.18000000f,0.59000000f,-0.87000000f,-0.98000000f,0.57000000f,0.11000000f,0.84000000f,-0.33000000f,0.55000000f,-0.89000000f,-0.07000000f,-0.64000000f,-0.17000000f,0.74000000f,0.70000000f,-0.54000000f,0.42000000f,-0.64000000f,-0.74000000f,-0.90000000f,-0.40000000f,0.69000000f,0.62000000f,0.26000000f,0.50000000f,-0.61000000f,0.60000000f,0.54000000f,0.23000000f,0.30000000f,0.68000000f,0.96000000f,-0.19000000f,0.38000000f,-0.73000000f,0.04000000f,-0.44000000f,0.51000000f,0.87000000f,0.56000000f,0.72000000f,0.26000000f,-0.61000000f,-0.36000000f,0.67000000f,0.64000000f,-0.67000000f,-0.85000000f,-0.30000000f,0.37000000f,-0.34000000f,-0.00000000f,0.30000000f,0.86000000f,-0.19000000f,0.08000000f,0.46000000f,-0.14000000f,0.45000000f,-0.52000000f,0.40000000f,-0.69000000f,-0.60000000f,-0.53000000f,-0.35000000f,-0.15000000f,-0.01000000f,-0.93000000f,-0.97000000f,0.48000000f,0.10000000f,0.64000000f,0.61000000f,-0.02000000f,-0.32000000f,0.67000000f,0.30000000f,-0.73000000f,-0.75000000f,-0.24000000f,0.43000000f,-0.68000000f,-0.09000000f,0.76000000f,-0.50000000f,-0.85000000f,-0.94000000f,-0.73000000f,0.85000000f,-0.73000000f,-0.93000000f,0.52000000f,-0.67000000f,0.67000000f,0.15000000f,0.25000000f,0.24000000f,-0.06000000f,-0.20000000f,-0.43000000f,0.77000000f,-0.09000000f,0.81000000f,0.28000000f,0.32000000f,-0.34000000f,0.15000000f,0.95000000f,0.48000000f,0.37000000f,-0.39000000f,0.92000000f,0.06000000f,0.97000000f,-0.59000000f,0.93000000f,-0.22000000f,-0.16000000f,-0.29000000f,0.00000000f,0.70000000f,-0.78000000f,0.56000000f,-0.05000000f,0.39000000f,0.23000000f,-0.89000000f,0.29000000f,-0.08000000f,-0.67000000f,-0.51000000f,-0.09000000f,0.64000000f,-0.75000000f,-0.89000000f,0.91000000f,-0.05000000f,-0.33000000f,0.84000000f,-0.74000000f,-0.95000000f,-0.12000000f,0.59000000f,0.27000000f,0.03000000f,0.98000000f,-0.16000000f,0.63000000f,0.24000000f,0.65000000f,-0.64000000f,-0.89000000f,0.27000000f,0.55000000f,-0.22000000f,-0.27000000f,0.68000000f,0.89000000f,-0.78000000f,0.36000000f,-0.98000000f,-0.53000000f,0.44000000f,0.72000000f,-0.00000000f,-0.08000000f,-0.58000000f,0.96000000f,0.05000000f,-0.75000000f,0.69000000f,0.14000000f,-0.55000000f,0.83000000f,-0.66000000f,0.30000000f,-0.85000000f,0.63000000f,0.03000000f,-0.10000000f,0.73000000f,0.04000000f,0.70000000f,-0.95000000f,-0.52000000f,-0.45000000f,0.97000000f,-0.16000000f,-0.31000000f,-0.61000000f,-0.55000000f,0.58000000f,0.20000000f,-0.17000000f,-0.80000000f,0.75000000f,-0.31000000f,-0.48000000f,0.81000000f,-0.61000000f,0.59000000f,-0.21000000f,-0.16000000f,0.15000000f,-0.84000000f,0.90000000f,-0.53000000f,0.82000000f,0.17000000f,-0.75000000f,-0.51000000f,-0.00000000f,-0.00000000f,-0.07000000f,-0.25000000f,-0.40000000f,-0.09000000f,-0.39000000f,0.50000000f,-0.63000000f,0.76000000f,-0.80000000f,0.03000000f,0.44000000f,-0.18000000f,-0.75000000f,0.08000000f,0.55000000f,0.22000000f,-0.88000000f,0.47000000f,0.32000000f,0.40000000f,0.58000000f,-0.08000000f,0.50000000f,0.40000000f,0.41000000f,-0.28000000f,0.40000000f,-0.30000000f,-0.39000000f,0.32000000f,0.78000000f,0.56000000f,-0.55000000f,0.08000000f,-0.50000000f,-0.94000000f,-0.69000000f,0.88000000f,-0.97000000f,-0.67000000f,0.98000000f,0.44000000f,-0.78000000f,0.08000000f,-0.66000000f,0.83000000f,-0.84000000f,0.93000000f,-0.55000000f,0.03000000f,-0.25000000f,-0.91000000f,-0.95000000f,0.88000000f,-0.19000000f,-0.23000000f,0.67000000f,-0.21000000f,-0.03000000f,-0.10000000f,-0.77000000f,-0.27000000f,0.19000000f,-0.37000000f,0.95000000f,0.29000000f,-0.43000000f,0.94000000f,0.47000000f,0.96000000f,-0.92000000f,0.26000000f,-0.20000000f,-0.00000000f,-0.55000000f,0.37000000f,-0.76000000f,-0.02000000f,-0.30000000f,-0.47000000f,0.65000000f,-0.14000000f,0.09000000f,-0.26000000f,-0.19000000f,-0.63000000f,-0.28000000f,0.58000000f,0.87000000f,0.87000000f,0.50000000f,0.73000000f,0.96000000f,-0.16000000f,0.55000000f,0.68000000f,-0.62000000f,-0.81000000f,0.32000000f,-0.47000000f,0.29000000f,0.53000000f,-0.19000000f,-0.98000000f,-0.41000000f,0.29000000f,-0.48000000f,-0.16000000f,0.11000000f,0.09000000f,-0.27000000f,-0.97000000f,0.95000000f,0.36000000f,-0.66000000f,-0.68000000f,0.41000000f,0.01000000f,0.07000000f,-0.85000000f,0.13000000f,-0.02000000f,0.31000000f,-0.53000000f,-0.13000000f,-0.29000000f,-0.43000000f,0.68000000f,0.14000000f,0.85000000f,-0.57000000f,-0.63000000f,-0.46000000f,-0.44000000f,-0.70000000f,-0.27000000f,0.68000000f,0.68000000f,0.90000000f,-0.59000000f,0.33000000f,0.63000000f,0.40000000f,0.69000000f,0.26000000f,0.44000000f,-0.91000000f,-0.00000000f,-0.60000000f,-0.45000000f,-0.51000000f,0.42000000f,0.53000000f,-0.19000000f,-0.97000000f,-0.79000000f,0.98000000f,0.99000000f,-0.05000000f,-0.17000000f,0.16000000f,-0.77000000f,0.14000000f,0.34000000f,0.15000000f,0.15000000f,-0.00000000f,0.27000000f,-0.17000000f,0.68000000f,0.37000000f,0.50000000f,-0.14000000f,-0.03000000f,-0.70000000f,-0.06000000f,-0.33000000f,0.50000000f,0.57000000f,-0.37000000f,-0.96000000f,-0.89000000f,-0.43000000f,-0.45000000f,0.11000000f,-0.33000000f,-0.19000000f,-0.62000000f,0.81000000f,0.56000000f,-0.38000000f,0.69000000f,0.61000000f,-0.30000000f,-0.58000000f,-0.67000000f,-0.72000000f,-0.83000000f,0.64000000f,0.94000000f,-0.61000000f,0.83000000f,-0.43000000f,-0.73000000f,-0.67000000f,0.96000000f,-0.73000000f,0.61000000f,0.89000000f,-0.97000000f,0.80000000f,0.30000000f,-0.42000000f,0.92000000f,0.81000000f,0.03000000f,0.48000000f,0.98000000f,-0.04000000f,-0.68000000f,0.13000000f,0.90000000f,0.17000000f,0.59000000f,0.48000000f,-0.40000000f,-0.70000000f,-0.25000000f,-0.46000000f,0.69000000f,-0.02000000f,-0.53000000f,-0.60000000f,0.55000000f,-0.49000000f,-0.47000000f,-0.83000000f,0.59000000f,-0.26000000f,0.21000000f,0.86000000f,-0.51000000f,-0.26000000f,0.59000000f,-0.18000000f,-0.93000000f,0.55000000f,-0.20000000f,-0.92000000f,0.87000000f,0.95000000f,-0.32000000f,0.84000000f,0.78000000f,0.43000000f,0.56000000f,0.43000000f,0.36000000f,0.14000000f,-0.19000000f,-0.84000000f,-0.30000000f,0.48000000f,0.63000000f,-0.62000000f,-0.54000000f,-0.28000000f,-0.08000000f,0.06000000f,0.71000000f,0.64000000f,0.60000000f,0.88000000f,-0.68000000f,-0.91000000f,-0.03000000f,0.79000000f,0.69000000f,-0.51000000f,-0.24000000f,0.95000000f,-0.41000000f,0.01000000f,0.97000000f,0.94000000f,-0.74000000f,0.28000000f,0.55000000f,-0.48000000f,-0.63000000f,-0.85000000f,-0.70000000f,0.56000000f,0.37000000f,0.96000000f,-0.80000000f,-0.08000000f,0.39000000f,0.92000000f,-0.02000000f,0.85000000f,-0.28000000f,-0.14000000f,0.81000000f,0.35000000f,-0.17000000f,-0.39000000f,0.12000000f,0.36000000f,-0.06000000f,0.88000000f,-0.59000000f,-0.25000000f,-0.50000000f,-0.34000000f,0.71000000f,-0.72000000f,-0.75000000f,0.40000000f,0.29000000f,0.29000000f,0.61000000f,0.49000000f,-0.79000000f,0.05000000f,0.03000000f,0.48000000f,0.58000000f,-0.38000000f,0.98000000f,0.60000000f,-0.79000000f,-0.15000000f,-0.24000000f,0.37000000f,0.51000000f,0.95000000f,-0.94000000f,0.30000000f,-0.58000000f,0.62000000f,0.57000000f,-0.86000000f,0.69000000f,-0.18000000f,-0.29000000f,0.33000000f,0.56000000f,-0.37000000f,0.02000000f,0.12000000f,-0.97000000f,0.80000000f,-0.46000000f,0.55000000f,-0.82000000f,-0.60000000f,-0.86000000f,-0.80000000f,0.60000000f,-0.09000000f,-0.51000000f,-0.46000000f,-0.86000000f,-0.46000000f,-0.30000000f,-0.86000000f,0.33000000f,0.31000000f,-0.73000000f,-0.83000000f,0.33000000f,0.35000000f,-0.26000000f,0.58000000f,0.75000000f,0.89000000f,-0.10000000f,-0.55000000f,-0.37000000f,0.51000000f,0.14000000f,-0.37000000f,0.58000000f,0.08000000f,0.54000000f,0.37000000f,0.43000000f,-0.03000000f,0.18000000f,-0.48000000f,0.27000000f,-0.22000000f,0.57000000f,-0.27000000f,-0.89000000f,0.05000000f,0.53000000f,-0.71000000f,-0.12000000f,-0.53000000f,0.57000000f,-0.38000000f,-0.22000000f,0.49000000f,-0.47000000f,0.58000000f,-0.26000000f,-0.15000000f,0.47000000f,0.32000000f,0.97000000f,-0.82000000f,0.70000000f,0.15000000f,-0.08000000f,0.16000000f,-0.76000000f,0.14000000f,-0.75000000f,-0.49000000f,0.68000000f,-0.31000000f,0.02000000f,0.20000000f,0.66000000f,0.16000000f,-0.10000000f,0.13000000f,-0.48000000f,-0.78000000f,-0.81000000f,-0.61000000f,-0.84000000f,-0.23000000f,-0.65000000f,0.18000000f,0.72000000f,0.50000000f,-0.09000000f,0.56000000f,0.97000000f,-0.98000000f,-0.49000000f,0.59000000f,0.37000000f,0.32000000f,-0.61000000f,0.24000000f,-0.76000000f,-0.36000000f,-0.69000000f,0.02000000f,-0.29000000f,0.22000000f,0.70000000f,0.49000000f,-0.99000000f,-0.88000000f,0.28000000f,-0.38000000f,0.17000000f,0.73000000f,-0.86000000f,-0.17000000f,-0.79000000f,0.84000000f,0.47000000f,0.86000000f,-0.23000000f,-0.03000000f,-0.69000000f,-0.38000000f,-0.92000000f,-0.86000000f,-0.46000000f,-0.11000000f,0.32000000f,0.37000000f,-0.29000000f,-0.41000000f,-0.05000000f,-0.11000000f,0.48000000f,-0.16000000f,-0.74000000f,-0.83000000f,-0.07000000f,-0.04000000f,0.14000000f,0.31000000f,0.39000000f,-0.91000000f,0.64000000f,-0.05000000f,0.22000000f,-0.61000000f,-0.70000000f,-0.82000000f,-0.45000000f,0.31000000f,-0.48000000f,-0.31000000f,0.61000000f,-0.31000000f,0.40000000f,0.86000000f,-0.92000000f,0.16000000f,0.02000000f,0.49000000f,-0.60000000f,-0.72000000f,0.71000000f,0.03000000f,-0.67000000f,0.27000000f,0.94000000f,0.06000000f,0.47000000f,0.24000000f,-0.72000000f,-0.41000000f,0.08000000f,0.83000000f,-0.81000000f,-0.61000000f,-0.48000000f,0.08000000f,-0.06000000f,0.35000000f,-0.65000000f,0.91000000f,-0.77000000f,-0.90000000f,0.38000000f,-0.42000000f,-0.48000000f,0.37000000f,-0.71000000f,0.36000000f,0.57000000f,-0.08000000f,0.36000000f,-0.87000000f,0.70000000f,-0.53000000f,-0.00000000f,0.65000000f,-0.73000000f,0.19000000f,-0.09000000f,0.42000000f,0.74000000f,-0.29000000f,-0.31000000f,-0.66000000f,-0.01000000f,-0.40000000f,0.71000000f,-0.36000000f,0.69000000f,0.67000000f,-0.86000000f,0.64000000f,-0.02000000f,0.06000000f,0.49000000f,0.42000000f,0.34000000f,-0.35000000f,-0.58000000f,-0.94000000f,-0.17000000f,0.54000000f,-0.91000000f,-0.31000000f,0.54000000f,-0.19000000f,0.69000000f,-0.39000000f,0.65000000f,0.18000000f,-0.54000000f,0.64000000f,0.43000000f,-0.12000000f,0.44000000f,-0.95000000f,-0.62000000f,0.15000000f,-0.71000000f,0.00000000f,-0.33000000f,-0.30000000f,-0.32000000f,-0.36000000f,0.44000000f,-0.96000000f,-0.65000000f,0.02000000f,-0.21000000f,0.34000000f,0.03000000f,0.10000000f,-0.13000000f,0.58000000f,0.40000000f,0.10000000f,0.75000000f,-0.32000000f,-0.22000000f,-0.48000000f,0.87000000f,-0.03000000f,-0.02000000f,0.82000000f,0.06000000f,0.56000000f,0.41000000f,0.16000000f,0.41000000f,-0.52000000f,0.38000000f,-0.09000000f,0.07000000f,-0.42000000f,0.70000000f,-0.16000000f,-0.13000000f,0.22000000f,0.83000000f,0.56000000f,-0.03000000f,0.20000000f,-0.34000000f,-0.52000000f,0.50000000f,0.73000000f,0.34000000f,0.05000000f,-0.39000000f,0.61000000f,0.67000000f,-0.63000000f,0.27000000f,-0.73000000f,-0.73000000f,0.84000000f,-0.65000000f,-0.51000000f,-0.05000000f,-0.46000000f,-0.38000000f,-0.00000000f,0.38000000f,-0.40000000f,-0.52000000f,0.51000000f,-0.63000000f,-0.40000000f,-0.02000000f,0.39000000f,0.18000000f,0.60000000f,0.30000000f,0.32000000f,0.23000000f,0.77000000f,0.21000000f,0.12000000f,0.49000000f,0.30000000f,0.72000000f,-0.85000000f,0.96000000f,0.23000000f,-0.08000000f,0.57000000f,0.20000000f,0.87000000f,0.99000000f,0.54000000f,-0.76000000f,0.11000000f,0.97000000f,-0.10000000f,0.19000000f,-0.45000000f,-0.12000000f,0.85000000f,-0.21000000f,0.69000000f,0.71000000f,-0.61000000f,0.01000000f,-0.73000000f,-0.61000000f,0.51000000f,0.33000000f,-0.71000000f,0.76000000f,0.67000000f,0.35000000f,-0.51000000f,-0.62000000f,-0.46000000f,0.28000000f,-0.80000000f,0.62000000f,0.65000000f,-0.11000000f,0.87000000f,0.24000000f,-0.97000000f,0.60000000f,-0.03000000f,-0.83000000f,0.32000000f,-0.49000000f,-0.94000000f,-0.42000000f,-0.47000000f,0.50000000f,0.34000000f,0.84000000f,0.11000000f,-0.86000000f,-0.24000000f,0.69000000f,-0.53000000f,0.89000000f,0.00000000f,0.08000000f,-0.81000000f,-0.07000000f,-0.18000000f,-0.52000000f,-0.39000000f,-0.94000000f,0.04000000f,0.89000000f,-0.30000000f,0.44000000f,-0.68000000f,0.49000000f,0.40000000f,0.65000000f,-0.80000000f,-0.72000000f,0.42000000f,-0.49000000f,0.91000000f,0.45000000f,0.26000000f,0.60000000f,0.00000000f,0.20000000f,0.27000000f,-0.00000000f,0.27000000f,0.91000000f,0.44000000f,0.84000000f,0.81000000f,-0.09000000f,0.38000000f,-0.49000000f,0.56000000f,0.04000000f,0.54000000f,-0.79000000f,0.05000000f,0.56000000f,0.34000000f,-0.20000000f,0.12000000f,0.00000000f,0.48000000f,0.18000000f,0.15000000f,-0.86000000f,0.57000000f,-0.03000000f,-0.12000000f,0.56000000f,-0.33000000f,-0.80000000f,0.03000000f,0.00000000f,0.90000000f,0.00000000f,0.50000000f,0.15000000f,-0.09000000f,-0.43000000f,0.17000000f,-0.28000000f,0.21000000f,-0.86000000f,-0.41000000f,0.69000000f,-0.40000000f,0.11000000f,-0.95000000f,-0.08000000f,-0.98000000f,-0.67000000f,0.73000000f,-0.97000000f,-0.67000000f,-0.09000000f,0.52000000f,-0.25000000f,0.26000000f,0.09000000f,-0.66000000f,-0.16000000f,0.01000000f,0.86000000f,-0.11000000f,-0.78000000f,0.15000000f,-0.02000000f,-0.23000000f,0.18000000f,0.91000000f,0.29000000f,0.21000000f,-0.53000000f,-0.65000000f,0.79000000f,-0.68000000f,0.87000000f,-0.22000000f,-0.07000000f,-0.43000000f,0.50000000f,0.26000000f,0.05000000f,0.55000000f,-0.30000000f,-0.16000000f,-0.43000000f,0.56000000f,-0.16000000f,0.03000000f,-0.92000000f,0.32000000f,-0.69000000f,0.05000000f,-0.34000000f,-0.90000000f,0.67000000f,-0.24000000f,-0.24000000f,0.97000000f,0.18000000f,-0.31000000f,-0.45000000f,-0.98000000f,0.94000000f,0.84000000f,0.52000000f,0.80000000f,0.71000000f,-0.26000000f,0.04000000f,-0.78000000f,0.10000000f,-0.21000000f,-0.21000000f,0.42000000f,-0.36000000f,-0.98000000f,-0.29000000f,-0.79000000f,-0.29000000f,-0.89000000f,-0.82000000f,0.17000000f,-0.11000000f,0.59000000f,-0.30000000f,0.43000000f,0.40000000f,0.54000000f,-0.35000000f,-0.60000000f,-0.30000000f,0.61000000f,0.52000000f,0.20000000f,-0.40000000f,0.07000000f,0.81000000f,0.50000000f,0.00000000f,0.26000000f,0.06000000f,0.01000000f,-0.43000000f,0.68000000f,-0.25000000f,-0.28000000f,0.01000000f,0.29000000f,0.87000000f,0.68000000f,0.18000000f,-0.26000000f,-0.16000000f,-0.43000000f,-0.59000000f,0.74000000f,0.91000000f,0.33000000f,0.88000000f,0.07000000f,-0.67000000f,0.26000000f,-0.88000000f,-0.31000000f,-0.25000000f,0.63000000f,0.08000000f,-0.60000000f,-0.08000000f,-0.29000000f,-0.41000000f,-0.12000000f,-0.65000000f,-0.20000000f,-0.73000000f,0.50000000f,-0.50000000f,-0.55000000f,0.80000000f,0.01000000f,-0.47000000f,-0.33000000f,0.52000000f,-0.59000000f,-0.61000000f,0.99000000f,-0.94000000f,0.32000000f,-0.50000000f,-0.41000000f,0.66000000f,-0.06000000f,-0.30000000f,0.79000000f,0.33000000f,0.21000000f,-0.79000000f,0.09000000f,0.66000000f,-0.13000000f,-0.32000000f,0.05000000f,0.32000000f,0.07000000f,-0.11000000f,-0.16000000f,0.72000000f,0.69000000f,0.76000000f,-0.14000000f,-0.96000000f,-0.26000000f,0.93000000f,0.84000000f,-0.00000000f,0.23000000f,-0.68000000f,0.65000000f,0.64000000f,-0.37000000f,0.94000000f,-0.70000000f,-0.04000000f,-0.39000000f,0.90000000f,-0.62000000f,0.02000000f,0.88000000f,0.77000000f,-0.40000000f,0.01000000f,-0.45000000f,-0.92000000f,-0.18000000f,0.79000000f,0.52000000f,0.86000000f,0.57000000f,-0.39000000f,-0.39000000f,-0.47000000f,0.47000000f,-0.70000000f,-0.10000000f,0.27000000f,0.99000000f,-0.62000000f,-0.11000000f,-0.99000000f,-0.68000000f,0.81000000f,-0.94000000f,0.08000000f,-0.01000000f,0.42000000f,0.50000000f,0.05000000f,0.67000000f,0.87000000f,-0.11000000f,-0.55000000f,-0.20000000f,0.12000000f,-0.77000000f,0.50000000f,-0.46000000f,-0.69000000f,-0.76000000f,-0.21000000f,-0.49000000f,0.08000000f,-0.29000000f,-0.44000000f,0.59000000f,0.17000000f,-0.34000000f,0.57000000f,-0.00000000f,-0.21000000f,0.65000000f,0.04000000f,-0.26000000f,-0.73000000f,0.95000000f,0.28000000f,-0.33000000f,-0.95000000f,-0.55000000f,-0.52000000f,-0.93000000f,0.57000000f,-0.56000000f,-0.50000000f,-0.62000000f,-0.73000000f,0.94000000f,-0.37000000f,0.04000000f,-0.09000000f,-0.12000000f,-0.71000000f,-0.38000000f,-0.08000000f,-0.56000000f,0.27000000f,0.45000000f,-0.47000000f,0.84000000f,0.24000000f,-0.76000000f,-0.10000000f,0.96000000f,0.72000000f,0.67000000f,0.04000000f,0.91000000f,0.50000000f,0.29000000f,-0.34000000f,-0.87000000f,0.00000000f,-0.74000000f,0.76000000f,-0.20000000f,0.38000000f,0.54000000f,-0.69000000f,0.54000000f,-0.24000000f,-0.16000000f,0.79000000f,-0.17000000f,0.53000000f,-0.25000000f,-0.54000000f,0.40000000f,-0.78000000f,-0.41000000f,-0.25000000f,0.85000000f,0.70000000f,-0.77000000f,-0.23000000f,-0.96000000f,0.75000000f,0.52000000f,0.59000000f,-0.85000000f,0.70000000f,-0.23000000f,-0.71000000f,-0.22000000f,0.87000000f,0.44000000f,0.57000000f,0.75000000f,0.44000000f,-0.44000000f,0.45000000f,0.41000000f,-0.90000000f,-0.86000000f,0.51000000f,0.56000000f,-0.41000000f,-0.55000000f,0.53000000f,0.78000000f,-0.71000000f,-0.43000000f,-0.20000000f,0.98000000f,-0.39000000f,-0.42000000f,-0.52000000f,0.40000000f,-0.67000000f,-0.32000000f,0.12000000f,0.95000000f,0.99000000f,-0.75000000f,0.97000000f,-0.33000000f,-0.24000000f,0.31000000f,-0.50000000f,-0.54000000f,-0.20000000f,0.92000000f,-0.81000000f,0.38000000f,-0.62000000f,-0.39000000f,0.82000000f,0.91000000f,-0.75000000f,0.03000000f,-0.06000000f,-0.61000000f,-0.17000000f,-0.91000000f,0.27000000f,0.30000000f,-0.75000000f,-0.51000000f,0.50000000f,0.60000000f,-0.96000000f,-0.91000000f,-0.52000000f,0.34000000f,0.92000000f,0.31000000f,-0.02000000f,0.89000000f,0.93000000f,-0.77000000f,0.53000000f,0.98000000f,0.01000000f,0.45000000f,0.56000000f,-0.41000000f,0.38000000f,-0.96000000f,0.72000000f,-0.11000000f,-0.05000000f,0.88000000f,-0.78000000f,-0.27000000f,-0.68000000f,-0.41000000f,-0.16000000f,-0.08000000f,0.70000000f,0.16000000f,0.13000000f,-0.29000000f,0.53000000f,-0.52000000f,-0.75000000f,0.99000000f,0.73000000f,0.11000000f,0.11000000f,-0.05000000f,0.27000000f,-0.87000000f,-0.19000000f,-0.59000000f,-0.73000000f,0.74000000f,-0.18000000f,0.13000000f,-0.32000000f,0.55000000f,0.03000000f,-0.20000000f,0.45000000f,-0.06000000f,-0.10000000f,-0.86000000f,0.94000000f,-0.63000000f,0.88000000f,0.23000000f,0.28000000f,-0.62000000f,-0.59000000f,0.76000000f,0.41000000f,-0.29000000f,0.55000000f,0.01000000f,0.36000000f,0.33000000f,0.06000000f,0.67000000f,-0.63000000f,-0.36000000f,0.77000000f,-0.72000000f,0.76000000f,-0.87000000f,0.95000000f,-0.28000000f,-0.83000000f,-0.67000000f,-0.64000000f,-0.49000000f,0.55000000f,0.06000000f,0.90000000f,-0.01000000f,-0.58000000f,0.94000000f,-0.76000000f,-0.24000000f,0.58000000f,-0.99000000f,0.17000000f,-0.14000000f,0.65000000f,-0.80000000f,0.77000000f,-0.18000000f,-0.37000000f,0.07000000f,-0.71000000f,-0.31000000f,0.43000000f,0.59000000f,-0.52000000f,-0.73000000f,-0.17000000f,0.04000000f,-0.25000000f,-0.62000000f,0.90000000f,0.40000000f,-0.60000000f,-0.31000000f,0.52000000f,-0.60000000f,0.90000000f,0.78000000f,0.13000000f,-0.27000000f,-0.71000000f,0.71000000f,0.24000000f,0.93000000f,-0.39000000f,0.33000000f,-0.02000000f,0.45000000f,0.61000000f,-0.50000000f,0.81000000f,0.95000000f,-0.70000000f,0.72000000f,0.03000000f,-0.16000000f,0.07000000f,-0.28000000f,-0.83000000f,0.84000000f,-0.48000000f,-0.42000000f,0.62000000f,0.62000000f,0.39000000f,0.88000000f,0.03000000f,-0.41000000f,-0.49000000f,-0.80000000f,-0.60000000f,0.55000000f,0.83000000f,-0.02000000f,-0.69000000f,-0.19000000f,0.65000000f,0.49000000f,-0.32000000f,-0.28000000f,0.05000000f,-0.40000000f,-0.03000000f,-0.39000000f,0.48000000f,-0.75000000f,-0.02000000f,-0.91000000f,-0.25000000f,0.33000000f,0.80000000f,-0.30000000f,-0.14000000f,-0.36000000f,0.61000000f,0.82000000f,0.48000000f,0.31000000f,-0.87000000f,0.45000000f,0.06000000f,0.15000000f,0.08000000f,-0.39000000f,0.10000000f,-0.21000000f,0.63000000f,-0.47000000f,0.55000000f,0.47000000f,0.90000000f,0.32000000f,-0.29000000f,0.79000000f,-0.76000000f,0.75000000f,-0.90000000f,0.56000000f,0.92000000f,-0.04000000f,-0.73000000f,-0.75000000f,-0.68000000f,-0.74000000f,0.99000000f,-0.68000000f,-0.49000000f,0.31000000f,0.76000000f,-0.76000000f,-0.03000000f,-0.95000000f,-0.75000000f,-0.89000000f,-0.32000000f,0.91000000f,-0.34000000f,0.58000000f,-0.43000000f,0.33000000f,-0.88000000f,-0.32000000f,0.90000000f,0.23000000f,-0.40000000f,-0.86000000f,0.81000000f,0.26000000f,-0.90000000f,0.78000000f,-0.61000000f,0.65000000f,-0.75000000f,0.69000000f,-0.29000000f,-0.17000000f,-0.92000000f,0.84000000f,0.80000000f,-0.35000000f,0.53000000f,0.73000000f,-0.60000000f,-0.75000000f,-0.46000000f,-0.68000000f,-0.13000000f,0.80000000f,-0.21000000f,0.38000000f,0.89000000f,-0.53000000f,0.34000000f,-0.32000000f,0.71000000f,0.08000000f,-0.43000000f,0.27000000f,-0.17000000f,0.48000000f,0.75000000f,-0.89000000f,-0.47000000f,-0.94000000f,-0.23000000f,0.52000000f,-0.47000000f,0.34000000f,-0.84000000f,-0.81000000f,-0.14000000f,0.36000000f,-0.73000000f,-0.35000000f,-0.06000000f,-0.66000000f,-0.16000000f,-0.84000000f,-0.95000000f,-0.52000000f,-0.02000000f,-0.28000000f,0.85000000f,0.91000000f,-0.61000000f,-0.16000000f,-0.82000000f,0.10000000f,0.19000000f,-0.51000000f,0.04000000f,-0.23000000f,0.74000000f,-0.18000000f,0.31000000f,-0.63000000f,-0.37000000f,-0.27000000f,-0.95000000f,-0.36000000f,-0.32000000f,-0.85000000f,0.52000000f,0.16000000f,0.75000000f,-0.68000000f,-0.99000000f,-0.18000000f,-0.82000000f,0.90000000f,0.61000000f,-0.96000000f,0.55000000f,0.61000000f,-0.82000000f,0.15000000f,0.21000000f,-0.46000000f,0.06000000f,0.35000000f,0.95000000f,0.25000000f,-0.10000000f,-0.08000000f,0.58000000f,0.14000000f,-0.54000000f,0.21000000f,0.48000000f,0.53000000f,0.09000000f,0.75000000f,0.82000000f,-0.12000000f,-0.45000000f,0.65000000f,0.29000000f,-0.04000000f,0.43000000f,0.84000000f,-0.97000000f,0.04000000f,-0.14000000f,-0.02000000f,0.09000000f,-0.46000000f,0.01000000f,-0.90000000f,-0.54000000f,-0.71000000f,-0.03000000f,-0.45000000f,-0.02000000f,-0.49000000f,-0.71000000f,0.06000000f,-0.48000000f,0.90000000f,0.83000000f,0.20000000f,0.42000000f,-0.99000000f,-0.11000000f,0.53000000f,-0.35000000f,-0.01000000f,0.67000000f,-0.68000000f,-0.08000000f,-0.52000000f,0.44000000f,-0.61000000f,-0.58000000f,-0.15000000f,-0.47000000f,0.90000000f,0.37000000f,-0.05000000f,-0.52000000f,0.54000000f,0.88000000f,0.19000000f,-0.36000000f,0.19000000f,0.82000000f,0.04000000f,-0.37000000f,0.36000000f,0.97000000f,-0.93000000f,0.97000000f,-0.82000000f,0.28000000f,0.17000000f,-0.19000000f,0.17000000f,-0.24000000f,-0.69000000f,0.48000000f,-0.01000000f,0.43000000f,-0.70000000f,0.98000000f,-0.49000000f,-0.51000000f,0.97000000f,0.05000000f,-0.87000000f,0.57000000f,-0.93000000f,-0.45000000f,0.78000000f,-0.22000000f,0.70000000f,0.91000000f,-0.54000000f,0.67000000f,-0.53000000f,-0.01000000f,0.38000000f,0.99000000f,-0.56000000f,0.85000000f,0.67000000f,0.88000000f,-0.02000000f,0.33000000f,-0.00000000f,0.74000000f,0.33000000f,-0.37000000f,-0.92000000f,0.79000000f,-0.93000000f,0.24000000f,0.18000000f,-0.56000000f,-0.83000000f,-0.22000000f,0.79000000f,-0.04000000f,0.54000000f,-0.11000000f,-0.40000000f,0.27000000f,0.44000000f,0.50000000f,0.24000000f,0.96000000f,-0.02000000f,0.24000000f,0.18000000f,-0.95000000f,-0.03000000f,0.93000000f,-0.15000000f,0.86000000f,-0.24000000f,-0.30000000f,0.80000000f,-0.05000000f,0.91000000f,0.55000000f,0.05000000f,0.44000000f,-0.43000000f,0.00000000f,-0.96000000f,-0.55000000f,0.52000000f,-0.11000000f,-0.56000000f,-0.08000000f,0.91000000f,0.05000000f,-0.70000000f,0.13000000f,0.43000000f,0.07000000f,0.81000000f,-0.49000000f,0.14000000f,-0.89000000f,-0.38000000f,0.19000000f,0.57000000f,0.94000000f,0.66000000f,0.98000000f,0.75000000f,0.37000000f,-0.12000000f,0.12000000f,0.96000000f,0.40000000f,-0.10000000f,-0.64000000f,-0.88000000f,-0.64000000f,0.95000000f,-0.81000000f,0.61000000f,-0.97000000f,-0.68000000f,-0.73000000f,-0.00000000f,-0.69000000f,-0.99000000f,0.73000000f,-0.09000000f,-0.49000000f,0.22000000f,0.04000000f,0.77000000f,0.79000000f,-0.06000000f,-0.35000000f,0.06000000f,0.81000000f,-0.03000000f,-0.05000000f,0.47000000f,0.27000000f,-0.74000000f,-0.59000000f,0.82000000f,0.47000000f,0.80000000f,0.80000000f,0.58000000f,-0.87000000f,0.05000000f,0.50000000f,-0.26000000f,-0.50000000f,-0.84000000f,0.12000000f,0.62000000f,0.66000000f,-0.77000000f,-0.10000000f,0.74000000f,0.66000000f,-0.07000000f,0.73000000f,0.74000000f,0.52000000f,0.10000000f,-0.78000000f,0.24000000f,0.92000000f,0.02000000f,-0.12000000f,0.80000000f,0.60000000f,0.76000000f,0.96000000f,0.57000000f,0.94000000f,-0.37000000f,-0.01000000f,-0.20000000f,-0.95000000f,-0.37000000f,-0.61000000f,0.74000000f,0.82000000f,0.31000000f,0.32000000f,-0.47000000f,-0.91000000f,-0.60000000f,-0.78000000f,0.19000000f,-0.65000000f,0.44000000f,-0.63000000f,-0.19000000f,-0.62000000f,0.39000000f,-0.58000000f,-0.80000000f,-0.47000000f,0.29000000f,-0.31000000f,0.19000000f,0.13000000f,0.59000000f,-0.52000000f,0.32000000f,0.71000000f,-0.69000000f,-0.21000000f,-0.94000000f,-0.80000000f,-0.82000000f,-0.81000000f,-0.92000000f,-0.08000000f,-0.68000000f,0.19000000f,0.31000000f,-0.02000000f,-0.60000000f,0.97000000f,-0.71000000f,0.21000000f,-0.18000000f,0.19000000f,0.83000000f,0.79000000f,-0.18000000f,-0.91000000f,-0.77000000f,-0.80000000f,-0.00000000f,0.08000000f,0.30000000f,-0.86000000f,-0.88000000f,-0.01000000f,-0.88000000f,0.71000000f,-0.80000000f,-0.54000000f,0.43000000f,-0.68000000f,-0.56000000f,0.32000000f,0.05000000f,0.21000000f,-0.51000000f,0.17000000f,-0.42000000f,0.01000000f,0.00000000f,0.03000000f,0.16000000f,-0.77000000f,0.62000000f,-0.91000000f,-0.70000000f,-0.42000000f,-0.49000000f,0.46000000f,-0.82000000f,0.97000000f,-0.49000000f,-0.49000000f,0.42000000f,0.23000000f,-0.19000000f,0.23000000f,0.99000000f,-0.57000000f,-0.93000000f,-0.46000000f,0.05000000f,-0.86000000f,0.23000000f,0.94000000f,-0.68000000f,0.73000000f,0.08000000f,0.33000000f,0.63000000f,0.65000000f,0.11000000f,0.41000000f,-0.16000000f,-0.05000000f,0.80000000f,0.65000000f,0.07000000f,-0.76000000f,-0.69000000f,0.34000000f,0.18000000f,0.69000000f,0.58000000f,0.67000000f,0.56000000f,0.02000000f,-0.72000000f,0.07000000f,0.38000000f,-0.30000000f,0.59000000f,0.00000000f,-0.67000000f,0.52000000f,0.40000000f,0.60000000f,-0.26000000f,-0.16000000f,-0.99000000f,-0.89000000f,0.48000000f,0.03000000f,-0.59000000f,-0.62000000f,-0.51000000f,0.10000000f,0.79000000f,0.47000000f,0.66000000f,0.23000000f,-0.51000000f,-0.08000000f,-0.84000000f,-0.38000000f,0.27000000f,0.11000000f,-0.46000000f,0.50000000f,-0.75000000f,-0.49000000f,-0.44000000f,-0.86000000f,-0.46000000f,0.70000000f,-0.21000000f,-0.33000000f,-0.69000000f,0.91000000f,0.79000000f,0.29000000f,-0.90000000f,0.70000000f,-0.92000000f,-0.49000000f,0.85000000f,-0.58000000f,-0.71000000f,0.53000000f,0.88000000f,0.29000000f,0.35000000f,0.75000000f,-0.23000000f,0.90000000f,-0.49000000f,0.04000000f,0.07000000f,0.13000000f,-0.12000000f,-0.84000000f,-0.09000000f,-0.19000000f,-0.26000000f,-0.73000000f,-0.66000000f,-0.83000000f,-0.14000000f,0.38000000f,-0.95000000f,0.39000000f,-0.69000000f,0.46000000f,0.44000000f,0.53000000f,-0.38000000f,0.01000000f,-0.41000000f,0.10000000f,0.90000000f,-0.36000000f,0.58000000f,0.41000000f,0.11000000f,-0.73000000f,0.14000000f,0.97000000f,0.89000000f,-0.24000000f,0.49000000f,0.65000000f,-0.52000000f,0.63000000f,-0.82000000f,0.34000000f,0.95000000f,-0.90000000f,-0.19000000f,-0.48000000f,-0.05000000f,-0.92000000f,-0.48000000f,-0.09000000f,-0.72000000f,0.64000000f,-0.92000000f,0.64000000f,-0.85000000f,-0.78000000f,-0.44000000f,-0.67000000f,-0.48000000f,0.91000000f,-0.45000000f,0.23000000f,-0.35000000f,-0.10000000f,0.49000000f,0.65000000f,0.29000000f,0.03000000f,0.59000000f,-0.92000000f,0.24000000f,0.48000000f,0.86000000f,0.29000000f,0.77000000f,0.40000000f,-0.56000000f,-0.27000000f,-0.99000000f,0.95000000f,0.99000000f,-0.65000000f,0.71000000f,0.21000000f,-0.14000000f,0.51000000f,0.25000000f,-0.31000000f,0.73000000f,0.37000000f,0.62000000f,0.58000000f,-0.81000000f,-0.68000000f,0.41000000f,-0.88000000f,-0.20000000f,0.40000000f,-0.71000000f,-0.71000000f,0.97000000f,-0.28000000f,-0.73000000f,0.36000000f,-0.57000000f,-0.56000000f,-0.33000000f,0.98000000f,-0.32000000f,0.25000000f,-0.85000000f,-0.16000000f,-0.14000000f,-0.17000000f,-0.57000000f,0.12000000f,0.03000000f,-0.77000000f,0.12000000f,-0.58000000f,-0.90000000f,0.51000000f,-0.29000000f,-0.47000000f,0.89000000f,-0.81000000f,0.69000000f,0.70000000f,-0.40000000f,0.15000000f,-0.66000000f,0.54000000f,-0.75000000f,-0.81000000f,-0.87000000f,-0.26000000f,0.31000000f,-0.56000000f,-0.15000000f,0.04000000f,-0.86000000f,0.07000000f,0.19000000f,-0.80000000f,-0.94000000f,0.04000000f,-0.01000000f,0.87000000f,0.83000000f,-0.44000000f,-0.77000000f,-0.73000000f,0.24000000f,-0.87000000f,-0.61000000f,0.85000000f,0.40000000f,-0.83000000f,0.18000000f,-0.88000000f,0.49000000f,-0.27000000f,-0.25000000f,-0.59000000f,-0.47000000f,-0.91000000f,-0.81000000f,-0.60000000f,-0.73000000f,0.78000000f,-0.81000000f,0.70000000f,0.20000000f,0.44000000f,-0.60000000f,-0.82000000f,-0.56000000f,0.90000000f,0.08000000f,-0.00000000f,0.06000000f,0.17000000f,-0.42000000f,0.34000000f,0.80000000f,-0.92000000f,0.02000000f,0.44000000f,-0.54000000f,0.45000000f,0.69000000f,-0.19000000f,-0.06000000f,0.32000000f,-0.38000000f,0.72000000f,0.96000000f,0.47000000f,-0.56000000f,-0.50000000f,0.09000000f,-0.60000000f,-0.92000000f,0.10000000f,-0.34000000f,0.16000000f,0.74000000f,0.03000000f,-0.54000000f,0.63000000f,0.60000000f,0.69000000f,0.20000000f,-0.43000000f,0.31000000f,-0.68000000f,-0.64000000f,-0.46000000f,0.61000000f,-0.74000000f,0.56000000f,0.11000000f,-0.44000000f,-0.02000000f,-0.38000000f,-0.96000000f,0.95000000f,0.38000000f,0.24000000f,-0.74000000f,0.91000000f,-0.54000000f,-0.61000000f,0.67000000f,0.38000000f,0.91000000f,0.05000000f,-0.53000000f,-0.08000000f,0.04000000f,-0.86000000f,-0.90000000f,-0.92000000f,0.08000000f,-0.49000000f,0.22000000f,0.92000000f,0.76000000f,-0.30000000f,0.85000000f,-0.76000000f,0.15000000f,0.28000000f,-0.52000000f,-0.16000000f,0.84000000f,0.48000000f,0.70000000f,0.62000000f,-0.52000000f,0.37000000f,-0.43000000f,0.52000000f,-0.87000000f,0.91000000f,0.13000000f,0.15000000f,0.10000000f,0.62000000f,0.72000000f,-0.69000000f,-0.53000000f,-0.09000000f,-0.37000000f,0.76000000f,-0.76000000f,-0.50000000f,0.86000000f,-0.17000000f,-0.73000000f,-0.39000000f,-0.05000000f,0.91000000f,-0.26000000f,0.39000000f,-0.69000000f,0.26000000f,0.97000000f,-0.23000000f,0.61000000f,0.77000000f,-0.28000000f,0.17000000f,0.32000000f,0.85000000f,-0.80000000f,-0.85000000f,-0.03000000f,-0.59000000f,-0.91000000f,0.28000000f,-0.14000000f,0.46000000f,-0.53000000f,-0.75000000f,-0.84000000f,0.52000000f,-0.35000000f,-0.97000000f,0.94000000f,-0.44000000f,-0.26000000f,0.54000000f,-0.51000000f,0.41000000f,0.41000000f,0.89000000f,-0.54000000f,-0.27000000f,0.72000000f,-0.34000000f,0.01000000f,0.19000000f,0.23000000f,-0.30000000f,-0.61000000f,-0.39000000f,-0.11000000f,0.45000000f,-0.22000000f,-0.66000000f,0.06000000f,0.15000000f,0.46000000f,-0.00000000f,0.91000000f,0.25000000f,0.37000000f,-0.13000000f,0.26000000f,0.08000000f,0.78000000f,-0.77000000f,-0.68000000f,0.21000000f,-0.80000000f,0.02000000f,0.33000000f,0.65000000f,0.33000000f,0.02000000f,-0.97000000f,0.01000000f,-0.47000000f,-0.48000000f,0.46000000f,-0.70000000f,0.47000000f,0.01000000f,-0.98000000f,0.49000000f,-0.12000000f,-0.62000000f,-0.45000000f,0.57000000f,-0.05000000f,0.91000000f,0.29000000f,-0.85000000f,-0.14000000f,-0.51000000f,-0.31000000f,0.48000000f,0.81000000f,-0.11000000f,0.10000000f,0.72000000f,0.27000000f,-0.97000000f,0.24000000f,-0.18000000f,-0.09000000f,-0.77000000f,-0.70000000f,0.98000000f,0.50000000f,0.58000000f,0.10000000f,-0.19000000f,0.12000000f,0.05000000f,0.77000000f,0.17000000f,-0.38000000f,-0.17000000f,0.15000000f,-0.18000000f,0.45000000f,0.10000000f,0.86000000f,0.23000000f,-0.74000000f,-0.18000000f,0.41000000f,0.30000000f,-0.75000000f,-0.25000000f,-0.29000000f,0.86000000f,-0.21000000f,0.34000000f,-0.62000000f,0.89000000f,-0.04000000f,-0.34000000f,-0.04000000f,0.38000000f,-0.59000000f,0.02000000f,0.52000000f,0.84000000f,0.14000000f,0.48000000f,-0.89000000f,-0.86000000f,0.12000000f,-0.07000000f,-0.21000000f,-0.94000000f,-0.36000000f,-0.49000000f,0.26000000f,0.70000000f,0.45000000f,0.16000000f,-0.98000000f,-0.85000000f,-0.38000000f,-0.01000000f,-0.31000000f,-0.23000000f,-0.16000000f,0.93000000f,-0.68000000f,0.12000000f,-0.92000000f,-0.55000000f,-0.15000000f,-0.68000000f,-0.59000000f,-0.57000000f,0.79000000f,-0.21000000f,0.17000000f,-0.14000000f,-0.30000000f,-0.35000000f,0.07000000f,-0.15000000f,-0.25000000f,-0.04000000f,0.01000000f,0.28000000f,-0.54000000f,0.85000000f,-0.59000000f,-0.69000000f,-0.18000000f,0.42000000f,-0.93000000f,-0.02000000f,-0.69000000f,0.94000000f,0.11000000f,-0.33000000f,0.34000000f,0.25000000f,-0.77000000f,-0.82000000f,0.33000000f,-0.29000000f,-0.68000000f,-0.52000000f,-0.49000000f,0.57000000f,0.47000000f,-0.60000000f,-0.45000000f,0.69000000f,0.82000000f,-0.15000000f,-0.83000000f,-0.07000000f,-0.79000000f,-0.63000000f,-0.42000000f,-0.62000000f,-0.25000000f,0.78000000f,0.69000000f,0.32000000f,0.36000000f,0.73000000f,0.52000000f,-0.74000000f,-0.11000000f,0.04000000f,-0.96000000f,-0.50000000f,-0.47000000f,-0.88000000f,-0.26000000f,0.67000000f,-0.59000000f,-0.33000000f,0.78000000f,-0.59000000f,0.21000000f,0.13000000f,-0.31000000f,-0.19000000f,0.15000000f,0.26000000f,-0.40000000f,0.43000000f,-0.96000000f,0.75000000f,-0.61000000f,-0.04000000f,0.66000000f,-0.10000000f,0.65000000f,0.12000000f,-0.20000000f,0.98000000f,0.99000000f,-0.75000000f,0.51000000f,0.93000000f,-0.27000000f,0.02000000f,-0.85000000f,-0.62000000f,-0.35000000f,-0.04000000f,0.96000000f,0.85000000f,0.89000000f,-0.38000000f,-0.68000000f,0.02000000f,-0.88000000f,-0.67000000f,0.00000000f,0.92000000f,-0.88000000f,0.56000000f,0.46000000f,-0.72000000f,0.66000000f,0.80000000f,0.48000000f,0.19000000f,0.27000000f,0.15000000f,-0.77000000f,-0.45000000f,-0.94000000f,0.11000000f,0.37000000f,0.22000000f,-0.54000000f,-0.27000000f,-0.67000000f,-0.76000000f,-0.15000000f,-0.20000000f,0.93000000f,-0.05000000f,0.27000000f,0.20000000f,0.72000000f,-0.40000000f,-0.72000000f,-0.49000000f,0.81000000f,0.06000000f,0.83000000f,0.09000000f,0.08000000f,-0.65000000f,-0.26000000f,0.74000000f,-0.22000000f,-0.96000000f,-0.62000000f,-0.45000000f,0.60000000f,-0.10000000f,0.17000000f,0.12000000f,-0.17000000f,-0.74000000f,0.08000000f,0.12000000f,-0.64000000f,0.68000000f,0.92000000f,0.00000000f,-0.04000000f,0.31000000f,-0.83000000f,-0.47000000f,-0.55000000f,-0.89000000f,-0.42000000f,-0.96000000f,-0.62000000f,0.19000000f,-0.47000000f,0.19000000f,-0.46000000f,-0.70000000f,0.39000000f,-0.10000000f,-0.82000000f,0.19000000f,-0.06000000f,-0.47000000f,-0.03000000f,-0.46000000f,0.22000000f,-0.76000000f,0.34000000f,-0.80000000f,0.31000000f,0.41000000f,0.17000000f,0.90000000f,0.47000000f,0.85000000f,-0.94000000f,0.31000000f,-0.81000000f,0.24000000f,0.42000000f,0.20000000f,0.15000000f,-0.24000000f,-0.69000000f,-0.87000000f,-0.65000000f,0.09000000f,-0.25000000f,0.36000000f,-0.38000000f,0.04000000f,-0.80000000f,0.54000000f,0.82000000f,-0.95000000f,0.86000000f,0.40000000f,0.70000000f,-0.34000000f,-0.58000000f,-0.75000000f,-0.37000000f,0.39000000f,-0.62000000f,0.05000000f,-0.76000000f,-0.91000000f,0.65000000f,0.38000000f,0.76000000f,0.36000000f,-0.73000000f,0.06000000f,-0.01000000f,-0.05000000f,0.41000000f,-0.66000000f,0.75000000f,0.56000000f,0.55000000f,-0.09000000f,0.82000000f,0.49000000f,-0.35000000f,0.91000000f,-0.54000000f,0.63000000f,0.00000000f,-0.34000000f,-0.30000000f,-0.08000000f,0.90000000f,0.76000000f,0.41000000f,-0.48000000f,0.95000000f,0.61000000f,0.28000000f,0.41000000f,-0.86000000f,-0.79000000f,0.25000000f,-0.48000000f,0.35000000f,0.22000000f,-0.38000000f,0.33000000f,0.81000000f,-0.85000000f,-0.60000000f,0.87000000f,0.77000000f,0.13000000f,0.90000000f,0.46000000f,0.74000000f,-0.66000000f,0.31000000f,0.00000000f,0.87000000f,0.60000000f,-0.04000000f,0.30000000f,0.61000000f,0.93000000f,0.59000000f,0.19000000f,0.26000000f,-0.93000000f,0.24000000f,0.64000000f,-0.72000000f,0.62000000f,0.31000000f,-0.11000000f,-0.24000000f,0.00000000f,0.79000000f,0.98000000f,-0.43000000f,-0.60000000f,-0.10000000f,0.31000000f,0.38000000f,-0.21000000f,0.81000000f,-0.96000000f,-0.87000000f,-0.66000000f,0.92000000f,0.21000000f,0.53000000f,0.22000000f,-0.25000000f,-0.20000000f,0.02000000f,0.93000000f,0.39000000f,0.38000000f,0.71000000f,-0.38000000f,0.73000000f,0.58000000f,-0.81000000f,0.78000000f,-0.92000000f,-0.26000000f,0.39000000f,0.83000000f,0.85000000f,0.90000000f,-0.26000000f,0.12000000f,-0.40000000f,-0.17000000f,0.54000000f,0.85000000f,-0.38000000f,-0.68000000f,-0.77000000f,0.90000000f,0.08000000f,0.26000000f,0.93000000f,0.52000000f,-0.05000000f,-0.19000000f,-0.64000000f,0.96000000f,0.92000000f,-0.90000000f,0.77000000f,0.05000000f,-0.27000000f,0.76000000f,0.63000000f,-0.15000000f,0.14000000f,0.24000000f,-0.37000000f,-0.39000000f,0.62000000f,-0.68000000f,-0.46000000f,-0.21000000f,-0.72000000f,0.67000000f,-0.75000000f,-0.48000000f,-0.85000000f,-0.06000000f,-0.37000000f,0.07000000f,0.63000000f,0.94000000f,-0.28000000f,-0.88000000f,-0.16000000f,-0.20000000f,-0.23000000f,0.45000000f,-0.02000000f,-0.78000000f,0.76000000f,-0.63000000f,0.09000000f,-0.35000000f,0.91000000f,0.41000000f,-0.89000000f,0.67000000f,0.57000000f,-0.95000000f,0.41000000f,0.62000000f,-0.61000000f,0.17000000f,-0.24000000f,0.34000000f,0.11000000f,-0.25000000f,-0.29000000f,-0.22000000f,0.99000000f,0.73000000f,-0.54000000f,0.39000000f,-0.74000000f,0.32000000f,0.39000000f,-0.40000000f,0.18000000f,0.94000000f,0.94000000f,0.47000000f,0.27000000f,-0.61000000f,-0.62000000f,0.78000000f,0.77000000f,-0.91000000f,0.41000000f,0.67000000f,-0.17000000f,-0.16000000f,0.86000000f,0.50000000f,0.71000000f,0.68000000f,0.54000000f,0.68000000f,0.27000000f,0.35000000f,-0.84000000f,-0.04000000f,-0.06000000f,0.14000000f,0.64000000f,-0.61000000f,-0.51000000f,-0.17000000f,-0.22000000f,-0.55000000f,0.68000000f,0.52000000f,-0.38000000f,-0.18000000f,0.21000000f,0.34000000f,-0.29000000f,-0.85000000f,-0.88000000f,0.92000000f,0.44000000f,-0.02000000f,0.59000000f,-0.06000000f,-0.62000000f,-0.11000000f,-0.72000000f,-0.88000000f,-0.91000000f,-0.59000000f,-0.77000000f,0.67000000f,0.19000000f,0.34000000f,0.05000000f,0.77000000f,0.09000000f,-0.08000000f,-0.60000000f,0.03000000f,0.02000000f,0.00000000f,0.98000000f,0.75000000f,0.96000000f,0.05000000f,-0.09000000f,0.25000000f,-0.53000000f,0.26000000f,0.00000000f,0.26000000f,0.77000000f,0.74000000f,0.38000000f,0.27000000f,0.49000000f,-0.85000000f,0.67000000f,0.59000000f,0.45000000f,0.70000000f,-0.21000000f,0.78000000f,0.74000000f,-0.83000000f,0.85000000f,-0.38000000f,0.78000000f,-0.82000000f,-0.70000000f,-0.36000000f,0.21000000f,0.32000000f,-0.66000000f,-0.33000000f,0.50000000f,0.26000000f,0.59000000f,-0.13000000f,0.86000000f,-0.01000000f,0.52000000f,-0.65000000f,-0.02000000f,-0.82000000f,0.04000000f,0.64000000f,0.62000000f,0.94000000f,0.70000000f,-0.55000000f,-0.03000000f,0.38000000f,-0.45000000f,0.70000000f,-0.17000000f,0.76000000f,0.35000000f,-0.91000000f,-0.85000000f,0.72000000f,-0.18000000f,-0.09000000f,0.54000000f,-0.54000000f,-0.19000000f,-0.97000000f,-0.98000000f,-0.60000000f,0.38000000f,-0.36000000f,0.58000000f,0.56000000f,0.29000000f,0.16000000f,0.27000000f,-0.91000000f,0.53000000f,-0.06000000f,-0.42000000f,0.05000000f,-0.05000000f,0.25000000f,-0.46000000f,0.92000000f,0.37000000f,-0.87000000f,0.14000000f,0.98000000f,-0.33000000f,0.07000000f,0.98000000f,0.16000000f,-0.19000000f,-0.22000000f,-0.45000000f,0.61000000f,-0.77000000f,0.59000000f,0.32000000f,0.34000000f,0.85000000f,0.98000000f,-0.56000000f,-0.46000000f,-0.83000000f,0.64000000f,-0.78000000f,0.33000000f,0.38000000f,0.49000000f,0.90000000f,-0.73000000f,0.50000000f,0.51000000f,-0.25000000f,-0.80000000f,0.17000000f,-0.88000000f,-0.30000000f,0.57000000f,-0.48000000f,-0.83000000f,-0.05000000f,-0.27000000f,-0.28000000f,0.80000000f,-0.26000000f,-0.17000000f,-0.61000000f,0.25000000f,-0.47000000f,-0.65000000f,-0.29000000f,-0.43000000f,-0.88000000f,-0.02000000f,0.97000000f,0.04000000f,0.94000000f,-0.47000000f,0.46000000f,0.19000000f,-0.00000000f,0.70000000f,0.36000000f,0.93000000f,-0.47000000f,-0.85000000f,-0.44000000f,-0.26000000f,-0.44000000f,0.41000000f,-0.50000000f,-0.77000000f,-0.98000000f,0.30000000f,-0.75000000f,-0.53000000f,-0.77000000f,-0.89000000f,0.92000000f,-0.35000000f,0.22000000f,-0.14000000f,-0.50000000f,0.41000000f,0.78000000f,-0.89000000f,0.59000000f,-0.62000000f,-0.82000000f,0.50000000f,0.98000000f,0.85000000f,0.84000000f,0.63000000f,0.40000000f,0.04000000f,0.15000000f,-0.70000000f,0.95000000f,0.10000000f,0.25000000f,-0.02000000f,-0.70000000f,0.88000000f,-0.56000000f,0.56000000f,-0.58000000f,0.52000000f,-0.11000000f,0.02000000f,-0.35000000f,-0.62000000f,-0.15000000f,-0.06000000f,0.15000000f,0.45000000f,-0.99000000f,0.57000000f,-0.19000000f,0.11000000f,0.84000000f,0.02000000f,-0.05000000f,-0.53000000f,0.74000000f,-0.85000000f,-0.07000000f,0.33000000f,0.45000000f,-0.45000000f,-0.74000000f,0.07000000f,0.38000000f,0.60000000f,0.36000000f,0.57000000f,-0.27000000f,-0.54000000f,-0.01000000f,0.68000000f,-0.97000000f,0.67000000f,-0.06000000f,0.67000000f,0.01000000f,0.03000000f,0.65000000f,0.18000000f,-0.81000000f,0.23000000f,0.06000000f,0.45000000f,0.42000000f,-0.17000000f,0.76000000f,-0.27000000f,-0.29000000f,-0.17000000f,0.02000000f,-0.42000000f,-0.46000000f,-0.93000000f,-0.17000000f,-0.78000000f,-0.43000000f,-0.04000000f,-0.69000000f,0.29000000f,0.35000000f,-0.91000000f,-0.97000000f,0.09000000f,0.63000000f,-0.20000000f,0.15000000f,-0.63000000f,-0.96000000f,-0.95000000f,0.60000000f,0.91000000f,0.09000000f,-0.70000000f,0.50000000f,-0.07000000f,0.44000000f,0.01000000f,0.75000000f,0.73000000f,-0.73000000f,0.16000000f,-0.80000000f,0.52000000f,0.64000000f,-0.02000000f,-0.17000000f,0.04000000f,-0.50000000f,0.72000000f,-0.06000000f,0.80000000f,-0.50000000f,-0.78000000f,-0.37000000f,-0.16000000f,-0.06000000f,-0.73000000f,-0.68000000f,-0.45000000f,0.43000000f,-0.41000000f,-0.01000000f,-0.75000000f,0.41000000f,-0.94000000f,0.86000000f,-0.33000000f,0.65000000f,-0.82000000f,-0.53000000f,-0.19000000f,-0.21000000f,0.75000000f,0.39000000f,-0.52000000f,-0.82000000f,0.05000000f,0.29000000f,-0.84000000f,-0.03000000f,-0.05000000f,-0.92000000f,0.66000000f,0.14000000f,0.19000000f,-0.98000000f,0.09000000f,0.48000000f,0.96000000f,0.39000000f,0.67000000f,-0.49000000f,0.42000000f,0.30000000f,0.84000000f,-0.46000000f,-0.41000000f,0.92000000f,-0.93000000f,0.51000000f,-0.90000000f,-0.54000000f,-0.32000000f,0.18000000f,-0.83000000f,-0.05000000f,0.78000000f,-0.76000000f,0.76000000f,-0.50000000f,-0.94000000f,-0.58000000f,0.52000000f,0.45000000f,-0.17000000f,0.62000000f,0.48000000f,0.85000000f,0.11000000f,0.74000000f,0.99000000f,0.94000000f,-0.77000000f,0.44000000f,-0.89000000f,0.97000000f,-0.77000000f,0.16000000f,-0.35000000f,0.16000000f,-0.45000000f,0.50000000f,-0.96000000f,0.74000000f,-0.52000000f,-0.64000000f,0.13000000f,-0.21000000f,-0.03000000f,-0.16000000f,0.35000000f,0.53000000f,-0.82000000f,0.34000000f,0.52000000f,-0.59000000f,-0.17000000f,-0.53000000f,-0.88000000f,0.67000000f,0.13000000f,-0.21000000f,0.93000000f,-0.45000000f,-0.11000000f,-0.60000000f,0.84000000f,0.16000000f,0.76000000f,0.01000000f,0.89000000f,0.87000000f,0.04000000f,0.86000000f,0.20000000f,0.20000000f,0.61000000f,-0.21000000f,0.04000000f,0.26000000f,0.91000000f,-0.40000000f,0.00000000f,-0.26000000f,-0.12000000f,0.35000000f,0.21000000f,-0.87000000f,0.81000000f,-0.03000000f,-0.82000000f,0.19000000f,-0.71000000f,0.93000000f,0.39000000f,-0.70000000f,-0.97000000f,0.20000000f,0.92000000f,0.13000000f,-0.81000000f,0.88000000f,0.34000000f,-0.27000000f,-0.46000000f,0.78000000f,0.94000000f,-0.50000000f,0.57000000f,0.06000000f,-0.52000000f,0.14000000f,0.33000000f,-0.34000000f,-0.31000000f,-0.05000000f,-0.73000000f,0.13000000f,-0.63000000f,0.88000000f,-0.44000000f,-0.15000000f,0.11000000f,0.90000000f,-0.36000000f,0.51000000f,-0.38000000f,-0.64000000f,-0.21000000f,0.13000000f,0.89000000f,0.81000000f,-0.69000000f,0.15000000f,-0.67000000f,-0.89000000f,-0.47000000f,0.73000000f,-0.15000000f,-0.97000000f,-0.24000000f,-0.57000000f,0.91000000f,-0.64000000f,-0.30000000f,0.67000000f,-0.55000000f,-0.68000000f,0.98000000f,-0.98000000f,0.96000000f,-0.36000000f,-0.55000000f,0.11000000f,-0.73000000f,0.57000000f,0.73000000f,-0.46000000f,-0.11000000f,0.52000000f,0.48000000f,0.06000000f,0.43000000f,-0.41000000f,-0.43000000f,0.58000000f,-0.69000000f,0.57000000f,0.71000000f,-0.73000000f,0.19000000f,-0.45000000f,-0.24000000f,0.96000000f,0.61000000f,0.66000000f,-0.50000000f,-0.46000000f,0.32000000f,0.43000000f,0.15000000f,-0.93000000f,0.77000000f,0.60000000f,-0.27000000f,-0.37000000f,0.31000000f,-0.69000000f,0.20000000f,-0.22000000f,0.90000000f,0.51000000f,-0.56000000f,-0.50000000f,-0.55000000f,0.64000000f,-0.03000000f,0.70000000f,0.90000000f,-0.83000000f,-0.11000000f,-0.70000000f,0.82000000f,0.62000000f,0.66000000f,0.26000000f,0.24000000f,-0.55000000f,0.72000000f,0.42000000f,0.58000000f,0.60000000f,-0.02000000f,-0.29000000f,0.73000000f,-0.04000000f,-0.45000000f,0.01000000f,-0.04000000f,-0.59000000f,0.86000000f,-0.29000000f,0.82000000f,0.56000000f,-0.76000000f,-0.58000000f,0.77000000f,0.96000000f,-0.28000000f,0.71000000f,0.19000000f,-0.26000000f,0.98000000f,0.32000000f,-0.75000000f,-0.24000000f,0.85000000f,-0.26000000f,-0.73000000f,0.49000000f,0.26000000f,-0.74000000f,0.08000000f,-0.53000000f,-0.58000000f,0.52000000f,0.41000000f,0.06000000f,0.20000000f,0.47000000f,-0.41000000f,0.14000000f,0.00000000f,0.94000000f,0.76000000f,-0.41000000f,-0.90000000f,0.92000000f,-0.29000000f,0.52000000f,-0.94000000f,0.37000000f,0.87000000f,-0.06000000f,-0.44000000f,-0.33000000f,-0.04000000f,0.78000000f,-0.55000000f,-0.23000000f,0.25000000f,0.08000000f,0.41000000f,-0.48000000f,0.05000000f,-0.37000000f,0.39000000f,-0.74000000f,-0.89000000f,0.51000000f,-0.80000000f,-0.70000000f,-0.94000000f,0.32000000f,-0.43000000f,-0.75000000f,0.63000000f,-0.33000000f,-0.67000000f,-0.33000000f,0.18000000f,0.65000000f,0.34000000f,0.92000000f,0.08000000f,0.92000000f,0.04000000f,-0.33000000f,-0.59000000f,0.62000000f,0.85000000f,-0.49000000f,0.39000000f,-0.37000000f,-0.04000000f,-0.11000000f,0.23000000f,-0.41000000f,-0.84000000f,0.71000000f,-0.35000000f,0.88000000f,0.70000000f,0.94000000f,0.19000000f,0.85000000f,-0.35000000f,0.84000000f,-0.99000000f,-0.70000000f,0.57000000f,-0.78000000f,-0.96000000f,-0.55000000f,0.79000000f,0.67000000f,0.09000000f,-0.28000000f,-0.11000000f,0.22000000f,0.92000000f,0.79000000f,-0.70000000f,-0.62000000f,0.56000000f,-0.70000000f,-0.15000000f,0.18000000f,0.65000000f,0.97000000f,-0.87000000f,-0.04000000f,-0.75000000f,-0.65000000f,0.12000000f,-0.09000000f,0.85000000f,0.98000000f,0.58000000f,0.09000000f,-0.06000000f,0.70000000f,0.19000000f,-0.89000000f,-0.53000000f,-0.26000000f,-0.79000000f,-0.07000000f,0.19000000f,-0.68000000f,0.72000000f,0.87000000f,-0.10000000f,0.68000000f,-0.12000000f,-0.44000000f,0.26000000f,-0.30000000f,0.36000000f,-0.98000000f,-0.76000000f,-0.93000000f,0.93000000f,-0.68000000f,-0.39000000f,-0.06000000f,0.87000000f,-0.19000000f,0.60000000f,0.96000000f,0.91000000f,0.05000000f,-0.95000000f,0.13000000f,0.35000000f,0.87000000f,0.67000000f,-0.48000000f,0.26000000f,0.19000000f,0.74000000f,-0.53000000f,-0.54000000f,0.60000000f,0.08000000f,0.50000000f,0.18000000f,0.89000000f,0.89000000f,-0.19000000f,0.10000000f,0.72000000f,-0.13000000f,-0.38000000f,-0.45000000f,0.19000000f,0.33000000f,-0.01000000f,-0.34000000f,-0.28000000f,-0.42000000f,-0.39000000f,0.48000000f,0.11000000f,-0.66000000f,0.22000000f,-0.08000000f,0.71000000f,0.86000000f,0.02000000f,-0.02000000f,0.39000000f,-0.86000000f,-0.51000000f,0.50000000f,-0.42000000f,0.12000000f,0.44000000f,-0.47000000f,-0.43000000f,0.11000000f,-0.92000000f,-0.07000000f,0.83000000f,-0.69000000f,-0.28000000f,-0.13000000f,0.05000000f,-0.49000000f,0.07000000f,-0.34000000f,0.18000000f,-0.42000000f,0.57000000f,0.44000000f,0.57000000f,0.45000000f,0.97000000f,-0.57000000f,0.30000000f,-0.87000000f,-0.90000000f,-0.11000000f,-0.14000000f,0.89000000f,0.74000000f,0.35000000f,0.30000000f,-0.16000000f,-0.17000000f,0.23000000f,-0.63000000f,-0.95000000f,0.79000000f,-0.39000000f,0.38000000f,0.34000000f,-0.69000000f,-0.45000000f,-0.34000000f,0.96000000f,-0.02000000f,-0.77000000f,0.15000000f,0.37000000f,-0.61000000f,-0.83000000f,0.48000000f,-0.57000000f,0.52000000f,-0.71000000f,-0.02000000f,-0.83000000f,0.34000000f,0.29000000f,-0.05000000f,0.73000000f,-0.15000000f,0.89000000f,-0.17000000f,-0.81000000f,0.59000000f,0.11000000f,0.92000000f,0.31000000f,0.71000000f,-0.89000000f,-0.70000000f,0.31000000f,0.75000000f,-0.59000000f,-0.89000000f,-0.81000000f,-0.81000000f,0.23000000f,0.12000000f,0.26000000f,0.56000000f,0.01000000f,0.24000000f,-0.26000000f,0.61000000f,-0.58000000f,0.57000000f,-0.95000000f,-0.46000000f,0.78000000f,0.06000000f,-0.32000000f,0.88000000f,0.84000000f,-0.25000000f,-0.25000000f,-0.32000000f,0.48000000f,0.28000000f,-0.14000000f,0.48000000f,0.29000000f,0.67000000f,0.89000000f,0.97000000f,0.54000000f,-0.46000000f,0.19000000f,0.67000000f,-0.27000000f,0.19000000f,-0.64000000f,0.68000000f,0.30000000f,0.24000000f,-0.61000000f,-0.28000000f,-0.26000000f,0.32000000f,-0.30000000f,-0.72000000f,0.01000000f,0.19000000f,-0.35000000f,-0.56000000f,-0.02000000f,0.17000000f,0.45000000f,0.07000000f,-0.07000000f,-0.75000000f,0.21000000f,-0.19000000f,0.21000000f,0.89000000f,-0.13000000f,0.51000000f,0.70000000f,-0.00000000f,-0.92000000f,-0.64000000f,0.26000000f,-0.13000000f,0.69000000f,0.28000000f,-0.47000000f,-0.78000000f,-0.32000000f,0.01000000f,0.15000000f,0.36000000f,-0.28000000f,-0.35000000f,0.31000000f,-0.47000000f,0.53000000f,0.51000000f,0.23000000f,0.35000000f,0.97000000f,0.23000000f,-0.09000000f,0.81000000f,-0.26000000f,0.08000000f,-0.17000000f,-0.41000000f,0.78000000f,-0.51000000f,0.16000000f,-0.27000000f,0.05000000f,-0.30000000f,0.32000000f,0.51000000f,0.19000000f,0.94000000f,0.60000000f,0.10000000f,0.21000000f,0.49000000f,-0.69000000f,0.23000000f,-0.87000000f,0.64000000f,-0.36000000f,-0.53000000f,-0.63000000f,-0.05000000f,-0.95000000f,0.23000000f,0.85000000f,-0.32000000f,-0.11000000f,-0.89000000f,-0.13000000f,0.31000000f,0.28000000f,-0.69000000f,-0.37000000f,-0.47000000f,-0.79000000f,0.78000000f,-0.90000000f,0.91000000f,-0.86000000f,0.05000000f,-0.86000000f,-0.74000000f,0.19000000f,0.68000000f,-0.56000000f,0.04000000f,0.10000000f,-0.35000000f,0.47000000f,-0.79000000f,-0.28000000f,0.46000000f,-0.11000000f,0.60000000f,0.72000000f,-0.47000000f,0.03000000f,0.63000000f,0.75000000f,-0.84000000f,0.40000000f,-0.25000000f,-0.72000000f,0.63000000f,-0.22000000f,-0.96000000f,0.43000000f,-0.61000000f,0.73000000f,-0.58000000f,0.78000000f,-0.11000000f,-0.30000000f,-0.59000000f,-0.11000000f,0.01000000f,0.44000000f,0.35000000f,0.42000000f,-0.84000000f,0.13000000f,0.63000000f,0.37000000f,-0.45000000f,0.86000000f,0.90000000f,0.08000000f,-0.50000000f,0.89000000f,0.54000000f,0.50000000f,-0.17000000f,-0.89000000f,-0.72000000f,0.60000000f,-0.75000000f,0.75000000f,-0.79000000f,0.60000000f,0.56000000f,-0.67000000f,0.75000000f,-0.70000000f,-0.15000000f,-0.09000000f,-0.27000000f,0.44000000f,0.74000000f,-0.97000000f,-0.72000000f,0.47000000f,0.83000000f,0.60000000f,-0.97000000f,0.32000000f,0.24000000f,0.33000000f,0.65000000f,0.74000000f,-0.10000000f,0.19000000f,0.30000000f,-0.94000000f,0.07000000f,-0.04000000f,-0.47000000f,0.56000000f,-0.94000000f,0.01000000f,-0.65000000f,-0.18000000f,0.41000000f,-0.34000000f,-0.42000000f,0.56000000f,0.40000000f,-0.17000000f,-0.98000000f,0.62000000f,0.27000000f,-0.27000000f,0.25000000f,0.26000000f,0.41000000f,-0.17000000f,0.18000000f,-0.67000000f,-0.17000000f,-0.78000000f,0.52000000f,0.83000000f,0.04000000f,-0.14000000f,0.35000000f,0.73000000f,0.14000000f,0.72000000f,-0.26000000f,0.83000000f,-0.60000000f,-0.61000000f,0.89000000f,0.30000000f,0.07000000f,0.82000000f,-0.79000000f,-0.68000000f,-0.42000000f,-0.40000000f,-0.99000000f,-0.86000000f,0.48000000f,0.44000000f,0.50000000f,0.51000000f,0.16000000f,-0.77000000f,-0.15000000f,-0.70000000f,0.64000000f,0.97000000f,-0.71000000f,-0.54000000f,0.23000000f,-0.23000000f,0.83000000f,0.53000000f,-0.58000000f,0.62000000f,-0.32000000f,0.84000000f,-0.66000000f,0.95000000f,0.76000000f,0.92000000f,0.48000000f,-0.81000000f,0.43000000f,0.08000000f,-0.67000000f,0.46000000f,0.30000000f,0.23000000f,0.01000000f,0.55000000f,0.02000000f,0.81000000f,0.56000000f,-0.34000000f,-0.69000000f,0.05000000f,-0.99000000f,0.96000000f,-0.84000000f,0.34000000f,0.88000000f,0.01000000f,0.44000000f,-0.19000000f,0.28000000f,0.39000000f,-0.70000000f,-0.24000000f,-0.83000000f,0.44000000f,0.09000000f,-0.08000000f,0.42000000f,0.09000000f,0.24000000f,-0.86000000f,-0.21000000f,-0.90000000f,-0.87000000f,-0.91000000f,0.29000000f,-0.61000000f,-0.84000000f,0.36000000f,-0.40000000f,-0.45000000f,0.46000000f,0.05000000f,-0.55000000f,0.24000000f,0.99000000f,-0.20000000f,0.18000000f,-0.16000000f,0.45000000f,0.90000000f,0.38000000f,-0.37000000f,0.24000000f,0.90000000f,-0.55000000f,0.09000000f,-0.53000000f,-0.14000000f,0.66000000f,-0.59000000f,-0.70000000f,0.24000000f,0.17000000f,0.24000000f,-0.65000000f,0.76000000f,0.32000000f,0.49000000f,-0.65000000f,0.55000000f,-0.59000000f,-0.31000000f,0.78000000f,-0.67000000f,-0.29000000f,-0.60000000f,0.31000000f,0.26000000f,-0.02000000f,0.87000000f,-0.31000000f,0.95000000f,0.14000000f,0.76000000f,-0.89000000f,0.26000000f,0.74000000f,-0.41000000f,0.10000000f,-0.93000000f,-0.42000000f,-0.60000000f,-0.96000000f,-0.31000000f,0.90000000f,-0.20000000f,0.68000000f,-0.57000000f,0.86000000f,-0.71000000f,0.68000000f,0.26000000f,0.75000000f,0.79000000f,0.09000000f,0.94000000f,0.20000000f,0.11000000f,-0.27000000f,-0.06000000f,0.23000000f,0.43000000f,-0.44000000f,-0.87000000f,0.56000000f,-0.34000000f,0.37000000f,-0.49000000f,-0.47000000f,0.10000000f,0.53000000f,0.80000000f,0.53000000f,-0.44000000f,-0.92000000f,0.79000000f,-0.89000000f,0.50000000f,0.82000000f,-0.09000000f,-0.14000000f,-0.88000000f,0.16000000f,-0.15000000f,0.81000000f,-0.96000000f,0.99000000f,0.30000000f,0.09000000f,-0.84000000f,-0.61000000f,0.41000000f,-0.68000000f,0.54000000f,-0.86000000f,-0.87000000f,-0.55000000f,0.69000000f,0.67000000f,-0.43000000f,0.09000000f,0.47000000f,0.85000000f,-0.36000000f,0.27000000f,-0.10000000f,0.93000000f,0.34000000f,-0.77000000f,0.45000000f,-0.37000000f,0.71000000f,0.82000000f,-0.98000000f,0.42000000f,-0.07000000f,0.50000000f,0.66000000f,0.62000000f,0.13000000f,-0.53000000f,-0.83000000f,-0.38000000f,-0.03000000f,-0.49000000f,-0.10000000f,0.21000000f,0.89000000f,-0.90000000f,0.55000000f,-0.62000000f,0.42000000f,0.45000000f,-0.17000000f,-0.04000000f,-0.22000000f,-0.20000000f,-0.10000000f,0.42000000f,0.97000000f,-0.08000000f,-0.58000000f,-0.25000000f,0.02000000f,-0.08000000f,-0.38000000f,0.89000000f,-0.65000000f,0.46000000f,-0.35000000f,-0.54000000f,0.92000000f,0.03000000f,0.58000000f,-0.00000000f,-0.40000000f,-0.55000000f,0.99000000f,-0.46000000f,-0.17000000f,0.17000000f,-0.05000000f,-0.28000000f,0.57000000f,-0.15000000f,-0.41000000f,0.24000000f,0.64000000f,0.55000000f,-0.43000000f,-0.52000000f,0.79000000f,0.59000000f,0.23000000f,-0.41000000f,-0.87000000f,0.82000000f,-0.26000000f,-0.10000000f,-0.14000000f,-0.93000000f,-0.03000000f,-0.51000000f,0.17000000f,-0.53000000f,-0.27000000f,-0.64000000f,0.28000000f,-0.98000000f,0.03000000f,-0.06000000f,0.22000000f,0.65000000f,0.93000000f,0.18000000f,-0.60000000f,0.74000000f,0.13000000f,0.79000000f,-0.20000000f,-0.12000000f,0.08000000f,-0.93000000f,-0.82000000f,0.61000000f,-0.68000000f,0.17000000f,-0.66000000f,0.23000000f,-0.62000000f,-0.23000000f,0.65000000f,0.42000000f,0.29000000f,-0.46000000f,0.97000000f,-0.42000000f,0.85000000f,-0.18000000f,-0.68000000f,0.13000000f,-0.50000000f,0.83000000f,0.59000000f,-0.44000000f,-0.14000000f,0.74000000f,0.46000000f,-0.27000000f,0.38000000f,-0.06000000f,-0.34000000f,-0.52000000f,0.66000000f,0.95000000f,0.69000000f,-0.09000000f,-0.37000000f,-0.35000000f,0.57000000f,0.19000000f,-0.65000000f,-0.70000000f,0.43000000f,-0.01000000f,0.24000000f,0.83000000f,0.28000000f,0.37000000f,-0.18000000f,-0.50000000f,0.10000000f,0.80000000f,0.04000000f,0.11000000f,0.02000000f,-0.44000000f,0.30000000f,0.91000000f,-0.42000000f,0.04000000f,-0.48000000f,-0.25000000f,-0.79000000f,-0.20000000f,0.33000000f,0.22000000f,-0.55000000f,-0.73000000f,0.25000000f,0.53000000f,0.57000000f,0.40000000f,0.53000000f,-0.69000000f,0.86000000f,0.78000000f,0.90000000f,0.79000000f,-0.52000000f,-0.90000000f,-0.16000000f,0.88000000f,0.40000000f,0.75000000f,0.53000000f,-0.91000000f,-0.39000000f,-0.79000000f,-0.26000000f,0.77000000f,-0.56000000f,-0.82000000f,-0.17000000f,0.94000000f,-0.86000000f,0.57000000f,-0.61000000f,-0.86000000f,0.11000000f,0.90000000f,-0.50000000f,-0.38000000f,0.06000000f,0.46000000f,0.60000000f,-0.81000000f,-0.81000000f,0.64000000f,0.13000000f,0.41000000f,-0.12000000f,-0.44000000f,-0.66000000f,-0.86000000f,-0.08000000f,0.16000000f,0.18000000f,0.45000000f,0.84000000f,-0.18000000f,-0.09000000f,0.78000000f,0.67000000f,0.86000000f,0.08000000f,-0.06000000f,0.77000000f,-0.88000000f,0.45000000f,-0.77000000f,-0.06000000f,-0.48000000f,0.81000000f,-0.48000000f,-0.01000000f,0.75000000f,0.43000000f,-0.63000000f,0.65000000f,-0.52000000f,-0.72000000f,-0.56000000f,-0.05000000f,-0.63000000f,0.08000000f,-0.34000000f,-0.72000000f,-0.70000000f,0.84000000f,-0.84000000f,-0.64000000f,-0.80000000f,0.40000000f,0.19000000f,0.07000000f,0.49000000f,0.62000000f,0.17000000f,-0.79000000f,0.62000000f,-0.59000000f,-0.82000000f,-0.40000000f,-0.07000000f,-0.35000000f,0.42000000f,-0.23000000f,-0.92000000f,0.70000000f,0.12000000f,0.93000000f,0.58000000f,0.94000000f,-0.67000000f,-0.13000000f,-0.96000000f,-0.04000000f,-0.57000000f,0.67000000f,0.36000000f,-0.03000000f,0.51000000f,-0.87000000f,0.58000000f,0.85000000f,0.54000000f,-0.10000000f,-0.98000000f,0.64000000f,-0.33000000f,0.70000000f,0.94000000f,-0.53000000f,-0.44000000f,-0.39000000f,0.17000000f,0.34000000f,0.22000000f,0.50000000f,0.63000000f,-0.61000000f,0.15000000f,-0.82000000f,-0.20000000f,-0.79000000f,-0.24000000f,0.58000000f,-0.48000000f,-0.76000000f,0.39000000f,-0.85000000f,-0.52000000f,-0.90000000f,0.00000000f,0.06000000f,0.40000000f,-0.89000000f,0.17000000f,-0.30000000f,-0.79000000f,-0.86000000f,0.44000000f,0.55000000f,0.49000000f,0.54000000f,0.12000000f,0.72000000f,0.17000000f,0.65000000f,-0.74000000f,-0.33000000f,-0.82000000f,0.30000000f,0.24000000f,-0.39000000f,0.47000000f,0.79000000f,-0.31000000f,0.97000000f,-0.17000000f,0.57000000f,-0.63000000f,0.23000000f,0.43000000f,-0.55000000f,0.61000000f,-0.88000000f,0.51000000f,-0.93000000f,0.26000000f,0.34000000f,-0.32000000f,0.22000000f,-0.38000000f,-0.93000000f,0.76000000f,-0.90000000f,-0.02000000f,0.08000000f,-0.07000000f,-0.71000000f,0.61000000f,-0.80000000f,0.81000000f,-0.26000000f,-0.82000000f,-0.18000000f,0.98000000f,0.57000000f,0.17000000f,-0.93000000f,0.67000000f,-0.80000000f,-0.07000000f,-0.43000000f,0.66000000f,0.17000000f,-0.26000000f,0.35000000f,0.15000000f,0.83000000f,0.74000000f,-0.88000000f,0.01000000f,0.81000000f,-0.90000000f,-0.75000000f,0.59000000f,0.00000000f,-0.42000000f,-0.11000000f,-0.54000000f,-0.99000000f,0.49000000f,0.46000000f,0.45000000f,0.27000000f,0.57000000f,-0.88000000f,0.54000000f,-0.59000000f,0.66000000f,-0.71000000f,-0.79000000f,-0.51000000f,0.73000000f,0.53000000f,-0.00000000f,0.52000000f,-0.84000000f,-0.39000000f,0.58000000f,0.17000000f,-0.29000000f,-0.36000000f,-0.57000000f,-0.25000000f,0.36000000f,0.58000000f,-0.06000000f,-0.71000000f,-0.35000000f,-0.87000000f,-0.38000000f,-0.60000000f,-0.75000000f,0.30000000f,0.97000000f,0.55000000f,0.31000000f,0.61000000f,0.59000000f,-0.24000000f,-0.13000000f,-0.91000000f,-0.07000000f,-0.17000000f,-0.82000000f,-0.40000000f,0.68000000f,0.78000000f,0.96000000f,-0.70000000f,0.19000000f,-0.98000000f,0.83000000f,0.77000000f,-0.17000000f,0.26000000f,-0.98000000f,0.62000000f,-0.43000000f,0.74000000f,0.50000000f,-0.36000000f,-0.78000000f,-0.34000000f,0.42000000f,0.62000000f,0.43000000f,-0.17000000f,0.83000000f,0.25000000f,0.51000000f,0.07000000f,-0.40000000f,0.05000000f,-0.69000000f,0.44000000f,-0.88000000f,0.12000000f,0.53000000f,0.24000000f,0.16000000f,0.08000000f,-0.97000000f,0.00000000f,-0.58000000f,0.19000000f,0.59000000f,0.32000000f,-0.46000000f,0.65000000f,-0.27000000f,-0.30000000f,0.63000000f,-0.85000000f,-0.99000000f,0.76000000f,-0.62000000f,0.90000000f,0.68000000f,-0.98000000f,0.40000000f,0.15000000f,-0.34000000f,-0.03000000f,-0.64000000f,-0.03000000f,0.99000000f,0.14000000f,-0.48000000f,-0.91000000f,-0.29000000f,0.43000000f,-0.40000000f,0.36000000f,0.15000000f,0.73000000f,0.00000000f,-0.39000000f,-0.55000000f,0.15000000f,0.12000000f,0.48000000f,0.47000000f,0.47000000f,-0.25000000f,-0.45000000f,0.68000000f,0.48000000f,-0.92000000f,-0.23000000f,0.36000000f,0.78000000f,-0.20000000f,-0.15000000f,-0.14000000f,0.82000000f,-0.49000000f,-0.91000000f,-0.92000000f,-0.92000000f,-0.25000000f,-0.22000000f,0.77000000f,0.44000000f,-0.86000000f,0.16000000f,0.76000000f,-0.06000000f,0.73000000f,-0.94000000f,-0.99000000f,-0.14000000f,0.52000000f,-0.63000000f,-0.18000000f,0.77000000f,-0.70000000f,-0.92000000f,0.36000000f,0.06000000f,0.57000000f,-0.96000000f,0.10000000f,0.12000000f,-0.64000000f,0.38000000f,-0.75000000f,-0.09000000f,-0.81000000f,-0.17000000f,-0.82000000f,0.39000000f,0.16000000f,-0.49000000f,-0.82000000f,-0.95000000f,0.16000000f,0.20000000f,0.12000000f,0.40000000f,0.26000000f,0.94000000f,0.55000000f,-0.83000000f,0.06000000f,-0.04000000f,0.42000000f,-0.97000000f,0.49000000f,-0.15000000f,-0.18000000f,-0.40000000f,0.43000000f,-0.56000000f,0.33000000f,0.29000000f,-0.94000000f,-0.74000000f,-0.20000000f,0.47000000f,-0.08000000f,-0.95000000f,0.08000000f,-0.32000000f,0.75000000f,-0.67000000f,0.36000000f,-0.29000000f,-0.41000000f,0.85000000f,-0.15000000f,0.09000000f,0.26000000f,-0.40000000f,-0.64000000f,-0.43000000f,-0.45000000f,0.87000000f,-0.62000000f,-0.96000000f,0.26000000f,0.87000000f,-0.36000000f,-0.69000000f,-0.93000000f,-0.32000000f,0.09000000f,0.94000000f,-0.85000000f,0.31000000f,-0.59000000f,-0.08000000f,0.10000000f,0.33000000f,-0.97000000f,-0.54000000f,-0.50000000f,0.25000000f,0.26000000f,0.67000000f,0.30000000f,-0.98000000f,0.67000000f,-0.92000000f,-0.56000000f,-0.80000000f,-0.53000000f,-0.34000000f,-0.68000000f,-0.28000000f,0.59000000f,-0.56000000f,0.94000000f,-0.10000000f,-0.26000000f,-0.93000000f,0.54000000f,0.13000000f,0.23000000f,-0.81000000f,0.36000000f,-0.26000000f,0.90000000f,0.53000000f,-0.43000000f,0.68000000f,0.28000000f,0.31000000f,0.25000000f,0.45000000f,-0.21000000f,0.67000000f,-0.56000000f,-0.63000000f,0.05000000f,0.39000000f,0.81000000f,-0.37000000f,-0.92000000f,0.53000000f,0.40000000f,-0.31000000f,0.23000000f,-0.00000000f,-0.83000000f,0.46000000f,-0.54000000f,0.98000000f,0.09000000f,-0.54000000f,-0.89000000f,0.82000000f,-0.62000000f,-0.09000000f,0.02000000f,-0.24000000f,0.42000000f,-0.85000000f,0.15000000f,-0.59000000f,-0.73000000f,0.73000000f,-0.19000000f,-0.58000000f,-0.45000000f,0.98000000f,-0.12000000f,-0.24000000f,-0.49000000f,-0.49000000f,0.46000000f,0.59000000f,-0.74000000f,0.79000000f,0.22000000f,-0.11000000f,-0.64000000f,-0.68000000f,0.31000000f,0.28000000f,0.23000000f,0.77000000f,-0.36000000f,0.30000000f,0.68000000f,-0.51000000f,-0.52000000f,0.59000000f,0.06000000f,0.29000000f,0.69000000f,-0.11000000f,-0.35000000f,0.67000000f,-0.18000000f,-0.59000000f,-0.77000000f,-0.09000000f,0.30000000f,0.78000000f,-0.36000000f,0.06000000f,-0.08000000f,-0.25000000f,-0.69000000f,0.82000000f,0.64000000f,-0.41000000f,0.40000000f,-0.34000000f,0.01000000f,-0.26000000f,0.40000000f,-0.73000000f,0.84000000f,0.39000000f,-0.42000000f,-0.31000000f,-0.28000000f,-0.96000000f,-0.75000000f,-0.64000000f,0.23000000f,-0.76000000f,-0.42000000f,0.92000000f,0.52000000f,0.92000000f,-0.58000000f,0.69000000f,-0.15000000f,0.24000000f,-0.27000000f,-0.86000000f,-0.09000000f,-0.42000000f,-0.74000000f,-0.01000000f,-0.18000000f,-0.41000000f,0.64000000f,0.92000000f,-0.58000000f,0.66000000f,-0.59000000f,-0.64000000f,0.20000000f,-0.80000000f,-0.58000000f,-0.44000000f,-0.34000000f,-0.11000000f,-0.07000000f,0.18000000f,0.31000000f,-0.05000000f,0.90000000f,-0.10000000f,-0.59000000f,0.33000000f,0.89000000f,-0.78000000f,0.66000000f,0.59000000f,0.76000000f,0.52000000f,0.04000000f,0.37000000f,0.79000000f,0.40000000f,-0.97000000f,-0.41000000f,0.04000000f,0.10000000f,0.72000000f,-0.20000000f,-0.95000000f,0.69000000f,0.26000000f,-0.56000000f,0.88000000f,-0.09000000f,-0.73000000f,-0.61000000f,-0.88000000f,-0.53000000f,-0.61000000f,-0.52000000f,-0.29000000f,0.96000000f,-0.61000000f,-0.63000000f,0.18000000f,0.04000000f,-0.31000000f,0.47000000f,-0.72000000f,0.57000000f,-0.69000000f,-0.30000000f,0.32000000f,0.38000000f,-0.31000000f,-0.05000000f,0.83000000f,-0.17000000f,0.40000000f,0.33000000f,-0.27000000f,0.09000000f,0.85000000f,-0.99000000f,-0.96000000f,-0.57000000f,-0.56000000f,-0.73000000f,0.69000000f,0.42000000f,-0.89000000f,-0.24000000f,0.99000000f,-0.18000000f,0.91000000f,-0.66000000f,-0.63000000f,-0.24000000f,-0.24000000f,-0.63000000f,0.80000000f,0.96000000f,0.94000000f,0.59000000f,-0.76000000f,0.26000000f,0.74000000f,-0.89000000f,0.50000000f,0.16000000f,0.21000000f,-0.48000000f,0.32000000f,-0.33000000f,0.13000000f,-0.61000000f,-0.01000000f,0.63000000f,-0.62000000f,0.45000000f,-0.03000000f,-0.25000000f,0.33000000f,0.09000000f,-0.96000000f,0.00000000f,-0.63000000f,0.41000000f,0.48000000f,0.90000000f,-0.61000000f,0.98000000f,-0.02000000f,-0.45000000f,-0.28000000f,0.14000000f,-0.22000000f,-0.68000000f,-0.46000000f,0.64000000f,-0.95000000f,-0.31000000f,-0.24000000f,0.88000000f,0.34000000f,-0.34000000f,-0.42000000f,0.56000000f,-0.40000000f,-0.27000000f,-0.09000000f,-0.78000000f,0.84000000f,0.25000000f,0.34000000f,-0.74000000f,0.46000000f,-0.95000000f,0.05000000f,-0.72000000f,-0.15000000f,0.12000000f,0.49000000f,-0.74000000f,0.91000000f,0.65000000f,0.89000000f,-0.33000000f,-0.57000000f,-0.49000000f,-0.19000000f,-0.08000000f,-0.36000000f,0.74000000f,-0.48000000f,0.07000000f,0.09000000f,-0.48000000f,-0.16000000f,0.65000000f,-0.29000000f,-0.13000000f,0.04000000f,0.37000000f,-0.66000000f,0.06000000f,-0.38000000f,0.10000000f,0.07000000f,0.92000000f,-0.41000000f,-0.17000000f,0.99000000f,0.36000000f,-0.38000000f,0.21000000f,0.66000000f,-0.25000000f,-0.32000000f,-0.31000000f,0.85000000f,-0.47000000f,-0.38000000f,-0.40000000f,-0.10000000f,0.08000000f,0.27000000f,-0.50000000f,-0.31000000f,0.96000000f,0.51000000f,-0.83000000f,0.63000000f,0.65000000f,-0.70000000f,0.09000000f,-0.48000000f,0.48000000f,0.22000000f,0.72000000f,-0.90000000f,-0.06000000f,0.19000000f,-0.16000000f,0.41000000f,-0.69000000f,-0.16000000f,-0.71000000f,0.78000000f,-0.83000000f,-0.76000000f,-0.20000000f,-0.81000000f,0.64000000f,-0.49000000f,0.08000000f,-0.15000000f,-0.33000000f,0.77000000f,0.51000000f,-0.24000000f,-0.08000000f,0.82000000f,-0.58000000f,0.64000000f,0.49000000f,-0.18000000f,0.43000000f,-0.54000000f,-0.85000000f,-0.24000000f,-0.71000000f,-0.90000000f,0.69000000f,-0.73000000f,0.72000000f,0.47000000f,-0.42000000f,-0.75000000f,-0.51000000f,0.80000000f,0.18000000f,-0.08000000f,-0.41000000f,0.61000000f,-0.31000000f,-0.39000000f,0.97000000f,-0.32000000f,0.51000000f,-0.61000000f,-0.35000000f,0.10000000f,-0.08000000f,-0.28000000f,-0.04000000f,0.94000000f,0.71000000f,0.61000000f,-0.13000000f,0.21000000f,0.96000000f,-0.61000000f,0.85000000f,-0.55000000f,0.96000000f,-0.18000000f,-0.05000000f,-0.85000000f,-0.60000000f,0.92000000f,-0.88000000f,-0.71000000f,-0.40000000f,0.14000000f,0.69000000f,-0.21000000f,0.63000000f,0.86000000f,0.44000000f,-0.25000000f,-0.23000000f,-0.05000000f,-0.29000000f,0.89000000f,-0.53000000f,-0.06000000f,0.03000000f,0.36000000f,-0.83000000f,0.79000000f,-0.40000000f,-0.10000000f,0.90000000f,-0.92000000f,-0.49000000f,-0.38000000f,-0.43000000f,0.02000000f,0.98000000f,-0.99000000f,0.13000000f,-0.75000000f,-0.99000000f,-0.37000000f,0.52000000f,-0.20000000f,-0.56000000f,-0.38000000f,0.80000000f,-0.45000000f,0.13000000f,0.71000000f,-0.60000000f,-0.46000000f,-0.90000000f,0.83000000f,-0.01000000f,-0.47000000f,0.08000000f,-0.52000000f,-0.27000000f,-0.83000000f,-0.06000000f,-0.26000000f,-0.43000000f,0.02000000f,0.71000000f,0.26000000f,-0.39000000f,-0.20000000f,-0.12000000f,0.95000000f,0.15000000f,0.71000000f,-0.82000000f,-0.91000000f,-0.98000000f,0.99000000f,0.60000000f,-0.20000000f,-0.89000000f,-0.33000000f,-0.22000000f,0.25000000f,0.04000000f,0.74000000f,-0.92000000f,-0.19000000f,-0.23000000f,0.84000000f,0.34000000f,0.83000000f,0.41000000f,0.77000000f,0.24000000f,0.32000000f,-0.31000000f,-0.36000000f,-0.08000000f,0.58000000f,-0.45000000f,0.63000000f,-0.28000000f,0.15000000f,-0.19000000f,0.58000000f,0.67000000f,-0.21000000f,-0.79000000f,0.23000000f,-0.33000000f,-0.05000000f,-0.60000000f,-0.09000000f,-0.98000000f,0.73000000f,-0.36000000f,0.18000000f,0.70000000f,0.86000000f,-0.18000000f,-0.36000000f,0.06000000f,-0.30000000f,-0.48000000f,-0.08000000f,0.70000000f,0.57000000f,0.00000000f,0.95000000f,0.69000000f,-0.70000000f,-0.98000000f,-0.30000000f,-0.78000000f,-0.63000000f,-0.91000000f,0.83000000f,0.72000000f,0.45000000f,-0.50000000f,-0.30000000f,-0.41000000f,-0.17000000f,-0.39000000f,-0.65000000f,-0.97000000f,0.25000000f,-0.03000000f,-0.38000000f,-0.24000000f,0.42000000f,0.27000000f,-0.18000000f,0.50000000f,-0.04000000f,-0.33000000f,-0.54000000f,0.69000000f,-0.97000000f,0.45000000f,0.03000000f,0.78000000f,0.83000000f,-0.91000000f,-0.37000000f,-0.55000000f,-0.28000000f,-0.15000000f,-0.19000000f,0.38000000f,0.11000000f,-0.39000000f,-0.63000000f,0.84000000f,-0.19000000f,0.61000000f,-0.36000000f,0.34000000f,-0.54000000f,-0.68000000f,-0.68000000f,0.47000000f,-0.08000000f,0.79000000f,0.21000000f,-0.50000000f,-0.18000000f,-0.40000000f,0.80000000f,0.00000000f,-0.40000000f,-0.90000000f,-0.52000000f,-0.21000000f,-0.10000000f,0.99000000f,0.97000000f,-0.71000000f,-0.98000000f,-0.80000000f,0.20000000f,0.73000000f,0.95000000f,-0.47000000f,0.52000000f,0.98000000f,0.01000000f,0.16000000f,-0.50000000f,0.43000000f,0.51000000f,0.81000000f,0.69000000f,-0.34000000f,-0.49000000f,-0.92000000f,0.68000000f,0.79000000f,-0.56000000f,-0.46000000f,0.69000000f,0.51000000f,-0.45000000f,-0.30000000f,0.95000000f,-0.46000000f,-0.88000000f,-0.92000000f,-0.69000000f,0.91000000f,-0.62000000f,-0.58000000f,0.70000000f,0.51000000f,-0.70000000f,-0.87000000f,-0.01000000f,-0.64000000f,-0.22000000f,-0.81000000f,-0.65000000f,-0.55000000f,-0.06000000f,0.84000000f,0.54000000f,0.29000000f,-0.85000000f,-0.99000000f,0.87000000f,0.98000000f,0.61000000f,0.64000000f,0.25000000f,0.87000000f,0.89000000f,0.48000000f,-0.25000000f,-0.78000000f,-0.77000000f,0.49000000f,0.53000000f,-0.06000000f,-0.93000000f,0.21000000f,0.92000000f,-0.51000000f,0.55000000f,0.83000000f,0.14000000f,0.17000000f,0.42000000f,-0.09000000f,0.52000000f,0.95000000f,0.46000000f,0.81000000f,-0.75000000f,0.88000000f,0.99000000f,-0.53000000f,-0.93000000f,-0.46000000f,-0.67000000f,0.61000000f,-0.02000000f,-0.57000000f,-0.58000000f,0.09000000f,0.29000000f,0.27000000f,0.73000000f,0.90000000f,-0.72000000f,-0.68000000f,-0.00000000f,0.64000000f,0.24000000f,0.18000000f,0.73000000f,0.03000000f,-0.06000000f,-0.84000000f,-0.07000000f,-0.25000000f,-0.61000000f,0.71000000f,-0.10000000f,-0.27000000f,-0.83000000f,0.24000000f,-0.11000000f,-0.97000000f,-0.99000000f,0.13000000f,-0.84000000f,-0.51000000f,0.85000000f,-0.11000000f,-0.67000000f,0.45000000f,0.95000000f,0.76000000f,-0.63000000f,0.95000000f,-0.68000000f,-0.15000000f,0.77000000f,-0.44000000f,0.10000000f,0.11000000f,0.76000000f,0.56000000f,0.48000000f,0.35000000f,-0.11000000f,-0.16000000f,-0.00000000f,0.63000000f,-0.01000000f,0.51000000f,0.13000000f,-0.28000000f,-0.01000000f,0.58000000f,0.89000000f,-0.69000000f,0.43000000f,-0.90000000f,0.28000000f,0.86000000f,0.93000000f,0.22000000f,-0.16000000f,0.47000000f,0.33000000f,-0.56000000f,0.12000000f,-0.26000000f,-0.72000000f,-0.51000000f,0.24000000f,-0.19000000f,-0.88000000f,-0.70000000f,0.45000000f,-0.93000000f,-0.61000000f,-0.76000000f,-0.49000000f,0.27000000f,-0.11000000f,-0.06000000f,0.10000000f,0.04000000f,0.62000000f,0.51000000f,-0.27000000f,-0.19000000f,0.90000000f,-0.39000000f,0.18000000f,-0.10000000f,0.84000000f,0.53000000f,-0.71000000f,0.17000000f,0.29000000f,0.72000000f,-0.80000000f,0.27000000f,0.57000000f,-0.53000000f,-0.95000000f,0.88000000f,0.84000000f,0.09000000f,0.11000000f,-0.13000000f,-0.64000000f,-0.36000000f,-0.48000000f,0.82000000f,0.08000000f,-0.35000000f,0.03000000f,0.76000000f,0.14000000f,0.79000000f,-0.94000000f,-0.35000000f,0.89000000f,-0.25000000f,-0.48000000f,0.37000000f,0.82000000f,-0.30000000f,0.57000000f,0.94000000f,0.47000000f,0.17000000f,-0.39000000f,-0.62000000f,0.65000000f,0.37000000f,0.41000000f,-0.85000000f,0.74000000f,-0.59000000f,0.44000000f,-0.63000000f,0.45000000f,0.90000000f,0.99000000f,-0.73000000f,-0.03000000f,0.00000000f,0.49000000f,-0.29000000f,-0.63000000f,0.59000000f,0.24000000f,0.66000000f,-0.05000000f,0.06000000f,-0.95000000f,0.06000000f,0.62000000f,-0.83000000f,-0.46000000f,-0.25000000f,-0.35000000f,-0.91000000f,0.07000000f,-0.77000000f,0.54000000f,-0.82000000f,0.82000000f,0.68000000f,0.49000000f,-0.63000000f,-0.36000000f,-0.31000000f,-0.48000000f,-0.95000000f,-0.55000000f,-0.62000000f,0.52000000f,0.26000000f,-0.39000000f,0.45000000f,-0.09000000f,-0.07000000f,0.56000000f,0.32000000f,0.37000000f,0.57000000f,-0.83000000f,-0.90000000f,0.03000000f,0.47000000f,0.97000000f,0.26000000f,0.37000000f,-0.24000000f,0.72000000f,0.38000000f,-0.73000000f,0.86000000f,0.88000000f,-0.59000000f,0.17000000f,-0.80000000f,-0.86000000f,0.64000000f,0.83000000f,-0.15000000f,-0.31000000f,-0.87000000f,0.92000000f,-0.24000000f,0.45000000f,0.42000000f,-0.61000000f,-0.37000000f,0.02000000f,0.82000000f,0.84000000f,0.06000000f,0.67000000f,-0.12000000f,0.11000000f,0.94000000f,-0.81000000f,0.75000000f,-0.04000000f,0.72000000f,-0.50000000f,0.30000000f,0.90000000f,0.93000000f,-0.05000000f,-0.10000000f,-0.02000000f,0.51000000f,0.03000000f,-0.67000000f,0.18000000f,0.37000000f,0.65000000f,-0.20000000f,-0.45000000f,0.52000000f,0.46000000f,0.95000000f,-0.78000000f,0.20000000f,0.54000000f,0.92000000f,-0.64000000f,0.51000000f,0.63000000f,-0.58000000f,-0.50000000f,-0.40000000f,0.82000000f,0.15000000f,0.15000000f,0.21000000f,0.01000000f,0.89000000f,0.10000000f,-0.05000000f,-0.92000000f,-0.18000000f,0.30000000f,0.00000000f,-0.12000000f,0.71000000f,-0.58000000f,0.15000000f,0.17000000f,-0.31000000f,-0.36000000f,0.95000000f,-0.21000000f,-0.82000000f,-0.31000000f,-0.78000000f,-0.17000000f,0.47000000f,-0.41000000f,0.90000000f,0.75000000f,0.28000000f,0.57000000f,0.16000000f,-0.73000000f,0.66000000f,-0.27000000f,0.76000000f,-0.74000000f,0.35000000f,-0.21000000f,0.39000000f,-0.70000000f,-0.31000000f,-0.14000000f,-0.85000000f,0.80000000f,0.58000000f,-0.43000000f,0.02000000f,0.01000000f,0.31000000f,-0.89000000f,-0.06000000f,0.04000000f,0.28000000f,-0.00000000f,0.74000000f,0.32000000f,0.66000000f,-0.98000000f,-0.53000000f,-0.40000000f,-0.94000000f,0.35000000f,0.53000000f,-0.57000000f,0.60000000f,0.86000000f,-0.94000000f,-0.67000000f,0.95000000f,-0.35000000f,-0.79000000f,0.56000000f,0.10000000f,-0.28000000f,-0.53000000f,-0.27000000f,0.25000000f,0.83000000f,0.77000000f,0.18000000f,-0.33000000f,0.49000000f,-0.64000000f,0.57000000f,0.80000000f,0.98000000f,0.56000000f,0.03000000f,0.58000000f,0.76000000f,0.87000000f,0.61000000f,0.91000000f,-0.30000000f,-0.60000000f,-0.76000000f,-0.30000000f,0.23000000f,0.06000000f,0.03000000f,0.72000000f,0.11000000f,-0.23000000f,-0.21000000f,-0.20000000f,-0.44000000f,0.78000000f,0.15000000f,0.87000000f,-0.31000000f,0.43000000f,-0.05000000f,-0.16000000f,0.04000000f,-0.79000000f,0.87000000f,0.09000000f,0.32000000f,-0.58000000f,0.65000000f,-0.62000000f,0.23000000f,0.20000000f,-0.29000000f,0.88000000f,-0.58000000f,-0.03000000f,-0.33000000f,-0.48000000f,0.27000000f,0.47000000f,0.81000000f,0.91000000f,-0.41000000f,0.67000000f,-0.94000000f,0.31000000f,0.25000000f,-0.00000000f,0.99000000f,-0.06000000f,0.22000000f,-0.19000000f,0.53000000f,-0.62000000f,-0.63000000f,0.28000000f,-0.49000000f,0.37000000f,-0.69000000f,0.59000000f,-0.30000000f,0.57000000f,0.52000000f,0.55000000f,-0.67000000f,-0.15000000f,0.71000000f,0.11000000f,-0.34000000f,-0.06000000f,0.10000000f,0.70000000f,0.98000000f,0.52000000f,0.16000000f,0.87000000f,-0.62000000f,-0.58000000f,0.57000000f,0.65000000f,-0.35000000f,-0.31000000f,0.96000000f,0.21000000f,0.31000000f,-0.82000000f,0.14000000f,0.57000000f,0.24000000f,-0.26000000f,0.77000000f,-0.09000000f,0.20000000f,0.40000000f,0.12000000f,-0.17000000f,0.65000000f,0.64000000f,-0.63000000f,-0.75000000f,0.50000000f,0.31000000f,-0.06000000f,-0.19000000f,-0.63000000f,0.69000000f,-0.54000000f,0.27000000f,0.95000000f,-0.44000000f,0.18000000f,-0.91000000f,-0.02000000f,0.77000000f,-0.66000000f,-0.33000000f,-0.20000000f,-0.22000000f,0.65000000f,0.31000000f,-0.00000000f,-0.26000000f,0.07000000f,0.05000000f,-0.47000000f,-0.52000000f,-0.06000000f,0.49000000f,0.65000000f,0.54000000f,0.10000000f,-0.10000000f,-0.56000000f,-0.87000000f,0.35000000f,-0.51000000f,0.90000000f,-0.04000000f,-0.90000000f,-0.16000000f,-0.75000000f,-0.06000000f,-0.04000000f,-0.11000000f,0.44000000f,0.73000000f,0.72000000f,0.80000000f,0.73000000f,-0.95000000f,0.83000000f,0.72000000f,0.46000000f,-0.94000000f,-0.56000000f,0.00000000f,-0.41000000f,-0.66000000f,0.56000000f,0.92000000f,-0.23000000f,-0.32000000f,-0.16000000f,-0.04000000f,-0.37000000f,-0.81000000f,-0.29000000f,-0.79000000f,-0.45000000f,-0.37000000f,0.65000000f,-0.07000000f,-0.97000000f,-0.93000000f,0.15000000f,0.01000000f,-0.90000000f,0.05000000f,-0.63000000f,0.43000000f,-0.67000000f,0.04000000f,0.86000000f,-0.64000000f,0.80000000f,0.66000000f,-0.02000000f,0.84000000f,-0.46000000f,0.19000000f,-0.42000000f,-0.20000000f,0.86000000f,0.12000000f,0.32000000f,-0.72000000f,-0.40000000f,-0.32000000f,-0.26000000f,0.85000000f,-0.40000000f,0.15000000f,-0.69000000f,-0.77000000f,-0.48000000f,-0.10000000f,-0.16000000f,0.61000000f,-0.12000000f,-0.76000000f,0.21000000f,-0.15000000f,-0.15000000f,0.00000000f,-0.31000000f,0.74000000f,-0.12000000f,0.75000000f,-0.31000000f,0.89000000f,0.75000000f,-0.17000000f,-0.58000000f,-0.33000000f,-0.72000000f,-0.43000000f,-0.36000000f,-0.74000000f,-0.17000000f,-0.61000000f,-0.53000000f,0.62000000f,-0.24000000f,-0.37000000f,-0.16000000f,-0.74000000f,0.39000000f,-0.41000000f,0.57000000f,-0.64000000f,-0.51000000f,0.65000000f,0.40000000f,0.65000000f,-0.04000000f,-0.08000000f,0.30000000f,-0.86000000f,0.37000000f,-0.49000000f,0.24000000f,0.36000000f,-0.66000000f,0.53000000f,-0.42000000f,0.47000000f,-0.10000000f,-0.41000000f,-0.92000000f,-0.88000000f,0.90000000f,0.59000000f,0.00000000f,0.70000000f,-0.55000000f,0.45000000f,0.81000000f,0.42000000f,-0.81000000f,-0.90000000f,-0.66000000f,0.47000000f,-0.49000000f,-0.21000000f,-0.71000000f,-0.62000000f,0.20000000f,-0.90000000f,-0.49000000f,-0.83000000f,-0.94000000f,0.16000000f,0.04000000f,0.84000000f,-0.49000000f,-0.23000000f,-0.75000000f,-0.13000000f,0.91000000f,0.36000000f,-0.51000000f,0.56000000f,-0.26000000f,-0.34000000f,-0.27000000f,0.13000000f,0.45000000f,-0.89000000f,0.69000000f,-0.42000000f,0.49000000f,-0.93000000f,0.46000000f,0.68000000f,0.63000000f,-0.86000000f,-0.26000000f,0.14000000f,-0.29000000f,0.80000000f,-0.74000000f,0.73000000f,0.19000000f,-0.26000000f,0.01000000f,-0.71000000f,-0.54000000f,-0.64000000f,-0.59000000f,-0.37000000f,0.76000000f,0.15000000f,0.90000000f,-0.28000000f,0.59000000f,0.16000000f,-0.55000000f,0.48000000f,-0.49000000f,-0.43000000f,0.56000000f,-0.30000000f,0.12000000f,0.08000000f,-0.28000000f,0.78000000f,0.73000000f,-0.06000000f,0.13000000f,0.31000000f,-0.30000000f,0.90000000f,0.39000000f,-0.77000000f,-0.89000000f,0.91000000f,-0.09000000f,0.76000000f,0.30000000f,-0.80000000f,0.31000000f,-0.94000000f,0.88000000f,-0.38000000f,-0.10000000f,0.02000000f,-0.93000000f,-0.27000000f,0.83000000f,-0.33000000f,-0.55000000f,0.04000000f,-0.31000000f,-0.21000000f,-0.38000000f,-0.04000000f,-0.21000000f,-0.58000000f,0.57000000f,-0.50000000f,0.45000000f,-0.88000000f,-0.95000000f,0.66000000f,-0.15000000f,-0.65000000f,0.04000000f,-0.91000000f,-0.02000000f,-0.40000000f,0.60000000f,0.17000000f,0.07000000f,-0.11000000f,-0.55000000f,0.36000000f,0.47000000f,0.09000000f,0.37000000f,0.75000000f,-0.98000000f,-0.39000000f,0.79000000f,0.61000000f,-0.75000000f,0.51000000f,-0.49000000f,-0.99000000f,-0.72000000f,-0.56000000f,0.97000000f,-0.42000000f,0.06000000f,-0.14000000f,-0.96000000f,-0.28000000f,-0.48000000f,0.99000000f,0.64000000f,-0.12000000f,0.63000000f,-0.95000000f,-0.09000000f,-0.81000000f,0.83000000f,0.99000000f,-0.01000000f,0.17000000f,0.03000000f,-0.52000000f,0.20000000f,0.77000000f,-0.42000000f,0.96000000f,0.79000000f,-0.64000000f,-0.29000000f,-0.84000000f,-0.79000000f,0.83000000f,-0.88000000f,-0.24000000f,0.22000000f,0.55000000f,0.16000000f,-0.85000000f,0.49000000f,0.61000000f,-0.79000000f,-0.75000000f,0.27000000f,0.36000000f,0.36000000f,-0.98000000f,-0.34000000f,0.13000000f,0.38000000f,-0.25000000f,0.74000000f,0.08000000f,0.46000000f,0.13000000f,0.32000000f,0.78000000f,0.44000000f,0.11000000f,-0.57000000f,-0.34000000f,-0.92000000f,-0.03000000f,-0.74000000f,-0.06000000f,0.30000000f,-0.51000000f,0.06000000f,0.74000000f,0.13000000f,0.34000000f,0.05000000f,0.81000000f,0.43000000f,0.80000000f,-0.77000000f,-0.54000000f,0.59000000f,-0.05000000f,0.14000000f,0.29000000f,-0.70000000f,-0.12000000f,0.03000000f,-0.04000000f,-0.07000000f,-0.84000000f,0.86000000f,0.87000000f,-0.24000000f,0.02000000f,0.71000000f,0.31000000f,-0.62000000f,0.62000000f,-0.65000000f,0.26000000f,0.47000000f,0.57000000f,0.84000000f,0.32000000f,0.54000000f,-0.50000000f,0.93000000f,-0.91000000f,0.35000000f,-0.74000000f,-0.56000000f,-0.46000000f,-0.78000000f,-0.60000000f,-0.89000000f,-0.88000000f,-0.16000000f,-0.83000000f,-0.63000000f,0.59000000f,0.85000000f,0.32000000f,0.74000000f,0.84000000f,-0.83000000f,-0.46000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.95000000f,0.99000000f,-0.87000000f,-0.28000000f,0.66000000f,-0.58000000f,0.20000000f,-0.17000000f,-0.95000000f,0.23000000f,0.86000000f,-0.81000000f,0.93000000f,0.38000000f,0.49000000f,0.68000000f,-0.91000000f,-0.58000000f,-0.41000000f,0.31000000f,0.23000000f,0.92000000f,0.71000000f,0.33000000f,0.18000000f,-0.33000000f,0.64000000f,0.75000000f,-0.72000000f,0.70000000f,-0.49000000f,-0.49000000f,-0.18000000f,-0.59000000f,-0.23000000f,0.71000000f,0.42000000f,-0.53000000f,-0.83000000f,-0.04000000f,-0.75000000f,-0.77000000f,-0.59000000f,0.53000000f,-0.30000000f,0.22000000f,-0.78000000f,0.64000000f,-0.64000000f,-0.37000000f,0.79000000f,0.72000000f,-0.06000000f,0.94000000f,0.93000000f,-0.75000000f,0.90000000f,-0.79000000f,0.96000000f,0.28000000f,-0.74000000f,0.70000000f,-0.81000000f,0.18000000f,-0.96000000f,0.84000000f,-0.18000000f,0.05000000f,-0.23000000f,0.26000000f,-0.85000000f,-0.12000000f,0.50000000f,0.12000000f,-0.94000000f,0.64000000f,0.86000000f,0.81000000f,0.89000000f,-0.62000000f,0.74000000f,-0.19000000f,-0.78000000f,0.67000000f,-0.04000000f,0.36000000f,0.62000000f,-0.02000000f,-0.49000000f,0.72000000f,-0.02000000f,0.42000000f,-0.78000000f,0.79000000f,0.26000000f,-0.63000000f,-0.31000000f,-0.38000000f,-0.37000000f,-0.43000000f,-0.97000000f,0.27000000f,-0.34000000f,-0.59000000f,-0.07000000f,0.44000000f,-0.62000000f,-0.64000000f,-0.09000000f,-0.70000000f,-0.11000000f,-0.89000000f,-0.35000000f,0.49000000f,-0.73000000f,-0.89000000f,0.76000000f,0.90000000f,0.04000000f,0.44000000f,0.58000000f,0.18000000f,-0.06000000f,0.68000000f,0.14000000f,-0.48000000f,-0.15000000f,-0.53000000f,-0.31000000f,0.37000000f,0.71000000f,-0.10000000f,-0.83000000f,-0.88000000f,-0.26000000f,-0.88000000f,0.82000000f,-0.04000000f,0.84000000f,-0.92000000f,-0.10000000f,0.00000000f,0.18000000f,0.21000000f,0.74000000f,-0.25000000f,0.88000000f,-0.75000000f,-0.47000000f,0.72000000f,-0.54000000f,0.04000000f,0.10000000f,0.29000000f,0.20000000f,0.08000000f,-0.17000000f,0.71000000f,-0.46000000f,0.96000000f,-0.21000000f,0.10000000f,0.58000000f,0.65000000f,0.06000000f,0.58000000f,0.68000000f,0.27000000f,-0.07000000f,-0.05000000f,0.97000000f,0.25000000f,-0.42000000f,-0.59000000f,0.42000000f,0.87000000f,-0.06000000f,-0.61000000f,0.06000000f,0.84000000f,0.58000000f,-0.68000000f,0.65000000f,0.40000000f,-0.32000000f,-0.38000000f,0.93000000f,0.58000000f,-0.65000000f,0.73000000f,0.96000000f,-0.97000000f,0.08000000f,0.80000000f,0.39000000f,-0.21000000f,-0.47000000f,0.56000000f,-0.17000000f,-0.46000000f,-0.52000000f,-0.27000000f,0.76000000f,0.60000000f,-0.41000000f,-0.73000000f,0.93000000f,-0.06000000f,0.30000000f,-0.64000000f,-0.02000000f,-0.23000000f,0.08000000f,0.72000000f,-0.58000000f,-0.29000000f,-0.49000000f,0.85000000f,-0.42000000f,0.40000000f,-0.37000000f,-0.74000000f,0.51000000f,-0.52000000f,-0.52000000f,-0.63000000f,-0.66000000f,0.81000000f,-0.39000000f,0.33000000f,-0.46000000f,-0.76000000f,-0.06000000f,0.45000000f,-0.05000000f,-0.64000000f,0.42000000f,0.76000000f,-0.55000000f,-0.98000000f,0.78000000f,-0.82000000f,-0.25000000f,0.24000000f,0.35000000f,0.68000000f,-0.68000000f,0.28000000f,0.60000000f,-0.50000000f,0.20000000f,0.15000000f,-0.92000000f,0.09000000f,-0.99000000f,0.49000000f,0.24000000f,0.69000000f,-0.50000000f,0.47000000f,0.94000000f,-0.30000000f,0.96000000f,-0.45000000f,-0.57000000f,0.25000000f,0.77000000f,0.82000000f,-0.88000000f,-0.33000000f,-0.32000000f,-0.65000000f,-0.85000000f,0.83000000f,0.06000000f,0.71000000f,0.53000000f,-0.42000000f,0.25000000f,-0.50000000f,-0.02000000f,0.76000000f,-0.13000000f,0.39000000f,-0.99000000f,-0.20000000f,0.20000000f,-0.80000000f,-0.59000000f,-0.59000000f,0.13000000f,0.57000000f,0.55000000f,0.44000000f,-0.11000000f,0.30000000f,-0.16000000f,0.78000000f,-0.91000000f,0.02000000f,0.68000000f,0.59000000f,-0.28000000f,-0.79000000f,0.48000000f,-0.17000000f,-0.86000000f,-0.68000000f,0.96000000f,-0.61000000f,-0.69000000f,0.95000000f,0.81000000f,-0.89000000f,0.02000000f,0.97000000f,-0.13000000f,-0.10000000f,0.07000000f,0.67000000f,0.30000000f,-0.26000000f,-0.07000000f,-0.55000000f,-0.58000000f,-0.81000000f,0.06000000f,0.65000000f,0.97000000f,-0.29000000f,0.85000000f,-0.49000000f,-0.01000000f,-0.90000000f,0.23000000f,-0.39000000f,-0.71000000f,0.28000000f,0.38000000f,-0.26000000f,0.19000000f,-0.94000000f,0.38000000f,-0.80000000f,0.15000000f,-0.59000000f,0.18000000f,0.87000000f,-0.54000000f,-0.65000000f,0.47000000f,0.74000000f,0.43000000f,0.30000000f,0.99000000f,-0.66000000f,0.89000000f,-0.72000000f,0.25000000f,0.73000000f,-0.26000000f,-0.60000000f,0.10000000f,0.55000000f,-0.86000000f,-0.96000000f,-0.54000000f,-0.81000000f,0.84000000f,0.67000000f,0.34000000f,0.98000000f,-0.50000000f,-0.64000000f,-0.40000000f,-0.61000000f,-0.72000000f,-0.68000000f,0.80000000f,-0.15000000f,-0.99000000f,-0.79000000f,0.71000000f,-0.66000000f,-0.11000000f,0.06000000f,0.24000000f,-0.58000000f,0.60000000f,-0.21000000f,0.24000000f,-0.75000000f,-0.12000000f,-0.91000000f,-0.67000000f,-0.19000000f,-0.47000000f,-0.87000000f,0.40000000f,0.42000000f,0.69000000f,-0.61000000f,-0.98000000f,-0.63000000f,0.97000000f,0.05000000f,-0.19000000f,-0.47000000f,0.41000000f,-0.45000000f,0.94000000f,0.85000000f,-0.10000000f,0.09000000f,0.00000000f,0.20000000f,0.49000000f,-0.81000000f,0.31000000f,0.94000000f,-0.41000000f,-0.71000000f,0.99000000f,0.82000000f,-0.34000000f,-0.08000000f,0.85000000f,0.61000000f,-0.93000000f,-0.54000000f,0.37000000f,-0.90000000f,-0.67000000f,-0.02000000f,-0.43000000f,-0.52000000f,-0.58000000f,-0.61000000f,0.81000000f,0.53000000f,0.86000000f,-0.09000000f,0.26000000f,0.23000000f,-0.76000000f,-0.58000000f,-0.90000000f,0.33000000f,0.82000000f,-0.44000000f,0.18000000f,-0.18000000f,0.72000000f,0.74000000f,-0.84000000f,0.83000000f,-0.26000000f,-0.32000000f,-0.99000000f,-0.07000000f,0.57000000f,0.71000000f,-0.64000000f,0.56000000f,-0.08000000f,-0.78000000f,0.83000000f,-0.60000000f,-0.54000000f,-0.65000000f,0.26000000f,0.67000000f,0.10000000f,0.72000000f,-0.12000000f,0.71000000f,0.90000000f,-0.37000000f,-0.55000000f,-0.42000000f,-0.89000000f,0.87000000f,0.70000000f,0.47000000f,0.07000000f,0.46000000f,0.48000000f,0.53000000f,-0.95000000f,0.82000000f,0.35000000f,0.48000000f,0.99000000f,-0.64000000f,0.45000000f,-0.33000000f,0.94000000f,0.93000000f,0.55000000f,0.95000000f,0.23000000f,0.71000000f,0.42000000f,0.48000000f,-0.45000000f,0.54000000f,0.38000000f,0.58000000f,0.94000000f,0.82000000f,0.65000000f,-0.51000000f,0.53000000f,-0.47000000f,-0.78000000f,-0.51000000f,0.67000000f,0.72000000f,-0.20000000f,0.09000000f,0.41000000f,0.69000000f,0.21000000f,0.95000000f,-0.26000000f,0.23000000f,-0.04000000f,-0.30000000f,-0.18000000f,-0.78000000f,0.06000000f,0.04000000f,0.83000000f,-0.97000000f,-0.55000000f,-0.86000000f,-0.99000000f,-0.12000000f,0.17000000f,-0.50000000f,-0.77000000f,-0.20000000f,-0.47000000f,-0.95000000f,0.05000000f,-0.37000000f,0.88000000f,0.09000000f,-0.54000000f,-0.64000000f,-0.72000000f,0.57000000f,0.16000000f,-0.31000000f,-0.28000000f,-0.36000000f,0.71000000f,-0.82000000f,0.23000000f,0.88000000f,0.69000000f,0.99000000f,-0.99000000f,0.94000000f,0.24000000f,-0.45000000f,0.61000000f,0.85000000f,-0.92000000f,0.96000000f,0.98000000f,0.34000000f,0.03000000f,-0.25000000f,0.15000000f,-0.71000000f,0.48000000f,-0.02000000f,-0.29000000f,0.34000000f,0.48000000f,-0.14000000f,-0.46000000f,-0.32000000f,0.67000000f,0.04000000f,-0.90000000f,-0.82000000f,0.44000000f,-0.46000000f,-0.33000000f,0.63000000f,-0.46000000f,0.16000000f,0.02000000f,0.57000000f,-0.02000000f,0.50000000f,0.26000000f,0.51000000f,-0.15000000f,0.25000000f,0.07000000f,-0.59000000f,-0.87000000f,0.64000000f,-0.92000000f,0.05000000f,0.79000000f,0.14000000f,-0.34000000f,-0.77000000f,0.72000000f,0.53000000f,-0.42000000f,0.95000000f,-0.86000000f,-0.35000000f,0.90000000f,0.36000000f,0.25000000f,0.63000000f,0.59000000f,-0.32000000f,-0.95000000f,-0.98000000f,-0.84000000f,-0.56000000f,0.65000000f,-0.81000000f,-0.06000000f,-0.45000000f,-0.60000000f,-0.84000000f,0.09000000f,0.77000000f,0.17000000f,0.11000000f,-0.57000000f,-0.67000000f,-0.23000000f,-0.98000000f,0.12000000f,0.32000000f,0.35000000f,0.37000000f,-0.81000000f,-0.07000000f,-0.21000000f,0.72000000f,-0.35000000f,-0.02000000f,0.33000000f,0.58000000f,-0.52000000f,0.17000000f,-0.49000000f,0.30000000f,-0.30000000f,-0.78000000f,-0.38000000f,0.25000000f,0.14000000f,-0.20000000f,0.75000000f,-0.51000000f,0.46000000f,0.15000000f,-0.07000000f,0.19000000f,-0.47000000f,0.70000000f,-0.47000000f,-0.03000000f,0.14000000f,-0.25000000f,0.67000000f,0.83000000f,0.22000000f,-0.80000000f,0.15000000f,0.88000000f,0.42000000f,0.76000000f,-0.53000000f,0.85000000f,0.89000000f,0.92000000f,-0.73000000f,-0.88000000f,0.05000000f,0.09000000f,0.19000000f,0.55000000f,0.74000000f,-0.08000000f,0.41000000f,0.06000000f,-0.35000000f,0.66000000f,0.05000000f,0.36000000f,0.28000000f,0.77000000f,0.65000000f,0.94000000f,-0.28000000f,-0.31000000f,0.47000000f,-0.62000000f,-0.99000000f,0.90000000f,0.70000000f,0.88000000f,-0.68000000f,0.69000000f,-0.23000000f,-0.01000000f,0.97000000f,0.87000000f,0.55000000f,0.07000000f,0.59000000f,-0.16000000f,-0.05000000f,0.28000000f,-0.48000000f,0.56000000f,-0.64000000f,0.22000000f,0.55000000f,-0.66000000f,0.29000000f,0.12000000f,0.73000000f,-0.98000000f,-0.13000000f,-0.39000000f,0.33000000f,0.95000000f,0.38000000f,-0.34000000f,0.73000000f,0.25000000f,0.63000000f,0.13000000f,-0.18000000f,-0.23000000f,-0.68000000f,0.39000000f,0.65000000f,-0.08000000f,-0.96000000f,0.35000000f,-0.06000000f,0.81000000f,-0.34000000f,-0.91000000f,0.96000000f,-0.75000000f,0.61000000f,0.81000000f,-0.21000000f,0.21000000f,-0.89000000f,-0.13000000f,-0.92000000f,-0.11000000f,-0.25000000f,0.28000000f,0.31000000f,0.83000000f,0.96000000f,-0.13000000f,0.54000000f,0.95000000f,0.16000000f,0.49000000f,0.12000000f,0.13000000f,0.20000000f,0.37000000f,0.34000000f,0.87000000f,-0.11000000f,-0.28000000f,-0.05000000f,0.72000000f,-0.27000000f,0.44000000f,0.84000000f,-0.03000000f,0.69000000f,-0.79000000f,0.63000000f,0.81000000f,0.88000000f,0.98000000f,0.51000000f,-0.20000000f,0.54000000f,0.73000000f,-0.95000000f,-0.61000000f,0.33000000f,0.26000000f,0.51000000f,0.46000000f,0.43000000f,-0.04000000f,-0.29000000f,0.77000000f,0.34000000f,-0.43000000f,0.48000000f,0.42000000f,-0.14000000f,0.89000000f,-0.93000000f,-0.40000000f,0.77000000f,-0.04000000f,0.85000000f,0.98000000f,-0.26000000f,0.05000000f,-0.24000000f,-0.22000000f,-0.50000000f,-0.82000000f,-0.42000000f,0.63000000f,0.79000000f,-0.84000000f,-0.60000000f,0.20000000f,-0.41000000f,0.86000000f,0.51000000f,-0.17000000f,-0.20000000f,0.94000000f,-0.89000000f,-0.51000000f,-0.35000000f,0.73000000f,-0.53000000f,0.09000000f,0.49000000f,-0.72000000f,-0.47000000f,-0.72000000f,-0.58000000f,-0.28000000f,0.05000000f,-0.08000000f,-0.86000000f,-0.69000000f,-0.22000000f,-0.32000000f,0.17000000f,-0.58000000f,-0.49000000f,-0.62000000f,0.19000000f,-0.28000000f,-0.40000000f,-0.61000000f,0.75000000f,-0.87000000f,-0.96000000f,-0.47000000f,-0.04000000f,0.64000000f,0.80000000f,0.90000000f,-0.57000000f,0.40000000f,0.34000000f,-0.31000000f,-0.94000000f,0.79000000f,0.12000000f,0.55000000f,0.62000000f,0.44000000f,0.58000000f,-0.10000000f,-0.07000000f,0.35000000f,0.73000000f,0.42000000f,-0.05000000f,-0.16000000f,0.89000000f,-0.05000000f,-0.22000000f,-0.25000000f,-0.81000000f,-0.57000000f,0.78000000f,0.49000000f,0.06000000f,0.87000000f,0.61000000f,-0.01000000f,0.77000000f,0.63000000f,-0.15000000f,-0.17000000f,-0.42000000f,-0.59000000f,0.64000000f,0.85000000f,-0.70000000f,0.03000000f,-0.58000000f,0.25000000f,0.31000000f,0.72000000f,0.26000000f,-0.83000000f,-0.37000000f,-0.10000000f,-0.30000000f,-0.75000000f,-0.54000000f,0.13000000f,0.10000000f,0.75000000f,-0.66000000f,-0.73000000f,-0.41000000f,0.15000000f,0.51000000f,-0.72000000f,0.76000000f,0.98000000f,-0.41000000f,0.61000000f,-0.67000000f,-0.82000000f,-0.90000000f,0.57000000f,0.57000000f,0.82000000f,0.50000000f,0.74000000f,-0.06000000f,-0.19000000f,-0.49000000f,0.71000000f,0.82000000f,0.19000000f,-0.04000000f,0.55000000f,0.03000000f,0.59000000f,-0.65000000f,0.99000000f,0.74000000f,0.81000000f,-0.59000000f,-0.60000000f,0.73000000f,0.47000000f,0.73000000f,0.72000000f,-0.33000000f,0.29000000f,0.66000000f,0.72000000f,-0.21000000f,-0.90000000f,0.69000000f,0.40000000f,0.67000000f,0.07000000f,-0.39000000f,0.34000000f,0.94000000f,0.56000000f,0.61000000f,0.24000000f,-0.76000000f,0.53000000f,-0.15000000f,-0.70000000f,0.93000000f,0.42000000f,-0.12000000f,-0.50000000f,0.67000000f,-0.55000000f,0.73000000f,0.46000000f,-0.74000000f,0.90000000f,-0.68000000f,0.57000000f,-0.62000000f,-0.19000000f,-0.57000000f,0.37000000f,0.81000000f,-0.84000000f,0.73000000f,0.20000000f,-0.89000000f,-0.55000000f,0.01000000f,-0.12000000f,0.24000000f,-0.14000000f,-0.35000000f,0.99000000f,0.40000000f,0.11000000f,-0.83000000f,-0.25000000f,0.84000000f,0.89000000f,-0.51000000f,0.75000000f,0.44000000f,0.45000000f,-0.18000000f,-0.70000000f,0.83000000f,0.02000000f,-0.84000000f,0.46000000f,-0.83000000f,-0.02000000f,0.10000000f,0.44000000f,0.53000000f,-0.96000000f,0.70000000f,0.55000000f,0.37000000f,0.84000000f,-0.64000000f,-0.06000000f,0.94000000f,-0.58000000f,-0.83000000f,0.92000000f,0.11000000f,0.34000000f,-0.67000000f,-0.42000000f,-0.27000000f,-0.55000000f,-0.97000000f,-0.92000000f,-0.81000000f,-0.21000000f,-0.40000000f,0.73000000f,0.49000000f,0.60000000f,-0.56000000f,0.95000000f,-0.09000000f,-0.20000000f,-0.88000000f,-0.09000000f,-0.70000000f,-0.30000000f,-0.85000000f,-0.39000000f,0.94000000f,0.06000000f,0.06000000f,-0.09000000f,0.05000000f,0.61000000f,0.51000000f,0.60000000f,-0.78000000f,-0.89000000f,0.92000000f,-0.03000000f,-0.03000000f,0.41000000f,-0.10000000f,0.97000000f,0.67000000f,0.92000000f,0.70000000f,-0.22000000f,0.63000000f,0.77000000f,-0.46000000f,0.25000000f,0.17000000f,0.00000000f,-0.14000000f,-0.87000000f,0.49000000f,0.99000000f,0.42000000f,-0.67000000f,0.61000000f,0.34000000f,0.25000000f,-0.71000000f,-0.18000000f,0.24000000f,-0.27000000f,0.24000000f,-0.06000000f,-0.05000000f,-0.08000000f,0.70000000f,-0.19000000f,-0.29000000f,0.41000000f,0.78000000f,0.08000000f,-0.88000000f,0.39000000f,0.33000000f,-0.50000000f,0.00000000f,-0.35000000f,0.56000000f,-0.85000000f,0.06000000f,-0.02000000f,-0.91000000f,-0.58000000f,0.18000000f,0.66000000f,0.46000000f,0.96000000f,0.90000000f,0.74000000f,-0.17000000f,-0.80000000f,-0.38000000f,-0.01000000f,0.25000000f,-0.53000000f,0.21000000f,0.26000000f,-0.63000000f,-0.78000000f,0.32000000f,0.42000000f,-0.60000000f,-0.31000000f,-0.93000000f,0.36000000f,0.41000000f,0.47000000f,-0.41000000f,0.03000000f,0.37000000f,-0.93000000f,-0.75000000f,-0.10000000f,-0.44000000f,0.74000000f,0.96000000f,0.47000000f,0.69000000f,0.44000000f,0.07000000f,0.28000000f,-0.84000000f,-0.00000000f,-0.65000000f,0.23000000f,-0.17000000f,0.65000000f,-0.05000000f,-0.32000000f,-0.98000000f,0.67000000f,-0.45000000f,0.16000000f,0.26000000f,0.81000000f,0.81000000f,-0.72000000f,-0.23000000f,0.57000000f,-0.87000000f,0.76000000f,-0.57000000f,0.14000000f,-0.44000000f,0.31000000f,0.80000000f,-0.73000000f,0.83000000f,0.00000000f,-0.54000000f,0.10000000f,0.42000000f,0.54000000f,-0.18000000f,0.56000000f,0.35000000f,0.44000000f,-0.52000000f,0.69000000f,0.69000000f,0.94000000f,0.39000000f,0.96000000f,0.58000000f,-0.71000000f,0.98000000f,-0.92000000f,-0.11000000f,0.98000000f,0.90000000f,0.79000000f,0.63000000f,0.84000000f,-0.95000000f,0.61000000f,-0.52000000f,-0.10000000f,0.33000000f,0.10000000f,0.56000000f,0.74000000f,0.11000000f,-0.27000000f,-0.36000000f,0.88000000f,0.33000000f,-0.30000000f,0.67000000f,0.98000000f,0.19000000f,0.56000000f,0.85000000f,0.13000000f,-0.65000000f,-0.67000000f,0.86000000f,-0.03000000f,0.83000000f,-0.50000000f,-0.54000000f,-0.65000000f,-0.64000000f,-0.73000000f,-0.60000000f,0.68000000f,-0.71000000f,-0.36000000f,-0.81000000f,-0.27000000f,-0.06000000f,-0.04000000f,0.47000000f,-0.99000000f,-0.35000000f,-0.89000000f,0.55000000f,-0.39000000f,-0.94000000f,0.32000000f,-0.23000000f,-0.53000000f,0.37000000f,-0.17000000f,0.85000000f,0.27000000f,-0.10000000f,-0.81000000f,-0.31000000f,-0.22000000f,-0.30000000f,-0.29000000f,0.93000000f,0.08000000f,0.98000000f,0.32000000f,0.97000000f,0.86000000f,0.67000000f,0.39000000f,0.50000000f,0.06000000f,0.25000000f,-0.73000000f,-0.88000000f,-0.02000000f,0.88000000f,0.85000000f,0.38000000f,-0.29000000f,-0.99000000f,0.30000000f,-0.06000000f,0.14000000f,-0.02000000f,0.09000000f,-0.62000000f,0.41000000f,-0.46000000f,0.90000000f,0.06000000f,-0.78000000f,-0.10000000f,0.97000000f,0.66000000f,-0.96000000f,0.46000000f,0.12000000f,0.84000000f,0.89000000f,-0.28000000f,-0.65000000f,-0.71000000f,0.04000000f,0.34000000f,-0.98000000f,-0.27000000f,0.21000000f,0.13000000f,-0.56000000f,0.56000000f,0.71000000f,-0.55000000f,0.14000000f,0.81000000f,0.03000000f,-0.19000000f,0.82000000f,0.48000000f,-0.42000000f,0.73000000f,0.04000000f,0.48000000f,-0.10000000f,-0.78000000f,0.75000000f,-0.89000000f,-0.02000000f,0.60000000f,0.15000000f,-0.88000000f,0.01000000f,0.93000000f,-0.59000000f,0.43000000f,0.57000000f,0.14000000f,0.96000000f,0.75000000f,0.58000000f,0.69000000f,-0.92000000f,0.14000000f,0.94000000f,-0.42000000f,0.54000000f,-0.73000000f,0.91000000f,-0.89000000f,-0.95000000f,0.41000000f,0.26000000f,-0.46000000f,-0.64000000f,-0.65000000f,0.53000000f,-0.61000000f,-0.95000000f,-0.41000000f,-0.28000000f,-0.78000000f,-0.01000000f,-0.55000000f,0.69000000f,0.60000000f,-0.29000000f,0.81000000f,0.74000000f,0.39000000f,0.58000000f,-0.65000000f,0.37000000f,-0.88000000f,-0.11000000f,0.08000000f,-0.78000000f,0.01000000f,-0.46000000f,-0.12000000f,0.38000000f,-0.63000000f,0.66000000f,-0.33000000f,-0.51000000f,-0.16000000f,0.32000000f,0.40000000f,-0.03000000f,-0.35000000f,0.49000000f,-0.52000000f,-0.26000000f,-0.99000000f,-0.94000000f,0.18000000f,0.94000000f,0.37000000f,0.94000000f,0.85000000f,0.36000000f,-0.00000000f,0.36000000f,-0.94000000f,-0.47000000f,0.92000000f,0.75000000f,-0.29000000f,-0.82000000f,0.95000000f,0.29000000f,-0.47000000f,0.12000000f,-0.96000000f,0.06000000f,-0.56000000f,-0.20000000f,0.47000000f,0.15000000f,0.08000000f,-0.20000000f,-0.20000000f,-0.31000000f,0.44000000f,-0.83000000f,-0.03000000f,0.75000000f,-0.87000000f,0.90000000f,-0.39000000f,-0.06000000f,0.56000000f,0.03000000f,-0.03000000f,-0.37000000f,-0.08000000f,-0.25000000f,0.15000000f,-0.90000000f,0.29000000f,-0.94000000f,0.20000000f,0.71000000f,0.14000000f,-0.70000000f,0.98000000f,-0.77000000f,-0.97000000f,-0.43000000f,0.25000000f,-0.30000000f,0.28000000f,-0.04000000f,0.19000000f,0.40000000f,0.56000000f,-0.18000000f,-0.66000000f,0.66000000f,-0.21000000f,-0.48000000f,0.76000000f,0.87000000f,-0.63000000f,-0.12000000f,0.22000000f,-0.48000000f,-0.41000000f,-0.87000000f,-0.16000000f,-0.53000000f,0.25000000f,-0.31000000f,0.45000000f,-0.25000000f,0.46000000f,0.35000000f,0.64000000f,-0.45000000f,0.84000000f,-0.70000000f,0.19000000f,-0.96000000f,-0.68000000f,0.92000000f,-0.07000000f,0.10000000f,0.89000000f,0.25000000f,0.70000000f,0.52000000f,0.63000000f,-0.36000000f,0.11000000f,-0.39000000f,0.77000000f,0.59000000f,-0.01000000f,-0.60000000f,0.66000000f,-0.46000000f,0.64000000f,-0.21000000f,0.37000000f,-0.55000000f,0.27000000f,0.09000000f,-0.35000000f,0.07000000f,0.80000000f,-0.51000000f,-0.80000000f,-0.04000000f,0.59000000f,0.59000000f,-0.96000000f,-0.12000000f,-0.28000000f,0.71000000f,0.17000000f,-0.36000000f,0.35000000f,0.99000000f,-0.30000000f,-0.98000000f,0.52000000f,-0.62000000f,0.69000000f,-0.48000000f,0.34000000f,0.30000000f,-0.78000000f,-0.84000000f,0.46000000f,-0.36000000f,0.31000000f,-0.61000000f,-0.71000000f,0.46000000f,-0.97000000f,-0.97000000f,-0.18000000f,-0.42000000f,-0.22000000f,-0.42000000f,-0.08000000f,0.84000000f,-0.48000000f,-0.22000000f,-0.95000000f,-0.42000000f,-0.45000000f,0.17000000f,-0.58000000f,0.82000000f,-0.81000000f,0.23000000f,0.07000000f,-0.16000000f,0.93000000f,-0.82000000f,-0.78000000f,0.13000000f,-0.80000000f,-0.24000000f,-0.00000000f,0.75000000f,-0.59000000f,0.01000000f,0.71000000f,0.53000000f,0.02000000f,-0.97000000f,0.81000000f,-0.35000000f,0.15000000f,-0.32000000f,-0.11000000f,0.79000000f,-0.08000000f,0.82000000f,-0.99000000f,-0.68000000f,-0.48000000f,-0.08000000f,-0.03000000f,0.64000000f,0.48000000f,-0.69000000f,-0.82000000f,0.98000000f,0.86000000f,-0.32000000f,-0.86000000f,-0.08000000f,0.25000000f,-0.37000000f,-0.56000000f,0.04000000f,-0.53000000f,0.52000000f,0.89000000f,-0.26000000f,0.79000000f,0.97000000f,0.46000000f,0.07000000f,-0.99000000f,-0.91000000f,-0.03000000f,0.81000000f,0.06000000f,-0.56000000f,-0.68000000f,0.14000000f,-0.15000000f,0.33000000f,-0.26000000f,0.94000000f,0.76000000f,0.70000000f,0.70000000f,-0.88000000f,0.20000000f,0.02000000f,-0.32000000f,0.75000000f,0.34000000f,0.47000000f,0.63000000f,0.01000000f,-0.80000000f,0.31000000f,0.01000000f,-0.25000000f,0.20000000f,0.40000000f,-0.95000000f,0.52000000f,0.24000000f,-0.46000000f,0.61000000f,0.58000000f,-0.97000000f,-0.90000000f,-0.24000000f,0.18000000f,0.16000000f,0.56000000f,0.21000000f,-0.71000000f,-0.96000000f,-0.86000000f,0.04000000f,-0.11000000f,-0.09000000f,0.07000000f,-0.01000000f,-0.58000000f,-0.12000000f,-0.43000000f,-0.95000000f,0.45000000f,-0.87000000f,-0.07000000f,0.31000000f,0.02000000f,-0.22000000f,-0.62000000f,0.48000000f,0.19000000f,0.42000000f,-0.23000000f,0.70000000f,-0.56000000f,-0.19000000f,-0.54000000f,-0.15000000f,0.78000000f,-0.39000000f,-0.95000000f,0.36000000f,0.12000000f,-0.31000000f,0.93000000f,0.16000000f,0.92000000f,0.58000000f,-0.80000000f,0.76000000f,-0.16000000f,0.15000000f,0.93000000f,-0.18000000f,0.11000000f,0.97000000f,0.36000000f,-0.29000000f,0.56000000f,0.67000000f,-0.46000000f,-0.94000000f,0.64000000f,-0.87000000f,-0.72000000f,-0.86000000f,0.64000000f,0.34000000f,-0.00000000f,0.03000000f,-0.48000000f,-0.11000000f,0.09000000f,-0.89000000f,-0.85000000f,0.71000000f,-0.36000000f,-0.28000000f,0.04000000f,-0.88000000f,0.91000000f,0.19000000f,0.37000000f,-0.58000000f,0.29000000f,0.17000000f,0.33000000f,-0.62000000f,-0.32000000f,0.83000000f,0.00000000f,-0.95000000f,-0.03000000f,-0.80000000f,0.64000000f,0.10000000f,-0.11000000f,0.46000000f,0.54000000f,0.64000000f,-0.17000000f,-0.31000000f,-0.46000000f,0.85000000f,-0.42000000f,-0.27000000f,0.45000000f,0.06000000f,-0.11000000f,-0.20000000f,-0.30000000f,0.29000000f,0.73000000f,0.43000000f,-0.95000000f,0.46000000f,-0.04000000f,-0.51000000f,0.30000000f,0.82000000f,-0.93000000f,-0.86000000f,0.33000000f,-0.39000000f,-0.07000000f,-0.67000000f,-0.86000000f,-0.61000000f,0.48000000f,-0.35000000f,-0.57000000f,0.31000000f,0.05000000f,-0.72000000f,0.46000000f,-0.62000000f,-0.81000000f,-0.74000000f,0.59000000f,0.79000000f,0.77000000f,-0.31000000f,-0.38000000f,-0.85000000f,0.70000000f,0.39000000f,0.57000000f,0.52000000f,-0.08000000f,0.49000000f,-0.49000000f,-0.53000000f,0.61000000f,-0.21000000f,-0.04000000f,0.03000000f,0.54000000f,-0.49000000f,0.95000000f,-0.45000000f,-0.99000000f,-0.39000000f,0.19000000f,-0.74000000f,-0.43000000f,0.97000000f,-0.46000000f,-0.93000000f,-0.56000000f,0.17000000f,-0.74000000f,-0.87000000f,-0.20000000f,-0.87000000f,-0.60000000f,-0.66000000f,0.12000000f,-0.88000000f,-0.25000000f,-0.27000000f,0.36000000f,-0.22000000f,0.97000000f,-0.24000000f,0.35000000f,-0.30000000f,-0.10000000f,0.66000000f,-0.06000000f,-0.21000000f,-0.20000000f,0.87000000f,-0.13000000f,-0.25000000f,0.10000000f,-0.47000000f,-0.51000000f,0.55000000f,0.20000000f,0.14000000f,0.80000000f,-0.25000000f,0.81000000f,-0.19000000f,-0.04000000f,-0.05000000f,0.63000000f,-0.03000000f,-0.60000000f,0.39000000f,-0.25000000f,0.47000000f,-0.51000000f,-0.42000000f,-0.31000000f,-0.08000000f,0.76000000f,-0.64000000f,0.28000000f,-0.15000000f,0.89000000f,-0.39000000f,0.49000000f,-0.31000000f,0.39000000f,-0.48000000f,-0.24000000f,-0.97000000f,0.76000000f,-0.34000000f,-0.35000000f,-0.83000000f,-0.70000000f,-0.92000000f,0.37000000f,-0.05000000f,0.95000000f,0.49000000f,-0.04000000f,0.51000000f,-0.84000000f,0.56000000f,0.50000000f,0.85000000f,0.78000000f,-0.03000000f,-0.32000000f,0.31000000f,-0.13000000f,-0.38000000f,-0.34000000f,-0.15000000f,0.22000000f,-0.91000000f,0.97000000f,0.12000000f,0.71000000f,0.22000000f,0.98000000f,0.45000000f,-0.21000000f,-0.27000000f,0.31000000f,-0.47000000f,-0.90000000f,-0.90000000f,-0.83000000f,0.07000000f,0.20000000f,0.68000000f,-0.42000000f,-0.36000000f,-0.14000000f,0.29000000f,0.57000000f,0.76000000f,-0.18000000f,-0.89000000f,-0.30000000f,0.92000000f,-0.09000000f,-0.05000000f,0.96000000f,0.29000000f,0.07000000f,-0.65000000f,-0.78000000f,0.55000000f,0.17000000f,-0.39000000f,0.17000000f,0.62000000f,0.51000000f,0.00000000f,-0.61000000f,-0.52000000f,-0.57000000f,-0.99000000f,-0.65000000f,0.94000000f,-0.54000000f,-0.00000000f,0.99000000f,0.40000000f,-0.98000000f,0.38000000f,-0.15000000f,-0.91000000f,-0.47000000f,0.61000000f,-0.67000000f,0.79000000f,-0.01000000f,-0.04000000f,0.27000000f,0.27000000f,0.49000000f,0.71000000f,0.56000000f,-0.98000000f,0.42000000f,-0.30000000f,-0.48000000f,0.85000000f,-0.28000000f,0.02000000f,-0.26000000f,0.27000000f,0.40000000f,-0.61000000f,-0.48000000f,0.79000000f,0.08000000f,-0.04000000f,0.96000000f,0.86000000f,0.99000000f,-0.97000000f,0.79000000f,-0.96000000f,0.53000000f,0.61000000f,-0.16000000f,0.39000000f,0.02000000f,0.76000000f,-0.51000000f,0.19000000f,0.79000000f,0.20000000f,0.76000000f,0.26000000f,-0.95000000f,0.03000000f,0.06000000f,0.86000000f,-0.69000000f,0.46000000f,-0.55000000f,-0.71000000f,-0.91000000f,0.69000000f,0.53000000f,-0.27000000f,-0.02000000f,-0.34000000f,-0.78000000f,0.51000000f,0.04000000f,0.92000000f,-0.72000000f,-0.84000000f,0.01000000f,-0.95000000f,0.58000000f,-0.85000000f,0.86000000f,-0.70000000f,0.34000000f,0.14000000f,-0.22000000f,0.89000000f,0.44000000f,0.91000000f,0.51000000f,0.15000000f,0.56000000f,0.75000000f,-0.10000000f,0.34000000f,0.14000000f,-0.34000000f,-0.55000000f,0.77000000f,0.59000000f,0.11000000f,-0.16000000f,-0.12000000f,-0.89000000f,-0.45000000f,-0.56000000f,-0.93000000f,0.51000000f,-0.19000000f,0.82000000f,0.17000000f,0.65000000f,0.18000000f,0.69000000f,-0.72000000f,0.75000000f,0.40000000f,-0.37000000f,-0.55000000f,0.87000000f,0.58000000f,0.33000000f,-0.78000000f,0.29000000f,-0.17000000f,0.62000000f,-0.05000000f,0.39000000f,0.69000000f,0.90000000f,-0.53000000f,0.98000000f,0.74000000f,-0.34000000f,-0.34000000f,-0.25000000f,0.62000000f,0.96000000f,-0.30000000f,-0.54000000f,0.46000000f,-0.99000000f,0.13000000f,-0.40000000f,0.15000000f,-0.59000000f,-0.85000000f,0.18000000f,0.89000000f,-0.85000000f,0.56000000f,-0.23000000f,0.73000000f,0.17000000f,-0.76000000f,-0.23000000f,0.77000000f,0.82000000f,-0.72000000f,-0.94000000f,-0.95000000f,0.28000000f,0.74000000f,-0.97000000f,0.44000000f,-0.02000000f,0.40000000f,-0.53000000f,-0.83000000f,-0.57000000f,-0.07000000f,0.20000000f,0.27000000f,0.10000000f,-0.19000000f,0.99000000f,0.18000000f,-0.24000000f,0.73000000f,-0.30000000f,-0.83000000f,-0.34000000f,-0.16000000f,-0.23000000f,0.18000000f,-0.69000000f,-0.70000000f,0.52000000f,-0.33000000f,0.45000000f,-0.81000000f,-0.17000000f,0.03000000f,0.49000000f,0.80000000f,0.88000000f,-0.30000000f,0.17000000f,-0.69000000f,0.19000000f,0.67000000f,-0.78000000f,-0.84000000f,-0.75000000f,-0.81000000f,0.65000000f,0.50000000f,0.62000000f,0.19000000f,-0.91000000f,0.26000000f,-0.17000000f,-0.33000000f,0.19000000f,0.13000000f,0.32000000f,0.59000000f,-0.31000000f,0.88000000f,-0.33000000f,-0.42000000f,-0.34000000f,-0.05000000f,-0.35000000f,0.20000000f,0.31000000f,-0.21000000f,-0.30000000f,0.70000000f,0.10000000f,-0.28000000f,-0.27000000f,0.48000000f,0.45000000f,-0.67000000f,-0.14000000f,-0.41000000f,-0.80000000f,0.02000000f,0.03000000f,-0.49000000f,-0.73000000f,-0.94000000f,-0.28000000f,-0.11000000f,0.94000000f,-0.02000000f,0.06000000f,-0.64000000f,-0.87000000f,0.59000000f,-0.99000000f,-0.19000000f,0.50000000f,-0.12000000f,0.84000000f,0.98000000f,-0.69000000f,0.64000000f,0.93000000f,-0.93000000f,-0.42000000f,-0.96000000f,-0.26000000f,0.21000000f,0.48000000f,-0.64000000f,0.58000000f,-0.86000000f,-0.85000000f,-0.73000000f,-0.81000000f,0.08000000f,-0.89000000f,0.00000000f,-0.16000000f,0.78000000f,0.25000000f,-0.87000000f,-0.30000000f,-0.19000000f,0.58000000f,0.30000000f,-0.10000000f,0.54000000f,0.06000000f,-0.52000000f,-0.88000000f,0.63000000f,-0.34000000f,-0.19000000f,-0.92000000f,0.60000000f,-0.90000000f,-0.21000000f,-0.90000000f,-0.28000000f,-0.14000000f,-0.71000000f,0.49000000f,0.80000000f,-0.49000000f,-0.38000000f,0.57000000f,0.10000000f,-0.80000000f,0.25000000f,-0.38000000f,-0.12000000f,-0.52000000f,-0.01000000f,-0.72000000f,0.74000000f,-0.35000000f,0.88000000f,0.02000000f,-0.14000000f,-0.40000000f,-0.42000000f,0.12000000f,0.93000000f,-0.98000000f,0.95000000f,-0.34000000f,0.53000000f,0.00000000f,0.22000000f,0.35000000f,0.90000000f,-0.39000000f,-0.04000000f,-0.27000000f,-0.20000000f,0.90000000f,-0.00000000f,0.36000000f,-0.68000000f,-0.95000000f,0.21000000f,0.76000000f,0.29000000f,0.99000000f,-0.28000000f,0.02000000f,-0.79000000f,-0.39000000f,0.63000000f,-0.25000000f,0.64000000f,0.72000000f,-0.93000000f,-0.64000000f,0.34000000f,0.36000000f,0.76000000f,0.77000000f,0.27000000f,0.63000000f,0.28000000f,0.94000000f,0.80000000f,0.45000000f,0.49000000f,0.09000000f,0.22000000f,0.50000000f,0.44000000f,0.94000000f,-0.85000000f,0.32000000f,0.34000000f,0.02000000f,-0.04000000f,-0.50000000f,-0.54000000f,-0.96000000f,0.77000000f,-0.09000000f,-0.20000000f,-0.24000000f,-0.78000000f,0.36000000f,-0.73000000f,0.87000000f,0.23000000f,-0.99000000f,0.72000000f,-0.56000000f,0.79000000f,0.14000000f,-0.48000000f,0.37000000f,0.69000000f,0.91000000f,-0.58000000f,0.37000000f,-0.86000000f,-0.76000000f,-0.15000000f,-0.60000000f,-0.16000000f,0.13000000f,-0.97000000f,-0.08000000f,0.84000000f,-0.34000000f,-0.46000000f,0.23000000f,0.61000000f,-0.71000000f,0.71000000f,-0.07000000f,-0.72000000f,0.17000000f,-0.25000000f,0.58000000f,0.10000000f,0.90000000f,-0.80000000f,0.26000000f,0.21000000f,0.48000000f,-0.24000000f,-0.28000000f,0.27000000f,-0.80000000f,0.52000000f,-0.76000000f,0.87000000f,-0.71000000f,0.20000000f,-0.14000000f,0.17000000f,0.87000000f,-0.37000000f,-0.87000000f,0.62000000f,0.50000000f,0.89000000f,-0.66000000f,0.43000000f,-0.85000000f,0.70000000f,0.73000000f,-0.69000000f,-0.95000000f,-0.85000000f,-0.43000000f,0.94000000f,-0.15000000f,-0.69000000f,0.23000000f,-0.29000000f,0.76000000f,-0.62000000f,0.05000000f,-0.59000000f,0.59000000f,0.47000000f,0.27000000f,-0.13000000f,0.47000000f,-0.18000000f,-0.20000000f,0.02000000f,-0.43000000f,0.60000000f,0.11000000f,-0.26000000f,-0.41000000f,0.82000000f,0.66000000f,-0.31000000f,-0.32000000f,0.58000000f,0.86000000f,0.49000000f,-0.90000000f,0.40000000f,0.35000000f,-0.16000000f,0.48000000f,-0.46000000f,-0.02000000f,-0.07000000f,0.32000000f,-0.98000000f,-0.33000000f,0.33000000f,0.22000000f,-0.26000000f,0.09000000f,-0.79000000f,0.06000000f,0.54000000f,-0.87000000f,0.02000000f,0.83000000f,-0.33000000f,0.10000000f,0.50000000f,-0.44000000f,-0.45000000f,-0.97000000f,-0.51000000f,-0.90000000f,-0.56000000f,0.79000000f,-0.48000000f,0.41000000f,0.72000000f,-0.23000000f,0.91000000f,-0.07000000f,-0.38000000f,0.77000000f,-0.55000000f,-0.81000000f,-0.55000000f,0.75000000f,0.66000000f,-0.47000000f,0.44000000f,-0.90000000f,-0.06000000f,0.68000000f,-0.31000000f,-0.25000000f,-0.00000000f,0.47000000f,-0.12000000f,0.12000000f,0.99000000f,-0.62000000f,-0.84000000f,0.17000000f,0.92000000f,0.38000000f,-0.19000000f,-0.97000000f,0.48000000f,-0.89000000f,0.30000000f,-0.08000000f,0.03000000f,0.42000000f,0.14000000f,0.36000000f,-0.26000000f,-0.09000000f,0.41000000f,0.76000000f,0.66000000f,-0.11000000f,-0.19000000f,0.22000000f,-0.11000000f,0.39000000f,0.68000000f,-0.81000000f,0.87000000f,0.04000000f,0.54000000f,0.02000000f,0.05000000f,-0.24000000f,0.05000000f,0.57000000f,-0.81000000f,-0.77000000f,-0.09000000f,-0.35000000f,-0.00000000f,-0.61000000f,0.03000000f,-0.48000000f,0.40000000f,-0.22000000f,-0.19000000f,-0.55000000f,-0.53000000f,-0.32000000f,-0.17000000f,-0.08000000f,0.57000000f,0.18000000f,0.41000000f,0.54000000f,0.21000000f,-0.25000000f,0.07000000f,0.76000000f,-0.97000000f,-0.79000000f,-0.03000000f,-0.56000000f,-0.50000000f,-0.55000000f,-0.58000000f,0.59000000f,0.82000000f,-0.18000000f,-0.50000000f,-0.32000000f,-0.83000000f,-0.44000000f,-0.94000000f,-0.70000000f,0.90000000f,-0.23000000f,-0.23000000f,-0.83000000f,0.35000000f,-0.45000000f,0.31000000f,0.52000000f,-0.14000000f,0.79000000f,-0.30000000f,-0.51000000f,0.99000000f,0.47000000f,0.00000000f,-0.42000000f,0.43000000f,-0.52000000f,0.68000000f,-0.11000000f,0.54000000f,0.98000000f,0.66000000f,-0.32000000f,0.13000000f,-0.87000000f,-0.20000000f,0.27000000f,-0.74000000f,0.64000000f,-0.08000000f,-0.68000000f,-0.78000000f,0.45000000f,-0.37000000f,0.23000000f,0.79000000f,-0.03000000f,-0.09000000f,0.27000000f,-0.46000000f,-0.22000000f,-0.39000000f,0.92000000f,0.80000000f,-0.83000000f,0.89000000f,0.42000000f,0.75000000f,-0.59000000f,-0.26000000f,-0.62000000f,-0.37000000f,-0.07000000f,0.97000000f,-0.90000000f,0.39000000f,-0.50000000f,-0.20000000f,-0.54000000f,0.34000000f,-0.43000000f,-0.82000000f,-0.35000000f,0.42000000f,-0.46000000f,0.48000000f,-0.69000000f,0.33000000f,0.19000000f,0.99000000f,0.06000000f,-0.30000000f,-0.99000000f,0.13000000f,0.47000000f,-0.23000000f,-0.47000000f,0.07000000f,0.82000000f,-0.58000000f,0.42000000f,-0.83000000f,-0.19000000f,-0.98000000f,-0.80000000f,0.28000000f,0.15000000f,0.44000000f,-0.87000000f,0.99000000f,-0.46000000f,-0.85000000f,-0.07000000f,-0.46000000f,-0.93000000f,0.87000000f,0.49000000f,-0.09000000f,-0.74000000f,-0.43000000f,-0.94000000f,0.44000000f,0.50000000f,-0.84000000f,-0.51000000f,0.50000000f,-0.33000000f,0.58000000f,0.22000000f,-0.89000000f,-0.65000000f,0.39000000f,0.01000000f,0.94000000f,-0.73000000f,-0.30000000f,0.69000000f,0.47000000f,0.11000000f,-0.30000000f,-0.16000000f,-0.58000000f,0.76000000f,-0.78000000f,-0.84000000f,0.83000000f,0.96000000f,-0.44000000f,-0.40000000f,-0.28000000f,0.76000000f,-0.47000000f,-0.00000000f,0.91000000f,0.12000000f,0.58000000f,0.64000000f,0.61000000f,0.30000000f,-0.55000000f,-0.33000000f,0.40000000f,0.17000000f,0.35000000f,0.93000000f,-0.63000000f,0.33000000f,0.21000000f,-0.03000000f,-0.55000000f,0.37000000f,0.55000000f,-0.14000000f,-0.37000000f,-0.32000000f,-0.41000000f,-0.50000000f,-0.30000000f,0.49000000f,-0.16000000f,-0.13000000f,-0.77000000f,-0.82000000f,-0.16000000f,0.67000000f,-0.83000000f,-0.87000000f,0.17000000f,0.39000000f,-0.72000000f,-0.09000000f,0.28000000f,0.43000000f,0.44000000f,-0.28000000f,0.23000000f,0.33000000f,-0.95000000f,0.94000000f,-0.70000000f,0.03000000f,-0.73000000f,-0.06000000f,0.90000000f,-0.13000000f,0.39000000f,-0.57000000f,0.13000000f,-0.00000000f,0.30000000f,-0.83000000f,0.53000000f,-0.61000000f,0.27000000f,0.84000000f,0.98000000f,0.98000000f,-0.34000000f,-0.83000000f,-0.36000000f,0.16000000f,-0.93000000f,-0.45000000f,0.23000000f,0.22000000f,0.18000000f,0.80000000f,-0.56000000f,-0.34000000f,-0.40000000f,-0.84000000f,-0.63000000f,0.98000000f,-0.07000000f,-0.36000000f,0.52000000f,0.06000000f,-0.61000000f,-0.19000000f,0.10000000f,0.60000000f,0.37000000f,-0.74000000f,0.84000000f,-0.86000000f,0.63000000f,0.75000000f,-0.48000000f,0.93000000f,-0.39000000f,-0.01000000f,0.43000000f,0.24000000f,-0.49000000f,-0.36000000f,-0.97000000f,-0.56000000f,-0.08000000f,0.61000000f,0.38000000f,-0.25000000f,0.81000000f,0.42000000f,0.42000000f,0.95000000f,0.18000000f,-0.14000000f,0.12000000f,-0.32000000f,-0.62000000f,0.84000000f,-0.92000000f,-0.57000000f,0.57000000f,-0.18000000f,-0.70000000f,0.39000000f,0.48000000f,0.37000000f,-0.34000000f,-0.65000000f,-0.42000000f,-0.81000000f,0.50000000f,-0.27000000f,-0.63000000f,0.09000000f,-0.97000000f,0.76000000f,-0.86000000f,-0.93000000f,-0.67000000f,-0.86000000f,-0.69000000f,0.15000000f,-0.21000000f,0.20000000f,-0.52000000f,-0.65000000f,0.80000000f,-0.69000000f,-0.78000000f,0.23000000f,-0.69000000f,-0.84000000f,0.09000000f,0.53000000f,-0.24000000f,0.44000000f,0.16000000f,-0.10000000f,0.46000000f,-0.63000000f,-0.50000000f,-0.08000000f,0.33000000f,0.76000000f,-0.37000000f,-0.16000000f,0.81000000f,0.44000000f,0.02000000f,0.33000000f,-0.73000000f,0.72000000f,-0.08000000f,-0.47000000f,0.59000000f,0.76000000f,-0.83000000f,0.09000000f,-0.90000000f,-0.91000000f,-0.53000000f,0.80000000f,-0.51000000f,0.33000000f,-0.78000000f,0.47000000f,-0.71000000f,-0.58000000f,0.22000000f,0.53000000f,-0.10000000f,-0.00000000f,0.10000000f,-0.71000000f,0.94000000f,0.18000000f,-0.67000000f,-0.10000000f,-0.95000000f,0.52000000f,0.87000000f,-0.45000000f,0.68000000f,-0.00000000f,-0.78000000f,-0.01000000f,-0.04000000f,0.39000000f,0.02000000f,0.77000000f,0.82000000f,-0.98000000f,-0.90000000f,-0.63000000f,-0.31000000f,-0.97000000f,0.29000000f,-0.00000000f,0.55000000f,-0.58000000f,0.97000000f,-0.35000000f,0.16000000f,-0.56000000f,0.06000000f,0.97000000f,0.54000000f,0.80000000f,-0.59000000f,0.87000000f,0.74000000f,-0.31000000f,-0.24000000f,0.39000000f,0.43000000f,0.33000000f,-0.12000000f,-0.30000000f,0.61000000f,0.77000000f,0.23000000f,-0.05000000f,-0.13000000f,0.14000000f,0.76000000f,-0.12000000f,0.53000000f,-0.56000000f,-0.75000000f,-0.84000000f,-0.97000000f,0.33000000f,0.65000000f,0.16000000f,-0.46000000f,0.28000000f,-0.39000000f,0.40000000f,0.03000000f,-0.36000000f,0.97000000f,-0.27000000f,-0.31000000f,-0.34000000f,0.68000000f,-0.15000000f,-0.09000000f,0.84000000f,0.29000000f,0.90000000f,-0.42000000f,-0.82000000f,0.89000000f,0.15000000f,0.20000000f,-0.32000000f,-0.03000000f,0.29000000f,0.61000000f,-0.52000000f,-0.62000000f,-0.93000000f,0.79000000f,0.28000000f,-0.03000000f,0.03000000f,-0.54000000f,-0.61000000f,0.31000000f,-0.91000000f,0.92000000f,-0.18000000f,-0.12000000f,0.79000000f,-0.24000000f,-0.40000000f,0.46000000f,-0.63000000f,-0.93000000f,0.82000000f,0.40000000f,-0.09000000f,0.12000000f,-0.77000000f,-0.13000000f,-0.58000000f,0.86000000f,-0.86000000f,0.50000000f,-0.72000000f,-0.46000000f,-0.81000000f,0.94000000f,-0.66000000f,0.24000000f,-0.78000000f,-0.79000000f,-0.48000000f,0.49000000f,0.47000000f,-0.04000000f,-0.83000000f,-0.49000000f,-0.48000000f,-0.16000000f,-0.18000000f,0.03000000f,-0.90000000f,-0.47000000f,-0.26000000f,0.38000000f,0.90000000f,-0.81000000f,-0.64000000f,-0.29000000f,0.69000000f,0.62000000f,-0.99000000f,0.50000000f,0.94000000f,0.68000000f,-0.00000000f,0.51000000f,0.26000000f,-0.78000000f,-0.71000000f,0.63000000f,-0.81000000f,-0.18000000f,-0.30000000f,0.28000000f,0.18000000f,-0.20000000f,-0.44000000f,0.26000000f,-0.13000000f,-0.86000000f,0.77000000f,0.78000000f,-0.19000000f,-0.15000000f,-0.77000000f,0.37000000f,-0.01000000f,-0.21000000f,-0.07000000f,-0.78000000f,0.54000000f,0.78000000f,0.38000000f,0.69000000f,0.32000000f,0.04000000f,0.42000000f,-0.40000000f,0.06000000f,0.79000000f,-0.26000000f,-0.15000000f,-0.27000000f,0.23000000f,-0.37000000f,0.90000000f,-0.22000000f,0.73000000f,-0.87000000f,0.59000000f,-0.53000000f,-0.35000000f,-0.88000000f,0.82000000f,-0.57000000f,-0.86000000f,-0.38000000f,-0.87000000f,0.72000000f,0.51000000f,0.56000000f,0.32000000f,0.27000000f,0.86000000f,0.96000000f,-0.40000000f,-0.54000000f,-0.54000000f,0.64000000f,0.99000000f,-0.50000000f,0.29000000f,0.58000000f,0.66000000f,-0.58000000f,0.23000000f,0.24000000f,-0.67000000f,-0.23000000f,0.31000000f,0.47000000f,-0.91000000f,0.56000000f,0.97000000f,0.06000000f,-0.68000000f,-0.36000000f,0.47000000f,0.98000000f,0.41000000f,-0.71000000f,-0.38000000f,0.94000000f,-0.28000000f,0.10000000f,0.87000000f,0.63000000f,0.19000000f,-0.93000000f,-0.64000000f,0.35000000f,0.85000000f,-0.33000000f,0.62000000f,-0.54000000f,0.37000000f,0.92000000f,-0.22000000f,-0.55000000f,-0.59000000f,-0.06000000f,-0.81000000f,0.81000000f,-0.05000000f,0.70000000f,0.47000000f,0.62000000f,-0.69000000f,-0.19000000f,0.37000000f,-0.57000000f,0.66000000f,-0.14000000f,-0.97000000f,-0.71000000f,0.57000000f,0.66000000f,-0.46000000f,0.66000000f,-0.11000000f,0.91000000f,0.75000000f,-0.02000000f,0.14000000f,-0.25000000f,-0.32000000f,0.92000000f,-0.58000000f,0.48000000f,0.62000000f,0.23000000f,0.06000000f,0.17000000f,-0.28000000f,0.81000000f,0.78000000f,-0.14000000f,0.09000000f,0.12000000f,0.27000000f,0.36000000f,0.92000000f,-0.06000000f,-0.52000000f,-0.17000000f,0.36000000f,-0.22000000f,-0.41000000f,-0.64000000f,0.64000000f,-0.69000000f,-0.68000000f,-0.07000000f,-0.12000000f,0.73000000f,0.88000000f,-0.49000000f,0.00000000f,-0.93000000f,-0.45000000f,-0.39000000f,0.67000000f,-0.02000000f,-0.55000000f,0.61000000f,0.51000000f,0.41000000f,0.27000000f,0.19000000f,-0.49000000f,0.14000000f,0.16000000f,-0.45000000f,-0.31000000f,0.70000000f,-0.17000000f,0.52000000f,-0.34000000f,0.66000000f,0.84000000f,0.47000000f,-0.90000000f,-0.38000000f,0.21000000f,0.55000000f,0.86000000f,0.86000000f,-0.79000000f,-0.44000000f,-0.51000000f,-0.09000000f,-0.30000000f,-0.39000000f,-0.18000000f,-0.81000000f,0.32000000f,-0.90000000f,-0.14000000f,-0.24000000f,0.77000000f,-0.68000000f,0.09000000f,0.64000000f,0.08000000f,0.15000000f,-0.36000000f,0.51000000f,-0.54000000f,-0.34000000f,-0.73000000f,-0.25000000f,0.66000000f,-0.33000000f,0.23000000f,-0.93000000f,0.40000000f,0.62000000f,0.12000000f,0.23000000f,0.20000000f,0.57000000f,-0.52000000f,0.08000000f,0.53000000f,0.10000000f,0.79000000f,-0.63000000f,0.46000000f,-0.12000000f,0.21000000f,0.60000000f,0.84000000f,0.84000000f,-0.54000000f,-0.24000000f,-0.75000000f,0.71000000f,0.94000000f,0.81000000f,-0.07000000f,-0.96000000f,-0.51000000f,0.40000000f,-0.26000000f,0.34000000f,-0.79000000f,-0.95000000f,-0.58000000f,0.54000000f,-0.48000000f,-0.83000000f,-0.71000000f,-0.45000000f,-0.68000000f,0.05000000f,0.28000000f,0.58000000f,0.16000000f,0.48000000f,0.09000000f,0.09000000f,0.13000000f,0.76000000f,-0.54000000f,0.14000000f,-0.47000000f,0.95000000f,-0.40000000f,0.96000000f,-0.26000000f,-0.38000000f,-0.54000000f,0.05000000f,0.77000000f,-0.84000000f,-0.88000000f,0.81000000f,-0.69000000f,-0.93000000f,-0.03000000f,0.32000000f,0.60000000f,-0.59000000f,-0.07000000f,-0.66000000f,0.68000000f,-0.77000000f,-0.55000000f,0.31000000f,-0.22000000f,-0.20000000f,0.13000000f,0.32000000f,0.32000000f,0.32000000f,-0.86000000f,-0.19000000f,0.12000000f,0.82000000f,0.38000000f,0.73000000f,0.07000000f,0.09000000f,-0.04000000f,-0.62000000f,0.13000000f,-0.51000000f,-0.87000000f,-0.48000000f,0.07000000f,0.13000000f,-0.16000000f,0.68000000f,-0.97000000f,-0.59000000f,0.00000000f,0.24000000f,-0.67000000f,-0.57000000f,0.59000000f,0.64000000f,0.36000000f,-0.50000000f,0.01000000f,0.94000000f,0.33000000f,0.69000000f,0.24000000f,-0.96000000f,0.31000000f,-0.21000000f,0.77000000f,-0.78000000f,-0.87000000f,0.73000000f,0.55000000f,0.46000000f,0.95000000f,0.99000000f,0.64000000f,0.03000000f,0.04000000f,-0.19000000f,-0.03000000f,0.54000000f,0.19000000f,-0.09000000f,0.57000000f,0.25000000f,0.75000000f,-0.22000000f,0.45000000f,0.23000000f,-0.52000000f,-0.27000000f,-0.83000000f,0.01000000f,-0.08000000f,-0.51000000f,0.26000000f,-0.36000000f,-0.30000000f,-0.77000000f,0.17000000f,-0.02000000f,-0.57000000f,-0.29000000f,-0.47000000f,-0.53000000f,0.97000000f,0.49000000f,0.03000000f,0.52000000f,0.93000000f,0.71000000f,0.82000000f,-0.35000000f,0.38000000f,0.47000000f,-0.92000000f,-0.36000000f,0.69000000f,-0.88000000f,0.58000000f,-0.02000000f,-0.80000000f,-0.69000000f,0.56000000f,-0.15000000f,-0.74000000f,0.88000000f,0.35000000f,0.24000000f,0.03000000f,-0.43000000f,-0.03000000f,-0.97000000f,0.17000000f,-0.92000000f,0.44000000f,-0.57000000f,-0.90000000f,0.50000000f,0.26000000f,-0.87000000f,0.25000000f,-0.70000000f,-0.19000000f,0.56000000f,0.92000000f,0.09000000f,0.55000000f,-0.38000000f,0.28000000f,0.91000000f,-0.25000000f,0.55000000f,0.46000000f,-0.80000000f,0.24000000f,-0.66000000f,0.32000000f,-0.05000000f,-0.09000000f,0.12000000f,0.86000000f,0.66000000f,-0.93000000f,0.88000000f,-0.31000000f,-0.13000000f,0.68000000f,0.84000000f,-0.58000000f,0.19000000f,-0.61000000f,-0.06000000f,-0.01000000f,0.10000000f,-0.77000000f,0.36000000f,-0.05000000f,0.96000000f,0.83000000f,-0.66000000f,0.81000000f,0.54000000f,0.46000000f,-0.93000000f,0.19000000f,-0.75000000f,0.85000000f,-0.26000000f,-0.03000000f,-0.77000000f,0.54000000f,-0.54000000f,0.72000000f,-0.05000000f,-0.81000000f,0.58000000f,-0.34000000f,-0.53000000f,0.98000000f,0.96000000f,-0.55000000f,0.99000000f,-0.48000000f,-0.29000000f,-0.01000000f,0.09000000f,-0.02000000f,-0.34000000f,-0.15000000f,0.44000000f,-0.54000000f,-0.82000000f,-0.35000000f,-0.87000000f,-0.45000000f,0.80000000f,0.74000000f,0.86000000f,0.75000000f,0.66000000f,-0.69000000f,-0.29000000f,-0.18000000f,0.17000000f,-0.50000000f,0.66000000f,0.37000000f,0.75000000f,-0.44000000f,-0.07000000f,0.06000000f,-0.36000000f,-0.10000000f,-0.63000000f,0.12000000f,-0.25000000f,-0.71000000f,-0.51000000f,-0.75000000f,-0.46000000f,0.52000000f,-0.36000000f,-0.97000000f,0.75000000f,-0.23000000f,0.26000000f,-0.27000000f,0.78000000f,-0.93000000f,-0.54000000f,0.00000000f,0.73000000f,0.05000000f,0.00000000f,-0.95000000f,0.19000000f,0.53000000f,-0.57000000f,0.82000000f,-0.48000000f,-0.46000000f,0.37000000f,0.74000000f,-0.99000000f,0.46000000f,-0.10000000f,0.91000000f,0.83000000f,-0.45000000f,-0.37000000f,-0.05000000f,-0.75000000f,-0.23000000f,-0.88000000f,-0.16000000f,-0.97000000f,0.80000000f,0.64000000f,-0.57000000f,0.53000000f,-0.70000000f,-0.19000000f,0.96000000f,0.26000000f,-0.70000000f,0.59000000f,-0.32000000f,0.49000000f,-0.25000000f,-0.01000000f,0.57000000f,-0.21000000f,0.04000000f,-0.32000000f,0.23000000f,0.19000000f,-0.17000000f,-0.58000000f,-0.27000000f,-0.50000000f,-0.59000000f,-0.77000000f,0.07000000f,-0.37000000f,0.13000000f,-0.83000000f,0.31000000f,0.63000000f,-0.55000000f,-0.32000000f,-0.66000000f,-0.61000000f,-0.95000000f,0.04000000f,0.58000000f,0.19000000f,0.50000000f,-0.79000000f,0.32000000f,0.89000000f,0.58000000f,-0.28000000f,0.21000000f,-0.36000000f,0.84000000f,0.24000000f,-0.18000000f,0.96000000f,-0.43000000f,0.17000000f,-0.38000000f,-0.07000000f,0.05000000f,0.91000000f,-0.41000000f,-0.24000000f,0.93000000f,-0.46000000f,-0.51000000f,0.93000000f,0.49000000f,0.17000000f,0.72000000f,-0.07000000f,-0.94000000f,-0.04000000f,0.87000000f,0.86000000f,-0.73000000f,-0.76000000f,-0.54000000f,-0.03000000f,0.83000000f,0.62000000f,0.76000000f,-0.72000000f,-0.76000000f,0.95000000f,0.32000000f,0.61000000f,0.45000000f,0.63000000f,0.89000000f,-0.73000000f,0.63000000f,0.30000000f,-0.75000000f,-0.03000000f,0.64000000f,0.48000000f,-0.94000000f,-0.40000000f,0.28000000f,0.91000000f,0.29000000f,-0.02000000f,0.62000000f,-0.06000000f,0.07000000f,0.86000000f,0.31000000f,0.93000000f,0.41000000f,0.58000000f,0.67000000f,-0.30000000f,0.64000000f,0.59000000f,-0.33000000f,-0.77000000f,-0.52000000f,0.74000000f,-0.58000000f,0.93000000f,-0.17000000f,-0.49000000f,-0.91000000f,0.82000000f,-0.57000000f,0.05000000f,0.17000000f,0.44000000f,0.72000000f,-0.95000000f,-0.29000000f,0.70000000f,-0.96000000f,-0.11000000f,0.31000000f,-0.52000000f,-0.97000000f,-0.58000000f,0.46000000f,-0.06000000f,-0.30000000f,0.25000000f,0.16000000f,-0.38000000f,0.72000000f,0.47000000f,0.47000000f,0.84000000f,0.64000000f,-0.61000000f,-0.39000000f,-0.78000000f,0.58000000f,0.19000000f,-0.05000000f,0.38000000f,0.35000000f,0.11000000f,-0.16000000f,0.85000000f,-0.63000000f,0.88000000f,0.22000000f,0.79000000f,0.30000000f,-0.50000000f,-0.90000000f,0.41000000f,0.16000000f,0.40000000f,-0.38000000f,-0.94000000f,-0.61000000f,-0.02000000f,0.13000000f,-0.84000000f,0.86000000f,0.61000000f,0.08000000f,0.00000000f,0.13000000f,-0.58000000f,0.09000000f,-0.10000000f,-0.21000000f,-0.89000000f,-0.53000000f,0.41000000f,0.02000000f,0.93000000f,0.94000000f,-0.95000000f,0.14000000f,-0.81000000f,0.51000000f,0.00000000f,-0.23000000f,0.11000000f,-0.50000000f,-0.62000000f,-0.57000000f,0.46000000f,0.65000000f,0.98000000f,0.61000000f,0.67000000f,-0.32000000f,-0.09000000f,-0.70000000f,0.62000000f,0.40000000f,-0.69000000f,0.15000000f,0.73000000f,0.76000000f,0.49000000f,-0.10000000f,-0.13000000f,0.93000000f,0.72000000f,0.08000000f,0.96000000f,0.44000000f,0.63000000f,-0.68000000f,-0.69000000f,0.35000000f,0.50000000f,-0.73000000f,0.58000000f,0.85000000f,-0.21000000f,0.32000000f,-0.87000000f,0.05000000f,-0.05000000f,0.35000000f,0.63000000f,-0.24000000f,-0.96000000f,-0.42000000f,-0.05000000f,0.75000000f,0.07000000f,-0.91000000f,-0.35000000f,-0.80000000f,-0.48000000f,-0.86000000f,-0.35000000f,0.42000000f,0.88000000f,0.38000000f,0.53000000f,-0.74000000f,-0.61000000f,0.14000000f,-0.43000000f,0.68000000f,-0.02000000f,-0.30000000f,-0.81000000f,-0.39000000f,0.32000000f,-0.39000000f,0.23000000f,-0.82000000f,0.17000000f,-0.05000000f,-0.45000000f,-0.37000000f,0.57000000f,-0.44000000f,0.72000000f,-0.00000000f,0.84000000f,0.98000000f,-0.03000000f,-0.34000000f,-0.51000000f,-0.27000000f,0.46000000f,-0.49000000f,0.86000000f,-0.15000000f,-0.70000000f,0.91000000f,-0.87000000f,-0.44000000f,0.68000000f,0.96000000f,0.20000000f,-0.22000000f,0.96000000f,-0.46000000f,-0.18000000f,0.42000000f,-0.02000000f,-0.66000000f,0.85000000f,0.23000000f,0.03000000f,0.28000000f,-0.56000000f,-0.20000000f,-0.94000000f,0.90000000f,-0.11000000f,-0.63000000f,-0.19000000f,-0.37000000f,0.29000000f,0.18000000f,-0.32000000f,0.41000000f,-0.42000000f,0.95000000f,-0.88000000f,0.74000000f,-0.55000000f,-0.36000000f,-0.70000000f,0.09000000f,0.08000000f,-0.33000000f,0.16000000f,0.67000000f,0.46000000f,-0.94000000f,-0.47000000f,0.94000000f,0.61000000f,-0.40000000f,0.97000000f,-0.08000000f,0.29000000f,0.61000000f,-0.88000000f,0.66000000f,0.83000000f,-0.84000000f,0.61000000f,0.66000000f,0.92000000f,0.26000000f,-0.12000000f,-0.25000000f,-0.01000000f,-0.07000000f,-0.98000000f,-0.45000000f,0.92000000f,-0.29000000f,-0.48000000f,0.08000000f,0.16000000f,0.53000000f,0.96000000f,0.55000000f,0.39000000f,-0.61000000f,0.45000000f,-0.45000000f,-0.09000000f,0.10000000f,-0.07000000f,-0.11000000f,-0.87000000f,-0.43000000f,0.32000000f,0.91000000f,-0.72000000f,-0.75000000f,0.55000000f,-0.80000000f,0.33000000f,0.03000000f,-0.19000000f,-0.93000000f,-0.65000000f,0.92000000f,-0.26000000f,0.89000000f,0.50000000f,0.28000000f,-0.98000000f,-0.55000000f,-0.80000000f,-0.50000000f,0.33000000f,0.08000000f,0.85000000f,-0.33000000f,0.57000000f,-0.59000000f,0.97000000f,0.95000000f,0.51000000f,0.60000000f,-0.80000000f,0.92000000f,-0.55000000f,0.10000000f,0.13000000f,-0.89000000f,0.04000000f,-0.75000000f,0.73000000f,0.80000000f,0.87000000f,0.23000000f,0.59000000f,-0.63000000f,0.70000000f,-0.95000000f,0.82000000f,-0.27000000f,0.54000000f,0.19000000f,0.96000000f,0.95000000f,-0.81000000f,0.02000000f,0.45000000f,0.40000000f,-0.52000000f,-0.74000000f,0.27000000f,0.37000000f,-0.27000000f,-0.23000000f,0.24000000f,0.28000000f,0.27000000f,0.38000000f,0.62000000f,-0.84000000f,0.22000000f,-0.88000000f,-0.77000000f,0.61000000f,-0.22000000f,-0.26000000f,0.59000000f,0.63000000f,0.49000000f,-0.77000000f,0.30000000f,-0.57000000f,0.39000000f,-0.21000000f,-0.68000000f,0.43000000f,0.60000000f,0.30000000f,-0.51000000f,-0.28000000f,0.26000000f,-0.06000000f,-0.68000000f,0.50000000f,-0.07000000f,0.16000000f,0.25000000f,-0.39000000f,-0.08000000f,0.81000000f,0.83000000f,-0.72000000f,-0.67000000f,0.35000000f,-0.08000000f,0.37000000f,-0.24000000f,0.64000000f,0.37000000f,-0.17000000f,0.61000000f,-0.35000000f,0.21000000f,0.72000000f,0.98000000f,0.38000000f,-0.14000000f,0.59000000f,0.45000000f,0.30000000f,0.61000000f,0.62000000f,0.56000000f,-0.66000000f,-0.39000000f,0.11000000f,-0.43000000f,-0.08000000f,0.75000000f,0.31000000f,-0.64000000f,-0.53000000f,0.41000000f,0.48000000f,0.54000000f,0.62000000f,-0.64000000f,-0.58000000f,-0.00000000f,0.05000000f,-0.62000000f,-0.65000000f,0.72000000f,-0.90000000f,0.29000000f,-0.56000000f,-0.68000000f,0.98000000f,0.84000000f,-0.43000000f,0.16000000f,-0.43000000f,0.16000000f,-0.86000000f,0.23000000f,0.70000000f,-0.94000000f,-0.74000000f,0.41000000f,0.20000000f,0.02000000f,-0.35000000f,-0.99000000f,-0.87000000f,-0.65000000f,0.77000000f,0.32000000f,0.92000000f,0.14000000f,0.95000000f,-0.80000000f,-0.14000000f,0.10000000f,0.60000000f,0.06000000f,0.19000000f,0.28000000f,0.32000000f,-0.87000000f,0.32000000f,-0.61000000f,-0.94000000f,-0.76000000f,0.91000000f,-0.77000000f,-0.80000000f,-0.33000000f,0.36000000f,-0.66000000f,0.50000000f,0.06000000f,-0.79000000f,-0.14000000f,0.38000000f,0.54000000f,-0.34000000f,-0.51000000f,-0.35000000f,-0.78000000f,0.40000000f,0.78000000f,-0.55000000f,-0.93000000f,0.77000000f,-0.93000000f,0.69000000f,0.86000000f,-0.07000000f,-0.78000000f,-0.16000000f,0.30000000f,-0.95000000f,-0.53000000f,0.73000000f,-0.75000000f,-0.55000000f,-0.16000000f,-0.30000000f,-0.74000000f,0.95000000f,-0.18000000f,-0.65000000f,0.99000000f,-0.87000000f,0.49000000f,0.24000000f,-0.06000000f,0.58000000f,-0.93000000f,-0.93000000f,-0.36000000f,0.74000000f,0.54000000f,-0.62000000f,0.09000000f,0.09000000f,-0.05000000f,-0.06000000f,0.15000000f,-0.69000000f,-0.22000000f,-0.20000000f,0.70000000f,0.56000000f,-0.30000000f,-0.70000000f,-0.69000000f,-0.10000000f,0.44000000f,-0.01000000f,-0.95000000f,-0.85000000f,0.53000000f,-0.05000000f,0.00000000f,-0.66000000f,0.05000000f,-0.52000000f,0.64000000f,-0.21000000f,0.22000000f,-0.25000000f,-0.22000000f,0.28000000f,-0.70000000f,0.57000000f,-0.90000000f,-0.33000000f,-0.69000000f,-0.14000000f,0.08000000f,-0.38000000f,-0.14000000f,-0.97000000f,0.84000000f,0.69000000f,-0.38000000f,0.36000000f,0.42000000f,-0.39000000f,0.29000000f,0.50000000f,-0.36000000f,-0.58000000f,-0.40000000f,0.88000000f,0.70000000f,0.59000000f,0.88000000f,0.90000000f,-0.10000000f,-0.22000000f,-0.68000000f,-0.92000000f,-0.55000000f,-0.46000000f,0.96000000f,-0.50000000f,0.08000000f,0.92000000f,-0.68000000f,-0.27000000f,0.29000000f,-0.95000000f,0.58000000f,0.69000000f,-0.62000000f,-0.25000000f,0.02000000f,-0.50000000f,0.01000000f,0.33000000f,-0.93000000f,-0.85000000f,-0.51000000f,0.04000000f,0.29000000f,-0.32000000f,-0.66000000f,0.08000000f,0.94000000f,-0.81000000f,-0.70000000f,0.44000000f,-0.13000000f,0.72000000f,-0.81000000f,-0.55000000f,-0.53000000f,-0.27000000f,-0.76000000f,0.04000000f,0.91000000f,0.80000000f,-0.91000000f,-0.79000000f,-0.11000000f,0.17000000f,-0.42000000f,0.57000000f,0.72000000f,-0.52000000f,-0.12000000f,-0.00000000f,-0.17000000f,0.98000000f,-0.30000000f,0.20000000f,0.64000000f,-0.29000000f,-0.42000000f,0.45000000f,0.85000000f,0.53000000f,0.47000000f,-0.29000000f,-0.04000000f,0.97000000f,0.86000000f,-0.13000000f,-0.96000000f,-0.34000000f,0.75000000f,-0.04000000f,-0.21000000f,0.59000000f,0.68000000f,0.36000000f,-0.11000000f,0.76000000f,-0.59000000f,-0.28000000f,0.07000000f,0.49000000f,0.23000000f,-0.01000000f,-0.00000000f,-0.33000000f,-0.14000000f,0.17000000f,0.68000000f,0.41000000f,-0.02000000f,-0.40000000f,0.75000000f,0.39000000f,-0.07000000f,0.11000000f,0.66000000f,0.47000000f,0.90000000f,0.17000000f,-0.15000000f,0.48000000f,-0.10000000f,-0.81000000f,0.47000000f,0.72000000f,0.51000000f,-0.64000000f,0.41000000f,-0.21000000f,0.97000000f,0.42000000f,0.81000000f,0.00000000f,-0.99000000f,0.43000000f,0.83000000f,0.78000000f,-0.92000000f,0.32000000f,0.59000000f,-0.96000000f,-0.46000000f,0.32000000f,0.53000000f,-0.28000000f,-0.00000000f,-0.04000000f,-0.99000000f,0.67000000f,-0.13000000f,-0.43000000f,0.50000000f,-0.65000000f,0.96000000f,0.71000000f,-0.71000000f,-0.40000000f,0.44000000f,0.25000000f,0.90000000f,0.45000000f,0.71000000f,-0.66000000f,0.00000000f,0.52000000f,0.93000000f,0.58000000f,0.29000000f,0.62000000f,0.27000000f,0.56000000f,0.42000000f,0.26000000f,0.78000000f,-0.92000000f,-0.29000000f,0.98000000f,0.97000000f,0.80000000f,0.53000000f,0.40000000f,-0.28000000f,-0.01000000f,-0.15000000f,0.00000000f,0.18000000f,0.01000000f,-0.46000000f,-0.81000000f,-0.42000000f,0.58000000f,-0.47000000f,0.40000000f,-0.81000000f,0.67000000f,0.70000000f,-0.64000000f,0.31000000f,-0.75000000f,-0.07000000f,0.73000000f,0.31000000f,0.20000000f,0.07000000f,-0.31000000f,-0.50000000f,-0.91000000f,-0.53000000f,0.80000000f,0.13000000f,-0.31000000f,0.46000000f,0.99000000f,-0.52000000f,0.09000000f,-0.21000000f,0.46000000f,-0.76000000f,0.27000000f,0.88000000f,0.30000000f,-0.83000000f,-0.85000000f,0.98000000f,-0.34000000f,-0.84000000f,0.50000000f,-0.78000000f,0.17000000f,-0.72000000f,-0.06000000f,-0.53000000f,-0.53000000f,-0.74000000f,0.95000000f,0.42000000f,0.25000000f,-0.73000000f,0.10000000f,-0.06000000f,-0.87000000f,0.01000000f,0.54000000f,0.87000000f,0.68000000f,-0.85000000f,0.53000000f,-0.02000000f,0.86000000f,-0.15000000f,0.23000000f,0.18000000f,-0.34000000f,0.67000000f,-0.82000000f,-0.70000000f,0.35000000f,-0.90000000f,0.09000000f,-0.03000000f,0.94000000f,0.69000000f,0.43000000f,0.60000000f,-0.87000000f,0.45000000f,0.61000000f,-0.31000000f,0.54000000f,-0.91000000f,-0.73000000f,0.58000000f,0.27000000f,-0.81000000f,-0.94000000f,-0.63000000f,-0.91000000f,0.10000000f,0.25000000f,0.08000000f,0.47000000f,-0.75000000f,-0.34000000f,0.69000000f,0.37000000f,0.90000000f,0.21000000f,0.81000000f,-0.53000000f,0.80000000f,-0.67000000f,-0.95000000f,-0.55000000f,0.21000000f,-0.04000000f,-0.12000000f,-0.64000000f,0.78000000f,0.15000000f,-0.49000000f,0.26000000f,-0.29000000f,0.09000000f,-0.84000000f,-0.93000000f,0.11000000f,0.58000000f,-0.67000000f,0.60000000f,-0.40000000f,-0.61000000f,0.72000000f,-0.36000000f,-0.24000000f,-0.89000000f,-0.21000000f,-0.82000000f,-0.37000000f,-0.57000000f,0.72000000f,-0.66000000f,0.63000000f,0.74000000f,0.37000000f,-0.51000000f,0.37000000f,-0.71000000f,0.92000000f,-0.34000000f,0.02000000f,-0.95000000f,-0.37000000f,-0.92000000f,0.04000000f,0.12000000f,-0.26000000f,-0.43000000f,-0.81000000f,-0.26000000f,-0.48000000f,0.44000000f,-0.12000000f,-0.75000000f,0.98000000f,-0.31000000f,-0.01000000f,0.29000000f,0.77000000f,0.29000000f,0.87000000f,0.47000000f,0.18000000f,0.07000000f,-0.99000000f,0.81000000f,0.14000000f,0.53000000f,-0.03000000f,-0.22000000f,0.28000000f,-0.56000000f,-0.86000000f,0.52000000f,0.83000000f,0.89000000f,-0.54000000f,-0.48000000f,-0.91000000f,0.80000000f,-0.12000000f,-0.06000000f,0.09000000f,0.75000000f,-0.36000000f,0.55000000f,0.55000000f,0.46000000f,0.74000000f,0.53000000f,0.99000000f,-0.33000000f,-0.45000000f,-0.06000000f,-0.12000000f,0.19000000f,-0.17000000f,-0.38000000f,-0.78000000f,-0.58000000f,-0.74000000f,-0.65000000f,-0.03000000f,-0.77000000f,-0.38000000f,-0.97000000f,0.24000000f,0.57000000f,0.75000000f,0.45000000f,0.39000000f,0.89000000f,-0.81000000f,-0.42000000f,0.93000000f,-0.87000000f,0.52000000f,0.44000000f,-0.34000000f,-0.16000000f,-0.02000000f,-0.85000000f,0.97000000f,-0.41000000f,-0.57000000f,0.96000000f,-0.94000000f,-0.66000000f,0.92000000f,-0.94000000f,0.23000000f,-0.06000000f,-0.68000000f,0.37000000f,0.30000000f,0.75000000f,-0.51000000f,0.12000000f,0.52000000f,-0.17000000f,0.55000000f,-0.17000000f,0.40000000f,0.60000000f,0.97000000f,0.83000000f,-0.13000000f,-0.28000000f,0.73000000f,-0.77000000f,0.36000000f,-0.03000000f,0.96000000f,0.41000000f,0.97000000f,-0.65000000f,-0.78000000f,-0.68000000f,0.71000000f,-0.25000000f,-0.02000000f,-0.14000000f,0.32000000f,0.48000000f,-0.85000000f,-0.12000000f,-0.11000000f,0.90000000f,-0.59000000f,-0.70000000f,0.19000000f,0.53000000f,-0.83000000f,0.34000000f,-0.22000000f,0.34000000f,-0.37000000f,0.01000000f,-0.64000000f,-0.40000000f,-0.64000000f,-0.04000000f,-0.41000000f,-0.77000000f,-0.63000000f,0.16000000f,-0.17000000f,0.29000000f,-0.19000000f,0.87000000f,0.49000000f,-0.09000000f,0.27000000f,-0.24000000f,0.73000000f,-0.55000000f,0.97000000f,-0.62000000f,0.64000000f,0.27000000f,-0.66000000f,-0.34000000f,0.39000000f,0.81000000f,-0.13000000f,0.14000000f,0.88000000f,-0.43000000f,0.79000000f,-0.88000000f,0.91000000f,-0.25000000f,-0.24000000f,-0.40000000f,-0.51000000f,-0.61000000f,0.11000000f,0.45000000f,0.23000000f,0.60000000f,-0.73000000f,0.20000000f,0.65000000f,-0.25000000f,-0.67000000f,0.76000000f,-0.83000000f,0.64000000f,-0.01000000f,-0.51000000f,-0.27000000f,-0.03000000f,0.33000000f,0.27000000f,-0.69000000f,-0.85000000f,0.06000000f,0.53000000f,-0.78000000f,0.85000000f,-0.26000000f,0.46000000f,-0.79000000f,0.86000000f,-0.25000000f,-0.67000000f,-0.88000000f,-0.69000000f,-0.71000000f,0.58000000f,0.09000000f,-0.60000000f,0.83000000f,0.40000000f,-0.88000000f,-0.15000000f,0.46000000f,0.05000000f,0.37000000f,0.25000000f,-0.85000000f,-0.39000000f,0.69000000f,-0.68000000f,-0.21000000f,0.97000000f,-0.03000000f,-0.13000000f,-0.59000000f,0.65000000f,-0.72000000f,-0.84000000f,-0.80000000f,0.42000000f,-0.36000000f,-0.11000000f,-0.84000000f,-0.27000000f,-0.13000000f,-0.03000000f,0.82000000f,0.33000000f,-0.24000000f,0.30000000f,-0.28000000f,0.41000000f,-0.56000000f,-0.47000000f,-0.18000000f,-0.57000000f,-0.56000000f,-0.87000000f,-0.05000000f,-0.17000000f,-0.31000000f,-0.73000000f,-0.89000000f,0.01000000f,0.20000000f,0.06000000f,-0.85000000f,-0.75000000f,0.78000000f,-0.60000000f,0.87000000f,0.91000000f,-0.13000000f,0.75000000f,-0.49000000f,0.96000000f,-0.60000000f,-0.87000000f,-0.49000000f,0.83000000f,0.42000000f,-0.29000000f,0.32000000f,-0.46000000f,-0.84000000f,0.37000000f,-0.36000000f,0.39000000f,-0.72000000f,0.24000000f,0.28000000f,-0.63000000f,0.40000000f,0.92000000f,-0.75000000f,-0.68000000f,0.74000000f,0.07000000f,0.60000000f,0.22000000f,-0.50000000f,-0.10000000f,-0.08000000f,0.50000000f,-0.34000000f,0.24000000f,-0.77000000f,-0.23000000f,0.77000000f,0.89000000f,-0.20000000f,0.89000000f,-0.95000000f,0.35000000f,0.19000000f,0.70000000f,-0.10000000f,0.07000000f,0.71000000f,0.16000000f,0.33000000f,0.37000000f,0.13000000f,-0.98000000f,-0.12000000f,-0.50000000f,0.68000000f,-0.62000000f,-0.38000000f,0.13000000f,0.86000000f,0.22000000f,-0.56000000f,0.35000000f,-0.98000000f,-0.72000000f,0.86000000f,-0.44000000f,0.73000000f,0.57000000f,0.84000000f,-0.93000000f,-0.62000000f,-0.67000000f,0.14000000f,-0.73000000f,-0.85000000f,-0.38000000f,0.01000000f,-0.87000000f,0.05000000f,-0.98000000f,-0.18000000f,0.56000000f,0.90000000f,-0.66000000f,-0.81000000f,0.09000000f,-0.63000000f,0.04000000f,-0.88000000f,0.74000000f,0.73000000f,0.71000000f,0.68000000f,0.27000000f,-0.52000000f,0.16000000f,-0.72000000f,0.10000000f,-0.71000000f,0.97000000f,-0.55000000f,-0.06000000f,-0.68000000f,-0.74000000f,-0.66000000f,-0.93000000f,0.23000000f,-0.35000000f,0.37000000f,0.54000000f,0.60000000f,0.10000000f,-0.76000000f,0.45000000f,-0.66000000f,-0.08000000f,0.98000000f,-0.09000000f,0.96000000f,-0.54000000f,-0.33000000f,-0.04000000f,0.36000000f,0.86000000f,-0.42000000f,-0.50000000f,0.45000000f,0.33000000f,0.78000000f,0.25000000f,0.58000000f,0.15000000f,-0.89000000f,-0.49000000f,0.42000000f,0.78000000f,-0.86000000f,-0.65000000f,0.81000000f,-0.67000000f,0.62000000f,0.14000000f,0.62000000f,0.05000000f,-0.93000000f,0.34000000f,-0.40000000f,0.01000000f,0.46000000f,-0.34000000f,0.51000000f,-0.86000000f,0.94000000f,-0.20000000f,-0.75000000f,0.27000000f,-0.09000000f,0.41000000f,-0.86000000f,0.80000000f,-0.13000000f,-0.31000000f,0.52000000f,-0.12000000f,0.46000000f,0.58000000f,0.60000000f,-0.12000000f,-0.45000000f,-0.61000000f,-0.33000000f,-0.80000000f,-0.25000000f,-0.00000000f,-0.20000000f,-0.48000000f,-0.98000000f,0.96000000f,-0.86000000f,-0.21000000f,0.30000000f,0.26000000f,0.53000000f,0.83000000f,0.82000000f,-0.39000000f,-0.66000000f,-0.69000000f,-0.42000000f,0.35000000f,-0.88000000f,0.27000000f,-0.34000000f,-0.21000000f,-0.89000000f,0.74000000f,-0.98000000f,-0.35000000f,-0.72000000f,-0.37000000f,-0.32000000f,0.39000000f,-0.24000000f,-0.83000000f,0.95000000f,-0.43000000f,0.72000000f,0.24000000f,-0.85000000f,-0.19000000f,0.55000000f,0.02000000f,0.34000000f,-0.41000000f,-0.08000000f,-0.25000000f,0.40000000f,-0.00000000f,0.58000000f,0.43000000f,0.79000000f,0.29000000f,-0.57000000f,-0.02000000f,-0.31000000f,-0.01000000f,0.33000000f,-0.09000000f,-0.07000000f,0.53000000f,-0.58000000f,0.94000000f,-0.64000000f,0.37000000f,0.63000000f,-0.79000000f,0.21000000f,0.72000000f,0.24000000f,0.09000000f,0.34000000f,0.15000000f,0.41000000f,0.94000000f,0.69000000f,0.51000000f,0.52000000f,-0.03000000f,-0.81000000f,-0.99000000f,-0.76000000f,0.33000000f,0.61000000f,0.03000000f,-0.61000000f,0.78000000f,0.69000000f,0.62000000f,-0.22000000f,-0.70000000f,-0.64000000f,0.55000000f,-0.56000000f,0.24000000f,-0.39000000f,0.33000000f,-0.08000000f,0.92000000f,0.88000000f,-0.94000000f,-0.85000000f,-0.47000000f,-0.96000000f,-0.51000000f,0.22000000f,0.87000000f,-0.85000000f,0.51000000f,0.27000000f,0.12000000f,-0.83000000f,-0.13000000f,-0.63000000f,0.72000000f,0.51000000f,0.35000000f,-0.94000000f,0.60000000f,0.79000000f,-0.57000000f,-0.70000000f,0.21000000f,-0.68000000f,-0.84000000f,0.10000000f,0.76000000f,0.92000000f,0.60000000f,-0.16000000f,0.85000000f,-0.28000000f,-0.00000000f,0.25000000f,0.61000000f,0.69000000f,-0.62000000f,0.17000000f,0.05000000f,0.08000000f,-0.87000000f,0.23000000f,0.95000000f,-0.82000000f,0.84000000f,-0.58000000f,0.76000000f,-0.46000000f,-0.35000000f,0.76000000f,-0.57000000f,0.70000000f,-0.14000000f,0.55000000f,0.57000000f,0.57000000f,-0.28000000f,-0.18000000f,0.46000000f,0.89000000f,0.07000000f,0.45000000f,-0.65000000f,-0.46000000f,0.01000000f,0.32000000f,-0.96000000f,-0.71000000f,0.05000000f,0.35000000f,-0.90000000f,-0.56000000f,0.72000000f,-0.33000000f,-0.48000000f,0.42000000f,0.32000000f,0.16000000f,-0.55000000f,-0.83000000f,0.42000000f,0.74000000f,0.41000000f,0.93000000f,0.61000000f,-0.39000000f,-0.03000000f,-0.81000000f,-0.37000000f,-0.55000000f,-0.06000000f,0.62000000f,0.69000000f,0.74000000f,0.21000000f,0.12000000f,-0.18000000f,0.25000000f,-0.66000000f,0.40000000f,-0.33000000f,0.95000000f,0.72000000f,0.29000000f,0.71000000f,-0.46000000f,-0.56000000f,-0.79000000f,0.59000000f,-0.71000000f,-0.02000000f,0.61000000f,0.66000000f,0.23000000f,-0.44000000f,0.99000000f,0.66000000f,-0.47000000f,0.99000000f,0.68000000f,-0.21000000f,-0.96000000f,-0.67000000f,0.39000000f,0.22000000f,-0.72000000f,0.01000000f,0.62000000f,0.68000000f,-0.87000000f,-0.92000000f,-0.64000000f,-0.60000000f,-0.51000000f,-0.45000000f,0.72000000f,-0.86000000f,0.99000000f,-0.77000000f,0.36000000f,0.20000000f,0.17000000f,-0.32000000f,-0.06000000f,0.10000000f,0.63000000f,-0.08000000f,-0.01000000f,0.58000000f,-0.31000000f,0.18000000f,-0.09000000f,0.10000000f,-0.72000000f,0.98000000f,-0.76000000f,-0.21000000f,-0.61000000f,0.19000000f,-0.52000000f,0.13000000f,0.39000000f,-0.53000000f,-0.86000000f,-0.91000000f,-0.57000000f,0.61000000f,0.47000000f,-0.73000000f,0.63000000f,0.07000000f,0.90000000f,-0.58000000f,0.52000000f,0.45000000f,-0.51000000f,-0.87000000f,0.31000000f,0.25000000f,-0.08000000f,0.53000000f,-0.73000000f,-0.08000000f,-0.86000000f,-0.63000000f,0.63000000f,-0.40000000f,-0.66000000f,-0.40000000f,-0.71000000f,-0.76000000f,0.66000000f,-0.22000000f,-0.58000000f,0.49000000f,-0.97000000f,0.84000000f,0.96000000f,-0.09000000f,-0.92000000f,-0.24000000f,0.01000000f,-0.97000000f,-0.80000000f,0.00000000f,-0.99000000f,0.62000000f,0.62000000f,-0.32000000f,0.11000000f,0.30000000f,0.80000000f,0.62000000f,-0.57000000f,0.89000000f,0.57000000f,-0.87000000f,-0.95000000f,0.74000000f,-0.57000000f,-0.31000000f,0.05000000f,-0.78000000f,-0.51000000f,0.84000000f,-0.40000000f,-0.97000000f,-0.31000000f,0.89000000f,-0.41000000f,0.15000000f,0.52000000f,0.19000000f,-0.33000000f,0.07000000f,0.74000000f,0.06000000f,-0.64000000f,-0.70000000f,0.58000000f,-0.31000000f,-0.99000000f,-0.46000000f,0.28000000f,0.08000000f,-0.73000000f,-0.31000000f,0.70000000f,-0.90000000f,0.28000000f,0.88000000f,-0.92000000f,-0.21000000f,-0.63000000f,0.47000000f,0.72000000f,0.86000000f,0.95000000f,0.79000000f,0.34000000f,0.16000000f,0.91000000f,0.65000000f,-0.86000000f,-0.81000000f,0.67000000f,0.18000000f,-0.58000000f,0.25000000f,-0.49000000f,0.52000000f,-0.86000000f,-0.25000000f,0.11000000f,-0.97000000f,0.44000000f,0.43000000f,0.64000000f,0.27000000f,-0.64000000f,-0.44000000f,0.96000000f,-0.44000000f,-0.79000000f,0.17000000f,-0.21000000f,0.86000000f,-0.61000000f,-0.16000000f,-0.68000000f,0.95000000f,0.67000000f,0.58000000f,0.10000000f,0.61000000f,-0.99000000f,-0.01000000f,0.86000000f,-0.80000000f,0.35000000f,-0.44000000f,0.84000000f,0.92000000f,-0.35000000f,0.62000000f,-0.40000000f,0.71000000f,-0.38000000f,0.43000000f,0.02000000f,0.74000000f,-0.66000000f,0.68000000f,0.29000000f,-0.79000000f,0.36000000f,0.07000000f,-0.04000000f,0.43000000f,-0.51000000f,-0.47000000f,0.55000000f,0.15000000f,0.82000000f,-0.94000000f,-0.59000000f,-0.85000000f,-0.74000000f,0.85000000f,0.41000000f,0.59000000f,0.53000000f,0.91000000f,0.12000000f,0.92000000f,-0.52000000f,0.41000000f,0.41000000f,-0.25000000f,0.64000000f,-0.45000000f,0.25000000f,-0.56000000f,-0.53000000f,0.16000000f,-0.75000000f,-0.85000000f,-0.16000000f,-0.84000000f,-0.85000000f,-0.57000000f,-0.57000000f,-0.00000000f,0.41000000f,-0.96000000f,0.34000000f,0.47000000f,-0.53000000f,-0.84000000f,0.00000000f,0.39000000f,-0.38000000f,0.87000000f,-0.84000000f,0.56000000f,-0.49000000f,0.32000000f,0.23000000f,-0.04000000f,-0.16000000f,-0.01000000f,-0.47000000f,-0.02000000f,0.57000000f,-0.69000000f,-0.71000000f,-0.71000000f,0.72000000f,0.82000000f,0.65000000f,0.73000000f,-0.31000000f,0.76000000f,-0.64000000f,0.15000000f,-0.50000000f,-0.59000000f,-0.94000000f,0.81000000f,0.78000000f,-0.19000000f,-0.56000000f,0.87000000f,-0.71000000f,0.65000000f,0.43000000f,0.79000000f,0.33000000f,0.07000000f,0.33000000f,-0.77000000f,0.11000000f,0.88000000f,0.47000000f,0.66000000f,-0.62000000f,0.89000000f,0.22000000f,-0.49000000f,-0.71000000f,-0.87000000f,0.77000000f,-0.86000000f,0.08000000f,-0.53000000f,-0.58000000f,0.89000000f,0.57000000f,-0.65000000f,-0.25000000f,-0.48000000f,-0.28000000f,-0.59000000f,0.60000000f,-0.56000000f,-0.06000000f,0.33000000f,0.29000000f,-0.00000000f,-0.66000000f,0.86000000f,-0.90000000f,-0.59000000f,-0.32000000f,0.00000000f,-0.16000000f,-0.59000000f,0.23000000f,0.45000000f,-0.86000000f,0.59000000f,0.37000000f,-0.79000000f,-0.57000000f,0.77000000f,0.34000000f,-0.08000000f,-0.98000000f,0.01000000f,0.69000000f,0.28000000f,-0.84000000f,0.74000000f,-0.02000000f,0.49000000f,0.29000000f,0.07000000f,0.09000000f,0.47000000f,0.87000000f,0.25000000f,0.38000000f,-0.31000000f,-0.12000000f,-0.23000000f,0.23000000f,-0.94000000f,-0.48000000f,0.38000000f,-0.12000000f,-0.66000000f,-0.72000000f,-0.21000000f,0.83000000f,0.78000000f,-0.27000000f,0.81000000f,0.58000000f,-0.93000000f,-0.63000000f,-0.42000000f,-0.16000000f,-0.96000000f,-0.73000000f,0.76000000f,0.32000000f,-0.60000000f,0.50000000f,0.24000000f,-0.48000000f,-0.20000000f,0.99000000f,-0.24000000f,0.59000000f,0.07000000f,-0.80000000f,-0.01000000f,0.45000000f,-0.48000000f,0.34000000f,-0.60000000f,0.15000000f,-0.40000000f,0.68000000f,0.69000000f,0.13000000f,-0.99000000f,-0.21000000f,-0.17000000f,0.29000000f,-0.20000000f,0.86000000f,-0.80000000f,0.82000000f,-0.36000000f,0.79000000f,0.75000000f,-0.37000000f,-0.54000000f,0.16000000f,-0.86000000f,0.36000000f,-0.46000000f,0.33000000f,-0.31000000f,0.75000000f,-0.62000000f,0.79000000f,-0.45000000f,0.34000000f,-0.72000000f,-0.67000000f,0.06000000f,0.17000000f,0.57000000f,0.89000000f,-0.08000000f,0.58000000f,-0.01000000f,0.27000000f,0.05000000f,-0.42000000f,-0.22000000f,0.86000000f,0.92000000f,-0.66000000f,-0.01000000f,-0.62000000f,0.62000000f,0.57000000f,0.17000000f,0.47000000f,-0.50000000f,-0.72000000f,-0.90000000f,0.05000000f,-0.40000000f,-0.77000000f,-0.71000000f,-0.03000000f,-0.81000000f,0.11000000f,-0.34000000f,-0.70000000f,0.05000000f,0.74000000f,-0.27000000f,-0.50000000f,-0.47000000f,0.87000000f,-0.15000000f,0.14000000f,0.31000000f,-0.67000000f,0.74000000f,-0.55000000f,0.41000000f,-0.80000000f,0.84000000f,-0.23000000f,0.10000000f,-0.17000000f,0.65000000f,0.79000000f,-0.67000000f,0.67000000f,-0.17000000f,0.32000000f,-0.06000000f,0.44000000f,0.13000000f,0.26000000f,-0.67000000f,0.63000000f,-0.17000000f,0.40000000f,0.26000000f,0.55000000f,0.29000000f,0.62000000f,0.83000000f,-0.41000000f,-0.07000000f,0.40000000f,-0.40000000f,-0.21000000f,0.45000000f,-0.88000000f,-0.83000000f,0.85000000f,-0.84000000f,0.43000000f,0.44000000f,0.24000000f,-0.32000000f,0.29000000f,-0.62000000f,-0.24000000f,0.38000000f,-0.84000000f,-0.97000000f,-0.68000000f,0.44000000f,-0.70000000f,-0.95000000f,-0.70000000f,-0.39000000f,-0.30000000f,-0.72000000f,-0.55000000f,-0.09000000f,-0.15000000f,0.77000000f,0.40000000f,-0.16000000f,-0.94000000f,-0.24000000f,-0.79000000f,-0.94000000f,0.46000000f,-0.35000000f,0.93000000f,0.10000000f,0.39000000f,-0.37000000f,-0.63000000f,0.03000000f,-0.13000000f,0.64000000f,0.49000000f,-0.52000000f,0.24000000f,-0.59000000f,0.13000000f,0.42000000f,-0.19000000f,0.33000000f,-0.33000000f,-0.67000000f,0.43000000f,0.22000000f,-0.85000000f,0.83000000f,-0.51000000f,0.60000000f,0.15000000f,-0.90000000f,-0.24000000f,-0.39000000f,0.90000000f,-0.87000000f,0.39000000f,-0.70000000f,-0.05000000f,-0.09000000f,-0.95000000f,-0.05000000f,-0.08000000f,0.92000000f,0.95000000f,-0.15000000f,-0.85000000f,-0.87000000f,0.53000000f,-0.31000000f,0.49000000f,-0.59000000f,0.92000000f,-0.82000000f,-0.97000000f,0.40000000f,-0.60000000f,0.80000000f,-0.48000000f,-0.68000000f,0.33000000f,0.73000000f,-0.37000000f,-0.31000000f,0.26000000f,0.62000000f,0.11000000f,0.65000000f,-0.73000000f,0.26000000f,-0.88000000f,0.33000000f,-0.03000000f,-0.54000000f,-0.92000000f,-0.74000000f,-0.80000000f,-0.82000000f,-0.61000000f,-0.97000000f,-0.09000000f,-0.81000000f,-0.83000000f,-0.84000000f,0.02000000f,-0.26000000f,0.60000000f,-0.30000000f,0.41000000f,-0.59000000f,-0.07000000f,-0.70000000f,0.74000000f,0.25000000f,-0.50000000f,0.88000000f,0.73000000f,-0.40000000f,0.49000000f,0.84000000f,0.27000000f,0.80000000f,-0.06000000f,-0.26000000f,0.16000000f,-0.87000000f,-0.86000000f,0.19000000f,0.88000000f,0.00000000f,0.19000000f,0.89000000f,0.94000000f,0.11000000f,-0.09000000f,0.04000000f,-0.15000000f,-0.07000000f,0.56000000f,0.71000000f,-0.94000000f,-0.13000000f,0.72000000f,0.50000000f,-0.17000000f,-0.58000000f,-0.35000000f,0.20000000f,-0.18000000f,-0.31000000f,-0.80000000f,-0.95000000f,-0.00000000f,0.84000000f,0.91000000f,0.34000000f,0.89000000f,-0.08000000f,0.90000000f,0.80000000f,-0.41000000f,-0.50000000f,0.95000000f,0.41000000f,0.52000000f,-0.21000000f,-0.99000000f,-0.77000000f,0.41000000f,-0.32000000f,-0.99000000f,0.21000000f,0.29000000f,0.82000000f,0.99000000f,0.57000000f,-0.46000000f,0.77000000f,-0.43000000f,-0.71000000f,0.13000000f,-0.61000000f,-0.38000000f,0.89000000f,-0.15000000f,-0.46000000f,-0.81000000f,-0.75000000f,0.54000000f,0.45000000f,0.88000000f,-0.25000000f,-0.74000000f,0.38000000f,0.52000000f,-0.93000000f,0.54000000f,0.50000000f,0.52000000f,0.41000000f,-0.64000000f,0.64000000f,0.04000000f,0.33000000f,0.38000000f,-0.97000000f,0.08000000f,-0.90000000f,0.49000000f,0.54000000f,-0.09000000f,0.90000000f,0.66000000f,0.20000000f,-0.75000000f,-0.42000000f,0.64000000f,0.33000000f,0.21000000f,-0.08000000f,0.02000000f,0.92000000f,-0.18000000f,-0.28000000f,0.75000000f,0.13000000f,0.37000000f,0.17000000f,0.89000000f,0.23000000f,-0.47000000f,0.90000000f,-0.24000000f,0.13000000f,-0.81000000f,0.73000000f,-0.12000000f,0.76000000f,-0.54000000f,0.19000000f,0.98000000f,0.81000000f,0.99000000f,0.76000000f,-0.33000000f,0.12000000f,0.22000000f,0.02000000f,-0.43000000f,-0.39000000f,-0.74000000f,-0.79000000f,0.26000000f,-0.14000000f,0.52000000f,-0.96000000f,-0.60000000f,-0.79000000f,-0.53000000f,0.11000000f,0.65000000f,-0.12000000f,-0.92000000f,-0.85000000f,-0.06000000f,0.31000000f,-0.55000000f,0.27000000f,-0.87000000f,-0.46000000f,-0.95000000f,0.23000000f,-0.52000000f,-0.96000000f,0.06000000f,-0.22000000f,-0.44000000f,-0.11000000f,0.34000000f,-0.89000000f,0.43000000f,-0.24000000f,0.48000000f,-0.07000000f,0.08000000f,-0.85000000f,-0.25000000f,0.92000000f,-0.27000000f,-0.03000000f,-0.06000000f,-0.85000000f,0.12000000f,-0.55000000f,-0.70000000f,-0.11000000f,0.70000000f,0.69000000f,0.76000000f,-0.91000000f,-0.63000000f,-0.61000000f,-0.98000000f,0.73000000f,-0.90000000f,-0.62000000f,0.68000000f,-0.87000000f,-0.56000000f,-0.27000000f,-0.70000000f,0.99000000f,0.79000000f,-0.41000000f,0.54000000f,-0.64000000f,0.61000000f,-0.35000000f,0.90000000f,-0.33000000f,0.51000000f,-0.59000000f,0.95000000f,-0.73000000f,0.15000000f,-0.22000000f,0.26000000f,0.72000000f,0.51000000f,0.61000000f,-0.00000000f,0.37000000f,0.58000000f,0.26000000f,-0.13000000f,0.41000000f,0.41000000f,-0.95000000f,-0.79000000f,0.58000000f,-0.20000000f,-0.86000000f,-0.20000000f,-0.60000000f,-0.44000000f,0.11000000f,-0.23000000f,0.91000000f,0.01000000f,0.87000000f,-0.19000000f,0.24000000f,0.01000000f,-0.88000000f,0.09000000f,0.08000000f,0.83000000f,0.02000000f,-0.57000000f,-0.21000000f,0.93000000f,0.91000000f,0.51000000f,-0.74000000f,0.29000000f,0.31000000f,0.41000000f,0.55000000f,0.72000000f,-0.93000000f,-0.47000000f,0.95000000f,-0.73000000f,-0.76000000f,-0.98000000f,-0.84000000f,0.31000000f,-0.89000000f,-0.27000000f,-0.70000000f,-0.22000000f,0.39000000f,0.81000000f,-0.85000000f,0.69000000f,-0.50000000f,-0.53000000f,-0.14000000f,-0.02000000f,0.31000000f,-0.74000000f,-0.19000000f,0.84000000f,0.99000000f,-0.92000000f,-0.35000000f,-0.30000000f,0.85000000f,-0.64000000f,-0.84000000f,0.69000000f,0.77000000f,0.91000000f,0.04000000f,0.94000000f,0.44000000f,0.28000000f,0.13000000f,-0.65000000f,-0.84000000f,0.61000000f,0.01000000f,0.78000000f,-0.17000000f,0.27000000f,0.72000000f,-0.14000000f,-0.18000000f,0.70000000f,-0.19000000f,0.57000000f,-0.89000000f,0.48000000f,0.36000000f,0.39000000f,0.46000000f,0.67000000f,0.16000000f,-0.86000000f,-0.52000000f,0.20000000f,-0.18000000f,0.70000000f,-0.11000000f,-0.57000000f,-0.96000000f,-0.27000000f,0.41000000f,0.72000000f,-0.33000000f,-0.93000000f,0.99000000f,-0.90000000f,0.79000000f,0.17000000f,-0.40000000f,-0.13000000f,0.92000000f,0.74000000f,-0.58000000f,-0.76000000f,-0.93000000f,0.65000000f,0.97000000f,0.27000000f,-0.84000000f,-0.61000000f,0.83000000f,-0.56000000f,-0.76000000f,-0.69000000f,-0.44000000f,-0.84000000f,-0.95000000f,0.33000000f,0.88000000f,-0.70000000f,0.30000000f,-0.69000000f,0.50000000f,-0.65000000f,-0.16000000f,-0.51000000f,0.81000000f,0.13000000f,-0.45000000f,0.35000000f,-0.10000000f,0.31000000f,-0.21000000f,0.39000000f,0.49000000f,-0.66000000f,0.44000000f,0.71000000f,0.87000000f,-0.61000000f,0.86000000f,-0.65000000f,0.87000000f,-0.89000000f,0.70000000f,-0.20000000f,-0.83000000f,0.61000000f,0.43000000f,-0.98000000f,-0.09000000f,-0.20000000f,-0.09000000f,0.99000000f,0.45000000f,0.28000000f,-0.28000000f,-0.46000000f,0.05000000f,0.96000000f,0.66000000f,0.72000000f,0.27000000f,-0.07000000f,-0.27000000f,0.54000000f,0.16000000f,0.54000000f,-0.60000000f,-0.50000000f,-0.94000000f,-0.28000000f,-0.05000000f,0.52000000f,0.65000000f,-0.99000000f,0.50000000f,-0.51000000f,0.28000000f,-0.93000000f,-0.15000000f,-0.64000000f,-0.62000000f,0.36000000f,-0.83000000f,0.86000000f,0.42000000f,0.60000000f,0.59000000f,0.42000000f,0.89000000f,0.50000000f,0.73000000f,-0.41000000f,-0.61000000f,-0.51000000f,-0.32000000f,-0.53000000f,0.64000000f,0.98000000f,-0.94000000f,-0.13000000f,0.06000000f,0.20000000f,-0.18000000f,-0.05000000f,0.50000000f,-0.39000000f,-0.08000000f,0.94000000f,-0.22000000f,-0.01000000f,0.51000000f,0.43000000f,-0.18000000f,-0.40000000f,0.08000000f,-0.40000000f,0.44000000f,-0.45000000f,-0.39000000f,0.39000000f,0.02000000f,0.81000000f,-0.75000000f,0.91000000f,-0.83000000f,0.06000000f,-0.36000000f,0.03000000f,0.11000000f,-0.19000000f,-0.29000000f,0.21000000f,-0.61000000f,0.44000000f,-0.86000000f,-0.69000000f,-0.18000000f,0.51000000f,0.90000000f,-0.05000000f,0.39000000f,-0.89000000f,-0.61000000f,0.66000000f,-0.06000000f,0.90000000f,0.20000000f,0.91000000f,-0.50000000f,-0.63000000f,0.68000000f,0.40000000f,-0.30000000f,0.28000000f,0.98000000f,-0.56000000f,-0.13000000f,-0.12000000f,0.29000000f,0.66000000f,0.07000000f,0.48000000f,0.60000000f,0.09000000f,0.09000000f,0.38000000f,0.63000000f,-0.27000000f,0.35000000f,-0.26000000f,-0.83000000f,-0.63000000f,-0.84000000f,0.87000000f,-0.94000000f,0.07000000f,0.17000000f,-0.98000000f,0.76000000f,-0.98000000f,0.81000000f,0.18000000f,-0.77000000f,-0.80000000f,-0.26000000f,0.76000000f,0.41000000f,-0.40000000f,-0.80000000f,0.16000000f,0.96000000f,0.81000000f,0.47000000f,-0.29000000f,0.57000000f,-0.06000000f,-0.04000000f,-0.30000000f,-0.92000000f,-0.18000000f,0.32000000f,-0.66000000f,-0.90000000f,0.74000000f,0.61000000f,0.37000000f,0.34000000f,0.67000000f,0.08000000f,0.80000000f,-0.27000000f,-0.49000000f,-0.15000000f,0.84000000f,-0.71000000f,0.56000000f,0.24000000f,0.89000000f,-0.00000000f,-0.44000000f,0.67000000f,-0.27000000f,0.31000000f,-0.86000000f,0.52000000f,0.87000000f,-0.03000000f,-0.34000000f,-0.38000000f,0.82000000f,0.84000000f,-0.30000000f,-0.13000000f,0.86000000f,-0.35000000f,0.67000000f,0.45000000f,-0.24000000f,0.95000000f,0.70000000f,-0.83000000f,-0.17000000f,-0.09000000f,-0.35000000f,-0.47000000f,0.71000000f,-0.75000000f,0.33000000f,0.64000000f,-0.68000000f,0.43000000f,0.38000000f,0.48000000f,0.21000000f,0.85000000f,-0.77000000f,0.11000000f,-0.19000000f,0.05000000f,-0.17000000f,-0.67000000f,-0.84000000f,-0.54000000f,-0.54000000f,-0.70000000f,-0.39000000f,-0.52000000f,-0.42000000f,-0.78000000f,0.39000000f,0.70000000f,-0.06000000f,-0.79000000f,0.41000000f,0.94000000f,0.83000000f,-0.33000000f,0.98000000f,-0.14000000f,-0.40000000f,-0.72000000f,0.66000000f,0.79000000f,0.79000000f,0.29000000f,-0.14000000f,-0.34000000f,0.40000000f,-0.95000000f,0.90000000f,-0.38000000f,-0.29000000f,0.95000000f,0.72000000f,0.17000000f,-0.54000000f,0.29000000f,-0.10000000f,0.93000000f,0.69000000f,-0.19000000f,0.20000000f,0.02000000f,0.96000000f,-0.05000000f,-0.49000000f,-0.93000000f,0.32000000f,-0.31000000f,0.07000000f,0.71000000f,-0.58000000f,0.08000000f,0.95000000f,-0.55000000f,0.95000000f,0.05000000f,0.42000000f,-0.98000000f,0.95000000f,-0.09000000f,-0.77000000f,0.42000000f,0.60000000f,-0.16000000f,0.29000000f,0.25000000f,0.39000000f,-0.81000000f,-0.90000000f,0.46000000f,-0.30000000f,0.10000000f,0.07000000f,0.81000000f,-0.57000000f,-0.31000000f,-0.21000000f,-0.12000000f,0.01000000f,-0.11000000f,0.66000000f,0.01000000f,0.90000000f,-0.38000000f,0.52000000f,0.08000000f,-0.77000000f,-0.66000000f,-0.54000000f,0.00000000f,-0.44000000f,0.17000000f,0.38000000f,-0.33000000f,0.80000000f,-0.80000000f,0.15000000f,-0.51000000f,-0.23000000f,-0.52000000f,0.37000000f,0.58000000f,-0.35000000f,-0.71000000f,-0.79000000f,-0.47000000f,-0.69000000f,-0.88000000f,-0.48000000f,0.28000000f,0.71000000f,0.46000000f,-0.28000000f,-0.13000000f,0.64000000f,-0.43000000f,-0.44000000f,0.44000000f,-0.11000000f,0.22000000f,0.10000000f,-0.94000000f,0.42000000f,-0.15000000f,0.25000000f,-0.25000000f,-0.88000000f,-0.29000000f,0.92000000f,-0.13000000f,0.06000000f,-0.35000000f,-0.66000000f,-0.77000000f,0.02000000f,-0.55000000f,0.51000000f,-0.57000000f,0.50000000f,0.68000000f,-0.22000000f,0.23000000f,0.00000000f,-0.66000000f,-0.36000000f,0.44000000f,0.25000000f,0.28000000f,0.96000000f,0.68000000f,-0.22000000f,-0.33000000f,-0.67000000f,0.11000000f,-0.33000000f,-0.15000000f,-0.16000000f,-0.87000000f,-0.37000000f,0.18000000f,0.62000000f,-0.25000000f,-0.13000000f,0.65000000f,-0.03000000f,-0.00000000f,0.30000000f,0.77000000f,0.63000000f,0.57000000f,0.93000000f,-0.37000000f,-0.06000000f,-0.72000000f,0.39000000f,0.36000000f,-0.28000000f,0.53000000f,0.00000000f,0.71000000f,-0.57000000f,-0.64000000f,0.30000000f,-0.40000000f,-0.30000000f,0.05000000f,-0.90000000f,0.36000000f,0.87000000f,0.77000000f,0.03000000f,-0.41000000f,-0.91000000f,0.81000000f,0.16000000f,-0.12000000f,-0.18000000f,0.30000000f,-0.51000000f,0.26000000f,-0.46000000f,-0.62000000f,0.79000000f,-0.98000000f,-0.60000000f,-0.90000000f,0.01000000f,-0.52000000f,0.66000000f,-0.49000000f,0.75000000f,-0.68000000f,-0.78000000f,-0.70000000f,0.44000000f,0.07000000f,-0.90000000f,-0.50000000f,0.22000000f,0.04000000f,-0.54000000f,0.35000000f,-0.38000000f,0.18000000f,-0.04000000f,-0.09000000f,-0.83000000f,-0.16000000f,-0.99000000f,-0.78000000f,-0.73000000f,0.71000000f,0.27000000f,0.15000000f,0.19000000f,0.29000000f,-0.20000000f,0.00000000f,0.38000000f,0.84000000f,-0.20000000f,0.28000000f,0.19000000f,-0.02000000f,-0.50000000f,-0.66000000f,-0.23000000f,0.79000000f,0.62000000f,0.20000000f,-0.24000000f,0.60000000f,-0.39000000f,-0.61000000f,-0.53000000f,-0.93000000f,0.99000000f,0.78000000f,-0.92000000f,0.92000000f,0.43000000f,0.46000000f,0.87000000f,0.32000000f,-0.53000000f,0.85000000f,-0.73000000f,-0.71000000f,-0.39000000f,-0.90000000f,-0.63000000f,0.01000000f,-0.38000000f,-0.62000000f,-0.25000000f,-0.37000000f,0.60000000f,-0.01000000f,0.18000000f,0.95000000f,0.99000000f,-0.70000000f,-0.76000000f,-0.15000000f,-0.78000000f,0.02000000f,0.08000000f,0.27000000f,-0.61000000f,0.62000000f,0.59000000f,-0.04000000f,0.46000000f,-0.63000000f,-0.05000000f,0.85000000f,-0.05000000f,-0.84000000f,-0.35000000f,-0.35000000f,0.63000000f,0.55000000f,-0.33000000f,-0.53000000f,0.62000000f,0.64000000f,-0.02000000f,0.06000000f,-0.39000000f,-0.55000000f,-0.09000000f,-0.17000000f,-0.09000000f,-0.84000000f,0.94000000f,-0.08000000f,-0.95000000f,-0.25000000f,0.12000000f,-0.26000000f,-0.94000000f,0.32000000f,-0.60000000f,-0.11000000f,-0.27000000f,-0.32000000f,0.31000000f,0.97000000f,0.64000000f,0.99000000f,-0.99000000f,-0.56000000f,0.96000000f,0.11000000f,-0.57000000f,-0.51000000f,0.82000000f,-0.35000000f,0.13000000f,0.70000000f,-0.97000000f,0.92000000f,0.59000000f,-0.03000000f,0.15000000f,-0.09000000f,0.46000000f,0.28000000f,0.73000000f,-0.17000000f,0.26000000f,-0.23000000f,0.45000000f,-0.96000000f,0.21000000f,-0.28000000f,-0.64000000f,-0.09000000f,0.68000000f,0.49000000f,-0.30000000f,-0.75000000f,0.98000000f,-0.71000000f,-0.42000000f,-0.52000000f,0.19000000f,0.52000000f,0.30000000f,0.92000000f,0.61000000f,-0.53000000f,0.62000000f,-0.15000000f,0.19000000f,0.07000000f,0.67000000f,0.92000000f,0.20000000f,-0.69000000f,-0.29000000f,-0.75000000f,0.54000000f,0.78000000f,0.92000000f,-0.70000000f,-0.70000000f,-0.40000000f,-0.41000000f,0.89000000f,-0.29000000f,0.02000000f,0.34000000f,-0.24000000f,0.48000000f,0.97000000f,0.75000000f,-0.66000000f,0.17000000f,-0.32000000f,-0.41000000f,0.24000000f,0.85000000f,-0.70000000f,0.39000000f,0.46000000f,-0.84000000f,0.86000000f,0.45000000f,-0.78000000f,-0.61000000f,0.74000000f,0.73000000f,0.78000000f,0.66000000f,-0.15000000f,-0.85000000f,0.46000000f,0.46000000f,-0.21000000f,-0.78000000f,-0.16000000f,0.12000000f,0.83000000f,0.05000000f,-0.95000000f,0.41000000f,0.45000000f,-0.02000000f,0.56000000f,-0.91000000f,-0.90000000f,-0.33000000f,-0.94000000f,-0.72000000f,-0.90000000f,-0.22000000f,-0.01000000f,-0.59000000f,0.58000000f,-0.37000000f,0.23000000f,-0.96000000f,0.41000000f,-0.65000000f,0.69000000f,-0.79000000f,0.14000000f,0.39000000f,-0.99000000f,-0.21000000f,-0.73000000f,-0.33000000f,0.53000000f,-0.15000000f,-0.04000000f,-0.00000000f,0.33000000f,0.12000000f,-0.44000000f,-0.88000000f,-0.93000000f,0.05000000f,0.73000000f,-0.66000000f,-0.85000000f,-0.17000000f,-0.47000000f,0.15000000f,0.65000000f,0.91000000f,-0.72000000f,0.32000000f,0.64000000f,-0.30000000f,-0.40000000f,-0.79000000f,-0.77000000f,0.27000000f,0.09000000f,0.65000000f,-0.85000000f,0.37000000f,0.57000000f,-0.79000000f,0.28000000f,0.02000000f,-0.92000000f,0.23000000f,0.66000000f,-0.38000000f,0.24000000f,-0.21000000f,0.84000000f,-0.71000000f,-0.12000000f,0.26000000f,-0.29000000f,0.26000000f,-0.08000000f,0.75000000f,0.54000000f,0.46000000f,0.11000000f,-0.81000000f,-0.53000000f,0.85000000f,-0.24000000f,-0.38000000f,0.95000000f,0.36000000f,0.77000000f,-0.37000000f,0.58000000f,0.91000000f,0.03000000f,0.13000000f,-0.98000000f,0.68000000f,0.74000000f,0.52000000f,0.42000000f,0.83000000f,-0.76000000f,0.52000000f,-0.79000000f,-0.57000000f,0.95000000f,-0.58000000f,-0.11000000f,-0.08000000f,0.57000000f,0.75000000f,-0.80000000f,0.33000000f,0.42000000f,-0.85000000f,-0.74000000f,-0.91000000f,-0.99000000f,-0.08000000f,-0.06000000f,-0.42000000f,0.33000000f,-0.45000000f,-0.09000000f,0.56000000f,-0.95000000f,0.98000000f,-0.24000000f,0.48000000f,-0.85000000f,-0.05000000f,0.73000000f,0.75000000f,0.43000000f,0.00000000f,-0.29000000f,-0.75000000f,-0.39000000f,-0.76000000f,0.35000000f,0.29000000f,-0.19000000f,-0.61000000f,-0.65000000f,-0.35000000f,0.74000000f,-0.12000000f,0.62000000f,0.59000000f,-0.11000000f,-0.36000000f,-0.37000000f,-0.59000000f,0.28000000f,-0.28000000f,-0.00000000f,0.60000000f,-0.40000000f,0.10000000f,-0.94000000f,-0.25000000f,-0.50000000f,-0.12000000f,-0.90000000f,0.13000000f,-0.39000000f,0.30000000f,-0.87000000f,0.76000000f,-0.61000000f,0.55000000f,0.17000000f,0.74000000f,-0.36000000f,0.52000000f,0.71000000f,-0.20000000f,0.07000000f,0.40000000f,0.61000000f,0.06000000f,0.68000000f,0.71000000f,-0.36000000f,-0.52000000f,-0.61000000f,-0.70000000f,-0.40000000f,0.00000000f,0.69000000f,-0.44000000f,-0.15000000f,0.45000000f,-0.63000000f,0.88000000f,0.23000000f,-0.98000000f,0.29000000f,-0.86000000f,-0.24000000f,0.65000000f,-0.61000000f,-0.61000000f,0.81000000f,0.10000000f,0.24000000f,0.84000000f,-0.98000000f,-0.26000000f,-0.17000000f,-0.05000000f,0.88000000f,-0.93000000f,-0.34000000f,0.10000000f,0.89000000f,-0.92000000f,0.88000000f,-0.01000000f,0.30000000f,0.01000000f,0.65000000f,-0.87000000f,-0.51000000f,0.42000000f,0.60000000f,0.02000000f,0.56000000f,-0.56000000f,-0.00000000f,0.63000000f,0.40000000f,0.32000000f,-0.12000000f,0.05000000f,0.61000000f,-0.57000000f,-0.84000000f,0.20000000f,-0.91000000f,0.48000000f,0.64000000f,-0.60000000f,-0.24000000f,0.84000000f,0.21000000f,-0.48000000f,0.26000000f,-0.71000000f,0.31000000f,0.21000000f,0.59000000f,0.90000000f,-0.38000000f,0.56000000f,-0.72000000f,0.22000000f,0.01000000f,0.74000000f,0.19000000f,-0.40000000f,-0.63000000f,0.76000000f,-0.67000000f,0.27000000f,0.09000000f,-0.04000000f,0.49000000f,0.33000000f,0.55000000f,0.73000000f,-0.41000000f,-0.49000000f,0.16000000f,-0.93000000f,0.37000000f,0.62000000f,0.68000000f,-0.51000000f,0.08000000f,0.89000000f,-0.35000000f,0.26000000f,0.77000000f,0.33000000f,0.42000000f,-0.66000000f,0.65000000f,-0.34000000f,0.87000000f,-0.97000000f,-0.16000000f,0.43000000f,-0.93000000f,-0.06000000f,0.00000000f,0.40000000f,0.06000000f,-0.16000000f,0.79000000f,0.46000000f,-0.60000000f,-0.68000000f,0.11000000f,-0.19000000f,0.33000000f,-0.37000000f,-0.94000000f,-0.08000000f,0.11000000f,0.20000000f,0.78000000f,0.34000000f,-0.61000000f,0.60000000f,-0.93000000f,-0.36000000f,0.96000000f,-0.37000000f,-0.79000000f,-0.56000000f,0.86000000f,0.36000000f,-0.68000000f,-0.18000000f,0.54000000f,0.14000000f,0.00000000f,0.23000000f,0.14000000f,0.83000000f,-0.45000000f,0.01000000f,0.59000000f,-0.02000000f,0.43000000f,-0.03000000f,0.97000000f,0.62000000f,-0.12000000f,0.90000000f,-0.90000000f,-0.08000000f,0.36000000f,-0.72000000f,0.02000000f,0.22000000f,-0.24000000f,0.96000000f,-0.33000000f,-0.13000000f,0.44000000f,-0.65000000f,0.95000000f,0.68000000f,-0.76000000f,0.18000000f,-0.06000000f,0.26000000f,0.74000000f,-0.38000000f,-0.08000000f,0.15000000f,0.45000000f,-0.97000000f,0.43000000f,-0.82000000f,-0.84000000f,0.99000000f,-0.55000000f,-0.93000000f,-0.07000000f,-0.29000000f,-0.59000000f,-0.91000000f,0.49000000f,-0.60000000f,-0.56000000f,0.63000000f,0.86000000f,0.49000000f,0.76000000f,0.69000000f,0.12000000f,0.67000000f,0.60000000f,0.12000000f,-0.79000000f,0.78000000f,0.35000000f,0.52000000f,-0.80000000f,-0.12000000f,0.25000000f,0.43000000f,0.69000000f,0.12000000f,-0.01000000f,0.47000000f,0.65000000f,-0.38000000f,0.99000000f,0.28000000f,-0.37000000f,-0.18000000f,0.69000000f,0.56000000f,0.80000000f,0.89000000f,-0.13000000f,0.57000000f,0.45000000f,-0.11000000f,0.62000000f,0.83000000f,0.14000000f,-0.80000000f,-0.12000000f,-0.04000000f,0.25000000f,0.59000000f,-0.17000000f,0.04000000f,-0.75000000f,0.75000000f,-0.56000000f,-0.46000000f,-0.27000000f,0.22000000f,0.53000000f,0.58000000f,0.03000000f,0.44000000f,-0.14000000f,0.26000000f,-0.22000000f,0.74000000f,0.28000000f,0.50000000f,-0.21000000f,-0.51000000f,-0.50000000f,0.73000000f,-0.67000000f,0.19000000f,-0.58000000f,-0.29000000f,0.56000000f,-0.77000000f,0.18000000f,-0.46000000f,0.59000000f,0.80000000f,0.95000000f,-0.66000000f,-0.67000000f,-0.57000000f,0.01000000f,-0.20000000f,0.27000000f,0.67000000f,-0.12000000f,-0.34000000f,0.72000000f,-0.05000000f,0.95000000f,-0.26000000f,0.30000000f,0.87000000f,-0.61000000f,0.91000000f,-0.68000000f,0.20000000f,-0.75000000f,-0.04000000f,0.12000000f,0.37000000f,-0.34000000f,0.06000000f,-0.92000000f,-0.76000000f,-0.04000000f,-0.17000000f,-0.73000000f,0.50000000f,-0.32000000f,-0.77000000f,-0.25000000f,-0.72000000f,-0.32000000f,-0.88000000f,0.97000000f,0.63000000f,-0.05000000f,0.05000000f,0.33000000f,0.46000000f,0.65000000f,-0.38000000f,0.36000000f,0.52000000f,-0.33000000f,-0.09000000f,0.57000000f,-0.44000000f,-0.80000000f,0.18000000f,-0.14000000f,0.83000000f,0.53000000f,0.45000000f,-0.82000000f,0.11000000f,0.24000000f,0.56000000f,-0.47000000f,-0.35000000f,-0.33000000f,0.97000000f,-0.77000000f,-0.42000000f,0.61000000f,-0.45000000f,0.57000000f,0.43000000f,0.69000000f,0.46000000f,0.22000000f,0.10000000f,-0.24000000f,0.52000000f,0.55000000f,-0.97000000f,0.09000000f,-0.52000000f,0.78000000f,0.50000000f,0.87000000f,-0.04000000f,0.21000000f,0.92000000f,0.15000000f,-0.85000000f,-0.64000000f,0.25000000f,0.20000000f,0.35000000f,0.85000000f,-0.95000000f,-0.36000000f,-0.75000000f,0.85000000f,0.62000000f,0.04000000f,-0.87000000f,0.41000000f,-0.07000000f,-0.71000000f,-0.30000000f,0.07000000f,0.37000000f,-0.16000000f,0.39000000f,-0.62000000f,-0.02000000f,0.57000000f,-0.37000000f,0.31000000f,-0.55000000f,-0.41000000f,-0.11000000f,-0.32000000f,-0.19000000f,0.31000000f,0.29000000f,0.44000000f,0.09000000f,-0.54000000f,0.38000000f,0.07000000f,0.10000000f,-0.71000000f,-0.97000000f,-0.48000000f,-0.55000000f,0.49000000f,-0.95000000f,0.92000000f,0.69000000f,0.24000000f,-0.82000000f,0.33000000f,-0.03000000f,-0.20000000f,-0.14000000f,-0.77000000f,-0.16000000f,0.57000000f,0.39000000f,0.84000000f,-0.73000000f,-0.48000000f,0.65000000f,0.33000000f,0.24000000f,-0.56000000f,0.31000000f,0.23000000f,0.44000000f,-0.97000000f,-0.87000000f,0.14000000f,-0.73000000f,-0.02000000f,0.18000000f,-0.09000000f,-0.02000000f,-0.27000000f,0.09000000f,0.96000000f,-0.01000000f,-0.79000000f,0.29000000f,-0.34000000f,0.99000000f,0.87000000f,-0.45000000f,0.55000000f,-0.25000000f,-0.69000000f,-0.75000000f,-0.45000000f,-0.27000000f,-0.00000000f,-0.99000000f,0.26000000f,0.07000000f,-0.60000000f,-0.50000000f,-0.11000000f,0.20000000f,0.01000000f,-0.09000000f,-0.56000000f,0.85000000f,0.96000000f,0.02000000f,0.09000000f,-0.63000000f,0.13000000f,0.61000000f,0.46000000f,-0.97000000f,0.29000000f,0.09000000f,-0.41000000f,-0.73000000f,0.43000000f,-0.49000000f,-0.33000000f,-0.35000000f,-0.36000000f,0.63000000f,0.41000000f,-0.57000000f,-0.39000000f,0.65000000f,-0.03000000f,-0.29000000f,0.06000000f,0.04000000f,0.97000000f,-0.50000000f,-0.54000000f,0.86000000f,-0.41000000f,0.57000000f,-0.12000000f,0.51000000f,-0.41000000f,0.77000000f,-0.89000000f,-0.74000000f,0.45000000f,0.99000000f,0.03000000f,0.96000000f,0.48000000f,0.47000000f,-0.71000000f,-0.85000000f,0.62000000f,-0.83000000f,-0.71000000f,-0.87000000f,0.97000000f,-0.41000000f,-0.20000000f,-0.84000000f,0.55000000f,-0.01000000f,-0.76000000f,0.15000000f,0.55000000f,0.26000000f,0.19000000f,0.70000000f,0.07000000f,-0.56000000f,-0.51000000f,0.48000000f,-0.55000000f,0.14000000f,0.53000000f,-0.53000000f,-0.99000000f,-0.22000000f,-0.61000000f,-0.88000000f,-0.26000000f,0.46000000f,-0.19000000f,-0.22000000f,0.20000000f,-0.02000000f,0.71000000f,-0.82000000f,-0.67000000f,0.80000000f,0.31000000f,-0.58000000f,-0.59000000f,-0.63000000f,0.48000000f,-0.73000000f,0.45000000f,0.49000000f,0.74000000f,0.59000000f,0.72000000f,-0.48000000f,0.18000000f,-0.12000000f,0.30000000f,0.81000000f,0.55000000f,0.97000000f,-0.66000000f,-0.52000000f,-0.99000000f,0.14000000f,-0.62000000f,-0.02000000f,0.90000000f,0.78000000f,0.77000000f,-0.05000000f,-0.06000000f,0.51000000f,-0.26000000f,0.64000000f,0.91000000f,0.66000000f,0.52000000f,0.19000000f,0.21000000f,-0.52000000f,0.96000000f,0.71000000f,0.28000000f,-0.89000000f,-0.01000000f,0.83000000f,0.07000000f,0.39000000f,-0.88000000f,0.28000000f,0.68000000f,-0.81000000f,-0.46000000f,0.42000000f,0.47000000f,-0.43000000f,-0.93000000f,0.43000000f,-0.76000000f,0.15000000f,0.88000000f,0.21000000f,0.30000000f,-0.85000000f,-0.26000000f,-0.12000000f,-0.96000000f,-0.84000000f,-0.97000000f,-0.49000000f,0.64000000f,0.42000000f,-0.50000000f,0.87000000f,0.19000000f,-0.13000000f,-0.46000000f,-0.45000000f,-0.95000000f,0.22000000f,0.41000000f,0.83000000f,-0.14000000f,-0.33000000f,0.87000000f,0.76000000f,-0.06000000f,-0.94000000f,0.72000000f,0.73000000f,-0.78000000f,0.90000000f,0.89000000f,0.84000000f,0.90000000f,0.28000000f,0.88000000f,0.86000000f,-0.62000000f,0.02000000f,-0.81000000f,-0.52000000f,-0.82000000f,-0.14000000f,-0.42000000f,-0.30000000f,-0.02000000f,0.79000000f,0.10000000f,-0.58000000f,-0.00000000f,0.95000000f,0.55000000f,-0.75000000f,-0.09000000f,0.36000000f,0.44000000f,0.30000000f,0.03000000f,-0.49000000f,-0.60000000f,0.95000000f,0.86000000f,-0.67000000f,-0.23000000f,0.28000000f,-0.45000000f,-0.58000000f,-0.52000000f,0.77000000f,-0.19000000f,-0.88000000f,-0.16000000f,0.08000000f,0.82000000f,-0.02000000f,0.45000000f,-0.66000000f,0.73000000f,0.94000000f,-0.55000000f,-0.54000000f,0.02000000f,0.62000000f,0.71000000f,-0.99000000f,0.10000000f,-0.06000000f,0.08000000f,0.79000000f,-0.00000000f,-0.77000000f,-0.47000000f,0.42000000f,0.83000000f,0.21000000f,0.08000000f,-0.43000000f,-0.14000000f,0.22000000f,0.32000000f,-0.03000000f,0.11000000f,0.12000000f,-0.64000000f,-0.58000000f,-0.54000000f,-0.08000000f,-0.38000000f,0.41000000f,0.61000000f,-0.65000000f,0.27000000f,0.98000000f,-0.40000000f,-0.13000000f,0.83000000f,0.74000000f,-0.68000000f,0.22000000f,-0.69000000f,0.42000000f,0.77000000f,-0.87000000f,-0.42000000f,-0.77000000f,-0.11000000f,0.25000000f,-0.69000000f,0.84000000f,-0.25000000f,-0.38000000f,-0.56000000f,-0.20000000f,-0.35000000f,0.83000000f,-0.89000000f,-0.51000000f,0.82000000f,-0.77000000f,0.05000000f,0.78000000f,0.71000000f,0.12000000f,-0.82000000f,-0.32000000f,0.09000000f,0.63000000f,0.70000000f,-0.49000000f,0.80000000f,0.25000000f,-0.85000000f,0.04000000f,-0.72000000f,0.56000000f,0.14000000f,0.62000000f,0.17000000f,-0.88000000f,-0.26000000f,0.20000000f,0.72000000f,-0.55000000f,-0.57000000f,-0.33000000f,0.66000000f,-0.12000000f,0.46000000f,-0.14000000f,-0.87000000f,-0.12000000f,0.08000000f,0.92000000f,0.41000000f,0.36000000f,-0.58000000f,-0.17000000f,0.25000000f,-0.97000000f,-0.87000000f,-0.86000000f,-0.43000000f,0.85000000f,-0.38000000f,-0.45000000f,0.47000000f,0.41000000f,0.98000000f,-0.67000000f,-0.13000000f,-0.36000000f,0.08000000f,-0.33000000f,0.92000000f,-0.96000000f,-0.13000000f,0.71000000f,0.77000000f,0.17000000f,-0.03000000f,-0.92000000f,-0.06000000f,0.00000000f,0.29000000f,-0.14000000f,-0.79000000f,0.64000000f,0.53000000f,0.82000000f,-0.02000000f,-0.39000000f,0.94000000f,-0.97000000f,-0.67000000f,-0.98000000f,-0.38000000f,-0.25000000f,-0.76000000f,0.21000000f,0.80000000f,0.24000000f,-0.69000000f,-0.44000000f,-0.80000000f,0.17000000f,-0.87000000f,0.33000000f,0.72000000f,-0.23000000f,-0.39000000f,0.52000000f,-0.39000000f,-0.14000000f,-0.70000000f,0.86000000f,-0.58000000f,0.05000000f,0.82000000f,0.19000000f,0.58000000f,-0.76000000f,0.00000000f,0.09000000f,0.97000000f,-0.60000000f,0.90000000f,-0.73000000f,-0.47000000f,-0.47000000f,0.18000000f,0.93000000f,-0.53000000f,0.71000000f,0.34000000f,0.48000000f,-0.12000000f,0.94000000f,0.12000000f,-0.44000000f,-0.35000000f,-0.93000000f,-0.00000000f,-0.91000000f,0.40000000f,0.37000000f,-0.87000000f,-0.86000000f,0.68000000f,0.55000000f,0.35000000f,-0.30000000f,0.31000000f,-0.37000000f,0.81000000f,0.89000000f,-0.00000000f,-0.72000000f,-0.24000000f,-0.33000000f,-0.09000000f,-0.79000000f,0.41000000f,0.15000000f,-0.30000000f,-0.99000000f,-0.00000000f,-0.07000000f,-0.55000000f,0.22000000f,0.54000000f,-0.15000000f,-0.45000000f,-0.79000000f,-0.75000000f,-0.50000000f,-0.69000000f,-0.59000000f,-0.67000000f,0.70000000f,0.29000000f,0.74000000f,0.83000000f,-0.83000000f,0.41000000f,-0.04000000f,-0.94000000f,0.59000000f,-0.38000000f,0.85000000f,0.34000000f,-0.06000000f,0.08000000f,0.79000000f,0.41000000f,-0.19000000f,-0.15000000f,0.25000000f,-0.66000000f,0.03000000f,0.57000000f,-0.17000000f,0.69000000f,0.32000000f,0.07000000f,-0.95000000f,0.49000000f,0.42000000f,-0.75000000f,0.70000000f,-0.09000000f,-0.98000000f,-0.93000000f,0.40000000f,-0.38000000f,0.36000000f,-0.49000000f,0.65000000f,-0.30000000f,0.14000000f,-0.99000000f,0.66000000f,-0.27000000f,0.94000000f,0.08000000f,-0.70000000f,0.78000000f,-0.93000000f,-0.97000000f,-0.89000000f,-0.94000000f,-0.77000000f,-0.75000000f,-0.87000000f,0.89000000f,-0.25000000f,0.61000000f,0.59000000f,-0.55000000f,-0.73000000f,0.26000000f,0.93000000f,-0.42000000f,0.66000000f,-0.91000000f,-0.72000000f,0.05000000f,0.26000000f,-0.49000000f,-0.00000000f,-0.88000000f,-0.66000000f,0.34000000f,0.93000000f,0.91000000f,0.94000000f,0.25000000f,0.72000000f,0.13000000f,-0.23000000f,-0.67000000f,-0.99000000f,-0.77000000f,0.45000000f,0.33000000f,0.68000000f,0.34000000f,0.43000000f,0.60000000f,0.36000000f,-0.72000000f,-0.56000000f,-0.41000000f,-0.72000000f,0.65000000f,0.34000000f,0.91000000f,0.95000000f,-0.90000000f,-0.85000000f,0.91000000f,0.80000000f,-0.60000000f,-0.96000000f,0.29000000f,-0.36000000f,-0.54000000f,0.81000000f,-0.95000000f,-0.54000000f,0.67000000f,0.13000000f,0.16000000f,0.73000000f,0.92000000f,0.00000000f,0.08000000f,-0.05000000f,0.84000000f,-0.42000000f,-0.82000000f,-0.31000000f,-0.82000000f,-0.14000000f,-0.65000000f,-0.15000000f,0.55000000f,0.56000000f,-0.93000000f,-0.06000000f,0.59000000f,0.48000000f,0.60000000f,0.08000000f,-0.81000000f,-0.72000000f,-0.69000000f,-0.19000000f,0.02000000f,0.25000000f,-0.38000000f,-0.41000000f,0.31000000f,-0.84000000f,-0.09000000f,0.64000000f,0.62000000f,-0.00000000f,0.78000000f,-0.87000000f,-0.50000000f,-0.85000000f,0.61000000f,-0.90000000f,0.96000000f,0.51000000f,0.99000000f,-0.33000000f,-0.44000000f,-0.23000000f,-0.27000000f,-0.03000000f,-0.75000000f,0.12000000f,-0.78000000f,-0.25000000f,0.44000000f,0.49000000f,0.33000000f,0.33000000f,-0.77000000f,-0.35000000f,-0.39000000f,-0.49000000f,0.00000000f,-0.20000000f,-0.06000000f,-0.78000000f,0.41000000f,0.31000000f,0.62000000f,-0.78000000f,-0.36000000f,0.98000000f,-0.03000000f,-0.41000000f,-0.01000000f,-0.81000000f,0.30000000f,-0.81000000f,0.60000000f,-0.05000000f,0.20000000f,0.70000000f,0.81000000f,0.64000000f,0.78000000f,0.84000000f,0.07000000f,0.86000000f,0.72000000f,0.59000000f,-0.58000000f,-0.85000000f,0.23000000f,0.03000000f,-0.40000000f,-0.29000000f,-0.16000000f,0.59000000f,0.79000000f,0.07000000f,-0.29000000f,0.45000000f,-0.94000000f,-0.48000000f,-0.65000000f,0.57000000f,0.43000000f,-0.31000000f,-0.18000000f,-0.83000000f,-0.85000000f,-0.27000000f,0.28000000f,0.58000000f,-0.07000000f,0.74000000f,0.09000000f,-0.80000000f,0.93000000f,-0.84000000f,0.74000000f,0.37000000f,0.85000000f,0.70000000f,-0.95000000f,0.35000000f,-0.81000000f,-0.54000000f,0.81000000f,0.05000000f,0.02000000f,0.47000000f,-0.70000000f,0.45000000f,0.44000000f,-0.12000000f,0.46000000f,-0.76000000f,0.42000000f,-0.38000000f,-0.47000000f,-0.80000000f,-0.96000000f,-0.97000000f,-0.95000000f,-0.91000000f,0.79000000f,-0.41000000f,-0.87000000f,0.60000000f,0.72000000f,0.19000000f,0.45000000f,0.99000000f,-0.02000000f,-0.70000000f,-0.89000000f,-0.75000000f,-0.54000000f,0.11000000f,-0.69000000f,0.94000000f,-0.86000000f,-0.34000000f,-0.79000000f,-0.75000000f,0.84000000f,-0.56000000f,0.63000000f,0.22000000f,-0.69000000f,0.34000000f,0.34000000f,0.38000000f,0.03000000f,0.43000000f,-0.38000000f,-0.70000000f,-0.34000000f,-0.01000000f,-0.47000000f,-0.88000000f,0.97000000f,-0.99000000f,0.33000000f,-0.79000000f,-0.79000000f,-0.78000000f,-0.14000000f,-0.58000000f,-0.93000000f,0.41000000f,0.14000000f,0.40000000f,-0.06000000f,0.31000000f,-0.69000000f,-0.83000000f,0.29000000f,0.08000000f,0.66000000f,0.71000000f,0.11000000f,0.28000000f,0.98000000f,0.94000000f,0.11000000f,0.91000000f,0.05000000f,-0.07000000f,0.33000000f,-0.97000000f,0.48000000f,-0.77000000f,0.93000000f,0.68000000f,-0.00000000f,0.36000000f,0.37000000f,-0.76000000f,0.51000000f,0.55000000f,-0.92000000f,0.15000000f,0.84000000f,-0.82000000f,0.02000000f,-0.15000000f,0.06000000f,0.05000000f,-0.10000000f,-0.57000000f,0.93000000f,0.03000000f,-0.61000000f,0.47000000f,-0.23000000f,0.39000000f,-0.54000000f,0.33000000f,-0.48000000f,0.45000000f,0.65000000f,0.64000000f,0.35000000f,0.64000000f,-0.39000000f,0.15000000f,0.54000000f,0.97000000f,-0.12000000f,-0.88000000f,0.57000000f,0.95000000f,0.91000000f,0.83000000f,0.64000000f,-0.16000000f,-0.85000000f,0.52000000f,0.03000000f,0.81000000f,0.10000000f,0.47000000f,0.39000000f,-0.66000000f,0.86000000f,0.69000000f,0.29000000f,-0.43000000f,-0.76000000f,0.58000000f,-0.76000000f,-0.89000000f,-0.12000000f,0.37000000f,0.83000000f,-0.02000000f,0.36000000f,0.79000000f,-0.29000000f,0.63000000f,0.18000000f,-0.24000000f,0.62000000f,-0.07000000f,-0.25000000f,0.07000000f,-0.17000000f,-0.60000000f,-0.66000000f,-0.21000000f,0.83000000f,0.04000000f,-0.63000000f,-0.35000000f,0.00000000f,0.22000000f,0.05000000f,-0.18000000f,0.26000000f,0.49000000f,0.51000000f,0.54000000f,-0.43000000f,0.10000000f,0.07000000f,-0.70000000f,0.69000000f,-0.19000000f,-0.24000000f,0.94000000f,0.22000000f,0.16000000f,-0.23000000f,-0.81000000f,-0.72000000f,0.58000000f,0.44000000f,-0.58000000f,-0.89000000f,0.59000000f,0.64000000f,0.72000000f,0.43000000f,0.82000000f,-0.57000000f,0.69000000f,0.27000000f,-0.20000000f,0.24000000f,0.07000000f,0.41000000f,-0.49000000f,0.72000000f,0.27000000f,-0.40000000f,0.11000000f,-0.58000000f,0.78000000f,-0.71000000f,0.97000000f,0.12000000f,0.00000000f,0.76000000f,0.77000000f,-0.70000000f,-0.13000000f,-0.41000000f,0.57000000f,0.42000000f,0.48000000f,0.59000000f,0.47000000f,0.16000000f,-0.10000000f,0.80000000f,0.53000000f,0.50000000f,-0.34000000f,0.78000000f,-0.20000000f,-0.70000000f,0.56000000f,-0.23000000f,-0.11000000f,-0.51000000f,0.44000000f,0.21000000f,-0.59000000f,0.08000000f,-0.43000000f,-0.87000000f,-0.60000000f,-0.35000000f,0.79000000f,-0.62000000f,-0.85000000f,-0.39000000f,-0.39000000f,-0.74000000f,0.80000000f,-0.19000000f,-0.93000000f,0.55000000f,-0.26000000f,-0.86000000f,-0.62000000f,-0.00000000f,-0.20000000f,-0.11000000f,0.95000000f,-0.27000000f,0.59000000f,0.61000000f,-0.78000000f,-0.64000000f,-0.09000000f,-0.51000000f,0.10000000f,0.83000000f,-0.22000000f,0.37000000f,0.40000000f,-0.74000000f,-0.68000000f,-0.22000000f,-0.36000000f,-0.82000000f,0.29000000f,0.29000000f,-0.04000000f,0.88000000f,-0.62000000f,0.49000000f,0.89000000f,-0.87000000f,0.30000000f,0.90000000f,0.54000000f,0.07000000f,-0.52000000f,-0.82000000f,0.65000000f,0.28000000f,0.73000000f,0.43000000f,0.34000000f,0.24000000f,-0.61000000f,-0.20000000f,-0.07000000f,0.85000000f,0.34000000f,-0.33000000f,0.14000000f,0.64000000f,-0.58000000f,0.32000000f,-0.46000000f,0.07000000f,0.88000000f,0.64000000f,0.12000000f,-0.26000000f,-0.11000000f,0.72000000f,-0.58000000f,-0.58000000f,-0.95000000f,0.38000000f,0.11000000f,-0.01000000f,0.15000000f,-0.10000000f,0.50000000f,0.66000000f,0.60000000f,-0.81000000f,0.75000000f,0.48000000f,0.65000000f,-0.83000000f,-0.81000000f,-0.92000000f,-0.31000000f,0.81000000f,-0.35000000f,0.49000000f,0.95000000f,-0.99000000f,0.17000000f,0.34000000f,0.60000000f,0.65000000f,-0.49000000f,-0.18000000f,-0.09000000f,0.35000000f,0.06000000f,0.92000000f,0.78000000f,-0.18000000f,-0.66000000f,0.46000000f,0.58000000f,-0.56000000f,-0.45000000f,0.63000000f,0.03000000f,0.28000000f,-0.84000000f,0.39000000f,0.06000000f,0.85000000f,0.04000000f,-0.50000000f,0.53000000f,0.62000000f,0.46000000f,-0.86000000f,-0.90000000f,-0.72000000f,0.12000000f,0.05000000f,-0.39000000f,-0.41000000f,0.59000000f,-0.19000000f,-0.22000000f,0.50000000f,0.32000000f,0.83000000f,-0.33000000f,-0.83000000f,-0.81000000f,-0.46000000f,-0.63000000f,-0.58000000f,-0.78000000f,-0.49000000f,-0.78000000f,0.19000000f,0.69000000f,-0.66000000f,0.27000000f,-0.10000000f,-0.09000000f,0.88000000f,0.08000000f,0.53000000f,-0.64000000f,-0.38000000f,0.46000000f,-0.64000000f,-0.55000000f,0.33000000f,-0.41000000f,-0.80000000f,0.11000000f,0.37000000f,-0.05000000f,-0.73000000f,-0.57000000f,0.93000000f,0.90000000f,-0.60000000f,0.93000000f,0.81000000f,0.94000000f,0.23000000f,0.06000000f,0.68000000f,-0.06000000f,-0.91000000f,-0.05000000f,0.40000000f,-0.11000000f,-0.83000000f,-0.67000000f,0.96000000f,-0.89000000f,-0.56000000f,0.96000000f,0.82000000f,-0.29000000f,0.80000000f,0.42000000f,0.23000000f,-0.05000000f,-0.06000000f,0.16000000f,-0.54000000f,0.08000000f,0.69000000f,0.97000000f,0.19000000f,-0.65000000f,0.87000000f,0.70000000f,0.67000000f,0.44000000f,0.10000000f,-0.12000000f,0.97000000f,0.07000000f,0.92000000f,-0.00000000f,-0.58000000f,-0.44000000f,0.66000000f,-0.63000000f,-0.32000000f,0.08000000f,0.53000000f,-0.11000000f,0.80000000f,-0.35000000f,0.98000000f,-0.66000000f,-0.63000000f,-0.80000000f,0.87000000f,-0.82000000f,0.09000000f,0.95000000f,-0.25000000f,-0.15000000f,0.72000000f,-0.97000000f,-0.45000000f,0.96000000f,0.49000000f,0.92000000f,-0.19000000f,-0.10000000f,-0.12000000f,-0.00000000f,-0.96000000f,0.76000000f,0.99000000f,-0.37000000f,0.84000000f,0.66000000f,-0.63000000f,-0.41000000f,0.37000000f,-0.29000000f,0.69000000f,0.61000000f,0.54000000f,-0.95000000f,0.97000000f,0.76000000f,0.02000000f,0.06000000f,0.83000000f,-0.94000000f,-0.77000000f,0.04000000f,-0.25000000f,0.57000000f,0.75000000f,0.46000000f,-0.96000000f,-0.49000000f,0.76000000f,0.35000000f,-0.80000000f,-0.74000000f,0.52000000f,-0.57000000f,-0.38000000f,-0.75000000f,-0.88000000f,0.76000000f,-0.69000000f,0.22000000f,-0.64000000f,0.65000000f,0.79000000f,-0.79000000f,0.78000000f,-0.13000000f,0.07000000f,-0.98000000f,0.63000000f,0.94000000f,-0.54000000f,0.52000000f,0.02000000f,-0.64000000f,-0.05000000f,0.04000000f,-0.91000000f,-0.05000000f,-0.54000000f,0.67000000f,0.44000000f,-0.43000000f,-0.37000000f,0.03000000f,0.37000000f,-0.51000000f,-0.36000000f,0.21000000f,0.65000000f,-0.62000000f,0.20000000f,-0.90000000f,-0.37000000f,-0.11000000f,-0.40000000f,-0.11000000f,0.50000000f,0.81000000f,0.46000000f,0.03000000f,-0.09000000f,0.05000000f,-0.20000000f,0.98000000f,0.45000000f,0.26000000f,-0.15000000f,-0.40000000f,0.70000000f,-0.17000000f,-0.59000000f,-0.23000000f,-0.80000000f,0.65000000f,-0.47000000f,0.39000000f,0.68000000f,-0.64000000f,0.15000000f,-0.89000000f,0.98000000f,-0.36000000f,0.15000000f,-0.59000000f,0.88000000f,0.47000000f,-0.01000000f,0.26000000f,-0.94000000f,0.39000000f,-0.76000000f,-0.43000000f,-0.29000000f,-0.88000000f,-0.52000000f,-0.42000000f,0.12000000f,-0.56000000f,0.09000000f,0.38000000f,0.32000000f,-0.22000000f,-0.29000000f,-0.46000000f,0.59000000f,-0.96000000f,0.30000000f,0.95000000f,-0.76000000f,-0.90000000f,-0.76000000f,0.56000000f,0.35000000f,-0.76000000f,0.42000000f,-0.72000000f,-0.67000000f,0.74000000f,-0.60000000f,0.90000000f,0.74000000f,-0.87000000f,-0.36000000f,-0.12000000f,0.29000000f,-0.83000000f,0.60000000f,0.35000000f,0.44000000f,-0.50000000f,0.19000000f,0.19000000f,0.42000000f,-0.47000000f,-0.50000000f,-0.35000000f,0.49000000f,0.41000000f,-0.19000000f,-0.08000000f,-0.70000000f,0.76000000f,-0.44000000f,0.69000000f,0.16000000f,-0.01000000f,0.56000000f,-0.85000000f,-0.11000000f,-0.87000000f,0.11000000f,0.17000000f,-0.05000000f,0.50000000f,0.24000000f,-0.47000000f,0.57000000f,0.59000000f,-0.90000000f,0.95000000f,-0.05000000f,0.02000000f,0.51000000f,0.82000000f,0.28000000f,0.91000000f,-0.59000000f,0.65000000f,-0.42000000f,-0.82000000f,0.84000000f,-0.31000000f,-0.41000000f,0.75000000f,0.68000000f,-0.67000000f,0.52000000f,-0.18000000f,0.79000000f,-0.38000000f,0.63000000f,0.33000000f,-0.93000000f,-0.59000000f,0.76000000f,-0.60000000f,0.03000000f,-0.77000000f,-0.34000000f,0.17000000f,-0.35000000f,0.81000000f,0.50000000f,0.82000000f,0.57000000f,0.61000000f,-0.38000000f,0.69000000f,0.69000000f,0.75000000f,-0.61000000f,-0.73000000f,0.53000000f,0.66000000f,-0.83000000f,-0.69000000f,0.67000000f,-0.41000000f,0.84000000f,-0.23000000f,0.70000000f,0.95000000f,0.66000000f,0.81000000f,0.64000000f,-0.55000000f,-0.80000000f,0.45000000f,-0.11000000f,-0.77000000f,-0.47000000f,-0.36000000f,-0.41000000f,-0.82000000f,-0.60000000f,-0.32000000f,-0.58000000f,0.49000000f,0.32000000f,-0.38000000f,0.35000000f,-0.88000000f,-0.11000000f,0.49000000f,0.24000000f,0.97000000f,0.68000000f,0.90000000f,0.62000000f,-0.40000000f,0.94000000f,-0.16000000f,-0.57000000f,-0.00000000f,-0.18000000f,0.55000000f,-0.88000000f,0.95000000f,-0.49000000f,-0.75000000f,0.54000000f,0.45000000f,0.03000000f,0.59000000f,0.17000000f,-0.22000000f,-0.44000000f,-0.63000000f,0.69000000f,0.08000000f,0.06000000f,-0.43000000f,0.00000000f,-0.50000000f,-0.86000000f,-0.48000000f,0.91000000f,-0.19000000f,-0.18000000f,-0.61000000f,0.85000000f,-0.41000000f,-0.73000000f,0.83000000f,-0.86000000f,0.66000000f,0.94000000f,-0.02000000f,-0.07000000f,0.21000000f,-0.68000000f,-0.33000000f,-0.40000000f,0.13000000f,-0.11000000f,0.59000000f,-0.91000000f,-0.28000000f,0.72000000f,0.18000000f,0.46000000f,-0.20000000f,-0.36000000f,-0.93000000f,-0.38000000f,0.91000000f,-0.03000000f,-0.85000000f,-0.05000000f,0.23000000f,-0.03000000f,-0.28000000f,0.68000000f,0.93000000f,0.07000000f,0.69000000f,-0.76000000f,-0.55000000f,0.42000000f,-0.27000000f,-0.28000000f,0.39000000f,-0.02000000f,0.95000000f,-0.43000000f,0.38000000f,0.70000000f,0.93000000f,-0.55000000f,-0.25000000f,-0.72000000f,-0.44000000f,0.97000000f,-0.72000000f,-0.24000000f,-0.66000000f,-0.99000000f,-0.29000000f,-0.93000000f,0.97000000f,0.64000000f,0.65000000f,0.95000000f,0.58000000f,0.13000000f,0.18000000f,0.42000000f,-0.38000000f,0.11000000f,0.60000000f,0.30000000f,-0.01000000f,0.79000000f,-0.31000000f,-0.70000000f,0.23000000f,-0.17000000f,-0.58000000f,-0.82000000f,0.13000000f,-0.75000000f,-0.44000000f,0.99000000f,0.26000000f,-0.55000000f,0.12000000f,-0.40000000f,0.85000000f,-0.93000000f,0.28000000f,-0.78000000f,-0.94000000f,0.99000000f,-0.71000000f,0.55000000f,-0.30000000f,0.20000000f,0.33000000f,-0.84000000f,-0.93000000f,-0.49000000f,-0.83000000f,-0.30000000f,-0.44000000f,-0.14000000f,0.96000000f,-0.71000000f,-0.68000000f,0.60000000f,0.74000000f,-0.86000000f,-0.10000000f,-0.04000000f,0.07000000f,-0.30000000f,0.28000000f,-0.10000000f,0.15000000f,-0.34000000f,0.94000000f,0.71000000f,0.17000000f,-0.48000000f,-0.53000000f,0.93000000f,0.73000000f,0.29000000f,-0.17000000f,-0.34000000f,-0.61000000f,-0.93000000f,0.94000000f,-0.14000000f,0.27000000f,0.49000000f,0.78000000f,-0.69000000f,0.36000000f,0.38000000f,0.49000000f,-0.93000000f,0.83000000f,-0.85000000f,0.51000000f,0.43000000f,0.61000000f,0.40000000f,-0.95000000f,-0.81000000f,0.09000000f,-0.87000000f,-0.42000000f,-0.85000000f,0.34000000f,-0.43000000f,0.72000000f,-0.40000000f,-0.51000000f,-0.39000000f,-0.50000000f,-0.74000000f,0.91000000f,0.49000000f,0.92000000f,0.84000000f,0.68000000f,-0.63000000f,-0.77000000f,0.25000000f,0.63000000f,-0.60000000f,0.32000000f,-0.94000000f,0.69000000f,-0.81000000f,0.55000000f,0.07000000f,0.58000000f,-0.76000000f,-0.82000000f,0.53000000f,-0.87000000f,-0.97000000f,-0.92000000f,-0.19000000f,0.12000000f,-0.70000000f,0.05000000f,0.99000000f,-0.88000000f,-0.76000000f,-0.81000000f,-0.81000000f,0.94000000f,-0.22000000f,0.44000000f,0.10000000f,-0.09000000f,0.34000000f,-0.72000000f,-0.19000000f,-0.44000000f,0.29000000f,0.74000000f,0.45000000f,0.77000000f,0.36000000f,0.37000000f,-0.59000000f,0.46000000f,0.41000000f,-0.86000000f,-0.10000000f,-0.42000000f,0.66000000f,0.11000000f,0.50000000f,0.17000000f,0.78000000f,0.92000000f,0.93000000f,0.64000000f,0.61000000f,0.53000000f,-0.51000000f,0.75000000f,-0.89000000f,-0.01000000f,0.50000000f,-0.27000000f,-0.40000000f,0.06000000f,0.66000000f,-0.02000000f,-0.70000000f,-0.13000000f,0.03000000f,-0.72000000f,-0.64000000f,0.67000000f,0.12000000f,-0.97000000f,0.97000000f,-0.74000000f,-0.56000000f,-0.11000000f,0.81000000f,-0.13000000f,-0.32000000f,0.06000000f,0.10000000f,0.77000000f,-0.80000000f,-0.68000000f,-0.14000000f,-0.53000000f,-0.70000000f,-0.18000000f,-0.37000000f,-0.61000000f,0.12000000f,0.65000000f,0.40000000f,-0.16000000f,-0.92000000f,0.92000000f,0.94000000f,-0.20000000f,-0.24000000f,0.33000000f,-0.75000000f,0.83000000f,0.67000000f,-0.10000000f,-0.18000000f,0.84000000f,-0.23000000f,-0.80000000f,0.77000000f,-0.80000000f,0.60000000f,-0.51000000f,0.64000000f,-0.63000000f,0.89000000f,-0.61000000f,0.00000000f,0.43000000f,0.86000000f,0.23000000f,-0.51000000f,0.05000000f,-0.23000000f,0.05000000f,0.32000000f,0.36000000f,0.78000000f,0.12000000f,-0.52000000f,0.52000000f,-0.86000000f,-0.37000000f,-0.63000000f,0.50000000f,-0.82000000f,-0.93000000f,0.49000000f,-0.20000000f,-0.35000000f,0.20000000f,-0.03000000f,0.09000000f,0.01000000f,0.26000000f,0.14000000f,0.82000000f,0.15000000f,0.26000000f,-0.83000000f,-0.22000000f,0.36000000f,0.26000000f,-0.40000000f,0.90000000f,0.87000000f,-0.96000000f,0.87000000f,0.73000000f,0.67000000f,0.08000000f,0.46000000f,0.59000000f,0.59000000f,0.82000000f,0.99000000f,-0.13000000f,0.18000000f,-0.04000000f,0.60000000f,-0.60000000f,0.84000000f,-0.80000000f,-0.54000000f,0.40000000f,-0.57000000f,-0.43000000f,-0.08000000f,-0.09000000f,0.62000000f,0.58000000f,0.89000000f,-0.38000000f,0.07000000f,-0.72000000f,-0.15000000f,0.20000000f,0.34000000f,-0.81000000f,-0.04000000f,-0.06000000f,0.77000000f,-0.95000000f,-0.99000000f,-0.05000000f,-0.13000000f,-0.37000000f,-0.21000000f,-0.31000000f,-0.77000000f,-0.82000000f,0.67000000f,0.71000000f,0.03000000f,0.98000000f,0.46000000f,-0.87000000f,0.55000000f,-0.14000000f,0.14000000f,0.26000000f,0.05000000f,0.31000000f,0.67000000f,-0.00000000f,-0.49000000f,-0.71000000f,-0.75000000f,-0.66000000f,0.27000000f,-0.29000000f,0.04000000f,-0.91000000f,0.02000000f,-0.68000000f,-0.03000000f,-0.47000000f,0.34000000f,-0.89000000f,-0.98000000f,-0.00000000f,0.11000000f,-0.52000000f,0.28000000f,-0.42000000f,0.60000000f,0.28000000f,0.42000000f,0.91000000f,-0.09000000f,0.23000000f,-0.44000000f,-0.39000000f,-0.20000000f,0.61000000f,0.82000000f,-0.43000000f,0.57000000f,0.15000000f,-0.03000000f,-0.71000000f,-0.19000000f,0.56000000f,0.54000000f,0.99000000f,-0.59000000f,-0.76000000f,-0.90000000f,0.05000000f,0.00000000f,-0.56000000f,-0.85000000f,-0.74000000f,0.31000000f,-0.92000000f,0.38000000f,0.13000000f,0.44000000f,0.94000000f,0.95000000f,0.35000000f,0.18000000f,0.35000000f,-0.16000000f,0.15000000f,0.21000000f,-0.90000000f,0.80000000f,0.50000000f,-0.68000000f,-0.20000000f,-0.99000000f,0.20000000f,0.71000000f,0.65000000f,0.46000000f,0.21000000f,0.19000000f,-0.64000000f,0.79000000f,-0.23000000f,0.69000000f,-0.71000000f,0.29000000f,-0.55000000f,0.61000000f,-0.31000000f,0.18000000f,-0.00000000f,0.40000000f,-0.89000000f,-0.38000000f,-0.08000000f,-0.43000000f,-0.87000000f,0.53000000f,-0.05000000f,0.55000000f,0.80000000f,-0.60000000f,-0.87000000f,-0.15000000f,-0.22000000f,-0.55000000f,-0.41000000f,-0.43000000f,0.69000000f,0.32000000f,-0.10000000f,-0.29000000f,0.26000000f,0.88000000f,-0.86000000f,-0.16000000f,-0.36000000f,-0.94000000f,0.47000000f,-0.75000000f,-0.15000000f,-0.10000000f,0.97000000f,0.93000000f,0.39000000f,0.29000000f,0.12000000f,0.49000000f,-0.38000000f,0.22000000f,0.24000000f,-0.33000000f,0.18000000f,0.37000000f,-0.80000000f,-0.77000000f,0.28000000f,-0.26000000f,0.05000000f,0.60000000f,-0.85000000f,-0.14000000f,0.90000000f,-0.44000000f,0.36000000f,-0.85000000f,-0.89000000f,0.36000000f,-0.93000000f,0.44000000f,-0.95000000f,-0.18000000f,0.62000000f,-0.50000000f,-0.58000000f,-0.08000000f,0.84000000f,0.33000000f,-0.96000000f,0.92000000f,0.41000000f,-0.61000000f,0.90000000f,0.09000000f,-0.70000000f,-0.73000000f,-0.64000000f,-0.09000000f,-0.09000000f,-0.42000000f,-0.90000000f,0.61000000f,0.71000000f,0.82000000f,-0.42000000f,0.56000000f,0.97000000f,0.64000000f,-0.49000000f,-0.22000000f,-0.94000000f,0.24000000f,-0.29000000f,-0.88000000f,-0.54000000f,0.97000000f,-0.76000000f,0.66000000f,-0.71000000f,-0.64000000f,-0.64000000f,-0.53000000f,0.20000000f,0.23000000f,-0.56000000f,-0.62000000f,-0.55000000f,0.18000000f,0.18000000f,-0.77000000f,0.19000000f,-0.68000000f,0.89000000f,0.50000000f,0.42000000f,-0.10000000f,-0.28000000f,0.41000000f,-0.39000000f,-0.51000000f,0.70000000f,-0.98000000f,0.44000000f,0.04000000f,-0.46000000f,-0.63000000f,-0.93000000f,-0.31000000f,0.41000000f,0.35000000f,0.53000000f,0.77000000f,0.60000000f,0.26000000f,-0.21000000f,0.82000000f,-0.92000000f,0.92000000f,-0.70000000f,-0.10000000f,0.64000000f,-0.83000000f,-0.55000000f,0.61000000f,0.77000000f,-0.72000000f,-0.30000000f,-0.85000000f,0.33000000f,-0.60000000f,0.19000000f,0.86000000f,0.70000000f,0.77000000f,0.21000000f,0.86000000f,0.04000000f,0.22000000f,0.95000000f,0.57000000f,0.36000000f,-0.41000000f,0.37000000f,-0.17000000f,0.29000000f,0.70000000f,-0.40000000f,-0.39000000f,-0.83000000f,-0.11000000f,0.84000000f,-0.43000000f,-0.48000000f,0.13000000f,-0.27000000f,-0.75000000f,-0.54000000f,0.79000000f,0.75000000f,-0.85000000f,0.90000000f,-0.41000000f,0.24000000f,0.29000000f,0.61000000f,0.69000000f,-0.03000000f,-0.72000000f,-0.36000000f,-0.33000000f,-0.32000000f,-0.11000000f,0.19000000f,-0.84000000f,-0.24000000f,-0.77000000f,-0.96000000f,0.70000000f,0.04000000f,0.95000000f,-0.97000000f,-0.11000000f,-0.24000000f,0.69000000f,-0.13000000f,0.85000000f,0.43000000f,-0.41000000f,-0.89000000f,0.70000000f,0.09000000f,-0.63000000f,0.57000000f,0.80000000f,0.56000000f,-0.62000000f,0.32000000f,-0.28000000f,0.54000000f,0.14000000f,-0.67000000f,-0.24000000f,-0.79000000f,0.23000000f,-0.95000000f,-0.16000000f,-0.85000000f,-0.18000000f,0.46000000f,-0.60000000f,0.36000000f,0.22000000f,-0.08000000f,0.15000000f,0.62000000f,-0.20000000f,0.88000000f,-0.26000000f,-0.13000000f,-0.11000000f,0.56000000f,0.17000000f,0.67000000f,-0.56000000f,0.49000000f,0.87000000f,-0.35000000f,-0.73000000f,-0.93000000f,-0.80000000f,-0.06000000f,-0.95000000f,-0.36000000f,-0.26000000f,0.34000000f,0.19000000f,0.57000000f,0.56000000f,-0.65000000f,0.60000000f,0.94000000f,0.86000000f,-0.16000000f,-0.95000000f,0.36000000f,0.12000000f,-0.42000000f,0.34000000f,0.75000000f,-0.14000000f,0.15000000f,0.03000000f,-0.17000000f,0.70000000f,0.95000000f,0.95000000f,0.79000000f,0.11000000f,-0.82000000f,-0.30000000f,0.75000000f,-0.72000000f,-0.91000000f,0.31000000f,-0.07000000f,0.42000000f,0.85000000f,0.00000000f,-0.47000000f,0.37000000f,-0.62000000f,0.22000000f,0.10000000f,0.75000000f,-0.15000000f,-0.13000000f,0.18000000f,-0.21000000f,0.45000000f,-0.35000000f,0.77000000f,-0.40000000f,-0.75000000f,0.59000000f,0.87000000f,-0.62000000f,-0.91000000f,0.55000000f,-0.09000000f,0.06000000f,0.30000000f,0.52000000f,-0.51000000f,-0.03000000f,0.89000000f,-0.05000000f,0.88000000f,0.83000000f,-0.66000000f,-0.01000000f,0.34000000f,-0.83000000f,0.60000000f,0.47000000f,0.65000000f,0.51000000f,0.70000000f,0.62000000f,0.99000000f,0.34000000f,0.41000000f,-0.31000000f,0.75000000f,0.61000000f,0.04000000f,0.54000000f,-0.42000000f,0.47000000f,-0.43000000f,0.39000000f,-0.58000000f,-0.44000000f,-0.02000000f,-0.08000000f,0.38000000f,-0.77000000f,-0.55000000f,-0.20000000f,0.63000000f,-0.93000000f,-0.96000000f,-0.04000000f,-0.26000000f,0.83000000f,0.34000000f,0.31000000f,-0.32000000f,0.37000000f,-0.74000000f,0.60000000f,-0.77000000f,-0.04000000f,0.65000000f,0.94000000f,-0.39000000f,0.01000000f,-0.76000000f,-0.25000000f,0.44000000f,0.87000000f,0.06000000f,-0.58000000f,-0.21000000f,0.67000000f,-0.97000000f,0.22000000f,0.24000000f,-0.16000000f,0.82000000f,-0.19000000f,0.66000000f,0.00000000f,0.50000000f,-0.85000000f,0.32000000f,-0.66000000f,0.11000000f,-0.48000000f,0.66000000f,-0.60000000f,-0.50000000f,0.29000000f,-0.93000000f,0.94000000f,-0.02000000f,0.41000000f,-0.13000000f,-0.04000000f,0.77000000f,0.31000000f,-0.23000000f,0.84000000f,0.25000000f,-0.48000000f,-0.51000000f,0.19000000f,-0.42000000f,-0.03000000f,-0.13000000f,0.78000000f,0.76000000f,0.23000000f,0.63000000f,0.23000000f,-0.82000000f,0.41000000f,0.10000000f,0.73000000f,0.49000000f,-0.94000000f,0.80000000f,-0.40000000f,0.78000000f,-0.12000000f,-0.49000000f,-0.80000000f,0.37000000f,0.96000000f,0.22000000f,-0.93000000f,0.78000000f,-0.74000000f,-0.71000000f,0.46000000f,-0.38000000f,0.86000000f,0.03000000f,0.48000000f,0.22000000f,-0.05000000f,0.13000000f,0.91000000f,-0.20000000f,0.36000000f,0.64000000f,0.26000000f,0.38000000f,-0.10000000f,0.57000000f,-0.14000000f,-0.72000000f,0.08000000f,0.55000000f,-0.91000000f,0.62000000f,0.27000000f,-0.49000000f,-0.22000000f,0.22000000f,-0.12000000f,-0.32000000f,-0.28000000f,0.15000000f,-0.92000000f,0.58000000f,-0.51000000f,-0.07000000f,-0.45000000f,-0.24000000f,-0.73000000f,0.63000000f,-0.70000000f,-0.11000000f,-0.46000000f,-0.75000000f,-0.58000000f,-0.15000000f,0.38000000f,-0.22000000f,0.23000000f,-0.26000000f,0.41000000f,0.14000000f,0.87000000f,0.44000000f,0.26000000f,0.79000000f,0.28000000f,0.19000000f,0.06000000f,0.84000000f,0.19000000f,0.91000000f,-0.25000000f,0.24000000f,0.07000000f,-0.46000000f,-0.57000000f,0.86000000f,0.98000000f,-0.33000000f,0.77000000f,0.04000000f,0.55000000f,-0.04000000f,-0.72000000f,-0.44000000f,0.36000000f,-0.73000000f,0.74000000f,-0.86000000f,0.71000000f,0.89000000f,-0.94000000f,-0.03000000f,0.07000000f,0.12000000f,-0.14000000f,-0.20000000f,-0.71000000f,-0.51000000f,-0.23000000f,-0.35000000f,-0.89000000f,0.75000000f,-0.95000000f,-0.48000000f,-0.34000000f,-0.16000000f,0.45000000f,0.34000000f,-0.50000000f,-0.82000000f,0.12000000f,0.18000000f,0.35000000f,-0.26000000f,-0.16000000f,-0.98000000f,0.80000000f,0.58000000f,-0.65000000f,-0.17000000f,0.77000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.43000000f,-0.88000000f,0.08000000f,0.23000000f,-0.70000000f,-0.69000000f,-0.76000000f,-0.11000000f,0.44000000f,-0.87000000f,0.70000000f,-0.73000000f,-0.55000000f,0.05000000f,0.30000000f,-0.02000000f,0.19000000f,0.20000000f,0.14000000f,0.08000000f,0.16000000f,0.44000000f,0.58000000f,-0.51000000f,-0.63000000f,0.32000000f,0.98000000f,-0.48000000f,-0.66000000f,-0.00000000f,-0.83000000f,0.39000000f,-0.95000000f,-0.32000000f,-0.28000000f,0.60000000f,0.59000000f,-0.94000000f,0.34000000f,-0.68000000f,-0.62000000f,0.46000000f,-0.87000000f,0.25000000f,-0.00000000f,0.12000000f,0.38000000f,0.69000000f,-0.54000000f,0.11000000f,0.03000000f,-0.76000000f,0.92000000f,0.52000000f,-0.33000000f,-0.36000000f,-0.33000000f,0.46000000f,-0.60000000f,0.33000000f,-0.56000000f,-0.77000000f,0.13000000f,0.31000000f,-0.65000000f,-0.67000000f,-0.58000000f,0.54000000f,0.41000000f,0.80000000f,-0.92000000f,0.77000000f,-0.44000000f,0.69000000f,-0.60000000f,0.13000000f,-0.82000000f,0.13000000f,0.27000000f,-0.36000000f,-0.88000000f,-0.77000000f,-0.72000000f,-0.94000000f,0.69000000f,0.18000000f,-0.29000000f,-0.12000000f,-0.81000000f,-0.51000000f,0.72000000f,-0.03000000f,0.32000000f,-0.25000000f,-0.83000000f,0.11000000f,0.14000000f,-0.76000000f,-0.62000000f,0.51000000f,0.87000000f,0.76000000f,-0.23000000f,0.52000000f,0.89000000f,-0.02000000f,-0.57000000f,0.81000000f,-0.83000000f,-0.10000000f,-0.88000000f,0.71000000f,0.30000000f,-0.66000000f,-0.38000000f,-0.56000000f,0.37000000f,0.02000000f,0.08000000f,-0.88000000f,-0.86000000f,0.01000000f,-0.61000000f,-0.44000000f,0.60000000f,0.34000000f,-0.90000000f,-0.50000000f,-0.11000000f,0.52000000f,-0.76000000f,0.04000000f,-0.53000000f,-0.10000000f,0.03000000f,0.07000000f,0.32000000f,0.98000000f,0.28000000f,0.13000000f,0.05000000f,0.62000000f,-0.15000000f,-0.39000000f,0.04000000f,-0.81000000f,0.84000000f,-0.48000000f,0.56000000f,-0.74000000f,0.39000000f,0.79000000f,-0.40000000f,-0.67000000f,-0.52000000f,0.67000000f,-0.68000000f,-0.55000000f,-0.65000000f,0.36000000f,0.27000000f,-0.14000000f,-0.14000000f,-0.58000000f,0.34000000f,0.14000000f,-0.33000000f,-0.67000000f,0.92000000f,-0.73000000f,-0.29000000f,0.96000000f,-0.43000000f,-0.85000000f,0.96000000f,0.65000000f,0.21000000f,0.76000000f,-0.74000000f,0.42000000f,-0.78000000f,-0.06000000f,0.21000000f,-0.03000000f,-0.83000000f,-0.42000000f,0.44000000f,-0.79000000f,-0.55000000f,-0.22000000f,-0.54000000f,-0.24000000f,0.68000000f,0.03000000f,-0.90000000f,0.81000000f,0.68000000f,0.70000000f,-0.84000000f,-0.41000000f,-0.26000000f,-0.67000000f,0.21000000f,-0.49000000f,0.00000000f,-0.99000000f,0.73000000f,0.96000000f,-0.50000000f,0.82000000f,0.83000000f,-0.41000000f,0.83000000f,-0.48000000f,-0.20000000f,0.84000000f,-0.79000000f,-0.93000000f,0.89000000f,-0.24000000f,0.59000000f,-0.10000000f,0.95000000f,0.43000000f,0.44000000f,-0.81000000f,0.61000000f,-0.49000000f,-0.78000000f,-0.97000000f,0.83000000f,-0.33000000f,0.26000000f,0.46000000f,-0.74000000f,-0.64000000f,0.49000000f,0.38000000f,0.92000000f,0.70000000f,0.51000000f,-0.64000000f,0.57000000f,0.55000000f,0.82000000f,-0.91000000f,-0.75000000f,-0.50000000f,-0.39000000f,-0.79000000f,-0.96000000f,-0.72000000f,-0.96000000f,0.78000000f,-0.81000000f,0.07000000f,-0.08000000f,-0.34000000f,-0.90000000f,0.26000000f,0.88000000f,-0.69000000f,-0.64000000f,-0.41000000f,0.46000000f,0.93000000f,-0.60000000f,-0.81000000f,-0.11000000f,-0.50000000f,-0.30000000f,-0.27000000f,0.59000000f,-0.02000000f,-0.71000000f,-0.78000000f,0.72000000f,0.11000000f,-0.84000000f,-0.84000000f,0.52000000f,0.45000000f,-0.90000000f,-0.64000000f,-0.38000000f,0.32000000f,-0.20000000f,0.20000000f,0.33000000f,-0.61000000f,0.79000000f,0.33000000f,-0.75000000f,-0.21000000f,-0.04000000f,0.65000000f,-0.27000000f,0.59000000f,0.60000000f,-0.49000000f,-0.38000000f,0.72000000f,0.87000000f,-0.36000000f,-0.97000000f,0.13000000f,-0.62000000f,-0.86000000f,-0.91000000f,-0.52000000f,0.45000000f,-0.41000000f,-0.38000000f,-0.29000000f,-0.07000000f,-0.69000000f,-0.86000000f,0.46000000f,0.60000000f,0.37000000f,0.14000000f,-0.12000000f,-0.75000000f,0.64000000f,-0.74000000f,0.00000000f,-0.91000000f,-0.44000000f,-0.75000000f,0.94000000f,0.91000000f,-0.12000000f,0.76000000f,0.25000000f,-0.75000000f,-0.42000000f,-0.71000000f,0.41000000f,0.55000000f,-0.99000000f,0.12000000f,0.83000000f,0.98000000f,-0.45000000f,0.16000000f,-0.89000000f,-0.38000000f,-0.36000000f,-0.89000000f,0.36000000f,0.27000000f,0.88000000f,0.64000000f,0.31000000f,-0.51000000f,0.48000000f,-0.31000000f,-0.94000000f,0.83000000f,-0.51000000f,0.51000000f,-0.32000000f,0.45000000f,-0.34000000f,0.62000000f,-0.88000000f,0.37000000f,0.48000000f,-0.25000000f,-0.87000000f,-0.40000000f,-0.35000000f,-0.60000000f,-0.48000000f,-0.62000000f,-0.14000000f,0.16000000f,-0.60000000f,-0.95000000f,0.70000000f,0.57000000f,0.38000000f,-0.42000000f,-0.76000000f,-0.37000000f,-0.13000000f,0.67000000f,0.46000000f,-0.54000000f,0.62000000f,0.87000000f,0.93000000f,-0.72000000f,0.56000000f,0.83000000f,-0.24000000f,-0.34000000f,-0.52000000f,0.65000000f,-0.64000000f,0.10000000f,-0.02000000f,-0.63000000f,-0.59000000f,-0.90000000f,-0.98000000f,0.28000000f,0.52000000f,-0.41000000f,0.27000000f,-0.97000000f,0.53000000f,0.29000000f,-0.58000000f,-0.44000000f,0.87000000f,0.32000000f,-0.02000000f,-0.49000000f,0.33000000f,0.61000000f,0.93000000f,-0.95000000f,0.65000000f,0.37000000f,-0.42000000f,-0.82000000f,0.95000000f,-0.96000000f,0.72000000f,-0.14000000f,-0.07000000f,0.03000000f,0.20000000f,0.87000000f,0.52000000f,-0.40000000f,-0.72000000f,-0.95000000f,0.49000000f,-0.29000000f,0.17000000f,0.93000000f,0.04000000f,-0.55000000f,0.37000000f,0.92000000f,-0.99000000f,0.94000000f,0.24000000f,-0.90000000f,-0.60000000f,-0.87000000f,0.48000000f,0.19000000f,-0.27000000f,0.12000000f,-0.50000000f,-0.97000000f,0.85000000f,-0.02000000f,0.68000000f,0.03000000f,0.30000000f,-0.53000000f,0.66000000f,0.38000000f,0.72000000f,0.12000000f,-0.62000000f,-0.46000000f,-0.61000000f,-0.89000000f,0.24000000f,-0.80000000f,0.13000000f,-0.52000000f,0.45000000f,-0.02000000f,0.13000000f,0.03000000f,0.02000000f,0.22000000f,0.50000000f,0.70000000f,0.46000000f,0.40000000f,-0.00000000f,0.49000000f,-0.96000000f,0.75000000f,-0.31000000f,0.60000000f,0.06000000f,-0.57000000f,0.20000000f,-0.79000000f,-0.70000000f,0.08000000f,0.71000000f,0.89000000f,0.75000000f,-0.65000000f,0.50000000f,-0.89000000f,0.15000000f,0.05000000f,0.95000000f,0.77000000f,-0.03000000f,-0.52000000f,0.52000000f,0.60000000f,0.00000000f,-0.92000000f,0.34000000f,0.38000000f,-0.69000000f,0.26000000f,-0.74000000f,0.29000000f,0.39000000f,0.18000000f,-0.06000000f,0.19000000f,-0.67000000f,-0.79000000f,0.96000000f,-0.63000000f,-0.55000000f,-0.86000000f,-0.29000000f,0.68000000f,-0.57000000f,-0.10000000f,-0.87000000f,0.22000000f,0.70000000f,0.09000000f,0.17000000f,0.27000000f,-0.30000000f,-0.53000000f,0.50000000f,0.80000000f,0.07000000f,0.09000000f,-0.85000000f,0.07000000f,0.52000000f,-0.71000000f,-0.71000000f,0.13000000f,-0.57000000f,0.39000000f,-0.45000000f,0.45000000f,0.93000000f,-0.82000000f,0.09000000f,0.94000000f,-0.77000000f,-0.58000000f,-0.46000000f,-0.40000000f,0.47000000f,-0.85000000f,-0.92000000f,-0.01000000f,-0.35000000f,0.33000000f,-0.74000000f,0.79000000f,0.10000000f,-0.24000000f,0.07000000f,0.97000000f,-0.67000000f,-0.69000000f,-0.64000000f,-0.31000000f,-0.19000000f,0.39000000f,-0.73000000f,0.18000000f,0.10000000f,0.14000000f,-0.97000000f,-0.37000000f,-0.36000000f,-0.33000000f,0.64000000f,-0.16000000f,-0.60000000f,-0.78000000f,0.84000000f,-0.77000000f,-0.40000000f,0.68000000f,-0.49000000f,0.13000000f,0.39000000f,0.98000000f,-0.35000000f,0.05000000f,-0.97000000f,-0.12000000f,0.93000000f,0.88000000f,0.33000000f,0.02000000f,0.17000000f,0.80000000f,-0.71000000f,0.98000000f,0.92000000f,-0.97000000f,0.75000000f,0.48000000f,0.22000000f,0.74000000f,-0.51000000f,0.67000000f,-0.87000000f,0.44000000f,0.84000000f,0.28000000f,-0.04000000f,0.41000000f,0.33000000f,-0.68000000f,0.52000000f,0.55000000f,-0.81000000f,-0.63000000f,0.57000000f,-0.48000000f,-0.29000000f,-0.51000000f,0.76000000f,-0.78000000f,-0.39000000f,-0.15000000f,-0.24000000f,-0.01000000f,-0.37000000f,-0.87000000f,0.64000000f,0.07000000f,0.19000000f,-0.96000000f,0.77000000f,0.48000000f,0.95000000f,0.27000000f,-0.55000000f,-0.47000000f,0.00000000f,-0.99000000f,-0.89000000f,-0.31000000f,0.05000000f,-0.08000000f,-0.56000000f,0.30000000f,0.41000000f,-0.63000000f,0.44000000f,0.80000000f,0.11000000f,0.14000000f,-0.62000000f,-0.41000000f,-0.94000000f,-0.64000000f,0.44000000f,-0.49000000f,-0.89000000f,0.42000000f,-0.82000000f,-0.97000000f,-0.83000000f,-0.41000000f,0.68000000f,0.89000000f,0.40000000f,0.09000000f,0.28000000f,0.09000000f,0.01000000f,0.32000000f,0.33000000f,-0.31000000f,0.29000000f,-0.57000000f,0.26000000f,0.70000000f,0.28000000f,0.34000000f,0.12000000f,-0.39000000f,0.77000000f,0.83000000f,0.30000000f,0.52000000f,-0.97000000f,0.80000000f,-0.94000000f,-0.53000000f,-0.33000000f,-0.38000000f,-0.25000000f,-0.20000000f,-0.22000000f,0.37000000f,-0.64000000f,0.95000000f,-0.26000000f,-0.46000000f,-0.97000000f,-0.86000000f,-0.73000000f,-0.19000000f,0.62000000f,0.45000000f,0.33000000f,-0.14000000f,0.87000000f,-0.41000000f,0.01000000f,-0.67000000f,-0.14000000f,0.59000000f,-0.29000000f,0.20000000f,-0.33000000f,0.19000000f,0.50000000f,0.68000000f,0.60000000f,0.21000000f,0.91000000f,0.29000000f,-0.77000000f,0.48000000f,0.54000000f,-0.72000000f,0.26000000f,0.94000000f,-0.82000000f,0.26000000f,0.08000000f,-0.69000000f,0.20000000f,0.66000000f,0.65000000f,-0.77000000f,0.22000000f,-0.17000000f,-0.31000000f,0.56000000f,0.86000000f,0.53000000f,-0.06000000f,0.73000000f,-0.52000000f,0.27000000f,0.99000000f,-0.73000000f,-0.31000000f,-0.09000000f,0.74000000f,-0.15000000f,-0.14000000f,-0.70000000f,0.86000000f,-0.83000000f,-0.02000000f,-0.18000000f,-0.53000000f,0.53000000f,-0.23000000f,0.94000000f,-0.23000000f,-0.32000000f,0.23000000f,-0.73000000f,-0.43000000f,0.06000000f,-0.75000000f,-0.88000000f,0.43000000f,0.50000000f,-0.74000000f,-0.17000000f,0.03000000f,0.74000000f,-0.18000000f,-0.97000000f,-0.09000000f,0.88000000f,0.63000000f,-0.88000000f,-0.42000000f,0.03000000f,-0.19000000f,0.54000000f,-0.26000000f,0.30000000f,-0.13000000f,0.74000000f,0.36000000f,0.05000000f,-0.31000000f,0.77000000f,-0.24000000f,-0.95000000f,-0.52000000f,0.95000000f,0.23000000f,0.87000000f,-0.09000000f,0.08000000f,0.24000000f,0.16000000f,0.31000000f,0.88000000f,0.48000000f,-0.12000000f,0.30000000f,-0.42000000f,-0.10000000f,0.44000000f,-0.91000000f,-0.43000000f,-0.95000000f,0.62000000f,0.36000000f,0.91000000f,-0.74000000f,0.74000000f,-0.08000000f,0.55000000f,0.12000000f,-0.14000000f,0.82000000f,0.22000000f,0.77000000f,-0.11000000f,0.81000000f,0.29000000f,-0.52000000f,-0.47000000f,0.75000000f,-0.08000000f,0.23000000f,0.45000000f,0.87000000f,0.48000000f,-0.41000000f,0.09000000f,0.46000000f,0.71000000f,0.73000000f,0.23000000f,-0.87000000f,-0.90000000f,-0.38000000f,-0.72000000f,0.23000000f,0.36000000f,0.64000000f,-0.87000000f,-0.82000000f,-0.97000000f,0.96000000f,0.97000000f,-0.63000000f,-0.92000000f,0.73000000f,0.29000000f,-0.54000000f,-0.20000000f,-0.96000000f,-0.15000000f,0.98000000f,-0.50000000f,-0.42000000f,0.29000000f,-0.21000000f,0.71000000f,-0.71000000f,0.58000000f,0.12000000f,-0.61000000f,-0.37000000f,-0.28000000f,-0.00000000f,0.66000000f,-0.80000000f,-0.29000000f,-0.83000000f,-0.15000000f,0.70000000f,0.27000000f,-0.37000000f,0.02000000f,-0.28000000f,0.85000000f,0.14000000f,0.26000000f,0.06000000f,-0.72000000f,0.07000000f,0.33000000f,0.18000000f,-0.56000000f,0.66000000f,0.51000000f,-0.21000000f,0.41000000f,-0.69000000f,-0.38000000f,0.42000000f,-0.04000000f,0.71000000f,0.66000000f,-0.26000000f,0.28000000f,0.74000000f,0.61000000f,0.22000000f,0.47000000f,-0.44000000f,0.49000000f,-0.26000000f,0.61000000f,-0.24000000f,0.07000000f,-0.63000000f,-0.24000000f,-0.44000000f,-0.41000000f,0.74000000f,-0.27000000f,0.60000000f,0.47000000f,-0.69000000f,0.13000000f,-0.10000000f,0.36000000f,-0.54000000f,-0.05000000f,-0.26000000f,0.50000000f,-0.62000000f,0.19000000f,-0.05000000f,0.56000000f,-0.12000000f,0.33000000f,0.60000000f,-0.50000000f,-0.40000000f,0.12000000f,-0.06000000f,0.95000000f,0.06000000f,0.60000000f,0.00000000f,0.32000000f,-0.73000000f,-0.05000000f,0.42000000f,0.24000000f,-0.51000000f,0.37000000f,-0.86000000f,0.49000000f,-0.35000000f,0.07000000f,0.21000000f,-0.03000000f,0.13000000f,-0.03000000f,-0.19000000f,0.48000000f,-0.29000000f,-0.56000000f,-0.35000000f,0.57000000f,-0.98000000f,-0.21000000f,0.50000000f,0.95000000f,0.51000000f,-0.40000000f,0.77000000f,0.26000000f,0.77000000f,0.71000000f,-0.28000000f,0.98000000f,-0.78000000f,0.55000000f,-0.96000000f,-0.30000000f,-0.06000000f,0.72000000f,0.79000000f,0.32000000f,0.46000000f,-0.42000000f,0.38000000f,-0.22000000f,0.82000000f,0.65000000f,0.63000000f,-0.92000000f,-0.99000000f,0.07000000f,-0.28000000f,-0.48000000f,-0.22000000f,0.29000000f,0.61000000f,0.04000000f,0.76000000f,0.77000000f,-0.89000000f,-0.84000000f,-0.18000000f,0.27000000f,-0.14000000f,0.13000000f,0.75000000f,-0.53000000f,0.88000000f,-0.46000000f,0.22000000f,-0.57000000f,-0.19000000f,-0.11000000f,-0.96000000f,0.16000000f,0.69000000f,0.37000000f,0.06000000f,0.59000000f,0.21000000f,-0.74000000f,0.53000000f,0.74000000f,0.68000000f,-0.60000000f,0.81000000f,-0.74000000f,-0.82000000f,-0.84000000f,-0.64000000f,-0.09000000f,0.31000000f,0.54000000f,0.34000000f,0.86000000f,0.30000000f,-0.72000000f,0.25000000f,0.51000000f,0.62000000f,0.47000000f,-0.67000000f,0.33000000f,-0.68000000f,0.63000000f,0.84000000f,0.91000000f,-0.85000000f,-0.24000000f,-0.48000000f,-0.40000000f,0.29000000f,0.24000000f,-0.76000000f,0.27000000f,0.60000000f,-0.51000000f,-0.27000000f,-0.99000000f,0.58000000f,0.87000000f,0.58000000f,-0.42000000f,0.18000000f,0.97000000f,-0.42000000f,-0.96000000f,-0.30000000f,-0.98000000f,-0.05000000f,0.98000000f,0.35000000f,-0.82000000f,-0.55000000f,0.87000000f,0.13000000f,0.13000000f,-0.14000000f,-0.61000000f,-0.75000000f,-0.58000000f,0.24000000f,-0.33000000f,-0.79000000f,0.95000000f,0.19000000f,0.01000000f,0.54000000f,-0.40000000f,-0.60000000f,0.08000000f,-0.59000000f,0.71000000f,-0.98000000f,-0.94000000f,0.73000000f,0.46000000f,-0.54000000f,0.23000000f,0.49000000f,-0.26000000f,0.26000000f,0.63000000f,-0.32000000f,-0.34000000f,-0.14000000f,0.01000000f,0.68000000f,-0.03000000f,0.53000000f,0.40000000f,-0.90000000f,0.70000000f,-0.13000000f,0.31000000f,0.12000000f,-0.57000000f,0.52000000f,-0.55000000f,0.98000000f,-0.71000000f,-0.75000000f,-0.71000000f,-0.23000000f,0.54000000f,0.19000000f,0.78000000f,-0.41000000f,-0.81000000f,-0.34000000f,-0.03000000f,-0.78000000f,-0.71000000f,-0.98000000f,0.69000000f,0.08000000f,0.16000000f,0.64000000f,-0.23000000f,-0.71000000f,0.35000000f,-0.53000000f,-0.45000000f,-0.01000000f,-0.99000000f,0.38000000f,-0.20000000f,-0.62000000f,0.56000000f,0.82000000f,0.98000000f,0.26000000f,0.00000000f,0.36000000f,0.29000000f,-0.78000000f,-0.88000000f,0.46000000f,0.00000000f,0.13000000f,-0.22000000f,0.73000000f,-0.42000000f,0.67000000f,-0.75000000f,0.76000000f,0.72000000f,0.95000000f,0.46000000f,-0.81000000f,-0.98000000f,-0.38000000f,-0.05000000f,-0.02000000f,0.77000000f,-0.53000000f,-0.53000000f,-0.68000000f,-0.98000000f,0.07000000f,-0.08000000f,0.40000000f,-0.59000000f,-0.03000000f,-0.13000000f,0.70000000f,0.07000000f,-0.82000000f,0.06000000f,-0.09000000f,0.66000000f,0.15000000f,0.73000000f,0.39000000f,-0.84000000f,-0.33000000f,-0.48000000f,-0.81000000f,-0.01000000f,-0.43000000f,0.42000000f,0.55000000f,0.31000000f,-0.78000000f,-0.15000000f,-0.04000000f,0.81000000f,0.26000000f,-0.38000000f,0.00000000f,0.54000000f,0.21000000f,-0.60000000f,-0.75000000f,0.92000000f,-0.60000000f,-0.51000000f,0.95000000f,-0.37000000f,-0.81000000f,0.44000000f,0.68000000f,0.71000000f,-0.37000000f,0.61000000f,0.29000000f,-0.27000000f,-0.96000000f,-0.14000000f,-0.06000000f,-0.74000000f,-0.09000000f,0.51000000f,-0.89000000f,0.47000000f,-0.75000000f,0.40000000f,0.50000000f,0.45000000f,-0.68000000f,0.77000000f,0.31000000f,-0.50000000f,-0.45000000f,0.52000000f,0.97000000f,0.05000000f,-0.91000000f,0.61000000f,-0.36000000f,-0.26000000f,-0.36000000f,0.47000000f,-0.34000000f,0.97000000f,-0.45000000f,0.19000000f,-0.08000000f,0.39000000f,0.35000000f,-0.28000000f,0.81000000f,-0.73000000f,0.37000000f,-0.39000000f,0.15000000f,-0.79000000f,-0.73000000f,0.37000000f,-0.65000000f,0.72000000f,-0.47000000f,0.57000000f,-0.57000000f,-0.82000000f,-0.87000000f,-0.62000000f,-0.92000000f,0.92000000f,0.85000000f,-0.32000000f,0.04000000f,-0.79000000f,0.96000000f,0.77000000f,0.13000000f,-0.19000000f,0.44000000f,-0.10000000f,-0.65000000f,-0.49000000f,0.33000000f,0.72000000f,0.96000000f,0.13000000f,-0.66000000f,-0.78000000f,0.76000000f,-0.44000000f,-0.69000000f,0.87000000f,0.67000000f,-0.34000000f,0.87000000f,0.92000000f,0.02000000f,-0.28000000f,-0.21000000f,-0.56000000f,0.36000000f,0.96000000f,0.53000000f,-0.19000000f,-0.15000000f,-0.73000000f,0.39000000f,0.53000000f,-0.78000000f,0.26000000f,-0.56000000f,0.17000000f,0.69000000f,0.20000000f,-0.08000000f,0.45000000f,0.19000000f,0.51000000f,-0.96000000f,-0.42000000f,0.59000000f,0.16000000f,0.48000000f,-0.75000000f,-0.71000000f,0.11000000f,-0.24000000f,-0.31000000f,-0.67000000f,-0.96000000f,-0.05000000f,-0.53000000f,0.62000000f,0.81000000f,0.37000000f,0.07000000f,0.80000000f,0.40000000f,-0.38000000f,-0.84000000f,-0.57000000f,0.96000000f,-0.23000000f,0.62000000f,-0.88000000f,0.49000000f,0.49000000f,0.37000000f,0.82000000f,-0.83000000f,-0.00000000f,0.93000000f,-0.25000000f,0.13000000f,-0.69000000f,0.87000000f,0.94000000f,0.71000000f,0.58000000f,0.51000000f,0.97000000f,-0.44000000f,-0.76000000f,0.48000000f,0.01000000f,0.11000000f,-0.57000000f,0.53000000f,-0.85000000f,-0.45000000f,0.31000000f,-0.02000000f,-0.27000000f,0.39000000f,0.86000000f,-0.42000000f,-0.67000000f,-0.34000000f,0.39000000f,0.42000000f,-0.08000000f,0.25000000f,0.01000000f,-0.45000000f,-0.11000000f,0.65000000f,-0.89000000f,-0.44000000f,0.54000000f,0.66000000f,0.53000000f,-0.96000000f,-0.09000000f,0.57000000f,0.20000000f,-0.16000000f,0.90000000f,-0.02000000f,0.92000000f,0.67000000f,-0.06000000f,0.51000000f,-0.54000000f,-0.79000000f,0.08000000f,0.89000000f,-0.96000000f,0.77000000f,-0.83000000f,-0.72000000f,0.95000000f,0.06000000f,0.38000000f,0.80000000f,0.20000000f,0.17000000f,-0.30000000f,0.76000000f,-0.39000000f,-0.81000000f,-0.59000000f,-0.66000000f,0.35000000f,0.01000000f,-0.53000000f,0.07000000f,0.94000000f,0.88000000f,0.97000000f,-0.18000000f,0.14000000f,0.41000000f,-0.83000000f,-0.00000000f,0.59000000f,-0.05000000f,0.03000000f,0.84000000f,-0.17000000f,-0.32000000f,-0.79000000f,-0.86000000f,-0.55000000f,-0.09000000f,0.57000000f,0.01000000f,0.80000000f,-0.11000000f,0.68000000f,0.92000000f,-0.57000000f,0.60000000f,-0.07000000f,-0.10000000f,0.66000000f,0.47000000f,0.62000000f,0.11000000f,-0.50000000f,0.01000000f,-0.03000000f,0.84000000f,-0.15000000f,-0.45000000f,-0.07000000f,0.19000000f,0.94000000f,-0.10000000f,-0.46000000f,-0.47000000f,-0.78000000f,0.05000000f,0.70000000f,-0.96000000f,0.88000000f,-0.84000000f,0.72000000f,-0.40000000f,0.46000000f,0.44000000f,0.31000000f,0.10000000f,0.36000000f,0.42000000f,0.42000000f,-0.29000000f,-0.87000000f,0.16000000f,-0.24000000f,0.62000000f,0.05000000f,0.13000000f,-0.11000000f,0.80000000f,-0.23000000f,0.18000000f,0.43000000f,-0.91000000f,0.75000000f,0.38000000f,0.84000000f,0.61000000f,-0.83000000f,-0.34000000f,-0.01000000f,0.05000000f,-0.39000000f,0.05000000f,-0.64000000f,0.62000000f,-0.29000000f,0.56000000f,-0.06000000f,0.23000000f,-0.39000000f,0.18000000f,0.44000000f,0.04000000f,0.36000000f,0.89000000f,0.93000000f,0.24000000f,0.42000000f,0.25000000f,-0.45000000f,-0.63000000f,-0.22000000f,0.09000000f,-0.27000000f,0.27000000f,0.28000000f,-0.12000000f,-0.97000000f,-0.20000000f,0.55000000f,-0.43000000f,-0.35000000f,-0.64000000f,0.63000000f,0.42000000f,-0.93000000f,-0.76000000f,-0.98000000f,0.90000000f,0.80000000f,-0.64000000f,-0.92000000f,0.34000000f,-0.81000000f,0.79000000f,-0.77000000f,0.56000000f,0.60000000f,-0.05000000f,-0.63000000f,-0.32000000f,0.51000000f,-0.52000000f,-0.20000000f,0.38000000f,0.80000000f,-0.63000000f,-0.52000000f,-0.13000000f,-0.06000000f,0.01000000f,-0.66000000f,0.14000000f,-0.45000000f,0.78000000f,0.07000000f,0.00000000f,0.17000000f,-0.46000000f,0.47000000f,-0.10000000f,0.31000000f,-0.16000000f,-0.62000000f,-0.32000000f,-0.85000000f,0.24000000f,-0.01000000f,-0.63000000f,0.80000000f,0.92000000f,0.54000000f,-0.85000000f,-0.74000000f,-0.93000000f,-0.98000000f,0.54000000f,-0.23000000f,-0.36000000f,0.20000000f,0.75000000f,0.22000000f,0.71000000f,-0.07000000f,-0.13000000f,0.40000000f,-0.82000000f,0.46000000f,-0.39000000f,0.34000000f,-0.35000000f,0.12000000f,-0.42000000f,0.63000000f,0.68000000f,0.04000000f,0.97000000f,-0.04000000f,-0.38000000f,0.87000000f,0.12000000f,0.02000000f,-0.71000000f,-0.81000000f,-0.43000000f,0.56000000f,0.80000000f,0.88000000f,0.51000000f,-0.78000000f,-0.52000000f,0.35000000f,-0.52000000f,0.21000000f,-0.51000000f,0.19000000f,-0.05000000f,0.64000000f,0.72000000f,-0.69000000f,0.45000000f,-0.94000000f,0.41000000f,-0.80000000f,-0.17000000f,0.67000000f,-0.41000000f,0.08000000f,0.15000000f,-0.55000000f,0.13000000f,-0.25000000f,-0.85000000f,0.77000000f,0.47000000f,-0.44000000f,0.39000000f,-0.71000000f,-0.62000000f,0.65000000f,0.35000000f,0.20000000f,0.25000000f,0.62000000f,-0.53000000f,-0.97000000f,-0.36000000f,-0.12000000f,-0.93000000f,-0.46000000f,0.39000000f,0.07000000f,0.06000000f,-0.88000000f,0.07000000f,0.01000000f,-0.95000000f,-0.02000000f,0.52000000f,0.41000000f,-0.88000000f,0.55000000f,0.99000000f,0.11000000f,0.76000000f,-0.90000000f,0.97000000f,-0.25000000f,-0.92000000f,0.65000000f,0.94000000f,0.71000000f,-0.82000000f,-0.46000000f,0.44000000f,0.21000000f,0.84000000f,-0.49000000f,0.55000000f,-0.20000000f,0.45000000f,0.48000000f,-0.58000000f,0.96000000f,0.52000000f,0.01000000f,0.31000000f,-0.67000000f,0.52000000f,-0.66000000f,-0.77000000f,0.18000000f,0.36000000f,-0.32000000f,0.51000000f,0.23000000f,0.58000000f,-0.45000000f,-0.52000000f,0.22000000f,-0.46000000f,0.79000000f,0.49000000f,0.40000000f,0.81000000f,-0.44000000f,0.79000000f,-0.50000000f,0.90000000f,0.13000000f,0.34000000f,0.93000000f,0.31000000f,0.56000000f,-0.83000000f,0.90000000f,-0.18000000f,0.55000000f,-0.05000000f,-0.82000000f,0.16000000f,0.67000000f,0.08000000f,-0.82000000f,-0.04000000f,-0.05000000f,0.69000000f,0.75000000f,0.74000000f,-0.37000000f,0.09000000f,0.82000000f,-0.32000000f,0.16000000f,0.67000000f,0.50000000f,0.37000000f,0.63000000f,-0.65000000f,0.28000000f,0.34000000f,0.09000000f,0.41000000f,-0.64000000f,0.57000000f,0.80000000f,-0.11000000f,-0.43000000f,-0.16000000f,-0.29000000f,-0.79000000f,-0.52000000f,-0.54000000f,-0.22000000f,-0.94000000f,-0.77000000f,0.36000000f,0.75000000f,-0.42000000f,0.71000000f,-0.53000000f,-0.23000000f,-0.26000000f,-0.23000000f,-0.19000000f,-0.13000000f,0.85000000f,-0.15000000f,0.70000000f,-0.27000000f,-0.43000000f,0.63000000f,0.13000000f,0.95000000f,-0.63000000f,-0.28000000f,-0.42000000f,-0.91000000f,-0.42000000f,0.79000000f,-0.05000000f,-0.43000000f,0.24000000f,0.39000000f,0.22000000f,0.63000000f,-0.40000000f,0.12000000f,0.10000000f,-0.23000000f,-0.86000000f,-0.12000000f,-0.42000000f,0.31000000f,-0.87000000f,-0.38000000f,0.04000000f,0.54000000f,0.37000000f,-0.51000000f,0.09000000f,0.58000000f,0.27000000f,0.27000000f,0.17000000f,-0.16000000f,0.36000000f,0.35000000f,0.88000000f,-0.79000000f,0.34000000f,0.34000000f,-0.51000000f,-0.15000000f,-0.84000000f,0.07000000f,0.46000000f,0.46000000f,0.44000000f,-0.70000000f,-0.41000000f,0.98000000f,0.44000000f,0.66000000f,0.31000000f,0.84000000f,0.95000000f,-0.25000000f,-0.52000000f,-0.07000000f,-0.78000000f,-0.72000000f,-0.55000000f,-0.84000000f,-0.38000000f,-0.77000000f,0.90000000f,-0.08000000f,-0.62000000f,0.74000000f,-0.78000000f,-0.46000000f,-0.71000000f,0.80000000f,0.21000000f,0.66000000f,0.19000000f,0.80000000f,0.05000000f,0.83000000f,0.28000000f,0.46000000f,0.75000000f,0.33000000f,0.31000000f,-0.62000000f,-0.20000000f,0.13000000f,-0.79000000f,-0.17000000f,0.32000000f,-0.26000000f,-0.48000000f,0.40000000f,0.93000000f,-0.08000000f,0.49000000f,0.71000000f,0.34000000f,-0.05000000f,0.62000000f,0.30000000f,0.22000000f,0.12000000f,0.60000000f,-0.02000000f,-0.56000000f,0.39000000f,-0.15000000f,0.78000000f,0.80000000f,-0.11000000f,-0.61000000f,-0.66000000f,-0.25000000f,-0.80000000f,-0.44000000f,-0.39000000f,-0.99000000f,0.05000000f,0.57000000f,-0.36000000f,0.82000000f,-0.74000000f,0.37000000f,-0.50000000f,0.68000000f,-0.37000000f,0.56000000f,0.80000000f,-0.50000000f,0.45000000f,-0.50000000f,0.58000000f,-0.01000000f,0.79000000f,-0.48000000f,0.05000000f,0.97000000f,0.32000000f,0.82000000f,0.46000000f,0.49000000f,-0.12000000f,-0.71000000f,-0.04000000f,-0.65000000f,0.60000000f,-0.81000000f,0.78000000f,-0.85000000f,0.90000000f,-0.95000000f,-0.46000000f,0.62000000f,0.36000000f,-0.43000000f,0.10000000f,0.57000000f,0.52000000f,-0.60000000f,-0.05000000f,-0.11000000f,0.12000000f,0.32000000f,0.52000000f,0.91000000f,0.53000000f,0.24000000f,0.04000000f,-0.44000000f,-0.41000000f,0.89000000f,-0.17000000f,-0.45000000f,-0.83000000f,0.28000000f,-0.70000000f,0.46000000f,0.58000000f,0.81000000f,-0.23000000f,-0.97000000f,-0.61000000f,-0.82000000f,0.83000000f,0.45000000f,0.74000000f,-0.55000000f,-0.51000000f,-0.74000000f,0.56000000f,0.00000000f,0.23000000f,0.76000000f,-0.30000000f,0.07000000f,0.91000000f,0.26000000f,0.82000000f,0.32000000f,-0.40000000f,0.82000000f,0.64000000f,-0.83000000f,-0.99000000f,-0.19000000f,0.34000000f,0.09000000f,0.31000000f,-0.47000000f,0.38000000f,0.33000000f,0.68000000f,0.71000000f,-0.20000000f,-0.86000000f,-0.10000000f,-0.53000000f,-0.04000000f,-0.99000000f,0.35000000f,0.49000000f,0.52000000f,0.81000000f,-0.51000000f,0.76000000f,-0.50000000f,-0.31000000f,-0.93000000f,-0.89000000f,-0.88000000f,0.97000000f,0.22000000f,-0.41000000f,0.25000000f,-0.28000000f,-0.29000000f,-0.60000000f,-0.23000000f,-0.75000000f,-0.39000000f,0.81000000f,0.17000000f,0.18000000f,-0.92000000f,-0.94000000f,0.82000000f,-0.83000000f,-0.71000000f,0.77000000f,-0.65000000f,0.15000000f,0.17000000f,0.09000000f,0.23000000f,0.21000000f,0.05000000f,0.14000000f,-0.56000000f,-0.31000000f,0.32000000f,0.45000000f,-0.41000000f,0.40000000f,-0.01000000f,-0.59000000f,-0.07000000f,0.96000000f,0.15000000f,0.98000000f,-0.32000000f,-0.66000000f,0.58000000f,-0.07000000f,0.01000000f,-0.67000000f,-0.17000000f,-0.37000000f,0.76000000f,-0.57000000f,0.18000000f,-0.97000000f,-0.14000000f,0.78000000f,0.13000000f,0.78000000f,-0.58000000f,0.33000000f,0.45000000f,-0.31000000f,0.29000000f,0.50000000f,-0.20000000f,-0.78000000f,-0.82000000f,-0.55000000f,0.46000000f,0.55000000f,-0.73000000f,-0.63000000f,0.01000000f,0.12000000f,0.62000000f,0.58000000f,0.95000000f,0.08000000f,-0.94000000f,-0.90000000f,-0.70000000f,-0.22000000f,0.57000000f,0.69000000f,0.80000000f,0.52000000f,-0.38000000f,-0.38000000f,0.59000000f,0.17000000f,0.53000000f,0.46000000f,-0.55000000f,0.81000000f,0.59000000f,0.54000000f,0.57000000f,-0.38000000f,0.07000000f,-0.23000000f,0.16000000f,0.18000000f,0.57000000f,-0.94000000f,0.95000000f,-0.83000000f,0.75000000f,-0.75000000f,-0.97000000f,-0.57000000f,-0.61000000f,-0.15000000f,-0.12000000f,-0.67000000f,0.72000000f,-0.90000000f,-0.26000000f,0.39000000f,0.65000000f,-0.34000000f,-0.43000000f,0.13000000f,-0.23000000f,-0.22000000f,-0.80000000f,0.60000000f,-0.54000000f,0.31000000f,-0.98000000f,-0.12000000f,0.48000000f,0.94000000f,-0.96000000f,0.42000000f,-0.33000000f,-0.89000000f,-0.03000000f,0.94000000f,0.04000000f,0.36000000f,-0.75000000f,0.28000000f,0.28000000f,-0.77000000f,0.32000000f,-0.33000000f,-0.09000000f,-0.30000000f,0.96000000f,-0.30000000f,-0.17000000f,0.54000000f,0.48000000f,0.61000000f,-0.50000000f,-0.01000000f,0.49000000f,-0.88000000f,-0.28000000f,0.50000000f,0.66000000f,0.03000000f,-0.19000000f,-0.01000000f,-0.44000000f,-0.73000000f,-0.11000000f,0.07000000f,0.71000000f,0.05000000f,-0.38000000f,-0.50000000f,-0.47000000f,-0.92000000f,0.75000000f,0.48000000f,-0.46000000f,-0.08000000f,-0.15000000f,0.59000000f,0.32000000f,0.87000000f,0.87000000f,0.80000000f,-0.79000000f,0.20000000f,-0.08000000f,-0.64000000f,0.45000000f,-0.26000000f,0.42000000f,-0.95000000f,0.03000000f,0.91000000f,-0.11000000f,0.14000000f,0.63000000f,0.55000000f,0.59000000f,0.04000000f,0.79000000f,0.30000000f,-0.13000000f,0.20000000f,0.48000000f,-0.07000000f,-0.69000000f,0.29000000f,-0.02000000f,0.45000000f,-0.61000000f,-0.52000000f,0.46000000f,-0.28000000f,0.81000000f,-0.93000000f,-0.73000000f,0.43000000f,-0.96000000f,0.45000000f,0.09000000f,0.51000000f,0.56000000f,-0.39000000f,0.20000000f,-0.18000000f,0.16000000f,-0.28000000f,0.02000000f,0.05000000f,-0.45000000f,0.31000000f,-0.61000000f,0.82000000f,-0.92000000f,-0.94000000f,-0.20000000f,0.10000000f,0.44000000f,-0.02000000f,-0.84000000f,0.16000000f,0.08000000f,-0.66000000f,0.06000000f,0.72000000f,0.09000000f,-0.91000000f,0.70000000f,-0.96000000f,0.53000000f,-0.30000000f,0.89000000f,0.76000000f,0.11000000f,0.61000000f,0.89000000f,-0.02000000f,-0.65000000f,-0.98000000f,-0.93000000f,-0.66000000f,-0.11000000f,-0.97000000f,0.52000000f,-0.75000000f,-0.15000000f,0.30000000f,0.39000000f,0.32000000f,0.49000000f,-0.72000000f,0.44000000f,0.62000000f,0.64000000f,-0.76000000f,0.63000000f,-0.18000000f,0.29000000f,-0.74000000f,-0.10000000f,-0.35000000f,-0.11000000f,-0.42000000f,0.29000000f,-0.07000000f,0.06000000f,-0.26000000f,-0.91000000f,0.85000000f,-0.31000000f,-0.73000000f,0.84000000f,0.89000000f,0.46000000f,0.96000000f,0.92000000f,-0.76000000f,0.87000000f,-0.83000000f,-0.57000000f,0.42000000f,-0.79000000f,-0.55000000f,-0.32000000f,-0.14000000f,0.36000000f,-0.37000000f,0.14000000f,0.17000000f,0.60000000f,0.48000000f,-0.66000000f,0.24000000f,-0.27000000f,0.30000000f,-0.76000000f,-0.73000000f,-0.14000000f,-0.86000000f,-0.43000000f,0.93000000f,0.61000000f,-0.03000000f,0.70000000f,0.74000000f,-0.91000000f,0.45000000f,-0.78000000f,-0.07000000f,-0.60000000f,-0.57000000f,0.40000000f,0.51000000f,0.53000000f,-0.02000000f,0.27000000f,0.04000000f,0.94000000f,0.49000000f,-0.16000000f,-0.94000000f,-0.16000000f,0.41000000f,-0.45000000f,0.31000000f,0.56000000f,0.25000000f,-0.56000000f,0.87000000f,0.15000000f,-0.83000000f,-0.66000000f,-0.69000000f,-0.16000000f,0.32000000f,-0.61000000f,0.76000000f,-0.59000000f,-0.69000000f,-0.70000000f,0.42000000f,0.65000000f,0.90000000f,-0.45000000f,0.59000000f,-0.25000000f,-0.94000000f,0.74000000f,-0.87000000f,-0.24000000f,0.69000000f,-0.85000000f,0.33000000f,-0.89000000f,0.35000000f,-0.29000000f,-0.67000000f,-0.28000000f,-0.85000000f,-0.91000000f,-0.68000000f,0.38000000f,0.48000000f,-0.21000000f,-0.00000000f,-0.39000000f,0.93000000f,0.00000000f,-0.43000000f,-0.25000000f,0.67000000f,0.82000000f,0.00000000f,0.27000000f,-0.76000000f,0.44000000f,-0.83000000f,-0.61000000f,-0.80000000f,0.98000000f,-0.07000000f,-0.86000000f,0.03000000f,0.69000000f,-0.88000000f,-0.87000000f,-0.65000000f,0.88000000f,0.61000000f,0.32000000f,-0.82000000f,0.76000000f,-0.57000000f,-0.59000000f,0.02000000f,-0.80000000f,0.34000000f,-0.98000000f,-0.25000000f,-0.34000000f,0.83000000f,0.40000000f,-0.73000000f,-0.63000000f,-0.73000000f,-0.59000000f,-0.15000000f,-0.19000000f,0.07000000f,-0.21000000f,-0.87000000f,-0.52000000f,0.03000000f,0.69000000f,-0.73000000f,0.99000000f,0.25000000f,-0.28000000f,0.50000000f,-0.17000000f,0.81000000f,0.70000000f,-0.62000000f,0.19000000f,-0.64000000f,-0.14000000f,0.87000000f,0.37000000f,-0.98000000f,-0.33000000f,-0.41000000f,-0.21000000f,0.51000000f,0.84000000f,-0.93000000f,-0.44000000f,0.40000000f,0.86000000f,-0.39000000f,-0.46000000f,0.01000000f,-0.06000000f,0.74000000f,0.43000000f,-0.97000000f,0.69000000f,-0.14000000f,0.06000000f,0.46000000f,0.72000000f,0.48000000f,-0.33000000f,0.91000000f,0.85000000f,0.07000000f,0.51000000f,0.34000000f,-0.16000000f,0.46000000f,0.88000000f,-0.24000000f,0.17000000f,0.55000000f,-0.61000000f,0.16000000f,-0.32000000f,0.02000000f,0.53000000f,0.91000000f,0.04000000f,0.26000000f,0.33000000f,-0.64000000f,-0.50000000f,0.32000000f,0.55000000f,-0.47000000f,0.37000000f,0.69000000f,0.09000000f,-0.29000000f,0.75000000f,-0.19000000f,0.93000000f,0.92000000f,0.65000000f,0.85000000f,-0.45000000f,0.17000000f,-0.36000000f,-0.08000000f,-0.01000000f,0.08000000f,0.69000000f,-0.98000000f,-0.46000000f,-0.32000000f,-0.66000000f,0.98000000f,0.08000000f,-0.71000000f,-0.98000000f,-0.51000000f,-0.95000000f,0.23000000f,0.26000000f,-0.35000000f,-0.72000000f,0.69000000f,-0.64000000f,-0.13000000f,-0.23000000f,0.95000000f,-0.74000000f,-0.25000000f,0.34000000f,0.36000000f,0.25000000f,-0.51000000f,0.00000000f,-0.60000000f,-0.92000000f,0.81000000f,-0.84000000f,0.85000000f,-0.55000000f,0.26000000f,0.20000000f,0.18000000f,-0.78000000f,-0.27000000f,0.99000000f,-0.36000000f,-0.97000000f,0.76000000f,0.10000000f,-0.80000000f,0.16000000f,-0.90000000f,0.48000000f,-0.38000000f,-0.15000000f,0.97000000f,0.75000000f,0.17000000f,0.60000000f,0.15000000f,-0.76000000f,-0.58000000f,0.72000000f,0.24000000f,0.16000000f,-0.37000000f,0.07000000f,0.45000000f,-0.29000000f,0.17000000f,-0.30000000f,-0.37000000f,-0.15000000f,0.43000000f,-0.90000000f,-0.33000000f,0.90000000f,-0.29000000f,0.53000000f,0.96000000f,0.83000000f,0.11000000f,0.28000000f,-0.70000000f,0.87000000f,-0.26000000f,0.90000000f,0.17000000f,0.89000000f,-0.25000000f,-0.92000000f,0.62000000f,0.10000000f,0.14000000f,-0.91000000f,-0.59000000f,-0.54000000f,-0.34000000f,0.10000000f,0.25000000f,0.69000000f,-0.60000000f,0.57000000f,0.82000000f,-0.12000000f,-0.97000000f,-0.72000000f,0.34000000f,-0.43000000f,-0.02000000f,-0.16000000f,-0.49000000f,-0.10000000f,-0.22000000f,-0.95000000f,-0.29000000f,0.15000000f,0.15000000f,0.55000000f,-0.55000000f,0.89000000f,-0.28000000f,-0.15000000f,-0.22000000f,-0.63000000f,0.28000000f,0.64000000f,-0.82000000f,-0.09000000f,-0.14000000f,0.96000000f,-0.07000000f,-0.58000000f,-0.29000000f,0.77000000f,0.18000000f,0.47000000f,-0.33000000f,-0.14000000f,-0.80000000f,-0.80000000f,-0.52000000f,0.52000000f,-0.37000000f,-0.09000000f,0.13000000f,0.85000000f,0.01000000f,0.25000000f,0.47000000f,-0.67000000f,0.29000000f,-0.52000000f,0.92000000f,0.87000000f,-0.25000000f,-0.87000000f,0.67000000f,0.44000000f,-0.85000000f,0.81000000f,-0.29000000f,-0.51000000f,-0.11000000f,-0.86000000f,-0.92000000f,0.90000000f,0.87000000f,0.57000000f,0.45000000f,0.74000000f,0.02000000f,0.81000000f,-0.50000000f,-0.32000000f,0.24000000f,-0.70000000f,-0.71000000f,-0.30000000f,0.71000000f,0.56000000f,0.60000000f,-0.64000000f,0.56000000f,-0.88000000f,0.75000000f,-0.04000000f,0.90000000f,0.40000000f,-0.39000000f,-0.16000000f,0.99000000f,-0.55000000f,0.55000000f,0.77000000f,-0.76000000f,0.25000000f,-0.18000000f,-0.78000000f,0.71000000f,0.05000000f,-0.03000000f,0.80000000f,-0.55000000f,-0.13000000f,0.63000000f,-0.33000000f,0.18000000f,-0.66000000f,0.27000000f,-0.83000000f,-0.21000000f,-0.79000000f,-0.46000000f,-0.15000000f,-0.61000000f,-0.28000000f,-0.84000000f,0.58000000f,-0.43000000f,0.85000000f,-0.22000000f,0.54000000f,0.73000000f,-0.87000000f,-0.48000000f,0.53000000f,-0.97000000f,-0.93000000f,0.85000000f,-0.96000000f,0.37000000f,0.78000000f,0.61000000f,0.55000000f,0.43000000f,-0.75000000f,0.09000000f,-0.06000000f,-0.23000000f,0.68000000f,-0.42000000f,-0.88000000f,-0.81000000f,-0.36000000f,0.33000000f,-0.50000000f,0.63000000f,-0.74000000f,-0.61000000f,-0.29000000f,0.14000000f,0.78000000f,-0.19000000f,-0.13000000f,-0.73000000f,0.97000000f,0.87000000f,-0.15000000f,-0.62000000f,-0.16000000f,0.83000000f,-0.78000000f,0.87000000f,0.48000000f,0.32000000f,0.77000000f,0.59000000f,-0.02000000f,0.06000000f,0.72000000f,0.84000000f,0.18000000f,-0.24000000f,-0.53000000f,0.26000000f,0.56000000f,0.50000000f,0.62000000f,-0.29000000f,-0.08000000f,-0.39000000f,-0.29000000f,-0.36000000f,-0.98000000f,0.53000000f,0.53000000f,-0.21000000f,-0.08000000f,0.47000000f,-0.77000000f,-0.73000000f,-0.48000000f,0.84000000f,0.12000000f,0.09000000f,-0.22000000f,0.77000000f,-0.10000000f,-0.69000000f,0.10000000f,0.13000000f,-0.42000000f,0.96000000f,-0.67000000f,-0.78000000f,0.10000000f,0.66000000f,0.85000000f,0.52000000f,0.89000000f,0.50000000f,0.38000000f,-0.03000000f,0.75000000f,0.29000000f,0.53000000f,-0.71000000f,0.99000000f,-0.58000000f,0.75000000f,0.74000000f,-0.66000000f,0.50000000f,0.76000000f,-0.73000000f,-0.84000000f,-0.86000000f,0.71000000f,0.07000000f,-0.82000000f,-0.43000000f,0.96000000f,0.94000000f,-0.36000000f,-0.27000000f,0.43000000f,0.03000000f,-0.60000000f,-0.35000000f,0.41000000f,-0.30000000f,0.06000000f,-0.51000000f,0.49000000f,-0.34000000f,0.99000000f,-0.86000000f,0.99000000f,-0.03000000f,-0.43000000f,-0.27000000f,-0.72000000f,-0.92000000f,0.17000000f,-0.78000000f,0.43000000f,0.93000000f,0.12000000f,-0.15000000f,0.73000000f,0.88000000f,0.44000000f,-0.58000000f,-0.20000000f,0.27000000f,0.45000000f,0.40000000f,0.02000000f,0.94000000f,-0.68000000f,0.88000000f,-0.76000000f,-0.16000000f,0.08000000f,0.92000000f,-0.88000000f,0.03000000f,-0.66000000f,-0.59000000f,-0.05000000f,-0.95000000f,-0.54000000f,0.97000000f,0.94000000f,-0.84000000f,0.24000000f,-0.03000000f,-0.14000000f,0.58000000f,-0.75000000f,0.38000000f,0.00000000f,-0.90000000f,-0.34000000f,-0.70000000f,-0.79000000f,-0.33000000f,0.48000000f,0.92000000f,-0.68000000f,-0.88000000f,0.99000000f,-0.58000000f,0.32000000f,0.81000000f,-0.57000000f,0.23000000f,-0.70000000f,-0.26000000f,0.49000000f,-0.13000000f,0.93000000f,0.66000000f,-0.31000000f,-0.58000000f,0.56000000f,-0.57000000f,-0.38000000f,0.59000000f,0.10000000f,0.10000000f,-0.55000000f,-0.41000000f,0.13000000f,-0.22000000f,-0.53000000f,0.30000000f,0.39000000f,0.66000000f,0.93000000f,-0.38000000f,0.93000000f,0.35000000f,-0.47000000f,0.21000000f,0.14000000f,0.86000000f,0.71000000f,-0.51000000f,-0.99000000f,0.72000000f,-0.37000000f,-0.24000000f,-0.04000000f,0.19000000f,0.03000000f,-0.18000000f,0.38000000f,-0.68000000f,0.88000000f,0.98000000f,-0.57000000f,0.26000000f,-0.18000000f,0.34000000f,0.99000000f,0.04000000f,-0.05000000f,0.84000000f,-0.83000000f,0.45000000f,-0.93000000f,-0.94000000f,-0.65000000f,0.91000000f,-0.23000000f,0.34000000f,-0.34000000f,-0.11000000f,0.10000000f,0.96000000f,0.22000000f,0.59000000f,0.67000000f,0.73000000f,-0.05000000f,0.34000000f,-0.69000000f,-0.74000000f,-0.32000000f,-0.47000000f,0.96000000f,-0.38000000f,-0.77000000f,-0.04000000f,-0.30000000f,-0.29000000f,-0.82000000f,0.22000000f,-0.05000000f,-0.56000000f,0.10000000f,-0.78000000f,-0.06000000f,-0.14000000f,-0.46000000f,-0.11000000f,0.66000000f,0.83000000f,-0.46000000f,-0.26000000f,-0.19000000f,-0.55000000f,0.28000000f,0.00000000f,-0.02000000f,0.02000000f,-0.64000000f,0.14000000f,-0.57000000f,-0.49000000f,0.07000000f,-0.38000000f,0.18000000f,0.75000000f,-0.97000000f,0.20000000f,-0.14000000f,0.26000000f,0.58000000f,-0.31000000f,-0.64000000f,0.90000000f,0.52000000f,-0.49000000f,0.98000000f,0.78000000f,-0.84000000f,-0.36000000f,0.64000000f,-0.63000000f,0.46000000f,-0.95000000f,0.05000000f,0.27000000f,0.65000000f,0.69000000f,-0.80000000f,-0.31000000f,-0.57000000f,0.70000000f,-0.34000000f,-0.65000000f,-0.46000000f,-0.06000000f,-0.12000000f,-0.35000000f,-0.03000000f,-0.49000000f,0.38000000f,-0.07000000f,-0.15000000f,-0.46000000f,0.65000000f,0.70000000f,-0.05000000f,-0.98000000f,-0.75000000f,0.07000000f,-0.61000000f,-0.69000000f,0.05000000f,-0.39000000f,-0.93000000f,-0.93000000f,0.66000000f,-0.68000000f,0.52000000f,0.76000000f,-0.24000000f,-0.78000000f,-0.06000000f,-0.77000000f,0.28000000f,-0.65000000f,-0.74000000f,0.42000000f,-0.04000000f,-0.59000000f,0.97000000f,-0.96000000f,0.87000000f,0.30000000f,-0.31000000f,-0.24000000f,0.99000000f,-0.15000000f,-0.06000000f,0.87000000f,-0.86000000f,0.34000000f,-0.68000000f,-0.15000000f,0.45000000f,-0.83000000f,-0.33000000f,0.56000000f,-0.53000000f,0.45000000f,-0.95000000f,0.48000000f,0.89000000f,0.93000000f,-0.74000000f,-0.21000000f,0.15000000f,-0.17000000f,-0.81000000f,-0.07000000f,0.99000000f,-0.32000000f,-0.66000000f,0.64000000f,-0.89000000f,-0.74000000f,0.14000000f,0.04000000f,-0.82000000f,-0.74000000f,-0.30000000f,0.61000000f,0.35000000f,-0.72000000f,0.52000000f,-0.60000000f,-0.44000000f,0.42000000f,0.58000000f,0.29000000f,0.91000000f,-0.44000000f,0.94000000f,0.65000000f,-0.32000000f,-0.26000000f,-0.02000000f,0.79000000f,0.45000000f,-0.40000000f,0.10000000f,0.53000000f,-0.11000000f,-0.15000000f,-0.99000000f,-0.24000000f,0.86000000f,0.85000000f,-0.42000000f,-0.00000000f,0.28000000f,0.07000000f,-0.86000000f,-0.18000000f,0.75000000f,-0.38000000f,0.16000000f,-0.62000000f,0.97000000f,0.28000000f,0.30000000f,0.80000000f,0.14000000f,0.24000000f,0.82000000f,-0.25000000f,0.55000000f,-0.82000000f,0.42000000f,-0.39000000f,-0.24000000f,-0.58000000f,0.54000000f,0.27000000f,0.95000000f,-0.98000000f,-0.30000000f,-0.55000000f,0.51000000f,-0.52000000f,-0.32000000f,-0.50000000f,0.49000000f,-0.90000000f,-0.15000000f,0.38000000f,-0.92000000f,0.38000000f,-0.48000000f,0.39000000f,0.45000000f,-0.56000000f,-0.96000000f,-0.96000000f,0.72000000f,-0.25000000f,-0.77000000f,-0.31000000f,0.59000000f,-0.89000000f,0.42000000f,0.48000000f,0.62000000f,-0.11000000f,-0.78000000f,0.70000000f,0.46000000f,0.88000000f,-0.32000000f,-0.62000000f,-0.87000000f,-0.61000000f,0.14000000f,0.99000000f,0.44000000f,0.81000000f,-0.66000000f,0.24000000f,-0.56000000f,0.69000000f,-0.97000000f,0.76000000f,-0.75000000f,-0.00000000f,-0.94000000f,0.58000000f,-0.32000000f,0.82000000f,0.74000000f,-0.24000000f,-0.88000000f,0.30000000f,-0.07000000f,0.04000000f,0.75000000f,-0.70000000f,0.70000000f,0.23000000f,-0.21000000f,-0.51000000f,0.36000000f,0.63000000f,-0.70000000f,0.10000000f,0.09000000f,0.64000000f,-0.51000000f,-0.12000000f,-0.23000000f,-0.39000000f,0.35000000f,0.74000000f,-0.58000000f,0.39000000f,-0.84000000f,0.81000000f,-0.93000000f,-0.40000000f,0.31000000f,-0.81000000f,0.41000000f,-0.89000000f,-0.27000000f,-0.39000000f,0.13000000f,-0.51000000f,-0.72000000f,-0.55000000f,0.79000000f,0.49000000f,-0.29000000f,0.00000000f,-0.92000000f,-0.10000000f,-0.77000000f,-0.75000000f,-0.33000000f,-0.20000000f,0.21000000f,0.22000000f,-0.31000000f,0.14000000f,-0.58000000f,0.82000000f,0.38000000f,0.33000000f,-0.01000000f,0.54000000f,-0.67000000f,0.24000000f,0.60000000f,0.53000000f,0.52000000f,0.21000000f,-0.73000000f,-0.72000000f,-0.60000000f,-0.37000000f,-0.34000000f,-0.06000000f,0.15000000f,-0.63000000f,-0.99000000f,-0.28000000f,0.04000000f,-0.36000000f,-0.28000000f,0.35000000f,0.88000000f,0.24000000f,0.52000000f,-0.54000000f,0.55000000f,-0.91000000f,0.36000000f,0.59000000f,0.48000000f,-0.43000000f,-0.54000000f,-0.36000000f,0.12000000f,0.56000000f,-0.72000000f,0.54000000f,-0.75000000f,-0.77000000f,0.12000000f,-0.89000000f,-0.30000000f,0.93000000f,-0.11000000f,-0.18000000f,-0.67000000f,-0.15000000f,0.02000000f,-0.76000000f,-0.51000000f,0.45000000f,0.79000000f,-0.49000000f,0.90000000f,-0.98000000f,-0.70000000f,0.10000000f,0.35000000f,-0.22000000f,0.66000000f,-0.62000000f,0.87000000f,0.44000000f,-0.55000000f,-0.63000000f,0.09000000f,-0.42000000f,-0.38000000f,0.81000000f,0.69000000f,-0.56000000f,-0.51000000f,0.25000000f,0.31000000f,0.06000000f,-0.99000000f,0.45000000f,-0.85000000f,0.84000000f,0.32000000f,0.21000000f,0.61000000f,-0.44000000f,-0.63000000f,0.46000000f,-0.87000000f,-0.03000000f,0.40000000f,-0.52000000f,0.89000000f,-0.92000000f,-0.14000000f,0.30000000f,0.39000000f,0.30000000f,-0.63000000f,-0.01000000f,-0.66000000f,-0.02000000f,-0.51000000f,0.14000000f,0.02000000f,0.28000000f,0.85000000f,0.77000000f,-0.55000000f,0.69000000f,-0.13000000f,-0.72000000f,-0.04000000f,-0.35000000f,0.05000000f,0.40000000f,0.49000000f,0.27000000f,-0.64000000f,-0.46000000f,-0.59000000f,-0.33000000f,0.43000000f,0.53000000f,-0.50000000f,-0.60000000f,0.28000000f,0.82000000f,0.51000000f,0.90000000f,0.48000000f,-0.55000000f,-0.08000000f,-0.32000000f,0.68000000f,-0.93000000f,-0.09000000f,-0.85000000f,-0.29000000f,-0.92000000f,0.15000000f,0.84000000f,-0.97000000f,0.12000000f,0.72000000f,0.81000000f,-0.88000000f,-0.98000000f,-0.26000000f,0.85000000f,0.56000000f,0.95000000f,-0.10000000f,0.67000000f,-0.14000000f,0.03000000f,0.25000000f,0.72000000f,-0.22000000f,0.18000000f,-0.72000000f,-0.85000000f,0.83000000f,0.00000000f,0.98000000f,-0.34000000f,0.35000000f,0.62000000f,-0.65000000f,-0.66000000f,0.78000000f,0.09000000f,-0.09000000f,-0.98000000f,0.89000000f,-0.27000000f,-0.54000000f,-0.82000000f,0.06000000f,-0.12000000f,-0.89000000f,0.45000000f,-0.07000000f,0.73000000f,-0.66000000f,-0.00000000f,-0.67000000f,0.56000000f,-0.41000000f,-0.99000000f,0.09000000f,0.30000000f,-0.30000000f,0.76000000f,-0.33000000f,0.02000000f,0.29000000f,-0.36000000f,0.69000000f,0.83000000f,-0.16000000f,0.76000000f,-0.36000000f,-0.47000000f,-0.22000000f,0.18000000f,-0.49000000f,0.57000000f,-0.02000000f,-0.56000000f,-0.93000000f,-0.19000000f,-0.98000000f,-0.98000000f,-0.17000000f,-0.42000000f,0.55000000f,0.49000000f,-0.37000000f,0.02000000f,-0.22000000f,-0.61000000f,-0.36000000f,0.94000000f,-0.65000000f,-0.87000000f,0.56000000f,-0.93000000f,-0.53000000f,-0.23000000f,-0.30000000f,0.34000000f,0.53000000f,-0.55000000f,-0.62000000f,-0.86000000f,0.22000000f,-0.57000000f,0.47000000f,0.12000000f,-0.93000000f,-0.83000000f,-0.90000000f,0.77000000f,0.36000000f,0.73000000f,-0.59000000f,0.87000000f,0.88000000f,-0.54000000f,0.88000000f,0.39000000f,0.42000000f,0.50000000f,0.68000000f,-0.66000000f,0.07000000f,0.22000000f,-0.39000000f,-0.47000000f,0.41000000f,-0.79000000f,-0.38000000f,0.79000000f,-0.09000000f,0.37000000f,-0.07000000f,0.05000000f,0.66000000f,-0.54000000f,0.45000000f,0.39000000f,0.84000000f,0.72000000f,0.12000000f,0.30000000f,-0.55000000f,0.54000000f,0.42000000f,-0.14000000f,-0.85000000f,-0.56000000f,-0.55000000f,0.27000000f,0.70000000f,0.98000000f,-0.28000000f,-0.29000000f,0.48000000f,-0.02000000f,-0.83000000f,-0.86000000f,-0.92000000f,0.88000000f,-0.11000000f,0.53000000f,0.06000000f,-0.45000000f,0.05000000f,0.78000000f,0.69000000f,0.22000000f,0.52000000f,0.11000000f,0.38000000f,-0.52000000f,0.47000000f,-0.02000000f,-0.43000000f,-0.19000000f,-0.39000000f,-0.45000000f,0.81000000f,0.29000000f,-0.97000000f,-0.04000000f,0.25000000f,-0.29000000f,-0.77000000f,0.46000000f,-0.62000000f,-0.92000000f,0.85000000f,-0.89000000f,-0.84000000f,0.03000000f,0.16000000f,0.47000000f,-0.18000000f,-0.60000000f,0.04000000f,0.71000000f,-0.99000000f,0.57000000f,0.12000000f,-0.83000000f,-0.26000000f,0.29000000f,-0.81000000f,-0.48000000f,0.91000000f,0.01000000f,-0.38000000f,0.50000000f,0.69000000f,0.38000000f,0.18000000f,0.03000000f,-0.64000000f,0.19000000f,0.10000000f,0.76000000f,0.27000000f,-0.34000000f,-0.28000000f,-0.74000000f,-0.26000000f,0.28000000f,-0.60000000f,0.95000000f,0.52000000f,0.84000000f,-0.20000000f,0.97000000f,0.93000000f,-0.56000000f,-0.29000000f,0.87000000f,-0.71000000f,0.20000000f,0.83000000f,-0.83000000f,0.69000000f,-0.86000000f,0.40000000f,0.34000000f,0.78000000f,-0.50000000f,-0.19000000f,0.50000000f,-0.78000000f,-0.11000000f,0.77000000f,-0.80000000f,0.95000000f,-0.22000000f,0.03000000f,-0.68000000f,-0.63000000f,0.74000000f,0.01000000f,-0.70000000f,-0.59000000f,-0.64000000f,-0.72000000f,0.83000000f,0.41000000f,-0.65000000f,-0.16000000f,-0.29000000f,0.55000000f,-0.63000000f,0.80000000f,-0.85000000f,-0.49000000f,0.45000000f,-0.54000000f,-0.00000000f,-0.36000000f,-0.04000000f,0.66000000f,-0.14000000f,0.15000000f,-0.44000000f,0.79000000f,-0.44000000f,0.81000000f,0.90000000f,0.65000000f,0.27000000f,-0.08000000f,0.28000000f,-0.88000000f,0.89000000f,-0.80000000f,-0.96000000f,-0.97000000f,0.56000000f,-0.72000000f,-0.68000000f,-0.26000000f,0.91000000f,0.43000000f,0.93000000f,-0.85000000f,-0.97000000f,-0.00000000f,0.04000000f,-0.68000000f,0.76000000f,0.61000000f,-0.66000000f,-0.08000000f,-0.75000000f,-0.95000000f,0.84000000f,0.47000000f,-0.66000000f,-0.92000000f,-0.50000000f,0.11000000f,-0.99000000f,0.22000000f,0.20000000f,0.00000000f,0.33000000f,0.14000000f,-0.35000000f,0.48000000f,0.42000000f,0.30000000f,0.89000000f,-0.93000000f,0.88000000f,-0.44000000f,0.08000000f,0.01000000f,0.03000000f,-0.14000000f,0.71000000f,0.24000000f,-0.17000000f,-0.68000000f,0.17000000f,0.53000000f,0.79000000f,0.97000000f,0.32000000f,0.58000000f,0.40000000f,-0.77000000f,-0.77000000f,0.14000000f,0.38000000f,0.69000000f,0.73000000f,0.88000000f,0.81000000f,0.67000000f,0.13000000f,-0.53000000f,-0.13000000f,-0.79000000f,0.70000000f,0.46000000f,0.71000000f,0.06000000f,-0.42000000f,0.96000000f,0.24000000f,0.02000000f,-0.31000000f,-0.18000000f,-0.87000000f,-0.70000000f,0.05000000f,-0.46000000f,-0.59000000f,-0.84000000f,0.12000000f,0.41000000f,-0.90000000f,0.45000000f,0.11000000f,0.02000000f,-0.49000000f,-0.26000000f,-0.41000000f,0.43000000f,-0.34000000f,-0.19000000f,-0.41000000f,-0.64000000f,-0.20000000f,0.22000000f,-0.20000000f,-0.05000000f,0.33000000f,-0.19000000f,0.69000000f,-0.85000000f,-0.01000000f,0.33000000f,0.07000000f,0.80000000f,-0.45000000f,-0.53000000f,-0.57000000f,0.88000000f,-0.80000000f,0.12000000f,0.60000000f,-0.31000000f,0.11000000f,0.33000000f,-0.10000000f,-0.09000000f,0.21000000f,-0.93000000f,-0.44000000f,0.18000000f,-0.13000000f,-0.33000000f,0.17000000f,0.38000000f,-0.43000000f,0.07000000f,0.30000000f,-0.10000000f,-0.25000000f,0.96000000f,-0.23000000f,0.91000000f,-0.47000000f,0.37000000f,0.52000000f,-0.96000000f,0.33000000f,0.37000000f,-0.75000000f,-0.91000000f,0.33000000f,0.11000000f,-0.92000000f,-0.98000000f,-0.74000000f,-0.26000000f,0.04000000f,-0.06000000f,0.38000000f,-0.73000000f,0.27000000f,0.88000000f,0.25000000f,-0.79000000f,0.48000000f,0.82000000f,0.98000000f,-0.97000000f,0.21000000f,-0.16000000f,0.56000000f,-0.03000000f,-0.53000000f,-0.13000000f,-0.73000000f,-0.31000000f,0.37000000f,-0.68000000f,-0.36000000f,0.42000000f,-0.21000000f,-0.02000000f,-0.57000000f,0.50000000f,0.00000000f,-0.87000000f,0.28000000f,0.27000000f,0.98000000f,-0.96000000f,0.21000000f,0.81000000f,-0.33000000f,-0.94000000f,-0.15000000f,-0.45000000f,0.93000000f,-0.36000000f,0.23000000f,0.64000000f,-0.04000000f,-0.13000000f,0.40000000f,-0.72000000f,0.17000000f,0.87000000f,-0.60000000f,-0.82000000f,-0.20000000f,0.32000000f,0.92000000f,0.99000000f,0.28000000f,-0.47000000f,0.50000000f,0.27000000f,0.58000000f,-0.98000000f,0.36000000f,0.90000000f,0.45000000f,-0.65000000f,0.26000000f,0.54000000f,-0.54000000f,0.35000000f,0.07000000f,-0.94000000f,0.23000000f,0.02000000f,0.87000000f,0.83000000f,0.09000000f,-0.83000000f,0.53000000f,0.44000000f,-0.93000000f,0.35000000f,-0.86000000f,-0.01000000f,0.38000000f,0.56000000f,-0.65000000f,0.72000000f,-0.04000000f,0.09000000f,0.17000000f,0.95000000f,-0.64000000f,0.91000000f,0.34000000f,-0.60000000f,-0.40000000f,0.73000000f,-0.66000000f,-0.65000000f,-0.21000000f,-0.17000000f,-0.12000000f,0.50000000f,0.27000000f,-0.68000000f,-0.74000000f,-0.27000000f,-0.64000000f,-0.75000000f,-0.01000000f,-0.50000000f,0.47000000f,-0.50000000f,-0.08000000f,-0.00000000f,-0.79000000f,0.99000000f,-0.01000000f,-0.69000000f,-0.60000000f,-0.95000000f,-0.11000000f,0.25000000f,-0.52000000f,-0.49000000f,0.31000000f,0.76000000f,-0.83000000f,-0.39000000f,-0.42000000f,-0.18000000f,0.06000000f,-0.04000000f,-0.74000000f,-0.27000000f,-0.23000000f,0.76000000f,0.33000000f,0.59000000f,-0.72000000f,-0.70000000f,-0.04000000f,0.63000000f,-0.21000000f,0.25000000f,0.16000000f,-0.03000000f,0.77000000f,0.03000000f,-0.74000000f,0.94000000f,-0.91000000f,-0.23000000f,0.47000000f,0.90000000f,0.82000000f,-0.58000000f,0.77000000f,-0.37000000f,0.05000000f,-0.51000000f,0.09000000f,-0.80000000f,0.95000000f,0.73000000f,0.28000000f,0.56000000f,-0.74000000f,-0.31000000f,0.37000000f,0.65000000f,0.32000000f,-0.50000000f,-0.52000000f,-0.68000000f,0.78000000f,0.82000000f,0.94000000f,0.27000000f,-0.44000000f,-0.05000000f,0.39000000f,-0.80000000f,-0.88000000f,0.42000000f,0.72000000f,0.02000000f,0.26000000f,-0.58000000f,0.21000000f,-0.90000000f,0.00000000f,0.36000000f,0.77000000f,-0.96000000f,-0.18000000f,0.99000000f,-0.71000000f,0.94000000f,-0.81000000f,-0.08000000f,-0.64000000f,-0.71000000f,-0.84000000f,-0.28000000f,0.44000000f,0.44000000f,0.80000000f,-0.17000000f,-0.50000000f,0.38000000f,0.75000000f,0.29000000f,0.54000000f,-0.56000000f,-0.40000000f,0.35000000f,0.59000000f,0.88000000f,-0.87000000f,0.03000000f,0.88000000f,-0.02000000f,0.26000000f,0.68000000f,0.38000000f,0.24000000f,0.03000000f,0.15000000f,0.28000000f,0.73000000f,0.67000000f,0.94000000f,-0.04000000f,0.18000000f,-0.19000000f,0.68000000f,-0.91000000f,0.41000000f,-0.50000000f,-0.36000000f,0.03000000f,-0.65000000f,0.44000000f,-0.73000000f,-0.18000000f,0.39000000f,0.40000000f,-0.53000000f,-0.94000000f,0.11000000f,0.71000000f,0.82000000f,-0.17000000f,0.65000000f,0.60000000f,0.93000000f,-0.99000000f,-0.11000000f,-0.83000000f,-0.31000000f,-0.09000000f,-0.08000000f,0.91000000f,-0.51000000f,-0.25000000f,0.52000000f,0.54000000f,0.23000000f,-0.00000000f,0.69000000f,0.88000000f,0.49000000f,-0.50000000f,0.99000000f,0.82000000f,-0.56000000f,-0.68000000f,0.18000000f,-0.38000000f,-0.97000000f,0.27000000f,-0.83000000f,0.63000000f,0.98000000f,-0.59000000f,0.43000000f,0.07000000f,-0.68000000f,-0.00000000f,-0.25000000f,-0.69000000f,-0.03000000f,0.86000000f,0.72000000f,0.53000000f,-0.95000000f,-0.88000000f,0.15000000f,0.43000000f,-0.61000000f,-0.03000000f,-0.56000000f,-0.44000000f,-0.35000000f,-0.46000000f,-0.21000000f,-0.80000000f,-0.63000000f,0.39000000f,-0.24000000f,-0.91000000f,0.24000000f,0.32000000f,-0.22000000f,0.73000000f,-0.24000000f,-0.53000000f,-0.22000000f,-0.62000000f,-0.39000000f,-0.40000000f,0.60000000f,0.78000000f,-0.11000000f,0.32000000f,-0.34000000f,0.53000000f,0.60000000f,0.10000000f,-0.59000000f,0.31000000f,0.77000000f,-0.54000000f,0.52000000f,0.68000000f,0.84000000f,-0.55000000f,-0.15000000f,0.16000000f,0.15000000f,-0.64000000f,0.73000000f,0.77000000f,-0.57000000f,-0.05000000f,0.36000000f,-0.03000000f,0.27000000f,0.93000000f,-0.88000000f,0.82000000f,0.40000000f,-0.69000000f,0.23000000f,0.01000000f,0.30000000f,-0.21000000f,0.09000000f,-0.18000000f,0.97000000f,0.33000000f,0.48000000f,-0.15000000f,-0.05000000f,-0.86000000f,0.81000000f,-0.33000000f,-0.92000000f,0.58000000f,0.47000000f,0.22000000f,0.81000000f,0.77000000f,-0.82000000f,-0.15000000f,0.82000000f,-0.53000000f,0.31000000f,0.30000000f,-0.16000000f,-0.24000000f,-0.24000000f,-0.80000000f,0.72000000f,-0.91000000f,-0.53000000f,-0.73000000f,0.85000000f,0.82000000f,-0.97000000f,-0.80000000f,-0.13000000f,-0.20000000f,0.40000000f,-0.70000000f,-0.35000000f,0.88000000f,0.08000000f,-0.48000000f,0.77000000f,0.62000000f,-0.16000000f,-0.47000000f,0.53000000f,0.11000000f,0.43000000f,-0.36000000f,-0.13000000f,-0.01000000f,-0.36000000f,0.88000000f,-0.89000000f,0.03000000f,0.69000000f,-0.36000000f,-0.98000000f,0.52000000f,0.28000000f,0.59000000f,0.27000000f,-0.43000000f,-0.75000000f,0.61000000f,0.67000000f,0.46000000f,-0.50000000f,-0.11000000f,-0.77000000f,-0.43000000f,-0.00000000f,-0.80000000f,0.91000000f,0.22000000f,-0.50000000f,-0.83000000f,-0.52000000f,0.94000000f,-0.92000000f,-0.36000000f,-0.96000000f,-0.40000000f,0.11000000f,-0.37000000f,0.08000000f,0.52000000f,0.53000000f,0.02000000f,-0.83000000f,0.54000000f,-0.48000000f,0.02000000f,-0.05000000f,0.32000000f,-0.78000000f,0.02000000f,-0.79000000f,0.34000000f,-0.54000000f,0.93000000f,-0.80000000f,0.32000000f,0.70000000f,-0.82000000f,0.92000000f,0.04000000f,0.83000000f,-0.26000000f,-0.68000000f,0.76000000f,0.78000000f,0.35000000f,0.71000000f,0.83000000f,0.52000000f,0.57000000f,-0.20000000f,0.12000000f,0.26000000f,-0.99000000f,0.47000000f,0.60000000f,-0.06000000f,-0.17000000f,0.26000000f,-0.60000000f,0.70000000f,-0.22000000f,-0.87000000f,-0.78000000f,0.29000000f,0.47000000f,0.76000000f,0.09000000f,0.73000000f,0.07000000f,-0.91000000f,-0.53000000f,-0.40000000f,0.78000000f,0.81000000f,-0.57000000f,-0.05000000f,-0.54000000f,-0.04000000f,-0.14000000f,0.80000000f,0.11000000f,-0.75000000f,0.56000000f,0.63000000f,-0.73000000f,-0.32000000f,0.86000000f,-0.98000000f,-0.64000000f,0.59000000f,-0.95000000f,0.63000000f,0.10000000f,0.24000000f,-0.83000000f,-0.60000000f,-0.67000000f,0.40000000f,-0.96000000f,-0.30000000f,-0.69000000f,0.70000000f,-0.89000000f,0.40000000f,-0.21000000f,0.83000000f,0.44000000f,0.71000000f,-0.85000000f,-0.05000000f,-0.95000000f,-0.83000000f,0.26000000f,-0.63000000f,0.37000000f,-0.05000000f,-0.76000000f,-0.47000000f,0.37000000f,0.01000000f,0.42000000f,-0.12000000f,0.99000000f,-0.43000000f,0.16000000f,-0.20000000f,-0.17000000f,-0.18000000f,-0.13000000f,-0.98000000f,-0.05000000f,-0.86000000f,0.40000000f,0.70000000f,-0.68000000f,0.93000000f,-0.62000000f,0.08000000f,-0.54000000f,-0.01000000f,0.82000000f,0.05000000f,-0.45000000f,-0.83000000f,-0.22000000f,-0.35000000f,0.54000000f,0.48000000f,0.12000000f,0.27000000f,-0.87000000f,-0.67000000f,-0.15000000f,0.02000000f,-0.67000000f,0.52000000f,0.24000000f,0.08000000f,-0.80000000f,0.09000000f,0.99000000f,0.31000000f,0.01000000f,0.83000000f,-0.99000000f,-0.90000000f,-0.23000000f,0.39000000f,0.75000000f,-0.51000000f,0.75000000f,0.37000000f,-0.28000000f,0.27000000f,-0.72000000f,0.71000000f,0.78000000f,0.95000000f,-0.05000000f,0.08000000f,-0.10000000f,-0.19000000f,0.43000000f,0.38000000f,-0.69000000f,-0.38000000f,0.67000000f,0.58000000f,0.86000000f,0.14000000f,0.86000000f,-0.06000000f,0.41000000f,-0.17000000f,-0.15000000f,0.96000000f,0.10000000f,0.20000000f,0.22000000f,-0.92000000f,-0.51000000f,-0.08000000f,0.84000000f,0.83000000f,-0.90000000f,0.51000000f,-0.07000000f,0.69000000f,0.84000000f,0.30000000f,0.35000000f,-0.01000000f,-0.01000000f,0.85000000f,0.76000000f,0.77000000f,-0.50000000f,0.67000000f,0.65000000f,-0.49000000f,-0.47000000f,-0.64000000f,0.63000000f,-0.12000000f,-0.84000000f,0.76000000f,0.50000000f,0.00000000f,-0.83000000f,-0.71000000f,0.43000000f,-0.10000000f,0.95000000f,0.86000000f,-0.77000000f,0.93000000f,-0.61000000f,-0.67000000f,-0.18000000f,-0.53000000f,-0.12000000f,-0.59000000f,0.95000000f,-0.97000000f,-0.08000000f,-0.20000000f,-0.65000000f,-0.78000000f,-0.02000000f,-0.47000000f,-0.55000000f,-0.77000000f,0.00000000f,-0.01000000f,-0.97000000f,0.29000000f,-0.68000000f,0.66000000f,-0.86000000f,0.70000000f,-0.53000000f,-0.99000000f,-0.29000000f,-0.87000000f,0.34000000f,0.13000000f,-0.12000000f,-0.64000000f,0.65000000f,-0.08000000f,0.80000000f,-0.37000000f,-0.01000000f,0.63000000f,-0.85000000f,0.37000000f,0.23000000f,0.06000000f,-0.57000000f,-0.99000000f,0.28000000f,-0.48000000f,0.70000000f,0.34000000f,0.08000000f,0.96000000f,-0.27000000f,0.36000000f,0.31000000f,-0.39000000f,-0.22000000f,-0.06000000f,-0.67000000f,-0.22000000f,-0.49000000f,0.77000000f,-0.16000000f,0.95000000f,-0.03000000f,-0.40000000f,0.67000000f,0.17000000f,0.73000000f,0.44000000f,-0.69000000f,0.78000000f,0.57000000f,-0.14000000f,-0.61000000f,-0.31000000f,0.73000000f,-0.71000000f,0.03000000f,0.95000000f,0.33000000f,-0.50000000f,0.69000000f,-0.11000000f,0.81000000f,-0.64000000f,0.67000000f,0.66000000f,-0.47000000f,-0.28000000f,-0.11000000f,0.11000000f,0.97000000f,0.67000000f,0.98000000f,0.38000000f,-0.07000000f,-0.38000000f,0.12000000f,-0.59000000f,0.89000000f,0.12000000f,0.05000000f,-0.03000000f,0.58000000f,-0.68000000f,-0.74000000f,0.57000000f,0.81000000f,0.23000000f,-0.35000000f,-0.27000000f,0.29000000f,-0.43000000f,0.03000000f,-0.60000000f,0.18000000f,0.07000000f,0.74000000f,-0.56000000f,0.70000000f,-0.11000000f,0.28000000f,-0.73000000f,0.14000000f,-0.60000000f,0.00000000f,-0.71000000f,-0.38000000f,0.39000000f,0.93000000f,-0.32000000f,0.75000000f,-0.39000000f,0.63000000f,-0.44000000f,-0.10000000f,0.10000000f,0.83000000f,0.56000000f,-0.07000000f,-0.25000000f,0.75000000f,0.96000000f,0.34000000f,-0.78000000f,-0.95000000f,-0.18000000f,0.36000000f,0.57000000f,-0.82000000f,0.44000000f,-0.57000000f,0.65000000f,0.40000000f,-0.02000000f,0.97000000f,0.31000000f,0.06000000f,-0.91000000f,-0.80000000f,-0.74000000f,-0.29000000f,0.46000000f,-0.58000000f,0.47000000f,0.25000000f,-0.06000000f,0.28000000f,0.98000000f,-0.56000000f,-0.13000000f,0.90000000f,0.28000000f,0.99000000f,0.78000000f,-0.46000000f,0.96000000f,-0.34000000f,-0.94000000f,0.22000000f,0.99000000f,-0.48000000f,0.18000000f,0.97000000f,-0.52000000f,0.98000000f,0.74000000f,-0.18000000f,0.04000000f,0.98000000f,-0.85000000f,-0.36000000f,-0.29000000f,-0.18000000f,-0.39000000f,-0.89000000f,0.49000000f,-0.71000000f,0.24000000f,0.59000000f,-0.85000000f,0.58000000f,0.86000000f,-0.68000000f,0.07000000f,0.72000000f,-0.32000000f,-0.76000000f,0.84000000f,0.05000000f,0.16000000f,0.68000000f,-0.76000000f,0.22000000f,-0.65000000f,-0.18000000f,-0.49000000f,-0.17000000f,0.70000000f,-0.42000000f,0.98000000f,0.18000000f,0.18000000f,0.22000000f,0.14000000f,0.35000000f,0.26000000f,-0.36000000f,0.98000000f,0.84000000f,-0.54000000f,0.13000000f,0.90000000f,0.46000000f,0.53000000f,-0.94000000f,-0.15000000f,-0.14000000f,0.77000000f,0.68000000f,0.16000000f,-0.49000000f,-0.43000000f,-0.83000000f,-0.33000000f,0.14000000f,-0.55000000f,-0.39000000f,-0.14000000f,0.08000000f,-0.78000000f,-0.79000000f,-0.65000000f,-0.65000000f,0.73000000f,0.97000000f,0.65000000f,0.50000000f,-0.51000000f,-0.24000000f,-0.88000000f,0.59000000f,0.74000000f,0.03000000f,-0.91000000f,0.33000000f,0.03000000f,-0.66000000f,-0.20000000f,-0.13000000f,0.94000000f,0.46000000f,0.41000000f,0.50000000f,0.45000000f,0.47000000f,-0.10000000f,-0.28000000f,-0.36000000f,-0.02000000f,-0.52000000f,0.11000000f,-0.19000000f,-0.70000000f,0.33000000f,0.20000000f,-0.85000000f,-0.15000000f,-0.89000000f,0.11000000f,0.68000000f,-0.64000000f,-0.70000000f,0.90000000f,-0.02000000f,-0.26000000f,-0.49000000f,0.88000000f,0.46000000f,0.75000000f,0.96000000f,0.46000000f,0.08000000f,0.43000000f,-0.14000000f,-0.17000000f,-0.74000000f,-0.75000000f,-0.19000000f,0.61000000f,-0.87000000f,0.84000000f,-0.04000000f,0.85000000f,0.16000000f,-0.73000000f,0.14000000f,-0.21000000f,0.21000000f,0.73000000f,0.92000000f,0.10000000f,-0.66000000f,0.37000000f,-0.64000000f,0.90000000f,0.32000000f,-0.46000000f,0.04000000f,0.80000000f,0.88000000f,0.13000000f,-0.88000000f,-0.48000000f,0.37000000f,0.42000000f,-0.35000000f,-0.92000000f,-0.16000000f,0.61000000f,-0.15000000f,0.17000000f,0.14000000f,0.89000000f,-0.15000000f,0.18000000f,0.94000000f,-0.13000000f,0.51000000f,-0.67000000f,0.64000000f,0.41000000f,0.45000000f,0.00000000f,-0.81000000f,0.06000000f,-0.06000000f,-0.48000000f,-0.92000000f,-0.42000000f,0.83000000f,-0.87000000f,0.29000000f,0.72000000f,0.70000000f,0.40000000f,0.79000000f,-0.80000000f,0.17000000f,0.32000000f,0.29000000f,-0.30000000f,-0.13000000f,0.82000000f,0.72000000f,-0.96000000f,-0.84000000f,-0.13000000f,-0.36000000f,0.10000000f,0.40000000f,0.59000000f,0.92000000f,-0.30000000f,-0.16000000f,-0.53000000f,-0.47000000f,0.14000000f,-0.82000000f,0.02000000f,0.81000000f,0.27000000f,-0.77000000f,0.63000000f,0.47000000f,0.24000000f,0.19000000f,-0.29000000f,-0.56000000f,-0.49000000f,-0.03000000f,0.60000000f,-0.84000000f,0.10000000f,-0.30000000f,-0.09000000f,0.78000000f,0.31000000f,-0.75000000f,0.19000000f,-0.10000000f,0.02000000f,0.45000000f,0.60000000f,-0.36000000f,0.68000000f,0.49000000f,-0.29000000f,-0.21000000f,0.54000000f,-0.66000000f,0.55000000f,0.03000000f,0.53000000f,0.25000000f,-0.47000000f,-0.13000000f,0.41000000f,0.74000000f,0.02000000f,-0.67000000f,-0.68000000f,-0.61000000f,-0.92000000f,-0.37000000f,-0.65000000f,-0.76000000f,-0.86000000f,0.83000000f,-0.84000000f,-0.79000000f,-0.36000000f,0.09000000f,0.43000000f,0.68000000f,-0.81000000f,-0.25000000f,0.81000000f,-0.66000000f,0.28000000f,0.33000000f,0.74000000f,0.56000000f,-0.29000000f,-0.84000000f,-0.76000000f,0.74000000f,-0.03000000f,0.52000000f,0.30000000f,0.18000000f,0.11000000f,-0.46000000f,0.28000000f,-0.15000000f,-0.27000000f,0.21000000f,0.79000000f,-0.46000000f,-0.41000000f,-0.70000000f,0.60000000f,-0.35000000f,-0.33000000f,-0.56000000f,-0.14000000f,0.17000000f,0.01000000f,-0.81000000f,-0.62000000f,-0.60000000f,0.39000000f,-0.62000000f,0.87000000f,0.83000000f,-0.00000000f,-0.47000000f,-0.39000000f,-0.97000000f,0.11000000f,0.22000000f,-0.32000000f,-0.21000000f,-0.25000000f,0.70000000f,0.70000000f,0.01000000f,0.04000000f,-0.38000000f,-0.12000000f,0.80000000f,0.85000000f,0.40000000f,0.87000000f,-0.59000000f,-0.99000000f,-0.17000000f,0.63000000f,0.30000000f,0.36000000f,0.77000000f,-0.25000000f,-0.50000000f,0.22000000f,-0.26000000f,0.49000000f,-0.97000000f,0.18000000f,-0.29000000f,-0.19000000f,-0.28000000f,0.34000000f,-0.69000000f,-0.15000000f,-0.50000000f,0.18000000f,0.68000000f,-0.31000000f,0.52000000f,-0.18000000f,-0.67000000f,-0.22000000f,0.11000000f,-0.58000000f,-0.17000000f,-0.21000000f,-0.01000000f,0.71000000f,0.93000000f,0.00000000f,0.41000000f,-0.72000000f,-0.66000000f,-0.26000000f,-0.57000000f,-0.06000000f,-0.44000000f,-0.06000000f,-0.79000000f,-0.14000000f,-0.09000000f,0.52000000f,0.67000000f,-0.65000000f,-0.52000000f,-0.85000000f,-0.52000000f,-0.18000000f,-0.70000000f,0.75000000f,-0.51000000f,-0.49000000f,-0.06000000f,0.81000000f,0.06000000f,-0.95000000f,0.53000000f,-0.80000000f,-0.16000000f,0.84000000f,0.97000000f,-0.53000000f,0.00000000f,-0.75000000f,-0.99000000f,-0.38000000f,0.07000000f,-0.44000000f,0.25000000f,0.31000000f,0.16000000f,-0.39000000f,-0.92000000f,-0.17000000f,-0.38000000f,-0.63000000f,0.27000000f,0.53000000f,0.56000000f,-0.82000000f,0.95000000f,0.69000000f,-0.25000000f,0.62000000f,-0.36000000f,-0.21000000f,0.15000000f,-0.82000000f,-0.73000000f,-0.77000000f,-0.78000000f,0.46000000f,-0.15000000f,0.44000000f,0.82000000f,-0.82000000f,-0.50000000f,-0.73000000f,-0.39000000f,-0.85000000f,0.89000000f,-0.30000000f,-0.48000000f,-0.96000000f,0.95000000f,0.66000000f,-0.08000000f,0.82000000f,-0.00000000f,-0.16000000f,0.99000000f,-0.49000000f,0.27000000f,0.88000000f,-0.69000000f,-0.36000000f,-0.81000000f,0.86000000f,-0.53000000f,0.79000000f,0.76000000f,0.56000000f,0.59000000f,-0.70000000f,0.31000000f,0.61000000f,0.80000000f,0.93000000f,0.90000000f,0.05000000f,0.42000000f,0.21000000f,-0.75000000f,-0.87000000f,0.48000000f,-0.83000000f,-0.58000000f,-0.53000000f,-0.20000000f,-0.34000000f,-0.08000000f,0.25000000f,-0.21000000f,-0.18000000f,-0.82000000f,0.59000000f,0.18000000f,-0.73000000f,0.50000000f,0.36000000f,0.01000000f,-0.54000000f,-0.40000000f,0.24000000f,-0.99000000f,-0.30000000f,-0.43000000f,-0.26000000f,0.53000000f,0.98000000f,0.90000000f,-0.68000000f,-0.57000000f,-0.02000000f,0.63000000f,-0.84000000f,-0.96000000f,-0.52000000f,0.32000000f,0.09000000f,-0.98000000f,-0.52000000f,0.64000000f,0.17000000f,0.82000000f,0.07000000f,0.92000000f,0.63000000f,-0.43000000f,-0.52000000f,0.06000000f,-0.85000000f,0.02000000f,-0.71000000f,-0.86000000f,-0.58000000f,-0.32000000f,0.79000000f,0.68000000f,0.02000000f,0.50000000f,-0.76000000f,-0.26000000f,-0.23000000f,0.03000000f,0.42000000f,-0.26000000f,-0.09000000f,-0.40000000f,0.84000000f,0.79000000f,-0.57000000f,-0.07000000f,-0.61000000f,-0.79000000f,-0.97000000f,0.16000000f,0.10000000f,0.45000000f,-0.04000000f,0.66000000f,-0.52000000f,-0.39000000f,-0.77000000f,0.94000000f,0.70000000f,0.61000000f,-0.96000000f,-0.33000000f,0.85000000f,0.53000000f,-0.74000000f,0.30000000f,0.31000000f,-0.33000000f,0.74000000f,-0.56000000f,-0.00000000f,-0.95000000f,-0.91000000f,-0.42000000f,0.85000000f,-0.02000000f,-0.06000000f,-0.73000000f,0.07000000f,-0.52000000f,0.10000000f,0.39000000f,0.90000000f,0.78000000f,-0.11000000f,0.58000000f,0.61000000f,0.30000000f,0.53000000f,0.51000000f,0.06000000f,0.62000000f,0.58000000f,0.39000000f,-0.78000000f,0.47000000f,-0.36000000f,-0.48000000f,0.29000000f,-0.98000000f,0.90000000f,-0.63000000f,-0.40000000f,0.77000000f,0.93000000f,0.32000000f,0.94000000f,0.76000000f,-0.86000000f,0.84000000f,-0.57000000f,-0.35000000f,-0.68000000f,0.58000000f,-0.70000000f,-0.87000000f,-0.13000000f,-0.99000000f,-0.46000000f,0.51000000f,0.28000000f,-0.22000000f,-0.92000000f,-0.02000000f,0.77000000f,0.91000000f,0.41000000f,-0.13000000f,-0.18000000f,-0.80000000f,-0.12000000f,0.99000000f,-0.62000000f,0.71000000f,-0.39000000f,-0.53000000f,-0.75000000f,-0.88000000f,-0.05000000f,0.84000000f,0.32000000f,0.87000000f,0.18000000f,0.71000000f,0.03000000f,-0.48000000f,-0.59000000f,0.43000000f,-0.44000000f,0.23000000f,-0.36000000f,0.79000000f,-0.27000000f,-0.30000000f,-0.35000000f,0.56000000f,0.99000000f,-0.35000000f,-0.89000000f,-0.45000000f,0.45000000f,-0.55000000f,0.27000000f,-0.29000000f,0.90000000f,-0.95000000f,-0.63000000f,0.31000000f,-0.28000000f,-0.56000000f,0.38000000f,-0.08000000f,-0.18000000f,0.51000000f,0.60000000f,-0.93000000f,-0.00000000f,0.89000000f,-0.52000000f,0.08000000f,-0.36000000f,-0.61000000f,0.71000000f,-0.06000000f,0.53000000f,-0.77000000f,-0.46000000f,-0.30000000f,-0.79000000f,-0.36000000f,0.59000000f,-0.32000000f,-0.28000000f,0.88000000f,-0.15000000f,0.99000000f,0.31000000f,0.84000000f,0.72000000f,0.45000000f,0.61000000f,-0.69000000f,0.73000000f,-0.28000000f,0.88000000f,-0.21000000f,0.65000000f,-0.54000000f,-0.76000000f,-0.33000000f,-0.53000000f,0.87000000f,-0.36000000f,0.96000000f,0.60000000f,-0.07000000f,0.43000000f,0.52000000f,0.68000000f,0.72000000f,-0.53000000f,-0.23000000f,0.09000000f,0.47000000f,-0.92000000f,-0.31000000f,-0.63000000f,-0.26000000f,-0.86000000f,0.28000000f,0.77000000f,-0.14000000f,0.63000000f,0.48000000f,0.81000000f,0.31000000f,0.94000000f,0.37000000f,0.93000000f,-0.70000000f,0.64000000f,-0.63000000f,-0.31000000f,-0.10000000f,-0.64000000f,0.61000000f,0.02000000f,-0.86000000f,-0.40000000f,-0.95000000f,-0.80000000f,0.98000000f,0.96000000f,-0.07000000f,0.33000000f,-0.59000000f,-0.13000000f,-0.54000000f,0.67000000f,-0.50000000f,0.14000000f,-0.30000000f,0.30000000f,-0.80000000f,0.71000000f,0.86000000f,0.26000000f,-0.97000000f,-0.57000000f,-0.88000000f,-0.95000000f,0.84000000f,-0.25000000f,0.58000000f,-0.28000000f,-0.61000000f,-0.55000000f,-0.03000000f,0.14000000f,-0.05000000f,0.66000000f,0.98000000f,-0.01000000f,-0.41000000f,0.06000000f,0.74000000f,0.09000000f,0.42000000f,0.34000000f,-0.06000000f,0.27000000f,-0.26000000f,-0.82000000f,-0.07000000f,0.67000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.07000000f,0.05000000f,-0.21000000f,0.35000000f,-0.77000000f,-0.39000000f,0.11000000f,0.15000000f,0.06000000f,0.17000000f,0.69000000f,0.25000000f,-0.89000000f,0.93000000f,-0.29000000f,-0.25000000f,-0.95000000f,0.74000000f,-0.29000000f,-0.22000000f,0.82000000f,-0.71000000f,0.39000000f,-0.54000000f,0.58000000f,0.41000000f,-0.82000000f,-0.65000000f,-0.41000000f,-0.74000000f,-0.09000000f,-0.08000000f,-0.53000000f,-0.06000000f,-0.02000000f,0.51000000f,0.76000000f,0.40000000f,0.23000000f,-0.14000000f,-0.71000000f,-0.59000000f,0.33000000f,0.14000000f,-0.98000000f,-0.01000000f,-0.45000000f,0.25000000f,-0.33000000f,-0.21000000f,0.47000000f,-0.28000000f,-0.43000000f,0.52000000f,-0.04000000f,0.04000000f,-0.63000000f,0.53000000f,-0.15000000f,-0.23000000f,-0.15000000f,0.04000000f,-0.99000000f,-0.69000000f,0.16000000f,0.26000000f,-0.21000000f,0.90000000f,0.99000000f,-0.91000000f,-0.69000000f,0.40000000f,-0.69000000f,-0.52000000f,0.18000000f,0.86000000f,-0.41000000f,0.69000000f,0.44000000f,-0.13000000f,-0.16000000f,0.89000000f,0.60000000f,-0.12000000f,0.06000000f,0.84000000f,-0.58000000f,0.71000000f,0.19000000f,0.81000000f,0.58000000f,-0.64000000f,-0.39000000f,-0.92000000f,-0.70000000f,-0.98000000f,-0.13000000f,0.07000000f,-0.99000000f,0.14000000f,0.69000000f,-0.20000000f,0.18000000f,-0.80000000f,0.34000000f,-0.79000000f,0.94000000f,0.34000000f,-0.81000000f,-0.69000000f,-0.72000000f,-0.07000000f,0.33000000f,0.06000000f,0.87000000f,-0.77000000f,0.72000000f,0.16000000f,0.74000000f,0.87000000f,-0.87000000f,0.57000000f,0.87000000f,0.65000000f,0.63000000f,-0.78000000f,0.71000000f,0.64000000f,-0.94000000f,0.45000000f,0.52000000f,0.61000000f,0.80000000f,0.56000000f,0.89000000f,-0.99000000f,0.31000000f,0.11000000f,-0.63000000f,0.21000000f,0.97000000f,0.04000000f,-0.59000000f,-0.81000000f,0.13000000f,0.46000000f,0.28000000f,0.01000000f,-0.22000000f,0.62000000f,-0.12000000f,0.64000000f,0.82000000f,-0.67000000f,-0.76000000f,0.87000000f,-0.23000000f,-0.43000000f,0.72000000f,-0.64000000f,0.08000000f,0.53000000f,-0.41000000f,-0.03000000f,-0.68000000f,0.62000000f,0.08000000f,0.37000000f,-0.12000000f,-0.52000000f,0.07000000f,0.06000000f,-0.28000000f,0.02000000f,0.35000000f,0.11000000f,0.38000000f,0.90000000f,-0.19000000f,-0.36000000f,0.95000000f,-0.53000000f,-0.66000000f,-0.30000000f,0.46000000f,0.44000000f,0.63000000f,0.15000000f,0.75000000f,-0.88000000f,-0.80000000f,-0.39000000f,-0.33000000f,0.45000000f,0.56000000f,-0.34000000f,0.98000000f,-0.50000000f,0.22000000f,0.15000000f,0.12000000f,0.62000000f,0.06000000f,0.82000000f,-0.40000000f,0.86000000f,0.56000000f,0.18000000f,0.13000000f,-0.30000000f,-0.98000000f,0.57000000f,-0.49000000f,-0.32000000f,-0.74000000f,0.91000000f,-0.07000000f,0.09000000f,0.35000000f,-0.22000000f,-0.42000000f,0.37000000f,0.41000000f,-0.01000000f,-0.45000000f,0.96000000f,-0.97000000f,-0.37000000f,0.58000000f,-0.74000000f,0.61000000f,0.37000000f,-0.25000000f,0.82000000f,0.99000000f,-0.22000000f,0.60000000f,-0.95000000f,0.35000000f,0.63000000f,-0.73000000f,-0.96000000f,0.40000000f,0.17000000f,-0.04000000f,0.01000000f,-0.45000000f,-0.52000000f,0.86000000f,0.32000000f,-0.97000000f,-0.67000000f,0.21000000f,0.60000000f,-0.88000000f,-0.17000000f,0.11000000f,-0.89000000f,0.52000000f,-0.93000000f,-0.17000000f,-0.94000000f,0.72000000f,-0.45000000f,0.81000000f,-0.85000000f,-0.63000000f,0.27000000f,0.72000000f,-0.99000000f,-0.74000000f,-0.70000000f,-0.06000000f,-0.28000000f,0.28000000f,0.89000000f,-0.38000000f,-0.36000000f,0.28000000f,0.51000000f,-0.29000000f,-0.04000000f,-0.22000000f,-0.77000000f,0.62000000f,0.68000000f,0.73000000f,-0.29000000f,0.96000000f,0.26000000f,0.36000000f,-0.79000000f,0.93000000f,0.23000000f,0.06000000f,-0.99000000f,0.93000000f,0.34000000f,-0.40000000f,0.43000000f,-0.80000000f,-0.60000000f,-0.64000000f,-0.17000000f,-0.89000000f,-0.56000000f,-0.81000000f,0.70000000f,-0.67000000f,0.57000000f,0.57000000f,-0.77000000f,-0.28000000f,-0.39000000f,-0.58000000f,-0.35000000f,-0.02000000f,0.21000000f,-0.43000000f,0.60000000f,-0.95000000f,-0.44000000f,0.40000000f,-0.22000000f,0.44000000f,-0.94000000f,0.21000000f,-0.21000000f,-0.38000000f,-0.06000000f,0.43000000f,-0.48000000f,0.49000000f,-0.79000000f,0.31000000f,-0.91000000f,0.34000000f,0.89000000f,0.10000000f,0.50000000f,0.48000000f,0.29000000f,0.00000000f,0.24000000f,0.50000000f,0.56000000f,-0.73000000f,-0.10000000f,0.23000000f,0.29000000f,0.59000000f,-0.02000000f,-0.76000000f,-0.46000000f,-0.97000000f,-0.06000000f,-0.46000000f,0.51000000f,0.14000000f,0.97000000f,-0.37000000f,0.65000000f,-0.74000000f,-0.20000000f,-0.29000000f,0.57000000f,-0.80000000f,-0.34000000f,-0.33000000f,0.17000000f,-0.86000000f,0.58000000f,-0.85000000f,-0.08000000f,0.09000000f,-0.88000000f,0.57000000f,-0.78000000f,-0.55000000f,-0.72000000f,0.18000000f,-0.45000000f,0.37000000f,-0.51000000f,-0.77000000f,0.83000000f,-0.39000000f,0.73000000f,-0.87000000f,-0.18000000f,-0.95000000f,0.94000000f,-0.21000000f,0.70000000f,0.56000000f,0.25000000f,0.99000000f,0.14000000f,0.18000000f,-0.35000000f,0.72000000f,0.09000000f,0.98000000f,0.85000000f,0.10000000f,0.97000000f,0.42000000f,-0.15000000f,-0.85000000f,0.89000000f,0.67000000f,0.99000000f,-0.08000000f,0.32000000f,0.08000000f,0.55000000f,0.96000000f,-0.52000000f,-0.63000000f,-0.21000000f,-0.50000000f,0.79000000f,0.10000000f,0.61000000f,-0.96000000f,-0.47000000f,0.59000000f,-0.02000000f,-0.39000000f,0.89000000f,0.31000000f,0.94000000f,-0.84000000f,0.47000000f,0.79000000f,0.82000000f,-0.18000000f,-0.41000000f,-0.22000000f,-0.99000000f,-0.68000000f,-0.35000000f,0.86000000f,0.16000000f,0.68000000f,0.05000000f,-0.11000000f,-0.65000000f,0.23000000f,-0.81000000f,-0.92000000f,-0.70000000f,0.60000000f,-0.65000000f,-0.37000000f,-0.23000000f,0.10000000f,0.15000000f,0.19000000f,-0.03000000f,0.74000000f,-0.07000000f,0.12000000f,-0.49000000f,0.67000000f,-0.91000000f,0.38000000f,0.53000000f,0.86000000f,-0.41000000f,-0.39000000f,-0.79000000f,-0.48000000f,-0.83000000f,-0.58000000f,0.18000000f,-0.96000000f,-0.77000000f,-0.47000000f,-0.38000000f,0.32000000f,0.23000000f,0.85000000f,0.35000000f,0.40000000f,-0.27000000f,0.66000000f,0.62000000f,0.65000000f,-0.94000000f,-0.69000000f,-0.93000000f,0.69000000f,-0.20000000f,0.05000000f,-0.67000000f,-0.18000000f,-0.36000000f,-0.31000000f,0.15000000f,-0.01000000f,0.86000000f,-0.72000000f,-0.94000000f,0.41000000f,-0.22000000f,-0.86000000f,-0.56000000f,0.69000000f,0.09000000f,-0.00000000f,-0.80000000f,0.05000000f,0.98000000f,0.95000000f,0.46000000f,-0.33000000f,-0.38000000f,-0.04000000f,-0.53000000f,-0.12000000f,0.82000000f,-0.55000000f,-0.79000000f,0.10000000f,-0.14000000f,-0.68000000f,-0.29000000f,0.14000000f,0.93000000f,0.64000000f,0.97000000f,0.37000000f,0.69000000f,0.73000000f,-0.57000000f,0.11000000f,-0.75000000f,-0.07000000f,0.74000000f,0.25000000f,-0.57000000f,0.67000000f,0.60000000f,-0.26000000f,-0.35000000f,-0.19000000f,0.55000000f,0.42000000f,-0.62000000f,0.63000000f,-0.87000000f,-0.82000000f,0.60000000f,-0.10000000f,-0.67000000f,0.89000000f,-0.38000000f,0.29000000f,0.30000000f,0.81000000f,0.95000000f,0.43000000f,-0.64000000f,0.91000000f,0.37000000f,0.96000000f,-0.71000000f,0.55000000f,0.06000000f,-0.95000000f,-0.56000000f,0.34000000f,0.25000000f,0.05000000f,0.26000000f,0.28000000f,0.95000000f,0.68000000f,-0.63000000f,-0.80000000f,0.63000000f,-0.09000000f,-0.06000000f,0.26000000f,-0.34000000f,-0.27000000f,-0.57000000f,0.99000000f,-0.48000000f,0.10000000f,0.96000000f,-0.17000000f,0.70000000f,-0.76000000f,-0.49000000f,0.37000000f,-0.81000000f,-0.05000000f,-0.67000000f,0.70000000f,-0.94000000f,-0.15000000f,-0.98000000f,0.03000000f,-0.77000000f,0.97000000f,-0.61000000f,-0.32000000f,0.63000000f,-0.01000000f,-0.42000000f,-0.89000000f,0.41000000f,0.14000000f,0.11000000f,-0.61000000f,-0.05000000f,0.32000000f,0.21000000f,0.64000000f,0.36000000f,-0.44000000f,0.05000000f,-0.33000000f,0.19000000f,-0.43000000f,-0.40000000f,-0.89000000f,0.90000000f,0.67000000f,0.66000000f,-0.37000000f,-0.67000000f,-0.63000000f,0.93000000f,0.29000000f,0.28000000f,0.41000000f,0.17000000f,-0.76000000f,-0.61000000f,-0.48000000f,-0.86000000f,-0.13000000f,-0.55000000f,0.96000000f,-0.06000000f,-0.14000000f,0.97000000f,0.86000000f,-0.20000000f,0.88000000f,0.40000000f,0.64000000f,0.79000000f,0.47000000f,-0.09000000f,-0.26000000f,-0.31000000f,0.74000000f,-0.09000000f,-0.49000000f,0.64000000f,-0.40000000f,-0.31000000f,-0.87000000f,-0.68000000f,0.40000000f,-0.44000000f,0.19000000f,0.10000000f,-0.69000000f,0.42000000f,-0.59000000f,0.84000000f,-0.39000000f,-0.85000000f,0.33000000f,0.44000000f,0.12000000f,0.69000000f,0.02000000f,-0.71000000f,0.57000000f,-0.16000000f,-0.67000000f,0.53000000f,-0.95000000f,0.37000000f,0.42000000f,0.40000000f,0.76000000f,-0.61000000f,0.02000000f,0.77000000f,0.66000000f,0.54000000f,-0.37000000f,-0.76000000f,-0.56000000f,0.77000000f,0.57000000f,0.99000000f,-0.02000000f,0.00000000f,0.54000000f,0.19000000f,0.89000000f,-0.32000000f,-0.00000000f,-0.74000000f,-0.82000000f,0.43000000f,0.42000000f,0.35000000f,-0.81000000f,0.68000000f,-0.52000000f,-0.17000000f,0.18000000f,0.29000000f,0.76000000f,-0.73000000f,0.01000000f,-0.28000000f,0.04000000f,0.21000000f,0.89000000f,-0.40000000f,0.04000000f,0.13000000f,-0.95000000f,0.33000000f,0.47000000f,0.18000000f,0.61000000f,-0.83000000f,-0.08000000f,-0.08000000f,-0.75000000f,0.30000000f,0.42000000f,0.76000000f,0.25000000f,0.18000000f,-0.84000000f,0.11000000f,-0.94000000f,-0.42000000f,-0.16000000f,-0.97000000f,0.54000000f,0.11000000f,0.37000000f,0.10000000f,-0.39000000f,-0.20000000f,0.09000000f,0.04000000f,-0.92000000f,0.97000000f,0.98000000f,-0.78000000f,0.58000000f,-0.74000000f,0.92000000f,-0.27000000f,0.16000000f,-0.42000000f,-0.31000000f,0.39000000f,0.23000000f,-0.65000000f,0.24000000f,-0.92000000f,0.52000000f,0.98000000f,0.39000000f,0.51000000f,0.98000000f,-0.98000000f,0.34000000f,0.68000000f,-0.84000000f,0.41000000f,-0.87000000f,0.55000000f,0.39000000f,0.16000000f,0.37000000f,0.01000000f,0.82000000f,0.91000000f,-0.82000000f,-0.76000000f,0.65000000f,-0.45000000f,0.44000000f,0.07000000f,-0.46000000f,0.64000000f,-0.63000000f,-0.11000000f,0.54000000f,-0.92000000f,-0.11000000f,-0.94000000f,-0.78000000f,-0.88000000f,0.68000000f,-0.11000000f,0.78000000f,0.28000000f,-0.08000000f,0.99000000f,0.27000000f,0.73000000f,-0.55000000f,0.05000000f,0.69000000f,-0.69000000f,-0.83000000f,0.70000000f,-0.24000000f,0.26000000f,-0.86000000f,0.69000000f,0.91000000f,0.43000000f,0.84000000f,-0.60000000f,0.31000000f,0.74000000f,0.57000000f,-0.93000000f,-0.85000000f,-0.74000000f,0.73000000f,-0.15000000f,0.30000000f,0.70000000f,-0.15000000f,0.09000000f,-0.46000000f,0.59000000f,0.05000000f,0.34000000f,0.33000000f,0.17000000f,-0.08000000f,0.03000000f,-0.60000000f,0.93000000f,0.11000000f,-0.13000000f,-0.65000000f,-0.19000000f,0.49000000f,0.82000000f,-0.77000000f,0.22000000f,-0.02000000f,0.79000000f,0.06000000f,0.16000000f,-0.79000000f,-0.30000000f,-0.48000000f,0.62000000f,-0.12000000f,-0.95000000f,-0.87000000f,-0.94000000f,-0.90000000f,-0.33000000f,0.60000000f,-0.21000000f,0.88000000f,-0.28000000f,0.46000000f,-0.14000000f,0.13000000f,-0.11000000f,-0.17000000f,-0.03000000f,0.19000000f,-0.04000000f,-0.34000000f,-0.14000000f,0.65000000f,-0.35000000f,-0.66000000f,-0.75000000f,0.25000000f,-0.91000000f,-0.45000000f,-0.59000000f,0.32000000f,0.75000000f,-0.24000000f,-0.14000000f,0.10000000f,-0.24000000f,0.03000000f,-0.83000000f,0.90000000f,0.08000000f,0.09000000f,0.65000000f,-0.39000000f,-0.80000000f,0.26000000f,0.36000000f,-0.14000000f,-0.53000000f,0.21000000f,-0.06000000f,0.63000000f,0.94000000f,-0.86000000f,0.30000000f,0.91000000f,-0.01000000f,-0.61000000f,0.67000000f,-0.44000000f,-0.57000000f,0.28000000f,0.83000000f,-0.46000000f,-0.18000000f,-0.27000000f,-0.25000000f,0.43000000f,0.55000000f,-0.74000000f,-0.39000000f,0.51000000f,0.62000000f,0.70000000f,0.17000000f,0.61000000f,-0.87000000f,-0.76000000f,-0.28000000f,0.80000000f,-0.09000000f,0.48000000f,-0.68000000f,0.46000000f,0.76000000f,0.73000000f,-0.06000000f,0.15000000f,0.01000000f,0.84000000f,-0.71000000f,0.43000000f,-0.82000000f,0.77000000f,-0.86000000f,0.30000000f,0.01000000f,-0.03000000f,-0.79000000f,-0.96000000f,0.75000000f,0.36000000f,-0.18000000f,-0.23000000f,0.79000000f,0.36000000f,-0.77000000f,0.96000000f,0.60000000f,0.11000000f,-0.73000000f,-0.44000000f,-0.15000000f,-0.54000000f,0.94000000f,-0.54000000f,0.73000000f,0.43000000f,0.70000000f,-0.02000000f,-0.47000000f,0.14000000f,-0.07000000f,-0.78000000f,-0.12000000f,0.61000000f,-0.65000000f,0.28000000f,-0.66000000f,-0.56000000f,0.76000000f,0.56000000f,0.52000000f,-0.43000000f,0.31000000f,0.11000000f,-0.94000000f,0.04000000f,-0.52000000f,-0.37000000f,0.86000000f,-0.74000000f,-0.38000000f,-0.40000000f,0.41000000f,-0.40000000f,0.09000000f,-0.07000000f,-0.79000000f,-0.08000000f,-0.32000000f,-0.87000000f,-0.31000000f,0.21000000f,-0.58000000f,-0.18000000f,-0.86000000f,0.29000000f,-0.28000000f,0.30000000f,-0.52000000f,0.41000000f,0.66000000f,0.10000000f,-0.40000000f,0.70000000f,0.29000000f,-0.20000000f,-0.25000000f,0.33000000f,0.32000000f,-0.14000000f,0.39000000f,-0.41000000f,0.65000000f,-0.88000000f,0.82000000f,0.34000000f,-0.80000000f,0.06000000f,0.86000000f,-0.69000000f,-0.84000000f,-0.36000000f,0.43000000f,0.25000000f,-0.80000000f,0.84000000f,0.19000000f,-0.80000000f,0.53000000f,-0.53000000f,0.04000000f,-0.54000000f,-0.26000000f,-0.59000000f,0.21000000f,-0.45000000f,0.53000000f,-0.17000000f,0.52000000f,0.35000000f,0.72000000f,0.16000000f,-0.31000000f,0.12000000f,-0.03000000f,-0.92000000f,0.02000000f,0.27000000f,0.52000000f,0.34000000f,-0.66000000f,-0.46000000f,-0.14000000f,0.81000000f,0.00000000f,0.92000000f,-0.49000000f,0.80000000f,0.40000000f,-0.90000000f,0.34000000f,0.12000000f,0.47000000f,0.16000000f,-0.66000000f,-0.83000000f,0.30000000f,0.10000000f,-0.99000000f,0.95000000f,0.61000000f,0.92000000f,0.90000000f,-0.46000000f,0.99000000f,0.38000000f,0.38000000f,0.79000000f,-0.33000000f,0.28000000f,0.69000000f,0.44000000f,-0.18000000f,-0.66000000f,0.07000000f,0.65000000f,-0.06000000f,-0.24000000f,-0.70000000f,0.01000000f,-0.31000000f,-0.40000000f,0.19000000f,0.93000000f,-0.52000000f,-0.29000000f,-0.59000000f,-0.55000000f,-0.57000000f,-0.61000000f,-0.51000000f,0.99000000f,0.22000000f,0.51000000f,0.71000000f,0.39000000f,0.59000000f,0.38000000f,0.02000000f,-0.98000000f,0.56000000f,-0.04000000f,-0.02000000f,0.44000000f,-0.85000000f,-0.70000000f,-0.70000000f,-0.02000000f,-0.09000000f,-0.96000000f,0.72000000f,0.25000000f,-0.20000000f,0.15000000f,0.68000000f,-0.90000000f,-0.91000000f,-0.99000000f,-0.21000000f,-0.59000000f,-0.38000000f,-0.02000000f,-0.84000000f,-0.50000000f,0.68000000f,-0.22000000f,-0.88000000f,0.25000000f,0.98000000f,-0.10000000f,-0.37000000f,-0.14000000f,0.70000000f,0.03000000f,0.45000000f,0.17000000f,-0.01000000f,0.33000000f,-0.15000000f,0.03000000f,-0.66000000f,-0.05000000f,-0.10000000f,0.35000000f,-0.00000000f,-0.12000000f,-0.79000000f,0.76000000f,0.29000000f,-0.27000000f,0.79000000f,-0.57000000f,0.62000000f,0.65000000f,0.84000000f,-0.17000000f,0.23000000f,0.74000000f,0.98000000f,-0.24000000f,-0.96000000f,-0.16000000f,0.76000000f,-0.22000000f,0.35000000f,-0.39000000f,0.67000000f,0.59000000f,0.91000000f,0.88000000f,0.69000000f,-0.72000000f,0.43000000f,0.55000000f,-0.55000000f,0.94000000f,0.34000000f,-0.74000000f,-0.44000000f,-0.48000000f,-0.92000000f,-0.62000000f,0.79000000f,0.52000000f,-0.59000000f,-0.14000000f,-0.20000000f,0.14000000f,0.65000000f,-0.27000000f,0.71000000f,-0.80000000f,0.29000000f,-0.15000000f,0.15000000f,0.30000000f,-0.65000000f,-0.17000000f,-0.72000000f,-0.90000000f,0.99000000f,-0.20000000f,0.40000000f,-0.59000000f,0.46000000f,-0.69000000f,0.97000000f,-0.86000000f,0.35000000f,-0.96000000f,0.22000000f,0.26000000f,-0.87000000f,-0.46000000f,-0.54000000f,0.30000000f,0.28000000f,0.63000000f,0.43000000f,-0.87000000f,-0.16000000f,0.40000000f,0.07000000f,-0.04000000f,0.67000000f,-0.30000000f,-0.45000000f,0.88000000f,0.92000000f,0.05000000f,0.24000000f,0.18000000f,-0.29000000f,0.26000000f,0.57000000f,-0.35000000f,0.49000000f,-0.16000000f,0.32000000f,-0.79000000f,-0.29000000f,-0.87000000f,-0.72000000f,0.40000000f,-0.44000000f,-0.69000000f,-0.93000000f,-0.85000000f,0.92000000f,0.00000000f,0.66000000f,-0.32000000f,0.94000000f,0.40000000f,0.81000000f,0.67000000f,-0.72000000f,-0.11000000f,0.82000000f,-0.83000000f,-0.53000000f,-0.01000000f,0.18000000f,-0.95000000f,-0.41000000f,-0.98000000f,-0.08000000f,0.24000000f,-0.33000000f,0.72000000f,-0.81000000f,0.21000000f,0.46000000f,0.25000000f,-0.74000000f,0.78000000f,0.68000000f,-0.20000000f,-0.66000000f,0.73000000f,-0.09000000f,0.98000000f,0.50000000f,0.38000000f,0.95000000f,-0.79000000f,0.47000000f,0.95000000f,-0.28000000f,-0.03000000f,0.15000000f,0.25000000f,0.61000000f,0.10000000f,-0.42000000f,0.98000000f,-0.93000000f,-0.47000000f,-0.03000000f,0.31000000f,0.50000000f,-0.24000000f,0.42000000f,-0.03000000f,-0.75000000f,0.75000000f,0.86000000f,0.07000000f,0.79000000f,0.39000000f,0.58000000f,-0.09000000f,-0.04000000f,0.63000000f,-0.49000000f,0.89000000f,0.64000000f,0.14000000f,-0.70000000f,0.04000000f,-0.24000000f,0.42000000f,0.98000000f,-0.88000000f,-0.86000000f,0.43000000f,-0.17000000f,-0.79000000f,-0.15000000f,-0.43000000f,0.97000000f,-0.88000000f,-0.97000000f,0.87000000f,-0.61000000f,0.56000000f,0.53000000f,0.94000000f,0.26000000f,-0.71000000f,0.68000000f,-0.19000000f,0.87000000f,0.00000000f,-0.02000000f,0.33000000f,0.91000000f,-0.36000000f,0.60000000f,-0.55000000f,-0.04000000f,-0.58000000f,-0.07000000f,0.18000000f,0.42000000f,-0.77000000f,-0.66000000f,-0.90000000f,-0.23000000f,-0.94000000f,0.90000000f,-0.37000000f,-0.63000000f,0.57000000f,0.98000000f,-0.46000000f,-0.47000000f,0.79000000f,0.63000000f,-0.05000000f,-0.39000000f,-0.51000000f,0.22000000f,0.23000000f,-0.89000000f,-0.01000000f,0.98000000f,-0.59000000f,-0.85000000f,0.12000000f,0.24000000f,0.63000000f,-0.69000000f,0.84000000f,-0.15000000f,0.48000000f,-0.16000000f,0.14000000f,0.78000000f,0.84000000f,0.86000000f,-0.80000000f,-0.05000000f,-0.42000000f,0.32000000f,-0.39000000f,-0.27000000f,0.85000000f,-0.58000000f,0.96000000f,-0.53000000f,-0.40000000f,-0.75000000f,0.76000000f,-0.87000000f,-0.39000000f,0.73000000f,0.48000000f,0.87000000f,-0.49000000f,0.94000000f,-0.25000000f,-0.19000000f,-0.30000000f,0.56000000f,-0.35000000f,0.09000000f,0.62000000f,0.02000000f,0.07000000f,-0.32000000f,0.83000000f,0.87000000f,0.96000000f,0.50000000f,0.16000000f,0.12000000f,-0.21000000f,-0.77000000f,-0.69000000f,0.95000000f,-0.84000000f,-0.93000000f,-0.83000000f,0.68000000f,0.06000000f,0.48000000f,-0.95000000f,0.44000000f,0.62000000f,0.21000000f,-0.62000000f,-0.11000000f,0.21000000f,-0.74000000f,-0.04000000f,0.07000000f,0.47000000f,-0.07000000f,-0.27000000f,0.71000000f,0.70000000f,-0.55000000f,0.13000000f,-0.50000000f,0.63000000f,-0.51000000f,0.48000000f,-0.19000000f,0.17000000f,-0.34000000f,-0.87000000f,-0.28000000f,-0.71000000f,0.16000000f,-0.56000000f,0.39000000f,-0.14000000f,0.26000000f,-0.09000000f,-0.48000000f,-0.10000000f,0.50000000f,-0.83000000f,0.02000000f,-0.39000000f,0.19000000f,0.10000000f,0.73000000f,-0.43000000f,-0.47000000f,0.79000000f,0.75000000f,0.89000000f,-0.38000000f,-0.72000000f,-0.93000000f,-0.22000000f,-0.00000000f,0.43000000f,0.07000000f,-0.96000000f,0.08000000f,0.63000000f,-0.55000000f,-0.55000000f,0.83000000f,-0.12000000f,-0.70000000f,0.03000000f,-0.51000000f,0.61000000f,0.49000000f,0.95000000f,0.93000000f,0.69000000f,0.88000000f,-0.10000000f,0.50000000f,-0.05000000f,-0.59000000f,0.36000000f,-0.85000000f,-0.02000000f,-0.02000000f,0.75000000f,-0.77000000f,-0.49000000f,0.16000000f,0.75000000f,-0.08000000f,-0.44000000f,0.17000000f,-0.87000000f,-0.19000000f,-0.60000000f,0.03000000f,-0.30000000f,-0.21000000f,-0.58000000f,0.08000000f,-0.47000000f,-0.03000000f,0.39000000f,0.61000000f,0.71000000f,0.10000000f,0.18000000f,0.53000000f,-0.62000000f,-0.72000000f,0.72000000f,-0.87000000f,-0.45000000f,-0.57000000f,0.14000000f,0.65000000f,-0.14000000f,-0.65000000f,0.17000000f,-0.89000000f,-0.35000000f,0.22000000f,-0.82000000f,-0.23000000f,-0.56000000f,0.25000000f,0.82000000f,0.98000000f,0.24000000f,0.76000000f,-0.27000000f,-0.97000000f,-0.14000000f,-0.99000000f,0.95000000f,0.73000000f,-0.37000000f,-0.26000000f,0.73000000f,-0.51000000f,0.42000000f,-0.25000000f,0.76000000f,0.59000000f,-0.54000000f,0.18000000f,0.12000000f,0.41000000f,0.41000000f,-0.45000000f,0.44000000f,-0.26000000f,-0.10000000f,-0.21000000f,-0.33000000f,0.82000000f,-0.88000000f,0.33000000f,-0.83000000f,-0.47000000f,0.08000000f,0.36000000f,-0.59000000f,-0.77000000f,0.70000000f,-0.23000000f,0.72000000f,0.77000000f,-0.99000000f,0.36000000f,0.16000000f,0.62000000f,0.35000000f,-0.99000000f,0.99000000f,-0.32000000f,0.39000000f,-0.09000000f,0.15000000f,0.97000000f,-0.42000000f,-0.51000000f,-0.98000000f,-0.23000000f,-0.81000000f,-0.62000000f,0.36000000f,-0.63000000f,0.33000000f,-0.67000000f,-0.84000000f,0.17000000f,0.26000000f,-0.57000000f,0.77000000f,-0.86000000f,0.54000000f,-0.11000000f,0.97000000f,-0.29000000f,0.45000000f,-0.59000000f,-0.39000000f,0.21000000f,-0.40000000f,0.03000000f,0.36000000f,0.41000000f,0.56000000f,0.76000000f,0.71000000f,-0.62000000f,-0.49000000f,0.99000000f,0.03000000f,0.55000000f,-0.15000000f,0.03000000f,0.62000000f,-0.62000000f,-0.02000000f,-0.53000000f,0.64000000f,-0.24000000f,0.14000000f,0.67000000f,-0.58000000f,-0.90000000f,0.66000000f,0.44000000f,-0.15000000f,0.16000000f,0.92000000f,0.84000000f,0.61000000f,0.45000000f,0.01000000f,-0.23000000f,0.51000000f,0.65000000f,-0.04000000f,-0.61000000f,-0.66000000f,0.76000000f,-0.52000000f,0.63000000f,0.82000000f,0.67000000f,0.81000000f,-0.08000000f,0.14000000f,0.91000000f,0.20000000f,-0.82000000f,-0.90000000f,0.70000000f,0.65000000f,0.87000000f,0.38000000f,0.77000000f,0.52000000f,0.40000000f,-0.57000000f,0.19000000f,0.58000000f,0.50000000f,0.78000000f,-0.09000000f,-0.93000000f,0.67000000f,0.06000000f,0.11000000f,0.36000000f,-0.40000000f,0.37000000f,0.53000000f,0.01000000f,-0.09000000f,0.89000000f,-0.87000000f,0.99000000f,-0.54000000f,0.92000000f,-0.45000000f,0.69000000f,-0.22000000f,0.92000000f,-0.01000000f,0.04000000f,0.68000000f,-0.96000000f,-0.56000000f,0.26000000f,0.24000000f,0.77000000f,-0.31000000f,0.23000000f,0.26000000f,-0.09000000f,-0.12000000f,-0.57000000f,0.35000000f,-0.80000000f,0.36000000f,0.36000000f,0.55000000f,0.85000000f,-0.60000000f,0.12000000f,-0.96000000f,-0.54000000f,-0.58000000f,-0.21000000f,0.62000000f,0.60000000f,0.64000000f,0.70000000f,-0.14000000f,-0.63000000f,-0.14000000f,0.55000000f,0.25000000f,0.21000000f,-0.19000000f,0.42000000f,-0.61000000f,-0.08000000f,-0.38000000f,-0.86000000f,0.08000000f,0.48000000f,-0.58000000f,0.82000000f,0.14000000f,0.50000000f,0.81000000f,0.07000000f,0.24000000f,0.03000000f,0.54000000f,0.47000000f,-0.97000000f,-0.80000000f,-0.76000000f,-0.86000000f,0.80000000f,-0.14000000f,-0.04000000f,-0.54000000f,0.61000000f,-0.42000000f,-0.90000000f,0.94000000f,-0.84000000f,0.15000000f,-0.72000000f,0.52000000f,0.10000000f,-0.48000000f,0.42000000f,-0.63000000f,0.93000000f,-0.80000000f,-0.17000000f,-0.29000000f,-0.87000000f,-0.24000000f,0.99000000f,0.75000000f,0.78000000f,-0.39000000f,-0.94000000f,0.46000000f,0.34000000f,-0.93000000f,0.87000000f,-0.18000000f,0.20000000f,0.33000000f,0.91000000f,0.12000000f,0.62000000f,-0.19000000f,-0.50000000f,-0.20000000f,0.73000000f,0.81000000f,-0.04000000f,-0.26000000f,0.16000000f,-0.24000000f,0.60000000f,-0.69000000f,0.59000000f,0.18000000f,0.02000000f,-0.00000000f,-0.28000000f,0.48000000f,-0.29000000f,-0.97000000f,0.11000000f,-0.34000000f,-0.22000000f,0.74000000f,0.53000000f,0.11000000f,-0.97000000f,-0.50000000f,-0.46000000f,-0.96000000f,-0.93000000f,-0.02000000f,-0.23000000f,0.04000000f,-0.30000000f,-0.79000000f,-0.46000000f,0.03000000f,-0.18000000f,0.71000000f,0.73000000f,0.27000000f,0.76000000f,0.65000000f,0.52000000f,0.34000000f,0.54000000f,-0.36000000f,0.02000000f,0.90000000f,-0.24000000f,-0.44000000f,-0.81000000f,-0.22000000f,0.50000000f,-0.25000000f,-0.94000000f,0.91000000f,-0.57000000f,-0.38000000f,0.95000000f,-0.05000000f,0.46000000f,-0.74000000f,-0.88000000f,0.59000000f,0.86000000f,-0.52000000f,-0.32000000f,0.30000000f,-0.43000000f,0.68000000f,0.69000000f,-0.88000000f,0.92000000f,-0.29000000f,-0.78000000f,0.89000000f,-0.96000000f,-0.91000000f,-0.80000000f,0.14000000f,-0.36000000f,-0.86000000f,0.79000000f,-0.39000000f,-0.81000000f,0.86000000f,0.43000000f,-0.77000000f,0.44000000f,-0.40000000f,-0.91000000f,-0.43000000f,-0.29000000f,-0.23000000f,-0.07000000f,-0.76000000f,0.14000000f,0.88000000f,0.59000000f,-0.36000000f,-0.80000000f,-0.81000000f,0.74000000f,0.49000000f,-0.41000000f,0.10000000f,-0.45000000f,0.89000000f,0.99000000f,0.95000000f,-0.84000000f,-0.19000000f,-0.50000000f,-0.00000000f,0.17000000f,-0.27000000f,-0.14000000f,-0.27000000f,-0.34000000f,-0.22000000f,0.10000000f,0.78000000f,-0.90000000f,0.64000000f,0.98000000f,-0.78000000f,0.06000000f,0.61000000f,0.51000000f,-0.34000000f,0.70000000f,-0.17000000f,-0.65000000f,0.84000000f,-0.56000000f,-0.81000000f,0.26000000f,-0.08000000f,0.84000000f,0.64000000f,0.96000000f,-0.26000000f,0.73000000f,0.68000000f,0.71000000f,-0.53000000f,-0.04000000f,0.32000000f,0.99000000f,-0.73000000f,0.65000000f,-0.57000000f,0.44000000f,-0.66000000f,-0.20000000f,-0.43000000f,-0.54000000f,-0.97000000f,0.41000000f,0.24000000f,-0.53000000f,-0.55000000f,-0.26000000f,-0.71000000f,0.51000000f,0.83000000f,0.53000000f,0.01000000f,0.95000000f,0.45000000f,-0.40000000f,0.31000000f,0.59000000f,0.34000000f,-0.45000000f,-0.92000000f,-0.27000000f,0.54000000f,-0.14000000f,-0.87000000f,-0.60000000f,0.72000000f,-0.70000000f,-0.04000000f,0.18000000f,0.91000000f,0.68000000f,-0.15000000f,0.21000000f,0.86000000f,0.54000000f,-0.86000000f,0.70000000f,0.40000000f,0.64000000f,-0.82000000f,-0.70000000f,0.68000000f,0.96000000f,0.71000000f,0.84000000f,-0.89000000f,-0.47000000f,-0.63000000f,-0.75000000f,0.79000000f,-0.77000000f,0.14000000f,0.02000000f,0.19000000f,-0.84000000f,-0.19000000f,0.63000000f,0.32000000f,0.65000000f,-0.16000000f,0.44000000f,-0.23000000f,-0.01000000f,0.67000000f,0.85000000f,0.08000000f,0.32000000f,0.14000000f,0.70000000f,0.40000000f,-0.03000000f,-0.29000000f,0.78000000f,-0.17000000f,-0.68000000f,0.36000000f,0.28000000f,-0.48000000f,0.65000000f,0.74000000f,-0.37000000f,0.81000000f,-0.95000000f,-0.21000000f,0.04000000f,-0.23000000f,-0.24000000f,-0.27000000f,-0.93000000f,0.19000000f,-0.27000000f,-0.83000000f,0.19000000f,-0.21000000f,-0.08000000f,-0.19000000f,0.73000000f,0.26000000f,-0.97000000f,0.51000000f,0.92000000f,-0.53000000f,-0.18000000f,-0.54000000f,0.89000000f,-0.49000000f,-0.61000000f,-0.54000000f,-0.63000000f,-0.01000000f,-0.77000000f,0.96000000f,0.44000000f,-0.64000000f,0.63000000f,0.24000000f,-0.51000000f,0.67000000f,-0.16000000f,-0.99000000f,0.61000000f,0.73000000f,0.53000000f,0.84000000f,-0.06000000f,-0.39000000f,0.13000000f,0.40000000f,-0.26000000f,0.90000000f,0.94000000f,0.15000000f,0.71000000f,0.70000000f,-0.71000000f,-0.53000000f,0.74000000f,0.47000000f,-0.45000000f,0.45000000f,-0.24000000f,0.44000000f,0.90000000f,-0.71000000f,0.22000000f,0.32000000f,-0.61000000f,-0.78000000f,-0.66000000f,-0.44000000f,0.88000000f,-0.58000000f,0.57000000f,0.08000000f,0.57000000f,-0.61000000f,0.71000000f,-0.12000000f,0.49000000f,-0.41000000f,-0.69000000f,-0.47000000f,-0.46000000f,0.73000000f,-0.19000000f,-0.01000000f,0.44000000f,-0.41000000f,0.74000000f,0.15000000f,0.15000000f,0.10000000f,0.10000000f,0.59000000f,0.16000000f,-0.80000000f,-0.75000000f,0.79000000f,-0.22000000f,-0.75000000f,-0.05000000f,0.22000000f,-0.92000000f,-0.11000000f,-0.86000000f,0.81000000f,-0.29000000f,-0.08000000f,-0.78000000f,-0.65000000f,0.19000000f,-0.35000000f,-0.76000000f,0.91000000f,-0.55000000f,-0.39000000f,-0.23000000f,0.34000000f,-0.07000000f,-0.95000000f,0.10000000f,0.98000000f,-0.12000000f,-0.49000000f,-0.79000000f,-0.00000000f,0.57000000f,0.83000000f,0.21000000f,0.28000000f,0.33000000f,-0.87000000f,0.60000000f,-0.00000000f,-0.82000000f,-0.00000000f,0.61000000f,0.06000000f,0.45000000f,0.65000000f,0.75000000f,0.04000000f,-0.21000000f,-0.92000000f,0.25000000f,-0.11000000f,-0.52000000f,0.79000000f,0.19000000f,0.48000000f,-0.79000000f,-0.26000000f,0.47000000f,0.05000000f,0.98000000f,0.89000000f,-0.58000000f,-0.03000000f,0.22000000f,0.20000000f,0.17000000f,-0.96000000f,0.13000000f,0.92000000f,-0.31000000f,-0.81000000f,-0.30000000f,-0.60000000f,0.30000000f,0.78000000f,0.86000000f,-0.40000000f,0.23000000f,-0.36000000f,-0.35000000f,-0.69000000f,0.93000000f,0.94000000f,0.52000000f,0.38000000f,0.33000000f,-0.97000000f,-0.28000000f,0.80000000f,0.47000000f,-0.27000000f,0.06000000f,0.25000000f,-0.74000000f,0.57000000f,0.04000000f,-0.93000000f,0.88000000f,0.65000000f,0.68000000f,0.95000000f,-0.69000000f,0.58000000f,-0.67000000f,0.73000000f,0.85000000f,-0.35000000f,-0.10000000f,-0.38000000f,-0.57000000f,0.67000000f,0.79000000f,-0.24000000f,0.60000000f,0.89000000f,-0.85000000f,0.20000000f,0.11000000f,0.14000000f,-0.02000000f,0.53000000f,-0.56000000f,0.39000000f,-0.27000000f,0.43000000f,0.43000000f,-0.41000000f,-0.25000000f,0.00000000f,-0.13000000f,0.26000000f,0.08000000f,0.39000000f,0.07000000f,0.04000000f,0.70000000f,0.49000000f,-0.28000000f,0.19000000f,-0.48000000f,0.29000000f,0.52000000f,-0.99000000f,0.40000000f,0.04000000f,0.47000000f,0.54000000f,0.32000000f,0.48000000f,0.66000000f,0.51000000f,0.29000000f,-0.58000000f,-0.93000000f,0.03000000f,-0.23000000f,0.62000000f,-0.33000000f,-0.51000000f,-0.63000000f,0.22000000f,0.47000000f,0.26000000f,-0.04000000f,-0.50000000f,0.25000000f,-0.61000000f,0.92000000f,-0.52000000f,0.97000000f,-0.12000000f,0.98000000f,-0.12000000f,0.20000000f,-0.04000000f,-0.78000000f,-0.69000000f,-0.06000000f,-0.55000000f,0.38000000f,-0.19000000f,-0.35000000f,0.84000000f,0.46000000f,0.68000000f,0.17000000f,0.27000000f,0.32000000f,0.79000000f,0.37000000f,-0.16000000f,-0.39000000f,0.55000000f,-0.49000000f,-0.70000000f,-0.67000000f,-0.53000000f,0.80000000f,0.35000000f,-0.96000000f,-0.06000000f,0.63000000f,-0.50000000f,-0.16000000f,0.35000000f,0.39000000f,0.51000000f,0.65000000f,-0.12000000f,0.24000000f,-0.88000000f,0.08000000f,0.56000000f,0.92000000f,-0.77000000f,0.93000000f,0.79000000f,-0.06000000f,-0.82000000f,0.00000000f,-0.67000000f,0.49000000f,0.83000000f,0.35000000f,-0.47000000f,-0.67000000f,-0.94000000f,-0.23000000f,0.71000000f,-0.06000000f,-0.06000000f,0.98000000f,-0.94000000f,-0.79000000f,0.03000000f,-0.43000000f,-0.64000000f,-0.27000000f,-0.32000000f,-0.78000000f,0.40000000f,-0.39000000f,0.96000000f,0.81000000f,0.36000000f,-0.64000000f,0.41000000f,0.97000000f,-0.08000000f,0.01000000f,0.31000000f,-0.08000000f,-0.85000000f,-0.09000000f,-0.40000000f,-0.91000000f,-0.11000000f,-0.29000000f,0.79000000f,-0.40000000f,-0.20000000f,-0.92000000f,0.72000000f,-0.25000000f,0.40000000f,-0.20000000f,0.47000000f,-0.52000000f,0.86000000f,0.68000000f,-0.68000000f,0.15000000f,0.99000000f,0.30000000f,-0.99000000f,-0.51000000f,0.44000000f,-0.96000000f,-0.71000000f,0.83000000f,-0.37000000f,-0.12000000f,-0.58000000f,-0.11000000f,0.60000000f,-0.96000000f,-0.35000000f,-0.13000000f,0.52000000f,0.99000000f,-0.94000000f,-0.49000000f,-0.88000000f,-0.50000000f,0.11000000f,-0.79000000f,-0.04000000f,-0.03000000f,-0.60000000f,-0.16000000f,-0.93000000f,-0.85000000f,-0.73000000f,-0.47000000f,-0.22000000f,-0.27000000f,-0.52000000f,0.19000000f,-0.39000000f,0.96000000f,-0.23000000f,0.72000000f,-0.19000000f,-0.71000000f,0.00000000f,-0.78000000f,0.55000000f,0.90000000f,0.47000000f,-0.33000000f,-0.02000000f,0.04000000f,-0.66000000f,-0.34000000f,-0.32000000f,-0.34000000f,0.34000000f,-0.93000000f,0.38000000f,-0.43000000f,0.70000000f,0.90000000f,-0.76000000f,-0.16000000f,0.54000000f,-0.30000000f,0.57000000f,0.20000000f,-0.68000000f,0.62000000f,0.03000000f,0.58000000f,0.41000000f,-0.59000000f,0.54000000f,0.96000000f,-0.04000000f,-0.84000000f,-0.34000000f,-0.76000000f,0.89000000f,-0.86000000f,-0.84000000f,-0.22000000f,-0.61000000f,-0.64000000f,-0.25000000f,0.07000000f,-0.37000000f,-0.85000000f,-0.41000000f,0.59000000f,0.11000000f,-0.97000000f,0.68000000f,0.28000000f,-0.42000000f,-0.19000000f,0.79000000f,-0.46000000f,0.42000000f,0.83000000f,0.97000000f,-0.18000000f,0.16000000f,-0.04000000f,-0.22000000f,0.04000000f,0.14000000f,0.96000000f,0.61000000f,0.72000000f,-0.71000000f,0.23000000f,-0.85000000f,0.06000000f,0.20000000f,-0.72000000f,0.31000000f,0.84000000f,-0.57000000f,-0.23000000f,-0.31000000f,0.17000000f,0.39000000f,0.56000000f,0.31000000f,0.46000000f,-0.15000000f,-0.11000000f,-0.86000000f,0.51000000f,-0.43000000f,-0.63000000f,0.65000000f,0.51000000f,-0.54000000f,-0.58000000f,0.13000000f,0.55000000f,-0.77000000f,-0.64000000f,-0.81000000f,0.18000000f,-0.08000000f,0.21000000f,-0.13000000f,0.18000000f,0.64000000f,0.55000000f,-0.73000000f,-0.35000000f,0.39000000f,-0.79000000f,0.68000000f,0.52000000f,-0.68000000f,0.69000000f,0.42000000f,-0.64000000f,-0.98000000f,0.76000000f,-0.56000000f,0.76000000f,-0.06000000f,-0.64000000f,-0.99000000f,-0.16000000f,0.19000000f,0.90000000f,-0.31000000f,-0.98000000f,-0.71000000f,-0.36000000f,-0.19000000f,-0.03000000f,0.98000000f,-0.34000000f,-0.50000000f,0.91000000f,-0.38000000f,0.20000000f,-0.13000000f,0.62000000f,-0.09000000f,0.66000000f,-0.69000000f,0.25000000f,-0.81000000f,-0.20000000f,-0.16000000f,-0.23000000f,0.26000000f,0.69000000f,0.05000000f,-0.88000000f,-0.71000000f,-0.02000000f,0.96000000f,0.56000000f,0.48000000f,-0.50000000f,-0.68000000f,-0.83000000f,-0.17000000f,0.38000000f,0.48000000f,0.04000000f,-0.05000000f,-0.47000000f,0.46000000f,0.85000000f,0.13000000f,0.08000000f,0.39000000f,0.89000000f,-0.36000000f,0.05000000f,-0.60000000f,-0.95000000f,-0.95000000f,0.08000000f,0.76000000f,0.82000000f,-0.62000000f,0.32000000f,-0.09000000f,0.55000000f,-0.26000000f,0.08000000f,-0.88000000f,-0.93000000f,-0.96000000f,0.26000000f,0.08000000f,0.98000000f,0.40000000f,0.34000000f,-0.34000000f,-0.38000000f,0.35000000f,0.68000000f,0.28000000f,-0.58000000f,0.66000000f,0.30000000f,-0.66000000f,-0.25000000f,0.42000000f,0.05000000f,-0.19000000f,0.33000000f,0.47000000f,0.39000000f,-0.03000000f,0.63000000f,0.09000000f,0.65000000f,0.83000000f,-0.67000000f,-0.86000000f,0.72000000f,-0.20000000f,0.35000000f,-0.88000000f,-0.37000000f,-0.52000000f,-0.29000000f,-0.83000000f,-0.02000000f,-0.08000000f,0.25000000f,-0.75000000f,0.42000000f,-0.23000000f,-0.37000000f,0.48000000f,-0.75000000f,-0.11000000f,0.87000000f,0.87000000f,0.03000000f,0.33000000f,-0.26000000f,-0.43000000f,0.65000000f,0.45000000f,0.77000000f,0.99000000f,-0.52000000f,0.97000000f,-0.72000000f,0.74000000f,0.38000000f,0.86000000f,-0.26000000f,0.81000000f,0.94000000f,0.28000000f,0.16000000f,-0.69000000f,-0.50000000f,-0.78000000f,-0.40000000f,0.11000000f,-0.10000000f,0.89000000f,0.88000000f,0.57000000f,-0.75000000f,-0.55000000f,-0.49000000f,0.06000000f,0.18000000f,-0.56000000f,0.18000000f,0.92000000f,-0.63000000f,0.94000000f,0.01000000f,0.39000000f,0.46000000f,0.44000000f,0.90000000f,0.16000000f,0.77000000f,-0.58000000f,-0.69000000f,0.88000000f,0.12000000f,0.10000000f,0.27000000f,-0.89000000f,-0.94000000f,-0.64000000f,0.55000000f,-0.87000000f,-0.70000000f,-0.47000000f,0.93000000f,0.73000000f,-0.87000000f,-0.20000000f,-0.21000000f,0.61000000f,-0.98000000f,-0.67000000f,-0.45000000f,0.82000000f,0.77000000f,-0.38000000f,-0.29000000f,-0.61000000f,-0.78000000f,0.93000000f,-0.74000000f,-0.48000000f,0.51000000f,0.03000000f,0.73000000f,-0.53000000f,-0.55000000f,0.99000000f,0.08000000f,0.99000000f,0.88000000f,0.57000000f,0.04000000f,-0.98000000f,0.12000000f,-0.39000000f,0.47000000f,-0.54000000f,-0.65000000f,-0.29000000f,-0.51000000f,-0.92000000f,-0.23000000f,0.73000000f,-0.76000000f,0.50000000f,0.11000000f,0.38000000f,-0.44000000f,0.04000000f,-0.40000000f,-0.27000000f,-0.95000000f,-0.83000000f,0.77000000f,-0.20000000f,-0.27000000f,-0.36000000f,0.59000000f,0.65000000f,-0.69000000f,-0.53000000f,-0.86000000f,-0.55000000f,-0.68000000f,0.80000000f,0.55000000f,0.69000000f,-0.41000000f,-0.49000000f,0.95000000f,0.99000000f,0.01000000f,-0.17000000f,-0.72000000f,-0.70000000f,-0.05000000f,-0.56000000f,0.92000000f,-0.37000000f,0.00000000f,-0.38000000f,-0.18000000f,-0.63000000f,-0.46000000f,-0.45000000f,0.82000000f,0.54000000f,0.31000000f,0.41000000f,-0.00000000f,0.08000000f,-0.91000000f,0.16000000f,0.35000000f,-0.62000000f,-0.36000000f,0.22000000f,0.26000000f,-0.31000000f,-0.91000000f,0.48000000f,0.41000000f,0.87000000f,-0.34000000f,0.69000000f,0.24000000f,-0.83000000f,0.90000000f,0.76000000f,0.17000000f,0.11000000f,0.85000000f,0.03000000f,-0.66000000f,-0.29000000f,0.58000000f,0.31000000f,-0.87000000f,-0.90000000f,-0.48000000f,0.21000000f,-0.34000000f,-0.87000000f,0.60000000f,0.91000000f,-0.85000000f,-0.59000000f,0.20000000f,0.64000000f,-0.55000000f,-0.20000000f,0.77000000f,-0.70000000f,0.36000000f,0.44000000f,-0.66000000f,-0.12000000f,-0.56000000f,-0.47000000f,0.37000000f,-0.45000000f,0.43000000f,0.93000000f,0.76000000f,0.03000000f,-0.42000000f,-0.12000000f,0.91000000f,-0.25000000f,-0.93000000f,-0.71000000f,0.00000000f,0.32000000f,0.41000000f,-0.72000000f,0.38000000f,-0.29000000f,-0.83000000f,0.71000000f,-0.73000000f,-0.68000000f,0.81000000f,0.83000000f,0.08000000f,0.74000000f,-0.37000000f,-0.17000000f,0.01000000f,-0.97000000f,-0.35000000f,-0.79000000f,0.80000000f,-0.27000000f,0.28000000f,-0.50000000f,-0.55000000f,0.70000000f,0.36000000f,0.68000000f,-0.25000000f,-0.08000000f,0.84000000f,-0.28000000f,-0.92000000f,0.54000000f,-0.50000000f,0.82000000f,0.23000000f,-0.01000000f,0.09000000f,0.61000000f,0.42000000f,-0.48000000f,0.01000000f,0.56000000f,0.96000000f,0.28000000f,0.67000000f,-0.48000000f,-0.98000000f,-0.56000000f,-0.05000000f,-0.55000000f,0.91000000f,0.77000000f,-0.98000000f,0.55000000f,0.89000000f,0.56000000f,0.58000000f,0.42000000f,0.87000000f,0.40000000f,0.28000000f,-0.51000000f,0.74000000f,0.99000000f,0.77000000f,0.55000000f,0.48000000f,0.58000000f,-0.28000000f,-0.16000000f,0.69000000f,0.19000000f,-0.15000000f,-0.67000000f,-0.89000000f,-0.63000000f,-0.49000000f,0.69000000f,0.14000000f,0.41000000f,0.37000000f,0.96000000f,0.11000000f,-0.89000000f,-0.19000000f,0.83000000f,0.67000000f,-0.51000000f,0.17000000f,-0.79000000f,0.53000000f,-0.27000000f,-0.41000000f,-0.93000000f,-0.01000000f,0.31000000f,0.17000000f,0.20000000f,0.79000000f,0.84000000f,0.90000000f,-0.02000000f,0.59000000f,-0.77000000f,-0.47000000f,0.59000000f,-0.99000000f,-0.88000000f,0.78000000f,0.43000000f,0.90000000f,0.08000000f,0.71000000f,-0.12000000f,0.91000000f,-0.82000000f,-0.86000000f,-0.61000000f,0.28000000f,0.35000000f,0.60000000f,0.55000000f,-0.60000000f,-0.67000000f,0.67000000f,0.99000000f,-0.30000000f,0.24000000f,0.47000000f,-0.17000000f,-0.82000000f,-0.22000000f,0.40000000f,0.01000000f,-0.75000000f,0.45000000f,0.38000000f,0.70000000f,-0.44000000f,0.96000000f,0.72000000f,0.12000000f,-0.58000000f,0.96000000f,-0.41000000f,-0.56000000f,-0.49000000f,-0.95000000f,-0.36000000f,0.62000000f,-0.10000000f,-0.65000000f,-0.51000000f,-0.13000000f,-0.44000000f,0.21000000f,0.75000000f,-0.82000000f,0.75000000f,-0.76000000f,0.20000000f,-0.63000000f,-0.95000000f,-0.10000000f,-0.30000000f,0.85000000f,0.59000000f,-0.76000000f,-0.36000000f,0.75000000f,-0.05000000f,-0.47000000f,-0.67000000f,-0.84000000f,-0.24000000f,-0.22000000f,0.24000000f,0.88000000f,-0.33000000f,-0.60000000f,-0.81000000f,-0.22000000f,-0.55000000f,-0.10000000f,0.84000000f,-0.52000000f,0.31000000f,0.31000000f,0.73000000f,-0.47000000f,0.08000000f,-0.78000000f,0.59000000f,0.27000000f,0.06000000f,0.74000000f,-0.58000000f,0.48000000f,-0.74000000f,-0.60000000f,-0.57000000f,0.16000000f,-0.91000000f,0.48000000f,-0.08000000f,0.42000000f,0.56000000f,-0.31000000f,-0.42000000f,-0.33000000f,0.88000000f,0.84000000f,0.72000000f,0.92000000f,0.36000000f,0.95000000f,-0.40000000f,0.77000000f,0.12000000f,-0.63000000f,-0.67000000f,-0.02000000f,-0.65000000f,0.53000000f,-0.98000000f,0.23000000f,-0.92000000f,-0.88000000f,-0.64000000f,0.84000000f,0.44000000f,-0.08000000f,-0.62000000f,-0.85000000f,-0.16000000f,0.61000000f,-0.11000000f,0.23000000f,0.01000000f,-0.37000000f,-0.36000000f,0.42000000f,-0.73000000f,0.43000000f,0.96000000f,-0.67000000f,0.41000000f,0.94000000f,-0.27000000f,0.04000000f,-0.46000000f,0.26000000f,0.01000000f,0.75000000f,-0.10000000f,-0.41000000f,-0.28000000f,0.57000000f,-0.55000000f,0.18000000f,-0.36000000f,-0.96000000f,-0.15000000f,-0.04000000f,0.80000000f,0.09000000f,-0.84000000f,0.06000000f,-0.63000000f,0.82000000f,0.47000000f,-0.17000000f,0.01000000f,-0.81000000f,0.44000000f,0.19000000f,-0.26000000f,0.88000000f,0.57000000f,-0.14000000f,-0.00000000f,0.34000000f,0.44000000f,-0.20000000f,-0.58000000f,-0.32000000f,0.17000000f,-0.98000000f,-0.29000000f,-0.08000000f,-0.53000000f,0.89000000f,-0.96000000f,-0.43000000f,0.87000000f,0.90000000f,0.25000000f,-0.00000000f,0.55000000f,0.73000000f,-0.28000000f,0.63000000f,-0.73000000f,0.61000000f,0.14000000f,0.51000000f,-0.15000000f,0.90000000f,0.15000000f,-0.24000000f,0.48000000f,-0.74000000f,0.54000000f,0.75000000f,-0.59000000f,-0.22000000f,0.54000000f,-0.99000000f,0.29000000f,0.47000000f,0.87000000f,-0.05000000f,0.65000000f,0.46000000f,0.76000000f,-0.89000000f,0.63000000f,0.65000000f,-0.28000000f,-0.63000000f,0.54000000f,0.37000000f,0.03000000f,0.05000000f,-0.16000000f,-0.38000000f,0.60000000f,0.70000000f,-0.74000000f,0.86000000f,-0.41000000f,0.22000000f,-0.45000000f,0.75000000f,-0.30000000f,0.32000000f,-0.03000000f,0.42000000f,0.48000000f,0.01000000f,-0.79000000f,-0.87000000f,-0.76000000f,-0.51000000f,-0.02000000f,0.00000000f,0.40000000f,0.35000000f,0.78000000f,-0.89000000f,-0.66000000f,-0.15000000f,-0.41000000f,-0.28000000f,0.41000000f,0.37000000f,0.47000000f,-0.56000000f,0.27000000f,0.58000000f,-0.44000000f,0.73000000f,-0.55000000f,-0.54000000f,0.87000000f,-0.67000000f,-0.62000000f,-0.95000000f,0.52000000f,-0.20000000f,0.81000000f,-0.34000000f,-0.48000000f,0.49000000f,-0.23000000f,0.62000000f,0.74000000f,-0.60000000f,-0.39000000f,-0.60000000f,0.34000000f,-0.81000000f,0.17000000f,0.63000000f,0.37000000f,0.11000000f,-0.74000000f,0.60000000f,-0.47000000f,-0.96000000f,-0.42000000f,-0.54000000f,0.20000000f,0.85000000f,0.13000000f,0.83000000f,0.17000000f,-0.56000000f,-0.25000000f,0.69000000f,-0.11000000f,0.11000000f,0.09000000f,-0.83000000f,-0.02000000f,-0.44000000f,-0.50000000f,-0.00000000f,-0.35000000f,0.25000000f,-0.41000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.69059996f,1.07150003f,-1.32450010f,0.0f,0.0f,0.59459998f,1.77580002f,0.67379999f,0.0f,0.0f,1.05099999f,0.54750002f,0.27440006f,0.0f,0.0f,-0.68599997f,1.54809995f,-0.72859998f,0.0f,0.0f,-0.62010000f,3.21359993f,1.44559992f,0.0f,0.0f,0.04979992f,-3.07150002f,-0.71609996f,0.0f,0.0f,0.45199992f,1.05479990f,2.11310002f,0.0f,0.0f,2.07010005f,0.02809996f,0.62110001f,0.0f,0.0f,1.14830004f,1.00379992f,-1.43590014f,0.0f,0.0f,0.00190006f,-0.30260000f,-1.06399998f,0.0f,0.0f,-2.61560003f,-1.54330001f,-1.09499990f,0.0f,0.0f,-1.27530002f,0.43840007f,-2.02730003f,0.0f,0.0f,-0.13580000f,-0.23940001f,0.06199998f,0.0f,0.0f,2.29359993f,-0.28860005f,1.57590002f,0.0f,0.0f,0.51880001f,2.92520001f,0.22110002f,0.0f,0.0f,-1.05169996f,-0.04659998f,-0.21599998f,0.0f,0.0f,-0.17040001f,1.68699995f,-2.68779996f,0.0f,0.0f,-1.89789999f,-0.50010001f,-0.18130003f,0.0f,0.0f,1.59779999f,-0.71039999f,0.29150002f,0.0f,0.0f,-1.25490002f,0.55809999f,-1.06100002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.68289995f,-0.43930005f,2.40730004f,0.0f,0.0f,-0.14060003f,-1.48570002f,1.95290001f,0.0f,0.0f,0.82809995f,-0.92360002f,-2.35969998f,0.0f,0.0f,0.34229999f,-1.25989997f,-0.05419998f,0.0f,0.0f,-0.63840003f,-0.05110003f,2.97160002f,0.0f,0.0f,2.73069997f,-2.22629990f,4.25929994f,0.0f,0.0f,-0.44269998f,-0.43510000f,1.48699997f,0.0f,0.0f,1.64280002f,2.53620000f,-0.28790002f,0.0f,0.0f,1.29999994f,-2.55840007f,-0.66529996f,0.0f,0.0f,-1.20689993f,-1.27679993f,3.97089987f,0.0f,0.0f,-1.03890005f,0.85740002f,1.17659991f,0.0f,0.0f,0.37370007f,1.70630000f,-0.29959996f,0.0f,0.0f,0.58999990f,-3.85370000f,1.39190005f,0.0f,0.0f,-3.27139999f,0.77340004f,0.69460002f,0.0f,0.0f,-0.82630003f,2.53459996f,-2.25229996f,0.0f,0.0f,0.75220002f,-1.15419998f,0.21759996f,0.0f,0.0f,-0.70379998f,0.14550004f,0.45180000f,0.0f,0.0f,0.09770003f,-0.72830002f,0.91790001f,0.0f,0.0f,-0.56529990f,-2.21010005f,0.22789998f,0.0f,0.0f,2.26979994f,0.33569997f,1.58950002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,2.42250006f,-0.61980000f,1.40249996f,0.0f,0.0f,2.26859999f,0.57149995f,-0.70049996f,0.0f,0.0f,-0.00079998f,1.32440001f,0.47909999f,0.0f,0.0f,-1.08769999f,0.78460002f,1.17160003f,0.0f,0.0f,1.62439999f,-0.61240004f,-2.52769994f,0.0f,0.0f,0.92970001f,0.35510002f,-0.38140002f,0.0f,0.0f,1.95290006f,-0.16439997f,-0.10340005f,0.0f,0.0f,0.39169999f,2.08049999f,2.63299992f,0.0f,0.0f,-0.88599999f,-0.29129999f,1.93410002f,0.0f,0.0f,1.22300008f,-0.61300002f,0.07310003f,0.0f,0.0f,-1.48579998f,-0.36860000f,0.99669995f,0.0f,0.0f,-1.68739990f,0.56549998f,1.06559995f,0.0f,0.0f,0.55100004f,1.71810001f,-0.53870001f,0.0f,0.0f,-1.05470001f,-0.24540002f,-1.59129997f,0.0f,0.0f,-0.49960004f,2.53620001f,2.50870000f,0.0f,0.0f,0.85219998f,-0.23900003f,-0.51869996f,0.0f,0.0f,1.06240001f,-0.04790000f,-0.45770001f,0.0f,0.0f,-0.25639999f,0.86159998f,-1.06030003f,0.0f,0.0f,-0.50149997f,0.62910003f,1.74249999f,0.0f,0.0f,-0.84219997f,1.03940000f,-0.35430000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.71340001f,1.20520002f,-0.04359997f,0.0f,0.0f,-0.10020000f,-1.14060002f,-0.28699996f,0.0f,0.0f,1.48600000f,2.02769999f,1.34950002f,0.0f,0.0f,-2.03249998f,-2.62900000f,0.54270011f,0.0f,0.0f,0.09279998f,-0.29079999f,-1.49200002f,0.0f,0.0f,-3.75119996f,-0.95210002f,1.06800001f,0.0f,0.0f,0.69930012f,-3.03159999f,-1.03610010f,0.0f,0.0f,-1.03730008f,-0.46190004f,0.91500000f,0.0f,0.0f,0.11039990f,-2.37949993f,-1.27109997f,0.0f,0.0f,2.30399993f,-0.59580003f,2.77749999f,0.0f,0.0f,1.35729997f,-1.09200002f,0.92679992f,0.0f,0.0f,0.24699997f,-0.02610002f,0.93959999f,0.0f,0.0f,-0.94120004f,0.56540006f,0.10490005f,0.0f,0.0f,-2.29129995f,-1.17789987f,2.19009999f,0.0f,0.0f,-1.37890013f,-2.98769999f,1.73229994f,0.0f,0.0f,0.22279992f,0.89030003f,0.03269999f,0.0f,0.0f,-0.58609998f,-1.28709996f,0.60869995f,0.0f,0.0f,0.30080000f,-1.10270003f,-0.37139990f,0.0f,0.0f,-1.24450003f,1.92909998f,-0.66320000f,0.0f,0.0f,-0.83779994f,-0.52089999f,0.27149997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.64130006f,0.33700002f,0.10700000f,0.0f,0.0f,0.39589998f,-1.36459996f,-1.65229996f,0.0f,0.0f,1.89249997f,-0.16359996f,0.42299999f,0.0f,0.0f,-0.51689999f,-0.20840002f,-0.85720005f,0.0f,0.0f,-2.77519996f,1.18650000f,-3.58739998f,0.0f,0.0f,0.48179998f,1.95850000f,1.45649998f,0.0f,0.0f,-0.66579996f,2.46260001f,0.47060012f,0.0f,0.0f,0.85100000f,-2.06280002f,-0.54250003f,0.0f,0.0f,0.06800008f,1.83730003f,0.27480000f,0.0f,0.0f,1.26749999f,1.19019999f,-3.45179999f,0.0f,0.0f,-2.92209999f,-0.57119991f,1.10269997f,0.0f,0.0f,0.91300002f,1.27930010f,-0.36170007f,0.0f,0.0f,-1.98459995f,3.33760004f,-1.01069997f,0.0f,0.0f,-0.02349999f,-0.58559998f,-0.19240002f,0.0f,0.0f,-1.68740001f,-2.11819994f,-0.24429995f,0.0f,0.0f,0.96990000f,1.59700007f,0.49529997f,0.0f,0.0f,-0.01450001f,1.70070003f,1.35650002f,0.0f,0.0f,2.38090001f,-2.79919996f,-1.40570000f,0.0f,0.0f,0.15459997f,0.71410001f,-0.71059998f,0.0f,0.0f,-1.74499998f,0.47279998f,0.18830001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.52780000f,0.29730002f,-0.47200002f,0.0f,0.0f,0.07779997f,-0.13809999f,0.59169999f,0.0f,0.0f,-0.24689996f,0.19869995f,0.34660001f,0.0f,0.0f,0.51539998f,-0.44569998f,-0.51730002f,0.0f,0.0f,-0.69630004f,0.24990004f,0.86739994f,0.0f,0.0f,0.14709999f,0.92659999f,-0.96459998f,0.0f,0.0f,-1.03240003f,-1.03950004f,0.00940004f,0.0f,0.0f,-1.89219995f,0.82519998f,-0.85369999f,0.0f,0.0f,0.83870004f,0.80869997f,-0.56730004f,0.0f,0.0f,-0.41579997f,0.02789998f,0.72199998f,0.0f,0.0f,0.85409998f,0.53760000f,0.00289998f,0.0f,0.0f,0.78269993f,0.05849998f,-0.77400000f,0.0f,0.0f,1.36849995f,0.49509995f,-0.27900003f,0.0f,0.0f,0.24210001f,0.44469998f,-0.25560002f,0.0f,0.0f,0.75380000f,-1.07959997f,1.08469995f,0.0f,0.0f,-0.25440001f,0.33409998f,0.86200001f,0.0f,0.0f,-0.02850000f,0.70499999f,-0.28919997f,0.0f,0.0f,-0.14360000f,0.03040005f,-0.53599998f,0.0f,0.0f,-0.59450001f,-0.84790000f,-0.18270000f,0.0f,0.0f,0.80219996f,0.09299998f,-0.77249996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.81510001f,0.19870001f,-0.21080001f,0.0f,0.0f,0.06419997f,-0.96100000f,1.19739999f,0.0f,0.0f,-0.07150002f,-0.47829998f,-1.32710003f,0.0f,0.0f,0.13200006f,2.83790001f,-0.57610001f,0.0f,0.0f,-0.69079999f,0.00599994f,0.27339991f,0.0f,0.0f,4.18760000f,1.66590007f,1.15259995f,0.0f,0.0f,2.43169992f,0.70770008f,2.53470008f,0.0f,0.0f,0.21169998f,-0.68250002f,0.97990004f,0.0f,0.0f,0.70649998f,0.62399992f,-0.24959996f,0.0f,0.0f,-0.38740000f,2.95779996f,-1.87269999f,0.0f,0.0f,1.87549999f,0.58039999f,1.38159998f,0.0f,0.0f,-0.34860003f,0.86719990f,-2.51419993f,0.0f,0.0f,-1.87889994f,1.01850008f,0.36420000f,0.0f,0.0f,1.37769989f,-1.66979998f,-0.12899998f,0.0f,0.0f,3.49619998f,2.62270001f,0.81909990f,0.0f,0.0f,-3.80359993f,2.27260008f,0.63470007f,0.0f,0.0f,1.88260000f,1.17119991f,-1.38159988f,0.0f,0.0f,0.92509999f,1.90750002f,1.35319998f,0.0f,0.0f,-1.22389997f,-0.46319986f,1.70019994f,0.0f,0.0f,0.64060005f,0.06270004f,-1.16769994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,2.30549999f,-0.03509998f,0.69140004f,0.0f,0.0f,0.83600003f,-0.36350000f,0.75509999f,0.0f,0.0f,-0.14150006f,1.02740005f,-1.50380012f,0.0f,0.0f,-1.17880002f,0.17510005f,-0.10999987f,0.0f,0.0f,2.70829989f,-1.46540006f,0.85520002f,0.0f,0.0f,-0.34659994f,0.25830003f,-0.73420011f,0.0f,0.0f,3.28119994f,-0.07589993f,-4.45090008f,0.0f,0.0f,-2.34690010f,1.08109996f,-1.48070000f,0.0f,0.0f,-0.84720004f,0.25520006f,-0.39430000f,0.0f,0.0f,-1.52460001f,1.70750003f,4.31159998f,0.0f,0.0f,0.15079991f,2.23920004f,-0.02009993f,0.0f,0.0f,0.20739991f,2.04710002f,1.45710003f,0.0f,0.0f,1.60970002f,-0.47609983f,2.72419993f,0.0f,0.0f,0.68830003f,-1.21920008f,0.72249998f,0.0f,0.0f,1.98990007f,0.02329996f,-0.90810015f,0.0f,0.0f,0.08420001f,1.05380007f,-1.03529996f,0.0f,0.0f,-3.02809997f,-2.82989999f,-1.53299997f,0.0f,0.0f,0.86330001f,1.75029991f,0.37080004f,0.0f,0.0f,-0.45960004f,-0.92480000f,-0.35929991f,0.0f,0.0f,0.44689995f,0.46429995f,0.34549999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.37660002f,0.07299999f,-0.22449999f,0.0f,0.0f,-0.21100001f,-0.23910000f,-0.15220000f,0.0f,0.0f,-0.03339998f,0.05180000f,-0.35040002f,0.0f,0.0f,-0.09299997f,0.05879999f,1.36840000f,0.0f,0.0f,1.77359996f,0.47139999f,-0.38259993f,0.0f,0.0f,-0.26580003f,0.70630003f,0.73020000f,0.0f,0.0f,2.09730001f,1.33720005f,0.21560000f,0.0f,0.0f,-1.09019997f,0.22779999f,1.00749997f,0.0f,0.0f,-1.70899997f,-0.98389996f,1.35090004f,0.0f,0.0f,-1.44179999f,0.93719999f,-0.47169999f,0.0f,0.0f,-2.58099995f,0.57269999f,0.12160000f,0.0f,0.0f,0.28990003f,0.43819997f,1.04769996f,0.0f,0.0f,0.81720000f,1.39420001f,0.61820003f,0.0f,0.0f,0.27270003f,-0.03919999f,1.21739996f,0.0f,0.0f,0.71499999f,1.28149997f,-1.21930003f,0.0f,0.0f,-1.32949994f,-0.64139999f,0.38210001f,0.0f,0.0f,1.29130003f,-0.59959997f,-1.42300000f,0.0f,0.0f,0.11650002f,0.49549999f,-0.91490005f,0.0f,0.0f,-0.58609998f,0.71160001f,0.80010002f,0.0f,0.0f,-0.82089995f,0.54720000f,-0.23239998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.34710003f,0.29130001f,-0.50509994f,0.0f,0.0f,-0.53939999f,-1.90029999f,-1.20899999f,0.0f,0.0f,-0.05429998f,0.56520008f,0.44579999f,0.0f,0.0f,0.45390001f,-0.58309994f,2.11839999f,0.0f,0.0f,-0.85420001f,-3.22810002f,-0.92599990f,0.0f,0.0f,1.46929998f,0.20410009f,1.08650000f,0.0f,0.0f,1.73870004f,0.05589994f,0.49680004f,0.0f,0.0f,-1.92259992f,-0.92179994f,-0.14639991f,0.0f,0.0f,-2.43929996f,-0.69350004f,-1.60789997f,0.0f,0.0f,-1.14399998f,-0.25369999f,0.10480000f,0.0f,0.0f,0.01659997f,1.17569993f,-0.55469996f,0.0f,0.0f,0.73529999f,-0.97790003f,0.18069994f,0.0f,0.0f,0.80519993f,0.82710008f,0.15659997f,0.0f,0.0f,-2.25950001f,-0.32879998f,-1.69769997f,0.0f,0.0f,-1.40699996f,-1.02099992f,-2.19249993f,0.0f,0.0f,-0.28100004f,1.41170007f,2.35370008f,0.0f,0.0f,-0.61160000f,0.26099997f,-0.14559994f,0.0f,0.0f,1.32760001f,-0.28059996f,0.77589999f,0.0f,0.0f,-0.09639996f,-0.78389996f,-0.85440002f,0.0f,0.0f,2.10969996f,-0.37499997f,0.30260000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.87790001f,0.15300005f,0.00480005f,0.0f,0.0f,-0.01120002f,-0.94829999f,-2.14819997f,0.0f,0.0f,-1.41810000f,1.37290001f,0.47039992f,0.0f,0.0f,-0.41019999f,1.59749998f,-0.52410001f,0.0f,0.0f,-0.42280001f,-0.30720003f,1.15589994f,0.0f,0.0f,-1.37689998f,-0.73139995f,-4.15539999f,0.0f,0.0f,-1.59369988f,1.34649996f,-0.53169999f,0.0f,0.0f,-0.71120005f,0.07240004f,-0.52360009f,0.0f,0.0f,3.20290006f,-0.72659998f,1.04779998f,0.0f,0.0f,1.72539997f,1.71530007f,-0.12459995f,0.0f,0.0f,-4.41829995f,0.21439999f,-4.78049988f,0.0f,0.0f,-0.80970005f,2.67369998f,-1.73710001f,0.0f,0.0f,-0.40229997f,1.26030008f,0.28830000f,0.0f,0.0f,1.82820001f,-1.17790001f,-2.62169995f,0.0f,0.0f,-1.07489999f,-2.35599990f,1.56689994f,0.0f,0.0f,0.85479998f,2.36650002f,-2.43559995f,0.0f,0.0f,1.28709996f,0.95690000f,-0.17660002f,0.0f,0.0f,-1.38360001f,0.93579999f,0.38529996f,0.0f,0.0f,1.45510002f,0.07069998f,1.21880003f,0.0f,0.0f,1.04659994f,-1.39280005f,0.07310000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.59569998f,0.60750002f,-0.39020001f,0.0f,0.0f,-1.19440001f,0.13070002f,0.75909997f,0.0f,0.0f,-0.09690002f,-0.99260005f,0.27660004f,0.0f,0.0f,1.04190001f,-0.32809998f,-1.55749998f,0.0f,0.0f,-2.63190000f,0.30550009f,0.94589997f,0.0f,0.0f,0.08509998f,-1.94810001f,0.20830004f,0.0f,0.0f,-0.80170000f,-2.89489998f,-0.21780004f,0.0f,0.0f,-0.39330001f,-2.13859996f,-1.77659995f,0.0f,0.0f,0.89930000f,0.08230003f,-2.05410007f,0.0f,0.0f,0.29839996f,-0.88039998f,1.72020000f,0.0f,0.0f,1.93559998f,-1.43679999f,-0.74190000f,0.0f,0.0f,0.13259998f,-2.25119992f,0.09490002f,0.0f,0.0f,-0.66500003f,-1.95769999f,-0.39669995f,0.0f,0.0f,0.10379998f,-0.59899997f,-0.21449998f,0.0f,0.0f,1.08940002f,-0.03639995f,-1.97429996f,0.0f,0.0f,0.23539998f,1.77759998f,-0.97410000f,0.0f,0.0f,-1.70940001f,-0.16679999f,1.22590000f,0.0f,0.0f,-0.68420001f,-0.49020002f,1.45800001f,0.0f,0.0f,0.46380000f,0.03400000f,-0.35020001f,0.0f,0.0f,-0.25069996f,-0.28580001f,1.75469999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.19149998f,-0.85689994f,-2.94539996f,0.0f,0.0f,0.00730001f,0.97239996f,-2.40820000f,0.0f,0.0f,-2.99940006f,0.96749994f,0.40059999f,0.0f,0.0f,0.74620001f,-0.21210000f,-0.82520003f,0.0f,0.0f,-2.27699992f,-1.00039996f,-3.13559999f,0.0f,0.0f,-2.33299996f,-1.41769995f,3.56060000f,0.0f,0.0f,0.08580005f,1.53290002f,2.42159998f,0.0f,0.0f,-0.63830001f,-0.10999997f,-0.49249997f,0.0f,0.0f,-2.41100000f,2.45379998f,4.09969996f,0.0f,0.0f,0.32010001f,-0.20130001f,-1.08860009f,0.0f,0.0f,2.38450005f,-1.36290006f,-2.01449998f,0.0f,0.0f,0.92240008f,0.82630000f,-2.87040002f,0.0f,0.0f,-0.74389993f,0.31820007f,-1.57270005f,0.0f,0.0f,2.65780005f,-0.64820001f,0.02130007f,0.0f,0.0f,-3.69379996f,2.54929992f,-1.66549999f,0.0f,0.0f,-0.75459998f,-2.39290002f,1.07829991f,0.0f,0.0f,-0.09660001f,1.08110003f,-1.32499988f,0.0f,0.0f,1.02059998f,-1.34619998f,1.04109999f,0.0f,0.0f,-1.55740003f,-0.81489995f,-0.84869998f,0.0f,0.0f,-0.40949997f,1.76160000f,0.71470006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.28979994f,-0.71029997f,2.45250003f,0.0f,0.0f,1.04680003f,1.90429998f,-1.06770003f,0.0f,0.0f,-0.53159998f,0.98820005f,-1.40140000f,0.0f,0.0f,0.10730002f,0.02019997f,-1.03509999f,0.0f,0.0f,1.20750000f,-0.13999990f,0.26559999f,0.0f,0.0f,1.29719999f,0.82239992f,-3.07070005f,0.0f,0.0f,1.13270003f,1.04709988f,1.55280003f,0.0f,0.0f,-0.53890003f,0.43199994f,0.07110000f,0.0f,0.0f,-0.05050002f,0.18589998f,0.89530004f,0.0f,0.0f,-1.41280002f,0.01890002f,2.10919997f,0.0f,0.0f,0.56280004f,-1.95060009f,-1.55750010f,0.0f,0.0f,1.20020004f,-1.27490006f,-2.57079998f,0.0f,0.0f,-3.21920004f,-1.42389997f,0.73390001f,0.0f,0.0f,-1.52599996f,1.09850002f,-1.22149999f,0.0f,0.0f,-1.05600006f,-0.15479990f,-1.97789999f,0.0f,0.0f,0.53620008f,4.11100005f,-0.84379997f,0.0f,0.0f,-0.25210006f,0.34229995f,-0.24530004f,0.0f,0.0f,1.73739999f,-0.72439993f,0.77959998f,0.0f,0.0f,-2.15260006f,0.90860001f,2.68739993f,0.0f,0.0f,-1.89900001f,1.66039992f,0.41120001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.91499998f,1.02780002f,-1.18409999f,0.0f,0.0f,-1.68959999f,0.04890000f,1.21499997f,0.0f,0.0f,-0.39620000f,-1.81269997f,0.50300002f,0.0f,0.0f,-0.68759999f,-0.22939999f,-1.64899992f,0.0f,0.0f,-0.19800003f,-0.93380000f,-0.71130001f,0.0f,0.0f,0.56570001f,-0.90710001f,-0.18289994f,0.0f,0.0f,-1.01459997f,-0.71619997f,-0.21620000f,0.0f,0.0f,2.89109998f,0.76710006f,-0.81710006f,0.0f,0.0f,-0.43160003f,-0.95090002f,0.08460001f,0.0f,0.0f,3.06430000f,-0.16849990f,0.37850006f,0.0f,0.0f,4.33450000f,-2.50569997f,0.88650000f,0.0f,0.0f,1.09989999f,1.45249999f,-0.30319998f,0.0f,0.0f,1.48120001f,2.83789995f,-0.44610002f,0.0f,0.0f,1.65769997f,-3.71669994f,0.26250000f,0.0f,0.0f,1.48150001f,3.27919999f,-0.48460000f,0.0f,0.0f,0.59960005f,2.11659997f,1.12439999f,0.0f,0.0f,0.23200000f,-0.37219999f,-0.78309999f,0.0f,0.0f,-0.66149997f,0.84470002f,0.08710000f,0.0f,0.0f,0.79229998f,0.61370002f,0.38839998f,0.0f,0.0f,0.32620001f,-0.23109997f,-0.57270000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.26880001f,0.95869999f,0.42360000f,0.0f,0.0f,-0.87690002f,-0.52139999f,0.76570005f,0.0f,0.0f,0.69130003f,1.40179998f,-0.72450002f,0.0f,0.0f,-0.71730001f,-0.47420001f,-0.38149998f,0.0f,0.0f,1.94390005f,-0.21370001f,1.44250000f,0.0f,0.0f,1.17020004f,-0.40259999f,-0.17550001f,0.0f,0.0f,-1.22959997f,0.70159999f,-0.66080009f,0.0f,0.0f,-3.58590000f,2.14320001f,1.87489991f,0.0f,0.0f,-0.68009997f,-0.76259999f,-3.43799999f,0.0f,0.0f,0.09519999f,-0.22189994f,2.01189996f,0.0f,0.0f,-0.76640002f,0.37689995f,1.81629997f,0.0f,0.0f,-1.02820009f,-0.34940003f,0.35820005f,0.0f,0.0f,1.30109998f,1.13999989f,-1.42620002f,0.0f,0.0f,-1.67419999f,-1.58300001f,1.13779998f,0.0f,0.0f,-0.96420000f,0.53969999f,-2.22090000f,0.0f,0.0f,0.34230003f,3.09449998f,-1.69909995f,0.0f,0.0f,0.38709996f,-0.24430007f,0.37149994f,0.0f,0.0f,-1.57640008f,2.62410004f,0.66400000f,0.0f,0.0f,-0.83269996f,-1.23589999f,1.00360005f,0.0f,0.0f,1.32399995f,-1.99569995f,0.38550000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.29850000f,-0.58019998f,-0.35160004f,0.0f,0.0f,0.18560004f,-0.25899999f,0.02350001f,0.0f,0.0f,1.28769998f,-1.16979996f,0.05480002f,0.0f,0.0f,-1.25589998f,0.50889999f,-0.40909999f,0.0f,0.0f,-0.19770003f,1.32289993f,-0.34159999f,0.0f,0.0f,-2.38849992f,-0.46869998f,1.17000005f,0.0f,0.0f,-0.60740000f,-1.24179993f,-0.07180002f,0.0f,0.0f,0.28340003f,2.43819995f,-0.50169997f,0.0f,0.0f,1.76400004f,0.23820003f,-1.88119999f,0.0f,0.0f,2.56600000f,-1.14860001f,-0.74409998f,0.0f,0.0f,-1.02730007f,-0.73379997f,0.56900001f,0.0f,0.0f,-0.35490000f,-3.12459993f,1.34940002f,0.0f,0.0f,0.30940004f,1.26689998f,-0.35719991f,0.0f,0.0f,2.69730006f,1.04190001f,0.76230004f,0.0f,0.0f,-1.74899998f,-0.71320004f,-1.05420001f,0.0f,0.0f,-0.73830006f,-1.72020008f,0.01279999f,0.0f,0.0f,-0.64540000f,-1.83100007f,-1.23879998f,0.0f,0.0f,-0.18090002f,0.60139996f,-0.33320000f,0.0f,0.0f,0.20620003f,1.18000004f,1.80949998f,0.0f,0.0f,1.19020002f,-0.73719995f,-0.47170000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.29930000f,-0.02970005f,1.16799995f,0.0f,0.0f,0.34840000f,-1.08730003f,-0.78130000f,0.0f,0.0f,0.27810000f,1.44919999f,-0.26220004f,0.0f,0.0f,1.15759996f,0.30090000f,1.56639996f,0.0f,0.0f,0.13279999f,-0.58389997f,-0.58909996f,0.0f,0.0f,0.11749997f,0.04510001f,0.57469999f,0.0f,0.0f,-0.51039999f,0.56710000f,-0.32260005f,0.0f,0.0f,-0.58439998f,-0.40499997f,-0.76079994f,0.0f,0.0f,-1.10089998f,1.18219998f,0.95070001f,0.0f,0.0f,-1.52210000f,0.65750001f,1.36480001f,0.0f,0.0f,-1.24069998f,0.55659996f,0.96229997f,0.0f,0.0f,-0.21199997f,-0.56190002f,-0.69480000f,0.0f,0.0f,-1.08840000f,-1.63950002f,-0.90680003f,0.0f,0.0f,1.11879999f,0.97319999f,0.58040002f,0.0f,0.0f,-0.38350000f,0.50370008f,-1.49200006f,0.0f,0.0f,0.51889996f,0.17249998f,0.37800001f,0.0f,0.0f,-0.48159995f,0.44690001f,-0.32860000f,0.0f,0.0f,-0.64469998f,-1.44670000f,0.69680001f,0.0f,0.0f,-0.02739995f,-0.56330001f,1.35240005f,0.0f,0.0f,0.27900000f,-0.17810000f,-0.59550000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.10869998f,0.58889998f,-0.72060000f,0.0f,0.0f,0.17380006f,-0.06329996f,-1.18220002f,0.0f,0.0f,-0.66219999f,-1.48340006f,-0.03970003f,0.0f,0.0f,1.70930000f,-1.18279999f,-0.23149996f,0.0f,0.0f,-1.77410007f,-0.17429995f,-1.21980003f,0.0f,0.0f,-1.04879997f,2.24549993f,1.63429991f,0.0f,0.0f,2.75049992f,1.33889992f,1.38929993f,0.0f,0.0f,-0.90249996f,1.29749999f,-0.46819992f,0.0f,0.0f,-0.85279993f,-0.36860001f,2.22729997f,0.0f,0.0f,-0.51910003f,0.43779998f,-0.17319992f,0.0f,0.0f,0.97600004f,1.73729987f,-0.47229997f,0.0f,0.0f,0.38529996f,0.63420001f,0.53070003f,0.0f,0.0f,1.28100002f,-0.30519997f,0.55280001f,0.0f,0.0f,0.84489999f,2.59739989f,-1.04380001f,0.0f,0.0f,0.37179992f,0.01949999f,4.47759995f,0.0f,0.0f,-3.25970000f,-1.05619998f,3.16629998f,0.0f,0.0f,0.70370002f,1.00080000f,-0.09850004f,0.0f,0.0f,3.84819999f,-0.99439999f,-0.46309995f,0.0f,0.0f,-1.25650004f,-1.26930001f,1.62409999f,0.0f,0.0f,-1.45609995f,-0.40269998f,-1.08300002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.44860001f,-0.61670001f,1.64490003f,0.0f,0.0f,1.95970002f,0.52380004f,1.21290000f,0.0f,0.0f,-1.05809999f,0.21989994f,-0.71600008f,0.0f,0.0f,2.22029998f,-0.64749999f,1.47220001f,0.0f,0.0f,1.13120006f,-1.32330001f,-1.25259998f,0.0f,0.0f,-0.04750000f,1.24439998f,-1.92709998f,0.0f,0.0f,0.02190004f,1.63119989f,0.45070014f,0.0f,0.0f,-1.93379994f,-1.29340001f,0.74069999f,0.0f,0.0f,-1.15119994f,-2.46010012f,-0.52920000f,0.0f,0.0f,-1.97360001f,-1.10330006f,-0.54549999f,0.0f,0.0f,2.18469998f,-0.04369996f,-1.24120007f,0.0f,0.0f,1.43480003f,0.42780001f,-0.00900000f,0.0f,0.0f,0.86060001f,0.10500008f,0.52069993f,0.0f,0.0f,-1.19289995f,0.82659995f,-0.35500003f,0.0f,0.0f,1.39320001f,2.49940009f,-0.28349997f,0.0f,0.0f,2.46760003f,2.26450001f,-0.30410002f,0.0f,0.0f,1.49060007f,2.89470000f,1.66250003f,0.0f,0.0f,-0.37570000f,1.34140004f,1.73859993f,0.0f,0.0f,0.63890004f,-0.65470003f,-1.51580002f,0.0f,0.0f,-1.30479999f,1.22619998f,0.13860002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.86450000f,-0.63049998f,-0.99749999f,0.0f,0.0f,-0.45190000f,0.49780004f,0.67599999f,0.0f,0.0f,0.56579999f,0.55419997f,1.67350002f,0.0f,0.0f,-0.90479999f,0.32049999f,-0.50850000f,0.0f,0.0f,-0.49279997f,0.74949996f,-1.35199998f,0.0f,0.0f,0.61469995f,0.44290002f,-1.55079994f,0.0f,0.0f,-2.02679997f,0.12249996f,0.66629996f,0.0f,0.0f,1.08139996f,1.53449998f,1.17469996f,0.0f,0.0f,0.08910001f,-1.18429998f,-0.44330001f,0.0f,0.0f,2.27379996f,-1.28790005f,-0.43669993f,0.0f,0.0f,-0.69670002f,-1.32769998f,-0.48530003f,0.0f,0.0f,-0.09309999f,0.72080002f,0.17869995f,0.0f,0.0f,-0.07179999f,0.86789995f,1.10829995f,0.0f,0.0f,-0.26079995f,-0.64269998f,0.09839998f,0.0f,0.0f,2.08690003f,-0.09650003f,-0.07780000f,0.0f,0.0f,1.72830002f,1.79779995f,0.87590000f,0.0f,0.0f,-0.70219998f,-1.07490000f,-0.77569999f,0.0f,0.0f,-1.43899996f,0.15269997f,-0.39179998f,0.0f,0.0f,-0.29739996f,1.32939996f,-1.74219996f,0.0f,0.0f,0.32919999f,0.86829998f,0.42309997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.19829999f,1.40319995f,1.46789999f,0.0f,0.0f,0.28670005f,-0.65129997f,0.63340001f,0.0f,0.0f,4.09630006f,0.50220002f,-2.05060003f,0.0f,0.0f,-1.82329996f,-1.14790001f,0.65810003f,0.0f,0.0f,0.98480005f,1.67689997f,3.05249998f,0.0f,0.0f,2.27050003f,0.70489990f,-1.16549993f,0.0f,0.0f,3.08289993f,2.31799986f,-2.14220004f,0.0f,0.0f,-2.20149996f,-0.29130003f,-0.94930007f,0.0f,0.0f,1.62589999f,2.36460009f,-2.42310000f,0.0f,0.0f,-1.17029998f,1.16260002f,2.97740004f,0.0f,0.0f,3.47080004f,-2.96569995f,1.94960007f,0.0f,0.0f,0.46389993f,-2.11440004f,-0.75870004f,0.0f,0.0f,0.41810001f,-0.55070003f,-0.97449999f,0.0f,0.0f,1.39720003f,-1.39529996f,0.82649997f,0.0f,0.0f,2.40319998f,-0.18620006f,-1.43799999f,0.0f,0.0f,0.24659998f,-1.19709992f,-1.05279993f,0.0f,0.0f,-0.32859997f,-1.13560000f,0.41290002f,0.0f,0.0f,0.83630003f,0.29060002f,-1.09629998f,0.0f,0.0f,1.06430002f,1.83390000f,-1.51759999f,0.0f,0.0f,-0.91140000f,0.24539996f,-1.14420001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.75610000f,-0.31009998f,-1.11150007f,0.0f,0.0f,0.70650005f,-1.09709999f,0.31710000f,0.0f,0.0f,-1.50439999f,-0.62209997f,1.10270001f,0.0f,0.0f,0.12040001f,-0.28240000f,2.80880005f,0.0f,0.0f,-4.18659994f,-0.23099999f,-1.32609998f,0.0f,0.0f,-1.16730002f,-1.47149997f,0.39140005f,0.0f,0.0f,0.07060004f,0.55749991f,3.53369989f,0.0f,0.0f,-0.40250007f,0.06820000f,1.75429997f,0.0f,0.0f,1.53550007f,0.89200000f,0.20820002f,0.0f,0.0f,2.08139992f,0.07690001f,1.44059999f,0.0f,0.0f,0.91669997f,-0.05910004f,1.70829999f,0.0f,0.0f,0.82200001f,-1.34560005f,2.17469996f,0.0f,0.0f,2.84670009f,2.73240004f,1.72520002f,0.0f,0.0f,2.73570006f,-2.31729991f,0.39889991f,0.0f,0.0f,0.44110002f,-0.85839998f,-0.60999992f,0.0f,0.0f,-1.76159995f,-0.52009997f,-1.51969996f,0.0f,0.0f,-0.05830001f,0.04790001f,-0.30539998f,0.0f,0.0f,-0.80450008f,-1.57169997f,0.20770005f,0.0f,0.0f,-2.79649999f,-1.99360003f,-1.78490001f,0.0f,0.0f,0.36160006f,0.91620002f,1.36010002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.02480000f,-0.03480003f,1.68169998f,0.0f,0.0f,1.16840000f,-0.40120002f,-1.44459998f,0.0f,0.0f,-0.61320000f,0.41070001f,-2.16260002f,0.0f,0.0f,0.45039998f,-0.15690000f,0.97999993f,0.0f,0.0f,-0.61979998f,1.19510000f,0.99059997f,0.0f,0.0f,-1.50010000f,-1.22870000f,1.85649997f,0.0f,0.0f,3.48849998f,0.78650011f,-0.68939996f,0.0f,0.0f,-1.51339998f,-1.43199996f,0.88380001f,0.0f,0.0f,0.45270000f,0.46799997f,-0.00929998f,0.0f,0.0f,-1.50699999f,1.56329994f,0.30589990f,0.0f,0.0f,-1.55609998f,3.09390001f,-0.26970002f,0.0f,0.0f,0.16629999f,-0.39890003f,0.43249998f,0.0f,0.0f,0.81809993f,-0.83919995f,0.41800002f,0.0f,0.0f,-1.33280002f,2.44559997f,-0.54669998f,0.0f,0.0f,-2.11180002f,-0.47169994f,-0.01249998f,0.0f,0.0f,-1.83980002f,-1.12440001f,-1.96520000f,0.0f,0.0f,1.07539995f,0.39249998f,0.86259999f,0.0f,0.0f,2.07219996f,0.62999998f,-0.88160001f,0.0f,0.0f,1.40459995f,-0.76910003f,-0.09880001f,0.0f,0.0f,0.16039997f,0.89719999f,0.36630000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.11929998f,0.99370001f,-1.03599997f,0.0f,0.0f,-0.10889999f,-0.64870000f,-2.24020002f,0.0f,0.0f,-1.85449999f,0.35390001f,1.42129993f,0.0f,0.0f,-0.07340002f,-1.01700006f,2.30649999f,0.0f,0.0f,0.08230002f,-0.64960000f,2.43549993f,0.0f,0.0f,1.50369994f,0.80649997f,0.04459999f,0.0f,0.0f,-3.46809998f,-0.84779993f,1.45220006f,0.0f,0.0f,-0.66160007f,0.36639996f,0.94299996f,0.0f,0.0f,0.43269996f,-1.69560003f,-1.76739993f,0.0f,0.0f,4.20839997f,1.23279992f,0.39730007f,0.0f,0.0f,2.53539993f,-1.29299995f,1.29770004f,0.0f,0.0f,-0.17280001f,-2.74440000f,-1.99450003f,0.0f,0.0f,1.44340004f,1.16890006f,2.02559996f,0.0f,0.0f,3.23609995f,-0.41219993f,0.01579999f,0.0f,0.0f,-0.20059996f,1.18190010f,-2.13149988f,0.0f,0.0f,1.52070002f,1.09729994f,-1.26970003f,0.0f,0.0f,0.82680003f,-0.48709999f,-1.55200002f,0.0f,0.0f,-1.58419995f,-0.94509997f,-0.04689994f,0.0f,0.0f,0.30639996f,1.35260004f,0.27469999f,0.0f,0.0f,-0.38500000f,-0.10419997f,-0.16569998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.94780000f,0.82670002f,1.38760003f,0.0f,0.0f,1.84529998f,-1.02339998f,-0.10920000f,0.0f,0.0f,-1.60589995f,1.17199995f,0.99569995f,0.0f,0.0f,0.88919997f,0.38709999f,0.02780006f,0.0f,0.0f,2.21390004f,2.50349996f,-0.84350010f,0.0f,0.0f,0.61020003f,-0.94080001f,3.05470001f,0.0f,0.0f,-2.88609999f,-1.26710002f,0.42340010f,0.0f,0.0f,-0.22410015f,-1.13220003f,1.01269998f,0.0f,0.0f,-0.91540000f,2.63579997f,-0.11150005f,0.0f,0.0f,-1.70250005f,-1.54249994f,1.62829993f,0.0f,0.0f,1.16609996f,-2.49149995f,2.35200006f,0.0f,0.0f,2.03779999f,0.58519996f,-1.98589996f,0.0f,0.0f,0.34610004f,-3.82230001f,-1.31490005f,0.0f,0.0f,-1.85299999f,0.60100002f,1.06649995f,0.0f,0.0f,-2.25210001f,-0.24850006f,-0.08410006f,0.0f,0.0f,-0.07840008f,1.06030001f,0.39669992f,0.0f,0.0f,0.03060004f,-0.29130002f,-0.19859997f,0.0f,0.0f,0.36229996f,1.00459999f,-0.45980006f,0.0f,0.0f,-1.62069995f,-2.06049998f,0.01390003f,0.0f,0.0f,-0.79340007f,-0.07649999f,0.01869997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.45740003f,-2.29619992f,-0.63840001f,0.0f,0.0f,-0.48030005f,-0.47970006f,-3.04440001f,0.0f,0.0f,-0.42659999f,0.64440000f,0.81849999f,0.0f,0.0f,0.78810000f,-0.67700004f,0.54219997f,0.0f,0.0f,0.59520002f,0.32939992f,0.87230001f,0.0f,0.0f,1.93799998f,-1.21740004f,2.08660001f,0.0f,0.0f,0.79700000f,-0.16129998f,-0.61899996f,0.0f,0.0f,-1.68729999f,0.25669999f,1.10389996f,0.0f,0.0f,0.74219998f,-0.46609996f,0.78319995f,0.0f,0.0f,-2.01919996f,-0.67350008f,-0.64260004f,0.0f,0.0f,1.12739996f,-1.21009996f,-2.51540001f,0.0f,0.0f,-0.94959996f,0.43509999f,1.03179995f,0.0f,0.0f,-0.98970002f,1.41500004f,0.83790002f,0.0f,0.0f,0.49839993f,0.13380001f,0.78009994f,0.0f,0.0f,0.00970001f,-1.76999995f,-0.19429997f,0.0f,0.0f,0.08249994f,0.07049998f,-1.19940003f,0.0f,0.0f,-0.65259999f,0.57699998f,-0.20400000f,0.0f,0.0f,-0.72899997f,-0.49289999f,-0.38120001f,0.0f,0.0f,1.38099997f,0.45260003f,0.33409999f,0.0f,0.0f,-0.68769997f,-0.13300004f,0.95710000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.33620001f,-0.95250001f,1.31390000f,0.0f,0.0f,0.23020002f,-0.12309999f,1.63830003f,0.0f,0.0f,0.86629999f,-0.39559997f,-1.16240000f,0.0f,0.0f,0.46429999f,-1.14739999f,0.88399994f,0.0f,0.0f,-0.07490003f,2.10589998f,-0.63859997f,0.0f,0.0f,-1.11590006f,0.82170001f,-1.53920002f,0.0f,0.0f,-1.81599996f,-4.91020010f,0.11049989f,0.0f,0.0f,-0.17529995f,-1.14569996f,-0.38779998f,0.0f,0.0f,-0.92719992f,0.49450000f,1.07270000f,0.0f,0.0f,0.35219997f,-0.09949997f,-0.55649999f,0.0f,0.0f,-0.67570009f,0.91040002f,0.32830003f,0.0f,0.0f,-0.10690006f,3.25179996f,1.14390000f,0.0f,0.0f,-0.91909999f,3.46780003f,-0.85580002f,0.0f,0.0f,-0.51349992f,-0.28080002f,-0.46600006f,0.0f,0.0f,-4.18739993f,-1.67990002f,0.29719997f,0.0f,0.0f,0.64910003f,0.69130001f,4.53789998f,0.0f,0.0f,-0.96739996f,-0.33810001f,-0.98340000f,0.0f,0.0f,0.28509997f,1.16730006f,0.92499999f,0.0f,0.0f,1.74419999f,-1.72140004f,-1.38859996f,0.0f,0.0f,0.74629998f,-0.43169999f,-0.50859995f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.10710004f,0.39230000f,0.57110000f,0.0f,0.0f,-1.34680000f,-0.65629998f,1.09859996f,0.0f,0.0f,-0.44960002f,0.42479999f,-1.15459999f,0.0f,0.0f,-0.06929999f,-0.44899998f,-1.13750005f,0.0f,0.0f,0.44289997f,-0.87379997f,-1.85479995f,0.0f,0.0f,0.48659999f,-0.57989996f,0.00599999f,0.0f,0.0f,0.48039994f,1.23950018f,1.42520002f,0.0f,0.0f,1.18469999f,-0.75309999f,-1.47230003f,0.0f,0.0f,0.42889997f,-1.59369997f,1.01889994f,0.0f,0.0f,0.53179998f,0.41009995f,-0.94379997f,0.0f,0.0f,2.77449999f,2.41909994f,1.62589998f,0.0f,0.0f,0.72170004f,1.95679996f,1.58860003f,0.0f,0.0f,0.45390005f,-1.05940002f,2.07139998f,0.0f,0.0f,0.55290000f,2.42679999f,-2.89700001f,0.0f,0.0f,2.56279999f,-1.90899994f,-2.71090000f,0.0f,0.0f,-0.99999995f,0.59489993f,0.59839998f,0.0f,0.0f,1.79759998f,-1.40319997f,-1.10140004f,0.0f,0.0f,0.44890010f,1.73390002f,-1.52069997f,0.0f,0.0f,0.62400004f,0.59499999f,0.09050002f,0.0f,0.0f,0.64530001f,-0.61459998f,-0.88439994f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.19460004f,1.94049997f,0.55829999f,0.0f,0.0f,-0.80580000f,-0.89219999f,0.46840002f,0.0f,0.0f,-0.76920000f,0.35800001f,0.19509998f,0.0f,0.0f,-0.53960003f,0.25700002f,-0.49300001f,0.0f,0.0f,0.63570000f,-1.31329996f,-0.13180003f,0.0f,0.0f,-0.65129997f,-0.78419997f,-0.59190000f,0.0f,0.0f,-2.08430001f,1.49469996f,-0.28030000f,0.0f,0.0f,0.19300004f,-0.20009999f,-2.47779991f,0.0f,0.0f,-0.54309999f,-0.91300003f,-1.48129998f,0.0f,0.0f,1.00269999f,-0.38550002f,-1.09429999f,0.0f,0.0f,-0.10289999f,1.27650004f,0.69790005f,0.0f,0.0f,1.60919996f,1.24019994f,-0.99129996f,0.0f,0.0f,1.10729994f,0.42739995f,-0.48390000f,0.0f,0.0f,-1.83769994f,-1.56579998f,-1.48679997f,0.0f,0.0f,0.08789995f,0.29389999f,-0.73790002f,0.0f,0.0f,1.79169995f,-0.91780000f,-0.51950002f,0.0f,0.0f,-0.04649996f,-0.51480002f,1.25559998f,0.0f,0.0f,0.25709998f,-0.07800001f,0.00250002f,0.0f,0.0f,-0.05709998f,0.09679999f,0.78430002f,0.0f,0.0f,0.21860001f,0.76159998f,-0.69160000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.65500004f,0.15439999f,-0.04210001f,0.0f,0.0f,1.10440001f,0.85220009f,-0.67620003f,0.0f,0.0f,-0.63420005f,0.79580000f,0.70809992f,0.0f,0.0f,0.97559994f,0.24939999f,-0.89320001f,0.0f,0.0f,-1.00580002f,-3.02700006f,0.83439995f,0.0f,0.0f,-1.73620008f,-1.74019999f,1.56859995f,0.0f,0.0f,-0.41150007f,-2.69320002f,-0.60060010f,0.0f,0.0f,-1.91499998f,0.36430000f,1.63590004f,0.0f,0.0f,1.39470006f,-1.54090001f,0.42600002f,0.0f,0.0f,2.73439990f,1.16459998f,-0.13709995f,0.0f,0.0f,0.95560005f,-2.40050003f,1.76909998f,0.0f,0.0f,-1.10189984f,-3.70670002f,-1.42589997f,0.0f,0.0f,1.90739991f,-3.82479995f,-0.40539985f,0.0f,0.0f,2.83749997f,-0.24290008f,0.99029996f,0.0f,0.0f,1.63990007f,3.45830000f,1.37040003f,0.0f,0.0f,-1.33229996f,1.71359998f,-1.15710003f,0.0f,0.0f,1.49439996f,0.14539996f,1.00549998f,0.0f,0.0f,1.10480001f,2.31679995f,1.84619994f,0.0f,0.0f,1.98690013f,0.51589998f,-0.88050010f,0.0f,0.0f,2.16200000f,-0.92229998f,0.18290000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.47840000f,1.04789999f,0.33880004f,0.0f,0.0f,1.43440002f,-1.58249999f,-2.32850002f,0.0f,0.0f,-1.51019987f,-1.67020009f,-0.89229995f,0.0f,0.0f,-1.18850000f,0.44970004f,0.35400001f,0.0f,0.0f,-1.35710006f,-0.93550001f,1.35850001f,0.0f,0.0f,1.36500002f,3.91019999f,2.72289990f,0.0f,0.0f,3.12860001f,-0.07730008f,-1.71310002f,0.0f,0.0f,-1.26080004f,-0.85719997f,-1.11039999f,0.0f,0.0f,0.00040011f,-1.99029996f,-2.44749997f,0.0f,0.0f,1.64410009f,-1.51759999f,0.51339994f,0.0f,0.0f,-1.94420004f,-1.49439998f,-0.03729996f,0.0f,0.0f,2.53629992f,-0.89239992f,0.31530000f,0.0f,0.0f,0.13880000f,1.28359993f,-2.76119993f,0.0f,0.0f,-2.21100003f,-1.98550000f,-0.91920001f,0.0f,0.0f,-0.61230007f,2.32610005f,0.58479999f,0.0f,0.0f,-2.01210007f,-0.83899992f,2.52199998f,0.0f,0.0f,0.91599995f,0.72200003f,1.62799998f,0.0f,0.0f,-1.01729997f,-2.46389999f,0.04560002f,0.0f,0.0f,-2.89829996f,-0.90369995f,0.62919996f,0.0f,0.0f,-0.49740000f,-0.02800000f,0.77899997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.63880003f,-0.70569999f,-0.72460001f,0.0f,0.0f,0.45100002f,0.13550000f,-0.33059999f,0.0f,0.0f,0.50460002f,-0.22119999f,0.55859999f,0.0f,0.0f,0.99630004f,-0.50680002f,0.15130000f,0.0f,0.0f,0.97409999f,1.16159994f,-0.26609999f,0.0f,0.0f,0.31719998f,-0.59880002f,1.93720000f,0.0f,0.0f,-0.34039999f,-1.03800003f,0.02399996f,0.0f,0.0f,-1.01839997f,-0.02600001f,0.95399997f,0.0f,0.0f,1.73409995f,1.68370001f,0.31809998f,0.0f,0.0f,-0.82679996f,-0.25290002f,0.01259999f,0.0f,0.0f,-0.62560002f,-1.22909999f,-0.66900001f,0.0f,0.0f,-0.65619998f,0.14269999f,1.12429998f,0.0f,0.0f,-0.96419998f,-0.77330002f,0.21469998f,0.0f,0.0f,0.65879994f,0.87089994f,-0.52960005f,0.0f,0.0f,-0.41390000f,0.19350005f,-0.29929998f,0.0f,0.0f,-1.53940004f,0.29830000f,-0.73470002f,0.0f,0.0f,-1.02789998f,0.74499998f,-0.60599998f,0.0f,0.0f,-0.22349997f,0.13599999f,-0.92850002f,0.0f,0.0f,0.76280000f,-0.09789999f,-0.73259997f,0.0f,0.0f,-0.57109998f,-0.27120001f,0.20379998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.08880004f,-1.55340003f,1.94299998f,0.0f,0.0f,1.03770002f,1.58470007f,2.62410006f,0.0f,0.0f,0.71870002f,0.24999997f,-1.08129999f,0.0f,0.0f,-0.00730000f,-1.10279999f,-1.62530001f,0.0f,0.0f,-1.84260003f,-1.88030001f,-0.08579994f,0.0f,0.0f,0.04259985f,0.21400002f,1.44749993f,0.0f,0.0f,2.05750003f,-1.83239999f,0.34869995f,0.0f,0.0f,-0.85040001f,-0.59309991f,-0.31969996f,0.0f,0.0f,0.63250006f,-0.05630001f,2.36149992f,0.0f,0.0f,-3.22579994f,0.56499997f,0.55769995f,0.0f,0.0f,-4.33779999f,1.47030008f,1.67270002f,0.0f,0.0f,3.57890000f,-1.92449998f,1.42649998f,0.0f,0.0f,0.67090001f,2.28100001f,-1.77389992f,0.0f,0.0f,-0.69609989f,-0.82959994f,-0.73410003f,0.0f,0.0f,2.53330006f,2.15979994f,2.11520001f,0.0f,0.0f,0.64620002f,-0.61650002f,-1.81049996f,0.0f,0.0f,1.47089997f,0.02359997f,0.27859999f,0.0f,0.0f,0.56170004f,-1.16369996f,0.96560003f,0.0f,0.0f,0.08739992f,-1.12079995f,0.24409999f,0.0f,0.0f,1.68329998f,0.27429997f,0.93399999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.43280007f,-0.01600000f,0.73820002f,0.0f,0.0f,-1.17259999f,-0.47360002f,-0.91090003f,0.0f,0.0f,1.11099998f,-1.62889994f,-2.38939999f,0.0f,0.0f,-0.79790003f,0.88530002f,0.48479998f,0.0f,0.0f,0.06020000f,-3.86249994f,0.92580000f,0.0f,0.0f,1.17650002f,0.25800003f,-4.10509988f,0.0f,0.0f,-1.77999996f,2.03070003f,-0.49049991f,0.0f,0.0f,-0.15100004f,-2.20629994f,1.24609993f,0.0f,0.0f,2.37020004f,-0.68009996f,-2.48700004f,0.0f,0.0f,-0.64319988f,-2.13499993f,-0.59280007f,0.0f,0.0f,-0.93739992f,-0.04930003f,0.61279999f,0.0f,0.0f,-0.72370003f,-3.00150001f,-0.90209996f,0.0f,0.0f,0.86859996f,1.53260001f,-1.37749999f,0.0f,0.0f,-0.21930005f,-0.50690004f,-1.03900007f,0.0f,0.0f,-3.17119992f,1.57740002f,1.91470001f,0.0f,0.0f,2.02659997f,-1.04069998f,-0.48549999f,0.0f,0.0f,-2.61329997f,0.78899994f,0.14070001f,0.0f,0.0f,0.59139998f,0.27259998f,0.13490000f,0.0f,0.0f,0.40820002f,-0.82719998f,0.95730004f,0.0f,0.0f,-1.70389999f,-0.53930000f,0.50419993f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.24880004f,1.50189992f,0.66439999f,0.0f,0.0f,-0.50079999f,-0.09899996f,1.82390000f,0.0f,0.0f,0.20600001f,-0.00480002f,-0.97829996f,0.0f,0.0f,-0.83710001f,0.95130002f,-0.15659997f,0.0f,0.0f,-0.98840001f,-0.67509998f,-1.32719997f,0.0f,0.0f,-0.38679997f,0.02999996f,-1.60629999f,0.0f,0.0f,-0.14270002f,-0.58549995f,0.78389993f,0.0f,0.0f,1.52820005f,0.49410000f,-0.11840001f,0.0f,0.0f,-1.76319995f,-0.13180004f,-0.44070000f,0.0f,0.0f,1.58959998f,-0.83529997f,0.18320001f,0.0f,0.0f,-1.78199986f,0.12610004f,1.84290002f,0.0f,0.0f,0.07560001f,-2.12520002f,-0.30560000f,0.0f,0.0f,0.33140005f,-0.94870002f,-1.29920001f,0.0f,0.0f,-1.43329992f,0.52569999f,0.74440007f,0.0f,0.0f,1.15509997f,0.61259995f,0.89089995f,0.0f,0.0f,0.64760002f,0.24720002f,-0.67049996f,0.0f,0.0f,1.51170000f,0.27120003f,-0.44840000f,0.0f,0.0f,-0.35010003f,0.21219999f,1.07069999f,0.0f,0.0f,0.71229999f,0.44119997f,-0.62280004f,0.0f,0.0f,1.09020001f,0.08940002f,0.33579999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.50149999f,1.46670001f,-0.01580000f,0.0f,0.0f,-1.65009997f,2.33070004f,1.76239999f,0.0f,0.0f,-1.07509999f,-1.35480007f,0.97860001f,0.0f,0.0f,-2.40570004f,-1.50560001f,-0.12409998f,0.0f,0.0f,0.36340003f,-0.22160007f,1.66870004f,0.0f,0.0f,-2.97969994f,-0.51159998f,-1.39189998f,0.0f,0.0f,2.03229994f,0.55010008f,-0.66559995f,0.0f,0.0f,-2.44949998f,-1.40789993f,-1.06370001f,0.0f,0.0f,-2.46229997f,2.48170002f,-0.42619990f,0.0f,0.0f,2.04749994f,0.41120002f,1.29739997f,0.0f,0.0f,-1.67160002f,-0.88309997f,1.56170003f,0.0f,0.0f,1.23160002f,-0.44119999f,0.20700003f,0.0f,0.0f,2.08520006f,-0.10709994f,-2.89320006f,0.0f,0.0f,1.08860000f,-0.88590000f,4.00070002f,0.0f,0.0f,0.03059998f,-1.18320002f,-1.32430001f,0.0f,0.0f,-0.71829997f,0.67590001f,-0.79459998f,0.0f,0.0f,-0.28300004f,0.09300000f,0.64079998f,0.0f,0.0f,0.25419997f,-0.10589998f,-2.40849996f,0.0f,0.0f,0.12700004f,1.31220011f,-2.28940002f,0.0f,0.0f,-1.61030001f,0.86880000f,-0.99980000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.85120008f,1.16589998f,-1.96419996f,0.0f,0.0f,-1.31039999f,-3.11300000f,0.12369997f,0.0f,0.0f,0.61099997f,-3.10380002f,2.14820003f,0.0f,0.0f,0.75460003f,0.02610001f,-0.81170007f,0.0f,0.0f,-2.24750006f,1.39610006f,-1.12830001f,0.0f,0.0f,-0.60159999f,-2.09670002f,-0.48860000f,0.0f,0.0f,0.29429994f,-0.74260002f,1.03450000f,0.0f,0.0f,-0.57170008f,-1.81730000f,2.42839999f,0.0f,0.0f,-3.58119998f,2.27070003f,-2.01449996f,0.0f,0.0f,-0.23540003f,-2.26860002f,-4.34709999f,0.0f,0.0f,-0.21429985f,3.10700005f,-1.84960008f,0.0f,0.0f,1.19750006f,-0.56960008f,-2.55940004f,0.0f,0.0f,0.53560007f,0.85389999f,0.27640000f,0.0f,0.0f,-0.44070001f,0.80390001f,1.66330000f,0.0f,0.0f,0.53569998f,-0.83479999f,-2.50729996f,0.0f,0.0f,-3.67220004f,-0.84549996f,-2.72100006f,0.0f,0.0f,-0.97470002f,0.77939999f,0.22070005f,0.0f,0.0f,-0.34299997f,-1.19060000f,-0.18369997f,0.0f,0.0f,-1.85930001f,1.39930003f,1.13880004f,0.0f,0.0f,-0.02599998f,0.56540001f,0.72769996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.06180002f,-1.67820003f,-0.24809996f,0.0f,0.0f,1.71479996f,1.53299998f,0.51900001f,0.0f,0.0f,-2.48070001f,2.89589998f,3.67180000f,0.0f,0.0f,0.10420000f,0.88290006f,-0.56919999f,0.0f,0.0f,0.86929998f,-2.03950008f,-0.67609999f,0.0f,0.0f,0.32359999f,0.23290003f,-2.32680003f,0.0f,0.0f,-0.84379997f,-1.25350001f,0.94869999f,0.0f,0.0f,-0.86519999f,1.02530005f,2.85000001f,0.0f,0.0f,1.43089998f,-1.88699993f,-0.79540001f,0.0f,0.0f,-1.82119996f,-1.00199996f,-1.85769997f,0.0f,0.0f,-0.86810001f,-2.12270001f,0.26509999f,0.0f,0.0f,1.21299994f,0.39160004f,1.76079996f,0.0f,0.0f,-0.52500001f,-1.48669998f,-0.42829995f,0.0f,0.0f,0.38620005f,2.34339995f,-0.28830006f,0.0f,0.0f,1.60250001f,0.94830000f,1.58299997f,0.0f,0.0f,-1.57279995f,-0.41749998f,0.45830000f,0.0f,0.0f,-0.37690001f,0.78860002f,-0.30400001f,0.0f,0.0f,0.48210001f,-0.02810001f,-0.47279998f,0.0f,0.0f,0.89399996f,0.05609999f,0.28869999f,0.0f,0.0f,-0.05790002f,0.97959999f,1.49840000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.99490003f,-0.11430001f,0.48479999f,0.0f,0.0f,0.65530002f,-0.62050000f,0.92320002f,0.0f,0.0f,0.04180004f,0.36220006f,1.61680000f,0.0f,0.0f,0.15590003f,-1.16349993f,-0.48220000f,0.0f,0.0f,-0.53319995f,0.27229998f,-2.62519996f,0.0f,0.0f,1.23679997f,2.41529998f,-0.01909996f,0.0f,0.0f,0.45399994f,2.12419998f,-3.64700005f,0.0f,0.0f,-0.23500003f,1.25629994f,1.11880000f,0.0f,0.0f,1.40070000f,-2.42510010f,1.26999999f,0.0f,0.0f,-2.74819998f,-0.17220001f,1.10100009f,0.0f,0.0f,0.68719994f,-1.48099995f,-3.45160003f,0.0f,0.0f,1.35019986f,0.09320008f,0.64689999f,0.0f,0.0f,0.61919991f,2.97940000f,-0.00839997f,0.0f,0.0f,-0.00359997f,2.45520005f,-0.67159995f,0.0f,0.0f,-2.65350005f,-0.70859994f,1.40450006f,0.0f,0.0f,0.32839997f,-1.08810007f,-0.88079998f,0.0f,0.0f,-0.54109996f,1.15579993f,-0.59740002f,0.0f,0.0f,-0.72129995f,0.86250002f,-0.18700000f,0.0f,0.0f,-3.01619995f,-3.40509998f,-0.43760003f,0.0f,0.0f,1.66620000f,0.56269999f,-0.52059998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.68840002f,-2.70250000f,1.63769997f,0.0f,0.0f,0.60389999f,0.15779997f,-1.14240000f,0.0f,0.0f,-1.08980005f,0.29400003f,-1.57590009f,0.0f,0.0f,0.91309997f,-1.27859999f,0.47340003f,0.0f,0.0f,-0.75660009f,-0.56410002f,-1.77749996f,0.0f,0.0f,2.95419999f,2.94089992f,2.30720004f,0.0f,0.0f,-0.27660003f,-1.97329994f,0.31730000f,0.0f,0.0f,0.05969991f,-2.03309997f,-1.21610002f,0.0f,0.0f,-0.76640004f,-2.13790003f,-0.60910001f,0.0f,0.0f,0.61990004f,0.85210002f,1.91230001f,0.0f,0.0f,0.44880001f,-0.87830002f,2.13779991f,0.0f,0.0f,-1.89819997f,-1.11740001f,1.40830000f,0.0f,0.0f,0.33979999f,2.16259998f,-0.51329999f,0.0f,0.0f,0.63920002f,2.32000002f,-0.76130001f,0.0f,0.0f,-0.28819988f,-2.26700000f,-0.63599998f,0.0f,0.0f,-0.12429996f,0.40079999f,0.62750007f,0.0f,0.0f,-0.28680003f,1.97720000f,1.79019994f,0.0f,0.0f,1.58650003f,1.15979996f,1.32369997f,0.0f,0.0f,2.88740001f,0.11420002f,2.05820003f,0.0f,0.0f,-0.62320004f,0.16649999f,0.28820000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.00340001f,0.07270002f,0.72239998f,0.0f,0.0f,-1.00520000f,-1.13579996f,-1.05890001f,0.0f,0.0f,0.77460003f,-0.38900001f,-0.93460003f,0.0f,0.0f,-0.01710002f,1.31229996f,-0.45140000f,0.0f,0.0f,-0.65639998f,1.03920001f,-0.55119998f,0.0f,0.0f,-0.72069996f,-0.92039997f,-0.27769998f,0.0f,0.0f,0.13530000f,-1.47079997f,-1.30520007f,0.0f,0.0f,-1.14769995f,1.48709995f,-2.01679997f,0.0f,0.0f,-1.36169993f,0.83259998f,0.44089998f,0.0f,0.0f,1.71790000f,1.32229996f,0.43110000f,0.0f,0.0f,-0.28000004f,-0.39840004f,-1.39430003f,0.0f,0.0f,-1.03649995f,1.35319996f,-0.53969998f,0.0f,0.0f,0.48580002f,1.44799998f,2.50269997f,0.0f,0.0f,1.13860000f,-0.05250001f,0.61179996f,0.0f,0.0f,-0.09579996f,-0.10180000f,1.02159999f,0.0f,0.0f,2.69859997f,-0.45879996f,-0.27439998f,0.0f,0.0f,0.31040003f,1.00029999f,1.10180002f,0.0f,0.0f,-0.44810001f,0.41419999f,-1.38000000f,0.0f,0.0f,0.17119998f,1.17090000f,0.66389997f,0.0f,0.0f,0.71479996f,-0.34229997f,-0.18640001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.76720002f,0.13219996f,0.42279995f,0.0f,0.0f,-0.46349995f,-1.87010005f,-1.35130004f,0.0f,0.0f,-0.11490002f,-1.88030000f,-1.59159998f,0.0f,0.0f,0.50459997f,0.48609992f,-0.39210004f,0.0f,0.0f,-1.33170002f,-2.15189998f,2.91710001f,0.0f,0.0f,-2.79799991f,-1.67390005f,1.56910003f,0.0f,0.0f,0.52589999f,-2.10450004f,4.56039993f,0.0f,0.0f,-2.11939996f,-2.80570002f,1.85110006f,0.0f,0.0f,0.24260000f,2.00999990f,0.07119997f,0.0f,0.0f,0.90470008f,-0.73760002f,-2.31449999f,0.0f,0.0f,-5.09770005f,0.68000014f,3.74929994f,0.0f,0.0f,-2.62949994f,-1.14080009f,-2.02570002f,0.0f,0.0f,-3.55669997f,-0.19450004f,-0.61020006f,0.0f,0.0f,-2.05939988f,-3.09499998f,0.51429991f,0.0f,0.0f,1.58010005f,-2.38799999f,0.50399992f,0.0f,0.0f,1.83099998f,0.12399997f,-2.18439996f,0.0f,0.0f,-0.06819995f,0.81330005f,0.59159995f,0.0f,0.0f,-1.78849999f,-0.55339997f,0.54780000f,0.0f,0.0f,0.84839999f,-1.31530001f,0.02950004f,0.0f,0.0f,1.22600000f,-1.31000000f,-1.03199996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-2.04400001f,3.04770002f,-1.60769999f,0.0f,0.0f,-1.48040003f,-1.50450000f,1.89880004f,0.0f,0.0f,0.54290002f,-0.58090006f,2.45760002f,0.0f,0.0f,-0.38429996f,0.20319993f,-0.08250005f,0.0f,0.0f,1.43330017f,1.37389996f,-1.32329987f,0.0f,0.0f,-2.42979999f,-0.96090004f,-1.86519999f,0.0f,0.0f,1.76420003f,-0.62110002f,3.35279992f,0.0f,0.0f,-0.89090002f,-3.72020003f,1.45219994f,0.0f,0.0f,-2.14319983f,0.36220000f,1.98340009f,0.0f,0.0f,-2.21839996f,2.26980002f,-0.72079999f,0.0f,0.0f,0.84999997f,-1.47610002f,-2.25490001f,0.0f,0.0f,1.12049993f,0.61309996f,-2.66149989f,0.0f,0.0f,1.66469997f,-0.53370002f,0.15069998f,0.0f,0.0f,-1.05490008f,-3.62120001f,-0.01409996f,0.0f,0.0f,-0.56520004f,3.03230000f,-4.22399990f,0.0f,0.0f,-1.06330009f,-1.22749995f,-0.11189999f,0.0f,0.0f,1.12270003f,-0.38670003f,0.69870001f,0.0f,0.0f,-1.03779993f,-0.31319992f,-0.48460005f,0.0f,0.0f,-3.64879990f,2.39420003f,-0.89269992f,0.0f,0.0f,0.27620006f,-0.56330000f,0.20490000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.51240001f,0.06960000f,-0.38229999f,0.0f,0.0f,0.27229999f,1.04179997f,0.36720002f,0.0f,0.0f,-1.26340001f,1.56439997f,1.43560000f,0.0f,0.0f,-0.46069999f,-0.51860000f,1.49100000f,0.0f,0.0f,-0.75610007f,-0.91570000f,-0.51499997f,0.0f,0.0f,1.26390002f,0.36200003f,-0.20670001f,0.0f,0.0f,-1.08540003f,-1.66869994f,1.01719998f,0.0f,0.0f,0.78030000f,1.42720001f,0.22340003f,0.0f,0.0f,0.63249998f,-1.17779992f,-1.10689998f,0.0f,0.0f,-1.25299998f,-0.52519998f,-0.95359998f,0.0f,0.0f,0.17420005f,-0.34019998f,0.11349998f,0.0f,0.0f,0.21700001f,-0.88480003f,-0.28049999f,0.0f,0.0f,1.44839997f,-2.11969991f,-1.33649994f,0.0f,0.0f,0.97870003f,1.33119996f,0.13489999f,0.0f,0.0f,2.02279999f,0.87629998f,0.83149998f,0.0f,0.0f,-1.50779998f,-0.52540002f,-0.59699996f,0.0f,0.0f,-1.28179994f,0.97650004f,-0.73679998f,0.0f,0.0f,0.67009998f,-0.46389996f,-1.15759998f,0.0f,0.0f,1.09219997f,-0.25629996f,1.02449996f,0.0f,0.0f,-0.21860001f,-0.07290000f,0.65999997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.69080010f,-1.74910001f,0.06859997f,0.0f,0.0f,1.11560000f,-2.54199998f,-0.83040000f,0.0f,0.0f,1.57800002f,-0.23519996f,-0.94600004f,0.0f,0.0f,0.42220001f,2.68369997f,-0.08720004f,0.0f,0.0f,-0.60150007f,-2.29839989f,1.34299993f,0.0f,0.0f,1.54579994f,3.29429999f,2.31229994f,0.0f,0.0f,0.90340000f,-2.85869994f,1.43259990f,0.0f,0.0f,0.26870001f,-0.08860006f,0.15770001f,0.0f,0.0f,2.22300003f,-2.89460004f,2.45509995f,0.0f,0.0f,-2.70549999f,1.66309992f,2.24460006f,0.0f,0.0f,-2.48629999f,2.50040001f,-1.19759996f,0.0f,0.0f,-1.61820002f,4.06789998f,-3.60890008f,0.0f,0.0f,-0.10820007f,1.84330003f,0.11250004f,0.0f,0.0f,-1.00369999f,0.15380003f,-1.04980001f,0.0f,0.0f,-2.82050001f,0.05040005f,0.22820002f,0.0f,0.0f,-2.52450000f,-2.00700002f,1.51589998f,0.0f,0.0f,0.88619997f,-1.77169994f,1.01180000f,0.0f,0.0f,0.72960006f,1.65499996f,-0.74489997f,0.0f,0.0f,0.66350002f,0.51800004f,0.25920003f,0.0f,0.0f,0.46570003f,-0.94199997f,0.44609999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.31950004f,-1.99180001f,0.88919996f,0.0f,0.0f,0.72870001f,1.57489995f,-1.04970002f,0.0f,0.0f,-2.82719999f,0.34849995f,0.43700001f,0.0f,0.0f,-1.43520003f,0.59610001f,0.25649999f,0.0f,0.0f,-0.92690002f,-1.91059997f,1.58749999f,0.0f,0.0f,-0.61369999f,0.41870000f,-0.11570001f,0.0f,0.0f,-0.50879999f,0.85769991f,0.83979993f,0.0f,0.0f,-1.05069997f,1.28330002f,-1.70740003f,0.0f,0.0f,1.20369992f,-0.16390007f,2.96050003f,0.0f,0.0f,-0.53840007f,2.67060006f,1.45440004f,0.0f,0.0f,0.38789999f,1.73939993f,-1.20710009f,0.0f,0.0f,1.15339999f,-2.27119991f,-0.47390006f,0.0f,0.0f,-2.85030002f,-1.10789998f,-2.93599998f,0.0f,0.0f,0.16239999f,1.91090005f,0.11799998f,0.0f,0.0f,0.86620004f,-1.00729999f,-1.51350015f,0.0f,0.0f,-0.75240001f,2.81120002f,-1.19109995f,0.0f,0.0f,-0.33389999f,-1.18979997f,-0.25789996f,0.0f,0.0f,1.36319999f,0.64570003f,-3.35409996f,0.0f,0.0f,0.01470001f,1.69709999f,-0.13500007f,0.0f,0.0f,0.24390000f,-1.39719996f,-1.00580001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.00300000f,1.36310005f,1.04549998f,0.0f,0.0f,-1.23739998f,-1.94399997f,-0.50360001f,0.0f,0.0f,2.07019998f,-2.96980000f,-3.25409996f,0.0f,0.0f,-0.20260002f,-0.75490005f,-1.05080000f,0.0f,0.0f,-0.01039999f,1.53040005f,-0.02730000f,0.0f,0.0f,-0.69699996f,0.08570002f,1.54120001f,0.0f,0.0f,1.73469997f,3.32139999f,-0.87229993f,0.0f,0.0f,0.99610001f,-0.65130001f,-1.68840001f,0.0f,0.0f,-1.43720000f,0.90939991f,0.69049999f,0.0f,0.0f,0.92619996f,1.10599996f,1.44419997f,0.0f,0.0f,0.56089997f,-0.78759993f,-0.86319996f,0.0f,0.0f,1.93800001f,-0.09559995f,-0.97179998f,0.0f,0.0f,-0.00589995f,0.75429993f,0.29790000f,0.0f,0.0f,-0.14980003f,-2.12939993f,0.21020001f,0.0f,0.0f,-3.01610003f,-0.92670000f,-1.23109987f,0.0f,0.0f,0.60810000f,1.77509997f,0.71899996f,0.0f,0.0f,0.25480000f,-1.95670001f,0.70140000f,0.0f,0.0f,-0.70260000f,-0.57839998f,1.60659998f,0.0f,0.0f,-0.77760000f,-0.75450002f,-0.71709998f,0.0f,0.0f,0.05480003f,-0.45160001f,-0.16379999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_1item_1o1i_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{1,1,3,5};
    Shape shape_b{1,1,2,2};
    Shape shape_r{1,1,4,8};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{2,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.68889997f,0.04410000f,-0.17429999f,-0.09449999f,0.37349998f,-0.04620000f,0.18260000f,0.18899999f,-0.44549999f,0.01320000f,0.02700000f,0.06820000f,0.13950000f,0.17600000f,0.36000000f,-0.11880000f,-0.82169999f,-0.01260000f,0.04980000f,-0.06510000f,0.25730000f,-0.16800000f,0.66400000f,0.11340000f,0.39599999f,-0.02860000f,-0.05850000f,-0.05500000f,-0.11250000f,-0.19360000f,-0.39599999f,0.05500000f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_1item_2o1i_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{1,1,3,5};
    Shape shape_b{2,1,2,2};
    Shape shape_r{1,2,4,8};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{2,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.68889997f,0.04410000f,-0.17429999f,-0.09449999f,0.37349998f,-0.04620000f,0.18260000f,0.18899999f,-0.44549999f,0.01320000f,0.02700000f,0.06820000f,0.13950000f,0.17600000f,0.36000000f,-0.11880000f,-0.82169999f,-0.01260000f,0.04980000f,-0.06510000f,0.25730000f,-0.16800000f,0.66400000f,0.11340000f,0.39599999f,-0.02860000f,-0.05850000f,-0.05500000f,-0.11250000f,-0.19360000f,-0.39599999f,0.05500000f,-0.74699997f,0.20790000f,0.18899999f,-0.44549999f,-0.40499998f,-0.21780000f,-0.19799999f,0.89099998f,-0.05940000f,0.01860000f,0.00360000f,0.09610000f,0.01860000f,0.24800001f,0.04800000f,-0.16740001f,0.89099998f,-0.05940000f,-0.05400000f,-0.30690001f,-0.27899999f,-0.79200002f,-0.71999999f,0.53460003f,0.05280000f,-0.04030000f,-0.00780000f,-0.07750000f,-0.01500000f,-0.27280000f,-0.05280000f,0.07750000f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_1item_2o2i_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{1,2,3,5};
    Shape shape_b{2,2,2,2};
    Shape shape_r{1,2,4,8};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{2,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{1.23789997f,1.02420002f,0.71669999f,-0.83700000f,-0.30150000f,0.29040001f,0.48859999f,0.20879999f,-0.48449999f,0.06590000f,0.03720000f,0.21080000f,0.16710000f,0.25660000f,0.37559999f,-0.35130001f,-0.23670003f,-0.18090000f,-0.10320000f,-0.52050001f,-0.15670000f,-0.42539999f,0.43000001f,0.85590001f,0.40139999f,0.00550000f,-0.05190000f,-0.28750000f,-0.15750000f,-0.06340000f,-0.37079999f,0.34330000f,0.81650000f,0.98460000f,0.07950001f,-0.90300000f,0.17250000f,0.18040000f,0.26100000f,0.50360001f,-1.03370000f,-0.11150000f,0.09530000f,-0.32090001f,0.38780000f,-0.26260000f,0.76900000f,0.52770001f,-0.62950003f,-0.18200000f,0.00550000f,-0.57220001f,0.13300000f,-0.66080001f,0.57500002f,0.95160002f,0.79689999f,-0.05020000f,-0.08690000f,0.49000001f,-0.40750000f,-0.14180000f,-0.66939999f,-0.59980002f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_1item_5o3i_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{1,3,3,5};
    Shape shape_b{5,3,2,2};
    Shape shape_r{1,5,4,8};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{2,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{2.01390001f,0.54360000f,1.42869999f,-0.75600000f,-0.42150001f,0.32280001f,0.44059999f,0.04679998f,-0.13249999f,0.00480000f,0.45080000f,0.10940001f,0.85349997f,0.19940000f,0.76279999f,-0.39420001f,0.08329998f,-0.43470001f,0.27280000f,-0.94170001f,0.46729999f,-0.66300000f,0.78200001f,0.67769999f,0.99979999f,-0.01790000f,0.10650001f,-0.27710000f,-0.22789999f,0.03280000f,-1.02199999f,0.24450001f,-0.23409997f,-0.40640001f,0.45410005f,0.14100001f,-0.75750000f,-0.45880000f,0.32060000f,0.82799998f,0.15750000f,0.08220000f,0.17340000f,0.00449998f,0.27989999f,-0.37880002f,0.31400001f,0.43020002f,0.63099999f,0.15460000f,-0.48879999f,0.20480000f,-1.03989998f,-0.43420001f,-0.74339998f,-0.03119998f,0.50220001f,0.12390000f,0.01290001f,0.14670000f,0.15570000f,0.33600001f,-0.70320001f,0.02649999f,-1.02420000f,-0.99300001f,-0.39180000f,0.74700001f,0.00000000f,-0.29280001f,-0.29880000f,-0.11760000f,-0.61939999f,0.29430000f,0.31250001f,0.48889999f,0.71430002f,-0.19260002f,0.47220000f,-0.13049997f,0.40950002f,0.13530000f,-0.04410000f,0.40890002f,-0.15630000f,0.28740000f,-0.55680002f,-0.76590001f,0.38810002f,0.26740000f,0.14640001f,-0.51199999f,-0.77900002f,0.73779997f,0.08859999f,0.94419999f,0.71249999f,0.43229999f,-0.09550003f,0.35549998f,0.60750000f,0.05819999f,-0.17340000f,-0.44459994f,-0.23160000f,-0.45380001f,0.19140000f,-0.81529999f,0.39599999f,-0.25399998f,0.49840000f,0.13259998f,-0.60329999f,0.48630000f,0.50100000f,1.00319998f,1.05129998f,1.05359999f,0.88719999f,-0.26909999f,0.63840000f,-0.25750001f,0.00240000f,0.53170000f,-0.08040000f,-0.05359999f,-0.70199999f,-1.16810001f,0.83300002f,-0.29790000f,0.48059999f,0.23550000f,0.09600000f,0.01460000f,-0.04200000f,-0.26379999f,0.32240001f,-0.29840000f,0.01360001f,-0.70669998f,-0.02869999f,-0.80519998f,-0.52220001f,0.53399998f,-0.01870000f,-0.01760000f,0.39010000f,0.04830001f,0.72069998f,0.18360000f,0.55040000f,-0.27960001f,-0.72729999f,-0.03370001f,0.15920000f,0.50949998f,-0.29120001f,0.69160000f,1.07560000f,-0.85709999f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_2item_5o3i_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,3,3,5};
    Shape shape_b{5,3,2,2};
    Shape shape_r{2,5,4,8};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{2,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{2.01390001f,0.54360000f,1.42869999f,-0.75600000f,-0.42150001f,0.32280001f,0.44059999f,0.04679998f,-0.13249999f,0.00480000f,0.45080000f,0.10940001f,0.85349997f,0.19940000f,0.76279999f,-0.39420001f,0.08329998f,-0.43470001f,0.27280000f,-0.94170001f,0.46729999f,-0.66300000f,0.78200001f,0.67769999f,0.99979999f,-0.01790000f,0.10650001f,-0.27710000f,-0.22789999f,0.03280000f,-1.02199999f,0.24450001f,-0.23409997f,-0.40640001f,0.45410005f,0.14100001f,-0.75750000f,-0.45880000f,0.32060000f,0.82799998f,0.15750000f,0.08220000f,0.17340000f,0.00449998f,0.27989999f,-0.37880002f,0.31400001f,0.43020002f,0.63099999f,0.15460000f,-0.48879999f,0.20480000f,-1.03989998f,-0.43420001f,-0.74339998f,-0.03119998f,0.50220001f,0.12390000f,0.01290001f,0.14670000f,0.15570000f,0.33600001f,-0.70320001f,0.02649999f,-1.02420000f,-0.99300001f,-0.39180000f,0.74700001f,0.00000000f,-0.29280001f,-0.29880000f,-0.11760000f,-0.61939999f,0.29430000f,0.31250001f,0.48889999f,0.71430002f,-0.19260002f,0.47220000f,-0.13049997f,0.40950002f,0.13530000f,-0.04410000f,0.40890002f,-0.15630000f,0.28740000f,-0.55680002f,-0.76590001f,0.38810002f,0.26740000f,0.14640001f,-0.51199999f,-0.77900002f,0.73779997f,0.08859999f,0.94419999f,0.71249999f,0.43229999f,-0.09550003f,0.35549998f,0.60750000f,0.05819999f,-0.17340000f,-0.44459994f,-0.23160000f,-0.45380001f,0.19140000f,-0.81529999f,0.39599999f,-0.25399998f,0.49840000f,0.13259998f,-0.60329999f,0.48630000f,0.50100000f,1.00319998f,1.05129998f,1.05359999f,0.88719999f,-0.26909999f,0.63840000f,-0.25750001f,0.00240000f,0.53170000f,-0.08040000f,-0.05359999f,-0.70199999f,-1.16810001f,0.83300002f,-0.29790000f,0.48059999f,0.23550000f,0.09600000f,0.01460000f,-0.04200000f,-0.26379999f,0.32240001f,-0.29840000f,0.01360001f,-0.70669998f,-0.02869999f,-0.80519998f,-0.52220001f,0.53399998f,-0.01870000f,-0.01760000f,0.39010000f,0.04830001f,0.72069998f,0.18360000f,0.55040000f,-0.27960001f,-0.72729999f,-0.03370001f,0.15920000f,0.50949998f,-0.29120001f,0.69160000f,1.07560000f,-0.85709999f,0.17509997f,-0.09959999f,0.15539999f,0.47670001f,-0.45119999f,0.53580001f,0.01189997f,0.38039998f,-1.24970000f,-0.24469999f,-0.96390000f,-0.10480000f,-0.27100000f,-0.05730001f,-0.78680001f,0.29930001f,-1.11430003f,1.14900002f,-0.54850002f,0.72840000f,0.36619996f,1.13070005f,-0.01680003f,-0.92190002f,-1.00319997f,0.17050000f,0.81829996f,0.01770000f,0.03600001f,0.01950000f,-0.08630000f,-0.00560000f,0.31299999f,-0.29310000f,-0.10270000f,0.43170000f,0.51730001f,-0.51340000f,0.58709999f,-0.77269999f,-0.52410002f,0.22189999f,-0.27950001f,-0.16220000f,0.07579999f,-0.31120000f,-0.16040001f,-0.34050002f,1.21569999f,-0.02290003f,1.25420000f,-0.61599999f,0.76019998f,-0.78210002f,1.22630001f,-0.07190001f,-0.71999999f,-0.32450002f,0.34969999f,0.09300000f,-0.04980000f,0.05170000f,-0.09130000f,0.31920000f,-0.56250000f,0.11520000f,-0.23490000f,-0.31170002f,0.45660001f,-0.21599999f,-0.21179999f,-0.91739999f,-0.75170002f,-0.36120002f,-0.89860003f,-0.75719998f,-0.64920001f,-1.06930002f,-0.91050005f,0.17329999f,0.59490002f,-0.60120000f,0.33090000f,-0.50639999f,-0.29759998f,-0.55530002f,-0.24839999f,0.61830001f,0.16050000f,-0.13690002f,0.47430000f,0.28620000f,0.18840001f,0.16929999f,0.08930000f,0.78400000f,-0.18750000f,0.21509999f,0.14940000f,-0.71279999f,-0.60740001f,-0.35130002f,-0.50710000f,0.84179999f,-0.69840000f,0.78450003f,-0.50920000f,0.72700000f,-0.02120000f,1.22280004f,-0.23440000f,-0.46710000f,-1.38390000f,-1.24679999f,-1.28110000f,-0.29100001f,-0.58699999f,-0.81180003f,-1.08900002f,0.90390000f,-0.59039998f,-0.32229997f,0.51219999f,-0.23940001f,-0.03300000f,-0.08810000f,-0.07700000f,-0.66480001f,-0.36190000f,0.11940000f,0.01610000f,-0.21080000f,-0.28300001f,0.08290000f,-0.40020001f,-0.18330000f,0.50930000f,0.97509997f,0.18359998f,0.28859999f,-0.46460000f,0.55840001f,-0.46110002f,-0.81989999f,-0.97450002f,-0.16429999f,-0.77770002f,-0.00540000f,-0.30400000f,0.05160000f,-0.75160001f,0.21710001f,0.78749999f,-0.80029997f,-0.50500000f,-0.03360001f,0.20790001f,0.04110000f,0.17500000f,-0.03600000f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(true) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_8item_large_5o3i_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{8,3,16,16};
    Shape shape_b{5,3,2,2};
    Shape shape_r{8,5,30,30};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{2,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.19389997f,0.58139999f,0.37869999f,-0.64529996f,-1.08249999f,1.06530004f,0.54759999f,1.07730000f,-0.14599998f,0.74250002f,-0.05169998f,0.11339996f,1.09380000f,-0.78780002f,0.87830002f,-0.50280001f,0.73399999f,-0.53730004f,-0.26519999f,-1.30710004f,0.66540000f,0.30720000f,0.77910002f,-0.80880002f,-0.56449996f,0.92910002f,0.46260003f,0.96630004f,-0.11850005f,0.29190000f,0.35650002f,0.06610000f,0.55369998f,0.07370000f,-0.07900000f,0.20150001f,0.58300001f,-0.00329999f,0.07850001f,-0.05000001f,-0.41109998f,0.00980001f,0.97680000f,-0.15560000f,0.28400000f,-0.27010000f,-0.40309999f,0.16940000f,0.04230000f,-0.12040000f,-0.05090000f,0.10990001f,-0.88170001f,0.31580000f,0.29559999f,-0.02589999f,1.00749998f,0.53710001f,0.20950001f,0.21210001f,-0.95169992f,-0.09000000f,1.01949997f,-0.45060001f,-0.69219998f,-1.23600005f,-0.35659997f,-0.67260003f,-0.78449997f,0.74010001f,0.17510000f,-0.63570002f,1.01480001f,0.40529998f,0.93079996f,0.54090001f,-0.33849998f,-0.46800000f,-0.37229999f,0.51510001f,0.47729999f,-0.09000000f,-1.69950001f,-0.86850000f,-0.27040000f,-0.12780001f,1.73689997f,-0.93180003f,-0.26989999f,-0.80250000f,-0.95370000f,-0.09430000f,-0.06080000f,-0.11340001f,-0.61480001f,0.23330000f,-0.19919999f,-0.15570000f,0.99410001f,0.16729999f,0.53119998f,-0.11280000f,0.25699999f,-0.04310000f,-0.19069999f,0.44970000f,-0.38719999f,-0.02470000f,-0.51979997f,-0.24220001f,0.31880000f,0.21070001f,-0.76759999f,0.15199999f,-0.26740003f,0.10500000f,-0.05970000f,0.26640000f,0.87620000f,0.22290000f,-0.69150003f,0.29070001f,0.17720001f,1.26450006f,0.43599998f,-0.11820000f,-0.27999999f,-0.15000003f,1.53109999f,-0.34110000f,0.74439997f,0.47190000f,1.02019997f,0.63449999f,0.46189998f,-0.30840000f,-0.65759999f,0.78839999f,0.06139999f,0.31380002f,0.77160001f,-0.50250003f,-1.93520001f,0.52890005f,0.39179996f,0.55170000f,0.77009997f,-1.37040000f,0.09740005f,-0.17850002f,0.11910000f,-0.25640000f,0.16989999f,-0.29130000f,0.40110001f,0.10660000f,-1.14029999f,-0.09800000f,0.20100000f,-0.02740000f,0.41380000f,0.30619999f,-0.14749997f,-0.34660000f,-0.23819999f,0.06680000f,0.63529998f,-0.19610000f,0.16660000f,0.01270000f,0.28350001f,0.07820000f,0.03320000f,-0.18630000f,-0.17409999f,-0.01630000f,-0.18780000f,-0.38170000f,-0.01190000f,-0.18100000f,-0.04309999f,0.81780000f,1.16649996f,-0.29970003f,0.02370003f,0.28500003f,-1.68249997f,0.21000000f,0.56620000f,-0.22560001f,0.45420001f,-0.14160000f,-0.12889997f,0.90000000f,0.38939999f,-0.17820000f,1.05549998f,0.29970000f,0.51140000f,-0.43860003f,-0.04629999f,-0.63780002f,-0.72999998f,0.69450001f,0.41249999f,0.32070000f,0.06339999f,0.90449999f,0.79189995f,1.12290004f,-0.96969999f,-0.39750000f,0.63719998f,-0.31850000f,0.07090001f,-0.10310000f,-0.49159998f,-0.20950000f,-0.20490000f,0.31670001f,0.89319998f,0.14060001f,0.81429997f,-0.11710001f,-0.57660003f,0.06840000f,-0.04920000f,-0.20610000f,0.85080000f,-0.12870001f,-0.18780001f,-0.54070001f,0.39040000f,0.18510001f,0.49790000f,0.37640000f,-0.86400000f,-0.10850001f,-0.91490000f,0.25690000f,-1.19549999f,0.16530001f,1.00160000f,0.29609999f,0.18110002f,0.29189999f,-0.66239997f,0.22440001f,-0.32510000f,-1.31730003f,0.26159999f,-0.80910002f,0.61129998f,1.17990007f,0.38819996f,0.01350001f,0.00240000f,-0.17100000f,1.16760002f,0.95190005f,0.80899998f,0.52170001f,0.85480001f,-1.18020005f,-0.46229999f,-0.30569999f,-1.65800000f,0.78240003f,-0.80550001f,0.21570004f,-1.21119999f,-0.16580001f,-0.70559999f,-0.17440000f,-0.57959998f,-0.43760000f,-0.89399998f,0.23950001f,0.98729997f,-0.11460000f,-0.67579997f,0.34749999f,0.05689998f,-0.30190000f,0.34030000f,-0.18490000f,0.26970001f,-0.03600000f,0.92899998f,0.11160000f,0.73219999f,0.35759999f,-0.29999999f,0.23560000f,0.88789997f,0.01349999f,0.68109999f,0.32840000f,1.10640000f,-0.09160000f,-0.74040002f,0.57600001f,-0.75360001f,0.81930000f,-0.18320001f,1.40279999f,-0.28360004f,-1.47180002f,0.14030000f,0.17009999f,-1.19979996f,-0.60989998f,-0.33610001f,0.62640000f,1.17769999f,0.22199998f,0.61550000f,-0.57750001f,0.95059999f,-0.64500001f,0.64700001f,0.13320002f,0.01679998f,-1.18919999f,0.33570003f,-0.10410000f,1.18529998f,-1.26360003f,0.76080001f,0.85800000f,-0.86170000f,-0.22059999f,-0.70260000f,0.05529999f,0.84669999f,-0.03380000f,-0.77959999f,0.02349999f,-0.22029999f,0.19200001f,0.50650000f,0.22340000f,0.60540000f,0.02750000f,0.44520000f,0.35140000f,0.64329998f,0.09380000f,-0.28319999f,-0.03140001f,-0.70040000f,-0.41229999f,0.27500000f,0.28429999f,-0.02690000f,-0.22630000f,-0.17599999f,0.17800000f,-0.73090000f,-0.23149999f,-1.61510000f,1.01340001f,-0.20460003f,-0.29310000f,1.29089999f,0.44400001f,-0.92759999f,0.96480002f,0.93909998f,-0.98850005f,-0.17210000f,-0.77160002f,0.35540000f,-0.84720000f,-0.28359996f,-1.18500001f,0.00269999f,0.62730002f,0.43080000f,0.22410001f,-1.07680001f,0.72089998f,1.05579998f,-0.90449999f,-0.97869996f,0.41940001f,-0.01839998f,-0.12059998f,-1.37269998f,0.11189999f,0.83779998f,-0.04740000f,-0.03899999f,-0.29020000f,-0.38119999f,-0.01690000f,0.00039998f,-0.06930000f,-0.12430000f,-0.22870001f,-0.53579998f,-0.07829999f,0.80220000f,-0.33620001f,-0.53810000f,0.09169999f,0.71380001f,0.00170000f,0.37059999f,0.05619999f,-0.62949999f,0.43790000f,0.20159999f,0.19500001f,0.68450000f,-0.37430000f,0.00260000f,0.26340001f,0.12520000f,0.24330000f,0.68340000f,0.60719999f,0.71179997f,0.51329999f,-0.35759999f,0.52980000f,0.71559994f,0.29220001f,0.08550000f,0.93540003f,-0.00019998f,-0.66780003f,0.53220002f,0.78870003f,-0.33150000f,-1.19340001f,-0.17139993f,0.17580000f,0.96059998f,0.72690002f,-0.14250001f,-0.76530002f,-0.16840002f,-1.11150003f,0.00430001f,0.32280000f,0.02220000f,-0.95640003f,-0.78119999f,-0.23400000f,0.59649999f,0.33160000f,-0.51369999f,0.22390000f,-0.13270000f,-0.06400001f,-1.20819999f,-0.38290000f,-0.10629998f,0.08290001f,-0.02020000f,0.02370000f,-0.74859998f,0.07700000f,0.06069999f,-0.20899999f,-0.09529998f,-0.08020000f,-0.33599998f,-0.10370001f,-0.71520000f,-0.09030001f,-0.00610002f,-0.26830000f,0.87270000f,0.04070000f,0.54200000f,-0.13700000f,0.47039999f,-0.10800000f,1.00789998f,0.16890001f,-0.37590000f,-0.35399999f,-0.48930000f,0.56220002f,-1.62540000f,0.71250002f,0.34230005f,-0.59550002f,-0.76899999f,-0.16649998f,-1.64779994f,0.52679999f,0.93569994f,-0.09570002f,-0.55669997f,0.11459999f,-0.58159997f,1.39680005f,0.43679998f,0.87600003f,1.09849995f,-0.05430002f,1.30010001f,0.04440000f,1.15400000f,-0.25290001f,0.39960000f,0.47070001f,-0.78399998f,0.10600000f,0.74330000f,-0.15909999f,0.80379999f,-0.01510000f,0.61079999f,-0.29880000f,-0.71959999f,0.28020001f,0.37150000f,-0.06120000f,-0.57170000f,0.11460001f,1.12200000f,0.17620000f,-0.17909999f,0.06250000f,-0.26709999f,-0.03050000f,-0.34849999f,0.18210000f,-0.44720000f,-0.09990001f,-0.56420001f,-0.11150000f,-0.66930001f,-0.00280000f,0.20680000f,0.08920000f,-0.24200001f,-0.98130003f,0.19590002f,-0.04050002f,1.31179999f,-0.37800001f,0.63719999f,0.74849999f,-0.69440002f,-1.14660005f,-0.55030000f,0.66630002f,-0.24990001f,-1.06530003f,0.82000001f,-0.69750001f,-1.10969996f,0.52860000f,0.28909999f,0.52350000f,0.01809998f,-0.01709999f,-0.67720001f,1.29990006f,0.59819997f,0.31080001f,-0.98870002f,0.36210001f,0.89759998f,0.10950000f,0.91509998f,0.24030000f,-0.35670000f,0.21080001f,0.94599999f,-0.14230001f,0.35570000f,0.11140000f,-0.76910001f,0.21609999f,-0.77329997f,-0.34029999f,-0.03650000f,-0.21310000f,0.56750000f,-0.24499999f,0.15210003f,0.21730000f,0.32950000f,-0.27330000f,-0.49559998f,0.32150000f,0.01570000f,0.17059999f,-0.58519998f,0.01660000f,0.08560000f,-0.03450000f,0.93200000f,0.34070000f,0.83650000f,0.03630001f,-0.36170001f,-1.25940003f,0.32200001f,-0.84480001f,-0.64809995f,0.45090003f,-0.73090002f,-0.09749999f,-1.37869995f,0.54839997f,0.29849997f,0.26879999f,1.22249999f,-0.08310003f,-0.10329995f,-0.48990001f,0.20650001f,0.58349999f,-0.46159999f,-0.11969999f,0.23389998f,0.16290001f,-0.70719998f,0.02610000f,0.22040000f,-0.64050003f,0.87080001f,-0.53369998f,-0.00230000f,-0.04680000f,0.90159998f,0.34939999f,-0.05410000f,-0.14540000f,-0.45229999f,0.08300002f,0.12870000f,-0.48450000f,0.28770004f,0.24500001f,0.63759998f,-0.15670001f,0.26479999f,0.63330001f,-0.29279998f,-0.34889999f,-0.09429999f,-0.42689999f,-0.74619999f,-0.27419999f,0.32749999f,0.08560000f,-0.71939998f,-0.28730000f,-0.66169999f,0.17500000f,0.56930000f,0.10430000f,0.86910001f,-0.18420000f,1.43039999f,-0.81209998f,-0.82829996f,0.05399999f,-0.96489999f,-0.92820004f,-0.94269998f,0.65580000f,0.90710006f,-1.25760003f,-0.23120001f,0.63180002f,1.20639998f,-0.68010003f,-0.77959999f,0.48749999f,0.09270001f,1.19639998f,-0.27220003f,0.00360000f,0.32170000f,-0.17940003f,-1.53820000f,0.71759999f,-0.61230002f,-0.87480001f,0.08710003f,0.17640001f,0.33549998f,-0.00510000f,0.25389999f,-0.26519999f,0.16860002f,-0.12250000f,-0.51439998f,-0.10120000f,0.73310000f,-0.08060001f,-1.14439999f,-0.16490000f,1.18199997f,-0.36070000f,0.05960000f,-0.00330000f,-0.57459999f,0.26350001f,0.71590000f,0.08580000f,0.14060000f,-0.02009999f,0.11870000f,-0.14099999f,0.78379997f,0.17639999f,-0.91179999f,-0.05310000f,0.05760000f,-0.27050001f,0.80489995f,0.54990002f,1.24609998f,0.37499997f,0.54020000f,0.02339999f,-1.10079996f,-0.03750000f,1.24610000f,0.83970001f,-1.13680002f,0.14970003f,2.29839999f,0.77550001f,0.77519999f,-0.23250002f,-1.43460000f,-0.98040003f,0.32530002f,-0.53400002f,-0.37019999f,-0.62790003f,-0.66430001f,0.22170001f,1.65739996f,-0.02639998f,-1.59299997f,0.00570000f,0.05800000f,1.12530003f,0.27859999f,-0.03989999f,0.88069998f,0.09129999f,-0.40909998f,0.41180000f,0.75550000f,0.10470000f,0.95310001f,-0.15299999f,0.20790001f,0.06639999f,-0.37899999f,0.26230001f,0.30700000f,0.01340000f,0.42849999f,0.01419999f,0.38920001f,0.13259999f,-0.06660000f,-0.19420000f,0.85220001f,-0.12499999f,1.14309999f,-0.42820001f,-0.21600000f,-0.15940001f,0.86080000f,0.23930000f,0.80060000f,-0.74550001f,0.62010001f,0.27870000f,-0.29809999f,-1.13340000f,0.36010005f,-0.68220003f,1.01370002f,-0.63840003f,-0.65949996f,0.99480003f,0.72379998f,-0.42540001f,0.30419999f,-0.22470001f,0.53069999f,-0.95130001f,-0.55119995f,0.26430001f,0.39019998f,-0.18960002f,1.15820002f,0.00690000f,2.07130000f,0.89910003f,0.33720000f,0.21390001f,1.77400000f,-0.66570000f,0.70799999f,-0.06430000f,-0.62339999f,-0.12080001f,-0.38950001f,-0.14040000f,-0.10369999f,-0.36240000f,-0.03039999f,-0.16260000f,-0.57230000f,-0.03860000f,0.80359999f,0.00140001f,-0.54199999f,0.17450001f,1.04990001f,-0.14660000f,-0.02430000f,-0.34990000f,0.12190000f,-0.15640000f,-0.66839999f,0.23020000f,0.88279999f,0.03600000f,-0.45330002f,-0.18950001f,-0.70789997f,0.20390000f,1.01080000f,1.12680002f,0.28499997f,0.94740004f,0.42269998f,0.15089999f,-0.15229999f,0.30360000f,-0.05439997f,1.13610002f,0.28349996f,-0.28980000f,1.10440000f,-0.18870001f,-1.30559998f,-0.84540003f,1.05450002f,0.47309999f,0.44029998f,0.83429998f,0.98929996f,1.26510001f,0.28399996f,-0.99240000f,0.59240004f,0.43530002f,-0.22990003f,0.87990000f,-0.36409999f,0.03810001f,0.50200001f,-0.08029999f,0.87339997f,0.21720000f,0.94820000f,0.02710000f,1.10420000f,-0.06180000f,-0.51030001f,0.41150001f,0.80070001f,0.11210000f,0.59560000f,-0.03870000f,-0.11930000f,-0.15550000f,-0.35240000f,-0.00710000f,0.20270000f,-0.29619999f,-0.03840000f,-0.00829999f,0.91080000f,0.04800000f,-0.42930000f,-0.27330001f,-0.40960000f,0.03640000f,-0.95110002f,0.28309999f,-0.75200001f,-0.23420000f,0.58430000f,0.19819999f,-0.58190000f,-0.91610002f,1.11150002f,0.15729997f,1.13090000f,0.41359998f,0.75790004f,-0.32039998f,0.03179998f,0.03800000f,-0.90909998f,-0.51970000f,-0.56670000f,0.82470003f,-0.58170001f,-0.10109997f,-1.42370001f,-0.21480001f,0.25850002f,0.79360000f,-0.83510000f,0.11489997f,0.92030004f,-0.75990001f,1.06300000f,0.38880001f,-0.16249998f,-0.38570002f,0.37850000f,0.21040001f,-0.23200000f,0.15240000f,-0.03720000f,0.48309999f,-0.19510000f,-0.22889999f,-0.02669999f,-0.05580002f,0.49140001f,-0.08700000f,0.37139999f,0.45170001f,-0.08809999f,-0.07210000f,-0.15110000f,-0.07790000f,0.16070000f,0.27370001f,-0.69850002f,-0.25300000f,-0.11780001f,-0.37630003f,0.70750000f,-0.69310003f,-0.21410000f,-0.39550002f,-1.19599998f,-0.77329999f,-0.14859999f,0.68270000f,-0.44250000f,0.81130002f,-1.30230002f,1.09409999f,-0.68840001f,-0.61300000f,0.79049998f,-0.20440000f,-0.74979999f,-0.63219997f,0.36959998f,0.38149999f,0.57640002f,0.26820000f,-0.46830001f,-0.48540000f,0.51950000f,1.00530000f,0.01259998f,0.20480001f,-0.89300000f,-1.03689999f,-0.24199998f,-0.22550000f,-0.93540005f,-0.45789998f,-0.40790001f,0.03680000f,0.06760000f,-0.37020001f,0.02100000f,-0.36660000f,-0.20220000f,-0.03850001f,0.69370001f,-0.42519999f,0.26320000f,-0.22720001f,0.37480000f,-0.28190001f,0.09830000f,-0.64300000f,-0.42260000f,-0.26919999f,-0.09079999f,0.17400000f,0.36600001f,0.28640002f,-0.77240002f,-0.63120000f,-0.00600001f,-0.64590001f,0.15990000f,-0.05740001f,0.12940001f,0.19000003f,0.92849999f,-0.15310001f,0.29530001f,-1.08080003f,1.33940003f,-0.21850000f,-0.08470002f,-0.59469998f,-0.27000000f,-0.59989997f,-0.39429999f,-0.84099999f,0.44220000f,-0.73990000f,0.65979997f,-0.27450000f,-0.24430004f,-0.62889999f,0.85269996f,-0.25980002f,0.26860004f,1.28350002f,-0.41130005f,-1.03020000f,0.57220001f,-1.20719999f,0.56969997f,0.46639999f,-1.46699997f,1.12890002f,-0.03090000f,-0.09970001f,0.44530000f,0.72030001f,0.19770001f,0.13130000f,-0.75050000f,-0.03180000f,0.23340001f,0.01900000f,0.22580001f,-0.55230001f,-0.17489999f,0.27260000f,0.17380000f,-0.36310002f,0.40630000f,0.15460000f,0.24500001f,0.15530000f,0.04630001f,0.28360001f,-0.21880000f,0.00910000f,0.13850000f,-0.10700000f,-0.01900000f,0.23330001f,0.34629999f,0.00330000f,-0.31489999f,-0.91039999f,0.79350000f,0.86070000f,-0.36299998f,0.69619996f,0.41989999f,-0.34760000f,0.18460001f,-0.07020000f,-0.27519999f,-0.46220001f,-0.11010003f,-0.24540001f,0.91680000f,-0.72800000f,-0.24669998f,-0.16930001f,0.27370002f,0.36050001f,-0.47380001f,0.85100001f,-0.64380001f,-0.44310000f,0.71080000f,-0.26869999f,0.34389999f,-0.45009998f,0.89440000f,-0.37720002f,-0.48750001f,0.49359999f,0.55400001f,0.50410000f,0.17630001f,0.28680000f,-0.25439999f,0.44290002f,-0.06130000f,-0.22880002f,0.16039999f,-0.15190001f,0.29949999f,-0.31660000f,0.01779999f,-0.14940001f,-0.03420000f,0.17579999f,0.58020002f,-0.32060001f,0.22340000f,0.69720001f,0.50880001f,0.19450000f,-0.07930001f,-0.21379999f,-0.77620002f,0.14850002f,-0.38610001f,-0.72760001f,0.72310000f,0.04009998f,0.07490006f,0.32749999f,0.27400001f,0.44369998f,0.34369998f,0.49750001f,0.23800002f,0.20070002f,-1.41250001f,-0.06999998f,-0.89989999f,-0.97110002f,1.24950003f,-0.16140001f,0.02280000f,-0.21750000f,-0.27809996f,-1.05070002f,0.97550003f,0.16329999f,0.45450006f,0.87450002f,-1.23740002f,0.57220000f,-0.19280003f,0.15570000f,0.88580000f,-0.99670000f,-0.34680000f,0.33400004f,-0.30520000f,0.10060001f,-0.11860000f,0.45560003f,-0.12440001f,0.02629998f,0.17529999f,0.50640001f,-0.43799999f,-0.40109999f,-0.20010001f,0.06649999f,0.50230001f,0.13230000f,0.29250001f,0.03559999f,0.47920000f,-0.16420001f,0.30100001f,-0.80639999f,-0.18720000f,-0.12850002f,0.20770000f,-0.31570000f,0.47050000f,-0.41200000f,0.34000001f,-0.05449999f,1.57989999f,0.41220002f,0.65099999f,-0.15979999f,0.88239998f,0.00800003f,1.49239997f,0.57770000f,-1.58319998f,0.93799998f,0.24039998f,-0.02889998f,-0.60359999f,-0.66370000f,0.57880002f,-0.20229999f,0.18440000f,-0.10779999f,-0.68819997f,-0.16480000f,-0.72659999f,-0.89759998f,0.18719997f,0.22199998f,-1.28689996f,-0.76169998f,-0.17979999f,-0.21239997f,-1.38120001f,-0.28759999f,-0.68910002f,0.12860000f,-0.13580001f,-0.35970000f,0.52170001f,0.15600000f,-0.41520000f,-0.68090001f,0.19850001f,0.02590000f,-0.00070001f,-0.26940000f,0.15420000f,0.34739999f,0.01260001f,-0.28109999f,0.02189999f,-0.55780002f,0.02140001f,0.27700003f,-0.43900001f,0.29539999f,0.49300000f,0.02270000f,-0.37190000f,0.31820000f,0.03460001f,0.05230000f,-0.59950001f,0.08699999f,0.00319998f,-0.20220001f,1.08959999f,-0.77189998f,-0.38679998f,0.35219998f,0.53299998f,-1.48190000f,1.00039998f,0.50380003f,-1.04430003f,-0.10419997f,-0.83440001f,0.82369998f,-0.90369997f,0.19620003f,-1.24930000f,-1.01040003f,0.67019999f,0.62840002f,0.30219999f,-0.41630000f,0.67550001f,0.79069999f,-0.89539999f,0.16429998f,0.43090002f,0.65679998f,-0.03130001f,-0.47430000f,0.27640000f,-0.33140001f,0.20180000f,0.50980001f,-0.08140000f,-0.36660000f,0.20099999f,0.00910000f,0.01970000f,0.11920001f,-0.03999999f,0.27479999f,0.35160001f,0.49290003f,-0.09330000f,0.31520001f,0.08080002f,-0.33680001f,0.34400000f,-0.35889999f,-0.19910000f,-0.57720000f,-0.15360001f,0.01830000f,0.08610000f,0.65480002f,0.13720000f,0.03200000f,-0.27680001f,-0.41040002f,-0.99079999f,-0.88059999f,0.61519998f,0.46079999f,0.54500000f,-0.88669997f,0.53429999f,-0.14550000f,0.30520001f,-0.26210002f,0.99190001f,0.34590001f,-0.76769999f,0.31920000f,0.83810003f,0.88789999f,-1.27969997f,-0.80850000f,0.13670000f,-0.61440000f,0.80709998f,-0.21489998f,-0.77170003f,0.47560002f,-1.18810000f,0.53670000f,0.30550003f,0.74220001f,-0.96580002f,-0.31450001f,0.39910000f,-0.65710001f,-0.33290000f,-0.19810000f,-0.24110000f,0.36660004f,-0.69060001f,0.43409999f,0.20310002f,0.26820001f,-0.24300001f,0.46980000f,-0.62459999f,-0.62330000f,0.24169999f,0.62930000f,-0.10009999f,0.28480000f,-0.20559999f,-0.44180001f,-0.00460000f,-0.45189999f,0.32950000f,0.22469999f,0.64290001f,-0.42140002f,0.42140001f,0.27460000f,0.26180000f,0.07170000f,-0.19010000f,-0.59940001f,0.24549997f,0.13770000f,-0.33080001f,0.80280001f,0.69819998f,0.01829995f,0.71080003f,0.83330001f,-0.59490002f,1.21929996f,-0.08409999f,-1.24019996f,0.52969997f,0.91599999f,-0.09750000f,0.48219998f,0.14859999f,-1.20990003f,1.48470001f,-1.27209998f,0.88080001f,-0.26830000f,-0.16599998f,-0.91990001f,-0.01289999f,0.22800001f,-0.31499998f,-0.08100002f,-0.09260000f,0.10190000f,0.18250001f,-0.01300002f,0.59260000f,0.00139999f,0.31540000f,0.53020003f,-0.24580001f,0.00629999f,-0.16470001f,-0.05950000f,-0.17450000f,-0.05620001f,0.43420001f,0.20590000f,-0.40390000f,-0.41490000f,-0.00270000f,-0.14290000f,-0.06230000f,-0.18840000f,-0.34800001f,-0.45700000f,0.07180000f,0.38730002f,-0.38010002f,-0.38180001f,0.29180000f,-0.49180001f,1.34659998f,0.43140001f,-1.06790000f,-0.52510000f,-0.13849999f,-0.09929999f,-0.45029998f,0.52060002f,0.81959998f,0.70100002f,-1.18430003f,-0.23580001f,0.73309999f,0.05080001f,-1.19419999f,0.94799998f,-0.67530001f,-0.76449999f,0.56699997f,-0.37129999f,0.56579998f,0.08450000f,0.04209998f,-1.25070002f,1.37030003f,0.67150001f,0.38200000f,-0.90660000f,0.34280000f,-0.93739998f,0.35350000f,-0.41830000f,-0.26210000f,-0.04560002f,0.22560000f,0.80350003f,-0.04749999f,-0.20570000f,-0.40990001f,-0.03489999f,-0.62389999f,0.42010001f,0.19189999f,0.00569999f,0.53430001f,0.57470000f,0.09130002f,-0.32410002f,0.05410000f,0.47600001f,-0.14120000f,-0.69310001f,-0.04490000f,-0.22539999f,-0.38299999f,-0.10580001f,0.07340000f,0.07880000f,0.45760001f,-0.47560002f,-0.95579999f,-0.30290000f,0.08919998f,0.34240000f,-1.36559999f,1.44230000f,-0.90059996f,-0.10480001f,0.54669999f,0.55929998f,-0.00120002f,0.08910003f,0.53959999f,-0.59729999f,0.19720001f,0.67159998f,-0.11410001f,-0.21710001f,-0.51960001f,0.43869999f,0.62949999f,-0.76330000f,-0.10520002f,-0.01600000f,0.23859997f,-0.20920001f,0.01780000f,-0.00489998f,-0.75209999f,-0.22410004f,0.35710001f,-0.22600002f,0.60760000f,-0.19110000f,-0.35970000f,0.55090002f,-0.31330000f,0.44429998f,-0.25710001f,0.51309999f,0.48050004f,0.03479999f,-0.00600001f,-0.24820000f,0.44260000f,-0.85120001f,-0.49880000f,0.51849999f,0.12590001f,0.50960001f,-0.09200001f,0.48509999f,0.25650000f,0.31460002f,-0.60980001f,0.49530003f,-0.21450001f,-0.05390001f,0.08990001f,0.05480001f,0.90830004f,-0.73440001f,-0.28839997f,0.47039998f,-0.79549999f,0.93740000f,0.09670000f,1.22299999f,-0.94750002f,-0.10390004f,0.60440003f,0.64780001f,-1.32780000f,-1.00370000f,0.60050003f,-0.28789999f,-0.62030008f,0.29909998f,0.48400001f,0.14450001f,1.26809998f,0.37179999f,-0.04749997f,1.01960002f,-0.09700005f,0.46410003f,0.78259998f,0.26979999f,-0.93729999f,0.48209998f,0.29089999f,-0.54570001f,0.39810001f,0.26260000f,0.27740001f,0.55220000f,-0.37219999f,-0.11750001f,0.53870001f,0.15940004f,-0.53740001f,-0.34680004f,0.94800001f,0.24359999f,0.35040000f,0.49300003f,-0.51820001f,-0.26470002f,0.15670000f,0.12820000f,-0.09940000f,0.46790001f,-0.14750001f,-0.24760003f,0.67600000f,0.08020002f,-0.69940000f,0.09320000f,0.04720000f,0.13500002f,0.07010001f,-1.29430001f,0.52720001f,-0.09999999f,0.34579998f,1.00609997f,0.07389999f,-0.60820000f,-0.12449998f,0.27680002f,0.97059998f,-1.34690003f,0.01150006f,-0.37950001f,0.75730002f,1.18470002f,-0.17150002f,-0.00110000f,-1.05540002f,0.50220001f,-0.55040001f,1.01150003f,-0.64860001f,-1.01560000f,0.12960003f,0.73559998f,0.08379999f,0.07090000f,-0.00349999f,-0.32210001f,0.26620001f,0.19989999f,0.37970000f,-0.21669999f,-0.20449999f,-0.52650003f,0.12330001f,-0.23670001f,0.45270002f,0.74950000f,-0.07989999f,-0.72300001f,0.08940001f,-0.47040002f,0.06000000f,-0.08810000f,0.23570000f,0.48940002f,-0.06819999f,-0.48799999f,0.04520000f,0.16059999f,0.57380002f,-0.31270004f,0.86350002f,0.45860003f,0.19300001f,-0.23820000f,0.73140002f,-0.13460000f,0.12900001f,0.26490000f,-0.85279997f,-0.21949999f,0.33179997f,-0.22340003f,-1.20629999f,-0.37229998f,-0.78900001f,1.30579998f,-0.67629999f,-1.45120002f,1.05059999f,-0.43470000f,-0.44950002f,-0.21239999f,-0.27369999f,1.12160000f,-1.00339998f,-0.77199998f,0.28159998f,-0.22180000f,-0.29639998f,-1.16120002f,-0.12629997f,-0.03120000f,0.90900004f,-1.04960000f,0.11220003f,0.29649999f,0.47420001f,-0.37840000f,-0.03920001f,-0.22870000f,0.07030000f,0.27850000f,-0.01570000f,0.65840000f,0.10480001f,-0.17530000f,0.00609999f,-0.11240000f,0.49400001f,0.43060001f,-0.47740001f,-0.33150003f,0.46110001f,0.00350000f,0.16570000f,0.13910000f,0.41890000f,-0.23820000f,-0.01740001f,-0.26400002f,0.27840001f,-0.17990000f,-0.17650001f,0.15890002f,-0.19129999f,-0.53960001f,-0.24619997f,-0.97170000f,1.20389998f,-0.79800001f,0.99370002f,0.28780000f,0.15630000f,0.57919998f,0.29040003f,-0.76440000f,1.20229999f,-0.44179999f,-0.38379998f,1.05000000f,-0.13060002f,-0.41970001f,-0.96080001f,-0.36879999f,0.47269999f,-0.59829998f,0.81039999f,-0.88299999f,1.34359998f,-0.10300002f,-1.08779998f,-0.27340000f,0.49190000f,-0.05150000f,0.95699997f,-0.71650001f,0.52460001f,-0.28660002f,0.66459999f,-0.45700003f,0.42100001f,-0.34860003f,0.67620002f,0.21290001f,-0.27770001f,-0.51390003f,0.13950001f,-0.07460000f,0.18980000f,0.13450001f,-0.07690000f,0.40260001f,-0.17940000f,0.34790000f,-0.06350000f,0.60580000f,0.04580000f,0.22579999f,0.34300001f,0.16570000f,-0.34930001f,0.42900003f,-0.07620000f,-0.03469999f,-0.49090002f,-0.28130001f,-0.39149999f,-0.55200000f,-0.08939999f,0.97769999f,0.17669999f,-0.74070003f,-0.44699999f,-0.82470001f,0.35879999f,-0.71610003f,0.43230000f,-0.52139999f,-0.37139999f,0.14520000f,-0.30120001f,0.22200001f,-0.56790001f,0.22230001f,0.45360001f,0.71370003f,-0.46440000f,-0.55260001f,-0.20700001f,0.59940000f,0.42779999f,-1.00530004f,0.19259999f,-0.38430000f,-0.25199998f,-0.26550000f,1.01910002f,-0.64539999f,-0.04320000f,0.72000000f,0.46260001f,1.07780001f,1.07320005f,1.18239999f,0.63420004f,-0.78049999f,-0.62230001f,0.06530000f,0.37950001f,-0.62809996f,-0.47469999f,0.22209999f,-0.44670002f,0.33879999f,0.45680001f,-0.55949999f,-0.49690001f,0.84139999f,0.31120002f,0.38050000f,0.79470002f,-0.81799999f,-0.12420000f,-0.04560001f,0.89340005f,-0.16449999f,0.99299998f,-0.14339999f,-0.68969999f,0.43140000f,0.45750000f,0.81720002f,0.30989999f,0.48600002f,0.68669998f,-0.41850000f,-0.25949999f,0.05430000f,-0.44610001f,-0.53909998f,-0.47729998f,-0.39930002f,0.41880000f,0.44700000f,0.13439999f,-0.45030000f,-0.28049999f,0.53940002f,0.91770001f,0.73110001f,-0.01050000f,-0.37679999f,-0.99150000f,0.95280004f,-0.29730002f,0.32370002f,-0.55600002f,-0.20330001f,-0.27450002f,-1.35090003f,-1.08670007f,-0.23080001f,0.18060001f,-0.38499997f,-0.10879999f,-0.44269998f,0.21370000f,-0.84669998f,-0.52970001f,-0.85029999f,-0.57310000f,-0.29020001f,0.42720002f,-0.82219998f,-0.64080000f,-0.24460001f,-0.40060003f,1.19430001f,0.69150005f,-1.13170001f,-0.43750004f,-1.27169999f,-0.51390001f,0.81199998f,1.13680001f,0.93550001f,0.15600002f,-0.25530001f,-0.06540000f,-0.77190003f,-0.48870000f,0.32340000f,-0.11490001f,-0.43139999f,-0.67950000f,0.12330000f,-0.58559998f,-0.55290000f,-0.61109999f,-0.43289998f,-0.41339999f,0.68760001f,-0.12510001f,-0.39119999f,-0.23909999f,-0.53580002f,-0.23280001f,0.86910003f,1.04640001f,-0.19830001f,-0.60809999f,-0.33929999f,-0.78209999f,0.82679999f,-0.01800002f,0.78030002f,0.27750000f,-0.98099998f,-0.85500002f,0.95550001f,0.17190001f,0.43859995f,0.00979999f,-0.33559999f,-0.26040001f,0.03720001f,0.11600001f,-0.45640002f,0.19600000f,-0.41479999f,-0.84160001f,-0.57380000f,0.02260000f,-0.18070000f,-0.34630002f,0.46680001f,0.35780003f,0.93180000f,0.61740003f,-0.56629999f,-0.64590002f,-0.34289999f,-0.26690000f,-0.57589996f,-0.90390001f,-0.67570002f,-0.06330001f,-0.86879999f,-0.60599998f,-0.12510000f,0.47700000f,0.36359999f,0.79979998f,-0.31440001f,-0.27480000f,-0.03000000f,-0.17340000f,0.36180000f,-0.30120002f,-0.80040000f,-0.02940000f,-0.11160000f,-0.68640000f,-0.42750001f,-0.13260000f,0.21960001f,0.14190000f,0.52860001f,0.53040000f,-0.57330001f,-0.20339999f,-0.17370000f,-0.11219999f,-0.92849999f,-0.22919997f,-0.61530001f,-0.37480002f,0.12609999f,-0.34550003f,0.28850000f,-0.32830001f,0.30429999f,-0.17090000f,0.41700001f,-0.18320001f,0.54750000f,1.08470005f,0.19390001f,0.59730003f,-1.22450002f,-1.01410007f,-0.16830001f,0.00390000f,-0.03840000f,-0.05700001f,-1.20050002f,-0.88850006f,0.15050000f,-0.64190004f,1.11640001f,1.03860006f,0.45329998f,0.53590001f,-0.12380000f,-0.54440003f,-1.02510001f,0.76620000f,-0.65910002f,-0.11520000f,-0.45450001f,0.24000000f,-0.06450000f,0.46139999f,-0.20700001f,0.42150001f,0.80790003f,-0.20400001f,0.34230002f,-0.32729999f,-0.72570003f,-0.42899999f,0.05310000f,-0.09990000f,-0.37980001f,-0.38070001f,-0.73290003f,-0.60300000f,-0.90990003f,0.06600000f,0.80280003f,0.38069999f,0.85950001f,0.58890000f,-0.25620002f,0.41010001f,0.03690000f,-1.13950003f,0.19400002f,-0.39920001f,-0.37889998f,-0.66710001f,-0.35639995f,-1.17640001f,0.95519999f,1.20620004f,0.77309998f,-0.00829999f,0.07210000f,0.60410000f,-0.68179999f,-0.71400002f,-0.18339998f,-0.29520000f,0.14270000f,0.33130001f,0.06260000f,0.45580001f,-0.94919998f,-0.03000000f,0.54839996f,0.95560000f,-0.60969998f,-0.06450000f,0.17320003f,0.98120004f,-0.53399999f,0.51780003f,-0.22560001f,0.51900002f,-0.47790000f,0.10830001f,-0.94679999f,0.35880004f,0.83880002f,0.02309999f,0.10770000f,0.84329998f,0.65789999f,-0.09119999f,-0.82500001f,-0.49290000f,-0.40740000f,-0.18870000f,0.00330000f,-0.36090000f,0.23460000f,-0.35820001f,0.24840000f,-0.54359999f,0.66179999f,-0.17580003f,-0.22230000f,-0.71459998f,0.67560001f,-0.54240000f,-0.39419999f,0.31970001f,-0.47060000f,-0.82900002f,-0.56269998f,0.08170000f,0.14199998f,-0.24320001f,-1.62939999f,-0.88200003f,0.72730002f,0.85070006f,0.11840002f,0.61800003f,1.00819997f,0.71640001f,0.47980002f,1.01980003f,-1.12970002f,-0.53350002f,0.45830002f,-0.04870000f,-0.46549998f,-0.79790001f,0.90189997f,0.90630001f,0.06759998f,-0.38100002f,0.53179996f,0.30900000f,-0.35329999f,0.79740000f,-0.60059999f,0.12720001f,-0.12570001f,-0.78059999f,-0.00960000f,0.48299999f,-0.63660001f,-0.89669999f,0.65370003f,0.13590000f,0.45840001f,-0.29579999f,0.47279999f,0.38909998f,0.84000001f,-0.13259999f,-0.30270001f,-0.58110001f,0.12690000f,0.63690002f,-0.93510000f,-0.29399999f,0.88769999f,0.47819998f,-0.38220002f,0.19829999f,0.53520000f,0.63239999f,-0.55769999f,0.69370002f,-0.95719998f,-0.58400000f,0.30750000f,-0.42670000f,-0.94479996f,-0.51620000f,-0.20720000f,-0.25860001f,-0.48840001f,-0.79460004f,0.57720001f,0.44700003f,0.10090001f,-0.65930004f,1.16919998f,0.99180001f,-0.75120000f,-0.26140001f,-0.81810000f,-0.54830002f,-0.06129999f,0.72630004f,0.74910001f,0.92690004f,0.47700001f,-0.34160001f,0.88880000f,0.91800004f,-0.27180002f,-0.53310001f,-0.48359999f,-0.55259999f,-0.39990000f,0.46650000f,-0.42299999f,-0.57389997f,-0.21240001f,-0.04410000f,-0.62100003f,0.03630000f,0.10620001f,-0.01890001f,-0.57030003f,0.43170002f,0.65819998f,0.33509997f,-0.30540000f,-0.64410000f,-0.24450001f,-0.20729999f,0.76710002f,-0.27240000f,0.66990001f,0.06029999f,-0.47760001f,0.40650001f,0.84600002f,0.40139999f,0.32640001f,-0.02339999f,-0.70050002f,-0.01430000f,0.16379999f,0.39280001f,0.48980001f,-0.25540001f,-0.10630003f,-0.69430004f,0.89890001f,0.58970003f,1.08509995f,0.34669999f,-1.27919996f,-0.52119999f,0.89249999f,0.10110001f,0.39539998f,-0.03500000f,-1.51420002f,-1.19000006f,-1.37379998f,-0.85640004f,-0.10149998f,-0.18030000f,-0.81060000f,-0.17280001f,0.34250001f,0.12070000f,-0.20550001f,-0.61619999f,0.30270001f,-0.27750001f,0.47100000f,0.09690000f,0.07619999f,0.91740002f,-0.73650003f,0.10559998f,0.52290002f,0.53520000f,0.48629998f,1.02779997f,-0.39179998f,-0.83759997f,-0.00750000f,0.65849999f,0.01620000f,0.43319998f,-0.82320002f,-0.54210000f,-0.73380001f,-0.81089997f,-0.51810000f,-0.41100000f,-0.25800000f,-0.77730001f,-0.10050000f,0.01950000f,-0.28350001f,-1.07330001f,0.69690001f,0.77950003f,-0.36649999f,-0.16889999f,0.06580000f,0.21680000f,0.27190003f,-0.57310000f,0.91980001f,1.04380006f,-0.42910001f,-0.51210002f,0.40370001f,0.76910003f,0.99829997f,0.73450002f,-0.87199998f,-0.44380001f,-0.50129999f,-0.42570001f,0.00689999f,0.13930000f,-1.51330002f,-1.13250007f,0.49300001f,-0.14640001f,-0.90330000f,-0.40270001f,-0.86909998f,0.35670000f,0.48810001f,0.02669999f,-0.43169999f,-0.57300000f,0.00600000f,-0.25710000f,-0.43350000f,0.61470003f,0.89160003f,0.29339999f,-0.29430001f,0.03870000f,0.38550001f,-0.34290001f,0.73110000f,0.64589998f,-0.25200000f,-0.42149999f,-0.26670000f,-0.12539999f,0.32730000f,0.16920000f,-0.81450003f,-0.61739999f,-0.00300000f,0.66750002f,-0.37830000f,-0.65490000f,-0.19649999f,0.62640002f,-0.36370000f,0.06950000f,0.68660000f,1.00780004f,1.59660000f,0.72360000f,-0.30370001f,-0.24190001f,0.42569997f,0.29970000f,-0.00059996f,-0.54879999f,-0.52419998f,-0.41560001f,0.69510000f,0.02570002f,-0.08190001f,0.41130002f,0.25550001f,-0.46570000f,-0.72530000f,0.13590001f,-0.14210000f,-0.00270000f,-0.19330000f,-0.04510000f,0.25310002f,0.39190002f,-0.11930005f,-0.56910002f,0.27930000f,-0.12060000f,0.67500002f,-0.11220001f,0.40979997f,0.84630000f,0.06750000f,0.15990001f,0.55949999f,0.57659998f,-0.61499998f,0.12270003f,-0.59700000f,-0.53609999f,-0.15210000f,0.42629998f,0.36150001f,-0.28020001f,-0.39210000f,0.48600000f,0.27930001f,-0.55140000f,0.24329999f,0.14970000f,-0.04950000f,-0.16590000f,0.05190000f,-0.29520000f,0.56669998f,-0.91620005f,-0.53260000f,-0.04500001f,0.57049997f,0.82790000f,0.82880000f,0.04760001f,1.35499999f,0.87660005f,-0.14840002f,-0.74300003f,0.93080000f,1.08400004f,-1.02799999f,-0.69020003f,-0.23170000f,0.77870005f,0.20349999f,-0.47610001f,-0.16659997f,-1.01120000f,0.41999999f,-0.10360001f,0.89700002f,0.35660004f,0.23140004f,-0.55640000f,0.49279998f,0.72360002f,0.29979997f,-0.32940000f,-0.29700000f,-0.75780000f,0.86729998f,0.26849998f,0.07740000f,0.77640000f,0.71400003f,0.74099998f,-0.93360003f,-0.08370003f,0.83520002f,0.17940000f,-0.70740002f,-0.71249999f,1.04430004f,-0.19260001f,-0.54630000f,0.27899999f,-0.84719999f,0.39870002f,-0.31740000f,0.18000000f,0.52020002f,0.87900001f,-0.42900000f,0.55770003f,0.52620000f,-0.03360002f,0.30479999f,-0.18400000f,-1.30170000f,-0.59690003f,-0.12379997f,-0.42499999f,0.88959998f,0.09420000f,-0.46049999f,-0.15030001f,-0.05409998f,-0.54190001f,-1.13150003f,-0.44670004f,-0.47530000f,-0.79450003f,1.09150001f,0.36630002f,0.26940000f,0.79680004f,0.59440000f,0.49080002f,1.10210002f,0.57970004f,-0.88810000f,-0.41750002f,0.56319997f,0.26159999f,0.07850000f,-0.02350000f,-0.59510000f,-0.53879997f,-0.54750001f,-0.92160000f,-0.52859999f,-0.07740000f,0.14340000f,0.83729998f,-0.36690001f,-0.61350000f,-0.17910001f,0.55770003f,-0.75630002f,-1.22700001f,-0.84810001f,-0.20940000f,0.44190001f,0.95400001f,0.59460002f,-0.27030002f,0.40320001f,0.26820000f,0.42270002f,0.62280001f,-0.61590000f,-0.88829999f,0.54359999f,0.74159999f,-0.06270000f,0.03600000f,-0.74190003f,-0.21680002f,0.52330000f,0.50610001f,-0.32729999f,-0.16410000f,0.08179995f,0.94660001f,-0.09599998f,0.43740003f,1.40679999f,0.55840002f,-1.63160001f,-0.86920004f,-0.30800000f,0.35740002f,-0.09929999f,0.11450000f,1.30490000f,0.83030001f,-0.80509998f,-0.23090001f,-0.03959999f,-0.03840000f,-0.93570001f,-0.29550001f,-0.20149999f,-0.85210005f,-0.90669999f,-0.43010003f,0.41069998f,-0.59400000f,0.15390000f,-0.10260001f,0.02490000f,-0.02640000f,0.78479999f,-0.45060004f,0.15840001f,-0.56250001f,0.31020000f,0.80639998f,-0.56160001f,-0.83280000f,0.34860002f,-0.42150001f,-0.01290000f,-0.27690000f,0.57149998f,0.60269999f,-0.09570000f,-0.50129999f,-0.35880000f,-0.38580001f,-0.60330000f,-1.10010002f,-0.85890003f,0.11550002f,-0.65610002f,-0.93210000f,0.60390000f,-0.02630001f,-1.22540000f,-0.94720002f,-0.98820001f,-0.83420005f,0.24070000f,-0.13150000f,0.51559999f,-0.31400002f,-1.01529999f,-0.97590003f,-0.24819999f,0.08220000f,0.95909999f,0.31610002f,-0.10120000f,0.57740003f,-0.43469998f,-0.46450000f,-0.68689996f,-0.86610000f,-1.16709998f,-1.07730002f,0.20079998f,0.76520001f,-0.41090001f,-0.30950001f,-0.30449999f,-0.69570001f,-0.69990001f,-0.41190000f,-0.63120000f,-0.42269999f,-0.63240002f,-0.37559999f,-0.15450000f,0.24210000f,-0.44040002f,0.44279999f,-0.72090000f,-0.28889998f,-0.16500001f,-0.53760000f,0.39570001f,0.85529999f,0.28320002f,-0.63510002f,-0.44549999f,-0.20909999f,-0.91589999f,-0.37319998f,-0.77369999f,-0.33629998f,0.50759999f,-0.38460002f,-0.11010000f,-0.03869999f,-0.47550001f,0.22200000f,0.07770000f,-0.49869999f,-0.78569996f,-0.23849999f,-0.29740002f,0.50860001f,-0.57470000f,0.11810000f,0.24440000f,-0.14320001f,0.11959999f,0.98100005f,0.25860001f,0.51200002f,0.19120000f,-0.00220000f,0.45440001f,-0.12860000f,0.86309999f,0.50470001f,0.58410000f,-0.17690000f,0.68640002f,0.65060004f,0.47229998f,0.17530000f,0.15600002f,-0.48820002f,-0.14320001f,-0.33840002f,0.37740000f,0.76410000f,-0.22289999f,-0.44830000f,-0.12000003f,0.30189999f,-0.41640002f,-0.85460002f,-0.98699996f,-1.09539999f,-0.69959999f,-0.74690003f,0.57960003f,0.22180002f,1.13730001f,1.02730000f,0.90869998f,0.71880000f,0.16020003f,0.42660001f,1.46159999f,1.47240002f,0.22590001f,-0.06270001f,0.21630002f,0.60250001f,-0.51299998f,-0.76920002f,-0.73890004f,-0.95970002f,-0.42839999f,-0.18459999f,0.21050001f,0.44559999f,-0.51920001f,-0.17060000f,-1.13880004f,0.14940000f,-0.94710002f,-0.19039999f,0.81090000f,-0.08279999f,-0.54380000f,0.52740000f,0.35219998f,0.24899999f,0.05590001f,-0.32020000f,-0.29590000f,-0.00940000f,0.46550001f,0.05800000f,-0.21050000f,-0.62960001f,-0.46820001f,0.15139999f,0.12190001f,0.71119999f,-0.11650001f,0.23240001f,-0.36489999f,0.79270000f,0.77339997f,0.40729999f,-0.13169999f,0.21820000f,0.68070003f,1.07980002f,-0.06659996f,0.39810002f,-0.40979999f,-0.65529998f,1.12830000f,0.92500000f,0.29669999f,-0.10419999f,-0.69329998f,-0.63530001f,0.12870000f,0.33910000f,-0.07380001f,-0.34910000f,-1.04940000f,-0.43930000f,0.52349998f,0.76060000f,1.25339997f,0.66309999f,0.64200001f,0.83150005f,1.26149995f,-0.42220000f,0.19480001f,-0.01240000f,1.35700006f,-0.09540000f,0.25780000f,-0.01739999f,-0.19270002f,0.59240000f,0.05760000f,0.41359999f,0.53000001f,0.28580000f,0.75270000f,0.05380001f,0.37980000f,-0.06579999f,0.89559999f,-0.12939999f,0.04760002f,0.17520000f,-0.54760004f,-0.61600000f,0.99080004f,0.10619999f,0.99750001f,0.23880000f,-1.08820000f,0.37640000f,-0.17760003f,-0.99290000f,-0.11280000f,-0.22700001f,-0.61710003f,-1.07820003f,-0.02910000f,0.03640002f,1.08600000f,0.61410001f,0.79499996f,0.56619999f,0.32549998f,-0.13800000f,-0.14070000f,-0.46449998f,-0.08010000f,0.11040003f,-0.51149998f,-0.73579997f,0.22320000f,-0.07040002f,-0.88979998f,-0.11379997f,-0.04950005f,-0.37640002f,0.17459998f,-0.28229998f,1.10220000f,1.35299999f,-1.24199998f,0.08040000f,0.68930001f,0.23539999f,-0.91110002f,-0.02580000f,0.22950002f,-0.69339999f,0.16460000f,0.15720000f,-0.23500001f,0.21520000f,0.39870000f,0.07020002f,0.46820000f,-0.11920000f,0.11430001f,0.47659999f,0.07140001f,0.08800000f,-0.50250003f,0.06680000f,-0.73880002f,-0.14960000f,0.53850001f,-0.02180000f,0.35940000f,-0.03920000f,0.48069999f,0.03019999f,0.94030004f,0.28490000f,0.13709998f,-0.42970000f,0.12510003f,0.28050000f,-1.29809998f,-0.79269999f,0.20460000f,-0.02860000f,0.45360000f,0.35620000f,0.11370002f,0.10930003f,-0.47519998f,-0.75499999f,0.85889997f,0.50289999f,0.07260000f,-0.13600001f,0.27600002f,0.40550002f,-0.02639998f,0.38560001f,-0.26370000f,-0.54390000f,-0.18420000f,-0.28759999f,-0.21810000f,-0.63530000f,-0.97500002f,-0.64259999f,-0.38439998f,0.24639999f,-0.23010001f,-0.08180000f,0.02319999f,-0.35159999f,-0.19890001f,-0.23720001f,-0.89800001f,0.44799999f,-0.57170001f,0.43879999f,1.24100006f,-0.10000001f,0.14820001f,0.01980000f,-0.38220000f,0.43500000f,1.02740005f,0.10720000f,-0.26639999f,0.07679999f,-1.12410004f,0.09160000f,0.05580000f,-0.48980000f,0.56590001f,-0.50160000f,0.82080004f,-0.97130000f,0.42899999f,0.13619996f,-0.18929997f,-0.24130000f,-0.68399996f,-0.49059998f,-0.44520000f,-0.32570002f,1.19339999f,1.35580001f,1.01939997f,0.97089999f,-0.59220005f,-1.01240004f,0.01529999f,-0.00900000f,0.83790000f,0.51839998f,-0.15420003f,-0.66360003f,0.03540000f,-0.25700004f,0.56520002f,0.99270002f,-0.78270000f,-0.20779999f,-1.12140001f,-1.00450001f,0.19499995f,-0.67800000f,0.22119998f,-0.46040000f,0.59819999f,-0.27980000f,0.76199997f,-0.51040000f,-1.25190000f,0.40399999f,-0.24280001f,-0.54779998f,-0.11370000f,0.08699999f,0.37750001f,0.26120000f,0.02049999f,0.14760000f,-0.57520000f,0.47659999f,-0.42700000f,0.41360000f,0.84959999f,0.09360000f,-0.88909997f,0.42859999f,0.12330000f,0.49819999f,-0.71920003f,0.64160000f,0.78090000f,-1.63460000f,-0.96299999f,-0.79360000f,-0.74849999f,-0.84859999f,-1.30799998f,-1.44999999f,1.19219998f,1.46209999f,-0.96689995f,-0.54239998f,0.31109996f,0.49429998f,0.26160000f,-0.24530001f,0.20040001f,-0.02869999f,1.02929998f,0.84719998f,0.92039999f,0.82379999f,0.03959997f,-0.10559998f,1.12769998f,1.25269997f,0.87749997f,0.47009999f,1.49759999f,1.46080001f,-0.82949999f,-0.57780000f,0.73460002f,-0.33880000f,0.00010000f,0.58859999f,0.28720001f,-0.46439999f,1.36010002f,0.20440001f,-0.83030004f,0.17440000f,-0.41540002f,0.35520000f,-1.00100000f,0.05220000f,-0.72290002f,0.33059999f,1.00220003f,0.08540001f,0.00419998f,-0.48260001f,0.25379999f,0.16040000f,-0.70309999f,-0.13540000f,0.05620001f,-0.15579999f,-0.05469998f,-0.47179999f,-0.07460000f,-0.40110000f,-0.91260000f,-1.04300000f,1.09349997f,0.68569999f,-0.94499998f,-0.71559999f,-0.02400002f,-0.62829999f,0.63120001f,0.90030002f,0.84839999f,0.85900001f,0.40290001f,0.72279999f,0.93869998f,1.15010000f,-0.11070000f,-0.46099999f,-0.89310000f,-0.55180000f,0.07680001f,-0.37880000f,0.05910000f,0.57249999f,-0.37829998f,-0.41720001f,-0.78449999f,-0.30490000f,0.71459999f,0.52819999f,0.75860000f,0.15760000f,-0.01900001f,-0.32900000f,0.72660000f,0.18299999f,0.22770001f,-0.04160000f,0.66480001f,-0.24499999f,-0.84120002f,0.31260000f,0.22270000f,-0.38400001f,-1.26560002f,0.18140001f,0.38960001f,0.35260000f,0.94090001f,-0.17439999f,-0.09200001f,0.21120000f,-0.93710002f,0.26880000f,-0.33560001f,-0.16780001f,-0.76800002f,-0.05320000f,0.18560001f,1.09039999f,0.04560000f,-0.36059998f,-0.69389997f,-0.61579999f,0.11189997f,-0.28400000f,-0.16740000f,-0.25590000f,-0.72329999f,-0.90500001f,0.79470002f,0.80100000f,-0.88200000f,-0.87310003f,0.73950002f,1.09179999f,0.52829998f,0.13180000f,-0.57960001f,-0.73689999f,0.56219998f,0.69940002f,0.83640000f,1.07310001f,-0.33389999f,-0.31900002f,0.22140001f,0.68280002f,0.21930001f,0.43460000f,0.76870002f,-0.07839999f,-0.07790000f,-0.06040000f,0.23899999f,-0.77520000f,0.16790002f,-0.11459999f,-0.68700003f,-0.17160000f,-0.45739998f,-0.62159999f,0.94489999f,0.30099999f,-0.61930001f,-0.27039999f,-0.12720000f,-0.27919999f,1.53220005f,-0.11659999f,1.06550002f,0.24919999f,-0.33950001f,0.44700000f,0.34540002f,0.46660000f,-0.48860001f,0.16419999f,0.33030001f,0.43450000f,-0.25920001f,-0.26349998f,-0.01080001f,0.19610000f,-1.50839999f,-1.04780000f,-0.38969997f,-0.59210001f,-0.08039999f,0.33320001f,-0.99059996f,-0.35400000f,0.29429997f,-0.20809998f,-0.38039996f,-0.09189999f,-0.49919997f,-0.29479999f,-0.70470002f,-1.20400001f,0.10679995f,-0.49890002f,0.82590001f,0.44529999f,0.76289999f,0.31960000f,0.39870000f,0.36019999f,-0.42659999f,-0.46539999f,-0.91910002f,0.29360000f,-0.11060000f,0.48320000f,-0.35740000f,0.32059999f,0.17979997f,-0.51020000f,-0.91750003f,0.07980000f,0.62310001f,-0.24280000f,-0.88580002f,0.56180000f,-0.69110000f,-0.25999999f,0.79890000f,0.03720001f,0.56330000f,-0.09940000f,0.20480000f,-0.21120000f,1.45500005f,-0.03280000f,-0.03130000f,-0.48840001f,0.58940001f,0.29140000f,0.47780001f,-1.30939998f,0.84600001f,1.00430000f,0.86100000f,0.44080000f,0.68669999f,0.55959999f,-1.08689998f,-0.94619999f,0.51450002f,0.93750003f,-0.64980000f,-0.71790000f,1.32870000f,1.27980001f,-0.20879997f,0.32870001f,-0.14880000f,-0.41229998f,-0.35970000f,-0.49629999f,-0.38460000f,-0.18659999f,-0.52740004f,-1.06080003f,-0.92040001f,-0.61090002f,0.35549998f,-0.06620000f,0.59609997f,0.56480000f,0.43870001f,-0.07660000f,-1.02240001f,0.42840000f,-1.39310003f,-0.14720001f,0.61170002f,-0.34160000f,0.04490000f,-0.46659998f,0.04789997f,-0.08840001f,0.13430000f,0.37320000f,-0.58950002f,-0.10239998f,-0.12190000f,0.24140000f,0.07719999f,-0.37839999f,0.52150001f,0.21620000f,0.38979999f,-0.26019999f,0.10380001f,0.08860000f,-0.66160002f,0.45680000f,0.00320003f,1.09190000f,-0.18870001f,-0.13649999f,1.15860000f,1.31440000f,0.09780002f,0.59889998f,-0.76800002f,-0.65410000f,-0.79169997f,-0.32709998f,-0.29159999f,-0.44689999f,0.56879999f,0.11469999f,-0.09479994f,0.03590002f,0.55110000f,0.54290001f,-0.80699997f,-0.71459999f,0.34889998f,0.20230001f,-0.53309999f,-0.36859998f,0.13650000f,0.04460000f,1.01940001f,0.88260000f,0.40140000f,0.06980000f,-0.04199998f,0.59239999f,-0.44049999f,-0.07200000f,-0.39570002f,-0.44180000f,-1.11230002f,-0.17939999f,0.01010000f,0.09040002f,-1.05720001f,0.21719999f,0.66900002f,0.31699999f,0.27159998f,0.01160002f,-0.07889999f,-0.16219999f,0.54079998f,-0.46420000f,-0.46429999f,0.04259999f,-0.33300004f,-0.55600000f,0.18069997f,-0.46800001f,-0.68050000f,0.25180000f,0.17960001f,-0.62190003f,1.07819998f,0.62039998f,0.11879999f,0.53409999f,-0.73829998f,-0.35950000f,0.03210004f,0.59710002f,-0.00299995f,-0.36630000f,0.79499999f,1.14160000f,0.32609997f,-0.23480002f,0.15600002f,0.43620006f,-0.39149997f,-0.45330000f,-1.15409998f,-1.24859998f,0.12270000f,0.08429998f,-0.88679997f,-0.30459997f,-1.00619999f,-0.89049999f,0.72210000f,0.87170000f,-0.92249998f,0.30579998f,0.87170003f,0.39540000f,0.03259998f,0.06400001f,-0.41300000f,-0.48339999f,-0.00770000f,0.47440000f,0.62579998f,-0.63620000f,0.28640005f,0.84119999f,0.36560002f,0.05400000f,-0.54780003f,-0.53240000f,-0.59050001f,0.39440001f,-0.53460002f,-0.02240000f,-0.90430004f,-0.15580001f,0.29840003f,0.57859999f,0.01260000f,-0.57799999f,-0.08480000f,0.00560000f,0.80780001f,0.15069998f,0.46049997f,-0.13710001f,0.01680003f,-0.20219998f,-0.80129996f,-0.37159999f,0.83399999f,0.42009999f,-1.37550000f,-1.16139999f,1.39439996f,0.56659996f,-0.13320000f,-0.51620001f,-0.80999998f,-0.22559999f,0.98580001f,1.05110002f,0.14760001f,0.39900001f,-0.02189999f,0.39210001f,0.91949996f,0.29879997f,-0.99899998f,-0.46379999f,0.01740000f,0.01020000f,-0.87180000f,0.30440000f,-0.84270000f,0.37419999f,0.44989998f,-0.14259999f,-0.47909998f,0.48300001f,-0.41610003f,0.56520000f,-1.17190002f,-0.19340000f,1.43820003f,0.12600001f,0.05920000f,0.28260000f,-0.14110000f,0.25840000f,-1.19940002f,-0.03980000f,0.64040000f,0.14860000f,-0.38300001f,0.43840000f,0.15230003f,0.78920000f,0.30020000f,-0.16540001f,0.27540001f,0.62100000f,-0.40020000f,0.10259999f,0.92069999f,0.90449998f,-0.36329999f,-0.35529998f,1.16490000f,1.21510000f,1.19160001f,0.97350002f,-0.05609996f,0.39750000f,-0.17580002f,-0.72219999f,0.58769999f,0.51380001f,0.51839999f,0.38110000f,0.28950002f,0.73819999f,0.12569998f,-0.12479999f,0.84840001f,0.53380000f,1.35299999f,0.63409999f,-0.53730001f,-0.77420003f,0.99749998f,0.34179998f,0.26940000f,0.39819999f,1.26080002f,-0.11499999f,0.96550003f,-0.04420000f,-0.12050001f,-0.13280000f,-0.34960000f,-0.19120000f,1.08210001f,-0.14800000f,-0.21160000f,0.48399999f,-0.46300001f,-0.48740000f,-0.46690001f,0.63360001f,0.35850000f,0.04280000f,0.49569999f,0.13219999f,1.24660001f,-0.16980000f,-0.61919999f,0.49320000f,0.54110002f,-0.16160001f,0.60709998f,-0.36819999f,0.50320002f,0.46299998f,-0.60750001f,-0.99139999f,-0.40950003f,-0.77950002f,-0.25439998f,-0.19830000f,-0.36839998f,-0.32400002f,-0.64800001f,-1.00530000f,0.93359998f,0.61999999f,-0.75149997f,-0.22699999f,1.35540001f,1.14550002f,-0.07860000f,-0.32170000f,-0.02550000f,-0.50510000f,-0.73470001f,-1.12819999f,1.16339999f,1.14439999f,-0.44400002f,-0.48630001f,-0.91769997f,-0.96369998f,0.27959998f,0.26740000f,0.16940000f,0.61999998f,-0.26859999f,0.62480001f,-0.11819999f,0.72720001f,0.07510000f,-0.34180001f,-0.53090002f,0.50040001f,-0.50860002f,0.29980000f,-0.08330000f,-0.11120000f,-0.15780001f,-0.31500000f,-0.76430001f,-0.05980000f,-0.40380000f,-0.19580000f,-0.98580003f,0.36500000f,-0.15009999f,-0.32000000f,0.11019999f,-0.31140001f,0.58670002f,-0.48860001f,-0.93230001f,0.26790000f,-0.13830000f,-0.09060000f,0.33569999f,-0.31710001f,-0.00400001f,-0.44340000f,-0.31920000f,-0.44040000f,-0.36630001f,-0.15510001f,-0.14420000f,0.48100002f,-0.01470000f,0.84040001f,0.19040001f,0.42670000f,-0.16080000f,0.37200001f,0.23340000f,0.85960001f,-0.16830000f,0.26060001f,-0.00550000f,0.28660001f,-0.40380000f,-0.03820000f,0.10890000f,-0.74000002f,-0.19530000f,1.31140001f,-0.50329999f,-0.77680000f,-0.00900000f,0.60490001f,-0.61740001f,0.56550003f,0.01429997f,0.89340000f,0.30749999f,-0.41550001f,-0.67640000f,-0.42140001f,-0.01320001f,-0.63119999f,0.65869998f,0.37179999f,-0.24389999f,0.24530000f,0.17050000f,-0.41530001f,0.49530000f,1.08880002f,-0.61599997f,0.15460002f,-0.69549999f,-1.13180001f,-0.88470000f,-0.14079999f,-0.94049996f,0.53580001f,0.12690000f,0.33810000f,-0.02100000f,0.02930000f,0.05060000f,0.58170001f,-0.12269999f,0.22090000f,0.03490000f,-0.42089998f,0.02040000f,0.76810001f,-0.04520000f,0.14970001f,-0.23190000f,-0.26040001f,0.09190000f,0.06400000f,-0.03290000f,-0.10470000f,-0.02290000f,-0.58210002f,0.20160000f,0.25410000f,0.08550001f,0.67590000f,0.40830001f,0.11050002f,0.19370000f,0.06290000f,0.16040000f,-0.13010001f,0.50320001f,-0.76580004f,-0.19759999f,-0.08690000f,-0.48450001f,-0.78340000f,-0.61639996f,-0.60689998f,-0.06540000f,-0.79060001f,0.14389998f,-0.57720001f,-0.37039998f,-0.04410000f,0.34459998f,-0.39590001f,0.10280000f,-0.34540002f,0.29759999f,1.31090004f,-0.08739996f,-0.76300001f,-0.17189999f,-0.97350001f,-0.92099997f,0.21380000f,0.49999999f,-0.81200001f,-0.05040000f,-0.06660000f,0.04240000f,-0.65090002f,0.19320000f,-0.20629999f,-0.05590000f,0.73510002f,0.18079999f,0.33920000f,0.00860000f,0.09550000f,0.05170000f,-0.25939999f,0.35640000f,-0.37929998f,0.05580000f,-0.51329998f,-0.14840000f,0.23599999f,0.01800000f,-0.45440000f,0.22420000f,-0.37390001f,0.20790000f,-0.22709999f,0.13220000f,0.76840000f,0.04680000f,-0.01210001f,0.18449999f,-0.85330001f,0.17849998f,0.56040000f,0.65469999f,0.89669998f,-0.02020000f,-0.36100001f,-0.24260000f,-0.17080000f,-0.34530000f,-0.29010002f,0.61739997f,-0.20920002f,-0.55609998f,-0.75990000f,0.14659999f,-0.22170001f,-0.18590001f,0.23040001f,-0.08040000f,0.71740002f,0.34489999f,-0.36060001f,0.13220000f,-0.17910000f,0.50269998f,-0.44539999f,0.76210000f,0.08930000f,-0.08610000f,0.02200000f,-0.30690000f,0.46620000f,0.01090000f,-0.83740001f,-0.03420000f,0.11960001f,-0.01580000f,0.32940001f,0.27170000f,-0.20279997f,-0.21980000f,-0.21140000f,0.12170000f,0.41120000f,-0.12380000f,0.12220000f,-0.03290000f,0.28250001f,-0.03720000f,0.14480000f,-0.08370000f,-0.19580000f,0.01940000f,-0.19100000f,-0.22470000f,-0.05400000f,-0.08130000f,0.77629999f,0.11919999f,-0.20650002f,0.40549997f,0.19499999f,0.49359997f,0.47829999f,0.45050000f,0.42900001f,-1.01599999f,-0.00309997f,-0.73869998f,-0.24229998f,0.48900002f,-0.68470002f,-0.06960000f,-0.10920001f,-0.29880000f,-0.44070001f,0.24100001f,-0.85390003f,0.48599998f,-0.06690002f,-0.53470001f,0.63720003f,0.09560002f,0.77280002f,0.76690000f,0.34600000f,-0.33319996f,-0.68860001f,-0.29560000f,0.54719998f,-0.26510000f,0.12160000f,-0.11800000f,-0.33259999f,-0.20290000f,-0.08510001f,0.19720001f,0.74160000f,0.10110000f,0.64769999f,0.02740000f,-0.60380003f,0.06720000f,-0.06690000f,-0.13200000f,0.67470000f,0.02420000f,-0.29700001f,-0.40960000f,0.37079999f,0.03270001f,0.52210001f,0.21560000f,-0.64370001f,-0.08650001f,-0.71930001f,0.29440000f,0.34130000f,0.72000000f,0.49540002f,0.61519998f,-0.01680000f,1.19319997f,0.15480001f,-0.95209998f,0.27300002f,0.66019997f,0.93679999f,-0.51329995f,0.02700002f,0.14689999f,-0.69980002f,0.06069998f,-0.27380001f,-0.57659999f,-0.33699999f,-0.64979999f,-0.30580000f,-0.33839997f,-0.60479999f,-0.90069997f,0.00069999f,-0.51589998f,-0.80999999f,-1.19759997f,-0.40119997f,0.58849999f,-0.95380000f,-0.15760001f,-0.50860000f,-0.10240000f,-0.48709999f,-0.30680000f,-0.70600000f,0.09970001f,0.87649999f,-0.17860000f,-0.41169999f,0.25209999f,0.02399999f,-0.14730000f,0.19890000f,-0.11310000f,0.20110001f,-0.02260000f,0.74529999f,0.09140000f,0.56860000f,0.35759999f,-0.39239998f,0.13670000f,0.74459999f,0.08669999f,0.44660000f,0.24879999f,0.85600002f,-0.02770000f,0.95740001f,0.75779998f,-0.02920001f,-0.68389998f,-0.85340000f,0.58599998f,0.48939999f,0.03070001f,-1.17700002f,-0.57090000f,0.32650003f,-0.71419998f,-0.20119998f,-0.28760000f,0.57849999f,-0.89689996f,0.06430004f,0.00360000f,-0.75340004f,0.54560001f,0.70020003f,0.35499997f,-0.49710001f,-0.32469998f,0.72160000f,0.43519998f,0.13989998f,0.28210000f,0.77150000f,-0.19460001f,-0.59180001f,-0.12979999f,-0.59120001f,0.11629999f,0.57820001f,-0.05560000f,-0.58460000f,0.18090000f,-0.39329999f,0.07810000f,0.47570001f,0.16620000f,0.46780001f,-0.07440000f,0.48009999f,0.22490000f,0.53500000f,0.18040000f,-0.38089999f,-0.08480001f,-0.48050001f,-0.25300000f,0.18680000f,0.11790000f,0.07620000f,-0.17880000f,-0.10830000f,0.06270000f,-0.51240001f,-0.12100000f,-0.44959999f,0.04059999f,-0.73480001f,0.67599997f,0.42859999f,-0.02759999f,-0.74429998f,0.16910000f,-0.10260001f,0.65419999f,-0.12390003f,-0.40860001f,0.06690001f,0.83530000f,0.34210000f,-0.55059999f,0.57490000f,-0.29539999f,-0.77110001f,0.30830001f,-0.34010001f,-0.74359997f,-0.14869997f,-0.69529999f,0.25750002f,0.53899998f,0.37690000f,-0.40040000f,0.63780003f,-0.35260000f,0.62070000f,0.06260000f,-0.15539999f,-0.25520000f,-0.23010000f,0.08480000f,-0.12570000f,-0.03270000f,-0.11870000f,-0.13060001f,-0.46310000f,-0.10140000f,0.70890001f,-0.27130001f,-0.37610001f,-0.03780001f,0.70530001f,0.08620000f,0.18690000f,0.11330000f,-0.60509999f,0.33600000f,0.11080001f,0.08170000f,0.61690000f,-0.32740000f,0.09869999f,0.10680000f,0.19460000f,0.20900000f,-0.69170000f,-0.14349999f,-0.30530001f,-0.20889999f,0.19180001f,0.93860000f,0.97100002f,0.59389997f,-0.02980005f,-0.05220000f,0.71730003f,0.53619999f,1.21689998f,-0.21589999f,-1.03749998f,0.40049997f,0.75049999f,0.36079998f,0.47459999f,0.54960000f,-0.84590004f,0.05490002f,-1.07860000f,-0.23150001f,-0.50060001f,-0.46919999f,-0.90110002f,-0.11400000f,0.04300001f,0.35849999f,0.39300001f,0.30830000f,-0.52289999f,0.14690000f,-0.10050000f,-0.12260001f,-0.86860001f,-0.27590000f,-0.06400000f,-0.03140000f,0.09840000f,-0.10940000f,-0.43820001f,0.19030000f,-0.13199999f,-0.24930000f,0.06430000f,-0.10720000f,-0.20120000f,0.06440000f,-0.75190000f,0.07429999f,-0.18230000f,-0.17130000f,0.68860001f,0.12480000f,0.30890001f,-0.12760000f,0.42409999f,-0.06570000f,0.17339998f,-0.61570000f,0.18850001f,-0.34900001f,-0.67670001f,-0.39239999f,-0.24370000f,0.91679998f,0.56440002f,-0.58990000f,0.54290003f,0.45130000f,-0.06090001f,-0.90160000f,-0.22579999f,-0.06690001f,0.87190000f,0.04950000f,-0.55800000f,0.25290000f,-0.22600000f,0.05480001f,0.22070001f,0.44140002f,-0.91830003f,0.63650000f,0.71300002f,-0.18559999f,-0.81160001f,-0.41519998f,-0.60910000f,0.02210000f,0.66330001f,-0.06419999f,0.58980000f,-0.00560000f,0.48549999f,-0.26480000f,-0.49750000f,0.12110001f,0.38900001f,-0.01290000f,-0.49750000f,0.06640000f,0.91770001f,0.02450000f,-0.01990000f,0.13090000f,-0.33089998f,0.02190000f,-0.33620000f,0.12560000f,-0.36280000f,0.07019999f,-0.63460001f,-0.14730000f,-0.44470002f,0.09520000f,0.03930000f,0.16320000f,-0.50440001f,-0.10689998f,-0.11540000f,-0.89879999f,0.08160001f,0.03870000f,1.08640002f,0.35510001f,0.13230000f,0.25290000f,0.70819999f,0.49329997f,0.01940002f,-0.12190001f,-0.68620001f,0.27069996f,0.47549998f,-0.52829999f,-0.22540000f,0.72799997f,0.44289999f,-0.49209998f,-0.58100000f,0.15680000f,0.17020000f,-0.09160000f,-0.19380001f,-0.57480000f,-0.25149999f,-0.55559998f,0.68230000f,0.20890000f,-0.34740000f,0.10520001f,0.81060000f,-0.26310001f,0.50450000f,0.09850000f,-0.64910001f,0.10110000f,-0.56299999f,-0.25370000f,0.00090000f,-0.09290000f,0.38930000f,-0.25070000f,0.23330002f,0.17670000f,0.22660001f,-0.23960000f,-0.32760000f,0.31410000f,-0.11339999f,0.12959999f,-0.48929998f,0.03400000f,0.03910000f,-0.03280000f,0.76240001f,0.26800000f,-0.55890004f,-0.57919999f,-0.85560001f,-0.41349997f,0.47330000f,0.55309998f,0.87270001f,-0.12950003f,1.00450001f,0.46269995f,-0.25300006f,-0.72239999f,0.42300003f,-0.01999999f,-0.93690001f,-0.68439999f,-0.04489999f,0.55549996f,0.20819998f,1.08779996f,0.23270000f,0.17649998f,0.17409999f,0.42099998f,1.05420003f,0.85929998f,0.50440003f,-0.60289999f,0.11150000f,0.43859999f,-0.06820001f,0.03840000f,0.63379999f,0.19990000f,0.00470000f,-0.20270000f,-0.22760001f,-0.07529999f,0.27580000f,-0.33910000f,0.24570002f,0.09920001f,0.60059999f,-0.00520000f,0.08090000f,0.48880000f,-0.31379997f,-0.28229999f,-0.01580000f,-0.31540000f,-0.56630000f,-0.24049999f,0.33519998f,-0.04340000f,-0.44619999f,-0.25090001f,-0.45890000f,0.09090000f,0.49440000f,0.02980000f,-0.63789998f,-0.23589999f,-1.14820002f,0.24339996f,-0.17740000f,0.56719997f,0.95049999f,-0.38550000f,-0.71690001f,0.88880000f,0.51180002f,-0.63999999f,-1.46230004f,0.43039998f,-0.40090002f,0.45499999f,1.13790003f,-0.83670000f,-0.13599999f,-0.18220000f,0.39960001f,0.00569999f,0.81080004f,-0.38819999f,-1.07800001f,0.40940000f,0.88380000f,0.03800000f,0.03430000f,0.78379999f,0.17879999f,0.13550000f,0.02240000f,-0.18100000f,0.13740001f,-0.19320000f,-0.26970000f,-0.01290000f,0.51710000f,-0.07760001f,-0.89090000f,0.01800001f,0.78139999f,-0.21800000f,0.01339999f,-0.12660000f,-0.29960000f,0.18270001f,0.57070001f,0.00540000f,0.18220000f,-0.12610000f,0.24279999f,0.00260001f,0.50229998f,0.05459999f,-0.64880000f,-0.04640000f,0.06000000f,-0.15300001f,-0.70540002f,-0.51790000f,-0.01380000f,0.13590000f,-0.06040000f,-1.07789998f,-0.30390003f,-0.79950000f,-0.53760000f,0.14409997f,1.00850000f,0.07980001f,-1.10220003f,-0.58699999f,-0.39290000f,-0.31609999f,-0.28569999f,-0.21519999f,0.83940001f,-0.18019998f,-0.60279999f,-0.31620001f,-0.44240001f,-0.65790000f,-1.28950004f,0.72600000f,-0.05140001f,-0.41639999f,-1.12980002f,-0.39459999f,0.11560000f,-0.06570000f,0.75939999f,0.09329999f,-0.37039998f,0.31310001f,0.56340001f,0.10710000f,0.71970002f,-0.25449999f,0.36480000f,0.20980000f,-0.52079999f,0.23300000f,0.17470001f,0.02890000f,0.31890000f,-0.11600001f,0.47770000f,0.18019999f,-0.17189999f,-0.12300000f,0.67460001f,0.02670001f,0.77410000f,-0.30200001f,-0.15830001f,-0.00760001f,0.56130001f,0.13820000f,-0.46740000f,0.44819999f,-0.66310002f,0.37910001f,-0.58910002f,0.27689998f,0.24070000f,0.54719998f,0.42319998f,0.55989999f,-0.52170001f,-0.50839999f,-0.58420000f,0.41919998f,1.01780001f,-0.96190000f,-0.58900001f,0.19509999f,-0.32970000f,0.36169998f,-0.59780000f,0.60879999f,-0.59480001f,-0.90839998f,-0.27060001f,0.23770001f,-0.10450000f,0.72749997f,0.10399999f,-0.34079999f,0.53950000f,0.06580000f,-0.64490000f,0.00410000f,-0.42600001f,-0.13130000f,-0.03610000f,-0.32320000f,0.07719999f,-0.02790000f,-0.56830000f,0.01320000f,0.59520000f,-0.10880000f,-0.29250000f,0.16150001f,0.78830002f,-0.06470000f,-0.06490000f,-0.18690000f,0.03240000f,-0.00960000f,-0.66410000f,0.16840000f,0.69420001f,0.05990000f,-0.41130002f,-0.12390000f,-0.57559998f,0.22440000f,-0.46840000f,-0.52739999f,-1.04109998f,-0.96179999f,-0.69460002f,-0.82140000f,-0.98730002f,0.44630000f,0.43990001f,-1.10630000f,-0.29600000f,-0.54679999f,-0.08529999f,0.14490000f,0.20860000f,0.47879999f,0.52950001f,-0.08230001f,0.58180000f,0.46519997f,0.48060000f,-0.57320001f,0.09990002f,0.25210000f,0.57950000f,0.66400000f,0.32290001f,0.59110002f,0.34730001f,-1.20569996f,-0.89749994f,-1.31129999f,-0.06089996f,0.04949999f,-0.06889999f,-0.09600000f,0.10779999f,-0.82529999f,0.94790000f,0.31649995f,0.56650003f,1.15650005f,0.50689995f,-0.42150001f,0.12010000f,-1.06170000f,-0.02669998f,0.52950000f,-1.19309999f,-0.92520001f,-0.51329998f,-0.32580000f,1.02129999f,1.41420004f,-0.24050000f,-0.91800002f,0.25640003f,0.15360000f,-0.67380000f,-1.55400006f,0.39530001f,-0.14069999f,0.58970000f,0.12840000f,0.78340001f,0.37499999f,-0.35690001f,-0.01520001f,-0.81039998f,0.44990001f,0.89049999f,-0.01079999f,0.41289998f,-0.13989999f,-0.84670002f,-0.20500000f,-0.04649999f,-0.16620001f,0.35980000f,0.04250001f,0.72829997f,-0.44980001f,-0.01379998f,0.15710001f,1.08859998f,0.07460002f,-0.06029999f,-0.07909999f,0.67440001f,-0.10769999f,-0.40209998f,0.41639998f,1.55309997f,-0.98910004f,0.28820002f,-0.56909997f,-1.04629997f,0.38400000f,-1.04879999f,-1.40820004f,0.28349998f,-0.65250001f,-0.12010001f,1.32090002f,0.03629992f,0.33899999f,0.14450000f,0.43080003f,1.10020001f,-0.72030002f,0.45569998f,0.78720000f,0.54740001f,-1.04640001f,0.83060001f,-0.75900004f,-1.08249997f,-0.69660003f,0.24480003f,-0.81900005f,0.24059998f,0.04760000f,0.15400000f,0.15270001f,0.79899999f,-0.30570000f,0.14850003f,0.20519999f,-0.31910000f,-0.06180000f,-0.07980001f,0.24940001f,-0.67089998f,-0.21750000f,-0.00370000f,-0.18270000f,0.35379998f,-0.12840001f,-0.88660002f,0.25730000f,-0.20180000f,0.24590000f,-0.30589999f,0.39819999f,-0.25730000f,-0.09130000f,0.59290000f,0.04480000f,0.48709997f,0.12400001f,-0.01779999f,-0.67380000f,-0.58199996f,-0.74610001f,0.68300001f,0.12059998f,0.10230004f,0.48900002f,0.29789997f,0.73020003f,0.78699997f,-0.23130003f,-1.32830000f,-0.03780001f,-0.30949999f,-0.38070000f,-0.05500000f,0.98730004f,-0.48980004f,-0.22409998f,-0.40419998f,-0.67980000f,-1.24969995f,-0.09780000f,-0.17430002f,0.02549999f,1.07429999f,-0.15899999f,0.77089996f,-0.68310003f,0.50240000f,-0.12679999f,0.09530002f,0.06650000f,-0.17360000f,0.34959999f,-0.69539997f,-0.17899999f,0.25810003f,-0.27050001f,-0.64440001f,0.16800000f,0.01720000f,-0.25810000f,0.48139999f,0.18219999f,-0.42899998f,0.25790000f,-0.17770000f,0.10590000f,-0.24690003f,-0.46210000f,-0.21669999f,0.16240000f,0.72069999f,-0.06360000f,0.52310000f,0.18049999f,0.06480000f,-0.36770000f,0.68920002f,-0.59790003f,-0.79049995f,-0.08940000f,-0.38240000f,-0.44039998f,-1.55019994f,-0.44760003f,-0.32809994f,0.82440002f,-0.41160004f,0.16230000f,0.45119999f,0.50340000f,1.32979997f,0.70140002f,0.35380000f,-0.27900000f,-0.43310000f,0.69120003f,0.60329994f,0.78900000f,0.14430000f,-1.36590000f,-0.31589995f,-0.29730001f,0.52410001f,-0.66329998f,-0.58679996f,1.06349999f,1.06960001f,0.02789999f,-1.06639998f,-0.37420000f,-0.91930000f,-0.19760000f,-0.19170000f,0.10140000f,-0.46820002f,-0.12190000f,0.36479999f,0.05890000f,0.21190000f,0.21340000f,0.43549999f,-0.23630000f,-0.71149997f,0.12160000f,-0.41100000f,0.06520000f,0.08140000f,0.05290000f,-0.06400000f,-0.10419999f,0.22190002f,0.19010000f,-0.44249999f,-0.09970000f,-0.75930001f,0.28420000f,1.85040002f,0.19320001f,-1.75759997f,1.17540000f,-0.57470004f,0.50700001f,0.10570000f,0.72600002f,0.21939994f,0.73590000f,1.58359995f,-0.33510000f,0.01210001f,-1.10670001f,-0.44829997f,1.28189998f,0.13229997f,-0.48330002f,-1.32300001f,-0.39150000f,-0.31059998f,-0.23820001f,-0.39279999f,-0.52230004f,-0.41549997f,-0.20280001f,-0.91629999f,0.77640002f,-0.50350003f,0.18150001f,0.52339998f,-0.13110000f,-0.61739997f,0.19469999f,-0.94309998f,-0.06899999f,-0.91449999f,0.21349999f,-0.70999998f,0.00520001f,0.05570001f,0.20239999f,-0.09660001f,0.19610001f,-0.33909999f,0.07080001f,0.33320000f,-0.39390000f,0.58720000f,-0.18299999f,0.46780003f,0.43609998f,-0.42650000f,-0.01190000f,-1.05550002f,-0.31209999f,-0.00799997f,0.08389999f,-0.94599999f,0.39010000f,-0.48820000f,0.56370000f,-0.56059997f,0.01650000f,-1.57289999f,0.62700002f,-0.97470000f,-0.25800000f,-1.48199996f,-0.72930003f,-0.89729996f,-0.50309997f,-0.65099997f,-0.75420004f,-1.47409999f,-0.80310003f,-0.38879998f,0.13350000f,0.86520001f,-0.42630004f,0.10140005f,-0.30929997f,-0.75030000f,0.75270004f,-1.00690004f,0.05579997f,-0.29679996f,0.24930001f,-1.38320001f,-0.47520001f,0.70119998f,-0.15080000f,0.17900000f,-0.33580000f,-0.76069998f,0.46450001f,0.50229999f,-0.01030001f,-0.75370002f,-0.26220000f,0.77069997f,0.27560000f,0.74629998f,-0.08660000f,-1.11070000f,-0.31530000f,0.24990001f,0.19820000f,0.22219999f,0.18320001f,0.46539998f,-0.29710001f,-1.02519997f,-0.34640001f,-0.55860001f,-0.08250000f,-0.54690000f,-0.16500000f,-0.15319999f,0.00569999f,0.56439999f,0.26189998f,0.53499998f,0.94860000f,-0.53890001f,-1.00530002f,0.10970000f,1.11210007f,0.07529997f,0.10890003f,1.33650000f,-1.06710001f,0.27769998f,0.94200003f,-0.93690001f,0.70649997f,1.09889997f,0.04020001f,0.71219998f,-1.13100000f,-0.45899998f,1.21350002f,-0.63759998f,1.12680004f,0.08579997f,0.29790001f,-0.73710000f,0.91319998f,0.78039996f,0.13500000f,-0.79069999f,-0.24580001f,-0.29559999f,0.02080000f,0.50639999f,0.14620000f,-0.99049997f,0.28899999f,-0.48079999f,0.19530000f,-0.44330000f,0.03699999f,-0.70289999f,0.02930000f,-0.06040000f,-0.11759999f,-0.45279998f,-0.22110000f,0.25269998f,0.00050000f,0.28110002f,-0.03290000f,0.33449998f,-0.31750000f,0.33679997f,-0.11029999f,-0.19159998f,0.08210000f,0.29920000f,0.28670001f,-0.35730005f,0.93600002f,0.44439999f,-0.50430000f,0.30200001f,0.24840001f,-1.39869997f,-0.11669999f,-0.75719998f,-0.18059999f,-0.88109999f,0.99090002f,0.05969998f,0.03150000f,-0.03920000f,-0.00090002f,-1.00999996f,-0.00240000f,0.23009999f,-0.76860001f,-0.52229992f,0.45570000f,1.23909994f,0.40920004f,0.85199999f,-0.24300001f,-0.83319995f,-0.61650000f,-0.18279997f,-1.26630003f,-0.54350001f,-0.21429999f,-0.28369999f,-0.11900000f,0.34669997f,0.00970000f,0.57479997f,-0.20230001f,-0.98599997f,-0.49980001f,0.09599999f,-0.14840000f,-0.31479999f,-0.01740000f,0.57730001f,0.27359999f,-0.57570002f,-0.54000001f,0.39190002f,-0.28480000f,-0.40459999f,0.26709999f,-0.39360000f,0.25769999f,-0.16640001f,0.06010000f,1.19429996f,0.12759999f,-0.55819998f,0.05410001f,-0.31250002f,0.06359999f,-0.70549997f,-0.25920000f,0.17289998f,-1.05989999f,-0.34879997f,1.20240004f,-0.46839997f,0.78390001f,0.69719997f,0.33300001f,-0.31639998f,-0.49260003f,0.41110002f,-0.40409996f,-1.35629997f,0.58260000f,0.94290003f,0.46649999f,-0.46140000f,0.02280002f,-0.42080000f,-0.05969998f,-0.10760002f,-0.72960000f,1.36209997f,0.46590001f,-0.28460000f,-1.24140004f,-0.22810001f,-0.06420001f,-0.12510000f,0.26700000f,-0.00390000f,0.22940000f,-0.68880002f,0.33439999f,0.48839999f,-0.31220000f,-0.53480000f,0.15310001f,0.81080001f,-0.20310000f,-0.54129999f,-0.21710001f,0.10100000f,0.40410000f,-0.33130002f,-0.19790000f,0.50020003f,-0.15920000f,-1.15600001f,-0.08490000f,-0.06980001f,-0.26140001f,-0.41360000f,0.28620000f,-0.05630000f,0.31740000f,0.66090000f,0.49920001f,0.37669999f,0.06390001f,0.38789999f,-0.14339996f,-1.26400000f,-0.92460000f,0.04520001f,0.83340000f,-0.23560005f,-1.18410005f,0.09920002f,0.43110000f,-0.68030000f,0.57930002f,0.74820000f,-0.16649997f,-0.40550003f,-0.58200004f,-0.06899994f,1.01310004f,-1.00920003f,0.67800000f,0.70739996f,0.86730003f,0.10360000f,0.09870001f,0.35710000f,0.07200003f,0.15060000f,0.04330000f,-0.47370001f,-0.02460000f,0.39720000f,-0.32430001f,-0.30720000f,-0.40969999f,0.14240002f,-0.21750001f,-1.17769997f,0.32040000f,0.17879999f,0.13030000f,1.11419999f,0.14940001f,0.50600001f,0.24260001f,0.86210000f,-0.14660000f,0.88679998f,-0.20160000f,0.33299999f,0.29990001f,0.05670000f,0.02739999f,-0.09830000f,-0.28310000f,-0.91610000f,0.04140000f,-0.00979998f,-0.41370001f,-1.43750000f,0.31860002f,1.17960002f,0.92460002f,0.31599999f,0.42869996f,0.39799999f,1.14570001f,-0.93430000f,-0.94349999f,-0.59439997f,-0.88260001f,1.07620002f,-0.37170001f,0.63280002f,-1.18290005f,0.30270000f,0.03749999f,1.59439997f,0.23280001f,0.73339999f,-0.83640003f,-0.70510001f,0.38160001f,0.37069998f,1.37940001f,-0.18110004f,0.40050001f,-0.76399998f,-0.13910000f,-0.17539999f,0.06670000f,0.02790000f,0.08539999f,-0.27709999f,0.05730001f,0.56320002f,0.17759999f,-0.11760004f,0.20920001f,0.83979999f,0.06460001f,-0.47589998f,-0.19250001f,-0.91490000f,0.09720000f,-0.66689999f,0.02880000f,0.30520000f,-0.08510000f,0.51939998f,-0.22940000f,-0.39970000f,0.13200000f,0.31570000f,0.26950000f,-0.29079999f,0.11720000f,0.06120000f,0.30570000f,-0.07459999f,0.29700000f,0.54209997f,0.95040002f,0.88069998f,-1.13460005f,-0.41999996f,0.47880005f,0.64079994f,-1.01340001f,0.45620002f,-0.34590002f,-1.32329996f,0.70140001f,-1.01430003f,-0.09420001f,-1.30550000f,-0.24210001f,0.28640001f,-0.14610000f,0.70179998f,0.87690002f,0.18049999f,-0.27570000f,0.37870001f,0.40530002f,0.31039999f,-0.32040001f,0.73189999f,-0.49360000f,0.04559999f,-0.10780000f,-0.66130000f,-0.00810002f,-0.02140003f,-0.21630000f,0.85929999f,0.05830001f,0.79570001f,-0.12650001f,-0.68209997f,0.29240000f,-0.50820000f,0.06130000f,-0.00129999f,0.09050000f,-0.09069999f,0.02710000f,-0.26539999f,-0.23740000f,0.52879998f,0.40820000f,-0.36359999f,0.45220000f,0.62029999f,0.21829999f,-0.28670000f,-0.35300001f,0.97089999f,0.76320000f,0.57839996f,0.69720003f,-0.43350000f,0.82170005f,1.08819996f,0.46860001f,2.05869999f,-0.11910002f,1.43710000f,0.94110001f,-0.15710000f,-0.07949999f,-0.75460001f,-0.56010002f,-0.70829998f,-0.64530000f,-0.96529996f,0.18060000f,-0.23060000f,-0.12510000f,0.57399999f,-0.67049999f,-1.16159996f,-1.14840001f,0.12490001f,0.36030001f,0.19709998f,0.24060000f,1.27009998f,-0.14600000f,-0.94029997f,0.13150000f,0.16039999f,0.38880000f,-0.03649999f,0.16000000f,-0.10889999f,-0.08790000f,-1.03900001f,0.04640000f,0.92599996f,-0.13510000f,-0.03619999f,-0.14050000f,-0.60790000f,0.08519999f,-0.97789998f,0.02780000f,0.01130000f,0.10020001f,0.45659998f,-0.34780000f,0.80800001f,-0.03379999f,0.26860001f,-0.08870001f,-0.82230000f,0.04209998f,1.29790001f,0.55229999f,-1.21649997f,0.19410001f,0.72959997f,-0.78240001f,-0.70789998f,-0.55709999f,-0.79829996f,0.78720003f,-1.01460002f,-0.24869998f,1.49519997f,-0.46200002f,-0.86539998f,0.62790002f,-0.46410000f,0.10380000f,-1.64489999f,0.24630000f,0.39509999f,-0.65220001f,0.09220000f,0.42689997f,1.75079998f,-0.44070003f,-0.13139999f,1.21590004f,-0.00330002f,0.75870004f,-0.21520000f,-0.32370001f,-0.56959999f,0.01039999f,-1.18789998f,0.05829999f,-0.35029998f,-0.05550001f,-0.34249999f,0.01420000f,0.21230000f,-0.12970000f,-0.22519999f,-0.15760000f,-0.29299999f,0.21150000f,-0.45010001f,0.18740001f,0.33190000f,-0.12850000f,0.92330001f,-0.17470000f,-1.17620000f,0.10560000f,0.37669998f,0.20129999f,-0.87259998f,0.41049999f,-0.45050001f,0.17210001f,-0.32920000f,1.01520002f,-0.06400002f,0.47520001f,-1.62129998f,0.46290000f,0.03269999f,0.37050001f,-0.21109999f,-0.20190000f,0.14610001f,0.09029999f,-0.45839998f,0.78030000f,0.33499998f,-0.01889998f,-0.65150000f,-0.01560000f,0.83410000f,-0.45180003f,1.00750003f,1.06230002f,-0.99780002f,0.05250001f,0.92089996f,-0.28980000f,-1.85379998f,-0.55799997f,-1.17069999f,-1.23240006f,0.97289999f,0.15920000f,-0.28240000f,0.03010000f,-0.40339998f,0.10819999f,-0.70679997f,-0.10690000f,-0.61410001f,0.18210000f,-0.01180000f,0.06290001f,-0.08969999f,-0.53590000f,0.07360001f,-0.30680001f,-0.62650000f,0.14280000f,-0.63630002f,-0.00610000f,0.37720000f,0.35940000f,-0.04440002f,0.07180000f,-0.54589999f,-0.30020000f,0.75610002f,0.19270000f,-0.11070001f,-0.25740001f,-0.44849999f,0.80939998f,-1.40909995f,0.51909999f,0.02960001f,0.32560000f,-0.12859998f,-0.47980001f,-0.92629997f,0.26109999f,0.26219999f,-1.31080001f,1.23250001f,-0.34340000f,-0.43290002f,0.53699999f,-1.13649997f,0.73350003f,0.62659998f,0.81869999f,-0.96299999f,-0.68570000f,-0.39999999f,-0.06620000f,1.50430003f,0.59540000f,-1.01659998f,0.76530001f,0.18250000f,0.50250002f,0.05490001f,-0.29450003f,0.60410000f,0.03240000f,0.20880001f,-0.27830000f,-0.49570000f,0.17360002f,-0.46160000f,-0.47930001f,0.11929999f,0.30750000f,0.06329999f,-0.22590000f,-0.13050003f,0.25950000f,0.10050000f,-0.12140001f,0.43820002f,0.06269999f,0.27209999f,0.48900001f,0.30300002f,-0.15560002f,0.41480000f,0.43529999f,-0.33450001f,0.36699999f,0.24500001f,0.53700000f,-0.72179999f,-1.10250000f,0.34780000f,0.32540002f,-1.07900001f,0.36759998f,-0.51509999f,0.44400000f,0.47679998f,-0.03029996f,-1.49680003f,0.63620001f,-0.70549998f,-0.79349999f,1.42059998f,0.07100000f,0.33650000f,-0.74660002f,0.38640004f,0.17850001f,-0.80599998f,-0.03820001f,0.77240002f,-0.06430000f,-1.16909997f,1.20019999f,-0.75610003f,0.56910000f,-0.78269999f,0.88730000f,-0.06160000f,0.32080001f,-0.14079999f,-0.22140003f,0.31140000f,0.56670001f,0.16770002f,-0.70149999f,-0.06170000f,-0.36940001f,0.21820000f,-0.06709999f,-0.59890001f,0.55650001f,-0.00930000f,0.54540001f,0.12780000f,0.02400002f,-0.28680002f,-0.34180001f,-0.24500000f,0.09150000f,-0.49469999f,-0.74969999f,-0.24390001f,-0.11510001f,0.45710001f,-0.24570000f,0.30329999f,-0.21200003f,-0.62619997f,0.84479999f,-0.69519998f,-0.19690002f,-0.83389999f,0.49649999f,0.08880001f,-1.04879998f,0.54049998f,-1.00100001f,0.74320001f,0.56080001f,-0.14590006f,0.71710000f,-0.04959999f,0.74450001f,-0.43369997f,-0.18500000f,1.08860001f,-0.09910002f,-0.19010001f,0.87849998f,-0.63960001f,-0.66659997f,-0.04870004f,-0.56249999f,-0.04479999f,-0.49959997f,-0.21209998f,-0.25180001f,0.36200001f,0.71510000f,-0.14989999f,0.00060000f,-0.16620000f,-0.13539998f,-0.69979999f,0.63890000f,0.03070002f,0.36340003f,-0.16180001f,-0.53980001f,0.06820000f,-0.02000000f,0.56000000f,-0.75060001f,-0.06299999f,-0.31390001f,-0.24770001f,-0.65550001f,0.07229998f,0.62550000f,0.15210000f,0.27329999f,0.01830001f,0.10329999f,0.28190001f,0.03920000f,-0.20839999f,0.23000000f,-0.12069998f,1.30619999f,-0.62150000f,0.19150000f,-0.06750001f,0.66559999f,-0.34900002f,0.97899998f,-0.49050000f,0.20250002f,0.88950001f,-0.80820000f,0.17119998f,-0.76389998f,0.44130002f,-1.20980001f,0.76599997f,-0.03590001f,-0.24820002f,-1.20750000f,0.73140000f,0.26489998f,0.79600002f,0.97379998f,-1.45089996f,0.01860000f,-0.36169999f,0.55049998f,-0.66749998f,-0.39170000f,0.79940003f,0.35260004f,-0.72700000f,0.49070002f,-0.23150002f,0.18990001f,0.05490000f,-0.55339999f,-0.08020002f,-0.46560001f,0.55560000f,0.00230000f,0.03010000f,0.10290000f,-0.09930000f,-0.03509999f,-0.04050000f,0.29680003f,-0.49480001f,0.10000000f,-0.08920000f,0.08940000f,-0.13980000f,0.53489999f,-0.02729999f,-0.06749999f,-0.41490000f,0.04890000f,-0.27210002f,-0.75730002f,-0.14769999f,0.99370000f,0.31469998f,0.25540002f,1.26889998f,-0.05480000f,0.52270001f,-0.96139998f,0.79079998f,-1.42389998f,0.69650000f,0.13570000f,-0.35879999f,0.74360000f,-1.15469999f,-0.61829998f,1.36099995f,1.03980003f,-0.43620003f,0.39019999f,-0.40099999f,0.34910000f,-0.23070001f,0.93719999f,-0.55790001f,0.38270001f,-0.14560003f,-0.06670001f,0.86300000f,-0.99240002f,-0.05080001f,0.21260000f,-0.24499999f,0.01970002f,-0.70730001f,0.17229999f,-0.44590001f,0.06100002f,-0.63699999f,0.51829999f,-0.23390000f,-0.05080000f,-0.26960000f,0.28670001f,-0.54590001f,0.26859999f,-0.05620000f,0.53600000f,0.50440001f,0.52039999f,0.19600002f,-0.58849998f,-0.45190000f,0.01290001f,-0.50610002f,0.71540000f,0.02620001f,0.11000003f,-0.61760001f,-0.57770000f,-1.22789999f,0.21369998f,0.63069998f,0.64710001f,0.13159996f,0.31259997f,0.73089999f,0.76650000f,-0.17050002f,1.19939998f,-0.74270001f,0.41699998f,-0.48659998f,1.20190001f,-0.71380005f,0.76620000f,-0.84440001f,0.15210000f,0.04850004f,0.67439999f,-0.49240000f,-0.18029998f,-0.24160002f,0.10850000f,0.87660000f,0.83809998f,0.04030000f,0.56830002f,0.36109998f,-0.31889999f,0.29640000f,0.06760000f,0.23840000f,0.48770002f,-0.19970000f,-0.61730002f,-0.01990000f,-0.42810000f,-0.14430001f,0.13889998f,0.62790001f,-0.24350000f,0.14629999f,0.07729999f,-0.47330001f,0.08550000f,0.46530000f,-0.62820001f,0.17460000f,0.17859999f,-0.08500001f,0.33160002f,-0.29919999f,0.26860002f,0.01939999f,0.26190000f,-0.29430001f,-0.22160000f,0.23600000f,0.39270003f,-0.68399998f,-0.25339999f,0.23659999f,0.33140001f,1.02429999f,-0.26949999f,-1.04600002f,-0.93270003f,1.20640003f,-0.43920003f,0.01050006f,0.07580003f,-1.14570000f,0.06899996f,1.06989999f,-0.64529998f,0.66899998f,-0.95459999f,0.02679999f,0.83639999f,-1.18419998f,0.10009998f,1.32330000f,-0.22080000f,1.18140003f,0.44549999f,0.35700000f,-0.92059998f,0.93059997f,1.01710000f,-0.13710001f,0.03200000f,0.14080001f,0.06739999f,0.18820000f,-0.01609999f,-0.65350000f,-0.35219999f,-0.41460000f,-0.09669999f,-0.40730001f,-0.47629998f,-0.15370000f,-0.06280000f,-0.03440000f,0.52620000f,-0.33540000f,0.40130000f,0.19629999f,0.43970000f,-0.07969998f,-0.44910000f,0.42389999f,0.27299999f,0.41820000f,0.55539999f,-0.23139999f,0.11600000f,-0.01159999f,-0.01000001f,1.24669997f,-0.53180001f,0.96500001f,0.15619999f,-0.56439998f,0.44419998f,0.36849997f,-0.01200000f,-0.04900002f,0.32910000f,-0.12280002f,-0.92639999f,1.08089997f,-0.06230000f,0.04010000f,0.95259998f,0.04279999f,0.32430000f,-0.04239997f,0.98309997f,-0.80759998f,-1.15249997f,0.42160000f,-0.22890002f,0.35890006f,1.01149997f,-0.23030000f,0.44809999f,-0.65149999f,0.66230000f,-0.25070001f,0.62010000f,-0.18090000f,0.30190000f,0.16609999f,0.48480000f,0.03000000f,0.09020001f,-0.27739999f,0.55380002f,0.38580000f,0.27040000f,-0.10480000f,0.11290000f,0.24710001f,-0.04350000f,-0.59370001f,0.64790002f,0.53290003f,0.54520001f,-0.11680000f,-0.45300000f,-0.29580000f,-0.48799999f,-0.15640001f,-0.22110001f,0.61709999f,-0.36879999f,-0.24680000f,0.53900000f,0.49769999f,0.90069999f,0.08400000f,0.35020000f,-0.30669997f,1.08009999f,-1.13389995f,-0.21370003f,1.31290000f,-0.02999999f,0.75420004f,0.27039998f,0.36320000f,0.15460001f,-0.56250000f,0.66779997f,-0.32969998f,0.05160000f,0.51590004f,0.55860000f,0.50059999f,-0.30950000f,0.08109999f,-0.43789999f,-0.02790000f,-0.47689998f,-0.86599996f,-0.45980000f,0.53939997f,1.32390001f,0.15450001f,-0.16190000f,0.09710000f,-0.69210001f,0.01170000f,-0.07680000f,-0.57840002f,-0.35760000f,0.00480000f,0.39880003f,-0.07480001f,0.10799999f,0.15480000f,0.44790002f,-0.23550000f,0.02540000f,0.30220001f,-0.67170001f,-0.32550002f,0.65880000f,0.16200002f,0.22220002f,-0.47780002f,-0.27880000f,0.20679999f,0.18540000f,0.02700001f,-0.73730003f,-0.01510000f,-0.50219999f,0.88480003f,-0.52540000f,0.51470000f,-0.90000000f,0.07949998f,0.48859998f,-0.05619999f,-0.00759999f,-0.96999999f,0.16460003f,0.88419999f,0.56030002f,-1.27770001f,0.56050000f,0.48439999f,-0.51390001f,0.56230003f,-0.46430000f,-0.10960001f,0.95069999f,-0.65410000f,0.21900000f,1.14280001f,-0.85349998f,0.68809999f,-0.20720002f,0.90780002f,-0.94880002f,0.12149998f,-0.27099999f,-0.08860000f,0.46590003f,-0.51270001f,-0.39720003f,0.41880002f,0.23660001f,0.13060000f,0.58440000f,0.28320000f,0.27270003f,-0.44190000f,-0.14420000f,-0.23380000f,-0.23040002f,0.49680001f,-0.34500003f,0.23340001f,-0.13650002f,0.19050000f,-0.14740001f,0.68380000f,0.13059999f,0.34460000f,-0.11190000f,-0.28410001f,-0.30709999f,0.06950000f,0.11210001f,-0.15530001f,-0.52050001f,-0.50420001f,1.23250002f,-0.36320001f,-1.01820004f,0.27660002f,-0.26330001f,0.95050002f,0.26870001f,0.39509999f,0.18650000f,1.27599997f,0.47899999f,-0.95559999f,-0.30830001f,-1.00789998f,-0.45920002f,-0.42340000f,0.22440002f,-1.27730003f,-0.81039998f,-0.06819998f,-0.25600001f,0.18740003f,0.51290002f,-0.83500003f,-0.62499999f,0.39790000f,-0.37970000f,1.47959998f,-1.11160000f,-0.12619999f,0.19460000f,-0.01100000f,-0.40430000f,0.13070000f,-0.78910001f,0.14830001f,0.43340001f,-0.00859999f,-0.73440000f,0.08639998f,-0.17420003f,0.23900000f,0.36350000f,-0.48950000f,0.41370003f,-0.41370001f,0.19310002f,-0.53870001f,-0.04620001f,0.13620000f,0.04099999f,0.33700000f,0.09330001f,0.03990000f,-0.27530001f,0.12770000f,-0.80760002f,-0.07440000f,-0.06370000f,1.26620000f,0.10569999f,0.32070000f,-0.75989998f,0.30059999f,-1.56460000f,0.99549997f,1.08630002f,-1.20550001f,-1.21679999f,0.50640002f,0.05359998f,-1.10539999f,1.05239998f,-0.29330002f,0.54810002f,0.79939999f,0.76480002f,-0.01610003f,-0.06340000f,-0.27680000f,-0.17990000f,-0.20969997f,-0.33760001f,0.91770001f,-0.32420001f,-0.30630000f,-1.12930001f,0.45629997f,0.15160000f,0.36290000f,0.58160002f,0.33999999f,0.07710000f,-0.22830000f,-0.60059999f,0.29460000f,-0.29570003f,0.82850001f,-0.47350003f,0.54910001f,-0.05409998f,-0.15109999f,-0.37440000f,-0.42120001f,0.28310000f,-0.21470000f,0.32570000f,-0.31490000f,-0.06280000f,-0.13160000f,0.38780000f,0.35740000f,-0.27700000f,-0.54020000f,-0.54050002f,0.01490000f,-0.65149999f,-0.08650000f,0.65250002f,-0.54909999f,0.05520002f,0.73920003f,-0.03300002f,0.77170001f,-1.39969999f,0.83210003f,-1.32890002f,0.36660004f,-1.02050001f,-0.20520001f,-0.38090000f,1.01939998f,-0.05140000f,-0.00820003f,0.80970000f,-0.56240001f,0.99249998f,-0.63699999f,-0.04670000f,0.21329999f,0.22240000f,-0.19779996f,0.45719999f,-0.61500002f,-0.13700000f,-1.20430001f,-0.90329998f,0.40759998f,0.58380001f,0.58110001f,0.42950002f,-0.49069999f,-0.55240001f,0.18880000f,-0.31850000f,-0.33670000f,0.09970000f,-0.29770000f,0.16120001f,-0.47800002f,-0.41460002f,0.59820000f,0.70080002f,-0.19680000f,0.18090001f,-0.21330000f,0.23570003f,-0.69650000f,-0.26250001f,0.10050000f,0.01579999f,0.09219999f,0.08140000f,0.77900002f,0.27720000f,0.03600000f,-0.28190000f,-0.15370000f,-0.68540000f,-1.10739996f,0.70739999f,0.65409997f,-0.94649999f,0.18550000f,0.27760000f,-0.76530003f,0.65459998f,-0.54210000f,0.25109999f,0.90550000f,-0.92940000f,-0.35119996f,1.26550001f,-0.47009999f,0.11549999f,0.69400001f,0.86400001f,0.21769997f,-0.53280000f,0.24909999f,0.24820000f,-0.70399999f,-0.79679998f,0.32300000f,0.52200001f,-0.47680001f,-0.79230001f,1.31460000f,-1.46709999f,-0.11380000f,0.30540003f,-0.03180000f,0.24290003f,-0.71090000f,-0.30989999f,-0.08969999f,0.03190001f,-0.11470000f,0.00770000f,0.08230000f,0.36400000f,-0.13000000f,-0.06280000f,0.08080000f,-0.25650000f,-0.35190001f,-0.61770003f,0.23610001f,0.16549999f,0.52570002f,0.23260001f,-0.47380001f,-0.49630000f,0.29829999f,0.20160004f,-0.77040000f,-0.32269999f,-0.56290001f,0.16410000f,0.14040000f,-0.07629999f,1.07110001f,0.70879999f,0.61209997f,-0.52529998f,0.50959997f,-0.03470000f,0.40920000f,0.03240000f,-0.22670000f,0.52469998f,0.10910000f,-0.52180000f,0.81219999f,0.00429999f,0.04220000f,-0.96980002f,-0.04230001f,-0.04790000f,-0.56559999f,0.20489999f,1.19389999f,-0.90699998f,0.01710000f,1.07510002f,-0.18530003f,0.36709999f,-0.49160000f,0.75110002f,0.32670001f,0.10120001f,-0.38200001f,0.56500000f,-0.51099999f,-0.26599999f,-0.34600000f,0.40210002f,-0.36610001f,-0.19500000f,-0.13260000f,0.28670000f,-0.26150000f,0.73620002f,0.32940001f,0.12450001f,0.00870000f,-0.17250000f,-0.39990002f,-0.06460000f,0.22300000f,-0.70720002f,-0.11360001f,-0.49349999f,-0.11130000f,0.16770000f,0.65310002f,-0.03230000f,-0.27370000f,0.09329999f,0.84599998f,0.72449998f,0.24029998f,-0.21150000f,0.35220000f,-0.11160000f,0.16680000f,0.34650000f,-0.65010001f,-0.64169999f,0.13439999f,-0.63210002f,-0.67049998f,0.40350002f,-0.33030001f,0.62250000f,0.11549998f,-0.09270001f,0.79020002f,0.65340001f,0.40949998f,0.00360000f,-0.68550000f,-0.94800004f,0.30660002f,0.34200000f,0.13379999f,-0.08040000f,0.63750001f,0.89640003f,0.52820003f,-1.03579998f,-0.55920000f,0.60150002f,0.77890004f,0.38109996f,0.66769999f,0.23520000f,-0.17600000f,0.33480003f,1.18340006f,0.79050000f,0.53230002f,-1.11909998f,-1.08670002f,0.01100001f,-0.33300000f,-0.73040001f,-0.51880004f,0.40850000f,0.52490002f,-0.15639999f,-0.79440003f,0.28259999f,0.76200002f,1.27459999f,0.75780005f,0.77720000f,0.50620002f,1.10400001f,0.74490001f,-0.67859998f,-0.88290000f,0.48930002f,-0.05850001f,0.83189998f,0.29429998f,0.06239999f,0.54960000f,0.96000004f,-0.37410000f,0.31290001f,0.28350000f,-0.72569998f,-0.22379997f,-0.36600000f,0.09300000f,-0.60000003f,-0.57420001f,0.25350002f,-0.12300000f,-0.87720002f,0.04980000f,0.41160001f,-0.41370001f,0.66360003f,0.78779998f,0.18660000f,0.16709999f,0.27060001f,0.55749998f,0.95219998f,0.62060001f,0.05789998f,0.54070002f,0.49320000f,-0.17580000f,-1.15299998f,-0.38220001f,-1.10020000f,-0.69460003f,0.46490001f,0.40710004f,0.70560000f,0.02180000f,0.84570001f,0.27010000f,-0.48210000f,-0.75190004f,-0.09890003f,0.28589999f,0.90559997f,0.75340001f,-0.68179998f,0.18700002f,-0.44969998f,-0.17650000f,-0.37939998f,0.03859999f,-0.00130001f,-0.24390001f,0.48299999f,0.49259999f,0.30750001f,-0.40680002f,-0.34560001f,0.32309999f,-0.11160000f,-0.61199998f,-0.56940001f,-0.61559999f,0.63690003f,0.53970000f,-0.09960000f,0.50130000f,0.02489999f,0.39960001f,-0.44070001f,0.18270002f,0.42149999f,-0.04020002f,0.81719999f,0.63029998f,0.43320001f,-0.41339999f,-0.34590000f,-0.54059999f,-0.07200000f,-0.48719998f,0.23130001f,-0.08250001f,1.38149999f,0.54850002f,0.17000000f,0.13420001f,0.59399997f,0.62360000f,1.06799999f,0.35880002f,-0.03699998f,-0.66320002f,-0.81070000f,-0.14970000f,-0.73679997f,-0.62580001f,-1.36100001f,-0.56340002f,-0.02480001f,0.33340001f,-1.32540000f,-0.60360002f,0.10400000f,-0.74740002f,1.27989997f,1.16290001f,0.15370000f,0.15630001f,0.64749997f,0.64190000f,-0.59249998f,-0.16140001f,0.34590000f,0.83849998f,0.18900000f,0.16950000f,0.87119998f,0.59999998f,0.12300000f,0.58199998f,-0.51000001f,0.37950003f,-0.03329999f,-0.55710000f,-0.76740000f,-0.60989998f,-0.24060001f,-0.67800001f,0.45360001f,-0.00690001f,-0.36179999f,-0.72269998f,-0.79320001f,0.31350000f,0.83189999f,0.37769997f,-0.04590000f,-0.14490000f,0.59549998f,0.30899998f,-0.91290000f,-0.25360000f,0.75580000f,0.07519999f,-0.08539997f,-0.94460001f,-0.16220000f,-0.46020002f,-1.12879998f,-0.58360001f,-1.43649997f,-0.81330002f,0.21930000f,0.27810001f,0.96669998f,0.98450003f,-0.91849996f,-1.08890000f,1.01570003f,0.57910004f,0.45349999f,0.36530000f,0.36519999f,0.25100001f,1.03189999f,0.44570003f,0.32660000f,0.31920002f,-0.31300001f,-0.57600002f,-1.01910002f,-0.90690001f,0.35399998f,0.98190000f,-0.71999999f,0.51780003f,-0.42600001f,0.05640000f,-0.29039999f,-0.49139997f,-0.81329999f,-1.02299998f,0.19950000f,0.01140000f,0.79110000f,0.31109998f,-0.81509999f,-0.13799998f,0.63750002f,0.78810002f,0.30690000f,0.21749999f,0.24660000f,0.23909999f,0.24270002f,0.55469998f,0.47460001f,0.36030000f,-0.31740000f,0.21450001f,0.08850000f,1.00980004f,0.01729999f,-0.40630001f,0.46490000f,0.22890001f,0.05259997f,-0.39060001f,0.66299999f,0.44000001f,1.28969998f,0.69550003f,0.46509996f,0.52729999f,1.22680001f,0.83020006f,0.92590000f,0.70410004f,0.23150001f,-0.30210002f,0.80390000f,0.28650002f,-0.20490000f,0.43670000f,-0.19010001f,-0.47410003f,0.80919999f,-0.07499999f,0.35290001f,-0.00470000f,-0.24099999f,0.50970000f,-0.23550001f,0.35639999f,0.53550000f,0.69120000f,-0.11160000f,0.50579999f,0.65399999f,0.69149999f,0.54570001f,0.76109998f,0.55769998f,0.27029998f,0.86040003f,0.85889999f,0.51570002f,0.38069999f,-0.60930002f,-0.02700000f,0.00810000f,0.31769998f,0.69809999f,-0.04919999f,-0.11070000f,0.40920002f,-0.22740000f,0.59609998f,0.28890000f,0.65820002f,0.60420002f,0.41680001f,-0.25509998f,-0.30929999f,0.05020002f,-0.76020001f,-0.02650001f,0.88790003f,-1.20790003f,-0.89710006f,-0.31050002f,-0.31350004f,0.36270002f,0.87450003f,-0.26640004f,-0.65000003f,-0.69149996f,-0.77069999f,-0.89979999f,-0.07900000f,1.06619998f,0.99860002f,-0.26130001f,-0.95010004f,-0.48039999f,-0.98360005f,0.29549999f,-0.16170001f,-1.06159996f,-0.86200000f,0.80640000f,-0.22200000f,-0.37649999f,-0.19829999f,-0.59280000f,0.51060002f,0.83250002f,-0.40800001f,-0.52770003f,-0.36419999f,-0.59490002f,-0.49050001f,0.65550001f,-0.23189999f,-0.27780000f,0.41279999f,-0.85409998f,-0.44999998f,-0.01380000f,-0.72239999f,0.77820000f,0.36659999f,-0.65490002f,0.43860000f,-0.83040002f,0.08880002f,-0.03150000f,0.47700000f,-0.74039998f,-0.52379998f,0.33599999f,-0.97070000f,-0.71000000f,-0.85520004f,0.31589999f,0.36770000f,0.22399998f,0.01160000f,-0.07850001f,0.25210000f,0.27079999f,0.29820001f,-1.17489998f,-0.78830003f,-0.07610000f,-0.01370000f,0.85169998f,0.10310001f,0.36140001f,-0.07560000f,1.12359997f,0.67820001f,-1.13509996f,-0.52710001f,-0.22540002f,-0.50320005f,0.99079997f,0.27500001f,0.58149999f,0.53190001f,0.93010000f,0.41190004f,-0.74160002f,-0.21300000f,0.17370000f,-0.06330001f,0.34739999f,0.58199999f,0.48449999f,0.10050000f,0.46080000f,0.32490000f,-0.42810001f,-0.38369998f,0.02070000f,-0.02580000f,0.13710000f,0.78209998f,-0.24660000f,0.16470001f,0.47039998f,0.54929997f,-0.52769999f,-0.85079997f,-0.66360003f,-0.20670000f,0.21060000f,0.73589997f,0.39269999f,0.18299999f,0.90930002f,-0.27210001f,0.82099999f,-0.00800000f,0.44120000f,0.15840000f,1.31289997f,0.89010000f,-0.55940002f,-0.94200005f,-0.12869997f,-0.82170003f,0.15979999f,-0.25740001f,0.32500001f,0.33620002f,0.61169995f,0.55349998f,0.03260002f,-0.70140004f,0.40590001f,-0.37510000f,-0.37460001f,0.09359999f,-0.44810000f,0.11749999f,-0.14899999f,0.42120000f,-0.61590000f,-0.30690001f,1.57080000f,-0.11009999f,-0.04860000f,0.70949999f,-0.02820000f,0.13560001f,0.56849999f,0.51719999f,-0.60720003f,0.20729999f,-0.95490002f,0.02790003f,-0.20460001f,0.29939999f,0.10920001f,-0.08100001f,0.74249998f,0.57509998f,-0.95760004f,-0.00720000f,-0.34950000f,0.53670000f,0.32279999f,-0.11730000f,0.27750000f,-0.27179999f,0.05820000f,-0.70049999f,-0.03090000f,-0.14070000f,0.75540002f,-0.78010006f,-0.60920000f,-0.45920002f,-0.88950000f,-0.04170000f,0.37819996f,0.32459998f,0.21499999f,0.80340001f,-0.05619996f,-0.70180001f,0.86470002f,0.96350005f,0.38910001f,-0.30130000f,-0.57030000f,-0.60350003f,-0.48690002f,0.27229999f,1.10260000f,0.42880002f,-0.13830001f,-0.71330003f,-0.94659998f,-0.64800001f,-0.40330001f,-0.76070004f,-0.95150003f,-0.06130000f,-0.38040000f,-0.56040000f,-0.37020001f,-0.29160000f,0.11250000f,-0.62550000f,0.56459999f,0.50160000f,0.69779999f,-0.21300001f,-0.59219999f,0.32640004f,0.64350002f,0.08159999f,-0.21030000f,0.56880001f,-0.62790002f,-0.33240000f,0.52410000f,-0.25920000f,0.10559999f,0.48929998f,-0.35610001f,0.53610002f,-0.54719999f,-0.51929998f,-0.64350002f,0.03810000f,0.12090001f,-0.64350002f,0.40920001f,0.47500000f,1.18270001f,0.52110002f,-0.97260003f,-0.40860003f,-0.44800000f,-0.84700004f,0.22390003f,-0.48129998f,-0.19349999f,-0.84110002f,0.63909998f,0.89650001f,0.02439999f,0.59460001f,-0.30510002f,0.24830001f,0.54530001f,0.95630006f,-0.64229997f,-0.26410000f,-0.22640000f,-0.32240002f,0.63500001f,0.82080005f,-0.68439999f,-0.34480001f,-0.73559998f,-1.13700002f,-1.10850000f,-0.31740002f,0.56490001f,0.94560001f,-0.44460002f,-0.78480002f,-0.77460002f,-0.02249999f,-0.64529998f,0.19320001f,-0.48450001f,0.53100001f,0.84569999f,0.20429998f,0.25620000f,-0.57630002f,0.14790001f,-0.48330002f,0.67290003f,-0.16710001f,-0.52290000f,-0.78689998f,-0.45480001f,-0.24120000f,0.80580003f,0.26850000f,-0.23580001f,-0.37919999f,-0.82560000f,0.08970002f,-0.38370000f,-0.95970005f,0.02729999f,-0.26430001f,-0.78159998f,-0.29060000f,-1.71799999f,-0.84960002f,1.32800002f,0.96900005f,-1.28040000f,-0.42360004f,0.34939998f,0.79460002f,0.99629998f,0.45730002f,0.27160002f,-0.47180001f,0.64460001f,0.26180002f,0.02730000f,0.16270001f,-0.06330000f,0.00869999f,-0.52970000f,-0.77110003f,-0.22070001f,0.20030000f,-1.21430002f,-0.30310001f,0.20440000f,-0.27810000f,-0.24150001f,0.14640000f,-0.20399999f,-0.51329999f,-0.56220000f,-0.94200000f,0.66060001f,0.51749999f,-0.21240001f,-0.78119998f,0.53100001f,-0.26580002f,0.52590001f,0.82589998f,-0.24360000f,0.67830003f,0.43680001f,0.69480001f,0.06630000f,-0.14310001f,-0.17490000f,-0.26940000f,-0.63810001f,-0.05609999f,0.14970000f,-0.33210001f,-0.02070000f,-0.68340001f,0.29700001f,0.29460001f,-0.05119996f,-0.78880002f,-0.25120002f,-0.52360003f,-1.49309999f,-0.79390005f,-1.21760001f,-0.68140003f,-0.84030001f,-0.07469999f,-0.63089999f,-0.75690002f,-0.12730001f,0.22290001f,0.87389999f,0.54910002f,1.04949997f,0.65590001f,-0.11880000f,-0.10860000f,0.32830001f,-0.02510001f,0.48249997f,0.77030001f,0.14479999f,0.99720003f,-0.98609998f,-0.26410001f,0.53980002f,-0.71220001f,-0.91200001f,0.09840003f,-0.30540002f,0.20640000f,-0.63510003f,-0.90179998f,-0.88800001f,-1.10430001f,-0.23609999f,-0.92640002f,-0.49710001f,-0.01019999f,0.47010001f,0.08310000f,0.47370001f,0.51719999f,0.59849999f,0.65999998f,-0.00300000f,0.05010000f,-0.28710001f,0.01290001f,0.93390000f,0.34949998f,0.88260001f,-0.35760002f,-0.01830000f,-0.52979998f,-0.41280002f,0.63950001f,0.44490000f,-0.31730000f,-0.92549999f,-0.21830001f,0.38079999f,0.79760003f,0.70309997f,0.57970000f,-0.05300001f,-0.51720003f,-0.70930001f,0.01849998f,1.29860001f,0.44800002f,-0.08650001f,-0.47170003f,0.65780001f,0.14460001f,-0.55509999f,-0.24010000f,0.41900000f,0.52940002f,-0.70049995f,-0.63790000f,0.62230001f,0.36010003f,-1.09810001f,-0.98690004f,-1.54569999f,-0.73080002f,-0.08790000f,0.78269999f,-0.14550000f,-0.68699999f,0.85980001f,0.13139999f,0.57989999f,0.43529998f,-0.19080001f,0.50850001f,-0.20190001f,-0.90690000f,0.29520000f,0.85530000f,-0.29550001f,0.29100000f,0.41760000f,0.86040001f,-0.18030000f,-0.35430000f,0.35940001f,-0.00000000f,-0.91110000f,-0.72149998f,0.20010001f,0.25890000f,-0.62430001f,-0.23879999f,-0.56610002f,-0.06810000f,-0.32459998f,-0.87080003f,0.41439999f,-0.17040001f,-0.64309998f,-0.35990000f,-0.14870000f,-0.28030001f,0.09870000f,0.14530000f,0.45989999f,-0.04210000f,-0.67669999f,-0.69810001f,-0.07170002f,0.14389999f,-0.88720002f,-0.05240000f,0.18160001f,0.20380002f,-0.16290001f,-0.75730002f,-0.82809998f,-0.13550000f,0.94080001f,0.50980001f,0.36259997f,0.68240000f,1.03700002f,0.26130000f,-0.72480002f,0.18270002f,0.17939999f,0.83820000f,-0.16530000f,-0.23879999f,-0.16530001f,0.09540000f,0.06870000f,-0.04890000f,-0.04530000f,0.43319999f,-0.56850000f,-0.22109999f,0.34770000f,0.11339999f,-0.02699999f,-0.76560002f,-0.14760000f,-0.30570001f,-0.39450000f,0.53580001f,-0.14970000f,-0.72629998f,0.74579999f,0.94590001f,0.88739999f,0.31829999f,0.74820003f,0.79380001f,0.67380000f,0.50460002f,1.39729996f,0.63530001f,-0.44939999f,-0.30140000f,0.55260001f,-0.08960000f,0.06749999f,0.31790000f,0.87189999f,0.52070002f,0.20420004f,-0.71360001f,-0.72530000f,-1.07110005f,-0.10530001f,-0.04470000f,-0.10939999f,0.06120000f,-0.65680003f,0.21080000f,-1.08499998f,-0.63380001f,-0.35659997f,-0.40220000f,0.47869997f,0.51430000f,-0.43590000f,0.14070000f,0.91079999f,1.24109996f,-0.15989998f,-0.07970001f,0.08940000f,0.11859999f,1.28759997f,1.09549998f,0.02370006f,-0.14509997f,-0.45300005f,-0.94710002f,0.46560000f,0.45330002f,0.76859999f,1.01409998f,-1.22489997f,-0.88589999f,0.33660001f,0.73049999f,0.95339998f,0.63549999f,-1.28130000f,-1.44670002f,0.80340001f,0.95719999f,-0.62729999f,-0.36620001f,1.31130002f,-0.10680001f,0.50970001f,0.50080000f,-0.86800003f,0.33900000f,-0.14449998f,-0.19640000f,0.22959999f,-0.49599999f,-0.74470003f,0.51519999f,-0.81430001f,0.06959999f,1.29830002f,-0.27420001f,0.03249999f,-0.06900000f,0.39340003f,0.30880000f,-0.68470000f,0.32939999f,0.16540000f,-0.06720000f,-0.77959999f,0.57579999f,-0.95450002f,-0.26939999f,-0.93020002f,0.20260000f,-1.17220004f,0.49490000f,0.71459999f,0.08010001f,0.92130002f,1.04160002f,-0.18780001f,0.23489999f,-0.97919998f,-0.69519998f,1.31579999f,1.45570002f,0.36599999f,0.58589998f,-0.93510003f,-1.25810000f,-0.20549998f,-0.28849999f,0.38999999f,-0.07620002f,0.81989998f,0.83289999f,-0.32519998f,-0.60260001f,1.33709998f,1.26699998f,-0.18209996f,0.39130003f,0.62010002f,0.73880000f,0.54150006f,0.20499999f,-0.81280001f,-0.09320000f,-0.46059998f,0.45960000f,-0.42750002f,-0.07679999f,1.02870000f,0.09260000f,0.89020003f,0.16040000f,-0.03970003f,-0.41119999f,-0.52130001f,-0.18480000f,-0.81220001f,-0.00840002f,0.82840003f,-0.41940001f,0.15580002f,-0.03999999f,-0.56190000f,-0.29759999f,0.61929999f,0.07260000f,0.05389999f,0.39700000f,0.04170000f,0.35219998f,-0.42360001f,0.59279997f,0.08820001f,0.46479999f,1.02839999f,0.93360000f,-0.11699996f,-0.09750000f,-0.06750003f,-0.36509999f,0.00659997f,-0.45540002f,-0.65399997f,-0.18189996f,-0.25619998f,-0.07050001f,0.16439999f,0.33839997f,-1.05630003f,-1.10280003f,-0.03180000f,0.10000001f,-0.29219997f,0.27130001f,0.08369998f,0.05750003f,0.67769999f,0.30670000f,0.64589996f,0.39469998f,1.04010002f,0.23080000f,-1.09790002f,-0.24519999f,-0.04860000f,-0.11580000f,-0.13500001f,-0.42999998f,-0.93490002f,-0.10419999f,0.37660000f,-0.40220002f,0.59940001f,0.20300001f,0.34480000f,0.35859999f,1.24580002f,0.06840002f,0.08670001f,-0.04120000f,1.13310003f,0.14639999f,0.06890000f,-0.23280000f,-1.36010000f,0.17760000f,-0.37650001f,0.24520000f,-0.54519999f,-0.05560000f,0.63680000f,0.25939999f,-0.16379996f,0.31910001f,-0.17430000f,-0.03080000f,-0.62579997f,-0.04659998f,0.02730006f,0.31730002f,-0.93870002f,-0.92920002f,0.24929999f,-0.00659999f,0.46409998f,-0.07820001f,-0.18420000f,-0.55179997f,-0.01320000f,0.14350001f,-0.03420005f,-0.46770001f,-0.60299998f,-0.73070001f,0.78480001f,1.21489998f,0.53820000f,0.44490000f,0.12240000f,0.45939999f,-0.53699999f,0.69460001f,-0.04460002f,-0.73099999f,0.56129999f,-0.56500001f,0.23810000f,-0.11340000f,1.09420001f,-0.01520001f,0.92920001f,0.45959999f,-0.28030000f,0.08540000f,-0.98010001f,0.09240000f,1.08429998f,-0.25859999f,-0.58280004f,-0.40220001f,-0.39480000f,-0.03140000f,-0.25260000f,-0.09660000f,-0.89530002f,-0.10199999f,-0.04370002f,-0.26999999f,0.63190002f,-0.37680000f,0.82330002f,0.58960001f,-1.31189997f,-0.73199999f,-1.32629999f,-1.32050000f,-0.34530000f,-0.46090001f,-0.31920004f,-0.62100000f,0.52079997f,-0.21500000f,0.25950000f,0.32690000f,0.53340001f,0.92810000f,-0.87569998f,-1.19529996f,-0.51929999f,0.05480001f,0.08250000f,0.28039999f,-0.08309999f,0.10760000f,0.04500005f,0.36490002f,-0.41519998f,-0.08329998f,-0.91020001f,-0.90410001f,0.19260000f,0.05139999f,0.30940000f,-0.36999998f,0.10229998f,-0.57219999f,0.42690002f,-0.52819999f,-0.16900002f,-0.47899999f,-1.01870001f,-0.22239999f,-0.32559998f,-0.10420000f,-0.78750004f,-0.38919999f,-0.88500002f,0.01540000f,-0.44040000f,0.19879999f,-0.83760002f,0.06260001f,0.33530000f,-0.10700000f,0.67950002f,-0.54660001f,-0.59060002f,-0.22659999f,0.19919998f,-0.57400000f,0.15129999f,0.96459999f,-0.81239996f,-0.71999998f,-1.00889998f,-0.49769998f,-1.11509998f,-0.90689999f,-0.75149997f,-0.20599998f,-0.10079996f,0.41750001f,-0.02430001f,0.28719998f,-0.40919996f,0.27010003f,0.31590002f,0.64980001f,0.36000000f,0.12419997f,0.30150005f,0.43080002f,-0.14670002f,0.08170000f,-1.20450002f,-1.03450002f,-0.34409995f,-0.16039999f,-1.07880000f,-0.66619999f,0.31859999f,0.35039999f,0.11839999f,0.11860000f,0.37389998f,-0.49660000f,-0.27270000f,0.37540000f,1.30850006f,-0.17940001f,-0.12809996f,0.43319999f,-0.67850002f,0.39519999f,0.77230004f,-0.57699999f,0.43169998f,0.21060000f,0.56180001f,0.33960000f,-1.06900000f,0.08319999f,0.74320001f,-0.57319999f,0.68020002f,-0.28280001f,0.05610001f,-0.37620000f,0.90639999f,0.09160000f,-0.13670002f,0.75399999f,0.12990000f,-0.09039999f,-1.13249998f,-1.09069999f,0.92489999f,1.01690002f,-0.72090005f,-1.04030003f,0.73979997f,0.30089995f,1.01759997f,1.11969999f,-1.31309999f,-1.19710000f,0.14850001f,-0.34709998f,0.52019997f,0.19300000f,0.53279999f,0.94659998f,-1.36919997f,-1.37300000f,-0.83700002f,-1.06660003f,-0.73169999f,-0.51870000f,-0.15900000f,-0.63719998f,-1.20839997f,-0.48240001f,0.71520002f,-0.07240000f,-0.49979999f,0.22100000f,0.31530000f,-0.56059998f,0.27820000f,-0.19139999f,-0.00090000f,-0.25840000f,1.25350000f,-0.14840000f,0.08640000f,-0.01240000f,-0.41540001f,-0.44099999f,-0.38610000f,0.02359999f,-1.00450001f,-0.06639999f,0.70550000f,0.40139999f,0.03020004f,0.16619999f,-0.65460000f,-0.32299999f,-0.60440000f,0.06680000f,-1.01360002f,-1.24689999f,-0.42900000f,-0.76760001f,0.55949999f,0.57739999f,-1.06769997f,-0.66729998f,-0.33390000f,-0.11139999f,-0.40500000f,-0.09329999f,-0.63180001f,-0.92709999f,-0.03840000f,-0.04100000f,-0.72149995f,-0.31979998f,0.08279999f,0.06389998f,0.17820004f,0.57190000f,0.51149996f,-0.05050001f,0.18629997f,-0.14000005f,-0.43229996f,-0.03279999f,0.33000001f,0.53620000f,0.71880002f,-0.16480000f,-0.46890001f,-0.36119999f,-0.50349999f,0.08019998f,-1.29879999f,0.05999999f,0.94420002f,-0.47379998f,0.09300000f,-0.02220002f,0.04880001f,-0.23479999f,-0.53930002f,0.25060000f,-0.20249996f,-0.38280000f,-0.17670001f,0.10100000f,-0.08320001f,-0.36020000f,0.46340001f,-0.08940000f,0.40600001f,0.04839999f,-0.49329999f,0.69959998f,0.74360000f,-0.16059999f,-1.47980002f,-0.49930000f,-0.59279997f,-0.29090000f,0.25589998f,0.29629997f,0.49979999f,0.90499996f,-1.21529998f,-1.30520000f,-0.23850002f,-0.55500004f,-0.49379998f,-0.42400000f,0.61230002f,0.59850001f,-0.54540001f,-0.02430002f,0.05310002f,-0.28770002f,-0.72989997f,-0.60319999f,-0.21030002f,-0.14080000f,0.05519997f,0.03539999f,1.44479995f,1.12549997f,-0.47129999f,-0.52839998f,0.45090001f,0.08340000f,0.53630001f,0.03820000f,0.66210001f,0.22680001f,0.03760003f,-0.40800001f,-0.44000000f,0.29400000f,0.33959998f,-0.34640001f,-1.08600004f,0.30720000f,-0.00830001f,-0.41580000f,0.40540002f,0.12440000f,0.50650003f,-0.00540001f,-1.08200003f,0.01860001f,0.70300002f,-0.64180001f,0.76920000f,0.13099999f,0.54060002f,-0.20100000f,0.73450003f,0.21400001f,0.56780002f,-0.61430002f,-0.11190001f,-0.36270000f,0.30779999f,0.07230001f,-0.67800002f,-0.24680002f,0.78179998f,0.91359999f,-0.84000001f,-0.88480001f,0.93660002f,1.17020002f,-0.82589998f,-0.63390000f,0.03239999f,-0.33040002f,-0.02310004f,0.05129999f,0.28890006f,0.52580002f,-1.43550002f,-1.29100002f,-0.01890002f,-0.43140000f,-0.61710000f,-0.80900001f,0.26939999f,0.03030002f,-0.41160004f,0.19600001f,-0.67270002f,-0.48540001f,0.54840004f,0.40560001f,0.52660001f,-0.14620000f,-0.20880003f,-0.04800000f,0.76129999f,-0.65459999f,-0.60820000f,0.03700000f,-0.59199999f,0.63540000f,-0.03379999f,0.36900001f,-0.87430003f,0.41640000f,0.05820000f,0.58579999f,0.02300002f,0.18759999f,-0.54170003f,-0.03360000f,0.57270000f,0.08620000f,1.05110001f,-0.41680000f,0.74090002f,0.49180001f,-0.67109999f,-0.05110000f,0.56879999f,0.06239999f,-0.53430000f,-0.80040002f,-0.16499997f,-0.30459998f,-1.49609997f,-1.39709998f,0.35790000f,0.73140000f,1.38089999f,1.18579999f,0.73470001f,0.55980001f,1.10340001f,1.23670003f,1.00229997f,0.45499999f,0.26699999f,-0.00300002f,0.20220000f,0.59350002f,-0.00390002f,-0.24790000f,-1.17060000f,-1.38850000f,0.41999997f,-0.21819999f,0.07940000f,-0.13000000f,0.58030000f,0.18280000f,1.45150002f,0.20300001f,-1.30860005f,0.06020000f,1.02720004f,0.22319998f,-0.70979999f,0.43600000f,-0.53030001f,-0.44559999f,0.26949998f,-0.59640001f,-0.16670003f,-0.47500000f,-0.17740000f,0.16860000f,-0.20619999f,0.28159999f,0.62790001f,-0.16200000f,-0.00109999f,0.24400000f,1.05600002f,0.13320001f,-0.19230000f,-1.10700000f,-0.30839999f,-0.32200000f,0.18359998f,-0.11169999f,-0.03270001f,-0.62989998f,0.51930004f,0.95640002f,0.16199993f,-0.24960004f,1.07880000f,1.12100000f,-0.63359996f,-0.07929998f,-1.23480000f,-0.99610000f,-0.78449998f,-0.31289998f,0.37050000f,0.32220000f,0.54659998f,0.35479998f,-0.56100000f,-0.79270001f,0.49080000f,0.38790000f,0.02039999f,-0.27819998f,0.11730000f,0.53500000f,0.05839999f,-0.06400002f,0.53570002f,-0.33660000f,1.15780003f,0.28079999f,0.51970004f,0.67000000f,0.23870001f,0.61580001f,0.83929999f,-0.27699999f,0.32920000f,-0.19620000f,-0.67550001f,-0.16060000f,-0.76770000f,-0.23859999f,0.22280000f,-0.11740000f,-0.49860000f,0.17899998f,-0.22180000f,-0.21339999f,-0.46270000f,0.40420000f,0.88310000f,0.08020000f,-0.39890002f,0.76430000f,-0.30240001f,-0.57200003f,-0.81090000f,-0.80690001f,0.16499994f,-0.44640003f,0.99479998f,0.18449998f,1.07310000f,0.56510002f,-0.79889998f,-0.95469998f,-0.35670001f,-0.14599998f,-0.07109998f,0.31730001f,-0.17609998f,0.31990000f,-0.27149999f,-0.24339999f,0.39449998f,0.28779997f,-0.18449999f,0.29740001f,1.02989999f,1.15790001f,-0.04230002f,-0.27289999f,-0.29609999f,0.74939999f,0.14529998f,-0.63519998f,0.61840001f,0.29720000f,-0.30710001f,-0.01699999f,-0.49850000f,-0.16639999f,0.57240002f,-0.57980001f,0.07340004f,0.65939998f,-0.96720003f,-0.30300000f,0.38510002f,-0.34620000f,-0.01890003f,-0.65139999f,0.41810000f,0.12120000f,-0.56060000f,0.18919999f,0.15979997f,0.51340000f,-0.61040002f,0.01860000f,1.26550003f,-0.25460000f,1.18260003f,1.33589998f,-1.25279995f,-0.91449997f,0.40319997f,0.04820000f,0.19290001f,0.54510002f,-0.10079999f,0.29090000f,-1.25910001f,-1.07340001f,1.19789995f,0.70659996f,-0.31109998f,0.16540000f,-0.79470000f,-0.75170001f,-1.15469998f,-0.60869998f,0.10619999f,-0.11089999f,0.54659999f,0.65699999f,0.77130001f,0.12220001f,0.20430002f,0.37880001f,-0.87210002f,-1.16770001f,0.23459995f,-0.17540000f,0.56419999f,-0.31500001f,0.28029999f,-0.73419999f,0.66549998f,-0.05459999f,0.29170000f,-0.17060000f,-0.18410000f,0.10040000f,-0.22840000f,-0.24079999f,0.68080000f,-0.05980000f,0.26410002f,-0.19140000f,0.49770002f,0.39540001f,-0.59430002f,0.44720000f,0.73340002f,-0.65120000f,0.43670000f,0.39199999f,-0.29920003f,-0.62580000f,-0.08609999f,-0.23720000f,-1.15850005f,-0.21980000f,-0.85350000f,-1.00560001f,-1.42049997f,-0.95989998f,-0.27809999f,-0.42969998f,-0.41729999f,-0.42270000f,0.24300000f,0.23930000f,-0.41579997f,-0.23539999f,-0.36570000f,-0.64879999f,-0.35610001f,-0.17550001f,0.63749999f,0.28390002f,0.94980002f,0.74050001f,-1.46699999f,-1.33520000f,0.62159996f,0.24209999f,-0.98489998f,-0.29219999f,-0.26760002f,0.18709999f,0.78720004f,0.49139999f,-0.38840001f,-0.25640000f,-0.87180000f,-0.49159999f,0.69239999f,-0.27919999f,-0.10530001f,-0.46880001f,-0.06140000f,0.01680000f,-0.62950001f,-0.20859999f,-0.14820003f,-0.10740000f,0.89910003f,-0.26400000f,0.38970002f,-0.30120001f,-0.10580000f,0.22820000f,0.49600004f,0.17720000f,1.10230000f,-0.07259999f,-0.08210002f,0.42660000f,-0.32809999f,-0.11660000f,0.04950000f,0.12200000f,0.00210000f,0.78569998f,-0.22630000f,0.14300000f,-0.14380000f,0.22839999f,0.20770000f,0.69369999f,-0.33129999f,0.31680002f,0.15590000f,-0.65710001f,0.23470001f,0.09950001f,0.04870000f,0.60329999f,-0.18450001f,-0.62619999f,0.00210000f,0.37169999f,0.14990000f,0.46430000f,-0.28710001f,-0.71380001f,-0.08120000f,0.73900000f,-0.22100000f,-0.16030001f,0.13800000f,0.93240003f,-0.26410001f,-1.10040001f,-0.67900000f,0.09380002f,-0.25229997f,0.47050000f,0.58639999f,0.57760000f,-1.20889997f,-0.17019996f,-0.22449999f,0.42290002f,0.71029999f,-0.47079999f,0.31449998f,0.03249999f,-0.05579999f,-0.74840003f,-0.53349999f,-0.03099998f,0.62019998f,-0.11360002f,-0.94379998f,-0.30530000f,0.00669997f,1.03270001f,-0.30960001f,0.28630000f,-0.24400003f,0.51870000f,0.01410001f,0.33130001f,0.04940000f,0.67970002f,0.23230000f,-0.25870000f,-0.05200000f,-0.59759999f,0.31810000f,0.69930001f,-0.08110000f,0.42889998f,-0.00590000f,-0.79780002f,-0.15450000f,-0.01699999f,-0.04100000f,0.19580000f,0.00430001f,0.61819999f,-0.31860000f,0.00700000f,0.10980001f,0.87169999f,-0.07709999f,0.11860000f,-0.12520000f,0.63650000f,-0.18040000f,-0.15340000f,-0.11959999f,0.67520000f,-0.75219999f,-0.34210001f,0.34589997f,0.31859999f,-0.12649998f,-0.75510000f,0.08060001f,-0.82760002f,0.13929999f,0.68930002f,0.33969998f,0.55900000f,0.05540001f,0.49610002f,0.75580001f,0.05020000f,-0.22179999f,0.01809998f,-0.08130000f,0.85980000f,-0.40909997f,-0.41509998f,-0.30290000f,-0.64060000f,-0.41429997f,-0.53489998f,-0.73060001f,0.15389999f,-0.05960000f,0.24420000f,0.12380001f,0.61640000f,-0.27510000f,0.20850001f,0.26489999f,-0.42159999f,0.06580000f,-0.20520001f,0.12390000f,-0.48089999f,-0.23450000f,0.11109999f,-0.21580000f,0.40519998f,-0.06380000f,-0.74390002f,0.19740000f,-0.19260000f,0.08330000f,-0.13709999f,0.36109999f,-0.32659998f,-0.00950000f,0.40860001f,0.08229999f,0.32399999f,0.10900001f,-0.20050001f,0.18349997f,1.04290000f,0.03600000f,0.21750000f,0.02500001f,0.80220000f,0.12749996f,0.71749999f,0.81000000f,0.28450002f,-0.28639999f,-0.64800001f,-0.01260000f,-0.81170000f,-0.03100000f,-0.86560003f,-0.23509999f,0.06480000f,-0.04829998f,-0.92520000f,0.78949996f,0.18979998f,-0.64669999f,0.65830000f,-0.26110000f,-0.13170000f,-0.25799998f,0.47749999f,0.67799997f,0.41340000f,-0.23470000f,0.27150000f,0.02840000f,-0.11790000f,0.18459999f,-0.49119998f,-0.23790000f,0.36040001f,-0.21040001f,-0.48310002f,0.20880000f,-0.11049999f,-0.10620000f,0.29750000f,0.26700000f,-0.53319998f,0.19070000f,-0.16390000f,0.21030000f,-0.38010001f,-0.35870000f,-0.11470001f,0.00350000f,0.71949999f,-0.05250000f,0.43330000f,0.06880000f,0.12220000f,-0.21840000f,-1.06630002f,0.72960000f,1.11130001f,1.13769997f,0.38010001f,0.39409999f,-0.03370001f,0.11940002f,-0.66319999f,-0.15799999f,-1.30730000f,-0.21390000f,0.06980000f,-0.53909999f,0.54930001f,0.76149997f,-0.37760000f,0.16740000f,0.99820004f,-0.12100000f,0.31740000f,-0.00960000f,0.31830000f,0.04729996f,0.70610000f,0.05770000f,0.47020001f,0.63850000f,0.12160000f,-0.35770000f,0.75210002f,-0.07880001f,-0.73029999f,-0.28810000f,-0.69460001f,-0.13410000f,-0.15400000f,0.18220000f,-0.52540001f,0.06480000f,0.10060000f,0.02550000f,0.18940000f,0.06790000f,0.45090000f,-0.09550000f,-0.65719998f,-0.02260000f,-0.19330000f,0.00340000f,0.11890000f,0.00040000f,-0.00510000f,-0.17929999f,0.32090001f,0.09870000f,-0.31669999f,-0.05730000f,-0.62450002f,0.31370000f,0.77350003f,0.60259997f,0.31329998f,0.40030000f,0.82140002f,0.72169998f,0.48449998f,0.22600000f,0.86450001f,0.02389997f,0.98890000f,-0.18779998f,0.41179999f,0.02709998f,1.12920003f,-0.27520001f,0.56760001f,0.15399999f,-0.09930001f,-0.02420004f,0.40799999f,-0.32029996f,0.04220002f,0.72630001f,0.36120001f,0.47839995f,0.64329998f,0.54880001f,0.73530002f,-0.55049998f,0.57469998f,-0.11180000f,-0.46679999f,0.07769999f,-0.68799999f,-0.07529999f,-0.69860001f,0.07599999f,-0.48149999f,-0.12789999f,0.21690000f,0.10060000f,-0.02990001f,0.01250001f,-0.11529999f,-0.03599999f,0.37810000f,-0.30480000f,0.52219999f,-0.20940000f,0.48830002f,0.33669999f,-0.39719999f,-0.01070000f,-0.84600003f,-0.31559999f,0.12990001f,0.00679999f,-0.69580000f,0.31490000f,-0.16319999f,0.07179999f,-0.28660000f,0.98389997f,0.40990000f,-0.98349998f,-0.26699999f,0.46370003f,-0.58660003f,-0.18149999f,-0.61590003f,-0.86909997f,-0.07729996f,0.86269998f,0.32829997f,0.22649997f,-0.66360000f,-0.47259998f,-0.81760000f,-0.51259998f,0.61340002f,1.09439997f,0.29229997f,0.83220000f,-0.10580000f,0.50249999f,0.49800000f,0.27479998f,-0.76100000f,0.68829999f,0.57239999f,-0.08220000f,0.11790000f,-0.27030000f,-0.55620000f,0.35830000f,0.34720001f,0.10150000f,-0.74860002f,-0.14730000f,0.58049998f,0.18270000f,0.60590000f,-0.05949999f,-0.89280002f,-0.15810000f,0.12840001f,0.24460000f,0.03440000f,0.03580000f,0.49019998f,-0.21480000f,-0.80740000f,-0.21940001f,-0.46960002f,-0.10290000f,-0.37860001f,-0.01640000f,-0.24819999f,-0.09830001f,0.25630003f,0.50199999f,-0.41460002f,-0.35719999f,0.00360000f,0.48649999f,0.65489999f,-0.07399998f,0.16900000f,0.04810001f,0.42660001f,0.36570001f,-0.58550000f,-0.00320000f,-0.03090000f,0.51639996f,0.89079999f,0.15130000f,0.16380001f,-0.13230001f,0.74899998f,-0.24369998f,-1.05579999f,0.19520001f,-0.33850002f,0.33559997f,0.87389998f,-0.28599999f,0.31270000f,-0.71680000f,-0.60350000f,-0.11560000f,-0.30460000f,-0.00680000f,0.43489999f,0.06550000f,-0.75319999f,0.21319999f,-0.40969999f,0.10830000f,-0.32530000f,0.13429999f,-0.70869999f,0.02840000f,-0.05980000f,-0.18439999f,-0.22730000f,-0.19650000f,0.26449998f,-0.10970000f,0.37030001f,0.09930000f,0.11000000f,-0.20600000f,0.25909997f,-0.18799999f,-0.00590000f,0.00720000f,0.30420000f,0.12840000f,-0.17470000f,0.53249997f,0.78539999f,-0.04909999f,0.18050001f,-0.33519998f,0.75590001f,0.92119998f,0.03789996f,0.61559999f,-0.14460000f,0.42759998f,0.27919998f,-0.35250001f,-0.02330000f,0.04890003f,0.75869999f,0.47769998f,-0.16050002f,0.68979997f,0.51740000f,-0.11919998f,-0.10630000f,-0.26519997f,-0.27409999f,-0.90549997f,-0.69579998f,0.17220000f,-0.21580001f,-0.35440001f,-0.50870001f,-0.24970000f,-0.09150000f,-0.12690000f,0.33959997f,-0.11640000f,0.62359997f,-0.11280001f,-0.82529999f,-0.35640001f,0.10049998f,-0.13320000f,-0.21060000f,-0.03470000f,0.49460001f,0.12870000f,-0.38910002f,-0.39690001f,0.35600001f,-0.26180000f,-0.23550000f,0.22920000f,-0.37990000f,0.23439999f,-0.21220000f,0.08430000f,0.90409998f,0.14700000f,-0.52849998f,-0.11079999f,-0.78340004f,0.14110000f,-0.41890001f,-0.41249998f,-0.70050001f,0.17440003f,0.62980000f,-0.78199997f,-0.06919999f,0.79159999f,0.21660003f,-0.71760001f,0.28770002f,0.66969998f,0.56980000f,0.19940000f,-0.49670002f,-0.35629996f,-0.22579999f,-0.00980003f,0.62769999f,1.00040000f,0.45160000f,0.11380000f,-0.71130000f,0.62039999f,-0.11580002f,-0.40649999f,-0.72410003f,-0.04779997f,-0.32440001f,0.01250000f,-0.17400000f,0.29010000f,-0.14609999f,0.11760000f,-0.50480002f,0.23639999f,0.38020000f,-0.23720001f,-0.39680001f,0.04120000f,0.73440001f,-0.20210000f,-0.35120000f,-0.10060000f,0.02040000f,0.34390000f,-0.35840001f,-0.25060000f,0.55510002f,-0.12760000f,-0.90450003f,0.03300000f,-0.17470000f,-0.16120000f,-0.35370001f,0.30970001f,-0.19689999f,0.26300000f,-0.25140001f,0.32690000f,1.16060004f,-0.28920000f,-0.95820005f,0.63199999f,-0.20210002f,0.47879995f,0.11010000f,1.09249998f,0.41899999f,-0.52879998f,0.41480001f,-0.93819999f,-0.52090001f,-0.56720000f,-0.48620002f,-0.89290000f,0.01070002f,-0.43759999f,-0.93419999f,0.03820000f,-0.33820001f,-0.41749999f,0.47080003f,-0.00729999f,-0.49170000f,0.97529998f,-0.13420000f,-0.26049999f,0.05740001f,-0.09930000f,-0.21280001f,0.09000000f,0.18000000f,-0.20120000f,-0.27150001f,-0.32479999f,0.17640000f,-0.16570000f,-0.92379999f,0.17600000f,0.19770000f,0.11700000f,0.85910001f,0.15280001f,0.33970001f,0.14170001f,0.72350001f,-0.02480000f,0.61610000f,-0.11980000f,0.24599999f,0.15870000f,0.10390000f,0.08889999f,-0.17120000f,-0.15330000f,-0.78770001f,0.14930000f,-0.50460003f,0.31259999f,0.10729999f,-0.15269999f,-0.62960000f,-0.02050000f,-1.21970003f,-0.39200001f,0.77310003f,-0.23279995f,-0.95280000f,-0.84219999f,-0.13260001f,0.28909998f,1.01470000f,0.90369999f,0.65800002f,0.35570000f,0.82990002f,-0.24640000f,-0.12640000f,-0.24059999f,-0.30070000f,0.56009999f,-0.22230002f,-0.40889999f,-0.32750001f,-0.23759999f,-0.81750002f,-0.18470000f,-0.73749999f,-0.10980000f,-0.12080000f,0.13070000f,-0.08949999f,0.23490000f,-0.45479998f,-0.08280000f,0.61250002f,0.26159999f,-0.27960002f,0.13660001f,0.68260000f,-0.06429999f,-0.24150000f,-0.18970001f,-0.65870001f,-0.00770000f,-0.44040000f,0.02480000f,0.23870000f,-0.04620000f,0.40299999f,-0.12410000f,-0.36270000f,0.12730000f,0.20450001f,0.31960000f,-0.41339999f,0.06710000f,-0.73150000f,0.64559999f,-0.05919999f,0.58610000f,0.12289998f,-0.05419996f,-1.16570001f,-0.35370000f,-1.37360004f,-0.66810001f,-1.04740003f,0.60569999f,-0.16600001f,-0.06259999f,0.14380001f,-0.03670001f,0.68860001f,-0.00650000f,0.87000000f,0.13740000f,0.03470000f,-0.01640000f,0.00420001f,-0.28799998f,0.55340000f,-1.03789997f,-0.18909999f,-0.15769998f,-0.63939999f,0.49509999f,0.48900000f,-0.36080000f,0.07119998f,-0.06770000f,-0.53920001f,0.14739999f,-0.21740001f,-0.01789999f,0.52310000f,0.14610001f,0.50080002f,-0.04290001f,-0.60499998f,0.22020000f,-0.43790000f,-0.04450000f,0.11160000f,-0.04270000f,0.06320000f,0.02700000f,-0.22489999f,-0.19960000f,0.47629998f,0.24640000f,-0.25309999f,0.33390000f,0.46320001f,0.25809999f,-0.37499999f,-0.31750001f,-0.68360001f,0.86629997f,0.80649999f,-0.33999998f,-0.80750000f,-0.48989999f,0.31510001f,-0.10830000f,0.60550000f,0.82700000f,0.46170000f,-0.73359997f,-1.00720001f,0.28019999f,1.04130002f,0.60349999f,0.22699999f,0.58510000f,0.99090002f,-0.07570000f,-0.44290001f,-0.42699999f,0.10840001f,-0.11000002f,-0.94060000f,-0.10340001f,0.36040001f,0.62430000f,-0.46640002f,-0.14139996f,0.96280000f,-0.17350000f,-0.65909999f,0.19640000f,-0.01140000f,0.24910000f,-0.01059999f,0.04430000f,-0.00370000f,-0.08100000f,-0.80810002f,0.12640000f,0.62089998f,-0.23500000f,0.15870000f,-0.10790000f,-0.47260001f,-0.02430001f,-0.67959999f,0.07810000f,-0.06849999f,0.04060000f,0.40319999f,-0.17000000f,0.56430002f,-0.08380000f,0.29590001f,0.03050000f,-0.78040001f,0.19059999f,0.27640000f,0.81679999f,0.02210000f,0.81829999f,0.90130000f,0.12430000f,-0.33740000f,0.30210000f,0.04899999f,-0.15910000f,-0.02510000f,0.35679998f,0.47209999f,0.38059999f,-0.39020001f,0.01210002f,0.16000000f,-0.53190000f,-0.86070002f,-0.44330002f,-0.30300001f,1.03419998f,0.44209999f,-0.44669997f,-0.83529999f,0.36860001f,1.16210003f,-0.23829997f,0.50100001f,-0.65150001f,-0.13210000f,-0.21880001f,-0.45910000f,-0.05910001f,-0.86940000f,0.10249999f,-0.36439998f,-0.03290000f,-0.28180000f,0.00470000f,0.17730000f,-0.14840000f,-0.10200000f,-0.05340000f,-0.30569999f,0.15550000f,-0.37820001f,0.23750001f,0.12240001f,-0.09550000f,0.75410002f,-0.13700000f,-0.92220001f,0.17150000f,0.17230000f,0.03499999f,-0.56949999f,0.25870000f,-0.33710001f,0.03510000f,-0.16049999f,0.00960000f,0.66640001f,0.30859998f,1.29569998f,0.30920000f,-0.01260000f,0.59570000f,0.73320002f,-0.23899998f,0.05770001f,0.02129999f,0.72980000f,0.69839997f,0.12870001f,0.81090000f,-0.26610002f,0.23190001f,0.22410001f,-0.25479999f,-0.26870000f,-0.49959997f,-0.49820001f,0.21550000f,-0.59090000f,-0.12170002f,-0.64490001f,-0.16409998f,0.42940000f,-0.08430001f,0.98709999f,-1.01190001f,-0.69909996f,1.47810004f,-0.13279998f,-0.63420002f,0.11539999f,0.54450003f,1.43660001f,1.25100000f,0.26299995f,0.67080000f,-0.94719998f,-0.20729996f,-1.19299997f,0.09240004f,-1.96389995f,-0.38610000f,0.12790002f,-0.78180001f,-0.02790003f,0.15330003f,-0.41050003f,0.78750001f,0.66630002f,1.16460000f,-0.03500007f,-0.79680002f,-0.04389999f,-0.99000002f,-1.07200002f,0.20559999f,-0.31270000f,0.06739999f,-0.67039997f,-0.14370000f,0.57679998f,-0.38209999f,0.01020000f,-0.15649999f,0.37390000f,-0.01730001f,-0.33229999f,-0.05750001f,-1.12049996f,0.31710000f,0.61359999f,-0.16920001f,0.11889999f,-0.13410000f,0.21839999f,0.07970001f,0.51189998f,-0.29220000f,-0.70019999f,-0.24800000f,0.18100000f,-0.10260000f,-0.56530000f,0.08919999f,-1.81440000f,0.35190001f,0.12069998f,0.04470000f,-1.15399996f,-0.51120001f,0.23919999f,0.89159998f,0.81619997f,0.41459998f,1.11609997f,1.11270000f,0.88109994f,0.44100000f,-1.61669997f,-0.85740001f,0.36000001f,0.70320003f,1.00949999f,-0.19860000f,-0.00800000f,-0.84300002f,-0.08910000f,0.89280003f,-0.44939997f,0.49499998f,0.75019998f,0.11909999f,-1.04350001f,0.38820002f,0.62159998f,-0.04350000f,-0.18090000f,-0.04250000f,-0.92290002f,-0.00140000f,-0.42709998f,0.25720000f,1.04639999f,-0.16320001f,-0.72859997f,0.11190000f,-0.48650002f,-0.15660001f,0.30510000f,0.13020000f,-0.12960001f,0.28599999f,-0.16590001f,0.31460001f,-0.18259999f,-0.04850000f,-0.30539999f,0.24719999f,-0.77269998f,0.18930000f,-0.18060000f,-0.15710000f,-0.59569997f,-0.04960000f,-0.36239996f,-0.13110000f,-0.58069999f,1.01790003f,-0.41870006f,0.02130000f,-0.79609998f,-1.52250002f,0.20440004f,0.88770001f,-0.36299999f,1.03680002f,0.62689993f,0.59820002f,1.23770001f,-0.41849999f,-0.68039999f,-0.13559998f,-0.17930002f,-0.76620003f,-1.05259999f,0.22740000f,-0.32979999f,-0.08039999f,-1.31809998f,-0.37529999f,-0.65099998f,0.90449998f,-0.07630000f,0.46860000f,-0.68850001f,0.12770000f,-0.25450000f,0.18860001f,-0.85829998f,0.24410000f,-0.03370001f,0.06730000f,0.72130002f,0.01100000f,-0.66499999f,-0.33340000f,-0.02839999f,0.25940000f,-0.34620000f,-0.07309999f,-0.28759998f,-0.09430000f,0.19180000f,0.11080001f,-0.18630000f,0.20020000f,-0.51340001f,-0.08780000f,0.30749999f,-0.13420000f,-0.12510000f,-0.10209999f,0.94879998f,0.00700002f,-0.87950001f,0.13590001f,-0.15590000f,-0.14700002f,-1.64289998f,-0.05759998f,0.13569998f,-1.10070004f,-0.05649996f,0.42900001f,-0.67580000f,0.28859999f,-0.03799999f,0.10650001f,-0.22220002f,-0.36360002f,-1.14279996f,0.59609999f,1.08779996f,-0.23610001f,-0.55930001f,-0.05669997f,-0.83900000f,-0.12660000f,0.31689999f,0.43170000f,0.20269999f,-0.32700001f,1.25999999f,-1.18950005f,0.50749998f,0.28920000f,0.47649999f,-0.08020000f,-0.97730000f,0.05690000f,-0.98380001f,-0.23200000f,-0.65679998f,0.03500000f,0.62090000f,-0.50119999f,0.28760000f,0.08229999f,-0.23890000f,-0.03920000f,-0.30409999f,-0.01409999f,0.57350001f,-0.18980000f,-0.41059999f,0.17270000f,-1.12570001f,0.01350000f,0.86979998f,0.12220000f,-0.39819999f,-0.38419999f,0.21209999f,0.30430000f,0.63889997f,-0.62010001f,0.39230000f,0.85590004f,-0.79150000f,0.48060003f,-1.16660001f,1.31279999f,0.28559996f,-1.00890002f,-0.16009996f,0.36449998f,0.48400001f,-0.24299999f,-0.70309998f,-0.25380001f,-0.98349997f,0.33179998f,1.55009998f,0.68699999f,-0.05820001f,0.03510004f,-1.92469999f,-0.55230001f,0.92819999f,-0.38790000f,-1.16539997f,0.71249998f,0.95509995f,-0.69480002f,-0.57149999f,-0.16150000f,-0.44500000f,-0.08440000f,-0.24719999f,-0.02440001f,-0.60529998f,-0.29040000f,0.75300000f,0.27670000f,-0.98200001f,0.04350000f,0.48409999f,0.08219999f,-0.40400002f,0.25270001f,-0.79019999f,0.45590000f,-0.61549999f,0.22510001f,-1.07620001f,0.28710001f,0.33439999f,-0.31880000f,0.30529998f,0.08299999f,-0.21380001f,-0.10470000f,0.05530000f,-0.03510000f,0.28309998f,0.15900000f,-0.82380000f,0.05190000f,-0.50199999f,0.68400002f,-0.24789998f,-0.00030001f,1.11860002f,-0.27059998f,-1.95159998f,-0.46560001f,0.33870000f,0.99240007f,0.69039997f,-0.16140002f,-1.45780001f,-0.48270001f,-1.33250000f,-0.33060000f,-2.27580002f,-0.80520003f,-0.14080002f,0.25260001f,0.57269999f,0.42030003f,0.26539998f,0.09780001f,0.12190000f,-0.15390001f,-0.17780001f,-0.18430000f,0.16750001f,-0.15320000f,0.17400001f,-0.38890000f,0.73529998f,0.17100000f,0.02909999f,-0.08090000f,0.24190000f,0.06270000f,-0.01549999f,0.23670000f,0.79259999f,-0.33330001f,-0.15960000f,0.17580000f,0.14720000f,0.14710000f,-0.36879999f,0.31390000f,-0.64750000f,0.32130000f,-0.04770002f,-0.12870000f,-0.70429999f,0.08480000f,0.05900000f,-0.25490000f,0.51819997f,0.01439999f,0.13130003f,0.18209999f,0.41200001f,0.37740001f,1.49469998f,0.18690001f,0.51169998f,0.36480000f,0.87929997f,-0.43860000f,-0.56569996f,-1.26720000f,0.04500005f,0.70350002f,0.28400001f,-0.40410000f,-0.07399998f,0.85350000f,0.64039996f,0.06780001f,-0.79450002f,-0.05219998f,0.20489997f,0.49140000f,-0.82569999f,0.10860000f,0.36179999f,1.04280001f,-0.27799999f,-0.31670000f,-0.17130000f,-0.07800000f,-1.03570001f,-0.08590001f,-1.16669997f,0.11190000f,-0.01230000f,-0.25810000f,-0.29210000f,0.25580000f,-0.28489998f,-0.15280000f,-0.44419999f,-0.19070001f,0.56779998f,0.14010000f,0.21819999f,0.23980000f,-0.77049999f,0.39570000f,-0.51489999f,-0.22750001f,0.07999999f,0.14130000f,-0.31250001f,-0.02910000f,0.04960000f,-0.44189999f,-0.31000000f,0.87839999f,0.52289996f,1.00320003f,-0.69750004f,0.85140000f,-1.16969999f,-0.45989999f,-0.53249998f,0.94140002f,0.44449998f,-0.01200001f,-0.27229998f,0.33510000f,-0.56819998f,0.56130004f,1.65419998f,0.25500002f,0.93539999f,0.05010001f,-1.14149999f,-0.29820001f,-0.95190001f,0.83550004f,1.05079999f,0.28560002f,-0.04470002f,0.20070001f,0.34040000f,0.93359997f,-0.39439998f,0.22060000f,1.16109999f,0.07080000f,-0.52480003f,0.01470001f,0.72829998f,-0.24830000f,-0.14039999f,0.30330000f,1.05490000f,-0.11490000f,-0.01680000f,-0.02460000f,0.61440001f,-0.04980000f,-0.31379999f,0.02420000f,0.05540000f,-0.07410000f,0.12910000f,-0.18460000f,-0.43450000f,0.22069999f,-0.87829999f,-0.40220000f,0.30090002f,0.17190000f,0.07040000f,0.33720000f,-0.96479998f,-1.15590000f,0.89170004f,0.98790002f,0.43799991f,-1.11690003f,-0.12589999f,0.74279999f,0.47319998f,-1.38330002f,0.46670004f,0.43500000f,0.43839998f,-0.27960002f,0.76960001f,0.22170000f,-0.35539999f,0.12750001f,0.31140000f,-0.16380001f,-0.06310000f,0.55830001f,-0.27670001f,0.12870002f,-1.26249998f,0.26669995f,0.48790000f,-0.42210000f,-0.25159998f,-0.83639999f,-0.01599999f,-0.09210001f,-0.64010001f,0.03630000f,0.24599999f,-0.16390000f,1.03509998f,-0.41559999f,0.60019999f,-0.37549998f,0.55590000f,-0.18000000f,-0.05840000f,-0.27910001f,-1.02260001f,0.35850000f,1.05879998f,-0.11830001f,-1.02629998f,-0.19100000f,0.73339998f,-0.07930000f,-0.57480000f,-0.19990001f,-1.08469997f,-0.15199999f,0.64679999f,-0.22810001f,-0.41490000f,-0.31350000f,-1.04079997f,1.18140004f,0.29649996f,-0.25740000f,0.15960000f,0.25560001f,2.16289998f,0.20309998f,0.96179999f,-0.00840003f,0.62930000f,0.34140000f,0.15360000f,1.35990003f,-0.40900005f,-1.50630001f,0.36720003f,1.13220003f,-0.54690000f,0.51659999f,1.91139993f,0.25320001f,-0.84919999f,0.82890000f,-1.17369999f,0.38069998f,1.60079997f,0.28020000f,-0.67430001f,0.23850000f,0.84519999f,0.24790001f,1.05640002f,-0.08190001f,0.12000000f,0.08259999f,-0.63889998f,0.13370000f,-0.87889999f,-0.32250000f,0.55530000f,0.01680000f,0.73870001f,-0.31230000f,0.67950001f,0.02880001f,0.94109997f,0.30449999f,-0.59819997f,0.37300000f,0.94530001f,0.36689999f,0.26839998f,0.11830000f,1.05529997f,0.27360000f,0.30690000f,-0.44810000f,0.18430002f,0.11870000f,0.48200001f,-1.19160004f,0.67160005f,0.85620003f,1.32399999f,0.39960000f,-0.58389999f,-0.12719997f,-1.71829995f,-0.12930003f,0.52150000f,-0.78360003f,0.35850004f,-0.01410002f,0.93250001f,-0.68250000f,0.90289999f,-0.16830000f,-1.03739997f,-1.36530002f,0.36030004f,-0.78959999f,-0.15480000f,-0.83070000f,1.02069999f,-0.68970001f,-0.04929999f,0.50849997f,0.54530000f,-1.12799999f,-0.66450001f,-0.05020000f,-0.44550004f,0.09660000f,-0.36469999f,0.05390000f,-0.14850000f,0.28210001f,-0.61570000f,-0.26030001f,0.70589999f,-0.24690001f,0.15450001f,-0.23170000f,0.16190001f,0.32440001f,0.48509998f,-0.10000001f,-0.81189998f,-0.14430000f,0.16350001f,-0.12520000f,-0.92580000f,0.13079999f,-0.12860000f,0.13380000f,-0.16240000f,0.11660000f,-0.30059999f,0.33450000f,-1.06070001f,1.10910002f,0.61989989f,-0.48510000f,-1.26489996f,-0.73320002f,-1.24069998f,-0.46110001f,-1.50270000f,0.20850002f,1.35170001f,0.41820000f,0.59390001f,-0.28080002f,-0.34309997f,-0.95580002f,-0.01590002f,0.42690000f,-1.08969999f,0.13889998f,0.34210000f,1.09290002f,-0.41540003f,-0.62429999f,-0.96299996f,-0.45000001f,-0.78319998f,-0.27120001f,-0.82179998f,0.07740001f,0.69679998f,-0.13270000f,0.57670001f,-0.29790000f,0.37630002f,0.07660001f,1.06759998f,-0.46129999f,0.00840000f,-0.16260001f,-0.43519999f,-0.28029999f,0.13220000f,0.14299999f,-0.25689999f,-0.06549999f,0.11860000f,0.19370000f,0.60780001f,0.10080000f,0.66399998f,0.29300000f,-0.10570002f,0.04620000f,0.15150000f,-0.02580001f,-0.48740001f,0.21270000f,-0.39649999f,-0.16120000f,0.64360000f,-0.22110002f,0.65370002f,-0.14310003f,0.18530004f,-0.67290001f,1.21519999f,0.66899999f,0.41319999f,0.68700001f,-0.07440000f,0.58769998f,0.74739996f,0.75690002f,0.71769998f,0.34739999f,0.63499998f,-0.66690001f,0.47100004f,-0.85440000f,0.21280001f,-0.12779998f,-0.04430002f,-0.34410000f,-0.13149998f,1.01580006f,0.43779999f,-0.42960000f,-1.11589998f,0.65670001f,0.61520000f,-0.33299999f,-0.77779997f,0.11059999f,-0.24870000f,-0.12700000f,0.31989999f,-0.19900000f,0.21220000f,0.12139999f,1.07849999f,-0.36700000f,-0.36029998f,0.12989999f,-1.07560002f,-0.28940000f,0.65769999f,0.11160001f,-0.23100000f,0.02400000f,-0.14020000f,0.33030001f,0.26270000f,-0.32990000f,0.78160001f,-0.09340000f,0.65720000f,0.24490001f,-0.76640000f,0.00930001f,0.05840002f,1.04129998f,-0.44020000f,0.73440004f,0.66509998f,0.67860002f,1.41169997f,0.24180000f,0.51580000f,-1.14120000f,0.63870004f,0.82230000f,0.02270002f,0.11940004f,-1.76040000f,0.10650001f,1.08390001f,-0.66180002f,-1.23459999f,-0.10830000f,-0.39299999f,-0.42510000f,0.29730001f,0.45659996f,1.76159997f,-0.15600002f,0.94440000f,-0.49530002f,-1.88360001f,-0.77580003f,0.57619999f,-0.34160000f,-0.22819999f,0.26950000f,-0.56059998f,-0.19630000f,-1.19170001f,0.08620000f,1.14460000f,0.13840001f,1.09039998f,0.09259998f,-0.45720002f,0.17529999f,-0.54129999f,0.40400000f,0.06379999f,-0.10269999f,0.46519999f,-0.07719999f,0.13390002f,-0.16160000f,-0.11230000f,-0.16170000f,0.31130000f,0.18970000f,-0.24889999f,0.31099999f,0.08019998f,0.27840001f,0.09660001f,0.69000000f,0.12340000f,0.09960001f,-0.63379999f,1.09710003f,-1.00430003f,-0.65370002f,1.40140001f,-1.10310002f,0.73400000f,1.03590006f,0.65999995f,0.05640001f,-0.76469998f,-0.42629999f,-0.00340000f,-1.03260005f,-0.65160001f,-0.45480002f,-0.46069994f,0.50010001f,0.29070000f,0.09030001f,0.53990001f,-0.66419999f,-1.18269995f,-0.12869999f,0.33379996f,-1.27080004f,0.79719998f,0.24489999f,-0.37570001f,0.22310000f,0.73069996f,-0.20420000f,-0.05630001f,0.22000000f,-0.73679999f,0.41800000f,-0.14850000f,0.26380000f,0.50999998f,0.46479999f,-0.39650000f,-0.17829999f,-0.26670000f,0.27550001f,-0.38840000f,-0.37289999f,0.34319998f,-0.17980000f,-0.39009999f,0.26660000f,0.08649998f,0.20880001f,0.15670000f,0.03409999f,-0.61700000f,0.37860001f,-0.69100000f,1.38019997f,-1.06689997f,-0.45530001f,1.58230000f,0.53930000f,-0.70349998f,-1.19890004f,0.49810003f,-0.53079998f,1.31139998f,0.32419999f,0.77339997f,0.51309998f,-0.13109999f,1.01479996f,0.22790000f,-0.07670002f,-0.41139999f,-0.18869997f,-0.80380002f,-0.56679998f,0.23069998f,-0.25590002f,0.77340002f,-0.42469997f,1.24369998f,-0.34690001f,-0.80920004f,1.37630000f,-0.78580002f,-0.60050000f,-0.10870000f,0.16020002f,-0.48779999f,0.43260000f,0.24419999f,0.23239999f,0.35800000f,-0.13990001f,0.44230000f,-0.63629999f,0.17189999f,0.39730003f,-0.67090000f,-0.43420002f,0.12460000f,-0.19510000f,0.36070001f,0.36020000f,0.09340000f,0.18249999f,0.06229999f,0.39299999f,-0.17699999f,0.12220000f,0.33140000f,0.45770003f,-0.37490001f,-0.02459998f,0.18730001f,-0.81619999f,0.40129997f,0.61240000f,0.12299997f,0.56290001f,-0.58809997f,-0.45549999f,0.87889999f,-0.76549998f,0.36899999f,-1.47329996f,1.15999996f,0.88110001f,0.56639997f,-0.24150000f,-0.91690000f,-0.89880001f,0.68810003f,0.45850000f,-0.23209998f,0.57270001f,-0.90399999f,0.22019995f,0.96360002f,-0.37959999f,0.46660000f,0.84560002f,0.17729999f,0.26960000f,0.03560000f,0.30230001f,-0.18350000f,-0.18770000f,-0.30550002f,0.21470001f,-0.31190000f,-0.00900001f,0.19980001f,0.10040002f,-0.20479999f,-0.80790001f,0.02309998f,-0.24410001f,0.46010002f,0.07620001f,-0.25980000f,-0.49829998f,-0.18570000f,-0.07379999f,-0.43740001f,0.10520000f,-0.14120000f,-0.12349998f,-0.61810000f,-0.07260000f,-0.28380000f,0.00190001f,-0.09909999f,-0.51660001f,-1.21739996f,0.60130001f,-0.11480000f,-0.44570000f,1.12819999f,0.53440000f,0.06869999f,0.53620000f,-1.63999998f,-0.11580000f,0.96859998f,-1.51749999f,1.10739997f,-0.99820002f,0.56210003f,0.52560000f,-0.40139999f,-0.38839998f,-0.10310001f,0.66340001f,-0.73680004f,0.14809999f,0.26089999f,0.43600000f,0.01769997f,0.34169999f,-0.34890000f,-0.34029999f,0.97119996f,-1.36999999f,-0.51070001f,-0.27730001f,-0.14390000f,0.11490000f,-0.70530001f,-0.52750001f,-0.05570001f,0.29890000f,0.12230001f,-0.00180000f,-0.33660001f,0.59880002f,0.09960001f,-0.52400000f,-0.22840001f,0.60940000f,-0.35020000f,-0.33260001f,0.37220000f,0.01310000f,-0.23270001f,-0.16640000f,-0.41320001f,0.14549999f,0.18570000f,0.05910000f,0.07410000f,-0.00780002f,0.59100000f,0.66119999f,0.14019999f,-0.28070001f,0.17239999f,0.84139998f,-0.04330005f,-0.57770000f,-0.04120000f,0.78650002f,-1.18820001f,0.09339999f,0.50759999f,0.51700001f,0.27660002f,-0.49760000f,0.15999997f,1.24189998f,-0.33950000f,-1.02869998f,0.57589998f,0.33620001f,-0.21190002f,0.18879999f,0.01040001f,0.07540000f,-0.16669998f,-0.19840000f,0.44270000f,-0.38070000f,-0.44089997f,1.49240001f,0.21069999f,-0.47610001f,0.11250000f,0.05690000f,-0.40610001f,0.01760000f,-0.55760002f,-0.09839999f,0.01200000f,0.35990001f,0.08290001f,0.77739999f,0.37100001f,0.11530001f,-0.27370000f,0.45190001f,-0.32230000f,-0.52670003f,0.55550000f,0.14940001f,-0.04140000f,0.15590001f,-0.83630002f,-0.07180001f,0.44260000f,0.21520000f,-0.44920000f,0.26750000f,0.44169999f,-0.09259999f,-0.47670000f,-0.39579999f,-0.66350001f,0.02479997f,0.96850000f,0.28989998f,0.59749999f,-0.75839998f,1.38639996f,0.85360000f,-1.08609998f,0.46059998f,0.30920003f,0.50290000f,-0.21459999f,0.96919999f,-0.22490000f,-1.30710000f,0.27099998f,-0.10499999f,0.72919998f,0.92229998f,0.16940000f,-0.22050000f,-0.65349998f,0.85239998f,-0.34120001f,-0.40119998f,0.67550000f,0.59570001f,0.00310000f,0.50520002f,-0.26760000f,0.29580001f,-0.16260000f,-0.14409999f,-0.19429999f,0.30039999f,0.57440002f,0.06300000f,-0.84780002f,-0.00530001f,0.18530000f,-0.74600000f,0.06920000f,-0.06520000f,-0.66200002f,-0.40229999f,-0.65970001f,0.28400002f,-0.93920003f,-0.25300001f,-0.06380001f,0.41329999f,0.33550000f,-0.40960000f,-0.00440000f,0.14830000f,0.08210000f,0.32400002f,1.19389999f,0.78990001f,0.20110000f,0.48740000f,0.07520000f,-0.33160001f,0.75669998f,-0.13900001f,-0.09939997f,0.96289997f,-0.14970001f,0.05010000f,-0.52159999f,-1.46060002f,1.05180003f,0.58610001f,-0.06190005f,0.31870001f,-0.39480006f,1.34730002f,-0.20270003f,0.12650002f,-0.83490003f,0.09359998f,0.20410004f,-0.70480000f,0.45280000f,0.06430000f,0.08700001f,0.67770002f,0.07620000f,0.34489999f,0.13750001f,0.13740000f,0.20460001f,0.25749998f,0.70730000f,-0.57230002f,0.08630000f,-0.21390000f,0.32190000f,0.19390000f,-0.17949999f,-0.02040002f,0.10680001f,0.34960001f,0.15800001f,-0.19260001f,-0.04860000f,-0.81480002f,0.04079999f,-0.46529999f,-0.47070001f,-0.71070002f,-0.06690002f,0.30870001f,-0.33750000f,-0.31980001f,0.08220000f,0.11930001f,0.59070000f,0.29869998f,-0.01399999f,-0.09860000f,0.15640001f,-0.49070001f,0.27880005f,-0.87640002f,0.19489999f,-0.72629999f,0.33740000f,0.60969998f,-0.43799999f,0.48329997f,-1.35509997f,-0.04210002f,0.71030003f,-0.00320001f,-0.41500000f,-1.45449999f,0.91109995f,-0.19029999f,0.15719997f,-0.79770000f,-0.03000001f,0.44989999f,0.56739999f,-0.52200000f,0.10779999f,-0.32590001f,-0.16760000f,0.18130001f,0.21469999f,-0.03050000f,-0.39430002f,0.17510002f,-0.54950000f,0.08970001f,-0.18690000f,0.05570001f,0.14590000f,-0.45690000f,-0.22709999f,0.34840000f,-0.20080000f,-0.27340001f,0.64420001f,-0.65080002f,0.25480000f,-0.20709999f,-0.56690001f,-0.45230000f,-0.51250001f,-0.13520000f,0.38360001f,-0.39430000f,-0.13130001f,-0.11040001f,0.11400000f,0.45260000f,0.14859999f,-0.38489998f,0.88919999f,-0.16440001f,1.12389999f,0.30150000f,0.98459996f,0.49710000f,-0.45719999f,-0.50950000f,0.96940001f,-0.35900000f,0.03329996f,0.45179998f,0.37939999f,-1.18110000f,0.49390005f,-1.15650002f,0.24110000f,0.22440000f,0.14889997f,0.03750001f,-0.22280005f,-0.90790001f,0.82290004f,-0.50850000f,0.33079999f,-0.33430001f,0.19570000f,-0.08290000f,-0.32880000f,-0.26350003f,0.42550002f,-0.65060000f,-0.02260003f,0.43470000f,0.12329999f,0.10380000f,0.18420000f,-0.23190001f,0.25710002f,-0.04780000f,0.15580000f,-0.05320000f,0.35560001f,0.11720001f,-0.14960000f,-0.18600000f,0.08880000f,0.23610001f,0.03750000f,0.24850002f,-0.10810000f,-0.16389998f,-0.61730000f,0.60630002f,0.34050001f,-0.12840001f,-0.11280000f,-0.28550001f,-0.05500002f,-0.15560003f,-1.28429997f,-1.25819997f,1.05999998f,0.96190002f,-1.20819998f,-0.38929999f,0.75249999f,0.14210001f,-1.49780000f,-0.40550000f,0.43510000f,-0.24979999f,-0.35180000f,0.17320000f,0.25599999f,-0.37080000f,0.12400001f,0.33770001f,-0.18379999f,0.13880000f,0.60210000f,0.28550000f,0.23919998f,0.32200003f,0.21429999f,0.14229999f,-0.42490000f,0.19399998f,-0.29440000f,-0.34430000f,-0.03010001f,-0.02100000f,0.08580000f,-0.35230003f,0.87790001f,0.52799999f,0.54120000f,0.61729998f,0.42670000f,0.20360000f,0.09160000f,0.17420003f,-0.24260001f,-0.27280003f,0.21160000f,-0.03729997f,-0.33710000f,-0.32660000f,0.75139999f,0.30340000f,-0.33220000f,0.42410003f,-0.49250000f,-0.27020003f,0.63380000f,0.55690003f,-0.19690001f,0.47280001f,-0.75060001f,-0.96350000f,1.25940000f,0.02010000f,-0.28529999f,-1.34170001f,0.13480004f,0.07620000f,0.11620003f,0.38989998f,-0.09039998f,0.00840000f,0.34160001f,-0.21549999f,1.47190000f,0.19049999f,-1.61949998f,-0.28530000f,1.25099998f,-1.32139995f,0.43040001f,0.55209998f,0.31510000f,0.57050001f,0.94659997f,-1.08180001f,0.30480000f,0.73330002f,0.31660001f,0.25610002f,0.33040000f,-0.24620003f,0.33260002f,-0.52420002f,0.41620001f,-0.16609999f,-0.33070000f,0.24330000f,-0.71130000f,0.58250001f,0.37870001f,0.16790000f,0.25690002f,0.40310000f,0.51490001f,-0.04670003f,0.44630000f,-0.28739998f,-0.52259999f,-0.35570001f,0.17930002f,-0.42260000f,-0.11020000f,-0.20990002f,0.47270000f,-0.29450001f,-0.04030000f,0.59350001f,0.34610001f,0.31079999f,-0.90799999f,-0.03430001f,-1.30730001f,-1.42970002f,0.84730001f,-0.10180000f,0.47889997f,0.99669996f,-0.02400000f,0.44710002f,-0.20959999f,0.35280000f,-0.87249999f,0.04810000f,-0.10639998f,-0.13060001f,-0.79209997f,0.18930000f,-0.08730003f,0.04920000f,-1.46370001f,-0.05009999f,-0.80749999f,-0.28610000f,-0.94959997f,-0.00100000f,-0.71590001f,0.18590001f,0.46900000f,0.96929997f,-0.40730001f,-0.49369999f,0.08689997f,0.33390001f,-0.45990000f,0.51250002f,-0.39010000f,0.00110000f,-0.64550002f,0.09229999f,0.61690002f,0.19270000f,0.28250001f,0.68930001f,0.02350001f,-0.30770001f,-0.00910001f,0.34630003f,-0.44350000f,0.15470000f,0.18010001f,-0.04399999f,-0.27640001f,0.23240001f,-0.33680000f,0.10920000f,-0.29640000f,0.08700000f,-0.33180000f,-0.60300001f,0.30280001f,-1.21879996f,1.16709999f,1.05559998f,-0.44450000f,1.33330002f,-0.72140001f,0.79650000f,-0.38240003f,-0.53470002f,0.11840005f,-0.21190001f,0.39200002f,0.96850000f,-0.31419998f,0.08160002f,-1.00170001f,0.62180002f,0.51569998f,-0.03470000f,0.11439999f,-0.32900000f,1.19979998f,0.88619999f,-0.60939998f,0.61420000f,-0.42940001f,0.53300000f,-0.23440002f,-0.46930002f,0.39500000f,0.18310000f,0.35330001f,0.62910001f,0.23850002f,-0.23700003f,0.54300000f,0.59580000f,0.27540000f,0.09680001f,-0.06080000f,0.15499999f,0.33099999f,-0.79030001f,0.08830000f,-0.17200001f,0.22240000f,-0.27940002f,0.19660002f,0.05919999f,0.17120000f,-0.55330001f,-0.13790001f,0.07210000f,-0.01809999f,-0.45860001f,0.01940000f,0.02770001f,-0.46690000f,0.16410000f,-0.44439996f,0.01770000f,-0.29439999f,0.63650000f,-0.20239999f,-0.45760001f,-0.79379997f,0.17529999f,0.64990001f,-0.15300001f,0.73340000f,-0.38269999f,0.56390000f,-1.42040001f,0.80089998f,-0.57730000f,0.33429999f,-0.20430002f,-0.73050000f,0.32799999f,-0.93119997f,-0.50300000f,-0.10150001f,0.26959999f,-0.36189999f,-1.07060003f,1.07880002f,0.65530000f,-0.37860002f,0.01460000f,0.11480000f,0.41880000f,-0.17760000f,-0.69910001f,0.08710000f,-0.38530001f,0.50050000f,0.18180000f,0.25740001f,0.00890000f,0.37270002f,0.44670000f,0.05370001f,0.16780002f,-0.76540002f,0.26669999f,0.54330001f,0.36220001f,-0.42700001f,0.10000001f,-0.14680000f,-0.61130003f,0.02450000f,0.02940000f,0.76980001f,-0.00480001f,0.43680001f,0.19760002f,-0.77000002f,0.37769999f,-0.97740000f,0.18199999f,1.11999996f,-1.29540001f,0.77550000f,-1.24780000f,0.64330002f,-0.11900000f,0.21000002f,0.22260000f,-1.26569996f,0.11479997f,0.85070001f,0.83369998f,0.24670001f,-0.20400002f,0.01910005f,1.14560001f,-0.63700002f,0.30660000f,-0.09260000f,-0.57810002f,-0.44060002f,-0.86729997f,0.35689999f,-0.32099999f,-0.23539999f,1.16770002f,-0.40230005f,0.85429999f,0.19160000f,0.41660001f,0.10180000f,-0.42879999f,-0.39200000f,0.26630001f,-0.47150002f,-0.31600001f,0.60760002f,-0.06780002f,0.39540000f,-0.77619999f,0.04539999f,-0.17829999f,-0.39050000f,-0.68240002f,-0.12760000f,0.79380001f,-0.03780001f,0.46469999f,-0.06869999f,0.06590000f,0.11050000f,0.15530000f,0.27310001f,0.18490000f,-0.44410000f,-0.69520000f,0.00039999f,-0.22500003f,-0.72169997f,0.09760000f,0.70380001f,-0.23030000f,0.17729996f,0.22809999f,1.22960000f,-0.62239999f,-0.78239999f,0.08900001f,-1.22759998f,-1.49759999f,1.10220001f,0.09990000f,0.12639998f,-0.53020001f,-0.41580001f,1.51110003f,-1.10030000f,0.85479997f,-0.47850000f,-0.25500001f,0.50890001f,-0.09370001f,0.04800003f,0.94189997f,-0.63320000f,-0.80199997f,-0.12200001f,0.09999999f,0.41520000f,-0.59429999f,-0.19050001f,-0.18490001f,0.17409999f,0.24250001f,0.10310000f,0.03860001f,-0.64700001f,-0.49490000f,-0.34030001f,-0.07380000f,-0.03780000f,-0.62609998f,-0.45390001f,0.06750000f,0.05489999f,-0.11220000f,-0.47100002f,0.83440001f,0.21319999f,0.09010001f,-0.01450001f,-0.38329999f,-0.09550001f,0.21030001f,-0.28230001f,-0.58679999f,-0.05400001f,-0.38300000f,-0.66450001f,0.59070000f,0.77969997f,-0.89670004f,0.05460001f,0.21660001f,0.18450000f,-0.67950002f,-0.89580002f,-0.89339999f,-0.11219997f,-0.16440000f,0.51780000f,0.56789998f,0.49079999f,0.52979998f,1.00979998f,0.26490000f,-0.15480002f,0.69720002f,-0.28409999f,0.31950000f,-0.25409998f,-0.85110002f,-0.10920001f,-0.71579998f,-0.01109996f,0.78060003f,-0.38490002f,0.64740001f,0.21479998f,-0.90429999f,-0.25050001f,0.47450000f,0.12550001f,0.72660001f,0.34520001f,-0.57539998f,-0.89680000f,-0.74399997f,-0.50579999f,-1.66249995f,-1.00130001f,0.59960001f,-0.15860000f,-0.00160001f,0.70620002f,-0.96160000f,-0.72480004f,0.51560000f,0.12980000f,0.77400000f,0.69980003f,-0.03960004f,-0.71760004f,-0.41259998f,-0.54340000f,0.70970002f,0.01510001f,0.04539999f,0.89010000f,-0.00750000f,-0.46289999f,0.31229999f,0.60149999f,0.04800000f,0.20430001f,-0.92879999f,-0.23969999f,-0.58799998f,-0.59249999f,-0.72509999f,-0.84899996f,0.13439999f,0.93930000f,0.57780001f,-0.40230002f,-0.70380002f,-0.59579999f,-0.02580000f,0.24930000f,0.47040002f,0.19650000f,-0.55080002f,0.41219998f,-0.61739999f,-0.26579999f,0.10410000f,0.74610002f,0.17099999f,0.95440002f,0.57530000f,0.16850000f,-0.74770000f,-0.76650002f,0.44430000f,0.08370001f,0.93249999f,1.24230003f,-0.37209999f,-0.69630002f,-1.72139999f,-0.88040002f,-1.01060001f,-0.66740004f,0.55289999f,0.44790000f,-0.38839999f,0.19319999f,0.72980000f,0.81220004f,0.05760000f,-0.14980000f,0.30279999f,0.28520000f,0.35789998f,0.42270000f,-0.57069997f,-0.74470000f,-1.31739998f,0.54419998f,0.15870000f,0.45540000f,-0.39629999f,0.01140002f,0.17790000f,0.48390000f,0.86190000f,-0.02550002f,-0.45630002f,0.18270001f,-0.51779998f,-0.84869998f,-0.69960002f,-0.72180001f,0.46349999f,0.36270000f,0.35339999f,-0.24419999f,0.86940002f,0.44039999f,-0.06660000f,0.20129999f,0.56459999f,0.49139999f,0.48869999f,0.25019999f,-0.52649999f,-0.00659999f,-0.63179999f,0.14889998f,-0.33890001f,-0.06050001f,0.69379998f,0.36660003f,-0.56180001f,0.08199999f,1.05770002f,0.89810004f,-0.08860001f,-0.25340001f,0.45740002f,-0.29780001f,-0.56250000f,0.00010000f,1.21699998f,0.41840002f,-1.05989997f,-0.63310000f,0.33090000f,0.28310002f,0.10309997f,0.19529999f,0.14620000f,0.04140000f,-0.27969999f,-0.39870001f,-0.15760000f,0.07820001f,1.71190000f,0.06240000f,0.08730000f,-0.12120001f,0.62040002f,0.79139998f,0.20700000f,-0.40290000f,0.56790001f,0.27059999f,-0.02340000f,0.27120000f,-0.41220001f,0.39720001f,0.23130001f,-0.25350000f,0.37080000f,0.91049998f,-0.60869998f,-0.71519998f,0.33570002f,0.26070000f,0.39929999f,0.25529999f,-0.09480000f,-0.03540000f,-0.35970000f,-0.06809999f,-0.24059999f,-0.53430000f,0.72810003f,0.30790001f,-0.21150000f,0.50710002f,-0.27350003f,-0.59850003f,0.03999997f,-0.22220001f,-1.05039997f,-1.13200001f,1.09210000f,0.83110002f,0.44629999f,-0.46110001f,0.48559999f,0.30060000f,0.93139999f,0.31820001f,-1.22599999f,-0.46379999f,-0.27619998f,-0.58100000f,0.69909996f,0.25389998f,0.01850000f,0.32490001f,0.82069998f,0.48330001f,-0.46049997f,-0.77230000f,0.64940000f,-0.56789999f,0.43890001f,-0.45450001f,-0.26790001f,0.34050000f,0.10980000f,0.49350000f,-0.86159999f,-0.24719998f,0.52289999f,0.35129999f,-0.71670000f,0.28589999f,0.34799999f,0.39030000f,0.31320000f,0.73319999f,-0.52919998f,-1.03050000f,-0.46140000f,0.09240001f,0.59129999f,0.93179999f,0.04050000f,-0.42300000f,0.55770000f,0.66209998f,-0.88289998f,-0.26849998f,0.81720002f,-0.96700003f,0.67040001f,-0.05740000f,0.42530000f,0.00390000f,-0.53120000f,-0.51840002f,-0.00409999f,-0.20510001f,0.80919995f,0.52340000f,0.20260000f,0.33720001f,-1.64480002f,-0.85960006f,0.45840000f,0.36860004f,0.27530000f,0.65290004f,1.17720000f,0.60100003f,0.30140002f,0.72160004f,0.10739999f,-0.34340002f,-0.78830000f,-0.35010002f,0.05800000f,-0.11620001f,0.64530002f,-0.29819999f,-0.01740001f,0.68070001f,0.02190000f,0.40890000f,-0.27060002f,-0.01860000f,-0.51870001f,-0.28530001f,0.82620000f,0.89609998f,0.16740000f,-0.12870000f,-0.53880003f,-0.83339999f,0.63900003f,0.59370000f,0.93150002f,0.33240000f,0.88500002f,1.18410001f,0.64680003f,-0.06930000f,-0.52800001f,0.01320000f,-0.17970001f,-0.40289999f,-0.16440001f,0.04050000f,0.20250001f,-0.49670003f,0.31899999f,-0.06840000f,-0.09289999f,-0.23070000f,-0.40680000f,-0.57500003f,-0.87890002f,-0.17630001f,-0.72139998f,-0.41960000f,0.65799998f,0.43460000f,0.79859996f,1.05480001f,-0.17330001f,-0.66890003f,0.08249998f,0.36950001f,-1.61209999f,-0.72850000f,-0.30920000f,0.11540000f,-0.78000001f,0.08580000f,0.24360000f,-0.31460001f,-0.51580000f,-0.11380000f,-0.57299999f,-0.58559998f,-0.19860001f,0.16949999f,-0.31350001f,-0.09570000f,-0.86400001f,-0.49289999f,-0.05609999f,-0.60570001f,-0.44339999f,-0.53669999f,0.38639999f,0.39149998f,0.76679998f,0.02429997f,-0.67530002f,0.07560000f,0.35310000f,-0.07650002f,-0.40769998f,-0.85079999f,0.43200001f,0.03390001f,0.25560001f,-0.55350000f,-0.13800000f,0.53730000f,-0.06060000f,-0.37140000f,-0.70380001f,-0.03780000f,-0.53619997f,-0.83480001f,-0.49040001f,-0.72720003f,-0.03559999f,-0.54820001f,0.55169999f,0.45810000f,-0.68839999f,-0.86220003f,-0.39880000f,0.10000001f,0.31409999f,-0.22810000f,-1.13790000f,-0.69830005f,-1.12960002f,-0.29100002f,0.07709999f,0.15730000f,-0.00920000f,0.44460003f,-0.99690000f,-0.84810005f,-0.59380000f,-0.19080001f,-0.34770001f,-0.20930001f,-0.25299997f,0.07320000f,-0.79619999f,-0.14609997f,-0.35460000f,0.23580001f,-0.18120000f,0.58170000f,0.43109999f,0.30959999f,-0.75480001f,-0.19769998f,0.29340001f,-0.18240001f,-0.14970000f,0.45929999f,-0.81150003f,-0.91919999f,-0.21420000f,-0.84330001f,0.45750000f,0.35430000f,0.70560002f,0.12690000f,-0.82410003f,-0.58019999f,0.00540000f,-0.25289999f,-0.19650000f,-0.22860000f,-0.90479999f,0.18340002f,0.22229996f,0.85530001f,-1.46749998f,-0.82650002f,1.23270001f,0.90830003f,-0.51499998f,-0.70560001f,0.52830000f,1.10830003f,-0.46359999f,-0.42700001f,-0.09519998f,0.11960001f,0.08150000f,-0.14230000f,-0.37150000f,-0.13570001f,0.37680001f,0.12220000f,-0.02309999f,-0.44970002f,0.10629999f,0.10589999f,0.32770005f,-0.36209998f,0.21389999f,0.40550001f,0.35079997f,0.70799999f,0.50189999f,-0.50610004f,-0.48689998f,-0.66149996f,0.54570001f,0.39060000f,-0.66359999f,-0.16949999f,0.77730000f,-0.29160002f,-0.40020000f,-0.24029999f,-0.07800000f,-0.35460000f,-0.05910000f,0.22050000f,-0.11010001f,-0.26250000f,0.02400000f,0.18990001f,-0.34710001f,0.25770001f,0.43409999f,0.43140000f,-0.58709999f,0.17610002f,0.39990000f,0.04319999f,0.75659999f,0.73020003f,-1.22840000f,-0.99820004f,0.10080000f,0.19260000f,-1.16780000f,-0.51360002f,0.14930001f,-0.37450001f,0.47940000f,-0.15519999f,-0.05260000f,-0.33060001f,-0.59089998f,-1.09170004f,0.59449997f,1.23090002f,-0.62599999f,-0.85780003f,-1.23939994f,-0.69540000f,0.40139998f,-0.11120001f,0.24490002f,-0.55470000f,-1.00029999f,-0.53930000f,0.60240002f,-0.18740001f,0.24810002f,0.83279999f,-0.68280001f,-0.40769998f,0.10980000f,-0.07110000f,-0.77100001f,-1.17690000f,-0.68250000f,-0.07710000f,-0.47339999f,0.13469999f,-0.34740001f,0.05220000f,-0.75930001f,0.22980003f,0.90450000f,-0.27000003f,-0.48360002f,0.16050001f,-0.85259999f,-1.06319996f,0.01800000f,0.55469999f,-0.26970000f,0.74820001f,-0.68369998f,-0.88590000f,-0.16560001f,0.64470002f,-0.46110000f,0.57300003f,0.32779999f,0.91760004f,-1.50280001f,-0.86740004f,-0.27040000f,-0.22600000f,0.83899995f,0.34839999f,0.55310003f,-0.03369999f,0.59000000f,0.58200002f,0.16790002f,-0.17530000f,0.13809999f,0.43510001f,0.10529999f,0.33210001f,0.41569999f,1.12270003f,0.11499999f,0.72840001f,0.02809999f,0.55770001f,0.15489999f,0.61510002f,0.13850003f,-0.57190000f,1.20259995f,-0.01500000f,0.59400001f,-0.39810004f,-0.77100002f,-0.95490000f,0.03060000f,0.12480000f,0.58139998f,0.90749997f,-0.34710000f,0.16380001f,0.28260000f,-0.00900002f,-0.48750000f,-0.13680000f,0.11850001f,-0.38970001f,0.58769999f,0.26639999f,0.85530000f,-0.32790002f,0.71279999f,-0.17550000f,0.23550000f,-0.54120001f,0.56130001f,-0.14130001f,-0.74970000f,0.13200001f,0.71879998f,-0.06880001f,-1.43309996f,-0.97250002f,1.03949997f,0.56770001f,1.38540001f,0.75280003f,0.73889998f,0.61930003f,-0.42990001f,-0.39430004f,-0.24199999f,-0.46220002f,1.01620000f,0.21640001f,0.30620001f,0.83380004f,0.40230002f,-0.22350000f,-0.02589999f,-0.18549999f,-0.64529999f,-0.84470002f,0.93589998f,0.64770000f,0.63839999f,0.48680002f,0.50839999f,0.34560002f,-0.55680002f,0.70110002f,-0.69029998f,-0.64229995f,0.60269999f,0.78749998f,0.67140000f,0.90570000f,0.81030002f,0.67019999f,-0.64170003f,-0.53220001f,-0.54480002f,-0.14850000f,0.00539999f,0.61410000f,0.71760003f,-0.15240000f,-0.02130001f,0.67890002f,-0.26969999f,-0.05220000f,-0.50310000f,0.10110002f,0.62369998f,0.59669999f,0.50520001f,0.43019999f,0.41880001f,0.42419999f,0.36780001f,0.15990000f,0.15090001f,0.06410001f,0.70890001f,0.02530001f,-0.16070001f,0.39830001f,0.07360001f,-0.68580001f,-0.32740000f,-0.57300002f,-0.43789998f,-0.62390000f,-1.54490000f,-0.66230002f,-0.59479999f,-0.37140000f,0.00549998f,0.51350002f,0.56319998f,0.67520001f,-0.49100001f,0.17140000f,0.34089999f,0.30070000f,-1.28180003f,-0.86980006f,0.63459999f,0.53000001f,-0.17470000f,-0.03630000f,-0.17130000f,-0.15180001f,-0.23970000f,0.34019999f,0.08190001f,-0.65010001f,-0.80220000f,0.18330001f,-0.43380001f,0.06480000f,-0.68669998f,-0.24719998f,-0.38610000f,-0.86370000f,-0.36419999f,-0.40290000f,0.35790000f,-0.35700003f,0.42240000f,-0.01440001f,0.32400000f,-0.33900000f,0.22649999f,0.11969999f,-0.58380003f,-0.53640000f,0.64380000f,0.51929999f,-0.36870000f,0.73800003f,-0.11249999f,-0.84590000f,-1.41800001f,-0.64480003f,-1.26379999f,-0.74700003f,-0.11500000f,-0.30140001f,0.57519999f,0.85400000f,-0.07270001f,-0.73770002f,0.60879997f,0.15659998f,-0.10010001f,-0.28550003f,1.17700000f,0.70780003f,0.29110000f,0.14130000f,-0.45590002f,0.37290001f,-0.77839995f,-0.65899999f,-0.17559999f,-0.01599999f,1.08030001f,0.68670005f,1.01399999f,0.08219999f,-0.65549998f,0.41850000f,-0.39180001f,-0.78000000f,-0.75120001f,-0.89339999f,-0.40500001f,-0.11400000f,0.46859998f,-0.21840002f,-0.69630001f,0.24689999f,0.47699998f,0.86490000f,-0.55770002f,-0.29730001f,0.68820001f,0.80100000f,0.16290000f,0.24030000f,0.40950001f,-0.51120002f,-0.91139999f,-0.76169998f,-0.23520000f,-0.40380000f,0.88350003f,0.96540001f,0.44160002f,0.47880001f,-0.04679999f,-0.63960002f,-0.33780000f,0.06000000f,-0.14810001f,-0.78890003f,-0.31109998f,0.36150002f,0.44110000f,0.81530003f,-1.69670000f,-0.88810006f,-0.00540001f,0.09040000f,-0.44370003f,0.42810001f,1.71080003f,0.88220005f,0.92599998f,0.40360001f,-0.34290000f,-0.47030002f,-0.05050001f,-0.17570002f,0.97519996f,0.72020001f,-0.75049998f,0.12810000f,0.45959999f,0.27809999f,-0.63840001f,0.18960001f,0.34080000f,-0.01290000f,-0.42750000f,0.55920002f,0.03750000f,-0.78330001f,0.44370002f,-0.31170001f,-0.54210002f,-0.84209997f,0.30899999f,0.21029999f,0.54570001f,-0.42810002f,0.52980003f,0.84990001f,0.24660000f,0.52499997f,-0.43530001f,-0.10470000f,-0.30990001f,-0.13500000f,0.74519999f,0.66209997f,0.25050001f,-0.59549998f,0.70320002f,0.27340001f,-0.78259998f,-0.14680001f,0.34569998f,0.77770000f,-0.02979999f,-0.35620002f,0.62309998f,0.42050001f,0.01820001f,0.61780004f,0.69969998f,0.95070001f,-0.20539999f,0.49180001f,-0.41619997f,-0.58679999f,0.48280001f,0.55300004f,0.97930002f,0.03610000f,-0.38729998f,-0.61590000f,-0.12149998f,0.38630001f,1.16580002f,0.98620006f,-1.43799997f,-0.90020002f,0.13780001f,0.89090000f,0.21480002f,0.74769998f,-1.21199998f,-1.46860000f,0.50010000f,0.64019999f,0.55859999f,-0.07720001f,-0.78960000f,-1.12819999f,-1.13699996f,-0.94159998f,-0.58920000f,-0.16400001f,-1.35029997f,-0.69570000f,0.39990000f,0.41550000f,0.65159997f,0.75670001f,-0.27120004f,-0.25930000f,-0.22409998f,-0.56290000f,-0.90510002f,-1.13500000f,0.67920001f,0.76990004f,0.11760002f,-0.69140000f,0.83450001f,0.04720000f,-0.03180002f,-0.44939998f,-0.83660001f,0.14579998f,0.46920000f,0.04220000f,0.39589999f,0.32120000f,1.44549999f,0.14100000f,0.10989997f,-0.74719999f,-0.33540000f,0.40220000f,0.69270003f,0.22100000f,-0.49460000f,-0.00820001f,-0.85930001f,0.14559999f,0.40860003f,-0.43679999f,0.24659999f,0.13120000f,-0.25090002f,-0.47200001f,0.42060000f,-0.61680002f,-0.09240001f,-0.28929999f,-0.78809996f,-0.39979997f,0.46649999f,0.55679997f,-0.19289999f,-0.61539999f,0.41520000f,-0.05529999f,-0.17910002f,-0.78969998f,-1.41659996f,-0.92889997f,0.94229999f,0.94680001f,0.13949998f,-0.36510002f,0.08670000f,0.18119998f,0.54900000f,0.78189999f,-1.01879998f,-1.00740001f,0.08160000f,-0.25060000f,-0.82199999f,-0.44430000f,-1.00199999f,0.06999999f,-0.34670001f,-0.22180000f,1.04330002f,-0.36980001f,-0.12550001f,-0.32319999f,-1.26580001f,0.44460000f,0.66719999f,-0.36099999f,1.55750003f,0.09360000f,0.63530003f,0.33580000f,-0.37020000f,-0.15420000f,0.35750000f,0.04259999f,-0.49500003f,-0.18119999f,0.11400000f,-0.18939999f,0.13629999f,-0.43579999f,-0.19980000f,-0.13200000f,0.75209998f,-0.24739999f,0.75420001f,0.97519998f,-0.31649999f,-0.05790000f,-1.00050003f,-1.10590001f,-0.55319998f,-0.26889999f,1.27650000f,1.53139999f,-0.91349998f,-0.96959999f,-0.25500004f,-0.79049999f,0.37049999f,-0.19290001f,-0.12690000f,0.19379999f,0.06869997f,0.08690000f,-0.07619998f,0.41860003f,-0.39629998f,-0.32259999f,-0.75209998f,-0.32309998f,-0.11699999f,0.16440000f,-0.72929997f,-0.89589996f,0.73559997f,-0.25580000f,0.37770002f,-0.04780000f,-0.11570001f,-0.57179998f,0.42750002f,0.14120000f,-1.18170004f,0.20260000f,0.40260001f,-0.34679999f,-0.30840002f,-0.17280000f,0.58440001f,-0.02780000f,-0.78300001f,-0.41299999f,0.72500000f,0.29560000f,-0.16950001f,-0.14560000f,0.16280002f,-0.26300000f,-0.25989999f,0.12299999f,0.28930000f,-0.04080000f,-0.34899999f,0.53339999f,-1.53840003f,-0.30230001f,-0.15630001f,-0.17270000f,-0.94529996f,-0.36349996f,0.21359997f,0.10870000f,0.74490003f,1.03790002f,-0.74939999f,-0.62059999f,-0.33719998f,-0.30320001f,-0.13650001f,-0.15919999f,-0.54569996f,-0.01239999f,0.29159998f,-0.23479999f,-0.17760000f,0.05630001f,-0.46050002f,-0.19840001f,0.27209999f,0.21589998f,-0.20640000f,-0.35570000f,1.04309998f,0.70119998f,0.29310003f,0.40399999f,-0.10270000f,0.36240000f,0.70990003f,-0.50079999f,0.46080002f,-0.53860000f,1.15759999f,-0.20159999f,-1.15470002f,0.13400000f,-0.44500000f,-0.03020000f,-0.25930000f,-0.21080000f,-0.55830001f,-0.35900000f,0.65310001f,0.55480001f,0.43539999f,-0.21000000f,0.01650003f,-0.72340000f,-0.45420000f,0.47839999f,-0.43960000f,-0.35659999f,0.27929999f,0.13039999f,-0.42180002f,0.61890000f,0.79079998f,0.72870001f,-1.15320000f,-1.06910001f,-1.10130000f,-0.82100000f,-0.79199999f,-1.17679997f,0.60060002f,0.91629999f,-0.09329997f,-0.22060001f,-0.27960000f,0.01669999f,-0.50249998f,-0.06610000f,0.81360000f,0.16590002f,-0.57779999f,-0.68379999f,-1.26690001f,-0.62630002f,1.01339998f,0.81839998f,-0.47849998f,0.01280001f,0.02399999f,-0.40090001f,-0.09749999f,-0.14380000f,-0.27640001f,-0.40980000f,-0.19460001f,-0.23700000f,0.71530000f,-0.23379999f,-0.35200000f,0.35740000f,-0.14939998f,-0.64499999f,-0.40350000f,0.23560000f,1.45960006f,0.11800000f,0.02519998f,-0.47499999f,0.06029998f,-0.30179999f,-0.38000001f,-0.77980001f,-0.42460002f,0.18260000f,-0.20929998f,0.08299999f,0.70600002f,0.05420000f,-0.06350000f,-0.00200000f,-0.37800002f,-0.99670000f,-0.72089999f,-0.41660001f,-0.40349998f,-0.21020000f,-0.64829999f,-0.73249999f,0.65850001f,0.33599999f,-1.03889999f,-0.33760000f,0.56519999f,0.55289999f,-0.19140006f,-0.72960003f,-0.78869998f,-0.28899997f,-0.41369999f,0.06670004f,-1.23390000f,-0.38380000f,0.55769999f,0.73920002f,0.10529999f,-0.07750003f,-0.08310003f,-0.31520001f,-0.02040000f,-0.06030001f,-0.37260000f,0.12599999f,-0.31370000f,-0.00759999f,-0.00340001f,0.08340000f,-0.02549998f,0.40719999f,0.64550003f,0.22360000f,0.43870000f,0.25920000f,-0.50270000f,-0.12559999f,-1.03319999f,0.32700000f,0.24200001f,-0.12080000f,-0.15259999f,0.10020001f,1.41120001f,0.14400001f,0.53730000f,-0.23280000f,0.59550003f,0.19200000f,0.17929999f,-0.46199999f,0.35900001f,0.15120000f,0.75030000f,-0.37160001f,0.01680003f,0.01870000f,0.10110001f,-0.05260000f,0.61859998f,0.08769996f,0.27419998f,-0.01110000f,0.31499999f,-0.07810000f,-0.05819998f,0.24570000f,0.98550000f,1.23659999f,-0.40620000f,-0.59940002f,0.28830000f,0.37140000f,-0.10740001f,-0.60939997f,-0.47820001f,-0.29829999f,0.28259996f,0.12870000f,-0.94079998f,-0.73349999f,0.19800000f,0.01300001f,-0.77339998f,-0.12640000f,0.52509999f,-0.05240001f,0.90570003f,-0.48980000f,0.62329999f,-0.65319999f,-0.42690000f,-0.09300000f,0.69790001f,-0.07720000f,0.42809999f,-0.02699998f,-0.00400000f,-0.33739999f,0.60340003f,0.49879999f,0.74520003f,0.37100001f,0.30910000f,-0.39159999f,0.23309999f,-0.20239999f,0.74440003f,0.19480000f,0.60150001f,-0.02680000f,0.24440001f,0.09000000f,0.32899998f,-0.20239999f,-0.36000000f,-0.69130000f,-1.19070002f,-1.18050001f,-1.40759997f,-1.18309997f,-0.00450000f,0.27869999f,-0.43680001f,-0.77330001f,-0.08969998f,-0.06169997f,-0.66689997f,-0.50479999f,0.66599996f,-0.02920004f,0.50309998f,0.05460000f,-0.72540000f,-0.39309999f,-0.30420000f,0.00630003f,0.05639997f,-0.48140003f,-0.18000002f,-0.28050000f,0.08160000f,-0.08700000f,-0.51329997f,-0.38879999f,-0.77529998f,0.64040000f,1.38540002f,0.01419998f,-1.31510002f,0.16139999f,0.48740000f,-0.02580000f,-0.96370002f,0.53820000f,0.37420000f,0.05900000f,-0.23480002f,0.35240000f,0.09999999f,-0.19900000f,0.25520001f,0.10860000f,-0.34810001f,-0.01800000f,0.25270000f,-0.27200000f,0.34270000f,-0.46059999f,-0.36910005f,0.02040000f,-0.21440000f,0.03120000f,-0.40569999f,-0.21399998f,1.47539999f,1.39369999f,-0.36270006f,-0.80460001f,0.69150000f,1.02929999f,-0.27690000f,-0.57399999f,1.37310001f,1.48230001f,-0.04290001f,-0.28440000f,0.70500001f,0.50640001f,-0.41009999f,-0.32519999f,0.13049999f,-0.02360000f,0.04560000f,0.13349999f,-0.63480000f,-0.62870001f,-0.86789999f,-0.50689999f,0.01020003f,-0.12129998f,0.17940000f,0.33300000f,0.44790000f,-0.27200000f,1.27390003f,-0.12920000f,-0.20460000f,0.12300000f,0.38830003f,0.76759999f,-0.38200000f,0.21779999f,-0.61650000f,0.13640000f,0.08520000f,-0.05800000f,0.99340001f,-0.50320001f,-1.02119999f,0.53840000f,1.00850000f,-0.46599999f,0.59779999f,0.60999998f,-0.01139999f,-0.41180000f,0.37629997f,-0.68619999f,0.45460002f,0.52300000f,-0.23370002f,-0.39320001f,-0.25960000f,0.38920001f,-0.64680003f,-1.04130001f,0.29789999f,0.29759999f,1.22999997f,0.42309998f,0.36990000f,0.08679998f,0.30480002f,0.18709999f,-0.19259999f,-0.28680000f,-1.30980002f,-1.44080002f,1.40939999f,1.57139999f,-1.19159999f,-1.25869999f,0.87059995f,0.09379999f,-0.77549998f,-0.51080000f,-1.43309996f,-1.16809998f,0.76769999f,0.12860001f,-0.72600000f,-0.48890001f,-0.04260002f,0.33319999f,-0.80580001f,0.56740002f,1.10020003f,0.34580001f,0.52289999f,-0.28219999f,-0.21209998f,-0.62279999f,-0.67730003f,0.13219999f,-0.82710002f,0.29420001f,-0.44510002f,0.27860000f,-0.58329998f,0.49719999f,0.19499999f,-0.28919999f,-0.82790002f,0.51400001f,-0.25499999f,0.19899999f,-0.56409999f,0.59979999f,-0.29710000f,0.19360000f,-0.16110003f,-0.01580000f,-1.18839998f,0.91840000f,1.36050003f,1.36040003f,0.27569998f,-0.40920001f,-0.64289998f,-0.56049998f,-1.02839997f,-0.40850000f,0.33330002f,0.27150000f,0.78930002f,0.86190001f,0.53490002f,0.29010000f,1.09139998f,0.93569998f,-0.48239998f,-0.14879997f,1.31220001f,1.43510002f,0.56429997f,0.72359999f,1.30349997f,1.11829998f,0.53520000f,0.65670001f,-0.13349997f,-0.33669999f,0.51390000f,-0.49480001f,1.32930001f,0.02679998f,-0.62230000f,-0.38639999f,-0.99330003f,-0.34400000f,-0.28070000f,-0.42820000f,-0.00389998f,0.42140000f,0.12890000f,0.08320000f,-0.84210002f,-0.15760000f,-0.50750001f,0.27219999f,0.10929997f,-0.54680000f,-0.05030002f,0.06620000f,0.97320001f,-0.40820000f,-0.66480000f,-0.22900000f,-0.41960001f,-0.18840000f,-0.24860001f,-0.24239999f,0.64940001f,-0.55650002f,-0.36420007f,-0.86930002f,-0.48719998f,0.07350000f,-0.31379998f,0.31630000f,-0.60209999f,-0.01509998f,0.68189999f,0.21049997f,0.02940001f,-0.22590001f,-0.11579997f,0.15069999f,0.75869998f,0.92390001f,-1.06499998f,-0.75289999f,0.08670002f,-0.03269999f,-1.07790000f,-1.18039999f,-0.17549999f,0.30239999f,-0.17339999f,0.19200001f,-0.32879998f,0.00820002f,-0.25589999f,0.26619999f,-0.39550002f,0.26140000f,-0.70870003f,0.00780001f,-0.42179998f,0.63539999f,-0.02140000f,-0.10260000f,0.48480000f,-0.20800000f,0.29339999f,0.10279999f,1.30350002f,0.19160001f,0.40240000f,0.16940000f,-0.32740000f,0.37280001f,-0.77599999f,0.27519999f,0.40530002f,0.09740000f,-0.34210000f,0.02560000f,1.23220005f,-0.02120000f,-0.30530001f,-0.30080000f,0.41230001f,0.53059997f,0.54990002f,0.40930001f,0.12390004f,0.18090001f,1.31189998f,1.02619998f,-0.33809998f,-0.53200001f,-0.57959999f,-0.68760000f,0.00480000f,-0.34160000f,0.01019998f,-0.49309999f,0.16710000f,-0.13699999f,0.84420002f,0.79360002f,0.76799998f,0.88799998f,0.15689997f,0.12190000f,0.16440001f,0.29010000f,-0.41460003f,-0.83580002f,-0.38579999f,0.07230001f,-0.70140000f,0.22600000f,0.50719999f,-0.47339999f,1.20470003f,0.16460000f,0.81970002f,0.39980000f,-0.00180000f,0.09960000f,-0.99610000f,0.50539999f,0.26890001f,-0.25799999f,0.06420003f,-0.68660000f,-0.23029998f,0.32399999f,-0.79660003f,-0.33680000f,-0.15480000f,-0.12980000f,0.18930001f,0.30100001f,0.23139997f,0.51780000f,-0.18880001f,0.37800000f,-0.46360003f,-0.58600000f,-0.96490001f,0.88960000f,-1.12889995f,-1.14839997f,-0.02070003f,-0.48950000f,0.44249997f,-0.21410001f,0.11460000f,-0.07940001f,1.26089999f,1.29609997f,-0.67619997f,-0.79610000f,-1.22850001f,-0.65760002f,0.56159999f,0.22309997f,-0.33959998f,0.25260001f,-0.18270000f,-0.01800000f,0.60570000f,0.51450002f,0.76410000f,0.09800001f,0.71460000f,0.43960000f,-0.84839998f,-0.10299997f,0.29940002f,0.12579999f,0.18020000f,-0.18520000f,0.51920000f,-0.18819999f,0.73170002f,-0.66700001f,-0.34600002f,0.70940000f,-0.90060001f,0.54179999f,1.52540004f,0.10099999f,0.26230000f,-0.26199999f,0.27400002f,0.20380001f,-1.53940005f,-0.10140002f,-0.77190001f,-0.12419999f,0.33370001f,-0.02680000f,-0.10449999f,0.14900000f,-0.63929999f,-0.29119999f,0.50920000f,0.25459999f,-0.87740001f,0.64259998f,-0.50819999f,-0.63700001f,-0.40649999f,-0.28059998f,-1.50270001f,-1.37150001f,1.42770000f,1.06640001f,1.30469999f,1.29019999f,-0.23850006f,-0.78020003f,-0.49679999f,-0.28449999f,0.42809998f,0.42520001f,0.23850002f,0.77920000f,-0.02309995f,0.28750001f,-0.20340000f,-0.39490001f,0.24810000f,0.07469998f,-0.27659998f,0.27470000f,0.41909996f,0.24160000f,1.29180002f,0.44039999f,0.76950000f,-0.00360000f,-0.65309997f,0.37939998f,0.06870000f,-0.06620001f,-0.12540000f,-0.48459999f,0.02529998f,-0.00140000f,-0.81699999f,0.19619999f,0.31809999f,-0.08460000f,0.46929999f,-0.10080001f,-0.19820002f,-0.25380000f,-0.89320001f,-0.07880002f,0.50949999f,-0.17480000f,0.02689999f,0.12519999f,-0.99190004f,-0.10140001f,1.41240000f,-0.04980000f,0.03819999f,0.59610001f,-0.17969999f,0.51429998f,-0.15720001f,-0.82659999f,-0.09819999f,0.52389999f,0.05020000f,0.17500000f,-0.15660000f,-0.53340000f,-0.09840000f,-0.69459999f,0.10699999f,-0.42840001f,-0.01330000f,-0.80580001f,0.10570000f,0.19480000f,0.29590000f,0.21090000f,0.30609999f,-0.52470000f,-0.25030000f,-0.00759999f,-0.11100000f,-0.63570001f,0.37350001f,0.14530002f,-0.15090000f,1.03950001f,-0.11809999f,-0.56230000f,0.38999999f,0.69780000f,-0.15680000f,0.29410002f,0.48819997f,-0.45570001f,-0.07950001f,-0.76600000f,0.16150000f,-1.14859999f,0.87569998f,1.01500001f,-0.85519998f,-0.30030000f,0.10030001f,-0.81390002f,0.06320000f,0.30130001f,-0.41750000f,0.36140002f,0.87779997f,0.30959996f,0.19579998f,-0.41100000f,0.56490000f,0.83330003f,0.50580000f,-0.75770003f,0.23970000f,-0.38309999f,-0.01240001f,-0.46349998f,-0.17000000f,0.55929998f,-0.22459999f,-0.03670000f,-0.03210000f,0.20410001f,0.15169999f,-0.48139998f,-0.12730001f,-0.78609999f,0.24840000f,0.44990001f,-0.02430000f,-0.02260000f,-0.14840000f,0.25109999f,-0.01009999f,0.49589999f,-0.22740000f,-0.52500001f,-0.13820000f,0.10660000f,-0.16090001f,-0.33530001f,0.04300000f,0.79900000f,0.21410000f,0.54100001f,0.64810001f,-0.14200000f,0.31709999f,0.55670000f,-1.01799998f,0.22640001f,0.70179998f,0.06059999f,0.08570001f,-1.12120000f,-0.04670000f,-0.94270004f,-0.06119999f,0.49740001f,-0.30129996f,-0.22749998f,-0.26940000f,0.66120003f,0.27819998f,0.19349999f,0.20310001f,0.61090000f,-0.11819999f,0.36810000f,0.59209997f,-0.16020001f,-0.35579999f,0.67099998f,-0.09530000f,-0.05940000f,0.02670000f,-0.81540002f,-0.05550000f,-0.27229999f,0.11640000f,0.91790000f,-0.09780001f,-0.60309998f,0.25070000f,-0.62050001f,-0.00610000f,0.11460001f,0.03720000f,-0.03750001f,0.24929999f,-0.20620000f,0.15500000f,-0.07079999f,-0.04820000f,-0.22569999f,0.13689999f,-0.58179999f,0.10020000f,-0.10860000f,-0.07010000f,-0.52699998f,0.10940000f,0.10680000f,-0.02029999f,-0.14460001f,0.36309998f,0.96070000f,-0.34309997f,-0.42780000f,-0.52810001f,0.48360002f,0.43379999f,0.25199999f,0.50279998f,0.37620000f,-0.15099999f,-0.27720000f,0.36199997f,1.09829999f,-0.05780001f,-0.92710000f,-0.00770000f,0.35010002f,0.08020002f,0.32840000f,-0.08110000f,-0.03310000f,0.25509999f,-0.15890000f,-0.51520000f,-0.58270000f,-0.22020002f,-0.60320001f,0.12470000f,-0.25480000f,0.05130001f,-0.59059999f,0.23870000f,-0.12310000f,-0.04430000f,0.69820002f,0.00380000f,-0.53040000f,-0.29560000f,0.06840000f,0.24380000f,-0.36769999f,-0.18559999f,-0.05330000f,0.04300000f,0.01440001f,0.04450000f,-0.10990000f,0.12780000f,-0.40290001f,-0.07410000f,0.26659999f,-0.07350000f,-0.12350000f,-0.04039999f,0.72589999f,-0.16219999f,-0.56709998f,-0.73449998f,-0.39909999f,0.76249999f,0.25809998f,0.59500000f,0.50730000f,0.71119997f,-0.50800000f,-0.41329999f,0.55950001f,0.51759995f,0.21559998f,0.07570001f,0.49760001f,0.31129999f,0.88110001f,-0.43750002f,-1.24320002f,0.52659998f,-0.01760000f,0.56770001f,1.09440000f,-0.61099999f,-0.40650000f,0.14739999f,0.83840000f,0.35949998f,-0.46289999f,-0.24520000f,0.32110000f,0.24650000f,0.31730001f,-0.05130000f,-0.79050001f,0.01820000f,-0.76510002f,-0.07760000f,-0.63279999f,-0.07390000f,0.62750000f,-0.41279999f,0.32729999f,0.00629999f,-0.12750000f,-0.13130000f,-0.10760000f,0.12750001f,0.28210002f,-0.12100000f,-0.34039999f,0.03350000f,-0.79660003f,0.02580000f,0.67819999f,-0.00180000f,-0.20970000f,-0.23390000f,0.13609999f,0.15520000f,-0.53010002f,0.56179999f,0.74450001f,0.30759999f,0.45520000f,0.41809999f,-0.12530002f,-0.11420001f,-0.36580002f,0.33240000f,1.11090000f,-0.37929999f,-0.07500000f,0.07440004f,-1.10060003f,0.21579999f,0.74190002f,-0.19289999f,0.51180002f,0.48740001f,1.44670004f,-0.60719999f,0.07370003f,0.23629999f,-0.06110001f,-0.01059998f,-0.51800000f,0.10950000f,0.01960000f,0.23760000f,-0.56980000f,-0.19820000f,-0.24190001f,-0.11160000f,-0.12770000f,0.02429999f,-0.54059998f,-0.20020000f,0.61050000f,0.10240001f,-0.67890002f,0.02130000f,0.40030000f,0.22239999f,-0.54340001f,0.12460000f,-0.57490000f,0.29810000f,-0.48119999f,0.02420000f,-0.69810002f,0.18920000f,0.27610000f,-0.24190000f,0.27959998f,0.13859999f,-0.27990000f,-0.08270000f,0.05990000f,-0.09720000f,-0.75150000f,0.15649998f,0.17139998f,0.08719999f,-0.15640001f,0.01189999f,-0.67380001f,-0.30229999f,-0.70750002f,-0.09230000f,-0.68480000f,-0.04050000f,0.52539999f,-0.82379998f,0.24389999f,0.55839999f,-0.05710002f,-0.33799999f,-0.00740001f,-0.03720000f,-1.09230001f,-0.00689998f,0.06780001f,-0.45149997f,-0.59340000f,0.67069998f,0.53360000f,-0.18460000f,-0.43540001f,0.71049998f,-0.28800000f,-0.16650000f,0.18930001f,-0.10080000f,0.13610001f,-0.23230000f,0.55089998f,0.21830001f,-0.11070000f,0.01910000f,0.09790000f,-0.02150000f,0.07130000f,0.10980000f,0.70410000f,-0.23320000f,-0.11880001f,0.12520000f,0.11050000f,0.26800001f,-0.51719998f,0.25210000f,-0.57270000f,0.31830000f,-0.17010001f,-0.13510000f,-0.50410000f,0.11740000f,-0.03099999f,-0.14210000f,0.07540000f,0.52409998f,-0.33739999f,0.78770000f,0.11549999f,0.91229998f,0.53720000f,-0.11609999f,0.43980001f,0.51769999f,-0.39920001f,-0.17910000f,-0.17790001f,0.53019998f,0.46339999f,-0.18579998f,-1.16990002f,-0.40219999f,-0.99630003f,0.19970001f,0.43210001f,-0.19389999f,0.23940002f,0.20520001f,-0.82250003f,-0.01309998f,-0.31740000f,-0.01240000f,-0.29770001f,0.72599995f,-0.23159999f,-0.18370000f,-0.17830000f,-0.02850000f,-0.86540002f,-0.08390000f,-0.90529999f,0.02610000f,0.05520000f,-0.12690000f,-0.29790001f,0.22550000f,-0.29759998f,-0.15500000f,-0.29010000f,-0.01300001f,0.30479999f,0.22500000f,0.00530000f,0.15470000f,-0.60990000f,0.28470000f,-0.43609999f,-0.06480001f,-0.05260001f,0.15990000f,-0.33550000f,0.01520000f,-0.00580000f,-0.30639999f,0.82540001f,-1.08389998f,-0.38830002f,0.18200002f,-0.90239998f,-0.45109999f,0.61840003f,0.40999998f,-0.33610001f,-1.10889998f,-0.09639999f,0.14480000f,-0.35630000f,-0.39040000f,-0.37220000f,0.28699999f,0.21640000f,-0.09099999f,-0.31960001f,0.03410000f,0.23480001f,0.54929999f,0.19330000f,0.30110001f,0.50740000f,0.36589996f,0.11510002f,-0.27319999f,0.13330000f,-0.59089998f,-0.19280000f,0.16470001f,0.91450000f,0.19320000f,-0.61250002f,-0.10130000f,0.73179999f,-0.13440000f,-0.15730000f,0.19250000f,0.86600002f,-0.03800000f,-0.06570000f,0.00400000f,0.46740002f,-0.05180000f,-0.22890000f,0.05740000f,-0.00910000f,-0.09130000f,0.15770000f,-0.14370000f,-0.32530000f,0.13529999f,-0.68819999f,-0.32670000f,0.31310002f,0.10720000f,0.06880000f,0.21890000f,1.07620001f,0.49770001f,-0.65720001f,-0.21239999f,-0.03990000f,-0.54309999f,-1.41980002f,0.17059998f,-0.17020001f,0.16329996f,0.11099999f,0.28479999f,-0.01200001f,1.05020000f,0.03130001f,-1.18399997f,-0.04650000f,0.82950000f,0.00439999f,-0.30379999f,-1.32999998f,0.52279998f,0.59489999f,1.02829997f,0.71920001f,-0.28560002f,-1.10000002f,0.62930000f,0.67680002f,0.31520000f,0.16880000f,0.04510000f,-0.65590001f,0.02160000f,0.20189999f,0.01950000f,0.66210000f,-0.31220000f,0.52309999f,-0.31729999f,0.52969999f,-0.12960000f,-0.03700000f,-0.16740001f,-0.85140002f,0.22680000f,0.87320000f,-0.04430001f,-0.87289999f,0.00060000f,0.42000000f,-0.11200000f,-0.38630001f,-0.19590001f,-0.79379999f,0.00320001f,0.38150000f,-0.24010001f,-0.22190001f,-0.25480000f,0.09760001f,-1.04440001f,-0.25470001f,-0.04960000f,-1.24130004f,0.30769999f,0.09570000f,0.46049999f,1.08539998f,0.09469998f,0.16900001f,-0.49550001f,0.10710000f,-0.02470002f,-0.19460001f,-0.67429999f,-0.34690000f,-0.00539999f,0.37050000f,-1.13609998f,-0.13249999f,-0.68199996f,-0.04169999f,-0.88129997f,-0.48940000f,-0.57769999f,-0.02830000f,0.49849996f,0.02279999f,-0.44379998f,0.74700000f,0.17200001f,0.84490003f,0.09640000f,-0.10229999f,0.07630000f,-0.54079998f,-0.00490000f,-0.58230001f,-0.28550000f,0.53460000f,-0.03330000f,0.65300002f,-0.23570000f,0.57840000f,0.02630001f,0.74849998f,0.20339999f,-0.47759998f,0.25370000f,0.75950002f,0.26640000f,0.19270000f,0.10650000f,0.81479999f,0.19370000f,0.23610000f,-0.34370000f,0.20080001f,-0.02540000f,0.76660002f,0.29630002f,-0.91289997f,0.17150000f,0.99470000f,0.10130000f,1.16280003f,0.07130000f,0.87820002f,-0.14630000f,-0.67860003f,0.22149999f,-0.26380002f,0.26289998f,0.72360000f,-0.76109998f,0.00430003f,0.71309999f,0.71050002f,0.08569998f,-0.09860000f,0.76939999f,-0.05940000f,-0.04219999f,0.79860000f,-0.03920000f,0.58060001f,0.07179999f,0.54520001f,-0.15160000f,-0.43350002f,0.10130000f,-0.53570002f,-0.04270000f,-0.15190000f,-0.10570000f,0.06670000f,0.12110000f,-0.40380001f,-0.13490000f,0.51380000f,-0.15550000f,0.10890001f,-0.27370000f,0.28310000f,0.21950000f,0.39080000f,-0.13230001f,-0.56889999f,-0.10130000f,0.13620001f,-0.04540000f,-0.79670000f,-0.00180000f,0.01489999f,0.03040000f,-0.05180000f,0.02820000f,-0.17539999f,0.29600000f,-0.01240000f,-0.20270001f,-0.15940000f,0.19129997f,0.37820000f,-0.84239999f,-0.64380001f,0.63319996f,0.05689999f,0.50319999f,-0.04620001f,0.27219998f,-0.40710000f,-0.10429999f,-1.09350002f,-0.02260001f,-0.52550001f,-0.68100000f,-0.29110002f,-0.56159998f,0.12160001f,-0.35749997f,-0.33749999f,-0.14870000f,0.19490000f,0.29940002f,-0.77360004f,0.01170001f,0.69040001f,0.57009999f,0.61349999f,-0.10250000f,0.48060001f,-0.28690000f,0.41420001f,0.09520001f,0.80249999f,-0.35039999f,0.05629999f,-0.09600000f,-0.36880000f,-0.16059999f,0.06800000f,0.26030000f,-0.42069999f,0.01500000f,0.01770001f,0.15580000f,0.45700002f,0.03040000f,0.58399999f,0.26630000f,-0.17380000f,0.00230000f,0.15990000f,0.10300000f,-0.55000001f,0.08470000f,-0.24130000f,-0.11250000f,0.24220001f,0.98299995f,0.28999999f,-0.05849998f,-0.99730002f,-0.11109999f,-1.14950002f,0.12299999f,-0.19200001f,-0.87209997f,-0.06970000f,0.74709996f,0.11949997f,0.58760002f,0.99930001f,-0.05570000f,-0.39530002f,0.06699999f,1.03820003f,0.07820000f,0.29700000f,-0.65829999f,-0.48840002f,-0.12080002f,-0.98930000f,-0.32920001f,-0.45580000f,0.24359999f,1.22030004f,-0.20950001f,0.56180000f,-0.25179999f,-0.59169999f,0.22330000f,-0.39440000f,0.04230000f,0.08940000f,-0.13180000f,0.16680000f,0.05289999f,0.90640000f,-0.27270000f,-0.25850000f,0.01200000f,-0.76610003f,-0.19150000f,0.52329999f,-0.04300000f,-0.03060000f,-0.01500000f,-0.07190000f,0.29790001f,0.11440001f,-0.14920000f,0.53170002f,-0.03800000f,0.49580001f,0.05520000f,-0.47180000f,-0.09009999f,0.40410000f,0.62339998f,0.07579999f,-0.00659999f,0.00350000f,1.07529999f,0.46140000f,-0.91619999f,-0.79960000f,-0.91079999f,-0.18119998f,0.09360004f,-1.11580001f,0.12770001f,0.25660000f,-0.62339998f,-0.38300001f,-0.08440001f,1.12310005f,0.06449997f,0.66509998f,0.28069999f,-0.21470001f,0.00750000f,-0.18940001f,-0.03910000f,0.88739999f,-0.52299996f,-0.63199998f,-1.03580000f,0.57429999f,-0.25380000f,-0.15440000f,0.22380000f,-0.50509998f,-0.15490000f,-0.93040002f,0.11940000f,0.84130002f,0.07960001f,0.89609999f,0.23439999f,-0.59270001f,0.11990000f,-0.43709999f,0.34740000f,-0.04510000f,-0.24320000f,0.60169999f,-0.15009999f,0.23580001f,-0.08710000f,-0.11970000f,-0.10870000f,0.24940000f,0.03550000f,-0.07850000f,0.31019999f,-0.06570000f,0.17980001f,-0.38760000f,-0.12269997f,-0.43619998f,-0.78709996f,-0.08279999f,0.31790000f,0.00510000f,0.23320000f,0.84600001f,-0.47309998f,0.08350003f,-0.67359997f,0.30260001f,-0.38029996f,0.02710003f,0.40509998f,-0.19759999f,-0.08840000f,0.56650003f,0.33159999f,0.60770002f,0.49289998f,-0.11510000f,-0.43249996f,-0.13929997f,-0.33190000f,0.84110004f,0.29700001f,-0.83429999f,-0.27539999f,1.09859995f,-0.53280002f,-1.38799999f,-0.07170000f,-0.38420002f,0.65460002f,1.41839999f,-0.09750001f,0.18330001f,-1.07189999f,-0.25989995f,-0.39300000f,0.22760000f,-0.00660002f,1.07060002f,-0.44490004f,-2.09089995f,-0.50400001f,-0.74799999f,-0.47910002f,-0.82019999f,0.98970000f,-0.12760001f,1.36019999f,-0.22530002f,-0.20340002f,-0.91869997f,0.01530000f,0.00910000f,-1.12590002f,0.22609999f,0.24540001f,-0.34670000f,0.44760000f,-0.28850002f,-0.09990001f,-0.05460000f,-0.11480001f,-1.01339998f,0.01590000f,0.35340000f,0.38000000f,0.47869998f,0.31950001f,0.28000000f,-0.10050001f,-0.50279999f,-0.19510001f,0.97699996f,0.13089999f,0.38740000f,-0.15840001f,0.03229999f,-0.19000000f,0.71819999f,0.00950001f,0.31090000f,-0.45730000f,0.34909998f,0.25010000f,0.78909999f,-0.35850002f,-0.88370001f,-0.48929999f,-0.72030004f,0.70680002f,0.75939998f,1.13580002f,-0.51300001f,-0.18060001f,0.44980000f,-0.76470000f,0.30049999f,-1.08450004f,-0.59560000f,0.90480002f,0.16839999f,0.27180003f,2.03739995f,-0.80009999f,-0.21099995f,0.90990001f,1.14129996f,0.47430003f,1.82460001f,-0.84540000f,-0.56089994f,0.65730000f,1.05889997f,-0.16079999f,0.18769999f,-0.35980000f,0.40459999f,-0.17780001f,0.70879998f,-0.23060000f,-0.15010000f,-0.08980000f,0.08580001f,-0.11860000f,0.80079999f,0.01890000f,-0.19590001f,0.21610001f,0.40660001f,-0.48050000f,0.03230000f,0.26650001f,0.55579999f,0.41159999f,-0.17280002f,0.15369999f,-0.54600001f,0.06610000f,-0.01439999f,0.49270000f,0.12439999f,0.24430000f,-0.84209998f,0.04150000f,1.11909999f,0.02130000f,0.39660001f,0.50310002f,1.86039995f,0.69089999f,0.40289997f,0.10410000f,0.20660001f,0.06300002f,1.49600001f,0.43620002f,0.24829998f,-1.13040004f,-0.53379998f,0.78419999f,0.59689997f,-0.95880002f,0.04980001f,-0.32849997f,-0.31560002f,-0.51059997f,-1.58439997f,-0.55140002f,-0.71599998f,-0.90300001f,-0.44520002f,-0.44129998f,-1.95549993f,-0.67530003f,0.95480001f,0.06440000f,0.29120000f,-0.24579999f,0.56290001f,-0.12840001f,0.40289999f,-0.12080000f,0.13090001f,-0.30450000f,0.35789999f,0.17810000f,-0.12839998f,0.04800000f,-0.48579999f,-0.19530000f,0.50030001f,-0.31140000f,0.78470001f,0.22390002f,0.77199999f,0.02850000f,-0.92190001f,0.35600000f,-0.09170002f,0.13580001f,0.98810000f,0.14040000f,-0.20590000f,0.24640000f,0.58600004f,-1.01640000f,-0.77279994f,-0.40350003f,0.24430004f,0.55830002f,1.40349997f,-0.24750002f,-0.22929997f,0.61560001f,1.19369998f,0.15660000f,0.17400001f,0.68280001f,0.06419999f,-0.11940002f,0.57530001f,0.13049996f,1.33690000f,-1.39170005f,-0.18200000f,0.14040003f,-1.55130000f,-0.36780000f,-0.27750003f,-0.66450002f,1.14150002f,-0.15630001f,-0.45250001f,-0.83490000f,0.68619998f,-0.21100000f,0.29040003f,-0.00459999f,-0.47290001f,-0.16990002f,-0.99419998f,0.09220000f,0.11970000f,-0.03000000f,-0.51459998f,0.37440000f,0.92520000f,-0.08430000f,-0.18280001f,-0.02190000f,1.00370001f,-0.15250000f,-0.91299998f,-0.20180000f,-1.20859997f,-0.09589999f,0.28020000f,-0.23840001f,-0.68209999f,0.22920000f,0.37069999f,0.16700001f,-0.19810000f,0.07510000f,0.48619999f,-0.15540003f,0.10240005f,0.81720000f,0.21489995f,1.22490003f,-0.41580000f,-0.17130000f,0.09950000f,-0.25289999f,-1.37779993f,-1.39440004f,0.28280001f,1.07220001f,1.03639994f,-0.59700003f,1.08390002f,0.97650001f,-0.58340000f,1.17750000f,-0.93180000f,0.54449998f,1.18499997f,0.64830002f,-0.69150000f,-0.80880000f,-0.14229999f,-0.85290003f,-1.37230000f,-0.61740001f,-0.26160003f,-0.27630000f,-0.40380000f,-0.23280000f,0.21199999f,0.07500000f,-0.96400001f,0.10220000f,-0.35269999f,-0.38149999f,0.04560002f,-0.40370001f,-0.64710001f,0.23110000f,0.67300000f,-0.35439999f,-0.25419999f,-0.35130000f,-0.09929998f,0.41300000f,-0.22190000f,0.04090000f,-0.98829997f,-0.01170000f,0.32000000f,0.05940000f,1.02130000f,-0.12770000f,0.10560001f,0.18840000f,-0.16160003f,1.01220001f,0.30619997f,0.39840000f,0.69359999f,0.44250003f,-1.16040001f,0.00210000f,-0.56009999f,0.68639996f,0.60079998f,1.21620005f,-0.02690001f,-0.55230000f,0.79860001f,0.86639998f,0.30299996f,0.40769997f,-0.03030000f,-0.65910001f,-0.86690000f,0.09960000f,-1.72169996f,-0.04440000f,0.54240000f,-0.34200001f,1.56470001f,0.01199999f,0.07360001f,-0.65430000f,0.33549998f,-0.15450001f,-0.14450000f,-0.33599999f,-1.16759995f,0.35290000f,0.50920000f,0.07140000f,-0.54739997f,0.04329999f,0.28359999f,-0.49750000f,0.02040001f,-0.04010000f,0.47380000f,0.26790000f,-0.46680002f,-0.13780000f,-0.41269997f,-0.43729999f,0.25249998f,-0.01479999f,0.92139998f,0.16640000f,-0.63449998f,-0.01810000f,-0.64439998f,0.19390001f,0.70510001f,0.34180000f,0.03449999f,-0.28050000f,-0.84509999f,1.46159997f,-0.61320000f,-0.79890000f,0.28080002f,0.17969999f,-0.72499998f,0.05100001f,0.66759997f,0.74610002f,0.50160004f,-0.23250001f,0.54580001f,-0.25289997f,-0.94320001f,1.05959999f,0.51389998f,0.71790001f,0.97949997f,-0.02400000f,1.72739998f,-0.35370002f,-1.52309997f,0.32820000f,-0.80919999f,-1.18530004f,-0.05949997f,-0.47160000f,-0.18579999f,0.18860000f,0.02480000f,0.28380000f,-0.15319999f,0.02629999f,-0.02610000f,0.30729999f,-0.17990001f,-0.54220000f,0.18690003f,-0.06980000f,-0.70370000f,0.21550000f,-0.01850000f,-0.30299999f,-1.32370000f,0.36730000f,-0.52670003f,0.43610000f,-0.18570000f,0.31070000f,0.26840000f,0.00320000f,0.43010000f,0.30820000f,-0.27519998f,-0.36169999f,0.14309999f,-0.20850000f,0.11699998f,0.01890001f,0.29080001f,-0.13319999f,-0.15399999f,0.30870001f,0.40769998f,-0.36899996f,-0.50529998f,0.73169997f,0.75150002f,0.90510003f,-0.18350003f,-0.78150000f,-0.87109997f,1.42620001f,-0.92550004f,0.11280003f,-0.43770006f,-0.30509999f,-0.27990000f,-0.47400000f,0.21800001f,-0.63870001f,-0.05169997f,-0.07740001f,-0.28399999f,0.36749998f,0.36969997f,-0.11730002f,-0.10369999f,0.45210000f,0.27630000f,0.00560000f,-0.13150000f,0.32880000f,0.03020000f,0.19030002f,0.46269998f,0.28800000f,-0.02970002f,-0.06140000f,-0.45819999f,-0.17200001f,-0.25910000f,0.46070000f,-0.33620000f,0.36770000f,-0.45150002f,-0.09530000f,0.40060001f,0.30790002f,1.35090001f,-0.21199999f,0.98230002f,0.32830000f,0.74519998f,-0.02760000f,0.36710000f,-0.18480000f,-0.69909998f,-0.96959999f,-0.29109996f,0.33420001f,0.21589999f,-0.51660000f,-0.27979998f,-1.15860004f,-0.49430001f,0.08370003f,0.38969997f,-0.01559999f,-0.97619998f,1.05510003f,0.76469998f,-0.46889999f,-0.76899999f,-0.02309999f,-0.48050005f,-0.56220004f,-0.11579998f,-1.45110006f,0.94910002f,0.04919995f,1.71969999f,-1.08509998f,0.31120003f,-0.60930001f,-0.16789998f,0.49620002f,-0.13020000f,0.16780000f,0.13610000f,-0.19709999f,0.72579999f,0.09889999f,-0.17539999f,0.26409999f,-0.04480001f,-0.11180000f,-0.77299999f,0.30959999f,-1.00640001f,-0.32279999f,0.94499998f,0.20300000f,0.31719999f,0.16319999f,-0.26210001f,0.22030000f,-0.64980000f,0.26369999f,0.27559998f,-0.18410001f,-0.96029999f,-0.19660000f,0.07420000f,0.31650000f,-0.14960000f,0.21560000f,-0.60179998f,-0.82050001f,-0.68169996f,-0.25050002f,0.82660000f,0.53520001f,0.51699999f,-0.44699998f,-0.40239998f,0.41190001f,-1.04900000f,-0.26939996f,-1.95919997f,0.28140000f,1.84219997f,-0.70170002f,-0.12720001f,0.14850002f,-0.11230002f,0.11940000f,-0.83500002f,-0.30419999f,0.41319997f,1.13010004f,-0.49810000f,0.62010000f,0.77659998f,-0.36389999f,-0.42919998f,-0.22289999f,-0.35710000f,0.30130000f,-0.58160001f,-0.54250000f,-0.16889997f,0.11710000f,-0.56840000f,-0.36230001f,0.66350001f,0.22300001f,0.31200001f,0.30920000f,-0.26780000f,0.05639999f,0.28749998f,-0.05980000f,0.12420000f,-0.40270000f,0.29450000f,-0.13030000f,-0.47239999f,0.06130000f,0.53779999f,-0.10000001f,-0.88019996f,-0.38100000f,0.35619998f,0.15590000f,-0.10560001f,0.01679999f,0.55549995f,0.02670002f,-0.73880002f,0.97890001f,0.40730003f,0.30510002f,-0.53920002f,0.28140000f,1.25370002f,-0.94050004f,-0.44519999f,-0.42029999f,-0.74379999f,0.07230001f,0.71969996f,0.04769999f,0.23700000f,0.58859998f,0.92109997f,0.59280001f,-0.23959999f,-0.40020001f,0.55339999f,0.87720000f,-0.59739999f,0.67080001f,1.17899997f,-0.35460000f,-0.51599999f,1.00110003f,-1.01389999f,-0.35350001f,0.88790001f,0.15770000f,0.58590000f,0.13550000f,0.76990000f,0.07800000f,-0.23560001f,0.26459999f,0.09429999f,-0.10599999f,0.16090000f,0.20560000f,0.16839998f,0.13170001f,1.10539999f,-0.21850000f,0.57370000f,-0.08780001f,-0.21290001f,-0.04220000f,0.81379995f,0.21240001f,0.63990002f,0.07820000f,-0.81450001f,0.19580000f,-0.17890000f,0.16189999f,-1.82809999f,0.27660000f,1.69010003f,-0.50850001f,0.60690000f,-0.41490001f,1.06610000f,0.32910002f,0.09119998f,-0.01409999f,0.46649997f,-0.50790001f,-0.51529997f,-0.09119999f,0.43479998f,-1.06200002f,0.81220002f,0.31530000f,1.29269999f,1.06830002f,0.96889996f,0.04230001f,1.58019993f,-1.06110006f,0.00810002f,0.09990002f,-1.34310000f,-0.49800000f,-0.81029998f,0.44640003f,-0.37630000f,0.03670000f,0.71679999f,0.03600001f,0.73739998f,-0.00440000f,-0.25470000f,-0.01560000f,0.66139997f,-0.36180000f,0.25169999f,0.31649999f,-0.49359999f,-0.19709999f,0.10069997f,0.23700001f,-1.01140001f,0.06490001f,0.21800000f,-0.08790001f,-0.84390000f,-0.30050000f,-0.60220000f,-0.23620000f,0.54849999f,-0.09210000f,-0.34279999f,0.27819999f,-0.62910000f,-0.19130000f,0.16509998f,-0.38640001f,0.88959999f,-1.19940001f,-0.19819998f,0.75239999f,0.54629995f,-0.35610000f,0.76459997f,0.25319999f,0.42069999f,-0.36989998f,-1.10119996f,-0.41190001f,-0.60310003f,-0.04709999f,-1.74420002f,-0.73770003f,-0.52719999f,0.94110003f,-0.42490001f,1.18320001f,0.13259997f,-0.08490001f,0.66910000f,0.43410000f,-0.16560000f,-0.17699996f,-1.13929997f,0.46200002f,0.31740000f,-0.13760000f,0.34309997f,-0.30570000f,-0.23529999f,-0.13489999f,0.54959999f,-0.25520000f,0.45200001f,0.24669999f,1.02540002f,-0.13180000f,0.45730002f,-0.21330000f,-0.20699999f,0.17440001f,-0.15409999f,0.32159999f,-0.20740003f,-0.03980000f,0.15390000f,-0.61790000f,0.34150004f,0.00590000f,1.03219997f,-0.10690001f,-0.68779998f,0.10870000f,1.12179998f,-0.31779999f,1.53660000f,-0.19980000f,0.22689998f,0.41490000f,-0.23029999f,0.08159999f,1.01839997f,-0.34140003f,0.10560003f,-1.08150000f,0.76300007f,-0.98340006f,-0.63209997f,0.17339999f,-0.40419999f,-0.68160003f,-1.04149999f,0.14310004f,0.16779994f,0.26100000f,0.61289999f,0.66569999f,0.87130005f,-0.35040000f,1.51259996f,0.99000003f,-0.07779998f,-0.69690001f,1.32339999f,0.06300000f,-0.65119998f,0.09290000f,0.98020002f,0.08330000f,0.24959999f,0.36390001f,0.04469999f,0.21140000f,0.03050000f,-0.13380001f,-0.23319999f,0.48160000f,-0.51139998f,0.07810000f,0.56639998f,-0.02600000f,0.34800001f,-0.10649999f,-0.34429998f,-0.06580000f,-1.10260001f,-0.14670000f,-0.81499997f,-0.06190000f,-0.62529999f,-0.03389999f,0.87599997f,-0.23030001f,-0.32699999f,-0.47220000f,-0.01799997f,-0.99840003f,0.61420004f,-1.02900001f,-0.84879997f,-0.51689999f,-0.21190000f,-0.72870002f,-0.70809999f,0.44310001f,0.01040001f,-0.56789999f,-1.22019996f,-0.44369999f,0.56759998f,-0.10500001f,0.49600001f,-0.19470003f,-1.05649998f,0.88050003f,-0.98260002f,1.09560000f,-0.22260002f,0.15300000f,-1.06549999f,-0.54630000f,0.89400000f,0.88590003f,0.33220001f,0.79740001f,0.41399998f,0.11760001f,0.71520000f,0.03809999f,-0.50629997f,-0.11030000f,0.53080001f,0.27450001f,-0.65429999f,-0.40969998f,0.21709999f,0.14790001f,0.50199999f,0.03910001f,0.75079999f,-0.34689999f,0.82130001f,-0.29190000f,0.57259998f,0.00729999f,-0.02480001f,-0.14299999f,0.36160000f,-0.11190000f,-0.17149999f,0.40220000f,0.46080000f,-0.10190000f,-0.63750002f,0.13110000f,0.39880002f,0.57100001f,-0.45580005f,-0.36259999f,-0.01820003f,-1.22640001f,0.61640002f,0.26999999f,-0.13429999f,0.45019997f,-1.12009998f,-0.08259999f,-0.42780000f,-0.38140000f,-0.08799999f,1.35490000f,-0.34020006f,0.94550002f,-0.50749999f,0.80820000f,-0.46700002f,-0.54249999f,1.07629996f,-0.24119998f,1.45609997f,0.62149999f,-0.15920003f,0.01480000f,0.01430000f,0.31399999f,0.26030000f,-0.13250000f,-0.40390001f,-0.55149999f,-0.41690002f,-0.27280000f,0.22960000f,-0.05539997f,-0.32620000f,-0.08800000f,0.19600000f,-0.58550001f,0.05629999f,-0.08760001f,-0.21120001f,-0.18459999f,-0.03140000f,-0.25840001f,0.84160000f,0.09220000f,-0.01659999f,-0.33390000f,0.37350000f,-0.28840003f,0.72400002f,0.46109998f,-0.08669999f,0.41350000f,0.52610000f,-0.41720000f,0.22040002f,0.36640002f,-0.31050004f,-0.07979997f,-0.43810002f,-0.88010000f,0.71470001f,-0.31919999f,1.25339997f,-0.19789999f,-0.22070000f,-0.41259998f,-0.80490000f,0.59630002f,-1.10930003f,-0.63230000f,0.96429999f,-1.20049998f,0.15590006f,0.51049998f,-0.84409997f,-1.18099999f,0.90710000f,-1.22940004f,0.38940005f,1.05249995f,-0.88799997f,-0.26890000f,0.60060004f,-0.29970000f,0.33750001f,0.63720000f,0.32400000f,-0.33500000f,0.72740000f,0.10610000f,0.15670000f,0.09120000f,0.10680001f,-0.18880003f,0.62800001f,-0.27650001f,0.01729999f,0.13000000f,-0.13000000f,0.54090001f,0.33750000f,-0.20320002f,0.04480000f,-0.64979999f,-0.26820001f,0.31220001f,-0.60740000f,0.27180001f,-0.22140000f,-0.56260000f,-0.26540002f,0.19790000f,-0.80629999f,-0.06010001f,0.50990001f,0.49199999f,-0.04279995f,-1.30399998f,0.42020004f,-0.33719999f,0.70209999f,-0.03160000f,0.09080000f,-0.82420004f,-0.03139996f,-0.56650001f,0.46340001f,0.81590001f,-1.17530002f,-0.00309998f,0.76260001f,0.16470000f,-1.01570000f,-0.41099998f,-0.29040001f,1.17229998f,-0.44709998f,0.79750001f,-0.55190001f,-0.03149998f,-0.89930003f,1.17469996f,-0.33940001f,-0.12410000f,0.30000001f,0.47040001f,-0.16799999f,0.60389998f,0.27810001f,-0.33369999f,0.51730001f,0.41230000f,0.00890001f,0.07169999f,0.51150000f,-0.48220002f,-0.04339999f,-0.38180000f,-0.10780000f,0.29690000f,0.33670001f,0.23369999f,0.64830001f,0.11719999f,0.04479999f,0.31470001f,-0.63870001f,-0.52849999f,-0.22030001f,-0.34410003f,0.48450002f,-0.10930000f,-0.21830001f,-0.29220001f,-1.18540000f,1.21799998f,-1.05559997f,0.69399998f,-0.48329998f,-1.14139998f,0.51250003f,0.62179999f,-0.27110000f,-0.66030001f,0.56580003f,-0.63450002f,0.18209998f,-0.70320000f,0.74619997f,0.12530000f,-0.18659999f,-0.34999998f,0.02810000f,0.76870002f,-1.47930001f,0.89309998f,0.24540001f,-0.28439997f,-0.34210002f,-0.54240002f,-0.77329999f,0.13340001f,-0.12750002f,-0.10020001f,0.26940000f,0.47440000f,0.16640002f,-0.36490001f,-0.04550002f,-0.00099997f,-0.27619999f,-0.15490000f,0.02170000f,0.54120000f,-0.47999999f,-0.32600000f,0.15320000f,-0.52300001f,0.27099999f,-0.02330001f,0.52730002f,0.10460001f,-0.30980000f,0.22680002f,-0.45360000f,-0.33620002f,0.41900000f,0.44130003f,-0.25770000f,-0.12970000f,-0.03590000f,0.35770002f,-0.47650001f,-0.04520001f,-0.72349998f,0.51459999f,-0.20060001f,-0.80179999f,0.87769997f,-0.33870000f,1.33829999f,-0.13000000f,-0.18130000f,1.22019996f,-0.20019999f,0.12320003f,-1.49080002f,-1.40169999f,1.09889998f,-0.21450000f,-0.71539999f,-0.05930001f,1.07929998f,0.12480000f,1.31239996f,-1.05030000f,0.51389998f,0.46860001f,0.71750001f,0.25640001f,-0.84570000f,1.27520002f,-0.83070002f,0.02449999f,-0.20840002f,0.10480000f,0.08960000f,0.14319999f,0.31760000f,-0.00740000f,-0.55780002f,-0.06049999f,-0.26710000f,0.36980000f,0.30700000f,0.38550002f,-0.01110000f,-0.49260003f,0.28740001f,0.32580001f,0.14939999f,0.58830001f,0.09210001f,-0.37290000f,-0.42990001f,0.35150001f,-0.70430000f,-0.10820001f,0.22340000f,-0.42510002f,0.63390002f,0.24300000f,0.08820001f,-0.29190001f,0.04120000f,-0.43210001f,1.05230000f,-0.29520000f,0.36640002f,0.27719998f,0.55780000f,0.16200000f,0.04669999f,-0.14169998f,0.66769998f,-0.09110001f,1.27840004f,-0.60450001f,-0.61989999f,-0.14159998f,0.88419998f,0.45390001f,0.40379999f,0.23440001f,-0.61890004f,1.01669998f,0.21219997f,-0.31230000f,-0.08090000f,-0.92980000f,-0.45529999f,0.21730000f,-0.00650000f,-0.24980000f,-0.02670001f,0.66590003f,-0.20870000f,0.31080001f,-0.31079999f,-0.51000002f,0.06720001f,-0.01879998f,-0.34479999f,-0.29500000f,0.23020000f,0.61759999f,0.31480002f,0.02300000f,0.26860001f,-0.20400000f,-0.45480002f,-0.26149999f,0.09590001f,0.37009999f,0.47590000f,-0.43700004f,0.68180000f,0.20810001f,-0.61490000f,0.13500001f,-0.35820000f,0.06669999f,0.07370001f,-0.15740000f,-0.73329999f,1.14630002f,-0.27579998f,-0.03360000f,1.58759994f,-0.31230001f,-0.84430000f,0.19840001f,0.24599996f,-0.59569998f,0.02250001f,0.13049995f,0.72450004f,-0.10009999f,-0.28949999f,0.27269999f,-0.18930000f,-0.91499999f,1.10869996f,-0.30690001f,0.67360004f,-1.13880001f,-0.12699998f,0.97500000f,-0.27810004f,0.33050000f,0.40189998f,0.58190001f,-1.26500002f,0.58220001f,0.08860000f,-0.48340002f,0.01900000f,-0.50160002f,-0.17520000f,-0.28689999f,0.09610000f,-0.36289999f,-0.28510000f,0.64790001f,0.43570002f,-0.15189999f,-0.18290001f,0.08990000f,-0.31670000f,0.34150001f,-0.44230002f,-0.69329999f,-0.36510003f,-0.72010001f,-0.26990001f,-0.52940002f,0.01100000f,0.25390000f,0.08090001f,-0.53840001f,-0.24640000f,0.51510001f,0.25889999f,0.66250001f,0.58779999f,-0.62600002f,0.02659999f,-0.40300002f,-0.10220002f,-0.58889999f,0.31620000f,-0.02050001f,-0.33619999f,0.06720000f,0.68910001f,-0.45680000f,0.98849999f,0.76630000f,-0.77580000f,0.13859999f,1.57089998f,-0.58889997f,0.19219998f,-0.50790000f,-0.26400002f,-0.44110001f,-0.49170001f,0.54739999f,-0.69269999f,-0.41180001f,-0.03100005f,0.23350002f,0.33580001f,0.99709999f,-0.15990000f,-0.49430002f,-0.17529999f,-0.20030000f,0.02750000f,-0.41340002f,-0.18420000f,0.18409999f,-0.09770002f,-0.74430002f,-0.00090001f,0.40460002f,-0.34700000f,-0.25729999f,0.21050001f,-0.57340002f,-0.44540001f,-0.62989999f,-0.36010002f,0.44880001f,0.09120001f,-0.34870004f,0.45310001f,-0.04930002f,0.76210002f,-0.35640002f,0.13680000f,0.33930001f,0.04590000f,-0.30820002f,-0.23150000f,0.00469998f,-0.98560000f,-0.43240000f,0.35250000f,-0.10280002f,-0.50740002f,0.86770002f,-1.21140001f,-0.96300001f,0.10350000f,0.81900000f,0.03160000f,-1.00980000f,1.08530002f,-0.09130002f,-0.41150002f,-0.44989997f,0.04659997f,0.74370002f,-0.61750001f,-0.14530000f,-1.59880002f,-0.76399998f,-0.07050002f,-0.04730002f,-1.16089997f,0.67060001f,-0.65769998f,-1.25960002f,-0.24720000f,0.15270000f,-0.21390000f,0.28179999f,0.45620000f,-0.55679999f,0.06720001f,-0.27060000f,-0.21180000f,0.36560002f,-0.41960001f,-0.00439999f,-0.86680001f,0.05979998f,0.82580000f,-0.12020000f,-0.03460001f,-0.36869999f,-0.14610001f,-0.27760000f,-0.44960001f,-0.55019999f,0.08219999f,0.08810001f,-0.28610000f,-0.04120000f,0.29680000f,-0.40520001f,-0.26080000f,-0.06199999f,-0.36269999f,0.77119999f,-0.83490000f,0.06250000f,-0.34409998f,-1.00609999f,0.56549998f,0.06589999f,-0.43229999f,0.63160001f,0.49559999f,0.89559997f,-0.14400000f,-0.79600000f,0.16220004f,0.21600002f,-0.73300001f,-0.39819999f,0.18789999f,-0.00069999f,0.20449997f,-0.61129997f,-0.32350000f,-0.17410002f,1.23800001f,-0.61120000f,0.60760001f,-0.09710001f,-0.33390001f,0.47139999f,0.14829999f,-0.43840000f,-0.43640002f,0.64830000f,0.26250002f,-0.21440000f,-0.31480001f,0.30530000f,0.61630002f,0.01780000f,-0.12940000f,-0.28119999f,-0.37040001f,-0.34509999f,0.24069999f,0.04160000f,0.11320000f,0.36350001f,0.45730000f,0.11100001f,-0.12540000f,-0.12720001f,0.24960000f,0.03660002f,-0.32459999f,0.21499999f,0.53380000f,-0.04780000f,-0.21860000f,-0.55389999f,1.11899998f,-0.16790000f,0.10769998f,0.10429997f,0.97820002f,-0.13090000f,0.37749999f,-0.30450001f,0.19120004f,0.58560002f,-0.97260003f,0.18140000f,-0.37820001f,-0.67739997f,0.04430001f,-0.07200000f,0.03120000f,-0.23689998f,0.54020001f,-0.03290001f,0.64409999f,-0.18969999f,-0.46049999f,-0.08320000f,0.97819996f,-0.52860000f,0.61760003f,0.30450000f,-0.33810000f,-1.18019997f,-0.76790001f,0.16809999f,0.78230003f,-0.30250001f,0.24130001f,-0.41890002f,0.41530001f,-0.31580000f,-0.05500000f,-0.67870000f,0.05590000f,0.56069999f,-0.06750000f,-0.51640000f,0.08439999f,-0.09120003f,0.42240001f,-0.02030000f,0.55670001f,-0.49550000f,0.24710000f,-0.36440001f,0.62719998f,-0.03870001f,0.07110000f,0.16850000f,-0.57530002f,0.00510000f,-0.32910000f,-0.66970001f,0.10859996f,-0.62050001f,0.16200004f,-0.34829999f,-0.57000000f,-0.69250000f,-0.49700000f,-0.49980000f,0.36280000f,-0.88559999f,-0.01030001f,0.99819997f,-0.53669998f,-0.67279999f,-0.09960000f,0.01629998f,-1.18809998f,-0.67169999f,0.24320002f,-1.34439999f,1.09810000f,-1.03159997f,-0.04959997f,0.39420002f,-1.13130004f,0.67439998f,0.19530000f,0.53700000f,-0.47270001f,-1.10830001f,-0.08430000f,-0.17380000f,0.38980001f,0.44179999f,0.09820000f,-0.43189999f,0.09349999f,-0.04120001f,0.36159999f,0.54530001f,0.29710000f,-0.21719999f,-0.52079999f,0.73910002f,-0.07310002f,0.00280001f,-0.78400003f,0.29400000f,-0.11760001f,-0.06109999f,-0.27370000f,0.13760000f,0.00640000f,0.34350000f,0.38730000f,0.07160001f,-0.08960000f,-0.20069999f,-0.54810000f,-0.06960000f,0.58969998f,-0.37909998f,-0.46769999f,1.03239999f,-1.29139996f,-0.97799997f,0.78809996f,-0.20380000f,-0.43379997f,0.29140001f,0.20830002f,0.37089999f,-0.30190001f,1.17890003f,-0.43799998f,0.72480000f,0.07719997f,0.82130001f,-0.76590001f,-0.28030001f,1.03940000f,-0.39870000f,1.24570000f,0.12160000f,-0.15929997f,-0.03810000f,0.47149999f,0.32379998f,-0.09410000f,-0.68950000f,0.54420001f,0.30310000f,0.18649999f,0.54510001f,-0.00870000f,-0.02980001f,0.44740000f,0.63800001f,0.21880001f,-0.31140002f,0.35100003f,0.83050003f,-0.02409999f,0.49240002f,-0.08200000f,0.18470000f,-0.37910001f,-0.77640000f,-0.11280002f,-0.18650001f,0.21530000f,0.79910000f,0.52930003f,-0.29520002f,0.64079999f,-0.13599999f,-0.13759999f,-0.32500002f,0.57340000f,0.46699998f,0.76110001f,0.30520000f,-0.24729997f,0.48670000f,0.42860001f,-0.47469999f,0.01430001f,0.75960001f,-0.40879999f,-0.18410002f,-1.19269998f,1.52100004f,-1.05130001f,0.60170001f,0.18650000f,0.89200001f,-0.66210003f,-0.93139998f,0.18500000f,-0.54780001f,0.24450000f,0.20289997f,0.60120003f,-0.77069999f,-0.46789997f,-0.51790002f,1.07050000f,-0.58249999f,-0.82229998f,0.20219998f,-0.01279998f,0.02039999f,0.35400002f,0.45660000f,-0.20460000f,-0.50570002f,-0.17470001f,0.03310000f,-0.25990001f,0.10700001f,-0.00259999f,-0.45440000f,-0.61480000f,-0.14960001f,0.25400000f,-0.04200000f,0.22200001f,0.59050001f,-0.32770000f,0.07000000f,-0.49120002f,-0.05319999f,-0.19160000f,0.36530001f,-0.40850000f,0.03479997f,0.45120000f,0.04980000f,0.09780001f,0.48330000f,1.28390002f,0.18550000f,-1.11210000f,1.23950000f,-1.06269998f,-0.22570001f,-0.50740001f,0.62000001f,-0.72810002f,-0.07600001f,0.46620001f,0.25459998f,-0.49100003f,-0.20069999f,-0.50669997f,-0.20000000f,-0.14600000f,1.11790000f,-0.16440002f,0.10519997f,1.00799999f,-0.41729999f,1.18909996f,0.74469999f,0.22039999f,-0.09870001f,-0.65069997f,-0.44750002f,0.91870002f,-0.11940002f,0.25379999f,0.25580000f,0.07900000f,-0.18069999f,-0.20449999f,0.16060000f,0.31460001f,0.11890001f,-0.71290001f,0.42789999f,0.39649999f,0.30639999f,-0.08680000f,-0.49080003f,0.55920001f,0.07789998f,0.78610002f,0.12279999f,0.57560000f,-0.27720000f,0.11520000f,-0.30800003f,0.50240001f,0.24210000f,-0.06570000f,-0.44420002f,-0.04900000f,-0.12970000f,-0.12230002f,0.41440004f,-0.35189998f,0.89760002f,0.49140000f,0.39870002f,-0.17790000f,-0.74460002f,-0.88620000f,-0.12690000f,0.11789999f,0.78509998f,0.09929997f,0.22140000f,-0.17760000f,-0.39180001f,-0.43200000f,0.87570002f,1.13159998f,0.39600000f,0.62250001f,0.46890001f,0.55350000f,-0.48510000f,-0.10739999f,-0.84360000f,0.18120003f,0.38040001f,0.51209999f,-0.02250000f,0.01110000f,0.55710001f,-0.28950003f,0.35050001f,0.45110004f,-0.05589999f,0.57870002f,-0.97419999f,-0.68080003f,-0.65739998f,-0.86420002f,-0.10479999f,0.09020001f,-0.20610000f,0.65370002f,0.79230001f,1.00870006f,-0.83979999f,-0.76360003f,-1.04239998f,-0.51740004f,0.68509997f,0.69230000f,-1.28309998f,-0.90370003f,-1.14590003f,-0.65050005f,1.20799994f,0.74620000f,-0.29909999f,-0.75750002f,-0.28980000f,-0.57720000f,0.58530003f,0.31050000f,0.78210001f,-0.02969998f,-0.58560001f,-0.53909999f,-0.49020001f,0.13380002f,-0.01140000f,-0.24390000f,0.60510001f,-0.48030000f,0.90870004f,0.24839999f,-0.53520001f,-0.23489999f,-0.77580002f,-1.06169998f,0.52469998f,0.18779998f,-0.81870000f,-0.75329998f,-0.81210002f,-0.99870002f,0.52199998f,0.58349996f,-0.94650000f,-0.21479998f,0.33000000f,-0.55300003f,0.54830000f,-0.14590002f,-1.22469997f,-0.67530003f,-0.45809998f,-0.65150000f,-0.03130000f,-0.12870000f,-0.67460003f,-0.26580003f,-0.65240001f,-0.37460002f,1.03580001f,1.01480005f,-0.11359996f,-0.80500001f,0.40019999f,0.81520003f,-0.38310000f,0.39150000f,1.12559996f,0.64099999f,0.85840000f,0.54420002f,0.12480001f,0.88300004f,1.06589995f,0.65270000f,0.13590000f,-0.88020000f,-0.41790002f,0.24690000f,-0.82290001f,-1.04609997f,-0.60809999f,-0.13529998f,-0.17430000f,-0.03390000f,-0.48660002f,-0.77280002f,-0.23880000f,-0.30869999f,0.82440002f,0.36689999f,-0.91440000f,0.06270003f,0.65280001f,-0.11190001f,0.58229999f,-0.27629999f,0.73979998f,0.91229999f,0.47580000f,0.51270000f,0.94260002f,-0.13710000f,0.87569999f,0.99419996f,0.14010000f,0.83120003f,1.39159997f,0.92120001f,0.83629998f,0.23650001f,-1.12749998f,-0.65050003f,0.66710000f,0.19970001f,-0.67380000f,-0.70800003f,-0.66560001f,-0.10780000f,-0.87319999f,-0.54120001f,0.22760001f,-0.02059999f,-0.22409997f,-0.34149999f,1.09230001f,1.17990006f,0.69059997f,0.09119998f,-0.23939998f,0.40580002f,-0.25870002f,0.41390001f,0.11750000f,0.21250002f,0.13689998f,-0.32580003f,0.69719998f,0.68879998f,-0.09090000f,0.30989997f,-0.69630002f,-0.85049998f,0.06030000f,0.38129999f,-0.82620001f,-0.49589999f,0.04380000f,-0.39930002f,-0.28080000f,-0.30959999f,-0.25320000f,-0.04770000f,-0.64769999f,-0.42929999f,0.86550004f,0.21840000f,0.32939999f,0.87030000f,0.54240001f,-0.21119998f,0.14730000f,-0.68910003f,0.30030001f,0.13050000f,0.50790000f,0.46090001f,0.57660000f,0.06460002f,-0.98719999f,-0.67880000f,-0.68629999f,-0.95950004f,-0.08070000f,0.14390000f,1.13969995f,0.36949999f,0.48880002f,1.15600006f,-1.56039998f,-1.00340001f,0.05440001f,0.33300002f,-0.36230000f,-0.73670002f,-0.26389999f,-0.86330001f,-1.05789999f,-0.60470000f,0.24250001f,-0.48050002f,0.43520000f,0.71200002f,1.33770001f,0.88950005f,0.22639999f,-0.17100000f,-0.13860000f,0.27479998f,-0.42299997f,-0.36959998f,-0.60150003f,0.12360001f,0.13410000f,-0.13710000f,0.41429998f,0.96209997f,0.88800002f,-0.27360001f,-0.80219998f,-0.83969998f,-0.00720000f,-0.45630001f,-0.43470000f,0.27660000f,-0.48570000f,0.49830001f,-0.60989998f,-0.75720000f,-0.33630002f,0.55950002f,0.59820000f,0.01259999f,0.85530002f,0.86610001f,0.23580000f,0.09019999f,-0.64279999f,-0.90500002f,-0.31040000f,-0.45600002f,0.03669997f,-0.18870002f,0.09630000f,0.09170000f,-0.23219996f,-0.70599999f,-0.38240000f,-1.05300006f,-0.39110002f,0.38890000f,-0.31119996f,-0.80559999f,0.36570003f,-0.39749999f,0.28789999f,0.72490003f,0.80579998f,0.14800001f,-0.24260000f,-0.03600000f,-0.67920000f,0.08680000f,0.22900001f,-0.04680000f,-0.03570001f,-0.31860000f,-0.76980000f,-0.10889999f,-0.54720001f,-0.22320000f,0.14130000f,0.47610000f,0.22110000f,0.20190000f,-0.78479998f,-0.04709998f,-0.89400003f,0.21030002f,0.26130000f,-0.64380002f,-0.77159998f,0.04440002f,-0.48329999f,0.38160001f,0.86310002f,0.15869999f,0.39900000f,0.96989998f,-0.11880000f,-0.30330000f,-0.16500000f,-0.93960001f,-0.13440000f,0.12750000f,0.33150000f,0.62740001f,1.13630001f,0.29670000f,-0.45359998f,-1.15920000f,-0.09770002f,0.67750001f,0.07150001f,-0.03549999f,-0.53999998f,-0.11580001f,0.02049997f,-0.76630004f,0.01950001f,0.10710001f,0.22229997f,0.37949999f,-1.12319997f,-0.93880000f,-0.36210000f,-0.79130003f,-0.94800001f,-0.20320001f,0.89409999f,0.51110003f,0.16160000f,-0.16260000f,0.86750001f,0.99350005f,0.53839999f,-0.24959999f,0.19169999f,0.81540001f,-0.80639998f,0.40320000f,0.60150000f,-0.42060002f,0.15330000f,0.29250000f,-0.14340000f,-0.48449998f,-0.88950003f,0.15599998f,-0.05970000f,-0.21000000f,0.57150000f,0.28440000f,-0.71939999f,-0.44159999f,-0.93750000f,-0.21179999f,-0.41160000f,-1.03200001f,0.66570001f,0.81029999f,0.02820000f,0.42330000f,0.71730002f,0.12299998f,0.83520002f,-0.53540000f,-0.61010002f,-0.01070000f,-0.40080002f,0.18760001f,-0.62569998f,-0.29170001f,0.00319998f,0.42499998f,-0.01009997f,-0.79630001f,-0.70350000f,-0.71250003f,0.86129998f,0.77970002f,-0.30740000f,-1.08420002f,-0.68419999f,0.04600000f,-0.48350001f,0.37370001f,-0.31380002f,0.41760001f,0.70469999f,0.51570001f,-0.43900001f,0.16500002f,0.19870003f,-0.41849999f,0.96910000f,0.14460001f,0.08730000f,-0.44430002f,0.34440001f,-0.25740002f,-0.21270000f,-0.37859999f,0.55439998f,-0.00390001f,-0.98130001f,0.06870001f,-0.42510000f,-0.06149999f,0.74670000f,0.47039999f,-0.68759999f,0.55980002f,0.37380001f,-0.27209997f,0.58470001f,-0.33900001f,0.43320000f,-0.42090002f,0.30270000f,0.21809999f,0.37140002f,-0.22800002f,-0.56909999f,0.16260002f,0.02490000f,0.23980001f,0.19659996f,0.90760001f,-0.49500000f,-0.29220001f,-0.01860002f,0.51860002f,1.10040001f,1.02660005f,-0.95850002f,-0.05310001f,0.72240000f,0.12280000f,-1.18830000f,-0.97450005f,-0.07850004f,0.57150001f,-0.51509998f,0.15970001f,0.88000002f,0.44140003f,0.30930000f,1.10210007f,-0.58199996f,-0.30359998f,0.24489996f,0.89610000f,0.80970000f,0.50030001f,-1.18180001f,0.71100000f,0.90060000f,-0.15570003f,-0.19680000f,-0.24000000f,0.58620001f,-0.12780002f,0.80520003f,0.38670000f,0.12150000f,-0.66150000f,0.18479999f,0.68820000f,-0.80670002f,-0.54689999f,0.79590001f,-0.02400002f,0.44550002f,-0.20579997f,0.19740001f,0.37050000f,0.69750004f,-0.57360003f,-0.61499998f,-0.77700000f,0.70169999f,-0.31980003f,0.29010000f,0.32310000f,-0.81780002f,0.41400000f,0.89889998f,0.77630002f,0.22510001f,0.05150001f,-1.09299998f,-0.47000002f,0.12279998f,0.46459999f,0.42090001f,-0.21930001f,0.73899995f,0.53059999f,-0.65419999f,-0.52820002f,0.37050001f,0.61910003f,-0.45689999f,-0.06830001f,-0.13200000f,0.05900001f,-0.50399998f,0.24740001f,-0.50550002f,-0.87670005f,-0.67609999f,-0.63510002f,-0.06710002f,0.41330000f,0.39929998f,0.26909999f,0.67770000f,0.43169998f,-0.25529999f,-0.16020000f,-0.27720001f,-0.61349999f,0.52739999f,0.01589999f,-0.03450000f,0.67470001f,0.85619998f,0.85499999f,-0.84540000f,-0.76859999f,0.52350002f,0.00750000f,0.10230000f,-0.20069999f,0.33660001f,0.17250001f,0.26940000f,-0.52649998f,-0.55170003f,0.22200000f,-0.63510000f,-0.39029999f,0.54210000f,-0.06480001f,0.54990000f,-0.97850001f,-0.26970001f,0.13830000f,-0.07270001f,-0.94950004f,-0.27250001f,-0.14890001f,-0.22320000f,-0.46220002f,0.76610001f,0.85390005f,0.19269999f,0.49650001f,-0.62229998f,-0.13650001f,-0.05569999f,-0.08110000f,-0.26719996f,-0.67340000f,-0.20260000f,-0.47000001f,-0.03200000f,0.26180001f,-0.36519999f,-0.64440001f,-0.55359999f,-0.76680002f,0.33159999f,0.38180001f,-1.38549997f,-0.35999998f,0.42630001f,0.02940000f,-1.01130003f,0.20639999f,0.09270000f,0.07800001f,-0.74040002f,-0.35310001f,0.72390003f,0.24630000f,0.63570000f,0.15510000f,-0.15390000f,-0.54089998f,-0.12990000f,-0.07710000f,-0.83519999f,-0.18509998f,-0.32400001f,0.14970000f,0.10260000f,-0.30450000f,-0.34080000f,0.24240000f,-0.91440000f,-0.39779999f,0.41820000f,0.20730000f,-0.54989999f,0.26700002f,-0.49200000f,-0.51180003f,-0.16249999f,0.36230002f,-0.48050000f,0.22470001f,-0.57830001f,-0.25650001f,-0.84669999f,0.00990000f,1.07869997f,0.44650001f,-0.61440000f,0.06240000f,0.36659998f,0.77120002f,-0.60269998f,-0.46270002f,-1.50909998f,-0.99250003f,-0.87189997f,-0.24330001f,0.65430002f,0.89010006f,0.50169997f,0.10789999f,0.56719999f,0.54200001f,-1.17020001f,0.95369999f,-0.83400003f,-0.63150001f,0.22290001f,-0.43800000f,0.05250000f,-0.71700001f,-0.10170000f,-0.26190000f,0.12690000f,-0.64709999f,0.25830000f,0.61409998f,0.11760000f,-0.52319999f,0.40080001f,-0.36270003f,-0.63930001f,-0.58559999f,-0.78750000f,-0.79229998f,-0.43049999f,-0.92369997f,0.66150003f,0.01889999f,0.34170000f,0.68610000f,0.58740000f,0.37559999f,-0.19500001f,-0.41890002f,-0.18779998f,0.20280001f,1.31539998f,0.98780002f,-1.11159996f,-0.66920000f,-0.03070000f,0.18310000f,0.29120002f,-0.33400001f,0.33089997f,0.50330000f,1.23050002f,0.36130002f,0.53829999f,0.31050002f,0.94990001f,0.66830003f,-0.56090000f,-0.71450003f,-0.67019999f,-1.02440003f,0.22730001f,-0.06890000f,-0.16150000f,-0.34470001f,0.23259996f,0.34619998f,-0.68419999f,-0.44009999f,-0.00480000f,-0.48089999f,0.61860000f,0.43019999f,-0.47219998f,-0.55379997f,-0.03450000f,-0.34109999f,-0.52980000f,0.16560001f,0.70409998f,0.34919998f,0.15630001f,0.76500002f,0.64170002f,0.75690001f,0.51390002f,0.45420000f,-0.39990001f,0.10080001f,-0.82680000f,-0.02009999f,-0.32670000f,-0.05910000f,-0.23670000f,0.09900000f,0.59279998f,0.36779999f,-0.62640001f,-0.86310003f,0.38780000f,0.10020000f,0.37290001f,-0.36790001f,-0.37979998f,-0.22360000f,0.87180002f,0.20260001f,0.15969997f,0.81810001f,1.71180004f,0.83420005f,0.52600001f,-0.13340000f,0.94560000f,0.71280004f,-0.96750000f,-0.06490002f,-0.54700000f,-0.29420000f,0.15930000f,-0.77550003f,-0.52059999f,0.08840000f,-0.77300001f,-0.80160004f,-0.26970000f,0.41070001f,0.27099998f,-0.96480001f,-0.08400000f,0.11040001f,-0.39930001f,0.43920000f,-0.39599999f,-0.46289999f,-0.09420000f,0.38940000f,0.52169998f,-0.48540004f,0.47760001f,0.86340001f,-0.16860001f,0.49050001f,0.70620002f,0.60179999f,0.17670000f,-0.58949998f,-0.29759999f,-0.39900000f,-1.04610003f,0.11939998f,-0.19559999f,-0.83129999f,-0.52080003f,-0.10050000f,0.09510001f,-0.75360000f,-0.45660001f,-1.05570005f,0.50060000f,0.73720003f,1.40719998f,0.94500002f,-0.13610003f,0.51790001f,0.71910000f,0.71610003f,-0.18070001f,-0.38330002f,0.24349997f,0.71210001f,-0.03130000f,0.29830000f,-0.11900000f,0.01500000f,1.06090000f,0.26570003f,-0.22050003f,-0.59070002f,-0.71259998f,-0.87600001f,0.59559999f,-0.00020000f,0.13769998f,0.31410000f,-0.62570001f,-0.79770004f,-0.22020000f,0.19079999f,0.38520000f,-0.20670002f,0.73740000f,0.71309999f,0.60090001f,-0.21780001f,0.68070001f,0.36029999f,-0.31890002f,0.04590000f,0.96570000f,0.25349997f,0.13350000f,-0.32339999f,-0.09300000f,-0.23700001f,0.24510001f,0.85319999f,-0.22110000f,0.43050000f,-0.56879999f,0.01170002f,0.12960000f,0.69330000f,0.00450000f,-0.33840001f,-0.67890002f,-0.15060000f,-0.94320001f,0.04260000f,1.10210001f,0.99830005f,-0.41589999f,-0.32670000f,0.15500001f,0.08600001f,0.99670000f,0.72790004f,-0.14469998f,-0.64710000f,1.27869998f,1.06550004f,-0.94790000f,-0.17590000f,-0.70399997f,-0.63380000f,-0.47360000f,-0.51180003f,-0.65870001f,-0.33830003f,-1.11580000f,-0.68140001f,0.22529999f,-0.11750000f,0.20189999f,0.89410003f,-0.73380000f,-0.75640003f,1.23550003f,-0.11280002f,-0.44339998f,0.09360003f,-0.10410001f,-0.03679998f,0.46259998f,-0.18920001f,0.14220001f,0.14370000f,0.65760001f,0.95649999f,0.46319999f,0.45200000f,0.67380001f,0.33300001f,-1.03649994f,-0.21769995f,-0.16050000f,0.24799999f,-0.20069998f,0.20520001f,-0.79679998f,-0.98979997f,-1.20149998f,-1.38589998f,-0.45299997f,-0.08849998f,-0.00960000f,-0.01250000f,1.08240000f,0.27580000f,-0.11510002f,-0.21080000f,0.15030000f,-0.05800001f,0.78400001f,0.14180000f,1.02579999f,-0.45199999f,-0.09920001f,0.21860000f,-0.11570000f,0.38079999f,-0.77680002f,0.06240000f,0.90700001f,-0.13180000f,0.32400003f,0.70459997f,-0.73259999f,0.10480000f,0.98230001f,0.23879999f,0.53360005f,0.58340001f,-1.08509998f,-0.06479999f,0.09250001f,0.15939998f,0.26120000f,0.01549998f,-0.26699999f,0.07830003f,0.00179996f,0.26370000f,-0.00870002f,-0.44340001f,-1.16999999f,-1.25139999f,0.43410000f,0.31380000f,0.85919997f,0.84250000f,0.45420001f,0.86580003f,-0.54510001f,-0.81720000f,1.12349993f,0.36699995f,0.45420001f,0.70519999f,0.08939997f,-0.52110001f,0.84149998f,0.10719998f,0.20820003f,0.63369998f,0.10769998f,-0.31910003f,0.08369999f,0.35940000f,-0.59439999f,0.04259999f,0.59780001f,0.59619998f,0.44709999f,-0.03880000f,-0.01160000f,0.03540000f,0.12400004f,0.55040000f,0.59810002f,0.02440000f,-1.01880003f,0.06340000f,0.11189998f,-0.05640001f,-0.61040000f,0.28100000f,0.34620001f,0.06299999f,-0.60179999f,-0.49180000f,-0.65740002f,-0.16380000f,-0.20060001f,0.14299999f,-0.41429999f,-0.62499998f,-0.56110001f,-0.15030001f,0.13230000f,0.08679997f,0.84989995f,0.09139997f,-0.28260000f,-0.54549999f,0.03750001f,-0.03920000f,0.92759998f,0.40119998f,-0.12720002f,-0.33870001f,0.49290002f,0.92420002f,-0.30000000f,-0.58570001f,0.78570000f,0.94460001f,0.15209996f,0.23459999f,-0.66630000f,0.00079998f,-0.08069998f,0.30680001f,0.48869998f,0.74720001f,-0.93449996f,-0.17709999f,1.05150002f,0.50040001f,-1.22080000f,-0.10080000f,-0.90510001f,0.09600001f,0.67330001f,0.41839999f,-0.56790001f,-0.08359999f,0.36270002f,0.26879999f,0.56060001f,0.09620002f,0.91140000f,-0.08599999f,-0.41050002f,0.19160000f,-0.19730003f,0.41400000f,-1.24720003f,0.25519999f,-0.06749998f,-0.63840000f,0.19969999f,0.06819999f,-0.31149999f,0.62280001f,0.00169999f,-0.10840000f,-0.44660000f,1.22520002f,0.20160002f,0.73359998f,0.36120004f,0.45070000f,0.51959996f,-0.10170002f,-0.02459997f,0.15950001f,0.27899998f,-0.23010002f,0.06930001f,-0.08719998f,-0.41220000f,-0.63059998f,0.40560002f,0.28470000f,0.70860002f,0.27810001f,0.91380001f,1.28420001f,-1.13580000f,-0.61710002f,0.18629997f,0.28150000f,1.27620000f,0.99790001f,-0.15060000f,0.01470001f,0.89729999f,0.32879999f,-0.57120002f,0.00400002f,0.99690001f,-0.06700000f,1.04300000f,-0.44679999f,-0.00630000f,0.10040000f,-0.61279999f,-0.51419998f,-0.87400004f,0.48880000f,1.29740002f,0.18980000f,-0.54630001f,0.53800000f,0.75180000f,-0.46239999f,0.82959999f,-0.65459999f,0.67900001f,0.34360001f,0.17829999f,-0.47160000f,-0.54070001f,0.16460000f,-0.94130004f,-0.33920000f,-0.50040000f,0.76919998f,0.10560005f,0.17080002f,-0.42090002f,-0.71449998f,-1.18439999f,-1.30880000f,0.21659999f,0.19910000f,-0.76649995f,-0.18960000f,1.28040000f,1.43880002f,-0.06870003f,-0.70559999f,1.13760001f,0.90810001f,-1.12019998f,-1.12279998f,-1.51109997f,-1.42599997f,0.39240000f,-0.15519998f,-0.99539999f,-0.84670001f,0.53969999f,0.73950000f,-0.28199998f,0.39490001f,0.75930001f,0.03080000f,0.72080001f,-0.15140000f,0.15120001f,0.13120000f,0.45180003f,-0.52340000f,0.09530000f,-0.19280000f,0.18779997f,-0.00580000f,0.65450002f,-0.36240001f,-0.05899998f,0.49440001f,0.39739998f,-0.15000000f,-0.20070003f,-0.19740000f,-0.14430001f,-0.09600000f,-0.12350001f,-0.69519998f,0.02580000f,0.22180000f,0.00110000f,0.70860000f,-0.21820001f,-0.01260000f,-0.31009999f,-0.03240001f,-0.58530000f,-0.88500000f,0.11519999f,-0.17520001f,-1.06470001f,-0.78180001f,-0.34559999f,-0.17209999f,-0.19649997f,-0.48639998f,-0.99420002f,-1.18990004f,0.99899999f,0.78800000f,-0.51299999f,-0.75019999f,-0.42029997f,-0.41549999f,0.00840000f,0.37870002f,-1.21859995f,-0.63069997f,0.39330000f,0.21120000f,1.31369999f,0.81810001f,-0.00149998f,0.00560000f,0.87959998f,0.24419999f,-0.78630002f,-0.33460001f,0.96599997f,-0.62159998f,-0.21199999f,0.37080001f,0.21519997f,-0.30139999f,0.26780000f,0.27139999f,0.01640003f,-0.09279999f,-0.25060001f,0.24920000f,0.04200002f,-0.24720001f,1.08229998f,-0.03379999f,0.18790002f,0.12259999f,0.26420003f,0.69160000f,-0.38050002f,-0.49239999f,0.20259999f,-0.39059999f,-1.03830003f,0.25660001f,-0.15300001f,0.70069999f,-0.42929999f,-0.00270002f,-1.53719994f,-1.60439995f,0.86039999f,0.86780001f,-0.59009997f,-0.39479997f,0.43049997f,0.16159999f,-0.34379997f,-0.57980002f,0.51600000f,0.39080000f,-0.37260002f,-0.04020001f,-0.43109998f,-0.85909997f,0.01889999f,-0.40090003f,1.17899997f,0.56139999f,-0.72899996f,-0.12949997f,-0.77969998f,-0.56719999f,0.84390003f,1.12370002f,-0.48360000f,-0.14800000f,0.43980002f,0.17180001f,0.36080002f,0.05160001f,0.49130000f,0.11420000f,0.06210002f,-0.03800000f,-0.04030003f,-0.00399999f,0.90110002f,-0.26320000f,-0.67030001f,-0.13660000f,0.92970001f,-0.72980000f,0.75970002f,-0.08160001f,0.42770001f,0.08060001f,0.07900001f,0.27220001f,-0.75830001f,0.09880000f,0.44960000f,-0.00319998f,-0.19390002f,-0.03300001f,-0.66130002f,-0.52779999f,0.24690000f,0.08140001f,0.08340000f,0.09240002f,0.07109998f,-0.16670000f,0.01679998f,0.20929998f,-0.17999996f,-0.49009999f,-0.77280001f,-0.92590000f,0.02370001f,0.48530000f,-1.71269999f,-1.66650000f,-0.25020005f,-0.22750001f,0.16829998f,0.22450001f,0.57929999f,0.53560001f,0.40740001f,0.59470000f,-0.03479998f,-0.00039996f,-0.12570000f,-0.25270001f,-0.42869995f,-0.28500000f,-0.32889998f,0.20440001f,0.44590001f,0.02620000f,-0.02899999f,0.08640001f,-1.09450002f,0.07639999f,0.72630004f,0.23040000f,-0.31820001f,-0.40720000f,1.05770002f,0.05680000f,0.19060002f,-0.07719999f,0.59190000f,-0.07340001f,-0.86960004f,0.02820000f,-0.94530002f,0.74540001f,-0.03070003f,0.61340001f,-0.59199997f,0.42840000f,-0.80450002f,0.03719999f,0.56980004f,-0.00330000f,0.62520000f,0.85710001f,-0.08310001f,-0.25190000f,0.27840000f,0.42180002f,0.53040000f,0.96230001f,0.30239996f,0.05489999f,-0.66959998f,-0.29260000f,-0.27000002f,-0.77810001f,-0.04080001f,0.22960002f,-0.18510004f,-0.11090000f,0.27810003f,0.49700001f,1.74750002f,1.69790003f,1.05690002f,0.47990003f,1.07039998f,1.14979998f,0.29820001f,0.52889999f,0.82919997f,-0.12180000f,-0.77310001f,-0.06840000f,-0.52220001f,0.31599999f,0.91920000f,0.13860001f,-0.09419999f,0.00420000f,0.07639999f,-0.53140000f,-0.08599997f,-0.63800000f,0.05300002f,0.58479999f,-0.46180001f,0.14259999f,0.46910001f,-0.02160000f,0.41040000f,-0.28780000f,0.22540000f,0.30419999f,0.88830003f,-0.46659999f,0.49840000f,0.13460000f,0.10000001f,-0.00559999f,-0.05280000f,0.18419999f,0.16260001f,0.57950000f,0.66540000f,0.48839999f,0.01289999f,-0.34579999f,0.12569998f,0.31399999f,-1.03109999f,-0.72640000f,-1.03380000f,-0.33960001f,0.94199997f,0.29099997f,0.46709999f,0.64060000f,-0.12360002f,-0.16950000f,-0.57270000f,-0.36459998f,0.57809996f,0.43199999f,-1.17930000f,-1.24450001f,0.03029999f,-0.35960001f,0.06780000f,0.22860001f,-0.51809999f,-0.04660000f,0.47480002f,-0.20680000f,0.18730000f,-0.18779999f,0.48600001f,-0.23600000f,-0.13250000f,0.33680000f,-0.76460003f,0.06580000f,-0.03920000f,-0.12340000f,0.32790000f,0.29239999f,-0.01480001f,0.06740000f,0.09089998f,0.13399999f,0.40500000f,-0.24659999f,-0.25200000f,0.31499999f,0.73299998f,-0.43319998f,0.27780001f,0.22879999f,-0.21460000f,-0.09220000f,1.30470001f,-0.86969999f,-0.41640002f,-0.24220000f,-0.58349996f,-0.83390001f,-0.53580001f,-0.45460000f,0.53100001f,0.10549998f,0.42390002f,0.77060003f,-0.10830001f,0.18400000f,0.45539996f,0.15809999f,0.10710001f,0.02560001f,0.08040000f,-0.29390000f,-0.61529998f,-0.64759999f,0.67109999f,0.55819999f,-1.04339997f,-1.02979997f,0.20519998f,-0.29100003f,-0.05130000f,0.18520000f,-0.36180005f,-0.69159999f,-0.04009999f,0.51520000f,-0.18430001f,0.38660000f,-0.03110000f,0.54620000f,0.55620002f,-0.00020000f,0.57990001f,0.27200000f,-0.90029999f,-0.14520000f,0.36920001f,0.25519999f,-0.85039999f,0.56340000f,0.19190000f,0.39100000f,1.27350002f,0.16240000f,0.26240002f,0.61179997f,-0.84330004f,0.26640001f,0.01910002f,-0.53200000f,-0.36190000f,-0.17100000f,0.94570003f,-0.55509998f,0.83220001f,0.24669998f,0.81449999f,0.68290001f,1.05269999f,0.73570000f,-0.13950002f,-0.28260000f,0.41399997f,0.17130000f,-0.03299998f,0.31989999f,0.42599997f,0.23239999f,1.32690000f,1.27499999f,0.58229999f,0.09189999f,-0.11280003f,-0.72310000f,1.02449993f,0.45079996f,0.81000003f,1.02690004f,-0.95040000f,-0.51110001f,-0.13769999f,0.23230001f,0.13199997f,0.00720000f,-0.22060001f,0.43939999f,-1.38500000f,0.15439999f,0.98229999f,0.07780000f,-0.30879998f,0.36739998f,-0.31970001f,0.00859999f,-0.03200000f,-0.27359999f,-0.97870002f,-0.22660002f,0.07680001f,-0.61580000f,-0.84480002f,-0.05400000f,0.86390002f,-0.37220000f,0.84400001f,-0.26020000f,-0.43110000f,0.20999999f,0.30480000f,-0.17559999f,0.11510002f,-0.33659999f,0.37440002f,-0.45449999f,0.88049998f,0.64879999f,0.70680000f,1.08659997f,-0.15210002f,-0.54909998f,0.75749997f,0.57839997f,-0.01230000f,-0.12750002f,-0.38219999f,0.02460001f,-0.18930001f,0.19649997f,-1.06650001f,-0.48839999f,0.17520001f,0.54380001f,-0.96690001f,-1.03650000f,-0.82890000f,-1.10380000f,0.43140000f,0.27909998f,-0.44279999f,-0.47099999f,-0.55410000f,-0.17350001f,0.33269997f,0.41880001f,-0.45909999f,0.08499998f,-0.14150001f,-0.26460000f,0.02580000f,0.35059999f,-0.87560003f,0.02600000f,-0.66100000f,0.58320001f,-1.53370007f,-0.11180000f,-0.28120002f,-0.26060000f,-0.66310003f,-0.23620000f,0.82000003f,0.14099998f,0.34570001f,0.18460000f,-0.24190001f,0.03260001f,-0.12159999f,0.67259998f,0.94960001f,-0.24819999f,-0.36819999f,0.69319999f,-0.41979998f,-0.28920000f,0.24509998f,0.25549997f,-0.54509998f,-0.48270001f,0.58649999f,0.23359999f,0.22140003f,0.34760000f,1.34580001f,1.28360000f,0.20790004f,0.73690002f,-0.46469998f,-0.30180000f,-0.17429998f,0.33470002f,0.12269994f,-0.06960002f,0.22050000f,-0.06009999f,-0.07889995f,-0.39310000f,1.26629996f,0.80739998f,-0.77249999f,-0.97580000f,1.41239997f,1.08439998f,0.27900000f,-0.35679999f,-0.88680002f,0.46020001f,-1.21340001f,-0.12300000f,0.05090002f,0.12460000f,-0.58550001f,-0.08240000f,0.26780001f,-0.11980000f,0.03000000f,-0.23299998f,-0.26839999f,0.33399999f,-0.08200001f,0.21000000f,-0.63170002f,-0.42019999f,0.73120003f,-0.57740000f,0.97079999f,-0.33819999f,-0.13650000f,-0.47440000f,-0.54479998f,0.44879999f,0.66500002f,-0.10319999f,0.16710001f,-1.19100001f,1.13610002f,1.15060001f,0.16530001f,0.72279999f,0.33629999f,0.44490001f,0.09600001f,0.48550001f,-0.34409999f,-0.42660001f,-0.27029998f,0.18440003f,0.71639997f,0.60499998f,0.39900001f,0.25400001f,-0.61529996f,-0.14849998f,-1.29450000f,-1.15160000f,-0.95669998f,-1.12379997f,-0.84659998f,-0.48170000f,0.97019998f,0.79979998f,-0.46500000f,-0.75400001f,-0.22049999f,0.31499999f,-1.21700003f,0.20060000f,0.57149999f,-0.18939999f,-0.37740001f,0.23980000f,-0.45850003f,-0.50179999f,0.03650000f,0.06579999f,-1.24760001f,0.05440000f,0.34560002f,0.60840000f,0.15569999f,0.52160000f,0.09960003f,0.35019999f,0.51760002f,0.11760000f,0.68640002f,0.39040000f,-0.07690000f,-0.16139999f,-0.42180000f,0.29500000f,0.89370002f,-0.22720001f,-0.47880005f,0.31629998f,0.21280000f,-0.39619999f,0.26900000f,-0.34249999f,0.03760000f,0.11100000f,-0.13650000f,0.25210000f,0.14430000f,0.43470000f,0.08680000f,0.25440000f,-0.08020000f,0.48960002f,0.00770000f,-0.54119998f,-0.11000000f,0.11949999f,-0.03900000f,0.01330000f,0.00880000f,-0.66939998f,-0.19910001f,-0.75239999f,-0.00610000f,-0.22449999f,-0.01270000f,0.00530000f,0.07090001f,-0.70180001f,-0.08250000f,0.44230003f,-0.42229996f,0.09270004f,0.12260000f,-0.74030001f,0.81419999f,-0.02660000f,-0.26859999f,-0.25369999f,-0.86069996f,-0.39649998f,-0.58840000f,0.48650003f,0.43640000f,-0.41750001f,-0.45379997f,-1.29270000f,-0.40779999f,0.35129999f,0.12730000f,-1.02530001f,-0.28980000f,-1.24900006f,-0.16050001f,0.80099998f,0.37529999f,-0.40160001f,-0.27859998f,0.07320000f,0.13930000f,-0.24369999f,0.33269999f,-0.27070001f,0.02500000f,-0.16530000f,-0.03820001f,-0.86739999f,0.02980000f,0.25950001f,0.31350000f,0.31190000f,0.16160001f,0.29720000f,0.00160000f,-0.49590000f,-0.01780001f,0.63649998f,0.03460000f,0.38260000f,0.01510000f,-0.13430000f,-0.00859999f,0.42070000f,-0.11109999f,0.40409999f,-0.30210000f,0.27079998f,0.21340000f,-1.09250003f,0.24859999f,0.23840000f,-0.30439997f,-1.30660000f,0.39529998f,-0.28670000f,0.06339999f,-0.06560001f,-0.41920000f,-0.91820004f,0.07270001f,-0.41920001f,-0.51940000f,0.61770003f,0.63329998f,-0.10199999f,-0.72459999f,0.04450001f,-0.46919995f,-0.22079998f,0.22120002f,1.14990001f,-0.03520000f,0.68270002f,-0.75639997f,0.03490003f,0.29529999f,1.24559998f,-0.66270000f,-0.02780000f,-0.31580000f,0.41989998f,0.00839999f,0.40169999f,-0.12730000f,-0.15870000f,-0.06180000f,0.07030000f,-0.00239999f,0.54239999f,0.07730000f,-0.24210001f,0.06220000f,0.43750001f,-0.34490000f,0.05129999f,0.16820001f,0.46350000f,0.34199999f,-0.22170000f,-0.01280000f,-0.28630002f,-0.03960000f,0.09890000f,0.35600000f,0.07110000f,0.05470000f,-0.53260000f,0.03510000f,-0.19220001f,-0.21279999f,0.95480000f,-0.00090004f,0.38789998f,-0.15849998f,-1.08230000f,0.11269998f,0.46290000f,0.13889999f,-0.70200002f,-0.19320000f,-0.46330002f,0.21860000f,-0.45300001f,-0.06030002f,-0.06160000f,-0.11870003f,-0.55430000f,-0.77640000f,0.48530004f,0.62670001f,0.99000000f,-0.44029996f,-0.14649997f,-0.87490000f,-0.68290002f,-0.04650000f,0.19130001f,-0.76519998f,0.77140002f,-0.08960000f,0.40880000f,-0.25749999f,0.57210000f,0.02889999f,0.17250000f,-0.15590000f,0.20230000f,-0.14970000f,0.21389999f,0.19840000f,-0.20509998f,0.11580000f,-0.49999999f,-0.15850000f,0.43690001f,-0.19250000f,0.60730001f,0.06960001f,0.72880000f,-0.06870000f,-0.62670003f,0.28749999f,-0.13440000f,0.14770001f,0.72230001f,0.08810000f,-0.15650000f,0.18200000f,-0.09729999f,0.12319996f,0.31499998f,0.27609999f,-0.54870000f,0.87539999f,-0.05830001f,-0.21289999f,-0.12210000f,0.45339998f,1.14699997f,-1.12039998f,-0.06519997f,0.15720000f,-1.14010001f,-0.65170001f,-0.44280001f,0.81339998f,0.15749998f,1.08819997f,0.37839999f,-0.11580002f,-0.96830002f,0.80650000f,0.52270001f,-0.54509998f,0.16190001f,-0.02310000f,1.14850004f,-0.52420000f,0.57019999f,-0.21040000f,0.32200002f,0.08870001f,-0.50080000f,-0.07580001f,-0.85159999f,0.07930000f,0.07430000f,-0.15020000f,-0.24410000f,0.24680000f,0.75360002f,0.09440000f,-0.34550000f,-0.00150000f,0.79030002f,-0.09460000f,-0.74619999f,-0.14740000f,-0.95869999f,0.04340001f,0.08360001f,-0.21610001f,-0.47750001f,0.13310000f,0.32740000f,-0.01770000f,0.01190000f,0.04540000f,-0.33080000f,0.62139998f,-0.30910001f,0.15919999f,-0.34560001f,0.55640001f,0.49500000f,0.10510000f,0.24590000f,0.48159996f,-0.20250000f,0.97670000f,0.01459999f,-0.79819999f,-0.63530002f,0.64459997f,-0.11979999f,0.57089996f,0.33840000f,-0.40169999f,0.33150002f,0.66109998f,1.11280000f,-0.21520000f,-0.34590000f,-0.81489999f,-1.02970002f,0.11599999f,0.13010000f,-0.69589998f,-0.30780002f,-0.14740000f,-0.37710001f,-0.13680000f,0.14319999f,0.03240000f,-0.75170002f,0.05890000f,-0.27030000f,-0.25880000f,0.03710001f,-0.27390001f,-0.52030002f,0.22580000f,0.45100001f,-0.23660000f,-0.20920000f,-0.30090000f,0.00240001f,0.27290000f,-0.16949999f,-0.07270000f,-0.66389999f,0.02280000f,0.21730000f,0.13490000f,0.69800002f,-0.11640000f,0.12410001f,0.15670000f,-0.14569998f,0.37210000f,0.96600003f,1.23479994f,0.20999998f,-0.83839998f,-0.32570001f,0.27899999f,0.32080001f,-0.28199998f,-0.56289999f,0.67199996f,0.00949995f,-0.26700000f,-0.21370000f,-0.03839997f,0.39930001f,0.41109998f,-0.68410001f,0.41029998f,-0.40460001f,-0.65899999f,-1.19260002f,0.25169999f,1.01030001f,0.47319999f,0.43930000f,-0.70150001f,0.34080001f,-0.05019999f,0.23680000f,-0.23490001f,0.05419999f,-0.22680000f,-0.94079997f,0.28280000f,0.35260001f,0.03460000f,-0.42249998f,0.09359999f,0.14410000f,-0.37159999f,0.06159999f,-0.02220000f,0.37480001f,0.16680000f,-0.35640002f,0.00490000f,-0.46079997f,-0.28269999f,0.18539998f,0.10540001f,0.59040000f,0.01870000f,-0.38749999f,-0.04320000f,-0.47809999f,0.06910000f,0.64900002f,0.18700000f,0.04780001f,-0.30920000f,-0.49380002f,-0.30760000f,-0.24340002f,-0.05189999f,-0.48040000f,-0.30009996f,0.08760000f,0.61829995f,-0.09490001f,0.53850000f,-0.21310001f,-0.23789999f,0.68600001f,1.30369997f,0.40050000f,-0.18289996f,-0.28639997f,-0.49949997f,-0.29380000f,-0.62759998f,-0.37910001f,-0.26010000f,0.34690000f,-0.26000000f,-0.21460001f,0.41089998f,0.08960002f,0.42669996f,-0.12780000f,0.20360001f,-0.07929999f,0.24920000f,-0.19779999f,0.08349999f,-0.10700000f,0.22449999f,-0.16610000f,-0.39830000f,0.19090002f,0.00630000f,-0.63650001f,0.07110000f,0.08320000f,-0.22049999f,-1.04540002f,0.33290000f,-0.53390001f,0.37030000f,-0.24739999f,0.26880000f,0.13970001f,-0.06150000f,0.42950000f,0.26880000f,-0.29999998f,-0.28650000f,0.16939999f,-0.25750000f,0.83810001f,-0.80029998f,0.01819999f,0.05550000f,-0.32630001f,-0.47419999f,-0.03140001f,-0.51870000f,0.64160003f,-0.42749997f,-0.74250001f,0.43580000f,0.79120001f,0.34990001f,-0.80950002f,-0.40899998f,0.09789999f,-0.22569996f,-0.18959997f,-0.09500002f,0.49990002f,-1.32890001f,-0.41219999f,-0.40950003f,-0.93250001f,-0.94719997f,-0.16990001f,-0.16910000f,0.46030001f,-0.28659999f,0.06740000f,0.32150000f,0.20250001f,0.05250000f,-0.16960000f,0.24700001f,-0.00739999f,0.03750001f,0.49209999f,0.31230000f,-0.17730001f,-0.12940000f,-0.25380000f,-0.01070001f,-0.34710000f,0.34380001f,-0.31200000f,0.31729999f,-0.45260000f,-0.15340000f,0.43870001f,0.22450001f,1.06640002f,-0.07770000f,0.70420003f,0.23400000f,0.58459999f,-0.09650000f,0.39730000f,-0.00140000f,0.38670000f,-0.27569999f,0.64110000f,-0.21180001f,-0.17270000f,-0.07499999f,-0.77670001f,-0.32639997f,0.11670000f,0.70379999f,0.70640001f,0.30000002f,1.06720000f,-0.23540000f,-0.97060001f,-0.47599999f,0.13700002f,-0.07029998f,-0.23409999f,0.13300001f,0.20910001f,-0.57799996f,-0.53209998f,0.88150000f,0.06779997f,0.18379999f,-0.56720001f,-0.33719998f,0.01749999f,0.09260000f,-0.05910001f,0.03490000f,0.21270000f,-0.15500000f,0.61220000f,0.18259999f,-0.29249998f,0.18280000f,-0.04110000f,-0.14220000f,-0.53510001f,0.13360000f,-0.71020002f,-0.15339999f,0.67499999f,0.11920000f,0.27930000f,0.16309999f,-0.27970000f,0.16420000f,-0.54250000f,0.25359999f,0.12370000f,-0.10430001f,-0.79960001f,-0.07500000f,-0.01650000f,0.23920000f,-0.15280000f,0.10820000f,-0.60280000f,-0.03239998f,0.06710001f,0.85809996f,0.02799996f,0.21200001f,0.05970000f,0.03409998f,-0.49460003f,-0.47880000f,0.45100003f,-0.23259998f,0.27940001f,-0.30709997f,-0.62969998f,-0.00540001f,-0.10360000f,0.33909998f,-0.35039999f,0.49079998f,0.06989999f,-0.45299999f,-0.28589999f,0.71859997f,0.13899999f,0.25179999f,-0.60600001f,-0.12479999f,0.31130001f,0.23050003f,-0.39200000f,0.24000000f,-0.51500001f,-0.39930000f,-0.09439999f,0.10360000f,-0.48920001f,-0.23290000f,0.51750001f,0.09320000f,0.32690001f,0.20460000f,-0.20910000f,0.11189999f,0.13490000f,-0.03620000f,0.09430001f,-0.26590000f,0.22790000f,-0.08560000f,-0.38370000f,0.05980000f,0.40890000f,-0.05460000f,-0.72559998f,-0.21900000f,0.23539998f,0.07960000f,-0.05090000f,0.14549999f,1.12040001f,-0.14550001f,-0.81500003f,-0.62549999f,-0.41259999f,-0.73749999f,-0.75200001f,0.02240001f,-0.34200001f,-0.47389997f,-0.71429999f,0.09389998f,0.77249999f,-0.43079997f,-0.56679999f,-0.91580000f,-0.24710001f,-0.12290000f,-0.75100001f,0.18530001f,-1.08510001f,-0.54379997f,-1.08039998f,-0.69390001f,0.20430002f,0.47490000f,0.78890000f,-0.11709999f,0.53210001f,-0.20289998f,-0.69170001f,-0.19410000f,0.65510001f,0.14590000f,0.42040001f,0.16590000f,0.52260001f,0.11280000f,-0.26810000f,0.28590000f,-0.06370000f,-0.18669999f,0.27989999f,0.21960000f,0.03040000f,0.08260001f,0.89830000f,-0.08870000f,0.38400001f,0.08590000f,-0.36170000f,0.07500000f,0.51929998f,0.10350001f,0.56790002f,-0.01010000f,-0.57290002f,0.08350000f,-0.07960000f,0.23850000f,-0.57230000f,-0.54959998f,-0.49509999f,-0.48219999f,0.67900001f,0.12030000f,-0.75229999f,-0.43139998f,-0.34419999f,0.34189999f,0.10990001f,-0.08119998f,0.49750000f,0.26850000f,0.92180004f,0.39260001f,0.91200002f,-0.18720000f,0.64230002f,0.66670000f,-0.03280001f,0.78859998f,-0.23450001f,-0.03690001f,-0.08490000f,0.35199999f,0.03929999f,0.05870002f,0.48589999f,0.00060001f,-0.43309999f,0.06120000f,0.52930001f,-0.09380000f,0.74819998f,0.10610000f,-0.34779999f,0.00500000f,0.51189998f,-0.29390000f,0.26639999f,0.19119999f,-0.36679999f,-0.27130000f,0.26139997f,0.10020000f,-0.73490002f,-0.04520000f,0.29220000f,-0.02470000f,-0.72480001f,-0.16660000f,-0.53310001f,-0.18790000f,0.47789999f,-0.05880000f,-0.28059999f,0.17009999f,-0.48220000f,-0.06500000f,-1.25310005f,-0.02389999f,0.14030001f,0.60129998f,0.40960000f,-0.20960000f,-0.56430000f,0.08959998f,0.46960001f,-1.03059999f,-0.37210002f,-0.03890002f,1.12790005f,0.46299998f,0.51590001f,-0.08430001f,0.81830002f,-0.35299995f,-0.66379998f,-0.07950001f,-0.50510001f,0.62609995f,-0.03580004f,-0.74019998f,-0.90969999f,0.57500000f,-0.27530003f,-0.92939998f,-0.75610000f,0.12899999f,0.07200001f,-0.13530000f,0.33119998f,-0.27050000f,-0.10640000f,-0.05000000f,0.38810000f,-0.27040000f,0.49140001f,0.18780000f,0.79820002f,-0.26510001f,0.59820001f,-0.21700000f,-0.07170000f,0.02910000f,-0.00740000f,0.33460000f,-0.31970002f,0.02990000f,0.04940000f,-0.46890000f,0.34060002f,0.07900000f,0.73249999f,-0.01380001f,-0.63029999f,0.13140000f,0.82720000f,-0.25459999f,-0.00750004f,-0.76980000f,-0.08070000f,-0.20960000f,0.98710002f,-0.53869998f,-0.13120000f,-0.27330000f,0.55030002f,0.33359999f,-0.02860002f,-0.30099998f,0.43619999f,-0.49559998f,-0.29929999f,-0.20800000f,-0.26200001f,0.43829997f,1.00300001f,0.83099999f,0.36039998f,0.71979998f,-0.16590000f,0.54369999f,0.77220000f,-0.54359999f,-0.31530001f,0.50659999f,-0.33310003f,0.58109997f,-0.52840000f,0.03740000f,0.82230002f,-0.07800000f,0.37689999f,0.28550001f,-0.01500000f,0.08370000f,0.10250000f,-0.08560000f,-0.19430000f,0.32260000f,-0.40669998f,0.07280000f,0.42979999f,-0.00000000f,0.25700001f,-0.19549999f,-0.11560000f,-0.04859999f,-0.88210002f,-0.05220000f,-0.71769998f,-0.12010000f,-0.40090001f,-0.02159999f,0.70319998f,-0.11340000f,-0.31900000f,-0.32670000f,-0.49789999f,-0.59080001f,0.52120003f,0.27069999f,-0.08280000f,-0.20200001f,-0.13410000f,0.12189999f,1.10000003f,0.40809997f,-0.21640000f,-0.47760000f,0.76330002f,-0.61680000f,-1.11030002f,-0.12050003f,-0.94980002f,-0.01420000f,-0.64830002f,-0.02839998f,-0.50690001f,-0.10960001f,-1.05300003f,0.28309998f,0.26119999f,-0.85719998f,-0.06659999f,0.53590000f,-0.26880000f,0.53599999f,-1.02819998f,-0.84390003f,0.22800004f,-0.95640003f,0.11940003f,-0.59310001f,0.35229999f,0.56220000f,-1.34949998f,-0.61470000f,0.74120001f,0.00509999f,0.32720002f,-0.89100000f,-0.27439998f,-0.51539999f,-0.79060002f,-0.56700000f,0.14239998f,-0.09330000f,-0.05630000f,-0.11190001f,-0.67469997f,0.35460001f,-1.78079997f,0.20789999f,-0.24129999f,-0.23670000f,-1.09300001f,-0.44189998f,-0.20580000f,0.11760000f,0.44050000f,-0.05020000f,-0.84209999f,-0.04960000f,-0.53689998f,0.12730000f,0.85020001f,0.02549999f,-0.65809998f,0.45269999f,0.07139997f,-0.01660000f,0.57290000f,-0.59640000f,0.36829998f,-0.07810000f,-0.96199996f,-0.36280000f,-0.54049998f,-0.04910000f,0.12360000f,-0.31780000f,-0.49470000f,0.26870000f,-0.43040001f,-0.18629999f,-0.97069999f,-0.16510000f,-0.27060001f,-0.75180001f,-0.05689997f,0.19919999f,-1.40630001f,0.29970000f,-0.67749998f,-0.76110002f,0.73180004f,0.57210001f,-0.44749999f,-0.72749997f,-0.35020000f,-0.76710001f,0.02310004f,0.66540001f,0.94729998f,0.43679999f,-1.34039997f,1.18440001f,0.18170000f,0.44070000f,0.79279998f,0.79860000f,-0.21290003f,0.07530002f,-0.41720002f,0.98160000f,-0.72650001f,0.64800000f,0.98230002f,-0.38699999f,0.27489999f,0.09009999f,0.19039998f,-0.04770000f,-0.24150000f,-0.19720000f,-0.01330000f,0.04350001f,-1.00590001f,-0.18260001f,0.15429999f,-0.15860001f,-0.38740000f,-0.05090001f,-0.75660000f,-0.12850000f,-0.26300000f,-0.32510001f,0.65350002f,0.13350000f,-0.26069999f,-0.22270001f,-0.63829999f,0.06320000f,-0.91920000f,-0.14060000f,-0.82560002f,-0.22760001f,0.87970003f,0.47009999f,0.73709997f,0.24930003f,0.81639997f,-0.49740003f,-1.21010000f,0.37290000f,0.26450000f,0.11040002f,-1.73769999f,0.48450003f,0.75930000f,0.21870000f,-0.62660001f,1.04280005f,-0.07300001f,-0.02100001f,-0.68419999f,0.16230000f,1.11210004f,-0.64980001f,-1.25009997f,0.83190001f,-0.33450001f,0.57810002f,-0.89960001f,0.95940004f,-0.42480005f,1.30920004f,0.57780000f,0.25950000f,-0.94280001f,0.17120000f,0.61879996f,0.05430000f,-0.66790001f,-0.07220000f,0.17240000f,0.16310001f,-0.67540000f,-0.20980000f,-0.27910000f,0.33690001f,0.56810000f,-0.28320000f,-0.04580000f,0.13280000f,-0.24350000f,-0.05970000f,0.58269998f,0.15990001f,0.65329999f,-0.20089999f,0.19050004f,-0.17680000f,0.69260002f,0.10800000f,-0.29989998f,-0.38020000f,0.40660004f,-0.38970001f,-2.06080003f,-0.92489997f,0.10880001f,0.62550003f,-0.35930003f,-0.81480003f,-0.87959998f,-0.12540001f,-1.28940001f,1.07850002f,0.71509997f,-0.87780003f,0.26670001f,0.52590001f,0.31500000f,0.64410003f,0.57549999f,-0.27960000f,0.66809999f,-0.66000001f,0.52950001f,-0.31080004f,-0.29409995f,-0.44220003f,0.52020004f,0.72240000f,0.54669999f,0.55020000f,0.14090000f,0.15750000f,-0.93899999f,-0.03589999f,-0.03369999f,0.35690000f,-0.85240001f,0.21210001f,0.87429998f,0.30300000f,0.37820000f,0.24050000f,-0.21320000f,-0.35600000f,-0.46949999f,0.06850001f,0.44270002f,-0.10270001f,0.40969999f,-0.13100000f,0.49420001f,-0.03710000f,-0.61999999f,-0.29340000f,0.54010003f,0.05700000f,-0.70319998f,0.09609999f,0.20829998f,0.01500000f,-0.38089997f,-0.01499998f,-1.65139996f,-0.32760003f,-0.56029998f,-0.38879998f,-1.77320000f,-1.10460001f,0.39970002f,-0.99120001f,-0.29579997f,-0.18029999f,-0.38479999f,0.96000000f,0.01550001f,-1.21620003f,-0.75269992f,0.62190003f,1.53429998f,-0.20370002f,0.52060002f,0.52530001f,-0.51080000f,-0.32940004f,0.24830005f,-0.00030000f,-1.29159998f,0.14790001f,0.71729996f,-0.01679999f,-0.71979999f,-0.21150000f,0.46730000f,-0.10050000f,-0.52050001f,0.56380000f,-0.37190001f,-0.07080000f,-0.65509998f,-0.43880000f,-0.06600000f,0.42530000f,-0.34530001f,0.40279999f,-0.63799999f,0.34080000f,-0.32369999f,-0.24440000f,0.73300000f,0.29070000f,-0.19079999f,0.54749998f,-0.39360003f,0.08179999f,-0.46940000f,-0.03410000f,-0.53929997f,0.24820000f,-0.06010001f,-0.21830000f,-0.52900000f,0.01920000f,0.68510002f,0.45300002f,-0.49190002f,-0.61949998f,-0.92809999f,0.04499999f,-1.28289998f,0.62490002f,0.23440001f,-0.21509998f,-0.47550001f,-0.32789998f,-1.22239997f,-0.57570000f,-1.03069997f,0.47370000f,1.78980000f,-0.24329999f,-0.37119998f,-0.44639994f,-0.74880001f,-0.37649998f,-1.33339996f,0.55109999f,-0.31589999f,-0.41100001f,-0.40030001f,1.12979999f,0.30630000f,-0.01190000f,-0.33310001f,-0.35490000f,0.12810002f,-0.44440000f,0.65030002f,-0.23999999f,-1.14899999f,0.31469999f,-0.37669998f,0.05500000f,0.32920000f,-0.06420000f,0.68869999f,-0.09010001f,0.58950001f,0.08530000f,0.93030000f,0.29750000f,-0.42300000f,0.18810000f,0.26409999f,0.21889998f,-0.12500000f,-0.15300001f,-0.81030000f,-0.29360000f,0.45410002f,-0.29110000f,0.17090001f,0.76530003f,0.40429996f,0.14159997f,0.03550001f,0.30089997f,1.16090000f,1.33950000f,-0.63620003f,-0.20189999f,-0.64489997f,-1.10220000f,-0.82919994f,0.21240002f,1.54929999f,-0.08520001f,0.91570002f,-0.95070001f,0.57530003f,0.12900001f,-0.29540002f,-0.40739999f,0.16110001f,0.30780002f,0.43699998f,1.45080004f,0.27149997f,0.03869999f,0.59230004f,-0.07020004f,-1.17789998f,0.20960000f,0.47420000f,0.26570000f,-0.35040000f,0.28330001f,0.16080000f,-0.09100000f,0.21499999f,0.07399999f,-0.62299999f,0.12940001f,-0.26919999f,-0.00970000f,0.59329999f,0.11039999f,-0.57010003f,-0.13410000f,0.10440000f,-0.27730001f,-0.31979999f,0.28889999f,-0.80809998f,-0.42420001f,-0.96969997f,0.06629999f,-1.03949997f,-0.34540000f,-0.11530000f,-0.00520000f,-1.24610000f,-0.55500000f,0.38660001f,0.20280002f,-0.08960001f,-0.40770000f,0.07080001f,-0.08400000f,0.19380000f,-0.41249999f,-1.68859996f,-0.74850004f,-1.40799998f,-0.27420001f,0.75349999f,0.79740005f,0.13209995f,0.40139999f,0.60359998f,1.05570004f,0.52740001f,-0.38909998f,-1.76629994f,1.47030002f,-0.32069997f,0.11459999f,-1.77049999f,0.94200001f,0.68609999f,0.41399999f,-0.40000000f,0.22359999f,0.23389999f,-0.38000001f,-1.05709998f,0.23360000f,-0.58200000f,-0.58169999f,0.31230002f,0.51090000f,-0.30790003f,0.13819999f,0.63189998f,0.10700000f,-0.82430000f,-0.18080000f,0.80500002f,0.31430000f,0.63609999f,-0.08830000f,0.36940001f,-0.06800000f,-0.31150000f,0.24659999f,0.45829998f,0.15920000f,0.11270000f,0.34050000f,1.18249999f,0.32080001f,-0.33320000f,-0.09419999f,0.57769997f,1.35660001f,-0.59610001f,0.52470002f,-0.12720002f,0.58829997f,0.74930002f,-0.38129999f,-0.53530006f,-0.59100001f,0.55889998f,0.15330001f,-1.25490001f,-0.27210003f,0.96820003f,-1.25100002f,-0.14529999f,-0.25500002f,0.25780002f,-0.30750001f,-1.10530000f,-0.45509999f,0.53689998f,-0.88080000f,-0.82029996f,-1.50000003f,0.59390001f,-0.63360001f,0.57809999f,-0.40000000f,0.21940003f,-0.17120000f,0.36699999f,-0.27470001f,0.89410002f,-0.05660000f,0.54399999f,-0.06429999f,0.16040000f,0.09350000f,-0.21590000f,0.09060000f,1.18209998f,0.13310000f,0.94179999f,0.05020000f,-0.36139999f,-0.23790000f,0.20099999f,0.25560000f,0.08710001f,-0.38410001f,-1.12259995f,-0.13600001f,-0.48339998f,0.11920000f,0.07199998f,0.01340001f,0.45549998f,0.26309997f,0.32820003f,0.64110001f,1.39979998f,0.03449999f,1.45710004f,0.46229999f,1.62519995f,-0.36450001f,-0.26959998f,-0.17160000f,-0.54689999f,-0.80790001f,1.26509998f,-1.24410000f,0.24580004f,0.23130001f,-0.31900000f,-0.10980001f,-0.03780001f,-0.23790000f,0.13210002f,1.55790003f,-0.44819995f,1.19340003f,0.56500000f,0.04740001f,0.34159996f,-0.36810000f,1.07480000f,0.23070000f,-0.03860001f,-0.43430001f,0.33859997f,0.26760000f,0.22019999f,-0.09150001f,-0.47940000f,0.18130001f,-0.52980001f,-0.22610001f,-0.45019999f,-0.03030000f,1.10710000f,-0.06099999f,0.11530002f,-0.18270001f,-0.59659999f,0.08260000f,-0.85660002f,-0.04120000f,-0.95480001f,-0.17160000f,-1.03210002f,0.29970000f,-0.50499999f,0.41980000f,0.71449999f,0.11540001f,0.78160003f,-0.42750001f,-0.40180001f,0.44280003f,0.76779999f,-0.58949999f,-0.08460000f,0.22590000f,-0.71700001f,-0.64710002f,-1.71060003f,0.94800004f,0.18540001f,-0.42270002f,1.51530000f,-0.59430003f,-0.67129995f,0.80670002f,-0.24300000f,0.54630003f,-0.80060003f,0.87240002f,-0.68040003f,1.20540003f,-0.51790005f,-0.32610002f,-1.08180000f,-1.16939999f,0.24030004f,-0.90780004f,0.46080002f,0.50769999f,-0.34880000f,0.01340000f,0.53659998f,-0.00210000f,0.59159998f,-0.00410001f,-0.37459998f,-0.07540000f,0.37280000f,-0.15830000f,-0.42129999f,-0.08920001f,0.10499998f,0.03350000f,-0.76840000f,0.06950000f,-0.65999999f,-0.29409999f,0.24719999f,-0.07770000f,-0.76050001f,0.12220000f,-0.54659999f,-0.29270000f,0.12979999f,0.00340000f,0.92939999f,0.55330000f,0.73240002f,-0.33779997f,-0.55759999f,-0.97529999f,-0.30099997f,-0.32280000f,0.69159999f,0.64739999f,0.16979998f,-0.31560001f,0.19520002f,0.11519999f,-0.83509999f,0.80160004f,1.21099996f,0.08340000f,-1.32840001f,0.37800001f,-0.66960000f,0.50759999f,0.84239997f,0.45360002f,-0.92790001f,0.21150001f,-0.62100000f,0.62730001f,0.78339998f,-0.54810001f,1.03740000f,-0.77399998f,-0.89789999f,0.31449999f,-0.47990000f,0.12970000f,0.29890000f,0.03509999f,-1.02829998f,0.30900000f,-0.25649999f,0.18330001f,0.71849998f,-0.05510001f,-0.11200001f,0.03100000f,1.14069997f,-0.41600001f,-0.30010000f,0.32510001f,0.52690000f,0.22310000f,-0.16270002f,-0.49880000f,0.01790001f,-0.18030000f,0.13620000f,0.14200000f,0.37060000f,0.32540000f,0.22370000f,-0.23850002f,-0.59410001f,0.16590001f,-0.33450003f,-0.84150002f,-0.44049998f,0.58350001f,-1.13490000f,-0.20099999f,-0.41829999f,-0.55890000f,0.82229998f,0.68880002f,0.67519997f,-0.53070001f,1.50089997f,0.77610001f,0.01849999f,-0.74370000f,0.35950002f,-0.08009998f,-0.16850002f,0.89100001f,0.69610000f,0.59819999f,0.88459997f,-0.24360000f,0.54060000f,-0.70140000f,-0.16649998f,1.28250004f,-1.06279997f,-0.00390000f,0.05590001f,0.04240000f,0.61969998f,-0.10800000f,-0.44950000f,-0.23899999f,0.86390001f,0.04930000f,0.77719998f,0.07180000f,-0.05940001f,-0.41999999f,0.32779998f,0.05850001f,0.69199998f,0.30449999f,-0.52940001f,0.24220001f,0.83850002f,0.16010000f,-0.05680000f,-0.36710000f,0.16059998f,0.13860000f,0.85060000f,-0.06240001f,-0.40220000f,-0.10230000f,-0.91439998f,0.73680001f,1.12449999f,-0.23640000f,0.91669997f,0.76950000f,0.07509996f,-0.02190004f,1.36169999f,-0.19260000f,1.28919996f,0.05100001f,0.03859999f,0.50369998f,0.84779996f,-0.94200003f,0.09679999f,-0.16709996f,-0.90299998f,-1.04610005f,0.44630002f,-0.28950000f,-0.32679999f,0.26370001f,0.25339998f,-0.57390002f,1.00500002f,0.62940002f,0.02459999f,0.48660003f,0.54030001f,0.41689999f,-0.37949998f,-0.18100000f,-0.61079998f,0.16490000f,-0.44140002f,0.04680000f,-0.01949999f,0.17089998f,-0.46920000f,-0.08329999f,0.85019999f,-0.36669999f,0.38470003f,-0.14970000f,-0.41509998f,0.00659999f,-0.58849999f,0.43580000f,0.03099999f,0.27819999f,-0.16470001f,0.10639999f,-0.29209998f,-0.03750000f,1.10389997f,-0.23500001f,0.39670000f,-0.10020000f,0.64970002f,-0.04319999f,-0.31289999f,0.37379999f,-0.86839998f,0.76620005f,0.39979996f,-0.55290002f,-0.75009997f,0.81450003f,0.41999997f,0.14519999f,1.74579997f,-0.02010004f,0.29290005f,0.17519999f,-0.73009997f,-0.01679999f,-1.15109999f,-0.80040001f,-0.54860001f,-0.16889998f,-0.23210002f,0.36840000f,0.06930000f,-0.36090000f,1.58649998f,0.40380001f,1.05490000f,0.05339999f,-0.25760000f,0.20030000f,0.68960000f,-0.12679999f,0.29629998f,0.20110000f,0.81789999f,-0.35229999f,-0.48509998f,-0.10210000f,-0.50040002f,-0.22879999f,0.42690001f,-0.01030000f,-0.18710000f,0.42340000f,-0.55570000f,0.57570000f,-0.21569998f,0.00460000f,-0.25930002f,0.07950000f,-0.69700000f,-0.18320001f,0.76069998f,-0.22990000f,0.02240001f,0.01720000f,0.59619999f,-0.30300000f,-0.27960002f,0.54000000f,-0.93340000f,0.72840000f,-1.05099998f,-0.40429999f,-0.63100001f,0.72619998f,0.67609998f,-0.23410002f,-0.70009998f,0.66740000f,-0.06279996f,0.47379999f,-0.93099998f,0.12710001f,-0.47010002f,-0.10029998f,-0.60050000f,0.07390000f,-0.09620000f,0.94739998f,-0.10489999f,0.93689997f,0.48869998f,0.35569999f,0.22060000f,0.34190001f,-0.16190003f,0.16419998f,-0.03280000f,0.05890000f,0.04190001f,0.41710004f,-0.55390001f,0.17570000f,-0.28730000f,-0.17580001f,0.34500002f,-0.15049999f,-0.27789999f,-0.57260000f,-0.23740001f,0.32430000f,0.14010001f,0.73310001f,0.54850000f,0.36580002f,-0.55299999f,0.25430001f,0.05530001f,-0.28600001f,0.26080000f,0.41770002f,-0.05770001f,-0.47760001f,-0.30360001f,0.21310000f,-0.34990001f,-0.06310000f,0.31020001f,0.39399999f,-0.80189999f,0.91660003f,0.29169998f,0.33139999f,0.35949998f,-0.16310000f,-0.85610000f,-0.21170000f,0.65219998f,-0.15250001f,-0.71829999f,0.64320000f,-0.83929998f,0.10400001f,0.59910005f,0.73890000f,0.54349997f,-0.29800002f,1.23670000f,-0.79750000f,0.42889999f,0.18940002f,0.84430000f,-0.35810000f,0.13829998f,0.10869998f,1.08899998f,-0.56530000f,0.43530002f,0.42710000f,0.39729999f,-0.51079999f,0.23360000f,0.62630003f,-0.36710001f,0.19690000f,0.13790000f,0.34630000f,-0.71350002f,-0.01350000f,0.30510001f,0.42160003f,-0.20200001f,-0.27520000f,-0.17120000f,0.46680002f,-0.20040000f,0.31230000f,0.56250003f,0.31590001f,-0.44550000f,0.23890002f,-0.15610000f,-0.10699999f,-0.47260001f,0.04240001f,-0.25120002f,-0.12940000f,-0.90270000f,-0.04799999f,0.42350002f,-0.96109998f,0.23570002f,1.34170003f,-0.47840001f,-0.05620001f,0.36750001f,1.01329998f,0.22519999f,-0.51960002f,0.46250004f,0.59920002f,0.25520001f,-0.68590002f,1.13450001f,0.76810001f,0.00090000f,-0.19110002f,0.07400003f,1.09889999f,-0.62040001f,0.03930001f,0.89900000f,0.01300000f,0.68919998f,-0.18060000f,1.05300001f,-0.82280002f,0.11880002f,0.17520003f,-0.86280003f,-0.03260001f,0.10820000f,-0.25590000f,-0.26610002f,0.70880002f,-0.17600000f,0.06240000f,-0.55920002f,-0.17330000f,0.20570000f,-0.44210003f,0.08210000f,0.30440001f,0.17440001f,-0.68610002f,0.05610000f,0.04849999f,0.33310000f,-0.22730002f,0.23450000f,0.62270000f,0.03250002f,0.39779999f,0.35820002f,-0.65630001f,0.04430001f,0.20409999f,-0.85219998f,1.17230004f,-0.27530004f,0.30379999f,-0.99359995f,-0.37850001f,0.70880000f,1.42500002f,-0.84620000f,0.63570001f,-0.04310003f,-0.91240000f,1.10910000f,-0.20370000f,-0.93140002f,-0.02820001f,0.52100002f,-1.20860003f,0.68490000f,-0.10350000f,-0.35019997f,-0.17670001f,-0.73040000f,0.89209999f,-0.34600001f,0.38519999f,-0.53299999f,-1.19840001f,0.76889996f,-0.57140000f,-0.11989999f,0.13160001f,-0.71480000f,0.35650000f,-0.14770000f,-0.10900000f,-0.79820002f,-0.12950002f,0.23030000f,-0.17180001f,-0.10180000f,-0.32880000f,-0.23640000f,0.37249999f,0.02350000f,0.53329999f,-0.13009998f,-0.44830001f,0.54550001f,0.20960000f,0.29800001f,0.01640000f,-0.26480000f,0.67410001f,0.29070002f,0.23740002f,-0.52900000f,-0.45690000f,0.20849999f,-0.38200002f,-0.59829998f,0.80769997f,0.09729999f,0.73030000f,-0.32920002f,0.76149999f,-0.27910001f,0.16029999f,-1.20119998f,0.34979999f,-1.02680000f,-0.11150001f,-0.14550001f,-0.01600003f,1.00250000f,1.35749997f,-1.27399999f,-1.33910001f,0.57740002f,0.09160000f,-0.26759999f,0.00609999f,0.59729999f,0.73460000f,-0.40849999f,0.76640000f,0.08059998f,-0.82349997f,0.13160000f,-0.90940002f,-0.22320000f,0.24709999f,0.36490001f,0.17210001f,-0.21530001f,-0.68770002f,-0.53270001f,0.48570002f,-0.47130000f,0.61500000f,0.20220001f,-0.67810000f,-0.35510001f,-0.38099999f,-0.61620000f,-0.20829999f,-0.47210000f,-0.16440001f,0.73680002f,-0.41360000f,-0.24520000f,-0.76979999f,-0.48300001f,0.34200002f,-0.49680000f,-0.05369999f,-0.19469999f,-0.25170000f,-0.20910001f,-0.03929999f,0.89009999f,-0.02770001f,-0.04379997f,0.18970000f,0.50980001f,-0.08360002f,-0.55410002f,1.00160000f,0.11409998f,0.28539998f,0.61480004f,-0.42270000f,-0.15600002f,0.23259999f,-0.23880002f,0.43660000f,-0.52730002f,-1.08660000f,0.38420002f,-0.17890001f,-0.20890002f,-0.31230000f,-0.37769999f,1.04679998f,-0.32399998f,-0.15570000f,0.61459996f,0.06980002f,-0.39510002f,-0.59649999f,0.09890000f,-0.38190000f,0.03989999f,0.68030003f,0.16210001f,0.49570000f,0.61670002f,0.16280001f,-0.34640001f,-0.40430000f,-0.36969999f,0.53879999f,-0.17159999f,-0.37530002f,0.59850001f,-0.03110000f,0.41270002f,0.02869999f,0.33490001f,-0.59240000f,-0.27880001f,-0.28210001f,0.03730000f,-0.69879999f,0.01480000f,-0.31350000f,-0.05370000f,0.43749999f,0.36530002f,0.63170001f,-0.37630000f,-0.87430000f,0.80940000f,0.63250003f,0.10960000f,-0.07779999f,0.20790001f,-0.12740000f,1.46739996f,-0.07610001f,-0.14520003f,1.34699997f,-1.14699996f,-1.10060001f,0.13490003f,-0.36589999f,-0.15619999f,0.19009999f,-1.05879997f,-0.54830000f,0.19329997f,-0.18930000f,-0.43059999f,-1.02729998f,0.33669998f,-1.03260001f,1.54710000f,0.19899998f,-0.02709997f,0.67470001f,-0.55430000f,-0.33260001f,0.13820001f,-0.61100001f,-0.19540000f,-0.45680003f,-0.04360000f,0.16980000f,0.13260000f,0.47040003f,-0.62520000f,0.40620000f,-0.48900001f,-0.08210001f,0.34130000f,-0.57570000f,-0.12990002f,-0.04020000f,0.23460000f,0.02900000f,0.16900001f,0.03190002f,-0.76269999f,0.41170001f,-0.15609998f,0.30590004f,-0.73790000f,0.17190001f,0.28170001f,0.16130002f,0.98749998f,-0.27160001f,-0.60179999f,-0.68090001f,0.25809998f,-0.33390002f,-0.41430001f,0.13260000f,-0.11359999f,1.33780000f,-0.34380000f,1.29680001f,-0.71940004f,-0.27549999f,-0.34319999f,-0.97880000f,0.87470001f,-0.45029999f,0.38669999f,-0.61770002f,1.08690002f,0.90489998f,-0.28800002f,-0.05040003f,1.56970000f,0.98290003f,0.23439995f,-0.48660000f,0.94570002f,0.44840000f,-0.11680000f,-0.59250000f,0.13170000f,0.43890004f,-0.26610000f,-0.65740002f,-0.24620001f,0.78670000f,0.47690001f,-0.77710000f,-0.39290003f,-0.21649999f,0.24530000f,0.06310002f,-0.56350001f,0.21680000f,0.50680002f,-0.13690000f,-0.00710000f,0.21240000f,0.18360001f,0.56670003f,-0.34710001f,-0.49030000f,0.16270000f,0.23230001f,-0.25389999f,-0.30010001f,0.30730000f,-0.24950001f,0.50630001f,-0.80799998f,-0.10890000f,0.13560002f,1.46689999f,-0.84660002f,0.60719997f,0.27109999f,0.52820002f,-0.43269997f,-0.32340003f,-0.20579997f,-0.65949999f,0.50760000f,0.25189998f,-0.05300000f,-0.37379999f,0.43250002f,-1.31720001f,0.22150000f,-0.30329999f,1.15940002f,-0.27990000f,-0.53679999f,-0.49709999f,0.93439999f,-0.89369999f,0.06830003f,-1.62780000f,0.26400000f,0.17810000f,0.64720000f,0.27800002f,-0.27480001f,0.52320001f,0.16049999f,0.69270003f,-0.50860002f,0.58420000f,0.34999999f,-0.01520000f,0.02110000f,-0.22990000f,-0.22810001f,0.57730000f,0.13259999f,0.23100001f,-0.10640000f,-0.18520000f,0.55200002f,0.11759999f,-0.48110001f,-0.03369999f,0.32900001f,-0.23899997f,-0.33100000f,0.09340001f,-0.36280000f,0.06759999f,-0.19480004f,-0.71390001f,0.43019999f,0.21980001f,-1.11300000f,0.59780002f,-0.43470001f,-0.07899997f,-1.37239998f,0.40380000f,0.62169999f,-0.38949999f,0.31290000f,-0.14440001f,-0.41279998f,-0.94209997f,0.55149999f,-1.35389996f,-0.07720000f,0.27639999f,0.63270002f,-0.14609998f,-0.45380001f,-0.23610001f,-0.12090005f,1.67729999f,-1.06280002f,1.25180000f,-0.53319998f,0.04640000f,-0.50000002f,0.42320002f,-0.20820000f,-0.19860001f,0.52840001f,0.43640000f,-0.31080000f,-0.06720000f,0.30300003f,-0.27060001f,0.34180003f,-0.64780003f,0.05760001f,0.02880001f,-0.19210000f,0.67090001f,0.54270000f,-0.13589999f,0.13940001f,-0.13580000f,-0.16280000f,-0.43840002f,-0.06199999f,-0.38440002f,0.03830001f,-0.31190002f,-0.20419999f,-0.51220001f,-0.49630003f,0.07870001f,0.41890001f,-1.12809998f,0.12230001f,-0.41510002f,0.05589999f,0.38630007f,-0.04500000f,-0.60539999f,0.50970002f,0.27630000f,1.31010004f,-0.58530003f,-0.40590002f,0.99530002f,-0.63509997f,-0.55119999f,1.07799998f,-0.61650000f,-0.09030000f,0.87110000f,-0.07160001f,0.65119999f,-0.15000000f,0.98479999f,-0.24880000f,1.32270000f,0.35850001f,-0.25730005f,-0.12900003f,-1.23769999f,1.26180003f,0.48500002f,-0.78100000f,-0.40700000f,0.43120000f,0.03320000f,-0.06220001f,0.32140000f,-0.28799999f,-0.03600000f,0.22600000f,0.16280001f,0.51850002f,-0.26650000f,-0.45660000f,0.38460000f,0.26460002f,-0.54540002f,-0.10659999f,-0.35420000f,0.18859999f,0.38740000f,0.24450001f,-0.39570001f,-0.16639999f,-0.33400000f,0.15579999f,0.34460000f,-0.08240001f,0.48920001f,-0.73070001f,0.24460002f,-0.44570000f,-0.27510002f,0.97039998f,-1.04399995f,-0.20989999f,-0.39169998f,-0.63389998f,0.69529996f,0.28580000f,-0.36419999f,0.82630000f,0.15440000f,-1.29160000f,0.79340003f,0.77490001f,0.17109998f,0.00330000f,0.45869998f,-0.35310000f,0.46950001f,0.44009999f,0.53820000f,-0.00960000f,0.28079999f,-0.41270000f,0.60350002f,-0.27719999f,-0.65639998f,-0.24610001f,-0.31290001f,-0.63149998f,-0.30810001f,0.17410000f,-0.09850000f,0.01490002f,-0.55130000f,-0.45530001f,-0.27910000f,-0.39630002f,0.32069999f,-0.33660000f,0.17820000f,-0.27510001f,0.65310000f,0.56850003f,0.08310000f,-0.49470003f,0.10230000f,-0.39070000f,-0.16010001f,0.51070000f,0.36770001f,-0.09680000f,0.33440000f,-0.35340001f,0.18060000f,-0.36630001f,-0.10890000f,0.01800002f,1.04059998f,-0.58829997f,0.23779997f,0.70490001f,-0.87620001f,0.23190000f,0.70519997f,-0.22060001f,-0.15790002f,-0.51149999f,-0.63419999f,-0.90490000f,0.70530001f,-0.67079998f,-0.66069997f,0.26180001f,0.79470002f,-0.35090002f,-0.79200000f,-0.30409999f,-0.05080000f,-0.11840001f,0.87110003f,-0.70329999f,0.57949999f,-0.48360000f,-0.27940000f,-0.02340001f,-0.71570001f,-0.49250001f,-0.44899999f,-0.58670002f,0.32030001f,-0.25110000f,0.37350000f,-0.09090000f,-0.04230001f,0.13369999f,0.64750001f,-0.38540000f,0.50780000f,-0.18100000f,-0.02780001f,0.45279999f,0.45079999f,0.21379999f,0.16059999f,-0.32500000f,-0.47060000f,-0.22810002f,0.22450001f,-0.13400000f,-0.15760000f,0.59860002f,0.23299999f,-0.34720002f,0.41560001f,-0.11860000f,-0.06140000f,-0.40370003f,1.03039997f,-1.36490002f,0.73799999f,-0.53199997f,-0.30509998f,-0.44179999f,0.82129998f,-0.40079998f,-0.13070000f,-0.83929997f,-0.27789998f,-0.22420000f,0.06200000f,-0.07979999f,0.44980002f,0.57110001f,-1.02510000f,0.09569997f,-0.09369999f,0.01520001f,-1.13650003f,0.11210000f,-0.27750000f,0.40970001f,0.22870004f,-0.52800000f,-0.66640000f,-0.39240000f,0.67700000f,-1.24690003f,0.27110001f,-0.77170000f,-0.31549999f,0.47560001f,-0.31000000f,-0.75200002f,-0.04720001f,0.32230001f,-0.22510000f,-0.78879998f,-0.05000000f,-0.36360003f,0.69480000f,0.69630000f,0.29370002f,0.44830000f,-0.23949999f,0.31070002f,-0.44750000f,-0.45419999f,-0.29460001f,-0.45449998f,-0.19710000f,-0.38449999f,-0.08349999f,-0.22050002f,0.69210000f,0.04590000f,0.45810001f,0.34700000f,-0.40600000f,-0.65610000f,0.02099996f,0.68859999f,0.43539999f,-1.25650002f,0.83190000f,0.86420000f,-0.55390001f,-1.32269998f,0.88409998f,-1.13990000f,0.04810001f,0.61209998f,-0.08280000f,0.68649998f,0.21479999f,0.79260001f,0.04849999f,0.08020003f,-0.78840003f,-0.30799998f,-0.13730001f,-0.57839999f,0.41029997f,-0.71870000f,-0.48879997f,-0.54380001f,0.35130003f,0.56699998f,-0.42900000f,0.01199999f,0.08520000f,0.37389998f,0.11569999f,-0.42750001f,0.36270001f,0.53790000f,-0.06990000f,-0.14120000f,-0.04960001f,-0.20170001f,0.58690001f,-0.04370000f,-0.05710000f,-0.48109999f,-0.55210002f,-0.78750000f,-0.42210000f,-0.39170000f,0.06049999f,-0.01880000f,-0.42760001f,-0.27030000f,0.72750001f,0.65740000f,-0.03100000f,0.23459999f,0.15420000f,0.50590000f,0.69629999f,0.32130000f,0.11969999f,0.38880000f,0.23399999f,0.44190001f,-0.44700000f,-0.03480000f,0.82019999f,0.19050000f,-0.41220002f,-0.44010002f,0.36690000f,0.64259999f,0.15599999f,0.75540002f,0.10830000f,0.40740001f,-0.21149999f,0.07170000f,0.03660000f,0.05310000f,0.69569999f,0.26339999f,0.98489998f,-0.18030000f,0.31319999f,0.60810002f,0.35820000f,0.64709999f,-0.25730001f,0.57339999f,0.63140001f,0.71880003f,0.00880001f,0.18549999f,-0.16350000f,0.10210000f,0.54090002f,-0.40670000f,-0.39310001f,-0.02870003f,0.72249999f,0.84229999f,0.60410001f,0.06740002f,-0.78020003f,0.48900000f,-0.19480000f,-0.56120000f,-1.04520003f,-0.82289999f,-0.46210001f,-0.01979997f,-0.67820001f,-0.43630001f,0.05170000f,-0.20900001f,-0.73000001f,-0.66019999f,0.42090002f,0.45480000f,0.09719999f,0.19980001f,0.87240002f,-0.01770000f,0.39449999f,0.28050000f,-0.39720002f,-0.12930001f,0.06840000f,0.80609999f,-0.19260001f,0.32549999f,0.23789999f,-1.04520002f,0.04320002f,0.05280000f,0.79950000f,-0.89340002f,0.03540000f,-0.42929999f,-0.55020000f,-0.58680000f,0.33060003f,0.29970001f,-0.13740000f,-0.43259999f,0.40950000f,-0.57300000f,0.53200003f,-0.06849998f,-0.55230001f,-0.94269999f,-0.28230003f,1.34240003f,0.53900003f,-0.11250000f,-0.37350002f,0.79779997f,0.14200000f,-0.55250001f,-0.52190004f,0.48530002f,-0.12930000f,-0.95700002f,-0.83200005f,0.70760001f,0.07540000f,-0.09650000f,-0.34130002f,1.12439999f,0.70500003f,-0.19649998f,-0.66850002f,-0.23370001f,-0.33230001f,-0.46300000f,-0.74060003f,-1.10520001f,-0.39840002f,-0.72449999f,-0.05849998f,-0.22710001f,-0.69959998f,0.46920001f,0.95670002f,-0.40290001f,-0.00150000f,0.40020000f,0.97289999f,-0.55770003f,-0.35850000f,-0.08850000f,0.53790002f,-0.49680003f,-0.19650000f,0.05940000f,0.60330001f,-0.62070003f,-0.28200001f,0.70560001f,0.77669999f,-0.48990001f,0.26400002f,0.00810000f,0.29190001f,-0.45420001f,0.16800003f,-0.87600003f,0.66029999f,1.03830002f,0.62830004f,0.54209997f,0.75989999f,-0.57930001f,-0.44050002f,1.54320001f,0.74440003f,0.52160000f,0.29900003f,-1.10009999f,-0.99510003f,0.03039999f,0.73860004f,-0.11350000f,-0.52050003f,-1.31890003f,-0.55670003f,0.04220000f,0.12480000f,0.03939999f,0.49320002f,0.95100000f,0.24080003f,0.56300001f,0.24740002f,-1.33040000f,-0.62080001f,-0.54419999f,-0.48990003f,0.89070003f,1.02240003f,0.54029998f,-0.02670001f,-0.14910000f,-0.04139999f,0.51240001f,0.88260000f,0.50460002f,0.60330000f,-0.83850000f,-0.47129999f,0.62640002f,-0.36630002f,-0.55890002f,0.04050001f,-0.31050001f,-0.72870001f,-0.08460000f,-0.24390000f,0.31140001f,-0.34830001f,0.03420000f,0.55049998f,-0.07860000f,0.05699998f,-0.36059999f,-0.70020000f,-0.90720001f,0.54310000f,0.62719996f,0.25579999f,0.75620000f,0.32400003f,0.65259996f,0.61240001f,0.47319998f,0.87500002f,0.55479998f,0.89280002f,-0.11950001f,0.24490000f,-0.24000001f,-0.84400002f,1.58399996f,1.07860003f,-1.32890000f,-0.71210004f,0.20610001f,0.06750001f,-0.18030001f,-0.36150001f,0.86100002f,0.16660002f,0.62590000f,0.17650000f,-0.79009998f,-0.18770001f,-0.76840002f,0.21989998f,0.53579999f,0.80009998f,0.24900001f,0.49109999f,0.90720000f,0.71129999f,0.58800000f,-0.20790002f,0.78120000f,0.05939998f,0.38250000f,-0.04200001f,-0.74700001f,0.19499999f,0.78600000f,0.73049996f,-0.73350002f,-0.98520000f,-0.14610000f,-0.07770001f,-0.14790000f,0.20760000f,-0.16680000f,0.35099999f,0.35610000f,0.71370000f,-0.15270000f,-0.61679998f,-0.28560001f,-0.63280002f,0.05180000f,-0.14840001f,0.02720000f,-0.32020002f,-0.05490004f,0.73410001f,0.85740000f,0.11140001f,0.17469999f,-0.62310003f,-0.44150001f,0.32450000f,0.16429997f,0.50410000f,0.45529998f,0.66350001f,-1.00369999f,-0.65750002f,-0.17210001f,0.30430001f,-0.30780003f,0.56999998f,0.99649997f,0.48669999f,-0.32809999f,-0.40610000f,0.11860001f,0.43220002f,-0.84919997f,0.40470000f,-0.35580001f,-0.13410001f,-0.17520000f,0.30510001f,0.99150001f,-0.02370002f,0.22200000f,0.87120000f,-0.72030002f,0.27510000f,0.58110001f,-0.23100000f,0.78929999f,0.29189999f,0.80130000f,0.33389999f,-0.85110001f,-0.90210000f,0.45150000f,-0.10080001f,0.85679998f,-0.16290000f,0.55709998f,0.81749999f,-0.20310000f,0.07620000f,0.49680001f,0.02580001f,-0.75239999f,0.26020001f,-1.02590000f,-0.66310003f,0.61940004f,-0.19479999f,-0.00689996f,-0.48390000f,-0.52389999f,-1.03810001f,-0.11030001f,0.31130000f,1.53699995f,0.99460001f,-0.98640000f,-0.37960003f,-0.24179999f,-0.06800001f,0.48929999f,0.70250001f,-0.62880001f,-0.00020000f,-0.07840001f,0.34500000f,-1.07119998f,-0.25260001f,-1.36560001f,-1.22280005f,0.26809999f,-0.17010001f,0.71080002f,-0.06660000f,-0.45090001f,-0.46019999f,-0.38220000f,0.42570002f,-0.79890000f,-0.18869999f,-0.66209999f,0.32130001f,0.51869999f,0.02159999f,0.74099998f,0.76199997f,-0.51900001f,-0.92520000f,-0.25740001f,-0.41190000f,0.36629999f,-0.18660002f,0.27180001f,-0.26790000f,0.30960000f,-0.23670001f,-0.05100001f,-0.66209998f,-0.85140002f,-0.38879999f,-0.41430002f,0.03029998f,-0.22800000f,-0.55370002f,-0.10020001f,0.43860001f,-0.75660001f,-0.09200001f,-0.23770002f,0.37750001f,0.17960000f,0.02240000f,1.25929999f,0.55870000f,1.33090000f,0.80270005f,-0.12479999f,0.12060000f,-1.17420001f,-0.62740004f,-0.48119998f,-0.42540000f,-0.81590001f,-0.96790005f,0.80049997f,0.59690000f,-0.43670001f,-1.22250005f,0.76160003f,0.14780002f,-0.63519999f,-0.91240003f,0.22360000f,0.70050001f,0.34140000f,-0.36060001f,0.16200000f,-0.37230000f,0.41430001f,-0.31260002f,-0.08760000f,0.03180000f,0.65069998f,1.05689999f,0.78390003f,0.90869999f,-0.06360000f,-0.36690000f,-0.29400001f,-0.47159998f,-0.44099999f,-0.30509999f,-0.84270003f,-0.25620000f,0.84629998f,0.80099998f,-0.95670003f,0.34290000f,0.42600000f,0.96030002f,-0.88860001f,-0.22559999f,0.07500000f,-0.36930002f,-0.73459999f,0.05060000f,-0.25339996f,-1.08740003f,-1.00670002f,-0.35050001f,0.23230001f,-0.69050001f,-0.42009999f,0.48310002f,-0.00299998f,0.42980001f,0.32910000f,0.06050000f,0.12930002f,0.05430001f,0.71920001f,1.08300004f,0.31880001f,0.15100001f,1.12390002f,0.37010002f,-0.37690000f,0.34810000f,1.06319998f,0.84000001f,0.49580002f,1.19320004f,0.33919999f,0.31560002f,0.10080000f,-0.63479999f,-0.80160002f,0.48480003f,-0.00209999f,-0.40110001f,-0.95070000f,0.16740000f,0.74490003f,-0.26279998f,0.25440000f,-0.35699999f,0.32190000f,0.57630001f,-0.26490001f,-0.26310001f,0.87240001f,0.02910000f,-0.02340000f,0.03990000f,0.34110001f,0.86370002f,0.29310000f,-0.53369999f,0.73019999f,0.54659998f,0.83220001f,-0.38610000f,0.71940003f,0.51070003f,0.41970001f,-0.33850000f,-1.11829999f,-0.72530003f,-0.27350000f,-0.27230002f,-1.31429997f,-0.58650000f,0.68949999f,0.31030001f,0.29339999f,0.22640001f,-0.07689998f,0.50250001f,0.88789998f,0.98830001f,-0.17290000f,-0.13270000f,0.66960002f,0.04020000f,-0.39290002f,0.22850000f,-0.54530002f,-1.26730005f,-1.29980001f,-1.05140004f,-0.51539999f,-0.05500001f,-0.28790002f,-0.38129998f,-0.54570000f,0.27209999f,-0.77010001f,-0.81389999f,-0.60090003f,-0.52500001f,-0.64289998f,-1.05689998f,0.17190000f,0.36299999f,0.28860000f,0.25769999f,0.14310000f,-0.65969999f,0.61829999f,0.03719998f,0.01530000f,0.05730000f,-0.14940000f,0.38430002f,0.29910000f,-0.36270002f,-0.93090004f,0.33959998f,-0.79020002f,-0.51540000f,0.00180000f,-0.38819998f,-0.08729999f,0.71850001f,0.17610000f,0.44170002f,0.04820000f,-0.54480005f,0.08189999f,0.53850000f,0.38070002f,-0.10890000f,1.28330003f,0.77170005f,-0.61580002f,-0.82760005f,-0.36429996f,0.13770001f,1.16149998f,0.54490003f,-0.31210000f,-0.65130003f,-0.30070002f,-0.31530002f,-0.44280000f,-0.61720002f,-0.60220000f,-0.93140003f,0.31030001f,0.46230003f,0.17219995f,0.99220001f,1.36740002f,-0.29820001f,0.48930001f,0.05580000f,-0.76080003f,-0.00389999f,0.51930000f,-0.14130000f,-0.01170001f,0.49860002f,0.85530003f,0.99240002f,-0.66840003f,-0.08490000f,-0.19530000f,-0.76139999f,0.37350000f,0.67349997f,-0.46530002f,0.16020001f,0.01590000f,0.21390001f,-0.26760000f,0.21360002f,-0.57000000f,0.19440002f,0.66510002f,0.34740000f,0.83640000f,-0.37740004f,0.77640003f,-0.46250000f,-0.44640002f,0.45060000f,1.18649997f,0.81750000f,-0.05379999f,0.16880000f,-0.78079997f,-0.53780000f,0.39120000f,0.21000001f,0.71660001f,-0.02039999f,-1.36240000f,-0.81120004f,0.61040000f,0.10940001f,-0.16820001f,-0.20080001f,-0.37699998f,-0.57520001f,0.22979999f,-0.26040001f,-0.13630001f,-0.06290001f,-0.47349999f,-0.66270002f,-0.02709999f,0.30550001f,-0.12940004f,0.17670000f,0.72779999f,-0.25770001f,0.52229998f,0.45749998f,-0.02040000f,-0.32490000f,-0.33539999f,-0.29189998f,0.03000000f,0.07859999f,0.00780000f,0.69630000f,-0.72600002f,-0.85919998f,0.30660001f,0.74370001f,0.04920000f,0.20190000f,-0.68519999f,-0.26249999f,-0.05220000f,0.54090000f,0.15870000f,0.14910000f,-0.72390000f,-0.26399999f,0.00390000f,-0.47730000f,0.94500000f,-0.70350002f,-0.68329998f,-0.02090000f,0.86570001f,0.75410003f,-0.03970000f,-0.31290001f,-0.23060002f,0.28060000f,-0.29130000f,0.38070001f,-1.00580000f,-0.64600003f,-0.37729998f,0.23890001f,0.08830002f,-0.71110003f,-0.14050003f,0.61750002f,-0.31370000f,0.13390000f,-0.24460000f,-0.90660003f,-0.75199998f,-0.62780001f,-0.37160000f,0.15640000f,0.12019998f,0.65060001f,-0.81150000f,0.28020001f,0.27930001f,-0.27839998f,0.59670001f,0.34260000f,0.03690000f,0.47340001f,0.45960000f,-0.10980001f,0.21690001f,-0.59040000f,-0.51840001f,-0.54389999f,-0.08970000f,-0.80489999f,-0.71730002f,0.33090002f,0.53370001f,-0.44700002f,0.27090000f,-0.18059999f,-1.00200002f,-0.00480000f,-0.63659999f,-0.47249999f,0.10560000f,-0.45480001f,0.63960000f,-0.13740002f,-0.77550003f,-0.63150002f,-1.43300001f,-0.73000002f,-0.37639998f,0.08120000f,-0.62429998f,-0.64570000f,-0.23729996f,-0.20749998f,-0.65559997f,0.00060000f,-0.23700000f,-0.02980000f,-0.09529998f,-0.60030000f,0.81860001f,0.75040004f,0.02569996f,0.31409998f,0.31650002f,0.82910006f,0.14249999f,0.30690000f,0.38930002f,-0.32230002f,-0.28210000f,0.35970001f,-0.54700000f,-0.51780002f,-1.19960002f,0.43829999f,-0.60180000f,-0.90450001f,-0.07380000f,-0.55019998f,-0.45869999f,-0.12689998f,-0.52169999f,-0.49889999f,-0.17580000f,-0.80129998f,0.03060000f,-0.13800000f,-0.79469999f,-0.09089998f,0.45240003f,0.14130000f,0.55529998f,0.18359998f,0.57690003f,-0.29550002f,0.34770000f,0.06599999f,-0.49950001f,0.27240002f,0.14130000f,-0.63630002f,-0.34380001f,-0.11699999f,-0.67800002f,0.21040001f,-0.70100001f,0.16520000f,0.51060000f,-0.22700000f,-1.41840003f,-0.62460004f,0.92290000f,0.54550002f,-1.49509998f,-0.66430003f,-0.98659999f,-0.35520000f,0.66830000f,-0.10129999f,0.57219998f,-0.07960000f,0.67400000f,0.16080000f,0.20240001f,0.80200003f,-0.30469999f,0.22470000f,-0.67079999f,-0.27880000f,-0.45570000f,0.07790000f,-0.52180000f,-0.50660003f,0.49819998f,-0.40050001f,0.45780000f,-0.37050001f,-0.12060000f,0.67080000f,-0.29580001f,-0.70170000f,0.46770000f,0.56069999f,-0.31710001f,-0.73679998f,-0.55199999f,-0.99930000f,-0.38070000f,0.33239998f,-0.03660000f,0.60209999f,0.28619999f,0.70200001f,0.87120002f,-0.02579999f,0.37409999f,-0.19109998f,-0.08940000f,-0.29940000f,-0.24630000f,-0.81360000f,-0.63720002f,-0.44340000f,0.02340000f,0.65950000f,0.75050000f,0.93770003f,0.58459998f,0.20340001f,-0.29659999f,0.43960001f,0.17180002f,-0.62999999f,-0.73830000f,-0.71270002f,-1.10189997f,-0.78730000f,-0.17040000f,-0.16780001f,-0.00369998f,0.47730004f,-0.23520001f,0.71220003f,-0.98739998f,-0.59220002f,0.06939998f,-0.07440001f,-1.07389998f,-0.58810003f,0.91920000f,0.12180001f,0.72879998f,0.60640000f,0.41349999f,-0.02079998f,0.73530003f,0.87780001f,0.73620001f,0.95099999f,0.74729998f,0.69070001f,-1.33949996f,-0.96409998f,0.95999999f,0.82379999f,0.07890002f,0.07819998f,0.49799999f,0.77559999f,-0.04890002f,0.26380001f,0.55949998f,0.59640000f,0.03270000f,0.07250000f,-0.43919997f,-0.11190000f,-1.44809996f,-0.89479999f,-0.36209998f,-0.28170000f,-0.48180000f,-0.10199998f,-0.07440001f,-0.24140001f,-0.67250001f,0.15340000f,-0.12270003f,-0.61580000f,0.13270000f,-0.34239999f,-0.51820001f,0.47400001f,0.64210000f,-0.27739999f,-0.05259997f,0.13599999f,-0.93430001f,0.14640000f,-0.18670000f,0.06979998f,0.11659998f,-0.64219998f,0.73450001f,-0.26019999f,0.57360001f,0.22040000f,0.29189999f,-0.33260001f,0.52920002f,-0.09720000f,0.66610001f,-0.53119999f,0.55510000f,-0.38080001f,0.52050001f,0.70650000f,-1.10489998f,-0.63169999f,-0.68159998f,-0.50029999f,1.06320001f,0.96200001f,-0.68909999f,-0.68549998f,0.41819996f,0.60719998f,0.54000002f,0.73989999f,-0.02010001f,-0.36810004f,-1.23389995f,-0.83959997f,-0.81749998f,-1.09250000f,0.21479999f,-0.17619999f,-0.80250000f,-0.84470001f,-0.24360002f,-0.18979999f,-1.23179998f,-1.17389998f,-0.11280000f,0.52020001f,-0.05310000f,0.08719999f,0.62000001f,0.30879999f,-0.90470005f,-0.40720001f,0.10990000f,-0.02480000f,-0.10869998f,-0.70280000f,0.36190003f,0.15720000f,-0.16360002f,-0.34100001f,1.12080004f,-0.23860000f,-0.39960002f,-0.31020000f,-0.22790000f,0.31380001f,-0.74310002f,-0.33839999f,0.49189999f,-0.35780000f,0.63780001f,-0.44780000f,0.78400002f,-0.39200001f,1.17740003f,1.03270002f,0.04319999f,-0.23730002f,0.40979995f,0.02059998f,-0.49019998f,0.09570001f,-0.14520000f,-0.28310001f,-1.23599999f,-0.64590000f,0.11699999f,-0.23470003f,-0.62790000f,-0.41200001f,-0.78690002f,-1.02220002f,-0.49109998f,-0.19940000f,0.53010002f,0.17689999f,-0.35099997f,0.23730001f,-0.87570000f,-0.91010000f,-0.98610000f,-0.83060000f,-0.99720003f,-1.05640002f,-0.73140002f,0.41940001f,-0.34360003f,-0.67200001f,-0.74299997f,0.26859998f,0.77710003f,-0.24300000f,-1.26560004f,-0.22360001f,-0.07360001f,-0.44220000f,1.00330002f,0.02080000f,-0.33870000f,0.37480001f,0.13440001f,-0.05980000f,1.12410004f,0.15240001f,-0.32129999f,0.30079999f,-0.37350000f,0.38440000f,-0.80910003f,-0.12279998f,-0.76660002f,0.23520001f,1.16350001f,0.11860002f,0.17430001f,0.90679999f,-1.03620000f,-0.25859999f,0.77009996f,0.92619995f,-0.65670002f,-0.70770001f,-0.05579997f,0.50120000f,-0.72989999f,-0.27499998f,-0.33240001f,-0.81770000f,0.90000000f,0.93810002f,-0.24570000f,-0.41760002f,-0.01140002f,-0.43010000f,0.62459998f,0.47309998f,0.86760000f,0.80370000f,-0.05159994f,0.19610003f,0.59760003f,0.57700001f,-0.09329999f,-0.51509996f,0.42509999f,-0.00160000f,-0.02119999f,-0.60939999f,-0.56050002f,-0.17479999f,-0.10139998f,-0.52660000f,-0.82249999f,0.43120000f,-0.64260000f,0.16000000f,0.17880001f,-0.04560000f,0.45150001f,-0.28299999f,-1.44530001f,-0.05439998f,0.82230003f,0.46700000f,-0.39640002f,0.20540000f,0.45440001f,-0.31359999f,-0.90850004f,0.06900001f,-0.13060001f,-0.49939999f,0.49330000f,0.28979999f,0.24920003f,0.44589999f,-1.05269998f,-0.49379999f,-0.16439997f,0.13670002f,-0.80970001f,-0.16520000f,1.10459999f,1.19069999f,0.58680000f,0.86940000f,-0.05460001f,0.06340001f,-0.77249997f,-0.92950000f,0.35460005f,0.93110001f,0.57269997f,-0.12050002f,0.44850002f,0.35120001f,-0.72059999f,-0.66339999f,0.29670005f,0.37890001f,-0.85349998f,-0.40019999f,0.41489996f,0.08689999f,0.88979998f,-0.43619999f,-0.25750000f,0.20480000f,0.25030001f,-0.31240001f,0.18170003f,-0.08079999f,-0.32170002f,-0.54420000f,-0.06339998f,-0.15900000f,0.47690001f,-0.01780000f,0.16140001f,-0.30299999f,-0.21530000f,-0.19959999f,0.42160001f,0.55260000f,0.20360000f,-0.01279999f,0.38820003f,-0.04620001f,-0.53519999f,-0.43860000f,0.52689998f,-0.23939999f,-0.08190001f,-0.00660000f,0.95609999f,-0.95500000f,0.37860001f,0.18569999f,-0.67920001f,-0.59130001f,-0.00960002f,0.32870001f,-0.92189997f,-0.44669999f,-0.42089999f,-0.54460003f,-0.02970002f,0.07690001f,-0.46410000f,-0.04939999f,-0.18419999f,0.24450001f,0.80009999f,0.09439999f,0.01500000f,0.13020002f,-0.01350005f,0.21839998f,-0.61349999f,-0.05240002f,-0.60569997f,-0.62709997f,0.09689999f,0.27950001f,-0.70319998f,0.14620000f,0.95670003f,0.01619999f,-0.50990005f,-0.12280000f,-0.28490003f,0.27040000f,1.00240000f,-0.57819999f,0.24790000f,-0.12259998f,-1.35079999f,-0.11040000f,0.41530003f,0.56100000f,-0.10410001f,0.35440000f,-0.85230000f,0.43340000f,0.67080001f,-0.04940000f,-0.08909999f,0.19880000f,0.86680000f,0.18620000f,1.47030003f,-0.20820000f,-0.40990000f,0.13840001f,-0.63970004f,0.38190001f,-0.25950003f,-0.60610001f,-0.19319997f,-0.14069999f,0.42720002f,0.05410000f,-1.43609998f,-1.49039998f,-0.19049999f,0.00630002f,0.21960002f,0.79759998f,0.87869997f,0.27749998f,0.64740000f,0.36310000f,1.07430000f,1.09249999f,-0.18870002f,-0.20179999f,0.45359999f,0.44849999f,0.15629997f,-0.14779999f,-0.87030002f,-1.30950001f,0.27480003f,0.13430000f,-0.03419995f,-0.70119999f,-0.18019999f,0.32320000f,0.73500002f,0.00940001f,0.07720002f,0.19240001f,-0.23860000f,0.06480000f,-0.65880001f,-0.57660000f,-0.89700003f,-0.38459999f,-0.20270000f,0.34959999f,1.17970004f,-0.06060001f,0.32819999f,0.12540000f,0.81140003f,-0.07119999f,-0.23150000f,-0.54499998f,0.86070001f,-0.53359998f,-0.06590004f,-0.70959999f,0.57530001f,-0.00780000f,0.27069998f,-1.21369999f,0.71519999f,0.66100000f,-0.11130002f,-0.20959999f,0.42480000f,0.42500001f,0.15840000f,0.13659999f,-0.83129998f,-0.12920001f,-0.39089996f,0.28220003f,0.69539999f,0.49689999f,-0.42450005f,-0.71610002f,0.08550000f,-0.20160000f,-0.46620000f,-0.85760002f,-0.82769997f,-0.16589999f,-1.37519996f,-1.52549999f,-1.25339997f,-0.65909997f,-0.30330000f,-0.70250001f,-1.04609996f,-0.27680001f,0.42690001f,0.31859999f,0.76029998f,-0.60900000f,1.04660003f,-0.07539999f,-0.28630001f,0.00940000f,0.43430001f,0.01579999f,-0.32830001f,0.37659999f,0.15410000f,-0.49760000f,-0.49000002f,0.38180001f,-0.89990002f,0.27199999f,-0.42360001f,0.12300000f,-0.69990003f,-0.40680001f,0.03710001f,0.37639999f,-0.88670001f,-0.11540000f,-1.00630003f,0.62239999f,-0.25130000f,-0.55900001f,0.53069996f,0.28070000f,-1.46789998f,-1.50070000f,-0.36990001f,-0.53059998f,-0.09569996f,-0.35550000f,0.07349995f,0.22110000f,0.83249997f,0.74589999f,-0.91800000f,-0.53330000f,0.78150002f,0.55400001f,0.87180000f,1.16530001f,0.32070001f,0.32020000f,-0.55739999f,-0.05410000f,0.76019996f,0.61409999f,0.10770001f,0.59349999f,1.55219999f,1.63530000f,0.10710000f,0.37119999f,-0.39880002f,-0.04219999f,0.68800002f,0.38820000f,-0.21770000f,0.49140001f,0.73940000f,0.54739999f,-0.60480000f,-0.06040000f,-0.12430000f,-0.15800000f,-0.54510001f,0.68479998f,-1.16820000f,0.37080000f,0.31080000f,-0.15500000f,-0.59520002f,-0.06900002f,0.23590001f,0.17680001f,1.01780001f,-0.58839997f,1.25340002f,-0.03759999f,0.34920001f,0.16519999f,-0.20159997f,0.77830001f,-0.09449996f,-0.16759999f,0.44549998f,-0.18400001f,0.86850002f,0.40909999f,0.75989997f,0.06260000f,0.04800002f,0.26140000f,-0.21959999f,-0.00229999f,1.44359997f,1.17149998f,1.07040000f,1.27239998f,-0.35850000f,-0.31839999f,-0.02970001f,0.08219998f,0.33960000f,0.28050001f,-1.50839995f,-1.64719998f,-0.48840000f,-0.97100000f,0.23819996f,0.06679999f,1.01369998f,0.52600000f,-0.13540001f,-0.00960000f,-0.17079998f,0.08979998f,-0.19680000f,0.15900000f,-0.04260002f,-0.35760001f,-0.73340004f,-0.50840001f,0.71920002f,-0.17219999f,-0.27630002f,0.67579999f,-0.94470002f,-0.17759999f,0.55620001f,-0.30400000f,0.65600003f,-0.39620000f,0.82520001f,-0.44720000f,0.99770002f,-0.48460001f,-0.00900002f,-0.27919999f,-0.52849997f,0.44420001f,-1.05970004f,1.20739999f,0.10139999f,0.29400001f,0.06689997f,-0.20380006f,0.44009998f,0.54959999f,-0.67140000f,-0.44400000f,-0.64800000f,0.09320001f,-0.60570000f,-0.85900002f,1.30589999f,0.87570000f,-0.06359995f,0.35590002f,-0.78300000f,-0.85560001f,-0.89070002f,-0.76840001f,-1.07640001f,-1.04840000f,-1.24050002f,-1.32210002f,-0.40499998f,-0.01199997f,1.11149999f,1.21250000f,-0.09449998f,0.07060000f,0.47540001f,-0.00219999f,-1.18279999f,0.06459999f,-0.25700000f,0.33619999f,0.78879998f,-0.05339999f,-0.48200001f,0.11320000f,-0.32410002f,-0.40520000f,1.00060003f,0.30839999f,-0.08380001f,-0.53700000f,0.45620000f,-0.31659999f,0.18980000f,0.15139999f,0.21390001f,-0.48000000f,0.37000000f,-0.24979999f,0.32300001f,0.10600000f,-0.44840001f,0.51819999f,0.06270002f,-0.10220000f,0.02729998f,0.17240001f,0.47489999f,0.83919996f,0.68969998f,0.52439998f,-0.33389999f,-0.56619997f,0.32460001f,0.35920000f,-0.69719998f,-0.37810000f,0.23459995f,-0.39260003f,-0.94409999f,-0.49279999f,-0.69030000f,-0.56719999f,0.11969999f,-0.23600001f,-0.96660000f,-0.72690001f,-0.52470000f,-0.39039999f,-0.00240001f,-0.36880001f,1.08089998f,0.84799999f,0.39839998f,-0.45660000f,0.73989999f,-0.06660000f,-0.82650002f,0.02020000f,0.54629999f,-0.55179999f,0.28010001f,-0.03379999f,-0.15449999f,0.49019999f,0.83340002f,0.12540000f,-0.28850000f,0.70919998f,0.11909999f,-0.26640001f,-0.18569998f,0.38340001f,0.30390001f,0.01699999f,0.22130001f,-0.04220000f,0.52400000f,0.18700000f,0.08620001f,0.30600000f,-0.23289999f,0.16500001f,1.04800002f,-1.09009999f,-0.23490003f,-0.24849999f,0.32730001f,0.67310001f,-1.15829999f,-0.91049998f,-0.03990000f,0.07590002f,1.00349997f,0.79949999f,-0.03810002f,-0.45040001f,1.39139996f,0.97729998f,-0.66360000f,-0.75550002f,0.86609999f,0.83830001f,0.01649997f,0.03429999f,-0.31289999f,-0.65770002f,0.12389999f,-0.30420000f,0.58139999f,0.40820000f,0.48150000f,0.63370001f,-0.99600000f,-0.56859998f,1.07230002f,0.31240001f,-0.02730000f,0.42419998f,0.71530000f,-0.14640000f,-0.23330003f,0.47480000f,0.10700000f,0.56739998f,0.20580001f,0.02840000f,-0.05640000f,0.11499999f,-0.98260001f,0.23179999f,0.22140003f,-0.23560000f,-0.68670003f,0.44840001f,-0.09440000f,-0.02720000f,-0.34860000f,-0.06200002f,-0.22440000f,0.55220001f,0.62820001f,-0.12640000f,0.66770004f,-1.15979998f,0.24959999f,-0.35369999f,0.79709996f,0.51409998f,-0.51720001f,-0.71729999f,0.85500001f,0.43490001f,1.02089996f,0.58879998f,0.01499999f,-0.03340000f,0.08369999f,-0.23640002f,0.73590000f,0.93360000f,-0.39240002f,-0.10800001f,1.10580003f,1.15070004f,0.03300000f,0.18220000f,-0.13440002f,-0.19000004f,1.12230000f,0.86880001f,-0.43920000f,-0.59700000f,0.68279998f,0.34840001f,0.69410000f,0.01280001f,-0.06840001f,-0.47359999f,1.29760005f,0.06940000f,-0.70270002f,-0.18320000f,1.37000001f,0.07040000f,0.33560001f,0.64620000f,-0.67590003f,0.00660001f,-0.21710000f,-0.37159999f,-0.22110001f,-0.45580000f,-0.20820002f,0.06480000f,0.29330000f,0.02519999f,0.65329999f,-0.00739999f,-0.20389998f,0.69059999f,0.22050001f,0.27420000f,-0.23580000f,0.53790001f,-0.04140000f,-0.03709997f,-0.90599997f,-0.63679999f,-0.20370005f,-0.60020001f,-0.10919997f,0.29670001f,-0.22140004f,-0.63980000f,1.05149998f,0.40220000f,0.08850006f,0.09370002f,-0.66479996f,-0.40229999f,-0.76409999f,-0.34290000f,0.32879998f,0.61420002f,0.05339997f,0.10190000f,-0.17189999f,-0.32569998f,1.30889997f,0.83849998f,0.35489999f,-0.06770002f,-0.45539997f,0.03180001f,-0.94120001f,0.27240000f,-0.58749999f,0.02259999f,-0.20210000f,0.54959999f,0.14289998f,-0.37199999f,0.82800002f,-0.15080001f,0.65009999f,0.40640000f,0.22610000f,-0.07160000f,0.24709998f,-0.22040000f,0.24029999f,0.04320002f,0.88850001f,0.05259999f,0.29160002f,-0.38180000f,0.45630001f,0.59399999f,-0.69740001f,-0.21500000f,-0.86179999f,0.18839999f,-0.53990000f,-0.13110000f,-0.06960000f,0.67190002f,-0.09780000f,0.72440000f,0.25250000f,0.27980001f,-0.15330000f,-0.73460000f,0.09200001f,0.58579999f,-0.37280000f,0.45350000f,0.08960000f,0.36559999f,0.26460000f,-0.22150001f,0.16040000f,0.26390000f,0.00510000f,0.03140000f,-0.23129999f,0.01269999f,-0.09080000f,-0.82850000f,-0.15550000f,-0.08440000f,0.16700000f,-0.42460000f,0.21230000f,0.41260002f,-0.43169999f,0.23770000f,0.68209999f,0.97410003f,0.44449998f,0.40629999f,-0.74980000f,-0.33190001f,0.39210000f,-0.00200001f,-0.67339995f,-0.06009999f,-0.32290000f,0.38630000f,0.57329999f,-0.12130000f,0.78999997f,0.85130000f,0.83809997f,-0.17810003f,-0.06080001f,-0.70770001f,0.77389999f,0.22590001f,-0.09959998f,-0.13710000f,0.90749997f,0.30639998f,0.23809999f,-0.08530001f,0.03730000f,0.41000000f,-0.12850001f,-0.55400000f,-0.06690000f,-0.38850000f,0.10140000f,0.66440002f,0.04749999f,-0.56919999f,0.34100000f,0.01259999f,-0.08750000f,0.56090000f,-0.44290000f,0.34719998f,-0.12800000f,-0.67589998f,-0.22290000f,-0.46500000f,0.05080000f,-0.01059999f,-0.24430000f,-0.36020001f,0.23600000f,-0.41700000f,-0.13669999f,-0.76750000f,-0.05610000f,-0.33630000f,0.34149998f,-0.18449999f,-0.30439996f,-0.83529999f,0.30229999f,1.17460004f,0.27449999f,-0.08090001f,0.66909999f,1.11500000f,0.11650001f,-0.50870003f,0.50860000f,0.57080002f,0.53500001f,-0.38730003f,0.39419999f,0.68550001f,-0.00350002f,-0.39020003f,0.05429999f,1.01100001f,0.73149999f,0.15560000f,0.52760000f,0.26040000f,0.73200001f,0.03580001f,0.67260000f,0.78240002f,-0.27510000f,0.23809999f,0.16799999f,0.01320000f,-0.17870001f,-0.00270000f,-0.13530000f,-0.00850000f,-0.07029999f,-0.67890002f,-0.07570000f,0.06129999f,-0.17580001f,-0.22230001f,0.04539999f,-0.71350001f,-0.17380000f,-0.09810000f,-0.21850000f,0.52360001f,-0.02190000f,-0.06270000f,-0.15830000f,-0.50400000f,0.05240000f,-0.75230001f,-0.07360000f,-0.69280003f,-0.06780000f,-0.40660003f,0.34160001f,1.27250006f,-0.62879996f,0.12640000f,0.34990001f,-0.13340000f,0.06439999f,1.13260003f,0.26420000f,0.73670002f,0.42029999f,-0.73010002f,-0.84970000f,-0.25320000f,0.41499999f,-0.06540001f,-0.08729999f,-0.92190003f,-0.31309999f,-0.24840000f,-0.66369999f,-0.28620000f,0.19749996f,0.65819999f,-0.19900002f,0.10939999f,-0.01530001f,-0.90350002f,0.12109999f,0.39830001f,0.06680000f,-0.61600001f,0.08400000f,0.53989997f,0.08650000f,-0.60260001f,-0.20920000f,0.34860000f,0.05380000f,-0.46930001f,-0.04830000f,-0.34750000f,0.25890001f,0.41710001f,-0.19980000f,-0.02650001f,0.22970000f,-0.37890000f,-0.03690000f,0.46429999f,0.12810000f,0.49990000f,-0.24350000f,0.29390002f,-0.17540000f,0.63020001f,0.21130000f,-0.42219997f,-0.21550000f,0.35730000f,0.45740000f,0.94749999f,0.11289998f,0.61220001f,0.12520002f,0.92430001f,-0.86309998f,-0.05180000f,-0.64539998f,0.25200000f,-0.19199999f,0.00750000f,0.79749996f,0.04049997f,-0.31150002f,1.03299999f,-0.20929999f,-1.24440003f,-0.14580001f,-0.07600000f,0.46439999f,0.15829999f,0.08149996f,0.41870000f,0.43479999f,0.83300001f,-0.31669997f,-0.72379998f,-0.52079999f,0.17090000f,0.03340000f,-0.65970000f,-0.10530000f,0.07890000f,0.18080000f,-0.60610002f,0.12670001f,0.72590000f,0.17580000f,0.34300000f,0.18680000f,-0.20280000f,-0.24949999f,-0.36700000f,-0.10329999f,0.55230001f,0.06890000f,0.14840000f,-0.10860000f,0.42370001f,-0.02160000f,-0.50360000f,-0.29590000f,0.56180002f,-0.03640000f,-0.46770000f,0.15709999f,0.04720000f,0.10400000f,0.31949999f,-0.02490001f,-0.18400002f,0.49490000f,0.27400000f,-0.52529997f,0.13310000f,0.59029998f,0.99290001f,0.65839998f,0.17239998f,-0.37349997f,-0.18339999f,-0.11039998f,0.43560000f,-0.22389998f,0.51310001f,-0.21740001f,-1.14380002f,-0.27919999f,-0.04510000f,-0.50159993f,-0.05549999f,0.26100001f,1.01160000f,0.39729998f,0.00279999f,-0.29429998f,0.12090002f,0.64109997f,-0.54510001f,-0.15310000f,0.38890000f,-0.08810000f,-0.39270001f,0.41730000f,-0.34550000f,-0.15430000f,-0.38800000f,-0.34560000f,0.01009998f,0.35470000f,-0.36500000f,0.26959999f,-0.50909999f,0.19990000f,-0.21989999f,-0.06340000f,0.45610001f,0.23000000f,-0.19679999f,0.43079999f,-0.39510001f,-0.05140000f,-0.23790001f,-0.00250000f,-0.46099998f,0.17110000f,-0.05220000f,-0.08630000f,-0.02109999f,0.18870001f,-0.64680001f,0.43429997f,0.42820002f,0.16769997f,-0.31730000f,1.08619997f,0.14499999f,-0.18209999f,0.09339999f,-0.21800000f,1.05099999f,-0.43429999f,-1.10990002f,-0.29110000f,-0.47520001f,-0.72589999f,-0.06540000f,-0.15459998f,-0.29250000f,-0.44329998f,-0.19080000f,-0.27339997f,-0.78469999f,0.69030000f,-0.68250003f,0.10869997f,-0.00670003f,0.27809996f,0.25620001f,0.09010000f,-0.39660001f,-0.32510001f,0.21390001f,-0.31650000f,0.54350001f,-0.14780000f,-0.94410000f,0.23770000f,-0.33519998f,-0.11080000f,0.45879999f,0.06790000f,0.40840000f,-0.03010000f,0.43390001f,0.03190000f,0.78260000f,0.27740000f,-0.43970000f,0.15330000f,0.17870000f,0.27059999f,-0.26069998f,0.01050000f,-0.80160001f,-0.23670000f,0.41490001f,-0.28490000f,0.66750000f,-0.61739998f,-0.30980001f,-0.16719998f,-0.42810001f,-0.51239999f,-0.26690001f,-0.01180000f,0.03800000f,0.39060001f,1.29300001f,0.07679998f,1.17780002f,-0.39809999f,-0.38540000f,0.17410003f,-0.64970001f,0.08759999f,-0.42870000f,0.55619999f,-0.48610004f,0.19650001f,1.01979999f,1.22209996f,0.12809996f,0.65869999f,1.10260003f,0.52009999f,-0.44230002f,0.61669998f,-0.88810000f,0.17580000f,0.33740001f,0.26840000f,-0.39770000f,0.23840001f,0.06860000f,-0.08180000f,0.19939999f,-0.08740001f,-0.32130000f,-0.04639999f,-0.04110000f,0.01770000f,0.44570000f,0.19150000f,-0.61160002f,-0.04800000f,0.02790000f,-0.12860000f,-0.33500000f,0.11589999f,-0.54579999f,-0.29010000f,-0.77689999f,-0.05030001f,-0.71189999f,-0.19370000f,-0.14560000f,-0.04470000f,0.27410001f,-0.50669997f,-0.69329999f,1.23069998f,0.31450001f,0.02160000f,-0.51280002f,0.60009995f,0.03559998f,-0.51569996f,-0.18519996f,-0.62149997f,-0.30909997f,0.43270001f,0.65750002f,-0.29340002f,-0.28660001f,-0.82809998f,0.25660003f,-0.11340001f,0.07290000f,0.36630000f,1.03650004f,-0.67229996f,-0.52029999f,-0.23909999f,0.78190001f,-1.24889997f,-0.18399997f,-0.37409999f,-0.28200001f,0.24670000f,0.06360000f,-0.27790001f,-0.82399999f,0.26560001f,-0.60890000f,-0.45009999f,0.32460000f,0.41690000f,-0.34040001f,0.11589999f,0.47940000f,0.02890000f,-0.60630001f,-0.13140000f,0.65950002f,0.17250000f,0.56490001f,-0.09100000f,0.33810001f,-0.17270000f,-0.08490001f,0.23150000f,0.28450000f,0.01110000f,0.21740000f,0.22610000f,0.95770001f,0.20210001f,-0.31829997f,0.42339996f,0.22699999f,-0.07460000f,-1.05740002f,-0.24650001f,-0.64640003f,-0.36359999f,-1.29820000f,0.01599998f,0.46590000f,0.03430000f,0.33500000f,-0.93529997f,-0.63329998f,-0.77819998f,0.24270000f,0.16820000f,0.03840000f,0.22620000f,0.43170002f,-0.43229999f,-0.35330002f,1.26539996f,0.11629994f,0.44739999f,-0.78900004f,-0.24079997f,-0.44159999f,-0.60380000f,0.42490001f,-0.33620000f,0.26190001f,-0.00460000f,0.14950000f,-0.15790000f,0.68260002f,0.10440000f,0.25090000f,-0.11559999f,0.22340000f,0.03490000f,-0.13650000f,0.09930000f,0.90170000f,0.02660000f,0.84120000f,0.04780000f,-0.30890000f,-0.24180000f,0.26729999f,0.23230000f,-0.00729999f,-0.25220000f,-0.91399998f,0.02300000f,-0.53979999f,0.14320000f,-0.02380001f,0.05660001f,-0.18669999f,-0.28179999f,0.15590002f,0.36940001f,-0.12310001f,-0.51419997f,-0.04379999f,0.47340000f,0.53250002f,0.18060001f,1.26610006f,0.58540000f,-0.26570003f,-0.73309999f,-0.82259999f,0.06749997f,0.85949999f,0.64179999f,0.04409999f,0.45460001f,0.17720000f,0.68440000f,0.11360000f,0.90810000f,0.02630000f,-0.05140000f,0.48690002f,-1.05609998f,-0.21290002f,-0.08570001f,0.88620001f,0.15260000f,-0.02620000f,-0.32100001f,0.30749997f,0.19500000f,0.15930000f,-0.11700001f,-0.31380000f,-0.00820000f,-0.25480001f,-0.11380001f,-0.41390000f,0.03749999f,0.81500002f,-0.16269999f,0.25170001f,-0.11580000f,-0.49060000f,0.07500000f,-0.71430002f,-0.00440000f,-0.79920001f,-0.08650000f,-0.86960002f,0.18060000f,-0.37699999f,0.30890001f,0.54300000f,-0.05510000f,0.09299999f,-0.48479996f,-0.18610000f,-0.32099998f,0.67480000f,-0.40359999f,-0.32869999f,0.21939999f,-0.43369999f,-0.12960001f,0.12820000f,0.54369998f,0.76940001f,-0.02179998f,-1.12340002f,0.51080000f,0.85250002f,0.34560000f,0.18650000f,0.21599998f,-0.41470000f,0.63809999f,0.54960000f,0.19740001f,0.15640000f,0.28899999f,-0.43390001f,-0.64019999f,-0.47119999f,-0.75429996f,0.45730001f,0.41639999f,-0.37549999f,-0.10140000f,0.57649998f,0.01600000f,0.45329999f,0.06979999f,-0.39649998f,-0.08880000f,0.34940000f,-0.20010000f,-0.21750000f,0.07619999f,-0.09440001f,-0.05360000f,-0.51850001f,0.05560000f,-0.54230000f,-0.17480000f,0.16689999f,-0.09690000f,-0.55410002f,0.09380000f,-0.45430000f,-0.16620000f,0.06239999f,0.02420000f,0.71930000f,0.42430000f,0.16839999f,-0.14209997f,-0.30799998f,-0.33610000f,0.53640002f,0.65110000f,0.46620000f,-0.26269999f,-0.05950001f,-0.75809998f,-0.57839999f,0.09840001f,-0.73770001f,-0.84109998f,-0.84949999f,0.78209999f,0.21750001f,-0.81449999f,-0.36780001f,-0.21289997f,-0.16979999f,0.66129997f,-0.19810002f,0.11499999f,-0.65710000f,-0.46819999f,-0.47300001f,-0.59409998f,-0.01570000f,0.83200000f,-0.73220000f,0.29449999f,-0.49279999f,0.01330000f,0.33820000f,0.00929999f,-0.80859999f,0.24830000f,-0.25739999f,0.18090000f,0.50399999f,0.06040000f,-0.21810000f,0.08510000f,0.83410000f,-0.32450001f,-0.18570001f,0.26690001f,0.36300001f,0.19490000f,-0.18820001f,-0.34530000f,0.02399999f,-0.05380000f,0.02010000f,0.15140000f,0.22600000f,0.23410000f,0.16220000f,-0.11000001f,0.35999998f,-0.10950001f,-1.15580003f,-0.50129997f,-0.59669998f,0.42189999f,-0.27350000f,-0.27310002f,-0.60350000f,-0.63319997f,-0.89289998f,-0.07099999f,-0.15840000f,0.34939998f,-0.23100000f,-0.50880000f,0.30950003f,-0.05659997f,0.27449999f,-0.88850001f,-0.15809999f,-0.17399999f,0.13870000f,0.41660000f,0.23130002f,-0.78620000f,-0.63480001f,0.33100000f,-0.23580001f,-0.27770000f,-0.84429999f,0.14590000f,-0.14949999f,0.08289999f,0.42779999f,-0.02510000f,-0.42470000f,-0.13570000f,0.66090002f,0.12000000f,0.51210000f,0.07660000f,-0.08440000f,-0.29579999f,0.27849998f,-0.02679999f,0.64389999f,0.21300000f,-0.43480001f,0.16450001f,0.67430003f,0.10320000f,-0.03880000f,-0.30980000f,0.20919998f,0.14940000f,0.61190002f,0.00180000f,-0.38140000f,0.05810000f,-0.40300001f,-0.35249998f,-0.37120001f,0.69319997f,0.69900000f,-0.00179998f,-0.90470002f,-0.00170001f,0.73610001f,0.00480003f,-0.95170000f,-0.51820000f,-1.18810001f,0.27809995f,0.34259998f,0.51989997f,0.65259999f,0.42850000f,0.81570002f,-0.61019997f,0.14160004f,-0.28689996f,-0.16209998f,0.01690000f,-0.38770001f,-0.72589998f,-0.89300001f,0.02490000f,-0.60150002f,0.35139998f,0.38970002f,0.37450000f,-0.42589998f,-0.19960000f,-0.39080000f,0.25980000f,-0.54910001f,-0.06070000f,0.10530000f,0.27159999f,-0.58159999f,0.05700001f,0.53570000f,-0.33370000f,0.42120002f,-0.17870000f,-0.23290000f,-0.07650001f,-0.36760000f,0.30380000f,0.01380001f,0.23489999f,-0.19330000f,0.14229999f,-0.32699998f,0.04150000f,0.80079999f,-0.11290000f,0.25860000f,-0.13140000f,-0.11400000f,-0.70599999f,0.25610001f,0.00369999f,0.31790000f,-0.85069997f,-0.63079999f,0.82509995f,0.37240000f,0.44240000f,-0.33870000f,-0.03530002f,-1.07310001f,0.13270000f,-0.04360000f,-0.20389998f,0.26330004f,-0.65789998f,-0.08459999f,0.11770001f,-0.65229999f,0.36980000f,0.39149999f,-0.32429998f,-1.21290001f,0.35039998f,0.71470000f,-0.39139999f,0.28540000f,0.10349999f,-0.88219999f,0.46140002f,-0.04620000f,0.45539998f,1.42419996f,0.23610000f,1.95119998f,-0.57210002f,-1.12689999f,-0.09329998f,-1.38719999f,-1.20990005f,-0.51360000f,1.00050004f,1.12249998f,-0.13979999f,0.36479998f,-0.34890001f,-0.70149999f,-0.27300001f,-0.19140001f,0.44759997f,1.22439995f,0.86129999f,-0.79570002f,0.25470001f,0.57300002f,0.86610004f,-0.47300003f,0.79859999f,-0.05950002f,0.11900000f,-0.51869999f,-0.01830000f,-0.52400000f,0.05369999f,-1.10530002f,0.05150000f,0.38560001f,0.56099999f,-0.14840002f,-0.17559999f,0.37420000f,0.16140001f,-0.03120000f,0.03220000f,-0.01460000f,-0.06120001f,-0.25029999f,-0.19350000f,0.61880000f,0.23400000f,0.24899999f,-0.02370001f,-0.70700000f,-0.14610000f,0.26910001f,0.26390000f,0.10900000f,0.18830000f,-0.23530002f,0.25620001f,-0.50890000f,0.69990001f,-0.06200003f,0.22170004f,-1.76350001f,-0.65310003f,-0.10199998f,-0.70859996f,-0.62359999f,-0.25740001f,0.16340001f,-0.28350001f,-0.26760001f,-0.21000000f,-0.28219999f,0.97290001f,0.79509997f,0.01769998f,0.99600000f,-0.50100001f,0.05500000f,0.74310004f,-0.36140001f,0.45719999f,0.98489999f,-0.97770000f,-0.84139996f,-0.04530002f,-0.69410000f,0.26059999f,-0.59090000f,0.18009999f,0.66039998f,-0.22460001f,0.04519999f,0.22270001f,0.87859998f,0.01340001f,1.00739999f,-0.09039999f,0.74869999f,-0.20300000f,-0.16240000f,0.06990000f,-0.84280000f,-0.13850001f,-0.16800000f,0.06860000f,0.33559999f,0.06540000f,-0.15790001f,-0.30400000f,-1.01070001f,-0.27070000f,0.09420002f,0.11230000f,-0.22950000f,-0.18220001f,-0.47910002f,-0.45989997f,-1.47789997f,-0.51570000f,0.76639997f,0.29160002f,0.23319999f,-1.27920002f,0.17820000f,-0.36510002f,1.45299999f,-0.73200003f,0.32610000f,0.70439999f,0.42959997f,0.23760003f,-1.21639999f,0.70200001f,0.48959999f,0.25260000f,1.07639996f,0.58920002f,0.58709998f,1.17270002f,-0.67410005f,0.30389998f,0.29180001f,-0.60090002f,-1.14649999f,-0.24120002f,-0.37350000f,-0.02510000f,0.73919999f,0.48340000f,-0.18110001f,0.28130000f,-0.04420000f,0.43870000f,-0.33550000f,-0.25170000f,0.42019999f,-0.35939999f,-0.44799998f,0.08570000f,-0.59799999f,-0.08289999f,0.64919998f,0.40270000f,1.01169997f,0.11669999f,-0.42589998f,-0.08909998f,0.40720001f,-0.12610000f,-0.55040000f,0.11000000f,0.59749997f,0.22729999f,-0.08490001f,-0.08010001f,-0.00050001f,-0.55740001f,0.62480001f,-0.72810001f,-0.80290002f,-0.62819999f,-0.63259997f,-0.59760000f,-0.97130000f,0.71490002f,1.51219997f,0.77219998f,-0.20719999f,0.54090001f,-0.30560000f,-0.89850003f,-0.08799999f,-1.46880000f,0.37910002f,0.29430000f,-0.27970000f,-0.88290004f,-0.54039996f,0.05369999f,-1.13240000f,-0.24899999f,0.93409997f,0.28650003f,0.49449998f,0.69330003f,0.58939999f,-0.17490001f,-0.87300000f,-0.12229999f,0.90779999f,-0.09330000f,0.53780000f,-0.00860000f,0.50390000f,-0.05920001f,-0.82519998f,0.12990000f,0.39670001f,-0.34639999f,-0.31239998f,0.45680000f,0.78999998f,-0.05630000f,-0.44129999f,-0.08929999f,-0.50389998f,-0.32570002f,-1.17509997f,-0.18330000f,0.56509998f,0.12380001f,1.03239998f,0.37010000f,-0.19440001f,-0.24230001f,-0.08140000f,0.83520003f,-0.72780001f,-0.02040003f,1.58259997f,0.56010001f,1.70659999f,-0.20160000f,0.68290001f,1.02930003f,-0.23360000f,-0.90840002f,-0.34429997f,0.83009998f,0.14959999f,-1.36890002f,0.15199999f,0.64319999f,-0.02470002f,-0.07770001f,-1.18249997f,1.54020004f,-0.50689999f,-0.02069999f,0.85089998f,-0.61080001f,1.28760000f,-0.08939998f,-0.07360002f,0.93930003f,-0.08810000f,0.10500001f,1.17130002f,-0.03140000f,0.95619997f,0.01700001f,1.13480002f,-0.35380000f,0.36599999f,-0.32200001f,-1.03000001f,0.13210000f,0.10930000f,-0.31039999f,0.72379998f,0.20979999f,-0.36710000f,0.00380000f,-0.98369999f,-0.33210000f,-0.75270001f,-0.01620000f,0.04660000f,-0.05120000f,0.90389996f,-0.46819999f,0.02880000f,0.45410000f,0.28029998f,0.21770001f,-0.25949999f,-0.93180005f,1.08910003f,-0.04799999f,1.74219997f,-0.69480003f,1.24600004f,0.67140000f,1.22999997f,1.47750004f,-0.30960004f,-0.46409999f,-0.28049998f,0.23789998f,1.36939996f,0.41520002f,0.10829998f,0.33480000f,-1.42949999f,1.33500002f,0.01629994f,-0.46200000f,-0.56899997f,-0.33029999f,1.22729997f,0.77879999f,0.59679999f,-1.05360003f,-0.39750003f,-1.36770001f,-0.47989999f,0.11659999f,-0.81019998f,-0.28060001f,0.92829997f,0.02690000f,-0.68459997f,-0.16230000f,0.32110001f,-0.14600000f,0.32660001f,0.36040000f,0.44409998f,0.18070000f,1.00539996f,0.29880000f,0.93139998f,0.06530001f,0.44209999f,-0.23679999f,-0.64419999f,-0.13280001f,-0.52360000f,-0.16990000f,0.42109999f,-0.06350000f,-0.27350000f,-0.37060001f,-1.16389998f,0.33469999f,0.04309997f,0.32190000f,-0.98299999f,0.40350002f,2.02769997f,-0.05910000f,-1.37179995f,-0.30570002f,0.00930002f,0.42389999f,1.04979999f,-0.96479998f,-0.06609998f,-0.71550000f,1.15579996f,-1.04580001f,0.69099998f,-1.02150000f,-0.48769997f,0.85259999f,-0.33340002f,0.39600001f,-0.61400002f,0.49710000f,1.30609996f,-0.19500002f,-0.87090001f,1.44120000f,-0.67410004f,-0.13829997f,0.35319999f,-0.12460001f,0.88020002f,0.20820001f,0.73999998f,0.19469999f,0.70169999f,-0.06720000f,0.37749999f,0.11610000f,-0.93800000f,0.00760000f,-0.80369999f,-0.34100001f,-1.21789998f,-0.09130001f,-1.26959996f,-0.21559999f,1.21019997f,-0.21530000f,0.76939999f,0.09280000f,-0.59530001f,-0.06610000f,-0.62150000f,0.05100000f,0.19639999f,-0.11220000f,-0.76170000f,0.40169999f,-0.12799999f,0.01560000f,1.57660003f,-1.27410002f,-0.09879999f,-0.55680001f,0.80589999f,-0.87090002f,-0.55589999f,-0.26130000f,-2.03839999f,0.53940002f,-0.79430001f,1.52040002f,-0.63450002f,0.74550000f,-1.52119998f,0.23459999f,2.41219993f,0.27449999f,1.61739998f,0.21240001f,-0.74750002f,0.99180002f,0.09949997f,0.26760002f,0.80840000f,1.00080001f,-0.21150003f,-1.27980001f,0.27010000f,-0.30860000f,0.38280001f,0.01910000f,0.09699999f,0.22810000f,0.38049999f,-0.32129999f,0.62660000f,0.03650000f,-0.46999999f,-0.08480000f,-0.00200000f,-0.06269999f,-1.14820000f,-0.22260001f,-0.68939998f,-0.03960000f,-0.28640000f,0.20010000f,-0.78860001f,0.45540001f,0.04839999f,0.48020000f,-0.37630003f,0.07439999f,-0.22540000f,-0.09690000f,-0.50170000f,-0.39470001f,0.81670000f,-0.38550003f,-0.15039998f,0.52320002f,0.93419998f,-0.28080000f,0.60709999f,-0.08820001f,0.71740001f,-0.03750000f,-0.91679999f,-0.40860001f,-0.66759999f,0.56880002f,-1.49899999f,1.09770003f,-0.06459999f,0.93720001f,0.70079996f,0.12330002f,-1.12060001f,-0.60060002f,-0.21560003f,-0.23579998f,-0.50090004f,0.66120002f,0.56699997f,0.42240002f,-0.49390000f,1.28910005f,-0.11870000f,-0.08720000f,-0.42419999f,0.21739999f,-0.43170002f,0.33459999f,-0.77749999f,-0.07859999f,0.85380000f,-0.31820000f,0.22079999f,0.36920000f,0.98349996f,0.17170000f,0.19570000f,0.04070000f,0.69679999f,-0.19360001f,-1.12330002f,0.05120000f,-0.55940001f,0.28970000f,-0.49650000f,-0.04150001f,-0.16560000f,-0.17329999f,0.68930000f,-0.13150000f,0.69960002f,-0.05180000f,-0.25530000f,0.70830001f,0.06299999f,0.51600003f,0.13209995f,-0.26279998f,-1.47969997f,-0.11250003f,1.40099999f,0.49680001f,0.74879999f,-1.26509999f,0.56849999f,-0.80279999f,-0.53769996f,0.04710001f,1.45639999f,0.92460003f,-1.10830004f,0.78780003f,0.07139996f,-0.05609999f,-0.70270001f,-0.36540001f,-0.87359999f,0.46410000f,1.77389998f,-0.17910003f,0.95040003f,-0.88290001f,-0.37520000f,0.29980000f,1.26560001f,-0.14660000f,0.24449999f,-0.46819999f,0.28630003f,-0.18250001f,-0.02310000f,-0.49610000f,0.45879999f,-0.51130000f,0.18109999f,0.34160000f,1.20760000f,-0.12399999f,0.16420002f,-0.18050000f,-0.46039999f,-0.05580000f,0.20690000f,-0.37470000f,0.48909999f,-0.31840001f,-1.16009999f,0.04460000f,-0.18910001f,0.07180001f,1.13229999f,-0.03750000f,-1.25519998f,-1.38300002f,0.86960005f,-0.12420000f,0.13109999f,0.33179994f,0.47410002f,0.59760002f,0.57390000f,0.57450000f,1.11119999f,0.51630002f,0.47730003f,-1.57590004f,0.53840001f,-0.50370003f,-0.52379996f,0.65639999f,-0.18600002f,0.03149999f,0.37870000f,0.31800001f,0.95370000f,1.59480006f,-0.39390000f,0.49980002f,0.37909998f,-0.68070002f,1.32370001f,0.80430001f,0.21419999f,0.19080000f,-0.69310001f,-0.07360000f,-0.36869999f,0.19320000f,0.00529999f,-0.29019999f,0.23749999f,0.12830000f,1.12150002f,0.08040000f,0.99499998f,0.00840000f,0.50940002f,0.13720000f,0.01070000f,0.31310000f,-0.47110002f,-0.27710001f,-0.17040000f,0.14750001f,0.75900000f,-0.02090000f,0.03710001f,-0.12670001f,0.16020001f,-0.13170000f,0.97430000f,0.46139999f,0.97219998f,0.00420001f,-1.11210002f,-0.19350000f,-1.06409998f,-0.20489999f,-0.05170000f,0.07260001f,0.22530002f,-0.94890003f,0.99610005f,-0.77370000f,0.93980000f,-0.76560004f,-0.06859996f,-0.55980000f,-0.59749998f,0.34530004f,-0.07050003f,0.98970002f,0.72439999f,-1.37100003f,-0.26619996f,-0.35490001f,-0.44429997f,0.87390004f,1.37460002f,-0.25620001f,1.37330002f,-0.41189999f,-0.83589999f,-0.20690000f,0.57999998f,0.12210001f,0.33500000f,-0.06760000f,-1.00290000f,-0.10800000f,-0.50749999f,0.14110001f,-0.60049997f,0.00220001f,0.42169999f,0.36549999f,-0.76019998f,-0.15110000f,0.00700000f,-0.00820000f,0.22970000f,-0.00369999f,0.83429997f,-0.31960001f,0.21240001f,0.01450000f,-0.74400001f,0.13240000f,-0.82980002f,-0.03810000f,0.07630000f,-0.09530000f,-0.47370000f,0.09870000f,1.01799998f,-0.79230003f,-0.31139999f,1.04820003f,-0.55990003f,0.16650000f,-0.87249999f,-0.55380004f,-1.76389997f,-1.19880003f,-0.84529998f,-0.32729999f,-1.50019996f,0.81330000f,0.96699996f,-0.04260000f,0.37470000f,-0.82320002f,0.46449999f,0.67590002f,0.97920002f,0.28050002f,-1.03000002f,0.01860003f,-1.42300000f,-0.47400001f,-0.55349998f,0.63060001f,0.00590001f,0.05490000f,0.65600000f,0.31980001f,-0.37800002f,-0.28570001f,-0.88719998f,0.05720000f,0.11159998f,0.02140000f,0.29019999f,0.51850000f,-0.33269997f,-0.32110000f,-0.12329999f,0.10230001f,1.27489999f,0.03740000f,-0.11170001f,-0.34959999f,0.16220001f,-0.23479999f,0.61979998f,0.16639999f,-0.20400000f,-0.05140000f,1.19579999f,0.24999999f,-0.35390000f,0.34119999f,0.17530001f,-0.91170000f,0.06520006f,-0.44640001f,-0.98040004f,1.21830001f,-0.35160001f,0.24630001f,0.62239996f,-0.11190000f,0.42940000f,-0.58080001f,-0.85089997f,0.58259999f,0.20049999f,-0.75630001f,1.52910001f,0.86400001f,1.02489994f,0.43109996f,0.50859998f,-0.41340001f,0.35300000f,0.10530001f,-0.05640001f,-0.40710002f,1.68379998f,0.17040001f,-0.15930002f,-0.84599998f,1.21870001f,0.24120001f,1.10579999f,0.34940001f,1.24079996f,-0.20620001f,0.70190000f,-0.01770000f,0.01510000f,0.28430001f,0.72400000f,0.39010000f,-0.07969999f,-0.07669999f,0.37520002f,0.13340000f,0.10100001f,-0.03910000f,-0.29179999f,0.17619999f,-0.74620001f,0.23090001f,0.35699999f,0.10779999f,-0.58690004f,-0.17740000f,0.36430002f,-0.23850000f,-0.69340000f,0.12859999f,1.12370004f,-1.14990003f,0.81700001f,-1.54200000f,0.65840000f,0.16170001f,1.34130002f,-0.24900001f,-0.33630000f,-1.04190003f,0.27960001f,-0.77759999f,-0.78309996f,-0.92310005f,-0.64359996f,-0.00720000f,0.33820001f,0.31410001f,-0.17259999f,-0.25589997f,-1.59179998f,-0.79020001f,-0.14099999f,0.78600004f,0.08089992f,-0.69360004f,-0.46229997f,0.98340002f,-0.24900002f,-0.17999999f,0.47519999f,-0.24100001f,-0.61290001f,-0.18650000f,-0.33480001f,-0.06780000f,-0.56800001f,0.52520001f,-0.46810002f,-0.09910000f,-0.12780000f,0.14370000f,-0.04510000f,-0.14250001f,0.58619999f,-0.20800001f,0.18830000f,-0.07580000f,-0.01789999f,-0.23140000f,-1.11429999f,0.26600000f,0.29139999f,0.23740000f,1.14400000f,0.04130000f,-0.06389999f,-0.09800000f,0.09780000f,0.07790000f,-0.50180007f,-0.14430001f,0.49450001f,-0.48109998f,0.36650002f,-1.12950001f,0.12290003f,0.91130001f,-0.54060002f,0.60089999f,0.00169999f,0.82500002f,-1.26080003f,-1.26490002f,1.00820003f,-0.63119999f,-0.14600001f,0.54800000f,-0.32790001f,0.00930001f,-0.26750002f,-0.55849998f,0.38170000f,0.48140001f,0.94929998f,-0.76620003f,0.25380000f,-0.08270001f,0.95470001f,-0.83929997f,-0.18950001f,-0.20789999f,-0.29610000f,-0.21440000f,-0.12760001f,0.28910003f,-0.74630002f,0.17200000f,0.04040000f,-0.73160000f,-0.39880001f,0.42259999f,0.18940000f,-0.15540001f,-0.13620001f,0.09140000f,-0.09140000f,-0.46649999f,0.18210000f,0.12399999f,0.47720001f,-0.31300001f,-0.01100000f,-0.13700000f,-0.24820000f,-0.14190001f,0.37950001f,0.05580000f,-0.29700000f,0.07440002f,-0.33299999f,-0.11620000f,0.32269998f,-0.48589999f,0.76409998f,0.91850000f,0.34920001f,0.48870001f,-0.69970001f,-0.21500001f,-0.66900000f,0.47839999f,-0.31099998f,0.06360000f,-0.27420002f,0.29500000f,-0.20880000f,-1.20499998f,1.00729998f,-0.27990000f,-0.06109999f,-0.13999999f,-0.52100001f,-0.30290001f,0.82770000f,-0.73230000f,0.42420000f,0.79989999f,-0.98550000f,0.75470001f,-0.29330001f,0.03890002f,-0.62570000f,-0.39080000f,0.29360000f,0.29440001f,0.15200000f,-0.02320002f,0.16719999f,-0.28880003f,0.61640001f,0.38189999f,0.28770000f,0.03560000f,0.15160000f,0.09780000f,-0.54420001f,-0.11540000f,0.14420000f,-0.53880001f,0.34440000f,-0.52670002f,0.10190000f,0.37190001f,-0.30350002f,0.37020000f,0.19500001f,0.31290002f,-0.40290001f,0.13070000f,0.68659999f,0.82519999f,-0.38509999f,-0.50109997f,-0.58429999f,0.09100000f,0.27740003f,0.43170001f,-1.37749999f,-0.73400000f,-0.47959999f,0.56640001f,-0.82729998f,-0.42659999f,0.71859999f,0.49329998f,0.33710000f,-0.60630000f,0.72030000f,-1.09619998f,0.22179999f,-1.02540001f,0.61629999f,0.17340001f,1.28009999f,0.14090000f,0.28190000f,1.03390002f,-0.57560001f,-0.26740000f,0.06330000f,0.09499999f,0.34420001f,-0.51170000f,-0.42790002f,-0.17320000f,-0.28040000f,-0.42169999f,-0.49270001f,-0.16540001f,0.59380001f,0.51360000f,-0.03120000f,-0.30400000f,-0.24680000f,0.54479999f,0.14999999f,-0.38330002f,0.18890000f,-0.28109999f,-0.21209999f,0.67679998f,-0.02520000f,0.55680003f,-0.38760001f,-0.39290000f,0.34969999f,-0.72410000f,0.03650000f,-0.49690000f,0.89620003f,0.07670000f,-0.64629998f,0.09320002f,-0.68930004f,0.33429999f,-0.61450000f,0.20050002f,-0.54280003f,-1.07530000f,0.66210003f,0.29739999f,0.81019998f,-0.41510001f,0.61729998f,0.97070000f,-0.98409998f,0.05569999f,-1.57399997f,-0.30009999f,0.35079997f,1.28329998f,-0.94190000f,1.01110001f,0.10830000f,-0.68079998f,-0.31169998f,-1.06789999f,0.31119999f,-1.38049999f,-0.02440001f,0.24600003f,-0.33240000f,-0.17280002f,0.67680000f,-0.49180002f,0.61780001f,-0.09290002f,0.30170001f,-0.20819999f,-0.22739999f,0.17290000f,-0.05049999f,0.36540000f,0.09180000f,-0.47260000f,0.05859999f,-0.12309999f,-0.08570000f,0.54410001f,-0.40370000f,0.22950004f,-0.28709999f,0.15749999f,0.42210000f,-0.38000003f,0.53840000f,-0.72180000f,-0.19260001f,0.02330000f,-1.25430001f,0.20370001f,0.93090001f,-0.80809999f,-0.12770000f,-1.42810001f,0.50130001f,-0.28820001f,-0.25989999f,-0.54620001f,1.12799999f,0.69250000f,-0.95460000f,-0.02380000f,0.85439998f,0.01340003f,-1.44560001f,-0.38289999f,0.69559997f,1.07229999f,-0.02760001f,-0.19310000f,1.66840000f,-0.17090000f,-0.09339996f,-0.66060001f,-0.72459998f,-0.68169999f,-0.04870002f,-0.54230001f,-0.12330000f,-0.16190002f,0.52190002f,-0.39700002f,0.69940000f,-0.11200003f,0.58720002f,0.14359999f,0.54040000f,0.19140001f,-0.20220001f,-0.02070000f,-0.09810000f,0.18119999f,0.64319999f,-0.63029998f,-0.12570000f,0.25790002f,-0.61070001f,0.17750001f,-0.04790002f,0.36940001f,-0.13899999f,-0.10430002f,0.55429999f,0.51719999f,0.33240000f,-0.43669999f,-0.20410002f,-0.01400002f,-0.12940000f,-0.22220000f,-1.06530001f,-1.09339999f,-0.15599997f,-0.33140001f,-0.82659999f,-0.62340000f,0.61860003f,-0.28620001f,1.58920001f,0.28289999f,-0.47379999f,-0.46179998f,0.14340002f,-0.86819998f,0.47149998f,0.70500000f,0.44729998f,-0.37309999f,1.41400000f,0.80259999f,-0.47279999f,-0.46619999f,-0.43649996f,-0.02540001f,0.75820002f,0.14190005f,-1.07080003f,0.42610001f,0.02949999f,-0.09719998f,-0.48960000f,-0.12710000f,0.85790001f,0.34540001f,-0.53619999f,0.45590001f,0.13090001f,-0.14720002f,0.41000001f,-0.36590001f,-0.04450000f,-0.42260001f,0.47659999f,-0.41460000f,0.29220000f,0.39169998f,-0.05690000f,0.26020000f,-0.15220001f,0.29560003f,-0.23800001f,-0.19610001f,0.50930000f,0.44910002f,-0.27630001f,0.40810004f,-0.31450001f,-0.54169999f,1.04019998f,0.16240000f,0.42119997f,-1.11479999f,0.28970006f,0.93489998f,0.01749999f,0.59490001f,-0.35319999f,-0.75020001f,0.38420000f,0.04519999f,-1.00429998f,-0.60849998f,-0.82429997f,-0.27679997f,-1.14339999f,1.02369998f,-1.07739997f,0.05240000f,0.91979998f,0.39040002f,0.45080000f,-0.93429999f,0.44640001f,0.89670002f,-0.17020001f,0.10020003f,1.56469997f,-0.34809998f,0.08440000f,-0.18020001f,0.66980003f,0.08179999f,0.06579999f,-0.41650000f,0.30850001f,0.63050001f,-0.04370001f,0.42040003f,-0.80560002f,-0.00449999f,-0.39870001f,0.30450004f,-0.32610000f,0.32440003f,-0.66640000f,-0.30460003f,1.00299999f,-0.10100001f,0.68780001f,-0.07009999f,-0.36910002f,-0.27130000f,-0.08870001f,-0.43360001f,0.24640001f,-0.09209999f,-0.18870001f,-0.41820000f,-0.53849998f,-0.82820001f,-0.08839998f,0.65000000f,-1.35779998f,-0.52669998f,-0.62960000f,1.23660002f,-0.92529998f,1.36450001f,-0.15390002f,0.09280000f,0.63429998f,-0.05579999f,1.65229999f,0.64150000f,0.88869996f,-1.38399998f,0.09140003f,-0.86929999f,0.18050002f,0.14080001f,0.28549999f,-0.73030000f,1.06719999f,-0.88540001f,0.25140001f,-0.42299999f,1.08929998f,-0.00609997f,0.24570001f,0.83780002f,0.15220000f,-0.50000002f,0.26960000f,-0.53810001f,0.17090000f,0.50999999f,0.44760001f,0.19120002f,-0.36760000f,0.52000003f,-0.15280000f,0.32640000f,-0.64320001f,0.06160001f,-0.09399999f,-0.47200001f,0.14079999f,-0.15780000f,-0.55140002f,-0.66440001f,-0.20680002f,-0.77830001f,-0.38810002f,-0.56779999f,0.07820000f,0.17690001f,-0.21290000f,0.31620000f,0.10199999f,1.08800002f,-0.44859998f,-1.11030001f,0.51890000f,-0.68650000f,-0.31340000f,0.27609998f,-0.17589997f,0.58290001f,0.01609998f,0.97640002f,-0.41719999f,0.70749997f,0.69829999f,-0.36280002f,1.17320001f,-1.15799999f,0.97639999f,0.23690000f,0.22269998f,-0.35419997f,-0.58740004f,-0.50780000f,-0.17050002f,-1.08959998f,0.69699998f,0.20810000f,0.47700000f,-0.22550004f,-0.11790000f,-0.10759999f,-0.04720000f,-0.69169999f,-0.13630002f,-0.19189998f,-0.69370000f,-0.17880003f,0.60000001f,0.26919999f,0.36440000f,-0.44390002f,0.24589999f,0.09790000f,-0.16269999f,-0.50600003f,0.53840001f,0.35590003f,-0.48550002f,-0.43100000f,-0.12340001f,-0.39210000f,-0.40350001f,0.46940003f,-0.26060000f,-0.30550003f,0.69790001f,0.08239999f,0.46120002f,0.50320000f,-0.05500001f,-0.42900000f,0.75779998f,-0.98299998f,0.58089998f,0.50539999f,-0.16130002f,-0.70320001f,-0.21240000f,-0.22740001f,0.46020003f,-0.16739999f,-1.36689997f,0.64909999f,-0.82339998f,-1.13050002f,-0.02729998f,0.43400001f,1.04790001f,-0.80040000f,0.86059999f,-0.10030000f,0.01399997f,0.98910002f,-0.35309999f,-1.22250001f,0.38320001f,-0.22350000f,-0.26550000f,0.96439997f,-0.54580001f,-0.33600003f,0.41520002f,0.31930001f,0.14150000f,0.72350000f,0.35650001f,-0.00610000f,0.21490001f,0.51240000f,0.57840001f,0.74189999f,0.34890001f,-0.25780000f,0.29740001f,0.59920000f,-0.06279999f,0.17700001f,-0.09060000f,0.00030000f,0.16890000f,0.40010000f,0.49990001f,0.16190001f,-0.25550000f,-0.39110000f,0.04550000f,-0.25390003f,0.58870001f,0.06910000f,-0.61510002f,-0.12820001f,-1.52099999f,0.32940001f,-0.16049998f,0.42220001f,0.27809998f,-0.48390001f,0.59640002f,-0.15330000f,0.50270004f,0.36389996f,0.47380006f,0.16580004f,-1.70720000f,1.03979999f,-0.53380001f,-0.01229999f,0.70429998f,-0.16520000f,0.00590000f,-0.10050001f,0.24680005f,-0.33120003f,1.72230002f,-0.76420000f,0.52830000f,-0.51560002f,-0.80909998f,0.17809997f,0.27440000f,-0.09469999f,-0.52450002f,0.52310002f,-0.34670000f,-0.31210000f,-0.08030000f,0.51869998f,0.21570000f,-0.17850002f,0.47730003f,-0.13000002f,0.45040000f,0.29660000f,0.09220001f,0.09310001f,-0.20830000f,-0.77070002f,-0.23370002f,-0.00040000f,0.25600001f,0.29280000f,0.04560001f,0.30350000f,-0.10549999f,-0.45100003f,0.45460002f,-0.00430001f,0.63790002f,-0.50049999f,0.29750000f,0.34800000f,0.09129998f,1.05060000f,-0.15870000f,-0.21820000f,-0.19710000f,0.41699996f,0.03130004f,-0.19490001f,-1.07580000f,-0.19420001f,-0.88739997f,0.65080001f,-0.82940001f,0.56800000f,-0.55930000f,-0.91290002f,0.41799999f,-0.70030001f,1.00370001f,0.97610000f,-1.46109999f,0.63989999f,-0.36379999f,-1.38150004f,0.85830003f,-0.45190000f,-0.37379997f,0.10120000f,-0.23770000f,0.11479999f,0.47920000f,0.13540000f,-0.05260001f,-0.10769999f,-0.35310001f,0.40350001f,-0.31350000f,0.40490001f,-0.66410001f,0.69130000f,-0.13690001f,-0.22619998f,-0.70619999f,-0.26380001f,0.31780000f,-0.06990000f,0.15630000f,0.19689998f,0.31429999f,0.13940000f,0.42580002f,0.14600001f,-0.45200002f,0.10820001f,-0.61940002f,0.41570001f,-0.12050000f,-0.12640000f,1.09840000f,-0.33170000f,0.02430003f,0.59250001f,-0.83090001f,-0.31840000f,1.16629999f,0.70100000f,0.21849999f,1.35850000f,-0.48540005f,1.55140000f,-1.25769998f,0.50469999f,-0.22670003f,-0.99829999f,0.81269999f,-0.20580000f,-0.06889999f,0.35650001f,-0.92419998f,-0.52860002f,0.64200003f,0.45050000f,0.36649999f,0.67759998f,0.11780001f,0.84930001f,-0.48939999f,-0.51230000f,0.12730001f,0.21840000f,0.14520002f,-0.22800000f,-0.46320003f,0.22680002f,-0.19440000f,-0.38700000f,0.17459999f,-0.12040001f,0.17440000f,-0.62890000f,-0.48709999f,0.39370001f,0.13910000f,-0.34550004f,0.66590001f,-0.69490002f,0.24129999f,0.42679999f,0.29680000f,0.55459999f,0.31660000f,-0.37419999f,-0.11900000f,-0.20040001f,0.74400001f,-0.54629998f,-0.20970000f,-0.53360000f,0.29450000f,0.57609998f,-0.99069997f,0.34260002f,-0.39180003f,-0.12570000f,1.31349998f,-0.75339998f,0.23960000f,-0.25160000f,-0.14399999f,-0.06970000f,-0.52180005f,0.08710001f,0.58480000f,-0.66210002f,-0.89959998f,-1.48939999f,0.88729998f,0.05980001f,0.39859999f,0.60320000f,-0.49899996f,-0.40859998f,0.13799998f,-0.71799998f,-0.54639999f,-0.57239997f,0.22489997f,-0.41399999f,0.49570002f,-0.28840003f,0.38560000f,-0.32040002f,0.33479999f,-0.00030001f,0.59430002f,0.22610000f,-0.08210000f,-0.27200001f,0.13880000f,-0.30230001f,-0.36729999f,0.69480000f,-0.06479999f,-0.37060002f,0.06820001f,0.00860001f,-0.09859999f,0.16880001f,-0.66200001f,-0.14080002f,-0.03920000f,-0.55169999f,-0.14670003f,0.76750003f,0.01730001f,0.19000001f,-0.13960000f,0.18260003f,-1.21579999f,-0.15380000f,-1.27100000f,0.03860000f,-1.67619997f,-0.60720002f,0.07450004f,0.47250000f,-0.25420000f,0.03510001f,-1.11730002f,0.32269998f,-0.75560001f,1.36010001f,-0.97830001f,-0.51740002f,-0.01120001f,-0.05110001f,0.34749999f,0.92159998f,-0.16639999f,0.23669999f,-0.82530000f,-0.92859998f,0.86490000f,1.26780003f,-0.75070000f,-0.10830001f,1.05730001f,0.82180001f,0.24920000f,0.41830002f,-0.20950001f,-0.07100000f,0.09980000f,-0.05060000f,-0.16900001f,-0.53970001f,-0.60510002f,-0.02380000f,0.07060000f,0.31790001f,-0.35390001f,-0.41580000f,0.66420001f,0.04150000f,0.32570001f,0.45070000f,-0.13749999f,0.19270003f,-0.35470001f,-0.30500001f,-0.03340000f,-0.37660001f,0.45220001f,-0.51190000f,0.16990000f,0.02460000f,0.15540000f,-0.19490000f,-0.11460001f,-0.27660001f,0.01650000f,-0.89219998f,-0.45749998f,-0.73230000f,-1.00920000f,0.65730001f,0.65280000f,0.54390000f,0.60540000f,0.87210003f,0.35190000f,-0.84570002f,-0.78360000f,0.17460000f,-0.49499999f,0.41130001f,0.39570000f,0.30660001f,-0.01950000f,-0.75239998f,-0.47309998f,-0.45330000f,0.63210002f,-0.18450001f,-0.53190002f,-0.39630001f,0.21840001f,-0.69299998f,0.38139999f,-0.24220000f,-0.11340000f,-0.67009999f,-0.55330001f,0.67129999f,0.05889998f,0.64170001f,0.54410003f,-0.13100004f,0.76579999f,0.57099999f,0.14580001f,0.09870000f,0.29490002f,0.31680000f,0.21000001f,-1.36529997f,-0.88870002f,-0.16789999f,-0.18270000f,-0.01900000f,0.44300002f,-0.52970002f,-0.55090003f,-0.73619999f,-0.52080001f,0.94549998f,0.94270002f,0.58190001f,-0.19349999f,0.10920000f,0.07140000f,-0.31649999f,-0.14579999f,0.36509999f,0.94140002f,0.36330001f,0.18659999f,0.95699999f,-0.18000001f,-0.07620000f,0.21899999f,0.33210002f,0.02610000f,0.18960000f,0.19140000f,-0.68010000f,-0.69389998f,-0.41310000f,-0.34920000f,0.41700001f,-0.20700000f,-0.26970002f,0.03240000f,-0.56700000f,-0.53910000f,0.87030000f,0.44399998f,0.57270001f,-0.41400001f,0.77109997f,0.61049999f,-0.29769998f,0.35270001f,0.05360000f,-0.31080003f,0.76499999f,1.04440004f,-0.48690000f,0.10930001f,0.79280001f,0.52160003f,-0.54959998f,-0.65960001f,0.29939997f,-0.01960001f,-0.72579999f,-0.65120002f,-1.04979998f,-0.32260000f,-1.11680001f,-0.52920002f,-0.18109999f,-0.91450002f,0.10910002f,-0.33810000f,1.05910001f,0.64830003f,-0.06319998f,0.08370001f,0.78509998f,0.68429999f,0.20790000f,-0.56459998f,-0.38280002f,0.07980001f,0.72840002f,-0.03450001f,-0.16829999f,-0.80070001f,0.17340001f,0.14340000f,-0.59639999f,-0.19379999f,0.24239999f,0.57869999f,-0.55320001f,-0.31889999f,-0.30899999f,-0.83039999f,-0.34740000f,-0.62640000f,-0.63389999f,0.48270003f,-0.44250000f,0.10380000f,0.64050001f,0.72780000f,-0.34620001f,-0.78360004f,0.28680000f,0.35900001f,0.16730000f,0.78710003f,0.41199997f,0.64180001f,0.22580000f,0.69480002f,-1.08309999f,-0.81590004f,0.09780000f,-0.66700000f,-0.59030001f,-0.37310001f,1.19510000f,0.70830003f,0.44899997f,1.20920002f,-0.41129999f,-0.17330000f,1.45589998f,0.75190004f,0.88370001f,0.07330001f,-0.52379999f,0.10380000f,-1.10070000f,-0.24110002f,-1.39989999f,0.32190002f,0.08100000f,-0.18210000f,0.94050002f,0.04290000f,0.67859999f,0.18749998f,0.88260001f,0.16890000f,-0.90030001f,-0.79379999f,-0.61259999f,0.39240000f,-0.09630000f,-0.09240000f,0.35310001f,0.43680000f,0.92340000f,-0.34950002f,0.03570000f,-0.07740000f,0.44790002f,0.71819997f,0.13410000f,0.85260001f,-0.01320000f,-0.65039999f,-0.04770001f,-0.70259999f,-0.72330002f,1.04760004f,-0.07739999f,-0.61080003f,-0.62779997f,-0.21119999f,-1.38430000f,-0.68270002f,-0.16360001f,0.07200000f,-0.83050000f,-0.80270003f,0.88059999f,0.79520003f,-0.20089998f,-0.75550000f,0.35410002f,1.17030004f,-0.54659998f,-0.52120000f,0.97109999f,0.19230001f,-0.62239999f,-1.23300006f,-0.06510000f,-0.13150001f,-0.37440001f,0.35000001f,-0.68680000f,0.16140000f,-0.72150000f,-0.12210001f,-0.35640002f,0.43830002f,-0.47279998f,-0.79589999f,-0.73830001f,-1.08540000f,-0.07860000f,-0.34680001f,-0.45990002f,-0.08249999f,0.60420000f,0.30329999f,-0.71189999f,0.13830001f,0.97950002f,-0.31469999f,-0.33299999f,-0.09929999f,0.23730000f,0.87179999f,-0.85800004f,0.30030002f,-0.35250000f,-0.26280000f,0.07800001f,-0.77820002f,0.38100000f,-0.43890000f,-0.74010002f,0.16720000f,0.12580001f,0.62660004f,-0.89399999f,-0.18960001f,-0.02240001f,0.39880002f,-0.64459999f,-0.76780002f,-0.67870000f,-1.20730005f,0.36429998f,0.43390000f,-0.35989997f,-0.43089999f,-0.97399998f,-0.29840002f,0.46720000f,-0.08440000f,-0.69399998f,-1.13740003f,0.86079998f,0.43640000f,-0.24850000f,0.09609999f,-0.13520000f,-0.79800002f,0.34380003f,0.98840005f,0.79589999f,0.07169999f,0.25320002f,-0.53460002f,-0.41880000f,-1.01099999f,0.03240000f,-0.58020003f,-0.90300000f,-0.46679999f,-0.87330002f,0.19290002f,0.39089999f,0.12839999f,-0.70289998f,-0.48269998f,-0.02940001f,-0.47999998f,0.19140000f,0.77160000f,-0.89520000f,0.04950003f,0.32879999f,0.50939999f,-0.18690000f,-0.58349999f,-0.90120000f,0.04740000f,0.96540003f,-0.06809998f,0.73350001f,-0.87690000f,-0.03070000f,-0.10610000f,-0.98669998f,-0.63970004f,0.80249998f,0.22690000f,0.68270001f,0.20670001f,-0.73869999f,-0.50250001f,0.26479997f,0.85520000f,-0.31269999f,0.46250001f,0.04740002f,0.81020002f,1.22889996f,0.88930001f,-0.18779999f,-0.68820000f,0.23120002f,-0.26640001f,-0.91289998f,-0.59850001f,0.85720002f,0.25180002f,-0.31919995f,-1.14280001f,-0.37230000f,0.17040002f,0.18990000f,0.34590000f,-0.90750002f,-0.97709998f,0.37529999f,0.82199998f,-0.00630000f,0.30960000f,-0.56730000f,-0.56910000f,0.76499999f,-0.16860001f,0.20610001f,-0.74459999f,0.56820001f,-0.52379999f,0.63270000f,0.51419998f,-0.51179999f,0.27660001f,-0.14880000f,0.44160002f,-0.68189999f,-0.71519999f,0.23880001f,0.68010002f,-0.81300000f,0.49440004f,0.44670000f,0.37950001f,-0.65760000f,-0.23960002f,0.95329999f,1.07230003f,-0.30939998f,0.38360001f,1.40330001f,0.74910003f,1.20790000f,0.49190002f,-0.12980000f,-0.32700001f,-0.49279997f,-1.20440004f,0.29430000f,-0.42050000f,-1.17539997f,-0.53980000f,-0.75549997f,-0.47070001f,0.00200000f,-0.05400000f,-0.96920000f,-0.81660002f,-0.87040001f,-0.30440003f,-0.69479999f,-0.79440002f,0.32520001f,0.38400000f,-0.48960002f,-0.79980001f,0.77910001f,0.15389999f,0.22980000f,-0.59670000f,0.46530001f,0.69390001f,0.70230000f,1.16820001f,-0.04800000f,0.31560001f,-0.83220002f,0.40560003f,-0.05490001f,0.83640000f,-0.86579998f,-1.25219998f,-0.69510000f,-0.77699999f,0.16260001f,0.26700001f,-0.52800000f,-0.26609999f,-0.26760001f,-0.64620001f,-0.49860000f,-0.01439998f,0.86820000f,-0.17960001f,1.18710002f,0.25850002f,-1.14540000f,-0.53080002f,-0.56260001f,0.19640000f,0.39239999f,-0.09100000f,0.49290000f,0.15410001f,1.01420002f,0.39140001f,0.40619996f,-0.27640001f,-0.63770001f,-0.91430004f,-1.32039999f,-0.84360002f,0.07529999f,0.08770000f,-0.24859998f,0.60500004f,-0.52700002f,0.35620001f,-1.20199998f,-0.58200002f,0.05300000f,-0.29480002f,-0.52730003f,-0.68550001f,-0.06030000f,0.63330001f,-0.44040000f,-0.75570000f,0.18180000f,-0.60330001f,-0.41100000f,0.02969999f,0.26610000f,0.52320000f,0.26819999f,0.64860001f,0.04440000f,0.83609999f,-0.67350002f,0.01890000f,-0.62279999f,-0.65519998f,0.38490001f,0.37440000f,0.71940003f,-0.31679999f,0.64440002f,-0.28500000f,-0.36720000f,-0.64799998f,-0.15780001f,0.31050001f,-0.93810003f,0.10240001f,-0.59829999f,-0.59090001f,-1.11239998f,-0.38000001f,0.39679998f,0.47000000f,-0.52110000f,-0.10529999f,-0.25720000f,-0.56000002f,0.19589999f,1.01570001f,0.78739997f,0.74480000f,-0.98970002f,-0.21330002f,0.09060001f,-0.63780003f,-0.99660000f,-0.62500002f,-0.17650001f,0.19710001f,0.99160002f,0.39260001f,-1.14270000f,-0.63230001f,-0.06949999f,-0.00669999f,1.17169997f,0.09150000f,-0.41010000f,-0.12989999f,-0.07380000f,-0.53519997f,0.76139999f,0.52439999f,-0.35009998f,-0.71730001f,-0.67920001f,-0.16860000f,0.75750000f,-0.48030001f,0.63899998f,0.33269998f,-0.33090000f,-0.96360001f,-0.32280001f,0.67080003f,-0.32700000f,-0.34979998f,0.44490001f,0.04800000f,0.33540000f,0.70230001f,-0.78090000f,-0.98760000f,-0.25950000f,-0.34800001f,0.39869998f,0.76640002f,0.30099998f,1.05620003f,0.38300001f,0.05020000f,0.41340003f,-0.42659997f,-0.56540000f,-0.58840003f,-0.15469998f,-0.70670003f,0.31069997f,-0.58330004f,0.60670003f,1.26090005f,1.11930000f,0.44030003f,-0.18979998f,-0.53840000f,-0.12989999f,-0.08530000f,-0.05980000f,-0.45600003f,-0.76280002f,-1.28920007f,-0.85380000f,-0.43620002f,-0.20490001f,0.38970001f,-0.14090003f,0.49529999f,0.67860000f,-0.53400003f,-0.10320000f,0.15900001f,-0.67079998f,0.25620000f,-0.56460002f,-0.27870000f,-0.95550001f,-0.16859999f,-0.79230003f,0.25859999f,0.88050001f,-0.33090000f,0.24270001f,0.64289998f,-0.40919999f,0.16710002f,-0.15270000f,-0.16470000f,-0.69660002f,-0.16290000f,-0.90300004f,0.20460000f,-0.27600001f,-0.44339999f,0.05550001f,-0.70770002f,-0.13710000f,-0.34760002f,0.21819999f,0.17940000f,0.99069999f,0.27290001f,-0.18190001f,0.21190000f,0.43819997f,-0.14980002f,0.14629999f,0.65710002f,0.09889999f,0.51430000f,0.83840001f,0.62000004f,0.63979999f,0.55140001f,-1.02550004f,-0.19750002f,-0.86069999f,-0.94030003f,1.28959999f,1.15740004f,0.68429999f,0.33430001f,-1.45130003f,-0.89770005f,-0.23319999f,0.00099999f,0.06229999f,-0.84150000f,0.42840001f,0.41760001f,0.27509999f,0.81210000f,0.27330000f,-0.17370000f,-0.33960001f,0.24059998f,0.30330000f,-0.50460003f,0.19590000f,-0.45630001f,0.36840001f,0.25919999f,0.51360000f,0.34439999f,0.13470001f,-0.49200001f,-0.85950001f,-0.35759999f,0.80940000f,0.36929998f,0.24689999f,0.40739999f,-0.83010003f,-0.92940002f,-0.32520001f,-0.58410001f,0.85350000f,-0.79110003f,-0.23730000f,-0.25290001f,0.75490000f,0.69690003f,-0.64180000f,-0.77820003f,0.57150000f,-0.04550000f,1.30440000f,0.69540005f,1.76719999f,1.06200004f,0.40869998f,0.53070000f,-1.09469998f,-0.80310001f,-0.15460000f,-0.01540000f,0.61620000f,0.59560003f,-0.57950000f,-0.73210004f,0.26849999f,-0.08950000f,0.51419997f,0.19459999f,0.91340000f,0.43920001f,-0.63599999f,0.29879999f,-0.46650000f,-0.36840000f,0.53730002f,0.25920000f,-0.39840000f,0.12360002f,0.03750000f,0.63450000f,0.79080003f,1.05269999f,0.74220001f,0.87359999f,0.82229999f,0.51359998f,-0.72749999f,-0.62759999f,-0.07680000f,-0.20580000f,0.25740002f,-0.03390000f,-0.81570003f,-0.36150000f,0.13050001f,0.52800001f,0.44459999f,0.68460000f,0.31140000f,0.53370000f,-0.43860000f,-0.31340000f,0.81269997f,0.72950000f,0.33480001f,0.54960004f,-0.45849998f,-0.98770002f,-0.75309998f,-0.26250001f,-0.17850000f,0.03930000f,-0.04020001f,0.68360003f,-0.02279997f,-0.55940001f,-0.31190002f,0.43050001f,-1.60279999f,-0.80960001f,0.02290003f,-0.48409998f,0.75900000f,0.23300001f,-0.45049999f,-0.04030000f,-0.43209997f,0.09930001f,-0.64639997f,-0.06080000f,-0.16120001f,0.11099999f,0.44309998f,0.15659997f,0.71280003f,0.29340001f,-0.71490001f,0.24600002f,-0.20849999f,-0.53429998f,-0.03270000f,-0.25950000f,0.91620001f,-0.02010002f,-0.59040000f,0.14610002f,0.06750001f,-0.85320003f,-0.59939998f,-0.93839998f,-0.62009998f,0.04170001f,-0.10260000f,0.23100000f,0.11130000f,-0.22649999f,-0.26069999f,-0.84029999f,0.17940000f,-0.29819998f,0.55559999f,0.77130002f,0.21350000f,0.86450004f,0.48319998f,1.22040002f,-0.49450001f,-0.34390003f,0.50120000f,0.23700001f,0.31530001f,0.85610004f,0.41659997f,0.80360001f,1.53130001f,0.79970005f,-0.48680001f,-0.00800000f,-0.14750000f,-0.23670001f,0.80789996f,0.44409999f,0.41079999f,0.69740002f,-1.12639999f,-0.61240003f,1.40520003f,0.57200003f,-0.37280000f,-0.80340003f,0.71320000f,-0.69360003f,0.53490002f,-0.49050002f,0.84360001f,-0.42540001f,-0.57090002f,-0.58650001f,0.17640000f,0.30510000f,0.65130002f,-0.25260001f,0.87659999f,0.17429997f,0.50130002f,0.77639999f,0.03960000f,-0.38940002f,-0.13470001f,0.06600000f,0.64649998f,0.80969999f,0.59100001f,0.00389998f,-0.27900000f,-0.43319996f,0.26700000f,0.73560001f,-0.59220001f,0.18810001f,0.52199998f,0.16390001f,0.19080000f,-0.48800003f,-0.79060001f,-0.81680004f,-0.42650000f,-0.51990001f,0.17359997f,0.75920002f,-0.37730000f,-0.39490002f,1.19780000f,0.83200003f,-1.33769997f,-0.71970003f,-0.48840000f,-0.51720003f,0.86929999f,0.32510001f,-0.41909997f,-0.95850001f,0.10379998f,0.57140000f,-0.00629998f,0.75750003f,-1.13629997f,-0.54550000f,-0.21620000f,-0.23340001f,-0.25650000f,0.30020005f,-0.38070000f,-0.45980001f,0.51329999f,-0.00940001f,1.09259998f,0.37459998f,-0.31529998f,0.20230001f,-0.80640000f,-0.33460000f,0.56790001f,1.00740002f,0.01769997f,-0.61310002f,0.41939997f,0.25800000f,-0.19919999f,0.11930001f,0.11250000f,0.20860001f,0.41789999f,-0.05960000f,-1.23059998f,-1.08529999f,0.23670000f,-0.06119999f,-0.96360002f,-0.98200002f,-0.06810002f,0.07159999f,0.43750000f,-0.21420000f,0.78040000f,-0.16040000f,0.03770001f,-0.73060001f,-0.69160002f,0.09640000f,0.12760003f,0.05680000f,-0.61220000f,0.05840000f,-0.07380000f,-0.00420000f,-0.23860000f,-0.06400000f,1.17970000f,0.11880000f,-0.16680001f,0.33520000f,-0.13100000f,0.18800000f,0.76540003f,-0.29000000f,0.44190000f,0.26400001f,-0.80340000f,-0.07320000f,0.00519997f,0.27929998f,-0.48090000f,-0.39829999f,-0.53160001f,-0.68939999f,-1.32690002f,-0.75990003f,0.39960002f,0.59500001f,0.25679996f,0.50879999f,0.22920001f,0.28899999f,0.06930000f,0.19500001f,-0.03480000f,0.11420000f,-0.15540001f,-0.68489999f,0.59580001f,0.28500000f,0.46199999f,0.50700001f,-0.76560001f,-0.82440001f,0.30060000f,-0.13649999f,0.19560001f,0.68440000f,-1.01099996f,-0.29680000f,-0.31609999f,-0.42520000f,-0.12000001f,0.45879999f,-0.04479999f,-0.03080001f,-1.04960000f,0.37819999f,-0.13560000f,0.65380000f,-0.97870002f,0.23819999f,0.52120000f,-0.02200000f,0.18940002f,-0.50940000f,0.65380001f,0.02260000f,0.63080000f,0.40559999f,0.93150003f,0.14620000f,0.67490001f,-0.58240001f,-0.10820002f,-0.02400000f,-0.70690003f,-0.31260000f,-0.40430002f,-0.72450000f,-0.59340000f,-0.00950001f,0.93479996f,0.74059999f,-0.11940001f,-0.21640003f,1.07909999f,1.28899999f,1.23869999f,0.80320000f,0.69570000f,0.79749999f,-0.26460000f,-0.54879999f,-0.96270000f,-0.60360001f,-0.20070001f,-0.52480000f,0.57599997f,0.09760000f,0.01169998f,-0.37710000f,-1.36800001f,-1.34570001f,-0.10379997f,-0.21199999f,-0.32189999f,0.22190001f,0.94830001f,-0.29280001f,-0.59100001f,0.34579999f,-0.07830001f,-0.03560000f,-0.31799999f,-0.04899999f,-0.04150002f,-0.14120000f,0.64100002f,0.39439999f,0.18159999f,-0.33839999f,0.74760001f,-0.19599999f,-1.23800001f,0.10559999f,-0.88949998f,0.54999999f,0.52069999f,-0.13019999f,-1.31560002f,-0.08039999f,-0.39000002f,-0.50280001f,0.09130001f,0.45459999f,0.86850002f,0.21580000f,0.93250002f,-0.85030003f,0.79890000f,0.72679999f,0.12299998f,0.46790002f,0.10110000f,0.41620000f,-0.09600001f,0.28850002f,0.44339997f,-0.22320002f,-0.79439996f,-0.81959998f,-0.55140000f,-0.60859998f,0.53340001f,0.82779999f,1.40639997f,1.54129998f,-0.35309999f,-0.36329998f,0.21480005f,0.67140002f,-0.84479999f,-0.41060000f,0.84029996f,0.53469998f,0.21269996f,-0.10910000f,0.46649995f,0.30940000f,0.51480000f,-0.50100000f,0.03439999f,0.59939999f,0.79940003f,0.55040000f,-0.12789999f,0.30820000f,1.05900001f,-0.30299999f,-0.88730002f,0.07120000f,0.34139999f,-0.20219999f,-0.70940002f,0.45739999f,0.64709999f,-0.14680000f,-0.48370001f,-0.48699999f,1.09850000f,-0.59039999f,-0.21949998f,0.28739999f,-0.24399998f,0.66760000f,0.59380001f,0.10260000f,0.72590002f,1.13740001f,-1.12770001f,-1.03380001f,1.04249999f,0.50780000f,0.73499998f,-0.00720000f,0.59790000f,0.40550000f,-0.88890000f,-1.05979999f,0.43860002f,0.76710001f,-0.58889997f,-0.76299998f,1.20209997f,1.37740000f,-0.47999999f,-0.62529998f,-0.77549996f,-0.29889999f,-1.51619999f,-1.64590001f,0.52769998f,0.27689997f,1.33379998f,0.99159999f,0.13649997f,0.07960001f,-0.42990001f,-0.04800000f,-0.69650003f,0.64180001f,0.20660002f,0.69679999f,-0.55680001f,0.63320001f,0.34040001f,0.25759999f,1.06820003f,-0.49860001f,-0.34609999f,0.01500000f,-0.06240000f,0.40739999f,0.91510000f,0.03180000f,0.13729999f,-0.63339999f,0.94090001f,-0.34480001f,-0.68300000f,-0.14720000f,-0.26089998f,0.53679998f,0.12920001f,-0.05160000f,-0.44410003f,0.17799999f,-1.14000000f,0.05990000f,1.41510003f,1.23570003f,1.19999996f,0.58819998f,1.32780002f,1.05400002f,0.24839999f,-0.27440002f,-1.33830002f,-1.52420002f,0.17550000f,0.36229999f,0.65669998f,0.18559999f,-0.14310003f,-0.35349999f,-1.19609998f,-0.76609999f,-1.02300002f,-1.28670001f,-0.07079998f,0.26339999f,1.04039995f,0.69649996f,-0.29219999f,-0.58000001f,0.61199998f,0.90430002f,1.22519998f,-0.27940000f,0.42239999f,-0.41699999f,0.31310002f,0.64959998f,-0.27300001f,-0.52999999f,-0.67230003f,0.00980000f,0.41480001f,0.29620000f,-0.45809998f,0.26500000f,-0.28259999f,0.65199998f,-0.53180001f,0.56399999f,-1.17209999f,0.01460000f,0.48940000f,-0.36559999f,0.09799999f,-0.36080001f,0.50290001f,0.37779999f,-0.51470003f,-0.33240001f,0.86389997f,-0.65300000f,0.40930002f,-0.95569998f,-0.84749998f,-0.60919998f,0.99719995f,0.23409995f,-0.87719996f,-0.37039999f,0.16290002f,0.28770000f,0.36750000f,-0.08439999f,0.74309998f,0.91849998f,1.33619995f,1.05319997f,1.28999996f,1.22939999f,0.39810001f,0.82749998f,-0.89399998f,-0.93019998f,-0.73320000f,-0.57640001f,0.48209998f,-0.07550001f,-0.47519999f,-0.08830000f,-1.57589998f,-1.60549999f,-0.05430005f,0.00319999f,0.07140000f,0.58960001f,-1.12300000f,0.26179999f,-0.13310001f,0.48679999f,-1.26210003f,-0.08200001f,-0.46400002f,-0.73160000f,0.50450000f,-0.41580000f,1.02189999f,-0.64260000f,0.42239998f,-0.77599998f,0.31020001f,0.85519998f,0.21020000f,0.52959999f,0.29090001f,-0.30980001f,1.06330002f,-0.16480000f,0.56480003f,0.29000000f,0.92730000f,-0.30540000f,-0.69220001f,0.42139999f,1.01280001f,0.47140000f,0.88349999f,1.19699999f,0.99479998f,0.79290000f,0.20340001f,0.65609999f,-1.15799999f,-0.38100000f,-0.90690000f,-0.76329999f,-1.59389999f,-1.66750000f,-1.57379996f,-1.19179997f,1.39559995f,0.51859998f,0.83099998f,0.23239999f,-0.62070001f,-0.43210000f,-0.64020002f,-0.92030000f,0.37859998f,-0.00120001f,-0.87210001f,-1.02809999f,1.18769997f,0.33720001f,-1.07820004f,-0.08500001f,0.82880003f,0.28300000f,0.22050001f,0.36640000f,-0.59000000f,0.20340000f,-0.14440002f,-0.34880000f,-0.77040002f,-0.21800001f,0.27280002f,-0.72539999f,0.85640002f,-0.29899999f,1.16160002f,0.09440000f,0.32300001f,-0.40920000f,0.12759999f,0.16720000f,0.55350003f,-0.00700001f,1.03020000f,0.12760000f,0.22070000f,-0.30640000f,0.77300004f,0.14050001f,0.06090003f,0.30739999f,0.27629998f,-0.20780000f,0.68099998f,0.46850000f,0.43770001f,0.29339998f,-0.58139999f,-0.24859999f,-0.19740000f,0.17839999f,-1.42709998f,-1.01460000f,-0.87689999f,-1.08000000f,-0.18720002f,-0.67919999f,-0.77520001f,-0.45840000f,0.42239998f,0.52800003f,-0.01410004f,0.09130000f,-0.04860002f,-0.45179999f,-0.65820000f,-0.56250001f,-0.98700000f,-0.06960000f,0.68080000f,-0.13339999f,1.05330001f,0.02499999f,0.05910000f,-0.43939999f,-0.02400000f,0.55740000f,0.11320002f,0.10840000f,-0.67809998f,0.57759999f,-0.71789999f,-0.01280000f,0.40480003f,0.58720000f,0.51370001f,-0.67580001f,1.04300002f,-0.10160000f,0.36130000f,-0.18060000f,-0.67420003f,-0.29500001f,0.54430002f,0.57020000f,-0.28840002f,0.37280001f,-1.17960001f,-0.00909999f,-0.47609999f,-0.66159999f,-0.19410005f,-0.44210000f,-0.70589999f,-0.19509999f,0.99810000f,0.54120001f,0.05580000f,-0.25600002f,1.38239996f,1.40409997f,0.24900000f,0.60769999f,0.96539998f,0.41139999f,-1.45290002f,-1.23890002f,-0.47880003f,-0.72860001f,-0.33870001f,-0.15229999f,-0.35189999f,0.07479999f,0.81989999f,0.10190000f,0.72180003f,0.46180002f,0.46050005f,-0.27139999f,-0.89520000f,0.69840001f,-0.40490000f,0.02979999f,-0.42190004f,-0.01779999f,0.46130002f,0.06200000f,-0.07040000f,0.18359999f,-0.28629997f,-0.06420000f,-1.10420004f,0.61459999f,-0.93160003f,-0.15499999f,0.39339998f,-0.25260000f,0.00010000f,0.12840000f,-0.16889999f,0.20599999f,1.19810004f,-0.55299999f,0.74710002f,0.07300000f,-0.42009999f,0.67880000f,0.67610002f,0.26320001f,1.64400001f,1.60760001f,0.12509999f,0.15289998f,-0.06629994f,-0.19089997f,-0.08640001f,-0.40070001f,0.18720000f,-0.22540003f,-0.20609999f,-0.36830004f,1.56749999f,1.69060001f,-0.04769995f,0.31240002f,-0.63989999f,-0.69399999f,0.21540000f,0.08550000f,0.29879999f,-0.02370003f,-1.47510000f,-1.66250002f,-0.07410003f,-0.35750001f,1.38899999f,1.06730000f,-1.30349998f,0.36580000f,0.16590001f,-0.38660000f,-0.56830001f,-0.41320000f,0.12050001f,0.07760000f,-0.43149997f,-0.01380000f,-0.68910001f,0.61500001f,-0.58479998f,0.54499999f,-0.90140004f,0.11720001f,-0.50830001f,-0.09260000f,0.99830005f,0.00540000f,0.77040001f,0.02000000f,-1.38560002f,0.19380000f,-0.54230001f,-0.11860000f,1.04420005f,0.34880001f,-0.30130000f,0.55640000f,0.19449999f,0.01020000f,-0.69030001f,-0.34230000f,-0.61019998f,-0.15050000f,0.17159999f,0.18870000f,0.00450001f,-0.01250002f,1.37190002f,1.22410002f,1.19669998f,1.03679998f,0.48540004f,0.71100002f,0.02910000f,0.35510000f,-0.18090004f,-0.33770000f,-0.28740001f,-0.73300001f,0.81690002f,1.23460000f,-0.06209998f,0.19970000f,0.28259999f,-0.41240001f,1.06080000f,0.66749999f,-0.31559999f,-0.44659999f,-0.09279999f,0.32479999f,-0.75900002f,0.06040000f,1.00450002f,-0.43980000f,-0.17350001f,-0.41400000f,-0.71050004f,-0.55959999f,-1.56970002f,-0.11540001f,0.03860000f,-0.42599998f,0.84980000f,0.18920000f,0.00350000f,0.15540000f,-0.89370000f,0.33759999f,0.36500001f,0.16700000f,0.16800001f,-0.46000001f,0.01260002f,-0.53200000f,-0.73650002f,-0.14560000f,0.61760000f,-1.12170000f,0.55019999f,0.21379998f,0.37800001f,0.66600001f,-1.12530001f,-1.18010000f,-0.74099998f,-0.43650000f,-0.76199995f,-0.01449996f,0.25770002f,0.88249999f,-0.66479998f,-0.13839998f,0.04079999f,-0.48279999f,0.27989999f,0.15730000f,0.88139999f,0.93189998f,0.08730001f,-0.35540001f,-0.88500001f,-0.58900001f,-0.93000001f,-0.45580002f,-0.05939999f,0.27870000f,-0.26430000f,-0.05619999f,-0.95960000f,0.21240000f,-0.09360001f,-0.21000001f,0.82399999f,-0.45599999f,0.51700000f,0.22139999f,-0.01119999f,0.19940000f,0.15449999f,-0.07119998f,0.10709998f,-0.12800000f,-0.41249998f,0.78460000f,1.28370002f,0.26180000f,-0.06960002f,0.01460000f,-0.87540000f,0.14479999f,0.43460000f,0.00980000f,-0.26720001f,0.73379999f,0.65349999f,-0.01740000f,-0.24559998f,-0.24649999f,0.69240001f,0.89459999f,-0.24660002f,0.13560001f,-1.17539998f,-1.28779999f,0.26969996f,-0.03860001f,0.37469999f,0.24200000f,0.00060002f,0.31370005f,-0.37499999f,-0.50930000f,1.59029999f,1.20509999f,0.10829996f,-0.50449999f,-0.07169998f,-0.26959999f,0.44520000f,0.49459998f,-0.05490001f,-0.11059999f,1.40189998f,0.91240000f,-0.14130002f,-0.20109999f,1.05119995f,0.72500001f,-0.74240001f,0.61580000f,-1.02679999f,0.65879998f,0.04310002f,0.44280000f,-0.39090001f,-0.09400000f,-0.63160002f,0.39400000f,-0.31289999f,-0.04759999f,-1.35840004f,-0.11039999f,0.31140001f,0.17840001f,0.26380000f,-0.13959999f,-0.25879998f,-0.53500000f,-0.51520000f,0.16220000f,1.15170003f,-0.07980002f,-1.24750006f,-0.11180000f,0.65640001f,-0.35660000f,-0.22260002f,1.39690001f,1.42770000f,1.36560001f,1.62779996f,1.69599997f,0.72539999f,0.25449998f,-0.06119999f,0.13230000f,1.00440000f,1.09660002f,0.13920001f,0.51710001f,0.17700005f,0.67820002f,0.27840000f,0.11860001f,-0.34679999f,-0.35599999f,-0.83970000f,-0.24400002f,0.52830000f,0.72220001f,-0.45210007f,-0.72130003f,0.10710003f,0.51070001f,-0.92790000f,-1.02900001f,-0.76919999f,0.03639999f,0.18330001f,-0.42380001f,0.79180003f,-0.06620000f,0.61980001f,-0.24260000f,0.05810002f,-0.18660000f,0.36260001f,-0.01600000f,-0.90910002f,-0.23200000f,0.74340000f,0.55799999f,0.29770001f,0.15820000f,-0.65190001f,-0.19640000f,0.90369999f,-0.57800000f,-0.24939998f,0.19360000f,-0.59260002f,0.67940000f,0.90109999f,0.19700000f,0.12500000f,0.07680000f,0.23130000f,-0.39339997f,-0.04700000f,-0.26170000f,-0.24059999f,0.48269999f,-0.01960000f,0.62680000f,0.01170000f,-0.09280000f,0.08360000f,-0.55340001f,0.07440001f,0.48370000f,0.03270000f,-0.21320001f,0.23040000f,0.02380000f,0.01390000f,-0.06810000f,0.11260000f,-0.00489999f,-0.15759999f,0.33670000f,-0.25350000f,-0.61650000f,0.13740000f,-0.05729999f,-0.08100000f,-0.64720002f,-0.02620000f,-0.13239998f,0.17710000f,0.05950000f,0.34680000f,-0.27410000f,0.71610002f,1.06340002f,-0.29960000f,0.31850001f,-0.67799995f,-0.03500000f,0.01699998f,0.26979999f,-0.19560000f,0.09180001f,-0.01740000f,0.25640000f,0.18190000f,-0.95390001f,-0.16480001f,-0.43050001f,-0.49299999f,-0.13699999f,0.48660001f,-0.07490001f,-0.02190001f,-0.70920002f,-0.38699999f,0.69030001f,0.40479998f,-0.10130001f,0.10290000f,-0.44660000f,0.04480000f,-0.49660000f,-0.05170001f,-0.77420003f,-0.02000000f,0.38220001f,0.42760000f,-0.18160001f,-0.18179999f,0.38339999f,0.10920000f,-0.02490000f,-0.00900000f,0.02860000f,0.09010000f,-0.37369998f,-0.11400000f,0.47560001f,0.18100000f,0.17100000f,0.02260000f,-0.61960001f,-0.02730000f,0.12270001f,0.10100000f,0.18960000f,0.06120000f,0.01080000f,0.08570003f,0.89170001f,-0.71439996f,-0.55529997f,0.28120000f,0.02180000f,-0.86499999f,0.17590002f,-0.73180000f,-0.87120001f,-0.34390000f,0.26270002f,0.36079998f,-0.35300000f,0.49480000f,0.64329999f,0.26640000f,-0.48950001f,-0.37959999f,-0.98980000f,-0.04209999f,-0.80370002f,1.09829998f,0.34850001f,0.31419997f,0.04209999f,0.05870000f,0.94460003f,-0.38590001f,-0.59770001f,0.10229999f,-0.37830001f,0.17799999f,0.45820000f,-0.17160000f,0.06179999f,0.10460001f,0.76769999f,0.08060001f,0.71710001f,-0.13370000f,0.69739999f,-0.09760000f,-0.18300000f,0.00400000f,-0.62150002f,-0.03160000f,-0.21670000f,0.16600000f,0.11360000f,0.16050000f,-0.27920000f,-0.22790000f,-0.78470002f,-0.21060000f,0.11140001f,-0.03030000f,-0.04540000f,-0.11010000f,0.19280000f,-0.45440000f,-0.13170000f,-0.53289997f,0.21630003f,-0.33499999f,0.34410000f,-0.36289997f,0.33740003f,0.00180000f,-1.05490002f,0.80559995f,0.29619998f,0.25840000f,-0.17610001f,-0.26480001f,0.62770002f,-1.22049996f,-0.13860000f,0.10790000f,-0.11860000f,-0.07720004f,0.95030000f,0.59639999f,0.96330002f,-0.58709997f,-0.70249999f,-0.31389997f,-0.82740000f,-0.16629997f,-0.25270001f,-0.03320000f,0.61610000f,0.33850000f,-0.16010000f,0.16580000f,-0.00310000f,0.29609999f,-0.26849999f,-0.06700000f,0.20259999f,-0.28639999f,-0.30439999f,0.11240000f,-0.55239999f,-0.17159999f,0.67359998f,0.27370000f,0.81309999f,0.12049999f,-0.39699998f,-0.20799999f,0.52100000f,-0.19600000f,-0.29820001f,0.14790000f,0.38479999f,0.28069999f,-0.23419999f,0.09069999f,0.08230002f,0.83220000f,0.36270001f,-0.48460001f,-0.93310000f,-0.31260000f,-1.35010003f,-0.34070000f,-0.37270001f,0.60000000f,-0.25440002f,-0.40230000f,0.50080001f,0.67919996f,-0.00480001f,-1.14879996f,-0.10639996f,0.34929999f,-0.21660000f,0.51869997f,1.00940000f,1.21669999f,0.08059998f,-0.13670000f,-0.32360000f,-0.89479999f,-0.79540001f,-0.41359997f,-0.44929999f,0.49949999f,0.48890000f,-0.13980001f,-0.67470001f,-0.00779999f,0.63230001f,0.08420000f,0.23980001f,0.02070000f,0.37080000f,0.02479999f,-0.74909999f,0.01390000f,0.41630001f,-0.24319999f,-0.24030000f,0.31920000f,0.62310000f,0.00550000f,-0.41229999f,-0.17670000f,-0.25340000f,-0.20190001f,-0.97029999f,-0.11810000f,0.44679998f,0.15160001f,0.74220000f,0.34200000f,-0.27590000f,-0.11190000f,0.11560000f,-0.93690001f,-0.46850001f,-0.65699998f,-1.16680001f,-0.79880001f,-0.56700002f,0.20279999f,-0.68260001f,1.10959999f,-0.03400001f,-0.23689999f,0.23320000f,-0.08580001f,-0.63179999f,-0.09049997f,-0.59089999f,0.69089999f,0.84410001f,0.93349999f,-0.18020000f,0.03660000f,0.65560000f,-0.55949998f,-0.63290000f,0.61759996f,-0.11740002f,-0.79789997f,0.13220005f,-0.94719997f,-0.06410000f,0.08890001f,0.91940003f,0.08820000f,0.62619999f,0.03800001f,0.87860002f,-0.18920000f,0.22839999f,-0.19040000f,-0.86530002f,0.06290000f,0.12280000f,-0.17899999f,0.54149999f,0.24889999f,-0.43519999f,-0.06530000f,-0.70280000f,-0.19070000f,-0.65070002f,-0.09980000f,0.15380000f,0.00590000f,0.67429998f,-0.33359999f,0.04459999f,0.30790000f,0.22530000f,0.10040000f,0.00640000f,0.39060000f,0.36720000f,-0.29989998f,-1.22470001f,0.47299998f,0.96329999f,0.04089999f,0.38340001f,-0.06140001f,-0.73900002f,-0.78489996f,-0.00870000f,-0.95139996f,-0.73409998f,-1.04419996f,-0.41539997f,-0.32570000f,0.75360000f,0.75539997f,0.16539999f,0.55240000f,0.43640002f,-0.10230000f,-0.92180001f,0.31989999f,0.80800003f,1.28709997f,0.31430002f,-0.27509995f,-0.38160000f,0.07340000f,-0.64469999f,-0.08810001f,0.61349999f,-0.07660000f,-0.42679999f,-0.18450000f,0.35600001f,-0.02580000f,0.16710001f,0.24970000f,0.35020000f,0.18700000f,0.72459999f,0.23620000f,0.70540000f,-0.06909999f,0.50419998f,-0.16979999f,-0.50620000f,-0.13320001f,-0.36480001f,-0.02370000f,0.21920000f,-0.14110000f,-0.09170001f,-0.26630001f,-0.91679999f,0.28109999f,0.50210001f,-0.46420000f,-0.94320003f,-0.74039998f,0.39140002f,-0.76329997f,-0.58459999f,-0.08990000f,0.92310003f,0.54480000f,1.40470003f,0.53090000f,0.28670000f,1.27389999f,0.20350000f,1.00759997f,0.84690000f,-0.59179999f,-1.51020000f,-0.26900000f,-0.96610001f,0.27850001f,0.28910001f,0.46310000f,-0.46220001f,-0.25079999f,-0.78100002f,0.63689999f,-0.17790000f,-1.08759995f,0.39999999f,-0.00700000f,0.60700002f,0.07160001f,0.68649999f,0.19089999f,0.48750001f,-0.18690000f,0.48889999f,-0.05720001f,-0.57700001f,0.00270000f,-0.64360000f,-0.22750001f,-0.98480000f,-0.12400000f,-0.94039999f,-0.01459999f,0.80179999f,-0.06660000f,0.51540000f,0.05670000f,-0.47100001f,0.03810000f,-0.60870000f,0.13160000f,0.03100000f,-0.02730000f,-0.67680000f,0.28159999f,-0.79860002f,0.22719998f,0.75180002f,-0.15379999f,-0.94930002f,-0.60369998f,-0.62880000f,0.03579998f,0.00789998f,0.29680000f,0.61550001f,0.17240000f,0.80040003f,0.89139998f,0.87609999f,0.74259999f,-0.16720003f,0.17920000f,-0.90120001f,0.26660001f,0.43970001f,-0.67319998f,-0.22219997f,-0.43249996f,-0.23609999f,-0.01299999f,-0.83820000f,0.47850000f,0.28520000f,0.96739998f,0.08670001f,-0.34400000f,0.48470000f,0.13420000f,-0.08070000f,0.23530000f,0.20050001f,-0.26659999f,0.56829999f,-0.03320000f,-0.30240000f,-0.16760001f,0.14259999f,-0.11179999f,-0.83330002f,-0.11380000f,-0.60330000f,0.10080000f,-0.39760000f,0.12500000f,-0.62080001f,0.36520000f,-0.03519999f,0.40370000f,-0.40540001f,0.17459999f,-0.34399999f,-0.08770000f,-0.37490001f,-0.25260000f,0.12400001f,0.37739999f,-0.26540001f,-0.06429997f,-0.66869999f,0.09110002f,0.68670000f,-0.50220002f,-0.82320002f,0.27359999f,-0.30740002f,-1.16869995f,-0.32409998f,-0.32769998f,0.52440000f,-0.58439999f,-1.11710003f,1.03770001f,0.61630002f,0.25780001f,-0.51460000f,-0.06949999f,0.09940001f,0.22320000f,0.86150003f,-0.29290001f,-1.23260003f,-0.30000002f,-0.39250001f,-0.25060001f,-0.08630000f,-0.01180000f,-0.40329999f,0.26749999f,-0.50480000f,0.19209999f,-0.58039999f,0.01260001f,0.60090001f,-0.20560000f,0.16459999f,0.27430000f,0.75989999f,0.05050000f,0.24370000f,0.14640001f,0.40520000f,-0.17610001f,-0.84520003f,0.12940000f,-0.57420001f,0.22350000f,-0.43520000f,-0.13640001f,0.00849999f,0.00290001f,0.39720001f,-0.07640000f,0.54640002f,-0.14780000f,0.71390001f,-1.25999999f,-0.37740001f,0.05550000f,0.18430001f,0.47129994f,0.19009999f,0.23670000f,-0.43300002f,0.36159998f,-0.34070001f,0.59689998f,0.16039996f,-1.26159997f,-0.10879996f,0.11859997f,0.80300000f,0.55239998f,0.07450001f,-0.07130001f,-0.20210000f,0.17889999f,-0.28140002f,1.18889999f,-0.03730004f,0.02190001f,-0.58130001f,-0.88230000f,-0.70990002f,0.80769997f,-0.23010000f,0.21760000f,0.99960002f,-0.14350000f,0.25459999f,-0.38489999f,0.31900002f,-0.07790000f,-0.07850000f,-0.34360000f,0.37899999f,-0.40850000f,0.22699998f,0.21599999f,0.99210002f,-0.20420000f,0.28950001f,-0.12400000f,-0.36830000f,-0.02390000f,0.14830000f,-0.26250000f,0.40489999f,-0.18170001f,-0.97820001f,0.11730000f,-0.26620000f,0.09750001f,0.84730000f,-0.03609999f,-1.00630001f,0.22190001f,0.50610002f,0.40589999f,0.95930001f,-0.27929998f,-0.14710000f,0.26089998f,0.23209997f,-0.93390000f,-0.42840002f,-0.78419998f,-0.40420000f,-0.31420002f,0.41380001f,-0.16189999f,0.49790001f,-0.16449998f,-0.58180002f,0.45159999f,-0.59370002f,-0.65180000f,0.64750001f,0.04009999f,0.52120000f,-0.01260000f,-1.21990006f,-0.49590000f,-0.65440001f,-0.25089998f,0.00270001f,0.10530000f,-0.52640001f,-0.16430000f,-0.14690001f,0.16250000f,-0.03710000f,-0.25609999f,0.26899998f,0.10310000f,0.88140003f,0.06980000f,0.78069999f,-0.06980000f,0.50880002f,0.03630000f,0.08280000f,0.32890001f,-0.53200001f,-0.12080000f,-0.22480000f,-0.00780000f,0.75190000f,-0.08530000f,0.12300000f,0.05860000f,-0.06019999f,-0.05410000f,0.73810001f,0.32529999f,0.16979997f,-0.12360000f,-0.46630001f,-0.35620000f,0.43170002f,0.74290000f,-0.01970000f,0.52549999f,0.69650000f,0.28529997f,1.31720002f,-0.19610001f,1.18790003f,0.03740001f,0.68750000f,0.14459999f,-0.86470001f,-0.15370000f,-0.23290000f,-0.53110000f,0.08160002f,0.26399999f,-0.55720003f,0.50200000f,0.57150001f,0.41140001f,0.80580000f,0.04930000f,0.68280002f,0.26099999f,-0.67160001f,-0.11760000f,0.43719999f,0.01980000f,0.35200000f,-0.00450000f,-0.86120001f,-0.14950000f,-0.30850001f,-0.04169999f,-0.30349999f,-0.17189999f,0.56639999f,0.21419999f,-0.56799998f,0.00060000f,-0.12920000f,0.01450000f,0.15860000f,-0.04929999f,0.73269998f,-0.17360000f,0.11470001f,-0.03200000f,-0.54400002f,0.02860000f,-0.58780002f,-0.12090000f,0.18590000f,-0.01020000f,0.05609999f,-0.47959999f,0.32229999f,-0.16439999f,0.44460004f,0.97399998f,0.07009999f,-0.19519998f,-0.64759999f,-0.23699999f,-0.28120000f,-0.48889999f,0.12600000f,0.52489998f,0.04380001f,-1.02730000f,-0.86340002f,-0.06109999f,-1.20870001f,0.37179996f,-0.05820000f,-0.05900001f,0.29940000f,-0.11399998f,-0.25719999f,-0.76819999f,-0.91879999f,-0.13729997f,-0.33949998f,-0.93839995f,0.03380001f,-0.02960000f,0.61540000f,0.19560000f,-0.27660001f,-0.18320001f,-0.72759999f,0.12240000f,-0.01970000f,0.04020000f,0.19990000f,0.38290000f,-0.30909997f,-0.23890000f,-0.07130000f,0.13410001f,0.94120000f,0.19070000f,-0.30640000f,-0.25899999f,0.15950000f,-0.24019999f,0.60499998f,0.16599999f,-0.23389999f,0.03060000f,0.87670001f,0.24529999f,-0.38419999f,0.28399999f,-0.61400001f,-1.07499999f,-0.36859999f,-1.30159996f,-0.22219998f,-0.22150000f,-0.72790003f,0.04090000f,0.38760001f,-0.86839999f,-0.10389998f,-0.46029998f,0.36419999f,-0.06840003f,1.02510002f,-0.27860000f,-0.43320002f,0.24499999f,0.02529999f,0.30980002f,0.99640000f,-0.53939999f,0.14930000f,0.19170004f,-0.60389998f,0.07089998f,0.93170003f,0.78139999f,0.04349999f,0.31540001f,0.92400002f,0.17980001f,0.86850001f,0.23520000f,1.00059998f,-0.08810000f,0.49730000f,-0.06450000f,0.08090000f,0.19360000f,0.58140001f,0.24550000f,-0.03949999f,-0.20719999f,0.50520001f,0.15140000f,0.00140001f,-0.01980000f,-0.24359999f,0.03260000f,-0.48690002f,0.13660001f,0.31330000f,0.18429999f,-0.61800002f,-0.26930001f,0.48840001f,-0.15300000f,-0.56930001f,0.00859999f,0.44790000f,0.76010000f,0.44850001f,0.44280000f,-0.45950002f,0.45800000f,-0.06060000f,-0.39429997f,0.35990002f,0.20340000f,-0.23470001f,-0.10290000f,0.96440003f,-0.27539998f,-1.33650000f,0.13170000f,-0.47450002f,0.16309999f,0.69390000f,1.05629998f,0.21070001f,-0.55939997f,-0.06100001f,-1.10759999f,-0.56019999f,-0.07410000f,-0.86440000f,0.05660000f,-0.21700000f,-0.06550000f,0.19519999f,0.24510001f,0.13060001f,-0.42150000f,0.62330001f,-0.95520003f,-0.72399998f,-0.27360001f,0.42280000f,0.48510001f,-1.07669999f,1.25460001f,0.56899995f,1.47960003f,-0.41939998f,0.88920000f,0.88429996f,-0.59730004f,0.62000003f,-0.21960001f,-1.03240003f,-0.17759999f,-1.14599997f,0.97979999f,-0.44540002f,-0.21780005f,-1.81719996f,0.59189997f,0.88089997f,-0.28590000f,0.11970000f,-0.16770001f,0.04720000f,-0.49319999f,-0.14849998f,-0.33270001f,-0.03770000f,-0.30750001f,-0.73120000f,0.01650000f,0.88120002f,0.06720000f,0.36010001f,0.15140001f,0.86479998f,0.06899999f,1.04079999f,0.08770000f,-0.86970000f,-0.27680001f,-1.04660001f,-0.00369999f,0.96059998f,0.21500000f,0.62819998f,0.59900001f,-0.28270002f,-0.10410000f,-0.56730000f,-0.27699999f,-0.72569997f,0.48840003f,0.57520001f,0.77309996f,0.21809998f,0.95130003f,0.86329999f,1.17420003f,-0.13680001f,-0.97920005f,0.36200004f,-0.92220001f,-0.50609995f,-1.05150000f,0.38520001f,-0.47430001f,1.42999999f,0.00060002f,-1.57629998f,1.32300002f,-0.50380006f,-0.67050001f,0.91980000f,-0.89970000f,0.21220001f,-0.65279998f,-0.76170001f,1.08510001f,0.28969996f,0.49770000f,0.15029998f,-0.24170000f,0.87560001f,0.53309999f,-0.15970003f,0.28640001f,-1.10549998f,-0.06450001f,-0.56640000f,-0.35270000f,0.10459999f,-0.26659999f,0.11990000f,-0.24720000f,-0.19589999f,0.36440000f,0.15429999f,0.21430001f,-0.55369999f,-0.03670000f,-0.48679998f,-0.35320000f,0.06920000f,-0.19679999f,0.57690001f,-0.05660001f,-0.60789999f,-0.12700000f,0.64569999f,0.11150000f,0.15249996f,0.00149999f,1.41360002f,-0.77009996f,-0.76270001f,-0.28920002f,-2.20449999f,1.19640004f,0.49119997f,0.74100002f,0.82339999f,0.40289998f,0.48329998f,0.36450001f,-0.15689998f,-0.83700000f,-0.44350000f,-0.37920002f,-1.34749999f,0.99240000f,0.39399998f,0.76140002f,0.78280000f,-0.65700004f,-0.02369997f,0.89370003f,0.00070001f,-0.21870000f,0.79670000f,-0.32789999f,-0.62789997f,-0.09880000f,-0.21870001f,0.20080000f,0.29550000f,0.00520000f,0.67490000f,0.08730001f,0.36079997f,0.19820000f,-0.30020000f,-0.35660000f,0.52560001f,0.00870000f,0.00720000f,0.11349999f,-0.68449998f,-0.46010000f,-0.22399999f,0.43279999f,-0.33570002f,0.25799999f,-0.36590003f,-0.11590001f,-0.59179997f,-0.38720001f,-0.95710000f,0.43790000f,0.27579998f,-0.33210001f,-0.29489999f,0.62760001f,0.33429997f,-0.69990001f,-0.16909998f,-0.71850002f,0.31230003f,-1.19520003f,-0.86000001f,-0.57089998f,-1.14259996f,-0.17130003f,0.36680001f,0.77820001f,1.10239996f,0.48450001f,-0.51870000f,0.85530000f,0.22440000f,-0.22919997f,-0.46790002f,0.43590003f,0.19469994f,0.76800000f,-0.21059999f,1.42020003f,-0.32330002f,-1.06500002f,-0.44060002f,0.59970002f,-1.11179998f,0.33149999f,-0.14170000f,0.25080000f,0.24369999f,0.25499999f,0.14850000f,-0.00679999f,0.47200002f,-0.06530000f,-0.13940000f,0.15880000f,0.56479999f,0.14390000f,0.31119999f,0.25690000f,-0.60919998f,-0.48710000f,-0.25050001f,0.22639999f,-0.93019998f,-0.22320000f,-0.17539999f,0.12299999f,-0.73379998f,0.17020001f,0.15830000f,0.28610000f,-0.70449999f,0.39350000f,-1.38060000f,-0.24179998f,-0.22750000f,-0.09359999f,0.62869999f,-0.63299998f,-0.29769997f,-1.27110007f,-0.85879997f,-0.02670001f,-0.38100000f,-0.88620000f,0.04400003f,-0.44489999f,0.14920001f,0.20700001f,-0.59319999f,0.93630000f,0.25449997f,-0.32249999f,-1.98139995f,0.40949999f,-0.02740000f,0.53580001f,-0.53180000f,-0.74040003f,-0.52509999f,-0.02880000f,-1.07030000f,-1.03200003f,1.13569997f,0.23619999f,-0.23299999f,-0.02390000f,0.75890000f,-0.20490000f,1.06019998f,0.18970000f,-0.25970000f,-0.13560000f,-0.30499999f,-0.36989998f,-0.01689999f,0.33950001f,0.69940000f,0.48839999f,0.16159999f,-0.18450000f,-0.07969999f,-0.09590001f,0.18240000f,0.12749999f,-0.73709998f,0.11970001f,-0.24299998f,0.01269999f,-0.08210001f,0.21220000f,-0.99359999f,0.03119999f,1.71589996f,0.24090001f,0.15579999f,-0.51720002f,0.71990002f,0.32399998f,2.25899993f,-0.06239999f,-0.36950000f,1.05930000f,0.72379997f,0.46859996f,0.19169999f,-1.01490003f,0.33300000f,-0.78179997f,-0.21039996f,-0.22230002f,-0.67389998f,0.24180001f,0.57680001f,-0.40589998f,-1.83809994f,-0.58110003f,-1.13659997f,0.75900002f,0.90809995f,-0.26850000f,-2.04519999f,0.56970000f,0.72520000f,-0.13930000f,0.76419997f,-0.05050001f,-1.02590001f,-0.16340000f,-0.03570000f,-0.25100000f,-0.03190001f,0.32639999f,0.67829999f,-0.01720000f,-0.25319999f,-0.06640000f,-0.46280000f,-0.16769999f,1.16470000f,0.27060000f,0.19719999f,0.16010000f,0.50489998f,0.23830000f,0.25160000f,0.26900002f,1.27139997f,0.27159999f,-0.46520000f,-0.04440000f,-0.54899998f,-0.20420000f,-0.14359995f,0.08970002f,1.43859997f,0.44940002f,-1.41450001f,0.51689999f,0.45969997f,0.16590000f,-0.12010001f,-1.03650000f,0.24730001f,-0.12420000f,-0.68039997f,-0.10650000f,-1.11679998f,0.05639999f,2.13250000f,-1.01700001f,-0.71799998f,-0.43020000f,0.56189999f,-0.92250002f,-0.51919998f,-1.35240004f,0.88779998f,-0.46859997f,-1.23479996f,0.47220000f,-0.45579999f,0.51420001f,0.20450000f,0.23360000f,-0.74369999f,-0.24130000f,0.17679999f,-0.25120000f,-0.30659999f,-0.18829999f,0.10150000f,0.07020000f,0.11399999f,0.51570000f,0.02840002f,-0.12010000f,-1.13349997f,-0.17010000f,0.88990002f,0.08600000f,-0.05940000f,0.02880000f,-1.03589998f,0.20830001f,-0.38290000f,-0.05320000f,-0.36110000f,-0.05370000f,0.89890001f,-0.15000000f,0.63850002f,-0.07360001f,-0.44529998f,-0.53160001f,-1.90309999f,-0.14790001f,-0.14120000f,0.98219998f,0.48099996f,-0.42060002f,-0.60349998f,-0.90210000f,-0.94959997f,-0.66750000f,-0.27759997f,0.84480000f,-1.15409999f,-0.32910003f,1.06530003f,-0.30510000f,-0.43859998f,0.18600001f,-1.70769997f,-0.72600003f,-1.50550001f,0.03270000f,-0.71250000f,-0.22530001f,1.36030003f,-0.45600003f,0.42750003f,0.87000004f,0.55349999f,-0.00470000f,-0.61100000f,-0.16869999f,0.45110002f,0.27809999f,-0.74409999f,0.23030000f,-0.14180000f,-0.35189999f,0.15770000f,-0.06070000f,-0.37660000f,-0.32770002f,-0.66359999f,-0.45069999f,-0.33079998f,-0.42650000f,-0.52209999f,-0.05740000f,-1.07429999f,-0.31419999f,0.77329998f,-0.30870000f,0.02800000f,-0.01280000f,-0.35329999f,-0.04629999f,0.25389999f,0.42800001f,-0.16470001f,0.54810001f,-0.42460001f,-0.51600003f,-0.03869994f,-0.29519998f,-1.52509997f,0.30990002f,0.42059998f,0.61799998f,0.75629998f,-0.10380002f,-0.94020000f,1.18170003f,-0.01920000f,0.93989998f,0.14639999f,0.91260000f,-0.23270001f,0.55800001f,-1.36530000f,0.18779999f,1.39109998f,0.39510000f,0.24679999f,-0.28080001f,-1.08549998f,-0.96900004f,-0.90630001f,-0.83070003f,-0.18769998f,-0.02539999f,0.71510002f,0.11710001f,0.49109999f,0.44279998f,-0.33240000f,-0.48980000f,0.29980003f,0.10610000f,0.44649998f,-0.53870000f,0.25679998f,-0.12310000f,0.21240001f,-0.01519999f,0.65600001f,-0.11430000f,0.55130000f,-0.29920001f,-1.05229998f,0.13600000f,0.87309999f,0.21030001f,0.15429999f,-0.37230000f,0.61450002f,0.25790000f,0.30880000f,0.12950000f,-0.71149996f,-1.05690005f,-0.11429995f,-0.72990002f,0.07050000f,-0.19799998f,-0.40680000f,0.66809999f,0.94140003f,0.03270000f,1.02869996f,0.43530000f,0.47959997f,-0.05910001f,0.18640002f,-0.79440004f,0.14720003f,-0.21240002f,0.63790000f,1.33139999f,-0.52890003f,-1.33710000f,-0.01229995f,-0.80070002f,-0.57029999f,0.39989997f,1.31190000f,-1.02300001f,-0.52559997f,-0.19049999f,-0.60239999f,0.14300000f,-0.53899999f,0.25760001f,-0.76300001f,-0.04360000f,-0.58089999f,0.09810000f,-0.76760001f,0.00839999f,0.65929998f,-0.27480000f,0.43509999f,0.06660000f,0.17580001f,-0.12550000f,0.30570000f,-0.02449999f,-0.09670000f,-0.40460000f,0.57700002f,0.12560000f,0.87570000f,0.11790000f,0.89409999f,-0.35679999f,0.42289997f,-0.00840000f,-0.33249999f,0.02820000f,0.21599999f,-0.30150000f,-1.29339997f,-0.18630000f,-1.43420002f,1.25070000f,0.56249995f,0.49830003f,-0.67760002f,-0.01049998f,1.26709998f,-0.08970001f,0.39930000f,-0.56910002f,-0.37299998f,0.61530002f,1.29830000f,-0.62730004f,-1.08410000f,0.34229997f,1.12260002f,-0.47850001f,1.17070000f,-0.69630002f,0.89549999f,0.64800000f,1.30389995f,0.01619999f,-0.62869998f,0.25200000f,-0.07120000f,-0.22470000f,-0.59659998f,-0.25980000f,0.54620000f,0.36020000f,0.13449999f,-0.15839999f,0.08340000f,0.18730000f,-0.14969999f,-0.09440000f,0.20800000f,0.15240001f,0.77490000f,0.01420001f,0.75679998f,0.50279999f,-0.46199999f,0.18140000f,0.11250000f,-0.03910000f,0.87139996f,-0.05350000f,0.25120001f,0.06010000f,0.68370000f,-0.18709999f,0.17379999f,-0.21960000f,-0.82159999f,0.76620001f,-0.34739998f,0.03419999f,0.80260001f,-0.60059997f,-0.15889997f,0.45929997f,0.61539996f,0.16080001f,0.14930000f,-0.12180001f,0.12400001f,-1.24560003f,-0.05609997f,-0.34290000f,1.00120000f,-0.31440000f,-0.74920001f,-0.67020001f,-0.50329998f,-0.26760000f,1.26539996f,-0.45570001f,-0.20839996f,-1.03950001f,-0.05249996f,0.52349998f,0.84579996f,0.09119998f,-0.02840000f,0.14080000f,-0.16410000f,-0.17650000f,0.75159999f,0.16250001f,0.71529999f,-0.42960000f,-0.05289999f,-0.04819999f,-0.82629999f,0.03649999f,-0.09060004f,-0.13260002f,-0.20710002f,-0.04310000f,0.48450000f,-0.02330000f,0.35840001f,-0.00040000f,0.60099999f,-0.13959999f,-0.42210001f,-0.14239999f,0.99309997f,0.11860000f,-0.38800000f,0.28010000f,0.72089999f,-0.25819999f,-1.33279998f,0.61020002f,0.69089997f,0.50939998f,1.95319994f,-1.24980004f,-0.16530000f,0.62970000f,0.27690002f,0.41640001f,-1.07249999f,0.87210006f,1.07579994f,1.08540006f,0.95229998f,-0.55770001f,0.11230002f,-0.88050000f,-0.55559994f,-0.15330001f,0.94659998f,1.07490001f,0.51489993f,0.25409998f,2.10449993f,-0.05580000f,-0.68960001f,-1.25670001f,-0.02889998f,-0.36270004f,0.30080000f,-0.16870000f,0.11400000f,0.05040001f,0.85290001f,0.05040000f,-1.10639999f,-0.27420000f,-0.48529999f,-0.19960000f,0.66920001f,0.07369999f,-0.17529999f,-0.17580000f,-0.74869999f,-0.08329999f,-0.24420001f,0.01870001f,1.02379999f,-0.41209999f,0.80820001f,0.28370000f,-0.26819999f,-0.39360000f,0.77149999f,-0.17599999f,0.07640001f,-0.07510000f,-0.70389999f,0.46389999f,-0.83479998f,0.53160001f,0.76279999f,-1.17060005f,0.08110003f,0.14970000f,-1.86919999f,1.19340000f,0.40249996f,-0.14640002f,0.85880001f,0.60120001f,0.57969998f,0.84510001f,-0.47530000f,0.72810000f,0.44219994f,-0.52740001f,1.26580000f,0.36059996f,1.58539998f,-0.25140001f,-0.53980000f,0.33480002f,1.50010000f,0.77759998f,1.02279996f,0.16470000f,-1.21609999f,-0.80639998f,0.72059998f,0.10830000f,0.90899997f,-0.25410000f,-0.02020000f,0.36620002f,0.76520000f,0.11470000f,0.02320000f,-0.24430001f,-0.95749998f,-0.24680001f,0.17810000f,0.46380000f,0.46639999f,-0.27530000f,-0.11039998f,-0.29320001f,-1.26930000f,-0.05760001f,0.67320001f,-0.15830000f,0.04900000f,0.09860000f,-1.11650001f,-0.31609999f,-0.34229999f,-0.18319999f,0.63930001f,0.27349999f,0.12340000f,-0.56340000f,1.09739997f,0.92850000f,0.95579996f,-1.29330005f,0.10480001f,0.53670001f,0.92039998f,1.01190001f,-0.72570001f,0.83580004f,1.21830000f,-1.06680000f,-0.04559999f,0.07229998f,-0.42919997f,1.37640003f,-0.87830004f,-0.09540000f,1.10040001f,0.27390001f,0.29220001f,0.32070002f,-1.59630002f,0.66959997f,-0.09570002f,-0.50520003f,0.32270003f,-1.10490000f,-0.33570001f,-0.23190001f,-0.59389999f,0.13020000f,0.58149999f,-0.44540000f,0.41290003f,-0.17450000f,0.89859999f,0.03190000f,0.88470001f,0.43259999f,-0.31900000f,-0.06090000f,0.13300000f,-0.17530000f,0.40860000f,-0.41250000f,0.52610002f,-0.21420000f,-0.08220000f,0.02280000f,0.45879998f,-0.10600001f,0.54619999f,-0.18100001f,-0.52429999f,0.34360000f,-0.52999998f,-0.37790001f,-0.03390001f,0.06939999f,0.23980001f,-0.64060002f,-0.46450001f,0.86690001f,-0.97690002f,0.28689999f,-0.34209997f,0.50009999f,0.58199998f,-1.09960000f,1.31739997f,-0.13110004f,1.59330000f,-0.61119999f,0.87850000f,0.32210001f,-0.70109999f,0.21860002f,-0.14300004f,0.99690000f,-0.13129999f,0.33820002f,1.04759998f,1.17890000f,-0.11930007f,-0.36739998f,0.55469999f,0.07820000f,-0.15930000f,0.00460000f,0.22580001f,0.67650002f,0.19830000f,0.09270000f,0.34290001f,0.23020001f,-0.09340000f,0.24300000f,0.28980002f,0.35450001f,-0.08089999f,-0.01860002f,0.24540000f,-0.35700000f,0.59820001f,0.25130000f,-0.65450001f,0.20980003f,-0.27460002f,0.01219997f,0.46660000f,-0.16280001f,0.12320000f,-0.79470003f,-0.47970002f,-0.28009999f,-0.01150001f,0.56720000f,-0.68429998f,-0.42830001f,0.47910003f,0.29460003f,0.77069998f,-0.64390001f,0.94720003f,-0.19050001f,1.25050001f,0.50990001f,-1.08590001f,0.95159999f,-0.96789998f,0.25919999f,-1.14979997f,-0.75039997f,-0.59059999f,0.89509996f,0.10160000f,-0.12519998f,1.43739999f,-0.08130001f,-0.78389997f,0.11680000f,-0.96679998f,-0.24780002f,-0.59570003f,-0.85449999f,1.15339998f,0.64199998f,-0.01210002f,0.11599999f,0.66520002f,-0.61089999f,-0.42950001f,0.11970000f,-0.94770002f,-0.46180000f,0.02980000f,0.22680000f,0.37080001f,0.27049999f,0.25150000f,0.42150000f,-0.00029999f,-0.31930000f,-0.21350001f,0.06890001f,-0.56570001f,-0.41460000f,0.01140000f,0.23120000f,0.35200001f,0.67290000f,0.19110001f,-0.22609999f,-0.11589999f,0.13069999f,0.40570000f,0.14850001f,-0.31280001f,-0.44970000f,-0.10849997f,-0.00850000f,-0.73139999f,1.13119999f,-0.15430006f,-1.16990001f,1.26790001f,-0.40210001f,0.71790003f,-0.08040000f,0.37930000f,0.34979998f,0.37650002f,0.19280001f,-0.84290001f,0.77050001f,-0.31020004f,-0.99769999f,1.05449996f,-0.38960002f,0.74240003f,0.97800001f,-0.73830000f,-0.60320002f,0.96710000f,-0.09520001f,-0.29929997f,0.66229998f,-0.26109999f,-0.12710000f,0.07669999f,-0.10470001f,-0.05010000f,0.17990000f,0.23410001f,0.51540001f,-0.18420002f,0.12000000f,-0.44760000f,0.71300001f,0.34180001f,-0.62300000f,0.29900000f,-0.28169999f,-0.33390000f,0.57360000f,0.17160001f,-0.69049999f,-0.35350001f,-0.76330000f,-0.11870002f,0.00520001f,-0.14919999f,0.35410001f,-0.16690001f,-0.38640000f,-0.21120001f,0.21740000f,0.64679996f,-0.52519999f,0.65290000f,0.24820000f,-0.72890001f,0.35700000f,-0.80029998f,1.37350003f,-1.24269999f,0.81999998f,-0.53279999f,0.66200001f,-0.25059998f,-1.41069998f,0.78589998f,-0.28290000f,0.57139997f,0.15149999f,0.86390001f,-0.43279999f,-0.17090001f,-1.04939998f,0.49489999f,-0.22650000f,0.83509997f,-0.08840001f,1.51970001f,0.21610003f,-1.08270002f,-0.38370002f,-0.61780000f,-0.53949998f,-0.20930000f,-0.66390002f,0.13830000f,-0.20870000f,-0.13689999f,0.74180002f,-0.12620000f,0.25260001f,-0.11220000f,-0.00360001f,0.08280001f,-0.17160001f,0.06000000f,-0.45500000f,-0.38740000f,0.59070002f,0.18329999f,0.19680003f,-0.82680000f,0.31800000f,0.03120000f,-0.31779999f,-0.35180000f,0.07350000f,-0.16710001f,-0.29349999f,-0.54890001f,-0.38750000f,0.69569997f,-0.36789998f,-0.21060001f,-0.90280000f,-0.10790001f,0.16459998f,-0.64209998f,1.63900004f,-1.33680003f,0.42630001f,-0.01510000f,0.34399999f,-0.94919998f,-0.05450001f,-0.47609999f,-0.31810001f,0.29049996f,0.12370002f,0.94720002f,1.13499999f,-0.21060002f,0.17179999f,0.42100000f,-0.33620000f,0.62919996f,0.59300001f,-0.75630002f,0.13870000f,0.06439996f,0.08250004f,0.73590000f,-0.63159999f,-0.09200000f,0.05069999f,0.37410001f,-0.31920001f,0.92400000f,-0.27190000f,-0.22490000f,-0.32400001f,0.17640000f,0.54249999f,0.17750000f,-0.41300002f,0.12860000f,-0.66520002f,-0.19159999f,0.65910002f,-0.13710000f,-0.05140000f,0.23140001f,0.39690002f,-0.71009999f,0.28700000f,-0.40580000f,-0.57029999f,0.22469999f,0.22340002f,-0.85340001f,-0.05249997f,-0.43949997f,-0.81679999f,0.28199997f,-0.02410000f,-0.60779999f,-1.37429996f,0.19890001f,-0.10730000f,-0.02400001f,-1.06420000f,1.09659998f,0.29190000f,0.45519998f,-0.14369999f,-1.08430002f,-0.28240003f,-0.78119999f,1.04630000f,-0.22579999f,-0.38530001f,0.21890002f,1.31909998f,-0.32160000f,0.99490000f,-0.55370003f,-1.26989998f,0.77660000f,1.16600001f,-0.14980003f,0.04980001f,0.11440001f,-0.13980001f,0.61140000f,0.32350003f,-0.59710002f,0.01650000f,0.17430000f,0.49590001f,0.04770000f,-0.35350000f,0.10510001f,0.27200000f,-0.23599999f,0.48900002f,-0.38460000f,-0.25910004f,0.89990002f,0.02280000f,-0.24600000f,-0.32530001f,0.21010000f,-0.00080000f,-0.16840000f,-0.28820004f,0.43219999f,-0.04799999f,-0.53520000f,0.03700001f,-0.23140000f,0.18000000f,-1.22399997f,-0.76129999f,-0.00149995f,0.71970001f,0.56480000f,-0.38119999f,0.51729999f,0.49400001f,0.15750002f,-0.03859998f,-1.10449999f,0.60719998f,-0.09840000f,1.00060000f,-0.06000000f,-1.15070002f,-0.08099997f,0.73220000f,-1.03460000f,-0.38609999f,-0.48179999f,0.58870000f,-0.94690001f,-0.09859999f,-1.49240000f,0.64079997f,-0.40719999f,0.02719999f,0.53539998f,-0.09860001f,-0.00310000f,0.24070003f,-0.76630001f,0.60240001f,0.08519999f,0.01540001f,0.15019999f,0.72410000f,-0.07610000f,0.46300001f,-0.25780000f,-0.74800002f,-0.24919999f,0.24510001f,-0.52590000f,0.18950000f,0.54850002f,0.05840000f,-0.16280000f,0.33970001f,-0.70690000f,0.25890002f,-0.56850002f,0.29590002f,-0.25630000f,-0.17630002f,0.59030002f,0.37250000f,0.31150002f,-0.60060001f,-0.47189997f,1.23520002f,-0.44210003f,0.74230000f,-0.18209997f,-0.58279998f,1.01259997f,1.16709998f,-0.44639998f,1.23439999f,-0.92019997f,-0.38830001f,-0.64950004f,0.37049998f,0.97239997f,-0.09689999f,-0.44019999f,0.36299999f,-0.29700000f,0.96319998f,0.30409998f,1.17410003f,-0.67980004f,0.58020000f,0.07010000f,-0.63770001f,-0.32999998f,0.40200000f,-0.53950000f,-1.59280001f,0.04289999f,-0.08420000f,-0.25060001f,0.56369999f,0.14910002f,-0.04829998f,-0.67890000f,-0.71900002f,0.00260000f,0.29109999f,0.36410000f,0.42720002f,-0.31920001f,0.23720003f,-0.03919999f,0.54280001f,0.12320000f,0.60730002f,-0.03130000f,0.28250002f,-0.59210001f,0.20249999f,0.66150000f,0.42720002f,0.18120000f,0.43510001f,-0.37030000f,0.72130002f,-0.17410002f,-0.50440003f,-1.04040001f,-0.14230000f,0.62109999f,0.81269997f,-0.58039999f,0.68589999f,-0.20080001f,-1.04250001f,0.34129999f,-0.25769999f,0.58780000f,0.86430001f,-0.06650001f,-0.23370000f,1.24950002f,0.11610000f,0.96169999f,0.34690001f,0.95660001f,0.61260000f,0.67949998f,-0.42780000f,0.08710003f,0.18050002f,0.37930001f,1.00400000f,-0.24530000f,1.51230003f,-1.00960000f,-0.07340001f,-0.21169999f,0.49250000f,0.13750001f,0.01629999f,0.08810000f,-0.74039998f,-0.33960000f,0.50999999f,0.49440002f,-0.51950000f,0.34309999f,0.83000001f,0.37599999f,0.22960000f,0.14120001f,0.29760000f,0.19200001f,0.14550000f,0.33690001f,0.26050003f,-0.27490001f,0.23369999f,0.14430001f,0.02510000f,-0.19430001f,0.26450000f,0.62470002f,-0.00140000f,-0.16420000f,0.27310002f,-0.17970001f,0.99240000f,-1.14830000f,0.28950000f,-0.78540000f,-0.52199998f,-0.13920002f,-0.12600002f,0.61520002f,-0.96629998f,-0.01060000f,0.48770001f,0.38210005f,0.18730000f,-0.08990000f,0.57680000f,-0.87600000f,-0.01849999f,-0.28179999f,-0.06599997f,1.44529996f,0.79859998f,-1.44009996f,0.58590001f,-0.81460001f,-0.41909999f,0.31580001f,0.63210000f,-1.05370000f,1.04870002f,-0.01780000f,0.17360001f,-0.52280000f,-0.07240000f,-0.65120002f,-0.54630001f,0.03869999f,-0.21080000f,-0.39040001f,-0.36370000f,0.48970000f,0.50090000f,0.30190000f,0.18280001f,-0.08559999f,-0.33270002f,0.46590001f,0.59290001f,-0.30850001f,0.40680000f,0.57600002f,-0.40250000f,0.47090001f,-0.22630000f,0.40270001f,0.13849999f,0.57429999f,0.18510000f,-0.24270000f,-0.03599999f,1.20150000f,0.82519998f,-0.23720002f,0.57940000f,-0.08980003f,-1.30859999f,1.32549996f,-0.15110000f,0.59369999f,-0.88299999f,-0.08309997f,0.39540001f,-0.15369997f,0.57440000f,-0.59080000f,-1.12150002f,0.58100002f,1.30990002f,-0.62440002f,-0.17159999f,0.26000001f,-0.69139998f,-0.57350000f,-0.30809997f,-0.79599999f,-0.64879999f,0.58850003f,0.43839999f,0.05269999f,0.03420000f,-0.31380001f,0.27200000f,-0.14959999f,0.31020000f,0.43140001f,-0.48030002f,-0.13889999f,-0.01480000f,0.24159999f,-0.49630001f,-0.05810000f,0.21080000f,0.11320000f,0.17609999f,0.10470000f,-0.17420003f,0.43700000f,-0.72679999f,-0.48280001f,0.01690000f,-0.17530000f,-0.16440001f,0.55319999f,0.34560000f,0.01800001f,0.28930000f,0.11750001f,-0.04300000f,0.33459999f,0.13759999f,-0.65710002f,0.10589998f,0.82790000f,-0.01580000f,-0.03999998f,-0.18620003f,-0.60209999f,-0.45259998f,0.44619998f,-0.64090001f,0.18919998f,0.21880000f,-0.15119999f,0.71880000f,-1.33589999f,-0.44240002f,-0.42939997f,-0.32199998f,-0.23920005f,0.49660000f,-0.67970000f,-0.56969998f,-0.36889997f,0.63009999f,-0.49109999f,0.74970000f,-1.12259997f,-0.60109998f,0.49949999f,-0.31479999f,-0.39520001f,-0.72170001f,0.10250000f,-0.36580000f,0.76180000f,0.18669999f,0.05809999f,0.58209999f,0.21350001f,0.23690000f,-0.46010001f,-0.71020000f,0.26019999f,-0.40350000f,0.25950000f,0.27449999f,0.15390001f,0.54200001f,-0.06319999f,-0.20160000f,0.39240000f,-0.26390001f,0.09469998f,-0.38070002f,0.84509999f,-0.03680000f,-0.31600001f,-0.09510002f,0.05550000f,0.56710000f,-0.98610001f,-1.27800000f,0.64229998f,-1.37589995f,0.42190000f,0.77550002f,-1.33300001f,0.23219997f,0.61870002f,0.50579997f,0.50949999f,-1.52910000f,0.89310004f,-1.24940001f,1.11230003f,0.46929999f,-0.61939998f,1.14869999f,-0.93049997f,-0.52699998f,-0.22139999f,-0.92419999f,1.12509998f,-1.34699997f,0.13910001f,0.26260000f,-0.00700002f,0.43129999f,-1.33419999f,0.57040000f,-0.17560000f,-0.06180000f,0.29220001f,0.32329999f,0.19510001f,0.35300002f,-0.77420001f,0.00390001f,0.09690000f,0.23800000f,0.45320001f,-0.54670000f,0.09310001f,0.17430001f,-0.23550000f,-0.22820000f,0.09499998f,-0.18560004f,0.56720001f,0.28759999f,0.75640001f,-0.34920000f,-0.30600000f,0.28229999f,0.71850001f,-0.21320001f,0.35720000f,0.43010002f,-0.46250001f,-0.55730001f,-1.09929999f,-0.59050000f,0.51530001f,0.78520001f,-1.27430001f,1.05700000f,0.27639997f,-0.65019999f,1.24449999f,-0.03880000f,-0.23279999f,-1.04809999f,0.63079998f,0.02359999f,0.92709999f,-0.71489998f,0.75809998f,-0.48470002f,-0.64509998f,-0.48909998f,0.25250000f,-0.04089999f,-0.20890003f,-0.44960002f,0.23150006f,-0.95359999f,0.76759998f,0.86770000f,0.24019999f,-0.09190001f,0.20259999f,-0.31320000f,0.46440000f,-0.08900000f,0.34460000f,-0.29860003f,0.07180000f,-0.70200002f,0.21600000f,0.32290004f,-0.32650000f,-0.14110001f,0.45790001f,-0.54920001f,-0.07000000f,0.66840001f,-0.04559999f,0.32710004f,-0.42070002f,-0.14640000f,0.47040002f,0.14580000f,0.14580001f,0.11050002f,-0.71890002f,0.43150001f,0.00769999f,0.49010000f,0.29470001f,-0.03590000f,-0.98539998f,-0.53429997f,-0.66389997f,-0.86009999f,0.92650000f,0.18160000f,-1.37140003f,-1.31970001f,0.54589998f,0.20970002f,1.11499998f,-0.98160002f,0.81130004f,-0.11100000f,-1.10420000f,0.83590000f,0.07030000f,0.12520002f,1.51509999f,-0.55559999f,-0.17399998f,-0.07950001f,0.26270002f,0.62520001f,0.45289999f,0.20970002f,0.69719998f,0.58640000f,-0.59109999f,0.58149998f,-0.31510001f,0.12470001f,-0.06710000f,-0.42810002f,0.33450000f,0.82690002f,0.33950002f,-0.15500003f,0.72740002f,-0.24710001f,0.51350002f,-0.63619999f,-0.37180000f,0.32780001f,-0.02180000f,0.82920002f,0.00600001f,0.68430000f,0.42450002f,0.07340000f,0.18580000f,0.15319999f,0.12040000f,-0.45960001f,0.62160001f,0.08130000f,-0.07409999f,-0.17379999f,-0.59300001f,0.24350000f,-0.44880001f,-0.28530001f,0.07410000f,0.26430001f,-0.60750002f,0.76560002f,0.47069999f,-0.12000000f,0.04830000f,-0.02430000f,0.61200000f,-0.82499999f,-0.52619998f,-0.88080002f,0.31109999f,-0.89940000f,-0.35099998f,0.01590000f,-0.03420001f,0.61320003f,0.27300001f,0.32639999f,0.79590000f,-0.66780000f,0.50520003f,0.62940003f,1.02089998f,-0.76469998f,-0.26009998f,0.34110001f,0.61200001f,-0.48260001f,-0.49840004f,0.14730005f,-0.75089999f,-0.77670000f,-0.93950005f,-0.48800000f,-0.98460004f,0.79740002f,0.73720004f,1.12939998f,0.81300001f,0.56029998f,0.82130001f,-0.48089997f,0.21130001f,0.72239995f,0.21859999f,-0.50139997f,-1.04980003f,0.18789998f,0.41630001f,0.35729999f,0.73630001f,-0.19480004f,0.74720002f,-1.09489998f,-0.92330002f,0.46149999f,0.68939999f,-0.50280002f,-0.26730000f,-0.83069998f,0.31590002f,-0.92370003f,-0.35459999f,-0.76500002f,0.15750001f,0.36960001f,0.04769999f,0.59399998f,0.49319998f,0.51450000f,-0.13110001f,-0.06510000f,-0.83069999f,0.44999999f,0.84569998f,-0.71820000f,0.29580004f,0.08070001f,-0.35880001f,0.54270000f,-0.15810001f,0.99780002f,-0.16440002f,-0.64830000f,-0.35819998f,-0.31350000f,0.27940001f,-0.28649999f,-0.23330001f,0.07789997f,0.82629999f,0.95479998f,0.57240004f,-1.41940000f,-1.02880005f,-0.48440000f,-0.77140004f,-0.11729998f,-0.44029999f,0.25349999f,-0.32430002f,0.33940000f,0.80220002f,0.71220000f,0.51960003f,-1.20699998f,-0.84800001f,-0.48140001f,-0.78260004f,1.15380001f,0.48300003f,-0.82810001f,-0.72390004f,0.05229999f,0.04529999f,0.64129997f,-0.34709998f,-0.54690001f,-0.53400000f,0.99329999f,-0.03780000f,0.90300003f,1.04339999f,-0.71160002f,-0.56969999f,-0.83700002f,-0.23970000f,-0.52889999f,-0.04889999f,-0.34290001f,0.32850000f,0.80040001f,0.01920000f,0.67740002f,0.64410000f,-0.57239999f,-0.48749999f,-0.83700002f,-0.22020000f,0.12960001f,0.48239999f,-0.45210002f,-0.18930000f,-0.20130001f,-0.24810001f,0.46469998f,-0.38720001f,-0.64439999f,-0.56360001f,0.39789999f,0.62250002f,0.57330000f,0.53350001f,1.58220002f,1.07960004f,0.83329996f,0.64270000f,0.76410003f,0.01190001f,-1.49239997f,-0.75740001f,-0.46790000f,-0.29510001f,-0.01790000f,-0.80990002f,-0.44760001f,0.33639999f,-1.15389999f,-0.31530002f,-0.43859998f,-0.61000001f,-0.46420000f,-1.17420004f,0.41720001f,0.99940004f,-0.42310001f,-0.14790001f,-0.44819999f,-0.25619999f,0.53070001f,0.03569999f,0.25410000f,0.01589999f,0.81840002f,0.76410001f,0.70109999f,0.59789998f,-0.32130000f,0.31830001f,-0.60420000f,-0.92069998f,0.00390000f,0.01680000f,-0.84030001f,0.24180000f,0.59219999f,-0.24179999f,-0.01710000f,-0.60569998f,-0.39720000f,0.05970000f,-0.90120002f,0.30840002f,0.96660003f,-0.01589999f,-0.77310003f,-0.28130000f,-0.34840000f,0.29379999f,-0.82560001f,0.04960000f,0.28059997f,0.59739999f,1.87230004f,1.11930007f,0.39610001f,0.05530001f,0.56619998f,0.73460001f,0.06709999f,0.36670000f,-0.44800001f,-0.03340000f,-0.06169997f,-0.88410002f,0.99409998f,0.55750001f,0.07650000f,-0.37130000f,-0.53619999f,-0.33220000f,0.71680001f,0.69320004f,0.01660000f,0.22120001f,0.30900003f,0.70440002f,0.45239999f,-0.24569999f,0.11220000f,-0.70380001f,0.57839998f,0.01979998f,0.77010003f,0.91590000f,0.04530000f,0.33180000f,0.52739999f,0.01859998f,0.29070000f,-0.15720001f,0.27180000f,-0.05250001f,-0.90750001f,0.23640003f,0.81269999f,0.99929999f,-0.37290000f,0.20250000f,-0.00780000f,-0.00360000f,0.60660002f,0.30840000f,0.51660001f,0.27030000f,0.84300003f,0.01880000f,-0.87449999f,-0.15990000f,0.18580000f,0.31520001f,-1.20539994f,-0.58920000f,-0.14100001f,0.13800000f,-1.25009999f,-0.96470002f,0.21280002f,-0.47819998f,0.13230000f,0.83990004f,-0.13180005f,0.75579999f,1.04130001f,0.22210001f,-0.38040000f,-0.28660002f,1.22009997f,0.58410000f,1.01569999f,0.63290004f,-1.36759998f,-0.71660002f,1.00529999f,0.51950002f,-0.18689998f,-0.90299998f,0.06090000f,-0.49349999f,0.04140000f,-0.25410001f,-0.86039998f,-1.19969997f,0.28140000f,-0.01650000f,-0.76709999f,-0.57329999f,-0.57959998f,0.25290000f,0.67470002f,-0.36960001f,0.82859998f,-0.31140003f,0.09870000f,0.73440000f,-0.32940002f,-0.29370000f,0.72989998f,1.07279998f,0.63570002f,0.70559998f,-0.54600000f,-0.80129997f,0.79110001f,1.04190000f,-0.02970000f,0.92580002f,-0.62349999f,-0.28430003f,0.45720000f,-0.18940001f,-0.45529998f,-0.50550000f,0.45250001f,-0.17170001f,0.23450000f,0.86510001f,0.56739998f,0.18140000f,0.91250000f,0.21190000f,-0.92900000f,-0.35200001f,0.90059998f,0.95980003f,-0.22520000f,0.30620001f,0.75589999f,0.85230003f,0.32640000f,1.02280005f,0.61419996f,0.58899999f,-0.13940000f,-0.32780000f,-0.19940000f,0.39299998f,-0.50310001f,-0.71699999f,0.08879999f,0.80310002f,-0.48449999f,-0.21089999f,-0.26550001f,0.37050001f,0.69329999f,-0.29250000f,0.20219999f,0.47819998f,0.25469999f,0.80850000f,-0.67740000f,-1.09350001f,0.86460000f,0.37079999f,0.20040001f,-0.43710000f,0.74670001f,0.26519999f,0.63360004f,-0.51180001f,0.74099998f,0.52259998f,-0.14340000f,0.19980000f,-0.45300001f,0.35610001f,1.15560001f,0.71560003f,0.77810000f,0.08290000f,-0.76859996f,-0.89780000f,1.22039999f,0.37020001f,1.35969997f,0.85390001f,-0.27550002f,0.67930002f,0.03859999f,-0.55240001f,0.10970002f,0.08970001f,0.38949999f,0.31730000f,0.73239998f,0.07480000f,1.18780002f,0.81440005f,0.49890000f,0.05270000f,-0.43250001f,-0.00490000f,0.57200001f,0.27600002f,-1.64920001f,0.68970001f,0.89460001f,1.00380001f,-0.11070000f,0.46380001f,-0.77579998f,-0.24179998f,0.16800000f,0.75569999f,0.69269999f,0.75509999f,0.81690001f,-0.34200002f,-0.21180000f,0.62130000f,-0.25290000f,-0.32040001f,0.31650000f,0.24149999f,0.34620000f,0.95219999f,0.86580003f,0.85290001f,0.10769999f,0.50070001f,-0.26790001f,-0.69300002f,-0.02700000f,0.08099999f,-0.81600002f,0.81930005f,-0.32710000f,-0.38350001f,0.94939998f,0.37880002f,0.58379998f,0.48920000f,-1.08930002f,-0.24970001f,-0.31579998f,-0.66480000f,0.79400001f,0.18860002f,-0.51949999f,-1.00990005f,-0.08369998f,-0.86530000f,0.11240002f,-0.79020002f,0.32800000f,-0.28360001f,-0.31059999f,-0.39460001f,0.12270003f,-0.41330001f,0.96079999f,0.35840001f,1.66560003f,0.87620005f,0.08709999f,0.25020000f,-0.15030000f,0.10320001f,0.09420000f,0.41069997f,0.73739998f,0.63989999f,-0.03810000f,-0.66840001f,-0.76499999f,-0.16289999f,0.21660001f,0.69150001f,-0.81390003f,0.11100002f,-0.85169999f,0.25140001f,-0.72840001f,0.45870002f,0.02220000f,0.75000001f,-0.68880000f,-0.47579999f,-0.50610001f,0.15660002f,0.37260000f,0.76739999f,0.61080002f,0.90930002f,0.81090003f,0.23010001f,1.25130001f,0.85030004f,0.47689999f,0.59770002f,-0.53879999f,0.30600000f,-0.16970000f,-0.75830002f,-0.87089998f,-0.13330000f,0.45690002f,-0.52510002f,0.22890001f,-0.00350000f,0.79600001f,0.61040003f,0.10980001f,0.06320001f,-0.44579995f,-1.05820001f,1.13109997f,1.09570001f,0.71810000f,0.75570003f,-0.36129997f,-0.56610000f,0.82319999f,0.93740002f,0.90870000f,0.59009998f,0.48090001f,0.42089998f,0.41430001f,0.01319999f,0.57239999f,-0.30239999f,-0.95190001f,-0.10110001f,-0.16589999f,-0.78719998f,-0.78030001f,0.31920002f,-0.12510001f,0.07319999f,0.30960001f,0.16799999f,-0.15540000f,-0.17010000f,-0.73559999f,0.33960003f,0.72389998f,0.21929997f,0.67950001f,0.29879999f,-0.81630000f,-0.41039999f,0.81060000f,0.27209999f,0.60330001f,-0.96500004f,0.75669998f,0.43530001f,0.46029999f,0.38650002f,-1.56549998f,-1.07650001f,-0.35570001f,-0.28930001f,-0.74589999f,-0.15050002f,0.47570001f,-0.03930000f,0.67630000f,0.51490002f,-1.13350001f,-0.68190003f,1.35590002f,0.63150005f,-0.11749997f,-0.50330000f,-0.45149998f,0.25990001f,-0.04149997f,0.46650002f,-0.65599998f,-0.75920002f,0.36779999f,0.06500001f,-0.07800000f,-0.24149999f,0.56730000f,0.68609998f,0.64890002f,0.57990000f,-0.73469998f,-0.65849998f,0.02190000f,0.13140001f,-0.28830001f,-0.78569999f,-0.29430000f,0.16110001f,0.40290000f,0.30689999f,-0.69450001f,-0.80700001f,0.51810003f,0.88620001f,-0.77370001f,-0.23250000f,0.04770000f,-0.74850000f,0.20430000f,-0.50399999f,-0.91259999f,-0.50099998f,0.13440000f,0.39239999f,0.01440000f,0.68360003f,-0.11440001f,-0.61500002f,0.07500001f,-0.18580001f,-0.06940005f,0.57699999f,-0.49569996f,-0.47829999f,-0.67620001f,-0.10600000f,0.26820001f,0.06060000f,1.02240000f,1.03200004f,-0.24910002f,0.14910000f,-0.34879999f,0.45520002f,0.60419999f,0.63700002f,-0.36459998f,0.04400000f,0.72709999f,0.37750001f,1.00609999f,0.84730001f,-0.63449997f,-0.56490000f,-0.21519998f,0.41129999f,-0.45900001f,0.29429999f,-0.43260001f,-0.14400000f,0.62279998f,-0.22020003f,-0.49109998f,-0.29609998f,0.05580000f,-0.39810001f,-0.05700000f,0.09060000f,0.70740001f,0.19619999f,-0.07050000f,-0.53130002f,0.75840001f,-0.14040000f,0.57960000f,0.25859999f,-0.21359999f,-0.64229998f,0.20789999f,0.33779999f,0.53309999f,0.25979998f,-0.59969998f,-0.41699998f,-0.47999999f,0.96770004f,-1.36780000f,-0.54260002f,-1.28839994f,-0.69180000f,1.06800001f,1.05140005f,0.12429999f,-0.63030002f,0.28799997f,-0.20600001f,-1.63910000f,-0.82270006f,-1.41780001f,-1.01380006f,0.62589999f,0.42030000f,1.31549998f,0.76630001f,-0.38709998f,0.00190000f,-1.13609998f,-0.95150001f,-1.18009996f,-0.50030000f,0.19700000f,0.15780001f,0.73369998f,1.06530003f,0.72110001f,1.00980000f,-0.31560000f,-0.80040000f,-0.84659999f,-1.10669996f,0.74400003f,0.25050000f,-0.72450001f,0.23489999f,0.02460000f,0.59999999f,-0.61590002f,-0.97079998f,-0.83040003f,-0.72539999f,0.18689999f,0.15719999f,0.50789998f,0.63599998f,-0.15570000f,-0.53429999f,-0.72809998f,-0.44429997f,-0.73769998f,-1.17029997f,0.29220001f,0.27600000f,0.81750000f,0.00659998f,-0.16050000f,0.95730004f,-0.63579999f,-0.55680002f,1.08980001f,0.93260005f,0.81709999f,0.12890001f,-0.89699997f,-1.06100002f,0.10080001f,-0.03600000f,-1.14379999f,-0.53600001f,-0.23310000f,-0.65090002f,-0.84909997f,-0.65390000f,-0.21640002f,0.26340001f,-0.38999996f,-0.57819999f,-0.04960000f,0.33060002f,-0.35400001f,-0.54280004f,-1.03359998f,-0.78720000f,0.70030000f,0.00670000f,0.04819997f,0.76740001f,-0.56760001f,-0.39389999f,0.55200002f,0.23039999f,0.41970001f,1.03230000f,-0.87240000f,-0.22499998f,-0.31200000f,-0.20760000f,-0.34380000f,-0.63689999f,-0.42150000f,0.28170000f,-0.50549998f,-0.37379997f,-0.04619999f,-0.64470002f,-0.89819998f,-0.51149999f,0.48900001f,0.01470000f,-0.85020003f,-0.47700000f,-0.74639998f,-0.61679999f,0.14850000f,0.80040000f,0.85859999f,0.69200003f,-0.27959998f,0.33300000f,-0.98149997f,-0.91590002f,0.50289999f,1.09630006f,-1.36490000f,-0.51890001f,-0.11249997f,-0.76690002f,-1.05180001f,-0.87380005f,0.13119999f,0.95640002f,0.78670001f,-0.06329999f,-0.30359998f,-1.04840003f,-0.41099999f,-0.07620001f,-0.10970001f,-0.28970002f,0.36810000f,-0.03130001f,0.04580003f,-0.58999999f,0.75960001f,0.32120002f,0.80549997f,0.22319999f,0.08820000f,-0.65429998f,-0.86670000f,-0.51299998f,0.87750004f,-0.18330002f,-0.35969999f,-0.88320000f,-0.49710001f,0.48000002f,-0.88080003f,-0.65640000f,0.89640000f,-0.29340001f,-0.17130000f,0.62159999f,-0.66780001f,0.53220004f,-0.26820001f,-0.56700000f,-0.33090001f,-0.04260000f,0.32010000f,0.74730002f,-0.55499998f,0.29490002f,-0.00900000f,0.20579999f,0.83249998f,0.24340001f,-0.49480000f,-0.82260004f,-0.55200000f,0.11560000f,0.75620002f,-0.17020000f,-0.74230002f,-0.35590003f,-0.35139998f,0.16720001f,-0.31280001f,0.41159999f,0.64070001f,0.28110002f,1.56980000f,0.67560001f,0.52680001f,-0.19900000f,-0.47679999f,-0.61240002f,0.52279998f,0.46200000f,-1.34229999f,-0.67810003f,-0.43600001f,-0.68840003f,0.51150001f,0.62730005f,-0.59580002f,0.11860000f,-0.13649999f,-0.20120001f,0.79800000f,0.60930001f,0.23370002f,0.69600002f,0.41970000f,0.38599998f,-1.08629998f,-0.80309999f,-0.53040001f,-1.02859999f,-1.42649997f,-1.56220000f,-0.12810001f,-0.58950001f,0.79080002f,0.75900001f,-0.44220001f,-0.09799998f,-0.66149998f,-0.18920001f,-1.10579998f,-1.09339999f,-1.03889993f,-0.35359994f,0.07500001f,-0.30629999f,0.05460000f,-0.17820000f,0.36100002f,0.08740000f,0.00389996f,-0.21000000f,0.64370002f,0.06540000f,0.76980002f,-0.36860000f,-1.05820004f,0.33180001f,-1.05450001f,-0.01060000f,-0.87939999f,0.39659999f,-0.16180002f,0.68219999f,-0.12329997f,-0.60399999f,0.93660000f,-0.53360001f,-0.62859998f,0.49159999f,-0.60959999f,0.31899999f,0.24110003f,0.00300001f,1.13570001f,-0.11780000f,-0.06520000f,0.40529999f,-0.00510001f,-0.29520002f,-0.55259997f,-0.69389998f,-0.18570001f,-0.65550002f,-1.00710000f,-1.17960002f,0.92670003f,1.05000002f,0.31770002f,0.72689999f,1.03769998f,1.13259998f,1.31729998f,0.90299999f,-1.03619999f,-0.48850001f,-1.34760002f,-1.43500001f,1.08359999f,0.92799998f,0.83729998f,0.93639998f,0.13769998f,0.41410001f,-0.58890001f,-0.95189999f,-0.87209996f,0.19599999f,-0.20120000f,0.49040000f,-0.02469997f,0.00379999f,-0.19970001f,-0.73979999f,1.38100003f,-0.04540000f,0.34920002f,0.08220000f,0.05229999f,0.03560000f,-0.07469999f,-0.20760000f,-0.36950001f,0.09140000f,-0.28570002f,-0.40239999f,1.17540000f,-0.03779999f,0.36480002f,0.06200000f,-1.16010004f,0.05100000f,0.94730002f,-0.18319999f,-0.35509999f,0.31999999f,-0.34490000f,0.35229999f,0.87300001f,0.42859999f,0.19589995f,0.52289998f,-1.19369996f,-0.39829996f,-0.51630003f,-0.99360001f,-0.07410001f,-0.46780002f,-0.04139999f,-0.24669999f,-0.44099998f,-0.40890001f,0.40109998f,0.67870000f,-0.57659998f,-0.04809997f,-0.43169999f,-0.82759997f,-0.11580000f,-0.50000002f,0.37170004f,0.61170001f,-0.63600000f,-0.85690000f,0.64679999f,0.45189998f,-0.36209998f,-0.18679998f,0.61350001f,-0.01340000f,-0.47170001f,0.12480000f,-0.78110001f,0.26000000f,-1.40420003f,-0.09540002f,-0.50519999f,-0.28979999f,-0.82140003f,0.06740000f,1.14140000f,0.29980000f,0.69490000f,-0.26219999f,0.16600000f,-0.21240000f,0.47610002f,-0.00980001f,1.04850002f,0.07759999f,0.64519998f,-0.26299999f,0.87230002f,-0.51380000f,-0.49680002f,0.15779999f,0.23580001f,-0.62709997f,-0.24090002f,-0.50030000f,0.43680001f,0.62570001f,0.70920001f,0.78470000f,0.27389999f,0.87839999f,-0.31109999f,0.19840000f,0.24630003f,0.26180000f,0.21029998f,-0.39959999f,-0.64709999f,-0.61989998f,-0.59399998f,-0.76900001f,-0.01230004f,0.09309999f,-0.08280005f,-0.34410001f,-0.71189997f,-0.80539997f,-1.32990000f,-1.47670002f,0.58529998f,0.90100001f,0.08100000f,-0.66440000f,0.31070000f,0.05720000f,0.48950002f,0.34740000f,-0.31209998f,0.07780000f,-1.67500007f,-0.11020000f,-0.22820001f,-0.16800000f,-0.73319999f,0.23160000f,-0.22079999f,0.18720000f,0.62940000f,-0.19579998f,0.21529999f,-0.22380001f,-0.31320002f,-0.66299999f,0.04880000f,-0.15660000f,0.77139999f,-0.27399999f,-0.64470002f,-0.01980000f,0.31830000f,-0.33399999f,-0.48850003f,-0.97479999f,0.12479998f,0.17550000f,0.57389997f,0.29730000f,0.32189999f,0.52409999f,0.29550005f,0.94700003f,-0.26099999f,-0.09640000f,0.69540000f,0.86839999f,0.45659999f,0.47859999f,-0.45749999f,-0.37119997f,-0.63870000f,-0.83830002f,-1.04009997f,-0.29959998f,-0.37649998f,-0.41039999f,-0.68819999f,-0.67259997f,0.21390001f,0.55190002f,-0.60719999f,-0.29329998f,0.74699997f,0.73139998f,0.76880000f,0.09140001f,-0.52350001f,0.37680000f,0.40799999f,0.78059998f,0.22310000f,-0.07720000f,1.12520001f,0.05100001f,-0.12330002f,-0.12560000f,-0.48340001f,0.42760000f,-0.02199996f,0.21320001f,-0.74350002f,-0.28620000f,0.20820001f,0.15620000f,-0.57570001f,-0.62099999f,-0.66740002f,-0.30999999f,1.09030001f,0.22679999f,-0.28860002f,-0.70300000f,0.57689998f,0.82849997f,0.01829999f,-0.17079998f,0.83580001f,0.71810000f,1.23389996f,0.38579999f,-0.14280001f,-0.04689999f,-0.28830000f,-0.79319998f,-0.31859996f,-0.40529998f,1.04040000f,1.09000002f,0.56219998f,0.70439999f,-0.36389997f,-0.00630000f,0.19049999f,-0.05560001f,-0.91889997f,-0.17970000f,-0.32639996f,0.20640003f,0.09359996f,-0.44170001f,-1.12529999f,-0.37179999f,-0.95219998f,0.16040000f,0.10500002f,0.51599998f,0.17090000f,-0.66560001f,0.38149999f,0.03720000f,-0.30990001f,-0.15720001f,-0.55010001f,0.39319999f,-0.30640000f,-0.25479999f,-0.46140001f,-0.44820000f,0.13990002f,0.79120000f,-0.81400001f,-0.01440000f,-0.09549999f,0.35479999f,-0.72760001f,0.03760000f,-0.91500000f,0.69039999f,-0.25999998f,-0.32279999f,0.38780000f,-0.28399999f,0.24800001f,1.03999999f,0.86339995f,0.35679996f,-1.28340001f,-0.87350001f,-0.10140000f,-0.35829999f,-0.28020000f,-0.20770002f,0.99299998f,1.08329999f,-0.37979998f,-0.09440000f,-0.70349999f,-0.24980001f,1.34579999f,0.60389999f,0.30840000f,0.76080000f,0.73079998f,0.59409999f,0.36660001f,0.73100001f,1.62479998f,1.58260000f,-0.41939999f,0.07519999f,-0.64919998f,-0.59579998f,-0.30120000f,-0.16280001f,-0.53190003f,-0.59060000f,-0.66600001f,-0.10440001f,0.76619999f,-0.06800000f,-0.97210001f,-0.22240000f,-1.10740000f,-0.19100001f,0.15320000f,0.17360002f,0.55250000f,-0.65639998f,-0.51870003f,0.43460001f,-0.27640000f,-0.09220000f,-0.04210000f,-0.70939999f,-0.73650004f,-0.40320000f,-0.19630001f,-0.30800000f,-0.11690000f,0.56980001f,-0.74850003f,0.20900001f,1.16860004f,0.26589998f,-0.84029998f,-0.07489998f,-0.07440000f,0.08619998f,-0.43800000f,-0.80059998f,-0.18059997f,0.20509999f,0.00510001f,0.56939998f,0.44700001f,0.57540003f,-1.40399996f,-1.17349998f,0.89010002f,0.63930001f,-0.05669999f,0.15880000f,-1.27289996f,-0.70949998f,-0.44579998f,0.23390002f,-0.52199999f,-0.25610001f,1.05690001f,0.63750000f,0.55350003f,0.56250001f,0.40019995f,0.14699999f,0.55980001f,-0.27320000f,-0.94210001f,0.02760001f,-0.09650000f,-0.46919999f,0.88820003f,0.18280001f,0.19289999f,0.07840000f,-0.41440002f,-0.37620000f,0.76160001f,-0.32920000f,0.26959999f,-0.25640000f,0.21349999f,-0.39560000f,0.29510000f,-0.66820000f,-0.12489999f,0.42419999f,-0.08200002f,-0.07080001f,-0.55830001f,-0.38660000f,-1.40290004f,-0.19760002f,-0.20640000f,0.88530001f,-0.66720000f,-0.65680000f,0.27360005f,0.47350001f,-0.73319999f,-0.18090000f,0.14759998f,-0.15439999f,-0.03419999f,-0.37110000f,-0.58409998f,-0.19699999f,-0.93960000f,-1.15100002f,-0.70199997f,-0.87379999f,-0.93119998f,-0.96490001f,-1.32749998f,-0.96229999f,0.70469999f,0.24009998f,-0.21000000f,-0.31500001f,-0.54389998f,-0.07090000f,0.04140001f,0.64149999f,0.53850001f,-0.27039999f,-1.31930004f,0.14240001f,-0.62390000f,0.20020000f,0.54359999f,0.01200000f,0.02079999f,0.10020001f,0.43430000f,0.43899999f,-0.43440000f,-0.05680002f,-0.27240001f,0.04720000f,-0.94080003f,0.20160000f,-0.35270001f,0.25920000f,0.89869997f,-0.55220000f,-1.32050000f,0.28560000f,-0.64710001f,-0.01420000f,-0.00090002f,0.33500000f,-0.80980001f,0.05980000f,-0.29270001f,-0.03909999f,0.64440004f,0.97370001f,0.59130000f,0.72530000f,0.01079998f,0.08280001f,0.00990004f,-0.36760000f,0.70829996f,0.29470000f,-0.15780001f,-0.29140004f,0.12540002f,0.10900001f,0.64320003f,0.80480001f,0.53940001f,0.39690000f,-1.37789998f,-1.45189998f,0.96120000f,1.28089998f,0.23850000f,0.59730001f,0.48510002f,0.00990001f,0.43830000f,0.82600000f,-0.97770000f,-0.17540000f,-0.32120000f,-0.41739999f,0.00960000f,-0.45940000f,1.49870001f,-0.02039999f,0.65200002f,-0.33320000f,0.23930002f,0.51199999f,-0.56130001f,0.09079999f,-0.61360002f,-0.02300000f,0.72670003f,0.36660001f,-0.99010004f,-0.32540001f,-0.16640002f,0.25980000f,-0.10590001f,0.59680000f,-0.42930002f,0.52459999f,0.32070002f,0.29059998f,-0.11390000f,-0.25739999f,0.27119999f,-1.02280000f,-0.61769997f,-0.10879999f,-0.75390000f,-0.25759999f,-0.49860001f,-1.02229997f,-0.76920002f,-0.68340000f,0.86639996f,0.40589997f,0.23940000f,0.19769998f,0.16350002f,0.43080001f,0.41009999f,-0.18890001f,-0.30749998f,0.26030001f,0.38610003f,0.00440000f,1.16399998f,0.82870000f,1.12589998f,0.95070000f,0.31349997f,-0.22910003f,-0.43889997f,-0.21209999f,-0.45899999f,-0.13860000f,0.40800001f,-0.35139999f,-0.31100001f,0.23400000f,-0.04529997f,0.16020001f,0.35199998f,0.11180000f,0.57870001f,0.08840001f,-0.30280001f,0.04280000f,-1.18890002f,0.25620000f,-0.19179997f,0.46900000f,0.45799999f,-0.08479999f,-0.53610001f,-0.02060000f,-0.15639999f,0.54419998f,-0.68040001f,-0.01559999f,-1.12250001f,0.19060000f,0.41539999f,0.18319999f,-0.12160001f,0.39360001f,-0.83969997f,-0.85139999f,0.43140001f,0.20579999f,0.42869999f,0.54129999f,0.04530000f,-0.25439998f,0.05280000f,-0.09849998f,0.13620001f,0.15080000f,0.87390001f,1.18050000f,0.91829998f,0.64099998f,-0.12000001f,0.09000003f,0.18390001f,0.49210000f,1.02689995f,0.64899997f,0.15600002f,0.36820000f,0.70290001f,0.98029999f,0.14699999f,-0.24519999f,0.56760000f,-0.32840000f,1.12090002f,0.20740000f,0.62499998f,0.63259998f,-1.19470003f,0.21639999f,-0.03209999f,-0.13999999f,0.19990001f,-0.52179999f,1.30100005f,0.28039998f,1.20430004f,0.13859999f,-0.72130000f,0.13500000f,-1.18880001f,-0.06640000f,-0.00600001f,0.40739999f,1.09710001f,-0.03680001f,0.41710000f,0.75119998f,0.03440000f,-0.22880000f,-0.95090000f,0.30900000f,-0.84910003f,0.52740001f,0.09269998f,-0.36129999f,0.90869996f,0.11440000f,0.80640001f,1.15090001f,-0.39239997f,-0.53550001f,-1.02869998f,-0.73509999f,0.13679993f,-0.49640004f,-0.15090004f,-0.74670003f,0.44670001f,0.56629999f,0.22500002f,0.66739999f,0.74549998f,0.44199999f,-0.44160003f,-0.87350000f,1.19879996f,0.40729999f,-0.38760000f,-0.15639999f,0.94290000f,1.20549999f,0.44400004f,-0.12440001f,0.44500001f,0.15420000f,-1.27130004f,0.26540000f,-0.07340001f,-0.76059999f,0.95690000f,-0.14580000f,-0.39800001f,0.30880000f,0.96030000f,0.14360001f,0.57170001f,-0.40199999f,0.78220000f,0.01599999f,-0.35199998f,0.61060000f,-0.07320003f,0.43940000f,0.14919999f,-0.08099999f,-0.08389997f,0.41579999f,0.77000000f,0.21040000f,-0.17610001f,-0.54100000f,-0.12989999f,0.75260000f,0.09149999f,-0.27800001f,0.88050003f,1.14690002f,-1.34969997f,-0.72419998f,-0.64470000f,-1.02809999f,0.61440001f,0.39880000f,0.00119999f,-0.39049999f,-0.96419999f,-0.96449999f,-0.23220002f,-0.56200000f,1.22609999f,0.90019999f,0.68370001f,0.13100001f,-0.09570000f,0.08500002f,0.65009999f,0.12989996f,0.09480000f,-0.43239998f,-0.96089998f,-0.54050000f,0.45599999f,0.20839999f,-0.25320000f,0.57779998f,0.78540000f,0.13120000f,-0.80340001f,0.39620001f,1.02640002f,0.30480001f,0.59029998f,-0.55460000f,0.73870003f,0.25580000f,-0.37559999f,0.32440000f,-0.52480002f,-0.27119999f,0.89850000f,-0.69860001f,-0.01920001f,0.44040000f,0.07300001f,0.01680000f,0.27230000f,-0.66800001f,0.16449998f,-0.26120000f,-0.89010002f,0.16580000f,-0.85410000f,0.89339998f,1.16729995f,0.88619998f,-0.08100001f,-0.60120000f,1.08750001f,1.28620003f,0.28979998f,-0.22059998f,-1.27169998f,-1.20529999f,0.16289998f,-0.43030003f,0.86219998f,1.02720000f,-0.43259996f,-0.21579999f,-1.64310001f,-1.60370001f,0.79019999f,0.43200000f,-0.04500000f,-0.17800001f,-1.26720001f,-0.80030001f,-0.63359998f,-0.68469998f,0.50550003f,0.57530000f,0.58170001f,-0.22100001f,0.69930001f,-0.27640000f,0.11930001f,0.45540000f,-0.75090004f,-0.01099999f,0.13140003f,0.60640000f,-0.17930002f,0.56320000f,0.36420001f,-0.02720000f,-0.55380002f,-0.06520000f,-1.39640002f,-0.11940001f,-0.63470002f,0.10320001f,0.42580001f,0.00560000f,-0.63479999f,0.15439999f,0.76400002f,0.54420000f,0.61470001f,-0.23939999f,-0.15460004f,-0.32379999f,0.65650003f,-0.11440000f,-0.12580000f,0.01030000f,0.24830001f,0.28230001f,0.03800000f,0.27690001f,-0.15359999f,0.46889998f,-0.09690000f,-0.63120000f,0.02220000f,-0.57540000f,-0.23380000f,-0.87070000f,-0.17110000f,-0.05620000f,-0.13000000f,0.72460001f,0.20280000f,-0.44340000f,-0.12560001f,-0.22270000f,-0.30340000f,-0.51000000f,-0.03839999f,-0.53489997f,-0.19970000f,0.15170001f,0.10930000f,0.89130001f,0.17280000f,-0.40190002f,0.78809995f,0.19110001f,0.44209999f,-0.59140003f,0.89599999f,-0.02850002f,-0.58120001f,0.20150001f,-0.27770000f,0.71490000f,-0.76839998f,0.02180000f,-0.83079998f,-0.88299999f,0.51129999f,0.98939999f,1.06820000f,0.11340002f,-0.64019999f,-0.31690001f,-0.70539998f,-0.02399999f,-0.64209997f,-0.02050000f,0.47170000f,-0.58720001f,0.76499996f,0.25859999f,-0.07400000f,-0.01390000f,-0.38490000f,-0.05309999f,-0.16810000f,-0.10540000f,-0.19320000f,-0.60830001f,-0.05200000f,0.79190002f,-0.05910000f,0.42680000f,0.07240000f,0.73549999f,0.12199999f,0.73910001f,-0.02689999f,-0.58690002f,-0.17540001f,-0.85820002f,-0.00259999f,0.77319999f,0.13580000f,0.51849999f,0.45970001f,-0.29800001f,0.02390000f,-0.58020000f,-0.26419999f,-0.32579997f,-0.28000001f,-0.64790002f,-0.62069994f,0.13520002f,0.41109998f,1.28530002f,0.39920001f,-0.84350002f,0.38819999f,-0.42990002f,0.27889997f,-0.14870000f,0.48749998f,0.29609999f,-0.58869997f,0.19030002f,0.12089999f,0.82760002f,0.31799999f,-0.71490001f,0.41319999f,-0.41040003f,-0.06090003f,0.63090001f,0.44830000f,-0.35770003f,-0.26290000f,-0.27050001f,0.09310000f,0.05229999f,-0.13240000f,0.66360001f,0.38509999f,-0.15980002f,0.09210001f,-0.75620000f,0.08680000f,-0.62670000f,-0.21020000f,0.04649999f,-0.18369999f,0.10050000f,-0.21390000f,-0.09690001f,0.23910000f,0.13440000f,0.07470000f,-0.35330000f,0.08720000f,-0.53849998f,-0.21160000f,0.01939999f,-0.25350000f,0.62160001f,0.03089999f,-0.57989999f,-0.08670000f,0.52049999f,0.01050000f,-0.24020002f,0.25070000f,-0.40110000f,-0.45669999f,0.16910001f,-0.43690000f,0.12490000f,-0.28159999f,1.07110005f,-0.02339999f,0.80040000f,0.17319997f,0.34980001f,-0.09679999f,-1.17910001f,0.28570000f,-0.03800000f,0.78519997f,0.09729998f,-0.39069995f,-0.19289998f,-0.16729996f,-0.73349999f,0.53979998f,-0.05830001f,1.16109998f,0.10009998f,-0.76859997f,0.19230004f,0.27579999f,-0.59169998f,-0.01150000f,-0.24860001f,0.11430000f,0.26630001f,-0.04150000f,0.60210001f,-0.09080000f,0.48669998f,0.05540000f,-0.13830001f,-0.33320000f,0.54290000f,0.16040000f,-0.19649999f,0.11870000f,-0.60559999f,-0.34480000f,-0.13700000f,0.36109999f,-0.35900000f,0.30330000f,-0.46270001f,-0.05300000f,-0.50969998f,-0.25950000f,-0.77400002f,0.28820000f,0.23310000f,-0.19860000f,0.72910002f,-0.37829996f,-0.20799999f,-0.55569998f,-0.76990001f,-0.43729998f,0.14749999f,-0.21240003f,1.24640005f,0.20619999f,0.37990001f,-0.57359999f,0.17160000f,-0.40679999f,-0.09870000f,0.03800000f,-0.05970001f,0.83809998f,0.07580001f,0.37620000f,1.23180001f,0.43099997f,0.14659999f,0.30260000f,-0.06800000f,-0.30390000f,0.48690002f,0.08770001f,0.35220001f,-0.81949997f,-0.83079999f,0.27949999f,-0.18589999f,0.27650000f,0.05660000f,0.16370000f,0.13140000f,-0.18840000f,0.62050002f,-0.09220000f,-0.04940000f,0.07120000f,0.50220000f,0.10640000f,0.23880000f,0.22480000f,-0.55669998f,-0.36090000f,-0.16120001f,0.04699999f,-0.60929999f,-0.17740000f,-0.10690000f,0.13180000f,-0.65399998f,0.05590000f,0.20520000f,0.19670000f,-0.57069999f,0.26950000f,-1.00469999f,-0.21299998f,-0.57760000f,-0.47490000f,-0.22080000f,-0.50579999f,-1.46129998f,-0.09149999f,0.01340000f,0.32779998f,-0.83620002f,0.53209995f,0.17820000f,-0.93739999f,-0.23649999f,-0.78959996f,-0.18520002f,0.36409998f,0.86000001f,-0.01280000f,-0.38730001f,0.39270000f,1.31700000f,0.05539998f,0.91690001f,-0.03469998f,-1.03760000f,0.43960000f,1.27140003f,0.53669999f,0.80939999f,0.26099999f,-0.31969998f,-0.02150000f,0.61770001f,-0.00660000f,0.68010000f,0.15030000f,-0.23750000f,0.02180000f,-0.39429999f,-0.29729999f,0.04750000f,0.25300001f,0.53280001f,0.38000000f,0.06580000f,-0.24610000f,0.09440000f,-0.02840000f,0.09890000f,-0.04590001f,-0.42000000f,-0.02059999f,-0.06239999f,0.14869999f,-0.24950000f,0.03400000f,-0.65590001f,0.02489999f,0.62480000f,-0.36299998f,-0.86010000f,0.79390001f,0.85700002f,0.22489998f,-0.34030000f,0.39149999f,0.37350001f,-0.89949996f,-0.14569998f,0.22679999f,0.56959999f,0.45600000f,0.94320002f,-0.61350001f,-1.29440003f,-0.45879999f,0.61220001f,-0.57689998f,-0.42279999f,-0.45919999f,0.47210002f,-1.22019999f,-0.35999998f,-0.02359998f,0.70719999f,0.42819998f,0.15619999f,0.37519999f,0.72940000f,-0.02380000f,0.52259999f,-0.10550001f,-0.73230002f,-0.07530000f,-0.07510000f,-0.23390000f,0.05789999f,0.23229999f,0.53130001f,-0.07640000f,-0.11900000f,-0.15280000f,-0.23130001f,-0.00529999f,0.79550001f,0.11240000f,0.25160000f,0.15250000f,0.34870000f,0.10440000f,0.27720000f,0.19220001f,1.01019999f,0.12920000f,-0.30260000f,-0.02980000f,-0.44219999f,-0.13440000f,0.83650002f,0.24770000f,1.26870004f,0.25319999f,0.52890001f,0.51379998f,-0.45540000f,0.25529998f,0.91340000f,-0.10159999f,1.01540001f,-0.74399998f,-0.23410001f,0.94069997f,0.57979999f,-0.36710002f,-0.34320001f,-0.05700000f,0.33500000f,0.70629998f,1.07809999f,0.03810000f,1.11960005f,0.34630000f,0.56810001f,-0.56250001f,-0.77540003f,-0.19850002f,0.14250000f,-0.12739998f,0.33709999f,0.03950000f,-0.44300000f,-0.25600000f,0.26339998f,-0.11380000f,-0.32059999f,-0.26369999f,0.25989999f,-0.08560000f,0.26609998f,0.41240000f,-0.05959998f,-0.11630000f,-0.86649999f,-0.11970000f,0.72200002f,0.02260000f,-0.00110000f,-0.07510000f,-0.70980000f,0.02470000f,-0.15570000f,-0.09830000f,-0.20910001f,0.02290000f,0.64580002f,-0.15750000f,0.58700002f,0.11940000f,0.44580003f,0.40580000f,0.03810000f,-0.02470004f,0.53059998f,0.15610002f,0.81820001f,-0.27859998f,-0.79090002f,0.35989997f,-0.32280001f,0.38299999f,0.80810002f,0.87600000f,-0.08590001f,0.84159996f,0.09709999f,0.94929997f,0.34400000f,0.82949999f,0.77870000f,-0.11170001f,-0.61690001f,0.41239999f,0.08510001f,0.31009999f,0.92790001f,-0.02030000f,1.18940005f,-0.72380000f,0.54420000f,0.01780000f,-0.51920000f,-0.21409999f,0.49370001f,0.13149999f,-0.52430000f,0.28060000f,-0.27720000f,-0.22589999f,0.11050000f,-0.13460000f,-0.18070000f,-0.20360001f,-0.55820000f,-0.33320000f,-0.22980000f,-0.33930000f,-0.35430001f,-0.09830000f,-0.78680001f,-0.18590000f,0.58699999f,-0.24160000f,0.06500000f,-0.11570000f,-0.14420000f,-0.20090000f,0.42629998f,0.31340001f,0.70309999f,-0.38590002f,0.63970001f,-0.47070000f,0.13720001f,-0.41159996f,-0.26639998f,0.46059996f,-0.27560004f,-0.49729998f,-0.90279999f,0.59079998f,0.23910001f,0.03679999f,0.07829999f,-0.38400001f,0.30960001f,-0.21290001f,-0.17960000f,1.10589997f,0.16010001f,-0.72229998f,0.46750000f,-0.35629999f,0.48960002f,0.07389997f,-0.57960001f,-0.52159998f,0.49730001f,0.43290001f,-0.03530000f,-0.13330000f,0.72750001f,0.04790001f,0.43639999f,0.37799999f,-0.36959998f,-0.34060000f,0.25270001f,0.17770000f,0.22080000f,-0.44240000f,0.30799997f,-0.11080000f,0.20680001f,-0.08000000f,0.61920001f,-0.08510000f,0.45370000f,-0.19790001f,-0.85319999f,0.00230000f,0.82030000f,0.08550000f,0.19880000f,-0.22710000f,0.46160002f,0.11320000f,0.32910000f,-0.01410000f,-0.46670002f,0.21139999f,0.85600000f,0.19060001f,0.73020002f,0.37249999f,-0.95170001f,0.36960001f,0.09070000f,-0.50129997f,-0.90670000f,0.10689999f,0.16590001f,-0.17540000f,0.44720001f,-0.09650000f,-1.04000003f,0.17229998f,1.11500004f,0.15699997f,-0.36920001f,-0.79449998f,-0.78029999f,-0.77449998f,-0.46619998f,0.16749999f,-0.71910000f,0.25809998f,0.45069999f,0.24599999f,-0.58450000f,0.01740000f,-0.32970000f,0.12860000f,-0.55390001f,0.11710000f,-0.65949999f,0.09400000f,-0.65380001f,0.09649999f,0.41169999f,-0.24450000f,0.42649999f,-0.01660000f,0.22230001f,0.02970000f,0.09580001f,-0.15990000f,0.10979999f,-0.27700000f,0.46810002f,0.15770000f,0.60970002f,0.11009999f,0.68000001f,-0.18909999f,0.27139998f,-0.05090000f,-0.20840000f,0.02040000f,0.60070002f,0.71019997f,0.20009997f,-0.01100001f,-0.20360001f,-0.59129997f,-0.12210002f,0.13459998f,-0.42979999f,-0.19190000f,-0.46140001f,0.00239999f,0.11120000f,-0.68370000f,0.42930002f,-0.54919999f,-0.56260002f,-0.39559997f,-0.05439998f,-0.29409999f,0.42030001f,-0.56019998f,-0.70869999f,-0.05880001f,0.45150000f,-0.49529999f,0.46120001f,0.10499999f,-0.58269999f,-0.12240001f,0.02350000f,-0.16740000f,-0.46030000f,-0.18980000f,0.45760000f,0.27770000f,0.06420000f,-0.06500000f,0.01170001f,0.20590000f,-0.22389999f,-0.09360000f,0.20620000f,0.02370000f,0.72780000f,0.05160001f,0.55409999f,0.40039999f,-0.44999998f,0.07490000f,0.15340000f,0.02620000f,0.63229998f,-0.10960000f,0.29820000f,-0.04510000f,0.66260000f,-0.07020000f,0.06580000f,-0.12880000f,1.32250004f,-0.15509999f,-0.99890002f,-0.33879999f,-1.37749998f,-0.65450000f,0.49400003f,0.63409996f,0.12629997f,0.64549998f,0.62709998f,-0.07619995f,-1.24750001f,0.24790002f,-1.01570003f,-0.23770000f,0.25880000f,-0.14200000f,0.86290000f,-0.43019998f,-0.59579999f,0.41929999f,-0.68970000f,-0.54469999f,-1.40929999f,0.11200000f,0.34220001f,-0.83809998f,0.22720001f,-0.03530003f,0.19580000f,0.24230000f,-0.32439999f,0.01680000f,0.42630001f,0.02530001f,0.68670000f,-0.33330000f,0.01270000f,-0.08229999f,-0.60000001f,0.19419999f,-0.29480002f,0.04329999f,-0.34100001f,-0.08670000f,0.46519999f,-0.14560000f,0.45840000f,0.05180000f,0.41550000f,0.00470001f,-0.46970001f,0.03590000f,0.62590000f,0.06000000f,-0.28560000f,0.14730000f,0.63580000f,-0.25350000f,1.04930004f,0.12040000f,-0.55490001f,-0.59290001f,0.44530002f,0.72919998f,1.17880001f,0.66049998f,-0.46990000f,-0.17640001f,-0.24320001f,-0.04309999f,-0.81660001f,0.74029998f,0.17989999f,0.23580000f,-0.55009999f,-0.73580000f,-0.66610002f,-0.00500003f,-0.69570000f,-0.21019999f,0.08890001f,-0.00350000f,-0.64970003f,0.13479998f,-0.85000001f,0.62109999f,0.89280001f,-0.70809997f,0.43500000f,-0.05760000f,0.01750000f,-0.05749999f,0.80640001f,-0.06920000f,-0.75510000f,-0.12130000f,-0.47500000f,-0.14520000f,0.55160001f,0.16910000f,-0.29709998f,-0.12190000f,-0.59890000f,0.02060000f,-0.29740001f,0.05700001f,0.76590000f,-0.24980000f,0.61190001f,0.21060000f,-0.23989999f,-0.24050000f,0.58659999f,-0.02279999f,-0.06479999f,-0.14230000f,-0.44680001f,0.34210000f,0.38740002f,-0.78419996f,-0.66089998f,0.31099999f,-0.76170001f,-0.99920000f,0.02340001f,-0.24680000f,-1.08710002f,0.98349998f,0.37640001f,0.16190000f,-0.91310004f,-0.94959996f,-0.12539999f,0.49639997f,0.67490000f,1.25329999f,0.37710001f,-0.40199999f,-0.64920001f,0.17860000f,-0.10910002f,0.64570001f,0.82970002f,0.67109996f,0.20380001f,-0.14330002f,0.29010000f,-0.62049998f,0.68879998f,0.12779999f,0.66029999f,-0.08820000f,-0.12620000f,0.23600001f,0.63170001f,0.22640000f,-0.17599999f,-0.18950001f,-0.73919999f,-0.07150000f,0.01800000f,0.34080000f,0.34060000f,-0.28800000f,0.04400001f,-0.21250001f,-1.00340002f,0.01319999f,0.47340001f,-0.10540000f,0.03700000f,0.01270000f,-0.82770002f,-0.24670000f,-0.23290000f,-0.20150000f,0.61580001f,0.12890000f,0.40570002f,0.69789999f,-0.10080002f,-0.60549998f,-0.71710001f,0.37189996f,0.39870000f,-0.41260000f,-1.01850004f,-0.66630000f,-0.70520000f,-0.39459996f,-0.09480000f,0.02739999f,0.44070001f,0.04660000f,1.03990001f,0.23709997f,0.16299999f,0.32539999f,-0.33440001f,-0.31639999f,0.18960000f,-0.29859999f,-1.32100002f,0.58349999f,-0.08850002f,-0.08400001f,0.65720003f,0.71389999f,-0.08529997f,0.28020000f,0.58750001f,0.34079999f,-0.91189997f,-1.19220006f,0.40140001f,0.03300000f,0.33610002f,-0.17729999f,1.02239998f,0.55110003f,0.58090001f,-0.72660002f,-0.09929999f,0.69780000f,1.28149994f,-0.09089999f,-1.31329999f,0.55950000f,-0.45489998f,-0.20429999f,0.47009999f,0.33150000f,-0.11510001f,0.80100004f,1.20049998f,0.90330003f,0.75139995f,-0.85890000f,-0.69129999f,-0.25810000f,0.00570000f,-0.23160001f,0.88480001f,0.30050000f,-0.19980001f,0.07370000f,-1.11590001f,0.03440000f,-0.70300001f,0.02909999f,-0.26630002f,-0.11269999f,0.79019999f,0.44230000f,-0.08720001f,0.15760000f,-0.38860000f,0.44949999f,-0.71450002f,-0.25270000f,0.42900002f,0.06919999f,0.69729999f,-0.22570000f,-0.53569998f,-0.24110000f,0.12030002f,0.05290000f,-0.51030001f,0.64560000f,0.60909999f,-0.00150001f,1.43880002f,-0.59519998f,-0.86499999f,0.28380002f,-1.67490002f,0.52830003f,-0.58460002f,0.84900005f,0.69629996f,0.29639999f,1.80579997f,-0.47370000f,-0.31640003f,-0.19019999f,-0.83220000f,-0.39599996f,-1.41070000f,0.15509996f,0.75220001f,-0.39840001f,0.87269998f,0.65879998f,-0.37990000f,0.23399998f,0.27930002f,-0.53070000f,0.25999999f,-0.15079999f,0.89009999f,-0.05580000f,-0.08449999f,0.22830001f,-1.05790002f,0.00320000f,-0.21610001f,-0.35290000f,0.79159999f,0.49340000f,-0.04019999f,-0.05740000f,-0.16270000f,0.57740000f,-0.37829998f,0.33509999f,0.79899999f,0.00319999f,-0.37139999f,0.12530000f,-0.82659999f,-0.36339999f,0.36319998f,-0.19160000f,0.41689999f,0.23070000f,-0.09070000f,0.43560000f,0.64959998f,0.42479999f,2.13269996f,0.92940002f,1.06089999f,-0.07350000f,-1.88050004f,0.85500001f,0.77169993f,0.21960000f,1.42599999f,-0.69450000f,-0.47299998f,0.57390000f,0.41549997f,-0.46890001f,-0.71610000f,-1.30980000f,0.11140004f,0.40080001f,-0.15739999f,0.49770002f,-0.76100001f,0.35250000f,0.77159998f,0.56639999f,1.36909995f,-0.87989999f,-1.12929995f,-0.43079999f,0.06530001f,-0.29060000f,-0.77679997f,0.33730001f,0.01280000f,0.16440000f,-0.06499999f,-0.32240000f,0.26930000f,0.18190000f,-0.02900000f,0.04920000f,-0.39240000f,0.06940000f,0.50860000f,0.08490000f,-0.23830001f,-0.12800000f,-0.97799998f,-0.14449999f,0.40870000f,0.20240001f,0.88870002f,0.28770000f,-0.49460001f,-0.03830000f,0.68910000f,-0.25290000f,-0.57989998f,-0.11550000f,-0.72569996f,1.24559998f,-0.10640002f,-0.87420002f,-0.79920000f,-0.10920001f,-0.08780000f,0.28289999f,0.54110000f,0.05880001f,0.23459999f,-0.02819998f,-0.73959999f,-0.31980001f,0.61780001f,0.67110003f,0.56789997f,0.54750000f,-1.27519999f,-0.69120002f,-0.33549997f,-1.23840004f,0.23090005f,0.17850003f,-0.37620003f,-0.69570002f,0.32130002f,0.65760000f,-0.49809997f,0.05700003f,0.14180000f,0.00090000f,0.78679999f,-0.02800000f,-0.29190001f,-0.16439999f,0.49400000f,0.20200000f,0.10390000f,-0.06910000f,0.50130000f,-0.03710001f,-0.67749998f,0.10250000f,-0.86770001f,-0.20160001f,-0.84689997f,-0.29730000f,-0.76179997f,-0.11319999f,0.03140000f,-0.21820000f,-1.08190000f,-0.04880001f,0.66269997f,0.13400000f,-0.45920001f,-0.06740000f,-0.60780001f,-0.05860001f,-0.35339998f,-0.44550001f,0.90160000f,0.41940002f,-0.01410002f,-0.78630001f,-0.32559996f,0.08910001f,0.55609999f,0.53550000f,1.62989997f,0.37380000f,-0.83169999f,0.34170002f,-1.08270002f,1.26570002f,-0.11149999f,1.28669999f,-0.02820002f,-0.59880004f,-0.89940000f,0.93600002f,-1.04090003f,0.04620002f,1.28649996f,0.37920002f,-0.20640003f,0.23400001f,-0.92580003f,-0.95790002f,-0.06590001f,-0.42210001f,-0.94259998f,-0.22700000f,-0.67579998f,0.27190000f,-0.08090000f,0.10790000f,-0.53579999f,-0.00770000f,-0.80030001f,-0.35260000f,-0.27329999f,0.02090000f,-0.45530000f,-0.00670000f,-0.11770000f,0.15730001f,1.15789998f,-0.32910001f,-0.53489998f,0.06919998f,-0.52240001f,-0.14340000f,-0.00010000f,0.03639999f,-1.03709997f,0.00610001f,-0.05679998f,-0.36710000f,0.76189999f,1.35240001f,-0.42940002f,0.80129999f,-0.45420000f,-0.86580000f,-1.04349997f,0.15060000f,-0.70100000f,0.82140002f,-0.41450004f,1.00109998f,0.45489996f,0.64860003f,0.04449998f,-0.71370000f,-1.22389997f,-0.96330001f,1.07970002f,0.91170003f,-0.14669998f,0.93480005f,0.36719998f,0.88080000f,1.05569997f,0.58890001f,-1.14289999f,-0.43800002f,-0.70959997f,1.00320002f,-0.12179999f,-0.06360000f,0.15159998f,0.16109999f,-0.28330000f,0.21910000f,0.26470000f,-0.03480000f,0.49559999f,0.02179999f,-0.16240001f,0.15950001f,-0.19589999f,0.07009999f,0.00049998f,-0.33600000f,0.01770000f,0.07330000f,-0.56700000f,-0.09539999f,-0.14979999f,-0.44099999f,-0.07589999f,0.04660000f,-0.17920001f,0.14210000f,-0.25399999f,-0.14389999f,-0.05369999f,-0.06330000f,0.29620000f,0.74970001f,1.25839992f,0.41700001f,0.21649996f,-0.20550000f,0.47770000f,-0.69570000f,-0.04799998f,-0.55799999f,-1.06159998f,-0.53760003f,-0.93969999f,0.33420002f,0.54469996f,0.12779999f,-0.17490000f,-0.32189998f,-1.45579996f,-0.38700001f,-0.93499996f,0.92789998f,0.63269997f,0.56640002f,0.49279997f,-0.13830000f,-0.51839999f,-0.00210001f,-0.27189997f,0.47429998f,-0.44509998f,-0.06130000f,0.98659998f,0.43600001f,-0.25500002f,0.40980001f,0.55100000f,-0.31450000f,-0.07000000f,-0.10730000f,0.63510000f,0.23130000f,1.24599999f,-0.29610000f,-0.68509998f,-0.09070000f,0.10639999f,0.03499999f,-0.62679999f,0.31600000f,0.19289999f,-0.09599999f,-0.44269998f,-0.38890000f,-0.06719997f,-0.16569999f,-1.02060000f,-0.07370001f,0.87559999f,0.01770001f,-1.08529997f,-0.17519999f,1.59019999f,-0.57299999f,-0.78500003f,-0.90240003f,0.28339999f,0.27600001f,-0.11399999f,0.39779998f,1.65329997f,-1.21289999f,0.98880005f,1.02690002f,-0.23890000f,-0.33930001f,-0.36920000f,0.92580004f,0.11400000f,-0.78840002f,-0.35730002f,0.26520000f,-0.59689997f,0.51389999f,0.13560005f,0.68670001f,-1.20780000f,0.16350002f,1.83119999f,-0.18870000f,-0.87469997f,0.12440000f,0.12820000f,-0.21310000f,0.87710000f,0.30990000f,0.84480002f,0.23530000f,-0.59669999f,0.04780000f,-0.93399997f,-0.38190000f,-1.25570000f,0.05879998f,-0.19990000f,-0.02590000f,-0.02990000f,0.14859999f,-0.48079998f,0.24819999f,0.89670001f,-0.11950002f,-0.48969999f,-0.12860000f,0.64220001f,0.16850001f,0.17200000f,-0.16470000f,0.42519998f,-0.26799999f,-0.00930003f,-0.23040001f,0.07100000f,0.27419999f,1.82730000f,-1.39350002f,0.05480006f,-0.35970001f,-1.37929999f,0.14159999f,-1.55079997f,1.55340002f,-0.70870005f,0.74550004f,0.71509998f,0.15510000f,0.12750000f,0.48750001f,-0.08120000f,-0.99630001f,0.63450004f,1.25220005f,0.65329999f,-0.42240002f,0.50580002f,-0.75900002f,-0.52639999f,-0.23310000f,0.30799999f,0.71909998f,-0.49400000f,0.46849999f,-0.33149999f,0.14170000f,0.22120001f,-0.03120000f,1.01959997f,-0.30990000f,0.63339998f,-0.09960000f,-0.00790002f,0.09720000f,-0.15630001f,0.40970001f,0.14950000f,0.34250001f,0.95749999f,-0.17100000f,-0.85959999f,0.16020001f,-0.50400000f,0.14899999f,0.25879998f,-0.26240000f,-0.38709999f,-0.14140001f,0.68009998f,0.16330000f,-0.75499998f,-0.11800000f,-0.11440001f,-0.28499999f,-0.49610000f,0.00720000f,0.59960001f,-0.11549999f,1.77119996f,0.51630001f,1.58139998f,0.90570000f,1.12549992f,0.21570002f,0.10909998f,-0.87510002f,-0.45350000f,-1.28700004f,0.45730000f,0.55110001f,-1.09119999f,-0.48210002f,-1.45639999f,-0.23879999f,0.33959998f,0.75929999f,0.00389998f,0.50760004f,1.85309998f,0.10559999f,-1.12259999f,-0.30570001f,0.19980000f,0.01039999f,-0.53380002f,-0.13380000f,-0.06120000f,-0.01270000f,-0.08300000f,-0.27670001f,0.42619999f,-0.06200001f,0.91629997f,-0.42290000f,-0.43450000f,0.29509999f,-0.40490000f,-0.36389999f,0.58530002f,0.14210000f,-0.08200000f,-0.01050000f,1.14170000f,0.09930001f,0.68900001f,-0.43140001f,-0.50899999f,-0.27259999f,0.60570001f,0.29970000f,-0.21310000f,0.16580000f,0.92220000f,0.93810005f,0.28219996f,0.44610001f,0.34640000f,0.29160000f,0.22939999f,0.56190002f,1.28300000f,-0.23729999f,1.36769997f,0.88319998f,-0.10030004f,0.20010002f,-0.16470003f,-0.07410003f,0.60830005f,-0.13529999f,-0.18240000f,-0.59220003f,1.36990001f,-1.39290005f,-0.48699996f,1.08870001f,0.03099999f,-0.23940003f,0.52350003f,-0.77250000f,-1.13729998f,-0.13530000f,-0.56669999f,0.18020000f,-0.75440002f,-0.08060000f,0.56329999f,0.18900000f,0.67840000f,-0.40459999f,0.15289998f,0.08690000f,-1.03190000f,0.09509999f,-0.61879998f,0.26159999f,-0.31860001f,0.21990000f,1.05640002f,-0.27999999f,0.35039999f,0.14590001f,0.96289998f,-0.09880000f,0.12430001f,0.04230000f,-0.60590001f,-0.11380000f,-0.42759998f,-0.00130000f,0.76510000f,-0.59509999f,-1.03409998f,0.47880003f,-0.58480004f,0.11699999f,1.15629996f,-0.70890001f,0.54360002f,0.48539999f,0.50269994f,-0.02879998f,-1.93089999f,0.62700001f,-0.21560001f,0.25530002f,0.03979997f,-1.21860002f,0.60200007f,0.33809997f,0.82279996f,-0.66810000f,1.09950000f,-0.26940002f,-0.24709998f,1.13100004f,0.44709996f,0.20099999f,-0.67719998f,-0.44370002f,0.85970000f,0.66929999f,0.41309999f,-0.15240000f,0.32440001f,0.05600000f,0.84819996f,-0.01810000f,0.98859998f,0.21370000f,-0.09620000f,0.10160000f,0.31559999f,-0.14610000f,-0.03509999f,-0.26300000f,-0.35419999f,-0.23190000f,-0.68039999f,-0.12670000f,-0.03540000f,0.00350000f,-0.54880000f,-0.06450001f,0.92850000f,-0.21690000f,-0.77569998f,-0.45930001f,-0.52030000f,0.21300001f,0.87089999f,0.27460001f,0.56690003f,-0.08970002f,0.32640001f,-0.23219999f,1.37899995f,-0.54630001f,1.12939999f,-0.31590000f,-0.37779999f,-1.13490000f,-0.84719997f,0.15089999f,-0.02649999f,0.51420001f,-0.27299997f,0.52560001f,-0.85079998f,0.26850001f,0.15820001f,0.14430001f,-0.85480001f,-0.13200002f,1.53429999f,0.64590000f,-0.85069999f,1.02720001f,-0.10810002f,-0.66090001f,1.00910001f,-1.32750003f,-1.30910000f,0.13710000f,0.16600000f,0.17070000f,0.89839998f,0.15270000f,0.62160001f,-0.17460000f,0.58800000f,0.25760000f,-0.05290000f,-0.26640000f,0.01180000f,-0.45930000f,-0.26230000f,0.36680000f,-0.49380000f,-0.21140001f,-1.06789997f,-0.30730000f,0.83890002f,0.14420000f,0.04780000f,-0.06220000f,-0.26509998f,0.07599999f,-0.63470002f,0.22030000f,-0.23749999f,0.08690000f,-1.13290003f,0.07920001f,0.58760001f,-1.20000000f,0.26640002f,-0.44820001f,0.75360003f,-0.59670002f,0.10680002f,-0.92640002f,-1.08989998f,0.78389999f,0.80299997f,1.03169998f,0.39589996f,-0.31710001f,-0.97060001f,1.01160001f,-0.90129999f,0.07949997f,1.37550002f,-0.70290001f,-0.71619998f,-0.18930001f,-0.84529996f,0.85770005f,0.05149995f,-0.32490000f,-0.65529999f,0.88259998f,0.02560003f,-0.17159999f,-0.32789998f,-0.29310000f,-0.55329999f,-0.11869999f,0.23220004f,-0.09220000f,0.87199997f,0.07590000f,-0.48679999f,-0.16730000f,-0.31890000f,0.02620000f,-0.31309999f,0.52350000f,-0.27650001f,0.03289999f,0.55449998f,-0.11960000f,0.16240000f,-0.00950000f,0.31270000f,0.26209999f,-0.04830001f,-0.22780001f,-0.44239999f,0.28770000f,0.84010000f,-0.25310000f,0.56360005f,0.31469999f,-0.39369998f,0.60210000f,-0.56989999f,-0.66510005f,-0.61019993f,0.03810002f,1.62919998f,-0.00840001f,-0.86359999f,0.49530001f,-0.12110001f,0.18750000f,-0.31410000f,-0.48899998f,-0.60950000f,-0.13920000f,0.91469997f,0.09389999f,0.30599999f,-0.34770001f,0.11050002f,0.08850001f,0.33069997f,0.77880001f,-0.03600000f,-0.85170000f,0.77110004f,0.13979998f,-0.15719999f,-0.23540000f,-0.74980001f,-0.03120000f,-0.08020001f,-0.00440001f,-0.36919997f,0.35990000f,-0.03260001f,0.23490001f,1.07560000f,-0.48660001f,0.20900001f,0.23440001f,-0.44389999f,0.02670001f,0.51199998f,0.13640000f,-0.01340000f,0.20930000f,-0.29930001f,-0.12980000f,0.94390002f,-0.11340000f,0.37050000f,-0.22319999f,0.35680001f,0.01750000f,-0.64069999f,0.09960000f,0.45650000f,0.44860001f,0.21190004f,0.67359998f,0.40589998f,0.30510003f,-1.30090003f,-0.90620002f,0.05249996f,-0.74789997f,-0.24149999f,-0.62780002f,0.55510002f,-0.22500000f,-0.73730003f,-1.45599997f,0.68729999f,0.73029999f,-0.01000001f,0.46009998f,0.60260000f,-0.70620000f,-0.21930000f,0.14050001f,0.34960000f,-1.07680001f,0.78190004f,-1.41939999f,0.95059999f,-0.05939998f,-0.34370001f,0.12430000f,0.25730000f,0.08900000f,0.67060002f,-0.16200000f,-0.38520001f,0.19870003f,-0.73150002f,-0.11440000f,-0.32840001f,-0.58089999f,0.12010000f,-0.37680003f,0.70800000f,-0.65800000f,-0.26000001f,-0.02740000f,-0.36860001f,-0.40069999f,-0.70090002f,0.26260000f,0.38900001f,-0.23269999f,0.36950000f,0.32450001f,-0.14450000f,0.33850000f,0.18710001f,0.05459999f,0.56409998f,-0.38270000f,0.63760001f,-0.48659999f,-0.11199998f,0.42589999f,-0.56290000f,0.76350001f,0.41419999f,-0.10100001f,0.61339999f,-1.23269999f,0.88880002f,-1.24010000f,0.20590001f,-0.35929998f,-0.44490003f,0.38520000f,-0.14060001f,0.31609999f,-0.29660000f,-0.09469999f,0.09549999f,-0.42839997f,-0.47589999f,0.21770000f,0.71259998f,0.14189999f,0.20999999f,0.21849999f,0.27880000f,-0.43670003f,0.83270000f,-0.53450002f,0.28970001f,0.06890002f,-0.82850004f,-0.54970001f,0.16089998f,0.26179999f,0.68860001f,-0.63680001f,-0.31000000f,-0.21570000f,0.09690000f,-0.83290000f,-0.48110000f,-0.22880000f,0.09200001f,-0.11779999f,-0.12699999f,-0.24459999f,-0.43580001f,0.41339999f,0.41820000f,-0.19470001f,0.53310000f,0.16730001f,-0.40850000f,-0.73780002f,0.17720001f,-1.48679999f,0.32250001f,-1.36460002f,0.94530000f,0.85910002f,0.05519996f,-1.23319998f,0.88789998f,-0.39350001f,0.11510005f,-0.18320000f,-0.67040003f,-0.62759999f,0.59469999f,-0.38159999f,-0.40050006f,0.25810000f,-1.39349998f,-0.22400000f,0.44619999f,-0.15230000f,0.60109998f,-0.02760001f,0.29620003f,-0.98679999f,0.51570000f,0.99109998f,-0.86639999f,-0.57240001f,-0.13870000f,0.15880001f,-0.10120000f,-0.14980000f,-0.33260001f,-0.27860000f,-0.09580000f,0.41790001f,0.32010001f,-0.46920001f,-0.00600000f,0.11200000f,-0.30640000f,-0.19300001f,0.25780001f,-0.59390002f,0.07189999f,0.40980002f,-0.52140000f,0.66250000f,0.05030000f,-0.01090001f,0.19090002f,-0.56860000f,-0.31340001f,0.25990000f,0.25490001f,0.41470000f,-0.17709999f,-0.31120003f,-0.52820000f,-0.30619999f,1.32859995f,0.52710002f,-0.86630003f,-0.20840000f,-0.09420002f,0.09860001f,0.23850002f,-0.60510000f,0.07249999f,0.42559998f,0.01760001f,-0.31700000f,-0.37560000f,-1.12110002f,0.70899999f,0.71259999f,0.65439998f,1.10689999f,-0.75139998f,0.40640000f,-1.33850001f,-0.51150000f,0.25069998f,0.42690001f,-0.78119999f,0.35929998f,0.71479999f,-1.12090003f,-0.10160000f,-0.07920000f,0.42120001f,-0.09910000f,-0.05930001f,0.73820000f,0.07900001f,-0.61190001f,0.10430000f,-0.51190002f,0.58030001f,0.16350002f,-0.36510000f,-0.04770000f,-0.52470002f,-0.03429998f,-0.14929999f,0.13540001f,-0.07420000f,0.71700002f,-0.19860001f,0.38450002f,-0.44930002f,-0.27090000f,0.51570000f,-0.37040000f,-0.20560001f,0.30700003f,-0.36460002f,0.56640001f,-0.55580000f,-0.26149998f,-0.53709999f,-0.27000000f,0.45450000f,1.22059998f,-0.85799996f,-0.89500000f,0.08949999f,-1.40790000f,0.48180000f,0.35030001f,0.45059998f,0.24569999f,0.44679998f,-0.51260001f,1.36149998f,-0.37889999f,1.36809997f,1.35240003f,-0.61460001f,0.43180000f,1.05349999f,-0.81799998f,-0.02929996f,-0.45719999f,0.44119999f,0.59460002f,0.30000000f,1.08999999f,0.32550001f,0.48280003f,-0.18040000f,0.29280000f,-0.19560000f,0.05170001f,-0.39730000f,-0.09079999f,-0.34840000f,-0.18609999f,-0.28910001f,0.22810001f,0.18589999f,-0.30630000f,-0.09690000f,0.62750001f,-0.35750000f,-0.25690004f,0.49810001f,0.37950001f,-0.04469999f,-0.60719999f,-0.04080000f,-0.33050001f,0.33770000f,0.01230003f,-0.55590000f,0.35219999f,-0.20820000f,0.42710000f,0.95320004f,0.11570002f,1.44769999f,0.15599999f,0.87199998f,0.83090000f,-0.85100000f,0.12610001f,0.21729997f,-0.36470000f,0.91799999f,-0.35959998f,1.02249998f,-0.60290000f,0.70680000f,1.43769999f,-0.70839998f,-0.30390002f,-1.09279997f,0.07649998f,0.96240002f,-1.16280000f,1.00600001f,-1.13100000f,0.88209999f,0.23020001f,0.71169997f,0.83149999f,-0.43590001f,0.09269997f,-0.01560000f,-0.50339999f,0.39899999f,-0.55869999f,-0.06050001f,-0.51250002f,0.11290000f,0.35460000f,0.10980001f,0.46280003f,-0.33320000f,0.13230000f,-0.35550001f,-0.42649999f,0.12409999f,0.70410001f,0.07350000f,0.37260001f,-0.54900000f,0.60779999f,-0.25500000f,0.39270000f,0.30930000f,-0.45240001f,0.07799999f,-0.10160000f,-0.24760000f,0.37789999f,-0.03589999f,0.37980002f,0.24549998f,-1.33779996f,0.73720000f,-0.83829997f,0.46139998f,-0.63890001f,-0.22500001f,0.67380000f,-0.75959997f,1.13740001f,-0.54459998f,0.73730000f,-0.51280003f,-0.79929998f,0.34140001f,0.74760001f,0.10890002f,1.10529997f,-0.25849998f,1.16619997f,-0.37960000f,-0.23040000f,0.92189999f,-0.90100000f,0.59460000f,0.16050000f,-0.10390002f,0.50209997f,-0.00400000f,0.82469998f,-0.39170000f,-0.24320003f,0.67520000f,-0.47700001f,-0.42300002f,-0.59020003f,0.05739999f,0.58500001f,0.06300000f,-0.38510001f,0.62990001f,-0.29080003f,0.46720002f,0.29130001f,-0.11490000f,0.42320002f,-0.04520001f,-0.46200000f,-0.12119999f,-0.26030000f,-0.16450001f,0.26409999f,-0.22810000f,0.58039999f,0.15760002f,0.41660000f,-0.49940001f,-0.41440002f,0.72040001f,-0.31120003f,-0.10800002f,-0.82030001f,-0.28949996f,0.05800001f,-0.52700002f,-0.35379999f,-0.95040003f,0.53850000f,0.26950003f,-1.22909998f,0.32579999f,-0.19950003f,-1.35069996f,-0.02530001f,1.09720000f,0.72730002f,-0.35949998f,-0.90660002f,1.00660000f,0.19920003f,-0.80070002f,0.40479997f,0.31169999f,0.33509997f,0.50550001f,0.63509997f,0.79769999f,-1.23450000f,0.06430004f,-0.75030001f,-0.10530000f,-0.19180001f,0.00460000f,-0.16350002f,0.76830002f,-0.12800001f,0.09560002f,0.02610001f,-0.59130001f,0.27360001f,-0.64800000f,0.39810002f,-0.34050002f,-0.60849999f,0.12970001f,-0.04070000f,0.03710000f,-0.47740000f,-0.18139999f,-0.31190001f,0.28670002f,-0.41269999f,0.11030001f,0.29300000f,0.32620001f,0.08460000f,-0.16380000f,0.35040000f,0.23640000f,0.44480000f,1.52839996f,-0.13240000f,-0.24020001f,-1.01850001f,0.16840002f,0.41989999f,-1.48450000f,0.73090001f,-0.28460003f,0.84979999f,0.24899996f,0.05750001f,1.68759999f,-1.22620000f,0.77850001f,-0.15750000f,0.15860000f,-0.66320000f,0.55379997f,-0.16800001f,-1.09229999f,-1.20730002f,1.31280001f,0.27420000f,-0.50479999f,0.61270000f,-0.77670001f,0.33530001f,-0.29149997f,0.39739998f,-0.10120000f,-0.73609999f,-0.37270000f,-0.46580003f,0.16340001f,-0.37940002f,0.72140000f,0.01419999f,0.68060000f,-0.45129999f,0.33969999f,-0.31730001f,-0.03910001f,-0.39690001f,-0.23310001f,-0.34870002f,0.21910000f,0.44780001f,-0.42980001f,0.25220000f,-0.56540001f,-0.31440000f,0.09840000f,0.25670001f,0.00610000f,-0.41110002f,0.70630001f,-0.07319999f,-0.53160000f,0.47170002f,0.75670000f,-0.44569998f,-0.22580003f,-0.72730002f,-0.00950001f,-1.05899999f,-0.23119997f,-0.83510001f,0.43470004f,-1.29459996f,0.91049999f,-0.46180001f,0.24050000f,0.13210000f,-0.87840003f,-0.01489998f,-1.38760002f,0.67639999f,0.64260000f,1.04680000f,-0.42260003f,-0.36419998f,-0.26179999f,-0.04859999f,0.79569998f,-1.38180002f,0.42990005f,0.33270001f,0.19909995f,0.76980001f,0.35680001f,-0.46160000f,-0.04600001f,0.01300000f,0.12740000f,-0.14920001f,0.04840000f,0.00939999f,0.54140001f,-0.15630000f,0.59910000f,0.57450003f,0.02309999f,-0.65089998f,-0.23830001f,0.62409999f,0.42350002f,-0.19560000f,-0.11760000f,-0.12810001f,0.63210002f,0.46340001f,-0.01339999f,0.47680002f,0.04520000f,0.51969999f,0.37310002f,-0.01670000f,-0.46210000f,-0.34290001f,0.50580002f,-0.97900001f,1.00740002f,-0.31000001f,0.45020001f,-0.36730000f,0.30309999f,-0.73870002f,0.50550004f,-0.61499998f,-0.34449995f,0.27170003f,0.91739999f,-0.69089998f,0.26299997f,0.43249997f,-0.15939998f,-0.07350000f,-0.11990000f,-0.44029999f,-0.72519999f,1.25090001f,-1.47810001f,0.03280000f,1.13280001f,0.42659999f,-0.32369998f,0.75930000f,-0.74060001f,-0.36840001f,-0.36850000f,-0.40120000f,-0.39080002f,-0.19550001f,0.46910000f,-0.27340001f,0.23380001f,0.52290000f,0.31229998f,0.36230002f,-0.78710001f,-0.38179999f,-0.23020000f,-0.65840000f,-0.15160001f,-0.15780002f,0.32340003f,0.22979999f,0.40019999f,-0.35230004f,0.46390000f,0.37950000f,-0.00510000f,-0.64850002f,-0.02830001f,0.34840000f,-0.24040000f,-0.06370000f,0.40570001f,0.77749999f,0.19559999f,-0.37780000f,0.57699999f,-0.71659998f,0.05150001f,-0.21000000f,-0.78099999f,0.13940002f,0.45150002f,1.16510000f,0.08979999f,-0.56749999f,0.70709997f,-0.80379999f,0.30739998f,0.09649998f,-1.33609999f,-0.23259998f,0.28760000f,-0.53250002f,-0.77359998f,0.60400000f,-0.29130000f,-1.31870002f,1.21199999f,0.55099998f,0.24419999f,-0.22929998f,-0.53299999f,0.21929998f,0.40510001f,0.26420000f,0.21460001f,-0.40900001f,0.54579999f,-0.06340001f,0.53500000f,-0.22219999f,-0.19900000f,0.45860001f,-0.19580000f,0.25570000f,0.03590000f,0.42900000f,-0.06179999f,0.51900000f,-0.30300000f,0.11860000f,0.07940001f,0.17320001f,-0.35680001f,-0.23770000f,0.64810001f,0.44110001f,-0.32950000f,0.59750003f,0.01450000f,-0.47090004f,0.39530000f,0.00309999f,0.14210006f,0.17940000f,-0.13480000f,-0.88359997f,-0.32539997f,-0.29529999f,-0.66229997f,0.05210000f,-0.29690001f,1.28460001f,-1.17599997f,0.21350000f,0.14840000f,0.34259998f,0.54440001f,0.66389997f,0.59370000f,-0.05150001f,0.26830001f,0.46430000f,0.20669999f,-0.80989997f,-0.23960000f,0.53349999f,0.72659998f,0.23930002f,1.07040002f,-0.62200002f,-0.75249999f,0.64880002f,-0.52350002f,-0.48060003f,0.14940001f,0.03099998f,0.21380000f,-0.35580003f,0.29100002f,0.56700001f,0.22140001f,0.11790001f,-0.39870001f,0.03480000f,0.31440000f,0.45650002f,0.20949999f,-0.37920000f,-0.50280001f,0.30250003f,-0.41049999f,0.23410000f,0.66950003f,0.16640000f,-0.23480000f,0.43710000f,-0.26789999f,-0.50449999f,-0.15430001f,-0.15590000f,-0.30850000f,-0.59550000f,1.33479999f,-0.76750002f,0.06909999f,0.41969999f,-1.30249996f,-0.48750002f,-0.51330001f,0.79080001f,-0.67739997f,0.94320001f,-0.91610002f,-0.61059999f,0.77619999f,-0.11169997f,1.04640000f,0.12860001f,-0.24580004f,0.25939999f,1.12869998f,-0.34410000f,-0.02919999f,0.75079999f,-0.70760000f,0.87159997f,-0.16530000f,-0.89740000f,0.94090000f,0.23630000f,-0.29000002f,-1.08729999f,0.33980003f,0.34749999f,-0.12069999f,0.54030002f,-0.17670000f,0.67420000f,-0.07299998f,-0.27140003f,0.67100000f,0.08260000f,-0.37060001f,0.19350001f,-0.04590000f,-0.04049999f,-0.16470000f,-0.74150002f,-0.41050001f,-0.26809999f,0.36170000f,0.13020000f,0.16140000f,0.12350000f,0.10330001f,-0.67550000f,-0.01210000f,0.18760001f,-0.02920000f,-0.48830003f,0.29750002f,0.33690001f,0.77740003f,0.38899998f,0.34489999f,0.54130000f,0.65360000f,1.21889999f,-0.70410002f,-0.95320002f,-0.06299995f,0.43690000f,0.04949997f,0.04510000f,0.52660001f,0.00720000f,0.22549999f,-0.32150002f,-0.43500002f,-0.58889997f,-0.20019998f,-0.02699999f,0.07040000f,0.22690000f,-0.38639999f,-0.86989998f,0.10899999f,-0.11220000f,0.82340000f,-0.46550003f,-0.93779999f,0.08710000f,0.17580001f,-0.01040000f,-0.07240001f,-0.47240000f,0.23119999f,-0.48500001f,0.06380002f,-0.23600000f,-0.34000001f,-0.18260000f,0.32660000f,0.47020000f,0.46580002f,0.05450000f,-0.52970001f,0.56460001f,-0.06060001f,-0.21840000f,-0.06600000f,-0.68230001f,-0.06650001f,-0.06970001f,0.65290002f,-0.33030001f,0.48150001f,0.72119999f,0.09240001f,0.29490002f,-0.47850001f,0.23000001f,0.33749998f,-0.69960002f,0.24180001f,-0.06660000f,0.66179999f,0.59700003f,-0.13530000f,0.16560000f,-0.62700002f,-0.08730001f,-0.69299998f,-0.47430002f,-0.38130000f,0.70560002f,-0.28260002f,-0.61559999f,-0.99839997f,0.45210000f,0.67499999f,-0.38550001f,0.49319999f,0.20070000f,-0.57510000f,-0.25470000f,0.18120001f,-0.80640003f,-0.72119999f,-0.51750000f,-0.83729998f,0.34830001f,-0.28190001f,-0.46859999f,-0.64760002f,-0.32049998f,-0.23190001f,0.46939997f,0.64920000f,0.50880000f,0.00260000f,-0.29990001f,-0.33890002f,-1.37679999f,-0.75780005f,-1.11739999f,-0.48960001f,-0.29609999f,0.51390002f,0.33659999f,0.29140000f,0.24259997f,0.59239999f,-0.04049997f,-0.27409999f,-0.23759997f,0.22160001f,0.02140002f,-0.52560000f,0.12500001f,-0.27439999f,0.36609999f,-0.02729999f,-0.66060000f,-0.21029999f,-0.54270002f,-0.56250000f,0.73560000f,0.29369999f,0.33360000f,0.84090002f,-0.06930000f,0.15330001f,-0.52200002f,-0.72089998f,-0.65999999f,-1.04070000f,0.67470002f,-0.27479999f,0.42060000f,0.34980000f,0.90539999f,0.36330000f,-0.46889999f,-0.15900000f,0.03300000f,-0.51179998f,-0.40379999f,0.34770001f,-0.38220000f,0.09149999f,0.25170000f,-0.27740001f,-1.35999998f,-0.64160001f,-1.48580001f,-0.88660003f,0.66530001f,0.34690003f,-1.36939998f,-0.77780001f,-0.27860000f,-0.43280002f,-0.08310002f,0.72070002f,-0.72669999f,-0.52210001f,-0.36950000f,0.59030003f,0.58599999f,1.10180001f,-0.34320000f,-0.29840001f,-0.36710000f,-0.27230001f,-0.01570000f,-0.45790001f,-0.97519997f,-0.66640001f,1.08289997f,0.89410001f,-0.49000002f,-0.28859999f,-0.82859999f,-1.22699999f,-0.71880001f,-0.85140000f,0.67830003f,0.86040002f,-0.56519998f,-0.73319997f,-0.74520001f,-0.45330000f,0.85590001f,-0.18330002f,-0.40709999f,-0.34709999f,0.88530002f,-0.21750001f,0.85619998f,-0.13950001f,-0.14040001f,-0.02760000f,0.06570000f,0.14520001f,-0.65910000f,-0.07709999f,-0.74699999f,-0.74459998f,0.86549999f,0.63719998f,0.58320001f,0.46920003f,-0.61959997f,-1.04160000f,0.64680001f,0.87100004f,-0.19880000f,0.13400001f,0.10150002f,-0.36430001f,-0.60500000f,-0.03680000f,0.35139998f,0.12699999f,-0.17340000f,0.19140001f,-1.23650002f,-0.58770002f,0.44410000f,-0.30210001f,1.25539999f,0.56120002f,0.73599999f,1.00080004f,-0.61270001f,-0.03150001f,0.64070001f,0.50470002f,0.15219999f,-0.51560001f,-0.92440003f,0.77309998f,-0.78959998f,0.09420001f,0.87780002f,0.28590000f,0.21360001f,-0.14040000f,-0.53730001f,0.02850001f,0.07680000f,-0.41250000f,0.23099999f,0.39419999f,0.05820000f,-0.37920001f,-0.36270000f,-0.66600000f,-0.05610000f,0.79530000f,0.26460000f,0.61169999f,0.67980001f,-0.05100003f,0.26010000f,-0.21960000f,0.20370000f,0.06359999f,-0.39900001f,0.45809999f,-0.58260002f,0.49810002f,-0.05189998f,0.24050001f,-0.37700000f,-0.33820002f,1.39549998f,0.63130001f,-0.86950000f,-0.09730001f,-1.36729998f,-0.64810001f,0.16840001f,-0.20020000f,0.03769998f,-0.11230000f,-0.83649999f,-1.03750004f,-0.69409997f,-1.08570001f,1.41560003f,0.56600004f,0.09400000f,-0.66080002f,-0.69019998f,-0.21060002f,-0.58320000f,-0.24640001f,0.44000001f,-0.08360001f,1.30909999f,0.23189999f,-0.01230000f,-0.42120000f,-0.21000000f,-0.07799999f,0.28769999f,0.66149998f,0.00450000f,-0.64650000f,-0.68790000f,-1.06439999f,-0.00360000f,0.44970001f,0.19230001f,0.42060000f,-0.71970002f,-0.03149999f,-0.83250000f,0.04320002f,0.38400002f,0.88680001f,-0.36540000f,0.66000002f,-0.36840001f,-0.73559998f,-0.00480000f,-0.17159999f,0.05520000f,0.59100002f,0.44369998f,-0.94130005f,-0.25219997f,-1.11440003f,-0.08449999f,-0.62990000f,0.92599998f,0.88100001f,0.00720000f,-0.00739999f,-0.61800000f,-0.60300002f,-0.54749996f,-0.93170000f,-0.76480000f,-0.51740002f,1.48989998f,0.72190001f,0.04829997f,0.66430001f,-0.15390001f,-0.77910004f,-1.36600001f,-0.77560005f,-1.23559998f,-0.86640001f,-0.04369999f,-0.31590001f,0.86739999f,0.44000003f,-0.16020002f,-0.22859999f,-0.87600001f,0.44190003f,-0.45149999f,0.35250000f,0.87479999f,0.52349999f,0.19260001f,0.23610000f,-0.27840000f,0.01950001f,-0.86669999f,-0.09149997f,-0.28440001f,-0.24989999f,0.60569999f,0.97319999f,0.31530000f,-0.59160003f,-0.66330003f,0.27180000f,-0.44760003f,-0.59999999f,-0.77219999f,-0.71279999f,0.03749999f,0.47490001f,0.37080001f,0.55769998f,-0.73500002f,-0.16860001f,-1.39169995f,-0.77030001f,-0.93039997f,-0.32420001f,-0.54750002f,0.15090001f,0.84809999f,0.55230000f,1.16560000f,0.58360000f,0.76580000f,0.58200004f,-0.83039998f,-0.31980002f,0.71460001f,-0.15300000f,1.02849996f,0.45689999f,1.17059997f,0.40580001f,-0.37589998f,-0.91530000f,-0.99560000f,-0.50320002f,0.13290000f,0.20690001f,0.48149998f,0.00470000f,0.54149999f,-0.52050000f,-0.69149999f,-0.90809996f,-0.09840000f,-0.47969997f,0.17070001f,-0.53400002f,0.29429999f,0.28529999f,0.52199999f,0.78780001f,0.60420002f,0.51689999f,-0.21840000f,-0.53069998f,-0.30960000f,0.53280001f,0.55409998f,0.88799998f,0.31260000f,0.82079998f,-0.95309999f,-0.05669999f,-0.33120000f,-0.53579999f,0.30930000f,0.16320000f,-0.06030000f,0.36599998f,0.09990000f,0.25890002f,-0.60300001f,-0.07560001f,0.09699999f,0.65100002f,-0.11560000f,0.77200005f,0.47300000f,-0.27400002f,-1.14879997f,-0.54980000f,0.20269996f,0.89070000f,-0.29670000f,-0.85190003f,0.77950001f,0.29710001f,-1.13260002f,-0.74380004f,0.34520002f,0.74200004f,0.27879998f,-0.15640000f,0.23949998f,-0.51130002f,0.34029998f,-0.42970001f,-1.07730000f,-0.37850003f,-0.56950001f,0.72599998f,-0.35160000f,-0.83850001f,0.82500002f,0.05100000f,0.69720003f,-0.46980001f,-0.37200002f,0.42150001f,-0.66479999f,-0.98489999f,0.51389998f,-0.56340003f,-0.66450001f,0.24840000f,0.16110000f,0.45300001f,-0.41340002f,-0.39480000f,0.71580002f,0.01860001f,-0.06180000f,0.41939998f,-0.60330002f,0.29999998f,-0.16770000f,0.76440000f,-0.57210002f,-1.07040000f,-0.19710000f,-1.19630001f,-0.07280001f,0.20160001f,-0.88239999f,-0.49660001f,0.76449998f,1.17010003f,0.66310000f,0.51270003f,0.64599999f,0.09440001f,-0.39359998f,-1.23020003f,-1.34350000f,-0.67130004f,-0.18210000f,-0.14530001f,-0.80430000f,-0.34530001f,0.14029999f,0.76690001f,-1.45080001f,-1.10580006f,0.44280001f,0.24400001f,0.74120000f,0.70780003f,0.43650001f,0.11050000f,0.16690000f,-0.05519997f,0.19560001f,-0.14640001f,-0.74280000f,-0.90870001f,0.88530000f,-0.04500003f,0.69450001f,0.62880000f,0.34560000f,0.84299999f,-0.86520000f,0.49770003f,-0.45390003f,-0.74249999f,-0.12270000f,-0.08880000f,-0.07050000f,-0.30090000f,0.51509999f,-0.43410002f,-0.82320003f,-0.60989999f,-0.04200000f,-0.00660001f,0.61380001f,0.31709999f,-0.11190000f,0.10800001f,-0.42089999f,-0.56890002f,-0.45120000f,0.39220000f,-0.67300002f,-0.05080000f,-0.83929999f,-0.13950001f,-0.78170000f,-0.67930003f,-1.40049995f,-0.88550001f,-0.51050001f,-0.16430001f,0.28489999f,0.84370004f,0.34360001f,1.04140005f,0.42889999f,-0.33770001f,1.00609999f,0.60350004f,-0.27519999f,0.17960000f,-0.22769998f,-0.66230000f,-1.30640002f,-0.67000005f,0.17740001f,0.09400002f,0.81330001f,0.02040001f,0.65520000f,-0.25710000f,-0.02160000f,-0.56550002f,-0.39510000f,-1.00889999f,-0.87810001f,-0.69659999f,-0.76169998f,-0.82349996f,-0.03810000f,-0.26550000f,0.85950002f,-0.02580001f,0.77040003f,-0.36870001f,-0.13890001f,0.74070000f,0.70230003f,0.81629999f,0.15720000f,-0.34259999f,-0.57209999f,0.13290001f,-0.79140003f,-1.09320000f,0.36120001f,0.43170000f,0.12570000f,-0.57850003f,-1.18890002f,-0.78030005f,-0.37970000f,-0.42830002f,-0.41660000f,-0.26400000f,-0.73050001f,-0.67050004f,-0.40549999f,0.00189998f,0.05860005f,-0.78280000f,-0.77549998f,-0.07390000f,0.53589999f,-0.09770000f,-0.06610001f,0.16190000f,-0.14279998f,0.29540001f,1.54910001f,1.19230005f,-0.21829998f,-0.96490003f,0.55820000f,0.06460001f,0.81909998f,0.82470002f,-0.32470001f,-0.48390000f,-0.48030002f,-0.46769999f,-0.39990001f,-0.16110000f,-0.19680000f,-0.21030000f,-0.79890003f,-0.57300000f,-0.27150001f,-0.68249998f,-0.74339999f,0.38130004f,0.20670000f,-0.36599998f,-0.42870000f,0.15119998f,0.22830000f,-0.04380000f,-0.06720000f,-0.64890000f,0.82950001f,0.57779999f,-0.87450001f,0.25110002f,-0.25440000f,0.12659999f,0.87930000f,0.51479999f,0.16530000f,-0.00350000f,-0.57200001f,-0.26760002f,-0.61899997f,-0.25740000f,0.01849999f,0.53670001f,0.09100003f,-0.53860000f,0.96219998f,0.28680000f,-0.75559999f,-0.45100001f,-0.87890000f,-0.15110001f,0.45959997f,0.94180002f,-0.21609997f,-0.43469999f,-0.25290003f,0.42430001f,0.65180000f,0.22420001f,-1.56200002f,-0.94780004f,0.43379999f,-0.09900000f,-0.02449998f,0.24390001f,0.16290000f,0.75120000f,0.08040000f,-0.03299999f,-0.39719999f,-0.63299998f,0.35550000f,-0.38250001f,-0.69119998f,0.10500003f,0.54660000f,1.07310000f,-0.14820000f,-0.18629999f,0.10410000f,-0.46169999f,0.59820000f,-0.30870004f,-0.59189998f,-0.21929998f,0.16770001f,-0.67620002f,0.09360000f,0.36839999f,-0.57840000f,-0.67049999f,-0.02940000f,0.51239999f,-0.00510000f,-0.39300000f,-1.00410000f,-0.33850003f,0.24530001f,-0.00329999f,-0.68059998f,0.02220000f,-0.03469999f,0.28770001f,0.08090000f,0.34610001f,1.47849999f,1.03310002f,0.18010000f,-0.14870000f,0.19659998f,-0.43220002f,0.45179997f,-0.36120002f,-0.09630001f,-0.26150002f,0.33630000f,-0.00570000f,-0.60939996f,-0.10359999f,0.28990000f,-0.45370000f,-0.00939997f,-0.90440003f,-0.35750002f,0.44470001f,0.94670000f,0.21569998f,-0.17010000f,0.03690000f,-0.17339999f,-0.85379998f,-0.03750000f,-0.50460000f,0.41850000f,0.03120000f,0.80069999f,0.71850000f,-0.18930000f,0.17280000f,-0.39660002f,0.37679999f,-0.23760001f,0.68489999f,-0.26910001f,-0.00240000f,0.14070000f,0.47640001f,-0.36060000f,-0.81269999f,-0.27870000f,0.62820000f,-0.83820001f,0.39330003f,0.24450001f,-0.71550002f,0.89550003f,-0.85220003f,-0.73260002f,-0.10760000f,0.74499998f,0.95880001f,-0.30120002f,0.29460001f,0.96390002f,0.42330001f,1.04960000f,0.93200004f,-0.71069997f,-0.78410001f,-0.30789995f,-0.97190001f,0.08630000f,0.45570003f,-0.08320000f,-0.73720002f,-0.20129998f,-0.30490000f,0.84609998f,0.68190002f,0.83329997f,0.24430001f,-1.11490000f,-0.67270004f,0.23749999f,0.38990001f,-1.28919997f,0.64710002f,-0.05520000f,-0.57330002f,0.62640000f,-0.04050002f,0.15660000f,-0.53910003f,0.09089999f,0.35370000f,0.90060001f,0.58979999f,-0.77609999f,-0.35909998f,-0.95969999f,0.08280003f,0.69330002f,0.18390000f,-0.42660002f,0.54240001f,-0.63030001f,-0.44340000f,0.61230000f,0.45029999f,0.23130000f,0.66089998f,-0.33210001f,-0.39269998f,0.49410000f,0.19499999f,-0.38399998f,-0.82150004f,0.27609999f,-0.23810000f,0.34290001f,-0.47110001f,1.33010000f,0.58090004f,-0.78450002f,-0.25710003f,0.34300000f,0.13280002f,-0.08510000f,-0.41550002f,-0.07550000f,-0.10370000f,-0.29000004f,0.58100001f,-0.45779998f,0.00200000f,-0.01189999f,-0.13970000f,0.32790000f,0.26070001f,-0.87149999f,-0.05510001f,-0.30239999f,-0.66520002f,-0.18170003f,0.64310001f,0.11920001f,0.12929998f,-0.19830000f,0.38429998f,-0.39210001f,0.57420001f,0.34050001f,0.73679997f,-0.48390001f,-0.88350001f,0.27480001f,0.42750000f,-0.34050001f,0.15720001f,0.01290000f,0.10050000f,0.82200001f,-0.20250002f,-0.12540000f,-0.56489998f,-0.21930000f,-0.05069999f,0.12210000f,0.04919999f,0.11070000f,-0.59099999f,-0.54120001f,0.10380001f,0.45210000f,-0.61560004f,-0.40440001f,-0.71670004f,-0.86230001f,-1.07130004f,-1.25989996f,-0.72930001f,-1.26130002f,-0.78550003f,0.49619999f,0.81320002f,0.44740004f,0.96560006f,-0.27320000f,-0.83760004f,0.75660000f,0.61140004f,1.54740002f,1.01720004f,-0.12670000f,0.14470000f,-1.09040000f,-0.33660001f,-0.39239998f,-0.08879999f,-1.07999998f,-0.61320002f,1.15379998f,0.36700002f,0.65890002f,0.15250002f,0.67099997f,-0.46889999f,0.03630001f,-0.10750003f,-0.90149996f,-0.61729998f,1.15470002f,1.27340003f,0.30450002f,0.08710004f,0.84239997f,0.49259999f,-0.02220001f,-0.35030001f,0.57150000f,0.68250003f,0.38489996f,-0.26710000f,-0.78629999f,-0.31770000f,-0.78689997f,-0.68970000f,0.54359997f,0.35370000f,-0.35789999f,-0.35990000f,0.19589997f,-0.39970003f,-0.09030004f,-0.62560000f,1.08989996f,-0.24760000f,0.37890001f,0.04360000f,-0.18060001f,0.50420000f,-0.28519999f,-0.14220000f,0.16610000f,-0.70040001f,0.58200002f,-0.32140000f,1.18890003f,0.13039999f,0.46880002f,0.63300000f,0.23360000f,0.09920000f,-0.07580000f,-0.24880000f,0.13590003f,-0.35120000f,-0.16380003f,0.19360001f,-0.17530001f,0.44499999f,0.27309998f,-0.34479999f,-0.13610002f,-0.00679999f,-0.49899999f,-0.60669999f,-0.12120000f,-0.43910000f,0.89550001f,0.43979999f,-0.07230001f,0.31299999f,-1.30320001f,-0.79070001f,-0.74850002f,-0.68600001f,-0.10620005f,-0.59310002f,0.97769998f,0.27499999f,0.26219997f,0.37460001f,-0.37800000f,-0.07060000f,-0.52860003f,-0.04090001f,0.31620003f,0.07480002f,0.88829997f,0.65649999f,-0.78779997f,-0.75889998f,-0.05399996f,-0.14769998f,0.47999999f,0.18199999f,0.60790002f,0.72819999f,1.18810003f,0.23500001f,0.00349999f,-0.66820001f,1.16010001f,0.15139999f,-0.15539999f,0.42019999f,0.04200000f,0.09340001f,0.64490000f,0.04200000f,0.42529999f,-0.01959999f,-0.88160000f,0.39220000f,0.45060000f,-0.13639999f,0.68820001f,-0.35799999f,-0.14019999f,0.13019999f,0.55470000f,0.38339999f,-0.80530000f,-0.21700000f,0.32340002f,-0.00440001f,1.09709997f,0.25249999f,0.05609999f,-0.56009999f,-1.14330001f,-0.50609999f,-0.06810004f,-0.57650000f,0.69329999f,0.21879997f,0.32610000f,0.53920002f,-0.13500001f,-0.42169999f,0.03420000f,0.25150004f,1.09289999f,1.30259999f,-0.38219999f,-0.43219999f,-0.81600000f,-0.70759999f,0.15569999f,-0.11300002f,0.46949998f,-0.12310000f,-0.07769999f,0.49949999f,0.41939999f,-0.23599999f,0.89239998f,-0.36439999f,-0.53180002f,-0.05260000f,0.17139999f,0.03640001f,-0.18630001f,0.06360000f,0.46360001f,0.13980000f,-0.07599999f,-0.27560000f,-0.12940000f,0.32840000f,1.06230004f,0.12940000f,0.16339999f,-0.65219999f,-1.15770001f,-0.05120000f,-1.03070002f,0.38540001f,0.69540002f,-0.09400000f,-0.83630002f,0.24580000f,0.19730000f,-0.40039999f,0.20240005f,0.25410001f,-1.03019997f,-1.23759996f,0.17730001f,0.60200002f,0.07140000f,0.08460002f,0.06180001f,-0.11650001f,0.17909999f,0.02540001f,-0.46380000f,-0.20160001f,0.66180000f,0.50180000f,-0.05130002f,-0.46050000f,-1.28309997f,-0.92739999f,0.20220002f,0.54949999f,1.07970003f,1.26550002f,-0.28080003f,-0.27480000f,0.68490001f,0.76370000f,-0.87599996f,-0.79589999f,1.22189996f,-0.00820000f,-0.35720001f,0.44399999f,0.43910002f,-0.09220000f,-1.30660000f,-0.03580000f,0.59790001f,0.26920000f,0.80270001f,0.53180000f,0.21569998f,-0.41399999f,0.40010002f,-0.46500000f,1.08670000f,-0.34239999f,0.94259999f,-0.34279999f,-1.09300004f,-0.28440001f,0.49230001f,-0.65860001f,0.19970001f,0.49139998f,0.66800001f,-0.11120000f,-0.02540001f,-0.43520001f,-1.29480002f,0.41120000f,0.91739999f,0.70739999f,-0.30870002f,-0.40670001f,0.26790002f,0.64259998f,0.38219998f,0.09770001f,0.70829998f,-0.00650000f,-0.83279998f,-0.61869998f,-0.93330001f,-0.65990000f,-1.01759998f,-1.25429998f,-1.00799998f,-1.25279998f,-0.23219998f,0.28660001f,-1.42350000f,-1.22990001f,0.82109995f,0.35509997f,-0.35640002f,-0.42080000f,-0.81000001f,-0.51580002f,0.46110004f,0.00899999f,0.70519998f,-0.55460000f,0.42519999f,-0.40139999f,-0.69330000f,-0.17240000f,0.25559999f,-0.27500000f,0.87890002f,-0.32080000f,0.58829998f,-0.11360000f,0.81510002f,-0.09600000f,-1.08390001f,-0.35980000f,-0.63469998f,0.66020000f,0.41610001f,-0.33059999f,1.30640003f,-0.00480000f,0.96090001f,0.21460000f,0.55369999f,-0.55559999f,-0.63780001f,-0.20099999f,0.44890002f,-0.69450003f,-1.36649999f,-1.44660000f,-0.93689997f,-0.91839998f,-0.01559999f,0.51470000f,-0.54149999f,-0.35779998f,-0.85020002f,-0.91510000f,-0.50279999f,-0.83149999f,-0.41100002f,-0.60530000f,-0.33629998f,0.30009999f,1.44809999f,1.26529999f,-0.83969998f,-0.93270001f,-0.37440004f,-0.77600002f,0.05669999f,-0.51929999f,-1.16699998f,-0.91809998f,-0.17489996f,0.19760002f,-0.92339997f,0.13980001f,0.99740000f,0.34499998f,0.84349999f,0.05960000f,0.26810002f,0.29780001f,-0.89820001f,0.09899999f,-0.81480002f,-0.31480001f,-0.50270002f,-0.22679999f,0.63130001f,0.17799999f,-0.52890002f,-0.19860001f,-0.50979998f,-0.50039999f,-0.81500000f,-0.33239999f,0.36449999f,-0.05640000f,0.85080002f,0.10680000f,0.01399999f,-0.13760000f,-0.33029999f,-0.15339999f,0.14939997f,-0.10779999f,0.31109995f,-0.32700001f,-0.08760003f,-0.32369999f,0.53850000f,0.35570001f,0.43650000f,0.64859998f,-0.32460000f,0.20319998f,-0.20999998f,0.22810002f,0.16079996f,-0.14630002f,-0.31949999f,-0.19230001f,-0.73679998f,-0.14320001f,-0.39659996f,0.07380000f,-0.36179998f,-0.71009999f,-0.04260003f,-0.38560000f,-0.20699999f,-0.02299999f,-0.23069997f,-0.08949999f,-1.40039993f,-0.40899999f,-0.02959997f,0.65019999f,0.01700001f,-0.07200001f,-0.22420001f,0.40880000f,-0.30100000f,-0.19500001f,0.57069999f,0.55480000f,-0.80399998f,0.69320000f,0.59870001f,-0.37859999f,-0.64440002f,-0.11320001f,1.18280003f,-0.11519999f,-0.38930002f,0.10179999f,0.01750001f,-0.31819999f,-0.11680000f,-0.16239998f,0.26780002f,-0.66280000f,0.39160002f,0.68000000f,0.04440002f,-0.19089998f,1.17509997f,0.66099997f,0.01199997f,0.32300000f,0.95280000f,0.97020003f,-0.37349999f,-0.31400002f,0.80639999f,0.13070002f,1.58399999f,1.47899998f,-0.97049998f,-1.07010000f,-0.04560000f,0.20499999f,-0.55080001f,-0.84800000f,0.40949999f,0.65690001f,-0.61889997f,-0.44429999f,-0.39419995f,-0.46699999f,-1.34639998f,-1.04120000f,1.09979997f,0.41179998f,0.98459997f,-0.35219999f,-0.01940000f,0.11000000f,0.25310001f,0.61440000f,-1.03960002f,0.37720001f,-0.22810002f,-0.41219999f,-0.02880002f,-0.63239999f,0.96830000f,-0.69120001f,1.12730002f,0.16640000f,0.15710000f,0.01420000f,0.84740000f,-0.07659999f,-0.58130000f,0.51640001f,1.37110003f,-0.00799999f,-0.65300002f,0.24080000f,-0.67020001f,-0.01740000f,-0.53560000f,0.11519999f,0.22599999f,-1.38369997f,0.24900000f,0.24820001f,0.97380000f,0.29830000f,1.10400002f,1.36380002f,-0.60449998f,-0.07569998f,-1.12979996f,-0.61719997f,-1.68060000f,-1.72410000f,-0.01200003f,-0.48690001f,-0.02970000f,-0.10970000f,-0.34170000f,-0.48459998f,1.20060000f,1.16210000f,-0.46380002f,-0.99890001f,0.59040002f,0.55580000f,0.22530001f,0.56920001f,0.31379999f,0.31139998f,-0.97769995f,-0.21200000f,0.47369999f,0.00040001f,0.39300002f,0.28300001f,0.13260002f,0.72099998f,0.30700002f,0.44079999f,1.08770000f,0.25159999f,0.46250002f,0.03400000f,-0.32910000f,0.10860000f,-0.77610002f,0.52880000f,0.11900000f,-0.59260000f,-0.53180001f,-0.44379999f,0.06800000f,0.22679999f,0.39249999f,-0.22120000f,0.67190005f,0.60379999f,0.23079998f,-0.41819999f,-0.66010002f,-0.71140001f,0.01919998f,0.13930002f,0.44790000f,0.18680001f,1.26629995f,0.66179997f,0.60779998f,-0.01440003f,0.10139996f,-0.51930000f,-0.04260002f,-0.16770001f,0.43590000f,0.71410002f,1.31340000f,1.38910002f,-1.17569998f,-0.87540000f,-0.59729997f,0.01380002f,0.44459997f,0.34119999f,-0.61019998f,-0.73689999f,0.85409996f,0.08649996f,-0.77669997f,-0.44379997f,-0.08819999f,0.21620000f,1.18120004f,-0.05780001f,0.33380001f,0.01420000f,0.36280001f,0.03380000f,0.36940003f,0.32320000f,-0.14569999f,0.57239998f,0.21029997f,-0.33600001f,0.77450000f,-0.01100000f,-0.67570001f,0.14380001f,0.08000001f,-0.00360000f,-0.46550002f,0.65520000f,-1.54540004f,0.09440000f,0.46120000f,-0.32420000f,-0.71090001f,0.16900000f,-0.54690001f,-0.21860000f,0.19130001f,-0.22880002f,-0.45390004f,-0.80840002f,-0.11910000f,-0.32460001f,-0.05070000f,-0.20779999f,0.38579999f,-0.14960003f,1.06739995f,0.65089996f,-0.82020000f,-0.89530000f,-0.15030003f,-0.22909999f,0.33990005f,0.24390001f,0.01799999f,0.07900000f,1.33140000f,0.99330000f,0.66660003f,1.18440002f,-0.87629999f,-1.05120001f,0.42750003f,0.37970000f,-0.13409999f,0.39750001f,0.26460000f,-0.47540000f,0.80440002f,-0.26680001f,0.19790000f,0.41619999f,-0.37260000f,0.40820000f,-0.11250001f,-0.01500002f,-0.22550000f,-0.74080000f,0.88420000f,-0.17299999f,0.81320001f,0.05020000f,-0.90460001f,0.53580002f,0.01299999f,0.17939999f,-0.30409997f,0.60980000f,-0.55470002f,-0.07980000f,1.50130004f,-0.01760000f,-0.10760000f,-0.34399999f,-0.36710002f,0.42620000f,-0.21230000f,-0.45970000f,-0.66540003f,-0.63200001f,0.67349998f,0.24529999f,0.92070000f,0.85620000f,-0.13170002f,-0.32590002f,-1.25579999f,-0.57110000f,-0.54690000f,-0.66239998f,-0.06150003f,-0.21960000f,1.32270003f,1.36320002f,0.22830000f,-0.07940000f,1.25369998f,0.98869999f,-0.01409998f,0.17590000f,-0.46500003f,-0.93990000f,-0.63479997f,-0.40879999f,0.88710000f,0.69250000f,-0.14129998f,0.04640000f,-0.33900002f,0.09980000f,0.08980001f,0.61279998f,-0.47060000f,0.54799999f,-0.03180000f,-0.02600000f,-1.30300001f,-0.09700001f,-0.10810001f,-0.08420000f,0.05020001f,-0.28679999f,0.01620001f,-0.51059999f,0.10260001f,-0.02600000f,0.01840000f,-0.36800000f,0.00489998f,0.61880000f,0.18729999f,-0.52819999f,0.30889999f,-0.37720001f,-0.18309998f,0.59320000f,-1.08510002f,-0.04510004f,0.23130002f,0.18060001f,1.11119994f,0.65499997f,1.13459998f,0.87399998f,0.03480000f,0.19400001f,0.24570000f,0.82539998f,-0.17129998f,-0.15929999f,-0.62819998f,-0.58900001f,-1.01609997f,-0.77880000f,-0.12120000f,-0.21320001f,-0.67620000f,-0.40460000f,1.10639999f,0.60210000f,-1.09409996f,-0.89309998f,-0.93720000f,-1.03710002f,1.21019999f,0.95670000f,0.84479999f,-0.74400000f,0.46700002f,0.26340001f,-1.03979999f,0.38259999f,-0.09539999f,0.43260001f,-1.02180003f,0.09899999f,-0.80110002f,-0.18420000f,0.56239999f,0.09300000f,0.40789998f,-0.17620001f,0.15159999f,-0.21540000f,0.62069999f,-0.61459999f,-0.24250002f,0.44020001f,-0.68600000f,-0.11140000f,-0.50070000f,-0.32279999f,1.16970003f,-0.11480001f,-0.08130000f,-0.13339999f,1.25949999f,-1.50150001f,0.38850000f,0.11400001f,1.06649999f,1.23839998f,0.87030002f,0.67080002f,0.42570001f,0.59579998f,-0.00989999f,0.55750001f,-0.08850000f,-0.51120000f,-0.59970000f,-0.88410000f,-0.31350000f,0.01720002f,-1.37909997f,-1.25829999f,0.77130002f,0.33910001f,0.05010001f,0.45520000f,-0.46139996f,-0.08569999f,-0.53220005f,-0.80050002f,-0.14429999f,0.11630001f,-0.40259999f,-0.08419998f,-0.03190000f,-0.26959999f,0.04089999f,-0.43140000f,-1.12820004f,-0.15799998f,0.17020004f,0.61659999f,-0.02420001f,-0.32059999f,0.24050001f,-0.19260000f,0.21370000f,-0.15240000f,0.31750003f,0.01000001f,0.06890000f,0.40239999f,-0.06260001f,0.06780000f,-0.40870001f,0.10580000f,0.67110000f,0.19780000f,0.47480000f,-0.23000000f,-0.30889998f,0.55660001f,-0.22810002f,-0.61300001f,-0.54119996f,-0.43169998f,-0.89969998f,-0.76710000f,0.00720008f,0.44000004f,1.04369996f,0.46779997f,-0.55229998f,-0.25799998f,-0.48030000f,-0.51910001f,-0.33299999f,-0.27609999f,0.10199999f,0.30150001f,0.72539997f,0.42009998f,0.10170000f,0.00020000f,0.31170001f,0.36650000f,0.25049997f,0.03070000f,-0.63899999f,-0.76640000f,1.20630000f,1.06830001f,0.16140002f,0.15540001f,1.06040003f,-0.29060000f,1.01040000f,0.19779999f,1.15500002f,0.04420002f,-0.39520000f,-0.04340000f,-0.90620005f,0.55180000f,0.14580001f,0.07120000f,-0.37690002f,-0.34659999f,-1.44860003f,-0.01740002f,0.09240000f,0.04500000f,0.97030002f,0.09200000f,-0.16390001f,0.57140001f,0.65190001f,0.39420000f,-1.04680001f,-0.07559999f,-0.18410003f,-0.47940000f,0.01560001f,-0.08429999f,-0.40950001f,0.41659999f,-0.17410000f,-0.40979999f,0.08540000f,0.81730002f,0.31310000f,-0.16739997f,0.13799999f,0.38340000f,-0.00370000f,-0.11270000f,0.31410001f,0.13300001f,0.15970000f,-0.07680000f,0.00850000f,-0.45980001f,-0.24430000f,-0.30600000f,0.25590000f,0.08190000f,-0.12250000f,-0.14120000f,-0.01610001f,-0.01640001f,0.21340000f,-0.45670000f,0.09660000f,-0.08390000f,0.32629998f,-0.37020001f,-0.30200001f,-0.67920001f,-0.25219998f,0.46450001f,0.68710001f,0.94040003f,0.41620001f,0.10380000f,0.06790003f,-0.95580001f,-0.44380000f,-1.26190002f,-0.56519997f,-0.19389998f,0.06620001f,0.45220001f,-0.11829996f,0.53400001f,0.05299997f,-0.23790000f,-0.58369998f,-0.52509998f,0.67729997f,0.27760000f,0.25649997f,0.04179999f,-0.34179999f,-0.62190000f,-0.14350000f,-0.03650000f,-0.12120001f,0.66530002f,0.17100000f,-0.11810001f,-0.02030000f,-0.80610002f,0.04220000f,-0.59050001f,0.15809999f,-0.39550001f,0.04740001f,0.47390000f,0.35760000f,-0.14600000f,0.07460000f,-0.27060001f,0.29470000f,-0.56210002f,-0.17500000f,0.35020002f,0.09009999f,0.50460000f,-0.18090000f,-0.39449999f,-0.18970000f,0.13130001f,0.01020000f,-0.38040000f,-0.47250000f,-1.50110002f,0.05490000f,-1.12910004f,0.44310001f,1.03460004f,0.06970001f,-0.97410000f,-0.06920001f,-0.60030002f,-0.65619998f,-0.04920000f,0.15110000f,-0.49330000f,-0.55649998f,-0.11169999f,-0.97499996f,0.07270001f,0.23060000f,-0.09060001f,0.37180000f,0.11010000f,0.25159998f,-0.18580001f,-0.07290000f,-0.96870000f,-0.19769998f,0.89540000f,-0.64699998f,0.16939999f,0.04610001f,0.52220000f,0.10990000f,-0.26139999f,0.07970000f,-0.75320002f,0.13910000f,-0.35320000f,-0.21760000f,0.60889999f,0.37460000f,-0.08509999f,0.02890000f,-0.21970000f,0.45970000f,-0.39409998f,0.20499999f,0.67190000f,0.03020000f,-0.33559999f,0.11420000f,-0.70360000f,-0.26119999f,0.31189998f,-0.03350000f,0.20940000f,0.05810000f,0.05560000f,0.37500000f,0.95400000f,0.89679996f,-0.11020001f,-0.43839999f,0.50110003f,-0.19260000f,-0.12620000f,0.26549998f,-0.04830000f,-0.26299999f,-0.46370001f,0.21880000f,0.46639999f,-0.45180000f,-0.38320001f,-0.02049999f,-0.85920002f,0.86719998f,0.82400000f,-0.01270001f,0.79200001f,-0.84550000f,0.14830000f,-0.09139998f,-0.24510000f,-0.38310000f,0.17140001f,0.75189997f,0.40219998f,-0.58979998f,0.23050000f,-0.16800000f,-0.66299998f,0.18440000f,0.06810001f,0.14140000f,-0.09159999f,-0.24470000f,0.25110000f,0.19700000f,-0.11989999f,-0.00760000f,-0.26220001f,0.07980000f,0.36640001f,0.18570000f,-0.35960000f,-0.16080000f,-0.69010000f,-0.22850000f,0.49989999f,0.09270000f,0.77340002f,0.26700000f,-0.49240001f,-0.08050000f,0.62600000f,-0.21550000f,-0.40890000f,0.03020000f,0.36100001f,-0.54079999f,-0.42169999f,0.21750001f,-0.15550000f,-0.03600001f,0.86120000f,-0.39549998f,-0.73650001f,-0.32010000f,-1.31920002f,0.52229999f,0.46080001f,0.45290000f,0.44900000f,0.81049998f,-0.24770002f,0.89179997f,-0.17610001f,0.21019998f,1.10060004f,1.04349999f,0.59910001f,-0.42189997f,-0.86409999f,0.09760002f,-0.23799999f,0.53100001f,0.64120003f,-0.24780001f,0.17490000f,0.02200000f,0.60520000f,0.01210000f,-0.27560001f,-0.25600000f,0.58689999f,0.24190000f,-0.05389999f,0.09970000f,0.21160001f,-0.05870001f,-0.50129999f,0.05470000f,-0.67900002f,-0.08090001f,-0.75449998f,-0.16500000f,-0.66079999f,-0.22940000f,0.22519999f,-0.19390000f,-0.81040002f,0.04830000f,0.42679999f,0.15040000f,-0.44760001f,-0.10780001f,-0.40780002f,-0.16660000f,-0.45220002f,1.21059997f,0.26030000f,0.76899997f,0.26199999f,-0.26949998f,0.76680001f,0.21740000f,0.26430001f,0.52350000f,-0.09940000f,0.64249997f,-0.29669999f,0.24090001f,-0.38220001f,0.16930000f,1.23060002f,-1.00389999f,-0.52340002f,0.80969998f,0.13979997f,0.18800003f,-0.82360002f,0.13129999f,-0.97230001f,0.65509999f,0.46730000f,0.07679998f,0.71070000f,0.89509997f,-0.10180001f,-0.30700001f,-0.73110000f,-0.17380000f,-0.51770000f,0.10510000f,0.03850000f,0.06860000f,-0.42529999f,0.04170000f,-0.70550001f,-0.21130000f,-0.25610000f,0.08510000f,-0.45930000f,-0.16090000f,0.10999999f,0.13550001f,0.89400000f,-0.23970000f,-0.40860000f,0.18159999f,-0.59680000f,0.02070000f,-0.15439999f,0.01049999f,-0.81609999f,-0.08599999f,0.07230001f,-0.26830000f,-0.61030001f,-0.09039998f,-1.16919998f,-0.07829998f,-0.59679998f,-0.51149999f,-0.56080002f,-0.24479999f,0.42840001f,0.14320001f,0.99660003f,-0.04490001f,0.69700002f,-0.14129997f,-0.65479999f,0.48869998f,0.55650001f,0.34100000f,1.08409999f,0.29619997f,0.99519999f,0.63869996f,-0.25650001f,0.00480001f,-0.69780001f,-0.01520000f,0.22670001f,0.26049997f,0.40619998f,0.87299996f,-0.22629999f,0.09919999f,-0.06430000f,0.20989999f,-0.35989999f,0.22470001f,0.11320001f,-0.10320000f,0.50309999f,-0.10720001f,0.02899999f,0.03570000f,-0.06289999f,0.13769999f,-0.11770000f,-0.32310000f,0.13919999f,-0.06300000f,-0.30880001f,-0.19459999f,0.04959999f,-0.29069999f,-0.07170000f,0.13360000f,-0.27780000f,0.08680000f,-0.19199999f,-0.15769999f,0.03560000f,-0.12540000f,0.86180000f,-0.62099999f,-0.95210002f,-0.42099997f,0.19700002f,-0.94619999f,-0.36039999f,0.50599999f,0.40850000f,-0.34710001f,-1.21160001f,-1.15759997f,-0.44490002f,0.85909998f,0.09979998f,0.09400000f,0.56310002f,0.31880001f,-0.58900003f,-0.54809998f,0.17650004f,0.44909997f,0.43449998f,0.59399995f,0.22369996f,0.94259997f,0.76309999f,-0.55359998f,-1.27190002f,-0.58399999f,-0.23480000f,0.03660001f,0.69169999f,0.30900000f,-0.22300001f,0.32780001f,0.37780001f,-0.28400000f,0.03649999f,0.05150000f,0.34850002f,0.17640000f,0.97700000f,-0.20350000f,-0.54760000f,-0.14560000f,0.19579999f,0.13000000f,-0.64360000f,0.20330000f,0.16940000f,-0.10909999f,-0.29860000f,-0.31520000f,0.01360001f,-0.17899999f,-0.73400002f,0.07400000f,0.54240000f,0.08760001f,-0.30740000f,-0.26260000f,-0.12020000f,-0.35230001f,-1.11820003f,-0.96199999f,0.19130000f,0.11870000f,0.80960002f,0.60599998f,0.96060000f,1.36129998f,0.30020001f,-0.01649997f,-0.96190001f,0.04630000f,-0.12880000f,0.08040000f,-0.40180001f,-0.94589998f,-0.32510001f,0.42090001f,-0.90500004f,-0.23740001f,0.03880000f,-0.30960000f,0.49950002f,-0.04000000f,0.13910001f,0.82579995f,-0.78319999f,0.10260000f,0.07920001f,-0.04970000f,0.58190001f,0.16880000f,0.73380002f,0.09450000f,-0.39519999f,-0.05000000f,-0.64379999f,-0.26890000f,-0.99730002f,0.17809999f,-0.34189999f,-0.00110000f,-0.04560000f,0.18360000f,-0.49549998f,0.18830000f,0.69530002f,0.05069999f,-0.56649999f,-0.12820000f,0.57060001f,0.05240000f,0.21930000f,-0.15880000f,0.40399999f,-0.22979999f,-0.09390001f,-0.44289996f,-0.19799999f,-0.38200000f,-0.63810003f,-0.69759998f,-1.15440000f,-0.04740000f,-0.92030002f,0.06750001f,-1.09869998f,-0.05449999f,-0.32710001f,-0.65069999f,0.14940001f,-1.10629999f,-0.19499998f,0.84479998f,0.75500000f,0.17719998f,1.03540002f,-0.39639997f,-0.34299999f,0.61309997f,0.00970000f,-0.33929998f,-1.35730004f,0.29979999f,0.50410001f,0.14409999f,-0.43160000f,0.38809999f,-0.35929998f,0.17920001f,0.06910001f,0.08400000f,0.68289999f,-0.13700000f,0.41419999f,0.07010000f,-0.18650000f,0.12170000f,-0.19890001f,0.27830001f,0.11940001f,0.23870001f,0.76190001f,-0.18880000f,-0.59630001f,0.00520001f,-0.27030000f,0.14440000f,0.15140000f,-0.17950000f,-0.30930000f,0.04330000f,0.36519999f,0.08780000f,-0.57769998f,-0.16970000f,-0.65980002f,0.28620002f,-0.67820002f,0.20560000f,-0.26860001f,0.05180000f,-0.28790001f,0.05100000f,-0.77990003f,-0.56149997f,-0.76249999f,0.88169998f,0.25920003f,-0.17149997f,-0.41679998f,0.13029996f,0.14119997f,-0.14319999f,-0.01330000f,-0.77210000f,-0.66500000f,-0.52380001f,0.88610003f,0.92939998f,0.07719999f,-0.00810003f,0.14829999f,-0.22329999f,0.74640001f,-0.30489999f,0.07390000f,0.11940000f,-0.57670002f,-0.06160000f,-0.08730000f,0.03180000f,-0.11970000f,-0.12180000f,0.25700000f,0.01429999f,0.66369999f,-0.32930000f,-0.29370001f,0.29109999f,-0.44519999f,-0.31389999f,0.55920001f,0.11080000f,-0.08500000f,0.03010000f,0.87010002f,-0.07180000f,0.73660001f,-0.30860000f,-0.38830001f,-0.24790000f,0.57020001f,0.13410000f,-0.08120000f,0.15850000f,0.83500001f,0.23600002f,-0.08659999f,-0.30649999f,-0.75969999f,-0.72199999f,-0.31500000f,0.45749998f,0.00030002f,0.63590000f,1.25680002f,0.25080000f,-0.29630000f,-0.18979997f,-0.53979999f,-0.99880000f,-0.15070002f,0.13479998f,-0.33799999f,-0.87129999f,-0.66620002f,0.08609999f,0.45390000f,0.27150001f,-0.93740003f,0.47159998f,0.54939999f,-0.52149999f,-0.38959999f,0.64129996f,-0.33520000f,0.17760000f,-0.67980001f,0.01530000f,0.36180000f,0.15240000f,0.51410001f,-0.30710000f,0.16619998f,-0.05550000f,-0.68070001f,0.13600000f,-0.59169999f,0.27860000f,-0.38910000f,0.13760000f,0.86510002f,-0.17879999f,0.26770000f,0.15410001f,0.70259999f,-0.13810000f,0.19320000f,0.18010000f,-0.68590001f,-0.13800000f,-0.26440000f,0.01710000f,0.59220001f,-0.45369999f,0.16289997f,0.00159998f,0.03720000f,-0.69219996f,-0.94699998f,-0.65139999f,-0.50569999f,-0.22419999f,0.10890001f,-0.27599998f,1.01120003f,0.23469998f,0.15980000f,0.61419998f,0.32799998f,0.80759997f,0.68669998f,0.19340000f,-0.05790001f,0.38760000f,0.53050001f,-0.57729999f,-0.92899999f,0.84329997f,0.60519999f,0.98669999f,0.24740001f,-0.90649999f,-0.70450002f,-0.78009998f,0.42229998f,-0.13200000f,0.29870001f,0.12900000f,0.56339998f,0.01020000f,0.76620000f,0.14860000f,-0.08239999f,-0.07040000f,0.43629999f,-0.12790000f,0.00960000f,-0.22300000f,-0.22640000f,-0.23280000f,-0.44850001f,-0.08500000f,-0.02960000f,-0.04320000f,-0.38200001f,0.03369999f,0.64590002f,-0.20690000f,-0.54580000f,-0.35110001f,-0.36650001f,0.21290001f,0.61110000f,0.12010001f,0.54620000f,-0.34120000f,-0.65830003f,-0.80799998f,0.15090000f,-0.65040001f,-0.53910003f,-0.10920000f,0.47580002f,-0.26229999f,0.85070003f,0.32059998f,-0.56380000f,0.79469997f,-0.11259999f,-0.16339999f,0.30460002f,1.01509998f,0.45269999f,-0.16010002f,-0.56260002f,-0.18580000f,0.64240001f,0.31109998f,0.78509998f,0.26870003f,-0.57150000f,-0.12849999f,0.30060000f,0.18609998f,-1.01470002f,0.18080001f,0.01850001f,0.06840000f,0.78489999f,0.15720001f,0.42990002f,-0.21720000f,0.60270000f,0.08230000f,0.07820000f,-0.12460000f,-0.06370000f,-0.31510000f,-0.20600000f,0.25380000f,-0.40430000f,-0.17030001f,-0.82399999f,-0.19070000f,0.65220002f,0.02100000f,0.13890000f,-0.13750000f,-0.08850000f,0.15850000f,-0.65090001f,0.13450000f,-0.17179999f,0.18630000f,-0.03180005f,0.47469997f,0.37729998f,0.79929998f,0.53980000f,0.07619995f,0.93609999f,-0.50999999f,-1.03940002f,0.24599999f,0.50530001f,0.44329999f,0.08840000f,0.17350000f,0.09190000f,-0.54749998f,-0.09800001f,-0.44809997f,-0.62919998f,0.05319999f,-0.08720000f,-0.18270000f,0.10700000f,-0.37449997f,-0.66479999f,0.59919999f,-0.02260001f,-0.97889999f,-0.55160003f,0.14089998f,0.06070001f,-0.16269999f,-0.20310000f,-0.26450000f,-0.35900000f,-0.22059999f,0.37040002f,0.03000000f,0.58069999f,0.01120000f,-0.33910000f,-0.12210000f,-0.24520001f,0.02090000f,-0.25609999f,0.41350001f,-0.29950000f,0.08289999f,0.36690000f,-0.08440000f,0.13510000f,-0.03450000f,0.28840000f,0.28369999f,-0.17779999f,-0.14720000f,-0.36540000f,0.24970001f,0.60440001f,-0.19410000f,-0.90160003f,0.78939999f,-0.31480002f,0.03020001f,-0.95339999f,0.19039999f,-0.81480004f,-0.44659997f,0.40430002f,-1.03319999f,-0.16969996f,0.51259998f,-0.31320003f,0.02069999f,0.80930002f,-0.30319999f,0.97090005f,-0.18539999f,-0.09420000f,-0.14229998f,-0.71540000f,-0.48630002f,-0.76510002f,-0.15449999f,-1.02930001f,0.12559996f,0.73759998f,0.44829999f,0.82900003f,0.62799999f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_8item_large_5o3i_uneven_filter_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{8,3,16,16};
    Shape shape_b{5,3,2,3};
    Shape shape_r{8,5,30,29};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{2,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.18389998f,-0.17660000f,0.56449999f,0.85430001f,-0.08990005f,0.13029999f,-0.83639999f,0.07869998f,-1.67409999f,-0.19030001f,-1.12529998f,-0.80740002f,0.37759999f,-0.87740000f,0.59770000f,-0.36739999f,0.77330002f,-0.31230001f,0.58660000f,-0.60969999f,0.21319997f,-0.57440001f,0.25860002f,-0.02400001f,-1.32060002f,-0.46790002f,-1.41860000f,0.64610002f,-0.00550000f,-1.74250005f,-1.11719997f,0.42890001f,0.69649999f,-0.01760000f,0.22369999f,-0.02410007f,0.74559997f,-1.19750001f,-0.07820001f,0.81260000f,-1.21370001f,-0.47550001f,-0.98089997f,0.98730000f,0.40769997f,-0.11279998f,0.36230000f,-0.31960001f,-0.45980000f,0.51120000f,1.86520002f,-0.55259998f,0.21270002f,-0.69250005f,-1.92599997f,-1.29800003f,0.24460001f,-0.56040004f,-0.74570001f,-0.45139998f,0.80440000f,0.18240000f,0.61480003f,-0.24740000f,0.17660003f,-0.00880000f,-1.05139997f,0.26689998f,0.72160000f,-0.84050000f,-0.12899999f,-0.43989999f,-0.51510002f,0.08989999f,-0.22259998f,0.15320000f,-0.26010001f,-0.10770000f,0.06680002f,0.92740002f,0.38560002f,0.08270001f,0.60959997f,-0.95079998f,1.65440003f,0.36000000f,1.72770000f,0.78540002f,-0.16380001f,-0.62640002f,-0.28869999f,0.26940006f,0.33190000f,0.49450000f,-1.72980000f,-0.84610000f,-0.83839996f,-0.25940002f,-1.05929998f,-0.15170001f,-0.40809999f,-0.80939999f,0.75530000f,-0.28220001f,0.05909999f,1.17470000f,-0.83880002f,0.19210003f,2.07400002f,-1.55700004f,-0.31109996f,-0.40479998f,-0.73019998f,0.80520002f,-0.28260003f,-0.93670001f,-0.14000001f,-0.05350001f,-0.85150003f,0.35010000f,0.68340002f,0.39879999f,0.54280000f,-1.04780000f,0.59009997f,-0.31809999f,0.32309995f,-0.38450000f,-0.05510000f,0.07750000f,0.92470002f,0.77979999f,0.34360000f,0.38539998f,-0.07490002f,-0.53780000f,0.09420004f,0.94890001f,-0.50550003f,0.32770001f,0.66599998f,0.09090000f,1.88929998f,-0.45200001f,0.29640002f,-0.11630001f,-1.18969998f,1.94310003f,-0.13230003f,-0.85860004f,1.90829997f,0.29090003f,-0.60340001f,0.26860000f,-0.53960001f,-1.30090001f,0.17689997f,0.83649998f,-0.34360001f,-0.10750000f,-1.17109998f,0.42800000f,-0.54760001f,0.37880002f,-0.01980001f,0.07579999f,0.70759999f,-0.51220002f,-0.37190001f,0.17120002f,-0.01919999f,0.81200000f,-0.78989997f,0.17859998f,-0.40850001f,-0.46139999f,-0.02899999f,-0.59550000f,-1.11779998f,1.12859999f,-0.43259997f,-0.29320001f,0.19780000f,-0.38760000f,0.41600000f,0.41559997f,-0.13900000f,-0.16600001f,-0.10879999f,-0.51819999f,0.19679998f,-0.35450000f,0.06110002f,-0.21000001f,0.20090001f,0.10020000f,-0.89580001f,-0.06730001f,-0.23820000f,0.12930000f,-0.72820000f,-0.40809999f,-1.18370001f,1.38720001f,-1.14520001f,0.65840003f,-0.21070003f,0.19820000f,0.75299996f,0.82000002f,0.35220000f,-0.38390002f,-0.44359996f,-0.78470004f,-0.77579996f,-1.13970004f,-0.25119997f,0.65640004f,0.01290000f,0.74040001f,-1.34550002f,-0.90200002f,-0.75160000f,2.26970006f,-0.95320003f,0.17000002f,0.34540001f,-1.61380004f,1.83570002f,0.13670001f,0.99000001f,-0.89270000f,-1.06039999f,-0.95409999f,-1.08799998f,-0.37010001f,-1.00439997f,0.34129998f,-0.80969999f,-0.01140000f,0.52390002f,-0.42989997f,1.08310000f,-0.55869997f,-0.46710005f,0.31970002f,0.39570000f,0.10350000f,0.18719999f,-0.95520001f,-0.74450004f,-0.03070000f,-0.42200002f,-0.88250000f,-0.06669996f,-0.18759999f,0.22680001f,1.16190001f,-0.43180001f,0.68300000f,-0.08670002f,1.14580007f,0.88780000f,0.27120001f,0.30270000f,1.15070003f,0.45840001f,0.85599999f,-0.35159998f,-0.27480003f,1.31829995f,-0.93229997f,0.33370003f,0.24749999f,-1.24260001f,0.61840002f,-0.67220001f,0.33759999f,-1.14269998f,-0.59490001f,-0.79320000f,-1.95719998f,0.07320002f,0.61389996f,-0.51910000f,-1.05269998f,-1.31109997f,-0.45369997f,-0.97839999f,-0.86610005f,-1.24600001f,0.45879999f,-1.17810001f,0.30929999f,-1.50229999f,0.31799999f,0.40730001f,-0.56879997f,-0.26439997f,0.51569998f,-0.02489999f,0.30710001f,-0.01470005f,-0.64060001f,-0.33800000f,-0.43340001f,0.23439999f,-0.84109998f,0.60189999f,-0.52340000f,0.60739998f,0.57479998f,1.97999994f,-0.50759998f,0.47479998f,-0.61430000f,1.62099997f,-0.62440001f,0.03959997f,0.07909998f,0.34940002f,0.19680005f,-1.44989999f,-0.00590003f,1.08179998f,-0.97219999f,-0.86219999f,1.14190003f,0.06120002f,-1.00480002f,-0.47359998f,0.37349996f,0.17469997f,-1.18759998f,-0.13169997f,-1.63570007f,-0.34870001f,1.04050006f,1.20890001f,0.78579999f,-1.11500000f,0.08200002f,0.97529998f,0.06679999f,0.04589997f,-0.14440000f,1.51589999f,0.46120000f,-1.08939997f,0.36500001f,0.11500000f,-0.71410000f,0.15159998f,0.65479999f,-0.69309999f,0.12939999f,1.58300002f,-0.20889999f,0.75509999f,-0.29600000f,0.89649997f,-0.30740000f,0.66570001f,-0.17979999f,0.24489996f,0.28249999f,0.40100001f,0.60490000f,-1.16310001f,-0.68410000f,0.33380000f,0.36050000f,-0.49110001f,-0.07240001f,-0.32449998f,0.84820001f,-0.29799998f,-0.90690003f,-0.68679998f,1.42560000f,0.42009998f,-0.61719999f,-0.69789994f,0.53990000f,-0.05840000f,0.30410003f,0.11129996f,1.25300003f,-0.70830001f,0.12900001f,0.42839999f,0.90430006f,0.00689994f,-1.44620005f,-1.02109998f,-0.55599999f,0.28760001f,-0.34789998f,0.14200004f,0.09349998f,-0.15159999f,0.52429999f,-0.04330001f,-0.26489999f,0.74660001f,-1.35510005f,0.32409999f,-0.06520000f,-0.23949999f,0.05489999f,-0.94359999f,-0.06799999f,0.22639997f,0.02720000f,-0.80880002f,0.20999997f,0.12520001f,-0.75000000f,-1.12100002f,0.13429999f,0.05259999f,-0.46840002f,-0.30760002f,-0.36239999f,0.09479999f,0.56369999f,1.28510001f,0.26530001f,1.62589999f,-0.36029999f,-0.52580002f,-0.35700000f,-0.11229997f,0.20560001f,0.39150001f,-1.36800003f,0.50360001f,0.15360001f,0.51980001f,0.25340003f,1.85879999f,1.10659999f,-0.33030007f,0.54040004f,0.75820000f,0.07089997f,1.77919994f,-1.36049998f,-0.92089994f,1.81859999f,0.55239996f,-0.04020002f,0.63959997f,-1.00010002f,-0.26570000f,0.43530006f,-1.07339996f,1.52180002f,-1.48310002f,-0.89380003f,-1.24690000f,0.87650001f,-0.50570000f,-0.33000001f,0.64429999f,0.74850000f,1.19460000f,0.35220000f,-0.30910000f,1.01739999f,-1.37020001f,-0.30170002f,-0.24739995f,0.14990000f,-0.39039999f,0.73649999f,-0.77239997f,-0.04319999f,0.55889999f,-0.08130001f,-1.03369996f,0.23339999f,-1.25250000f,0.43899999f,-0.00100003f,-0.15979999f,0.43629997f,-1.04090000f,-0.07390001f,-0.47580000f,0.62259999f,-0.53209999f,-0.70440001f,0.86180004f,-0.35680001f,-0.45310006f,-1.47239999f,0.04590000f,-0.76269999f,0.49770003f,0.82590000f,0.18919999f,0.46570001f,-0.94020005f,0.37220000f,0.68820002f,-1.05170000f,-0.49160004f,1.13199997f,-1.30180000f,-0.21619999f,0.27440000f,0.06130001f,-0.08139999f,0.77320001f,-0.72210001f,-0.45759999f,1.61420007f,1.11140002f,-0.57140000f,-0.92209999f,-0.34589999f,-0.01639995f,-0.50490000f,-0.05150001f,-0.88389999f,0.34830000f,-0.54579999f,-0.76759999f,0.34009999f,0.12970004f,0.00900001f,-0.41510000f,0.41470000f,0.82820001f,-0.84290000f,0.65880000f,0.38889999f,-0.45799998f,0.25039999f,0.17209999f,0.24690000f,0.27640000f,0.57630000f,-0.56960005f,0.31090000f,0.10149999f,0.49820001f,-0.67220001f,-0.23190000f,0.63839998f,-1.27360000f,0.44830001f,0.47849999f,-0.52059999f,0.71680003f,0.54079995f,-1.67450004f,0.89600002f,0.14140003f,1.53369996f,0.92390001f,-0.30139998f,0.28119999f,-1.33379999f,1.16930000f,0.05159994f,-0.98940003f,-0.26510000f,0.66199999f,0.54879998f,-1.21480001f,-0.21329998f,-0.22509998f,0.83369998f,0.17129999f,-0.23350000f,0.49220002f,-1.06560001f,-1.45490005f,0.78570001f,0.53650000f,1.48800000f,-0.57619998f,0.42189999f,-0.37020002f,-1.19720002f,0.76930001f,0.33230001f,0.91829997f,-0.66289998f,-0.31379999f,-0.81340000f,-0.74060000f,-0.20279998f,-0.34470003f,-0.19089997f,-0.07170000f,-0.21959999f,0.16929999f,-0.22659998f,0.27410000f,0.91769999f,0.67729998f,0.26739999f,-0.06830000f,0.56170000f,-0.83630001f,0.65219997f,0.31190001f,-1.60419999f,-0.56389998f,0.83879998f,0.55110001f,1.03609999f,0.50019997f,0.89289999f,0.31129997f,-0.97720009f,0.12920001f,0.09140003f,-1.10410002f,-1.24489999f,-1.30079999f,0.86260001f,1.22619994f,-0.08810003f,0.74420001f,0.41370001f,1.46079999f,-0.40450000f,-0.07909996f,1.66920000f,0.56260001f,0.73320001f,0.18009998f,-0.20670002f,-0.72340002f,0.01039999f,-0.86419999f,1.11949999f,0.43269999f,-0.02830000f,0.29200000f,-0.23719995f,0.04420001f,-1.33769997f,-0.75160004f,0.29350004f,-0.25879997f,-0.35350003f,-0.44560000f,1.31490002f,0.88689999f,0.44960000f,-0.26110000f,-1.86429994f,0.20980000f,-1.02009998f,-0.54239998f,-0.57379994f,0.76379999f,-1.24469999f,0.29899999f,-0.01870001f,-0.29360000f,0.02030001f,-0.66150002f,-1.27249999f,1.22070002f,-0.58000001f,0.84069998f,1.18409995f,-0.22200000f,-1.38880000f,-0.09319996f,1.36730001f,0.35219996f,-2.52100000f,0.69110002f,-0.78900001f,0.92830005f,1.52980000f,-0.70340003f,-0.46760000f,-0.24700002f,0.33280000f,0.44000000f,0.61830001f,-0.81690007f,-1.80329996f,-0.03309996f,1.77219997f,0.27250000f,-0.07280000f,0.07050002f,0.20999995f,-0.29670000f,0.26580001f,-0.42340001f,-0.60449997f,0.37279999f,-0.70839998f,-0.76830000f,-0.47540001f,0.91569999f,-0.33570005f,-1.26129998f,-0.21060000f,-0.44390000f,-0.36199996f,0.55730000f,0.20190002f,-0.34380000f,0.78290001f,-0.00400000f,0.12140002f,-0.06529999f,-0.67490002f,-0.87589997f,0.40950000f,1.00639998f,-0.23020000f,-0.10010000f,-1.04800002f,0.90080000f,-0.80990000f,-1.20649999f,0.39009998f,-0.46520004f,-0.50230003f,-0.55409999f,-1.20180001f,1.02849996f,0.58549996f,-2.25390003f,-0.61340000f,0.27990001f,-0.35249998f,0.00180000f,-0.61519999f,0.81200004f,0.44749996f,-1.81230001f,-0.35709998f,1.07690001f,-1.33600002f,-0.49930005f,-2.28860001f,0.90700005f,-0.30250002f,0.12670004f,-1.93570001f,-0.14040000f,0.93659999f,-0.78249998f,-0.25619999f,0.43289997f,1.36919998f,-0.23780000f,1.38430001f,-0.73200001f,0.52270000f,-0.26200000f,-1.34279999f,0.31159999f,1.43490000f,-0.01839999f,0.84419999f,-0.36630000f,0.64699998f,-0.25610002f,-0.53460003f,0.14989999f,0.63829997f,-0.94440001f,-0.04870002f,-1.17629999f,-0.44500002f,-0.25690001f,-0.73780005f,-0.96290001f,0.96369998f,-1.02360002f,-0.13689998f,0.50980002f,-0.32829999f,1.23140004f,0.16439999f,1.16160000f,0.03959996f,-0.67550000f,-0.15279998f,0.89020004f,-1.26360000f,0.36359999f,1.39689999f,-0.62630003f,-1.26000001f,-0.35770003f,-0.43139999f,0.66280000f,-1.01129998f,-0.19970000f,-0.13069997f,0.68430002f,-0.76820002f,-0.96290003f,0.33080003f,0.56400004f,0.50769997f,-0.49640002f,-0.64840001f,0.41420000f,-0.21510002f,0.16500000f,-0.01910000f,-0.03910000f,-0.94649999f,-0.31400001f,-1.65049999f,0.28090000f,0.38929999f,-0.75500000f,0.18310001f,0.52650000f,0.18980004f,-0.74600000f,0.15720001f,-0.15090000f,-0.76649999f,-0.49869999f,-1.04930000f,0.36310000f,1.09409999f,-0.52720000f,0.20909999f,0.41090002f,-0.56049999f,0.41009997f,-0.04760000f,-0.25080003f,-1.78399994f,-0.51840003f,-1.22520001f,-0.53650003f,-1.82240002f,0.07490000f,0.77650001f,-0.70490001f,-0.53420001f,-0.42630002f,-0.47390000f,-0.20330002f,0.25320000f,0.58630001f,0.62629999f,0.55870000f,0.35029998f,0.55369998f,0.16709999f,0.35120001f,-0.69930001f,-0.65020004f,0.94759999f,0.63230004f,0.36530001f,-0.25160000f,1.17150004f,0.27470005f,-0.62840001f,-0.00260000f,0.47150002f,-0.58120000f,-1.75230001f,-0.52590000f,0.59759997f,-0.19730000f,1.29619997f,0.15619999f,0.84080003f,0.59280002f,0.73890003f,0.89199999f,0.16870005f,0.25829999f,0.17159998f,0.57450002f,-0.08459994f,0.70670000f,-0.17840000f,0.38920000f,1.12090002f,0.36080001f,0.29289999f,0.28629999f,1.34270006f,-0.91330001f,-0.29360006f,-0.79059999f,0.33480001f,0.66600000f,0.06859999f,0.65860003f,0.56020001f,-0.17969998f,0.07120001f,-1.21960001f,-0.28779999f,0.96780000f,0.50200002f,-0.41559998f,-0.05919998f,-0.07690003f,-0.51120001f,0.59400001f,0.22980000f,-0.80380000f,-0.18339999f,0.50680001f,-0.28680002f,0.28929999f,0.52919999f,-0.39200000f,0.44880003f,1.42410003f,0.73240002f,0.24799998f,-0.06349991f,0.19749999f,0.42319998f,0.09630000f,-0.18820000f,0.62610001f,0.34109999f,0.40609999f,0.04459999f,-0.51119998f,-0.60900000f,0.77139999f,0.36660004f,0.14640000f,1.03259997f,-0.06190000f,0.47420001f,0.01380000f,-0.52670000f,-0.11840000f,0.91359999f,-0.51750001f,-1.04370003f,0.12140000f,-1.39639998f,0.56389998f,0.21790000f,-0.22229998f,-1.95670000f,-0.05330001f,-0.14700000f,-0.89080004f,-0.48120001f,0.96530003f,0.16660000f,-0.04329999f,0.30320003f,0.71009998f,0.44820000f,-0.35940001f,-0.02919999f,0.00290001f,-0.17159998f,0.88849999f,0.32420000f,-0.95919999f,-0.31379999f,0.08259997f,-0.13160000f,0.85070005f,-0.10100002f,-1.19700006f,0.00999999f,0.00470001f,0.05460002f,1.76849998f,0.77479999f,-0.43269995f,-0.70950004f,-0.04090000f,0.02690001f,-0.79100001f,-0.34750002f,-0.38329998f,-1.27550000f,0.76890000f,0.54080007f,0.16870000f,-0.49549997f,0.03240000f,0.21040000f,-0.36489999f,-0.31100001f,-0.69649997f,-1.57360001f,-0.62529997f,-0.40510001f,0.34459999f,1.53070002f,-0.39629999f,-1.44890000f,-0.64120001f,-1.20710000f,-0.48779998f,-0.66040001f,0.73200000f,0.62910004f,-0.92239999f,-0.24499998f,0.88460001f,-0.11160000f,-0.39220001f,-0.43220002f,-0.55139999f,-0.02439999f,0.44580001f,0.17600001f,0.24670000f,0.27100001f,-0.94359998f,-0.53759998f,0.72049999f,0.37860001f,-0.08510000f,-0.15179999f,0.65180003f,0.17080001f,0.30980001f,0.13639999f,-1.18660001f,-0.32239999f,0.19380001f,-0.12340000f,-0.70149999f,-0.47039998f,-0.33310004f,-0.55969999f,0.02519999f,1.14959997f,0.79049999f,1.73320001f,-0.83299999f,-1.18720003f,0.12680000f,0.22880001f,0.35140000f,0.03130002f,-0.45899997f,-0.77660001f,-0.06540000f,0.19910001f,0.28119999f,0.20070000f,0.21289999f,0.68210001f,0.34690001f,0.48230001f,0.24180000f,-0.15119999f,-0.17050000f,0.31680001f,-0.23409999f,-0.06110000f,0.08809999f,1.21779999f,-0.33950001f,-0.14299999f,-0.02849998f,-0.32879999f,-0.11559998f,-0.35740000f,-0.32620000f,-0.33520001f,1.19910002f,0.83420001f,0.15289999f,0.57780000f,-1.23780006f,-0.46260002f,0.73620001f,0.05040000f,0.08549999f,0.18300001f,-0.59590003f,-0.28100000f,0.09620000f,-0.43340000f,1.50060005f,0.49960001f,-0.34770002f,0.02239997f,-1.30020002f,-0.58840002f,0.07409998f,-0.16530005f,0.80709996f,1.81889999f,0.35930000f,1.34400000f,-0.22249999f,0.36849999f,0.10669999f,0.05120003f,0.63369998f,-0.61540000f,0.59179998f,0.03590001f,-0.72210002f,-0.23370003f,-0.13440000f,-0.48630002f,0.79289999f,0.83180005f,-0.40490001f,0.40779997f,0.72149998f,1.83030004f,0.58250000f,0.20730000f,-0.80079999f,-1.14000004f,-0.67190000f,-0.85919999f,-0.05110001f,-0.54120002f,-0.68990000f,-0.50560000f,-0.97229999f,-0.97040000f,1.89789998f,0.80320000f,-0.88769999f,-0.44880000f,0.34469998f,0.43759997f,-1.00060000f,-0.20399998f,0.39350001f,-0.08719999f,0.74449999f,0.42680001f,0.55570000f,0.49880001f,-0.10340001f,0.23999999f,1.19529998f,0.73659999f,-0.39559999f,0.33800001f,1.47490001f,0.94320001f,-1.13390000f,0.65430000f,-0.37739998f,0.21980001f,-0.43959998f,0.62599999f,-0.49519999f,0.33299999f,0.87849997f,0.75849996f,-0.22179999f,-0.33399997f,-0.17549999f,-1.11689999f,0.27590000f,0.94330001f,0.28450001f,0.33550003f,0.78839997f,0.34940002f,0.50999999f,-0.29159994f,-0.75599996f,-1.57809999f,0.68599997f,-0.56719996f,0.34330000f,-0.27149995f,0.68280002f,0.03950005f,-1.43850000f,-0.62400000f,0.70939998f,0.47120001f,-0.14009999f,-0.42520000f,-0.83430001f,-0.13199998f,1.68120004f,0.50020001f,0.17709999f,0.56800000f,0.44019999f,0.28539999f,0.58330002f,0.74779999f,-1.05470002f,-0.06599999f,0.27100001f,-0.37320002f,-0.95740000f,-0.35939998f,1.49109998f,0.34679998f,-1.16389999f,-0.35100000f,0.34490001f,-0.14100002f,-0.62769999f,-0.69570005f,-0.52980001f,-0.54280003f,0.45670000f,0.81730001f,-0.54140000f,-0.98320001f,-0.65989998f,-0.38340000f,0.47160001f,-0.51839998f,0.35020001f,-0.01570000f,0.61929999f,-0.05839995f,0.39580000f,-0.87599998f,-0.61259999f,0.00519998f,-0.38979999f,-0.38250001f,0.36429999f,1.45070000f,0.04370000f,-0.47600000f,0.03950000f,0.91780000f,-0.53720000f,-1.25150003f,-0.74689999f,-0.10399998f,-0.00710000f,-0.52120000f,-0.31790000f,-0.04819999f,0.22529998f,-0.14960000f,-0.68820002f,-0.55060001f,0.98440003f,0.32700001f,-0.98020003f,-0.65980002f,1.28750000f,0.49979999f,-0.80679998f,0.16460001f,-0.19660001f,-0.27380000f,1.14280002f,0.61180000f,0.59710000f,0.59340000f,-0.96410001f,-0.42260001f,1.01080003f,0.39800000f,-0.41800001f,-0.52259998f,-0.27499999f,0.53879996f,-0.00620000f,0.19030003f,-0.26190000f,0.01229998f,-0.10870000f,0.29939999f,-0.39969999f,0.15160002f,0.84509999f,1.30160002f,-0.15620000f,0.63350001f,0.83030001f,-0.16359992f,0.06909999f,0.12340000f,-0.76539998f,-1.04209999f,-0.16429999f,-1.20720001f,0.61420000f,0.41950000f,0.39949999f,1.16050002f,0.17260000f,-0.85610001f,0.22659999f,0.11020000f,0.39480000f,0.20079999f,-0.79860000f,-0.66440003f,-0.93480002f,-0.50479999f,0.94520005f,0.11419999f,-0.39480002f,-0.31380002f,-0.98319997f,0.08180002f,0.56739999f,-0.26540000f,-0.37409999f,-0.25000000f,-1.31600003f,-0.52500000f,0.09989999f,-0.15040000f,0.72900001f,0.11920002f,0.31129999f,0.29420002f,0.53590001f,0.08520000f,-0.46050001f,0.02970002f,-0.83199998f,-1.31940003f,-0.21070000f,0.09349999f,-0.75279998f,-0.34060004f,0.15169999f,1.26980002f,0.18750000f,0.56319996f,-0.28370000f,-1.08839997f,-0.37699999f,0.29389994f,0.32940000f,0.91999999f,-0.09100000f,-0.18690000f,-0.92310000f,-0.76569999f,-0.34050000f,-0.08910001f,0.83469999f,0.71960005f,0.15810000f,0.22310000f,0.55979999f,0.84930001f,1.38730000f,0.51700000f,-0.46319999f,0.20460003f,0.66209999f,0.28980000f,-0.74189998f,-0.70160001f,1.19280002f,0.54180001f,-1.30480003f,-0.37060000f,1.19240002f,0.70760002f,0.34030000f,0.14699999f,-1.08899999f,-0.08679999f,-0.06980000f,-0.22520000f,0.35639999f,-0.01020001f,-1.29640005f,-0.44500001f,0.54740002f,-0.45040003f,-0.44610001f,0.07280001f,0.40840000f,0.48069997f,0.70640000f,-0.14389997f,0.62869998f,0.71300000f,0.50429999f,1.09390000f,-0.27359999f,0.34610000f,0.36140000f,-0.32630001f,-0.52640000f,-0.67020001f,0.90980000f,0.82050001f,0.02820000f,-0.80659999f,-0.50369998f,-0.42090000f,-0.39509999f,-0.10240001f,-0.47169999f,-1.06880000f,-0.80810000f,0.37489999f,-0.30010001f,-0.56530000f,-0.09920000f,-0.47319998f,-0.10860000f,0.09199999f,1.06270001f,0.74080001f,0.10429999f,0.05959997f,-0.99220000f,-0.26340001f,0.18750000f,-0.12080002f,-1.01779996f,-0.41679999f,0.03529998f,0.01840002f,0.45700002f,-0.18979998f,0.37910000f,0.41680001f,-0.75239999f,-0.56020000f,0.35149999f,0.36240001f,-0.02180000f,-0.09720001f,-0.11900000f,0.05640001f,0.60180001f,0.43340001f,0.48999997f,-0.15170000f,-0.54909999f,-1.21710001f,0.78839999f,0.67079999f,0.83790000f,0.87220008f,-0.76300000f,-0.47120005f,-0.62729997f,-0.83270000f,0.20710000f,0.58530000f,0.43669999f,1.30459998f,0.48940001f,0.47960004f,0.08190000f,0.13839997f,-0.12190000f,-0.08929998f,-0.42069999f,-0.81650002f,-0.61419997f,-0.99279999f,-0.00100000f,-0.29610000f,0.82170000f,0.40180004f,0.83820001f,0.38000002f,1.12699999f,0.39939998f,-0.73319997f,-0.37140001f,0.51050003f,0.20260001f,-1.48130002f,-0.42799997f,1.68200004f,0.63400000f,-1.27280003f,-0.08219999f,1.47190004f,0.58820001f,-1.04050001f,-0.44959999f,-0.91269997f,-0.87819999f,0.38369998f,-0.14460000f,0.23540004f,-0.23240001f,-1.25030001f,-0.66040001f,0.94169998f,0.50460000f,-0.52139999f,0.31340003f,0.57879998f,0.71130001f,-0.11859999f,-0.32230000f,-0.01060000f,0.55869997f,0.43539999f,0.08679993f,0.51610001f,1.41310006f,0.59579998f,-0.59829999f,0.01629999f,0.14820003f,-0.73329996f,-1.57070007f,0.22729999f,1.46279998f,-0.33270000f,0.85539995f,0.56619997f,1.61039999f,-0.35839998f,-0.07640002f,-0.24829999f,0.16640000f,0.46419999f,0.35730000f,-0.15040003f,0.08160001f,0.25730003f,-0.22999997f,0.25380000f,-0.37380000f,-0.33840000f,0.23420001f,-0.38559999f,-0.66840002f,-0.08840005f,0.36380002f,-0.02259998f,-0.40699999f,0.77700002f,-0.25820002f,0.35420001f,0.67480002f,0.09000001f,0.18880000f,0.12680002f,0.06919999f,-0.76220003f,0.20000002f,0.67909999f,-0.23240003f,-0.49529999f,-0.03100000f,-1.01740002f,-0.46039998f,-0.17650000f,0.16529998f,0.27880001f,1.49449997f,-0.05710000f,-0.40280000f,0.50639999f,1.29220003f,-0.84939998f,-1.42010000f,0.70489996f,1.21160000f,0.15829998f,1.68459999f,-0.12789999f,-0.71150000f,0.45210000f,-0.10710000f,0.22220000f,0.29100000f,0.42569999f,-0.40629999f,0.44939997f,1.37039997f,-0.66759998f,-1.01890000f,0.10430000f,0.43300000f,0.93200001f,0.40960001f,-0.40689999f,-0.10760000f,1.16119999f,0.86260001f,0.17570004f,0.59640002f,0.42770001f,-0.03260000f,-1.34800002f,-0.16119999f,1.20180002f,0.45140001f,0.09659999f,0.22700000f,0.83179999f,0.25079998f,-0.83079999f,0.09760000f,0.36290000f,0.19760002f,0.17979999f,0.39700003f,-0.29020001f,-0.61560001f,0.28739999f,0.21640001f,1.26420001f,-0.13020000f,0.86389998f,0.72550002f,-0.47609997f,-1.13559999f,0.32580000f,-1.14659998f,0.64050002f,0.91700001f,0.67539999f,0.12240003f,-0.81359999f,-0.97330000f,-0.03230000f,-0.76680001f,0.29500000f,0.57480001f,0.67100001f,-0.07739991f,-0.37699998f,-0.71980000f,0.78540000f,0.30150004f,0.70379998f,1.36720001f,0.07020000f,0.37160006f,0.51660000f,0.89870005f,-0.74749999f,-0.42419999f,-0.15590004f,-0.36620001f,0.43100002f,-0.20900000f,-0.37330001f,-0.42400000f,-0.90359999f,-0.50739999f,0.89009999f,0.34920001f,0.32630002f,-0.24040001f,0.27500001f,0.72640003f,-0.54620000f,-0.19699999f,-0.45449999f,-0.36959998f,-0.41200001f,-0.55279999f,1.63789998f,0.71720000f,-0.65819999f,-0.19700001f,-0.63489999f,-0.58519999f,0.37399999f,0.62630003f,-0.79529999f,-0.44800003f,-0.50560001f,0.24589998f,0.08640000f,0.79279997f,0.37679999f,0.96630003f,-0.62660000f,-0.43720002f,0.57940000f,1.25280001f,-0.14420000f,-0.94560002f,0.66590000f,0.16700001f,-0.04340000f,0.27199999f,0.13789999f,0.94270000f,-0.74959999f,-0.57180003f,0.58500000f,-0.00189996f,-0.49640001f,-0.09760005f,-0.50729997f,-0.41039997f,0.43599999f,0.31900002f,1.19029998f,0.71960002f,0.29830001f,0.56660003f,0.03080000f,-0.32020002f,1.05990003f,0.88600003f,0.14620000f,0.43700001f,-0.26990000f,-0.09920000f,-0.29440000f,-0.34460001f,0.38400000f,0.11920000f,-0.67679999f,-0.34840000f,0.73590002f,0.46660002f,-0.25160002f,-0.14420002f,-0.87890000f,-0.52020002f,-0.29590002f,-0.43740003f,1.26509998f,-0.22000000f,0.27050001f,1.48539998f,-0.54440002f,-0.17970002f,0.67560002f,-0.82559999f,-0.14259995f,-1.51040000f,-0.22879995f,-1.31390001f,0.61160000f,-0.28570001f,0.34870000f,0.61210002f,0.56329998f,-0.04450002f,-0.51540001f,0.20039999f,0.33119995f,-0.34670001f,0.42810002f,0.24269999f,-0.62309999f,-1.54520001f,0.13140006f,0.27170004f,0.32249999f,-0.58220002f,0.23059997f,0.46660001f,-0.52839998f,-0.03420001f,-0.30870002f,0.42140000f,-0.11789999f,-0.15699999f,0.39700004f,-0.14719999f,0.11189998f,0.46120001f,0.16280001f,-0.01519999f,-0.45259997f,-0.65380001f,-0.86400003f,0.23560000f,0.83670001f,-0.12640000f,-1.02550003f,-0.37060001f,0.24260000f,0.58039999f,1.34400001f,0.55940002f,-1.08319997f,0.96060003f,1.34060003f,-0.38199998f,0.80539997f,0.61899999f,-0.62270000f,0.00799999f,-0.54390002f,-0.07289997f,-0.86339998f,-0.15090000f,0.37260001f,-0.44880000f,0.52449999f,-0.10959997f,0.69689997f,-0.34080001f,-0.33109996f,0.08590000f,-0.28510000f,-0.26899999f,0.43580000f,0.74150003f,-1.20140000f,0.14499998f,-0.20990003f,-0.34629998f,1.23339997f,2.01170002f,0.00319997f,0.45120003f,0.56269999f,-0.14620000f,0.37510002f,-0.25240000f,-0.37740002f,0.31540001f,1.21449999f,0.27740001f,-0.71779997f,0.58499999f,0.74910001f,0.07520001f,-0.07919999f,-0.02219998f,-0.56859999f,0.58180001f,1.59989999f,-0.15099998f,0.51110000f,-0.19800001f,-1.71160005f,-0.21300001f,1.25090002f,0.29759999f,0.84379999f,0.34200002f,-0.31249999f,0.70399999f,-0.46640003f,-0.49360001f,0.14800001f,0.06910001f,0.70990002f,0.78539999f,-0.00770001f,-0.81830000f,0.92959999f,0.70289999f,0.60659996f,0.03269999f,0.83689999f,0.31600002f,0.55469999f,1.55889999f,-0.13590002f,0.32000000f,0.33310000f,-0.82850001f,0.44720002f,0.97200002f,-1.43500002f,0.07210000f,0.66949998f,0.63629999f,0.91379998f,0.58869996f,-0.18460000f,1.35860001f,1.06830000f,-0.17279999f,-0.85249999f,-0.42900001f,-1.37699999f,-0.43240000f,1.07029998f,-0.00880000f,-0.27060000f,0.14360000f,-0.39939998f,0.49160002f,1.34909998f,-0.59719999f,-0.54219999f,0.49440000f,0.20790003f,-0.20580000f,-0.76490001f,0.07820000f,-0.53820000f,-0.00840001f,0.70900001f,-0.28780000f,-0.33520002f,-0.05900000f,0.68809999f,-0.52180000f,-0.69759998f,-0.62999998f,0.93049999f,-0.83770001f,-0.41429998f,0.63170001f,-1.04309996f,-0.90700000f,0.40580000f,-0.14320000f,0.22400000f,1.10389998f,0.17550000f,-0.63819997f,0.27920002f,-0.21449999f,0.79829998f,-0.15980000f,0.29460002f,-0.09240000f,-0.19560000f,0.14270000f,-0.72080000f,-0.57950000f,0.38730001f,0.06620000f,0.15779999f,-1.00309998f,0.54729999f,-0.06759998f,0.52209999f,-0.35580000f,-1.03729998f,-0.52020000f,-0.95400001f,-0.44219999f,-0.04130002f,-0.49580002f,-0.85740004f,0.83420001f,0.44310005f,0.57320000f,0.63690006f,-0.26060001f,-0.20310002f,0.11280000f,0.60120002f,0.07500000f,-0.22749997f,-0.10140000f,0.24550000f,-0.70300002f,-2.17050004f,0.34940001f,-0.40899998f,0.12399999f,1.36459999f,-0.58020002f,0.21639997f,-1.98799999f,0.39500003f,-0.83850000f,-0.08789997f,-0.23259999f,-0.49519997f,-0.83600000f,-0.38159999f,0.12510001f,0.01459996f,0.35020001f,0.29139996f,0.40090001f,0.63620001f,0.23870000f,0.08070000f,-0.92640002f,0.59250001f,0.12070001f,0.85100002f,-1.51120001f,0.27180004f,0.11220001f,-0.61920002f,1.42340001f,-0.96930001f,-0.19210001f,-0.41419999f,0.42410001f,-0.53550005f,-0.62440002f,0.11459996f,-0.48800000f,0.21419997f,-1.05760000f,-1.33320004f,0.69020000f,-0.02759995f,-0.62119999f,-0.37620002f,0.56859998f,1.61020000f,-0.21339999f,-0.64240000f,-0.13940000f,-0.44720000f,0.35360000f,-0.45599996f,0.50960000f,-0.02379998f,0.58079999f,0.62939998f,0.70240000f,0.71310003f,0.43659999f,-0.51840000f,1.01200000f,0.64260001f,-0.71300003f,-0.51859999f,-0.59170001f,-0.00029999f,-0.96809999f,-0.12719999f,-0.35180000f,-0.22140003f,0.23520000f,-0.96189995f,0.38899998f,-0.12270003f,-0.80520001f,0.81400001f,-0.42130000f,0.35440001f,-0.46519999f,0.44989998f,0.30149999f,0.35239999f,1.53859997f,0.44999996f,0.42849999f,0.03430000f,0.08809999f,0.86849997f,0.81099995f,0.42559995f,0.69570001f,1.14819999f,-0.60439999f,0.01520002f,0.57299999f,-0.42060000f,-0.44039999f,0.89780001f,0.19420001f,-0.44660004f,0.42640001f,0.18470003f,0.61960000f,-0.04099998f,0.09099999f,-0.49630001f,0.78359998f,1.05990003f,0.19720002f,-0.05720002f,-0.45000002f,0.96539997f,-0.45419999f,-1.96429998f,0.29659998f,1.02780000f,-0.45340000f,-1.10290002f,-0.14240000f,1.36689999f,-0.71919996f,0.01100001f,-0.48750003f,0.91809997f,0.80440001f,-0.56059997f,-0.10140000f,1.11799999f,0.55830001f,-0.31640003f,0.42249998f,0.20199996f,0.10829998f,-0.52129998f,0.56919999f,-0.09110005f,0.76670000f,0.67550001f,0.41920000f,-0.75810000f,-1.66449999f,0.64080001f,0.80869998f,-0.79309999f,-0.67210000f,-0.09049996f,0.62360002f,-0.89349998f,-1.34379998f,0.87220002f,0.05880002f,-0.08399999f,-0.68920000f,-0.13540001f,0.12380000f,0.01590002f,-0.13540000f,0.22100002f,-0.53660001f,-0.44670006f,0.15780000f,-0.24069997f,-0.80280003f,-1.14990003f,0.29299998f,0.47769998f,0.29540001f,-0.02869997f,-0.07400000f,-0.10650004f,0.80140001f,0.63870001f,0.51080000f,0.51710002f,-0.67100002f,-1.61130003f,0.33640000f,0.57160003f,0.44010002f,0.72799999f,-0.42749999f,-0.37809997f,-0.33519998f,0.73289996f,0.11729999f,0.10620001f,-0.36340003f,0.12570004f,-0.83960000f,0.05250000f,-0.49970001f,-0.29839997f,-0.56340006f,-0.50509998f,-0.07279998f,0.79729998f,0.86750000f,0.24160000f,1.06610000f,0.03939995f,0.42439999f,-0.22880002f,-0.88100000f,-0.25729998f,0.33650000f,-0.68700002f,0.61590000f,-0.37429998f,0.40000002f,0.65329999f,0.26860000f,0.26519999f,-0.74400002f,0.81179998f,-0.64259999f,-1.47440004f,-0.02060000f,-0.35769998f,-0.48460001f,0.95989996f,0.35480001f,-0.12649999f,-0.51960000f,-0.58250000f,-0.34759999f,0.61840002f,-0.25779999f,0.59229998f,0.07219999f,0.16079999f,-0.00379999f,-0.62759997f,0.44700001f,-0.08849999f,-0.05320001f,-0.36179998f,1.60620001f,0.13959999f,0.75030000f,-0.26960001f,0.36009999f,-1.07319998f,-1.66570002f,0.13010007f,0.00740002f,-0.72840001f,0.14539999f,-1.28539994f,-0.31809997f,0.99889995f,-0.21080001f,-0.68319996f,-0.43409998f,-0.47999997f,-0.10989998f,0.77350002f,-0.11470001f,1.08079997f,-0.84040002f,0.67210001f,0.20790001f,0.93309999f,-0.17139999f,0.05410000f,-0.06170001f,-1.11820001f,0.40480000f,0.55330002f,0.18020002f,-0.65849996f,0.25060000f,-0.20230000f,-0.85520001f,-1.13240005f,0.47320001f,0.82190004f,-0.29600000f,-0.06430002f,0.64200001f,-0.78979997f,0.03800000f,0.89450000f,0.11380001f,0.38059998f,-0.13139999f,-0.28580001f,0.08020000f,1.33850002f,-0.18140001f,-0.40830005f,-0.56860002f,0.46919999f,0.23600001f,0.19180001f,-0.55350001f,-0.12800001f,-0.61269997f,0.80379999f,0.03910001f,0.31489999f,-0.25040000f,-0.54829999f,0.02960000f,-0.57010003f,0.17400001f,0.01020001f,-0.41780001f,0.31929998f,0.92850000f,-0.92599998f,0.09930000f,0.49559999f,0.24900001f,0.18890000f,0.67980000f,-0.32260001f,-0.02100001f,0.86100001f,0.08240000f,-0.74320000f,-0.50200001f,0.81889999f,0.44980000f,0.04820005f,0.27420000f,0.37539998f,0.66800001f,-0.24799995f,-0.31500004f,-0.50640003f,-0.13320000f,-0.02270000f,-0.08460000f,1.28619994f,-0.55900000f,-0.28719998f,0.00900001f,-0.83739998f,-0.42999999f,-0.78030000f,0.51300001f,0.52640001f,-0.70740000f,-0.52870001f,0.63500001f,0.52500002f,0.02120000f,0.74959997f,0.09720001f,0.10100000f,0.33980000f,-0.74089996f,1.36120000f,-0.00050001f,0.10440000f,-0.03060002f,-0.35760004f,-0.97819998f,0.39330001f,-0.25320000f,0.72339997f,-0.84789997f,-1.27699997f,0.07759999f,-0.96930000f,0.80120000f,-0.49870000f,-0.37439996f,0.23900002f,0.19489999f,-0.28219998f,-0.41059997f,0.54170001f,0.47469997f,1.07569998f,-0.28609999f,-0.13399999f,0.19470000f,-0.46990002f,0.36619999f,1.21419998f,-0.49930001f,0.43120001f,-1.18899996f,0.44039999f,0.68849997f,-0.57480001f,-0.80710004f,-0.02359998f,0.96170008f,-0.61379999f,-1.96640005f,0.53960000f,1.17000006f,0.03780000f,-1.27650003f,0.90900003f,2.03510001f,-0.63219999f,-0.44880001f,-1.00179999f,-0.65530000f,-0.35080000f,-1.45270000f,-0.34240000f,0.67819998f,-0.80340002f,-0.77800002f,0.46600000f,-0.13789998f,-0.47979999f,0.95699999f,1.45359997f,-0.57280000f,-0.27280000f,-0.86369998f,-0.39169997f,-0.99169999f,-1.71500001f,0.42500007f,0.27530004f,-0.41100003f,-0.35090001f,0.99389999f,2.21230000f,-0.17840004f,-0.75129997f,-0.11129996f,-1.02789996f,-0.18909998f,-1.38679998f,-0.05029998f,0.44900000f,-1.14120001f,-0.99240001f,-0.48620000f,-0.28500002f,-0.09370000f,0.85530001f,0.48250003f,0.31780001f,0.15539999f,-0.32399998f,-1.13799999f,-0.57700000f,0.43090000f,0.25440000f,-0.70710000f,-0.65400002f,1.16579999f,0.46940001f,-0.36769996f,-0.47099999f,-1.61510002f,-0.44740002f,0.04069998f,0.71100002f,0.09540002f,0.10760000f,-0.22800002f,-0.15220001f,0.71760003f,0.28280001f,-1.39339996f,-0.23440001f,0.90839996f,-0.07020000f,0.29090002f,0.25729999f,1.15429999f,-0.36319999f,0.27200001f,-0.14869999f,-0.95389995f,-1.09510000f,0.81760000f,0.73019999f,-0.61170000f,-1.45730000f,1.61840001f,-0.25059998f,0.50600002f,0.19860000f,-1.17960000f,-0.16760001f,0.13939998f,0.46970001f,-0.39960001f,-0.24669999f,-0.77290002f,-0.93869998f,1.18849998f,1.39549998f,-1.02419998f,-0.64920000f,-0.01100000f,-0.40300002f,-0.08660000f,0.26420000f,-0.43899996f,0.00660000f,0.01819999f,0.99560002f,0.90250002f,0.62700001f,-0.53200000f,-0.37080000f,0.23450003f,0.18880002f,0.07719998f,0.61020001f,0.65230003f,0.23720000f,-0.67149999f,-0.00360003f,0.20519998f,0.30840000f,0.70500000f,0.09480000f,-0.05739997f,0.48360002f,-0.33209995f,-0.75080003f,-0.29480002f,0.29240000f,-1.26980001f,-0.25149999f,0.12929999f,0.70509998f,-0.01630000f,0.70169999f,0.26430000f,0.29999999f,0.60719998f,-0.14179999f,-0.91629997f,0.15480001f,1.01340000f,0.86890001f,0.34269997f,0.14930000f,0.32599999f,-0.02460005f,-0.77909999f,0.29659999f,0.54229997f,-0.71570002f,0.59080001f,-0.52459998f,1.43300001f,-0.37340001f,0.15170003f,-0.99720004f,1.25370000f,1.10829999f,-0.09459999f,-0.19819998f,0.47010002f,-0.21680001f,-0.22490003f,-0.31040000f,-0.13509999f,-0.67360001f,-0.36060001f,-0.36439999f,0.02090000f,0.35320000f,-0.98260001f,-0.40360000f,0.36200000f,0.78420003f,0.39140004f,-0.17559999f,0.31490000f,-0.39099999f,-0.45579998f,-0.37519999f,-0.42939999f,0.74680000f,0.32920000f,-0.08880000f,0.44610001f,-0.58380000f,-0.15260003f,0.51300002f,0.59390000f,-0.05880000f,0.56590001f,-0.31760000f,-0.20599999f,-1.17730000f,-0.30999996f,-0.38259998f,0.49080000f,-0.52990002f,0.67759999f,0.59430001f,-1.05969998f,-0.49769999f,0.64819999f,0.18770003f,0.36300000f,-0.92859998f,0.70269999f,0.06710002f,0.54910000f,0.13789997f,0.30060000f,0.76720003f,0.03799999f,-0.23600002f,-0.12909997f,0.29060001f,-0.46760000f,0.40500001f,-0.54909993f,0.83600002f,0.61600004f,0.65020002f,-0.55829998f,-0.37560001f,-0.29810002f,1.01020003f,0.64800004f,0.41540000f,0.01650001f,-0.14780000f,-0.13660001f,-0.48460001f,-0.56870002f,-0.05420000f,0.04340000f,-0.58280000f,-0.82740000f,0.30260001f,-0.66969997f,-0.19920001f,0.49469999f,-0.65140003f,-0.70470004f,-0.36320002f,0.20930000f,0.49150001f,0.01360000f,0.43040001f,0.31700000f,1.44920003f,0.12959999f,0.15580003f,0.40599997f,-1.17340000f,0.23539999f,-1.06590005f,-0.48440000f,-0.86950004f,-0.68919999f,-0.06839999f,-0.48979998f,-0.55180002f,-0.09480000f,-0.78920007f,-0.74039998f,-0.19039999f,-0.27360000f,-0.96320002f,-0.03120001f,-1.07600000f,0.05999999f,0.17930003f,0.41760000f,0.33850001f,0.22700002f,0.24959998f,0.09010000f,-0.41209999f,-0.26840000f,-0.56070000f,0.23320000f,-0.31420002f,0.13390000f,0.19110001f,-0.19960000f,0.32659999f,0.63930000f,0.64919997f,0.70730000f,0.39900001f,-0.05840000f,-0.47169999f,-0.03890000f,0.42210000f,-0.00800000f,-0.83360001f,-0.93230001f,-0.72299999f,-0.25750001f,0.68219997f,-0.35770003f,-1.13440001f,-0.90710001f,-0.79880003f,-0.48259998f,-0.07429999f,0.15380000f,-0.95640004f,-0.27180000f,-1.35050000f,0.10139999f,-0.09449999f,0.19019998f,0.20969998f,-0.69219999f,-0.04320000f,-0.28979999f,-0.37300000f,0.31519999f,-0.49230001f,0.01720000f,0.32680001f,-0.03980000f,-0.13589998f,0.74659999f,-0.05160002f,-0.15699999f,0.54980000f,-0.83259997f,0.90080004f,-0.14900001f,0.99720002f,-0.40150001f,0.25290001f,0.10930000f,0.42860001f,-0.63630002f,-0.53949999f,-0.20440000f,0.84499998f,0.35390002f,-0.05030000f,0.09990000f,0.60619999f,0.17969998f,0.27919998f,-0.81260001f,-1.08709998f,-0.82159999f,0.10470000f,0.05740001f,0.74620001f,0.23200001f,-1.12570001f,-0.87910000f,-0.11179999f,-0.69170002f,0.11549999f,-0.57919999f,-0.51939997f,-0.10039997f,0.57700000f,0.01520000f,0.98590005f,0.25940000f,1.27010003f,0.11539999f,0.39509997f,-0.76699999f,0.18989997f,-0.43799998f,0.81950000f,-0.29899999f,0.87940002f,0.02279999f,1.36630001f,0.24539998f,1.64760000f,0.26299998f,0.34510000f,-0.26479999f,-0.74550001f,0.71319999f,0.91650000f,0.04300001f,2.05150002f,-0.12540000f,0.45549998f,-0.51679999f,-0.41130001f,0.18919999f,0.94129997f,0.85889999f,0.53279999f,0.51080001f,-0.80389998f,-0.53250001f,0.39940000f,0.24100000f,0.20760000f,-0.26839999f,-0.61949997f,-0.01349999f,0.82519998f,0.13679998f,0.25749999f,0.45490000f,0.56450000f,0.34050000f,-0.06080000f,0.13050001f,-0.44300000f,0.21660001f,0.52820000f,0.09540000f,0.06830000f,0.42089999f,1.03859997f,0.63019998f,0.49800001f,-0.25639999f,-1.05730001f,-0.16440000f,-1.02029997f,0.87839997f,0.24490000f,-0.19040000f,-0.16020001f,-0.29240000f,0.62210000f,0.04919998f,0.67470002f,0.11079999f,0.13350000f,-0.53159998f,0.12900002f,-0.14640000f,-0.63190002f,-0.14100000f,-0.91540003f,0.10160000f,-0.20800001f,0.04680000f,0.35690000f,0.08880000f,0.14469999f,-0.07359999f,0.19590004f,0.37609998f,1.11089999f,1.32489999f,0.66860000f,0.63920000f,-0.04030000f,0.27090001f,0.27740000f,-0.21910002f,-0.54930003f,-0.11130001f,-0.07170002f,0.28540000f,0.41390001f,-0.34810002f,-0.12480000f,0.18870000f,0.80310000f,0.74320001f,0.57990001f,0.80550000f,1.33770000f,0.71349999f,-0.56680002f,-0.43169999f,-1.32039999f,-0.70909999f,-0.06039999f,-0.80030001f,-1.01119999f,-0.44599998f,-1.48149999f,-0.01680001f,-0.92570000f,0.39199998f,-0.76570002f,0.19980000f,-0.71030003f,-0.56359997f,-0.17379999f,-0.55659997f,0.81240006f,0.24880001f,0.88430003f,0.01380000f,-0.22230000f,-0.61859999f,0.28320004f,-0.02720000f,-0.37779998f,-0.26759999f,-1.71110004f,-0.20579999f,-0.11859999f,0.68579999f,0.66940001f,0.63859999f,1.24250001f,0.10730002f,0.05500001f,0.10580001f,0.29240000f,0.52730000f,0.76839998f,-0.17020002f,-0.45860002f,0.49330000f,-0.22279999f,-0.63489998f,-0.79379997f,-0.01359999f,1.02059999f,0.75170000f,0.57860000f,0.42230000f,0.39019999f,0.34790000f,0.00260000f,-0.41359998f,-0.64799997f,-0.96619998f,-0.36629999f,0.10110001f,0.40720000f,-0.20699998f,-0.38439999f,0.21540003f,-0.30410006f,0.52999999f,-0.02360004f,0.36299998f,-0.02800003f,0.58799998f,-0.88760005f,-0.57779997f,-0.98279996f,0.58659997f,-0.07780003f,-0.02639999f,0.51499999f,-0.33940000f,-0.31620001f,-0.22060000f,-0.60420002f,-0.64819997f,-0.41280000f,-0.51559999f,1.22059999f,0.09359999f,0.86649999f,-0.56079998f,0.16550001f,-0.56999998f,0.27279994f,-0.76639998f,0.59690000f,-0.28240003f,0.37879997f,-0.23040002f,0.36020001f,0.35280001f,-0.25900000f,-0.51580001f,0.34740001f,-0.48150001f,-0.46370002f,-0.25959999f,-0.31720000f,0.07900002f,-0.19449999f,-0.21699998f,-0.70269999f,-0.34549999f,0.01460001f,-0.25849999f,-0.32859999f,0.31549999f,1.18389997f,0.27350000f,-0.92759997f,0.04700002f,0.43050001f,-0.01600000f,-0.84029999f,-0.21490002f,0.26660004f,0.43839999f,0.39339999f,-0.68199998f,0.24400003f,0.57799998f,1.34220002f,-0.05900001f,0.62149997f,-0.26379999f,-0.16910004f,-0.41559999f,-0.67990001f,-0.18460000f,-0.68060003f,-0.39279998f,1.15190002f,0.05379998f,0.63460001f,0.56339999f,-0.41310003f,-0.26519999f,-0.72150000f,0.14360000f,-0.38649999f,0.13219999f,-0.34519997f,0.59799999f,-0.07299999f,0.02830000f,0.37799998f,0.42759999f,0.42779999f,0.14049999f,0.31949998f,0.02919999f,0.17300000f,0.30390001f,0.46550003f,0.16920000f,0.30989999f,1.04320003f,0.53510002f,0.15140002f,-0.28769996f,0.25000002f,0.35909999f,-0.05120000f,-0.12269999f,-1.10280000f,-0.90610000f,-0.67530000f,-0.40990000f,0.75340002f,0.71430000f,0.20100000f,-0.81860001f,-0.59200000f,0.93240002f,-0.10040000f,-0.03879998f,0.31059999f,0.14629998f,-0.12659998f,0.61090000f,0.06060000f,0.22550001f,0.31619998f,-0.66580004f,-0.49979999f,-1.03300000f,0.39500000f,-1.36940007f,-0.35500000f,-0.21460001f,-0.36619999f,1.18120003f,0.34339999f,1.27979998f,-0.14679999f,0.20639997f,-0.38859999f,-1.13880001f,0.05660000f,-1.19770004f,0.03240000f,0.38790001f,-0.35490000f,-0.74309999f,-1.04300000f,-0.61019999f,-0.19749998f,-0.45499998f,0.10200000f,0.86620002f,0.38400000f,-0.46410001f,0.02170001f,-0.65889997f,-0.54250001f,0.22709997f,0.22949999f,0.17630000f,0.44500000f,-0.06100000f,-0.02420000f,0.41710001f,-0.33220001f,0.61220000f,0.40029999f,0.97219999f,0.61480000f,0.35230000f,0.38740000f,0.38859999f,0.56710000f,1.27780003f,0.27979998f,1.23430002f,0.12020000f,0.10240000f,0.93159998f,-0.51040001f,0.05679998f,-1.06270001f,0.13560000f,-0.99799998f,0.68239997f,0.62439999f,-0.21319999f,-0.07900000f,0.18459999f,-1.14129999f,0.29279998f,0.88190005f,0.30979999f,1.78610002f,-0.18019998f,0.17959998f,-0.64359999f,-0.01409999f,-0.49659999f,-0.13549999f,-0.29379999f,-0.43069999f,0.04949998f,-0.16890000f,0.49019999f,0.77549997f,0.59169999f,0.24529999f,0.78940001f,0.33039999f,-0.27930001f,-0.77330002f,-0.05310000f,0.05170000f,-0.35880001f,0.04139999f,0.25910002f,-0.76669998f,-0.40799999f,0.01560001f,-0.28210000f,0.08720000f,-0.44600000f,-0.58669999f,-0.44370000f,0.46510002f,-0.05690000f,-0.14420000f,-0.22430002f,0.35279999f,-0.18450001f,-0.87490003f,-0.43899999f,-0.52480000f,-0.62799998f,-0.42239998f,-0.42979998f,-0.63470001f,0.54859999f,-0.85650006f,-0.14000000f,0.18600002f,0.35219999f,-0.12170003f,-0.74979998f,-0.78389999f,0.26419999f,0.53090000f,0.07619999f,1.07360000f,0.18279999f,0.65770000f,0.32439999f,1.50540004f,0.20160000f,0.48250001f,0.54460000f,0.32039999f,-0.26899999f,1.15700001f,-0.24850000f,-0.57539999f,-0.74800001f,-0.32880001f,0.61600003f,-0.01519997f,0.27650003f,-0.45430000f,-0.82460000f,-0.91179996f,-0.09939999f,0.76379997f,0.68449998f,0.85659998f,0.93630000f,0.41050000f,0.10500000f,-0.34780000f,0.31100000f,0.36149999f,-0.42770001f,-0.51300000f,-0.72939999f,-0.56819997f,-0.55129999f,0.05180000f,0.08750000f,0.35510000f,-0.00989998f,0.85580005f,0.21079999f,0.21139998f,-0.58439998f,-1.74860003f,-0.04420000f,-0.67290002f,0.51299999f,0.66250001f,0.61479997f,-0.17900003f,0.02140000f,-0.53300002f,-0.48019999f,-1.03190000f,-0.01980002f,-0.53910001f,-0.24440000f,-0.13269998f,0.38599998f,0.50750000f,-0.10360000f,1.37420001f,0.40339998f,0.62419999f,-0.08700000f,-0.32790003f,-0.63559999f,0.10280001f,0.40269998f,0.60519999f,-0.01979999f,-0.98809996f,-0.12479998f,-0.08470000f,0.03789998f,-0.54370003f,0.78229999f,1.25940002f,0.46230001f,-0.59580002f,0.21200000f,0.76330000f,-0.73400001f,-1.48830000f,-0.41330000f,0.70099998f,1.03079998f,0.74329997f,0.61919997f,0.62509998f,0.48949999f,-0.73340000f,0.06700001f,0.33799999f,-0.15070001f,-0.33149999f,-0.03989999f,0.01230001f,-0.71879998f,0.07850003f,0.11980000f,-0.48900001f,0.43319999f,-1.53340001f,0.08960000f,-1.27749997f,-0.23300002f,-1.24240002f,-0.32999998f,0.19810001f,-0.32939999f,1.36840000f,0.18799998f,0.58330003f,0.08999999f,-0.90389998f,0.50739999f,-1.14300000f,-0.18279999f,-1.13410000f,0.63719998f,-0.62640005f,0.50179999f,-0.69270004f,-0.34039999f,-0.04259996f,-0.01490001f,0.49420000f,0.41259999f,0.70619998f,0.67160000f,-0.17849999f,0.09019999f,0.64450000f,0.55220003f,-0.23139999f,-0.30770002f,1.15869999f,1.18389998f,0.98769999f,0.55090000f,-0.53350000f,-0.55090001f,-0.41200001f,-0.03569999f,-0.31960000f,0.14460000f,-0.23680002f,0.30259998f,0.88159997f,0.26710000f,-0.91419997f,-0.52879999f,0.11970000f,0.44590001f,1.19750001f,-0.35599999f,0.39040001f,-0.14120001f,-1.08609999f,0.48619998f,-0.54080001f,-0.58899999f,0.13710000f,0.81299998f,0.52729999f,-1.00159997f,-0.00219993f,-0.11120000f,-0.98560001f,0.55799999f,-0.52070004f,-0.47420000f,-0.27480000f,-0.02040000f,-1.12080003f,0.06160001f,-0.39300000f,-0.68299997f,0.13620004f,0.73199997f,0.01069998f,-0.03160000f,0.09480001f,0.14139999f,0.26779999f,0.34520001f,-0.26559998f,-0.94459999f,-0.68009998f,-0.30769999f,0.14880000f,0.68710002f,0.00990000f,0.14590000f,0.19020001f,-0.81900001f,-0.39190001f,-0.23360000f,0.16050000f,0.28880003f,-0.27339997f,-0.00309997f,-0.08879999f,0.03050001f,0.77680000f,0.75779999f,0.99469999f,1.25660002f,0.95660002f,0.57690001f,0.95820001f,0.22370002f,-0.22559999f,-0.56279998f,-0.10460000f,0.25119998f,0.73389999f,-0.52560000f,0.41070000f,-0.69539999f,-1.30050001f,0.03639999f,0.29950003f,0.05519999f,1.63730002f,-0.25779999f,0.50740000f,-0.32059999f,-1.06450004f,-0.10500000f,-0.02680004f,-0.05780000f,0.26439997f,-0.61959999f,-0.19229999f,-0.94699998f,-0.27669997f,0.12220000f,-0.22100005f,-0.74099998f,0.06329999f,0.44929999f,0.27589999f,-0.23400001f,0.42270001f,0.11869999f,0.21010000f,0.74040000f,0.66320000f,0.62559999f,0.45729999f,-0.11300001f,0.46500000f,0.50280001f,-0.49260000f,-0.45130002f,0.02739999f,0.45690000f,0.45489998f,0.59879998f,1.04939997f,0.56239998f,0.45199998f,-0.53970001f,-0.25259998f,0.05520001f,-0.13110001f,-0.04600001f,0.25640001f,-0.50100000f,0.72590003f,0.28299999f,1.41720004f,0.14600000f,0.13040001f,0.10459999f,-1.18930000f,0.08559999f,-0.17449999f,0.27299999f,0.41809998f,-0.61039998f,-0.69100000f,0.51699998f,-0.36020001f,-0.76459999f,0.22690003f,-0.04260000f,0.05490000f,-0.18399999f,0.64800002f,0.32179999f,0.53819999f,-0.60359999f,0.49650004f,0.27100000f,0.53270001f,0.46479997f,0.82949999f,0.68429998f,0.74629995f,0.11049997f,-0.05020000f,0.07139999f,0.52530000f,0.56530002f,-0.12390000f,-0.75050003f,-0.67360001f,-0.26189999f,-0.10830000f,0.24260002f,-0.01340000f,0.28170001f,0.08730000f,0.15740000f,-0.16380000f,0.67720000f,0.48859998f,0.48589998f,0.15849999f,0.47500001f,-0.41189999f,0.19360001f,0.42350000f,0.08400000f,-0.39930000f,-0.89690001f,0.34799999f,-0.60899999f,-0.86179998f,1.66679997f,-0.02039995f,-0.29260003f,0.70110005f,-0.71580000f,0.60130003f,-0.95040002f,1.16820000f,-1.17279999f,0.98249998f,-0.73459999f,0.55549999f,-0.01319998f,-0.08650004f,-0.33060000f,-0.06390006f,0.08140002f,0.73300001f,-1.00300001f,-0.17030000f,0.30179999f,0.48840003f,-1.40140002f,0.57500005f,0.49120001f,0.04389999f,0.36250000f,-0.02410000f,-0.79040001f,-0.13510000f,-0.75310004f,-0.34110001f,-0.96730006f,-0.15490001f,0.35259998f,0.17730000f,0.35540000f,-0.11790000f,0.27789998f,0.16049999f,0.64330002f,0.20740001f,0.35870002f,-0.16820000f,0.01569999f,0.16190000f,-0.42600001f,-0.09190001f,-0.65320004f,-0.30470000f,-0.29950003f,0.01570000f,-1.33780005f,-0.40010001f,-1.57800010f,0.23389999f,-0.35699998f,-0.26840001f,0.38120000f,-0.90700005f,0.27680001f,-0.97690005f,0.13060003f,-0.05229998f,0.04959997f,0.72089999f,-0.71419999f,1.11809999f,-0.74419997f,0.46890001f,-0.38040001f,-0.39300000f,0.48140000f,0.24000001f,-0.38000000f,-0.97760002f,1.11700003f,-1.20500005f,0.68820000f,0.86879997f,-0.98339996f,-0.04150001f,1.27900001f,-0.05040006f,0.44990002f,0.09940000f,0.79140005f,0.31590001f,-0.07949997f,-0.11670000f,0.12329998f,0.05530000f,-0.01939999f,-0.11960000f,-0.03879998f,0.16030000f,0.47130001f,0.15799999f,-0.80530002f,-0.24410000f,-0.80870002f,0.17590000f,0.79950002f,0.17040001f,-0.51000001f,-0.22040001f,-0.18800002f,0.06210001f,-0.18409998f,0.09150000f,-0.97060000f,-0.38480000f,-1.87140003f,0.03360001f,-0.24180001f,0.72460007f,-0.06100002f,-0.04329996f,0.74319998f,0.89509998f,-1.24979999f,0.96670000f,-0.03260000f,1.01560001f,-0.64499999f,0.91590002f,-0.11319999f,-0.53859998f,1.46119997f,-0.27799997f,0.19439997f,0.82530003f,-0.93960001f,-1.12440002f,1.36060002f,-0.56800001f,0.42419999f,0.67460003f,0.11399999f,-0.06600000f,0.18119998f,-1.82440001f,0.53320000f,0.28900000f,0.87010001f,0.04560000f,0.06710002f,-0.01160000f,0.46749999f,0.09120000f,0.28980001f,-0.02860000f,-0.55659999f,-0.14580000f,0.04409999f,0.32500000f,1.09460001f,-0.04220000f,0.09610001f,0.14540000f,0.30140001f,-0.09770001f,-0.54700003f,-0.17680000f,0.40140001f,0.22280000f,0.58010002f,0.07460000f,1.04140000f,0.34660000f,1.33230004f,0.99830001f,-0.98779998f,0.74489998f,-0.93239998f,-1.04299997f,1.23899998f,-0.15379999f,-0.47560001f,0.55560000f,-0.38600000f,-0.13689995f,0.86179995f,0.43240003f,-0.82119999f,1.02750000f,-0.40579999f,0.85880002f,-0.68740000f,0.18389999f,-0.10500000f,-0.71830003f,0.34280000f,0.16770001f,-0.46400001f,0.40230002f,0.04260000f,0.98899998f,-1.11719997f,0.70710002f,1.61930001f,0.20120001f,1.37540004f,0.18380000f,0.79530002f,0.08700000f,0.67080000f,0.11870000f,-0.02460002f,-0.38920001f,-1.19060008f,-0.21050000f,-0.05139999f,0.29860001f,0.27600004f,-0.02250000f,0.44850001f,0.06270001f,0.88090006f,0.26300001f,1.42120006f,0.32640001f,0.59180002f,-0.32530001f,-1.63060006f,-0.23530000f,-0.57490001f,0.18930001f,0.33160003f,0.64399998f,-1.54059997f,0.93260001f,-0.86440000f,-0.10049998f,0.15179999f,-0.22590001f,-0.33660000f,-0.24670006f,0.25900005f,0.03289993f,-0.21479996f,0.63960003f,-0.07900001f,0.25060002f,0.19380000f,0.86310000f,-1.21680000f,1.31010006f,-0.40540001f,1.43130003f,-1.73260000f,-0.03190004f,0.30460003f,-1.76400002f,1.75619999f,-1.15100000f,0.39059998f,-0.03369999f,1.35620006f,0.16820000f,0.99820004f,0.23330000f,1.39990002f,0.45160000f,0.73020000f,-0.39530001f,-0.98960003f,0.05550000f,-0.17430000f,-0.26339999f,0.04390002f,0.26590000f,1.09320003f,0.12690000f,0.58980000f,-0.08990000f,-0.26990000f,-0.16460000f,-0.96759999f,-0.10440000f,-1.34740000f,-0.33080000f,-0.48570001f,-0.00440000f,-0.77629999f,-0.37280000f,-0.92300001f,-0.29969999f,0.12879997f,-0.02449999f,-0.08820001f,0.39820000f,-0.55200000f,-0.09680007f,0.04740005f,-0.90060000f,0.34179999f,-0.91490000f,0.90519997f,0.76650001f,-1.19100000f,1.19130002f,-0.73700000f,0.89839997f,-0.78779997f,0.57859999f,-0.25200000f,-0.04719996f,1.03439995f,-0.27710001f,0.04460001f,0.70410000f,-0.59080000f,0.51429998f,0.06319999f,0.02130002f,0.36769997f,0.29080000f,0.98160001f,-0.05760000f,-0.58149998f,0.08820000f,0.78240001f,0.21170000f,-0.64640003f,-0.28210001f,-0.93920005f,-0.23820000f,-1.02800001f,-0.19350000f,-0.86510002f,-0.37920000f,-0.90170000f,0.10510000f,-0.47630001f,0.03830000f,1.38170002f,0.32440000f,0.01640002f,-0.31400000f,-0.22749999f,0.17170000f,-0.07909999f,-0.11740000f,0.56549997f,-0.49690002f,-0.13359997f,0.90889999f,-0.59760001f,-0.11769997f,0.53279999f,0.51680005f,-0.04260003f,-0.00610003f,0.25080003f,-0.25800004f,0.15640000f,-0.39950002f,-0.09800000f,-0.60180004f,0.53340000f,0.09390004f,0.27979998f,-0.51969999f,0.53179999f,0.74199998f,-1.40179997f,-0.36899999f,0.93959998f,-0.36179998f,-0.46320001f,-0.93639998f,1.13220000f,0.44999997f,-0.53650002f,0.15860000f,0.46279999f,0.20870000f,1.21250000f,0.13110000f,0.15350002f,0.08870000f,0.71000005f,0.28130001f,0.82970003f,-0.10110000f,0.53550003f,0.28410001f,0.57760007f,-0.28789999f,-0.02269999f,0.05450000f,-0.14809999f,0.12910000f,-0.84440002f,-0.32640001f,-1.65740006f,-0.30570001f,-0.02800001f,0.20710000f,0.15630001f,-0.31340001f,-1.02820004f,0.67080001f,-0.25959999f,0.34770000f,-0.43699999f,0.64369999f,-0.20559999f,0.46070000f,-0.12620000f,0.39060006f,-0.28680004f,0.47339999f,-0.73079998f,0.29350002f,-0.47520002f,-0.28530000f,-0.10440003f,0.49140002f,-0.40759999f,0.35950004f,0.49759997f,-0.53680001f,1.01500000f,-0.64090005f,0.12560001f,0.12009998f,-0.93039999f,-0.65370004f,0.76400001f,-0.69430000f,-0.83350000f,-0.09470000f,-1.26540003f,-0.16670000f,-0.79820000f,0.11100000f,1.35460006f,0.29820001f,0.49930001f,-0.17040001f,-0.70540000f,-0.07500000f,0.53619998f,0.09979999f,-0.20270001f,0.04690000f,0.57560000f,0.04280000f,0.89880003f,0.34010001f,1.00130005f,0.23830001f,0.89000004f,0.11280000f,0.70370002f,0.01610000f,-0.06090001f,0.00530000f,0.44610003f,-0.08259996f,1.17079998f,-0.81380000f,0.73339999f,-1.28709999f,0.83999997f,0.07630003f,-0.96840002f,-0.32250001f,0.39100001f,-1.53829999f,0.82339998f,0.06860000f,-0.05539999f,0.06939998f,-0.33919999f,-0.44019999f,0.10920000f,0.44770007f,0.01479997f,1.27970005f,-0.47100001f,1.55140000f,-1.41199999f,1.36960003f,-0.44440000f,0.71319999f,-0.67339998f,0.27320003f,0.98209999f,-0.24170000f,0.18839997f,0.07540000f,0.26599999f,-0.06170000f,0.22330000f,0.25490000f,0.17769998f,-0.35520001f,-0.59050004f,0.15790000f,0.16179999f,-0.25070000f,-1.32510002f,-0.23290000f,-0.19860002f,0.09330000f,0.01360000f,0.12160000f,-0.32870000f,-0.08400000f,0.27440003f,0.32140001f,0.21860004f,0.08790000f,0.87060002f,0.09410000f,0.06310000f,0.10819997f,-0.16839999f,0.93259997f,-1.10939996f,0.92639998f,-0.49959998f,0.04539999f,-0.20580000f,-0.80210006f,0.62500003f,-0.43680000f,0.20239999f,0.29329997f,-0.48619998f,-0.83100000f,0.78159999f,-0.28439998f,0.22659998f,0.24020002f,0.10120000f,-0.51509999f,0.83619999f,0.36930006f,-0.09100003f,-0.19109999f,0.29780001f,0.40080000f,-0.31940000f,0.97210001f,-1.28820004f,-0.08840000f,-0.97690004f,-0.33660001f,-0.92560002f,-0.13689999f,0.07980004f,0.03950000f,-0.82059999f,-0.12680000f,0.41509998f,0.24709999f,1.59080002f,0.15870000f,0.61800002f,0.07150000f,0.27179998f,-0.17960000f,-0.27990002f,0.21520000f,0.43900000f,-0.14000000f,-1.28650001f,-0.04250000f,-0.20990000f,0.00350000f,0.10369999f,-0.10520000f,-0.80479998f,-0.25619998f,0.86079998f,-0.37310005f,-0.04359997f,-0.59120003f,-0.38740002f,-0.71989998f,0.84079999f,-1.37549997f,1.24959995f,-0.10330002f,-0.88939997f,1.32649998f,-1.09979998f,0.62610001f,-0.66000000f,-0.00350000f,0.31840000f,-0.11490000f,-0.31220000f,-0.04579999f,0.73199999f,-0.63539996f,0.88619996f,-0.17889999f,-0.05380000f,0.57739998f,-0.76739999f,-0.10009995f,1.27510004f,0.00580000f,-1.11279999f,-0.31589999f,-0.88780001f,0.04700000f,-0.03690004f,-0.24360001f,0.96109999f,0.33470001f,0.42999999f,-0.35940001f,-0.00540001f,0.21370001f,-1.04770000f,-0.39260002f,-0.88080007f,0.23360000f,1.67910000f,0.40449999f,1.76150000f,0.10860000f,-0.01570002f,-0.09860001f,0.43899998f,0.24570000f,0.52980002f,-0.24700000f,-1.06030001f,1.52660002f,-0.90999998f,-0.39619998f,1.07999997f,-1.09410001f,0.09620000f,-1.13870006f,0.35380005f,0.57680002f,-1.55260003f,0.07949998f,0.32720004f,0.73690000f,-0.80000001f,-0.47509998f,1.89339998f,-0.27640001f,-0.83359998f,0.52000000f,-0.60479997f,0.58219996f,-0.92019996f,-0.89120003f,0.93600000f,-0.73160004f,-0.22620000f,-0.23140002f,0.11700000f,-0.99829997f,0.33170004f,0.14100000f,0.45550001f,0.18739999f,0.43920000f,0.02950000f,1.04710000f,0.05330000f,-0.06719997f,0.18470000f,1.51170005f,0.13620001f,0.87740003f,0.31140000f,0.35780001f,-0.07480000f,-0.21000003f,-0.29750001f,-1.19440006f,-0.15100000f,-0.51420005f,-0.13700001f,0.85509998f,0.13030000f,-0.69929998f,-0.10120000f,-0.02700000f,0.02200000f,0.73400005f,1.25130003f,-0.42920001f,1.09290001f,-0.86559998f,-0.32669999f,0.21600000f,0.56970000f,-0.91480000f,-0.08449997f,0.65419997f,1.39320001f,-1.54539998f,1.80930004f,-1.09859999f,-0.51130002f,0.61780000f,-0.64630005f,0.20500001f,-0.48390003f,0.22360001f,-0.77210006f,0.04080003f,0.98119996f,-1.13339996f,-0.51819996f,1.27239996f,-0.59060001f,-0.17420000f,0.40650005f,-0.14640001f,-0.13000000f,-0.28889999f,0.01900000f,-0.83570000f,-0.38400000f,-1.22090004f,-0.16290000f,-0.67040002f,-0.08980000f,0.75910002f,0.19800001f,-0.54340001f,-0.18090001f,-0.66990003f,-0.04210000f,-0.55439998f,-0.21549999f,-0.06529997f,0.01370000f,0.22130002f,0.05420000f,1.04020002f,0.08710000f,0.79140004f,0.35410001f,1.92990010f,0.13770001f,-0.53169997f,0.59869998f,-0.69679997f,-0.02319997f,0.50559996f,-0.33219998f,0.54259999f,0.35780000f,-0.46740001f,-0.21000002f,-0.33459998f,0.41900005f,0.19479997f,0.28310001f,0.41880001f,0.26849999f,-0.31040000f,-0.38810001f,-0.04060002f,-0.04449998f,0.27259998f,0.97560000f,-1.18600000f,1.99420002f,-1.37479998f,1.45910005f,-1.02220002f,1.74570004f,-1.24540002f,0.19780002f,0.47410003f,0.26590000f,0.74810003f,0.25180001f,0.52430003f,0.08090000f,0.95880002f,0.19720000f,1.50100004f,0.30430000f,0.83280002f,-0.02560000f,-0.60680000f,-0.06490001f,0.13669996f,-0.22230001f,-0.31620004f,0.16210000f,1.31040000f,0.32380000f,1.34910002f,0.32910000f,0.15130001f,-0.28260000f,-0.85440001f,0.07370000f,0.35220002f,0.24820000f,0.48650002f,0.84470004f,0.09920000f,0.75260005f,-0.19300002f,0.29040001f,-0.25799999f,0.25720000f,-0.86640000f,0.67100003f,-0.16960000f,0.99660000f,-0.76440000f,-0.53390000f,0.58300001f,-0.02080003f,-0.35459998f,0.70830000f,-0.44999999f,1.30309999f,-1.15319997f,1.10400002f,-0.10460000f,0.36600000f,-0.02480001f,-0.07279998f,0.37640001f,-0.04569997f,-0.01760004f,0.15170003f,1.26189998f,0.06459999f,-0.26280001f,-0.21740000f,-0.47200002f,-0.06300000f,-0.50900001f,0.06700000f,-0.38290003f,-0.39330001f,-1.44220008f,-0.17530000f,-0.44850001f,0.01610000f,0.23560001f,0.09090000f,0.29490000f,-0.12500000f,0.42349998f,0.14210000f,0.77469998f,-0.17630001f,-0.54910002f,-0.04870000f,0.46360001f,0.21870001f,0.58390004f,0.09200000f,-0.25789999f,0.02950001f,-0.52529998f,-0.49249999f,-0.27190000f,-0.72979998f,-0.31679999f,0.42869999f,-0.60649998f,0.07210002f,-0.68570002f,-1.34330001f,0.42930001f,1.25940001f,0.09410001f,1.38220000f,-0.36929999f,-0.62769999f,0.65769997f,-0.06450000f,-0.09299999f,0.18520000f,-0.51999999f,-0.71170004f,0.32659998f,-0.10320000f,-0.66559999f,-0.68269999f,0.13660000f,0.48320003f,-1.25260007f,-1.65679998f,0.56980002f,-0.45470001f,-1.40680004f,1.12259999f,-0.00619998f,1.20799998f,-0.49759999f,-0.45679996f,0.05489995f,0.02080002f,-1.21240004f,0.15270006f,1.51540003f,-0.14150001f,-0.02030001f,-1.16400002f,0.56580001f,-0.60989997f,0.44230001f,-0.55520004f,0.10489999f,-1.05189999f,0.05419997f,1.07229998f,0.15599998f,-0.39890002f,0.41600000f,-1.23240001f,-0.71379999f,1.14540002f,-0.52230001f,0.66719997f,0.71330000f,0.00010000f,0.70559998f,1.01850002f,-0.30359999f,1.07519998f,-0.32969998f,-1.24010000f,0.53830002f,-0.21459998f,-0.16700001f,-0.65400002f,-0.52240001f,0.67560000f,-0.57169997f,-0.87880001f,-0.45320002f,0.19730000f,-0.77699998f,0.71050004f,0.19660001f,-0.21109996f,-0.62840000f,-0.05339997f,0.48510002f,0.53379997f,-0.80790005f,-0.84140000f,0.73400002f,-0.15120005f,-1.70209999f,-0.20469998f,0.15569998f,-0.75139998f,0.25730003f,1.46280000f,1.05319998f,0.28999998f,0.71070002f,-0.03859999f,-0.80160001f,0.67490003f,-0.06979997f,0.45479998f,0.11340001f,1.30159996f,-1.88729999f,0.25170003f,0.49829999f,-1.18850000f,-0.29639999f,-0.86089996f,-0.16730002f,0.95449997f,-0.03540001f,0.28080000f,-0.54029998f,-0.01989998f,-0.41400003f,-0.74290001f,0.42579999f,0.47239995f,-0.05179999f,0.70770003f,0.86469999f,-0.21019999f,-0.18000000f,-0.70910000f,-0.44969999f,-1.41670003f,0.61890001f,0.23330000f,0.43249999f,0.94870001f,0.56559998f,0.34970001f,0.59299999f,0.95399996f,-0.63510000f,0.41799997f,-0.40059998f,0.96729998f,1.04990000f,0.74059996f,-0.89490002f,0.41630000f,-0.58529997f,1.69019995f,1.19129999f,0.24969994f,-0.18280000f,0.53470003f,-0.66530000f,-0.43389999f,0.64820000f,-1.42089998f,-1.26110000f,-0.23500001f,0.27159999f,0.47740001f,-1.14620003f,-0.52439994f,2.02980001f,-0.11640002f,0.66950002f,0.14999997f,-0.69390001f,-0.63500001f,-0.29550000f,0.56659997f,0.03889999f,-0.10849998f,-0.13830001f,-0.81699997f,0.22840000f,0.45010000f,0.99479997f,0.15380002f,-0.35040002f,-1.59809999f,0.28660001f,-0.40360001f,0.11230000f,0.27239998f,-0.72239999f,-0.10890002f,0.48739997f,1.30730000f,0.41600001f,0.19119999f,0.25260003f,-0.12880000f,-0.27440000f,0.06580003f,-0.39670000f,-0.09979999f,-0.51370000f,0.42489999f,0.16129999f,-0.97679999f,0.20800003f,1.95989997f,0.74540000f,0.75130002f,0.80480002f,-0.06970001f,-0.93729999f,-0.09959994f,0.19910001f,-1.63339996f,0.70140001f,-0.05750000f,0.00620000f,0.34779999f,-0.92820001f,0.02250000f,1.18230004f,1.39030002f,-0.22730003f,0.28729999f,-0.18020000f,0.40029999f,0.83639998f,0.34739997f,-0.99380001f,1.00540000f,-0.09900004f,0.66040003f,-0.92050000f,0.02919999f,1.00099997f,-1.68189999f,0.41900001f,-1.23279999f,-0.04180001f,-0.55060001f,0.45200002f,0.28019997f,-0.51949999f,0.86359998f,-0.11370000f,0.83330001f,-0.11230000f,-1.03349998f,0.33289998f,0.21230002f,0.53710000f,-0.14320001f,0.01930000f,0.03840001f,0.12920000f,0.02200004f,-0.24470000f,-0.43539995f,0.59739999f,-0.54440000f,0.54580002f,0.09800002f,-0.74260003f,0.68139996f,-0.04859997f,1.76089999f,0.19679995f,1.15689999f,0.19240006f,1.61949996f,0.82999997f,0.86119997f,-0.94440001f,0.66769998f,0.09110001f,1.52500000f,-0.02100004f,0.30549999f,0.55859999f,-1.00060002f,0.71540001f,-0.21730006f,-1.94549998f,0.85390001f,0.00689998f,1.22410003f,1.90620003f,0.27329995f,-0.56599997f,1.57060001f,-0.91500000f,-0.93109998f,0.40749998f,-0.30839996f,1.04709998f,-0.63679999f,0.73220000f,-0.09629996f,0.87299997f,0.19200002f,0.02550000f,-0.20899999f,0.31490000f,0.55240004f,0.56120000f,0.11360004f,-0.16989999f,-0.70870000f,-0.90110000f,-0.59829998f,-0.55190002f,-0.05250000f,0.80489999f,0.18759996f,0.90050002f,-0.52829997f,-0.26680002f,-1.12649996f,0.93109999f,0.44790000f,-0.21360001f,-0.57089999f,0.80260001f,0.68189999f,-0.75990001f,-0.19689998f,-1.16890005f,0.10050002f,1.57580003f,-1.49460000f,-0.45289995f,-0.42759996f,-0.70490008f,1.16450000f,0.97730005f,-1.14569999f,-0.78870001f,-0.73379997f,0.78039999f,0.34960000f,-0.44050000f,0.84139996f,1.02980004f,0.02620001f,0.84540002f,0.83970000f,-0.28709999f,-0.73379997f,1.06120003f,-0.17009999f,-0.32330000f,-1.04289999f,0.32659999f,0.36940002f,0.03130001f,0.23619995f,0.58390001f,0.25769997f,-0.95669998f,0.81300000f,-0.35309998f,-0.32350003f,0.86880001f,-0.83999995f,-0.57570000f,0.16039999f,-0.04099999f,1.61699998f,-0.16379998f,-1.24020000f,0.58049997f,-1.55180001f,0.11080000f,-0.76380000f,0.41010000f,-1.00159997f,-0.09040000f,-0.00349999f,0.51060000f,-0.37820001f,0.79600002f,-0.41010000f,-0.77440000f,1.59949997f,-0.54369997f,0.86489999f,-0.11950001f,0.97160000f,-0.99749998f,0.10660001f,0.83810001f,0.05380000f,0.87739999f,1.08169996f,0.56090000f,-0.29499999f,0.52400002f,0.44359993f,-1.41680001f,-1.28589995f,1.17799998f,-0.92550000f,0.92160002f,0.84949995f,-0.21759999f,0.11339998f,-0.42550001f,-1.45610002f,-0.02920001f,0.24790000f,-0.40469999f,-0.16489999f,1.02639998f,0.23430001f,0.70969998f,0.63979999f,0.60040000f,-0.41740001f,0.58929998f,0.54009998f,0.07850000f,-0.16309997f,0.32189999f,-0.93119997f,-0.42619998f,-0.12079999f,-0.18520003f,-0.68090001f,-0.38649999f,0.10769994f,-0.62899998f,-0.41259997f,0.10839999f,-0.30749997f,-0.14710000f,0.88020002f,1.60360001f,0.74059997f,0.32729999f,-0.25529997f,0.59420001f,0.20719999f,-1.05849999f,0.67289995f,1.91390005f,-0.72929999f,0.46950001f,0.37259998f,0.42130002f,-0.53490001f,-0.78120004f,1.46939999f,1.31770006f,-1.03930005f,0.74190001f,0.52689998f,-1.02999999f,0.51590001f,-0.59919998f,0.15780003f,0.27040000f,-1.59939995f,-1.28360000f,0.41350000f,1.64800000f,0.04020002f,0.07420000f,-0.79049998f,-0.40039997f,0.21619999f,-0.42249998f,-1.50070001f,0.62659997f,-1.14400001f,-0.59849999f,-1.11610001f,0.13299999f,-0.08019997f,-0.50500001f,0.29409998f,0.81390001f,-0.79450001f,-0.88940003f,-1.44869999f,0.08610000f,-0.51679999f,0.59540000f,0.85729997f,0.38330000f,1.24549995f,-0.99099997f,0.24759998f,0.58469998f,1.10980002f,0.45600005f,-0.34150000f,-0.87860000f,-0.36179999f,0.07999999f,1.40320002f,-0.50759996f,-0.13819999f,0.29120001f,0.33560003f,0.64330001f,-0.27560000f,-0.17120003f,0.77629999f,0.17660000f,-0.76420001f,-1.10700000f,0.49430004f,1.75360003f,-0.05970007f,-0.74050003f,1.24130002f,0.12660003f,-0.67749996f,0.86030001f,-0.01990002f,-0.96180001f,-0.31859999f,-0.59499999f,0.11019999f,0.01159999f,0.48289999f,0.22709999f,1.08589998f,0.85540002f,0.94179999f,-0.07580000f,-0.30980002f,0.14740001f,0.26460002f,-0.50710000f,-0.57999999f,0.28769999f,-1.11740001f,-0.33930001f,0.44999999f,0.67410002f,0.95090001f,-0.57940003f,-1.65060000f,0.84150001f,-0.80739999f,-0.07579999f,-0.43000002f,0.07449999f,-0.00159999f,0.28910000f,1.17610000f,0.69060003f,1.51190001f,-1.01530005f,-1.24200002f,0.80930003f,-0.25490001f,1.58860002f,-0.44360001f,0.02240001f,1.17009998f,0.32370002f,0.55549999f,-0.56440002f,-1.29850001f,-1.00350004f,-0.72490002f,-0.12320001f,-0.48059999f,-0.63340004f,-1.76609997f,0.37249998f,-0.80260000f,-0.29639998f,0.69040002f,-0.95710002f,-0.33669998f,0.45609999f,0.37240002f,-0.01329998f,0.82700000f,0.52130001f,-0.70520002f,-0.42420001f,-0.30730001f,-0.08480000f,-1.00449997f,-0.52870000f,-1.74339997f,0.79829998f,0.33870000f,0.20330000f,0.98699999f,-0.84040000f,0.85480000f,-0.30690000f,1.46340004f,-0.47809999f,0.27239998f,-0.95849999f,-0.01230004f,-0.50799999f,0.57430003f,0.28900001f,0.02889998f,0.07720000f,-0.73090002f,0.47400000f,-0.32900000f,1.29960003f,0.10539998f,-0.64059999f,-0.53059997f,-1.03170001f,-0.78869999f,1.97700004f,0.28189997f,-2.35550005f,-0.58679994f,0.64420000f,-0.62680000f,-0.11670002f,1.40239997f,0.15140002f,1.18860002f,0.35310003f,1.43110000f,-0.07430002f,-0.34790000f,0.10299998f,-0.80839998f,-0.06429999f,-0.09620001f,0.05730001f,-0.43440000f,-1.58110003f,-0.21979999f,0.67070001f,-0.03810000f,0.01349999f,-0.30989999f,0.00160000f,0.16869997f,0.23719998f,1.62670001f,-0.36320001f,-0.48750005f,0.21480002f,1.77619998f,-0.50299998f,0.44330004f,0.53489999f,-1.21459997f,0.61880000f,-0.61089999f,0.71619999f,-0.10010000f,-0.23610000f,0.15709999f,-0.54389998f,-0.73390001f,0.08809999f,0.16320000f,-0.15370000f,0.48889999f,0.46309999f,1.29420000f,1.12970002f,-0.60159998f,0.00090000f,0.56909999f,-0.59219996f,-1.05519996f,0.68199999f,-2.21580000f,-0.27820000f,-1.58030001f,-0.12249998f,0.30369998f,-0.23409999f,0.86890002f,0.74750000f,0.69349998f,0.00009998f,0.96609996f,-0.75240000f,0.28749999f,1.08770000f,-0.69469999f,-1.14069999f,1.23829998f,-1.03200002f,-0.23969999f,-1.64550000f,-0.11329998f,1.93000003f,-0.21820002f,-0.54399999f,-1.32940002f,0.45520000f,-0.52680004f,-0.06929999f,0.47329994f,-1.03599999f,0.72430001f,-0.68130000f,-0.00859999f,0.43409997f,0.27030000f,0.73450000f,0.75170001f,0.11010000f,0.00880002f,0.22729999f,-0.50629998f,0.25319999f,-0.07180001f,-0.68589998f,0.24320000f,0.75829999f,1.50590001f,-0.07519999f,0.83859997f,0.41969999f,0.28419995f,-0.00460000f,1.39399996f,-0.77790000f,-0.74019997f,-0.24729999f,0.71970000f,-0.13180002f,0.81159997f,-0.35290001f,1.22350002f,0.03710001f,-1.66769996f,1.22820005f,0.84349998f,-0.53370002f,0.58469999f,0.40500007f,1.83289998f,-0.39980002f,-0.38579999f,0.43299999f,-0.18979998f,0.06220001f,-1.91150000f,0.61629999f,0.06389999f,-1.16010003f,0.18850001f,-0.19879995f,-0.05449999f,0.69749997f,-0.53189999f,-0.05610000f,1.51059999f,0.44720000f,0.83430000f,0.29529999f,-0.77240000f,0.81620001f,0.04039998f,-0.80029997f,0.63500000f,-0.03620001f,-1.45350001f,0.38410000f,-0.44559998f,0.97659998f,-0.45070001f,-0.01130000f,0.82070000f,-0.27499998f,-0.39530000f,-1.09710001f,0.14380000f,-0.23590000f,-1.10770002f,0.57010000f,0.00079996f,0.44600003f,0.17590000f,0.50660004f,1.85429997f,-0.36549997f,0.05250000f,0.49090000f,0.28169999f,0.30700001f,-0.19060001f,0.45309998f,0.49119997f,-0.29299999f,-0.26730000f,-0.13050001f,0.75050001f,-0.79360002f,-0.87850000f,0.95150001f,-1.20200003f,-0.38970004f,1.23400000f,-0.16009996f,-0.97799996f,0.31430005f,2.01849998f,-0.98850002f,1.26740001f,0.40000002f,-1.19980002f,0.15179999f,-0.90390000f,1.07119998f,-0.61619999f,0.33109998f,0.06579998f,0.23509999f,0.06610000f,-0.16590000f,-0.23009999f,0.08969999f,-1.06729998f,0.05989999f,0.20569999f,0.60450001f,0.60120001f,-0.14720000f,1.04930001f,-0.92800001f,-1.02709999f,0.84210000f,-0.23889999f,-0.26629999f,0.85099998f,1.01759998f,0.31539997f,0.83020000f,1.26220003f,-0.62570001f,1.01540000f,0.57309998f,1.56139994f,-1.31619998f,0.70679999f,1.10780002f,1.08720002f,-0.44249999f,0.25040000f,0.40159999f,0.80869997f,1.01860002f,-0.49750002f,0.00919999f,-0.02120000f,0.16230002f,0.89820004f,0.33810002f,-0.57569999f,-1.45610005f,-0.04699997f,-0.64869998f,0.00270002f,1.47100002f,-1.54770002f,-0.27990001f,0.68589999f,0.20400002f,0.32130002f,0.87719997f,0.58580000f,0.36489999f,0.86830000f,0.37519998f,-0.08829998f,0.52639998f,0.25559996f,0.61050001f,1.00460005f,-0.90340001f,-0.88150003f,-0.10560000f,-0.72410002f,0.63039998f,0.76400001f,-0.45589997f,0.00170001f,0.44549998f,-0.67269999f,0.31749999f,0.65300000f,-0.52419999f,0.50720002f,0.87859999f,1.17410001f,0.06170000f,0.02620001f,-0.88750000f,0.09880003f,1.53450001f,0.56040001f,0.19109997f,0.27219997f,-0.89129998f,-0.41600001f,1.21630003f,0.98240001f,-0.05980002f,0.21779999f,-1.52330000f,-0.62120000f,0.32979999f,-0.26299999f,-0.21940003f,-0.03679999f,1.14840003f,0.42640000f,-1.05230001f,-0.53839999f,1.44440000f,0.73700001f,0.37170004f,0.09580000f,-0.16960000f,0.26820001f,0.33220003f,0.36750006f,0.25549999f,0.51329999f,0.69440001f,0.26690004f,-0.42659999f,-0.76900001f,-0.55119998f,-1.07019997f,0.47770001f,-0.47180000f,0.55759998f,0.39200001f,-0.88570001f,-0.08960008f,0.10900000f,0.19140001f,0.18299999f,0.45400003f,0.65509997f,0.65349997f,0.25540000f,0.71690005f,0.81929998f,0.80039998f,0.27100000f,-0.11150004f,0.80429999f,0.92600000f,0.28810001f,0.16159998f,0.15290001f,0.58020001f,-0.37979999f,-0.26879999f,-0.27190000f,0.04580000f,-0.24760003f,-0.14560000f,0.89220004f,-0.02940000f,-0.54100001f,-0.23520000f,0.10209999f,-0.01140001f,-1.10680003f,-0.60840002f,0.63399999f,0.19739999f,0.44340001f,0.16239998f,-0.47089998f,0.31700000f,-0.10080001f,0.17600002f,0.47679998f,0.28459999f,0.76910001f,-0.42959999f,0.36280000f,-0.41209997f,0.53209998f,0.46389996f,0.47010001f,0.50940008f,-0.72439997f,-1.19639999f,-0.33820001f,0.36309998f,-0.55939997f,-0.67320005f,0.35229999f,0.93040001f,0.64669998f,1.08410003f,-0.74000001f,-0.40150003f,-0.36369999f,-0.51630002f,-0.14549999f,-1.24779996f,-0.67339997f,-1.67880000f,0.39370000f,0.22080005f,0.23759999f,-0.27260000f,0.59710003f,-0.05900000f,-0.47290000f,-0.00380000f,0.33519999f,0.07959998f,-0.35169996f,-0.04819999f,-1.14280001f,-0.64020002f,0.20389999f,0.18080001f,-0.26270000f,-0.08379998f,0.12259999f,-0.04239999f,0.82590001f,0.21240000f,-0.77010002f,-0.03960000f,-0.26510000f,-0.64639999f,1.58259999f,0.58939999f,-0.56769998f,0.19180001f,0.60619998f,0.26339998f,-1.51559997f,1.41280000f,0.56240000f,0.59070002f,-0.13170000f,0.01929999f,-0.61039996f,-0.95650001f,0.63420001f,1.18670004f,-0.32430001f,-0.14310000f,-0.33799999f,-0.82330000f,0.33929999f,0.51450002f,-0.85419997f,-0.97260000f,-0.32390000f,-1.30630000f,-0.64950001f,-0.07610009f,0.18169998f,1.18439998f,0.81879998f,-0.01209997f,0.49519999f,0.63590001f,0.11310000f,-0.25439999f,0.36940000f,-0.47780003f,-1.53889998f,-0.90060000f,-0.09890003f,-0.33220000f,-0.28820001f,-0.14960000f,-0.18470002f,-0.00379998f,1.14709999f,0.18160000f,0.82730001f,0.49699999f,-1.83449997f,-0.66039998f,1.12060000f,-0.03240002f,-0.29060002f,0.13079999f,-0.07589999f,0.04100000f,0.15320003f,0.02020001f,-0.17899999f,0.01119999f,-1.03790002f,-0.50600001f,0.20160000f,1.87620004f,-0.62909997f,-0.11019999f,-0.48020000f,0.55249996f,-0.05920000f,0.09560004f,-0.76140000f,-1.30470001f,-0.04850000f,0.44209999f,0.18750000f,0.03280000f,0.47099999f,-0.10779999f,-0.65569997f,0.61089999f,-0.10919999f,-0.45020001f,0.14959999f,0.04070000f,0.01950000f,0.21279997f,0.54380000f,0.69160000f,-0.38089998f,-0.50770001f,-0.61190001f,-0.79760004f,-1.26250000f,-0.46180000f,0.16230001f,-0.22960002f,-0.98740001f,-0.53660001f,0.31300000f,-0.08500002f,0.04580003f,0.07300000f,-0.16480003f,0.20279998f,0.25640006f,0.09720000f,-0.12710000f,0.27760001f,-0.78500002f,-0.16059999f,0.56100003f,0.04400002f,0.19829998f,0.29119997f,-0.95990001f,-0.54760003f,-0.07509998f,-0.34499999f,-0.28270000f,-0.36420003f,0.26340000f,0.53499997f,-0.38409998f,0.41650000f,-0.73309997f,-0.65620003f,-0.64780001f,0.00949995f,-0.50749997f,-0.54020002f,0.41359999f,0.18739999f,-0.08040000f,-0.08680001f,-0.04369999f,-0.52330004f,0.47840000f,0.18429999f,0.79629998f,1.71230001f,0.72340001f,0.67200007f,-0.69289997f,-1.07609999f,-0.86730001f,-0.15240009f,0.44450000f,1.39980002f,-0.69109998f,-1.20829999f,-0.41149999f,-0.09479998f,-0.63320000f,-0.77220000f,1.29580000f,0.79440001f,-1.35350005f,-0.42560002f,0.42289999f,0.06900000f,1.41090002f,0.70699999f,-1.25380002f,-0.66500001f,-0.49659997f,-0.26519997f,0.70509997f,0.31600001f,1.26340000f,0.47959999f,-1.82450001f,-0.86860001f,-0.65510002f,-0.69960002f,0.29100001f,-0.36120001f,-0.88949998f,-0.30199998f,0.57669999f,0.29820000f,0.16960000f,1.10989998f,-0.34419999f,-0.15279999f,0.06110000f,-1.05550000f,-0.92890002f,-0.84080004f,0.69059996f,0.83010004f,0.49440000f,0.23029999f,-0.88060001f,-0.69620006f,0.21210001f,0.39370003f,-0.22540000f,-0.35920001f,0.54399998f,0.44269998f,-0.66689998f,0.40370001f,-0.33360001f,0.95759999f,-0.28230001f,-0.36170001f,-0.31259999f,1.02819996f,-0.41010004f,-0.45720000f,1.01810000f,0.28720000f,-0.32699999f,-0.31740001f,-0.06970000f,0.09559998f,-0.03179999f,0.01519999f,-1.13780001f,-0.34380000f,0.52880000f,0.00180000f,-0.03939998f,-0.33840000f,-0.40180000f,-0.12160000f,0.67030000f,0.17519999f,-0.94459998f,0.09440001f,0.15529995f,-0.21020001f,0.58440003f,-0.19500000f,0.14470001f,0.26339999f,0.78340003f,0.54879998f,-0.26540000f,0.30900000f,0.47079998f,0.73769999f,-0.80619998f,-1.06440000f,-0.59659997f,-0.94239999f,-0.40129999f,-0.98479999f,-0.91259997f,-0.66670000f,-0.08930000f,0.49589996f,-0.02360000f,0.24619998f,0.45429998f,1.10849997f,0.54390001f,-0.32069991f,-0.04630000f,0.22519999f,0.41629996f,1.62979997f,0.21469999f,0.26740000f,0.34430000f,-0.06439998f,0.01040001f,-0.36800000f,-0.03890001f,0.04739999f,0.77649998f,0.33859998f,-1.73170000f,-0.74700001f,-0.36930000f,-0.54120001f,0.22250000f,-0.32640000f,0.46110002f,0.27820001f,0.29359997f,0.05099996f,-1.26519999f,-0.43540000f,0.02310003f,-0.52360000f,0.14749998f,0.10459999f,0.06729999f,0.20499999f,0.60179999f,0.66320000f,-0.30170000f,-0.14840000f,1.21830002f,-0.14380006f,0.16589999f,0.54000000f,0.47979997f,0.83449998f,0.82069997f,0.80260000f,-0.78849998f,0.10330001f,0.38339998f,1.72380000f,-0.09560000f,0.08070000f,0.55500001f,0.76770002f,-0.45960001f,-0.88770004f,0.68800000f,2.27340005f,0.00040000f,0.37250001f,-0.59949999f,-1.29279998f,-0.43769999f,-1.47869998f,0.84349997f,0.55330002f,-0.70079997f,-0.41890002f,0.20440001f,-0.15620000f,0.41720000f,0.28380001f,0.38629998f,-0.06440003f,0.46360000f,0.64239999f,-1.23359998f,-0.63480001f,1.35990001f,0.61100001f,-1.00710000f,-0.49680001f,-0.56300002f,-0.22100000f,0.78909999f,0.29279998f,0.25010003f,0.05180001f,-1.25410001f,-0.76880003f,-0.38210000f,-0.16299999f,-0.25550003f,-0.52520000f,0.47990001f,0.27820001f,0.25589999f,-0.16260000f,-0.22939999f,-0.47829998f,-0.44579998f,-0.48000001f,-0.58460001f,-1.43140001f,0.21040001f,-0.13379997f,-0.21580000f,0.35509999f,0.77490000f,0.71830000f,-0.16730000f,0.09040000f,0.06349999f,0.30410004f,-0.67850001f,-1.00640008f,0.84550001f,1.51750005f,-0.82840001f,-0.63650003f,-0.26990000f,0.33549997f,-0.25740000f,-0.13789999f,-0.51779999f,-0.97060000f,0.13160002f,-0.15040003f,-0.91250003f,0.14040002f,-0.36379999f,-0.54700000f,0.03070004f,-0.40179997f,-0.74170001f,-0.84960001f,1.18759999f,0.48399998f,0.15030001f,0.71060001f,0.24450001f,0.41880002f,1.08490004f,0.73180002f,-0.57680002f,0.25240002f,0.21609998f,-0.07640000f,1.11670003f,0.39880000f,-0.91470003f,-0.03780000f,-0.92970000f,-0.81200000f,0.32159998f,-0.19460000f,-0.05530000f,-0.91190001f,0.04379999f,0.46210000f,-0.14410001f,0.95479998f,0.45929999f,1.82869998f,-0.82089998f,-0.26250000f,0.10240000f,-1.29609999f,0.78289999f,-0.05409997f,0.20140000f,-0.42510000f,0.66020000f,-0.59919998f,0.60459999f,0.85720002f,0.33279998f,0.77720001f,0.02050001f,-0.98400000f,-0.29379999f,0.13720000f,-0.72930000f,-0.45100002f,0.31960001f,-0.24980000f,-0.09820000f,0.06840001f,-0.41930002f,-0.09059998f,1.73300003f,0.38900000f,-1.04060005f,0.11039998f,1.38640001f,0.67560001f,-0.06259998f,-0.13220000f,-1.22840000f,-0.67480002f,0.14510000f,-0.20020002f,-0.21850001f,0.18720001f,0.05459999f,0.15820000f,-0.68590001f,-0.48460000f,0.76330000f,0.30580001f,-0.24400000f,0.13340001f,0.65100001f,-0.17770001f,-0.03210000f,-0.10449998f,-0.25109999f,-0.81959999f,-0.77259997f,-0.29150002f,0.78310001f,-0.27129992f,-0.58560001f,-1.02380003f,0.60919998f,0.57989996f,-0.12579999f,0.21539999f,-0.49909999f,0.41159999f,-0.39879998f,-0.82200001f,0.22520000f,-0.07189999f,0.44429997f,0.70719999f,-0.30540000f,0.00310000f,0.09000000f,-0.69229998f,-0.76469998f,-1.02400003f,-0.74400000f,-0.55680000f,-0.10910003f,-0.46460001f,-0.45530004f,-0.06540001f,0.29999999f,0.13960003f,0.96500002f,0.44080004f,-0.44590000f,-0.50840000f,0.60280000f,0.08439999f,0.25230001f,0.09759999f,0.06250000f,0.09239999f,-0.75809999f,-0.10460000f,0.04509999f,-0.00360000f,0.77760000f,0.31079998f,0.47120001f,0.84420000f,-0.71860001f,0.08240000f,-0.05340001f,0.25500000f,0.36239998f,1.64410000f,-0.51220001f,-0.73989998f,-0.44390000f,-0.79949999f,0.46469997f,0.36450000f,0.33450000f,0.47370000f,-0.62549997f,-0.17489998f,-0.63439999f,-0.84260004f,0.20990000f,0.27629998f,0.17110000f,-0.19059999f,-0.25949999f,-0.20530000f,0.67059997f,1.09440001f,-0.42539998f,-1.86089999f,0.21100000f,-1.21319997f,-0.65989997f,-0.40280001f,-0.61009997f,-0.62780000f,-0.20400001f,0.20620000f,1.12940001f,0.44859999f,-0.05560001f,0.15419999f,-1.19930000f,-0.62420002f,0.32489997f,0.49600000f,0.65330002f,-0.13700002f,-1.09560002f,-0.47120001f,0.11020002f,-0.36940002f,-0.62140000f,0.02140001f,0.82890000f,0.35840000f,-0.77729999f,-0.02439997f,1.05600001f,0.11360001f,-1.31270003f,-0.54840001f,0.02079997f,1.11039999f,-0.50079998f,-0.73709998f,-0.23470000f,-0.40600000f,-0.18719998f,-0.84370002f,0.00840000f,0.04170001f,-0.76210001f,-1.19290002f,0.48199997f,1.07609998f,0.44190000f,0.75730002f,-0.40030000f,0.60939999f,-0.62839997f,-1.09409999f,-0.17139999f,-0.21100001f,0.40699998f,-0.34120000f,0.66580001f,1.59580003f,0.41260000f,0.30940002f,-0.89610000f,-1.01599999f,-1.00630001f,-0.67380001f,0.07510000f,-0.56940002f,-0.59799999f,-0.12639999f,-0.06650001f,-0.24080000f,0.29610000f,0.12580000f,-0.18559999f,-0.25060000f,-0.81040000f,-0.35159999f,0.58249998f,0.02039999f,-0.09059999f,0.35860002f,0.59770002f,0.31680002f,-0.89770000f,-0.79780001f,0.23409999f,0.28700000f,0.62690000f,-0.17220003f,-0.07430002f,0.26639997f,0.49010005f,0.40730000f,-0.31269999f,1.16980000f,-0.81039998f,-0.93900000f,-0.49909997f,-0.29849999f,-0.27089999f,-0.15519999f,0.18380000f,0.48229998f,0.04810000f,0.20270000f,-0.31479999f,0.22040000f,-0.51710000f,-1.51100002f,-0.12900000f,-0.59560003f,0.85930000f,1.56900003f,-0.84050000f,-0.89540001f,-0.02040000f,0.54290000f,-0.54489997f,-1.01589997f,-0.52929999f,-1.41950002f,0.07140002f,0.06559999f,-0.04090000f,-0.12420002f,-1.11049998f,-0.24040000f,-0.13270000f,-0.41560002f,0.14009999f,0.20939999f,0.22770002f,0.05520000f,-1.25969999f,-0.58459999f,-0.71380004f,-0.69460001f,0.52630000f,-0.15420002f,0.03370000f,0.17820001f,0.35079999f,0.37880000f,-0.64949999f,-0.22179999f,0.19410000f,0.01580003f,0.95679998f,0.18479998f,-0.74190000f,-0.50120000f,-0.41999999f,-0.58999999f,-0.28529998f,-0.72599999f,-0.11580000f,0.12420000f,0.63359998f,-0.77319998f,0.10470004f,0.32320003f,0.85339999f,0.83030000f,0.22119998f,0.31590000f,-0.27220001f,0.11499997f,-0.85949999f,-0.43720000f,-0.61380000f,-0.05149999f,0.76379998f,-0.22600003f,-0.07269996f,-0.91900001f,-0.18420000f,-0.29430000f,-0.65829999f,-0.19140003f,0.14740000f,0.21620003f,-0.95739997f,0.47440000f,-0.58259997f,0.36999999f,0.90789997f,-0.44000001f,-0.18160006f,1.07900001f,0.59500003f,0.04959999f,0.37790001f,-0.43979999f,0.08100001f,-0.34999999f,0.07130003f,0.01960000f,-0.73240003f,0.34260000f,0.43740006f,-0.69800001f,-1.27620003f,0.71340000f,-0.66329998f,-0.11239998f,0.20770003f,0.06500000f,-0.64769999f,-0.87209997f,1.18739999f,0.39619999f,-0.03730002f,1.41229998f,-0.61340000f,0.22609999f,-0.65599998f,0.36580000f,0.13819994f,0.19010001f,-0.36160001f,0.07760005f,0.40189998f,-0.67890001f,0.02350002f,-0.68080001f,0.82360002f,0.01350002f,0.10369998f,-0.98940002f,0.24280004f,-0.25349999f,0.38049998f,0.60520003f,-1.03909999f,-0.91789999f,-0.17689999f,-0.62800001f,0.27719999f,-0.00400002f,0.11139999f,0.60700002f,0.24190005f,-0.49620000f,-0.58700001f,0.36160000f,1.10809999f,0.03960000f,-0.85580003f,0.01000001f,0.88550000f,-0.46060001f,-0.60940001f,-0.26060002f,-0.35269999f,-0.54160002f,-0.31700001f,0.33140001f,-0.00310001f,0.10460000f,0.65579997f,0.62280000f,1.50489999f,0.20300001f,-0.29639999f,0.35919998f,-0.08609998f,0.22709997f,-0.65619999f,-0.12639998f,0.38359999f,-0.55560001f,-0.20339996f,0.62039999f,0.63989997f,0.17920000f,0.81819999f,1.19660000f,-0.82720001f,-0.95789999f,-0.48259998f,-0.99650000f,-0.38920000f,-0.02230000f,-0.11569999f,0.49949998f,-0.11779999f,0.79619998f,-0.94979998f,0.99879999f,0.25749996f,-0.29050001f,0.72349999f,0.25049999f,0.56729996f,0.26929998f,-1.12030001f,-0.37760000f,-0.42870000f,-0.00220000f,-0.54229999f,0.13759999f,1.01399994f,-0.33479999f,-0.27790001f,-0.72580002f,-0.27770002f,0.40480001f,1.07800001f,-0.06900000f,-0.60829997f,0.30680002f,0.20599997f,0.33180001f,1.17380001f,0.26460001f,0.68380002f,-0.85379999f,-1.73419999f,0.39119999f,0.36510001f,0.11840000f,-0.84169998f,0.21459999f,1.13009998f,-0.35560000f,-0.97099997f,-0.10319999f,-0.25290000f,1.16149995f,-0.97019998f,-1.00870000f,-0.61809996f,-0.65729998f,-0.27410000f,0.13599999f,0.58589999f,-0.61179999f,0.92709999f,1.09929998f,0.74180000f,1.02520002f,-0.16080001f,0.53210004f,0.84419997f,-0.90249999f,-0.07419996f,-0.29030001f,-0.60679999f,-0.38730000f,0.20940000f,0.58229998f,-0.51279999f,-0.89079998f,-1.49069999f,-0.57380002f,0.84089992f,-1.01160000f,-0.36770000f,-0.37840000f,-0.15370002f,0.12280000f,1.20500000f,0.20500001f,-0.71849998f,0.15780000f,-0.50040000f,0.38919999f,1.01710000f,-0.56219998f,-1.10080005f,-0.16000002f,0.31120000f,0.06960000f,-0.05700000f,-0.00380000f,-0.10770001f,-0.22679998f,-0.71489999f,0.04420000f,0.80559998f,-0.46340000f,0.12360002f,1.11659998f,-1.22089998f,-1.22139997f,-0.36929999f,-0.96010001f,0.06890002f,0.46580002f,0.56319996f,-0.28760000f,1.35759997f,0.51929999f,-0.06070000f,0.36699999f,-0.54900000f,-0.21499999f,0.35530000f,0.29409999f,-1.06070002f,-0.28080001f,-0.32009999f,0.09600000f,-0.33450000f,-0.56589998f,-0.63339998f,0.50730001f,-0.56840001f,-0.08669996f,-0.17899999f,0.62649999f,0.19230005f,-0.49979999f,-0.71510003f,-0.20420001f,0.79679996f,-0.54519999f,-0.49690000f,-0.09700001f,0.32169994f,-0.17119999f,-0.34729997f,0.20319999f,-0.23200005f,-0.04139999f,0.32740000f,0.12080001f,0.59520004f,-0.39020001f,-1.30570000f,-0.20119999f,-1.07299999f,0.52819998f,1.18139995f,-0.48140001f,0.35139998f,-0.62979999f,-1.18110001f,-0.36420002f,0.29369996f,-0.12870000f,-0.34039996f,0.63470000f,-0.97230000f,-0.20349997f,-0.56129997f,0.44609997f,-0.99249999f,-0.49689998f,-0.96199998f,0.26919999f,-0.47409999f,0.53430002f,-1.20240001f,-0.41379999f,-0.53670000f,-1.44470000f,0.28320002f,-0.74110001f,-0.28949997f,1.34679998f,-0.22090003f,0.52530001f,-0.47430000f,-1.32450001f,-0.53749995f,0.33330000f,-0.85560000f,0.62099998f,0.17120003f,-0.11599999f,-0.28339999f,-0.89800001f,-0.98770003f,0.97860001f,1.42460005f,-0.17580001f,0.74720000f,-0.00840000f,-1.34549999f,0.72959999f,0.45950002f,-0.61399999f,0.90349999f,-0.27539998f,-0.76039998f,0.56280001f,-0.24760000f,0.33919999f,0.64480004f,-0.91020000f,0.09869996f,-0.73600002f,-0.88020003f,-0.43380000f,0.66199999f,-0.16519998f,-1.02980000f,-0.21989999f,0.34609999f,-0.47479999f,-0.39109998f,0.56350000f,0.18269996f,0.82410002f,0.48770001f,-1.09500000f,0.77100002f,0.68309999f,0.08199995f,0.65480003f,-0.42649996f,-1.38549998f,0.77189999f,0.66260000f,0.76699997f,0.60440000f,-0.59920001f,-0.30080001f,-0.31879995f,-1.14100000f,0.14020001f,-0.23750000f,-0.52709998f,-0.64839998f,0.77499998f,0.55979998f,-0.19230000f,-0.41640000f,-0.65860002f,0.21920000f,-0.57799998f,-0.26520000f,0.40769997f,0.24839999f,0.50839996f,0.06100000f,1.06100000f,-0.08200000f,0.25489996f,0.03060000f,-0.24850001f,-0.53439999f,0.08459999f,-0.29180001f,-1.09799997f,-0.04700001f,0.61039997f,0.28460000f,0.20440003f,-0.31260001f,-1.34610000f,-0.42299999f,-0.41850000f,0.17779999f,-0.48510002f,-0.93530002f,0.44340002f,-0.25250000f,0.05010000f,1.01139999f,-0.80069997f,0.60169997f,-0.30770000f,0.65429999f,-0.52740000f,0.33809998f,0.47859999f,0.12229999f,0.01440000f,-0.16009999f,-0.88969996f,-1.21229997f,-0.06480000f,-0.28070004f,-0.69939996f,-0.33459998f,1.08169996f,-0.59890000f,0.46490002f,-0.19960000f,-0.84449995f,-0.33650000f,-0.29479999f,0.47300000f,0.30829999f,-0.60460000f,-0.37060001f,-0.09800001f,-0.89809998f,0.07459998f,0.20570004f,-0.69340000f,0.44769994f,-0.73080002f,-1.32560000f,-0.40880000f,-0.26300001f,0.19000000f,-0.94189998f,0.06959998f,1.67110000f,-0.68240002f,-1.50770005f,-0.70720000f,-0.75900000f,0.30140000f,0.69889998f,0.40419999f,0.93509998f,0.67699999f,-0.30239995f,0.04080001f,-0.16820005f,-0.55590000f,-0.73799997f,-0.93899998f,-0.10030001f,-0.35060002f,-0.67419999f,-0.12030002f,-0.09349995f,-1.77399999f,0.30090001f,-0.38550001f,-0.26619997f,-0.58350000f,0.09610000f,1.14760000f,-0.89099998f,-1.97400004f,0.36330004f,-0.66229998f,-0.46929997f,0.56199999f,-0.02170001f,0.84709998f,0.17199997f,-0.26000000f,0.80359996f,1.24199998f,0.10730000f,-0.25619998f,0.11799999f,-0.06360000f,-0.07470001f,0.56520001f,0.05290000f,-0.01640002f,0.52899999f,0.72639999f,0.97479998f,-0.73800002f,-1.01520003f,0.48460001f,0.10730003f,-0.63820001f,0.23960000f,-0.20780000f,-0.96190002f,0.56660000f,0.96760001f,-0.25740000f,-0.60050001f,-0.77120002f,0.53519997f,-0.01699999f,0.11330003f,-0.54520000f,-0.46260001f,0.58120003f,0.37930000f,0.08769999f,0.41390000f,0.87339999f,0.60539998f,1.26270001f,-0.76520000f,0.36179996f,0.02619997f,-0.30939999f,-0.18240001f,-0.36960002f,-0.23100002f,-0.13269999f,-0.56089998f,-1.01660001f,0.56200002f,1.40890001f,0.06189997f,-0.72710003f,-0.49609996f,-0.00859996f,-0.53089999f,-0.66040000f,0.71249998f,-0.31320001f,0.14190003f,0.70250001f,0.61659999f,1.51550002f,0.14059997f,-0.34060002f,0.95460002f,0.30120002f,0.19720001f,-0.58860001f,-0.38050004f,-0.62179998f,-1.00869997f,-0.86540000f,-0.73860004f,0.49199999f,0.89000001f,0.72380001f,-0.02549997f,0.52280002f,-0.18540000f,0.70200002f,0.97730005f,0.28280000f,-0.39639997f,-0.12960000f,-1.29380002f,0.40300000f,1.08040003f,0.10679999f,0.51789998f,-0.76139999f,0.04780000f,0.51850000f,-1.20370001f,-0.67920001f,0.99120002f,-0.30189999f,0.25750002f,-1.35469997f,0.03060002f,-0.16850000f,-0.48429997f,0.20349998f,-0.47950001f,-0.14240001f,0.60229999f,0.71480001f,0.49090000f,0.56630002f,0.01939997f,-0.45639999f,1.06169997f,-0.20790000f,0.42980001f,0.87580001f,-0.54260003f,0.15019999f,0.46109998f,-0.14239998f,0.10700001f,-0.23010000f,0.09939996f,-0.30780000f,-0.00910001f,0.24380000f,0.71720002f,0.28040002f,-0.37870004f,0.14260000f,0.40570003f,0.43199998f,0.16599999f,0.66960002f,-0.36799997f,-0.27799999f,0.36129998f,-0.77700002f,-0.65200004f,-0.25920001f,0.59189998f,0.18400001f,0.18520001f,0.11700000f,-0.01409997f,-0.46760000f,-0.47870001f,0.39280001f,0.38850002f,0.48700002f,0.49389999f,-0.37990000f,-0.08439998f,0.08820000f,0.59919998f,0.72519999f,1.13469999f,0.14029998f,-0.70650000f,0.56450001f,0.86519996f,0.48680000f,0.16679999f,0.69320002f,-1.06759997f,-0.54029999f,-0.69440000f,0.00379998f,-0.91910000f,-0.48510000f,0.15110000f,-0.34349998f,0.38059999f,-0.19160000f,0.23820002f,0.09830000f,0.31839999f,1.20990001f,0.68519999f,0.56890001f,0.74650002f,-0.75680002f,-1.21099999f,-0.44040000f,0.63470000f,0.21499998f,0.81430000f,0.25060002f,-0.54499996f,0.59820003f,0.05500004f,-0.41940000f,-0.49360005f,0.24880000f,0.48959999f,-0.04220000f,-0.35300000f,-0.06540001f,0.33979999f,-0.06180000f,0.38849999f,-0.18360001f,-1.54999998f,0.40360000f,0.80379998f,0.98680001f,1.09610003f,0.37100000f,0.75359998f,-0.86399999f,0.20960000f,-0.11690001f,-0.16629998f,-0.17140002f,1.13979998f,-0.55720000f,1.50880001f,0.43300002f,1.10089999f,0.60650000f,0.11930002f,0.87290000f,-0.28730002f,0.03219999f,-0.69169999f,0.02009999f,-0.88829998f,-0.05950000f,-0.07330000f,-1.00499999f,0.12870000f,1.31739997f,-0.70510000f,0.81020000f,0.12409997f,1.21409998f,0.52669997f,-0.81190003f,-0.30699997f,-0.74240000f,0.33049997f,0.43180000f,-0.42170001f,0.54160000f,0.54770001f,0.09199999f,0.44389998f,-0.61660001f,0.62550000f,0.61920000f,-0.74999998f,-0.43900002f,-0.14290001f,-0.49380001f,-0.72360003f,-0.42560002f,0.89029996f,0.13800001f,-0.19470000f,0.30600000f,0.99000003f,-0.06519999f,-1.48320000f,-0.02760000f,0.29660003f,-0.35020000f,0.64180000f,0.65620000f,-0.85639996f,-0.22770000f,0.76959997f,1.41369999f,-0.42770002f,0.48019999f,-0.65239998f,0.10000003f,-0.54809999f,-0.74040000f,1.08049998f,0.15399998f,-0.98249999f,-0.48340000f,-0.25209998f,0.36389997f,-1.10969999f,-0.44780000f,0.42619999f,0.18170001f,-0.08180002f,-1.16570001f,1.11829999f,0.12740000f,-0.31070000f,0.17620001f,0.38530001f,0.11159998f,0.32360000f,-0.72980002f,-1.08750004f,-0.60400001f,0.68849996f,0.03180000f,0.29339998f,-0.22460000f,-0.04280002f,0.10600000f,-0.14350000f,-0.38499999f,0.21690000f,-0.27999999f,-0.65480001f,0.13820000f,0.97980000f,0.59480003f,0.52410003f,0.19740001f,-0.64539999f,-0.80140000f,0.32029998f,0.47600000f,-0.77290000f,-0.23660003f,0.24109995f,0.38579999f,0.75919996f,-0.76660002f,0.00710001f,0.28319998f,-1.02469997f,-0.24150002f,0.27129999f,0.05689999f,-0.07189999f,-0.20260000f,0.04540000f,-0.20749999f,-0.44979997f,-0.50809999f,0.39370000f,0.78700001f,-0.27230000f,0.32170001f,0.82529999f,-0.37040000f,0.44340001f,0.40390004f,-0.51939997f,-0.36940001f,0.82999996f,1.32179995f,-1.29910000f,0.78049998f,-0.66480001f,-0.06170002f,-0.45450000f,0.01440000f,-0.15540000f,-0.36300000f,0.30729998f,-0.08600000f,0.26939995f,-0.54500002f,-0.22560001f,0.27379999f,0.00489998f,-0.08060000f,0.80680000f,-0.85180001f,-0.86369999f,-0.66560001f,-0.86290004f,-0.05280000f,0.74570001f,0.18380000f,-0.29169999f,0.65640001f,1.19960002f,0.03240001f,0.95249999f,-0.06839999f,-1.57209999f,0.17899999f,1.20000002f,-1.74440001f,-0.44219998f,-1.33849998f,0.01560000f,-1.19360000f,-0.10559999f,-0.26689999f,-0.70139997f,-0.57829997f,-0.19680002f,0.43850003f,0.20500001f,1.54080002f,-0.17140000f,-0.01619998f,-0.36139998f,-0.72610002f,0.71159997f,-0.95540006f,-0.09539999f,-0.07639999f,-0.56459998f,0.27190002f,0.57519998f,-1.03830005f,-0.45959999f,-1.37310001f,0.33220000f,-1.15200007f,0.69529999f,0.85159997f,0.24869999f,-0.17660000f,-0.26529997f,-1.10449996f,-0.57359998f,-0.34079998f,-0.99100000f,-0.79140001f,-0.01489999f,-0.05450001f,0.37279998f,0.33279996f,-0.01280004f,0.44749999f,0.41850000f,0.73240001f,0.30459999f,0.05619997f,0.99160000f,1.06880001f,0.34540000f,-0.03230001f,0.35999999f,-0.57190002f,0.17749999f,0.20410000f,0.75980001f,-0.79220003f,-0.56339999f,-0.20960001f,-0.48019999f,-0.03570000f,0.31219999f,0.42530000f,0.61279997f,0.16639994f,-0.58819998f,-0.40090001f,-0.19099998f,0.27770004f,0.45640000f,0.35350001f,0.03199999f,-0.06589999f,-0.35799999f,-0.32980000f,-0.46759997f,-0.80899999f,-0.01720001f,-0.84930003f,-0.74139997f,-1.00879997f,0.21439999f,-1.44580001f,-0.38139999f,-1.84080003f,-0.26509997f,-0.33359998f,-0.12800001f,-0.06470001f,0.70590000f,0.60780001f,0.07410002f,-0.24649998f,-0.51809999f,0.43800000f,-0.38360001f,-0.96090001f,-0.20520000f,0.28579999f,0.68710001f,0.29950000f,0.60890001f,0.10220000f,-0.70230002f,-0.63449998f,-0.71369998f,-0.94619997f,-1.05069998f,-0.80409999f,-0.58189999f,0.56579999f,0.26420001f,0.19409999f,-0.03290001f,-0.22540001f,0.01720000f,-0.53350000f,-0.56359998f,-0.78529998f,-0.04500001f,0.41689997f,0.07799999f,1.81330001f,-0.09039999f,0.69130001f,0.54699998f,-0.54710001f,0.09380000f,-1.69550003f,-0.14359998f,-0.45789999f,0.57020000f,0.74050001f,0.13519999f,0.21530001f,0.34379998f,1.01929998f,0.09919999f,1.14669997f,-0.48679999f,0.21789998f,-0.39959997f,0.15709999f,0.79430001f,-0.08490000f,0.23140000f,-0.26790000f,-0.62699998f,-1.23739994f,-0.35399997f,0.18890000f,0.83410002f,0.38589999f,-0.30380002f,-0.13640000f,0.05229999f,0.99009998f,0.08999999f,-0.17359998f,-0.93660000f,-0.64880000f,-0.70090002f,0.05879998f,0.34489997f,0.94299998f,0.36949999f,-0.47949998f,0.35960001f,0.29690000f,0.13600002f,-0.58029997f,0.34970000f,-1.64000001f,0.11419999f,-1.01440000f,0.14820000f,0.21809999f,0.58319997f,-0.74130003f,-0.04520002f,-1.13440001f,0.45380001f,0.57509998f,-0.11820000f,0.82430001f,-0.44739998f,1.27510002f,0.12879998f,1.56260002f,0.12780000f,1.63900005f,0.00180002f,0.34480005f,0.16299999f,-1.62870001f,-0.34419999f,-0.96900000f,-0.35579999f,-0.56560000f,0.04240000f,-0.08539999f,0.68600005f,-0.69049996f,0.05940001f,0.53349997f,0.30109998f,0.42730000f,-0.12110000f,-0.07280001f,-0.39640003f,0.84289998f,0.14829999f,-0.11980000f,-0.17920000f,-0.61049999f,0.28080001f,0.54439998f,-0.20699999f,-0.73460000f,-0.32369999f,-0.25299999f,-0.05130000f,-0.25350000f,0.18939999f,0.01509998f,0.06340000f,-0.69819999f,-0.31190000f,0.03439998f,-0.79210004f,-0.37420001f,0.86659997f,-0.37480003f,0.64319999f,-0.41540001f,0.11320000f,0.91710000f,0.18680001f,1.74490000f,-0.45519998f,0.42490001f,-0.12200000f,-0.62370001f,-0.18059999f,0.20810000f,0.38479998f,-0.17920005f,0.43220000f,-0.57780003f,0.00300000f,-0.36870000f,0.09540000f,-1.07480000f,-0.02300001f,-0.69950000f,0.36379998f,0.47840002f,0.50180000f,1.36590003f,0.42619999f,0.06150001f,-0.38569998f,-0.93859998f,-0.56000000f,-0.20290001f,-0.61190000f,-0.95249996f,-0.44119999f,-0.37410001f,-0.13659999f,-0.63699997f,-0.44310000f,-0.94040001f,-0.32710001f,-0.31120001f,0.76430000f,1.05250000f,1.15330000f,0.35560000f,-0.15809996f,-1.09619996f,-0.77859998f,-0.31440001f,0.03799997f,0.46949999f,0.35520002f,-0.65329999f,-1.14330000f,-0.76459998f,0.44359997f,0.05029999f,0.74159997f,0.32090002f,0.66239998f,0.01660000f,0.60099997f,-0.86420002f,0.13219999f,-0.80789999f,0.13420000f,-0.51720001f,0.40979999f,-1.00420002f,-0.11460000f,-1.32710001f,-0.39599999f,-1.82190002f,-0.23100001f,-0.02580003f,0.28479999f,1.25140001f,0.73200000f,-0.68590000f,0.10939998f,-0.88520002f,0.72719998f,0.83469996f,0.50859999f,0.48779998f,0.76030000f,0.46529999f,-0.63770002f,-0.86380000f,-0.45059999f,0.09820001f,-0.07760003f,0.98189999f,0.30239999f,-0.45590000f,0.13900000f,-0.14190001f,-0.03870004f,1.01999997f,0.07879999f,-0.10160000f,-0.38400000f,-0.55980000f,0.49380001f,0.36970002f,0.32950001f,0.72340000f,0.27699999f,-0.10560000f,0.00859998f,0.63459997f,0.11140001f,-0.27439999f,-0.16460000f,-0.43450000f,0.54799998f,0.14569997f,-0.35759999f,1.67760007f,0.37960000f,0.56350004f,-0.59819997f,-0.47480001f,-0.48339997f,0.38240005f,0.76039998f,0.31590001f,-0.27600000f,0.74199999f,-0.27679999f,0.11340001f,-0.18919998f,-0.40369997f,0.69679997f,-0.04670001f,0.33200000f,-0.33620000f,0.43079999f,0.43700000f,-0.03400000f,0.01399999f,0.39899999f,0.66100000f,0.11259999f,0.04960000f,0.03830001f,-0.77409998f,-1.08909998f,-0.81819996f,-0.87249998f,-0.69379999f,-0.61149999f,-0.00049998f,-0.53139999f,-0.06710000f,0.18369999f,-0.15520000f,0.36689999f,0.49299998f,0.53850000f,-0.22899996f,0.16730002f,0.53859998f,0.56979999f,0.91930000f,0.80399998f,-0.11470000f,0.06040000f,-0.24749998f,-0.25029999f,-0.05790002f,0.11399999f,-0.22520000f,-0.32099999f,-0.01529997f,0.74279997f,0.86889998f,0.33859998f,0.75459998f,0.35699999f,1.33149999f,0.34819998f,1.00339998f,0.03360000f,-0.58749998f,0.43699998f,-1.19000000f,-0.13619998f,-1.50980001f,-0.05180002f,0.01879998f,-0.39199998f,0.20210002f,-0.27619998f,-1.27859997f,0.26819998f,-1.09280000f,-0.13600000f,-0.71740002f,-0.06620001f,0.13859999f,0.42249999f,0.27149998f,0.46809999f,-0.19549999f,0.61370001f,0.25650003f,0.47420001f,1.21619999f,0.90149999f,0.17280000f,0.10919999f,0.16090000f,-0.03009998f,-1.02389997f,0.24480001f,1.37170002f,1.33590002f,0.37739999f,-0.24450000f,-0.64729998f,-0.98779999f,-0.51829998f,-0.53710000f,0.35739998f,0.23330000f,-0.31899998f,-0.40550000f,-0.19549999f,0.31019999f,-1.30550000f,-0.19159997f,-1.61580000f,-0.23719998f,-0.49859997f,0.63019996f,-0.35130002f,-0.09299998f,-0.96140000f,0.24519999f,-0.64630002f,-0.37120000f,-0.31099997f,0.49859999f,-0.62800001f,-0.28440000f,-1.52730003f,0.34059999f,0.14070000f,0.23619999f,1.42980000f,0.06320001f,0.61389998f,-0.87619995f,0.66420002f,0.32019998f,-0.54630003f,-0.07240000f,0.28050001f,-0.51550000f,-0.34709999f,-0.72239999f,-0.89619998f,-1.06940000f,-0.64359998f,0.29220003f,0.52819998f,-0.01080002f,-0.30090001f,0.60670002f,0.14420000f,0.29800000f,0.70350001f,-0.38050000f,-0.90340000f,-0.30020001f,0.31310001f,0.79680003f,-0.03120000f,-0.33210003f,0.44889998f,0.34879999f,0.56100001f,-0.42510002f,-0.39230000f,-0.98160000f,0.99430002f,0.00760000f,1.30020000f,-0.11220001f,1.10130004f,0.54800000f,0.46099999f,-0.31719999f,0.03099998f,0.37200000f,-0.95550006f,-0.46439999f,-0.88370000f,0.43759999f,-0.29790001f,-0.15160000f,0.94510003f,0.17840001f,-0.22130000f,-0.21460002f,-0.89969998f,0.80899999f,0.70790000f,-0.07739999f,0.48150003f,0.23939999f,1.02650003f,-0.08260001f,1.84230005f,-0.33119998f,-0.62900000f,-0.24220001f,0.49500001f,0.58700000f,0.75810000f,0.86279998f,0.92309996f,0.90270000f,0.11020001f,-0.72859999f,-0.85439998f,-0.45189999f,0.11530001f,0.12460000f,-0.05980000f,-0.27490001f,-0.39110002f,0.31860000f,0.86019998f,0.84430000f,0.65339999f,0.00679999f,-0.85240001f,-0.40709999f,0.10370001f,0.21190000f,0.51979998f,-0.31190003f,-0.09760001f,0.49840000f,0.09640000f,-0.41520000f,0.41010005f,0.15620000f,-0.91220001f,-0.07800000f,-0.66849999f,0.81639997f,-0.05240003f,-0.03860000f,-0.01410001f,-0.79459998f,0.24590003f,-0.40180000f,0.00930000f,-0.54259999f,-0.04970001f,-0.72419997f,-0.22759999f,-0.27199999f,-0.34680001f,0.04820000f,0.65289999f,-0.02040000f,0.84310002f,0.55539999f,1.03210001f,-0.14630000f,0.24350000f,-0.08270000f,0.09039999f,-0.42890000f,0.21090001f,-0.33309999f,-0.31310000f,-0.08539998f,-0.06959999f,-0.65800003f,-0.26500001f,0.16520000f,-0.62310000f,0.07840001f,0.01400000f,-0.26570000f,-0.66509999f,-0.43090000f,0.04120000f,0.23849999f,0.40909999f,0.64369999f,0.53070000f,-0.16400001f,-0.11690000f,-0.55580000f,-0.36449999f,-0.73290000f,0.52650000f,0.12759999f,0.47630000f,-0.12340000f,2.00850002f,-0.02920001f,0.14059996f,-0.22620000f,0.41350000f,-0.08399998f,0.86420002f,-0.55319998f,-0.62189995f,0.47539998f,-0.61870001f,0.69019999f,-0.44950005f,0.56599998f,-0.12310003f,-0.21500000f,-0.22289999f,-0.38239998f,-0.02819997f,0.21299999f,0.31100000f,-0.25420000f,1.58960004f,0.05039999f,1.17220002f,0.81690000f,1.15999998f,0.77259999f,0.07150001f,-0.33510000f,0.45410002f,0.09409998f,1.17999998f,0.42589997f,0.41659999f,0.36780001f,0.21920001f,-0.67559999f,-0.82179999f,-0.63130000f,-0.40020000f,-0.04339999f,-0.55279998f,-0.12759999f,-0.12669999f,0.22060000f,0.64419999f,0.01030000f,-1.21299997f,-1.31229999f,-0.84210000f,-0.68369998f,-0.31379998f,0.09100003f,-0.22589999f,-0.04639998f,-0.54569999f,0.43959999f,1.23980001f,-0.18399998f,1.28530003f,-0.78219998f,0.70140005f,-0.68240000f,0.85420003f,0.40359997f,0.91999999f,0.35179999f,0.06599999f,0.11839999f,-1.05500000f,0.20639999f,-0.26130000f,0.17499999f,-0.50850001f,-0.33899997f,-0.41419999f,0.33099998f,0.78089999f,-0.41959999f,1.56350000f,0.07719999f,0.09349996f,0.65800001f,-0.15329999f,-0.51980000f,0.03510000f,-0.71050000f,-1.01509999f,-0.65009998f,-0.61549998f,-0.07759999f,-0.17530000f,-0.52640003f,0.45399999f,0.65930001f,-0.09089999f,0.45540002f,0.11740001f,-0.19459998f,-0.75889997f,-0.62129999f,0.10570000f,-0.18120001f,-0.18120001f,0.58859999f,1.30739998f,0.88390001f,-0.00640001f,0.24390001f,0.21880001f,-0.58500000f,-0.30149996f,0.73219996f,0.56079998f,-0.23679999f,0.93740000f,0.08239999f,0.09700000f,0.17419999f,0.02360003f,0.73739999f,0.51270001f,-0.75859996f,-0.87030000f,0.19740000f,-0.93290001f,0.42279999f,-0.18750002f,0.79079997f,0.42199996f,-0.08180000f,0.07630000f,-0.27039998f,-0.30880002f,-0.67819999f,-0.88480003f,-0.11020000f,0.41840002f,0.44239999f,1.89510001f,0.45190002f,0.62110001f,0.12300002f,-0.59489998f,-0.70469999f,-0.07419999f,-0.22699998f,0.04180001f,-0.11760000f,0.01830000f,0.33020000f,0.07470000f,0.26129999f,0.45059999f,-0.32510000f,-0.63159999f,-0.85400003f,-0.03930001f,0.07009999f,0.58780000f,0.86050001f,0.00389999f,-0.59630002f,0.14689999f,-0.23559997f,-1.06849996f,-1.18419997f,-1.21539997f,-0.85910000f,-0.23910002f,0.36099999f,-0.21000003f,0.90799997f,0.68269996f,0.16639998f,0.65559998f,0.22519999f,-0.02530002f,-0.13900000f,-0.54759999f,0.22119999f,-0.04989999f,0.11779999f,0.64900002f,0.31640000f,1.30510004f,-0.35400000f,0.21130001f,-0.64019999f,-0.35429996f,0.81999998f,0.76479999f,-0.37939998f,0.31479997f,0.75459998f,0.33689996f,0.37740000f,-0.17980005f,0.11670002f,-0.67039999f,-0.19599999f,-0.63609998f,-0.33129998f,-0.38019998f,-0.30319998f,-0.15160000f,-0.38470000f,-0.44049999f,-0.24069999f,-0.43660000f,0.77340001f,1.19129999f,1.11360001f,0.68010001f,-0.20320002f,-0.53490001f,-0.49380002f,0.18870000f,-0.42320001f,-0.64260000f,-0.74260001f,-0.04750000f,-0.01830000f,1.07689999f,0.46950002f,-0.62419998f,0.09160001f,-0.66200003f,-0.07799998f,-0.08590001f,-0.60079999f,0.23609998f,-0.50039998f,0.46779998f,-0.14439998f,0.86649999f,-1.32399998f,0.97670005f,0.20679998f,0.10920001f,0.55320001f,-0.42360003f,0.05680001f,-0.79649999f,0.35479996f,-0.91330004f,0.27660002f,0.25429998f,-0.31459999f,0.63140006f,-0.52420005f,0.24139998f,-0.50319998f,-0.28970001f,-0.15120000f,-0.44140006f,1.29720001f,0.16909999f,-0.20360003f,-0.24990001f,-1.47890001f,-0.27849999f,-1.01820000f,0.06640000f,-0.54100004f,-0.45730001f,-1.51540007f,-0.13530000f,0.44459998f,0.33000000f,0.92050000f,0.15000000f,1.18730004f,0.17300001f,0.18100001f,-0.15840000f,0.67570001f,0.34260001f,0.92840003f,-0.26230000f,-1.29010006f,-0.20760001f,-0.02410006f,-0.11230000f,0.04469998f,1.13109998f,-1.00819997f,0.60579997f,-0.15499999f,-1.07699998f,1.34999996f,-1.24299997f,0.62239997f,-0.67000006f,0.58420002f,-0.41250006f,-0.21319997f,0.25609999f,0.08520003f,0.46419999f,-0.51499999f,1.10720004f,-0.84840002f,0.66929998f,-0.37679995f,0.87490001f,-1.22840002f,0.76149998f,-0.36639997f,-0.77740004f,0.46300003f,-0.39570005f,-0.60079998f,0.00259997f,-1.24809999f,-0.17020000f,-0.25060001f,-0.20040000f,-0.12480002f,0.14070000f,0.65420004f,0.03220000f,-0.02389997f,0.19120001f,-0.71760001f,-0.16630001f,-0.17700005f,0.06690000f,0.76080000f,-0.01320000f,0.64740004f,0.24570001f,0.01250004f,-0.15020000f,-1.45980001f,-0.25770000f,-1.08860002f,-0.17160000f,-0.50010002f,0.05960000f,0.15530001f,-0.03540000f,-0.36329999f,-0.75240000f,0.17079999f,-0.04200002f,-0.19339997f,0.39210001f,-0.85500002f,0.36060005f,0.60379996f,0.75560004f,-0.29120000f,-0.73080000f,1.26720000f,-0.70660004f,-0.46419999f,-0.00810004f,-0.62179998f,-0.04499999f,0.25460000f,-0.51159997f,0.83219997f,-1.41209998f,1.05139997f,-0.99779999f,1.15619997f,0.53609999f,-0.77839999f,0.90819999f,-0.31819999f,0.58369999f,0.10880001f,-0.09350000f,0.16299998f,-0.05070000f,-1.16369999f,-0.25160000f,-0.55320001f,-0.03380000f,0.87650000f,0.26570001f,0.79670004f,-0.01970000f,0.39329999f,0.22670000f,0.43430005f,0.08640000f,-0.98600002f,-0.16250000f,-0.41280004f,0.11730000f,0.57060000f,0.33990000f,0.61420001f,-0.35310000f,-0.33060002f,-0.02890000f,-0.55979999f,-0.21739999f,0.46820000f,-0.24330001f,-0.18159999f,-0.59050001f,0.34160000f,-1.52849996f,1.57799993f,-0.95990000f,-0.50060000f,-0.04130000f,-0.23959999f,0.28100001f,0.30259999f,1.25290000f,-1.19079998f,0.90250007f,0.59119995f,-0.40559998f,0.82780000f,0.17290000f,0.25140002f,0.73850000f,-1.06139998f,-0.22530002f,0.09960000f,0.04719999f,-0.54799999f,-0.43199999f,0.54619998f,0.38690001f,-0.51569997f,-0.00310000f,0.90450001f,0.37480000f,1.61670003f,0.18180000f,0.60870002f,0.11900000f,0.61240001f,0.22980000f,-0.06599999f,-0.09200000f,-0.86090002f,-0.32010000f,0.05239998f,0.35939999f,0.05129999f,-0.17170001f,-0.36890001f,-0.11230000f,-0.39630001f,-0.07710000f,-0.17110003f,-0.07890001f,-0.32120004f,-0.13050001f,-0.16880002f,0.19050000f,0.18660000f,-0.44219995f,1.02359995f,-0.59520001f,-0.31579998f,0.34190000f,-0.41260001f,0.39100002f,0.44280000f,1.37820000f,-0.85219999f,0.60180000f,0.03280000f,-0.68270003f,0.40360001f,0.11210002f,-0.24480001f,-0.80740003f,0.81580000f,-0.89670003f,0.18980000f,-0.51750001f,0.25360000f,-0.50190003f,-0.27719997f,-0.92000001f,0.90819999f,-0.58490000f,0.26260002f,0.01290003f,-0.17450001f,0.15640000f,-0.24440000f,-0.09860000f,-0.23850001f,0.13880000f,-0.36190000f,-0.16150000f,-0.69950003f,-0.17210001f,-0.52080002f,-0.19309999f,-1.32490004f,-0.25910001f,-0.67580008f,-0.20230001f,0.64829998f,0.19060001f,1.02460004f,-0.01970000f,-0.53669999f,-0.24099999f,-1.11069999f,0.14340000f,0.69490001f,0.12190000f,0.34730000f,-0.00500000f,-0.61280001f,-0.51929999f,0.12459998f,-1.28979998f,1.32919997f,-1.17639999f,0.52660001f,-1.46249998f,1.23399995f,-1.40750003f,0.18920002f,-1.04170000f,0.69859998f,-1.63440004f,0.99700002f,-1.13840007f,0.09100003f,0.61659997f,-1.47459999f,0.61400000f,-0.71740000f,-0.74029997f,1.46919995f,-1.05199999f,0.74800001f,-0.30780002f,-0.69839999f,-0.90929999f,1.01379998f,-0.98350001f,0.13879998f,0.12110000f,0.80690001f,0.31360000f,0.23530000f,-0.38140001f,-1.04190002f,0.23880001f,0.96430004f,0.14550001f,-0.12799999f,-0.32110000f,-0.85340001f,0.21220000f,1.45869998f,0.28619999f,0.60150001f,-0.05160000f,-1.26220003f,-0.31420000f,-0.03839998f,0.35300001f,1.77540006f,0.36680001f,0.94320005f,0.07920000f,1.05369999f,0.26779999f,-0.11479999f,0.64289998f,-0.58739998f,0.28690001f,-0.31140000f,-0.34510002f,0.86120001f,-0.00199995f,0.34799998f,1.21130001f,-1.35239998f,0.45199998f,0.23000001f,-0.53509998f,0.57620001f,0.84329999f,-1.15919998f,0.97970001f,0.21119999f,-0.45980003f,0.31600002f,-0.38319996f,-0.05620004f,0.47170004f,-0.58520001f,-0.12009999f,0.24840001f,0.59250000f,-0.50639999f,-0.68119999f,1.87840006f,0.29620001f,0.60500003f,-0.10790000f,-0.76629999f,-0.02860000f,-0.71610000f,-0.14610000f,-1.16570000f,-0.12710000f,-0.16259999f,0.19550000f,-0.01899998f,-0.00500000f,-0.20460001f,0.02429999f,0.87829997f,0.08590000f,0.18280003f,-0.17150000f,0.52260000f,0.13140000f,0.69050004f,0.21990001f,0.52130004f,-0.02590000f,0.10909999f,-0.16340000f,-1.03060003f,0.76680002f,-0.55520001f,0.45470000f,-0.28019999f,-0.94189996f,1.19419996f,-1.27049997f,1.13579995f,-1.17439999f,0.91339999f,-0.23009996f,0.44199996f,0.04180001f,0.11260000f,-0.64820000f,0.17540001f,-0.02040004f,-0.72939997f,-0.30770000f,-0.02500003f,0.70220001f,-0.53799999f,1.34760001f,-1.15319998f,-0.05759999f,0.01760000f,-0.55310001f,0.08939999f,-0.80730003f,-0.09380001f,0.07950000f,0.85039999f,-0.00700000f,-0.11250000f,-0.23279999f,0.29440005f,0.31870001f,1.84050005f,0.36330001f,1.38550007f,0.11900000f,0.52600000f,-0.08920000f,-0.99350000f,-0.21209999f,0.71600003f,0.34060001f,1.58550007f,0.19490000f,0.35690002f,-0.10230000f,-0.98610000f,-0.11020000f,-0.44120001f,-0.14970000f,-0.69259998f,0.04510000f,-0.72210004f,-0.48460001f,-0.22059999f,-0.00540004f,-0.51299996f,-0.33540005f,-0.19419998f,-0.19799994f,0.11879995f,0.93700001f,-1.44299999f,0.48220002f,-0.13080000f,0.18589999f,-0.43620000f,-1.04719998f,1.28399998f,0.42150002f,-1.75180003f,0.58090002f,-0.38779999f,-0.44029998f,0.95959997f,-0.51649998f,0.74699998f,0.60169996f,-0.78219996f,0.22040003f,0.66939997f,-0.81350006f,0.47090005f,0.13580000f,-0.09649998f,-0.07830000f,-1.47540001f,-0.13919999f,-0.98480000f,-0.31740000f,-0.41980001f,0.28640000f,0.50280000f,-0.30360001f,-0.38980003f,0.15300000f,1.35470004f,0.21640001f,-0.26719998f,-0.19260000f,-0.80250002f,-0.05010000f,0.55030001f,0.25270001f,1.20930002f,0.18730000f,0.73970003f,0.28110001f,0.46670003f,-0.07870000f,-1.41740004f,0.72620005f,-0.17980002f,0.32320004f,0.57239998f,-1.01139998f,1.21240000f,-0.91280002f,0.56199998f,-0.03960001f,-0.43959999f,-0.10800006f,-0.06499998f,-0.39620001f,-0.06520000f,0.63010002f,-0.75940001f,-0.13079997f,1.26200000f,-0.38480002f,-0.73200001f,-0.39159998f,0.43700000f,0.44549999f,-0.33519999f,0.73180003f,-0.45460001f,0.32000005f,0.65399999f,-0.65179999f,-1.50340004f,-0.13020000f,0.58910002f,0.09840001f,0.61400003f,0.32050001f,1.65590002f,0.24959999f,1.24940002f,0.30360000f,0.04810002f,-0.32830000f,-0.83570002f,-0.21330000f,-0.75010002f,-0.12150000f,-1.04070007f,-0.33270001f,-0.11340005f,0.09250000f,0.60830003f,0.13760000f,-0.43040002f,-0.30030001f,-0.56020003f,0.07700000f,0.53750002f,0.39130000f,1.25620002f,-1.29110003f,0.68120001f,0.30730002f,-0.53640001f,1.04010005f,-0.71360001f,0.93509998f,-1.17619996f,0.06640003f,0.28719997f,-0.91500000f,0.83419998f,0.06169999f,-0.50200000f,0.53800002f,-0.03820000f,-0.01960004f,0.08280003f,1.09109996f,-1.18619998f,1.31580000f,-0.83799999f,-0.43320003f,0.87220002f,-0.15660001f,0.03379998f,0.44280002f,-0.18259999f,0.91530001f,0.57910004f,0.11440000f,0.53360001f,0.04790000f,0.11000002f,0.18460000f,-0.70510002f,-0.26750001f,-0.16570000f,0.04680001f,-0.86960000f,-0.28180000f,-1.31500005f,-0.12170001f,0.16419997f,0.19950000f,0.21520002f,-0.08060000f,0.00589999f,-0.05610000f,0.14569999f,0.01420000f,0.61180003f,0.27270000f,0.52200002f,-0.09970000f,-0.64400000f,-0.00900000f,-0.97400003f,0.23760003f,-0.23540000f,0.44770001f,0.02620000f,0.91060006f,0.15299997f,-0.17330002f,-0.05439999f,0.15170001f,0.35279999f,0.19119998f,-0.02319997f,-1.02060001f,0.70880000f,-0.99200001f,0.23100000f,-1.19240002f,0.88419999f,-0.39070002f,-0.15259999f,0.57759998f,-0.63979997f,0.70150002f,-0.40040001f,0.37360001f,0.07560000f,0.17720005f,0.74499997f,-0.25739999f,0.31369999f,0.35440000f,1.37220007f,0.17820001f,0.96190005f,0.19620001f,0.94780006f,0.21770001f,0.52080001f,-0.01940000f,-0.12450000f,0.24160000f,-0.19309999f,-0.13950000f,-1.00410004f,-0.15380000f,-0.64230002f,-0.18740000f,-0.18910001f,0.02350000f,0.49110000f,0.07270000f,-0.61749998f,-0.31430000f,-1.70750005f,-0.40660001f,-1.47470003f,-0.00160000f,0.01250003f,1.05519998f,-1.37439997f,0.39510002f,0.17579999f,0.84620004f,-0.25780003f,2.08710004f,-1.45019998f,1.81460003f,-0.59719999f,0.62020006f,0.07719996f,-0.63099998f,1.15779999f,-1.04130003f,0.31400000f,-1.16080001f,0.49119999f,-0.58479999f,0.25719999f,0.43099997f,-0.99139997f,-0.84989999f,1.46179997f,-1.05730002f,0.76620000f,-0.18949997f,0.64239996f,0.23860000f,-0.84370000f,0.14710000f,0.75720001f,0.00580000f,-1.37680001f,-0.32200001f,-1.51330003f,-0.19150000f,-0.33680001f,0.17870000f,0.86950001f,-0.04109999f,-0.61729999f,-0.06330000f,0.63250003f,0.17520001f,-0.08069997f,-0.04100000f,0.26510001f,0.04890000f,-0.36300002f,-0.17240000f,0.76619999f,0.25190000f,0.48530001f,-0.08250001f,0.42570002f,0.28820001f,0.81730005f,-0.32929997f,0.40519998f,0.12760001f,0.07459999f,-0.64140000f,1.14059999f,-1.24480000f,0.63399998f,-0.91089999f,0.55360000f,0.68819998f,-0.70739997f,-0.09470002f,-0.11680000f,-0.40699999f,0.07439999f,-1.21359998f,1.09339996f,-0.33020000f,-0.02760000f,0.03559997f,-0.01039997f,1.42089998f,-1.67779999f,0.68409999f,-0.19259999f,0.20270004f,0.20799998f,1.00110005f,0.90050003f,0.33210001f,0.53450007f,0.06520000f,0.38490002f,0.07620000f,0.00030002f,0.09440000f,0.21270001f,-0.04490000f,-0.02980000f,0.05840000f,0.91240000f,0.22870000f,-0.07709999f,-0.09480000f,-0.40890002f,-0.05700000f,-0.23430003f,-0.02810000f,0.21520001f,0.26900000f,0.91900000f,-0.01070000f,-1.35519998f,-0.17070000f,-1.22329999f,-0.29170000f,-1.41000005f,0.25410002f,-0.48920002f,-0.82419996f,1.01219996f,-0.48549998f,0.31799996f,-0.02539997f,0.08879998f,0.03410000f,-0.10840000f,-0.19000000f,-0.09859999f,0.36620002f,-0.31380001f,-0.32029998f,0.90439999f,0.11900001f,0.09980000f,0.89920000f,-1.02620000f,0.00150003f,0.40660000f,0.38129999f,-0.14520000f,-1.15629999f,1.37319995f,-1.93850000f,1.51459998f,-1.10990005f,-1.28450001f,-0.16900000f,-0.87780001f,-0.15520000f,-0.06740000f,0.05360000f,-0.19140000f,0.07130000f,0.09560002f,-0.13740000f,-0.88540002f,-0.14540000f,0.97949999f,0.34950000f,2.06230008f,0.37650001f,0.50180003f,-0.02190000f,-0.04180002f,-0.02150000f,-0.62890001f,-0.16940000f,-0.82960003f,0.14280000f,0.79730001f,0.18000000f,-0.08669997f,-0.18640000f,0.39450003f,1.06260000f,-0.28909998f,-1.96649999f,0.48229996f,0.07350000f,-0.48559998f,-0.61010001f,-0.53690001f,-0.50279998f,0.15260000f,-0.78759998f,0.70079998f,-0.13879999f,0.77049999f,-0.10960000f,1.17559999f,-0.03699998f,-0.08550000f,1.12450001f,0.11640001f,0.93279995f,0.75890000f,-0.00830004f,-0.42230002f,-1.35429998f,0.35800002f,0.81720003f,0.23380000f,1.37940002f,-1.10019997f,-0.03359998f,0.69560003f,1.28269996f,0.98499999f,-0.37449999f,-0.12140003f,-0.81869999f,0.26130000f,-1.18219998f,-0.91619998f,-0.78209995f,1.45890004f,1.83039996f,-0.52190003f,-0.47469999f,-0.51520001f,-1.02010000f,1.22580003f,-0.05030000f,0.04869999f,-0.02719998f,-0.09380005f,0.58319996f,0.69220004f,-0.78639999f,0.81470003f,1.14120001f,-0.49420000f,-0.26260000f,0.43389999f,0.66300000f,0.67989997f,-0.10400000f,-0.61139998f,-1.33039999f,-0.42779999f,-0.60939997f,-0.52559999f,-0.35290000f,0.18409999f,0.27409998f,0.95319997f,0.25520001f,-0.21439999f,0.16309996f,-0.32720000f,0.20509999f,-0.29959999f,0.11140002f,-0.32519998f,-1.04310000f,0.31319999f,-1.05879995f,-0.43220000f,-0.45169999f,0.42790000f,-0.88470000f,-0.58599999f,0.60490000f,-0.82090003f,0.61890005f,1.07280005f,0.87399998f,0.13420001f,-0.42670002f,-0.97950000f,0.51289997f,-1.02690003f,-0.49159993f,0.91590002f,-1.28470002f,0.48730003f,0.69990000f,-1.26439997f,0.22910002f,-0.01050000f,1.08500000f,-0.23490003f,0.38909998f,-0.42499998f,1.47629998f,-0.08520000f,0.68639999f,-0.24319999f,0.20329998f,-0.12150002f,-0.61479998f,0.14470000f,-1.06800000f,0.72370002f,0.03850002f,0.39569999f,0.85160000f,-0.60370000f,-0.57960002f,0.45129997f,-0.60840001f,0.44700002f,0.60029997f,-0.47980001f,0.62629999f,0.27510000f,0.27369998f,0.41480000f,1.29659999f,0.51820000f,-0.11389999f,0.22079999f,0.00510002f,0.94279998f,0.44860000f,0.36929999f,-0.60039998f,0.33069997f,-0.22160001f,-0.14090000f,0.21790001f,0.17519999f,1.80909998f,-1.02090001f,-0.11059998f,1.02320004f,-0.10810003f,-1.12110006f,0.81260000f,1.47880004f,0.02479998f,-1.32780001f,0.31110002f,1.44599999f,1.17529996f,-1.03760002f,-1.10899997f,0.44590000f,0.59400002f,-0.61700002f,0.94710001f,0.53240001f,-0.38469999f,-0.10220000f,-0.17600000f,0.52029998f,-1.45229998f,0.93129999f,0.60919999f,0.33410000f,0.44400005f,0.97899999f,0.10230002f,0.24740001f,1.36950001f,-0.50570001f,-0.60020000f,0.58780000f,-0.59519999f,-0.28940001f,-0.58490000f,0.53610000f,0.64680002f,0.24220000f,-1.12029996f,-0.32009999f,0.62070001f,0.29310001f,0.13479999f,0.65770001f,0.18590000f,-0.35019999f,-0.52829999f,-0.04190000f,0.11140000f,-0.94159998f,0.68860004f,-0.77890002f,-0.47599998f,-0.25930003f,0.99239999f,0.30790001f,1.36690001f,0.13270003f,-0.13919999f,1.67530004f,0.01419997f,0.70239994f,-0.56610003f,-0.26749996f,0.74459999f,0.52430001f,1.02589998f,-1.11830005f,-1.64299998f,0.64640001f,0.14100000f,0.21539999f,2.14450000f,0.22220002f,-1.10439998f,-0.18800001f,1.23389997f,0.36639998f,-1.00079997f,-0.15009998f,1.37419997f,-0.13409999f,0.01379998f,0.75830000f,-0.51299997f,0.92000001f,-1.07909996f,0.28239999f,0.62650000f,-0.44890001f,-1.08720000f,-0.73669999f,-0.84179997f,0.31839999f,-0.16770000f,0.27580000f,-0.63389997f,-0.58120000f,0.11410002f,0.15139999f,-0.28700000f,1.19690001f,0.13620001f,-0.74569998f,0.40370001f,0.51609999f,-1.01659998f,-0.60029998f,0.26560003f,1.62820005f,0.89609999f,0.28450000f,0.54129999f,-0.54439998f,0.38009997f,1.40850001f,-1.27990003f,-0.60240003f,2.14330000f,0.08270002f,-0.43940000f,-1.75180002f,-0.57419997f,0.67110004f,1.61670002f,-0.95410000f,1.46570001f,0.18759998f,2.47790004f,-0.63880001f,0.07590003f,0.58539995f,-0.64630000f,-0.97809997f,-0.20429998f,0.84590002f,-0.13740000f,0.44550003f,-0.18950000f,0.26080000f,-0.86919999f,0.15310000f,-0.84330000f,0.47599997f,-0.07770002f,-0.95350001f,-0.08579998f,1.18280001f,0.19620003f,-0.36819999f,-0.33590005f,0.34880000f,1.11070002f,0.97200000f,0.65230004f,1.01589999f,0.66970002f,1.23240002f,0.31100003f,0.01540001f,-0.05170002f,-0.58499998f,-0.63470001f,0.22910000f,0.34319998f,-0.15160000f,-0.21709999f,1.38360001f,-0.17700004f,0.09300001f,-0.45010001f,0.77869998f,-1.64759999f,-1.11270002f,-0.49539998f,0.21520002f,-0.91679998f,0.60820000f,0.55799997f,-0.25650001f,-0.21390003f,-0.13640001f,-0.25840002f,-0.17139999f,0.04789999f,-1.67040003f,-0.52999996f,-0.02859998f,0.94120002f,-0.89460003f,-0.17039995f,0.82040002f,0.95979998f,-0.38380000f,-0.36120000f,0.39260001f,0.43489998f,-0.31660001f,-0.65819999f,-0.31270001f,-0.64460002f,-1.05959998f,-0.14800000f,0.10130001f,0.53760000f,-0.33220000f,0.53919999f,0.11239999f,0.74080000f,-0.40980000f,-0.60410001f,-0.20830001f,-0.07269999f,0.05430000f,0.02150002f,0.38570000f,1.21650000f,0.86840000f,0.95119998f,0.32640002f,0.40740000f,0.49799999f,-0.39829999f,0.00700000f,-0.44790000f,0.53800001f,-0.48739998f,0.06109998f,0.91450003f,0.72390006f,1.40419997f,0.64500002f,0.52769999f,-0.20670000f,-0.37979999f,-0.43109997f,0.34549999f,0.86389998f,0.64749998f,-0.20799999f,-1.75299999f,-0.69810001f,-0.95349999f,-0.12819997f,1.30340000f,-0.78020000f,1.06840002f,0.09569999f,-1.05460000f,-0.28039997f,0.12380002f,0.30630000f,-0.34460000f,1.05409999f,-0.70190000f,-0.20060000f,-1.00190000f,0.80000002f,-0.77509997f,0.93079997f,-0.02010000f,0.15390000f,-0.86870002f,-0.04360000f,0.13390001f,0.48759998f,0.14950001f,0.24989999f,-0.84030002f,-0.75090000f,0.49309997f,-0.10880000f,0.96000001f,0.92129999f,0.70240002f,0.85160000f,-0.05370004f,-0.35430001f,0.14469998f,0.38500000f,0.36809999f,-0.09150000f,-0.82489997f,-0.47010004f,-1.12460002f,-1.93480003f,-0.30109991f,2.01090004f,-0.04509999f,-0.79240003f,-0.44229999f,0.16390003f,-0.68150002f,-0.81740004f,-0.42949999f,0.37210003f,-0.89300001f,-0.08960001f,0.41589999f,-0.21670000f,-0.31470000f,0.65350002f,0.02740000f,0.09630001f,0.35960000f,-0.40859997f,1.44509999f,1.59060004f,-0.56740002f,-0.56730004f,0.23839999f,-0.70570001f,0.39870001f,-0.77910000f,0.03440000f,0.45230003f,1.40250000f,-0.55589998f,-1.11010000f,-0.15700000f,0.99670001f,-0.58590001f,0.10089997f,-0.12680000f,0.26250000f,-0.56720001f,-0.09270001f,0.22809999f,-0.19440001f,-0.04370000f,0.24540000f,-0.16800000f,-0.83740001f,0.19109999f,-0.34110000f,0.99769998f,-0.39929999f,-0.65410002f,-0.36830000f,0.12450000f,0.98599999f,-1.50420003f,-0.14579997f,1.00350003f,-0.21029999f,-0.40410003f,-2.35499998f,1.44080001f,-1.09890000f,1.01869997f,-0.76260001f,-0.10839999f,-0.14620001f,0.16030002f,0.61920003f,0.50730002f,-0.58240000f,-1.13559999f,0.76339998f,0.53760003f,-2.04179994f,0.76329998f,0.95549999f,0.50690005f,1.38269998f,0.12909995f,-1.71709998f,1.19910005f,0.73980000f,0.82630001f,-1.40190000f,0.40040001f,0.56139999f,-0.17279999f,-0.03320003f,-1.13379999f,0.06519999f,-0.93889999f,-0.97799997f,-0.84179998f,-1.12609997f,-0.13460000f,-1.39580001f,0.57890001f,0.93639999f,-0.52969999f,-0.34730002f,0.74359997f,-0.35890003f,-0.90139998f,0.14229998f,0.44340000f,-1.26009996f,0.75829997f,-0.86509999f,-0.77329998f,-0.09239999f,0.16320000f,-1.20170002f,-0.93630004f,-0.88450004f,-1.48820005f,-1.32170001f,0.29940005f,0.72109998f,0.54029998f,1.88419995f,1.18340004f,-0.65450001f,-0.05040000f,-0.51910004f,0.34229998f,-1.08290002f,-0.19860004f,-1.09539998f,-1.27129997f,1.16579998f,-0.27190000f,-0.54860002f,-1.44010003f,0.10930002f,-0.28630003f,-1.23149998f,-0.99700002f,-0.00760000f,1.00040000f,-0.59890002f,0.48979998f,0.80050002f,-0.65420001f,0.00879998f,-0.26840001f,0.46230000f,0.62799998f,0.18250000f,0.94899999f,-0.60329996f,-0.78350000f,-0.20460000f,-0.59720002f,-0.36700000f,-0.90230000f,0.04910000f,-0.78609997f,0.47030001f,0.83789997f,1.54729999f,-0.42530001f,1.40559997f,0.14420001f,1.30069996f,-0.80089998f,1.06310000f,0.01790000f,-0.29269999f,-0.60890001f,-0.04970000f,-0.97990000f,-0.50339990f,1.43710003f,1.32159997f,0.38060003f,1.24559999f,-1.00320004f,1.62170001f,0.30409999f,-1.49430002f,0.40550003f,-0.62800002f,1.38600002f,0.28359997f,-1.14150001f,-0.07849996f,-0.00739998f,1.24339999f,0.49759999f,-0.37910001f,-0.35410001f,0.61170002f,1.08810004f,0.97489997f,-0.38770001f,0.80779999f,-0.27660001f,0.87639999f,-1.45710003f,-1.17140002f,0.26190004f,0.81099999f,0.47249999f,-0.10839997f,0.25860000f,-0.24709998f,0.86430001f,-0.29160002f,-0.90450000f,-0.51090002f,-0.39880001f,-0.38159999f,-0.32260001f,0.02370002f,-0.07819998f,-0.00510001f,0.62969998f,-0.72350000f,-0.29090001f,-0.99050000f,0.64770000f,0.34140000f,0.29529999f,0.02310001f,0.31200000f,0.05040003f,0.40839999f,0.14330002f,-0.00329999f,-0.77750002f,0.95850000f,-0.28430005f,-0.67730005f,-1.42609998f,0.80739998f,-0.43030001f,0.06570002f,0.16399999f,0.78810000f,-0.77419998f,-1.27890001f,-0.63139999f,0.74890000f,-0.64949999f,-0.08280001f,-0.58840003f,-0.01740002f,-0.35520000f,-1.69750002f,0.08410003f,0.46640002f,0.09559998f,-1.17800003f,-0.31500000f,0.79440006f,1.19039999f,-0.00610002f,-0.32630000f,-0.63090001f,-0.40919999f,-0.59370002f,-0.18210000f,-0.86409998f,-0.42659999f,-0.47199999f,-1.36289998f,0.19779999f,-0.73699999f,-0.42369999f,-0.39970000f,0.28729999f,0.77960000f,-0.20200000f,0.86130001f,-0.33430001f,1.04500000f,-0.44799998f,0.38959999f,0.36380001f,0.94069999f,-0.06730001f,-0.62490004f,0.33140000f,0.87710001f,0.59659999f,-0.63300000f,-0.05440005f,0.58989998f,-0.89100000f,-0.58389999f,0.39180002f,-1.45589998f,1.02450002f,-0.56260001f,0.26530003f,-0.86470002f,-0.01300004f,0.04059996f,0.13410002f,1.97050001f,0.87920002f,-1.22400002f,0.28580003f,1.26200000f,-0.44760002f,0.41650000f,-1.19150003f,-0.33170000f,0.53300001f,-1.91489999f,0.32589998f,-1.07700000f,-0.16430000f,2.02540002f,0.46759995f,-1.05549997f,0.33569999f,-0.85469999f,0.25399999f,0.49359997f,-0.47620000f,0.20499998f,-0.39380001f,0.62179998f,-0.78880001f,-0.75550002f,-0.06170001f,-0.74759998f,1.10480001f,-0.56420001f,-0.87430000f,0.06550003f,0.37820000f,-0.42209999f,0.16250000f,0.49690001f,0.08150000f,0.39670001f,-1.06000001f,0.09949999f,-0.67880000f,0.40500003f,0.97650001f,0.10810003f,0.02830000f,-0.08660001f,-0.85809998f,0.76210000f,0.60649998f,1.24270002f,0.37950005f,-1.62470001f,-0.17650004f,-0.95929998f,-2.22770001f,-0.53169995f,0.63190005f,0.87979998f,-1.05840003f,0.01130001f,1.74060002f,0.52110002f,-0.30960005f,0.41329994f,-0.44240001f,-0.26620001f,0.66440001f,-0.60690001f,0.06970000f,1.21999996f,-1.72599999f,-0.32609995f,0.18569997f,-1.25609999f,-0.15000001f,-0.40729999f,0.74579998f,-0.43750001f,0.83450001f,0.14530001f,-0.92970001f,1.37299998f,-0.78909998f,-0.20460005f,0.40310001f,1.01219997f,0.65099998f,0.86819999f,0.33090001f,1.29880003f,-0.41959998f,-0.83589997f,-0.14600001f,-1.00369998f,-0.08430001f,-0.27790001f,-0.43910000f,0.27490001f,0.46239999f,0.21060000f,0.20570001f,1.98229999f,-1.56459998f,0.17620003f,0.41839999f,-0.47329997f,-0.05199998f,-0.15730000f,-0.18309999f,1.63229999f,-1.07699999f,0.63430003f,-0.03050002f,0.11030001f,-1.98459997f,0.84390002f,0.37889997f,-0.13519997f,-0.04790000f,1.13490002f,1.55119998f,-0.12339999f,-0.58930000f,0.04460002f,-0.33009997f,0.07300005f,0.35130000f,0.84910002f,-1.93140003f,-0.19749996f,0.18990000f,0.54379997f,0.77799996f,0.75769999f,-0.77229997f,0.19680003f,0.66329997f,-0.04040001f,0.05689999f,0.65830001f,-0.47199999f,0.89859996f,-0.62459998f,-0.05350002f,-0.49470000f,-0.23200003f,-0.75799999f,-1.26480002f,0.11470000f,-0.61529996f,-0.02629999f,-1.09919997f,-0.82979998f,-1.17940004f,0.17070000f,1.24020004f,-0.60710000f,-0.41890004f,-0.16729999f,-0.62950005f,-0.70819999f,0.05700000f,0.23280001f,-0.24200001f,0.05290000f,0.14219999f,-1.09239998f,-0.45979998f,0.26690000f,-0.01879997f,-0.38720001f,-0.23679998f,0.45579999f,-0.60960002f,0.56480000f,0.67820001f,-0.93870003f,-0.16780000f,0.76460002f,-0.03220001f,0.60030001f,0.37280000f,-1.30820002f,-0.69360000f,-0.20479997f,-0.21239998f,0.31140000f,-0.38140002f,-0.55790001f,-1.44320001f,-0.64759998f,-0.38060003f,-0.43019997f,-0.48169998f,0.75849997f,0.85440000f,0.10569999f,0.65809999f,0.18330000f,0.14030002f,-0.72829997f,0.50589997f,-0.65729996f,-1.05839998f,0.25690000f,-0.76539999f,-0.06920000f,0.68010001f,0.41209998f,0.56150000f,0.56709998f,0.67549996f,-0.35340001f,0.24759998f,0.19280000f,1.37730000f,-0.16259999f,0.31120000f,-0.61639999f,-0.12400001f,-1.10790001f,-0.53400001f,0.38130000f,-0.20180001f,1.12500000f,0.85280000f,-1.49939999f,-0.56680000f,-0.47560000f,-0.16439999f,0.20209996f,-0.06139999f,1.05830001f,0.10439998f,-0.18860001f,0.24019998f,0.65980003f,0.29919999f,-0.88520001f,-0.20780000f,0.16730000f,-0.08780002f,-0.02830000f,0.14219999f,-1.17409997f,-0.49919998f,0.03269998f,0.80440000f,0.05630000f,0.18190002f,-0.90470001f,-0.18160007f,-0.20219999f,-0.53939999f,0.90560000f,0.35500004f,-0.56119997f,-0.60439995f,-0.95470000f,-1.16220007f,0.05260000f,0.75800002f,-0.03060000f,-0.68369996f,-0.43959998f,-0.75959999f,-0.14819998f,-0.74150002f,-0.18709999f,0.22740000f,-0.68399997f,-1.08270000f,-0.16769999f,-0.46310000f,-0.51969997f,-0.72629998f,-0.26070000f,0.01200000f,0.22700003f,-0.18740000f,-0.40730003f,0.25199999f,0.97720003f,0.47160001f,-0.93930001f,-0.32240001f,-0.34120000f,-0.39080000f,0.10410000f,0.11360000f,0.29150001f,-0.19260000f,-1.06869999f,-0.04659998f,0.86310000f,0.04660000f,-0.15920003f,-0.01920002f,-0.18319999f,0.05540000f,-0.38880000f,-0.22819999f,0.50670000f,0.35020002f,1.17530004f,-1.50090002f,-0.38450000f,-0.00820005f,-0.59659999f,-1.42400002f,-0.35810000f,-0.67530002f,0.82070001f,0.62310004f,-0.55020000f,-0.06040004f,0.34140000f,0.67100004f,-0.61179999f,-0.31270006f,0.17989999f,-0.36159999f,-0.09290000f,0.46079998f,-0.12560000f,-0.27280002f,-0.50780000f,-0.90490002f,0.34219998f,0.49330000f,-0.08540000f,-0.15570000f,0.76249997f,1.37689998f,0.62030000f,0.57060001f,-0.90830002f,-0.59100001f,-0.18010000f,-0.42420002f,-1.26139998f,-0.63199998f,1.58979998f,0.38459999f,-1.06179998f,-0.42959998f,0.49819999f,-0.00840002f,-0.13849999f,-0.16980001f,-0.70789998f,0.23320004f,0.00160000f,-0.43599999f,0.34559997f,-0.33960004f,-0.07419999f,0.45140001f,0.35280001f,-0.03120001f,-1.26789998f,-0.35779998f,1.29450000f,-0.77889998f,0.10880000f,-0.08990002f,-0.78340000f,-0.03570004f,-0.79250001f,-0.77250005f,-0.65439998f,0.25229997f,0.77500000f,0.77900001f,0.69999997f,1.82600000f,-0.10189999f,0.17520000f,0.06080000f,-0.77479999f,0.10010000f,0.55889997f,-0.26779999f,0.88779999f,-0.79190001f,-1.58080003f,0.67209998f,0.96889999f,-0.15620000f,-0.56430001f,0.29739998f,1.29869999f,0.46140000f,-0.39140002f,-0.26390000f,-0.20960001f,-0.71040001f,-0.34740000f,0.17690000f,0.03640002f,0.61730000f,-0.14260003f,-0.29170000f,0.29920000f,-0.92140005f,-0.15560001f,0.96340005f,-0.08540001f,0.07400000f,0.23439999f,-0.24630000f,-0.23900004f,-0.05799999f,0.51260001f,-0.75310003f,-0.21740000f,-0.05190001f,-0.03360001f,0.19260000f,-0.09320000f,0.18470002f,0.54869998f,-0.03970000f,0.51669999f,-0.01040000f,0.16910000f,-0.60759997f,-0.51420000f,0.78519999f,1.86810002f,-0.72030001f,-1.53450005f,0.40489999f,-0.30249996f,-0.84780001f,-0.23030002f,-0.65629999f,-1.12010004f,-0.71429997f,-0.84400003f,-0.65110000f,-1.49700004f,0.14850000f,-0.41380003f,0.48919997f,0.80800002f,-0.45219999f,-0.34660001f,0.13229999f,0.70620001f,0.38040001f,-0.12239999f,-0.18409999f,-0.09519999f,-0.25240001f,-0.09999999f,0.50940000f,0.18820001f,-0.05180000f,0.00440001f,0.82929999f,0.08559999f,0.74239999f,0.69779999f,-1.32549999f,-0.47540000f,0.80980001f,0.28200000f,-0.85679998f,-0.06099997f,0.72099998f,0.03439999f,0.00369998f,0.32880000f,-0.37970000f,-0.49560001f,-0.06440000f,0.11320001f,-0.77870000f,-0.20310003f,0.35030000f,0.62350001f,0.21440000f,0.30420002f,0.72289996f,1.05180002f,-0.35060001f,-0.83540002f,0.03490000f,0.56309998f,0.13530000f,-0.34800000f,0.68369999f,0.17060002f,0.05649999f,0.63390001f,0.01660000f,-0.94409998f,-0.85589998f,-0.79010003f,-0.81029998f,-1.81530000f,-0.48570001f,-0.45010006f,-0.38769999f,-0.39790000f,-0.16239999f,-0.01360002f,-0.86789999f,-0.47279999f,-0.28370003f,-0.62420001f,-0.43389999f,-0.68520001f,0.50219999f,0.14159999f,-1.25960000f,-0.46920000f,0.69930001f,0.14500001f,-0.39050000f,-0.39160000f,-0.54400004f,0.02620000f,0.61510001f,0.23900002f,0.47960001f,-0.10220002f,0.10560002f,0.20560000f,-1.16110005f,-0.25660000f,0.54300001f,-0.00880000f,-0.01930001f,-0.01979999f,-0.73109997f,-0.27120000f,-0.06930000f,1.04219999f,-0.89320001f,0.05719993f,-0.85769997f,-0.40830001f,0.07290000f,-0.24149999f,-0.24790000f,0.25980000f,-0.51419997f,-0.48200002f,-0.14840000f,-0.43789999f,0.24349999f,0.19360004f,-0.25490000f,-0.08840001f,-0.74259998f,-1.21040001f,-0.67689998f,-1.69580002f,-0.06930001f,0.42330004f,-0.51289999f,-0.76940002f,-0.04210000f,0.38339998f,0.69159998f,0.84580001f,-1.09499999f,-0.22400000f,1.58769999f,0.41879999f,-1.32770000f,-0.37659999f,1.75760000f,0.89880001f,-0.94550000f,-0.15699999f,0.57020001f,0.27560001f,-0.12130000f,-0.21280000f,-0.09220001f,0.04480000f,0.27120001f,-0.01080000f,-0.64680001f,-0.43420001f,0.15649999f,-0.17760002f,-0.65329996f,-0.31059998f,0.64499998f,0.24300000f,0.54139999f,-0.63250001f,0.81419998f,-0.19499994f,-0.88240001f,-0.48640007f,0.91329998f,0.55520001f,-0.08650000f,0.07350000f,0.76310001f,-0.17919995f,-0.06790000f,-0.02410000f,0.46700001f,0.68300003f,-0.18579999f,-0.25899999f,-0.08140000f,0.09060000f,0.26090000f,0.62500001f,-0.21660000f,0.49440001f,-0.80469998f,-0.91520001f,0.60740002f,1.25030004f,-0.00230000f,-0.59780000f,-1.71170003f,-0.46520000f,0.92480000f,0.16860000f,-0.34550001f,0.29040003f,0.44470001f,-0.18199998f,0.20860002f,-0.14719998f,-0.21440001f,-0.24160000f,-1.02790002f,-0.85620002f,1.93339999f,0.96740000f,-1.61360000f,-0.67080001f,-0.07600000f,0.10560002f,0.57999998f,-0.36820001f,-0.89859998f,-0.76920001f,-0.31020000f,0.11520004f,0.34239999f,-0.45640002f,-0.40090001f,-0.11779999f,-0.78990000f,-0.34980003f,0.19529999f,-0.74129998f,0.57949998f,1.14770000f,0.79759997f,1.74019998f,0.83109997f,1.55389998f,0.06400000f,0.86810002f,-0.77290000f,-0.45500002f,0.74709998f,0.07110002f,-0.89729997f,-1.09409995f,0.34299999f,1.41189998f,-0.27550001f,0.57609996f,-0.63369997f,-0.75330000f,0.31799998f,1.37119997f,0.01010000f,0.60480002f,0.79840002f,0.82860003f,-1.12160002f,-0.08139998f,0.53750002f,-0.23100000f,0.19289999f,-0.25760002f,-0.58019996f,-0.08319999f,0.70020000f,0.40700001f,-0.40359999f,-0.02079998f,0.80969999f,0.50860001f,0.16700001f,0.06059999f,0.90870001f,0.92220001f,0.23109999f,0.56739998f,0.32260000f,0.66720000f,0.55970001f,0.47860000f,-0.92669998f,-0.42839998f,1.34469997f,0.16850001f,0.74450001f,-0.53319996f,-0.28570000f,0.33920001f,-0.63219997f,-0.03600003f,-0.53250000f,-0.71630002f,0.81529999f,1.17160002f,0.73360001f,0.46140004f,0.79309999f,0.92700004f,0.75159997f,0.66530000f,-0.64529996f,-1.74459998f,0.59700002f,-0.68189994f,-0.01210000f,-1.35709998f,0.74649997f,0.12460002f,0.09400000f,-0.24840003f,0.49370000f,1.51520001f,-1.14160001f,-0.32500000f,1.19449998f,-0.03780002f,-0.00379998f,0.03079998f,-0.27219999f,0.04479998f,-0.92210004f,0.03520001f,0.04660001f,-0.21919999f,0.50830002f,-0.15960000f,0.62850002f,0.63180000f,-0.85800001f,-0.51100002f,-0.28569999f,-0.08799999f,-0.79420001f,-0.62920000f,0.99239998f,0.11719998f,-0.18269998f,0.09479999f,-0.19059998f,0.00160000f,-0.31440000f,-0.50699997f,-0.72700001f,0.25889992f,-0.04900000f,0.12900000f,0.24890001f,0.21030001f,-0.45970000f,-1.44670004f,0.60429998f,1.16290003f,0.22090000f,1.24810001f,0.58090000f,0.47800005f,0.24120000f,0.05609998f,-0.44519998f,-0.23539999f,0.21950001f,0.75090001f,-0.81999999f,0.01539996f,0.08080000f,-0.15419999f,-0.03380000f,-0.17980002f,-0.16699999f,-0.71510001f,0.11870001f,0.13760001f,0.06950002f,-0.13919999f,0.52979999f,0.61880001f,-0.70089998f,-0.53379999f,-0.21480001f,-0.41800000f,-0.27089998f,-0.27539998f,-0.07090003f,-0.00779999f,0.32530001f,-0.03539998f,0.99090000f,0.53100002f,0.56190000f,0.46719999f,-0.15530000f,0.27539999f,0.26000000f,0.14020000f,-1.06030004f,-0.31280001f,1.09250003f,0.06999998f,-1.13780000f,0.88260001f,0.58390000f,1.07290001f,0.70430001f,0.50810005f,0.73019997f,0.84389998f,0.34729998f,1.44429999f,-0.32059999f,0.09070000f,0.16989999f,0.23440000f,-0.74659998f,-0.89650002f,-0.03490000f,-0.18280002f,0.33990001f,-0.26449998f,0.60959998f,-0.14109996f,-0.42740000f,-0.86330003f,0.18460000f,-0.27059997f,-0.73260000f,-0.05180002f,-0.27149999f,-0.52920001f,-1.43049997f,-0.78239998f,-0.19200004f,-0.03780000f,0.00009999f,-0.02699999f,0.49320000f,-0.13039999f,1.24609998f,0.69899999f,-1.20759998f,-0.61219999f,0.33209998f,-0.36740004f,-0.64340001f,-0.01300000f,0.92670004f,0.05079999f,-0.60870001f,-0.03320001f,0.30450000f,0.50440002f,-0.58249998f,-0.01899996f,0.82459999f,0.21400002f,0.68330003f,-0.06380002f,-0.15360000f,0.69019999f,-0.40659999f,-0.14710001f,-0.68099999f,-1.10730000f,-0.02980000f,0.48180000f,0.26940000f,0.33370003f,0.92099999f,0.81690003f,-0.04700000f,1.38710000f,-0.74950001f,-1.17840004f,0.68259998f,1.71520002f,0.08440000f,-0.22780001f,-0.04120000f,-0.66799999f,-0.15669999f,-1.18080001f,0.61030001f,1.07610003f,0.52460000f,1.28890001f,-0.45209999f,-0.89110006f,-1.02220000f,-0.51560000f,0.37040000f,0.02500000f,-1.08620001f,-0.83040002f,0.82500000f,0.66400002f,1.05680001f,0.72080001f,-1.15640005f,-0.17160002f,0.77260001f,-0.06560001f,0.32690000f,0.49160000f,0.64010004f,0.16419999f,-0.40930001f,0.00460001f,-0.86100000f,-0.25580000f,0.19549999f,-0.03520000f,0.80300001f,0.12719998f,-0.45530000f,0.38159999f,1.23110002f,1.04409999f,0.04560000f,0.70710002f,-0.72029997f,-0.51610002f,-0.83330001f,-0.97570003f,0.73980001f,0.10420005f,0.87959998f,-0.14179995f,-0.91140000f,-0.53920001f,-0.54369998f,-1.32349998f,-0.35880000f,-0.54770004f,0.92869998f,1.05179997f,0.42600000f,0.38210001f,-0.07480000f,0.29460000f,0.33929999f,1.01230000f,-0.04210000f,-1.17169996f,-0.37059999f,-1.29520002f,-0.11470001f,0.07519999f,1.03259997f,0.63719998f,-0.75799999f,-0.26820001f,0.48050001f,-0.09200002f,0.08240002f,0.41580000f,0.57549997f,0.58519998f,-0.12300000f,0.33979998f,-0.96629998f,-0.35479999f,0.85060001f,0.14300000f,-0.53430002f,-0.23540001f,-0.78369999f,-0.41739999f,0.79409998f,0.35179999f,0.73400003f,0.35820000f,-1.66860003f,-0.31220000f,1.19060001f,0.11890002f,-0.96799997f,-0.55110003f,0.16400004f,-0.76189998f,-0.21610001f,-0.37730000f,1.18620002f,-0.06679997f,0.36639999f,-0.00160001f,-0.55579997f,0.41359999f,-0.74759998f,0.55269999f,-1.31649995f,-0.39750000f,0.09250001f,1.07240000f,0.08479994f,1.50449998f,0.10919996f,-0.97220002f,0.39970004f,-0.28309995f,0.19069998f,0.95710000f,0.15639997f,0.10950002f,0.98669998f,0.32560001f,0.15509999f,-0.28120000f,0.43179995f,-0.07540001f,0.15650001f,-0.51219998f,-0.47069998f,0.04380002f,0.07980003f,0.08220001f,-0.49540002f,-0.71020001f,0.11019995f,0.79180001f,1.23770005f,-0.06080001f,-0.61690002f,-0.19380001f,-0.72810001f,0.24260000f,0.28720006f,-0.78599999f,0.00879997f,-0.24479999f,-1.07560000f,-0.54040002f,-0.28370002f,0.20409998f,0.45199998f,0.64819997f,-0.78149998f,-1.10919999f,-0.17690001f,-1.00359997f,0.56010001f,-0.55509998f,0.83959998f,0.52020000f,1.08909996f,0.61119996f,-1.10779997f,-0.08480000f,0.27209998f,-0.06580001f,0.86010001f,-0.28010000f,-0.22910000f,-0.17029999f,-0.31660002f,-0.40549999f,-0.29879994f,-1.14579997f,0.49680000f,0.02839999f,-0.85120000f,0.22029998f,-0.32899998f,-0.24540001f,0.21339998f,-0.37940000f,-0.10060000f,-0.27240000f,-0.29910001f,0.74959999f,0.55540003f,-0.54080000f,0.38079995f,0.22540002f,1.02000005f,0.05400001f,-1.04550001f,0.05879999f,0.26299999f,0.43999998f,0.05769995f,0.29960000f,0.93100001f,-0.22899999f,-0.57010001f,-0.01520001f,0.56829997f,0.16019999f,0.91689998f,-0.43739998f,0.52459999f,-0.15210000f,-0.53749999f,0.14030003f,0.04249999f,-0.05600002f,-0.59439998f,-0.16240003f,-0.17410001f,0.24599998f,-0.09689997f,0.37890004f,1.00579997f,-0.23780002f,1.00430002f,0.70929999f,-0.54030000f,0.74699997f,0.11809997f,1.03779999f,-0.76140002f,-0.13270000f,-0.21089998f,0.86499998f,-0.76189999f,0.26559999f,-0.43740000f,-0.19990000f,0.13290001f,-0.46779998f,1.08319998f,0.13860001f,-0.29280002f,-0.21079998f,0.86750001f,0.46260000f,0.18959999f,0.27540000f,-0.11439999f,-0.27880000f,0.44599999f,-0.61720001f,-0.92660001f,0.34120001f,0.23919999f,-0.44460000f,0.65710000f,0.10820002f,-0.73129999f,0.03680000f,0.01990002f,0.06279999f,0.82959998f,-0.01960000f,-0.08449998f,-0.22760000f,0.04630000f,0.30540001f,-1.34929999f,0.40070000f,0.07350000f,0.90830002f,-1.09669998f,0.25120001f,0.34199998f,-0.01580003f,-0.40770001f,0.42800002f,-0.32819999f,-1.19600001f,-0.27239998f,0.66250000f,0.15329998f,-0.05519999f,-1.08629996f,-0.73829997f,0.95719998f,0.68640001f,-0.39720001f,0.66860000f,-0.44110000f,-0.57139999f,0.09470000f,-0.22619999f,0.18040000f,-0.76239998f,0.71209999f,0.09680003f,0.20330001f,0.71680001f,0.57090003f,-0.54040000f,-0.12750003f,-0.37500000f,1.14629999f,-0.50879999f,-0.85580001f,0.17159998f,0.36809999f,-0.73519999f,-1.74419997f,-0.05780002f,-0.08280003f,-0.35280001f,0.78629999f,0.44060004f,-0.11779996f,-0.45000000f,-1.09440002f,-0.36180002f,1.10819998f,0.42460000f,-0.89289997f,-0.12200000f,1.23559998f,-0.43959999f,-1.80889999f,0.98729999f,0.36079997f,0.64230001f,-0.34399997f,0.24300003f,-0.62909999f,-0.66109999f,0.48800000f,-0.38840003f,-0.48419999f,-1.54119996f,-0.02829996f,0.12549999f,-0.53919999f,-0.22140001f,-0.88589998f,-0.61219997f,1.28759998f,0.25010002f,0.02500001f,0.78730001f,-1.25429998f,-0.98260000f,0.49619998f,0.84770000f,-0.90309998f,-1.45889996f,0.59159999f,0.94899999f,-0.48110003f,-0.57180002f,-0.33210002f,-0.31760000f,0.06320001f,-0.23680000f,0.60389997f,-0.11040000f,-1.92940000f,-0.14660000f,1.14070000f,0.26300000f,0.51280004f,0.20439999f,-0.42560006f,-0.03939999f,0.25449999f,0.39500001f,0.46239996f,-0.33140002f,0.72749998f,0.56540001f,1.01930004f,-0.38240001f,-0.72469997f,0.15799999f,0.33179998f,-0.15020000f,-0.58760002f,-0.32330001f,-0.73269999f,-0.56760001f,-0.44929999f,0.01499998f,0.05830002f,-1.29810001f,0.53270002f,1.39260003f,-1.28429998f,-0.65250000f,0.11759999f,0.71190000f,1.00420000f,1.31670001f,-0.89370001f,1.16879999f,-0.70830002f,0.89410002f,-1.60850002f,-0.07200000f,-0.11770004f,-0.85139998f,0.19030002f,0.36889999f,0.45669999f,-0.17930001f,0.01840001f,-0.06350000f,0.25889999f,-0.26619999f,-0.27000000f,-0.14800000f,0.28980000f,-0.21140000f,-1.13499997f,0.42600002f,0.82070002f,0.09900001f,-0.74459998f,-0.01220000f,-0.24019999f,0.61980000f,0.80390002f,-0.57780001f,-1.03230001f,0.33560001f,0.89980000f,0.31900003f,0.03970001f,0.24700000f,1.02919998f,0.61380001f,0.68400002f,-0.57260000f,0.11179998f,0.24480001f,0.58460001f,-0.38940001f,-0.09319997f,-0.57760000f,0.21890001f,-1.35469998f,0.86100001f,0.78950002f,0.64459999f,0.01310001f,0.72219998f,0.38989999f,-0.53419998f,0.06219998f,-0.21509999f,-0.59389999f,0.13580003f,0.25230000f,-0.02750000f,0.80630004f,0.98099997f,1.50200000f,-0.23580002f,0.87930002f,0.47939997f,0.27010000f,-0.56679998f,-0.17590000f,0.40759999f,-0.19480000f,0.82579998f,-0.49900000f,-0.70660000f,-0.52960000f,0.04029999f,-0.67580000f,-0.14700004f,0.08459999f,0.89300000f,-0.43780000f,-0.78880001f,0.33800001f,0.68769998f,-0.50079999f,0.64540002f,0.14259999f,-0.43170000f,0.50500002f,-0.28069999f,0.01000000f,0.39429996f,0.39140001f,1.96100003f,-0.16620001f,-0.67170002f,0.17380000f,0.63820000f,0.03220001f,0.44689999f,-0.82799998f,0.40359999f,0.25960003f,-0.21209999f,-0.02520002f,-0.63759997f,-0.25540001f,-0.46470000f,-0.62159999f,0.43240001f,0.81659998f,0.06449999f,-0.15129998f,-0.46029997f,-1.04890001f,1.26760000f,0.82010000f,0.95849999f,1.46010000f,-0.58460000f,1.07510000f,-0.41220002f,-0.66170002f,0.88120001f,0.78040000f,0.23159999f,-0.00990000f,0.30560001f,-1.00489996f,-0.05719998f,0.85800001f,0.62070001f,0.10160000f,-0.17260000f,0.16699999f,0.35020003f,-0.37899999f,-1.01429999f,0.89140000f,0.76340001f,-0.11700000f,-0.14450000f,0.26280000f,-0.35780000f,-0.23880000f,0.15219999f,0.12360000f,-0.05380001f,-0.11780001f,-0.07760000f,-0.49320001f,-0.78530002f,-0.07540001f,1.29839994f,-0.55240000f,-1.41810000f,0.27260000f,-0.05449999f,-0.36960001f,0.45140000f,1.08320005f,0.79949995f,-0.22620002f,-0.52310002f,-0.56909999f,0.38570001f,0.26079996f,0.12889998f,0.16550001f,0.38050000f,-0.29150002f,0.44379999f,0.28990000f,-0.23389999f,-0.11000000f,0.31190000f,-0.16490001f,-0.19240000f,-0.36390001f,-0.18559999f,0.76899997f,-0.66529999f,-1.59580001f,0.04220000f,0.31550000f,-0.17300000f,0.84129998f,0.71740003f,-0.24980000f,-0.14000001f,0.15660000f,0.92510003f,0.40820001f,-0.42399997f,-0.40560000f,-0.99399998f,-0.41499998f,-0.94279995f,-0.30560000f,-0.07380001f,-0.82780002f,-0.84610003f,0.97060000f,0.78990004f,-0.56780001f,0.95739994f,0.23560000f,-1.10859998f,-0.45860000f,-0.04450001f,-0.86380001f,0.67759996f,0.21920003f,-0.84179996f,-0.65300003f,-0.09960003f,-0.20039998f,0.59440000f,-0.02780001f,0.05729999f,-0.77249999f,1.55919999f,-0.76039998f,0.36050001f,-1.27149996f,0.06840003f,-0.48789999f,0.05820001f,-0.31299999f,-0.06859999f,0.03079997f,0.06419998f,0.66099998f,-0.09039998f,-1.12330000f,1.44379995f,0.58970000f,-0.62609997f,-0.42440001f,-0.77209998f,-1.26869996f,1.19709999f,0.00650000f,-0.64319999f,-1.39090000f,-0.56859996f,0.83580003f,1.05890006f,0.16500001f,-0.49730001f,-0.12360000f,-0.26110002f,-0.33100000f,0.99679996f,-0.34260001f,-1.15159998f,0.27760000f,0.21830000f,-0.20700000f,-0.97839999f,0.46320000f,-0.79169995f,0.18900000f,0.62109997f,0.96920001f,0.23030001f,0.69139999f,0.92850000f,0.67660000f,-0.42079997f,0.55440001f,1.08910001f,-0.64979999f,-1.81059999f,0.34029999f,0.30030000f,0.29340002f,1.25230001f,0.95559999f,-0.19349999f,0.55580000f,-1.20479995f,-1.73499999f,-0.00410000f,-0.37570003f,-0.02249999f,-1.02049999f,0.36310001f,-0.25319997f,0.44179998f,1.50189997f,-0.52320000f,0.37059997f,0.13059998f,1.31859999f,-0.03630003f,0.04240000f,0.56809998f,1.08860000f,-0.01720001f,-1.13039999f,0.13230002f,-0.13050000f,0.70259996f,-0.05960001f,-0.73889998f,-0.18200001f,-0.22430003f,-0.20420002f,-0.44700003f,0.04420000f,1.67660004f,-0.01660001f,-0.58059999f,-0.28260000f,-0.89560002f,-0.45540001f,-0.98520002f,0.69440000f,0.45690003f,-0.60240002f,0.30149995f,-0.14939999f,-0.19500000f,-0.52880000f,-0.61880001f,-0.00080002f,0.00759997f,0.03560000f,0.05219999f,-0.03559999f,0.24660001f,-0.28649997f,0.85499994f,0.51889996f,-1.04439998f,-0.26210002f,-1.17060000f,0.62540001f,-1.01510001f,-1.37090002f,0.82410002f,-0.42120001f,0.34940002f,-0.75310001f,-0.61979998f,0.35880001f,-0.04310004f,0.34659997f,-0.76099999f,-0.96600000f,0.15850001f,0.17010002f,-0.01409999f,0.06939997f,-0.83489998f,0.15850000f,-0.62660000f,0.24900001f,-0.60319999f,0.98350000f,-0.52059997f,0.03380000f,-0.47060000f,-0.41180000f,-0.66540000f,0.64600001f,0.25420004f,-0.74259999f,-0.95929997f,-0.41000000f,0.25559996f,-0.31499999f,-0.34009996f,0.35400002f,0.69969999f,0.04580002f,-0.37349997f,0.59140002f,0.03170001f,0.38079999f,-0.07499998f,0.49560000f,0.58750001f,0.09000000f,0.60470002f,-0.06440000f,-0.59880004f,0.05259999f,0.92839998f,-0.52620002f,0.26330001f,-0.88930001f,-0.23709997f,-0.42489998f,0.73289998f,-0.74339997f,0.08210003f,-0.40650000f,0.04200002f,-0.97139997f,0.49679999f,0.68580000f,0.99659999f,0.14000002f,0.54729999f,0.41529999f,0.29900001f,0.25360001f,-0.07040001f,1.07450000f,0.23069997f,0.22139998f,-0.18639999f,0.25170000f,0.70660002f,0.83459999f,-0.78500000f,-0.42829998f,0.38300000f,-0.87559998f,-0.10919998f,0.28600001f,1.03490000f,0.14840001f,-0.25629999f,-0.19960000f,-0.79859999f,0.60519998f,0.32170001f,-0.74119999f,-1.46050001f,-0.39220002f,1.32129999f,-0.13800001f,-1.72950002f,-0.11760001f,0.30500000f,-0.07360001f,0.03040000f,0.72140002f,1.59820002f,-0.03659999f,-0.92829998f,0.18600001f,-1.43560002f,-0.13980000f,0.64629999f,-0.39609996f,-0.27669997f,0.08660001f,0.91309999f,-0.12010000f,1.19949999f,-0.23100001f,0.27180001f,-0.18310004f,0.15950000f,-0.46059999f,-0.05059995f,0.55380001f,-1.14269998f,-1.67590002f,0.55000002f,0.53410000f,-1.07560000f,-0.24230001f,-0.31410000f,0.68740001f,0.41069999f,-0.87189999f,1.15749998f,-0.15250000f,0.55099999f,1.26000002f,-1.35640002f,-0.73499998f,-0.06009997f,-0.64320001f,-1.07120001f,0.22140001f,0.94769997f,-0.84540001f,0.21139999f,0.72120001f,-0.39299999f,0.65920000f,0.54580007f,0.20439998f,-0.03600003f,0.02740000f,0.42919997f,0.74400001f,0.42659997f,-0.21900001f,-0.59969996f,-0.20799999f,0.14530001f,-0.25520000f,-0.14370000f,-0.10420000f,-1.25460000f,0.03060000f,0.68879998f,0.65239999f,0.38860000f,-0.83510000f,0.00020002f,0.81589999f,-0.14950001f,-0.00719997f,-0.53369998f,-0.84850004f,0.89149998f,0.43120001f,0.26489997f,1.00879999f,1.00969997f,1.01069996f,-0.36679999f,0.94460001f,0.26229998f,-0.33119998f,-1.01290002f,-0.61340001f,-0.61169996f,-0.57199998f,0.24460001f,-0.61500000f,0.26990001f,0.65799999f,-0.95339997f,0.58660000f,0.53529995f,0.59829999f,-0.30239997f,0.33939999f,0.45399998f,0.64139998f,0.56100002f,-0.34680001f,-1.19090002f,-0.09280000f,0.41439996f,0.59360000f,0.64190001f,0.54679998f,0.04460001f,0.58799999f,1.69069995f,-0.34219999f,-1.00600001f,0.18060001f,0.96450000f,-0.58980002f,-0.72089999f,-0.40679999f,-0.58150001f,0.48439998f,-0.07850003f,0.22000000f,1.08170003f,-0.00460000f,-0.35850005f,-1.04489997f,-0.06819999f,-0.60579997f,0.56799997f,-0.49000004f,-0.29539998f,0.03640005f,-0.45840000f,0.75010004f,0.30440000f,0.15640000f,0.66199997f,0.12630000f,0.49079999f,0.06840003f,0.93519997f,0.10390001f,-0.18160000f,0.58899999f,-0.22339998f,1.59069999f,0.28980000f,0.77550000f,-0.06160001f,0.00590001f,0.41740000f,0.91350000f,-0.20980001f,-0.44539998f,-1.04920001f,-0.31889999f,-0.54219998f,-0.54779997f,-0.08009998f,0.32989999f,1.03639998f,1.04769996f,0.60599996f,0.71959997f,0.18129999f,0.40819999f,-0.13499998f,-0.46939997f,-0.89269999f,-0.49250000f,0.05920001f,0.71710001f,0.44610000f,0.23549999f,0.27359999f,-0.21900002f,0.63929999f,0.41520001f,0.36139998f,0.75739998f,0.58520001f,-0.18970000f,-0.22259999f,1.10760000f,0.10659999f,0.79489999f,0.54539997f,-0.88250004f,-0.31899998f,-0.84759999f,-0.08940000f,0.00690001f,-0.36979999f,1.40020000f,0.01640000f,0.73699997f,0.88339996f,0.09989995f,-0.43619999f,0.81960003f,-0.21599999f,-0.34460000f,-0.08979999f,-1.14310001f,-0.26299998f,-0.63779994f,0.49319998f,-0.32859999f,-0.18840000f,-0.72330002f,0.49899999f,-0.14850002f,0.51480000f,-0.13980000f,-0.00080000f,-0.02880002f,-0.40940002f,-0.28989999f,-0.45839999f,-0.46999998f,0.46010004f,0.20860002f,-0.51310001f,0.07239997f,-0.37310003f,0.77310001f,0.11990001f,-0.51059999f,-0.65069998f,-0.60049998f,-0.87509999f,-1.00440000f,-0.34919999f,-0.02150000f,-0.42939998f,-0.94609997f,-0.91089998f,-0.60689998f,-0.11949999f,0.30380000f,-0.18400001f,-1.37359999f,0.20600000f,0.35380002f,0.56200000f,0.33710001f,0.36579998f,-0.75670005f,-0.62299998f,-0.15120000f,0.47099997f,1.67400001f,0.12100001f,1.75630004f,-0.35600000f,0.06090001f,0.16860000f,0.61649998f,0.07120000f,0.61289997f,0.23279999f,0.06630000f,0.22619999f,0.23579999f,0.59839997f,0.40359998f,0.17999999f,0.47989999f,0.34919997f,1.02519998f,-1.00400001f,-0.28700000f,-0.53320001f,-0.96070000f,-1.01710001f,-0.40339999f,-0.36290000f,-0.19599999f,0.31820002f,-0.24960000f,0.20360000f,0.61500000f,-0.00400000f,-0.55600000f,-0.31330000f,-0.30310000f,0.09179998f,0.60269997f,-0.00970001f,-0.42170001f,-0.49740000f,-0.68159998f,-0.34310001f,0.27309999f,0.44449999f,0.34249999f,0.23099998f,0.63789998f,0.73079998f,1.31700002f,0.13920000f,0.37390004f,0.71119997f,0.83430001f,-0.04739999f,-0.15780003f,-0.37560000f,-0.43880000f,0.46559999f,-0.55780001f,0.07680000f,0.07079999f,0.17699999f,-0.13969998f,0.36779998f,-0.12499999f,-0.28039999f,0.36420001f,0.17940000f,0.32510002f,0.38500000f,0.06990001f,-0.20239999f,-0.22879999f,0.05060000f,-0.24840000f,-0.70339997f,-1.65249999f,-0.51700000f,-0.41810000f,-0.06359999f,-0.10409999f,-0.48060002f,-0.51290001f,-0.29960003f,0.59439998f,-0.05200000f,-0.17029998f,1.14140000f,1.12079997f,0.72670000f,-0.42239998f,-0.03329998f,-0.30189999f,-0.11570003f,0.61279997f,0.45209999f,0.36079999f,-0.18119999f,-1.02679998f,-0.71680002f,0.29169999f,0.29650000f,-0.67319999f,0.25469999f,1.09449996f,0.15259998f,0.89140000f,-0.36619999f,0.77940005f,0.66379998f,0.52300005f,0.71219999f,0.91490002f,0.32799998f,-0.51370004f,-0.29939999f,-1.77789999f,-0.15380000f,-1.29499999f,0.23739999f,-0.77950002f,0.34199999f,0.23970000f,-0.57539999f,0.60520003f,0.25519999f,-0.08039998f,0.90359999f,-0.07590001f,-0.62159998f,-0.54909998f,0.39699998f,-0.40650000f,-0.21899998f,-0.41160001f,0.14030001f,0.00190000f,0.20860000f,-0.02680000f,0.00250001f,-0.01469997f,0.13770001f,0.94860000f,0.38350001f,-1.24289999f,-0.79960002f,0.02300000f,-0.08989999f,0.14860002f,-0.77120001f,-1.01150001f,-1.32560000f,-1.35539999f,-1.08099998f,-1.26990001f,-1.10840003f,-0.61930002f,0.31579999f,0.81149998f,0.35489999f,-0.03599999f,-0.10730000f,0.24280000f,0.27650001f,-0.13000001f,0.40659999f,-0.90890002f,0.23299999f,0.18249999f,0.36319997f,-0.14490003f,-0.54499999f,-0.63289996f,0.81659998f,-0.02269999f,-0.31979999f,1.27120004f,0.07160001f,1.33690003f,0.63179998f,0.83849999f,0.48479998f,0.34209999f,0.93259999f,-0.01160003f,-0.19579999f,-0.37799998f,-0.20919998f,0.12590002f,0.04940000f,0.43700000f,-0.03340000f,-0.68510002f,0.04690000f,0.38940000f,0.56090001f,0.44320000f,0.81989999f,1.28659997f,0.46989997f,-0.11850001f,-0.21780002f,0.49039999f,0.12970000f,-0.34459998f,-0.30729999f,-0.47909997f,0.63160002f,0.75270001f,0.07329999f,-0.37059999f,-0.52270002f,0.00389998f,-0.99830001f,-0.86939999f,-1.29070001f,-0.52020001f,-0.27770001f,-0.04400000f,-0.33490001f,-0.01820000f,0.20460000f,0.24530000f,-0.08020001f,-0.67800001f,-0.13940000f,-0.59720000f,-0.58739997f,0.34670005f,-0.13580000f,1.14230003f,-0.27099999f,-0.16879999f,0.09979999f,-0.74390000f,-0.45899999f,-0.55019997f,0.08680000f,-0.23990000f,-0.09220000f,1.67370004f,0.05159999f,2.03290003f,0.42779999f,1.82700002f,-0.06539999f,0.76280004f,0.53619998f,0.30499999f,-0.11000000f,0.63640002f,0.20760000f,0.81819998f,0.33609998f,-0.06670001f,-0.32270002f,-0.23319999f,-0.57249999f,-0.42419998f,0.21720001f,0.68399999f,-0.29610001f,-0.57329998f,-0.23429999f,0.08820000f,0.18430000f,0.98790001f,0.10469999f,0.09790000f,-0.52000000f,-0.86129998f,-1.26660000f,-1.09540000f,-0.50049999f,0.84610001f,-0.02670000f,-0.26420000f,-0.36550001f,0.18850000f,0.67149998f,0.22019999f,0.04700000f,0.35870003f,0.67679999f,0.57410002f,0.83139996f,-0.11020003f,0.08400000f,0.09680000f,0.11420000f,0.76669999f,0.15479998f,0.35210001f,0.35859998f,0.15490000f,-0.56199998f,1.21580003f,-0.30540000f,1.25180004f,0.56659998f,1.14489999f,0.37379999f,1.15830001f,-0.19359999f,0.90870001f,0.14700000f,0.84150001f,-0.08240000f,-0.20619998f,-0.34780001f,-0.13209999f,0.04860000f,0.07639997f,-0.35810003f,-0.12520001f,0.75419999f,0.66729998f,-0.19440001f,-0.45199998f,0.29720003f,0.39389999f,0.13140000f,0.31620000f,0.40020002f,-0.02879999f,-0.15390000f,0.07600000f,0.11510001f,0.10600000f,0.45810001f,0.26470000f,-0.30659998f,-0.86699997f,-0.05439999f,0.93489998f,0.44020001f,-0.42969999f,-0.63709999f,-0.61130000f,-0.80059998f,1.25910006f,0.18180002f,0.00719999f,-0.35799998f,-0.76450000f,0.02860000f,-0.28650004f,-0.68239999f,0.12250000f,-0.05140000f,-0.00570003f,-0.45400000f,-0.17760001f,0.23539999f,0.24459999f,-0.08900000f,-0.16980001f,-0.04340000f,-0.48910001f,0.30619999f,0.23789999f,0.64759998f,-0.36750006f,-0.17780000f,-0.82540004f,-0.01960000f,0.26000001f,0.09079999f,0.33399999f,-0.33430002f,-0.02010000f,0.22199998f,1.11179998f,1.25529998f,1.13139997f,1.43909996f,0.92499996f,1.04429998f,0.40480000f,0.55000001f,0.42750000f,-0.66370002f,-0.59629999f,0.21750003f,0.06920003f,-0.22330000f,1.08119997f,0.64879999f,-0.15490000f,0.17160000f,-0.02519999f,-0.11520003f,0.88839996f,0.82130000f,0.18560000f,0.63190000f,0.19440003f,0.29420000f,0.62890001f,-0.16259999f,0.36530002f,-0.90099997f,-0.60859997f,-0.41659998f,-1.84219998f,-0.34019999f,-1.16579997f,0.03240000f,0.07110001f,0.65120000f,-0.06820003f,-0.67559998f,0.51370003f,0.65139997f,0.92039994f,-0.69439997f,-0.01949998f,0.46499999f,-0.42590000f,0.80839997f,0.19739998f,-0.59979999f,-0.46099998f,0.37500000f,-1.24790004f,0.16179999f,-0.26530000f,0.20280001f,0.67890001f,-0.11399999f,-0.34929998f,-0.55989998f,-0.88619997f,0.01710000f,0.78179998f,0.75460001f,0.06490001f,0.87270002f,0.91979999f,0.71059999f,0.24809998f,-0.02319999f,-0.95249996f,-1.17769998f,-0.61909998f,-0.51919996f,-0.77109998f,-0.49120000f,0.11939999f,-0.03220001f,-0.55530000f,0.50440000f,1.05199998f,0.60480000f,-0.76390001f,-0.71100000f,0.94280004f,-0.28780000f,1.17020002f,0.42359998f,0.17530001f,0.74459997f,-1.04520002f,-0.32919999f,-1.52770005f,-0.45120000f,-1.17350002f,-0.46959999f,-1.00950000f,-0.65659997f,0.21060002f,0.44759997f,0.51119995f,-0.61780000f,0.45859999f,-0.17219999f,0.33450000f,-0.75199997f,0.10350002f,-0.19580000f,-0.47470000f,-0.12000001f,-1.66890001f,-0.23170002f,0.37249996f,-0.31400002f,-0.66709998f,-0.16279998f,-0.59079999f,-0.38569999f,-1.09620001f,-0.23800001f,0.98860001f,0.98260001f,0.69420001f,0.81330001f,0.28840000f,-0.00390000f,-0.64910001f,0.03370002f,-0.19729998f,-0.01779999f,0.39899999f,0.37820000f,0.12859999f,-0.44790000f,-0.62539997f,-0.29249999f,-0.55660000f,-0.32400000f,-0.53080000f,-0.81100000f,0.79769999f,0.12780003f,0.28300001f,0.40179999f,-1.30070004f,0.29220000f,-0.72420002f,0.54439999f,-0.03479999f,-0.56759998f,-0.49220000f,-0.14660000f,-1.37840003f,0.01620000f,-0.89030004f,-0.30279998f,-0.03640001f,0.63499998f,-0.41090005f,-0.12280000f,0.28260002f,0.57659999f,-0.10940001f,0.21899999f,-0.57400001f,0.20359999f,-0.28420000f,0.28519999f,0.92470002f,0.81750000f,0.47580000f,0.97600002f,0.61180000f,0.48980000f,0.27539998f,1.10629998f,1.03509997f,0.80059999f,0.30460001f,0.34879999f,0.82029996f,0.01589998f,0.03550001f,-0.38560001f,0.37109998f,-0.19460002f,-0.21489999f,-0.04309999f,-0.14720000f,-0.25020000f,-0.56330000f,-0.49470000f,-0.14969999f,-0.04579999f,0.25600002f,-0.56660000f,-0.82399998f,-0.18610000f,-1.09540001f,-0.39560000f,-1.43080003f,-0.17960001f,-0.97300002f,-0.78659997f,-0.69689995f,-0.00260000f,-0.62609999f,0.26639999f,-0.03550000f,-0.15719999f,1.19420003f,-0.01980001f,1.50180002f,-0.16540000f,0.33000001f,-0.43280001f,-0.28069999f,-0.39999998f,0.45830002f,0.01440001f,0.53020000f,-0.06260000f,0.87530004f,0.17839999f,0.70620001f,0.37219999f,0.08710001f,0.69700000f,0.50079997f,-0.26950002f,0.07490001f,-0.30130001f,0.78629999f,0.50250000f,0.56880000f,0.22380002f,-0.04149997f,0.95570002f,0.72410000f,0.13840001f,-0.88329998f,-0.20340001f,0.93890000f,0.61740001f,-0.69180000f,-0.16659999f,-0.19419999f,-0.61330001f,-0.52000000f,0.10079999f,1.27969997f,0.85780000f,0.51339999f,0.15100000f,-1.16950001f,-0.50510002f,-0.54479998f,0.53859997f,0.99130002f,-0.00920000f,1.75060002f,-0.39999999f,0.23690001f,-0.17040000f,-0.80190003f,-0.69559998f,-0.73779998f,0.24379998f,-0.48239997f,0.85499999f,-0.36440000f,-0.48939998f,-1.21750001f,0.32439999f,-0.60980002f,0.13980000f,0.61860001f,-0.24480000f,0.68230000f,-0.66939999f,-0.37590002f,-0.49639999f,-0.50250000f,0.69759999f,-0.90290001f,0.98660000f,0.70820000f,-0.12540000f,-0.72669998f,-0.36379999f,0.04299999f,-0.49120003f,0.32720001f,0.26030001f,-0.03600002f,0.08110001f,0.12020002f,-0.74069999f,-0.60299998f,-1.13190000f,-0.76699999f,-0.19090000f,-0.09830003f,0.69679999f,-0.04829999f,0.44510001f,0.42870000f,0.36220000f,0.50180000f,0.15660001f,-0.81699998f,-0.82009999f,-0.45720000f,-0.78050001f,-1.15609999f,0.15280000f,0.28809999f,0.36099998f,0.85770003f,0.83279999f,0.14039996f,-0.86179999f,-0.34020002f,-0.72179997f,1.20720003f,0.10300001f,1.58340000f,0.39019998f,1.24660001f,-0.09940000f,-0.65710001f,-0.10699998f,-2.07600001f,0.02639998f,-0.61519999f,0.03260000f,-0.27170000f,-0.23239999f,-0.71299999f,0.31139998f,0.73959999f,-0.15339999f,0.69339999f,-0.06599999f,-0.46859998f,-0.84929999f,-0.33680000f,0.40300000f,0.45410000f,-0.04829999f,-0.96559998f,-1.21010000f,-1.01630000f,-0.92209999f,-0.61819998f,-0.75149998f,-1.15029997f,-0.56649999f,0.43039996f,-0.30790002f,-0.91930001f,0.16200000f,0.69029997f,0.94369998f,0.37869998f,-0.40480000f,-0.54030000f,-0.50420000f,-0.76430002f,-0.28790000f,0.11670000f,-1.01400001f,-0.41030004f,-0.12679996f,0.03840007f,-0.21820007f,0.20319998f,-0.42599995f,1.16250003f,-0.80980001f,1.20130004f,-0.51599999f,-0.13259998f,0.44479998f,-1.23099997f,1.12579997f,-1.95579996f,1.34779997f,-0.82669999f,0.17839999f,-0.44050002f,0.79900001f,-0.70850000f,1.18719997f,0.53450003f,-1.11440001f,0.80760001f,-0.18359997f,-0.26870002f,1.03300001f,-1.05590005f,-0.17889999f,-0.00010000f,-0.92879999f,-0.03750000f,0.24309999f,-0.04950000f,1.21670000f,0.34450000f,1.55309999f,0.16629999f,0.74320000f,0.25680000f,-0.31109997f,0.08330000f,0.01040000f,-0.29090000f,-0.27770000f,0.22960001f,0.45790003f,0.00790000f,-0.00570002f,-0.20830001f,0.16760000f,0.28740001f,1.61800001f,0.21020000f,0.37940000f,0.04330000f,0.08480002f,-0.70089999f,0.64199997f,-0.85069997f,0.77779996f,-0.28810004f,-0.70839997f,1.06359998f,-1.13519996f,1.47969998f,-0.83539997f,1.32460002f,-0.07200002f,-0.58209997f,0.80859995f,-0.62080001f,0.38240001f,0.83300004f,-0.71020002f,0.53990000f,-0.44239998f,-0.21410005f,-0.04819996f,-0.10889998f,-0.25560001f,0.79660000f,-0.87759998f,-0.20500002f,0.27840000f,-1.07939999f,-0.25480002f,-0.02240000f,0.34710000f,0.22160000f,0.08630001f,-0.01010000f,-0.44840001f,-0.41130000f,-0.57949998f,0.24010000f,0.84230002f,0.18810000f,0.46060002f,0.20720001f,-0.26029997f,-0.14910000f,-0.73109999f,-0.13800000f,-1.61890002f,-0.29760001f,-0.65700004f,0.05950000f,-0.55630000f,-0.13360000f,-0.90530001f,-0.16140000f,-0.00380000f,0.24679999f,1.18170000f,-0.62110002f,0.11920000f,-0.27960000f,0.46920002f,-0.59430001f,0.39999999f,-0.57230003f,0.04580000f,-0.15829995f,0.05779995f,0.56300003f,0.38500002f,1.30380004f,-0.82780002f,-0.05029997f,0.54419999f,-0.65929999f,0.83299997f,-1.25880002f,1.11200000f,-0.74670001f,0.11399999f,-1.14539997f,1.31219996f,-1.22839999f,0.70979998f,-0.15139997f,-0.06160002f,1.32250001f,-0.85190001f,-0.02180000f,-1.07070004f,-0.13200001f,-0.47430005f,-0.10010000f,-0.97880002f,-0.25720001f,-0.43770001f,0.07320000f,0.68620000f,0.18360000f,0.45800003f,-0.07810000f,-0.90690003f,-0.07090000f,0.95289997f,0.18080000f,-0.28280002f,-0.10130001f,-0.74800001f,-0.10210000f,-0.13950001f,0.01200000f,0.47870001f,0.14430000f,0.81519999f,-0.00690000f,-0.53870005f,-0.63399999f,0.48280000f,-1.37280000f,1.28620000f,-0.75980000f,0.58899999f,-0.34720003f,-0.19480000f,-0.53089999f,0.52639999f,0.00819999f,-0.79960000f,-0.12169998f,0.87059999f,-1.00070001f,0.23000001f,0.50169999f,-0.58099998f,-0.00710002f,0.49800002f,-0.97910000f,0.95219999f,-0.15630002f,-0.44859998f,0.44340000f,-0.31280000f,1.03749997f,-1.03199996f,-0.27600007f,-1.14820002f,-0.23010000f,-0.83260001f,0.19450000f,0.13040000f,0.05770000f,0.84329999f,0.36720000f,0.38700001f,-0.22790000f,0.74620000f,0.27170000f,0.81130002f,-0.09490000f,-0.39439999f,-0.05740000f,0.82569998f,0.10429999f,0.16059998f,0.21360000f,-0.25639999f,-0.09320000f,0.11569998f,-0.10340000f,-0.90480001f,-0.14890000f,0.86449997f,0.31030000f,-0.02800001f,0.07879999f,0.37720000f,-0.38499996f,0.48959999f,-0.93089999f,0.91720001f,0.15690001f,-0.29760000f,0.00399998f,-0.19880001f,0.54469998f,-1.49699995f,-0.13319999f,0.48779998f,-1.00920001f,0.28580000f,0.77359999f,-0.68659997f,0.79070002f,-0.24240000f,-1.29509999f,1.44999999f,-0.24710004f,-0.62979998f,-0.65460000f,0.77459999f,0.50219996f,-1.27679995f,-0.41270003f,0.48310003f,0.07770000f,0.56290002f,0.03270000f,0.41550003f,0.14800000f,0.95770003f,0.12890000f,-0.55309999f,-0.19650000f,-0.38370004f,-0.10750000f,0.06140004f,0.19100001f,-1.05060000f,-0.15530001f,-1.51190007f,-0.29580001f,-2.01510008f,-0.19610001f,-0.76170006f,-0.27830001f,-0.11030004f,0.18220001f,0.75930004f,0.06250001f,0.00310002f,0.06170000f,0.05380000f,-0.17710000f,0.02040000f,-0.49400001f,0.03460000f,-0.17089995f,0.31019995f,0.91570001f,-1.36299999f,-1.00929998f,1.63840000f,-0.73670003f,-0.22099999f,0.66790006f,0.25439997f,-0.89229999f,1.36680001f,-1.93420002f,1.74919998f,-2.49180005f,1.63400002f,-1.36980008f,0.56760002f,0.37919997f,-1.07619997f,0.58610003f,0.25499998f,0.25300001f,-0.31500000f,-0.37910002f,0.09600003f,0.07390000f,0.81420001f,0.10290000f,1.41090002f,0.25190001f,0.66780002f,-0.01450000f,-0.04160002f,0.12330000f,-0.28019999f,-0.12610000f,-0.68240000f,-0.35310000f,-0.05989999f,0.27680001f,0.50800003f,-0.15150000f,-0.31170003f,0.13679999f,-1.05580003f,-0.11730000f,-1.01380003f,-0.12630000f,-0.81540002f,0.13530000f,0.56340001f,-0.00180000f,0.32220001f,0.39970001f,-0.57180000f,0.54320001f,-0.56260001f,1.56179999f,-1.68299996f,1.03770002f,0.29000001f,0.83540000f,-0.52619999f,-0.11869999f,0.29219999f,-0.60620000f,0.16319999f,0.32610003f,-0.80500001f,0.08740002f,0.37459999f,0.36220003f,0.40780000f,-0.49269998f,1.29219998f,-0.49310000f,0.77100001f,-0.48389999f,0.23619999f,0.01670001f,0.09600000f,0.47160004f,0.71860000f,0.31190000f,0.89920002f,0.22640000f,0.40350002f,0.18850000f,0.14400001f,-0.14820000f,0.46430002f,0.30190000f,0.22680003f,-0.10260000f,-0.47050002f,0.11630000f,1.43230003f,0.22000001f,0.35700006f,0.01930000f,-1.18250001f,-0.10010000f,-1.27480003f,-0.22750001f,-0.01240000f,0.27980001f,0.30880005f,0.00670000f,-0.11619999f,0.05940000f,0.97699999f,0.57320000f,-0.81259998f,0.15560001f,0.50380001f,-0.73679997f,0.66019996f,-0.83180000f,0.40439999f,0.34610002f,-0.58740000f,0.01440004f,0.84139997f,-0.45949999f,-0.01700000f,1.24180003f,-1.14340001f,1.33680005f,0.01880000f,-0.62549996f,1.25239997f,-1.46700000f,1.46139999f,0.45030003f,-0.84340002f,0.48930004f,0.52099999f,0.22550001f,-0.17540000f,0.86880000f,0.06339998f,-0.30770000f,-0.64300003f,0.18950000f,-0.42050003f,-0.24240000f,0.49049999f,0.25710000f,0.04910000f,-0.39420000f,-0.64270001f,0.14230000f,0.46930001f,-0.03500000f,-0.12379999f,0.05830000f,0.31190001f,0.02370000f,-0.05330000f,-0.00810000f,0.46600002f,0.18050000f,-0.08779996f,-0.07880000f,0.49890000f,0.21449999f,0.52700002f,-0.15720000f,-1.19300001f,-0.05380002f,-0.26120000f,0.56370001f,0.34660003f,-0.09350007f,-0.31239996f,0.46719999f,-0.64839999f,0.23799998f,0.09519999f,0.36540001f,-0.37520000f,0.73970000f,-0.55520001f,0.09470002f,0.12099999f,0.13390001f,-0.04020001f,0.08299999f,-0.23540000f,0.02030001f,-0.16720001f,-0.94449996f,1.28879995f,0.07069998f,-1.26039999f,0.03760000f,0.44539999f,-0.80399999f,0.52259999f,0.28790001f,0.27100002f,-0.06450000f,0.79430001f,0.15550000f,0.93420001f,0.21510000f,1.58970000f,0.14949999f,1.17660000f,0.14140000f,1.01020004f,0.38140001f,0.25040003f,-0.44240000f,-0.93140000f,0.27130001f,1.51900003f,0.21560000f,0.06220003f,0.06650000f,0.49330001f,0.22600000f,1.62790000f,0.16669999f,0.28029999f,0.13070000f,1.33580003f,0.02520002f,0.03659999f,0.28420000f,-0.07439999f,1.64810000f,-1.43579998f,1.82639999f,-1.55699996f,1.21679996f,-1.35899994f,0.68010000f,-0.44920000f,0.29740003f,-0.06540001f,-0.14270003f,0.25220001f,-0.25549995f,0.36499995f,1.46329999f,-1.28879997f,0.33370001f,0.29640001f,-0.78759999f,0.33719997f,0.99079999f,-1.07659996f,0.40599999f,-0.19380000f,0.34709996f,-0.52100003f,-0.32950001f,-0.20890001f,0.23530001f,-0.16349997f,0.04220000f,-0.77909999f,-0.10890000f,0.58799998f,0.10240000f,0.60370002f,-0.16400000f,0.50950000f,0.13060000f,0.68250000f,-0.13690000f,-1.12940000f,-0.16800000f,-1.26800002f,-0.41830000f,-1.90940003f,-0.30490000f,-1.00810002f,-0.19900000f,-1.15370002f,-0.24730000f,0.14779997f,0.28340000f,0.53070002f,0.22549998f,-0.08920000f,1.14380006f,-0.56720003f,0.20640006f,0.66859996f,-1.50139996f,1.17859997f,-0.16840003f,-1.20319998f,0.42799998f,-0.42340001f,0.88549999f,-1.33639998f,0.96529997f,-0.62319996f,-0.66319997f,1.29899995f,-0.75410001f,0.34839998f,-0.61929999f,0.80199998f,0.18919997f,-0.48839997f,-0.07150001f,0.52760000f,0.53209999f,-1.32639999f,-0.13280002f,0.94800001f,0.26330000f,-0.47799998f,-0.16170000f,-0.65900002f,-0.19750000f,-0.93980003f,-0.23000001f,0.36869999f,0.16600001f,1.02110006f,0.19070001f,0.71460003f,0.02050000f,-0.05540002f,-0.32140001f,-1.03430002f,0.10610000f,0.86200002f,0.08920000f,0.58170001f,0.26810000f,-0.07069998f,-0.19789999f,-0.73750001f,-0.15900000f,-0.70860003f,-0.11580001f,-0.76280002f,0.32829997f,-0.03479997f,-0.67800002f,0.71679999f,-1.55620004f,0.49380000f,-1.81400004f,1.35920001f,0.40599999f,-1.31760001f,1.25970004f,-0.82540001f,0.21810000f,-0.57739999f,-0.41200004f,0.55300002f,-0.84500001f,0.42319997f,0.03149999f,-0.51919999f,0.18880003f,0.26579999f,-0.85710000f,0.60979998f,-1.15720001f,0.59360000f,-1.06420001f,0.63160000f,-0.88029997f,0.62230002f,0.01520000f,0.61910001f,0.08400000f,0.80970000f,-0.14670000f,0.39589998f,0.31950000f,1.49890004f,0.20320000f,1.25800001f,0.24160000f,0.79640002f,0.11950000f,-0.03820001f,0.10930000f,-0.18550001f,-0.20300000f,-0.91640003f,-0.21280000f,-0.86220001f,-0.13640000f,-0.91130001f,-0.09190000f,0.24560004f,0.23120001f,-0.62199998f,-0.19030000f,-0.08540001f,0.78129999f,-0.77600000f,0.56280000f,-0.97280000f,0.86499998f,-0.64219997f,1.03129999f,-1.23759996f,0.58990003f,-0.15880002f,0.88899999f,-0.93139996f,0.99150004f,0.32199997f,0.78750002f,-0.36839999f,0.37590001f,0.05539999f,-0.04010001f,-0.14399998f,-0.26549999f,0.78820000f,-0.34460000f,0.06559999f,0.40120007f,0.08879997f,-0.72019998f,0.98579998f,-0.52110000f,0.14419998f,0.33389999f,1.25090001f,0.12580001f,0.44390003f,0.21640001f,0.61290003f,0.13440000f,0.21240003f,-0.27259999f,0.11550003f,0.30930000f,0.31340002f,-0.05649999f,0.81310003f,0.15030001f,-0.15959999f,-0.20380001f,-0.29440002f,-0.03910000f,-0.45970001f,-0.20620000f,0.16869996f,0.25170000f,0.91670001f,0.01980000f,-1.00740004f,-0.23060001f,-0.57680007f,-0.01770000f,-0.31819998f,0.60050004f,0.24979997f,1.41090004f,-0.80220000f,1.14060002f,-0.71920000f,0.46150000f,-0.40540002f,0.46800004f,-0.72440000f,-1.01769998f,1.28079999f,0.24529999f,-1.30319999f,-0.49340002f,0.67760001f,-0.85490002f,0.22180000f,-0.23209999f,0.61120000f,1.40539999f,-1.62239998f,1.50630000f,-0.78719999f,-1.15260003f,1.43260002f,-1.22490008f,0.81870001f,0.27400000f,0.35700004f,-0.09110000f,-0.33330001f,0.28420000f,1.00910002f,-0.14270000f,-0.77870003f,-0.26910000f,-0.35329999f,0.19570001f,-0.69669995f,-0.06770000f,-0.93580001f,-0.23950000f,-1.32430008f,-0.19110001f,0.12249998f,-0.07560000f,0.64470000f,0.17050000f,0.82320003f,0.08920000f,-0.46469998f,-0.23230000f,-0.68680002f,-0.13610000f,-1.36530003f,0.44750000f,-0.75320000f,-0.31789997f,1.10079997f,-0.72519999f,0.36280001f,0.60679998f,-0.70100001f,0.63969997f,-0.39139996f,0.69750004f,0.31459997f,-0.34419995f,0.88819996f,-0.67659998f,0.96499999f,-0.79630009f,-0.34559994f,-0.61820004f,-0.15460000f,0.22020002f,-0.40720001f,0.70410001f,-0.68400000f,-0.76409998f,0.86779998f,-0.55040000f,0.64979999f,-0.10580003f,-0.56480000f,-0.03690000f,-0.97160000f,-0.27979999f,-0.33229999f,0.15560000f,-0.29529998f,-0.15830000f,-1.16950004f,-0.28540001f,-1.65810004f,-0.33030000f,-1.72030000f,-0.26460000f,-0.60550003f,0.20789999f,-0.31760004f,-0.21690001f,-0.02550006f,0.10700000f,1.31360002f,0.21830000f,0.04919999f,-0.18430000f,-1.48360004f,-0.31260001f,-0.19410002f,0.22170000f,-0.90550002f,0.30090004f,0.90119999f,0.57370001f,0.59190000f,0.30009997f,-0.49740000f,0.40330000f,-0.35110000f,0.52300000f,-0.09550001f,0.55950000f,-0.17500000f,0.17279998f,-0.75100002f,0.24160004f,1.05009998f,-0.27509998f,0.06100000f,-0.27599999f,0.21890000f,-1.00469998f,0.51389997f,-1.00480000f,0.42419998f,-0.29369998f,0.44399999f,-0.25739998f,-0.01750000f,0.81840001f,-0.09199999f,0.95460002f,-1.24370000f,0.79340006f,-0.30030001f,-0.73249999f,0.22870004f,0.72759999f,0.76970003f,-0.51890000f,-1.09500001f,-0.38199997f,-0.28990003f,0.53320002f,-1.00790003f,-0.05330000f,0.61720002f,-2.22109995f,0.38960003f,0.12319996f,-1.06530001f,-1.12779997f,0.50539997f,-1.95370002f,1.21390001f,0.47479995f,0.15459999f,-1.13769998f,-0.80919998f,0.82850001f,0.57110000f,0.84180000f,0.70390002f,0.27859995f,-0.10580001f,-0.49590002f,0.73419998f,0.12589999f,-0.29840000f,1.02759998f,-0.04349999f,1.71410001f,0.12210001f,-0.43490001f,0.29259999f,0.02719995f,-1.10799997f,0.97529996f,-0.16910001f,-0.62710002f,-0.25770000f,0.13039995f,-0.88210000f,0.84200002f,-0.19760000f,-1.30189998f,-0.78569998f,-0.17949999f,1.97530002f,-0.50010001f,-0.77649997f,-1.98569996f,0.60860001f,-0.37059999f,0.54640001f,-0.22610001f,-0.06110004f,-1.64880002f,-0.50339999f,-0.19539998f,0.71750003f,0.43790000f,0.33669998f,-0.61579999f,-0.21650001f,-0.16209999f,-1.79049999f,0.37050003f,0.59700000f,1.67789998f,0.03380002f,0.70429999f,-1.58640002f,0.43250004f,-0.13930003f,2.11289994f,-0.09449999f,0.37049998f,-0.68989999f,-1.06720003f,-0.86569999f,-0.12440003f,-0.12750000f,-0.30400000f,-0.16790001f,-0.11610002f,-0.85659999f,0.10710000f,0.15560001f,1.14520003f,-0.08060000f,-1.00560000f,-0.52239999f,0.11900001f,-0.19379999f,0.93659998f,0.54870000f,1.11899995f,0.69360000f,-0.12599998f,0.12560000f,0.66460001f,0.39840001f,1.06649999f,1.04129998f,0.20960003f,0.24339999f,0.68879995f,0.36809996f,-0.38200004f,-1.11849999f,-1.46719998f,1.25190001f,0.18619997f,-0.09280003f,-1.26239999f,-0.69290000f,-0.12970001f,-0.38410000f,0.05260001f,1.43240001f,-0.68700001f,0.40030000f,-1.50100001f,0.13589997f,0.01120002f,-0.70920005f,1.72560000f,-1.04589996f,0.31150005f,-0.18200004f,-1.33260002f,-0.59110001f,0.49620001f,-0.38280001f,0.90660000f,-0.11480001f,-0.56889998f,-0.69710000f,-1.02600000f,-0.54290000f,0.42899998f,-0.20150001f,-1.06540000f,-0.65819999f,0.04300001f,0.25759999f,0.28210001f,0.42679999f,0.35090000f,-0.62360000f,-0.60879999f,-1.01430001f,0.76750003f,-0.38909998f,-0.26630000f,0.87180001f,0.08310001f,0.42900001f,1.33489997f,-0.73970000f,0.73520002f,0.32890000f,0.90899999f,0.50000000f,-0.17880006f,-1.20830005f,-0.10009995f,0.53600005f,0.62539998f,0.56850002f,-0.11940000f,0.77420000f,1.45909993f,-0.84009997f,-0.46839999f,-1.61150008f,-0.97169995f,1.22990002f,-1.28900002f,-0.50570002f,0.77079998f,0.71800002f,1.17569998f,0.23099998f,-1.22419998f,1.11930005f,0.81779999f,-0.02629998f,0.06570000f,0.07480000f,1.39160001f,-0.59390004f,-0.07779998f,-0.43740003f,-1.02819997f,0.35600002f,-0.51340001f,0.65989997f,0.09449998f,-0.01530000f,0.17420000f,0.48029998f,0.49550005f,-0.40240000f,-0.04850003f,-0.00919999f,1.06080000f,-0.89680001f,-0.65450000f,0.62389998f,-1.22409997f,0.83749998f,-0.70689997f,-0.39889999f,-0.26210000f,0.36709999f,0.04849999f,-0.06800000f,0.73550001f,0.41430001f,0.02800000f,0.59490000f,-0.22029999f,0.94230002f,-0.73760000f,-0.23360001f,1.35730002f,0.15700004f,0.63280000f,0.88210000f,-0.61710000f,0.73910001f,0.15320000f,-0.21429998f,-0.92040000f,0.52959999f,-0.25619998f,1.40300002f,0.03269998f,-1.00580002f,0.91880002f,0.21699999f,1.90759996f,-0.10910000f,-0.60290000f,-0.45080001f,-1.75670001f,0.42600000f,-0.10330002f,-0.55260001f,-0.09790000f,0.03800000f,-0.60149999f,-0.43840000f,-0.47450000f,0.92090001f,-0.03059998f,0.41729999f,-0.68939998f,-0.43980001f,-1.62600003f,0.13520000f,0.06649999f,-0.37450000f,-0.13779998f,-0.15440000f,-1.08479997f,-0.25050001f,-0.05049997f,0.62890001f,0.28420002f,0.94859998f,-0.46399998f,-0.30460000f,0.59549999f,-0.86880001f,0.50189999f,-0.20980001f,0.32859999f,0.98030003f,0.84769999f,-0.26450002f,0.84839997f,-0.06930001f,-0.37140000f,-0.39859998f,0.83669998f,-0.23800000f,-0.71329997f,1.42239997f,-0.52120006f,0.18770005f,-0.64340001f,-0.80190002f,1.04160002f,-0.44589998f,-0.41270000f,1.68829997f,-1.03689998f,-0.36290001f,-1.89619998f,0.23990002f,1.63939998f,-0.18430001f,0.93609998f,0.44270001f,-0.09430002f,-1.37010005f,0.46819997f,0.03010000f,-2.12339997f,0.65519997f,0.33040003f,-0.09190000f,0.62050001f,0.55489997f,0.06699997f,-0.23279999f,-0.50890003f,-0.52210001f,-0.67139996f,-0.45390000f,0.34779999f,0.69210002f,-0.45899999f,0.16079998f,-0.50340002f,-0.68429998f,-0.29339999f,-0.87119998f,0.85390003f,0.77149999f,-0.60219998f,0.55359999f,0.63970003f,-0.37310001f,0.49600002f,-0.76520003f,-0.27830000f,-0.67650002f,0.20140000f,-0.22139998f,-0.38949998f,-0.41989998f,0.55100000f,1.42770003f,-0.80560004f,-0.50050001f,0.33760002f,0.77960004f,0.86469999f,-0.18100004f,1.19050003f,-0.70689996f,0.56880007f,-0.83560000f,0.34010002f,-0.59660002f,-0.25690000f,0.60880000f,-0.04900002f,-1.70160003f,0.35759999f,1.41440000f,-0.41349998f,1.00530000f,-0.23869999f,0.13730000f,0.99490002f,0.40080000f,0.53880000f,0.01610000f,0.84889995f,0.46959999f,-0.45900002f,-0.71470003f,-1.45140000f,0.50670000f,0.69550001f,0.28110000f,-1.33239998f,0.83300002f,-0.29809998f,0.79700003f,1.46949997f,0.57950000f,1.55609999f,0.06420000f,1.07780000f,-0.33510000f,0.07510002f,0.53019999f,0.11300001f,-0.48189999f,-0.89799998f,-1.44390003f,0.24499998f,-0.62950002f,-0.17949999f,-0.47930002f,0.28400000f,0.36779998f,0.38500003f,-2.21790006f,-0.35639996f,1.12600004f,1.05319998f,-0.65809999f,-0.69440000f,-0.45410000f,0.85260001f,-1.16439998f,0.59310006f,1.39820002f,0.01469998f,-0.98330006f,-1.21950000f,-0.49740005f,-1.91390001f,-0.60620005f,-0.45700000f,0.22050002f,0.07699999f,-0.87240004f,0.22590001f,0.22820000f,0.53030000f,0.09420000f,0.85940001f,0.30660000f,1.36030004f,-0.15239997f,0.14379999f,0.26730002f,0.79170000f,0.37679999f,-1.25910003f,-0.01170001f,0.96550000f,0.75770001f,1.09100001f,0.74070001f,0.97909999f,-0.40000001f,0.72870003f,-0.85169999f,0.52880002f,-1.10520001f,1.14619998f,-0.30489999f,0.84730000f,-0.30570000f,-0.67410004f,0.05840001f,0.64179998f,0.19229998f,-0.98400000f,-1.47949998f,-0.45730000f,0.12140001f,0.41710000f,0.38030002f,1.19409999f,-0.31110000f,2.15819999f,0.51279999f,-2.03079997f,-0.22199998f,0.06190002f,-1.12200001f,0.17920003f,-0.37630000f,0.97590002f,-0.60099998f,-0.45129996f,0.09189999f,0.69689998f,0.73810004f,-0.78449999f,-0.49540000f,0.47039999f,-0.24899999f,0.58900001f,0.09950000f,-0.14609999f,-0.82269999f,-0.43650001f,0.19539998f,1.18699996f,0.31400000f,-0.11020001f,0.58469999f,-0.26890000f,1.23380000f,-0.37720000f,-1.18899998f,0.59390001f,-0.05129999f,0.28379998f,0.37050000f,0.53359999f,0.78480000f,0.80899998f,0.00000001f,-0.15230006f,0.62549999f,-0.70410000f,-0.30070000f,0.54569999f,0.44870000f,0.76390000f,-0.30700000f,0.87100003f,1.65560001f,-0.38810006f,-0.44379998f,0.66320002f,1.24980002f,-1.39480004f,-0.11419999f,0.37390000f,-1.25010003f,0.80370001f,-0.52619999f,-0.76419996f,0.35360000f,-0.26290000f,0.83330001f,-0.98779999f,0.13250000f,0.33529998f,0.24500001f,-0.65989999f,-0.37989999f,0.77979997f,1.20859998f,-1.25199998f,-0.00129998f,0.53570000f,-1.23920000f,0.31400001f,0.80010001f,-0.58260001f,-0.40730003f,-0.98299998f,0.60130000f,-0.19570002f,-0.96000002f,0.37640003f,-0.00530000f,0.52419999f,0.55850000f,0.45399997f,-0.22729999f,0.39999997f,-0.17230000f,-0.71780000f,-0.68080000f,-0.96720000f,0.26979999f,0.15500000f,-0.40959999f,-0.45110000f,0.64839997f,-0.81020001f,-0.72799998f,0.04510001f,0.26840000f,-0.43060002f,0.66640001f,-1.87120004f,-0.50359999f,-0.71770000f,-0.70950003f,-1.20869999f,-0.70790002f,-0.02989998f,-0.79919998f,-0.46119997f,1.47349997f,0.45859997f,-1.58620000f,-0.45079997f,0.38829997f,-1.03930001f,-0.48450000f,-1.40390001f,-0.78100000f,-0.89919997f,0.58340002f,-1.72949992f,0.18100001f,-0.14400001f,-0.63890007f,1.50080001f,-0.04349997f,0.84149999f,-1.48690002f,-0.76099999f,-1.16160002f,0.37109999f,-0.36070000f,0.95139998f,-0.56110000f,0.52409998f,0.25430000f,0.72799998f,0.14110000f,0.99919999f,-0.19069999f,-0.37249998f,0.02880001f,1.51569998f,-0.81299999f,-0.03890001f,-0.75570001f,-0.53110003f,0.01630000f,0.69399996f,-0.80089996f,1.36660001f,-0.30870001f,0.01480000f,0.81830001f,0.12170003f,0.38560000f,-0.01850002f,0.60390003f,-1.03009999f,0.74749998f,0.02440000f,-1.88150001f,-0.47329996f,0.87149998f,-0.89849996f,0.86420002f,-0.48830000f,-0.89639998f,1.20439997f,1.38400001f,0.55290003f,-1.11430003f,1.94590004f,0.67540001f,0.46660001f,-0.95600002f,0.60410000f,0.86000002f,-0.00669999f,1.48800003f,-0.79180000f,-0.30769999f,0.23539999f,-0.38409999f,1.27069998f,0.18520001f,0.98679997f,-0.59940000f,0.98789997f,-0.53779998f,-0.84659999f,0.15880000f,0.78289997f,-0.59569997f,-0.37670001f,-0.57199999f,-0.25700001f,0.77069998f,0.20340000f,-0.22249997f,-0.83909998f,1.15370002f,0.34750004f,-0.07389999f,-1.01460001f,0.61849999f,-0.99850000f,0.18540000f,-0.39819999f,-0.70729999f,-0.76169999f,0.19749999f,0.14739999f,0.84499999f,-0.13990003f,1.32510002f,-0.30809997f,0.60710002f,0.26149998f,0.06159999f,-1.12649998f,1.29290002f,-0.22180003f,-1.00590001f,-0.96640005f,1.05130004f,0.50229998f,-0.30880004f,0.42949998f,0.00599999f,1.05970000f,-1.97750003f,-0.09729993f,0.37080000f,-0.63470000f,1.93430002f,-0.96230008f,-0.42480001f,-1.71149996f,-0.55479998f,0.22889996f,0.47860001f,-1.54219998f,0.70839996f,0.51020000f,-0.41899997f,-0.95240000f,-0.08490001f,-0.81769999f,-0.63779998f,0.00470001f,-0.60780001f,0.18579999f,-0.63730003f,0.85780001f,-0.44220001f,-1.38290001f,-0.00760001f,-0.19569996f,0.36240001f,0.05889999f,0.45630002f,0.85829997f,-0.20420000f,-0.71160000f,-0.91770004f,-0.65550000f,-0.92419997f,-0.21080003f,0.45139997f,0.74869998f,-0.88469998f,0.21559998f,0.82130005f,-0.81970003f,0.10459997f,0.77349998f,-1.89310005f,0.21650002f,0.03440001f,0.69440000f,-0.26400002f,0.03629998f,-0.89329999f,1.33369997f,-0.04520001f,-0.67939997f,-0.19400000f,-0.56500001f,0.86119999f,1.10249998f,-0.62630005f,1.20830001f,0.33580005f,0.39710000f,1.22970001f,1.17879999f,0.26889997f,-1.07519999f,-0.38929999f,-0.26080002f,1.52810001f,0.17690003f,-0.73580002f,0.66060000f,-0.05839999f,0.12750001f,0.32330001f,1.23770002f,0.22650000f,-0.41420001f,0.05829999f,0.54460001f,0.94929998f,0.96129998f,-0.41749998f,0.33639998f,-0.33700001f,-0.03699997f,0.24950000f,-1.46089997f,0.88530001f,-1.00759996f,0.52539998f,-0.29899999f,0.51560000f,-0.15709999f,-0.79289997f,-0.67520001f,0.01849998f,-1.00460001f,0.63330000f,-0.01670000f,-1.41390002f,0.39829998f,0.92780000f,-0.69190002f,-0.40770000f,1.84970000f,0.65949994f,-0.80609997f,0.61540000f,0.41880000f,-1.58170006f,-1.61899999f,0.70640000f,-1.93040001f,0.53249997f,-1.38469999f,-0.45819997f,-0.43439999f,0.01639998f,-1.41999999f,0.88120001f,0.27069998f,-0.81910001f,-0.04230000f,-0.70090004f,0.19680004f,1.07910007f,1.38319998f,-0.54019997f,-1.59320000f,-0.59559999f,-1.65880002f,-0.00200000f,0.62450000f,0.39019999f,0.45130000f,0.37280000f,-0.60579996f,0.19140000f,-0.36579999f,0.54700001f,1.61020002f,-0.47369996f,-0.67580001f,0.27950000f,0.41050001f,0.10280000f,-0.14710001f,-0.74509996f,0.07380000f,-0.64639997f,0.58419998f,-0.18489999f,-0.42780001f,0.01660000f,-0.22470000f,0.75210004f,0.12460000f,0.14769998f,0.37819998f,-1.03150003f,-0.17379999f,-0.39560000f,-0.66120001f,0.58360000f,0.19220000f,0.81879999f,0.67820000f,0.75320003f,0.53820000f,-1.49030003f,-0.39460000f,0.22379996f,0.22860000f,1.44009999f,0.36779999f,-1.27209999f,-0.20819999f,0.34619997f,0.10200002f,1.47300002f,0.20319999f,-1.32279998f,-0.36999999f,0.82950000f,0.19200002f,-0.33779999f,-1.08029999f,-0.55039999f,-1.70550001f,-0.25569999f,0.45450001f,-0.89879997f,-0.62089999f,0.23330001f,-0.37039995f,0.04920000f,-0.75790000f,0.22610000f,-0.66820002f,-0.56469999f,-0.83219997f,0.59229997f,1.13160001f,0.40910000f,-0.46539994f,-0.23720000f,-0.26820001f,0.35759998f,1.26139998f,0.58529998f,0.29490001f,0.50129997f,1.22860001f,0.46510000f,-0.20240001f,-0.39200002f,0.10920001f,0.14650001f,-0.35899999f,0.33459999f,-0.06319999f,0.01469998f,0.24120002f,0.11690001f,-0.09560000f,1.31880003f,0.48780000f,-1.55190000f,-0.54999999f,1.41919999f,0.60220000f,-0.02770002f,0.38399998f,0.26029998f,-0.05900004f,-0.24899997f,0.09619999f,0.43220001f,0.64299999f,-0.09440002f,-0.10280002f,-0.21249997f,0.25859999f,0.72259997f,0.60400006f,0.31899999f,0.93430002f,-0.08980000f,0.50979999f,0.11980000f,-0.24519999f,0.50899997f,0.64020002f,-0.35450001f,-0.14640003f,0.46670000f,0.01910000f,0.32489999f,1.04540001f,0.36349999f,-0.68329997f,-0.53039998f,-0.67490001f,-0.20450001f,-0.41980001f,0.19190001f,-0.48479996f,-0.20829999f,-0.61750005f,-0.51469999f,-1.54870001f,0.49719999f,0.26319998f,-0.51759996f,0.01900002f,-0.67470002f,0.01700000f,0.85730002f,-0.05579999f,-0.83340001f,-0.19799999f,0.58140001f,0.12420002f,-0.38600000f,-0.21319999f,0.41210001f,0.02840002f,-0.13499998f,0.02100003f,1.66200002f,0.68140001f,-0.86800004f,-0.40680003f,0.04610001f,0.36379999f,0.37579999f,0.64540003f,0.19370002f,0.06500000f,0.58379999f,0.46620000f,0.58519999f,0.34830000f,0.85019998f,0.55990005f,0.07520000f,0.84050001f,0.37880000f,0.23920001f,0.29369998f,0.70240000f,-0.41609998f,-0.76830000f,-0.66399998f,-0.51120002f,0.59010000f,0.65380002f,0.76060000f,1.28990003f,0.76169999f,0.64409998f,-0.53610001f,-0.95540000f,-0.38719999f,-1.68570001f,0.59900000f,0.32310002f,-0.22319999f,-0.91600001f,-0.13609997f,-0.08439998f,-0.75449999f,-0.27179999f,-0.58290003f,-0.71700001f,0.67190000f,0.16540000f,0.14380000f,-0.25800002f,0.74030005f,0.91600001f,-1.50880001f,-0.23739998f,1.35410000f,0.47800002f,-0.85549999f,-0.64620000f,-0.73539999f,-0.84880000f,-0.16999999f,-0.00419997f,0.00289998f,-0.61300002f,0.85300000f,0.46699999f,0.32380003f,0.13699998f,-0.30010002f,0.59309997f,0.53900001f,0.63150004f,-0.65060000f,-0.06930006f,-0.85409997f,-0.39739998f,0.00580000f,0.52679996f,-0.04880000f,-0.67999996f,0.60160002f,-0.84049995f,-0.53610000f,-0.40290005f,0.81110000f,1.11300002f,-0.70909998f,0.35889997f,-0.87619998f,-0.75770002f,-0.02250000f,0.95419997f,-0.29479999f,0.04990003f,0.25560000f,0.15330001f,0.11820000f,-0.75710001f,-0.94800000f,-0.54499999f,0.17339999f,-0.17599999f,0.04529999f,-0.39320002f,-0.07310000f,-0.05380001f,-0.86189997f,-0.43099997f,-0.66570006f,-0.80800002f,1.12290001f,0.59540001f,-0.86529996f,-0.55159998f,0.02960000f,-0.44999999f,0.85350000f,0.38139999f,-0.62639999f,-0.42200001f,-0.42720000f,0.13900001f,0.45030000f,0.55980003f,0.24280001f,-0.08980000f,0.62459999f,-0.91710006f,-0.30890001f,0.38389997f,0.23599999f,1.15540000f,-0.79060001f,-0.72430005f,-0.31699999f,-0.35910002f,0.23230001f,1.47410000f,-0.33430001f,0.02280002f,0.24970000f,0.03750000f,-0.04240000f,1.20519996f,0.27210001f,0.83960003f,-0.37499999f,-0.52060006f,-0.56289998f,-0.96080001f,0.18650000f,-0.53639998f,0.55580000f,0.61630002f,0.23690001f,0.00080004f,-0.14820000f,-0.21880002f,-1.75909996f,-0.99119998f,1.33129997f,0.66500000f,-0.41179997f,-0.18800000f,-0.13750002f,0.17620000f,-0.56710001f,-0.57179999f,0.65520003f,0.19060001f,0.34279998f,0.08699998f,-1.30539998f,-0.40179998f,-0.05980002f,-0.39679999f,0.63549999f,0.41480003f,0.85480003f,-0.09540001f,-0.90430000f,-0.33860001f,0.97680003f,0.60600001f,-0.10249999f,-0.01960000f,0.32410000f,0.97010000f,-0.80639997f,-0.41050001f,0.12310000f,-0.39690000f,-0.45419997f,-0.92909997f,0.03390000f,0.38259997f,0.36629998f,1.18980002f,0.40170000f,0.54300003f,-0.48390001f,-1.19120003f,-0.55099997f,0.07479999f,0.39409996f,0.55910000f,0.45159998f,1.12829997f,-0.34919998f,-0.45990002f,-0.44149998f,-0.48510001f,0.66530001f,0.23450003f,0.35709998f,0.21480001f,0.33970001f,0.24360001f,-0.32100001f,-0.00120000f,0.70719997f,0.26999997f,-1.10999996f,-0.54179998f,-0.23610002f,-0.45500001f,1.13330000f,0.26919998f,-1.93979999f,-1.02620000f,0.47289997f,0.14599998f,0.39219998f,0.40320000f,0.32370000f,0.48860001f,0.38680001f,0.24020000f,-0.17189998f,0.21000001f,-0.52279999f,-0.34599999f,0.27090000f,0.25619999f,-0.28820000f,-0.81680002f,-0.43179999f,-1.15180001f,-0.21989999f,-0.25549998f,-0.35169999f,-0.67180001f,0.51780001f,1.68870005f,-0.70260000f,-0.12660003f,0.08610000f,0.13739999f,-0.90820001f,-0.37020003f,-0.86210000f,-1.80150003f,-0.58649999f,-1.79880001f,-0.09749999f,-0.60180001f,0.53639999f,0.06180002f,-0.55459998f,-0.78700003f,0.41929998f,1.67549996f,0.61549999f,0.67360000f,-0.80889999f,-0.07420000f,0.79080001f,0.39960000f,0.71430003f,0.48760000f,-0.69100004f,0.29340000f,0.18610000f,-0.27920002f,-1.24340002f,-0.36700000f,1.31960001f,0.36899999f,-0.26030000f,0.18919998f,0.32010001f,0.11540001f,0.97440003f,1.04560004f,-0.54759998f,0.22540005f,1.53689996f,0.76459999f,0.05970002f,0.17579999f,-0.84590003f,0.05040002f,-0.04129999f,-1.17159999f,-0.24960000f,-0.38060001f,-0.20960000f,-0.78160002f,0.54689998f,-0.70320000f,-0.50040001f,-0.32680006f,-0.10419999f,-0.33129998f,-0.42679999f,0.02630001f,-0.60310000f,-1.73670000f,-0.75489999f,-1.10340005f,0.63250001f,-0.11849997f,0.92650000f,-0.43600000f,0.74160001f,0.73770004f,0.42289998f,-0.20439999f,0.53920000f,-0.28379996f,0.37620001f,0.29179999f,-0.47839998f,0.13900001f,-0.31090001f,-0.00499999f,0.91759998f,0.29059998f,-0.70729998f,-0.50480002f,0.21529997f,-0.11840004f,-1.03699999f,0.07480002f,1.31530001f,0.40760000f,-0.44110002f,0.04619999f,0.04730001f,-0.07100001f,0.19299998f,0.43139999f,-1.00360003f,-0.71120002f,-0.16379999f,-0.21359999f,0.95159999f,0.29379999f,-0.01739999f,-0.30800001f,0.25020000f,-0.41449999f,0.76589998f,0.61880004f,-0.52169997f,-0.56539997f,-0.18210000f,-0.14970000f,-0.40139999f,0.34059999f,-0.78240000f,-1.93780002f,0.76839996f,1.33860001f,0.21340000f,-0.49069998f,-0.44919999f,-0.55810000f,-0.69589999f,-1.54920000f,-0.11449999f,-0.20070000f,-0.76550000f,-0.34030000f,-0.00220000f,0.36770001f,-0.35489999f,-0.71350001f,0.79419998f,0.05379999f,-1.17890001f,-0.72199999f,0.35400001f,-0.15540001f,-0.35000001f,-0.09919998f,1.33550005f,0.44040000f,-0.13820002f,0.23399998f,-0.43870001f,0.19100000f,0.20200000f,-0.00959999f,-0.54519999f,-0.33239998f,-0.00660002f,-0.39500000f,0.57740000f,0.33980000f,-0.79919999f,-0.56839999f,-0.42500001f,-0.28479999f,1.00600000f,0.13979999f,-1.13860001f,0.24779998f,-0.73890000f,-0.80610008f,0.22330000f,1.42620004f,-0.60190000f,-0.85530004f,0.70190000f,1.42650005f,0.31020001f,-0.36719999f,-0.36639999f,-1.42369998f,0.00400000f,-0.03359999f,0.12180000f,0.28220001f,0.43029999f,1.50100000f,-0.33569999f,-0.27319999f,0.36629999f,0.51570000f,-0.72079996f,-0.45880000f,0.38019997f,1.31430000f,-0.09390000f,-0.81599997f,-0.89470003f,0.01520002f,1.08940002f,0.47280001f,0.33550000f,0.52920002f,-0.11960001f,-0.04400000f,0.32469999f,0.33140000f,0.54610001f,-0.01100000f,-0.28210000f,0.30640000f,1.04080000f,0.71820002f,-0.63220000f,0.01280001f,-0.38410001f,-0.25499999f,0.79819998f,0.33120000f,1.44930004f,0.58860002f,-0.58530003f,-0.30060002f,0.13900001f,0.15699999f,-0.78450002f,-1.32270006f,0.79230000f,1.09330008f,0.29910001f,-0.67409997f,0.36530000f,-0.05389998f,-0.40480000f,-0.96349999f,-0.35539999f,-0.28130004f,0.51119998f,0.00120002f,-0.18960000f,-0.92750001f,0.87429998f,0.06210002f,0.42250000f,0.50700006f,-0.54220000f,-0.67579998f,0.40899997f,0.43369998f,0.54000002f,0.40330000f,-0.54180001f,-0.56210004f,-0.11019999f,-1.13719998f,0.68550000f,0.39580001f,1.07279999f,0.45079999f,-1.30549998f,-0.16619998f,0.85109997f,0.31160000f,-0.30220000f,-0.28900000f,0.63089998f,0.13379998f,-0.22109998f,-0.14320002f,-0.30460001f,-0.21200002f,0.11180001f,0.21380000f,-1.34970003f,-0.54200001f,-0.73470000f,-0.67339999f,0.60500000f,0.00460001f,-0.26840000f,-0.28420000f,0.41179997f,0.01819997f,-0.84800000f,-1.08549999f,0.47730000f,0.53230002f,0.92959997f,0.15690004f,-0.51719998f,-0.52540001f,0.51599997f,0.73629998f,0.53059999f,1.30610002f,-0.50689998f,-0.59869999f,0.57149997f,1.18230000f,-0.79420001f,-1.06270007f,0.39989999f,0.24710000f,-0.75769999f,-0.14780002f,-0.45430000f,0.37679997f,0.65579998f,1.17990001f,-0.24949999f,0.19400000f,-0.61419999f,-1.45389999f,0.97520001f,0.02219999f,-0.51400000f,-0.46440000f,-0.00669999f,0.10540002f,0.51780001f,-0.04639999f,0.80669999f,0.80660001f,0.45420006f,0.12620000f,-0.95100001f,-0.33740001f,0.56390003f,0.15580000f,-0.64490004f,0.24359998f,-0.05820000f,0.01380002f,-0.46200000f,-0.54799998f,0.82710001f,0.50740001f,-0.58440002f,-0.49260000f,1.10430001f,0.68020001f,-0.12130001f,0.64860000f,0.47439997f,1.09199997f,0.13690000f,0.39060002f,0.41049998f,1.02969998f,0.78080000f,0.48070004f,0.67250001f,0.58760005f,0.94300002f,1.21570004f,0.13930000f,0.79400001f,0.03360000f,-1.03099997f,-0.66440001f,-1.32950004f,-0.01140000f,0.51359995f,0.73950000f,1.24540009f,0.64729997f,0.72760000f,-0.68469998f,-0.90559996f,0.71849998f,0.55570000f,1.44430003f,0.61420002f,0.55000001f,0.26499998f,-0.22280000f,0.44440000f,0.39170002f,0.28459999f,-0.98420002f,-0.27880000f,0.86300001f,0.31559999f,-0.20340000f,0.37379999f,0.02770001f,0.14000001f,0.20680003f,-0.26480000f,-1.19140002f,-0.63520001f,-0.80309998f,-0.60099999f,0.33449999f,-0.36720001f,0.19229999f,0.40260001f,-0.83840001f,-0.45220000f,-0.29839999f,0.30100001f,0.84270001f,0.82140004f,0.54429999f,-0.29929998f,-0.25670000f,-0.84400003f,0.08580000f,-0.38560001f,-0.14100000f,0.19120001f,-0.66039997f,-1.96169999f,0.37709998f,-0.01890000f,0.25400001f,0.94459999f,0.11370000f,0.57689998f,-0.87540001f,-0.38850006f,-0.73849997f,0.36729997f,-0.27050000f,-0.53500001f,0.74429996f,0.74999999f,-0.27610000f,0.56979999f,1.16850003f,0.52880001f,-1.02990001f,-0.22119999f,0.31490000f,0.14100001f,0.59960003f,0.02439999f,-1.41110000f,-0.37559998f,1.53000000f,0.46300000f,-0.75460001f,0.39260003f,-0.01799998f,-0.01679996f,0.30459997f,-0.06979999f,0.24489999f,-0.02380000f,-0.21849999f,-0.02039997f,0.53560001f,-0.20999999f,0.97480001f,0.70760000f,-1.29420001f,-0.46040001f,0.73830003f,1.42589999f,-0.85580002f,0.82150001f,0.02009997f,-0.35730000f,1.19180001f,-0.13339999f,-0.05699999f,0.45309998f,-0.32599999f,0.28390000f,0.13679998f,-0.56300003f,0.63260001f,1.19330000f,-1.53509998f,-0.70450000f,-0.77550001f,-0.08060000f,-0.73770000f,-0.04950001f,0.21120001f,-0.56150000f,0.02030001f,0.00080000f,-0.68739998f,-0.32209999f,-0.00360000f,-0.05569999f,-0.62240003f,0.17320001f,0.27470000f,0.58719999f,1.82270001f,-0.02940000f,-0.10370001f,-0.55120001f,0.13719995f,0.20700000f,-0.34770000f,0.86160000f,0.12469999f,0.51340001f,1.19270005f,-0.26100000f,0.74209999f,0.31139998f,-1.37189997f,0.28019999f,1.01830000f,-0.03280000f,0.32890003f,0.21520002f,-1.38079998f,-0.03220000f,0.73360001f,-0.51780000f,-1.53699998f,1.11120001f,-0.54620002f,1.22829999f,-0.25740005f,-0.11780002f,0.74710000f,0.40469998f,-0.05959999f,-0.43650002f,0.28509999f,1.01329999f,0.33159996f,1.09310001f,-0.53740003f,0.06950000f,0.37870001f,-0.97800001f,1.43729997f,0.73689995f,-0.33659998f,-0.31559999f,1.05339999f,-0.50980000f,1.36250003f,0.31950001f,-0.74939996f,-1.57139996f,0.56950001f,0.81569999f,0.11790000f,-0.47160001f,-0.15659998f,0.24279999f,-0.41980000f,-0.36439999f,-0.45449999f,-0.09800000f,0.32540002f,0.29240001f,-0.45299998f,0.04260000f,-0.56480002f,0.36900000f,1.10070001f,-0.73220001f,-1.65280000f,0.62020001f,0.19070003f,0.63599998f,0.32039998f,-0.18940003f,0.25549996f,-0.03820001f,-0.32970002f,0.82300000f,0.32870003f,-0.17380000f,1.13879998f,-0.80830000f,-0.07869998f,-0.84660001f,1.41409997f,0.02030000f,0.33100000f,-0.32380001f,0.10090001f,-0.65429999f,1.02760002f,0.66480002f,0.38119999f,0.41219999f,-0.62010002f,-1.33049998f,0.24600000f,0.29320000f,-0.05690002f,1.48339998f,0.07349996f,0.78739997f,-1.23449998f,-0.33460001f,-0.68890000f,1.08640000f,-0.16550005f,1.21479998f,-1.38989996f,-0.87010001f,-0.43979996f,0.01679998f,0.19259999f,-0.26199999f,-0.05409996f,0.16319999f,-0.73790002f,-0.23760000f,0.41230001f,-0.21060000f,-0.92559998f,0.32980002f,0.70010000f,-0.01119999f,0.45299998f,-0.11379999f,-0.07959999f,-0.09399999f,-1.73830001f,0.54300001f,-0.14389995f,-0.49500002f,0.18959997f,0.56239999f,1.10570001f,0.71880002f,-0.30929998f,0.10880000f,0.24550002f,0.34579999f,-0.91839997f,-1.20739998f,-0.23999996f,-0.53050000f,1.14399998f,-0.03110001f,-0.40139998f,-1.12069998f,0.81900001f,0.80660000f,0.38510000f,0.60950001f,0.37140000f,-0.76480000f,0.17720001f,-1.13449999f,0.72700000f,0.44250002f,-0.44980003f,0.61880001f,-1.08539998f,0.47539998f,0.02689995f,0.07259998f,0.74420000f,1.02310002f,-0.25300001f,0.29579998f,-0.08449997f,-0.29239999f,-0.25600001f,-0.07079998f,0.38830004f,-0.62540001f,-0.16050006f,0.21560000f,-0.39629998f,-0.46960001f,-0.23120005f,0.95040000f,1.42540002f,0.02900002f,-0.09349997f,0.42500001f,-0.29239998f,-0.61139999f,0.03429997f,-0.84359999f,0.56479997f,0.14660003f,-0.43449996f,-0.73680002f,-0.71530004f,0.46879999f,-0.33790003f,-0.03960001f,0.57690002f,-0.52040001f,-0.21119996f,0.18350006f,0.48209998f,0.10479997f,-0.00999998f,-0.12140001f,0.10619999f,0.19359998f,-1.17349994f,0.02409999f,0.06199996f,0.38810004f,1.11829998f,-0.26470002f,0.55800000f,0.46010002f,-0.21659997f,-0.31529999f,-0.45289997f,-0.85909996f,1.00839999f,0.00979999f,-0.52099998f,-0.02900003f,-0.18250002f,0.59900000f,-1.19600002f,-0.47640002f,1.36700001f,-0.52619999f,-0.17889999f,-0.22240000f,-1.01360000f,-0.33640001f,0.35059999f,-0.01720000f,0.95949997f,-0.54939998f,-0.53829997f,-0.88420003f,-0.78820003f,0.74460001f,0.79430000f,-0.63359999f,-0.64539999f,-0.66420000f,-1.48700002f,0.50840001f,0.58930000f,-0.52460000f,0.75639997f,0.16940000f,0.26330002f,0.67960002f,-0.24749998f,-0.19060000f,-0.42510000f,-0.36869998f,0.33650001f,-0.83869999f,0.43200001f,0.74950002f,-0.62009999f,0.04589999f,-0.31240000f,-1.19159998f,0.31650000f,-0.83830001f,0.02900003f,-0.00170002f,0.63219999f,-0.34899996f,0.19220000f,-1.11090000f,-0.23849998f,0.95020001f,-0.47280003f,0.52270000f,-1.21699996f,-0.78639999f,0.37950000f,-0.08620001f,1.10989999f,0.21990000f,-0.07689999f,0.15109999f,0.33589999f,-0.49460003f,0.10959997f,-1.00799997f,-0.71500001f,0.81540001f,0.49350001f,-0.15320000f,0.66039998f,0.28739999f,0.50790002f,-0.78619999f,-1.17870000f,0.15420000f,-0.78470000f,0.17339999f,1.48710000f,-0.23319998f,0.40509999f,-0.52100000f,-0.65019996f,0.55760002f,-1.20599997f,-0.17360000f,0.58749999f,-0.35540000f,-0.25010004f,0.49980001f,-0.43240000f,-0.17250003f,-0.91589999f,-0.73779999f,-0.24359996f,0.20980000f,0.27399999f,0.83689999f,-0.39950000f,-0.20780001f,0.57109997f,-1.10150000f,0.14060007f,-0.52840000f,0.27680000f,1.13060001f,-0.52500001f,-0.25570001f,0.66110000f,-1.24509996f,0.55510001f,-0.38599998f,1.27939999f,1.33440000f,-1.11219999f,-0.18760000f,-0.50029998f,-0.19600001f,-0.30750001f,1.33860002f,-0.60139998f,0.40920002f,0.25880002f,0.44440002f,1.01460001f,0.12939999f,-0.36199999f,0.40499998f,1.52879997f,-0.77480000f,-1.23690001f,-0.32760000f,-0.60650002f,0.19739999f,0.86939998f,-1.05159999f,-0.50990001f,0.44819999f,0.79620000f,0.68500001f,1.01520001f,0.67020001f,0.44210001f,0.09360000f,-0.29969999f,0.43240003f,1.22139999f,-0.54100001f,-1.21359998f,0.37410001f,0.42990000f,1.11990002f,0.13580000f,0.27350000f,0.45889998f,1.08819996f,-0.19800001f,-1.53930002f,0.27560004f,0.07190002f,0.14600000f,0.38659998f,-0.73690000f,-0.31509994f,-0.45809998f,0.69860001f,0.10899995f,1.40839998f,0.13609997f,0.95629999f,0.31029999f,0.06730000f,-0.28939999f,1.01950001f,0.08599999f,-0.96589997f,0.03649999f,-0.70670001f,-0.81509999f,0.81780001f,1.28460001f,0.02640001f,-0.33550000f,0.54080002f,0.22699998f,0.34380000f,0.52000006f,0.59760001f,0.32970002f,-0.42680002f,0.76580000f,-0.20560001f,-1.00830003f,0.58940002f,1.06029999f,0.45699999f,0.88219998f,-0.10500000f,-0.54590001f,1.07180004f,0.99960007f,0.21360003f,-1.32869995f,0.83180000f,0.32670001f,-0.00160001f,0.73890003f,0.73719999f,-0.11920000f,0.35800002f,0.30190000f,0.96060001f,-0.06320001f,0.36660003f,-0.62920003f,0.86810002f,0.63719997f,0.34269998f,-0.80959998f,-0.66920001f,0.81200001f,1.55590001f,-0.27200001f,1.31610001f,0.02309995f,-0.44050003f,-0.41330000f,0.08600002f,0.47129997f,-0.38949998f,1.09069999f,1.01660000f,0.15679999f,0.07759999f,-0.39860000f,-0.81910000f,-0.07330001f,0.18759999f,0.73269999f,-0.01100000f,-0.43329996f,0.24980000f,-0.13470002f,0.38019999f,0.50329997f,-0.60600001f,-0.83220002f,-0.09440002f,2.12159997f,0.03120001f,-1.61099997f,0.41240000f,0.41140002f,0.21039999f,0.17109998f,0.06860000f,0.80549999f,0.62899999f,0.78170002f,-0.66100001f,0.39139996f,-0.17080000f,-0.96239999f,0.44500000f,0.35109999f,0.23089998f,-0.66059999f,-1.01169999f,0.31300000f,0.61489997f,0.70949999f,0.97759997f,-0.19770001f,0.08759999f,-0.74889999f,0.79929999f,-1.25419998f,-1.80099998f,1.15639999f,0.82950000f,-0.15670003f,0.72889999f,0.14959998f,0.99320000f,-0.34650001f,0.46359998f,0.47469995f,0.34219998f,-0.12509996f,-0.88750000f,0.62170000f,1.07409999f,-0.12860000f,0.89869999f,-0.85899999f,0.25140000f,1.60430002f,-0.93140000f,-1.48220003f,-0.03540000f,1.14610001f,-0.23180000f,-1.76640003f,0.37880001f,0.04280002f,0.33679999f,1.20739999f,0.32319999f,0.09450000f,-0.02840000f,0.42259999f,-0.46140000f,-1.04999998f,-0.39580000f,-0.12210002f,0.35380000f,0.04950002f,-0.51199999f,0.80139997f,-0.35240000f,-1.53539998f,0.14620000f,0.99250000f,1.13780001f,-0.22360002f,-1.47130001f,0.11350006f,0.35120002f,-0.16020001f,-1.43200003f,0.66940003f,0.61260001f,-0.47030002f,0.99219999f,-0.39650001f,0.01429999f,0.63299996f,0.08379999f,0.13370000f,-1.18469999f,0.49680000f,-0.07560001f,-0.08549998f,-0.29260000f,0.32489998f,0.44069999f,-0.21019998f,-1.50719997f,0.74760000f,0.60369999f,-0.36310000f,0.30590001f,1.59340003f,-0.07020000f,-1.30880001f,0.55060000f,0.38420002f,0.65180001f,0.13440002f,0.10640000f,0.34680000f,0.60040000f,0.24169999f,-0.26560000f,-0.16249998f,0.50400000f,0.32020001f,0.66740001f,0.57590006f,0.01580000f,-0.11439999f,0.00120001f,0.31789999f,0.45159999f,-0.91959998f,0.53280002f,-0.11169997f,-0.33560001f,0.05889999f,0.13800000f,0.95770001f,-1.95970002f,1.00660003f,0.53519999f,0.42589998f,0.39049999f,0.78609998f,0.87650001f,0.28349999f,0.81549999f,0.63119996f,-0.08729999f,-0.70499997f,0.28230001f,0.51319997f,0.11050000f,0.33310000f,-0.39760000f,0.86690000f,0.28500001f,1.06199999f,-0.19099999f,1.16509995f,0.78609998f,-0.18720002f,0.76610003f,-0.89079998f,0.13419999f,-0.59950000f,0.43980000f,0.58489998f,0.42299999f,-0.69250000f,0.19199999f,0.38200002f,0.05120001f,0.14890000f,0.28879999f,0.02220003f,-0.50520001f,-1.62389998f,0.22099999f,0.73949993f,-0.46300003f,-1.15340001f,-0.18040000f,0.60879999f,0.05380000f,0.35710003f,-0.44460001f,0.57299997f,-0.65299999f,-0.33930001f,-0.15640000f,-0.70449998f,-0.28100000f,-0.66450000f,0.11239999f,1.58809997f,-0.10260002f,0.55789997f,0.02290000f,-0.58760000f,0.18930001f,0.70689997f,-0.19029999f,0.41929998f,-0.84740000f,0.02950001f,0.98019996f,-0.63859999f,-0.85249998f,-0.83110001f,0.75710002f,-1.08150001f,-0.47730000f,-0.62160001f,0.08410000f,-0.04149999f,-0.74529998f,0.24730002f,-1.13670000f,0.21780000f,0.01290000f,-0.05159999f,0.90829998f,-0.63189999f,-0.86170000f,-0.61490000f,-0.12080001f,-0.33009998f,-0.65620001f,-0.24100002f,0.10220001f,-0.62129997f,-0.33440001f,-0.91339997f,0.84620000f,-0.27750004f,-0.26920002f,-0.40590000f,-0.52020001f,-1.08330004f,0.05520001f,0.63790002f,0.56959999f,1.15740000f,0.09560002f,0.47730004f,-0.85019999f,-1.30480002f,0.57420000f,-0.10489993f,-0.36820000f,0.14109995f,0.73980000f,0.14790004f,-0.13949997f,-0.05590001f,-0.75510001f,-0.33769997f,-0.92349998f,0.65669998f,-0.69810002f,-0.33019998f,0.04819996f,0.41180001f,-0.20410001f,-1.00990001f,-0.80950001f,-0.46569998f,0.18160001f,-0.87010001f,0.81250001f,0.52929995f,0.13419999f,0.52390000f,-1.68350002f,0.25850007f,-0.57589997f,1.00969996f,0.67439997f,0.21970003f,-0.36730000f,0.83959997f,-0.52399997f,-0.95170004f,0.52580001f,-0.77710000f,0.02499999f,-0.09069999f,0.62220001f,0.36540000f,0.23640000f,0.79410002f,-0.29320000f,-1.02960001f,0.48960001f,1.52299997f,0.39379999f,0.13070002f,0.14000001f,-0.64360002f,-0.49939999f,-0.09020000f,-0.58439999f,0.56759999f,-0.50059999f,-0.45210003f,-0.48540001f,0.28819998f,0.33300001f,0.05690007f,-0.41980000f,0.11669998f,-0.58290002f,0.16710000f,0.34320001f,-0.96049999f,0.77140002f,0.02569998f,0.70960000f,-0.59720001f,-0.32980001f,0.04010002f,1.44579998f,-0.62970000f,-0.15429999f,0.33639998f,0.05259998f,0.30500000f,-0.03009998f,-0.98989998f,-0.09229996f,-0.46309998f,-0.40700000f,0.10950001f,-0.13950000f,-0.81059998f,-0.97149998f,0.42179999f,-0.09900001f,0.35540003f,-1.39409998f,-0.52370001f,0.34560000f,0.17260004f,-0.10939999f,0.42019998f,0.04740000f,-1.37310002f,-0.02700000f,1.63839998f,-0.52819998f,-1.81699997f,0.26620000f,0.84030005f,0.56380002f,0.59170004f,-0.05699998f,-0.63979996f,-0.12220000f,-0.74869996f,0.10500000f,0.70550000f,0.11880003f,-0.62899998f,-0.29419999f,-0.65840000f,0.82360001f,1.21080001f,-0.34300000f,-0.97840003f,-0.16619999f,0.47959998f,1.18819999f,0.19139999f,1.46860002f,-0.41239999f,-0.05509998f,-0.13980000f,-0.71960000f,-0.24340000f,-0.02870000f,-0.23279999f,-0.09180002f,-0.50720000f,-0.70000002f,0.80399996f,-0.94810005f,0.14700001f,-1.09650003f,0.19979999f,0.30769999f,0.41519997f,0.72479997f,0.56199998f,-0.18910004f,0.34899998f,-0.14950000f,-0.00060000f,-0.50100001f,-0.30780000f,-0.79550001f,-1.12839999f,-1.11469999f,-0.65100000f,0.49710000f,0.12380002f,0.07540002f,-0.42839999f,0.12810000f,-0.44599999f,-0.62629999f,-0.66620000f,-0.85970002f,-0.13690000f,0.28950001f,0.01640000f,1.12389999f,0.50500001f,-0.35649997f,0.19170002f,0.75529999f,0.29239998f,1.04540000f,0.59789999f,-0.26339999f,0.89589999f,1.26519997f,0.31519998f,0.54650000f,0.29899999f,0.95219998f,0.20580001f,1.39600000f,-0.09220000f,0.99030000f,0.63799997f,0.45129995f,-0.26739999f,0.55299998f,-0.36579998f,0.36179999f,-0.09080000f,0.58060002f,0.24739999f,0.74499999f,-0.84299995f,-0.34680000f,-0.18480000f,0.46200000f,-0.19659999f,0.93350004f,-0.67099999f,-0.75499994f,-0.06180000f,-1.21219996f,-0.29679998f,-0.03629999f,0.55130000f,0.81159999f,0.84610000f,1.03739999f,0.76910000f,0.60629998f,0.31379999f,0.24680000f,0.27069999f,0.77340000f,0.38879999f,0.07679999f,-0.39290001f,-0.64810001f,0.71880001f,1.14359997f,0.25289998f,-0.51810001f,-0.69239998f,-0.89159997f,-0.75849997f,-0.89149997f,-0.38339999f,-0.41149999f,-0.74939999f,-1.11570000f,-0.82059999f,-1.19239996f,-0.67139999f,-0.24389998f,-0.22219998f,-0.44080002f,-0.67459997f,0.34510000f,0.04340000f,-0.17130001f,-0.06700000f,0.02740003f,-0.66639998f,0.58320006f,0.05380001f,-0.13150001f,-0.15060000f,-0.91410002f,-0.04499999f,-0.75470002f,-0.34179999f,0.92310000f,0.07860001f,0.37829999f,0.54419999f,-0.84140003f,0.12580000f,0.13879997f,-0.06579999f,0.37410003f,0.74999997f,-0.29880002f,0.26360003f,-0.45079997f,0.62480001f,0.52529999f,0.73500001f,0.78030001f,0.51240001f,0.12710000f,0.66399999f,1.03079998f,0.16909998f,-0.25749999f,-0.49900000f,-0.03340000f,-0.04560001f,0.56719999f,0.95729999f,1.07389998f,0.52619999f,-0.54490003f,0.19530001f,-0.61799999f,-0.98410001f,-0.77670000f,-0.73390001f,0.13930000f,0.08360001f,-0.43330001f,-0.61960000f,-1.11419999f,-0.02240000f,-1.84770000f,-0.29580000f,-0.40560000f,-0.44139998f,-0.32620001f,-0.00660001f,-0.57969999f,-0.35099998f,0.60150003f,0.00579998f,1.51410003f,0.23279999f,0.14639998f,-0.33140000f,-0.96630003f,-0.59739999f,-1.22360003f,-0.40519998f,-0.73089996f,0.75419999f,0.52369998f,0.03880001f,0.85659999f,-0.74179999f,0.27920003f,0.16540000f,0.27429999f,0.67029999f,0.42020000f,0.36039999f,0.12549996f,-0.11870001f,0.21710003f,-0.46609999f,-0.14150000f,0.08660001f,-0.46419997f,-0.62869999f,-0.65160000f,-0.01080000f,0.58729997f,-0.06200003f,0.41240000f,0.70410002f,0.11170000f,-0.00750000f,0.08360000f,-0.30570003f,0.63909997f,0.54830001f,0.21530002f,-0.30959999f,-0.51309999f,-0.19849998f,-0.85370001f,-0.28540000f,-1.03070000f,-0.13440002f,0.11610002f,0.20760000f,1.18360002f,0.61959997f,0.51439997f,-0.09540000f,-0.61449998f,0.52099997f,-0.66820005f,-0.59359999f,1.18270002f,-0.07819999f,0.51570000f,-0.71339999f,-0.01589998f,0.60479997f,0.38490001f,0.82939996f,0.71630000f,-0.34360000f,0.05760002f,0.51859999f,-0.45960005f,-0.20479999f,-0.71760003f,0.32300000f,-0.68400003f,-0.20380003f,0.66989998f,0.42319998f,0.70399999f,0.25459999f,-0.54580000f,-0.70310001f,-0.39509999f,0.26059999f,0.95769997f,1.04940001f,0.79180001f,-0.21510002f,-0.15789999f,0.50349999f,0.80619996f,0.86139998f,0.65639999f,-0.17120000f,-1.11270000f,-0.59439999f,-0.70559998f,-0.46710000f,0.21950000f,0.00179999f,0.45130000f,0.57810002f,0.26350000f,-0.05239999f,1.06770006f,0.20020000f,-0.08629998f,-0.19679999f,0.06240004f,0.69779999f,0.45490001f,0.26739999f,-0.15900002f,-0.06900001f,-0.56450000f,0.40780000f,0.19109999f,-0.53199999f,0.25170003f,0.13600000f,-1.02380002f,0.11519999f,-0.34930002f,0.20339999f,0.19450002f,0.81739996f,-0.08510002f,-0.26220000f,0.40539999f,-0.82279999f,-0.11120000f,-0.04700000f,-0.22120002f,0.10370003f,-0.03919999f,0.66940000f,0.46199998f,-0.71300001f,-0.58509999f,-0.31069998f,-0.39079998f,-0.46329998f,0.16850000f,0.78920000f,1.13810000f,0.70309999f,0.26450000f,-0.10409999f,-0.85409999f,-0.44830001f,0.49289999f,0.50889999f,1.20179997f,0.58039995f,0.66299998f,0.21859999f,-0.88509999f,-0.40539999f,-0.24969999f,-0.47820000f,-0.43480000f,-0.30059998f,-0.62090003f,0.25320000f,-0.70160002f,0.77279995f,0.43249999f,-0.37360000f,0.64930001f,0.40339997f,0.58949996f,-0.27499998f,-0.36279997f,-0.01880001f,-0.95720000f,-0.33799999f,0.11300002f,0.36840000f,1.14140001f,0.14439998f,0.16570001f,-0.23559998f,-0.03999996f,-0.78799997f,0.01050004f,0.57699997f,-0.11560001f,0.48379998f,-0.52790004f,-0.38760000f,-0.18320000f,-0.08180003f,-0.24020000f,-0.74070001f,-0.58700000f,-0.56320000f,0.11600000f,-0.55879998f,-0.77079996f,0.34230002f,1.31209999f,0.80420001f,0.10310000f,-0.54900001f,-0.75519998f,0.20580000f,0.28429996f,-0.90330004f,-0.83440000f,-1.47470001f,-0.92259999f,-1.17280000f,-0.51529999f,-0.22079999f,-0.05450000f,-0.24780000f,-0.67740000f,0.00820000f,0.82119997f,0.94619999f,0.34060002f,-0.09660001f,1.34640005f,0.06039999f,1.21180002f,-0.06440000f,0.85179999f,0.13380000f,-0.23890002f,-0.14300001f,-0.27800000f,0.41019999f,0.10209999f,0.13120000f,-0.03209996f,0.90479999f,1.12630001f,0.29180001f,2.05940001f,0.07480000f,1.57710002f,-0.23020000f,-0.02139999f,-0.21460000f,0.29870001f,0.14319998f,0.13140000f,-0.08119999f,-1.67540002f,-0.43490000f,-0.98699997f,-0.47709999f,0.08470000f,-0.60610001f,-0.73420000f,-0.57780001f,-0.58720003f,-0.45390002f,-0.38430001f,-0.29480000f,-0.24719998f,0.05660001f,0.64830001f,-0.70620001f,-1.15589999f,-1.35390000f,-0.85720000f,-0.49100000f,0.10730000f,-0.04040002f,-0.28580003f,0.55799999f,1.02769997f,0.22890001f,-0.54169998f,0.08770002f,-0.03909999f,0.44540000f,-0.40310001f,-0.16580000f,0.92770003f,0.02840000f,0.76550002f,-0.01960001f,-0.16639999f,-0.18259998f,0.65750004f,-0.10259999f,0.48550003f,0.42439999f,0.31249999f,0.02500000f,1.22300002f,0.23719999f,1.80390002f,0.26040001f,0.09069996f,-0.17140000f,-0.87550004f,-0.92399999f,-0.07649999f,-0.78559999f,-0.13059999f,-0.49759998f,-0.52959999f,-0.15579999f,-0.11109999f,-0.38979999f,-0.59909998f,0.24940000f,0.65709998f,0.36090001f,0.03270002f,-0.68219997f,-0.65669997f,-0.14079998f,-0.16119999f,-0.59949999f,-1.30639997f,-0.38700002f,1.28819996f,0.54219998f,-0.45420001f,-0.36409999f,-0.33589999f,-0.71680000f,-0.70910000f,-1.04440000f,-0.34869999f,-0.01779998f,0.20860002f,-0.04080001f,0.67799999f,-0.25430000f,-0.75949998f,-0.76529998f,-0.45140001f,0.02460000f,-0.88420001f,-0.49359998f,0.39059999f,-0.01860001f,1.08999998f,0.05220000f,0.05810000f,0.60939999f,-0.15680000f,0.82519998f,0.12700001f,-0.76999997f,-0.41379999f,-0.17539999f,0.64370000f,0.12940000f,1.11100000f,0.45179999f,1.22539998f,-0.26139998f,0.98690002f,0.61919998f,0.45480000f,-0.14619999f,0.57290001f,0.10279999f,0.66790001f,-0.45740002f,-0.82750000f,0.12629999f,1.19720001f,0.38940001f,-0.40090000f,0.08450000f,1.14420001f,0.49870001f,-0.61940001f,-0.51709998f,-0.86459998f,-0.64569999f,0.16450000f,0.10320000f,0.20000000f,0.71250000f,1.11039997f,0.80070000f,0.17970000f,-0.17160000f,0.07229999f,0.28880001f,0.00500001f,0.19420000f,1.16919997f,0.40379998f,-0.49449999f,-0.38260000f,1.04290002f,0.38560000f,0.12710002f,0.10399998f,-0.26810000f,0.37319999f,0.00449999f,-0.51100000f,-0.92820003f,-0.11860000f,0.15539999f,0.22220000f,0.90049998f,-0.28859998f,0.31569999f,-0.09740000f,-0.48660002f,-0.25259999f,-0.44610000f,0.31019998f,0.00639998f,-0.38939998f,0.33150001f,0.58159996f,0.08619999f,-0.33479998f,-0.36589999f,0.12220000f,1.24000001f,-0.09030001f,1.28860001f,0.58490002f,-0.09100000f,-0.17379999f,0.12360000f,-0.01239999f,-0.09520000f,-0.73690000f,-0.31729999f,-0.09100000f,-0.01770001f,-0.06980001f,-0.22360000f,-0.38200002f,0.00709999f,0.67100000f,0.89460000f,0.48860000f,0.56869999f,-0.12800002f,0.66239997f,0.12369997f,-0.43830001f,0.01880001f,-0.63490000f,-0.69200001f,-0.68329999f,-0.64429999f,-0.34200001f,-0.70779999f,-0.26360002f,-0.43999999f,0.56859999f,-0.61479999f,0.90100003f,0.09300000f,1.46890000f,-0.17699999f,-0.10859998f,0.02700000f,-0.12909999f,-0.19999999f,0.28290001f,-0.74259998f,-0.22609998f,-0.49519999f,0.94310001f,-0.04980000f,1.19670000f,-0.70099995f,-0.09930001f,-0.36900000f,-0.28319997f,0.65259999f,-0.11039999f,0.20679999f,1.13130002f,-0.48959999f,0.24230000f,0.36200001f,-0.19500000f,0.31339999f,0.24429998f,-0.18130002f,0.29419998f,0.90989999f,0.83489999f,0.15270001f,-1.00749996f,-0.19429998f,0.12259998f,0.08379998f,-1.08280001f,-0.74750003f,-0.34830001f,0.17190001f,0.04920001f,0.04199999f,0.65849998f,0.41499998f,0.67889999f,0.70060000f,0.12910000f,-0.46249998f,-0.94189996f,-0.41089999f,0.86379996f,-0.53899998f,-1.10050002f,-0.35319998f,0.01290000f,0.03440000f,0.54530000f,-0.47899997f,-0.90849999f,-0.14679999f,-0.50000002f,0.40279998f,-0.79590003f,0.08920002f,-0.89759999f,0.80099999f,-0.39150001f,-0.02879999f,-0.00329999f,0.52959999f,0.61990002f,0.33859999f,-0.54580001f,-0.36659998f,-0.54220000f,0.22319999f,0.36460000f,0.48639998f,0.62060000f,0.48449999f,0.32849998f,0.86369999f,0.49880000f,0.47119998f,0.62829997f,0.87520000f,0.49440000f,0.26040002f,-0.22429996f,0.56290005f,-0.03510000f,0.89350003f,0.25290000f,0.03860000f,-0.73750001f,-0.79630000f,-0.52540000f,-0.57410002f,0.31149999f,1.02730000f,1.49300001f,0.90320000f,0.53049998f,0.53020001f,0.21450003f,-0.44080000f,0.25489999f,0.88969999f,-0.05539996f,-0.19639997f,-1.14289999f,0.21439999f,-0.65110002f,-0.44699998f,-1.20430002f,-0.21160000f,-1.02390004f,-0.71120000f,-1.50240006f,-0.10160000f,-1.92300006f,0.21579999f,-1.02760003f,0.23919999f,0.95310000f,0.02420002f,1.42250002f,-0.18400000f,-0.79289999f,-0.23240002f,-0.95670002f,-0.81019996f,0.66900004f,0.38899997f,0.52879997f,-0.83959997f,-0.66009996f,0.06470000f,0.00870001f,0.40780003f,-0.51429999f,-0.43180001f,-0.77400000f,-0.69580001f,-0.68510000f,-0.01159999f,0.27140001f,-0.66269999f,-1.36539996f,-0.94989998f,0.04450000f,0.20230000f,0.22600000f,0.45100001f,-0.20180001f,0.12319999f,-0.20000001f,-0.32010003f,0.23950000f,-0.11919999f,-0.27139999f,-0.10570002f,0.36689998f,0.75989999f,0.58870001f,0.77149999f,-0.69540004f,-0.63540000f,-1.36680002f,0.00980001f,-0.16809998f,-0.04520000f,0.36310002f,0.07700000f,-0.08530000f,0.14139999f,0.52060000f,0.40619997f,0.71509999f,-0.40959997f,-0.01370000f,-0.26600000f,-0.90660000f,0.38719998f,-0.37119996f,0.76099999f,0.79890002f,0.48779997f,-0.01630001f,0.52739999f,-0.64370000f,-0.61079997f,-0.09179995f,0.14799999f,-0.39739999f,0.02519999f,-0.32640002f,0.18430001f,-0.15439999f,-0.14099999f,0.40610000f,0.08600002f,-1.17000000f,0.02239998f,1.06079994f,0.51299996f,-0.52850001f,0.01329998f,0.47549998f,0.69629998f,1.31139998f,1.17349999f,1.02349998f,0.53099999f,0.16970001f,0.03609998f,0.79459998f,0.45379998f,0.12400000f,-0.50600001f,-0.80499999f,-0.18970000f,0.21039998f,-0.32250001f,-0.68060002f,1.53679999f,-1.18810001f,1.03979999f,0.87320003f,-0.82280001f,0.82200001f,-0.53239998f,-0.40679999f,0.49559998f,-0.28960000f,0.05320000f,0.82840001f,-0.98320002f,-1.17269999f,1.44559998f,-1.48740005f,0.15800000f,-0.99400004f,0.41620001f,-0.22899997f,0.21059996f,0.35180003f,-0.28580002f,-0.53700000f,0.60699999f,-0.36910001f,-0.04160000f,-0.02920004f,-0.85730001f,-0.18310001f,-1.43640005f,-0.28250000f,-0.51020000f,0.19990001f,0.42750005f,0.27140000f,0.61760003f,-0.03530000f,-0.75750001f,-0.29590000f,-1.96360006f,-0.35760001f,-0.43720003f,0.23050000f,1.29550004f,0.16810001f,-0.30349994f,-0.22059999f,0.37380002f,0.27150000f,1.21340006f,0.20470001f,-0.19109998f,-0.19170000f,1.08619999f,0.32780000f,0.57030003f,-0.51970001f,0.98760001f,-1.31420004f,1.41919999f,0.19550001f,-0.39200002f,0.29730006f,0.35919996f,0.22310000f,-0.24680001f,-0.01670001f,0.62120000f,-0.92460005f,0.77980003f,-0.11399999f,-0.02600002f,1.74160000f,-1.45399998f,0.48590002f,0.17059998f,0.83990003f,-0.66880000f,2.00930005f,-1.25860000f,0.24660003f,-0.00939999f,0.84459998f,-1.55199996f,0.36020001f,0.41550002f,0.14550001f,1.74350005f,0.20690001f,0.72770005f,0.23830000f,0.79540002f,0.05910000f,0.83670002f,0.08560001f,0.14140001f,0.08930000f,-0.74140003f,-0.32770001f,0.44729996f,0.35430000f,0.61660001f,-0.29930001f,-1.54730003f,-0.22769999f,-1.81149999f,-0.19429999f,-0.55850001f,-0.15390000f,-1.11530004f,-0.38090001f,-2.29170003f,-0.22040000f,-0.20970003f,0.92450000f,-1.18859998f,1.78890001f,-1.23180000f,1.33560001f,-0.58359999f,0.52310000f,-0.31340000f,1.23400002f,-1.04999999f,0.84040004f,0.09140000f,-0.58300004f,0.44480002f,0.45389996f,-1.33939997f,0.20839997f,0.35840002f,-0.70439999f,1.17779997f,-1.60550000f,1.02479998f,-1.31600003f,0.33440000f,-1.09540004f,1.25360001f,-2.03179999f,1.48679997f,-0.42500001f,-1.31820003f,-0.25199999f,0.20140000f,0.01110000f,1.23540002f,0.19150001f,0.16140004f,-0.01150000f,1.23840001f,0.26490000f,0.43040003f,-0.02990000f,-0.36410001f,0.12680000f,0.38880000f,0.05830000f,1.23320000f,0.16830000f,-0.13780004f,-0.37880001f,-1.19300004f,-0.01049999f,-0.40700001f,-0.21460000f,-0.85390002f,-0.16830000f,-1.02480004f,-0.09350000f,-0.69100002f,-0.72100000f,0.18479998f,-0.14660002f,-0.95439997f,1.31360002f,-0.84680002f,0.48360001f,-0.31359999f,1.06640000f,-1.21019998f,0.66560004f,0.46639998f,0.12790004f,0.35559998f,0.54339999f,-0.87299998f,1.41889998f,-1.48119998f,0.13479994f,0.19420005f,-1.33590002f,0.90300000f,-1.03420002f,0.98979999f,0.28459999f,-0.43799999f,-0.12460000f,0.55680001f,-0.29850001f,-0.00080000f,0.04760000f,0.72219998f,0.17739999f,0.44150002f,0.31240001f,0.53240004f,-0.06830000f,-0.70459998f,-0.06810000f,-0.41330003f,-0.42640001f,-0.51240004f,0.27610000f,0.38610000f,-0.09670000f,-0.00539999f,0.25060000f,0.86640002f,0.30450000f,1.45649999f,0.17239999f,0.33120001f,0.21150001f,0.28120004f,-0.25760000f,-1.48170004f,-0.26710001f,-0.34560002f,0.27289999f,-0.69480000f,0.42170001f,0.18460003f,0.17880005f,0.19099994f,0.00710002f,0.14280000f,-0.99329997f,0.50779997f,-0.78420003f,0.38000000f,0.76990001f,-0.35039998f,1.14829999f,-0.82220000f,0.22290005f,0.23019998f,-0.37119996f,0.34139998f,0.81680000f,-0.65299997f,0.30150002f,-0.07680002f,-0.46670001f,0.40619999f,-1.41680005f,0.82880002f,-0.48590003f,-0.02700002f,0.32090000f,1.38410002f,0.18320000f,0.11840002f,0.04310000f,-0.21130000f,-0.04810000f,0.72639998f,0.29709999f,1.73110005f,0.40470001f,0.97280006f,-0.18660000f,-0.03280003f,0.31919999f,1.50640000f,0.21540000f,-0.05670001f,-0.30810001f,-1.50540004f,-0.02690000f,0.43159999f,0.00530000f,0.24130001f,-0.06420000f,-0.30030000f,0.05130000f,0.06770001f,0.35330001f,-0.54279998f,1.00690000f,-0.84319999f,-0.36889998f,0.95020000f,-0.86700000f,0.56319999f,0.51189998f,-1.10279998f,0.89290003f,-0.65500002f,0.58670002f,0.03900000f,0.71189999f,-0.81239997f,0.60769998f,-0.80879999f,-0.77230002f,1.33280000f,-1.74900000f,1.00699998f,-0.26460001f,-0.31880000f,1.17520001f,-0.74060001f,0.64150002f,-0.38680001f,0.22809999f,-0.98870000f,-0.01760000f,1.10330003f,0.41999999f,0.57239999f,-0.29340000f,-1.32540002f,-0.00250000f,0.14670000f,0.00730000f,0.77910004f,0.35080001f,1.40960003f,-0.02360000f,-0.76340000f,-0.17040000f,0.06220000f,0.28340000f,1.44910001f,0.33160000f,1.53110002f,0.03320000f,-1.09040002f,-0.16490001f,-0.31020002f,0.06030000f,-0.28570002f,-0.32200001f,-1.62950006f,-0.73070003f,-0.11320000f,-0.21249998f,-0.08400001f,-0.11119999f,0.54299999f,-0.63559997f,0.62579997f,0.15830000f,-0.19280000f,1.00070003f,-1.35339999f,0.83270001f,-0.46940000f,-0.65369999f,1.11900000f,0.13580002f,-0.24380002f,1.39570000f,-1.43439996f,1.80770000f,-0.90919997f,-0.57639999f,1.08799999f,-1.14390000f,0.47439998f,-0.62820003f,0.12680001f,-1.43250002f,0.57720000f,-0.06050000f,-1.00110003f,-0.13620000f,-0.53920002f,0.06280000f,-0.77329996f,-0.20109999f,0.44120003f,0.36910000f,1.51940005f,0.21250000f,-0.40379999f,-0.26060000f,-0.02590003f,0.39440000f,0.49389999f,-0.12090000f,-1.57580002f,-0.23120000f,-1.53710003f,-0.21070000f,-1.02870003f,-0.13630000f,-0.62340002f,-0.13600001f,-0.01500005f,0.21840000f,0.94350002f,0.31070001f,0.38620000f,-0.28219997f,0.81519999f,0.11810002f,-0.01480001f,-0.43749997f,0.96739996f,0.61330002f,-1.60720000f,0.66440004f,0.23439999f,-0.82970001f,0.74079999f,-0.67680000f,0.14980003f,-0.58120002f,1.27980000f,-0.83220000f,1.23679998f,-0.45359999f,0.57799999f,-0.25690001f,-0.20319999f,-0.46279998f,0.96839998f,0.28049996f,-1.05159996f,-0.00800002f,-0.43850000f,-0.37690000f,-1.06480003f,0.07220000f,-0.67150001f,-0.23580000f,-1.48780009f,-0.32330001f,-0.79880005f,-0.08190000f,-0.99760001f,0.00100000f,1.04180005f,0.29990001f,-0.57319997f,-0.28400000f,-1.72520006f,-0.15040000f,-0.83410003f,-0.08490001f,-0.25790005f,-0.40100002f,-0.30690008f,0.12159999f,-0.40550001f,-0.34380000f,-1.15840002f,-0.12090000f,0.94700003f,-0.84179999f,1.03939998f,-0.19079998f,0.03260000f,-0.37979999f,0.86000000f,-0.95780007f,0.34300005f,-0.24930002f,0.63720001f,-0.62480000f,0.30919998f,0.49040004f,-0.46520003f,-0.44679996f,1.48739999f,-1.08780001f,1.25159999f,-0.47360005f,-0.41639999f,0.16699994f,-0.15719996f,1.40079998f,-1.42579998f,0.55060001f,0.35300000f,-0.33470002f,-0.22000000f,1.35720002f,-0.93090001f,-0.24750000f,0.09419998f,0.03620000f,0.41800003f,0.08550000f,-0.86809997f,-0.19949999f,-0.71329999f,0.10810000f,-0.55509998f,-0.20859999f,0.67219998f,0.21380000f,-0.00280000f,-0.22510000f,-0.80710001f,-0.03150000f,-0.90760001f,-0.07250000f,-0.67250002f,-0.15390000f,-0.43749996f,0.29620001f,1.35210004f,0.21790000f,-0.24169998f,-0.20200000f,-1.43800002f,-1.03610001f,0.49959999f,0.24999997f,-1.05179997f,0.76500004f,0.21679995f,-0.33239997f,0.76719997f,-0.88479999f,0.36459999f,-1.87259999f,1.73399997f,0.62919997f,-1.70799995f,0.50849998f,0.36580001f,-0.34500000f,0.56439999f,-0.79010000f,1.07160000f,-0.32700002f,0.41359999f,-0.02839995f,0.15719997f,0.75560002f,-0.70140000f,-0.12619997f,0.95699998f,-1.25879998f,-0.07190000f,-0.12020000f,0.50080001f,0.41460001f,1.12430004f,0.01040000f,0.81620002f,0.21730001f,0.03800001f,-0.28870001f,-1.34290004f,-0.21710000f,-0.51730001f,0.00790000f,-0.10699998f,0.03670000f,1.08290000f,0.29050000f,1.12500004f,0.16830000f,0.45130000f,-0.09630000f,-0.17829999f,0.21000000f,1.52580001f,0.30460000f,0.34480002f,-0.14210000f,-0.00130001f,-0.29310000f,1.21420000f,0.37040002f,-1.34480002f,0.09570004f,0.70699999f,0.89970001f,-1.52500001f,0.04119999f,0.49060001f,-1.11050001f,1.07219998f,0.02379999f,-0.17440000f,0.44650000f,-0.26620000f,1.09619998f,-1.35739997f,0.59040002f,-0.02200001f,0.29219999f,-0.25399999f,-0.05249996f,0.34599996f,1.05560000f,-1.39479997f,0.14950000f,0.55760000f,0.20950001f,1.13720000f,0.22130001f,0.43300004f,-0.15380000f,-0.52990001f,-0.11720000f,-0.62030001f,0.04190000f,-0.40290000f,-0.09230000f,-0.86380001f,-0.07710000f,0.12179998f,-0.08720000f,-0.76400002f,-0.25650000f,0.14169999f,0.17180000f,0.96630005f,0.27530000f,0.72040001f,0.05450000f,-0.72330002f,-0.30150001f,-1.17340005f,-0.03350000f,-0.54060002f,-0.19260000f,-0.35190000f,0.69830000f,-1.71940002f,1.03280003f,-0.05320001f,0.68160000f,-0.30840000f,0.36460003f,0.29380000f,0.18040002f,0.49759998f,-0.33860002f,-0.22719997f,-0.01680000f,0.32079999f,0.34109997f,-0.43359997f,1.22360001f,-1.13240001f,1.50490005f,-0.32800001f,1.59209998f,-0.88739996f,0.28459995f,0.19080002f,-1.13020001f,0.92240001f,-1.27830002f,0.76139999f,-0.05059996f,-0.14079999f,-0.07790000f,-0.67890000f,-0.26900000f,0.11939999f,0.16999999f,0.18589999f,-0.05450000f,0.53290001f,0.19540000f,-0.01749995f,-0.21600000f,-0.60340003f,-0.02480000f,-0.32790002f,-0.13090001f,-0.64970006f,-0.18900001f,0.03360000f,0.22220001f,1.13850003f,0.36250000f,1.39990002f,0.08250000f,0.60900003f,0.12220000f,-0.46239997f,-0.16199999f,0.20750001f,0.55869999f,-0.48440000f,-0.09690004f,-0.24799997f,0.33029999f,-0.00380000f,0.72829996f,-0.55619996f,0.80749997f,-1.11979998f,-0.66699997f,1.28899995f,-0.94740006f,-0.40079995f,-1.50340005f,1.50820002f,-1.28080007f,0.16780003f,-0.34939998f,0.31759998f,0.44300003f,-0.45999999f,0.86749998f,-1.02039997f,0.36740002f,-0.01180001f,-0.96239996f,1.27339996f,0.36530001f,0.40960000f,0.01340000f,0.71730002f,0.19620000f,1.38110001f,0.08650000f,0.46590000f,0.02500000f,0.22900003f,-0.30419999f,-1.11780003f,-0.16960001f,0.53670001f,0.10790000f,-0.07470001f,-0.22760001f,-0.68990004f,-0.08610000f,-0.51350000f,0.08120000f,1.29230003f,0.38560001f,1.83130003f,-0.04710000f,-0.03389995f,0.24610001f,0.52250002f,-0.16160000f,0.03179999f,0.89499999f,-0.56939996f,0.23149999f,-0.58000000f,0.88779998f,-0.85079997f,0.60369997f,-0.88839999f,0.31540002f,-0.09700004f,-0.45480003f,-0.41779999f,-0.36090002f,-0.32680000f,-0.97240004f,0.74860002f,-0.56490002f,0.86300000f,0.40990000f,-0.31819999f,1.34790003f,-1.90160002f,1.63220000f,-0.86639996f,0.70600007f,0.11039994f,0.81710000f,-0.61579998f,1.01149998f,0.99680004f,-0.23250000f,-1.07690003f,-0.26310000f,-0.86110003f,-0.24760000f,-1.59610006f,-0.24490001f,-0.19520001f,0.14290001f,-0.78689998f,-0.32110000f,-1.05230004f,-0.11140000f,-0.19859999f,-0.00300000f,-0.26280002f,-0.02140001f,0.42169998f,0.19070000f,0.84190000f,0.28030000f,0.34570001f,0.03490000f,0.59879999f,-0.08520000f,0.44280002f,0.27780001f,1.67900005f,0.46240001f,-0.41920001f,-0.71480003f,0.27040001f,-0.88240001f,0.92360001f,-1.03230003f,0.66800001f,-0.24689999f,-0.21180002f,-1.12529996f,1.73299995f,-0.45180002f,-0.23059999f,0.47130000f,-0.35800001f,-0.51170002f,0.15720002f,-0.82439999f,0.63380001f,-0.12569998f,0.11119998f,-0.59270000f,0.41500000f,0.19089996f,-0.74219996f,0.82210004f,-0.47500003f,1.22020002f,-0.76590003f,-0.29810001f,-0.46850002f,0.07840000f,0.31230000f,0.00350000f,-0.91010002f,-0.25300001f,0.52309993f,0.28819999f,0.31749996f,-0.31960001f,-0.01880004f,0.01260000f,0.72639999f,0.25030000f,1.44040002f,0.20810001f,0.71890004f,0.08040001f,0.68400002f,0.20480000f,0.27659999f,0.06960000f,-0.44330002f,-0.36130000f,-0.80450004f,0.23230000f,-0.50080002f,0.01120003f,-0.59990002f,0.26510000f,-0.62599999f,0.30940001f,-0.09009999f,0.09180001f,0.80979999f,-0.07539998f,-0.56489998f,-0.10390000f,-0.74010001f,-0.27210001f,-0.08979999f,0.68710000f,0.63360002f,1.06579999f,-0.09119999f,0.45689998f,0.00050000f,-0.21849999f,0.00770000f,-1.18759995f,1.06639999f,-0.88409996f,0.00209999f,-0.13119997f,0.78750001f,0.72510000f,0.06120000f,-0.03990002f,-0.03899997f,1.56150001f,0.12559998f,0.78119998f,0.03570002f,-0.90220003f,-0.89560001f,0.58949998f,-0.60320000f,0.35000002f,0.69910002f,-0.15600003f,0.84950000f,-1.04130000f,0.18860004f,1.52349996f,0.55719999f,-0.07230003f,0.13280001f,-0.80339999f,1.09750002f,0.30390002f,-0.80160001f,0.52100002f,0.57539998f,0.92159999f,0.48420002f,-0.10190001f,-0.23500001f,-0.33979999f,0.72359999f,-0.90910000f,0.42889999f,0.37050001f,-0.60850002f,-0.02680002f,0.57949997f,0.99319997f,0.39590001f,1.18449998f,-0.47270001f,-1.27570003f,-0.92419999f,-1.41609998f,0.78779997f,-1.60789999f,0.07399998f,-0.62259998f,-0.20190000f,-0.45580000f,0.10860000f,-0.39660000f,0.62590001f,-0.25689998f,0.64820000f,-0.86499997f,0.41679996f,-0.80319998f,-0.91969997f,-0.83399997f,1.46340005f,1.23160000f,-0.24810003f,-0.26560001f,0.35559998f,1.92740000f,0.07870002f,-0.78540001f,0.91480006f,0.69090001f,-0.77300001f,0.24330000f,1.64360006f,0.71989999f,0.56310001f,-1.25250006f,0.19090000f,1.28519998f,-0.22420000f,0.46090000f,-0.07669999f,1.09230001f,0.41650001f,0.59680004f,0.31220003f,-0.40050001f,-0.63709998f,-0.49690003f,-0.12530000f,0.76409998f,0.23440000f,-1.21100002f,-0.19470000f,-0.47099998f,0.96620001f,-0.92100000f,-0.34990000f,-0.35020001f,0.20350000f,-1.23440004f,0.55859999f,0.06100001f,0.13720000f,-0.94930001f,-0.90670003f,0.02010002f,0.42360000f,-1.15949999f,0.32129999f,-0.73950000f,0.85530000f,-0.69390001f,0.55420002f,-1.09680003f,-0.24799997f,2.23960005f,-0.11760003f,-0.23949999f,-1.23770001f,0.50750003f,1.90790006f,0.81259999f,-1.09930004f,1.42110002f,-0.30420002f,-0.64359998f,0.04100000f,-0.37220000f,0.33239999f,-0.31210001f,-1.19860002f,-0.49659999f,1.12600002f,-0.78879999f,-0.53340001f,-0.65780000f,0.87800000f,0.23099994f,0.33099998f,-0.67680004f,-1.86670004f,-0.45690000f,1.53060000f,1.03690002f,1.14330002f,0.43189996f,-0.33809998f,-0.21430001f,0.60810001f,0.54400003f,-0.14160000f,-0.76929997f,0.78400001f,-0.89100000f,-0.02790000f,1.06320002f,-0.15280000f,0.06979999f,-0.25370000f,-0.56800001f,0.27730000f,1.01340000f,-0.56779998f,0.59740001f,-0.40659999f,0.28860003f,-0.31980002f,-0.66709997f,-0.75500001f,-0.67579998f,0.30079998f,0.22659998f,-0.48150001f,1.83429996f,0.66530001f,0.55139998f,-0.97950003f,1.94410002f,-0.04730001f,-0.57960000f,-0.95260001f,0.21759999f,-1.20210002f,0.43760000f,0.78269998f,0.07349997f,1.36910002f,0.63439993f,-1.70180004f,-1.59469999f,1.12650003f,-0.62870002f,-0.47080002f,0.63879999f,1.79330004f,-0.38330006f,-0.53850001f,1.42369998f,-0.80089999f,-0.74129996f,-0.10730002f,-0.02819999f,1.01439999f,-0.15959995f,0.03340000f,-0.03699998f,1.14260002f,0.98420001f,-0.52359998f,1.12850000f,0.00680000f,0.60439999f,0.42430000f,-0.51680000f,0.03599999f,0.13250006f,-0.23280002f,-0.91370000f,-0.53350000f,0.62169999f,-0.55410001f,-0.61850000f,0.49469999f,-0.19399997f,-0.72420003f,-0.89669998f,0.70609999f,-0.26250001f,-0.12669999f,0.76939995f,0.98250002f,-0.78720003f,-0.05080000f,0.59380001f,-1.27310001f,1.02160002f,0.84050003f,1.39689998f,0.99629998f,-0.23770003f,-1.47149998f,0.56690003f,-0.59629998f,1.36069998f,-0.39999999f,1.09779999f,-0.10180001f,-1.92630001f,-0.61540000f,0.42199999f,-1.45789999f,0.85110003f,0.74710003f,1.41169997f,-0.59789998f,0.43049998f,-0.11400000f,0.41770002f,-0.20170001f,-0.66739999f,-0.62060001f,-0.70220000f,0.35440001f,0.58840001f,0.89490001f,0.63430002f,0.54659999f,-1.48830000f,-0.37870000f,-0.28329998f,0.71030000f,1.34749998f,0.97569998f,1.03679999f,0.65349999f,-0.07900003f,-0.94270001f,0.67149999f,0.45289999f,1.29589996f,0.88380001f,1.13299996f,0.54669999f,-0.85089998f,0.41929997f,0.47020001f,0.31100001f,-0.51990000f,-0.97350003f,-0.31729997f,2.05730007f,-0.08420002f,0.80369999f,-1.30600002f,-0.24040003f,0.87190001f,-0.10629996f,0.73289998f,1.21529998f,0.73439995f,-1.43230002f,-1.67169999f,0.41050004f,-1.03320002f,0.17119999f,-0.77070002f,-1.93400003f,0.40230003f,0.06030000f,-0.20740000f,-1.38769997f,-0.38429998f,-0.06220002f,-0.08549999f,2.12280004f,-0.69840005f,0.91160003f,-0.35040003f,0.22430001f,-0.02030000f,-0.43940002f,-1.40240001f,-1.02030001f,-1.68619998f,0.73270000f,0.04670003f,0.64309998f,1.09039999f,-0.14980000f,-0.65820000f,-0.72000000f,0.58269998f,-0.61980002f,0.78249998f,-0.70050000f,0.28550000f,0.63840000f,1.18139998f,-0.04400000f,0.51099997f,0.27439998f,-0.07330006f,0.48000000f,0.01910000f,-0.68090002f,-0.80679997f,-0.05199999f,-0.47440000f,-1.40190002f,0.18330002f,-0.26180003f,-0.09020000f,0.44160000f,-0.24360000f,0.39960004f,1.79269997f,0.12589999f,1.44069999f,-0.60170003f,-0.87159999f,-1.38110003f,0.00950005f,0.92380004f,-0.61949999f,0.28780000f,-0.45520003f,0.32280006f,1.92329995f,0.46700000f,0.51279994f,0.88000009f,1.96839999f,0.41029998f,-0.66090000f,0.44120004f,0.07090000f,-0.20700000f,0.65029999f,0.53580000f,1.30350000f,0.13450001f,0.58400001f,-0.27079999f,-0.07030000f,0.68709998f,-0.23439996f,0.43790000f,-0.29739999f,-0.53519999f,-0.15370004f,0.54780002f,0.36729999f,-0.25320000f,-0.79370003f,-0.04570002f,0.24880001f,1.04269997f,-1.42330000f,0.39349997f,-0.83799996f,1.01679997f,-1.31610003f,-0.28400001f,-0.62119998f,-0.90029998f,-0.60409997f,0.88440005f,0.80369999f,-0.75850003f,0.27170002f,2.46730002f,-0.83470004f,-1.85570001f,0.62130009f,0.12320002f,-0.68269997f,-0.45420002f,1.41880001f,0.84600003f,-1.13930004f,-0.58410000f,0.01200001f,-0.19350003f,-0.34150002f,0.56060002f,1.14460001f,-1.29030001f,-0.61499997f,0.37570001f,0.78169997f,-0.94649999f,-0.83279999f,-1.37650007f,-0.06340003f,-0.01659999f,-0.46020003f,0.52459997f,-0.74570001f,0.69230000f,-0.09949997f,-0.85150001f,-0.29299997f,0.76570004f,1.53679997f,-0.41219999f,0.24089997f,0.84690001f,-0.09000000f,-0.88050002f,0.82640000f,-0.19840000f,0.33999998f,-0.39560001f,-0.25899999f,0.26330001f,-0.16220003f,-0.17029999f,1.26529997f,0.11999999f,1.01950000f,-0.66140000f,1.16409999f,1.08159997f,-0.39290005f,-0.62090002f,-1.45769999f,1.11430004f,-1.64130005f,-0.91830002f,-1.71169995f,1.17499999f,0.22179998f,-0.52080001f,0.58780000f,-0.14949999f,-1.50039997f,-0.02530001f,-0.44980002f,-1.22780001f,0.39710000f,1.34420003f,-0.02309999f,-1.35000002f,-0.13440001f,0.54910000f,0.67459991f,0.15740003f,-0.44600002f,0.31120004f,-0.34259996f,0.16439995f,-0.06440002f,-0.57570002f,-1.22300000f,-0.55450000f,0.20409997f,-1.07530003f,-0.28290002f,-0.60329999f,0.79250000f,-0.16870000f,-0.28909997f,0.29940000f,0.65419999f,-0.94549998f,1.28749996f,-0.64070000f,-0.17010001f,0.35769999f,-0.10060001f,-0.38159999f,-0.26540001f,0.16249999f,-0.71350001f,0.56209995f,-1.32139999f,0.21499998f,0.49479999f,0.03060001f,0.81749997f,-1.16730003f,0.41320002f,1.07090000f,-0.85050000f,-0.72709996f,0.04650001f,0.25860002f,0.80400000f,0.35990002f,1.79860004f,-0.45030002f,-0.08910003f,0.56210007f,-1.73350000f,0.70279996f,0.62359995f,-0.57710001f,0.36439999f,-0.11480000f,0.98250003f,0.17370002f,0.88120003f,0.49750001f,0.73350004f,0.19400005f,1.18720001f,-0.75390006f,-0.37570002f,0.24820002f,0.57699998f,0.27750001f,-0.36290005f,-0.73459999f,-0.05240002f,0.08370000f,0.13049998f,0.34650000f,-0.05919998f,0.71590002f,-1.22690004f,0.13099998f,0.23269999f,-1.01810001f,0.54409999f,-0.10070001f,-1.35629998f,0.31929999f,-0.55690000f,0.81670002f,-0.48589999f,0.76920001f,-0.94660000f,0.69580002f,0.22680003f,0.76249999f,1.37939999f,-0.18899999f,1.24860004f,-2.03359999f,0.65230000f,1.27990000f,0.16969998f,-0.84040000f,-0.81049998f,-0.83019998f,-0.07889999f,1.13029999f,-0.28060001f,0.43620001f,0.90179999f,-0.93180001f,-1.20859997f,0.94210003f,1.47330002f,-0.40980000f,0.80870000f,0.88599999f,-0.89409998f,0.33630000f,1.07520001f,-0.28239997f,0.73810000f,0.72539999f,-0.80939999f,0.35100003f,-1.22509999f,-1.85030003f,-0.28399999f,0.79679999f,1.52379996f,-0.39209999f,-0.23000001f,-0.52219999f,-0.21460000f,0.28159998f,0.44009998f,-0.38160000f,-0.58249998f,0.24580000f,-1.12470003f,-0.25519999f,0.41890000f,0.73840001f,-0.61579999f,0.63859999f,-0.44240000f,-0.53499998f,-0.68159999f,0.59820001f,-0.44319998f,0.59469999f,-0.42370001f,-0.43609999f,0.21690000f,-0.81049999f,1.18699997f,-0.74269995f,0.45450004f,0.92630000f,0.36710000f,-0.91530001f,1.34509999f,-0.49180000f,0.48410000f,-0.29870002f,-0.95669997f,-0.74440001f,-0.63469998f,0.47460002f,-1.72379997f,0.74550002f,0.02800000f,-0.71420002f,-0.45370000f,-0.95890000f,0.21430003f,1.30240000f,-0.71010002f,0.08660002f,-0.90309998f,-0.17510000f,-0.60419999f,-0.63590002f,0.12870000f,-0.29399999f,-0.01500000f,0.70250000f,1.34179998f,-0.08330000f,-0.59120000f,0.93249998f,0.28780000f,0.52579999f,1.17979999f,-0.45749998f,0.21009997f,-0.01180000f,0.90299997f,-0.98589998f,-0.42980004f,-0.15550000f,0.03370000f,-0.13789999f,0.97400000f,0.35210001f,-0.47880003f,-0.53540001f,-1.12329998f,-0.34240000f,0.47009999f,-0.19960000f,1.22720000f,0.14140000f,-0.47820003f,-0.40130001f,-1.10820000f,0.52490004f,-1.03369996f,-0.30860002f,0.02480003f,1.12430002f,-1.53940000f,-0.68650001f,-1.43249995f,-0.32510002f,-0.01979998f,1.18139998f,-0.92509997f,0.46940000f,-0.25109997f,-1.59200003f,1.01899999f,-0.02269998f,-0.61500001f,-0.85990004f,0.34039999f,1.14310002f,-0.30459998f,-0.67380000f,-1.16770001f,-0.51670001f,0.06560000f,-0.01060002f,-0.57499999f,-0.12940001f,1.02049998f,-0.51879999f,-0.16390002f,0.24990001f,-0.04159999f,-1.01070000f,0.19999997f,-0.66439998f,0.61929996f,0.11220001f,-0.42390000f,-0.71829998f,0.03260004f,-0.50179997f,0.13569999f,0.77350000f,1.28730003f,-0.47010001f,0.69530000f,0.21990000f,-0.34580002f,-0.49249998f,-0.18290001f,-0.61790001f,0.11209998f,0.25899999f,-0.11390003f,-1.72060001f,0.41599999f,1.25040000f,0.97679997f,-1.48890004f,-0.27789996f,1.52020006f,0.73759998f,-2.06289999f,-0.29079998f,0.70749998f,-1.90149998f,1.62330001f,-0.39490007f,0.16169998f,0.79859996f,0.21850003f,1.25749999f,-1.04889999f,0.55160003f,-1.06790000f,0.27980002f,-0.54469999f,0.00609999f,0.46669997f,-1.80249998f,0.05420001f,-1.13230002f,0.67690000f,0.76619999f,0.71779998f,0.46410000f,0.37739999f,-0.88250001f,0.47760002f,1.19520002f,0.11389999f,-0.62850002f,0.50389998f,0.97509996f,-0.88059999f,0.17490002f,-0.67310003f,-1.21089996f,0.24139999f,-0.72629997f,0.55719999f,0.42140000f,0.42640001f,0.98749996f,0.41030000f,0.49509996f,0.32759997f,0.79859997f,-1.02749998f,0.01319997f,-0.61340001f,-0.24179999f,0.41460000f,-0.15180001f,0.03709994f,-0.09450000f,-1.02109998f,-1.07159999f,0.70679997f,0.39399999f,-0.22370002f,0.01500004f,0.50630002f,-1.58279999f,0.31740000f,0.11020001f,-0.96049998f,1.15380005f,-1.38500002f,0.70079999f,-0.53610003f,-0.36869995f,0.40740000f,1.03810000f,0.09400003f,-1.95019998f,1.49230001f,0.39709997f,0.04589999f,-0.23340001f,0.44349999f,-0.23520002f,0.79540001f,0.60800004f,0.88599999f,0.12160004f,0.06430000f,0.19519997f,-0.59419999f,-0.77090002f,0.52249998f,0.61969997f,0.81519999f,1.39300005f,0.34539999f,-0.33849997f,-0.43050000f,-1.50520002f,0.14210000f,-0.32630000f,0.03410000f,0.52959997f,0.26359999f,1.22449997f,-0.72629999f,-0.45190005f,0.05990000f,0.51540001f,-0.55029999f,-1.15320004f,0.70560000f,0.37540000f,-0.58589998f,-0.45820002f,-0.59560001f,-0.32100000f,0.62560000f,0.57740001f,-0.62630000f,-0.31160000f,0.93879997f,0.56499998f,0.20010001f,0.29260000f,-1.16860001f,-0.51220000f,0.15900002f,-0.55780001f,-1.29910001f,-0.71219999f,0.24950001f,-0.02059998f,-0.31560000f,-0.62020001f,0.34989999f,0.08619999f,-0.93339999f,-0.71000000f,-0.32310001f,0.50890002f,0.42720000f,0.70850002f,-0.41139998f,-0.03830002f,-0.32919999f,-0.64670001f,0.60230001f,0.35150005f,-0.64709997f,-0.89199997f,-0.26630001f,-1.10040002f,0.70100000f,0.75210003f,0.71879997f,2.55490001f,-0.55189997f,-0.13360001f,-0.33159999f,0.24350001f,-0.10850000f,0.60219999f,-0.17020000f,0.36750001f,-0.64710000f,-0.56270006f,-0.68610000f,-0.27510004f,-0.67100000f,-0.31779999f,0.24899996f,0.17219999f,0.77680003f,-0.13600002f,-1.01420002f,-0.24100000f,0.16680000f,-0.42800002f,-0.92600003f,-0.15340000f,0.21600002f,-0.36480002f,-0.97570004f,-0.46700001f,0.48500002f,-0.26060001f,-0.48680001f,-0.05679998f,0.95800003f,0.05999999f,-1.47280000f,-0.58600001f,-0.15100001f,-0.39280001f,-0.80570002f,-0.59160002f,-0.80760003f,0.60090003f,0.46179998f,0.71450003f,-0.18770000f,0.49770001f,0.23450001f,0.14440001f,0.09360000f,1.25899999f,-0.58070001f,-0.90980005f,0.08619999f,1.04300002f,-0.05060000f,0.19890001f,-0.83030000f,0.05799998f,0.08970000f,0.10549999f,0.70510000f,1.78730005f,0.03090000f,-0.10790001f,-0.39889999f,0.44350000f,-0.82599999f,-0.51780002f,-0.67860002f,-0.20280004f,0.16040005f,-0.13620003f,0.03659994f,0.52639998f,-0.92729999f,-0.28800001f,0.86890002f,0.04839999f,-0.54419999f,-0.13100001f,-1.39900003f,-0.41859999f,1.60700002f,0.67960002f,-0.87470002f,-0.35800000f,-0.14570001f,-0.00619999f,0.74140001f,0.22280000f,0.65390001f,0.51520001f,0.01390003f,-0.11119998f,0.02100001f,0.15640002f,-0.65229999f,-0.06379997f,-0.03210001f,0.09090003f,-0.61149999f,-1.46270003f,0.51959997f,0.01900002f,-0.72470001f,-0.05210006f,0.63140000f,0.80210002f,-0.48670000f,-1.03040004f,-0.39060000f,-0.15900001f,0.21710000f,-0.36110002f,0.12759999f,0.23170002f,-0.66360000f,-0.80880003f,0.50649998f,0.16790000f,0.40849999f,0.43429997f,0.56290001f,0.76230001f,0.82400000f,0.51770005f,-0.69359997f,-0.77410002f,-0.33889999f,-0.26620002f,-0.23069996f,-0.03600000f,0.10159998f,0.01139997f,0.30210000f,0.70000000f,0.49980001f,0.56079999f,-0.33130000f,0.17139999f,-1.10479999f,-0.65899999f,1.48710002f,0.34960000f,-1.40240001f,0.04440001f,0.89700002f,0.10000001f,-0.41740000f,-0.35900000f,0.27900003f,-0.04739998f,-0.12190000f,-0.26600002f,-0.46490001f,0.19280000f,0.33249997f,0.31830000f,-0.65709999f,-0.68570004f,0.21790000f,0.51580000f,-0.72050001f,-1.86030005f,0.66989998f,-0.12089999f,0.24500000f,-0.65309998f,-0.36689999f,-0.44240004f,-0.18800001f,1.01499995f,0.75590000f,-0.43169995f,0.00429999f,0.42470000f,0.53460000f,0.93570002f,-0.50850000f,-0.02980005f,0.87260001f,1.73760005f,-0.40459998f,-1.06279997f,-0.13370000f,-0.78469999f,0.14409999f,-0.01239999f,-0.22570000f,-0.37720001f,0.79599999f,0.47259999f,-0.59879998f,-0.38460002f,-1.05350002f,-0.54160000f,0.67570000f,0.31199999f,0.21839999f,0.15759998f,0.11250001f,0.25099998f,-1.04280000f,0.05000003f,1.06500001f,0.23980000f,0.37129996f,0.43499996f,-0.05070000f,-0.10880003f,-1.05829997f,-0.31959999f,0.62080000f,0.26419999f,-1.31689999f,0.10609997f,0.52469999f,1.20790003f,-0.32710001f,-0.31760001f,-0.69540000f,-1.10530006f,-0.21159999f,0.20319998f,0.30319998f,0.84860003f,-0.69089999f,-1.34050002f,-0.72719997f,-1.42489999f,-0.35559998f,-1.67579999f,0.44800000f,0.91690004f,-0.39949998f,-1.25019997f,-0.77429999f,-1.22470002f,-0.13260000f,-0.34179999f,-0.49069997f,-0.38699998f,-0.18419999f,-0.63740002f,-0.75580002f,-0.21160000f,0.27200002f,-0.33280000f,-0.37399999f,-0.19539997f,-0.75039999f,-0.87159999f,0.76209998f,0.17679999f,0.66850000f,0.27559998f,-1.01490000f,0.23940001f,0.61090001f,0.18200001f,1.03860000f,0.58000000f,-0.30989999f,0.11780000f,0.42689999f,0.35000000f,-0.30940001f,0.16140000f,-0.93030002f,-0.62580000f,0.68360001f,-0.10859999f,0.10740004f,-0.15539996f,-0.54810000f,0.17769996f,0.52490001f,1.09840003f,0.81120000f,2.12380003f,-0.87879999f,-0.24220005f,-0.54269997f,-0.69730002f,0.66339998f,-0.49169997f,0.29379999f,0.28060002f,0.45050001f,0.34190004f,0.80589999f,0.16180005f,-0.71709999f,-1.41110002f,0.05230000f,-0.85479996f,-0.55929997f,-0.81019998f,-0.91980000f,-0.10770005f,0.63399999f,1.49460001f,0.59369999f,0.47960000f,-0.21400000f,0.11300000f,0.55930001f,0.40500001f,-0.11870000f,0.00640000f,0.36289999f,-0.18680003f,-0.05619995f,0.05720000f,-0.57500002f,0.28160001f,-0.53370003f,-0.19140001f,0.09480001f,-0.11939999f,-0.59850004f,-0.50940000f,1.09890001f,-0.04160003f,-2.07329999f,-0.99500000f,0.54120003f,-0.41920002f,-1.36990003f,-0.48139999f,0.30690002f,-0.80560000f,0.19440000f,-0.57969997f,-0.67569999f,-1.36500002f,-0.14010000f,-0.64010003f,0.28219999f,1.12919999f,-0.17039999f,0.01060000f,0.08700001f,-0.76440001f,0.43169999f,0.13720004f,-0.86000001f,-0.89830004f,0.03450000f,0.42039999f,-0.29310000f,0.97150000f,-0.59609997f,-0.72480002f,-0.58659998f,1.19840001f,-0.63309996f,-0.79539999f,-0.03460000f,1.31109999f,0.28499999f,0.35660000f,-1.11030000f,-0.98140001f,0.13629999f,-0.04799999f,-0.43269998f,-0.51799998f,0.96170000f,0.43159999f,0.24959997f,0.47780000f,-0.21480000f,-0.27700002f,-0.12320000f,0.19480002f,1.27500001f,0.70800000f,-0.48060000f,0.09100001f,0.15500001f,-0.20140002f,-0.03350003f,0.50659999f,0.73960000f,0.27499998f,0.67990002f,1.00520000f,0.07810001f,-0.31799995f,-0.18599999f,0.14449999f,-0.63199997f,0.01200003f,-0.90599999f,-0.73600009f,0.71289999f,1.42810007f,-0.71490000f,-2.00360004f,0.39460000f,0.47730003f,-0.61940000f,-1.01440004f,0.78840001f,0.82140007f,0.48530001f,-0.36419999f,0.44070000f,1.13800002f,0.13080000f,-0.48309996f,0.07620000f,-0.12630000f,0.28560000f,-0.86679995f,0.82710000f,-0.15519996f,-0.54420000f,-0.34599998f,-0.40440002f,-0.05079998f,0.61049999f,0.11720002f,0.02500002f,0.16600003f,1.00120000f,0.02580000f,-0.10719999f,0.01039999f,0.46379999f,0.69500001f,1.04739999f,0.65379999f,-0.73499998f,-0.12720000f,0.03270000f,-0.15780001f,0.19199999f,0.33100001f,-1.48300000f,-1.02779999f,-0.40210000f,-0.44039999f,0.78680000f,0.15999999f,0.45789999f,0.14179998f,0.56920000f,0.77260004f,0.07959999f,0.32439999f,0.80590001f,0.60890010f,0.08099999f,0.68569997f,0.36909999f,0.47250000f,-0.14750000f,-1.00839999f,0.83379999f,0.37810003f,0.89729999f,0.38530004f,-0.36579999f,-0.05330001f,0.51509999f,0.45220002f,-0.22319999f,-0.10370004f,-0.76469997f,0.05630002f,-0.65839998f,-0.35039997f,-0.17600000f,-0.80600001f,0.15820002f,0.25619999f,-0.84070004f,-0.33780001f,0.99270001f,0.42599999f,-0.52319999f,-0.33540002f,0.48480002f,-0.01380003f,-1.69870006f,-0.50860001f,0.86760002f,0.50720002f,0.69550002f,0.02140001f,-1.25900001f,-0.52180001f,-0.09720001f,-0.34080002f,-0.68170001f,-0.53920001f,-0.81410002f,-0.73540002f,0.83150002f,0.10779999f,0.66719997f,0.85420000f,0.30250005f,0.44320007f,-0.13870000f,-0.47780002f,0.57789997f,1.16090005f,0.00960000f,-0.14549999f,-0.19889999f,0.56840002f,-0.16530000f,-0.65740004f,-0.37189999f,-0.34689996f,0.77590001f,1.25380002f,0.46860000f,0.58470001f,-0.42769999f,0.28790001f,-0.81020001f,-0.53460005f,-0.84200000f,-0.21050004f,-0.85800001f,-0.12030005f,-0.51009997f,-1.68060001f,0.31459999f,-0.19150000f,0.78669998f,0.40659998f,0.53149999f,0.31999998f,-0.33309999f,0.29180000f,-0.49619999f,-0.21579999f,0.62379999f,0.11000000f,-0.27569999f,-0.37440001f,-0.90280004f,-0.09320000f,0.71280002f,-0.32660002f,-0.64120001f,-0.25380001f,-0.52020000f,-0.23219999f,0.07349999f,-0.46440002f,-0.18330001f,-0.13440001f,-0.68440000f,-0.29219999f,0.98460000f,0.46800001f,0.87099998f,1.38850006f,-0.75209997f,-1.42650001f,0.75179997f,0.10870004f,0.44569998f,0.26520002f,-0.51469997f,-0.24970000f,0.45539999f,1.06080000f,-0.01010000f,-0.33309997f,-0.25160001f,0.79650000f,-0.44350000f,-0.38860003f,-0.60989999f,-0.70100002f,0.28649998f,1.43129998f,-0.47070001f,-0.17830003f,-0.54899999f,-0.75210001f,0.16629999f,0.42310001f,0.71219999f,0.19240005f,0.27549999f,0.10759999f,0.77030001f,0.32760000f,-1.03090001f,-0.47440002f,0.24959999f,0.22660000f,0.34400000f,0.56520001f,-0.60690002f,-0.15100000f,1.01460000f,0.59540001f,-0.61910001f,-0.63460001f,1.09510000f,0.64000001f,-0.08870001f,0.17039999f,-0.98320001f,-0.58259999f,0.05300001f,-0.16579998f,0.81399999f,0.34040001f,0.75530000f,0.49660000f,-1.52330002f,-0.50689999f,-0.78889997f,-1.10250001f,0.39350000f,0.32410001f,-0.83509998f,-0.97820000f,-0.48019998f,-1.59219999f,0.34709998f,-0.33980000f,-0.34050000f,-0.66999998f,0.75579998f,1.11810002f,0.08040000f,0.41780003f,0.14370000f,-0.74169999f,-0.37190000f,-0.49600004f,0.28839999f,1.12090002f,0.01270000f,0.12610001f,0.08200000f,-0.43649999f,-0.01660000f,-0.52090000f,-0.41720000f,-0.01999997f,0.94129999f,0.34820000f,-0.51719999f,-0.37019999f,0.34630001f,0.14500003f,0.55029998f,0.42660001f,0.27979999f,0.04720000f,-0.52229999f,-0.33079998f,1.26350001f,0.43940001f,-0.20910005f,0.09259997f,0.63750006f,0.71260003f,-0.08440002f,0.16339999f,-0.58420001f,-0.33780001f,0.69560000f,0.57920002f,-0.52230001f,-0.29080000f,-0.10350002f,-1.02060001f,-0.36929999f,-0.49399998f,0.34319999f,0.31090002f,-0.45560000f,-0.36470004f,0.76820000f,0.57490006f,0.37989999f,0.23430002f,-0.16460000f,-0.14560002f,0.51799997f,1.32749998f,0.73469998f,0.39479999f,-0.61490000f,-1.60380001f,0.57580002f,-0.10389998f,-0.11369999f,-0.13160000f,0.49189997f,0.53950002f,0.48340000f,0.18800002f,-0.42799999f,-0.77000000f,0.21590000f,0.27720000f,-0.44119998f,-0.50200001f,-0.65840003f,-0.07060000f,1.01640003f,0.07299999f,-1.11640003f,-0.07980001f,0.43450001f,0.29780003f,0.47140002f,-0.21679998f,-0.17619999f,-0.36560000f,-0.13730000f,-0.26620002f,0.46720001f,0.53199999f,-0.28380003f,0.23419998f,-0.38460000f,-0.04179999f,0.51959999f,0.49440002f,-0.13320001f,-0.09259999f,0.41440002f,-0.24689996f,-0.78689996f,-0.82990003f,-0.20139999f,-0.36169998f,-0.86850001f,-0.49000007f,0.22000001f,-0.58049995f,-0.91649997f,-1.58459998f,0.43249998f,1.08269995f,0.74670001f,1.81210001f,-0.05310000f,0.68819999f,-0.26659999f,-0.60859997f,-0.21899998f,-1.38989998f,-0.40899998f,-1.09149998f,-0.49519997f,-1.17779997f,0.75189997f,0.59560001f,0.31980000f,1.26420001f,0.58980002f,0.60220000f,-0.36800000f,0.01740000f,0.44509999f,0.63560000f,-0.78209996f,-0.64999998f,-0.49110003f,-0.39220000f,-0.18209999f,-0.08779996f,0.60039998f,-0.11080000f,0.51180002f,0.21779999f,0.31799999f,0.55920000f,-1.00090001f,-0.15420000f,0.30159998f,-0.25340001f,-0.51520002f,0.13340001f,0.76570002f,-0.23020000f,0.40679999f,0.34039999f,-0.44720000f,-0.77700002f,-0.16889999f,-0.36249999f,-0.30660000f,0.69270000f,0.34829997f,0.50870001f,-0.92089996f,-0.69379998f,0.42560000f,-1.01050001f,-0.19409997f,0.16169999f,-0.34440001f,1.24910001f,-0.38870003f,0.40279999f,0.11089997f,0.25559999f,-0.05950000f,-0.48479999f,-0.74759996f,0.15420002f,-1.20309995f,-1.06439999f,-0.27669998f,0.80200002f,-0.62140002f,0.77259999f,-0.83980002f,0.30160000f,-0.24770002f,-0.58760002f,0.13189997f,-0.35919999f,0.07710000f,0.58340001f,0.03290001f,-0.20180000f,-0.19500003f,0.75899999f,0.90610000f,0.10679999f,0.52350000f,-0.78880002f,-2.02390000f,-0.65140000f,0.77489997f,-0.74079999f,-0.33710002f,0.11060002f,0.01650000f,-0.73400001f,-0.83030001f,0.29660001f,0.94530000f,-0.71659998f,0.34620000f,-0.21540003f,-0.21530000f,0.30889999f,-1.03710000f,-0.45680001f,-0.44599998f,-0.36670003f,0.38720000f,0.80809999f,-0.08329999f,1.03879999f,-0.06700003f,-0.16860003f,-0.30519999f,-1.79239999f,0.33890002f,0.12789998f,-0.92289997f,-1.26739999f,0.21790004f,-0.36859998f,0.72119999f,-0.38969999f,-0.18510000f,0.64460000f,0.00359999f,-0.00099997f,-0.35899997f,-0.81409999f,0.33110001f,-0.47720000f,-0.76569996f,0.38259998f,-0.52650005f,-0.40260002f,0.36420000f,-0.30240000f,-1.13030002f,-0.52740000f,1.06940002f,-0.13080001f,-0.70690003f,-0.51080002f,0.12200000f,-0.28180001f,-0.15050005f,-0.44020001f,0.37170002f,-0.19740000f,-1.82780003f,-0.08820000f,0.76920000f,-0.62140001f,-0.49760003f,-0.29120000f,0.71019998f,-0.53560001f,0.54900001f,-0.78359996f,0.32760000f,0.20929997f,0.81259997f,0.24719997f,-1.16300001f,-0.99070001f,0.13600002f,0.49550003f,-1.22199997f,-1.15870001f,0.56980002f,-0.14640001f,-0.55690000f,-0.05940002f,0.30450002f,-0.38100001f,-0.66329999f,-1.54460003f,0.55510004f,0.59580001f,-1.05899999f,-0.63640000f,-0.16149999f,0.32090000f,-0.38189999f,-0.27009998f,-0.09080000f,-0.54620002f,-0.28140005f,-0.19220002f,0.83050001f,0.47519998f,0.32300001f,-0.13300000f,-0.23020002f,-0.28040002f,-0.66840002f,-0.13860000f,1.41950002f,-0.28919999f,-0.82190001f,0.79700002f,1.02300005f,-0.45440001f,-0.33579999f,0.30800002f,0.48590000f,0.17020000f,-0.45059997f,0.55340001f,-0.00039998f,-0.38259999f,-0.43160000f,-0.04799999f,-0.26359998f,0.24400003f,1.06150001f,1.51930003f,-1.43260003f,-0.43830003f,-0.10130001f,0.70920002f,0.03550000f,-0.51200002f,-1.06580000f,0.39310002f,-0.84850001f,-0.72629999f,0.74320000f,0.72610001f,0.21479998f,-0.37939999f,0.14250002f,0.47490001f,0.83340000f,-0.16829998f,0.32939999f,0.34010000f,0.30959999f,-0.37590000f,-0.56159996f,-1.09549999f,0.02720002f,0.62450002f,0.81610000f,-1.02129999f,-0.29550001f,-0.28740000f,0.53169995f,-0.19339999f,-0.87740000f,0.06659999f,1.05010000f,0.67060000f,-0.26279997f,0.57080000f,0.43620001f,0.30260000f,1.11970000f,-0.74799999f,-1.47510000f,0.06340001f,0.94840003f,0.23940001f,-0.40000000f,-0.01080000f,-0.51799999f,-0.31980000f,0.17889999f,-0.35240000f,-1.38810001f,-0.33720001f,0.77359997f,0.37619999f,0.56060002f,0.81820000f,-1.08409996f,-0.64089998f,-0.59199999f,1.12580002f,-1.11030000f,-0.26990000f,0.09099999f,0.95169999f,-0.29160001f,0.91220000f,-0.10380001f,-0.70389997f,0.01050004f,-0.41700001f,-0.97819996f,-0.56939998f,1.29570000f,-0.13810001f,0.17150001f,0.32150001f,-0.21699998f,-1.36470002f,-0.25869997f,0.35470000f,-0.91449998f,-0.22240001f,0.70389996f,0.09819999f,-0.02670000f,-0.12700000f,-0.73500001f,-0.40740001f,-0.74040001f,0.73320001f,1.18030000f,-0.55520001f,0.55409999f,-0.75760001f,-1.45540001f,0.58660000f,0.55420000f,0.31759999f,0.66679996f,0.31919999f,1.93610000f,0.11280001f,-1.30859999f,0.40140001f,0.26430000f,0.73739997f,0.92469997f,-0.24760002f,0.57059997f,-0.25379999f,-0.25260004f,0.34840000f,1.20250000f,-1.20290001f,0.29780002f,0.08110002f,-0.29959999f,1.46090000f,-0.34120002f,0.13139999f,-1.02729998f,-1.71449999f,-0.04629996f,1.12400000f,0.01249997f,1.52909996f,-0.62070000f,0.89749998f,-0.64100000f,-1.07880001f,1.27750000f,1.38069999f,-0.06460001f,1.78869997f,-0.15450003f,0.49959996f,-1.06889998f,-0.23480001f,-0.05629999f,0.53870000f,-0.19890003f,-0.22720000f,0.42650001f,-0.01100000f,0.15119998f,-0.60420001f,-0.28980001f,-0.40320000f,-1.14030000f,-0.83519998f,-0.60400000f,0.34300000f,0.27059997f,-0.00360001f,0.81040003f,0.37640000f,-0.20229998f,0.17020000f,-0.62340000f,0.49220000f,-0.23279999f,0.37660001f,0.76330001f,0.43540000f,0.59400001f,0.46099999f,1.15329998f,-0.40440000f,0.09249999f,-0.29840000f,-0.86930001f,0.30990001f,0.59669999f,-0.96940003f,-0.29839999f,-1.77250001f,0.51880001f,0.04440004f,-0.20629998f,0.59619997f,-0.22910000f,-0.13000000f,-1.00519997f,-0.66489999f,1.18569999f,0.00879997f,0.56100000f,0.03299998f,0.14850000f,1.37790002f,0.14789998f,0.48549999f,0.16199999f,0.94399996f,0.68769997f,0.36860000f,0.61710002f,-1.10880001f,0.14720004f,-0.94770000f,0.01369997f,0.57120000f,0.32600001f,0.38020001f,0.58389999f,0.56420002f,0.72070002f,-0.07320000f,-1.08239999f,-0.37360003f,-0.24600007f,-0.13159999f,0.75200002f,0.28140000f,0.02300002f,0.09679999f,0.79489999f,-0.08819999f,0.18170004f,-0.46100000f,-1.52290003f,-0.04460001f,1.63199997f,-1.05880000f,-1.39410007f,-0.50100002f,1.30659997f,-0.50280000f,-1.18610002f,-0.24130001f,0.29679999f,1.26410001f,0.29849999f,0.85970002f,0.19599999f,-0.12719998f,0.01520000f,0.42789997f,-1.35989998f,-0.16899999f,-1.22190000f,-0.70830000f,0.44979999f,0.94620002f,0.53529998f,-0.29190001f,0.47129999f,-0.43450002f,0.51980003f,1.08849996f,-1.17829997f,-1.10840000f,-0.11399994f,0.15689998f,-1.22060000f,-1.46660001f,0.52130002f,0.37049999f,-0.18290003f,0.58240000f,0.75970000f,-1.05840002f,-0.52590005f,0.26080002f,1.36100001f,-0.81779999f,-2.07200002f,0.73700000f,1.39100003f,0.51559998f,-0.31970001f,-0.26680001f,0.93969999f,0.06720000f,-1.33200001f,0.68299999f,0.66740002f,-0.01900000f,-0.84030002f,-0.43280002f,0.03090000f,0.66679999f,-0.20709999f,0.13679999f,0.09629998f,1.01539999f,-0.05759999f,0.28409998f,0.63929996f,-0.14210003f,-0.31969998f,0.45290001f,0.36350000f,-1.67219998f,0.17450004f,1.43390004f,-0.00670007f,0.24489996f,0.33589996f,0.99660000f,-0.77200000f,-1.29380003f,0.42890001f,0.75229999f,-0.26900003f,-0.22860001f,-0.00149999f,-0.07030000f,-1.03020001f,0.03669997f,0.48979996f,0.69739997f,-0.79849999f,0.17059998f,0.21859995f,1.41060002f,0.63750002f,-0.60159999f,-0.32399999f,0.07680001f,-0.08519996f,0.02340000f,-0.33080002f,0.37320002f,-0.69059997f,-0.13740000f,-0.44889999f,0.00140000f,0.52340000f,0.70839999f,-0.60009996f,0.51019999f,0.00950001f,-0.06120000f,0.26319998f,-0.39180002f,-0.73389999f,0.51040001f,1.05630003f,-1.04899999f,0.03109996f,-0.23519999f,-0.17260004f,0.30559999f,0.51680001f,-0.88860001f,-0.07749996f,-0.73419998f,1.12810000f,-0.79040004f,0.81910003f,0.02550003f,1.35049996f,0.24450000f,-0.41759998f,0.21040001f,-0.38080000f,-0.44810001f,0.73199996f,0.41549997f,-0.16560000f,0.55910000f,-0.09510000f,-0.89120000f,-0.32790000f,0.51349998f,0.28000000f,-0.23910001f,-0.13239992f,-0.54539999f,0.75480003f,0.39640000f,0.40499997f,-0.13829998f,-0.50650001f,0.32140000f,1.17050003f,-0.54140003f,-1.56130001f,0.51599999f,0.45779999f,-0.43020002f,-0.90530007f,-0.16300002f,1.24550004f,-0.47220001f,-0.05350004f,0.52660000f,-0.98200000f,-0.22839999f,0.13070001f,-0.51980001f,-0.39910003f,-0.22040000f,0.58339999f,-0.44080000f,0.48859998f,-0.65920001f,-0.67670003f,0.19220000f,0.60230001f,0.97480001f,0.08569999f,1.03160001f,-0.22540002f,-1.33230001f,0.28910002f,0.59019997f,-0.01050002f,0.13109998f,-0.55020000f,0.32380000f,-1.35440004f,-0.84550003f,0.27370004f,-0.71820003f,0.94409997f,0.25560000f,-0.80879997f,-0.45989999f,-0.05939998f,0.41150002f,-0.29890000f,0.11550002f,-0.21160000f,-0.24849998f,-0.09670000f,0.68419998f,-0.62460002f,0.61429999f,0.16810000f,0.64870002f,-1.95419998f,0.71700000f,0.98049998f,0.08279998f,0.07680001f,0.28140000f,0.04010002f,-0.05699999f,0.04689998f,-0.00840000f,-0.53700000f,-0.56300001f,0.55440001f,0.12399999f,-0.86600003f,-0.40260001f,0.31330000f,-0.17060000f,0.97729998f,-0.29299999f,-1.06889998f,-0.51540000f,-0.06740000f,-0.03880000f,1.09239998f,-0.33020000f,-0.66869999f,0.44360000f,-0.92899997f,1.49199998f,-0.00970002f,-0.14800001f,-0.60049999f,-0.35040000f,0.39189998f,0.49379998f,0.38109999f,-0.38070000f,-0.05899999f,-0.24859999f,-0.75519998f,-0.62510000f,1.13739999f,0.77630001f,-0.93430000f,0.04639999f,-0.28089999f,-1.11739997f,0.52190000f,0.22670002f,-0.60419998f,0.19119999f,-0.25370000f,-0.98869999f,0.52640001f,-0.37390001f,0.56949998f,1.95029998f,-0.19120003f,0.38579999f,0.47119996f,0.20820000f,0.07640001f,-0.41780001f,0.19799997f,0.40920001f,0.95609999f,0.67380001f,0.66500005f,0.02020000f,0.16869999f,0.64200000f,-0.03269997f,-0.81680002f,-1.16190002f,0.78620002f,0.48900003f,0.32939999f,1.29600001f,-0.74720000f,-0.76550001f,-0.10379999f,-0.51369998f,0.45840001f,-0.18519999f,0.60360001f,1.25210003f,0.78549998f,0.15129996f,0.23749998f,-0.52770001f,0.55569999f,-0.58769999f,0.56669999f,-0.06370001f,0.24370002f,0.59609997f,0.42950000f,0.72449999f,-0.25370001f,0.95619996f,-0.40210001f,-0.12479998f,0.33580000f,0.32549999f,1.10290001f,0.08069997f,-1.26670000f,0.34370004f,-0.63069999f,0.71209999f,0.41750000f,0.46419999f,1.08710000f,-0.05470001f,-0.01900002f,0.78059998f,0.24820003f,0.08100000f,0.41679999f,0.14750000f,-0.28239999f,0.38450000f,0.06040001f,-0.59309997f,0.54579999f,-0.22269998f,0.12440000f,0.77119999f,-0.50079999f,-1.53659998f,0.28580000f,-0.50369993f,0.23379999f,0.75789996f,0.72680002f,0.07710004f,0.20580000f,0.72449999f,-0.57180003f,-0.84909999f,0.66280002f,0.24020003f,-0.20000000f,0.70500001f,-0.38929998f,1.13800000f,0.22980000f,0.64409996f,0.34460002f,0.24639999f,-1.13510000f,0.76299999f,0.14900000f,0.95029995f,0.76469999f,0.12659999f,-1.24329996f,0.38910000f,-0.22659998f,-0.23830002f,1.20529998f,-0.42119999f,0.11980000f,0.18179998f,0.83390000f,-0.18980000f,-1.11240000f,-0.09840000f,-0.18050002f,0.68009999f,0.55490001f,0.20160001f,-0.50700000f,-0.25719998f,0.59860001f,1.02899997f,-0.65480000f,0.18120000f,0.28260001f,0.00129999f,-0.08160000f,0.60530001f,0.29139999f,1.20289996f,0.42140002f,-0.45589995f,-0.51099999f,-1.22220000f,-0.52339999f,-0.60460001f,-0.37160002f,-0.26590005f,0.67639999f,0.93900001f,0.41479998f,0.89069998f,0.14000000f,0.79869998f,0.52820000f,0.00480006f,-0.10600000f,-0.98590001f,1.68689998f,0.19459999f,-0.06449999f,-0.70199997f,0.30190003f,0.78369999f,0.30469999f,-0.73599999f,0.57689997f,0.82459997f,-0.32829999f,1.28689998f,-0.65360001f,-0.18089995f,-0.39519997f,-0.64279996f,-0.12800001f,-0.86909999f,0.74459998f,-0.26400005f,0.99539996f,0.05659997f,0.59359996f,0.31310000f,-0.51929999f,1.01469998f,-0.22070002f,0.70470001f,0.03540001f,1.14319997f,0.52140000f,0.25950001f,-0.15680000f,-0.32569996f,0.74939999f,0.40099999f,-0.81499998f,-0.36599999f,-0.27860000f,0.70230001f,0.01040002f,-0.81689998f,-0.07660000f,-0.55480003f,0.41560000f,0.74150000f,0.85380001f,1.96059998f,0.04360000f,-0.23570000f,-0.20980000f,1.33150001f,0.23439999f,-1.02970001f,-0.50220000f,-0.75710000f,0.18959999f,0.12960002f,-1.16440004f,-0.41820000f,-1.55280003f,-0.41279999f,-0.29860000f,-0.33719999f,0.23830003f,0.79999997f,-0.23720000f,-0.54799998f,-1.19209999f,-0.20459999f,-1.45900003f,-0.17999999f,0.29750001f,0.21860000f,0.72899999f,-0.24499998f,0.17050000f,-0.00680000f,-0.91449999f,0.23579999f,-0.99159997f,0.93339997f,-0.50270000f,0.16239999f,-0.08790000f,0.44319999f,0.73580002f,0.12750001f,-0.27289999f,0.24930003f,-0.41649999f,-0.19650000f,-0.14430000f,-0.35740000f,-0.00049998f,0.17590004f,-0.18559998f,-1.06499998f,-0.99869998f,-0.42769999f,0.00370002f,1.27040002f,1.48129998f,1.09170000f,-0.32969998f,0.16140001f,0.79170000f,0.14649998f,0.40329999f,0.52810000f,0.54529999f,-0.28910002f,-0.64650000f,-0.32730002f,0.12159998f,-0.06610003f,-0.93870005f,-0.23800000f,-0.66320002f,0.69959999f,-0.38480003f,0.40939998f,-0.16260003f,-0.59480000f,0.43170000f,0.41839998f,1.02609999f,-0.04879999f,-0.08420001f,-0.29900000f,-1.56280002f,-0.26359998f,-1.29200002f,0.75459996f,-0.12220001f,0.30799998f,0.41040000f,-0.19920000f,0.07840001f,0.34800000f,0.41260000f,0.25440000f,0.89270005f,0.66619998f,0.34440002f,0.97870001f,1.00809997f,0.38919999f,0.14610002f,0.10230002f,-0.38100000f,0.33670001f,0.47890000f,0.23740000f,-0.71580000f,-0.25350002f,0.63950001f,0.54260002f,0.07200000f,0.03090001f,0.11530002f,-0.11780000f,-0.01590000f,0.57560001f,1.01780002f,0.62240002f,-0.73739999f,0.10790001f,0.32640000f,-0.16700000f,-0.42160000f,-0.38030001f,0.14739999f,-0.02660002f,-0.74080000f,-0.21179998f,0.16279999f,-0.26119998f,-0.37290005f,0.35180000f,-0.96710004f,-0.00820000f,-0.54769997f,0.82899999f,-0.02889998f,-0.18699999f,-0.48210001f,0.34060000f,0.38310000f,0.41459999f,0.00539999f,0.28140000f,-1.05190003f,-0.48640000f,-1.19860001f,0.33899999f,-0.38740001f,0.42879999f,0.38100000f,0.62939999f,0.78740002f,0.52880001f,0.90240003f,-0.46769997f,-1.25690001f,-0.89910000f,-0.31879999f,-0.01570001f,-0.20380001f,-0.17840001f,-0.22860000f,0.09800000f,-0.78230002f,-0.28160002f,0.70089999f,-0.45840003f,-0.56440001f,0.26690001f,0.66340000f,-0.00310001f,-0.00330000f,-0.29240002f,0.34359999f,0.12729998f,-0.13060000f,0.51190000f,0.24820000f,0.74570001f,0.49780000f,0.30900000f,0.03550000f,0.13590000f,0.27450001f,0.81880000f,-0.30610002f,-0.36939997f,0.46700005f,0.40280000f,-0.72000002f,0.08120000f,-1.06310002f,0.55659999f,0.71180002f,0.05060000f,0.66890001f,-0.39900000f,0.09400003f,0.01380000f,0.85710003f,0.00059999f,0.77870004f,-0.41339998f,-0.21399998f,-0.46139999f,-0.94419999f,-0.01260002f,-1.71280003f,-0.42440000f,0.45210001f,0.03919998f,0.78340001f,-0.24319998f,-0.90029997f,-0.47420000f,-0.15540001f,-0.39010000f,-1.33069999f,-1.07540002f,-0.29540000f,-0.20709999f,-0.71439998f,-0.52919998f,-0.59429998f,0.09389999f,0.70749999f,0.25509999f,-0.46019998f,0.28330001f,0.78400000f,0.44060000f,0.42440000f,0.45390001f,-0.09550000f,0.26110000f,0.61810000f,0.66850003f,-0.58139998f,-0.57989999f,0.09380000f,-0.17580001f,-0.18319997f,0.75979997f,-0.51290001f,0.12459999f,-0.30829998f,0.70379999f,0.09390001f,-0.56139998f,-0.24459998f,-0.19320000f,0.51610001f,0.14039999f,0.30300004f,0.29999998f,-1.49830000f,-0.10540001f,-0.14299998f,-0.47279999f,0.07740000f,-0.32900000f,-0.20629999f,0.42039998f,-0.96680003f,-0.27680001f,-1.30490003f,0.58899998f,0.55639996f,-0.25359998f,0.99960001f,0.27119999f,0.64400000f,0.64590001f,0.02520000f,-0.97790002f,-1.41189999f,-0.70879999f,-0.34009999f,0.51810000f,0.92560000f,-0.14990001f,-0.97059999f,-1.33139998f,-1.20959996f,-1.27229997f,-1.03589997f,-0.27279999f,1.13300000f,0.12570001f,-0.68489998f,-1.32729997f,-1.30769995f,-0.93379997f,-0.65999997f,-0.23349999f,-0.02799999f,-0.60559999f,-0.62490000f,-0.08930000f,-0.59990000f,-0.33140000f,-0.49659999f,0.37580000f,0.81710002f,0.26739999f,0.39700002f,0.58359998f,-1.15130001f,0.06460000f,0.20860001f,0.19480000f,1.54120001f,0.48539998f,0.85229998f,0.29779999f,0.59749999f,-0.66339999f,0.59330001f,0.11799999f,1.63260000f,0.24900001f,0.57830000f,0.47099999f,-0.02080002f,0.34279997f,0.51149997f,0.06240000f,0.80230000f,0.01930001f,0.20640000f,0.36640000f,0.67500000f,1.23010001f,1.26249998f,1.17500000f,0.27059997f,-0.78030001f,-0.82819997f,-0.51899998f,-0.45819998f,0.21880000f,0.69950000f,0.45010001f,0.50000001f,0.30350002f,0.01060001f,-0.13039999f,-0.65230000f,-0.91740000f,-0.30679999f,-0.54889998f,-0.22889997f,-0.32859998f,0.44970000f,0.16289998f,0.76230001f,1.11780001f,0.73570001f,0.10200001f,-0.31200003f,-0.01420000f,-1.66190007f,-0.47380000f,-0.49249998f,0.75139998f,0.77599999f,0.25999998f,-0.51840000f,-0.03040000f,-0.37949998f,-0.62679998f,0.24350000f,-0.45660000f,-0.59620003f,-0.60119999f,0.59770002f,0.22379999f,1.16410001f,-0.19739999f,1.39409999f,-0.05020000f,1.98660002f,0.39719999f,0.04480001f,-0.29420000f,-1.67910003f,-0.70480001f,-0.27019999f,-0.51799999f,-0.51429999f,-1.01180002f,-0.51590000f,-0.14250001f,0.23559999f,0.23840002f,-0.77819996f,-0.36089999f,-0.79260002f,-0.17950001f,0.28300000f,0.00530000f,-0.11830000f,-0.35190003f,0.48869999f,0.51680000f,0.75530002f,-0.23329998f,-1.20259995f,-0.09999997f,0.73310002f,-0.00199997f,-0.76979998f,-0.06629998f,0.93430000f,0.35170000f,0.22609997f,-0.35079999f,1.26970003f,0.15419999f,1.44080003f,-0.14320000f,0.23390003f,-0.13159999f,-0.99600001f,0.61619998f,-1.23620004f,0.37259999f,-0.56180002f,-0.44259998f,1.07630004f,0.25400001f,1.13600001f,-0.14100000f,0.36420002f,0.11679999f,0.08170000f,0.69079997f,0.15110001f,0.63179996f,-0.42910005f,0.84859997f,-0.05750005f,-0.00680000f,-0.11520000f,-0.36149999f,-0.20429999f,0.31230003f,0.54470001f,-0.50390001f,-0.45400000f,0.24389998f,1.37759998f,0.09059999f,-1.15840002f,-1.02900001f,-0.07649999f,-0.00429998f,-0.65310000f,-0.21600001f,0.67820001f,0.22710002f,-0.69179999f,0.13470002f,0.24630000f,0.52320002f,-0.29610000f,-0.37859999f,-0.27849999f,-0.25579998f,-0.63709997f,-0.51709998f,-0.47919999f,-0.26889999f,0.54459997f,-0.26279999f,0.64219999f,0.71959998f,0.99349999f,0.28659999f,0.05960003f,-0.20120000f,-0.04160000f,0.17200002f,1.14069998f,-0.45199998f,0.15320000f,0.63699999f,-0.35650004f,-0.56300000f,-0.80180005f,-0.35619999f,-0.51370002f,-0.22380000f,-1.26380003f,0.37260000f,-0.17900005f,-0.37579998f,-0.11700001f,0.06320000f,-0.58270006f,-0.77779998f,0.15710000f,0.64700001f,0.87179999f,0.79510000f,0.86179999f,0.69570000f,1.04600002f,0.71720001f,0.72499997f,0.39249999f,0.00250000f,0.09970000f,-0.38220000f,-0.33390000f,0.26169999f,0.34160001f,-0.21269998f,0.26310002f,-0.19959999f,0.17230001f,0.42029999f,0.02839999f,-0.43429999f,0.20620002f,0.61610003f,-0.02549999f,0.51460002f,-0.39439999f,-0.09200000f,-0.19880003f,-0.66350002f,-0.10700001f,-0.38020000f,-0.41499999f,-0.06140001f,-0.68200000f,0.31839999f,-0.56659998f,-0.08849998f,-0.02400000f,-0.58049999f,0.19539999f,-0.06670003f,-0.85739997f,-0.78480001f,-0.55559998f,-0.24309999f,0.23699999f,-0.60190003f,-0.05819998f,-0.18640001f,-0.11140001f,0.75520005f,0.72759995f,0.87930001f,0.17159998f,1.17700000f,-0.11879998f,0.50900002f,0.11390003f,-0.59390000f,0.36510001f,1.10550000f,0.32080000f,-0.55259998f,-0.05309997f,-0.08489999f,-0.23809999f,-0.99530002f,-0.10330000f,0.52970002f,0.03620001f,0.59500000f,0.74720002f,-0.16230000f,0.46600002f,0.28510001f,-0.24170000f,-0.42240001f,-0.52830002f,-0.13440001f,-0.25100002f,0.18169998f,-0.75410002f,-0.96729999f,-1.20570000f,-0.74069998f,-0.21189999f,-0.17380002f,0.05440000f,-0.42400000f,-0.24259997f,-0.53070002f,-0.14339999f,0.01769998f,0.39359999f,-0.85320006f,0.55400001f,-0.07800001f,0.23779999f,0.09129995f,-0.84359998f,-1.06230002f,0.07139998f,-0.66339999f,0.38399999f,0.56150002f,0.57580000f,0.98720004f,0.62559999f,0.86530003f,0.65800000f,0.59459999f,0.40799998f,0.66060000f,-0.48399999f,-0.48519999f,0.10350001f,-1.15869996f,-0.74519997f,-0.18079999f,0.33890000f,0.24389999f,0.21200000f,0.10010000f,-0.08439999f,0.19660000f,0.61020001f,-0.01020000f,0.05710000f,0.64820000f,0.05700000f,-0.54770001f,-0.48900001f,-0.35769999f,-0.01160002f,0.87709997f,0.59299998f,-0.17760001f,-0.45110001f,-0.44479999f,-0.03290001f,0.85829998f,0.39169999f,0.35080000f,-0.40289999f,-0.05510001f,0.19779999f,0.12689999f,-0.22659998f,-0.88190000f,-0.43179998f,0.55759999f,0.16459998f,0.05249997f,-0.21640000f,-1.07620000f,0.39579999f,0.31559999f,-0.25839998f,0.38670001f,0.63339999f,0.23980000f,0.45219998f,0.19100000f,-0.23179999f,-0.39369996f,0.57539999f,0.30660001f,0.37579999f,0.32870001f,-0.16039999f,-0.39210002f,-0.67059998f,0.64320001f,-0.82300000f,-0.69639999f,-0.79159999f,-0.44080000f,-0.01339998f,-0.45619998f,-1.03180000f,-0.73409998f,-0.82990001f,-0.06120002f,0.07759999f,0.38250000f,-0.14040001f,0.47149999f,1.11280002f,0.81090000f,-0.11280002f,-0.50220000f,-0.53319999f,-0.47779999f,0.34220000f,1.21889999f,0.81649998f,0.68669998f,-0.01440001f,-0.07420000f,-0.50600000f,-0.69469999f,-0.01709998f,1.21479997f,0.25760000f,0.44319996f,-0.09720000f,-0.05900001f,0.73319997f,0.94809998f,0.15759999f,0.96450001f,-0.55199998f,0.99310004f,-0.05460000f,0.58639998f,-0.86859996f,-0.54000000f,0.22140000f,-0.20830002f,-0.39239999f,1.02880003f,0.07800001f,0.08150001f,-0.05240000f,-0.33720000f,-0.20059999f,0.50750000f,-0.31359999f,0.63870002f,-0.14000000f,0.85460003f,-0.52410002f,0.45580000f,-0.17870000f,0.24870000f,0.31449999f,0.26269998f,0.21159997f,0.94229998f,0.56640001f,0.37529999f,0.12900000f,-0.11600000f,0.48659998f,1.11139995f,0.67469996f,-0.11590003f,-0.13340000f,-0.90289996f,-0.96450001f,-0.33110001f,-0.10259998f,-0.42949999f,0.37310002f,0.78349999f,0.34089998f,0.08800000f,0.25150002f,0.15340001f,-0.11740001f,1.24200002f,-0.23140001f,1.00610000f,-0.49439997f,0.56860001f,0.23780000f,-0.03780003f,-0.65499999f,-0.04640003f,-0.64459997f,0.56430001f,0.01200000f,-0.29679998f,-0.25379998f,-1.35750000f,-0.38659998f,-0.03619996f,0.38759999f,0.46719998f,-0.55620000f,0.11840000f,0.06200000f,-0.63540001f,-0.06839998f,-0.62450003f,-0.64619999f,0.60180003f,0.21479999f,0.95560003f,-0.54709998f,-0.88719997f,-0.44669998f,0.03140000f,-0.41340001f,-0.12170000f,-0.51560002f,-0.38849999f,-0.39859998f,-0.12309997f,-0.52510001f,0.80409997f,1.05419999f,0.78420000f,0.97800001f,0.01540000f,0.08510001f,-0.43729998f,-0.87369999f,-1.04399999f,-0.96619997f,-0.60709998f,-0.68059998f,-0.15389998f,-0.30850000f,0.63739998f,0.84880000f,0.84150001f,0.64210000f,1.26000001f,0.18459998f,0.64940000f,0.50399998f,0.94350003f,0.12980001f,0.54820002f,0.13779999f,0.99419998f,0.13959999f,1.66819999f,-0.74299998f,-0.82229998f,-0.19200002f,-1.56940000f,0.37219998f,-0.82950001f,0.51239999f,0.17129995f,0.01080000f,1.17989997f,0.08140000f,1.34999997f,0.12159998f,0.65889998f,-0.85359997f,-0.05389998f,-0.35759999f,-0.59349999f,-1.09229998f,-0.42049999f,0.38950000f,0.22769998f,0.02389999f,-0.06279999f,0.66050000f,0.57079997f,0.30229998f,0.26389998f,0.06889996f,1.01109997f,0.40339999f,0.00360000f,-0.73170000f,-1.17570001f,-1.69100000f,-1.32659997f,-0.95129998f,0.18509999f,-0.32750001f,-0.46510000f,-0.25340001f,1.02450000f,0.94580001f,0.26050000f,0.42220000f,-0.03100000f,0.82300000f,-0.39770003f,-0.44260001f,-0.05980003f,-0.45879998f,-0.06470001f,0.42520000f,-0.81419998f,0.55779999f,-0.05320002f,-0.31339997f,0.64479999f,-1.30620000f,-0.15340001f,0.36520000f,-1.12890002f,1.26920001f,-0.64020004f,0.30880001f,-0.15980001f,0.04520000f,-0.41150001f,-0.20599998f,-1.32629998f,1.02079998f,-0.64820000f,-0.26000000f,-0.95130001f,1.22620000f,-1.30930000f,0.37330004f,-0.20260000f,-0.70090001f,0.03380000f,0.35650002f,0.06850000f,0.18720000f,-0.19320000f,-0.62039998f,0.10220000f,-0.79689999f,-0.32739999f,-1.27580001f,-0.15450000f,1.20900002f,0.37900001f,1.16550007f,0.09530000f,1.33450003f,0.38680000f,1.42490003f,0.12580000f,0.57080000f,0.28160000f,0.44270002f,-0.09180000f,-0.33040003f,0.26150000f,1.28340000f,-0.20050001f,0.07499999f,-1.03350001f,0.63419999f,-0.85180000f,0.31079999f,0.09080000f,-0.29380002f,-0.07399994f,0.50639996f,-0.77149998f,1.16059998f,-0.50970001f,-0.34320001f,1.08289999f,-1.87979997f,-0.11629997f,0.61239997f,0.13880004f,-0.65700002f,0.98180002f,-0.36659999f,0.53180000f,-0.47939999f,-0.29799999f,0.98180000f,-0.48429999f,0.20940001f,0.51210001f,0.42089998f,0.25630000f,1.04880004f,0.03440001f,-0.76059999f,-0.10970000f,0.73260002f,0.15650000f,-0.08819999f,-0.02590000f,0.84760001f,0.18390001f,0.44220004f,0.09290000f,0.81170006f,0.23650001f,0.24730003f,0.03030000f,1.29010004f,0.17580001f,-0.10269998f,-0.20970000f,0.21699999f,0.25100000f,0.48210003f,0.08090000f,0.36630000f,0.24560001f,1.26680006f,1.04659998f,-1.26639996f,1.03800001f,-0.06300002f,-0.61810003f,0.28420001f,-0.08810002f,-0.54040000f,-0.97980000f,1.02620001f,0.07490001f,-0.70440001f,0.10370001f,-0.04740000f,0.03210005f,0.28319996f,-0.31780000f,-0.02440000f,0.79800002f,-1.39560002f,-0.48349999f,0.75060000f,-0.51400000f,-0.14240001f,-0.50259998f,0.83819999f,-0.34700000f,0.17800001f,0.61080004f,-2.13130005f,-0.21720001f,-0.68120002f,-0.25569999f,-0.62889999f,0.10440000f,-0.31450002f,-0.16100000f,-0.40700003f,-0.11130001f,0.57649998f,0.31790000f,-0.05580001f,-0.30430001f,-0.39900003f,0.22150001f,0.82970005f,0.09690000f,-0.12600002f,-0.02390000f,-0.22260001f,-0.18790000f,-0.45960003f,0.00369999f,0.83619999f,-0.01740000f,0.43820001f,0.12200000f,0.79610000f,-1.71800002f,1.60060002f,-1.09360006f,0.07700001f,-0.28049998f,0.56240001f,-0.81350005f,-0.06639999f,-1.35190004f,1.04760002f,0.25450000f,-0.53680000f,0.26639999f,0.47620001f,0.34840001f,-0.74740000f,0.71980006f,0.32239999f,0.63919999f,-0.60219997f,0.39829998f,-0.06499999f,-0.07210001f,-0.52740000f,0.34849999f,-0.91439999f,0.67790005f,0.29699997f,1.47570002f,-1.07439999f,-0.09290000f,-0.24990003f,-0.06610001f,-0.97420004f,-0.24770000f,-0.98570005f,-0.30310000f,-1.47760003f,-0.32620000f,-1.32080002f,-0.13440000f,0.16380000f,0.33400000f,0.42930000f,-0.29510000f,0.56460000f,0.19780001f,0.33410003f,0.01570000f,0.19650001f,0.11440000f,0.68980000f,0.04440000f,0.15550002f,-0.04570000f,0.23230000f,0.00900000f,0.01030002f,-1.47769996f,1.25319997f,-1.09590002f,0.05700002f,-1.71080001f,1.72840000f,-0.89270005f,-0.02099998f,-0.60290001f,0.61959999f,-0.76799998f,0.79219998f,0.12780002f,-0.63899999f,-0.52580001f,0.11180000f,0.82580003f,-0.81680001f,1.05200002f,-0.69860000f,0.00100003f,0.34659999f,0.16019999f,-1.06100001f,-0.71609998f,0.80059998f,-0.03430001f,-0.03480000f,1.09990002f,1.31110002f,0.09550000f,0.47380002f,0.12310000f,-0.80480000f,-0.35690000f,-1.57940005f,0.01140000f,1.26210002f,0.29850001f,0.33010003f,-0.21200000f,-2.00310001f,-0.24150000f,-1.71630001f,-0.26690000f,0.27980000f,0.22410000f,-0.26669997f,-0.16600000f,-1.77800000f,-0.31109999f,-1.87049998f,-0.13469999f,0.07870002f,0.12240000f,-0.33850001f,-0.18600000f,0.02029999f,0.58270000f,-0.92100000f,0.15410002f,0.13420001f,-1.18049999f,1.79679999f,-1.48170001f,0.45819999f,0.10750000f,-1.10259999f,-0.27749997f,1.33759998f,-1.52939997f,1.60459995f,-1.67379998f,1.24479997f,0.87870002f,-1.39260001f,0.32920005f,0.90139997f,-1.21279997f,1.72679995f,-1.59699999f,0.75019998f,-0.64889997f,0.26759997f,-0.55240001f,0.73540000f,0.19100001f,0.10390001f,0.17280000f,0.59410002f,0.16210000f,1.94160004f,0.25010000f,1.32880002f,0.35829999f,0.21450001f,-0.17140000f,-1.23710002f,-0.26760000f,0.49460001f,0.09780001f,0.26890004f,0.03290000f,-0.11059998f,-0.22040000f,-0.94030001f,-0.08890000f,-0.96230002f,-0.15230000f,-0.66619998f,-0.00829999f,0.00870005f,0.36660001f,1.12510004f,0.12830000f,1.02020002f,0.43490002f,0.05080000f,0.47349998f,-0.95060000f,1.30869998f,-1.69959999f,0.60210003f,0.14860001f,-0.67989997f,1.11959995f,-1.19770001f,0.15480001f,0.72730002f,-0.86980000f,1.27520003f,-0.73740002f,0.54160000f,-0.40320000f,-0.26319997f,1.02119999f,-0.31350000f,0.29059999f,0.16120004f,0.50519995f,0.61540007f,-0.01980002f,0.87220002f,-1.09560000f,0.53440001f,0.41620002f,-0.18700000f,-1.03440001f,-0.05770000f,-1.07790003f,-0.18940000f,-0.59940005f,0.01980000f,-0.53359998f,-0.14610000f,-0.67010003f,-0.23190001f,0.05129995f,-0.03970000f,-0.11619998f,0.12900001f,0.26430001f,0.14550000f,1.03730005f,0.33460001f,-0.31099994f,-0.22240000f,0.39110003f,0.46010001f,0.69660004f,-0.03410000f,1.10060003f,0.33900001f,0.59130004f,-0.27900000f,0.18319999f,-0.18669996f,0.85799998f,-0.33709999f,0.59980001f,0.03189999f,-0.38039998f,-1.16930000f,0.89179997f,-1.85610005f,0.78100003f,-0.15600004f,-0.50379999f,0.42360003f,0.53780000f,0.62310000f,-0.52319999f,1.03010005f,-0.63940003f,-1.04959994f,1.53599994f,-0.51049993f,-0.47120004f,-1.03459997f,1.10739996f,0.18160001f,-0.94980000f,-0.20689996f,0.42060004f,-0.09180000f,-0.04869997f,0.41460001f,0.97930005f,0.02110000f,0.69309998f,0.35360000f,0.40229999f,-0.27980001f,-1.35570004f,-0.16480000f,-1.04009999f,-0.03130000f,0.50560000f,0.02830000f,-0.52950001f,-0.38210000f,-0.76440002f,-0.01590000f,-0.17330001f,-0.06030000f,0.07120001f,-0.17690000f,-1.43880000f,-0.25960000f,-0.95570003f,-0.43010000f,-1.94820005f,0.24720001f,0.29859999f,0.15710004f,-0.25380004f,-0.06389996f,0.90739999f,0.85089999f,-1.76919998f,-0.14780002f,1.54320002f,-0.27140005f,-0.11420000f,-0.80620000f,0.97840000f,0.22989998f,-1.08500001f,-0.09580002f,0.47940000f,-0.11460002f,-0.46840000f,-0.65670003f,0.24640001f,-0.25280003f,0.24839999f,-0.77330000f,0.52219998f,-0.50580004f,0.09180000f,-0.81300003f,0.00960000f,0.20990000f,1.76630003f,0.22470000f,1.07450006f,0.13680001f,1.06870003f,0.14890000f,-0.19050001f,-0.05780000f,-0.17120002f,-0.08110000f,-0.05000002f,-0.17930000f,-0.95439999f,-0.30600000f,-0.66700000f,0.02390000f,0.27390000f,0.06450000f,0.21190003f,-0.14230000f,0.03480003f,0.46120001f,1.86140007f,0.31180001f,0.32840003f,-0.02780000f,-0.10860001f,0.52369999f,-1.17620000f,1.50670003f,-0.93300000f,1.80830004f,-1.47480003f,1.89260003f,-0.79339998f,0.43999999f,-0.18019999f,-0.55710001f,0.46780000f,0.41309996f,-0.67839998f,0.21939998f,-0.21580000f,-0.27779998f,0.38419999f,-0.02470003f,-0.68279998f,-0.01409999f,0.55559998f,0.10920010f,-0.26380006f,0.82290010f,-0.21440004f,0.53300002f,0.17880000f,0.76309998f,-1.04220001f,-0.18300000f,0.39520001f,0.26870001f,0.45510006f,-0.22470000f,-0.76950000f,0.06780000f,-0.51560002f,-0.23560001f,0.37980002f,0.28650001f,1.07230005f,-0.04880000f,-0.52689999f,-0.11490001f,0.55680000f,0.23260001f,0.35760003f,0.06890000f,0.05649999f,0.18560000f,0.68620001f,0.30700000f,-0.13530000f,-0.20020001f,-1.33140004f,-0.39680000f,-1.94110008f,-0.32530000f,0.68140001f,0.57759999f,-1.42319999f,0.19520001f,0.56579999f,-0.60000000f,0.18659999f,-1.59650007f,1.11340003f,-0.32399999f,-0.36720004f,1.22980001f,-0.99520001f,0.00070000f,-0.05679999f,-0.17319998f,-0.08620002f,-0.43979998f,0.83100001f,-0.57320000f,0.54880000f,-0.19650000f,0.22980001f,-0.99280001f,1.24899999f,-0.85540001f,0.61100000f,-1.20610005f,0.23110004f,-0.26990000f,-1.50370001f,-0.21549999f,0.04690000f,-0.05390000f,0.01430001f,0.14070000f,0.16470000f,-0.03460000f,0.09720000f,0.06710000f,1.23900003f,0.22440001f,-0.35419998f,-0.02010000f,-0.03270001f,0.04090000f,0.79309999f,0.23170000f,0.54570001f,0.10650000f,0.11800001f,-0.01270000f,0.63490001f,0.25520000f,0.85420002f,-0.09670000f,-1.38049999f,-0.20809995f,1.56159995f,-0.85840002f,-0.17619999f,0.22709998f,-0.46999998f,0.46140002f,0.14519997f,0.23609999f,-0.42399999f,-0.37520001f,0.01860000f,0.80890002f,-0.55160001f,-0.37310000f,0.78480001f,-0.92420000f,0.66679998f,0.59819998f,-1.04679996f,-0.02450000f,0.41460001f,-0.72559999f,0.72699998f,0.55800000f,-0.96899998f,1.08299998f,-0.71059999f,-0.46499998f,0.08170001f,-0.08820000f,-1.18290002f,-0.23320000f,-0.62470000f,0.08800000f,-0.39029999f,-0.16480000f,-0.83090004f,-0.16980000f,-0.26670000f,0.17790000f,0.40190001f,-0.09450000f,0.30680003f,0.31770001f,0.62780004f,-0.27000000f,-1.36230004f,-0.10280000f,0.57490002f,0.38540001f,1.86670004f,0.20930000f,0.26410001f,-0.09360000f,-1.15000002f,-0.27120000f,-0.27889998f,-0.46319998f,1.10159997f,-0.78820003f,0.26600001f,-0.98139998f,0.87919997f,-0.89079998f,0.99139998f,0.04029998f,-0.10799997f,0.78700002f,-0.23240001f,1.24009998f,-0.85799998f,0.88880001f,-0.87560000f,0.18330000f,0.44720001f,-0.34519999f,0.67359999f,0.76220001f,-1.39979999f,1.37990002f,-0.71799999f,0.69470001f,0.03480000f,-0.32489999f,0.72539999f,0.07280006f,1.07490002f,0.17750000f,0.05559999f,-0.04800000f,0.01370001f,0.20310000f,1.10899999f,0.10989999f,0.60380000f,-0.03430000f,-0.48609999f,-0.01520000f,0.78139998f,0.27770000f,0.69209997f,-0.21770001f,-1.03430001f,-0.16519999f,-1.01720003f,-0.30110001f,-1.21660004f,-0.12640000f,0.28320000f,0.19640001f,0.88940004f,-0.15290000f,-0.39650000f,0.15580000f,0.95820004f,0.69560005f,-0.29580001f,1.02740000f,-0.42619999f,0.54760000f,-0.05079998f,1.21119997f,-1.34919998f,1.42569998f,-0.57599999f,0.42150000f,0.19920000f,0.90689996f,-1.40059994f,0.40869993f,-0.23639995f,-0.89709999f,1.23259996f,-0.51090002f,0.06120001f,-0.40600000f,0.49939999f,0.22389997f,-1.04739998f,0.79039999f,-0.32860000f,0.42080004f,0.04879998f,1.30460005f,-1.06320000f,-0.16970000f,-0.91040001f,0.12920000f,0.71880002f,0.10730001f,-0.79770002f,-0.14770000f,0.01440002f,0.11560001f,0.28560002f,0.09450000f,0.48230000f,0.13740000f,0.87170001f,0.07850000f,0.17400000f,-0.02780000f,-0.73930001f,-0.34020001f,-1.57820002f,-0.14310000f,-0.71999997f,0.03920000f,0.23870000f,-0.03180000f,0.46770003f,0.19200001f,0.40290004f,-0.29969995f,1.29739995f,-0.73529998f,0.06839999f,0.11270004f,0.54440000f,-0.51570001f,0.29720000f,-0.00539996f,0.56899995f,1.40720001f,-1.04559997f,1.10040001f,-1.17160000f,-0.10089998f,0.01260000f,-0.97640000f,0.58459998f,-1.20200003f,1.18519999f,-0.82380000f,0.82519997f,-0.17969996f,0.39819996f,1.04909999f,-1.02759997f,1.50140003f,-1.02700001f,0.20420002f,-1.88150004f,-0.31020000f,-0.52120004f,-0.01420000f,0.13649999f,-0.19230000f,-0.21100001f,0.28109999f,1.38439999f,0.21860000f,1.27720000f,0.25749999f,0.39380000f,0.04850000f,-0.91440003f,-0.24370001f,-2.02920004f,-0.35910001f,-1.11740004f,0.14840000f,-0.34549999f,0.00770000f,0.91630001f,0.18630001f,0.30900004f,0.04610000f,0.48350000f,-0.16680000f,0.42000001f,0.64349998f,0.15639999f,-0.61119999f,-0.99679998f,-0.43630001f,-1.07529999f,0.74160002f,0.43410000f,-0.16200000f,0.89930000f,0.82150004f,-0.10869999f,-0.67990003f,-0.18170000f,0.83219999f,0.06500001f,0.92229999f,0.28310000f,0.15160002f,0.16120000f,-0.21240000f,-0.76019998f,-1.01439998f,0.46489999f,-0.73540000f,-0.02490001f,-0.15470001f,0.53150002f,-0.73729999f,-0.42010000f,0.62230000f,-0.15140001f,0.18060003f,0.76020003f,1.97610002f,0.49280003f,0.01299999f,-2.03300003f,0.67320001f,1.01819999f,-0.25560001f,-0.81640001f,0.27690002f,0.09290000f,0.28000000f,-1.02169999f,-0.71979998f,1.34970001f,-1.12400001f,-0.71840001f,-0.09799998f,-0.53890002f,0.51420000f,0.50220002f,-1.02960001f,0.33370001f,0.80899998f,-0.80589999f,0.54669997f,0.56139999f,-0.20220000f,0.40370001f,-0.04440001f,1.05670001f,-0.05379999f,-0.25050000f,0.77379998f,0.69260000f,0.92539999f,-0.47499999f,-0.20109996f,0.19650001f,0.32970001f,0.06240000f,-0.64250001f,0.08369999f,0.44089998f,-0.74650000f,0.43340000f,0.01900001f,-0.04600002f,0.56570000f,-0.21170000f,-0.42300001f,0.94010001f,0.22330000f,0.01860003f,0.33610004f,1.59059998f,-0.72389997f,-0.88899996f,0.47059999f,-0.25020000f,0.09350000f,-0.36429998f,-1.02910004f,-1.64729999f,0.73699999f,-0.49589999f,-0.68850003f,-0.39219999f,0.28289999f,1.38350000f,0.00360003f,-0.44570000f,-0.35729999f,-1.12199996f,-0.52490003f,-0.53149998f,1.14960001f,0.87320003f,1.31570004f,-0.32120003f,0.33080001f,1.17590000f,0.06020000f,0.49899999f,0.82249999f,0.48849997f,-0.41029999f,0.18759994f,-0.26480000f,0.60010001f,-0.50099997f,0.51720000f,-0.89309999f,0.81390001f,-0.70399998f,-0.98519999f,-0.09360000f,-0.27029999f,0.82380001f,-0.69479999f,-0.03260001f,0.16489999f,-0.27979999f,0.51819997f,0.14480001f,-0.41809999f,0.56510002f,-1.03149997f,-0.35150001f,-0.14279998f,0.37130000f,-0.33160001f,0.55910002f,-0.78090000f,-1.59100001f,0.85100004f,-0.44150002f,0.64209998f,-1.20169998f,1.04820001f,-0.06050004f,-1.58399999f,1.31320000f,0.28519997f,-0.57329999f,0.44079999f,1.74630000f,-0.06919999f,-1.46500003f,-0.58059999f,-1.35979999f,0.37749999f,1.72479997f,0.42699996f,-0.16589999f,1.22300000f,-0.79010000f,-1.04169996f,-1.31429999f,-0.44909997f,-0.07849999f,-0.40880001f,-0.65640000f,0.80500001f,0.65830001f,1.26179999f,0.34639999f,0.95040001f,0.75099999f,0.02189995f,-0.68089999f,-0.62619998f,0.03179999f,-0.96699996f,0.57829999f,0.73620001f,-0.58789998f,0.68590000f,-0.45139998f,0.55009999f,0.46889998f,0.66260002f,-0.36870000f,-1.10779995f,0.40030000f,-0.40160002f,-0.43859998f,0.70339995f,0.24630000f,0.59819993f,-0.30959999f,0.90090000f,0.44980000f,-1.75809998f,-0.68800004f,-1.79160000f,0.54270000f,-0.78210001f,-0.70509999f,0.41509999f,1.19970003f,0.25079998f,-0.01840004f,-0.09290001f,-0.48029997f,-0.30509996f,-0.88150004f,0.12300001f,1.31940000f,1.26309997f,-0.15949996f,0.74719997f,1.38180001f,-0.96969998f,-0.59730002f,-1.48579999f,-1.67130000f,0.13750003f,0.50369999f,-0.24520002f,0.58139999f,-0.36140001f,-0.95139999f,0.06389998f,-0.63890000f,0.84040000f,-0.45800000f,-0.50550001f,0.61689998f,0.79040001f,-0.16780001f,-0.99639998f,-0.08950000f,0.76800002f,-0.20769999f,0.28639997f,0.29939999f,-0.07809998f,0.40169999f,-2.02210000f,0.66319996f,-0.53150002f,-0.68369998f,0.46300000f,-0.79679998f,1.03849999f,0.50920000f,0.17269996f,0.01210000f,-1.32570003f,-0.97570006f,-1.91959997f,0.22219999f,-1.47500004f,-0.00520003f,-1.30239999f,0.35700001f,0.52170002f,0.79610005f,0.25529999f,0.37709998f,-1.51849997f,-1.36619997f,-0.00869998f,0.85700001f,1.61989999f,0.37190000f,0.13960004f,1.38500004f,0.54239997f,-0.40150002f,-1.40719996f,0.80739999f,-0.61420001f,-0.75139996f,0.34780006f,-0.13850006f,0.84910002f,-0.91060002f,0.51279997f,-0.91559998f,1.13719999f,-0.97600001f,-0.37660001f,-0.71379999f,-1.39690001f,0.53710001f,0.00310001f,0.05810000f,-0.27530000f,-0.96729998f,-0.17670002f,0.48199999f,0.43179998f,0.88879999f,-1.53669999f,0.28360002f,-0.14769999f,-0.01120001f,-0.19530002f,-0.85549997f,-0.67070001f,-0.50799999f,0.35950004f,0.23460002f,1.66169997f,-0.06029998f,1.15129999f,0.52880001f,-2.20519998f,0.53770003f,1.49579995f,0.77820002f,-0.09250003f,-0.62510004f,-1.10610000f,-0.34719999f,-0.01810000f,-0.84900001f,-1.34799995f,-0.81479999f,-0.87159997f,0.32879995f,0.37629998f,-0.55090002f,0.46040000f,0.79680004f,0.71160001f,-0.04540001f,-1.37889997f,1.04670004f,0.90780001f,0.12750003f,0.90490001f,-0.43149999f,-0.68869997f,0.82509998f,-0.26180005f,-1.14929999f,0.13889998f,0.66869998f,-0.50279998f,-0.40910001f,-0.83890000f,-0.47330000f,1.13549999f,-0.00799999f,1.26459996f,-0.71209997f,1.63999996f,-0.50819999f,1.23559997f,-0.25449998f,-1.21759996f,0.31260000f,-0.84859998f,0.33520000f,-0.75920002f,-0.58949999f,0.21750001f,0.22040001f,-1.88910000f,0.62399998f,-0.26040003f,-0.63899999f,-1.74600004f,0.26959998f,-0.06329998f,-1.44850000f,-0.93619999f,1.07250000f,0.45020000f,-0.55910000f,2.20860000f,-0.52130000f,0.95990000f,0.71420005f,0.88050000f,1.04020004f,1.76999996f,0.30919997f,-2.64119994f,0.27190001f,-1.76519999f,-0.23270000f,0.87090003f,-0.36350001f,0.04320002f,0.12320001f,-0.82980000f,0.06510002f,0.37590002f,0.10880005f,-0.53300001f,-0.93120003f,1.23869999f,-0.38449997f,0.60639999f,-0.43220000f,0.96779998f,-0.32329999f,-0.70669999f,1.00250000f,-0.99280000f,0.70339999f,-1.37500001f,0.69199998f,-1.22219999f,1.03289997f,-0.64700000f,-1.33979997f,0.26859997f,-0.93170000f,0.08339998f,0.61480001f,-0.58450000f,0.42440000f,0.26469998f,-0.16640000f,-0.14320001f,0.51480000f,1.21829999f,2.01360004f,0.04049998f,-1.66380005f,-0.93109998f,-0.28509999f,-0.66639998f,1.31669998f,-0.86170002f,-0.31319997f,1.00359999f,0.84500003f,0.64580000f,-0.32790005f,1.72189999f,0.26150003f,0.20989997f,-0.20409998f,-0.61839997f,0.30090001f,1.28500002f,-0.98859999f,0.22440005f,-1.50970006f,0.60190006f,-0.61349997f,-0.49579998f,0.96800001f,0.59160000f,0.68349999f,0.52420001f,-0.58470000f,-1.21300002f,-0.12660000f,1.11259999f,-0.13100000f,0.51019999f,-0.85319999f,-0.64549997f,0.47429999f,-0.21820000f,-0.03020000f,-1.21330000f,0.96180001f,-1.40019997f,0.34249998f,-0.66290000f,0.13960000f,0.58620000f,0.89670001f,0.95160002f,0.40700001f,1.48399998f,0.78860003f,0.75259998f,0.20839999f,0.29749997f,0.34300000f,-1.43490002f,-0.27420000f,0.03190000f,-0.85919999f,-0.01649994f,0.13500003f,1.63969997f,0.08149996f,-1.56630000f,0.56269998f,-0.79820000f,-0.54609998f,-0.76039997f,-0.39340000f,0.48799998f,-1.21170004f,-1.57719999f,0.60130003f,1.32830003f,-0.46989998f,0.06280004f,-0.11219998f,0.81550002f,1.07780004f,0.88670000f,-0.74330005f,-1.89669999f,0.74340003f,-1.09480004f,0.77920000f,-0.45280000f,0.25029999f,0.04529998f,0.53880001f,1.19699997f,1.04079998f,0.32450000f,-0.85409999f,-0.24490000f,-0.52999999f,0.83549999f,-0.47429997f,1.27159997f,0.04540000f,0.08989998f,-0.62069999f,-0.14740001f,0.79020001f,-0.95740001f,0.48780001f,0.76100000f,0.71890000f,0.53430000f,0.15560000f,-0.86670002f,-0.83970000f,0.49660001f,-0.74890002f,0.37490000f,-0.54150002f,-1.12280003f,-0.06610002f,-0.19249999f,1.17080000f,-0.55430004f,-0.29630002f,-0.56380001f,1.52730002f,-1.21620001f,1.40799999f,-0.53550004f,-0.45069992f,-0.78449999f,0.23109995f,0.46509996f,-0.46940001f,0.27750000f,0.39740000f,-0.41980000f,0.94819999f,-1.06300001f,-0.11769999f,0.63409998f,0.21280005f,-0.32289998f,0.43819999f,-1.54700001f,-0.58160004f,1.34470000f,-0.78580001f,0.49959999f,-0.34219999f,-1.03739997f,-0.70380002f,-1.39629999f,-0.19540001f,-0.75770002f,-0.91330000f,-1.44160002f,-0.66110000f,0.36310003f,-0.67630000f,0.56719998f,-0.20970001f,-1.33459997f,0.20899999f,-0.32220000f,-0.24450000f,-0.47040002f,-0.81140000f,-1.77950002f,0.64999999f,-0.54060000f,0.16500001f,1.08289999f,-0.92789999f,-0.17589998f,0.11580000f,1.25410003f,0.98760002f,1.11739998f,-0.99870000f,0.06000001f,1.15649996f,-0.29070003f,-0.36629998f,-1.22230004f,-0.53970005f,-1.14089999f,0.15650002f,-0.05060003f,-0.58750003f,0.58709999f,-1.94030006f,0.19530004f,0.82940003f,-0.68160000f,1.23990003f,0.09189998f,-0.53230003f,0.42289997f,-1.08000004f,-1.38280003f,1.08240005f,-1.57020002f,-1.48029999f,0.89369999f,0.81140002f,-0.02029999f,0.30049999f,-0.37780000f,0.18190000f,0.07569999f,-0.47899999f,0.13160004f,-0.84230002f,0.97529998f,-0.78289998f,0.70390002f,-0.39200002f,0.08100000f,0.16420000f,0.03719999f,0.67510002f,0.16500000f,-0.17850001f,0.86410001f,-0.44480000f,-0.14830000f,-0.01710001f,-0.86060002f,-0.34630002f,0.71989999f,-0.99800001f,0.70599999f,0.98680002f,-1.13719999f,0.17030001f,0.23260001f,-1.03250003f,0.77350002f,1.38660003f,0.96099999f,0.36640000f,1.86459998f,0.82469997f,0.72569999f,-1.93000000f,1.65739996f,-0.30110003f,-0.95179998f,0.57270001f,-0.41850000f,0.56929998f,-0.64559997f,-0.29880000f,-1.02070004f,0.27000001f,1.17600002f,0.06760000f,1.58520001f,0.81620005f,0.51919999f,-0.80130001f,-0.54179997f,-0.72989998f,0.44180002f,-0.12849999f,-0.85180000f,0.77380000f,-0.27909999f,0.36450000f,-0.29199994f,0.73799999f,0.03270005f,-0.27199998f,-0.40299998f,1.05769997f,-0.27740001f,-0.21810000f,0.37319999f,-0.21740000f,0.62130000f,-0.70019997f,-0.78820002f,-0.54130002f,-0.43829999f,0.67950002f,-0.27699999f,0.88740002f,-0.04069998f,-0.05660000f,-0.94440001f,0.50840001f,-0.21220005f,-1.36820003f,1.06020005f,0.19830001f,0.53159999f,0.01000002f,-0.62869996f,0.24750000f,-0.48409999f,-1.38870000f,0.93479998f,0.90699999f,-0.18480000f,-0.17600005f,-1.77830000f,-1.62080003f,-0.97009995f,1.86030001f,-0.55250000f,1.14129998f,-0.50040000f,-1.45539998f,0.11150001f,0.36770000f,-1.91929998f,-1.40839998f,0.25110003f,-0.32370000f,0.17980001f,-0.47430001f,0.29200002f,0.67320003f,-0.76120000f,0.46089998f,-0.40810001f,-0.07969999f,0.63499997f,-0.24150000f,0.98440002f,0.81539998f,0.14480000f,-0.21960001f,0.17030000f,-1.02729998f,0.23500001f,0.05000002f,0.29270002f,-0.49570000f,-0.53629998f,-0.73979998f,-0.53849999f,0.32329999f,0.82159997f,-1.12069999f,0.52589997f,0.52879999f,1.58059993f,-0.78350004f,-1.03789999f,-0.92570005f,-0.90859997f,-0.54950002f,-1.48020003f,0.37440002f,0.32300000f,-0.64590001f,-0.42379999f,-1.18840004f,0.80299998f,1.11190000f,0.53559997f,-1.68220006f,-0.34520001f,0.17050001f,0.23339998f,0.21780001f,1.73269999f,-0.35460000f,0.06770000f,-1.55080001f,0.06310008f,2.37560008f,0.35589997f,-0.74280005f,0.38950000f,0.59290007f,1.63690000f,-0.71029999f,1.81949998f,-0.70399997f,0.38769996f,-0.84950001f,0.13580000f,-0.00440000f,0.64650002f,-0.32730000f,1.22029999f,0.48819999f,0.77430004f,-0.32410001f,-0.65339998f,0.02120000f,0.24800001f,0.20749999f,0.11990000f,0.87450000f,0.41380002f,-0.05559999f,-0.08330002f,0.56240003f,0.78979999f,-0.42360001f,-1.78550002f,0.34400000f,-0.23869999f,-0.06429997f,0.68790000f,0.01780001f,-0.32449999f,0.37250002f,0.36250002f,-0.75760001f,1.27170004f,0.04980000f,-0.20680000f,0.75000003f,1.06800000f,-1.14870000f,-1.87139997f,0.70630001f,-0.80950002f,0.99220002f,0.57139997f,-0.39569998f,0.91100002f,0.20240001f,-0.03200001f,-0.58919999f,-1.24970000f,-1.41530004f,-0.69249997f,0.77709999f,-0.38320000f,-0.30279999f,-1.81810003f,-0.24670000f,-0.15440000f,0.65889997f,0.81640000f,0.58869998f,1.47350000f,-0.04049999f,-0.14020000f,-0.60050000f,-0.98050002f,0.50600000f,-0.68960000f,-0.33950001f,-0.16389998f,-0.20199999f,-0.31870001f,-0.04260000f,-0.44750000f,-0.09309999f,-0.64920000f,0.43549999f,1.77399997f,-0.40959999f,-0.16340002f,-0.22319999f,0.10650000f,-0.61810002f,-0.41400002f,-0.38190000f,-0.12740001f,-0.58750000f,-0.30380000f,0.17629997f,-0.46960005f,0.14940002f,0.27260000f,0.42669996f,0.57879997f,-0.33779998f,-0.00119999f,0.18390001f,0.17640000f,-0.02370001f,0.04000000f,-1.01360000f,-0.23819999f,0.65980000f,0.07780002f,0.78570000f,0.39800000f,-0.83870003f,-0.39740001f,-0.14979999f,-0.05879998f,1.42050000f,0.39219998f,-0.63079996f,-0.86940000f,-0.55579999f,-0.70230001f,-0.58890000f,0.38329997f,-0.70170001f,-0.80720003f,0.45010000f,-0.21329996f,-0.54180000f,-1.45680003f,0.57799998f,0.70540000f,-0.10740000f,-0.34500003f,0.05820000f,-0.46129998f,-0.54799998f,-0.29530000f,0.56630000f,0.65210004f,0.02600000f,-0.34330000f,-0.68670000f,-0.75390002f,0.09690000f,0.67640000f,0.17610000f,-0.07020000f,0.64639997f,0.03299996f,-0.15559999f,0.53220000f,-0.33970002f,-0.23880001f,1.33360002f,0.72340000f,-0.27570000f,0.50480003f,0.81980001f,0.29260000f,-0.95460000f,-0.33559999f,0.29739998f,-0.33060002f,-0.86220000f,-0.26819999f,0.32020000f,0.21640002f,0.00809998f,-0.03619999f,-0.58960000f,-0.86700001f,0.02000000f,-0.26659999f,0.74430001f,0.04879998f,-0.51100001f,-0.16060003f,-0.41619999f,-1.60029996f,0.30230000f,0.09250002f,0.20619999f,0.39610002f,0.75049998f,-0.62430000f,0.63259999f,0.64970000f,0.87439998f,0.79380001f,-0.14500000f,0.86029997f,-0.61670001f,-0.85460003f,-0.24509999f,-0.39169997f,-0.09100000f,-0.43670000f,-0.49180000f,0.24349996f,-0.62760002f,0.32249993f,0.29230001f,1.24970002f,0.05090000f,-0.71540000f,0.85260001f,0.34900001f,0.67200001f,0.48059999f,0.06229998f,0.31979999f,0.17150002f,0.35279998f,-1.22610003f,-0.11739999f,0.02430003f,-0.64199998f,-0.12070001f,-0.21660000f,0.91340002f,0.26380000f,0.85559998f,0.99120000f,-0.80299998f,-0.08880000f,0.77860003f,0.14340001f,-0.73620000f,-0.39620002f,-0.07960002f,0.41180000f,0.01759998f,0.19040000f,-0.26530003f,0.69140003f,0.67509999f,0.39780005f,-0.42699999f,-1.43850003f,-0.10969999f,-0.83229998f,-0.49909997f,-1.84879999f,0.18689998f,1.39149997f,-0.07100000f,0.66009998f,-0.69529998f,-0.43600003f,0.90849997f,0.17670002f,0.63769998f,-0.43769998f,-0.53109997f,-0.17760003f,0.80029998f,1.28639999f,-0.08430000f,-0.52679997f,0.23639999f,-0.47979996f,-0.54249999f,-1.37049997f,-1.36040003f,-0.64380002f,0.17320002f,0.29180003f,-0.03950002f,0.11780003f,0.96300001f,0.23700001f,-0.77370001f,-0.50720000f,1.25960002f,0.37720000f,-1.37889997f,-0.56799998f,1.73719999f,0.94079999f,-1.16380000f,-0.30319999f,0.34820001f,-0.32720001f,-1.80600003f,-0.98800002f,0.56400000f,0.06600000f,0.77750000f,0.65000002f,0.29760000f,0.31539999f,-0.88360002f,-0.13560001f,-0.57989999f,-0.68939998f,0.60829999f,0.18300001f,0.08130000f,0.24780000f,0.35019999f,0.43900001f,-0.84119998f,-0.36560001f,0.47370000f,0.26650000f,-0.06120000f,0.18840001f,0.40040000f,-0.66699998f,-0.46249998f,0.49489996f,-0.04830000f,0.47069999f,-0.86829997f,-0.09669997f,0.54729997f,0.17670001f,0.60819998f,-0.10149997f,-0.60649999f,-1.16050002f,0.67270003f,0.71260003f,-0.11140002f,0.41440002f,1.08160002f,0.58680003f,-0.66900000f,-0.25079998f,-0.66590002f,-0.91280001f,1.07109999f,0.22039999f,-0.61819998f,-0.01239998f,0.23339997f,0.03259999f,-0.00169999f,-0.47340002f,-1.48190001f,-0.78640000f,1.03419999f,0.03039999f,-0.15820001f,0.38460000f,-0.62689999f,-0.53799998f,1.56510002f,0.68239999f,0.59989997f,-0.86160000f,0.87420001f,-0.25139994f,0.50579998f,0.14359999f,0.86380000f,0.54120004f,0.34259998f,1.58980000f,-0.77440001f,0.14519996f,0.09910000f,-0.51869998f,0.67319997f,0.94790002f,-0.71299997f,-0.25050001f,-0.63179999f,-0.35000002f,-0.55630001f,0.68449994f,0.29700000f,-0.34389996f,0.66599996f,0.98939997f,0.30739998f,0.98120003f,0.00310001f,-1.31900001f,0.26219998f,-0.26960001f,-0.54170004f,0.10580001f,0.83900002f,-0.28660001f,-0.25049998f,-0.00880000f,-0.58020000f,-0.02999998f,1.45179998f,0.65219999f,0.18550000f,0.70500000f,0.97609999f,0.81720000f,0.56479999f,0.33479999f,-1.46969997f,-0.60519999f,-0.06420001f,-0.41040002f,-0.46380001f,-0.01599998f,0.76560001f,-0.18520001f,-1.70610000f,-1.02580001f,0.74259995f,0.90749997f,-0.71939997f,-1.47889998f,0.62979998f,1.93630001f,-0.31809998f,-0.25070000f,0.55990000f,0.36050004f,0.14080000f,0.22890002f,0.17240000f,-1.36689995f,0.56569998f,-0.44049996f,0.53080000f,0.05680000f,0.65469997f,0.57289998f,-0.39120000f,0.61799997f,-0.24800000f,-0.41019999f,0.18029999f,1.19629999f,0.07990000f,0.69420000f,-0.74059997f,-0.03579997f,-0.36390001f,0.27440002f,1.59670002f,0.64279999f,-0.13480001f,0.56960000f,0.66780001f,0.15259999f,-0.38420000f,-0.29660004f,-1.18260001f,-0.39700001f,-1.34130001f,-1.02340001f,-0.09489999f,-0.73300001f,-0.34410000f,0.31720003f,0.52149998f,0.10980002f,0.45980000f,-0.18900002f,-0.94430001f,-0.41760000f,0.34439998f,0.13160001f,-0.47749999f,-0.53340000f,1.65579998f,0.03290001f,0.57980001f,0.79080006f,0.70739997f,-0.58399998f,0.32090001f,0.35320002f,0.74679998f,1.33950001f,-0.45929999f,-0.56940002f,-0.66759999f,0.02069998f,-0.85339998f,0.82989998f,-0.83829997f,-1.44969998f,0.74919997f,0.83510000f,0.52809999f,1.26440003f,-0.52640000f,-0.70900003f,-0.71830000f,-0.76290003f,-0.13500000f,0.08910001f,-0.71579999f,-0.76269999f,0.52750002f,-0.13400000f,-0.71030002f,0.03620001f,0.88010000f,0.44040001f,0.02120001f,-0.05099999f,0.16730001f,-0.17740001f,0.01070000f,-0.06960002f,-0.92740000f,-0.63540002f,-1.15210001f,-0.62480000f,-0.25789999f,-0.22959999f,0.66769999f,-0.15780002f,0.42030001f,0.55000000f,0.05469997f,0.35819999f,-0.72500002f,-0.06199999f,0.14149999f,-0.36280001f,-1.15270003f,0.34869997f,0.85539999f,0.65970005f,-0.26990000f,-0.60510000f,-0.02530000f,-0.30460003f,0.82329997f,1.70040001f,-0.24769999f,0.07230000f,0.35120000f,1.01090000f,-0.73130001f,-0.36530006f,-0.56659999f,-0.26019998f,-0.57800000f,0.08409997f,-0.72970000f,-1.50430001f,-0.34979999f,-1.58950000f,-0.77780001f,-2.01400004f,-0.57519998f,-0.11160000f,-0.30750000f,0.29219997f,-0.72290000f,-0.33240000f,0.03639998f,0.00499999f,0.67729998f,0.01499997f,-0.47009997f,0.31920003f,-0.17370002f,-0.26999999f,1.62979999f,0.93019999f,0.28159999f,0.32279998f,-0.57810000f,0.36620002f,-0.37100000f,-0.78580003f,-0.50520002f,-0.25000001f,0.59520000f,0.08559999f,0.07970000f,-0.10140002f,-0.90200001f,0.10720003f,0.85820002f,0.19380003f,0.88300000f,-0.22910001f,-0.44279998f,-0.47709996f,-0.80859999f,-0.67150003f,-0.72099997f,-1.94660000f,0.56699999f,0.77599999f,0.31739998f,0.37810003f,0.56559998f,-0.22680000f,0.26150000f,-1.02079997f,0.22649999f,0.97560000f,-0.71280001f,-0.39980001f,-0.75920000f,-0.62020003f,-0.63769999f,-0.63900003f,0.18750000f,-0.58149997f,0.32449999f,0.61519999f,0.61470001f,1.06750001f,0.57460000f,0.99320002f,-0.37609999f,-0.03780001f,-0.49409996f,-0.39259996f,-0.30550004f,-0.24240000f,-0.19390000f,-0.35619999f,-0.04690002f,-0.49880000f,1.77780004f,1.02240000f,-0.25299998f,-0.02919999f,-1.05029999f,-0.44740000f,0.21899999f,0.03420001f,-0.27640002f,-0.19600000f,-1.03370002f,-0.97620002f,0.28230000f,-0.06820000f,0.97780000f,0.64420002f,-0.63109999f,-1.80630001f,0.86340000f,0.19610004f,0.40259998f,0.94229997f,0.66660001f,1.40440002f,-0.05550000f,0.52100000f,0.65529998f,2.04209999f,0.58489996f,0.99010005f,0.87800002f,0.37220002f,0.53800000f,0.77170002f,-0.28789999f,0.06359999f,0.16180000f,0.29719999f,0.62229998f,1.78740001f,-0.90240000f,-0.24210000f,-0.42540000f,-0.94050002f,0.77099998f,1.03039999f,0.53610000f,-0.11660002f,-0.18040000f,-0.24060002f,-0.19110001f,0.22339999f,-0.26560000f,-0.20779999f,0.90260002f,0.71560002f,0.49220000f,0.59480001f,0.52250004f,0.29000001f,0.08909999f,0.18539999f,-0.62300002f,0.10000000f,-0.71540001f,-0.43579999f,1.88710002f,0.59140000f,-0.49799999f,0.01480000f,-1.08640003f,-0.11219998f,1.02480002f,0.32600002f,0.77120001f,0.04400001f,-0.60760000f,-0.36550006f,0.05160000f,-0.19629998f,-0.18240000f,-0.26750003f,0.51259997f,0.43859999f,0.82530001f,-0.05049994f,0.74639997f,0.55180000f,0.63320002f,0.52270004f,0.09880000f,-0.73499998f,-0.88030001f,-1.30120007f,-0.19010000f,0.65179999f,0.86169999f,0.45370002f,0.24170000f,-0.43419999f,-0.20850000f,-0.07449999f,0.78090000f,0.95920006f,0.20120000f,0.04060001f,1.02960002f,0.33340000f,-1.38680002f,-0.60020001f,0.19080000f,-0.36300001f,0.31200004f,-0.09560000f,0.18190000f,0.26699999f,-0.48350001f,0.06019998f,-1.29919998f,-0.20659998f,0.73259998f,0.10060000f,0.76950001f,0.43160001f,-0.96710003f,-0.28559999f,0.37700002f,-0.34700002f,-0.13310002f,-0.24440003f,-0.02749999f,0.02119999f,-0.97640000f,-0.18380004f,0.52529998f,1.00140000f,0.39469999f,0.18460000f,-0.91880000f,-0.00110005f,-0.15400000f,0.67359997f,-0.18629998f,-0.20640004f,0.83859998f,0.63530000f,-0.72549996f,-1.81219998f,-0.20730000f,0.19179998f,0.13940000f,0.03660001f,0.82969997f,0.50449998f,0.21840000f,1.40950004f,-0.51050001f,-0.03870005f,-0.58760001f,-0.53680005f,0.35050000f,0.13280002f,0.95569998f,0.41699999f,0.03270004f,0.19559999f,-1.60190002f,-0.79220000f,0.31659999f,0.10000000f,0.42739999f,0.16480000f,0.74500002f,0.43960000f,-1.09289999f,-0.43840000f,0.99259999f,0.74800003f,-0.61639999f,-0.06059998f,0.28310002f,-0.32759998f,0.58669998f,0.05800000f,-0.16690000f,0.07920000f,0.38480000f,0.52480002f,0.24039999f,0.09619999f,0.90459996f,0.60449999f,0.70750000f,0.42290007f,-0.41820001f,-0.68810007f,-0.62469998f,-0.23389997f,-0.17120000f,-0.34120001f,0.15900000f,-0.09619999f,-0.62929996f,-1.36910001f,0.11990000f,0.02050001f,0.82969998f,-0.04499997f,-0.57740000f,-0.09560007f,0.37479999f,1.24259998f,0.86439997f,0.90120003f,-0.40439998f,-1.29119998f,0.83979999f,0.65230006f,-0.63559997f,-1.55959996f,0.84580003f,0.84200002f,1.08209998f,1.04440000f,-0.76980001f,0.09460001f,0.65920003f,0.00200000f,0.73350002f,0.70460001f,0.36079998f,0.42959999f,0.13770005f,0.14420001f,-0.63210001f,0.19200001f,-0.15830000f,-0.19620000f,0.37839998f,-0.14240004f,0.14750002f,0.46140000f,-1.03410003f,-0.20140002f,0.95550002f,0.01699999f,-1.43080002f,-0.63740001f,0.60040000f,-0.40809994f,0.75439999f,-0.50899997f,0.86259997f,-0.45570000f,0.54499999f,1.20700004f,0.16930000f,-0.31019999f,0.45730000f,-0.33570000f,-0.21129999f,-0.60340003f,0.78870000f,0.22310002f,-0.15499999f,-0.22330002f,-0.24249999f,0.43470000f,-0.46780000f,-1.09210001f,0.23669999f,-0.61639997f,-0.85740001f,-0.24410006f,0.81340001f,1.14170005f,-0.48190000f,0.65249998f,-0.77080002f,-0.58300002f,-0.69080002f,-0.40980000f,-0.00710000f,-0.37640000f,0.97979999f,0.38619998f,-1.00030001f,-0.19140000f,1.02240002f,0.18199998f,-1.27070003f,0.08580001f,0.35999999f,-0.16419999f,0.69800002f,-0.07140001f,-1.48529999f,-0.84100001f,1.04849996f,0.46039999f,0.65290003f,0.85000002f,-0.67029999f,-0.01799998f,0.32349998f,-0.07240000f,0.18200000f,0.02270000f,0.05030002f,-1.48199996f,0.82669999f,-0.67089999f,1.36659999f,1.06590000f,-0.91550001f,0.59180000f,-0.87200000f,-0.02789999f,-0.61590003f,-0.26299999f,1.08670001f,0.86339999f,0.46379997f,0.61920000f,-0.56040000f,0.25280000f,-0.08290002f,-0.96979997f,0.78209998f,-0.16729999f,-0.57139998f,-0.30400001f,0.61530001f,0.28710003f,-0.15879999f,-0.66229998f,0.71879999f,-0.01400000f,0.71329998f,-0.16699999f,-0.48610001f,-0.53740003f,0.36559996f,0.15980000f,-0.56069997f,0.84519999f,1.52939998f,-0.19600000f,-0.78739999f,0.22680001f,0.26160002f,-0.00600000f,0.75580001f,0.00320001f,0.22929999f,0.00740001f,-0.97169999f,0.49200000f,0.63920002f,-0.28340000f,0.71829998f,0.01020002f,-1.25959999f,0.32059999f,0.07609998f,0.74359998f,-0.15470000f,0.13220002f,0.21159999f,0.56929999f,-1.18629999f,-0.71840002f,-0.28120001f,1.64639998f,-0.14960002f,-0.51799999f,-0.16759998f,0.40130002f,-0.14130001f,0.09690000f,-0.26200000f,-0.02540001f,0.92139999f,-0.60450000f,0.55140000f,0.76020000f,0.09399998f,0.51640000f,-0.00319999f,-0.66080000f,0.76860001f,0.85269999f,-0.74040000f,0.83339999f,-0.46680001f,0.01639997f,1.04809996f,0.64259999f,0.42230002f,-0.34520002f,-1.02400003f,0.64300000f,0.71210006f,0.56920002f,-0.51439998f,0.07920000f,-0.01329997f,-0.31159999f,-0.89919999f,-0.32980000f,0.99330000f,-0.18340000f,0.10029998f,0.43320001f,0.35080003f,0.20840002f,0.35529999f,-0.92720001f,-0.14030000f,-0.40460000f,-1.38670002f,-0.09700001f,0.89960002f,0.75889996f,-1.01899999f,-0.15410002f,0.56759995f,-0.21140002f,0.05060001f,0.05330001f,-0.13430003f,-0.14219999f,0.96689998f,-0.10019998f,-0.14170001f,-0.35179998f,0.38620000f,0.56830001f,-0.74929998f,-0.66260000f,0.49990001f,0.15810001f,0.98719997f,0.77250001f,0.74790000f,-0.09479996f,-0.36999999f,-1.30630002f,0.05020002f,0.25350000f,-0.98410001f,-1.26870004f,-0.90960003f,0.25940000f,-0.98690000f,0.65880000f,0.84030002f,0.36180000f,0.12869998f,0.50619999f,2.15820000f,-0.03220000f,-0.65170000f,-0.79719998f,-0.70399999f,-0.04859999f,0.08729996f,-0.01940000f,-0.81949995f,1.04220000f,0.66760004f,0.05260000f,-0.04160005f,-0.18379998f,-0.62589998f,-0.59860002f,0.19869998f,0.53759999f,0.22910003f,0.49780000f,1.30900000f,-0.77320002f,0.22349999f,1.64170000f,-0.37620004f,0.83059998f,-0.42510000f,1.33609998f,-0.49960003f,-0.85150000f,1.15580000f,-0.41839997f,-0.23599996f,0.20800001f,0.07620001f,-0.70179998f,-0.51260000f,0.53299999f,0.13559998f,1.03519998f,0.03110000f,-0.57919998f,-0.85479997f,-0.36979999f,-0.96959999f,-0.46050001f,0.72489996f,1.17709997f,0.73169997f,0.06569998f,0.87590005f,-0.67380003f,0.47989995f,0.32900002f,0.10210006f,0.32300002f,-0.39989998f,0.24760001f,0.04290003f,-0.34720000f,-0.37260005f,0.25180000f,0.68460000f,-0.66559998f,-1.32140000f,1.03999999f,1.14100002f,-0.20859999f,-0.46200002f,-0.53220000f,0.46980002f,-0.96820002f,-0.09960008f,-0.01780000f,-0.47439996f,0.73880002f,-0.26199996f,0.60820000f,1.52250001f,0.23079998f,-0.40589999f,-1.15619999f,1.05589998f,0.08710001f,1.41140000f,0.29270001f,0.42650000f,0.55069999f,0.16890002f,-0.06670002f,-0.48140000f,-0.78779996f,0.07050002f,0.63059999f,0.06189994f,0.52570000f,0.17640000f,-0.14499999f,-1.02009997f,-0.78280003f,-0.12099996f,-1.24899999f,0.43750000f,0.05900001f,0.86299998f,1.74910000f,0.30669997f,-0.23760000f,0.34680000f,0.69400002f,0.45430004f,0.53880001f,-0.32519995f,0.56040002f,0.35860003f,-0.29000000f,-0.66379998f,-0.88560001f,-0.79220002f,0.20339999f,0.99239998f,-0.09919999f,-0.99979994f,0.31799999f,0.19409995f,-0.52760001f,0.97929997f,-0.76980000f,-0.99880000f,-0.14120001f,0.36739999f,0.37999999f,0.08210004f,-0.71079999f,-1.86180002f,0.79939999f,0.70540002f,-0.31120001f,0.56529999f,0.03160003f,1.26319997f,0.12959999f,0.68340001f,-0.59899996f,0.81560000f,-0.15409998f,0.00710002f,-0.11420002f,-0.25430000f,-1.17069996f,0.79529998f,1.10739997f,0.47229997f,0.62090000f,-0.94269998f,-1.04359997f,0.18580000f,-0.40610003f,-0.63079998f,-0.76359998f,0.74079997f,-0.85549998f,0.25700003f,0.95420000f,-0.23080007f,0.26330000f,-1.05399999f,-0.18760000f,1.56759999f,0.14359998f,-1.71950000f,-0.40460000f,0.35169996f,-0.21740001f,0.07460000f,0.03760002f,-1.01699998f,0.73919999f,0.92990000f,0.80699999f,-0.12529997f,0.90319999f,-0.12139998f,0.11460000f,0.33440001f,-0.64799998f,-0.44220000f,-0.49280002f,0.56719998f,0.07140001f,-1.06460000f,-0.36540001f,0.35199998f,-1.08280001f,-0.81050005f,0.44069999f,-0.48930000f,-1.44790001f,1.39039998f,0.89209997f,-1.03079996f,-1.13870001f,-0.28889999f,-0.60309999f,0.80450000f,1.02959998f,-0.04590002f,0.29760000f,0.78299995f,0.95279997f,0.42759995f,0.38650000f,-0.70409998f,-0.42099996f,-0.16759998f,-0.45140000f,-0.44920000f,-0.94249999f,1.00149998f,0.24560000f,-0.80360001f,-0.79420001f,-0.33489999f,0.52449998f,0.24850005f,0.31720001f,-1.25240003f,0.52520000f,0.40080005f,0.68699999f,-0.27860002f,-0.15440002f,-1.05810001f,-0.44540002f,0.67529997f,-0.34240000f,0.69049998f,-1.03320002f,-0.74030006f,-0.78500000f,1.30169995f,0.40880002f,-0.41239993f,0.13660000f,-1.15950000f,-0.13040001f,0.86710000f,-0.24099999f,0.35720001f,0.31160001f,0.26599999f,-0.42360000f,-0.49770002f,-0.82860004f,1.06320001f,0.64790002f,-0.35710002f,0.37749997f,0.59679997f,-0.00790001f,-0.83820001f,0.46869999f,-1.51880000f,-0.25010001f,-0.37749999f,-0.62690002f,-0.24169998f,-0.19340002f,-0.95099997f,-1.75379996f,1.68359996f,-0.17020001f,1.09939999f,0.98410001f,-0.38050001f,-0.03619999f,0.39820000f,0.05729999f,0.77180000f,0.43370001f,0.11730000f,0.49269996f,-0.01760000f,-0.50200002f,-0.33419998f,0.25820001f,-0.02109999f,0.63060001f,0.70480002f,-0.28179999f,-1.40889998f,-0.23980001f,-0.03730003f,-0.29760003f,-0.46820002f,-0.70060000f,0.72790001f,-0.57480000f,0.21459996f,0.01360001f,-0.52820001f,-0.06140000f,0.44969997f,0.78760001f,0.77280001f,0.67320001f,1.77190003f,0.20480000f,0.15899998f,-0.39700001f,0.50080001f,-0.74320000f,-0.59849999f,-0.16759999f,0.93409999f,0.82230000f,0.59219998f,-0.81719998f,0.16150003f,0.34070000f,-0.66820000f,-0.61800002f,-0.75780000f,0.06270002f,-0.97369996f,-0.85880000f,0.14810004f,-0.10069998f,0.85919999f,1.12020001f,-0.58240001f,0.96140000f,0.08799995f,1.79750002f,0.04409996f,0.55339998f,0.77099998f,0.20779999f,-0.30939999f,-0.99550000f,0.50300001f,-0.24160000f,0.05579998f,0.32199999f,-0.07370000f,0.10679999f,1.71189996f,0.35640003f,-0.07099995f,-0.36280000f,-1.25399999f,1.01599999f,0.08690004f,0.23939999f,0.98440001f,0.54780002f,-0.30369999f,-0.84720003f,0.22549997f,-0.02080000f,-0.08260001f,0.25780000f,0.50359998f,-0.30140003f,0.89609999f,0.22780002f,-0.51199996f,0.12820001f,-0.98569998f,-0.04160000f,0.23530001f,0.81800000f,0.53849996f,1.44509995f,-0.86249999f,-0.89989998f,0.92909999f,-0.49069998f,0.42100002f,0.56399999f,0.32359996f,0.84089997f,-0.54059999f,-0.20329999f,1.16259999f,0.57250002f,-0.67790000f,-0.10380001f,0.42199998f,1.07769999f,-0.24170002f,-0.16270002f,-0.84970000f,-1.06739999f,1.33810000f,-0.17240001f,0.50540001f,-0.22670003f,0.88650000f,1.02040001f,0.35520002f,-0.18040001f,-0.04710000f,-0.67799998f,-0.84389996f,-0.21140000f,0.19939999f,-0.55140001f,-1.02189997f,-0.77940001f,-1.80200001f,1.01119999f,0.14140001f,-0.29920000f,-0.08820000f,-0.47220000f,-0.14630001f,0.02840001f,0.30690002f,-0.35900001f,-0.70499997f,-0.92720001f,-0.14910004f,0.11880000f,0.34850000f,0.67560002f,-0.39209996f,-0.01050003f,0.42959999f,0.04030002f,-0.10790000f,-1.50109999f,-0.01329997f,-0.61159999f,0.47480002f,-1.51050000f,0.53440002f,-1.46709999f,0.01610006f,0.11549997f,0.14769995f,0.00279999f,-0.72909997f,-0.52059998f,-0.07370000f,-0.46510000f,0.23860000f,-1.16010000f,0.44400002f,-0.17840000f,-0.00609995f,-0.15850000f,0.53289999f,-0.18320000f,0.80659999f,1.01760004f,-0.35230002f,-0.05440000f,0.35469999f,-0.44720001f,-0.09110001f,0.33920000f,0.66330000f,-0.42119999f,-0.80189996f,0.70460002f,-0.03039998f,0.57680000f,-0.45959997f,0.11760000f,-0.54320000f,0.12159999f,0.43110000f,0.44220002f,1.57880003f,-0.38380000f,-1.33670002f,0.38379999f,-0.07229998f,-0.12500000f,0.82420003f,0.10420002f,-0.08150000f,0.28220000f,-1.40880000f,1.26880002f,-0.63330001f,-0.37620002f,-0.95979998f,0.10169999f,0.08719999f,-0.81979997f,-0.11289996f,-0.31910002f,0.51330000f,0.23230002f,0.48889998f,0.15549998f,-0.34700000f,0.33830000f,-0.52630000f,1.05510003f,0.42049999f,-0.44200000f,0.64260002f,-0.01450002f,-0.58730000f,-0.06440000f,-0.49909998f,-0.48860000f,1.24940003f,-0.42720001f,0.79400000f,1.96329997f,0.16999999f,-0.02100000f,-1.20449999f,0.23060000f,0.42510003f,-0.47360000f,-0.07830003f,-0.50000001f,-0.89810004f,-0.26339999f,0.00799999f,-0.08120001f,-0.74509996f,0.16219999f,1.96049995f,-0.06299998f,-0.37449998f,0.11880000f,-0.23530001f,0.28540000f,0.38300008f,-0.31760000f,-1.25880004f,-0.36700001f,-0.19050000f,-0.25840001f,0.36579998f,-0.17060001f,0.30160000f,-1.20439998f,0.58580000f,0.35240001f,-0.41880001f,0.34450002f,-0.07910000f,-0.39020000f,-0.70899998f,0.17910001f,-1.40079999f,-0.85839998f,-1.11250000f,1.07799996f,-0.87039999f,-0.63359997f,0.89119999f,0.09969999f,0.25730000f,-0.32059998f,0.01979998f,-0.73560002f,0.66470003f,0.49570003f,-0.65100000f,0.34300001f,-0.92519999f,-0.64480002f,-0.64739999f,-0.31420000f,-0.88209998f,0.26419999f,-0.62650004f,0.27960000f,1.37080003f,-0.79620000f,-0.14310004f,0.26320000f,0.15060001f,0.19800000f,-0.70699999f,0.67700002f,1.83299998f,-0.56540001f,-0.51640000f,0.80780002f,0.39760005f,0.26280002f,0.41050001f,-0.48479998f,-0.93279998f,-0.20560001f,-0.81339997f,0.24160000f,0.96459999f,0.54520001f,-0.70479997f,0.33599999f,0.55609998f,-0.32540003f,-0.25399998f,1.13700004f,-0.57420004f,-0.44980001f,-0.08859998f,-0.22230000f,0.62949997f,0.19259999f,0.30289999f,1.76709998f,-0.31620001f,-0.75509999f,0.03780001f,-0.48379999f,0.96449999f,0.94070005f,1.15769997f,-0.66809997f,0.17970001f,-1.06789998f,-0.14999999f,0.57309998f,0.17809998f,-0.59800001f,1.05489997f,1.51119997f,0.21609996f,0.72999996f,-0.00999999f,0.86640002f,-0.15079996f,1.05879999f,1.06600007f,0.07800000f,-1.06530002f,-0.10100000f,-0.32600001f,0.74060001f,-0.15549996f,0.51780000f,0.55979997f,-0.19100000f,-0.11809997f,0.33720002f,0.31780001f,-0.17500000f,-0.71270002f,-0.19640002f,0.45399997f,0.46900001f,0.77330002f,0.07719998f,0.04669998f,-0.33640002f,-0.17850000f,-0.64420000f,-0.98510002f,0.74110002f,0.41949997f,0.84530001f,0.26019996f,-0.32020002f,0.85580002f,0.25890001f,-0.37200000f,0.28210000f,0.10279997f,1.42439999f,-0.48120000f,-0.48929999f,-0.93539999f,0.09700002f,0.39600000f,0.26240000f,-0.04759999f,0.68309999f,-1.11469998f,-0.02720000f,-0.17230001f,0.79840002f,0.48929996f,-0.68950005f,-0.81550000f,-0.56089999f,-0.05369998f,0.32629996f,-0.77789997f,-0.70040003f,0.12909998f,-0.32740000f,-0.27250002f,-0.30520000f,-0.75660002f,0.59040001f,1.83250003f,-0.15740000f,-0.95630003f,0.01699999f,1.38560002f,0.25979999f,-0.23429999f,-0.16560000f,-0.97470001f,-0.26760001f,0.11829998f,-0.82200001f,-0.49510002f,0.54319999f,0.55299999f,0.91320001f,0.62520002f,0.21700001f,0.25640001f,-0.07600000f,-0.30299999f,1.27850001f,0.17979999f,-0.27940000f,-0.52819997f,-0.25359998f,-0.81639997f,-0.37769999f,0.31519999f,-0.15630000f,0.61759999f,-0.38190003f,-0.18659999f,0.50000004f,-0.15280000f,1.27800002f,-0.18359999f,0.39810000f,0.19980000f,0.04359999f,0.00700000f,0.10299999f,-0.42659998f,-0.60079999f,0.63739998f,0.29850000f,-0.15180001f,0.80610005f,0.51640000f,0.67540000f,-0.65509999f,-0.39549999f,-0.45990001f,0.04329999f,-0.30689999f,-0.73899998f,-0.55980001f,-0.16290000f,-0.68469998f,-1.29859996f,-0.46660000f,0.37259998f,0.21379998f,-0.40980001f,-0.22830000f,-0.17320000f,-0.06340000f,0.45110000f,0.12600000f,0.72529999f,0.17650000f,-0.43500000f,-0.19619999f,-0.05509999f,-0.20290002f,0.65399999f,-0.05029999f,-0.84269998f,-0.43729998f,1.08050000f,0.34159999f,1.03600001f,0.28639999f,0.29570001f,0.88360000f,-0.55430004f,-0.19040000f,0.49430000f,0.09680000f,0.22920002f,-0.19479999f,-0.53819998f,0.03780000f,0.00740001f,0.05320000f,0.86730000f,-0.00340001f,0.48059998f,-0.46919999f,-0.07390000f,-0.17799999f,0.83990003f,0.43639999f,0.72610001f,-0.29340000f,-0.24430000f,0.05160000f,-0.14100001f,-0.71689999f,-1.04729996f,-0.84619998f,-0.07390000f,0.41110002f,0.51420000f,0.05359998f,-0.40470002f,0.14439998f,0.49399998f,0.64729999f,0.25329998f,0.78949999f,0.56579998f,0.05119999f,-0.56649999f,-0.33320001f,0.46870000f,-0.16680001f,0.28179998f,-0.21560002f,0.12289999f,0.18489998f,0.36709997f,0.29899997f,0.62150000f,0.32650001f,-0.65780000f,0.10700001f,0.32970000f,0.53059999f,0.40099995f,-0.51119997f,-0.04710001f,-0.02839999f,-0.86390002f,-0.52539997f,-0.14309998f,-0.78779998f,-0.80789999f,-0.43279998f,-0.58629999f,0.04040000f,0.10030003f,0.64579999f,0.52340001f,0.02180000f,1.04389999f,-0.37999999f,1.59350004f,-0.03480000f,0.74360005f,0.69700000f,-0.59560001f,-0.05680001f,-1.09330003f,0.30760000f,-0.78990005f,0.42130000f,0.25090000f,-0.30099999f,-1.22230000f,-1.06599999f,-0.78169998f,-0.98259998f,-1.19579998f,-0.41889999f,1.05529999f,0.97949998f,0.62299997f,0.05439999f,-0.24589999f,-0.19930001f,0.07909998f,-0.04230001f,-0.67179999f,-0.20109998f,-0.30499998f,-0.10820000f,-0.07550002f,0.69610001f,-0.18210000f,-0.24770000f,0.12969999f,-0.34069999f,-0.22419998f,-0.42759999f,-0.98570004f,-0.49259998f,0.18300000f,0.15900000f,0.76200000f,0.09059999f,0.69169999f,0.27699999f,1.00389999f,-0.44959998f,-0.30389997f,0.32959998f,0.18150002f,0.35159998f,-0.54260001f,-0.30759998f,-0.99710000f,-0.66059997f,0.69040002f,0.25239998f,-0.78570002f,-0.09920000f,-1.77300000f,0.51119999f,-0.17780004f,-0.49719997f,1.47970001f,-0.08280000f,1.87940000f,0.08820002f,0.09330002f,-0.07740002f,0.80829997f,0.55199998f,0.82729999f,0.26649999f,0.25830000f,0.24410001f,0.07080002f,-0.49769999f,-0.40879999f,0.59770000f,0.73319997f,-0.37810001f,-0.85080000f,-0.13669999f,0.12459999f,0.03870000f,-0.27460000f,0.36900003f,0.48580004f,0.06670000f,0.65119998f,0.28279997f,0.21779999f,-0.31200000f,-0.71469999f,-0.32180000f,0.21100001f,0.61379999f,0.07559996f,-0.73699998f,0.75980003f,-0.57199999f,0.53100003f,-0.38359999f,0.69710003f,0.48059998f,-0.00220003f,-0.16540000f,-0.63459999f,0.19259999f,-0.18700004f,-0.51339998f,0.75480000f,0.24299999f,-0.40200000f,0.48999998f,-0.28300001f,0.75579997f,-0.19780003f,-0.41679997f,-0.16219997f,-0.78919998f,1.22010004f,0.05300000f,1.29790003f,-0.29150001f,0.16450000f,0.41030001f,0.69799998f,0.40899998f,0.39580000f,0.99640001f,1.13779998f,0.98199999f,0.54879999f,-0.30850002f,-0.36879998f,0.35259999f,1.08899995f,0.29910000f,-0.32829998f,-0.48649998f,-0.51849999f,-0.01430001f,0.68099997f,0.10709998f,-0.20119998f,0.17100000f,0.53169998f,1.17159997f,1.12059997f,-0.05540002f,-1.03380001f,-0.65270000f,-0.10910003f,-0.82240000f,0.23550001f,-0.80599997f,0.03420002f,-0.81720000f,-0.28519997f,-0.35359998f,0.06000005f,0.64419999f,0.00600000f,-0.02800000f,-0.33600000f,-0.57179997f,0.65510000f,0.13639999f,0.84619999f,0.76839998f,0.20930001f,0.44300000f,-0.61660001f,0.08120000f,-0.61850001f,-0.68259996f,-0.66349996f,-0.04520000f,-0.37020003f,-0.14899998f,-0.09930002f,0.01259999f,-0.56279998f,-0.20669999f,1.28430000f,0.75400001f,-0.55809997f,0.01230002f,0.28900000f,0.56440000f,0.67619999f,-0.23130000f,-0.73449998f,-0.51329999f,0.05929999f,-0.20610000f,-0.34540000f,0.10000001f,-0.34760000f,0.56299998f,0.35379997f,0.19079999f,0.03720000f,0.10359998f,0.81819998f,0.52000000f,-0.21280001f,0.53530001f,0.50249999f,-0.66149999f,0.08419999f,0.57899997f,0.53809997f,-0.80179996f,-0.48239999f,0.59879997f,-1.06490004f,-0.14160000f,-0.43060001f,-0.33500000f,0.30530001f,-0.27839999f,0.54699999f,-0.76079996f,0.38009998f,-0.65799997f,-0.71099999f,-0.15239999f,-0.73539996f,0.43399998f,-0.34060001f,0.40480000f,0.14379998f,-0.42639998f,-0.49320001f,0.30980000f,-0.51830004f,0.78759998f,0.66549995f,0.51430000f,0.81200002f,0.31240002f,-0.47980001f,-0.14670000f,-0.08819999f,0.30730002f,-0.12110001f,0.31440002f,-0.97789999f,-0.53109999f,-0.28189999f,0.04950002f,0.46610001f,-0.04049999f,-0.35769998f,-0.25450002f,1.29819995f,1.01699998f,1.00649999f,0.43810001f,-0.43710000f,-0.40190002f,0.20459999f,-0.45330002f,0.21620001f,0.05740000f,0.17549999f,-0.84890000f,-0.62230001f,-0.72120000f,-0.61680001f,-0.40099998f,-0.06700001f,-0.54219998f,-0.90430003f,-0.08459998f,-1.53720003f,0.83599999f,-0.01760002f,0.55959998f,0.46199999f,0.80359998f,-0.01900004f,0.94919996f,0.29749997f,-1.02839995f,0.17990002f,-0.65599998f,0.18640001f,0.42880000f,1.05470003f,0.31579999f,1.27240002f,-0.25640000f,1.08050003f,0.45239999f,0.50479995f,0.50910001f,0.49659999f,0.52970000f,0.33330000f,-0.46360001f,-0.21040000f,0.37649999f,0.85369998f,0.72740000f,-0.40709999f,-0.00789998f,-0.10839999f,0.31260001f,-0.41050000f,-0.17360002f,0.43800002f,-0.17290001f,0.37479999f,-0.49300001f,-0.77690000f,-1.33450002f,-0.94820001f,-1.34520001f,-1.08230001f,-1.05730001f,0.10220001f,-0.15119999f,0.01640001f,0.42250000f,-0.79020001f,-0.12059999f,-0.38670001f,-0.22219999f,1.30490002f,-0.34499999f,-0.26969998f,-0.40179999f,-1.07720000f,0.40359999f,-0.99250005f,0.13560001f,-0.84269998f,0.87739998f,0.26750004f,0.40659998f,1.18160001f,0.02880000f,1.15230003f,0.57879999f,1.21949999f,-0.06159999f,1.94750003f,0.20640001f,2.17730002f,0.00240000f,0.80520000f,0.36579999f,-0.04329997f,-0.05850000f,0.21700000f,-0.57970000f,-0.32890000f,-1.04109999f,-1.17549996f,-0.69050001f,0.65639997f,0.92409999f,0.88659999f,-0.04320001f,-0.53069999f,-0.15579998f,-0.55239997f,-0.21050000f,0.46389999f,0.49770001f,-0.00830000f,-0.46750002f,-0.03180001f,-0.87000001f,-0.79659999f,-0.46139998f,-0.26229999f,0.20699999f,0.99539998f,0.65479999f,0.58490000f,0.69190003f,0.50240000f,0.22339999f,1.52409999f,0.16440001f,1.39540000f,0.61559997f,0.55489999f,-0.68339999f,-0.29099995f,-0.19719999f,-0.27270000f,-0.67459997f,-0.17349999f,-0.03300000f,0.40230002f,-0.63159999f,0.40700005f,0.81560000f,0.84330000f,0.26920000f,1.40760002f,0.33679999f,-0.09910003f,0.25060000f,-0.12870002f,-0.64959999f,-0.04289999f,-0.51320000f,-1.39310003f,-0.97240000f,-0.29699998f,0.51600003f,0.31329999f,1.07889998f,1.05469997f,0.98030000f,0.57620001f,0.90750000f,1.35229998f,1.63329999f,1.14400000f,0.30880000f,-0.50519999f,0.49630003f,0.01260000f,0.57490001f,0.29509999f,0.06279999f,0.24409999f,0.72060000f,1.05820000f,1.10010001f,0.51650002f,-0.37030001f,0.08050000f,-0.33570003f,0.32389999f,0.47439999f,0.10689998f,-0.86399999f,-0.53369999f,-0.12639998f,-1.49460002f,-0.15680001f,-0.83710000f,-0.06140000f,-0.59270000f,-0.35679998f,-1.72709998f,-0.09559999f,-1.28340005f,-0.78099998f,-1.13560003f,0.02979999f,-0.86650002f,0.30259999f,-0.08760002f,-0.16660000f,-0.61849999f,-0.36419998f,-0.24049995f,0.72639998f,0.95280001f,0.02240000f,0.59640001f,-0.83899998f,0.28190008f,-0.39760000f,-0.76210000f,-0.35330000f,-0.26529999f,-0.31379999f,-0.38529999f,0.22499999f,0.62229998f,0.34369998f,0.08640001f,0.28640002f,0.16219999f,0.45810000f,-0.07620000f,0.15760003f,-0.49949999f,-0.68910001f,-0.58820001f,-0.37080002f,0.82450000f,0.10530000f,-0.43389999f,0.38120002f,-0.14159999f,0.15080000f,0.78110002f,0.30270000f,0.73760001f,-0.07469997f,1.02760003f,0.52920000f,-0.43060000f,0.39579999f,-0.21180002f,-0.02540000f,-0.36359996f,-0.11599999f,-0.94709999f,-0.78360000f,-0.33319999f,-0.69979997f,-0.88960001f,-0.25360001f,-0.88610003f,0.07960000f,1.12690005f,0.20560000f,1.49710006f,0.00360000f,-0.83300003f,-0.37059999f,-1.23690001f,0.06439999f,0.44670003f,-0.31040001f,0.38670001f,-0.73219999f,0.40069999f,0.14719997f,0.76189998f,0.41249998f,-0.37690001f,0.10130000f,-0.03310000f,-0.23590001f,-0.11450000f,-0.15360001f,-0.93640001f,-0.19290000f,-0.37110001f,-0.17329998f,-1.24309995f,-0.67209999f,0.67309997f,0.10489999f,0.15130000f,0.17929999f,0.13999997f,0.88249999f,0.98240002f,0.45730001f,-0.39350001f,-0.51070001f,-0.76819999f,-0.37980001f,-0.15559999f,0.23830001f,-0.20989998f,-0.45079998f,-0.79200000f,-0.13799999f,0.29420003f,0.63319999f,0.03760000f,0.43899999f,-1.03530002f,0.60699997f,-1.81470003f,-0.06679999f,-0.76320001f,0.60519997f,1.11659999f,-0.15320000f,0.45060001f,-0.18559999f,-0.62990000f,-0.51659997f,-0.58659998f,-0.23420000f,-0.21909998f,0.57000000f,0.01330003f,0.66600000f,-0.65640001f,0.06660000f,-0.19890001f,0.29110001f,-0.11949997f,-0.13889999f,-0.97260002f,-0.17860001f,0.45430000f,-0.26270000f,0.13519999f,-0.12590001f,0.11360000f,-0.68710000f,-1.29799997f,-0.33649998f,0.69379999f,0.16769997f,0.33979998f,0.24959998f,0.34869997f,0.29969996f,0.85299996f,0.95049998f,0.54459998f,0.36020000f,-0.32319999f,-0.30010000f,0.69679999f,0.16610002f,-0.51249998f,-1.06109998f,-1.07260001f,-0.36160000f,-0.27550000f,0.32040001f,0.55090001f,0.57159998f,0.63909997f,-0.17979998f,0.59380000f,-0.23179999f,0.86060000f,0.24059997f,0.51759999f,0.08100000f,-0.37320001f,-0.95519998f,1.32330007f,-0.13319999f,0.49250003f,-0.11820000f,-1.60640000f,-0.34679998f,-0.33680000f,0.08860000f,0.54739996f,-0.91659997f,0.79389998f,0.17119999f,1.25689996f,-0.04819999f,-0.19740001f,-0.22370000f,-0.47380000f,0.46440000f,0.88270001f,0.63340001f,-0.10280000f,-0.32250001f,-0.47010001f,-0.53049998f,-1.04499997f,-0.23069999f,-0.13830001f,0.15330000f,-0.12200000f,-0.11560000f,0.02310001f,-0.29549998f,-0.92399997f,-0.82210001f,-0.51490000f,-0.36020000f,-0.13290001f,-0.10430000f,0.12510000f,0.82950002f,0.39410000f,-0.19319999f,0.01560000f,-0.76179998f,-0.18239999f,-0.82119996f,-0.08249997f,-0.57259999f,-0.59250000f,0.05580000f,-0.34410003f,-0.47359999f,0.31370001f,0.11819999f,-0.95370002f,-0.06600001f,-0.56930000f,-0.13560001f,0.58830002f,0.18919999f,-0.11209999f,0.64579999f,-0.10950000f,-0.19819999f,1.15560003f,0.27240002f,-0.41920005f,-0.07640000f,-1.04600002f,0.44459999f,-0.20850003f,1.02730000f,0.26270001f,0.22509999f,0.53470000f,0.06699998f,0.06739999f,-0.99890002f,-1.42790000f,-0.76110001f,0.29030000f,-0.06809999f,-0.70119999f,-0.01729999f,0.94410000f,0.62190001f,0.69130001f,0.51110001f,-0.09189999f,0.45640001f,0.23289999f,-0.66760000f,-0.52859998f,-0.53579999f,-0.10900000f,0.08030001f,0.21919999f,-0.04660000f,0.32500000f,0.01080000f,-0.54329998f,-0.05880002f,1.36019997f,-1.64999994f,2.23409999f,-1.40219998f,-0.15180001f,0.76880000f,-1.61150001f,1.20539999f,-1.31360007f,0.45820004f,0.64590002f,-0.59600001f,0.64370003f,0.39639999f,-0.59020001f,0.49840001f,-0.60390002f,0.43320000f,0.93279996f,-1.27079995f,0.40249999f,-0.09120000f,0.30970003f,0.01979998f,0.10300003f,0.18140001f,0.74879998f,-1.06959999f,-0.00000000f,-0.00850001f,0.15260000f,-0.42240000f,-0.00679999f,0.01170000f,-0.15820000f,-1.32780000f,-0.36879999f,-1.11360003f,0.01420000f,-0.00120002f,-0.12450001f,-0.55990003f,-0.06140000f,0.47980001f,0.24210000f,0.70660002f,0.09440000f,-0.13560000f,-0.19100000f,-0.58320000f,0.15800001f,0.83440002f,0.16890000f,-0.60840000f,-0.31920000f,-1.39580003f,-0.63979998f,0.67899998f,-0.12759999f,0.24060001f,-1.16180000f,1.10879999f,-0.86510004f,-0.04939999f,-1.00229998f,1.60439996f,-0.37620002f,-0.66479997f,-0.20810002f,0.47580001f,-0.44600002f,0.15160000f,0.62220003f,-0.20320002f,1.19460000f,-1.02619999f,0.26230000f,0.43600000f,-0.23079997f,0.39059998f,0.78250002f,-0.72540000f,-0.44830000f,0.78739999f,-1.74890000f,-0.79699998f,-0.22129999f,-0.53660000f,-0.16060000f,-0.21859997f,0.14900001f,0.02540000f,-0.34790001f,-0.40510005f,-0.05410000f,-0.29470004f,-0.11400000f,0.62609999f,0.23140000f,0.08620001f,0.00090000f,0.59350001f,0.20810000f,0.62430002f,0.04800000f,-0.14380000f,0.11060000f,0.26309999f,0.34630000f,1.58160002f,0.16980000f,0.01780000f,-0.18960000f,0.46450001f,-1.38949999f,1.28759996f,-0.36940002f,-0.07300000f,0.49890000f,-0.63120000f,-0.02610005f,0.05360004f,0.78319997f,-0.82139998f,0.63889996f,-0.68579996f,0.64679999f,-0.51519999f,-0.52709998f,0.88760000f,0.08860002f,-0.36680001f,1.03990001f,-0.25079999f,0.84590003f,0.10900000f,0.15660000f,-0.07239997f,0.40739998f,-0.78380000f,-0.70320002f,0.65840001f,0.40619999f,1.27360006f,-0.09590000f,-1.21990003f,-0.34750001f,-1.85740004f,-0.24830000f,-1.69850003f,-0.30670000f,-0.00340000f,0.27220001f,1.02080003f,0.29159999f,0.93080001f,0.07600000f,-0.17280003f,-0.15960000f,-0.65260003f,-0.45070000f,-1.46160002f,0.01320000f,-0.41490003f,-0.16260001f,0.05339996f,0.03660000f,0.62720001f,-0.07540000f,-0.60509997f,-0.01479999f,0.07390004f,0.61099999f,-0.58799999f,-0.77510002f,1.47080000f,-1.29170001f,0.86199998f,-1.44730000f,1.47899997f,0.70910001f,-1.18499999f,0.93410002f,-0.60759998f,-0.00879997f,0.59139997f,-0.28110005f,-0.52099995f,-0.30570004f,0.38300001f,-0.37659997f,0.57279996f,-0.60930004f,-0.30739996f,-0.91330003f,0.23300000f,0.18399997f,-0.25179999f,0.52130003f,0.49199997f,1.25220004f,-0.89950002f,0.22650001f,1.34730003f,0.07109999f,0.75550001f,0.18460000f,0.14460001f,-0.02620000f,0.08070002f,0.23370001f,-0.14589999f,-0.24550000f,0.33399998f,0.30569999f,0.05709997f,-0.45410000f,-1.14130002f,0.15550000f,-0.02280001f,-0.00560000f,1.07050004f,0.43470001f,1.63220006f,0.07980000f,0.37630000f,-0.14980000f,-1.21300002f,-0.15750000f,-0.24149999f,-0.54959999f,0.18719997f,1.03899998f,-1.13439997f,1.95670003f,-0.89940000f,1.14360002f,-0.43859999f,0.29530006f,0.33499996f,-0.45340000f,0.19380000f,0.20179999f,-0.72739998f,-0.13110004f,0.68340000f,-0.13600000f,0.09539999f,-0.70400001f,0.31120000f,-0.26929994f,-0.07900007f,0.77980000f,-0.93999997f,1.09369999f,-0.52399997f,0.07250003f,1.03119998f,0.40860003f,-0.20580002f,-0.21400001f,-0.03210003f,0.03460000f,-0.06120000f,-0.12860000f,0.63379999f,0.29560000f,1.38480005f,0.42390001f,0.68830004f,-0.15180000f,0.57769998f,0.19110000f,0.34730003f,0.01140000f,-0.86329998f,0.04180000f,1.07210000f,0.40390000f,0.75120003f,-0.10180000f,0.47539999f,-0.02710000f,0.84480001f,0.34860000f,0.16199998f,-0.39730001f,-1.68180007f,0.36759998f,-0.59700000f,1.47800000f,-0.97159997f,1.36280000f,-0.83120000f,1.56540001f,-1.34439997f,0.91050004f,-0.19020000f,-0.19950000f,0.33359999f,0.96739996f,-1.45459994f,0.68510003f,0.68339996f,-0.95129998f,0.84619999f,-0.04520001f,-0.43339998f,-0.19630001f,0.06599999f,0.57919997f,-0.87559996f,1.27259999f,-1.30719997f,-0.23400005f,1.06660002f,-0.60610008f,0.61050001f,0.00570000f,1.05590002f,0.22730001f,-0.12959993f,-0.04840000f,0.37120000f,-0.00380000f,0.97710002f,0.16310000f,-0.52190000f,-0.33760000f,-1.05650002f,-0.19540000f,-1.20120001f,-0.31740000f,-1.47100002f,-0.24800000f,0.20829997f,0.26059999f,0.84840000f,0.12080000f,1.25020002f,0.19220000f,0.00770000f,-0.03390000f,0.92040002f,0.42740000f,0.62310004f,-0.42359999f,0.93259997f,1.24420000f,-1.63760000f,-0.06819996f,0.73499997f,-0.46560002f,-0.56920000f,0.94020001f,-0.76979999f,0.04890001f,0.67459999f,0.28679997f,-0.33939998f,0.38569997f,0.09680001f,-0.52870004f,0.04360003f,-0.22110001f,-0.17439998f,-0.21320001f,0.08400000f,0.95769999f,-0.93639998f,-0.00170003f,0.18420001f,-0.28320001f,-0.15740002f,-0.44830001f,0.91280003f,0.07940001f,-0.59240000f,-0.34670000f,-0.80870003f,-0.17390000f,-0.97280002f,-0.16850000f,-0.68340001f,-0.13660000f,-0.05840000f,0.09540000f,0.81290004f,0.43380001f,0.98970007f,0.16160000f,1.72719999f,0.17500000f,0.94160002f,0.16820000f,-0.07219998f,-0.00400000f,0.27590000f,0.23470000f,0.50720002f,0.05260001f,0.04640002f,0.24780000f,-0.30210000f,1.12970002f,-1.12440003f,0.21149998f,0.15300004f,0.10339998f,-0.06740001f,-0.34030005f,-0.23439997f,-1.75120004f,1.23899999f,-1.26700000f,0.61699998f,-0.20889996f,-0.06540004f,-0.80579996f,0.78059996f,1.37529996f,-1.71119994f,2.28220000f,-1.30019999f,0.17940001f,0.70860001f,-0.01339999f,0.13620000f,0.71590003f,-0.16080001f,0.39050004f,0.16619999f,-0.24450003f,-0.09900002f,0.03070000f,1.11170003f,0.12050000f,-0.35970000f,-0.13210000f,-0.06600002f,0.11430000f,0.29950001f,-0.03880000f,-0.08040000f,-0.06700000f,0.03420002f,0.11430000f,1.05310002f,0.31190001f,1.17510004f,0.22480000f,-0.52120000f,-0.06960000f,-1.09100005f,-0.29920001f,-2.05020007f,-0.23720000f,-0.91730002f,0.12200000f,-0.13799997f,0.11530000f,1.23680006f,0.26759997f,-0.92579998f,0.78530002f,-0.21680000f,0.59950002f,0.22700000f,0.75859999f,-1.28199997f,-0.25150000f,0.54339999f,-0.83270003f,-0.05560000f,-1.12209999f,0.78320001f,-0.18419996f,-0.17740003f,0.83920004f,-0.10960000f,-0.52119999f,1.15900000f,-1.01970003f,1.14840001f,-1.01430002f,1.49500001f,0.03460002f,0.17079997f,0.01600002f,0.13379999f,0.40350005f,0.17520000f,0.18230000f,0.13570001f,0.03020000f,-1.48109998f,-0.20740000f,-0.04830002f,0.03209999f,0.68289999f,0.23660000f,0.09640001f,-0.39190000f,-1.77180001f,-0.24250000f,-0.02479999f,0.02240000f,-0.26340000f,0.24500001f,0.93630004f,0.14780000f,-0.67540000f,-0.13260000f,-0.86970002f,-0.07790000f,1.11650002f,0.19540000f,0.57810001f,0.02920000f,-0.05599998f,0.09440002f,-0.00980002f,0.17170002f,0.73019999f,-1.27789997f,1.56739995f,0.27229999f,-0.95699997f,1.32940001f,-1.07119998f,0.40359998f,0.27160001f,-0.68240000f,0.44539998f,0.64450002f,-0.59379999f,0.03320002f,0.35780000f,-0.07899999f,0.40000000f,-0.60309999f,1.13319999f,-1.03640003f,0.18319999f,1.07840000f,-1.19079998f,1.45970002f,-0.90460001f,0.13220002f,-1.13110003f,-0.38520000f,-0.87900003f,0.03080000f,1.19930000f,0.25239999f,1.66830002f,0.20410001f,1.58100004f,0.32580001f,2.06240007f,0.30720001f,0.59850002f,-0.44750000f,-1.25330002f,-0.06970001f,0.67909999f,0.20130000f,0.77450001f,0.03450000f,0.95720002f,0.22390001f,1.43800009f,0.44560001f,1.23670006f,0.09560000f,0.04570000f,-0.14450000f,-0.65080002f,-0.50030002f,-0.11480001f,0.22129999f,-0.51859998f,0.77249997f,-1.41259997f,1.02980002f,-0.56980001f,1.50290001f,-1.71659998f,1.40880002f,-1.46519999f,0.33879997f,0.09419999f,-0.46410003f,-0.27139999f,-0.07190000f,-0.16440000f,0.36789999f,-0.33159999f,1.10160000f,-1.39659999f,0.75400008f,-0.09460004f,0.45450004f,0.12139999f,0.89799999f,-0.71239998f,-0.18689996f,-1.03870001f,-0.09100000f,-0.51210002f,-0.03350000f,0.03800001f,-0.11570000f,0.00020000f,0.12720000f,0.61390000f,-0.22800000f,-0.62790003f,-0.17450000f,-0.68090002f,-0.16520001f,-0.60240002f,-0.17980000f,-0.69030001f,-0.04500000f,0.10289999f,0.32440001f,0.10120001f,-0.34770000f,-0.67470002f,-0.07520000f,0.87570004f,0.25660001f,0.71180004f,0.02110000f,-1.06639997f,-0.55219999f,1.08460001f,-1.21380003f,0.25280000f,-0.55340000f,0.48599999f,0.21489999f,-0.89099997f,0.66190000f,-0.49240001f,0.68479999f,-0.53219997f,0.05359998f,-0.22760000f,-0.68010001f,0.46979999f,-0.49909998f,1.03320001f,0.69210003f,-0.76140001f,-0.04540002f,0.03160001f,-0.62820001f,0.03079999f,0.99650007f,-0.71020003f,1.60090004f,-1.14420001f,-0.57609995f,1.41210000f,0.11680000f,-0.10960002f,-0.21760001f,-0.20720002f,0.23460000f,0.33850001f,0.05850000f,-0.39160003f,-0.20210001f,-0.57880008f,-0.26860001f,-1.04310001f,-0.23280000f,0.02979999f,0.24520000f,0.40720001f,0.00120000f,-0.08110003f,-0.16270001f,0.70000002f,0.27910001f,0.40610003f,0.03400000f,-0.41400001f,-0.07220000f,-0.25380001f,-0.09590000f,0.49960002f,0.85249999f,-1.04419997f,0.04649996f,0.19900003f,-0.38819999f,0.48099999f,-0.59380001f,0.19600000f,-1.64540004f,1.06300001f,-1.54460009f,-0.01979996f,-1.70639999f,1.63939994f,0.15650001f,-0.59779999f,0.73940001f,-0.22500000f,0.30999995f,-0.54779995f,1.09040002f,-1.12300003f,-0.10599998f,0.65700002f,-1.41050001f,1.08240000f,-1.01880003f,-0.00700000f,0.15720002f,0.31650002f,-0.21059999f,-1.11780003f,-0.23100001f,-0.10860002f,0.35520000f,1.10200003f,0.04230000f,-0.15509999f,-0.02330000f,-1.27110001f,-0.33050001f,-0.55540004f,0.24530000f,1.00380001f,-0.16780000f,-0.22170004f,0.18700000f,0.55789997f,0.22989999f,1.17949998f,0.00700000f,0.22440001f,-0.04070000f,0.12030000f,-0.03450000f,-0.63349998f,-0.06000000f,-1.06289999f,0.04240000f,-0.21940002f,-1.01670002f,1.20960003f,-0.39400000f,-0.16500002f,0.53920000f,-0.05899999f,0.47909999f,-0.19579999f,-0.86119997f,1.64699996f,-0.16570000f,-0.77459999f,1.12259998f,-0.75799997f,1.28220002f,-0.08419998f,1.05569997f,-1.06339996f,0.69259995f,-0.98159996f,0.08810001f,0.52939998f,1.02149998f,-1.13179998f,0.37470003f,0.83699996f,-0.16180000f,-1.28530004f,-0.31550001f,-1.52470006f,-0.44100000f,-0.46520000f,0.13590001f,0.13440002f,-0.05210000f,-0.45300003f,-0.31900001f,-1.85400004f,-0.32290000f,-1.19220006f,-0.17760001f,0.10959997f,-0.04460000f,-0.33280001f,0.07720000f,-0.61899998f,-0.14929999f,-0.68490002f,-0.25430000f,-0.61650003f,0.12660001f,-0.21149999f,-0.08860000f,0.90390003f,0.29030000f,0.12630004f,0.42099999f,-0.16459998f,0.05919995f,0.06880003f,1.02580001f,-1.17960001f,0.33200001f,0.02540001f,-0.29750004f,0.26260001f,-1.02409999f,1.18339997f,-1.08990004f,-0.23659998f,-0.11730000f,0.19959999f,0.01980003f,0.09419998f,-1.26279998f,1.18579998f,-1.05670003f,0.41720001f,-0.09040000f,0.55180001f,-0.29610005f,-0.52100000f,0.01110001f,-0.17240000f,-0.96089998f,0.91680002f,0.21260001f,1.37310006f,0.26810001f,0.66310003f,0.16190000f,-0.92570002f,-0.34800001f,-0.84990004f,0.13180000f,-0.45100000f,-0.24890000f,0.61640001f,0.20880001f,0.70480007f,0.19040001f,0.28110003f,-0.05350000f,0.63520001f,0.33530000f,0.36180003f,-0.23380000f,-0.97760002f,-0.28910000f,-0.64950002f,0.12040000f,0.12270000f,0.08700000f,0.10740001f,0.41629999f,-0.15690001f,0.29840001f,-0.18190000f,1.41780003f,0.07100000f,-0.16040000f,-0.59299998f,-0.84829998f,0.69929999f,-1.21819998f,0.23780001f,-0.91309999f,0.53859998f,-1.28309997f,-0.38999999f,0.10780001f,-0.81350001f,0.02640002f,0.81200002f,0.26410000f,0.41259999f,-1.62429999f,0.23619999f,-0.73629994f,0.91879997f,-1.10699995f,-0.55810000f,0.02060001f,-0.65100001f,-0.58050002f,1.54980004f,-0.20580000f,0.26599999f,-0.85070001f,0.75760003f,0.28510000f,1.27540006f,-0.55550003f,-0.15360002f,0.41329996f,-0.63350004f,-0.56669999f,-1.03189998f,-1.62949998f,-0.04630006f,1.74119999f,0.12320004f,0.71720004f,1.05749999f,-1.11819999f,-0.70140000f,-0.33989999f,-2.14480006f,0.84090003f,-0.39029999f,-0.15669998f,1.78850000f,-1.04750001f,-0.23740001f,-0.96919998f,-0.36330001f,-1.71570002f,-0.34650001f,-1.16550002f,0.30080000f,0.22020003f,-0.71100002f,0.32409999f,-0.18620001f,0.39949999f,-0.57229998f,0.62339998f,-0.86550000f,0.48139997f,0.88800001f,-1.49869997f,0.60700001f,0.08159999f,-0.83349998f,0.84690000f,-0.31169998f,1.22790000f,0.84520002f,0.32860001f,0.33170000f,-0.36989999f,0.65070000f,-1.59280003f,-1.50099999f,0.80970003f,-0.21520002f,2.41870000f,-0.99420002f,-0.35089999f,1.60240003f,-0.84590001f,0.83380001f,-0.51339999f,0.77450000f,0.18419997f,-0.68309997f,0.41670002f,-0.39470002f,1.45240000f,-1.00370002f,-0.27310000f,1.44349999f,-0.79820001f,1.64350004f,-0.12150003f,-1.44540003f,0.13679998f,1.19770001f,-0.93240000f,-0.18859999f,0.48969996f,-1.02630001f,0.85459996f,0.68530001f,1.03540002f,1.30840001f,-0.92630000f,0.35380000f,-0.19840003f,-0.47560000f,-0.77319998f,-0.38189999f,-0.84539999f,-0.06630001f,0.25210002f,0.25340001f,0.75110001f,0.73980000f,-0.67919998f,0.32379998f,-0.26350002f,-0.44500000f,-0.16279997f,-0.64260000f,-1.37050001f,0.42969998f,0.28879999f,-0.69069999f,0.09490000f,0.41849999f,-0.28049997f,0.29880002f,0.10759999f,0.14189999f,-0.46000002f,0.33209999f,0.75890004f,-1.01350003f,1.19329997f,1.15650002f,-0.49890002f,-1.71820002f,-1.07469997f,0.11830002f,0.66990000f,1.64500000f,-0.19260003f,-1.31329997f,0.55770003f,-1.11720000f,-0.09039994f,0.68430004f,0.33549997f,0.97779999f,0.51450000f,-0.04299995f,0.38990004f,0.18999997f,-0.00210000f,0.05640001f,0.72470001f,-0.03310000f,0.62500000f,-0.55410001f,0.51900001f,-0.14219997f,-0.18720000f,0.50829999f,-0.41539998f,-0.78090000f,-1.18380001f,-0.07720001f,0.57629998f,0.68869998f,-0.66680001f,-0.27250001f,-0.23220000f,0.70920001f,0.92969995f,0.52030002f,0.36059998f,0.37619997f,-1.33750001f,0.41860000f,0.45690003f,0.22600002f,-0.05130005f,-0.73139997f,0.27300001f,-0.90430003f,-0.65449998f,-0.05339999f,0.26989998f,1.17570004f,0.72669998f,-0.85380006f,0.39960000f,-0.05940000f,-0.16460002f,-0.82850002f,-0.20920000f,-1.22930001f,0.73309999f,1.62750002f,-0.21729999f,0.14010005f,2.15749996f,0.41269998f,0.05469998f,-0.76249998f,0.69459999f,0.73270000f,0.48430001f,-1.29370003f,1.22140001f,-0.38699999f,0.10609996f,0.44199999f,1.08889995f,-0.00239999f,1.48379998f,0.14419999f,0.91670004f,-0.31950001f,-0.98110000f,0.07670000f,0.34239999f,-0.30220000f,0.50079999f,-0.12230000f,0.35910001f,0.76959998f,-0.50070001f,-0.27909999f,-0.59729999f,1.09629997f,-0.79699999f,-0.06930000f,-0.66289998f,0.73779998f,0.88340001f,0.07280001f,0.15210002f,0.90740000f,1.32160001f,-1.40469998f,-0.08449999f,0.90889999f,-0.87800001f,-0.59730001f,-2.45669994f,-0.38770001f,0.43060001f,-0.40480002f,-0.64189998f,1.90330000f,-0.20360001f,-0.72590002f,-0.46699999f,-1.66040005f,0.19499998f,1.15820003f,0.66429997f,-0.54820001f,-0.60930001f,0.55270004f,1.96769995f,0.00439998f,1.16979998f,-1.47460001f,-0.86459996f,0.82240003f,2.23350000f,-0.49339998f,0.58489997f,0.39689998f,1.13479998f,-0.67780000f,-0.15040002f,-1.19939998f,0.68939997f,0.41220000f,-0.33500000f,0.06210000f,-0.28559996f,-0.34960000f,0.26490005f,-0.25949999f,1.57219998f,0.34780000f,0.74540001f,-0.06210001f,-1.02970001f,-0.27720001f,0.24169999f,0.83909998f,-0.22419996f,0.38830000f,-0.68830000f,0.01160000f,0.86819999f,1.13790000f,-0.73899999f,-0.98510002f,-1.58559997f,0.29060004f,1.61200001f,0.27170001f,-0.44859998f,1.20790002f,0.11020000f,-0.75849997f,-0.37940000f,-0.04500003f,0.72019997f,0.51400003f,1.19089999f,-0.35010004f,-2.35560000f,0.01640001f,0.66880000f,-1.07100002f,-0.65499998f,-0.11430000f,0.46080000f,-0.76340006f,-1.14359996f,-1.07080002f,1.32539997f,-0.23319999f,0.56839998f,0.65900001f,-0.50460002f,-0.84289998f,-0.22490003f,0.87000000f,-0.93319999f,-0.15910000f,-0.42100000f,-0.20289999f,0.32139998f,-0.24890000f,0.51829997f,0.23419999f,-0.50229998f,0.38590000f,-0.64780001f,-1.23819999f,1.21750002f,0.15060001f,0.49589999f,-0.29079999f,1.19810000f,0.06250000f,1.20340002f,-0.82079996f,0.94039999f,0.71539999f,-0.32599999f,0.42739999f,-0.59940000f,-0.64829999f,2.03850000f,0.83459998f,0.08300000f,-0.48300000f,-0.41159998f,1.91319999f,0.55359998f,0.06820000f,0.90229998f,-2.28020002f,0.29279999f,0.25739997f,1.37939997f,1.12800004f,-1.25290003f,-0.39790003f,0.44569999f,0.06819999f,1.90429997f,0.29370003f,1.56640002f,-0.09190002f,0.77440000f,-0.13940001f,-1.53570003f,0.72940001f,-0.57250004f,-1.53870004f,-0.56169999f,0.94920000f,-0.55020000f,-0.35809999f,-1.53679998f,-0.02820000f,-0.10789998f,-0.21479999f,-0.43239997f,0.04430001f,0.34870002f,0.48429998f,0.25390002f,0.87099998f,-0.31569997f,-0.94490002f,0.05409999f,0.16010000f,-0.33109998f,0.97399999f,-0.05309994f,0.60980001f,-0.49780000f,0.28830000f,-0.19490001f,-0.86350002f,0.44580001f,-0.68000002f,-0.82300004f,-1.08200004f,0.55460001f,1.61120001f,-0.07620006f,-1.13399999f,1.67299998f,-1.36530003f,-0.36379998f,1.34460000f,-0.79279999f,0.76130002f,0.99930000f,0.04800002f,0.15379998f,1.59110002f,-0.09140001f,1.24660002f,0.32339999f,0.36710002f,1.57489999f,0.97680000f,-1.55129999f,0.69580004f,-0.26420000f,0.57150001f,1.13809998f,0.93490002f,0.82120002f,-2.01180007f,-0.55360000f,0.51190000f,0.14650002f,-0.51500002f,-0.37259998f,0.96419998f,0.13509998f,0.29970000f,0.25690001f,-0.51219999f,-0.49239997f,0.31000000f,-1.60670002f,0.21949998f,-1.40220000f,-0.17310000f,-1.76289998f,0.02919999f,-1.38009998f,0.89839999f,-0.76480000f,-1.01179998f,-0.73980000f,-0.33150000f,-0.53540000f,0.34720000f,-0.18429997f,-0.17999998f,0.02560003f,0.70510001f,-0.05560004f,-0.89360006f,-0.17569999f,-2.01389997f,0.49800001f,1.57619998f,-1.01370005f,-0.81569999f,-1.09909996f,1.98340000f,-0.55679998f,0.14410003f,-0.23760003f,0.48700000f,-0.29600002f,-0.28700003f,-0.75520000f,-0.05609998f,0.74170001f,1.33060001f,-0.18240003f,-1.01800002f,0.53150001f,0.28729999f,-1.44070002f,-0.06060000f,0.45489999f,-0.43330000f,0.00880005f,-0.58410001f,-0.00009999f,-0.28489998f,0.59159999f,0.71159998f,0.12549996f,-0.76870002f,-0.44489999f,-0.32909999f,-0.07740004f,-0.74729998f,-1.14579999f,-0.29850001f,0.17000002f,-0.54640001f,-0.24429999f,-0.59220000f,-1.27489999f,0.59219998f,0.44289998f,-0.56470000f,0.42710001f,0.11710001f,-0.48640000f,-0.93470002f,0.49770000f,0.03600000f,0.11970001f,0.90210003f,1.39229997f,-0.63770002f,1.58770003f,-1.02020002f,-0.41579997f,0.52250001f,0.84300002f,0.10590003f,-1.38599997f,1.21570001f,-0.50500000f,-0.11319999f,0.32629998f,-0.89490004f,-1.34210001f,1.50430003f,1.07670001f,0.28749999f,-1.24950003f,-0.65119999f,-1.33559999f,-0.30059999f,-1.07229998f,0.11759994f,-1.38769996f,0.41780002f,0.68869998f,-0.25789999f,0.29500001f,0.65689999f,-0.02759996f,0.95330002f,-0.65399998f,0.37990000f,0.37450000f,0.75170001f,0.35009997f,-0.60769999f,0.31599997f,-0.63409999f,-0.25639999f,-0.04990001f,-0.54830002f,-0.45530001f,0.64480004f,0.13210001f,-1.26849999f,-0.92170002f,0.04559999f,-0.66210001f,1.22369996f,-0.66410000f,-0.23000004f,-0.76719997f,-0.25159998f,0.30179999f,-0.42499998f,-0.01180003f,0.46369996f,1.11950003f,-0.92260002f,-1.18750003f,0.14389998f,0.02630001f,-0.62749997f,-0.71110002f,-0.10020000f,0.89880001f,-0.17420001f,0.23190000f,-0.11610001f,-1.00530008f,-1.14929999f,-1.75329996f,0.86480002f,0.38109999f,0.47429999f,-0.40780002f,-1.43609995f,0.50760001f,0.14179997f,0.15200000f,-0.10370002f,-0.82660003f,-0.87439997f,0.78180000f,-0.75419999f,0.28719998f,-0.63749999f,-0.73740001f,0.35759998f,0.24460000f,0.28350002f,-0.26029999f,0.14260000f,0.28499999f,0.60350000f,-0.26340000f,0.61180001f,-0.46800000f,0.18949999f,-0.66049998f,0.94130002f,0.89599999f,1.43359998f,0.11820000f,0.25349998f,-0.82099997f,0.46549999f,-0.23510001f,0.23400000f,-0.48290000f,-0.69660000f,-0.37589999f,-0.12420000f,-2.26330005f,-0.62689998f,0.50340003f,-2.08589995f,0.87369998f,0.00460002f,0.21089995f,-0.28160004f,0.14549999f,1.23289998f,-1.05059998f,-1.02459995f,0.26590004f,-0.88689999f,1.52510004f,-0.22390002f,0.47280002f,0.45679995f,-1.06980000f,-1.06089998f,-0.56880004f,-0.41159994f,0.52730001f,-2.28719993f,0.01539999f,0.76800001f,0.00239999f,-0.12290000f,0.50619999f,-0.85440001f,0.21340000f,0.63369998f,-0.90519999f,1.38259999f,-0.40319998f,-0.94279999f,-0.38350001f,-1.17989995f,0.68880000f,-0.71900002f,0.02870002f,0.23039992f,-0.02940000f,0.75259998f,-0.43390000f,0.11140000f,-0.26670001f,-0.45610001f,-0.54650000f,-0.39080002f,0.16650002f,0.20600000f,-1.07589997f,0.64909999f,0.47020001f,1.03140001f,-0.30649999f,0.18490001f,-1.00350004f,-0.77870000f,1.09920002f,-0.27350001f,-0.73490004f,2.07909999f,-0.01280000f,-0.29509998f,1.40610002f,-1.00240002f,-1.35760000f,-0.51979999f,0.86490000f,0.62619999f,0.03610001f,-0.37879995f,0.56789997f,-1.46850000f,0.55060000f,-1.75409999f,-0.90120001f,0.60370001f,0.99019998f,-1.66150002f,-0.40430000f,-1.02359998f,1.11240002f,1.34289999f,-1.17489999f,-1.05210003f,-0.30500000f,0.79810002f,-0.63620000f,-0.54869997f,1.06210000f,-1.47829998f,0.09780000f,-0.12100000f,-0.78240001f,-0.44550001f,0.16699999f,-0.04700001f,0.46349999f,-0.76369998f,0.08350002f,0.71030000f,-0.88759998f,-0.14479997f,-1.14600000f,0.07540001f,0.51999999f,-0.01870004f,-1.09319999f,-0.83339998f,-0.30080000f,-0.04959998f,0.57650000f,0.30510000f,-1.15329999f,-1.27289996f,-0.31000002f,-0.94039998f,0.15339998f,-0.25849999f,-1.86680006f,-0.89519998f,1.11900006f,0.91449999f,0.39440000f,-1.24150002f,-0.44569996f,-0.03739998f,0.91590000f,0.42799996f,-0.09549998f,1.13250002f,0.70850005f,-1.23060001f,0.25949998f,-0.30480001f,-0.12989998f,1.81840003f,1.03200001f,0.15460001f,1.22610000f,-0.47250003f,-0.74390001f,0.17649999f,-0.69959998f,-0.20450004f,-0.29290000f,1.22830003f,-0.27009999f,0.40790001f,0.02330000f,-0.02520000f,0.58289997f,-1.13220005f,-0.46260001f,1.27659999f,0.07040001f,0.38919999f,-0.14110002f,-2.06839999f,0.79560000f,-0.45320002f,-0.66900002f,-0.05060003f,-0.20950000f,-0.44009999f,1.09590001f,-0.97539997f,-0.01940000f,-0.48449997f,-0.70440000f,0.31160000f,0.09190001f,0.17899999f,-0.05909998f,-1.02049999f,1.74900003f,-0.44890006f,-0.53340006f,-1.88200002f,-0.14359996f,-1.37120001f,-1.52980001f,0.63280001f,0.92550001f,0.22579999f,1.18050002f,0.41889996f,0.41030000f,-0.72760005f,-0.33780001f,-0.45560000f,0.70080000f,-0.19720000f,-1.08440000f,-1.78529998f,0.57420001f,0.18289998f,-0.09489996f,1.40950000f,0.39009996f,-0.59230003f,0.11480000f,-0.13529998f,0.05320000f,-0.21710002f,0.32170001f,-0.27220000f,0.63129997f,1.35829998f,-0.54689999f,-0.57510000f,-0.69760000f,0.47669992f,-0.73469999f,0.16219999f,0.03199999f,0.79709998f,0.88230000f,1.01610006f,-0.60699999f,-0.62290006f,-0.06189999f,0.43650001f,-0.26939999f,1.27469997f,-0.44349996f,-0.86200002f,0.28920000f,0.98170000f,-1.03560002f,-0.18740000f,-0.41559995f,-0.64739998f,-0.50150005f,-0.43200000f,-0.37010001f,-0.74060001f,1.35000004f,0.48420002f,0.38089999f,0.29299999f,0.29810001f,0.62680000f,0.00780001f,0.58680001f,0.21739999f,-0.31040002f,-1.66200000f,-0.86280002f,1.06169998f,0.48180001f,0.74920000f,0.57679999f,0.38180000f,0.55419999f,-1.42520000f,-0.43879999f,0.12560000f,0.14770001f,0.01290000f,0.92400000f,0.26880001f,1.19060001f,-0.02410001f,1.18300001f,-0.49690001f,0.22019998f,0.90470001f,0.83200004f,0.56080000f,-0.14699995f,0.72979997f,-0.50279996f,0.62180001f,1.10120002f,-0.52730001f,-0.31590003f,-0.76720000f,-0.33850003f,0.80369997f,0.37730001f,0.44299998f,-0.50229998f,-0.69100001f,-1.93500005f,-0.68629999f,0.44609994f,-0.16750002f,0.14620002f,1.22809997f,0.54679996f,-0.22559995f,-0.18860001f,-1.78800005f,-0.40180000f,0.02739999f,-0.37540000f,0.15920003f,-0.25579998f,-0.07330002f,-0.37980000f,0.93700001f,0.51419999f,-0.13649998f,-0.00440001f,-1.40800001f,-0.32299998f,-0.12260003f,-0.39359999f,1.05630004f,0.09300001f,-1.13800003f,-0.39540000f,0.59830001f,0.17580001f,0.41690000f,-0.93960002f,0.76490000f,0.96570008f,-0.47070000f,-0.87540003f,-0.78079999f,-1.72590005f,-0.80709999f,-0.28540002f,0.18509998f,1.08440000f,0.24379999f,1.15749997f,0.09239999f,0.36870003f,-0.03399999f,-0.48440001f,-0.37229999f,-1.14400002f,-0.70289997f,-0.27730002f,0.15879998f,1.30849998f,0.91920000f,0.97950003f,-0.67339998f,-0.48790000f,0.60499998f,1.09960000f,-0.32990000f,-0.24460000f,1.07000000f,0.39500000f,0.20450000f,0.36100000f,0.73270002f,0.33059998f,-0.33510003f,0.10719998f,-0.60979997f,-0.13159999f,-0.66170001f,-0.03139998f,0.38379999f,-0.22360000f,-0.76500000f,-0.65139999f,0.80539998f,0.32539998f,-0.46440002f,0.08419999f,-0.35549999f,-0.44499999f,-0.99510002f,-0.94620001f,1.63860002f,0.66339999f,-1.24970003f,-0.86619999f,-0.28840001f,-0.03170002f,0.20600001f,-0.40590000f,0.68720000f,0.87470004f,0.67869997f,0.42669998f,-0.12900000f,-0.38240002f,0.87699999f,0.77230006f,-0.43309998f,-0.06110000f,-0.74629997f,-0.38660003f,0.13929999f,0.77680004f,-0.69039999f,-1.89709998f,-0.79760000f,-0.84270005f,-0.50689997f,0.40640000f,-0.61040001f,0.11950000f,0.03210001f,-1.02360002f,0.20279997f,0.30679998f,0.02390000f,0.39060001f,0.79189998f,0.38139998f,0.65450007f,0.28480000f,-0.93260002f,-0.13420001f,0.65349999f,0.48559999f,-0.00889999f,0.32620000f,-0.24569999f,-0.01740000f,-0.99080000f,-0.69760000f,0.84579999f,-0.17000003f,-1.15919998f,-0.34679999f,-0.22130000f,-0.23920000f,0.81070002f,0.30020000f,-0.39750000f,-0.01680001f,0.70010001f,-0.98229996f,-0.44069997f,-1.62579996f,-0.22360000f,-0.69930001f,0.02020000f,-0.04780000f,0.91440002f,0.71150003f,0.05170000f,-0.03390000f,0.49319999f,-0.23109997f,0.16169999f,-0.25639999f,-0.78129997f,-0.71150002f,0.12469999f,1.80810000f,-0.59159997f,-0.92020001f,0.04040000f,0.52880000f,-0.81099997f,-0.76690001f,0.21300000f,-0.18640000f,-0.74089998f,-1.59570000f,0.24129999f,0.13360000f,0.62660001f,0.35720001f,-0.39259999f,0.25380003f,0.94589998f,0.08799999f,-1.04070000f,-0.34919998f,0.23140003f,-0.43519997f,1.22110000f,0.75140002f,0.44169996f,0.64879999f,-0.29739996f,-0.22440001f,-0.57850002f,-0.03260000f,0.66320000f,-0.18240003f,-0.23119995f,0.04940000f,-1.24980003f,-0.06760000f,0.96750001f,-0.21800003f,-1.19170000f,0.44160003f,-0.59819997f,-1.10420000f,0.66030000f,-0.22499994f,0.61649999f,1.13070002f,-0.37409999f,-0.96070001f,-0.50559999f,0.43539994f,0.30469999f,0.51019999f,0.34690000f,-0.90590000f,-0.25080000f,-0.65440002f,0.36770000f,0.34400002f,0.09790000f,1.08650000f,-0.30749998f,-0.34340000f,0.02270001f,-0.93929999f,-0.46909999f,0.52709999f,-0.62779999f,-0.89170002f,-0.75610002f,0.20020000f,0.06640000f,-0.55840003f,-0.68379999f,-0.22299999f,0.15609998f,-0.29620001f,0.99649999f,0.72859999f,-0.33289999f,-0.12960001f,-0.21509999f,-0.28160002f,-0.50260000f,0.35800004f,1.58880001f,0.44279999f,-0.29670000f,0.43320000f,0.81410001f,0.42779999f,0.61210002f,0.96080002f,0.07739997f,0.10399997f,-0.99059997f,-0.33080000f,-0.39600001f,0.00110005f,0.50969998f,1.53430002f,-0.62990000f,-0.57700001f,-0.04660000f,0.75889998f,0.28019999f,0.24970004f,0.36920001f,-0.06759998f,-0.02040000f,0.52399999f,-0.04920000f,-0.85279999f,0.75209998f,1.26470001f,0.22700000f,-0.97659998f,0.21629999f,-0.08880000f,0.24970000f,-1.06429998f,0.89659997f,0.40859997f,-0.37159999f,-0.79220000f,-0.43639998f,-0.12580001f,0.12800002f,-0.06340003f,-0.79190001f,-0.17060001f,-1.05629998f,-0.47079998f,0.90069999f,-0.13280000f,0.33789999f,0.18039998f,-0.00699998f,0.60980001f,-1.11219998f,-0.70640000f,0.29140001f,0.24920002f,0.40780000f,0.08279999f,-0.43119999f,-0.46220002f,0.25730004f,0.08839999f,-0.85800003f,-0.22780002f,-0.03350000f,0.37360003f,0.60640003f,0.16100001f,-0.87000004f,1.40390004f,-0.40479998f,-0.67470002f,0.53009998f,0.83030001f,-0.28719999f,0.99579995f,0.56309998f,1.08889998f,0.43419998f,-0.50989998f,-0.41489997f,-0.79070003f,-0.78669998f,-0.67550004f,0.84130001f,1.18950005f,0.00720000f,0.48529998f,-0.61279999f,-0.23520002f,-0.09749999f,-0.35780003f,-0.09920000f,-0.60780000f,0.61050000f,0.76620003f,0.76600001f,0.18020007f,-1.00400002f,-0.32100001f,0.52120002f,0.05680001f,0.03610000f,-0.02880003f,-0.74470000f,0.16580001f,-0.31839998f,-0.34279998f,0.56400000f,-0.23540001f,-1.44550004f,-0.73140001f,-0.37419997f,-0.69579998f,-0.43800001f,-0.75720000f,-0.13650000f,-0.59460002f,-0.39410001f,0.00940002f,0.03450000f,-0.34380000f,0.46240000f,-0.16260001f,0.30110003f,0.12319998f,0.05670001f,0.29680000f,-0.56650000f,-0.13150006f,0.74270000f,1.19330003f,-0.60169998f,-1.74659998f,-0.58550000f,-0.73990004f,0.27469999f,1.56919998f,-0.02050000f,0.27919999f,-0.43949999f,0.84040001f,0.03070000f,1.57189998f,-0.07790000f,1.46879999f,-0.70019999f,-0.80270002f,0.72859997f,1.60530001f,0.27110000f,1.41260000f,0.01280000f,0.42740000f,0.71229998f,0.04330001f,0.53550003f,0.36580001f,0.05330001f,0.39720000f,-0.01770002f,0.33599998f,-0.89889999f,-0.42879997f,0.58650000f,0.32120001f,-0.21840001f,-0.48860000f,0.30360000f,-0.03099999f,0.65890002f,0.33440001f,-0.24030000f,0.14520001f,-1.14849999f,-0.89020000f,1.65419997f,0.63019999f,0.04950003f,0.34519999f,-1.02929999f,-0.13959997f,1.49490000f,0.48139999f,-0.46279999f,0.29569998f,0.93620001f,0.51060004f,0.43889999f,-0.32669997f,-0.72119996f,-1.32520002f,0.52300000f,0.90660007f,0.02110000f,0.39539999f,0.70509996f,1.74460000f,0.31670001f,0.51950001f,0.75120000f,0.40360003f,0.53950000f,1.19400002f,-0.73999997f,0.03669998f,0.91239999f,0.35360004f,0.18250000f,-0.58870002f,0.63070001f,1.41240004f,0.30010000f,0.19610001f,0.93490001f,-0.07920001f,-0.28479999f,-0.06600002f,-1.54190000f,-0.38899998f,0.44419997f,-0.27980001f,0.08809997f,0.31700000f,0.35010001f,-0.08980000f,0.52920001f,0.18640000f,-0.95210002f,-0.02839998f,1.20190005f,-0.03600001f,-1.09060001f,-0.18879998f,0.91130000f,0.57140001f,0.74190000f,0.58400001f,-0.74340001f,-0.22619998f,0.66650000f,-0.16500000f,-0.38160000f,0.43169998f,-0.29859999f,-0.35880001f,-0.63800000f,-1.51170004f,-0.87519998f,-0.22690004f,-0.76770000f,-1.40200001f,0.29039999f,0.55710001f,0.66639998f,1.21000001f,0.28660001f,-0.52059998f,-0.00410000f,1.07449999f,0.33489999f,0.05409997f,0.69460001f,0.82270007f,0.46280001f,-0.27979994f,0.60130001f,0.07540004f,0.38559996f,1.51709996f,-0.14599999f,-0.03820001f,-1.28980001f,-0.56500000f,0.14460001f,-0.02879999f,0.85589998f,0.48699999f,-0.75089995f,-0.15879998f,0.34439998f,0.12400001f,0.22040001f,0.00160000f,1.04570001f,0.59700000f,-0.35830001f,0.38760001f,0.56990001f,0.34719999f,0.29609999f,0.28699999f,-0.26800001f,0.37900000f,0.59090000f,0.08500000f,0.57050000f,0.44279999f,-1.05299998f,-0.15139998f,0.35149999f,-0.20320003f,-0.34129999f,0.16469999f,0.62620000f,0.74290004f,-0.16500000f,-1.01719999f,0.03080000f,0.12979999f,-0.44209998f,-0.57370002f,0.30480000f,0.36090001f,0.79319999f,-0.28139998f,0.50619997f,0.18100001f,-0.80839996f,-1.63730001f,0.13700000f,-0.89169997f,0.59869997f,0.88139998f,0.44310000f,0.40430002f,0.78149999f,0.15720005f,0.08069999f,0.38149998f,-1.35640002f,0.04140001f,0.07000001f,0.13020003f,1.92530001f,0.58040001f,-1.36540002f,-0.52579999f,-0.01019999f,-0.46100001f,-0.81250005f,-0.05220001f,-0.15340003f,-0.30180001f,1.28440002f,0.21080000f,0.45020000f,0.19179998f,-0.50319999f,0.28840001f,-0.73230000f,-0.40899999f,0.44729999f,0.29420003f,0.83729999f,-0.04920001f,0.92119999f,0.71080000f,-0.42769997f,-0.68199997f,-0.62159999f,-1.29989998f,0.33290000f,0.89570001f,0.75309999f,0.47179996f,0.29239999f,1.65989998f,-0.52540000f,-1.03810000f,-0.57090002f,-0.63140000f,-0.48020001f,0.19459999f,0.58789999f,0.85320000f,0.67610000f,-0.04049993f,0.35520000f,0.22190003f,-0.56080001f,-0.78690003f,0.52839998f,1.15699999f,-0.32660000f,-0.80140002f,0.57909999f,-0.05500002f,-1.30090002f,-0.15979999f,1.47210004f,0.51860001f,-0.69670000f,-0.46960002f,-1.56520001f,-0.59099999f,0.76080000f,0.10400002f,-0.31050000f,-0.03599999f,-0.26480000f,-0.58740000f,-0.35339999f,-0.24539999f,0.95269998f,0.52740002f,-0.33879997f,-0.09019996f,0.92439999f,0.19660000f,-0.67490003f,-0.08579999f,-0.12819996f,-0.19919997f,0.52399999f,-0.41880002f,0.54819998f,-0.01239997f,0.02110000f,0.50760000f,0.94400000f,1.28840001f,-0.65799999f,-0.77910003f,-0.44739999f,0.24099998f,0.68760000f,0.57740005f,-0.51889998f,-0.01940001f,-0.52780000f,-0.20670000f,-0.37830001f,-0.54840005f,0.72009997f,0.39119999f,0.80049999f,1.54820003f,-0.41929998f,-1.17180002f,0.76959997f,1.24880004f,-0.11840000f,1.11399996f,-0.29210000f,-0.57629999f,0.07419998f,0.57300000f,-0.80810000f,-0.33739998f,1.94800002f,0.82680002f,-0.99400001f,0.10460002f,-0.35490000f,-0.76840001f,-0.49780004f,-0.23179999f,1.82880001f,0.78039999f,-0.67709998f,-0.35380000f,-1.37920001f,-0.98740002f,0.48039998f,0.25680001f,-0.01030001f,-0.16420000f,-0.02370000f,-0.43180003f,-0.97219998f,-0.53999999f,0.62929999f,0.12820001f,0.82019999f,0.00790003f,0.55049999f,0.09840003f,-0.12430000f,0.21989999f,0.48700000f,-1.07810000f,-0.45709999f,0.17849997f,-0.60769997f,-0.31159998f,0.00439999f,0.25060005f,0.07940000f,-0.39050003f,0.33290001f,1.37640003f,-0.87160000f,-0.50120001f,0.44400001f,0.62930004f,0.11589999f,1.03800001f,-0.82940000f,-0.60800006f,-0.03390000f,0.76899996f,0.84399999f,0.91300003f,-1.17850002f,-0.58360001f,0.73010000f,0.42660001f,-0.03769998f,-0.29219999f,-0.10190002f,0.22260002f,0.90000003f,0.46920002f,0.57759998f,0.33759998f,-0.02449998f,0.01460000f,0.33989999f,0.04659998f,-0.79969998f,-0.20399998f,-0.45620000f,-0.30640000f,0.94319999f,0.27199999f,-0.76630001f,0.10840002f,0.03739999f,-0.48740000f,0.91310004f,0.15280000f,-1.65060005f,-0.20290001f,0.01890002f,0.42830001f,0.57679999f,0.77240000f,-0.72490001f,-0.82699998f,0.03470001f,0.26200000f,-0.69569998f,-0.51599996f,0.77439999f,-0.37349999f,-0.11509993f,-1.33239997f,0.66530000f,-0.70580002f,0.10040000f,1.27940003f,-0.53540003f,-0.08930003f,-0.96729998f,-1.14650000f,-0.35579999f,0.18630000f,-1.33549998f,-1.57969996f,0.54459999f,0.53730000f,0.39230003f,-0.16820001f,-0.04190004f,-0.87839999f,-0.50069997f,-0.42380001f,-0.50520001f,-0.75340001f,-0.76690003f,0.31060001f,-0.74529998f,0.09519998f,-0.11470002f,0.55560000f,0.45320004f,0.67239999f,-0.87079999f,-0.38140000f,0.96999998f,-0.84960002f,-0.24960002f,0.41260001f,-0.65009995f,0.57879999f,-0.29479999f,0.85320002f,2.16190003f,-0.25619999f,-0.15040001f,-0.71590001f,0.44830002f,-1.21549998f,-0.05819999f,-1.13300001f,0.67250002f,-0.40529999f,0.03270003f,-0.74800003f,-0.09790000f,0.11759998f,-0.67649998f,-0.14509999f,0.03589999f,0.01239997f,0.96589996f,1.20950002f,-1.09619997f,-0.74629998f,-0.15240000f,-0.92040000f,0.42439999f,0.62970000f,0.03389998f,2.06040003f,-0.19090003f,0.22270002f,0.53809999f,-0.54809999f,1.14180003f,0.06940000f,-1.67189999f,0.76219998f,0.49259995f,-0.21199998f,1.87510003f,-0.14100000f,0.56089999f,-0.43580000f,-0.63190002f,-0.34999999f,-0.63069997f,-0.52560000f,-1.08070002f,0.59839999f,0.25149998f,-0.03059999f,1.33520001f,-0.09339998f,0.61410000f,-0.45360000f,-1.18180002f,-0.22800000f,-0.31849996f,-0.24200000f,0.26229996f,0.09080000f,-1.05909997f,-0.82390004f,0.80860001f,1.89509998f,-0.30910003f,1.36970002f,-1.47230000f,-0.41470000f,0.77710000f,-0.89600000f,0.53730002f,-0.74989997f,0.23860000f,-0.62350000f,-0.23939997f,0.65819999f,-0.27590003f,0.92720001f,-0.93820001f,-0.11880000f,0.65250000f,-0.88909999f,0.51420003f,-0.88450000f,-0.49049999f,0.07799999f,0.29480002f,-0.73969999f,0.37840000f,0.62899998f,0.84659996f,-0.15680000f,-0.57970000f,0.39440000f,0.31470001f,0.23200000f,-0.94150003f,0.05539998f,-0.42749996f,0.04279999f,0.87459997f,-0.44440001f,-0.40419998f,0.25500001f,-0.16930000f,-0.06420000f,1.00619998f,-0.83460000f,-1.47050000f,0.60399999f,1.38249998f,0.42400000f,0.92530000f,-0.39099999f,0.34609997f,-0.98960001f,-1.30770005f,0.75980000f,1.68830005f,-0.17319997f,0.39569999f,0.41139999f,-0.19000001f,-0.24710001f,-0.04400000f,0.10360002f,-1.03070003f,0.41979997f,-0.87689998f,-1.55200000f,-0.17429999f,0.02220000f,1.15129997f,1.05979999f,-0.07730000f,-1.28899999f,0.01480004f,1.11249999f,0.02069996f,1.10140000f,0.59759996f,0.23139997f,0.02150002f,-0.75919998f,-0.09609997f,0.59389999f,-0.28530005f,-0.81210002f,0.16389995f,0.51739998f,1.03039997f,0.64480001f,0.09990003f,0.43079999f,-0.11010005f,-0.08880001f,-0.16439999f,-0.23220001f,-0.40289999f,0.42639999f,0.11460001f,0.36380000f,0.05270001f,0.19620001f,1.39889998f,-0.88300002f,-2.07140001f,-0.23200002f,1.23279995f,-0.44959999f,-0.54999999f,-0.06119999f,0.07699995f,0.23080000f,-0.02029999f,0.12420000f,0.52999996f,0.45259995f,0.08839997f,0.78420000f,0.70729998f,1.02069998f,-0.20229999f,-0.28670001f,-1.16110001f,-0.41250000f,-0.36860000f,-0.06220002f,-0.14820000f,0.40300000f,0.09060000f,1.20470000f,-0.08970000f,-1.26439999f,0.04070001f,0.72009995f,-1.38149998f,-1.10179999f,-0.09789998f,0.54829999f,-0.05660000f,0.20590001f,-0.50790002f,1.07740000f,-0.51240001f,0.65170000f,-0.52629995f,0.40680000f,0.72299998f,0.28660001f,0.64160001f,0.36060000f,-1.26629996f,0.20340000f,1.24360000f,-0.15919998f,-0.03240001f,-0.63099998f,-1.24659998f,0.84620002f,0.16670006f,0.87440000f,0.92479998f,-0.49700001f,-0.03979999f,-0.00700000f,-1.19910001f,-0.33540002f,0.09399993f,-0.08459999f,1.09010002f,0.19980000f,-0.95060003f,-0.28600001f,0.91739998f,1.44569997f,0.46729998f,-0.23330001f,0.31260000f,-0.71699998f,1.61489995f,1.34249998f,-0.10000001f,-0.14099998f,0.82190000f,-0.89069996f,-0.06659998f,0.38190001f,0.21319997f,1.67359999f,0.05540000f,-0.24990000f,-0.79569998f,-0.69430001f,0.42870001f,0.75859996f,-1.41269996f,-0.20499998f,-0.96079999f,-0.14579999f,1.00119997f,1.30759998f,-1.42350000f,-0.08770003f,0.48260003f,0.23419999f,-1.07570000f,-0.63220003f,0.69659996f,-0.20439999f,-0.38349999f,-0.48680002f,-0.94290000f,0.79919998f,0.32210000f,-0.23600000f,-0.32240002f,-0.46720002f,0.93180000f,0.42460003f,-1.65619997f,0.37959999f,0.73500001f,0.52660000f,-0.36079999f,0.37660000f,0.39529999f,0.97000002f,-0.44199991f,0.11759999f,0.95519997f,-0.30479999f,0.37699999f,-0.69779999f,0.97259998f,0.75979999f,-0.94419999f,-0.97970000f,0.37699999f,-0.66910000f,-0.29459999f,0.32749995f,0.12579997f,0.39549999f,-0.58179997f,-0.28350001f,-0.95729999f,-1.41489999f,1.45300000f,1.26050000f,-0.65560001f,0.17360000f,0.42559997f,0.81769999f,-0.50260001f,0.11180004f,0.42239996f,1.49959998f,-0.82699998f,-0.09980000f,-0.20439998f,-0.69260000f,-1.44910004f,-0.15920002f,0.96609997f,-0.42580001f,-0.05990000f,-0.42079999f,-0.92700000f,-0.44700000f,-1.09199998f,-0.05160002f,-0.18740000f,0.87860002f,1.20749999f,-0.72659999f,0.45359998f,0.12700001f,-1.07039999f,0.04720000f,-0.28420001f,-0.55440000f,-0.29710006f,-0.03620001f,0.56840001f,-0.33280001f,0.48270001f,0.40300001f,-0.49719999f,-0.03200000f,0.27770003f,0.62719998f,-1.39770001f,-1.32820000f,-0.42479999f,-0.70159998f,0.48359999f,-0.68719999f,-0.82539997f,-0.29580000f,-1.00029999f,1.15429998f,0.07939998f,0.49540003f,-0.66519996f,-1.45200002f,0.49110000f,0.52990000f,-0.36009999f,0.43620001f,-1.18509996f,0.04980001f,-1.20180002f,-0.39370001f,-0.58239999f,-0.85440002f,0.88030001f,-0.28190001f,-0.01949999f,-0.11139999f,0.16720004f,-0.24060000f,0.04849999f,-0.20939999f,-1.25679999f,0.00259998f,1.27939997f,0.47420002f,1.12950000f,-0.43659999f,-1.37759999f,-0.39900001f,0.53530002f,-0.74900002f,-0.16410007f,-0.85899999f,-0.73090000f,-0.94100001f,-1.19720003f,-0.64520001f,0.95049998f,-0.09000000f,-0.85749997f,-0.49820002f,-1.29790002f,-0.33840001f,-0.45650005f,-0.22060002f,-0.54959999f,0.35480001f,-0.10800000f,-0.93180001f,-0.41559996f,0.97189999f,-0.97039999f,0.41450001f,0.68839999f,-0.71719997f,0.43860001f,-0.02819999f,-0.81670000f,-0.93130003f,0.10280003f,-1.35499998f,-0.00039998f,-1.22359999f,-0.27159997f,-0.08160000f,-0.87129998f,-1.78549999f,0.78770000f,-0.57740001f,0.01160000f,-0.07030001f,-0.94529998f,-0.76859999f,-1.11940002f,0.74120001f,-0.43130001f,0.09400000f,-0.48330000f,0.33980000f,-0.16439996f,0.63599998f,1.92919997f,-0.61319999f,-1.05380001f,0.51620000f,0.47380001f,-0.81100002f,-1.39229998f,-0.13340000f,-0.59770001f,0.15520000f,-0.03639998f,0.05780000f,-0.17560000f,-0.89680001f,-0.90210002f,0.44399999f,-0.41470001f,0.29260000f,1.26080002f,-0.24859999f,-1.85180000f,0.42379999f,-0.09050002f,-0.80790000f,-0.53359999f,0.03420002f,-0.11090001f,1.55199996f,0.08999997f,-1.31510001f,0.45010005f,0.12140002f,0.90409996f,-1.18079999f,-0.04379999f,-0.66900003f,-0.01499999f,-0.42780000f,-0.22080000f,-0.51099999f,0.27460000f,-0.11560000f,-0.19210000f,-0.58600004f,-0.39439999f,0.59700001f,-0.52290001f,-1.32790001f,0.74970001f,0.71589999f,-0.52630001f,0.71440001f,-0.89650004f,-0.14440000f,0.00659996f,-0.01920000f,1.65900001f,-0.09119997f,-0.13130000f,-0.14540000f,0.98450000f,0.43999999f,-0.12510000f,-0.31040001f,-1.19309999f,0.08040000f,0.88180002f,0.12340001f,-1.15760004f,-0.30020000f,0.72220003f,-0.35640000f,-1.06160000f,0.68080000f,0.00550000f,0.61179999f,0.73560001f,-0.26639999f,-1.38369997f,-0.22719999f,0.06230000f,0.51879999f,-0.94309998f,0.67320003f,-0.88050001f,-0.07729998f,0.87499999f,0.79310001f,-0.20840000f,-0.44740002f,0.96199998f,-0.52030000f,-0.02939999f,0.01259998f,-0.43630000f,-0.48200000f,1.09030001f,0.25530003f,-1.09450001f,-1.77670002f,0.54910002f,0.07809998f,0.82919997f,0.43779997f,0.52649996f,-0.69449997f,0.85889999f,0.32350000f,-0.47749998f,0.04680000f,0.83670002f,-0.61819999f,0.00309998f,-0.17080000f,-1.23659998f,0.64760000f,1.30309998f,-0.13439999f,-0.42839997f,0.33620002f,0.51359999f,-0.09600000f,-0.78500001f,0.44160000f,0.43450003f,0.41560001f,-0.78439996f,0.64080000f,1.01099998f,0.24520000f,0.86770000f,0.40259999f,-0.69749996f,-0.08380000f,-0.55930000f,0.25459999f,0.51299999f,-0.11579999f,-0.15189998f,-0.45300000f,-0.19949996f,-1.29890000f,0.34060001f,1.04709999f,0.02850001f,-0.22569997f,0.47709998f,0.73510000f,0.37800000f,-0.19990000f,-0.05620000f,-0.04150001f,-0.37350001f,-0.17309997f,0.63530000f,2.02549998f,-0.15040004f,0.48349998f,-0.45150000f,-0.53669998f,0.80749996f,0.13569997f,-0.39599998f,-0.33170002f,-0.38810000f,-0.48859997f,0.64579998f,-0.71640000f,0.78350001f,0.36560001f,1.23769999f,0.27500000f,-1.40090000f,0.42260000f,0.66000006f,-0.72879999f,-1.33210000f,-0.50839999f,0.90730002f,0.27699998f,0.72990002f,-0.08200001f,-0.53450003f,0.05780000f,-0.74339998f,-0.07940002f,0.21329999f,0.34159999f,0.31419999f,-0.23839998f,0.58670002f,0.42480001f,-1.17189996f,-0.02360000f,-0.02340000f,0.66580000f,0.60700003f,0.15710000f,0.91569998f,-0.42710000f,1.48809995f,0.61030000f,-0.44680003f,-1.06129999f,-0.00239995f,0.02600003f,-0.69649997f,-0.19040000f,1.19839997f,0.22569997f,1.00810001f,-0.17790001f,-0.18309999f,-0.29480003f,-0.79459997f,-0.45090001f,0.65369997f,0.25870004f,0.66599998f,-0.73629998f,1.53759995f,1.17390000f,-0.41560001f,0.19749999f,-0.22010001f,-0.82920001f,0.63630001f,-0.11420000f,-0.92570002f,0.30480001f,-0.74869998f,-0.56640000f,1.26119998f,-0.52040000f,-0.29750000f,-0.02160000f,-0.37759998f,0.21780001f,0.31219998f,-0.59239999f,0.24229997f,-0.11139999f,0.07930003f,0.54220002f,0.42710004f,-0.21699998f,-1.78369997f,0.33460001f,1.60050002f,-0.21040001f,-0.68610000f,-0.07999997f,-0.95719998f,-0.55980001f,-0.37920001f,-0.71090001f,0.60610000f,-0.20440000f,-0.34970001f,0.72790002f,-1.29829998f,-1.12319999f,0.48350000f,-0.96720002f,0.37600001f,0.55519999f,0.75599999f,0.13710001f,-0.21219998f,-0.38449996f,0.53379997f,-0.35029999f,0.76670000f,-0.98879997f,0.89789999f,1.20260000f,-0.20270002f,-1.42300000f,0.84310002f,-0.17519997f,0.89239999f,0.31130000f,-0.93389998f,0.70839997f,-0.07319996f,0.64139999f,0.62630002f,-0.25779999f,-1.23650001f,0.86040003f,1.19620006f,0.41100003f,0.30250001f,-0.81820001f,0.51579998f,-0.14240000f,-1.30310002f,0.93560000f,0.97600001f,-0.61540000f,-0.38850002f,-1.01120002f,0.08789998f,0.28800000f,-0.21580000f,-0.21180000f,-0.94250002f,-0.42280002f,0.99949996f,-0.67059999f,-0.69899999f,-0.11440000f,-1.25069997f,-0.05470001f,0.72149995f,-0.11250000f,0.81779999f,0.74330002f,-0.04110003f,0.74550003f,1.03179999f,0.19909998f,-0.40869998f,-1.17070002f,0.98710002f,1.28839999f,0.04019997f,-0.41060001f,-0.59139997f,-0.52489999f,-0.43169999f,-1.04060005f,0.73139999f,-0.07700000f,0.15940002f,0.77180001f,-0.97240000f,-1.24569998f,-0.14599999f,-1.14720000f,-0.15389999f,0.50549997f,0.85450002f,-0.56780001f,-0.20120003f,0.56680001f,0.30350002f,-0.63720001f,-0.54909999f,0.25980002f,-0.58089997f,0.51980001f,-0.70659998f,0.58999999f,1.03499996f,-0.13700001f,-0.58390000f,-0.33860003f,-0.14430001f,-0.49540000f,-0.79800000f,-0.30360000f,-0.74360001f,0.16719999f,0.76160004f,0.30000001f,-0.31859998f,-0.46360000f,-1.03130005f,0.21840001f,1.78540002f,0.50470002f,0.00900000f,0.31970001f,-0.40100000f,-0.00119999f,-0.00380000f,-0.98660001f,-0.31579998f,-0.70049997f,0.65519998f,0.87440001f,0.19160000f,0.84330006f,0.68899997f,0.09780001f,-0.11359999f,-0.85060003f,-0.51920000f,-0.26510001f,0.42680000f,-0.10970001f,0.44499999f,-0.86310004f,0.51119999f,-0.88990004f,0.75259995f,-0.41200003f,-0.22299999f,-0.18400001f,0.40250000f,0.54430001f,0.95000000f,1.02689997f,0.98620000f,0.97660001f,0.74880000f,0.57170000f,0.05339999f,0.05770000f,0.47820004f,-0.35329997f,0.01170002f,-0.18620000f,0.12830000f,0.37780000f,0.30830002f,-0.74299999f,-0.11110001f,0.38659999f,-0.16620004f,0.31489998f,0.19829999f,-0.36040000f,-0.86050001f,-1.41710000f,-0.85870002f,0.34919999f,0.22719999f,-0.64539999f,-0.10060000f,-0.71840002f,0.11939999f,-0.66070002f,-0.08120000f,0.06890002f,0.45539999f,-0.80060005f,-0.52580000f,-1.47180004f,-0.10680000f,-1.04470002f,-0.54379997f,-0.07020002f,-0.81019998f,-0.07939997f,0.72179998f,0.16080002f,0.68040000f,-0.26290001f,-0.66439997f,-0.45669997f,-0.40019998f,0.98370005f,0.18520000f,1.90870006f,0.25959999f,0.00780002f,0.07390000f,0.96750000f,-0.09169997f,-1.30119997f,-1.08800000f,-1.35490001f,-0.86070001f,0.35550001f,0.17879999f,0.98910000f,0.84599998f,0.68909997f,0.77879999f,0.41550000f,-0.27720000f,-0.87509999f,-0.61449999f,-0.91000001f,-0.54410001f,0.25890000f,0.20000000f,0.97600000f,0.85039999f,0.32429999f,0.61950002f,0.14610003f,-0.08780000f,0.51809999f,0.36740001f,0.23249998f,-0.66999999f,0.27730000f,0.13240001f,0.72590003f,0.92479997f,1.24460003f,0.21620000f,0.72100002f,-0.14459999f,-0.57859999f,-0.10540000f,-0.84179998f,0.17099999f,-0.29020002f,-0.06039999f,0.20570000f,0.49539998f,1.00870000f,0.18779998f,0.62830001f,-0.11880000f,-1.53530002f,-0.26280000f,-0.41719999f,0.32499998f,0.17540000f,-0.45819998f,-0.63389998f,-0.41890000f,0.33469998f,-0.29430002f,-0.46549999f,-0.02639999f,0.07230001f,0.38840002f,-0.53350002f,-0.02900000f,-0.81359997f,0.28590001f,0.78579999f,0.60670000f,0.42629999f,-0.34739999f,-0.37839999f,0.17820000f,0.97189999f,-0.22650000f,-0.98229998f,-1.24409999f,-0.38450000f,-0.46560000f,0.17190001f,0.35640001f,0.66149999f,-0.62770002f,-1.02030000f,0.07540001f,1.11970001f,0.06960001f,0.17000000f,-0.15620000f,-0.56200002f,-0.40779999f,-1.62560003f,-0.04659997f,-1.15430000f,0.32939999f,-1.26960003f,-0.28019999f,0.01749998f,-0.20420000f,1.52810000f,0.43039998f,0.05590000f,0.15199999f,0.33499999f,0.18720000f,2.28760001f,0.11220001f,1.45500000f,0.36459997f,0.26080001f,0.61959999f,0.09199997f,-0.13619999f,0.19640000f,-1.02489997f,-0.70719996f,-0.96849999f,-0.23570000f,-0.61969999f,-0.60989997f,-0.03309998f,-0.36280001f,0.52150002f,-0.02110000f,-0.13370000f,-0.31799998f,-0.08999999f,-0.23129999f,-0.45930000f,-0.68349999f,0.07180001f,1.03659998f,0.23640001f,-1.16339996f,-0.31209999f,0.42099999f,-0.03910000f,-0.39839998f,-0.73739999f,-0.54210001f,-0.51389999f,-0.92419999f,-1.25750000f,0.81169993f,0.05980000f,1.63749999f,-0.28159999f,0.90100003f,-0.06560000f,-1.31950005f,-0.08900000f,-1.54910004f,0.15200000f,-0.63930002f,-0.32759999f,-0.14049999f,-0.21239999f,0.92480002f,0.38099998f,0.25129999f,0.16480001f,-0.89220004f,0.80339997f,-0.32740002f,0.13299999f,0.38140000f,0.45679997f,0.31749997f,-0.01560000f,0.33730000f,0.51179998f,0.78119996f,0.11270000f,-0.36759998f,-0.42069999f,0.28560000f,0.61010000f,1.22609996f,0.37200000f,-0.48939999f,-0.29390001f,0.56619998f,0.50009997f,0.77539996f,-0.01850003f,-0.55110001f,-0.82549999f,-1.01559996f,-0.17019998f,0.08200000f,0.38600001f,0.40090001f,0.09900003f,-0.93179995f,-0.50199999f,-0.66690001f,-0.33790000f,0.34640000f,-0.39409999f,-1.15819999f,-0.73649998f,1.03190000f,0.05379999f,0.57899997f,-0.52019999f,0.07589998f,-0.92459996f,0.55550000f,0.17019999f,1.25740002f,0.05019999f,-0.06219998f,0.03539999f,-0.49730000f,-0.47959999f,0.99550004f,-0.12680000f,-0.21319999f,0.19359999f,-0.75050002f,-0.18300000f,-0.54710001f,0.69359997f,-0.88830003f,0.31159998f,0.71150000f,-0.12339999f,0.58039999f,0.85019998f,0.34749997f,0.57280001f,0.79169999f,0.60690002f,-0.40739999f,-0.19290002f,0.49509998f,0.57280000f,0.42690000f,-0.12679999f,-0.55949997f,0.01380003f,-0.22479999f,0.12960002f,-0.29399999f,0.10409998f,1.09839998f,0.37950000f,-0.81139999f,-0.43240000f,-0.10840000f,-0.25990000f,-0.67409999f,-0.48250002f,-0.23200004f,-0.05179999f,-0.97839996f,-0.46739999f,-0.06420000f,0.06680000f,-0.73190000f,-0.63359997f,-0.20409999f,0.79659999f,0.02309997f,-0.03740000f,-0.64360001f,0.07980001f,-0.53820005f,-0.45099999f,-0.17610000f,0.25719999f,-0.96260001f,0.45299999f,-0.31420001f,-0.96219998f,-0.34619997f,-0.01760000f,0.11800000f,-0.39019998f,-0.04530000f,-0.07640000f,-0.30270001f,-0.86519997f,-0.05719995f,0.41959998f,0.33860001f,0.37479998f,0.05040000f,0.21040003f,-1.15749999f,-0.12109999f,0.38669999f,0.75289998f,0.68659997f,0.50819998f,0.10579999f,0.40990000f,-0.52139999f,-0.72630000f,-1.08549998f,-0.48089998f,-0.16460000f,-0.11990001f,0.69160000f,0.55980002f,-0.33459999f,-0.08549999f,-0.67409999f,-0.67850000f,-0.97320001f,-0.22609999f,-0.16289999f,-0.02200000f,0.59020001f,0.75140002f,0.41350000f,0.49570002f,-1.43900005f,0.69119998f,-1.08020004f,-0.02639999f,-0.54810000f,0.11400000f,-1.05860000f,0.08740000f,-1.96780000f,0.10060001f,0.17830000f,-0.05000002f,1.01550004f,0.81699997f,-0.45900004f,-0.62640000f,-0.69080001f,0.09580000f,-0.35469998f,0.84159997f,-0.67130003f,0.43619999f,-0.64030003f,0.32500000f,-0.23890003f,-0.70360000f,-0.80670002f,-0.38400000f,0.38470001f,0.18140000f,-0.12250000f,0.03329999f,0.27340000f,0.13890003f,-1.08939996f,-1.11430000f,-0.25590000f,0.05429998f,0.95719997f,0.65889999f,-0.23930001f,0.39660002f,0.65270003f,0.71830000f,0.92969997f,1.04969999f,0.74399999f,0.40470000f,-0.37149999f,0.02829998f,1.10169997f,1.21970000f,0.67929999f,0.52130001f,-0.38949999f,0.15450001f,-0.29340002f,-0.31970002f,-0.11349998f,0.39479999f,-0.71550000f,-0.19940001f,-0.81100000f,0.61579998f,1.41070001f,-0.04040000f,0.75130003f,-0.16020000f,-0.98430001f,0.37539999f,-0.36080002f,0.40239999f,-0.51260002f,0.21999999f,-1.10030001f,0.38379999f,-0.68190001f,0.81399998f,-0.39240002f,-0.60079997f,-0.98520000f,-0.00799999f,-1.20840003f,0.38159999f,-1.85930005f,0.03940002f,-0.63620001f,0.22240000f,-0.04410000f,0.35020001f,-0.22400001f,-0.59239998f,-0.97679996f,-0.03859998f,1.28240000f,0.50710000f,0.18479999f,0.86780000f,1.19169997f,1.04709998f,0.29330001f,0.37970001f,0.04560000f,0.58540001f,0.43639999f,0.81830001f,0.41909999f,-0.25610000f,-0.31749998f,0.09440002f,-0.63560000f,0.39640000f,1.18959999f,0.42960001f,-0.71729999f,-0.22259998f,-1.64400003f,-0.34660000f,-1.23630001f,-0.28719999f,0.85719999f,0.17279999f,0.48019998f,-0.24460001f,-0.03320001f,-0.43519998f,-0.54630000f,-0.13079997f,-1.53320002f,-0.12360001f,-1.13370003f,-0.36480000f,-0.98900002f,-0.38259999f,-0.18770001f,0.69159998f,-0.82960006f,-0.47379999f,-0.93530000f,-0.01200000f,-0.48600002f,-0.49440000f,-0.84870002f,-0.10820000f,-0.47030000f,-0.30440000f,-0.75479998f,-0.72750000f,-1.01300001f,-0.74450003f,0.34569998f,-0.53760001f,-0.40790000f,-0.60210001f,0.45110001f,0.70960000f,0.65049998f,0.56000000f,-0.28679999f,0.13670000f,0.73880000f,0.38140000f,-0.38340002f,0.69379999f,1.17680000f,0.55170001f,0.17750001f,0.05280003f,0.08020000f,0.75560000f,1.16949996f,0.64629997f,-0.21550000f,-0.17310000f,0.18150000f,0.48979998f,0.07360001f,0.61259999f,1.54850003f,0.20739999f,1.53720003f,0.50479999f,0.95000000f,-0.57259997f,-0.52280001f,-0.25259998f,-1.25390002f,-0.03500000f,0.28560001f,-0.37240000f,-0.63300000f,0.25000000f,-1.37560004f,-0.43540000f,-0.37990005f,-0.68699999f,0.24069995f,-0.64559998f,-0.07270000f,-0.39599997f,-0.47739997f,0.28759998f,0.04130000f,0.07920000f,0.32230001f,0.38760000f,0.77720000f,0.04900001f,-0.75149997f,-0.20310000f,0.54059997f,-0.14790001f,-0.28339999f,-0.19290000f,0.21440000f,0.11520000f,-0.35970000f,0.22349999f,0.32699998f,-0.46570000f,-1.21919998f,-1.09739998f,-0.55149999f,-0.09610000f,0.52629998f,0.59239999f,0.00090001f,0.25790002f,-0.17839998f,0.55600000f,0.68149997f,0.58209998f,-0.14959998f,0.40979998f,-0.66790002f,-0.38559999f,-0.06949999f,-0.10080000f,0.70710002f,-0.12820000f,0.81060001f,0.01979999f,0.34020000f,-0.11480000f,-1.08610003f,-0.41759999f,-0.49669997f,-0.57619998f,1.02420003f,0.29199998f,0.84209998f,0.00240000f,-0.07080001f,-0.67459996f,-0.71820000f,-0.08400001f,-1.38690003f,-0.35559999f,-0.45450001f,-0.21199999f,-0.22710001f,-0.31770000f,0.02290000f,-0.21950001f,1.06949997f,0.34479999f,-0.41880002f,0.88349999f,0.92449999f,0.61979999f,-0.28710000f,-0.52810001f,0.36950001f,-0.15950000f,0.64610002f,0.08190000f,0.09520000f,0.50220002f,-0.20249997f,0.27490002f,0.34260000f,0.35689999f,0.49729996f,-0.01160005f,1.05049995f,0.40159998f,-0.47580001f,-0.66620001f,-0.58599999f,0.51580001f,0.40659999f,-0.06280000f,1.60439998f,-0.71379997f,-0.44410003f,-0.36859998f,-1.17649997f,0.04859999f,-0.81359996f,0.63079998f,1.24140003f,-0.15319998f,1.95540004f,-0.04239999f,0.02630000f,-0.26479999f,-1.63330002f,-0.08200000f,-0.72310004f,-0.48299998f,0.84810002f,0.14940001f,1.00660001f,-0.87219996f,0.33450002f,0.30639999f,-0.18540001f,-0.41559999f,-1.17810001f,0.40450001f,0.61730000f,0.25139999f,-0.11730001f,0.43050002f,-0.77520000f,-0.20890001f,0.70989998f,0.35369999f,0.67840000f,0.35980001f,0.10540001f,-0.03209999f,0.18850000f,-0.11660002f,0.35049996f,-0.12290005f,0.40769998f,1.04039997f,1.36209996f,0.44400000f,-0.73449999f,0.07260000f,1.29530000f,1.00469998f,0.73799996f,0.35119999f,-0.30200000f,-0.88100000f,-0.64920003f,-0.16900000f,-0.86020003f,-0.46599999f,-1.03889999f,0.90379997f,0.27469999f,0.22479999f,-0.28510003f,-0.46959999f,0.47600000f,-0.02580001f,0.92490002f,0.50379998f,0.61360001f,0.06080001f,0.37220002f,-0.76339998f,-0.51299998f,-0.63779999f,-0.11960000f,0.18979999f,0.09660001f,-0.60639998f,-0.05249997f,-0.19520000f,-0.15559998f,0.59759999f,0.19199998f,0.26739999f,0.17850000f,0.56700000f,0.86449998f,-0.26550003f,-0.69740002f,-0.35550002f,0.15229999f,0.10750001f,0.23040001f,0.10780001f,0.94350001f,-0.36930000f,-0.92259998f,0.14060002f,0.35350000f,0.75930002f,0.28130000f,-0.21570001f,0.50760002f,0.59200002f,0.41270000f,0.09370001f,-0.75570000f,-0.15560002f,0.57939997f,0.58949998f,0.43389999f,0.26890002f,-0.59070001f,-0.68819996f,0.52600000f,-0.11999999f,0.11430000f,-0.47699999f,1.26810005f,-0.19720000f,0.93730001f,0.66879997f,0.32589997f,-0.27160000f,0.59590000f,-0.31079999f,-0.39430000f,0.18039998f,-0.72620001f,0.86639999f,0.08989994f,-0.53879999f,-0.14170000f,-0.05200000f,-0.08419998f,0.85179999f,-0.18270001f,0.24739999f,-1.39070003f,-0.36000000f,-1.20170002f,0.00310000f,0.45280001f,-0.27910001f,0.08590000f,0.81770001f,0.94850001f,1.01730000f,0.95809999f,0.51769999f,0.36520001f,-0.32449996f,-1.01559996f,-0.56919998f,-0.00110000f,0.60970002f,0.08810002f,1.21800002f,0.98420000f,1.09070001f,0.60000000f,0.21099999f,-0.03440000f,0.26819999f,0.84700000f,0.51590000f,0.34530001f,-0.53090000f,-1.13679999f,-0.13849998f,0.18080002f,-0.43140001f,0.34440002f,0.23960001f,-0.70730003f,0.52520001f,-0.08620005f,-0.76679996f,-0.39999999f,0.52199998f,0.38090001f,-0.21359998f,0.56330006f,-0.23840002f,1.09700002f,-1.02859998f,0.93779998f,-0.86819999f,-0.69590001f,1.28880001f,-1.33830002f,0.42359998f,-0.31790001f,-0.46960000f,-1.25930001f,1.14239999f,0.17829996f,-1.13759997f,0.17239999f,0.65590002f,0.17570001f,1.29130002f,0.34949999f,2.21520005f,0.33960001f,1.41370007f,0.35810001f,0.83350002f,-0.20490001f,-0.68410000f,-0.22820000f,-0.49990001f,-0.26970000f,-0.34790001f,-0.09810000f,-1.13049999f,-0.06230000f,0.60799999f,0.37100000f,1.11440002f,-0.12200000f,-0.68900003f,-0.26470000f,-1.91410004f,-0.37380001f,-0.96010006f,0.27200000f,0.64170002f,0.28410002f,-0.57000002f,0.90909999f,-1.19039998f,1.33470002f,-0.99920001f,0.84480005f,-0.34880001f,0.25059998f,-0.49880000f,-0.50460000f,0.09499998f,-0.30110003f,-0.16259997f,0.84109998f,-0.69620001f,-0.68479998f,1.02780001f,-0.55610000f,-0.02560000f,0.56439996f,-0.71739996f,0.13919998f,0.15660001f,-1.09270000f,1.79940001f,-0.15609999f,-0.02920001f,0.05160001f,0.08680001f,0.11680000f,-0.83339997f,-0.37399999f,-2.41570005f,-0.20880001f,0.18149997f,0.28450001f,1.12670005f,0.30210001f,1.41790002f,0.19269999f,0.99520001f,0.16530000f,-0.13239999f,-0.31940000f,-1.72270005f,-0.18470001f,0.06519997f,0.22950000f,1.04250003f,0.30580001f,0.95760002f,-0.06540001f,0.66910003f,0.20870001f,0.63980003f,0.01630000f,-0.38459998f,1.02729999f,-1.37380001f,-0.35279997f,1.57319997f,-2.32460002f,1.78420002f,-0.36789998f,0.02199997f,1.20960004f,-1.11320000f,1.08649999f,-0.83079997f,0.43860000f,-0.47280000f,-0.58330001f,0.92099999f,-1.51900003f,1.12420001f,-0.14979998f,0.07159998f,1.12150003f,-1.08680000f,0.49449997f,-0.77939998f,0.22840005f,0.17519995f,0.67960001f,-0.83039998f,-0.42869998f,0.21879999f,0.17480000f,-0.21910001f,-0.22470000f,-0.61580002f,-0.14690000f,-0.80480004f,-0.29970001f,-0.95310001f,-0.21510000f,0.24569998f,0.10330000f,1.27430003f,0.18110000f,-0.36049998f,0.04980000f,0.78470001f,0.35460000f,0.40440003f,-0.21760000f,-1.22690000f,-0.00050000f,-0.36359998f,0.20030000f,1.17330004f,0.43580001f,0.23850000f,-0.39450001f,-0.26850000f,0.28240002f,-0.20699999f,-0.14480001f,0.38120000f,-0.12820002f,-0.40840000f,-0.80070008f,0.22520005f,-1.45000003f,0.90619998f,-0.11790004f,-1.23659998f,1.17930002f,-0.23440001f,0.11840005f,0.75359997f,0.37790001f,-1.07099999f,-0.25499997f,1.34939997f,-0.33599999f,0.78199999f,0.04390003f,0.06879997f,0.30220004f,-0.38580000f,-0.57830004f,1.03880001f,0.47210001f,-0.18879996f,-0.17809999f,-0.99039999f,-0.10080000f,-1.34390000f,-0.23319999f,-1.17210004f,-0.28070001f,-0.01010003f,0.01140000f,-0.15880000f,-0.24420000f,-0.77020001f,-0.14400000f,-0.95080001f,-0.06310000f,0.47129999f,0.38220000f,0.28430006f,-0.18930000f,0.18550000f,0.16830000f,0.38510002f,0.05680000f,-0.68200003f,-0.22860001f,-1.15670004f,-0.13250000f,-1.31360006f,-0.84489998f,0.94379995f,0.00560002f,0.34900000f,-0.36869997f,0.62059997f,-1.09030006f,-0.06499998f,-0.63320004f,-0.00179999f,-0.33250001f,0.08919999f,-0.19139999f,0.15980000f,-0.57239996f,1.08559997f,0.31259999f,-1.13079998f,-1.15619998f,1.49419995f,-0.66250000f,-0.45379999f,-0.21479996f,0.80559996f,-0.80430003f,0.45820002f,-1.23900001f,1.31619998f,-1.04610006f,-0.52009997f,-0.03410000f,-0.43550000f,-0.08610000f,0.89839999f,0.18690000f,-0.29769998f,-0.09050000f,0.22779999f,0.28650000f,1.01229998f,0.23929999f,0.35359996f,-0.33280001f,-1.96220003f,-0.34939999f,-1.26400003f,0.00900000f,0.92630003f,0.09730001f,-0.67549996f,-0.16739999f,-0.64030002f,-0.18800001f,0.27079997f,0.17190000f,-1.09819999f,-0.17390000f,-0.33830000f,0.62630004f,0.66819996f,0.37840000f,-0.61699999f,1.96239998f,-1.57199997f,0.56290002f,0.68739999f,0.53820002f,-0.34219999f,0.84539998f,-0.94819995f,0.12509996f,0.39940002f,-0.69569997f,1.16999997f,-0.76030001f,-0.26000000f,0.32260001f,-0.46320002f,-1.13639996f,1.11719995f,-1.71330003f,0.68140002f,0.23730000f,-0.13380001f,-1.19620000f,1.50659999f,-1.35719999f,0.47620000f,0.09780001f,-0.20259996f,0.08630000f,0.94820001f,0.17790000f,0.73520001f,0.12570000f,0.06880003f,-0.33410000f,-1.20739999f,-0.03260000f,-0.10860000f,-0.01890000f,1.28030001f,0.11450000f,-0.81800002f,-0.32760000f,-0.80500003f,-0.13910000f,-1.25420002f,-0.29200000f,-0.99560008f,-0.36700001f,-1.88680004f,-0.22259999f,-0.46860000f,0.10700000f,0.71560001f,0.93499999f,-1.06899999f,-0.26509999f,0.73059999f,0.05169998f,-0.48999998f,0.38179998f,-0.57559999f,-0.12260001f,0.39759998f,-0.62419999f,0.24439999f,-0.99330001f,0.33139999f,1.19179999f,-1.50539998f,0.02050000f,0.73000000f,-0.25480002f,0.00500001f,-0.56950002f,0.57660000f,-0.16670008f,-0.19799994f,-1.00399999f,1.19399996f,-0.81439997f,0.27919998f,0.23120002f,-0.47879999f,-0.23440001f,0.00049997f,0.05580000f,1.31300001f,0.30859999f,0.65259999f,-0.02990000f,-0.04480001f,-0.23350000f,-1.05810001f,-0.33680000f,-1.32340004f,0.20010000f,1.14360000f,0.01420000f,-0.15529999f,-0.10430000f,-0.69410000f,-0.00400000f,-0.61190005f,-0.25830001f,-0.44820003f,0.01310000f,0.72780003f,-0.00160000f,0.08130001f,-0.03200000f,0.97550004f,-1.63630002f,1.39739999f,-0.82060006f,-0.65499997f,0.70809999f,-0.57119998f,-0.00680004f,-0.37939997f,-1.01640004f,0.33140001f,-1.06579999f,1.32179997f,-0.96589997f,0.55499999f,0.47779999f,-1.12480001f,0.03460001f,0.34339999f,-1.37869998f,0.99859998f,-1.90540006f,1.05700002f,-1.15170004f,0.21879999f,0.69450001f,-0.90960001f,0.80260001f,-0.79900000f,1.43200005f,-0.36350003f,0.10880000f,0.29160000f,-0.04650000f,-0.56720000f,-0.19410000f,-0.55700000f,-0.01240000f,0.24479997f,0.27470000f,0.57879999f,-0.01710000f,1.02690004f,0.36940001f,1.85140006f,0.36740000f,1.93440003f,0.34550000f,1.00160004f,0.11260000f,1.40310000f,0.18240000f,1.12030003f,0.20220000f,0.39520003f,-0.07480000f,-0.19970004f,-0.20350001f,-0.69200004f,-0.37430001f,0.40219999f,-0.12710001f,-0.64140000f,-1.23909997f,1.42099995f,-0.50169997f,0.54579999f,0.90689999f,-1.12339997f,-0.13800003f,0.26040001f,0.07450003f,-0.46060004f,0.77850001f,-0.97459998f,0.59890000f,-0.72900000f,-0.61339999f,0.72739999f,0.75149997f,-1.49459996f,1.09279999f,-0.83300000f,-0.52040001f,0.39980000f,-1.17620009f,-0.03859996f,-0.96820005f,0.07259996f,-0.21470001f,-0.34900004f,-0.19540000f,-1.19610001f,-0.21360000f,0.07920003f,0.33990000f,1.28730002f,-0.01300000f,0.53650000f,0.30040000f,1.51760005f,0.03680000f,0.16399999f,-0.15840001f,0.21739998f,0.00990000f,0.66220001f,0.38060000f,0.55430003f,-0.33149999f,-1.15100003f,-0.25700001f,0.50049998f,0.24700000f,-0.02429999f,-0.32050000f,-1.41810004f,-0.49220004f,-0.40719999f,-0.26330004f,0.01840003f,-0.66609998f,1.35839994f,0.68530003f,-1.57980000f,1.27350001f,-0.20479999f,1.05429996f,-1.57259995f,0.65449999f,-0.45660001f,0.08949998f,-0.41119999f,0.46719998f,-0.71379999f,0.32360002f,-0.07220002f,-0.27560002f,-0.11400000f,-0.83270002f,0.56960001f,0.82579998f,-1.53759999f,-0.01460001f,0.59680000f,-1.67380003f,-0.14349997f,-0.14090000f,-0.98050005f,-0.16190001f,0.11549996f,0.28949999f,-0.08380001f,0.05540000f,0.33480001f,0.01870001f,0.21820002f,0.09070000f,0.26340001f,-0.15130000f,0.53770002f,0.20040001f,-0.29470002f,-0.14320001f,1.18469999f,0.24330000f,0.90750003f,-0.12490000f,-0.64460000f,-0.17300000f,0.47590000f,0.29320000f,0.53130001f,-0.00540000f,0.02669999f,-0.78199998f,0.92819998f,-1.73130002f,1.35940002f,-0.02100000f,0.06480000f,-0.11319998f,0.79500000f,0.60850000f,-0.61080000f,0.87679998f,-0.99519997f,-0.12910002f,0.15859999f,0.86490003f,-0.76520001f,-0.26340003f,0.23760004f,0.64379997f,-1.55460000f,1.26780001f,-0.41160001f,0.74669999f,-0.37720000f,1.43859998f,-1.39819995f,0.26890000f,0.29540000f,-0.49319998f,-0.08110001f,0.23770000f,1.35170002f,0.11880000f,-0.19559996f,-0.26279999f,-0.43290003f,0.16689999f,0.14350000f,-0.03290000f,-0.32580002f,0.01180000f,-0.29600001f,-0.31920000f,-0.31490003f,-0.05830000f,-1.29050002f,-0.26680000f,-1.68820003f,-0.21760000f,-0.04810003f,-0.01770000f,-0.27409999f,-0.07980000f,-0.20080000f,-0.24160000f,0.35629999f,0.19539999f,1.01520000f,-0.41699998f,-0.16600002f,0.75230000f,-1.10800000f,-0.01509996f,0.85579997f,0.32389999f,-0.57499997f,0.35280002f,0.50579998f,0.09730000f,-0.36920000f,-0.27210004f,-0.01259998f,0.42789998f,-0.58619996f,-0.54159998f,1.65199996f,-1.10850001f,0.50459999f,0.52309996f,-0.83759996f,0.26409999f,-0.21460001f,-0.34320002f,-0.19400000f,0.65789998f,-0.74539997f,1.29869998f,0.09200000f,0.08900000f,0.54949999f,0.20950000f,-0.42410002f,-0.32590001f,0.28799997f,0.29690000f,0.91740002f,0.08500000f,0.84810001f,0.19000001f,0.51360008f,0.29520002f,0.26370005f,-0.09900000f,-0.30829999f,-0.18679999f,0.31240001f,-0.01410000f,0.36770000f,0.28730000f,1.28779998f,0.14610000f,-0.42720001f,-0.06880000f,-0.82740004f,-0.36840000f,-0.43630003f,-0.09519999f,0.27459998f,1.76710000f,-1.27199998f,0.39689994f,0.06820005f,0.32609999f,-1.09639999f,-0.27909998f,0.55460001f,0.53840003f,-0.10900001f,1.36660007f,-0.43780003f,0.49510001f,-0.38319999f,-0.50650001f,-0.11620002f,0.36379999f,-0.52900000f,0.96040000f,-0.24359996f,1.91019995f,-1.34759995f,0.29599999f,0.65160001f,-0.72290004f,0.32440001f,0.13349998f,0.50100002f,0.18870000f,0.04949999f,-0.26300001f,-0.91310004f,-0.02270001f,1.02769999f,0.36000000f,1.27570003f,0.05960000f,0.50020003f,0.10990000f,0.05760002f,0.23370000f,1.04739999f,0.19219999f,0.46959998f,-0.09370000f,0.77629997f,0.25869999f,0.13150000f,-0.16830000f,0.46030000f,0.24480001f,1.44370003f,0.24799999f,0.10099999f,0.03940000f,-0.48889999f,0.31420000f,-0.65000001f,0.21379996f,-0.33619997f,-1.37050001f,1.12540000f,-0.03610000f,-0.51740000f,1.05079999f,-1.03599999f,0.85580005f,0.14019997f,0.15190004f,0.06280000f,0.45999999f,-0.18019997f,1.01879997f,-0.77399996f,1.80779998f,-1.79879996f,0.21320001f,0.96279999f,0.97460000f,-1.71459999f,1.70260002f,-0.70799997f,-0.24530000f,0.45760000f,-1.07529999f,-0.01900002f,-0.13770000f,0.28150002f,0.30740000f,-0.19080003f,-0.40550001f,-0.87090007f,0.08760000f,-0.06659999f,0.28940000f,1.78270008f,0.29020001f,-0.41229997f,-0.39700000f,-1.00940002f,0.10920000f,1.20660003f,0.38120001f,1.48730006f,0.02220001f,0.28020004f,0.12180001f,-0.19499999f,0.00050000f,0.67499998f,0.25609999f,1.14799999f,-0.03200000f,-0.41709999f,0.57349996f,-0.45479999f,1.27650001f,-0.83539999f,0.16019996f,0.48340004f,0.42260001f,0.06060000f,0.15000004f,0.05919996f,1.06420005f,-0.98020002f,0.12360002f,0.91359999f,-0.43600001f,-0.52420000f,-0.19979998f,0.13499999f,0.69960000f,-0.74280002f,0.76300003f,-0.48300000f,-0.89429999f,1.18720000f,-0.35720004f,-0.58099997f,0.40799996f,-0.85739998f,-0.47410000f,0.32750002f,0.29050001f,0.76160004f,-0.08460000f,0.20290001f,0.17960000f,1.84150005f,0.12380001f,0.35020001f,-0.07150000f,-1.21879998f,-0.23619999f,-1.06680001f,-0.05120000f,0.07820001f,-0.11549999f,1.21270004f,0.17310000f,1.48880004f,0.22180000f,0.39640001f,-0.13040000f,0.63200001f,0.18750001f,0.39970005f,0.23940001f,-0.41430000f,-0.25430001f,0.24570000f,-1.29629999f,-0.82900001f,-1.42859999f,0.42639998f,0.29450005f,-0.62320000f,0.48649999f,0.27819997f,1.24659997f,-0.47430000f,0.20489994f,-0.11010001f,1.03250002f,0.20900000f,0.49239999f,-0.21819999f,0.83779999f,0.74610000f,-0.92379997f,0.14809999f,-0.24429998f,0.01290001f,0.40829999f,0.02970000f,-0.83700004f,-0.38540000f,-0.02710004f,0.26130000f,1.58399997f,0.90860000f,-0.60900000f,0.76740004f,-1.61890003f,-0.64620002f,0.90550001f,-0.20249998f,1.89340003f,-0.21360001f,0.73390002f,-0.60249997f,-0.61479996f,0.52610000f,-1.94769998f,-1.02259999f,0.35320004f,-0.02600001f,0.90920000f,-1.08300000f,1.56440002f,0.83030002f,-0.84600002f,-0.37609999f,-1.00729998f,0.30489999f,0.48119999f,0.93220000f,-0.31340003f,0.08169999f,-0.20520001f,-0.29220000f,-0.27480001f,-1.02590002f,0.52579998f,0.50500001f,-0.05139999f,1.07760001f,-0.67820000f,0.63350001f,-0.29520003f,0.18880000f,0.61059996f,-0.86499999f,1.25770001f,0.50970001f,1.04619998f,0.51780000f,0.57169999f,1.09420001f,0.19070001f,-0.63390002f,0.08619998f,-0.55200000f,-0.29270002f,0.24019999f,-0.84679997f,-0.34340002f,-0.06169999f,-0.35610002f,-2.29129997f,-0.53400002f,-1.01670000f,0.60390002f,2.08890006f,-0.92140002f,-0.70129994f,1.67940001f,-1.59170000f,-1.45969999f,0.49770000f,-0.34540002f,-0.37019998f,-1.25969999f,0.81740001f,0.07950000f,-0.27450001f,-1.00530002f,0.23939999f,-0.34849999f,0.93940001f,1.51359999f,-0.85589999f,-0.27980000f,-1.44049996f,0.54930002f,1.13369997f,-1.99070004f,-0.16020001f,-1.00399999f,0.15219998f,-0.06220001f,0.74220003f,1.19230003f,-0.56580000f,0.11900002f,0.31309997f,-1.06539999f,0.59860001f,0.53189999f,0.49859999f,0.04510000f,1.06720001f,0.89749999f,2.17839996f,-0.32680001f,0.15789997f,0.30959998f,-0.11620000f,0.83029999f,-0.27690000f,-0.68749998f,-0.89569999f,-0.61119998f,0.89379999f,0.37149999f,0.51880000f,-0.58360002f,0.26699999f,0.32630001f,0.79430001f,-0.93730003f,0.10980000f,1.04690000f,-0.60740001f,-1.04250001f,-0.21149999f,0.40789999f,0.81379999f,-0.23340000f,-0.71540000f,-1.24300005f,-0.49309998f,1.26210004f,1.46089998f,1.48710001f,0.22399998f,-0.71830001f,-0.41910004f,-2.03580006f,0.49700003f,1.21620002f,-0.47450001f,-0.03470003f,0.60499996f,-0.01130002f,-1.87089995f,0.35079998f,0.47170004f,0.36600000f,0.45250000f,0.21319999f,-0.09550001f,-0.55750000f,-0.33540000f,0.17780000f,0.59109999f,0.41180000f,0.14900001f,-0.38340000f,0.07519999f,0.22850001f,0.13990002f,0.74869999f,-0.42779997f,-0.43699999f,0.14310003f,-0.53200001f,0.29439999f,0.69190001f,1.07600000f,-0.60710000f,-0.96289999f,0.25819998f,-0.54980001f,-0.27960000f,-1.05999999f,-0.56170003f,0.07970002f,1.80870001f,0.19349996f,-2.09120001f,-0.55419999f,-0.26100001f,-1.70709998f,0.64970004f,0.96459998f,-0.16980003f,1.26090002f,0.12400004f,0.29319997f,0.96910003f,0.18699999f,2.01260004f,0.86220001f,-0.39350003f,1.25170002f,0.17960003f,-1.40889996f,-0.71569999f,0.31480003f,0.89880003f,1.03840003f,1.18060004f,0.27029999f,-0.68970000f,-0.09100003f,0.20660001f,0.32090001f,-0.52429999f,-0.65959999f,0.06790000f,0.59609998f,-0.58150000f,0.34270000f,0.56359998f,-0.47510000f,0.86470002f,-0.96489999f,0.49089996f,-1.11549999f,0.32689998f,-0.15759997f,-0.06679999f,-1.78700000f,0.72920001f,-0.54940002f,-0.66579998f,0.31119996f,0.50640001f,0.12379999f,0.48640001f,-0.00430001f,1.09260006f,0.61250000f,0.95530001f,0.58589998f,0.31730003f,1.05019999f,-0.84910001f,0.81270000f,-0.32150002f,0.58840003f,1.14090003f,-0.39959998f,-0.22320000f,0.06320001f,1.67240004f,1.21869998f,-0.94810005f,-1.31050000f,0.06950001f,0.24809996f,-0.88289996f,-0.23279999f,0.48970001f,-1.03609998f,0.40740004f,1.35499998f,1.06269999f,0.70449997f,0.22569998f,-1.58790000f,0.38179999f,-1.48919998f,0.35569999f,0.21680002f,0.39640000f,-0.09099999f,0.57839999f,-0.44720000f,0.65880001f,-0.74899998f,-0.14850000f,-0.68460001f,0.37840000f,0.60230000f,0.17570000f,0.03520000f,-0.84989998f,-0.43860001f,0.12509998f,-0.97180003f,0.45399999f,0.17619998f,-0.21160000f,-0.01669999f,0.94129998f,0.06080002f,0.10220000f,-1.43199998f,-0.26389998f,-1.26409993f,-0.37269997f,-0.13619996f,-0.23080003f,-0.51410000f,0.95070002f,-0.06990002f,0.03710003f,1.07259999f,-0.47940002f,0.96940000f,-1.10620000f,-0.52659996f,1.79850001f,0.14730000f,0.04059999f,1.55299996f,0.69359999f,0.93979996f,0.21549998f,-0.62339999f,-0.58240000f,-0.43579997f,0.34130003f,0.57160000f,0.71439996f,0.26909997f,0.10120002f,0.38019997f,-0.27149998f,0.60459995f,0.36160000f,1.09489997f,-0.03810000f,1.03870000f,-0.42330000f,-0.17510001f,0.22640000f,-0.21869998f,0.37420000f,-0.22300001f,0.02640001f,0.08209998f,-0.31859999f,-0.80899999f,0.62510000f,-0.50479996f,0.09660000f,-1.72309995f,-0.40170000f,-0.75589999f,0.15080001f,0.73040000f,0.37349999f,-0.07079999f,-0.07350000f,-0.99939993f,-0.37160003f,-1.78029998f,-1.13990001f,0.84800005f,-0.95200003f,-0.38039997f,0.90389999f,0.10949999f,-0.65930000f,-1.76299998f,0.15909997f,-1.23820003f,-0.26580000f,0.37449998f,1.26580005f,0.32980001f,-1.47140002f,0.03599999f,0.41290005f,0.32110004f,0.06599994f,0.67829997f,1.15360000f,-0.13840007f,0.37809998f,1.40299999f,-0.16189997f,-1.98999999f,-0.08310002f,-0.31729999f,-0.95699998f,1.11270001f,0.67100003f,1.60200002f,-0.07159999f,0.32049999f,-0.23300000f,-0.93099999f,-0.72560000f,1.58209997f,-0.84350000f,-0.41940001f,0.28229999f,-0.40919999f,-0.14349999f,-1.00020003f,0.52299999f,1.27160001f,0.17080001f,0.05500000f,0.30439999f,-1.08519996f,-0.32350003f,-1.47139995f,0.74210001f,-0.61259999f,-0.89790000f,0.86299997f,0.58449999f,-0.09180000f,0.03739998f,-1.99440001f,0.03630002f,-0.23140004f,-1.03120003f,1.49450000f,0.05529999f,1.72899997f,0.49460000f,0.95920002f,-0.33189994f,-0.64679999f,0.77840002f,-0.11870000f,-0.89369999f,0.19869999f,0.30260002f,-0.81140003f,-1.28660002f,-0.52960001f,1.77700005f,-0.64840002f,-0.39630002f,0.48230000f,0.28279998f,-0.40759999f,0.23539998f,0.15160001f,0.01040000f,0.07629999f,-1.03040001f,1.40470001f,-0.38290002f,0.58380001f,0.79609999f,-0.26739997f,0.89959998f,-1.80429998f,0.68880001f,-0.93860003f,0.16269998f,0.64609996f,-0.00990000f,-0.07590000f,0.52829998f,1.46759998f,-0.52430002f,-0.26280006f,0.22919998f,0.61009999f,-0.66840001f,0.24050001f,0.06040001f,-0.08810000f,-0.51569998f,-1.17449997f,-1.06479995f,0.58620001f,-0.39510005f,-0.62710001f,-0.05750002f,-1.96249996f,0.35119999f,-1.70399999f,-0.56309997f,-1.09979993f,0.17649999f,-0.06459998f,-0.42880000f,0.43010001f,-0.67930003f,-0.64759998f,-0.05180004f,1.25189999f,0.36470000f,1.54390000f,-0.86830000f,-0.38219997f,0.45810000f,0.07100000f,-0.14310002f,-1.96989999f,0.03840005f,1.27709999f,1.10220001f,0.55429999f,0.74159998f,1.14959997f,-0.08540000f,0.84359999f,-0.96789997f,0.11649997f,-0.91029999f,-0.48090001f,-0.16909999f,0.55199996f,0.20810001f,1.28410002f,0.30070001f,1.70210002f,-0.47079999f,-0.05280001f,0.60070000f,-0.37459994f,0.65710001f,-0.01649999f,-0.08959999f,-0.28170001f,0.05970000f,-0.62390003f,-0.80799999f,0.56650002f,0.83539998f,0.03300000f,-0.62570000f,-0.15069997f,0.96130004f,-0.33070001f,-0.02840000f,-0.20489999f,0.51540000f,-1.36360002f,0.25950004f,-1.54739997f,0.83640003f,0.17440002f,-1.16739997f,0.27070003f,1.97929998f,-0.74830006f,-0.96020000f,0.20460000f,0.18960001f,-1.59880001f,0.53590000f,0.32039997f,-0.36120003f,0.06329999f,1.52600002f,-0.66530004f,-0.77530000f,1.17369999f,-1.00000003f,-0.36600004f,0.41370001f,0.16559999f,-0.10270000f,-0.18840000f,0.03740000f,-0.30250003f,-0.69270000f,0.22049997f,-0.88569998f,-0.69080002f,-0.04660000f,-0.61090002f,0.61229999f,0.51279998f,-0.85270001f,-0.54559998f,0.21250000f,0.72269999f,-1.01640001f,1.11570001f,-0.41870001f,-1.58610001f,-0.00490001f,-0.79469999f,-0.77660001f,0.02380003f,0.53450000f,0.30410000f,-1.12230001f,0.75420004f,0.51170002f,-1.26089997f,-0.23170001f,-0.67570001f,0.77099998f,-0.54769995f,0.17730002f,2.12399999f,-0.96189999f,0.35850000f,-0.61609999f,0.04970003f,0.59040000f,-0.81830005f,-0.13430004f,-0.89809997f,-0.39550005f,-1.28529998f,0.43560001f,0.20629998f,-1.72170005f,-0.29279997f,1.66120004f,0.75199997f,0.06240003f,-1.01430000f,1.30289995f,-0.79700000f,0.81200001f,0.41619999f,-0.60739999f,0.96029998f,-0.40010000f,-0.23390000f,-0.53979997f,-0.77729998f,1.04180000f,-0.82259999f,0.59719998f,0.57199998f,0.49730000f,1.81219999f,-0.67560002f,-0.08359998f,-0.60229998f,0.37790000f,-0.70709997f,0.56840002f,-0.17420000f,-1.01590001f,0.48920001f,0.44410002f,0.28139999f,-0.14699999f,-0.67150001f,-0.78880002f,0.17540004f,-0.40150002f,-0.74690001f,-1.53599994f,0.19910000f,-1.32959998f,-0.90090000f,0.40220000f,0.82860002f,0.75769999f,-0.49970002f,0.02569998f,0.64269999f,0.33299996f,0.82390000f,0.97289997f,0.28920002f,-0.15300001f,0.20730002f,0.95960001f,-0.05859996f,-1.71259999f,0.54319997f,0.99569997f,1.21950004f,0.19980000f,-0.37790003f,-1.17219999f,-0.08770001f,-0.97699996f,-0.42530001f,0.03009998f,-0.72099997f,1.01459996f,-0.88449999f,0.54759998f,0.30549999f,0.94829999f,-0.09369999f,-0.78170000f,-0.10810001f,-0.94559999f,0.05299999f,-1.24109997f,0.38339999f,-1.01309997f,-0.10290000f,-0.33499999f,0.50130000f,-0.10010001f,-0.90980001f,-0.31030002f,0.47329999f,-1.74509999f,-0.01220000f,-0.12720000f,-0.56409999f,1.72060003f,-0.17510000f,-0.60290001f,0.59200000f,-0.45770000f,-1.30360003f,-0.86910003f,1.09710003f,-0.24990002f,-0.70800001f,1.08810000f,-0.41870003f,-0.79969998f,1.27610002f,-0.35069998f,-0.62290000f,1.08010002f,0.43760001f,1.11289997f,1.28230003f,-1.55090004f,-0.00050002f,0.69449999f,0.18659998f,0.88099996f,-1.42910000f,0.10100004f,0.49200004f,0.70549999f,-1.24670002f,-0.38559998f,-0.04500000f,1.52520000f,-0.57219998f,0.56940001f,-0.40440001f,0.67980000f,-0.63990000f,0.01790001f,0.36400000f,-0.77550000f,-0.31890000f,-1.10929999f,-0.25370000f,-0.16669998f,0.80890000f,-0.44090000f,0.71439997f,-0.73660000f,-1.05630002f,0.23830000f,0.14990000f,-0.24379998f,0.21309999f,-0.97560000f,0.57250001f,0.92889999f,0.44409999f,-0.18229998f,0.58080001f,0.44959997f,0.86060003f,0.66649998f,1.32120001f,0.53379993f,-1.02560007f,-1.79349998f,0.03360002f,0.95790000f,0.31570000f,0.18230000f,0.02300002f,0.37979999f,-1.35920004f,0.68700001f,-0.03699997f,-1.01719997f,0.32799999f,-0.34230000f,0.24510000f,-0.18050001f,-1.58670000f,-0.29609997f,0.78070001f,0.12459999f,-0.31940002f,-0.92910003f,0.48430001f,-1.23299995f,0.12709999f,-1.20729997f,0.20429999f,-0.58079995f,-0.25250003f,-0.77730000f,-0.89789998f,0.41220002f,0.52100000f,-0.62110000f,0.10430000f,-0.40149999f,0.29629999f,0.80440001f,0.75800001f,1.16499999f,-0.47579999f,0.24399997f,-0.26410000f,0.03990000f,-0.26550000f,0.14859998f,0.26190000f,0.17319997f,0.13919999f,0.57940000f,-0.45190001f,0.42230000f,0.62090000f,0.11370001f,0.00690004f,-0.83449994f,-0.18510000f,-0.43210004f,0.33280003f,0.76810001f,-0.35959999f,-0.83669998f,0.30829995f,-0.96680003f,-0.04549998f,1.36210000f,0.86440000f,0.47510002f,-1.52950004f,0.06590001f,-1.25610002f,-0.18119996f,0.94870002f,-1.64330002f,-0.60300002f,-1.37549998f,1.87009999f,0.13779995f,-0.49479998f,1.32570001f,-0.04930003f,1.06190000f,0.78979999f,2.23050003f,-0.24239999f,-0.29350000f,0.80830001f,-0.34519997f,-0.48659997f,-1.44989997f,0.23790001f,-0.05259997f,-0.16000000f,-0.20089998f,-0.12459999f,-1.62009999f,-0.31080000f,0.48099997f,-0.43430000f,-0.21950006f,-0.09410000f,-0.07539999f,-0.16680000f,-0.34180002f,-0.04090000f,-0.11739999f,-0.08200001f,0.00380005f,-0.74719999f,-0.91300000f,-0.51240000f,-0.31359999f,0.40830000f,0.16160002f,1.00290000f,0.26619998f,-0.74690000f,-0.45640003f,-0.77190002f,-0.32040001f,-0.58060004f,-0.14080001f,0.38120001f,0.22940003f,1.24210000f,0.46539999f,-0.07170001f,0.00039999f,0.16049998f,0.17639996f,-0.79309997f,-0.08259997f,0.63299998f,0.42260000f,-0.56709998f,-0.53159999f,-0.08189999f,-0.21839998f,0.63309999f,-0.89760003f,0.04729999f,0.31210000f,0.75520001f,1.27490007f,-0.22730001f,-0.27090001f,-0.77090000f,-0.74630003f,-0.65720001f,-1.02700001f,-0.62630000f,-1.05939999f,0.36829998f,0.39040002f,-0.45989999f,-1.08010003f,-0.31360000f,-0.56200000f,-0.79630000f,-1.72500005f,0.49670001f,0.51800006f,0.42520000f,0.67280001f,-0.25389999f,0.41549997f,0.29670001f,0.66120002f,-0.10830001f,0.22740003f,0.06329998f,-0.15259998f,0.93980002f,-0.24160003f,-1.27620002f,-0.14579999f,0.37459997f,-0.02579999f,1.25530001f,0.55520000f,-0.93430000f,-0.17059999f,1.02110000f,0.47580000f,0.82349997f,0.80979999f,-0.93959999f,-0.19240000f,-0.20310000f,-0.27780001f,-0.37580000f,-0.24439999f,-0.16480000f,-0.04539998f,1.49319998f,0.25759997f,-0.25229999f,-0.33709999f,0.40199998f,0.42010000f,-0.45779999f,0.58879999f,-0.78750001f,-1.73800005f,-0.56720000f,-0.45950005f,0.77889997f,1.12210004f,-0.39699998f,-1.54750000f,-0.29740000f,-0.36910000f,-0.80099996f,-2.20790000f,0.55890000f,-0.30849995f,-0.39039998f,-0.13709999f,-0.83569998f,-0.83910004f,0.52939997f,0.79190001f,0.17399999f,1.05259998f,0.08370000f,-1.13129997f,-1.64179997f,-0.74759998f,1.42840000f,0.42099999f,-0.50320001f,0.15400000f,-0.41440000f,-0.23979999f,0.28949999f,0.18020000f,0.16499999f,-0.12800001f,0.06140001f,0.33040001f,-0.49140001f,-0.05719999f,0.03000001f,-0.62560001f,0.39980001f,0.07319999f,0.61510002f,0.70380001f,-0.59410001f,0.07099999f,0.58030001f,0.31920000f,-0.91419999f,-0.58160000f,0.07879997f,0.77169999f,-0.58219998f,0.24729999f,-0.03609999f,-1.03270000f,-0.22199999f,-0.36230001f,0.46199999f,0.71390004f,-0.32389999f,-0.26870002f,-0.23720001f,-0.72280001f,0.29700000f,-0.29459998f,-0.60250001f,0.23949994f,-0.54279999f,0.12559997f,0.78169998f,0.49240001f,0.76400001f,-0.12469994f,-0.76130000f,-1.18430005f,0.74789999f,1.10210000f,-0.23149999f,-0.44059999f,-0.00440000f,0.39300001f,-0.31860001f,-0.19020000f,0.79770000f,0.09679999f,-0.52870000f,0.26220001f,-0.21870000f,0.12840003f,0.43800000f,-0.37720001f,-0.30760001f,-0.31280002f,-1.25430001f,-0.68500000f,-0.56979998f,-0.75019999f,1.07490002f,-0.07400001f,-1.46090002f,-0.79380002f,0.09729997f,0.25340000f,0.14279999f,-0.09040001f,-0.06740001f,-0.36960003f,0.60149999f,-0.53649998f,0.59590000f,0.52680003f,-0.31680001f,0.29719995f,0.90239998f,0.33430004f,-0.31119999f,-1.24839999f,0.04110000f,0.84189999f,-0.45209998f,-0.00949999f,-0.73450001f,-0.66940006f,-0.76119997f,0.20350001f,-0.58749998f,0.87589998f,0.51320000f,1.08870000f,-0.66260001f,-0.66670001f,0.34879998f,0.42320003f,-0.61880000f,-0.21440002f,-0.29820001f,0.09259996f,-0.59589998f,-0.97340001f,-0.22489999f,-0.60639999f,1.06579999f,0.30599998f,-0.81979998f,-0.14140001f,-0.80030001f,-0.42800001f,-0.65159999f,-0.56619998f,0.08859997f,-0.22640000f,0.93820001f,-0.02160002f,0.11350000f,0.76480002f,-1.03630001f,-0.65760001f,-0.35330002f,-0.22160001f,-0.16469998f,-0.20539998f,0.28500000f,-0.47740001f,0.33010002f,0.00500000f,-1.41070002f,1.56960001f,-0.51349999f,0.92649998f,-0.39259999f,0.37139998f,0.01730001f,-0.56879999f,-0.48909998f,-0.53090001f,-0.79590000f,-0.40420004f,-0.12700000f,0.63239999f,-0.59010000f,0.23569996f,0.34509999f,-0.58429999f,0.80509997f,0.76209999f,-0.23250000f,0.17590005f,-0.84999999f,-1.00909999f,-0.25900000f,0.74229998f,-0.84399997f,-0.43690003f,0.20310000f,0.44989996f,-0.40570000f,-0.04079999f,0.48299998f,0.01880000f,0.56079999f,0.37240001f,0.62660000f,0.23279999f,0.07910000f,-0.02040003f,-0.11109997f,0.11200000f,-0.79150003f,0.05719999f,0.11650001f,-0.36300000f,0.25569998f,-0.16660003f,-0.31949997f,-0.15120000f,-1.42799998f,-0.56579998f,0.17129997f,-0.06520000f,0.61830000f,0.04340000f,-0.26369999f,-0.18079999f,-0.52479997f,-1.24409997f,-0.24160000f,-0.15719998f,-0.60149998f,-1.17030000f,-0.10470000f,-0.31590002f,0.65519999f,0.99620003f,0.19660000f,0.18080002f,-0.04069999f,-0.89589998f,-0.28890000f,0.26519998f,0.45359998f,1.57889998f,-0.19330001f,0.07429996f,0.28899999f,0.41809998f,0.13739999f,0.78280000f,-0.46020000f,-0.23750002f,-0.25729999f,-0.23670004f,0.19749999f,1.14139996f,-0.28210002f,0.40340002f,1.01360001f,0.38599998f,0.42160002f,0.75200002f,-0.68020002f,-0.38900001f,-0.29349998f,0.15720003f,1.78609996f,0.90020001f,-1.26789998f,-0.69840000f,0.67160001f,-0.02940001f,-1.05230003f,-0.30680000f,1.29410003f,0.47699999f,-0.73710001f,-0.32539999f,-0.62409999f,-0.48179998f,-0.37619998f,-0.69420001f,-0.18080003f,0.31900002f,0.79660000f,-0.86400001f,0.63449997f,0.64830002f,-0.47200001f,-1.92840004f,0.11100000f,-0.31610004f,0.30049999f,0.17130004f,0.23490001f,0.00960001f,0.86709998f,0.61810002f,-0.41349999f,0.64800000f,0.37149999f,0.17730002f,-0.83979999f,-0.75329999f,0.03120001f,-0.33350004f,-0.19680000f,0.37209994f,0.28650000f,1.73560000f,-0.57990001f,-0.98500003f,0.41929999f,0.13960004f,0.95089999f,0.20760001f,-0.38150000f,0.16240003f,1.93390001f,0.80860001f,-0.29429997f,-0.00280001f,-0.67909999f,-0.39160001f,-1.81630000f,-1.08720001f,-0.03900005f,-0.07180001f,0.47850001f,-0.05080000f,-0.23000000f,-0.09079999f,1.17049999f,0.74340001f,-1.37400002f,-0.42880000f,1.14140003f,0.18400001f,0.60080001f,0.30580000f,-0.40350001f,0.03300000f,-0.74899997f,-0.09370002f,-0.00760000f,-0.85300001f,0.57349999f,0.82440002f,0.66370002f,0.13970005f,-0.43449998f,-0.35950004f,-0.57179998f,-0.04600002f,-0.82570000f,-0.30960001f,-0.58559998f,-0.41479998f,-0.05810000f,-0.16269999f,-0.70979997f,-1.29610000f,0.56580001f,-0.33119994f,-0.71849999f,-0.11770000f,0.71660000f,0.90690003f,0.23190000f,-0.20500000f,0.57109998f,1.30689998f,0.72819999f,0.36919999f,-0.18580000f,0.25620002f,0.29529999f,0.44800002f,-0.06640001f,-0.06979998f,-0.07329999f,-0.16299999f,0.66149997f,0.02020000f,1.03430002f,0.56320000f,0.65200002f,0.89040002f,-1.01610001f,-0.61720002f,0.38900003f,-0.03400001f,-0.41650003f,0.29559999f,-0.72839998f,-0.50779999f,-0.09940005f,0.13500001f,0.77660004f,-0.18100000f,-0.05520001f,-0.39389997f,-0.71289996f,-1.98699999f,-0.12130000f,-1.04569999f,0.57079997f,0.34130000f,0.48029997f,0.74360004f,-0.34320000f,-0.01510001f,-0.33680001f,-0.63740002f,-0.08489999f,-1.52950001f,0.60670000f,0.40809998f,-0.42540000f,0.42519996f,-0.21100000f,-1.04320002f,0.01820000f,0.01830000f,-0.18520000f,-0.28450000f,0.24779998f,1.06310001f,-0.64849997f,-0.58140002f,-0.23460002f,-0.29080001f,0.16260000f,-0.19880000f,0.07650001f,-0.06899999f,-0.34170003f,-0.13299999f,0.82349999f,0.37340000f,-0.60919998f,-0.71080000f,0.32219997f,0.11959999f,0.02190001f,-0.11719998f,0.25980000f,0.12339999f,0.38380001f,0.55440002f,1.28550003f,0.50780000f,-1.92680002f,-0.76640000f,0.62000001f,0.00060002f,0.74080001f,0.26919998f,-0.53370000f,0.33180004f,-0.76680001f,-0.48820003f,-0.06500000f,0.18230001f,-0.17650000f,-0.33560002f,0.31109999f,0.46580005f,0.63759998f,1.27200003f,-0.02790000f,0.53530003f,-0.74389997f,-0.92390004f,0.86229999f,1.32900004f,-0.18130000f,-1.00989999f,0.85330000f,1.01980003f,0.91590001f,0.72670003f,-0.16020000f,0.95209998f,0.82139999f,1.39500003f,-0.13569999f,-1.19140000f,-0.58490002f,-0.18360002f,-0.02230000f,0.16860001f,1.05829999f,0.56120001f,-0.73399998f,-0.39460000f,0.40009998f,-0.38520003f,-1.06860000f,-0.22100000f,0.16569998f,0.12039999f,1.27290000f,0.79980002f,-0.81009996f,-0.15919998f,0.99929998f,0.64480002f,0.18440002f,-0.03380000f,-1.14490002f,-0.30079999f,0.52340001f,-0.33400000f,0.25520000f,0.38040001f,-0.74750000f,-0.03689997f,-0.87700000f,-1.47470003f,0.31419999f,0.13280001f,0.40180000f,0.18930002f,0.42539997f,1.99379996f,-0.58330000f,-0.95800001f,-0.76589997f,-1.10289998f,-0.68359999f,-1.42550003f,0.80210001f,0.09010005f,0.40359998f,0.35019999f,0.57409997f,0.50519997f,0.35400000f,0.02020003f,-0.95310001f,-0.17370008f,-0.12780000f,-0.30659999f,0.58850001f,0.86790001f,0.23800003f,-0.00879999f,0.24949998f,0.46920000f,0.75069999f,0.47220001f,0.39100000f,0.20459999f,0.72000000f,0.32159997f,-1.01829998f,-0.18319999f,-0.47330001f,-0.47920000f,-0.37279999f,-0.59820001f,-0.28070000f,-0.16900000f,0.05020001f,-0.26020002f,-0.09040000f,0.37040002f,-0.23359999f,-0.63320000f,-0.96820001f,-0.79840001f,1.07520000f,0.67420002f,1.18410002f,1.59500001f,0.42880000f,-0.04179994f,0.42319998f,-0.06889999f,0.77089998f,0.64100003f,-0.19929999f,-0.27130000f,0.60359999f,0.21140001f,0.12610000f,0.80289998f,-0.03620000f,1.13329997f,-0.23730001f,0.26479998f,0.03230000f,0.69280001f,-0.33150000f,-0.97369999f,0.58970001f,1.37810002f,-0.36869999f,0.63229998f,-0.08910000f,0.21800002f,0.42579998f,-0.12990000f,0.24219999f,0.22140002f,1.29340000f,0.67179999f,-0.09639998f,0.48060002f,0.43950001f,0.11879999f,0.55180002f,0.30699999f,-1.52490000f,-0.32759998f,-0.40470000f,-0.67839999f,0.99539999f,0.18519999f,-1.32840001f,-0.78420001f,0.05540001f,0.05360003f,1.04660001f,0.21839999f,-0.43709999f,-0.18020000f,-1.04190002f,-0.26220002f,0.82510001f,0.14639999f,-1.03299998f,-0.73980004f,-0.17830000f,-0.53420002f,0.79609997f,-0.31939999f,0.29010001f,0.21990001f,0.85739999f,1.18810005f,0.08480000f,-0.77580000f,-0.01240000f,1.00379999f,0.02490000f,1.05870001f,-0.61279999f,-0.73050005f,-0.70779997f,-0.39520000f,0.80650001f,1.60130005f,0.18260000f,0.18089997f,0.07860000f,-0.16489997f,-0.86920000f,-0.65140003f,-0.26829999f,-1.06490000f,0.19430004f,-0.35659999f,-0.58670000f,-0.60960001f,0.60600004f,0.01740002f,-0.60900003f,0.30440001f,0.53110003f,-0.14420000f,-0.72720002f,-0.35800001f,0.05490000f,-0.12820000f,0.60579999f,0.46600000f,-0.23870001f,0.30200000f,0.08610000f,-0.05919999f,0.40930000f,0.15520000f,-0.12330001f,0.25640000f,-0.54690000f,-0.49720000f,1.18239999f,0.75160002f,-0.38459998f,1.79790001f,-0.05600000f,0.84899997f,-0.12770000f,0.94599997f,0.64830002f,-0.08069996f,0.51419997f,1.09389999f,-0.33149999f,-0.28830002f,-0.15670000f,0.32879999f,-0.28339999f,-0.63659999f,-0.66150000f,-2.08070002f,0.27550000f,0.26110002f,0.20560000f,0.42860000f,0.34470000f,-0.24609995f,-0.47169998f,-0.55990001f,-0.27379999f,-0.34499999f,0.40110000f,-0.14790000f,-0.50460000f,-0.67680000f,0.01000001f,-0.11479999f,-0.07920003f,-0.22799998f,1.42730001f,0.42019998f,0.51820004f,0.82660002f,-1.25460004f,-0.47359999f,1.11170004f,0.07540000f,0.35860000f,0.33419998f,-0.63390001f,0.14920000f,-0.35040001f,0.06240000f,0.42570001f,0.30820003f,-0.13390001f,0.01980002f,0.97480002f,-0.04799999f,-0.36039998f,-0.28000002f,-0.43590001f,-1.85120001f,0.02090002f,-0.27470000f,-0.71249996f,-0.47570000f,0.02049997f,1.21539999f,0.58710000f,0.31619999f,0.79439996f,0.23559998f,0.54900002f,1.13440001f,0.07289998f,0.30930002f,1.24829996f,1.05170000f,-0.90529999f,-0.95689999f,-0.41829996f,0.23620001f,0.54479998f,0.03700000f,-0.11849999f,-0.66330002f,1.02690001f,0.75690000f,1.00949998f,0.23120000f,1.10389998f,-0.33379999f,-0.13999998f,0.09520000f,-1.57480001f,0.31059999f,0.37469998f,-0.48460002f,0.63659998f,-0.22560000f,0.87600001f,0.14139999f,0.84299998f,0.36740002f,-1.09109997f,0.71100000f,0.75850001f,0.01599999f,-0.16140001f,0.34379998f,1.86879998f,-0.19579999f,-0.66689999f,0.47359999f,0.02370000f,-0.61299999f,-0.13900001f,-0.34779999f,-0.80860000f,-0.78869999f,0.43920001f,-1.01900003f,0.83730001f,1.26440000f,-0.56690001f,0.61550001f,-1.07320001f,-0.12940000f,-0.19470000f,0.08989998f,0.89459998f,-0.36759999f,1.36069998f,1.86030001f,0.04819995f,0.80459999f,-0.53480000f,1.36959999f,-0.73980001f,-1.09630001f,0.35820001f,-0.03090001f,0.57529997f,0.02620000f,-0.26779998f,-1.05390000f,0.04480002f,-0.15709999f,0.50100002f,0.39200002f,-0.15249994f,0.10840002f,-1.01710004f,-0.23620001f,1.64800001f,0.12240001f,0.64810003f,-0.14820000f,-1.78809998f,0.78040001f,1.66120000f,-0.05159999f,-0.71210000f,0.80200001f,1.14230000f,0.81339998f,0.69490000f,-0.11360000f,-0.01600003f,-0.12780000f,1.10849997f,-0.40680000f,-0.35659997f,0.04480001f,-1.52309997f,0.15259998f,0.47579999f,-0.60149998f,1.61769998f,0.66450001f,1.11070001f,1.40930004f,-1.20430003f,-0.32969999f,0.92609997f,-1.07730000f,0.78510001f,1.65839999f,-0.10290002f,0.16590002f,0.48019999f,1.88629998f,-0.10660003f,0.64599996f,-0.07610002f,0.53929999f,0.04380001f,0.69620000f,-0.24240000f,-1.38949997f,0.33230001f,-0.63759998f,1.05329998f,0.95529997f,-0.95469999f,0.99140001f,0.20940000f,-0.72679998f,-1.18240003f,0.44020000f,0.82930001f,0.26320001f,0.80880000f,-0.40400000f,-0.87829999f,0.37260001f,0.14010000f,-0.16080000f,0.41640000f,0.37560001f,0.38160003f,0.22100002f,-0.04760000f,-0.73120000f,-0.23300004f,-0.23940001f,-0.80879999f,0.62000001f,0.10250002f,0.32500000f,0.78170000f,0.15860000f,-0.21099998f,-0.69779999f,0.33100001f,-0.71749997f,0.10220001f,0.58310000f,-0.58850003f,0.46870000f,0.06699999f,-0.93720000f,0.17460001f,0.52300000f,0.39609999f,0.51070001f,-0.51699998f,-0.28280000f,0.41419999f,0.72650003f,0.78690000f,0.33190000f,-0.88329997f,-1.26850000f,-0.68339998f,-0.12140002f,-0.10010000f,1.34900003f,0.09599998f,-0.43110001f,-0.07490000f,-0.30399999f,-0.38679995f,-1.13439999f,0.45020001f,0.37700000f,-0.16789999f,-0.12080000f,-0.34070000f,-0.25360001f,-0.31079998f,0.50880001f,1.20330001f,0.34180002f,-0.67239999f,-0.40220001f,-0.11940005f,-0.24780000f,1.05120002f,-0.58320000f,0.22669994f,-0.71859999f,-1.04850005f,-0.39120001f,-0.18920000f,-0.86760001f,0.36129999f,0.34159999f,-0.43049999f,0.09200000f,0.23479998f,-0.46120002f,-0.30680000f,-0.40970001f,0.50499998f,0.44510001f,0.12590000f,-0.83010001f,-0.73509997f,0.36310000f,0.67259998f,0.00780001f,1.36969998f,0.75039998f,-0.51959999f,0.34700003f,-0.57190000f,-0.43240003f,0.20200003f,-0.63309999f,0.17040002f,-0.69480000f,-1.03900001f,-0.47269998f,-0.64889998f,-0.98230002f,0.93769997f,1.07419999f,0.13879998f,0.07759999f,-0.67880001f,-0.93610006f,-0.62280003f,-1.07220001f,-0.59710004f,-0.66359999f,-1.07740001f,0.24779999f,0.59799998f,-0.07940000f,0.62369998f,-0.28740000f,0.82899998f,-0.60199999f,-0.63409998f,-0.05740000f,-0.52560002f,-0.30300002f,0.19580000f,0.78340001f,0.29540007f,-0.74940001f,-0.22940002f,0.08399999f,0.98139996f,-0.03159998f,-0.71569999f,-0.41920001f,0.08929994f,-0.15499999f,0.48890003f,-0.70550001f,-0.24069998f,-0.79899999f,-0.26869997f,0.36169998f,-0.84000000f,0.38960000f,-0.35370000f,0.21610002f,0.00500000f,-0.99149998f,0.36240000f,0.21530000f,0.31380000f,-0.06200001f,-1.21529998f,-0.56129999f,0.60189999f,-0.08470001f,-0.10229995f,0.21859998f,0.72320000f,-0.16049999f,0.99329999f,0.86139998f,-0.59019999f,-0.44139999f,-0.70349998f,-0.95749999f,1.21949999f,0.19120000f,-0.17139999f,0.27259999f,0.50059999f,0.55980002f,0.17320002f,0.04079998f,-0.79180001f,-0.22680003f,-0.33660004f,0.04060001f,0.86160002f,0.24419999f,0.16639998f,-0.64080001f,-1.48089999f,-0.31180001f,0.05849997f,-0.40839999f,0.56900000f,-0.67799999f,-0.79749997f,0.14920001f,-0.16960000f,0.08660000f,0.41829999f,-0.33099999f,-0.70439999f,0.08860001f,1.18009995f,1.03869997f,0.50239996f,0.68780000f,0.51469999f,-0.05650001f,-0.35009999f,0.04269997f,-1.00020000f,0.12140000f,-0.75200000f,0.03329999f,0.61959997f,-0.74420000f,-0.44249998f,0.09959999f,-1.14879996f,-0.75039998f,-0.96259996f,-1.54679995f,0.37260001f,0.17690002f,0.64739999f,0.69619999f,-0.29380000f,-0.49229998f,-0.36089996f,0.12260001f,0.76120001f,0.45900001f,-1.19029998f,0.56000000f,0.95020001f,0.92840003f,0.97260005f,-0.60900002f,0.01349999f,0.30860002f,-0.74239995f,0.91780000f,0.46630003f,-0.74420000f,-0.76200004f,-0.21900002f,0.14070002f,-0.05640000f,-0.24000006f,0.53840000f,0.67790002f,-0.40399998f,0.26550002f,-0.68899999f,-1.13890002f,-0.79459999f,0.74250003f,0.46300000f,-0.24569999f,-1.00689997f,1.06569999f,1.87090002f,-0.35200004f,0.90100001f,0.29599996f,-0.43730000f,-0.31449998f,-0.79190000f,1.29159998f,0.54489998f,0.51360000f,0.11610002f,-0.09069997f,-0.69140001f,-0.51120000f,0.29199998f,0.49160002f,0.77950000f,-0.24350004f,0.04830001f,-0.44869996f,-1.35239999f,-0.11139994f,-0.22639994f,-0.81759996f,-1.14180001f,1.36899999f,0.33860002f,-0.51900002f,0.26960001f,1.08140003f,0.21060002f,-1.51219997f,0.76620000f,-0.13390001f,-0.00940000f,0.38119998f,-0.46280000f,0.91219996f,-1.13180001f,-0.04059999f,0.21439999f,0.21469996f,-0.02620000f,0.02800001f,0.14040001f,0.33859999f,0.79160000f,1.00350003f,-0.18780000f,-0.18160005f,0.02440000f,-1.03980000f,0.23060000f,0.51430001f,-0.13340001f,-0.46169999f,0.03900000f,0.09579999f,-0.82459999f,1.26020001f,0.91149997f,-0.17920000f,1.17970001f,-0.93190001f,0.20060000f,-1.06379998f,-0.96559996f,-0.32859998f,-0.23930005f,0.89959999f,0.23259999f,0.13010000f,0.72009999f,0.29210000f,0.29189996f,0.35019999f,0.45909999f,0.86260002f,-0.58510001f,0.07600001f,0.44430001f,-0.51810001f,-0.73669999f,-0.03700000f,-0.42089998f,-0.53750002f,0.66339999f,1.50399998f,0.43620002f,0.83850002f,0.56000001f,0.26800006f,-0.07340000f,-0.38889999f,0.06080000f,-0.29629999f,0.16320000f,-0.29210001f,0.67700001f,0.68820001f,0.93780001f,0.38040004f,-0.74200001f,-0.80520005f,-0.14039999f,0.71800002f,0.40199999f,0.58519999f,-0.56239999f,0.32890003f,0.30040000f,-1.17190001f,-0.12059999f,0.52449997f,1.32739996f,0.01559997f,0.48120001f,0.60810000f,-0.19759997f,1.25849997f,-0.45929999f,1.06660000f,0.18200001f,1.10299995f,0.69150000f,0.27259999f,1.13240001f,-0.24990003f,0.60520001f,0.20219996f,0.37500001f,-0.78909997f,0.06520003f,-1.11950000f,-0.10790001f,0.32179997f,-0.27859999f,0.02260001f,-0.83600000f,1.44950000f,1.37189999f,-0.63050000f,-0.73450001f,-0.18120000f,-0.04320000f,0.43839999f,-0.18120000f,-0.17500001f,0.00740001f,0.68770003f,-0.12540000f,-0.52490000f,0.39359998f,-0.19590001f,-0.88580001f,-0.99340000f,0.40459999f,1.14479998f,-0.39179998f,-1.28059998f,0.19860000f,0.70070000f,0.53900000f,-1.16580000f,0.23299999f,0.61570002f,-0.89000001f,-0.77440002f,-0.24039999f,-1.65129999f,0.24739999f,0.92100000f,0.57080001f,0.59710000f,-0.23740001f,0.29510001f,0.05260001f,0.27550000f,-0.84970001f,0.89500002f,-0.32080001f,0.87219997f,-0.48010000f,-0.17940000f,0.69439996f,0.27229997f,-1.18510001f,0.03890005f,0.41220001f,-0.03880000f,-0.53380002f,0.78819998f,0.35829999f,-0.81460001f,-0.97969999f,-0.00769997f,-1.41220001f,0.00730003f,0.88450000f,-0.84390000f,0.25200000f,-0.10540003f,0.02599999f,1.19839999f,0.23320000f,-0.57689997f,0.61480001f,0.67499999f,-0.58760001f,-1.84849998f,-0.49660002f,0.83399998f,-0.01699999f,0.46229998f,0.40800000f,0.48300001f,0.77020002f,0.68510000f,-0.24799999f,-0.75059996f,0.72220002f,-0.17879995f,-0.20320000f,0.29070001f,0.03340002f,0.05320000f,-0.44999999f,0.07419999f,0.35900000f,0.34480001f,0.42940001f,-0.05780002f,-0.56230000f,0.83329997f,0.56049998f,0.33209999f,-0.82939995f,0.13769999f,0.55619999f,-1.37659998f,-0.04460001f,0.18850000f,0.89420000f,0.41269997f,0.24739996f,0.20690001f,-0.49679995f,0.45489999f,0.05260002f,0.72189999f,0.16050000f,-0.39989999f,0.36920003f,0.83260000f,0.01270000f,-0.55399997f,-0.71030001f,0.47169998f,-1.44089997f,-1.18369999f,-0.13040000f,-0.09180000f,0.59359999f,-0.01799997f,0.43820000f,-0.73629997f,0.28260000f,-0.11550002f,0.07359997f,0.35420000f,-0.27780000f,-0.21459999f,-0.61560000f,-0.60860002f,-0.75900000f,-0.11850000f,-0.20300000f,-0.59130002f,-0.30420001f,0.78809999f,0.42780000f,-0.63040000f,-0.75379999f,0.18319998f,-0.97300002f,-0.90500002f,0.80280003f,-0.42409998f,-0.70419999f,0.04710001f,-0.18789999f,1.00959995f,0.03739998f,0.61659998f,1.05819998f,-0.18120001f,0.04289998f,-0.98170000f,-0.59580000f,-0.11709998f,-0.68260000f,-0.28459996f,-0.64529998f,-0.68309995f,-0.82309999f,0.09000002f,0.21100001f,-0.58460000f,-0.90420004f,1.03719997f,0.29020001f,-0.61909996f,-1.50340000f,-0.16719998f,-0.21030000f,0.72859999f,0.91770003f,0.13059998f,0.41260002f,-0.12509998f,0.57259999f,0.24890004f,0.58140003f,0.00510001f,-0.15720002f,-1.37540002f,0.21839999f,1.41590000f,-0.30559999f,-0.16240000f,-0.80500000f,-1.67820001f,0.34000001f,1.22740001f,-0.82200001f,0.46269996f,-0.06579999f,-1.68900001f,0.11720000f,0.07760001f,-0.35559999f,0.31070000f,0.00239999f,-0.05650002f,0.20220000f,1.06819999f,-0.27680000f,0.62270000f,0.29340001f,-0.09210001f,0.40720000f,0.55530001f,-0.42660001f,-0.34410000f,0.60259999f,-0.91450001f,-0.87709998f,0.63170000f,-1.03099998f,0.21530000f,1.02710000f,-0.46490003f,-0.15400002f,-0.50609996f,-1.75830002f,0.74030002f,0.60970001f,-0.66529999f,-0.23969999f,-0.78059996f,0.24350002f,0.46139998f,0.73979998f,-0.38730000f,0.51640002f,-1.36380002f,-0.47039998f,-0.22890000f,-0.77980001f,-0.93960003f,-0.29259998f,0.35130003f,0.38520001f,-0.99379998f,-0.16099999f,0.58590000f,-0.40180001f,-0.37780001f,-0.09240000f,-0.32910001f,0.75100002f,1.73260001f,0.38419999f,-0.00180000f,-0.11280000f,-0.45379999f,0.07860000f,-0.02899999f,0.53380000f,0.93119999f,-0.52120000f,-0.52620001f,0.87940002f,0.69960003f,-0.51369996f,-0.35679996f,-0.84059999f,-0.50629997f,-0.97160001f,-0.85279996f,-0.90109996f,1.14669999f,0.96060001f,-0.57410000f,-0.56839999f,-0.07449999f,0.04719999f,-0.13460000f,1.48550001f,-0.09200002f,0.01049999f,0.67099997f,-0.03700000f,0.13990000f,-0.17280001f,-0.06490000f,0.85349999f,0.56669997f,-0.09000001f,0.03740002f,0.19469999f,0.55330000f,-0.33380000f,0.42099998f,-0.58760000f,0.18819998f,0.11360001f,0.33600004f,0.02160002f,-0.61880004f,0.47899999f,0.74669998f,0.80500001f,0.94650005f,-0.63400001f,-2.07580004f,0.04560001f,0.22989998f,0.03499998f,-0.08849997f,0.23120000f,0.54840001f,0.36740001f,1.07620001f,0.29640002f,-0.05809997f,0.16440001f,-0.74130000f,-0.37279999f,-1.06320000f,-0.37620001f,-0.26860002f,-1.66500003f,-0.23119999f,-1.55040002f,0.51599997f,-0.83560006f,-0.59979999f,0.75520000f,-0.09600002f,1.40579998f,-0.51359998f,0.73980000f,-0.07020000f,0.79560001f,-0.16800000f,1.70340002f,-0.31559998f,0.68350003f,0.57319999f,-0.49059998f,0.37359998f,0.25830001f,-0.25139999f,0.49770002f,0.15360000f,0.35950000f,-0.26759999f,1.68950002f,0.01020000f,0.91099999f,-0.21380001f,0.73099999f,0.61350000f,0.95800001f,0.28450003f,-0.90129999f,-0.50639999f,-0.74040000f,-0.67550001f,-0.25460001f,-0.58450001f,0.24220001f,-0.20810003f,0.88749997f,-0.26080001f,-0.95530000f,-0.82970000f,-0.60659999f,-1.01619999f,-1.36839998f,-0.51190001f,0.75109999f,0.39950002f,0.17550000f,0.56790001f,0.30719999f,0.40289999f,0.55899999f,0.33010000f,0.69210000f,-0.07020000f,-0.39440003f,-0.68099999f,-0.28070000f,0.21020000f,0.20590002f,0.86979999f,0.50080001f,0.46500000f,1.51380002f,0.00780001f,1.40830001f,-0.71779998f,1.11840003f,0.02920001f,0.91590001f,0.32599999f,0.71000002f,0.55140000f,0.31309998f,-0.31680001f,-0.35120005f,-0.53119998f,-0.10690001f,0.38419998f,-0.67800002f,-0.07300001f,-0.77030000f,0.35879997f,1.08429997f,0.45029998f,0.53710000f,-0.37590001f,-1.11820002f,-0.88240004f,0.31809997f,0.29129997f,1.18749999f,0.05339999f,-1.11759998f,-0.63190000f,0.28569999f,-0.97080001f,-1.35189998f,-1.38079997f,-0.63829996f,-0.02999996f,-0.04539998f,-0.43999999f,-0.48889999f,-0.03830002f,0.97179997f,0.82829996f,0.88469997f,0.12090000f,-0.88299997f,-0.94939999f,0.55270002f,-0.82239997f,1.40880006f,-0.13840001f,0.83390003f,0.85120000f,1.28430001f,-0.02759999f,0.40760002f,-0.61019998f,0.16150001f,0.02459999f,1.32150002f,0.01900000f,1.49260000f,0.23019998f,1.01139997f,-0.49059999f,0.34210000f,0.22079999f,0.91410000f,0.54599998f,0.04130001f,-0.26779998f,-0.25029998f,-0.43199998f,-0.31129999f,0.21279999f,0.68560001f,0.66409999f,0.55499998f,-0.50320001f,-0.95790000f,-0.63340000f,-0.34100000f,0.24220001f,0.80789999f,0.21180000f,-0.24669999f,-0.33419999f,-0.36479999f,-0.34060001f,0.08480000f,-0.10440001f,0.08359999f,-0.09220001f,-0.20839999f,0.06610000f,0.11120000f,0.25210000f,-0.34589999f,-0.26229998f,-0.66170000f,-0.52570001f,0.15700000f,0.82280001f,0.31380000f,0.14249998f,-0.67740000f,0.47079997f,0.04449997f,0.08180000f,0.52369999f,0.02239999f,-0.18010001f,-0.18419999f,0.08359999f,-0.05740000f,0.52670003f,0.32919999f,0.06800000f,-0.38719999f,1.18320005f,0.00720000f,0.61820004f,0.75939997f,-1.45500003f,-0.12779999f,-1.52390003f,-0.53680000f,0.63620003f,0.27720000f,0.22269999f,-0.40959999f,-0.90139998f,0.43299998f,-0.03889998f,-0.02229999f,0.31010000f,0.37790001f,0.06589999f,0.24929999f,0.14720000f,0.17010000f,-0.16389999f,-0.29820001f,0.75319998f,0.28660001f,-0.22079998f,-0.42290000f,-0.57260001f,-0.32760001f,0.38970002f,0.15340001f,0.59809999f,0.25810000f,-0.15020002f,0.60080000f,0.06249999f,-0.22810002f,0.56649999f,0.06490000f,-0.30600000f,-0.29719999f,-0.20600000f,0.04520001f,-0.32210003f,-0.57159998f,0.16460001f,0.15880000f,-1.13250000f,-0.17059999f,-0.27649999f,-0.18780000f,1.60790002f,-0.54319999f,0.54780001f,0.50819998f,0.30220000f,0.62919999f,0.88330002f,0.49339997f,0.66279998f,0.44999998f,-1.10070005f,0.16480000f,-1.11250001f,0.78599999f,0.15639998f,-0.56839997f,0.89070002f,0.25360000f,0.36600000f,0.49400000f,-1.40940006f,1.00120001f,0.68370000f,0.38519999f,0.28879999f,-0.36710000f,-0.92679998f,-0.47229998f,-0.45070000f,-0.44700000f,-0.10060001f,0.04989997f,0.86509997f,0.15999999f,0.00780000f,-0.15429999f,-0.47179999f,-0.15300001f,0.06299999f,0.84060001f,0.59580002f,-0.09519998f,0.05080003f,-0.35180001f,0.69469998f,0.01550001f,-0.46129998f,-0.47540000f,-0.29310001f,0.56700000f,-0.36950001f,0.63699998f,-0.37510002f,0.47059998f,-0.46340002f,0.18540000f,0.16069999f,0.38699999f,0.91630002f,0.49179999f,0.53150000f,0.11820000f,0.53770001f,0.22500000f,-0.52040001f,0.28320000f,-0.93400000f,-0.82239998f,-0.24599994f,0.35879998f,0.93460000f,0.19360000f,1.74830001f,-0.16680000f,0.80780001f,0.73899997f,-0.31240003f,0.15659999f,-0.71149997f,-0.41340000f,0.61599998f,-0.29210000f,-0.19839999f,-0.79430001f,-0.23800000f,-0.05459999f,0.01440001f,0.42910003f,-0.45739998f,-0.17979999f,-0.66580001f,-0.41929999f,0.08680000f,0.41970000f,0.56189998f,0.47370000f,-0.68689997f,-0.02810000f,-0.18640000f,0.76799998f,1.09049996f,0.32119997f,0.12179999f,-0.42740001f,-0.45989999f,-0.02830001f,0.16539999f,0.33360000f,1.74510000f,-0.29539998f,1.64419998f,0.08140000f,1.48840000f,-0.26000000f,-0.19899999f,-0.24299999f,-1.46180003f,0.27240000f,-0.92060004f,0.24499999f,0.56159999f,-0.11019998f,-0.39530001f,0.07800001f,-1.47839999f,0.54519998f,-1.32069998f,0.26239999f,-1.07289998f,-0.00180000f,0.40210002f,-0.00360000f,0.83270001f,0.20199999f,-0.33869998f,0.10079999f,-0.72529998f,-0.09540002f,0.69129998f,-0.14340002f,-1.12100001f,-1.28760003f,-0.69400002f,0.25860001f,0.55150000f,0.45499998f,0.82599998f,0.02950000f,-0.11869998f,0.73790002f,0.50620000f,0.23080000f,0.01570000f,0.06190001f,0.02020002f,-0.87760000f,-0.75170001f,-0.10890000f,-0.03050000f,0.53709999f,0.79190001f,0.75130000f,-0.10750002f,-0.24330003f,0.81870000f,0.35249999f,-0.24149998f,-0.78939997f,0.59170005f,0.20200001f,1.17620002f,-0.40519999f,-0.18029998f,0.10900000f,-0.16730003f,-0.61059999f,0.22650001f,-0.86399998f,-0.05669995f,0.44799998f,-0.85690003f,0.02640001f,0.42170001f,0.29919998f,0.96489998f,-0.08799999f,0.00840002f,0.35359998f,-0.88639997f,0.07479998f,-0.96459996f,0.77559998f,0.28980001f,-0.77319998f,0.58460003f,-0.35500001f,-0.21420001f,0.14079998f,1.07979999f,0.23390001f,-0.61649997f,-0.21549996f,-0.95959999f,-0.54679999f,-0.65339999f,0.06900000f,0.51579998f,-0.37550001f,0.18950003f,-0.25679999f,0.10200000f,-0.30060000f,-0.28179998f,-0.83689998f,-0.27049997f,0.16780004f,0.51940003f,0.03850001f,0.40440000f,0.32620001f,-0.54030000f,0.22280000f,0.40689999f,0.86189999f,0.51519998f,-0.10000000f,0.38500001f,-0.75019999f,-0.37070001f,-0.50000000f,-0.20550001f,0.51999998f,-0.09460001f,0.75719997f,-0.01420000f,0.84339999f,1.05109998f,-0.03500000f,1.02009999f,-0.00320000f,0.97880001f,0.23979998f,0.82189997f,-0.62140000f,1.13690002f,0.15619999f,0.11779997f,-0.40360000f,-0.96970002f,-0.02220000f,-0.84760001f,-0.24919998f,-0.93209998f,-0.87669998f,-1.06119996f,-1.06209999f,-0.04030000f,-0.15260002f,0.70519998f,0.85869998f,1.17909998f,0.64769998f,0.64069997f,-0.18700002f,-0.12930000f,-0.82620002f,-0.96420000f,-0.89620001f,-0.52340001f,0.35070001f,-0.06100000f,-0.31230002f,-0.85500002f,-0.61290001f,-0.16099999f,0.28520000f,0.52109998f,0.21679998f,0.96770000f,0.16770000f,-0.71049999f,-0.29899998f,1.20949997f,0.18419999f,1.69750001f,-0.24660000f,0.91290004f,-0.84419996f,0.23830004f,-0.56319998f,0.74900001f,-0.18259998f,1.20260001f,0.04540001f,0.77390002f,-0.06360000f,0.41139999f,-0.63659998f,-0.23979997f,0.67179998f,-0.74380000f,0.49819999f,0.12399999f,-0.22039999f,0.24110000f,0.24379999f,0.45180001f,-0.66439998f,0.63640002f,0.56779997f,-0.46520004f,0.12470000f,0.12820000f,-0.20150002f,0.39540000f,0.08689999f,0.12149999f,0.29119999f,1.00990001f,0.55570000f,0.60770000f,1.12600001f,0.78479997f,-0.19370000f,-0.59639998f,-0.02600000f,0.89279999f,0.56260001f,-0.33589999f,-0.21390000f,0.49700000f,0.55690002f,-0.42730000f,0.95550003f,0.85840000f,0.74789999f,0.68529999f,0.30670001f,-1.00839998f,-0.69440000f,1.12380003f,0.22460001f,0.94420002f,-0.00860000f,0.34070001f,0.00380000f,0.32440002f,-0.40719999f,-0.08640001f,-0.71259996f,-0.57270002f,0.31380000f,0.47479995f,0.19119999f,-0.02040002f,-0.35360001f,-0.74629999f,0.05200000f,0.11029997f,-0.83859998f,-1.37550004f,-0.28640000f,-1.18850001f,0.33019999f,-1.33790003f,-0.36400000f,-1.04770000f,0.26639999f,0.47910000f,-0.40339999f,-0.52620000f,-0.57100002f,0.58049998f,0.04569999f,-0.18139999f,0.70890000f,0.95489995f,0.54529999f,-0.87359999f,-0.74990000f,-0.22609999f,-0.95879999f,-0.45659999f,-0.83250000f,-0.24049998f,0.67200001f,0.83599996f,0.26689996f,0.10499998f,0.47259999f,0.07890000f,0.01829999f,0.13899999f,-0.26050002f,-0.03020000f,-0.02340000f,0.29880000f,1.28100000f,0.37800000f,0.46760000f,1.00750000f,-0.48799998f,0.18830000f,-0.48179999f,-0.51009999f,-0.10319997f,-1.08189999f,0.87019998f,0.64249999f,0.34459998f,1.79770000f,0.11500000f,0.68989999f,-0.69380000f,-0.45289999f,-0.28419998f,-0.22139997f,-0.72279997f,-0.49329996f,-0.00360000f,0.80510004f,0.22700000f,0.72560004f,0.36319998f,-0.48540004f,-0.55239999f,-1.13059999f,1.06199998f,0.39759999f,0.22390000f,0.39419998f,0.31459999f,0.42449999f,0.18250001f,-0.54849998f,-0.31709997f,-0.55239998f,0.37950001f,0.26700000f,0.59340000f,0.40880001f,0.56360000f,0.13890000f,0.18099999f,0.30470001f,0.15810001f,-0.31490000f,-0.19750000f,0.67860000f,0.82890002f,0.11680000f,0.60840001f,0.85580000f,-0.02230003f,-0.05190001f,-0.19400001f,-1.51409999f,-0.20220000f,-0.05820002f,-0.69879996f,0.06589999f,-0.71439997f,0.01220000f,0.08279999f,-0.73930003f,-0.02779999f,-1.08820002f,0.04719999f,-0.73539999f,0.27679998f,-0.92889997f,0.54539998f,-0.55139999f,0.01080000f,-0.25440000f,0.43879999f,0.09609994f,-0.74859999f,-0.28540000f,0.59239997f,-0.80800002f,0.36580000f,-0.23230002f,-0.66979999f,-0.15819997f,-0.63530004f,-0.03290000f,-0.33000001f,-0.27250000f,0.02359999f,-0.02490000f,0.44280002f,0.33420001f,0.29390002f,-0.92030000f,0.06649999f,0.82419997f,0.94329999f,1.04179997f,-0.11960002f,-1.04980000f,-0.39029999f,0.10490002f,0.19290000f,1.07820000f,0.64020002f,-0.56279999f,0.08130000f,-0.20549999f,-0.20880000f,-0.08170000f,-0.80100001f,-0.66339999f,-0.63140001f,0.70950001f,-0.21500000f,0.06140003f,-0.54299998f,-0.08379997f,-0.48420001f,-0.81630001f,-0.29579999f,-1.39130004f,0.18160000f,-0.02010001f,-0.10700000f,-0.31960001f,0.14080000f,0.06139998f,0.37099999f,0.65110001f,0.75239997f,-0.48110006f,-0.63320000f,-1.00000001f,0.08060000f,-0.92289998f,0.30059998f,0.56120003f,0.30780001f,1.07110001f,0.20519999f,1.45940001f,0.94369999f,0.18629999f,0.55000000f,0.35900000f,0.43779999f,-0.03650000f,0.43690000f,0.77259999f,0.38929999f,-0.45890000f,-0.06160000f,0.28720000f,0.00120000f,-0.15549999f,-1.00700001f,-1.21399999f,-0.90530000f,0.27000000f,0.36910000f,0.33799999f,0.27590000f,0.04220000f,-0.28939999f,-0.35799999f,-0.11259999f,0.44340000f,-0.39520001f,-0.28639999f,0.42260002f,-1.14489998f,0.26979998f,-0.86810000f,0.43879999f,-1.72870004f,0.00919997f,-0.73509999f,-0.73179997f,0.06750004f,0.39619998f,-0.05630000f,0.21520000f,0.02549999f,0.21499999f,1.12570002f,0.16699999f,1.29660001f,-0.45859998f,0.00379999f,-0.11980000f,-0.54260001f,-0.18080000f,0.73459999f,-0.07800000f,0.94300000f,0.27399999f,0.24979999f,-0.62320000f,-0.13639999f,0.10670000f,0.51119999f,-0.20930003f,0.41539997f,-0.21770001f,0.24560002f,-0.76709998f,-0.98189998f,-0.73180000f,-0.26390001f,0.96560002f,1.27160000f,0.40880000f,-0.92770001f,-0.33610000f,-0.32770002f,0.11980000f,-0.27900000f,-0.61010001f,-0.26700001f,-0.33130002f,0.76910000f,0.65610001f,0.71969999f,0.68409999f,0.30159999f,0.57820001f,-0.47740000f,-0.37060000f,0.89870000f,-1.56820000f,-0.00509998f,0.16939999f,-0.27810005f,-0.14999998f,0.02700003f,0.67219996f,0.60080002f,-0.33540002f,0.87350005f,-0.36480002f,-0.14009999f,0.90700001f,0.71690000f,-0.36979999f,-0.46850000f,0.93680000f,-0.58380000f,-0.33280000f,0.14470001f,0.39000000f,0.10610000f,-0.24120000f,1.13320004f,-0.81100002f,1.21530006f,0.17699998f,0.52709996f,0.49520001f,0.24290000f,1.37500004f,0.11290001f,-0.52929997f,-0.25290000f,-1.21270003f,0.00050000f,0.07060000f,0.08710000f,0.44930003f,0.18070001f,0.67760003f,0.13830000f,-0.86570002f,-0.26960001f,-1.61520004f,-0.11420000f,-1.40260001f,-0.27670000f,-0.26240002f,0.14060000f,0.58500001f,-0.09280000f,-0.06109999f,0.21490000f,1.19980000f,0.14390000f,0.43260000f,0.47120001f,-0.77939999f,1.51860001f,-1.35940002f,-0.24829998f,1.04319999f,-1.64450001f,1.14340000f,-0.94720001f,0.58300000f,0.42460003f,0.05059997f,1.66320001f,-1.10079997f,0.16430000f,1.20940000f,-1.06070001f,0.78079999f,-1.69879999f,1.80259998f,-0.06050002f,-1.01820000f,0.89059999f,-0.39020000f,0.24500001f,-0.19260000f,0.39830000f,-0.72140000f,0.20429999f,1.16560000f,0.18560000f,0.59890002f,0.23600000f,-0.86850003f,-0.13580001f,0.20949996f,0.19300000f,0.93590001f,0.20410001f,-0.37009998f,-0.33790000f,-0.89410004f,0.14970000f,-1.00080001f,-0.32630001f,-2.06060004f,-0.39729999f,-0.99849998f,0.08000000f,-0.23299998f,0.04360000f,0.73379999f,0.22350000f,1.60270001f,0.21600000f,-0.57949999f,-0.29180000f,-1.18070002f,1.94030000f,-1.32139997f,1.80470006f,-0.33660001f,-0.95690002f,1.54200003f,-0.11540004f,-0.05659998f,1.57289999f,-1.60759998f,-0.04259998f,1.34699998f,-0.03759999f,-0.15239999f,-0.69859998f,1.78519997f,-0.92870001f,0.38759997f,-0.25829996f,0.23639997f,-0.53559996f,0.91179998f,0.51299997f,-1.26179996f,1.63469999f,-1.00219997f,-0.43910000f,0.87479998f,-0.94989998f,1.02919998f,0.36739999f,0.00379997f,-0.32390001f,-1.07530004f,-0.08560000f,0.27759999f,0.18930000f,0.55460003f,-0.05070000f,-0.79350001f,-0.03820000f,0.04859999f,-0.08120000f,-0.14680000f,0.12020000f,-0.33350000f,0.13830000f,0.60629999f,-0.09790000f,-0.13660001f,-0.33080001f,-1.20070003f,-0.07640000f,-0.60360003f,-0.12580000f,0.27850001f,0.22250000f,1.58220003f,0.08210001f,-0.29040000f,-0.71070003f,1.00880001f,-0.69570001f,0.45959999f,0.49639999f,-1.05919999f,0.43370002f,0.41039999f,-0.53869999f,0.49400000f,0.03140000f,-0.23360000f,0.62490004f,0.20320000f,-0.48279998f,0.48259998f,-0.62620004f,-0.49179998f,-0.29060003f,-0.01380000f,-0.50659998f,1.05260000f,-0.14040004f,-0.52519998f,0.00830002f,-0.20980001f,1.38940002f,-0.07910001f,-0.07680000f,-0.12099999f,0.09820000f,0.10010000f,-0.11030000f,0.27090001f,-0.04570000f,0.10880000f,0.16900000f,-0.21089998f,0.07650000f,-0.10000000f,0.01320000f,0.51990002f,0.33850001f,1.36800005f,0.38000000f,0.67539999f,-0.10080001f,0.56280000f,0.25780000f,1.34910002f,0.05220001f,-0.30689997f,0.02600000f,-0.38160000f,0.05660000f,0.18840004f,0.31799998f,-0.61179999f,0.37400001f,0.08540001f,-0.22490003f,-0.58739998f,0.17580002f,0.31759998f,1.36750003f,-0.80320000f,0.18350003f,0.44979997f,-0.99780000f,0.95040001f,-0.14409995f,-0.03320005f,0.54200005f,-0.33260001f,-0.42570006f,-0.08999997f,-0.73430002f,0.26020001f,0.71869998f,-0.75819999f,0.33900002f,0.61599999f,-0.66200002f,0.36040001f,-0.60530002f,1.66150007f,0.43250000f,1.65970004f,0.24390000f,-0.12390000f,-0.30250000f,-0.91820002f,-0.02170000f,-0.05510001f,0.16750000f,1.05740000f,0.34970000f,1.03340003f,0.12930000f,-0.48780000f,-0.17060000f,0.07849999f,-0.24020000f,-0.12589999f,0.31080001f,1.17330008f,0.17760001f,0.58820004f,0.25820000f,-0.02149998f,0.08850000f,-0.09940001f,-0.10770001f,0.74710000f,0.73080004f,-0.45520001f,0.11720001f,-0.10620000f,-1.02820001f,0.95179998f,-1.09280000f,0.70439999f,-0.42649999f,0.49060000f,0.61909999f,-0.83279998f,0.54380002f,0.27739999f,-0.90680002f,0.32440001f,-0.02140003f,-0.45879997f,0.50160005f,-0.50160003f,0.55130008f,0.35759995f,1.13990004f,-0.59539999f,-0.18159996f,0.88879996f,-0.95470002f,0.20680001f,-0.00309997f,0.10969999f,0.20490000f,-0.07149997f,0.03190000f,-0.59359999f,-0.11540000f,-0.77450003f,-0.13410000f,-0.46869998f,-0.14539999f,-0.54120000f,-0.18990001f,-0.14200002f,0.05450001f,0.21080002f,0.14820000f,0.26730003f,-0.12239999f,-0.16420001f,-0.06360000f,1.38359997f,0.37049999f,1.29180001f,0.11100000f,-0.52860000f,-0.09160000f,-0.14660002f,0.04780000f,0.11949999f,1.06540001f,-0.52339999f,0.67080002f,0.49499997f,0.19380002f,0.29440000f,-0.08340001f,-0.33180000f,-0.89560002f,0.38079999f,-1.27440003f,0.71020001f,-0.06650001f,0.04819999f,0.29399997f,-0.79859997f,-0.99380000f,0.80779998f,-1.24070002f,0.05600002f,0.54059998f,-1.19399996f,0.92200002f,0.09520000f,-0.26519999f,0.60099999f,-0.36680000f,-0.26519998f,-0.97469997f,0.76249997f,0.01610000f,-1.16830003f,-0.29700000f,-1.67960008f,-0.33620001f,-0.72520005f,0.17250001f,1.58210003f,0.15470000f,-0.28539999f,-0.32179999f,-0.37599999f,0.32100000f,0.86450002f,-0.04460000f,0.42900005f,0.18360001f,-0.70660001f,-0.28960001f,-0.80990003f,0.08000000f,1.09230000f,0.25480000f,1.01000001f,0.18280000f,1.44620001f,0.09640001f,0.15960002f,0.69559998f,-1.02639997f,-0.31010001f,1.38800002f,-0.74840005f,0.66120003f,-0.00230002f,-0.71400000f,1.39890000f,-0.97219999f,1.00370001f,-0.30100001f,0.35180005f,-0.32120002f,-0.12610002f,-0.19459999f,0.10590005f,0.38519996f,-0.47910001f,0.76180001f,-0.64510001f,0.12900000f,0.26760003f,-0.95620001f,-0.33269998f,0.39620002f,1.02350001f,-1.05460001f,1.52790001f,0.64930000f,-0.09320000f,0.56759999f,0.17130000f,-0.51039999f,-0.40660000f,-1.79720004f,-0.18900001f,-0.87070003f,-0.01740001f,0.85399999f,0.45450000f,1.58540007f,0.14830001f,-0.08219996f,0.04460000f,-0.07669998f,0.04570000f,-0.64869999f,-0.28930000f,-0.24799995f,0.31970001f,0.58360004f,-0.03140000f,-0.39560001f,-0.23190001f,-0.13250003f,0.01800000f,0.66560001f,0.16650000f,0.22440001f,1.37880001f,-1.39859999f,0.38750002f,0.31459998f,-1.38640000f,1.20559999f,-1.70650000f,0.95679998f,-0.55340000f,-0.12979999f,0.63330004f,0.08519995f,0.41950003f,-0.07760000f,0.01300005f,0.63459996f,0.04600002f,0.00279997f,0.77860009f,-0.19060005f,0.73870001f,-0.76599999f,-0.38590002f,0.44720001f,-0.06130004f,-0.69739997f,0.06440001f,-0.47299996f,-0.24310000f,-1.11540001f,-0.03970000f,0.09489997f,0.02090000f,0.73910002f,0.25340001f,1.19340003f,0.24850000f,0.08160002f,0.01130000f,-1.13480003f,-0.34440001f,-1.65090009f,-0.38870001f,-1.09240004f,0.15850000f,-0.05810003f,-0.18830001f,-0.32530005f,-0.09900000f,0.06000000f,0.25690000f,1.62600004f,0.19420001f,-0.50909997f,-0.05970001f,-0.17910002f,-0.60409996f,1.44179994f,-0.09679997f,0.09800000f,1.36339999f,-1.01059996f,2.01040001f,-1.45499998f,1.75390001f,-0.49919998f,0.58040001f,0.29600000f,-0.70290002f,1.03760001f,-0.54830006f,0.24460003f,-0.64400000f,0.27300000f,-1.45270004f,0.98980003f,-0.54020003f,0.15599999f,0.32940000f,-0.44799999f,1.63130003f,-1.12540000f,-0.07089996f,1.05119998f,-0.72390003f,0.58270006f,0.19850001f,0.43050003f,0.14990000f,0.47010002f,0.07030000f,0.92710003f,0.24500001f,0.96380005f,-0.00089999f,0.59840003f,0.34050000f,0.75780004f,-0.07060000f,0.01650001f,0.13100000f,0.48490001f,-0.08460000f,-0.01880000f,-0.09450000f,-0.90400002f,-0.33860001f,0.51120000f,0.38930001f,1.70750004f,0.06080000f,-0.39470001f,-0.29500000f,-0.82850002f,0.81330006f,0.23779999f,0.56730003f,-0.37780001f,0.44070002f,-0.04080000f,1.25790003f,-1.19740001f,1.57270001f,-0.94079999f,0.84919998f,-0.79579998f,-0.02099999f,0.97599996f,0.43740000f,-1.34079999f,0.15330002f,0.43499999f,0.69589999f,-0.93100000f,-0.18690004f,-0.00059999f,0.14300000f,-0.80820000f,0.77989999f,-1.10659999f,-0.79690000f,1.11039999f,-0.62070000f,0.17210001f,0.02260000f,0.22839999f,0.07640000f,-0.26289999f,-0.20870000f,0.15649997f,0.26160000f,0.24370002f,-0.07490000f,0.09520001f,0.09230000f,-0.41590000f,-0.04270000f,-0.99950000f,-0.32610000f,-0.10830005f,0.19049999f,0.56849998f,-0.17360000f,-0.66230004f,-0.02460000f,0.56810001f,0.23030000f,-0.04960000f,0.07160000f,0.62020000f,-0.07640000f,0.99110001f,-0.73309999f,0.96960000f,0.60169998f,-0.75539998f,0.59930000f,-0.00940001f,0.72629996f,-1.19299994f,-0.96960002f,1.19099999f,-0.83599998f,0.60479997f,-0.15859997f,0.80179998f,-0.02689999f,-0.14240002f,0.81199998f,-1.06099995f,1.00469997f,-0.39039996f,0.11899999f,-0.25179999f,0.42020004f,0.31620000f,-0.13109998f,0.09560000f,0.33529999f,-0.59640000f,1.28299999f,1.33800002f,0.04390000f,0.59769999f,-0.04340000f,-0.18520000f,-0.08660000f,-0.73879999f,-0.15280000f,-1.13380002f,-0.29210000f,-0.00290000f,0.08540000f,0.78250002f,0.20040000f,0.95060003f,0.18030000f,1.09930002f,0.10640000f,0.07980001f,0.01280000f,0.71860001f,0.02530000f,0.01320003f,0.20000000f,1.62390002f,0.38410001f,1.17000004f,-0.19870000f,-1.55560008f,0.73650000f,-0.61899999f,1.05459997f,-0.61679997f,1.14299997f,-0.81539998f,-0.06789999f,0.66379998f,-1.10780004f,0.28100000f,-0.34670001f,-0.33640000f,0.13370002f,-0.40320001f,-0.28489998f,-0.02520000f,0.07490001f,-0.33060001f,-0.42429999f,0.48860000f,0.76709998f,-0.99140001f,0.23840003f,0.06120000f,0.22930000f,-0.83940000f,0.70489999f,-0.15639998f,-0.35560006f,0.94080002f,-0.02310000f,-0.85370004f,-0.31030000f,-0.71330002f,-0.13650000f,-0.43110003f,-0.05850000f,-0.55890000f,-0.31080001f,0.24249997f,0.27870000f,1.58930001f,0.39460000f,0.31250001f,-0.22110001f,-0.52690001f,0.27380000f,1.71550004f,0.15680000f,-0.07249999f,-0.21470000f,-0.51810002f,-0.03270000f,0.38240000f,0.15290001f,-0.66559999f,-0.16240000f,-0.31950002f,0.12240001f,0.11800000f,0.01979998f,-0.10519998f,0.26800001f,-0.11760001f,0.23699998f,-0.76019999f,-0.99190003f,0.91260001f,0.26149998f,-0.84739998f,1.20929998f,-1.08839997f,-0.50060001f,1.38340000f,-0.86129998f,0.23779996f,0.99370001f,-1.50800001f,-0.05259999f,0.49500000f,-0.95880001f,0.17720000f,-0.14819997f,0.50479999f,-0.59069999f,0.81679999f,-0.08089997f,1.46350003f,0.12230000f,0.91060000f,0.22440000f,0.76570001f,-0.10720001f,0.96819998f,0.07310001f,-0.46830000f,-0.04630001f,0.28569999f,0.16380000f,0.40970002f,0.02370000f,-1.00800001f,-0.30850000f,-1.03480005f,-0.02410000f,-0.00039998f,0.06990000f,0.22390000f,-0.06740000f,-0.29709999f,-0.07240000f,-0.23249998f,0.24740000f,0.33000003f,-0.27100000f,-0.43730002f,0.40100004f,-0.16359999f,-0.14449999f,-0.30640001f,-0.48710002f,-0.27380000f,0.96340000f,-1.05219997f,-0.00209999f,0.63720000f,-0.24400000f,-0.22000000f,-0.12369999f,0.29879999f,-0.93079998f,1.57499999f,0.07529999f,-0.41540000f,0.60339999f,-0.44939999f,0.19429999f,-0.21080000f,0.10340002f,0.59639998f,0.25310003f,-0.32480002f,0.35970002f,0.09839999f,0.60170002f,0.59310004f,0.35570001f,1.21450002f,0.18950000f,0.35870004f,0.20090001f,-0.88490000f,-0.31630000f,-1.24590005f,-0.33730001f,0.25850000f,0.36020001f,0.29700002f,-0.21620001f,-0.85670008f,-0.26790001f,-0.33930001f,-0.08010000f,-0.46950001f,0.01930000f,0.08539999f,0.04300000f,0.68410002f,0.17820000f,0.23130001f,-0.02340000f,0.14159997f,-0.02820000f,-0.45950001f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_2d_8item_large_5o3i_uneven_filter_uneven_data_dilation_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{8,3,16,16};
    Shape shape_b{5,3,2,3};
    Shape shape_r{8,5,30,44};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1},        // move_strides
                                                                  Strides{1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0}, // below_pads
                                                                  CoordinateDiff{0,0}, // above_pads
                                                                  Strides{2,3}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f,0.64000000f,0.10000000f,0.22000000f,-0.81000000f,0.95000000f,-0.54000000f,0.86000000f,-0.12000000f,-0.38000000f,-0.48000000f,0.01000000f,0.89000000f,0.96000000f,0.51000000f,0.00000000f,-0.27000000f,0.72000000f,-0.07000000f,0.91000000f,0.45000000f,-0.56000000f,0.05000000f,-0.76000000f,0.23000000f,0.79000000f,0.88000000f,0.51000000f,-0.46000000f,0.73000000f,-0.46000000f,0.65000000f,-0.09000000f,-0.49000000f,0.43000000f,-0.78000000f,0.97000000f,0.25000000f,0.89000000f,-0.11000000f,0.72000000f,-0.10000000f,0.74000000f,0.13000000f,0.57000000f,0.55000000f,0.22000000f,0.36000000f,0.02000000f,-0.92000000f,0.66000000f,-0.26000000f,-0.09000000f,0.92000000f,0.38000000f,-0.17000000f,-0.79000000f,0.40000000f,-0.85000000f,-0.17000000f,-0.55000000f,0.77000000f,0.26000000f,-0.79000000f,0.01000000f,0.03000000f,0.58000000f,0.51000000f,0.24000000f,-0.49000000f,-0.34000000f,-0.34000000f,0.65000000f,0.59000000f,-0.81000000f,0.08000000f,0.26000000f,0.69000000f,0.62000000f,-0.71000000f,-0.80000000f,0.70000000f,0.13000000f,0.43000000f,-0.73000000f,0.93000000f,0.82000000f,-0.75000000f,-0.22000000f,-0.11000000f,-0.56000000f,-0.46000000f,-0.84000000f,0.68000000f,0.13000000f,-0.29000000f,0.13000000f,-0.13000000f,-0.41000000f,0.85000000f,0.37000000f,0.64000000f,-0.37000000f,0.64000000f,-0.81000000f,-0.29000000f,-0.31000000f,-0.62000000f,-0.47000000f,-0.90000000f,-0.15000000f,0.39000000f,0.75000000f,0.87000000f,-0.62000000f,-0.68000000f,-0.66000000f,0.14000000f,0.92000000f,0.70000000f,-0.35000000f,-0.57000000f,-0.12000000f,0.12000000f,0.41000000f,0.89000000f,0.85000000f,0.23000000f,0.57000000f,0.54000000f,-0.89000000f,0.97000000f,-0.66000000f,0.89000000f,-0.89000000f,-0.53000000f,0.43000000f,-0.04000000f,-0.39000000f,0.14000000f,0.91000000f,-0.83000000f,0.31000000f,-0.83000000f,-0.27000000f,-0.65000000f,0.76000000f,-0.56000000f,-0.17000000f,-0.94000000f,0.42000000f,0.13000000f,-0.77000000f,-0.16000000f,0.00000000f,0.66000000f,-0.67000000f,0.84000000f,-0.30000000f,-0.52000000f,-0.60000000f,-0.42000000f,-0.24000000f,0.54000000f,-0.48000000f,0.60000000f,0.72000000f,0.22000000f,-0.71000000f,0.71000000f,0.40000000f,0.12000000f,0.28000000f,0.43000000f,-0.04000000f,-0.91000000f,0.61000000f,0.82000000f,-0.88000000f,0.40000000f,-0.32000000f,-0.26000000f,0.16000000f,0.87000000f,-0.70000000f,0.68000000f,0.12000000f,0.12000000f,0.63000000f,-0.00000000f,0.12000000f,-0.48000000f,-0.93000000f,0.47000000f,-0.65000000f,0.15000000f,0.43000000f,-0.49000000f,-0.81000000f,-0.44000000f,-0.83000000f,0.85000000f,-0.85000000f,-0.45000000f,0.63000000f,-0.22000000f,-0.62000000f,-0.55000000f,0.30000000f,0.58000000f,-0.85000000f,-0.59000000f,0.03000000f,-0.19000000f,-0.84000000f,-0.22000000f,0.44000000f,0.04000000f,-0.20000000f,-0.61000000f,-0.14000000f,0.72000000f,-0.80000000f,-0.02000000f,-0.79000000f,-0.49000000f,-0.87000000f,0.88000000f,-0.86000000f,0.47000000f,-0.90000000f,-0.86000000f,0.77000000f,0.77000000f,0.67000000f,-0.58000000f,-0.53000000f,-0.41000000f,-0.75000000f,-0.13000000f,0.58000000f,-0.94000000f,-0.22000000f,0.39000000f,-0.89000000f,0.89000000f,-0.02000000f,-0.49000000f,0.01000000f,-0.39000000f,-0.93000000f,-0.45000000f,0.26000000f,-0.71000000f,0.88000000f,0.10000000f,0.47000000f,-0.49000000f,-0.41000000f,-0.50000000f,-0.40000000f,-0.01000000f,-0.19000000f,0.33000000f,-0.70000000f,-0.74000000f,-0.40000000f,-0.08000000f,-0.16000000f,-0.32000000f,0.14000000f,-0.61000000f,-0.64000000f,0.23000000f,-0.51000000f,-0.27000000f,0.00000000f,-0.29000000f,0.18000000f,-0.77000000f,-0.42000000f,0.99000000f,-0.10000000f,0.93000000f,0.51000000f,0.57000000f,-0.23000000f,0.45000000f,0.63000000f,-0.23000000f,0.70000000f,0.33000000f,-0.61000000f,0.40000000f,-0.47000000f,0.60000000f,0.03000000f,0.60000000f,-0.14000000f,0.60000000f,-0.81000000f,0.50000000f,0.03000000f,0.50000000f,0.98000000f,-0.53000000f,-0.97000000f,-0.59000000f,0.22000000f,-0.68000000f,-0.54000000f,0.94000000f,-0.61000000f,0.55000000f,0.46000000f,0.07000000f,-0.31000000f,-0.15000000f,-0.00000000f,0.51000000f,0.93000000f,-0.52000000f,-0.58000000f,-0.33000000f,-0.94000000f,-0.63000000f,-0.82000000f,-0.35000000f,0.75000000f,-0.95000000f,0.86000000f,0.11000000f,0.17000000f,0.05000000f,-0.41000000f,0.24000000f,0.36000000f,0.44000000f,0.33000000f,0.17000000f,-0.94000000f,-0.31000000f,0.67000000f,-0.50000000f,-0.77000000f,-0.82000000f,0.93000000f,-0.41000000f,-0.78000000f,-0.65000000f,0.24000000f,-0.49000000f,0.83000000f,-0.17000000f,0.56000000f,0.29000000f,0.76000000f,0.71000000f,-0.48000000f,-0.90000000f,0.61000000f,0.27000000f,-0.42000000f,-0.18000000f,-0.29000000f,0.18000000f,0.99000000f,0.36000000f,0.13000000f,0.20000000f,-0.32000000f,-0.06000000f,-0.37000000f,0.06000000f,-0.77000000f,-0.91000000f,0.07000000f,0.43000000f,0.48000000f,0.91000000f,-0.90000000f,0.98000000f,-0.49000000f,0.93000000f,-0.09000000f,0.27000000f,-0.01000000f,0.81000000f,0.13000000f,0.88000000f,-0.66000000f,-0.25000000f,-0.34000000f,0.23000000f,-0.93000000f,-0.02000000f,-0.46000000f,-0.24000000f,-0.83000000f,-0.87000000f,-0.73000000f,-0.36000000f,0.47000000f,0.87000000f,0.60000000f,0.77000000f,-0.25000000f,-0.31000000f,-0.14000000f,-0.71000000f,0.01000000f,0.06000000f,-0.24000000f,0.97000000f,0.92000000f,0.06000000f,0.11000000f,-0.39000000f,-0.49000000f,0.72000000f,-0.51000000f,-0.03000000f,-0.97000000f,0.72000000f,0.22000000f,-0.50000000f,0.49000000f,0.03000000f,0.32000000f,0.63000000f,-0.67000000f,-0.83000000f,-0.91000000f,0.69000000f,-0.64000000f,-0.65000000f,0.02000000f,0.42000000f,-0.08000000f,-0.09000000f,0.86000000f,-0.36000000f,-0.02000000f,0.70000000f,0.03000000f,-0.13000000f,0.75000000f,-0.01000000f,-0.89000000f,0.44000000f,-0.18000000f,-0.68000000f,-0.02000000f,-0.41000000f,-0.18000000f,0.62000000f,0.12000000f,0.68000000f,-0.50000000f,-0.22000000f,0.99000000f,0.70000000f,-0.06000000f,-0.63000000f,0.85000000f,0.31000000f,0.75000000f,0.11000000f,0.52000000f,0.52000000f,0.24000000f,0.00000000f,0.77000000f,-0.54000000f,-0.53000000f,-0.60000000f,-0.35000000f,0.43000000f,-0.11000000f,0.40000000f,0.79000000f,-0.05000000f,-0.35000000f,0.06000000f,0.46000000f,-0.56000000f,0.49000000f,0.64000000f,0.28000000f,-0.03000000f,-0.35000000f,-0.86000000f,-0.32000000f,0.17000000f,0.28000000f,0.67000000f,-0.08000000f,-0.83000000f,-0.75000000f,-0.09000000f,-0.21000000f,0.53000000f,0.57000000f,0.96000000f,0.11000000f,-0.72000000f,-0.87000000f,0.51000000f,-0.16000000f,0.86000000f,-0.08000000f,-0.42000000f,0.30000000f,0.07000000f,-0.85000000f,-0.94000000f,-0.05000000f,0.69000000f,-0.58000000f,-0.93000000f,-0.32000000f,0.55000000f,-0.13000000f,-0.03000000f,-0.26000000f,0.87000000f,-0.07000000f,0.68000000f,0.46000000f,-0.15000000f,-0.43000000f,0.51000000f,0.38000000f,-0.66000000f,0.71000000f,0.36000000f,-0.74000000f,-0.89000000f,0.65000000f,0.29000000f,0.06000000f,0.15000000f,0.74000000f,0.74000000f,0.08000000f,-0.85000000f,-0.58000000f,0.16000000f,-0.18000000f,-0.14000000f,0.72000000f,-0.16000000f,0.07000000f,0.87000000f,-0.07000000f,-0.85000000f,0.06000000f,0.41000000f,0.93000000f,0.72000000f,0.62000000f,-0.15000000f,0.80000000f,-0.53000000f,0.79000000f,-0.62000000f,0.61000000f,0.34000000f,-0.20000000f,-0.19000000f,0.68000000f,-0.58000000f,-0.44000000f,-0.60000000f,-0.92000000f,0.71000000f,-0.69000000f,-0.14000000f,0.81000000f,-0.20000000f,0.91000000f,-0.70000000f,-0.20000000f,0.44000000f,0.15000000f,-0.74000000f,-0.11000000f,-0.61000000f,0.56000000f,-0.97000000f,0.51000000f,0.11000000f,-0.38000000f,0.43000000f,-0.62000000f,0.36000000f,0.86000000f,0.29000000f,-0.39000000f,0.81000000f,0.89000000f,0.48000000f,-0.61000000f,0.48000000f,0.93000000f,0.23000000f,0.53000000f,0.25000000f,0.52000000f,-0.27000000f,0.55000000f,-0.60000000f,-0.98000000f,0.93000000f,0.65000000f,-0.64000000f,-0.41000000f,-0.54000000f,-0.87000000f,0.81000000f,-0.04000000f,0.59000000f,0.93000000f,-0.74000000f,-0.66000000f,0.88000000f,-0.20000000f,0.75000000f,0.18000000f,-0.32000000f,0.29000000f,0.01000000f,-0.50000000f,0.91000000f,-0.09000000f,0.24000000f,0.77000000f,0.58000000f,0.78000000f,-0.05000000f,0.71000000f,0.16000000f,0.19000000f,0.65000000f,0.99000000f,-0.87000000f,0.85000000f,-0.43000000f,0.74000000f,-0.91000000f,-0.46000000f,-0.49000000f,-0.08000000f,-0.08000000f,-0.23000000f,-0.86000000f,0.27000000f,-0.30000000f,-0.67000000f,-0.19000000f,-0.97000000f,-0.19000000f,-0.38000000f,0.20000000f,-0.94000000f,-0.94000000f,0.41000000f,-0.57000000f,0.26000000f,0.78000000f,0.64000000f,0.18000000f,-0.65000000f,-0.98000000f,0.20000000f,-0.71000000f,0.03000000f,0.24000000f,0.30000000f,0.35000000f,-0.91000000f,-0.46000000f,0.44000000f,0.91000000f,0.92000000f,0.91000000f,0.64000000f,-0.29000000f,-0.25000000f,-0.99000000f,0.89000000f,-0.77000000f,-0.51000000f,0.53000000f,-0.50000000f,0.04000000f,0.18000000f,0.55000000f,0.69000000f,-0.39000000f,0.54000000f,0.63000000f,-0.26000000f,-0.81000000f,0.56000000f,0.75000000f,0.89000000f,-0.37000000f,0.95000000f,0.57000000f,-0.39000000f,0.31000000f,-0.88000000f,-0.14000000f,-0.13000000f,0.43000000f,-0.41000000f,-0.09000000f,-0.10000000f,0.07000000f,0.70000000f,0.89000000f,0.32000000f,-0.41000000f,0.46000000f,-0.92000000f,-0.47000000f,0.18000000f,-0.65000000f,-0.77000000f,0.74000000f,-0.60000000f,0.16000000f,-0.58000000f,-0.55000000f,0.44000000f,-0.24000000f,-0.36000000f,0.90000000f,0.24000000f,0.91000000f,-0.18000000f,0.96000000f,-0.57000000f,-0.85000000f,0.08000000f,0.35000000f,0.32000000f,0.48000000f,0.53000000f,-0.89000000f,-0.43000000f,0.02000000f,0.83000000f,-0.62000000f,-0.53000000f,-0.46000000f,0.06000000f,0.54000000f,-0.30000000f,0.20000000f,0.88000000f,0.78000000f,0.49000000f,0.67000000f,-0.56000000f,-0.47000000f,-0.70000000f,-0.82000000f,-0.86000000f,0.14000000f,0.06000000f,-0.74000000f,0.43000000f,0.34000000f,0.02000000f,-0.55000000f,-0.76000000f,0.25000000f,-0.22000000f,-0.08000000f,0.99000000f,-0.60000000f,0.40000000f,-0.26000000f,-0.59000000f,-0.07000000f,-0.10000000f,0.85000000f,0.10000000f,-0.88000000f,0.42000000f,-0.18000000f,0.14000000f,-0.57000000f,-0.10000000f,-0.50000000f,0.08000000f,-0.33000000f,0.08000000f,0.50000000f,0.07000000f,0.33000000f,-0.78000000f,0.36000000f,-0.34000000f,-0.80000000f,0.23000000f,0.08000000f,0.48000000f,-0.12000000f,-0.88000000f,-0.67000000f,0.87000000f,0.44000000f,0.55000000f,-0.21000000f,0.85000000f,-0.16000000f,-0.57000000f,-0.18000000f,-0.39000000f,-0.44000000f,0.84000000f,-0.18000000f,0.50000000f,-0.87000000f,-0.21000000f,0.78000000f,0.98000000f,-0.77000000f,-0.95000000f,-0.83000000f,-0.62000000f,0.66000000f,-0.62000000f,-0.92000000f,-0.33000000f,0.02000000f,0.11000000f,0.58000000f,-0.90000000f,-0.01000000f,0.95000000f,0.73000000f,-0.03000000f,-0.92000000f,-0.88000000f,0.11000000f,-0.05000000f,-0.67000000f,-0.94000000f,-0.60000000f,0.00000000f,0.62000000f,-0.05000000f,-0.08000000f,-0.71000000f,0.75000000f,0.49000000f,0.50000000f,-0.51000000f,0.64000000f,-0.65000000f,-0.38000000f,0.63000000f,0.20000000f,-0.59000000f,0.76000000f,0.49000000f,-0.36000000f,-0.63000000f,-0.96000000f,-0.90000000f,0.39000000f,0.58000000f,0.60000000f,-0.47000000f,0.73000000f,0.97000000f,-0.59000000f,0.50000000f,-0.62000000f,-0.14000000f,-0.83000000f,0.73000000f,0.98000000f,0.31000000f,0.85000000f,0.94000000f,-0.94000000f,-0.48000000f,0.15000000f,-0.15000000f,-0.68000000f,0.15000000f,-0.84000000f,-0.79000000f,0.98000000f,-0.74000000f,-0.87000000f,0.42000000f,0.46000000f,0.72000000f,0.90000000f,0.32000000f,-0.56000000f,0.12000000f,-0.88000000f,-0.87000000f,-0.70000000f,0.43000000f,0.64000000f,0.01000000f,0.00000000f,-0.77000000f,0.09000000f,-0.60000000f,0.24000000f,-0.95000000f,0.09000000f,-0.98000000f,0.91000000f,-0.38000000f,-0.31000000f,0.72000000f,-0.73000000f,-0.18000000f,0.48000000f,0.04000000f,-0.92000000f,0.33000000f,0.83000000f,-0.03000000f,0.46000000f,0.89000000f,-0.78000000f,0.76000000f,0.40000000f,-0.09000000f,0.31000000f,0.63000000f,-0.47000000f,-0.79000000f,0.53000000f,-0.94000000f,0.17000000f,0.87000000f,-0.41000000f,0.59000000f,-0.67000000f,-0.56000000f,0.22000000f,0.15000000f,-0.85000000f,0.02000000f,0.14000000f,0.41000000f,-0.72000000f,-0.41000000f,-0.41000000f,0.59000000f,-0.10000000f,0.08000000f,0.23000000f,0.75000000f,0.83000000f,0.81000000f,0.04000000f,-0.40000000f,-0.19000000f,-0.05000000f,0.06000000f,0.50000000f,0.50000000f,0.55000000f,-0.10000000f,0.39000000f,0.06000000f,-0.12000000f,0.62000000f,-0.58000000f,-0.28000000f,-0.67000000f,0.55000000f,-0.97000000f,-0.93000000f,0.48000000f,0.50000000f,-0.42000000f,-0.76000000f,-0.59000000f,-0.96000000f,-0.99000000f,-0.80000000f,-0.88000000f,-0.31000000f,0.31000000f,-0.62000000f,-0.33000000f,0.82000000f,-0.54000000f,0.12000000f,0.56000000f,-0.30000000f,-0.53000000f,0.91000000f,0.50000000f,0.54000000f,0.70000000f,0.79000000f,0.00000000f,0.14000000f,-0.49000000f,-0.00000000f,0.49000000f,-0.84000000f,-0.05000000f,0.63000000f,0.67000000f,-0.50000000f,-0.94000000f,-0.69000000f,-0.02000000f,-0.23000000f,-0.92000000f,0.30000000f,0.90000000f,0.81000000f,-0.74000000f,-0.57000000f,-0.97000000f,0.98000000f,-0.10000000f,-0.46000000f,-0.30000000f,0.78000000f,0.42000000f,0.27000000f,0.43000000f,0.78000000f,-0.45000000f,-0.07000000f,0.39000000f,-0.42000000f,-0.43000000f,-0.90000000f,-0.00000000f,-0.33000000f,-0.22000000f,0.82000000f,0.41000000f,-0.40000000f,0.33000000f,0.63000000f,-0.95000000f,-0.61000000f,0.19000000f,-0.84000000f,-0.17000000f,0.36000000f,-0.80000000f,0.21000000f,-0.27000000f,0.64000000f,-0.26000000f,0.62000000f,0.42000000f,0.47000000f,0.64000000f,0.41000000f,-0.74000000f,0.33000000f,0.73000000f,-0.12000000f,-0.92000000f,-0.70000000f,-0.87000000f,0.99000000f,0.58000000f,0.17000000f,-0.49000000f,-0.95000000f,0.02000000f,-0.61000000f,-0.23000000f,0.07000000f,0.18000000f,0.86000000f,-0.92000000f,0.36000000f,0.52000000f,0.87000000f,0.09000000f,0.55000000f,-0.69000000f,0.71000000f,-0.99000000f,0.39000000f,-0.34000000f,0.91000000f,0.34000000f,-0.04000000f,-0.28000000f,0.80000000f,-0.21000000f,-0.27000000f,0.50000000f,-0.04000000f,0.94000000f,0.93000000f,-0.42000000f,0.71000000f,0.15000000f,-0.23000000f,0.95000000f,-0.42000000f,0.20000000f,0.88000000f,-0.97000000f,-0.81000000f,0.78000000f,-0.17000000f,0.98000000f,-0.45000000f,-0.08000000f,0.63000000f,-0.77000000f,-0.17000000f,-0.56000000f,-0.76000000f,0.52000000f,0.12000000f,0.76000000f,-0.33000000f,0.83000000f,-0.38000000f,-0.25000000f,0.54000000f,-0.87000000f,-0.19000000f,-0.62000000f,-0.81000000f,0.07000000f,0.87000000f,0.03000000f,0.96000000f,0.75000000f,-0.15000000f,0.63000000f,0.36000000f,0.57000000f,-0.88000000f,0.25000000f,-0.09000000f,0.56000000f,-0.11000000f,0.34000000f,-0.31000000f,-0.38000000f,-0.08000000f,0.73000000f,0.76000000f,-0.37000000f,-0.66000000f,-0.55000000f,0.50000000f,0.15000000f,0.97000000f,-0.15000000f,0.47000000f,0.21000000f,-0.77000000f,0.39000000f,0.68000000f,-0.76000000f,-0.71000000f,0.43000000f,0.31000000f,0.44000000f,-0.40000000f,-0.44000000f,0.88000000f,0.25000000f,-0.53000000f,-0.94000000f,-0.70000000f,0.05000000f,0.59000000f,0.61000000f,0.93000000f,0.72000000f,-0.93000000f,-0.37000000f,0.42000000f,0.16000000f,0.67000000f,0.97000000f,0.37000000f,-0.04000000f,0.16000000f,0.40000000f,-0.43000000f,-0.38000000f,-0.24000000f,0.27000000f,-0.32000000f,-0.21000000f,-0.46000000f,-0.57000000f,0.00000000f,0.93000000f,-0.94000000f,-0.32000000f,0.97000000f,0.33000000f,-0.82000000f,0.56000000f,0.47000000f,-0.61000000f,0.47000000f,-0.10000000f,-0.91000000f,-0.93000000f,-0.83000000f,0.83000000f,0.09000000f,-0.33000000f,0.85000000f,-0.15000000f,-0.48000000f,-0.41000000f,0.50000000f,0.35000000f,-0.53000000f,-0.72000000f,0.75000000f,0.29000000f,0.05000000f,-0.87000000f,0.57000000f,-0.04000000f,0.77000000f,0.59000000f,0.00000000f,-0.05000000f,0.29000000f,-0.09000000f,-0.52000000f,-0.42000000f,-0.55000000f,-0.88000000f,0.60000000f,-0.23000000f,-0.67000000f,-0.89000000f,-0.67000000f,0.02000000f,0.15000000f,-0.71000000f,-0.62000000f,0.41000000f,-0.43000000f,0.62000000f,-0.58000000f,0.03000000f,0.33000000f,0.74000000f,0.35000000f,-0.99000000f,0.37000000f,-0.87000000f,0.93000000f,0.61000000f,-0.32000000f,0.64000000f,-0.52000000f,-0.43000000f,0.52000000f,0.28000000f,-0.00000000f,0.96000000f,0.25000000f,-0.83000000f,-0.76000000f,0.13000000f,0.74000000f,-0.47000000f,0.27000000f,0.22000000f,0.10000000f,0.13000000f,-0.57000000f,0.44000000f,0.21000000f,0.66000000f,0.15000000f,0.40000000f,0.63000000f,0.62000000f,0.85000000f,-0.46000000f,0.68000000f,-0.64000000f,0.15000000f,-0.04000000f,0.52000000f,-0.68000000f,-0.00000000f,0.74000000f,-0.18000000f,-0.10000000f,0.84000000f,0.74000000f,0.56000000f,-0.34000000f,-0.26000000f,-0.77000000f,-0.75000000f,-0.95000000f,0.10000000f,0.73000000f,0.21000000f,0.04000000f,0.49000000f,0.66000000f,-0.36000000f,0.03000000f,-0.97000000f,-0.06000000f,-0.75000000f,0.56000000f,0.19000000f,0.64000000f,-0.32000000f,0.04000000f,0.76000000f,-0.96000000f,-0.64000000f,0.59000000f,-0.82000000f,0.14000000f,-0.29000000f,0.57000000f,0.03000000f,-0.29000000f,0.63000000f,-0.75000000f,-0.20000000f,-0.41000000f,0.89000000f,-0.46000000f,0.01000000f,-0.37000000f,0.48000000f,0.11000000f,0.90000000f,-0.65000000f,-0.70000000f,0.69000000f,0.23000000f,0.14000000f,-0.97000000f,-0.64000000f,-0.98000000f,-0.48000000f,0.79000000f,-0.07000000f,-0.83000000f,0.77000000f,0.75000000f,0.54000000f,-0.28000000f,-0.78000000f,-0.42000000f,0.08000000f,-0.90000000f,0.17000000f,0.83000000f,-0.82000000f,0.42000000f,-0.61000000f,-0.23000000f,-0.13000000f,-0.64000000f,-0.56000000f,-0.65000000f,0.40000000f,0.28000000f,-0.29000000f,-0.04000000f,0.77000000f,0.67000000f,-0.64000000f,-0.72000000f,-0.71000000f,-0.36000000f,-0.76000000f,0.62000000f,0.75000000f,0.89000000f,0.96000000f,-0.96000000f,-0.68000000f,0.61000000f,0.74000000f,0.10000000f,0.75000000f,-0.43000000f,0.08000000f,-0.93000000f,0.23000000f,0.02000000f,-0.95000000f,0.32000000f,-0.34000000f,0.85000000f,0.57000000f,0.56000000f,0.86000000f,0.44000000f,0.91000000f,0.58000000f,0.34000000f,0.36000000f,0.14000000f,0.45000000f,0.87000000f,0.89000000f,-0.69000000f,-0.42000000f,-0.58000000f,-0.22000000f,-0.32000000f,0.79000000f,0.80000000f,0.75000000f,-0.15000000f,-0.47000000f,-0.72000000f,-0.85000000f,0.47000000f,-0.92000000f,-0.45000000f,-0.79000000f,-0.00000000f,-0.82000000f,-0.71000000f,-0.91000000f,-0.55000000f,0.29000000f,-0.20000000f,-0.76000000f,0.93000000f,0.43000000f,-0.88000000f,0.99000000f,0.21000000f,0.73000000f,-0.00000000f,0.22000000f,-0.59000000f,-0.91000000f,-0.83000000f,-0.66000000f,-0.05000000f,0.97000000f,0.12000000f,-0.87000000f,-0.23000000f,0.12000000f,-0.92000000f,0.90000000f,0.61000000f,-0.64000000f,-0.38000000f,0.99000000f,0.20000000f,0.32000000f,-0.83000000f,0.90000000f,0.14000000f,-0.17000000f,-0.90000000f,-0.33000000f,0.60000000f,0.72000000f,-0.34000000f,0.29000000f,-0.23000000f,-0.74000000f,0.54000000f,0.64000000f,0.15000000f,-0.19000000f,0.78000000f,-0.18000000f,-0.95000000f,0.55000000f,-0.47000000f,-0.96000000f,0.45000000f,-0.99000000f,0.71000000f,-0.24000000f,-0.85000000f,-0.81000000f,-0.90000000f,-0.68000000f,-0.16000000f,-0.46000000f,0.32000000f,-0.80000000f,0.16000000f,0.26000000f,0.61000000f,-0.21000000f,0.91000000f,-0.85000000f,0.49000000f,0.52000000f,-0.90000000f,0.27000000f,0.33000000f,0.55000000f,0.85000000f,0.12000000f,-0.14000000f,-0.30000000f,-0.23000000f,-0.28000000f,0.88000000f,-0.04000000f,-0.79000000f,0.39000000f,-0.12000000f,0.21000000f,-0.74000000f,0.28000000f,-0.91000000f,0.20000000f,0.24000000f,0.69000000f,-0.30000000f,0.78000000f,0.09000000f,0.10000000f,-0.12000000f,0.80000000f,0.98000000f,0.84000000f,0.17000000f,-0.17000000f,0.69000000f,-0.04000000f,0.93000000f,0.09000000f,0.56000000f,-0.00000000f,0.37000000f,-0.34000000f,-0.90000000f,0.71000000f,0.66000000f,-0.36000000f,-0.44000000f,-0.91000000f,-0.19000000f,0.96000000f,-0.65000000f,-0.22000000f,-0.71000000f,0.65000000f,-0.44000000f,0.22000000f,0.29000000f,0.63000000f,-0.45000000f,0.35000000f,-0.40000000f,0.24000000f,0.69000000f,-0.09000000f,-0.09000000f,0.35000000f,-0.27000000f,-0.11000000f,-0.23000000f,-0.01000000f,0.60000000f,0.32000000f,0.74000000f,-0.88000000f,-0.11000000f,0.82000000f,-0.77000000f,-0.89000000f,0.22000000f,0.81000000f,-0.58000000f,0.16000000f,0.72000000f,-0.65000000f,-0.99000000f,-0.31000000f,0.86000000f,0.40000000f,-0.20000000f,-0.34000000f,-0.36000000f,0.85000000f,0.68000000f,0.48000000f,-0.14000000f,0.07000000f,-0.09000000f,-0.65000000f,-0.83000000f,-0.76000000f,-0.23000000f,-0.90000000f,-0.25000000f,-0.36000000f,0.71000000f,-0.80000000f,-0.92000000f,0.93000000f,-0.16000000f,0.87000000f,0.52000000f,-0.77000000f,0.74000000f,0.27000000f,0.32000000f,-0.52000000f,0.85000000f,0.01000000f,0.67000000f,-0.71000000f,0.48000000f,0.86000000f,-0.85000000f,0.00000000f,-0.63000000f,-0.06000000f,-0.86000000f,0.16000000f,0.26000000f,0.28000000f,0.91000000f,0.67000000f,0.74000000f,0.10000000f,0.95000000f,0.62000000f,-0.98000000f,0.77000000f,-0.11000000f,0.12000000f,0.89000000f,0.55000000f,0.55000000f,-0.61000000f,0.25000000f,-0.94000000f,0.09000000f,0.12000000f,0.59000000f,0.27000000f,-0.92000000f,0.29000000f,0.74000000f,0.54000000f,0.82000000f,0.99000000f,0.81000000f,-0.07000000f,0.54000000f,0.75000000f,0.91000000f,-0.72000000f,0.65000000f,0.41000000f,-0.15000000f,-0.84000000f,0.52000000f,-0.89000000f,0.98000000f,0.22000000f,0.16000000f,-0.03000000f,0.73000000f,0.01000000f,0.01000000f,0.07000000f,-0.08000000f,0.73000000f,-0.00000000f,0.48000000f,0.24000000f,-0.55000000f,0.02000000f,-0.77000000f,0.49000000f,0.20000000f,-0.61000000f,0.87000000f,0.28000000f,-0.89000000f,-0.65000000f,-0.03000000f,0.39000000f,0.12000000f,0.12000000f,0.58000000f,0.18000000f,-0.67000000f,-0.08000000f,-0.61000000f,0.20000000f,-0.03000000f,-0.54000000f,-0.76000000f,0.01000000f,-0.58000000f,0.38000000f,0.15000000f,-0.16000000f,-0.08000000f,0.86000000f,-0.93000000f,-0.84000000f,0.01000000f,0.77000000f,0.65000000f,-0.96000000f,-0.51000000f,0.19000000f,0.62000000f,-0.52000000f,-0.23000000f,-0.95000000f,0.12000000f,-0.37000000f,0.51000000f,0.66000000f,-0.16000000f,0.13000000f,0.94000000f,0.15000000f,0.04000000f,-0.69000000f,0.51000000f,-0.24000000f,-0.66000000f,0.02000000f,-0.34000000f,0.03000000f,-0.36000000f,0.87000000f,-0.75000000f,0.22000000f,-0.78000000f,-0.16000000f,-0.66000000f,-0.98000000f,0.79000000f,-0.31000000f,-0.88000000f,0.94000000f,0.91000000f,-0.48000000f,0.16000000f,0.61000000f,0.69000000f,0.41000000f,-0.17000000f,0.15000000f,0.37000000f,-0.81000000f,0.93000000f,-0.60000000f,-0.69000000f,-0.70000000f,0.40000000f,0.98000000f,0.69000000f,0.10000000f,0.04000000f,-0.88000000f,0.29000000f,0.02000000f,0.41000000f,-0.11000000f,0.27000000f,-0.20000000f,-0.86000000f,0.06000000f,0.00000000f,0.96000000f,0.92000000f,0.95000000f,-0.09000000f,-0.60000000f,-0.42000000f,0.64000000f,-0.72000000f,0.78000000f,-0.34000000f,-0.57000000f,0.54000000f,0.78000000f,0.98000000f,0.80000000f,-0.46000000f,-0.71000000f,-0.57000000f,0.11000000f,-0.51000000f,0.76000000f,-0.11000000f,-0.57000000f,-0.93000000f,0.76000000f,0.25000000f,-0.27000000f,0.55000000f,-0.96000000f,-0.97000000f,0.86000000f,0.86000000f,0.52000000f,0.30000000f,-0.81000000f,-0.73000000f,0.70000000f,0.86000000f,-0.27000000f,0.54000000f,0.18000000f,-0.52000000f,0.17000000f,0.51000000f,-0.56000000f,-0.32000000f,-0.98000000f,-0.77000000f,0.21000000f,0.76000000f,0.06000000f,0.81000000f,-0.51000000f,0.16000000f,0.44000000f,0.93000000f,-0.98000000f,0.79000000f,-0.07000000f,-0.39000000f,-0.01000000f,-0.59000000f,-0.97000000f,-0.09000000f,-0.58000000f,-0.29000000f,-0.20000000f,0.88000000f,-0.89000000f,0.35000000f,0.08000000f,-0.67000000f,-0.49000000f,-0.85000000f,0.35000000f,0.05000000f,-0.07000000f,0.96000000f,-0.25000000f,0.89000000f,0.53000000f,-0.67000000f,-0.78000000f,-0.22000000f,0.36000000f,-0.84000000f,-0.73000000f,0.69000000f,-0.87000000f,0.06000000f,-0.70000000f,0.55000000f,-0.13000000f,0.52000000f,0.20000000f,-0.70000000f,-0.26000000f,-0.35000000f,0.75000000f,-0.94000000f,-0.17000000f,-0.81000000f,-0.66000000f,-0.78000000f,0.16000000f,0.46000000f,-0.26000000f,-0.99000000f,0.01000000f,0.84000000f,-0.31000000f,-0.83000000f,-0.75000000f,0.21000000f,0.22000000f,-0.35000000f,-0.41000000f,-0.97000000f,-0.16000000f,0.30000000f,-0.05000000f,0.98000000f,-0.66000000f,0.19000000f,-0.21000000f,-0.77000000f,0.17000000f,0.77000000f,-0.30000000f,0.85000000f,0.83000000f,0.69000000f,-0.05000000f,0.69000000f,0.47000000f,-0.47000000f,-0.79000000f,-0.79000000f,-0.28000000f,-0.62000000f,-0.46000000f,-0.48000000f,0.93000000f,0.26000000f,0.69000000f,0.09000000f,-0.40000000f,0.13000000f,0.77000000f,-0.84000000f,-0.74000000f,0.82000000f,-0.88000000f,-0.68000000f,0.80000000f,-0.63000000f,-0.67000000f,0.90000000f,0.03000000f,0.36000000f,0.22000000f,-0.47000000f,0.80000000f,-0.66000000f,0.75000000f,-0.00000000f,-0.20000000f,0.95000000f,-0.17000000f,0.00000000f,-0.74000000f,0.46000000f,0.40000000f,-0.59000000f,0.53000000f,0.03000000f,0.02000000f,-0.81000000f,0.09000000f,-0.68000000f,-0.63000000f,0.24000000f,-0.29000000f,-0.64000000f,0.65000000f,0.48000000f,-0.99000000f,0.47000000f,0.96000000f,-0.85000000f,0.68000000f,-0.05000000f,0.79000000f,0.97000000f,-0.26000000f,-0.65000000f,0.19000000f,0.84000000f,0.84000000f,-0.30000000f,-0.88000000f,0.06000000f,-0.87000000f,0.62000000f,-0.67000000f,-0.49000000f,0.95000000f,0.28000000f,0.47000000f,0.44000000f,0.59000000f,0.06000000f,0.90000000f,-0.46000000f,0.85000000f,0.84000000f,-0.22000000f,-0.83000000f,-0.46000000f,-0.06000000f,0.95000000f,-0.91000000f,0.51000000f,0.50000000f,0.97000000f,-0.88000000f,0.07000000f,0.69000000f,0.30000000f,0.33000000f,-0.34000000f,0.53000000f,-0.09000000f,-0.90000000f,-0.37000000f,0.67000000f,0.05000000f,0.37000000f,0.67000000f,0.11000000f,-0.58000000f,-0.23000000f,-0.52000000f,0.43000000f,0.62000000f,-0.32000000f,0.87000000f,0.55000000f,-0.85000000f,0.97000000f,0.40000000f,-0.15000000f,-0.06000000f,-0.27000000f,-0.71000000f,0.63000000f,0.68000000f,0.75000000f,-0.13000000f,-0.98000000f,0.74000000f,0.13000000f,0.26000000f,0.59000000f,-0.40000000f,0.16000000f,-0.45000000f,-0.07000000f,-0.36000000f,-0.07000000f,0.49000000f,-0.97000000f,-0.55000000f,-0.77000000f,-0.73000000f,0.66000000f,0.80000000f,-0.90000000f,-0.45000000f,0.85000000f,0.69000000f,0.09000000f,0.18000000f,-0.92000000f,0.61000000f,0.99000000f,0.81000000f,-0.29000000f,-0.32000000f,-0.12000000f,0.11000000f,0.50000000f,0.71000000f,-0.26000000f,-0.99000000f,0.70000000f,-0.70000000f,0.21000000f,0.84000000f,0.27000000f,-0.18000000f,-0.74000000f,-0.65000000f,0.23000000f,-0.99000000f,0.39000000f,0.83000000f,-0.22000000f,0.81000000f,0.86000000f,0.53000000f,0.61000000f,0.05000000f,-0.40000000f,0.90000000f,0.52000000f,0.23000000f,0.03000000f,-0.91000000f,-0.04000000f,-0.50000000f,-0.16000000f,0.89000000f,-0.21000000f,0.77000000f,-0.07000000f,0.90000000f,-0.17000000f,0.88000000f,-0.10000000f,-0.89000000f,0.65000000f,-0.74000000f,-0.81000000f,0.44000000f,0.47000000f,-0.38000000f,-0.34000000f,0.34000000f,-0.37000000f,-0.15000000f,0.45000000f,0.06000000f,0.44000000f,0.81000000f,0.84000000f,-0.94000000f,-0.64000000f,0.74000000f,-0.00000000f,-0.32000000f,-0.36000000f,0.06000000f,0.11000000f,-0.94000000f,-0.16000000f,-0.24000000f,-0.20000000f,-0.96000000f,0.50000000f,0.48000000f,-0.00000000f,-0.68000000f,0.57000000f,-0.58000000f,0.24000000f,-0.58000000f,-0.39000000f,0.52000000f,0.88000000f,-0.97000000f,0.03000000f,0.75000000f,0.22000000f,0.14000000f,-0.73000000f,-0.85000000f,0.18000000f,-0.63000000f,0.62000000f,-0.80000000f,0.76000000f,0.62000000f,-0.38000000f,0.07000000f,0.42000000f,-0.10000000f,0.04000000f,0.81000000f,-0.89000000f,-0.34000000f,0.05000000f,-0.70000000f,0.19000000f,-0.10000000f,-0.98000000f,-0.45000000f,0.84000000f,-0.67000000f,-0.07000000f,-0.84000000f,-0.36000000f,-0.80000000f,-0.62000000f,0.77000000f,-0.94000000f,-0.13000000f,-0.79000000f,-0.25000000f,0.61000000f,0.63000000f,0.41000000f,0.79000000f,0.88000000f,0.86000000f,-0.38000000f,-0.76000000f,-0.27000000f,-0.09000000f,-0.29000000f,-0.85000000f,-0.54000000f,-0.67000000f,-0.53000000f,0.19000000f,0.42000000f,0.07000000f,0.35000000f,-0.74000000f,0.23000000f,-0.09000000f,0.48000000f,-0.34000000f,-0.81000000f,-0.59000000f,0.96000000f,-0.09000000f,-0.71000000f,-0.46000000f,-0.81000000f,-0.16000000f,-0.68000000f,-0.34000000f,0.63000000f,-0.49000000f,-0.76000000f,-0.38000000f,0.61000000f,0.54000000f,0.43000000f,-0.63000000f,-0.68000000f,-0.43000000f,0.54000000f,-0.70000000f,0.40000000f,-0.57000000f,-0.98000000f,-0.62000000f,-0.09000000f,-0.99000000f,0.81000000f,0.41000000f,-0.80000000f,0.52000000f,0.56000000f,0.36000000f,-0.83000000f,-0.99000000f,0.51000000f,-0.95000000f,0.04000000f,0.37000000f,0.32000000f,-0.90000000f,-0.63000000f,0.04000000f,-0.47000000f,0.44000000f,0.65000000f,-0.11000000f,-0.02000000f,-0.36000000f,0.93000000f,-0.54000000f,-0.16000000f,0.98000000f,0.00000000f,-0.93000000f,-0.33000000f,0.33000000f,0.44000000f,-0.25000000f,-0.97000000f,-0.76000000f,-0.66000000f,0.76000000f,-0.34000000f,-0.93000000f,-0.98000000f,0.00000000f,-0.52000000f,-0.23000000f,0.41000000f,0.65000000f,0.10000000f,0.71000000f,0.85000000f,0.83000000f,-0.38000000f,-0.97000000f,-0.78000000f,-0.23000000f,-0.79000000f,-0.95000000f,0.51000000f,0.83000000f,-0.87000000f,0.37000000f,-0.45000000f,-0.88000000f,-0.52000000f,-0.19000000f,0.13000000f,-0.26000000f,-0.10000000f,0.73000000f,0.12000000f,-0.71000000f,-0.86000000f,-0.82000000f,0.14000000f,-0.21000000f,0.16000000f,-0.59000000f,0.63000000f,0.39000000f,-0.08000000f,-0.12000000f,-0.99000000f,-0.73000000f,0.55000000f,-0.69000000f,0.00000000f,-0.80000000f,-0.25000000f,-0.93000000f,-0.58000000f,-0.02000000f,0.00000000f,0.38000000f,-0.47000000f,0.31000000f,-0.98000000f,0.89000000f,0.48000000f,-0.16000000f,-0.34000000f,0.43000000f,-0.62000000f,0.32000000f,-0.46000000f,-0.73000000f,0.94000000f,0.75000000f,-0.33000000f,-0.56000000f,0.09000000f,0.77000000f,-0.86000000f,0.08000000f,-0.42000000f,-0.03000000f,0.82000000f,-0.87000000f,-0.93000000f,0.49000000f,0.29000000f,0.25000000f,0.44000000f,0.98000000f,0.93000000f,-0.65000000f,-0.32000000f,0.66000000f,0.56000000f,0.27000000f,0.98000000f,0.64000000f,0.15000000f,0.10000000f,0.05000000f,0.37000000f,-0.25000000f,0.93000000f,-0.79000000f,0.69000000f,-0.64000000f,-0.49000000f,0.43000000f,0.52000000f,0.77000000f,-0.74000000f,-0.78000000f,-0.65000000f,-0.79000000f,0.30000000f,0.72000000f,0.29000000f,-0.59000000f,0.93000000f,0.76000000f,0.90000000f,0.51000000f,-0.56000000f,-0.02000000f,0.53000000f,0.96000000f,0.71000000f,-0.74000000f,-0.50000000f,-0.98000000f,0.80000000f,-0.81000000f,-0.86000000f,0.63000000f,0.54000000f,-0.40000000f,-0.39000000f,0.53000000f,0.78000000f,0.96000000f,-0.94000000f,-0.74000000f,0.31000000f,-0.30000000f,-0.61000000f,-0.46000000f,0.31000000f,0.76000000f,0.99000000f,-0.77000000f,-0.05000000f,-0.46000000f,-0.75000000f,-0.41000000f,0.14000000f,0.08000000f,0.30000000f,0.84000000f,0.18000000f,-0.83000000f,-0.72000000f,-0.94000000f,-0.28000000f,-0.65000000f,-0.37000000f,-0.55000000f,-0.81000000f,0.94000000f,0.58000000f,-0.52000000f,0.47000000f,-0.87000000f,0.22000000f,0.61000000f,-0.24000000f,-0.44000000f,0.02000000f,-0.18000000f,-0.20000000f,-0.59000000f,0.91000000f,-0.71000000f,0.59000000f,-0.22000000f,-0.63000000f,0.40000000f,0.80000000f,0.45000000f,0.11000000f,-0.49000000f,0.87000000f,-0.24000000f,-0.51000000f,-0.62000000f,0.61000000f,0.93000000f,-0.28000000f,-0.76000000f,-0.60000000f,0.14000000f,-0.85000000f,0.47000000f,-0.67000000f,0.64000000f,-0.39000000f,0.89000000f,0.77000000f,0.22000000f,-0.90000000f,-0.48000000f,-0.24000000f,0.54000000f,0.35000000f,0.70000000f,0.96000000f,0.16000000f,0.46000000f,-0.71000000f,0.89000000f,0.97000000f,-0.97000000f,-0.21000000f,0.93000000f,-0.72000000f,-0.28000000f,-0.72000000f,0.54000000f,0.23000000f,0.00000000f,0.67000000f,-0.28000000f,0.81000000f,-0.05000000f,0.24000000f,0.71000000f,-0.45000000f,-0.09000000f,-0.61000000f,0.78000000f,0.59000000f,0.93000000f,0.84000000f,-0.74000000f,0.32000000f,0.37000000f,0.07000000f,-0.85000000f,-0.59000000f,0.10000000f,0.05000000f,-0.89000000f,0.40000000f,-0.97000000f,0.31000000f,-0.62000000f,0.24000000f,-0.64000000f,-0.54000000f,-0.26000000f,-0.64000000f,0.50000000f,0.29000000f,0.60000000f,-0.28000000f,-0.81000000f,-0.49000000f,-0.63000000f,0.84000000f,0.67000000f,0.76000000f,0.40000000f,0.61000000f,0.01000000f,-0.66000000f,-0.05000000f,0.15000000f,0.54000000f,-0.67000000f,0.77000000f,-0.50000000f,0.34000000f,-0.12000000f,0.24000000f,0.91000000f,0.69000000f,-0.37000000f,0.04000000f,0.69000000f,0.55000000f,-0.76000000f,-0.37000000f,0.11000000f,0.67000000f,0.76000000f,-0.61000000f,-0.44000000f,-0.89000000f,0.45000000f,-0.01000000f,0.39000000f,0.35000000f,-0.29000000f,0.38000000f,0.95000000f,0.87000000f,-0.72000000f,0.71000000f,0.74000000f,-0.81000000f,0.48000000f,-0.80000000f,-0.90000000f,0.18000000f,-0.01000000f,0.63000000f,0.83000000f,-0.96000000f,-0.50000000f,-0.43000000f,0.84000000f,-0.92000000f,-0.18000000f,0.50000000f,-0.00000000f,-0.26000000f,-0.04000000f,0.50000000f,0.01000000f,-0.41000000f,-0.75000000f,-0.17000000f,-0.28000000f,0.37000000f,0.66000000f,-0.47000000f,0.01000000f,0.25000000f,-0.45000000f,0.10000000f,0.82000000f,-0.01000000f,-0.18000000f,0.80000000f,0.89000000f,-0.54000000f,0.35000000f,0.43000000f,0.08000000f,-0.10000000f,-0.59000000f,0.98000000f,0.88000000f,0.45000000f,-0.95000000f,-0.18000000f,0.35000000f,0.90000000f,0.37000000f,-0.76000000f,-0.32000000f,0.66000000f,0.60000000f,0.89000000f,-0.02000000f,-0.46000000f,0.73000000f,0.10000000f,0.83000000f,0.21000000f,-0.10000000f,-0.39000000f,-0.64000000f,-0.67000000f,0.31000000f,0.21000000f,-0.65000000f,-0.44000000f,0.96000000f,0.44000000f,-0.31000000f,-0.00000000f,-0.15000000f,-0.40000000f,0.40000000f,-0.80000000f,-0.66000000f,0.30000000f,0.77000000f,-0.53000000f,0.68000000f,-0.25000000f,0.54000000f,-0.73000000f,0.03000000f,0.55000000f,0.13000000f,0.67000000f,0.25000000f,0.96000000f,-0.18000000f,0.81000000f,-0.95000000f,-0.74000000f,-0.40000000f,0.89000000f,0.60000000f,0.14000000f,0.17000000f,-0.52000000f,0.97000000f,-0.02000000f,-0.68000000f,0.05000000f,0.39000000f,0.43000000f,-0.57000000f,0.10000000f,0.47000000f,0.93000000f,0.90000000f,0.10000000f,-0.86000000f,-0.79000000f,0.09000000f,-0.79000000f,-0.12000000f,0.58000000f,0.91000000f,-0.36000000f,-0.22000000f,0.67000000f,0.61000000f,0.43000000f,0.24000000f,0.85000000f,0.30000000f,0.71000000f,-0.10000000f,0.34000000f,-0.21000000f,0.07000000f,-0.99000000f,0.87000000f,0.17000000f,-0.94000000f,-0.12000000f,-0.16000000f,0.00000000f,0.45000000f,-0.35000000f,0.65000000f,-0.63000000f,0.24000000f,0.01000000f,-0.64000000f,0.59000000f,-0.14000000f,-0.17000000f,0.75000000f,-0.02000000f,0.00000000f,0.94000000f,0.54000000f,0.13000000f,0.24000000f,0.03000000f,-0.41000000f,-0.95000000f,0.16000000f,0.36000000f,0.18000000f,0.27000000f,-0.17000000f,0.41000000f,0.24000000f,0.81000000f,-0.20000000f,-0.98000000f,0.47000000f,0.14000000f,-0.70000000f,-0.12000000f,-0.21000000f,-0.99000000f,0.83000000f,0.96000000f,-0.67000000f,0.43000000f,0.62000000f,-0.69000000f,-0.32000000f,0.46000000f,-0.50000000f,0.53000000f,0.91000000f,0.16000000f,0.34000000f,-0.49000000f,0.55000000f,-0.30000000f,0.34000000f,0.00000000f,-0.75000000f,0.17000000f,0.21000000f,-0.16000000f,0.00000000f,0.56000000f,-0.42000000f,0.37000000f,0.67000000f,0.87000000f,0.71000000f,0.67000000f,-0.88000000f,-0.66000000f,0.98000000f,-0.79000000f,-0.86000000f,-0.17000000f,0.21000000f,0.41000000f,0.75000000f,-0.22000000f,-0.36000000f,-0.50000000f,-0.18000000f,-0.93000000f,0.29000000f,-0.85000000f,0.53000000f,-0.30000000f,0.12000000f,0.19000000f,0.25000000f,0.55000000f,0.09000000f,0.18000000f,0.03000000f,-0.01000000f,0.75000000f,-0.71000000f,0.88000000f,-0.12000000f,-0.91000000f,0.33000000f,0.92000000f,0.73000000f,0.62000000f,-0.51000000f,0.56000000f,0.40000000f,0.98000000f,-0.60000000f,-0.49000000f,0.26000000f,-0.36000000f,-0.42000000f,-0.26000000f,-0.57000000f,0.41000000f,0.97000000f,0.55000000f,-0.95000000f,0.51000000f,0.28000000f,0.96000000f,-0.55000000f,0.42000000f,0.94000000f,-0.65000000f,-0.29000000f,0.01000000f,0.50000000f,-0.50000000f,0.58000000f,0.13000000f,0.26000000f,-0.56000000f,0.35000000f,0.30000000f,-0.34000000f,0.61000000f,0.63000000f,-0.82000000f,-0.79000000f,0.86000000f,-0.81000000f,0.24000000f,-0.77000000f,-0.17000000f,-0.68000000f,0.33000000f,-0.95000000f,0.32000000f,-0.15000000f,0.52000000f,0.85000000f,0.78000000f,0.58000000f,-0.50000000f,0.73000000f,-0.45000000f,0.68000000f,0.36000000f,-0.91000000f,-0.13000000f,0.51000000f,0.41000000f,0.08000000f,0.57000000f,0.86000000f,0.06000000f,0.62000000f,-0.29000000f,-0.89000000f,0.21000000f,0.88000000f,0.19000000f,0.96000000f,-0.17000000f,0.22000000f,0.51000000f,0.17000000f,0.64000000f,0.11000000f,-0.69000000f,-0.14000000f,0.12000000f,0.28000000f,-0.51000000f,0.30000000f,-0.26000000f,-0.24000000f,0.46000000f,0.32000000f,-0.21000000f,0.78000000f,0.17000000f,-0.77000000f,0.60000000f,-0.08000000f,-0.35000000f,-0.36000000f,-0.94000000f,0.41000000f,-0.38000000f,0.88000000f,0.03000000f,0.23000000f,-0.36000000f,0.66000000f,-0.56000000f,-0.52000000f,0.77000000f,0.02000000f,-0.74000000f,-0.66000000f,0.57000000f,0.70000000f,0.86000000f,0.58000000f,0.05000000f,0.77000000f,-0.60000000f,0.70000000f,-0.80000000f,-0.19000000f,-0.64000000f,0.29000000f,0.44000000f,0.84000000f,0.11000000f,-0.71000000f,-0.64000000f,0.28000000f,0.36000000f,0.17000000f,-0.62000000f,0.49000000f,0.33000000f,-0.02000000f,0.16000000f,-0.39000000f,0.77000000f,-0.40000000f,-0.15000000f,0.79000000f,0.03000000f,0.17000000f,-0.44000000f,-0.76000000f,-0.02000000f,0.83000000f,-0.99000000f,0.22000000f,-0.98000000f,-0.92000000f,0.11000000f,-0.93000000f,0.25000000f,0.16000000f,0.21000000f,0.98000000f,-0.41000000f,-0.43000000f,-0.53000000f,0.74000000f,0.83000000f,0.75000000f,-0.85000000f,-0.51000000f,-0.65000000f,-0.37000000f,0.98000000f,0.16000000f,-0.67000000f,-0.83000000f,-0.90000000f,-0.49000000f,-0.52000000f,-0.88000000f,0.26000000f,-0.57000000f,-0.15000000f,0.02000000f,0.27000000f,-0.06000000f,0.40000000f,-0.72000000f,0.41000000f,0.04000000f,-0.48000000f,-0.58000000f,0.98000000f,0.17000000f,-0.83000000f,-0.33000000f,-0.93000000f,0.01000000f,-0.07000000f,-0.11000000f,0.75000000f,0.77000000f,-0.97000000f,-0.13000000f,-0.04000000f,0.92000000f,0.35000000f,0.90000000f,-0.49000000f,0.06000000f,0.13000000f,-0.66000000f,-0.65000000f,0.41000000f,0.15000000f,0.32000000f,0.80000000f,-0.34000000f,-0.25000000f,-0.37000000f,0.51000000f,0.26000000f,-0.43000000f,-0.54000000f,0.45000000f,0.67000000f,0.37000000f,0.65000000f,0.23000000f,-0.85000000f,-0.56000000f,0.41000000f,-0.83000000f,0.17000000f,0.74000000f,-0.85000000f,-0.15000000f,-0.82000000f,0.41000000f,0.86000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.72189997f,-0.53800000f,-0.17660000f,-0.22099999f,0.78549998f,0.85430001f,0.61609998f,-0.70600003f,0.13029999f,0.25660000f,-1.09299999f,0.07869998f,-0.75559997f,-0.91850002f,-0.19030001f,-0.91629999f,-0.20899999f,-0.80740002f,-0.16140001f,0.53900000f,-0.87740000f,0.02119999f,0.57650000f,-0.36739999f,0.60230000f,0.17100002f,-0.31230001f,-0.57840001f,1.16500001f,-0.60969999f,0.58919998f,-0.37600001f,-0.57440001f,-0.26340000f,0.52200001f,-0.02400001f,-0.24860000f,-1.07200002f,-0.46790002f,-0.88859998f,-0.53000002f,0.64610002f,0.42000000f,-0.42550000f,-1.22230003f,-0.52020002f,-1.11719997f,0.11980000f,0.30910001f,0.69649999f,-0.37530001f,0.35770001f,0.22369999f,-0.87330005f,0.84919998f,0.74559997f,-0.70420002f,-0.49329999f,-0.07820001f,0.62460001f,0.18799999f,-1.21370001f,-0.46730002f,-0.00820000f,-0.98089997f,0.23549999f,0.75180001f,0.40769997f,0.05990002f,-0.17270000f,0.36230000f,-0.21570001f,-0.10390000f,-0.45980000f,0.34300001f,0.16819999f,1.86520002f,-0.09179999f,-0.46079999f,0.21270002f,-0.35530002f,-0.33720003f,-1.92599997f,0.02060000f,-1.31860003f,0.24460001f,-0.08280003f,-0.47760001f,-0.98020000f,0.23449999f,-0.45139998f,0.54489999f,0.25950001f,0.18240000f,-0.26470000f,0.87950003f,-0.24740000f,-0.11390000f,0.29050004f,-0.00880000f,-0.59789997f,-0.45350000f,0.26689998f,0.24109999f,0.48050000f,-0.84050000f,0.16850000f,-0.29749999f,-0.43989999f,0.12289999f,-0.63800001f,0.08989999f,-0.63159999f,0.40900001f,0.15320000f,0.11040000f,-0.37050001f,-0.10770000f,0.08130000f,-0.01449998f,0.92740002f,-0.42089998f,0.80650000f,0.08270001f,0.37609998f,0.23349999f,-0.95079998f,0.56989999f,1.08450003f,0.36000000f,0.93970001f,0.78799999f,0.70590002f,0.07950000f,-0.16380001f,0.14480001f,-0.77120003f,-0.28869999f,1.03930006f,-0.76990000f,0.33190000f,0.21129999f,0.28320001f,-1.72980000f,-0.21480002f,-0.63129998f,-0.83839996f,0.01179999f,-0.27120001f,-1.05929998f,0.36990001f,-0.52160002f,-0.40809999f,0.56690000f,-1.37630000f,0.75530000f,0.32109999f,-0.60329999f,0.05909999f,0.69530000f,0.47940000f,-0.83880002f,0.00560002f,0.18650002f,2.07400002f,-0.34500003f,-1.21200001f,-0.31109996f,0.75410003f,-1.15890001f,-0.73019998f,0.74340000f,0.06180002f,-0.28260003f,-0.85380002f,-0.08289998f,0.10800000f,-0.24800001f,-0.05350001f,-0.06100000f,-0.79050004f,0.35010000f,0.39190001f,0.29150001f,0.39879999f,0.46129999f,0.08150000f,-1.04780000f,0.13309999f,0.45699998f,-0.31809999f,0.60159996f,-0.27850001f,-0.38450000f,0.29989999f,-0.35499999f,0.07750000f,0.33020001f,0.59450001f,0.77979999f,0.80909999f,-0.46549999f,0.38539998f,0.28310000f,-0.35800002f,-0.53780000f,-0.20880000f,0.30300004f,0.94890001f,-0.41599999f,-0.08950003f,0.32770001f,0.77849998f,-0.11250000f,0.09090000f,0.81329999f,1.07599999f,-0.45200001f,0.18439998f,0.11200003f,-0.08980000f,-0.02650001f,-1.18969998f,0.48870001f,1.45440001f,-0.13230003f,-0.70890001f,-0.14970002f,1.90829997f,0.25030003f,0.04060000f,-0.60340001f,0.10460000f,0.16400000f,-0.53960001f,-0.20240001f,-1.09850000f,0.17689997f,0.31409999f,0.52239999f,-0.34360001f,0.35040002f,-0.45790001f,-1.17109998f,0.04330000f,0.38470000f,-0.54760001f,0.03500001f,0.34380001f,-0.01980001f,-0.38960003f,0.46540001f,0.70759999f,-0.54480002f,0.03260000f,-0.37190001f,0.40310001f,-0.23190000f,-0.01919999f,0.27740000f,0.53460000f,-0.78989997f,0.34310001f,-0.16450003f,0.20650000f,-0.61500001f,-0.46139999f,0.11800000f,-0.14699999f,-0.59550000f,-0.88979999f,-0.22799999f,1.12859999f,-0.26859997f,-0.16400001f,-0.29320001f,0.05080000f,0.14700000f,-0.38760000f,0.01500000f,0.40100000f,0.41559997f,0.70599999f,-0.84499999f,-0.16600001f,-0.39779998f,0.28899999f,-0.51819999f,0.52479999f,-0.32800001f,-0.35450000f,-0.19540000f,0.25650002f,-0.21000001f,-0.16510000f,0.36600001f,0.10020000f,-0.34480000f,-0.55100001f,-0.06730001f,-0.04620000f,-0.19200000f,0.12930000f,0.11380000f,-0.84200000f,-0.40809999f,-0.32920000f,-0.85450001f,0.21170003f,1.17549998f,-1.14520001f,-0.33979998f,0.99820001f,-0.21070003f,-0.18490000f,0.38310000f,0.75299996f,0.04720000f,0.77280002f,0.35220000f,-0.13960000f,-0.24430002f,-0.44359996f,-0.71300003f,-0.07170001f,-0.77579996f,-0.47260002f,-0.66710002f,-0.25119997f,0.95100006f,-0.29460001f,0.01290000f,0.11490001f,0.62550001f,-1.34550002f,-0.34650000f,-0.55550002f,-0.75160000f,0.76660005f,1.50310001f,-0.95320003f,-0.24059998f,0.41060000f,0.34540001f,-0.85720004f,-0.75660000f,1.83570002f,0.11210000f,0.02460001f,0.99000001f,0.47620003f,-1.36890002f,-0.64139997f,-0.41900002f,-0.95409999f,-0.59199998f,-0.49600000f,-0.37010001f,-0.65439999f,-0.34999998f,0.34129998f,-0.41819998f,-0.39150001f,-0.01140000f,-0.59510000f,1.11900002f,-0.42989997f,0.40560000f,0.67750000f,-0.55869997f,0.28489999f,-0.75200004f,0.31970002f,0.32820000f,0.06750000f,0.10350000f,0.18870000f,-0.00150002f,-0.95520001f,-0.15450001f,-0.59000003f,-0.03070000f,0.37100000f,-0.79300003f,-0.88250000f,-0.88519999f,0.81850003f,-0.18759999f,-0.17670000f,0.40350001f,1.16190001f,0.21670000f,-0.64850001f,0.68300000f,-0.28770000f,0.20099998f,0.72200002f,0.42380004f,0.88780000f,0.20580000f,0.06540001f,0.30270000f,0.47510000f,0.67560003f,0.45840001f,0.60880001f,0.24719998f,-0.35159998f,-0.98300002f,0.70820000f,1.31829995f,-0.13690000f,-0.79539997f,0.33370003f,-0.07650001f,0.32400000f,-1.24260001f,0.24560001f,0.37280001f,-0.67220001f,-0.00920001f,0.34679999f,-1.14269998f,-0.48870001f,-0.10620000f,-0.79320000f,-0.36120001f,-1.59599997f,0.07320002f,0.65879999f,-0.04490002f,-0.51910000f,-0.70870000f,-0.34399998f,-1.31109997f,0.04509999f,-0.49879996f,-0.97839999f,-0.59520005f,-0.27090000f,-0.65700000f,-0.58900001f,0.45879999f,-0.50460001f,-0.67349999f,0.30929999f,-0.20030000f,-1.30199999f,0.31799999f,-0.70120000f,1.10850001f,-0.56879997f,0.08810000f,-0.35249998f,0.51569998f,-0.71289997f,0.68799998f,0.30710001f,0.54079997f,-0.55550001f,-0.64060001f,-0.07750000f,-0.26050000f,-0.43340001f,-0.15610000f,0.39049999f,-0.84109998f,0.04489999f,0.55699999f,-0.52340000f,0.28939999f,0.31799998f,0.57479998f,1.01399996f,0.96599998f,-0.50759998f,0.27180000f,0.20299998f,-0.61430000f,0.46499997f,1.15600000f,-0.62440001f,0.65759996f,-0.61799999f,-0.01489999f,0.09399997f,0.34940002f,0.58260003f,-0.38579998f,-1.44989999f,-0.05570001f,0.04979998f,1.08179998f,0.26380002f,-1.23600001f,-0.86219999f,1.01920002f,0.12270001f,0.06120002f,-0.64080004f,-0.36399998f,-0.47359998f,-0.34040003f,0.71390000f,0.17469997f,-0.76790001f,-0.41969997f,-0.13169997f,-0.56570004f,-1.07000003f,-0.34870001f,0.76170002f,0.27880003f,1.20890001f,0.04970000f,0.73609999f,-1.11500000f,0.15520001f,-0.07319999f,0.97529998f,-0.50770001f,0.57449999f,0.04589997f,0.04610002f,-0.19050002f,1.51589999f,0.01510002f,0.44609998f,-0.25339998f,-0.83599999f,0.36500001f,-0.25199998f,0.36699998f,-0.71410000f,0.54059997f,-0.38899999f,0.65479999f,-0.27659997f,-0.41650002f,0.12939999f,0.83349999f,0.74950003f,-0.20889999f,0.03609999f,0.71900000f,-0.29600000f,0.41899997f,0.47750000f,-0.30740000f,-0.38829999f,1.05400000f,-0.17979999f,0.44939997f,-0.20450001f,0.28249999f,0.67950001f,-0.27850000f,0.60490000f,-0.42010001f,-0.74300000f,-0.68410000f,-0.38119999f,0.71499999f,0.36050000f,-0.00460000f,-0.48650001f,-0.07240001f,-0.43749998f,0.11300001f,0.84820001f,-0.12199998f,-0.17600000f,-0.34690002f,-0.56000001f,-0.68679998f,0.56080000f,0.86480000f,0.42009998f,0.00250001f,-0.61969999f,-0.69789994f,0.53550000f,0.00440000f,-0.05840000f,0.17420001f,0.12990002f,0.11129996f,0.51950002f,0.73350000f,-0.70830001f,-0.67770003f,0.80670003f,0.42839999f,0.19000002f,0.71430003f,0.00689994f,-0.97930003f,-0.46690002f,-1.02109998f,0.26230001f,-0.81830000f,0.28760001f,0.73880002f,-1.08670000f,0.14200004f,-0.06740003f,0.16090001f,-0.15159999f,-0.73160003f,1.25590002f,-0.04330001f,-0.25990000f,-0.00500000f,0.74660001f,-0.56660003f,-0.78850002f,0.64109998f,-0.31699999f,-0.06520000f,0.40700000f,-0.64649999f,0.05489999f,-0.70409998f,-0.23950001f,-0.06799999f,0.45789998f,-0.23150001f,0.02720000f,-0.03030000f,-0.77850002f,0.20999997f,-0.22430000f,0.34950001f,-0.75000000f,-0.27150000f,-0.84950002f,0.13429999f,-0.70290001f,0.75549999f,-0.46840002f,-0.31510001f,0.00749999f,-0.36239999f,0.45930000f,-0.36450001f,0.56369999f,0.39209999f,0.89300001f,0.26530001f,0.78439998f,0.84150001f,-0.36029999f,0.06369999f,-0.58950001f,-0.35700000f,-0.85530000f,0.74300003f,0.20560001f,-0.00300000f,0.39450001f,0.02629999f,-1.39430002f,0.50360001f,0.61280001f,-0.45920000f,0.51980001f,-0.04120001f,0.29460003f,1.85879999f,0.25640001f,0.85019998f,-0.33030007f,0.11870003f,0.42170001f,0.75820000f,-0.50280002f,0.57369999f,1.77919994f,-0.28579998f,-1.07470000f,-0.92089994f,0.69549999f,1.12310000f,0.55239996f,-0.45720001f,0.41699999f,0.63959997f,-0.07360000f,-0.92650003f,-0.26570000f,1.17570005f,-0.74039999f,-1.07339996f,0.78360002f,0.73820000f,-1.48310002f,-0.31850001f,-0.57530002f,-1.24690000f,0.21930001f,0.65720001f,-0.50570000f,-0.39690001f,0.06690000f,0.41779999f,0.22650000f,0.74850000f,0.80310000f,0.39150000f,0.35220000f,0.25589999f,-0.56500000f,1.01739999f,-0.58620000f,-0.78400001f,-0.30170002f,-0.59039997f,0.34300002f,0.14990000f,-0.33040000f,-0.05999999f,0.73649999f,-0.66139997f,-0.11100000f,-0.04319999f,0.79439997f,-0.23549998f,-0.08130001f,-0.81769997f,-0.21599998f,0.23339999f,-0.39799998f,-0.85450003f,0.43899999f,0.47250001f,-0.47350003f,-0.15979999f,0.55729997f,-0.12100000f,-1.04090000f,-0.21940000f,0.14549999f,-0.47580000f,0.58610000f,0.03650000f,-0.53209999f,-0.30990000f,-0.39450001f,0.50830003f,0.35350001f,-0.35680001f,-0.72520003f,0.27209997f,-1.47239999f,-0.14140000f,0.18730000f,-0.76269999f,-0.30570001f,0.80340003f,0.82590000f,0.17190000f,0.01730000f,0.46570001f,-0.69310004f,-0.24710001f,0.37220000f,0.49660002f,0.19160000f,-1.05170000f,-0.72610003f,0.23450000f,1.13199997f,-0.49200001f,-0.80979999f,-0.21619999f,0.60960000f,-0.33520000f,0.06130001f,0.43830001f,-0.51970000f,0.77320001f,0.18740000f,-0.90950001f,-0.45759999f,1.10860005f,0.50560002f,1.11140002f,0.01880001f,-0.59020001f,-0.92209999f,0.42070001f,-0.76660000f,-0.70789996f,0.69150001f,-0.50490000f,-0.04350001f,-0.00800000f,-0.88389999f,0.08180001f,0.26649999f,-0.54579999f,0.05789999f,-0.82549999f,0.34009999f,-0.76430000f,0.89400004f,0.00900001f,0.05540000f,-0.47050000f,0.41470000f,0.01170001f,0.81650001f,-0.84290000f,0.19329999f,0.46550002f,0.38889999f,-0.25949998f,-0.19850000f,0.25039999f,0.49909999f,-0.32700000f,0.24690000f,0.14140000f,0.13500000f,0.57630000f,0.20840000f,-0.77800004f,0.31090000f,0.50699999f,-0.40550000f,0.49820001f,-0.56270000f,-0.10950001f,-0.23190000f,0.49889999f,0.13949999f,-0.36660000f,-0.90700000f,0.44830001f,0.35570000f,0.12279999f,-0.52059999f,-0.81180003f,1.52860005f,0.54079995f,-1.05660002f,-0.61790001f,0.89600002f,0.50720002f,-0.36579999f,1.53369996f,0.09270000f,0.83120001f,-0.30139998f,0.02679999f,0.25440000f,-1.33379999f,0.05360000f,1.11570000f,0.05159994f,-0.45320001f,-0.53620002f,-0.26510000f,-0.10530001f,0.76730000f,0.54879998f,0.08180001f,-1.29660002f,-0.21329998f,0.39410000f,-0.61919998f,0.83369998f,0.33290000f,-0.16160001f,-0.23350000f,0.07130000f,0.42090002f,-1.06560001f,-0.55260003f,-0.90230002f,0.58270001f,0.20300000f,0.53650000f,0.51099999f,0.97700001f,-0.57619998f,0.17140000f,0.25049999f,-0.37020002f,-0.98470001f,-0.21250000f,0.76930001f,0.19130000f,0.14100001f,0.91829997f,-0.01339999f,-0.64949998f,-0.31379999f,-0.56190000f,-0.25150001f,-0.74060000f,0.02970000f,-0.23249998f,-0.34470003f,-0.72789998f,0.53700001f,-0.07170000f,0.45940000f,-0.67899999f,0.16929999f,-0.67159998f,0.44500000f,0.27410000f,0.90019999f,0.01750000f,0.67729998f,0.23989999f,0.02750000f,-0.06830000f,0.14270000f,0.41900000f,-0.83630001f,-0.00880002f,0.66099999f,0.41590004f,-0.10400002f,-1.60419999f,-0.09379999f,-0.47009999f,0.83879998f,-0.31000000f,0.86110002f,1.03609999f,-0.26590000f,0.76609997f,0.89289999f,-0.82670002f,1.13800000f,-0.97720009f,-0.02779998f,0.15699999f,0.09140003f,-0.81540003f,-0.28870000f,-1.24489999f,0.47050002f,-1.77130001f,0.86260001f,0.24079997f,0.98539998f,-0.08810003f,-0.06309998f,0.80730000f,0.41370001f,0.43590001f,1.02489998f,-0.40450000f,-0.37369999f,0.29460002f,1.66920000f,-0.19400003f,0.75660004f,0.73320001f,0.16899999f,0.01109999f,-0.20670002f,-0.53510001f,-0.18830001f,-0.19859999f,0.20899999f,-0.86419999f,0.36900000f,0.75049999f,0.43269999f,0.26669999f,-0.29499999f,0.29200000f,-0.74919999f,0.51200004f,0.04420001f,-0.53619996f,-0.80150001f,-0.75160004f,-0.65949997f,0.95300002f,-0.25879997f,0.04300000f,-0.39650003f,-0.44560000f,0.32289998f,0.99200004f,0.88689999f,1.09659999f,-0.64699999f,-0.26110000f,-0.69179997f,-1.17249998f,0.20980000f,-0.75309998f,-0.26700000f,-0.54239998f,-0.60079998f,0.02700003f,0.76379999f,-0.45820000f,-0.78649999f,0.29899999f,-0.71370001f,0.69500000f,-0.29360000f,0.14080000f,-0.12049999f,0.19390000f,-0.85540001f,-1.27249999f,0.62570002f,0.59500000f,-0.58000001f,0.00399999f,0.83669999f,1.18409995f,-0.27370000f,0.05170000f,-1.38880000f,-0.05880000f,-0.03439996f,1.36730001f,0.53690000f,-0.18470005f,-2.52100000f,0.12560004f,0.56549998f,-0.78900001f,0.25400003f,0.67430003f,1.52980000f,-0.36520002f,-0.33820001f,-0.46760000f,-0.47580003f,0.22880001f,0.33280000f,-0.40120002f,0.84120002f,0.61830001f,-0.67590003f,-0.14100004f,-1.80329996f,0.16230002f,-0.19539998f,1.77219997f,0.07700000f,0.19550000f,-0.07280000f,-0.06820000f,0.13870002f,0.38999997f,-0.18000002f,-0.29670000f,0.70879999f,-0.44299998f,-0.42340001f,-0.33699999f,-0.26749998f,0.37279999f,-0.75489997f,0.04649999f,-0.76830000f,0.21109999f,-0.68650000f,0.91569999f,-0.32170001f,-0.01400004f,-1.26129998f,0.53740001f,-0.74800001f,-0.44390000f,-0.33299998f,-0.02899998f,0.55730000f,-0.67560000f,0.87750002f,-0.34380000f,0.42790000f,0.35500001f,-0.00400000f,-0.13860000f,0.26000002f,-0.06529999f,-0.57640000f,-0.09850002f,-0.87589997f,0.37550000f,0.03400000f,1.00639998f,-0.17520000f,-0.05500000f,-0.10010000f,-0.11600000f,-0.93200002f,0.28620001f,0.61459999f,-0.80990000f,-0.68290001f,-0.52359998f,0.39009998f,0.36269999f,-0.82790003f,-0.50230003f,-0.39150001f,-0.16259998f,-1.20180001f,-0.36840004f,1.39690000f,0.58549996f,-0.88370001f,-1.37020002f,-0.61340000f,1.08900003f,-0.80910002f,-0.35249998f,0.03129999f,-0.02949999f,-0.61519999f,-0.13280001f,0.94480005f,0.44749996f,-0.91090003f,-0.90139998f,-0.35709998f,0.48130000f,0.59560001f,-1.33600002f,-0.34680001f,-0.15250004f,-2.28860001f,0.03060001f,0.87640004f,-0.30250002f,0.22230002f,-0.09559998f,-1.93570001f,0.13950000f,-0.27990000f,0.49159999f,0.44500000f,-0.78249998f,-0.16620000f,-0.09000000f,0.43289997f,0.23919999f,1.13000000f,-0.23780000f,0.77380000f,0.61050000f,-0.73200001f,0.40169998f,0.12100002f,-0.26200000f,-0.93279997f,-0.41000002f,0.31159999f,0.87440000f,0.56050001f,-0.01839999f,0.64470000f,0.19949999f,-0.36630000f,0.15449999f,0.49249999f,-0.25610002f,-0.57310002f,0.03849999f,0.14989999f,0.61729997f,0.02100000f,-0.94440001f,-0.13420001f,0.08549999f,-1.17629999f,0.49450001f,-0.93950003f,-0.25690001f,-0.63630001f,-0.10150003f,-0.96290001f,0.36969997f,0.59400000f,-0.21790000f,-0.80570002f,-0.13689998f,0.97050003f,-0.46070001f,-0.32829999f,0.73490004f,0.49650000f,0.16439999f,-0.08640000f,1.24800000f,0.03959996f,-0.26759999f,-0.40790001f,-0.15279998f,0.83200003f,0.05820001f,-1.26360000f,-0.21200001f,0.57560000f,1.39689999f,-0.30470001f,-0.32160002f,-1.26000001f,-0.41020002f,0.05250000f,-0.43139999f,0.26140000f,0.40140000f,-1.01129998f,0.34610000f,-0.54580001f,-0.13069997f,0.96010002f,-0.27580001f,-0.76820002f,-0.50940001f,-0.45350002f,0.33080003f,0.43120002f,0.13280002f,0.50769997f,0.48990000f,-0.98630002f,0.02709999f,-0.67550000f,0.41420000f,0.40590001f,-0.62100003f,0.16500000f,0.23640000f,-0.25549999f,-0.03910000f,-0.37249999f,-0.57400000f,-0.31400001f,-0.86199998f,-0.78850001f,0.28090000f,0.14730000f,0.24199998f,-0.75500000f,0.21759998f,-0.03449997f,0.52650000f,-0.59369998f,0.78350001f,-0.74600000f,0.53670000f,-0.37950000f,-0.15090000f,-0.02050000f,-0.74599999f,-0.49869999f,-0.19480000f,-0.85450000f,0.36310000f,0.21710000f,0.87699999f,-0.52720000f,0.44059999f,-0.23150001f,0.41090002f,0.18350000f,-0.74399999f,0.41009997f,-0.28760000f,0.23999999f,-0.04730002f,-0.20350001f,-1.78399994f,0.06299999f,-0.58140002f,-1.22520001f,-0.25560001f,-0.28090002f,-1.82240002f,-0.16140001f,0.23630000f,0.77650001f,0.08810001f,-0.79300003f,-0.53420001f,-0.43280004f,0.00650001f,-0.47390000f,-0.41210002f,0.20880001f,0.25320000f,-0.05460000f,0.64090001f,0.62629999f,-0.09750000f,0.65620000f,0.35029998f,-0.57790001f,1.13159999f,0.16709999f,-0.30489999f,0.65610001f,-0.69930001f,-0.78950004f,0.13929999f,0.94759999f,-0.07999999f,0.71230003f,0.36530001f,0.10030001f,-0.35190000f,1.17150004f,0.49870003f,-0.22399997f,-0.69470001f,0.06629999f,-0.00260000f,0.54740000f,-0.07589998f,-0.58120000f,-1.59080001f,-0.16149999f,-0.52590000f,0.07770000f,0.51989996f,-0.19730000f,0.75830000f,0.53789998f,0.15619999f,1.04500003f,-0.20420000f,0.59280002f,1.06800003f,-0.32910000f,0.89199999f,0.71240004f,-0.54369999f,0.25829999f,-0.12570001f,0.29730000f,0.57450002f,0.51810004f,-0.60269998f,0.70670000f,-0.12889999f,-0.04950001f,0.38920000f,0.93200003f,0.18889999f,0.36080001f,-0.11239998f,0.40529997f,0.28629999f,1.41470004f,-0.07199998f,-0.91330001f,-0.65090006f,0.35729999f,-0.89429999f,0.10370000f,0.33480001f,0.26940000f,0.39660001f,0.06859999f,-0.43580000f,1.09440003f,0.56020001f,-0.73000001f,0.55030003f,0.07120001f,-0.59080001f,-0.62880000f,-0.28779999f,0.43510000f,0.53270001f,0.50200002f,-0.02650000f,-0.38909998f,-0.05919998f,0.47289998f,-0.54980001f,-0.51120001f,0.14550001f,0.44850000f,0.22980000f,-0.33540000f,-0.46840000f,-0.18339999f,0.39850000f,0.10830001f,-0.28680002f,-0.54540001f,0.83470000f,0.52919999f,-0.49530000f,0.10330000f,0.44880003f,0.45360000f,0.97050003f,0.73240002f,-0.49840001f,0.74639999f,0.48610007f,-0.54959998f,0.19749999f,0.15469999f,0.26849999f,0.09630000f,-0.21090000f,0.02269999f,0.62610001f,-0.09149998f,0.43259997f,0.40609999f,0.13209999f,-0.08750000f,-0.51119998f,-0.18720000f,-0.42180000f,0.77139999f,0.63500002f,-0.26839999f,0.14640000f,0.57719999f,0.45539998f,-0.06190000f,0.47650001f,-0.00230000f,0.01380000f,-0.41220000f,-0.11450000f,-0.11840000f,0.26000000f,0.65359999f,-0.51750001f,-0.84270005f,-0.20099998f,0.12140000f,-0.63739999f,-0.75899998f,0.56389998f,0.70029999f,-0.48239999f,-0.22229998f,-1.32270004f,-0.63399997f,0.22140000f,-0.27470001f,-0.14700000f,0.19350001f,-1.08430004f,-0.48120001f,0.78090002f,0.18440000f,0.16660000f,-0.11500000f,0.07170002f,0.30320003f,0.36219999f,0.34789999f,0.44820000f,0.06810000f,-0.42750000f,-0.02919999f,0.54070000f,-0.53779999f,-0.17159998f,0.46709999f,0.42140001f,0.32420000f,-0.29960000f,-0.65959999f,-0.31379999f,0.42959999f,-0.34700002f,-0.13160000f,0.36500002f,0.48570003f,-0.10100002f,-0.81970003f,-0.37730003f,0.00999999f,0.41690001f,-0.41220000f,0.05460002f,0.53669999f,1.23179999f,0.77479999f,-0.65479998f,0.22210003f,-0.72180004f,0.01230000f,-0.04090000f,0.20350001f,-0.17660000f,-0.79100001f,-0.18580003f,-0.16169999f,-0.38329998f,-0.78250001f,-0.49299999f,0.76890000f,1.07010003f,-0.52929996f,0.16870000f,-0.12369998f,-0.37179999f,0.03240000f,0.42960000f,-0.21920000f,-0.36489999f,-0.06170002f,-0.24929999f,-0.69649997f,-1.50130002f,-0.07230000f,-0.62529997f,-0.33170001f,-0.07340001f,0.34459999f,0.85900003f,0.67169999f,-0.39629999f,-1.01910003f,-0.42979997f,-0.64120001f,-0.66080002f,-0.54629998f,-0.48779998f,-0.40140002f,-0.25900000f,0.73200000f,-0.08639995f,0.71550000f,-0.15589999f,-0.76650000f,-0.24499998f,0.74719999f,0.13740001f,-0.11160000f,-0.18990000f,-0.20230001f,-0.43220002f,-0.34359999f,-0.20780000f,-0.02439999f,0.26800000f,0.17780000f,0.17600001f,0.01480000f,0.23190000f,0.27100001f,-0.07179999f,-0.87179999f,-0.53759998f,0.54360000f,0.17689999f,0.37860001f,0.23400000f,-0.31910001f,-0.15179999f,0.28530001f,0.36650002f,0.17080001f,-0.24280001f,0.55260001f,0.13639999f,-0.54500001f,-0.64160001f,-0.32239999f,0.46430000f,-0.27050000f,-0.12340000f,0.18549999f,-0.88699999f,-0.47039998f,0.66269998f,-0.99580002f,-0.27320000f,-0.28649999f,0.02519999f,0.75359999f,0.39599998f,0.79049999f,1.11930003f,0.61389997f,-0.83299999f,-1.03180003f,-0.15540000f,0.12680000f,0.38200001f,-0.15320000f,0.35140000f,0.35540002f,-0.32410000f,-0.45899997f,-0.95939999f,0.18279998f,-0.06540000f,0.75779999f,-0.55869998f,0.28119999f,0.21200000f,-0.01130001f,0.21289999f,0.63490001f,0.04719999f,0.34690001f,0.18410002f,0.29819999f,0.24180000f,-0.13499999f,-0.01620000f,-0.17050000f,0.35590000f,-0.03910000f,-0.23409999f,-0.10250001f,0.04140000f,0.08809999f,0.99609999f,0.22170000f,-0.05740000f,-0.28210002f,-0.14299999f,0.33530001f,-0.36380000f,-0.32879999f,0.16710000f,-0.28269999f,-0.35740000f,-0.06050000f,-0.26570000f,-0.33520001f,-0.00860000f,1.20770002f,0.83420001f,-0.57050001f,0.72340001f,0.57780000f,-0.22170001f,-1.01610005f,-0.46260002f,0.72150002f,0.01470000f,0.05040000f,0.01710000f,0.06839999f,0.18300001f,0.23460001f,-0.83050004f,-0.28100000f,0.72710002f,-0.63090002f,-0.43340000f,0.45890002f,1.04170004f,0.49960001f,-0.73480002f,0.38710000f,0.02239997f,-0.61010000f,-0.69010002f,-0.58840002f,0.15340000f,-0.07930003f,-0.20120003f,0.03589998f,0.80709996f,1.51790002f,0.30099998f,0.35930000f,0.93130002f,0.41269998f,-0.22249999f,-0.03250000f,0.40099999f,0.10669999f,0.45670001f,-0.40549999f,0.63369998f,-0.22750002f,-0.38789998f,0.59179998f,0.17740000f,-0.14149998f,-0.72210002f,-0.14250003f,-0.09120000f,-0.13440000f,-0.22920001f,-0.25710000f,0.79289999f,1.13130004f,-0.29949999f,-0.40490001f,0.15229999f,0.25549998f,0.72149998f,1.74270004f,0.08760000f,0.58250000f,-0.10190000f,0.30920001f,-0.80079999f,-1.57880004f,0.43880000f,-0.67190000f,-0.32830002f,-0.53089997f,0.49010000f,-0.54120000f,-0.54120002f,0.05279999f,-0.74269999f,-0.50560000f,0.35169999f,-1.32399998f,-0.97040000f,0.59239998f,1.30550001f,0.80320000f,-0.69880000f,-0.18889998f,-0.44880000f,-0.28830000f,0.63299998f,0.43759997f,-0.37489999f,-0.62570001f,-0.20399998f,0.64380000f,-0.25029999f,-0.08719999f,0.27740000f,0.46709999f,0.42680001f,-0.02150000f,0.57720000f,0.49880001f,-0.12859999f,0.02519999f,0.23999999f,0.12360000f,1.07169998f,0.73659999f,-0.49179998f,0.09619999f,0.33800001f,0.30490000f,1.17000001f,0.94320001f,-0.39000001f,-0.74389999f,0.14530000f,0.50900000f,-0.37739998f,-0.01259998f,0.23240000f,-0.43959998f,0.06159999f,0.56439999f,-0.49519999f,0.56719999f,-0.23420000f,0.87849997f,0.07010000f,0.68839996f,-0.22179999f,-0.09740000f,-0.23659997f,-0.17549999f,-0.90269999f,-0.21420000f,0.27590000f,1.00990002f,-0.06660000f,0.28450001f,0.67370002f,-0.33819999f,0.78839997f,0.73200001f,-0.38259999f,0.50999999f,0.19320002f,-0.48479996f,-0.75599996f,-1.23119999f,-0.34690000f,0.68599997f,-0.01039999f,-0.55679997f,0.34330000f,0.38570002f,-0.65719997f,0.68280002f,-0.13799995f,0.17750000f,-0.51810000f,-0.92040000f,-0.62400000f,0.44099999f,0.26839999f,0.47120001f,0.24310000f,-0.38320000f,-0.42520000f,-0.05120000f,-0.78310001f,-0.13199998f,0.79380000f,0.88740004f,0.50020001f,-0.54550002f,0.72260001f,0.56800000f,-0.26800001f,0.70820000f,0.28539999f,-0.52719999f,1.11050000f,0.74779999f,-0.57440001f,-0.48030001f,-0.06599999f,0.47250001f,-0.20150000f,-0.37320002f,-0.21150001f,-0.74589999f,-0.35939998f,0.64169999f,0.84939999f,0.34679998f,-0.73229998f,-0.43160001f,-0.35100000f,0.18420001f,0.16069999f,-0.14100002f,-0.45359999f,-0.17410000f,-0.97930004f,0.28359999f,-0.52980001f,0.09899995f,-0.64179998f,0.45670000f,0.38630004f,0.43099998f,-0.54140000f,-0.42460003f,-0.55859998f,-0.65989998f,-0.30910001f,-0.07430000f,0.47160001f,-0.13800000f,-0.38039998f,0.35020001f,-0.19299998f,0.17729998f,0.61929999f,0.28490002f,-0.34329997f,0.39580000f,-0.49419998f,-0.38180000f,-0.61259999f,-0.51300002f,0.51820000f,-0.38979999f,-0.35900000f,-0.02350001f,0.36429999f,1.27910000f,0.17160000f,0.04370000f,-0.73789998f,0.26189998f,0.03950000f,0.50110001f,0.41669999f,-0.53720000f,-0.94480003f,-0.30670000f,-0.23110000f,-0.51579999f,-0.10399998f,0.52759999f,-0.53469999f,-0.52120000f,0.12250000f,-0.44040000f,-0.04819999f,0.49219998f,-0.26690001f,-0.14960000f,0.17000000f,-0.85820002f,-0.55060001f,0.46060002f,0.52380002f,0.32700001f,-0.20100000f,-0.77920002f,-0.65980002f,0.26890001f,1.01859999f,0.49979999f,-0.66659998f,-0.14020000f,0.16460001f,0.38260000f,-0.57920001f,-0.27380000f,0.34670000f,0.79610001f,0.61180000f,-0.39370001f,0.99080002f,0.59340000f,-0.55650001f,-0.40760000f,-0.42260001f,0.12560000f,0.88520002f,0.39800000f,-0.70280001f,0.28480001f,-0.19579999f,-0.32679999f,-0.27499999f,0.04579998f,0.49299998f,-0.00620000f,0.55100000f,-0.36069997f,-0.26190000f,-0.00990002f,0.02220000f,-0.10870000f,0.09250000f,0.20689999f,-0.39969999f,0.23230002f,-0.08070001f,0.84509999f,0.78750003f,0.51409999f,-0.15620000f,0.55820002f,0.07529999f,0.83030001f,0.30070007f,-0.46429999f,0.06909999f,0.20029999f,-0.07689999f,-0.76539998f,-0.62540001f,-0.41669997f,-0.16429999f,-1.05910002f,-0.14809999f,0.61420000f,-0.02499998f,0.44449999f,0.39949999f,1.04830002f,0.11220000f,0.17260000f,-0.57940001f,-0.27670000f,0.24240000f,-0.01580000f,0.11020000f,0.02030000f,0.37450000f,0.20079999f,-0.30340000f,-0.49520000f,-0.66440003f,-0.20380000f,-0.73100002f,-0.50479999f,0.42590002f,0.51930002f,0.11419999f,-0.53390001f,0.13909999f,-0.31380002f,-0.58169998f,-0.40149999f,0.08180002f,0.56979998f,-0.00239998f,-0.26540000f,-0.24670000f,-0.12739999f,-0.25000000f,-0.12620000f,-1.18980003f,-0.52500000f,0.85200002f,-0.75210003f,-0.15040000f,0.77980000f,-0.05079999f,0.11920002f,0.32750000f,-0.01620001f,0.29420002f,0.37720001f,0.15870000f,0.08520000f,-0.03090000f,-0.42960001f,0.30220001f,-0.27249999f,-0.83199998f,-1.28960003f,-0.02979999f,-0.21070000f,-0.68870001f,0.78219999f,-0.75279998f,-0.61040001f,0.26979996f,0.15169999f,0.96370003f,0.30609999f,0.18750000f,-0.18570000f,0.74889996f,-0.28370000f,-0.50410000f,-0.58429996f,-0.37699999f,-0.24460002f,0.53849997f,0.32940000f,0.55740001f,0.36259998f,-0.09100000f,0.01540000f,-0.20230000f,-0.92310000f,-0.28950003f,-0.47619997f,-0.34050000f,0.15990000f,-0.24900001f,0.83469999f,1.31150004f,-0.59189999f,0.15810000f,0.20610001f,0.01700000f,0.55979999f,0.70980002f,0.13949999f,0.53669999f,0.85060001f,0.51700000f,-0.44230000f,-0.02089999f,0.20460003f,0.35310000f,0.30900000f,0.28980000f,-0.00840000f,-0.73349998f,-0.70160001f,0.14329998f,1.04950004f,0.54180001f,-0.73080002f,-0.57400001f,-0.37060000f,0.26650000f,0.92590001f,0.70760002f,-0.29690000f,0.63720001f,0.14699999f,-0.67769999f,-0.41130000f,-0.08679999f,0.37359999f,-0.44340000f,-0.22520000f,0.27649999f,0.07990000f,-0.01020001f,-0.18870000f,-1.10770005f,-0.44500001f,0.85030002f,-0.30290000f,-0.45040003f,-0.15020001f,-0.29590001f,0.07280001f,0.46090000f,-0.05250000f,0.61459997f,-0.13390000f,0.70640000f,0.25360003f,-0.39750000f,0.62869998f,0.95230000f,-0.23929999f,0.50429999f,0.45630001f,0.63759999f,-0.27359999f,0.34440000f,0.00170000f,0.36140000f,-0.45740001f,0.13110000f,-0.52640000f,-0.24400002f,-0.42619999f,0.90980000f,0.46780003f,0.35269998f,0.02820000f,-0.54060000f,-0.26599999f,-0.50369998f,-0.40170000f,-0.01920000f,-0.39509999f,-0.18150001f,0.07910001f,-0.47169999f,-0.79610002f,-0.27269998f,-0.80810000f,-0.19810001f,0.57300000f,-0.30010001f,-0.11810001f,-0.44719999f,-0.09920000f,0.09319999f,-0.56639997f,-0.16780000f,0.05919999f,0.09199999f,-0.05750000f,1.12020001f,0.74080001f,-0.53620000f,0.64049999f,0.05959997f,-0.65899999f,-0.33320001f,-0.26340001f,0.03150000f,0.15600000f,-0.12080002f,-0.43809999f,-0.57969998f,-0.41679999f,0.33219998f,-0.29690000f,0.01840002f,0.48140000f,-0.02439998f,-0.18979998f,-0.10810000f,0.48720000f,0.41680001f,-0.16570000f,-0.58669999f,-0.56020000f,0.13029999f,0.22120000f,0.36240001f,0.05130000f,-0.07310000f,-0.09720001f,-0.10470000f,-0.01430000f,0.05640001f,0.08250000f,0.51930001f,0.43340001f,-0.07850000f,0.56849998f,-0.00390001f,-0.14779999f,-0.54909999f,-0.91550001f,-0.30160000f,0.78839999f,0.10440001f,0.56639998f,0.83790000f,0.72150007f,0.15070001f,-0.76300000f,-0.83900004f,0.36779999f,-0.62729997f,-1.08329999f,0.25060000f,0.20710000f,0.90110000f,-0.31580000f,0.43669999f,0.93070001f,0.37389996f,0.48940001f,0.81020003f,-0.33059999f,0.08190000f,-0.37410001f,0.51249998f,-0.12190000f,0.42490000f,-0.51419998f,-0.42069999f,-0.90710002f,0.09060000f,-0.61419997f,-0.86659999f,-0.12620000f,-0.00100000f,0.00100000f,-0.29710000f,0.82170000f,0.73650004f,-0.33470000f,0.69760002f,0.14059999f,0.38000002f,0.32860001f,0.79839998f,0.39939998f,-0.62949998f,-0.10369999f,-0.37140001f,-0.28260000f,0.79310004f,0.20260001f,-0.76120001f,-0.72010000f,-0.42799997f,0.55280002f,1.12920002f,0.63400000f,-0.69760001f,-0.57520002f,-0.08219999f,0.67500001f,0.79690003f,0.58820001f,-0.50690002f,-0.53359999f,-0.44959999f,0.23690000f,-1.14959997f,-0.87819999f,0.48879998f,-0.10510000f,-0.14460000f,0.06180000f,0.17360003f,-0.23240001f,-0.54700002f,-0.70329999f,-0.66040001f,0.15339998f,0.78830000f,0.50460000f,-0.40979999f,-0.11160000f,0.89780002f,-0.58439999f,0.57879998f,0.70280001f,0.00850000f,-0.11859999f,-0.95299999f,0.63069998f,-0.01060000f,0.14020000f,0.41849997f,0.43539999f,-0.05860003f,0.14539996f,0.51610001f,1.50290006f,-0.08979999f,0.59579998f,-0.18180001f,-0.41649998f,0.01629999f,0.54350001f,-0.39529998f,-0.73329996f,-1.93370003f,0.36299997f,0.22729999f,0.89770000f,0.56509998f,-0.33270000f,0.64889997f,0.20649998f,0.56619997f,0.99139999f,0.61899999f,-0.35839998f,-0.66400002f,0.58760000f,-0.24829999f,0.34970000f,-0.18330000f,0.46419999f,-0.06339999f,0.42069998f,0.29979999f,-0.45020002f,0.08160001f,0.66450001f,-0.40719997f,-0.22999997f,0.32419999f,-0.07039999f,-0.37380000f,-0.33659999f,-0.00180001f,0.23420001f,0.34270001f,-0.72830000f,-0.66840002f,0.08729999f,-0.17570004f,0.36380002f,0.75010003f,-0.77270001f,-0.40699999f,0.59270001f,0.18430002f,-0.25820002f,-0.55570001f,0.90990002f,0.67480002f,-0.38140001f,0.47140001f,0.18880000f,-0.38080001f,0.50760003f,0.06919999f,-0.53330002f,-0.22890001f,0.20000002f,0.59770000f,0.08139999f,-0.23240003f,-0.47079999f,-0.02450000f,-0.03100000f,0.01330000f,-1.03070002f,0.16340000f,-0.62379998f,-0.17650000f,0.10750000f,0.05779999f,0.27880001f,0.82760001f,0.66689996f,-0.05710000f,0.03970000f,-0.44249999f,0.50639999f,0.74160003f,0.55060001f,-0.84939998f,-0.55460001f,-0.86549999f,0.70489996f,1.17730001f,0.03429999f,0.15829998f,0.99310000f,0.69149999f,-0.12789999f,-0.31310001f,-0.39840000f,0.45210000f,-0.21870000f,0.11160000f,0.22220000f,-0.10340000f,0.39439999f,0.42569999f,0.20010000f,-0.60639999f,0.44939997f,0.85859998f,0.51179999f,-0.66759998f,-1.06040000f,0.04150000f,0.10430000f,0.18790000f,0.24509999f,0.32920001f,0.60280000f,0.40960001f,-0.21010000f,-0.19679999f,-0.10760000f,0.06890000f,1.09229999f,0.86260001f,-0.43119998f,0.60690002f,0.59640002f,-0.03840000f,0.46610002f,-0.03260000f,-0.55540000f,-0.79260002f,-0.16119999f,0.75040001f,0.45140001f,0.45140001f,-0.09620001f,0.19280000f,0.22700000f,0.04390000f,0.78790000f,0.25079998f,-0.66449999f,-0.16630001f,0.09760000f,0.27470000f,0.08820001f,0.19760002f,0.22360000f,-0.04380001f,0.39700003f,0.61190001f,-0.90210003f,-0.61560001f,0.51630001f,-0.22890002f,0.21640001f,0.62630001f,0.63790000f,0.03360001f,-0.16380000f,0.86389998f,0.73270002f,-0.00719999f,-0.47609997f,-0.54329999f,-0.59230000f,0.32580000f,-0.60659999f,-0.53999999f,0.64050002f,0.35130004f,0.56569997f,0.67539999f,0.63980002f,-0.51739999f,-0.81359999f,-0.53280002f,-0.44049999f,-0.03230000f,-0.52510002f,-0.24169999f,0.29500000f,0.24620001f,0.32859999f,0.67100001f,0.30100006f,-0.37839997f,-0.37699998f,-0.45340000f,-0.26640001f,0.78540000f,1.09980004f,-0.79830000f,0.70379998f,1.05420001f,0.31300000f,0.07020000f,1.00740004f,-0.63579998f,0.51660000f,0.95940005f,-0.06070000f,0.20530001f,-0.95280000f,-0.42419999f,0.66959999f,-0.82550003f,-0.36620001f,0.60920001f,-0.17819999f,-0.20900000f,0.01430000f,-0.38760000f,-0.42400000f,0.09400001f,-0.99760001f,-0.50739999f,0.66069999f,0.22939999f,0.34920001f,0.17580000f,0.15050002f,-0.24040001f,-0.49310001f,0.76810002f,0.72640003f,-0.10240000f,-0.44379999f,-0.19699999f,0.36169999f,-0.81619999f,-0.36959998f,0.68969998f,-1.10170000f,-0.55279999f,0.72949999f,0.90839999f,0.71720000f,-0.31159998f,-0.34660001f,-0.19700001f,0.16430000f,-0.79919999f,-0.58519999f,0.32690000f,0.04709999f,0.78340003f,-0.15709999f,-0.79529999f,-0.31770004f,-0.13029999f,-0.50560001f,0.00759999f,0.23829999f,0.08640000f,0.32640000f,0.46639997f,0.37679999f,0.99600002f,-0.02969999f,-0.62660000f,-0.00340003f,-0.43379999f,0.57940000f,0.63140003f,0.62139998f,-0.14420000f,-0.31180002f,-0.63380000f,0.66590000f,0.22630001f,-0.05930000f,-0.04340000f,0.35659999f,-0.08460000f,0.13789999f,0.99309999f,-0.05039999f,-0.74959999f,-0.09400003f,-0.47780000f,0.58500000f,-0.01979997f,0.01790001f,-0.49640001f,-0.42760004f,0.32999999f,-0.50729997f,0.02070001f,-0.43109999f,0.47529998f,-0.03929999f,0.31900002f,0.48829998f,0.70200000f,0.71960002f,-0.04699999f,0.34530000f,0.56660003f,0.28090001f,-0.25010001f,-0.32020002f,-0.07100000f,1.13090003f,0.88600003f,-0.44920001f,0.59540001f,0.43700001f,-0.23000000f,-0.03990000f,-0.09920000f,-0.06040000f,-0.23400000f,-0.34460001f,-0.08260000f,0.46660001f,0.11920000f,-0.42430000f,-0.25249999f,-0.34840000f,-0.00530000f,0.74120002f,0.46660002f,-0.32260001f,0.07099999f,-0.14420002f,-0.29169999f,-0.58720001f,-0.52020002f,0.18180000f,-0.47770002f,-0.43740003f,0.02100000f,1.24409999f,0.34609999f,-0.56609999f,0.27050001f,-0.04160000f,1.52699998f,-0.54440002f,-0.03550001f,-0.14420001f,0.67560002f,0.05640000f,-0.88199998f,-0.14259995f,-0.39499999f,-1.11540002f,-0.22879995f,-0.36190000f,-0.95200001f,0.61160000f,0.23540001f,-0.52110001f,0.34870000f,0.35820001f,0.25390001f,0.56329998f,0.42830000f,-0.47280002f,-0.51540001f,-0.14220000f,0.34259999f,0.33119995f,0.52540000f,-0.87210001f,0.42810002f,0.09560001f,0.14709998f,-0.62309999f,-0.09679999f,-1.44840001f,0.13140006f,-0.24399999f,0.51570003f,0.32249999f,-0.06560001f,-0.51660000f,-0.09620003f,0.32680000f,0.46660001f,-0.10419997f,-0.42420001f,-0.03420001f,0.29030000f,-0.59900002f,0.42140000f,0.39730002f,-0.51520002f,-0.15699999f,0.06920003f,0.32780001f,-0.14719999f,-0.04090002f,0.15280001f,0.46120001f,-0.35279997f,0.51559999f,-0.01519999f,-0.57699998f,0.12440001f,-0.65380001f,-0.52820002f,-0.33580000f,0.23560000f,0.45810000f,0.37860001f,-0.12640000f,-0.34670000f,-0.67880003f,-0.37060001f,0.71220001f,-0.46960001f,0.58039999f,0.74560001f,0.59840000f,0.55940002f,-0.53959995f,-0.54360002f,0.96060003f,1.31980004f,0.02079999f,-0.34179999f,-0.04019999f,0.80539997f,0.42910000f,0.18989999f,-0.62270000f,-0.18830000f,0.19629999f,-0.54390002f,0.05730001f,-0.13019998f,-0.86339998f,-0.26689999f,0.11599999f,0.37260001f,0.00030000f,-0.44910000f,0.52449999f,0.41070001f,-0.52029998f,0.69689997f,0.22229999f,-0.56310000f,-0.33109996f,-0.33520000f,0.42110000f,-0.28510000f,-0.00220000f,-0.26680000f,0.43580000f,0.07330000f,0.66820003f,-1.20140000f,-0.55310001f,0.69809999f,-0.20990003f,0.15350000f,-0.49979998f,1.23339997f,0.63410000f,1.37760002f,0.00319997f,0.30950001f,0.14170002f,0.37649998f,0.18620001f,-0.14620000f,-0.24170001f,0.61680003f,-0.25240000f,-0.17920002f,-0.19820000f,0.31540001f,0.66809999f,0.54640000f,0.27740001f,-0.83439997f,0.11660000f,0.58499999f,0.18830000f,0.56080001f,0.07520001f,-0.47439999f,0.39520000f,-0.02219998f,-0.11599999f,-0.45260000f,0.58180001f,1.30329999f,0.29660000f,-0.15099998f,0.06429998f,0.44680002f,-0.19800001f,-0.78220001f,-0.92940004f,-0.21300001f,0.96370000f,0.28720001f,0.29759999f,0.39919999f,0.44460000f,0.34200002f,0.18150000f,-0.49399999f,0.70399999f,0.42740000f,-0.89380003f,-0.27820001f,-0.21540001f,0.14800001f,-0.01120000f,0.08030001f,0.70990002f,0.03210000f,0.75329999f,-0.00770001f,0.06210000f,-0.88040000f,0.92959999f,0.46850000f,0.23439998f,0.60659996f,0.40699999f,-0.37429999f,0.83689999f,0.28250000f,0.03350002f,0.55469999f,0.11620000f,1.44269999f,-0.13590002f,0.07910000f,0.24090000f,0.33310000f,-0.02650000f,-0.80200001f,0.44720002f,0.10680000f,0.86520001f,-1.43500002f,-0.55420001f,0.62630000f,0.66949998f,0.22949999f,0.40680001f,0.91379998f,0.33690000f,0.25179996f,-0.18460000f,0.27680001f,1.08180001f,0.30210000f,0.76620000f,-0.17279999f,-0.82849998f,-0.02400001f,-0.42900001f,-0.83279999f,-0.54420000f,-0.43240000f,0.76829997f,0.30200001f,-0.00880000f,-0.36660000f,0.09600000f,0.14360000f,-0.23119999f,-0.16819999f,0.49160002f,0.81789998f,0.53120000f,-0.59719999f,-0.85200000f,0.30980001f,0.49440000f,-0.12789998f,0.33580001f,-0.20580000f,-0.59570000f,-0.16920001f,0.07820000f,-0.03539999f,-0.50280001f,-0.00840001f,0.27740000f,0.43160001f,-0.28780000f,-0.47140001f,0.13620000f,-0.05900000f,-0.00030000f,0.68839999f,-0.52180000f,-1.04779999f,0.35020001f,0.08730000f,-0.71729998f,0.93049999f,0.22340000f,-1.06110001f,-0.41429998f,-0.18060000f,0.81230001f,-1.04309996f,-0.56439999f,-0.34260001f,0.40580000f,0.13440000f,-0.27760001f,0.22400000f,0.15940000f,0.94449997f,0.17550000f,0.16980001f,-0.80799998f,0.27920002f,-0.13180000f,-0.08270000f,0.79829998f,0.44660000f,-0.60640000f,0.29460002f,0.04240000f,-0.13480001f,-0.19560000f,0.00950000f,0.13319999f,-0.72080000f,-0.19160000f,-0.38790000f,0.38730001f,-0.00380000f,0.07000000f,0.15779999f,-0.00080000f,-1.00229998f,0.54729999f,-0.00640001f,-0.06119997f,0.00469998f,0.51740001f,-0.35580000f,-1.28009998f,0.24280001f,-0.52020000f,-0.83540001f,-0.11860000f,-0.44219999f,-0.04850001f,0.00720000f,-0.49580002f,-0.42960002f,-0.42780002f,0.83420001f,0.52810006f,-0.08500001f,0.57320000f,0.06550004f,0.57140002f,-0.26060001f,-0.19230002f,-0.01080000f,0.11280000f,0.18300000f,0.41820002f,0.07500000f,-0.87810000f,0.65060003f,-0.10140000f,-0.37350002f,0.61900002f,-0.70300002f,-1.55570001f,-0.61480003f,0.34940001f,0.39140004f,-0.80040001f,0.12399999f,1.36739999f,-0.00280000f,-0.58020002f,0.06459997f,0.15180001f,-0.57960000f,-1.40839999f,0.39500003f,0.09100000f,-0.92950000f,-0.08789997f,-0.16519999f,-0.06740000f,-0.49519997f,-0.32999999f,-0.50600001f,-0.38159999f,-0.27530001f,0.40040002f,0.01459996f,0.37060000f,-0.02039999f,0.29139996f,0.35809999f,0.04280001f,0.63620001f,0.01519999f,0.22350001f,0.08070000f,0.04770000f,-0.97410002f,0.59250001f,0.29910000f,-0.17840000f,0.85100002f,0.17320000f,-1.68440001f,0.27180004f,-0.07740000f,0.18960001f,-0.61920002f,0.00430000f,1.41910000f,-0.96930001f,-0.34430001f,0.15220000f,-0.41419999f,-0.40710001f,0.83120002f,-0.49510005f,-0.04040000f,-0.62440002f,-0.13860004f,0.25320000f,-0.48800000f,-0.26340002f,0.47759998f,-1.05760000f,-0.82680002f,-0.50640001f,0.69020000f,0.32640005f,-0.35400000f,-0.62119999f,0.03699998f,-0.41320000f,0.56859998f,0.89419998f,0.71600001f,-0.21339999f,-0.98720000f,0.34480000f,-0.13940000f,-0.60720000f,0.16000000f,0.35360000f,-0.44679997f,-0.00919999f,0.50960000f,0.00980001f,-0.03359999f,0.58079999f,0.96719997f,-0.33779999f,0.70240000f,0.31790003f,0.39520001f,0.43659999f,-0.28879999f,-0.22960000f,1.01200000f,0.44040001f,0.20219999f,-0.58440001f,-0.12860002f,-0.51859999f,-0.41900001f,-0.17270000f,-0.00029999f,-0.22250000f,-0.74559999f,-0.12719999f,-0.46600001f,0.11420001f,-0.22140003f,0.27830000f,-0.04310000f,-0.96189995f,-0.53309999f,0.92209997f,-0.12270003f,0.14039999f,-0.94560000f,0.81400001f,0.20390000f,-0.62520001f,0.35440001f,0.09210000f,-0.55730000f,0.44989998f,0.35270000f,-0.05120001f,0.35239999f,0.34460000f,1.19399997f,0.44999996f,0.24839999f,0.18010000f,0.03430000f,0.33680000f,-0.24870002f,0.86849997f,0.45499999f,0.35599996f,0.42559995f,0.56240000f,0.13330001f,0.82580000f,0.32239999f,-0.60439999f,-0.34439999f,0.35960001f,0.57299999f,-0.24020000f,-0.18040000f,-0.44039999f,0.23139999f,0.66640002f,0.19420001f,-0.00160002f,-0.44500003f,0.42640001f,0.37030003f,-0.18560001f,0.61960000f,0.35760001f,-0.39859999f,0.09099999f,-0.01050000f,-0.48580001f,0.78359998f,0.71110001f,0.34880002f,0.19720002f,0.25319999f,-0.31040001f,-0.45000002f,0.23559997f,0.72980000f,-0.45419999f,-1.23069998f,-0.73359999f,0.29659998f,0.83799998f,0.18980001f,-0.45340000f,-0.51710002f,-0.58580000f,-0.14240000f,0.80269999f,0.56420000f,-0.48540000f,-0.23379996f,0.01100001f,-0.27040000f,-0.21710002f,0.91809997f,0.53100000f,0.27340001f,-0.56059997f,-0.38699999f,0.28560000f,1.11799999f,0.32650000f,0.23180000f,-0.31640003f,0.10930000f,0.31319998f,0.20199996f,0.31860000f,-0.21030001f,-0.52129998f,-0.05189999f,0.62109998f,-0.09110005f,0.29279999f,0.47390001f,0.67550001f,0.19970001f,0.21949999f,-0.75810000f,-0.43190001f,-1.23259998f,0.64080001f,0.07820000f,0.73049997f,-0.79309999f,-0.13060000f,-0.54150000f,-0.09049996f,-0.18069999f,0.80430001f,-0.89349998f,-0.38300000f,-0.96079998f,0.39380002f,0.47840000f,0.05880002f,-0.19679999f,0.11279999f,-0.68920000f,-0.58160000f,0.44619999f,0.12380000f,-0.13129999f,0.14720000f,-0.13540000f,-0.15160001f,0.37260002f,-0.53660001f,-0.43290005f,-0.01380001f,0.15780000f,-0.46769998f,0.22700001f,-0.80280003f,-0.65930004f,-0.49059998f,0.29299998f,0.06669998f,0.41100000f,0.29540001f,-0.21049998f,0.18180001f,-0.07400000f,0.31969997f,-0.42620002f,0.80140001f,1.06170002f,-0.42300001f,0.51080000f,0.31010002f,0.20700000f,-0.67100002f,-0.93730001f,-0.67400002f,0.33640000f,0.72220002f,-0.15059999f,0.48410000f,-0.04399998f,0.72799999f,0.20740000f,-0.63489999f,-0.37809997f,-0.35510000f,0.01990001f,0.73289996f,0.23309999f,-0.11580000f,0.10620001f,-0.02810000f,-0.33530003f,0.12570004f,-0.19670000f,-0.64290000f,0.05250000f,0.17130001f,-0.67100002f,-0.29839997f,-0.38850001f,-0.17490005f,-0.50509998f,0.04850001f,-0.12129999f,0.79729998f,0.35170000f,0.51580000f,0.24160000f,-0.04390000f,1.11000000f,0.03939995f,0.27180000f,0.15259999f,-0.22880002f,0.18210000f,-1.06310001f,-0.25729998f,-0.26410000f,0.60060000f,-0.68700002f,-0.06940000f,0.68530000f,-0.21529998f,-0.15900000f,0.40000002f,1.00609999f,-0.35280000f,0.26860000f,0.65360000f,-0.38840001f,-0.74400002f,0.35299996f,0.45880003f,-0.64259999f,-0.97060002f,-0.50380002f,-0.02060000f,0.30770001f,-0.66539999f,-0.48460001f,0.45649997f,0.50339999f,0.35480001f,0.06010002f,-0.18660001f,-0.51960000f,-0.42770000f,-0.15480000f,-0.34759999f,-0.04140001f,0.65980003f,-0.25779999f,-0.12930003f,0.72160001f,0.07219999f,-0.36040001f,0.52120001f,-0.00379999f,-1.05539998f,0.42780001f,0.44700001f,-0.18129999f,0.09280000f,-0.05320001f,-0.51239999f,0.15060001f,0.39800000f,1.20820001f,0.13959999f,0.08270000f,0.66759999f,-0.26960001f,-0.01270000f,0.37279999f,-1.07319998f,-0.67260001f,-0.99310001f,0.13010007f,-0.16679998f,0.17420000f,-0.72840001f,-0.20460000f,0.34999999f,-1.28539994f,-0.59039999f,0.27230001f,0.99889995f,0.38019999f,-0.59100000f,-0.68319996f,-0.34809999f,-0.08599999f,-0.47999997f,-0.27679999f,0.16690001f,0.77350002f,0.03370000f,-0.14840001f,1.08079997f,0.31069999f,-1.15110001f,0.67210001f,0.30060001f,-0.09270000f,0.93309999f,0.45610001f,-0.62750000f,0.05410000f,0.06430000f,-0.12600001f,-0.83080000f,-0.28740001f,0.40480000f,0.04910002f,0.50420000f,0.18020002f,-0.76669996f,0.10820000f,0.25060000f,-0.27389998f,0.07159998f,-0.85520001f,-0.47420002f,-0.65820003f,0.47320001f,0.67210004f,0.14980001f,-0.29600000f,0.02529998f,-0.08960000f,0.64200001f,-0.10439997f,-0.68540000f,0.03800000f,0.62369999f,0.27080000f,0.11380001f,0.18859998f,0.19200000f,-0.13139999f,0.01119999f,-0.29700001f,0.08020000f,0.65349999f,0.68500003f,-0.18140001f,-0.17870004f,-0.22960001f,-0.56860002f,0.01679998f,0.45240001f,0.23600001f,-0.17179999f,0.36360000f,-0.43689999f,-0.11660002f,-0.12800001f,0.18650000f,-0.79919998f,0.80379999f,0.38000001f,-0.34090000f,0.31489999f,0.24230000f,-0.49270000f,-0.54829999f,-0.49610001f,0.52570001f,-0.57010003f,0.03600000f,0.13800001f,0.01020001f,-0.16270000f,-0.25510001f,0.31929998f,0.42830001f,0.50019999f,-0.92599998f,-0.26269999f,0.36199999f,0.49559999f,0.12930000f,0.11970001f,0.18890000f,-0.03580000f,0.71560000f,-0.32260001f,-0.12540000f,0.10440000f,0.86100001f,0.10039999f,-0.01800000f,-0.74320000f,-0.45810001f,-0.04389999f,0.81889999f,0.31750000f,0.13230000f,0.22540005f,-0.17720000f,0.27420000f,0.73619999f,-0.36080001f,0.66800001f,0.24280004f,-0.49080000f,-0.31500004f,-0.36580003f,-0.14060000f,-0.13320000f,0.56649999f,-0.58919999f,-0.08460000f,0.90939996f,0.37679998f,-0.55900000f,-0.87679999f,0.58960000f,0.00900001f,-0.82959998f,-0.00780000f,-0.42999999f,-0.63750000f,-0.14280000f,0.51300001f,0.43180002f,0.09459999f,-0.70740000f,-0.49710001f,-0.03160000f,0.63500001f,0.76900001f,-0.24399999f,0.02120000f,0.66399996f,0.08560000f,0.09720001f,-0.00800000f,0.10900000f,0.33980000f,-0.43389999f,-0.30699997f,0.50330001f,0.85789999f,-0.00050001f,0.03020000f,0.07420001f,-0.03060002f,0.31740000f,-0.67500005f,-0.97819998f,-0.30530000f,0.69860001f,-0.25320000f,-0.21350001f,0.93689997f,-0.84789997f,-0.35979999f,-0.91719998f,0.07759999f,-0.14690001f,-0.82239999f,0.80120000f,0.29670000f,-0.79540001f,-0.37439996f,-0.20469998f,0.44370000f,0.19489999f,0.24740001f,-0.52959999f,-0.41059997f,-0.38500000f,0.92670000f,0.47469997f,0.31460000f,0.76109998f,-0.28609999f,-0.15190000f,0.01790000f,0.19470000f,0.09250000f,-0.56240002f,0.36619999f,0.32660000f,0.88759998f,-0.97130002f,0.47200001f,0.43120001f,-0.52639997f,-0.66259999f,0.44039999f,0.98869998f,-0.30020001f,-0.57480001f,-0.12650001f,-0.68060003f,-0.02359998f,0.29130004f,0.67040003f,-0.61379999f,-1.39560003f,-0.57080002f,0.53960000f,0.47620004f,0.69380002f,0.03780000f,-0.60910001f,-0.66740002f,0.90900003f,1.75230001f,0.28280000f,-0.63219999f,-0.85779999f,0.40899998f,-1.00179999f,-0.83950000f,0.18420000f,-0.35080000f,-0.80829997f,-0.64440003f,-0.34240000f,0.58979999f,0.08839998f,-0.80340002f,-0.47060002f,-0.30740000f,0.46600000f,0.27950002f,-0.41740000f,0.04640000f,-0.52619999f,0.95699999f,0.50780000f,0.94579997f,-0.57280000f,-0.03330000f,-0.23950000f,-0.86369998f,-0.46220000f,0.07050003f,-0.99169999f,-0.25559999f,-1.45940002f,0.42500007f,-0.02449998f,0.29980001f,-0.41100003f,0.13500000f,-0.48590001f,0.99389999f,0.31489999f,1.89740000f,-0.17840004f,0.17600001f,-0.92729998f,-0.11129996f,-0.22699999f,-0.80089997f,-0.18909998f,-0.44590000f,-0.94089997f,-0.05029998f,-0.07020000f,0.51920000f,-1.14120001f,-0.50620000f,-0.48620000f,-0.48620000f,-0.45630001f,0.17129999f,-0.09370000f,0.18940001f,0.66590000f,-0.16189999f,0.64440002f,0.31780001f,-0.23300000f,0.38839999f,-0.32399998f,-0.77219999f,-0.36580000f,-0.57700000f,-0.03650001f,0.46740001f,0.25440000f,-0.59589999f,-0.11120001f,-0.65400002f,0.23439995f,0.93140003f,0.46940001f,-1.00109997f,0.63340001f,-0.47099999f,-1.01170000f,-0.60340002f,-0.44740002f,0.31789999f,-0.27720001f,0.71100002f,0.43300003f,-0.33760001f,0.10760000f,0.22400001f,-0.45200003f,-0.15220001f,0.00200002f,0.71560001f,0.28280001f,-0.75939996f,-0.63400000f,-0.23440001f,0.87259996f,0.03580000f,-0.07020000f,-0.15450000f,0.44540002f,0.30219998f,-0.04490000f,1.15429999f,0.43800000f,-0.80119999f,0.27200001f,0.00220001f,-0.15089999f,-0.95389995f,-0.49569999f,-0.59940001f,0.81760000f,0.39550000f,0.33469999f,-0.61170000f,-0.51350001f,-0.94379999f,1.61840001f,0.73560001f,-0.98619998f,0.50600002f,0.00720000f,0.19140000f,-1.17960000f,-0.52700001f,0.35940000f,0.13939998f,0.34370001f,0.12600000f,-0.39960001f,-0.05660000f,-0.19009999f,-0.77290002f,-0.23560001f,-0.70309997f,1.18849998f,0.51050000f,0.88499998f,-1.02419998f,-0.47000000f,-0.17920000f,-0.01100000f,-0.01540000f,-0.38760002f,-0.06940000f,-0.01720000f,0.26420000f,-0.40299997f,-0.03600000f,0.00660000f,0.36999997f,-0.35179998f,0.99560002f,0.78850002f,0.11400000f,0.62700001f,-0.10979999f,-0.42220001f,-0.37080000f,-0.35309999f,0.58760002f,0.18880002f,0.17299998f,-0.09580000f,0.61020001f,0.53770002f,0.11460000f,0.23720000f,-0.14269999f,-0.52880000f,-0.00360003f,0.00399998f,0.20120000f,0.30840000f,0.29939999f,0.40560001f,0.09480000f,-0.84759999f,0.79020002f,0.48360002f,-0.86329996f,0.53120002f,-0.75080003f,-1.05480004f,0.76000003f,0.29240000f,-0.83960001f,-0.43020000f,0.32000000f,-0.57150000f,0.12929999f,0.23380000f,0.47129998f,-0.01630000f,-0.05920000f,0.76089999f,0.26430000f,0.46560002f,-0.16560002f,0.60719998f,0.47790001f,-0.61970000f,-0.91629997f,-0.32539999f,0.48020000f,1.01340000f,0.27480000f,0.59410001f,0.34269997f,0.31230000f,-0.16300001f,0.32599999f,0.21610000f,-0.24070005f,-0.77909999f,-0.15650000f,0.45309999f,0.54229997f,0.22629999f,-0.94200002f,0.59080001f,0.30460001f,-0.82919999f,1.43300001f,0.68450001f,-1.05790003f,0.15170003f,-0.20770001f,-0.78950003f,1.25370000f,0.54150000f,0.56679999f,-0.59759999f,0.50300000f,-0.19819998f,-0.03570001f,0.50580002f,-0.21680001f,-0.25390002f,0.02900000f,-0.31040000f,-0.30470000f,0.16960001f,-0.67360001f,-0.88960001f,0.52900000f,-0.36439999f,-0.29390001f,0.31480001f,0.35320000f,-0.44019999f,-0.54240002f,-0.40360000f,0.30520000f,0.05680000f,0.78420003f,0.03440004f,0.35700000f,-0.17559999f,-0.41429999f,0.72919999f,-0.39099999f,-1.02739998f,0.57160000f,-0.37519999f,-0.25380001f,-0.17559998f,0.74680000f,0.27380001f,0.05540000f,-0.08880000f,0.23490000f,0.21120001f,-0.58380000f,-0.24560004f,0.09300001f,0.30250000f,0.21050002f,0.59390000f,0.01550000f,-0.07430000f,0.56590001f,0.03499999f,-0.35260000f,-0.20599999f,-0.16010000f,-1.01720000f,-0.30999996f,-0.28359999f,-0.09899998f,0.49080000f,-0.05350001f,-0.47640002f,0.67759999f,0.39640000f,0.19790001f,-1.05969998f,-0.47750000f,-0.02020000f,0.64819999f,0.54810002f,-0.36039999f,0.36300000f,0.04310000f,-0.97169998f,0.70269999f,0.09200000f,-0.02489998f,0.54910000f,-0.05430001f,0.19219998f,0.30060000f,0.42060001f,0.34660002f,0.03799999f,-0.07850001f,-0.15750002f,-0.12909997f,-0.30280000f,0.59340001f,-1.08619998f,0.61859999f,0.40500001f,-0.62629995f,0.07720001f,0.83600002f,0.16820003f,0.44780002f,0.65020002f,-0.41649998f,-0.14180001f,-0.37560001f,0.06149999f,-0.35960001f,1.01020003f,0.77340004f,-0.12540000f,0.41540000f,0.08290001f,-0.06640000f,-0.14780000f,-0.03680001f,-0.09980001f,-0.48460001f,-0.22670001f,-0.34200000f,-0.05420000f,-0.01899999f,0.06239999f,-0.58280000f,-0.70679999f,-0.12060001f,0.30260001f,-0.31709997f,-0.35260000f,-0.19920001f,0.33809999f,0.15660000f,-0.65140003f,-0.54010003f,-0.16460001f,-0.36320002f,0.45649999f,-0.24719999f,0.52860000f,-0.03709999f,0.01360000f,-0.14370000f,0.57410001f,0.31700000f,0.71970000f,0.72950002f,0.12959999f,0.50490000f,-0.34909997f,0.40599997f,-0.46170000f,-0.71170000f,0.23539999f,-0.76890002f,-0.29700003f,-0.48440000f,-0.38740002f,-0.48210002f,-0.68919999f,-0.42549999f,0.35710001f,-0.48979998f,0.34430003f,-0.89610005f,-0.09480000f,-0.75630004f,-0.03290004f,-0.74039998f,0.08690001f,-0.27730000f,-0.27360000f,-0.36830000f,-0.59490002f,-0.03120001f,-0.40990001f,-0.66609999f,0.05999999f,-0.79310001f,0.97240004f,0.41760000f,0.80360002f,-0.46510001f,0.38480003f,-0.15780001f,0.24959998f,0.13209999f,-0.04199999f,-0.41209999f,-0.07320000f,-0.19520000f,-0.56070000f,0.11380001f,0.11939999f,-0.31420002f,0.13670000f,-0.00280000f,0.19110001f,-0.19779999f,-0.00180001f,0.32659999f,0.46390001f,0.17539999f,0.64919997f,0.28249999f,0.42480001f,0.39900001f,0.16340000f,-0.22180000f,-0.47169999f,-0.16570000f,0.12680000f,0.42210000f,0.08220000f,-0.09020000f,-0.83360001f,-0.49610002f,-0.43619999f,-0.72299999f,-0.22449999f,-0.03300002f,0.68219997f,0.45289999f,-0.81060002f,-1.13440001f,-0.57870000f,-0.32840001f,-1.24380003f,0.44500000f,-0.48259998f,0.34920002f,-0.42350001f,0.15380000f,-0.28430001f,-0.67210003f,-0.27180000f,-0.44370001f,-0.90680000f,0.10139999f,-0.70539999f,0.61090000f,0.19019998f,0.46649999f,-0.25680001f,-0.69219999f,-0.24339999f,0.20019999f,-0.28979999f,0.05880000f,-0.43179999f,0.31519999f,-0.45300001f,-0.03930000f,0.01720000f,0.05570000f,0.27110001f,-0.03980000f,0.14910000f,-0.28499998f,0.74659999f,-0.11720000f,0.06559998f,-0.15699999f,0.19980000f,0.35000000f,-0.83259997f,0.20460003f,0.69620001f,-0.14900001f,0.80600003f,0.19119999f,-0.52330001f,0.12180000f,0.25290001f,0.07310000f,0.03620000f,0.42860001f,-0.26190002f,-0.37440000f,-0.53949999f,-0.40819999f,0.20379999f,0.84499998f,0.64450001f,-0.29059999f,-0.05030000f,0.01010001f,0.08979999f,0.60619999f,0.19809999f,-0.01840001f,0.27919998f,-0.10580001f,-0.70680000f,-1.08709998f,-0.77599999f,-0.04560000f,0.10470000f,-0.28540000f,0.34280000f,0.74620001f,0.43900000f,-0.20700000f,-1.12570001f,-0.53970001f,-0.33940000f,-0.11179999f,-0.41090001f,-0.28080001f,0.11549999f,-0.26280000f,-0.31639999f,-0.51939997f,0.15220003f,-0.25259999f,0.53569999f,0.04130001f,0.01520000f,-0.01410000f,1.00000005f,0.25940000f,0.74420002f,0.52590000f,0.11539999f,0.53750000f,-0.14240003f,-0.76699999f,-0.24220000f,0.43209997f,-0.43799998f,0.39309999f,0.42640000f,-0.29899999f,0.25700001f,0.62240001f,0.02279999f,0.46760001f,0.89870000f,0.24539998f,0.94750000f,0.70010000f,0.26299998f,0.55409999f,-0.20899999f,-0.26479999f,-0.30380000f,-0.44170001f,0.71319999f,-0.19150002f,1.10800002f,0.04300001f,0.94780001f,1.10370001f,-0.12540000f,0.90930001f,-0.45380003f,-0.51679999f,-0.25660000f,-0.15470001f,-0.10299999f,0.29219999f,0.94129997f,0.32609999f,0.53280000f,0.53279999f,0.63660001f,-0.12580000f,-0.80389998f,-0.64890001f,0.11640000f,0.39940000f,0.19340000f,0.04760000f,0.20760000f,0.23700001f,-0.50540000f,-0.61949997f,-0.49309998f,0.47959999f,0.82519998f,0.28819999f,-0.15140001f,0.25749999f,0.17630000f,0.27860000f,0.56450000f,0.31270000f,0.02780000f,-0.06080000f,0.15810001f,-0.02759999f,-0.44300000f,-0.00779999f,0.22440000f,0.52820000f,0.10520000f,-0.00980000f,0.06830000f,-0.09750000f,0.51839999f,1.03859997f,0.42859999f,0.20159999f,0.14110001f,0.35690001f,-0.25639999f,0.13310001f,-1.19040002f,-0.16440000f,-1.09080001f,0.07050004f,0.87839997f,0.16870001f,0.07620000f,-0.19040000f,-0.00260000f,-0.15760001f,-0.29240000f,-0.15720000f,0.77930000f,0.04919998f,0.76830000f,-0.09359998f,0.11079999f,-0.24040000f,0.37390000f,-0.53159998f,0.29050002f,-0.16150000f,-0.14640000f,-0.23530000f,-0.39660002f,-0.14100000f,-0.31400001f,-0.60140002f,0.10160000f,-0.42500001f,0.21700001f,0.04680000f,0.07940000f,0.27750000f,0.08880000f,0.21530000f,-0.07060001f,-0.07359999f,-0.25260001f,0.44850005f,-0.23810002f,0.61419999f,1.11089999f,0.81769999f,0.50720000f,0.66860000f,0.45820000f,0.18100000f,-0.04030000f,-0.08290000f,0.35380001f,0.27740000f,0.19830000f,-0.41740002f,-0.54930003f,0.07590000f,-0.18720001f,-0.07170002f,0.23120000f,0.05420000f,0.41390001f,-0.22870002f,-0.11940000f,-0.12480000f,-0.12330000f,0.31200000f,0.80310000f,0.66660001f,0.07660000f,0.57990001f,-0.02470001f,0.83020001f,1.33770000f,0.88090000f,-0.16740001f,-0.56680002f,0.09650000f,-0.52819999f,-1.32039999f,-0.85410000f,0.14500001f,-0.06039999f,-0.31450001f,-0.48580001f,-0.24770000f,-0.76349999f,-0.44599998f,-0.82889998f,-0.65260000f,-0.01680001f,-0.67300001f,-0.25269999f,0.39199998f,-0.22330001f,-0.54240001f,0.19980000f,-0.51700002f,-0.19330001f,-0.56359997f,-0.03029998f,-0.14350002f,-0.55659997f,-0.07949999f,0.89190004f,0.24880001f,0.65690002f,0.22740001f,0.01380000f,0.21360001f,-0.43590001f,-0.61859999f,-0.48750000f,0.77070004f,-0.02720000f,0.53730002f,-0.91510000f,-0.26759999f,-1.00770001f,-0.70340003f,-0.20579999f,-0.47200000f,0.35340001f,0.68579999f,0.51320000f,0.15620002f,0.63859999f,0.11119999f,1.13130003f,-0.15590001f,0.26320002f,0.05500001f,-0.11599999f,0.22180000f,0.29240000f,-0.09030000f,0.61760000f,0.76839998f,0.09119999f,-0.26140001f,-0.45860002f,0.25110000f,0.24220000f,-0.22279999f,-0.11970000f,-0.51519998f,-0.79379997f,-0.40419999f,0.39059999f,1.02059999f,0.48950000f,0.26220000f,0.57860000f,0.34810001f,0.07419999f,0.39019999f,0.50470000f,-0.15680000f,0.00260000f,0.21760001f,-0.63119998f,-0.64799997f,-0.67079998f,-0.29540000f,-0.36629999f,0.17550000f,-0.07440000f,0.40720000f,0.26260001f,-0.46959999f,-0.38439999f,0.13400003f,0.08140000f,-0.09950004f,-0.20460002f,0.52999999f,-0.20780004f,0.18420000f,0.36299998f,0.08119998f,-0.10920001f,0.58799998f,-0.26600004f,-0.62160001f,-0.57779997f,-0.40579997f,-0.57699999f,0.58659997f,-0.47000001f,0.39219998f,-0.02639999f,0.48059999f,0.03440000f,-0.33940000f,-0.14820000f,-0.16800001f,-0.22060000f,-0.23980001f,-0.36440001f,-0.64819997f,-0.34779999f,-0.06500001f,-0.51559999f,-0.02979999f,1.25039998f,0.09359999f,1.16639998f,-0.29989999f,-0.56079998f,-0.15449997f,0.31999998f,-0.56999998f,0.21880000f,0.05399994f,-0.76639998f,0.15559999f,0.44130001f,-0.56400001f,0.28159999f,0.37879997f,-0.09880003f,-0.13160000f,0.36020001f,0.29360001f,0.05920000f,-0.25900000f,-0.32200001f,-0.19380000f,0.34740001f,-0.26630000f,-0.21520001f,-0.46370002f,0.06080001f,-0.32040000f,-0.31720000f,0.02020002f,0.05880000f,-0.19449999f,0.26080001f,-0.47779999f,-0.70269999f,-0.09369998f,-0.25180001f,0.01460001f,-0.34510000f,0.08660002f,-0.32859999f,-0.26150000f,0.57699999f,1.18389997f,0.61429999f,-0.34079999f,-0.92759997f,-0.29859999f,0.34560000f,0.43050001f,0.20540000f,-0.22140000f,-0.84029999f,-0.53390001f,0.31899999f,0.04700000f,0.21960004f,0.43839999f,0.09080001f,0.30259997f,-0.68199998f,0.21860000f,0.02540003f,0.57799998f,0.04220000f,1.30000001f,-0.05900001f,1.02660001f,-0.40510003f,-0.26379999f,-0.23870001f,0.06959996f,-0.41559999f,0.13879999f,-0.81870000f,-0.18460000f,-0.64029999f,-0.04030004f,-0.39279998f,0.11869999f,1.03320003f,0.05379998f,0.86060002f,-0.22600001f,0.56339999f,-0.15460003f,-0.25850000f,-0.26519999f,-0.42830000f,-0.29320001f,0.14360000f,-0.07680000f,-0.30969999f,0.13219999f,-0.34770000f,0.00250003f,0.59799999f,0.13230001f,-0.20530000f,0.04950001f,-0.02120001f,0.37799998f,-0.03580001f,0.46340000f,0.42779999f,0.20609999f,-0.06560000f,0.31949998f,-0.05420001f,0.08340000f,0.17300000f,0.01070000f,0.29320002f,0.46550003f,-0.00959999f,0.17879999f,0.30989999f,0.53160001f,0.51160002f,0.53510002f,0.17180000f,-0.02039998f,-0.28769996f,0.32240003f,-0.07240001f,0.35909999f,0.11639999f,-0.16760000f,-0.12269999f,-0.43980000f,-0.66300000f,-0.90610000f,-0.45889999f,-0.21640000f,-0.40990000f,0.14460001f,0.60880001f,0.71430000f,0.51060000f,-0.30960000f,-0.81860001f,-0.20000000f,-0.39200001f,0.27000001f,0.66240001f,-0.10040000f,0.48840001f,-0.52719999f,0.31059999f,-0.53820001f,0.68449999f,-0.12659998f,0.51930000f,0.09160001f,0.06060000f,0.04100000f,0.18450001f,0.31619998f,0.05089998f,-0.71670002f,-0.49979999f,-0.63510000f,-0.39790000f,0.39500000f,-0.45430003f,-0.91510004f,-0.35500000f,-0.69510002f,0.48050001f,-0.36619999f,0.35250002f,0.82870001f,0.34339999f,0.70110000f,0.57869998f,-0.14679999f,0.66410000f,-0.45770003f,-0.38859999f,-0.28690000f,-0.85190001f,0.05660000f,-0.85230002f,-0.34540002f,0.03240000f,-0.13580000f,0.52370001f,0.21470000f,-0.56960001f,-0.74309999f,-0.72120000f,-0.32180000f,-0.61019999f,-0.33270000f,0.13520002f,-0.45499998f,-0.46280000f,0.56480000f,0.86620002f,0.42220000f,-0.03820000f,-0.46410001f,-0.04210000f,0.06380001f,-0.65889997f,-0.30390000f,-0.23860001f,0.22709997f,-0.17010001f,0.39960000f,0.17630000f,0.28860000f,0.15640000f,-0.06100000f,-0.02940000f,0.00520000f,0.41710001f,-0.33560001f,0.00340000f,0.61220000f,0.00070000f,0.39959999f,0.97219999f,0.75040001f,-0.13560001f,0.35230000f,0.14520000f,0.24220000f,0.38859999f,0.42670000f,0.14040000f,0.19950001f,1.07830002f,0.27979998f,1.03110002f,0.20320000f,0.12020000f,0.28020000f,-0.17780000f,0.93159998f,-0.10820004f,-0.40219997f,0.05679998f,-0.50419999f,-0.55850002f,0.13560000f,-0.38670001f,-0.61129997f,0.68239997f,-0.42070000f,1.04509999f,-0.21319999f,0.84330000f,-0.92230000f,0.18459999f,-0.81550001f,-0.32579999f,0.29279998f,-0.27580000f,1.15770005f,0.30979999f,0.87610002f,0.91000000f,-0.18019998f,0.65540000f,-0.47580002f,-0.64359999f,-0.55180000f,0.53770001f,-0.49659999f,0.40810002f,-0.54360001f,-0.29379999f,-0.51500000f,0.08430001f,0.13669998f,-0.08720000f,-0.16890000f,0.28080001f,0.20939998f,0.77549997f,0.55849999f,0.03320000f,0.24529999f,0.31880000f,0.47060001f,0.33039999f,0.05090000f,-0.33020001f,-0.77330002f,-0.09990000f,0.04680000f,0.05170000f,-0.23300001f,-0.12580001f,0.04139999f,0.42910001f,-0.17000000f,-0.76669998f,-0.22819999f,-0.17980000f,0.01560001f,-0.27729999f,-0.00480000f,0.08720000f,-0.16980000f,-0.27620000f,-0.58669999f,-0.44430000f,0.00060001f,0.46510002f,-0.26750001f,0.21060001f,-0.14420000f,-0.14290001f,-0.08140001f,0.35279999f,0.03090000f,-0.21540001f,-0.32540000f,-0.54950003f,-0.43899999f,-0.40710000f,-0.11769999f,-0.62799998f,-0.21509998f,-0.20730001f,-0.42979998f,-0.19929999f,-0.43540001f,0.54859999f,-0.45440004f,-0.40210002f,-0.14000000f,-0.18350000f,0.36950002f,0.35219999f,0.28270000f,-0.40440003f,-0.74979998f,-0.31019999f,-0.47370000f,0.26419999f,-0.26450000f,0.79540000f,0.07619999f,0.65999999f,0.41360001f,0.18279999f,0.32120000f,0.33650001f,0.32439999f,0.37750000f,1.12790004f,0.20160000f,0.84730001f,-0.36480000f,0.54460000f,-0.30500002f,0.62540001f,-0.26899999f,0.47040001f,0.68660000f,0.15029999f,-0.39879999f,-0.57539999f,-0.50360000f,-0.24440001f,-0.32880001f,0.24580000f,0.37020003f,-0.01519997f,0.47850003f,-0.20200000f,-0.45430000f,-0.53540001f,-0.28919998f,-0.91179996f,-0.61079998f,0.51139999f,0.76379997f,0.41069999f,0.27379999f,0.85659998f,0.49990000f,0.43640000f,0.41050000f,0.43740001f,-0.33240001f,-0.34780000f,-0.12120000f,0.43220000f,0.36149999f,0.12549999f,-0.55320001f,-0.51300000f,-0.45520000f,-0.27419999f,-0.56819997f,-0.50829999f,-0.04300000f,0.05180000f,0.00490000f,0.08260000f,0.35510000f,0.51310002f,-0.52300000f,0.18560004f,0.67020000f,0.21079999f,0.66060000f,-0.44920001f,-0.58439998f,-0.28559998f,-1.46300004f,-0.04420000f,-1.22120004f,0.54830002f,0.51299999f,0.52070000f,0.14180000f,0.61479997f,0.26179999f,-0.44080002f,0.02140000f,-0.51540002f,-0.01760001f,-0.48019999f,-0.15379999f,-0.87810001f,-0.01980002f,-0.81290001f,0.27380000f,-0.24440000f,0.30740002f,-0.44009999f,0.38599998f,-0.45630001f,0.96380001f,-0.10360000f,0.91020002f,0.46400000f,0.40339998f,0.47699998f,0.14720001f,-0.08700000f,0.11780001f,-0.44570004f,-0.63559999f,-0.40990001f,0.51270002f,0.37750000f,0.02519999f,0.60519999f,0.45100000f,-0.47079999f,-0.98809996f,-0.42019999f,0.29540001f,-0.08470000f,0.03130000f,0.00659998f,-0.54370003f,0.06609999f,0.71620000f,1.25940002f,0.73670001f,-0.27440001f,-0.59580002f,0.07360000f,0.13840000f,0.76330000f,0.24260000f,-0.97660001f,-1.48830000f,-0.95689999f,0.54359999f,0.70099998f,0.40999999f,0.62079999f,0.74329997f,0.16419998f,0.45499999f,0.62509998f,0.53669998f,-0.04719999f,-0.73340000f,-0.38280000f,0.44980001f,0.33799999f,0.06110000f,-0.21180000f,-0.33149999f,0.09370001f,-0.13359999f,-0.12049999f,0.13280001f,-0.71879998f,0.03160003f,0.04690000f,0.11980000f,0.22090000f,-0.70990001f,0.43319999f,-0.60010002f,-0.93329999f,0.08960000f,-0.68349998f,-0.59399999f,-0.23300002f,-0.72540000f,-0.51700002f,-0.32999998f,-0.30419999f,0.50230000f,-0.32939999f,0.29230000f,1.07610000f,0.18799998f,1.17510001f,-0.59179998f,0.08999999f,-0.63339999f,-0.27049999f,0.50739999f,-0.39250001f,-0.75049999f,-0.18279999f,-0.73869998f,-0.39540002f,0.63719998f,-0.22340003f,-0.40300002f,0.50179999f,-0.42640004f,-0.26630000f,-0.34039999f,-0.14369999f,0.10110002f,0.10110000f,-0.11600001f,0.49420000f,0.02460000f,0.38799999f,0.70619998f,0.40520000f,0.26640000f,-0.17849999f,-0.02260000f,0.11280000f,0.64450000f,0.44400001f,0.10820002f,-0.23139999f,-0.45470000f,0.14699998f,1.15869999f,0.68689999f,0.49699999f,0.98769999f,0.44469999f,0.10620001f,-0.53350000f,-0.18550000f,-0.36540001f,-0.41200001f,0.03510001f,-0.07080000f,-0.31960000f,0.00740000f,0.13720000f,-0.23680002f,0.17080000f,0.13179998f,0.88159997f,0.48429998f,-0.21719998f,-0.91419997f,-0.61659999f,0.08780000f,0.11970000f,0.10090000f,0.34500001f,0.28769999f,0.90980001f,-0.35599999f,0.68620002f,-0.29580001f,-0.14120001f,-0.37500001f,-0.71109998f,0.48619998f,-0.58590000f,0.04509999f,-0.58899999f,-0.05569999f,0.19279999f,0.81299998f,0.16579996f,0.36150003f,-1.00159997f,0.13210005f,-0.13429998f,-0.11120000f,-0.29449999f,-0.69110002f,0.55799999f,-0.50530003f,-0.01540001f,-0.47420000f,0.08840002f,-0.36320001f,-0.02040000f,-0.24280000f,-0.87800003f,0.06160001f,-0.69400002f,0.30100002f,-0.68299997f,0.11840004f,0.01780001f,0.73199997f,0.15259998f,-0.14190000f,-0.03160000f,-0.14010000f,0.23490001f,0.02500000f,0.11639999f,0.26779999f,0.51680000f,-0.17159999f,-0.26559998f,-0.33839998f,-0.60620001f,-0.68009998f,-0.14749999f,-0.16020000f,0.14880000f,0.32010002f,0.36700000f,0.00990000f,0.40550000f,-0.25960000f,0.19020001f,-0.39700000f,-0.42200001f,-0.39190001f,-0.20680000f,-0.02680000f,0.16050000f,0.18180001f,0.10700002f,-0.27339997f,0.27430003f,-0.27739999f,-0.08879999f,-0.26349999f,0.29400000f,0.77680000f,0.65220001f,0.10559998f,0.99469999f,0.63360000f,0.62300002f,0.95660002f,0.41870001f,0.15820000f,0.95820001f,0.54310002f,-0.31940000f,0.41780001f,-0.64340001f,-0.56279998f,-0.56259999f,0.45799999f,0.25119998f,0.42199998f,0.31190001f,-0.52560000f,0.41610004f,-0.00540004f,-0.69539999f,0.00119999f,-1.30170001f,0.03639999f,-1.09470000f,1.39420003f,0.05519999f,1.12980002f,0.50750000f,-0.25779999f,0.51230002f,-0.00490001f,-0.32059999f,-0.01890000f,-1.04560004f,-0.10500000f,-0.81940003f,0.79259999f,-0.05780000f,0.68399999f,-0.41960002f,-0.61959999f,-0.46880000f,0.27650002f,-0.94699998f,0.08930004f,-0.36600001f,0.12220000f,-0.49420003f,0.27319998f,-0.74099998f,0.08340000f,-0.02010000f,0.47490000f,-0.02560001f,0.27589999f,-0.31780002f,0.08380000f,0.42270001f,-0.11490001f,0.23360000f,0.21010000f,0.14600000f,0.59440000f,0.66320000f,0.48280000f,0.14279999f,0.45729999f,-0.15260001f,0.03960000f,0.46500000f,0.41620001f,0.08660000f,-0.49260000f,-0.18630001f,-0.26500002f,0.02739999f,0.27850001f,0.17839999f,0.45489998f,0.13799999f,0.46079999f,1.04939997f,0.44419999f,0.11819999f,0.45199998f,-0.21890002f,-0.32080000f,-0.25259998f,0.15200002f,-0.09680000f,-0.13110001f,-0.29680002f,0.25080001f,0.25640001f,-0.12719999f,-0.37380001f,-0.24700000f,0.97290003f,0.28299999f,0.74930001f,0.66790003f,0.14600000f,0.47250001f,-0.34210000f,0.10459999f,-0.33170000f,-0.85759999f,0.08559999f,-0.84880001f,0.67430002f,0.27299999f,0.46510000f,-0.04700002f,-0.61039998f,-0.09780000f,-0.59320000f,0.51699998f,-0.42900001f,0.06879999f,-0.76459999f,0.08980003f,0.13710000f,-0.04260000f,0.03070000f,0.02420000f,-0.18399999f,-0.16980000f,0.81780002f,0.32179999f,0.58400000f,-0.04580001f,-0.60359999f,0.03900002f,0.45750002f,0.27100000f,0.39510001f,0.13760000f,0.46479997f,0.04399997f,0.78550002f,0.63330000f,0.05099998f,0.74629995f,0.45929998f,-0.34880001f,-0.05020000f,0.16000001f,-0.08860001f,0.52530000f,0.45230001f,0.11300001f,-0.12390000f,-0.14870001f,-0.60180002f,-0.67360001f,-0.12229999f,-0.13960000f,-0.10830000f,0.16680001f,0.07580000f,-0.01340000f,0.00650000f,0.27520001f,0.08730000f,0.06220000f,0.09520000f,-0.16380000f,0.17580000f,0.50139999f,0.48859998f,0.40109999f,0.08479999f,0.15849999f,0.50460001f,-0.02960000f,-0.41189999f,-0.22960001f,0.42320002f,0.42350000f,0.15900000f,-0.07499999f,-0.39930000f,-0.51590002f,-0.38099999f,-0.15310001f,0.50110000f,-0.60899999f,0.29120000f,-1.15299998f,1.66679997f,-0.67640000f,0.65600005f,-0.29260003f,0.35210002f,0.34900003f,-0.71580000f,0.23390001f,0.36740002f,-0.95040002f,0.25300001f,0.91519999f,-1.17279999f,0.52000001f,0.46249998f,-0.73459999f,0.25820001f,0.29729999f,-0.01319998f,0.13490000f,-0.22140004f,-0.33060000f,-0.09270001f,0.02879995f,0.08140002f,-0.01370001f,0.74670001f,-1.00300001f,0.43100002f,-0.60130001f,0.30179999f,-0.32220000f,0.81060003f,-1.40140002f,0.49910002f,0.07590002f,0.49120001f,0.01930000f,0.02459999f,0.16110001f,0.20139999f,-0.02410000f,-0.38040001f,-0.41000001f,-0.13510000f,-0.10390001f,-0.64920003f,-0.34110001f,-0.59270004f,-0.37460003f,-0.15490001f,0.07599996f,0.27660002f,0.17730000f,0.18740001f,0.16799999f,-0.11790000f,-0.31250001f,0.59039999f,0.16049999f,0.25310000f,0.39020002f,0.20740001f,0.80970003f,-0.45100001f,-0.16820000f,-0.40770002f,0.42340001f,0.16190000f,0.27140001f,-0.69740003f,-0.09190001f,0.05639997f,-0.70960001f,-0.30470000f,-0.84450002f,0.54499999f,0.01570000f,-0.30120001f,-1.03660004f,-0.40010001f,-1.40180008f,-0.17620003f,-0.40970000f,0.64359999f,-0.35699998f,0.33110000f,-0.59950001f,0.38120000f,-0.32070001f,-0.58630004f,0.27680001f,-0.32050001f,-0.65640003f,0.13060003f,-0.33470002f,0.28240004f,0.04959997f,0.14440001f,0.57649998f,-0.71419999f,0.31400001f,0.80409998f,-0.74419997f,0.44259999f,0.02630002f,-0.38040001f,0.04750001f,-0.44050000f,0.48140000f,-0.25160000f,0.49160001f,-0.38000000f,0.27000001f,-1.24760003f,1.11700003f,-0.67510003f,-0.52990002f,0.68820000f,-0.31520001f,1.18399998f,-0.98339996f,0.63190000f,-0.67340001f,1.27900001f,-0.42510001f,0.37469995f,0.20190001f,0.24800001f,0.09940000f,0.23700001f,0.55440004f,0.31590001f,0.36210003f,-0.44160000f,-0.11670000f,-0.53810002f,0.66139999f,0.05530000f,0.05900001f,-0.07840000f,-0.11960000f,-0.60959999f,0.57080000f,0.16030000f,0.13790001f,0.33339999f,0.15799999f,0.09869999f,-0.90400001f,-0.24410000f,-1.02430003f,0.21560001f,0.17590000f,0.15390000f,0.64560002f,0.17040001f,0.48760003f,-0.99760004f,-0.22040001f,-0.20120004f,0.01320002f,0.06210001f,-0.38509999f,0.20100000f,0.09150000f,-0.34140001f,-0.62920000f,-0.38480000f,-0.86260001f,-1.00880003f,-0.19640000f,0.23000002f,-0.24180001f,0.13150001f,0.59310006f,-0.06100002f,0.30960002f,-0.35289998f,0.74319998f,-0.22150000f,1.11659998f,-1.24979999f,0.61730001f,0.34939999f,-0.03260000f,0.16390000f,0.85170001f,-0.64499999f,0.45980001f,0.45610001f,-0.11319999f,0.23690000f,-0.77549998f,1.46119997f,-0.47590000f,0.19790003f,0.19439997f,0.09490001f,0.73040002f,-0.93960001f,0.41900002f,-1.54340004f,1.36060002f,-0.84030004f,0.27230003f,0.42419999f,0.11060001f,0.56400003f,0.11399999f,0.27180001f,-0.33780001f,0.18119998f,-0.19719999f,-1.62720002f,-0.35740001f,0.89060000f,0.28900000f,0.51070002f,0.35940000f,0.04560000f,0.67770001f,-0.61059999f,-0.01160000f,0.11109998f,0.35640001f,0.09120000f,0.15740001f,0.13240000f,-0.02860000f,-0.05320000f,-0.50339999f,-0.14580000f,-0.75230002f,0.79640001f,0.32500000f,0.90120001f,0.19340000f,-0.04220000f,-0.40110000f,0.49720001f,0.14540000f,0.42360002f,-0.12220001f,-0.09770001f,-0.08060001f,-0.46640001f,-0.17680000f,-0.13240001f,0.53380002f,0.22280000f,0.47170002f,0.10840000f,0.07460000f,0.07040000f,0.97100000f,0.34660000f,0.90810002f,0.42420001f,-0.10160000f,1.09990000f,-0.98779998f,0.60780001f,0.13709997f,-0.93239998f,0.12390000f,-1.16689996f,1.23899998f,-0.63840000f,0.48460001f,-0.47560001f,0.26800001f,0.28759999f,-0.38600000f,0.16020000f,-0.29709996f,0.86179995f,-0.20319998f,0.63560001f,-0.82119999f,0.37540001f,0.65210000f,-0.40579999f,0.33700001f,0.52180001f,-0.68740000f,0.30170001f,-0.11780002f,-0.10500000f,-0.05670000f,-0.66160003f,0.34280000f,-0.35100001f,0.51870002f,-0.46400001f,0.29170001f,0.11060001f,0.04260000f,0.05550000f,0.93349998f,-1.11719997f,0.53830000f,0.16880003f,0.71290000f,0.90640001f,0.20120001f,0.80680003f,0.56860001f,0.18380000f,0.79290002f,0.00240000f,0.08700000f,0.42739999f,0.24340001f,0.11870000f,0.61460003f,-0.63920005f,-0.38920001f,-1.01320005f,-0.17740003f,-0.21050000f,-0.57900002f,0.52760003f,0.29860001f,0.36960004f,-0.09360000f,-0.02250000f,-0.16830001f,0.61680001f,0.06270001f,0.25410003f,0.62680003f,0.26300001f,0.28360003f,1.13760003f,0.32640001f,1.23880006f,-0.64700004f,-0.32530001f,-0.52340004f,-1.10720001f,-0.23530000f,-0.64150003f,0.06660002f,0.18930001f,0.53480003f,-0.20320000f,-0.31060001f,0.95459999f,-1.54059997f,0.56470001f,0.36790000f,-0.86440000f,0.23990001f,-0.34039998f,0.15179999f,-0.16850000f,-0.05740001f,-0.33660000f,-0.00090000f,-0.24580006f,0.25900005f,-0.15750002f,0.19039995f,-0.21479996f,0.09219999f,0.54740004f,-0.07900001f,0.28750001f,-0.03689999f,0.19380000f,-0.03060000f,0.89370000f,-1.21680000f,0.50790002f,0.80220005f,-0.40540001f,0.42790002f,1.00340000f,-1.73260000f,0.60710002f,-0.63900006f,0.30460003f,-0.34670002f,-1.41730000f,1.75619999f,-0.80340002f,-0.34759998f,0.39059998f,-0.17990000f,0.14620001f,1.23460005f,0.12160002f,0.16820000f,0.63900004f,0.35920001f,0.23330000f,0.57830001f,0.82160001f,0.45160000f,1.32880003f,-0.59860004f,-0.39530001f,-0.81800004f,-0.17160000f,0.05550000f,0.54749999f,-0.72179999f,-0.26339999f,-0.87549999f,0.91940002f,0.26590000f,0.59580003f,0.49740001f,0.12690000f,0.36460001f,0.22519999f,-0.08990000f,-0.17830000f,-0.09160000f,-0.16460000f,-0.49240001f,-0.47519998f,-0.10440000f,-0.87240000f,-0.47500001f,-0.33080000f,-0.80990002f,0.32420001f,-0.00440000f,-0.28509998f,-0.49120001f,-0.37280000f,-1.13520001f,0.21220000f,0.01490000f,-0.31459999f,0.12879997f,-0.14980000f,0.12530002f,-0.08820001f,0.07980000f,0.31840000f,-0.55200000f,0.21359999f,-0.31040006f,0.04740005f,-0.17670002f,-0.72389999f,0.34179999f,-0.36720000f,-0.54770000f,0.90519997f,-0.33410000f,1.10060001f,-1.19100000f,0.61870002f,0.57260000f,-0.73700000f,0.32810001f,0.57029997f,-0.78779997f,0.31700000f,0.26159999f,-0.25200000f,0.13160001f,-0.17879996f,1.03439995f,-0.15359999f,-0.12350002f,0.04460001f,-0.08220000f,0.78629999f,-0.59080000f,0.41510001f,0.09919997f,0.06319999f,0.02200000f,-0.00069998f,-0.09030003f,0.45799999f,0.29080000f,0.72300000f,0.25860001f,-0.05760000f,-0.43509998f,-0.14640000f,0.08820000f,0.32899999f,0.45340002f,0.21170000f,-0.11819999f,-0.52820004f,-0.28210001f,-0.57320004f,-0.36600001f,-0.23820000f,-0.72800001f,-0.30000000f,-0.19350000f,-0.12410000f,-0.74100002f,-0.37920000f,-1.02970001f,0.12800002f,0.10510000f,-0.23550001f,-0.24080000f,0.03830000f,0.32370002f,1.05800000f,0.32440000f,0.90660002f,-0.89020000f,-0.31400000f,-0.62910001f,0.40160002f,0.17170000f,0.62070002f,-0.69980000f,-0.11740000f,-0.18210002f,0.74759999f,-0.66990002f,0.17300001f,-0.13359997f,0.10899999f,0.79990000f,-0.59760001f,0.41890001f,-0.53659998f,0.53279999f,-0.28580000f,0.80260005f,-0.04260003f,0.40370002f,-0.40980005f,0.25080003f,-0.23000002f,-0.02800002f,0.15640000f,-0.03700000f,-0.36250001f,-0.09800000f,-0.18130000f,-0.42050004f,0.53340000f,-0.25760001f,0.35150005f,0.27979998f,0.16000002f,-0.67970001f,0.53179999f,-0.35800001f,1.09999999f,-1.40179997f,0.63430001f,-1.00330000f,0.93959998f,-0.55970000f,0.19790002f,-0.46320001f,0.13330001f,-1.06969999f,1.13220000f,-0.59140001f,1.04139998f,-0.94730002f,0.41080000f,0.15860000f,0.05559999f,0.40720000f,0.20870000f,0.85970001f,0.35279999f,0.13110000f,-0.03109999f,0.18460001f,0.08870000f,0.19360001f,0.51640004f,0.28130001f,0.69170004f,0.13799999f,-0.10110000f,-0.00150001f,0.53700003f,0.28410001f,1.00520006f,-0.42759998f,-0.28789999f,-0.35189999f,0.32920000f,0.05450000f,-0.17350000f,0.02540002f,0.12910000f,-0.01399999f,-0.83040003f,-0.32640001f,-1.15400004f,-0.50340002f,-0.30570001f,-0.63240002f,0.60440001f,0.20710000f,0.96670004f,-0.81040003f,-0.31340001f,-0.62380004f,-0.40440000f,0.04560000f,0.62520001f,-0.25959999f,0.32740000f,0.02030000f,-0.43699999f,0.04800000f,0.59569999f,-0.20559999f,0.30829999f,0.15240001f,-0.12620000f,0.08650000f,0.30410005f,-0.28680004f,0.18090002f,0.29249997f,-0.73079998f,0.17850000f,0.11500002f,-0.47520002f,0.10060001f,-0.38590000f,-0.10440003f,-0.19789999f,0.68930000f,-0.40759999f,0.36090001f,-0.00139996f,0.49759997f,-0.02219999f,-0.51460002f,1.01500000f,-0.32830001f,-0.31260004f,0.12560001f,-0.17700001f,0.29709999f,-0.93039999f,0.21090000f,-0.86460004f,0.76400001f,-0.48220002f,-0.21209998f,-0.28170000f,-0.55180000f,-0.09470000f,-0.72440003f,-0.54100001f,-0.16670000f,-0.50420001f,-0.29399999f,0.11100000f,0.55960002f,0.79500004f,0.29820001f,0.97570003f,-0.47640002f,-0.17040001f,-0.13060002f,-0.57479999f,-0.07500000f,0.24959999f,0.28659999f,0.09979999f,-0.30850000f,0.10580000f,0.04690000f,0.61720000f,-0.04160000f,0.04280000f,0.33079999f,0.56800004f,0.34010001f,0.35550002f,0.64580002f,0.23830001f,0.12020004f,0.76980000f,0.11280000f,0.39730002f,0.30640001f,0.01610000f,-0.32650000f,0.26560000f,0.00530000f,0.22590001f,0.22020002f,0.34360000f,-0.42619997f,1.17079998f,-0.28080000f,-0.53300000f,0.73339999f,-0.31110001f,-0.97599999f,0.83999997f,-0.51520001f,0.59150004f,-0.96840002f,0.36110003f,-0.68360003f,0.39100001f,-0.36410002f,-1.17419997f,0.82339998f,-0.62130000f,0.68989999f,-0.05539999f,0.34320000f,-0.27380001f,-0.33919999f,-0.10980000f,-0.33039999f,0.10920000f,-0.16380000f,0.61150007f,0.01479997f,0.31550002f,0.96420002f,-0.47100001f,0.50870001f,1.04269999f,-1.41199999f,0.59450001f,0.77510002f,-0.44440000f,0.40230002f,0.31089998f,-0.67339998f,0.19040000f,0.08280003f,1.27350000f,-0.29140001f,-0.24170000f,-0.43280001f,0.62119999f,0.07540000f,0.12599999f,0.13999999f,-0.06170000f,-0.14070000f,0.36400000f,0.25490000f,0.97990002f,-0.80220004f,-0.35520001f,-0.73710005f,0.14660001f,0.15790000f,0.29060001f,-0.12880002f,-0.25070000f,-0.59050002f,-0.73460001f,-0.23290000f,-0.30720003f,0.10860001f,0.09330000f,-0.14260000f,0.15620000f,0.12160000f,0.14170000f,-0.47040000f,-0.08400000f,-0.31800001f,0.59240004f,0.32140001f,0.30080004f,-0.08220000f,0.08790000f,0.51620002f,0.35440001f,0.09410000f,-0.12490000f,0.18800000f,0.21280000f,-0.10460003f,-0.16839999f,-0.05520000f,0.98779998f,-1.10939996f,0.54790000f,0.37849998f,-0.49959998f,0.20890000f,-0.16350001f,-0.20580000f,-0.05180001f,-0.75030005f,0.62500003f,-0.42120002f,-0.01559997f,0.20239999f,-0.01000000f,0.30329996f,-0.48619998f,0.16040000f,-0.99140000f,0.78159999f,-0.53980001f,0.25540003f,0.22659998f,0.11590001f,0.12430001f,0.10120000f,0.06150000f,-0.57659999f,0.83619999f,-0.33330001f,0.70260006f,-0.09100003f,0.36470002f,-0.55580001f,0.29780001f,-0.28130002f,0.68210001f,-0.31940000f,0.35460001f,0.61750000f,-0.84320004f,-0.44500000f,-0.08840000f,-0.51850001f,-0.45840003f,-0.33660001f,-0.75500003f,-0.17059998f,-0.13689999f,0.37040004f,-0.29060000f,0.03950000f,-0.06960000f,-0.75099998f,-0.12680000f,-0.27230001f,0.68739999f,0.24709999f,0.85700001f,0.73380000f,0.15870000f,0.31900001f,0.29900000f,0.07150000f,0.61720000f,-0.34540001f,-0.17960000f,-0.64550003f,0.36560000f,0.21520000f,0.84800001f,-0.40900001f,-0.14000000f,-0.86010003f,-0.42639999f,-0.04250000f,-0.25950000f,0.04960000f,0.00350000f,-0.08190000f,0.18559999f,-0.10520000f,-0.17440000f,-0.63039998f,0.12930000f,-0.38549998f,0.86079998f,-0.24250000f,-0.13060005f,-0.04359997f,-0.08080001f,-0.51040002f,-0.38740002f,-0.23250000f,-0.48739998f,0.84079999f,-0.28300001f,-1.09249996f,1.24959995f,-0.60989999f,0.50659997f,-0.88939997f,0.31229999f,1.01419999f,-1.09979998f,0.56510001f,0.06100000f,-0.66000000f,0.07260001f,-0.07610000f,0.31840000f,-0.06630000f,-0.04860000f,-0.31220000f,0.00770000f,-0.05349999f,0.73199999f,-0.07730000f,-0.55809997f,0.88619996f,-0.32479999f,0.14590001f,-0.05380000f,0.07400000f,0.50339998f,-0.76739999f,0.28250000f,-0.38259996f,0.80630005f,0.46880000f,0.00580000f,-0.19540000f,-0.91739999f,-0.31589999f,-0.80840001f,-0.07940000f,0.04700000f,0.56130001f,-0.59820005f,-0.24360001f,-0.14030006f,1.10140004f,0.33470001f,1.10680003f,-0.67680004f,-0.35940001f,-0.72860004f,0.72320002f,0.21370001f,0.23070004f,-1.27840003f,-0.39260002f,-1.50460007f,0.62380000f,0.23360000f,0.91150001f,0.76759999f,0.40449999f,1.27250001f,0.48899999f,0.10860000f,0.61590001f,-0.63160002f,-0.09860001f,0.07239998f,0.36660000f,0.24570000f,0.93080003f,-0.40100001f,-0.24700000f,-0.56790002f,-0.49239999f,0.55040003f,0.97619999f,-0.90999998f,0.52640001f,-0.92259999f,1.07999997f,-0.52900000f,-0.56510001f,0.09620000f,-0.27640001f,-0.86230005f,0.35380005f,-0.45280003f,1.02960005f,-1.55260003f,0.60970004f,-0.53020006f,0.32720004f,-0.29740002f,1.03430002f,-0.80000001f,0.56050002f,-1.03559999f,1.89339998f,-0.63610001f,0.35970000f,-0.83359998f,0.23710000f,0.28289999f,-0.60479997f,0.19669999f,0.38549997f,-0.92019996f,0.24720000f,-1.13840002f,0.93600000f,-0.61200003f,-0.11960001f,-0.22620000f,-0.02990001f,-0.20150001f,0.11700000f,-0.11920000f,-0.87909997f,-0.17169998f,0.50340002f,0.14100000f,-0.16409999f,0.61959999f,0.18739999f,0.59920000f,-0.16000000f,0.02950000f,0.52769999f,0.51940001f,0.05330000f,-0.00399999f,-0.06319998f,0.18470000f,0.53970003f,0.97200002f,0.13620001f,-0.03219998f,0.90960001f,0.31140000f,0.84220002f,-0.48440002f,-0.07480000f,0.26500000f,-0.47500003f,-0.29750001f,-0.84920004f,-0.34520002f,-0.15100000f,-0.20960002f,-0.30460003f,-0.13700001f,0.09949999f,0.75559999f,0.13030000f,0.04670001f,-0.74599999f,-0.10120000f,-0.12140000f,0.09440000f,0.02200000f,0.12080000f,0.61320004f,0.29520000f,0.95610003f,-0.42920001f,0.49650002f,0.59639999f,-0.86559998f,0.35080000f,-0.67749999f,0.21600000f,-0.33890000f,0.90860000f,-0.91480000f,0.49680001f,-0.58129998f,0.65419997f,-0.30880001f,1.70200001f,-1.54539998f,0.92290003f,0.88640001f,-1.09859999f,0.51230001f,-1.02360003f,0.61780000f,-0.53630002f,-0.11000003f,0.20500001f,-0.08310000f,-0.40080002f,0.22360001f,-0.21620001f,-0.55590005f,0.04080003f,-0.27970003f,1.26089999f,-1.13339996f,0.68480001f,-1.20299997f,1.27239996f,-0.66320000f,0.07260000f,-0.17420000f,0.04670000f,0.35980005f,-0.24099999f,0.09459999f,-0.13000000f,-0.12470000f,-0.16419999f,0.01900000f,-0.12950000f,-0.70620000f,-0.38400000f,-1.24430004f,0.02340000f,-0.16290000f,-0.55380001f,-0.11660001f,-0.08980000f,0.42669999f,0.33240003f,0.19800001f,-0.17739999f,-0.36600002f,-0.18090001f,-0.76810003f,0.09820000f,-0.04210000f,-0.16959999f,-0.38479999f,-0.21549999f,-0.05129998f,-0.01399999f,0.01370000f,-0.37189999f,0.59320001f,0.05420000f,0.22400002f,0.81620001f,0.08710000f,-0.10460000f,0.89600004f,0.35410001f,1.11390007f,0.81600003f,0.13770001f,0.06790004f,-0.59960001f,0.28280002f,0.31589996f,-0.69679997f,0.18610000f,-0.20929997f,0.50559996f,-0.12989999f,-0.20229999f,0.54259999f,-0.15279999f,0.51059999f,-0.46740001f,0.26490001f,-0.47490003f,-0.33459998f,-0.21560001f,0.63460006f,0.19479997f,0.30760002f,-0.02450001f,0.41880001f,-0.04730000f,0.31579999f,-0.31040000f,0.16860000f,-0.55670001f,-0.04060002f,-0.28000000f,0.23550002f,0.27259998f,0.09880001f,0.87679999f,-1.18600000f,0.49740001f,1.49680001f,-1.37479998f,0.81060002f,0.64850002f,-1.02220002f,0.39520002f,1.35050002f,-1.24540002f,0.73520003f,-0.53740000f,0.06410002f,0.41000001f,0.26590000f,0.25230000f,0.49580003f,0.25180001f,0.34090003f,0.18340000f,0.08090000f,0.39880000f,0.56000002f,0.19720000f,0.95000003f,0.55100001f,0.30430000f,0.49760001f,0.33520001f,-0.02560000f,-0.16439998f,-0.44240002f,-0.06490001f,0.23329998f,-0.09660002f,-0.22230001f,-0.75680004f,0.44060000f,0.16210000f,0.33820001f,0.97219999f,0.32380000f,0.78030002f,0.56880001f,0.32910000f,0.49930001f,-0.34800000f,-0.28260000f,-0.82180001f,-0.03260000f,0.07370000f,0.01480000f,0.33740002f,0.24820000f,0.66010002f,-0.17360000f,0.40920001f,0.43550003f,0.09920000f,0.22090001f,0.53170004f,-0.19300002f,0.28380002f,0.00660000f,-0.25799999f,0.02320000f,0.23400000f,-0.86640000f,0.17600001f,0.49500002f,-0.16960000f,0.26780000f,0.72879999f,-0.76440000f,0.39620001f,-0.93010002f,0.58300001f,-0.48840002f,0.46759998f,-0.35459998f,0.23390001f,0.47440000f,-0.44999999f,0.26580000f,1.03729999f,-1.15319997f,0.58930000f,0.51470003f,-0.10460000f,0.27500000f,0.09100000f,-0.02480001f,0.02860001f,-0.10140000f,0.37640001f,-0.06680001f,0.02110004f,-0.01760004f,0.02610001f,0.12560002f,0.64550001f,0.61639997f,0.06459999f,-0.12320000f,-0.13960001f,-0.21740000f,-0.84760002f,0.37560000f,-0.06300000f,-0.44320001f,-0.06580000f,0.06700000f,0.32570001f,-0.70860004f,-0.39330001f,-1.25420007f,-0.18800001f,-0.17530000f,-0.43750001f,-0.01100000f,0.01610000f,0.14680000f,0.08880000f,0.09090000f,0.52750001f,-0.23260001f,-0.12500000f,0.02349999f,0.39999999f,0.14210000f,0.79310000f,-0.01840002f,-0.17630001f,-0.19970002f,-0.34940000f,-0.04870000f,0.04600000f,0.41760002f,0.21870001f,0.81450004f,-0.23060000f,0.09200000f,0.18390001f,-0.44179999f,-0.85399998f,0.88349998f,-0.52529998f,-0.19950000f,-0.29299999f,-0.27190000f,-0.63379998f,-0.09600000f,-0.31679999f,-0.39079999f,0.81949999f,-0.60649998f,0.64609999f,-0.57399997f,-0.68570002f,-0.75679997f,-0.58650003f,0.42930001f,0.70489999f,0.55450002f,0.09410001f,0.61270000f,0.76949999f,-0.36929999f,-0.02670000f,-0.60099999f,0.65769997f,-0.67500001f,0.61050001f,-0.09299999f,-0.23429999f,0.41949999f,-0.51999999f,0.57429999f,-1.28600003f,0.32659998f,-0.63620001f,0.53300001f,-0.66559999f,-0.30820000f,-0.37450000f,0.13660000f,-0.72630000f,1.20950003f,-0.97440004f,-0.27820003f,-1.65679998f,0.33140001f,0.23840002f,-0.45470001f,-0.68950004f,-0.71729999f,1.12259999f,-0.07020000f,0.06400002f,1.20799998f,0.22400000f,-0.72159999f,-0.45679996f,-0.59540005f,0.65030000f,0.02080002f,-0.62920001f,-0.58320003f,0.15270006f,1.01090003f,0.50450000f,-0.14150001f,0.02050000f,-0.04080001f,-1.16400002f,0.26040002f,0.30539998f,-0.60989997f,-0.55330001f,0.99560002f,-0.55520004f,0.10840001f,-0.00350002f,-1.05189999f,-0.64410001f,0.69829998f,1.07229998f,-0.69770002f,0.85370000f,-0.39890002f,-0.73470002f,1.15070002f,-1.01290001f,-0.21950000f,-0.71379999f,0.41490001f,0.73050002f,-0.52230001f,0.04969999f,0.61749999f,0.71330000f,0.34809999f,-0.34799999f,0.70559998f,-0.30000000f,1.31850002f,-0.30359999f,0.73169997f,0.34350000f,-0.32969998f,-0.34510000f,-0.89500000f,0.53830002f,0.18540001f,-0.39999999f,-0.16700001f,-0.34899999f,-0.30500003f,-0.52240001f,0.17260000f,0.50300000f,-0.57169997f,-0.00180000f,-0.87700001f,-0.45320002f,-0.65620000f,0.85349999f,-0.77699998f,0.31850000f,0.39200004f,0.19660001f,-0.54459997f,0.33350001f,-0.62840000f,-0.39989999f,0.34650003f,-0.09050000f,0.57560002f,0.53379997f,-0.60860001f,-0.19930004f,-0.84140000f,-0.38920000f,1.12320002f,-0.15120005f,-0.33540001f,-1.36669998f,-0.20469998f,0.78730000f,-0.63160002f,-0.75139998f,0.66020003f,-0.40290000f,1.46280000f,0.02439998f,1.02880000f,0.28999998f,-0.39140000f,1.10210002f,-0.03859999f,-0.62920001f,-0.17240000f,0.67490003f,0.66730004f,-0.73710001f,0.45479998f,0.13700001f,-0.02359999f,1.30159996f,-0.38580001f,-1.50149998f,0.25170003f,0.48729998f,0.01100000f,-1.18850000f,-0.00350001f,-0.29289998f,-0.86089996f,-0.00090000f,-0.16640002f,0.58549998f,0.36900000f,-0.03540001f,-0.38220000f,0.66300001f,-0.54029998f,0.37160001f,-0.39150000f,-0.41400003f,-0.72389999f,-0.01900002f,0.42579999f,0.86639997f,-0.39400002f,-0.05179999f,0.44920000f,0.25850004f,0.86469999f,0.04030001f,-0.25049999f,-0.18000000f,-0.71809999f,0.00899999f,-0.44969999f,-0.66520001f,-0.75150002f,0.61890001f,-0.13070000f,0.36400000f,0.43249999f,0.43220000f,0.51650001f,0.56559998f,-0.12229999f,0.47200000f,0.59299999f,0.95099997f,0.00300000f,-0.63510000f,0.19499999f,0.22299998f,-0.40059998f,0.36079997f,0.60650001f,-0.24560000f,1.29550000f,0.74059996f,-0.82060002f,-0.07430000f,0.41630000f,-0.02190000f,-0.56339997f,1.69019995f,-0.04100001f,1.23230000f,0.24969994f,-0.71310002f,0.53030002f,0.53470003f,0.31290002f,-0.97820001f,-0.43389999f,0.44650000f,0.20170000f,-1.42089998f,0.21330001f,-1.47440001f,-0.23500001f,0.95420001f,-0.68260002f,0.47740001f,0.08440000f,-1.23060003f,-0.52439994f,0.85620003f,1.17359998f,-0.11640002f,0.05060002f,0.61890000f,0.14999997f,-1.04720002f,0.35330000f,-0.63500001f,-0.31540001f,0.01990000f,0.56659997f,-0.40080000f,0.43969999f,-0.22100000f,0.11250002f,-0.13830001f,-0.89849998f,0.08150001f,0.22840000f,-0.01190000f,0.46200000f,0.99479997f,0.13279999f,0.02100002f,-0.35040002f,-0.79159998f,-0.80650001f,0.28660001f,-0.54510001f,0.14150000f,0.11230000f,0.69389999f,-0.42150001f,-0.72239999f,0.04909999f,-0.15800001f,0.48739997f,0.91479999f,0.39250001f,0.41600001f,0.39970001f,-0.20850001f,0.25260003f,0.80670000f,-0.93549999f,-0.27440000f,-0.84869997f,0.91450000f,-0.39670000f,-0.25529999f,0.15550000f,-0.51370000f,-0.08310000f,0.50799999f,0.16129999f,-0.02580000f,-0.95099999f,-0.07070001f,0.27870004f,1.95989997f,0.04049999f,0.70490001f,0.75130002f,0.46450002f,0.34030000f,-0.06970001f,0.18230001f,-1.11960000f,-0.09959994f,0.84240002f,-0.64330001f,-1.63339996f,0.65680001f,0.04460000f,-0.05750000f,-0.21930001f,0.22550000f,0.34779999f,-0.74580002f,-0.18239999f,0.02250000f,0.84070000f,0.34160004f,1.39030002f,-0.39810003f,0.17080000f,0.28729999f,-0.29470000f,0.11450000f,0.40029999f,-0.18030001f,1.01669998f,0.34739997f,-0.67900002f,-0.31479999f,1.00540000f,0.00399998f,-0.10300002f,0.66040003f,0.51460003f,-1.43510003f,0.29969999f,-0.27050000f,1.00099997f,-0.54590000f,-1.13599999f,0.41900001f,-0.74179999f,-0.49100001f,-0.04180001f,-0.27560000f,-0.27500001f,0.45200002f,0.65619998f,-0.37600002f,-0.51949999f,0.60859998f,0.25500000f,-0.11370000f,0.02380000f,0.80950001f,-0.11230000f,-0.06550000f,-0.96799998f,0.33289998f,-0.04920000f,0.26150002f,0.53710000f,-0.40170001f,0.25850000f,0.01930000f,-0.11110000f,0.14950001f,0.12920000f,-0.11349999f,0.13550003f,-0.24470000f,-0.65789997f,0.22250002f,0.59739999f,0.05810000f,-0.60250000f,0.54580002f,-0.14649998f,0.24450001f,-0.97230002f,0.22970000f,0.68139996f,0.26600001f,-0.31459998f,1.76089999f,0.14589999f,0.05089996f,1.15689999f,0.37490003f,-0.18249997f,1.61949996f,-0.06950001f,0.89949998f,0.86119997f,-0.75520002f,-0.18920000f,0.66769998f,-0.22709999f,0.31820000f,1.52500000f,-0.55160003f,0.53059999f,0.30549999f,-0.67330002f,1.23190001f,-1.00060002f,-0.37760000f,1.09300000f,-0.21730006f,-0.65570002f,-1.28979996f,0.85390001f,0.29049999f,-0.28360001f,1.22410003f,0.57270003f,1.33349999f,0.27329995f,-0.44530001f,-0.12069997f,1.57060001f,0.21400000f,-1.12900000f,-0.40809999f,-0.52299999f,0.40749998f,-0.34039998f,0.03200001f,1.04709998f,-0.10080000f,-0.53599999f,0.73220000f,-0.31379996f,0.21750001f,0.87299997f,-0.12750001f,0.31950003f,0.02550000f,-0.64349997f,0.43449998f,0.31490000f,0.07290000f,0.47950005f,0.56120000f,-0.37489999f,0.48850003f,-0.16989999f,-0.29669999f,-0.41200001f,-0.90110000f,-0.64980000f,0.05150002f,-0.55190002f,-0.62249998f,0.56999998f,0.80489999f,0.73559996f,-0.54800001f,0.90050002f,-0.12279999f,-0.40549998f,-0.26680002f,-0.92649997f,-0.20000000f,0.93109999f,-0.22460001f,0.67250001f,-0.43680001f,0.22320000f,-0.57089999f,0.07029999f,0.73230002f,0.68189999f,0.31670001f,-1.07660002f,-0.19689998f,-0.22030002f,-0.94860003f,0.10050002f,1.01630006f,0.55949997f,-1.49460000f,-0.15539997f,-0.29749998f,-0.42759996f,-0.54240003f,-0.16250005f,1.16450000f,0.64250005f,0.33480000f,-1.14569999f,0.29129999f,-1.08000001f,-0.73379997f,0.40580000f,0.37459999f,0.34960000f,-0.81440001f,0.37390001f,0.84139996f,0.60840003f,0.42140002f,0.02620001f,0.52860003f,0.31679999f,0.83970000f,0.07590001f,-0.36300000f,-0.73379997f,0.67380000f,0.38740003f,0.08440000f,-0.25449999f,-0.32330000f,-0.08090000f,-0.96199999f,0.32659999f,-0.71859999f,1.08800001f,0.03130001f,0.86719999f,-0.63100004f,0.58390001f,0.46020000f,-0.20250003f,-0.95669998f,-0.12149999f,0.93449999f,-0.35309998f,0.40549997f,-0.72899999f,0.86880001f,-0.21599996f,-0.62399999f,-0.57570000f,-0.11160000f,0.27199999f,-0.04099999f,0.82799998f,0.78900000f,-0.16379998f,-0.16020000f,-1.08000001f,0.58049997f,-0.54579998f,-1.00600003f,0.11080000f,-0.42480001f,-0.33899999f,0.41010000f,-0.39059998f,-0.61099999f,-0.09040000f,0.24700000f,-0.25049999f,0.45280000f,0.05780000f,-0.37820001f,0.53980003f,0.25619999f,-0.41010000f,-0.40250000f,-0.37190000f,1.59949997f,0.30470001f,-0.84839997f,0.86489999f,0.24729999f,-0.36680000f,0.97160000f,0.03580000f,-1.03329998f,0.10660001f,0.97380001f,-0.13570000f,0.05380000f,0.06880000f,0.80859999f,1.08169996f,-0.27950000f,0.84040000f,-0.29499999f,-0.30919999f,0.83320002f,0.44359993f,-0.76020002f,-0.65659999f,-1.28589995f,0.49670000f,0.68129998f,-0.92550000f,-0.01089996f,0.93249998f,0.84949995f,-0.47350000f,0.25590001f,0.11339998f,-0.46360001f,0.03810000f,-0.70710001f,-0.74900002f,-0.02920001f,-0.09260000f,0.34049999f,-0.40469999f,-0.03190000f,-0.13299999f,1.02639998f,-0.06519999f,0.29949999f,0.70969998f,0.42029998f,0.21950001f,0.60040000f,0.09510000f,-0.51250001f,0.58929998f,0.53009998f,0.01000000f,0.07850000f,0.07540000f,-0.23849997f,0.32189999f,-0.71569997f,-0.21550000f,-0.42619998f,-0.49829999f,0.37750000f,-0.18520003f,-0.52289999f,-0.15800001f,-0.38649999f,0.59319997f,-0.48550003f,-0.62899998f,-0.33809999f,-0.07449998f,0.10839999f,-0.72549996f,0.41800000f,-0.14710000f,-0.10780000f,0.98800002f,0.54960002f,1.05399999f,0.74059997f,-0.33360000f,0.66089999f,-0.25529997f,-0.39889999f,0.99310000f,0.20719999f,-0.99700000f,-0.06149999f,0.67289995f,0.75710003f,1.15680002f,-0.72929999f,0.04590002f,0.42359999f,0.37259998f,0.05260001f,0.36870001f,-0.53490001f,-0.43770002f,-0.34350001f,1.46939999f,-0.10139998f,1.41910004f,-1.03930005f,-0.17450000f,0.91640000f,0.52689998f,-0.04310000f,-0.98690000f,0.51590001f,0.37730001f,-0.97649999f,0.15780003f,0.31920000f,-0.04880000f,-1.59939995f,-0.44320001f,-0.84039999f,0.41350000f,0.59070000f,1.05730000f,0.38770000f,-0.34749998f,0.07420000f,-0.82549997f,0.03499999f,-0.40039997f,-0.35480000f,0.57099999f,-0.42249998f,-0.54919999f,-0.95150001f,0.62659997f,-0.23049999f,-0.91350002f,-0.59849999f,-0.73110001f,-0.38500000f,0.13299999f,-0.38419998f,0.30400001f,-0.50500001f,-0.08540000f,0.37949999f,0.81390001f,0.02250001f,-0.81700003f,-0.88940003f,-0.82320001f,-0.62549998f,0.08610000f,-0.75029998f,0.23349999f,0.59540000f,0.55329999f,0.30399998f,0.38330000f,0.61899998f,0.62649998f,-0.99099997f,0.40209998f,-0.15450000f,0.58469998f,0.41829999f,0.69150003f,0.74570004f,-0.28970000f,-0.34150000f,0.40210001f,-1.28070001f,-0.36179999f,0.49740000f,-0.41740001f,1.40320002f,0.08200002f,-0.58959998f,-0.13819999f,-0.34700002f,0.63820003f,0.33560003f,0.27680000f,0.36650001f,-0.27560000f,-0.85140004f,0.68020001f,0.77629999f,0.02410000f,0.15250000f,-0.76420001f,0.28520002f,-1.39220002f,0.49430004f,0.40930002f,1.34430002f,-0.05970007f,-0.83870003f,0.09820000f,1.24130002f,0.59210004f,-0.46550001f,-0.67749996f,0.56950001f,0.29079999f,-0.01990002f,0.41850003f,-1.38030004f,-0.31859999f,0.55500001f,-1.15000000f,0.42120000f,-0.31100001f,0.01159999f,0.18439999f,0.29849999f,0.22709999f,0.89189999f,0.19399999f,0.85540002f,0.04880001f,0.89299999f,-0.07580000f,0.52819997f,-0.83800000f,0.14740001f,-0.58240001f,0.84700003f,-0.50710000f,-0.04000000f,-0.53999999f,0.28769999f,-0.63439999f,-0.48300002f,-0.33930001f,-0.04200000f,0.49199999f,0.67410002f,0.84639999f,0.10450002f,-0.57940003f,-0.79409999f,-0.85650001f,0.84150001f,-0.40889999f,-0.39850000f,-0.07579999f,0.33449999f,-0.76450002f,0.07449999f,-0.29809999f,0.29650000f,0.28910000f,0.94510001f,0.23099999f,0.05000000f,0.64060003f,1.51190001f,-0.46270002f,-0.55260004f,-1.24200002f,0.37680003f,0.43250000f,-0.25490001f,0.39890003f,1.18969999f,-0.44360001f,-0.17700001f,0.19940002f,1.17009998f,0.63470002f,-0.31100000f,0.55549999f,-0.45050001f,-0.11390001f,-1.29850001f,-0.50830001f,-0.49520003f,-0.72490002f,-0.05450000f,-0.06870001f,-0.48059999f,-0.69580004f,0.06240001f,-1.76609997f,-0.02210001f,0.39459999f,-0.80260000f,-0.01219998f,-0.28419999f,0.69040002f,-0.39380003f,-0.56329998f,-0.33669998f,0.43010000f,0.02599999f,0.37240002f,0.82860003f,-0.84190001f,0.70299999f,0.12400001f,0.52130001f,-0.62720000f,-0.07800002f,-0.42420001f,0.53520001f,-0.84250002f,-0.08480000f,-0.35750000f,-0.64699997f,-0.52870000f,-0.75639998f,-0.98699999f,0.79829998f,-0.47979999f,0.81850000f,0.20330000f,0.22849999f,0.75849999f,-0.84040000f,0.41229999f,0.44250001f,-0.30690000f,0.49690001f,0.96650003f,-0.47809999f,0.27990000f,-0.00750002f,-0.95849999f,0.25969998f,-0.27200001f,-0.50799999f,-0.14920000f,0.72350003f,0.28900001f,0.17389999f,-0.14500001f,0.07720000f,0.37759998f,-1.10850000f,0.47400000f,-0.25849999f,-0.07050001f,0.96790003f,0.33170000f,0.10539998f,0.06600001f,-0.70660000f,-0.53059997f,0.42840000f,-1.46010001f,-0.78869999f,1.09250002f,0.88450003f,0.28189997f,-1.00190005f,-1.35360001f,-0.58679994f,0.77160003f,-0.12740003f,-0.62680000f,-0.57400001f,0.45729999f,1.40239997f,-0.35680001f,0.50820003f,1.18860002f,0.25480001f,0.09830003f,1.43110000f,-0.07450002f,0.00019999f,-0.34790000f,-0.15070000f,0.25369999f,-0.80839998f,-0.19019999f,0.12590000f,-0.09620001f,0.48300002f,-0.42570001f,-0.43440000f,-0.01800000f,-1.56310002f,-0.21979999f,0.80760002f,-0.13690000f,0.29489999f,-0.33300000f,0.01349999f,-0.27439999f,-0.03550001f,0.00160000f,0.51569998f,-0.34700001f,0.23719998f,0.96919999f,0.65750003f,-0.36320001f,-0.48150000f,-0.00600004f,0.21480002f,0.92519997f,0.85100001f,-0.50299998f,0.32180001f,0.12150003f,0.53489999f,-0.49709997f,-0.71750000f,0.61880000f,-0.62790001f,0.01700002f,0.71619999f,-0.29960000f,0.19950000f,-0.23610000f,0.09110000f,0.06599999f,-0.54389998f,-0.00740000f,-0.72650001f,0.08809999f,-0.17830000f,0.34150000f,-0.15370000f,0.38890000f,0.10000000f,0.46309999f,1.00820000f,0.28600001f,-0.05750000f,1.18720002f,-0.60159998f,0.02400001f,-0.02310001f,0.56909999f,0.43670003f,-1.02889999f,-1.05519996f,0.85540003f,-0.17340004f,-2.21580000f,0.31800003f,-0.59620003f,-1.58030001f,0.12390000f,-0.24639998f,0.30369998f,0.66150001f,-0.89560000f,0.86890002f,0.28690000f,0.46060000f,0.69349998f,-0.49630002f,0.49640000f,0.96609996f,-0.55730001f,-0.19509999f,0.28749999f,0.18330000f,0.90440000f,-0.69469999f,-0.41149999f,-0.72920000f,1.23829998f,-0.12570001f,-0.90630001f,-0.23969999f,-0.36890002f,-1.27659997f,-0.11329998f,0.67810000f,1.25190004f,0.68979999f,-0.90800001f,-0.54399999f,-0.77040001f,-0.55900001f,0.45520000f,-0.17279999f,-0.35400005f,-0.06929999f,0.74979997f,-0.27650002f,-1.03599999f,0.43630001f,0.28800001f,-0.68130000f,0.67840001f,-0.68700000f,0.43409997f,-0.01220000f,0.28250001f,0.73450000f,0.44570000f,0.30600002f,0.11010000f,-0.34919999f,0.35800001f,0.22729999f,-0.40879999f,-0.09750000f,0.25319999f,0.05470000f,-0.12650001f,-0.68589998f,-0.45530000f,0.69850000f,0.75829999f,0.34890000f,1.15700001f,-0.07519999f,0.78159999f,0.05699999f,0.41969999f,0.80819997f,-0.52400001f,-0.51530001f,0.51070001f,1.39399996f,0.16640000f,-0.94430000f,-0.74019997f,0.44960001f,-0.69690000f,0.71970000f,-0.21150002f,0.07970000f,0.81159997f,-0.35520000f,0.00229999f,1.22350002f,0.49010003f,-0.45300003f,-1.66769996f,-0.00729998f,1.23550004f,0.84349998f,-0.71550002f,0.18180000f,0.58469999f,0.32090002f,0.08410004f,1.83289998f,0.05529999f,-0.45510001f,-0.38579999f,0.30860000f,0.12439999f,-0.18979998f,-0.44140001f,0.50360002f,-1.91150000f,0.05169998f,0.56460001f,0.06389999f,-0.46970002f,-0.69040001f,0.18850001f,0.98670004f,-1.18549999f,0.54999999f,-0.60449998f,0.69749997f,-0.64589998f,0.11399998f,-0.05610000f,0.72059998f,0.79000001f,0.44720000f,0.43179999f,0.40250000f,0.29529999f,-0.12089999f,-0.65150001f,0.81620001f,-0.31409999f,0.35449997f,-0.80029997f,0.61649999f,0.01850001f,-0.03620001f,-0.89450000f,-0.55900001f,0.38410000f,-0.30059999f,-0.14499999f,0.97659998f,-0.38520001f,-0.06550000f,-0.01130000f,0.33270000f,0.48800000f,-0.27499998f,0.03520000f,-0.43050000f,-1.09710001f,-0.05370002f,0.19750002f,-0.23590000f,-0.32370000f,-0.78400002f,0.57010000f,0.26280000f,-0.26200004f,-0.02670000f,0.47270003f,0.17590000f,0.44450002f,0.06210002f,1.85429997f,0.28790001f,-0.65339997f,0.05250000f,0.51669999f,-0.02579999f,0.28169999f,0.23670001f,0.07030000f,-0.19060001f,-0.14980001f,0.60289999f,0.49119997f,-0.15740000f,-0.13560000f,-0.26730000f,0.51710001f,-0.64760002f,0.75050001f,0.23230002f,-1.02590004f,-0.87850000f,0.35070001f,0.60080001f,-1.20200003f,-0.50540002f,0.11569998f,1.23400000f,0.61540003f,-0.77549999f,-0.97799996f,0.30000000f,0.01430005f,2.01849998f,-0.15490002f,-0.83359999f,1.26740001f,-0.01960000f,0.41960002f,-0.26530000f,-0.93450002f,0.15179999f,-0.46990001f,-0.43399999f,1.07119998f,-0.42219999f,-0.19400000f,0.33109998f,0.35879998f,-0.29300000f,0.23509999f,-0.07940000f,0.14550000f,-0.16590000f,0.01290000f,-0.24299999f,0.08969999f,-0.49079998f,-0.57650000f,0.05989999f,0.03470000f,0.17100000f,0.60450001f,0.29620001f,0.30500000f,-0.14720000f,0.82480001f,0.22450000f,-0.92800001f,-0.12710000f,-0.89999999f,0.84210000f,-0.42539997f,0.18649998f,-0.26629999f,0.66949997f,0.18150001f,1.01759998f,-0.32110002f,0.63649999f,0.83020000f,0.39769999f,0.86450004f,-0.65730002f,0.03160001f,1.01540000f,-0.26220001f,0.83529999f,1.56139994f,-0.61480000f,-0.70139998f,0.70679999f,0.56240000f,0.54540002f,1.08720002f,-0.03940000f,-0.40309999f,0.25040000f,-0.03860001f,0.44020000f,0.80869997f,-0.45630001f,1.47490003f,-0.49750002f,-0.13170001f,0.14090000f,-0.02120000f,0.69600004f,-0.53370002f,0.89820004f,0.33540002f,0.00270000f,-0.57569999f,-0.10390001f,-1.35220004f,-0.04699997f,0.38060002f,-1.02929999f,0.00270002f,0.85270000f,0.61830001f,-1.54770002f,-0.12170001f,-0.15820000f,0.68589999f,-0.22830000f,0.43230001f,0.34440002f,-0.02310001f,0.87719997f,0.25320002f,0.33259998f,0.36489999f,0.71690001f,0.15139999f,0.37519998f,0.56800000f,-0.65629998f,0.52639998f,0.00640000f,0.24919996f,0.61050001f,1.36410002f,-0.35949997f,-0.90340001f,-0.50660003f,-0.37489999f,-0.10560000f,-0.63360002f,-0.09050000f,0.63039998f,0.05840001f,0.70559999f,-0.45589997f,-0.15429997f,0.15599999f,0.44549998f,-0.08370000f,-0.58899998f,0.31749999f,0.13070000f,0.52229999f,-0.52419999f,0.52180003f,-0.01460001f,0.87859999f,0.62260003f,0.55149999f,0.06170000f,0.34090001f,-0.31470000f,-0.49760001f,-0.38989999f,0.09880003f,0.66859999f,0.86590002f,0.56040001f,-0.41550001f,0.60659997f,0.27219997f,-0.56409998f,-0.32719999f,-0.41600001f,-0.11680000f,1.33310003f,0.98240001f,-0.59360002f,0.53380000f,0.21779999f,-0.38070000f,-1.14260000f,-0.62120000f,0.68629998f,-0.35649999f,-0.26299999f,0.19400000f,-0.41340003f,-0.03679999f,0.53600002f,0.61240001f,0.42640000f,-0.23530001f,-0.81700001f,-0.53839999f,0.51800001f,0.92640000f,0.73700001f,-0.27799999f,0.64970004f,0.09580000f,-0.71560001f,0.54600001f,0.26820001f,-0.30300000f,0.63520003f,0.94470005f,-0.57719999f,0.25549999f,0.71829998f,-0.20500000f,0.69440001f,0.21400003f,0.05290001f,-0.42659999f,-1.23780000f,0.46879999f,-0.55119998f,-0.49040000f,-0.57979997f,0.47770001f,-0.60430000f,0.13250000f,0.55759998f,0.35440000f,0.03760001f,-0.88570001f,-0.25610007f,0.16649999f,0.10900000f,0.52700000f,-0.33560000f,0.18299999f,0.65100003f,-0.19699999f,0.65509997f,0.39909999f,0.25439998f,0.25540000f,1.20500004f,-0.48809999f,0.81929998f,0.32250001f,0.47789997f,0.27100000f,-0.16780002f,0.05629998f,0.80429999f,0.71550003f,0.21049997f,-0.28329998f,0.57139999f,0.16159998f,-0.52339999f,0.67630000f,0.58020001f,-0.16529999f,-0.21449999f,-0.26879999f,0.05280001f,-0.32470001f,0.04580000f,0.37480000f,-0.62240002f,-0.14560000f,0.61300001f,0.27920003f,-0.02940000f,-0.48870002f,-0.05229999f,-0.23520000f,-0.14280000f,0.24490000f,-0.01140001f,-0.24150000f,-0.86530003f,-0.60840002f,0.35370000f,0.28029999f,0.19739999f,-0.20489999f,0.64830000f,0.16239998f,-0.70119999f,0.23030001f,0.31700000f,-0.05000001f,-0.05080000f,0.17600002f,0.32530000f,0.15149999f,0.28459999f,0.15520000f,0.61390002f,-0.70239998f,0.27279999f,0.36280000f,0.03080003f,-0.44290000f,0.53209998f,0.12609999f,0.33779997f,0.47010001f,0.96090005f,-0.45149997f,-0.72439997f,-0.84160000f,-0.35479998f,-0.33820001f,0.04899998f,0.31410000f,-0.55939997f,-1.10260003f,0.42939998f,0.35229999f,0.63110001f,0.29930000f,0.64669998f,0.78550002f,0.29860001f,-0.74000001f,-0.27640003f,-0.12510000f,-0.36369999f,-0.84170001f,0.32539999f,-0.14549999f,-0.82109999f,-0.42669997f,-0.67339997f,-1.29700001f,-0.38179999f,0.39370000f,0.62090002f,-0.40009997f,0.23759999f,0.18360001f,-0.45620001f,0.15510001f,0.44200002f,-0.05900000f,-0.57010000f,0.09720000f,-0.00380000f,-0.15340000f,0.48859999f,0.07959998f,-0.65199999f,0.30030002f,-0.04819999f,-0.35860000f,-0.78420001f,-0.64020002f,0.27239999f,-0.06850000f,0.18080001f,0.24430000f,-0.50700000f,-0.08379998f,0.63099999f,-0.50840001f,-0.04239999f,0.50020001f,0.32570001f,0.21240000f,-0.24240000f,-0.52770002f,-0.03960000f,0.55980000f,-0.82490000f,-0.64639999f,0.39560000f,1.18699999f,0.58939999f,-0.79129998f,0.22360000f,0.19180001f,-0.00670000f,0.61289998f,0.26339998f,-0.50129998f,-1.01429999f,0.82430003f,0.58849997f,0.56240000f,0.49120002f,0.09950000f,-0.13170000f,-0.28770001f,0.30699999f,-0.61039996f,-1.38399998f,0.42749996f,0.63420001f,0.72420003f,0.46250001f,-0.32430001f,0.29969999f,-0.44279999f,-0.33799999f,-0.49360001f,-0.32969999f,0.33929999f,0.98250001f,-0.46799999f,-0.85419997f,-0.86540001f,-0.10720000f,-0.32390000f,-0.82270003f,-0.48359997f,-0.64950001f,-0.53310006f,0.45699997f,0.18169998f,1.11730000f,0.06709999f,0.81879998f,0.11960003f,-0.13170000f,0.49519999f,0.53440002f,0.10149999f,0.11310000f,-0.40889998f,0.15449999f,0.52600001f,-0.15660000f,-0.47780003f,-0.42520000f,-1.11369998f,-0.90060000f,0.39359998f,-0.49250001f,-0.33220000f,0.27160000f,-0.55980001f,-0.14960000f,0.46159999f,-0.64630001f,-0.00379998f,0.84829999f,0.29880000f,0.18160000f,-0.16450000f,0.99180000f,0.49699999f,-0.68810000f,-1.14639998f,-0.66039998f,0.68169998f,0.43890002f,-0.03240002f,-0.63690002f,0.34630000f,0.13079999f,-0.29069999f,0.21480001f,0.04100000f,-0.23660000f,0.38980003f,0.02020001f,-0.41410001f,0.23510002f,0.01119999f,-0.35740001f,-0.68050001f,-0.50600001f,0.24260000f,-0.04100000f,1.11650005f,0.75969999f,-0.62909997f,-0.74909998f,0.63889999f,-0.48020000f,0.39379997f,0.15869999f,-0.05920000f,0.39880001f,-0.30319997f,-0.76140000f,-0.65820004f,-0.64649997f,-0.04850000f,0.49189999f,-0.04980000f,0.18750000f,-0.00450000f,0.03730000f,0.47099999f,-0.22979999f,0.12200000f,-0.65569997f,0.10909999f,0.50180000f,-0.10919999f,-0.54720000f,0.09699999f,0.14959999f,-0.09560000f,0.13629999f,0.01950000f,-0.16530000f,0.37809997f,0.54380000f,0.49420000f,0.19740000f,-0.38089998f,-0.79570001f,0.28800000f,-0.61190001f,-0.25870005f,-0.53889999f,-0.74540001f,-0.51709999f,-0.46180000f,0.10930000f,0.05300001f,-0.22960002f,-0.43970001f,-0.54770000f,-0.53660001f,0.02600000f,0.28700000f,-0.08500002f,-0.55400000f,0.59980002f,0.07300000f,-0.65350000f,0.48869998f,0.20279998f,-0.43349998f,0.68990004f,0.09720000f,-0.81480002f,0.68770002f,0.27760001f,-0.52990001f,-0.25510001f,-0.16059999f,0.27790001f,0.28310002f,0.04400002f,-0.21830000f,0.41659998f,0.29119997f,-0.32989999f,-0.63000002f,-0.54760003f,0.09010000f,-0.16519998f,-0.34499999f,-0.10260000f,-0.18010000f,-0.36420003f,-0.27510001f,0.53850001f,0.15929999f,0.37569998f,-0.38409998f,-0.05810000f,0.47460000f,-0.73309997f,-1.13710001f,0.48089998f,-0.64780001f,-0.42500005f,0.43449999f,-0.50749997f,-1.01949998f,0.47929997f,0.41359999f,0.10000000f,0.08740000f,-0.08040000f,-0.58799999f,0.50119998f,-0.04369999f,-0.68890002f,0.16559999f,0.47840000f,0.08680000f,0.09749999f,0.79629998f,1.48070004f,0.23159997f,0.72340001f,0.86060004f,-0.18859997f,-0.69289997f,-1.48569999f,0.40960000f,-0.86730001f,-0.68970005f,0.53729996f,0.44450000f,0.89170002f,0.50810000f,-0.69109998f,-0.84430001f,-0.36399998f,-0.14080000f,-0.27069999f,-0.09479998f,0.27869999f,-0.91189999f,-0.77220000f,0.29039999f,1.00540001f,0.79440001f,-0.43230001f,-0.92120005f,-0.42560002f,0.60590002f,-0.18300003f,0.06900000f,0.42510002f,0.98580000f,0.70699999f,-0.43970001f,-0.81410001f,-0.66500001f,0.20060001f,-0.69719998f,-0.26519997f,0.66029998f,0.04479999f,0.31600001f,0.26300000f,1.00040000f,0.47959999f,-0.70820000f,-1.11630001f,-0.86860001f,0.40510001f,-1.06020003f,-0.69960002f,0.57120001f,-0.28020000f,-0.36120001f,-0.07710000f,-0.81239998f,-0.30199998f,0.69319998f,-0.11649999f,0.37560000f,-0.07740000f,0.16960000f,0.51560000f,0.59429998f,-0.34419999f,0.40420000f,-0.55699998f,0.06110000f,-0.92690002f,-0.12859999f,-0.92890002f,-0.55130004f,-0.28950000f,0.69059996f,1.21380001f,-0.38369997f,0.49440000f,-0.22559998f,0.45589998f,-0.88060001f,-0.52820006f,-0.16800000f,0.21210001f,0.98490000f,-0.59119997f,-0.22540000f,-0.44300001f,0.08380000f,0.54399998f,-0.12160000f,0.56429998f,-0.66689998f,0.10230000f,0.30140000f,-0.33360001f,0.53760000f,0.41999999f,-0.28230001f,-0.12630002f,-0.23539999f,-0.31259999f,0.28259998f,0.74559998f,0.45309997f,-0.86320002f,-0.45720000f,0.59280001f,0.42529999f,0.28720000f,-0.17109999f,-0.15590000f,-0.31740001f,-0.27180000f,0.20209999f,0.09559998f,-0.25069999f,0.21890000f,0.01519999f,-0.33440000f,-0.80340001f,-0.34380000f,0.54390000f,-0.01510000f,0.00180000f,0.00870000f,-0.04809998f,-0.33840000f,-0.32130000f,-0.08050000f,-0.12160000f,0.03820000f,0.63210000f,0.17519999f,-0.56159998f,-0.38300000f,0.09440001f,0.60909999f,-0.45380004f,-0.21020001f,0.42920002f,0.15520001f,-0.19500000f,-0.39419999f,0.53890000f,0.26339999f,-0.36809999f,1.15150002f,0.52579998f,0.02300000f,-0.26540000f,0.42740000f,-0.11840000f,0.47079998f,0.30320001f,0.43449998f,-0.80619998f,-1.05140001f,-0.01299999f,-0.59659997f,-1.11459999f,0.17220000f,-0.40129999f,-0.81370001f,-0.17109998f,-0.91259997f,-0.64380000f,-0.02290000f,-0.08930000f,-0.12490000f,0.62079996f,-0.02360000f,0.06559999f,0.18059999f,0.45429998f,0.79310000f,0.31539997f,0.54390001f,0.25470005f,-0.57539997f,-0.04630000f,0.24729999f,-0.02210000f,0.41629996f,1.07710001f,0.55269996f,0.21469999f,0.22990000f,0.03749999f,0.34430000f,0.01270002f,-0.07710000f,0.14690000f,-0.13649999f,-0.36800000f,-0.20860000f,0.16969999f,0.04739999f,-0.10020000f,0.87669998f,0.33859998f,-0.66109998f,-1.07060002f,-0.74700001f,0.46320002f,-0.83250001f,-0.54120001f,0.55470000f,-0.33220000f,-0.32640000f,0.05940001f,0.40170002f,0.27820001f,-0.13720000f,0.43079997f,0.05099996f,-0.58469998f,-0.68050001f,-0.43540000f,0.51760002f,-0.49449998f,-0.52360000f,0.06729999f,0.08019999f,0.10459999f,-0.07879999f,0.14609998f,0.20499999f,-0.02890000f,0.63069999f,0.66320000f,0.03580000f,-0.33750000f,-0.14840000f,0.17630000f,1.04200003f,-0.74280003f,0.59899997f,0.16589999f,0.44070000f,0.09930000f,0.47979997f,0.58339999f,0.25109999f,0.82069997f,0.43870002f,0.36389998f,-0.78849998f,-0.14689999f,0.25020000f,0.38339998f,1.41660002f,0.30719998f,-0.09560000f,0.20120000f,-0.12050000f,0.55500001f,0.45540003f,0.31229999f,-0.45960001f,-1.09560002f,0.20789998f,0.68800000f,1.73480008f,0.53859998f,0.00040000f,0.52640000f,-0.15389999f,-0.59949999f,-1.01390001f,-0.27889997f,-0.43769999f,-0.83970001f,-0.63899997f,0.84349997f,0.63190001f,-0.07859999f,-0.70079997f,-0.75960001f,0.34069999f,0.63890002f,-0.43450001f,-0.15620000f,0.36740000f,0.04979999f,0.28380001f,0.18690000f,0.19939997f,-0.06440003f,-0.42579999f,0.88939999f,0.64239999f,-0.42699999f,-0.80659999f,-0.63480001f,0.32459998f,1.03530003f,0.61100001f,-0.57170001f,-0.43539999f,-0.49680001f,-0.00630000f,-0.55670002f,-0.22100000f,0.50090001f,0.28819998f,0.29279998f,-0.15510000f,0.40520002f,0.05180001f,-0.35360000f,-0.90050002f,-0.76880003f,0.20630000f,-0.58840000f,-0.16299999f,0.55839999f,-0.81390002f,-0.52520000f,0.45170001f,0.02819999f,0.27820001f,0.19850001f,0.05739999f,-0.02330000f,-0.13929999f,-0.22939999f,0.05420001f,-0.53249998f,-0.44579998f,-0.78180001f,0.30180000f,-0.58460001f,-1.06540003f,-0.36599998f,0.21040001f,-0.56799998f,0.43420001f,-0.21580000f,0.48579999f,-0.13070000f,0.77490000f,0.18090002f,0.53739998f,-0.16730000f,0.21110000f,-0.12070000f,0.06349999f,0.62470002f,-0.32059997f,-0.67850001f,-1.35130004f,0.34489997f,0.84550001f,0.94070005f,0.57680000f,-0.82840001f,-0.35360004f,-0.28289998f,-0.26990000f,0.12769998f,0.20779999f,-0.25740000f,0.40860000f,-0.54649999f,-0.51779999f,-0.87300003f,-0.09759997f,-0.21979999f,0.35140001f,-0.15040003f,-0.64550001f,-0.26700002f,0.14040002f,0.52020002f,-0.88400002f,-0.54700000f,0.53740001f,-0.50669997f,-0.40179997f,0.28989998f,-1.03160000f,-0.84960001f,0.29070000f,0.89689999f,0.48399998f,-0.63189999f,0.78220000f,0.71060001f,-0.12139999f,0.36590000f,0.41880002f,0.01590001f,1.06900004f,0.73180002f,-0.49750002f,-0.07930000f,0.25240002f,0.48109999f,-0.26500001f,-0.07640000f,0.31640001f,0.80030003f,0.39880000f,-0.61180002f,-0.30290001f,-0.03780000f,0.31620000f,-1.24590000f,-0.81200000f,0.63199999f,-0.31040001f,-0.84440000f,0.64980000f,-0.05530000f,-0.36650000f,-0.54540000f,0.04379999f,0.27660000f,0.18549999f,-0.14410001f,0.64870001f,0.30609998f,0.45929999f,1.22370000f,0.60499999f,-0.82089998f,-0.21290001f,-0.04960000f,0.10240000f,-0.71319999f,-0.58290000f,0.78289999f,0.39730003f,-0.45140000f,0.20140000f,-0.08380000f,-0.34130000f,0.66020000f,-0.04700000f,-0.55219998f,0.60459999f,0.95780002f,-0.10060000f,0.33279998f,0.75920001f,0.01800001f,0.02050001f,-0.73990002f,-0.24409998f,-0.29379999f,-0.18139999f,0.31860000f,-0.72930000f,0.10949996f,-0.56049998f,0.62470001f,-0.30510000f,-0.24980000f,0.11930000f,-0.21750000f,0.06840001f,0.32879999f,-0.74810001f,-0.09059998f,0.77700000f,0.95600003f,0.38900000f,-0.71540001f,-0.32520004f,0.11039998f,0.46920001f,0.91720000f,0.67560001f,-0.36660000f,0.30400002f,-0.13220000f,-0.57250000f,-0.65590000f,-0.67480002f,0.03639999f,0.10870002f,-0.20020002f,-0.43040001f,0.21190000f,0.18720001f,-0.03690000f,0.09149999f,0.15820000f,0.12350000f,-0.80940001f,-0.48460000f,0.48430000f,0.27900000f,0.30580001f,-0.01270000f,-0.23130001f,0.13340001f,0.34330000f,0.30770000f,-0.36340000f,0.18569999f,-0.03210000f,0.26190000f,-0.36639998f,-0.25109999f,-0.20910001f,-0.61049998f,-0.77259997f,-0.52100001f,0.22949999f,0.78310001f,0.30230004f,-0.57359996f,-0.58560001f,-0.63840003f,-0.38540000f,0.60919998f,0.01719999f,0.56269997f,-0.12579999f,-0.43700001f,0.65240000f,-0.49909999f,-0.07630001f,0.48790000f,-0.39879998f,-0.67520001f,-0.14680000f,0.22520000f,0.12880000f,-0.20069999f,0.44429997f,0.57750000f,0.12970000f,-0.30540000f,0.32340000f,-0.32030000f,0.09000000f,-0.15960000f,-0.53269999f,-0.76469998f,-1.00110003f,-0.02290000f,0.06960000f,-0.81360000f,-0.55680000f,0.50879999f,-0.61790002f,-0.46460001f,0.22100001f,-0.67630005f,-0.06540001f,0.75930001f,-0.45930002f,0.13960003f,0.83840001f,0.12660001f,0.44080004f,0.37910000f,-0.82500000f,-0.50840000f,0.43010000f,0.17270000f,0.08439999f,-0.22990001f,0.48220001f,0.09759999f,-0.49990000f,0.56240000f,0.09239999f,-0.61829999f,-0.13980000f,-0.10460000f,0.02900000f,0.01609999f,-0.00360000f,0.07530000f,0.70230000f,0.31079998f,-0.64769999f,1.11890001f,0.84420000f,-0.50460000f,-0.21400001f,0.08240000f,0.27850000f,-0.33190001f,-0.04420000f,0.29920000f,0.36239998f,1.37040001f,0.27369999f,-0.51220001f,-0.16700002f,-0.57289996f,-0.44390000f,-0.08110000f,-0.71840000f,0.46469997f,1.09470000f,-0.73020000f,0.33450000f,0.32730000f,0.14640000f,-0.62549997f,-0.15269999f,-0.02219999f,-0.63439999f,-1.14520003f,0.30259999f,0.20990000f,-0.11569999f,0.39199998f,0.17110000f,-0.24489999f,0.05430000f,-0.25949999f,-0.25950000f,0.05420000f,0.67059997f,1.02140001f,0.07300000f,-0.42539998f,-1.32660000f,-0.53429998f,0.21100000f,-0.80380000f,-0.40939997f,-0.65989997f,-0.84550000f,0.44269999f,-0.09389999f,-0.51619998f,-0.62780000f,-0.09670000f,-0.10730001f,0.20620000f,0.34010000f,0.78930001f,0.44859999f,-0.57220000f,0.51660000f,0.15419999f,-0.51209999f,-0.68720001f,-0.62420002f,0.09560000f,0.22929997f,0.49600000f,0.32690001f,0.32640001f,-0.13700002f,-0.52240000f,-0.57320001f,-0.47120001f,0.17090001f,-0.06069999f,-0.36940002f,-0.43040001f,-0.19100000f,0.02140001f,0.25250000f,0.57640000f,0.35840000f,-0.30140000f,-0.47589999f,-0.02439997f,0.70569999f,0.35030002f,0.11360001f,-0.27590001f,-1.03680002f,-0.54840001f,0.62610001f,-0.60530004f,0.41030002f,0.70009997f,-0.50079998f,-0.20960000f,-0.52749997f,-0.23470000f,-0.30470001f,-0.10129999f,-0.18719998f,-1.05960001f,0.21589999f,0.00840000f,-0.46679999f,0.50850000f,-0.76210001f,-0.46370004f,-0.72919998f,0.48199997f,0.45520000f,0.62089998f,0.44190000f,0.42030003f,0.33699999f,-0.40030000f,-0.03230001f,0.64170000f,-0.62839997f,-0.85119999f,-0.24289999f,-0.17139999f,-0.10100001f,-0.11000000f,0.40699998f,0.05979999f,-0.40099999f,0.66580001f,1.44860004f,0.14719999f,0.41260000f,0.30980001f,-0.00039999f,-0.89610000f,-0.37770003f,-0.63829996f,-0.04610000f,-0.96020001f,-0.67380001f,0.47040000f,-0.39530000f,-0.56940002f,-0.23820000f,-0.35979999f,-0.12639999f,0.26109999f,-0.32760001f,-0.24080000f,0.12350000f,0.17260000f,0.12580000f,-0.06010000f,-0.12549999f,-0.25060000f,-0.10850000f,-0.70190000f,-0.35159999f,0.48990000f,0.09259999f,0.02039999f,-0.17789999f,0.08730000f,0.35860002f,0.26900000f,0.32870001f,0.31680002f,0.04920000f,-0.94690000f,-0.79780001f,0.23350000f,0.00059999f,0.28700000f,0.31989999f,0.30700000f,-0.17220003f,-0.68460000f,0.61029998f,0.26639997f,-0.59099999f,1.08110004f,0.05520000f,0.35210000f,-0.31269999f,0.47770002f,0.69209999f,-0.81039998f,-0.80360001f,-0.13539999f,-0.49909997f,-0.43269999f,0.13420000f,-0.27089999f,-0.08849999f,-0.06670000f,0.18380000f,0.11020001f,0.37209998f,0.04810000f,0.22850000f,-0.02580000f,-0.31479999f,0.19120000f,0.02920000f,-0.51710000f,-0.88270003f,-0.62829999f,-0.12900000f,-0.33900002f,-0.25660001f,0.85930000f,0.98210004f,0.58689998f,-0.84050000f,-0.32650005f,-0.56889997f,-0.02040000f,-0.08280000f,0.62570000f,-0.54489997f,-1.07929998f,0.06340001f,-0.52929999f,-1.39850001f,-0.02100001f,-0.34439999f,0.41580001f,0.06559999f,-0.49940000f,0.45850000f,-0.12420002f,-0.73949998f,-0.37099999f,-0.24040000f,0.10900000f,-0.24170000f,-0.41560002f,-0.18380001f,0.32389999f,0.20939999f,-0.21210000f,0.43980002f,0.05520000f,-0.50190000f,-0.75779999f,-0.58459999f,0.42199999f,-1.13580003f,-0.69460001f,0.65470001f,-0.12840001f,-0.15420002f,-0.09690000f,0.13060000f,0.17820001f,0.06720000f,0.28359999f,0.37880000f,-0.02120000f,-0.62830000f,-0.22179999f,0.46719999f,-0.27309999f,0.01580003f,0.48520000f,0.47159999f,0.18479998f,-0.43109999f,-0.31080001f,-0.39739999f,-0.10380001f,-0.41999999f,0.12570000f,-0.71569999f,-0.28529998f,-0.19060000f,-0.53539999f,-0.11580000f,-0.05840000f,0.18260000f,0.63359998f,0.54490000f,-1.31809999f,0.10470004f,-0.09119998f,0.41440001f,0.85339999f,0.14849999f,0.68180001f,0.22119998f,0.25390001f,0.06199999f,-0.27220001f,0.14290000f,-0.02790003f,-0.85949999f,-0.57460001f,0.13740001f,-0.61380000f,-0.06210000f,0.01060000f,0.76379998f,0.47210000f,-0.69810003f,-0.07269996f,-0.43920001f,-0.47980000f,-0.18420000f,0.12460001f,-0.41890000f,-0.65829999f,-0.39270001f,0.20129998f,-0.59620001f,0.74360000f,0.21620003f,-0.69579996f,-0.26160001f,0.47440000f,0.08320002f,-0.66579999f,0.36999999f,1.15749997f,-0.24960000f,-0.44000001f,0.30079997f,-0.48240002f,1.07900001f,0.85840004f,-0.26340001f,0.04959999f,-0.11809998f,0.49599998f,-0.43979999f,-0.13599999f,0.21700000f,-0.34999999f,-0.51750000f,0.58880003f,0.01960000f,-0.64400001f,-0.08840001f,0.34260000f,-0.13779996f,0.57520002f,-0.69800001f,-1.18680003f,-0.08940000f,0.71340000f,0.00890004f,-0.67220002f,-0.11239998f,0.33630003f,-0.12860000f,0.06500000f,-0.40109998f,-0.24660001f,-0.27390000f,-0.59819997f,1.18739999f,0.46390000f,-0.06770002f,-0.03730002f,0.23670000f,1.17559997f,-0.61340000f,-0.10670000f,0.33279999f,-0.65599998f,-0.41680000f,0.78260000f,0.13819994f,0.47470000f,-0.28459999f,-0.36160001f,-0.02550001f,0.10310005f,0.40189998f,-0.13740001f,-0.54149999f,0.02350002f,-0.10200000f,-0.57880001f,0.82360002f,0.27700000f,-0.26349998f,0.10369998f,0.22860000f,-1.21800002f,0.24280004f,-0.13980000f,-0.11370000f,0.38049998f,0.46090000f,0.14430003f,-1.03909999f,-0.32039999f,-0.59750000f,-0.17689999f,0.06490001f,-0.69290002f,0.73079998f,-0.45360000f,-0.00400002f,0.15159999f,-0.04020000f,0.60700002f,0.09070004f,0.15120001f,-0.49620000f,-0.81360002f,0.22660001f,0.36160000f,0.55689997f,0.55120001f,0.03960000f,-0.23160000f,-0.62420002f,0.01000001f,0.95990000f,-0.07440001f,-0.46060001f,-0.50320000f,-0.10620001f,-0.26060002f,-0.53989999f,0.18720000f,-0.54160002f,-0.03160002f,-0.28539999f,0.33140001f,0.74409999f,-0.74720000f,0.10460000f,0.84759998f,-0.19180001f,0.62280000f,1.08129999f,0.42360000f,0.20300001f,-0.51379999f,0.21740000f,0.35919998f,-0.10929999f,0.02320001f,0.23769999f,-0.01060002f,-0.65619999f,-0.15620000f,0.02980002f,0.38359999f,0.39060001f,-0.94620002f,-0.20339996f,-0.17849999f,0.79889998f,0.63989997f,0.23299999f,-0.05379999f,0.81819999f,0.22039999f,0.97620001f,-0.82720001f,-0.31250000f,-0.64539999f,-0.48259998f,-0.26430000f,-0.73220001f,-0.38920000f,-0.13140001f,0.10910001f,-0.11569999f,-0.31170001f,0.81119999f,-0.11779999f,0.03680001f,0.75939998f,-0.94979998f,-0.26729999f,1.26609998f,0.25749996f,0.21479999f,-0.50530000f,0.72349999f,0.33580000f,-0.08530001f,0.56729996f,0.32459998f,-0.05530000f,-0.65770000f,-0.46260001f,-0.37760000f,-0.24249999f,-0.18620000f,-0.00220000f,0.25810000f,-0.80039999f,0.13759999f,1.24379994f,-0.22980000f,-0.33479999f,-0.47210000f,0.19419999f,-0.72580002f,-0.45810002f,0.18040001f,0.40480001f,0.35860000f,0.71940000f,-0.06900000f,-0.93309999f,0.32480002f,0.30680002f,0.52079997f,-0.31480001f,0.33180001f,0.74300001f,0.43080000f,0.26460001f,0.25260002f,0.43120000f,-0.85379999f,-1.11520000f,-0.61899999f,0.39119999f,0.25930001f,0.10580000f,0.11840000f,-0.35829999f,-0.48339999f,0.21459999f,0.50669998f,0.62340000f,0.13600000f,-0.49160000f,-0.97099997f,-0.35769999f,0.25450000f,-0.25290000f,-0.09270000f,1.25419995f,-0.97019998f,-0.31719999f,-0.69150001f,-0.61809996f,-0.22779998f,-0.42949999f,-0.27410000f,-0.37430002f,0.51030000f,0.58589999f,0.27770000f,-0.88949999f,0.92709999f,0.29589999f,0.80339999f,0.74180000f,0.22920001f,0.79600001f,-0.16080001f,0.02870000f,0.50340003f,0.84419997f,0.26969999f,-1.17219998f,-0.07419996f,-0.29849999f,0.00819998f,-0.60679999f,0.05070001f,-0.43800000f,0.20940000f,0.16330000f,0.41899998f,-0.51279999f,-0.06640000f,-0.82439998f,-0.90649999f,-0.58420000f,-0.57380002f,0.56229994f,0.27859998f,-1.01160000f,-0.62590001f,0.25820001f,-0.37840000f,-0.45690001f,0.30319999f,0.12280000f,0.34600000f,0.85900000f,0.20500001f,-0.59489998f,-0.12360000f,0.15780000f,0.09100001f,-0.59140000f,0.38919999f,0.47630001f,0.54079999f,-0.56219998f,-0.42320002f,-0.67760003f,-0.16000002f,0.57360000f,-0.26240000f,0.06960000f,0.18040000f,-0.23740000f,-0.00380000f,0.19730000f,-0.30500001f,-0.22679998f,-0.26529997f,-0.44960001f,0.04420000f,0.70199999f,0.10359999f,-0.46340000f,0.00900000f,0.11460001f,0.57850001f,0.53809997f,-1.22089998f,-0.64310000f,-0.57829997f,-0.36929999f,-0.52120001f,-0.43890000f,0.06890002f,-0.11820000f,0.58400002f,0.56319996f,0.12219998f,-0.40979999f,1.35759997f,0.47519999f,0.04410000f,-0.06070000f,0.05900000f,0.30799999f,-0.54900000f,0.02610000f,-0.24109999f,0.35530000f,-0.16680000f,0.46089999f,-1.06070002f,-0.38870001f,0.10790000f,-0.32009999f,-0.05450000f,0.15050000f,-0.33450000f,-0.09990000f,-0.46599998f,-0.63339998f,-0.20549999f,0.71280000f,-0.56840001f,-0.20130000f,0.11460003f,-0.17899999f,-0.28830001f,0.91480000f,0.17450004f,0.01780001f,-0.49979999f,-0.09870002f,-0.61640001f,-0.20420001f,0.92379997f,-0.12700000f,-0.54519999f,0.18410000f,-0.68100000f,-0.09700001f,0.89949995f,-0.57780001f,-0.17119999f,0.11030002f,-0.45759999f,0.20319999f,0.61079998f,-0.84280003f,-0.04139999f,0.75980002f,-0.43240002f,0.12080001f,0.13940003f,0.45580001f,-0.39020001f,-1.24130000f,-0.06440000f,-0.20119999f,-0.58940000f,-0.48359999f,0.52819998f,1.29099996f,-0.10960001f,-0.48140001f,0.36679999f,-0.01540000f,-0.62979999f,-0.73970000f,-0.44140001f,-0.36420002f,0.62449997f,-0.33080001f,-0.06530000f,-0.06340000f,-0.34039996f,-0.32259999f,0.95729998f,-0.97230000f,-0.45160000f,0.24810003f,-0.56129997f,-0.43639999f,0.88249996f,-0.99249999f,-0.39350000f,-0.10339999f,-0.96199998f,-0.30069999f,0.56989998f,-0.47409999f,-0.08170000f,0.61600001f,-1.20240001f,-0.38230000f,-0.03149999f,-0.53670000f,-0.06289999f,-1.38180001f,0.28320002f,0.04400000f,-0.78510001f,-0.28949997f,-0.07149998f,1.41829996f,-0.22090003f,0.03519999f,0.49010002f,-0.47430000f,-0.41400001f,-0.91049999f,-0.53749995f,-0.32889998f,0.66219999f,-0.85560000f,-0.46720001f,1.08819999f,-0.14959997f,0.32079999f,-0.11599999f,-0.48879999f,0.20539999f,-0.89800001f,-0.57530002f,-0.41240001f,0.97860001f,1.01620003f,0.40840002f,-0.17580001f,0.15859997f,0.58860002f,-0.00840000f,-1.01849998f,-0.32700001f,0.72959999f,0.46130002f,-0.00180000f,-0.61399999f,0.18589999f,0.71759999f,-0.27539998f,-0.98759998f,0.22720001f,0.56280001f,0.34880001f,-0.59640001f,0.33919999f,0.39460002f,0.25020002f,-0.91020000f,-0.39850005f,0.49720001f,-0.73600002f,-0.73140003f,-0.14880000f,-0.43380000f,0.02640000f,0.63559999f,-0.16519998f,-0.46939999f,-0.56040001f,0.26280000f,-0.48269999f,0.34609999f,0.08410000f,-0.55889999f,-0.39109998f,-0.47200000f,1.03550000f,0.18269996f,0.40360000f,0.42050001f,0.48770001f,-0.02460001f,-1.07039999f,0.77100002f,0.31170000f,0.37139998f,0.08199995f,0.33789999f,0.31690004f,-0.42649996f,-0.44740000f,-0.93809999f,0.77189999f,0.16200000f,0.50060000f,0.76699997f,0.40080000f,0.20360000f,-0.59920001f,0.00220000f,-0.30300001f,-0.31879995f,-0.49280000f,-0.64820000f,0.14020001f,-0.25400001f,0.01650002f,-0.52709998f,-0.34380000f,-0.30459998f,0.77499998f,0.13900000f,0.42079998f,-0.73190001f,0.53960002f,-0.41640000f,-0.59260002f,-0.06600000f,0.21920000f,-0.11579998f,-0.46220000f,-0.26520000f,0.79329997f,-0.38559999f,0.24839999f,0.93879996f,-0.43040000f,0.06100000f,0.71079999f,0.35020001f,-0.08200000f,0.26549996f,-0.01060000f,0.03060000f,0.09350000f,-0.34200001f,-0.53439999f,-0.05140000f,0.13599999f,-0.29180001f,-0.64519998f,-0.45279998f,-0.04700001f,-0.00600002f,0.61640000f,0.28460000f,-0.32219999f,0.52660002f,-0.31260001f,-0.98470000f,-0.36140000f,-0.42299999f,-0.12230000f,-0.29619999f,0.17779999f,0.15070000f,-0.63580001f,-0.45270002f,-0.48260000f,0.44340002f,-0.04300000f,-0.20950000f,0.05010000f,0.14750000f,0.86389999f,-0.80069997f,-0.42979999f,1.03149997f,-0.30770000f,-0.07710000f,0.73140000f,-0.52740000f,-0.18550000f,0.52359998f,0.47859999f,0.00729999f,0.11500000f,0.01440000f,0.00440000f,-0.16449999f,-0.88969996f,-0.45749999f,-0.75479998f,-0.06480000f,-0.06730001f,-0.21340004f,-0.69939996f,-0.16269998f,-0.17189999f,1.08169996f,0.41999999f,-1.01889999f,0.46490002f,0.08070000f,-0.28029999f,-0.84449995f,-0.37669999f,0.04019998f,-0.29479999f,0.01400000f,0.45899999f,0.49389999f,-0.18560001f,-0.60460000f,-0.37400000f,0.00339999f,-0.09800001f,-0.40749998f,-0.49060000f,0.07459998f,-0.08009999f,0.28580003f,-0.69340000f,-0.19310006f,0.64080000f,-0.73080002f,-1.35840001f,0.03280001f,-0.40880000f,-0.25000001f,-0.01300000f,0.19000000f,-0.24289999f,-0.69899999f,0.06959998f,0.99929998f,0.67180002f,-0.68240002f,-1.56530004f,0.05759999f,-0.70720000f,-0.54920000f,-0.20979999f,0.30140000f,0.81989998f,-0.12100000f,0.40419999f,0.69909999f,0.23600000f,0.67699999f,-0.32639996f,0.02400001f,0.04080001f,0.49719997f,-0.66540003f,-0.04630001f,-0.50959999f,-0.73799997f,-0.41369999f,-0.52529998f,-0.10030001f,-0.00740001f,-0.34320001f,-0.67419999f,-0.07980000f,-0.04050002f,-0.09349995f,-0.36369999f,-1.41030000f,0.30090001f,-0.11850001f,-0.26700000f,-0.26619997f,-0.23419999f,-0.34930001f,0.09610000f,0.16120001f,0.98639999f,-0.89099998f,-0.29910000f,-1.67490004f,0.36330004f,-0.04660000f,-0.61569999f,-0.46929997f,-0.38810000f,0.95009999f,-0.02170001f,0.02730000f,0.81979999f,0.17199997f,0.14079999f,-0.40080000f,0.80359996f,0.57869999f,0.66329999f,0.10730000f,-0.03670000f,-0.21949998f,-0.20500003f,0.32300001f,-0.06360000f,-0.17490002f,0.10020001f,0.56520001f,0.61890000f,-0.56600000f,-0.01640002f,0.90659999f,-0.37759999f,0.72639999f,0.70320000f,0.27159998f,-0.73800002f,-0.61220001f,-0.40300002f,0.48460001f,0.16130003f,-0.05400001f,-0.63820001f,-0.28300002f,0.52260002f,-0.20780000f,-0.66070001f,-0.30120000f,0.56660000f,1.14380000f,-0.17620000f,-0.25740000f,-0.61370000f,0.01320000f,-0.77120002f,0.02539998f,0.50980000f,-0.01699999f,-0.28189999f,0.39520002f,-0.54520000f,-0.55880002f,0.09620001f,0.58120003f,0.68410001f,-0.30480001f,0.16080000f,-0.07310001f,0.41390000f,0.07540000f,0.79799999f,0.60539998f,0.32670000f,0.93600001f,-0.76520000f,-0.30600001f,0.66779997f,0.02619997f,0.28620000f,-0.59559999f,-0.18240001f,-0.33800002f,-0.03160000f,-0.23100002f,0.19140001f,-0.32410000f,-0.56089998f,-0.41160000f,-0.60500001f,0.56200002f,0.10460000f,1.30430001f,0.06189997f,0.13559999f,-0.86270002f,-0.49609996f,-0.13889998f,0.13030002f,-0.53089999f,-0.52750001f,-0.13289998f,0.71249998f,0.17689999f,-0.49010000f,0.14190003f,-0.17790000f,0.88040001f,0.61659999f,0.32710001f,1.18840001f,0.81780000f,-0.67720002f,-0.34060002f,0.40859999f,0.54600003f,0.30120002f,-0.31020000f,0.50740001f,-0.58860001f,-0.76950002f,0.38899998f,-0.62179998f,-1.10829997f,0.09960000f,-0.86540000f,-0.12380004f,-0.61480000f,0.49199999f,0.82740000f,0.06260001f,0.72380001f,-0.09509998f,0.06960001f,0.52280002f,0.16400002f,-0.34940002f,0.70200002f,0.34610005f,0.63120000f,0.28280000f,-0.79199998f,0.39560001f,-0.12960000f,-0.67979999f,-0.61400003f,0.40300000f,0.82140002f,0.25900001f,0.10679999f,0.04749998f,0.47039999f,-0.76139999f,-0.44840001f,0.49620001f,0.25420001f,0.26430000f,-1.20370001f,-0.48840001f,-0.19080000f,0.99120002f,0.40920001f,-0.71110000f,0.25750002f,-0.14470000f,-1.20999997f,0.03060002f,-0.15299999f,-0.01550000f,-0.48429997f,-0.54540000f,0.74889998f,-0.47950001f,0.03910000f,-0.18150001f,0.60229999f,0.52710001f,0.18770000f,0.49090000f,0.35430001f,0.21200001f,0.01939997f,0.32910001f,-0.78550000f,1.06169997f,0.49069999f,-0.69859999f,0.42980001f,0.12400000f,0.75180001f,-0.54260003f,-0.02070000f,0.17089999f,0.46109998f,0.14139999f,-0.28379997f,0.10700001f,-0.31990001f,0.08980000f,-0.01040005f,0.10980000f,-0.30780000f,-0.29270001f,0.28360000f,0.24380000f,0.09180000f,0.62540002f,0.28040002f,0.17469998f,-0.55340002f,0.14260000f,0.05050001f,0.35520001f,0.43199998f,0.39359999f,-0.22760000f,0.66960002f,0.24940004f,-0.61740001f,-0.27799999f,0.44810000f,-0.08680001f,-0.77700002f,-0.11900003f,-0.53300002f,-0.25920001f,0.57629998f,0.01560000f,0.18400001f,-0.04219999f,0.22740000f,0.11700000f,-0.43309998f,0.41900001f,-0.46760000f,-0.49210002f,0.01340001f,0.39280001f,0.20110001f,0.18740001f,0.48700002f,0.70849999f,-0.21460000f,-0.08050000f,-0.29940000f,-0.08439998f,-0.13660000f,0.22480000f,0.59919998f,0.23590000f,0.48930000f,1.13469999f,0.34820000f,-0.20790002f,-0.70650000f,-0.07029999f,0.63480000f,0.86519996f,0.34199998f,0.14480001f,0.16679999f,0.35620001f,0.33700001f,-1.06759997f,-0.43389999f,-0.10640000f,-0.69440000f,-0.53970002f,0.54349999f,-0.91910000f,-0.41500000f,-0.07010000f,0.15110000f,0.13650000f,-0.47999999f,0.38059999f,0.20840000f,-0.40000000f,0.23820002f,-0.12750000f,0.22580000f,0.31839999f,0.24370001f,0.96620000f,0.68519999f,0.28560001f,0.28330000f,0.15770003f,0.58879999f,-0.75680002f,-1.31520000f,0.10420001f,-0.44040000f,-0.04510002f,0.67980002f,0.21499998f,-0.15010003f,0.96440002f,0.25060002f,-1.01659997f,0.47160001f,0.59820003f,-0.23779997f,0.29280001f,-0.41940000f,-0.12080004f,-0.37280001f,0.24880000f,0.95399999f,-0.46440001f,-0.04220000f,0.24140000f,-0.59440000f,-0.06540001f,0.36919999f,-0.02940000f,-0.06180000f,0.16449999f,0.22400000f,-0.18360001f,-0.79959998f,-0.75040000f,0.40360000f,1.25639998f,-0.45260000f,0.98680001f,0.95330003f,0.14280001f,0.37100000f,0.59379997f,0.15980000f,0.51040000f,-1.37439999f,0.20960000f,-0.15760002f,0.04070001f,-0.16629998f,-0.26460000f,0.09319998f,1.13979998f,0.36599998f,-0.92319998f,1.50880001f,0.59770001f,-0.16469999f,1.10089999f,0.58040001f,0.02609999f,0.11930002f,-0.18460000f,1.05750000f,-0.28730002f,-0.07530000f,0.10750000f,-0.69169999f,-0.19840000f,0.21849999f,-0.88829998f,-0.27039999f,0.21089999f,-0.07330000f,-0.07450000f,-0.93049999f,0.12870000f,0.05449999f,1.26289998f,-0.70510000f,-0.12249999f,0.93269999f,0.12409997f,0.40660000f,0.80749997f,0.52669997f,0.20979999f,-1.02170002f,-0.08439996f,-0.22260000f,-0.74240000f,0.02869997f,0.30180001f,0.43180000f,0.19610000f,-0.61780001f,0.54160000f,1.06750000f,-0.51980000f,0.09199999f,0.52649999f,-0.08260001f,-0.61660001f,0.17389998f,0.45160001f,0.61920000f,-0.30819997f,-0.44180001f,-0.43900002f,-0.22010001f,0.07720001f,-0.49380001f,-0.13660002f,-0.58700001f,-0.42560002f,0.66849995f,0.22180000f,0.13800001f,0.01730000f,-0.21200001f,0.30600000f,0.12120003f,0.86880000f,-0.06519999f,-1.29319999f,-0.19000001f,-0.02760000f,-0.13699999f,0.43360001f,-0.35020000f,-0.00960003f,0.65140002f,0.63480000f,0.02140000f,-0.85639996f,-0.57669999f,0.34900000f,0.76959997f,0.35479999f,1.05889999f,-0.42770002f,0.03760000f,0.44259999f,-0.65239998f,-0.16369999f,0.26370002f,-0.54809999f,-0.47090001f,-0.26949999f,1.08049998f,0.59909999f,-0.44510002f,-0.98249999f,-0.39690000f,-0.08650000f,-0.25209998f,-0.29580000f,0.65969997f,-1.10969999f,-0.55780001f,0.11000001f,0.42619999f,0.15630000f,0.02540001f,-0.08180002f,0.13040000f,-1.29610001f,1.11829999f,0.39370000f,-0.26630000f,-0.31070000f,-0.05430000f,0.23050001f,0.38530001f,-0.11240000f,0.22399998f,-0.07540001f,0.39900001f,-0.72980002f,-0.65330004f,-0.43420000f,-0.60400001f,0.53289995f,0.15560000f,0.03180000f,0.23139997f,0.06200001f,-0.22460000f,-0.02420002f,-0.01860000f,0.10600000f,-0.03730000f,-0.10620000f,-0.38499999f,-0.20870000f,0.42560000f,-0.27999999f,-0.35960001f,-0.29520000f,0.13820000f,0.72439999f,0.25540001f,0.59480003f,0.27850002f,0.24560001f,0.19740001f,-0.68319999f,0.03779999f,-0.80140000f,-0.00950002f,0.32980000f,0.47600000f,0.05210001f,-0.82500001f,-0.23660003f,0.95709995f,-0.71600000f,0.38579999f,1.28559998f,-0.52640002f,-0.17510000f,-0.59150002f,0.00710001f,-0.28950001f,0.57269999f,-1.02469997f,-0.61600000f,0.37449998f,0.27129999f,0.03360000f,0.02329999f,-0.07189999f,-0.13220000f,-0.07040001f,0.04540000f,0.07250000f,-0.27999999f,-0.44979997f,-0.26419999f,-0.24390000f,0.39370000f,-0.01630000f,0.80330001f,-0.27230000f,-0.09540000f,0.41710001f,0.82529999f,0.44100001f,-0.81140001f,0.44340001f,0.30470001f,0.09920003f,-0.51939997f,-0.53600000f,0.16660000f,0.82999996f,0.41389999f,0.90789996f,-1.29910000f,-0.53910001f,1.31959998f,-0.66480001f,-0.12890001f,0.06719999f,0.08550002f,-0.54000001f,0.01440000f,0.59000000f,-0.74540000f,-0.36300000f,0.36609998f,-0.05880000f,-0.08600000f,0.52019996f,-0.25080001f,-0.54500002f,0.01259999f,-0.23820000f,0.27379999f,0.48769999f,-0.48280001f,-0.08060000f,0.28020000f,0.52660000f,-0.85180001f,-1.41350001f,0.54980002f,-0.66560001f,-0.62350003f,-0.23940001f,-0.05280000f,0.61470001f,0.13100000f,0.18380000f,-0.17449999f,-0.11720000f,0.65640001f,0.89820002f,0.30140000f,0.03240001f,0.30309998f,0.64940001f,-0.06839999f,-1.11650000f,-0.45559999f,0.17899999f,0.59219999f,0.60780003f,-0.89210001f,-0.85230000f,-0.44219998f,-0.62909998f,-0.70940000f,0.01560000f,-0.67340000f,-0.52020000f,-0.10559999f,-0.48940000f,0.22250001f,-0.70139997f,0.24170003f,-0.82000001f,-0.19680002f,-0.86640000f,1.30490003f,0.20500001f,1.04170001f,0.49910001f,-0.17140000f,0.51910002f,-0.53530001f,-0.36139998f,-0.36449999f,-0.36160003f,0.71159997f,-0.31400006f,-0.64140000f,-0.09539999f,-0.44279999f,0.36640000f,-0.56459998f,0.30580002f,-0.03390000f,0.57519998f,-0.19970004f,-0.83860002f,-0.45959999f,-0.69459999f,-0.67850001f,0.33220000f,-0.60770002f,-0.54430005f,0.57950002f,0.11579998f,0.85159997f,0.37849999f,-0.12980000f,-0.17660000f,0.26430002f,-0.52959998f,-1.10449996f,-0.61359999f,0.04000001f,-0.34079998f,-0.35279999f,-0.63820001f,-0.79140001f,-0.11009999f,0.09520000f,-0.05450001f,0.27599999f,0.09679998f,0.33279996f,-0.32180004f,0.30900000f,0.44749999f,0.23650000f,0.18200000f,0.73240001f,0.32420000f,-0.01960001f,0.05619997f,0.33039999f,0.66120001f,1.06880001f,0.54700001f,-0.20160001f,-0.03230001f,0.34980000f,0.01019999f,-0.57190002f,-0.02090001f,0.19840000f,0.20410000f,0.48700001f,0.27280000f,-1.24800004f,0.45580001f,-0.56339999f,0.24800003f,-0.45760004f,-0.48019999f,-0.32660001f,0.29090001f,0.31219999f,0.43810000f,-0.01280000f,0.61279997f,0.02399998f,0.14239996f,-0.58819998f,0.29820000f,-0.69910001f,-0.19099998f,-0.56630000f,0.84400003f,0.45640000f,0.62200001f,-0.26850000f,0.03199999f,-0.31150000f,0.24560001f,-0.35799999f,0.08440001f,-0.41420001f,-0.46759997f,-0.33499998f,-0.47400001f,-0.01720001f,-0.59920002f,-0.25010001f,-0.74139997f,-0.16729997f,-0.84150000f,0.21439999f,-0.60729999f,-0.83850002f,-0.38139999f,-0.72290000f,-1.11790003f,-0.28629999f,0.02120001f,-0.33359998f,0.09060001f,-0.21860002f,-0.06470001f,0.19769999f,0.50820001f,0.60780001f,0.49590001f,-0.42179999f,-0.24649998f,-0.50449999f,-0.01360000f,0.43800000f,-0.04880001f,-0.33480000f,-0.96090001f,-0.60020000f,0.39500000f,0.28579999f,0.32850000f,0.35860001f,0.29950000f,0.46830000f,0.14060001f,0.10220000f,-0.30450002f,-0.39780000f,-0.63449998f,-0.42909999f,-0.28459999f,-0.94619997f,-0.38449999f,-0.66619999f,-0.80409999f,-0.67989999f,0.09800000f,0.56579999f,0.36480001f,-0.10060000f,0.19409999f,0.14810000f,-0.18100001f,0.45900000f,-0.68440001f,0.01720000f,-0.51120001f,-0.02229998f,-0.56359998f,0.02110004f,-0.80640002f,-0.04500001f,-0.78900002f,1.20589999f,0.07799999f,1.05369999f,0.75960002f,-0.09039999f,0.55800002f,0.13329999f,0.54699998f,0.26729999f,-0.81440000f,0.09380000f,-0.74140001f,-0.95410002f,-0.14359998f,-0.84950001f,0.39160002f,0.57020000f,0.28100000f,0.45950002f,0.13519999f,0.49890001f,-0.28360000f,0.34379998f,-0.07500001f,1.09429998f,0.09919999f,1.06489999f,0.08179999f,-0.48679999f,-0.01500000f,0.23289998f,-0.39959997f,0.17790000f,-0.02080001f,0.46990001f,0.32440000f,-0.08490000f,0.31620000f,-0.08480000f,-0.26790000f,-0.15380000f,-0.47319997f,-1.23739994f,-0.72779997f,0.37380000f,0.18890000f,0.43530001f,0.39880001f,0.38589999f,0.02679999f,-0.33060001f,-0.13640000f,-0.26810000f,0.32039999f,0.99009998f,0.49799999f,-0.40800000f,-0.17359998f,-0.54519999f,-0.39140001f,-0.64880000f,-0.41230000f,-0.28860001f,0.05879998f,-0.35850002f,0.70339999f,0.94299998f,0.48549998f,-0.11599999f,-0.47949998f,0.24560001f,0.11400000f,0.29690000f,0.34460000f,-0.20859999f,-0.58029997f,-0.14409999f,0.49379999f,-0.41730000f,-1.22270001f,0.11419999f,-1.01430001f,-0.00010000f,0.14820000f,0.04350000f,0.17459999f,0.58319997f,0.35259998f,-1.09390001f,-0.04520002f,-0.95050001f,-0.18390000f,0.45380001f,-0.24950002f,0.82460001f,-0.11820000f,0.72280001f,0.10149999f,-0.44739998f,-0.08090000f,1.35600002f,0.12879998f,1.16320001f,0.39940001f,0.12780000f,0.45160002f,1.18740003f,0.00180002f,0.98400003f,-0.63919998f,0.16299999f,-0.72260000f,-0.90610001f,-0.34419999f,-0.65169999f,-0.31730001f,-0.35579999f,-0.30490000f,-0.26070000f,0.04240000f,-0.11050000f,0.02510001f,0.66240002f,0.02360003f,-0.69049996f,-0.48879999f,0.54820000f,0.53349997f,0.02089998f,0.28020000f,0.42730000f,0.14330000f,-0.26440000f,-0.07280001f,-0.44380001f,0.04739999f,0.84289998f,0.21429999f,-0.06600000f,-0.11980000f,0.04560000f,-0.22480000f,-0.61049999f,0.01880001f,0.26200000f,0.54439998f,-0.11920000f,-0.08779999f,-0.73460000f,-0.26990000f,-0.05380000f,-0.25299999f,-0.00650000f,-0.04480000f,-0.25350000f,-0.06820000f,0.25759999f,0.01509998f,0.32080000f,-0.25740000f,-0.69819999f,-0.42649999f,0.11459999f,0.03439998f,-0.26570003f,-0.52640001f,-0.08670000f,-0.28750001f,0.86659997f,-0.15230004f,-0.22249999f,0.64319999f,-0.31910002f,-0.09630000f,0.11320000f,-0.16730001f,1.08440001f,0.18680001f,0.91360000f,0.83130000f,-0.45519998f,0.55910001f,-0.13420000f,-0.12200000f,-0.08380000f,-0.53990001f,-0.18059999f,-0.32790000f,0.53600000f,0.38479998f,0.32719998f,-0.50640003f,0.43220000f,-0.30620003f,-0.27160000f,0.00300000f,-0.17980000f,-0.18890000f,0.09540000f,-0.11490000f,-0.95990000f,-0.02300001f,-0.80629999f,0.10679999f,0.36379998f,0.20419999f,0.27420004f,0.50180000f,0.19880001f,1.16710002f,0.23159999f,0.19460000f,0.06150001f,-0.13130000f,-0.25439998f,-0.93859998f,-0.66259999f,0.10259999f,-0.20290001f,-0.34990002f,-0.26199998f,-0.95249996f,-0.55799998f,0.11679999f,-0.37410001f,0.12360000f,-0.26019999f,-0.63699997f,-0.26409999f,-0.17900000f,-0.94040001f,-0.31210000f,-0.01500001f,-0.31120001f,0.14570000f,0.61860000f,1.05250000f,0.79750000f,0.35580000f,0.35560000f,0.52030001f,-0.67839998f,-1.09619996f,-0.77099998f,-0.00760000f,-0.31440001f,-0.50920002f,0.54720000f,0.46949999f,0.45380000f,-0.09859998f,-0.65329999f,-0.53350000f,-0.60980000f,-0.71809999f,-0.04649998f,0.44359997f,-0.07230001f,0.12259999f,0.74159997f,0.24459997f,0.07630005f,0.66239998f,0.07010002f,-0.05350001f,0.60099997f,0.10649997f,-0.97070000f,0.13219999f,-0.74909999f,-0.05879999f,0.13420000f,0.06500000f,-0.58220001f,0.40979999f,-0.32960001f,-0.67460001f,-0.11460000f,-0.50080000f,-0.82630001f,-0.39599999f,-0.87290001f,-0.94900001f,-0.23100001f,-0.85160001f,0.82579998f,0.28479999f,0.88619998f,0.36520003f,0.73200000f,0.33000000f,-1.01590000f,0.10939998f,-0.94590001f,0.06069999f,0.72719998f,0.13929997f,0.69539999f,0.30520000f,0.20339999f,0.48779998f,0.25570000f,0.50460001f,0.46529999f,0.05989999f,-0.69760001f,-0.86380000f,-0.34460000f,-0.10600000f,0.09820001f,-0.44720002f,0.36959999f,0.98189999f,0.67679999f,-0.37440000f,-0.45590000f,0.04200001f,0.09699999f,-0.14190001f,-0.44790003f,0.40919999f,1.01999997f,0.46200000f,-0.38320000f,-0.10160000f,-0.21440000f,-0.16960000f,-0.55980000f,0.07920000f,0.41460001f,0.36970002f,-0.14130000f,0.47080001f,0.72340000f,0.12819999f,0.14880000f,-0.10560000f,-0.13620001f,0.14479999f,0.63459997f,0.04879999f,0.06260002f,-0.22559998f,-0.04880001f,-0.16460000f,-0.12540000f,-0.30910000f,0.54799998f,-0.37410003f,0.51980000f,-0.35759999f,0.61700002f,1.06060005f,0.37960000f,0.85180002f,-0.28829998f,-0.59819997f,-0.39869997f,-0.07610004f,-0.48339997f,0.04629999f,0.33610006f,0.76039998f,0.27150002f,0.04439999f,-0.27600000f,-0.14280001f,0.88480000f,-0.27679999f,0.77440001f,-0.66100001f,-0.18919998f,-0.43859999f,0.03490002f,0.69679997f,-0.07490002f,0.02820001f,0.33200000f,-0.12980002f,-0.20639998f,0.43079999f,-0.17400000f,0.61100000f,-0.03400000f,0.39340000f,-0.37940001f,0.09979999f,0.29920000f,0.66100000f,0.11000000f,0.00260000f,0.04960000f,0.24330000f,-0.20499999f,-0.77409998f,-0.64370000f,-0.44539998f,-0.81819996f,-0.60189998f,-0.27059999f,-0.69379999f,-0.43790000f,-0.17359999f,-0.00049998f,-0.47959999f,-0.05180000f,-0.06710000f,-0.07210000f,0.25580000f,-0.15520000f,-0.00210001f,0.36900000f,0.49299998f,0.42909999f,0.10940001f,-0.22899996f,0.22490003f,-0.05760001f,0.53859998f,0.11179999f,0.45800000f,0.91930000f,0.54399999f,0.26000000f,-0.11470000f,0.12580000f,-0.06539999f,-0.24749998f,0.08750001f,-0.33780000f,-0.33130004f,0.27340002f,0.11399999f,0.09820000f,-0.32340000f,-0.32099999f,-0.26479999f,0.24950002f,0.74279997f,0.31969999f,0.54919999f,0.33859998f,0.59899998f,0.15560000f,0.35699999f,0.24460000f,1.08690000f,0.34819998f,0.89409998f,0.10930000f,0.03360000f,0.10270000f,-0.69019998f,0.43699998f,-0.57040000f,-0.61960000f,-0.13619998f,-0.60620000f,-0.90360002f,-0.05180002f,-0.71140001f,0.73019999f,-0.39199998f,0.52900000f,-0.32689998f,-0.27619998f,-0.43489998f,-0.84369998f,0.26819998f,-0.69849999f,-0.39430001f,-0.13600000f,-0.27690000f,-0.44050002f,-0.46560001f,0.39940000f,0.13859999f,0.19869999f,0.22380000f,0.27149998f,0.35229999f,0.11580001f,-0.19549999f,0.37010000f,0.24360001f,0.25650003f,-0.26559999f,0.73980001f,1.21619999f,0.66509999f,0.23640000f,0.17280000f,0.04780000f,0.06140000f,0.16090000f,0.32630001f,-0.35639999f,-1.02389997f,-0.57300000f,0.81780002f,1.37170002f,0.87130002f,0.46460000f,0.37739999f,0.19589999f,-0.44039999f,-0.64729998f,-0.55600000f,-0.43179999f,-0.51829998f,-0.44050000f,-0.09660001f,0.35739998f,0.48830000f,-0.25499999f,-0.31899998f,-0.47909999f,0.07359999f,0.63770001f,-0.83319999f,0.31019999f,-0.73980000f,-0.56570000f,-0.19159997f,-0.51629999f,-1.09950000f,-0.23719998f,-0.87289999f,0.37430002f,0.63019996f,0.23429999f,-0.58560001f,-0.09299998f,-0.71700002f,-0.24439999f,0.24519999f,-0.24960000f,-0.39670002f,-0.37120000f,-0.34490001f,0.03390003f,0.49859999f,0.19830001f,-0.82630003f,-0.28440000f,-0.93890003f,-0.58840000f,0.34059999f,-0.58140001f,0.72210001f,0.23619999f,0.71650000f,0.71330000f,0.06320001f,0.69310000f,-0.07920002f,-0.87619995f,-0.09139998f,0.75560000f,0.32019998f,0.67819999f,-1.22450002f,-0.10940000f,0.03700000f,0.28050001f,-0.02830000f,-0.48720000f,-0.34709999f,-0.40919999f,-0.31319999f,-0.89619998f,-0.59060001f,-0.47879999f,-0.64359998f,-0.16819998f,0.46040001f,0.52819998f,0.13059999f,-0.14140001f,-0.30090001f,0.26750001f,0.33920001f,0.14420000f,0.02580000f,0.27220000f,0.70350001f,0.27630000f,-0.65680000f,-0.90340000f,-0.70740001f,0.40720000f,0.31310001f,0.57860002f,0.21820001f,-0.03120000f,-0.36810002f,0.03599999f,0.44889998f,-0.00260001f,0.35140000f,0.56100001f,0.09729999f,-0.52240001f,-0.39230000f,-0.46360000f,-0.51800000f,0.59500002f,0.39930000f,0.00760000f,0.28110000f,1.01910001f,-0.11220001f,0.92550001f,0.17580003f,0.54800000f,0.29060001f,0.17039998f,-0.31719999f,0.28040000f,-0.24940001f,0.37200000f,-0.32740003f,-0.62810003f,-0.46439999f,-0.44670000f,-0.43700000f,0.43759999f,-0.41500002f,0.11710001f,-0.15160000f,-0.02790000f,0.97300002f,0.17840001f,0.97820002f,-1.19950002f,-0.21460002f,-1.05430002f,0.15460003f,0.80899999f,0.09599999f,0.61190001f,-0.07739999f,0.43150000f,0.05000002f,0.23939999f,-0.07620000f,1.10270003f,-0.08260001f,1.00270003f,0.83960001f,-0.37679999f,0.04560001f,-0.62900000f,-0.18820000f,-0.05400001f,0.49500001f,0.14460000f,0.44240001f,0.75810000f,0.22419999f,0.63859998f,0.92309996f,0.60229999f,0.30040001f,0.11020001f,-0.30960000f,-0.41899999f,-0.85439998f,-0.26589999f,-0.18600001f,0.11530001f,0.37520001f,-0.25060001f,-0.05980000f,0.03150000f,-0.30640002f,-0.39110002f,0.15400001f,0.16459999f,0.86019998f,0.56070000f,0.28360000f,0.65339999f,0.39619999f,-0.38940000f,-0.85240001f,-0.29930000f,-0.10779999f,0.10370001f,-0.13670000f,0.34859999f,0.51979998f,-0.14430002f,-0.16760001f,0.62300001f,-0.72060002f,0.49840000f,-0.50900003f,0.60540003f,-0.41520000f,0.43380003f,-0.02369999f,0.15620000f,-0.17130001f,-0.74090000f,-0.07800000f,-0.79230000f,0.12380001f,0.81639997f,0.04299997f,-0.09540001f,-0.03860000f,0.08400000f,-0.09810001f,-0.79459998f,-0.06529998f,0.31120001f,-0.40180000f,0.29180003f,-0.28250002f,-0.54259999f,-0.13609999f,0.08639998f,-0.72419997f,-0.05540000f,-0.17219999f,-0.27199999f,-0.25499999f,-0.09180002f,0.04820000f,0.08240000f,0.57049999f,-0.02040000f,0.45949999f,0.38360003f,0.55539999f,0.19580000f,0.83630001f,-0.35690000f,0.21060000f,0.24350000f,0.09270000f,-0.17540000f,0.09039999f,-0.13310000f,-0.29580000f,0.21090001f,-0.37870000f,0.04560000f,-0.31310000f,0.30580002f,-0.39120000f,-0.06959999f,-0.38280001f,-0.27520002f,-0.26500001f,0.16960000f,-0.00440000f,-0.62310000f,-0.23100000f,0.30940001f,0.01400000f,-0.17710001f,-0.08859999f,-0.66509999f,-0.39230000f,-0.03860001f,0.04120000f,0.11310000f,0.12539999f,0.40909999f,0.35249999f,0.29120000f,0.53070000f,0.05359999f,-0.21760001f,-0.11690000f,-0.03160000f,-0.52420001f,-0.36449999f,-0.57670000f,-0.15620000f,0.69099999f,-0.16449999f,0.12759999f,-0.19030000f,0.66660000f,-0.12340000f,0.54760000f,1.46090002f,-0.02920001f,1.18590001f,-1.04530004f,-0.22620000f,-0.80570002f,1.21920002f,-0.08399998f,1.03920001f,-0.17499999f,-0.55319998f,-0.06939997f,-0.55249999f,0.47539998f,-0.36810000f,-0.25060001f,0.69019999f,-0.24640003f,-0.20310001f,0.56599998f,-0.07170003f,-0.05140000f,-0.21500000f,-0.04039999f,-0.18250000f,-0.38239998f,-0.21189999f,0.18370001f,0.21299999f,0.04290000f,0.26810000f,-0.25420000f,0.25930001f,1.33030003f,0.05039999f,1.18170002f,-0.00950000f,0.07930000f,0.73760000f,1.15999998f,0.63919999f,0.13340000f,0.07150001f,-0.20330001f,-0.13179999f,0.45410002f,-0.11970000f,0.21379998f,1.17999998f,0.58909999f,-0.16320002f,0.41659999f,0.24300000f,0.12480001f,0.21920001f,-0.22019999f,-0.45540000f,-0.82179999f,-0.62330000f,-0.00800000f,-0.40020000f,-0.00780000f,-0.03559999f,-0.55279998f,-0.07359999f,-0.05400000f,-0.12669999f,-0.17160000f,0.39220000f,0.64419999f,0.58009999f,-0.56979999f,-1.21299997f,-0.65049999f,-0.66180001f,-0.84210000f,-0.25849999f,-0.42519999f,-0.31379998f,-0.49199999f,0.58300002f,0.39810003f,-0.62400001f,-0.04639998f,-0.74080002f,0.19510003f,0.43959999f,0.12850000f,1.11130001f,-0.18399998f,0.85430000f,0.43100003f,-0.78219998f,0.17560004f,0.52580001f,-0.68240000f,0.39500003f,0.45920000f,0.40359997f,0.32359998f,0.59640001f,0.35179999f,0.63860000f,-0.57260001f,0.11839999f,-0.40980001f,-0.64520000f,0.20639999f,-0.44600000f,0.18470000f,0.17499999f,0.17029999f,-0.67880001f,-0.33899997f,-0.67460000f,0.26040000f,0.33099998f,0.43220000f,0.34869999f,-0.41959999f,0.47250002f,1.09099998f,0.07719999f,0.97019998f,-0.87670003f,0.40200000f,0.25600001f,-0.15329999f,-0.23400000f,-0.28580000f,0.03510000f,-0.16230000f,-0.54820000f,-1.01509999f,-0.47649999f,-0.17359999f,-0.61549998f,-0.19759999f,0.12000000f,-0.17530000f,-0.39460002f,-0.13180001f,0.45399999f,0.33129999f,0.32800002f,-0.09089999f,0.25660001f,0.19880001f,0.11740001f,-0.12320001f,-0.07139998f,-0.75889997f,-0.52609999f,-0.09520001f,0.10570000f,-0.07400000f,-0.10720001f,-0.18120001f,0.12760000f,0.46099999f,1.30739998f,0.77130001f,0.11260000f,-0.00640001f,0.22190001f,0.02200000f,0.21880001f,-0.37280001f,-0.21219999f,0.01160003f,-0.31309999f,0.73219996f,-0.26910002f,0.82990000f,-0.23679999f,0.70050001f,0.23689999f,0.08239999f,0.38710000f,-0.29010000f,0.17419999f,-0.13490000f,0.15850003f,0.73739999f,0.13010000f,0.38260001f,-0.75859996f,0.27160003f,-1.14190003f,0.19740000f,-0.94950003f,0.01660002f,0.42279999f,-0.02900000f,-0.15850002f,0.79079997f,-0.02750004f,0.44950000f,-0.08180000f,0.36070001f,-0.28440000f,-0.27039998f,-0.19079999f,-0.11800003f,-0.67819999f,-0.31380001f,-0.57100002f,-0.11020000f,-0.47200001f,0.89040003f,0.44239999f,0.68320000f,1.21190000f,0.00030000f,0.45160002f,0.62110001f,0.10680000f,0.01620002f,-0.59489998f,-0.55270000f,-0.15199999f,-0.07419999f,-0.29379999f,0.06680001f,0.04180001f,-0.10720000f,-0.01040000f,0.01830000f,0.09240000f,0.23780000f,0.07470000f,0.09150000f,0.16980000f,0.45059999f,0.00290000f,-0.32800000f,-0.63159999f,-0.48900001f,-0.36500002f,-0.03930001f,-0.14690000f,0.21700000f,0.58780000f,0.62150002f,0.23900000f,0.00389999f,-0.36030002f,-0.23600000f,0.14689999f,-0.01760000f,-0.21799997f,-1.06849996f,-0.59879998f,-0.58539999f,-1.21539997f,-0.70489999f,-0.15420000f,-0.18320001f,-0.05590001f,0.36099999f,-0.18230003f,-0.02769999f,0.90799997f,0.04529997f,0.63739998f,0.16639998f,0.54019998f,0.11540000f,0.22519999f,0.07779999f,-0.10310001f,-0.13900000f,-0.08310000f,-0.46449999f,0.22119999f,-0.41430000f,0.36440000f,0.11779999f,0.21419999f,0.43480002f,0.31640000f,0.46880001f,0.83630002f,-0.35400000f,0.72570003f,-0.51440002f,-0.64019999f,-0.51140000f,0.15710004f,0.81999998f,0.09090000f,0.67389999f,-0.37939998f,0.55550000f,-0.24070003f,0.75459998f,-0.03590005f,0.37280001f,0.37740000f,0.52460000f,-0.70440005f,0.29310001f,-0.17640000f,-0.67039999f,-0.28260000f,0.08660001f,-0.63609998f,-0.12049999f,-0.21079999f,-0.38019998f,-0.51299999f,0.20980001f,-0.15160000f,-0.11730001f,-0.26739999f,-0.44049999f,-0.22949999f,-0.01120000f,-0.43660000f,-0.05260000f,0.82600001f,1.19129999f,0.72640000f,0.38720001f,0.68010001f,0.02599999f,-0.22920000f,-0.53490001f,-0.49500002f,0.00120000f,0.18870000f,0.18080000f,-0.60400001f,-0.64260000f,-0.52640001f,-0.21620000f,-0.04750000f,-0.44050000f,0.42220000f,1.07689999f,0.71390001f,-0.24439999f,-0.62419998f,-0.25759999f,0.34920001f,-0.30380000f,-0.35820003f,-0.07799998f,-0.18840000f,0.10249999f,-0.60079999f,0.09070000f,0.14539998f,-0.50039998f,0.10199999f,0.36579998f,-0.14439998f,0.17120000f,0.69529999f,-1.32399998f,0.42830001f,0.54840005f,0.20679998f,0.26820001f,-0.15900001f,0.55320001f,-0.12080000f,-0.30280003f,0.05680001f,-0.16680000f,-0.62969999f,0.35479996f,-0.31690000f,-0.59640003f,0.27660002f,-0.32010001f,0.57439999f,-0.31459999f,0.29110001f,0.34030005f,-0.52420005f,0.22240002f,0.01899997f,-0.50319998f,0.02780000f,-0.31750001f,-0.15120000f,-0.13930001f,-0.30210005f,0.53420002f,0.76299999f,0.16909999f,0.09279999f,-0.29640002f,-0.24990001f,-0.50790002f,-0.97099999f,-0.27849999f,-0.79580001f,-0.22239999f,0.06640000f,0.29920001f,-0.84020004f,-0.45730001f,-1.36000005f,-0.15540002f,-0.13530000f,-0.03600000f,0.48059999f,0.33000000f,0.51550000f,0.40500000f,0.15000000f,0.52450001f,0.66280003f,0.17300001f,0.24880003f,-0.06780003f,-0.15840000f,-0.29270002f,0.96840003f,0.34260001f,1.11040005f,-0.18200002f,-0.26230000f,-0.69550002f,-0.59460004f,-0.20760001f,-0.06890005f,0.04479999f,-0.11230000f,0.05429999f,-0.00960001f,-0.09290001f,1.22399999f,-1.00819997f,0.66190001f,-0.05610003f,-0.15499999f,-0.03300000f,-1.04399998f,1.34999996f,-0.60140000f,-0.64159998f,0.62239997f,-0.34320000f,-0.32680005f,0.58420002f,-0.21990002f,-0.19260004f,-0.21319997f,-0.08880002f,0.34490000f,0.08520003f,0.18169999f,0.28250000f,-0.51499999f,0.17600000f,0.93120003f,-0.84840002f,0.51100003f,0.15829995f,-0.37679995f,0.08929999f,0.78560002f,-1.22840002f,0.47300002f,0.28849997f,-0.36639997f,0.14550000f,-0.92290004f,0.46300003f,-0.48640002f,0.09069997f,-0.60079998f,0.07250000f,-0.06990002f,-0.86329999f,-0.38479999f,-0.17020000f,-0.09099999f,-0.15960002f,-0.20040000f,-0.61500003f,0.49020002f,0.14070000f,0.75360002f,-0.09939998f,0.03220000f,-0.50349999f,0.47960002f,0.19120001f,0.09260002f,-0.81020003f,-0.16630001f,-0.38280004f,0.20580000f,0.06690000f,0.59640001f,0.16440000f,-0.01320000f,0.41340002f,0.23400002f,0.24570001f,0.54810003f,-0.53559999f,-0.15020000f,-0.58680002f,-0.87300000f,-0.25770000f,-0.44960002f,-0.63900001f,-0.17160000f,-0.96550002f,0.46540000f,0.05960000f,0.01430001f,0.14100000f,-0.03540000f,-0.28689998f,-0.07640001f,-0.20419999f,-0.54820001f,0.17079999f,-0.28560000f,0.24359998f,-0.19339997f,0.11730000f,0.27480001f,-0.85500002f,0.19170001f,0.16890004f,0.60379996f,0.04820001f,0.70740003f,-0.29120000f,0.37100001f,-1.10180001f,1.26720000f,-0.61780002f,-0.08880002f,-0.46419999f,-0.01170001f,0.00359996f,-0.62179998f,0.03749999f,-0.08249998f,0.25460000f,-0.04020000f,-0.47139997f,0.83219997f,-0.28609999f,-1.12599999f,1.05139997f,-0.62230000f,-0.37549999f,1.15619997f,-0.26000000f,0.79609999f,-0.77839999f,0.43470001f,0.47349998f,-0.31819999f,0.24580000f,0.33789999f,0.29460002f,-0.18580001f,-0.09350000f,0.39339999f,-0.23040001f,-0.05070000f,-0.10010001f,-1.06359998f,-0.25160000f,-0.61460001f,0.06140000f,-0.03380000f,0.45009999f,0.42640001f,0.26570001f,0.86310004f,-0.06640000f,-0.01970000f,-0.48550001f,0.87880000f,0.22670000f,0.44030002f,-0.00599998f,0.08640000f,-0.42940000f,-0.55660001f,-0.16250000f,-0.58980003f,0.17699999f,0.11730000f,-0.29160001f,0.86220001f,0.33990000f,1.22200002f,-0.60780000f,-0.35310000f,-0.52120001f,0.19060000f,-0.02890000f,0.01300000f,-0.57279999f,-0.21739999f,-0.41820000f,0.88640001f,0.32990001f,-0.57320003f,-0.18159999f,-0.27240001f,-0.31810000f,0.34160000f,-0.17710001f,-1.35139996f,1.57799993f,-0.76199999f,-0.19790001f,-0.50060000f,-0.06840000f,0.02710000f,-0.23959999f,0.04309999f,0.23790002f,0.30259999f,0.09620001f,1.15669999f,-1.19079998f,0.64350001f,0.25900006f,0.59119995f,0.09580002f,-0.50140000f,0.82780000f,-0.30110001f,0.47400001f,0.25140002f,0.22170000f,0.51680000f,-1.06139998f,0.33290000f,-0.55820002f,0.09960000f,-0.29720000f,0.34439999f,-0.54799999f,0.19720000f,-0.62919999f,0.54619998f,-0.34970000f,0.73660001f,0.02510002f,-0.54079998f,-0.00310000f,0.30910002f,0.59539999f,0.37480000f,1.19970002f,0.41700001f,0.18180000f,0.53630002f,0.07240000f,0.11900000f,-0.19879999f,0.81120000f,0.22980000f,0.08260002f,-0.14860000f,-0.09200000f,-0.19310001f,-0.66780001f,-0.32010000f,-0.58660002f,0.63900001f,0.35939999f,0.73010001f,-0.67880002f,-0.17170001f,-0.10050001f,-0.26840000f,-0.11230000f,-0.15150001f,-0.24480001f,-0.07710000f,-0.08410001f,-0.08700002f,-0.07890001f,0.27219997f,-0.59340001f,-0.13050001f,-0.31460002f,0.14580000f,0.19050000f,0.45160000f,-0.26500000f,0.74550003f,-1.18769998f,1.02359995f,-0.63530000f,0.04009999f,-0.31579998f,0.06039998f,0.28150001f,-0.41260001f,0.17140001f,0.21960001f,0.44280000f,0.08739999f,1.29080001f,-0.85219999f,0.68870001f,-0.08690001f,0.03280000f,-0.04950000f,-0.63320003f,0.40360001f,-0.34940001f,0.46150002f,-0.24480001f,0.25930000f,-1.06670004f,0.81580000f,-0.57460003f,-0.32210001f,0.18980000f,-0.17380000f,-0.34370001f,0.25360000f,-0.18590000f,-0.31600003f,-0.27719997f,-0.14140001f,-0.77860000f,0.90819999f,-0.43810001f,-0.14679999f,0.26260002f,-0.07510001f,0.08800004f,-0.30370003f,0.12920001f,0.15640000f,0.51260000f,-0.75700000f,-0.09860000f,-0.16510001f,-0.07340000f,0.13880000f,0.45009998f,-0.81199999f,-0.16150000f,-0.26650000f,-0.43300002f,-0.17210001f,0.06999997f,-0.59079999f,-0.19309999f,-0.43830000f,-0.88660004f,-0.25910001f,-0.29100005f,-0.38480003f,-0.20230001f,-0.20450003f,0.85280001f,0.19060001f,0.82100004f,0.20360000f,-0.01970000f,0.37669999f,-0.91339998f,-0.24099999f,-0.97210000f,-0.13860000f,0.14340000f,0.33170001f,0.36320000f,0.12190000f,0.84090000f,-0.49360000f,-0.00500000f,0.10260001f,-0.71540001f,-0.31410003f,-0.20519997f,0.12459998f,-0.09729999f,-1.19249999f,1.32919997f,-0.66130001f,-0.51509998f,0.52660001f,-0.27200001f,-1.19049998f,1.23399995f,-0.65850000f,-0.74900003f,0.18920002f,-0.38400001f,-0.65769998f,0.69859998f,-0.37099999f,-1.26340004f,0.99700002f,-0.68570003f,-0.45270004f,0.09100003f,-0.23660001f,0.85319999f,-1.47459999f,0.51110001f,0.10289999f,-0.71740000f,0.09080001f,-0.83109997f,1.46919995f,-0.50310000f,-0.54889999f,0.74800001f,-0.30110001f,-0.00670001f,-0.69839999f,0.04510000f,-0.95439999f,1.01379998f,-0.52190001f,-0.46160000f,-0.29360001f,0.43239999f,0.12110000f,0.30150000f,0.50540001f,0.31360000f,1.06710002f,-0.83180003f,-0.38140001f,-1.30770005f,0.26580003f,0.23880001f,0.15850003f,0.80580002f,0.14550001f,0.39660003f,-0.52460002f,-0.32110000f,-0.88120001f,0.02780000f,0.21220000f,0.52809999f,0.93059999f,0.28619999f,0.65550001f,-0.05400000f,-0.05160000f,-0.62900001f,-0.63320002f,-0.31420000f,-0.51280002f,0.47440004f,0.35300001f,1.02620003f,0.74920003f,0.36680001f,0.99180005f,-0.04860000f,0.07920000f,0.39210000f,0.66159999f,0.26779999f,0.37420000f,-0.48899999f,0.13880000f,0.50409999f,-0.58739998f,0.28580000f,0.00110001f,-0.31140000f,0.03760000f,-0.38270002f,0.86120001f,-0.25870001f,0.25670005f,0.34799998f,0.11810001f,1.09320000f,-1.35239998f,0.61740002f,-0.16540004f,0.23000001f,-0.11280001f,-0.42229997f,0.57620001f,-0.22560000f,1.06889999f,-1.15919998f,0.60270000f,0.37700001f,0.21119999f,0.16700001f,-0.62680004f,0.31600002f,-0.34080001f,-0.04239995f,-0.05620004f,0.00390001f,0.46780002f,-0.58520001f,0.28280001f,-0.40290000f,0.24840001f,-0.20490001f,0.79740000f,-0.50639999f,0.43180000f,-1.11299999f,1.20080003f,0.67760003f,0.29620001f,0.64500003f,-0.04000000f,-0.10790000f,-0.17930000f,-0.58699999f,-0.02860000f,-0.04890001f,-0.66719998f,-0.14610000f,-0.58030000f,-0.58540000f,-0.12710000f,-0.33160001f,0.16900003f,0.19550000f,0.02820002f,-0.04720000f,-0.00500000f,-0.06060000f,-0.14400001f,0.02429999f,0.49409998f,0.38419999f,0.08590000f,0.50180001f,-0.31899998f,-0.17150000f,0.00120000f,0.52140000f,0.13140000f,-0.10629999f,0.79680002f,0.21990001f,0.67090004f,-0.14960000f,-0.02590000f,0.40829999f,-0.29920000f,-0.16340000f,-0.24900000f,-0.78160003f,0.14739998f,0.61940003f,-0.55520001f,0.35020002f,0.10449998f,-0.28019999f,0.06060000f,-1.00249996f,1.19419996f,-0.55720000f,-0.71329997f,1.13579995f,-0.42079999f,-0.75359999f,0.91339999f,-0.42610001f,0.19600005f,0.44199996f,0.08060001f,-0.03880000f,0.11260000f,-0.02570000f,-0.62250000f,0.17540001f,-0.31020001f,0.28979997f,-0.72939997f,0.18829999f,-0.49599999f,-0.02500003f,-0.24889999f,0.95109999f,-0.53799999f,0.49990000f,0.84770001f,-1.15319998f,0.49130001f,-0.54890000f,0.01760000f,-0.26830000f,-0.28480000f,0.08939999f,-0.15290000f,-0.65440003f,-0.19400000f,0.10020000f,0.07950000f,0.68140000f,0.16899999f,-0.00700000f,0.22590001f,-0.33840000f,-0.23279999f,-0.09519999f,0.38960005f,0.31870001f,0.75570003f,1.08480002f,0.36330001f,1.20390006f,0.18160001f,0.11900000f,0.47580001f,0.05019999f,-0.08920000f,-0.10490001f,-0.88859999f,-0.21209999f,-0.46020001f,1.17620004f,0.34060001f,1.22750007f,0.35800000f,0.19490000f,0.86090001f,-0.50399999f,-0.10230000f,-0.57490001f,-0.41119999f,-0.11020000f,-0.62540000f,0.18419999f,-0.14970000f,-0.51939999f,-0.17319999f,0.04510000f,-0.19730000f,-0.52480004f,-0.14040000f,-0.34420001f,-0.22059999f,-0.14890001f,0.14349996f,-0.51299996f,0.09919999f,-0.43460004f,-0.19419998f,-0.21290001f,0.01490007f,0.11879995f,0.01930002f,0.91769999f,-1.44299999f,0.55080000f,-0.06859999f,-0.13080000f,-0.01840000f,0.20429998f,-0.43620000f,0.11920000f,-1.16639998f,1.28399998f,-0.65280000f,1.07430002f,-1.75180003f,0.64340003f,-0.06250001f,-0.38779999f,0.00419999f,-0.44449997f,0.95959997f,-0.27770000f,-0.23879999f,0.74699998f,-0.16610000f,0.76779996f,-0.78219996f,0.40870000f,-0.18829996f,0.66939997f,-0.12779999f,-0.68570007f,0.16150003f,0.30940002f,0.13580000f,0.15010002f,-0.24660000f,-0.07830000f,-0.73140001f,-0.74400000f,-0.13919999f,-0.33440001f,-0.65040000f,-0.31740000f,-0.96140001f,0.54160000f,0.28640000f,0.93240003f,-0.42960003f,-0.30360001f,-0.55720003f,0.16740000f,0.15300000f,0.69750001f,0.65720003f,0.21640001f,0.46540003f,-0.73260001f,-0.19260000f,-0.94290002f,0.14040000f,-0.05010000f,0.42710000f,0.12320001f,0.25270001f,0.73210002f,0.47720000f,0.18730000f,0.15890001f,0.58080003f,0.28110001f,0.74290003f,-0.27620000f,-0.07870000f,-0.76820003f,-0.64920001f,0.34010003f,0.38610002f,-0.17980002f,0.20560001f,0.11760003f,0.57239998f,0.01860001f,-1.02999999f,1.21240000f,-0.57820001f,-0.33460000f,0.56199998f,-0.21400000f,0.17439998f,-0.43959999f,0.12739999f,-0.23540005f,-0.06499998f,-0.12830001f,-0.26790000f,-0.06520000f,-0.11670001f,0.74680003f,-0.75940001f,0.41910002f,-0.54989999f,1.26200000f,-0.35190001f,-0.03290001f,-0.73200001f,0.02410001f,-0.41569998f,0.43700000f,-0.21180001f,0.65730000f,-0.33519999f,0.34910000f,0.38270003f,-0.45460001f,0.22880001f,0.09120003f,0.65399999f,0.00100001f,-0.65280000f,-0.91480002f,-0.58860002f,-0.13020000f,0.12590000f,0.46320002f,0.09840001f,-0.13320000f,0.74720003f,0.32050001f,0.86390004f,0.79199998f,0.24959999f,0.99320000f,0.25620002f,0.30360000f,0.87930002f,-0.83120000f,-0.32830000f,-0.80090002f,-0.03480000f,-0.21330000f,-0.65650001f,-0.09360001f,-0.12150000f,-0.54690003f,-0.49380004f,-0.33270001f,-0.81980005f,0.70640000f,0.09250000f,0.04870002f,0.55960001f,0.13760000f,0.38380002f,-0.81420003f,-0.30030001f,-0.71360004f,0.15340001f,0.07700000f,-0.09149998f,0.62900000f,0.39130000f,0.92200002f,0.33420001f,-0.20519999f,-1.08590003f,0.68120001f,-0.57350002f,0.88080004f,-0.53640001f,0.46380003f,0.57630002f,-0.71360001f,0.34010001f,0.59499997f,-1.17619996f,0.37209999f,-0.30569996f,0.28719997f,-0.14670000f,-0.76830000f,0.83419998f,-0.44060000f,0.50229999f,-0.50200000f,0.25990001f,0.27810001f,-0.03820000f,0.12960001f,-0.14920005f,0.08280003f,-0.09700002f,1.18809998f,-1.18619998f,0.65040001f,0.66540000f,-0.83799999f,0.37960001f,-0.81280004f,0.87220002f,-0.46270002f,0.30610002f,0.03379998f,0.15080001f,0.29200002f,-0.18259999f,0.17549999f,0.73980002f,0.34190003f,0.23720001f,0.11440000f,0.40060001f,0.13300000f,0.04790000f,-0.23460000f,0.34460002f,0.18460000f,-0.26190000f,-0.44320002f,-0.26750001f,-0.20890002f,0.04320002f,0.04680001f,-0.50519998f,-0.36440002f,-0.28180000f,-0.74520004f,-0.56980001f,-0.12170001f,0.05919997f,0.10500000f,0.19950000f,0.77420003f,-0.55900001f,-0.08060000f,0.00829999f,-0.00240000f,-0.05610000f,-0.16110001f,0.30679999f,0.01420000f,0.05080001f,0.56100002f,0.27270000f,0.64940003f,-0.12740000f,-0.09970000f,-0.44000001f,-0.20399999f,-0.00900000f,-0.67660002f,-0.29740001f,0.15080002f,0.08680001f,-0.23540000f,0.06270000f,0.38500001f,0.02620000f,0.18770000f,0.72290006f,0.15299997f,0.35200002f,-0.52530004f,-0.05439999f,-0.26710001f,0.41880002f,0.35279999f,0.18480001f,0.00639997f,-0.02319997f,-0.01240000f,-1.00820001f,0.70880000f,-0.53700001f,-0.45500000f,0.23100000f,-0.22190001f,-0.97050001f,0.88419999f,-0.52660002f,0.13590000f,-0.15259999f,0.07140000f,0.50619998f,-0.63979997f,0.28350000f,0.41800003f,-0.40040001f,0.24220001f,0.13140001f,0.07560000f,0.05320001f,0.12400005f,0.74499997f,0.01570001f,-0.27310001f,-0.72150002f,1.03520001f,0.35440000f,1.20960005f,0.16260002f,0.17820001f,0.44710001f,0.51480004f,0.19620001f,-0.08879995f,1.03660001f,0.21770001f,0.18580001f,0.33499999f,-0.01940000f,-0.44870002f,0.32420002f,0.24160000f,0.47050002f,-0.66360001f,-0.13950000f,-0.58430002f,-0.41980001f,-0.15380000f,-0.08450002f,-0.55780000f,-0.18740000f,-0.11670001f,-0.07240000f,0.02350000f,0.00310000f,0.48800000f,0.07270000f,0.45690002f,-1.07440000f,-0.31430000f,-0.86850003f,-0.83900002f,-0.40660001f,-1.29930004f,-0.17539998f,-0.00160000f,-0.53289999f,0.54540002f,0.22640000f,0.82879998f,-1.37439997f,0.50320000f,-0.10809997f,0.17579999f,-0.05200000f,0.89820004f,-0.25780003f,0.46170002f,1.62540002f,-1.45019998f,0.88510002f,0.92950001f,-0.59719999f,0.48390002f,0.13630004f,0.07719996f,0.07590001f,-0.70689999f,1.15779999f,-0.41860001f,-0.62270002f,0.31400000f,-0.32910001f,-0.83170000f,0.49119999f,-0.44270000f,-0.14209999f,0.25719999f,-0.08250000f,0.51349997f,-0.99139997f,0.31120000f,-1.16109998f,1.46179997f,-0.66680000f,-0.39050002f,0.76620000f,-0.25840000f,0.06890003f,0.64239996f,-0.00449999f,0.24310000f,-0.78990001f,-0.05379999f,0.14710000f,0.67960000f,0.07760001f,0.00580000f,-0.44660000f,-0.93020002f,-0.32200001f,-0.92630004f,-0.58700000f,-0.19150000f,-0.31080001f,-0.02599999f,0.17870000f,0.52630001f,0.34320000f,-0.04109999f,-0.44809999f,-0.16920000f,-0.06330000f,0.44710001f,0.18540002f,0.17520001f,0.52510002f,-0.60579999f,-0.04100000f,0.13250001f,0.13260000f,0.04890000f,-0.11540000f,-0.24760002f,-0.17240000f,-0.35380002f,1.12000001f,0.25190000f,0.56810003f,-0.08280001f,-0.08250001f,0.05149999f,0.37420002f,0.28820001f,0.38250002f,0.43480003f,0.31890001f,-0.64819998f,0.40519998f,-0.32880000f,0.45640001f,0.07459999f,0.21690001f,-0.85830000f,1.14059999f,-0.50180001f,-0.74299999f,0.63399998f,-0.40840000f,-0.50249999f,0.55360000f,-0.26510001f,0.95329999f,-0.70739997f,0.50060001f,-0.59530003f,-0.11680000f,-0.28510001f,-0.12189998f,0.07439999f,-0.05290000f,-1.16069999f,1.09339996f,-0.62860001f,0.29840001f,-0.02760000f,0.14900000f,-0.11340003f,-0.01039997f,-0.06460001f,1.48549999f,-1.67779999f,0.83280001f,-0.14870003f,-0.19259999f,-0.06560001f,0.26830005f,0.20799998f,0.13490001f,0.86620004f,0.25250001f,0.64800003f,0.33210001f,0.95070005f,-0.41619999f,0.06520000f,0.36270001f,0.02220001f,0.07620000f,-0.08949999f,0.08980001f,0.09440000f,0.22930001f,-0.01660000f,-0.04490000f,-0.09140000f,0.06160000f,0.05840000f,0.42559999f,0.48680001f,0.22870000f,0.42750001f,-0.50460000f,-0.09480000f,-0.39630001f,-0.01260001f,-0.05700000f,-0.63410003f,0.39980000f,-0.02810000f,0.05640000f,0.15880000f,0.26900000f,0.77480000f,0.14420000f,-0.01070000f,-0.43959999f,-0.91559999f,-0.17070000f,-0.16589999f,-1.05740000f,-0.29170000f,-0.85740002f,-0.55260003f,-0.07740000f,0.33150002f,-0.48920002f,0.20910001f,-1.03329997f,1.01219996f,-0.55580000f,0.07030003f,0.31799996f,0.01990001f,-0.04529998f,0.08879998f,-0.02149999f,0.05560000f,-0.10840000f,0.03060000f,-0.22060000f,-0.09859999f,-0.09750000f,0.46370002f,-0.31380001f,0.25660001f,-0.57689999f,0.90439999f,-0.33810000f,0.45710002f,0.09980000f,0.21200001f,0.68719999f,-1.02620000f,0.39130001f,-0.38979998f,0.40660000f,-0.19650001f,0.57780000f,-0.14520000f,0.28760000f,-1.44389999f,1.37319995f,-0.78990001f,-1.14859999f,1.51459998f,-0.66250001f,-0.44740005f,-0.67170000f,-0.61280001f,-0.16900000f,-0.25900002f,-0.61880000f,-0.15520000f,0.15419998f,-0.22159999f,0.05360000f,-0.09160000f,-0.09980000f,0.07130000f,0.49280002f,-0.39720000f,-0.13740000f,-0.44400000f,-0.44140001f,-0.14540000f,-0.06210002f,1.04160001f,0.34950000f,1.32610004f,0.73620003f,0.37650001f,0.89480004f,-0.39300001f,-0.02190000f,-0.17220002f,0.13040000f,-0.02150000f,-0.10650000f,-0.52240001f,-0.16940000f,-0.93100003f,0.10140001f,0.14280000f,-0.09850000f,0.89580001f,0.18000000f,0.49190002f,-0.57860000f,-0.18640000f,-0.40890001f,0.80340004f,0.60609999f,0.45650001f,-0.28909998f,-0.78849997f,-1.17800003f,0.48229996f,-0.24500001f,0.31850001f,-0.48559998f,-0.34209999f,-0.26800002f,-0.53690001f,0.51020001f,-1.01300000f,0.15260000f,-0.19660000f,-0.59099998f,0.70079998f,-0.36579998f,0.22699999f,0.77049999f,0.02440000f,-0.13400000f,1.17559999f,-0.42099997f,0.38400000f,-0.08550000f,0.26200000f,0.86250000f,0.11640001f,0.69929997f,0.23349998f,0.75890000f,0.78769997f,-0.79600001f,-0.42230002f,-0.44279998f,-0.91149999f,0.35800002f,-0.14330000f,0.96050003f,0.23380000f,0.90890001f,0.47050002f,0.09230002f,-1.19250000f,-0.03359998f,0.64360000f,0.05200003f,1.28269996f,0.02429999f,0.96070001f,-0.37449999f,-0.66110001f,0.53969998f,-0.81869999f,0.33310001f,-0.07180001f,-1.18219998f,0.26160000f,-1.17779998f,-0.78209995f,1.08850000f,0.37040004f,1.83039996f,0.15539999f,-0.67730002f,-0.47469999f,-0.27890002f,-0.23630000f,-1.02010000f,0.49750003f,0.72830000f,-0.05030000f,-0.38410000f,0.43279999f,-0.02719998f,-0.66620002f,0.57239997f,0.58319996f,0.33960004f,0.35260000f,-0.78639999f,0.16160000f,0.65310003f,1.14120001f,-0.15000001f,-0.34419999f,-0.30209999f,0.03949999f,0.43389999f,0.74049998f,-0.07749999f,0.67989997f,-0.26150000f,0.15750000f,-0.61139998f,-0.49790000f,-0.83249999f,-0.42779999f,-0.32589998f,-0.28349999f,-0.52559999f,0.19810000f,-0.55100000f,0.18409999f,0.76259997f,-0.48849998f,0.95319997f,-0.61530000f,0.87050000f,-0.21439999f,0.63510000f,-0.47200003f,-0.32720000f,0.24059999f,-0.03550000f,-0.29959999f,-0.44210000f,0.55350001f,-0.32519998f,-0.17009999f,-0.87300001f,0.31319999f,-0.58979996f,-0.46899999f,-0.43220000f,-0.15820000f,-0.29349999f,0.42790000f,-0.63970001f,-0.24500000f,-1.06500001f,0.47900001f,0.60490000f,-0.24490001f,-0.57600002f,0.61890005f,0.83110004f,0.24170001f,0.87399998f,-0.06360001f,0.19780001f,-0.42670002f,-0.99670003f,0.01720003f,0.51289997f,0.53650001f,-1.56340004f,-0.49159993f,1.18580003f,-0.26990001f,-1.28470002f,0.44290002f,0.04440001f,0.69990000f,-0.26010000f,-1.00429997f,0.22910002f,0.28429999f,-0.29479999f,1.08500000f,-0.34260003f,0.10770000f,0.38909998f,0.10330000f,-0.52829998f,1.47629998f,0.16109999f,-0.24629999f,0.68639999f,-0.12900001f,-0.11419999f,0.20329998f,0.59030000f,-0.71180001f,-0.57779998f,-0.03700000f,0.14470000f,-0.40100000f,-0.66700000f,0.72370002f,0.13900001f,-0.10049999f,0.39569999f,-0.31189999f,1.16350000f,-0.60370000f,0.13989999f,-0.71950000f,0.45129997f,-0.21390000f,-0.39450000f,0.44700002f,0.97430000f,-0.37400003f,-0.47980001f,0.32180000f,0.30450000f,0.27510000f,-0.09630000f,0.36999998f,0.41480000f,0.63459997f,0.66200003f,0.51820000f,0.10360000f,-0.21749999f,0.22079999f,-0.16689999f,0.17200001f,0.94279998f,0.10060000f,0.34800000f,0.36929999f,0.09060000f,-0.69099998f,0.33069997f,-0.07660000f,-0.14500001f,0.45410002f,-0.59500002f,0.21790001f,0.30010001f,-0.12490002f,1.80909998f,-0.02090001f,-1.00000001f,-0.11059998f,0.32560001f,0.69760003f,-0.10810003f,-0.91870005f,-0.20240001f,0.81260000f,0.34260001f,1.13620002f,0.02479998f,-0.23640000f,-1.09140001f,0.31110002f,0.46310000f,0.98289999f,1.17529996f,-0.56050000f,-0.47710001f,-1.10899997f,0.51880000f,-0.07290001f,0.59400002f,-0.10880001f,-0.50820001f,0.94710001f,0.16150002f,0.37089999f,-0.38469999f,-0.21550000f,0.11330000f,-0.17600000f,0.21760001f,0.30269998f,-1.45229998f,-0.32530000f,1.25659999f,0.56319999f,0.04600000f,0.33410000f,0.33400001f,0.11000004f,0.97899999f,-0.21219997f,0.31449999f,0.24740001f,0.68049999f,0.68900002f,-0.50570001f,-0.29620001f,-0.30399999f,0.58780000f,-0.06319999f,-0.53200000f,-0.28940001f,-0.78440000f,0.19950000f,0.53610000f,0.64629999f,0.00050003f,0.24220000f,-0.79929997f,-0.32100000f,-0.32009999f,0.42719999f,0.19350002f,0.29310001f,-0.02470000f,0.15949999f,0.65770001f,0.17590000f,0.01000000f,-0.35019999f,-0.15980000f,-0.36850000f,-0.04190000f,-0.09910000f,0.21050000f,-0.94159998f,0.09510000f,0.59350004f,-0.00000001f,-0.77890001f,-0.47599998f,-0.09880001f,-0.16050002f,0.99239999f,0.58760004f,-0.27970003f,1.36690001f,0.40870003f,-0.27600000f,-0.13919999f,0.89120001f,0.78410003f,0.01419997f,-0.89300003f,1.59539997f,-0.56610003f,-0.36409998f,0.09660002f,0.74459999f,-0.17240000f,0.69670001f,1.02589998f,-0.39250001f,-0.72580004f,-1.64299998f,0.44240000f,0.20400001f,0.14100000f,0.34300000f,-0.12760001f,2.14450000f,0.09430003f,0.12789999f,-1.10439998f,-0.39380001f,0.20580000f,1.23389997f,-0.29330000f,0.65969999f,-1.00079997f,0.17920001f,-0.32929999f,0.66469997f,0.70950000f,-0.13409999f,0.67129999f,-0.65750001f,0.75830000f,-0.17649998f,-0.33649999f,0.92000001f,-0.11509998f,-0.96399999f,0.28239999f,0.03600000f,0.59050000f,-0.44890001f,-0.38570001f,-0.70149999f,-0.73669999f,-0.99229996f,0.15049999f,0.31839999f,-0.16070001f,-0.00699999f,0.27580000f,-0.60039999f,-0.03349999f,-0.58120000f,0.71610001f,-0.60199999f,0.15139999f,-0.24600000f,-0.04100000f,1.19690001f,-0.29179998f,0.42799999f,-0.74569998f,0.17819999f,0.22550001f,0.51609999f,-0.29809998f,-0.71849999f,-0.60029998f,-0.34989999f,0.61550002f,0.83710002f,0.79110002f,0.89609999f,-0.17890000f,0.46340001f,0.54129999f,-0.12950000f,-0.41489998f,0.38009997f,0.56810001f,0.84040000f,-1.27990003f,-0.32030000f,-0.28210003f,2.14330000f,-0.03449998f,0.11720000f,-0.43940000f,-0.32920001f,-1.42260001f,-0.57419997f,1.10700005f,-0.43590001f,1.61670002f,0.08049999f,-1.03459999f,1.46570001f,0.10109997f,0.08650001f,2.47790004f,-0.19990001f,-0.43890000f,0.07590003f,-0.32670003f,0.91209998f,-0.64630000f,-0.18549998f,-0.79259999f,-0.20429998f,0.53810001f,0.30780000f,-0.13740000f,-0.05399999f,0.49950003f,0.16700000f,-0.35650000f,0.26080000f,-0.69270000f,-0.17649999f,0.15310000f,-0.40329999f,-0.44000001f,0.47599997f,0.11779999f,-0.19550001f,-0.95350001f,-0.32830000f,0.24250001f,1.18280001f,-0.15129997f,0.34750000f,-0.36819999f,0.05910000f,-0.39500005f,0.34880000f,0.90219998f,0.20850004f,0.97200000f,0.02630001f,0.62600002f,1.01589999f,0.48519999f,0.18450002f,1.23240002f,-0.44249999f,0.75350002f,0.01540001f,0.37729999f,-0.42900001f,-0.58499998f,-0.51719998f,-0.11750002f,0.22910000f,0.49969998f,-0.15650001f,-0.15160000f,-0.19010000f,-0.02699999f,0.67800002f,0.70559999f,-0.17700004f,-0.24880000f,0.34180001f,-0.45010001f,-0.01930000f,0.79799998f,-1.64759999f,-0.08139998f,-1.03130004f,-0.49539998f,0.47980002f,-0.26460000f,-0.91679998f,0.30460000f,0.30360000f,0.55799997f,-0.36780000f,0.11129999f,-0.21390003f,-0.80850001f,0.67210000f,-0.25840002f,0.17860002f,-0.35000001f,0.04789999f,-0.11690000f,-1.55350003f,-0.52999996f,1.07100001f,-1.09959999f,0.94120002f,0.45060000f,-1.34520003f,-0.17039995f,0.45300001f,0.36740001f,0.95979998f,0.17600001f,-0.55980001f,-0.36120000f,0.26360000f,0.12900000f,0.63039998f,-0.19549999f,-0.31660001f,-0.43269998f,-0.22550000f,-0.31270001f,-0.16910000f,-0.47550002f,-1.05959998f,-0.28549999f,0.13750000f,0.10130001f,0.73610001f,-0.19850000f,-0.33220000f,0.28469999f,0.25450000f,0.11239999f,-0.23869999f,0.97949999f,-0.40980000f,0.12690000f,-0.73100002f,-0.20830001f,-0.48519999f,0.41250000f,0.05430000f,0.27250000f,-0.25099999f,0.38570000f,0.99800000f,0.21850000f,0.86840000f,0.54769999f,0.40349999f,0.32640002f,0.91590000f,-0.50849999f,0.49799999f,-0.46929999f,0.07100000f,0.00700000f,0.41460000f,-0.86250000f,0.16280000f,0.37520001f,-0.48739998f,0.38880001f,-0.32770003f,0.91450003f,0.73610004f,-0.01219998f,1.40419997f,0.53640000f,0.10860001f,0.52769999f,-0.31050001f,0.10380000f,-0.37979999f,0.52640002f,-0.95749999f,0.34549999f,0.34349999f,0.52039999f,0.64749998f,0.02230001f,-0.23030000f,-1.75299999f,0.40040003f,-1.09850003f,-0.95349999f,0.53950002f,-0.66769999f,1.30340000f,0.28820000f,-1.06840000f,1.06840002f,0.21979998f,-0.12409999f,-1.05460000f,0.53640003f,-0.81680000f,0.12380002f,0.46960001f,-0.16330001f,-0.34460000f,0.17600001f,0.87809999f,0.08360000f,-0.78550000f,-0.20060000f,-0.27390000f,-0.72800000f,0.80000002f,-0.07259998f,-0.70249999f,0.93079997f,-0.34409999f,0.32400000f,0.15390000f,-0.10320000f,-0.76550001f,-0.04360000f,-0.12310000f,0.25700001f,0.48759998f,0.56799999f,-0.41849999f,0.24989999f,-0.49529998f,-0.34500005f,-0.75090000f,0.38159998f,0.11149999f,-0.10880000f,0.85050000f,0.10950000f,0.92129999f,0.20490000f,0.49750002f,0.85160000f,0.55230000f,-0.60600004f,-0.35430001f,0.15619999f,-0.01150001f,0.38500000f,0.47609999f,-0.10800000f,-0.09150000f,0.14060000f,-0.96549998f,-0.28040001f,-0.18970003f,-1.12460002f,-0.64380001f,-1.29100002f,-0.30109991f,1.06010003f,0.95080001f,-0.04509999f,-1.01930003f,0.22689999f,-0.44229999f,0.36110001f,-0.19719998f,-0.68150002f,-0.77290004f,-0.04450000f,-0.42949999f,0.27350001f,0.09860002f,-0.89300001f,-0.21580002f,0.12620001f,0.41589999f,0.09350000f,-0.31020000f,-0.31470000f,0.18530001f,0.46820001f,0.02740000f,-0.26800001f,0.36430001f,0.35960000f,0.21000001f,-0.61859998f,1.44509999f,0.31970000f,1.27090004f,-0.56740002f,-0.30580003f,-0.26150001f,0.23839999f,-0.15740001f,-0.54830000f,-0.59279998f,0.99149999f,-0.77910000f,0.46690000f,-0.43250001f,0.45230003f,0.76949999f,0.63300001f,-0.55589998f,-0.47060000f,-0.63950000f,-0.15700000f,-0.16729999f,1.16400000f,-0.58590001f,0.42439998f,-0.32350000f,-0.12680000f,0.04750000f,0.21500000f,-0.56720001f,0.12579998f,-0.21850000f,0.22809999f,-0.18290000f,-0.01150001f,-0.04370000f,0.24090000f,0.00450000f,-0.16800000f,-0.28990000f,-0.54750001f,0.19109999f,-0.37210000f,0.03100000f,0.99769998f,0.13819999f,-0.53749998f,-0.65410002f,-0.76730001f,0.39900000f,0.12450000f,0.18400000f,0.80199999f,-0.76200002f,-0.74220001f,-0.14579997f,0.98040004f,0.02310000f,-0.21029999f,-0.16650000f,-0.23760003f,-2.35499998f,0.21080002f,1.22999999f,-1.09890000f,-0.33609999f,1.35479996f,-0.76260001f,-0.50479999f,0.39640000f,-0.14620001f,0.06100001f,0.09930002f,0.61920003f,0.79340003f,-0.28610002f,-0.58240000f,-0.81380002f,-0.32179997f,0.76339998f,0.81000002f,-0.27239999f,-2.04179994f,0.38499999f,0.37829998f,0.95549999f,0.02810002f,0.47880003f,1.38269998f,0.34490000f,-0.21580005f,-1.71709998f,0.28650001f,0.91260003f,0.73980000f,-0.15160000f,0.97790001f,-0.66639998f,-0.73550002f,0.40040001f,0.35890000f,0.20250000f,-0.17279999f,0.05430000f,-0.08750002f,-1.13379999f,0.52969999f,-0.46450000f,-0.93889999f,-0.64049999f,-0.33749998f,-0.84179998f,-0.75309996f,-0.37300000f,-0.13460000f,-0.27780000f,-1.11800002f,0.57890001f,-0.34660001f,1.28299999f,-0.52969999f,0.48120000f,-0.82850001f,0.74359997f,-0.06690001f,-0.29200002f,-0.90139998f,0.46479997f,-0.32249999f,0.44340000f,-0.44509997f,-0.81499999f,0.75829997f,-0.65860000f,-0.20649999f,-0.77329998f,0.38910002f,-0.48150000f,0.16320000f,-0.76070001f,-0.44100001f,-0.73540002f,-0.20090002f,-0.88450004f,-0.65830003f,-0.82990002f,-1.32170001f,0.80090003f,-0.50149998f,0.72109998f,0.43190000f,0.10839999f,1.88419995f,-0.09239998f,1.27580002f,-0.65450001f,-0.54790002f,0.49750002f,-0.51910004f,-0.65990003f,1.00220001f,-1.08290002f,-0.38470001f,0.18609997f,-1.09539998f,-0.49340000f,-0.77789997f,1.16579998f,0.19439998f,-0.46629999f,-0.54860002f,-0.66300004f,-0.77709999f,0.10930002f,-0.19450001f,-0.09180001f,-1.23149998f,-0.48410001f,-0.51290001f,-0.00760000f,-0.23120001f,1.23160001f,-0.59890002f,-0.14590001f,0.63569998f,-0.21700000f,1.01750002f,-0.65420001f,0.43730001f,-0.42850003f,-0.26840001f,0.66130000f,-0.19899999f,0.62799998f,0.15200000f,0.03050001f,0.94899999f,-0.38029997f,-0.22299999f,-0.78350000f,-0.70460000f,0.50000000f,-0.59720002f,-0.13500001f,-0.23200000f,-0.90230000f,-0.46640000f,0.51549999f,-0.78609997f,0.15530001f,0.31500001f,0.83789997f,0.32879999f,1.21850000f,-0.42530001f,0.57509998f,0.83049998f,0.14420001f,0.59069998f,0.70999999f,-0.80089998f,0.37959999f,0.68350001f,0.01790000f,0.42530000f,-0.71799999f,-0.60890001f,-0.76719999f,0.71749999f,-0.02439999f,-0.95550001f,-0.50339990f,1.00940002f,0.42770001f,1.32159997f,-0.43120000f,0.81180004f,1.24559999f,-0.72100003f,-0.28220001f,1.62170001f,-0.15610001f,0.46020000f,-1.49430002f,-0.05929998f,0.46480001f,-0.62800002f,0.07660001f,1.30940002f,0.28359997f,-0.63980001f,-0.50170000f,-0.07849996f,-0.39690003f,0.38950004f,1.24339999f,0.13259999f,0.36500000f,-0.37910001f,-0.05290001f,-0.30120000f,0.61170002f,0.77690002f,0.31120002f,0.97489997f,-0.47750000f,0.08980000f,0.80779999f,-0.29420001f,0.01760000f,0.87639999f,-0.15920001f,-1.29790002f,-0.55790000f,-0.61350002f,0.26190004f,0.56949998f,0.24150001f,0.47249999f,-0.44589999f,0.33750001f,0.25860000f,-0.65210001f,0.40500003f,0.86430001f,-0.03659998f,-0.25500003f,-0.90450000f,-0.06940001f,-0.44150001f,-0.39880001f,-0.24910000f,-0.13249999f,-0.32260001f,-0.86929999f,0.89300001f,-0.07819998f,0.46439999f,-0.46950000f,0.62969998f,-0.52450001f,-0.19899999f,-0.29090001f,-0.19100000f,-0.79950000f,0.64770000f,-0.04909999f,0.39049999f,0.29529999f,-0.29190000f,0.31500001f,0.31200000f,-0.14059999f,0.19100002f,0.40839999f,-0.12819999f,0.27150001f,-0.53390000f,0.53060001f,-0.77750002f,-0.33530002f,1.29380002f,-0.28430005f,-0.55810002f,-0.11920003f,-1.42609998f,-0.38130000f,1.18869998f,-0.43030001f,-0.03129999f,0.09700001f,0.16399999f,0.38200001f,0.40609999f,-0.77419998f,0.19840001f,-1.47730001f,-0.63139999f,0.98380002f,-0.23490002f,-0.64949999f,0.28670000f,-0.36950002f,-0.58840003f,-0.27660001f,0.25919999f,-0.35520000f,-0.61440001f,-1.08310001f,0.08410003f,0.31570001f,0.15070001f,0.09559998f,-0.26120001f,-0.91680002f,-0.31500000f,0.94140005f,-0.14699999f,1.19039999f,-0.19140001f,0.18529999f,-0.37730000f,0.05100000f,-0.63090001f,-0.18420000f,-0.22499999f,-0.59370002f,-0.77859999f,0.59649999f,-0.86409998f,0.41090000f,-0.83749999f,-0.47199999f,-0.78889997f,-0.57400001f,0.19779999f,-0.18000000f,-0.55699999f,-0.42369999f,-0.20719999f,-0.19250001f,0.28729999f,0.97809999f,-0.19849999f,-0.20200000f,0.22130001f,0.64000001f,-0.33430001f,0.42900001f,0.61599999f,-0.44799998f,0.00160000f,0.38799999f,0.36380001f,0.71019999f,0.23050000f,-0.06730001f,-0.07090000f,-0.55400004f,0.33140000f,0.52360000f,0.35350001f,0.59659999f,-0.05450000f,-0.57850000f,-0.66300003f,0.60859998f,0.58989998f,0.41630001f,-1.30730001f,-0.58389999f,0.90930003f,-0.51750001f,-1.45589998f,0.57890002f,0.44560000f,-0.56260001f,-0.02220000f,0.28750002f,-0.86470002f,-0.80430002f,0.79129998f,0.04059996f,0.21100002f,-0.07690000f,1.97050001f,0.12470003f,0.75450000f,-1.22400002f,-0.22399998f,0.50980001f,1.26200000f,-0.56840002f,0.12080001f,0.41650000f,-0.10390000f,-1.08760003f,-0.33170000f,0.13250000f,0.40050001f,-1.91489999f,0.10689998f,0.21900000f,-1.07700000f,-0.18700001f,0.02270001f,2.02540002f,-0.28200002f,0.74959998f,-0.05500000f,-1.00049997f,0.33569999f,-0.63369996f,-0.22100002f,0.25399999f,0.86159999f,-0.36800002f,-0.47620000f,0.50299999f,-0.29800001f,-0.39380001f,-0.22520000f,0.84699997f,-0.78880001f,0.10799998f,-0.86350000f,-0.06170001f,-0.63009997f,-0.11750001f,1.10480001f,-0.30569999f,-0.25850002f,-0.87430000f,-0.29550000f,0.36100002f,0.37820000f,-0.46659999f,0.04450000f,0.16250000f,-0.13710000f,0.63400001f,0.08150000f,0.82320001f,-0.42650000f,-1.06000001f,0.01049999f,0.08900000f,-0.67880000f,0.06300000f,0.34200004f,0.97650001f,-0.30139999f,0.40950002f,-0.74110001f,0.76940001f,-0.08660001f,0.13740001f,-0.99549999f,0.76210000f,0.42990000f,0.17659999f,1.24270002f,0.61450004f,-0.23499999f,-1.62470001f,-0.33030003f,0.15379999f,-0.95929998f,-0.73410002f,-1.49359999f,-0.53169995f,1.15950004f,-0.52759999f,0.87979998f,0.23600000f,-1.29440003f,0.01130001f,0.21090000f,1.52970002f,0.52110002f,-1.17070004f,0.86109999f,0.41329994f,-0.58110001f,0.13870000f,-0.26620001f,0.24860001f,0.41580000f,-0.60690001f,-0.10349999f,0.17320000f,1.21999996f,-0.44860000f,-1.27739999f,-0.32609995f,0.38029999f,-0.19460002f,-0.50609999f,-0.75000001f,-0.15000001f,-0.57679999f,0.16950001f,0.74579998f,0.50649999f,-0.94400000f,0.83450001f,-0.47119998f,0.61649999f,-0.92970001f,0.51849998f,0.85450000f,-0.78909998f,0.20689999f,-0.41150005f,0.40310001f,0.93569997f,0.07650000f,0.65099998f,0.18570000f,0.68250000f,0.33090001f,0.89930000f,0.39950003f,-0.41959998f,-0.95789999f,0.12200002f,-0.14600001f,-0.57619997f,-0.42750001f,-0.08430001f,-0.10890000f,-0.16900001f,-0.43910000f,-0.17860000f,0.45350001f,0.46239999f,-0.23889998f,0.44949999f,0.20570001f,0.90829997f,1.07400002f,-0.34980000f,-1.21479998f,0.17620003f,0.60120000f,-0.18280001f,-0.47329997f,-0.52430000f,0.47230001f,-0.15730000f,0.04790001f,-0.23100000f,1.63229999f,-0.03530000f,-1.04169999f,0.63430003f,0.04229997f,-0.07280000f,0.11030001f,-0.62890001f,-1.35569997f,0.84390002f,0.27669998f,0.10219999f,-0.13519997f,0.35860000f,-0.40650000f,1.13490002f,-0.11090002f,1.66210001f,-0.12339999f,-0.69440000f,0.10510000f,0.04460002f,0.39660001f,-0.72669998f,0.07300005f,0.02259999f,0.32870001f,0.84910002f,-0.73570004f,-1.19569998f,-0.19749996f,1.08510001f,-0.89520001f,0.07670001f,0.46709997f,0.77799996f,0.44840000f,0.30929999f,-0.77229997f,0.12730003f,0.06949999f,0.66329997f,0.53849999f,-0.57890000f,0.05689999f,0.50290000f,0.15540001f,-0.47199999f,0.39519998f,0.50339998f,-0.62459998f,-0.34140001f,0.28790000f,-0.49470000f,-0.97590000f,0.74389997f,-0.75799999f,-1.06240002f,-0.20240000f,0.11470000f,-0.20050000f,-0.41479997f,-0.02629999f,-0.84190001f,-0.25729996f,-0.82979998f,-1.29780002f,0.11839998f,0.17070000f,1.03950003f,0.20070001f,-0.60710000f,0.09529995f,-0.51419999f,-0.16729999f,-1.11010003f,0.48059998f,-0.49599999f,-0.21220000f,0.05700000f,0.24930000f,-0.01649999f,-0.24200001f,-0.31570000f,0.36860000f,0.14219999f,-0.21600000f,-0.87639998f,-0.45979998f,0.66319999f,-0.39629998f,-0.01879997f,0.53359998f,-0.92079999f,-0.23679998f,0.84849998f,-0.39269999f,-0.60960002f,-0.26400000f,0.82880000f,0.67820001f,-0.29900000f,-0.63970003f,-0.16780000f,0.65140002f,0.11320000f,-0.03220001f,-0.12500000f,0.72530001f,0.37280000f,-0.45920001f,-0.84900002f,-0.69360000f,0.29400002f,-0.49879999f,-0.21239998f,0.45299999f,-0.14159999f,-0.38140002f,-0.26630001f,-0.29160000f,-1.08650003f,-0.35669998f,-0.64759998f,-0.82360001f,0.44299999f,-0.43019997f,-0.60659998f,0.12490000f,0.75849997f,0.82250001f,0.03189999f,0.10569999f,1.01209998f,-0.35399999f,0.18330000f,0.63329999f,-0.49299997f,-0.72829997f,-0.27550001f,0.78139998f,-0.65729996f,-0.56249999f,-0.49589999f,0.25690000f,-0.44950000f,-0.31589999f,-0.06920000f,0.48320002f,0.19689999f,0.41209998f,0.54250001f,0.01900000f,0.56709998f,0.17389999f,0.50159997f,-0.35340001f,0.32099998f,-0.07340000f,0.19280000f,0.77200000f,0.60530000f,-0.16259999f,-0.05940000f,0.37060000f,-0.70559999f,0.08920000f,-0.12400001f,-0.25010000f,-0.85780001f,-0.53400001f,0.40289999f,-0.02159999f,-0.20180001f,-0.22930000f,1.35430000f,0.85280000f,-0.70369999f,-0.79570000f,-0.56680000f,0.33490000f,-0.81050001f,-0.16439999f,0.74939999f,-0.54730002f,-0.06139999f,0.66680002f,0.39149999f,0.10439998f,-0.40769999f,0.21909998f,0.24019998f,-0.08660000f,0.74640002f,0.29919999f,-0.67780001f,-0.20739999f,-0.20780000f,0.01340000f,0.15390000f,-0.08780002f,-0.40660000f,0.37830000f,0.14219999f,-0.36809999f,-0.80599998f,-0.49919998f,0.43109999f,-0.39840001f,0.46620001f,0.33819999f,0.05630000f,0.03070001f,0.15120001f,-0.90470001f,-0.55030006f,0.36869999f,-0.20219999f,-0.25740000f,-0.28200000f,0.90560000f,0.06040004f,0.29459999f,-0.56119997f,-0.06879998f,-0.53559997f,-0.95470000f,-0.73430007f,-0.42790000f,0.05260000f,0.57140002f,0.18660000f,-0.03060000f,-0.40860000f,-0.27509997f,-0.43959998f,-0.91279999f,0.15320000f,-0.14819998f,-0.93540001f,0.19389999f,-0.18709999f,-0.07030000f,0.29770000f,-0.68399997f,-1.17480000f,0.09210000f,-0.16769999f,-0.61529999f,0.15219999f,-0.51969997f,-0.00770000f,-0.71859997f,-0.19609999f,-0.06460001f,0.01200000f,0.04170000f,0.18530003f,-0.18740000f,-0.54760001f,0.14029998f,0.25199999f,0.04380000f,0.93340003f,0.47160001f,-0.58650001f,-0.35280000f,-0.32240001f,0.02300000f,-0.36420000f,-0.39080000f,0.09500000f,0.00910000f,0.11360000f,0.02410000f,0.26740002f,-0.19260000f,-0.54600000f,-0.52269999f,-0.04659998f,0.62889999f,0.23420001f,0.04660000f,-0.27790001f,0.11869998f,-0.01920002f,-0.25589999f,0.07270000f,0.05540000f,0.01720000f,-0.40600000f,-0.22819999f,0.26990000f,0.23680000f,0.35020002f,0.19460000f,0.98070004f,-1.39430003f,-0.10660000f,-0.38450000f,-0.53890002f,0.53069997f,-0.59659999f,-1.04980004f,-0.37419998f,-0.35810000f,-0.72010002f,0.04479999f,0.82070001f,0.36550004f,0.25759999f,-0.55020000f,-0.48300003f,0.42259999f,0.34140000f,0.91500003f,-0.24399998f,-0.61179999f,-0.97220002f,0.65949996f,0.17989999f,0.07750000f,-0.43909999f,-0.09290000f,0.32269998f,0.13810000f,-0.12560000f,-0.40720002f,0.13440000f,-0.50780000f,-0.88420002f,-0.02070000f,0.34219998f,0.45460000f,0.03870000f,-0.08540000f,0.26420000f,-0.41990000f,0.76249997f,0.90730000f,0.46959998f,-0.00230001f,0.62260000f,0.57060001f,-0.16830000f,-0.74000002f,-0.59100001f,0.20010001f,-0.38020001f,-0.42420002f,-0.09180000f,-1.16959998f,-0.63199998f,0.74479998f,0.84500000f,0.38459999f,-0.57389999f,-0.48789999f,-0.42959998f,0.26970000f,0.22849999f,-0.00840002f,-0.32879999f,0.19030001f,-0.16980001f,-0.43560000f,-0.27229998f,0.23320004f,0.64039999f,-0.63879999f,-0.43599999f,0.31779999f,0.02779998f,-0.33960004f,-0.53909999f,0.46490000f,0.45140001f,-0.00830000f,0.36110001f,-0.03120001f,-0.53910000f,-0.72879999f,-0.35779998f,0.61069998f,0.68380002f,-0.28140000f,-0.49749998f,0.10880000f,-0.47840000f,0.38849999f,-0.78340000f,-0.45620003f,0.42049999f,-0.79250001f,-0.81490006f,0.04240000f,-0.65439998f,0.12639998f,0.12589999f,0.77500000f,0.38780005f,0.39119996f,0.69999997f,1.58360000f,0.24240000f,-0.10189999f,-0.35589999f,0.53109998f,0.06080000f,-0.04279999f,-0.73199999f,0.10010000f,0.35169998f,0.20720000f,-0.26779999f,0.22340000f,0.66439999f,-0.79190001f,-1.18630004f,-0.39449999f,0.67209998f,0.55010001f,0.41879998f,-0.15620000f,-0.55180001f,-0.01250000f,0.29739998f,1.16059998f,0.13810000f,0.65720000f,-0.19580000f,-0.39140002f,-0.18700000f,-0.07689999f,-0.20960001f,-0.13570000f,-0.57470001f,-0.34740000f,0.28140001f,-0.10450000f,0.03640002f,0.29810001f,0.31920000f,-0.14260003f,-0.69379999f,0.40210000f,0.29920000f,-0.13660000f,-0.78480005f,-0.15560001f,0.74120002f,0.22220003f,-0.08540001f,-0.49060002f,0.56460002f,0.23439999f,-0.59410001f,0.34780001f,-0.23900004f,-0.83020002f,0.77220002f,0.51260001f,-0.42680002f,-0.32630001f,-0.21740000f,0.26240001f,-0.31430002f,-0.03360001f,0.31230001f,-0.11970001f,-0.09320000f,0.07400000f,0.11070001f,-0.02740001f,0.57609999f,-0.03970000f,0.17950001f,0.33719999f,-0.01040000f,0.08840000f,0.08070000f,-0.60759997f,-0.37279999f,-0.14140001f,0.78519999f,1.29680004f,0.57129998f,-0.72030001f,-1.36590005f,-0.16860000f,0.40489999f,0.21970001f,-0.52219997f,-0.84780001f,-0.59340002f,0.36310000f,-0.65629999f,-1.19230005f,0.07220001f,-0.71429997f,-1.63830002f,0.79430000f,-0.65110000f,-1.26710005f,-0.22989999f,0.14850000f,-0.53790002f,0.12409999f,0.48919997f,1.07920000f,-0.27119998f,-0.45219999f,-0.41660000f,0.07000000f,0.13229999f,0.32550001f,0.38070000f,0.46130000f,-0.08089999f,-0.12239999f,0.02220001f,-0.20630000f,-0.09519999f,0.19930000f,-0.45170001f,-0.09999999f,0.59680001f,-0.08740001f,0.18820001f,0.27590000f,-0.32770000f,0.00440001f,0.44619999f,0.38310000f,0.08559999f,-0.39279999f,1.13519999f,0.69779999f,-0.62039998f,-0.70510002f,-0.47540000f,0.41030001f,0.39950000f,0.28200000f,-0.21089999f,-0.64589999f,-0.06099997f,0.66189998f,0.05910000f,0.03439999f,-0.16160001f,0.16529999f,0.32880000f,0.07800000f,-0.45769999f,-0.49560001f,-0.00840000f,-0.05600000f,0.11320001f,0.17780000f,-0.95650000f,-0.38010001f,0.17699998f,0.35030000f,0.63310002f,-0.00960000f,0.21440000f,0.52840002f,-0.22420000f,0.72289996f,1.52890001f,-0.47709999f,-0.35060001f,-0.49780004f,-0.33759999f,0.03490000f,0.34010000f,0.22299999f,0.13530000f,-0.14189999f,-0.20610001f,0.68369999f,-0.06269997f,0.23329999f,0.05649999f,0.78890002f,-0.15500000f,0.01660000f,-0.37420000f,-0.56989998f,-0.85589998f,-0.74430005f,-0.04579998f,-0.81029998f,-1.30830003f,-0.50699998f,-0.48570001f,-0.95250005f,0.50239998f,-0.38769999f,-0.10970001f,-0.28819999f,-0.16239999f,-0.22160001f,0.20799999f,-0.02580000f,-0.84209999f,-0.47279999f,0.57659999f,-0.86030001f,-0.62420001f,0.30620000f,-0.74009999f,-0.68520001f,0.08279999f,0.41939999f,0.14159999f,-0.38729999f,-0.87230001f,-0.46920000f,0.59400000f,0.10530001f,0.14500001f,-0.05380000f,-0.33669999f,-0.39160000f,-0.01610000f,-0.52790004f,0.02620000f,0.76850002f,-0.15340001f,0.23900002f,0.43540001f,0.04420000f,-0.10220002f,-0.28570000f,0.39130002f,0.20560000f,-0.39040001f,-0.77070004f,-0.25660000f,0.72550002f,-0.18250001f,-0.00880000f,0.15580000f,-0.17510001f,-0.01979999f,0.20430000f,-0.93539997f,-0.35540000f,0.08420000f,-0.06930000f,0.71429999f,0.32790000f,-0.89320001f,-0.51440006f,0.57159998f,-0.85769997f,-0.55410001f,0.14580000f,0.07290000f,-0.27989999f,0.03840000f,-0.24790000f,0.46450000f,-0.20469999f,-0.51419997f,-0.91140000f,0.42939998f,-0.14840000f,0.13519999f,-0.57309998f,0.24349999f,0.83350003f,-0.63989999f,-0.25490000f,-0.30130002f,0.21290000f,-0.74259998f,-1.16660002f,-0.04379999f,-0.67689998f,-1.42370003f,-0.27209999f,-0.06930001f,0.61350002f,-0.19019998f,-0.51289999f,-0.63010002f,-0.13930000f,-0.04210000f,0.09190000f,0.29149998f,-0.34940001f,1.04099999f,0.84580001f,-0.30849998f,-0.78650001f,-0.22400000f,0.66109998f,0.92660001f,0.41879999f,-0.62310001f,-0.70459999f,-0.37659999f,0.49959999f,1.25800001f,0.89880001f,-0.54509999f,-0.40040000f,-0.15699999f,0.34540000f,0.22480001f,0.27560001f,0.08200000f,-0.20330000f,-0.21280000f,0.00250000f,-0.09470001f,0.04480000f,0.16430001f,0.10690000f,-0.01080000f,-0.11520000f,-0.53160000f,-0.43420001f,0.18490000f,-0.02840001f,-0.17760002f,-0.28349999f,-0.36979997f,-0.31059998f,0.23289998f,0.41210000f,0.24300000f,-0.27450000f,0.81589999f,-0.04420001f,-0.58830000f,0.81419998f,0.19500002f,-0.38999996f,-0.88240001f,-0.63320007f,0.14680000f,0.91329998f,0.52370002f,0.03150000f,-0.08650000f,0.55029999f,-0.47679999f,0.76310001f,-0.08329995f,-0.09590000f,-0.06790000f,0.27370000f,-0.29779999f,0.46700001f,0.47500004f,0.20799999f,-0.18579999f,-0.07100000f,-0.18799999f,-0.08140000f,-0.05060000f,0.14120000f,0.26090000f,0.31090001f,0.31410000f,-0.21660000f,0.20820000f,0.28620000f,-0.80469998f,-1.18550000f,0.27029999f,0.60740002f,1.31620004f,-0.06590000f,-0.00230000f,-0.40750000f,-0.19030000f,-0.70340001f,-1.00830002f,-0.46520000f,0.69800000f,0.22680000f,0.16860000f,-0.08220000f,-0.26330002f,0.29040003f,0.76500001f,-0.32029999f,-0.18199998f,0.34070000f,-0.13209998f,-0.14719998f,0.13460000f,-0.34900000f,-0.24160000f,0.20140000f,-1.22930002f,-0.85620002f,0.55350000f,1.37989999f,0.96740000f,-0.63229999f,-0.98130001f,-0.67080001f,0.41400000f,-0.49000000f,0.10560002f,0.82259998f,-0.24260000f,-0.36820001f,-0.13400000f,-0.76459999f,-0.76920001f,0.05429999f,-0.36449999f,0.11520004f,0.66269999f,-0.32030000f,-0.45640002f,-0.08720000f,-0.31370000f,0.01379999f,-0.13159999f,-0.78990000f,-0.25350003f,-0.09630000f,0.19529999f,0.07290000f,-0.81419999f,0.57949998f,1.07350001f,0.07419998f,0.79759997f,1.54360001f,0.19659997f,0.83109997f,1.42429999f,0.12959999f,0.06400000f,0.44720001f,0.42090001f,-0.77290000f,0.03549998f,-0.49049999f,0.74709998f,-0.22689998f,0.29800000f,-0.89729997f,-0.40649999f,-0.68759996f,0.34299999f,0.93980001f,0.47209998f,-0.27550001f,-0.14750002f,0.72359998f,-0.63369997f,-0.17210000f,-0.58120000f,0.31799998f,0.78959998f,0.58160000f,0.01010000f,0.37690001f,0.22790000f,-0.28140001f,1.07980002f,0.82860003f,-0.39000000f,-0.73160003f,-0.08139998f,0.83860002f,-0.30110000f,-0.23100000f,0.04500000f,0.14789999f,-0.25760002f,-0.56739998f,-0.01279998f,-0.08319999f,0.04569999f,0.65450001f,0.40700001f,-0.30140000f,-0.10219999f,-0.02079998f,0.23170000f,0.57799999f,0.50860001f,-0.08230000f,0.24930000f,0.06059999f,-0.36030000f,1.26900001f,0.92220001f,-0.55830000f,0.78939998f,0.56739998f,-0.41199999f,0.73459999f,0.66720000f,-0.11249999f,0.67220000f,0.47860000f,-0.34030000f,-0.58639998f,-0.42839998f,0.37109999f,0.97359998f,0.68680002f,-0.51830001f,0.74450001f,0.05650003f,-0.58969999f,-0.28570000f,0.21430001f,0.12490000f,-0.63219997f,-0.67100000f,0.63499997f,-0.53250000f,-0.90570001f,0.18939999f,0.81529999f,1.28410003f,-0.11250001f,0.73360001f,0.48680005f,-0.02540001f,0.79309999f,1.31710003f,-0.39010000f,0.75159997f,0.56359999f,0.10170000f,-0.64529996f,-1.22489999f,-0.51969999f,0.59700002f,-0.35339996f,-0.32849998f,-0.01210000f,-0.81049999f,-0.54659999f,0.74649997f,0.39050001f,-0.26589999f,0.09400000f,-0.52840001f,0.27999998f,0.49370000f,1.35130002f,0.16389998f,-0.21020000f,-0.93140001f,-0.32500000f,0.76329998f,0.43120000f,-0.03780002f,-0.62369999f,0.61990001f,0.03079998f,-0.75260001f,0.48040002f,0.04479998f,-0.65770001f,-0.26440003f,0.03520001f,0.48230002f,-0.43570001f,-0.21919999f,0.36560001f,0.14270001f,-0.15960000f,-0.28260000f,0.91110001f,0.63180000f,-0.46320001f,-0.39479999f,-0.51100002f,-0.11810001f,-0.16759998f,-0.08799999f,0.15669999f,-0.95090000f,-0.62920000f,0.43209999f,0.56029999f,0.11719998f,-0.60109999f,0.41840001f,0.09479999f,-0.45480000f,0.26420002f,0.00160000f,-0.37480001f,0.06040000f,-0.17810001f,-0.32889996f,-0.72700001f,-0.24860006f,0.50749998f,-0.04900000f,-0.44660000f,0.57559999f,0.24890001f,-0.16429998f,0.37459999f,-0.45970000f,-1.13810004f,-0.30860000f,0.60429998f,1.15790004f,0.00499999f,0.22090000f,0.76130003f,0.48679998f,0.58090000f,0.79970003f,-0.32169998f,0.24120000f,-0.53760001f,0.59370000f,-0.44519998f,-0.25079999f,0.01539999f,0.21950001f,0.50110001f,0.24980000f,-0.81999999f,-0.32120003f,0.33659999f,0.08080000f,-0.38679998f,0.23259999f,-0.03380000f,-0.43540001f,0.25559999f,-0.16699999f,-0.48940001f,-0.22570000f,-0.01650000f,0.13520001f,0.13760001f,0.06310000f,0.00640002f,-0.13919999f,-0.05970000f,0.58949999f,0.61880001f,0.02350000f,-0.72439999f,-0.53379999f,0.41379999f,-0.62860001f,-0.41800000f,0.31660000f,-0.58749999f,-0.27539998f,0.49649999f,-0.56740001f,-0.00779999f,0.63390000f,-0.30859999f,-0.03539998f,0.36539999f,0.62550001f,0.53100002f,-0.18209999f,0.74399999f,0.46719999f,-0.37119999f,0.21589999f,0.27539999f,-0.04080000f,0.30080000f,0.14020000f,-0.21429999f,-0.84600004f,-0.31280001f,0.66260002f,0.42990000f,0.06999998f,-0.53380000f,-0.60400000f,0.99200002f,-0.10940001f,0.58390000f,0.75830004f,0.31459997f,0.70430001f,1.10590005f,-0.59779999f,0.73019997f,0.50100000f,0.34289998f,0.34729998f,1.26489999f,0.17939999f,-0.32059999f,0.12980001f,-0.03910000f,0.16989999f,0.82549998f,-0.59109998f,-0.74659998f,-0.65380002f,-0.24270000f,-0.03490000f,0.22269999f,-0.40550001f,0.33990001f,-0.11729998f,-0.14720000f,0.60959998f,0.20640001f,-0.34749998f,-0.42740000f,-0.89740002f,0.03410000f,0.18460000f,-0.00339998f,-0.26719999f,-0.73260000f,-0.33420001f,0.28240000f,-0.27149999f,-0.80790000f,0.27869999f,-0.44360000f,-0.98689997f,-0.78239998f,0.36929998f,-0.56130003f,-0.03780000f,0.60180001f,-0.60170002f,-0.02699999f,0.76560000f,-0.27240000f,-0.13039999f,0.25580000f,0.99029998f,0.69899999f,-0.39059998f,-0.81700000f,-0.61219999f,0.38930001f,-0.05720003f,-0.36740004f,-0.45099999f,-0.19240002f,-0.01300000f,0.34390002f,0.58280002f,0.05079999f,-0.70540001f,0.09670000f,-0.03320001f,-0.17230000f,0.47680000f,0.50440002f,-0.08890000f,-0.49359998f,-0.01899996f,0.72699998f,0.09760001f,0.21400002f,0.19040000f,0.49290003f,-0.06380002f,-0.79570002f,0.64210002f,0.15420002f,0.53599997f,-0.40659999f,0.37539997f,-0.52249998f,-0.68099999f,-0.55260001f,-0.55469998f,-0.02980000f,0.48580000f,-0.00400001f,0.26940000f,0.67740002f,-0.34369999f,0.92099999f,0.43020006f,0.38669997f,-0.04700000f,0.75140000f,0.63570000f,-0.74950001f,-1.04150003f,-0.13690001f,0.68259998f,1.22420003f,0.49099999f,0.08440000f,-0.38920001f,0.16140000f,-0.04120000f,-0.14240000f,-0.52559999f,-0.15669999f,-0.74870002f,-0.43209999f,0.61030001f,1.37750003f,-0.30140000f,0.52460000f,0.68620002f,0.60270000f,-0.45209999f,-1.11810004f,0.22699998f,-0.32440000f,-0.69780000f,-0.51560000f,0.35360000f,0.01680000f,0.02500000f,-0.10240000f,-0.98380001f,-0.83040002f,0.24690000f,0.57810000f,0.66400002f,0.09110000f,0.96570001f,0.72080001f,-0.33950000f,-0.81690005f,-0.17160002f,0.75630001f,0.01630000f,-0.06560001f,-0.17740000f,0.50429999f,0.49160000f,-0.17029999f,0.81040004f,0.16419999f,-0.75340002f,0.34410001f,0.00460001f,-0.38859999f,-0.47240001f,-0.25580000f,0.32870001f,-0.13320001f,-0.03520000f,0.18850001f,0.61450000f,0.12719998f,-0.68039999f,0.22509999f,0.38159999f,0.07529999f,1.15580002f,0.72430001f,0.31979999f,0.04560000f,0.77280001f,-0.06569999f,-0.72029997f,-1.13070001f,0.61459999f,-0.83330001f,-0.27730005f,-0.69839998f,0.73980001f,0.51780005f,-0.41359999f,0.87959998f,0.38400001f,-0.52579996f,-0.91140000f,-0.66060001f,0.12140000f,-0.54369998f,-0.84170000f,-0.48179999f,-0.35880000f,-1.08240003f,0.53469999f,0.92869998f,0.69430000f,0.35749996f,0.42600000f,0.35520002f,0.02690000f,-0.07480000f,0.34360001f,-0.04900000f,0.33929999f,0.64650002f,0.36579998f,-0.04210000f,-0.62570000f,-0.54599996f,-0.37059999f,-0.83660001f,-0.45860001f,0.01100000f,-0.12570001f,0.07519999f,0.14860000f,0.88399997f,0.63719998f,-0.38009999f,-0.37790001f,-0.26820001f,0.21360000f,0.26690000f,-0.09200002f,-0.54070000f,0.62310002f,0.41580000f,-0.42000002f,0.99549998f,0.58519998f,-0.60169999f,0.47869999f,0.33979998f,-0.35720000f,-0.60909998f,-0.35479999f,0.37939998f,0.47120003f,0.14300000f,-0.51860002f,-0.01570000f,-0.23540001f,-0.12310001f,-0.66059999f,-0.41739999f,0.36429998f,0.42979999f,0.35179999f,-0.19790001f,0.93190003f,0.35820000f,-0.78840002f,-0.88020000f,-0.31220000f,0.68059999f,0.51000002f,0.51190000f,-0.39299998f,-0.96799997f,-0.24329999f,-0.30780004f,0.16400004f,-0.31800000f,-0.44389998f,-0.21610001f,0.03590000f,-0.41320000f,1.18620002f,0.43840001f,-0.50519998f,0.36639999f,-0.16540001f,0.16380000f,-0.55579997f,-0.44899999f,0.86259998f,-0.74759998f,-0.28380000f,0.83649999f,-1.31649995f,-0.65119999f,0.25370000f,0.09250001f,0.15960001f,0.91279999f,0.08479994f,0.28989999f,1.21459999f,0.10919996f,0.07169999f,-1.04390000f,0.39970004f,-0.05239999f,-0.23069996f,0.19069998f,-0.21890001f,1.17600001f,0.15639997f,0.34230001f,-0.23279999f,0.87169997f,0.11500000f,0.32560001f,0.57829999f,-0.42320000f,-0.28120000f,0.48399996f,-0.05220001f,-0.07540001f,-0.53649998f,0.69299999f,-0.51219998f,-1.05749998f,0.58679999f,0.04380002f,-0.62539997f,0.70520000f,0.08220001f,-0.06740001f,-0.42800001f,-0.71020001f,0.34559995f,-0.23540000f,0.79180001f,0.58870003f,0.64900002f,-0.06080001f,-0.57830002f,-0.03860001f,-0.19380001f,-0.38969999f,-0.33840002f,0.24260000f,0.07840004f,0.20880002f,-0.78599999f,-0.49320002f,0.50200000f,-0.24479999f,-0.75859999f,-0.31700002f,-0.54040002f,0.01909998f,-0.30280000f,-0.57530001f,0.77939999f,0.45199998f,0.17290000f,0.47529997f,-0.78149998f,-0.38489999f,-0.72429999f,-0.17690001f,0.01049999f,-1.01409996f,0.56010001f,0.00290000f,-0.55799998f,0.83959998f,0.29030000f,0.22990000f,1.08909996f,0.27059999f,0.34059997f,-1.10779997f,-0.65990000f,0.57510000f,0.27209998f,0.38870001f,-0.45450001f,0.86010001f,0.23000000f,-0.51009999f,-0.22910000f,-0.08770000f,-0.08259998f,-0.31660002f,0.05650000f,-0.46199998f,-0.29879994f,-0.40619999f,-0.73959998f,0.49680000f,0.08740000f,-0.05900001f,-0.85120000f,-0.46450001f,0.68479999f,-0.08219997f,-0.24680001f,-0.24540001f,0.01019999f,0.20319999f,-0.37940000f,0.18320000f,-0.28380000f,-0.27240000f,0.20529998f,-0.50440000f,0.74959999f,0.34740002f,0.20800001f,-0.54080000f,-0.17480005f,0.55560000f,0.22540002f,0.32620002f,0.69380003f,0.05400001f,-0.62310001f,-0.42240000f,0.05879999f,0.44279999f,-0.17980000f,0.43999998f,0.77849997f,-0.72080002f,0.29960000f,0.96280001f,-0.03180000f,-0.22899999f,-0.00150001f,-0.56860000f,-0.01520001f,0.97929996f,-0.41100000f,0.16019999f,0.59969998f,0.31720000f,-0.43739998f,-0.22940002f,0.75400001f,-0.07939999f,-0.07270001f,-0.53749999f,-0.24100000f,0.38130004f,0.04249999f,-0.22700001f,0.17099999f,-0.59439998f,-0.29830000f,0.13589997f,-0.17410001f,0.31650001f,-0.07050002f,-0.09689997f,-0.28450000f,0.66340004f,1.00579997f,0.26849999f,-0.50630001f,1.00430002f,0.32800001f,0.38129999f,-0.54030000f,-0.14610000f,0.89309997f,0.11809997f,0.13679999f,0.90100000f,-0.76140002f,-0.14280000f,0.01010000f,-0.21089998f,-0.16569999f,1.03069998f,-0.76189999f,-0.31640000f,0.58199998f,-0.43740000f,-0.09600000f,-0.10390000f,0.13290001f,-0.17419999f,-0.29359999f,1.12439998f,-0.04120000f,0.13860001f,0.40340000f,-0.69620002f,-0.21079998f,0.89550000f,-0.02799999f,0.46260000f,0.60080000f,-0.41120001f,0.27540000f,-0.01039999f,-0.10400000f,-0.27880000f,0.28239999f,0.16360000f,-0.61720001f,-0.81980001f,-0.10680000f,0.34120001f,0.76380000f,-0.52460001f,-0.44460000f,0.03370000f,0.62340000f,0.10820002f,-0.41989998f,-0.31140002f,0.03680000f,0.39390001f,-0.37400000f,0.06279999f,0.73579998f,0.09380000f,-0.01960000f,-0.33749998f,0.25300000f,-0.22760000f,-0.32790000f,0.37420000f,0.30540001f,-0.65529996f,-0.69400003f,-0.09680001f,0.49750001f,0.07350000f,0.02480000f,0.88350002f,-1.09669998f,-0.47519999f,0.72640000f,0.34199998f,0.22190000f,-0.23770002f,-0.40770001f,0.07060001f,0.35740001f,-0.32819999f,-0.26160000f,-0.93440001f,-0.27239998f,-0.25680000f,0.91930000f,0.15329998f,0.09250000f,-0.14769999f,-1.08629996f,-0.46129999f,-0.27699998f,0.95719998f,0.31540000f,0.37100001f,-0.39720001f,-0.12190000f,0.79050000f,-0.44110000f,-0.17150000f,-0.39989999f,0.09470000f,0.06240000f,-0.28859999f,0.18040000f,-0.03510000f,-0.72729998f,0.71209999f,0.41190000f,-0.31509997f,0.33950002f,-0.13620000f,0.71680001f,0.55030002f,0.02060001f,-0.54040000f,0.14949998f,-0.27700001f,-0.37500000f,0.53990000f,0.60639999f,-0.50879999f,-0.44560001f,-0.41020000f,0.17159998f,-0.05230001f,0.42040000f,-0.73519999f,-1.38459997f,-0.35960000f,-0.05780002f,0.35419998f,-0.43700001f,-0.35280001f,0.10269999f,0.68360000f,0.44060004f,-0.37539996f,0.25759999f,-0.45000000f,-0.36080001f,-0.73360000f,-0.36180002f,0.95959998f,0.14860000f,0.42460000f,-0.30529997f,-0.58760000f,-0.12200000f,0.55219999f,0.68339999f,-0.43959999f,-1.13189997f,-0.67700002f,0.40789999f,0.57940000f,0.36079997f,0.37170000f,0.27060001f,-0.34399997f,-0.38530000f,0.62830003f,-0.62909999f,-0.41470000f,-0.24639998f,0.48800000f,-0.10800000f,-0.28040003f,-0.48419999f,0.00590000f,-1.54709997f,-0.02829996f,-0.18169999f,0.30719998f,-0.53919999f,-0.19490000f,-0.02650000f,-0.88589998f,-0.38300000f,-0.22919997f,1.28759998f,0.55390001f,-0.30380000f,0.02500001f,-0.18120000f,0.96850001f,-1.25429998f,-0.59860001f,-0.38400000f,0.49619998f,0.37760000f,0.47010000f,-0.90309998f,-0.33349999f,-1.12539996f,0.59159999f,0.06049999f,0.88850000f,-0.27210002f,-0.20900001f,-0.57180002f,-0.18610002f,-0.14600000f,-0.31760000f,-0.08460001f,0.14780002f,-0.23680000f,0.12549996f,0.47840001f,-0.11040000f,-1.05719999f,-0.87220001f,-0.14660000f,1.18549999f,-0.04480000f,0.26300000f,-0.05799999f,0.57080003f,0.20439999f,0.22299997f,-0.64860003f,-0.03939999f,1.01490001f,-0.76040002f,0.39500001f,1.46139999f,-0.99900004f,-0.33140002f,1.12130000f,-0.39380002f,0.56540001f,0.64790003f,0.37140001f,-0.38240001f,-0.94509998f,0.22040001f,0.15799999f,0.22899998f,0.10280000f,-0.15020000f,-0.29060000f,-0.29700002f,-0.04720000f,-0.27610001f,-0.73269999f,-0.42510001f,-0.14250000f,-0.44929999f,-0.24750000f,0.26249998f,0.05830002f,-0.13720000f,-1.16090001f,0.53270002f,0.21550001f,1.17710002f,-1.28429998f,-0.52410000f,-0.12840000f,0.11759999f,0.17530000f,0.53659999f,1.00420000f,0.27339999f,1.04330002f,-0.89370001f,-0.36130000f,1.53009999f,-0.70830002f,-0.16080000f,1.05490002f,-1.60850002f,-0.67810001f,0.60610001f,-0.11770004f,0.17930000f,-1.03069998f,0.19030002f,-0.01780000f,0.38669999f,0.45669999f,0.13909999f,-0.31840000f,0.01840001f,-0.03110000f,-0.03240000f,0.16209998f,0.09680001f,-0.26619999f,-0.51920000f,0.24920001f,-0.14800000f,-0.47820001f,0.76800001f,-0.21140000f,-1.34519997f,0.21020001f,0.42600002f,0.35550002f,0.46520000f,0.09900001f,-0.37339999f,-0.37120000f,-0.01220000f,0.23079999f,-0.47099998f,0.61980000f,0.38130001f,0.42260001f,-0.57780001f,-0.82590002f,-0.20639999f,0.33560001f,0.41000000f,0.48980000f,0.31900003f,0.38210002f,-0.34240001f,0.24700000f,1.04839998f,-0.01920000f,0.61380001f,0.78840002f,-0.10440000f,-0.57260000f,-0.03740002f,0.14920000f,0.24480001f,0.15140000f,0.43320001f,0.22019999f,-0.60960000f,-0.09319997f,-0.07929999f,-0.49830001f,0.21890001f,0.03990000f,-1.39459998f,0.86100001f,0.27190000f,0.51760002f,0.64459999f,0.30130000f,-0.28819999f,0.72219998f,0.25650000f,0.13339999f,-0.53419998f,-0.14929999f,0.21149998f,-0.21509999f,0.23250001f,-0.82640000f,0.13580003f,-0.15380000f,0.40610000f,-0.02750000f,0.11070001f,0.69560003f,0.98099997f,0.30540000f,1.19660000f,-0.23580002f,-0.08130001f,0.96060002f,0.47939997f,0.30089999f,-0.03080000f,-0.56679998f,-0.41670000f,0.24080000f,0.40759999f,0.18900000f,-0.38380000f,0.26019999f,0.56559999f,-0.49900000f,-0.81120000f,0.10460000f,-0.52960000f,0.15829999f,-0.11800000f,-0.67580000f,0.23099996f,-0.37800000f,0.08459999f,0.34859999f,0.54440001f,-0.43780000f,-0.62420001f,-0.16460000f,0.33800001f,0.74529998f,-0.05760000f,-0.50079999f,-0.19640001f,0.84180003f,0.14259999f,-0.82750001f,0.39580002f,0.50500002f,0.17710001f,-0.45780000f,0.01000000f,0.93829998f,-0.54400001f,0.39140001f,1.23800000f,0.72300003f,-0.16620001f,-0.71890003f,0.04720000f,0.17380000f,0.43839999f,0.19980001f,0.03220001f,-0.12770000f,0.57459999f,-0.07840000f,-0.74959998f,0.40359999f,-0.06050001f,0.32010004f,-0.21209999f,-0.35480001f,0.32959999f,-0.63759997f,-0.52990000f,0.27449999f,-0.46470000f,-0.10200000f,-0.51959999f,0.43240001f,-0.05170001f,0.86829998f,0.06449999f,0.07620001f,-0.22749999f,-0.46029997f,-0.33109999f,-0.71780002f,1.26760000f,0.46099999f,0.35910001f,0.95849999f,0.43490001f,1.02519999f,-0.58460000f,-0.26110000f,1.33620000f,-0.41220002f,-0.06830000f,-0.59340002f,0.88120001f,0.19960000f,0.58080000f,0.23159999f,0.06949999f,-0.07940000f,0.30560001f,0.09840000f,-1.10329997f,0.06220000f,-0.11939998f,0.85800001f,0.14110003f,0.47959999f,0.10160000f,0.25700002f,-0.42960002f,0.16699999f,-0.13479997f,0.48500000f,-0.37899999f,-0.64230000f,-0.37199999f,0.89140000f,0.42760001f,0.33580000f,-0.11700000f,-0.33690000f,0.19240000f,0.26280000f,-0.31500000f,-0.04280000f,-0.23880000f,0.00059999f,0.15160001f,0.12360000f,0.00740000f,-0.06120000f,-0.11780001f,-0.21020000f,0.13260000f,-0.49320001f,-0.31450002f,-0.47080000f,-0.07540001f,0.93339996f,0.36499999f,-0.55240000f,-1.14150000f,-0.27660000f,0.27260000f,0.44210000f,-0.49659999f,-0.39959999f,0.02999999f,0.45140000f,0.53210001f,0.55110004f,0.79949995f,0.17169998f,-0.39790000f,-0.52310002f,0.00900000f,-0.57809998f,0.38570001f,-0.02610000f,0.28689996f,0.12889998f,0.44040001f,-0.27490000f,0.38050000f,0.06590000f,-0.35740002f,0.44379999f,0.28100000f,0.00890000f,-0.23389999f,-0.17590000f,0.06590000f,0.31190000f,0.12750000f,-0.29240001f,-0.19240000f,-0.06810000f,-0.29580000f,-0.18559999f,-0.25370000f,1.02269998f,-0.66529999f,-0.32260000f,-1.27320001f,0.04220000f,-0.10770000f,0.42320000f,-0.17300000f,0.04260000f,0.79869998f,0.18500002f,0.53240001f,-0.24980000f,-0.10220001f,-0.03780000f,0.15660000f,0.00750001f,0.91760002f,0.40820001f,-0.94399997f,0.52000000f,-0.40560000f,-1.31079997f,0.31679999f,-0.41499998f,-1.15799995f,0.21520000f,-0.30560000f,-0.45320001f,0.37940000f,-0.82780002f,-0.38270003f,-0.46339999f,0.97060000f,0.57670003f,0.21320001f,-0.56780001f,0.03659994f,0.92079999f,0.23560000f,-0.90279997f,-0.20580000f,-0.45860000f,0.05550000f,-0.10000001f,-0.86380001f,-0.07400004f,0.75160000f,0.21920003f,-0.74459995f,-0.09720001f,-0.65300003f,-0.37860002f,0.27899999f,-0.34279999f,0.14240002f,0.59440000f,-0.00170001f,-0.02610000f,0.05729999f,0.09510000f,-0.86759999f,1.55919999f,0.68150000f,-1.44189998f,0.36050001f,0.06210000f,-1.33359996f,0.06840003f,-0.02529999f,-0.46260000f,0.05820001f,-0.08140000f,-0.23159999f,-0.06859999f,-0.40120002f,0.43199999f,0.06419998f,0.44660001f,0.21439998f,-0.09039998f,-0.33190000f,-0.79139999f,1.44379995f,0.55839998f,0.03130002f,-0.62609997f,-0.38150000f,-0.04290001f,-0.77209998f,-0.60940000f,-0.65929996f,1.19709999f,0.47530001f,-0.46880001f,-0.64319999f,-0.42050001f,-0.97039999f,-0.34999996f,-0.21860000f,0.83580003f,0.26350003f,0.79540003f,0.16500001f,-0.39990001f,-0.09740000f,-0.12360000f,0.44289997f,-0.70399999f,-0.33100000f,0.77319997f,0.22359999f,-0.34260001f,-1.01219999f,-0.13939999f,0.27760000f,-0.19250000f,0.41080000f,-0.20700000f,-1.06979999f,0.09140000f,0.46320000f,-0.28229995f,-0.50940000f,0.18900000f,1.04249996f,-0.42139999f,0.96920001f,0.64290001f,-0.41260000f,0.69139999f,0.86570000f,0.06280000f,0.67660000f,-0.10299996f,-0.31780000f,0.55440001f,0.60990002f,0.47920000f,-0.64979999f,-1.23320000f,-0.57739999f,0.19220000f,0.14809999f,0.30030000f,0.47050002f,-0.17710001f,1.25230001f,0.40130000f,0.55429998f,-0.19349999f,-0.17660000f,0.73239999f,-1.20479995f,-0.54209999f,-1.19290000f,-0.00410000f,-0.02380000f,-0.35190003f,-0.02249999f,0.17720001f,-1.19770000f,0.36310001f,0.13160000f,-0.38479998f,0.44179998f,0.38410000f,1.11779997f,-0.52320000f,-0.16860000f,0.53919997f,0.13059998f,0.44830001f,0.87029998f,-0.03630003f,0.22869999f,-0.18630000f,0.56809998f,0.49600000f,0.59260000f,-0.01720001f,0.19930000f,-1.32969999f,0.13230002f,-0.12799999f,-0.00250001f,0.08639998f,0.61619998f,-0.05960001f,-0.08789998f,-0.65100000f,-0.18200001f,0.49209998f,-0.71640002f,-0.20420002f,0.32699999f,-0.77400002f,0.04420000f,1.04900001f,0.62760003f,-0.01660001f,-0.99900001f,0.41840001f,-0.28260000f,-0.72960002f,-0.16600000f,-0.45540001f,-0.57700000f,-0.40820002f,0.69440000f,0.68670003f,-0.22980001f,-0.60240002f,0.09469996f,0.20680000f,-0.14939999f,-0.44459999f,0.24960000f,-0.52880000f,-0.02280002f,-0.59599999f,-0.00080002f,0.47919998f,-0.47160001f,0.03560000f,0.47300000f,-0.42080001f,-0.03559999f,0.47040000f,-0.22379999f,-0.46450001f,0.17800004f,0.85499994f,0.15069997f,0.36819999f,-1.04439998f,-0.38430000f,0.12219998f,-1.17060000f,-0.39470001f,1.02010002f,-1.01510001f,-0.34540000f,-1.02550002f,0.82410002f,0.31460000f,-0.73580001f,0.34940002f,0.03310000f,-0.78620001f,-0.61979998f,-0.27670000f,0.63550001f,-0.04310004f,0.25780000f,0.08879998f,-0.76099999f,-0.49250001f,-0.47350000f,0.15850001f,0.02180000f,0.14830002f,-0.01409999f,-0.28610001f,0.35549998f,-0.83489998f,-0.24250000f,0.40100000f,-0.62660000f,-0.18060000f,0.42960000f,-0.60319999f,-0.21419999f,1.19770000f,-0.71619998f,0.19560000f,0.03380000f,-0.56060000f,0.09000000f,-0.41180000f,-0.86300000f,0.19760000f,0.64600001f,-0.23439996f,0.48860000f,-0.74259999f,-1.20449998f,0.24520001f,-0.41000000f,-0.28460003f,0.54019999f,-0.31499999f,-0.82629997f,0.48620002f,0.35400002f,0.33349999f,0.36620000f,0.04580002f,-0.27289998f,-0.10059999f,0.59140002f,0.26850001f,-0.23680000f,0.38079999f,0.05440002f,-0.12940000f,0.49560000f,0.76370000f,-0.17619999f,0.09000000f,0.09269999f,0.51200003f,-0.06440000f,0.00639997f,-0.60520001f,0.05259999f,0.77139998f,0.15700000f,0.12730000f,-0.65350001f,0.26330001f,0.16060001f,-1.04990002f,-0.23709997f,-0.13139999f,-0.29349999f,0.73289998f,0.53310000f,-1.27649997f,0.08210003f,-0.19290000f,-0.21360001f,0.04200002f,-0.16840000f,-0.80299997f,0.49679999f,0.06020000f,0.62560000f,0.99659999f,0.33530000f,-0.19529998f,0.54729999f,0.17690000f,0.23839999f,0.29900001f,0.33680002f,-0.08320000f,-0.07040001f,0.18400000f,0.89050000f,0.23069997f,0.19159999f,0.02979998f,-0.18639999f,-0.00290000f,0.25460000f,0.70660002f,0.10360000f,0.73099999f,-0.78500000f,-0.25070000f,-0.17759998f,0.11060002f,0.27239999f,-0.87559998f,-0.57620000f,0.46700002f,0.28600001f,0.25709998f,0.77780002f,0.14840001f,-0.57470000f,0.31840001f,-0.19960000f,-0.61520000f,-0.18339998f,0.60519998f,-0.05370000f,0.37540001f,-0.74119999f,-0.82590001f,-0.63460000f,-0.39220002f,0.81949997f,0.50180002f,-0.13800001f,-1.02590000f,-0.70360002f,-0.11760001f,0.49140000f,-0.18640000f,-0.07360001f,0.14479999f,-0.11439999f,0.72140002f,0.71960002f,0.87860000f,-0.03659999f,-1.24309998f,0.31480000f,0.18600001f,-0.51939998f,-0.91620004f,-0.13980000f,1.04230001f,-0.39600002f,0.13540000f,-0.53149996f,-0.27669997f,-0.43709999f,0.52370000f,0.91309999f,0.29420000f,-0.41430000f,1.19949999f,0.41000000f,-0.64100000f,0.27180001f,0.04440000f,-0.22750004f,0.15950000f,0.36860000f,-0.82919999f,-0.05059995f,-0.27929999f,0.83310000f,-1.14269998f,-0.57050001f,-1.10540001f,0.55000002f,0.19890000f,0.33520000f,-1.07560000f,-0.35540000f,0.11310000f,-0.31410000f,-0.12530000f,0.81270001f,0.41069999f,0.35680001f,-1.22870000f,1.15749998f,0.40890000f,-0.56140000f,0.55099999f,0.29340000f,0.96660002f,-1.35640002f,-0.51160001f,-0.22339998f,-0.42129997f,0.36120000f,-0.64320001f,-0.80900002f,-0.26220000f,0.22140001f,0.89529998f,0.05239999f,-0.84540001f,-0.05860002f,0.27000001f,0.72120001f,-0.25339999f,-0.13960001f,0.65920000f,-0.02619995f,0.57200002f,0.20439998f,0.26639997f,-0.30239999f,0.02740000f,0.67159997f,-0.24240000f,0.74400001f,0.99200001f,-0.56540004f,-0.21900001f,-0.29469996f,-0.30500000f,-0.20799999f,-0.16970000f,0.31500001f,-0.25520000f,-0.41050001f,0.26680001f,-0.10420000f,-0.55060000f,-0.70400000f,0.03060000f,0.68439999f,0.00440000f,0.65239999f,0.71380000f,-0.32520000f,-0.01010000f,-0.82500000f,0.00020002f,-0.21880000f,1.03469999f,-0.14950001f,-0.05350000f,0.04630003f,-0.53369998f,-0.55480001f,-0.29370003f,0.89149998f,0.60830001f,-0.17709999f,0.26489997f,0.41430000f,0.59449999f,1.00969997f,0.26749998f,0.74319998f,-0.36679999f,-0.16570000f,1.11030001f,0.26229998f,0.29590000f,-0.62709998f,-1.01290002f,-0.27150001f,-0.34190000f,-0.61169996f,-0.20639998f,-0.36560000f,0.24460001f,-0.02410000f,-0.59090000f,0.26990001f,0.08540000f,0.57259999f,-0.95339997f,-0.28189999f,0.86849999f,0.53529995f,0.34489999f,0.25340000f,-0.30559997f,0.00320000f,0.33939999f,0.71719998f,-0.26319999f,0.64139998f,0.32840002f,0.23260000f,-0.34680001f,-0.51530001f,-0.67560001f,-0.09280000f,0.92339998f,-0.50900002f,0.59360000f,1.15470001f,-0.51280000f,0.54679998f,0.55440001f,-0.50980000f,0.58799999f,1.35429997f,0.33639998f,-0.34219999f,-0.40019998f,-0.60580003f,0.18060001f,0.91870002f,0.04579998f,-0.58980002f,-1.02149998f,0.30059999f,-0.40679999f,-0.35290000f,-0.22860001f,0.48439998f,0.65290000f,-0.73140003f,0.22000000f,0.59230003f,0.48940000f,-0.00460000f,0.19989998f,-0.55840003f,0.26040002f,-1.30529999f,-0.06819999f,-1.04529998f,0.43950001f,0.56799997f,0.23169997f,-0.72170000f,-0.29539998f,-0.60969999f,0.64610004f,-0.45840000f,0.42110004f,0.32900000f,0.30440000f,0.12419998f,0.03220002f,0.66199997f,0.02019999f,0.10610001f,0.49079999f,0.22710000f,-0.15869997f,0.93519997f,0.00030000f,0.10360001f,-0.18160000f,0.13880002f,0.45019997f,-0.22339998f,0.53280000f,1.05789999f,0.28980000f,1.01669999f,-0.24119999f,-0.06160001f,-0.38840000f,0.39430001f,0.41740000f,0.22229999f,0.69120001f,-0.20980001f,0.76460003f,-1.21000001f,-0.65080001f,-0.39840000f,-0.31889999f,-0.48200000f,-0.06019998f,-0.54779997f,-0.37009998f,0.29000000f,0.32989999f,0.51720000f,0.51919998f,1.04769996f,0.43979998f,0.16619998f,0.71959997f,0.31769999f,-0.13640000f,0.40819999f,-0.27160000f,0.13660002f,-0.46939997f,-0.41989999f,-0.47280001f,-0.49250000f,-0.10339999f,0.16260000f,0.71710001f,0.19330000f,0.25280000f,0.23549999f,0.31539999f,-0.04180001f,-0.21900002f,0.20849999f,0.43080000f,0.41520001f,0.02699999f,0.33439999f,0.75739998f,0.36639999f,0.21880001f,-0.18970000f,-0.08660000f,-0.13599999f,0.08870000f,1.01890000f,0.10659999f,0.90930000f,-0.11440001f,0.54539997f,-0.01860003f,-0.86390002f,-0.31899998f,-0.77110000f,-0.07649999f,-0.08940000f,-0.25849999f,0.26540000f,-0.36979999f,0.10400001f,1.29619999f,0.01640000f,1.00819998f,-0.27120001f,0.88339996f,-0.18140004f,0.28130000f,-0.43619999f,0.35050002f,0.46910001f,-0.21599999f,0.26770000f,-0.61230000f,-0.08979999f,-0.55350000f,-0.58960001f,-0.26299998f,-0.43979999f,-0.19799995f,0.49319998f,-0.26879999f,-0.05980000f,-0.18840000f,-0.18460000f,-0.53870002f,0.49899999f,-0.43990003f,0.29140001f,0.39520000f,0.11960001f,-0.13980000f,0.01360000f,-0.01440001f,-0.02880002f,-0.45140003f,0.04200001f,-0.28989999f,-0.16859999f,-0.28979999f,-0.46999998f,0.25550002f,0.20460002f,0.20860002f,-0.17569999f,-0.33740002f,0.07239997f,-0.51330003f,0.14020000f,0.77310001f,0.26330000f,-0.14339999f,-0.51059999f,-0.18210000f,-0.46859998f,-0.60049998f,-0.47109999f,-0.40400000f,-1.00440000f,-0.42559999f,0.07640000f,-0.02150000f,-0.08160000f,-0.34779998f,-0.94609997f,-0.65949999f,-0.25139999f,-0.60689998f,-0.29669999f,0.17720000f,0.30380000f,-0.13520000f,-0.04880001f,-0.92659998f,-0.44700001f,0.20600000f,-0.35820001f,0.71200003f,0.56200000f,0.57480001f,-0.23770000f,0.36579998f,-0.16210001f,-0.59460003f,-0.62299998f,-0.37880000f,0.22760000f,0.47099997f,0.12819997f,1.54580004f,0.12100001f,1.27600003f,0.48030001f,-0.35600000f,0.27330001f,-0.21240000f,0.16860000f,-0.08940001f,0.70589998f,0.07120000f,0.70209998f,-0.08920002f,0.23279999f,0.10439999f,-0.03809999f,0.22619999f,-0.03890000f,0.27470000f,0.59839997f,0.38049998f,0.02310000f,0.17999999f,0.12570000f,0.35420000f,0.34919997f,0.22219998f,0.80300000f,-0.77760000f,-0.22640000f,-0.28700000f,-0.31060001f,-0.22260001f,-0.96070000f,-0.59570001f,-0.42140000f,-0.40339999f,-0.36850000f,0.00560000f,-0.19599999f,0.34780002f,-0.02960000f,-0.24960000f,-0.34160001f,0.54520001f,0.61500000f,0.44260000f,-0.44660000f,-0.55600000f,-0.53850000f,0.22520000f,-0.30310000f,0.05080000f,0.04099998f,0.60269997f,0.12629999f,-0.13600000f,-0.42170001f,-0.20280001f,-0.29459999f,-0.68159998f,-0.49130000f,0.14819999f,0.27309999f,0.27049999f,0.17400000f,0.34249999f,0.08620000f,0.14479998f,0.63789998f,0.57339999f,0.15739999f,0.83720000f,0.47980002f,0.13920000f,0.44980001f,-0.07589998f,0.71119997f,0.08390001f,0.75040001f,-0.04739999f,0.70780001f,-0.86560004f,-0.37560000f,-0.67000002f,0.23120002f,0.46559999f,0.21840000f,-0.77620001f,0.07680000f,-0.77100002f,0.84180001f,0.17699999f,0.80240001f,-0.94209999f,0.36779998f,-0.75010000f,0.62510000f,-0.28039999f,0.42330001f,-0.05910000f,0.17940000f,0.02170000f,0.30340002f,0.38500000f,0.36480001f,-0.29490000f,-0.20239999f,-0.28909999f,0.06030000f,0.05060000f,-0.01690000f,-0.23150000f,-0.70339997f,-0.28069998f,-1.37180001f,-0.06500000f,-0.45200001f,-0.41810000f,-0.15120000f,0.08760000f,-0.10409999f,-0.39220001f,-0.08840000f,-0.51290001f,-0.54280002f,0.24319999f,0.59439998f,-0.10880001f,0.05680001f,-0.17029998f,0.34280002f,0.79859998f,1.12079997f,0.80529998f,-0.07859999f,-0.42239998f,-0.17989999f,0.14660001f,-0.30189999f,-0.02270000f,-0.09300003f,0.61279997f,0.19609999f,0.25600000f,0.36079999f,0.01880000f,-0.19999999f,-1.02679998f,-0.70420002f,-0.01260001f,0.29169999f,0.40390000f,-0.10740000f,-0.67319999f,-0.28010000f,0.53479998f,1.09449996f,0.54899998f,-0.39640000f,0.45890000f,0.43249999f,-0.36619999f,0.45970001f,0.31970004f,0.66379998f,0.25530001f,0.26770004f,0.71219999f,0.28690001f,0.62800001f,0.32799998f,0.39759999f,-0.91130003f,-0.29939999f,-0.71690002f,-1.06099998f,-0.15380000f,-1.09439998f,-0.20060001f,0.23739999f,-0.09960001f,-0.67990000f,0.34199999f,-0.52930001f,0.76900002f,-0.57539999f,0.55640003f,0.04880000f,0.25519999f,-0.04000002f,-0.04039997f,0.90359999f,0.11680000f,-0.19270001f,-0.62159998f,-0.18649998f,-0.36259999f,0.39699998f,-0.19560000f,-0.21090000f,-0.21899998f,-0.37370000f,-0.03790001f,-0.16410001f,0.30440001f,0.00190000f,0.04240000f,0.16620000f,-0.02680000f,0.02110000f,-0.01859999f,-0.01469997f,-0.30369999f,0.44140000f,0.94860000f,0.72830001f,-0.34480000f,-1.24289999f,-0.75700002f,-0.04260000f,0.02300000f,0.19490000f,-0.28479999f,0.14860002f,-0.43000001f,-0.34120001f,-1.01150001f,-0.66240001f,-0.66320000f,-1.35539999f,-0.84859999f,-0.23239999f,-1.26990001f,-0.70800002f,-0.40040001f,-0.61930002f,-0.17600000f,0.49179999f,0.81149998f,0.55709998f,-0.20219999f,-0.03599999f,-0.27070000f,0.16340000f,0.24280000f,0.16310000f,0.11340001f,0.48430000f,-0.61430001f,0.40659999f,-0.53510002f,-0.37380000f,0.23299999f,-0.31960001f,0.50210000f,0.36319997f,0.40589998f,-0.55080001f,-0.54499999f,-0.61500000f,-0.01789996f,0.81659998f,0.18090002f,-0.20360001f,-0.31979999f,-0.15939999f,1.43060004f,0.07160001f,1.16740002f,0.16950001f,0.63179998f,0.30310000f,0.53539999f,0.48479998f,0.68219999f,-0.34010000f,0.93259999f,-0.08970001f,0.07809998f,-0.19579999f,0.19250000f,-0.57049998f,-0.20919998f,-0.62189998f,0.74780000f,0.04940000f,0.63120000f,-0.19420000f,-0.03340000f,-0.20720000f,-0.47790002f,-0.26210000f,0.30900000f,0.38940000f,0.33830000f,0.22260000f,0.44320000f,0.26930001f,0.55059999f,1.28659997f,0.81149998f,-0.34160002f,-0.11850001f,-0.27160001f,0.05379999f,0.49039999f,0.16070000f,-0.03100000f,-0.34459998f,-0.03369999f,-0.27360000f,-0.47909997f,0.14820002f,0.48340000f,0.75270001f,0.32870000f,-0.25540000f,-0.37059999f,-0.14370000f,-0.37900002f,0.00389998f,-0.49210001f,-0.50619999f,-0.86939999f,-0.73210000f,-0.55860001f,-0.52020001f,-0.48990001f,0.21220001f,-0.04400000f,-0.15810000f,-0.17680001f,-0.01820000f,-0.11960000f,0.32420000f,0.76530000f,-0.52000000f,-0.08020001f,-0.50580000f,-0.17220001f,-0.13940000f,-0.22160001f,-0.37559999f,-0.58739997f,-0.53019998f,0.87690003f,-0.13580000f,0.76410003f,0.37820000f,-0.27099999f,0.23720000f,-0.40600000f,0.09979999f,-0.27980000f,-0.46410000f,-0.45899999f,-0.27569998f,-0.27449999f,0.08680000f,-0.37710000f,0.13720001f,-0.09220000f,0.18980001f,1.48390003f,0.05159999f,1.24050002f,0.79240000f,0.42779999f,0.80820000f,1.01880003f,-0.06539999f,0.95580003f,-0.19299999f,0.53619998f,-0.17960001f,0.48460001f,-0.11000000f,0.41500001f,0.22140001f,-0.21580000f,0.42340000f,0.81819998f,0.27309999f,0.06299999f,-0.06670001f,-0.44050003f,0.11780001f,-0.23319999f,-0.45730000f,-0.11519999f,-0.42419998f,-0.10259999f,0.31980000f,0.68399999f,0.12889999f,-0.42500000f,-0.57329998f,-0.49129999f,0.25700000f,0.08820000f,0.00329999f,0.18100000f,0.98790001f,0.42270000f,-0.31800001f,0.09790000f,-0.16160001f,-0.35839999f,-0.86129998f,-0.66720000f,-0.59940000f,-1.09540000f,-0.74710000f,0.24660001f,0.84610001f,0.24510000f,-0.27180000f,-0.26420000f,-0.37610000f,0.01060000f,0.18850000f,0.03270000f,0.63879998f,0.19859999f,0.02160000f,0.04700000f,-0.13940001f,0.49810004f,0.67679999f,0.39710001f,0.17700000f,0.83139996f,0.15199997f,-0.26220001f,0.08400000f,-0.14340001f,0.24020001f,0.11420000f,0.06600000f,0.70070000f,0.15479998f,0.68849999f,-0.33639998f,0.35859998f,-0.31620000f,0.47110000f,-0.56199998f,0.23490001f,0.98090003f,-0.30540000f,0.81850003f,0.43330001f,0.56659998f,0.49889999f,0.64600000f,0.37379999f,0.73100000f,0.42730001f,-0.19359999f,0.20710000f,0.70160001f,0.14700000f,0.63100000f,0.21050001f,-0.08240000f,0.14470001f,-0.35089999f,-0.04540000f,-0.30240001f,-0.13209999f,0.30000001f,-0.25140001f,0.07639997f,-0.45970003f,0.10160000f,-0.12520001f,0.43140000f,0.32279999f,0.66729998f,0.20359999f,-0.39800000f,-0.45199998f,0.16920003f,0.12800000f,0.39389999f,0.09940000f,0.03200000f,0.31620000f,0.31960002f,0.08060000f,-0.02879999f,-0.08210000f,-0.07180000f,0.07600000f,-0.03350000f,0.14860000f,0.10600000f,0.18570000f,0.27240001f,0.26470000f,0.02100000f,-0.32759998f,-0.86699997f,-0.69279999f,0.63840000f,0.93489998f,0.67760001f,-0.23740000f,-0.42969999f,-0.16530000f,-0.47179999f,-0.47380001f,-0.13750000f,-0.80059998f,-0.05109996f,1.31020002f,0.18180002f,1.07480002f,-1.06760003f,-0.35799998f,-0.85360000f,0.08910001f,0.02860000f,-0.05330000f,-0.23320004f,-0.68239999f,-0.07640000f,0.19890000f,-0.05140000f,0.09450000f,-0.10020003f,-0.45400000f,-0.12180001f,-0.05580000f,0.23539999f,-0.05280001f,0.29740001f,-0.08900000f,0.23920001f,-0.40900001f,-0.04340000f,-0.36080001f,-0.12830000f,0.30619999f,-0.17270002f,0.41060000f,0.64759998f,0.47699998f,-0.84450004f,-0.17780000f,-0.87650004f,0.05110000f,-0.01960000f,0.12530001f,0.13470000f,0.07500000f,0.01580000f,0.33399999f,-0.29110002f,-0.04320000f,-0.02010000f,0.08100000f,0.14099998f,1.11179998f,0.61189999f,0.64339999f,1.13139997f,0.82449999f,0.61459998f,0.92499996f,0.77909998f,0.26520000f,0.40480000f,0.19420000f,0.35580001f,0.42750000f,-0.18910002f,-0.47460001f,-0.59629999f,0.10690001f,0.11060002f,0.06920003f,-0.39609999f,0.17279999f,1.08119997f,0.49479999f,0.15400000f,-0.15490000f,-0.14520001f,0.31680002f,-0.02519999f,-0.25180000f,0.13659997f,0.88839996f,0.42309998f,0.39820002f,0.18560000f,0.13530000f,0.49660000f,-0.74780000f,0.94220003f,0.29420000f,0.71200001f,-0.08310000f,-0.16259999f,-0.05789999f,0.42320001f,-0.90099997f,0.18780003f,-0.79640000f,-0.41659998f,-0.86179999f,-0.98039998f,-0.34019999f,-0.98059997f,-0.18520000f,0.03240000f,-0.23360001f,0.30470001f,0.65120000f,0.14249998f,-0.21070001f,-0.67559998f,-0.03049997f,0.54420000f,0.65139997f,0.41119997f,0.50919997f,-0.69439997f,0.25560000f,-0.27509998f,0.46499999f,-0.22389999f,-0.20200001f,0.80839997f,-0.20400004f,0.40140002f,-0.59979999f,0.19720004f,-0.65820002f,0.37500000f,-0.60520003f,-0.64270001f,0.49580000f,-0.33400001f,-0.26530000f,0.22360002f,-0.02080000f,0.67890001f,0.04060000f,-0.15459999f,-0.34929998f,-0.43369999f,-0.12619999f,-0.88619997f,-0.52490000f,0.54200000f,0.78179998f,0.71800000f,0.03660000f,0.06490001f,0.38230002f,0.49040000f,0.91979999f,0.73420000f,-0.02360002f,0.24809998f,0.42859999f,-0.45179998f,-0.95249996f,-0.66329998f,-0.51440000f,-0.61909998f,0.01960003f,-0.53879999f,-0.77109998f,-0.32319999f,-0.16800001f,0.11939999f,0.36220000f,-0.39440001f,-0.55530000f,-0.18400000f,0.68840000f,1.05199998f,0.66400000f,-0.05920000f,-0.60719999f,-0.15670001f,-0.71100000f,-0.04629998f,0.98910002f,-0.28780000f,0.71430002f,0.45590000f,0.42359998f,0.42769998f,-0.25239997f,0.74459997f,-0.07980000f,-0.96540003f,-0.32919999f,-0.94140002f,-0.58630003f,-0.45120000f,-0.48170001f,-0.69180002f,-0.46959999f,-0.73140000f,-0.27809999f,-0.65659997f,-0.24809997f,0.45869999f,0.44759997f,0.54329998f,-0.03210003f,-0.61780000f,0.12070000f,0.33789999f,-0.17219999f,0.43790000f,-0.10340001f,-0.75199997f,-0.07259998f,0.17610000f,-0.19580000f,0.26250002f,-0.73720001f,-0.12000001f,-0.81160002f,-0.85729999f,-0.16610001f,-0.06560001f,0.37249996f,-0.26640003f,-0.04759999f,-0.66709998f,-0.21419999f,0.05140002f,-0.59079999f,-0.02849999f,-0.35720000f,-1.09620001f,-0.59280001f,0.35480000f,0.98860001f,0.63360001f,0.34900000f,0.69420001f,0.36590001f,0.44740001f,0.28840000f,0.45110001f,-0.45500001f,-0.64910001f,-0.14990000f,0.18360002f,-0.19729998f,-0.23339999f,0.21560000f,0.39899999f,0.25840000f,0.11980000f,0.12859999f,-0.34050001f,-0.10739998f,-0.62539997f,-0.15169999f,-0.14080000f,-0.55660000f,-0.19560000f,-0.12840000f,-0.53080000f,-0.25100000f,-0.56000000f,-0.30900002f,1.10670001f,0.12780003f,0.85070000f,-0.56770000f,0.40179999f,-0.36890001f,-0.93180003f,0.29220000f,-0.68320003f,-0.04099999f,0.54439999f,0.14700001f,-0.18180000f,-0.56759998f,-0.31219999f,-0.18000001f,-0.14660000f,-0.27540001f,-1.10300002f,0.01620000f,-0.98000002f,0.08969998f,-0.30279998f,0.21310001f,-0.24950002f,0.63499998f,-0.20270004f,-0.20820001f,-0.12280000f,-0.24420000f,0.52680002f,0.57659999f,0.38899999f,-0.49840001f,0.21899999f,-0.30980001f,-0.26420000f,0.20359999f,-0.12580000f,-0.15840000f,0.28519999f,-0.04600000f,0.97070002f,0.59950000f,0.21800000f,0.47580000f,0.45720001f,0.51880000f,0.61180000f,0.61320001f,-0.12340002f,0.27539998f,0.40549999f,0.70079999f,1.03509997f,0.59059998f,0.21000001f,0.30460001f,-0.03140000f,0.38019998f,0.82029996f,0.38149998f,-0.36560001f,0.03550001f,-0.42760000f,0.04199999f,0.37109998f,0.09199999f,-0.28660001f,-0.21489999f,0.04970001f,-0.09280000f,-0.14720000f,0.23840000f,-0.48860000f,-0.56330000f,-0.45910000f,-0.03559999f,-0.14969999f,0.04220001f,-0.08800000f,0.25600002f,-0.30520001f,-0.26139999f,-0.82399998f,-0.40809999f,0.22200000f,-0.67679999f,-0.41860002f,-0.39560000f,-0.42180001f,-1.00900002f,-0.17960001f,-0.95300002f,-0.02000000f,-0.78659997f,-0.03059997f,-0.66629999f,-0.00260000f,-0.75470000f,0.12860001f,0.26639999f,0.03699999f,-0.07249999f,-0.15719999f,-0.20869999f,1.40290002f,-0.01980001f,1.17010001f,0.33170001f,-0.16540000f,0.21570001f,0.11430000f,-0.43280001f,0.15770002f,-0.43840001f,-0.39999998f,-0.31999999f,0.77830001f,0.01440001f,0.75850001f,-0.22830001f,-0.06260000f,-0.15990000f,1.03520004f,0.17839999f,0.81040002f,-0.10420001f,0.37219999f,0.05079999f,0.03630002f,0.21240001f,0.48459999f,0.50079997f,0.03509998f,-0.30460000f,0.07490001f,-0.37270000f,0.07139999f,0.78629999f,0.21290000f,0.28960000f,0.56880000f,0.34360000f,-0.11979999f,-0.04149997f,0.41330003f,0.54240000f,0.72410000f,0.28239999f,-0.14399998f,-0.88329998f,-0.63340001f,0.43000000f,0.93890000f,0.67340000f,-0.05600000f,-0.69180000f,-0.15760000f,-0.00900000f,-0.19419999f,-0.07450000f,-0.53880001f,-0.52000000f,-0.32560000f,0.42639999f,1.27969997f,0.72980000f,0.12799999f,0.51339999f,0.42040000f,-0.26940000f,-1.16950001f,-0.59130001f,0.08619999f,-0.36500000f,-0.17979998f,0.53859997f,-0.27200000f,1.26330002f,-0.00920000f,1.04510001f,0.70550001f,-0.39999999f,0.46170001f,-0.22480000f,-0.17040000f,-0.28800000f,-0.51390003f,-0.69559998f,-0.38890000f,-0.34889997f,0.24379998f,-0.44170000f,-0.04069997f,0.85499999f,0.09170000f,-0.45610000f,-0.48939998f,-0.53649999f,-0.68100002f,0.32439999f,-0.45540001f,-0.15440000f,0.13980000f,-0.09940001f,0.71800002f,-0.24480000f,0.71240003f,-0.03010003f,-0.66939999f,-0.23530001f,-0.14060001f,-0.49639999f,-0.19099999f,-0.31150001f,0.69759999f,-0.07330002f,-0.82960000f,0.47899999f,0.50760000f,0.70820000f,0.31620000f,-0.44159999f,-0.72669998f,-0.63659999f,0.27280000f,0.04299999f,-0.33940003f,-0.15180000f,0.32720001f,0.41850002f,-0.15820001f,-0.03600002f,0.38690000f,-0.30579999f,0.12020002f,-0.47290000f,-0.26779999f,-0.60299998f,-0.48209999f,-0.64980001f,-0.76699999f,-0.51330000f,0.32240000f,-0.09830003f,0.49059999f,0.20620000f,-0.04829999f,0.23590001f,0.20920000f,0.42870000f,0.12180000f,0.24040000f,0.50180000f,0.34960000f,-0.19299999f,-0.81699998f,-0.28069999f,-0.53940000f,-0.45720000f,-0.41290000f,-0.36760002f,-0.79149999f,-0.36460000f,0.15280000f,-0.44740001f,0.73550000f,0.36099998f,0.73669999f,0.12100004f,0.83279999f,0.05260000f,0.08779997f,-0.86179999f,0.05360000f,-0.39380002f,-0.72179997f,-0.28799998f,1.49520002f,0.10300001f,1.22540000f,0.35800000f,0.39019998f,0.39539999f,0.85120002f,-0.09940000f,0.86380003f,-1.52090004f,-0.10699998f,-1.25090002f,-0.82509999f,0.02639998f,-0.68369999f,0.06850001f,0.03260000f,-0.02550000f,-0.24620000f,-0.23239999f,-0.29020000f,-0.42279999f,0.31139998f,-0.21460000f,0.95419999f,-0.15339999f,0.89400000f,-0.20060001f,0.38020000f,-0.44619999f,-0.46859998f,-0.55209999f,-0.29720000f,-0.33680000f,0.09920000f,0.30380001f,0.45410000f,0.22750000f,-0.27579999f,-0.96559998f,-0.58230000f,-0.62780000f,-1.01630000f,-0.59629999f,-0.32579999f,-0.61819998f,-0.03009999f,-0.72139998f,-1.15029997f,-0.79269998f,0.22619999f,0.43039996f,0.06249998f,-0.37040000f,-0.91930001f,-0.49540000f,0.65740000f,0.69029997f,0.71329999f,0.23039999f,0.37869998f,0.00719999f,-0.41199999f,-0.54030000f,-0.30360000f,-0.20060000f,-0.76430002f,-0.09390000f,-0.19400000f,0.11670000f,-0.45560000f,-0.55840001f,0.22910000f,-0.63940004f,-0.12679996f,-0.31480001f,0.35320008f,-0.21820007f,0.20890003f,-0.00570005f,-0.42599995f,0.01549998f,1.14700005f,-0.80980001f,0.61370003f,0.58760000f,-0.51599999f,0.33760000f,-0.47019997f,0.44479998f,-0.24420000f,-0.98679997f,1.12579997f,-0.55270000f,-1.40309996f,1.34779997f,-0.76220000f,-0.06449999f,0.17839999f,-0.04949999f,-0.39100003f,0.79900001f,-0.25470001f,-0.45379998f,1.18719997f,-0.29540000f,0.82990003f,-1.11440001f,0.48650002f,0.32109999f,-0.18359997f,0.18589998f,-0.45460001f,1.03300001f,-0.30130001f,-0.75460005f,0.00370000f,-0.18259999f,-0.00010000f,-0.48720000f,-0.44159999f,-0.03750000f,0.07030000f,0.17279999f,-0.04950000f,0.24030001f,0.97639999f,0.34450000f,0.90250001f,0.65059999f,0.16629999f,0.21940000f,0.52380001f,0.25680000f,0.01430001f,-0.32539998f,0.08330000f,0.52560001f,-0.51520002f,-0.29090000f,-0.97270003f,0.69500003f,0.22960001f,0.31070004f,0.14719999f,0.00790000f,0.30770001f,-0.31340003f,-0.20830001f,-0.29200002f,0.45960003f,0.28740001f,0.93360001f,0.68440000f,0.21020000f,0.53040001f,-0.15100000f,0.04330000f,0.47960001f,-0.39479999f,-0.72350001f,0.02260003f,0.64199997f,-0.02679999f,-0.82389997f,0.77779996f,-0.44680000f,0.15869996f,-0.70839997f,0.11549999f,0.94809999f,-1.13519996f,0.54630000f,0.93339999f,-0.83539997f,0.51090000f,0.81370002f,-0.07200002f,0.41350000f,-0.99559997f,0.80859995f,-0.52450000f,-0.09630001f,0.38240001f,-0.08650000f,0.91950004f,-0.71020002f,0.50060002f,0.03929998f,-0.44239998f,0.04549999f,-0.25960005f,-0.04819996f,-0.13530002f,0.02640004f,-0.25560001f,0.04500001f,0.75159999f,-0.87759998f,0.42800000f,-0.63300002f,0.27840000f,-0.32020002f,-0.75919998f,-0.11100002f,-0.14380000f,-0.02240000f,0.20690001f,0.14020000f,0.22160000f,0.32490000f,-0.23860000f,-0.01010000f,0.16600000f,-0.61440001f,-0.41130000f,-0.88150001f,0.30200003f,0.24010000f,0.59570003f,0.24659999f,0.18810000f,-0.26520001f,0.72580003f,0.20720001f,0.21970003f,-0.48000000f,-0.14910000f,-0.24210000f,-0.48899999f,-0.13800000f,-0.69129999f,-0.92760003f,-0.29760001f,-0.67100004f,0.01400000f,0.05950000f,0.21670000f,-0.77299999f,-0.13360000f,-0.35930001f,-0.54600000f,-0.16140000f,-0.38880001f,0.38500001f,0.24679999f,0.52530000f,0.65640000f,-0.22540001f,-0.39570001f,0.11920000f,-0.19990001f,-0.07969999f,0.46920002f,-0.05290001f,-0.54139999f,0.39999999f,-0.28620000f,-0.28610003f,0.04580000f,-0.16580000f,0.00750004f,0.05779995f,0.01460001f,0.54840002f,0.38500002f,0.25410000f,1.04970004f,-0.82780002f,0.56920003f,-0.61950000f,0.54419999f,-0.34080000f,-0.31849998f,0.83299997f,-0.21140000f,-1.04740002f,1.11200000f,-0.59020002f,-0.15649999f,0.11399999f,-0.07890000f,-1.06649997f,1.31219996f,-0.60140000f,-0.62699999f,0.70979998f,-0.35490000f,0.20350003f,-0.06160002f,0.11690001f,1.20560000f,-0.65050001f,-0.20140000f,-0.02180000f,-0.26730001f,-0.80340002f,-0.13200001f,-0.15770005f,-0.31660000f,-0.10010000f,-0.64020001f,-0.33860002f,-0.25720001f,-0.30210001f,-0.13560000f,0.07320000f,0.16539999f,0.52080001f,0.18360000f,0.87280003f,-0.41480000f,-0.07810000f,-0.58450002f,-0.32240001f,-0.07090000f,0.36209998f,0.59079999f,0.18080000f,0.09500000f,-0.37780002f,-0.10130001f,-0.19400002f,-0.55399999f,-0.10210000f,-0.33570000f,0.19619999f,0.01200000f,0.13730000f,0.34140000f,0.14430000f,0.34960001f,0.46559999f,-0.00690000f,-0.04310000f,-0.49560005f,-0.47490000f,-0.15909999f,0.48280000f,-0.10670000f,-1.26610000f,1.28620000f,-0.69640002f,-0.06339999f,0.58899999f,-0.07130000f,-0.27590003f,-0.19480000f,-0.13750000f,-0.39339998f,0.52639999f,-0.21700000f,0.22519999f,-0.79960000f,0.16700000f,-0.28869998f,0.87059999f,-0.19560000f,-0.80510001f,0.23000001f,-0.40750001f,0.90920000f,-0.58099998f,0.48510000f,-0.49220002f,0.49800002f,-0.27360002f,-0.70549998f,0.95219999f,-0.40360000f,0.24729998f,-0.44859998f,0.14680000f,0.29660000f,-0.31280000f,0.17060000f,0.86689997f,-1.03199996f,0.47990000f,-0.75590008f,-0.73120001f,-0.41700001f,-0.23010000f,-0.87840002f,0.04580002f,0.19450000f,0.47160001f,-0.34120001f,0.05770000f,0.15689998f,0.68640001f,0.36720000f,0.69280001f,-0.30580000f,-0.22790000f,-0.18899999f,0.93519999f,0.27170000f,1.19430001f,-0.38299999f,-0.09490000f,-0.09539999f,-0.29900000f,-0.05740000f,0.26070000f,0.56499998f,0.10429999f,-0.23180003f,0.39240000f,0.21360000f,0.57380001f,-0.83020000f,-0.09320000f,-0.03750001f,0.15319999f,-0.10340000f,-0.29320000f,-0.61160000f,-0.14890000f,-0.12090002f,0.98539999f,0.31030000f,0.85600001f,-0.88400002f,0.09380000f,-0.01500001f,0.37720000f,-0.04320000f,-0.34179996f,0.48959999f,-0.18260000f,-0.74829999f,0.91720001f,-0.41270001f,0.56960002f,-0.29760000f,0.31520000f,-0.31120002f,-0.19880001f,-0.15260000f,0.69729998f,-1.49699995f,0.44180000f,-0.57499999f,0.48779998f,-0.31270000f,-0.69650001f,0.28580000f,-0.35740001f,1.13100000f,-0.68659997f,0.59410001f,0.19660001f,-0.24240000f,0.12220000f,-1.41729999f,1.44999999f,-0.77690002f,0.52979997f,-0.62979998f,0.28730000f,-0.94190000f,0.77459999f,-0.51040001f,1.01259997f,-1.27679995f,0.58379999f,-0.99650002f,0.47470002f,0.00840000f,0.07770000f,0.58690002f,-0.02400000f,0.03270000f,0.31690000f,0.09860003f,0.14800000f,0.20130002f,0.75640001f,0.12890000f,0.49570002f,-1.04880001f,-0.19650000f,-0.33070004f,-0.05300000f,-0.10750000f,-0.23780000f,0.29920004f,0.19100001f,-0.21019997f,-0.84040003f,-0.15530001f,-0.35570005f,-1.15620002f,-0.29580001f,-0.92750004f,-1.08760003f,-0.19610001f,-0.14570003f,-0.61600004f,-0.27830001f,-0.79090004f,0.68060000f,0.18220001f,0.70930002f,0.05000002f,0.06250001f,-0.20309998f,0.20620001f,0.06170000f,0.24820001f,-0.19440001f,0.26280001f,-0.43990001f,0.02040000f,-0.20950001f,-0.28450000f,0.03460000f,-0.13780000f,-0.03309995f,0.31019995f,-0.02539998f,0.94110000f,-1.36299999f,0.54340002f,-1.55270000f,1.63840000f,-0.85970002f,0.12299999f,-0.22099999f,0.06610000f,0.60180006f,0.25439997f,0.28780002f,-1.18010001f,1.36680001f,-0.66090003f,-1.27330000f,1.74919998f,-0.73690002f,-1.75490004f,1.63400002f,-0.95730004f,-0.41250004f,0.56760002f,-0.24970002f,0.62889999f,-1.07619997f,0.37860000f,0.20750003f,0.25499998f,0.08920001f,0.16380000f,-0.31500000f,0.10150000f,-0.48060003f,-0.20899998f,0.30500001f,0.07390000f,0.43260000f,0.38160001f,0.10290000f,0.32150001f,1.08940000f,0.25190001f,0.71480003f,-0.04700001f,-0.01450000f,-0.50180002f,0.46020000f,0.12330000f,0.07280001f,-0.35300000f,-0.12610000f,-0.10040001f,-0.58200000f,-0.35310000f,-0.76470001f,0.70480003f,0.27680001f,0.86320004f,-0.35520000f,-0.15150000f,-0.47490002f,0.16319999f,0.13679999f,-0.37960003f,-0.67620000f,-0.11730000f,-0.61000002f,-0.40380001f,-0.12630000f,-0.84480003f,0.02940001f,0.13530000f,0.55020001f,0.01320000f,-0.00180000f,-0.26840001f,0.59060002f,0.19670001f,0.20300000f,-0.57180000f,0.13630001f,0.40690001f,-0.56260001f,0.23620001f,1.32559998f,-1.68299996f,0.75570001f,0.28200002f,0.29000001f,0.11860000f,0.71680000f,-0.52619999f,0.38530000f,-0.50400000f,0.29219999f,-0.26870000f,-0.33750000f,0.16319999f,-0.19409999f,0.52020002f,-0.80500001f,0.31570001f,-0.22829999f,0.37459999f,-0.14160000f,0.50380003f,0.40780000f,0.22810000f,-0.72079998f,1.29219998f,-0.43190001f,-0.06120000f,0.77100001f,-0.08250001f,-0.40139999f,0.23619999f,-0.20010000f,0.21680001f,0.09600000f,0.09920001f,0.37240003f,-0.07200000f,0.79060000f,0.31190000f,0.79740002f,0.10180000f,0.22640000f,0.46690000f,-0.06339998f,0.18850000f,0.56100001f,-0.41700000f,-0.14820000f,-0.23190000f,0.69620002f,0.30190000f,0.67620003f,-0.44940000f,-0.10260000f,-0.58130002f,0.11080000f,0.11630000f,0.53750000f,0.89480004f,0.22000001f,0.21580005f,0.14120001f,0.01930000f,-0.50110001f,-0.68140000f,-0.10010000f,-0.35900001f,-0.91580002f,-0.22750001f,-0.83000004f,0.81760004f,0.27980001f,0.46460005f,-0.15580000f,0.00670000f,-0.30340000f,0.18720001f,0.05940000f,0.03060000f,0.94639999f,-0.13220000f,0.70539999f,-0.81259998f,0.40790000f,-0.25229998f,0.50380001f,-0.13820001f,-0.59859996f,0.66019996f,-0.31730000f,-0.51450000f,0.40439999f,-0.28170000f,0.62780002f,-0.58740000f,0.35650001f,-0.34209997f,0.84139997f,-0.22119999f,-0.23829999f,-0.01700000f,-0.10740000f,1.34920003f,-1.14340001f,0.73350003f,0.60330003f,0.01880000f,0.29210001f,-0.91759998f,1.25239997f,-0.52380001f,-0.94320000f,1.46139999f,-0.55610001f,1.00640004f,-0.84340002f,0.55350003f,-0.06419998f,0.52099999f,-0.06130000f,0.28680001f,-0.17540000f,0.15270001f,0.71609999f,0.33919998f,-0.27580000f,-0.30770000f,-0.87980002f,0.23679999f,0.18950000f,-0.13190000f,-0.28860003f,-0.24240000f,-0.15990001f,0.65040000f,0.25710000f,0.61970001f,-0.57060001f,-0.39420000f,-1.02990002f,0.38720001f,0.14230000f,0.25490001f,0.21440000f,-0.03500000f,-0.13059999f,0.00680001f,0.05830000f,0.22430001f,0.08760001f,0.02370000f,-0.10550000f,0.05220000f,-0.00810000f,0.17460001f,0.29140001f,0.18050000f,0.58760002f,-0.67539998f,-0.07880000f,-0.27690000f,0.77580000f,0.21449999f,0.93500003f,-0.40800000f,-0.15720000f,-0.43200002f,-0.76100000f,-0.32660001f,0.27279999f,-0.26120000f,0.12900001f,0.43470000f,0.34660003f,0.20139999f,-0.29490006f,-0.31239996f,-0.13890002f,0.60610000f,-0.64839999f,0.34690000f,-0.10890002f,0.09519999f,-0.08189999f,0.44730001f,-0.37520000f,0.24710000f,0.49259999f,-0.55520001f,0.26900001f,-0.17429999f,0.12099999f,-0.08800000f,0.22190001f,-0.04020001f,0.11120001f,-0.02820001f,-0.23540000f,-0.00030000f,0.02060001f,-0.16720001f,0.03060000f,-0.97509996f,1.28879995f,-0.55250000f,0.62319998f,-1.26039999f,0.38860000f,-0.35100000f,0.44539999f,-0.20550000f,-0.59849999f,0.05839997f,0.46420002f,0.28790001f,0.32620002f,-0.05520000f,-0.06450000f,-0.15630000f,0.95060001f,0.15550000f,0.00660002f,0.92760000f,0.21510000f,0.86470002f,0.72499998f,0.14949999f,0.80379999f,0.37280001f,0.14140000f,0.46100002f,0.54920002f,0.38140001f,0.95520004f,-0.70480002f,-0.44240000f,-1.16320003f,0.23180004f,0.27130001f,0.55380004f,0.96519999f,0.21560000f,0.15900003f,-0.09680000f,0.06650000f,0.40069999f,0.09260001f,0.22600000f,0.84150002f,0.78639998f,0.16669999f,0.10649998f,0.17380001f,0.13070000f,0.73820003f,0.59760000f,-0.44460002f,0.46980004f,0.03659999f,0.24250001f,0.04169999f,-0.07439999f,0.02070000f,1.62740000f,-1.43579998f,0.88150002f,0.94489997f,-1.55699996f,0.56180000f,0.65499996f,-1.35899994f,0.40589999f,0.27420001f,-0.44920000f,0.16760000f,0.12980002f,-0.06540001f,0.08950000f,-0.23220003f,0.25220001f,-0.15370000f,-0.10179995f,0.36499995f,-0.05449999f,1.51779998f,-1.28879997f,0.82340000f,-0.48970000f,0.29640001f,-0.25050001f,-0.53709998f,0.33719997f,-0.26630000f,1.25709999f,-1.07659996f,0.68180001f,-0.27580001f,-0.19380000f,-0.11430001f,0.46139997f,-0.13140001f,-0.38960002f,-0.32950001f,-0.90810004f,0.69920003f,0.23530001f,0.05150002f,-0.21499999f,0.04220000f,-0.03450000f,-0.74459999f,-0.10890000f,-0.00380001f,0.59179999f,0.10240000f,0.67790002f,-0.07420000f,-0.16400000f,-0.21790000f,0.72740000f,0.13060000f,0.58550002f,0.09699998f,-0.13690000f,-0.34340001f,-0.78599999f,-0.16800000f,-0.56940001f,-0.69860001f,-0.41830000f,-1.17900003f,-0.73040000f,-0.30490000f,-0.98390001f,-0.02420001f,-0.19900000f,-0.60870001f,-0.54500001f,-0.24730000f,-0.76040003f,0.90820000f,0.28340000f,1.06950002f,-0.53880000f,0.12639999f,0.09909999f,-0.08920000f,0.03350001f,1.11030005f,-0.56720003f,0.58490003f,-0.37849997f,0.66859996f,-0.22000000f,-1.28139997f,1.17859997f,-0.69610000f,0.52769996f,-1.20319998f,0.33230000f,0.09569999f,-0.42340001f,0.06140001f,0.82409998f,-1.33639998f,0.48530001f,0.47999996f,-0.62319996f,0.26080000f,-0.92399997f,1.29899995f,-0.53370000f,-0.22040001f,0.34839998f,-0.15219999f,-0.46710000f,0.80199998f,-0.29150000f,0.48069997f,-0.48839997f,0.24950000f,-0.32100001f,0.52760000f,-0.20120000f,0.73329999f,-1.32639999f,0.44990000f,-0.58270002f,0.45860002f,0.48939999f,0.26330000f,0.14780002f,-0.62580000f,-0.16170000f,-0.05040001f,-0.60860001f,-0.19750000f,0.01760000f,-0.95740003f,-0.23000001f,-0.45950004f,0.82820003f,0.16600001f,0.40210004f,0.61900002f,0.19070001f,0.54880003f,0.16580000f,0.02050000f,0.60600001f,-0.66140003f,-0.32140001f,-0.92850003f,-0.10579999f,0.10610000f,0.52340002f,0.33860000f,0.08920000f,0.30770000f,0.27400001f,0.26810000f,0.53930001f,-0.60999999f,-0.19789999f,-0.21430000f,-0.52320001f,-0.15900000f,-0.23460002f,-0.47400001f,-0.11580001f,-0.16040002f,-0.60240000f,-0.32530001f,0.65359999f,-0.03479997f,0.33419998f,-1.01220000f,0.71679999f,-0.54180001f,-1.01440003f,0.49380000f,-0.53190002f,-1.28210002f,1.35920001f,-0.71430002f,1.12030002f,-1.31760001f,0.62970003f,0.63000002f,-0.82540001f,0.36490002f,-0.14680002f,-0.57739999f,-0.03590000f,-0.37610004f,0.55300002f,-0.23380002f,-0.61119999f,0.42319997f,-0.31440000f,0.34589999f,-0.51919999f,0.20330000f,-0.01449998f,0.26579999f,-0.00660000f,-0.85050000f,0.60979998f,-0.45940000f,-0.69780001f,0.59360000f,-0.38220001f,-0.68200000f,0.63160000f,-0.37420001f,-0.50609996f,0.27810001f,0.34420000f,0.01520000f,0.16850001f,0.45060000f,0.08400000f,0.68250001f,0.12719999f,-0.14670000f,-0.52330001f,0.91920000f,0.31950000f,1.15010002f,0.34880002f,0.20320000f,0.50960002f,0.74839999f,0.24160000f,0.62340000f,0.17300002f,0.11950000f,-0.39780000f,0.35959999f,0.10930000f,0.08129999f,-0.26680000f,-0.20300000f,-0.66360003f,-0.25280001f,-0.21280000f,-0.40640000f,-0.45580000f,-0.13640000f,-0.73470001f,-0.17659999f,-0.09190000f,-0.13400000f,0.37960004f,0.23120001f,0.11140003f,-0.73340000f,-0.19030000f,-0.36080001f,0.27540000f,0.29300000f,0.48829999f,-0.77600000f,0.28290001f,0.27989999f,-0.97280000f,0.19770001f,0.66729997f,-0.64219997f,0.35200000f,0.67929999f,-1.23759996f,0.42070000f,0.16920003f,-0.15880002f,0.10340001f,0.78559998f,-0.93139996f,0.44949999f,0.54200005f,0.32199997f,0.25060002f,0.53690000f,-0.36839999f,0.28810000f,0.08780001f,0.05539999f,0.02710001f,-0.06720003f,-0.14399998f,-0.03680000f,-0.22869999f,0.78820000f,-0.16520000f,-0.17940000f,0.06559999f,-0.09620000f,0.49740006f,0.08879997f,0.24940002f,-0.96960000f,0.98579998f,-0.53870001f,0.01760000f,-0.40660001f,0.55079999f,0.33389999f,1.05269999f,0.19820002f,0.12580001f,-0.30989999f,0.75380002f,0.21640001f,0.12210002f,0.49080001f,0.13440000f,0.42220002f,-0.20979999f,-0.27259999f,-0.58109998f,0.69660002f,0.30930000f,1.01500002f,-0.70159999f,-0.05649999f,0.04690001f,0.76620002f,0.15030001f,0.51440003f,-0.67400002f,-0.20380001f,-0.11720002f,-0.17720000f,-0.03910000f,0.00490000f,-0.46460001f,-0.20620000f,-0.93530004f,1.10400000f,0.25170000f,0.52550002f,0.39120000f,0.01980000f,0.02140000f,-1.02880004f,-0.23060001f,-0.29540004f,-0.28140003f,-0.10140000f,0.08370001f,-0.31819998f,0.07919999f,0.52130005f,0.24979997f,0.24520002f,1.16570002f,-0.80220000f,0.62440002f,0.51620000f,-0.71920000f,0.30020001f,0.16129999f,-0.40540002f,0.08560001f,0.38240002f,-0.72440000f,0.24620001f,-1.26389999f,1.28079999f,-0.69050001f,0.93580000f,-1.30319999f,0.53860002f,-1.03200003f,0.67760001f,-0.55160002f,-0.30330000f,0.22180000f,-0.16220000f,-0.06989999f,0.61120000f,-0.08209999f,1.48749999f,-1.62239998f,0.83050001f,0.67579999f,-0.78719999f,0.37460001f,-1.52720004f,1.43260002f,-0.83730004f,-0.38760004f,0.15429999f,0.66440002f,0.27400000f,0.91420003f,-0.55720000f,-0.09110000f,-0.52790002f,0.19460000f,0.28420000f,0.83430001f,0.17480000f,-0.14270000f,-0.58190000f,-0.19680003f,-0.26910000f,-0.63730002f,0.28400004f,0.19570001f,-0.22409996f,-0.47259999f,-0.06770000f,-0.27380000f,-0.66200001f,-0.23950000f,-1.05790004f,-0.26640005f,-0.19110001f,0.24789998f,-0.12540000f,-0.07560000f,0.22329998f,0.42140002f,0.17050000f,0.40900002f,0.41420001f,0.08920000f,0.30470002f,-0.76940000f,-0.23230000f,-0.32160002f,-0.36520000f,-0.13610000f,-0.85530000f,-0.51000003f,0.03489999f,0.41260001f,-0.75320000f,0.26040001f,-0.57829997f,1.10079997f,-0.35010000f,-0.37509999f,0.36280001f,-0.18590001f,0.79269999f,-0.70100001f,0.41640001f,0.22329995f,-0.39139996f,0.11499999f,0.58250005f,0.31459997f,0.27520002f,-0.61939997f,0.88819996f,-0.35610000f,-0.32049999f,0.96499999f,-0.22620000f,-0.57010009f,-0.34559994f,-0.26710004f,-0.35110000f,-0.15460000f,-0.16540000f,0.38560002f,-0.40720001f,0.22080001f,0.48330000f,-0.68400000f,0.27950001f,-1.04359999f,0.86779998f,-0.57010000f,0.01970000f,0.64979999f,-0.03680000f,-0.06900003f,-0.24740001f,-0.31739999f,-0.03690000f,-0.55659999f,-0.41500001f,-0.27979999f,-0.74730000f,0.41500001f,0.15560000f,0.52230003f,-0.81760000f,-0.15830000f,-0.27770002f,-0.89180002f,-0.28540001f,-0.99330004f,-0.66480001f,-0.33030000f,-0.75490001f,-0.96540000f,-0.26460000f,-1.05250001f,0.44699998f,0.20789999f,0.49120000f,-0.80880003f,-0.21690001f,-0.53110004f,0.50559999f,0.10700000f,0.89980002f,0.41379999f,0.21830000f,0.53420000f,-0.48500001f,-0.18430000f,-0.69820000f,-0.78540004f,-0.31260001f,-0.47610004f,0.28200001f,0.22170000f,-0.01069998f,-0.89480004f,-0.26009999f,0.56100003f,0.90119999f,0.23020000f,0.34350001f,0.59190000f,0.65709999f,-0.35700003f,-0.49740000f,0.48779999f,-0.08449999f,-0.35110000f,-0.35549999f,0.87849999f,-0.09550001f,0.18950000f,0.37000000f,-0.17500000f,0.22879999f,-0.05600001f,-0.75100002f,-0.00640001f,0.24800005f,1.05009998f,-0.46759998f,0.19250000f,0.06100000f,-0.53050001f,0.25450002f,0.21890000f,-0.34469999f,-0.65999999f,0.51389997f,0.14419999f,-1.14899999f,0.42419998f,-0.39720001f,0.10350002f,0.44399999f,-0.23289998f,-0.02450000f,-0.01750000f,-0.03110000f,0.84950001f,0.32590001f,-0.41790000f,0.95460002f,-0.05340002f,-1.19029998f,0.79340006f,0.14499999f,-0.44530000f,-0.73249999f,0.57890002f,-0.35019997f,0.72759999f,0.82200001f,-0.05229999f,-0.51890000f,-0.09670001f,-0.99830000f,-0.38199997f,-0.10560002f,-0.18430001f,0.53320002f,-0.58180004f,-0.42610000f,-0.05330000f,0.70010002f,-0.08290000f,-2.22109995f,0.16630002f,0.22330001f,0.12319996f,-0.56260001f,-0.50270000f,-1.12779997f,0.71740002f,-0.21200004f,-1.95370002f,0.33870004f,0.87519997f,0.47479995f,-0.82139999f,0.97599999f,-1.13769998f,0.02970002f,-0.83890000f,0.45399998f,0.37450003f,0.57110000f,0.15430000f,0.68750000f,0.70390002f,0.70409997f,-0.42550002f,-0.10580001f,0.32709999f,-0.82300001f,0.73419998f,-0.04260001f,0.16850000f,-0.29840000f,0.14709999f,0.88049999f,-0.04349999f,0.81709997f,0.89700003f,0.12210001f,0.16760000f,-0.60250001f,0.29259999f,0.17170000f,-0.14450005f,-1.10799997f,0.40329997f,0.57199999f,-0.16910001f,-0.06460000f,-0.56250002f,-0.25770000f,0.40689998f,-0.27650003f,-0.88210000f,0.41550001f,0.42650000f,-0.19760000f,-0.54589997f,-0.75600001f,-0.78569998f,-0.52599999f,0.34650000f,0.63670002f,1.33860000f,-0.50010001f,-0.47769999f,-0.29879998f,-1.98569996f,0.38710001f,0.22150000f,-0.37059999f,0.33260001f,0.21380000f,-0.22610001f,-0.01730000f,-0.04380004f,-1.64880002f,0.03320003f,-0.53660002f,-0.19539998f,0.45520002f,0.26230001f,0.43790000f,-0.77230004f,1.10900002f,-0.61579999f,0.06480000f,-0.28130001f,-0.16209999f,-0.47950002f,-1.31099997f,0.37050003f,0.28049999f,0.31650001f,1.67789998f,-0.40189999f,0.43570002f,0.70429999f,-0.48190002f,-1.10450000f,0.43250004f,-0.14050003f,0.00119999f,2.11289994f,-0.24049999f,0.14600001f,0.73299999f,-0.36250001f,-0.68989999f,-0.79169999f,-0.27550004f,-0.86569999f,0.47409996f,-0.59849999f,-0.12750000f,-0.16950000f,-0.13450000f,-0.16790001f,-0.11410000f,-0.00200002f,-0.85659999f,0.30560001f,-0.19850001f,0.15560001f,0.32870000f,0.81650003f,-0.08060000f,-0.10210000f,-0.90350000f,-0.52239999f,-0.71950000f,0.83850001f,-0.19379999f,0.33510000f,0.60149998f,0.54870000f,0.83549996f,0.28349999f,0.69360000f,-0.43149999f,0.30550001f,0.12560000f,-0.33590000f,1.00050001f,0.39840001f,0.76349998f,0.30300001f,1.04129998f,-0.30939997f,0.51900000f,-0.62180003f,0.86520002f,0.68879995f,-0.91840001f,1.28649998f,-0.38200004f,-0.71400001f,-0.40449998f,-1.46719998f,0.46520001f,0.78670000f,0.18619997f,-0.43180001f,0.33899998f,-1.26239999f,0.23340002f,-0.92630002f,-0.12970001f,0.42810000f,-0.81220000f,0.05260001f,0.70700001f,0.72540000f,-0.68700001f,-0.34320001f,0.74350001f,-1.50100001f,-0.20900002f,0.34489999f,0.01120002f,-0.96540004f,0.25619999f,1.72560000f,0.01380003f,-1.05969998f,0.31150005f,0.16509998f,-0.34710003f,-1.33260002f,-0.29260001f,-0.29850000f,0.49620001f,0.01979999f,-0.40260000f,0.34660001f,0.56000000f,-0.11480001f,-0.55440000f,-0.01449998f,-0.69710000f,-0.72349997f,-0.30250004f,-0.54290000f,0.44649997f,-0.01749999f,-0.20150001f,-0.51489999f,-0.55050002f,-0.65819999f,-0.08249999f,0.12550001f,0.25759999f,0.60810001f,-0.32600000f,0.42679999f,0.43440000f,-0.08349999f,-0.62360000f,-0.34030000f,-0.26849999f,-1.01430001f,-0.24350000f,1.01100003f,-0.38909998f,-0.04880000f,-0.21750000f,0.87180001f,-0.48389998f,0.56700000f,0.42900001f,0.68639997f,0.64850000f,-0.73970000f,0.54270000f,0.19250001f,0.32890000f,0.12950000f,0.77949999f,-0.47260001f,0.97260000f,-0.17880006f,-0.44800002f,-0.76030003f,-0.10009995f,0.76750002f,-0.23149997f,0.62539998f,0.83160002f,-0.26310000f,-0.11940000f,-0.00980000f,0.78400000f,1.45909993f,-0.41809999f,-0.42199998f,-0.46839999f,-0.69560005f,-0.91590003f,-0.97169995f,0.96690002f,0.26300000f,-1.28900002f,-0.47200002f,-0.03370000f,0.77079998f,0.61180002f,0.10620000f,1.17569998f,0.68770002f,-0.45670004f,-1.22419998f,0.47880001f,0.64050004f,0.81779999f,0.17020001f,-0.19649999f,0.06570000f,-0.41670002f,0.49150002f,1.39160001f,-0.67560003f,0.08170000f,0.05419999f,-0.13199998f,-0.43740003f,-0.58519998f,-0.44299999f,0.35600002f,0.40960001f,-0.92300002f,0.65989997f,-0.11400001f,0.20850000f,-0.01530000f,0.21470000f,-0.04049999f,0.48029998f,-0.73249997f,1.22800002f,-0.40240000f,0.53599997f,-0.58450000f,-0.00919999f,0.62930000f,0.43150000f,-0.89680001f,0.12749999f,-0.78199999f,0.62389998f,-0.23659998f,-0.98749998f,0.83749998f,-0.42389998f,-0.28299999f,-0.39889999f,0.44040001f,-0.70250001f,0.36709999f,-0.64350001f,0.69200000f,-0.06800000f,0.22099999f,0.51450003f,0.41430001f,-0.45250000f,0.48050000f,0.43340002f,0.16149998f,-0.22029999f,0.55030003f,0.39199999f,-0.73760000f,0.08960001f,-0.32320002f,1.35730002f,0.40130003f,-0.24429999f,0.63280000f,0.09760000f,0.78450000f,-0.61710000f,0.12309999f,0.61600002f,0.15320000f,0.51380004f,-0.72810002f,-0.92040000f,-0.08180000f,0.61140000f,-0.25619998f,0.29900000f,1.10400002f,0.03269998f,-0.15270001f,-0.85310001f,0.91880002f,-0.07800002f,0.29500001f,1.90759996f,-0.02260000f,-0.08650000f,-0.60290000f,-0.00310000f,-0.44770001f,-1.75670001f,-0.06670001f,0.49270001f,-0.10330002f,-0.17230001f,-0.38030000f,0.74260000f,-0.84050000f,0.03800000f,-0.19749998f,-0.40400001f,-0.43840000f,-0.17999999f,-0.29450000f,0.92090001f,-0.08009998f,0.04950000f,0.41729999f,0.05010000f,-0.73949998f,-0.43980001f,-0.49449999f,-1.13150003f,0.13520000f,-0.58550000f,0.65199999f,-0.37450000f,0.70620000f,-0.84399998f,-0.15440000f,-0.46679999f,-0.61799998f,-0.25050001f,-0.77999999f,0.72950002f,0.62890001f,0.48370000f,-0.19949998f,0.94859998f,-0.53549998f,0.07150000f,-0.30460000f,0.16650000f,0.42899999f,-0.86880001f,0.64039999f,-0.13850000f,-0.20980001f,-0.30590000f,0.63449999f,-0.17090001f,1.15120004f,0.84769999f,-0.57530001f,0.31079999f,0.84839997f,0.78120001f,-0.85050002f,-0.37140000f,-0.17960001f,-0.21899997f,0.83669998f,0.19829998f,-0.43629999f,-0.71329997f,0.17970000f,1.24269997f,-0.52120006f,-0.00539996f,0.19310001f,-0.64340001f,-0.21840001f,-0.58350001f,1.04160002f,0.07140001f,-0.51729999f,-0.41270000f,0.82210000f,0.86619997f,-1.03689998f,0.10730003f,-0.47020004f,-1.89619998f,0.13180002f,0.10810001f,1.63939998f,-0.23220002f,0.04790001f,0.93609998f,0.19270000f,0.25000001f,-0.09430002f,-0.80770004f,-0.56240000f,0.57119997f,-0.10300000f,0.03010000f,-0.86340001f,-1.25999996f,0.65519997f,-0.53759997f,0.86800000f,-0.09190000f,0.72300000f,-0.10249999f,0.55489997f,-0.02450001f,0.09149998f,-0.23279999f,0.40209998f,-0.91100001f,-0.52210001f,-0.81839996f,0.14700000f,-0.45390000f,0.01479999f,0.33299999f,0.69210002f,0.23400000f,-0.69299999f,0.16079998f,0.27359999f,-0.77700001f,-0.68429998f,-0.47939998f,0.18599999f,-0.87119998f,0.63840000f,0.21550003f,0.77149999f,-0.30869999f,-0.29349999f,0.55359999f,-0.23529999f,0.87500002f,-0.37310001f,0.00500000f,0.49100002f,0.12200000f,-0.88720003f,-0.27830000f,0.32890001f,-1.00540003f,0.20140000f,0.28580001f,-0.50719999f,-0.38949998f,0.36510000f,-0.78499998f,0.55100000f,0.06800001f,1.35970002f,-0.80560004f,-0.06000001f,-0.44050001f,0.33760002f,0.71040003f,0.06920001f,0.86469999f,-0.48630001f,0.30529997f,1.19050003f,0.76610004f,-1.47300000f,0.56880007f,0.60820001f,-1.44380001f,0.34010002f,0.34230000f,-0.93890001f,-0.25690000f,0.05010000f,0.55870000f,-0.04900002f,-0.58860001f,-1.11300002f,0.35759999f,0.36039999f,1.05400001f,-0.41349998f,-0.16450000f,1.16980001f,-0.46619999f,0.22750000f,0.13730000f,0.62590001f,0.36900001f,0.40080000f,0.63980001f,-0.10100001f,0.01610000f,0.35939998f,0.48949997f,0.46959999f,0.46549998f,-0.92449999f,-0.71470003f,-0.84389999f,-0.60750001f,0.50670000f,0.11350000f,0.58200001f,0.28110000f,-0.09440000f,-1.23799998f,0.83300002f,-0.58859996f,0.29049999f,0.79700003f,0.85049998f,0.61900000f,0.57950000f,0.92459999f,0.63150000f,0.06420000f,0.71929999f,0.35850000f,-0.33510000f,-0.27490000f,0.35000002f,0.53019999f,0.67600001f,-0.56299999f,-0.48189999f,-0.66500000f,-0.23299998f,-0.51550001f,-0.92840002f,0.24499998f,-0.24680001f,-0.38270001f,-0.17949999f,0.33810001f,-0.81740002f,0.28400000f,-0.01280000f,0.38059999f,0.38500003f,-0.83280003f,-1.38510003f,-0.35639996f,0.54720002f,0.57880002f,1.05319998f,-0.20560000f,-0.45249999f,-0.69440000f,0.79240003f,-1.24650003f,0.85260001f,0.17840000f,-1.34279999f,0.59310006f,0.47929999f,0.91890003f,0.01469998f,-0.67190003f,-0.31140003f,-1.21950000f,-0.77930005f,0.28190000f,-1.91390001f,-0.09630003f,-0.50990002f,-0.45700000f,-0.47680000f,0.69730002f,0.07699999f,-0.61940002f,-0.25300003f,-0.78459999f,1.01050000f,0.22820000f,0.68930000f,-0.15900000f,0.09420000f,0.23840000f,0.62100001f,0.30660000f,0.55180001f,0.80850003f,-0.15239997f,-0.16669999f,0.31049999f,0.26730002f,0.95670000f,-0.16500000f,0.37679999f,-0.55860000f,-0.70050003f,-0.01170001f,0.28049999f,0.68500001f,0.75770001f,0.72800001f,0.36300000f,0.74070001f,0.77859997f,0.20050002f,-0.40000001f,-0.53130000f,1.26000004f,-0.85169999f,0.60080001f,-0.07199998f,-1.10520001f,0.14020000f,1.00599998f,-0.30489999f,0.55180000f,0.29550000f,-0.30570000f,-0.39110001f,-0.28300003f,-0.18090000f,0.23930001f,0.64179998f,-0.57420002f,0.76649999f,-0.98400000f,-0.44100001f,-1.03849997f,-0.45730000f,0.69330000f,-0.57189999f,0.41710000f,-0.05790000f,0.43820002f,1.19409999f,0.10530000f,-0.41640001f,2.15819999f,0.01500002f,0.49779997f,-2.03079997f,-0.03559998f,-0.18639999f,0.06190002f,-0.35570002f,-0.76629999f,0.17920003f,0.36920000f,-0.74550000f,0.97590002f,0.35410000f,-0.95509998f,-0.45129996f,0.15609999f,-0.06420000f,0.69689998f,0.71470004f,0.02340000f,-0.78449999f,0.35630001f,-0.85170001f,0.47039999f,0.09420000f,-0.34319999f,0.01650000f,0.57250001f,0.09950000f,-0.16210000f,0.01600000f,-0.82269999f,-0.29900000f,-0.13750002f,0.19539998f,0.68949997f,0.49749998f,0.31400000f,0.35929999f,-0.46950000f,0.58469999f,-0.54590000f,0.27699999f,1.23380000f,-0.06619999f,-0.31100001f,-1.18899998f,-0.01060000f,0.60450001f,-0.05129999f,0.20129999f,0.08249999f,0.37050000f,0.45109998f,0.08250001f,0.78480000f,0.30350000f,0.50549998f,0.00000001f,0.74169996f,-0.89400002f,0.62549999f,-0.22359999f,-0.48050001f,-0.30070000f,0.04070000f,0.50500000f,0.44870000f,0.52240000f,0.24150001f,0.72270001f,-1.02970002f,0.87100003f,0.39960001f,1.25600000f,-0.38810006f,0.13210002f,-0.57590000f,0.66320002f,0.40100001f,0.84880001f,-1.39480004f,-0.15459999f,0.04040001f,0.37390000f,-0.57810004f,-0.67199999f,0.80370001f,-0.00070001f,-0.52549998f,-0.76419996f,0.22420000f,0.12940000f,-0.26290000f,-0.02130001f,0.85460001f,-0.98779999f,0.03400000f,0.09850000f,0.33529998f,0.32670001f,-0.08170000f,-0.65989999f,-0.22050001f,-0.15939998f,0.77979997f,0.59740000f,0.61119998f,-1.25199998f,0.16840002f,-0.16970000f,0.53570000f,-0.14610000f,-1.09309999f,0.08000000f,0.23400000f,0.80010001f,0.51940000f,-1.10200001f,-0.40730003f,-0.87999998f,-0.10300000f,0.60130000f,0.22280000f,-0.41850002f,-0.96000002f,-0.35010000f,0.72650003f,-0.00530000f,0.02970000f,0.49450000f,0.55850000f,0.35449999f,0.09949998f,-0.22729999f,0.46649997f,-0.06650000f,-0.17230000f,-0.04530000f,-0.67250000f,-0.68080000f,-0.46370000f,-0.50350000f,0.26979999f,-0.19849999f,0.35349999f,-0.40959999f,0.21889999f,-0.66999999f,0.64839997f,-0.14320000f,-0.66700001f,-0.72799998f,-0.26939999f,0.31450000f,0.26840000f,0.06390000f,-0.49450002f,-0.01080000f,0.67720001f,-1.87120004f,-0.10139999f,-0.40219999f,-0.71770000f,-0.17070002f,-0.53880001f,-1.20869999f,-0.07090001f,-0.63700001f,-0.02989998f,0.42890002f,-1.22809999f,-0.46119997f,0.43000000f,1.04349997f,0.45859997f,-0.67860000f,-0.90760000f,-0.45079997f,0.26760000f,0.12069997f,-1.03930001f,-0.69830001f,0.21380001f,-1.40390001f,0.09550000f,-0.87650001f,-0.89919997f,0.95120002f,-0.36780001f,-1.72949992f,0.13690001f,0.04410000f,-0.14400001f,-0.65880005f,0.01989998f,1.50080001f,0.07200002f,-0.11549999f,0.84149999f,-0.24850001f,-1.23840001f,-0.40249997f,-0.35850003f,-1.16160002f,-0.15490001f,0.52600000f,-0.36070000f,0.45239998f,0.49899999f,-0.56110000f,0.61459999f,-0.09050001f,0.25430000f,0.37950000f,0.34849998f,0.14110000f,0.88469997f,0.11450001f,-0.19069999f,-0.69649997f,0.32399999f,0.02880001f,0.68319998f,0.83250000f,-0.81299999f,0.23710001f,-0.27600002f,-0.75570001f,0.06239999f,-0.59350002f,0.01630000f,0.59149999f,0.10249997f,-0.80089996f,0.53409997f,0.83250004f,-0.30870001f,0.13230000f,-0.11750000f,0.81830001f,-0.28529998f,0.40700001f,0.38560000f,-0.00600000f,-0.01250002f,0.70360001f,-0.09969998f,-1.03009999f,-0.21030002f,0.95780000f,0.02440000f,-1.07080001f,-0.81069999f,-0.47329996f,0.74190000f,0.12959998f,-0.89849996f,-0.27329999f,1.13750001f,-0.48830000f,-0.26470000f,-0.63169998f,1.20439997f,0.02020000f,1.36380002f,0.55290003f,-0.73530001f,-0.37900002f,1.94590004f,0.13310001f,0.54230000f,0.46660001f,-0.63600002f,-0.32000000f,0.60410000f,0.69190003f,0.16809999f,-0.00669999f,0.65390003f,0.83410000f,-0.79180000f,-0.36300000f,0.05530001f,0.23539999f,0.24520000f,-0.62929999f,1.27069998f,0.13670001f,0.04850000f,0.63129998f,0.35549999f,-0.59940000f,0.29289997f,0.69500000f,-0.53779998f,-0.47659999f,-0.36999999f,0.15880000f,0.51539998f,0.26749999f,-0.59569997f,0.11630000f,-0.49300001f,-0.57199999f,-0.69200000f,0.43499999f,0.77069998f,0.25239999f,-0.04899999f,-0.22249997f,-0.93460000f,0.09550002f,1.15370002f,-0.08249998f,0.43000002f,-0.07389999f,-0.34060000f,-0.67400001f,0.61849999f,-0.01600000f,-0.98250000f,0.18540000f,-0.26069999f,-0.13750001f,-0.70729999f,-0.39770000f,-0.36400000f,0.19749999f,-0.13260000f,0.27999999f,0.84499999f,0.21460000f,-0.35450002f,0.65640003f,0.66869999f,-0.30809997f,-0.36649999f,0.97360001f,0.26149998f,-0.09829999f,0.15989999f,-1.12649998f,-0.02270000f,1.31560002f,-0.22180003f,-0.68500002f,-0.32089999f,-0.96640005f,-0.54940002f,1.60070006f,0.50229998f,-1.16690006f,0.85810002f,0.42949998f,-0.20030000f,0.20630000f,1.05970000f,-0.47310003f,-1.50440000f,-0.09729993f,0.62950001f,-0.25870002f,-0.63470000f,0.24330001f,1.69100001f,-0.96230008f,-0.22169999f,-0.20310002f,-1.71149996f,-0.15970000f,-0.39509998f,0.22889996f,0.74390002f,-0.26530001f,-1.54219998f,-0.34440001f,1.05279997f,0.52320001f,-0.01300001f,-0.41899997f,-0.35840000f,-0.59400000f,-0.08490001f,-0.73519999f,-0.08250000f,-0.63779998f,0.07970000f,-0.07499999f,-0.60780001f,-0.77820000f,0.96399999f,-0.63730003f,0.51579999f,0.34200003f,-0.44220001f,-1.00740001f,-0.37550000f,-0.00760001f,-0.65770000f,0.46200003f,0.36240001f,-0.23059999f,0.28949998f,0.45630002f,0.98229997f,-0.12400000f,-0.20420000f,0.24540001f,-0.95700000f,-0.91770004f,-1.02499998f,0.36949998f,-0.92419997f,0.47369999f,-0.68450002f,0.45139997f,0.09170000f,0.65699999f,-0.88469998f,0.52959998f,-0.31400001f,0.53260004f,0.28870002f,-0.81970003f,-0.71790004f,0.82250001f,0.77349998f,-0.90950002f,-0.98360003f,0.21650002f,0.04630000f,-0.01190000f,0.69440000f,-0.42720002f,0.16320000f,0.03629998f,0.20910001f,-1.10240000f,1.33369997f,0.07249999f,-0.11770000f,-0.67939997f,-0.23400000f,0.04000000f,-0.56500001f,-0.08500001f,0.94620000f,1.10249998f,-0.44610001f,-0.18020004f,1.20830001f,0.61230004f,-0.27649999f,0.39710000f,0.76690001f,0.46280001f,1.17879999f,-0.06019999f,0.32909997f,-1.07519999f,-0.46259999f,0.07330000f,-0.26080002f,0.50540003f,1.02269999f,-0.55559998f,0.73250001f,-0.73580002f,0.08109999f,0.57950001f,-0.05839999f,-0.53949999f,0.66700000f,0.32330001f,0.67220001f,0.56550002f,0.22650000f,-0.01870000f,-0.39550001f,0.05829999f,-0.16990000f,0.71450001f,0.94929998f,0.56330000f,0.39799998f,-0.41749998f,0.25139998f,0.08500000f,-0.33700001f,0.08500000f,-0.12199997f,0.24950000f,-0.78439997f,-0.67650000f,0.88530001f,-0.20409997f,-0.80349999f,0.52539998f,-0.02850000f,-0.27049999f,0.51560000f,-0.52609999f,0.36900000f,-0.79289997f,0.04080001f,-0.71600002f,0.01849998f,-0.11660000f,-0.88800001f,0.02950000f,0.60380001f,-0.01670000f,-0.94270004f,-0.47119998f,0.39829998f,0.45729999f,0.47050001f,-0.69190002f,-0.31810001f,-0.08959999f,1.84970000f,-0.28490003f,0.94439996f,-0.80609997f,-0.00109999f,0.61649999f,0.41880000f,-0.94980002f,-0.63190003f,-1.61899999f,0.20520001f,0.50119999f,-1.93040001f,0.04779999f,0.48469998f,-1.38469999f,0.02510003f,-0.48330000f,-0.43439999f,0.38380002f,-0.36740004f,-1.41999999f,0.47720002f,0.40399999f,0.27069998f,-0.04870000f,-0.77040001f,-0.04230000f,-0.32950002f,-0.37140002f,0.19680004f,0.69940003f,0.37970004f,1.17699998f,0.20620000f,-0.54019997f,-1.36900002f,-0.22419998f,-0.59559999f,-1.10720003f,-0.55159999f,-0.00200000f,0.51080001f,0.11369999f,0.39019999f,0.58540001f,-0.13410001f,0.37280000f,-0.39199997f,-0.21379999f,0.19140000f,-0.07979999f,-0.28600000f,0.54700001f,0.86540005f,0.74479997f,-0.47369996f,-1.08330001f,0.40750000f,0.27950000f,0.07150002f,0.33899999f,0.10280000f,-0.21440001f,0.06730000f,-0.74509996f,-0.32230000f,0.39610000f,-0.64639997f,0.24440000f,0.33979998f,-0.18489999f,-0.44210001f,0.01430000f,0.01660000f,0.04460000f,-0.26930000f,0.36750001f,0.38460002f,0.12460000f,-0.42190002f,0.56959999f,0.37819998f,-0.41390001f,-0.61760002f,-0.17379999f,0.58720000f,-0.98280000f,-0.66120001f,0.42660000f,0.15700000f,0.19220000f,0.04300000f,0.77579999f,0.67820000f,-0.25970000f,1.01290003f,0.53820000f,-0.70650002f,-0.78380001f,-0.39460000f,0.51280000f,-0.28900004f,0.22860000f,0.73140001f,0.70869998f,0.36779999f,-0.46649998f,-0.80560001f,-0.20819999f,0.80130000f,-0.45510003f,0.10200002f,0.77430003f,0.69869999f,0.20319999f,-0.61239998f,-0.71040001f,-0.36999999f,0.60310000f,0.22640000f,0.06650001f,0.12550000f,-0.33779999f,-0.88020003f,-0.20009996f,-0.55039999f,-1.41520003f,-0.29029999f,-0.25569999f,0.17710001f,0.27740000f,-0.89879997f,-0.40920000f,-0.21169999f,0.23330001f,0.18850002f,-0.55889997f,0.04920000f,-0.72360000f,-0.03430000f,0.22610000f,-0.63350002f,-0.03469999f,-0.56469999f,-0.11510001f,-0.71709997f,0.59229997f,1.12670002f,0.00489999f,0.40910000f,-0.05449996f,-0.41089998f,-0.23720000f,0.37640000f,-0.64460001f,0.35759998f,0.93240001f,0.32899996f,0.58529998f,0.25530001f,0.03959999f,0.50129997f,1.46130000f,-0.23269999f,0.61680001f,-0.15170001f,-0.20240001f,0.08210001f,-0.47410003f,0.10920001f,0.80190000f,-0.65539999f,-0.35899999f,0.45349999f,-0.11890000f,-0.06319999f,0.10490000f,-0.09020003f,0.24120002f,0.46860002f,-0.35170001f,-0.09560000f,0.30680000f,1.01200003f,0.48780000f,-0.72600001f,-0.82589999f,-0.54999999f,0.52719999f,0.89200001f,0.60220000f,-0.45280000f,0.42509998f,0.38399998f,-0.21210000f,0.47239998f,-0.05900004f,-0.72579998f,0.47680001f,0.09619999f,-0.49700000f,0.92920001f,0.64299999f,-0.54220001f,0.44780000f,-0.10280002f,-0.78909998f,0.57660001f,-0.02260000f,0.28119998f,0.72259997f,1.28380002f,-0.67979997f,0.31899999f,0.88820002f,0.04610000f,-0.08980000f,0.49899999f,0.01080000f,0.11980000f,0.30020001f,-0.54540000f,0.50899997f,0.82180001f,-0.18159999f,-0.35450001f,-0.22210002f,0.07570000f,0.46670000f,-0.25249999f,0.27159999f,0.32489999f,1.32210001f,-0.27670000f,0.36349999f,-0.32690001f,-0.35639996f,-0.53039998f,-1.25880000f,0.58389999f,-0.20450001f,-0.71890000f,0.29909999f,0.19190001f,-0.13849999f,-0.34629997f,-0.20829999f,-1.24910002f,0.63159997f,-0.51469999f,-1.16830001f,-0.38040000f,-0.36240000f,0.85959999f,0.26319998f,-0.75879998f,0.24120002f,0.01900002f,-0.17169999f,-0.50300003f,0.01700000f,0.69970001f,0.15760001f,-0.05579999f,-0.21570000f,-0.61770001f,-0.19799999f,0.64260001f,-0.06120000f,0.12420002f,0.15900000f,-0.54500000f,-0.21319999f,0.38480000f,0.02730001f,0.02840002f,0.08440000f,-0.21939998f,0.02100003f,0.42989999f,1.23210003f,0.68140001f,-0.75610002f,-0.11190002f,-0.40680003f,-0.39059999f,0.43670000f,0.36379999f,-0.22880001f,0.60460000f,0.64540003f,0.01370001f,0.18000001f,0.06500000f,-0.19970001f,0.78349999f,0.09380002f,0.37239998f,0.58519999f,0.10360004f,0.24469996f,0.85019998f,1.09740002f,-0.53749997f,0.07520000f,0.55360003f,0.28689998f,0.37880000f,0.45640002f,-0.21720000f,0.29369998f,1.02930000f,-0.32690000f,-0.41609998f,-0.61050001f,-0.15779999f,-0.66399998f,-0.50960001f,-0.00160001f,0.59010000f,0.88170002f,-0.22790000f,0.76060000f,1.36220003f,-0.07230000f,0.76169999f,-0.02430001f,0.66839999f,-0.53610001f,-0.65730003f,-0.29809997f,-0.38719999f,-1.04440001f,-0.64130000f,0.59900000f,0.28060002f,0.04250000f,-0.22319999f,-0.51360002f,-0.40239999f,-0.18510000f,0.04900002f,-0.08439998f,-0.07940000f,-0.67509999f,-0.27179999f,0.49379998f,-1.07670002f,-0.71700001f,0.49530001f,0.17660000f,0.16540000f,-0.04750000f,0.19129999f,-0.25800002f,-0.55289998f,1.29320003f,0.91600001f,-0.59680001f,-0.91200000f,-0.23739998f,0.86499999f,0.48910001f,0.47800002f,0.01040000f,-0.86590000f,-0.64620000f,0.31650000f,-1.05189999f,-0.84880000f,0.31029999f,-0.48029998f,-0.00419997f,0.63089999f,-0.62800001f,-0.61300002f,0.09970000f,0.75330000f,0.46699999f,-0.43700000f,0.76080003f,0.13699998f,-0.83990002f,0.53980000f,0.35170001f,0.24139997f,0.53900001f,0.80380003f,-0.17229999f,-0.65060000f,-0.36460006f,0.29530000f,-0.85409997f,-0.24809998f,-0.14929999f,0.00580000f,-0.17500000f,0.70179996f,-0.04880000f,-0.19719998f,-0.48279998f,0.60160002f,-0.36639997f,-0.47409998f,-0.53610000f,0.01349996f,-0.41640000f,0.81110000f,0.73870004f,0.37429999f,-0.70909998f,-0.22150002f,0.58039998f,-0.87619998f,-0.28060002f,-0.47710000f,-0.02250000f,0.38669997f,0.56749999f,-0.29479999f,0.20360002f,-0.15369999f,0.25560000f,-0.34799998f,0.50130000f,0.11820000f,-0.50820001f,-0.24890001f,-0.00980000f,-0.93820000f,-0.54499999f,0.58700000f,-0.41360001f,-0.17599999f,0.38720000f,-0.34190001f,-0.39320002f,-0.10750000f,0.03440000f,-0.05380001f,-0.15410000f,-0.70779997f,-0.43099997f,0.49039998f,-1.15610004f,-0.80800002f,0.57640002f,0.54649999f,0.59540001f,-0.01789999f,-0.84739997f,-0.55159998f,0.49879998f,-0.46919998f,-0.44999999f,0.15749999f,0.69600001f,0.38139999f,-0.55210001f,-0.07429998f,-0.42200001f,-0.46180000f,0.03460000f,0.13900001f,0.13880000f,0.31150000f,0.55980003f,0.30060001f,-0.05779999f,-0.08980000f,0.01120000f,0.61339999f,-1.03640005f,0.11929999f,-0.30890001f,0.44149997f,-0.05760000f,0.23599999f,0.75760000f,0.39780000f,-0.79060001f,-0.85100005f,0.12670000f,-0.31699999f,-0.50980001f,0.15069999f,0.23230001f,1.05470000f,0.41940000f,-0.33430001f,0.63970001f,-0.61689999f,0.24970000f,-0.19869999f,0.23619999f,-0.04240000f,0.77439998f,0.43079998f,0.27210001f,0.91050002f,-0.07089999f,-0.37499999f,-1.25580003f,0.73519997f,-0.56289998f,-0.72890001f,-0.23190000f,0.18650000f,0.23290001f,-0.76929999f,0.55580000f,0.48580003f,0.13049999f,0.23690001f,0.43210002f,-0.43129998f,-0.31760000f,0.16940000f,-0.21880002f,-0.42350000f,-1.33559996f,-0.99119998f,0.53759998f,0.79369999f,0.66500000f,-0.28729999f,-0.12449998f,-0.18800000f,-0.11470001f,-0.02280001f,0.17620000f,0.23420000f,-0.80130001f,-0.57179999f,0.47610002f,0.17910000f,0.19060001f,0.03710000f,0.30569998f,0.08699998f,-0.38129999f,-0.92409998f,-0.40179998f,0.69339999f,-0.75320001f,-0.39679999f,0.61370000f,0.02179999f,0.41480003f,0.50680001f,0.34800002f,-0.09540001f,-0.62310001f,-0.28119999f,-0.33860001f,-0.07420000f,1.05100003f,0.60600001f,-0.61470001f,0.51220001f,-0.63879999f,0.61919999f,0.32410000f,0.39050003f,0.57959997f,-0.80639997f,0.10079998f,-0.51129999f,0.12310000f,-0.62290000f,0.22600000f,-0.45419997f,-0.55859999f,-0.37049998f,0.03390000f,0.04110001f,0.34149996f,0.36629998f,1.36830001f,-0.17850000f,0.40170000f,0.42930002f,0.11370001f,-0.48390001f,-1.02990003f,-0.16130000f,-0.55099997f,0.03020000f,0.04459999f,0.39409996f,1.33809998f,-0.77899999f,0.45159998f,0.60439999f,0.52389998f,-0.34919998f,-0.82680001f,0.36689999f,-0.44149998f,-0.37510000f,-0.11000001f,0.66530001f,-0.00109998f,0.23560000f,0.30019999f,0.05690000f,0.21480001f,0.12330001f,0.21640000f,0.24360001f,-0.07800000f,-0.24300001f,-0.00120000f,0.28890000f,0.41829997f,0.26999997f,-0.30479998f,-0.80519998f,-0.54179998f,0.53790000f,-0.77400001f,-0.45500001f,0.41090000f,0.72240000f,0.26919998f,-0.64450000f,-1.29529999f,-1.02620000f,0.42919998f,0.04369999f,0.14599998f,-0.02300001f,0.41519999f,0.40320000f,-0.18570000f,0.50939999f,0.48860001f,-0.14119999f,0.52800001f,0.24020000f,-0.35090000f,0.17900002f,0.21000001f,-0.08460001f,-0.43819998f,-0.34599999f,0.25569998f,0.01520002f,0.63759999f,-0.38140000f,-0.28820000f,-0.53260002f,-0.28420000f,-0.43179999f,-0.89900003f,-0.25279998f,-0.21989999f,-0.12630000f,-0.12919998f,-0.35169999f,-0.95689999f,0.28509998f,0.51780001f,1.60020005f,0.08850001f,-0.70260000f,-0.32580003f,0.19920000f,0.08610000f,-0.54749999f,0.68489998f,-0.90820001f,-0.08540007f,-0.28479996f,-0.86210000f,-1.39450005f,-0.40699998f,-0.58649999f,-1.34010002f,-0.45869999f,-0.09749999f,-0.68310000f,0.08129999f,0.53639999f,0.32280002f,-0.26100000f,-0.55459998f,-1.04980002f,0.26280000f,0.41929998f,1.09210000f,0.58339997f,-0.35400000f,0.96949999f,0.67360000f,-0.53619999f,-0.27270000f,-0.07420000f,0.24160000f,0.54920000f,0.39960000f,-0.31140000f,1.02570003f,0.48760000f,-0.73240002f,0.04139998f,0.29340000f,0.20070000f,-0.01460000f,-0.27920002f,-0.31120000f,-0.93220003f,-0.36700000f,0.76210001f,0.55750000f,0.36899999f,-0.41610000f,0.15580000f,0.18919998f,-0.10730001f,0.42740003f,0.11540001f,-0.34340001f,1.31780004f,1.04560004f,-0.43450001f,-0.11309997f,0.22540005f,0.51619998f,1.02069998f,0.76459999f,-0.43189998f,0.49160000f,0.17579999f,-0.37470000f,-0.47120003f,0.40900002f,-0.35860000f,-0.04129999f,-1.03210000f,-0.13950000f,-0.24960000f,-0.13320001f,-0.24740000f,-0.20960000f,-0.87520002f,0.09360000f,0.54689998f,-0.14070002f,-0.56249998f,-0.50040001f,-0.86040004f,0.53359999f,-0.10419999f,-0.09859999f,-0.23269999f,-0.42679999f,0.22280001f,-0.19650000f,-0.60310000f,-1.48430004f,-0.25239996f,-0.75489999f,-1.33490003f,0.23149999f,0.63250001f,0.58130003f,-0.69980000f,0.92650000f,0.09050000f,-0.52650000f,0.74160001f,1.20360003f,-0.46589999f,0.42289998f,-0.37669999f,0.17230000f,0.53920000f,0.37040003f,-0.65419999f,-0.36119999f,0.73740000f,0.29179999f,-0.61429999f,0.13590001f,0.13900001f,0.09110000f,-0.40200001f,-0.00499999f,0.45080000f,0.46679998f,0.29059998f,-0.32059999f,-0.38670000f,-0.50480002f,-0.11530000f,0.33059998f,-0.11840004f,-0.69099998f,-0.34600001f,0.07480002f,0.66020000f,0.65510001f,0.40760000f,-0.37970001f,-0.06140001f,0.04619999f,0.06630000f,-0.01899999f,-0.07100001f,-0.15940001f,0.35239999f,0.43139999f,0.00059999f,-1.00420003f,-0.71120002f,0.41870002f,-0.58250000f,-0.21359999f,0.53370000f,0.41789999f,0.29379999f,-0.27789999f,0.26050000f,-0.48510000f,0.17709999f,0.25020000f,-0.31139998f,-0.10310001f,0.76589998f,1.03830002f,-0.41949998f,-0.52169997f,-0.45209998f,-0.11329999f,-0.18210000f,-0.74129999f,0.59159999f,-0.40139999f,-0.19140001f,0.53199999f,-0.78240000f,-1.47600003f,-0.46180000f,0.76839996f,1.47560000f,-0.13699999f,0.21340000f,-0.31660000f,-0.17409998f,-0.44919999f,-0.64760001f,0.08950001f,-0.69589999f,-1.04470004f,-0.50449996f,-0.11449999f,-0.56170000f,0.36099999f,-0.76550000f,-0.17590001f,-0.16440000f,-0.00220000f,0.54460000f,-0.17689999f,-0.35489999f,-0.96570001f,0.25220000f,0.70569998f,0.08849999f,0.05379999f,-0.16810000f,-1.01080001f,-0.72199999f,0.56390001f,-0.20990001f,-0.15540001f,0.01350000f,-0.36350001f,-0.09919998f,0.47720001f,0.85830003f,0.44040000f,-0.59850002f,0.46029999f,0.23399998f,-0.40350000f,-0.03520001f,0.19100000f,0.26290000f,-0.06089999f,-0.00959999f,0.08850000f,-0.63369999f,-0.33239998f,0.53279999f,-0.53940000f,-0.39500000f,0.22160000f,0.35580000f,0.33980000f,-0.03500000f,-0.76419999f,-0.56839999f,0.26719999f,-0.69220001f,-0.28479999f,0.65680000f,0.34920000f,0.13979999f,-0.32100000f,-0.81760002f,0.29909997f,-0.05129999f,-0.73890000f,-1.22730004f,0.42119996f,0.22330000f,1.35770003f,0.06850001f,-0.60190000f,-0.71750003f,-0.13780001f,0.70190000f,1.41910005f,0.00740000f,0.31020001f,-0.35100000f,-0.01619999f,-0.36639999f,-1.01000001f,-0.41369997f,0.00400000f,0.00320001f,-0.03680000f,0.12180000f,0.24300001f,0.03920000f,0.43029999f,1.27790001f,0.22309999f,-0.33569999f,0.02430000f,-0.29749999f,0.36629999f,0.19350001f,0.32219999f,-0.72079996f,-0.34240000f,-0.11640000f,0.38019997f,1.24340000f,0.07090000f,-0.09390000f,-0.47550001f,-0.34049996f,-0.54040001f,-0.35430002f,0.01520002f,0.60760002f,0.48180000f,0.47280001f,-0.06270000f,0.39820000f,0.52920002f,0.12210000f,-0.24170001f,-0.04400000f,0.21110000f,0.11359999f,0.33140000f,0.16930000f,0.37680001f,-0.01100000f,-0.43689999f,0.15479999f,0.30640000f,0.11120000f,0.92960000f,0.71820002f,-0.29519999f,-0.33700001f,0.01280001f,0.52630000f,-0.91040001f,-0.25499999f,0.84210000f,-0.04390002f,0.33120000f,0.49349999f,0.95580004f,0.58860002f,-0.52650002f,-0.05880001f,-0.30060002f,-0.34230000f,0.48130000f,0.15699999f,-0.47980000f,-0.30470003f,-0.97170005f,-0.35100001f,0.79230000f,1.53030006f,-0.43699999f,0.29910001f,-0.04409998f,-0.62999999f,0.36530000f,0.12130001f,-0.17519999f,-0.40480000f,-0.40520002f,-0.55829997f,-0.35539999f,-0.70660001f,0.42529997f,0.51119998f,0.46080000f,-0.45959997f,-0.18960000f,-0.48240001f,-0.44510001f,0.87429998f,0.40790001f,-0.34579999f,0.42250000f,0.94490003f,-0.43789998f,-0.54220000f,0.00579998f,-0.68159996f,0.40899997f,0.61099999f,-0.17730000f,0.54000002f,-0.10799999f,0.51129999f,-0.54180001f,-0.73140004f,0.16930000f,-0.11019999f,-0.61940000f,-0.51779998f,0.34890000f,0.33660000f,0.39580001f,0.07040000f,1.00240000f,0.45079999f,-0.68539999f,-0.62009999f,-0.16619998f,0.55979998f,0.29129999f,0.31160000f,0.04150000f,-0.34370000f,-0.28900000f,0.21100000f,0.41989999f,0.13379998f,-0.48389999f,0.26280001f,-0.14320002f,-0.42530001f,0.12070001f,-0.21200002f,-0.51910001f,0.63090002f,0.21380000f,-0.53810001f,-0.81160002f,-0.54200001f,0.35450000f,-1.08920000f,-0.67339999f,0.62120000f,-0.01620000f,0.00460001f,0.12530000f,-0.39370000f,-0.28420000f,0.16570000f,0.24609998f,0.01819997f,-0.39919998f,-0.44880002f,-0.66280001f,-0.42269998f,0.47730000f,0.37170003f,0.16059999f,0.92959997f,0.47680002f,-0.31989998f,-0.51719998f,-0.22560002f,-0.29979999f,0.51599997f,0.48599999f,0.25029999f,0.53059999f,1.17100002f,0.13510000f,-0.50689998f,-1.17369999f,0.57500000f,0.57149997f,0.67710000f,0.50520000f,-0.79420001f,-1.29380007f,0.23109999f,0.39989999f,0.02670000f,0.22040000f,-0.75769999f,-0.36250002f,0.21469999f,-0.45430000f,0.37209998f,0.00469999f,0.65579998f,1.02540002f,0.15449999f,-0.24949999f,0.01010000f,0.18390000f,-0.61419999f,-1.16660000f,-0.28729999f,0.86130001f,0.11389999f,0.02219999f,-0.05520000f,-0.45880000f,-0.46440000f,0.10710000f,-0.11379999f,0.10540002f,0.33199999f,0.18580002f,-0.04639999f,-0.18220000f,0.98889999f,0.80660001f,-0.30469998f,0.75890004f,0.12620000f,-0.72560002f,-0.22539999f,-0.33740001f,-0.05980000f,0.62370003f,0.15580000f,-0.64900002f,0.00409997f,0.24359998f,0.16950000f,-0.22770000f,0.01380002f,0.31680000f,-0.77880000f,-0.54799998f,0.52910001f,0.29799999f,0.50740001f,0.27320000f,-0.85760002f,-0.49260000f,0.48240002f,0.62189999f,0.68020001f,0.04790000f,-0.16920001f,0.55590000f,0.09270000f,0.47439997f,0.62839999f,0.46359998f,0.13690000f,0.69530001f,-0.30469999f,0.41049998f,0.71449999f,0.31519998f,0.78080000f,1.05040004f,-0.56970000f,0.67250001f,0.02890006f,0.55869999f,0.94300002f,0.76820006f,0.44749999f,0.13930000f,0.47210002f,0.32189999f,0.03360000f,-0.52200002f,-0.50899996f,-0.66440001f,-1.07200004f,-0.25750000f,-0.01140000f,0.17939999f,0.33419996f,0.73950000f,1.92030006f,-0.67489998f,0.64729997f,0.64810000f,0.07950000f,-0.68469998f,-0.21829998f,-0.68729998f,0.71849998f,0.44370001f,0.11199998f,0.58270002f,0.86160001f,0.61420002f,-0.32680000f,0.87680001f,0.26499998f,-0.78580000f,0.56300000f,0.44440000f,-0.28630000f,0.67800001f,0.28459999f,-0.56810001f,-0.41610001f,-0.27880000f,0.21790001f,0.64510000f,0.31559999f,-0.60149999f,0.39809999f,0.37379999f,-0.05130000f,0.07900000f,0.14000001f,0.09100000f,0.11580003f,-0.26480000f,-0.43570001f,-0.75570001f,-0.63520001f,0.15730000f,-0.96039999f,-0.60099999f,0.48879999f,-0.15430000f,-0.36720001f,-0.24960000f,0.44189999f,0.40260001f,-0.02189999f,-0.81650002f,-0.45220000f,0.53470001f,-0.83310001f,0.61010002f,-0.30910000f,0.84270001f,0.43710005f,0.38429999f,0.54429999f,0.02510001f,-0.32439999f,-0.25670000f,-0.96790003f,0.12390000f,0.08580000f,-0.51180001f,0.12619999f,-0.14100000f,0.19620001f,-0.00500000f,-0.66039997f,-1.64000000f,-0.32169998f,0.37709998f,0.16710001f,-0.18600000f,0.25400001f,0.29800002f,0.64659997f,0.11370000f,0.12089999f,0.45599999f,-0.87540001f,-0.57660006f,0.18810000f,-0.73849997f,-0.19210001f,0.55939998f,-0.27050000f,-0.21730001f,-0.31770000f,0.74429996f,0.69029999f,0.05969999f,-0.27610000f,0.36910001f,0.20069998f,0.13580000f,1.03270003f,0.52880001f,-0.65810002f,-0.37179999f,-0.22119999f,0.16390000f,0.15100001f,0.14100001f,0.03840000f,0.56120003f,0.02439999f,-0.78070002f,-0.63039998f,-0.37559998f,0.47669998f,1.05330002f,0.46300000f,-0.78010000f,0.02550000f,0.39260003f,0.45130000f,-0.46929998f,-0.01679996f,0.70679999f,-0.40220002f,-0.06979999f,0.53300001f,-0.28810002f,-0.02380000f,0.32410001f,-0.54260000f,-0.02039997f,0.70740000f,-0.17179999f,-0.20999999f,-0.00690000f,0.98170001f,0.70760000f,-0.48710000f,-0.80710001f,-0.46040001f,0.45860000f,0.27970003f,0.15969999f,1.26620000f,-0.85580002f,-0.23460000f,1.05610001f,0.02009997f,0.07810000f,-0.43540000f,1.19180001f,0.41140000f,-0.54479999f,-0.05699999f,-0.02869999f,0.48179997f,-0.32599999f,0.13790001f,0.14599999f,0.13679998f,0.17880000f,-0.74180002f,0.63260001f,0.28720001f,0.90610000f,-1.53509998f,-0.61799999f,-0.08650001f,-0.77550001f,-0.26450001f,0.18390001f,-0.73770000f,-0.23930000f,0.18979999f,0.21120001f,-0.14320000f,-0.41830000f,0.02030001f,-0.36500001f,0.36580000f,-0.68739998f,-0.27749999f,-0.04460000f,-0.00360000f,-0.00790000f,-0.04779999f,-0.11860001f,-0.50380002f,0.17320001f,0.81130001f,-0.53660002f,0.58719999f,1.28050000f,0.54220001f,-0.02940000f,-0.32970002f,0.22600001f,-0.55120001f,0.03779995f,0.09940000f,0.20700000f,-0.10710000f,-0.24060000f,0.86160000f,0.78770001f,-0.66300003f,0.51340001f,0.79930004f,0.39340001f,-0.26100000f,-0.14250002f,0.88460002f,0.31139998f,-0.99129999f,-0.38059999f,0.28019999f,0.25329999f,0.76500001f,-0.03280000f,-0.54550001f,0.87440004f,0.21520002f,-0.88559999f,-0.49519999f,-0.03220000f,0.01360001f,0.72000000f,-0.51780000f,-1.36239998f,-0.17460000f,0.29440000f,0.81680001f,-0.54620002f,-0.14450000f,1.37279999f,-0.25740005f,0.06169998f,-0.17950001f,0.74710000f,0.18470000f,0.21999998f,-0.05959999f,-0.31700001f,-0.11950001f,0.28509999f,0.18590000f,0.82739999f,0.33159996f,0.40629999f,0.68680002f,-0.53740003f,0.04380000f,0.02570000f,0.37870001f,-0.04390000f,-0.93410000f,1.43729997f,0.61249998f,0.12439997f,-0.33659998f,0.04480001f,-0.36040000f,1.05339999f,0.27809999f,-0.78789999f,1.36250003f,0.52850001f,-0.20900000f,-0.74939996f,-0.16769998f,-1.40369997f,0.56950001f,0.05079999f,0.76490000f,-0.12010001f,0.23800000f,-0.47160001f,-1.05099999f,0.89440001f,0.24279999f,-0.85720000f,0.43739999f,-0.36439999f,-0.58689999f,0.13240000f,-0.09800000f,-0.27180000f,0.59720003f,0.29240001f,-0.68779998f,0.23480001f,0.04260000f,0.06660000f,-0.63140002f,0.36900000f,0.50110002f,0.59959999f,-0.73220001f,-1.28139999f,-0.37140001f,0.62020001f,0.51590003f,-0.32520000f,0.63599998f,1.11059998f,-0.79020000f,-0.18940003f,0.72089997f,-0.46540001f,-0.03820001f,0.25770000f,-0.58740002f,0.82300000f,1.25270002f,-0.92399999f,-0.17380000f,1.06919997f,0.06960001f,0.41400000f,-1.22230000f,-0.07869998f,-0.10230000f,-0.74430001f,1.41409997f,0.54909999f,-0.52879998f,0.33100000f,-0.03790000f,-0.28590000f,0.10090001f,0.01050000f,-0.66479999f,1.02760002f,0.47240001f,0.19240001f,0.38119999f,0.08770000f,0.32450000f,-0.62010002f,-0.00290000f,-1.32759999f,0.24600000f,-0.14250001f,0.43570001f,-0.05690002f,0.24230000f,1.24109997f,0.07349996f,0.18089999f,0.60649998f,-1.23449998f,-0.46270000f,0.12809999f,-0.68890000f,-0.19830000f,1.28470000f,-0.16550005f,0.21229999f,1.00249999f,-1.38989996f,-0.54099999f,-0.32910002f,0.20420003f,-0.64399999f,0.01679998f,0.18199998f,0.01060000f,-0.26199999f,-0.78829998f,0.73420002f,0.16319999f,-0.59850001f,-0.13940000f,-0.23760000f,-0.30650000f,0.71880001f,-0.21060000f,-1.00019999f,0.07460001f,0.32980002f,0.45570000f,0.24440000f,-0.01119999f,0.23659998f,0.21640000f,-0.11379999f,-0.68739999f,0.60780000f,-0.09399999f,-1.14489998f,-0.59340003f,0.54300001f,0.38290006f,-0.52680000f,-0.49500002f,0.50099998f,-0.31140001f,0.56239999f,0.94630000f,0.15940001f,0.71880002f,-0.05709997f,-0.25220001f,0.10880000f,0.45950001f,-0.21399999f,0.40740002f,-0.06160003f,-0.91839997f,-0.20159999f,-1.00579999f,-0.23999996f,-0.06269998f,-0.46780002f,1.14399998f,0.41089999f,-0.44200000f,-0.40139998f,-0.15889999f,-0.96179998f,0.81900001f,0.20850000f,0.59810000f,0.38510000f,0.18170001f,0.42780000f,0.37140000f,0.02920000f,-0.79400000f,0.17720001f,0.08390000f,-1.21840000f,0.72700000f,0.27690001f,0.16560002f,-0.44980003f,0.14420000f,0.47460001f,-1.08539998f,-0.56370001f,1.03909999f,0.02689995f,0.15819999f,-0.08560000f,0.74420000f,0.54630002f,0.47680001f,-0.25300001f,-0.06490000f,0.36069998f,-0.11929997f,0.03480000f,-0.29239999f,-0.61380000f,0.35779999f,-0.07079998f,0.08330003f,0.30500002f,-0.62540001f,-0.11670006f,-0.04380000f,0.21560000f,0.18690000f,-0.58319999f,-0.46960001f,0.22879997f,-0.46000001f,0.95040000f,0.66120002f,0.76420000f,0.02900002f,-0.29229998f,0.19880001f,0.42500001f,-0.44739998f,0.15500000f,-0.61139999f,-0.07330003f,0.10760000f,-0.84359999f,-0.07700003f,0.64180000f,0.14660003f,-0.45869997f,0.02420000f,-0.73680002f,-0.33350004f,-0.38180000f,0.46879999f,0.49430000f,-0.83220003f,-0.03960001f,0.63830001f,-0.06139999f,0.24000000f,-0.76040001f,-0.21119996f,-0.10159998f,0.28510005f,0.48209998f,0.04340000f,0.06139997f,-0.00999998f,-0.32260000f,0.20120000f,0.10619999f,0.10790000f,0.08569998f,-1.17349994f,-0.52349998f,0.54759998f,0.06199996f,0.42160000f,-0.03349996f,1.11829998f,0.28369999f,-0.54840001f,0.55800000f,0.41290001f,0.04720001f,-0.21659997f,-0.36280000f,0.04750001f,-0.45289997f,-0.53490000f,-0.32419997f,1.00839999f,0.35260001f,-0.34280002f,-0.52099998f,-0.44910001f,0.42009998f,-0.18250002f,0.13880000f,0.46020000f,-1.19600002f,-0.36050001f,-0.11590002f,0.84480001f,0.52220000f,-0.52619999f,-0.62370000f,0.44480001f,-0.22240000f,-0.72159999f,-0.29200000f,-0.33640001f,0.57919999f,-0.22860000f,-0.01720000f,0.41529999f,0.54419999f,-0.54939998f,-1.03829998f,0.50000002f,-0.88420003f,-0.83760004f,0.04940001f,0.74460001f,0.30430002f,0.48999998f,-0.63359999f,-0.85659998f,0.21119999f,-0.66420000f,-0.84720000f,-0.63980002f,0.50840001f,1.19530001f,-0.60600001f,-0.52460000f,0.57019997f,0.18620000f,0.16940000f,-0.17889999f,0.44220002f,0.67960002f,-0.30889998f,0.06140000f,-0.19060000f,-0.35490001f,-0.07019999f,0.15019999f,-0.51889997f,0.33650001f,-0.11870000f,-0.71999999f,0.43200001f,0.08080000f,0.66870002f,-0.62009999f,-0.39830001f,0.44419999f,-0.31240000f,-0.13790000f,-1.05369998f,0.31650000f,-0.06850000f,-0.76980001f,0.02900003f,-0.33930001f,0.33760000f,0.63219999f,0.48000001f,-0.82899997f,0.19220000f,-0.16800000f,-0.94290000f,-0.23849998f,-0.27120000f,1.22140001f,-0.47280003f,-0.00990000f,0.53260000f,-1.21699996f,-0.61689999f,-0.16950000f,0.37950000f,0.19570000f,-0.28190001f,1.10989999f,0.63780001f,-0.41790001f,-0.07689999f,-0.06150000f,0.21259999f,0.70390000f,-0.36800001f,-0.49460003f,-0.24320002f,0.35279999f,-1.00799997f,-0.46200002f,-0.25299999f,0.81540001f,0.71470001f,-0.22120000f,-0.15320000f,0.40899997f,0.25140000f,0.28739999f,-0.04790000f,0.55580002f,-0.78619999f,-1.30890001f,0.13020000f,0.15420000f,-0.28969999f,-0.49500000f,0.17339999f,0.90570000f,0.58140000f,-0.23319998f,-0.30170002f,0.70680000f,-0.52100000f,-1.27779997f,0.62760001f,0.55760002f,-0.48859996f,-0.71740002f,-0.17360000f,0.76769999f,-0.18020000f,-0.35540000f,0.22109998f,-0.47120001f,0.49980001f,0.31000002f,-0.74240002f,0.26219999f,-0.43470002f,-0.91589999f,-0.41020001f,-0.32759998f,-0.24359996f,-0.52079999f,0.73059999f,0.27399999f,0.38160001f,0.45529998f,-0.39950000f,-0.22790000f,0.02009999f,0.57109997f,0.27649999f,-1.37799999f,0.14060007f,-0.18819999f,-0.34020001f,0.27680000f,0.18500000f,0.94560001f,-0.52500001f,-0.15540001f,-0.10030000f,0.66110000f,0.05260000f,-1.29769996f,0.55510001f,0.03260000f,-0.41859998f,1.27939999f,0.63400001f,0.70040000f,-1.11219999f,-0.43749999f,0.24989999f,-0.50029998f,-0.32730000f,0.13129999f,-0.30750001f,0.16060001f,1.17800001f,-0.66939999f,0.06800001f,0.40920002f,0.42800001f,-0.16920000f,0.44440002f,0.76660001f,0.24800000f,0.12939999f,0.02159999f,-0.38359998f,0.40499998f,0.87579997f,0.65300001f,-0.77480000f,-1.49430001f,0.25740000f,-0.32760000f,0.02949999f,-0.63600000f,0.19739999f,0.65080000f,0.21859998f,-1.05159999f,-0.30070000f,-0.20920001f,0.44819999f,1.10620000f,-0.31000000f,0.68500001f,1.17060000f,-0.15539999f,0.67020001f,0.67910001f,-0.23700000f,0.09360000f,-0.09609999f,-0.20360000f,0.43240003f,0.87500000f,0.34639998f,-0.54100001f,-0.98519998f,-0.22840000f,-0.17500000f,0.54910001f,0.42990000f,0.23810001f,0.88180001f,0.13580000f,0.14460001f,0.12889999f,0.45889998f,0.15739999f,0.93079997f,-0.19800001f,0.03969999f,-1.57900001f,0.27560004f,-0.12549999f,0.19740001f,0.14600000f,-0.15370001f,0.54029999f,-0.73690000f,-0.14320000f,-0.17189994f,-0.45809998f,-0.61280001f,1.31140001f,0.10899995f,0.08669998f,1.32169999f,0.13609997f,0.21020000f,0.74609999f,0.31029999f,0.31570001f,-0.24840001f,-0.28939999f,0.00910001f,1.01040001f,0.08599999f,0.11080001f,-1.07669998f,0.03649999f,-0.12780001f,-0.57890000f,-0.27110001f,-0.54399999f,0.81780001f,1.09320000f,0.19140000f,0.02640001f,0.02090000f,-0.35640000f,0.54080002f,0.84740001f,-0.62040003f,0.34380000f,0.41740005f,0.10260001f,0.59760001f,0.67770002f,-0.34800000f,-0.42680002f,0.08599997f,0.67980002f,-0.20560001f,-0.45770003f,-0.55060000f,0.58940002f,1.33150001f,-0.27120001f,0.45699999f,1.09320000f,-0.21100001f,-0.10500000f,-0.32629999f,-0.21960001f,1.07180004f,0.30300007f,0.69660000f,0.21360003f,-0.99529997f,-0.33339999f,0.83180000f,0.58890002f,-0.26220000f,-0.00160001f,-0.14230000f,0.88120003f,-0.35760000f,1.09479999f,-0.11920000f,0.24430001f,0.11370000f,0.30190000f,0.07060000f,0.89000001f,-0.06320001f,0.14460001f,0.22200003f,-0.62920003f,-0.00490000f,0.87300002f,0.63719997f,0.34110000f,0.00159999f,-0.80959998f,-0.40540000f,-0.26380001f,0.81200001f,0.12249999f,1.43340001f,-0.27200001f,0.05180001f,1.26430000f,0.02309995f,0.07659998f,-0.51710001f,-0.41330000f,-0.08610000f,0.17210002f,0.47129997f,0.62600002f,-1.01550000f,1.09069999f,0.49160001f,0.52499999f,0.15679999f,0.38760001f,-0.31000002f,-0.39860000f,-0.05670000f,-0.76239999f,0.49529999f,-0.56860000f,0.18759999f,0.46850000f,0.26420000f,-0.01100000f,-0.78109997f,0.34780001f,0.24980000f,0.22749997f,-0.36219999f,0.38019999f,0.72049998f,-0.21720001f,-0.60600001f,0.05019997f,-0.88240000f,-0.09440002f,1.27479997f,0.84680001f,0.03120001f,-1.27739996f,-0.33360001f,0.41240000f,0.44080002f,-0.02940000f,0.21039999f,0.48849999f,-0.31740001f,0.06860000f,0.82050000f,-0.01500000f,0.62899999f,0.53570000f,0.24600002f,-0.66100001f,-0.15060005f,0.54200001f,-0.17080000f,-0.60620000f,-0.35619999f,0.44500000f,0.88149999f,-0.53040000f,-0.10110000f,0.33199998f,-0.66059999f,-0.10410000f,-0.90759999f,0.31300000f,0.18160000f,0.43329997f,0.70949999f,0.23910000f,0.73849998f,-0.19770001f,0.05130000f,0.03630000f,-0.74889999f,-0.48490001f,1.28419999f,-1.25419998f,-0.50420000f,-1.29679997f,1.15639999f,0.45100000f,0.37850000f,-0.15670003f,0.12190000f,0.60699999f,0.14959998f,0.06509999f,0.92810001f,-0.34650001f,-0.16330000f,0.62689998f,0.47469995f,0.34889999f,-0.00670001f,-0.12509996f,-0.35920000f,-0.52829999f,0.62170000f,0.12770000f,0.94639999f,-0.12860000f,0.07420000f,0.82449999f,-0.52599999f,-0.33300001f,0.25140000f,0.99310000f,0.61120002f,-0.93140000f,-1.36080003f,-0.12140000f,-0.03540000f,0.50529999f,0.64080002f,-0.23180000f,-1.23040001f,-0.53600002f,0.37880001f,0.53160002f,-0.48880000f,0.33679999f,0.93279999f,0.27460000f,0.32319999f,-0.02270000f,0.11720000f,-0.02840000f,-0.21060000f,0.63319999f,-0.46140000f,-1.19499999f,0.14500001f,-0.39580000f,-0.17390002f,0.05180000f,0.35380000f,-0.05409998f,0.10360000f,-0.51199999f,0.05099996f,0.75040000f,-0.35240000f,-1.18879998f,-0.34660000f,0.14620000f,0.48030000f,0.51220000f,0.01039999f,1.12740001f,-0.22360002f,-0.06760001f,-1.40370001f,0.11350006f,-0.26399999f,0.61520001f,-0.16020001f,-0.13220001f,-1.29980002f,0.66940003f,0.20450001f,0.40810000f,-0.47030002f,0.02710000f,0.96509999f,-0.39650001f,-0.04570000f,0.05999999f,0.63299996f,0.30409999f,-0.22030000f,0.13370000f,0.04490000f,-1.22959999f,0.49680000f,0.04009999f,-0.11570000f,-0.08549998f,-0.20370000f,-0.08890000f,0.32489998f,0.26490000f,0.17579999f,-0.21019998f,-0.32760000f,-1.17959998f,0.74760000f,0.14780000f,0.45590000f,-0.36310000f,-0.06970000f,0.37560001f,0.79660000f,0.79680003f,-0.07020000f,-1.32040001f,0.01160000f,0.55060000f,0.16740001f,0.21680001f,0.65180001f,0.00760002f,0.12680000f,0.10640000f,0.24380000f,0.10300001f,0.60040000f,0.57790000f,-0.33620000f,-0.26560000f,-0.24169998f,0.07920000f,0.50400000f,0.41560000f,-0.09540000f,0.66740001f,-0.05649996f,0.63240001f,0.01580000f,-0.85340000f,0.73900001f,0.00120001f,-0.28490001f,0.60280000f,0.45159999f,-0.51099996f,-0.40860002f,0.53280002f,0.36450003f,-0.47620001f,-0.33560001f,0.57149999f,-0.51260000f,0.13800000f,0.63529999f,0.32240002f,-0.59470000f,-1.36500003f,1.00660003f,0.37330001f,0.16189999f,0.42589998f,0.35600000f,0.03449999f,0.78609998f,0.50780000f,0.36870001f,0.28349999f,0.07450000f,0.74099999f,0.63119996f,0.35749999f,-0.44479998f,-0.70499997f,-0.24449999f,0.52680000f,0.51319997f,0.30799999f,-0.19749999f,0.33310000f,0.43710001f,-0.83470001f,0.86690000f,0.31720000f,-0.03219999f,1.06199999f,0.25629999f,-0.44729998f,1.16509995f,0.55749998f,0.22860000f,-0.18720002f,0.19350001f,0.57260002f,-0.89079998f,-0.45010000f,0.58429999f,-0.59950000f,-0.14580000f,0.58560000f,0.39949998f,0.18540000f,0.42299999f,-0.20329999f,-0.48920001f,0.19199999f,-0.07499997f,0.45699999f,0.05120001f,-0.01349999f,0.16240000f,0.28879999f,-0.30399997f,0.32620000f,-0.50520001f,-1.01970000f,-0.60419999f,0.22099999f,1.05349996f,-0.31400003f,-0.46300003f,-0.44259998f,-0.71080003f,-0.18040000f,1.06820001f,-0.45940002f,0.05380000f,0.17150002f,0.18560001f,-0.44460001f,0.05039997f,0.52260000f,-0.65299999f,-0.61150001f,0.27220000f,-0.15640000f,-0.81349998f,0.10900000f,-0.28100000f,-0.12110002f,-0.54339999f,0.11239999f,0.99749996f,0.59060001f,0.12930000f,-0.23190002f,0.55789997f,0.37250000f,-0.34960000f,-0.58760000f,0.00020000f,0.18910001f,0.70689997f,0.16959999f,-0.35989998f,0.41929998f,0.28849999f,-1.13590000f,0.02950001f,-0.10420001f,1.08439997f,-0.63859999f,-0.17580000f,-0.67669998f,-0.83110001f,-0.34420002f,1.10130003f,-1.08150001f,-0.48350001f,0.00620001f,-0.62160001f,-0.12120000f,0.20530000f,-0.04149999f,-0.25760001f,-0.48769998f,0.24730002f,-0.20710000f,-0.92959999f,0.21780000f,0.08910000f,-0.07620000f,-0.05159999f,-0.14320000f,1.05149998f,-0.63189999f,-0.22440000f,-0.63730000f,-0.66269999f,0.04779999f,-0.12080001f,-0.45969998f,0.12960000f,-0.65620001f,-0.67360001f,0.43260000f,0.10220001f,-0.60449997f,-0.01680000f,-0.33440001f,-0.76600000f,-0.14739997f,0.84620000f,0.25709999f,-0.53460003f,-0.26920002f,-0.36770000f,-0.03820000f,-0.52020001f,-0.42870001f,-0.65460002f,0.05520001f,0.60430002f,0.03360000f,0.56959999f,0.83480000f,0.32260000f,0.09560002f,-0.21509999f,0.69240002f,-0.85019999f,-1.73780002f,0.43300000f,0.57420000f,-0.43869996f,0.33380003f,-0.36820000f,-0.08030005f,0.22140000f,0.73980000f,-0.18169997f,0.32960000f,0.43140001f,-0.57089998f,-0.05590001f,-0.00260001f,-0.75250000f,-0.33769997f,-0.31440000f,-0.60909998f,0.65669998f,0.28250000f,-0.98060002f,-0.33019998f,-0.12340000f,0.17159995f,0.41180001f,0.49920002f,-0.70330003f,-1.00990001f,-0.28640000f,-0.52310001f,-0.46569998f,-0.30530000f,0.48690001f,-0.87010001f,-0.23920000f,1.05170001f,0.52929995f,0.27929998f,-0.14509999f,0.52390000f,0.19000000f,-1.87350002f,0.25850007f,-0.13059998f,-0.44529999f,1.00969996f,0.58169999f,0.09269997f,0.21970003f,-0.14350000f,-0.22380000f,0.83959997f,0.59660000f,-1.12059997f,-0.81470004f,-0.13700000f,0.52580001f,-0.09649999f,-0.68060001f,0.02499999f,0.24930001f,-0.34000000f,0.62220001f,0.92280002f,-0.55740001f,0.23640000f,0.60770001f,0.18640001f,-0.29320000f,-0.27520002f,-0.75439999f,0.48960001f,1.48479997f,0.03820000f,0.39379999f,-0.02129998f,0.15200001f,0.14000001f,-0.21600000f,-0.42760002f,-0.49939999f,-0.04579999f,-0.04440000f,-0.58439999f,0.24139999f,0.32620000f,-0.50059999f,-0.12890002f,-0.32320001f,-0.48540001f,0.13879998f,0.14940000f,0.33300001f,-0.42089996f,0.47780002f,-0.41980000f,-0.53190003f,0.64860001f,-0.32979999f,-0.25310003f,0.16710000f,0.33390001f,0.00929999f,-0.96049999f,-0.21630000f,0.98770001f,0.02569998f,0.19420000f,0.51540000f,-0.59720001f,-0.08750000f,-0.24230001f,0.04010002f,-0.10690000f,1.55269998f,-0.62970000f,-0.09769999f,-0.05660000f,0.33639998f,0.28359999f,-0.23100001f,0.30500000f,0.17100001f,-0.20109999f,-0.98989998f,-0.45919999f,0.36690004f,-0.46309998f,-0.44750000f,0.04050000f,0.10950001f,-0.22930000f,0.08980000f,-0.81059998f,-0.44590000f,-0.52559998f,0.42179999f,0.33180000f,-0.43080001f,0.35540003f,-0.07200000f,-1.32209998f,-0.03449999f,-0.48920002f,0.34560000f,0.12780004f,0.04480000f,-0.10939999f,0.26079997f,0.15940000f,0.04740000f,-0.48350000f,-0.88960003f,-0.02700000f,1.06800000f,0.57039998f,-0.52819998f,-1.17159995f,-0.64540002f,0.26620000f,0.30730003f,0.53300001f,0.56380002f,-0.28029997f,0.87200001f,-0.05699998f,-1.29639998f,0.65660001f,-0.12220000f,-1.03329998f,0.28460001f,0.10500000f,-0.03170001f,0.73720001f,0.11880003f,-0.61939998f,-0.00960000f,-0.29419999f,-0.20480000f,-0.45360000f,0.82360001f,0.89040002f,0.32040000f,-0.34300000f,-0.08340000f,-0.89500003f,-0.38679998f,0.22059999f,0.47959998f,0.39499999f,0.79320000f,0.19139999f,0.79340001f,0.67520002f,-0.41239999f,0.43560002f,-0.49070000f,-0.13980000f,-0.46750000f,-0.25210000f,-0.24340000f,-0.07529999f,0.04659999f,-0.23279999f,0.07740000f,-0.16920002f,-0.50720000f,-0.24840001f,-0.45160001f,0.80399996f,-0.19560002f,-0.75250003f,0.14700001f,-0.58450003f,-0.51200001f,0.19979999f,-0.35380001f,0.66150000f,0.41519997f,0.50649998f,0.21829999f,0.56199998f,0.04529996f,-0.23440000f,0.34899998f,-0.11900000f,-0.03050000f,-0.00060000f,-0.03170000f,-0.46930001f,0.02980000f,-0.33760000f,-0.79550001f,-0.44800000f,-0.68039999f,-1.11469999f,-0.70700000f,0.05600000f,0.49710000f,0.02140000f,0.10240002f,0.07540002f,-0.39679999f,-0.03160000f,0.12810000f,0.14200001f,-0.58800000f,-0.62629999f,-0.26399999f,-0.40220001f,-0.85970002f,-0.20370000f,0.06680000f,0.28950001f,-0.18320000f,0.19960000f,1.12389999f,0.63319999f,-0.12819999f,-0.35649997f,0.07690002f,0.11480000f,0.75529999f,0.11220000f,0.18019998f,1.04540000f,0.49370000f,0.10420000f,-0.26339999f,0.23470000f,0.66119999f,1.26519997f,0.71999998f,-0.40480000f,0.40620001f,0.14029999f,0.29899999f,0.25389999f,0.69829999f,0.20580001f,0.78669999f,0.60930000f,-0.09220000f,0.42090000f,0.56940000f,0.63799997f,0.43179997f,0.01949998f,-0.26739999f,0.00509999f,0.54789998f,-0.36579998f,0.59590001f,-0.23410001f,-0.09080000f,-0.02869999f,0.60930001f,0.24739999f,0.44369999f,0.30129999f,-0.84299995f,0.08050001f,-0.42730001f,-0.18480000f,-0.28150000f,0.74350000f,-0.19659999f,0.48950000f,0.44400004f,-0.67099999f,0.20660004f,-0.96159998f,-0.06180000f,-0.75299998f,-0.45919999f,-0.29679998f,-0.61039999f,0.57410000f,-0.04530000f,0.59660000f,0.81159999f,0.69189999f,0.15420000f,1.03739999f,0.46750000f,0.30159999f,0.60629998f,0.18119999f,0.13260000f,0.24680000f,0.15190000f,0.11879999f,0.77340000f,0.48139999f,-0.09260000f,0.07679999f,-0.17050001f,-0.22240000f,-0.64810001f,0.00700001f,0.71180000f,1.14359997f,0.61129999f,-0.35840001f,-0.51810001f,-0.03540000f,-0.65699998f,-0.89159997f,-0.63209999f,-0.12639998f,-0.89149997f,-0.36660000f,-0.01679999f,-0.41149999f,-0.02139999f,-0.72800000f,-1.11570000f,-0.55020000f,-0.27039999f,-1.19239996f,-0.62819999f,-0.04320000f,0.73310002f,-0.97700000f,-0.22219998f,-0.96200000f,0.52119998f,-0.67459997f,0.27300000f,0.07210000f,0.04340000f,-0.05670001f,-0.11460000f,-0.06700000f,-0.13960000f,0.16700003f,-0.66639998f,0.02580004f,0.55740002f,0.05380001f,0.45000001f,-0.58150003f,-0.15060000f,-0.35710000f,-0.55700001f,-0.04499999f,-0.68160002f,-0.07310000f,-0.34179999f,0.05370002f,0.86939998f,0.07860001f,0.89399999f,-0.51569999f,0.54419999f,-0.28970001f,-0.55170002f,0.12580000f,-0.39050001f,0.52929999f,-0.06579999f,0.65850000f,-0.28439998f,0.74999997f,-0.04880000f,-0.25000002f,0.22440001f,0.03920002f,-0.45079997f,0.17080002f,0.45399999f,0.52529999f,0.64780000f,0.08720001f,0.78030001f,0.26560001f,0.24680000f,0.12710000f,0.26860000f,0.39539999f,1.03079998f,0.50189999f,-0.33280001f,-0.25749999f,-0.33940000f,-0.15960000f,-0.03340000f,-0.36460000f,0.31899999f,0.56719999f,0.50530000f,0.45199999f,1.07389998f,0.75240001f,-0.22620001f,-0.54490003f,0.17790000f,0.01740001f,-0.61799999f,-0.42510001f,-0.55899999f,-0.77670000f,-0.51150000f,-0.22240001f,0.13930000f,0.28480001f,-0.20120000f,-0.43330001f,-0.26660000f,-0.35300000f,-0.09219998f,-1.02200001f,-0.02240000f,-0.77000001f,-1.07769999f,-0.29580000f,-0.98849999f,0.58289999f,-0.44139998f,0.36209999f,-0.68830001f,-0.00660001f,-0.60070000f,0.02100002f,-0.35099998f,-0.16079998f,0.76230002f,0.00579998f,0.68750002f,0.82660001f,0.23279999f,0.68780000f,-0.54140001f,-0.33140000f,-0.54520000f,-0.42110002f,-0.59739999f,-0.52750001f,-0.69610002f,-0.40519998f,-0.46029999f,-0.27059997f,0.75419999f,-0.14640000f,0.67009998f,0.03880001f,0.70709999f,0.14950000f,-0.74179999f,0.13510003f,0.14410000f,0.16540000f,0.19490000f,0.07939999f,0.29550000f,0.37480000f,0.42020000f,0.45180001f,-0.09140002f,0.12549996f,-0.30130003f,0.18260002f,0.21710003f,-0.32049999f,-0.14560000f,-0.14150000f,-0.06480000f,0.15140001f,-0.46419997f,-0.11909999f,-0.50960000f,-0.65160000f,0.01400002f,-0.02480002f,0.58729997f,-0.10700002f,0.04499999f,0.41240000f,0.51590002f,0.18820000f,0.11170000f,-0.27730000f,0.26980000f,0.08360000f,-0.34990001f,0.04419997f,0.63909997f,0.17109999f,0.37720002f,0.21530002f,-0.00940000f,-0.30019999f,-0.51309999f,-0.07489999f,-0.12359999f,-0.85370001f,-0.19860000f,-0.08680000f,-0.25489999f,-0.77580001f,-0.13440002f,-0.72340001f,0.83950003f,0.20760000f,0.66970002f,0.51390000f,0.61959997f,0.35929997f,0.15510000f,-0.09540000f,0.16150000f,-0.77599998f,0.52099997f,-0.58780000f,-0.08040005f,-0.59359999f,0.08519999f,1.09750002f,-0.07819999f,0.81230002f,-0.29660002f,-0.71339999f,-0.29199999f,0.27610002f,0.60479997f,0.18069999f,0.20420002f,0.82939996f,0.11479998f,0.60150002f,-0.34360000f,0.39970003f,-0.34210001f,0.51859999f,-0.35290004f,-0.10670002f,-0.20479999f,0.01790000f,-0.73550003f,0.32300000f,-0.47030002f,-0.21370001f,-0.55460002f,0.35079999f,0.66989998f,0.10159998f,0.32159999f,0.70399999f,0.37039999f,-0.11580000f,-0.54580000f,-0.55630002f,-0.14679999f,-0.39509999f,-0.29100000f,0.55159999f,0.95769997f,0.48359999f,0.56580002f,0.79180001f,0.16549999f,-0.38060001f,-0.15789999f,0.00230001f,0.50119999f,0.80619996f,0.29859998f,0.56280000f,0.65639999f,0.42360000f,-0.59480000f,-1.11270000f,-0.60380000f,0.00940001f,-0.70559998f,-0.46350000f,-0.00360000f,0.21950000f,0.14960000f,-0.14780001f,0.45130000f,0.36330001f,0.21480000f,0.26350000f,0.23000001f,-0.28240000f,0.86040003f,0.20730003f,0.20020000f,0.03690001f,-0.12319999f,-0.19679999f,-0.22719999f,0.28960004f,0.69779999f,0.31220001f,0.14270000f,0.26739999f,0.18149999f,-0.34050001f,-0.06900001f,-0.46370001f,-0.10079998f,0.40780000f,-0.25460002f,0.44570001f,-0.53199999f,0.42950003f,-0.17780000f,0.13600000f,-0.30860001f,-0.71520002f,0.11519999f,-0.72960002f,0.38030000f,0.20339999f,0.51990001f,-0.32539999f,0.81739996f,-0.17880002f,0.09370000f,-0.26220000f,0.04970000f,0.35569999f,-0.82279999f,0.25270002f,-0.36390001f,-0.04700000f,-0.35270001f,0.13149999f,-0.23709999f,0.34080002f,-0.03919999f,0.21580001f,0.45359999f,0.46199998f,-0.17640001f,-0.53660001f,-0.58509999f,-0.20649999f,-0.10419999f,-0.39079998f,-0.34809999f,-0.11520000f,0.16850000f,0.03900000f,0.75019999f,1.13810000f,0.63769999f,0.06540000f,0.26450000f,0.28050001f,-0.38460000f,-0.85409999f,-0.54450001f,0.09620000f,0.49289999f,-0.11550000f,0.62439998f,1.20179997f,0.64319997f,-0.06280002f,0.66299998f,0.38699999f,-0.16839999f,-0.88509999f,-0.44379999f,0.03840001f,-0.24969999f,-0.27500000f,-0.20320000f,-0.43480000f,0.16540002f,-0.46600000f,0.40069999f,-1.02160003f,0.25320000f,-0.86120004f,0.15960002f,0.77279995f,0.00839998f,0.42410000f,-0.37360000f,0.48470002f,0.16459998f,0.40339997f,0.19239997f,0.39709999f,-0.27499998f,0.31430000f,-0.67709996f,-0.01880001f,-0.78249998f,-0.17470002f,-0.33799999f,-0.18010000f,0.29310002f,0.36840000f,0.38970001f,0.75170000f,0.14439998f,0.52949999f,-0.36379998f,-0.23559998f,-0.52139998f,0.48140002f,-0.78799997f,0.31620004f,-0.30570000f,0.57699997f,-0.11650001f,0.00090000f,0.48379998f,0.02449999f,-0.55240003f,-0.38760000f,-0.36160000f,0.17840000f,0.26039999f,-0.34220001f,-0.24020000f,-0.27430000f,-0.46640001f,-0.58700000f,-0.46320000f,-0.09999999f,0.11600000f,-0.09580000f,-0.46299998f,-0.77079996f,-0.47329999f,0.81560000f,1.31209999f,0.77180001f,0.03240000f,0.10310000f,-0.30780001f,-0.24119999f,-0.75519998f,-0.21119999f,0.41699999f,0.28429996f,-0.28150004f,-0.62180000f,-0.83440000f,-0.77110001f,-0.70360000f,-0.92259999f,-0.67720000f,-0.49560000f,-0.51529999f,-0.28679999f,0.06600000f,-0.05450000f,0.25980001f,-0.50760001f,-0.67740000f,-0.55580000f,0.56399999f,0.82119997f,0.54019999f,0.40600000f,-0.35940001f,0.70000003f,-0.09660001f,0.63700003f,0.70940002f,0.06039999f,0.70300002f,0.50879999f,-0.06440000f,0.40759999f,0.44420000f,0.13380000f,0.51199999f,-0.75090002f,-0.14300001f,-0.87130003f,0.59330002f,0.41019999f,0.45770000f,-0.35560001f,0.13120000f,-0.16120000f,0.12910005f,0.90479999f,0.01010000f,1.11620001f,0.29180001f,1.07960000f,0.97980001f,0.07480000f,0.99260001f,0.58450001f,-0.23020000f,0.59890002f,-0.62030001f,-0.21460000f,-0.49910000f,0.79780001f,0.14319998f,0.79020001f,-0.65880001f,-0.08119999f,-0.70400001f,-0.97140001f,0.22410000f,-0.65900000f,-0.98699997f,-0.42009999f,-0.05700000f,0.08470000f,-0.11010000f,-0.49600001f,-0.73420000f,-0.40080000f,-0.17700001f,-0.58720003f,0.07169999f,-0.52560001f,-0.38430001f,-0.45360001f,0.15880001f,-0.24719998f,-0.08579999f,0.14240001f,0.64830001f,-0.00360000f,-0.70260001f,-1.15589999f,-0.74830000f,-0.60559999f,-0.85720000f,-0.72180000f,0.23080000f,0.10730000f,0.38360001f,-0.42400003f,-0.28580003f,0.28860001f,0.26939998f,1.02769997f,0.69390001f,-0.46500000f,-0.54169998f,-0.03429999f,0.12200001f,-0.03909999f,0.27660001f,0.16879999f,-0.79070002f,0.38760001f,-0.16580000f,0.52020002f,0.40750001f,0.02840000f,0.32410001f,0.44140001f,-0.01960001f,0.51020002f,-0.67660001f,-0.18259998f,-0.44679999f,1.10430003f,-0.10259999f,1.00350003f,-0.51800001f,0.42439999f,-0.40800002f,0.72050001f,0.02500000f,0.47970000f,0.74330003f,0.23719999f,0.83070003f,0.97319999f,0.26040001f,0.96559999f,-0.87490004f,-0.17140000f,-0.74530002f,-0.13020002f,-0.92399999f,-0.00979997f,-0.06670003f,-0.78559999f,-0.21250000f,0.08190001f,-0.49759998f,0.19570003f,-0.72530002f,-0.15579999f,-0.59290001f,0.48180002f,-0.22500000f,-0.16479999f,-0.59909998f,-0.07359999f,0.32299999f,0.65709998f,0.61610000f,-0.25519999f,0.03270002f,-0.29659998f,-0.38559999f,-0.65669997f,-0.34419999f,0.20340001f,-0.16119999f,-0.19830000f,-0.40119998f,-1.30639997f,-0.81580000f,0.42879998f,1.28819996f,0.80959998f,-0.26740000f,-0.45420001f,-0.07290000f,-0.29119999f,-0.33589999f,-0.36840000f,-0.34840000f,-0.70910000f,-0.60120001f,-0.44319999f,-0.34869999f,-0.23939999f,0.22160001f,0.20860002f,-0.27180000f,0.23100000f,0.67799999f,0.22909999f,-0.48340000f,-0.75949998f,-0.47589999f,-0.28939999f,0.03030000f,-0.48170001f,0.02460000f,-0.29130000f,-0.59290001f,-0.49359998f,-0.59749999f,0.98809999f,-0.01860001f,0.82289998f,0.26710000f,0.05220000f,0.34590000f,-0.28780000f,0.60939999f,-0.24040002f,0.08360003f,0.82519998f,0.27760000f,-0.15059999f,-0.76999997f,-0.33299997f,-0.08080002f,-0.17539999f,0.02700000f,0.61670000f,0.12940000f,0.57429999f,0.53670001f,0.45179999f,0.56230000f,0.66309998f,-0.26139998f,0.63469999f,0.35220003f,0.61919998f,0.22539999f,0.22940000f,-0.14619999f,0.07080000f,0.50210001f,0.10279999f,0.55990001f,0.10800000f,0.02559998f,-0.48300000f,-0.82750000f,-0.68130001f,0.80760000f,1.19720001f,0.59560000f,-0.20620000f,-0.40090000f,-0.44330001f,0.52780000f,1.14420001f,0.75810001f,-0.25940000f,-0.61940001f,-0.06889999f,-0.44819999f,-0.86459998f,-0.50289999f,-0.14279999f,0.16450000f,0.01780000f,0.08540000f,0.20000000f,0.13070000f,0.58179999f,1.11039997f,0.62749999f,0.17320000f,0.17970000f,-0.08000000f,-0.09160000f,0.07229999f,0.17960000f,0.10920001f,0.00500001f,-0.32779999f,0.52199999f,1.16919997f,0.60699998f,-0.20320000f,-0.49449999f,-0.22060000f,-0.16200000f,0.31160000f,0.73130002f,0.38560000f,0.75110001f,-0.62399999f,0.10399998f,-0.75520001f,0.48710001f,0.37319999f,0.46610000f,-0.46160001f,-0.51100000f,-0.57900000f,-0.34920003f,-0.11860000f,-0.16940001f,0.32480000f,0.22220000f,0.42540000f,0.47509998f,-0.28859998f,0.38109999f,-0.06540001f,-0.09740000f,-0.08800000f,-0.39860002f,-0.25259999f,-0.53240001f,0.08630001f,0.31019998f,0.02309999f,-0.01670001f,-0.38939998f,-0.00869999f,0.34020000f,0.58159996f,0.25579998f,-0.16959999f,-0.33479998f,-0.34759999f,-0.01830000f,0.12220000f,0.07250000f,1.16750001f,-0.58050001f,0.49020000f,1.28860001f,0.83370002f,-0.24880000f,-0.09100000f,0.07100001f,-0.24480001f,0.12360000f,0.16220001f,-0.17460000f,-0.09520000f,-0.25810001f,-0.47880000f,-0.31729999f,-0.35539999f,0.26439999f,-0.01770001f,0.29739999f,-0.36720000f,-0.22360000f,-0.22680000f,-0.15520002f,0.00709999f,0.39660000f,0.27440000f,0.89460000f,0.50340001f,-0.01480000f,0.56869999f,-0.11300001f,-0.01500001f,0.66239997f,0.37569998f,-0.25200001f,-0.43830001f,0.09360001f,-0.07480000f,-0.63490000f,-0.45100002f,-0.24099999f,-0.68329999f,-0.28729999f,-0.35700000f,-0.04240000f,-0.29960001f,-0.70779999f,-0.46100000f,0.19739998f,-0.43999999f,0.20420000f,0.36439999f,-0.61479999f,0.31200002f,0.58900002f,0.09300000f,0.50720001f,0.96169999f,-0.17699999f,0.87490000f,-0.98349998f,0.02700000f,-0.82229998f,0.69320000f,-0.19999999f,0.63320001f,-0.35030000f,-0.74259998f,-0.25869996f,0.03259999f,-0.49519999f,-0.11820000f,1.06130001f,-0.04980000f,0.78410001f,0.41259999f,-0.70099995f,0.25440002f,-0.35370003f,-0.36900000f,-0.19530000f,-0.08789997f,0.65259999f,0.01490001f,-0.12530000f,0.20679999f,0.01450000f,1.11680002f,-0.42120000f,-0.06840000f,0.24230000f,0.28440001f,0.07760000f,-0.19500000f,0.41560000f,-0.10220001f,0.24429998f,-0.20630001f,0.02499999f,0.29419998f,0.33609999f,0.57380000f,0.83489999f,0.60010000f,-0.44739998f,-1.00749996f,-0.60989998f,0.41560000f,0.12259998f,0.39519999f,-0.31140000f,-1.08280001f,-0.74290002f,-0.00460000f,-0.34830001f,0.09950000f,0.07240001f,0.04920001f,-0.34120001f,0.38319999f,0.65849998f,0.03419998f,0.38080000f,0.67889999f,0.58000000f,0.12060000f,0.12910000f,-0.06230000f,-0.40019998f,-0.94189996f,-0.63489999f,0.22400000f,0.83689999f,0.02689997f,-0.53899998f,0.00289999f,-1.10340001f,-0.35319998f,-0.87059999f,0.88349999f,0.03440000f,0.69249999f,-0.14720000f,-0.47899997f,-0.15579998f,-0.75270001f,-0.14679999f,-0.78210001f,0.28210000f,0.40279998f,0.40789999f,-1.20380002f,0.08920002f,-1.03660002f,0.13900003f,0.80099999f,0.28280001f,-0.67430002f,-0.02879999f,-0.49770000f,0.49440002f,0.52959999f,0.37919999f,0.24070002f,0.33859999f,0.06030000f,-0.60610001f,-0.36659998f,-0.61890000f,0.07670000f,0.22319999f,0.02889999f,0.33570001f,0.48639998f,0.43630000f,0.18430000f,0.23789999f,0.24660000f,0.32849998f,0.36969998f,0.49400001f,0.49880000f,0.30120000f,0.16999999f,0.62829997f,0.40439999f,0.47080001f,0.49440000f,0.60900001f,-0.34859999f,-0.22429996f,0.19670003f,0.36620002f,-0.03510000f,0.52350002f,0.37000001f,0.25290000f,0.21080000f,-0.17220000f,-0.73750001f,-0.21810000f,-0.57820000f,-0.52540000f,-0.58230001f,0.00819999f,0.31149999f,0.08049999f,0.94680000f,1.49300001f,0.95520001f,-0.05200001f,0.53049998f,0.44859999f,0.08160001f,0.21450003f,-0.25899999f,-0.18180001f,0.25489999f,0.38250000f,0.50719999f,0.49410003f,-0.54950000f,-0.19639997f,-0.51329999f,-0.62960000f,0.21439999f,-0.63280001f,-0.01830000f,-0.44699998f,-0.11269999f,-1.09160003f,-0.21160000f,-0.99840002f,-0.02550002f,-0.71120000f,0.05590001f,-1.55830007f,-0.10160000f,-1.29450005f,-0.62850001f,0.21579999f,-0.58530002f,-0.44230001f,0.23919999f,-0.24250000f,1.19560001f,0.02420002f,1.10060001f,0.32190001f,-0.18400000f,0.21970001f,-1.01260001f,-0.23240002f,-1.12060002f,0.16390000f,-0.81019996f,0.07630002f,0.59270001f,0.38899997f,0.43709998f,0.09169999f,-0.83959997f,0.06950002f,-0.72959998f,0.14950000f,-0.08480000f,0.00870001f,0.39580003f,0.01200001f,-0.51429999f,0.12820000f,-0.56000001f,-0.77400000f,-0.44740001f,-0.24840000f,-0.68510000f,-0.19380000f,0.18220001f,0.27140001f,0.04150000f,-0.70419999f,-1.36539996f,-0.83329998f,-0.11660000f,0.04450000f,0.17230000f,0.03000000f,0.22600000f,0.19100001f,0.26000000f,-0.20180001f,0.05300000f,0.07019999f,-0.20000001f,-0.46650003f,0.14640000f,0.23950000f,-0.26540000f,0.14620001f,-0.27139999f,-0.17590000f,0.07019998f,0.36689998f,0.47609999f,0.28380001f,0.58870001f,0.08210000f,0.68939999f,-0.22190001f,-0.47350003f,-0.63540000f,-0.36750000f,-0.99930001f,0.00980001f,-0.74050000f,0.57240002f,-0.04520000f,0.62880003f,-0.26570001f,0.07700000f,-0.09650000f,0.01120001f,0.14139999f,-0.04900001f,0.56960001f,0.40619997f,0.71660000f,-0.00150001f,-0.40959997f,0.01030001f,-0.02400001f,-0.26600000f,-0.05000000f,-0.85660000f,0.38719998f,-0.69860001f,0.32740005f,0.76099999f,0.27520002f,0.52370000f,0.48779997f,0.36969998f,-0.38599999f,0.52739999f,-0.29780001f,-0.34589999f,-0.61079997f,-0.32969997f,0.23790002f,0.14799999f,0.08050000f,-0.47789998f,0.09100000f,-0.06580001f,-0.32640002f,0.28510001f,-0.10079999f,-0.15439999f,-0.32539999f,0.18440000f,0.40610000f,0.40720001f,-0.32120000f,-1.17000000f,-0.58120000f,0.60359997f,1.06079994f,0.60879997f,-0.09580001f,-0.52850001f,0.15830000f,-0.14500002f,0.47549998f,0.23689999f,0.45939998f,1.31139998f,0.77630000f,0.39719999f,1.02349998f,0.60559998f,-0.07460000f,0.16970001f,-0.07390000f,0.10999998f,0.79459998f,0.26499999f,0.18880000f,0.12400000f,0.07620000f,-0.58220000f,-0.80499999f,-0.26789999f,0.07819999f,0.21039998f,-0.23790003f,-0.08459998f,0.59199999f,-1.27260001f,1.53679999f,-0.72300002f,-0.46509999f,1.03979999f,-0.29460001f,1.16780004f,-0.82280001f,0.62640002f,0.19559999f,-0.53239998f,0.12820000f,-0.53499999f,0.49559998f,-0.30799999f,0.01839999f,0.05320000f,-0.00140000f,0.82980001f,-0.98320002f,0.46420002f,-1.63690000f,1.44559998f,-0.88990002f,-0.59750003f,0.15800000f,-0.30550001f,-0.68850002f,0.41620001f,-0.36620002f,0.13720004f,0.21059996f,0.06810001f,0.28370002f,-0.28580002f,0.17820000f,-0.71520000f,0.60699999f,-0.38730001f,0.01820000f,-0.04160000f,0.01180000f,-0.04100004f,-0.16349998f,-0.69380003f,-0.18310001f,-0.47900004f,-0.95740002f,-0.28250000f,-1.03060002f,0.52040002f,0.19990001f,0.18950002f,0.23800003f,0.27140000f,0.53880003f,0.07880000f,-0.03530000f,-0.15369999f,-0.60380001f,-0.29590000f,-1.10440002f,-0.85920005f,-0.35760001f,-0.81720006f,0.38000002f,0.23050000f,0.33590002f,0.95960002f,0.16810001f,0.11130005f,-0.41479999f,-0.22059999f,-0.38880000f,0.76260002f,0.27150000f,0.28500003f,0.92840003f,0.20470001f,0.16830002f,-0.35940000f,-0.19170000f,-0.02360002f,1.10980000f,0.32780000f,1.00910003f,-0.43880000f,0.29750001f,-0.81720002f,0.98760001f,-0.46460002f,-0.84960001f,1.41919999f,-0.51160002f,0.70710003f,-0.39200002f,0.37730002f,-0.07999995f,0.35919996f,-0.04359999f,0.26670000f,-0.24680001f,0.14150000f,-0.15820001f,0.62120000f,-0.13080000f,-0.79380005f,0.77980003f,-0.45150003f,0.33750004f,-0.02600002f,0.17870001f,1.56289999f,-1.45399998f,0.85210001f,-0.36619999f,0.17059998f,-0.20049999f,1.04040002f,-0.66880000f,0.55920001f,1.45010004f,-1.25860000f,0.78820003f,-0.54160001f,-0.00939999f,-0.27310000f,1.11769998f,-1.55199996f,0.65190000f,-0.29169999f,-0.22169998f,0.63720001f,0.14550001f,0.81550003f,0.92800002f,0.20690001f,0.13470005f,0.59300000f,0.23830000f,0.58300001f,0.21240001f,0.05910000f,0.19510001f,0.64160002f,0.08560001f,0.00240001f,0.13900000f,0.08930000f,-0.03860000f,-0.70280003f,-0.32770001f,-0.57930004f,1.02660000f,0.35430000f,1.17620004f,-0.55960002f,-0.29930001f,-0.79850003f,-0.74879999f,-0.22769999f,-1.00110000f,-0.81039999f,-0.19429999f,-0.13130000f,-0.42720001f,-0.15390000f,-0.09370001f,-1.02160003f,-0.38090001f,-1.25270004f,-1.03899999f,-0.22040000f,-0.27230003f,0.06260000f,0.43320002f,0.49129998f,-1.18859998f,0.31640000f,1.47250000f,-1.23180000f,0.79760002f,0.53800000f,-0.58359999f,0.30900000f,0.21410000f,-0.31340000f,0.12560000f,1.10840002f,-1.04999999f,0.60340002f,0.23700001f,0.09140000f,0.11470000f,-0.69770004f,0.44480002f,-0.38350002f,0.83739998f,-1.33939997f,0.50530000f,-0.29690003f,0.35840002f,-0.18270001f,-0.52169999f,1.17779997f,-0.33540000f,-1.27009999f,1.02479998f,-0.68670001f,-0.62930002f,0.33440000f,-0.33350001f,-0.76190003f,1.25360001f,-0.46530002f,-1.56649997f,1.48679997f,-0.85890000f,0.43389999f,-0.78060004f,-0.53759999f,-0.25199999f,-0.14000000f,0.34139999f,0.01110000f,0.50679999f,0.72860003f,0.19150001f,0.11120004f,0.05020000f,-0.01150000f,0.31260000f,0.92580001f,0.26490000f,0.59760003f,-0.16720000f,-0.02990000f,-0.45570002f,0.09160001f,0.12680000f,-0.04100000f,0.42979999f,0.05830000f,0.35300000f,0.88020000f,0.16830000f,0.52140001f,-0.65920005f,-0.37880001f,-0.70400005f,-0.48900000f,-0.01049999f,0.25920000f,-0.66620001f,-0.21460000f,-0.87610001f,0.02219999f,-0.16830000f,-0.65420002f,-0.37060001f,-0.09350000f,-0.27820002f,-0.41280000f,0.02940001f,-0.75040001f,0.18479998f,-0.38920000f,0.24259998f,-0.95439997f,0.17420000f,1.13940002f,-0.84680002f,0.61280002f,-0.12920001f,-0.31359999f,-0.04480000f,1.11120000f,-1.21019998f,0.62490001f,0.04070003f,0.46639998f,-0.00949999f,0.13740003f,0.35559998f,0.05320001f,0.49019998f,-0.87299998f,0.29210000f,1.12679998f,-1.48119998f,0.64260001f,-0.50780007f,0.19420005f,-0.27990003f,-1.05599999f,0.90300000f,-0.56490001f,-0.46930001f,0.98979999f,-0.29820001f,0.58280000f,-0.43799999f,0.29780001f,-0.42240001f,0.55680001f,-0.24280001f,-0.05570000f,-0.30000000f,0.29920000f,0.04760000f,0.48200000f,0.24019998f,0.17739999f,0.07709998f,0.36440004f,0.31240001f,0.66780004f,-0.13540000f,-0.06830000f,-0.27140000f,-0.43319998f,-0.06810000f,0.31710000f,-0.73040003f,-0.42640001f,-1.17080003f,0.65840000f,0.27610000f,0.14390000f,0.24220000f,-0.09670000f,-0.24260000f,0.23720001f,0.25060000f,0.62520001f,0.24120001f,0.30450000f,0.84410001f,0.61239999f,0.17239999f,0.07259998f,0.25860002f,0.21150001f,0.81620004f,-0.53500001f,-0.25760000f,-0.64750001f,-0.83420003f,-0.26710001f,-0.25240003f,-0.09320000f,0.10409999f,0.16880000f,-0.69480000f,0.12540001f,0.29630000f,0.18460003f,0.14319999f,0.03560006f,0.19099994f,0.02470002f,-0.01760000f,0.14280000f,-0.02100000f,-0.97229997f,0.50779997f,-0.50459999f,-0.27960004f,0.38000000f,-0.18320001f,0.95310001f,-0.35039998f,0.49850000f,0.64979999f,-0.82220000f,0.35710001f,-0.13419996f,0.23019998f,-0.06350000f,-0.30769997f,0.34139998f,-0.15080000f,0.96760000f,-0.65299997f,0.51710000f,-0.21559998f,-0.07680002f,-0.08720000f,-0.37950001f,0.40619999f,-0.22300000f,-1.19380005f,0.82880002f,-0.64260003f,0.15670000f,-0.72100002f,0.69400001f,0.32090000f,0.75850001f,0.62560001f,0.18320000f,0.49120002f,-0.37280000f,0.04310000f,0.10569999f,-0.31700000f,-0.04810000f,-0.14080001f,0.86719999f,0.29709999f,0.91690001f,0.81420004f,0.40470001f,1.16840006f,-0.19560000f,-0.18660000f,-0.80680002f,0.77399999f,0.31919999f,0.93340001f,0.57300000f,0.21540000f,0.93150001f,-0.98820002f,-0.30810001f,-0.93800004f,-0.56740000f,-0.02690000f,0.25719998f,0.17440000f,0.00530000f,-0.08570000f,0.32700001f,-0.06420000f,-0.50670000f,0.20640001f,0.05130000f,0.30350001f,-0.23580000f,-0.20320001f,0.55650001f,-0.54279998f,0.32050000f,0.68640000f,-0.84319999f,0.39280001f,-0.76169999f,0.95020000f,-0.42200001f,-0.44499999f,0.56319999f,-0.25140000f,0.76329998f,-1.10279998f,0.45210000f,0.44080003f,-0.65500002f,0.27610001f,0.31060001f,0.03900000f,0.13690001f,0.57499998f,-0.81239997f,0.34519999f,0.26249999f,-0.80879999f,0.18750000f,-0.95980001f,1.33280000f,-0.56140002f,-1.18759998f,1.00699998f,-0.63570001f,0.37110000f,-0.31880000f,0.19870001f,0.97650001f,-0.74060001f,0.51240002f,0.12910000f,-0.38680001f,0.08830000f,0.13979999f,-0.89050000f,-0.09820000f,-0.01760000f,0.51530003f,0.58800000f,0.41999999f,1.15079999f,-0.57840001f,-0.29340000f,-1.03780003f,-0.28759999f,-0.00250000f,-0.00770000f,0.15440001f,0.00730000f,-0.23449998f,1.01360003f,0.35080001f,1.23240003f,0.17720000f,-0.02360000f,-0.04099999f,-0.72240001f,-0.17040000f,-0.50880002f,0.57100001f,0.28340000f,0.37970001f,1.06940000f,0.33160000f,0.98350002f,0.54760000f,0.03320000f,-0.31300001f,-0.77740001f,-0.16490001f,-0.15420003f,-0.15599999f,0.06030000f,0.25090000f,-0.53660002f,-0.32200001f,-0.62670003f,-1.00280002f,-0.19340000f,-0.53730002f,-0.11320000f,-0.25450001f,0.04200003f,-0.08400001f,0.05040000f,-0.16160000f,0.54299999f,-0.12769999f,-0.50789998f,0.62579997f,-0.28280000f,0.44110000f,-0.19280000f,0.22530000f,0.77540003f,-1.35339999f,0.47590002f,0.35679999f,-0.46940000f,0.19890001f,-0.85260000f,1.11900000f,-0.48870001f,0.62450003f,-0.24380002f,0.33360001f,1.06209999f,-1.43439996f,0.61830000f,1.18940000f,-0.90919997f,0.63120001f,-1.20760000f,1.08799999f,-0.65840001f,-0.48549998f,0.47439998f,-0.25930000f,-0.36890003f,0.12680001f,-0.20530001f,-1.22720001f,0.75160001f,-0.17440000f,-0.06050000f,-0.52350003f,-0.47760001f,-0.13620000f,-0.69060003f,0.15140001f,0.06280000f,-0.10589998f,-0.66739998f,-0.20109999f,-0.70979999f,1.15100002f,0.36910000f,1.29120004f,0.22820001f,0.21250000f,0.33040001f,-0.73420001f,-0.26060000f,-0.46370002f,0.43779999f,0.39440000f,1.12690000f,-0.63300001f,-0.12090000f,-0.80800001f,-0.76780000f,-0.23120000f,-1.06590003f,-0.47120000f,-0.21070000f,-0.87730002f,-0.15140001f,-0.13630000f,-0.08260001f,-0.54080001f,-0.13600001f,-0.71760004f,0.70259999f,0.21840000f,0.87170002f,0.07180000f,0.22079999f,0.08990002f,0.38620000f,0.01720001f,-0.29939998f,0.81519999f,-0.20100000f,0.31910001f,-0.01480001f,0.15910001f,-0.59659997f,0.96739996f,-0.35769999f,0.97100001f,-1.60720000f,0.58660001f,0.07780003f,0.23439999f,0.03660000f,-0.86630001f,0.74079999f,-0.47850001f,-0.19830000f,0.14980003f,-0.08120002f,-0.50000000f,1.27980000f,-0.32450002f,-0.50769998f,1.23679998f,-0.33230000f,-0.12129999f,0.57799999f,-0.10529999f,-0.15160002f,-0.20319999f,-0.06960000f,-0.39319998f,0.96839998f,-0.25540000f,0.53589996f,-1.05159996f,0.33429999f,-0.34230001f,0.49170001f,-0.93020000f,-0.37690000f,-1.19180004f,0.12700001f,0.07220000f,-0.01270000f,-0.65880001f,-0.23580000f,-0.82800004f,-0.65980005f,-0.32330001f,-0.52700004f,-0.27180001f,-0.08190000f,-0.78120002f,-0.21639999f,0.00100000f,0.34600001f,0.69580004f,0.29990001f,0.41360004f,-0.98680001f,-0.28400000f,-1.05060005f,-0.67460001f,-0.15040000f,-0.81850001f,-0.01560001f,-0.08490001f,0.18470000f,-0.44260005f,-0.40100002f,-1.14710007f,0.84019999f,0.12159999f,0.18730000f,-0.59280000f,-0.34380000f,-1.02100002f,-0.13740000f,-0.12090000f,0.02100001f,0.92600002f,-0.19800001f,-0.64379999f,1.03939998f,-0.39529999f,0.20450001f,0.03260000f,0.10140000f,-0.48119999f,0.86000000f,-0.29760000f,-0.66020007f,0.34300005f,-0.35910003f,0.10980001f,0.63720001f,0.01080000f,-0.63560000f,0.30919998f,-0.32580000f,0.81620005f,-0.46520003f,0.44040002f,-0.88719999f,1.48739999f,-0.53390001f,-0.55390000f,1.25159999f,-0.35070002f,-0.12290003f,-0.41639999f,-0.04010001f,0.20709995f,-0.15719996f,0.08549999f,1.31529998f,-1.42579998f,0.72780001f,-0.17720000f,0.35300000f,-0.12709999f,-0.20760002f,-0.22000000f,-0.09480000f,1.45200002f,-0.31470001f,-0.61620000f,-0.24750000f,-0.38860001f,0.48279999f,0.03620000f,0.28960000f,0.12840003f,0.08550000f,-0.27769998f,-0.59039999f,-0.19949999f,-0.63370000f,-0.07959999f,0.10810000f,0.54250001f,-1.09759999f,-0.20859999f,-0.41060001f,1.08280000f,0.21380000f,0.46840002f,-0.47120002f,-0.22510000f,-0.57130002f,-0.23580000f,-0.03150000f,-0.36240000f,-0.54520001f,-0.07250000f,-0.36290002f,-0.30960000f,-0.15390000f,-0.77730000f,0.33980004f,0.29620001f,0.70690003f,0.64520001f,0.21790000f,0.41430002f,-0.65600000f,-0.20200000f,-0.74720002f,-0.69080000f,-0.32130000f,-0.71480001f,0.49959999f,-0.39020000f,0.64019997f,-1.05179997f,0.37390000f,0.39110004f,0.21679995f,0.18170002f,-0.51409999f,0.76719997f,-0.30590000f,-0.57890000f,0.36459999f,-0.29520001f,-1.57739998f,1.73399997f,-0.87800001f,1.50719998f,-1.70799995f,0.84280001f,-0.33430003f,0.36580001f,-0.19680001f,-0.14819999f,0.56439999f,-0.10680000f,-0.68329999f,1.07160000f,-0.39810001f,0.07109999f,0.41359999f,0.00090000f,-0.02929995f,0.15719997f,-0.00569999f,0.76130001f,-0.70140000f,0.42280001f,-0.54899998f,0.95699998f,-0.33410000f,-0.92469998f,0.57770001f,-0.64960001f,-0.12020000f,-0.59540002f,1.09620004f,0.41460001f,1.39390004f,-0.26960000f,0.01040000f,-0.14160000f,0.95780003f,0.21730001f,0.68440004f,-0.64640003f,-0.28870001f,-0.58890004f,-0.75400000f,-0.21710000f,-0.67350001f,0.15620000f,0.00790000f,-0.27459998f,0.16760000f,0.03670000f,0.10710000f,0.97580000f,0.29050000f,0.89220003f,0.23280001f,0.16830000f,0.45010001f,0.00119999f,-0.09630000f,-0.31630000f,0.13800002f,0.21000000f,0.48460001f,1.04120000f,0.30460000f,0.79760003f,-0.45280001f,-0.14210000f,-0.33030001f,0.32900000f,0.38930000f,-0.68239999f,1.21420000f,-0.40890001f,0.77930004f,-1.34480002f,0.48110002f,-0.38539999f,0.70699999f,-0.22750000f,1.12720002f,-1.52500001f,0.64830002f,-0.60710004f,0.49060001f,-0.34000002f,-0.77049999f,1.07219998f,-0.44900000f,0.47279999f,-0.17440000f,0.23960000f,0.20690000f,-0.26620000f,0.11800000f,0.97819998f,-1.35739997f,0.57070000f,0.01970002f,-0.02200001f,0.02090001f,0.27129998f,-0.25399999f,0.14050000f,-0.19299996f,0.34599996f,-0.10119999f,1.15679999f,-1.39479997f,0.66020000f,-0.51070000f,0.55760000f,-0.28850001f,0.49800001f,0.05859996f,1.07860003f,0.22130001f,0.57440004f,-0.14140000f,-0.15380000f,-0.58050001f,0.05060000f,-0.11720000f,-0.60510001f,-0.01520000f,0.04190000f,-0.16790000f,-0.23500000f,-0.09230000f,-0.75160000f,-0.11220001f,-0.07710000f,0.29859998f,-0.17680000f,-0.08720000f,-0.60920000f,-0.15480002f,-0.25650000f,-0.63090003f,0.77260002f,0.17180000f,0.32450003f,0.64180002f,0.27530000f,0.16560002f,0.55479999f,0.05450000f,-0.20669998f,-0.51660004f,-0.30150001f,-0.66960005f,-0.50380001f,-0.03350000f,0.08879999f,-0.62940000f,-0.19260000f,-0.38930001f,0.03740002f,-0.72210002f,1.42040002f,-1.71940002f,0.80190003f,0.23089999f,-0.05320001f,0.10570000f,0.57590000f,-0.30840000f,0.28990001f,0.07470002f,0.29380000f,0.02140000f,0.15900001f,0.49759998f,0.04220001f,-0.38080002f,-0.22719997f,-0.17560001f,0.15880000f,0.32079999f,0.05280000f,0.28829997f,-0.43359997f,0.14970000f,1.07390001f,-1.13240001f,0.59670002f,0.90820003f,-0.32800001f,0.47540001f,1.11669996f,-0.88739996f,0.59599999f,-0.31140004f,0.19080002f,-0.18000001f,-0.95020000f,0.92240001f,-0.51620001f,-0.76210000f,0.76139999f,-0.42520001f,0.37460004f,-0.28319999f,0.14240000f,-0.07790000f,-0.32089999f,-0.35800002f,-0.26900000f,-0.20920001f,0.32859999f,0.16999999f,0.00150000f,0.18439999f,-0.05450000f,-0.16210000f,0.69500000f,0.19540000f,0.84650003f,-0.86399998f,-0.21600000f,-0.61320001f,0.00979998f,-0.02480000f,0.55490001f,-0.88280003f,-0.13090001f,-0.24410003f,-0.40560003f,-0.18900001f,-0.15340002f,0.18700002f,0.22220001f,0.42850002f,0.71000001f,0.36250000f,0.87610002f,0.52380000f,0.08250000f,0.44020002f,0.16880001f,0.12220000f,0.31940001f,-0.78179998f,-0.16199999f,-0.48490000f,0.69240001f,0.03960001f,0.51909999f,-0.48440000f,0.27510001f,-0.37200005f,-0.24799997f,-0.18160001f,0.51190000f,-0.00380000f,0.25820000f,0.47009997f,-0.55619996f,0.25699999f,0.55049998f,-1.11979998f,0.34400000f,-1.01099997f,1.28899995f,-0.57809999f,-0.36930007f,-0.40079995f,-0.15670003f,-1.34670002f,1.50820002f,-0.74840003f,-0.53240004f,0.16780003f,-0.27890002f,-0.07049996f,0.31759998f,-0.03949999f,0.48250002f,-0.45999999f,0.28230000f,0.58519998f,-1.02039997f,0.34820000f,0.01920002f,-0.01180001f,0.01730000f,-0.97969996f,1.27339996f,-0.55879999f,0.92410000f,0.18540001f,0.22419999f,0.01340000f,0.26910001f,0.44820001f,0.19620000f,0.85950002f,0.52159999f,0.08650000f,0.14110000f,0.32480000f,0.02500000f,0.56620002f,-0.33719998f,-0.30419999f,-0.90880001f,-0.20900002f,-0.16960001f,0.32270001f,0.21400001f,0.10790000f,0.63310002f,-0.70780003f,-0.22760001f,-0.31430004f,-0.37560000f,-0.08610000f,-0.81210000f,0.29860000f,0.08120000f,0.01049999f,1.28180004f,0.38560001f,1.44610005f,0.38519999f,-0.04710000f,-0.36470000f,0.33080004f,0.24610001f,0.41250003f,0.10999999f,-0.16160000f,-0.62780000f,0.65960000f,0.69270003f,0.20229996f,-0.56939996f,0.13219999f,0.09930000f,-0.58000000f,0.09390000f,0.79389998f,-0.85079997f,0.43950000f,0.16419998f,-0.88839999f,0.13320000f,0.18220002f,-0.09700004f,0.07570003f,-0.53050006f,-0.41779999f,-0.24240002f,-0.11850001f,-0.32680000f,-0.03170000f,-0.94070003f,0.74860002f,-0.51300002f,-0.05189999f,0.86300000f,-0.08100001f,0.49090001f,-0.31819999f,0.26120001f,1.08670003f,-1.90160002f,0.66090003f,0.97129997f,-0.86639996f,0.51830000f,0.18770007f,0.11039994f,0.09910003f,0.71799997f,-0.61579998f,0.37410000f,0.63739998f,1.14440004f,-0.14760000f,-0.23250000f,-0.48650001f,-0.59040002f,-0.26310000f,-0.17330001f,-0.68780002f,-0.24760000f,-0.92870004f,-0.66740002f,-0.24490001f,-0.47920003f,0.28400002f,0.14290001f,0.38870002f,-1.17560000f,-0.32110000f,-1.02510003f,-0.02720000f,-0.11140000f,-0.36659999f,0.16800000f,-0.00300000f,-0.04900000f,-0.21380002f,-0.02140001f,0.45009998f,-0.02840000f,0.19070000f,0.47749999f,0.36440001f,0.28030000f,0.55430001f,-0.20860000f,0.03490000f,0.38760000f,0.21119998f,-0.08520000f,-0.16800001f,0.61080003f,0.27780001f,0.62240003f,1.05660002f,0.27530002f,0.18709999f,-0.41920001f,0.10130001f,-0.81610004f,0.27040001f,-0.42670001f,-0.45570000f,0.92360001f,-0.28970001f,-0.74260002f,0.66800001f,-0.41340001f,0.16650002f,-0.21180002f,0.10160001f,-1.22689997f,1.73299995f,-0.71500000f,0.26319998f,-0.23059999f,0.13430000f,0.33700000f,-0.35800001f,0.18400001f,-0.69570002f,0.15720002f,-0.34730002f,-0.47709998f,0.63380001f,-0.25680001f,0.13110003f,0.11119998f,0.07370000f,-0.66640000f,0.41500000f,-0.34490001f,0.53579997f,-0.74219996f,0.29790000f,0.52420004f,-0.47500003f,0.29830002f,0.92190001f,-0.30829999f,-0.45760004f,-0.29810001f,-0.42190003f,-0.04659999f,0.07840000f,0.02510000f,0.28720000f,0.00350000f,0.12690001f,-1.03700003f,-0.25300001f,-0.40910004f,0.93219997f,0.28819999f,0.94230000f,-0.62480003f,-0.31960001f,-0.41960004f,0.40080000f,0.01260000f,-0.39580001f,1.12220000f,0.25030000f,0.56160001f,0.87880001f,0.20810001f,0.51730003f,0.20160002f,0.08040001f,-0.06159998f,0.74560000f,0.20480000f,0.16080000f,0.11580000f,0.06960000f,0.34709999f,-0.79040002f,-0.36130000f,-1.12270004f,0.31820000f,0.23230000f,0.38800001f,-0.88880002f,-0.48429998f,0.49550001f,-0.59990002f,-0.27090001f,0.53600001f,-0.62599999f,-0.38760000f,0.69700000f,-0.09009999f,0.68379999f,-0.59199998f,0.80979999f,-0.61539997f,0.54000000f,-0.56489998f,0.31460001f,-0.41850001f,-0.74010001f,-0.96610000f,0.69399999f,-0.08979999f,0.06160000f,0.62550001f,0.63360002f,0.49729999f,0.56850000f,-0.09119999f,0.38989998f,0.06700000f,0.00050000f,-0.01100000f,-0.20749999f,0.00770000f,-0.79409997f,-0.39349998f,1.06639999f,-0.56009997f,-0.32399999f,0.00209999f,-0.44919998f,0.31800002f,0.78750001f,0.20660000f,0.51850000f,-0.12570000f,0.18690001f,-0.03990002f,-0.52230002f,0.48330004f,1.56150001f,-0.03490001f,0.16050000f,0.78119998f,0.13280001f,-0.09709999f,-0.90220003f,-0.43600003f,-0.45959998f,0.58949998f,0.51930000f,-1.12250000f,0.35000002f,-0.02900000f,0.72810002f,-0.15600003f,-0.72880002f,1.57830001f,-1.04130000f,-0.18209998f,0.37070002f,1.52349996f,0.14889999f,0.40830000f,-0.07230003f,0.56690003f,-0.43410002f,-0.80339999f,0.41320001f,0.68430002f,0.30390002f,0.23870001f,-1.04030002f,0.52100002f,0.42840001f,0.14699997f,0.92159999f,0.55140003f,-0.06720001f,-0.64890001f,0.54700000f,-0.23500001f,-0.01880000f,-0.32099999f,0.72359999f,-0.61160001f,-0.29749999f,0.42889999f,-0.27849998f,0.64900000f,-0.60850002f,0.31719999f,-0.34400000f,0.57949997f,0.12519999f,0.86799998f,0.39590001f,0.76699998f,0.41750000f,-0.47270001f,-0.35070000f,-0.92500002f,-0.92419999f,-0.93760000f,-0.47849998f,0.78779997f,-0.56189999f,-1.04600000f,0.07399998f,-0.40659998f,-0.21600000f,-0.20190000f,0.36620000f,-0.82200000f,0.10860000f,-0.60260000f,0.20600000f,0.62590001f,0.58060000f,-0.83749998f,0.64820000f,-0.38149997f,-0.48350000f,-0.53490003f,0.95169999f,-0.80319998f,-0.07039999f,-0.84929998f,-0.83399997f,0.44740001f,1.01600004f,1.23160000f,-0.65260003f,0.40450000f,-0.26560001f,0.07560001f,0.27999998f,1.92740000f,-0.01039998f,0.08910000f,-0.78540001f,0.25060003f,0.66420003f,0.69090001f,-0.09950000f,-0.67350001f,0.24330000f,0.87670004f,0.76690002f,0.71989999f,-0.28110001f,0.84420001f,-1.25250006f,-0.22310000f,0.41400000f,1.28519998f,-0.52620002f,0.30200002f,0.46090000f,0.39910001f,-0.47580000f,1.09230001f,0.53510002f,-0.11860001f,0.59680004f,0.63000004f,-0.31780001f,0.20799999f,-0.60850000f,-0.63709998f,-0.54389999f,0.04699996f,-0.12530000f,0.66759996f,0.09650002f,0.23440000f,-0.81350001f,-0.39750001f,-0.19470000f,-0.26650000f,-0.20449999f,0.96620001f,-0.53049997f,-0.39050003f,-0.34990000f,0.01530000f,-0.36550000f,0.20350000f,-0.58190001f,-0.65250003f,0.55859999f,0.26450000f,-0.20349999f,0.13720000f,-0.62330000f,-0.32600002f,-0.90670003f,-0.35640000f,0.37650002f,0.42360000f,-0.40949999f,-0.75000000f,0.32129999f,-0.38400000f,-0.35550000f,0.85530000f,0.04810001f,-0.74200002f,0.55420002f,-0.14880000f,-0.94800003f,-0.17530000f,-0.07269998f,2.23960005f,-0.18100002f,0.06339999f,-0.23949999f,-0.58469999f,-0.65300002f,0.50750003f,0.62050003f,1.28740003f,0.81259999f,-0.94780003f,-0.15150001f,1.42110002f,-0.00310000f,-0.30110001f,-0.64359998f,0.75240003f,-0.71140003f,-0.37220000f,-0.27760002f,0.61000001f,-0.31210001f,0.09310002f,-1.29170004f,-0.49659999f,0.85020003f,0.27579998f,-0.78879999f,-0.27860000f,-0.25480002f,-0.65780000f,-0.31480001f,1.19280001f,0.23099994f,-0.61640002f,0.94740001f,-0.67680004f,-0.61840002f,-1.24830002f,-0.45690000f,0.88230001f,0.64829999f,0.75789999f,0.27900003f,1.14330002f,-0.28960001f,0.72149997f,-0.33809998f,0.11869999f,-0.33300001f,0.60810001f,0.25900001f,0.28500002f,-0.14160000f,-0.87780000f,0.10850003f,0.78400001f,-0.13049999f,-0.76050001f,-0.02790000f,0.16970000f,0.89350002f,-0.15280000f,0.64230000f,-0.57250001f,-0.25370000f,-0.41250000f,-0.15550001f,0.27730000f,0.84790001f,0.16549999f,-0.56779998f,-0.00810000f,0.60550000f,-0.40659999f,0.36510000f,-0.07649997f,-0.31980002f,-0.78009998f,0.11300001f,-0.75500001f,-0.44579999f,-0.22999999f,0.30079998f,0.80260000f,-0.57600002f,-0.37280000f,-0.10870001f,1.83429996f,0.05330001f,0.61200000f,0.55139998f,-0.41240002f,-0.56710002f,1.94410002f,-0.00529999f,-0.04200002f,-0.57960000f,-0.65940001f,-0.29320000f,0.21759999f,-0.49000002f,-0.71210000f,0.43760000f,0.15420000f,0.62849997f,0.07349997f,0.35350003f,1.01559999f,0.63439993f,-1.09420002f,-0.60760001f,-1.59469999f,0.57550002f,0.55100001f,-0.62870002f,-0.33030001f,-0.14050001f,0.63879999f,0.37620002f,1.41710003f,-0.38330006f,-0.71650003f,0.17800002f,1.42369998f,-0.04670001f,-0.75419999f,-0.74129996f,0.35290000f,-0.46020002f,-0.02870000f,0.00050001f,1.01439999f,-0.24409998f,0.08450003f,0.03340000f,-0.45349998f,0.41650001f,1.14260002f,0.08470001f,0.89950000f,-0.52359998f,0.26950000f,0.85900000f,0.00680000f,0.28140000f,0.32300000f,0.42430000f,0.41320000f,-0.92999999f,0.03599999f,-0.54699997f,0.67950002f,-0.23280002f,-0.61769997f,-0.29600003f,-0.53350000f,0.59319999f,0.02850000f,-0.55410001f,-0.22550000f,-0.39300000f,0.49469999f,-0.08599999f,-0.10799998f,-0.72420003f,-0.81819999f,-0.07849999f,0.70609999f,-0.36250000f,0.09999998f,-0.12669999f,0.60239997f,0.16699998f,0.34590002f,0.63660000f,-0.78720003f,-0.22860000f,0.17780000f,0.59380001f,0.21680002f,-1.48990003f,1.02160002f,0.17760001f,0.66290002f,1.39689998f,-0.19510001f,1.19139999f,-0.23770003f,-0.05649997f,-1.41500001f,0.56690003f,0.38910000f,-0.98539998f,1.36069998f,0.17550000f,-0.57549999f,1.09779999f,-0.12580001f,0.02400000f,-1.92630001f,0.25330001f,-0.86870000f,0.42199999f,0.17259999f,-1.63049998f,0.85110003f,0.33090001f,0.41620002f,1.41169997f,-0.36030000f,-0.23759998f,0.43049998f,0.42429999f,-0.53829999f,0.41770002f,-0.04830001f,-0.15340000f,-0.49989998f,-0.16750001f,-0.62060001f,-0.28270000f,-0.41950001f,0.35440001f,-0.27710000f,0.86550001f,0.89490001f,0.87730001f,-0.24299998f,0.54659999f,-0.68079999f,-0.80750001f,-0.37870000f,-0.81829998f,0.53500000f,0.71030000f,0.85499999f,0.49249999f,0.97569998f,0.45129999f,0.58550001f,0.65349999f,0.26049999f,-0.33950002f,-0.94270001f,0.25649999f,0.41500000f,0.45289999f,0.52640000f,0.76949996f,0.88380001f,0.97649996f,0.15649999f,0.54669999f,-0.46790000f,-0.38299999f,0.41929997f,0.01020000f,0.46000001f,0.31100001f,0.33259999f,-0.85249999f,-0.22790002f,-0.74560001f,-0.31729997f,0.72810003f,1.32920005f,-0.08420002f,-0.39640003f,1.20010002f,-1.30600002f,-0.26880002f,0.02839998f,0.87190001f,0.80990003f,-0.91619999f,0.73289998f,0.21869999f,0.99659999f,0.73439995f,-1.01720000f,-0.41510001f,-1.67169999f,0.25750002f,0.15300002f,-1.03320002f,-0.11980001f,0.29100000f,-0.77070002f,-0.68930002f,-1.24470001f,0.40230003f,0.53330001f,-0.47300000f,-0.20740000f,-0.07760000f,-1.31009997f,-0.38429998f,0.65509999f,-0.71730002f,-0.08549999f,1.13490005f,0.98790000f,-0.69840005f,-0.34280000f,1.25440003f,0.05059999f,-0.40100002f,0.22430001f,0.44419999f,-0.46449999f,-0.43940002f,-0.87290001f,-0.52949999f,-1.02030001f,-0.59770000f,-1.08849998f,0.73270000f,-0.34129997f,0.38800000f,0.64309998f,0.49839999f,0.59200000f,-0.14980000f,-0.63719998f,-0.02100003f,-0.72000000f,0.53319999f,0.04949999f,-0.61980002f,0.08949998f,0.69299999f,-0.70050000f,0.06499999f,0.22050000f,0.63840000f,0.72789999f,0.45349999f,-0.04400000f,0.39749999f,0.11349998f,0.27439998f,0.88369996f,-0.95700002f,0.48000000f,0.29760000f,-0.27850000f,-0.68090002f,-0.53029998f,-0.27649998f,0.45340002f,-0.50540001f,-0.47440000f,-0.15840001f,-1.24350001f,0.18330002f,0.57470001f,-0.83650004f,-0.09020000f,0.05520000f,0.38640000f,-0.24360000f,-0.19360000f,0.59320004f,1.79269997f,-0.44130001f,0.56720000f,1.44069999f,-0.63930003f,0.03760000f,-0.87159999f,-0.19020001f,-1.19090002f,0.00950005f,0.91270004f,0.01110000f,-0.61949999f,0.23070000f,0.05710000f,-0.45520003f,0.61140003f,-0.28859998f,1.92329995f,-0.10650001f,0.57350000f,0.51279994f,0.68720003f,0.19280005f,1.96839999f,0.02419997f,0.38610000f,-0.66090000f,0.42110002f,0.02010001f,-0.51409999f,0.58499999f,-0.20700000f,0.48379999f,0.16649999f,0.53580000f,0.75549999f,0.54800001f,0.13450001f,0.61500001f,-0.03100000f,-0.27079999f,-0.19980000f,0.12950000f,0.68709998f,-0.64490000f,0.41050005f,0.43790000f,-0.52389998f,0.22649999f,-0.53519999f,0.16129999f,-0.31500003f,0.54780002f,0.67479999f,-0.30750000f,-0.25320000f,0.04830000f,-0.84200003f,-0.04570002f,-0.09420000f,0.34300000f,1.04269997f,-0.09380000f,-1.32950001f,0.39349997f,-0.65249998f,-0.18549998f,1.01679997f,-0.48110001f,-0.83500002f,-0.28400001f,-0.25920000f,-0.36199998f,0.12460001f,-1.02489999f,-0.60409997f,0.30630000f,0.57810005f,0.80369999f,0.62050001f,-1.37900004f,0.27170002f,0.81930003f,1.64799999f,-0.83470004f,-0.25129999f,-1.60440001f,0.62130009f,0.35789999f,-0.23469997f,-0.68269997f,-0.28070002f,-0.17349999f,1.41880001f,0.17320001f,0.67280002f,-1.13930004f,-0.42210002f,-0.16199998f,0.01200001f,-0.69700004f,0.50350001f,-0.34150002f,-0.34050001f,0.90110003f,1.14460001f,-0.49740002f,-0.79289999f,-0.61499997f,0.00419999f,0.37150001f,0.78169997f,-0.65670001f,-0.28979998f,-0.83279999f,-0.81180005f,-0.56470002f,-0.42440001f,0.36099998f,-0.01659999f,0.78679997f,-1.24700001f,0.52459997f,-0.69120001f,-0.05450000f,0.69230000f,0.78750001f,-0.88699999f,-0.85150001f,-1.00899997f,0.71600001f,0.76570004f,0.99079998f,0.54599999f,-0.41219999f,0.34739997f,-0.10649999f,0.84690001f,-0.15150000f,0.06150000f,-0.88050002f,-0.20810001f,1.03450001f,-0.19840000f,0.26449998f,0.07550000f,-0.39560001f,-0.23750000f,-0.02149999f,0.26330001f,-0.74770001f,0.58549998f,-0.17029999f,0.68329997f,0.58200000f,0.11999999f,-0.26500000f,1.28450000f,-0.66140000f,0.52609997f,0.63800002f,-0.23440003f,1.31600001f,-0.39290005f,-0.32210001f,-0.29880001f,-1.45769999f,0.47710002f,0.63720002f,-1.64130005f,-0.23030001f,-0.68800001f,-1.71169995f,0.50670000f,0.66829999f,0.22179998f,-0.45920000f,-0.06160000f,0.58780000f,-0.07400000f,-0.07549999f,-1.50039997f,-0.47960002f,0.45430001f,-0.44980002f,-0.92160002f,-0.30620000f,0.39710000f,0.25550000f,1.08870003f,-0.02309999f,-0.46050001f,-0.88950001f,-0.13440001f,0.17640000f,0.37270000f,0.67459991f,0.81480004f,-0.65740001f,-0.44600002f,0.95320003f,-0.64199999f,-0.34259996f,0.25660000f,-0.09220005f,0.48609997f,-0.55049999f,-0.57570002f,-0.82649998f,-0.39650002f,-0.55450000f,0.36509999f,-0.16100002f,-1.07530003f,-0.13740001f,-0.14550001f,-0.60329999f,0.68649999f,0.10600001f,-0.16870000f,-0.42859998f,0.13950001f,0.29940000f,-0.03929999f,0.69349998f,-0.94549998f,0.41249997f,0.87499999f,-0.64070000f,-0.05960001f,-0.11050000f,0.35769999f,0.10190000f,-0.20250001f,-0.38159999f,-0.69390001f,0.42850000f,0.16249999f,0.63550000f,-1.34900001f,0.56209995f,-0.56039997f,-0.76100002f,0.21499998f,0.35380000f,0.14099998f,0.03060001f,0.47299998f,0.34450000f,-0.71600003f,-0.45130000f,0.41320002f,-0.08980001f,1.16070001f,-0.85050000f,-0.16309997f,-0.56399999f,0.04650001f,-0.15150001f,0.41010003f,0.80400000f,-0.00180000f,0.36170003f,1.79860004f,-0.49920003f,0.04890001f,-0.08910003f,0.55390003f,0.00820003f,-1.73350000f,-0.28010003f,0.98289999f,0.62359995f,-0.70680002f,0.12970001f,0.36439999f,0.44500002f,-0.55980002f,0.98250003f,0.54490003f,-0.37120001f,0.88120003f,0.67240003f,-0.17490001f,0.73350004f,0.80070004f,-0.60669999f,1.18720001f,0.03739998f,-0.79130003f,-0.37570002f,-0.42490000f,0.67310002f,0.12699998f,0.45000001f,0.27750001f,0.27859999f,-0.64150004f,-0.73459999f,-0.66890000f,0.61649999f,0.08370000f,0.43649998f,-0.30600000f,0.34650000f,-0.43620001f,0.37700003f,0.71590002f,-0.46440001f,-0.76250003f,0.13099998f,-0.13830000f,0.37099999f,-1.01810001f,0.34859996f,0.19550003f,-0.10070001f,-0.67429997f,-0.68200001f,0.31929999f,-0.25140000f,-0.30550000f,0.81670002f,0.12610001f,-0.61200000f,0.76920001f,-0.02159999f,-0.92500001f,0.69580002f,-0.16719999f,0.39400002f,0.76249999f,0.23340000f,1.14600000f,-0.18899999f,0.73260001f,0.51600003f,-0.41170000f,-1.62189999f,0.65230000f,0.39090000f,0.88900000f,0.16969998f,-0.90870000f,0.06830000f,-0.81049998f,-0.22990000f,-0.60029998f,-0.07889999f,0.60729999f,0.52300000f,-0.28060001f,-0.38340001f,0.81960001f,0.90179999f,-0.21560000f,-0.71620000f,-1.20859997f,0.72820003f,0.21390000f,1.47330002f,-0.00850000f,-0.40130000f,0.80870000f,0.38370001f,0.50229998f,-0.89409998f,0.11370001f,0.22259998f,1.07520001f,0.20700002f,-0.48940000f,0.73810000f,0.31410001f,0.41129999f,-0.80939999f,0.22000002f,0.13100001f,-1.22509999f,-0.39390002f,-1.45640001f,-0.96949998f,0.68549999f,0.79679999f,0.99129998f,0.53249999f,-0.39209999f,-0.48550000f,0.25549999f,-0.52219999f,0.13689999f,-0.35149999f,0.28159998f,0.32309998f,0.11700000f,-0.38160000f,-0.25299999f,-0.32949999f,0.24580000f,-0.70669999f,-0.41800004f,-0.25519999f,0.57439998f,-0.15549998f,0.73840001f,-0.40529999f,-0.21050000f,0.63859999f,0.07410000f,-0.51650000f,-0.53499998f,-0.23909999f,-0.44250000f,0.59820001f,-0.38969998f,-0.05350000f,0.59469999f,0.16530000f,-0.58900001f,-0.43609999f,-0.20959999f,0.42649999f,-0.81049999f,0.19649998f,0.99049999f,0.59170002f,-1.33439997f,0.45450004f,0.58869999f,0.33760001f,0.36710000f,-0.62590003f,-0.28939998f,1.34509999f,0.47410001f,-0.96590001f,0.48410000f,0.23410000f,-0.53280002f,-0.95669997f,-0.15690001f,-0.58750001f,-0.63469998f,0.62070002f,-0.14610000f,-1.72379997f,-0.28940001f,1.03490003f,0.02800000f,0.09480001f,-0.80900003f,-0.45370000f,-0.16230001f,-0.79660000f,0.21430003f,0.24250000f,1.05990000f,-0.71010002f,0.14590002f,-0.05930000f,-0.90309998f,0.37150000f,-0.54660001f,-0.60419999f,0.04300000f,-0.67890001f,0.12870000f,-0.17650001f,-0.11749998f,-0.22899999f,0.21399999f,0.70250000f,0.77279997f,0.56900001f,-0.08330000f,-0.17620000f,-0.41500000f,0.93249998f,-0.11820000f,0.40600000f,0.52579999f,0.57380000f,0.60600000f,-0.45749998f,0.58559999f,-0.37550002f,-0.01180000f,0.40549999f,0.49749998f,-0.98589998f,0.46169997f,-0.89150001f,-0.15550000f,-0.78130001f,0.81500001f,-0.13789999f,0.70300001f,0.27099999f,0.35210001f,0.49419998f,-0.97300001f,-0.53540001f,-0.68479998f,-0.43850000f,-0.34240000f,0.11810000f,0.35199999f,-0.19960000f,0.49319999f,0.73400000f,0.14140000f,0.51180000f,-0.99000003f,0.58270002f,-0.98400003f,-1.10820000f,0.78720002f,-0.26229998f,-1.03369996f,-0.06090001f,-0.24770001f,0.02480003f,0.55480001f,0.56950001f,-1.53940000f,-0.23860002f,-0.44789998f,-1.43249995f,0.02769999f,-0.35280001f,-0.01979998f,0.15820001f,1.02319998f,-0.92509997f,-0.07749999f,0.54689998f,-0.25109997f,-0.77010002f,-0.82190001f,1.01899999f,0.20920002f,-0.23190000f,-0.61500001f,-0.55580005f,-0.30410000f,0.34039999f,-0.06060000f,1.20370002f,-0.30459998f,-0.27999999f,-0.39380001f,-1.16770001f,-0.21890002f,-0.29780000f,0.06560000f,0.48880002f,-0.49940003f,-0.27749998f,-0.29750001f,-0.12940001f,0.74050000f,0.27999998f,-0.51879999f,0.38059997f,-0.54449999f,0.24990001f,0.05890000f,-0.10049999f,-1.01070000f,-0.10350001f,0.30349998f,-0.66439998f,0.56529997f,0.05400000f,0.11220001f,0.22760000f,-0.65149999f,-0.71829998f,-0.57389998f,0.60650002f,-0.50179997f,-0.19329999f,0.32899998f,0.77350000f,0.38280000f,0.90450003f,-0.47010001f,0.39230000f,0.30300000f,0.21990000f,0.17720000f,-0.52300002f,-0.49249998f,-0.76840001f,0.58550000f,-0.61790001f,0.53309999f,-0.42100001f,0.25899999f,0.10260000f,-0.21650003f,-0.13880001f,-1.58179999f,0.41599999f,0.55139999f,0.69900001f,0.97679997f,-0.01480000f,-1.47410004f,-0.27789996f,0.99270005f,0.52750001f,0.73759998f,-0.51560002f,-1.54729997f,-0.29079998f,1.04820001f,-0.34070003f,-1.90149998f,0.18710000f,1.43620001f,-0.39490007f,-0.53670001f,0.69839999f,0.79859996f,-0.13680000f,0.35530003f,1.25749999f,-0.12290001f,-0.92599998f,0.55160003f,-0.14160003f,-0.92629997f,0.27980002f,0.23659999f,-0.78129998f,0.00609999f,0.50529999f,-0.03860002f,-1.80249998f,-0.22670000f,0.28090001f,-1.13230002f,0.12810001f,0.54879999f,0.31970000f,0.44650000f,0.71779998f,0.96809998f,-0.50399999f,0.37739999f,-0.67399998f,-0.20850002f,0.47760002f,0.91370000f,0.28150002f,0.11389999f,-0.40149999f,-0.22700003f,0.50389998f,0.95759996f,0.01750000f,-0.88059999f,0.53290000f,-0.35799998f,-0.67310003f,-0.86839998f,-0.34249998f,0.24139999f,-0.61729997f,-0.10900000f,0.55719999f,-0.44760000f,0.86900001f,0.42640001f,0.61299997f,0.37449998f,0.41030000f,0.57909996f,-0.08400000f,0.32759997f,0.46259998f,0.33599998f,-1.02749998f,0.38319999f,-0.37000002f,-0.61340001f,-0.03980001f,-0.20199999f,0.26489999f,0.14970001f,-0.15180001f,-0.73480003f,0.77189997f,-0.09450000f,-0.45769999f,-0.56339999f,-1.07159999f,-0.19820002f,0.90499999f,0.39399999f,0.12700000f,-0.35070002f,0.01500004f,0.64160003f,-0.13530001f,-1.58279999f,0.44320000f,-0.12580000f,0.11020001f,0.17920001f,-1.13969999f,1.15380005f,0.23379998f,-1.61879999f,0.70079999f,0.21059997f,-0.74670000f,-0.36869995f,0.67330002f,-0.26590002f,1.03810000f,0.26510002f,-0.17109999f,-1.95019998f,0.27900001f,1.21330000f,0.39709997f,-0.52350000f,0.56940000f,-0.23340001f,-0.67580000f,1.11930000f,-0.21780001f,-0.01740001f,0.79540001f,0.55100005f,0.05699999f,0.88599999f,0.61160002f,-0.48999998f,0.06430000f,-0.52690001f,0.72209997f,-0.59419999f,-0.35380002f,-0.41710000f,0.52249998f,0.23649999f,0.38319998f,0.81519999f,1.44200005f,-0.04900000f,0.34539999f,-0.25539999f,-0.08309998f,-0.43050000f,-1.21770003f,-0.28749998f,0.14210000f,-0.33710000f,0.01080000f,0.03410000f,-0.02750000f,0.55709997f,0.26359999f,0.43480000f,0.78969997f,-0.72629999f,-0.75750003f,0.30559998f,0.05990000f,0.34630000f,0.16910001f,-0.55029999f,-1.11710004f,-0.03610000f,0.04110000f,0.66450000f,0.37540000f,-0.39639999f,-0.18949999f,-0.45820002f,-0.32660002f,-0.26899999f,-0.32100000f,-0.05370000f,0.67930000f,0.57740001f,-0.16189999f,-0.46440000f,-0.31160000f,0.16910000f,0.76969997f,0.56499998f,-0.42669999f,0.62680000f,0.29260000f,-0.39849999f,-0.77010001f,-0.51220000f,0.55480000f,-0.39579998f,-0.55780001f,-0.18560000f,-1.11350000f,-0.71219999f,0.62820001f,-0.37870000f,-0.02059998f,0.46429999f,-0.77990000f,-0.62020001f,0.31239999f,0.03750000f,0.08619999f,-0.04990000f,-0.88349999f,-0.71000000f,0.27139999f,-0.59450000f,0.56280003f,-0.05390000f,0.42720000f,0.01080003f,0.69770000f,-0.41139998f,-0.38780000f,0.34949998f,-0.32919999f,-0.21560001f,-0.43110000f,0.60230001f,0.23230005f,0.11920000f,-0.64709997f,-0.53669999f,-0.35529997f,-0.26630001f,-1.18510001f,0.08469999f,0.70100000f,0.48100004f,0.27109999f,0.71879997f,1.87440003f,0.68049998f,-0.55189997f,-0.40630000f,0.27269998f,-0.33159999f,0.58960000f,-0.34609999f,-0.10850000f,0.16789999f,0.43430000f,-0.17020000f,0.53019999f,-0.16269999f,-0.64710000f,-1.04670004f,0.48399998f,-0.68610000f,-0.15930005f,-0.11580000f,-0.14020000f,-0.53079999f,-0.31779999f,0.41709999f,-0.16810003f,0.17219999f,0.38970001f,0.38710002f,-0.13600002f,-0.63320002f,-0.38100000f,-0.24100000f,0.24910000f,-0.08230000f,-0.42800002f,-0.46060000f,-0.46540003f,-0.15340000f,0.45910002f,-0.24310000f,-0.36480002f,-0.09570001f,-0.88000003f,-0.46700001f,0.51920002f,-0.03419999f,-0.26060001f,-0.23500000f,-0.25180001f,-0.05679998f,0.37690002f,0.58110002f,0.05999999f,-0.70080000f,-0.77200000f,-0.58600001f,0.30610000f,-0.45710001f,-0.39280001f,0.04090000f,-0.84660002f,-0.59160002f,0.35700000f,-1.16460003f,0.48540004f,0.11550000f,0.46179998f,1.23380000f,-0.51929996f,-0.18770000f,-0.17289998f,0.67059999f,0.23450001f,0.04690001f,0.09749999f,0.09360000f,0.52080001f,0.73819998f,-0.58070001f,-0.74830005f,-0.16150000f,0.08619999f,0.56780002f,0.47520000f,-0.05060000f,0.19940001f,-0.00049999f,-0.83030000f,-0.42790001f,0.48589999f,0.08970000f,0.21450001f,-0.10900002f,0.70510000f,1.31870006f,0.46859998f,0.03090000f,-0.47190000f,0.36400000f,-0.39889999f,0.16430000f,0.27920000f,-0.82599999f,-0.80480003f,0.28700001f,-0.67860002f,-0.20100004f,-0.00180000f,-0.25009997f,0.41050002f,-0.13620003f,-0.79170003f,0.82829997f,0.52639998f,-0.43009998f,-0.49720001f,-0.28800001f,0.22770000f,0.64120002f,0.04839999f,-0.70360001f,0.15940002f,-0.13100001f,-0.43300002f,-0.96600001f,-0.41859999f,0.75430000f,0.85270002f,0.67960002f,-0.33520001f,-0.53950001f,-0.35800000f,0.33310001f,-0.47880002f,-0.00619999f,0.53030001f,0.21109999f,0.22280000f,0.04660000f,0.60730000f,0.51520001f,-0.16540000f,0.17930003f,-0.11119998f,-0.27940000f,0.30040002f,0.15640002f,-0.09940000f,-0.55289999f,-0.06379997f,0.55940000f,-0.59150001f,-0.56479998f,0.65570001f,-0.61149999f,-1.27910004f,-0.18359999f,0.51959997f,-0.01679999f,0.03580001f,-0.72470001f,-0.63190005f,0.57979998f,0.63140000f,0.40420003f,0.39790000f,-0.48670000f,-0.86750005f,-0.16289999f,-0.39060000f,0.31739998f,-0.47640000f,0.21710000f,-0.53210001f,0.17099999f,0.12759999f,0.73280002f,-0.50109999f,-0.66360000f,-0.60360003f,-0.20520000f,0.50649998f,0.55730000f,-0.38940000f,0.40849999f,0.00730000f,0.42699996f,0.56290001f,0.73130003f,0.03099998f,0.82400000f,0.98080004f,-0.46309999f,-0.69359997f,-0.57480002f,-0.19930000f,-0.40349999f,0.06459999f,-0.26620002f,-0.48499999f,0.25430002f,-0.03600000f,-0.34620001f,0.44779999f,0.01139997f,-0.69120000f,0.99330000f,0.70000000f,-0.43119999f,0.93100000f,0.56079999f,-0.56919999f,0.23789999f,0.17139999f,-0.17830000f,-0.92650000f,-0.65899999f,0.46100000f,1.02610002f,0.34960000f,-0.85719999f,-0.54520003f,0.04440001f,0.77610001f,0.12090001f,0.10000001f,0.03230000f,-0.44970000f,-0.35900000f,0.11690000f,0.16210002f,-0.04739998f,-0.13800000f,0.01610001f,-0.26600002f,-0.38230000f,-0.08260001f,0.19280000f,0.30729999f,0.02519998f,-0.24399998f,0.56229998f,-0.65709999f,-1.02350002f,0.33779998f,0.21790000f,0.11990000f,0.39590000f,-0.72050001f,-1.50610005f,-0.35420000f,0.66989998f,0.03990001f,-0.16080000f,0.24500000f,-0.53659999f,-0.11649999f,-0.36689999f,-0.80490001f,0.36249997f,-0.18800001f,0.63799998f,0.37699996f,0.75590000f,0.20590003f,-0.63759998f,0.00429999f,0.47630001f,-0.05160001f,0.53460000f,0.70140003f,0.23429999f,-0.50850000f,-0.32730002f,0.29749997f,0.87260001f,1.21300006f,0.52459999f,-0.40459998f,-0.59140000f,-0.47139997f,-0.13370000f,-0.16810000f,-0.61659999f,0.23680000f,-0.09270001f,-0.01239999f,0.18820001f,-0.41390001f,-0.37720001f,0.07600000f,0.71999999f,0.47259999f,-0.52929999f,-0.06949999f,-0.38460002f,-0.37320001f,-0.68030001f,-0.54160000f,0.33970001f,0.33599999f,0.31199999f,-0.19890000f,0.41729999f,0.15759998f,-0.48669999f,0.59920000f,0.25099998f,-0.56750000f,-0.47530001f,0.05000003f,0.75610001f,0.30890000f,0.23980000f,-0.20050000f,0.57179996f,0.43499996f,-0.38639998f,0.33569998f,-0.10880003f,-0.58929998f,-0.46899999f,-0.31959999f,0.18969999f,0.43110001f,0.26419999f,-0.30320001f,-1.01369998f,0.15089998f,-0.04480001f,0.52469999f,0.89310003f,0.31480000f,-0.32710001f,-0.07550002f,-0.24209999f,-0.69540000f,-1.78740005f,0.68209998f,-0.21159999f,-0.19760000f,0.40079997f,0.30319998f,1.15960001f,-0.31099998f,-0.69089999f,-1.41570003f,0.07520001f,-0.72719997f,-1.51560000f,0.09070000f,-0.35559998f,-1.11800000f,-0.55779999f,0.44800000f,1.09880003f,-0.18189999f,-0.39949998f,-0.92950001f,-0.32069996f,-0.77429999f,-1.77270001f,0.54799999f,-0.13260000f,-0.47939999f,0.13759999f,-0.49069997f,-0.28989999f,-0.09709999f,-0.18419999f,-0.70860001f,0.07120000f,-0.12160000f,-0.63420002f,-0.21160000f,0.52270000f,-0.25069998f,-0.33280000f,0.03699999f,-0.41099998f,-0.19539997f,0.44829999f,-1.19869998f,-0.87159999f,0.47949998f,0.28260000f,0.17679999f,-0.25809999f,0.92659999f,0.27559998f,-0.82219998f,-0.19270002f,0.23940001f,0.57060001f,0.04029999f,0.18200001f,0.21940001f,0.81920000f,0.58000000f,-0.31449999f,0.00460000f,0.11780000f,0.01900000f,0.40789999f,0.35000000f,-0.13999999f,-0.16940002f,0.16140000f,0.32340000f,-1.25370002f,-0.62580000f,0.82380001f,-0.14020000f,-0.10859999f,0.15930001f,-0.05189997f,0.09020002f,-0.24559998f,-0.54810000f,-0.25290003f,0.43059999f,0.52490001f,1.08850005f,0.00989999f,0.81120000f,1.64640004f,0.47739998f,-0.87879999f,-0.15200005f,-0.09020000f,-0.54269997f,-1.11629999f,0.41899997f,0.66339998f,0.16340002f,-0.65509999f,0.29379999f,0.57980002f,-0.29920000f,0.45050001f,0.62770005f,-0.28580000f,0.80589999f,0.42350004f,-0.26169998f,-0.71709999f,-1.13150003f,-0.27959999f,0.05230000f,-0.33849999f,-0.51629996f,-0.55929997f,-0.74329998f,-0.06689999f,-0.91980000f,-0.21060003f,0.10289997f,0.63399999f,1.12040004f,0.37419997f,0.05490000f,0.53879999f,0.47960000f,-0.14659999f,-0.06740001f,0.11300000f,0.11560000f,0.44370000f,0.40500001f,-0.15450000f,0.03580000f,0.00640000f,0.00200000f,0.36089999f,-0.18680003f,-0.71649999f,0.66030004f,0.05720000f,-0.80090002f,0.22590000f,0.28160001f,0.08200000f,-0.61570003f,-0.19140001f,0.47400001f,-0.37919999f,-0.11939999f,0.37499999f,-0.97350003f,-0.50940000f,0.67650002f,0.42239999f,-0.04160003f,-0.69849998f,-1.37480001f,-0.99500000f,0.61850001f,-0.07729998f,-0.41920002f,-0.46520002f,-0.90470001f,-0.48139999f,0.65540000f,-0.34849998f,-0.40780001f,-0.39779999f,0.19440000f,-0.25679999f,-0.32289998f,-0.67569999f,-1.00370003f,-0.36130000f,-0.14010000f,-0.67650003f,0.03640000f,0.28219999f,0.40300000f,0.72619999f,-0.17039999f,-0.54599998f,0.55659998f,0.08700001f,-0.45420002f,-0.31019999f,0.43169999f,0.41850002f,-0.28129997f,-0.86000001f,-0.75400005f,-0.14430000f,0.03450000f,0.40650000f,0.01389999f,-0.29310000f,0.49050002f,0.48099999f,-0.59609997f,-1.28249999f,0.55769997f,-0.58659998f,0.47500001f,0.72340000f,-0.63309996f,-0.83509999f,0.03970000f,-0.03460000f,0.82420001f,0.48689998f,0.12030000f,0.16469999f,0.35660000f,0.15520000f,-1.26550000f,-0.98140001f,0.48159999f,-0.34530001f,-0.04799999f,0.26910000f,-0.70179998f,-0.51799998f,0.45650000f,0.50520000f,0.43159999f,-0.29270002f,0.54229999f,0.47780000f,-0.12320000f,-0.09160000f,-0.27700002f,-0.28370001f,0.16050001f,0.19480002f,0.12470000f,1.15030001f,0.70800000f,-0.65880001f,0.17820001f,0.09100001f,-0.06820000f,0.22320001f,-0.20140002f,-0.50450001f,0.47099998f,0.50659999f,-0.04370000f,0.78330000f,0.27499998f,-0.68899999f,1.36890001f,1.00520000f,-0.56300000f,0.64110002f,0.23090002f,-0.54889997f,-0.18599999f,-0.49440000f,0.63890000f,-0.63199997f,0.30680002f,-0.29479999f,-0.90599999f,-1.08720005f,0.35119996f,0.71289999f,1.80650002f,-0.37839996f,-0.71490000f,-1.62210007f,-0.38149997f,0.39460000f,0.04940003f,0.42790000f,-0.61940000f,-0.82660003f,-0.18780001f,0.78840001f,1.04160005f,-0.22019999f,0.48530001f,-0.38389998f,0.01969999f,0.44070000f,0.50790002f,0.63010000f,0.13080000f,0.04200001f,-0.52509997f,0.07620000f,-0.38459999f,0.25829999f,0.28560000f,-0.29399997f,-0.57279998f,0.82710000f,-0.10049996f,-0.05470000f,-0.17750001f,-0.36669998f,-0.34599998f,0.18310000f,-0.58750002f,-0.05079998f,0.73630001f,-0.12580001f,0.11720002f,0.42070002f,-0.39570000f,0.16600003f,0.72589999f,0.27530001f,0.02580000f,-0.28170000f,0.17450000f,0.01039999f,-0.24260000f,0.70639999f,0.69500001f,-0.03050000f,1.07789999f,0.65379999f,-0.56169998f,-0.17330000f,-0.12720000f,0.03210000f,0.00060000f,-0.15780001f,-0.10140001f,0.29340000f,0.33100001f,-0.05049999f,-1.43250001f,-1.02779999f,0.63150002f,-1.03360002f,-0.44039999f,0.77940001f,0.00739999f,0.15999999f,0.14420000f,0.31369999f,-0.19999998f,0.34179997f,0.56920000f,1.26080003f,-0.48819999f,0.07959999f,0.64640000f,-0.32200001f,0.80590001f,1.33310007f,-0.72419997f,0.08099999f,0.44219999f,0.24349998f,0.36909999f,0.32390000f,0.14860000f,-0.14750000f,-0.38230001f,-0.62609997f,0.83379999f,0.54500003f,-0.16690000f,0.89729999f,0.32490004f,0.06040000f,-0.36579999f,-0.39020001f,0.33690000f,0.51509999f,0.82230002f,-0.37010000f,-0.22319999f,-0.66000000f,0.55629996f,-0.76469997f,0.25650002f,-0.20020000f,-0.65839998f,-0.03280000f,-0.31759997f,-0.17600000f,-0.30640001f,-0.49960000f,-0.27989999f,0.43810001f,0.25619999f,-0.31470001f,-0.52600004f,-0.33780001f,0.40560002f,0.58709999f,0.42599999f,-0.29909999f,-0.22410000f,-0.33540002f,-0.11010001f,0.59490003f,-0.01380003f,-0.83190003f,-0.86680003f,-0.50860001f,0.52360002f,0.34400000f,0.50720002f,0.23110000f,0.46440002f,0.02140001f,-0.52330000f,-0.73570001f,-0.52180001f,0.32590000f,-0.42310001f,-0.34080002f,0.05670000f,-0.73840001f,-0.53920001f,0.24759999f,-1.06170001f,-0.73540002f,0.45399999f,0.37750002f,0.10779999f,-0.45730001f,1.12449999f,0.85420000f,-0.48519998f,0.78770003f,0.51530006f,-0.07209999f,-0.13870000f,-0.64310001f,0.16530000f,0.57789997f,1.41230003f,-0.25139998f,0.00960000f,-0.57479999f,0.42930000f,-0.19889999f,-0.05129999f,0.61970001f,-0.16530000f,-0.77370003f,0.11629999f,-0.37189999f,0.27530002f,-0.62219998f,0.77590001f,0.80630006f,0.44749996f,0.46860000f,0.31260002f,0.27210000f,-0.42769999f,0.07670000f,0.21120000f,-0.81020001f,-0.81940005f,0.28480000f,-0.84200000f,-0.55720005f,0.34670000f,-0.85800001f,-0.26400005f,0.14370000f,-0.51009997f,-1.13690002f,-0.54370000f,0.31459999f,-0.65060000f,0.45910000f,0.31870000f,0.46799998f,0.40659998f,-0.27699999f,0.80849998f,0.31999998f,-0.60169998f,0.26859999f,0.29180000f,0.03880000f,-0.53499999f,-0.21579999f,0.39099999f,0.23280000f,0.11000000f,-0.11720000f,-0.15849999f,-0.37440001f,-0.21300001f,-0.68980003f,-0.09320000f,0.77480001f,-0.06199999f,-0.32660002f,-0.35260001f,-0.28860000f,-0.25380001f,0.00600000f,-0.52620000f,-0.23219999f,0.48119999f,-0.40770000f,-0.46440002f,-0.05220000f,-0.13110001f,-0.13440001f,-0.05970000f,-0.62470001f,-0.29219999f,0.52650000f,0.45810000f,0.46800001f,0.02550000f,0.84549998f,1.75660004f,-0.36809997f,-0.75209997f,-1.64250000f,0.21599999f,0.75179997f,0.39540002f,-0.28669999f,0.44569998f,0.40090001f,-0.13569999f,-0.51469997f,-0.28749999f,0.03779999f,0.45539999f,0.47940002f,0.58139998f,-0.01010000f,0.18950000f,-0.52259997f,-0.25160001f,0.23240000f,0.56409999f,-0.44350000f,-0.57230003f,0.18370000f,-0.60989999f,-0.64350002f,-0.05750000f,0.28649998f,0.94409999f,0.48719999f,-0.47070001f,-0.28710004f,0.10880000f,-0.54899999f,-0.70860001f,-0.04350000f,0.16629999f,0.85550000f,-0.43239999f,0.71219999f,0.61500003f,-0.42259998f,0.29510000f,-0.01960000f,0.10759999f,0.02889999f,0.74140002f,0.32760000f,-0.55770001f,-0.47320000f,-0.47440002f,-0.03110000f,0.28070000f,0.22660000f,-0.19000000f,0.53400000f,0.56520001f,-0.02070000f,-0.58620002f,-0.15100000f,0.55840000f,0.45619999f,0.59540001f,0.17830000f,-0.79740001f,-0.63460001f,0.35710000f,0.73800000f,0.64000001f,-0.23829999f,0.14959999f,0.17039999f,-0.06270000f,-0.92050001f,-0.58259999f,0.61080001f,-0.55779999f,-0.16579998f,0.55699999f,0.25700000f,0.34040001f,0.05440000f,0.70090000f,0.49660000f,-0.37479999f,-1.14850003f,-0.23770002f,-0.26919997f,-0.78889997f,-1.21930001f,0.11680000f,0.39350000f,-0.10009999f,0.42420000f,-0.83509998f,-0.79030001f,-0.18789999f,-0.48019998f,-1.02700001f,-0.56519998f,0.34709998f,-0.03210001f,-0.30769999f,-0.34050000f,0.01469999f,-0.68469997f,0.75579998f,0.66140002f,0.45669999f,0.08040000f,0.93480002f,-0.51700000f,0.14370000f,-0.53790001f,-0.20379998f,-0.37190000f,-0.73510002f,0.23909998f,0.28839999f,1.35440002f,-0.23349999f,0.01270000f,0.53750000f,-0.41139999f,0.08200000f,-0.15880000f,-0.27770000f,-0.01660000f,-0.72740000f,0.20650000f,0.18730000f,-0.60450001f,-0.01999997f,0.72620000f,0.21509999f,0.34820000f,0.15820000f,-0.67539999f,-0.37019999f,0.41249999f,-0.06619998f,0.14500003f,0.36709999f,0.18319999f,0.42660001f,0.29459999f,-0.01480001f,0.04720000f,0.04820000f,-0.57049999f,-0.33079998f,0.46369999f,0.79980002f,0.43940001f,-0.45800001f,0.24889997f,0.09259997f,-0.31909998f,0.95660004f,0.71260003f,-0.38230001f,0.29790000f,0.16339999f,-0.22910000f,-0.35510001f,-0.33780001f,0.16530000f,0.53030000f,0.57920002f,0.02050000f,-0.54280001f,-0.29080000f,0.32980000f,-0.43330003f,-0.43360001f,-0.58699999f,-0.36929999f,-0.03690001f,-0.45709997f,0.34319999f,0.27960001f,0.03130001f,-0.45560000f,-0.04600004f,-0.31870000f,0.76820000f,1.21780003f,-0.64289996f,0.37989999f,0.35030001f,-0.11599999f,-0.16460000f,-0.24940001f,0.10379999f,0.51799997f,1.35759998f,-0.03010000f,0.73469998f,0.35549999f,0.03930001f,-0.61490000f,-1.18330001f,-0.42050000f,0.57580002f,-0.07539998f,-0.02850000f,-0.11369999f,-0.46530000f,0.33370000f,0.49189997f,1.12990002f,-0.59039999f,0.48340000f,0.17900002f,0.00900000f,-0.42799999f,-0.13360001f,-0.63640000f,0.02420000f,0.19169999f,0.27720000f,-0.06060000f,-0.38059999f,-0.50200001f,-0.09020000f,-0.56820003f,-0.07060000f,0.54580001f,0.47060001f,0.07299999f,-0.51070000f,-0.60570002f,-0.07980001f,0.57810000f,-0.14360000f,0.29780003f,0.59199999f,-0.12059998f,-0.21679998f,0.02810000f,-0.20429999f,-0.36560000f,-0.14860000f,0.01130000f,-0.26620002f,-0.35540000f,0.82260001f,0.53199999f,-0.52720001f,0.24339998f,0.23419998f,-0.12110000f,-0.26350000f,-0.04179999f,0.22900000f,0.29059999f,0.49440002f,0.28410000f,-0.41730002f,-0.09259999f,0.49880001f,-0.08439999f,0.14510002f,-0.39199998f,-0.78689996f,-1.43130000f,0.60139998f,-0.20139999f,0.11140000f,-0.47309998f,-0.86850001f,-0.83010005f,0.34009999f,0.22000001f,-0.08559999f,-0.49489996f,-0.91649997f,-0.86969999f,-0.71489999f,0.43249998f,0.74049999f,0.34219996f,0.74670001f,1.29630004f,0.51579997f,-0.05310000f,0.16170000f,0.52650000f,-0.26659999f,-0.37419999f,-0.23439997f,-0.21899998f,-1.15260001f,-0.23729997f,-0.40899998f,-0.88579999f,-0.20569999f,-0.49519997f,-0.52599999f,-0.65179999f,0.75189997f,0.81830001f,-0.22270000f,0.31980000f,0.87540003f,0.38879998f,-0.41289999f,1.00270001f,0.60220000f,-0.56230000f,0.19430000f,0.01740000f,-0.16560000f,0.61069999f,0.63560000f,-0.03380000f,-0.74829996f,-0.64999998f,0.24979998f,-0.74090001f,-0.39220000f,0.46330000f,-0.64539998f,-0.08779996f,0.78529999f,-0.18490000f,-0.11080000f,0.09280000f,0.41900002f,0.21779999f,-0.42090002f,0.73890001f,0.55920000f,-0.44760000f,-0.55330001f,-0.15420000f,0.48839999f,-0.18680001f,-0.25340001f,-0.12400000f,-0.39120003f,0.13340001f,0.73210001f,0.03360001f,-0.23020000f,-0.23780000f,0.64459999f,0.34039999f,-0.37399999f,-0.07320001f,-0.35609999f,-0.42090003f,-0.16889999f,0.11570001f,-0.47820000f,-0.30660000f,0.07280001f,0.61990000f,0.34829997f,0.36020000f,0.14850001f,-0.92089996f,-0.60600000f,-0.08779998f,0.42560000f,0.37200001f,-1.38250002f,-0.19409997f,-0.16390000f,0.32559999f,-0.34440001f,0.07400000f,1.17510001f,-0.38870003f,-0.00710001f,0.40990000f,0.11089997f,0.22349999f,0.03210000f,-0.05950000f,-0.00420000f,-0.48059999f,-0.74759996f,-0.37129999f,0.52550001f,-1.20309995f,-0.67689999f,-0.38749999f,-0.27669998f,-0.21239999f,1.01440001f,-0.62140002f,-0.20520000f,0.97779999f,-0.53520002f,-0.30460000f,0.30160000f,0.18730000f,-0.43500002f,-0.58760002f,0.26609997f,-0.13420000f,-0.35919999f,0.09849999f,-0.02139999f,0.58340001f,0.00810000f,0.02480001f,-0.20180000f,0.28839996f,-0.48339999f,0.75899999f,1.15469999f,-0.24859999f,0.10679999f,-0.19150000f,0.71500001f,-0.78880002f,-1.70050000f,-0.32340000f,-0.65140000f,0.21909996f,0.55580001f,-0.74079999f,-0.78890003f,0.45180000f,0.11060002f,-0.25289999f,0.26939999f,-0.73400001f,-0.63930001f,-0.19100000f,0.29660001f,0.83290000f,0.11239999f,-0.71659998f,-0.12500000f,0.47120000f,-0.28550001f,0.07009998f,-0.21530000f,0.09100001f,0.21789999f,-1.03710000f,-0.56660001f,0.10980000f,-0.44599998f,-0.29889999f,-0.06780003f,0.38720000f,0.39180001f,0.41629998f,-0.08329999f,-0.17240000f,1.21119998f,-0.06700003f,0.21279999f,-0.38140002f,-0.30519999f,0.02850001f,-1.82090000f,0.33890002f,-0.08740001f,0.21529999f,-0.92289997f,-0.57109999f,-0.69630000f,0.21790004f,-0.23200000f,-0.13659999f,0.72119999f,0.24320000f,-0.63289999f,-0.18510000f,-0.33200001f,0.97660001f,0.00359999f,0.02760000f,-0.02859997f,-0.35899997f,-0.43970000f,-0.37439999f,-0.19069998f,0.52179999f,-0.47720000f,-1.12789998f,0.36220001f,0.38259998f,0.07429998f,-0.60080003f,-0.40260002f,0.09359999f,0.27060001f,-0.30240000f,-0.52150001f,-0.60880001f,-0.52740000f,0.58320000f,0.48620002f,-0.13080001f,-0.58970002f,-0.11720001f,-0.51080002f,-0.21820002f,0.34020002f,-0.28180001f,0.07649996f,-0.22700001f,-0.44020001f,-0.16790001f,0.53960003f,-0.19740000f,-1.11740002f,-0.71040001f,-0.08820000f,0.55560000f,0.21360000f,-0.62140001f,-0.35000003f,-0.14760000f,-0.29120000f,0.50579998f,0.20440000f,-0.53560001f,-0.08580001f,0.63480002f,0.40740001f,-1.19099997f,0.32760000f,-0.01270001f,0.22199998f,0.81259997f,0.35619999f,-0.10900001f,-1.16300001f,-0.46330001f,-0.52740000f,0.13600002f,-0.05330000f,0.54880003f,-1.22199997f,-0.62150000f,-0.53720001f,0.56980002f,0.13650000f,-0.28290001f,-0.55690000f,-0.35210001f,0.29269999f,0.30450002f,-0.10510000f,-0.27590000f,-0.66329999f,-0.34290000f,-1.20170003f,0.55510004f,0.18240001f,0.41340000f,-1.05899999f,-0.34649999f,-0.28990000f,-0.16149999f,-0.31280001f,0.63370001f,-0.38189999f,-0.31490000f,0.04480002f,-0.09080000f,-0.29480002f,-0.25140000f,0.66719999f,-0.94860004f,-0.19220002f,1.14610000f,-0.31559999f,0.47519998f,0.25460001f,0.06840000f,-0.13300000f,0.35180000f,-0.58200002f,-0.28040002f,-0.11500000f,-0.55340003f,-0.13860000f,0.74090001f,0.67860001f,-0.28919999f,-0.54070001f,-0.28120001f,0.79700002f,0.66140004f,0.36160001f,-0.45440001f,-0.73400001f,0.39820002f,0.30800002f,0.32230000f,0.16360000f,0.17020000f,-0.38179997f,-0.06880000f,0.55340001f,0.16520003f,-0.16560000f,-0.38259999f,-0.51360000f,0.08200000f,-0.04799999f,-0.68379999f,0.42020001f,0.24400003f,0.27849999f,0.78300001f,0.42450001f,1.09480001f,-1.43260003f,-0.57180002f,0.13349999f,-0.10130001f,0.19689999f,0.51230002f,0.03550000f,-0.12180001f,-0.39020001f,-1.06580000f,-0.34420000f,0.73730003f,-0.84850001f,-0.36210000f,-0.36419999f,0.74320000f,0.07690000f,0.64920001f,0.21479998f,0.36850001f,-0.74790000f,0.14250002f,-0.10030000f,0.57520001f,0.83340000f,0.27990001f,-0.44819999f,0.32939999f,0.21890000f,0.12120000f,0.30959999f,0.33490001f,-0.71080001f,-0.56159996f,-0.23589998f,-0.85960001f,0.02720002f,0.08940001f,0.53510000f,0.81610000f,0.24880001f,-1.27010000f,0.35149999f,-0.64700000f,-0.28740000f,0.83969997f,-0.30800001f,-0.19339999f,-0.01119999f,-0.86620001f,0.06659999f,1.33010000f,-0.28000000f,0.67060000f,0.25480003f,-0.51760000f,0.57080000f,0.69560001f,-0.25940000f,0.30260000f,0.70269999f,0.41700001f,-0.74799999f,-0.76950000f,-0.70560000f,0.06340001f,0.15080001f,0.79760002f,0.23940001f,-0.55240000f,0.15240000f,-0.01080000f,-0.51860000f,0.00060000f,-0.31980000f,0.13029999f,0.04860000f,-0.35240000f,-0.90170000f,-0.48640001f,-0.33720001f,0.48359997f,0.29000000f,0.37619999f,0.09700000f,0.46360002f,-0.02350000f,0.84169999f,-1.08409996f,-0.50529999f,-0.13559999f,-0.59199999f,-0.22009999f,1.34590002f,-1.11030000f,-0.39730001f,0.12740000f,0.09099999f,0.34090001f,0.61079998f,-0.29160001f,0.14020000f,0.77199999f,-0.10380001f,0.03060000f,-0.73449998f,0.01050004f,-0.27999999f,-0.13700001f,-0.97819996f,-0.18309998f,-0.38630000f,1.29570000f,0.47480000f,-0.61290001f,0.17150001f,0.11150001f,0.21000001f,-0.21699998f,-0.23740000f,-1.12730002f,-0.25869997f,-0.09719999f,0.45189999f,-0.91449998f,-0.44150000f,0.21910000f,0.70389996f,0.32759999f,-0.22940000f,-0.33430001f,0.30760001f,-0.12700000f,-0.73300000f,-0.00200000f,-0.40740001f,-0.05580001f,-0.68460000f,0.73320001f,1.61770001f,-0.43740001f,-0.55520001f,0.15129998f,0.40280001f,-0.75760001f,-1.10700001f,-0.34840000f,0.58660000f,1.20899999f,-0.65479999f,0.31759999f,1.32099996f,-0.65420000f,0.31919999f,1.06169998f,0.87440002f,0.11280001f,-1.02080000f,-0.28780000f,0.40140001f,0.82049999f,-0.55619999f,0.73739997f,1.56029996f,-0.63560000f,-0.24760002f,0.49059997f,0.08000000f,-0.25379999f,0.09279997f,-0.34540001f,0.34840000f,0.68450001f,0.51800000f,-0.39270000f,-0.81020001f,0.29780002f,0.10790001f,-0.02679999f,-0.29959999f,-0.27130001f,1.73220001f,-0.34120002f,0.07010000f,0.06129999f,-1.02729998f,-0.52860000f,-1.18589999f,-0.04629996f,-0.24210000f,1.36610000f,0.01249997f,0.12620000f,1.40289997f,-0.62070000f,-0.16290000f,1.06039998f,-0.64100000f,-0.12430000f,-0.95450001f,1.27750000f,0.47790001f,0.90279999f,-0.06460001f,0.07300000f,1.71569997f,-0.15450003f,0.11849998f,0.38109998f,-1.06889998f,-0.42450000f,0.18969999f,-0.05629999f,-0.16379999f,0.70250000f,-0.19890003f,0.03959999f,-0.26679999f,0.01530000f,0.41120001f,-0.01100000f,0.00559999f,0.14559999f,-0.60420001f,-0.92280001f,0.63300000f,-0.40320000f,-1.42029999f,0.27999999f,-0.83519998f,-0.22440001f,-0.37959999f,0.34300000f,0.96219997f,-0.69159999f,-0.00360001f,0.15580000f,0.65460002f,0.37640000f,-0.52989999f,0.32760001f,0.17020000f,-0.49020001f,-0.13319999f,0.49220000f,-0.09779999f,-0.13500000f,0.37660001f,0.88770000f,-0.12439999f,0.43540000f,0.38140000f,0.21260001f,0.46099999f,0.52389997f,0.62940002f,-0.40440000f,-0.20730003f,0.29980002f,-0.29840000f,-0.92290000f,0.05360000f,0.10960000f,0.20030001f,0.59669999f,0.11099999f,-1.08040002f,-0.29839999f,-0.23830000f,-1.53420000f,0.51880001f,0.11230000f,-0.06789996f,-0.20629998f,-0.45790000f,1.05409997f,-0.22910000f,-0.01399999f,-0.11600001f,-1.00519997f,-0.22559999f,-0.43930000f,1.18569999f,0.52380000f,-0.51500003f,0.56100000f,0.28210000f,-0.24910002f,0.14850000f,0.31220001f,1.06570001f,0.14789998f,0.09070000f,0.39479999f,0.16199999f,0.20690000f,0.73709996f,0.68769997f,0.30169999f,0.06690001f,0.61710002f,-0.06420000f,-1.04460001f,0.14720004f,0.01570001f,-0.96340002f,0.11089996f,-0.09719999f,0.57120000f,0.35300001f,-0.02699999f,0.38020001f,0.76409999f,-0.18020000f,0.56420002f,0.65670002f,0.06400000f,-0.07320000f,-0.30639999f,-0.77600000f,-0.37360003f,0.55479996f,-0.80080003f,-0.13159999f,0.56720002f,0.18480000f,0.28140000f,-0.27039999f,0.29340001f,0.09679999f,0.40549999f,0.38940000f,-0.08819999f,-0.43649999f,0.61820003f,-0.46100000f,-0.67530004f,-0.84759999f,-0.04460001f,1.14819995f,0.48380002f,-1.05880000f,-0.76930005f,-0.62480002f,-0.50100002f,0.65279995f,0.65380001f,-0.50280000f,-0.91750001f,-0.26860000f,-0.59530000f,0.35399999f,0.29679999f,0.31180000f,0.95230000f,0.29849999f,0.14230000f,0.71740002f,0.19599999f,0.23920001f,-0.36639999f,0.01520000f,0.01260000f,0.41529997f,-1.35989998f,-0.56070000f,0.39170002f,-1.22190000f,-0.40409999f,-0.30420000f,0.44979999f,0.28510000f,0.66110002f,0.53529998f,0.09299999f,-0.38489999f,0.47129999f,0.11550000f,-0.55000001f,0.51980003f,-0.03880000f,1.12729996f,-1.17829997f,-0.44179999f,-0.66660001f,-0.11399994f,-0.47329999f,0.63019997f,-1.22060000f,-0.61810001f,-0.84850000f,0.52130002f,-0.02220000f,0.39269999f,-0.30910003f,0.12620000f,0.58240000f,0.42590000f,0.33380000f,-1.05840002f,-0.60230006f,0.07640001f,0.26080002f,0.74820000f,0.61280000f,-0.81779999f,-1.62479999f,-0.44720003f,0.73700000f,1.42040003f,-0.02940000f,0.51559998f,0.11290000f,-0.43260001f,-0.26680001f,0.63489999f,0.30480001f,0.06720000f,-0.77840000f,-0.55360001f,0.68299999f,0.63880002f,0.02860000f,-0.01900000f,-0.34730000f,-0.49300002f,-0.43280002f,0.04789999f,-0.01700000f,0.66679999f,0.43070000f,-0.63780000f,0.13679999f,0.47029999f,-0.37400001f,1.01539999f,0.47180002f,-0.52940002f,-0.26900001f,0.55309999f,0.63929996f,0.37379999f,-0.51590002f,-0.31969998f,-0.54060001f,0.99350002f,0.36350000f,0.09290000f,-1.76509999f,0.17450004f,-0.14779999f,1.58170003f,-0.00670007f,0.16999998f,0.07489998f,0.33589996f,0.32799999f,0.66860001f,-0.77200000f,-0.39950001f,-0.89430002f,0.42890001f,0.24650001f,0.50579998f,-0.26900003f,0.21470000f,-0.44330001f,-0.00149999f,0.04530000f,-0.11560001f,-1.03020001f,-0.44610001f,0.48279999f,0.48979996f,0.38929999f,0.30809998f,-0.79849999f,-0.15920000f,0.32979997f,0.21859995f,0.51830000f,0.89230002f,0.33270001f,0.30480000f,-0.60159999f,-1.09520000f,0.77120002f,0.07680001f,-0.69559999f,0.61040003f,0.02340000f,-1.09640002f,0.76560000f,0.37320002f,-0.48319997f,-0.20740000f,-0.13740000f,-0.16809999f,-0.28080001f,0.00140000f,0.35680000f,0.16660000f,0.70839999f,-0.23509997f,-0.36499999f,0.51019999f,0.05950001f,-0.05000000f,-0.06120000f,0.25779999f,0.00539999f,-0.39180002f,-0.64050000f,-0.09339999f,0.51040001f,0.59890000f,0.45740003f,-1.04899999f,-0.61410007f,0.64520003f,-0.23519999f,-0.28540004f,0.11280000f,0.30559999f,0.23640000f,0.28040001f,0.34569999f,-1.23430000f,-0.07749996f,-0.16549999f,-0.56869999f,1.12810000f,0.37650000f,-1.16690004f,0.81910003f,0.35100001f,-0.32549998f,1.35049996f,0.54710000f,-0.30259999f,-0.41759998f,-0.12999999f,0.34040000f,-0.38080000f,-0.13190000f,-0.31620001f,0.73199996f,0.56689999f,-0.15140003f,-0.16560000f,0.23460000f,0.32450000f,-0.09510000f,-0.09350000f,-0.79770000f,-0.32790000f,-0.17430001f,0.68779999f,0.28000000f,0.23590001f,-0.47500002f,-0.13239992f,-0.49659998f,-0.04880001f,0.75480003f,0.06740001f,0.32900000f,0.40499997f,0.20779999f,-0.34609997f,-0.15910000f,-0.34740001f,0.32140000f,0.63550001f,0.53500002f,-0.54140003f,-1.26610001f,-0.29520000f,0.51599999f,0.62160000f,-0.16380001f,-0.43020002f,-0.01590003f,-0.88940004f,-0.16300002f,0.80130001f,0.44420003f,-0.47220001f,-0.47150004f,0.41800001f,0.52660000f,-0.54859999f,-0.43340000f,-0.22839999f,-0.09829999f,0.22900001f,-0.51980001f,-0.27230003f,-0.12680000f,-0.22040000f,0.52580000f,0.05759999f,-0.44080000f,0.22719999f,0.26139999f,-0.65920001f,-0.09850001f,-0.57820002f,0.19220000f,1.01209999f,-0.40979999f,0.97480001f,0.83390002f,-0.74820003f,0.39160000f,0.64000000f,-0.22540002f,0.02760000f,-1.35990001f,0.28910002f,-0.03290001f,0.62309998f,-0.01050002f,0.17790000f,-0.04680001f,-0.55020000f,-0.33960001f,0.66340001f,-1.35440004f,-0.48500002f,-0.36050002f,0.27370004f,-0.12630000f,-0.59190003f,0.94409997f,0.56060000f,-0.30500000f,-0.80879997f,-0.26789998f,-0.19200001f,-0.05939998f,-0.25000000f,0.66150003f,-0.29890000f,-0.26330001f,0.37880002f,-0.21160000f,-0.31760001f,0.06910003f,-0.09670000f,-0.36100001f,1.04520000f,-0.62460002f,-0.18200000f,0.79629999f,0.16810000f,0.42800001f,0.22070001f,-1.51439999f,-0.43979999f,0.71700000f,1.42569997f,-0.44519999f,0.08279998f,-0.06699999f,0.14380000f,0.28140000f,-0.24329998f,0.28340000f,-0.05699999f,0.06489998f,-0.01800000f,-0.00840000f,-0.30819999f,-0.22880001f,-0.56300001f,-0.18280001f,0.73720002f,0.12399999f,-0.40020001f,-0.46580002f,-0.40260001f,0.44630000f,-0.13300000f,-0.17060000f,0.42629998f,0.55100000f,-0.29299999f,-0.90209998f,-0.16680001f,-0.51540000f,0.11699999f,-0.18440000f,-0.03880000f,0.52259998f,0.56980001f,-0.33020000f,-0.86109999f,0.19240000f,0.44360000f,-0.35939998f,-0.56959999f,-0.10249999f,1.59449997f,-0.00970002f,0.15770000f,-0.30570001f,-0.60049999f,-0.06290000f,-0.28750000f,0.39189998f,0.26930000f,0.22449999f,0.38109999f,0.03390000f,-0.41460000f,-0.05899999f,0.03340000f,-0.28200000f,-0.75519998f,-0.42530000f,-0.19980000f,1.13739999f,0.35639999f,0.41990002f,-0.93430000f,-0.47490001f,0.52130000f,-0.28089999f,-0.21670000f,-0.90069997f,0.52190000f,0.08930000f,0.13740002f,-0.60419998f,-0.41790000f,0.60909999f,-0.25370000f,-0.15530000f,-0.83339998f,0.52640001f,0.06340000f,-0.43730001f,0.56949998f,0.41110000f,1.53919998f,-0.05040002f,-0.14080001f,0.38579999f,0.94959998f,-0.47840001f,0.20820000f,0.30160001f,-0.22520000f,-0.41780001f,0.49299996f,-0.29500000f,0.40920001f,0.88889999f,0.06720000f,0.67380001f,0.17040004f,0.49460001f,0.02020000f,-0.19270001f,0.36140000f,0.64200000f,-0.40249997f,0.36980000f,-0.81680002f,-0.96310003f,-0.19879999f,0.78620002f,0.63100003f,-0.14200000f,0.32939999f,0.61940000f,0.67660001f,-0.74720000f,-1.33570001f,0.57020000f,-0.10379999f,-0.59489999f,0.08120001f,0.45840001f,0.19180001f,-0.37700000f,0.60360001f,0.77510001f,0.47700002f,-0.35820000f,1.14369998f,0.15129996f,0.08639999f,0.15109999f,-0.52770001f,-0.03980000f,0.59549999f,-0.58769999f,-0.42220000f,0.98889999f,-0.06370001f,0.06640000f,0.17730001f,0.59609997f,0.45600000f,-0.02650000f,0.72449999f,0.18510000f,-0.43880000f,0.95619996f,0.60209999f,-1.00420001f,-0.12479998f,-0.31290001f,0.64870001f,0.32549999f,0.38940001f,0.71350000f,0.08069997f,0.09499999f,-1.36169999f,0.34370004f,-0.12260000f,-0.50809999f,0.71209999f,0.18010000f,0.23740000f,0.46419999f,0.30960000f,0.77749999f,-0.05470001f,0.19200001f,-0.21100002f,0.11739996f,0.66320002f,0.24820003f,-0.16400000f,0.24500000f,0.41679999f,-0.16749999f,0.31499999f,-0.28239999f,-0.16329999f,0.54779999f,0.06040001f,-0.98769997f,0.39460000f,0.54579999f,-0.23709998f,0.01440000f,0.12440000f,0.18960000f,0.58159999f,-0.50079999f,-1.23759996f,-0.29900002f,0.28580000f,-0.04389995f,-0.45979998f,0.23379999f,1.00809997f,-0.25020001f,0.72680002f,0.33330004f,-0.25620000f,0.20580000f,0.45469999f,0.26980000f,-0.57180003f,-0.98870000f,0.13960001f,0.66280002f,0.00220002f,0.23800001f,-0.20000000f,-0.05540002f,0.76040003f,-0.45249999f,0.06320001f,1.13800000f,0.38590001f,-0.15610001f,0.64409996f,0.38039999f,-0.03579997f,0.24639999f,-0.07830001f,-1.05680000f,0.76299999f,0.34250000f,-0.19350001f,0.95029995f,0.52209999f,0.24260001f,0.12659999f,0.06200000f,-1.30529996f,0.38910000f,0.00430000f,-0.23089997f,-0.23830002f,0.11510000f,1.09019998f,-0.42119999f,-0.11860000f,0.23840000f,0.18179998f,0.37670001f,0.45719999f,-0.18980000f,0.00100000f,-1.11340000f,-0.09840000f,-0.17060001f,-0.00990001f,0.68009999f,0.49370001f,0.06120000f,0.20160001f,-0.05980000f,-0.44720000f,-0.02879999f,-0.22839999f,0.59860001f,1.17659997f,-0.14760001f,-0.65480000f,-0.18660002f,0.36780002f,0.28260001f,0.47510000f,-0.47380001f,-0.08160000f,0.21510000f,0.39020002f,0.29139999f,0.49469996f,0.70820000f,0.42140002f,-0.64349996f,0.18760001f,-0.51099999f,-1.05020000f,-0.17200000f,-0.52339999f,-0.17600001f,-0.42860001f,-0.37160002f,0.31089997f,-0.57680002f,0.67639999f,1.14760001f,-0.20860000f,0.41479998f,0.76529997f,0.12540001f,0.14000000f,0.33189997f,0.46680001f,0.52820000f,-0.57459996f,0.57940002f,-0.10600000f,-0.81950001f,-0.16640000f,0.30910001f,1.37779997f,0.19459999f,0.17390000f,-0.23840000f,-0.70199997f,-0.46400000f,0.76590003f,0.78369999f,0.23170000f,0.07299999f,-0.73599999f,-0.22430000f,0.80119997f,0.82459997f,0.24139999f,-0.56969997f,1.28689998f,0.58650000f,-1.24010001f,-0.18089995f,-0.14399998f,-0.25119999f,-0.64279996f,-0.38269999f,0.25469998f,-0.86909999f,-0.42340001f,1.16799999f,-0.26400005f,0.13019999f,0.86519997f,0.05659997f,0.11309999f,0.48049998f,0.31310000f,0.08440000f,-0.60369999f,1.01469998f,0.57960000f,-0.80030002f,0.70470001f,0.21360000f,-0.17819999f,1.57179997f,-0.42860000f,0.52140000f,0.32210002f,-0.06260001f,-0.15680000f,-0.39489997f,0.06920001f,0.74939999f,0.17740001f,0.22359998f,-0.81499998f,-0.71579999f,0.34980000f,-0.27860000f,-0.13830000f,0.84060000f,0.01040002f,-0.86849998f,0.05160000f,-0.07660000f,0.03100000f,-0.58580003f,0.41560000f,1.32710000f,-0.58560000f,0.85380001f,1.57079999f,0.38980000f,0.04360000f,0.02330000f,-0.25900000f,-0.20980000f,0.48889999f,0.84260002f,0.23439999f,-0.87790000f,-0.15180000f,-0.50220000f,-0.52630000f,-0.23080000f,0.18959999f,-0.12259999f,0.25220001f,-0.40920000f,-0.75520003f,-0.41820000f,-0.62300001f,-0.92980002f,-0.41279999f,-0.76460000f,0.46599999f,-0.33719999f,0.49120001f,-0.25289998f,0.79999997f,-0.20230001f,-0.03489998f,-0.54799998f,-0.01309996f,-1.17900002f,-0.20459999f,-1.14560002f,-0.31340001f,-0.17999999f,-0.15619999f,0.45370000f,0.21860000f,0.56410001f,0.16489999f,-0.24499998f,0.21970000f,-0.04920000f,-0.00680000f,-0.02960000f,-0.88489999f,0.23579999f,-0.76810000f,-0.22349997f,0.93339997f,-0.11110000f,-0.39159999f,0.16239999f,-0.37880000f,0.29090001f,0.44319999f,0.39790000f,0.33790002f,0.24610001f,-0.11860000f,-0.27289999f,0.11030001f,0.13900002f,-0.41649999f,-0.28530000f,0.08880000f,-0.14430000f,-0.18160000f,-0.17580000f,-0.00049998f,0.25790003f,-0.08199999f,-0.18559998f,-0.38199999f,-0.68299999f,-0.99869998f,-0.53770000f,0.11000001f,0.00370002f,0.36460002f,0.90580000f,1.48129998f,0.93369999f,0.15800001f,-0.32969998f,-0.32639999f,0.48780000f,0.79170000f,0.15110000f,-0.00460001f,0.40329999f,0.05549999f,0.47260001f,0.54529999f,0.15989999f,-0.44900000f,-0.64650000f,-0.58070001f,0.25339999f,0.12159998f,-0.25030002f,0.18419999f,-0.56540003f,-0.37330001f,-0.23800000f,-0.24950000f,-0.41370002f,0.69959999f,-0.30190004f,-0.08289999f,0.40939998f,-0.06210000f,-0.10050003f,-0.59480000f,-0.05510000f,0.48680000f,0.41839998f,0.42279998f,0.60330001f,-0.04879999f,0.69750001f,-0.78170002f,-0.29900000f,-0.64130001f,-0.92150001f,-0.26359998f,-1.04050001f,-0.25150000f,0.75459996f,-0.18510003f,0.06290002f,0.30799998f,-0.11250001f,0.52290001f,-0.19920000f,0.37150001f,-0.29310000f,0.34800000f,-0.36610002f,0.77870002f,0.25440000f,0.76290002f,0.12980004f,0.66619998f,0.05320001f,0.29120001f,0.40150002f,0.57719999f,1.00809997f,0.61419998f,-0.22499999f,0.14610002f,-0.09709999f,0.19940002f,-0.38100000f,0.05110001f,0.28560000f,0.47890000f,0.23280000f,0.00460000f,-0.71580000f,-0.47590002f,0.22240000f,0.63950001f,0.26000000f,0.28260002f,0.07200000f,0.05170000f,-0.02079999f,0.11530002f,-0.37740001f,0.25960001f,-0.01590000f,0.09160000f,0.48400001f,1.01780002f,0.71660002f,-0.09420000f,-0.73739999f,-0.20370000f,0.31160001f,0.32640000f,-0.04320000f,-0.12380000f,-0.42160000f,-0.54150001f,0.16120000f,0.14739999f,-0.25820002f,0.23160000f,-0.21870000f,-0.52210000f,-0.21179998f,-0.61850000f,0.78129999f,-0.26119998f,0.63989999f,-1.01280004f,0.35180000f,-0.79380004f,-0.17330000f,-0.00820000f,-0.23570000f,-0.31199996f,0.82899999f,-0.16619999f,0.13730001f,-0.18699999f,0.00290001f,-0.48500002f,0.34060000f,-0.43680003f,0.81990003f,0.41459999f,0.64510000f,-0.63970001f,0.28140000f,-0.54690002f,-0.50500001f,-0.48640000f,-0.59260001f,-0.60600000f,0.33899999f,-0.38460001f,-0.00280000f,0.42879999f,-0.08520002f,0.46620002f,0.62939999f,0.44000000f,0.34740003f,0.52880001f,0.23740000f,0.66500003f,-0.17109998f,-0.29659999f,-1.25690001f,-0.69810001f,-0.20099999f,-0.31879999f,0.12630000f,-0.14200000f,-0.20380001f,-0.43680002f,0.25840001f,-0.22860000f,0.29760001f,-0.19960001f,-0.78230002f,-0.48920002f,0.20759999f,0.70089999f,0.04139999f,-0.49980002f,-0.56440001f,-0.14770000f,0.41460001f,0.66340000f,0.32530000f,-0.32840001f,-0.00330000f,-0.39020001f,0.09779999f,0.34359999f,0.35949999f,-0.23220001f,-0.13060000f,0.11690000f,0.39500000f,0.24820000f,0.42090001f,0.32480000f,0.49780000f,0.60160001f,-0.29260001f,0.03550000f,-0.38710000f,0.52299999f,0.49540002f,-0.22090002f,0.81880000f,0.01329997f,-0.31940000f,-0.36939997f,-0.18919998f,0.65620003f,0.40280000f,0.56900001f,-1.28900004f,0.08120000f,-1.04100003f,-0.02209999f,0.55659999f,0.10270000f,0.60910002f,0.05060000f,0.37510001f,0.29380000f,-0.39900000f,0.37280003f,-0.27880000f,0.01380000f,-0.36020001f,1.21730004f,0.00059999f,1.02090003f,-0.24220000f,-0.41339998f,-0.24799998f,0.03400000f,-0.46139999f,0.07580002f,-1.02000001f,-0.01260002f,-0.90140001f,-0.81140002f,-0.42440000f,-0.75380000f,1.20590002f,0.03919998f,1.00210001f,-0.21870000f,-0.06039999f,-0.18279999f,-0.90029997f,-0.60080000f,0.12660000f,-0.15540001f,0.08950000f,-0.47960000f,-1.33069999f,-0.80800001f,-0.26740001f,-0.29540000f,0.19250000f,-0.39960000f,-0.71439998f,-0.15459999f,-0.37460000f,-0.59429998f,-0.41510000f,0.50899999f,0.70749999f,0.20249998f,0.05260000f,-0.46019998f,0.25410002f,0.02919999f,0.78400000f,0.22040000f,0.22020000f,0.42440000f,0.41970001f,0.03420000f,-0.09550000f,-0.26670001f,0.52780000f,0.61810000f,0.69870002f,-0.03019999f,-0.58139998f,-0.36069999f,-0.21920000f,0.09380000f,-0.08380000f,-0.09200001f,-0.13430000f,-0.04889997f,0.75979997f,0.09270000f,-0.60560001f,0.12459999f,-0.48420000f,0.17590003f,0.70379999f,0.36550001f,-0.27160000f,-0.56139998f,-0.14419997f,-0.10040001f,-0.19320000f,0.06080001f,0.45530001f,0.14039999f,0.48750000f,-0.18449997f,0.29999998f,-0.30349999f,-1.19480001f,-0.10540001f,-0.90899999f,0.76600001f,-0.47279999f,0.51640002f,-0.43900002f,-0.32900000f,-0.43240001f,0.22610002f,0.42039998f,0.18710000f,-1.15390003f,-0.27680001f,-1.07090002f,-0.23400000f,0.58899998f,-0.11460002f,0.67099999f,-0.25359998f,0.55700000f,0.44260001f,-0.05500001f,0.32620000f,0.64400000f,0.49570001f,0.15020000f,0.02520000f,-0.12230001f,-0.85560001f,-1.41189999f,-0.89340000f,0.18460001f,-0.34009999f,-0.15810000f,0.67620000f,0.92560000f,0.53449999f,-0.68440000f,-0.97059999f,-0.73720000f,-0.59419998f,-1.20959996f,-0.80149998f,-0.47079999f,-1.03589997f,-0.54859999f,0.27579999f,1.13300000f,0.58070001f,-0.45500000f,-0.68489998f,-0.47169999f,-0.85559998f,-1.30769995f,-0.90359999f,-0.03019998f,-0.65999997f,-0.24949999f,0.01600001f,-0.02799999f,-0.24339999f,-0.36220000f,-0.62490000f,-0.33190000f,0.24260000f,-0.17610000f,-0.42380000f,-0.33140000f,-0.46120000f,-0.03539999f,0.37580000f,-0.05280000f,0.86990003f,0.26739999f,0.98390003f,-0.58690001f,0.58359998f,-0.45590003f,-0.69539998f,0.06460000f,-0.76160000f,0.97020001f,0.19480000f,0.98780001f,0.55340000f,0.48539998f,0.66959999f,0.18269999f,0.29779999f,0.33509999f,0.26239999f,-0.66339999f,0.03740001f,0.55590000f,0.11799999f,0.59010000f,1.04250000f,0.24900001f,1.10970000f,-0.53140000f,0.47099999f,-0.34320001f,0.32239999f,0.34279997f,0.25879998f,0.25269999f,0.06240000f,0.32730000f,0.47500000f,0.10250001f,-0.08320000f,0.20640000f,-0.22780001f,0.59420001f,0.67500000f,0.55810001f,0.67200000f,1.26249998f,0.87240001f,0.30259999f,0.27059997f,-0.29390002f,-0.48639999f,-0.82819997f,-0.58659998f,0.06760000f,-0.45819998f,0.21260001f,0.00619999f,0.69950000f,0.33390000f,0.11620001f,0.50000001f,0.37830002f,-0.07480000f,0.01060001f,0.38040001f,-0.51080000f,-0.65230000f,-0.62880000f,-0.28860000f,-0.30679999f,-0.11569999f,-0.43319998f,-0.22889997f,-0.42159998f,0.09300000f,0.44970000f,-0.30750001f,0.47040000f,0.76230001f,0.61000001f,0.50780000f,-0.09150001f,0.82720002f,0.10200001f,0.64920001f,-0.96120004f,-0.01420000f,-0.93300004f,-0.72890003f,-0.47380000f,-0.82730002f,0.33480003f,0.75139998f,0.19260000f,0.58340000f,0.25999998f,0.63339999f,-1.15179999f,-0.03040000f,-0.87699999f,0.49750001f,-0.62679998f,0.31490002f,-0.07140002f,-0.45660000f,-0.13240001f,-0.46380002f,-0.60119999f,-0.36139999f,0.95910001f,0.22379999f,0.91670001f,0.24740000f,-0.19739999f,0.27520001f,1.11889998f,-0.05020000f,0.98369998f,1.00290004f,0.39719999f,0.73590001f,-0.69110000f,-0.29420000f,-0.70950000f,-0.96960003f,-0.38320000f,-0.32160000f,-0.27019999f,-0.04319999f,-0.47480000f,-0.51429999f,-0.56400000f,-0.44780002f,-0.51590000f,-0.29810000f,0.15560000f,0.23559999f,0.23260000f,0.00580003f,-0.77819996f,-0.29269998f,-0.06820001f,-0.79260002f,-0.18610000f,0.00660000f,0.28300000f,0.28830000f,-0.28300000f,-0.11830000f,-0.50790002f,0.15599999f,0.48869999f,0.18060000f,0.33620001f,0.75530002f,0.12950000f,-0.36279998f,-1.20259995f,-0.68919998f,0.58920001f,0.73310002f,0.03140000f,-0.03339998f,-0.76979998f,-0.52369998f,0.45740000f,0.93430000f,0.32829999f,0.02340001f,-0.01850002f,0.24460000f,-0.35079999f,0.27340001f,0.99630002f,0.15419999f,0.92510001f,0.51570002f,-0.14320000f,0.53710003f,-0.30320000f,-0.13159999f,-0.29240000f,-0.70360002f,0.61619998f,-0.47220003f,-0.76400001f,0.37259999f,-0.50820001f,-0.05360001f,-0.44259998f,-0.07700000f,1.15330003f,0.25400001f,0.97670002f,0.15930000f,-0.14100000f,0.04770000f,0.31650002f,0.11679999f,0.11630000f,-0.03460000f,0.69079997f,0.16539998f,-0.01429998f,0.63179996f,-0.18190002f,-0.24720003f,0.84859997f,-0.10260005f,0.04510001f,-0.00680000f,-0.13910001f,0.02390000f,0.04390000f,-0.40540000f,-0.20429999f,-0.22750000f,0.53980002f,0.54470001f,-0.05169999f,-0.45220001f,-0.45400000f,-0.65530001f,0.89919999f,1.37759998f,0.90139999f,-0.81080001f,-1.15840002f,-0.82520002f,-0.20379999f,-0.07649999f,0.13050001f,-0.13479999f,-0.65310000f,-0.50580001f,0.28980000f,0.67820001f,0.62610002f,-0.39900000f,-0.69179999f,-0.03129998f,0.16600000f,0.24630000f,0.31480001f,0.20840001f,-0.29610000f,0.02540000f,-0.40400000f,-0.27849999f,-0.11959999f,-0.13619999f,-0.63709997f,-0.06089999f,-0.45620000f,-0.47919999f,0.18130002f,-0.45020001f,-0.24750003f,0.79209999f,-0.26279999f,0.71550000f,-0.07330002f,0.71959998f,-0.19990005f,1.19340004f,0.28659999f,1.07240003f,-1.01280000f,-0.20120000f,-1.10040000f,1.05880001f,0.17200002f,1.09880001f,0.04189996f,-0.45199998f,0.07169999f,0.08150001f,0.63699999f,0.16109999f,-0.51760003f,-0.56300000f,-0.53500001f,-0.26680004f,-0.35619999f,-0.07500001f,-0.43870002f,-0.22380000f,-0.40350001f,-0.86030003f,0.37260000f,-0.68310003f,0.50409999f,-0.37579998f,0.49370000f,-0.61070001f,0.06320000f,-0.39410001f,-0.18860005f,-0.77779998f,-0.02920000f,0.18630001f,0.00360001f,0.64340000f,0.87179999f,0.64290001f,0.15219999f,0.86179999f,0.30289999f,0.39280001f,1.04600002f,0.75500002f,-0.03780002f,0.72499997f,0.22829999f,0.16420000f,0.00250000f,0.21350000f,-0.11380000f,-0.38220000f,-0.19830000f,-0.13560000f,0.26169999f,0.44980001f,-0.10819999f,-0.21269998f,0.35770002f,-0.09460000f,-0.19959999f,-0.25130000f,0.42360001f,0.42029999f,0.45000000f,-0.42160000f,-0.43429999f,-0.31119999f,0.51740001f,0.61610003f,-0.10149999f,0.07600000f,0.51460002f,-0.16600000f,-0.22840000f,-0.09200000f,-0.15660000f,-0.04220002f,0.22849999f,-0.89200001f,-0.10700001f,-0.90780001f,0.52760001f,-0.41499999f,0.29900001f,-0.36040002f,-0.68200000f,-0.46720001f,0.78560000f,-0.56659998f,0.54860002f,-0.63710000f,-0.02400000f,-0.53329999f,-0.04720000f,0.19539999f,0.02340000f,-0.09010003f,-0.85739997f,-0.08329999f,-0.70150002f,-0.55559998f,-0.52049999f,0.27740000f,0.23699999f,0.25880000f,-0.86070002f,-0.05819998f,-0.79830002f,0.61190001f,-0.11140001f,0.60070002f,0.15450003f,0.72759995f,-0.02290002f,0.90220002f,0.17159998f,0.65020000f,0.52679999f,-0.11879998f,0.46480000f,0.04420002f,0.44410003f,-0.33020000f,-0.59390000f,-0.29490000f,0.66000001f,1.10550000f,0.71379999f,-0.39299999f,-0.55259998f,-0.22409999f,0.17100002f,-0.08489999f,-0.08550000f,-0.15259999f,-0.99530002f,-0.38090001f,0.27760001f,0.52970002f,0.01820000f,0.01800000f,0.59500000f,0.54280002f,0.20440000f,-0.16230000f,0.22540001f,0.24060001f,0.28510001f,-0.08270000f,-0.15900000f,-0.42240001f,-0.54110002f,0.01280000f,-0.13440001f,-0.44400002f,0.19300000f,0.18169998f,-0.32990003f,-0.42420000f,-0.96729999f,-0.59589999f,-0.60980001f,-0.74069998f,-0.17009999f,-0.04180000f,-0.35550001f,0.18169999f,0.05440000f,0.26230000f,-0.68630000f,-0.24259997f,-0.77310000f,0.24239999f,-0.14339999f,0.31500000f,-0.29730002f,0.39359999f,-0.25230003f,-0.60090003f,0.55400001f,-0.34190003f,0.26390002f,0.23779999f,0.10909999f,-0.01780005f,-0.84359998f,-0.08660001f,-0.97570000f,0.07139998f,-0.79050000f,0.12710001f,0.38399999f,0.03369999f,0.52780003f,0.57580000f,0.49440001f,0.49280003f,0.62559999f,0.40800000f,0.45730003f,0.65800000f,0.31670000f,0.27789999f,0.40799998f,0.39649999f,0.26410002f,-0.48399999f,0.38550004f,-0.87070003f,0.91230000f,-0.80879999f,-1.15869996f,-0.84299998f,0.09780001f,-0.18079999f,0.33690000f,0.00200000f,0.24389999f,0.28360000f,-0.07160000f,0.10010000f,-0.23799999f,0.15360000f,0.19660000f,0.30600000f,0.30420001f,-0.01020000f,0.05350000f,0.00360000f,0.64820000f,0.05379999f,0.00320000f,-0.54770001f,-0.36380001f,-0.12520000f,-0.35769999f,-0.41920000f,0.40759999f,0.87709997f,0.45919998f,0.13380000f,-0.17760001f,-0.25050002f,-0.20059999f,-0.44479999f,-0.42830000f,0.39539999f,0.85829998f,0.39309999f,-0.00140000f,0.35080000f,0.44170001f,-0.84460000f,-1.13860001f,1.08350000f,0.19779999f,1.11830000f,-0.99140001f,-0.22659998f,-0.78559999f,-0.09630001f,-0.43179998f,-0.10589999f,0.66349998f,0.16459998f,0.52909998f,-0.47660001f,-0.21640000f,-0.42620000f,-0.65000001f,0.39579999f,-0.56220002f,0.87780001f,-0.25839998f,0.62540001f,-0.23870000f,0.63339999f,-0.12710001f,0.36690001f,0.45219998f,0.35330000f,-0.16229999f,-0.23179999f,-0.29109999f,-0.10259997f,0.57539999f,-0.08040000f,0.38700001f,0.37579999f,0.39039999f,-0.06169999f,-0.16039999f,-0.20669999f,-0.18540002f,-0.67059998f,-0.18920000f,0.83240001f,-0.28100001f,-0.54199999f,-0.69639999f,-0.68199999f,-0.10960000f,-0.44080000f,0.05020001f,-0.06359999f,-0.45619998f,-0.54320000f,-0.48860000f,-0.73409998f,-0.53109999f,-0.29880001f,-0.06120002f,0.09239999f,-0.01480000f,0.38250000f,-0.06520001f,-0.07520001f,0.47149999f,0.48080000f,0.63200001f,0.81090000f,0.38600000f,-0.49880001f,-0.50220000f,-0.16640000f,-0.36680000f,-0.47779999f,-0.38440000f,0.72660000f,1.21889999f,0.61689999f,0.19959999f,0.68669998f,0.23239999f,-0.24680000f,-0.07420000f,-0.02980000f,-0.47620000f,-0.69469999f,-0.29209999f,0.27500002f,0.17959999f,1.03519998f,0.25760000f,0.98719998f,-0.54400002f,-0.09720000f,-0.36760001f,0.30860000f,0.73319997f,0.30939998f,0.63870001f,0.15759999f,0.66690001f,0.29760000f,-0.55199998f,0.28800003f,0.70510001f,-0.05460000f,0.52110001f,0.06529998f,-0.86859996f,0.00770001f,-0.54770001f,0.22140000f,-0.62370003f,0.41540001f,-0.39239999f,0.46260003f,0.56620000f,0.07800001f,0.56140000f,-0.47989999f,-0.05240000f,-0.63090000f,0.29370000f,-0.20059999f,0.12570000f,0.38180000f,-0.31359999f,0.34940001f,0.28930000f,-0.14000000f,0.38110002f,0.47350001f,-0.39230000f,-0.13180001f,0.45580000f,-0.08290000f,-0.09580000f,0.24870000f,0.21530000f,0.09919999f,0.26269998f,-0.13080002f,0.34239999f,0.94229998f,0.69840001f,-0.13200000f,0.37529999f,0.26020000f,-0.13120000f,-0.11600000f,-0.13800000f,0.62459998f,1.11139995f,0.67909997f,-0.00440001f,-0.11590003f,0.32559999f,-0.45899999f,-0.90289996f,-0.63650000f,-0.32800001f,-0.33110001f,0.12480002f,-0.22740000f,-0.42949999f,-0.21749999f,0.59060001f,0.78349999f,0.57069999f,-0.22980001f,0.08800000f,0.21310001f,0.03840000f,0.15340001f,-0.15920000f,0.04179999f,0.18759999f,1.05440003f,-0.23140001f,0.80860002f,0.19749998f,-0.49439997f,0.14250000f,0.42610001f,0.23780000f,0.29570000f,-0.33350003f,-0.65499999f,-0.42630001f,0.37989997f,-0.64459997f,0.27870000f,0.28560001f,0.01200000f,0.26080001f,-0.55759999f,-0.25379998f,-0.66579999f,-0.69170001f,-0.38659998f,-0.53889999f,0.50270002f,0.38759999f,0.57370001f,-0.10650003f,-0.55620000f,0.00070001f,0.11770000f,0.06200000f,0.17710000f,-0.81250001f,-0.06839998f,-0.82630002f,0.20179999f,-0.64619999f,0.18400002f,0.41780001f,0.21479999f,0.31060000f,0.64500003f,0.14990001f,-0.69699999f,-0.88719997f,-0.76389998f,0.31720001f,0.03140000f,-0.02580000f,-0.38760001f,-0.12170000f,-0.53400002f,0.01840000f,-0.38849999f,0.00560001f,-0.40419998f,-0.12309997f,-0.56109999f,0.03599998f,0.80409997f,0.43579999f,0.61840000f,0.78420000f,0.70060001f,0.27740000f,0.01540000f,0.03410000f,0.05100002f,-0.43729998f,-0.23809999f,-0.63559999f,-1.04399999f,-0.51739999f,-0.44879998f,-0.60709998f,-0.45399999f,-0.22659999f,-0.15389998f,-0.32849998f,0.01999999f,0.63739998f,0.54300000f,0.30580000f,0.84150001f,0.44530001f,0.19680000f,0.09900001f,1.16100000f,0.18459998f,1.13240000f,-0.48300000f,0.50399998f,-0.43540002f,1.37890005f,0.12980001f,1.17250004f,-0.62430001f,0.13779999f,-0.45630001f,1.45049999f,0.13959999f,1.23229998f,0.43590001f,-0.74299998f,0.24910003f,-1.07140001f,-0.19200002f,-1.03740001f,-0.53199999f,0.37219998f,-0.46700000f,-0.36250001f,0.51239999f,-0.24590003f,0.41719997f,0.01080000f,0.54719999f,0.63269998f,0.08140000f,0.64149998f,0.70849999f,0.12159998f,0.61709998f,0.04180000f,-0.85359997f,-0.04419997f,-0.00970000f,-0.35759999f,-0.15030000f,-0.44319999f,-0.86809998f,-0.22420000f,-0.42049999f,0.14050001f,0.24899999f,0.22769998f,0.34929998f,-0.32540000f,-0.06279999f,0.11750002f,0.54299999f,0.57079997f,0.22329998f,0.07899999f,0.26389998f,-0.17190002f,0.24079998f,1.01109997f,0.40559999f,-0.00220000f,0.00360000f,-0.09090000f,-0.64080000f,-1.17570001f,-0.80120000f,-0.88980000f,-1.32659997f,-0.84749998f,-0.10380000f,0.18509999f,-0.20990001f,-0.11760000f,-0.46510000f,-0.43060001f,0.17720000f,1.02450000f,0.51140001f,0.43440000f,0.26050000f,0.37380000f,0.04840000f,-0.03100000f,0.32420000f,0.49880000f,-0.40640001f,0.00869998f,-0.44260001f,0.02000001f,-0.07980004f,-0.45879998f,-0.02320001f,-0.04150001f,0.42520000f,-0.05870000f,-0.75549998f,0.55779999f,-0.39040001f,0.33719999f,-0.31339997f,0.17250000f,0.47229999f,-1.30620000f,0.31500001f,-0.46840001f,0.36520000f,-0.26420000f,-0.86470001f,1.26920001f,-0.50910002f,-0.13110002f,0.30880001f,-0.09330001f,-0.06650000f,0.04520000f,-0.03650000f,-0.37500001f,-0.20599998f,-0.16760001f,-1.15869997f,1.02079998f,-0.61850001f,-0.02970000f,-0.26000000f,0.00690000f,-0.95820001f,1.22620000f,-0.54630002f,-0.76299998f,0.71190004f,-0.33860000f,-0.20260000f,-0.38030001f,-0.32060000f,0.03380000f,0.43310001f,-0.07660000f,0.06850000f,0.29879999f,-0.11159999f,-0.19320000f,-0.56380000f,-0.05659998f,0.10220000f,0.10270001f,-0.89960000f,-0.32739999f,-1.14920001f,-0.12660000f,-0.15450000f,-0.06559999f,1.27460002f,0.37900001f,1.37750006f,-0.21199999f,0.09530000f,0.52070000f,0.81380003f,0.38680000f,1.02090003f,0.40400000f,0.12580000f,0.02140000f,0.54940001f,0.28160000f,0.93710003f,-0.49440001f,-0.09180000f,-0.57260002f,0.24220000f,0.26150000f,0.73839999f,0.54500001f,0.04340000f,-0.24390001f,0.07499999f,-0.13460000f,-0.89890001f,0.63419999f,-0.47040002f,-0.38139998f,0.31079999f,-0.19880000f,0.28960000f,-0.29380002f,0.14590002f,-0.21989996f,0.50639996f,-0.13009999f,-0.64139999f,1.16059998f,-0.39830000f,-0.11140001f,-0.34320001f,-0.04300000f,1.12589998f,-1.87979997f,0.67820001f,-0.79449998f,0.61239997f,-0.41490000f,0.55370004f,-0.65700002f,0.32980001f,0.65200001f,-0.36659999f,0.34470001f,0.18709999f,-0.47939999f,0.13559999f,-0.43359999f,0.98180000f,-0.27310000f,-0.21119998f,0.20940001f,-0.09890001f,0.61100001f,-0.45170002f,0.87259999f,0.25630000f,0.87440002f,0.17440002f,0.03440001f,-0.35399997f,-0.40660002f,-0.10970000f,0.29480000f,0.43780001f,0.15650000f,0.48560002f,-0.57380001f,-0.02590000f,0.25539998f,0.59220003f,0.18390001f,0.36500003f,0.07720000f,0.09290000f,0.54810003f,0.26360004f,0.23650001f,0.27970003f,-0.03240000f,0.03030000f,0.45310001f,0.83700003f,0.17580001f,0.60470004f,-0.70740001f,-0.20970000f,-0.16680002f,0.38380001f,0.25100000f,0.73010003f,-0.24800000f,0.08090000f,0.10070000f,0.26560001f,0.24560001f,0.56160002f,0.70520004f,0.22520001f,0.82139997f,-1.26639996f,0.48739999f,0.55060002f,-0.06300002f,0.27230001f,-0.89040004f,0.28420001f,-0.45430002f,0.36620001f,-0.54040000f,0.21840001f,-1.19820000f,1.02620001f,-0.64190002f,0.71680003f,-0.70440001f,0.39940002f,-0.29570001f,-0.04740000f,-0.13480001f,0.16690006f,0.28319996f,0.07830002f,-0.39610001f,-0.02440000f,-0.18850001f,0.98650002f,-1.39560002f,0.57010003f,-1.05360002f,0.75060000f,-0.56670001f,0.05270002f,-0.14240001f,0.04890000f,-0.55149998f,0.83819999f,-0.31140001f,-0.03559999f,0.17800001f,-0.01300001f,0.62380005f,-1.04890001f,-1.08240004f,-0.21720001f,-0.28200003f,-0.39920000f,-0.25569999f,-0.56949999f,-0.05940000f,0.10440000f,0.02070000f,-0.33520002f,-0.16100000f,0.24700000f,-0.65400003f,-0.11130001f,-0.16250003f,0.73900001f,0.31790000f,0.52040002f,-0.57620003f,-0.30430001f,-1.00580005f,0.60680002f,0.22150001f,0.70910003f,0.12060001f,0.09690000f,-0.35900001f,0.23299999f,-0.02390000f,-0.02320000f,-0.19940001f,-0.18790000f,-0.59060002f,0.13099999f,0.00369999f,0.51579999f,0.32040000f,-0.01740000f,0.27520000f,0.16300001f,0.12200000f,-0.28130002f,1.07740002f,-0.07939998f,-1.63860004f,1.60060002f,-0.90030004f,-0.19330002f,0.07700001f,-0.11340000f,-0.16709998f,0.56240001f,-0.10770001f,-0.70580005f,-0.06639999f,-0.34740002f,-1.00450002f,1.04760002f,-0.55450003f,0.80900003f,-0.53680000f,0.44220001f,-0.17580002f,0.47620001f,-0.13130000f,0.47970001f,-0.74740000f,0.28940001f,0.43040005f,0.32239999f,0.19520002f,0.44399998f,-0.60219997f,0.24890000f,0.14939999f,-0.06499999f,0.06490000f,-0.13700001f,-0.52740000f,-0.03510000f,0.38359998f,-0.91439999f,0.23840001f,0.43950005f,0.29699997f,0.20260002f,1.27310000f,-0.33960000f,-0.73479999f,-0.09290000f,-0.06130001f,-0.18860002f,-0.06610001f,0.15779998f,-1.13200002f,-0.24770000f,-0.58110003f,-0.40460002f,-0.30310000f,-0.75320002f,-0.72440001f,-0.32620000f,-0.82400002f,-0.49680000f,-0.13440000f,-0.54320001f,0.70700001f,0.33400000f,1.00750001f,-0.57820001f,-0.29510000f,-0.18080003f,0.74540003f,0.19780001f,0.02970003f,0.30440000f,0.01570000f,0.19330001f,0.00320001f,0.11440000f,0.26440000f,0.42540000f,0.04440000f,0.63390001f,-0.47840000f,-0.04570000f,0.11770000f,0.11460000f,0.00900000f,-0.36249999f,0.37280001f,-0.24800000f,-1.22969997f,1.25319997f,-0.67450000f,-0.42140002f,0.05700002f,-0.21130001f,-1.49950000f,1.72840000f,-0.84230002f,-0.05040003f,-0.02099998f,-0.04130000f,-0.56160001f,0.61959999f,-0.32780000f,-0.44019998f,0.79219998f,-0.26770000f,0.39550002f,-0.63899999f,0.24900001f,-0.77480002f,0.11180000f,-0.39930000f,1.22510003f,-0.81680001f,0.65290002f,0.39909999f,-0.69860000f,0.23520001f,-0.23419998f,0.34659999f,-0.12690000f,0.28709999f,-1.06100001f,0.20400001f,-0.92009999f,0.80059998f,-0.49520001f,0.46090000f,-0.03480000f,0.22570000f,0.87420002f,0.79610001f,0.51500001f,0.09550000f,0.38960002f,0.08420000f,0.12310000f,0.40820001f,-1.21300001f,-0.35690000f,-1.29440005f,-0.28500000f,0.01140000f,0.43890000f,0.82320002f,0.29850001f,1.12430003f,-0.79420000f,-0.21200000f,-0.98790002f,-1.01519998f,-0.24150000f,-0.79730001f,-0.91900000f,-0.26690000f,-0.71500002f,0.99480002f,0.22410000f,0.31010003f,-0.57680000f,-0.16600000f,-0.67880002f,-1.09919998f,-0.31109999f,-1.26689999f,-0.60359999f,-0.13469999f,0.01450001f,0.06420001f,0.12240000f,0.22130000f,-0.55980001f,-0.18600000f,-0.58990002f,0.61020001f,-0.01730000f,0.60000001f,-0.92100000f,0.35030001f,-0.19620000f,0.13420001f,-0.09550001f,-1.08499999f,1.79679999f,-0.65220001f,-0.82950000f,0.45819999f,-0.42780001f,0.53530001f,-1.10259999f,0.34180001f,-0.61929998f,1.33759998f,-0.39110000f,-1.13829996f,1.60459995f,-0.65980000f,-1.01399999f,1.24479997f,-0.58000000f,1.45870002f,-1.39260001f,0.80140003f,-0.47219998f,0.90139997f,-0.29150000f,-0.92129997f,1.72679995f,-0.56610000f,-1.03089999f,0.75019998f,-0.55120000f,-0.09769997f,0.26759997f,-0.05569999f,-0.49670001f,0.73540000f,-0.29480001f,0.48580003f,-0.19430000f,0.29820001f,0.17280000f,0.05030001f,0.54380000f,0.16210000f,0.89180003f,1.04980000f,0.25010000f,0.90920003f,0.41960000f,0.35829999f,0.90110000f,-0.68659999f,-0.17140000f,-0.67790001f,-0.55920000f,-0.26760000f,-0.11680001f,0.61140002f,0.09780001f,-0.12329998f,0.39220002f,0.03290000f,0.02840002f,-0.13900000f,-0.22040000f,-0.45350000f,-0.48680001f,-0.08890000f,-0.66130002f,-0.30100000f,-0.15230000f,-0.55300001f,-0.11319998f,-0.00829999f,-0.58949998f,0.59820003f,0.36660001f,0.51810003f,0.60700002f,0.12830000f,0.61440002f,0.40580000f,0.01360000f,0.42130002f,0.05080000f,0.21130001f,0.26219998f,-0.95060000f,0.19250000f,1.11619998f,-1.69959999f,0.65520001f,-0.05309998f,0.14860001f,-0.01300001f,-0.66689996f,1.11959995f,-0.39889999f,-0.79880002f,0.15480001f,-0.41180000f,1.13910002f,-0.86980000f,0.60840002f,0.66680001f,-0.73740002f,0.36810002f,0.17349999f,-0.40320000f,0.09450001f,-0.35769998f,1.02119999f,-0.23850000f,-0.07500000f,0.29059999f,-0.06250000f,0.22370004f,0.50519995f,0.07810001f,0.53730005f,-0.01980002f,0.28320001f,0.58900001f,-1.09560000f,0.35720002f,0.17719999f,0.70860002f,-0.29240000f,-0.18700000f,-0.67120001f,-0.36320000f,-0.05770000f,-0.61390002f,-0.46400002f,-0.18940000f,-0.77100004f,0.17160000f,0.01980000f,0.17560000f,-0.70919999f,-0.14610000f,0.10030001f,-0.77040004f,-0.23190001f,-0.13810005f,0.18940000f,-0.03970000f,-0.16359999f,0.04740001f,0.12900001f,-0.19409999f,0.45840000f,0.14550000f,0.26490001f,0.77240004f,0.33460001f,0.72240004f,-1.03339998f,-0.22240000f,-0.41390001f,0.80500004f,0.46010001f,1.31200004f,-0.61540000f,-0.03410000f,0.20600000f,0.89460002f,0.33900001f,0.84430004f,-0.25299999f,-0.31940000f,0.04040000f,0.18319999f,-0.00239999f,-0.18429997f,0.85799998f,-0.14310000f,-0.19400000f,0.59980001f,-0.14050000f,0.17239999f,-0.38039998f,0.10700000f,-1.27630000f,0.89179997f,-0.67900001f,-1.17710004f,0.78100003f,-0.62960003f,0.47359999f,-0.50379999f,0.25650000f,0.16710003f,0.53780000f,0.05700000f,0.56610000f,-0.52319999f,0.31350000f,0.71660005f,-0.63940003f,0.40450003f,-1.45409996f,1.53599994f,-0.80750000f,0.29700006f,-0.47120004f,0.19900002f,-1.23360000f,1.10739996f,-0.66430001f,0.84590002f,-0.94980000f,0.48560001f,-0.69249997f,0.57960004f,-0.15900000f,-0.09180000f,-0.68290000f,0.63420003f,0.41460001f,1.24250006f,-0.26320000f,0.02110000f,-0.48390003f,1.17700001f,0.35360000f,1.37050002f,-0.96820004f,-0.27980001f,-1.21030004f,-0.14540000f,-0.16480000f,-0.53349999f,-0.50660001f,-0.03130000f,0.00679999f,0.49880001f,0.02830000f,0.21790002f,-0.74740002f,-0.38210000f,-0.91680002f,0.15240000f,-0.01590000f,0.13330000f,-0.30660001f,-0.06030000f,0.34940001f,-0.27820000f,-0.17690000f,-0.77980000f,-0.65900000f,-0.25960000f,-0.34750001f,-0.60820002f,-0.43010000f,-1.16320002f,-0.78500003f,0.00170000f,0.24550001f,0.29859999f,0.09580000f,0.06130003f,-0.25380004f,0.06940000f,-0.13329996f,0.90739999f,-0.11660000f,0.96749999f,-1.76919998f,0.59350001f,-0.74130003f,1.54320002f,-0.46630003f,0.19489998f,-0.11420000f,0.09120000f,-0.89740000f,0.97840000f,-0.49380002f,0.72370000f,-1.08500001f,0.41580002f,-0.51160004f,0.47940000f,-0.29870001f,0.18409999f,-0.46840000f,0.11570000f,-0.77240004f,0.24640001f,-0.39200002f,0.13920000f,0.24839999f,0.04220000f,-0.81550001f,0.52219998f,-0.44100000f,-0.06480004f,0.09180000f,-0.06250000f,-0.75050002f,-0.71320001f,0.72280001f,0.20990000f,0.96110002f,0.80520002f,0.22470000f,0.22910002f,0.84540003f,0.13680001f,0.39350004f,0.67519999f,0.14890000f,-0.12410000f,-0.06640001f,-0.05780000f,0.16499999f,-0.33620001f,-0.08110000f,-0.14500001f,0.09499999f,-0.17930000f,-0.58599999f,-0.36840000f,-0.30600000f,-0.54500000f,-0.12200000f,0.02390000f,-0.02970000f,0.30360000f,0.06450000f,0.58290003f,-0.37100000f,-0.14230000f,-0.69200002f,0.72680006f,0.46120001f,1.24980004f,0.61160004f,0.31180001f,0.38280003f,-0.05440000f,-0.02780000f,-0.35779999f,0.24919999f,0.01199999f,0.51170000f,-1.17620000f,0.32940001f,1.17730002f,-0.93300000f,0.63820002f,1.17010002f,-1.47480003f,0.66130003f,1.23129999f,-0.79339998f,0.65160000f,-0.21160002f,-0.18019999f,-0.09530000f,-0.46180000f,0.46780000f,-0.25590001f,0.66899997f,-0.67839998f,0.35300000f,-0.13360002f,-0.21580000f,-0.07029999f,-0.20749999f,0.38419999f,-0.12160000f,0.09689997f,-0.68279998f,0.09089999f,-0.10499998f,0.55559998f,-0.09199999f,0.20120009f,-0.26380006f,0.14050003f,0.68240007f,-0.21440004f,0.36160003f,0.17140000f,0.17880000f,0.07080000f,0.69229998f,-0.50339999f,-0.53880002f,-0.18300000f,-0.54840002f,0.94360003f,0.26870001f,0.98190006f,-0.52680000f,-0.22470000f,-0.72510000f,-0.04439999f,0.06780000f,0.40080002f,-0.91640004f,-0.23560001f,-0.19260002f,0.57240004f,0.28650001f,0.64970004f,0.42260001f,-0.04880000f,-0.28509998f,-0.24180001f,-0.11490001f,0.20679998f,0.35000002f,0.23260001f,0.60920003f,-0.25160000f,0.06890000f,0.02849999f,0.02800000f,0.18560000f,0.35480000f,0.33140001f,0.30700000f,0.68990002f,-0.82520002f,-0.20020001f,-0.56960003f,-0.76180001f,-0.39680000f,-1.24490004f,-0.69620004f,0.16490001f,-0.49020002f,0.68140001f,-0.28830001f,0.86590000f,-1.42319999f,0.51890001f,-0.32370000f,0.56579999f,-0.20340000f,-0.39660000f,0.18659999f,-0.19890001f,-1.39760006f,1.11340003f,-0.75610004f,0.43210005f,-0.36720004f,0.24790002f,0.98189999f,-0.99520001f,0.53090001f,-0.53020001f,-0.05679999f,-0.26020000f,0.08700003f,-0.08620002f,0.06110001f,-0.50089999f,0.83100001f,-0.28720001f,-0.28599999f,0.54880000f,-0.15960001f,-0.03689999f,0.22980001f,-0.01300001f,-0.97980000f,1.24899999f,-0.55970001f,-0.29570000f,0.61100000f,-0.20279999f,-1.00330006f,1.19270002f,-0.96159999f,-0.26990000f,-1.19210001f,-0.31160000f,-0.21549999f,-0.10269999f,0.14959999f,-0.05390000f,-0.17650000f,0.19080001f,0.14070000f,0.06230001f,0.10240000f,-0.03460000f,0.10580000f,-0.00860000f,0.06710000f,0.57540001f,0.66360003f,0.22440001f,0.08500004f,-0.43920002f,-0.02010000f,0.19449999f,-0.22719999f,0.04090000f,0.01230000f,0.78079999f,0.23170000f,0.62790001f,-0.08220000f,0.10650000f,0.43920000f,-0.32119999f,-0.01270000f,-0.15030000f,0.78520001f,0.25520000f,0.65220002f,0.20200000f,-0.09670000f,-0.28949999f,-1.09100000f,0.53880001f,-0.74689996f,1.56159995f,-0.46949999f,-0.38890003f,-0.17619999f,-0.19080000f,0.41789998f,-0.46999998f,0.22670000f,0.23470002f,0.14519997f,0.11350001f,0.12259999f,-0.42399999f,0.08220000f,-0.45740001f,0.01860000f,-0.21850001f,1.02740003f,-0.55160001f,0.54320002f,-0.91630002f,0.78480001f,-0.49090002f,-0.43329998f,0.66679998f,-0.24650000f,0.84469998f,-1.04679996f,0.48430000f,-0.50880000f,0.41460001f,-0.26430001f,-0.46129998f,0.72699998f,-0.26680000f,0.82480000f,-0.96899998f,0.47150001f,0.61149998f,-0.71059999f,0.33200000f,-0.79699998f,0.59710001f,-0.51540000f,-0.08820000f,-0.69070000f,-0.49220002f,-0.23320000f,-0.34530002f,-0.27939999f,0.08800000f,0.21830001f,-0.60860000f,-0.16480000f,-0.70910002f,-0.12180002f,-0.16980000f,-0.69390002f,0.42720002f,0.17790000f,0.09290002f,0.30899999f,-0.09450000f,-0.44859999f,0.75540002f,0.31770001f,1.13120005f,-0.50340001f,-0.27000000f,-0.97730004f,-0.38500000f,-0.10280000f,-0.53010000f,1.10500002f,0.38540001f,1.21590004f,0.65080000f,0.20930000f,0.34930001f,-0.08520000f,-0.09360000f,-0.49300001f,-0.65700001f,-0.27120000f,-0.86690003f,0.58800005f,-0.07510000f,-0.38809998f,1.10159997f,-0.25790000f,-0.53030003f,0.26600001f,-0.28630001f,-0.69509997f,0.87919997f,-0.38290000f,-0.50789998f,0.99139998f,-0.31400000f,0.35429998f,-0.10799997f,0.16770000f,0.61930003f,-0.23240001f,0.32410001f,0.91599997f,-0.85799998f,0.48820000f,0.40060000f,-0.87560000f,0.26440000f,-0.08110000f,0.44720001f,-0.08170000f,-0.26350000f,0.67359999f,-0.17330000f,0.93550001f,-1.39979999f,0.55820001f,0.82170000f,-0.71799999f,0.45250000f,0.24220000f,0.03480000f,0.10960001f,-0.43450000f,0.72539999f,-0.26920000f,0.34200006f,0.57230000f,0.50260001f,0.17750000f,-0.11780000f,0.17340000f,-0.04800000f,-0.32049998f,0.33419999f,0.20310000f,0.35520000f,0.75379999f,0.10989999f,0.31660001f,0.28720000f,-0.03430000f,-0.40649998f,-0.07960000f,-0.01520000f,-0.17900000f,0.96039998f,0.27770000f,0.93850001f,-0.24640004f,-0.21770001f,-0.28990003f,-0.74439998f,-0.16519999f,-0.59620000f,-0.42100003f,-0.30110001f,-0.82940005f,-0.38720000f,-0.12640000f,-0.37000001f,0.65320001f,0.19640001f,0.89460005f,-0.00520000f,-0.15290000f,-0.62170002f,0.22520002f,0.15580000f,0.23360001f,0.72460003f,-0.20979999f,0.90540004f,-0.29580001f,0.46630002f,0.56109998f,-0.42619999f,0.29380000f,0.25380000f,-0.05079998f,0.13799999f,1.07319997f,-1.34919998f,0.60540000f,0.82029998f,-0.57599999f,0.42890000f,-0.00740000f,0.19920000f,-0.01620000f,0.92309996f,-1.40059994f,0.54579999f,-0.13710006f,-0.23639995f,-0.06550002f,-0.83159996f,1.23259996f,-0.48489999f,-0.02600003f,0.06120001f,-0.03420000f,-0.37179999f,0.49939999f,-0.21690000f,0.44079997f,-1.04739998f,0.28669999f,0.50370000f,-0.32860000f,0.25400001f,0.16680003f,0.04879998f,0.08720001f,1.21740004f,-0.36620001f,-0.69699999f,-0.16970000f,-0.97680002f,0.06640000f,0.12920000f,0.67280001f,0.04600001f,0.10730001f,-0.38710001f,-0.41060001f,-0.14770000f,-0.03920001f,0.05360003f,0.11560001f,-0.39959997f,0.68519999f,0.09450000f,-0.12430001f,0.60660001f,0.13740000f,0.84790001f,0.02380000f,0.07850000f,0.54099999f,-0.36699999f,-0.02780000f,0.21230001f,-0.95160002f,-0.34020001f,-1.07720003f,-0.50099999f,-0.14310000f,-0.66579999f,-0.05419998f,0.03920000f,-0.22869999f,0.46739999f,-0.03180000f,-0.27330000f,0.74100003f,0.19200001f,0.42490004f,-0.02200000f,0.17230001f,-0.47199996f,1.29739995f,-0.31489999f,-0.42039999f,0.06839999f,-0.19980000f,0.31250004f,0.54440000f,0.12570001f,-0.64140002f,0.29720000f,-0.33680001f,0.33140005f,0.56899995f,0.13390002f,1.27329999f,-1.04559997f,0.68350001f,0.41690000f,-1.17160000f,0.27890001f,-0.37979999f,0.01260000f,-0.17990000f,-0.79650000f,0.58459998f,-0.42160001f,-0.78040002f,1.18519999f,-0.46780002f,-0.35599999f,0.82519997f,-0.22940000f,0.04970004f,0.39819996f,0.00300001f,1.04609998f,-1.02759997f,0.56490001f,0.93650002f,-1.02700001f,0.52520002f,-0.32100000f,-1.36790002f,-0.51360002f,-0.31020000f,-0.64700002f,0.12579998f,-0.01420000f,0.27149999f,-0.13500000f,-0.19230000f,-0.76840000f,0.55739998f,0.28109999f,1.03479999f,0.34960000f,0.21860000f,0.34700001f,0.93020000f,0.25749999f,0.35560000f,0.03820000f,0.04850000f,0.06860000f,-0.98300003f,-0.24370001f,-0.88620004f,-1.14300001f,-0.35910001f,-1.38480004f,0.26740000f,0.14840000f,-0.00989999f,-0.33560000f,0.00770000f,0.01689999f,0.89940003f,0.18630001f,0.14420005f,0.16480000f,0.04610000f,0.63590001f,-0.15240000f,-0.16680000f,-0.16540000f,0.58540001f,1.00899999f,-0.36550001f,0.15639999f,-0.07170000f,-0.53949999f,-0.99679998f,-0.31129999f,-0.12500002f,-1.07529999f,0.37560000f,0.36600002f,0.43410000f,-0.28000000f,0.11800000f,0.89930000f,-0.06300000f,0.88450003f,-0.10869999f,-0.07590000f,-0.60400003f,-0.18170000f,0.46520000f,0.36699999f,0.06500001f,0.69179998f,0.23050001f,0.28310000f,-0.15490000f,0.30650001f,0.16120000f,0.23309999f,-0.44549999f,-0.76019998f,-0.12290000f,-0.89149999f,0.46489999f,-0.73689999f,0.00149999f,-0.02490001f,0.53430001f,-0.68900002f,0.53150002f,-0.19279999f,-0.54450000f,0.13080000f,-0.55090000f,0.62230000f,0.36190000f,-0.51330001f,0.18060003f,0.61080001f,0.14940002f,1.97610002f,0.10470002f,0.38810001f,0.01299999f,-0.53480002f,-1.49820000f,0.67320001f,0.12240001f,0.89579998f,-0.25560001f,-0.48280000f,-0.33360001f,0.27690002f,-0.04710001f,0.14000000f,0.28000000f,-0.17400000f,-0.84769999f,-0.71979998f,0.88540001f,0.46430000f,-1.12400001f,-0.17140001f,-0.54700000f,-0.09799998f,-0.10600001f,-0.43290001f,0.51420000f,0.61200003f,-0.10980001f,-1.02960001f,0.30300001f,0.03070001f,0.80899998f,-0.59160002f,-0.21429997f,0.61669997f,-0.07000000f,0.56139999f,0.21980000f,-0.42199999f,0.40370001f,0.21460000f,-0.25900001f,1.05670001f,-0.46780000f,0.41400001f,-0.25050000f,-0.17220000f,0.94599998f,0.69260000f,0.95439998f,-0.02899999f,-0.47499999f,-0.50859998f,0.30750001f,0.19650001f,0.20670000f,0.12300000f,0.06240000f,-0.11300000f,-0.52950001f,0.08369999f,0.55389998f,-0.11300000f,-0.74650000f,-0.11160000f,0.54500000f,0.01900001f,0.43899999f,-0.48500002f,0.56570000f,0.09880000f,-0.31050000f,-0.42300001f,0.19110000f,0.74900000f,0.22330000f,-0.03440000f,0.05300003f,0.53860002f,-0.20249998f,1.59059998f,-0.18460000f,-0.53929998f,-0.88899996f,-0.12760002f,0.59820001f,-0.25020000f,-0.04339999f,0.13689998f,-0.36429998f,-0.82690002f,-0.20220002f,-1.64729999f,-0.16810001f,0.90510000f,-0.49589999f,-0.77590002f,0.08739999f,-0.39219999f,0.38900001f,-0.10610002f,1.38350000f,0.19930002f,-0.19570000f,-0.44570000f,0.48930001f,-0.84660001f,-1.12199996f,0.44480000f,-0.96970003f,-0.53149998f,0.70010003f,0.44949999f,0.87320003f,0.55680003f,0.75890001f,-0.32120003f,-0.09500001f,0.42580002f,1.17590000f,-0.50230002f,0.56250003f,0.11550000f,0.38349999f,0.82249999f,-0.08350001f,0.57199998f,-0.41029999f,0.57259996f,-0.38500002f,-0.26480000f,-0.38540000f,0.98550001f,-0.50099997f,0.13770000f,0.37950000f,-0.89309999f,0.46390000f,0.35000001f,-0.70399998f,-0.41220000f,-0.57299999f,-0.09360000f,-0.07980000f,-0.19050000f,0.82380001f,-0.20029998f,-0.49450001f,-0.03260001f,0.11489999f,0.04999999f,-0.27979999f,0.71519998f,-0.19700001f,0.14480001f,0.65040001f,-1.06849999f,0.56510002f,-0.59549998f,-0.43599999f,-0.35150001f,-0.47979999f,0.33700002f,0.37130000f,-0.40460000f,0.07299999f,0.17060002f,0.38850000f,-0.78090000f,-0.48710001f,-1.10390000f,0.85100004f,-0.02980002f,-0.41170000f,0.64209998f,-0.22250001f,-0.97919998f,1.04820001f,0.00639998f,-0.06690001f,-1.58399999f,0.43620003f,0.87699998f,0.28519997f,0.15280001f,-0.72610000f,0.44079999f,0.59500001f,1.15129999f,-0.06919999f,-0.96020002f,-0.50480002f,-0.58059999f,-0.71200001f,-0.64779998f,0.37749999f,0.41689999f,1.30789997f,0.42699996f,-1.00120002f,0.83530003f,1.22300000f,-0.25440001f,-0.53570000f,-1.04169996f,0.03030000f,-1.34459999f,-0.44909997f,0.65390001f,-0.73239999f,-0.76430001f,0.35550000f,-0.65640000f,-0.04750001f,0.85250001f,0.65830001f,0.66829998f,0.59350000f,0.34639999f,0.23890000f,0.71150001f,0.75099999f,0.53589998f,-0.51400003f,-0.68089999f,0.22579999f,-0.85199997f,0.03179999f,-0.72199996f,-0.24500000f,0.57829999f,0.32920000f,0.40700001f,-0.58789998f,-0.62559999f,1.31149999f,-0.45139998f,0.61909999f,-0.06900000f,0.46889998f,0.32059998f,0.34200004f,-0.36870000f,-0.81579996f,-0.29199999f,0.40030000f,-0.76460000f,0.36299998f,-0.43859998f,0.56239997f,0.14099998f,0.24630000f,0.92019997f,-0.32200004f,-0.53730003f,0.22770004f,0.90090000f,0.43350002f,0.01629998f,-1.75809998f,-0.04030001f,-0.64770003f,-1.79160000f,0.55020002f,-0.00750002f,-0.78210001f,-0.12890000f,-0.57619999f,0.41509999f,0.83550002f,0.36420001f,0.25079998f,-0.67740002f,0.65899998f,-0.09290001f,0.26190001f,-0.74219998f,-0.30509996f,-0.56230004f,-0.31920000f,0.12300001f,0.50560000f,0.81380000f,1.26309997f,-0.32550000f,0.16600004f,0.74719997f,0.87980003f,0.50199998f,-0.96969998f,-0.20629999f,-0.39100003f,-1.48579999f,-0.24620000f,-1.42510000f,0.13750003f,0.46330000f,0.04040000f,0.49730000f,-0.74250002f,0.58139999f,-0.41190001f,0.05050000f,-0.95139999f,0.29590000f,-0.23200002f,-0.63890000f,0.66140000f,0.17900000f,-0.45800000f,0.16600001f,-0.67150001f,0.61689998f,0.17290000f,0.61750001f,-0.16780001f,-0.16490000f,-0.83149998f,-0.08950000f,-0.52149997f,1.28950000f,-0.20769999f,0.71389996f,-0.42749999f,0.29939999f,0.10490000f,-0.18299998f,0.40169999f,-0.74059997f,-1.28150003f,0.66319996f,-0.43550001f,-0.09600001f,-0.68369998f,-0.15799999f,0.62099999f,-0.79679998f,0.59100000f,0.44749999f,0.50920000f,0.91969998f,-0.74700002f,-0.01700000f,0.02910000f,-1.32570003f,-0.59010004f,-0.38560002f,-1.91959997f,0.08640001f,0.13579999f,-1.47500004f,-0.48740002f,0.48219999f,-1.30239999f,0.21480002f,0.14219999f,0.52170002f,0.84770005f,-0.05160000f,0.25529999f,-0.25850000f,0.63559998f,-1.51849997f,-0.10530000f,-1.26089997f,-0.00869998f,0.70690000f,0.15010001f,1.61989999f,0.16830000f,0.20359999f,0.13960004f,0.73460003f,0.65040001f,0.54239997f,-0.50760001f,0.10609998f,-1.40719996f,-0.25559999f,1.06299998f,-0.61420001f,0.07820002f,-0.82959998f,0.34780006f,-0.33200004f,0.19349999f,0.08910000f,0.76000002f,-0.91060002f,0.32980000f,0.18299998f,-0.91559998f,0.59019999f,0.54700001f,-0.97600001f,0.25540000f,-0.63200001f,-0.71379999f,-0.17640000f,-1.22050002f,0.53710001f,-0.37289999f,0.37599999f,0.05810000f,0.04920000f,-0.32450000f,-0.96729998f,-0.18370000f,0.00699998f,0.48199999f,0.77279997f,-0.34099998f,0.88879999f,-0.42119999f,-1.11550001f,0.28360002f,-0.32869999f,0.18100000f,-0.01120001f,-0.45979999f,0.26449998f,-0.85549997f,0.21629999f,-0.88700000f,-0.50799999f,-0.68899997f,1.04850002f,0.23460002f,0.61769997f,1.04400000f,0.38630001f,-0.44659998f,1.15129999f,0.37050000f,0.15830001f,-2.20519998f,0.15880002f,0.37890001f,1.49579995f,-0.15400000f,0.93220003f,-0.09250003f,-0.52310002f,-0.10200002f,-1.10610000f,0.27910001f,-0.62630000f,-0.01810000f,-0.35650001f,-0.49250000f,-1.34799995f,-0.27100001f,-0.54379998f,-0.87159997f,-0.44600003f,0.77479998f,0.37629998f,-0.89270000f,0.34179998f,0.46040000f,0.39720001f,0.39960003f,0.71160001f,0.10360000f,-0.14900001f,-1.37889997f,0.33690001f,0.70980003f,0.90780001f,-0.36320002f,0.49070005f,0.90490001f,0.70450000f,-1.13599999f,-0.52719998f,-0.16149999f,0.82509998f,0.05170000f,-0.31350005f,-1.14929999f,0.22589997f,-0.08699999f,0.66869998f,-0.49879998f,-0.00400000f,-0.40910001f,-0.55440000f,-0.28450000f,-0.47330000f,0.20350001f,0.93199998f,-0.00799999f,0.53659998f,0.72799998f,-0.71209997f,0.64699997f,0.99299999f,-0.50819999f,0.64059996f,0.59500001f,-0.25449998f,-0.44059998f,-0.77699998f,0.31260000f,-0.41259997f,-0.43600000f,0.33520000f,-0.43520001f,-0.32400001f,-0.58949999f,0.27199999f,-0.05449999f,0.22040001f,-0.59610000f,-1.29299999f,0.62399998f,-0.66240001f,0.40199998f,-0.63540001f,-0.00359999f,-1.74600004f,-0.01120000f,0.28079999f,-0.06329998f,-0.87210002f,-0.57639998f,-0.93619999f,-0.13960002f,1.21210002f,0.45020000f,-0.95900002f,0.39990003f,2.20860000f,-0.27480001f,-0.24649999f,0.95990000f,0.42710001f,0.28710004f,0.88050000f,0.82570002f,0.21450002f,1.76999996f,0.39500000f,-0.08580003f,-2.64119994f,0.13960001f,0.13230001f,-1.76519999f,0.09580000f,-0.32850000f,0.87090003f,0.25810001f,-0.62160002f,0.04320002f,0.82460003f,-0.70140001f,-0.82980000f,0.40500002f,-0.33990000f,0.37590002f,0.73230002f,-0.62349997f,-0.55999999f,0.02699998f,-0.93120003f,0.30219999f,0.93650001f,-0.38449997f,-0.00910000f,0.61549999f,-0.43220000f,0.61029997f,0.35750001f,-0.32329999f,-0.75870000f,0.05200001f,1.00250000f,-0.60980000f,-0.38300000f,0.70339999f,-0.07400000f,-1.30100001f,0.69199998f,-0.53520001f,-0.68699998f,1.03289997f,-0.54199999f,-0.10500001f,-1.33979997f,0.48259999f,-0.21400002f,-0.93170000f,0.18339998f,-0.10000000f,0.61480001f,0.03700000f,-0.62150001f,0.42440000f,0.27170001f,-0.00700002f,-0.16640000f,0.56779999f,-0.71100000f,0.51480000f,0.02880000f,1.18949999f,0.35760001f,1.65600003f,0.04049998f,-0.83150002f,-0.83230002f,-0.93109998f,0.60550002f,-0.89060001f,-0.66639998f,0.14420000f,1.17249998f,-0.86170002f,-0.48829999f,0.17510002f,1.00359999f,-0.07340001f,0.91840004f,0.64580000f,-0.57100002f,0.24309997f,1.72189999f,0.27730003f,-0.01580000f,0.20989997f,0.67150003f,-0.87560001f,-0.61839997f,0.87520002f,-0.57430001f,1.28500002f,0.29840001f,-1.28700000f,0.22440005f,0.10559997f,-1.61530003f,0.60190006f,0.44950001f,-1.06299998f,-0.49579998f,0.77780001f,0.19020001f,0.59160000f,0.19380001f,0.48969998f,0.66070000f,-0.13649999f,-0.58470000f,-1.04050000f,-0.17250001f,-0.12660000f,0.63810000f,0.47449999f,-0.13100000f,0.73369999f,-0.22350000f,-0.85319999f,-0.60649998f,-0.03899999f,0.47429999f,-0.28320000f,0.06500000f,-0.03020000f,-0.65980001f,-0.55349998f,0.96180001f,-0.52969996f,-0.87050002f,0.34249998f,-0.16689999f,-0.49600001f,0.13960000f,0.55919999f,0.02700001f,0.89670001f,0.13760001f,0.81400002f,0.40700001f,0.87999998f,0.60400000f,0.78860003f,0.98260000f,-0.23000002f,0.20839999f,0.69599997f,-0.39850001f,0.34300000f,-0.28090000f,-1.15400002f,0.00220000f,-0.27639999f,0.03190000f,0.52830001f,-1.38749999f,-0.01649994f,0.81350001f,-0.67849998f,1.63969997f,0.10730000f,-0.02580003f,-1.56630000f,-0.07830000f,0.64099998f,-0.79820000f,0.05820002f,-0.60430000f,-0.76039997f,-0.55520001f,0.16180001f,0.48799998f,-0.53740001f,-0.67430003f,-1.57719999f,0.25260002f,0.34870002f,1.32830003f,0.44910003f,-0.91900001f,0.06280004f,0.80920003f,-0.92140000f,0.81550002f,0.30970000f,0.76810004f,0.88670000f,-0.48750002f,-0.25580003f,-1.89669999f,0.34910001f,0.39430001f,-1.09480004f,-0.26460002f,1.04380002f,0.03570000f,-0.48850000f,0.25029999f,0.08430000f,-0.03900002f,0.53880001f,0.84399997f,0.35300000f,1.04079998f,0.19399999f,0.13050001f,-0.85409999f,0.30210001f,-0.54700001f,-0.52999999f,-0.34499999f,1.18049998f,-0.47429997f,0.68909998f,0.58249999f,0.04540000f,-0.08710000f,0.17699998f,-0.62069999f,0.70760000f,-0.85500001f,0.79020001f,-0.57640000f,-0.38100001f,0.48780001f,0.48899999f,0.27200001f,0.71890000f,0.46880000f,0.06550000f,0.15560000f,-0.60870001f,-0.25800001f,-0.83970000f,0.43560001f,0.06100001f,-0.74890002f,-0.04560000f,0.42050000f,-0.22970001f,-0.31180001f,-1.12280003f,-0.73680003f,0.67070001f,-0.19249999f,-0.32010000f,1.49090000f,-0.55430004f,-0.34590002f,0.04960000f,-0.56380001f,0.33600002f,1.19130000f,-1.21620001f,-0.09919998f,1.50719998f,-0.53550004f,-0.24009996f,-0.21059996f,-0.78449999f,-0.88570006f,1.11680001f,0.46509996f,-0.70250002f,0.23310001f,0.27750000f,0.31570000f,0.08170000f,-0.41980000f,-0.01580000f,0.96400000f,-1.06300001f,-0.16999998f,0.05230000f,0.63409998f,0.95250006f,-0.73970001f,-0.32289998f,0.56550002f,-0.12730003f,-1.54700001f,-0.38460001f,-0.19700003f,0.14070000f,1.20400000f,-0.78580001f,0.57559999f,-0.07600001f,-0.34219999f,-0.38940000f,-0.64799996f,-0.70380002f,-0.92179998f,-0.47450002f,-0.19540001f,-0.01170000f,-0.74600002f,-0.91330000f,-0.64260000f,-0.79900002f,-0.66110000f,-0.95939997f,1.32250000f,-0.67630000f,0.47569996f,0.09150002f,-0.20970001f,-0.74609998f,-0.58849999f,0.20899999f,-0.28470000f,-0.03750000f,-0.24450000f,0.01510000f,-0.48550002f,-0.81140000f,-0.48749999f,-1.29200003f,0.64999999f,-0.34859998f,-0.19200002f,0.16500001f,0.47539999f,0.60750000f,-0.92789999f,0.43810001f,-0.61399998f,0.55090001f,-0.43510001f,1.25410003f,0.17570001f,0.81190002f,1.11739998f,-0.39660001f,-0.60210000f,0.06000001f,0.09480000f,1.06169996f,-0.29070003f,-0.34389997f,-0.02240000f,-1.22230004f,-0.58050003f,0.04079998f,-1.14089999f,-0.49650000f,0.65300002f,-0.05060003f,-0.69940004f,0.11190001f,0.58709999f,-0.37130001f,-1.56900005f,0.19530004f,0.77870004f,0.05070000f,-0.68160000f,0.57100002f,0.66890001f,0.09189998f,-1.06910003f,0.53680001f,0.42289997f,-0.40330001f,-0.67670003f,-1.38280003f,0.75540004f,0.32700001f,-1.57020002f,-0.29280001f,-1.18749998f,0.80869998f,0.08500001f,0.81140002f,0.06720001f,-0.08749999f,0.30049999f,-0.69929999f,0.32149999f,0.18190000f,0.40969999f,-0.33400000f,-0.47899999f,-0.65339996f,0.78500000f,-0.84230002f,0.34780000f,0.62749999f,-0.78289998f,0.26990000f,0.43400002f,-0.39200002f,-0.32000000f,0.40100000f,0.16420000f,-0.10280000f,0.13999999f,0.67510002f,0.94800001f,-0.78300002f,-0.17850001f,-0.04240000f,0.90650001f,-0.44480000f,-0.27730000f,0.12900001f,-0.01710001f,-0.37859999f,-0.48200003f,-0.34630002f,0.56940001f,0.15049998f,-0.99800001f,0.09049999f,0.61550000f,0.54470004f,0.44209998f,-1.13719999f,-0.11459999f,0.28490000f,0.23260001f,-0.57880002f,-0.45370000f,0.77350002f,0.80710003f,0.57950001f,0.96099999f,-0.09700000f,0.46340000f,1.86459998f,-0.47880003f,1.30350000f,0.72569999f,-1.18670003f,-0.74329998f,1.65739996f,0.09199999f,-0.39310002f,-0.95179998f,0.62160001f,-0.04890000f,-0.41850000f,-0.01330000f,0.58259998f,-0.64559997f,-0.71620001f,0.41740001f,-1.02070004f,0.24450002f,0.02549999f,1.17600002f,0.17500002f,-0.10740001f,1.58520001f,0.07000002f,0.74620002f,0.51919999f,-0.54980002f,-0.25150000f,-0.37079996f,-0.17100001f,-0.72989998f,-0.10520000f,0.54700002f,-0.12849999f,-0.12480000f,-0.72700001f,0.77380000f,0.02840000f,-0.30749999f,0.36450000f,-0.56649999f,0.27450005f,0.73799999f,-0.55429997f,0.58700002f,-0.27199998f,-0.82399999f,0.42100000f,1.05769997f,0.24159999f,-0.51900000f,-0.21810000f,0.31720000f,0.05599999f,-0.21740000f,0.10979999f,0.51150001f,-0.70019997f,-0.16369999f,-0.62450002f,-0.54130002f,-0.18330000f,-0.25499999f,0.67950002f,-0.25599999f,-0.02100000f,0.88740002f,-0.20619999f,0.16550000f,-0.05660000f,-0.51690000f,-0.42750000f,-0.03710000f,0.54550001f,-0.21220005f,-0.75080001f,-0.61740001f,1.06020005f,-0.03300001f,0.23130002f,0.53159999f,0.65900002f,-0.64900000f,-0.62869996f,0.37570000f,-0.12820001f,-0.48409999f,-0.02730000f,-1.36140000f,0.93479998f,0.15339998f,0.75360002f,-0.18480000f,0.07700000f,-0.25300005f,-1.77830000f,-0.38770000f,-1.23310003f,-0.97009995f,0.95590002f,0.90439999f,-0.55250000f,-0.07370000f,1.21499999f,-0.50040000f,-0.69560000f,-0.75979998f,0.11150001f,0.33989999f,0.02780001f,-1.91929998f,-0.28010002f,-1.12829996f,0.25110003f,0.51429999f,-0.83799999f,-0.40219998f,0.58199999f,-0.47430001f,-0.20300000f,0.49500002f,0.67320003f,0.27780000f,-1.03900000f,0.46089998f,-0.39960000f,-0.00850001f,-0.07969999f,0.50149998f,0.13350000f,-0.24150000f,0.18190000f,0.80250002f,0.81539998f,0.80329999f,-0.65850000f,-0.21960001f,-0.53570000f,0.70600000f,-1.02729998f,0.57000001f,-0.33500000f,0.05000002f,0.86320000f,-0.57049998f,-0.49570000f,-0.55129998f,0.01500000f,-0.73979998f,-0.65499999f,0.11649999f,0.32329999f,0.46409998f,0.35749999f,-1.12069999f,0.36589998f,0.15999999f,0.52879999f,0.67259996f,0.90799997f,-0.52750003f,-0.25600002f,-1.03789999f,-0.61510003f,-0.31060002f,-0.90859997f,-0.83060002f,0.28110000f,-1.48020003f,-0.02259999f,0.39700000f,0.32300000f,-0.29000001f,-0.35590000f,-0.42379999f,-0.50600003f,-0.68240000f,0.80299998f,-0.21280001f,1.32470001f,0.53559997f,-1.03020004f,-0.65200002f,-0.34520001f,0.22720000f,-0.05669999f,0.23339998f,0.21320001f,0.00460000f,1.73269999f,-0.13449999f,-0.22010002f,0.06770000f,-0.39690001f,-1.15390000f,0.06310008f,0.89310003f,1.48250005f,0.35589997f,-0.95090004f,0.20810000f,0.38950000f,0.52370003f,0.06920005f,0.63439998f,1.00250001f,-0.71029999f,0.49450000f,1.32499999f,-0.70399997f,0.55819999f,-0.17050003f,-0.84950001f,0.05129999f,0.08450001f,-0.00440000f,-0.28350000f,0.93000002f,-0.32730000f,0.43979999f,0.78050000f,0.48819999f,0.40730000f,0.36700004f,-0.32410001f,-0.84039998f,0.18700000f,0.02120000f,0.48700001f,-0.23900000f,0.20749999f,-0.04360000f,0.16349999f,0.87450000f,-0.26969999f,0.68350001f,-0.05559999f,0.23370001f,-0.31700003f,0.56240003f,0.64279997f,0.14700002f,-0.42360001f,-0.94200001f,-0.84350001f,0.34400000f,-0.32969999f,0.09100000f,-0.68679999f,0.62250002f,0.68790000f,0.16910002f,-0.15130001f,-0.32449999f,0.60090003f,-0.22840001f,0.36250002f,0.49370002f,-1.25130003f,1.27170004f,0.09170000f,-0.04190000f,-0.20680000f,0.27300001f,0.47700002f,1.06800000f,-0.66300003f,-0.48569998f,-1.87139997f,0.50400001f,0.20230000f,-0.80950002f,0.20010002f,0.79210000f,0.57139997f,-0.48220001f,0.08650002f,0.91100002f,0.73500001f,-0.53260000f,-0.03200001f,-0.19520000f,-0.39399999f,-1.24970000f,-0.50730004f,-0.90800000f,-0.69249997f,0.67050000f,0.10660000f,-0.38320000f,0.08240001f,-0.38520000f,-1.91360003f,0.09550000f,-0.24670000f,0.03010000f,-0.18450000f,0.65889997f,1.50049999f,-0.68409999f,0.58869998f,1.09310001f,0.38040000f,-0.04049999f,-0.53490000f,0.39470000f,-0.60050000f,-1.02970002f,0.04920000f,0.50600000f,-0.26480001f,-0.42479999f,-0.33950001f,0.28609999f,-0.44999997f,-0.20199999f,-0.54680001f,0.22810000f,-0.04260000f,-0.35700001f,-0.09049999f,-0.09309999f,-0.42590001f,-0.22330000f,0.43549999f,1.11069999f,0.66329999f,-0.40959999f,0.22479999f,-0.38820000f,-0.22319999f,-0.20520000f,0.31170000f,-0.61810002f,-0.18170004f,-0.23229998f,-0.21319999f,-0.16870000f,-0.12740001f,-0.00280000f,-0.58470000f,-0.30380000f,0.34669999f,-0.17040002f,-0.46960005f,-0.40850000f,0.55790002f,0.27260000f,-0.36710001f,0.79379997f,0.57879997f,-0.48459998f,0.14680001f,-0.00119999f,-0.10980000f,0.29370001f,0.17640000f,-0.20790001f,0.18420000f,0.04000000f,-0.19120000f,-0.82240000f,-0.23819999f,0.74309999f,-0.08329999f,0.07780002f,0.28370000f,0.50200000f,0.39800000f,-0.21500000f,-0.62370002f,-0.39740001f,0.27830001f,-0.42810000f,-0.05879998f,0.51780000f,0.90270000f,0.39219998f,-0.73209999f,0.10130003f,-0.92610000f,0.05670000f,-0.55579999f,-0.68740001f,-0.01489999f,-0.58890000f,-0.34290003f,0.72620000f,-0.70170001f,-0.85050003f,0.04330000f,0.45010000f,0.15770002f,-0.37099997f,-0.54180000f,-1.63380001f,0.17699998f,0.57799998f,0.76360000f,-0.05820000f,-0.10740000f,-0.45420002f,0.10920000f,0.05820000f,-0.07860000f,-0.38269998f,-0.54799998f,-0.08320000f,-0.21210000f,0.56630000f,0.93310002f,-0.28099999f,0.02600000f,-0.47000001f,0.12670000f,-0.68670000f,-0.44310002f,-0.31080000f,0.09690000f,0.53490000f,0.14149999f,0.17610000f,-0.58829999f,0.51809999f,0.17500000f,0.47139998f,0.03299996f,-0.65249998f,0.49689999f,0.53220000f,-0.01530000f,-0.32440002f,-0.23880001f,0.19320001f,1.14040001f,0.72340000f,-0.58840001f,0.31270000f,0.50480003f,0.24850000f,0.57130001f,0.29260000f,-0.29860001f,-0.65599999f,-0.33559999f,0.47239999f,-0.17500001f,-0.33060002f,-0.23279999f,-0.62940001f,-0.26819999f,0.49800000f,-0.17780000f,0.21640002f,0.46699999f,-0.45890001f,-0.03619999f,0.49580000f,-1.08540000f,-0.86700001f,0.37169999f,-0.35169999f,-0.26659999f,0.21110000f,0.53320002f,0.04879998f,-0.64670001f,0.13570000f,-0.55150003f,0.39090000f,-0.41619999f,-1.06099999f,-0.53929997f,0.30230000f,-0.06289998f,0.15540000f,0.20619999f,0.64460002f,-0.24850000f,0.75049998f,0.03129999f,-0.65559999f,0.63259999f,0.61300001f,0.03669999f,0.87439998f,0.79720001f,-0.00340000f,-0.14500000f,0.41019998f,0.45009999f,-0.61670001f,-0.73990003f,-0.11470000f,-0.24509999f,0.22050000f,-0.61219997f,-0.09100000f,-0.02300001f,-0.41369999f,-0.49180000f,-0.35060003f,0.59409999f,-0.62760002f,0.13559995f,0.18689998f,0.29230001f,0.80630002f,0.44340000f,0.05090000f,-0.39710000f,-0.31830000f,0.39940001f,0.45320000f,0.34900001f,-0.10780000f,0.77980001f,0.48059999f,-0.55950001f,0.62179999f,0.31979999f,-0.48299999f,0.65450001f,0.35279998f,-0.54780001f,-0.67830002f,-0.11739999f,0.79810001f,-0.77379997f,-0.64199998f,0.29459999f,-0.41530000f,-0.21660000f,0.20370000f,0.70970001f,0.26380000f,-0.51010001f,1.36569999f,0.99120000f,-0.60299999f,-0.20000000f,-0.08880000f,0.08610000f,0.69250003f,0.14340001f,-0.63930001f,-0.09689999f,-0.39620002f,-0.33070001f,0.25109999f,0.41180000f,0.16600000f,-0.14840002f,0.19040000f,0.33070000f,-0.59600003f,0.89470003f,-0.20330000f,0.67509999f,0.58310002f,-0.18529998f,-0.42699999f,-1.42700003f,-0.01150000f,-0.10969999f,-0.77050000f,-0.06179998f,-0.49909997f,-1.40590000f,-0.44289999f,0.18689998f,0.90330001f,0.48819997f,-0.07100000f,0.68179998f,-0.02170000f,-0.69529998f,-0.67090001f,0.23489999f,0.90849997f,0.73370000f,-0.55699999f,0.63769998f,-0.38749999f,-0.05019999f,-0.53109997f,-0.62869999f,0.45109996f,0.80029998f,0.60310000f,0.68329999f,-0.08430000f,0.02490000f,-0.55169997f,0.23639999f,0.07200000f,-0.55179997f,-0.54249999f,-0.74090000f,-0.62959997f,-0.60200001f,-0.75840002f,-0.64380002f,0.19560000f,-0.02239999f,0.29180003f,0.45039999f,-0.48990001f,0.11780003f,0.79690001f,0.16610000f,0.23700001f,0.09900001f,-0.87270001f,-0.50720000f,0.46250001f,0.79710001f,0.37720000f,-0.56380000f,-0.81509998f,-0.56799998f,0.43449999f,1.30270001f,0.94079999f,-0.61170001f,-0.55209999f,-0.30319999f,0.32299999f,0.02520002f,-0.32720001f,-0.40990000f,-1.39610002f,-0.98800002f,0.61240001f,-0.04840001f,0.06600000f,0.22110000f,0.55639999f,0.65000002f,0.08440001f,0.21319999f,0.31539999f,-0.01900000f,-0.86460002f,-0.61950002f,0.48390000f,-0.57989999f,-0.11669999f,-0.57269999f,0.60829999f,0.90670000f,-0.72369999f,0.08130000f,0.53370000f,-0.28590000f,0.35019999f,0.35300001f,0.08600000f,-0.84119998f,-0.44400000f,0.07839999f,0.47370000f,-0.03389998f,0.30039998f,-0.06120000f,0.71999998f,-0.53159997f,0.40040000f,-0.68959999f,0.02260000f,-0.46249998f,-0.17650001f,0.67139997f,-0.04830000f,-0.03870001f,0.50939999f,-0.86829997f,0.05770003f,-0.15440000f,0.54729997f,0.87530000f,-0.69859999f,0.60819998f,0.33620000f,-0.43769997f,-0.60649999f,-1.17850002f,0.01800000f,-0.14060000f,0.81330003f,0.71260003f,-0.14680000f,0.03539998f,0.41440002f,0.49640000f,0.58520001f,0.58680003f,0.01320001f,-0.68220001f,-0.25079998f,0.67620000f,-1.34210002f,-0.91280001f,0.63950000f,0.43159999f,0.22039999f,-0.31069999f,-0.30749999f,-0.01239998f,0.49629999f,-0.26290002f,0.03259999f,0.27940000f,-0.28109999f,-0.47340002f,-0.25500001f,-1.22690001f,-0.78640000f,0.66159999f,0.37260000f,0.03039999f,-0.41679999f,0.25859998f,0.38460000f,0.18990000f,-0.81679999f,-0.53799998f,0.52600000f,1.03910002f,0.68239999f,-0.61220002f,1.21210000f,-0.31030000f,-0.55130000f,0.87420001f,0.51060004f,-0.76199998f,0.50579998f,0.67620000f,-0.53260001f,0.86380000f,0.71660004f,-0.17540000f,0.34259998f,1.17060000f,0.41920000f,-0.77440001f,0.14199997f,0.00320000f,0.09910000f,-0.26409999f,-0.25460000f,0.67319997f,1.31039999f,-0.36249997f,-0.71299997f,-0.87579999f,0.62529999f,-0.63179999f,-0.64500002f,0.29500000f,-0.55630001f,0.35529996f,0.32919998f,0.29700000f,0.12660002f,-0.47049998f,0.66599996f,0.73320000f,0.25619998f,0.30739998f,1.28499999f,-0.30379997f,0.00310001f,-1.02610002f,-0.29289999f,0.48809998f,-0.22589999f,-0.26960001f,-0.11170000f,-0.43000004f,0.10580001f,0.78610001f,0.05290000f,-0.28660001f,-0.44149999f,0.19100001f,-0.00880000f,-0.17990000f,-0.40030000f,-0.02999998f,0.51990000f,0.93189998f,0.65219999f,-0.47819998f,0.66369999f,0.70500000f,-0.00270000f,0.97880000f,0.81720000f,-0.30060000f,0.86540000f,0.33479999f,-0.67529999f,-0.79439998f,-0.60519999f,0.31539999f,-0.37960000f,-0.41040002f,0.00479999f,-0.46860000f,-0.01599998f,0.63249999f,0.13310002f,-0.18520001f,-0.37400001f,-1.33209999f,-1.02580001f,0.50379998f,0.23879998f,0.63429997f,0.27320000f,-0.71939997f,-0.86460001f,-0.61429997f,0.62979998f,1.32980004f,0.60649997f,-0.31809998f,-0.48649999f,0.23579999f,0.55990000f,0.69830004f,-0.33780000f,0.14080000f,0.57320000f,-0.34429998f,0.17240000f,-0.66559999f,-0.70129996f,0.56569998f,0.16690001f,-0.60739997f,0.53080000f,-0.18279998f,0.23959998f,0.65469997f,0.19310000f,0.37979998f,-0.39120000f,0.19919996f,0.41880000f,-0.24800000f,0.02240000f,-0.43259999f,0.18029999f,0.69149999f,0.50480000f,0.07990000f,0.03950000f,0.65470000f,-0.74059997f,0.20540000f,-0.24119996f,-0.31090000f,-0.05300001f,0.27440002f,0.46720002f,1.12950001f,0.64279999f,-0.67130000f,0.53649999f,0.56960000f,-0.02300000f,0.69080001f,0.15259999f,-0.63470001f,0.25050001f,-0.29660004f,-0.73690001f,-0.44570000f,-0.39700001f,0.04480000f,-1.38610001f,-1.02340001f,0.56140000f,-0.65629999f,-0.73300001f,-0.07970000f,-0.26440000f,0.31720003f,0.82219999f,-0.30070001f,0.10980002f,0.60330000f,-0.14350000f,-0.18900002f,-0.10140001f,-0.84290001f,-0.41760000f,0.54240000f,-0.19800002f,0.13160001f,0.39160001f,-0.86910000f,-0.53340000f,0.44699999f,1.20879999f,0.60330001f,-0.57040000f,0.57980001f,0.89260006f,-0.10180000f,0.70739997f,-0.01140000f,-0.57259997f,0.32090001f,-0.07549997f,0.42869999f,0.74679998f,0.52040002f,0.81909999f,-0.45929999f,-0.87570001f,0.30630000f,-0.66759999f,-0.56960002f,0.59030000f,-0.85339998f,0.07820000f,0.75169998f,-0.83829997f,-0.58910000f,-0.86059998f,0.74919997f,1.33159999f,-0.49649999f,0.52809999f,1.05890003f,0.20550001f,-0.52640000f,-0.65320003f,-0.05579999f,-0.71830000f,-0.29630004f,-0.46659999f,-0.13500000f,-0.05820000f,0.14730001f,-0.71579999f,-0.24900002f,-0.51369997f,0.32660000f,0.20090002f,-0.13400000f,-0.28990001f,-0.42040001f,0.03620001f,0.55960000f,0.32049999f,0.44040001f,0.06660000f,-0.04540000f,-0.05099999f,0.12660001f,0.04070001f,-0.17740001f,-0.29150000f,0.30220000f,-0.06960002f,-0.42780000f,-0.49960000f,-0.63540002f,-0.16200000f,-0.99010002f,-0.62480000f,0.52730001f,-0.78520001f,-0.22959999f,0.69879999f,-0.03110000f,-0.15780002f,-0.24630000f,0.66660002f,0.55000000f,-0.31900002f,0.37369999f,0.35819999f,-0.21000001f,-0.51500001f,-0.06199999f,0.52880000f,-0.38730001f,-0.36280001f,0.05980000f,-1.21250003f,-0.15870001f,0.50739998f,0.85539999f,1.16780004f,-0.50809999f,-0.26990000f,-0.05470001f,-0.55039998f,-0.02530000f,-0.39770000f,0.09309998f,0.82329997f,1.31930002f,0.38110000f,-0.24769999f,-0.38650000f,0.45880000f,0.35120000f,0.28960003f,0.72129997f,-0.73130001f,-0.57850005f,0.21319999f,-0.56659999f,0.10340000f,-0.36359998f,-0.57800000f,-0.16360003f,0.24770000f,-0.72970000f,-1.07090004f,-0.43339997f,-0.34979999f,-1.22100003f,-0.36849997f,-0.77780001f,-1.59100007f,-0.42299997f,-0.57519998f,-0.42560000f,0.31400000f,-0.30750000f,-0.07110000f,0.36329998f,-0.10580000f,-0.61710000f,-0.33240000f,0.37950000f,-0.34310001f,0.00499999f,0.34059999f,0.33669999f,0.01499997f,-0.53939999f,0.06930001f,0.31920003f,0.35310000f,-0.52680001f,-0.26999999f,0.44400001f,1.18579998f,0.93019999f,-0.44329999f,0.72489999f,0.32279998f,-0.56099998f,-0.01710002f,0.36620002f,0.46990001f,-0.84090002f,-0.78580003f,0.12520000f,-0.63040002f,-0.25000001f,0.44260000f,0.15260000f,0.08559999f,-0.20230000f,0.28200000f,-0.10140002f,-0.46140000f,-0.44060000f,0.10720003f,0.75590000f,0.10230001f,0.19380003f,0.17490000f,0.70810000f,-0.24490001f,0.01580000f,-0.44279998f,-0.08400000f,-0.39309996f,-0.80859999f,-0.94820003f,0.27670000f,-0.72099997f,-1.41020000f,-0.53640000f,0.56699999f,0.75780000f,0.01819999f,0.31739998f,0.99900000f,-0.62089997f,0.56559998f,-0.33039999f,0.10360000f,0.26150000f,-0.28849998f,-0.73229999f,0.22649999f,0.29970000f,0.67590000f,-0.71280001f,-0.22440003f,-0.17539998f,-0.75920000f,-0.57520004f,-0.04499999f,-0.63769999f,-1.13290003f,0.49390000f,0.18750000f,0.06030002f,-0.64180000f,0.32449999f,0.86770000f,-0.25250001f,0.61470001f,0.82470005f,0.24279997f,-0.68360000f,1.25820000f,0.99320002f,-0.42379999f,0.04770000f,-0.03780001f,-0.04560000f,-0.44849995f,-0.39259996f,0.25399998f,-0.55950002f,-0.24240000f,0.46260001f,-0.65650001f,-0.35619999f,0.57010000f,-0.61700002f,-0.49880000f,0.34610002f,1.43170001f,1.02240000f,-0.61950001f,0.36650002f,-0.02919999f,-0.43970000f,-0.61059999f,-0.44740000f,0.26439999f,-0.04540000f,0.03420001f,0.12330000f,-0.39970002f,-0.19600000f,0.40420001f,-1.43790003f,-0.97620002f,0.67620002f,-0.39390002f,-0.06820000f,0.38320000f,0.59460000f,0.64420002f,0.05150001f,-0.68260000f,-1.14730001f,-0.65900000f,0.86340000f,0.05460004f,0.14150000f,0.40259998f,0.58620001f,0.35609996f,0.66660001f,1.49100002f,-0.08660000f,-0.05550000f,0.44730001f,0.07369999f,0.65529998f,1.64930003f,0.39279997f,0.58489996f,1.53130002f,-0.54119997f,0.87800002f,-0.07999995f,0.45219997f,0.53800000f,0.51440002f,0.25730000f,-0.28789999f,0.16969999f,-0.10610000f,0.16180000f,0.28340000f,0.01379999f,0.62229998f,1.34510003f,0.44229999f,-0.90240000f,0.03959999f,-0.28169998f,-0.42540000f,-0.29940002f,-0.64110000f,0.77099998f,0.55500001f,0.47539998f,0.47240001f,0.06370000f,-0.11660002f,-0.30760001f,0.12720001f,-0.24060002f,-0.43290000f,0.24179999f,0.22339999f,-0.09710000f,-0.16850001f,-0.20779999f,0.06680001f,0.83580001f,0.71560002f,-0.18069999f,0.67289999f,0.59480001f,-0.11209999f,0.63460003f,0.29000001f,-0.42200001f,0.51110000f,0.18539999f,-0.45600000f,-0.16700002f,0.10000000f,0.20270001f,-0.91810001f,-0.43579999f,0.70130001f,1.18580001f,0.59140000f,-0.78100000f,0.28300000f,0.01480000f,-0.32349999f,-0.76290003f,-0.11219998f,0.85710003f,0.16769999f,0.32600002f,0.26200001f,0.50920000f,-0.22330000f,0.26730000f,-0.60760000f,-0.97280004f,0.60729998f,0.05160000f,0.01080001f,-0.20709999f,-0.18240000f,-0.53280000f,0.26529997f,0.51259997f,0.97539999f,-0.53680001f,0.82530001f,0.41490005f,-0.46539999f,0.74639997f,0.45720001f,0.09459999f,0.63320002f,0.37000004f,0.15270000f,0.09880000f,-0.32799999f,-0.40699999f,-0.88030001f,-1.22990007f,-0.07130000f,-0.19010000f,0.58790000f,0.06389999f,0.86169999f,0.18650003f,0.26719998f,0.24170000f,0.12250002f,-0.55670000f,-0.20850000f,0.36630001f,-0.44080000f,0.78090000f,1.00050005f,-0.04129999f,0.35630001f,-0.15510000f,0.04060001f,0.33110000f,0.69850002f,0.33340000f,-0.49390001f,-0.89290001f,-0.60020001f,0.37280000f,-0.18199999f,-0.36300001f,-0.19050000f,0.50250004f,-0.09560000f,-0.80440002f,0.98630002f,0.26699999f,-0.88500001f,0.40150000f,0.06019998f,-0.57529999f,-0.72389999f,-0.20659998f,0.69889999f,0.03370000f,0.10060000f,0.08960000f,0.67990001f,0.43160001f,-0.29300001f,-0.67410002f,-0.28559999f,0.60750002f,-0.23050000f,-0.34700002f,-0.16150000f,0.02839998f,-0.24440003f,-0.40179999f,0.37430001f,0.02119999f,-0.42140000f,-0.55500000f,0.02889996f,-0.21270000f,0.52529998f,0.93930000f,0.06210000f,0.39469999f,-0.06170000f,0.24630000f,-0.91880000f,-0.52960004f,0.52849998f,-0.15400000f,-0.01400001f,0.68759997f,-0.18629998f,-0.71070002f,0.50429998f,0.83859998f,0.38300001f,0.25230000f,-0.72549996f,-1.48189999f,-0.33029999f,-0.20730000f,0.35069998f,-0.15890000f,0.13940000f,0.16780001f,-0.13120000f,0.82969997f,0.60849999f,-0.10400001f,0.21840000f,0.97800004f,0.43150000f,-0.51050001f,-0.52450004f,0.48580000f,-0.58760001f,-0.88840004f,0.35159999f,0.35050000f,0.20930002f,-0.07650000f,0.18240000f,0.77329999f,0.41699999f,-0.45209998f,0.48480002f,0.19559999f,-0.48720002f,-1.11470000f,-0.79220000f,0.49550000f,-0.17890001f,0.10000000f,0.32509999f,0.10230000f,0.16480000f,0.07370000f,0.67130002f,0.43960000f,-0.49180000f,-0.60109999f,-0.43840000f,0.32319999f,0.66940000f,0.74800003f,0.07790001f,-0.69430000f,-0.06059998f,0.76859999f,-0.48549997f,-0.32759998f,0.33269998f,0.25400000f,0.05800000f,-0.14260000f,-0.02430000f,0.07920000f,0.06090000f,0.32390001f,0.52480002f,0.28729999f,-0.04690000f,0.09619999f,0.07539999f,0.82919997f,0.61820000f,-0.01370001f,0.70750000f,0.34070005f,0.08220001f,-0.41820001f,-1.10460006f,0.41649999f,-0.62469998f,0.15250000f,-0.38639997f,-0.17120000f,-0.12520001f,-0.21599999f,0.15900000f,0.12660000f,-0.22279999f,-0.62929996f,-1.63690001f,0.26779999f,0.11990000f,0.78910001f,-0.76860000f,0.82969998f,0.56170000f,-0.60669997f,-0.57740000f,-0.27220005f,0.17659998f,0.37479999f,1.06159999f,0.18099999f,0.86439997f,1.10120001f,-0.19999998f,-0.40439998f,-0.61680000f,-0.67439998f,0.83979999f,0.91940003f,-0.26709997f,-0.63559997f,-0.95680000f,-0.60279997f,-0.19769999f,1.04350002f,0.84200002f,-0.32510000f,1.40719999f,1.04440000f,-0.56439999f,-0.20540002f,0.09460001f,0.46190002f,0.19730001f,0.00200000f,-0.23480000f,0.96830002f,0.70460001f,-0.42470001f,0.78549999f,0.42959999f,-0.59219999f,0.72990004f,0.14420001f,-0.68990001f,0.05780000f,0.19200001f,0.11640000f,-0.27470000f,-0.19620000f,0.10770000f,0.27069998f,-0.14240004f,-0.59109999f,0.73860001f,0.46140000f,-0.42660000f,-0.60750003f,-0.20140002f,0.45219999f,0.50330003f,0.01699999f,-0.52820001f,-0.90260001f,-0.63740001f,0.40940000f,0.19099999f,0.17290005f,-0.58099999f,0.75439999f,0.10120001f,-0.61019998f,0.86259997f,-0.08620000f,-0.36950000f,0.54499999f,1.00420004f,0.20279999f,0.16930000f,0.08810000f,-0.39829999f,0.45730000f,-0.26710000f,-0.06860000f,-0.21129999f,-1.09010000f,0.48669997f,0.78870000f,0.55230002f,-0.32920000f,-0.15499999f,-0.32380001f,0.10049999f,-0.24249999f,-0.09889999f,0.53359999f,-0.46780000f,-0.93380001f,-0.15830000f,0.23669999f,-0.36330001f,-0.25309996f,-0.85740001f,-0.75540005f,0.51129999f,0.81340001f,0.81140005f,0.33029999f,-0.48190000f,0.15969998f,0.49280000f,-0.15050000f,-0.62030002f,-0.58300002f,0.12940001f,-0.82020002f,-0.40980000f,0.57480001f,-0.58190000f,-0.37640000f,0.27170000f,0.70810000f,0.38619998f,-0.60820000f,-0.39210001f,-0.19140000f,0.28470000f,0.73770001f,0.18199998f,-0.74420001f,-0.52650002f,0.08580001f,0.82230000f,-0.46230001f,-0.16419999f,0.45220001f,0.24580001f,-0.07140001f,-0.36389999f,-1.12139999f,-0.84100001f,0.41889998f,0.62959998f,0.46039999f,-0.30739998f,0.96030001f,0.85000002f,-0.21010000f,-0.46019999f,-0.01799998f,0.53069999f,-0.20720000f,-0.07240000f,0.20620000f,-0.02420000f,0.10980001f,-0.08710001f,0.05030002f,-0.09930000f,-1.38269996f,0.82669999f,0.23470000f,-0.90559999f,1.36659999f,0.58740000f,0.47849999f,-0.91550001f,-0.29120000f,0.88300000f,-0.87200000f,-0.37560000f,0.34770001f,-0.61590003f,0.02110000f,-0.28409999f,1.08670001f,0.27480000f,0.58859999f,0.46379997f,0.29859999f,0.32060000f,-0.56040000f,-0.17730000f,0.43010000f,-0.08290002f,0.04950000f,-1.01929997f,0.78209998f,0.23110000f,-0.39839999f,-0.57139998f,-0.53290001f,0.22890000f,0.61530001f,0.25530001f,0.03180002f,-0.15879999f,-0.30540001f,-0.35689997f,0.84619999f,-0.12740000f,-0.01400000f,0.49349998f,0.21979999f,-0.16699999f,0.09670000f,-0.58280001f,-0.53740003f,0.63739997f,-0.27180001f,0.15980000f,0.04210001f,-0.60279999f,0.84519999f,1.51539998f,0.01400000f,-0.19600000f,-0.55459998f,-0.23280001f,0.22680001f,0.44400002f,-0.18240000f,-0.00600000f,0.11920000f,0.63660001f,0.00320001f,-0.18730002f,0.41660000f,0.00740001f,-0.76569999f,-0.20600000f,0.49200000f,0.51300001f,0.12620001f,-0.28340000f,0.16749998f,0.55080001f,0.01020002f,-0.55619999f,-0.70340000f,0.32059999f,0.73510000f,-0.65900002f,0.14929999f,0.59430000f,-0.15470000f,-0.11760000f,0.24980002f,0.21159999f,-0.06440000f,0.63370000f,-1.18629999f,-0.62860002f,-0.08980001f,-0.28120001f,0.02440000f,1.62199998f,-0.14960002f,0.18520000f,-0.70319998f,-0.16759998f,-0.05019999f,0.45150001f,-0.14130001f,0.02370000f,0.07320000f,-0.26200000f,-0.07420000f,0.04879999f,0.92139999f,0.21390000f,-0.81840000f,0.55140000f,0.23620000f,0.52400000f,0.09399998f,0.20300000f,0.31340000f,-0.00319999f,-0.18140000f,-0.47939999f,0.76860001f,0.24690001f,0.60579998f,-0.74040000f,-0.09060000f,0.92399999f,0.29259999f,-0.75939999f,0.01639997f,0.98589996f,0.06220000f,0.64259999f,0.18430001f,0.23800001f,-0.34520002f,-0.60100001f,-0.42300002f,0.64300000f,0.30770005f,0.40440001f,0.56920002f,-0.40619996f,-0.10820001f,0.07920000f,-0.45849996f,0.44519999f,-0.31159999f,-0.51819999f,-0.38100000f,-0.32980000f,0.54229999f,0.45100001f,-0.18340000f,-0.36330002f,0.46360000f,0.43320001f,-0.04899998f,0.39980001f,0.20840002f,0.13070001f,0.22459998f,-0.92720001f,-0.41490000f,0.27460000f,-0.40460000f,-0.73590000f,-0.65080002f,-0.09700001f,0.48180000f,0.41780002f,-0.18790001f,0.94679997f,-1.01899999f,-0.35110001f,0.19699998f,0.56759995f,0.43119999f,-0.64260001f,0.05060001f,-0.08060001f,0.13390002f,-0.13430003f,0.27290000f,-0.41509999f,0.96689998f,0.56530001f,-0.66549999f,-0.14170001f,0.08880000f,-0.44059998f,0.38620000f,-0.00940000f,0.57770001f,-0.74929998f,-0.41430000f,-0.24830000f,0.49990001f,0.05770000f,0.10040001f,0.98719997f,0.43799999f,0.33450002f,0.74790000f,0.23980000f,-0.33459996f,-0.36999999f,-0.50950001f,-0.79680000f,0.05020002f,-0.09119999f,0.34470000f,-0.98410001f,-0.32460000f,-0.94410004f,-0.95460004f,0.04500000f,0.25940000f,-0.33029998f,-0.65660002f,0.65880000f,1.35250001f,-0.51220000f,0.36180000f,0.79189999f,-0.66320001f,0.50619999f,1.30159998f,0.85660002f,-0.03220000f,-0.92410000f,0.27239999f,-0.79719998f,-0.75579999f,0.05180001f,-0.04859999f,0.40549998f,-0.31820002f,-0.01940000f,-0.36269996f,-0.45679999f,1.04220000f,0.69760003f,-0.03000000f,0.05260000f,0.43539997f,-0.47700002f,-0.18379998f,-0.25969996f,-0.36620002f,-0.59860002f,-0.03230002f,0.23100000f,0.53759999f,0.00470002f,0.22440001f,0.49780000f,0.52739998f,0.78160002f,-0.32730001f,-0.44590001f,0.22349999f,0.23810000f,1.40360000f,-0.37620004f,0.06549999f,0.76509999f,-0.42510000f,-0.01509999f,1.35119998f,-0.49960003f,-0.03350001f,-0.81799999f,1.15580000f,0.35960000f,-0.77799997f,-0.23599996f,-0.35759999f,0.56560000f,0.07620001f,-0.07660000f,-0.62519998f,-0.51260000f,-0.05340000f,0.58639999f,0.13559998f,0.48010000f,0.55509998f,0.03110000f,-0.03540000f,-0.54379998f,-0.85479997f,-0.22679998f,-0.14300000f,-0.96959999f,-0.51120001f,0.05070000f,0.72489996f,0.43419999f,0.74289998f,0.73169997f,0.32979999f,-0.26410001f,0.81650004f,0.05940000f,-0.67380003f,-0.12150005f,0.60140000f,0.32900002f,-0.73529996f,0.83740002f,0.32300002f,-0.58329999f,0.18340001f,0.24760001f,-0.23589998f,0.27880002f,-0.34720000f,0.09339996f,-0.46600000f,0.25180000f,0.26500001f,0.41959999f,-0.66559998f,-0.80259999f,-0.51880001f,1.03999999f,0.91780002f,0.22319999f,-0.20859999f,-0.02400001f,-0.43800001f,-0.53220000f,0.05379999f,0.41600002f,-0.96820002f,-0.44760008f,0.34800000f,-0.01780000f,-0.70839997f,0.23400001f,0.73880002f,-0.11659996f,-0.14540000f,0.60820000f,0.98249999f,0.54000002f,0.28450000f,-0.05370002f,-0.40589999f,-0.42630001f,-0.72989998f,1.05589998f,0.50550000f,-0.41839999f,1.41140000f,0.54800001f,-0.25529999f,0.42650000f,0.25660001f,0.29409999f,0.16890002f,-0.17010000f,0.10339998f,-0.48140000f,-0.00109999f,-0.78669997f,0.07050002f,-0.21809999f,0.84869998f,0.06189994f,0.42889999f,0.09680001f,0.17640000f,-0.07450000f,-0.07049999f,-1.02009997f,-0.49899999f,-0.28380004f,-0.12099996f,-0.47730001f,-0.77169998f,0.43750000f,0.19080000f,-0.13179999f,0.86299998f,0.59020001f,1.15889999f,0.30669997f,0.23249999f,-0.47010000f,0.29019999f,0.05660000f,0.69400002f,-0.17449997f,0.62880001f,0.53880001f,-0.54079997f,0.21560001f,0.56040002f,-0.40419997f,0.76280001f,-0.29000000f,-1.12979998f,0.46600001f,-0.88560001f,-0.50020003f,-0.29199999f,0.20339999f,0.33639999f,0.65599999f,-0.09919999f,-1.13079995f,0.13100001f,0.31799999f,0.60429997f,-0.41020001f,-0.52760001f,0.44009998f,0.53919999f,-0.76980000f,-0.63720000f,-0.36160000f,-0.14120001f,0.01839999f,0.34900000f,0.37999999f,-0.51269996f,0.59480000f,-0.71079999f,-1.24979999f,-0.61200003f,0.79939999f,1.11040003f,-0.40500001f,-0.02550000f,-0.28570001f,0.56529999f,0.51640002f,-0.48479999f,1.26319997f,0.62900000f,-0.49940001f,0.68340001f,0.50420002f,-1.10319998f,0.81560000f,0.18560000f,-0.33969998f,0.00710002f,-0.39870001f,0.28449999f,-0.25430000f,0.00600000f,-1.17669997f,0.79529998f,0.28530000f,0.82209997f,0.47229997f,0.16859999f,0.45230000f,-0.94269998f,-0.54340000f,-0.50019997f,0.18580000f,-0.27850001f,-0.12760001f,-0.63079998f,-0.20420000f,-0.55939998f,0.74079997f,0.43509999f,-1.29059997f,0.25700003f,-0.13380000f,1.08800000f,-0.23080007f,0.20949999f,0.05380001f,-0.77599999f,-0.27800000f,-0.18760000f,0.62139997f,0.94620002f,0.14359998f,-1.19090000f,-0.52860000f,-0.40460000f,0.41369997f,-0.06200000f,-0.21740001f,-0.48860001f,0.56320001f,0.03760002f,-0.57879999f,-0.43819999f,0.73919999f,0.79330000f,0.13660000f,0.80699999f,0.04870003f,-0.17400000f,0.90319999f,0.42020002f,-0.54160000f,0.11460000f,0.11000003f,0.22439999f,-0.64799998f,-0.38379999f,-0.05840001f,-0.49280002f,-0.12040002f,0.68760000f,0.07140001f,-0.69459998f,-0.37000002f,-0.36540001f,0.02020000f,0.33179999f,-1.08280001f,-0.54170004f,-0.26880000f,-0.27280000f,0.71349999f,-0.48930000f,-0.29850000f,-1.14940001f,1.39039998f,0.54429999f,0.34779998f,-1.03079996f,-0.48979999f,-0.64890002f,-0.28889999f,-0.09640000f,-0.50669999f,0.80450000f,0.27250001f,0.75709998f,-0.04590002f,0.26440000f,0.03320000f,0.78299995f,0.58479999f,0.36799998f,0.42759995f,0.50699999f,-0.12049999f,-0.70409998f,-0.09459999f,-0.32639997f,-0.16759998f,-0.32300000f,-0.12840000f,-0.44920000f,-0.33680001f,-0.60569998f,1.00149998f,0.34840000f,-0.10280000f,-0.80360001f,-0.36030001f,-0.43390000f,-0.33489999f,-0.56660001f,1.09109999f,-0.36349998f,0.61200003f,0.31720001f,-0.73320001f,-0.51920001f,0.52520000f,0.34160004f,0.05920001f,0.68699999f,0.20520000f,-0.48380002f,-0.15440002f,-0.19549998f,-0.86260002f,-0.44540002f,0.78429998f,-0.10900000f,-0.34240000f,0.32429998f,0.36620000f,-1.03320002f,-0.45890006f,-0.28140000f,-0.78500000f,0.28769995f,1.01400000f,0.40880002f,-1.14899994f,0.73660001f,0.13660000f,-0.93609999f,-0.22340001f,-0.13040001f,0.47750000f,0.38960000f,-0.24099999f,-0.01760001f,0.37480002f,0.31160001f,-0.02380000f,0.28980000f,-0.42360000f,-0.05790002f,-0.43980000f,-0.10780000f,-0.72080004f,1.06320001f,0.50020001f,0.14770001f,-0.35710002f,0.15950000f,0.21799997f,0.59679997f,0.45770000f,-0.46560000f,-0.83820001f,-0.21790001f,0.68659999f,-1.51880000f,-0.66800001f,0.41790000f,-0.37749999f,-0.31260000f,-0.31430001f,-0.24169998f,-0.53460001f,0.34119999f,-0.95099997f,-0.66020000f,-1.09359996f,1.68359996f,0.73939999f,-0.90960001f,1.09939999f,0.44200000f,0.54210001f,-0.38050001f,-0.22280001f,0.18660002f,0.39820000f,-0.04930000f,0.10660000f,0.77180000f,0.32540000f,0.10830001f,0.11730000f,-0.19740001f,0.69009997f,0.09520001f,-0.11280001f,-0.50200002f,-0.84960000f,0.51540001f,0.25820001f,-0.09349999f,0.07240001f,0.63060001f,0.39580001f,0.30900000f,-0.28179999f,-1.05189998f,-0.35700001f,-0.23980001f,0.32589998f,-0.36320001f,-0.29760003f,-0.12800002f,-0.34020001f,-0.70060000f,0.32509999f,0.40280002f,-0.57480000f,-0.37020004f,0.58480000f,0.01360001f,-0.11240000f,-0.41580001f,-0.06140000f,0.84129999f,-0.39160002f,0.78760001f,1.15060002f,-0.37780001f,0.67320001f,1.35710002f,0.41480001f,0.20480000f,0.17299998f,-0.01400000f,-0.39700001f,-0.05140002f,0.55220003f,0.37290001f,-1.11610001f,-0.59849999f,-0.25390000f,0.08630001f,0.93409999f,0.33970000f,0.48260000f,0.59219998f,0.39550000f,-1.21269999f,0.16150003f,0.04830001f,0.29239999f,-0.66820000f,-0.31460000f,-0.30340002f,-0.75780000f,-0.29060001f,0.35330003f,-0.97369996f,-0.62490000f,-0.23390001f,0.14810004f,-0.22310000f,0.12240002f,0.85919999f,0.19520000f,0.92500002f,-0.58240001f,-0.28380001f,1.24520001f,0.08799995f,0.25959999f,1.53790003f,0.04409996f,0.15559999f,0.39779999f,0.77099998f,0.23559999f,-0.02780000f,-0.30939999f,-0.26830000f,-0.72719999f,0.21820000f,0.28480001f,-0.24160000f,-0.11640002f,0.17220000f,0.32199999f,0.63689999f,-0.71059999f,0.10679999f,1.21869995f,0.49320000f,0.35640003f,-0.58979996f,0.51880001f,-0.36280000f,-0.94379999f,-0.31020000f,1.01599999f,0.59770003f,-0.51079999f,0.23939999f,0.44499999f,0.53940002f,0.54780002f,-0.25869998f,-0.04500001f,-0.84720003f,-0.05650003f,0.28200000f,-0.02080000f,0.26259999f,-0.34520001f,0.25780000f,0.93779999f,-0.43420001f,-0.30140003f,0.04769998f,0.84840001f,0.22780002f,-0.83019997f,0.31820001f,0.12820001f,-0.62610000f,-0.35959998f,-0.04890000f,0.00730000f,0.23530001f,-0.06590000f,0.88390000f,0.53849996f,0.17859998f,1.26649997f,-0.86249999f,-0.30860000f,-0.59129998f,0.92909999f,0.47190001f,-0.96259999f,0.42100002f,0.03820000f,0.52579999f,0.32359996f,0.51909999f,0.32179998f,-0.54059999f,-0.04850000f,-0.15479999f,1.16259999f,0.56860001f,0.00390001f,-0.67790000f,-0.58460002f,0.48080001f,0.42199998f,0.02979999f,1.04790000f,-0.24170002f,-0.05880000f,-0.10390002f,-0.84970000f,-0.33910001f,-0.72829998f,1.33810000f,0.52160001f,-0.69400002f,0.50540001f,0.27020001f,-0.49690004f,1.11009999f,-0.22359999f,1.02040001f,0.31460002f,0.04059999f,-0.18040001f,-0.44489999f,0.39779999f,-0.67799998f,-1.30069998f,0.45680002f,-0.21140000f,-0.52080002f,0.72020001f,-0.55140001f,-1.49390000f,0.47200002f,-0.77940001f,-1.38160000f,-0.42040001f,1.01119999f,0.47500002f,-0.33360001f,-0.29920000f,-0.28640000f,0.19819999f,-0.47220000f,-0.30890001f,0.16260000f,0.02840001f,-0.23949999f,0.54640002f,-0.35900001f,-1.17920000f,0.47420003f,-0.92720001f,-0.44730005f,0.29820001f,0.11880000f,0.11269999f,0.23580001f,0.67560002f,-0.27649996f,-0.11560000f,-0.20210000f,0.19159997f,0.42959999f,0.58800002f,-0.54770000f,-0.10790000f,-0.04760001f,-1.45349998f,-0.01329997f,-0.16119999f,-0.45040001f,0.47480002f,0.06290000f,-1.57340000f,0.53440002f,0.04680000f,-1.51389999f,0.01610006f,-0.19739999f,0.31289996f,0.14769995f,0.50150000f,-0.49870000f,-0.72909997f,-0.26029999f,-0.26029999f,-0.07370000f,-0.22110000f,-0.24400000f,0.23860000f,0.10110000f,-1.26120000f,0.44400002f,0.08270000f,-0.26110000f,-0.00609995f,-0.43240000f,0.27390001f,0.53289999f,0.15160000f,-0.33479999f,0.80659999f,0.57050001f,0.44710003f,0.09870000f,-0.45100001f,-0.05440000f,0.79250000f,-0.43780001f,-0.44720001f,0.04349998f,-0.13460000f,0.33920000f,0.48709999f,0.17620001f,-0.42119999f,-0.81309998f,0.01120001f,0.70460002f,-0.09199999f,0.06160001f,0.57680000f,-0.17199997f,-0.28760001f,0.11760000f,-0.10139999f,-0.44180000f,0.12159999f,0.41389999f,0.01720001f,0.44220002f,0.91100001f,0.66780001f,-0.38380000f,-0.73770002f,-0.59900001f,0.38379999f,0.20610002f,-0.27840000f,-0.12500000f,-0.00640001f,0.83060004f,0.10420002f,-0.52830002f,0.44680002f,0.28220000f,-0.74980000f,-0.65900000f,0.42550000f,0.84330002f,-0.63330001f,-0.28220001f,-0.09400001f,-0.95979998f,-0.43930000f,0.54099999f,0.08719999f,0.12290000f,-0.94269997f,-0.11289996f,-0.11999999f,-0.19910003f,0.51330000f,0.49860002f,-0.26630000f,0.48889998f,0.43730000f,-0.28180002f,-0.34700000f,0.01160001f,0.32669999f,-0.52630000f,-0.10460000f,1.15970003f,0.42049999f,0.17640000f,-0.61840000f,0.64260002f,0.03740000f,-0.05190002f,-0.58730000f,0.05910001f,-0.12350001f,-0.49909998f,-0.16539999f,-0.32320000f,1.24940003f,0.38840001f,-0.81560003f,0.79400000f,0.43070001f,1.53259997f,-0.28540001f,0.45540000f,-0.02100000f,-0.79189997f,-0.41260002f,0.23060000f,0.25730003f,0.16780000f,-0.47360000f,0.15869998f,-0.23700001f,-0.50000001f,-0.03050001f,-0.86760003f,-0.26339999f,0.72580001f,-0.71780002f,-0.08120001f,0.00230003f,-0.74739999f,0.16219999f,1.29389995f,0.66660000f,-0.06299998f,-0.49909999f,0.12460000f,0.11880000f,-0.12610000f,-0.10920002f,0.28540000f,-0.28139995f,0.66440003f,-0.31760000f,-0.97380003f,-0.28500001f,-0.36700001f,0.35550000f,-0.54600000f,-0.25840001f,0.72059999f,-0.35480001f,-0.17060001f,-0.04580001f,0.34740001f,-0.37279999f,-0.83159998f,0.58580000f,0.23180000f,0.12060001f,-0.41880001f,0.00100000f,0.34350001f,-0.07910000f,-0.29820001f,-0.09200000f,-0.70899998f,-0.40650000f,0.58560002f,-1.40079999f,-0.53649999f,-0.32189999f,-1.11250000f,-0.26420000f,1.34219996f,-0.87039999f,-0.29219999f,-0.34139998f,0.89119999f,0.22220000f,-0.12250001f,0.25730000f,0.13560000f,-0.45619998f,0.01979998f,0.20410000f,-0.93970002f,0.66470003f,0.11570001f,0.38000003f,-0.65100000f,-0.38500001f,0.72800001f,-0.92519999f,-0.43900001f,-0.20580001f,-0.64739999f,-0.21310000f,-0.10110000f,-0.58269999f,-0.29939998f,0.26419999f,-0.03970001f,-0.58680003f,0.27960000f,1.01700003f,0.35380000f,-0.79620000f,-0.44110004f,0.29800000f,0.26320000f,0.03660001f,0.11400000f,0.19800000f,-0.07459999f,-0.63240000f,0.67700002f,1.48499999f,0.34800000f,-0.56540001f,-0.79440001f,0.27800001f,0.80780002f,-0.26259995f,0.66020000f,0.26280002f,-0.00549998f,0.41599998f,-0.48479998f,-0.97719997f,0.04439999f,-0.20560001f,-0.78899997f,-0.02440000f,0.24160000f,0.47459998f,0.49000000f,0.54520001f,-0.64499997f,-0.05980000f,0.33599999f,0.73449997f,-0.17839999f,-0.10239999f,-0.22300004f,-0.25399998f,0.09960001f,1.03740003f,-0.57420004f,-0.12540001f,-0.32440000f,-0.08859998f,-0.37860000f,0.15630001f,0.62949997f,0.26129999f,-0.06870000f,0.30289999f,0.17930000f,1.58779998f,-0.31620001f,0.06590001f,-0.82100000f,0.03780001f,-0.17150000f,-0.31229998f,0.96449999f,0.67120001f,0.26950003f,1.15769997f,0.37219999f,-1.04029997f,0.17970001f,-0.07030000f,-0.99759998f,-0.14999999f,-0.01420000f,0.58729998f,0.17809998f,0.08989999f,-0.68790001f,1.05489997f,0.60810000f,0.90309997f,0.21609996f,0.10679999f,0.62319997f,0.13960001f,-0.14960001f,0.86640002f,0.21600005f,-0.36680000f,1.05879999f,0.47100005f,0.59500003f,0.07800000f,-0.86170001f,-0.20360001f,-0.10100000f,-0.00619999f,-0.31980001f,0.74060001f,0.48850003f,-0.64399999f,0.51780000f,1.09119999f,-0.53140002f,-0.19100000f,-0.20769998f,0.08960001f,0.33720002f,0.26480001f,0.05300001f,-0.17500000f,-0.00110002f,-0.71160000f,-0.19640002f,0.82939997f,-0.37540001f,0.46900001f,0.50190002f,0.27140000f,0.07719998f,0.40969999f,-0.36300002f,-0.33640002f,-0.47870001f,0.30020000f,-0.64420000f,-0.38590002f,-0.59920000f,0.62720001f,0.11390000f,0.41949997f,0.51830001f,0.32700000f,0.26019996f,0.55020000f,-0.87040002f,0.85580002f,0.35010001f,-0.09120000f,-0.37200000f,-0.12730000f,0.40940000f,0.10279997f,0.34360001f,1.08079998f,-0.48120000f,0.01030001f,-0.49960000f,-0.93539999f,-0.25499999f,0.35200001f,0.39600000f,0.21860001f,0.04379999f,-0.04759999f,-0.10420000f,0.78729999f,-1.11469998f,-0.46030000f,0.43310001f,-0.17230001f,0.13970001f,0.65870002f,0.48929996f,0.07259998f,-0.76210003f,-0.81550000f,-0.26660000f,-0.29429999f,-0.05369998f,-0.29810000f,0.62439996f,-0.84209997f,0.06420000f,-0.70040003f,-0.37230003f,0.50140001f,-0.32740000f,-0.42930001f,0.15680000f,-0.30520000f,0.00680000f,-0.76340002f,0.59040001f,1.57550002f,0.25700001f,-0.15740000f,-0.24390001f,-0.71240002f,0.01699999f,0.50420000f,0.88140002f,0.25979999f,-0.72690001f,0.49260002f,-0.16560000f,-0.66370001f,-0.31100000f,-0.26760001f,-0.11150001f,0.22979999f,-0.82200001f,-0.20590003f,-0.28919999f,0.54319999f,0.59139999f,-0.03840000f,0.91320001f,0.17080002f,0.45440000f,0.21700001f,0.02880000f,0.22760000f,-0.07600000f,-0.31500000f,0.01200000f,1.13500000f,0.14350001f,0.17979999f,0.07870000f,-0.35810000f,-0.52819997f,-0.51809999f,0.26450001f,-0.81639997f,0.05750003f,-0.43520002f,0.31519999f,-0.24320002f,0.08690001f,0.61759999f,0.20989999f,-0.59180002f,-0.18659999f,-0.35800000f,0.85800004f,-0.15280000f,0.58760002f,0.69039999f,-0.18359999f,0.64280000f,-0.24470000f,0.19980000f,-0.12750000f,0.17109999f,0.00700000f,0.21430000f,-0.11130001f,-0.42659998f,-0.26649999f,-0.33430000f,0.63739998f,-0.36510003f,0.66360002f,-0.15180001f,0.54780002f,0.25830003f,0.51640000f,0.16930000f,0.50610000f,-0.44929999f,-0.20580000f,-0.39549999f,-0.41930000f,-0.04060001f,0.04329999f,-0.28330001f,-0.02359998f,-0.73899998f,-0.54680001f,-0.01300000f,-0.16290000f,0.17250001f,-0.85719999f,-1.29859996f,-0.78819999f,0.32159999f,0.37259998f,0.44719999f,-0.23340001f,-0.40980001f,-0.21030001f,-0.01800000f,-0.17320000f,-0.02220000f,-0.04120000f,0.45110000f,-0.15300000f,0.27899999f,0.72529999f,0.52850000f,-0.35200000f,-0.43500000f,-0.17600000f,-0.02020000f,-0.05509999f,-0.35350001f,0.15059999f,0.65399999f,0.25470000f,-0.30499999f,-0.84269998f,-0.20389999f,-0.23339999f,0.62479999f,0.45570001f,0.34159999f,0.44030000f,0.59570001f,0.28639999f,0.47710000f,-0.18139999f,0.88360000f,-0.05500002f,-0.49930002f,-0.19040000f,-0.37830001f,0.87260001f,0.09680000f,0.97300001f,-0.74379999f,-0.19479999f,-0.68459999f,0.14640000f,0.03780000f,0.19860001f,-0.19120000f,0.05320000f,-0.13000000f,0.99730000f,-0.00340001f,0.75049999f,-0.26990001f,-0.46919999f,-0.34090000f,0.26699999f,-0.17799999f,0.31500001f,0.52490003f,0.43639999f,0.42910000f,0.29700001f,-0.29340000f,0.13920001f,-0.38350001f,0.05160000f,-0.16410000f,0.02309999f,-0.39530001f,-0.32159998f,-1.04729996f,-0.55119999f,-0.29499999f,-0.07390000f,0.06790001f,0.34320001f,0.51420000f,0.30880000f,-0.25520001f,-0.40470002f,0.20460000f,-0.06020002f,0.49399998f,0.42990000f,0.21739999f,0.25329998f,0.53830000f,0.25119999f,0.56579998f,0.13319999f,-0.08200000f,-0.56649999f,-0.47040001f,0.13720000f,0.46870000f,0.03520000f,-0.20200001f,0.28179998f,-0.00860000f,-0.20700001f,0.12289999f,-0.24790001f,0.43280000f,0.36709997f,-0.11920003f,0.41820000f,0.62150000f,0.39490000f,-0.06839999f,-0.65780000f,-0.16720000f,0.27420001f,0.42880000f,-0.09910000f,0.53059999f,0.08969999f,0.31129997f,-0.51119997f,0.29989999f,-0.34700000f,-0.02839999f,-0.38700001f,-0.47690001f,-0.52539997f,-0.29729998f,0.15420000f,-0.78779998f,0.07400002f,-0.88190002f,-0.43279998f,-0.76610000f,0.17980001f,0.04040000f,0.04140000f,0.05890003f,0.64579999f,0.12530001f,0.39810001f,0.02180000f,0.24370000f,0.80020000f,-0.37999999f,0.63580001f,0.95770003f,-0.03480000f,0.78110003f,-0.03749997f,0.69700000f,-0.13510000f,-0.46050001f,-0.05680001f,-0.50110001f,-0.59220002f,0.30760000f,-0.38660002f,-0.40330003f,0.35090000f,0.07040000f,0.25090000f,0.41100001f,-0.71200000f,-1.22230000f,-0.68240000f,-0.38359999f,-0.78169998f,-0.34239999f,-0.64019999f,-1.19579998f,-0.69589999f,0.27699999f,1.05529999f,0.43269999f,0.54679999f,0.62299997f,0.24419999f,-0.18980000f,-0.24589999f,-0.44350000f,0.24419999f,0.07909998f,0.51309999f,-0.55540000f,-0.67179999f,0.01690001f,-0.21799999f,-0.30499998f,-0.38519999f,0.27699998f,-0.07550002f,0.42509999f,0.27100001f,-0.18210000f,-0.03590000f,-0.21180000f,0.12969999f,0.10770000f,-0.44839999f,-0.22419998f,-0.41519999f,-0.01240000f,-0.57080003f,-0.41490002f,-0.49259998f,-0.37130000f,0.55429999f,0.15900000f,0.68870000f,0.07330000f,0.09059999f,0.20530001f,0.48639998f,0.27699999f,0.62099998f,0.38290001f,-0.44959998f,0.14270001f,-0.44659998f,0.32959998f,-0.50860000f,0.69010001f,0.35159998f,0.60790000f,-1.15050001f,-0.30759998f,-0.96429999f,-0.03280000f,-0.66059997f,0.13220003f,0.55819999f,0.25239998f,0.51339998f,-1.29910000f,-0.09920000f,-1.06969999f,-0.70330002f,0.51119999f,-0.57990003f,0.40209999f,-0.49719997f,0.33670001f,1.14300000f,-0.08280000f,1.00460000f,0.87480000f,-0.16140000f,0.24960002f,0.09330002f,-0.20700000f,0.12959998f,0.80829997f,0.54139999f,0.01059999f,0.82729999f,0.26590000f,0.00059999f,0.25830000f,0.24070000f,0.00340001f,0.07080002f,-0.38990000f,-0.10780000f,-0.40879999f,0.09830001f,0.49939999f,0.73319997f,0.26929998f,-0.64740000f,-0.85080000f,-0.16569998f,0.02900000f,0.12459999f,-0.18570000f,0.22440000f,-0.27460000f,-0.05280000f,0.42180003f,0.48580004f,-0.20649999f,0.27319999f,0.65119998f,0.49799999f,-0.21520002f,0.21779999f,0.31200000f,-0.62400000f,-0.71469999f,-0.61460000f,0.29280000f,0.18670002f,0.02430000f,0.61379999f,-0.02730003f,0.10289999f,-0.73699998f,-0.03109998f,0.79090002f,-0.57199999f,0.53390003f,-0.00289999f,-0.38359999f,-0.03269998f,0.72980001f,0.48059998f,0.57479999f,-0.57700002f,-0.16540000f,-0.39800000f,-0.23659999f,0.19259999f,-0.34680000f,0.15979996f,-0.51339998f,0.32040000f,0.43440000f,0.24299999f,0.32859999f,-0.73059999f,0.48999998f,-0.58420001f,0.30120000f,0.75579997f,0.12339996f,-0.32119999f,-0.41679997f,-0.37239998f,0.21020001f,-0.78919998f,0.17340004f,1.04670000f,0.05300000f,1.01030001f,0.28760002f,-0.15370000f,-0.13780001f,0.16450000f,0.44270002f,-0.03240001f,0.69799998f,0.42899999f,-0.02000001f,0.39580000f,0.52400002f,0.47239999f,1.13779998f,0.57019999f,0.41180000f,0.54879999f,-0.14570002f,-0.16279999f,-0.36879998f,-0.08439999f,0.43699998f,1.08899995f,0.71089998f,-0.41179999f,-0.32829998f,-0.51909999f,0.03260001f,-0.51849999f,-0.44170000f,0.42740000f,0.68099997f,-0.00050003f,0.10760001f,-0.20119998f,0.11180001f,0.05919999f,0.53169998f,0.48039999f,0.69119999f,1.12059997f,0.59239998f,-0.64780000f,-1.03380001f,-0.40889999f,-0.24380001f,0.11120000f,-0.22030003f,-0.82240000f,-0.17569999f,0.41120000f,-0.80599997f,0.25160003f,-0.21740001f,-0.81720000f,-0.21739998f,-0.06779999f,-0.35359998f,-0.25539999f,0.31540004f,0.64419999f,0.12880000f,-0.12280000f,-0.02800000f,-0.03160000f,-0.30440000f,-0.57179997f,-0.43379999f,1.08889999f,0.13639999f,0.96829998f,-0.12209999f,0.76839998f,-0.04150002f,0.25080002f,0.44300000f,0.05940000f,-0.67600001f,0.08120000f,-0.53240001f,-0.08610000f,-0.68259996f,-0.13969998f,-0.52379998f,-0.04520000f,-0.64939999f,0.27919996f,-0.14899998f,0.43739999f,-0.53670001f,0.19639998f,-0.18379999f,-0.56279998f,-0.53989999f,0.33320000f,1.28430000f,0.72180000f,0.03220001f,-0.55809997f,-0.29969999f,0.31200001f,0.28900000f,0.41380001f,0.15059999f,0.67619999f,0.28210000f,-0.51339999f,-0.73449998f,-0.21829999f,-0.29500000f,0.05929999f,0.23230000f,-0.43840000f,-0.34540000f,0.07680001f,0.02319999f,-0.34760000f,0.22939999f,0.33359999f,0.35379997f,-0.02760002f,0.21840001f,0.03720000f,-0.06680000f,0.17039999f,0.81819998f,0.34379999f,0.17620001f,-0.21280001f,0.01670000f,0.51860002f,0.50249999f,-0.12030000f,-0.54119999f,-0.27600001f,0.36020000f,0.57899997f,0.38039998f,0.15769999f,-0.80179996f,-0.07230000f,-0.41010000f,0.59879997f,-0.26710002f,-0.79780003f,-0.14160000f,-0.71660002f,0.28600001f,-0.33500000f,0.12780001f,0.17749999f,-0.27839999f,0.30170001f,0.24529998f,-0.76079996f,0.23150001f,0.14859996f,-0.65799997f,0.22220000f,-0.93319999f,-0.15239999f,-0.70879998f,-0.02659998f,0.43399998f,-0.11060000f,-0.23000001f,0.40480000f,-0.21960003f,0.36340001f,-0.42639998f,0.17020001f,-0.66340002f,0.30980000f,-0.53080003f,0.01249998f,0.78759998f,-0.12330005f,0.78880000f,0.38429999f,0.13000000f,0.81200002f,0.52860002f,-0.21620001f,-0.47980001f,0.17110000f,-0.31779999f,-0.08819999f,0.06850002f,0.23880001f,-0.12110001f,0.37900000f,-0.06459998f,-0.97789999f,-0.50170000f,-0.02939999f,-0.28189999f,-0.40750000f,0.45700002f,0.46610001f,-0.19750000f,0.15700001f,-0.35769998f,-0.47369999f,0.21919997f,1.29819995f,0.76079998f,0.25620000f,1.00649999f,0.58150000f,-0.14340000f,-0.43710000f,-0.40370001f,0.00179999f,0.20459999f,-0.29410002f,-0.15920000f,0.21620001f,-0.03920000f,0.09660000f,0.17549999f,-0.28170001f,-0.56719999f,-0.75070000f,0.12839998f,-0.72120000f,-0.01120000f,-0.60560001f,-0.40099998f,-0.39699998f,0.32999997f,-0.54219998f,0.31980000f,-1.22410003f,-0.08459998f,-0.99890002f,-0.53830001f,0.83599999f,-0.30650003f,0.28890001f,0.55959998f,0.26829999f,0.19370000f,0.80359998f,0.03469996f,-0.05370000f,0.94919996f,-0.02350003f,0.32100000f,-1.02839995f,0.07300003f,0.10689998f,-0.65599998f,-0.06930000f,0.25570001f,0.42880000f,0.27630000f,0.77840003f,0.31579999f,0.59820001f,0.67420002f,-0.25640000f,0.53660002f,0.54390001f,0.45239999f,0.40049999f,0.10429996f,-0.07190000f,0.58100001f,0.49659999f,0.66810001f,-0.13840001f,0.33330000f,-0.06900001f,-0.39460001f,-0.21040000f,-0.14870000f,0.52519999f,0.85369998f,0.73799999f,-0.01059999f,-0.40709999f,-0.23310000f,0.22520002f,-0.10839999f,0.18700001f,0.12560000f,-0.41050000f,-0.44220002f,0.26860001f,0.43800002f,-0.10330000f,-0.06960001f,0.37479999f,-0.19400001f,-0.29900000f,-0.77690000f,-0.62610001f,-0.70840001f,-0.94820001f,-0.56980000f,-0.77540001f,-1.08230001f,-0.82810002f,-0.22919999f,0.10220001f,-0.29859999f,0.14740001f,0.01640001f,-0.11570000f,0.53820000f,0.59220003f,-1.38240004f,-0.12059999f,-1.24700003f,0.86030002f,-0.22219999f,0.66870002f,0.63620000f,-0.34499999f,0.59000002f,-0.85969999f,-0.40179999f,-0.86289999f,-0.21430001f,0.40359999f,-0.12210002f,-0.87040003f,0.13560001f,-0.71560003f,-0.12709995f,0.87739998f,-0.07149999f,0.33900002f,0.40659998f,0.18119999f,1.00040002f,0.02880000f,0.76600001f,0.38630002f,0.57879999f,0.44290000f,0.77659999f,-0.06159999f,0.83380001f,1.11370003f,0.20640001f,1.12870003f,1.04859999f,0.00240000f,0.85939999f,-0.05419999f,0.36579999f,-0.06640001f,0.02310004f,-0.12910000f,0.07060000f,0.21700000f,-0.14270000f,-0.43700000f,-0.32890000f,-0.57090001f,-0.47019998f,-1.17549996f,-0.76429998f,0.07379998f,0.65639997f,0.46889999f,0.45519999f,0.88659999f,0.48639999f,-0.52960000f,-0.53069999f,0.02520001f,-0.18099999f,-0.55239997f,-0.05869999f,-0.15180002f,0.46389999f,0.20550000f,0.29220001f,-0.00830000f,-0.29070002f,-0.17680000f,-0.03180001f,-0.41400001f,-0.45600000f,-0.79659999f,-0.61820000f,0.15680002f,-0.26229999f,0.05180001f,0.15519998f,0.99539998f,0.45899999f,0.19580000f,0.58490000f,0.49730002f,0.19460001f,0.07400000f,0.42840000f,0.22339999f,0.30699999f,1.21710000f,0.16440001f,1.07450000f,0.32090000f,0.61559997f,0.46189998f,0.09300001f,-0.68339999f,-0.01319997f,-0.27779998f,-0.19719999f,-0.39139999f,0.11869999f,-0.67459997f,0.23310002f,-0.40660001f,-0.03300000f,-0.23440000f,0.63670002f,-0.63159999f,0.47650004f,-0.06949999f,0.81560000f,-0.09650002f,0.93980002f,0.26920000f,0.78060001f,0.62700001f,0.33679999f,0.66020000f,-0.75930003f,0.25060000f,-0.59890003f,0.47020002f,-0.64959999f,0.23700003f,-0.27990002f,-0.51320000f,-0.32050001f,-1.07260002f,-0.55919999f,-0.41320001f,-0.29699998f,0.25700002f,0.25900000f,0.31329999f,0.33310000f,0.74579999f,1.05469997f,0.76050000f,0.21980000f,0.57620001f,0.17330000f,0.73420000f,1.35229998f,0.83329999f,0.80000000f,1.14400000f,0.75579999f,-0.44699999f,-0.50519999f,0.20090003f,0.29540000f,0.01260000f,0.32490001f,0.25000000f,0.29509999f,-0.01000000f,0.07280000f,0.24409999f,0.15960000f,0.56100000f,1.05820000f,0.70270000f,0.39740001f,0.51650002f,-0.21970001f,-0.15060000f,0.08050000f,-0.21570001f,-0.12000002f,0.32389999f,0.43920000f,0.03519999f,0.22230000f,-0.11540002f,-0.86399999f,0.00180002f,-0.53550001f,-0.12639998f,-0.50210000f,-0.99250002f,-0.15680001f,-1.02430001f,0.18720001f,-0.06140000f,0.05060000f,-0.64330000f,-0.35679998f,-0.77830000f,-0.94879997f,-0.09559999f,-1.00759999f,-0.27580007f,-0.78099998f,-0.09720002f,-1.03840002f,0.02979999f,-0.87420001f,0.00770000f,0.30259999f,-0.06430002f,-0.02330000f,-0.16660000f,-0.05770000f,-0.56080000f,-0.36419998f,-0.65300000f,0.41250004f,0.72639998f,0.21229999f,0.74050002f,0.02240000f,0.60430001f,-0.00790000f,-0.83899998f,-0.02709997f,0.30900005f,-0.12700000f,-0.27060000f,-0.76210000f,-0.55690001f,0.20360001f,-0.26529999f,-0.00580000f,-0.30800000f,-0.38529999f,-0.25520000f,0.48019999f,0.62229998f,0.51489998f,-0.17120001f,0.08640001f,0.39100003f,-0.10460001f,0.16219999f,0.38650000f,0.07160000f,-0.07620000f,0.30220002f,-0.14459999f,-0.49949999f,-0.11629999f,-0.57280002f,-0.58820001f,-0.70340002f,0.33260000f,0.82450000f,0.19770000f,-0.09240000f,-0.43389999f,0.28360002f,0.09760001f,-0.14159999f,0.09900001f,0.05179999f,0.78110002f,0.12050000f,0.18220000f,0.73760001f,0.61690002f,-0.69159998f,0.78210001f,0.24550002f,0.52920000f,0.32450000f,-0.75510001f,0.39579999f,-0.60190002f,0.39010000f,-0.02540000f,0.40130000f,-0.76489997f,-0.11599999f,-0.75349997f,-0.19360002f,-0.78360000f,-0.14039999f,-0.19280000f,-0.69979997f,-0.15819997f,-0.73140003f,-0.25360001f,-0.58620002f,-0.29990001f,0.07960000f,-0.16050001f,1.28740005f,0.20560000f,1.18060004f,0.31650001f,0.00360000f,0.10870000f,-0.94170003f,-0.37059999f,-0.68890000f,-0.54800001f,0.06439999f,-0.43560001f,0.88230004f,-0.31040001f,0.60650003f,-0.21980002f,-0.73219999f,-0.28840000f,0.68909999f,-0.14500002f,0.29219999f,0.76189998f,0.52109999f,-0.10860001f,-0.37690001f,0.06830000f,0.03300000f,-0.03310000f,-0.44990002f,0.21400000f,-0.11450000f,-0.06300000f,-0.09060000f,-0.93640001f,-0.36270000f,0.16980000f,-0.37110001f,0.34210000f,-0.51539998f,-1.24309995f,-0.79389998f,0.12179999f,0.67309997f,0.10589999f,-0.00100000f,0.15130000f,0.10870000f,0.07059999f,0.13999997f,0.45629999f,0.42620001f,0.98240002f,0.45830001f,-0.00100000f,-0.39350001f,-0.35550002f,-0.15519999f,-0.76819999f,-0.52560002f,0.14580001f,-0.15559999f,0.15790001f,0.08040000f,0.01700001f,-0.22690000f,-0.45079998f,-0.31269998f,-0.47930001f,-0.13799999f,-0.32350000f,0.61770002f,0.63319999f,0.49309999f,-0.45550000f,0.43899999f,-0.38150001f,-0.65380000f,0.60699997f,-0.40000001f,-1.41470002f,-0.06679999f,-1.11210000f,0.34890000f,0.60519997f,0.49869998f,0.61790001f,-0.15320000f,0.39770001f,0.05290000f,-0.18559999f,0.02470000f,-0.65460001f,-0.51659997f,-0.54999998f,-0.03660000f,-0.23420000f,-0.20560000f,-0.01349998f,0.57000000f,0.03550000f,-0.02219997f,0.66600000f,0.09460001f,-0.75100002f,0.06660000f,-0.60320002f,0.40430001f,0.29090000f,0.00020001f,-0.11949997f,0.31230002f,-0.45120001f,-0.97260002f,-0.55800002f,0.37940001f,0.45430000f,-0.10490000f,-0.15780000f,0.13519999f,-0.07850001f,-0.04740000f,0.11360000f,0.09870000f,-0.78580000f,-1.29799997f,-0.81629998f,0.47980000f,0.69379999f,0.34290000f,-0.17520002f,0.33979998f,0.46100000f,-0.21140002f,0.34869997f,-0.22930002f,0.52899998f,0.85299996f,0.52009999f,0.43039999f,0.54459998f,0.65519999f,-0.29499999f,-0.32319999f,-0.34389999f,0.04379999f,0.69679999f,0.60670001f,-0.44059998f,-0.51249998f,-0.53709999f,-0.52399999f,-0.38870000f,-0.68390002f,-0.36160000f,-0.53290000f,0.25740001f,0.32040001f,0.38460001f,0.16630001f,0.57159998f,0.02529997f,0.61379999f,-0.17979998f,0.49760000f,0.09620000f,-0.23179999f,0.07040001f,0.79020000f,0.24059997f,0.89680000f,-0.37920001f,0.08100000f,-0.45340002f,0.08020001f,-0.95519998f,0.04940005f,1.27390003f,-0.13319999f,1.00810002f,-0.51560000f,-0.11820000f,-0.58820000f,-1.01820000f,-0.34679998f,-0.93979999f,0.60299999f,0.08860000f,0.56239999f,-0.01500003f,-0.91659997f,-0.10000000f,0.89389998f,0.17119999f,0.83809998f,0.41879998f,0.28640003f,-0.33460002f,-0.19740001f,0.24670001f,-0.47040001f,-0.47380000f,0.19720000f,0.26720000f,0.88270001f,0.55840001f,0.07500000f,-0.10280000f,0.06970000f,-0.39220001f,-0.47010001f,0.01650001f,-0.54699999f,-1.04499997f,-0.49609999f,0.26540000f,-0.13830001f,0.40010001f,-0.24680001f,-0.12200000f,-0.15820000f,0.04260000f,0.02310001f,-0.10330000f,-0.19219998f,-0.92399997f,-0.51690000f,-0.30520001f,-0.51490000f,-0.08560000f,-0.27460000f,-0.13290001f,-0.50890002f,0.40460002f,0.12510000f,0.51150002f,0.31800000f,0.39410000f,-0.06400001f,-0.12919997f,0.10680001f,-0.09120002f,-0.76179998f,-0.00179998f,-0.18060001f,-0.82119996f,-0.02139997f,-0.06110000f,-0.57259999f,-0.19069999f,-0.40180001f,0.05580000f,-0.32000000f,-0.02410002f,-0.47359999f,0.09210001f,0.22160000f,0.11819999f,0.37820001f,-1.33190003f,-0.06600001f,-1.08690001f,0.51760002f,-0.13560001f,0.46360002f,0.12470000f,0.18919999f,0.09089999f,-0.20299998f,0.64579999f,-0.02640000f,-0.08310000f,-0.19819999f,0.03770002f,1.11790001f,0.27240002f,0.94890000f,-1.36810006f,-0.07640000f,-1.16670004f,0.12070002f,0.44459999f,0.00470000f,-0.21320002f,0.65069999f,0.37660002f,0.26270001f,0.02309999f,0.20200000f,0.53470000f,0.00999999f,0.05700000f,0.06739999f,-0.22270001f,-0.77620001f,-1.42790000f,-0.87290001f,0.11180000f,0.29030000f,0.03290000f,-0.10099999f,-0.70119999f,-0.10669999f,0.08940001f,0.94410000f,0.35490001f,0.26700000f,0.69130001f,0.31350000f,0.19760000f,-0.09189999f,0.15640000f,0.30000001f,0.23289999f,-0.27960001f,-0.38799999f,-0.52859998f,-0.18599999f,-0.34980000f,-0.10900000f,0.25230002f,-0.17200001f,0.21919999f,-0.17380000f,0.12720000f,0.32500000f,0.15320000f,-0.14240000f,-0.64880001f,0.10550002f,-0.05880002f,0.06230001f,1.29789996f,-1.64999994f,0.74149999f,1.49260000f,-1.40219998f,0.81430002f,-0.96610002f,0.76880000f,-0.52470002f,-1.08679999f,1.20539999f,-0.60410001f,-0.70950006f,0.45820004f,-0.39140003f,1.03730005f,-0.59600001f,0.55430002f,0.08940000f,0.39639999f,0.01360000f,-0.60380002f,0.49840001f,-0.32900001f,-0.27490001f,0.43320000f,-0.16570001f,1.09849997f,-1.27079995f,0.62009999f,-0.21760000f,-0.09120000f,-0.08360001f,0.39330004f,0.01979998f,0.19140002f,-0.08839998f,0.18140001f,-0.04010000f,0.78889999f,-0.79659999f,-0.27300000f,-0.00000000f,-0.15890000f,0.15040000f,0.15260000f,0.15100000f,-0.57339999f,-0.00679999f,0.25010002f,-0.23840001f,-0.15820000f,-0.19420001f,-1.13359999f,-0.36879999f,-1.36040002f,0.24679999f,0.01420000f,0.36840000f,-0.36960002f,-0.12450001f,-0.38430003f,-0.17560000f,-0.06140000f,-0.05120000f,0.53100002f,0.24210000f,0.12180002f,0.58480000f,0.09440000f,0.28240001f,-0.41800001f,-0.19100000f,-0.65800002f,0.07480002f,0.15800001f,0.23020001f,0.60420001f,0.16890000f,0.22560000f,-0.83400001f,-0.31920000f,-0.61580002f,-0.78000001f,-0.26530000f,-0.37449998f,0.67899998f,-0.22120000f,0.09360001f,0.24060001f,0.04029999f,-1.20210000f,1.10879999f,-0.64750002f,-0.21760003f,-0.04939999f,-0.11190001f,-0.89039997f,1.60439996f,-0.54740000f,0.17119998f,-0.66479997f,0.12280000f,-0.33090001f,0.47580001f,-0.19560001f,-0.25040001f,0.15160000f,-0.13380000f,0.75600003f,-0.20320002f,0.39240001f,0.80219999f,-1.02619999f,0.45430001f,-0.19200001f,0.43600000f,-0.13000000f,-0.10079996f,0.39059998f,-0.06229999f,0.84480001f,-0.72540000f,0.46170001f,-0.91000001f,0.78739999f,-0.50590000f,-1.24299999f,0.12200000f,-0.91899998f,-0.22129999f,-0.41099999f,-0.12560000f,-0.16060000f,-0.66899999f,0.45040002f,0.14900001f,0.54900003f,-0.52360004f,-0.34790001f,-0.75830004f,0.35319999f,-0.05410000f,-0.37330001f,0.07859998f,-0.11400000f,0.06129999f,0.56480000f,0.23140000f,0.51100001f,-0.42480000f,0.00090000f,0.10229999f,0.49120002f,0.20810000f,0.33870002f,0.28559999f,0.04800000f,-0.35240000f,0.20860000f,0.11060000f,-0.20150001f,0.46460000f,0.34630000f,1.04520002f,0.53640001f,0.16980000f,0.65320001f,-0.63540002f,-0.18960000f,-0.12850001f,0.59300002f,-0.13750000f,-1.25199998f,1.28759996f,-0.69500000f,0.32559998f,-0.07300000f,0.15230000f,0.34660000f,-0.63120000f,0.21380000f,-0.23990006f,0.05360004f,-0.14010002f,0.92329999f,-0.82139998f,0.49200001f,0.14689995f,-0.68579996f,0.10459999f,0.54220000f,-0.51519999f,0.30660000f,-0.83369998f,0.88760000f,-0.45570001f,0.54430003f,-0.36680001f,0.29750001f,0.74240000f,-0.25079999f,0.37700000f,0.46890003f,0.10900000f,0.22720001f,-0.07060000f,-0.07239997f,-0.00920002f,0.41660000f,-0.78380000f,0.25790001f,-0.96110003f,0.65840001f,-0.51530002f,0.92150001f,1.16000006f,0.11360000f,-0.09590000f,-0.13730000f,-1.08260003f,-0.34750001f,-1.13460004f,-0.72280000f,-0.24830000f,-0.65430002f,-1.04420001f,-0.30670000f,-0.97260002f,0.96920002f,0.27220001f,0.41600003f,0.60479999f,0.29159999f,1.03559999f,-0.10479999f,0.07600000f,-0.07920000f,-0.09360003f,-0.15960000f,0.10359999f,-0.75620002f,-0.45070000f,-1.27020003f,-0.19139999f,0.01320000f,-0.19410000f,-0.22080003f,-0.16260001f,0.21179996f,-0.15840000f,0.03660000f,0.54700001f,0.08020000f,-0.07540000f,-0.49329999f,-0.11179998f,-0.01479999f,-0.62469999f,0.69860003f,0.26710001f,0.34389998f,-0.58799999f,0.19530000f,-0.97040002f,1.47080000f,-0.57700002f,-0.71469999f,0.86199998f,-0.41150000f,-1.03580000f,1.47899997f,-0.60670001f,1.31580002f,-1.18499999f,0.72290002f,0.21120000f,-0.60759998f,0.15540000f,-0.16419996f,0.59139997f,-0.10969999f,-0.17140006f,-0.52099995f,-0.06190002f,-0.24380003f,0.38300001f,-0.16750000f,-0.20909997f,0.57279996f,-0.13409999f,-0.47520005f,-0.30739996f,-0.22170002f,-0.69160002f,0.23300000f,-0.34630002f,0.53029999f,-0.25179999f,0.26700000f,0.25430003f,0.49199997f,0.09330001f,1.15890003f,-1.09510005f,0.19560003f,0.22650001f,0.69090004f,0.65639998f,0.07109999f,-0.01690001f,0.77240002f,0.18460000f,-0.03639999f,0.18100000f,-0.02620000f,-0.14250001f,0.22320003f,0.23370001f,0.33070002f,-0.47660001f,-0.24550000f,-0.37400002f,0.70799999f,0.30569999f,0.93950000f,-0.88240003f,-0.45410000f,-1.34550002f,0.20420000f,0.15550000f,0.23020000f,-0.25300001f,-0.00560000f,0.44829999f,0.62220006f,0.43470001f,1.11440006f,0.51780000f,0.07980000f,0.28110001f,0.09519999f,-0.14980000f,-0.64660002f,-0.56640000f,-0.15750000f,-0.91490002f,0.67340002f,-0.30450002f,-0.24509997f,0.18719997f,-0.11610000f,1.15509998f,-1.13439997f,0.63010000f,1.32660003f,-0.89940000f,0.70610002f,0.43750000f,-0.43859999f,0.23600001f,0.05930006f,0.33499996f,0.02300002f,-0.47640002f,0.19380000f,-0.25670000f,0.45850000f,-0.72739998f,0.28300000f,-0.41410004f,0.68340000f,-0.26780001f,0.13180001f,0.09539999f,0.06750000f,-0.77150001f,0.31120000f,-0.39210001f,0.12280007f,-0.07900007f,0.09010002f,0.68969998f,-0.93999997f,0.39390000f,0.69979999f,-0.52399997f,0.36060001f,-0.28809998f,1.03119998f,-0.20950000f,0.61810003f,-0.20080000f,-0.00500001f,-0.21400001f,-0.60290003f,0.57080000f,0.03460000f,-0.27799999f,0.21680000f,-0.12860000f,-0.38460002f,1.01840001f,0.29560000f,0.72000003f,0.66480002f,0.42390001f,1.05730004f,-0.36900000f,-0.15180000f,-0.33310000f,0.91079998f,0.19110000f,0.52670001f,-0.17939998f,0.01140000f,-0.48669998f,-0.37660000f,0.04180000f,0.32189999f,0.75020000f,0.40390000f,0.99800003f,-0.24680000f,-0.10180000f,0.09280000f,0.38259999f,-0.02710000f,-0.16319999f,1.00800000f,0.34860000f,1.14500002f,-0.98300004f,-0.39730001f,-1.18660004f,-0.49520003f,-0.14990000f,0.51749998f,-0.59700000f,0.27280001f,1.20519999f,-0.97159997f,0.64260001f,0.72020000f,-0.83120000f,0.38980002f,1.17560000f,-1.34439997f,0.66580001f,0.24470003f,-0.19020000f,0.15500000f,-0.35450000f,0.33359999f,-0.20030000f,1.16769996f,-1.45459994f,0.66219999f,0.02290004f,0.68339996f,-0.02839999f,-0.92289999f,0.84619999f,-0.49400001f,0.44880000f,-0.43339998f,0.26689999f,-0.46320001f,0.06599999f,-0.23420000f,0.81339997f,-0.87559996f,0.44360000f,0.82900000f,-1.30719997f,0.49900000f,-0.73300005f,1.06660002f,-0.44130003f,-0.16480006f,1.01250000f,-0.40199999f,0.00570000f,-0.04910000f,1.10500003f,0.22730001f,0.34280006f,-0.47239999f,-0.04840000f,0.20060000f,0.17060000f,-0.00380000f,0.35990001f,0.61720000f,0.16310000f,0.20790000f,-0.72980000f,-0.33760000f,-1.00890001f,-0.04760001f,-0.19540000f,-0.77520000f,-0.42600001f,-0.31740000f,-1.01880001f,-0.45220002f,-0.24800000f,-0.20010002f,0.40839999f,0.26059999f,0.76759999f,0.08080000f,0.12080000f,0.50520002f,0.74500000f,0.19220000f,0.22550001f,-0.21780002f,-0.03390000f,0.30620000f,0.61420001f,0.42740000f,1.24610004f,-0.62300000f,0.26289999f,-0.68649997f,0.93259997f,-0.38680000f,1.63100000f,-1.63760000f,0.89940002f,-0.96759998f,0.73499997f,-0.51450000f,0.04889998f,-0.56920000f,0.05690000f,0.88330001f,-0.76979999f,0.48260001f,-0.43370000f,0.67459999f,-0.26980000f,0.55659997f,-0.33939998f,0.27770000f,0.10799997f,0.09680001f,0.02760000f,-0.55630003f,0.04360003f,-0.28670001f,0.06560000f,-0.17439998f,0.05759999f,-0.27080001f,0.08400000f,-0.12880001f,1.08649999f,-0.93639998f,0.59250001f,-0.59420003f,0.18420001f,-0.30050002f,0.01730001f,-0.15740002f,0.04319999f,-0.49150000f,0.24760000f,0.66520003f,0.07940001f,-0.00519997f,-0.58720003f,-0.34670000f,-0.66610003f,-0.14260000f,-0.17390000f,-0.71860000f,-0.25420002f,-0.16850000f,0.16220000f,-0.84560001f,-0.13660000f,0.08620000f,-0.14459999f,0.09540000f,0.21230000f,0.60060003f,0.43380001f,1.17530005f,-0.18559999f,0.16160000f,0.63080001f,1.09639998f,0.17500000f,0.08200001f,0.85960001f,0.16820000f,0.24600003f,-0.31820001f,-0.00400000f,-0.05190001f,0.32780001f,0.23470000f,0.27600001f,0.23120002f,0.05260001f,-0.25299999f,0.29940001f,0.24780000f,0.45390001f,-0.75600001f,-0.02910001f,1.15880003f,-1.12440003f,0.63180003f,-0.42030005f,0.15300004f,-0.23320002f,0.33659999f,-0.06740001f,0.15650001f,-0.49680006f,-0.23439997f,-0.23680002f,-1.51440002f,1.23899999f,-0.81410002f,-0.45289998f,0.61699998f,-0.24980000f,0.04090004f,-0.06540004f,0.04960000f,-0.85539997f,0.78059996f,-0.45030000f,1.82559996f,-1.71119994f,0.99480000f,1.28740000f,-1.30019999f,0.70970001f,-0.53030000f,0.70860001f,-0.29860001f,0.28520003f,0.13620000f,0.14410000f,0.57180003f,-0.16080001f,0.28940002f,0.10110002f,0.16619999f,0.05400000f,-0.29850003f,-0.41180002f,0.31279999f,0.03070000f,0.74410002f,0.36760001f,0.12050000f,-0.16510000f,-0.19460000f,-0.13210000f,-0.72480001f,0.65880000f,0.11430000f,0.64110001f,-0.34160000f,-0.03880000f,0.08840000f,-0.16880000f,-0.06700000f,0.28980002f,-0.25560000f,0.11430000f,0.53189998f,0.52120004f,0.31190001f,0.71110003f,0.46400001f,0.22480000f,0.08240001f,-0.60360001f,-0.06960000f,-0.25500002f,-0.83600003f,-0.29920001f,-1.16600004f,-0.88420002f,-0.23720000f,-1.12170004f,0.20440002f,0.12200000f,-0.21019998f,0.07220001f,0.11530000f,0.39560002f,0.84120004f,0.25490001f,0.01269996f,-0.92579998f,0.06239999f,0.72290003f,-0.21680000f,0.36990001f,0.22960001f,0.22700000f,0.08990001f,0.66869998f,-1.28199997f,0.40590000f,-0.65740000f,0.54339999f,-0.35250001f,-0.48020003f,-0.05560000f,-0.23320001f,-0.88889998f,0.78320001f,-0.46950001f,0.28530005f,-0.17740003f,0.16720002f,0.67200002f,-0.10960000f,0.34520001f,-0.86639999f,1.15900000f,-0.49170001f,-0.52800002f,1.14840001f,-0.34100002f,-0.67330000f,1.49500001f,-0.42800002f,0.46260003f,0.17079997f,0.22120001f,-0.20519999f,0.13379999f,-0.10030000f,0.50380005f,-0.11320001f,0.28840001f,0.18230000f,0.29790001f,-0.16220000f,0.03020000f,-0.49690000f,-0.98419998f,-0.20740000f,-0.56790001f,0.51959998f,0.03209999f,-0.10110002f,0.78400001f,0.23660000f,0.70500002f,-0.60860001f,-0.39190000f,-1.19800001f,-0.57379999f,-0.24250000f,-0.42480000f,0.40000001f,0.02240000f,-0.38680001f,0.12340001f,0.24500001f,0.82550003f,0.11080001f,0.14780000f,-0.03639999f,-0.63900001f,-0.13260000f,-0.58490002f,-0.28480000f,-0.07790000f,0.22950002f,0.88700000f,0.19540000f,0.13570000f,0.44240001f,0.02920000f,0.11160001f,-0.16759998f,-0.12770001f,0.22210003f,-0.00980002f,0.11900001f,0.05270002f,0.73019999f,-0.01560000f,-1.26229996f,1.56739995f,-0.71560000f,0.98789999f,-0.95699997f,0.53640001f,0.79300000f,-1.07119998f,0.46100001f,-0.05740003f,0.27160001f,-0.06720000f,-0.61520000f,0.44539998f,-0.33850000f,0.98300002f,-0.59379999f,0.51210002f,-0.47890000f,0.35780000f,-0.23820001f,0.15920002f,0.40000000f,0.06240000f,-0.66549999f,1.13319999f,-0.39670001f,-0.63970002f,0.18319999f,-0.32510001f,1.40350001f,-1.19079998f,0.76110002f,0.69860000f,-0.90460001f,0.39310002f,-0.26089999f,-0.68950003f,-0.44160000f,-0.38520000f,-1.10200003f,0.22300000f,0.03080000f,0.32070002f,0.87859999f,0.25239999f,1.11010000f,0.55820002f,0.20410001f,0.41700003f,1.16400002f,0.32580001f,1.08380004f,0.97860003f,0.30720001f,1.24090004f,-0.64240002f,-0.44750000f,-1.16490001f,-0.08840001f,-0.06970001f,0.34549999f,0.33360000f,0.20130000f,0.57230001f,0.20220000f,0.03450000f,0.06660000f,0.89060002f,0.22390001f,0.78020004f,0.65780005f,0.44560001f,1.08090005f,0.15580001f,0.09560000f,-0.12009999f,0.16579999f,-0.14450000f,-0.53420002f,-0.11660000f,-0.66990001f,0.16959999f,-0.11480001f,0.06580002f,0.15549998f,-0.51859998f,0.10759999f,0.66489998f,-1.41259997f,0.42000000f,0.60980003f,-0.56980001f,0.34090002f,1.16199999f,-1.71659998f,0.68290001f,0.72590001f,-1.46519999f,0.45590002f,-0.11710004f,0.09419999f,-0.08900000f,-0.37510002f,-0.27139999f,-0.16980001f,0.09790000f,-0.16440000f,0.06910000f,0.29880000f,-0.33159999f,0.16620000f,0.93540000f,-1.39659999f,0.54830001f,0.20570007f,-0.09460004f,0.13180002f,0.32270002f,0.12139999f,0.15480001f,0.74319999f,-0.71239998f,0.39300001f,-0.57989997f,-0.42649999f,-0.61220001f,-0.09100000f,-0.24950002f,-0.26260000f,-0.03350000f,0.37020000f,-0.33220000f,-0.11570000f,-0.49600000f,0.49620000f,0.12720000f,0.68410000f,-0.07020000f,-0.22800000f,-0.64430002f,0.01639999f,-0.17450000f,-0.49090001f,-0.19000001f,-0.16520001f,-0.10900001f,-0.49340000f,-0.17980000f,-0.29490001f,-0.39540001f,-0.04500000f,-0.71630003f,0.81920002f,0.32440001f,0.67360003f,-0.57240002f,-0.34770000f,-0.49490002f,-0.17980000f,-0.07520000f,0.09370000f,0.78200004f,0.25660001f,0.15480002f,0.55700002f,0.02110000f,0.01700002f,-1.08339999f,0.32410002f,-0.87630001f,1.08460001f,-0.49340002f,-0.72040001f,0.25280000f,-0.36560001f,-0.18779999f,0.48599999f,-0.12640000f,0.34129999f,-0.89099997f,0.22520000f,0.43670000f,-0.49240001f,0.22670002f,0.45809997f,-0.53219997f,0.24260000f,-0.18900002f,-0.22760000f,-0.08800000f,-0.59210001f,0.46979999f,-0.32500000f,-0.17409997f,1.03320001f,-0.14770000f,0.83980003f,-0.76140001f,0.47070002f,-0.51610004f,0.03160001f,-0.27250001f,-0.35570000f,0.03079999f,-0.17850000f,1.17500007f,-0.71020003f,0.62590004f,0.97500000f,-1.14420001f,0.54050002f,-1.11659997f,0.78490000f,0.62720000f,0.11680000f,0.32200001f,-0.43160003f,-0.21760001f,-0.34580003f,0.13860001f,0.23460000f,0.41950001f,-0.08100000f,0.05850000f,0.46500000f,-0.85660004f,-0.20210001f,-0.06980005f,-0.50900003f,-0.26860001f,0.00449998f,-1.04759998f,-0.23280000f,-0.64900001f,0.67880000f,0.24520000f,0.28900000f,0.11820000f,0.00120000f,-0.06049999f,-0.02060003f,-0.16270001f,-0.19360002f,0.89360004f,0.27910001f,0.68610004f,-0.28000001f,0.03400000f,0.20799999f,-0.62200000f,-0.07220000f,-0.04040001f,-0.21340000f,-0.09590000f,0.14240001f,0.35720001f,0.01270000f,0.83979998f,-1.04419997f,0.47490000f,-0.42840004f,0.19900003f,-0.23210002f,-0.15609997f,0.48099999f,-0.08980000f,-0.50400000f,0.19600000f,-0.25200001f,-1.39340003f,1.06300001f,-0.74910003f,-0.79550006f,-0.01979996f,-0.40000002f,-1.30639996f,1.63939994f,-0.74270000f,0.89920001f,-0.59779999f,0.48510000f,0.25430000f,-0.22500000f,0.13640000f,0.17359994f,-0.54779995f,0.10649998f,0.98390004f,-1.12300003f,0.55900003f,-0.66500001f,0.65700002f,-0.35850002f,-1.05200000f,1.08240000f,-0.57720001f,-0.44160002f,-0.00700000f,-0.21910001f,0.37630002f,0.56130000f,-0.24479998f,-0.21059999f,-0.27059999f,-0.84720004f,-0.23100001f,-0.65580004f,0.54720002f,0.35520000f,0.94120003f,0.16080000f,0.04230000f,-0.23389999f,0.07880000f,-0.02330000f,-0.15410000f,-1.11700001f,-0.33050001f,-1.19240005f,0.63700001f,0.24530000f,0.83360003f,0.17019999f,-0.16780000f,-0.66110003f,0.43939999f,0.18700000f,-0.18330001f,0.74119998f,0.22989999f,0.82230000f,0.35719999f,0.00700000f,0.45640001f,-0.23199999f,-0.04070000f,-0.38730000f,0.50759999f,-0.03450000f,-0.26449999f,-0.36899999f,-0.06000000f,-0.56529999f,-0.49759999f,0.19360000f,-0.15120000f,-0.21940002f,-0.07289999f,-0.94380004f,1.20960003f,-0.54180003f,0.14780003f,-0.16500002f,0.10250001f,0.43670000f,-0.05899999f,0.21740000f,0.26170000f,-0.19579999f,0.13680000f,-0.99799997f,1.64699996f,-0.59970000f,0.43399999f,-0.77459999f,0.27030000f,0.85229998f,-0.75799997f,0.44710001f,0.83510001f,-0.08419998f,0.42040000f,0.63529997f,-1.06339996f,0.38379999f,0.30879996f,-0.98159996f,0.20759999f,-0.11949999f,0.52939998f,-0.09140000f,1.11289997f,-1.13179998f,0.60320001f,-0.22849998f,0.83699996f,-0.16340000f,0.00160000f,-0.95850001f,-0.32680003f,-0.31550001f,-0.91510004f,-0.60960003f,-0.44100000f,-1.20380003f,0.73860003f,0.13590001f,0.26380003f,-0.12940001f,-0.05210000f,0.07820000f,-0.53120003f,-0.31900001f,-0.89980004f,-0.95420000f,-0.32290000f,-0.91380003f,-0.27840003f,-0.17760001f,0.19639998f,-0.08680000f,-0.04460000f,-0.39960002f,0.06680001f,0.07720000f,0.17340001f,-0.79239999f,-0.14929999f,-0.15170000f,-0.53320002f,-0.25430000f,-0.64950003f,0.03300000f,0.12660001f,-0.17889998f,-0.03260001f,-0.08860000f,0.44030002f,0.46360002f,0.29030000f,0.77230002f,-0.64599998f,0.21070002f,0.21029997f,-0.16459998f,0.09260000f,-0.03340005f,0.06880003f,-0.04660001f,1.07240002f,-1.17960001f,0.59660003f,-0.26460002f,0.02540001f,-0.13270001f,-0.16480003f,0.26260001f,-0.11430001f,-0.90979998f,1.18339997f,-0.52930000f,-0.56060005f,-0.23659998f,-0.26810002f,0.15080002f,0.19959999f,0.05860001f,-0.03879998f,0.09419998f,-0.01969999f,-1.24309999f,1.18579998f,-0.68040001f,-0.37630002f,0.41720001f,-0.22190001f,0.13150001f,0.55180001f,0.03879999f,-0.33490004f,-0.52100000f,-0.13680001f,0.14790002f,-0.17240000f,0.09910000f,-1.05999998f,0.62060000f,0.29620002f,0.21260001f,0.79790004f,0.57520002f,0.26810001f,0.50310003f,0.16000000f,0.16190000f,0.30610000f,-1.23180003f,-0.34800001f,-1.15190005f,0.30200001f,0.13180000f,0.25560001f,-0.70660002f,-0.24890000f,-0.25120002f,0.86760003f,0.20880001f,0.07500005f,0.62980002f,0.19040001f,0.42290003f,-0.14180000f,-0.05350000f,0.26100000f,0.37420001f,0.33530000f,0.87740002f,-0.51559999f,-0.23380000f,-0.74080001f,-0.23680001f,-0.28910000f,-0.93410002f,0.28460000f,0.12040000f,-0.17130000f,0.29400000f,0.08700000f,0.19760001f,-0.09020000f,0.72080000f,-0.30450001f,-0.15690001f,-0.28610000f,0.58450001f,-0.18190000f,0.75230001f,0.66550003f,0.07100000f,-0.18190000f,0.02150000f,-0.59299998f,-0.38029999f,-0.46799999f,0.69929999f,-0.41519999f,-0.80299999f,0.23780001f,0.36140001f,-1.27450000f,0.53859998f,-0.51509996f,-0.76800000f,-0.38999999f,-0.16420000f,0.27200001f,-0.81350001f,-0.32260000f,0.34900002f,0.81200002f,0.32060000f,-0.05650000f,0.41259999f,-0.60630000f,-1.01799999f,0.23619999f,-0.78680000f,0.05050006f,0.91879997f,-0.50649997f,-0.60049998f,-0.55810000f,-0.28790000f,0.30850001f,-0.73410001f,0.08310000f,-0.58050002f,0.25770002f,1.29210002f,-0.20580000f,-0.00300001f,0.26900000f,-0.85070001f,0.46670003f,0.29090000f,0.28510000f,0.60770004f,0.66770002f,-0.55550003f,-0.84010005f,0.68650002f,0.41329996f,-0.80030002f,0.16679998f,-0.56669999f,-0.70270001f,-0.32919997f,-1.62949998f,-0.18790003f,0.14159997f,1.74119999f,-0.02899997f,0.15220002f,0.71720004f,0.75320002f,0.30429997f,-1.11819999f,-0.52920000f,-0.17220001f,-0.33989999f,-0.48550001f,-1.65930005f,0.84090003f,0.21650001f,-0.60680000f,-0.15669998f,0.87310002f,0.91539998f,-0.65099998f,-0.39650002f,-0.23740001f,-0.01670000f,-0.95249997f,-0.36330001f,-0.90869999f,-0.80700003f,-0.34650001f,-0.15100000f,-1.01450002f,0.30080000f,-0.39029999f,0.61050002f,-0.71100002f,-0.21490001f,0.53900000f,-0.18620001f,-0.40200000f,0.80149999f,-0.57229998f,0.12390000f,0.49949998f,-0.86550000f,0.55789996f,-0.07649999f,0.88800001f,-0.39369997f,-1.10500001f,0.60700001f,-0.39340001f,0.47500000f,-0.83349998f,0.08040001f,0.76649999f,-0.31169998f,0.28689999f,0.94100001f,0.84520002f,1.02360001f,-0.69500000f,0.33170000f,0.28460000f,-0.65449998f,0.10699999f,0.54370001f,-1.59280003f,-0.21580001f,-1.28519999f,0.80970003f,0.00990000f,-0.22510002f,2.41870000f,-0.06290001f,-0.93130001f,-0.35089999f,1.05530004f,0.54709999f,-0.84590001f,0.23910003f,0.59469998f,-0.51339999f,0.02180000f,0.75270000f,0.18419997f,-0.04979999f,-0.63329999f,0.41670002f,-0.27130002f,-0.12340000f,1.45240000f,-0.16620002f,-0.83750000f,-0.27310000f,0.89910001f,0.54439999f,-0.79820001f,0.25300003f,1.39050001f,-0.12150003f,-0.90150003f,-0.54390000f,0.13679998f,0.73840003f,0.45929999f,-0.93240000f,-0.30999999f,0.12140001f,0.60069997f,-0.11100002f,-1.02630001f,-0.08040001f,0.93499997f,0.68530001f,0.79939997f,0.23600005f,1.30840001f,-0.23379997f,-0.69250003f,0.35380000f,0.51609999f,-0.71450002f,-0.47560000f,-0.30669999f,-0.46649999f,-0.38189999f,-0.35189998f,-0.49350000f,-0.06630001f,-0.57089999f,0.82300000f,0.25340001f,0.44959998f,0.30150003f,0.73980000f,-0.12169999f,-0.55750000f,0.32379998f,0.46749999f,-0.73100002f,-0.44500000f,-0.31579999f,0.15300002f,-0.64260000f,-0.80399999f,-0.56650002f,0.42969998f,0.21730000f,0.07149999f,-0.69069999f,-0.11110000f,0.20600000f,0.66360000f,-0.24510001f,-0.28049997f,0.46430002f,-0.16550000f,0.10759999f,-0.36160002f,0.50350001f,-0.46000002f,-0.62200002f,0.95410001f,0.75890004f,-1.05770003f,0.04420000f,1.19329997f,-0.34590000f,1.50240002f,-0.49890002f,-0.65330002f,-1.06490000f,-1.07469997f,0.84190001f,-0.72359999f,0.66990000f,0.56290000f,1.08210000f,-0.19260003f,0.12280002f,-1.43609999f,0.55770003f,0.38810000f,-1.50530001f,-0.09039994f,0.80680002f,-0.12249998f,0.33549997f,0.51250000f,0.46530000f,0.51450000f,0.69610004f,-0.73909999f,0.38990004f,-0.37110003f,0.56110000f,0.42390000f,-0.42600000f,0.05640001f,0.12820000f,0.59650001f,-0.03310000f,0.17950000f,0.44550000f,-0.55410001f,-0.15750000f,0.67650002f,-0.14219997f,-0.60170000f,0.41450000f,0.50829999f,-0.16189999f,-0.25349999f,-0.78090000f,-0.87430000f,-0.30950001f,-0.07720001f,0.78229998f,-0.20600000f,0.68869998f,0.29519999f,-0.96200000f,-0.27250001f,-0.78419998f,0.55199998f,0.70920001f,0.87219997f,0.05749998f,0.52030002f,0.94409998f,-0.58349999f,0.37619997f,-0.07650000f,-1.26100001f,0.41860000f,-0.57559998f,1.03250001f,0.22600002f,0.55269998f,-0.60400002f,0.35279999f,-1.08419996f,0.27300001f,0.24959999f,-1.15390002f,-0.65449998f,0.35270001f,-0.40610000f,0.26989998f,-0.23210000f,1.40780004f,0.72669998f,-1.26810007f,0.41430001f,0.39960000f,-0.16100000f,0.10160000f,-0.16460002f,-0.57420001f,-0.25430001f,-0.20920000f,-0.17940000f,-1.04990001f,0.73309999f,0.51410000f,1.11340002f,-0.21729999f,0.16010001f,-0.01999997f,2.15749996f,-0.16050001f,0.57319999f,0.05469998f,0.04070001f,-0.80319998f,0.69459999f,0.62300000f,0.10970000f,0.48430001f,-0.48090003f,-0.81280000f,1.22140001f,0.29199999f,-0.67899998f,-0.36840002f,0.47449998f,0.44199999f,0.69289996f,0.39599999f,-0.00239999f,0.87979999f,0.60399998f,0.14419999f,0.30019999f,0.61650004f,-0.31950001f,-0.88310000f,-0.09799999f,0.07670000f,-0.33660000f,0.67899999f,-0.30220000f,0.07580000f,0.42499999f,-0.12230000f,0.25960000f,0.09950001f,0.76959998f,0.53330000f,-1.03400001f,-0.27909999f,-0.81080000f,0.21350001f,1.09629997f,-0.31850000f,-0.47849999f,-0.06930000f,-0.43689998f,-0.22599999f,0.73779998f,0.33639999f,0.54700002f,0.07280001f,-0.06040000f,0.21250002f,0.90740000f,0.32410000f,0.99750001f,-0.17130000f,-1.23339998f,-0.08449999f,0.59069999f,0.31820000f,-0.87800001f,-0.43860002f,-0.15869999f,-2.45669994f,0.22229999f,-0.61000000f,0.43060001f,0.18840000f,-0.59320002f,-0.64189998f,0.84650002f,1.05679998f,-0.20360001f,-0.10180000f,-0.62410002f,-0.46699999f,-0.39320003f,-1.26720002f,0.19499998f,-0.01139999f,1.16960002f,0.66429997f,-0.54910001f,0.00090001f,-0.60930001f,0.13810001f,0.41460003f,1.96769995f,-0.37050000f,0.37489999f,1.16979998f,-0.47200002f,-1.00259999f,-0.86459996f,0.81040001f,0.01200002f,2.23350000f,-0.13850001f,-0.35489997f,0.44539998f,0.13949999f,0.39689998f,0.79029997f,0.34450000f,-0.67780000f,0.01010000f,-0.16050002f,-1.19939998f,0.48689997f,0.20250000f,0.41220000f,0.33249999f,-0.66750000f,0.06210000f,0.36290001f,-0.64849997f,-0.34960000f,-0.71609997f,0.98100002f,-0.25949999f,0.61920000f,0.95299998f,0.34780000f,0.89540000f,-0.14999999f,-0.06210001f,-0.85119999f,-0.17850002f,-0.27720001f,0.07369999f,0.16800000f,0.83909998f,-0.55920000f,0.33500004f,0.38830000f,-0.37279998f,-0.31550002f,0.01160000f,0.70769997f,0.16050002f,1.13790000f,-0.35950000f,-0.37949999f,-1.02180002f,0.03670000f,-1.58559997f,0.02100001f,0.26960003f,1.61200001f,0.19420001f,0.07749999f,-0.44859998f,0.27860000f,0.92930002f,0.11020000f,-0.23460000f,-0.52389997f,-0.37940000f,-0.44140003f,0.39640000f,0.72019997f,-0.20940000f,0.72340003f,1.19089999f,-0.31110001f,-0.03900004f,-2.35560000f,0.01860001f,-0.00220000f,0.66880000f,-0.60520002f,-0.46580000f,-0.65499998f,-0.09960001f,-0.01469999f,0.46080000f,-0.54620002f,-0.21720004f,-1.14359996f,-0.75280003f,-0.31799999f,1.32539997f,-0.15139999f,-0.08180000f,0.56839998f,0.32200000f,0.33700000f,-0.45859999f,-0.04600003f,-0.84289998f,0.23859998f,-0.46350001f,0.87000000f,-0.51270000f,-0.42049999f,-0.15910000f,-0.03950000f,-0.38150001f,-0.20289999f,-0.64810000f,0.96949998f,-0.24890000f,0.54129997f,-0.02299999f,0.23419999f,-0.36779998f,-0.13450000f,0.38590000f,-0.66530000f,0.01749999f,-1.23819999f,0.42550001f,0.79200001f,0.15060001f,0.01640000f,0.47949999f,-0.29079999f,0.47309999f,0.72500001f,0.06250000f,0.04840000f,1.15500002f,-0.82079996f,0.51340000f,0.42699999f,0.71539999f,0.03900000f,-0.36499999f,0.42739999f,-0.10539999f,-0.49400001f,-0.75540002f,0.10710003f,2.03850000f,-0.33430003f,1.16890000f,0.08300000f,-0.51120000f,0.02820000f,-0.41159998f,0.57800000f,1.33519999f,0.55359998f,-0.73020000f,0.79840001f,0.90229998f,-0.82250001f,-1.45770001f,0.29279999f,0.12779998f,0.12959999f,1.37939997f,0.48080002f,0.64720002f,-1.25290003f,-0.44870003f,0.05080000f,0.44569999f,-0.19710000f,0.26530000f,1.90429997f,0.04030001f,0.25340002f,1.56640002f,-0.51060004f,0.41870002f,0.77440000f,-0.12200000f,-0.01740001f,-1.53570003f,-0.14910001f,0.87850002f,-0.57250004f,-0.60050003f,-0.93820001f,-0.90970001f,0.34800002f,0.94920000f,-0.35420001f,-0.19600000f,-0.35809999f,-0.75979999f,-0.77699999f,-0.02820000f,-0.07340000f,-0.03449998f,-0.21479999f,-0.91489997f,0.48250000f,0.04430001f,-0.56229999f,0.91100001f,0.48429998f,0.98839999f,-0.73449998f,0.87099998f,-0.43169997f,0.11600000f,-0.94490002f,-0.16440001f,0.21850000f,0.16010000f,-0.07110000f,-0.25999998f,0.97399999f,-0.52659997f,0.47350004f,0.60980001f,-0.34330000f,-0.15450000f,0.28830000f,-0.41190000f,0.21699999f,-0.86350002f,0.30580000f,0.14000001f,-0.68000002f,-0.41700000f,-0.40600004f,-0.76050004f,-0.32150001f,0.55460001f,0.45440002f,1.15679999f,-0.07620006f,-0.73120001f,-0.40279997f,1.67299998f,-0.01160000f,-1.35370003f,-0.36379998f,0.67240002f,0.67219998f,-0.79279999f,0.12020001f,0.64110002f,0.99930000f,-0.28210001f,0.33010004f,0.15379998f,0.59640003f,0.99470000f,-0.09140001f,0.20680001f,1.03980002f,0.32339999f,0.17920001f,0.18790001f,1.57489999f,0.28890001f,0.68789998f,-1.55129999f,-0.15489999f,0.85070003f,-0.26420000f,-0.07240000f,0.64390001f,1.13809998f,-0.38830001f,1.32320003f,0.82120002f,-1.05380004f,-0.95800003f,-0.19260000f,-0.36100000f,0.51190000f,0.04400001f,0.10250002f,-0.51500002f,-0.67709997f,0.30449999f,0.96419998f,0.01209999f,0.12299999f,0.29970000f,0.90840000f,-0.65149999f,-0.51219999f,-0.38189998f,-0.11049998f,0.31000000f,-0.57870000f,-1.02800003f,0.21949998f,-0.39420001f,-1.00799998f,-0.17310000f,-0.75539998f,-1.00750000f,0.02919999f,-0.85309999f,-0.52699999f,0.89839999f,-0.46679999f,-0.29800001f,-1.01179998f,-0.20580000f,-0.53400001f,-0.33150000f,-0.56140001f,0.02600001f,0.34720000f,-0.58179999f,0.39750002f,-0.17999998f,-0.88290000f,0.90850003f,-0.35520000f,1.06030002f,-0.05560004f,-1.02280004f,0.12919998f,-0.17569999f,-0.48990001f,-1.52399996f,0.49800001f,0.43799998f,1.13820000f,-1.01370005f,-0.02089999f,-0.79480000f,-1.09909996f,0.29350000f,1.68990000f,-0.55679998f,-0.35539999f,0.49950001f,-0.23760003f,-0.21940001f,0.70640001f,-0.29600002f,-0.73920003f,0.45220000f,-0.75520000f,-0.30140001f,0.24530003f,0.74170001f,0.72490000f,0.60570001f,-0.18240003f,-1.02920002f,0.01120000f,0.53150001f,-0.48110002f,0.76840001f,-1.44070002f,-0.05450001f,-0.00609999f,0.45489999f,-0.61010002f,0.17680002f,-0.54769997f,0.55650002f,-0.58410001f,-0.54810000f,0.54800001f,-0.28489998f,0.03960001f,0.55199998f,0.71159998f,0.93599996f,-0.81050000f,-0.76870002f,-0.65489998f,0.20999999f,-0.32909999f,0.70559997f,-0.78300001f,-0.74729998f,-1.06479999f,-0.08100000f,-0.29850001f,-0.27800000f,0.44800002f,-0.54640001f,-0.30880000f,0.06450000f,-0.59220000f,-0.13790000f,-1.13699999f,0.59219998f,-0.45960001f,0.90249999f,-0.56470000f,-0.19290000f,0.62000002f,0.11710001f,0.00360000f,-0.49000000f,-0.93470002f,-0.30480000f,0.80250000f,0.03600000f,0.05670000f,0.06300001f,0.81630003f,0.08580000f,1.39229997f,-0.19570000f,-0.44200002f,1.58770003f,0.06730000f,-1.08750002f,-0.41579997f,1.14380002f,-0.62130001f,0.84300002f,0.53640002f,-0.43049999f,-1.38599997f,0.13200001f,1.08370001f,-0.50500000f,-0.45260000f,0.33940002f,0.32629998f,-0.46250002f,-0.43240002f,-1.34210001f,0.51130002f,0.99300001f,1.07670001f,-0.72470003f,1.01220002f,-1.24950003f,-0.17510001f,-0.47609998f,-1.33559999f,-0.13360003f,-0.16699997f,-1.07229998f,-0.37370003f,0.49129997f,-1.38769996f,0.19630002f,0.22149999f,0.68869998f,-0.06170000f,-0.19619999f,0.10950000f,0.18550002f,0.65689999f,-0.25809999f,0.23050002f,0.95330002f,0.03850001f,-0.69249999f,0.37990000f,0.62250000f,-0.24800000f,0.75170001f,0.19660000f,0.15349997f,-0.60769999f,0.52249997f,-0.20650000f,-0.63409999f,-0.60990000f,0.35350001f,-0.04990001f,-0.20530000f,-0.34300002f,-0.45530001f,0.43580000f,0.20900003f,0.13210001f,-0.75499999f,-0.51350000f,-0.92170002f,-0.48990000f,0.53549999f,-0.66210001f,0.60369997f,0.61999999f,-0.66410000f,0.38399997f,-0.61400001f,-0.76719997f,-0.16459999f,-0.08699998f,0.30179999f,-0.26599998f,-0.15899999f,-0.38330002f,0.37149999f,0.46369996f,0.33430002f,0.78520001f,-0.92260002f,-0.27500001f,-0.91250002f,0.14389998f,-0.03089999f,0.05720000f,-0.62749997f,0.24889999f,-0.96000001f,-0.10020000f,0.44320000f,0.45560001f,-0.17420001f,-0.24060001f,0.47250001f,-0.11610001f,-0.92490003f,-0.08040005f,-1.14929999f,-0.19249998f,-1.56079998f,0.86480002f,0.38559998f,-0.00449999f,0.47429999f,-0.39730001f,-0.01050001f,-1.43609995f,-0.17590000f,0.68350001f,0.14179997f,-0.52080001f,0.67280001f,-0.10370002f,-0.87270002f,0.04609999f,-0.87439997f,0.28860000f,0.49320000f,-0.03770000f,-0.71650000f,0.28719998f,-0.42149998f,-0.21600001f,-0.73740001f,-0.35840001f,0.71599998f,0.24460000f,0.64900000f,-0.36549998f,-0.26029999f,0.01210000f,0.13050000f,0.28499999f,0.62450000f,-0.02100000f,-0.26340000f,-0.25220000f,0.86400001f,-0.46800000f,-0.12900000f,0.31849999f,-0.66049998f,0.29530002f,0.64600001f,0.89599999f,0.91159997f,0.52200000f,0.11820000f,0.00700000f,0.24649998f,-0.82099997f,0.28949998f,0.17600001f,-0.23510001f,-0.41299999f,0.64700000f,-0.48290000f,-0.28860000f,-0.40799999f,-0.37589999f,0.05380000f,-0.17800000f,-0.93120004f,-1.33210001f,-0.62689998f,0.84270002f,-0.33929998f,-2.08589995f,0.40429999f,0.46939999f,0.00460002f,-0.92480004f,1.13569998f,-0.28160004f,-0.03399998f,0.17949997f,1.23289998f,0.20210002f,-1.25270000f,-1.02459995f,0.96720004f,-0.70130000f,-0.88689999f,0.89830004f,0.62680000f,-0.22390002f,-0.56650001f,1.03930002f,0.45679995f,-0.90220002f,-0.16759998f,-1.06089998f,-0.04530001f,-0.52350003f,-0.41159994f,0.83360003f,-0.30630001f,-2.28719993f,0.23560000f,-0.22020001f,0.76800001f,0.05560000f,-0.05320001f,-0.12290000f,-0.74150002f,1.24770001f,-0.73940000f,-0.11500001f,0.21340000f,0.90119999f,-0.26750001f,-0.90519999f,0.51709996f,0.86550003f,-0.40319998f,-0.14730000f,-0.79550000f,-0.38350001f,-0.77489997f,-0.40499998f,0.68880000f,-0.38399997f,-0.33500005f,0.02870002f,0.88439997f,-0.65400005f,-0.02940000f,0.47259998f,0.28000000f,-0.43390000f,-0.29959999f,0.41100000f,-0.26670001f,-0.64560000f,0.18949999f,-0.54650000f,0.31269997f,-0.70350000f,0.16650002f,0.27550001f,-0.06950001f,-1.07589997f,0.56309998f,0.08600001f,0.47020001f,0.01840001f,1.01300000f,-0.30649999f,0.21740000f,-0.03249998f,-0.99320004f,-0.01030000f,-0.77870000f,0.31510001f,0.78410000f,-0.27350001f,-0.99430004f,0.25940001f,2.07909999f,0.02270000f,-0.03550000f,-0.29509998f,0.73010002f,0.67600001f,-1.00240002f,-0.34560001f,-1.01199999f,-0.51979999f,0.72280000f,0.14209999f,0.62619999f,0.46700002f,-0.43090001f,-0.37879995f,0.59100001f,-0.02310005f,-1.46850000f,-0.32870000f,0.87930000f,-1.75409999f,-0.12230001f,-0.77890000f,0.60370001f,0.13749999f,0.85269999f,-1.66150002f,-0.12709998f,-0.27720002f,-1.02359998f,0.55720001f,0.55520001f,1.34289999f,-0.08450000f,-1.09040000f,-0.65060001f,-0.40150001f,-0.30500000f,0.07309999f,0.72500003f,-0.63620000f,-0.31520000f,-0.23349997f,1.06210000f,-0.54829998f,-0.93000000f,0.09780000f,-0.07900000f,-0.04200000f,-0.78240001f,-0.25000000f,-0.19550001f,0.16699999f,0.67449998f,-0.72149999f,0.46349999f,-0.30969998f,-0.45399999f,0.08350002f,0.25380000f,0.45650000f,-0.88759998f,0.33670002f,-0.48149999f,-1.14600000f,-0.31810000f,0.39350001f,0.51999999f,0.43729999f,-0.45600003f,-1.09319999f,-0.31340000f,-0.51999999f,-0.30080000f,0.25840001f,-0.30799999f,0.57650000f,-0.61639999f,0.92149999f,-0.84580001f,-0.30749998f,-1.27289996f,-0.24510001f,-0.06490000f,-0.94039998f,0.57260001f,-0.41920003f,-0.25849999f,-0.63290003f,-1.23390003f,-0.89519998f,0.75940001f,0.35960004f,0.91449999f,0.49270000f,-0.09830001f,-1.24150002f,0.52490004f,-0.97060000f,-0.03739998f,-0.29380002f,1.20970002f,0.42799996f,-0.38860001f,0.29310003f,1.13250002f,0.73970003f,-0.03119998f,-1.23060001f,-0.06180001f,0.32130000f,-0.30480001f,0.04540002f,-0.17529999f,1.81840003f,0.28000001f,0.75200000f,0.15460001f,0.13440000f,1.09170001f,-0.47250003f,-0.70610002f,-0.03779999f,-0.37999999f,0.55649998f,-0.69959998f,0.49349996f,-0.69800001f,-0.29290000f,0.08580000f,1.14250004f,-0.27009999f,0.48490001f,-0.07700000f,0.02330000f,0.89280000f,-0.91800000f,0.58289997f,-0.52320001f,-0.60900004f,-0.46260001f,0.17160000f,1.10499999f,0.07040001f,0.77819998f,-0.38899999f,-0.14110002f,-0.87439999f,-1.19400001f,0.79560000f,-0.56420000f,0.11099998f,-0.66900002f,0.24539998f,-0.29600001f,-0.20950000f,-0.19259999f,-0.24750000f,1.09590001f,-0.24090000f,-0.73449997f,-0.01940000f,-0.60449998f,0.12000001f,-0.70440000f,-0.56739999f,0.87899999f,-0.03150000f,0.12340001f,0.17899999f,0.54880003f,-0.60790001f,-1.02049999f,0.05270000f,1.69630004f,-0.44890006f,-0.59650002f,0.06309996f,-1.88200002f,0.03020002f,-0.17379999f,-1.37120001f,-0.19140002f,-1.33839998f,0.63280001f,0.30440000f,0.62110001f,0.22579999f,-0.41960002f,1.60010004f,0.41889996f,-1.06370002f,1.47400002f,-0.72760005f,-0.51740001f,0.17960000f,-0.45560000f,0.31280002f,0.38799999f,-0.19720000f,-0.49880000f,-0.58560000f,-1.78529998f,0.52310001f,0.05110000f,0.18289998f,0.48330002f,-0.57819998f,1.40950000f,-0.06690004f,0.45700000f,-0.72210002f,0.12979999f,0.11480000f,0.44320002f,-0.57850000f,0.05320000f,-0.40120001f,0.18410000f,0.32170001f,-0.31509999f,0.04289999f,0.63129997f,0.81530000f,0.54299999f,-0.54689999f,-0.37650001f,-0.19859999f,-0.69760000f,-0.04160005f,0.51829997f,-0.73469999f,0.22769998f,-0.06550000f,0.03199999f,0.86919999f,-0.07210001f,0.88230000f,0.91710004f,0.09900001f,-0.60699999f,-1.20860005f,0.58569999f,-0.06189999f,-0.16909998f,0.60559999f,-0.26939999f,0.56100000f,0.71369997f,-0.44349996f,-0.82670002f,-0.03530000f,0.28920000f,1.03080000f,-0.04910000f,-0.57179999f,-0.46380002f,-0.18740000f,0.40760002f,-0.82319996f,-0.64739998f,0.40529998f,-0.90680002f,-0.43200000f,0.71550001f,-1.08560002f,-0.74060001f,0.53420001f,0.81580003f,0.48420002f,-0.40320001f,0.78410000f,0.29299999f,-0.62839999f,0.92649999f,0.62680000f,-0.41589999f,0.42370000f,0.58680001f,0.19170000f,0.02569999f,-0.31040002f,-0.46359999f,-1.19840001f,-0.86280002f,0.50579999f,0.55590000f,0.48180001f,-0.07529999f,0.82449999f,0.57679999f,-0.37969999f,0.76150000f,0.55419999f,-0.49180000f,-0.93340000f,-0.43879999f,0.64369999f,-0.51809999f,0.24360001f,-0.09590000f,0.01290000f,0.45930002f,0.46469998f,0.26880001f,1.25040001f,-0.05980000f,-0.02410001f,0.83350002f,0.34949999f,-0.49690001f,0.31509999f,-0.09490001f,0.90470001f,0.59590005f,0.23609999f,0.56080000f,0.12680005f,-0.27380000f,0.72979997f,0.20380001f,-0.70659997f,0.62180001f,0.48460004f,0.61659998f,-0.52730001f,-0.78130004f,0.46540001f,-0.76720000f,0.01839997f,-0.35690000f,0.80369997f,0.66810000f,-0.29079999f,0.44299998f,-0.14059999f,-0.36169999f,-0.69100001f,-1.83140006f,-0.10359999f,-0.68629999f,-0.16390002f,0.60999996f,-0.08120001f,-0.08630001f,0.14620002f,0.39470001f,0.83339997f,0.54679996f,-0.56269999f,0.33710004f,-0.18860001f,-0.77860002f,-1.00940003f,-0.40180000f,0.76840001f,-0.74100002f,-0.37540000f,0.59020001f,-0.43099998f,-0.25579998f,0.32149999f,-0.39480001f,-0.37980000f,0.11070001f,0.82630000f,0.51419999f,-0.52440000f,0.38790002f,-0.00440001f,-0.57700001f,-0.83099999f,-0.32299998f,0.63559999f,-0.75820002f,-0.39359999f,0.58860001f,0.46770003f,0.09300001f,-0.37920001f,-0.75880002f,-0.39540000f,0.46230002f,0.13599999f,0.17580001f,0.10830001f,0.30859999f,-0.59810001f,-0.34150000f,0.76490000f,1.23010005f,-0.26439997f,-0.47070000f,-1.55310001f,0.67769998f,-0.78079999f,-1.46680006f,-0.25909998f,-0.80709999f,-0.29030002f,0.00489999f,0.18509998f,1.00110001f,0.08329999f,0.24379999f,0.79899999f,0.35849998f,0.09239999f,0.55560001f,-0.18689998f,-0.03399999f,-0.86720000f,0.38279999f,-0.37229999f,-0.91350003f,-0.23049999f,-0.70289997f,-0.29970001f,0.02239999f,0.15879998f,0.97880001f,0.32969998f,0.91920000f,0.99240003f,-0.01290000f,-0.67339998f,-0.30459999f,-0.18330000f,0.60499998f,0.78340001f,0.31619999f,0.22380000f,-0.55370000f,-0.24460000f,0.41739999f,0.65260001f,0.39500000f,-0.39170000f,0.59620000f,0.36100000f,-0.28269999f,1.01540002f,0.33059998f,-0.87600002f,0.54089999f,0.10719998f,-0.61809999f,0.00830002f,-0.13159999f,-0.02770001f,-0.63400000f,-0.03139998f,0.74299999f,-0.35920000f,-0.22360000f,0.11350000f,-0.87850000f,-0.65139999f,0.45490000f,0.35049998f,0.32539998f,-0.20300000f,-0.26140002f,0.08419999f,0.32290000f,-0.67839999f,-0.44499999f,0.32440000f,-1.31950002f,-0.94620001f,0.59640000f,1.04220001f,0.66339999f,-0.63340002f,-0.61630002f,-0.77910000f,-0.08709999f,-0.28840001f,0.08319997f,-0.11490000f,0.20600001f,-0.32359999f,-0.08230001f,0.68720000f,0.47440004f,0.40030000f,0.67869997f,0.09949999f,0.32719999f,-0.12900000f,-0.69180000f,0.30939998f,0.87699999f,1.36940004f,-0.59709997f,-0.43309998f,-0.10750001f,0.04640001f,-0.74629997f,-0.79750001f,0.41089997f,0.13929999f,1.09970001f,-0.32289997f,-0.69039999f,-1.43000001f,-0.46709996f,-0.79760000f,-1.01680004f,0.17409999f,-0.50689997f,-0.10929999f,0.51569999f,-0.61040001f,0.38119998f,-0.26169997f,0.03210001f,-0.98070001f,-0.04290001f,-0.12090001f,0.32369998f,0.30679998f,-0.15079999f,0.17469999f,0.39060001f,0.17460000f,0.61729998f,0.38139998f,-0.38799998f,1.04250005f,0.28480000f,-0.92830003f,-0.00429999f,-0.13420001f,-0.13790000f,0.79139999f,0.48559999f,-0.43099999f,0.42209999f,0.32620000f,-0.16929999f,-0.07640000f,-0.01740000f,-0.03540000f,-0.95540000f,-0.69760000f,0.50289999f,0.34290000f,-0.17000003f,-0.73689999f,-0.42229999f,-0.34679999f,0.17670000f,-0.39800000f,-0.23920000f,0.13780000f,0.67290002f,0.30020000f,-0.52460001f,0.12710001f,-0.01680001f,-0.29940001f,0.99950002f,-0.68069999f,-0.30159997f,-0.44069997f,-1.01789998f,-0.60789998f,-0.22360000f,-0.56720002f,-0.13210000f,0.02020000f,-0.57699998f,0.52919998f,0.91440002f,0.44760004f,0.26389999f,0.05170000f,0.10730000f,-0.14120000f,0.49319999f,-0.01799997f,-0.21310000f,0.16169999f,-0.17790000f,-0.07850000f,-0.78129997f,-1.13570002f,0.42420000f,0.12469999f,1.15270001f,0.65539999f,-0.59159997f,-1.18319999f,0.26299998f,0.04040000f,0.49360000f,0.03520000f,-0.81099997f,-0.86060000f,0.09370000f,0.21300000f,-0.31380001f,0.12740001f,-0.74089998f,-1.25170003f,-0.34399997f,0.35020000f,-0.10890001f,0.13360000f,0.20570000f,0.42090001f,0.35720001f,-0.05780000f,-0.33480000f,0.25380003f,0.82439998f,0.12150000f,0.08799999f,-0.11860000f,-0.92210000f,-0.34919998f,0.75689999f,-0.52549996f,-0.43519997f,0.25399998f,0.96710002f,0.75140002f,-0.38690001f,0.82859997f,0.64879999f,-0.40819997f,0.11080001f,-0.22440001f,-0.34530000f,-0.23320002f,-0.03260000f,0.28820001f,0.37499999f,-0.18240003f,-0.75089998f,0.51970003f,0.04940000f,-0.63230001f,-0.61750002f,-0.06760000f,0.67480000f,0.29270001f,-0.21800003f,-0.72970001f,-0.46199999f,0.84360001f,-0.40199998f,-0.59819997f,-0.85139999f,-0.25280000f,0.66030000f,0.58710003f,-0.81209997f,0.61649999f,1.19970001f,-0.06899999f,-0.37409999f,-0.69930001f,-0.26140000f,-0.50559999f,0.08919997f,0.34619997f,0.30469999f,1.00749998f,-0.49729999f,0.34690000f,-0.44470001f,-0.46119999f,-0.25080000f,-1.22760000f,0.57319998f,0.36770000f,0.51010002f,-0.16610000f,0.09790000f,0.36110002f,0.72539998f,-0.30749998f,-0.77069998f,0.42729998f,0.02270001f,-0.42890002f,-0.51039997f,-0.46909999f,-0.17110001f,0.69819999f,-0.62779999f,-1.18660002f,0.29490000f,-0.63579999f,-0.12030003f,0.20020000f,0.46250001f,-0.39610001f,-0.55840003f,-0.19760000f,-0.48619999f,-0.22299999f,0.38829999f,-0.23220000f,-0.29620001f,0.01690000f,0.97959999f,0.72859999f,-0.42589999f,0.09300000f,-0.12960001f,-0.27299999f,0.05790000f,-0.28160002f,-0.40210000f,-0.10050000f,0.35800004f,0.65060001f,0.93820000f,0.44279999f,-0.71460000f,0.41789999f,0.43320000f,-0.03480000f,0.84890001f,0.42779999f,-0.60930000f,1.22140002f,0.96080002f,-0.40640001f,0.48379998f,0.10399997f,-0.58219998f,-0.40839999f,-0.33080000f,0.10460000f,-0.50060001f,0.49560003f,-0.49449998f,0.50969998f,0.85650002f,0.67780000f,-0.62990000f,-0.52630002f,-0.05070000f,-0.04660000f,0.39339999f,0.36549999f,0.28019999f,0.68820001f,-0.43849998f,0.36920001f,-0.41719996f,0.34959998f,-0.02040000f,-0.09000000f,0.61399999f,-0.04920000f,-0.07679999f,-0.77600000f,0.75209998f,1.18530001f,0.07940000f,0.22700000f,-0.54980000f,-0.42679998f,0.21629999f,-0.10890000f,0.02010000f,0.24970000f,-0.43389999f,-0.63039999f,0.89659997f,0.14379998f,0.26479999f,-0.37159999f,-1.01559999f,0.22339999f,-0.43639998f,-0.25720001f,0.13139999f,-0.39050000f,0.51850002f,-0.06340003f,-0.82220001f,0.03030000f,-0.17060001f,-0.15310000f,-0.90319998f,-0.47079998f,0.62739998f,0.27330001f,-0.13280000f,-0.42880000f,0.76669999f,0.18039998f,-0.75129999f,0.74430001f,0.60980001f,-0.36470000f,-0.74749999f,-0.70640000f,0.07940000f,0.21200002f,0.24920002f,0.12550000f,0.28230000f,0.08279999f,-0.28110000f,-0.15009999f,-0.46220002f,-0.41380000f,0.67110003f,0.08839999f,-0.80780002f,-0.05020000f,-0.22780002f,-0.20510000f,0.17160000f,0.37360003f,0.28490001f,0.32150002f,0.16100001f,-0.13100000f,-0.73900004f,0.77400005f,0.62990000f,-0.40479998f,-1.06760001f,0.39289999f,0.53009998f,0.82170001f,0.00860000f,-0.28719999f,0.43119998f,0.56459997f,0.56309998f,0.65310000f,0.43579999f,0.43419998f,-0.03339999f,-0.47649999f,-0.41489997f,-1.40010001f,0.60939997f,-0.78669998f,-0.43430003f,-0.24120001f,0.84130001f,1.06850005f,0.12099999f,0.00720000f,-0.25080000f,0.73609997f,-0.61279999f,-0.73240002f,0.49720000f,-0.09749999f,-0.75390002f,0.39610000f,-0.09920000f,-0.06880000f,-0.53900000f,0.61050000f,0.72570004f,0.04049999f,0.76600001f,0.87200005f,-0.69179998f,-0.54810002f,-0.45590000f,-0.32100001f,0.15930000f,0.36190002f,0.05680001f,-0.30579999f,0.34189999f,-0.02880003f,-0.57779999f,-0.16690001f,0.16580001f,0.32110001f,-0.63949998f,-0.34279998f,0.50539999f,0.05860002f,-0.23540001f,-0.34660001f,-1.09890003f,-0.73140001f,0.57090001f,-0.94509998f,-0.69579998f,0.47709999f,-0.91510000f,-0.75720000f,0.35159999f,-0.48810000f,-0.59460002f,-0.12660000f,-0.26750000f,0.00940002f,0.47600000f,-0.44150000f,-0.34380000f,0.24029999f,0.22210001f,-0.16260001f,-0.47700000f,0.77810003f,0.12319998f,-0.78920002f,0.84590003f,0.14670000f,0.15010000f,-0.56650000f,-0.41810002f,0.28659996f,0.74270000f,0.81910003f,0.37420000f,-0.60169998f,-1.22289999f,-0.52369998f,-0.58550000f,-0.78670003f,0.04679999f,0.27469999f,1.04469999f,0.52449999f,-0.02050000f,-0.04130001f,0.32050000f,-0.43949999f,0.41370003f,0.42669998f,0.03070000f,0.99829999f,0.57359998f,-0.07790000f,0.81530000f,0.65349999f,-0.70019999f,-0.54780002f,-0.25490000f,0.72859997f,1.35700001f,0.24830000f,0.27110000f,0.86590002f,0.54669998f,0.01280000f,-0.14600000f,0.57339999f,0.71229998f,0.39590000f,-0.35260000f,-0.32650000f,0.86200003f,0.36580001f,-0.59350000f,0.64680001f,0.39720000f,-0.34650000f,0.32879998f,0.33599998f,-0.16680000f,-0.73209999f,-0.42879997f,0.56890001f,0.01760000f,0.32120001f,0.34209999f,-0.56050000f,-0.48860000f,0.30050000f,0.00310001f,-0.03099999f,0.00850000f,0.65040002f,0.33440001f,-0.37520000f,0.13490001f,0.14520001f,0.06540000f,-1.21389998f,-0.89020000f,0.49959998f,1.15459999f,0.63019999f,-0.68809998f,0.73760001f,0.34519999f,-0.56450001f,-0.46479999f,-0.13959997f,0.55569999f,0.93920000f,0.48139999f,-0.66140000f,0.19860000f,0.10800000f,0.18769998f,0.93620001f,0.62500004f,-0.11440000f,0.43889999f,0.04049999f,-0.36719996f,-0.72119996f,-1.46039998f,0.13519997f,0.52300000f,1.52420004f,-0.61759997f,0.02110000f,-0.03970000f,0.43509999f,0.70509996f,1.66550001f,0.07909999f,0.31670001f,0.49150003f,0.02799999f,0.75120000f,0.53040003f,-0.12680000f,0.53950000f,0.68870002f,0.50530000f,-0.73999997f,0.07879999f,-0.04210001f,0.91239999f,0.28520004f,0.06840000f,0.18250000f,-0.42550001f,-0.16320001f,0.63070001f,1.40510004f,0.00730000f,0.30010000f,-0.44469999f,0.64080000f,0.63780001f,0.29710001f,-0.07920001f,-0.52950000f,0.24470001f,-0.06600002f,-0.49590001f,-1.04599999f,-0.38899998f,0.82129998f,-0.37710001f,-0.27980001f,0.07070000f,0.01739997f,0.31700000f,0.37810001f,-0.02800000f,-0.08980000f,0.03610000f,0.49310001f,0.18640000f,-0.40270000f,-0.54940002f,-0.02839998f,0.69830001f,0.50360003f,-0.03600001f,-0.66030002f,-0.43029999f,-0.18879998f,0.46390000f,0.44740000f,0.57140001f,0.11890000f,0.62300000f,0.58400001f,-0.07970001f,-0.66370000f,-0.22619998f,0.68579999f,-0.01929999f,-0.16500000f,-0.18240000f,-0.19920000f,-0.01110000f,0.44279998f,-0.29859999f,-0.70700001f,0.34820000f,-0.63800000f,-1.18720006f,-0.32449999f,-0.87519998f,-0.36560004f,0.13870001f,-0.76770000f,-0.80490004f,-0.59709997f,0.29039999f,0.37680002f,0.18029999f,0.66639998f,1.06880002f,0.14119999f,0.28660001f,-0.02259998f,-0.49800000f,-0.00410000f,0.47990001f,0.59459998f,0.33489999f,0.08209999f,-0.02800001f,0.69460001f,1.48220005f,-0.65949998f,0.46280001f,0.22120004f,-0.50099998f,0.60130001f,0.27890004f,-0.20350000f,0.38559996f,1.21639998f,0.30069998f,-0.14599999f,-0.17920001f,0.14100000f,-0.57120001f,-0.71860000f,-0.56500000f,0.26740001f,-0.12280000f,-0.02879999f,0.22500000f,0.63089997f,0.48699999f,-0.31479998f,-0.43609998f,-0.15879998f,0.40569998f,-0.06130000f,0.12400001f,0.15500000f,0.06540000f,0.00160000f,-0.03940000f,1.08510001f,0.59700000f,-0.65100000f,0.29269999f,0.38760001f,0.12390001f,0.44600000f,0.34719999f,-0.32320001f,0.61930000f,0.28699999f,-0.47960000f,0.21159999f,0.37900000f,0.23600000f,0.35490001f,0.08500000f,-0.30969999f,0.88020000f,0.44279999f,-0.55409999f,-0.49889999f,-0.15139998f,0.50509998f,-0.15359999f,-0.58210001f,0.37889998f,-0.34129999f,0.20270000f,-0.03800001f,0.62620000f,1.07900004f,-0.33610000f,-0.16500000f,-0.89340000f,-0.12379999f,0.03080000f,0.45759998f,-0.32779999f,-0.44209998f,-0.65050001f,0.07679999f,0.30480000f,0.41280001f,-0.05190000f,0.79319999f,0.16800002f,-0.44940000f,0.50619997f,0.45619998f,-0.27519997f,-0.80839996f,-1.69960001f,0.06230000f,0.13700000f,-0.38179999f,-0.50989998f,0.59869997f,0.67150000f,0.20989998f,0.44310000f,0.35790003f,0.04639999f,0.78149999f,0.35670004f,-0.19949999f,0.08069999f,0.58829998f,-0.20680000f,-0.90910001f,-0.44730001f,0.04140001f,0.54840000f,-0.47840000f,0.13020003f,0.83339998f,1.09190003f,0.58040001f,-0.68480002f,-0.68060000f,-0.52579999f,0.35630001f,-0.36650000f,-0.46100001f,-0.11140000f,-0.70110005f,-0.05220001f,0.78810001f,-0.94150005f,-0.30180001f,0.84000002f,0.44440000f,0.21080000f,-0.26509999f,0.71529999f,0.19179998f,-0.63369998f,0.13050000f,0.28840001f,0.20510000f,-0.93739999f,-0.40899999f,0.70149998f,-0.25419999f,0.29420003f,0.74949998f,0.08780001f,-0.04920001f,-0.22140001f,1.14260000f,0.71080000f,-0.63129999f,0.20360002f,-0.12029999f,-0.56169998f,-0.62159999f,-0.57480002f,-0.72509996f,0.33290000f,0.90970001f,-0.01400000f,0.75309999f,0.10309999f,0.36869997f,0.29239999f,1.14040001f,0.51949997f,-0.52540000f,-0.40820004f,-0.62989996f,-0.57090002f,-0.25770002f,-0.37369998f,-0.48020001f,0.13700000f,0.05759999f,0.58789999f,0.48070002f,0.37249998f,0.67610000f,0.38290005f,-0.42339998f,0.35520000f,0.38280002f,-0.16089999f,-0.56080001f,0.02799994f,-0.81489997f,0.52839998f,0.98599999f,0.17100000f,-0.32660000f,-0.57220003f,-0.22920000f,0.57909999f,-0.23289999f,0.17789997f,-0.80190001f,-0.49900001f,-0.15979999f,0.48680000f,0.98530003f,0.51860001f,-0.58400001f,-0.11269998f,-0.46960002f,-0.47870001f,-1.08650000f,-0.59099999f,0.71159999f,0.04920001f,0.10400002f,0.15520000f,-0.46570000f,-0.03599999f,0.50100000f,-0.76580000f,-0.58740000f,0.27690000f,-0.63029999f,-0.24539999f,0.50489998f,0.44780000f,0.52740002f,0.10740001f,-0.44619997f,-0.09019996f,0.61219998f,0.31220001f,0.19660000f,-0.25660001f,-0.41830003f,-0.08579999f,0.57540002f,-0.70359998f,-0.19919997f,0.69359998f,-0.16960000f,-0.41880002f,-0.29070000f,0.83889998f,0.17330003f,-0.18570000f,0.02110000f,0.49790001f,0.00969999f,0.94400000f,0.50200002f,0.78639998f,-0.65799999f,-0.83360003f,0.05450000f,-0.44739999f,0.36579999f,-0.12480001f,0.68760000f,0.99960004f,-0.42219998f,-0.51889998f,-0.38650000f,0.36709999f,-0.52780000f,-0.03980002f,-0.16689998f,-0.37830001f,0.01169996f,-0.56010000f,0.72009997f,0.62570000f,-0.23450000f,0.80049999f,1.64210002f,-0.09389999f,-0.41929998f,-0.95530001f,-0.21650001f,0.76959997f,1.56920003f,-0.32040000f,-0.11840000f,0.46879997f,0.64519999f,-0.29210000f,-0.22810001f,-0.34819998f,-0.43640000f,0.51059999f,0.57300000f,0.04980000f,-0.85790000f,-0.33739998f,0.74209999f,1.20590003f,0.82680002f,-0.59850001f,-0.39550000f,0.10460002f,0.57550000f,-0.93040000f,-0.76840001f,0.27969999f,-0.77750004f,-0.23179999f,0.77360002f,1.05519999f,0.78039999f,-0.51160000f,-0.16549998f,-0.35380000f,-0.12890000f,-1.25030001f,-0.98740002f,0.41859999f,0.06179999f,0.25680001f,0.27420001f,-0.28450001f,-0.16420000f,0.21070001f,-0.23440001f,-0.43180003f,-0.29990001f,-0.67229997f,-0.53999999f,0.28019998f,0.34910002f,0.12820001f,-0.19300000f,1.01319999f,0.60280000f,-0.59489997f,0.55049999f,0.30090002f,-0.20249999f,-0.12430000f,0.61929999f,-0.39940000f,0.48700000f,-0.45100002f,-0.62709999f,-0.45709999f,-0.37750003f,0.55600000f,-0.60769997f,0.01310001f,-0.32470000f,0.00439999f,0.72880002f,-0.47819998f,0.07940000f,-0.93980000f,0.54929997f,0.33290001f,0.72130003f,0.65510000f,-0.87160000f,-0.07520002f,-0.42599999f,0.44400001f,0.58560005f,0.04369999f,0.11589999f,0.45710001f,0.58090000f,-0.82940000f,-0.99820004f,0.39019999f,-0.03390000f,0.63209998f,0.13689998f,0.84399999f,0.97400003f,-0.06100000f,-0.28320000f,-0.89530002f,-0.58360001f,0.46600001f,0.26409999f,0.42660001f,0.16020000f,-0.19789998f,-0.29219999f,0.06120000f,-0.16310002f,0.22260002f,0.55890002f,0.34110001f,0.46920002f,0.16020000f,0.41739998f,0.33759998f,-0.27039999f,0.24590001f,0.01460000f,-0.26090000f,0.60080000f,0.04659998f,-0.61239999f,-0.18729999f,-0.20399998f,0.14640000f,-0.60260001f,-0.30640000f,0.44800000f,0.49519999f,0.27199999f,-0.27799999f,-0.48830002f,0.10840002f,0.78830000f,-0.75090001f,-0.48740000f,0.38780001f,0.52530003f,0.15280000f,-0.60190002f,-1.04870003f,0.24700000f,-0.44990001f,0.01890002f,-0.07550000f,0.50380001f,0.57679999f,0.42550001f,0.34689999f,-0.72490001f,-0.10070000f,-0.72629998f,0.03470001f,0.05530000f,0.20670000f,-0.69569998f,-0.46920000f,-0.04679996f,0.77439999f,0.06140000f,-0.43489999f,-0.11509993f,-0.46549999f,-0.86689998f,0.66530000f,0.06360000f,-0.76940002f,0.10040000f,0.17120001f,1.10820002f,-0.53540003f,-0.16180001f,0.07249998f,-0.96729998f,-0.43950000f,-0.70700000f,-0.35579999f,-0.46920001f,0.65550001f,-1.33549998f,-0.58809998f,-0.99159998f,0.54459999f,0.07450000f,0.46280000f,-0.02429999f,0.41660002f,-0.16820001f,-0.50210002f,0.46019998f,-0.87839999f,-1.21949999f,0.71880002f,-0.42380001f,-0.92780002f,0.42260001f,-0.75340001f,-0.56230003f,-0.20460001f,0.31060001f,-0.23029999f,-0.51499999f,0.09519998f,0.13809998f,-0.25280000f,0.55560000f,0.10760003f,0.34560001f,0.67239999f,-0.27319999f,-0.59760000f,-0.38140000f,0.63839999f,0.33159999f,-0.84960002f,-0.35900002f,0.10940000f,0.41260001f,-0.37049995f,-0.27960000f,0.57879999f,0.34860002f,-0.64340001f,0.85320002f,1.66190003f,0.50000000f,-0.25619999f,-0.15000001f,-0.00040000f,-0.26640000f,-0.44950001f,0.44830002f,0.07810000f,-1.29359998f,-0.05819999f,-0.29190000f,-0.84110001f,0.67250002f,0.05220000f,-0.45749999f,0.03270003f,-0.31190001f,-0.43610002f,-0.09790000f,0.18630001f,-0.06870004f,-0.67649998f,-0.10419999f,-0.04090000f,0.03589999f,0.29130000f,-0.27890003f,0.96589996f,0.59969999f,0.60980002f,-1.09619997f,-0.52630000f,-0.21999998f,-0.15240000f,-0.43340002f,-0.48699998f,0.42439999f,0.36740000f,0.26230000f,0.03389998f,0.26470000f,1.79570003f,-0.19090003f,0.15780000f,0.06490001f,0.53809999f,-0.00860001f,-0.53949998f,0.56640001f,0.57540002f,0.06940000f,-1.00390000f,-0.66799999f,0.76219998f,1.46599998f,-0.97340003f,-0.21199998f,1.27290001f,0.60220002f,-0.14100000f,-0.07650003f,0.63740002f,-0.43580000f,-1.00930001f,0.37739999f,-0.34999999f,-0.75609997f,0.12540001f,-0.52560000f,-0.54690001f,-0.53380001f,0.59839999f,0.92470000f,-0.67320002f,-0.03059999f,0.84460001f,0.49060000f,-0.09339998f,-0.01550002f,0.62960002f,-0.45360000f,-0.99640001f,-0.18540001f,-0.22800000f,-0.63629998f,0.31780002f,-0.24200000f,0.01489996f,0.24740001f,0.09080000f,-0.58189998f,-0.47719999f,0.24249999f,-1.06640002f,0.80860001f,0.35900001f,1.53609998f,-0.30910003f,0.11659999f,1.25310003f,-1.47230000f,-0.61079999f,0.19610000f,0.77710000f,0.08929999f,-0.98530000f,0.53730002f,0.03210000f,-0.78199997f,0.23860000f,-0.02110000f,-0.60240000f,-0.23939997f,-0.24450000f,0.90269999f,-0.27590003f,0.12139999f,0.80580001f,-0.93820001f,-0.33790000f,0.21910000f,0.65250000f,0.08070000f,-0.96979999f,0.51420003f,0.01580000f,-0.90030000f,-0.49049999f,-0.11819999f,0.19619998f,0.29480002f,-0.07550000f,-0.66419999f,0.37840000f,0.21770000f,0.41129998f,0.48719997f,0.35940000f,-0.15680000f,-0.23189999f,-0.34780000f,0.39440000f,0.44610001f,-0.13140000f,0.23200000f,-0.19929999f,-0.74220003f,0.05539998f,0.23210004f,-0.65959999f,0.04279999f,0.71379998f,0.16079999f,-0.44440001f,-1.07039999f,0.66620001f,0.25500001f,-0.11730000f,-0.05200000f,-0.06420000f,0.52359997f,0.48260000f,-0.83460000f,-1.11830001f,-0.35220000f,0.60399999f,1.22429998f,0.15820000f,0.42400000f,0.71350000f,0.21180000f,-0.39099999f,-0.11090003f,0.45700001f,-0.98960001f,-0.67990003f,-0.62780002f,0.75980000f,1.07650002f,0.61180002f,-0.05269999f,-0.12049998f,0.39569999f,0.03039999f,0.38099999f,-0.19000001f,0.10470000f,-0.35180002f,-0.04400000f,0.14930001f,-0.04569999f,-1.03070003f,-0.21090001f,0.63069999f,-0.87689998f,-0.26490000f,-1.28710001f,-0.17429999f,-0.10330000f,0.12550000f,1.15129997f,0.38470000f,0.67509999f,-0.07730000f,-0.13440000f,-1.15459999f,0.01480004f,-0.27000000f,1.38249998f,0.02069996f,0.13479999f,0.96660001f,0.59759996f,0.23329998f,-0.00190001f,0.02150002f,-0.19010000f,-0.56909998f,-0.09609997f,-0.44660001f,1.04050000f,-0.28530005f,0.18269999f,-0.99480001f,0.40829994f,-0.24439999f,0.51739998f,0.89179997f,0.13860001f,0.64480001f,0.48490001f,-0.38499998f,0.43079999f,0.63509998f,-0.74520003f,-0.08880001f,-0.03139998f,-0.13300001f,-0.23220001f,-0.07970000f,-0.32319999f,0.42639999f,0.24560000f,-0.13099999f,0.36380000f,0.26050001f,-0.20780000f,0.19620001f,0.87129998f,0.52759999f,-0.88300002f,-1.18260001f,-0.88880000f,-0.23200002f,1.05039995f,0.18240000f,-0.44959999f,-0.50840000f,-0.04160000f,-0.06119999f,0.56159997f,-0.48460002f,0.23080000f,0.44930002f,-0.46960001f,0.12420000f,1.02799999f,-0.49800003f,-0.55100001f,1.00359996f,0.08839997f,0.15469999f,0.62950001f,0.70729998f,0.41160000f,0.60909997f,-0.20229999f,0.09160000f,-0.37830002f,-1.16110001f,-0.27250000f,-0.14000000f,-0.36860000f,-0.18600000f,0.12379998f,-0.14820000f,0.16260001f,0.24039999f,0.09060000f,0.17340000f,1.03130000f,-0.08970000f,-0.05149999f,-1.21289999f,0.04070001f,-0.28080001f,1.00089997f,-1.38149998f,-0.56790000f,-0.53389999f,-0.09789998f,-0.18150000f,0.72979998f,-0.05660000f,-0.13480000f,0.34070000f,-0.50790002f,-0.04740000f,1.12480000f,-0.51240001f,-0.19930000f,0.85100000f,-0.60909996f,0.08280001f,0.40680000f,0.62979997f,0.09320000f,0.28660001f,-0.34419998f,0.98580000f,0.36060000f,-1.06469996f,-0.20160000f,0.20340000f,0.58599999f,0.65760000f,-0.15919998f,-0.34999999f,0.31759998f,-0.63099998f,-0.94239997f,-0.30420001f,0.84620002f,0.62590004f,-0.45919998f,0.87440000f,1.20319999f,-0.27840001f,-0.49700001f,-0.35600001f,0.31620002f,-0.00700000f,-0.35790001f,-0.84119999f,-0.33540002f,0.73619995f,-0.64220002f,-0.08459999f,0.50250002f,0.58760001f,0.19980000f,-0.06020001f,-0.89040002f,-0.28600001f,1.03919998f,-0.12180000f,0.62279999f,0.82289998f,0.46729998f,0.21170000f,-0.44500001f,0.31260000f,0.27270001f,-0.98969999f,1.61489995f,0.68609999f,0.65640000f,-0.10000001f,-0.00370000f,-0.13729998f,0.82190000f,0.13230000f,-1.02299996f,-0.06659998f,-0.20389999f,0.58580001f,0.21319997f,0.40060001f,1.27299998f,0.05540000f,0.29180001f,-0.54170001f,-0.79569998f,-0.36960000f,-0.32470001f,0.42870001f,0.13850000f,0.62009996f,-1.41269996f,-0.57960000f,0.37460002f,-0.96079999f,-0.31659999f,0.17080000f,1.00119997f,0.31589999f,0.99170000f,-1.42350000f,-0.60370001f,0.51599998f,-0.10759998f,0.59020001f,0.23419999f,-0.72289999f,-0.35280001f,-0.63220003f,0.31359997f,0.38299999f,-0.20439999f,-0.45569999f,0.07220000f,-0.48680002f,-0.60310001f,-0.33979999f,0.79919998f,0.60929999f,-0.28720000f,-0.23600000f,0.10679999f,-0.42920001f,-0.46720002f,0.09219998f,0.83960002f,0.42460003f,-0.98299996f,-0.67320001f,0.37959999f,0.71380001f,0.02120000f,0.52660000f,0.19980002f,-0.56060001f,0.37660000f,0.59450001f,-0.19920002f,0.97000002f,0.23400008f,-0.67599999f,0.11759999f,0.95079997f,0.00440000f,-0.30479999f,0.08699998f,0.29000001f,0.00980001f,-0.70760000f,0.97259998f,0.43559999f,0.32420000f,-0.94419999f,-0.58010001f,-0.39959998f,0.37699999f,0.03690000f,-0.70600000f,-0.29459999f,-0.22530001f,0.55279996f,0.12579997f,0.36050000f,0.03500000f,-0.58179997f,-0.26019999f,-0.02330001f,-0.95729999f,-0.45750000f,-0.95739998f,1.45300000f,0.67570001f,0.58479999f,-0.65560001f,-0.03840000f,0.21200000f,0.42559997f,0.33770000f,0.47999999f,-0.50260001f,0.00940000f,0.10240003f,0.42239996f,0.57220000f,0.92739997f,-0.82699998f,-0.25260000f,0.15280000f,-0.20439998f,-0.21980000f,-0.47280000f,-0.51610002f,-0.93300002f,-0.15920002f,1.01069998f,-0.04460001f,-0.42580001f,-0.62989999f,0.56999999f,-0.42079999f,-0.60779999f,-0.31920001f,-0.44700000f,-0.42079998f,-0.67120000f,-0.05160002f,0.26400000f,-0.45139999f,0.87860002f,1.31390000f,-0.10640000f,-0.72659999f,0.13519998f,0.31840001f,0.12700001f,-0.78559999f,-0.28480000f,0.04720000f,0.28439999f,-0.56860001f,-0.55440000f,0.55049997f,-0.84760004f,-0.03620001f,0.80540001f,-0.23700001f,-0.33280001f,0.04869998f,0.43400002f,0.40300001f,-0.53419999f,0.03700000f,-0.03200000f,-0.59150000f,0.86920003f,-0.29210001f,0.91929999f,-1.39770001f,-0.52520001f,-0.80299999f,-0.42479999f,-0.21360001f,-0.48799998f,0.48359999f,-0.03500000f,-0.65219998f,-0.82539997f,-0.33789999f,0.04209999f,-1.00029999f,-0.26810000f,1.42239998f,0.07939998f,0.28100001f,0.21440002f,-0.66519996f,-0.54749999f,-0.90450002f,0.49110000f,0.29240001f,0.23749999f,-0.36009999f,-0.09130000f,0.52750000f,-1.18509996f,-0.62359999f,0.67340001f,-1.20180002f,-0.38670001f,-0.00700001f,-0.58239999f,-0.30350001f,-0.55090002f,0.88030001f,0.47860001f,-0.76050002f,-0.01949999f,0.07400001f,-0.18540000f,0.13500004f,0.03220000f,-0.24060000f,0.19809999f,-0.14959999f,-0.20939999f,-0.53199999f,-0.72480000f,0.00259998f,1.07479996f,0.20460001f,0.47420002f,0.55870000f,0.57079999f,-0.43659999f,-1.01259998f,-0.36500002f,-0.39900001f,0.06230000f,0.47300002f,-0.74900002f,-0.64470006f,0.48059999f,-0.85899999f,-1.05770000f,0.32680000f,-0.94100001f,-0.90100002f,-0.29620001f,-0.64520001f,0.30269997f,0.64780000f,-0.09000000f,-1.15569997f,0.29820000f,-0.49820002f,-0.80810001f,-0.48980001f,-0.33840001f,0.19389999f,-0.65040004f,-0.22060002f,-0.06799997f,-0.48160001f,0.04980000f,0.30500001f,-0.10800000f,-0.18380000f,-0.74800001f,-0.41559996f,-0.11009998f,1.08199997f,-0.97039999f,-0.36330000f,0.77780001f,0.68839999f,0.30340000f,-1.02059997f,0.43860001f,0.01270000f,-0.04090000f,-0.81670000f,-0.38790000f,-0.54340003f,0.10280003f,-0.28240001f,-1.07259998f,-0.00039998f,-0.29600000f,-0.92759999f,-0.27159997f,-0.41930000f,0.33770000f,-0.87129998f,-0.57100000f,-1.21449998f,0.78770000f,0.29280000f,-0.87020001f,0.01160000f,-0.13800001f,0.06770000f,-0.94529998f,-0.40160000f,-0.36699999f,-1.11940002f,-0.32990001f,1.07110002f,-0.03590000f,-0.39540001f,0.09400000f,-0.23289999f,-0.25040001f,0.33980000f,0.15720003f,-0.32159999f,0.63599998f,1.24079996f,0.68840002f,-0.61319999f,-1.41620001f,0.36240000f,0.51620000f,0.02200002f,0.45179999f,-0.81100002f,-1.46969998f,0.07740000f,-0.13340000f,-0.38490001f,-0.21280001f,0.15520000f,-0.22479998f,0.18840000f,0.05780000f,-0.50619998f,0.33059999f,-0.89680001f,-0.41030003f,-0.49179999f,0.44399999f,0.11650001f,-0.53120001f,0.29260000f,0.55600002f,0.70480001f,-0.24859999f,-1.24999999f,-0.60180000f,0.42379999f,0.62950001f,-0.72000002f,-0.30489999f,-0.50300002f,-0.53359999f,-0.01689999f,0.05110001f,-0.11090001f,0.13720000f,1.41479995f,0.08999997f,0.16319999f,-1.47830000f,0.45010005f,-0.01589998f,0.13730000f,0.90409996f,0.45519999f,-1.63599998f,-0.04379999f,-0.21220001f,-0.45680001f,-0.01499999f,-0.01339999f,-0.41440001f,-0.22080000f,0.07680001f,-0.58780000f,0.27460000f,0.16710000f,-0.28270000f,-0.19210000f,-0.45860001f,-0.12740003f,-0.39439999f,0.14430001f,0.45270000f,-0.52290001f,-0.03400000f,-1.29390001f,0.74970001f,0.21440001f,0.50149999f,-0.52630001f,0.02470000f,0.68970001f,-0.28650003f,-0.61000000f,-0.14440000f,0.65619998f,-0.64960002f,-0.01920000f,1.01720001f,0.64180000f,-0.09119997f,-0.02950000f,-0.10180000f,-0.14540000f,0.52629999f,0.45820002f,0.43999999f,-0.30610000f,0.18100000f,-0.31040001f,-0.84709999f,-0.34600000f,0.08040000f,0.16740000f,0.71440002f,0.12340001f,-0.55320000f,-0.60440003f,-0.30020000f,0.09860003f,0.62360001f,-0.35640000f,-1.29740000f,0.23580001f,0.68080000f,-0.05729999f,0.06280000f,0.61179999f,-0.04699999f,0.78260000f,-0.26639999f,-1.16109996f,-0.22260000f,-0.22719999f,0.14270000f,-0.08040000f,-0.08090000f,0.59969999f,-0.94309998f,-0.37029999f,1.04350003f,-0.88050001f,-0.34810001f,0.27080003f,0.87499999f,0.12810000f,0.66500001f,-0.20840000f,-0.20480001f,-0.24260001f,0.96199998f,0.47809999f,-0.99839999f,-0.02939999f,-0.03790000f,0.05049998f,-0.43630000f,-0.06950000f,-0.41250000f,1.09030001f,0.37140001f,-0.11609998f,-1.09450001f,-0.39500000f,-1.38170001f,0.54910002f,0.12390001f,-0.04580003f,0.82919997f,0.54250000f,-0.10470003f,0.52649996f,0.44359999f,-1.13809996f,0.85889999f,0.21199999f,0.11150001f,-0.47749998f,-0.24059999f,0.28739999f,0.64970001f,0.18700001f,-0.61819999f,-0.36410002f,0.36720001f,-0.17080000f,-0.88840000f,-0.34819998f,0.64760000f,0.88389999f,0.41919998f,-0.13439999f,-0.49319998f,0.06480001f,0.33620002f,0.48719999f,0.02640000f,-0.09600000f,-0.30440000f,-0.48060001f,0.44160000f,0.18810002f,0.24640001f,0.41560001f,-0.28359996f,-0.50080001f,0.64080000f,1.46639998f,-0.45540000f,0.24520000f,0.48630000f,0.38140000f,0.40259999f,-0.47889996f,-0.21860000f,-0.08380000f,-0.17210000f,-0.38720000f,0.25459999f,-0.01920000f,0.53219999f,-0.11579999f,-0.61669998f,0.46480000f,-0.13170000f,-0.32130000f,-0.19949996f,-0.31629999f,-0.98260001f,0.34060001f,0.11760000f,0.92949998f,0.02850001f,0.21480001f,-0.44049998f,0.47709998f,0.10070000f,0.63440000f,0.37800000f,0.17870001f,-0.37860000f,-0.05620000f,-0.01420000f,-0.02730001f,-0.37350001f,0.13560000f,-0.30869997f,0.63530000f,0.39670001f,1.62879998f,-0.15040004f,0.08200000f,0.40149999f,-0.45150000f,-0.03440000f,-0.50229999f,0.80749996f,0.45509999f,-0.31940001f,-0.39599998f,-0.09599999f,-0.23570002f,-0.38810000f,0.06460000f,-0.55319998f,0.64579998f,0.16399999f,-0.88040000f,0.35650000f,0.42700001f,0.36560001f,0.30750000f,0.93020000f,0.27500000f,-0.87649998f,-0.52440003f,0.42260000f,0.24220005f,0.41780001f,-0.72879999f,-1.09270000f,-0.23940000f,-0.50839999f,0.22549999f,0.68180002f,0.27699998f,-0.01950002f,0.74940003f,-0.08200001f,-0.39610003f,-0.13840000f,0.05780000f,-0.24599999f,-0.49739999f,-0.07940002f,-0.08110002f,0.29440000f,0.34159999f,-0.27319999f,0.58739999f,-0.23839998f,-0.30389998f,0.89059999f,0.42480001f,-0.87229995f,-0.29960001f,-0.02360000f,0.48140001f,-0.50480000f,0.66580000f,0.51720002f,0.08980000f,-0.40520000f,0.56230000f,0.91569998f,0.32980000f,-0.75690000f,1.48809995f,0.58429999f,0.02600002f,-0.44680003f,0.10210000f,-1.16339999f,-0.00239995f,-0.22009999f,0.24610003f,-0.69649997f,-0.44979999f,0.25940000f,1.19839997f,0.39019998f,-0.16450001f,1.00810001f,0.21839999f,-0.39630001f,-0.18309999f,0.03480000f,-0.32960003f,-0.79459997f,-0.18699999f,-0.26390001f,0.65369997f,0.35849999f,-0.09979995f,0.66599998f,0.05109999f,-0.78739997f,1.53759995f,0.67469999f,0.49920001f,-0.41560001f,-0.17240000f,0.36989999f,-0.22010001f,0.23460000f,-1.06380001f,0.13610000f,0.50020001f,-0.11420000f,-0.54510001f,-0.38060002f,0.30480001f,-0.10349997f,-0.64520002f,-0.56640000f,0.64259998f,0.61860000f,-0.52040000f,-0.60950001f,0.31200001f,-0.02160000f,-0.77679999f,0.39920001f,0.21780001f,0.15679998f,0.15540000f,-0.59239999f,-0.18710002f,0.42939998f,-0.11139999f,-0.20009998f,0.27940001f,0.54220002f,-0.37389995f,0.80099999f,-0.21699998f,-1.43309997f,-0.35060001f,0.33460001f,0.84390000f,0.75660002f,-0.21040001f,-1.36689999f,0.68079999f,-0.07999997f,-0.58599997f,-0.37120001f,-0.55980001f,0.14479998f,-0.52399999f,-0.23720001f,-0.47370000f,0.60610000f,0.14550000f,-0.34990000f,-0.34970001f,0.11300001f,0.61490001f,-1.29829998f,-0.66730000f,-0.45589999f,0.48350000f,-0.08880001f,-0.87840001f,0.37600001f,0.18760001f,0.36759999f,0.75599999f,0.24230000f,-0.10519999f,-0.21219998f,-0.33330000f,-0.05119996f,0.53379997f,0.07719999f,-0.42749998f,0.76670000f,0.50590001f,-1.49469998f,0.89789999f,0.29030000f,0.91230000f,-0.20270002f,0.00570000f,-1.42870000f,0.84310002f,0.27240000f,-0.44759997f,0.89239999f,0.22720000f,0.08410000f,-0.93389998f,-0.51160000f,1.21999997f,-0.25739996f,0.18420000f,0.64139999f,-0.09989998f,0.72620000f,-0.25779999f,-0.74769999f,-0.48880002f,0.86040003f,0.70400006f,0.49220001f,0.41100003f,0.16570001f,0.13680000f,-0.81820001f,-0.27320005f,0.78900003f,-0.14240000f,-0.81310002f,-0.49000000f,0.93560000f,1.04300001f,-0.06700000f,-0.61540000f,-0.60510001f,0.21659999f,-1.01120002f,-0.29610004f,0.38400002f,0.28800000f,-0.45360001f,0.23780001f,-0.21180000f,-0.44390001f,-0.49860002f,-0.42280002f,0.73149998f,0.26799998f,-0.67059999f,-0.68879999f,-0.01020000f,-0.11440000f,-0.66149998f,-0.58919999f,0.06680000f,-0.12150001f,0.72149995f,0.50669999f,-0.61919998f,0.81779999f,0.14200000f,0.60130002f,-0.04110003f,0.34550001f,0.40000002f,1.03179999f,0.40020000f,-0.20110002f,-0.40869998f,-0.48080001f,-0.68990001f,0.98710002f,0.24860000f,1.03979998f,0.04019997f,0.34780000f,-0.75840001f,-0.59139997f,-0.35339999f,-0.17149999f,-0.43169999f,-0.58640002f,-0.45420003f,0.73139999f,0.37380000f,-0.45080000f,0.15940002f,-0.01200000f,0.78380001f,-0.97240000f,-0.53930001f,-0.70639997f,-0.14599999f,-0.28190000f,-0.86530000f,-0.15389999f,0.01400001f,0.49149996f,0.48690000f,0.36760002f,-0.56780001f,-0.41900004f,0.21780001f,0.56680001f,0.06130002f,0.24220000f,-0.63720001f,-1.25930002f,0.71020003f,0.25980002f,-0.87889998f,0.29800001f,0.51980001f,-0.29699999f,-0.40959999f,0.58999999f,1.22959997f,-0.19460001f,-0.13700001f,-0.15290000f,-0.43100000f,-0.33860003f,-0.47550002f,0.33120001f,-0.49540000f,-1.23880001f,0.44080001f,-0.30360000f,-0.57240001f,-0.17120000f,0.16719999f,-0.07279998f,0.83440002f,0.30000001f,-0.61600000f,0.29740001f,-0.46360000f,-0.30770003f,-0.72360002f,0.21840001f,1.15539999f,0.63000003f,0.74230002f,-0.23760000f,0.00900000f,-0.26860001f,0.58830002f,-0.40100000f,0.56190003f,-0.56310003f,-0.00380000f,-0.34710001f,-0.63949999f,-0.31579998f,-0.60509998f,-0.09539999f,0.65519998f,-0.06540002f,0.93980003f,0.19160000f,0.67740001f,0.16590005f,0.68899997f,-0.00410000f,0.10190001f,-0.11359999f,-0.09470000f,-0.75590003f,-0.51920000f,-0.68890001f,0.42380000f,0.42680000f,0.51660000f,-0.62630001f,0.44499999f,-0.47510002f,-0.38800001f,0.51119999f,-0.46080004f,-0.42910000f,0.75259995f,-0.22710002f,-0.18490001f,-0.22299999f,-0.32690001f,0.14290000f,0.19650000f,0.20600001f,0.54430001f,0.19520000f,0.75480000f,1.02689997f,0.56099999f,0.42520000f,0.97660001f,0.33840000f,0.41040001f,0.57170000f,-0.00460001f,0.05800000f,0.05770000f,0.46800002f,0.01020002f,-0.35329997f,0.17950002f,-0.16780001f,-0.18620000f,0.27130000f,-0.14300000f,0.37780000f,0.37650002f,-0.06820000f,-0.74299999f,-0.47190002f,0.36080001f,0.38659999f,-0.19640002f,0.03019998f,0.31489998f,0.48289999f,-0.28460000f,-0.36040000f,0.06090000f,-0.92140002f,-1.41710000f,-0.90590001f,0.04720000f,0.34919999f,-0.23020001f,0.45740000f,-0.77430000f,0.12890001f,-0.10060000f,0.00970000f,-0.72810002f,0.11939999f,-0.81090003f,0.15020001f,-0.08120000f,-0.05540000f,0.12430002f,0.45539999f,-0.02650001f,-0.77410004f,-0.52580000f,-0.63410001f,-0.83770002f,-0.10680000f,-0.62990001f,-0.41480000f,-0.54379997f,-0.28579998f,0.21559996f,-0.81019998f,0.14859999f,-0.22799996f,0.72179998f,-0.08539998f,0.24620001f,0.68040000f,0.09979998f,-0.36269999f,-0.66439997f,-0.33129997f,-0.12540001f,-0.40019998f,-0.01719998f,1.00090004f,0.18520000f,1.09870004f,0.81000001f,0.25959999f,0.60000000f,-0.59219998f,-0.26790000f,0.34180000f,0.96750000f,0.70350001f,-0.79519998f,-1.30119997f,-0.74179999f,-0.34620001f,-1.35490001f,-0.81710002f,-0.04360000f,0.35550001f,-0.30560001f,0.48440000f,0.98910000f,0.45559999f,0.39039999f,0.68909997f,0.38399999f,0.39480000f,0.41550000f,0.23700000f,-0.51419999f,-0.87509999f,-0.35709999f,-0.25740000f,-0.91000001f,-0.47970000f,-0.06440000f,0.25890000f,-0.28520000f,0.48520000f,0.97600000f,0.43939999f,0.41100000f,0.32429999f,0.61830001f,0.00120001f,0.14610003f,-0.28819999f,0.20039999f,0.51809999f,0.47540000f,-0.10799999f,0.53540000f,-0.30290002f,-0.66999999f,-0.40470000f,0.68200000f,0.13240001f,0.81200000f,-0.08609998f,0.92479997f,0.13970000f,1.10490003f,0.21620000f,0.84810000f,-0.12709999f,-0.14459999f,-0.28709999f,-0.29149999f,-0.10540000f,-0.36989999f,-0.47189999f,0.17099999f,-0.48270000f,0.19249998f,-0.06039999f,0.33030000f,-0.12460000f,0.49539998f,0.04399999f,0.96470001f,0.18779998f,0.75029999f,-0.12199998f,-0.11880000f,-0.28159999f,-1.25370003f,-0.26280000f,-1.09950001f,0.68230002f,0.32499998f,0.52829999f,-0.35290000f,-0.45819998f,-0.37169998f,-0.26220000f,-0.50389999f,0.08499999f,0.33469998f,-0.03270001f,-0.26160000f,-0.46549999f,-0.07839999f,0.05200000f,0.07230001f,0.36480001f,0.02360000f,-0.53350002f,0.19079999f,-0.21979999f,-0.81359997f,-0.32749999f,0.61340000f,0.78579999f,0.76350001f,-0.15680001f,0.42629999f,-0.12700000f,-0.22039999f,-0.37839999f,-0.51039999f,0.68860000f,0.97189999f,0.46969999f,-0.69619999f,-0.98229998f,-0.74249999f,-0.50160000f,-0.38450000f,-0.59360001f,0.12800001f,0.17190001f,-0.17459999f,0.53100000f,0.66149999f,-0.01130002f,-0.61640000f,-1.02030000f,-0.38479999f,0.46020000f,0.71859999f,0.40110001f,0.06960001f,0.26930001f,-0.09930001f,-0.15620000f,0.01270000f,-0.57470002f,-0.40779999f,-0.47550000f,-1.15010003f,-0.04659997f,-0.86050001f,-0.29379999f,0.32939999f,-0.10800000f,-1.16160003f,-0.28019999f,-1.10900002f,1.12650000f,-0.20420000f,0.87330000f,0.65480000f,0.43039998f,0.59959999f,-0.54369999f,0.15199999f,-0.64750001f,0.98250000f,0.18720000f,1.00070000f,1.28690001f,0.11220001f,1.14610001f,0.30889999f,0.36459997f,0.20849998f,0.05230003f,0.61959999f,-0.11190001f,0.20389997f,-0.13619999f,0.37110000f,-0.17469999f,-0.49189999f,-0.53299998f,-0.70719996f,-0.51349998f,-0.45500001f,-0.23570000f,-0.26430000f,-0.35539999f,-0.60989997f,-0.22689999f,0.19380001f,-0.36280001f,0.38610002f,0.13540000f,-0.02110000f,0.04670000f,-0.18040000f,-0.31799998f,0.11780001f,-0.20780000f,-0.23129999f,-0.02570000f,-0.43360000f,-0.68349999f,-0.65300000f,0.72480001f,1.03659998f,0.48739999f,-0.25099997f,-1.16339996f,-0.65389998f,0.34179999f,0.42099999f,0.20249999f,-0.24159999f,-0.39839998f,-0.55159999f,-0.18580000f,-0.54210001f,-0.08050000f,-0.43340000f,-0.92419999f,-0.69850000f,-0.55900000f,0.08109995f,0.73059998f,0.05980000f,0.74359998f,0.89390001f,-0.28159999f,0.80770002f,0.09330000f,-0.06560000f,0.19710001f,-1.51660006f,-0.08900000f,-1.19800004f,-0.35110001f,0.15200000f,-0.29770001f,-0.34160001f,-0.32759999f,-0.20999999f,0.06950000f,-0.21239999f,0.11250001f,0.81230001f,0.38099998f,0.79190000f,-0.54060001f,0.16480001f,-0.65780002f,-0.23440001f,0.80339997f,-0.01500003f,-0.31239999f,0.13299999f,-0.34820000f,0.72960000f,0.45679997f,0.66479998f,-0.34730002f,-0.01560000f,-0.18750000f,0.52480001f,0.51179998f,0.59020000f,0.19099996f,0.55369999f,-0.44099999f,-0.36759998f,-0.47969999f,0.05900000f,0.28560000f,0.41090001f,0.19919999f,1.22609996f,0.67260000f,-0.30060000f,-0.48939999f,-0.37530000f,0.08139999f,0.56619998f,-0.07650001f,0.57659998f,0.77539996f,0.47449998f,-0.49300001f,-0.55110001f,-0.07949999f,-0.74600000f,-1.01559996f,-0.54739999f,0.37720001f,0.08200000f,0.27720001f,0.10880000f,0.40090001f,0.17820001f,-0.07919997f,-0.93179995f,-0.41819998f,-0.08380001f,-0.66690001f,-0.18650000f,-0.15140000f,0.34640000f,-0.16510000f,-0.22899999f,-1.15819999f,-0.66570000f,-0.07079998f,0.01290002f,1.01899999f,0.05379999f,0.92119999f,-0.34220002f,-0.52019999f,-0.31560000f,0.39149997f,-0.92459996f,0.14070000f,0.41480000f,0.17019999f,0.43220000f,0.82520002f,0.05019999f,0.58180001f,-0.64399999f,0.03539999f,-0.68859999f,0.19129999f,-0.47959999f,0.28830002f,0.70720002f,-0.12680000f,0.79160003f,-1.00480002f,0.19359999f,-0.86720002f,0.11670000f,-0.18300000f,0.03070000f,-0.57780001f,0.69359997f,-0.34140003f,-0.54690000f,0.31159998f,-0.34710000f,1.05860000f,-0.12339999f,0.82760000f,-0.24720000f,0.85019998f,-0.02900002f,0.37649999f,0.41820001f,0.15460000f,0.79169999f,0.49390000f,0.11300002f,-0.40739999f,-0.39450001f,0.20159999f,0.49509998f,0.15199999f,0.42080001f,0.42690000f,0.33680000f,-0.46359999f,-0.55949997f,-0.06499998f,0.07880000f,-0.22479999f,-0.05500000f,0.18460002f,-0.29399999f,-0.06650000f,0.17059998f,1.09839998f,0.69830000f,-0.31880000f,-0.81139999f,-0.17339999f,-0.25900000f,-0.10840000f,0.02390000f,-0.28380000f,-0.67409999f,-0.11809999f,-0.36440003f,-0.23200004f,0.30059999f,-0.35239998f,-0.97839996f,-0.51699999f,0.04960000f,-0.06420000f,-0.22000000f,0.28680000f,-0.84159999f,0.10969999f,-0.63359997f,-0.02729999f,-0.17680000f,0.79659999f,-0.10980003f,0.13290000f,-0.03740000f,0.01930000f,-0.66290001f,0.07980001f,-0.64050002f,0.10229996f,-0.45099999f,0.21389999f,-0.38999999f,0.25719999f,-0.29680000f,-0.66580001f,0.45299999f,-0.52440002f,0.21020001f,-0.96219998f,0.01480004f,-0.36100001f,-0.01760000f,-0.14780000f,0.26579999f,-0.39019998f,0.26240001f,-0.30770002f,-0.07640000f,-0.12630000f,-0.17640001f,-0.86519997f,-0.06159996f,0.00440001f,0.41959998f,0.16880000f,0.16980001f,0.37479998f,0.13619999f,-0.08579999f,0.45540001f,-0.24499998f,-1.15749999f,-0.56009999f,0.43900000f,0.38669999f,0.45129999f,0.30159999f,0.68659997f,0.10679999f,0.40139999f,0.10579999f,0.38369999f,0.02620001f,-0.52139999f,0.07550000f,-0.80180000f,-1.08549998f,-0.65749998f,0.17660000f,-0.16460000f,-0.39230001f,0.27240000f,0.69160000f,0.65200002f,-0.09220000f,-0.33459999f,-0.10570000f,0.02020001f,-0.67409999f,-0.47710000f,-0.20140000f,-0.97320001f,-0.35170000f,0.12560001f,-0.16289999f,-0.06720000f,0.04519999f,0.59020001f,0.46640002f,0.28500000f,0.41350000f,0.54250002f,-0.04680000f,-1.05110003f,-0.38790002f,0.69119998f,-0.13930003f,-0.94090001f,-0.02639999f,-0.86070001f,0.31260000f,0.11400000f,0.12619999f,-1.18479999f,0.08740000f,-1.01739999f,-0.95040000f,0.10060001f,-0.70260000f,0.88090000f,-0.05000002f,0.94670001f,0.06880003f,0.81699997f,0.04899999f,-0.50800003f,-0.62640000f,-0.52640001f,-0.16440000f,0.09580000f,-0.07900000f,-0.27569998f,0.84159997f,-0.14430001f,-0.52700002f,0.43619999f,-0.27840002f,-0.36190001f,0.32500000f,-0.28830002f,0.04939999f,-0.70360000f,-0.03619999f,-0.77050003f,-0.38400000f,-0.70550002f,1.09020002f,0.21000000f,-0.02860000f,-0.12250000f,-0.31490001f,0.34820000f,0.27340000f,0.50590001f,-0.36699998f,-1.08939996f,-0.66209999f,-0.45220001f,-0.25590000f,-0.44550001f,0.49979998f,0.95719997f,0.49369999f,0.16520001f,-0.23930001f,-0.04160000f,0.43820002f,0.65270003f,0.05090001f,0.66739999f,0.92969997f,0.40109999f,0.64860001f,0.74399999f,0.29409999f,0.11060001f,-0.37149999f,-0.41950001f,0.44779999f,1.10169997f,0.74349999f,0.47620001f,0.67929999f,0.41190000f,0.10940001f,-0.38949999f,-0.07730000f,0.23180000f,-0.29340002f,0.31410000f,-0.63380002f,-0.49020000f,0.37670002f,0.39479999f,0.31970000f,-1.03520000f,-0.19940001f,-0.90980000f,0.09880000f,0.61579998f,0.25939998f,1.15130003f,-0.04040000f,1.01550003f,-0.26419999f,-0.16020000f,-0.39519999f,-0.58910001f,0.37539999f,-0.46670002f,0.10590000f,0.40239999f,-0.05470003f,-0.45789999f,0.21999999f,-0.57090001f,-0.52940000f,0.38379999f,-0.60360002f,-0.07829999f,0.81399998f,-0.03490002f,-0.35750000f,-0.60079997f,-0.47929998f,-0.50590002f,-0.00799999f,-0.55250002f,-0.65590000f,0.38159999f,-0.49450001f,-1.36480004f,0.03940002f,-1.09020002f,0.45400001f,0.05880000f,0.16360000f,-0.04410000f,0.47700002f,-0.12680001f,-0.22400001f,0.12760000f,-0.71999998f,-0.97679996f,-0.76079998f,0.72219999f,1.28240000f,0.74750000f,-0.24040000f,0.18479999f,0.01200000f,0.85580000f,1.19169997f,0.83849998f,0.20860000f,0.29330001f,0.27570001f,0.10400000f,0.04560000f,0.39920001f,0.18620000f,0.43639999f,0.41850000f,0.39980001f,0.41909999f,-0.16650000f,-0.08959999f,-0.31749998f,0.34040002f,-0.24600000f,-0.63560000f,-0.13280000f,0.52919999f,1.18959999f,0.73600001f,-0.30640000f,-0.71729999f,-0.10979999f,-0.11279999f,-0.51250000f,-1.13150003f,-0.34660000f,-0.92310001f,-0.31320000f,-0.28719999f,-0.20599998f,1.06319997f,0.17279999f,1.06799998f,-0.58780000f,-0.24460001f,-0.72400000f,0.69079999f,-0.43519998f,0.56520001f,-1.11150000f,-0.13079997f,-1.15130001f,-0.38190001f,-0.12360001f,-0.36970001f,-0.76400002f,-0.36480000f,-0.63120000f,-0.35780001f,-0.38259999f,-0.36400000f,0.17629999f,0.69159998f,0.03449996f,-0.86410002f,-0.47379999f,-0.64089999f,-0.29440001f,-0.01200000f,-0.12560000f,-0.36040002f,-0.49440000f,-0.50360001f,-0.34510001f,-0.10820000f,-0.14790000f,-0.32240000f,-0.15860000f,-0.14579999f,-0.75479998f,-0.37930000f,-0.34820000f,-1.01300001f,-0.65530002f,-0.08920002f,0.34569998f,-0.35060002f,-0.18700000f,-0.40790000f,-0.52210001f,-0.08000000f,0.45110001f,0.24760000f,0.46200000f,0.65049998f,0.59380000f,-0.03379999f,-0.28679999f,0.05510001f,0.08159999f,0.73880000f,0.21460000f,0.16680000f,-0.38340002f,0.09279999f,0.60100000f,1.17680000f,0.77810001f,-0.22640000f,0.17750001f,0.22800002f,-0.17519999f,0.08020000f,0.27940002f,0.47619998f,1.16949996f,0.60049997f,0.04580000f,-0.21550000f,-0.12030000f,-0.05279999f,0.43690000f,-0.25539999f,0.48979998f,-0.09480001f,0.16840002f,0.61259999f,0.30340001f,1.24510002f,0.20739999f,0.96790001f,0.56930002f,0.50479999f,0.52990000f,0.42009999f,-0.57259997f,0.29450001f,-0.81730001f,-0.25259998f,-0.79610000f,-0.45780002f,-0.03500000f,-0.32760001f,0.61320002f,-0.37240000f,0.39200002f,-1.02500002f,0.25000000f,-0.79860001f,-0.57700002f,-0.43540000f,-0.68560002f,0.30569997f,-0.68699999f,0.25609999f,-0.01540004f,-0.64559998f,0.00339999f,-0.07609998f,-0.39599997f,-0.26629998f,-0.21109999f,0.28759998f,-0.15010000f,0.19140000f,-0.24360000f,0.32280000f,0.32230001f,-0.01400000f,0.40160000f,0.77720000f,0.59640001f,-0.54740000f,-0.75149997f,-0.39409999f,0.19099999f,0.54059997f,0.19989999f,-0.34780000f,-0.28339999f,-0.36210000f,0.16920000f,0.21440000f,0.24060000f,-0.12540000f,-0.35970000f,0.26370001f,-0.04020002f,0.32699998f,0.32709999f,-0.79279999f,-1.21919998f,-0.88359998f,-0.21379999f,-0.55149999f,-0.12569999f,0.02959999f,0.52629998f,0.44019999f,0.15220000f,0.00090001f,0.24670001f,0.01120001f,-0.17839998f,0.33460002f,0.22139999f,0.68149997f,0.26849999f,0.31359999f,-0.07330000f,-0.07629998f,0.40979998f,-0.14510000f,-0.52280002f,-0.38559999f,-0.56680001f,0.49730002f,-0.10080000f,0.56430002f,0.14279999f,-0.12820000f,0.02340000f,0.78720001f,0.01979999f,0.71260001f,-0.37240001f,-0.11480000f,-0.34720001f,-0.73890002f,-0.41759999f,-0.53070000f,0.03400003f,-0.57619998f,-0.00539996f,1.02959999f,0.29199998f,1.07999999f,-0.23790001f,0.00240000f,-0.09490000f,0.02409999f,-0.67459996f,-0.04669998f,-0.67150001f,-0.08400001f,-0.55890001f,-0.82800002f,-0.35559999f,-0.64280000f,0.18830000f,-0.21199999f,0.03890000f,-0.26600002f,0.02690001f,-0.34460001f,0.02290000f,-0.36590000f,0.14639999f,1.06949997f,0.48140000f,-0.13660001f,-0.41880002f,0.22590000f,0.65759999f,0.92449999f,0.52519999f,0.09459999f,-0.28710000f,-0.31470002f,-0.21340000f,0.36950001f,-0.22090001f,0.06140001f,0.64610002f,-0.04650000f,0.12840000f,0.09520000f,0.33800000f,0.16420002f,-0.20249997f,0.30750002f,-0.03260000f,0.34260000f,0.25930001f,0.09759998f,0.49729996f,-0.11880003f,0.10719998f,1.05049995f,0.56359999f,-0.16200000f,-0.47580001f,-0.32060001f,-0.34560000f,-0.58599999f,0.05380001f,0.46200000f,-0.83990003f,1.24650002f,-0.06280000f,1.04350001f,0.56089997f,-0.71379997f,0.30209999f,-0.74620002f,-0.36859998f,-0.52799999f,-0.64849998f,0.04859999f,-0.72129999f,-0.09229996f,0.63079998f,-0.05369999f,1.29510002f,-0.15319998f,1.02290001f,0.93250002f,-0.04239999f,0.66110001f,-0.63480001f,-0.26479999f,-0.53720000f,-1.09610002f,-0.08200000f,-0.87630001f,0.15319998f,-0.48299998f,0.08699999f,0.76110003f,0.14940001f,0.53630002f,0.47029999f,-0.87219996f,0.23750002f,0.09700001f,0.30639999f,0.15660000f,-0.34200001f,-0.41559999f,-0.15519998f,-1.02290002f,0.21130001f,0.19320000f,0.61730000f,0.21640000f,0.03499999f,-0.11730001f,0.43510001f,-0.00459999f,-0.77520000f,-0.53150001f,0.32260000f,0.70989998f,0.03929999f,0.31440000f,0.67840000f,0.58200001f,-0.22220000f,0.10540001f,-0.26889999f,0.23680000f,0.18850000f,-0.15840001f,0.04179999f,0.35049996f,-0.08090002f,-0.04200002f,0.40769998f,0.45279999f,0.58759998f,1.36209996f,0.87720000f,-0.43320000f,-0.73449999f,-0.49039999f,0.56300000f,1.29530000f,0.83910000f,0.16559998f,0.73799996f,0.17559998f,0.17560001f,-0.30200000f,-0.18880000f,-0.69219999f,-0.87630003f,0.22710000f,-0.16900000f,0.08150000f,-0.94170003f,-0.46599999f,-0.74430000f,-0.29459999f,0.90379997f,-0.14400002f,0.41870001f,0.22479999f,0.20529999f,-0.49040002f,-0.46959999f,-0.51680000f,0.99280000f,-0.02580001f,0.81340000f,0.11150002f,0.50379998f,0.03310000f,0.58050001f,0.06080001f,0.41710001f,-0.04489998f,-0.76339998f,-0.07769996f,-0.43530002f,-0.63779999f,-0.59210000f,0.47250000f,0.18979999f,0.52610000f,-0.42949999f,-0.60639998f,-0.57609999f,0.52360001f,-0.19520000f,0.30840001f,-0.46400000f,0.59759999f,-0.36080002f,0.55280000f,0.45099999f,-0.18360000f,0.17850000f,0.27960001f,0.28739999f,0.86449998f,0.23149999f,-0.49700002f,-0.69740002f,-0.05170000f,-0.30380002f,0.15229999f,-0.24250001f,0.35000002f,0.23040001f,-0.16319999f,0.27100000f,0.94350001f,0.31230000f,-0.68160000f,-0.92259998f,-0.34839999f,0.48900001f,0.35350000f,0.35630001f,0.40300001f,0.28130000f,-0.26730001f,0.05160001f,0.50760002f,0.36420002f,0.22780000f,0.41270000f,0.21410000f,-0.12039999f,-0.75570000f,-0.63300001f,0.47739999f,0.57939997f,0.23649999f,0.35300000f,0.43389999f,0.59970001f,-0.33079999f,-0.73739998f,0.14669997f,-0.68819996f,0.12270000f,0.40330000f,-0.11999999f,0.17990000f,-0.06560000f,-0.47699999f,0.10060003f,1.16750002f,-0.19720000f,0.95930003f,-0.02200002f,0.66879997f,-0.09480005f,0.42070002f,-0.27160000f,0.18690001f,0.40899999f,-0.31079999f,0.53300001f,-0.92730001f,0.18039998f,-0.85310002f,0.12690001f,0.86639999f,0.01069997f,0.07919998f,-0.53879999f,-0.00360001f,-0.13809999f,-0.05200000f,-0.19150000f,0.10730001f,0.85179999f,0.19169999f,-0.37440000f,0.24739999f,-0.43580001f,-0.95490002f,-0.36000000f,-0.86510000f,-0.33660002f,-0.29390001f,0.29700001f,0.45280001f,-0.03410000f,-0.24500001f,0.08590000f,0.07230000f,0.74540001f,0.94850001f,0.82030002f,0.19699998f,0.95809999f,0.59350000f,-0.07580000f,0.36520001f,0.35830002f,-0.68279998f,-1.01559996f,-0.72339998f,0.15420000f,-0.00110000f,0.19210000f,0.41760002f,0.08810002f,0.54340002f,0.67460000f,0.98420000f,0.81510001f,0.27560000f,0.60000000f,0.19180000f,0.01920000f,-0.03440000f,0.23440000f,0.03379999f,0.84700000f,0.28930000f,0.22660000f,0.34530001f,-0.05990000f,-0.47100000f,-1.13679999f,-0.64709999f,0.50860001f,-0.05130000f,0.23210001f,-0.43140001f,0.14460001f,0.19980001f,0.23960001f,0.07240001f,-0.77970003f,0.52520001f,-0.42530002f,0.33909997f,-0.76679996f,0.20989999f,-0.60989998f,0.52199998f,-0.31950000f,0.70040002f,-0.21359998f,0.37120000f,0.19210006f,-0.23840002f,0.13310002f,0.96390000f,-1.02859998f,0.54660000f,0.39119998f,-0.86819999f,0.23630000f,-0.93220002f,1.28880001f,-0.53780002f,-0.80050000f,0.42359998f,-0.41530000f,0.09740000f,-0.46960000f,0.09499999f,-1.35430001f,1.14239999f,-0.73010002f,0.90839998f,-1.13759997f,0.52239999f,-0.35000000f,0.14069999f,0.51520003f,0.17570001f,0.36550003f,0.92579999f,0.34949999f,1.28220002f,0.93300003f,0.33960001f,0.77850005f,0.63520003f,0.35810001f,0.94630004f,-0.11280001f,-0.20490001f,-0.24390001f,-0.44019999f,-0.22820000f,-0.18789999f,-0.31200002f,-0.26970000f,-0.59270002f,0.24480000f,-0.09810000f,-0.52109998f,-0.60940000f,-0.06230000f,0.09879998f,0.50920001f,0.37100000f,0.96360004f,0.15079998f,-0.12200000f,-0.26460002f,-0.42440001f,-0.26470000f,-0.69550001f,-1.21860003f,-0.37380001f,-1.41950007f,0.45940001f,0.27200000f,0.34450001f,0.29720000f,-0.29820001f,0.58230003f,-0.57000002f,0.32590002f,0.58319998f,-1.19039998f,0.37319999f,0.96150003f,-0.99920001f,0.54450002f,0.30030003f,-0.34880001f,0.18730001f,0.06329997f,-0.49880000f,0.04770000f,-0.55230001f,0.09499998f,-0.28660000f,-0.01450003f,-0.16259997f,-0.01360000f,0.85469999f,-0.69620001f,0.44880001f,-1.13359999f,1.02780001f,-0.61290001f,0.05680001f,-0.02560000f,0.05119999f,0.51319997f,-0.71739996f,0.28330000f,-0.14410002f,0.15660001f,-0.09480000f,-0.99790000f,1.79940001f,-0.61120001f,0.45510003f,-0.02920001f,0.23830000f,-0.18669999f,-0.69160001f,0.77840002f,0.11680000f,0.31600003f,-1.14940000f,-0.37399999f,-1.27150001f,-1.14420004f,-0.20880001f,-0.30650006f,0.48800003f,0.28450001f,0.22070003f,0.90600002f,0.30210001f,0.80810004f,0.60979999f,0.19269999f,0.61780000f,0.37740001f,0.16530000f,0.69300002f,-0.82540001f,-0.31940000f,-0.92610002f,-0.79660003f,-0.18470001f,-0.31160004f,0.37680001f,0.22950000f,0.14410000f,0.89840002f,0.30580001f,0.82020003f,0.13739998f,-0.06540001f,0.40529999f,0.26380004f,0.20870001f,0.25920003f,0.38060000f,0.01630000f,0.12600001f,-0.51059999f,-0.08730001f,1.11460001f,-1.37380001f,0.62730002f,-0.98009999f,1.57319997f,-0.58930000f,-1.73530002f,1.78420002f,-0.95740003f,0.58950005f,0.02199997f,0.30110002f,0.90850002f,-1.11320000f,0.52330001f,0.56319998f,-0.83079997f,0.33299999f,0.10560001f,-0.47280000f,0.08880001f,-0.67210002f,0.92099999f,-0.39860001f,-1.12040002f,1.12420001f,-0.61950002f,0.46970004f,0.07159998f,0.23690001f,0.88460002f,-1.08680000f,0.51040002f,-0.01590004f,-0.77939998f,0.03419999f,0.19420006f,0.17519995f,0.09620002f,0.58339999f,-0.83039998f,0.33220001f,-0.76089998f,-0.15300001f,0.37180000f,0.17480000f,0.26150001f,-0.48060001f,-0.22470000f,-0.55720002f,-0.05860000f,-0.14690000f,-0.17120000f,-0.63360004f,-0.29970001f,-0.20310002f,-0.75000000f,-0.21510000f,-0.33830001f,0.58400000f,0.10330000f,0.78790002f,0.48640001f,0.18110000f,-0.13909999f,-0.22139999f,0.04980000f,-0.11290000f,0.89760001f,0.35460000f,1.20980003f,-0.80539999f,-0.21760000f,-1.00990000f,-0.21700000f,-0.00050000f,-0.62080000f,0.25720002f,0.20030000f,0.43190001f,0.74140002f,0.43580001f,1.21410004f,-0.97560003f,-0.39450001f,-1.13930004f,0.87080003f,-0.11829999f,0.40070000f,-0.20699999f,0.21660000f,-0.36140001f,0.38120000f,-0.21080000f,0.08259998f,-0.40840000f,0.05520000f,-0.85590008f,0.22520005f,-0.44550004f,-1.00449999f,0.90619998f,-0.55240000f,0.43449997f,-1.23659998f,0.28920000f,0.89010003f,-0.23440001f,0.45550001f,-0.33709997f,0.75359997f,-0.20450000f,0.58240001f,-1.07099999f,0.36610001f,-0.62109998f,1.34939997f,-0.39300000f,0.05700002f,0.78199999f,-0.01840000f,0.06230004f,0.06879997f,0.03810001f,0.26410003f,-0.38580000f,0.17660000f,-0.75490004f,1.03880001f,-0.45010002f,0.92220003f,0.40140002f,-0.59019998f,-0.17809999f,-0.80859999f,-0.18180000f,-0.10080000f,-0.76050002f,-0.58339999f,-0.23319999f,-0.65690000f,-0.51520004f,-0.28070001f,0.01989998f,-0.03000000f,0.01140000f,0.23480000f,-0.39360000f,-0.24420000f,-0.52060001f,-0.24960000f,-0.14400000f,-0.44600001f,-0.50480000f,-0.06310000f,-0.49050002f,0.96180001f,0.38220000f,1.28150005f,-0.99719999f,-0.18930000f,-0.20690000f,0.39240000f,0.16830000f,0.61350000f,-0.22839999f,0.05680000f,-0.12700000f,-0.55500003f,-0.22860001f,-0.41530003f,-0.74140001f,-0.13250000f,-0.49860003f,-0.81500003f,-0.44710001f,-0.39779997f,0.94379995f,-0.25869999f,0.26430001f,0.34900000f,0.10140001f,-0.47009998f,0.62059997f,-0.27799999f,-0.81230007f,-0.06499998f,-0.40620003f,-0.22700001f,-0.00179999f,-0.10910001f,-0.22340001f,0.08919999f,-0.12799999f,-0.06340000f,0.15980000f,-0.04870000f,-0.52369997f,1.08559997f,-0.32110000f,0.63369999f,-1.13079998f,0.39610000f,-1.55229998f,1.49419995f,-0.85060000f,0.18810000f,-0.45379999f,0.12780000f,-0.34259996f,0.80559996f,-0.20979999f,-0.59450003f,0.45820002f,-0.32840002f,-0.91059999f,1.31619998f,-0.52610001f,-0.52000005f,-0.28209999f,-0.23799999f,-0.03410000f,-0.58490000f,0.14940000f,-0.08610000f,-0.15400000f,1.05239999f,0.18690000f,0.09810002f,-0.39580000f,-0.09050000f,-0.40460001f,0.63240000f,0.28650000f,0.33210000f,0.68019998f,0.23929999f,0.94119999f,-0.58760003f,-0.33280001f,-1.04380005f,-0.91839999f,-0.34939999f,-1.27300002f,0.00900000f,0.00900000f,0.56310001f,0.36320002f,0.09730001f,0.15430002f,-0.82979998f,-0.16739999f,-0.00149999f,-0.63880003f,-0.18800001f,-0.14620004f,0.41700001f,0.17190000f,-0.11259998f,-0.98560001f,-0.17390000f,-0.15170002f,-0.18659998f,0.61780000f,0.00850003f,0.66819996f,-0.03719999f,0.41559999f,-0.61699999f,0.23230001f,1.73009997f,-1.57199997f,0.94110000f,-0.37819999f,0.68739999f,-0.22890000f,0.76710002f,-0.34219999f,0.40860001f,0.43679997f,-0.94819995f,0.28149999f,-0.15640003f,0.39940002f,-0.11910001f,-0.57659997f,1.16999997f,-0.36879999f,-0.39150002f,-0.26000000f,-0.17370001f,0.49630002f,-0.46320002f,0.27330001f,-1.40969998f,1.11719995f,-0.75810000f,-0.95520003f,0.68140002f,-0.51370002f,0.75100002f,-0.13380001f,0.38170001f,-1.57790001f,1.50659999f,-0.86280002f,-0.49439997f,-0.18260001f,0.65880001f,0.09780001f,0.06880003f,-0.27139999f,0.08630000f,0.46880002f,0.47939999f,0.17790000f,0.38180000f,0.35340000f,0.12570000f,0.66860003f,-0.59980000f,-0.33410000f,-0.99700000f,-0.21040000f,-0.03260000f,0.16260000f,-0.27120000f,-0.01890000f,0.37450001f,0.90580000f,0.11450000f,-0.00440000f,-0.81360002f,-0.32760000f,-0.66240002f,-0.14260001f,-0.13910000f,-0.56700001f,-0.68720002f,-0.29200000f,-0.60960002f,-0.38600005f,-0.36700001f,-1.02520006f,-0.86159998f,-0.22259999f,-0.48820000f,0.01960001f,0.10700000f,0.26440000f,0.45120002f,-0.15120000f,1.08619999f,-1.06899999f,0.59450001f,-0.85960000f,0.73059999f,-0.45390001f,0.50559999f,-0.48999998f,0.28420000f,0.09759998f,-0.57559999f,0.08859999f,-0.21120001f,0.39759998f,-0.14560000f,-0.47859999f,0.24439999f,-0.24800000f,-0.74530001f,0.33139999f,-0.38140001f,1.57320000f,-1.50539998f,0.85690002f,-0.83640002f,0.73000000f,-0.46740001f,0.21259999f,0.00500001f,0.09430000f,-0.66380002f,0.57660000f,-0.37270001f,0.20599993f,-0.19799994f,0.08939998f,-1.09339997f,1.19399996f,-0.61280000f,-0.20159998f,0.27919998f,-0.10760000f,0.33880001f,0.54740003f,-1.02620002f,-0.23440001f,-0.26830002f,0.26879999f,0.05580000f,0.60700001f,0.70599999f,0.30859999f,0.65720001f,-0.00460002f,-0.02990000f,0.53199999f,-0.57680000f,-0.23350000f,-0.10370000f,-0.95440001f,-0.33680000f,-1.31200005f,-0.01140000f,0.20010000f,0.64179999f,0.50180000f,0.01420000f,0.16430001f,-0.31960000f,-0.10430000f,-0.16590001f,-0.52820000f,-0.00400000f,0.29589999f,-0.90780004f,-0.25830001f,-0.31120003f,-0.13700000f,0.01310000f,0.27920001f,0.44860001f,-0.00160000f,-0.16969999f,0.25100000f,-0.03200000f,0.22550001f,0.75000003f,-0.09600001f,-1.54030002f,1.39739999f,-0.84180002f,0.02119997f,-0.65499997f,0.05209999f,0.65600000f,-0.57119998f,0.36960000f,-0.37640003f,-0.37939997f,-0.16170001f,-0.85470002f,0.33140001f,-0.44720001f,-0.61859998f,1.32179997f,-0.39729999f,-0.56859997f,0.55499999f,-0.29590000f,0.77369999f,-1.12480001f,0.44150001f,-0.40690000f,0.34339999f,-0.22340000f,-1.15529998f,0.99859998f,-0.61820001f,-1.28720005f,1.05700002f,-0.70070003f,-0.45100000f,0.21879999f,-0.23040001f,0.92490002f,-0.90960001f,0.50110002f,0.30149999f,-0.79900000f,0.19100001f,1.24100004f,-0.35190003f,-0.01160000f,0.10880000f,0.16980000f,0.12180000f,-0.04650000f,0.35739999f,-0.92459999f,-0.19410000f,-0.42300000f,-0.13400000f,-0.01240000f,-0.61420002f,0.85899999f,0.27470000f,0.80320001f,-0.22440001f,-0.01710000f,0.32530000f,0.70160005f,0.36940001f,0.97380006f,0.87760000f,0.36740000f,1.21340001f,0.72100001f,0.34550000f,1.22580003f,-0.22420000f,0.11260000f,0.49050000f,0.91260000f,0.18240000f,0.52510002f,0.59520001f,0.20220000f,0.76860004f,-0.37340001f,-0.07480000f,0.21209999f,-0.41180004f,-0.20350001f,0.16759999f,-0.85960003f,-0.18390002f,-0.19039998f,0.40219999f,-0.10930000f,-0.01780001f,-0.64140000f,0.02630001f,-1.26539998f,1.42099995f,-0.70770000f,0.20600003f,0.54579999f,0.06690001f,0.83999998f,-1.12339997f,0.48910000f,-0.62710002f,0.26040001f,-0.31990002f,0.39440005f,-0.46060004f,0.24010002f,0.53840000f,-0.97459998f,0.33990000f,0.25900000f,-0.72900000f,0.18890000f,-0.80229999f,0.72739999f,-0.42440001f,1.17589998f,-1.49459996f,0.66800001f,0.42479999f,-0.83300000f,0.26670000f,-0.78710001f,0.39980000f,-0.40900001f,-0.76720008f,-0.03859996f,-0.38130003f,-0.58690001f,0.28839998f,-0.21580002f,-0.21470001f,-0.05480001f,-0.29420002f,-0.19540000f,-0.40170002f,-0.79439998f,-0.21360000f,-1.04280000f,1.12200002f,0.33990000f,1.11470003f,0.17260000f,-0.01300000f,-0.46510000f,1.00160000f,0.30040000f,1.29760004f,0.22000001f,0.03680000f,0.26000001f,-0.09600001f,-0.15840001f,-0.09760001f,0.31499999f,0.00990000f,0.12720000f,0.53500001f,0.38060000f,1.02530003f,-0.47100000f,-0.33149999f,-0.51280000f,-0.63820002f,-0.25700001f,-0.51370003f,1.01420001f,0.24700000f,0.71330002f,-0.73760001f,-0.32050000f,-0.67030002f,-0.74780002f,-0.24000000f,-0.25220004f,-0.40719999f,-0.11100000f,-0.15230003f,0.01840003f,-0.08650001f,-0.57959997f,1.35839994f,-0.37319999f,1.05850002f,-1.57980000f,0.62560002f,0.64789999f,-0.20479999f,0.32490000f,0.72939996f,-1.57259995f,0.46349999f,0.19100000f,-0.45660001f,0.12150001f,-0.03200003f,-0.41119999f,-0.00080000f,0.46799998f,-0.71379999f,0.26910000f,0.05450002f,-0.07220002f,0.05339999f,-0.32900002f,-0.11400000f,-0.17239999f,-0.66030003f,0.56960001f,-0.36850002f,1.19430000f,-1.53759999f,0.68330001f,-0.69790002f,0.59680000f,-0.39210001f,-1.28170002f,0.51930003f,-0.66280000f,-0.14090000f,-0.13530002f,-0.84520003f,-0.16190001f,-0.37590004f,0.49140000f,0.28949999f,0.16179999f,-0.24560000f,0.05540000f,-0.04100000f,0.37580002f,0.01870001f,-0.27639997f,0.49460000f,0.09070000f,0.58940002f,-0.32600000f,-0.15130000f,-0.16610001f,0.70380002f,0.20040001f,0.13270002f,-0.42740004f,-0.14320001f,0.19469997f,0.99000001f,0.24330000f,0.82370003f,0.08380000f,-0.12490000f,-0.60999999f,-0.03460000f,-0.17300000f,-0.56469999f,1.04059999f,0.29320000f,0.70950002f,-0.17820000f,-0.00540000f,0.14909999f,-0.12239999f,0.24470002f,-1.02669999f,0.92819998f,-0.56000001f,-1.17130002f,1.35940002f,-0.65660003f,0.63560003f,0.06480000f,0.32120000f,-0.43439998f,0.79500000f,-0.25370001f,0.86220000f,-0.61080000f,0.45440001f,0.42239997f,-0.99519997f,0.26840000f,-0.39750001f,0.15859999f,-0.21080000f,1.07570004f,-0.76520001f,0.57770002f,-0.84110006f,0.23760004f,-0.42970003f,1.07350000f,-1.55460000f,0.62560002f,0.64220000f,-0.41160001f,0.32760001f,0.41909998f,-0.37720000f,0.21470000f,1.22389998f,-1.39819995f,0.69220000f,-0.42329999f,0.29540000f,-0.22260000f,-0.27059998f,-0.45030003f,0.36920002f,0.23770000f,0.72890001f,0.62280001f,0.11880000f,0.48780003f,-0.68339999f,-0.26279999f,-0.94130002f,0.50839998f,0.16689999f,0.33050000f,-0.18700000f,-0.03290000f,-0.47300002f,0.14720000f,0.01180000f,0.19300001f,-0.48900002f,-0.31920000f,-0.53250002f,0.21759999f,-0.05830000f,-0.28170002f,-1.00880000f,-0.26680000f,-1.13840003f,-0.54980001f,-0.21760000f,-0.43810001f,0.38999999f,-0.01770000f,-0.19249999f,-0.08160000f,-0.07980000f,0.11380000f,-0.31460000f,-0.24160000f,-0.27690000f,0.63319999f,0.19539999f,0.36400000f,0.65120000f,-0.45030001f,0.03330003f,-0.16600002f,0.04010001f,0.71219999f,-1.10800000f,0.41700001f,-0.43209997f,0.85579997f,-0.27519999f,0.59909998f,-0.57499997f,0.33379999f,0.01900003f,0.50579998f,-0.02249999f,0.11979999f,-0.36920000f,0.08040000f,-0.35250004f,-0.01259998f,-0.18900001f,0.61689999f,-0.58619996f,0.32960000f,-0.87119998f,1.65199996f,-0.53480000f,-0.57370001f,0.50459999f,-0.32040000f,0.84349996f,-0.83759996f,0.45650000f,-0.19240001f,-0.21460001f,-0.08530000f,-0.25790002f,-0.19400000f,-0.12790000f,0.78579998f,-0.74539997f,0.43589999f,0.86279998f,-0.04580001f,0.13780001f,0.08900000f,-0.40650000f,0.95600000f,0.20950000f,0.11370003f,-0.53780004f,-0.32590001f,-0.53620004f,0.82420001f,0.29690000f,1.09360002f,-0.17620000f,0.08500000f,0.39009998f,0.45800003f,0.19000001f,-0.19019996f,0.70380004f,0.29520002f,0.28230005f,-0.01860000f,-0.09900000f,0.01010000f,-0.31839999f,-0.18679999f,0.05200001f,0.26040000f,-0.01410000f,-0.20929998f,0.57699999f,0.28730000f,0.38600000f,0.90179998f,0.14610000f,-0.03519999f,-0.39200002f,-0.06880000f,-0.16320002f,-0.66420002f,-0.36840000f,-0.85610003f,0.41980000f,-0.59390002f,0.49870004f,0.27459998f,0.23060001f,1.53649998f,-1.27199998f,0.83110001f,-0.43420007f,0.06820005f,-0.23370002f,0.55980001f,-1.09639999f,0.35320001f,-0.63229999f,0.55460001f,-0.33360001f,0.87200004f,-0.10900001f,0.43990002f,0.92670005f,-0.43780003f,0.49200003f,0.00309998f,-0.38319999f,0.01810000f,-0.52460001f,-0.11620002f,-0.25830000f,0.62209999f,-0.52900000f,0.33140000f,0.62900000f,-0.24359996f,0.33599999f,1.57419996f,-1.34759995f,0.85000000f,-0.55400001f,0.65160001f,-0.31060001f,-0.41230003f,0.32440001f,-0.24070001f,0.37419998f,-0.08220000f,0.58320002f,0.18870000f,0.33610002f,-0.28660003f,-0.26300001f,-0.29710003f,-0.61600001f,-0.02270001f,0.26989998f,0.75780001f,0.36000000f,0.75810002f,0.51760000f,0.05960000f,0.30320001f,0.19700002f,0.10990000f,-0.21899999f,0.27660001f,0.23370000f,0.64380001f,0.40359998f,0.19219999f,0.21480000f,0.25479998f,-0.09370000f,-0.37050002f,1.14679999f,0.25869999f,0.75190001f,-0.62040001f,-0.16830000f,-0.62870003f,1.08900003f,0.24480001f,0.71970004f,0.72399999f,0.24799999f,0.33479999f,-0.23380000f,0.03940000f,0.45210000f,-0.94100000f,-0.40510002f,0.71930002f,-0.65000001f,0.39770001f,-0.18390005f,-0.33619997f,-0.08500001f,-1.28550000f,1.12540000f,-0.68980002f,0.65370002f,-0.51740000f,0.36840000f,0.68239999f,-1.03599999f,0.39480001f,0.46100004f,0.14019997f,0.22150001f,-0.06959998f,0.06280000f,-0.02340000f,0.48339999f,-0.18019997f,0.25609999f,0.76269998f,-0.77399996f,0.40910001f,1.39869997f,-1.79879996f,0.79830000f,-0.58509999f,0.96279999f,-0.34990001f,1.32450001f,-1.71459999f,0.75660002f,0.94600000f,-0.70799997f,0.51440000f,-0.75970000f,0.45760000f,-0.39230001f,-0.68299998f,-0.08740002f,0.06840000f,-0.13770000f,-0.56369999f,0.84520001f,0.30740000f,0.56200002f,-0.75280005f,-0.40550001f,-1.10130007f,0.23040000f,0.08760000f,-0.39760002f,0.33100002f,0.28940000f,0.88610004f,0.89660004f,0.29020001f,0.47890004f,-0.89120001f,-0.39700000f,-1.28300003f,0.27360000f,0.10920000f,0.77840001f,0.42820002f,0.38120001f,1.08650004f,0.40080002f,0.02220001f,-0.09059998f,0.37080002f,0.12180001f,0.37040002f,-0.56540001f,0.00050000f,0.11840000f,0.55659998f,0.25609999f,0.89220000f,0.25579999f,-0.03200000f,0.32230000f,-0.73939999f,-0.01360002f,0.58709997f,-0.45479999f,0.30270000f,0.97380001f,-0.83539999f,0.53890001f,-0.37870004f,0.48340004f,-0.23600002f,0.65860003f,0.06060000f,0.32050001f,-0.17049997f,0.05919996f,-0.06870000f,1.13290005f,-0.98020002f,0.62340003f,-0.49980001f,0.91359999f,-0.31940000f,-0.11660001f,-0.52420000f,-0.01910000f,-0.18069998f,0.13499999f,-0.07260001f,0.77220001f,-0.74280002f,0.41880002f,0.34420001f,-0.48300000f,0.20230001f,-1.09660000f,1.18720000f,-0.60060002f,0.24339998f,-0.58099997f,0.16729999f,0.24069997f,-0.85739998f,0.16500000f,-0.63909999f,-0.18510001f,0.51260003f,0.29050001f,0.71660004f,0.04500000f,-0.08460000f,-0.54090001f,0.74380001f,0.17960000f,1.04190003f,0.79960001f,0.12380001f,0.10680001f,0.24340000f,-0.07150000f,-0.37200000f,-0.84679999f,-0.23619999f,-1.00400000f,-0.06280001f,-0.05120000f,0.16100000f,-0.08279999f,-0.11549999f,0.43450003f,0.77820001f,0.17310000f,0.90840003f,0.58040002f,0.22180000f,0.52040002f,-0.12400001f,-0.13040000f,-0.15400000f,0.78600002f,0.18750001f,-0.00409998f,0.40380002f,0.23940001f,0.57370002f,-0.98800002f,-0.25430001f,-0.65570004f,0.90140004f,-0.65829997f,-0.63800002f,-0.82900001f,-0.97460001f,-0.45399998f,0.42639998f,-0.61699997f,0.91150003f,-0.62320000f,0.14249998f,0.34400001f,0.27819997f,0.94060000f,0.30599997f,-0.47430000f,0.56339996f,-0.35850002f,-0.11010001f,0.18850000f,0.84400002f,0.20900000f,0.74340000f,-0.25100001f,-0.21819999f,0.80479998f,0.03300001f,0.74610000f,-0.25579998f,-0.66799999f,0.14809999f,-0.68679997f,0.44249999f,0.01290001f,0.77429999f,-0.36600000f,0.02970000f,-0.31400000f,-0.52300004f,-0.38540000f,0.31639998f,-0.34350002f,0.26130000f,0.87649998f,0.70749999f,0.60020001f,0.30839999f,-0.60900000f,0.27080001f,0.49660003f,-1.61890003f,-0.20090001f,-0.44530001f,0.90550001f,-0.18710000f,-0.01539999f,1.89340003f,0.20080001f,-0.41440002f,0.73390002f,0.47830002f,-1.08079999f,-0.61479996f,0.89620003f,-0.37010003f,-1.94769998f,0.28850001f,-1.31110000f,0.35320004f,0.19259999f,-0.21860000f,0.90920000f,-0.02440000f,-1.05860000f,1.56440002f,0.16340001f,0.66690001f,-0.84600002f,-0.15820002f,-0.21789997f,-1.00729998f,-0.17450002f,0.47940000f,0.48119999f,0.23060000f,0.70160000f,-0.31340003f,-0.11640001f,0.19809999f,0.37529999f,-0.58050000f,-0.29220000f,-0.17929999f,-0.09550002f,-1.02590002f,-0.04470002f,0.57050000f,0.50500001f,0.21110000f,-0.26250000f,1.07760001f,-0.35370000f,-0.32450000f,0.63350001f,0.07630001f,-0.37150004f,0.18880000f,0.70409997f,-0.09350001f,-0.86499999f,0.54070000f,0.71700001f,0.50970001f,0.85719998f,0.18900000f,0.51780000f,0.01020000f,0.56149999f,1.09420001f,0.47269999f,-0.28199999f,-0.63390002f,-0.30980000f,0.39599998f,-0.55200000f,0.36779997f,-0.66049998f,0.24019999f,-0.48129999f,-0.36549998f,-0.34340002f,-0.43469998f,0.37299999f,0.07300001f,-0.42910003f,-2.29129997f,0.38310001f,-0.91710003f,-1.01670000f,0.88050003f,-0.27660000f,2.08890006f,0.08190000f,-1.00330002f,-0.70129994f,0.87070002f,0.80869999f,-1.59170000f,-0.17989999f,-1.27980001f,0.49770000f,0.04969998f,-0.39510001f,-0.37019998f,0.48500001f,-1.74470000f,0.81740001f,0.35819998f,-0.27869997f,-0.27450001f,-0.69390003f,-0.31139999f,0.23939999f,0.35780001f,-0.70630000f,0.93940001f,0.56800001f,0.94559998f,-0.85589999f,-0.13989998f,-0.13990002f,-1.44049996f,0.37470001f,0.17460001f,1.13369997f,-0.58050001f,-1.41020003f,0.01180000f,-0.17200001f,-1.00399999f,0.62220000f,-0.47000001f,-0.06220001f,0.65620000f,0.08600003f,1.19230003f,-0.17079999f,-0.39500000f,0.11900002f,0.66759999f,-0.35450002f,-1.06539999f,-0.28190000f,0.88050001f,0.53189999f,0.84009999f,-0.34150000f,0.04510000f,0.24870000f,0.81850002f,0.89749999f,1.05989998f,1.11849998f,-0.32680001f,0.39789997f,-0.24000001f,0.30959998f,0.11080000f,-0.22700000f,0.83029999f,0.23560000f,-0.51250000f,-0.68749998f,-0.51569998f,-0.38000000f,-0.61119998f,0.26780000f,0.62600000f,0.37149999f,-0.19720000f,0.71600000f,-0.73300002f,0.14940000f,0.26699999f,0.70180000f,-0.37549999f,0.79430001f,-0.38230003f,-0.55500000f,0.10980000f,0.13619999f,0.91070001f,-0.60740001f,-0.16620000f,-0.87630001f,-0.21149999f,0.34990000f,0.05799999f,0.81379999f,-0.02779999f,-0.20560001f,-0.71540000f,-0.12780001f,-1.11520004f,-0.49309998f,0.80270003f,0.45940001f,1.46089998f,0.18290001f,1.30420000f,0.22399998f,-0.88660001f,0.16830000f,-0.41910004f,-0.81430004f,-1.22150002f,0.49700003f,0.55600002f,0.66020001f,-0.47450001f,-0.66510002f,0.63039999f,0.60499996f,0.17680002f,-0.18810004f,-0.83789997f,-1.03299997f,0.35079998f,-0.30379998f,0.77550002f,0.36600000f,0.22049999f,0.23200001f,0.21319999f,0.35800000f,-0.45350000f,-0.55750000f,-0.52690000f,0.19150000f,0.17780000f,0.60209999f,-0.01100000f,0.41180000f,-0.17499999f,0.32400000f,-0.38340000f,0.29920000f,-0.22400001f,0.22850001f,0.72840001f,-0.58849999f,0.74869999f,-0.62329998f,0.19550001f,-0.43699999f,-0.80289999f,0.94600002f,-0.53200001f,0.12140000f,0.17299999f,0.69190001f,0.69000000f,0.38600000f,-0.60710000f,-0.26040000f,-0.70249999f,0.25819998f,-0.60129997f,0.05149996f,-0.37510001f,0.09550001f,-1.05999999f,-0.31700002f,-0.24470001f,0.07970002f,0.34290002f,1.46580000f,0.19349996f,-1.00290001f,-1.08830001f,-0.55419999f,0.44060000f,-0.70160002f,-1.70709998f,0.55590001f,0.09380003f,0.96459998f,0.20399999f,-0.37380002f,1.26090002f,0.35750002f,-0.23349998f,0.29319997f,0.85280002f,0.11630001f,0.18699999f,0.73760001f,1.27500003f,0.86220001f,-0.81220003f,0.41870000f,1.25170002f,0.42970003f,-0.25009999f,-1.40889996f,0.10070001f,-0.81640000f,0.31480003f,0.52840001f,0.37040002f,1.03840003f,0.02040001f,1.16020003f,-0.08070000f,0.35099999f,-0.68970000f,0.17799998f,-0.26900001f,0.20660001f,0.09240000f,0.22850001f,-0.52429999f,-0.89109998f,0.23149999f,0.06790000f,0.79609999f,-0.20000001f,-0.58150000f,0.68519999f,-0.34249999f,0.56359998f,-0.27610000f,-0.19899999f,0.86470002f,-0.01739998f,-0.94750001f,0.49089996f,-0.06050000f,-1.05499999f,0.32689998f,-0.27359999f,0.11600003f,-0.06679999f,-0.90600000f,-0.88100000f,0.72920001f,-0.61039998f,0.06099997f,-0.66579998f,0.40119997f,-0.09000001f,0.50640001f,0.43079999f,-0.30700001f,0.48640001f,-0.45180001f,0.44750000f,0.39050003f,0.70210003f,0.61250000f,0.57070001f,0.38459999f,0.58589998f,0.35230001f,-0.03499999f,1.05019999f,-0.49720002f,-0.35189999f,0.81270000f,0.22850000f,-0.55000001f,0.58840003f,0.70260003f,0.43830000f,-0.39959998f,0.44120001f,-0.66440001f,0.06320001f,0.63300002f,1.03940001f,1.21869998f,-0.79190001f,-0.15620004f,-1.31050000f,-0.54190000f,0.61140001f,0.24809996f,0.33270003f,-1.21559999f,-0.23279999f,1.00160003f,-0.51190002f,-1.03609998f,0.70430001f,-0.29689997f,1.35499998f,0.48020000f,0.58249999f,0.70449997f,-0.46650001f,0.69219999f,-0.31540000f,-1.27250000f,0.38179999f,-0.73870000f,-0.75049998f,0.35569999f,-0.45569998f,0.67250000f,0.39640000f,-0.04750000f,-0.04349999f,0.57839999f,0.07030000f,-0.51750000f,0.65880001f,0.15250000f,-0.90149999f,-0.14850000f,-0.34610000f,-0.33850001f,0.37840000f,0.34030000f,0.26200001f,0.17570000f,-0.79879999f,0.83399999f,-0.84989998f,0.45240001f,-0.89100002f,0.12509998f,-0.55979999f,-0.41200004f,0.45399999f,0.71519998f,-0.53900000f,-0.21160000f,0.40080000f,-0.41749999f,0.94129998f,-0.11570000f,0.17650003f,0.10220000f,-0.44649998f,-0.98550001f,0.52790001f,-0.79179999f,-1.26409993f,0.72350001f,-1.09619997f,-0.13619996f,0.64680000f,-0.87760003f,-0.51410000f,0.18690000f,0.76380002f,-0.06990002f,-0.69750001f,0.73460004f,1.07259999f,-0.58940001f,0.11000000f,0.96940000f,-0.35240002f,-0.75379998f,-0.52659996f,0.46800001f,1.33050001f,0.14730000f,-0.40230000f,0.44290000f,1.55299996f,-0.33519999f,1.02879998f,0.93979996f,-0.59420000f,0.80969998f,-0.62339999f,0.25980001f,-0.84220002f,-0.43579997f,0.64140002f,-0.30009999f,0.57160000f,0.03219999f,0.68219997f,0.26909997f,-0.24469999f,0.34590001f,0.73569999f,-0.35550002f,-0.27149998f,0.64009997f,-0.03550001f,0.36160000f,0.68689997f,0.40800000f,-0.03810000f,0.68920000f,0.34949999f,-0.42330000f,-0.39810001f,0.22299999f,0.22640000f,-0.59420001f,0.37550003f,0.37420000f,-0.17049999f,-0.05250002f,0.02640001f,0.54109997f,-0.45899999f,-0.31859999f,-0.91199999f,0.10300000f,0.62510000f,-0.51679998f,0.01200002f,0.09660000f,-0.78559996f,-0.93749999f,-0.40170000f,-0.54089998f,-0.21500001f,0.15080001f,0.55340000f,0.17700001f,0.37349999f,0.11520000f,-0.18599998f,-0.07350000f,-0.49239997f,-0.50699997f,-0.26850000f,-0.10310003f,-1.78029998f,-0.09089999f,-1.04900002f,0.84800005f,0.04400000f,-0.99600003f,-0.38039997f,-0.18960003f,1.09350002f,0.10949999f,-0.22749999f,-0.43180001f,-1.76299998f,0.37439999f,-0.21530002f,-1.23820003f,-0.67040001f,0.40460000f,0.37449998f,0.47870002f,0.78710002f,0.32980001f,-0.48560001f,-0.98580001f,0.03599999f,0.91640003f,-0.50349999f,0.32110004f,-0.29010003f,0.35609997f,0.67829997f,0.03990001f,1.11369999f,-0.13840007f,-0.09419999f,0.47229997f,1.40299999f,0.26160003f,-0.42350001f,-1.98999999f,0.22700001f,-0.31010003f,-0.52279997f,0.20549998f,-0.95699998f,0.39770000f,0.71500001f,0.67100003f,0.61300000f,0.98900003f,-0.07159999f,0.83300000f,-0.51250001f,-0.23300000f,-0.76950000f,-0.16150000f,-0.72560000f,0.53609999f,1.04599998f,-0.84350000f,0.51060000f,-0.93000000f,0.28229999f,-0.46119999f,0.05200000f,-0.14349999f,-0.52820001f,-0.47200002f,0.52299999f,0.51960000f,0.75200001f,0.17080001f,0.37499998f,-0.31999998f,0.30439999f,-0.38419997f,-0.70099999f,-0.32350003f,-0.77039997f,-0.70099998f,0.74210001f,-0.63959996f,0.02699997f,-0.89790000f,0.59999998f,0.26299999f,0.91990001f,-0.33540001f,-0.09180000f,-0.01900001f,0.05639998f,-1.99440001f,0.12020000f,-0.08389999f,-0.23140004f,-0.81440004f,-0.21679999f,1.49450000f,-0.12010002f,0.17540001f,1.72899997f,0.04379999f,0.45080000f,0.95920002f,0.78740003f,-1.11929998f,-0.64679999f,0.84720002f,-0.06880000f,-0.11870000f,0.11710000f,-1.01080000f,0.19869999f,0.66270001f,-0.36009998f,-0.81140003f,-0.48180002f,-0.80479999f,-0.52960001f,1.04100004f,0.73600001f,-0.64840002f,-0.52960002f,0.13330000f,0.48230000f,-0.50070002f,0.78350000f,-0.40759999f,-0.42940000f,0.66479998f,-0.12240000f,0.27400001f,0.01040000f,0.26480000f,-0.18850001f,-1.03040001f,0.27270000f,1.13200001f,-0.38290002f,0.27379999f,0.31000002f,0.79609999f,-0.07040000f,-0.19699997f,0.89959998f,-0.43179998f,-1.37250000f,0.68880001f,-0.66009999f,-0.27850004f,0.16269998f,0.74809997f,-0.10200000f,-0.00990000f,0.04560000f,-0.12150000f,0.52829998f,0.56409999f,0.90349999f,-0.52430002f,0.50369998f,-0.76650004f,0.22919998f,0.45709999f,0.15300000f,-0.66840001f,-0.31500000f,0.55550001f,0.06040001f,-0.07310000f,-0.01500001f,-0.51569998f,-0.41200000f,-0.76249997f,0.46100002f,-1.52579997f,0.58620001f,0.38719998f,-0.78230004f,-0.62710001f,0.27950001f,-0.33700003f,-1.96249996f,0.02750001f,0.32369998f,-1.70399999f,0.17340002f,-0.73649999f,-1.09979993f,0.79980001f,-0.62330002f,-0.06459998f,0.35500002f,-0.78380002f,0.43010001f,-0.23970002f,-0.43960001f,-0.64759998f,-0.62660004f,0.57480000f,1.25189999f,0.14070002f,0.22399998f,1.54390000f,-0.35290001f,-0.51539999f,-0.38219997f,0.03739999f,0.42070000f,0.07100000f,0.30740000f,-0.45050002f,-1.96989999f,0.44490004f,-0.40649998f,1.27709999f,0.22689998f,0.87530003f,-0.06520000f,0.61949999f,0.74159998f,0.93309996f,0.21650000f,-0.08540000f,0.61910001f,0.22449998f,-0.96789997f,0.57449999f,-0.45800002f,-0.91029999f,0.01660000f,-0.49750001f,-0.16909999f,0.55549997f,-0.00350001f,0.20810001f,0.39110000f,0.89300002f,0.30070001f,0.55060000f,1.15150002f,-0.47079999f,0.56469999f,-0.61749999f,0.60070000f,-0.66309998f,0.28850004f,0.65710001f,-0.35149997f,0.33499998f,-0.08959999f,0.43379998f,-0.71549999f,0.05970000f,-0.38489999f,-0.23900004f,-0.80799999f,0.56999999f,-0.00349998f,0.83539998f,0.03150000f,0.00150000f,0.32310002f,-0.94880002f,-0.15069997f,0.90810004f,0.05320000f,-0.33070001f,0.24610001f,-0.27450001f,-0.20489999f,0.27290001f,0.24249999f,-1.36360002f,0.23460003f,0.02490001f,-1.54739997f,-0.17180000f,1.00820003f,0.17440002f,0.17100000f,-1.33839997f,0.27070003f,0.60849999f,1.37079999f,-0.74830006f,-0.55010000f,-0.41010000f,0.20460000f,0.06920000f,0.12040001f,-1.59880001f,-0.42140003f,0.95730003f,0.32039997f,-1.18380005f,0.82260002f,0.06329999f,0.36090002f,1.16510000f,-0.66530004f,-0.57450001f,-0.20079999f,1.17369999f,-0.37930002f,-0.62070001f,0.12149999f,-0.48750003f,0.41370001f,0.52610000f,-0.36050001f,-0.10270000f,-0.03490000f,-0.15350000f,0.03740000f,0.17750000f,-0.48000003f,-0.69270000f,0.00500000f,0.21549997f,-0.88569998f,0.28169997f,-0.97249999f,-0.04660000f,-0.80290000f,0.19199999f,0.61229999f,0.80279997f,-0.28999999f,-0.85270001f,-0.75759997f,0.21199999f,0.21250000f,0.25019999f,0.47249999f,-1.01640001f,0.27369998f,0.84200003f,-0.41870001f,-0.50260000f,-1.08350001f,-0.00490001f,-0.68870000f,-0.10599999f,-0.77660001f,-0.61619998f,0.64000001f,0.53450000f,0.02760000f,0.27650000f,-0.14970000f,-0.97260001f,0.75420004f,0.65060002f,-0.13890000f,-1.26089997f,0.10510000f,-0.33680000f,-0.67570001f,-0.31490001f,1.08589999f,-0.54769995f,-0.10649999f,0.28380001f,2.12399999f,-0.09340000f,-0.86849999f,0.35850000f,0.69750000f,-1.31360000f,0.04970003f,0.63010001f,-0.03970001f,-0.81830005f,-0.73210003f,0.59779999f,-0.89809997f,-0.02330000f,-0.37220005f,-1.28529998f,-0.28509999f,0.72070001f,0.20629998f,-0.42090001f,-1.30080004f,-0.29279997f,1.15020004f,0.51099999f,0.75199997f,-0.05400000f,0.11640002f,-1.01430000f,-0.32290002f,1.62579998f,-0.65999999f,-0.13700001f,0.81200001f,0.44420000f,-0.02800001f,-0.60739999f,0.29379999f,0.66650000f,-0.40010000f,0.42809999f,-0.66199999f,-0.53979997f,-0.67779999f,-0.09949999f,1.04180000f,-0.54909999f,-0.27350000f,0.59719998f,0.42549999f,0.14649999f,0.49730000f,0.81769998f,0.99450001f,-0.67560002f,0.32390000f,-0.40749999f,-0.60229998f,-0.27909999f,0.65700000f,-0.70709997f,0.55140001f,0.01700001f,-0.17420000f,-0.47239999f,-0.54350001f,0.48920001f,0.75610001f,-0.31199999f,0.28139999f,-0.48999998f,0.34299999f,-0.67150001f,0.15619998f,-0.94500000f,-0.42679997f,0.60220001f,-0.40150002f,-0.27710001f,-0.46980000f,-1.53599994f,0.01040000f,0.18870000f,-1.32959998f,-0.41500001f,-0.48589999f,0.40220000f,-0.01000001f,0.83860003f,0.75769999f,-0.97950002f,0.47980000f,0.02569998f,-0.08210000f,0.72480000f,0.33299996f,0.05260002f,0.77129998f,0.97289997f,0.05070002f,0.23850000f,-0.15300001f,0.07400001f,0.13330001f,0.95960001f,0.05100000f,-0.10959997f,-1.71259999f,-0.06160003f,0.60480000f,0.99569997f,0.18390001f,1.03560003f,0.19980000f,0.24840001f,-0.62630005f,-1.17219999f,-0.18740000f,0.09969999f,-0.89649997f,-0.08049999f,-0.42530001f,-0.31290000f,0.34299998f,-0.72099997f,0.60259997f,0.41199999f,-0.88449999f,0.17659998f,0.37100000f,0.30549999f,0.28879999f,0.65950000f,-0.09369999f,-0.53370001f,-0.24799999f,-0.10810001f,-0.33759999f,-0.60800000f,0.05299999f,-0.59759998f,-0.64349999f,0.38339999f,-0.74009996f,-0.27300001f,-0.10290000f,-0.16399999f,-0.17100000f,0.50130000f,-0.27160000f,0.17149999f,-0.90980001f,0.38469996f,-0.69499998f,0.47329999f,-0.65059997f,-1.09450001f,-0.01220000f,-0.84370001f,0.71650000f,-0.56409999f,0.69710001f,1.02350002f,0.64700003f,-0.82210004f,-0.60290001f,0.33770001f,0.25429999f,-0.45770000f,-0.82270001f,-0.48090002f,-0.86910003f,-0.10770001f,1.20480003f,-0.24990002f,-0.79950002f,0.09150001f,1.08810000f,-0.57910003f,0.16039999f,-0.79969998f,0.40550001f,0.87060002f,-0.35069998f,0.30390000f,-0.92680000f,1.08010002f,0.15729999f,0.28030002f,1.11289997f,0.52370001f,0.75860002f,-1.55090004f,-0.24590002f,0.24540000f,0.69449999f,-0.50470001f,0.69129999f,0.88099996f,-0.35340000f,-1.07570001f,0.10100004f,0.90860003f,-0.41660000f,0.70549999f,-0.03670001f,-1.21000001f,-0.55509998f,0.16950000f,-0.04500000f,0.63170001f,0.89349999f,-0.57219998f,0.06690000f,0.50250001f,-0.40440001f,0.52230001f,0.15750000f,-0.63990000f,-0.66810001f,0.68600002f,0.36400000f,-0.12900000f,-0.64650000f,-0.31890000f,-0.06730000f,-1.04199999f,-0.25370000f,-0.64120000f,0.47450002f,0.80890000f,0.46010000f,-0.90100000f,0.71439997f,-0.50559999f,-0.23100000f,-1.05630002f,-0.23820001f,0.47650001f,0.14990000f,-0.19029999f,-0.05349998f,0.21309999f,-0.58009997f,-0.39550003f,0.57250001f,0.57589999f,0.35300001f,0.44409999f,0.19220000f,-0.37449998f,0.02090003f,0.55989998f,0.44959997f,-0.00679999f,0.86740002f,0.66649998f,0.05830001f,1.26290000f,0.53379993f,-0.85200003f,-0.17360004f,-1.79349998f,0.06330002f,-0.02970000f,0.95790000f,0.01769999f,0.29800000f,0.18230000f,0.19370001f,-0.17069999f,0.37979999f,0.17980000f,-1.53900004f,0.68700001f,0.27000001f,-0.30699998f,-1.01719997f,0.01419999f,0.31380000f,-0.34230000f,-0.06110000f,0.30620001f,-0.18050001f,-0.32310001f,-1.26359999f,-0.29609997f,0.50690000f,0.27380001f,0.12459999f,0.37300001f,-0.69240003f,-0.92910003f,-0.27570001f,0.76000002f,-0.82449997f,-0.40849998f,0.12709999f,-0.48429997f,-0.72300000f,0.20429999f,-0.75979999f,0.17900004f,-0.25250003f,-0.83279997f,0.05549997f,-0.89789998f,0.41870000f,-0.00649998f,0.52100000f,-0.14509999f,-0.47600001f,0.10430000f,-0.29000000f,-0.11150000f,0.29629999f,0.02190000f,0.78250001f,0.75800001f,0.95050001f,0.21449998f,-0.47579999f,0.39449997f,-0.15050000f,-0.26410000f,-0.15810000f,0.19800000f,-0.26550000f,-0.12440000f,0.27299999f,0.26190000f,0.86619997f,-0.69300000f,0.13919999f,-0.30060000f,0.88000000f,-0.45190001f,0.72280000f,-0.30050000f,0.77270002f,-0.15180002f,0.11370001f,0.82570004f,-0.81880000f,-0.83449994f,0.74990001f,-0.93500001f,-0.43210004f,0.87710002f,-0.54429999f,0.76810001f,-0.27770001f,-0.08189997f,-0.83669998f,-0.73410006f,1.04240000f,-0.96680003f,0.07760002f,-0.12310000f,1.36210000f,-0.24030002f,1.10470002f,0.47510002f,-1.10270003f,-0.42680000f,0.06590001f,0.07350000f,-1.32960002f,-0.18119996f,0.74300002f,0.20570000f,-1.64330002f,-0.18930002f,-0.41370000f,-1.37549998f,0.45210001f,1.41799998f,0.13779995f,-0.80380000f,0.30900003f,1.32570001f,-0.09170001f,0.04239999f,0.71600001f,0.34589999f,0.78979999f,1.64860006f,0.58189997f,-0.24239999f,0.00840000f,-0.30189999f,0.80830001f,0.20030003f,-0.54550000f,-0.48659997f,-0.88140000f,-0.56849997f,0.23790001f,0.13830003f,-0.19090000f,-0.16000000f,0.21040001f,-0.41129999f,-0.12459999f,-0.95540003f,-0.66469997f,-0.31080000f,0.01199998f,0.46899999f,-0.43430000f,-0.73510003f,0.51559997f,-0.09410000f,0.44989999f,-0.52529998f,-0.16680000f,-0.56040001f,0.21860000f,-0.04090000f,0.27670000f,-0.39409998f,-0.08200001f,0.53920002f,-0.53539997f,-0.74719999f,-0.50920002f,-0.40379998f,0.11510000f,-0.62750000f,-0.31359999f,0.48820000f,-0.07990000f,0.16160002f,0.40210001f,0.60079999f,0.26619998f,-0.53319999f,-0.21370000f,-0.45640003f,-0.34640001f,-0.42550001f,-0.32040001f,0.10590000f,-0.68650004f,-0.14080001f,0.66040001f,-0.27920000f,0.22940003f,0.68560000f,0.55650000f,0.46539999f,-0.28450001f,0.21280000f,0.00039999f,-0.32980000f,0.49029998f,0.17639996f,-0.57299999f,-0.22009998f,-0.08259997f,0.27429999f,0.35869999f,0.42260000f,0.06340000f,-0.63049998f,-0.53159999f,0.20099999f,-0.28289998f,-0.21839998f,0.17460000f,0.45849999f,-0.88820002f,-0.00940001f,0.04729999f,0.67810000f,-0.36600000f,0.75520001f,1.20680006f,0.06810000f,-0.22730001f,-0.92410002f,0.65320000f,-0.77090000f,-0.92170004f,0.17540000f,-0.65720001f,-0.58480004f,-0.44219997f,-0.62630000f,-0.34030001f,-0.71909999f,0.36829998f,0.77229999f,-0.38189997f,-0.45989999f,-1.27950003f,0.19940000f,-0.31360000f,-0.67040001f,0.10840002f,-0.79630000f,-1.68950003f,-0.03550001f,0.49670001f,0.97390003f,-0.45589997f,0.42520000f,0.26720003f,0.40559998f,-0.25389999f,0.25449999f,0.16099998f,0.29670001f,0.74430002f,-0.08310000f,0.28980000f,-0.39810000f,0.22740003f,0.84660000f,-0.78330001f,-0.15259998f,0.80120001f,0.13860002f,-0.24160003f,-0.57530002f,-0.70090000f,-0.14579999f,0.68279998f,-0.30820001f,-0.02579999f,0.49800001f,0.75730000f,0.55520000f,-0.44090000f,-0.49340000f,-0.17059999f,0.41929999f,0.60180001f,0.47580000f,-0.38430001f,1.20779998f,0.80979999f,-0.60939998f,-0.33020001f,-0.19240000f,0.16360000f,-0.36670000f,-0.27780001f,0.04890000f,-0.42470000f,-0.24439999f,0.36890000f,-0.53370000f,-0.04539998f,0.68499999f,0.80819999f,0.25759997f,-0.77209998f,0.51980000f,0.49640000f,-0.83349998f,0.40199998f,0.92879999f,-0.50869999f,-0.45779999f,0.00659999f,0.58220001f,-0.78750001f,-1.29390007f,-0.44409997f,-0.56720000f,-0.23560005f,-0.22390000f,0.77889997f,1.47650002f,-0.35439999f,-0.39699998f,-1.37420001f,-0.17329999f,-0.29740000f,0.00339998f,-0.37249998f,-0.80099996f,-1.84740002f,-0.36049998f,0.55890000f,-0.33869995f,0.03020000f,-0.39039998f,-0.27919999f,0.14210001f,-0.83569998f,-0.91930002f,0.08019999f,0.52939997f,1.23219999f,-0.44029999f,0.17399999f,0.74399999f,0.30859999f,0.08370000f,-0.62429998f,-0.50699999f,-0.50380000f,-1.13799997f,-0.74759998f,0.58319998f,0.84520002f,0.42099999f,-0.65500001f,0.15180001f,0.15400000f,-0.06160001f,-0.35280000f,-0.23979999f,0.26830000f,0.02120000f,0.18020000f,0.12640000f,0.03859999f,-0.12800001f,-0.23139999f,0.29280000f,0.33040001f,0.02780000f,-0.51920001f,-0.05719999f,0.53570000f,-0.50569999f,-0.62560001f,-0.11450000f,0.51430001f,0.07319999f,-0.48420000f,1.09930002f,0.70380001f,-0.55380000f,-0.04030001f,0.07099999f,0.01930000f,0.56100001f,0.31920000f,-0.27390000f,-0.64029999f,-0.58160000f,0.16100000f,-0.08220004f,0.46510001f,0.30659999f,-0.58219998f,0.23059998f,0.01670001f,-0.03609999f,-0.87050001f,-0.16219999f,-0.22199999f,-0.50280001f,0.14049999f,0.46199999f,1.06440002f,-0.35049999f,-0.32389999f,-0.55030001f,0.28159999f,-0.23720001f,-0.37720001f,-0.34560000f,0.29700000f,0.14340001f,-0.43799999f,-0.60250001f,-0.46490004f,0.70439998f,-0.54279999f,-0.28400001f,0.40959998f,0.78169998f,0.74290002f,-0.25050001f,0.76400001f,0.09160004f,-0.21629998f,-0.76130000f,-1.15210004f,-0.03220001f,0.74789999f,0.60630003f,0.49579997f,-0.23149999f,0.30650000f,-0.74709999f,-0.37630000f,0.37190000f,0.39300001f,0.03810000f,-0.35670001f,-0.19020000f,0.21240000f,0.58530000f,0.09679999f,-0.53389999f,0.00519999f,0.26220001f,0.24210000f,-0.46080000f,0.12840003f,0.76410000f,-0.32609999f,-0.37720001f,-0.05960000f,-0.24800000f,-0.31280002f,-0.13330000f,-1.12100001f,-0.68500000f,0.60430001f,-1.17409999f,-0.75019999f,0.62749999f,0.44740003f,-0.07400001f,-0.60160002f,-0.85930000f,-0.79380002f,0.14819999f,-0.05090002f,0.25340000f,0.40600000f,-0.26320001f,-0.09040001f,0.15520000f,-0.22260001f,-0.36960003f,-0.16560001f,0.76710000f,-0.16039999f,-0.37609999f,0.59590000f,0.52430003f,0.00250001f,-0.31680001f,-0.14280002f,0.43999997f,0.90239998f,0.86280003f,-0.52849998f,-0.31119999f,-0.53120001f,-0.71719998f,0.04110000f,0.44430000f,0.39759999f,-0.45209998f,-0.34529999f,0.33580000f,-0.73450001f,-0.86090005f,0.19149999f,-0.76119997f,-0.07159998f,0.27509999f,-0.58749998f,0.25449999f,0.62139999f,0.51320000f,0.41320001f,0.67549999f,-0.66260001f,-0.12940004f,-0.53729997f,0.34879998f,0.53800001f,-0.11479998f,-0.61880000f,-0.70840003f,0.49400001f,-0.29820001f,-0.19980001f,0.29239998f,0.68130001f,-1.27720000f,-0.97340001f,0.52399999f,-0.74889998f,-0.60639999f,0.25329999f,0.81250000f,0.30599998f,-0.73319999f,-0.08659999f,-0.14140001f,-0.11780001f,-0.68250001f,-0.42800001f,0.30560000f,-0.95719998f,-0.56619998f,0.61569998f,-0.52710002f,-0.22640000f,0.35720000f,0.58100000f,-0.02160002f,-0.74549999f,0.85899999f,0.76480002f,-0.15909999f,-0.87720002f,-0.65760001f,0.39030002f,-0.74360004f,-0.22160001f,0.61160002f,-0.77630000f,-0.20539998f,0.76219999f,-0.47720000f,-0.47740001f,-0.03050000f,0.36060002f,0.00500000f,-0.44360000f,-0.96710001f,0.95290002f,0.61669999f,-0.51349999f,0.49850000f,0.42799998f,-0.39259999f,0.15739998f,0.21400000f,0.01730001f,-0.73909999f,0.17030000f,-0.48909998f,-0.65390001f,0.12300001f,-0.79590000f,-0.55470004f,0.15050000f,-0.12700000f,0.74259998f,-0.11019999f,-0.59010000f,-0.40890002f,0.64459998f,0.34509999f,0.02750001f,-0.61180000f,0.80509997f,0.35470001f,0.40739998f,-0.23250000f,0.52590002f,-0.34999997f,-0.84999999f,-0.62120000f,-0.38789999f,-0.25900000f,0.31659998f,0.42570000f,-0.84399997f,-0.80000000f,0.36309997f,0.20310000f,-0.00330000f,0.45319997f,0.23140000f,-0.63710001f,-0.04079999f,0.76529998f,-0.28230001f,0.01880000f,0.30639999f,0.25440000f,0.37240001f,0.06590000f,0.56069999f,0.23279999f,-0.38489999f,0.46399999f,-0.02040003f,-0.61080000f,0.49970003f,0.11200000f,-0.54460001f,-0.24690002f,0.05719999f,0.34960000f,-0.23309999f,-0.36300000f,-0.03120001f,0.28689999f,-0.16660003f,-0.59869998f,0.27920001f,-0.15120000f,-0.49859999f,-0.92939998f,-0.56579998f,0.61889999f,-0.44760001f,-0.06520000f,0.45280000f,0.16550001f,0.04340000f,-0.20990000f,-0.05379999f,-0.18079999f,-0.10270000f,-0.42209997f,-0.67130001f,-0.57279996f,-0.24160000f,0.19239999f,-0.34959997f,-0.60149998f,-0.68430000f,-0.48599999f,-0.10470000f,-0.45030001f,0.13440000f,0.65519999f,0.47880003f,0.51740000f,0.19660000f,-0.09939997f,0.28019999f,-0.04069999f,-0.52030002f,-0.37559997f,-0.28890000f,-0.23970000f,0.50489998f,0.45359998f,0.96840001f,0.61049998f,-0.19330001f,-0.52010000f,0.59439996f,0.28899999f,0.22820000f,0.18989998f,0.13739999f,1.12619998f,-0.34339998f,-0.46020000f,-0.30660003f,0.06910000f,-0.25729999f,-0.54970000f,0.31299997f,0.19749999f,0.38389999f,0.75749996f,-0.41050000f,0.12839998f,0.40340002f,0.37960001f,0.63400000f,0.38599998f,-0.47900001f,0.90060002f,0.75200002f,-0.33320001f,-0.34700001f,-0.38900001f,0.06800001f,-0.36149999f,0.15720003f,0.69359999f,1.09249998f,0.90020001f,-0.30769997f,-0.96020001f,-0.69840000f,0.42750000f,0.24410000f,-0.02940001f,-0.30210000f,-0.75020003f,-0.30680000f,0.52580002f,0.76830002f,0.47699999f,-0.47940002f,-0.25769999f,-0.32539999f,-0.05380000f,-0.57029999f,-0.48179998f,0.25830001f,-0.63450000f,-0.69420001f,-0.02610000f,-0.15470003f,0.31900002f,0.62870001f,0.16789999f,-0.22350002f,-0.64049999f,0.63449997f,0.79530000f,-0.14699998f,-0.47200001f,-1.35200005f,-0.57639999f,0.11100000f,-0.75060003f,0.43449999f,0.30049999f,0.83650002f,-0.66519998f,0.23490001f,0.65130001f,-0.64170000f,0.86709998f,0.22190004f,0.39619998f,-0.41349999f,0.32650000f,0.32150000f,0.37149999f,0.36470002f,-0.18739999f,-0.83979999f,-0.58460001f,-0.16869998f,0.03120001f,-0.70920001f,0.37569997f,-0.19680000f,-0.02040002f,0.39249996f,0.28650000f,1.02690003f,0.70869997f,-0.57990001f,-0.21630005f,-0.76869998f,0.41929999f,0.72610003f,-0.58649999f,0.71349998f,0.23740001f,0.20760001f,-0.08280000f,-0.29870000f,0.16240003f,0.66680001f,1.26710001f,0.80860001f,-0.67389999f,0.37960002f,-0.00280001f,-0.57350001f,-0.10559998f,-0.39160001f,-0.38720001f,-1.42910000f,-1.08720001f,0.55079999f,-0.58980004f,-0.07180001f,0.61570001f,-0.13720000f,-0.05080000f,0.11650000f,-0.34650000f,-0.09079999f,0.25190000f,0.91859999f,0.74340001f,-0.29849998f,-1.07550004f,-0.42880000f,0.83920002f,0.30220001f,0.18400001f,-0.08680000f,0.68760001f,0.30580000f,-0.53500000f,0.13150000f,0.03300000f,-0.05190000f,-0.69709997f,0.07849998f,-0.17220000f,-0.00760000f,-0.25640001f,-0.59660000f,0.57349999f,1.11790003f,-0.29350000f,0.66370002f,-0.22869995f,0.36840000f,-0.43449998f,-1.00250001f,0.64299998f,-0.57179998f,-0.72060001f,0.67459999f,-0.82570000f,0.16989996f,-0.47949997f,-0.58559998f,-0.37439998f,-0.04040000f,-0.05810000f,0.03950000f,-0.20219999f,-0.70979997f,-0.77580001f,-0.52029999f,0.56580001f,-0.06299995f,-0.26819999f,-0.71849999f,-0.09089999f,-0.02680001f,0.71660000f,0.80860004f,0.09830000f,0.23190000f,-0.29850000f,0.09350000f,0.57109998f,0.76030001f,0.54659997f,0.31830000f,0.40989999f,0.36919999f,-0.23600000f,0.05020000f,0.25620002f,0.20400001f,0.09129998f,0.44800002f,0.46970000f,-0.53610002f,-0.06979998f,0.70670001f,-0.78000000f,-0.16299999f,0.80229998f,-0.14080001f,0.02020000f,0.15950000f,0.87480002f,0.56320000f,-0.54130001f,1.19330002f,0.89040002f,-0.49200001f,-0.52410000f,-0.61720002f,-0.06290000f,0.45190003f,-0.03400001f,-0.67130001f,0.25479999f,0.29559999f,-0.00280000f,-0.72559998f,-0.50779999f,0.36469999f,-0.46410004f,0.13500001f,0.80700002f,-0.03039998f,-0.18100000f,-0.26120001f,0.20600001f,-0.04310000f,-0.35079997f,-0.71289996f,-1.52449999f,-0.46250000f,-0.12130000f,-0.27650001f,-0.76919998f,0.57079997f,0.72160000f,-0.38030000f,0.48029997f,1.22310001f,-0.47949996f,-0.34320000f,0.18239998f,-0.19749999f,-0.33680001f,-0.40000003f,-0.23739999f,-0.08489999f,-0.99690002f,-0.53259998f,0.60670000f,-0.26650000f,0.67459998f,-0.42540000f,-0.08820002f,0.51339998f,-0.21100000f,-0.71540004f,-0.32779998f,0.01820000f,-0.24739999f,0.26569999f,-0.18520000f,0.43959999f,-0.72409998f,0.24779998f,0.76500001f,0.29810000f,-0.64849997f,-0.94210001f,0.36069999f,0.53430001f,-0.76890004f,-0.29080001f,0.57970001f,-0.41710001f,-0.19880000f,0.32090001f,-0.24440000f,-0.06899999f,0.22080000f,-0.56250003f,-0.13299999f,0.64510002f,0.17839998f,0.37340000f,0.27970001f,-0.88889998f,-0.71080000f,0.37659998f,-0.05440001f,0.11959999f,0.09549999f,-0.07359998f,-0.11719998f,0.09530001f,0.16449999f,0.12339999f,-0.10690000f,0.49070001f,0.55440002f,0.10080000f,1.18470003f,0.50780000f,-0.86570001f,-1.06110001f,-0.76640000f,0.52310000f,0.09690001f,0.00060002f,-0.00480000f,0.74560000f,0.26919998f,-0.70870000f,0.17500000f,0.56640002f,-0.23459998f,-0.76680001f,-0.45840003f,-0.02980000f,-0.06500000f,0.30020001f,-0.11790000f,-0.17650000f,-0.04610001f,-0.28950000f,0.31109999f,0.99630003f,-0.53049997f,0.63759998f,0.76160003f,0.51040000f,-0.02790000f,0.86130000f,-0.32599997f,-0.74389997f,-1.12150000f,0.19759996f,0.86229999f,1.41590003f,-0.08689999f,-0.18130000f,-0.44570000f,-0.56419999f,0.85330000f,0.78890005f,0.23089999f,0.91590001f,0.28590004f,0.44079999f,-0.16020000f,0.81780001f,0.13429997f,0.82139999f,1.18260003f,0.21240000f,-0.13569999f,-0.91010001f,-0.28129999f,-0.25530000f,-0.32960002f,-0.18360002f,0.09960000f,-0.12190000f,0.16860001f,0.39959999f,0.65870000f,0.56120001f,-0.18289999f,-0.55109999f,-0.39460000f,0.35199998f,0.04810000f,-0.38520003f,-0.58620000f,-0.48240000f,-0.22100000f,0.27739999f,-0.11170001f,0.12039999f,0.18170000f,1.09120001f,0.79980002f,-0.42899998f,-0.38109998f,-0.15919998f,0.38809998f,0.61119999f,0.64480002f,0.00050001f,0.18390001f,-0.03380000f,-0.22960000f,-0.91530002f,-0.30079999f,0.73520000f,-0.21179999f,-0.33400000f,-0.11420000f,0.36940000f,0.38040001f,0.02610000f,-0.77359999f,-0.02789999f,-0.00899998f,-0.87700000f,-1.03220005f,-0.44249998f,0.31419999f,0.56180000f,-0.42899999f,0.40180000f,-0.05619998f,0.24550000f,0.42539997f,1.20899998f,0.78479999f,-0.58330000f,-0.87410002f,-0.08389999f,-0.76589997f,-0.72030001f,-0.38259997f,-0.68359999f,-0.97840002f,-0.44710001f,0.80210001f,0.14050005f,-0.05040000f,0.40359998f,0.98479999f,-0.63460000f,0.57409997f,0.23649998f,0.26869999f,0.35400000f,0.39120002f,-0.37099999f,-0.95310001f,-0.61590005f,0.44219998f,-0.12780000f,0.04740000f,-0.35399999f,0.58850001f,0.51730004f,0.35059997f,0.22010002f,0.01790001f,-0.00879999f,0.03070000f,0.21879998f,0.46920000f,0.30180000f,0.44890000f,0.47220001f,0.05130000f,0.33970000f,0.20459999f,-0.25110000f,0.97110000f,0.32159997f,-0.83849999f,-0.17979999f,-0.18319999f,0.05150000f,-0.52480001f,-0.47920000f,0.15220001f,-0.52500000f,-0.59820001f,-0.01199999f,-0.26870001f,-0.16900000f,0.17170001f,-0.12150000f,-0.26020002f,-0.18170000f,0.09130000f,0.37040002f,0.38499999f,-0.61859999f,-0.63320000f,0.05330000f,-1.02150001f,-0.79840001f,0.44500000f,0.63020000f,0.67420002f,-0.01389999f,1.19800002f,1.53980001f,0.05519999f,0.42880000f,0.64760002f,-0.68939996f,0.42319998f,0.37840000f,-0.44729999f,0.77089998f,0.71290002f,-0.07189999f,-0.19929999f,-0.64129999f,0.37000000f,0.60359999f,0.02400003f,0.18739999f,0.12610000f,0.38450001f,0.41839997f,-0.03620000f,0.48860001f,0.64469997f,-0.23730001f,0.19949998f,0.06529999f,0.03230000f,0.31510001f,0.37770000f,-0.33150000f,-0.35910001f,-0.61459998f,0.58970001f,0.76450005f,0.61359997f,-0.36869999f,0.08489999f,0.54740000f,-0.08910000f,0.89850001f,-0.68050000f,0.42579998f,-0.01420001f,-0.11569999f,0.25320000f,-0.01100000f,0.22140002f,0.23760001f,1.05579999f,0.67179999f,-0.52719999f,0.43080001f,0.48060002f,0.01260001f,0.42690000f,0.11879999f,-0.30510000f,0.85690002f,0.30699999f,-0.78100001f,-0.74389999f,-0.32759998f,0.61829999f,-1.02299998f,-0.67839999f,0.59949998f,0.39590001f,0.18519999f,-0.40990001f,-0.91850000f,-0.78420001f,0.23100000f,-0.17559999f,0.05360003f,0.41530000f,0.63130001f,0.21839999f,-0.56610000f,0.12900001f,-0.18020000f,-0.36309999f,-0.67880003f,-0.26220002f,0.47670000f,0.34840000f,0.14639999f,-0.33870000f,-0.69429998f,-0.28190004f,-0.45790000f,-0.17830000f,-0.30470002f,-0.22950000f,0.79609997f,0.18490002f,-0.50430001f,0.29010001f,-0.01469999f,0.23459999f,0.85739999f,0.92820005f,0.25990000f,0.08480000f,-0.67400000f,-0.10180000f,-0.01240000f,0.69039999f,0.31340000f,0.02490000f,1.05449999f,0.00420001f,-0.61279999f,-1.32520004f,0.59469998f,-0.70779997f,-0.14899999f,-0.24620001f,0.80650001f,1.38890006f,0.21239999f,0.18260000f,-0.30980000f,0.49069997f,0.07860000f,0.04020000f,-0.20509997f,-0.86920000f,-0.70040003f,0.04900000f,-0.26829999f,-0.74510001f,-0.31979999f,0.52050002f,-0.32619999f,-0.35659999f,0.02330000f,-0.61000000f,-0.60960001f,0.10470000f,0.50130004f,0.01740002f,-0.54990000f,-0.05910003f,0.30440001f,0.49930001f,0.03180002f,-0.14420000f,-0.25480001f,-0.47240001f,-0.35800001f,0.20110000f,-0.14620000f,-0.12820000f,0.00730000f,0.59849999f,0.46600000f,-0.36999999f,0.13129999f,0.30200000f,0.20740000f,-0.12129999f,-0.05919999f,0.12549999f,0.28380000f,0.15520000f,-0.15070000f,0.02739999f,0.25640000f,0.18190000f,-0.72880000f,-0.49720000f,0.36760000f,0.81479999f,0.75160002f,-0.17589998f,-0.20869999f,1.42300004f,0.37489997f,-0.05600000f,0.26239999f,0.58659998f,-0.12770000f,0.44510001f,0.50089996f,0.64830002f,0.55830003f,-0.63899999f,0.51419997f,0.79140000f,0.30249999f,-0.33149999f,-0.51390002f,0.22560000f,-0.15670000f,0.23530000f,0.09350000f,-0.28339999f,-0.28660000f,-0.34999999f,-0.66150000f,-1.62750005f,-0.45319997f,0.27550000f,0.25670002f,0.00440000f,0.20560000f,0.43400000f,-0.00540000f,0.34470000f,0.25590002f,-0.50199997f,-0.47169998f,-0.79730000f,0.23739999f,-0.27379999f,0.30380001f,-0.64880000f,0.40110000f,-0.22769998f,0.07979999f,0.63490001f,-1.13950002f,-0.67680000f,0.65190000f,-0.64190000f,-0.11479999f,0.66349998f,-0.74270001f,-0.22799998f,0.63330001f,0.79399999f,0.42019998f,-0.60200000f,1.12020003f,0.82660002f,-0.43720002f,-0.81740002f,-0.47359999f,0.61640001f,0.49530003f,0.07540000f,-0.61720002f,0.97580002f,0.33419998f,-0.79680001f,0.16290000f,0.14920000f,-0.06970000f,-0.28070001f,0.06240000f,0.33960000f,0.08610001f,0.30820003f,0.33980000f,-0.47370001f,0.01980002f,0.66060000f,0.31420002f,-0.04799999f,-0.35699999f,-0.00339998f,-0.28000002f,-0.35930002f,-0.07660000f,-0.26029999f,-1.59090002f,0.02090002f,-0.13680000f,-0.13790000f,-0.71249996f,-0.45599999f,-0.01970001f,0.02049997f,0.32130001f,0.89409999f,0.58710000f,0.33000002f,-0.01380003f,0.79439996f,0.44759999f,-0.21200001f,0.54900002f,0.12370000f,1.01070001f,0.07289998f,0.27400001f,0.03530001f,1.24829996f,0.45059999f,0.60110001f,-0.90529999f,-0.40620000f,-0.55069999f,-0.41829996f,-0.38359999f,0.61980000f,0.54479998f,0.35790000f,-0.32090000f,-0.11849999f,-0.16160000f,-0.50170002f,1.02690001f,0.28659999f,0.47030001f,1.00949998f,0.29629999f,-0.06509999f,0.59989998f,0.50400000f,-0.33379999f,-0.72120000f,0.58120002f,0.09520000f,-0.98420001f,-0.59060000f,0.31059999f,0.90870000f,-0.53400002f,-0.48460002f,0.67899998f,-0.04240000f,-0.22560000f,0.33919999f,0.53680002f,0.14139999f,0.05439997f,0.78860001f,0.36740002f,-0.70889996f,-0.38220001f,0.71100000f,1.16530001f,-0.40680000f,0.01599999f,0.59659999f,-0.75800000f,0.34379998f,1.48059998f,0.38820000f,-0.19579999f,-0.83429999f,0.16740000f,0.47359999f,-0.11510000f,0.13879999f,-0.61299999f,-0.37820001f,0.23920000f,-0.34779999f,-0.66720000f,-0.14140000f,-0.10990000f,-0.67879999f,0.43920001f,0.02170000f,-1.04070003f,0.83730001f,0.37550001f,0.88890000f,-0.56690001f,-0.08970000f,0.70520001f,-1.07320001f,-0.58430002f,0.45490002f,-0.19470000f,-0.21550001f,0.30539999f,0.89459998f,0.24469999f,-0.61229997f,1.36069998f,0.58230000f,1.27800000f,0.04819995f,0.20779999f,0.59680000f,-0.53480000f,-0.19300000f,1.56260000f,-0.73980001f,-0.19790001f,-0.89840001f,0.35820001f,0.09880001f,-0.12970002f,0.57529997f,0.38919999f,-0.36299999f,-0.26779998f,-0.32470000f,-0.72920000f,0.04480002f,-0.07249999f,-0.08460000f,-0.45999998f,0.96100001f,0.39200002f,-0.87029996f,0.71780002f,0.10840002f,-0.24950000f,-0.76760004f,-0.23620001f,1.07540001f,0.57259999f,0.12240001f,-0.03249998f,0.68060001f,-0.14820000f,-1.26129998f,-0.52680000f,0.78040001f,1.30020000f,0.36100000f,-0.05159999f,-0.15310000f,-0.55900001f,0.80200001f,1.62689999f,-0.48459999f,0.81339998f,0.61689999f,0.07800001f,-0.11360000f,0.12299997f,-0.13900000f,-0.12780000f,0.61969998f,0.48880000f,-0.40680000f,-1.09599997f,0.73940000f,0.04480001f,-0.75549997f,-0.76760000f,0.15259998f,0.73939998f,-0.26359999f,0.14660000f,-0.74809998f,1.61769998f,0.67240000f,-0.00789999f,1.11070001f,0.31840001f,1.09090004f,-1.20430003f,-0.53920002f,0.20950003f,0.92609997f,0.25459999f,-1.33189999f,0.78510001f,0.27770000f,1.38069999f,-0.10290002f,0.19390001f,-0.02799999f,0.48019999f,0.09150000f,1.79479999f,-0.10660003f,0.15230000f,0.49369995f,-0.07610002f,0.32710000f,0.21219999f,0.04380001f,-0.07280000f,0.76900000f,-0.24240000f,-0.21700000f,-1.17249997f,0.33230001f,0.02130000f,-0.65889997f,1.05329998f,0.35400000f,0.60129997f,-0.95469999f,-0.22480000f,1.21620000f,-0.24459999f,0.45399999f,-0.72679998f,-0.51220001f,-0.67020002f,0.44020000f,0.93770001f,-0.10840000f,0.26320001f,0.43780000f,0.37100000f,-0.40400000f,-0.94090000f,0.06260001f,0.37260001f,0.43210000f,-0.29200000f,-0.16080000f,0.31559999f,0.10080001f,0.37560001f,-0.03439999f,0.41600001f,0.22100002f,0.20240001f,-0.25000001f,-0.73120000f,0.09059997f,-0.32360001f,-0.23940001f,-0.42379999f,-0.38500000f,0.62000001f,0.24790002f,-0.14540000f,0.32500000f,0.89170000f,-0.11000000f,0.15860000f,-0.31259998f,0.10160001f,-0.69779999f,-0.42000002f,0.75100003f,-0.33769999f,-0.37979998f,0.10220001f,-0.29180000f,0.87490000f,-0.58850003f,-0.02830000f,0.49700000f,0.06699999f,0.08560000f,-1.02280000f,0.17460001f,-0.03330000f,0.55630000f,0.39609999f,0.21090000f,0.29980000f,-0.51699998f,-0.24020000f,-0.04260000f,0.41419999f,0.29120001f,0.43530002f,0.78690000f,0.24280000f,0.08910000f,-0.88329997f,-0.58590000f,-0.68260000f,-0.68339998f,-0.19670000f,0.07529998f,-0.10010000f,0.27680002f,1.07220001f,0.09599998f,0.05179999f,-0.48290001f,-0.07490000f,0.12160000f,-0.42559999f,-0.38679995f,-0.38749999f,-0.74690000f,0.27200000f,0.17820000f,0.37700000f,-0.31209999f,0.14420000f,-0.12080000f,0.00690000f,-0.34760000f,-0.25360001f,-0.49659999f,0.18580001f,0.50880001f,0.40810000f,0.79520001f,0.34180002f,-0.50399998f,-0.16840000f,-0.40220001f,0.18499997f,-0.30440001f,-0.24780000f,0.61340000f,0.43780002f,-0.58320000f,-0.27150005f,0.49820000f,-0.71859999f,-0.54250002f,-0.50600003f,-0.39120001f,-0.17859999f,-0.01060001f,-0.86760001f,-0.13690002f,0.49820001f,0.34159999f,-0.45209999f,0.02160000f,0.09200000f,0.47799999f,-0.24320001f,-0.46120002f,0.10319999f,-0.40999999f,-0.03610000f,-0.37360001f,0.50499998f,0.35460000f,0.09050001f,0.12590000f,-0.04180001f,-0.78830000f,-0.73509997f,-0.20289999f,0.56599999f,0.67259998f,0.34330000f,-0.33549999f,1.36969998f,0.53720000f,0.21319998f,-0.51959999f,-0.35070000f,0.69770003f,-0.57190000f,-0.34620001f,-0.08620002f,0.20200003f,-0.23290000f,-0.40019999f,0.17040002f,-0.26900000f,-0.42580000f,-1.03900001f,-0.38880001f,-0.08389998f,-0.64889998f,-0.57700001f,-0.40530000f,0.93769997f,0.44339999f,0.63080001f,0.13879998f,0.00039999f,0.07720000f,-0.67880001f,-0.40100002f,-0.53510005f,-1.02620002f,0.40340000f,-1.07220001f,-0.75750004f,0.16039999f,-0.66359999f,-0.33620001f,-0.74120000f,0.24779999f,0.82899999f,-0.23100001f,-0.07940000f,0.49409999f,0.12960000f,-0.28740000f,0.23799999f,0.59099999f,-0.60199999f,-0.86609999f,0.23200001f,-0.05740000f,0.16359999f,-0.68920001f,-0.30300002f,0.16579999f,0.03000001f,0.78340001f,-0.03939996f,0.33480002f,-0.74940001f,-0.66540004f,0.43600003f,0.08399999f,0.26119996f,0.72020000f,-0.03159998f,-0.48909999f,-0.22660000f,-0.41920001f,0.49949995f,-0.41020001f,-0.15499999f,0.11810001f,0.37080002f,-0.01860001f,-0.68690000f,-0.24069998f,-0.50750001f,-0.29149998f,-0.26869997f,-0.35910000f,0.72079998f,-0.84000000f,-0.16490000f,0.55450000f,-0.35370000f,-0.19250000f,0.40860002f,0.00500000f,-0.19330001f,-0.79819998f,0.36240000f,-0.11570001f,0.33100000f,0.31380000f,0.00450000f,-0.06650001f,-1.21529998f,-0.43120000f,-0.13009999f,0.60189999f,0.55040001f,-0.63510002f,-0.10229995f,-0.31980000f,0.53839998f,0.72320000f,0.14639999f,-0.30689998f,0.99329999f,0.25780000f,0.60359998f,-0.59019999f,-0.42450000f,-0.01689999f,-0.70349998f,-0.24209999f,-0.71540000f,0.48869999f,0.73080000f,0.19120000f,-0.35419999f,0.18280000f,0.27259999f,0.44779998f,0.05280001f,0.55980002f,0.41920002f,-0.24600000f,0.04079998f,-0.20820000f,-0.58360001f,-0.22680003f,0.22819997f,-0.56480002f,0.04060001f,0.56520001f,0.29640000f,0.24419999f,0.10699999f,0.05939999f,-0.64080001f,-0.82109999f,-0.65979999f,-0.31180001f,0.50969998f,-0.45120001f,-0.40839999f,-0.08319999f,0.65219999f,-0.67799999f,-1.15949998f,0.36200001f,0.14920001f,0.10100000f,-0.27060000f,0.08660000f,0.48429999f,-0.06600000f,-0.33099999f,-0.31139999f,-0.39300001f,0.23850000f,-0.14989999f,1.18009995f,0.39389998f,0.64479998f,0.50239996f,0.17509999f,0.51270001f,0.51469999f,0.33800001f,-0.39450002f,-0.35009999f,-0.01350000f,0.05619997f,-1.00020000f,-0.35740001f,0.47880001f,-0.75200000f,-0.21750000f,0.25079999f,0.61959997f,0.23769999f,-0.98189999f,-0.44249998f,-0.30300000f,0.40259999f,-1.14879996f,-0.47820000f,-0.27219999f,-0.96259996f,-0.39839999f,-1.14839997f,0.37260001f,-0.10770000f,0.28460001f,0.64739999f,0.19260000f,0.50359999f,-0.29380000f,-0.08900000f,-0.40329998f,-0.36089996f,-0.20079999f,0.32339999f,0.22420000f,0.53700001f,0.45900001f,-0.60429996f,-0.58600002f,0.56000000f,1.25100002f,-0.30080002f,0.92840003f,0.84560005f,0.12700000f,-0.60900002f,-0.75250001f,0.76600000f,0.30860002f,-0.63659998f,-0.10579997f,0.91780000f,0.13390002f,0.33240001f,-0.74420000f,-0.53300003f,-0.22900001f,-0.21900002f,-0.20770000f,0.34840003f,-0.05640000f,0.23419996f,-0.47420002f,0.53840000f,0.78330002f,-0.10540000f,-0.40399998f,-0.05150000f,0.31700002f,-0.68899999f,-0.96990001f,-0.16900001f,-0.79459999f,-0.00090000f,0.74340003f,0.46300000f,-0.63669999f,0.39100001f,-0.40479999f,-0.60209998f,1.06569999f,0.55690000f,1.31400002f,-0.35200004f,0.03299999f,0.86800002f,0.29599996f,0.42620001f,-0.86350001f,-0.31449998f,-0.27150000f,-0.52039999f,1.29159998f,0.52510000f,0.01979998f,0.51360000f,0.57800001f,-0.46190000f,-0.09069997f,-0.33600000f,-0.35540001f,-0.51120000f,-0.18640001f,0.47839999f,0.49160002f,0.02880000f,0.75070000f,-0.24350004f,0.11799999f,-0.06969998f,-0.44869996f,-0.29959999f,-1.05280000f,-0.11139994f,-0.23979998f,0.01340004f,-0.81759996f,-0.59260000f,-0.54920001f,1.36899999f,0.62420000f,-0.28559998f,-0.43700002f,-0.08200000f,0.26960001f,0.26860001f,0.81280002f,0.21060002f,-0.98439998f,-0.52779999f,0.76620000f,0.54930000f,-0.68320002f,-0.00940000f,0.91199999f,-0.53080001f,-0.46280000f,0.55219998f,0.35999999f,-1.13180001f,-0.54200002f,0.50140003f,0.21439999f,0.10909996f,0.10560000f,-0.02620000f,-0.07280000f,0.10080001f,0.14040001f,0.50439998f,-0.16579998f,0.79160000f,0.30989999f,0.69360003f,-0.18780000f,-0.25360005f,0.07200000f,0.02440000f,-0.54879999f,-0.49100001f,0.23060000f,0.44170002f,0.07260000f,-0.13340001f,-0.55849998f,0.09679999f,-0.24600000f,0.28500001f,0.09579999f,0.12200001f,-0.94660000f,1.26020001f,0.52170001f,0.38979996f,-0.17920000f,0.29200001f,0.88770000f,-0.93190001f,-0.33600000f,0.53660000f,-1.06379998f,-0.55019999f,-0.41539997f,-0.32859998f,-0.59190001f,0.35259997f,0.89959999f,0.27649999f,-0.04390000f,0.13010000f,0.02320000f,0.69689999f,0.29210000f,0.05270000f,0.23919996f,0.35019999f,0.44890001f,0.01019998f,0.86260002f,0.10930000f,-0.69440001f,0.07600001f,0.11660001f,0.32770000f,-0.51810001f,-0.04830000f,-0.68839999f,-0.03700000f,0.01019999f,-0.43109998f,-0.14750003f,-0.38999999f,0.66339999f,1.31579996f,0.18820001f,0.43620002f,0.22210001f,0.61640001f,0.56000001f,-0.56019996f,0.82820001f,-0.07340000f,-1.13269998f,0.74379999f,0.06080000f,-0.38649999f,0.09020000f,0.16320000f,0.26910001f,-0.56120001f,0.67700001f,1.04020002f,-0.35200002f,0.93780001f,0.55160005f,-0.17120000f,-0.74200001f,-0.07000002f,-0.73520003f,-0.14039999f,0.71040002f,0.00760000f,0.40199999f,0.26300000f,0.32219999f,-0.56239999f,-0.55570000f,0.88460003f,0.30040000f,-0.75810000f,-0.41380001f,-0.12059999f,0.74109998f,-0.21660001f,-0.15140000f,1.47879996f,0.01559997f,0.15130000f,0.32990001f,0.60810000f,0.32110001f,-0.51869998f,1.25849997f,0.64269999f,-1.10199999f,1.06660000f,0.35320000f,-0.17119998f,1.10299995f,0.31309998f,0.37840001f,0.27259999f,0.09910000f,1.03330001f,-0.24990003f,0.15060000f,0.45460000f,0.20219996f,0.46010000f,-0.08509999f,-0.78909997f,-0.54730000f,0.61250003f,-1.11950000f,-0.41170000f,0.30379999f,0.32179997f,0.23939999f,-0.51799998f,0.02260001f,-0.21130000f,-0.62470000f,1.44950000f,0.57140000f,0.80049999f,-0.63050000f,-0.30930000f,-0.42520001f,-0.60120002f,0.42000002f,-0.04320000f,0.12799998f,0.31040001f,-0.18120000f,-0.36120001f,0.18620000f,0.00740001f,-0.03889999f,0.72660003f,-0.12540000f,-0.95950001f,0.43460001f,0.39359998f,-0.56029999f,0.36439998f,-0.88580001f,-0.93100000f,-0.06240000f,0.40459999f,0.86079997f,0.28400001f,-0.39179998f,-1.13399999f,-0.14660000f,0.19860000f,0.39829999f,0.30240001f,0.53900000f,-0.48999998f,-0.67580002f,0.23299999f,0.13130002f,0.48440000f,-0.89000001f,-0.94940003f,0.17500000f,-0.24039999f,-0.90089999f,-0.75040001f,0.24739999f,0.94400000f,-0.02299999f,0.20090000f,0.36990001f,0.59710000f,0.07389999f,-0.31130000f,0.29510001f,0.01810000f,0.03450001f,0.27550000f,0.06470000f,-0.91440001f,0.89500002f,0.26320000f,-0.58400001f,0.87219997f,0.47609999f,-0.95619999f,-0.17940000f,-0.36630001f,1.06069998f,0.27229997f,0.13479999f,-1.31990000f,0.03890005f,-0.02239998f,0.43459999f,-0.03880000f,0.03600000f,-0.56980002f,0.78819998f,0.52710001f,-0.16880002f,-0.81460001f,-0.05559999f,-0.92410000f,-0.00769997f,-0.33170001f,-1.08050000f,0.00730003f,0.01600001f,0.86849999f,-0.84390000f,-0.18440000f,0.43640000f,-0.01140002f,-0.09400000f,0.02599999f,0.71619999f,0.48220000f,0.23320000f,-0.48969998f,-0.08719999f,0.61480001f,0.22960001f,0.44539998f,-0.58760001f,-1.11129996f,-0.73720001f,-0.49660002f,0.72219997f,0.11180000f,-0.01699999f,0.42309998f,0.03920000f,0.40800000f,0.72959999f,-0.24659998f,0.77020002f,0.20230001f,0.48279998f,-0.24799999f,-0.89099996f,0.14040001f,0.72220002f,-0.02019995f,-0.15860001f,-0.20320000f,-0.24770000f,0.53840001f,0.03340002f,0.20560000f,-0.15240000f,-0.44999999f,-0.08980001f,0.16400000f,0.35900000f,-0.30679999f,0.65160000f,-0.47000000f,0.89940001f,-0.05780002f,-0.11260001f,-0.44969999f,0.83329997f,0.36999999f,0.19049999f,0.33209999f,0.36230001f,-1.19169996f,0.13769999f,-0.11280001f,0.66900000f,-1.37659998f,-0.65770001f,0.61309999f,0.18850000f,-0.04010000f,0.93430000f,0.41269997f,0.18549999f,0.06189997f,0.20690001f,0.42630002f,-0.92309997f,0.45489999f,0.09870000f,-0.04609997f,0.72189999f,0.53780001f,-0.37730000f,-0.39989999f,-0.14940000f,0.51860003f,0.83260000f,0.14950000f,-0.13680000f,-0.55399997f,-0.33919999f,-0.37110002f,0.47169998f,0.33740000f,-1.77829997f,-1.30889999f,0.12520000f,-0.13040000f,-0.50419999f,0.41240000f,0.59359999f,-0.24979997f,0.23180000f,0.43820000f,-0.43969997f,-0.29660000f,0.28260000f,0.60489999f,-0.72040001f,0.07359997f,0.27780000f,0.07640000f,-0.27780000f,-0.35220000f,0.13760001f,-0.61560000f,-0.53120002f,-0.07740000f,-0.75900000f,-0.29790001f,0.17940001f,-0.20300000f,-0.32670001f,-0.26460001f,-0.30420001f,0.25609999f,0.53200001f,0.42780000f,-0.59040000f,-0.04000001f,-0.75379999f,-0.23600002f,0.41920000f,-0.97300002f,-0.99880003f,0.09380001f,0.80280003f,0.18210004f,-0.60620003f,-0.11169999f,-0.59250000f,0.04710001f,0.01970000f,-0.20759999f,1.00959995f,0.56179998f,-0.52440000f,0.61659998f,0.43040000f,0.62779998f,-0.18120001f,0.02020000f,0.02269998f,-0.98170000f,-0.19870001f,-0.39710000f,-0.11709998f,-0.11720000f,-0.56540000f,-0.28459996f,-0.30479999f,-0.34049998f,-0.68309995f,-0.49889999f,-0.32420000f,0.09000002f,-0.03980000f,0.25080000f,-0.58460000f,-0.32180001f,-0.58240003f,1.03719997f,0.53210000f,-0.24189999f,-0.61909996f,-0.49339999f,-1.01000000f,-0.16719998f,-0.40030001f,0.19000002f,0.72859999f,0.55030001f,0.36740001f,-0.07880003f,0.20940001f,0.41260002f,0.22630001f,-0.35140000f,0.57259999f,0.16190003f,0.08700001f,0.58140003f,0.12750002f,-0.12240000f,-0.15720002f,-0.60000000f,-0.77540002f,0.21839999f,0.79190001f,0.62400000f,-0.30559999f,-0.76759999f,0.60519999f,-0.80500000f,-1.12780000f,-0.55040002f,0.34000001f,1.16280000f,0.06460001f,-0.82200001f,-0.14090005f,0.60360001f,-0.06579999f,-1.15340000f,-0.53560001f,0.11720000f,0.43660001f,-0.35900000f,-0.35559999f,0.01809999f,0.29260001f,0.00239999f,0.34629998f,-0.40280000f,0.20220000f,0.69219999f,0.37599999f,-0.62490001f,0.34810001f,0.62270000f,0.31050001f,-0.01710000f,-0.09210001f,0.26650000f,0.14070000f,0.55530001f,0.40470002f,-0.83130002f,-0.34410000f,-0.05670000f,0.65930000f,-0.91450001f,-0.18960000f,-0.68749998f,0.63170000f,0.08250000f,-1.11349998f,0.21530000f,-0.21280001f,1.23990001f,-0.46490003f,-0.09450000f,-0.05950001f,-0.50609996f,-0.52340000f,-1.23490002f,0.74030002f,0.29620001f,0.31350000f,-0.66529999f,-0.13810000f,-0.10160000f,-0.78059996f,-0.35009999f,0.59360001f,0.46139998f,0.03669999f,0.70309999f,-0.38730000f,-0.07820000f,0.59460001f,-1.36760002f,0.00380000f,-0.47039998f,-0.29490000f,0.06600000f,-0.77980001f,-0.51820003f,-0.42140001f,-0.29259998f,-0.27989999f,0.63120002f,0.38520001f,-0.65679997f,-0.33700001f,-0.16099999f,0.42190000f,0.16400000f,-0.40180001f,-0.32040001f,-0.05740000f,-0.09240000f,0.18489999f,-0.51400000f,0.75100002f,1.45300001f,0.27960000f,0.38419999f,-0.17420000f,0.17240000f,-0.11280000f,-0.37819999f,-0.07560000f,0.07860000f,-0.11780000f,0.08880000f,0.53380000f,0.62519999f,0.30600000f,-0.52120000f,-0.45020002f,-0.07599998f,0.87940002f,0.40600002f,0.29360001f,-0.18109998f,-0.33259998f,-0.35679996f,-0.27829999f,-0.56230000f,-0.50629997f,-0.43980000f,-0.53180001f,-0.85279996f,-0.28219998f,-0.61889998f,1.14669999f,0.54130000f,0.41930001f,-0.57410000f,-0.26870000f,-0.29970000f,-0.07449999f,-0.18120000f,0.22840000f,-0.13460000f,-0.10650000f,1.59200001f,-0.09200002f,0.15550001f,-0.14500002f,0.67099997f,0.36909999f,-0.40609999f,0.13990000f,0.02730000f,-0.20010001f,-0.06490000f,0.04880000f,0.80469999f,0.56669997f,0.30099999f,-0.39100001f,0.03740002f,-0.20300000f,0.39769999f,0.55330000f,0.52120002f,-0.85500002f,-0.08580003f,0.50680001f,-0.58760000f,-0.40060001f,0.58879999f,0.11360001f,-0.16599999f,0.50200003f,0.02160002f,0.01779997f,-0.63660001f,0.47899999f,1.00090000f,-0.25420002f,0.80500001f,0.23290003f,0.71360002f,-0.63400001f,-1.38160002f,-0.69420002f,0.04560001f,0.85810001f,-0.62820003f,0.03499998f,0.01070003f,-0.09920000f,0.23120000f,0.35080000f,0.19760000f,0.36740001f,0.56560000f,0.51060001f,0.29640002f,-0.74749998f,0.68940001f,0.16440001f,-0.54210000f,-0.19920000f,-0.37279999f,-0.61879998f,-0.44440002f,-0.37620001f,0.35859999f,-0.62720001f,-0.56910000f,-1.09590003f,-0.23119999f,-1.12490003f,-0.42549999f,0.51599997f,-0.37290001f,-0.46270005f,-0.59979999f,-0.31390001f,1.06910001f,-0.09600002f,0.98130001f,0.42449997f,-0.51359998f,0.34109999f,0.39870001f,-0.07020000f,0.25670001f,0.53890001f,-0.16800000f,0.61550002f,1.08790000f,-0.31559998f,0.83250001f,-0.14899998f,0.57319999f,-0.02020000f,-0.47039998f,0.37359998f,-0.48240000f,0.74070001f,-0.25139999f,0.69030002f,-0.19260000f,0.15360000f,-0.21700001f,0.57650001f,-0.26759999f,0.34070000f,1.34880002f,0.01020000f,1.09660001f,-0.18560002f,-0.55680000f,0.34299999f,0.73099999f,0.29009999f,0.32340001f,0.95800001f,0.69250002f,-0.40800000f,-0.90129999f,-0.43700000f,-0.06939999f,-0.74040000f,-0.59010001f,-0.08540000f,-0.25460001f,-0.40630002f,-0.17819999f,0.24220001f,-0.27530000f,0.06719998f,0.88749997f,0.43339999f,-0.69420000f,-0.95530000f,-0.62250000f,-0.20720000f,-0.60659999f,-0.35880000f,-0.65739999f,-1.36839998f,-0.89090000f,0.37900000f,0.75109999f,0.52170001f,-0.12219999f,0.17550000f,0.23010001f,0.33780000f,0.30719999f,0.02750000f,0.37539999f,0.55899999f,0.37150000f,-0.04140000f,0.68369999f,0.00840001f,-0.07020000f,-0.12820000f,-0.26620003f,-0.68099999f,-0.37160001f,0.09090001f,0.21020000f,0.23690001f,-0.03099999f,0.86979999f,0.07199998f,0.42880003f,0.46500000f,0.38500001f,1.12880001f,0.00780001f,0.89980000f,0.50850001f,-0.71779998f,0.29290003f,0.82550000f,0.02920001f,0.87170001f,0.04420001f,0.32599999f,0.13620000f,0.57380002f,0.55140000f,0.71360001f,-0.40050002f,-0.31680001f,-0.46270001f,0.11149997f,-0.53119998f,0.08609999f,-0.19300000f,0.38419998f,-0.23880001f,-0.43920000f,-0.07300001f,-0.47060000f,-0.29970000f,0.25699999f,0.10179998f,1.08429997f,0.51009999f,-0.05980001f,0.53710000f,-0.08950001f,-0.28640000f,-1.11820002f,-0.74420002f,-0.13820001f,0.31809997f,-0.21790002f,0.50919999f,1.18749999f,0.80359999f,-0.75020000f,-1.11759998f,-0.64709999f,0.01519999f,0.28569999f,-0.06440001f,-0.90640000f,-1.35189998f,-0.93879999f,-0.44199998f,-0.63829996f,0.01040003f,-0.04039999f,-0.04539998f,-0.21059999f,-0.22939999f,-0.48889999f,-0.58570000f,0.54739999f,0.97179997f,0.63129998f,0.19699998f,0.88469997f,0.36409999f,-0.24319998f,-0.88299997f,-0.24739999f,-0.70200001f,-0.06439999f,0.61710001f,-0.82239997f,0.35170003f,1.05710003f,-0.13840001f,0.79090002f,0.04300001f,0.85120000f,0.20659999f,1.07770002f,-0.02759999f,0.84430001f,-0.43670000f,-0.61019998f,-0.56149999f,0.72300000f,0.02459999f,0.81680001f,0.50470001f,0.01900000f,0.36790000f,1.12470000f,0.23019998f,1.18790000f,-0.17650003f,-0.49059999f,-0.00290001f,0.34500000f,0.22079999f,0.28699999f,0.62710001f,0.54599998f,0.59169999f,-0.55039999f,-0.26779998f,-0.63259998f,0.38230000f,-0.43199998f,0.17370001f,-0.48500001f,0.21279999f,-0.24940001f,0.93500002f,0.29210000f,0.37199999f,0.55499998f,-0.05840001f,-0.44480000f,-0.95790000f,-0.36659999f,-0.26680000f,-0.34100000f,-0.25420000f,0.49640000f,0.80789999f,0.54380000f,-0.33200000f,-0.24669999f,-0.29140000f,-0.04280000f,-0.36479999f,-0.22300001f,-0.11760001f,0.08480000f,0.14400000f,-0.24840001f,0.08359999f,-0.32080002f,0.22860001f,-0.20839999f,-0.27490000f,0.34100000f,0.11120000f,0.47950000f,-0.22740000f,-0.34589999f,0.23270002f,-0.49500000f,-0.66170000f,-0.64970001f,0.12400000f,0.15700000f,0.43180001f,0.39100000f,0.31380000f,0.05090000f,0.09159999f,-0.93280000f,0.25540001f,0.47079997f,0.08579999f,-0.04130002f,0.08180000f,0.14310000f,0.38060000f,0.02239999f,0.38260000f,-0.56270001f,-0.18419999f,-0.61590001f,0.69950001f,-0.05740000f,0.63590001f,-0.10919998f,0.32919999f,-0.03839999f,0.10640000f,-0.38719999f,0.09200001f,1.09120004f,0.00720000f,0.89840003f,-0.28019999f,0.75939997f,-0.23240002f,-1.22260001f,-0.12779999f,-1.03960000f,-0.48430003f,-0.53680000f,-0.31410000f,0.95030002f,0.27720000f,0.90850002f,-0.68580002f,-0.40959999f,-0.58460000f,-0.31679998f,0.43299998f,-0.34620000f,0.30730002f,-0.02129999f,-0.00100000f,0.31010000f,0.37410001f,0.00380000f,0.06589999f,-0.13570001f,0.38500000f,0.14720000f,0.55690000f,-0.38680000f,-0.16389999f,-0.27380000f,-0.02440001f,0.75319998f,0.21920000f,0.06740001f,-0.22079998f,-0.26649999f,-0.15640000f,-0.57260001f,-0.54440002f,0.21680001f,0.38970002f,-0.22159999f,0.37500000f,0.59809999f,-0.04870001f,0.30680001f,-0.15020002f,0.27100000f,0.32980000f,0.06249999f,-0.23950002f,0.01140000f,0.56649999f,0.32570000f,-0.26080000f,-0.30600000f,-0.43680001f,0.13960001f,-0.20600000f,-0.17300001f,0.21820002f,-0.18420000f,-0.13790003f,-0.57159998f,-0.14650000f,0.31110002f,0.15880000f,0.24050001f,-1.37300000f,-0.17059999f,-1.17040000f,0.89390001f,-0.18780000f,0.78950001f,0.81840001f,-0.54319999f,0.56960002f,-0.02180001f,0.50819998f,-0.00120003f,0.30340003f,0.62919999f,0.33220001f,0.55110001f,0.49339997f,0.36389998f,0.29890001f,0.44999998f,0.11509998f,-1.21580003f,0.16480000f,-0.99860003f,-0.11389998f,0.78599999f,-0.14570001f,0.30209999f,-0.56839997f,0.17350001f,0.71720001f,0.25360000f,0.64680000f,-0.28080001f,0.49400000f,-0.22040002f,-1.18900003f,0.39720000f,0.60400001f,0.68370000f,0.05659999f,0.32859999f,0.28879999f,-0.04690001f,-0.32019999f,-0.92679998f,-0.30709999f,-0.16520000f,-0.45070000f,-0.39360000f,-0.05340000f,-0.10060001f,-0.42570002f,0.47559999f,0.86509997f,0.26819999f,-0.10820000f,0.00780000f,-0.30710001f,0.15280001f,-0.47179999f,0.07100000f,-0.22400002f,0.06299999f,0.36420000f,0.47640001f,0.59580002f,0.14400000f,-0.23919999f,0.05080003f,-0.44840000f,0.09659999f,0.69469998f,0.08149999f,-0.06599998f,-0.46129998f,-0.54939999f,0.07399999f,-0.29310001f,0.03440000f,0.53260000f,-0.21380001f,-0.15570000f,0.63699998f,-0.29130004f,-0.08379998f,0.47059998f,-0.14800001f,-0.31540001f,0.18540000f,-0.09760001f,0.25830000f,0.38699999f,0.28309999f,0.63320003f,0.49179999f,0.52580000f,0.00570000f,0.11820000f,-0.16510001f,0.70280002f,0.22500000f,0.57660000f,-1.09700001f,0.28320000f,-0.84380001f,-0.09019999f,-0.82239998f,-0.04739996f,-0.19859998f,0.35879998f,-0.29700001f,1.23160001f,0.19360000f,1.01320000f,0.73510001f,-0.16680000f,0.49250001f,0.31530000f,0.73899997f,0.31569997f,-0.62810000f,0.15659999f,-0.47850000f,-0.23299997f,-0.37600000f,-0.03740000f,0.61599998f,0.04169999f,-0.33379999f,-0.19839999f,-0.41389999f,-0.38040001f,-0.23800000f,-0.19200000f,0.13740001f,0.01440001f,0.35070001f,0.07840002f,-0.45739998f,-0.01239999f,-0.16740000f,-0.66580001f,-0.23390000f,-0.18539999f,0.08680000f,-0.15450000f,0.57420000f,0.56189998f,0.48869999f,-0.01499999f,-0.68689997f,-0.28330000f,0.25520000f,-0.18640000f,0.14159999f,0.62639998f,1.09049996f,0.48839998f,-0.16720001f,0.12179999f,-0.22480001f,-0.20260000f,-0.45989999f,-0.29070000f,0.26239999f,0.16539999f,0.19379999f,0.13980001f,0.82210001f,0.92299999f,-0.29539998f,0.67119999f,0.97299998f,0.08140000f,0.84919998f,0.63920002f,-0.26000000f,0.59360003f,-0.79260002f,-0.24299999f,-0.65520001f,-0.80660003f,0.27240000f,-0.60260003f,-0.31800001f,0.24499999f,-0.15220000f,0.71379999f,-0.11019998f,0.58719999f,-0.98250001f,0.07800001f,-0.93390001f,-0.54449998f,0.54519998f,-0.35270000f,-0.96799998f,0.26239999f,-0.78879999f,-0.28409999f,-0.00180000f,-0.44490000f,0.84700002f,-0.00360000f,0.68700001f,0.14570000f,0.20199999f,0.19949999f,-0.53819998f,0.10079999f,-0.48739998f,-0.23789999f,-0.13620000f,0.04079998f,0.69129998f,0.50459999f,-0.64800001f,-1.12100001f,-0.66400001f,-0.62360002f,-0.69400002f,-0.25940000f,0.51800001f,0.55150000f,0.40000000f,0.05499998f,0.82599998f,0.34930000f,-0.31980000f,-0.11869998f,0.32590002f,0.41200000f,0.50620000f,0.01859999f,0.21220001f,0.01570000f,0.22790000f,-0.16599999f,0.02020002f,-0.43700000f,-0.44060000f,-0.75170001f,-0.27710000f,0.16819999f,-0.03050000f,-0.07030001f,0.60740000f,0.79190001f,0.47630000f,0.27499999f,-0.10750002f,-0.25630003f,0.01300000f,0.81870000f,0.42870001f,-0.07620002f,-0.38860000f,0.14710001f,-0.78939997f,0.03070004f,0.56100001f,0.20200001f,0.67300002f,0.50320000f,-0.40519999f,0.57320003f,-0.75350000f,0.10900000f,-0.74150002f,0.57419999f,-0.61059999f,0.35440001f,-0.12790000f,-0.86399998f,-0.04249997f,-0.01419998f,0.44799998f,-0.12980001f,-0.72710002f,0.02640001f,-0.61370002f,1.03540003f,0.29919998f,0.84940000f,0.11549998f,-0.08799999f,0.24369999f,-0.23529997f,0.35359998f,-0.20869999f,-0.67769999f,0.07479998f,-0.72190000f,-0.24269996f,0.77559998f,-0.22089999f,0.51070000f,-0.77319998f,0.31050002f,0.27410001f,-0.16180001f,-0.19320001f,-0.21420001f,-0.10060000f,0.24139999f,1.07979999f,0.62050000f,-0.38659999f,-0.61649997f,0.07850003f,-0.29399999f,-0.95959999f,-0.53080000f,-0.01599999f,-0.65339999f,-0.45880000f,0.52780000f,0.51579998f,-0.15630003f,-0.21919998f,0.18950003f,-0.27799999f,0.02120000f,0.10200000f,0.00360000f,-0.30420000f,-0.28179998f,-0.48329999f,-0.35359999f,-0.27049997f,0.13120003f,0.03660001f,0.51940003f,-0.20189999f,0.24040000f,0.40440000f,0.50700001f,-0.18080000f,-0.54030000f,-0.06980000f,0.29260000f,0.40689999f,0.44729999f,0.41459999f,0.32539998f,0.18980001f,-0.10000000f,0.20460001f,0.18040000f,-0.75019999f,-0.01699998f,-0.35370003f,-0.50000000f,-0.15510000f,-0.05040001f,0.51999998f,0.11439998f,-0.20900000f,0.75719997f,-0.08820002f,0.07400002f,0.84339999f,-0.07700002f,1.12810000f,-0.03500000f,0.91129999f,0.10880000f,-0.00320000f,0.07200000f,0.90680001f,0.23979998f,0.80180000f,0.02009997f,-0.62140000f,0.09850000f,1.03840002f,0.15619999f,0.76420000f,-0.64640002f,-0.40360000f,-0.59880001f,-0.37090001f,-0.02220000f,-0.20730000f,-0.64030001f,-0.24919998f,-0.60170000f,-0.33039998f,-0.12650000f,-0.75019998f,-1.06119996f,-0.78569998f,-0.27640001f,-0.04030000f,-0.12560000f,-0.02700002f,0.70519998f,0.46369999f,0.39499999f,1.17909998f,0.63289999f,0.01479999f,0.64069997f,0.00939999f,-0.19640001f,-0.12930000f,-0.23860001f,-0.58760001f,-0.96420000f,-0.42080000f,-0.47540001f,-0.52340001f,0.05810001f,0.29260001f,-0.06100000f,-0.16490001f,-0.14740001f,-0.85500002f,-0.36410001f,-0.24879999f,-0.16099999f,-0.08479999f,0.36999999f,0.52109998f,0.12539999f,0.09139999f,0.96770000f,0.40129999f,-0.23359999f,-0.71049999f,-0.55539999f,0.25640001f,0.17809999f,1.03139998f,0.18419999f,1.05679998f,0.64070002f,-0.24660000f,0.55670003f,0.35620001f,-0.84419996f,0.20600003f,0.03230001f,-0.56319998f,-0.16909998f,0.91809999f,-0.18259998f,0.65689999f,0.54570002f,0.04540001f,0.47970002f,0.29420000f,-0.06360000f,0.43260002f,-0.02120003f,-0.63659998f,0.11260001f,-0.35239998f,0.67179998f,-0.31660001f,-0.42719999f,0.49819999f,-0.22019999f,0.34419999f,-0.22039999f,0.32980000f,-0.08870000f,0.24379999f,-0.18510001f,0.63690002f,-0.66439998f,0.38270003f,0.25369999f,0.56779997f,0.31969998f,-0.78490002f,0.25850000f,-0.13380000f,0.12820000f,-0.36570002f,0.16420000f,0.39540000f,0.10850000f,-0.02160001f,0.12149999f,-0.05740001f,0.34860000f,1.00990001f,0.49530000f,0.06040000f,0.60770000f,0.48740000f,0.63860000f,0.78479997f,0.32749999f,-0.52119999f,-0.59639998f,-0.62879999f,0.60279999f,0.89279999f,0.78320000f,-0.22060000f,-0.33589999f,-0.22370000f,0.00980000f,0.49700000f,0.55230002f,0.00460000f,-0.42730000f,0.33130002f,0.62420001f,0.85840000f,0.28009999f,0.46779999f,0.68529999f,0.67990001f,-0.37319999f,-1.00839998f,-0.41439999f,-0.28000000f,0.09980000f,1.02400004f,0.22460001f,0.82300002f,0.12120001f,-0.00860000f,0.02700000f,0.31370001f,0.00380000f,0.23970001f,0.08470001f,-0.40719999f,-0.10069999f,0.01429998f,-0.71259996f,-0.06850000f,-0.50420002f,0.31380000f,-0.58680003f,1.06159999f,0.19119999f,0.99359998f,-1.01400000f,-0.35360001f,-1.00199999f,0.25570000f,0.05200000f,0.27550000f,-0.16520003f,-0.83859998f,-0.19180000f,-1.18370004f,-0.28640000f,-0.89710002f,-0.29140000f,0.33019999f,-0.42320002f,-0.91470001f,-0.36400000f,-0.87890000f,-0.16880000f,0.26639999f,0.03680000f,0.44230001f,-0.07220000f,-0.33120000f,-0.52620000f,-0.63640002f,0.06539999f,0.58049998f,0.32350000f,-0.27780000f,-0.18139999f,0.09070001f,0.61819999f,0.95489995f,0.59029997f,-0.04499999f,-0.87359999f,-0.52990000f,-0.22000000f,-0.22609999f,-0.47860000f,-0.48020000f,-0.45659999f,-0.55330000f,-0.27920000f,-0.24049998f,0.26940003f,0.40259998f,0.83599996f,0.50409998f,-0.23720002f,0.10499998f,0.26039999f,0.21220000f,0.07890000f,0.23650000f,-0.21820001f,0.13899999f,-0.47050002f,0.21000000f,-0.03020000f,-0.02820000f,0.00480000f,0.29880000f,0.36860002f,0.91239999f,-0.45860002f,0.83660003f,0.46760000f,0.77820001f,0.22929999f,-0.48799998f,0.10590001f,0.08239999f,-0.48179999f,0.12700001f,-0.63710000f,-0.10319997f,-0.71010000f,-0.37179999f,0.87019998f,-0.18840002f,0.83090000f,0.34459998f,0.72249999f,1.07520001f,0.11500000f,0.98220000f,-0.29230002f,-0.69380000f,-0.16549998f,-0.28740000f,-0.28419998f,-0.38560000f,0.16420002f,-0.72279997f,0.15300005f,-0.64630001f,-0.00360000f,-0.55650001f,1.36160005f,0.22700000f,1.10380003f,-0.37819999f,0.36319998f,-0.32900000f,-0.15640003f,-0.55239999f,-0.16080001f,-0.96979998f,0.80699999f,0.25500000f,0.39759999f,0.36790001f,-0.14400001f,0.39419998f,0.28399999f,0.03060000f,0.42449999f,0.49670000f,-0.31419999f,-0.54849998f,-0.30889999f,-0.00819998f,-0.55239998f,0.14270001f,0.23680000f,0.26700000f,0.18140000f,0.41200000f,0.40880001f,0.17600000f,0.38760000f,0.13890000f,-0.00000001f,0.18100000f,0.30470001f,0.13470000f,0.02340001f,-0.31490000f,-0.24210000f,0.04460000f,0.67860000f,0.48010002f,0.34880000f,0.11680000f,-0.07780001f,0.68620001f,0.85580000f,0.32650000f,-0.34880002f,-0.05190001f,0.12320000f,-0.31720001f,-1.05589998f,-0.45820001f,-0.20220000f,-0.44960001f,0.39139999f,-0.69879996f,0.28740001f,-0.22150002f,-0.71439997f,-0.23129999f,0.24349999f,0.08279999f,0.30409999f,-1.04340003f,-0.02779999f,-0.76840002f,-0.31980000f,0.04719999f,-0.32100000f,-0.41439998f,0.27679998f,-0.43840000f,-0.49049997f,0.54539998f,-0.46410000f,-0.08729999f,0.01080000f,-0.13150000f,-0.12290000f,0.43879999f,-0.06470001f,0.16079996f,-0.74859999f,0.04259998f,-0.32799998f,0.59239997f,-0.32600001f,-0.48200001f,0.36580000f,-0.58420004f,0.35190002f,-0.66979999f,0.33750004f,-0.49570002f,-0.35970002f,-0.27560002f,-0.03290000f,-0.15120000f,-0.17880000f,-0.27250000f,0.27800000f,-0.25440001f,-0.02490000f,0.08340001f,0.35940001f,0.33420001f,0.58050001f,-0.28660000f,-0.92030000f,-0.26569999f,0.33219999f,0.82419997f,0.28409999f,0.65920000f,1.04179997f,0.42699999f,-0.54660000f,-1.04980000f,-0.69290000f,0.30260002f,0.10490002f,-0.25550000f,0.44840000f,1.07820000f,0.77520002f,-0.13500000f,-0.56279999f,-0.09070000f,0.17200000f,-0.20549999f,0.01720000f,-0.22600000f,-0.08170000f,-0.49100001f,-0.31000000f,-0.66339999f,-0.37279999f,-0.25860001f,0.01779999f,0.69170003f,-0.21500000f,0.59650003f,-0.53510001f,-0.54299998f,-0.37029998f,0.28650001f,-0.48420001f,0.26850002f,-1.08480004f,-0.29579999f,-0.95820002f,-0.43310002f,0.18160000f,-0.19730001f,0.17720000f,-0.10700000f,-0.00260000f,-0.31700001f,0.14080000f,-0.47020002f,0.53160000f,0.37099999f,0.62660000f,0.02450000f,0.75239997f,-0.03610003f,-0.44500003f,-0.63320000f,-0.54660001f,-0.45340000f,0.08060000f,-0.27720000f,-0.64569999f,0.30059998f,-0.51690000f,1.07810002f,0.30780001f,0.90410001f,0.16700000f,0.20519999f,0.25580000f,1.20360001f,0.66130000f,0.28239999f,0.18629999f,0.07999999f,0.47000001f,0.35900000f,0.12960000f,0.30820000f,-0.03650000f,0.36790002f,0.06899998f,0.77259999f,0.47369999f,-0.08440000f,-0.45890000f,-0.30280000f,0.24120000f,0.28720000f,0.04999999f,-0.04880000f,-0.15549999f,-0.19000000f,-0.81700001f,-1.21399999f,-0.81550001f,-0.08979999f,0.27000000f,0.18930001f,0.17980000f,0.33799999f,0.22790000f,0.04800000f,0.04220000f,0.18900001f,-0.47839999f,-0.35799999f,-0.42299999f,0.31040001f,0.44340000f,0.04920000f,-0.44440001f,-0.28639999f,0.02840001f,0.39420001f,-0.78580000f,-0.35909998f,0.26979998f,-0.34949999f,-0.51860000f,0.43879999f,-0.52420002f,-1.20450002f,0.00919997f,-1.00310001f,0.26800002f,-0.73179997f,0.11380004f,-0.04630000f,0.39619998f,0.02889999f,-0.08519999f,0.21520000f,-0.13640001f,0.16190000f,0.21499999f,0.15469999f,0.97100003f,0.16699999f,1.03600003f,0.26059997f,-0.45859998f,0.18959999f,-0.18580000f,-0.11980000f,-0.21400000f,-0.32860001f,-0.18080000f,-0.27460000f,1.00919999f,-0.07800000f,0.91760000f,0.02540000f,0.27399999f,-0.07620002f,0.32600001f,-0.62320000f,0.35800003f,-0.49440002f,-0.15909999f,0.26580000f,0.51119999f,-0.13430002f,-0.07500001f,0.41539997f,-0.10030001f,-0.11740000f,0.24560002f,-0.27349999f,-0.49359999f,-0.98189998f,-0.42899999f,-0.30280000f,-0.26390001f,0.25880002f,0.70680000f,1.27160000f,0.69140000f,-0.28260000f,-0.92770001f,-0.44850000f,0.11240000f,-0.32770002f,0.33720000f,-0.21740000f,-0.27900000f,-0.18830000f,-0.42180001f,-0.26700001f,-0.49510001f,0.16379999f,0.76910000f,0.58710001f,0.06900000f,0.71969999f,0.23490000f,0.44919999f,0.30159999f,0.54540000f,0.03280001f,-0.47740000f,-0.27820000f,-0.09240000f,0.14800001f,0.75069999f,-1.56820000f,0.47080001f,-0.47589999f,0.16939999f,-0.23380000f,-0.04430005f,-0.14999998f,-0.03110001f,0.05810005f,0.67219996f,-0.01719998f,0.61800000f,-0.33540002f,0.31590001f,0.55760004f,-0.36480002f,0.30120002f,-0.44130001f,0.90700001f,-0.28520001f,1.00210000f,-0.36979999f,0.51700000f,-0.98550000f,0.93680000f,-0.53730001f,-0.04649999f,-0.33280000f,0.00970000f,0.13500001f,0.39000000f,0.03480000f,0.07130000f,-0.24120000f,0.05610000f,1.07710004f,-0.81100002f,0.58460003f,0.63070004f,0.17699998f,0.30540001f,0.22169995f,-0.19100000f,0.68620001f,0.24290000f,0.60380002f,0.77120002f,0.11290001f,0.28550003f,-0.81480001f,-0.25290000f,-0.65090002f,-0.56180001f,0.00050000f,0.19100000f,-0.12040000f,0.08710000f,0.10230000f,0.34700003f,0.18070001f,-0.09879996f,0.77639999f,0.13830000f,-0.04330000f,-0.82240002f,-0.26960001f,-1.09640003f,-0.51880000f,-0.11420000f,-0.24920001f,-1.15340000f,-0.27670000f,-0.88440002f,0.62200000f,0.14060000f,0.49640001f,0.08860000f,-0.09280000f,-0.39969998f,0.33860000f,0.21490000f,0.72360000f,0.47620000f,0.14390000f,0.57300000f,-0.14040000f,-0.21660000f,0.68780001f,-0.77939999f,0.39330001f,1.12530001f,-1.35940002f,0.63140002f,-0.87970000f,1.04319999f,-0.50230001f,-1.14220001f,1.14340000f,-0.62010002f,-0.32709999f,0.58300000f,-0.18740001f,0.61200004f,0.05059997f,0.30410002f,1.35910000f,-1.10079997f,0.73090001f,-0.56660001f,1.20940000f,-0.36150001f,-0.69920000f,0.78079999f,-0.39120001f,-1.30759999f,1.80259998f,-0.75550001f,0.69499999f,-1.01820000f,0.40470001f,0.48589998f,-0.39020000f,0.25260000f,-0.00760000f,-0.19260000f,0.02050000f,0.37780000f,-0.72140000f,0.23390001f,-0.02960002f,0.20820001f,0.95740000f,0.18560000f,0.00270000f,0.59620002f,0.23600000f,0.04930001f,-0.91780004f,-0.13580001f,-0.19870003f,0.40819999f,0.19300000f,-0.04890000f,0.98480001f,0.20410001f,0.61830003f,-0.98840001f,-0.33790000f,-1.22110004f,0.32700000f,0.14970000f,0.13540000f,-1.13620001f,-0.32630001f,-1.35060005f,-0.70999999f,-0.39729999f,-1.02770000f,0.02920002f,0.08000000f,0.07700001f,-0.30999999f,0.04360000f,-0.09180000f,0.82559999f,0.22350000f,0.79330001f,0.80939999f,0.21600000f,0.27590001f,-0.85540000f,-0.29180000f,-0.46270001f,-0.71800001f,0.31120000f,1.62910000f,-1.32139997f,0.87740001f,0.92730005f,-0.33660001f,0.48280002f,-1.43970004f,1.54200003f,-0.79570004f,0.68030001f,-0.05659998f,0.34420000f,1.22869999f,-1.60759998f,0.70150001f,-0.74409999f,1.34699998f,-0.45960000f,0.42200001f,-0.15239999f,0.22220000f,-0.92079998f,1.78519997f,-0.57020000f,-0.35850001f,0.38759997f,-0.22009999f,-0.03819997f,0.23639997f,-0.02759999f,-0.50799997f,0.91179998f,-0.29690000f,0.80989998f,-1.26179996f,0.47960000f,1.15509999f,-1.00219997f,0.63100000f,-1.07010000f,0.87479998f,-0.58690000f,-0.36299998f,0.39399998f,0.63520000f,0.36739999f,0.90780000f,-0.90400003f,-0.32390001f,-0.79250004f,-0.28280001f,-0.08560000f,-0.40460002f,0.68220001f,0.18930000f,0.72860003f,-0.17400000f,-0.05070000f,-0.49030001f,-0.30320000f,-0.03820000f,0.02260000f,0.02600000f,-0.08120000f,-0.33860001f,0.19180001f,0.12020000f,-0.23510001f,-0.09839999f,0.13830000f,0.64610001f,-0.03980001f,-0.09790000f,0.33360000f,-0.47020001f,-0.33080001f,-0.71310003f,-0.48760000f,-0.07640000f,-0.61420002f,0.01059999f,-0.12580000f,-0.06210000f,0.34060001f,0.22250000f,0.81460001f,0.76760002f,-0.24170001f,0.32380002f,-0.29040000f,0.19580000f,-0.90650003f,1.00880001f,-0.51750002f,-0.17819999f,0.45959999f,-0.11840000f,0.61479999f,-1.05919999f,0.37120000f,0.06250002f,0.41039999f,0.00310001f,-0.54179999f,0.49400000f,-0.29360000f,0.32500000f,-0.23360000f,0.16620001f,0.45870003f,0.20320000f,0.21730001f,-0.70009998f,0.48259998f,-0.35900001f,-0.26720004f,-0.49179998f,-0.10630001f,-0.18430002f,-0.01380000f,-0.10820000f,-0.39839998f,1.05260000f,-0.25930001f,0.11889997f,-0.52519998f,0.08090000f,-0.07259998f,-0.20980001f,-0.00949999f,1.39890002f,-0.26390001f,0.18480000f,-0.07680000f,-0.24239999f,0.12140000f,0.09820000f,0.12810001f,-0.02800001f,-0.11030000f,0.36830000f,-0.09739999f,-0.04570000f,-0.60060001f,0.70940001f,0.16900000f,-0.08429999f,-0.12659999f,0.07650000f,0.30860001f,-0.40860001f,0.01320000f,0.00849998f,0.51140004f,0.33850001f,0.69080003f,0.67720001f,0.38000000f,0.91420002f,-0.23880003f,-0.10080001f,0.38139999f,0.18140000f,0.25780000f,0.87450002f,0.47460001f,0.05220001f,-0.13089997f,-0.17600000f,0.02600000f,-0.24040000f,-0.14120000f,0.05660000f,0.38400002f,-0.19559998f,-0.22020000f,0.53819998f,-0.61179999f,0.29190000f,0.08210001f,0.08540001f,0.04060000f,-0.26550003f,-0.58739998f,-0.10060000f,0.27640002f,0.31759998f,0.11240001f,1.25510002f,-0.80320000f,0.66490002f,-0.48139998f,0.44979997f,-0.25490000f,-0.74290000f,0.95040001f,-0.41470002f,0.27060006f,-0.03320005f,0.15320002f,0.38880003f,-0.33260001f,0.23050000f,-0.65620006f,-0.08999997f,-0.31840003f,-0.41590000f,0.26020001f,-0.20120001f,0.91989999f,-0.75819999f,0.49300001f,-0.15399999f,0.61599999f,-0.10920000f,-0.55280002f,0.36040001f,-0.28540002f,-0.31990000f,0.91710005f,0.74440002f,0.43250000f,1.31290004f,0.34680000f,0.24390000f,0.76070000f,-0.88460000f,-0.30250000f,-0.58020001f,-0.33800000f,-0.02170000f,-0.10690001f,0.05180000f,0.16750000f,0.21160000f,0.84579999f,0.34970000f,0.91640002f,0.11700001f,0.12930000f,0.02560001f,-0.51340001f,-0.17060000f,0.16710000f,-0.08860001f,-0.24020000f,-0.73490003f,0.60900004f,0.31080001f,0.96690004f,0.20640004f,0.17760001f,-0.12079996f,0.70900000f,0.25820000f,0.26110000f,-0.28259998f,0.08850000f,0.21740001f,-0.31680002f,-0.10770001f,0.06889997f,0.67820003f,0.53070002f,0.20010002f,-0.45520001f,0.14950000f,-0.03229999f,-0.10620000f,0.00520000f,-1.03340001f,0.95179998f,-0.57430001f,-0.51849999f,0.70439999f,-0.29370001f,-0.13279998f,0.49060000f,-0.08310001f,0.70219999f,-0.83279998f,0.40979999f,0.13400003f,0.27739999f,0.05630001f,-0.96310003f,0.32440001f,-0.49550001f,0.47409998f,-0.45879997f,0.24210001f,0.25950004f,-0.50160003f,0.17370002f,0.37760006f,0.35759995f,0.17240002f,0.96750002f,-0.59539999f,0.51880001f,-0.70039997f,0.88879996f,-0.38600000f,-0.56870002f,0.20680001f,-0.29390001f,0.29080004f,-0.52150001f,0.63120000f,0.20490000f,0.00510002f,-0.07659999f,0.03190000f,-0.38739999f,-0.20620001f,-0.11540000f,-0.66650003f,-0.10800000f,-0.13410000f,0.00330001f,-0.47199999f,-0.14539999f,0.08460002f,-0.62580003f,-0.18990001f,-0.27860003f,0.13660001f,0.05450001f,-0.23859998f,0.44939999f,0.14820000f,0.88530002f,-0.61799999f,-0.12239999f,0.06740000f,-0.23160001f,-0.06360000f,0.37259998f,1.01099999f,0.37049999f,1.09020001f,0.20160000f,0.11100000f,-0.13900000f,-0.38960000f,-0.09160000f,-0.26680001f,0.12019999f,0.04780000f,0.41109998f,-0.29159999f,0.03010001f,1.03530000f,-0.52339999f,0.54420000f,0.12660002f,0.49499997f,0.03410000f,0.15970001f,0.29440000f,0.05310001f,-0.13650002f,-0.33180000f,-0.05460000f,-0.84100002f,0.38079999f,-0.43820001f,-0.83620002f,0.71020001f,-0.45790002f,0.39140001f,0.04819999f,0.18990000f,0.10409997f,-0.79859997f,0.10619999f,-1.09999999f,0.80779998f,-0.58730000f,-0.65340001f,0.05600002f,-0.32340001f,0.86399999f,-1.19399996f,0.51060000f,0.41140002f,0.09520000f,0.20020000f,-0.46540000f,0.60099999f,-0.26610000f,-0.10070000f,-0.26519998f,-0.03030000f,-0.94439997f,0.22209997f,0.54040000f,0.01610000f,-0.19030000f,-0.97800003f,-0.29700000f,-1.00000004f,-0.67960004f,-0.33620001f,-1.19320006f,0.46800001f,0.17250001f,0.83950003f,0.74260000f,0.15470000f,-0.01260000f,-0.27279999f,-0.32179999f,-0.93340001f,0.55740002f,0.32100000f,0.91890003f,-0.05440001f,-0.04460000f,0.25380001f,0.17520004f,0.18360001f,0.01360002f,-0.72020003f,-0.28960001f,-0.81690003f,0.00700000f,0.08000000f,0.39309998f,0.69920002f,0.25480000f,1.00560001f,0.00439999f,0.18280000f,0.74459999f,0.70160002f,0.09640001f,-0.16279997f,0.32239999f,-0.40050001f,1.09609999f,-1.02639997f,0.59190001f,-0.90200002f,1.38800002f,-0.53600002f,-0.21240003f,0.66120003f,-0.16180001f,0.15949999f,-0.71400000f,0.12950000f,1.26940000f,-0.97219999f,0.68090001f,0.32280000f,-0.30100001f,0.15470002f,0.19710003f,-0.32120002f,0.13350001f,-0.25960003f,-0.19459999f,-0.11690001f,0.22280006f,0.38519996f,0.09620002f,-0.57530003f,0.76180001f,-0.34060002f,-0.30449999f,0.12900000f,-0.15020000f,0.41780003f,-0.95620001f,0.27370002f,-0.60639999f,0.39620002f,-0.30590001f,1.32940002f,-1.05460001f,0.71130003f,0.81659999f,0.85130002f,-0.20200001f,-0.09320000f,-0.35340002f,0.92100001f,0.17130000f,0.19840001f,-0.70880000f,-0.40660000f,-0.96500002f,-0.83220001f,-0.18900001f,-0.35470002f,-0.51600000f,-0.01740001f,0.21139998f,0.64260001f,0.45450000f,1.29600003f,0.28940004f,0.14830001f,-0.18999996f,0.10780000f,0.04460000f,0.05930000f,-0.13599999f,0.04570000f,-0.28730001f,-0.36139999f,-0.28930000f,-0.87540000f,0.62740005f,0.31970001f,0.33200005f,0.25160000f,-0.03140000f,0.16120001f,-0.55680002f,-0.23190001f,-0.41330002f,0.28079999f,0.01800000f,0.31560001f,0.35000000f,0.23350000f,-0.06700000f,0.22440001f,-0.05120000f,1.43000001f,-1.39859999f,0.78470002f,-0.39720001f,0.31459998f,-0.23509999f,-1.15130001f,1.20559999f,-0.63950002f,-1.06699999f,0.95679998f,-0.57380001f,0.02040001f,-0.12979999f,0.04469999f,0.58860006f,0.08519995f,0.28880003f,0.13070000f,-0.07760000f,0.07050000f,-0.05749996f,0.63459996f,-0.06239999f,0.10840001f,0.00279997f,0.03500002f,0.74360007f,-0.19060005f,0.39030003f,0.34839998f,-0.76599999f,0.21180000f,-0.59770003f,0.44720001f,-0.32950001f,0.26819997f,-0.69739997f,0.17189999f,-0.10749999f,0.40320002f,-0.87619999f,-0.24310000f,-1.10020001f,-0.01520000f,-0.03970000f,-0.47070002f,0.56559999f,0.02090000f,-0.29329999f,1.03240001f,0.25340001f,0.52000003f,0.67340000f,0.24850000f,0.14180002f,-0.06020000f,0.01130000f,-0.23420001f,-0.90060003f,-0.34440001f,-1.04150005f,-0.60940004f,-0.38870001f,-1.11240004f,0.02000001f,0.15850000f,0.71630001f,-0.77440004f,-0.18830001f,-0.16930005f,-0.15600000f,-0.09900000f,-0.46939999f,0.52940000f,0.25690000f,0.75100001f,0.87500003f,0.19420001f,0.04650003f,-0.55560001f,-0.05970001f,-0.16570002f,-0.01340000f,0.06770001f,-0.67179997f,1.44179994f,-0.42449999f,0.32770002f,0.09800000f,0.15050001f,1.21289998f,-1.01059996f,0.64780001f,1.36260000f,-1.45499998f,0.76030001f,0.99360000f,-0.49919998f,0.52520000f,0.05520001f,0.29600000f,0.01000000f,-0.71290002f,1.03760001f,-0.42670001f,-0.12160005f,0.24460003f,-0.09650001f,-0.54749999f,0.27300000f,-0.27160001f,-1.18110003f,0.98980003f,-0.64120003f,0.10100000f,0.15599999f,0.03380000f,0.29560000f,-0.44799999f,0.18480000f,1.44650003f,-1.12540000f,0.77800003f,-0.84889999f,1.05119998f,-0.47630001f,-0.24760002f,0.31830003f,0.26440002f,0.19850001f,0.04250002f,0.38800001f,0.14990000f,0.32170002f,0.14840000f,0.07030000f,0.02430000f,0.90280003f,0.24500001f,0.50360004f,0.46020001f,-0.00089999f,-0.15219997f,0.75060000f,0.34050000f,1.18640003f,-0.42859999f,-0.07060000f,-0.67210000f,0.68860000f,0.13100000f,0.77050000f,-0.28560000f,-0.08460000f,-0.33380000f,0.31500000f,-0.09450000f,-0.32760000f,-0.57640003f,-0.33860001f,-0.33400002f,0.84520002f,0.38930001f,1.20850004f,0.49900000f,0.06080000f,0.53910001f,-0.93380001f,-0.29500000f,-0.61790003f,-0.21060000f,0.45820002f,0.35510004f,0.23779999f,0.16980001f,0.39750002f,-0.37780001f,0.22360001f,0.21710001f,-0.04080000f,0.11170000f,1.14620003f,-1.19740001f,0.63990003f,0.93279998f,-0.94079999f,0.50680001f,0.34239998f,-0.79579998f,0.23289999f,-0.25389998f,0.97599996f,-0.18450000f,0.62189999f,-1.34079999f,0.38770001f,-0.23439999f,0.43499999f,-0.14410000f,0.83999999f,-0.93100000f,0.45570001f,-0.64260005f,-0.00059999f,-0.33130001f,0.47430002f,-0.80820000f,0.30040001f,0.47949998f,-1.10659999f,0.30080001f,-1.09770001f,1.11039999f,-0.61430001f,-0.00639999f,0.50970001f,-0.33760000f,0.02260000f,-0.26580000f,0.49419999f,0.07640000f,-0.01649999f,-0.24640000f,-0.20870000f,-0.67210001f,0.82859998f,0.26160000f,0.96710002f,-0.72340000f,-0.07490000f,0.16800000f,-0.07279999f,0.09230000f,-0.10910000f,-0.30679999f,-0.04270000f,-0.62270000f,-0.37680000f,-0.32610000f,-0.82830003f,0.71999998f,0.19049999f,0.57430000f,-0.00580002f,-0.17360000f,-0.67130003f,0.00899999f,-0.02460000f,0.25870000f,0.30940001f,0.23030000f,-0.04400000f,-0.00560000f,0.07160000f,0.44480000f,0.17540000f,-0.07640000f,-0.22829999f,1.21940000f,-0.30970001f,-0.42339998f,0.96960000f,-0.26060001f,0.86229998f,-0.75539998f,0.46640000f,0.13290000f,-0.00940001f,0.05240001f,0.67389995f,-1.19299994f,0.41199998f,-1.38160000f,1.19099999f,-0.74330002f,-0.09269997f,0.60479997f,-0.07489999f,-0.08369998f,0.80179998f,-0.09020000f,0.06330000f,-0.14240002f,0.01950002f,0.79249996f,-1.06099995f,0.45739999f,0.54729998f,-0.39039996f,0.27750000f,-0.15850002f,-0.25179999f,-0.06340000f,0.48360004f,0.31620000f,0.22930001f,-0.36039999f,0.09560000f,-0.17580000f,0.51109999f,-0.59640000f,0.27790001f,1.00509998f,1.03960003f,0.29840000f,0.04390000f,0.30050000f,0.29719999f,-0.04340000f,-0.44639999f,0.26119999f,-0.08660000f,-0.25439999f,-0.48440000f,-0.15280000f,-0.49620001f,-0.63760001f,-0.29210000f,-0.23310000f,0.23020000f,0.08540000f,0.38770000f,0.39480002f,0.20040000f,0.77540002f,0.17520001f,0.18030000f,0.81570000f,0.28360001f,0.10640000f,0.31820001f,-0.23840000f,0.01280000f,0.18200000f,0.53660001f,0.02530000f,-0.16539998f,0.17860000f,0.20000000f,0.79450000f,0.82940002f,0.38410001f,1.29740006f,-0.12740002f,-0.19870000f,-0.81860004f,-0.73700004f,0.43740001f,0.29909999f,-0.61899999f,0.18380000f,0.87079997f,-0.61679997f,0.45520000f,0.68779997f,-0.81539998f,0.37570000f,-0.44359999f,0.66379998f,-0.26290000f,-0.84490004f,0.28100000f,-0.44300001f,0.09630000f,-0.33640000f,0.07150000f,0.06220002f,-0.40320001f,0.06580001f,-0.35069998f,-0.02520000f,-0.15750000f,0.23240001f,-0.33060001f,0.13830001f,-0.56260000f,0.48860000f,-0.30030001f,1.06739999f,-0.99140001f,0.57650001f,-0.33809999f,0.06120000f,-0.15530000f,0.38460000f,-0.83940000f,0.25850000f,0.44639999f,-0.15639998f,0.21340001f,-0.56900006f,0.93840002f,0.00240000f,-0.02310000f,-0.44730002f,-0.40640001f,-0.31030000f,-0.63650001f,-0.07680000f,-0.13650000f,-0.58950003f,0.15840000f,-0.05850000f,0.33210002f,-0.89100002f,-0.31080001f,-0.54350003f,0.78600000f,0.27870000f,0.60390001f,0.98540000f,0.39460000f,1.19690003f,-0.88440002f,-0.22110001f,-0.75710004f,0.23020003f,0.27380000f,0.83970003f,0.87580002f,0.15680000f,0.49670003f,-0.56920001f,-0.21470000f,-0.30750002f,-0.21060000f,-0.03270000f,0.29859999f,0.08380002f,0.15290001f,-0.08459998f,-0.58100000f,-0.16240000f,-0.45810002f,0.13859999f,-0.21270001f,0.33510002f,0.11800000f,0.15390001f,-0.13410003f,-0.10519998f,-0.07730000f,0.34530001f,-0.11760001f,0.16590002f,0.07109997f,-0.76019999f,0.07560000f,-1.06750003f,0.91260001f,-0.58900002f,0.85050000f,-0.84739998f,0.47820000f,0.73109998f,-1.08839997f,0.44149999f,-0.94210001f,1.38340000f,-0.55060002f,-0.31069996f,0.23779996f,-0.14799999f,1.14170000f,-1.50800001f,0.65070002f,-0.70330002f,0.49500000f,-0.38240001f,-0.57640000f,0.17720000f,-0.29140000f,0.14320003f,0.50479999f,0.04880000f,-0.63949999f,0.81679999f,-0.36730000f,0.28640003f,1.27650003f,0.18700000f,0.12230000f,0.54639999f,0.36420001f,0.22440000f,0.92130003f,-0.15560001f,-0.10720001f,0.32819997f,0.64000001f,0.07310001f,-0.09309999f,-0.37520001f,-0.04630001f,-0.01610002f,0.30180001f,0.16380000f,0.50510002f,-0.09540000f,0.02370000f,0.02300000f,-1.03100001f,-0.30850000f,-1.24100005f,0.20620000f,-0.02410000f,-0.28359998f,0.28320000f,0.06990000f,0.24770000f,-0.02380000f,-0.06740000f,-0.04490000f,-0.25219999f,-0.07240000f,-0.70450000f,0.47200002f,0.24740000f,0.67580003f,-0.34580000f,-0.27100000f,-0.98150003f,0.54420001f,0.51200003f,-0.11099999f,-0.16359999f,-0.03680000f,-0.10769999f,-0.30640001f,-0.02070000f,-0.46640002f,-0.27380000f,-0.21610000f,1.17950000f,-1.05219997f,0.63720001f,-0.63930000f,0.63720000f,-0.34970001f,0.10570001f,-0.22000000f,0.07390000f,-0.19759999f,0.29879999f,-0.11180000f,-0.81899998f,1.57499999f,-0.50750000f,0.58279999f,-0.41540000f,0.30510000f,0.29829999f,-0.44939999f,0.17500000f,0.01929999f,-0.21080000f,0.01770000f,0.08570002f,0.59639998f,0.00210001f,0.25100002f,-0.32480002f,0.15540001f,0.20430001f,0.09839999f,0.07690002f,0.52480000f,-0.01689998f,0.61000002f,0.35570001f,0.74370002f,0.47079999f,0.18950000f,0.00430001f,0.35440004f,0.20090001f,0.02430001f,-0.90920001f,-0.31630000f,-0.84670002f,-0.39920003f,-0.33730001f,-0.87230003f,1.13080003f,0.36020001f,1.12600005f,-0.82900003f,-0.21620001f,-0.39110004f,-0.46560004f,-0.26790001f,-0.10050001f,-0.23880000f,-0.08010000f,-0.34490001f,-0.12460000f,0.01930000f,-0.51480001f,0.60020000f,0.04300000f,0.00910000f,0.67500001f,0.17820000f,0.08730002f,0.14399999f,-0.02340000f,0.53699999f,-0.39540001f,-0.02820000f,0.19970000f,-0.65920001f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_3d_2item_large_5o3i_uneven_filter_uneven_data_dilation_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,3,8,8,8};
    Shape shape_b{5,3,2,3,4};
    Shape shape_r{2,5,14,20,12};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1,1},        // move_strides
                                                                  Strides{1,1,1},        // filter_dilation
                                                                  CoordinateDiff{0,0,0}, // below_pads
                                                                  CoordinateDiff{0,0,0}, // above_pads
                                                                  Strides{2,3,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.02300000f,1.00359999f,0.21590000f,0.26630000f,0.98889999f,-0.39219998f,-0.13799998f,0.24879996f,-0.50489997f,0.07589997f,-0.36589998f,-1.05610000f,0.83070001f,0.14200003f,0.36189997f,-0.37670001f,1.19360001f,0.59930002f,-0.22929999f,0.33000000f,-1.67980001f,-0.02210000f,-0.50500003f,-0.34950002f,0.02260004f,1.70340006f,2.00550005f,0.33880001f,0.05780004f,1.20100001f,-0.02900002f,0.31700002f,0.85780002f,0.51900000f,0.09569992f,-1.66130004f,0.46290000f,-0.69149999f,-1.03750004f,-0.29430000f,0.38379998f,0.38689999f,0.22260003f,-0.93990000f,-1.38650000f,1.11330002f,-0.92339999f,-0.98600000f,0.18069997f,-0.48400003f,-0.36119998f,0.02520002f,0.20600002f,0.07790000f,0.05570000f,-0.29950001f,-0.63009999f,-0.04880000f,1.56330004f,0.04559999f,1.08109998f,-0.90040001f,-0.27699997f,0.64400004f,1.55730002f,0.80780001f,0.77500000f,0.19060001f,0.91149999f,0.23280001f,0.90390006f,1.04779998f,-0.38430003f,-0.79639999f,-0.34260001f,-0.79449997f,-0.81549997f,-0.21089999f,-0.59639999f,-0.01240002f,-1.57249999f,-0.65129999f,0.73289999f,0.51239996f,-0.71220000f,-0.13390001f,-0.37870002f,0.08689999f,-0.43840000f,0.34520002f,-0.80380002f,-0.44070001f,1.59700000f,-1.00510002f,1.95830005f,-0.57790004f,0.13909995f,-0.37250001f,-0.05599999f,-0.60000002f,-1.35200006f,0.01599998f,0.66529998f,0.29039999f,0.97710006f,-0.26079999f,-0.49699999f,-0.58570006f,-0.09369996f,-0.29740001f,-0.25690002f,0.93370001f,0.50680002f,-0.36300000f,-0.48499998f,-0.80579998f,0.25289995f,0.33660002f,0.60310001f,-0.66919998f,0.30339998f,-0.51500001f,0.38289998f,-0.27580000f,0.83770003f,0.25030000f,0.90210001f,-0.02839999f,0.87169997f,-0.62880001f,0.43159997f,-0.50230001f,0.15900001f,-0.61830000f,-0.41380004f,-1.15140002f,-1.15180001f,0.21720000f,0.16630005f,1.06070001f,-0.28640000f,-0.72429998f,-0.13789993f,-0.44589998f,0.24090001f,0.61280002f,-0.10440000f,0.54439999f,1.26200003f,-0.61610002f,1.12259998f,0.38519999f,0.56639996f,-0.73049999f,0.01649993f,0.42410001f,0.78330002f,0.03099999f,-0.10729999f,-0.51380000f,-0.75460002f,-0.17239999f,0.59099995f,-0.56290001f,1.61940001f,-0.10480001f,1.05150002f,-0.60820002f,-1.89039998f,-0.64829999f,0.17970002f,-0.55859998f,0.32009998f,-0.16290000f,0.17219997f,-1.32720000f,-1.58719998f,-0.53830001f,-0.37089994f,-0.86599997f,1.62319999f,-0.81989998f,0.22069999f,-0.16739997f,-1.42219998f,0.78270000f,0.01149998f,0.66099999f,1.85569999f,-0.72080001f,1.33619997f,0.35200001f,0.18550000f,0.17050000f,0.08170002f,-0.31029999f,-1.59650000f,0.25620001f,0.45320001f,0.22540001f,0.57070001f,-0.28670000f,0.12190001f,0.06819997f,0.23130001f,0.38259998f,0.82890004f,0.17840005f,0.72609994f,-0.05260003f,0.64569999f,0.67320000f,0.04600001f,-0.04599996f,-0.58899999f,-0.96020001f,-0.14940001f,-0.87650000f,-0.20579999f,0.31290005f,-2.40919996f,0.00569998f,0.29030003f,0.10509999f,0.55069999f,0.51099998f,0.04969999f,0.21969998f,0.17860001f,0.35870001f,0.25180001f,0.53100000f,-0.73400000f,-0.13549999f,-1.10110001f,-0.17879999f,0.70009998f,-0.17530000f,-0.16710000f,0.18610000f,0.19579998f,1.84889995f,0.74859999f,1.22569999f,0.25180002f,0.84330001f,0.04300000f,0.75809999f,0.93800000f,-0.28610002f,0.54299998f,-0.57120003f,1.15290000f,1.73650003f,0.36539997f,-0.80460002f,-0.63130002f,0.45679999f,1.30799997f,1.51590003f,0.08359998f,-0.25389999f,-1.72840002f,-0.27550000f,-0.00030005f,0.03540003f,-0.50759999f,-0.69660000f,-0.96850000f,-1.12400001f,0.83080002f,0.33190002f,-0.04780001f,0.32219999f,-0.57300001f,0.03570000f,0.17159998f,0.21389997f,0.21770000f,0.05580002f,-0.16010002f,1.50749998f,0.70629999f,0.15459997f,-0.32020001f,-0.45219998f,-0.83340001f,-0.88100001f,-1.17050003f,-0.25140001f,0.26110002f,-0.01249999f,-1.15790001f,-1.05960000f,1.14849998f,1.39789999f,-0.19150002f,0.47050000f,0.39769993f,0.19859997f,0.01890004f,-0.51320002f,0.44450004f,-0.11140001f,-0.08089998f,-1.81279999f,0.07050004f,-0.03209999f,-0.43870000f,-1.19839996f,-0.42469998f,-0.73210002f,-0.48609999f,0.18410005f,-0.44009999f,0.42770004f,-0.56599999f,0.33130004f,0.29439999f,0.77789996f,-0.24070001f,0.09610001f,-0.06710001f,-0.81839996f,0.10229998f,0.22969997f,1.33580001f,1.66519997f,0.47570001f,-0.60239998f,-1.26739994f,0.45179997f,0.74369998f,0.21159996f,0.81900004f,1.57500004f,-0.11869998f,0.12100000f,0.52680001f,0.66520001f,-0.88109998f,-0.12840000f,-2.26479996f,0.28570000f,-0.06950002f,-0.07630004f,-0.87579998f,0.92720000f,0.77130000f,0.21649997f,0.70749999f,-1.04280001f,-0.16969999f,-1.47279995f,-0.19409999f,-0.14500003f,0.61729998f,-0.73689996f,0.50370001f,-0.52969998f,-0.91560002f,-1.11100003f,0.42399998f,0.78180003f,0.19360004f,0.40959999f,-0.84880003f,-1.26870002f,-0.68109994f,0.09789997f,1.41750003f,0.20960002f,0.30959997f,-0.35700003f,0.45199995f,0.94330000f,-0.18380000f,0.03340001f,-0.49560002f,0.79310000f,-0.37249998f,-0.26410000f,0.09970003f,-0.03860001f,-0.44790001f,-0.24230001f,0.47409999f,-0.46640000f,-0.53930000f,-0.51250002f,-0.08729998f,-1.07109996f,-0.08839998f,-0.23579999f,0.33350000f,0.31780002f,0.50370006f,-0.12289999f,-0.86080002f,-0.56870001f,-0.77990001f,-0.21400001f,0.48590001f,-0.76860001f,0.40250002f,0.17210004f,-0.49720000f,-1.58200001f,0.42409998f,0.27780004f,-1.26020002f,-0.89060002f,-0.03849995f,0.70220001f,1.79050001f,0.20810000f,1.02970001f,0.64340000f,1.23819997f,-0.89810000f,-0.00839998f,-1.08949997f,-1.06450002f,0.79030004f,0.24100002f,0.83539998f,0.51620001f,0.28730001f,-0.04720000f,0.73739995f,-0.01260000f,-0.23670000f,0.02020002f,-0.79680000f,-0.21169998f,0.38889999f,0.73019997f,0.27429999f,-0.57879999f,0.49649999f,-0.40990000f,-0.94390000f,-0.35010000f,0.33670001f,0.55619996f,0.49300001f,0.28710000f,-0.73619998f,0.24020002f,0.02960000f,-1.26219997f,-0.20369999f,-0.59529998f,-0.86600002f,-0.07629998f,0.45000001f,0.26530002f,-0.21339998f,-0.44510000f,0.25159999f,0.13349999f,-0.74199997f,-0.43360000f,-0.05559999f,-0.44050000f,0.53850003f,0.42360002f,1.20280000f,0.84660001f,0.91409999f,-0.07260000f,-0.06790002f,-1.22139995f,-1.02880001f,-0.29099998f,-0.32870002f,0.72310001f,0.48469999f,0.95089997f,0.95179999f,-0.87919995f,0.27159996f,-0.59989998f,0.34039999f,-0.94999997f,0.02649997f,-0.33340000f,0.32039998f,0.37619999f,-0.82089998f,-0.06220001f,0.02630005f,-0.20419996f,-0.54420001f,0.70950000f,0.09979999f,0.21850001f,0.40750002f,-0.48240001f,-0.59640001f,-0.34090001f,-0.02990001f,-0.23150001f,0.03720001f,1.04740006f,0.50490002f,0.29409998f,-0.24560004f,0.53460003f,1.90330001f,1.85260001f,-0.43779998f,-0.25340003f,-1.43520002f,-1.24250002f,-0.41850001f,-0.38010001f,0.37150003f,-0.57310000f,-1.03369999f,0.21950001f,-0.37360000f,-1.48930000f,0.56550002f,-0.97930000f,0.71589999f,0.72680001f,0.64420001f,-0.75030003f,0.08180003f,-1.18130004f,0.11500001f,-0.72600002f,0.57850002f,-0.28070002f,-0.56860001f,-0.36859998f,0.04930002f,0.11199998f,-0.58170000f,0.05330000f,-0.45109993f,0.35770003f,-0.66969998f,-0.39910000f,1.05210001f,1.97160001f,-0.21320000f,0.31370000f,0.46990001f,1.02199995f,-0.69809998f,-0.18450000f,-0.04540000f,-0.99160002f,0.39999998f,-0.19360000f,-0.93929996f,-0.75740000f,-0.24479999f,-1.27139997f,0.26610001f,-0.68979997f,-0.89700000f,0.97260000f,-0.04519999f,0.30589999f,-1.03359999f,0.92089998f,-0.26850001f,2.03359999f,-0.16270000f,0.94750000f,-0.35559998f,1.44019998f,-1.07010002f,0.79560000f,1.04109999f,0.65570001f,-0.67759995f,-0.52779999f,-0.79940000f,-0.50289994f,0.80879996f,0.21690000f,0.48840004f,0.48850009f,-1.14139994f,0.51620000f,-0.50610000f,-0.33090001f,0.39810000f,-0.15850002f,-0.45089998f,1.98599994f,-0.16230001f,0.30600000f,-0.67070001f,0.49929994f,0.05890002f,-0.68519999f,0.64610001f,0.41060001f,-0.91320003f,-0.57759999f,0.11690002f,0.92320002f,0.05490000f,0.61540000f,-0.22919999f,0.12859997f,0.00120000f,-0.57590005f,0.84519996f,0.29800000f,-1.43899996f,-0.69239997f,0.02750001f,-0.69120006f,-0.84720001f,-1.09219998f,0.42970002f,0.83180004f,0.44750001f,0.18790003f,0.08269996f,0.86240001f,-0.43669997f,-0.80490003f,1.35379998f,1.07310005f,-0.33170001f,1.64539999f,-0.72030001f,-0.62530004f,-0.26079999f,0.14650001f,-0.75840004f,-0.28609999f,0.77820004f,0.21499998f,0.51570001f,-0.76910002f,0.24520000f,-1.11090000f,0.37369998f,-0.84630000f,0.46560000f,-1.15349998f,-2.24860002f,-0.78130000f,0.99150002f,0.54150001f,0.89759999f,-0.29790005f,-0.16430000f,-0.02130000f,0.17589997f,-0.77470005f,0.21159996f,0.33009997f,-0.58999998f,-0.06879999f,0.32399999f,0.49680001f,0.50459998f,-0.07769999f,-0.35870000f,-0.44330000f,1.06979997f,-0.01969999f,-0.98089998f,0.46930003f,-0.11140002f,-0.93769999f,0.11740002f,-0.14990003f,-0.52250000f,0.58949999f,-0.32080000f,-0.15540001f,0.75440002f,0.42680001f,0.09430000f,-1.44500000f,-1.12410001f,-0.52559999f,0.66000000f,0.81419996f,-0.97319998f,-0.31409997f,-0.63039998f,-0.01779999f,1.08400000f,0.73130003f,0.45360000f,1.02710000f,-0.64259999f,-0.16019999f,0.28500000f,-0.71459999f,-0.27089998f,0.28659999f,0.02620000f,-0.43960000f,-0.19290002f,0.64730000f,-0.13220000f,0.50649999f,-0.91630001f,0.24310001f,-0.10320000f,1.48549997f,0.13310000f,0.65540002f,0.10040000f,-1.07100003f,0.26300003f,-0.57320003f,-0.62060001f,-0.23919999f,-1.53579999f,-0.69560000f,-0.28169996f,-1.00450000f,0.86000004f,-0.07219997f,1.20569998f,0.50130001f,0.89259999f,-0.15509999f,-0.18350002f,-0.43460002f,-0.04480000f,0.52080003f,-0.48910002f,-0.42130001f,-0.63590003f,-0.29399997f,1.05320000f,1.04710001f,-0.17229999f,-0.27820000f,0.79310000f,1.13100004f,0.78340002f,1.43239999f,0.25620001f,-1.07570003f,-0.51750002f,-1.31619997f,-0.06429999f,0.08250001f,0.22360001f,-0.60300001f,-0.33160000f,0.40620002f,-0.15120005f,-0.12180000f,-1.62969998f,-0.54350001f,-0.54649995f,0.08930001f,0.30079996f,0.72500001f,-0.17100000f,0.16749999f,0.42309998f,0.90789999f,-0.06950000f,1.22040002f,0.50219999f,0.96639996f,1.02409998f,-0.31540003f,-0.33010000f,-0.18899999f,0.48120002f,0.66540000f,-0.69770001f,1.49090000f,-0.17550000f,0.59980001f,-0.35619997f,-0.33220000f,-0.10959998f,-0.48559996f,-0.94800003f,0.41800004f,0.33730000f,0.30179997f,-1.12550003f,0.56130000f,0.45959998f,0.76120000f,0.14949997f,0.42139998f,0.57890002f,-0.38270001f,0.90780002f,0.38920001f,-0.20100002f,-0.32380001f,-0.19589998f,0.89980001f,0.27950001f,-0.99669998f,0.14520001f,-0.89179999f,-0.15359999f,-0.64469997f,-1.11779999f,-1.30710001f,-0.66470004f,0.95500002f,0.34929999f,0.58640000f,0.25450001f,-1.37909998f,0.51530000f,-0.31859999f,1.03919999f,0.22889998f,1.09999999f,0.34789998f,-0.37810002f,0.96700002f,0.23500001f,-0.12730000f,-1.03159997f,-0.61159999f,-0.47630000f,-0.35369999f,-0.86600001f,-0.32890000f,-0.50499997f,-0.62900000f,-0.03390000f,0.19480000f,-1.18010001f,-0.13730001f,-0.68920000f,-0.98070000f,-0.63400003f,0.19760000f,0.57430003f,1.17860004f,-0.74470000f,-0.91979999f,-1.16580000f,0.24559999f,0.41489998f,-1.42050003f,-0.36590000f,-1.34169999f,0.49979999f,1.43960002f,0.71049998f,2.75580004f,0.91249996f,0.48059994f,-0.87849998f,-0.15759998f,-1.27049999f,-0.32220002f,-0.61459997f,0.17400001f,1.35190001f,0.66430000f,1.36599998f,0.46010001f,-0.62379999f,-0.64349999f,-0.21559994f,-0.51900000f,0.73050001f,1.44500000f,0.33960004f,-1.50020002f,-0.11800000f,0.83830000f,0.20899999f,-0.46219995f,-0.11549996f,-1.21960000f,-0.97970002f,0.11360002f,0.52200002f,0.31939999f,0.58729999f,-0.53340004f,0.17600000f,1.28289998f,0.81889999f,-1.30240003f,-0.23700001f,-1.21640001f,0.08479996f,0.52179998f,1.15319998f,0.39969999f,0.25409999f,-0.24450000f,-0.00660003f,0.32700001f,-1.73919999f,-0.95730000f,-0.55519997f,-0.25809998f,0.22770000f,0.68530001f,0.08079997f,1.13390002f,0.72459999f,0.10000001f,-0.72369998f,-0.92570000f,-0.91659999f,1.35379999f,0.02239999f,-0.03270006f,0.00770002f,1.66689998f,1.07119998f,0.76830000f,1.05060000f,0.15699998f,0.70369998f,0.73049999f,-1.16230000f,1.26460000f,-0.94530001f,0.44349997f,-0.89909995f,0.86190001f,-0.43899999f,0.67020000f,-0.17520004f,0.19949999f,0.40630002f,-0.18839999f,0.97600000f,0.05459999f,1.53289996f,0.54590001f,0.88379998f,0.60469999f,-0.07990002f,-1.14679996f,0.43720002f,-0.16090006f,-1.04049999f,0.25419996f,0.37299998f,0.06979996f,-0.98040001f,0.11560000f,-0.62490000f,0.52960001f,0.86960002f,0.38459998f,0.01950000f,1.30300000f,-0.07469998f,-0.73829998f,0.43079999f,0.30430004f,0.39109997f,-0.22529997f,0.06990001f,-0.98109998f,0.48139998f,-0.57150000f,0.09439999f,-1.01080001f,-0.40430001f,0.66940000f,-0.06249999f,1.09250000f,-0.15439999f,0.83250000f,-0.13240002f,0.68570002f,-0.36410000f,0.29569993f,-0.31850001f,-0.78460006f,-1.41880003f,-0.81360001f,-0.05289999f,0.43900008f,1.31250002f,0.68680000f,-0.02000003f,-0.08979998f,0.08360002f,-0.32439994f,0.83609998f,-0.25629999f,-0.04780000f,0.98070000f,-0.96029999f,0.77959997f,0.09790000f,-0.29130001f,-0.57540000f,0.58039999f,-0.39719999f,-0.82080000f,0.19420000f,0.21530000f,-0.27520001f,0.49240001f,-0.50200000f,-0.48490003f,0.80690003f,0.02049997f,-0.49670002f,-0.77219999f,0.41120001f,0.99129997f,1.28730000f,0.89240001f,0.68849998f,0.95109999f,-0.48219998f,0.23350000f,1.34590002f,0.77570001f,-0.72729999f,-0.09390000f,0.81339999f,-0.14689997f,-0.55899999f,-0.30040002f,-0.75889997f,-0.57029998f,-0.30719998f,-1.13479999f,0.51899997f,0.10949998f,-0.21909999f,-1.00260001f,-0.36910001f,-0.59630001f,-0.54450001f,0.69620000f,-0.12580000f,0.22299999f,-0.07560001f,0.07209998f,0.11389999f,-0.73750000f,0.42800003f,-0.54990003f,-0.57040001f,0.05059999f,-1.33129997f,-0.81249998f,-0.74140000f,-0.98910002f,-0.93880002f,-1.51940003f,-1.55310003f,-1.66710003f,0.50120001f,0.45469999f,-0.54000001f,-0.63489999f,0.13140001f,0.67329998f,0.68209999f,0.68590000f,0.95729998f,1.01309998f,0.20730000f,0.96560001f,0.13989999f,-0.26630001f,-0.18279999f,1.05000001f,0.22680001f,1.58990002f,0.58970001f,-0.71560002f,0.46410002f,-1.72450007f,0.06830000f,-0.76869997f,0.09030000f,-0.98940000f,0.26090003f,-0.58510002f,0.18399999f,-0.08079998f,1.09169997f,0.14880000f,1.12120004f,-0.10910004f,-1.41789999f,-1.51610000f,-0.79409998f,0.70250002f,1.39620002f,-0.05470000f,-0.14879999f,1.67680001f,-0.48360003f,-0.10109999f,1.10299998f,-1.26430004f,0.62009998f,0.67420003f,-1.04289998f,-0.71579999f,-0.17079999f,-0.14069999f,-0.10100002f,0.27460005f,0.39350002f,-0.33750000f,-1.05060003f,0.21580001f,0.01280000f,0.98750002f,0.62960001f,0.51270001f,-0.07060000f,1.46450000f,-0.50020002f,-0.91230000f,0.68360001f,-0.10050005f,-2.39249999f,-1.21439995f,-0.40579998f,-0.42039998f,1.06089997f,0.11050003f,0.67460004f,-1.29700001f,0.35089999f,0.64910002f,0.87499999f,0.01770002f,-0.35940001f,0.27899997f,0.36960000f,1.11099999f,-0.16870005f,1.00969999f,0.45590000f,0.16270000f,-0.37830002f,0.39960000f,0.34630000f,-0.78340000f,0.50790000f,-1.78919999f,0.67610002f,-0.15929993f,0.27699999f,-0.53980000f,-0.45480000f,0.63509999f,-0.06950002f,-0.74650001f,-0.45110001f,-0.91080000f,0.59740001f,1.58990001f,1.63309999f,1.17399998f,1.41869999f,1.65119997f,0.44569999f,0.19600000f,0.25799999f,0.28269999f,0.18819999f,0.43950000f,-0.93899998f,-1.77749999f,-0.01860002f,-0.47249992f,-0.68309998f,-1.33550000f,-0.22129999f,0.16980006f,0.27740000f,-1.17189998f,0.91210001f,-0.88810000f,0.43300001f,-1.35340001f,0.47630002f,-1.92200004f,0.71350004f,-0.20170002f,-0.52300002f,0.33080001f,-0.54869999f,-0.04269999f,1.26159999f,0.17560002f,0.90079998f,0.88540001f,0.17270000f,-0.27319999f,-0.32419997f,0.52670001f,-0.08550006f,0.86799998f,0.74870001f,-0.51450000f,-0.37940000f,0.01429998f,0.07859999f,1.88369998f,1.90349998f,-0.72800003f,-0.40739999f,-0.95290002f,0.17259999f,-0.45599997f,0.14070002f,-0.91189999f,-0.21920000f,0.61310001f,-1.29749997f,0.22430003f,0.36740003f,-1.48700000f,-0.85880000f,-0.77649999f,0.55440000f,0.26450001f,0.03519999f,0.08710000f,0.85170002f,0.22000000f,0.34259999f,0.52979998f,-0.28010004f,-0.66090002f,0.01120003f,-0.23830000f,0.35170000f,-0.18919999f,1.17959998f,0.43420000f,-0.36239999f,0.68790005f,0.77419998f,-0.06040002f,0.33490003f,-0.60689997f,1.08040000f,1.22219998f,-0.39960001f,-0.92180000f,0.77329998f,0.77039999f,-0.65630000f,-1.15430000f,-0.46509998f,-2.27140002f,0.02830001f,-0.40769996f,0.23390002f,1.54300000f,0.36700002f,0.28769999f,0.49449997f,0.29780001f,-1.28949998f,-0.12509999f,-0.91110001f,0.17620000f,0.87080002f,0.25400002f,0.64129993f,0.49890001f,-2.01349999f,0.51680001f,1.17990000f,0.56910001f,-0.92770001f,0.06640004f,0.42960003f,0.60870002f,0.11350000f,0.60489999f,-0.30570002f,0.56130000f,0.11990001f,0.06300003f,-0.04800002f,0.50850005f,-0.41460003f,-1.04400000f,0.00019998f,0.32569999f,0.94750001f,0.64229995f,-0.65120005f,0.67350003f,1.34620000f,0.13520000f,0.58590000f,0.47960002f,-0.78439994f,0.00050001f,0.63719996f,1.24860002f,0.18339998f,0.06169998f,0.72810003f,0.89160002f,-0.06290000f,-0.18509998f,-0.65010001f,-0.30649998f,-0.50200001f,-0.90959999f,-0.72909999f,0.17389998f,0.61260000f,0.85519998f,-0.85730003f,-0.07300000f,0.48520003f,0.65030001f,0.59740002f,-0.30250002f,0.04789999f,-0.43820000f,-0.40190000f,1.07930000f,-0.10099998f,1.32360001f,-0.62310001f,-0.77100000f,1.03059999f,0.17820001f,-1.29349999f,-0.64350001f,-0.17989999f,-0.28200000f,1.15380001f,0.18370000f,0.84489997f,0.15390000f,-0.59249998f,0.10860000f,0.71579999f,-0.26619999f,-0.31370000f,0.07810000f,0.61660001f,-0.12589999f,-1.22930001f,0.06570003f,1.12080003f,0.43519999f,0.53409996f,-0.96900002f,0.65880002f,-0.56380001f,-0.06250001f,0.19350000f,0.81010000f,0.64790000f,-0.23740002f,-0.34910002f,0.63540005f,-0.52080001f,-0.47089999f,-1.57399999f,-1.04229998f,0.15690000f,0.15010001f,0.12120000f,0.07579998f,-0.04879999f,-0.84639999f,0.15060000f,-0.59270002f,-0.30810002f,-0.56349998f,-0.90330000f,-0.73869999f,1.14149999f,1.09559998f,0.63329999f,0.76399998f,-0.03069998f,0.95360003f,-0.25470000f,-0.24480003f,0.76890000f,0.55010000f,0.02760001f,0.58610002f,-0.63009996f,-0.43099999f,-1.76929999f,-0.03239999f,-1.65990000f,1.05860003f,-0.17350001f,-0.94990002f,-0.40390001f,-0.03449997f,-1.54880001f,0.61039998f,0.61859999f,-0.75630002f,0.36330000f,-0.64380004f,0.57790000f,-0.02650002f,-0.14300001f,-0.39340001f,0.26930001f,-0.74070001f,0.05359999f,0.51690000f,1.07940001f,-0.11759998f,0.19789996f,-0.49230003f,1.40699996f,1.04910004f,0.00670000f,-0.91070000f,-0.36970003f,0.11570001f,0.67529998f,-1.11160007f,1.45529996f,-0.52530000f,0.79210001f,0.38930000f,-0.36589996f,0.27609996f,0.18560003f,0.48489998f,-0.44490003f,-0.12229999f,1.08469998f,-0.79649998f,0.31480000f,-0.33480002f,0.88300001f,0.40130001f,-0.54550001f,0.10000002f,-0.05110002f,-1.12760002f,0.38630000f,0.33180001f,0.33890000f,0.05560001f,1.76580002f,0.06489999f,-0.08559999f,0.59419999f,0.41420000f,1.28990001f,1.93859999f,-1.24170001f,-0.47370001f,-0.01120000f,0.24400000f,-0.22159998f,-0.71169999f,-0.07950000f,0.29750000f,-0.24980000f,-0.31390000f,-0.80289995f,-1.26530000f,0.08730001f,-0.67949998f,0.22769999f,0.48170001f,0.48329999f,1.03900001f,-0.21889999f,-0.13360000f,-0.35850001f,0.84690002f,-0.70450001f,2.13480005f,-0.01310001f,0.31700001f,0.16380002f,-0.47300001f,-0.67500003f,0.38570002f,0.48220002f,-0.34340001f,-0.44539996f,0.56720006f,0.03570000f,0.54760004f,0.47970001f,0.24930003f,1.20440002f,0.19209993f,-1.65170001f,0.72779999f,0.64939997f,-0.46089999f,-0.72209998f,0.21379997f,-0.76250000f,0.64400001f,-0.51659999f,-0.00970002f,1.19129999f,-0.83649997f,-0.40759999f,-0.36990002f,0.05180003f,0.29259995f,-0.10360000f,0.74570002f,0.43490000f,1.44330002f,-0.39240004f,-0.68199998f,0.78800005f,0.55039998f,-0.06340000f,0.77220005f,1.17560006f,0.33250001f,-0.33569998f,0.39540009f,2.23730000f,0.58810001f,-0.40000004f,-0.29559999f,1.95480004f,0.89090003f,0.19510002f,-0.63330002f,0.88049998f,-0.40310004f,-1.14870000f,0.60869996f,0.31109998f,0.79399998f,-0.78260000f,-0.62240000f,0.35209998f,0.38989999f,0.24680000f,0.19939999f,-0.32930002f,-0.19640000f,0.09090000f,0.07860001f,0.60660001f,-1.14559999f,0.18390001f,-1.05580002f,0.20620001f,0.81830000f,-0.03460001f,-1.20910004f,-1.61930002f,-1.03700002f,-0.55170002f,-0.43579999f,0.65969999f,0.63079999f,0.68530001f,0.40679994f,0.13489998f,0.40090003f,-0.03569999f,0.34130000f,-0.04809999f,0.54780000f,-0.04070001f,0.59440000f,-0.37150000f,-0.67229997f,0.60340000f,-1.21229998f,-0.45720001f,0.80759999f,0.36450000f,0.83210002f,0.16590000f,-0.08160000f,-0.10220000f,-0.28390001f,0.29580000f,0.69580002f,-0.92870003f,0.08040000f,-0.61069999f,0.08150001f,-0.39340000f,-0.49590001f,0.21269999f,0.13620001f,-0.15809999f,-0.82560003f,0.00949999f,0.01900003f,-0.93350000f,-0.35540002f,-1.44789998f,-0.12099998f,-0.33319997f,0.33389999f,-0.17040000f,0.05450000f,0.86489999f,0.00710000f,-0.35040001f,1.11979999f,-0.25959995f,-0.64790001f,-0.14270000f,-0.33899996f,0.13880000f,0.99459998f,-0.73460000f,1.92270003f,-0.43080001f,2.33370003f,-0.64190004f,0.03090000f,0.15150002f,0.64810002f,-0.65700003f,1.35150003f,0.08050000f,1.52460001f,0.40840001f,0.78950003f,0.68079998f,0.25200003f,-0.65860002f,-0.78960002f,0.66490003f,0.95690002f,-0.27640002f,0.19690003f,0.47260000f,-0.55800003f,-0.65189996f,0.17230000f,-0.32150001f,1.12109999f,-0.05499999f,-0.17990001f,-0.18840000f,0.05410002f,-0.74490000f,0.35989999f,0.61429998f,-1.48410002f,0.46180000f,-0.85249999f,0.70540002f,-0.45809999f,-0.00130001f,-0.30780001f,0.63500001f,-1.19920001f,-0.07729998f,-1.71020006f,0.68730005f,-1.00120000f,-0.36220001f,-0.06450001f,-1.01889993f,-1.03210000f,1.14920006f,0.08180000f,1.46100000f,-0.03750000f,0.92410006f,0.21860003f,1.02119997f,-0.94929998f,-0.67040002f,-0.12640002f,-0.44940001f,-0.66690001f,1.53280003f,0.45279999f,-0.87620003f,-0.76520002f,0.83190002f,-0.62180002f,-0.96660002f,-0.41210001f,0.17150000f,-0.97880008f,-0.45869998f,-1.38169999f,0.49990001f,0.88900002f,0.12130000f,-1.02940002f,-0.48890000f,0.19300005f,-1.39780001f,-0.22650001f,-1.72580002f,-0.53520001f,-0.27999997f,-0.18590001f,0.59269995f,0.43540000f,-1.03149995f,-1.09560002f,0.84190002f,-0.37780000f,-0.21129998f,-1.58680000f,0.91040001f,1.08460000f,0.71060001f,-0.42190000f,0.39390001f,-0.33699995f,-1.50289999f,-0.02770000f,1.38390000f,0.96419994f,-0.24260001f,-2.64620001f,-0.79229998f,-0.34659999f,0.30659999f,-1.00050003f,1.71040000f,-0.00900005f,-0.35990000f,-0.57250005f,-0.51679997f,0.33640001f,0.31570000f,-0.58720000f,0.30029998f,0.38189999f,-0.53050003f,0.41610001f,-1.07750005f,-0.03380000f,-0.53969998f,-0.21490002f,0.91779996f,0.29059999f,0.40129999f,0.35570000f,0.44910000f,-0.03040002f,1.22430000f,0.22230000f,-0.26270002f,-0.07440002f,1.63310000f,-0.95949998f,0.11120001f,0.42890002f,1.15130002f,-0.38749999f,-0.23509997f,-0.79259998f,-0.37279998f,-0.43489998f,-0.78089998f,-2.23280003f,0.70410001f,-1.09369998f,-0.87949998f,-1.03430000f,0.09530002f,0.10950000f,0.03580002f,-0.20480000f,-0.03610004f,-0.03870001f,-1.50259998f,-0.24190001f,-0.10610001f,-0.39579998f,-0.98080000f,-0.31649999f,-1.54110002f,0.60639997f,-0.72450003f,-0.25110004f,1.43990001f,0.80090002f,-1.13389996f,-1.35250000f,-0.25560001f,1.50839996f,0.08450000f,-0.19109998f,-0.21279998f,0.67780000f,-1.16590002f,-0.43169997f,-0.60310000f,0.37770006f,-0.27800003f,-0.68770004f,-0.09290000f,1.86659997f,0.83049999f,1.22770000f,0.10070001f,0.03249998f,0.53770007f,-0.25760000f,0.76010000f,0.10110001f,0.03030002f,0.03930000f,1.19109996f,0.85959999f,0.82239998f,0.17160001f,0.29410000f,-2.08850001f,-1.39700004f,0.23170000f,0.35300001f,1.12280005f,-1.17779997f,-0.88299999f,-0.06980000f,1.59169998f,0.49030001f,1.05859994f,0.71729995f,-0.99710000f,-0.12500002f,1.41290000f,0.17299997f,1.05460001f,0.56869999f,-0.38440005f,-0.37270002f,1.48509998f,-1.05079996f,-0.24259999f,-0.15460004f,-0.53710000f,0.65420001f,0.13250000f,0.10879998f,0.51130002f,-0.38230000f,0.15119999f,1.20899998f,0.46739999f,0.32319998f,0.66809997f,-0.85280002f,-1.14240000f,-0.62239999f,-0.59680002f,-0.15720000f,-0.21849997f,0.10310001f,0.05540002f,0.13610005f,-1.26420002f,-1.39060005f,-0.07700000f,0.18330002f,-0.84099999f,-0.93850000f,-0.12400000f,0.59839997f,0.47709998f,0.75169997f,0.01479996f,0.07640002f,-0.55119999f,-0.36960003f,-0.09360002f,0.03510001f,-0.93089999f,0.16270002f,-0.22629999f,-0.13390001f,0.21740000f,-0.75579997f,-0.72900000f,-0.37749998f,-0.54309999f,-0.40159999f,0.17569999f,0.74370001f,1.09070000f,-0.72160001f,0.89370001f,1.22359998f,0.96190003f,-0.37590000f,-1.16999998f,0.31790000f,-0.02960002f,0.18160002f,-0.61930002f,-0.09299999f,0.26530002f,0.75919999f,-0.21300001f,-0.36079997f,0.60349997f,-0.99979999f,-1.08589998f,0.26659998f,-2.19620001f,0.27370000f,0.68810001f,-0.43380003f,0.66519998f,-0.40330001f,0.54520006f,-0.18850002f,0.64770002f,-0.02289999f,0.13179995f,-0.55830002f,-0.69600000f,0.11920002f,-0.75650005f,0.15620000f,-1.30240005f,-1.44000002f,-0.65710000f,-0.46840003f,0.32090003f,1.02260001f,-0.23640006f,-2.34730003f,-0.59419997f,0.03890004f,0.12349997f,-0.35660002f,0.68519998f,-0.24399998f,0.84470004f,-1.04269999f,0.39380000f,1.40420000f,-0.34650002f,-1.08329998f,-0.11820000f,0.93040001f,-0.85900000f,-0.92980000f,1.52990003f,-0.23340001f,0.44819999f,-0.19160000f,1.83970003f,-0.48830003f,0.72670002f,0.04199997f,-0.11359996f,-0.19129999f,-0.28070001f,0.35350001f,-0.19669991f,0.94620001f,1.27550001f,0.51989999f,-0.38270000f,-0.85300003f,-1.76200002f,-0.71700005f,0.32590004f,0.98070001f,1.04429995f,-0.03100001f,1.35750000f,-0.34509999f,-0.92930003f,0.52300000f,1.29140000f,0.65409998f,1.22359999f,-1.45999998f,0.28600000f,0.14640003f,-1.48969997f,0.56020000f,0.36179999f,-0.45080001f,0.07390001f,-0.29790000f,0.41519998f,-0.54090001f,1.59910004f,-0.83450001f,0.56040001f,-0.30550000f,0.52810002f,-1.20040005f,0.74360003f,-0.39399998f,0.38900001f,0.25720001f,0.30559998f,-0.71960001f,0.48370004f,-0.84749996f,-0.80679998f,-0.42649996f,0.56610001f,-1.74390001f,0.02029998f,-0.71209996f,-0.57969999f,0.66480000f,-0.47950001f,-0.97239997f,0.73890001f,0.37280000f,-0.08190000f,-0.09679999f,-0.15930001f,-0.19970000f,-0.75850002f,0.25530003f,-0.58560001f,-0.14259998f,-0.40300006f,0.52389998f,0.67020004f,0.59650001f,-0.81739998f,0.24610000f,-0.78440001f,0.05240000f,0.30479997f,-0.04879998f,1.03860005f,0.78600007f,0.86150001f,0.07929995f,-0.20399997f,1.70229998f,0.93399996f,0.26550000f,-0.60550001f,-0.65789997f,-1.14909999f,-0.92150000f,-0.65919998f,0.61820000f,-1.45920005f,-0.20690001f,1.38660000f,-0.18790000f,-0.84359996f,0.42919997f,-0.12550000f,0.13950001f,0.66750001f,0.76580002f,-1.24130002f,0.18470002f,-0.02080001f,0.23169996f,0.68580004f,0.24760000f,-1.32829999f,0.15480001f,0.84109998f,-0.66710000f,-1.61930004f,0.36759997f,0.19219999f,0.95960006f,0.17830001f,-0.25320008f,-0.70359998f,1.05690001f,1.26020001f,1.55399996f,1.43519996f,0.18380002f,1.50990004f,-0.23190004f,-0.15709998f,0.63569999f,-0.20420003f,-0.53440002f,1.53589998f,-0.77469998f,-1.68629999f,-0.12779997f,-0.36480000f,-0.72830000f,-0.50059999f,0.53880002f,-0.20280000f,0.23050000f,0.27149998f,-0.64040002f,-0.85589999f,-0.00400000f,0.14869999f,0.49190001f,0.36020000f,-0.13640001f,-0.77569999f,0.13560000f,0.34289998f,0.22569998f,-0.69240000f,-1.69759996f,-0.83739995f,-0.79409999f,-0.84430005f,0.19949995f,0.17010002f,0.13190002f,-0.58219999f,0.42449999f,0.18170002f,0.64809996f,0.81279997f,-0.22230000f,-0.53110002f,0.91970002f,0.62850000f,-0.40680003f,0.94290001f,-0.76269997f,-1.17539999f,0.81330003f,-0.14030000f,-0.65580000f,-0.15050002f,-0.61200002f,0.14970001f,0.07550001f,-0.08690001f,0.11880000f,-0.62789997f,0.48320001f,-0.05280000f,-0.18299998f,-0.64470000f,-0.53469998f,-0.47660000f,0.29710001f,0.29700000f,0.25509996f,0.90719999f,-0.35520006f,0.23939999f,0.14060002f,-0.22910001f,-0.81440002f,-0.45160003f,-0.27330001f,-0.08270002f,0.56209998f,0.89480003f,0.12880003f,-1.34709996f,-0.21500000f,-0.92129999f,-1.65440004f,0.76129997f,-0.26780002f,0.36460000f,-0.56730002f,0.94450005f,-0.52450002f,0.13200002f,0.69510001f,-1.85950003f,1.46230000f,0.05549999f,-0.35950005f,-0.36160001f,0.27320004f,-0.48190001f,1.13340005f,-0.13060000f,-0.30960000f,-0.07189998f,-1.69080001f,-0.26229999f,-0.64919998f,-0.28849999f,0.47240004f,-0.71140000f,-0.77479996f,-0.83569997f,-1.00080000f,-0.43710000f,-0.74729998f,0.60900004f,0.07309999f,-0.46159998f,-0.21940000f,-0.69979998f,0.17300000f,0.27040002f,0.76059998f,1.01189998f,0.75749998f,1.89149996f,0.10560000f,1.36799999f,1.17369999f,-0.82240005f,-0.05550000f,-1.15499998f,1.06899999f,-0.15819999f,0.16410002f,-0.24979998f,0.64480000f,-0.33259997f,-0.18460002f,0.23120001f,-1.64279999f,-0.75550000f,-1.03749996f,-0.19969999f,-0.18619998f,0.07239998f,0.82449998f,-0.68320000f,-0.52639995f,-1.22440000f,0.28909998f,0.59499997f,-0.09960004f,-0.38209993f,-0.19939996f,-1.18649998f,-1.63540001f,-0.78299998f,-0.49570001f,-1.77320001f,-0.17140002f,-0.90680001f,1.37820000f,1.47499998f,1.25549998f,-0.21049998f,0.29260000f,-0.51250000f,0.42199997f,-0.49190001f,-0.85709999f,-0.65280001f,-0.19139998f,0.16980000f,-0.00550004f,0.53900000f,-1.32589997f,-0.95579999f,-0.81839999f,-0.25189999f,-0.44140000f,-0.79609999f,0.59120002f,-0.35280003f,-1.78690003f,0.02600000f,0.19470001f,-0.00380002f,-0.19160004f,2.22860002f,0.57670001f,-0.22600000f,1.21169996f,-0.95869999f,0.32740002f,0.77119999f,-0.90780003f,-0.20720001f,0.52380000f,1.52540003f,-0.79569997f,1.14820004f,-0.48799994f,-1.92739999f,1.20439999f,-0.27750000f,0.48599997f,-0.21120000f,-0.27119996f,0.05830000f,1.65070000f,0.66060002f,0.24369998f,0.41590001f,-0.68030003f,0.08809998f,-0.15200004f,-0.71660001f,0.85129999f,1.44669997f,0.45610001f,-1.64049998f,-0.73169999f,0.54669998f,-0.24360003f,-1.38389997f,-0.88310002f,0.25790003f,0.56570004f,-0.94480002f,-0.30069998f,0.89650003f,0.94369999f,0.09930001f,-0.03969998f,0.95369999f,1.35719998f,-0.65669999f,-0.31500002f,0.22990002f,1.64749999f,0.14559999f,0.80649998f,0.41840000f,0.32589999f,-0.52479999f,-0.53640000f,-0.02950001f,-1.16279997f,-0.73050000f,-0.33409997f,0.17450001f,-0.07760002f,-1.16709999f,-0.38200000f,0.57029997f,0.26910001f,-0.91009999f,-1.43929997f,0.30900001f,-0.49290000f,0.23759997f,-0.95529999f,0.45220003f,-0.43410000f,-0.37770004f,-0.73579998f,0.49129999f,0.41169998f,0.73650000f,0.12479999f,1.65679996f,0.49909998f,1.62399998f,-0.05300004f,1.59320001f,0.59439999f,-0.66460000f,0.49780000f,-0.08160000f,0.89079997f,0.06390002f,0.50940000f,0.24280000f,0.87290001f,0.15439999f,0.78350000f,0.63290001f,0.44720000f,-1.21709995f,0.30229998f,-0.50300000f,-0.53949998f,0.11529999f,1.28019998f,0.62529997f,0.84359997f,-1.39439997f,-0.31579999f,0.06810004f,0.36500000f,-0.12740001f,0.82580000f,0.11460002f,0.11779999f,0.27450000f,0.02290000f,0.84500001f,-0.58329999f,-0.31940000f,-0.18649999f,0.12010001f,-0.48729999f,-0.90870001f,0.26610002f,-1.15380002f,0.50110003f,-1.35940005f,-0.13249997f,-0.11930001f,-0.48470003f,2.03090003f,-0.24650001f,0.08250001f,0.90170003f,-0.94210003f,-0.65590001f,-0.03770000f,0.34640003f,0.51990000f,0.15970008f,0.49570002f,-1.05360002f,-1.38969999f,-1.14880000f,-1.69430001f,0.95360001f,-0.04000001f,-0.21240000f,-0.39809998f,0.13969999f,-0.97760001f,0.48530000f,-0.70340001f,0.47629998f,2.13979998f,0.31950000f,1.06880001f,-0.47110005f,-0.35030003f,0.43989999f,-0.87689999f,0.58880001f,-1.95249996f,0.62050000f,-0.45710002f,-0.86090002f,0.22890003f,-0.12880000f,1.12319998f,-0.37850001f,-0.11220001f,-0.51140000f,-1.14120001f,-0.53569998f,-0.96520003f,0.50479999f,-0.25370004f,-2.11629999f,-1.51869998f,-0.53379999f,-0.47809998f,-1.36439999f,-0.06099999f,0.67899998f,0.57149999f,0.55169998f,-0.21109994f,0.89309996f,0.37879998f,-0.06650000f,0.62200000f,0.22950000f,1.18709997f,0.16819999f,-0.15150001f,-0.65660000f,0.76629999f,0.35919999f,1.23640001f,0.12310001f,-0.01250001f,-0.78480001f,-0.68330003f,0.17360000f,0.81409999f,0.29009998f,0.51099999f,-1.04609999f,-0.04929997f,0.30029997f,-0.30039998f,0.55849998f,-1.00080007f,-2.38559997f,-1.57509996f,-0.47240000f,-1.11500003f,-0.58580006f,-0.83570000f,0.11659999f,-0.00300001f,0.22370000f,1.56209997f,0.92960000f,0.52410002f,-0.09040001f,0.06019996f,1.18249999f,1.51109998f,-0.78490001f,0.34550001f,0.10940000f,-0.73840001f,0.58700001f,0.02890002f,0.55670002f,-0.65410000f,0.16560003f,-0.83580001f,-0.52240003f,1.71030001f,-0.24319998f,-0.23509999f,-0.07070001f,-0.53920006f,0.14119999f,0.68940005f,1.35430001f,0.01939997f,0.95830005f,1.47489998f,0.00199995f,0.46749999f,0.27880000f,-0.02250000f,1.07729999f,-0.37809998f,-0.88240001f,0.56840000f,0.31140000f,-0.28489997f,-0.54459997f,-1.46779998f,-0.59399997f,0.54520000f,1.23709997f,0.86680003f,-0.06789998f,-0.58760001f,-0.07270001f,-0.46400000f,0.42540001f,-0.44620002f,-0.49920000f,0.17249998f,0.41010002f,0.16419997f,-0.33530002f,0.01440004f,1.01440003f,1.01259997f,-0.91880000f,-1.44360002f,0.02289998f,-0.25460007f,-1.97490000f,-1.92839999f,0.31520001f,0.17000002f,-1.07590000f,0.86359999f,-0.10569997f,-1.46819998f,0.94629997f,0.38500001f,0.76190000f,0.28110001f,0.23760000f,1.17539999f,0.02619998f,0.55069997f,0.82859999f,-0.29469997f,0.22830000f,-0.94509998f,0.41340001f,-0.38259999f,0.83609999f,-1.11629999f,0.45160001f,-1.30230001f,0.93720002f,-0.51150003f,0.12879999f,-1.15699999f,0.19810000f,0.85849998f,0.40160000f,-0.61760002f,0.47739997f,-0.06610002f,0.31319999f,-0.22570002f,1.32439999f,0.24050000f,-0.02190003f,0.88920002f,-0.42749999f,-1.00159997f,1.00559996f,0.24440002f,0.05249997f,0.14260000f,0.12649999f,-0.44889999f,0.37839998f,0.29119997f,-0.34150000f,0.18589999f,-0.20720000f,-0.36110002f,0.35050000f,1.07960003f,-0.83220002f,1.02390003f,-0.81120001f,0.39459999f,-0.03599999f,0.70270000f,-0.68240003f,-0.20419999f,-1.43369997f,-0.64890000f,-1.05039999f,-0.67010001f,0.12430002f,-0.45530000f,-0.54499998f,-0.27970000f,-1.50010001f,-0.52490001f,-0.73209996f,0.38390004f,0.35310001f,-1.89780005f,-1.64340000f,-0.62340000f,-0.87209999f,1.09759998f,-0.31820002f,1.72659994f,0.80229998f,-0.14630001f,0.29330001f,-0.17409999f,0.26639999f,-0.92520002f,-0.80520004f,1.05760003f,-0.44030001f,2.25460001f,-1.20039997f,0.81360002f,-0.24080002f,0.42790002f,0.24450002f,-0.60300002f,-0.20289998f,-1.00730001f,1.05280005f,-0.00669999f,1.69499999f,0.72400000f,1.03549999f,0.41719998f,1.32279995f,0.71749999f,-0.04169999f,1.41609999f,-0.79010000f,-0.17729998f,0.41540002f,0.88689997f,-1.14880001f,0.47300003f,1.33910002f,0.68989997f,-0.58550003f,-0.73890001f,1.22560002f,1.50870000f,0.13319997f,0.15529997f,0.57750002f,1.99670000f,-0.31759999f,0.49620001f,0.38370004f,0.50409997f,0.11310002f,-1.65950006f,0.16720000f,0.72640000f,0.35920000f,0.38610000f,1.21359997f,0.68500001f,0.16570000f,0.07249999f,0.08549991f,0.36899999f,-1.40960001f,-0.81030003f,-0.00210003f,-0.87529999f,0.75639999f,1.37770002f,0.31060004f,-1.53640003f,-1.74390003f,-0.57329999f,0.26209999f,0.83470000f,-1.43910002f,-0.30039998f,-0.19019996f,-0.36089999f,0.16930001f,1.19850000f,0.35740001f,-0.49660001f,0.31670000f,0.49870001f,-0.15810002f,1.59550004f,-0.32710004f,0.34560000f,0.26350001f,0.26260002f,0.53009997f,-0.15420001f,-0.36100000f,-0.29689998f,-0.13899995f,-0.39300001f,1.04240000f,0.34000001f,0.41040004f,0.28090002f,1.70769999f,0.18440000f,-1.10670006f,-0.01329998f,1.25440003f,0.05930002f,0.35409998f,-0.59839996f,0.27820002f,-1.41509998f,-1.46689999f,-0.56879996f,-0.39290001f,0.45260000f,-0.54820003f,-1.03810002f,0.97540003f,-0.46889998f,0.59749998f,-1.07419999f,0.78019999f,-0.59950000f,0.45899997f,-0.11540003f,-1.45389998f,-0.01120000f,-1.11719999f,0.02240000f,-0.54580000f,0.14320000f,-1.24399997f,-0.78520000f,-0.88179999f,-0.33309999f,-0.78959996f,-0.53999999f,1.06939999f,1.07590001f,0.56550003f,0.13769998f,1.07249999f,0.45519995f,0.21759999f,-0.29820000f,-0.26479999f,-0.02940000f,0.34120000f,0.02159999f,-1.34760003f,-0.29349998f,-0.77239997f,-1.04929999f,-0.67549998f,-0.29579999f,-0.09379999f,-0.63479999f,0.08469999f,0.11280000f,0.90309999f,1.08319998f,-0.26470001f,0.43070001f,0.32480000f,0.07649999f,0.58219996f,0.24539999f,-0.20820001f,0.05050000f,0.16730000f,0.24399999f,0.34719997f,0.23080001f,-0.52039997f,1.04500000f,-0.59400001f,0.49940000f,-0.37310001f,0.07070004f,1.11940003f,1.79970002f,-0.80469998f,-1.74560006f,0.30169993f,2.67790000f,1.28760002f,2.05480002f,-0.60560001f,-0.06239999f,0.57939994f,0.07269999f,0.41910001f,0.48169996f,-0.07889998f,-1.25340002f,-1.07090001f,1.36450004f,1.21300002f,0.13240001f,-0.24329998f,0.47620000f,0.07970000f,0.74090001f,-0.31860005f,0.28449999f,0.04910003f,-0.08310002f,0.93299997f,1.00350001f,-0.01970000f,-1.64599999f,-1.17130000f,0.05819999f,0.11020001f,0.72629994f,0.69289999f,-0.02609999f,-0.72910000f,-0.33459999f,-0.35180001f,0.77530000f,0.45530001f,-0.67609999f,-0.12609996f,0.66780000f,-0.16509996f,0.03750001f,0.88449995f,0.93329999f,0.19820005f,-0.63970002f,0.49479998f,1.41230001f,-0.75769998f,-0.58020003f,-0.32280001f,-0.34150000f,1.14590003f,-1.20220002f,1.02320002f,-1.49050001f,0.26340001f,-1.03580000f,0.44870002f,0.45719998f,-0.41440001f,-0.33900000f,-1.65470001f,-1.12210001f,0.56490000f,0.42610001f,1.74509998f,1.06879997f,1.14109998f,1.99329998f,1.74419997f,0.51649998f,-0.73789997f,-0.63270004f,0.57750000f,0.20190002f,0.05619998f,0.06470000f,-0.17020000f,-0.96699999f,-1.24409995f,-1.81089997f,0.66019996f,-0.00690000f,-0.34229996f,-0.52610001f,0.33389999f,0.19780004f,0.45020001f,-0.82270000f,0.32229999f,-0.66500000f,-0.18350001f,0.38660001f,-0.67640005f,0.38880004f,-0.22469999f,0.99859997f,0.48269998f,0.09990004f,1.37380001f,0.05319993f,0.06649997f,0.51520001f,0.75039998f,-0.12920009f,-1.97470007f,-0.55199998f,0.07100002f,-0.71709999f,-0.63750002f,0.56260000f,0.68060000f,-0.61119996f,-0.88499999f,-0.24990001f,1.06790002f,-0.24299997f,-1.01830000f,0.51350002f,1.10960000f,0.75890002f,-0.36360001f,-1.57670002f,0.13330001f,0.68240002f,0.35629999f,-1.03780003f,0.46210004f,-1.05020004f,0.69650002f,-0.13649998f,0.83650001f,-0.52439998f,-0.17099998f,0.43090000f,-0.38709999f,-1.18750006f,-0.98840005f,-0.56089999f,1.05540004f,0.48069998f,0.51770000f,0.30070005f,1.95930002f,1.24770001f,-0.19340001f,-1.99280001f,1.44640000f,1.26390003f,-0.70810001f,0.39460000f,0.62589999f,-0.97600000f,-0.56910003f,0.62240001f,0.26520000f,-0.03990001f,0.09400001f,1.04500003f,-0.65790002f,0.98309997f,-0.79040000f,0.21049998f,-0.07940000f,0.90629997f,-0.00510001f,-0.53849996f,0.33170000f,-0.96760005f,-0.20950001f,0.24720005f,-0.18149999f,-0.75970001f,-1.82069996f,-1.01419996f,-0.75970001f,-1.58080002f,-1.45179999f,-0.78869995f,0.89079999f,-0.17610001f,-0.61540002f,1.10060001f,0.42770001f,0.39619996f,-0.01699999f,0.24739997f,1.38639997f,1.56319997f,-0.73149998f,0.61860000f,-1.10790000f,0.39690001f,-0.31710002f,0.49200002f,-0.13519999f,0.30170001f,-0.09770000f,0.69239999f,0.16709999f,0.19080000f,0.14550001f,-0.31240000f,0.37950001f,1.31470004f,0.30699999f,1.03910002f,0.85250000f,0.93639997f,0.06799998f,-0.01310000f,0.35179998f,0.03700001f,0.31179999f,-0.76010004f,0.31419997f,-0.83580002f,-0.85679996f,-0.63010000f,0.09480002f,-0.81439996f,0.05310000f,0.41839999f,-0.16680000f,0.30929999f,0.83059999f,0.17090002f,-0.64610002f,-1.85750003f,0.41220002f,0.75039997f,0.19050000f,0.98580001f,-0.64530003f,-0.04889998f,0.21249998f,0.88570004f,0.34620005f,-0.42080003f,-0.69800002f,0.46300000f,0.92329999f,0.61490001f,0.86269999f,-0.14959993f,0.22030003f,0.34730001f,-0.27860008f,-0.34780001f,2.20670005f,2.14600001f,-1.10649998f,-1.28680001f,-0.03590001f,0.61529997f,-0.40230002f,1.07339996f,-0.16559998f,-1.07990003f,-0.54719998f,1.36930004f,-0.49109999f,-1.65829999f,0.51489998f,-0.05639997f,0.44540000f,-1.41269996f,0.30130001f,-0.74069999f,-0.00299999f,0.64980000f,-0.06870002f,0.10030005f,0.81510002f,0.57530001f,-0.26980001f,-0.12430001f,0.43639999f,-0.32789999f,0.38740000f,0.53059999f,0.73110000f,0.42959999f,1.33070002f,0.70250002f,1.60910000f,0.37010001f,1.40400004f,-0.64009998f,-0.20699999f,-0.80169997f,0.42820001f,0.40720000f,-0.14120001f,-1.63460000f,-0.81070002f,1.67409999f,0.25990003f,0.12340002f,0.76240002f,-1.22070003f,0.49770000f,-1.02730003f,0.21620004f,-0.83820002f,0.26960000f,-0.89080002f,-1.06690001f,0.96830000f,0.38079998f,0.29940001f,0.73150002f,-0.44029999f,-1.12890000f,-0.21320000f,-1.09530002f,-0.31480000f,-0.00200001f,-0.25390000f,0.60580001f,0.79390000f,0.71909999f,0.80160000f,0.64709997f,-0.29029999f,-1.81349999f,-0.28619998f,0.43039998f,1.13049999f,0.45300001f,-0.06639996f,0.18260001f,-0.66979999f,-1.73290004f,0.11050001f,1.96420001f,0.39350003f,-0.26440002f,-0.23300002f,0.09519999f,0.67769999f,0.94149998f,-0.23160000f,1.03990001f,0.19100000f,-0.45909998f,-0.27469997f,-0.14019996f,0.25820001f,-0.63439995f,-0.05730000f,0.37609997f,0.83499999f,-0.55559999f,-0.04279999f,-0.54540001f,-0.05899998f,-0.37469994f,-0.29710000f,0.80049994f,-0.39959997f,-1.35340002f,-0.52879997f,0.09920000f,0.62289998f,0.15920000f,0.26549999f,0.72700001f,-0.20800007f,-0.60110000f,-0.72430002f,-1.27460001f,0.41079999f,0.51649995f,-0.33200003f,-0.35549998f,0.43150001f,-1.06119999f,-0.29229998f,-0.81140000f,0.08300000f,-0.36390004f,1.06950004f,-0.64570002f,-0.13020001f,-0.97139996f,-0.32360000f,0.57480001f,0.09260000f,0.69610001f,-0.15530002f,1.17060001f,-0.20210002f,1.30870004f,0.16760001f,0.69830001f,-0.76150000f,-0.64940000f,-0.89580003f,-1.79079999f,0.28010002f,-0.13409998f,0.27539997f,-0.60589999f,0.05050000f,0.43750000f,0.16939997f,-0.45259999f,0.59170000f,0.59719998f,1.53139996f,-0.23710005f,1.42589998f,0.46479998f,1.13819996f,-0.34180002f,0.66350000f,-0.26880000f,0.75180000f,-0.09620002f,-0.46450000f,0.63109999f,-0.35990001f,0.25720003f,0.09000000f,0.53699999f,0.10629999f,0.62630002f,-0.20360000f,0.69899999f,-0.08310000f,-0.50559998f,0.43890003f,0.56870004f,1.23810000f,0.68510004f,-1.08600006f,-1.85710001f,1.18210000f,1.09930002f,-0.40709998f,-1.49020001f,-0.41890003f,-0.16110001f,0.56909999f,-0.80379998f,0.93630001f,0.04840001f,1.06439999f,-1.09089999f,0.98250001f,1.43519999f,0.58509999f,0.27999998f,0.96569995f,-0.50360000f,0.37000002f,1.52109999f,0.14280000f,1.59909997f,-0.04699998f,0.06770002f,0.40109999f,0.27709995f,0.12039999f,0.14070000f,-0.08370001f,0.34999998f,-0.15600005f,0.29789999f,0.01449999f,-1.12739997f,-1.37599995f,0.02490003f,0.32449998f,-0.88220003f,-0.03289998f,0.68690000f,-0.19259999f,0.55710003f,0.62139998f,0.35290001f,0.55109997f,0.44739996f,-0.27040001f,0.91950001f,1.32889998f,-0.12130001f,-0.44910002f,0.97050001f,-0.60320004f,0.46620002f,0.18040000f,-0.22700003f,-0.34510000f,-0.55129996f,-0.30569999f,0.01779999f,-0.12700000f,-1.00530002f,-0.01250001f,-0.90280003f,-0.21400000f,-1.14180000f,-0.12319999f,-0.55550002f,0.32630004f,-0.35150002f,0.35099998f,0.06300001f,0.72950004f,-0.03269999f,0.99660001f,0.53310002f,-0.32760004f,0.10779998f,0.23590000f,0.41159999f,-0.68670000f,0.32599998f,0.18600001f,1.21079997f,-0.07739999f,0.30020004f,-0.48680002f,-1.64559999f,0.22240000f,-1.24020000f,-0.39190007f,-0.96419996f,0.21290000f,0.40830002f,-0.24200005f,1.48490007f,0.06789997f,0.03029999f,-0.05260002f,1.19520004f,1.93080004f,-1.24340007f,0.95790001f,1.16180001f,0.48820001f,-0.94280001f,1.06220000f,-0.74470004f,0.79780002f,0.18450005f,0.80930002f,0.30700000f,-0.16290000f,-0.22729998f,0.12470001f,-0.76260000f,0.72169998f,0.06020001f,-0.05620000f,-1.03440001f,-0.36230000f,0.03399998f,0.03150000f,0.31860000f,-1.17070001f,1.64040002f,1.13190002f,-1.12250003f,-0.87960001f,-0.30489996f,0.47299998f,1.40820001f,0.89409996f,-0.20980005f,1.38129998f,-0.83970000f,-0.51690000f,1.03980001f,0.69520000f,0.58240001f,0.17600001f,-0.19290001f,0.52760000f,-1.33049996f,1.28399999f,0.89560002f,-0.01499999f,-0.54880001f,-0.03180001f,-0.55970003f,-0.40600002f,0.18000003f,0.16840001f,0.66559999f,0.51959999f,0.61119999f,-0.42710001f,0.75200000f,-0.46909996f,0.37540001f,1.15849997f,-1.06299995f,0.34880002f,-0.90280005f,-0.44930002f,1.76020006f,0.56120004f,-1.30620004f,-0.30159999f,-1.75920005f,-0.72120001f,-0.76830005f,-0.06610005f,-2.07440005f,-0.07500000f,0.84570004f,-0.29350000f,-1.23760003f,0.04540001f,1.33880002f,-0.88030002f,0.66550004f,-0.03000003f,0.48399999f,-0.05770003f,0.48440000f,-0.19740001f,-0.17960002f,0.20470002f,0.42580001f,-1.05140002f,-0.33240001f,0.73210001f,-0.11059998f,1.10699999f,-0.01440001f,-0.18139996f,-0.21299998f,0.04060000f,0.02839998f,0.89070002f,-0.52510005f,-0.45510001f,-1.17410003f,-1.64210004f,0.00210005f,-0.60170002f,-1.96320005f,-1.17159999f,-0.01180000f,-0.73530002f,0.20680003f,-0.52460002f,-0.02510002f,-1.12540002f,0.14610001f,-0.20710000f,0.58959995f,0.41040003f,1.26760004f,-0.25920000f,-0.18050003f,0.54629999f,0.80379998f,-0.56200000f,0.27659997f,0.16750003f,-0.96160001f,1.26620000f,-1.72379998f,-0.08680001f,-0.25360000f,0.58110001f,0.34540000f,-0.79949999f,-1.30110002f,-1.05770000f,0.55230002f,1.37399999f,-0.10230001f,1.20200005f,-1.08110005f,-0.98339999f,-1.61720004f,-2.01370002f,0.82210002f,-1.22599997f,0.31350003f,-0.40459999f,-0.30599999f,0.52010002f,0.34280001f,-1.03870002f,0.31929997f,-1.33890001f,0.23840000f,-0.36850000f,-0.11780001f,-0.01789998f,0.14099997f,0.92179998f,1.61599999f,-0.87370000f,0.75479999f,-0.14380001f,-0.12860002f,0.31390003f,-0.68580000f,1.23730000f,0.89160000f,-0.47130002f,0.58120001f,-0.11410004f,1.24500005f,2.47850002f,0.00059996f,0.50099998f,0.45070002f,-0.28010002f,-0.53360004f,-0.11890002f,0.27069998f,-0.16410001f,-1.36990000f,1.13269999f,0.21390002f,0.63530001f,-0.62869999f,-0.58340003f,-0.47200001f,0.36870000f,1.19720001f,-0.44309998f,-0.86170000f,0.42290000f,0.59640003f,0.32899999f,1.39519996f,-1.53440000f,0.90359998f,0.55320000f,-0.62539999f,0.14060000f,-0.78800004f,-0.31719995f,-0.13920001f,-0.84280004f,1.07390002f,0.25659998f,1.03010005f,-0.13959999f,-0.94609999f,0.32270001f,0.59700000f,0.70449999f,-0.66359998f,-0.14269999f,2.12590002f,-0.85279995f,-0.86659996f,-0.27199999f,0.19549998f,0.39169998f,0.44349998f,0.09859999f,0.09190003f,1.02029994f,-0.15269998f,0.50459997f,-0.22399999f,-0.03930001f,0.50950004f,0.40600000f,0.02019999f,-0.57509999f,-1.13130000f,-0.59100001f,0.77710005f,-0.18150001f,1.46460004f,-0.38580000f,-0.07909995f,0.22019998f,0.51090000f,0.78390001f,-0.29040002f,-1.63909999f,0.44200001f,0.17760001f,-0.25709998f,1.11610000f,-1.88249999f,-1.09650001f,0.22999996f,-0.39960003f,-0.57810001f,-0.46079999f,0.00740000f,-1.05429995f,0.59850001f,-1.09610000f,-0.07810001f,-0.43420001f,-0.13380001f,0.10210000f,0.95219999f,-1.00360003f,-0.22290001f,-0.74810002f,0.96550001f,-0.93950000f,-1.54889999f,-0.31690002f,0.76020000f,-0.87069996f,-0.05109993f,0.00929996f,0.37249994f,-1.53640002f,-0.50040000f,0.27170001f,-1.81129997f,-0.98340000f,0.76259994f,-0.60949996f,-0.48119995f,0.15610001f,-0.03190004f,-0.13000001f,0.67270000f,-0.73440000f,1.36260000f,-0.59200001f,0.04169998f,-0.59009998f,1.98849997f,-1.03579997f,-0.54879998f,-1.44639994f,1.31159991f,-0.86069998f,0.32660006f,0.35299999f,-1.10950004f,0.50039999f,0.64980000f,1.08149996f,0.81199995f,1.01020000f,-0.48070001f,0.87219997f,-0.59760007f,1.14059995f,1.19189997f,-0.99139999f,1.64049997f,1.08709999f,1.26119997f,1.76909997f,0.33659999f,-1.74439993f,1.38339996f,0.68409996f,1.98489995f,0.45089998f,0.29350003f,-0.05729999f,-0.25949996f,0.28459998f,-0.30480000f,0.26169997f,-0.71289998f,0.11280003f,-0.71209997f,0.49439997f,-0.33369996f,0.18259995f,-1.05679997f,-0.52939998f,-0.93209999f,0.66029997f,0.40409998f,-0.26669998f,0.99890005f,0.82460000f,0.01759994f,0.61730001f,-1.10310005f,0.41149996f,0.42379997f,-0.69949999f,0.53229996f,-0.34830005f,0.51340001f,1.48620002f,-0.79419998f,-0.50940003f,0.30119998f,-0.54749999f,1.75119997f,1.17190001f,-0.18349999f,0.13340001f,0.49580000f,0.92109994f,-0.29159997f,-0.25770000f,-0.16030005f,0.76690000f,-0.69429999f,1.18220001f,0.62380002f,-0.13290002f,-1.18029998f,0.90060000f,0.92690003f,-0.41730000f,0.15649999f,-0.37810000f,-0.63620001f,-0.11809999f,-0.70320003f,-0.56679998f,0.45540003f,-0.42169998f,-1.49119997f,1.90049997f,-0.32220003f,-0.10840001f,-1.29089998f,-1.93499999f,-0.16979999f,0.73469998f,-0.02899999f,0.42850001f,-1.39019993f,0.13760001f,0.85749993f,1.39129993f,0.34659996f,-0.67919997f,-0.01070000f,-0.36049996f,-0.52510000f,1.07329999f,0.42520001f,0.20230001f,-0.48949999f,0.70589997f,1.56689997f,0.95310001f,-0.12860002f,-0.64419997f,-0.39439996f,0.06239996f,0.72739999f,0.16779999f,0.65590000f,-0.37560000f,-0.39430003f,-0.12680000f,-0.52840001f,1.20259994f,-0.19269999f,0.13520001f,0.24009998f,0.43750000f,0.07109998f,-0.32089999f,-0.51969998f,-0.16699999f,-0.47059999f,-1.73869998f,-0.18250000f,1.79609994f,0.10870000f,-0.00389997f,1.01069997f,-0.34970000f,-0.15279999f,-0.44409997f,0.22569999f,-0.75129997f,0.00779999f,-0.20449999f,-0.26040000f,0.50699999f,0.76960001f,0.46700000f,1.11089998f,1.12159998f,-0.27650004f,0.65220000f,-0.89300005f,-0.88570000f,-0.68629999f,-0.54790002f,0.23360000f,1.03809997f,-0.52799995f,-0.76379998f,-0.48460000f,-0.78599999f,-0.13799997f,-0.15220002f,-1.96179996f,0.42829998f,-1.31319996f,0.70800000f,0.84720000f,-1.34780002f,0.39190004f,1.05910000f,-0.09590001f,-0.65990003f,0.91520004f,1.15699998f,0.53940002f,1.44550003f,0.77350001f,0.43150006f,-1.00850001f,0.10489999f,0.16129998f,0.50640000f,-1.21379999f,0.62249998f,-0.14059999f,1.27669999f,0.26159999f,0.03610002f,-1.00930003f,-0.86009999f,1.31380000f,1.28230000f,0.25460001f,-0.69120001f,0.73580003f,0.71859998f,-0.19939996f,-0.17440000f,0.96540001f,-1.14299999f,1.21240001f,-0.46360001f,-0.38860001f,1.49670008f,-0.04089998f,0.83190006f,1.39240005f,1.02920004f,-0.91529997f,-0.01729996f,1.12619997f,1.31519994f,-0.05039994f,1.29500002f,-1.28070006f,-0.26339996f,0.34200002f,-0.43089997f,-1.27670003f,-0.00449996f,0.50560003f,-0.01600002f,-0.95839997f,1.22849999f,0.37029995f,-0.46399998f,-0.11249994f,-0.55790003f,0.89219997f,-0.21830000f,1.33560000f,-0.69940001f,-0.10040000f,1.17379995f,1.51200000f,-1.03789996f,0.64979999f,0.02209997f,1.05520000f,-0.15500001f,-0.71370001f,-0.65370005f,-1.22550000f,0.25929998f,-1.30080002f,-1.69499998f,-0.61680001f,-0.69750006f,-1.66760000f,-1.26040003f,-0.20689999f,0.80899999f,0.90690002f,0.66899998f,1.44499996f,-0.58549997f,-0.59779997f,-0.55410002f,0.62869997f,0.39809998f,0.92749998f,0.14800002f,0.07020001f,0.40519996f,-1.24739999f,0.34160002f,0.14419997f,-0.40219997f,0.01819998f,1.28669996f,-1.17359997f,0.31960002f,-1.00040000f,0.96340001f,0.95539999f,0.67900004f,-0.65230002f,-0.90620001f,-0.77330003f,-0.10999998f,0.50120002f,0.64900001f,-1.13300003f,-2.10780003f,-1.47840002f,-0.53960003f,0.72260004f,-0.59700003f,0.60359997f,-0.62020002f,0.62030004f,0.16190002f,-0.05040006f,-1.13750001f,0.04840001f,-0.57179999f,1.36000003f,0.12250001f,-1.26580001f,-0.43620000f,-1.43299997f,0.94840001f,0.87839999f,-0.58409998f,-0.15820004f,-0.23239999f,-0.86340004f,0.92400000f,-0.60840001f,0.57000001f,-0.00499998f,-0.75829997f,-1.11380003f,-0.39230000f,1.51200007f,0.54820003f,0.99150003f,0.00829998f,-0.11960002f,-0.36610000f,1.73459999f,0.92690003f,-1.49240003f,-0.65559999f,-0.03950001f,-0.59069997f,-1.49930002f,0.29729999f,0.13219999f,0.37560001f,0.26850004f,0.09040000f,-0.54869999f,-0.02680000f,0.84050001f,-0.23159997f,1.72380000f,0.06540000f,0.03199999f,0.14219997f,-1.26680001f,-0.50009999f,-0.20420002f,0.03320001f,-0.13879998f,-1.04839999f,-0.49319998f,-1.22650001f,-0.47940003f,-0.78430001f,-0.02849997f,0.98330001f,-0.66270000f,-0.25629999f,0.21729999f,0.73580000f,0.68310003f,-0.30060000f,1.08760005f,-0.21189999f,-0.04979997f,0.02100001f,0.65409999f,-0.29040000f,-0.15490000f,-0.23230000f,-0.33600000f,-0.04499999f,-1.07730001f,0.39160000f,-0.14030001f,-0.18429998f,0.43379998f,0.09640000f,0.04940000f,-0.08650001f,0.83399998f,0.17120000f,1.15479998f,-0.37519999f,-0.48399999f,0.68439997f,-0.03499997f,0.49010000f,-1.09930002f,-0.08230001f,-0.39550004f,-0.59909999f,-0.87279998f,-1.95440001f,0.18060002f,-0.21280003f,0.71560005f,1.35480000f,-1.00110006f,0.88289997f,-0.22420002f,0.44390000f,0.30769997f,-0.79139996f,0.48469998f,-0.41229993f,-0.11570002f,0.81200000f,0.36220000f,0.23210001f,1.32919997f,-0.72669996f,-0.27339998f,0.14110001f,0.39970003f,0.79659997f,-0.13420006f,0.32069999f,-0.47690002f,0.74469999f,0.05159998f,0.19320001f,-0.37930000f,-0.83969998f,-0.07489996f,1.56850002f,0.48559994f,0.06989997f,0.66249997f,-1.21149999f,1.28870001f,0.91020002f,0.41909999f,-0.52830000f,0.56100001f,-0.12189993f,0.50909999f,1.21839997f,0.45069997f,0.57049998f,-0.20239997f,-0.47729997f,-0.46389999f,0.09499999f,-0.88649999f,-0.03769999f,0.66630001f,-0.31510000f,-1.21770003f,0.29660000f,-0.65470000f,0.23020000f,0.72629999f,-0.91970000f,-0.19600001f,-0.24450002f,-0.15809998f,-0.23460000f,-0.22080000f,-0.33640000f,1.34639999f,0.58420003f,1.36859995f,0.51220000f,-0.59919999f,-0.02680000f,-0.94039996f,-1.24719997f,0.53150000f,1.44149999f,0.21199998f,0.37220000f,-0.12359998f,0.12180000f,-0.05860002f,-0.60869997f,-0.25920000f,-1.39739994f,0.35390002f,-0.20710001f,0.52280000f,-0.20910003f,0.20219999f,0.16819999f,1.14730000f,0.33570000f,0.92340001f,0.22940000f,0.66780002f,0.61709999f,0.66920002f,-0.40539999f,-1.04980001f,0.18219997f,0.22150000f,1.38279999f,-0.30759999f,-0.41509998f,-0.76509998f,-0.22190000f,-0.45559999f,0.47910000f,-1.27550003f,-0.49740005f,0.49919998f,0.67000000f,1.18879997f,0.30929998f,-0.23970001f,-0.10049998f,-0.40230001f,0.52240000f,-0.33079998f,1.44689995f,-0.52180001f,0.95089999f,1.24500002f,0.53089997f,-0.19279999f,0.73010000f,0.38969999f,0.71200001f,-0.80550006f,-0.72159999f,-0.76050000f,-0.44530003f,0.61370002f,-0.15519998f,-0.66450000f,-0.84360000f,-0.35180001f,1.00710000f,-0.05280002f,-1.84689999f,-0.21800000f,-0.29600004f,-0.35829996f,1.99510002f,-1.10219999f,0.07619994f,0.00909996f,-0.40229998f,0.19020000f,-0.26169999f,-0.64380001f,0.19320003f,-1.18889997f,0.28730001f,0.13860004f,0.97979993f,0.05250000f,1.04279996f,1.64659994f,-0.98069996f,0.40349999f,0.02699999f,1.32020002f,-0.36099996f,-0.67799997f,0.56809999f,0.86569997f,0.39420000f,0.98640002f,0.35240001f,-0.76810005f,0.42059999f,-0.65660003f,0.88960004f,-1.38629995f,-1.12350002f,0.32820000f,1.12749998f,0.56150001f,0.86750000f,-0.77289998f,-1.41409999f,0.37290000f,-0.66910002f,1.15300002f,-0.76060002f,-1.45470000f,-0.10119999f,0.65309998f,1.21069995f,0.13670002f,0.09469997f,-0.31450003f,-0.02990000f,-0.63829997f,0.87119996f,-0.76879997f,0.53090000f,0.27259999f,0.52990000f,0.35439999f,-0.67099998f,-1.63069999f,-1.23949998f,-0.29619999f,-0.73619995f,-1.52969999f,-0.29990000f,0.04950001f,0.45380002f,0.53870001f,0.95769998f,-1.29589998f,-0.63900002f,0.22580000f,0.34320003f,-0.82499994f,-1.27510003f,1.14039999f,0.73370005f,0.94779997f,0.68689999f,-1.18179996f,0.74839997f,-0.72199999f,0.49639999f,1.95369999f,-1.07409998f,-0.17690004f,-0.88269994f,0.96479996f,-0.69029998f,-0.03899999f,-0.27669995f,0.21670005f,-1.22449997f,-0.92589997f,-0.93819998f,-0.02769998f,-0.85349999f,-0.53750000f,-1.26580002f,-0.87680001f,-0.16290002f,0.54810001f,-0.58279997f,0.53579998f,0.49850000f,1.92399998f,-0.75650000f,0.46799995f,-0.01270002f,-1.11600000f,-0.39480000f,0.08739998f,-0.74539999f,-0.41240001f,1.64729997f,-0.13830006f,0.30180001f,-1.85290003f,-1.07099998f,-0.98640001f,-1.27570002f,-0.09650000f,0.23349996f,-0.26850001f,-0.99230004f,-0.17910002f,0.81029999f,1.29840004f,-0.96410000f,0.93349997f,-1.43990000f,-0.46259999f,0.26679999f,0.64650001f,0.58909999f,-0.52330001f,0.59140000f,0.57070003f,-1.02950000f,-0.59680004f,-0.56179997f,0.13179999f,0.73970000f,-0.03760001f,1.13199999f,-0.94780001f,-0.06609999f,-0.25419998f,0.42729999f,0.68020001f,-0.40420004f,-0.40690000f,-0.58570003f,-0.68360000f,-0.25200006f,0.87720003f,1.12409998f,1.39440003f,0.88490003f,-0.71020003f,0.28180002f,-0.32770000f,0.00079998f,0.54820003f,0.78199998f,0.41920000f,0.79699998f,-0.89910001f,0.93410002f,-0.86949999f,0.15599999f,0.98130002f,-0.14449998f,-0.62080002f,0.73720000f,-1.22340000f,0.45379999f,-0.27439999f,0.34570000f,1.59900000f,-0.84380000f,-0.26519999f,0.01119998f,0.50700001f,-0.39039998f,-0.34379998f,0.19169999f,-0.58800001f,-0.19779998f,0.28160000f,0.11960002f,-0.24630003f,-0.36549996f,0.19620002f,-0.92749995f,-0.67610002f,-0.03809997f,-1.56940004f,-0.72769998f,-0.16640000f,-0.69759998f,-0.23090001f,-0.65699999f,0.56340000f,-1.25190000f,-0.58680004f,-0.62629999f,1.20720003f,-0.73700002f,0.88270000f,-0.04899997f,0.90579997f,0.04949999f,0.27279998f,-0.33020000f,-0.42140001f,-0.25139999f,0.21440001f,-0.13190002f,-0.79180002f,0.39010001f,-0.23780000f,0.21719994f,-0.29099998f,-1.12490001f,1.36140005f,-0.63820007f,1.54220004f,1.41970007f,0.00029997f,-0.33789996f,-1.06780000f,-0.31379998f,0.55790004f,-0.10620001f,-0.88570002f,-0.17320003f,-1.08800003f,1.62030002f,0.82520002f,0.22820003f,0.10239997f,-1.13589998f,0.23290002f,-0.31369997f,-0.47780000f,-0.45289996f,-0.42980001f,1.01609997f,-1.01659997f,-0.17240000f,-0.98799999f,-1.39410000f,0.19679998f,-0.28909997f,0.96979998f,0.71159997f,0.10520000f,0.98729999f,1.47440002f,0.20560000f,-0.16270000f,0.28030003f,-2.00580010f,-0.86880001f,0.19350002f,-0.06889996f,0.08149999f,-1.23050004f,-0.23590000f,0.28030000f,-1.70530004f,0.55580001f,1.33279999f,-0.89960000f,0.98410003f,-1.08659998f,-0.83070003f,-0.52659999f,-0.28070001f,0.35000000f,1.28620001f,0.00270000f,0.68480003f,-0.64060000f,-1.22240003f,-0.10969999f,1.04559997f,0.16530004f,0.43979999f,0.26529998f,-1.57539997f,0.72760001f,-1.68060002f,-0.99270003f,-0.01950003f,-0.37280004f,1.12630003f,-0.29199998f,-0.20070002f,0.50460002f,1.90020002f,0.98849993f,-0.25919999f,0.35119997f,-0.43280000f,0.01529997f,0.31319999f,0.26540000f,-1.06140002f,0.23930002f,0.48410007f,0.41999998f,-1.48210002f,1.26089998f,0.71560003f,0.78290000f,0.32859999f,0.82940000f,-0.61899999f,-0.41429997f,0.03460002f,-0.38920001f,0.33420000f,0.28379999f,0.01520000f,-0.22669998f,-0.52479999f,0.27859997f,0.21880002f,-1.48060000f,1.90150003f,1.71310000f,0.99890003f,0.49450002f,2.14470004f,1.21539998f,0.54240004f,0.51740005f,0.36940004f,0.37970004f,0.26449997f,1.44829994f,-0.67549999f,0.83740000f,-0.60270002f,0.37420004f,0.57559998f,1.13609998f,-0.88699997f,1.00189995f,0.98740000f,0.77569997f,-0.73749997f,0.03139998f,0.69749998f,0.18210001f,-0.36770001f,-0.64880000f,-1.58669999f,0.11089998f,1.65150002f,-0.21719999f,0.56620002f,-0.22110000f,0.32950000f,-0.46619998f,-0.00059997f,-0.48989998f,-0.46430000f,-0.52320000f,1.69009994f,0.79420004f,-0.34589997f,0.37530000f,-1.11419999f,-1.66969998f,-0.75209999f,-1.12389997f,-1.07680000f,-0.39829997f,-0.13120001f,-0.31199999f,1.50549999f,-0.87199998f,-0.75069999f,-1.18319995f,0.41599997f,-0.55989998f,-0.33130001f,0.33840001f,0.17299999f,0.18559999f,-0.55800002f,0.82870000f,0.40179998f,1.02470000f,0.39309995f,-0.57049996f,-0.47879996f,0.40939999f,0.48289999f,-1.00319997f,0.16690002f,1.27769995f,1.58569999f,0.29360005f,1.45339998f,-0.56500001f,-0.46399995f,-1.08329995f,0.34110003f,1.83789998f,1.00879998f,-0.25799997f,-0.82399998f,0.47539997f,1.15319999f,-0.20650000f,-0.65230002f,-0.76999996f,-1.38949999f,-0.80909994f,0.33389998f,0.79619997f,0.12419999f,-0.53910001f,0.02509999f,0.41579995f,-0.49760006f,0.32349999f,-0.61480003f,1.04240001f,-0.47190001f,-0.35579999f,-0.85070002f,0.45299996f,-0.20750005f,-0.09850001f,0.14660002f,0.75170000f,1.02299997f,-0.70199999f,0.97370004f,-0.16199998f,0.80989997f,1.21859996f,0.25679998f,-0.54110003f,0.63450000f,-0.76239999f,-0.22519998f,0.21669995f,0.22140002f,-0.29350001f,-1.32359997f,0.77569997f,-0.70509999f,0.09589998f,-0.00799999f,0.44269996f,-1.32929997f,0.56200001f,0.23270001f,0.30970000f,0.51279999f,-0.22409999f,-0.68610000f,-1.06149998f,-0.41769997f,-0.39500001f,-0.36100002f,0.47929998f,0.60119998f,1.15089998f,0.17229997f,0.50320000f,-0.77139998f,-1.00100000f,-0.69339999f,-0.54350000f,-0.20799998f,1.15360000f,0.51009996f,-0.93330000f,-0.85509995f,1.20969998f,0.50279998f,0.69269999f,-0.26169999f,-0.04679998f,0.29019998f,-0.45969997f,0.65729998f,-0.01470001f,0.40570000f,0.00369999f,-1.47169997f,0.43490002f,-0.26920000f,-0.08580000f,0.46770001f,0.15050000f,-0.60780002f,0.71660000f,0.35350003f,0.23740000f,1.24220001f,-0.46089999f,0.52840001f,0.28210001f,0.04289999f,-0.17440001f,-0.41709998f,0.83979999f,0.71939998f,-0.55490000f,0.94699997f,1.49820002f,-0.80069999f,-0.68850002f,0.22910003f,0.13820001f,-0.01360000f,0.04020000f,-0.49549999f,0.75359997f,0.39960001f,0.68939997f,-0.22630001f,-0.24289999f,0.50779998f,-1.31029994f,1.10469998f,0.53279997f,-0.00590002f,1.15240000f,0.27919995f,1.35210001f,0.68790001f,-0.06019998f,-0.72750001f,0.62930000f,0.25139998f,0.65880000f,0.74149999f,0.21910005f,1.94769996f,0.28140000f,1.43100002f,-0.45909997f,0.11010001f,0.76940001f,0.99049999f,-0.03020000f,1.21999999f,-0.08339998f,-0.72759996f,-0.83419999f,-0.39929999f,-0.62599996f,-1.32819998f,0.03230002f,-1.27320000f,0.03120001f,1.06360000f,-0.13760000f,-0.61880001f,-0.49729998f,-1.52089997f,-0.84570000f,-0.44959998f,-1.00859998f,-1.67070000f,-0.49690001f,0.34320001f,-0.30489999f,-0.20789998f,-0.78020001f,-0.32499996f,-0.76420003f,-0.26200003f,0.04180001f,-0.66040002f,0.49000002f,-0.26720003f,-0.86540000f,-2.04080001f,0.48720000f,-0.09780000f,-1.22309997f,-1.53100001f,1.47929996f,-0.19779997f,0.74660001f,0.43380000f,0.02639995f,0.90760005f,0.13570000f,-1.14249999f,0.25470000f,0.34049996f,1.15669995f,0.60210002f,0.48250003f,0.86400003f,-0.06930002f,-0.80960000f,0.67390000f,-0.77160002f,0.76770001f,1.27550004f,0.30569996f,-0.54610000f,0.40260000f,-1.01280001f,-0.34550000f,-0.25460002f,0.65979999f,0.29720000f,-0.17340000f,-0.06359997f,-0.09680002f,-0.41900000f,0.69709997f,1.93260000f,-1.04799996f,0.72060000f,0.24539997f,0.12579999f,-1.09040004f,0.80240001f,0.72479996f,-2.43030006f,-0.96669999f,-1.34570003f,-0.80780010f,1.31160004f,-0.01860004f,0.67560001f,1.40959999f,-2.44130009f,0.51789997f,0.30769997f,0.44150002f,1.41550006f,-0.91640001f,-0.04110002f,0.35820000f,-1.74759998f,1.61560001f,1.28169999f,-0.27500000f,0.98880003f,0.85989998f,-0.44100000f,-0.97209995f,-0.08240005f,1.23330000f,0.16539999f,0.87490002f,0.35740000f,-0.25870002f,-0.95920003f,-0.93239997f,0.11939996f,-0.44190003f,0.88590006f,1.21480003f,-1.62060002f,-1.58730001f,0.65700001f,-0.41310004f,-0.40430001f,-0.79440005f,0.67550008f,0.08460002f,-0.02619998f,0.86770002f,0.33369997f,0.17240003f,0.14490002f,-0.01949999f,-0.17760000f,0.91689997f,0.31779998f,0.90520003f,-0.10270004f,0.29300001f,0.44729999f,0.37000000f,-0.52240000f,-0.69140000f,-0.16220000f,1.30029999f,-2.03159998f,0.28569999f,-0.21759995f,-0.23879998f,-1.44799999f,0.39819998f,-1.40280003f,0.43800000f,-1.50940006f,-0.93939998f,0.26889998f,-0.31520000f,1.08080004f,0.28420000f,0.82780002f,1.41600001f,-1.00620002f,-0.97450001f,1.53690003f,-0.03560000f,0.94990002f,-1.29020000f,-0.81029999f,-0.11000001f,-0.80480000f,0.82810000f,0.58860001f,0.05150001f,0.08459999f,-0.39810002f,-1.00560000f,-1.08199998f,0.20379997f,0.37070001f,0.41340000f,0.13470000f,0.03480001f,-0.11940002f,-0.05100001f,-0.85139999f,-0.38459999f,1.10689999f,-0.01199999f,-0.22290006f,0.03630001f,-0.24700000f,0.64590001f,0.54950002f,-1.38090004f,-1.48480000f,-0.97960001f,0.03660000f,-0.17000003f,0.80809998f,-0.84730004f,0.61720001f,-0.11320001f,0.17050000f,0.24869999f,-0.26929999f,0.55630001f,-0.75440002f,0.90040001f,0.02970001f,-0.57400001f,-0.38980000f,0.47610004f,-0.35489999f,-0.23299999f,0.16919999f,-0.20420001f,-0.82389998f,-0.94960001f,1.24590000f,0.57380000f,-0.40300000f,2.09679996f,-0.23259997f,1.04419997f,0.25159998f,-1.50000002f,-0.53310006f,-0.79970005f,-0.99710010f,0.26720000f,-0.06590002f,-1.12650004f,-0.15870001f,-1.18710004f,-0.84350007f,1.48820004f,0.62939999f,0.63180001f,0.35839996f,-0.11099999f,0.50149997f,-0.24280001f,0.65670002f,0.91430002f,-0.55300004f,0.09520000f,0.36580001f,-1.10250003f,0.49849997f,-0.17820002f,0.70970001f,-0.78620001f,0.73560002f,0.34520002f,-0.72700000f,-0.48240003f,0.85800002f,0.14980000f,0.58110000f,-0.31199998f,-0.03969999f,1.40600004f,0.76710000f,0.25880002f,0.38209996f,1.70240004f,0.97320000f,1.15110004f,0.10120003f,-0.03649995f,1.05260009f,-0.31199998f,-1.11669992f,0.52689998f,-0.34410000f,-0.55389999f,-0.60869996f,1.44049998f,-1.82949993f,0.55950000f,-1.47410000f,-0.08600002f,-0.21489997f,0.59130000f,0.59790001f,0.09170004f,0.81090001f,0.26189997f,-0.24739999f,0.33660004f,0.52179997f,0.45980001f,-0.74830001f,0.91960004f,-0.84090001f,-0.54589999f,0.28780005f,0.79959995f,0.28999995f,0.05879999f,-1.39749998f,-0.11209998f,1.26050002f,-0.28760007f,-0.37680004f,-1.74909996f,-0.42049997f,0.02749998f,0.73029998f,0.75829998f,0.56789999f,-0.31730002f,-0.97479994f,-0.57459998f,0.71919996f,0.67490000f,-0.77839998f,0.44029999f,-0.82209998f,1.75090000f,0.24370001f,-0.52520000f,0.22439998f,0.63870001f,1.25670001f,0.63509999f,1.13650002f,-0.69760001f,-0.33769998f,-0.21559995f,-0.28130001f,0.90019999f,-2.23500002f,1.12270000f,0.57790004f,0.50880000f,-0.36090001f,0.55140002f,1.15339999f,0.58339996f,-0.81710000f,0.34159998f,0.91679999f,-1.55609995f,-0.91389996f,0.47070000f,-0.87900000f,-1.26479999f,0.65379999f,-1.37709997f,1.75459995f,0.49359999f,-0.45999998f,0.30849997f,-0.92629997f,-1.03060000f,0.23199998f,0.22650000f,-0.38629999f,0.48390002f,0.35319999f,0.07550001f,0.87770000f,1.62759997f,-0.03199998f,-0.08209999f,0.55810000f,1.57100001f,-0.36649999f,0.24149998f,-0.12369999f,0.05540004f,0.50330004f,1.34369994f,-0.70950000f,-0.57109994f,0.09960001f,0.76210002f,0.22860005f,0.39730003f,-0.32090001f,-0.10150002f,-1.07079994f,0.35610001f,-0.37149999f,0.55159997f,-0.66619997f,-1.35719999f,-0.53499996f,1.46819996f,-0.46419999f,-0.31210000f,-0.45720001f,-0.24260002f,-1.10250001f,0.03380000f,-0.22230004f,0.40710000f,-0.13369997f,-1.59299998f,-0.22469999f,0.08489997f,-0.47789998f,-0.27939997f,0.97119999f,-0.63180003f,-1.37930003f,-0.05579996f,0.95750005f,-1.00949998f,-2.28459998f,0.77039997f,0.95519995f,-0.76059995f,0.30869999f,-0.57639998f,-0.39550000f,0.86949998f,-1.52139996f,0.72140001f,-0.77920002f,-0.71339999f,0.00730001f,0.18089999f,0.37019998f,-0.90889997f,0.57369999f,1.12699996f,0.08580004f,-0.96140002f,-0.73330001f,-0.74100002f,0.68199999f,0.04719999f,0.24000002f,-1.51310000f,-0.83369999f,-0.77059995f,0.55859996f,-0.10880007f,-1.41120000f,-0.52560000f,-0.31330003f,0.83300003f,1.36460001f,-0.04230001f,-1.24430000f,0.77509998f,1.08519998f,1.10829993f,0.06850001f,1.90549999f,0.47760006f,0.58140000f,0.34549999f,0.31950003f,0.93659994f,-1.22499999f,0.69739998f,0.67250002f,-0.61280001f,0.51309996f,-0.48290000f,-0.49499992f,-0.78199998f,0.20020004f,-0.34340000f,0.09989999f,0.51529998f,0.27890000f,-0.25730001f,1.24150006f,0.00220000f,-0.64400003f,0.30009999f,-0.48960002f,-0.11200000f,-1.18429998f,-1.28249998f,-0.15379998f,0.10989999f,0.17469998f,1.25409996f,-1.41949999f,-0.79529998f,0.26969997f,-0.92670002f,0.26870000f,-0.95039996f,0.97669995f,-0.34499999f,-0.58069996f,1.11759993f,0.41650002f,0.07059995f,-0.01150005f,0.15560001f,0.35940003f,0.45439999f,-0.09709999f,-0.54990000f,-1.33870003f,0.07420001f,-0.02760002f,0.64739999f,1.00689999f,-0.36849999f,0.12280001f,-0.54650000f,0.49590001f,-0.99599996f,-0.14419996f,0.54599998f,0.45559998f,-0.28389999f,1.78419999f,-0.05910002f,0.89260000f,0.55809997f,1.29680001f,-1.40129998f,-0.05080001f,0.20519995f,-1.50120000f,0.71900002f,-2.26570008f,-1.25940000f,-0.44360002f,-0.85010005f,1.25420004f,1.48580004f,-1.39950003f,-0.91139998f,1.86640007f,2.21910008f,-0.96910005f,-0.51260002f,1.27690000f,-1.53160003f,-1.03250000f,0.58230000f,0.47869999f,-0.00710000f,-0.10670001f,-0.49619999f,-0.89480001f,-0.02609999f,0.03900004f,-0.95109999f,0.03179997f,0.93040003f,0.73360001f,0.72279998f,-0.65739999f,-1.18610000f,1.67460002f,0.44790000f,1.37500000f,-1.17670002f,1.01240002f,-1.17330001f,-0.38500001f,0.65079998f,-0.05570000f,-0.43310002f,-0.71180007f,-1.10170003f,-1.45640005f,-1.70100002f,0.72720005f,1.60489999f,1.59220001f,-0.26080003f,0.56870003f,0.52080000f,-0.14500003f,-0.06630003f,0.82130001f,-0.68820001f,-0.10899998f,0.11889998f,0.24329999f,0.75979999f,-1.59010000f,1.11640000f,0.03280001f,0.09359999f,-0.82699999f,0.20750001f,-1.00160001f,-0.22269996f,0.16480003f,1.24769998f,0.39040001f,-0.76540000f,0.16659996f,-0.09019998f,-0.20779998f,0.09589998f,0.19589997f,1.31960000f,-2.31820004f,-1.23190003f,0.82969999f,0.81339996f,-1.59650006f,0.20410001f,-1.34210010f,-0.30590000f,-0.39100000f,0.65970001f,0.43030003f,-0.34010002f,0.53600000f,-0.61940002f,-0.86140000f,0.50590002f,1.18190005f,-1.14640000f,0.08900002f,0.64789999f,0.94059999f,-0.02440001f,0.46659998f,-0.50669998f,0.40919999f,1.43549999f,1.22459996f,-1.04559997f,0.51399994f,0.63400001f,1.57239999f,0.98630000f,0.28300005f,0.26640000f,0.81860003f,2.07400005f,0.67420000f,-0.88239998f,0.46550003f,0.03479997f,1.39460000f,0.25719998f,0.13199999f,0.46830000f,-1.05160003f,0.57840002f,0.44580003f,0.16810003f,-1.68650001f,0.24199997f,0.55889998f,0.87339999f,-0.58699999f,0.61700001f,0.59410002f,-0.74859999f,1.18340001f,0.39719998f,0.59279999f,-0.93590000f,-0.07179995f,0.66289997f,-1.43779997f,-0.04749999f,-0.38619999f,-0.81969998f,0.66499997f,-0.26990001f,0.42029999f,-0.37730002f,-0.23640001f,0.27660003f,-0.21940003f,-1.90700003f,0.17210002f,0.34909999f,-0.29489995f,0.42030000f,-1.62770008f,-0.35640003f,-0.17980000f,0.09710001f,1.34340003f,-0.41110000f,-0.92190001f,0.31489999f,0.49310002f,1.13109999f,0.51289997f,0.31319997f,0.66590004f,-0.36070000f,-0.54459999f,0.23380001f,-1.26900003f,-0.14089998f,-0.77299994f,0.80089998f,-0.34699996f,-0.15729999f,-0.62979996f,0.46409996f,-0.37560001f,1.15680002f,0.61800002f,0.74380004f,0.27249999f,-0.34269998f,-1.05480003f,-0.20509996f,0.70010005f,0.72030008f,-0.78330005f,-1.26660003f,0.27650002f,-0.00149997f,-0.57630001f,-0.64400000f,0.12599999f,-0.36979999f,0.90220000f,-0.61489996f,-0.60890003f,-0.88519999f,0.03900001f,-0.40980004f,-0.23199998f,-1.05909998f,0.53439999f,0.16079998f,-0.92719997f,-0.07899999f,0.82340000f,-0.31719997f,0.81659999f,-0.43100004f,-0.79099999f,1.10890001f,0.36400001f,-0.04060000f,0.46340005f,-0.38770002f,-0.71360004f,0.22349996f,-1.06160003f,-0.51649999f,0.53760001f,1.17910001f,1.41140001f,0.97729999f,1.48700003f,0.14869997f,0.66509999f,0.99249996f,0.96380000f,0.38799999f,-0.41990001f,0.49860001f,0.47950003f,0.44639999f,-1.01809999f,0.13540001f,-0.14210002f,-0.29310000f,0.01660002f,-0.99330001f,-0.15910000f,-1.20600003f,-0.29510000f,0.40259998f,1.34410000f,1.44580001f,0.75849999f,0.27880002f,-1.27370009f,0.64619998f,-1.07590003f,-0.60290004f,-1.30050000f,-0.47620001f,0.55920002f,1.10020000f,0.16700002f,-0.76349997f,-0.39280002f,0.20129995f,0.09780002f,0.65469996f,0.73280000f,-0.46219999f,0.70420000f,-0.70790000f,1.34710000f,-0.04500003f,-1.15650001f,0.97499998f,-1.27210000f,1.18979999f,0.30750004f,-0.41540001f,0.34810001f,-0.40499998f,-0.09069999f,-1.04549995f,-0.76519999f,0.54179999f,0.76390000f,0.58680000f,0.59019999f,0.79659997f,1.01779997f,-0.71539999f,-1.37649995f,-0.29660000f,-1.60109995f,0.18019994f,0.06330004f,0.73750004f,0.51179997f,0.99399994f,0.05349998f,-0.70649998f,-0.95279997f,-0.13940000f,-0.31440000f,0.98439996f,0.19789997f,0.82779999f,0.92199998f,1.45909993f,-0.22750000f,0.72059996f,-0.06950001f,0.38179999f,-0.88909997f,-0.26780001f,1.16020001f,0.22289998f,0.62920001f,0.42810000f,-0.34509997f,0.85319998f,0.64059994f,0.00209999f,1.02160004f,0.77789999f,-0.45340003f,0.10400003f,-0.21729998f,-0.41209999f,-0.69069999f,-1.89529997f,0.56889994f,1.61029992f,0.08430001f,1.27299999f,-0.94699998f,-0.77929997f,0.08059999f,-1.08809997f,0.43670001f,-0.93230000f,-0.90669999f,0.28539999f,-0.95179999f,1.94899994f,0.13170005f,0.58669998f,-0.24300002f,1.06869997f,-0.32989997f,-0.32119997f,0.62780006f,-0.35150000f,-0.93520003f,-0.12740000f,-0.23450002f,-0.67039997f,-1.89720002f,0.05070000f,0.43830000f,0.72030002f,1.07000000f,-0.59139997f,-1.20829997f,0.37389999f,0.21789996f,-1.30610001f,-0.79669997f,-0.14610002f,1.70299998f,1.71600003f,0.93600000f,-0.72539993f,-0.19070000f,-0.77059995f,0.00869997f,0.26919998f,0.96610000f,-0.16130000f,-1.35340001f,0.28600003f,1.85919998f,-0.18999997f,-0.49480002f,-0.75219993f,-1.84189999f,0.01830002f,-0.85739999f,-0.19750001f,1.59519999f,-0.61209997f,-0.61609993f,0.53449996f,1.24739997f,0.22440000f,-0.61750003f,0.40619997f,1.13470000f,-1.37580001f,0.85839998f,1.39869999f,-2.05539991f,-0.61389999f,0.12859994f,0.76369998f,-0.64170002f,-0.08760004f,0.31799999f,-0.22809999f,-1.00039996f,-0.31099998f,0.50769999f,-0.45819999f,-1.19569998f,0.24320002f,1.29699994f,1.19969995f,-0.98249996f,0.87150000f,0.62710002f,0.57689996f,-1.38449996f,-0.26079996f,-0.67259998f,-0.72739999f,0.75529999f,-0.44559997f,-1.02479999f,-0.41039999f,-0.52979998f,-0.71480001f,-1.00890002f,-0.03270001f,-0.70019999f,-0.75690003f,-0.07890000f,0.04580000f,-1.65069990f,-0.63060000f,-0.39889999f,-0.05550001f,-0.57980002f,0.41959994f,-0.23179999f,-0.15899999f,0.18399996f,0.40240001f,1.14479995f,-0.75329997f,-0.88629999f,0.37010000f,0.46579999f,0.89269995f,-0.13840000f,0.48169996f,0.10700005f,0.96159995f,-0.10160000f,-0.01029999f,0.67710001f,-0.52130001f,-0.43549998f,0.54590000f,0.19860002f,0.94830001f,1.76749998f,0.04190001f,-0.04160000f,0.68489999f,0.64279999f,-1.76770001f,0.24479999f,-0.55100000f,0.22279998f,0.30370000f,-0.73859998f,0.39809997f,-1.76380000f,0.82200001f,-0.35220000f,-0.07559997f,1.12660002f,-0.07249994f,0.40590003f,0.25940004f,1.45010007f,1.23680005f,-0.73030002f,0.95830003f,-1.01260006f,-1.23690001f,-0.04139998f,-1.02250000f,-0.00160002f,-0.44669998f,-0.55180002f,-0.13379999f,-0.79560002f,0.39150003f,1.43860003f,-0.94770000f,-0.06330001f,-1.07110000f,-0.18670005f,-0.32029998f,-0.19149998f,-0.46380002f,0.87660002f,-0.09210001f,0.73300002f,-0.58330002f,0.08279994f,-0.09549997f,-0.25080002f,0.57020000f,-0.30640002f,-0.25779999f,-1.25720000f,1.37190001f,0.96400001f,-0.08729994f,1.22730001f,0.26250001f,-0.30990004f,-0.04289997f,-1.74590005f,-1.08070000f,-0.79259999f,-0.61179997f,0.53270000f,-0.23239999f,-0.50880000f,-0.45189998f,-0.34730001f,-0.28989998f,1.29830003f,-1.27850000f,1.02499998f,-1.11829997f,0.08249998f,-0.90479999f,-0.65680000f,-0.69639998f,-0.19480000f,-0.44740001f,-0.01380004f,-0.74269997f,-1.33320002f,0.17240000f,0.41679998f,0.09410004f,-0.04000002f,0.58899998f,0.79279999f,1.01650003f,-0.56560005f,0.70310001f,0.57470003f,-0.63219996f,0.14750005f,-0.43430000f,-1.43710008f,-0.73869999f,0.20390001f,-0.01389993f,-0.74980007f,-0.40329999f,-0.05260000f,-0.67130000f,-1.29520002f,-0.00350001f,1.05969993f,-0.27530000f,1.01590004f,-1.07829997f,-0.14900001f,-1.35590000f,-0.32279998f,-0.14500001f,1.52019999f,-0.03969998f,-0.33919995f,0.52759995f,-1.84519999f,-0.48069999f,0.77259995f,-0.23879995f,-0.22140001f,0.02739997f,-0.60139997f,0.22209996f,1.34670002f,1.38060003f,-0.96610002f,-1.24430000f,2.28150010f,0.47689997f,-1.38370003f,0.18139997f,-0.91140005f,-0.53870007f,0.93740003f,0.65259999f,-0.19440002f,-0.30769999f,-0.11329999f,-0.28900002f,-1.26430004f,1.52750002f,2.03790007f,-0.18750002f,-0.26129996f,0.29689996f,-0.20830008f,-0.36169999f,0.39560001f,-1.08800000f,-0.35459999f,1.38489999f,-0.76679999f,-0.87530001f,-0.75080007f,0.47460002f,0.30700000f,0.69159998f,-0.83160001f,-1.14300003f,0.14060004f,0.94439999f,1.91679999f,0.83320000f,-0.78579998f,-0.02079993f,-0.45720002f,-1.01249999f,-0.67490001f,-0.61939997f,0.97500000f,0.79019999f,0.82700000f,0.64660000f,-1.48579999f,0.07840001f,1.50359997f,-1.58510000f,-0.24240002f,-0.75779999f,0.55150001f,-0.66630000f,-0.38080001f,0.63329998f,-0.23020001f,-0.45860000f,0.94019999f,-1.24159998f,-0.87920001f,0.28319997f,0.44819998f,-0.16499998f,-0.78900001f,0.71489999f,0.17020001f,-1.00230000f,-0.01080000f,0.50889999f,2.16270000f,0.97699999f,0.32550000f,-0.54729997f,0.97550006f,0.10710003f,0.77560002f,-0.21049996f,0.06500002f,-0.66500002f,0.14600001f,0.14330000f,-1.26760000f,0.33040000f,0.13550000f,-0.17589999f,-0.20060004f,0.44480003f,0.01290002f,0.07229998f,0.27749997f,0.28510002f,0.46959999f,0.07410000f,0.04079999f,-0.98099998f,-1.03479997f,0.24599998f,-0.46219995f,-0.50890001f,-1.48299997f,0.16679998f,-0.45099996f,-0.82769994f,0.24419996f,1.00110001f,-0.61579999f,-0.37819998f,-1.14950003f,-0.26110007f,0.07369995f,0.21719997f,-1.30430003f,-0.19249996f,-1.22580005f,0.67189997f,0.65999995f,-0.10129996f,0.13279998f,-0.70609993f,-1.12989997f,0.18540000f,1.63039998f,0.40079997f,-0.60469999f,0.54349999f,0.21320003f,-0.03770001f,1.88250005f,-0.76740000f,-0.45240001f,-1.17290000f,-1.61230000f,-0.92139999f,-1.74369998f,-0.85440000f,0.19799999f,-0.06410000f,-0.38799997f,1.22960005f,-2.12289999f,-1.11390004f,-1.77849998f,-1.77850000f,-0.22060000f,0.13920000f,1.06479993f,0.52460000f,-0.65669995f,-0.69159999f,0.47349995f,-0.11900001f,-0.33130002f,-0.60839998f,0.75479999f,-0.20079999f,0.52600000f,0.08659999f,1.37939997f,-1.31429995f,-1.06099995f,-0.13760000f,0.82129997f,0.07629999f,-0.43920004f,-0.15119997f,-0.70229998f,-0.13979999f,-1.00150004f,-0.47579998f,0.11920007f,0.79990001f,0.55110001f,0.01850002f,0.99770004f,0.85420001f,0.11540002f,-0.83430001f,-0.01940000f,1.18289997f,0.36420000f,-0.19119996f,0.50280001f,1.42590001f,0.34959997f,-0.50090001f,-0.59229997f,0.36339997f,-0.82649997f,0.14000000f,-0.50140003f,0.83979999f,0.61790002f,-0.18009997f,-0.23950001f,0.70219999f,0.20380000f,-0.51929997f,-0.35320001f,0.17080003f,-0.67080001f,-0.69330000f,1.50000007f,0.44770001f,-0.34670003f,-0.78740000f,-0.64010000f,-0.39820002f,-0.63690006f,-0.38119998f,-1.22020001f,-1.20480001f,0.56410004f,2.12220002f,-1.57629998f,-0.97570002f,-0.65110003f,-0.73620001f,-0.31509999f,0.84139999f,-0.34999998f,-1.36420002f,-0.07099997f,0.44840003f,0.93310002f,-0.48010002f,-0.65080006f,0.75340000f,0.20560001f,0.25810002f,0.56460002f,0.19629998f,-0.12029999f,0.09560000f,-0.55130001f,0.41670000f,-0.45260004f,0.78540000f,0.62340000f,0.94159997f,0.95649998f,0.26319999f,1.46540002f,0.84959997f,-0.10600003f,-0.32259996f,-1.16169999f,1.59930000f,0.92019997f,-0.80270003f,0.80549999f,1.08040001f,0.07079999f,0.48419999f,-1.04969997f,-0.48160000f,-0.15670001f,-0.41430001f,0.24230001f,0.78179998f,0.57420002f,0.22939999f,-1.21100000f,0.64889997f,0.02180003f,0.01799999f,-0.80909999f,1.21649995f,0.20560002f,0.35050000f,1.31439996f,0.12829999f,0.03480001f,-0.31609999f,0.04890003f,-0.04960000f,0.33280000f,0.32319999f,-0.20040001f,0.05380000f,0.12350001f,0.17370001f,-1.12810003f,0.39210003f,0.43369999f,-0.57159996f,0.20020000f,0.11800000f,0.06020000f,-0.42359998f,0.10529999f,-0.30189999f,-0.33119999f,0.76879996f,1.03639994f,-0.87740000f,-0.08160002f,-1.47159994f,0.14359998f,-0.90319996f,-0.33970000f,-0.07199999f,-0.42639998f,0.17799999f,-0.74849999f,1.05569997f,0.52030000f,-0.84820002f,-0.75370000f,0.72099995f,-0.45890008f,0.63810000f,-0.81929999f,0.67770000f,0.85440003f,-0.33139997f,-2.22070005f,0.19969997f,1.78329998f,1.04899997f,0.75879995f,-0.35060000f,0.85249999f,-0.33380002f,2.03169999f,2.58540001f,-1.08720004f,-2.55580002f,2.04239997f,1.67189999f,-1.07019993f,0.17559996f,0.46940000f,0.42029996f,-1.51359992f,0.81249996f,0.36920002f,0.26599995f,-1.36390004f,-0.44729994f,1.41320003f,-0.35190000f,-1.80820000f,0.12640004f,-0.62190000f,-1.11539996f,-0.65529996f,-0.74629999f,0.34140000f,0.54730001f,-0.07640002f,-0.13489996f,-1.13260003f,0.42739999f,-0.71970003f,-0.71559996f,0.74939995f,0.64509998f,1.33759995f,0.01930000f,0.83020002f,-0.76129999f,-0.08940003f,0.11709998f,0.39760000f,0.20680002f,1.06639998f,-0.01659997f,1.18710003f,0.99730005f,1.50250005f,0.32180006f,1.26530005f,0.36970001f,-0.40499997f,0.30699998f,2.12960002f,1.07819996f,-0.69809998f,-0.77530000f,-1.45830005f,-0.38279998f,-1.35620000f,0.10560000f,-0.18799999f,0.96499999f,0.50780002f,1.04979998f,-1.24390001f,1.12959997f,1.04899999f,-0.07389999f,2.00660002f,-0.88020000f,0.10740002f,0.16809996f,-1.05859997f,-0.12680002f,0.02480002f,0.41249998f,-0.50899996f,-0.65299999f,0.59279999f,0.49929999f,0.24269999f,-1.12100004f,1.35140007f,0.67569999f,-0.60000005f,-0.84680002f,0.30019998f,0.98060000f,-1.81240011f,-1.32620005f,0.85820002f,0.19229999f,-0.83049999f,0.86569999f,0.27269996f,0.65960002f,0.11700007f,0.25109997f,1.00160001f,-0.30560004f,0.04900002f,-0.53890003f,-0.07500002f,0.00130000f,-0.68699997f,0.50220000f,-1.24340000f,-0.86270000f,-0.25660001f,0.66739999f,-0.71140001f,-0.72699999f,1.12960001f,0.80120002f,0.34359999f,-1.21790003f,-0.21170005f,1.03149998f,1.16230006f,0.68400006f,-0.29470001f,-1.27840000f,1.06570005f,1.22000004f,0.30750000f,-1.00490003f,1.67100008f,0.63309999f,1.22650006f,0.25870002f,-0.80480007f,-0.94599999f,-0.50219999f,-0.10589999f,0.38860000f,0.15030001f,-0.91120000f,0.45910001f,-0.24910000f,0.38459999f,0.50019999f,-0.82979996f,0.22899998f,-0.54010002f,0.11540001f,0.51129999f,-0.44660001f,-0.70269999f,-0.59280000f,0.74410000f,-1.56920000f,0.38050002f,-1.79110007f,-1.51560004f,-0.33579997f,-0.17850001f,-1.14830004f,-0.30929997f,0.43180001f,0.08850006f,-1.08790005f,-1.54589997f,0.13949999f,-0.05529999f,0.52650001f,-0.78940003f,0.55039997f,0.01730004f,0.51160001f,-0.87119999f,-0.25080004f,-1.24679998f,-0.00669997f,-0.50450001f,-0.29739997f,-0.96700000f,-0.53320002f,1.47470003f,-0.44160000f,-0.41730001f,0.99139997f,-0.08259998f,-0.09420000f,-0.36100000f,0.20479998f,0.68040000f,0.65020002f,0.28329998f,-0.01799998f,0.26299998f,0.56490002f,1.18949997f,-0.02700001f,-0.09220002f,0.14940000f,-0.45560000f,0.86870002f,0.25500000f,-1.41560001f,0.69910002f,-0.66469999f,1.03059999f,-0.13220001f,0.57319998f,-0.25840000f,0.01329999f,-0.29970000f,0.35369998f,0.14249997f,-0.00640000f,0.72969999f,0.28429999f,0.82900002f,0.18839997f,0.40100000f,-0.36819999f,0.01820000f,0.14509999f,-0.45539997f,0.19769999f,-0.78100000f,-0.72179998f,-1.17879999f,0.79550006f,-0.70939998f,-0.59599998f,-0.07200000f,-1.55440004f,-1.44510005f,0.05750000f,0.84810006f,-1.00950002f,-0.71640000f,0.53259995f,1.24480001f,0.04380003f,0.54359998f,-0.40000001f,-0.38230000f,0.85799999f,2.12750004f,-0.05020000f,-2.30300007f,0.80569999f,1.76940004f,0.59089997f,-1.21580002f,-0.50080000f,-1.07799998f,0.89789997f,-1.55219996f,0.57750001f,-0.64600000f,-0.18959997f,0.44200006f,0.52159995f,-1.32120004f,0.37320003f,1.06119999f,-1.40420001f,0.13989997f,0.05850001f,0.57310003f,1.16509998f,0.41639998f,0.57479998f,-0.64140006f,-1.08370005f,0.71520003f,-0.26210005f,-0.61919998f,-0.92049995f,0.20010000f,-0.04029996f,0.72079997f,0.37840001f,0.21800002f,-0.89969997f,0.30840001f,-1.46449997f,-1.14419999f,-0.16010003f,0.46780001f,0.89830001f,0.68499999f,0.82710001f,0.09210002f,0.60390002f,1.19919998f,-0.23709996f,-1.94350001f,0.08339997f,-0.26430004f,0.28320000f,-0.09559994f,0.22320000f,0.14610001f,-0.43519999f,1.15169997f,1.01070001f,-1.30489994f,-1.67409999f,1.30929995f,0.28879999f,0.41590001f,-0.27389998f,-0.17450003f,0.52369999f,-0.60550000f,0.70009999f,0.35789997f,-0.02049998f,-1.21579999f,-0.14859996f,1.19349999f,-0.11230003f,-1.55359994f,0.35059998f,0.15740000f,0.24559998f,-0.63180002f,0.08590001f,-0.86890001f,0.70299997f,0.35149997f,0.50590000f,0.74610002f,0.72120000f,-0.91780005f,-0.67119999f,0.31270003f,0.66810001f,0.19919996f,-1.09240000f,1.22829997f,0.89559997f,0.56320000f,0.77079999f,-0.44110000f,0.29849998f,0.46909994f,-0.74099999f,-0.05329996f,0.30669997f,0.44319999f,0.37669999f,-0.40119997f,0.59199995f,-0.88269996f,0.59549997f,-0.85740002f,1.40769998f,0.83289999f,-0.62219994f,0.23690001f,0.84759997f,-0.10850003f,0.15470001f,-0.53129999f,-0.53320000f,-0.22330000f,-0.96560001f,0.41800005f,-1.16330002f,0.09320001f,-0.91120001f,-2.13620002f,0.64650000f,0.19779996f,-0.44860004f,0.21199999f,0.34390000f,-0.22789999f,-0.48079996f,-1.22210000f,-0.53430002f,-1.88289998f,-1.36020003f,1.10939995f,1.68999993f,-0.10869996f,0.64869997f,0.43999998f,-0.63579998f,0.83850000f,-1.64359997f,0.43819998f,-1.48979999f,-0.09700000f,-0.02120000f,0.88670002f,-0.76159998f,0.45910005f,-0.84390000f,-1.11530001f,-0.42090001f,-0.33399997f,-0.39360000f,-0.37550000f,-1.01559999f,0.07280003f,-0.53650001f,0.06919999f,-0.21579998f,-2.10789998f,-0.27470005f,-0.42110001f,-0.31940001f,-0.25190002f,0.58789995f,-0.66339999f,-0.26890000f,-0.78259997f,0.32459998f,-0.06329999f,0.09780001f,0.06039999f,0.83049996f,1.04510003f,0.73919994f,-0.13650000f,0.40329996f,0.66140000f,-0.57909999f,0.57699997f,-0.28610001f,0.22120000f,-0.41709997f,-0.90950001f,-1.39839997f,1.05970006f,-1.05249996f,-1.91800000f,-0.01670003f,0.84350001f,0.22850000f,-0.39789998f,-0.46529998f,-1.12820000f,-0.41360000f,0.14320006f,0.72530005f,-2.59539991f,-0.84520002f,0.78779995f,-0.21889998f,-0.42049997f,0.89220000f,-0.79840003f,-0.60790005f,0.75379999f,-0.09699999f,0.85499998f,-1.67929997f,-0.59330006f,-0.18139997f,1.81779997f,0.26799998f,-1.68389993f,0.92889997f,0.14620000f,0.73459999f,1.29310002f,-0.76909996f,0.31750004f,0.03050000f,0.63289998f,0.08980000f,-0.12989995f,-0.06450000f,-0.28480001f,0.79620001f,0.65030000f,0.70110001f,1.11460003f,-0.35119999f,-0.46579997f,0.87589997f,-1.07959997f,-1.32199998f,-0.19620003f,1.37429997f,0.57499999f,-0.28809999f,0.59730001f,0.88549998f,-0.19810000f,-0.70439996f,0.54299996f,0.51149997f,-0.51389998f,0.82589996f,0.09429998f,1.01849996f,0.46630002f,0.72989999f,-0.78889999f,0.58699998f,0.21519999f,0.52050000f,-0.48260004f,-0.10509999f,-0.71970002f,0.29440002f,-0.77520005f,0.52100000f,-0.79260001f,-0.46840001f,0.42130003f,-0.14200000f,-0.53210001f,-0.84349997f,0.28519996f,1.40389996f,-0.82490003f,0.55100001f,-0.97059998f,-0.15080001f,0.59719998f,0.70719991f,0.93970004f,0.06659999f,0.35730002f,-0.91189999f,-0.96310002f,0.26660000f,0.94130001f,-1.03839999f,0.51140003f,0.21400001f,-1.17800003f,0.89980004f,1.04390005f,-0.28040002f,-1.26950005f,-0.25060003f,0.81920004f,1.35940005f,-0.01119999f,-0.37020002f,0.45450002f,-0.69900005f,0.38670007f,0.45849999f,-0.81280005f,0.80850001f,-0.64590001f,-1.23090004f,0.40440005f,-0.44619998f,1.64640003f,-1.35549999f,1.38720003f,-0.36580002f,-0.95649999f,-1.28260000f,-0.35370002f,1.62659999f,-1.49520002f,0.14489998f,-0.34280002f,0.29080001f,-0.87120000f,-0.38300002f,0.47660001f,-0.82879999f,-0.09620003f,-0.09220002f,-0.70749998f,-0.74960005f,1.36590001f,0.41060003f,0.34250001f,-0.48509998f,-0.21039998f,1.57910000f,-0.54139998f,0.71269998f,-0.55330000f,1.49070004f,-0.01830001f,0.81650002f,0.43419998f,0.74059999f,-0.99249999f,-1.57409994f,0.21790008f,-0.16380001f,1.18430001f,-0.53630003f,-1.17989999f,0.59299996f,1.11550005f,0.07849998f,1.96899998f,0.71399999f,-0.48270004f,0.52650003f,1.27370006f,-0.36600002f,-1.63420005f,1.15060002f,-0.56370002f,-0.49020000f,1.58000001f,-1.21260001f,-0.33019997f,-0.09880002f,0.36250003f,-0.14130000f,-0.78950005f,-0.88850003f,0.52310002f,0.68600002f,0.48160001f,0.63470003f,-0.11070002f,-0.43300000f,0.57529999f,0.75360000f,-0.91500003f,-0.38230000f,0.26309998f,0.61160000f,-1.46520003f,0.66720001f,0.59169998f,-0.63909996f,0.85960003f,-0.37649995f,0.57199998f,-0.38959998f,0.87560002f,-0.68010000f,0.40009999f,-0.31920000f,-0.95760002f,0.39360002f,0.96960002f,0.11490001f,-0.39070005f,0.25470004f,1.03560002f,0.90769999f,-0.84380003f,0.38960000f,-0.34660002f,-0.62930002f,1.04040005f,-0.61280002f,1.07170001f,-1.23870002f,0.67600003f,-0.45379995f,-0.43960003f,0.96279997f,-0.47450003f,1.05079999f,-0.18910001f,1.03839998f,0.77800000f,-0.70380002f,1.37560000f,-0.91509998f,-0.80590003f,-1.30779993f,0.45520003f,-0.31919999f,-1.30820000f,0.48850001f,0.43300000f,-0.66759999f,0.28170000f,-0.57770001f,0.83329999f,-0.49000000f,-0.74760001f,0.25530001f,1.30420001f,-1.32770003f,0.37160004f,0.06129998f,-1.15640001f,1.11090000f,-0.90280006f,1.16030004f,-0.05300003f,-1.24019999f,0.94970003f,-1.02480002f,-0.81020002f,0.77139995f,-0.74479998f,-0.45120001f,-0.98189998f,-0.07230001f,-0.38740005f,2.27249996f,0.14459998f,0.77220002f,0.40350001f,-1.08499999f,-0.91189999f,0.13090001f,-0.46880001f,-0.49380001f,0.66560003f,-0.34080001f,-0.74120001f,-0.43680001f,0.28210001f,-0.15220000f,0.64519998f,0.31780002f,0.35020003f,0.13900000f,-0.16689999f,0.52529999f,-1.26070001f,1.64910001f,-0.70690000f,1.27419998f,0.34400001f,-0.41310001f,0.43360003f,-0.70049999f,0.05390000f,-0.49669998f,0.96170002f,-1.10930001f,-1.39349994f,0.56110001f,0.11499999f,1.60269991f,1.22030000f,-0.26890001f,-0.40409998f,0.03460001f,0.36889999f,0.01460002f,0.36600000f,-0.25310001f,0.12950002f,0.58030000f,-0.97720001f,0.65740001f,0.71390000f,-0.88400000f,-0.72719999f,-0.05540000f,1.63050003f,-0.60370001f,-0.44479995f,-0.69879997f,0.19640004f,-1.37189997f,0.48719998f,-0.74840003f,1.87130001f,-0.06939999f,0.28339998f,-0.35419998f,-1.35289999f,0.29750006f,-1.06440004f,-0.20430002f,-0.46829995f,1.38130004f,-0.84850000f,0.08550002f,-0.06630002f,0.04640001f,0.37870002f,0.87540002f,1.62280002f,-1.28329999f,-0.42489999f,2.00990006f,0.98470005f,-0.88260001f,-0.73829995f,-0.11660001f,0.65970004f,1.63280003f,1.26760001f,-0.32130002f,-0.36920003f,-0.29409999f,-0.93749999f,0.15590004f,-0.59660003f,0.28039999f,0.01280004f,-0.66899998f,-1.14309999f,-0.40339997f,-0.30750003f,0.44889998f,1.50049999f,1.31440003f,1.32790000f,0.72080001f,-0.13370001f,1.01140001f,1.02560002f,0.98140000f,-1.18889997f,0.84220001f,0.57039996f,0.86099999f,0.08560009f,-1.02650006f,1.08939999f,-0.80640006f,1.24980001f,-0.31390003f,-0.12480000f,-1.95160001f,1.27580006f,1.55649999f,0.04560000f,-0.15490001f,1.08570003f,0.14679997f,0.18760003f,-0.56420004f,-0.71370001f,-0.13950003f,1.44239999f,0.06979997f,-2.27029994f,-0.62819996f,0.65069997f,0.44070000f,-0.70340000f,-0.25270002f,-0.40899999f,-1.07690000f,0.30729996f,-0.55790001f,-0.40129995f,0.83619997f,-0.74710000f,-1.01429998f,-0.31620001f,-0.48929998f,-0.57880002f,-0.09159995f,-1.20309998f,0.49110000f,-0.06690002f,2.29879999f,0.06159994f,-0.09999996f,-1.33739997f,0.88970000f,-1.02030001f,0.69799999f,0.97380001f,0.57620001f,0.18530003f,-0.36969998f,-0.61880000f,0.36120001f,0.16539995f,1.78459995f,0.14319999f,0.22250002f,0.27999999f,0.65649999f,-2.00200000f,0.44510001f,0.53840001f,-0.65509996f,0.52269999f,-0.01860000f,-0.04710003f,-0.19250003f,0.35240000f,-0.47120004f,0.61070000f,-0.39530000f,-1.71580000f,-0.78700001f,-1.45460001f,-1.38710003f,1.50650002f,1.36990003f,-0.87470009f,0.31019999f,-0.17780007f,-0.75530000f,-0.40189998f,0.17129998f,-0.28180001f,0.00810000f,1.98559997f,0.52820001f,-1.70619998f,-0.84849999f,1.00960000f,1.18400003f,0.54929997f,0.52579995f,0.32990000f,-0.27300002f,-0.82500000f,-1.54880001f,1.17950000f,1.35650003f,-0.98269998f,0.66559998f,-0.38680003f,-1.52870004f,0.73920001f,-0.27080001f,-0.36220000f,-0.72620001f,1.55500001f,1.14670002f,2.44300005f,0.16140001f,-0.54740005f,-1.12910004f,-1.22170002f,-0.23020000f,0.36830000f,-0.91650002f,-0.34129999f,0.02520002f,0.07310002f,-0.25029997f,-1.24630007f,0.00809997f,0.64170003f,0.58349998f,0.50580003f,-0.83400000f,0.16760002f,-0.88130001f,0.03670001f,-0.51749999f,1.44799996f,-1.91820001f,0.79120000f,0.24610000f,0.51479999f,0.11499999f,0.08850002f,0.78360000f,0.10460001f,0.87190000f,-0.81300000f,0.42559999f,-0.44320004f,1.03060004f,1.29700001f,-0.65030000f,-0.37619999f,-0.08730002f,0.93699999f,0.56609998f,1.06660001f,0.43019997f,-0.78890003f,-1.35080001f,0.18150006f,-0.09369997f,-0.58780001f,-0.72780002f,0.71350000f,0.02669999f,-0.73290000f,0.51049999f,-0.78649999f,0.02279999f,0.86149999f,0.56769998f,-0.93369999f,-0.93420003f,0.72589997f,-0.09740002f,-0.05459995f,-0.05980002f,-0.10770003f,-0.80430001f,-0.17370000f,-0.04540000f,-0.20130001f,0.33479999f,0.48250003f,-0.07369999f,1.77429997f,-0.51180002f,-0.43129996f,0.00160000f,-0.23850002f,0.24829995f,1.26949997f,0.24060004f,0.11250000f,-1.91429991f,-0.84710001f,0.86019999f,1.27940005f,-0.92870002f,-0.87690001f,-0.35500000f,-0.32560002f,-0.03510001f,1.16450002f,-0.62480002f,0.44740001f,-0.41320002f,-0.33639999f,0.33320003f,-0.43220003f,0.47870001f,-0.12179999f,0.35029998f,0.12800001f,1.42230004f,-0.97750005f,0.54640003f,-1.18300006f,-0.19499999f,0.13269996f,-1.44169996f,0.58740003f,-0.03319997f,0.53049999f,-0.97970001f,0.78020001f,-0.40279999f,-0.80819999f,0.54060001f,-0.61540003f,1.55239996f,-1.07700004f,-0.40040004f,-0.70780003f,0.35930001f,0.33410001f,-0.46430002f,-2.07129999f,0.61709999f,0.98199998f,-1.09939999f,-0.32919996f,-0.30650004f,-0.51930006f,1.07440004f,-0.60120000f,1.04830006f,-1.22940003f,0.45640002f,0.47040002f,1.70080002f,-1.12029999f,0.79500000f,-0.64080003f,1.68729999f,-0.32989998f,2.06499992f,-1.56239998f,0.92529998f,-0.36609999f,1.01329993f,-0.23989999f,0.30210002f,-0.00859999f,-0.83160000f,-0.36439996f,1.67269994f,-0.09290003f,-0.32000003f,-0.13780003f,0.39150003f,1.13129998f,-0.55099998f,-0.27509998f,-0.66519999f,0.34359998f,-0.00639999f,-0.24820004f,-0.06179998f,1.42470001f,0.00809998f,1.14300004f,-0.33030001f,-0.16760000f,-0.12069999f,0.26280000f,-0.70670002f,0.93430001f,-0.60150002f,1.09510004f,-0.36019998f,-0.68200001f,-0.35889999f,0.58779999f,-1.51919994f,-0.69649996f,0.07870001f,1.13189997f,-0.29779999f,1.01789999f,-1.08509996f,0.82680003f,-1.33329996f,-0.42479998f,0.05579998f,-0.91650002f,0.83519998f,0.47379999f,-0.13699998f,0.87200004f,-0.42090003f,-0.48290001f,0.53160004f,-0.70690005f,0.45530004f,0.51620002f,0.14080001f,1.04860000f,-0.32760000f,-0.32729999f,-0.35789997f,-0.50220004f,-0.07790003f,0.92330005f,-1.68650007f,0.84130005f,0.30280002f,0.00460000f,1.53029998f,0.56699998f,0.55069999f,-1.55489999f,-1.32639994f,0.53460003f,2.34179994f,0.22189999f,-0.85280001f,-0.43090000f,-1.02479999f,1.67170002f,0.49310002f,-0.33070000f,-0.32380001f,-0.16369999f,-0.31910001f,0.38420001f,0.74960003f,-0.69480002f,0.81250003f,0.93410002f,0.14109999f,-2.09620001f,-1.34619997f,-0.84380001f,0.08499998f,-0.34060001f,0.53680000f,0.65620002f,-0.89380004f,0.35670004f,-0.23840000f,-0.44940004f,-0.47209999f,0.89370002f,-0.48529991f,-1.80539998f,-0.29130003f,1.47190000f,1.07189997f,0.41839998f,-0.26190000f,-0.83750001f,-0.56949999f,0.06579995f,1.00969997f,-0.78879999f,0.41190001f,-0.62160001f,0.50290003f,-0.21889999f,0.06899999f,0.11699999f,-0.58039998f,0.23859998f,-0.54519999f,-0.66519999f,0.00179999f,0.33570000f,-2.10700002f,0.06820004f,-0.52620003f,-0.19340002f,1.11850001f,-0.43360000f,0.06260000f,-0.86910000f,0.65790001f,0.31840001f,0.23149999f,0.01160001f,-0.96869993f,-1.15730000f,-1.02559999f,-0.34350000f,1.12699997f,-0.29139999f,-0.17219998f,-0.56549999f,0.42969996f,1.53830001f,0.19339996f,-0.32729999f,-0.15720001f,0.68160000f,-0.30479998f,0.58259999f,-0.43229999f,-0.32959999f,0.52510001f,-0.56620002f,0.42900004f,-0.25930000f,-0.06690000f,0.02189998f,0.26450002f,-0.04670006f,0.95339998f,-1.52670000f,-0.55020002f,0.77620006f,0.30779998f,0.78540001f,-0.97670001f,-0.20039995f,-1.53220000f,1.56219998f,-0.21570007f,1.39050000f,-1.22200004f,1.48990000f,0.26780002f,-0.42359996f,0.77650001f,-0.98030002f,-0.92470003f,-0.87980000f,0.01480001f,0.31250000f,-0.15320001f,-0.34790003f,-0.14330000f,0.55209999f,-0.22820001f,0.11439998f,-0.43600002f,-1.50430002f,1.27020003f,-0.08519998f,0.25790004f,0.68970005f,-0.31239998f,0.89420002f,-0.67340001f,0.64809993f,0.84209998f,-0.04650000f,0.80879998f,0.06140003f,0.11730003f,-0.58010004f,0.25050000f,-0.79209997f,-0.43750001f,-0.53180001f,-0.84100002f,-0.54620001f,-0.05250000f,-0.74450000f,1.03390001f,-0.65379997f,0.26239999f,0.98569998f,-0.08419997f,-0.55539998f,-2.27350004f,-1.23900001f,-0.00129997f,-0.35289996f,0.68640003f,1.51180006f,1.09379997f,-0.95490002f,-1.01400004f,0.89600004f,0.59000002f,-0.74970002f,-0.42530002f,0.38010002f,-0.32699999f,-0.44880000f,-0.10799997f,-2.00449997f,-0.56030000f,1.03250003f,0.37929998f,-0.61280001f,-0.78089998f,0.98369996f,-0.42670001f,0.28620000f,0.73149998f,0.10120000f,-0.03550002f,0.81610002f,-0.85110001f,0.66629999f,-0.10169998f,1.36920003f,-0.52670001f,0.31810001f,-0.07170003f,0.96669997f,0.60730001f,0.20509997f,0.30880000f,-0.24330003f,0.11760000f,1.00360000f,-0.87150001f,-0.69110003f,-1.14470007f,-0.18100000f,-0.42760001f,-0.55110003f,0.76659998f,-0.02960001f,0.42049999f,0.66719998f,0.31399998f,-0.15620004f,-0.25000003f,1.63430004f,-0.21440002f,0.07789997f,0.06570001f,-0.83559999f,0.46009998f,-1.54490002f,-0.91370000f,0.17579998f,-1.88240002f,1.23269998f,-0.24819997f,1.66329999f,1.37700001f,-0.92109998f,2.43310002f,-0.66700006f,-0.52829998f,-0.72969996f,-0.49160002f,-1.16889999f,0.24199999f,0.74599996f,-0.69130003f,1.64680002f,-1.67860001f,-0.63790000f,0.44360003f,0.60759997f,1.44769999f,-0.54319998f,-1.05880001f,0.50910006f,-1.57540001f,0.36710000f,-0.15999999f,0.21459996f,-0.39850004f,0.21090003f,0.03320000f,-1.48360002f,0.35690002f,0.97799996f,-1.31390003f,1.53720003f,0.50880003f,-0.36740002f,0.74719999f,-0.74680000f,-0.88669998f,-0.17130006f,0.24170004f,0.52990001f,0.69320004f,-1.39950006f,-0.41400000f,1.81120002f,0.84659999f,0.10779995f,-0.09549997f,-1.53970001f,-0.90590000f,-1.61170006f,-0.27599998f,-1.33360002f,0.21970003f,1.71740001f,-0.13019999f,-0.88720003f,0.21229998f,0.18029996f,1.16750000f,1.01829998f,0.25989999f,0.37800004f,-0.97880002f,-0.69040000f,-1.11040000f,-0.34590001f,-0.18999999f,1.30840002f,0.66520002f,-1.61990002f,0.44120000f,0.10589998f,-0.17070002f,-0.57359998f,-0.85160000f,-0.58769998f,1.36650002f,0.41390001f,-0.65640000f,0.75110004f,-1.80310001f,-0.63450001f,-0.50250000f,-0.61889996f,-0.43529995f,-0.22729996f,-0.07370001f,-0.62699999f,-0.15859998f,-0.37510001f,-0.49340001f,0.51960003f,-1.27310000f,-0.11439995f,-0.13269994f,0.43449998f,-0.73140000f,-0.51540000f,1.38190001f,-0.57650002f,0.63830001f,-0.03809998f,0.61570000f,-0.76870003f,-0.89039999f,1.26789998f,0.44170002f,0.13080001f,0.13469999f,0.09489999f,0.12690003f,-0.63000001f,0.38109998f,-1.83839997f,0.22789998f,0.71220001f,1.65369994f,0.40259997f,0.00089995f,-1.21370000f,-0.20309998f,-0.75730002f,-0.34650000f,0.18229999f,0.94470002f,-0.49930000f,0.20319999f,-0.77090003f,-0.29269998f,0.63780001f,-0.25649999f,0.03330001f,-0.26540000f,-0.07390003f,0.40379994f,0.17380001f,-0.49810001f,0.12899998f,-0.44740001f,0.47030003f,-0.07750000f,0.58470002f,0.09430000f,0.43480001f,-0.66730004f,-0.33279999f,1.12079993f,-1.42540005f,1.03849998f,-1.07100001f,0.57860000f,0.89260001f,-1.08959998f,1.09420002f,-0.56819998f,0.92230000f,-1.40959999f,-0.92939999f,1.27140002f,-0.38320000f,0.41830002f,-0.18349999f,-0.19530000f,0.63809999f,-0.92299998f,-0.15990001f,-0.07770001f,-0.03300001f,0.24049999f,-0.78970000f,0.27549996f,1.11030004f,-0.13430001f,0.51460002f,0.37819997f,-1.12200000f,0.80960000f,-0.20200001f,0.77250003f,-0.17770000f,0.24450004f,0.35069999f,0.24289995f,0.84300000f,-1.36389995f,0.49570003f,-1.39539996f,-0.32759998f,-0.61030002f,1.18879997f,1.38789995f,-1.57519999f,-0.38589997f,1.50450002f,0.64880002f,0.37480001f,-0.62710000f,0.65060001f,-0.24520000f,0.58250000f,0.35820001f,-0.03149998f,0.49130000f,-0.94110004f,1.00520002f,0.08989999f,0.29860000f,-0.63970001f,-0.16550000f,-0.46930002f,-0.49640001f,0.00719997f,-1.15869999f,-0.14040003f,-1.42750003f,0.58330002f,0.34410003f,0.37500000f,0.51969998f,-0.43699999f,0.47839997f,-0.15880002f,0.93229998f,-0.64610006f,1.12830000f,-0.82080002f,0.01780002f,-0.78130003f,0.87570002f,-0.06720001f,-1.03469999f,-0.23009997f,-0.44420001f,0.04619998f,0.44170004f,0.79880000f,0.91960002f,0.04489999f,0.56969999f,-1.80120000f,0.56329999f,-0.18960000f,-0.12330002f,0.35630000f,-0.48800004f,0.83060005f,-1.03090006f,0.16629999f,-0.17169994f,-0.29130002f,-0.95199999f,-0.15629997f,1.01950000f,-0.15949999f,-0.43500000f,1.67540001f,0.05070000f,1.36820000f,-2.07480000f,-0.58970005f,0.68620002f,-1.29589999f,0.98189999f,-1.62219996f,-0.11630003f,1.18800002f,0.05649998f,1.15540004f,-0.88640003f,-0.04119999f,0.89999999f,-0.01770005f,-0.12809997f,0.25450004f,-0.65520004f,-0.39480002f,0.53130001f,0.77270001f,1.43220003f,-0.75410004f,-0.67960002f,0.55520000f,-0.16540000f,-0.35689998f,-0.51519998f,-0.50620004f,-0.02650000f,1.19120003f,-0.98830002f,1.07800003f,0.26729997f,0.97520002f,-0.21170002f,-0.44080000f,1.36090000f,-1.99970001f,-0.36430001f,0.70690002f,1.03779996f,1.53159998f,-0.76280001f,0.18070002f,0.91820002f,1.04819999f,-0.13249998f,0.21100001f,0.25170000f,-1.81470002f,0.98000000f,0.04990001f,-0.41790003f,-0.89129998f,0.49509999f,0.35949999f,-0.33970003f,0.36420000f,-1.09860002f,-0.13410001f,-0.96280001f,0.15670003f,1.51800004f,-0.24669998f,0.86529996f,0.62590004f,1.06859998f,-0.09940001f,-0.63159996f,0.39269998f,-0.90669997f,0.10169999f,-0.26730001f,-1.34780000f,-0.26519997f,1.66600006f,0.03969995f,0.02110001f,-0.74600002f,0.44930001f,-0.13520001f,0.35160002f,-0.34610003f,-1.14129998f,0.45409998f,0.91540000f,0.22300000f,-0.97500002f,0.84670001f,-0.84850000f,0.41030000f,0.82600000f,0.82750000f,-0.09740001f,-0.22130000f,-0.34439995f,-1.08499999f,2.29070001f,-0.40510001f,-1.07409999f,-1.36140002f,2.64449999f,0.86009997f,-1.23160000f,0.96749999f,-1.39430000f,0.23809998f,-0.61730001f,0.09080001f,0.64750001f,0.15849999f,-0.77339997f,1.00030002f,-0.11429998f,1.18910000f,-0.08980003f,-0.74780004f,-0.01309999f,1.15670004f,-0.04129997f,-0.59470000f,-0.59629998f,-0.41840000f,1.67350006f,2.42909999f,0.33809998f,-0.86020001f,0.17669999f,0.48760001f,-1.08650001f,0.42020001f,-0.19680000f,-0.48280001f,0.84040002f,-0.24570000f,-2.47649997f,0.06890003f,0.42619998f,0.82659998f,-0.34099998f,0.32960000f,-0.77670004f,-1.16230000f,1.43820001f,0.51419998f,-1.04620001f,0.70710000f,-2.13860001f,0.42489997f,0.19719995f,-1.54670005f,1.28490003f,-0.16239997f,-0.74690000f,1.48339998f,0.15699994f,-0.35419997f,-0.17720001f,1.35010004f,0.19210001f,0.63430005f,-1.57130004f,0.82440000f,0.65039996f,0.63719999f,-0.58659995f,-0.53609996f,0.89939998f,0.76389998f,-0.71020004f,1.31450003f,-1.61449999f,-0.14460001f,0.90440006f,-0.53209996f,0.29699995f,0.41480002f,-0.75340004f,-0.81900002f,0.34190001f,0.61920002f,-2.10290002f,-1.48890004f,-0.19040004f,-0.69829996f,-0.85560003f,-0.74540001f,-0.59990004f,-0.39100003f,-1.31890002f,1.08039999f,0.30549999f,-0.74380000f,-2.82080005f,0.68190007f,0.50740009f,0.67700004f,-2.09670005f,-0.69260003f,-1.14260005f,-0.55160002f,0.27010003f,0.04510000f,0.21749997f,0.54249997f,0.75040002f,0.59080004f,-1.28750004f,-1.17699998f,1.49850002f,0.41990000f,-0.08209998f,-1.54540004f,1.76180002f,0.02359999f,-0.13079996f,0.54790001f,-0.28210002f,0.22070001f,0.35789998f,-0.54950002f,0.31550003f,0.44070002f,-1.34210002f,1.67620002f,0.91559998f,-0.43370000f,0.55440000f,-0.47770002f,0.19870002f,-1.18830000f,-0.34049999f,0.18479999f,-0.33640001f,-0.96140002f,0.01630001f,-0.16909997f,0.39889997f,0.12509997f,-0.18760000f,0.30129999f,-0.04749999f,-0.85980000f,0.26340004f,-0.84539999f,0.96509997f,0.84759998f,-1.27539997f,-0.46960002f,-0.08830000f,-0.06759999f,-0.06030002f,-0.86830001f,0.77500002f,-0.14389999f,0.31769998f,-0.12390001f,0.45580003f,1.84410002f,0.72990003f,1.63320006f,-0.15189999f,-0.35740000f,-0.33430002f,0.79200000f,-0.66380004f,-1.24620000f,0.82470003f,1.67900006f,2.05900001f,0.46459993f,0.52599999f,0.17420002f,0.14729999f,-0.08880000f,-0.12039998f,-0.27889999f,1.47469997f,0.75249999f,-1.27560001f,-0.35479998f,-1.17489998f,0.44180000f,0.31079998f,0.14709999f,-0.81219999f,0.20579999f,-1.67569998f,-0.25410003f,-0.85510003f,-0.40320001f,0.70720002f,0.18570000f,-0.65280001f,0.38390000f,-1.72660002f,0.67080004f,-0.58870002f,1.62330002f,-1.30050003f,1.46740005f,0.53590005f,1.65470007f,-0.74530005f,-0.58900003f,0.14950002f,1.13450006f,-0.73960001f,0.41910000f,-0.48519998f,0.99860004f,-0.29360001f,1.32880003f,-1.71700003f,-0.47359999f,1.34520003f,0.66430002f,-0.85850005f,0.67320001f,-0.66269999f,-0.08639999f,-0.83840000f,0.33780001f,-0.25870000f,0.18070003f,-1.48800003f,-0.78310002f,0.15819998f,-0.29249996f,1.65689998f,0.03189999f,-0.29449995f,0.11060005f,-0.12379998f,-1.47429997f,0.30280002f,-0.24650002f,0.76719998f,0.44159997f,-1.19390002f,-0.76329999f,0.72309997f,0.85930003f,-0.09820001f,-0.09570002f,0.84430001f,-0.91070000f,-0.21959999f,0.11440000f,-1.23560000f,0.42290000f,1.50219998f,-1.52849999f,-0.29409998f,-0.46340003f,0.57290000f,1.87790004f,-0.25710000f,-0.19060003f,0.06200000f,0.10029999f,0.65310002f,1.51030002f,-1.47700002f,0.51990000f,-0.70120003f,0.75670001f,-0.32600000f,0.94139999f,1.11290001f,-0.71380002f,0.53010000f,-0.52260001f,-0.25399999f,-0.34999994f,-0.47840000f,-0.26120000f,0.46290000f,1.39529994f,-0.29439999f,-0.29259999f,1.30769998f,-0.17059999f,-1.21260001f,0.25320000f,0.17880000f,-1.12350001f,0.62760003f,-0.85889999f,0.87960001f,0.40700000f,-0.49560001f,-0.28550003f,-0.01609999f,-0.43009999f,0.54470004f,0.53040002f,0.22270003f,0.20159996f,-0.19829997f,-0.22530004f,0.12970000f,0.28880000f,0.33060002f,-1.17779998f,0.27510002f,-0.21230000f,-0.80619997f,-0.00439999f,1.27430007f,-1.14040002f,1.64820002f,-1.64880002f,-0.21499999f,1.31129999f,-0.86540001f,0.14240002f,1.03600000f,-0.30460000f,-1.20200003f,0.15050001f,0.75110003f,-0.17830001f,0.10279999f,0.34920001f,-0.17320000f,0.26939999f,0.79050002f,0.30020000f,-0.11320002f,0.37050004f,0.71900004f,-0.15039998f,1.19700002f,-0.71450002f,0.56610002f,-0.89610002f,0.77400000f,0.14070002f,0.96180003f,-1.52740000f,0.72850001f,0.87199998f,0.16510003f,-1.23429998f,2.82100000f,-0.71419998f,-0.50229999f,-2.37809997f,1.73310002f,0.52560000f,0.56450000f,-0.21119998f,-0.52220001f,0.55990002f,-0.08700001f,-0.17970000f,-0.62329999f,0.41489999f,0.30660001f,0.32610000f,-0.95900002f,0.14890000f,1.24310002f,-1.19290001f,0.08660000f,-0.63670002f,-0.28630000f,-0.27280001f,0.03670002f,0.34739999f,-0.28620001f,0.71490001f,0.52630001f,0.07560000f,-0.23900001f,0.23540003f,-1.66200003f,0.32850001f,0.16289998f,0.12099998f,0.16370002f,-0.46000001f,-0.67040000f,0.88979999f,0.47310000f,0.05019999f,0.63919999f,-0.70319999f,-0.24540000f,0.17230000f,1.01420001f,0.02570000f,-1.10250002f,0.63470000f,0.60100003f,-0.33749999f,0.08769996f,-0.96970000f,-0.19630000f,-0.76690004f,0.23530000f,-0.10200000f,-0.22890002f,-0.55829999f,0.95620002f,-0.49810000f,-0.20340001f,-0.08790001f,-1.44830001f,1.07990001f,-0.80050002f,-1.08340001f,0.20470000f,-0.28670000f,-0.24980001f,0.60280000f,0.21399999f,0.02400001f,-1.05199999f,-0.92459995f,-1.03459996f,0.78899996f,-0.53290001f,-0.42930001f,0.23890000f,-0.88279999f,0.65890000f,-0.93859998f,1.16240003f,-0.51719999f,-0.88990003f,0.23850000f,0.13610000f,-0.71000000f,1.33020002f,1.05310001f,0.43380002f,0.35779999f,0.68440004f,-0.53530005f,-0.21980001f,-0.81570003f,0.46870003f,0.81320002f,0.25890003f,-0.12990004f,-0.16760002f,-0.52779999f,1.00700004f,-1.11639993f,2.12770001f,-1.18070000f,-0.00350000f,-1.35699998f,0.06470002f,0.68600002f,0.62350003f,-1.37530002f,1.51169999f,1.14210002f,-0.17939998f,-0.03390002f,-1.24590002f,0.47599999f,1.39170003f,-0.42460000f,-0.22840000f,0.64579999f,-0.33419999f,0.64750001f,-0.82330003f,0.60589998f,0.33700000f,0.83229999f,-1.65770003f,0.44949995f,0.19190004f,-0.29920003f,-1.28819996f,-1.09690000f,0.74490002f,0.45989999f,1.07030002f,-0.54440002f,1.87200001f,0.24520003f,-0.61609998f,1.27130001f,-0.78650002f,-1.36830004f,1.56140003f,1.56590007f,-0.22929999f,0.85229999f,1.31370007f,1.63250004f,0.59329996f,-0.45470001f,0.96680004f,-0.25689998f,-1.50450001f,1.57060002f,2.76460007f,-0.71570005f,0.72540000f,0.25559996f,1.28080006f,0.55190001f,0.84819997f,0.73410003f,-0.88960005f,0.48129998f,0.17700004f,-0.11869998f,-1.06860005f,-0.25630003f,-0.48289995f,-0.16940001f,0.49259997f,1.94880005f,-0.34540000f,0.19030000f,-1.32110001f,-0.62520002f,0.00640000f,-1.59170002f,0.75710002f,0.88160005f,-0.59640003f,0.01679999f,-1.15069998f,-0.27960005f,-0.43449996f,0.78300004f,-1.44680005f,1.22940004f,-0.72380003f,1.30820005f,1.04960004f,-1.46029997f,-0.21489997f,1.14840001f,-0.05450006f,1.53290000f,-0.14600001f,0.04610001f,0.18240000f,1.23160004f,-0.06010001f,0.26450002f,-0.00310006f,-0.04040001f,-0.64269996f,-0.52549996f,-0.31719995f,0.44740001f,-0.39110001f,0.86439999f,-0.02309997f,0.17099998f,0.63100002f,1.20920002f,-1.31130001f,0.38539997f,1.49460001f,0.82229997f,0.12240003f,-0.65120002f,1.04770002f,0.62000002f,-0.21650000f,1.07499999f,0.53509999f,-0.03299998f,0.90129999f,2.25520001f,0.37529995f,-0.18659999f,1.49910002f,0.46789999f,-1.29430000f,-0.15399999f,-0.00209997f,0.39370001f,0.22329994f,1.35420001f,-2.13109996f,0.16540002f,0.87799999f,0.76709999f,-1.39910005f,-0.19529999f,0.06900000f,1.70000004f,-0.07370000f,0.10759998f,-0.99719997f,0.68420003f,-0.30780005f,-1.29349999f,-0.77760001f,-0.89130001f,1.50499997f,0.67109999f,1.33640004f,-1.26330007f,-0.15439999f,1.00489998f,-0.09120000f,-1.16369996f,-1.44159998f,-0.52749999f,-0.30809999f,0.21790000f,1.09729999f,-0.81419999f,-0.43490000f,-0.17780002f,-0.20669995f,-0.35080001f,0.21189995f,0.82830000f,0.71800002f,-1.05789995f,-0.50769997f,-0.82240000f,0.02060002f,0.39579998f,0.60550002f,-0.24849998f,0.41889998f,-1.38920003f,-0.79649999f,-0.23429997f,0.08769998f,-0.38389996f,-0.48240001f,-0.05340000f,-0.60689994f,0.41669999f,-0.08309997f,-1.86220006f,-1.55300007f,0.24780000f,-0.29529997f,-0.68959993f,-0.08929994f,-0.39940000f,-1.31559996f,0.19710003f,-0.52580000f,0.82660000f,0.87100000f,-0.76920003f,1.21600005f,-0.16819998f,-0.01800009f,0.43589999f,-0.21879996f,-1.47489997f,0.79329997f,0.49390001f,-0.39589996f,1.21200001f,0.51580000f,0.95010000f,-0.18659999f,-0.98119999f,1.48949997f,0.10900005f,0.21599998f,0.57509997f,0.47720006f,0.04500003f,-0.39140002f,1.13239999f,0.20009997f,-1.33820002f,-1.01860000f,0.00240000f,1.57710002f,0.38559998f,0.52069996f,-0.00229997f,-0.51830000f,-1.55230006f,0.68770004f,-0.22559999f,1.00359998f,0.52749998f,0.69199998f,0.22899999f,-0.76030001f,-0.67720000f,0.11169997f,0.66569998f,1.29539999f,0.52479998f,-1.18189998f,-1.27069999f,-0.55670003f,-1.00470005f,0.53279997f,-1.42060005f,0.88950002f,1.83050001f,-0.14839998f,1.29660000f,-0.70520000f,0.90430000f,0.20639998f,-0.03900003f,-0.05670001f,1.76689994f,-0.78840000f,-0.33580000f,0.18160003f,0.02399998f,-0.55289998f,0.48169993f,1.53610003f,0.97779997f,0.28160001f,-0.76030000f,-0.84490001f,0.43739999f,-0.56160000f,-0.58160000f,1.66710003f,-0.28220001f,-1.08480004f,0.08830001f,0.77520002f,-0.67630002f,-1.76680004f,-0.68350000f,0.32210000f,-0.36860001f,-0.08849998f,0.12389996f,-0.23790005f,-0.04429998f,-0.56290001f,0.04920001f,-1.55990006f,1.27560005f,-0.28900000f,1.15109999f,-1.37499998f,0.43660004f,0.60130001f,-1.24630003f,0.56929996f,1.19930002f,-2.06830000f,-0.78299998f,-0.34210001f,1.96859997f,-1.01170002f,-1.01190001f,-0.04980000f,-0.37640001f,1.06360003f,-0.71890002f,1.16780000f,0.15760002f,-1.67860001f,0.50479999f,0.59310002f,-0.47930002f,0.71350002f,0.06610001f,0.06950001f,1.13740003f,0.33739998f,-0.75150002f,0.58840000f,-2.00550003f,0.63390003f,-0.16940002f,-0.47160002f,1.25230001f,-0.47690000f,-0.35749998f,0.31420001f,-0.29190001f,1.76720001f,0.08750003f,-0.02310004f,-0.41449997f,-0.46360000f,-1.56919997f,0.06660003f,0.11510003f,1.10649999f,0.10619999f,-0.01689999f,-0.58340000f,0.72089999f,-0.60840000f,-0.98980000f,-0.44280002f,1.76640000f,-1.37629998f,-0.77830000f,-0.03690001f,0.66789999f,0.70400003f,-0.39049999f,0.50159998f,-0.67720002f,0.94740002f,0.25850001f,0.47009998f,-1.11690000f,-0.18420002f,-0.22569998f,1.17260002f,-0.95450002f,0.46960000f,-0.13319996f,-1.03639998f,-0.11860003f,1.32579998f,-0.04629996f,-0.38779999f,0.29870003f,-0.32710003f,-1.07329998f,1.27599996f,-0.56239999f,-0.04540000f,-1.15790003f,-0.18640001f,0.66319999f,-0.44380000f,-0.33739997f,-0.28230004f,-0.39459999f,0.91789999f,0.77439999f,0.19770002f,-0.43139999f,0.50540001f,-0.53049999f,1.24310001f,-0.81250002f,1.51380007f,0.06759997f,-0.54230001f,1.06010002f,-0.04420002f,0.02270001f,-0.83830001f,-0.48630000f,-0.13469998f,-0.17649995f,-0.26320004f,-0.37660000f,1.22659997f,1.52979997f,-0.11830001f,0.49790003f,-0.89919995f,0.34859998f,-0.44960001f,-1.99349997f,-0.79919999f,-1.05110004f,1.05300002f,0.20909999f,0.61780001f,-0.27769998f,0.15239999f,-0.72860002f,0.69710000f,-0.26369996f,-0.19380003f,0.08119993f,-1.12000006f,0.49540003f,-0.18990002f,0.66780002f,-0.11229996f,0.82930000f,-1.57050005f,0.54190002f,0.66410004f,0.43159997f,1.03029999f,0.64740004f,0.56679999f,-0.32010003f,-0.10630004f,-0.04230000f,0.65180003f,1.22809996f,-1.45330001f,-0.42759998f,-1.37939993f,1.01990000f,0.21460002f,0.83720000f,-0.98940000f,-0.57279998f,-0.01260003f,0.47129999f,0.27670000f,-0.10070003f,0.31980000f,0.59500007f,-0.47570004f,-1.15760005f,0.61490002f,-0.15169999f,0.45830003f,-0.63470003f,0.94980001f,0.40319998f,-0.93619998f,-0.32770001f,-0.25659994f,-1.01080007f,0.09390000f,0.81080002f,-0.36700001f,0.02970002f,0.42859998f,-0.06999999f,1.93609992f,0.52029995f,0.42469999f,-2.14579997f,-0.33019997f,-0.24240001f,1.87679997f,0.40809996f,-0.05710000f,-0.26599997f,0.87110000f,-0.55619998f,0.75800001f,0.98139998f,0.23450004f,-0.57170001f,-0.54819999f,-0.29890000f,-0.57550002f,0.25210002f,-0.52940002f,-0.09399999f,-0.27039998f,0.74730001f,-0.60660001f,0.92430000f,0.00969997f,0.67839998f,0.22909999f,1.27770004f,-0.29999998f,-0.88330000f,0.14640004f,-1.29430003f,-0.45339998f,0.78400002f,0.85680005f,0.07950000f,0.61970002f,1.31650000f,-0.05740002f,-0.29590000f,-0.08090002f,-0.10510004f,-0.78950002f,0.12030003f,-0.17099997f,1.27550004f,-1.23450007f,0.64220003f,-0.95040006f,-0.24360006f,0.16229995f,-0.37960006f,0.87270007f,0.20139996f,0.46930002f,-0.93660002f,-0.61490001f,-0.09920000f,-0.50640002f,-0.09969998f,-0.76640003f,0.97150006f,0.11780001f,0.19819993f,1.73449999f,-0.51440002f,-0.03610000f,1.37660001f,0.37420000f,0.32469998f,-0.50000001f,0.85229995f,-0.53970001f,1.42830000f,-1.21680004f,1.33869997f,-0.14979997f,0.27900000f,0.30089998f,-0.13960000f,-0.22730006f,0.10849997f,-0.85549998f,0.55789995f,-1.33100004f,-1.35440005f,-1.18329999f,1.16619998f,0.78830000f,-0.15770005f,-0.06219999f,1.23130001f,0.16179999f,0.37499999f,-0.36280002f,0.29740004f,-1.19249998f,2.26669998f,0.00689997f,-0.53470003f,0.16940001f,0.62099996f,1.17269996f,-1.35359999f,1.19670000f,0.37990004f,1.39510004f,-1.17889999f,0.30220001f,-0.14290005f,-2.35370001f,1.80270004f,-0.05619999f,0.27930000f,-0.16810003f,0.33490004f,0.25470000f,1.20340002f,0.84499997f,-0.69950002f,-0.43029994f,-1.83810002f,0.72769999f,1.76499999f,0.43479994f,-0.57850007f,-0.20199997f,0.25140001f,0.14359999f,-0.61870001f,0.91040000f,0.40459994f,1.20139998f,0.77130002f,-0.39129997f,-0.73439998f,-0.46970004f,1.11139996f,1.19359998f,0.31799997f,0.76559999f,0.05369998f,-0.27520000f,0.82260003f,0.72800003f,-1.96090006f,-1.03070004f,1.61289999f,-0.50750005f,-0.90609995f,0.78329997f,-1.49550004f,0.97210002f,0.06310001f,0.35530000f,0.06679999f,-2.21070004f,-1.01550001f,0.23490002f,-0.58020005f,-0.72990003f,-0.01459998f,0.97420007f,-1.42850004f,0.12300001f,-0.06340000f,-0.35059999f,1.28129998f,0.38889998f,-0.65709996f,-0.93289998f,1.28700007f,-0.81250000f,-0.60790004f,1.12910000f,-0.31689997f,0.48050003f,-0.05240004f,-0.50780002f,-0.86339998f,0.12679999f,1.93149997f,-0.77950001f,0.40320003f,-0.07589999f,0.76910002f,-0.25660000f,-0.39860002f,-0.11069997f,-0.46859999f,0.64890000f,0.83779999f,0.66869999f,-0.80310003f,-1.19250000f,1.07579998f,0.44969995f,-0.71390003f,-1.13820003f,0.42310000f,0.49530000f,-0.16509995f,-0.85599997f,-1.23389997f,-0.16280000f,2.18309996f,0.12859998f,-0.75899999f,0.25559997f,1.45729999f,0.37769996f,-1.12649999f,0.49450003f,0.73429999f,0.61250000f,-1.14320000f,-0.34790002f,0.71609998f,-0.76519998f,-0.00100004f,-0.76129996f,-0.09909998f,-1.09270000f,0.27069996f,-0.87570003f,0.61520001f,-0.91470000f,-0.39700003f,0.15179999f,-0.60099999f,-1.84189997f,-0.13769996f,-0.64410002f,-1.56060002f,-1.35900002f,0.12590006f,0.12850000f,0.18880000f,-0.58599999f,-0.26509996f,-0.15599998f,1.31269996f,-0.67470001f,0.02410000f,-1.10780000f,1.52730002f,-0.31910001f,-0.24290002f,1.13439998f,0.53630005f,1.20210002f,-0.06899999f,0.59239999f,-0.27970002f,-0.57620003f,-0.14269998f,0.64809999f,1.20670001f,0.53489997f,-0.20039999f,0.81549998f,-1.80150002f,1.58930001f,-1.28950003f,1.05439999f,1.07089998f,-0.09040000f,0.51249999f,-1.08279992f,0.58280001f,-1.29259997f,-0.38509999f,0.50119998f,-0.72400003f,0.31110000f,-0.29790001f,0.13900000f,-0.19690004f,0.22330000f,0.77460003f,-0.67840002f,0.75320002f,0.12360001f,-1.28460006f,-0.66129999f,-0.53980002f,0.42480002f,-0.71190002f,0.94600004f,-0.21829999f,1.08020007f,0.08249998f,-1.27970003f,0.18090000f,-1.78750005f,1.10990006f,0.18040003f,-0.99990001f,0.39730000f,-0.40660000f,0.74689997f,-1.13089997f,1.58830000f,0.81529998f,0.46749996f,-0.12169998f,-0.59789998f,0.69309998f,-0.34710000f,0.20840003f,0.53919999f,-0.13860000f,0.99650000f,-0.47339999f,1.20280000f,0.20849998f,0.11250000f,-0.03179999f,-0.26560000f,0.78479999f,0.58630002f,-0.14180002f,-0.95029999f,-0.21549998f,-0.68830002f,0.65920001f,-0.29959999f,-0.03170000f,-1.07780000f,-0.00250001f,-0.28040001f,-0.61300001f,1.81029992f,-0.34530002f,0.72699998f,-1.15539996f,0.62059997f,-0.60920005f,1.72779994f,-1.64409997f,-0.34569997f,0.26240000f,0.80389997f,-0.63260001f,-0.45560002f,0.29079996f,-1.00930001f,0.20590005f,-0.51610004f,0.98550002f,0.74390001f,0.02669992f,0.40080006f,0.55770005f,-0.15700003f,-1.01610003f,1.40480002f,-1.12910003f,0.99260005f,0.07179995f,-0.57070000f,0.98819998f,-1.62700003f,-0.27429997f,-0.91049997f,-0.32460006f,-0.58529999f,0.88440003f,0.94629997f,-0.61570000f,1.10519995f,1.80679997f,0.34709999f,0.31969999f,-0.10639993f,-2.41850003f,-0.28879998f,0.31009996f,2.09409997f,0.07069997f,-0.94399999f,0.90710003f,-0.10230002f,-1.85730003f,0.69980000f,0.93410004f,0.00010001f,-1.37030003f,1.12930004f,0.12670003f,-0.99880000f,2.04180000f,0.01859998f,-0.82220005f,0.17390001f,0.69820003f,0.22330001f,0.22340002f,-0.70060005f,0.86370008f,1.12510000f,0.02680001f,0.28179994f,0.00999998f,-0.70780001f,-0.45520002f,1.48669996f,0.07170000f,-0.17760000f,1.57830003f,-0.99120000f,-1.27279997f,-0.08739997f,1.08599998f,-0.75750001f,1.39680002f,-0.46750001f,0.08890001f,0.16800001f,1.46170000f,-0.65599999f,-0.68829996f,1.12769998f,0.61079997f,-0.11549996f,-0.82570002f,0.64760001f,1.52080002f,-0.61100003f,0.15950002f,0.83590001f,-1.18010002f,-0.70390001f,0.43049996f,-0.00640000f,-0.28320001f,-1.53900001f,0.62020001f,-0.09259998f,-0.45910003f,-1.49779999f,-0.28169996f,-0.38899996f,0.10089997f,0.70599995f,-1.16730002f,1.93259999f,-0.73290003f,-0.21599997f,-0.00060003f,0.59699999f,-0.38540003f,0.25200001f,-0.91350000f,0.36729999f,1.12560000f,-0.32320000f,-0.91159999f,1.26019998f,-0.03390000f,0.71959999f,-0.42910001f,0.94760000f,-0.26300000f,-0.86520001f,-0.17019998f,1.02909999f,-0.62050001f,-0.37610001f,0.75120000f,-0.55860000f,0.24849998f,-0.51509999f,0.85500000f,-0.45519997f,0.51560000f,-0.03149998f,-0.81339997f,0.14999998f,0.87769998f,0.89389994f,-0.24040003f,0.12999998f,-0.24810000f,-0.40409998f,0.76819995f,0.37330003f,-0.57509999f,-0.30389998f,-0.02930004f,-0.47060000f,-0.86779997f,-0.10470004f,0.79210001f,-0.47279999f,1.17639997f,-0.96439997f,-0.73970000f,0.09579999f,0.16779999f,-0.78709999f,0.30929996f,0.95249997f,-0.95159999f,0.64329998f,-0.75980001f,0.45519996f,1.21760001f,-0.37640001f,-0.09370004f,1.30359999f,-0.80669999f,0.25550000f,-0.08320000f,1.39050005f,0.16260002f,0.69140001f,-0.23120002f,-0.77400000f,0.39420000f,0.46130001f,-2.21399996f,-0.45630000f,1.26559995f,0.27150000f,1.96890003f,0.35789997f,0.17389999f,-2.54050005f,-1.01319997f,-1.54630000f,0.21650006f,-0.90160001f,-1.46009997f,0.67749998f,1.10850003f,-0.39510003f,-1.34730002f,0.25030000f,1.00940001f,-0.30520004f,0.86750003f,-1.27880000f,0.04440002f,-1.08579999f,-0.21809995f,0.13970002f,-0.57070000f,-1.02550002f,-0.99409999f,-0.21649998f,-0.70360008f,-1.69010004f,0.62710005f,0.19269999f,-0.24340001f,-1.23760004f,1.01210006f,1.27850006f,-0.48170002f,-0.58359999f,-0.42339999f,-0.58459998f,-1.49420003f,0.33370003f,0.32630002f,-1.35960001f,-1.36940002f,1.44610005f,1.92930006f,-0.16870000f,-0.37110003f,-0.53909999f,-0.16870001f,-0.09069999f,0.31100003f,-1.02069997f,0.36560001f,-0.52020003f,0.40870003f,0.07940006f,-0.81630006f,0.44720000f,-0.16579998f,-0.24200002f,1.05690000f,-0.31999999f,-0.41980004f,0.00259996f,0.87570004f,0.34870002f,0.15589998f,-0.73870001f,-0.38950000f,0.15980001f,-1.14410007f,-0.12469998f,0.81880006f,0.59599998f,-0.37650008f,0.30750003f,1.11280004f,-1.80100005f,-0.76140002f,-0.24740005f,-0.30780002f,-1.64510003f,-1.74590003f,0.41440000f,-0.68839996f,-1.53509999f,0.43179998f,1.05580001f,0.08129997f,-0.56340006f,0.63050007f,-0.81420000f,0.58110000f,0.00959998f,0.46900003f,-1.20380003f,0.82360005f,0.40950002f,-0.73490005f,-0.98210003f,0.99180002f,0.49780001f,-0.07420000f,-0.39930001f,1.19670002f,0.37760002f,0.11790000f,1.75840006f,-0.28540004f,-1.10420006f,-0.65500000f,2.00930006f,1.40039999f,0.79249996f,-0.46840004f,0.55590001f,1.23979997f,-1.29150001f,0.68160006f,-0.42159998f,1.25610000f,1.05830000f,-0.69840004f,0.29319999f,-0.75269999f,0.27879998f,0.51799996f,1.12159997f,0.02589999f,-0.20570001f,-0.17490000f,0.20219999f,-0.96660000f,1.09050001f,-0.77460000f,0.35559999f,-0.47949998f,0.16719999f,-0.51809998f,-0.24949999f,-0.38680003f,-1.29940001f,0.79330001f,0.50220004f,0.61030004f,0.60310005f,-0.25979998f,0.88129999f,-0.21080000f,0.34780001f,-0.42269998f,-0.16359999f,-0.89130002f,0.52450000f,-0.74420000f,-0.03819999f,-1.17690002f,0.12370001f,-0.43589996f,0.08020004f,-0.08300001f,0.53359999f,0.04099999f,0.02290000f,0.13780003f,-0.40349997f,1.42739995f,-0.60519998f,0.21680001f,-0.31429999f,-1.49479999f,-1.10279998f,0.74639997f,-1.16510000f,-1.70770000f,1.05930002f,0.43710001f,-0.90690002f,-1.43080003f,-1.07690005f,-1.31010001f,-0.82200000f,-1.46920000f,0.21210001f,-0.54129999f,1.45600006f,0.49890004f,-0.52409995f,-1.64370002f,-0.26110008f,0.96330001f,-1.37460001f,1.55579996f,0.69879997f,0.02950001f,0.23730001f,-0.08499999f,-0.64889996f,-0.89990008f,0.79660000f,1.26770010f,-0.78199998f,-2.24180001f,-0.05419997f,1.02940001f,0.79570002f,0.09739997f,0.69239999f,-0.51929998f,-0.39040004f,0.09020001f,0.40660001f,-1.30370003f,-1.03600000f,-0.24330005f,0.42870000f,-1.00439998f,0.83209999f,-0.83170000f,0.25160000f,0.67099994f,1.01399992f,-2.03670000f,1.17710006f,-0.04880003f,0.82189997f,-0.92200000f,0.29820003f,0.84460001f,-0.95550003f,-1.09340000f,0.60669999f,-0.79499999f,1.06210000f,-1.46770000f,0.56770000f,1.15569999f,-0.69320000f,-0.30629999f,0.25840003f,-1.74960008f,0.20890002f,-0.21840001f,0.46360002f,0.71910002f,0.28050000f,0.47800003f,1.47499999f,-0.16560002f,0.15530000f,-0.18130000f,0.09110001f,-0.68439999f,1.23839996f,0.26009998f,1.01749995f,0.42799999f,-0.42069998f,-0.46809997f,-1.23019994f,2.20209995f,0.22069997f,-1.91199996f,0.79150000f,-0.33480001f,0.16250000f,0.75450005f,0.56039999f,-1.29420003f,0.74970003f,1.21150005f,-0.13760002f,-0.79430004f,-0.20989999f,1.31840003f,0.46670000f,0.73680003f,-0.80620002f,0.50890001f,-0.48900004f,0.62160005f,0.02349998f,0.02309997f,-0.00410001f,-0.19589999f,-0.22320002f,-0.80360005f,0.36819999f,1.21230000f,-1.54999998f,0.54540003f,-0.15129999f,-0.40500004f,-0.96959998f,0.21309998f,0.98360004f,-1.16330002f,-0.91299999f,0.26110000f,-0.22519999f,-0.05970005f,0.48300003f,1.19060008f,-0.61290005f,-1.18390003f,0.84900004f,0.15889999f,0.50400001f,-0.96390003f,0.47130001f,0.25030005f,-1.26910005f,-0.23369997f,0.76810004f,-0.85220007f,-0.42520003f,0.32090003f,-0.77640003f,-0.03310000f,0.53460004f,0.63870005f,-0.41540002f,0.87330003f,-1.22779998f,-1.92170001f,-0.41400000f,0.62490002f,2.22229996f,-0.81700005f,-0.83690001f,-0.23780000f,0.87070001f,0.92430002f,-0.71610003f,1.18940002f,-0.14480000f,-1.26450006f,0.33450002f,1.37290004f,-0.51469999f,0.26099996f,-0.30529997f,1.20600002f,-0.42070002f,-1.07940002f,0.69420001f,-1.36610001f,-0.82760001f,0.77980004f,-0.12850000f,0.17139998f,-0.89450002f,-0.55710001f,-0.28029996f,-0.50700006f,-0.95659999f,0.33620003f,-0.87199999f,-0.08609996f,-0.17039996f,0.16260000f,-0.02920000f,0.45260000f,-0.54980000f,-1.40540000f,0.14090002f,0.34509995f,1.88019995f,-1.11020000f,-0.81919995f,-0.22779996f,-0.25230001f,-0.11009997f,-0.84120002f,0.46060001f,-0.67890001f,0.25550000f,-0.40620000f,-0.03950000f,0.06620000f,0.94930001f,0.26400000f,-1.36480003f,0.95610002f,-0.31720000f,0.94709999f,-0.45450001f,1.11329999f,-0.05820001f,-0.03250002f,0.37970000f,-0.39990000f,0.18249999f,-0.90340001f,1.24790003f,-0.74890001f,0.64070003f,-1.09009998f,0.54740003f,0.27270000f,0.60669998f,0.05939998f,0.67089997f,-0.58269997f,0.24799999f,0.24260002f,0.12429998f,1.09710000f,-0.71930000f,0.39749999f,0.22339997f,0.10350002f,0.22450000f,0.38630000f,0.02800006f,-0.80360004f,-0.97830007f,0.85950004f,1.93650001f,0.48210006f,0.81359999f,0.10060001f,1.28060003f,-1.47989999f,0.65730002f,0.09060004f,-0.18230004f,-0.70580008f,1.13690008f,1.31540003f,-1.05380001f,0.44710002f,0.73889998f,0.44159999f,1.92239998f,-1.89229994f,-1.02969998f,-0.83539993f,1.82820001f,-1.02110001f,-0.00369997f,-0.45859994f,0.33230002f,0.18710001f,-1.29040002f,0.67609999f,-0.60089997f,0.01429997f,0.74780000f,-0.36799999f,-0.59890001f,0.10790001f,-0.16610000f,0.33729999f,0.37570000f,-1.02309999f,0.30440005f,0.12860001f,1.63129997f,-0.07310002f,-0.63959996f,-0.84759998f,-0.28489997f,-0.21250000f,-1.09760001f,-0.85270000f,0.80760003f,0.02559999f,0.09150001f,-0.07280001f,0.99109999f,0.08509998f,-1.28499996f,0.67500001f,0.45799998f,-0.42749998f,-2.03729999f,-0.96350000f,0.51039997f,0.90880002f,-0.09740004f,0.25200003f,0.55859997f,0.78970004f,0.51290001f,0.12310000f,-1.32259999f,-1.38360001f,-1.44349997f,0.67370005f,1.05820010f,0.88510001f,0.21699996f,0.95509999f,-0.21700001f,0.22680002f,-0.90400001f,0.59620000f,1.58869998f,-0.30600001f,-0.42350000f,-0.01469999f,-1.26540000f,-0.90000003f,0.83950001f,0.33940002f,-0.70890002f,-1.33099999f,-0.20320002f,-0.68780000f,-0.04650004f,-1.04740005f,1.09220003f,1.02640000f,-0.39649999f,2.15100000f,0.11189998f,-1.91099998f,-1.82269998f,0.57270000f,-0.06390002f,1.08690001f,-0.75780007f,0.54480002f,1.38410002f,-1.83800004f,-0.30359998f,0.00770002f,1.08489994f,0.40369997f,0.61620000f,-0.07659998f,-0.61319999f,-0.01129999f,0.45060000f,0.42630000f,-0.00930002f,-0.37280005f,-0.60499993f,-1.19810000f,0.86860003f,0.05440004f,0.03739997f,0.20750000f,-0.07799996f,1.37160003f,-0.62360001f,1.17620005f,-0.81570001f,0.15540001f,0.44200001f,0.12590000f,0.59589999f,-1.03390003f,0.31400002f,-0.11110000f,1.14210008f,-0.29730001f,0.98050008f,0.18289998f,-0.35950001f,-1.22780005f,-1.95580001f,0.37649997f,0.29679998f,0.17689999f,-0.34559999f,-0.64109999f,-0.78840000f,-0.41160002f,-1.02900000f,-0.48939999f,0.42150002f,-0.26160002f,2.14740001f,0.21800000f,0.49660000f,-0.36749996f,1.30730002f,-0.34569996f,0.04119996f,-0.67399996f,0.44820000f,0.57840002f,0.21229997f,0.08760000f,0.44990001f,-0.38380000f,0.29380003f,-1.06790005f,-0.33630000f,-2.39280003f,-0.13759996f,-0.16829999f,0.90650002f,-1.02020002f,0.13730001f,-0.02600003f,-0.41580005f,-0.50400001f,0.45600000f,-0.66480000f,1.73379999f,-0.46430003f,-0.05470001f,-0.80569998f,-0.19929998f,-0.77250001f,0.06870002f,-0.47449999f,0.94739999f,-0.10870000f,-0.21680003f,0.63200000f,-1.37320006f,0.08709997f,1.61990002f,-0.09040000f,-1.21329998f,-1.31680000f,0.60510000f,-0.24979997f,1.12600002f,-1.11980001f,0.91210006f,0.07680004f,-0.07300003f,0.17740001f,-0.79800000f,-2.64130002f,-0.57159997f,1.73190003f,0.07160000f,-1.70880002f,0.30130006f,-0.51590000f,-1.18709997f,-1.52749998f,-0.53769996f,-0.42589996f,2.38269995f,-0.11560005f,-1.02469997f,-0.38109998f,0.79399999f,-0.37219999f,0.33230001f,0.22949999f,1.06589997f,-0.33710000f,0.11030002f,0.11510001f,0.90419995f,-1.10870001f,0.97930006f,-0.13000000f,0.04509999f,-0.54280000f,1.07070001f,0.42110002f,0.20349999f,0.13449998f,0.14609997f,-1.02559999f,-0.10770001f,0.06970002f,-0.49990004f,-0.88210002f,0.12930000f,1.37820003f,1.49700001f,-0.41389995f,0.42110000f,-0.22039999f,0.51499995f,0.61259995f,0.30830000f,-0.80979999f,1.38780000f,0.81070000f,-0.64450002f,0.22700003f,-0.73610004f,-0.91170004f,0.65980003f,-0.04090001f,-1.14800002f,-0.37140002f,-1.16020002f,-1.82710003f,0.75079999f,0.05060005f,-0.89750002f,0.39650001f,0.78140002f,0.84950000f,-0.11220002f,-0.45410004f,-1.24780001f,-0.21370002f,-0.96780000f,-0.39619997f,0.85280001f,-1.02879997f,1.62120008f,-0.25349998f,1.00700001f,0.02619995f,-0.04080000f,-0.64900002f,-0.16999999f,-0.05090004f,-1.00610005f,-1.21510003f,0.77499999f,-1.43760001f,-0.66170001f,0.73810001f,1.62840005f,0.90290002f,0.81800007f,-0.33520007f,-0.71820001f,1.04650001f,0.69710003f,0.02270001f,1.06120008f,-1.76650002f,0.81510004f,-0.82860003f,-1.46650007f,0.54220003f,1.12590005f,1.61210002f,0.79480001f,0.67670002f,1.22820005f,-0.64040002f,0.06850000f,-0.13009998f,0.06699998f,-1.00660004f,-1.40460004f,-0.95810000f,0.92750003f,-0.50539996f,0.56739999f,0.28859998f,-0.07720001f,-0.05910005f,0.43430005f,0.58830000f,0.27470000f,0.84480000f,-1.17289997f,-0.06890008f,0.30359998f,-0.47319997f,-0.58970001f,-0.19319999f,-0.44489996f,-0.11090001f,0.66020000f,-1.25490000f,-1.75360006f,1.47920001f,0.33619998f,-0.13280001f,-0.76560004f,0.28580002f,0.49950005f,1.19360003f,0.96620001f,0.09920003f,-0.32190002f,0.09520006f,0.47790005f,1.71490004f,1.25479999f,-0.76429999f,0.40560002f,-0.31370000f,-0.50730003f,0.32170001f,0.46160001f,-0.27779997f,0.37840004f,0.45530000f,-0.32679998f,1.06349999f,0.39010004f,-0.51610000f,0.52610004f,-0.45740002f,-0.25020001f,0.04010002f,0.66010001f,-0.85610002f,-0.78490001f,1.13149997f,-0.49510006f,1.48500006f,-1.26790005f,-0.72910003f,-0.51240003f,0.12130000f,-0.26040001f,-1.66070005f,-0.49920002f,0.35230000f,0.31129998f,2.05190002f,-0.02210002f,0.85350002f,-0.22720005f,1.40619997f,-0.00099999f,1.37979999f,-0.08160000f,1.20420000f,-0.02470000f,-0.62310002f,-1.12110000f,-1.08420003f,0.72600003f,-0.22180000f,-0.21020000f,0.37589999f,-0.36889999f,0.15759999f,-1.02210007f,1.14500005f,-0.50120000f,1.14660000f,1.08430003f,0.75439997f,0.25630003f,0.15579997f,-0.67520005f,0.51630000f,-0.64670003f,-0.26690002f,-0.86960000f,-0.16030000f,0.40260003f,1.13230002f,1.03010001f,0.19809995f,-0.69380003f,0.95500000f,-0.20649999f,1.18039995f,0.83259998f,-0.13320001f,0.81350001f,0.79459997f,-0.21409998f,1.84819999f,-0.29209999f,1.31910000f,0.31020000f,-0.37900000f,0.31110001f,1.27820004f,-0.47699998f,0.03400001f,-0.11369998f,-1.16150000f,-0.68460000f,0.36769994f,-1.10360007f,1.89300003f,-0.74120003f,1.32250002f,0.59130002f,-0.57590001f,-0.57379998f,0.69370000f,-0.60200002f,-0.36970000f,-0.42380001f,0.07229998f,-0.92150000f,0.15579999f,-0.16549999f,1.12000001f,-0.77400003f,0.00770000f,0.46760001f,-0.34070001f,0.41319997f,0.51609999f,0.20170002f,1.31819998f,-0.58570001f,-0.41240002f,-0.43250000f,-0.18870002f,-0.13660002f,-0.01040000f,-0.93000003f,0.12020001f,1.08420006f,-2.24719999f,-1.47270004f,0.54520000f,-0.11430000f,0.68770000f,1.06510003f,-0.04919999f,-0.73380002f,0.67050000f,0.70580001f,0.62970004f,-0.33220000f,-1.01510000f,-0.05669999f,0.52100003f,0.80630002f,0.18420000f,-0.25889999f,-0.27489999f,-0.41529999f,-0.44040000f,-0.65080000f,-0.40570001f,-0.59150002f,-1.34739999f,0.85399998f,-0.33790000f,-0.22409999f,1.14139995f,0.84289999f,0.28389999f,-1.07930001f,0.23809998f,0.37219995f,-0.29699999f,0.52739996f,-0.27769999f,1.26999999f,-0.03590003f,0.67339994f,0.30410001f,0.02839998f,-1.33850001f,-1.85889999f,-0.30679992f,-0.60130002f,0.19350001f,-0.18829999f,0.97110005f,-0.62560001f,-0.91789998f,-0.65440001f,0.74930002f,-0.22669998f,1.42620001f,1.17700002f,0.91149999f,0.37370003f,-0.20590001f,-0.27750001f,0.78739998f,-0.64479999f,0.12169996f,0.97930005f,-1.10150000f,1.15410002f,-1.29180002f,0.83140004f,-0.84410002f,-1.86190004f,0.29370003f,1.27620001f,-0.61690000f,-0.46800003f,0.24880001f,-1.61750001f,0.39980003f,0.50610003f,0.74850003f,-0.56489998f,0.99029997f,0.16120000f,0.58149997f,-0.78380001f,1.13519998f,0.91230001f,-0.29599999f,-1.44879997f,1.22760002f,0.33989999f,0.50990001f,0.37020005f,-1.81700003f,0.81420000f,-1.44160001f,0.76519999f,-1.06109999f,-0.09430001f,-0.52030007f,0.38440003f,-0.02549999f,1.10069999f,-1.80300000f,0.68580000f,1.50010002f,-0.04369997f,0.69000001f,0.44790002f,0.53440001f,0.43440000f,0.84010000f,-0.83720000f,-0.53229996f,-1.16939994f,1.75669997f,-0.40259998f,-0.98180000f,0.19189999f,-1.34189999f,0.35869999f,0.53689999f,0.78910002f,1.08629998f,0.19979999f,-1.01339996f,0.76009998f,-0.49899999f,-0.65420002f,1.03649997f,-1.12150000f,1.39710001f,0.93790000f,-0.51939993f,0.14929997f,0.83109997f,-0.83330000f,1.26630001f,-0.62130004f,1.33300002f,0.64790002f,0.08990000f,-0.35990001f,-0.91910001f,-2.29519993f,0.18029999f,0.60289997f,-0.11889999f,-0.57119999f,-0.61720002f,-0.58659998f,-0.62940002f,-1.36680003f,0.47700002f,1.05020001f,-1.33549996f,-0.31100001f,0.98620000f,0.33700003f,0.07189996f,0.78390000f,-0.23130005f,0.67709999f,-0.57520000f,-0.71310002f,-1.24360005f,-0.61190001f,0.22469998f,0.38990004f,0.26480003f,0.95259998f,-1.43369998f,-0.68070007f,1.35500005f,-0.37610002f,0.53290003f,-0.63640002f,0.87220003f,0.67500003f,0.53009997f,-0.62970003f,-1.29259996f,-0.83479996f,1.78239999f,1.46350002f,-1.03720005f,-0.60269997f,-0.46180004f,0.39799995f,-0.66530003f,0.20230000f,2.22450004f,-0.41559999f,-0.16500005f,-0.37940003f,-1.78500005f,0.07180000f,-0.47650002f,-0.74770000f,-0.61580001f,1.20830001f,0.42480002f,1.17960001f,-0.57409995f,-0.18280004f,-0.29970006f,-1.09340002f,0.70230003f,-0.48410001f,0.31600001f,-0.02659996f,-0.55760002f,-0.39269999f,-0.70359996f,0.17850007f,-0.49580002f,0.87249999f,0.98320002f,0.50269998f,-0.48940002f,0.91320000f,-0.67840001f,0.18489994f,0.36880002f,1.10780001f,-1.18670002f,0.00870000f,0.47849999f,0.28760000f,-0.21449999f,0.10970002f,1.28739999f,-0.32469998f,1.17479999f,-0.01360000f,-0.52780002f,-1.01860006f,1.41550004f,-0.19700001f,0.52540004f,0.54580001f,-1.20970001f,0.65530000f,-0.12700000f,0.85220000f,-0.83829998f,-0.69830005f,0.50549997f,-0.75380000f,-1.19889998f,1.15260001f,-1.17660002f,-0.97699996f,1.19559998f,-0.29089997f,-0.10929998f,-0.47769996f,0.35790000f,1.18029998f,0.37089999f,0.18229999f,-1.17030002f,0.24930000f,1.01959999f,0.66240004f,0.43369997f,0.57899997f,-0.74970002f,-0.54860003f,-0.40340001f,-0.39000000f,-0.34920002f,0.37020005f,0.67810001f,1.77129999f,-0.63069996f,0.34880003f,-1.29339999f,0.22130000f,-0.83740000f,1.51250002f,0.04859998f,0.37729995f,1.05899998f,-0.82920007f,-1.03599994f,-0.35500000f,0.60199999f,0.79030002f,-0.05839999f,-0.24289999f,-0.83889999f,0.11400002f,0.95240001f,0.14690000f,1.41550002f,-0.23430001f,-0.36709998f,0.20060000f,0.14700000f,-1.36470005f,0.40550002f,0.84040003f,-0.98920004f,0.36650000f,-0.75790000f,-1.23240006f,0.28540001f,0.31950001f,1.42630005f,0.41519999f,0.23189998f,0.17789999f,0.80820002f,1.46260001f,0.48900004f,-0.59050003f,-0.69960001f,-1.10200001f,-1.17450002f,-0.77930002f,1.16939998f,0.64109999f,0.47579998f,0.22169999f,0.88539997f,0.49679998f,-0.34089998f,0.58460003f,0.49399998f,0.00359999f,1.16029998f,1.00910005f,-0.42000003f,0.20320005f,-1.27010004f,-0.80470002f,-0.44510001f,-0.05069996f,-0.52290005f,-0.28550002f,-0.78069997f,-0.27360001f,-0.26630002f,-1.45200000f,-1.08770000f,-0.77589996f,-0.45799999f,-0.48349997f,-1.09229999f,0.58210003f,1.35280000f,-0.02760004f,-0.27629995f,0.04210003f,0.39789998f,-0.43440001f,-0.65280000f,-0.23479999f,-1.32620000f,0.05890002f,1.03939995f,0.19669999f,0.83769997f,-0.49899997f,-0.75910000f,-0.01769998f,-0.46880004f,0.48400002f,0.98279998f,1.13260003f,-0.05020002f,0.35090000f,0.33970000f,-2.10370001f,2.36699998f,0.57059998f,0.69600000f,0.02310000f,1.09999997f,-0.23619997f,0.73479998f,0.84679998f,0.85390000f,-0.79850001f,0.36719998f,-0.14679998f,1.38479997f,0.78979997f,0.83409999f,0.53010003f,1.68760001f,-0.83280001f,0.69620005f,-0.66539999f,-0.67129996f,1.06760001f,0.13840001f,-1.05930003f,1.36649998f,0.07509998f,-0.58510004f,0.37860003f,-0.66400003f,-0.24520001f,-0.29479999f,0.29659996f,0.65530000f,0.40120003f,-0.86989998f,-0.56780005f,1.11680003f,-0.50259999f,1.18810002f,0.82600005f,-0.33990004f,-0.83390001f,-1.13900000f,0.62340001f,0.51610000f,-1.30150004f,-0.27329999f,-0.03039996f,-0.49700002f,-0.40259999f,0.29349997f,0.11979999f,1.10410001f,0.89010003f,-0.32619998f,1.54290003f,1.19200000f,-0.68810004f,0.14939997f,-0.89260003f,-1.41150001f,0.37369999f,-0.91199999f,-0.81240000f,-0.11709997f,0.65970000f,0.05500002f,-1.14780005f,-0.22589996f,-0.88950000f,0.56389997f,1.47600005f,-0.57470001f,0.73300004f,-0.96440000f,0.64560001f,-0.53850000f,0.19729997f,-0.31050002f,-1.88360004f,-0.00780000f,1.08450007f,-0.13870000f,0.70290000f,-0.97460003f,-0.27600001f,-0.41449999f,0.10339997f,-1.66560000f,-0.07410001f,-0.90859998f,0.93419999f,-0.49620000f,-0.19459999f,0.43139999f,0.60730000f,0.90409998f,0.48770001f,0.95019997f,-0.49420002f,-0.45420002f,0.07040000f,0.67750005f,0.02710002f,-0.69159997f,0.42710002f,-0.49080004f,-0.99180001f,0.53540000f,-0.58220001f,-0.28380000f,-0.71250000f,0.74159998f,1.34490005f,-0.45700003f,-0.91590002f,-0.34829999f,0.18840000f,0.16189998f,-0.68660000f,0.43529999f,-0.56540000f,-0.18019998f,1.19750006f,0.48920002f,0.30109998f,-0.50160002f,0.58010000f,0.91669998f,-0.64729998f,1.18619996f,-0.18970003f,-0.99810000f,0.61320000f,-1.34980002f,-0.08350001f,-0.11980002f,0.53030002f,-0.11959998f,0.27940003f,0.01199999f,-0.14959993f,-0.16439999f,1.29370000f,1.25100002f,1.12779998f,-0.28100005f,0.90559998f,-0.61409999f,-0.77879995f,-0.81690008f,0.45500002f,-0.88840003f,1.27530001f,0.85730003f,0.41620001f,0.50720000f,-0.09230001f,-1.04690001f,-0.16480002f,0.05210003f,-0.30390000f,-0.46369999f,0.28510002f,-0.96059997f,0.85900001f,-0.55839998f,-0.41810004f,1.14399998f,-0.54990001f,0.65220001f,-0.72020001f,1.46450002f,0.33160003f,0.84589999f,-0.38060000f,0.41109997f,-0.08619993f,0.31019997f,0.74450001f,-0.57700000f,-1.30890004f,-0.02780001f,0.58479998f,-1.06980001f,-0.97740000f,-1.68950001f,0.12499998f,-1.39790000f,-0.01650002f,-0.25219996f,-1.19070001f,1.38490000f,-0.24069998f,-0.63780003f,0.07909999f,0.39170004f,0.54210002f,0.20440001f,-1.23260001f,1.36949999f,-0.53630000f,0.95960001f,0.52560000f,-0.23149997f,-0.12380002f,-0.66500006f,0.45990005f,-0.43509999f,-0.22810003f,0.29259993f,0.02429995f,-0.75810001f,-0.59510000f,-0.66070002f,-0.53849996f,-0.41679999f,0.33549998f,1.30860001f,-0.71760001f,-0.38659999f,0.53780000f,-0.26920002f,0.22400001f,1.46949998f,-0.00549999f,0.48599997f,0.52190001f,-0.15630001f,-0.00720002f,0.41600000f,0.93310003f,-1.01350002f,0.78710001f,-0.88479995f,1.00979999f,-0.56479998f,0.60350000f,-0.61039999f,0.47950002f,-0.61140000f,-0.02209999f,0.22490000f,-0.01310000f,-0.73210004f,0.31560001f,0.38709996f,-0.36139998f,0.25370000f,-0.11699999f,0.44060000f,-0.05600000f,0.38150000f,1.66230002f,-0.75689999f,0.00480003f,0.74820000f,-0.79769998f,1.22190004f,0.42830001f,0.19329999f,-1.06460006f,-1.51650002f,-0.63810004f,-2.03180005f,0.32010002f,0.31539999f,0.62609999f,0.97430001f,-0.25439999f,-0.11299995f,-0.30360004f,0.77839997f,-2.03320006f,2.29830004f,-0.50779997f,-0.59140002f,0.53310001f,-0.74919998f,0.45089998f,-0.61669999f,-0.03920002f,-0.24070001f,0.80529999f,0.19590000f,1.68079999f,-1.82300004f,-0.60880006f,0.24110002f,0.80640003f,0.09900002f,0.94820004f,-0.02820003f,-0.56770000f,-0.47739997f,-1.13230001f,0.78640002f,0.73920000f,-1.49920003f,0.74680003f,1.78260003f,0.13240001f,0.88149999f,0.24569999f,-1.52869999f,0.10429997f,-0.68840000f,-0.02369999f,0.49040001f,0.00420000f,-0.86270000f,1.18900002f,-0.41439994f,0.62519999f,-0.49710002f,-1.44850004f,1.57490000f,-0.97510000f,0.76179997f,0.52619996f,-0.46739997f,-0.55090000f,0.99239998f,-0.52509994f,-0.58370001f,0.13279998f,0.81820002f,1.23229998f,-0.59270004f,-0.64980007f,-1.63410000f,-0.29910001f,-0.51589999f,-0.63370003f,-0.12950001f,0.18290002f,-0.35189998f,-1.03349998f,-0.53880000f,0.08589997f,-1.03219998f,-0.06149999f,0.94959999f,-0.47119998f,0.96250003f,-0.51700001f,0.55560001f,-0.23579998f,-0.52050005f,-0.68580003f,0.28630001f,-0.68610001f,0.30450001f,0.26690002f,-0.30490003f,-0.52230001f,-0.88220000f,1.47649998f,-0.73629999f,0.69999997f,0.02550001f,0.48449998f,0.34990000f,-0.30190004f,-0.09920006f,-1.35769998f,1.86670003f,-1.19510001f,0.31650002f,-0.19760000f,-0.58859999f,-1.23100002f,-1.02220002f,-0.11580003f,0.04769998f,0.29200001f,-0.84420003f,-0.57510000f,-0.32460002f,-1.30720002f,0.16639999f,-1.64280001f,-0.88280001f,0.58670008f,-0.70239999f,0.85990000f,-1.11060002f,-0.38790001f,-1.43520000f,-0.12490000f,-0.21600005f,-0.36730000f,-0.18659999f,0.51170001f,0.94810001f,0.45930000f,-0.10010003f,-0.70180000f,-0.47760003f,0.13300001f,-0.50920000f,0.63370003f,-0.38570000f,1.45920006f,-0.94290001f,-0.72120005f,0.81860002f,-1.21270001f,1.16889999f,0.80650004f,0.33209998f,-0.51010002f,0.78040002f,0.64740002f,-1.26640001f,-0.75640004f,-1.19530002f,-1.30650002f,0.47659997f,0.32710003f,1.43160001f,1.08000001f,0.73300000f,0.37419998f,0.63990000f,-0.21650002f,-1.42750000f,-0.29130001f,-1.41120000f,0.25440001f,-0.55500000f,0.75070002f,0.59839995f,-0.88020001f,0.04529998f,0.72420002f,0.09010003f,-0.27530000f,-0.59170002f,0.94630005f,-0.04580002f,0.28890000f,0.01560002f,-0.45140000f,-0.78950000f,-0.23919998f,0.18549994f,0.74610001f,-1.10539999f,-1.25800006f,0.14090001f,1.09990000f,0.86150000f,0.62219997f,1.16400000f,-0.29400001f,-0.28339999f,1.15660005f,-0.19119998f,-0.93930004f,-0.20839998f,0.95430005f,0.07209999f,0.43750000f,1.34129996f,-0.24870001f,0.79859998f,-0.47590000f,0.48300002f,0.28749998f,-0.10749996f,-0.20490001f,-0.40479999f,0.18350002f,-0.84520000f,-1.18590002f,0.78390001f,-0.45450001f,0.47800000f,0.18890000f,0.44569999f,-0.37340004f,0.01760003f,0.95760005f,-0.58680004f,-0.37080002f,-0.11529999f,-1.00319999f,0.08569999f,-0.57350000f,-0.67600002f,-0.90250003f,-0.96280004f,-1.13010002f,-1.25510005f,-0.02729999f,0.03409999f,-0.43580002f,1.19309998f,-0.38950003f,0.28059999f,-0.40670000f,-2.22910002f,-1.04050001f,-1.15249999f,0.09559998f,0.37230004f,1.38919999f,0.10910000f,-0.30760000f,0.56590003f,-1.53110004f,1.96340002f,0.83940002f,-0.41420001f,2.57200012f,-1.85730008f,-0.01300005f,-0.21239994f,-0.44069999f,-0.97200000f,-0.36469998f,0.41630000f,0.63160004f,0.96969998f,1.32440000f,-0.42520001f,0.44249999f,-1.80400003f,-1.30609999f,-1.33409999f,-0.90249998f,0.47500001f,1.21070004f,-0.04569999f,-0.20790000f,0.40100001f,-0.90040003f,-0.31249998f,1.29730005f,1.16599999f,-0.22800002f,1.13439999f,-0.77359999f,-1.38900000f,-0.85250003f,-0.78740003f,-1.00450007f,0.63560006f,1.37300003f,-0.35010001f,-0.63520003f,0.14900003f,-1.45090005f,1.27320001f,0.22779999f,0.86639999f,1.88130006f,0.70610005f,0.08210000f,-0.77639998f,0.11430002f,-0.52960003f,-2.12350004f,0.19700003f,-0.08659995f,0.14010000f,1.18040002f,0.41370002f,0.41170001f,-1.33899998f,-0.38819998f,-0.43470000f,-0.10260002f,-0.57269999f,0.89249999f,-0.91469995f,-0.59240002f,-0.52050001f,0.11880001f,-1.07580000f,0.07060003f,0.12929998f,0.60570000f,0.32470002f,-0.06700001f,-0.21139998f,0.90910005f,-2.02750002f,-0.18690004f,-0.15579994f,1.11460006f,-1.03650003f,-0.15190002f,0.77119998f,0.07259996f,-0.21990001f,-0.12919999f,-1.16680001f,0.05289999f,0.18890004f,1.61000005f,-0.02129993f,0.91699999f,0.79510001f,0.36659998f,0.55010002f,0.00260000f,0.16980002f,-0.09090002f,-0.68549996f,-0.72520001f,-0.81459999f,0.59069999f,-0.37770000f,-0.43990003f,-0.37090000f,0.35140001f,-0.07249997f,1.26940000f,-1.52400001f,1.05479996f,-0.59990001f,1.13949999f,0.35969994f,0.01360001f,-1.29740001f,1.08479996f,0.90930001f,-0.14370002f,0.08369999f,-0.64750000f,0.51080000f,-0.57530003f,-0.40800000f,0.69050000f,-0.68129998f,-1.03409997f,2.15010003f,0.02150002f,0.83390000f,-0.50940002f,-1.06790005f,-0.12330002f,0.73410003f,-0.67460001f,0.56169999f,-0.20189998f,-0.18000005f,1.29470004f,-0.61669997f,0.67389999f,-0.99500004f,0.03149999f,1.43140001f,-0.35810001f,-0.43300001f,0.83519999f,-0.41520001f,-0.83910001f,0.42660000f,-1.64969996f,-0.16929997f,0.39460001f,1.20950001f,0.10290002f,0.03710002f,-0.68360002f,-0.76490002f,1.50910003f,0.50480000f,0.31120001f,0.94470003f,-1.34680003f,0.27169997f,-0.03230000f,-1.57840004f,1.39300004f,1.37009999f,-0.24860000f,0.20090005f,0.55009999f,-0.31570000f,0.08929996f,0.99090006f,-0.90620004f,1.60000002f,0.12150001f,-1.08559998f,0.73399999f,-0.67790001f,-1.05949999f,-0.25570000f,-0.53830001f,0.37459999f,-0.95549997f,-0.31160003f,0.66579993f,-1.20970000f,-1.67080000f,1.09559999f,-0.13949996f,0.02990001f,-0.36400003f,-0.87380004f,0.80860000f,0.39090001f,-0.22180002f,-2.09980002f,-0.46850005f,-0.32859994f,0.15659998f,-1.71860004f,-0.13120004f,0.99830002f,0.08269999f,-0.57170000f,-0.40810003f,1.08650000f,-1.57150002f,1.71889998f,-0.96779999f,1.66790006f,-0.91610004f,0.37449996f,-1.14800003f,-1.02500002f,-1.45130001f,0.90630000f,0.84560000f,-0.75810001f,-0.31070011f,-0.17650000f,0.39329999f,-2.08850003f,0.14269999f,0.74710000f,0.18929996f,-0.78280005f,0.99910002f,0.66170000f,-0.11419998f,0.60590000f,-0.60830002f,-0.51880000f,-0.32780001f,-0.71810002f,0.86410002f,0.02610002f,-1.25920003f,0.16950002f,0.68050001f,-0.51659998f,0.10749999f,0.06929999f,-0.74570001f,0.38449999f,0.23660002f,-1.08090000f,-0.13240003f,0.27729998f,-0.64890000f,-0.15829997f,0.28180004f,-0.11570002f,0.81810001f,-0.08479999f,1.22049997f,-0.40680000f,-0.87360000f,0.71840000f,0.57380003f,0.26569998f,0.38259994f,0.09560001f,0.00709999f,-0.27849999f,-0.31330001f,-0.37630003f,1.23550002f,-0.49239999f,-0.05840002f,0.77430002f,-0.18919995f,2.40640000f,0.65440004f,1.07840005f,-0.34960001f,0.35840000f,0.20230002f,-0.42339999f,-0.36960002f,0.47409998f,0.50680004f,0.07070003f,1.64030000f,-1.44419998f,1.59720001f,-0.86050002f,0.41169999f,-0.22150000f,-0.59210001f,0.17640001f,0.84860000f,0.07439998f,-1.28180001f,-0.72979999f,-0.59729991f,0.67160002f,-1.47739999f,-0.35399998f,0.41440002f,0.41230002f,0.16730002f,-0.11270000f,-0.83490004f,0.41640002f,1.03420005f,-0.32300001f,0.17070000f,0.73490003f,-0.97300003f,0.33589998f,0.02590000f,0.83919999f,-0.57210003f,1.57900003f,-0.18859998f,0.92590005f,0.22999999f,-0.54710003f,-0.07390002f,1.05810005f,-0.51910001f,0.32139998f,-1.52589999f,-0.21349998f,-0.79420002f,-0.44890003f,-0.42520003f,-1.29420000f,-0.53499998f,0.99270001f,-0.57179999f,-0.75660004f,0.03899995f,-0.96860000f,-0.93100002f,-0.34789998f,0.01390000f,-1.19729997f,-1.27200003f,-0.62550001f,-0.38130003f,-0.62639999f,0.06319998f,0.20569998f,0.90750004f,-0.03650004f,-0.36750000f,0.05040000f,0.50400002f,-1.46970001f,1.35480002f,-0.22390001f,-0.89970004f,-1.69090003f,0.80200005f,0.94639998f,-0.06370008f,0.50309999f,-0.10559998f,0.27519996f,-0.06490001f,-0.75750000f,0.31599999f,-0.52399998f,0.73520005f,1.64299997f,-0.07950001f,1.02319999f,-0.20860002f,-0.11880003f,-0.70500001f,0.78870001f,0.14010001f,-0.42000001f,0.81470006f,-0.72490004f,-0.90080005f,-0.06219997f,-1.32610003f,0.58549999f,0.42120001f,1.20820003f,0.42659999f,0.34870001f,0.63930001f,-0.22070000f,0.68059999f,1.44759999f,-0.90820006f,-0.17929998f,0.10730004f,0.04500001f,-0.21709999f,-0.40410000f,-0.66459999f,-0.32950003f,0.72390000f,0.53429999f,0.31590003f,0.68509995f,0.01049999f,-0.58050005f,-1.15970002f,-0.19540001f,0.75030001f,1.10680000f,1.11700001f,-0.38299999f,-0.42609997f,0.54870000f,-1.35180007f,1.72450005f,-0.68249997f,0.37250000f,1.91030005f,-0.86600001f,-1.03840002f,1.17120000f,0.33910000f,-0.70059999f,-0.61299998f,1.60540003f,0.40590001f,2.02130004f,0.99760002f,0.16550002f,0.48590001f,-0.83080002f,-1.36110002f,-0.84280003f,-1.03420000f,0.14839996f,0.74970001f,-0.31220001f,-1.63110001f,-1.25290000f,0.63670004f,-1.33019997f,-1.25720003f,-0.81700002f,-0.66290003f,-0.50830002f,0.82090005f,-0.05220006f,-0.83950001f,0.80030000f,0.60060002f,1.34619998f,0.94859998f,-0.80759996f,0.46790002f,0.58659995f,1.10630006f,0.65020002f,0.81870004f,-0.28680001f,-0.07519997f,1.46460003f,2.21510003f,0.77190001f,-0.23900006f,-0.07339999f,1.68090008f,0.40659999f,0.31650000f,-0.05940001f,0.67320000f,0.50570002f,0.16510000f,0.29170000f,0.09919998f,-1.00859998f,-0.37830001f,-0.13210000f,0.09200001f,0.04520000f,-0.38950001f,0.21240001f,-0.16140000f,0.03050002f,-0.85660003f,0.42290001f,0.36280001f,-0.97289999f,1.31720005f,-1.34400002f,-0.77460003f,0.95309999f,0.36060002f,-1.13740004f,-1.56150004f,-0.17050003f,-0.23910000f,-0.19769999f,0.59880002f,-0.43549998f,0.14279999f,-0.84880001f,0.21550002f,1.07180001f,0.28099999f,-0.05730003f,-0.02400000f,-0.39149999f,-0.55460001f,0.13660000f,-0.05120000f,-0.33219998f,0.70430001f,0.40530001f,1.06050002f,1.91369996f,0.35440002f,0.70370002f,0.06820000f,-0.00860000f,0.69130002f,-0.24530000f,-0.34960002f,0.97000001f,0.34320001f,-0.38439998f,-1.53330006f,-0.04949996f,-1.02799999f,0.14160000f,0.22960000f,0.08660000f,-0.24820001f,-1.04120002f,0.03830002f,0.89780001f,-0.91320006f,0.20619997f,-1.22049999f,0.05140004f,-0.53199999f,-0.09300002f,0.16440001f,0.43239998f,-0.49769998f,0.05579995f,0.23110002f,-0.13630001f,-0.09190001f,0.24210001f,0.47350003f,0.26139997f,-0.88340000f,0.35939995f,-0.58440002f,1.28600002f,-0.83730002f,2.07870002f,0.18510000f,-0.08979998f,-0.04980000f,0.39710000f,-0.80240003f,1.04860003f,-0.14010000f,1.56200000f,0.50950000f,2.00610001f,1.04830000f,1.69580002f,-0.33030005f,-0.39530002f,0.31800003f,1.13620003f,0.05289998f,1.40210002f,0.78480001f,-1.29489998f,-0.03230001f,-0.72899998f,-0.11250000f,-1.19659998f,-0.71060000f,-0.46770000f,-0.24790001f,-0.73199997f,0.59009998f,0.21290002f,-0.75840002f,-0.06950000f,-2.00889994f,1.76029997f,0.46360005f,-0.60279997f,1.08620003f,0.48850001f,-1.42909997f,0.63409999f,1.56209994f,0.77070004f,0.46330000f,0.38030000f,1.52810005f,0.76090004f,-0.13840000f,1.16460003f,-0.54800002f,-1.09150003f,0.38020001f,2.14890006f,-0.93009999f,0.87029996f,0.70390005f,-0.71280002f,0.81480002f,-0.53950000f,-0.18730003f,0.99090002f,0.19180004f,-0.78190003f,0.83010002f,-0.19529999f,1.21200003f,-2.03450005f,0.66780002f,0.62830002f,-0.04079995f,0.23310001f,0.87680002f,-0.80480003f,-1.77110004f,0.95970002f,1.04270008f,-0.92999999f,-0.76540000f,1.52350005f,0.57790003f,2.18380003f,0.00670000f,-0.09599997f,0.09700001f,-0.34770000f,0.34400001f,-0.52620000f,0.64880000f,0.54800007f,-0.69450001f,-0.12919999f,-0.78559998f,0.37239996f,0.08590001f,-0.12640001f,-0.19980000f,0.67379998f,-0.21569998f,0.81560005f,-0.55240000f,1.16789999f,0.26000003f,-0.62360001f,-0.19540003f,-0.12839995f,-1.32440003f,0.35379999f,-0.77910004f,0.24660002f,-0.39820003f,-0.79630001f,1.68079999f,-1.21890001f,-1.56270000f,0.49440002f,0.93689999f,0.00830000f,-0.43840001f,1.03650000f,-0.03829996f,0.40189999f,1.22970003f,1.32200005f,-1.15069999f,1.41589996f,1.19180005f,0.86679999f,0.25240005f,-0.40840003f,0.16409999f,0.35810002f,1.02800003f,-1.40620002f,0.61959999f,0.13060000f,0.70799999f,-0.03039994f,1.29040000f,-1.56289999f,1.58450003f,0.68480000f,-0.21249999f,-0.63519999f,-1.74399999f,1.31780001f,-0.32859995f,0.15469999f,-1.14829999f,-0.35809998f,-1.11819998f,1.36749998f,-1.43339998f,-0.11159998f,-0.29330001f,1.03890001f,-0.48260000f,0.04879996f,-0.17429999f,0.23350003f,-0.17600004f,-2.12169998f,-0.90620002f,-0.81410003f,-0.00380000f,-0.35780000f,0.13789996f,-0.20400001f,0.86540002f,-1.60990002f,-0.57030000f,0.88639994f,-1.44050000f,0.97490000f,-0.73680001f,0.64760002f,0.60170002f,-0.07109999f,1.00650006f,0.01480000f,-1.88840001f,1.30850002f,1.75299994f,-0.17789998f,0.29949997f,-0.56640001f,0.54879997f,-0.73170000f,0.04940000f,1.12649997f,0.09630000f,-0.96110000f,0.50730001f,-1.53050005f,0.07019998f,-0.30889995f,-0.39430002f,-1.06449996f,0.32899998f,-0.72569995f,0.50870005f,0.03760000f,-0.79930003f,0.29260001f,-0.23250000f,-0.33830001f,-1.20640001f,2.02770001f,-0.97009997f,0.67799997f,-0.19179998f,-0.07610005f,-0.20970000f,-0.03949997f,1.63140004f,-0.32070005f,-0.94890004f,0.60230001f,1.85089995f,-1.39930003f,0.17249996f,-0.87559997f,-1.03340001f,0.83059998f,-1.04049999f,2.14049998f,0.24230002f,0.43039999f,0.15729999f,-0.88299999f,0.27379999f,0.96350002f,-0.06770000f,0.97849997f,0.87250003f,-0.51749998f,-0.72700003f,-1.14169998f,0.75949998f,-1.52340002f,-0.35209999f,0.23769999f,0.74630003f,-0.50829998f,1.15910002f,-1.47810003f,-0.55840002f,0.56509998f,-0.59969999f,0.07070005f,0.39040002f,1.58159999f,0.16679998f,0.10789999f,-0.24529997f,-0.62379997f,-0.18410001f,1.22850003f,1.26530004f,-0.01800002f,0.26759996f,-1.82070001f,0.08779997f,-2.00840006f,0.14900000f,-0.55950004f,0.27630002f,2.44270000f,-0.30069998f,0.87060000f,-1.01669999f,0.75749999f,-0.65400001f,0.58390002f,-0.08870000f,0.29599998f,-1.52470001f,-0.15540003f,0.76240006f,0.67950004f,0.24370001f,-0.74999996f,1.11610010f,-0.38200000f,1.17600000f,1.14110000f,0.68670000f,0.78930005f,0.82440002f,0.13189997f,-1.36300000f,0.22130000f,1.92030003f,0.68250003f,-0.22260002f,1.31059998f,1.13710003f,0.73709999f,-0.54270008f,0.64370008f,-1.47280004f,0.74120002f,1.22580005f,-0.16920005f,-1.15840007f,-0.49489996f,-0.30119998f,-0.82550005f,-0.89810003f,-0.96990003f,-1.41230002f,0.66530001f,0.04399999f,1.02750002f,0.63309998f,-0.93580005f,-1.95010004f,0.14110001f,-0.14589998f,-1.22640002f,-0.49360001f,1.32230000f,0.05870003f,0.09499999f,-0.98650001f,0.36280000f,-0.54559999f,-0.13889999f,1.21320002f,-0.68059995f,-0.14200000f,0.16270000f,-0.58500004f,1.80650004f,0.30410003f,-0.19540004f,-0.54180005f,1.82590002f,0.51189999f,0.92550004f,-0.74470004f,0.11190004f,0.75380002f,-0.93050001f,-0.79080001f,1.32320004f,0.63729999f,1.02860002f,0.76490001f,0.61859999f,-0.61500005f,-0.47860002f,-0.41520003f,1.06450003f,0.58619999f,0.04639999f,0.37550002f,0.22990000f,0.80860000f,0.24719998f,-0.32069998f,1.18409998f,0.89770001f,0.98330000f,0.13560001f,1.12689993f,0.50510000f,1.31869998f,0.93890006f,0.24519997f,-0.55190000f,-0.18989998f,0.01100002f,-0.00960003f,-1.54160007f,1.38570004f,-0.74360001f,0.36480003f,-0.49139998f,0.17910000f,-1.72030007f,0.79600001f,-0.18870000f,0.53720000f,-0.03430002f,0.00940001f,-0.49590000f,2.04100002f,-0.41660000f,-0.45599998f,-0.75359998f,0.95460003f,-1.31980004f,-0.13449999f,0.94230000f,0.13289998f,-0.28639999f,0.76639996f,-0.23720000f,-0.12309996f,-0.59830002f,-1.92109995f,-0.51510000f,-0.88930001f,0.57689998f,-1.09020001f,-0.98720003f,-0.55010000f,0.71590008f,-1.01670009f,-1.48940007f,1.30110002f,1.81400002f,-0.98849998f,0.80610003f,-0.54650000f,0.87600003f,-0.46930001f,0.05960005f,0.45190003f,0.24620002f,-0.32229999f,0.62670001f,0.21070002f,1.25450000f,-0.03630000f,0.34679999f,-1.20370000f,-1.02220000f,1.00819999f,0.00050000f,-1.20879999f,-0.86570002f,-0.48910000f,-0.07299998f,-0.96209996f,0.36180000f,-1.56639995f,-0.49599999f,-0.08119998f,0.22850004f,1.28500005f,0.63990001f,-0.84830001f,1.45030007f,-0.25520003f,-0.77060006f,1.28420003f,1.52990003f,-1.71750000f,0.23349999f,0.35499996f,-0.46340002f,-0.87090004f,0.22250000f,-0.55939999f,0.43200003f,-0.12500000f,0.36609997f,0.36240000f,0.64099998f,0.12900003f,1.18659999f,1.21509997f,0.34799999f,1.54489997f,-0.17270002f,0.88360000f,-0.81459998f,-0.29969999f,1.06320002f,0.39640003f,-0.25120003f,1.45980001f,-0.05279999f,-0.53929998f,0.63610000f,-0.55519997f,-0.78190002f,0.04679999f,0.36910000f,0.54009997f,0.32509998f,-0.93409997f,-0.93820002f,0.45080000f,-0.40030003f,0.72170000f,0.53870003f,-0.93719997f,-0.00429996f,-0.28219999f,0.23789999f,-0.47960001f,-1.69890001f,-0.49639998f,-0.66419998f,-0.86030005f,0.26860000f,0.66210001f,0.15619999f,-1.99129998f,-0.86580005f,-1.63910001f,-0.16309999f,-0.09700004f,1.49970001f,1.39919997f,0.29920000f,0.84789998f,0.23709999f,0.29860000f,-0.08600000f,0.31240005f,0.81230003f,0.54470003f,0.72280004f,0.54480000f,1.31309998f,-0.18420001f,-0.07690003f,-0.45220001f,-0.92710002f,-0.88460001f,0.30170003f,-0.02309998f,-0.14750000f,0.66390002f,-0.70120002f,0.09029998f,0.76850004f,-0.03600004f,0.71960002f,0.77680000f,-0.11480003f,0.02899997f,0.43480000f,-0.28360001f,0.33600001f,-0.66410003f,0.16589999f,-0.90740003f,1.06310001f,-1.79280001f,0.53049999f,0.27050003f,-0.28630002f,0.87010006f,-1.33730007f,-0.33449998f,1.03970005f,0.07540002f,0.54900002f,0.52060001f,-1.53839997f,1.49800002f,-0.28800001f,0.22759997f,0.68300001f,-1.07360000f,1.82500000f,0.23929996f,-0.20790001f,-0.37640003f,-0.39290000f,-0.57230005f,1.06790001f,-1.54300003f,0.74130001f,1.09460002f,0.73950000f,0.55199998f,-0.68780001f,-1.40230001f,-0.13140000f,-0.22670001f,-0.21810002f,-0.46459996f,0.02010000f,-1.02039999f,0.78610001f,-0.08419994f,0.55769997f,-0.34840000f,0.23580000f,1.33150000f,1.16079995f,-0.03219999f,1.45730001f,-0.23500000f,0.03069998f,1.17429994f,-0.30979995f,-0.69880000f,-0.10559998f,0.65239998f,0.44170001f,1.36480001f,0.19850005f,1.97450003f,-0.04360001f,0.05840002f,0.14519995f,-2.01160001f,0.52740003f,1.18029997f,0.54810001f,0.16969997f,0.45650002f,-1.57500001f,1.65220002f,-1.48170000f,-0.32570000f,0.60419994f,-0.88039999f,0.73360002f,0.88320001f,-0.42519995f,0.80150001f,-1.11200003f,-1.00950000f,0.98610000f,-1.23179994f,1.07770001f,0.87239993f,0.28870002f,-0.37059999f,-0.43900000f,-0.02619993f,-0.82350000f,-0.08980003f,1.38610001f,2.07209998f,1.18490000f,-0.56320001f,-0.01300001f,0.94980002f,-0.13729998f,-1.48940006f,-1.45760006f,0.98850002f,-1.18140005f,0.17590003f,0.93010003f,-0.54470001f,0.39320002f,0.66070003f,-1.32840000f,-0.47160003f,0.40689997f,-1.49580004f,1.39640003f,-0.18380002f,-0.50959998f,0.16600000f,0.66710000f,-0.17990003f,-0.56109999f,-0.56480000f,0.89950000f,1.65140002f,0.00019999f,0.77599995f,-0.95880000f,-0.74019998f,0.34889997f,-0.67450002f,-0.12160003f,-0.99499996f,0.32790004f,-0.28870002f,-0.77350001f,-1.22489998f,0.82249996f,1.30749999f,-0.95020000f,0.08490001f,1.03049997f,0.89650001f,-0.68070002f,-0.81840002f,1.68829999f,-0.22429999f,-0.14059999f,0.47810000f,-0.44939998f,0.50090002f,-1.46130002f,0.42360000f,0.27720002f,-0.17340002f,-0.15320003f,0.06700003f,-1.10860000f,-1.11750000f,0.00980001f,0.33189999f,-0.02579998f,-0.16549997f,1.36319997f,0.60360006f,-0.81419998f,0.47580001f,0.51219998f,0.02999996f,0.90650001f,0.05060000f,0.11440001f,-1.06389999f,-0.35380005f,0.31469998f,-1.42339998f,-0.51990005f,-1.00789998f,0.14429999f,-1.92810002f,-0.23100004f,0.08279999f,0.15030000f,-0.60729999f,-0.12080001f,-0.27869999f,-0.90650000f,0.31079999f,-0.79569999f,0.44530000f,-1.10080000f,0.41869993f,-0.83769998f,-0.52649998f,0.23650001f,0.26009998f,0.31869997f,0.39070001f,1.55309995f,-0.20790003f,0.93439999f,-0.66599999f,1.00989994f,0.19500001f,0.75980000f,2.08229996f,-0.16329996f,1.39630001f,0.76530002f,-0.12929998f,0.19800001f,0.13370001f,-0.45329997f,1.86039997f,1.21230003f,0.45909998f,0.33040002f,-1.78440003f,-1.32120000f,-1.80740004f,-0.97100000f,-0.45010001f,0.72330001f,-0.09470003f,1.09819998f,1.14590000f,0.19429996f,0.61300001f,-0.44870002f,-0.12939995f,0.64540000f,0.12730002f,0.09979999f,-0.05770001f,-0.07120001f,0.86469998f,-0.38079999f,1.19809998f,-0.10360003f,-0.22530001f,-0.31200001f,-0.66709999f,-0.31170003f,-0.87690000f,0.18750003f,-1.26620005f,0.62380004f,-0.55300003f,-1.46940005f,2.34680003f,-0.04360002f,0.54340005f,0.37860004f,-1.06100004f,-0.63180000f,-0.64890000f,0.15000003f,-0.91920000f,-0.44449996f,0.12190003f,-0.51600000f,0.52829999f,-0.70860000f,-0.82070004f,0.89380004f,0.83799996f,-0.38550003f,-0.26569997f,-0.09140005f,-0.70479998f,-0.88810001f,-0.32569999f,0.82280001f,0.73710001f,-0.13210001f,0.92079997f,0.41020000f,-0.17700003f,0.22770001f,-0.26660000f,0.88710000f,-1.36329994f,1.19040006f,-0.24020004f,-0.25360005f,0.30960007f,-1.02170001f,1.30599998f,-0.28460000f,-1.01729998f,-0.40329999f,-1.47910001f,-0.62079997f,-1.99059998f,-0.05120000f,-0.62210001f,-1.85630002f,-0.10410000f,-0.34469997f,0.49459997f,-0.95330001f,1.34609999f,0.60780005f,2.03359997f,-0.66990001f,0.25100002f,-1.23230003f,-1.11449997f,1.12020002f,0.58299997f,-0.84810002f,1.18300001f,0.42570001f,-0.51760001f,-1.38400005f,0.50790000f,-1.35820004f,1.70609999f,1.75250000f,0.09180001f,0.11220003f,-0.56070000f,-0.78110001f,1.26689999f,-0.34730005f,0.24630001f,-0.93490000f,0.44460004f,0.75200002f,0.31289998f,0.34699998f,-0.84870008f,-2.22220003f,-0.68800000f,-0.36729998f,-0.58960004f,-0.19020003f,0.54019997f,-0.52570000f,0.59400001f,0.44959999f,-0.53619998f,-0.95590004f,-1.55730003f,0.31719997f,-0.86060001f,0.27310003f,0.69479998f,-1.36030001f,0.30560002f,0.45420000f,-0.67230000f,-0.67370003f,0.36220000f,0.93070004f,-0.46099999f,1.70090010f,-1.42630002f,-1.29820002f,1.42210001f,0.23499996f,0.02530002f,-0.26680001f,-1.42630002f,0.18020003f,0.95530003f,1.46100003f,-1.01990002f,0.12970001f,0.78050001f,0.33459996f,1.58260000f,0.49210001f,-0.45969999f,-0.06350001f,-0.57470001f,-0.30450000f,0.72209997f,-0.49300002f,0.15580004f,0.39360000f,0.58079998f,-0.26670000f,-0.25430000f,-0.28150000f,1.11450003f,1.35160005f,-1.17670002f,-0.56100001f,-0.01489998f,0.89280002f,-0.29650002f,-0.73470003f,0.66180002f,0.11160003f,0.34259995f,0.38830000f,0.79410001f,0.51980000f,0.13209999f,-0.49860001f,-1.76969999f,-0.53860000f,-0.45330006f,-1.42110002f,-0.75150004f,0.13270002f,0.34259999f,-0.76420003f,0.27720003f,0.53809999f,-0.16069999f,-0.92950001f,0.04599998f,-0.34510001f,-1.33689994f,-0.21870001f,-1.19359996f,-1.00570002f,-1.33959996f,0.22750000f,0.27700006f,0.27460001f,-1.08879999f,0.02800000f,-0.02939999f,0.93680001f,-0.66040000f,1.08680000f,-1.06100000f,1.01020004f,-0.18050005f,1.09089999f,-0.49049999f,-0.08809999f,0.05050002f,0.52420002f,-1.42819998f,0.26840000f,-0.69350000f,0.20570000f,-1.07650002f,1.05020002f,-0.47780001f,-0.08300003f,1.29219997f,0.56890004f,1.28519998f,-0.24720002f,0.26670003f,0.07320001f,0.26279999f,0.49790003f,1.51319993f,0.11769999f,1.03219999f,0.54480003f,0.05159999f,-0.30819995f,0.66289999f,-1.02289993f,0.28860000f,0.59890004f,0.35010000f,-0.62430000f,0.87040003f,-0.57249992f,0.47949998f,0.55789999f,0.88180002f,-0.82549999f,2.14830002f,-0.25950000f,-0.39390003f,-0.45060004f,-1.98710000f,-0.01010002f,-0.55179996f,-1.17879999f,-0.95770001f,0.07879997f,-0.88809999f,1.43810003f,-1.38510001f,-0.38540003f,-0.47490006f,-1.43180000f,0.60269996f,-0.67349999f,0.36379997f,-0.70380000f,0.44719997f,0.43030003f,-0.05850001f,0.12770005f,0.56110004f,2.06529999f,0.61820001f,1.17109995f,-0.30210000f,0.15890000f,-0.45290000f,-0.32370003f,0.39880001f,-0.52759997f,-1.82910000f,-0.29200001f,-0.63949998f,-0.66850006f,-1.97990004f,0.34440002f,-0.35010000f,-0.00969998f,-0.91210000f,0.64810005f,1.90780008f,-0.36889999f,-0.12820000f,-1.32970002f,1.82940000f,-1.02740001f,0.46800003f,-0.69740001f,0.72569999f,0.30290006f,-0.72280002f,0.66110002f,0.26550002f,0.90840003f,0.53599997f,1.42029995f,-1.25530000f,-0.20970004f,-0.25290001f,1.24979999f,-0.76060002f,-1.84530004f,0.87980002f,0.58990006f,-0.83380002f,-1.43060001f,-0.31420003f,-0.26079999f,-0.09549999f,-0.15410000f,0.44289996f,0.20499999f,0.17670001f,-0.31940001f,-1.17510005f,0.02630000f,-0.62380002f,-0.83190007f,1.81510001f,0.31580003f,-0.69879996f,0.92840000f,-1.26790001f,-0.56310003f,0.75120001f,-0.14670000f,-0.78700003f,-1.10410006f,1.16980001f,-1.76800003f,-1.12339999f,-1.01799999f,-0.34030001f,-0.29850001f,1.45300002f,2.24980004f,-1.13160004f,-0.42780000f,0.69080002f,1.91200000f,-0.61340003f,0.68729991f,-0.32570001f,1.36430006f,0.11260001f,-0.14380005f,-0.14120001f,0.39560002f,1.52189999f,0.21970000f,0.33929998f,0.58990002f,0.57320000f,-0.26459999f,0.04710003f,-0.04860003f,0.33810000f,-0.00250000f,0.58970005f,1.13020001f,-0.63989999f,0.86600001f,-0.95440000f,-0.17850000f,0.61719999f,-0.27850001f,-0.39979999f,0.61800006f,0.18939998f,-1.30410001f,-0.46430003f,-0.56529995f,-0.13029997f,-0.39779999f,1.09440000f,1.70589999f,-1.07489997f,0.41460000f,-0.19869999f,-0.52940001f,0.88970004f,-0.48939999f,0.16270001f,-0.00109999f,0.23270000f,-0.10880001f,-0.44129998f,-0.37650001f,-1.05230002f,1.15359999f,0.32900001f,-0.02679999f,0.52699998f,0.30960001f,-0.49390001f,0.08449999f,0.12670000f,-0.61559999f,0.79729997f,-0.40219999f,0.17010001f,-0.79990003f,-0.02840001f,-0.34990004f,-0.39219998f,-1.22209999f,0.65010001f,-0.21549999f,0.15969999f,0.49909997f,-0.45729999f,-0.16660001f,-0.12869999f,1.03320003f,-1.13250003f,0.89869999f,-0.92479998f,-0.12230002f,-1.32509999f,0.49499999f,-0.73639997f,-0.70300003f,0.87700005f,0.54810002f,-1.97720003f,-1.37290003f,-0.69370002f,-0.37130001f,0.12839997f,-1.72290002f,2.48499998f,-0.01759995f,0.11070001f,-0.66520002f,1.52159999f,-0.81490002f,0.08609998f,0.39149998f,0.19430002f,0.10010000f,0.64529997f,0.89119995f,-1.47109999f,-1.81440005f,-0.42989999f,1.83249999f,-0.89770000f,-1.12049998f,0.34939999f,-0.46629999f,1.03360004f,0.04510003f,0.25170001f,-0.28870001f,-0.02199999f,-0.04459997f,-0.31640004f,0.16750001f,0.42000002f,-0.03370002f,-2.11080000f,0.01299995f,-0.90530001f,-1.25129999f,0.60489997f,-1.15250003f,0.49789997f,-0.22310000f,-1.30510001f,-1.05220000f,-0.19430004f,-0.96670003f,0.16889998f,-1.06170000f,0.61460001f,0.49000001f,1.77660000f,-0.19580003f,-0.51849999f,-0.52830003f,-1.96699996f,0.77059999f,-1.19039997f,-1.29599998f,-0.37210002f,0.89609999f,-0.81750003f,-1.50980009f,-0.00319996f,-0.33989999f,-0.57690004f,1.54690005f,-1.39780003f,0.92130003f,-1.55580001f,0.13510000f,0.41529996f,0.93770002f,-0.05570001f,-1.21340000f,-1.24490000f,0.52620005f,-0.82369999f,1.31510001f,-0.53710001f,0.67859998f,0.94480000f,1.75970000f,-0.32249999f,-1.02800002f,-1.06519999f,-0.08570000f,-1.26069998f,-1.09410004f,-1.37360000f,0.59030000f,-1.01569998f,-1.02770001f,0.30010003f,1.50920005f,0.78240003f,-0.71090000f,-0.75950003f,-0.17990002f,0.49420003f,1.87310005f,-0.88639999f,0.22640004f,-0.53880001f,1.10720001f,0.00430001f,-1.42080009f,0.50430007f,-0.10170001f,0.01280000f,0.82930001f,0.37860003f,1.00620002f,-1.01870004f,0.03479997f,0.40520001f,0.33979996f,-0.37550003f,-1.49580007f,0.82090003f,-0.02649999f,-0.76450002f,0.69380004f,-0.34380000f,-0.99400005f,1.42249999f,0.78880001f,-0.84609999f,-0.64580002f,-0.51150000f,-0.06460002f,-1.10030002f,-1.13180005f,1.21320003f,1.62160007f,-2.13410002f,-0.91810004f,1.11490003f,-0.27050000f,-0.42560000f,1.37990006f,-1.19920005f,-0.37240001f,0.33440001f,1.84210009f,0.19329998f,-0.69100005f,-0.54519996f,-0.19579996f,-1.05010005f,-0.68980003f,-0.41620002f,0.52060003f,-0.86900001f,0.74290005f,0.25210004f,1.65800003f,0.04080001f,0.28180001f,0.11040000f,-0.43909999f,0.20589996f,0.83890001f,1.20219998f,-0.91360000f,1.31459998f,0.97129998f,-0.37689996f,0.81480002f,-0.23450000f,-0.86820005f,1.20160002f,0.32340002f,0.73339998f,-0.64830001f,0.18080000f,-0.73730003f,1.33939998f,-0.48040002f,-0.04699996f,0.08610000f,-0.81160006f,-0.11429998f,1.38860004f,-0.04870002f,0.08409995f,-1.60150001f,-0.06950000f,-0.53249999f,-0.89570004f,-1.11920000f,-0.05109998f,0.60980000f,-0.25460002f,0.61500001f,0.20010000f,-0.18850000f,0.45019999f,-0.16209999f,0.34169998f,-0.20020000f,-0.56589998f,-0.85650002f,-0.51189999f,0.06140001f,-0.16450002f,-0.77710001f,0.10410000f,0.01429999f,-0.17559999f,-0.52030001f,0.68199999f,0.00580000f,0.30679999f,0.99470000f,-0.17229998f,0.15300001f,1.15220003f,0.48529999f,1.06390002f,0.65310000f,0.37770001f,0.20819999f,0.34779999f,0.47409999f,0.16279999f,0.22569999f,-1.05470003f,0.24640000f,-0.96059997f,-0.53360000f,-0.30519999f,-0.65179999f,-1.53409999f,0.16910002f,-0.43749996f,0.11259999f,-0.05609998f,-0.30740001f,-1.37740002f,0.01740002f,-1.89580004f,0.03510000f,0.76599995f,0.16739999f,1.19489999f,1.68320004f,-0.78970000f,-1.98610010f,1.48480005f,2.03280009f,-1.21570005f,-0.65250001f,-1.00130000f,0.71620002f,0.88919998f,1.22610001f,0.67770001f,-0.27700004f,0.54040001f,0.58350000f,0.34909998f,1.29660002f,1.11730002f,-0.51940001f,0.46800005f,0.76419998f,-0.39719996f,0.20899999f,-0.03450000f,-0.76340001f,0.47319997f,0.61280001f,-0.35189999f,-1.28780000f,-1.44990001f,-0.19540000f,0.03220002f,0.70480003f,1.01380003f,1.23739998f,0.07559995f,0.21330003f,-1.20750001f,-0.20160002f,0.03729998f,0.01649993f,-0.36560000f,1.79319997f,0.91219999f,0.57940002f,0.44070000f,0.74950002f,0.71440001f,-0.75809997f,0.89970000f,0.74629998f,-1.64399998f,-0.75340004f,-1.25439999f,-0.79130004f,-0.41869997f,0.23459999f,0.28280002f,0.65840002f,-0.23719998f,-0.03140002f,0.53670002f,-1.00620002f,0.47329998f,-1.53700000f,2.04199997f,0.16930008f,0.25660000f,0.11999999f,-0.05350001f,-0.96369999f,-0.16139999f,0.90950001f,-0.31300001f,0.31690000f,0.16909996f,0.37339991f,-1.11579998f,-0.54870001f,-0.38200005f,0.97840000f,-0.13309998f,0.10949997f,-1.66099998f,-0.00670001f,-0.00950002f,0.15109999f,-0.44490005f,0.63260000f,0.58020000f,-0.77289999f,-0.72729999f,-0.56210002f,0.77229998f,-0.98540000f,0.94410000f,-0.18260000f,0.77730002f,0.14849999f,-0.17889997f,-0.55450004f,1.03850002f,0.85940005f,0.84070002f,1.81179998f,-0.45350001f,-0.63460001f,-0.22560002f,-0.34480002f,-0.86909998f,-0.20980000f,0.28819999f,1.93380005f,-1.30200003f,-2.32190001f,-0.61020000f,0.75970001f,0.24790002f,-0.28450002f,-0.07970000f,-0.50399999f,0.92830004f,-1.15490002f,0.90090004f,-0.87030003f,-0.57870004f,0.82459998f,-0.50040001f,-0.36980000f,0.93149998f,-0.18480000f,0.05460001f,0.34370002f,-0.47740003f,0.65980003f,-1.14830004f,-0.36360002f,-0.41420004f,-1.51710001f,0.47579999f,1.50340001f,-1.01969997f,-0.04870000f,-0.26210000f,-0.05590000f,0.14530001f,-0.43529999f,0.72480004f,1.16610000f,0.67990002f,0.90349996f,0.44459999f,-0.50580000f,-0.34849999f,0.71830001f,-1.12949998f,-0.34700004f,-0.72029997f,-0.31600000f,0.20640000f,-0.42500000f,-0.04170002f,0.62780002f,-0.75390003f,0.23410003f,-1.10850002f,-0.57389999f,-0.16980006f,-0.48399997f,0.26250000f,-0.06249999f,-0.25410002f,0.54530000f,-1.29109999f,0.21969999f,0.14720004f,1.02580002f,0.58830001f,1.67349997f,0.20460001f,0.37539998f,-0.47359999f,0.86189999f,-0.19309998f,-0.54879997f,0.92270000f,0.15789999f,-0.77430001f,-1.01220002f,0.07040001f,-1.68620001f,-0.06300005f,1.40180000f,-1.33739998f,-0.97720002f,-0.53140000f,0.20980000f,-0.59969998f,0.34290001f,1.56100004f,-0.23509999f,-0.09449998f,0.36129999f,-1.27579998f,-0.64940002f,-0.10330003f,-0.34659994f,0.62709998f,-0.60239999f,0.34319997f,-0.01459997f,-1.22940004f,-0.33390006f,-0.48410000f,-0.00420003f,1.14030002f,1.21340002f,0.51069993f,-0.57930006f,-0.69439995f,1.80770000f,-0.37859999f,-0.24450000f,-0.09390001f,0.23590001f,0.06959999f,0.25240000f,0.22789999f,0.07639997f,-0.71810001f,1.23930006f,-0.21999999f,0.16200001f,0.37890002f,0.31070001f,-0.72570001f,0.87870000f,-1.45849995f,-0.06320002f,0.20069999f,0.04680004f,-0.45840000f,0.08680000f,-0.07870003f,0.26730001f,0.35350006f,1.45930005f,0.73240002f,-0.69669995f,0.87759997f,1.46379997f,-0.02540000f,-0.13600002f,-0.09829998f,0.36510002f,0.42090000f,-0.75869999f,-0.57320001f,-0.85209999f,-0.91890005f,0.35780001f,0.03949999f,-0.03340000f,-1.24370002f,-0.26190004f,-2.05550001f,0.06559998f,0.11870006f,-0.55600001f,0.16960000f,0.83710001f,-0.79579997f,-0.33120001f,-1.17430000f,0.03390000f,-0.17790000f,-0.49079998f,0.69120001f,0.66379997f,1.24910002f,1.51990003f,1.22770000f,0.18919999f,0.22490003f,0.81340000f,-0.96360005f,-0.99810000f,0.03369999f,-0.60680002f,-0.33400000f,-0.92320004f,0.63380001f,0.46319999f,-0.50899999f,-0.00540000f,-0.15020000f,-1.78470000f,-0.95100001f,-0.17340001f,-0.57779999f,0.62800001f,-1.07190002f,-0.46830003f,-0.54220006f,0.46760003f,1.33089999f,-0.38220003f,-0.14249995f,-0.11899998f,-0.91810000f,-0.39040001f,-0.67720000f,0.90020001f,0.80100002f,-0.30119998f,1.47650005f,-0.55380002f,-0.69380003f,-0.69999998f,-1.53580002f,-0.80700000f,1.05290000f,0.21229999f,-0.47240003f,-0.96960001f,-0.19349999f,0.37949999f,-0.12100000f,0.73280002f,-0.74590003f,-0.59500001f,-0.95229998f,-0.48410001f,-0.69659997f,-1.06500000f,0.59809998f,0.04009997f,0.50789996f,-0.68880003f,1.14419996f,-0.87340002f,0.27900003f,0.36469999f,-0.41630004f,-0.75250001f,0.43440000f,-0.47349995f,-0.61449998f,-0.44810000f,-0.12579998f,-1.20990000f,-0.75670002f,0.26790000f,-1.12750004f,0.44349994f,-0.51200001f,0.10040000f,0.37370001f,-0.80590002f,0.41500003f,1.19490002f,-0.20220000f,0.74480004f,-0.51890003f,0.13440006f,-0.13890004f,0.63160001f,-0.40730002f,-0.37660001f,-0.43620003f,1.66850003f,0.83480002f,-0.72609999f,-0.10330001f,-1.54860001f,-0.57549996f,-0.46219999f,-0.24249999f,-1.02369997f,0.72610000f,-0.18620000f,0.24250002f,0.15109997f,0.68599999f,0.39690004f,0.40860003f,-0.29550001f,-1.53350003f,-0.90570000f,-2.10330007f,0.05069997f,-0.04159999f,0.41030002f,-0.04479999f,0.71630004f,0.02920000f,0.47270001f,-0.28260001f,-0.12530002f,-0.35330001f,-0.01409997f,0.62119998f,0.07090003f,1.60239997f,0.22170001f,1.34659998f,0.57870001f,0.65029999f,-0.58130001f,-1.49140000f,-0.15779996f,-2.13299998f,-0.99440002f,-1.06779998f,0.20820000f,-0.47009996f,-0.79460001f,-1.09580002f,0.28890002f,-0.53960002f,1.08150000f,0.14340001f,0.52269997f,-0.38040000f,-0.60280001f,-0.38550000f,-0.41310001f,0.48820000f,0.25139999f,0.33180000f,-0.81250004f,0.58810002f,1.52040002f,-0.83650000f,0.86650006f,0.02719998f,0.19700001f,0.21079999f,-1.29910004f,0.52649996f,-0.54090000f,-0.25610003f,-0.03260000f,1.69929996f,0.00820001f,1.88350001f,0.46120001f,0.04980003f,-0.51560001f,-1.46749998f,0.67419999f,-0.22360001f,0.20490002f,0.45510002f,-1.65439997f,-0.30239995f,-0.25680001f,-1.48150001f,0.32770000f,-1.07090004f,0.71829999f,0.08200000f,-1.40960002f,0.18630000f,-0.97210002f,0.07570001f,-0.62870002f,0.30049999f,1.10330000f,-0.77049998f,-0.10570000f,-0.38750000f,0.32400003f,0.07479997f,-0.50800001f,-0.31690001f,-0.25920003f,0.07500002f,0.02680001f,1.94699993f,-0.07930001f,1.64229997f,0.10970000f,-0.73429999f,-0.04410001f,-0.77250005f,1.06529998f,-0.28619999f,-0.10280000f,0.38040003f,-1.85519996f,-0.24220000f,0.33200002f,-0.60449998f,0.60199999f,-0.03250001f,-0.12599999f,-0.38450004f,0.74259996f,0.65350000f,-0.27900001f,-0.48290000f,-0.66610003f,0.06450000f,0.11809999f,0.35089998f,0.21450000f,-0.36489999f,-0.08220002f,0.30520000f,-0.34050000f,0.25400004f,0.29929996f,-0.61539998f,0.78820000f,-1.26869995f,-0.30470005f,-0.92029999f,0.95170000f,0.04730003f,0.30290001f,-0.13610000f,0.65760007f,0.65079997f,1.23970004f,0.58840002f,0.62079999f,-1.07050002f,1.23060001f,0.80810003f,1.20390003f,0.71910003f,-0.19189997f,-1.38450003f,-1.62480000f,-1.43760003f,-0.45400000f,0.75470003f,-1.51099999f,-0.48820002f,-0.31190002f,-0.53320001f,0.47500002f,0.96470004f,0.55230005f,0.94010004f,1.88950003f,0.26330006f,1.01700007f,0.80759997f,-2.09900006f,0.01170001f,0.29329999f,0.65840003f,0.96400004f,0.09469999f,-0.61170004f,-0.47000000f,1.06000003f,-1.31080002f,0.12749999f,0.32940003f,0.75230004f,-0.93530000f,-0.40760002f,0.13400000f,2.48849996f,0.25930003f,0.18660003f,0.00429997f,0.64949999f,0.65220002f,1.23230002f,-0.06070001f,0.17580002f,0.67310001f,0.47310000f,-1.21280000f,-1.19439996f,0.66569999f,1.00039996f,0.26960003f,-1.09599995f,0.10140000f,-0.10550000f,0.05010003f,-0.70060004f,-0.49830000f,-0.75209998f,1.37650002f,-0.45529999f,-0.24629998f,0.42139999f,1.63129994f,-1.33209999f,-0.55000001f,-0.02470003f,1.19100001f,0.21600001f,1.05010000f,-0.83609998f,-1.72319999f,-0.18340000f,0.62749998f,-0.39869998f,0.47369999f,1.36730004f,-0.28149999f,-0.55340002f,-0.72690003f,0.34139997f,0.81379999f,-1.43159995f,0.04289998f,-0.72010004f,-0.28200002f,-0.99010005f,-0.54470006f,-0.85719997f,0.62999998f,0.65640002f,0.09680000f,1.44720004f,0.82589994f,-1.47799995f,0.86499997f,0.69949998f,0.34459997f,0.12280000f,0.94999998f,0.24190007f,-0.78790002f,-1.80289999f,-0.20270007f,0.99769998f,1.06460005f,-0.99159998f,-0.91390006f,-1.54540003f,-0.70610001f,-0.14800002f,1.24420003f,0.81710003f,0.48310004f,0.69919994f,-0.73210001f,-0.29749997f,0.26190000f,1.08849998f,1.00500003f,-0.51400000f,-0.48520004f,0.01509997f,-0.75280005f,-1.77609999f,-0.39799998f,0.34629993f,0.50010000f,-0.04629993f,-0.90829996f,1.07909999f,0.93639995f,-0.78730000f,-0.78510003f,0.37760001f,0.57609998f,-0.83079998f,1.17140001f,0.44620000f,-0.36020002f,0.00110001f,-1.42890001f,-0.46310002f,0.67110001f,-0.27360005f,0.52360002f,-0.03659998f,-0.09169998f,-1.17450004f,0.16360001f,-0.18130000f,0.31940001f,-0.28559997f,0.05550000f,0.48419999f,-0.26550000f,0.40720001f,-0.61760001f,0.84820002f,0.59800004f,0.58129996f,-0.60359996f,-1.37620003f,-0.37330002f,-0.65660002f,0.42150000f,1.08080001f,-1.15530002f,-0.22600000f,-0.98019997f,0.90590000f,-1.01549998f,-0.80760004f,0.59049998f,-0.00070005f,0.12930001f,-0.02639999f,0.49170000f,0.35249999f,-0.45010000f,0.82449999f,-0.21559999f,-0.35339997f,-1.14610001f,1.12250001f,0.10730001f,-0.16689999f,-0.42990001f,1.03929998f,0.04980001f,-0.56969996f,0.34929999f,-0.00559998f,0.50989999f,-0.65130002f,-0.49840002f,-0.13190002f,-1.13109999f,-1.00080000f,-1.27539998f,0.82330000f,1.04139996f,-0.70309998f,0.33639998f,-0.35600001f,0.22419999f,-0.88940003f,0.40440001f,0.36809999f,0.70570004f,0.17489997f,0.62669999f,-1.31559997f,-1.30090000f,-1.29680000f,-0.38890004f,0.90849996f,0.79830004f,0.94129999f,0.62930002f,0.56929998f,1.23420003f,0.37759998f,0.64310001f,0.21640000f,1.33639998f,0.64439997f,1.39380002f,1.69569998f,0.58039996f,0.07579999f,0.10219999f,-1.68090000f,0.23249998f,-0.16220000f,-0.29660002f,-0.67250002f,0.25170003f,-0.25350001f,-0.73100001f,-0.28650002f,0.30140001f,0.11329999f,0.33520003f,1.62990004f,-1.32619996f,-0.31589997f,0.36590001f,-0.28710002f,0.16930003f,-0.82020002f,-0.19009999f,0.24200001f,1.36410000f,1.38770000f,1.94740003f,0.00440004f,0.47909999f,-1.02550001f,-1.41910004f,0.04640001f,0.44590004f,-0.26380000f,-0.12369999f,-1.39530002f,-0.78550002f,0.07789998f,0.27560000f,0.46630000f,-0.38479999f,0.34579999f,0.18369998f,-0.43670005f,0.26250003f,1.08880001f,-0.84150003f,-1.51770001f,0.62180001f,1.25049996f,-0.89250000f,0.10750003f,2.45880001f,-0.01030002f,1.37509997f,1.07759998f,1.92279999f,-1.36669998f,-0.00199998f,0.07049996f,1.27189997f,-0.49599996f,1.52789998f,-0.96100005f,0.34690004f,-0.49079997f,0.34000002f,-0.27630000f,0.47160003f,0.44960003f,0.00460001f,-1.71209998f,-0.34899998f,-0.32509997f,-1.11219999f,-0.81159999f,-0.97430001f,-0.23159998f,-0.12380002f,0.45490000f,0.18569998f,0.50800004f,-0.17380001f,-0.01110000f,-0.28690000f,0.34010001f,-0.28130004f,-0.98830001f,-1.04139995f,-1.00549999f,-1.98949999f,-0.54649997f,0.14129996f,-0.25060000f,-0.39589997f,-0.69859997f,-1.72779997f,-1.32190000f,-1.79529998f,0.06439998f,-0.31320001f,0.02250001f,-0.14569999f,-1.26419998f,-1.73610000f,0.68579998f,-0.79840001f,0.17099999f,-0.59859999f,0.06500001f,-0.99069999f,-1.63980002f,-0.02049998f,1.23950002f,-0.85690001f,-1.14079999f,1.41959999f,1.43570002f,-0.96680002f,-0.00669999f,0.46940001f,0.27239999f,-0.00880001f,-0.84410000f,1.42850002f,-0.29979999f,-1.25459996f,-0.16970002f,0.19019998f,0.80280003f,1.00629997f,0.21150001f,-1.51600003f,-1.33950000f,-1.17750003f,0.10189999f,0.53989998f,1.54420000f,0.19659998f,-1.64460001f,0.05849999f,0.72740002f,-1.04050004f,1.06990001f,0.73780003f,-0.38009999f,-0.40209997f,0.15119998f,0.56829995f,-0.45660005f,1.27070004f,0.30170001f,-0.95890001f,-0.39890002f,-0.05689999f,-0.41980000f,0.53250000f,-0.27130000f,-0.02689997f,0.79110002f,-1.21970000f,0.05290000f,1.41219998f,0.58740000f,0.64920001f,0.57990002f,-1.27080002f,0.04279998f,-0.49310003f,1.34089998f,0.52390001f,-1.02369999f,-0.19090006f,-1.20430000f,0.06420004f,1.09030002f,0.22720002f,0.75320000f,1.02470002f,0.12680001f,1.18330002f,0.38129995f,0.71049996f,0.69500002f,0.47869997f,-0.86890002f,1.12400002f,0.94709998f,-0.70020000f,-0.09029998f,0.37459999f,-0.16320001f,0.24590001f,0.26190000f,-0.84240001f,-1.37440007f,-1.98419998f,0.16749998f,-0.16080003f,-0.43809997f,0.67529999f,-0.14629999f,0.64960000f,0.13609998f,1.39239996f,0.03339998f,-0.38149999f,0.22260000f,0.25649996f,-0.28599999f,1.21560003f,-0.15789999f,-0.68059999f,-0.61949998f,-0.58539998f,-0.82169998f,-0.37059997f,1.26290000f,0.36190001f,-0.60610002f,-0.71480002f,-0.04469999f,0.78519999f,1.12370003f,-0.51349999f,-0.16049999f,0.27259998f,-1.30870005f,0.69820002f,0.14789999f,-0.61710002f,0.62300003f,-0.02160002f,-0.74860001f,0.04599998f,-0.74210001f,-0.71540002f,-0.87640001f,0.06250001f,0.62299997f,-1.25040001f,0.17640002f,-1.67969995f,1.15769998f,-0.55679998f,-1.12890004f,1.02680003f,-1.38210000f,-0.35010005f,-0.09410001f,-0.83680001f,0.36340001f,0.89990003f,0.24720001f,-0.37610000f,1.19989998f,0.52820001f,2.05050001f,0.13970002f,0.66989999f,0.07710001f,-1.49729999f,-0.55750005f,-0.44080003f,-0.02640001f,-1.48050002f,-0.26980001f,0.13670000f,-0.33350003f,1.62940003f,-0.66450001f,-0.20860002f,0.47579996f,-1.49930001f,0.57430000f,1.21110005f,0.81429998f,-0.84150001f,-0.27300001f,0.26420002f,0.19259999f,-0.03200002f,0.87670003f,0.74229998f,0.75169999f,2.14439999f,0.08340003f,-0.16679997f,-0.82209998f,0.43070000f,1.17060002f,-0.55089997f,-1.24310003f,-0.62030002f,-0.85660002f,-1.00650003f,-0.47250001f,-0.94009997f,0.55959999f,0.35900002f,0.01139999f,0.59939999f,0.01770001f,-0.78860004f,-0.06770000f,0.34700004f,0.13840001f,-0.06829998f,0.58279998f,-0.69460001f,-0.26330003f,0.10189998f,0.66210001f,0.41970002f,-0.31019996f,-0.96250005f,1.09980001f,-0.02629998f,-0.74799999f,-0.39869999f,-0.59290000f,-1.41479999f,-0.18110000f,-0.87400001f,-0.79930005f,-1.28370004f,0.67700000f,-0.53199999f,-0.15580001f,-0.16509998f,0.68470000f,0.42690003f,0.69730002f,1.23300003f,0.56460003f,0.27750003f,0.12020003f,1.59320002f,-0.58910001f,-0.25970001f,0.19699999f,-0.49079998f,0.31389998f,0.24420001f,-0.19040003f,0.94080001f,-0.52570002f,-0.77600004f,-1.77580000f,0.83030001f,0.37900001f,0.19540002f,0.45180001f,-0.78169998f,-1.61730004f,0.57059999f,0.16610000f,-0.04859999f,1.71250008f,-1.15530001f,-0.40070005f,-0.08210002f,-0.02280000f,0.79080001f,0.94910000f,-1.13890000f,-0.09050000f,-1.43890003f,-0.79320004f,1.84320003f,0.11480002f,1.25710000f,0.34510002f,0.42019998f,-0.80670001f,-0.52640000f,0.57789995f,-1.03670000f,0.72999998f,-0.53930006f,-1.74580001f,2.39160005f,-1.11469998f,0.08159996f,-1.15819995f,-1.48130002f,0.06720002f,-0.12769999f,1.11550005f,0.92090004f,-1.17410002f,-1.48550000f,0.81629999f,-0.25100002f,0.22880001f,-0.33519994f,-1.44810002f,-1.03029998f,-0.38340002f,-0.65520000f,-0.28930000f,-1.22630000f,0.79610002f,1.94919997f,-0.08789997f,0.20700001f,0.39299997f,-0.28370000f,0.56860002f,-0.65680005f,-0.76690004f,0.45279997f,1.24120002f,-0.74460003f,-0.84959998f,1.84820002f,0.23890000f,-0.44510000f,-0.18659999f,-0.58630000f,0.64500000f,-0.15160006f,-0.32099999f,1.89640007f,0.65620000f,0.12560000f,0.57320001f,-0.07189999f,-0.63110001f,0.34779995f,0.96980003f,1.09349999f,-0.59000003f,0.46700000f,1.21980005f,0.86070001f,-1.03610002f,-0.48970000f,0.29440000f,-0.23589999f,0.04050001f,0.81990001f,-1.18380000f,-0.85960005f,-0.14190001f,0.06569995f,-0.93500000f,-0.62550000f,0.21269999f,0.81200001f,-0.59810002f,-0.60750004f,-1.60059998f,-0.57909999f,-0.06469992f,-0.45880005f,0.22000004f,0.30720003f,0.55389999f,0.29490001f,-1.04090000f,1.45860001f,-0.04830000f,0.06059999f,-0.42080000f,0.70889999f,0.50479999f,-0.05320001f,0.22710001f,-0.48390000f,-0.15119999f,0.87279998f,-1.04460004f,0.06409999f,-0.31200001f,-1.43849997f,0.26790005f,1.11200004f,0.75510002f,1.05999999f,1.51910003f,-0.11019999f,1.68690001f,0.35540001f,-0.79179998f,0.63780001f,0.16950001f,1.05590001f,0.24920001f,-0.06999998f,-0.06180002f,0.14390001f,-0.64380003f,-0.72950001f,0.27360002f,-0.38730000f,0.77549993f,0.51340000f,-0.05750006f,-0.20839997f,0.17060002f,-0.73860001f,-0.73719998f,-0.77899999f,-1.14280002f,-0.22190000f,-1.01789997f,-0.69380002f,0.43780002f,0.17659999f,0.45669998f,0.11950001f,-0.49670000f,0.32470002f,-0.22899997f,-0.16800000f,-1.04730003f,0.12089998f,0.11040001f,-1.29109999f,-0.69889999f,-0.20029999f,-0.30810002f,-0.35110001f,-0.06360000f,-1.30340005f,0.67290003f,0.67670001f,-1.18030001f,-0.27140000f,0.73510000f,0.86200002f,-1.10270004f,-0.93200000f,-1.87360000f,-1.15139997f,-0.96040000f,0.10510000f,1.42179997f,0.37229998f,0.54630001f,-0.35570001f,0.31460000f,-0.54680001f,1.17190003f,0.30470000f,0.06759999f,-0.56019998f,-0.57949999f,-1.55209998f,-0.17019993f,1.02349999f,0.02490000f,-1.12600001f,-0.01060002f,1.03730000f,0.09809999f,0.21380000f,0.34160000f,0.25430000f,0.08470001f,0.67570002f,0.16810001f,-0.57830002f,1.01700003f,1.18160004f,-0.49750003f,0.56880002f,0.07429993f,0.25930000f,1.02319998f,0.80810001f,0.70889999f,0.92350001f,0.05730001f,1.31570003f,0.11730004f,-0.39539999f,-0.38700001f,-0.67509998f,-0.14209999f,-0.45630000f,-0.68230000f,0.13419999f,-0.15930000f,0.54019997f,0.08989997f,0.55199999f,1.50780003f,0.64470003f,0.22370000f,-0.23650000f,0.47180002f,0.50650003f,-0.64150002f,-1.77110006f,0.38340004f,-0.15710001f,-0.13220000f,0.20310002f,0.64529999f,0.15879996f,0.49310001f,0.37680000f,0.48599998f,-0.00559998f,-0.54629997f,0.36880000f,-1.91710000f,0.71319999f,-0.37380001f,1.17579999f,0.59990000f,-0.63230001f,0.79019997f,-0.66520000f,-1.58990001f,1.16300001f,-0.41340001f,0.67700000f,1.72090008f,0.07689996f,0.84029998f,0.41730001f,0.94259998f,-0.32539997f,0.73060004f,0.01770003f,-0.68610001f,-1.14530001f,0.39350002f,1.31070002f,-0.68850003f,0.00800001f,1.26310001f,0.56690001f,-0.42300001f,0.01600000f,-0.48420000f,-0.12529997f,0.13409997f,1.16449998f,0.64570003f,0.09570003f,-0.51580002f,-0.21150004f,0.63289997f,0.48410000f,0.88230002f,-0.03490002f,-1.99209997f,-0.08909999f,-0.85220004f,-0.07940003f,0.27189998f,0.79760001f,-0.05150004f,-1.19640000f,-0.45980000f,0.47329999f,-0.58580004f,1.50669998f,0.67010000f,0.22819999f,-0.49540001f,-0.60419999f,0.36870001f,-0.95630003f,0.59870002f,-0.03360000f,0.08999999f,-0.50780000f,-0.79310001f,0.04599996f,-0.42439999f,0.12290001f,-1.94860000f,0.16000001f,-1.04799999f,1.17449999f,-0.06489998f,-0.85150003f,0.26129999f,0.16879997f,0.23759997f,-1.20889999f,-0.80470003f,-0.86799999f,0.28920000f,-0.24340002f,-0.18710001f,0.52989998f,1.44010002f,-0.26879998f,1.08270000f,0.43800003f,0.27729999f,-0.20190001f,0.03730000f,-0.79719999f,1.15970002f,-0.71550004f,-0.01879997f,0.10779999f,-0.60899999f,-0.94180003f,0.12340002f,-0.23290006f,0.48740002f,0.82640002f,-0.96460003f,-0.76910001f,0.01449998f,-0.64320001f,-1.22419998f,0.15620002f,-1.64329999f,0.90649997f,-0.25460001f,0.96910000f,-2.10460001f,-0.08109998f,0.95830003f,-0.18409999f,0.03369999f,0.97720002f,-0.45959998f,0.49230001f,-0.14760000f,0.14359997f,1.24170002f,2.17209999f,0.01280001f,-0.08699997f,-1.40670002f,0.18539999f,-0.41560001f,-1.41770000f,0.43999999f,-0.51260001f,-0.34990000f,0.34280000f,-0.96140000f,-0.96439996f,1.32390000f,0.07240001f,0.30800001f,0.39340000f,1.92480001f,-0.37779999f,0.15909997f,-0.52070003f,-0.55580000f,0.35470006f,1.44690000f,-0.21039999f,0.20799997f,-0.82460003f,0.76370000f,0.40569999f,-0.65780000f,0.59240000f,0.93890001f,-0.96240001f,0.27380002f,0.61730001f,-0.45230003f,1.67430002f,-0.65159995f,-0.31270001f,1.45950001f,-1.27210002f,-0.47730002f,0.11829997f,0.51739999f,0.34209999f,-0.55720002f,-1.93280006f,0.07369996f,-2.28129999f,0.04729997f,1.81449997f,0.39530003f,-0.01790000f,0.35479999f,1.45860000f,-0.43780001f,-0.27339994f,1.43530002f,-0.75920001f,1.56649996f,-1.20239997f,-0.62390000f,2.64800005f,0.36319998f,-0.56069997f,0.33250001f,0.30320005f,0.59310003f,-0.49050000f,-0.40190001f,-0.29079996f,0.05490002f,0.74770000f,1.15320000f,-0.72539996f,-0.17610002f,-0.55130001f,-0.75450005f,0.55209999f,0.54580000f,-1.04140002f,-0.84810005f,-1.11330004f,-0.26500001f,-0.95820006f,-0.50210001f,0.10369996f,-0.43600002f,-0.35460000f,-0.28489999f,1.68060003f,0.68379997f,-1.41450001f,0.40610003f,1.05580005f,0.58960000f,-0.23280004f,-1.46319999f,0.72719998f,0.75499999f,0.93920005f,0.51290002f,-1.23340004f,0.04429999f,-0.09090001f,-0.93690001f,0.49999999f,-0.03200000f,0.33199999f,1.06410002f,-0.93180000f,-0.68580004f,0.91690001f,0.90380002f,0.97080002f,-0.02639999f,-0.38339997f,0.12309999f,-0.21010001f,-0.59400000f,1.33930000f,0.18540002f,-0.26630002f,-0.53580002f,-0.83149997f,-0.72120002f,-0.14179999f,-0.36550001f,-0.89200003f,-0.33629999f,-0.69200003f,-0.80609996f,1.38030002f,-0.02720001f,-0.74790004f,0.81689999f,0.12680002f,0.06830002f,-0.10630000f,-0.04230001f,-0.11219999f,0.39010001f,-1.70230001f,-0.46500003f,0.81979999f,1.07070003f,1.06849997f,-0.76320003f,0.10590004f,0.46500000f,-0.17390001f,-0.27070000f,0.74240001f,0.62720002f,0.17559998f,-0.73450002f,-0.22929999f,0.35800002f,-0.12969997f,0.80069998f,0.64530002f,-0.24370003f,-0.20790001f,-0.16139999f,1.19350002f,-0.54470001f,-0.41170002f,0.46040002f,0.41730007f,-0.06160002f,-1.07170003f,0.63149999f,0.06140005f,0.56340004f,0.58059998f,0.30899999f,0.16080000f,-0.42409999f,1.11810002f,0.45220003f,-0.83730004f,0.13849997f,0.56410002f,-0.06759999f,0.53790005f,-0.34530001f,-1.44300000f,-0.01340002f,-1.94660003f,0.07979996f,-1.03420000f,0.49030001f,0.59899999f,-0.45050002f,-1.56680004f,-0.03730003f,-0.91149999f,1.63059996f,0.01610006f,1.70059998f,-0.08099997f,1.21449996f,0.07870003f,-0.96480003f,0.29050001f,1.51570003f,-0.65409999f,0.71959996f,0.29660000f,0.78410002f,1.09700000f,-0.00399999f,0.35299998f,0.55539999f,1.16430003f,0.41560005f,-0.38029998f,-0.27640003f,0.14559998f,1.15680002f,-1.51370001f,-0.60010003f,0.45560001f,1.01610001f,0.40280000f,1.51790001f,1.93090001f,1.14320001f,-0.66210003f,1.08630004f,2.02070000f,0.22249996f,-0.86400001f,-1.12560005f,-0.69660002f,0.04060002f,-0.68700004f,0.01360002f,0.79170002f,-0.69600003f,-1.01380001f,0.78580003f,0.64890000f,-0.62050000f,-0.44260002f,0.69329998f,0.03329999f,-0.02530001f,0.18290000f,-0.23609998f,-1.75379997f,-0.58039999f,0.16489999f,1.87069998f,0.39469999f,1.40070001f,0.76270001f,-0.97410001f,-0.39850002f,-0.60609999f,0.25999999f,0.80030003f,-0.32139997f,-0.67490000f,-2.11089999f,-1.24989998f,0.49440000f,-0.24550000f,-0.08939999f,-0.15139999f,-0.50230001f,0.05609999f,1.28940005f,-0.20820005f,0.09590000f,-0.29020001f,-1.71740003f,0.28960002f,0.85550001f,-0.77030002f,0.85140004f,-1.03129997f,0.30810000f,-0.39080003f,-1.39920002f,-0.31430003f,-1.23710000f,-0.53590002f,0.21749997f,-0.35360001f,0.09590003f,-0.11370006f,-0.55250000f,-0.15579999f,-0.47159999f,-0.28050000f,-0.12859998f,-0.98260004f,-0.54399998f,-1.75980000f,-0.27010002f,0.33950002f,-0.00859999f,-0.58410004f,-0.07179999f,0.40860001f,0.46829999f,-0.83500002f,0.07970002f,0.18269998f,0.12590003f,-1.23140003f,-1.61440006f,1.23570004f,0.80350001f,-1.35700004f,-0.66050000f,-0.62250001f,0.05200001f,0.08229999f,-0.96530003f,-0.98479999f,-0.35250000f,-2.28749997f,-0.29530000f,-1.39399998f,-0.20219999f,-1.10269997f,0.29880002f,0.54530006f,-0.06850001f,-0.92490001f,0.26850001f,0.01770001f,1.19899996f,-0.62140007f,-0.78510003f,0.89580003f,1.38150001f,-0.15790000f,0.42769999f,0.08759999f,0.55210001f,0.70610001f,-0.21549999f,0.19960001f,-0.75980003f,0.09120001f,0.22529998f,-0.27120000f,0.80300002f,-0.47480001f,-1.50900002f,-0.43910001f,0.10220002f,0.16409998f,0.51009998f,0.42230001f,0.21969999f,-0.08390000f,0.13780001f,0.57069997f,-0.57180000f,-0.51249998f,1.02359999f,-0.28850003f,-0.03689999f,0.24980000f,0.29500000f,0.38820001f,0.31490001f,1.29130002f,-0.36279999f,0.03730000f,0.78350001f,-0.23019999f,-0.19140003f,0.29260002f,-0.11670001f,-0.01830000f,-0.04230000f,0.11440000f,1.00940004f,-0.37520002f,-0.52930001f,0.83920001f,-0.01280000f,0.43520000f,1.40560001f,-0.63320001f,-0.05150000f,-0.37909999f,0.73500001f,0.17779999f,-0.47980001f,-1.13849998f,-0.51079997f,0.08550000f,0.10459998f,2.44039995f,-0.64560003f,-0.54030001f,0.25870000f,0.30830000f,-0.10460001f,-0.01530002f,1.18270000f,0.10559998f,-1.50460001f,-0.70870001f,-1.26529994f,-0.75919996f,-0.64280001f,-0.84900001f,0.28960005f,-0.40900005f,0.07230003f,-0.58970001f,-1.38600004f,0.94120003f,1.41130007f,-0.89480005f,-0.31180002f,0.19110001f,-0.75660001f,-0.59249999f,-1.52369998f,-0.82439999f,-0.87290001f,-1.45810001f,0.28590001f,-0.28270000f,-1.00160000f,-0.22390002f,-0.92800001f,-0.64780001f,0.87250000f,-1.33700000f,-0.72199996f,-1.93430002f,0.15180000f,-1.55450002f,-1.00860004f,-0.00650000f,0.41500005f,-0.85830004f,-0.63090001f,-1.03170000f,0.30129996f,0.06070000f,-0.86220003f,-0.09249999f,0.19659999f,-0.86930001f,-1.05740002f,0.05430001f,-0.41280004f,0.20850003f,0.14439998f,0.52420000f,1.42920004f,0.31190000f,1.16310002f,1.74759992f,-1.73360001f,-0.53300003f,-1.73860004f,0.62990003f,0.67989998f,0.20799999f,-1.00360001f,-0.03319997f,0.69769997f,-0.36569996f,-1.56820005f,-0.10400008f,0.70360000f,-0.98290001f,0.20420004f,0.81130004f,0.23089997f,-0.41150005f,1.10820003f,-0.43059997f,-0.03360002f,1.36680004f,0.83809999f,-0.16899999f,-1.78970001f,-0.31300003f,0.97930003f,0.93120004f,-0.29939998f,-0.22950001f,0.89910007f,1.04900004f,0.29280001f,-0.03410003f,-0.22450001f,0.52730003f,-1.97350004f,0.14379998f,2.38460007f,0.29799996f,-2.05640007f,-0.73929998f,0.38390002f,0.27990000f,-1.47550005f,-2.00090007f,0.85250003f,0.78930004f,-0.37189997f,-0.58500003f,-1.07730001f,0.34740000f,-0.36890002f,-0.38850003f,1.47100000f,1.02190001f,0.13639997f,0.13739997f,-0.29390002f,-0.13430001f,-0.83130001f,0.52910001f,0.12990000f,0.48890001f,-0.97080002f,-1.14530001f,0.09540000f,0.30880003f,-0.57909995f,0.81230002f,0.45640004f,1.27139999f,0.63210003f,0.83289998f,1.15920003f,-0.81750001f,-2.02910004f,-0.36689995f,0.94670004f,0.70929998f,-0.52600000f,-0.14430001f,1.29269999f,0.05310001f,0.45090000f,0.27770004f,-0.44700001f,-0.60370005f,1.71450000f,-0.27009997f,-0.62530001f,0.12030002f,0.75920003f,-0.35050001f,-1.10459999f,0.01669999f,0.71710003f,0.77810001f,-0.82120003f,-0.32400001f,-1.12829997f,1.28009998f,1.08599999f,0.04110000f,-0.80990000f,1.01360001f,-0.92099998f,0.09389999f,1.08620005f,1.21119998f,-1.21060001f,1.65069998f,-0.00669997f,-0.20480003f,0.19070005f,1.71930000f,-0.65789999f,0.92640002f,0.93080000f,-0.70670003f,1.10350004f,0.90150008f,-0.36939996f,-1.86930003f,-0.09970002f,1.27929998f,0.34710000f,0.22620003f,0.04019997f,0.17720001f,-0.68200001f,-0.48580003f,0.97300003f,0.63030000f,-1.24419999f,-0.17999999f,0.22379994f,-0.94049999f,-0.12169999f,0.15169999f,1.55680000f,-0.23320001f,-1.85010008f,0.18190001f,1.36590006f,0.99289999f,-1.61360004f,-0.23529996f,0.90659998f,-0.48369997f,0.43339999f,-1.42969998f,0.34440002f,-1.72920003f,-0.71720003f,0.01929998f,-0.91290000f,1.10760003f,-0.71499996f,-1.07330002f,0.86739997f,1.52130001f,0.10160004f,0.39069998f,0.25469996f,1.02540002f,0.57459998f,-0.85220003f,1.28979999f,-0.10910000f,-1.53590003f,-0.53560000f,-0.04980002f,-0.97320001f,-0.10470003f,-0.31139997f,-1.40989999f,-0.71640004f,-0.42140008f,-1.00409999f,1.87640006f,0.40360003f,-1.32980005f,-0.96140000f,0.15350000f,-0.52249993f,0.62570001f,1.64279995f,-0.12469998f,-0.40659998f,-0.49569998f,-1.05170002f,-0.95159996f,-0.14300000f,0.04550000f,0.78930000f,-0.29089995f,-1.09100001f,-1.37100003f,-0.65780005f,1.30759999f,1.15690001f,0.95409999f,0.17030002f,0.40869999f,0.15160000f,0.70100000f,0.14750000f,0.77560004f,0.97530006f,-0.02650001f,-0.79740003f,-0.85870000f,-0.45279998f,-0.36380003f,0.70920000f,0.78109998f,-0.33850001f,-0.02380001f,-0.78909995f,0.06460003f,0.20179997f,-0.73500007f,0.16970001f,-0.54169997f,1.17160001f,-0.66940002f,0.32650000f,-0.05340004f,1.71960004f,0.39619999f,-0.99880000f,0.98040001f,-0.39389998f,1.29569999f,-0.55309999f,0.55560001f,-0.22409998f,-0.52859999f,-1.83419999f,-0.92229999f,0.00250006f,0.08470006f,0.62250007f,-1.58580000f,-0.37259995f,1.43990000f,0.79669999f,0.65650001f,-0.07809997f,1.18220007f,0.29979997f,-0.72190003f,0.36350003f,0.41490001f,-0.72470000f,-0.65250002f,1.51080003f,0.11379999f,-0.35000000f,0.64870001f,0.83010002f,-0.47609998f,-0.02949999f,-0.42040001f,0.00440000f,0.52650003f,0.15360001f,-0.10190000f,1.07010003f,0.93720000f,2.55770000f,-0.82140004f,-0.87400005f,0.10500004f,-0.42350004f,-0.20740000f,0.03840004f,-0.12000004f,-0.90530004f,-0.96719998f,0.75600006f,-0.59570000f,-0.30119999f,-0.16759999f,0.20469998f,0.26889999f,-0.53710001f,0.45500005f,-0.71810003f,-0.04259996f,0.52390000f,-0.42870000f,0.69140002f,-0.18010001f,-0.37470001f,-0.53329998f,0.78430005f,-1.14150001f,-0.04570001f,0.00290002f,-0.81529996f,0.53850000f,-1.30890000f,-0.74750002f,-0.82509996f,-0.50449997f,0.65009999f,1.26350000f,-0.62709999f,-0.71940002f,-1.13170002f,0.52879998f,-1.25740006f,0.21989996f,-0.18860005f,0.21149999f,0.93800001f,-1.07009998f,-0.84150000f,0.69580002f,-0.57580003f,-0.83010002f,0.51040000f,0.79890002f,-0.61320001f,0.91190003f,-0.15300002f,-1.10330001f,0.59770000f,1.61310003f,-0.49320003f,0.15750002f,0.07520001f,-0.47219999f,0.42509999f,-0.14880001f,1.20879997f,-1.34459999f,-0.05339999f,0.58469998f,1.14769994f,-0.92200002f,1.01469994f,-0.39410004f,-0.45070001f,-1.03289998f,-0.25789997f,-0.64790000f,-1.38850003f,-0.23009997f,-1.30770001f,-1.37769999f,-0.88689999f,-0.37019998f,-1.28370004f,-1.46130002f,0.21170001f,-0.44730004f,0.11980001f,0.44529999f,-0.60160002f,-0.25109998f,-0.25949999f,-0.29650001f,-0.34780001f,-1.03640002f,0.37760002f,-0.02680001f,0.40370000f,-0.30970001f,1.05420000f,-0.22570002f,1.40849996f,0.60659998f,-0.20209992f,-0.46749998f,-1.74429998f,0.92229998f,-0.47000001f,0.31679999f,-0.00909998f,-0.26269995f,0.55440008f,-0.99610001f,-1.06080001f,1.24089996f,0.63619997f,0.53620001f,0.81939999f,0.19149998f,1.01410001f,-0.57499998f,0.36500003f,-0.16110003f,0.10070003f,0.94480005f,-0.65700006f,-0.73570002f,0.37150004f,-0.82670000f,0.24379998f,0.88689999f,-1.16380000f,0.13310008f,0.88640001f,0.31069999f,-0.58250001f,-0.27800001f,-0.88850003f,0.31569999f,-1.63779994f,-0.81180001f,-0.89699998f,-1.10729994f,-0.47269995f,-1.37390003f,0.12250001f,0.93680001f,1.63410006f,0.42040000f,-0.39820006f,1.11339994f,0.95069999f,-0.49019999f,0.85250000f,0.15749999f,-1.17040001f,-0.50449997f,0.93980001f,1.03429999f,-0.74189999f,0.33260000f,-0.26489999f,-0.35150000f,1.22659999f,0.61560000f,-0.19659999f,0.65600003f,-0.34890000f,-1.34790003f,2.36569997f,0.44169999f,1.50529998f,0.55549999f,-0.71899997f,0.02599998f,0.56810000f,1.05230003f,1.74610002f,-0.26240001f,-0.96859997f,-0.36090001f,-0.23459999f,0.66660001f,0.01049999f,0.83959995f,0.15639998f,-1.10490000f,0.31789999f,0.15369998f,-0.33470003f,1.25700002f,0.50910002f,-0.84610000f,0.19039999f,0.15150000f,-0.76050003f,0.01580000f,0.44869999f,-0.24600002f,0.94150002f,0.26289999f,-0.48910000f,-0.84730001f,0.19070001f,-0.15860005f,-0.83000001f,0.44839998f,-1.25699997f,-0.26080002f,-0.22639999f,-0.50120002f,-0.43510001f,0.78750003f,0.49550002f,0.43320003f,0.11749998f,-1.07850003f,0.30439999f,0.11719998f,-0.40780004f,0.71180002f,-0.13339999f,-0.49230002f,0.84850002f,-1.16239995f,-1.29330001f,-0.58860000f,-0.29450003f,-1.15900002f,0.14690005f,0.46290002f,-0.16320000f,0.57200002f,-0.00620000f,1.77890001f,0.21969999f,-0.55610002f,0.74420001f,-0.28750000f,0.34160001f,-0.05470003f,-1.12569999f,-0.95740007f,-0.66009998f,-0.31240004f,-0.43859999f,1.34880005f,1.26320003f,-0.09709998f,0.61179996f,-0.01170001f,-1.42920002f,-0.59610006f,-0.71989999f,-0.81009997f,-0.50619999f,-0.58780005f,0.04809997f,-2.12329999f,0.45950003f,-0.70610001f,0.26789996f,-0.95969996f,-0.90190001f,0.55110000f,0.73699999f,0.81260001f,0.19770003f,1.33599999f,-0.06439999f,2.29429997f,-0.26289998f,0.35409998f,0.36190000f,0.08150000f,0.29070000f,-0.36679996f,0.16959999f,0.10410000f,-1.37319996f,0.14249996f,-1.97189994f,1.58670002f,0.13800000f,-0.01040001f,-0.53459999f,-0.18959999f,0.78759995f,-0.44820001f,0.08740002f,0.58420002f,-0.61680001f,-0.52129992f,-1.70100001f,-1.19280001f,1.04419995f,-0.48650006f,0.55640003f,-1.46139994f,-1.20950001f,-1.01590004f,0.39880002f,0.07110002f,0.87659999f,-1.00109999f,0.18450003f,0.84719998f,0.07440003f,0.80790005f,0.29809996f,1.02220003f,0.80880005f,-0.73980001f,1.00859999f,-0.37810002f,1.29249999f,-0.80440001f,0.31570000f,2.08180001f,-0.89280004f,-0.07719999f,-1.12289999f,0.58720003f,0.44429998f,-1.38680006f,-0.55419997f,0.20670003f,0.06920000f,-1.14080002f,-0.76430005f,0.94220001f,0.12800002f,-0.52920009f,1.89790003f,0.58060000f,-0.58459998f,-0.12639999f,0.52499999f,1.18110001f,0.82970004f,-0.11170002f,-1.13500003f,-0.94220002f,-0.05300000f,1.43199998f,-1.08140003f,-1.59769999f,0.12099999f,-0.29270002f,-0.21180000f,1.03780000f,-0.36030001f,-1.45210006f,0.31360004f,0.32320000f,-1.41840001f,1.03040007f,0.80530001f,-0.78879996f,1.30269994f,1.52069998f,-1.01550003f,0.83919998f,1.49530002f,0.73080000f,-0.94609997f,-2.11099998f,0.42999997f,-0.54990003f,-0.67710003f,-1.36970000f,-0.15890000f,0.22490002f,-0.32770002f,0.36219999f,-0.22860000f,-0.13179995f,1.18660001f,2.47909998f,-0.19259995f,-0.18149994f,0.59129999f,0.74270000f,-0.50650002f,0.09230004f,-0.25550000f,1.06250004f,0.31529999f,-0.10770001f,-1.29810000f,1.36500001f,0.40509997f,-0.50880002f,-1.20240002f,0.14419999f,0.40700000f,0.63120002f,-0.91710004f,0.32259997f,0.37230000f,0.37170001f,-0.68559998f,-1.25949998f,0.12790000f,-0.02289999f,0.48739998f,-1.14719999f,0.07100001f,0.02389999f,0.00090000f,0.51349998f,-0.46760000f,0.09880001f,0.73070000f,0.93169996f,-0.82909998f,0.38139998f,-0.34269998f,0.71090001f,-0.64240000f,0.04139997f,-1.00319996f,-0.37400001f,0.12100002f,0.42719998f,-0.79179999f,0.08709996f,-1.04059996f,0.25369995f,-1.42639998f,0.65080000f,-0.47709996f,0.04889996f,-0.78239999f,0.64580000f,-0.39579998f,-0.69859998f,-0.76830002f,0.39549996f,0.94059999f,0.70659999f,-0.66469999f,-1.13779999f,-0.34289999f,0.19520001f,-0.13080003f,0.45890001f,1.27920000f,0.45990002f,0.62410001f,1.23299999f,0.78560001f,0.63990002f,0.00419998f,-0.63230001f,-0.80610002f,-0.83190000f,0.68620002f,-0.27280002f,0.45510002f,-0.33580005f,-0.04889999f,1.47470005f,-0.60550006f,0.76610002f,-0.14789999f,-0.69550001f,0.87350001f,0.13010000f,0.16820004f,0.47140000f,1.07260003f,0.54989999f,1.26050000f,-0.54620002f,0.88149994f,0.34660000f,-0.23539999f,0.94540003f,-0.68600000f,-0.12680004f,0.82399999f,-0.03999998f,1.03690005f,-0.07249999f,0.86300005f,-0.38549996f,-1.04140004f,0.55799996f,-1.14720005f,0.24940000f,0.67780001f,1.54600001f,-0.54749999f,-0.18800001f,0.32880001f,-0.52070001f,0.66660000f,1.63490001f,-0.74100000f,0.02930002f,1.15169999f,0.95610000f,-0.35570000f,-1.15770002f,1.59199997f,1.34729998f,0.18630001f,1.42099998f,0.37239995f,0.27189999f,-0.49900004f,0.07900000f,0.03009999f,0.03230001f,0.20890000f,0.99549998f,-0.05899999f,0.80659996f,1.28049997f,0.56680003f,2.00810000f,1.29529996f,0.30879995f,-0.70089999f,-0.19640002f,0.50119999f,-0.74050000f,-0.58620001f,-0.03010000f,0.63760001f,-0.05740000f,0.22480001f,-0.62829999f,0.14280001f,-0.08260001f,-0.29159998f,1.52940000f,1.31210003f,-0.63610000f,-0.53099997f,1.80709997f,-0.18120003f,1.99949999f,0.53460000f,-0.22409992f,0.49390008f,-1.84699996f,0.32779997f,0.45659995f,1.00210002f,0.74210002f,0.09459998f,-0.86490000f,-1.01189999f,-1.45240000f,1.19699994f,-0.13810004f,0.74330000f,0.27449999f,-0.95679998f,0.42700004f,1.03319996f,-0.51010006f,0.95479999f,0.49760002f,0.12539998f,-0.10589998f,0.61470002f,-0.27800001f,-1.51500005f,-0.01259999f,0.96530003f,-0.37960004f,0.07660001f,-0.27589998f,-0.10359999f,0.69299998f,1.02940001f,1.28409999f,-0.56570002f,-0.61189998f,0.84830002f,-1.01260001f,-1.51329999f,-0.78980009f,-0.89689999f,-0.17200000f,0.90600004f,-0.25589999f,-0.16420002f,0.06489999f,1.12270002f,0.74880001f,0.46890000f,1.13910003f,-0.23239993f,-0.10760000f,-0.41230002f,-1.40020000f,0.28710002f,0.20480001f,-0.14330001f,-0.18800002f,-0.98590001f,0.57420003f,1.84660000f,-0.60260000f,-0.51209998f,1.11000001f,1.02390002f,-0.51880001f,-1.05400000f,-0.87549995f,-0.74209998f,-0.27220003f,1.79229996f,1.40679997f,0.10170006f,0.00650001f,0.98550001f,0.18660001f,-0.22880000f,-0.58579999f,1.41729999f,0.26740001f,-0.75769997f,-0.32099999f,-0.20930002f,0.55340001f,0.97109999f,0.07749998f,-0.10439999f,0.43680004f,0.99110000f,0.14370000f,-0.34410004f,0.83750001f,0.06369998f,0.01280000f,-0.48440000f,-0.22629999f,0.14289998f,-0.04799998f,-0.76760004f,0.38950002f,0.39220002f,-0.68150001f,-0.89070003f,0.33910001f,-0.38690001f,0.58169997f,1.41349997f,0.66379997f,0.42549999f,-0.96679998f,0.62020001f,-0.55499996f,0.34989999f,-1.22679995f,0.07530002f,0.95260000f,-0.27339998f,0.42900001f,0.47409998f,0.50979999f,1.27649996f,1.60739998f,0.34409998f,1.42510002f,1.52209997f,1.01299998f,-0.04230001f,1.09529999f,0.21059999f,0.10710002f,1.17910004f,-1.08130003f,-0.03179998f,0.17859999f,-0.55730001f,0.85710003f,1.64510004f,-0.64150003f,-0.07339999f,-0.54680000f,-0.55779997f,0.87629996f,-0.48849996f,0.77529994f,-0.51430007f,-0.75940004f,1.02000008f,0.37850003f,-0.04210004f,0.54999994f,-1.44769997f,0.85020005f,0.91650003f,-1.36060004f,-0.46519999f,-1.16420001f,-0.02880001f,0.72350001f,0.92089994f,1.23790000f,0.93710002f,-0.40559998f,0.46799998f,0.06420000f,0.00600004f,1.26870003f,0.52810002f,-0.52480000f,0.42169998f,-1.04379999f,-0.20090001f,-1.24990000f,-0.82609998f,0.43049999f,0.79849999f,-0.03670000f,-0.92580006f,-0.50780000f,-1.08340006f,-0.63129996f,0.29179998f,-0.84999996f,-0.50250000f,0.34700002f,0.61489998f,0.21049998f,0.32510002f,1.05670002f,0.00980000f,-0.44980001f,0.05650000f,1.11670000f,-0.32620006f,0.19130003f,-0.15240001f,0.95290001f,-0.05960004f,-0.59140004f,0.31470004f,-0.60880000f,-1.43200002f,-0.68300003f,0.57769996f,-0.08709997f,-0.18229998f,-1.02360003f,1.01520001f,0.67740006f,-0.78590000f,-0.15640002f,0.61680002f,0.35350000f,-1.00550003f,-0.75899996f,1.65190003f,-0.87540002f,-0.93450000f,-0.48599997f,2.20730008f,0.63829998f,-1.78960005f,-0.06569999f,1.19770003f,-1.02320002f,0.94389996f,1.95620007f,-0.66279994f,-1.39420004f,-0.67740004f,-0.53140001f,0.04419999f,0.87320002f,-0.52390001f,-0.83230002f,0.11650001f,-0.19410002f,1.03830000f,-0.12710002f,0.72350001f,1.25280006f,-0.14699998f,-0.78740003f,1.27440002f,-0.01899999f,-0.77130004f,-0.86470005f,-0.01440003f,-0.75940001f,0.94020002f,-0.47909997f,0.60580001f,0.25049996f,-1.56700007f,-1.53000000f,1.32200002f,-0.14839999f,-1.25460007f,-0.57739997f,1.01740004f,0.96630003f,-1.45390004f,-0.65140006f,0.19800006f,0.54410003f,-0.05320002f,-0.03930000f,-1.12509993f,-1.11990001f,-0.87570005f,-0.43010002f,1.17939998f,0.71910004f,-0.13040002f,-0.69490005f,-0.46890002f,0.64460001f,0.24390005f,0.57979999f,0.78930002f,1.18010003f,-0.10689997f,-0.61770001f,-0.41260005f,-0.61350004f,-0.82310005f,0.95520002f,1.10520005f,0.05879993f,-0.23799998f,-0.05180000f,0.82060000f,0.12119995f,-1.41970001f,-1.13319993f,-1.09420004f,0.71380004f,1.57890001f,-0.13359998f,1.14939999f,0.29010000f,0.06270001f,-0.42140000f,-0.08019999f,-0.16350000f,-0.32880001f,0.42619999f,-1.53220000f,-0.39210002f,-1.56410000f,-0.10330000f,-0.26910000f,0.33280001f,-0.46119999f,0.20690000f,-0.56669999f,-0.25800000f,0.54630000f,0.34640002f,0.07549996f,1.02890001f,-1.06509998f,0.70090000f,0.43200001f,1.00139998f,-0.12600000f,0.43679997f,-0.23400000f,-0.25119999f,1.25530001f,-0.83270000f,-0.41050004f,1.15670001f,-1.21449996f,-0.16270002f,-0.36999999f,-0.16510000f,0.10069999f,2.18470004f,0.51560004f,-2.09200007f,-0.01040008f,2.08440002f,1.50450004f,-0.52419999f,0.31749997f,-0.55170000f,-1.68180001f,-0.60060004f,0.64639997f,-0.20569999f,-2.34000001f,-0.00919998f,0.80269998f,-1.15400005f,-1.18650000f,-0.76759995f,0.28529998f,0.99799997f,-0.23080002f,-0.56709997f,1.68250008f,0.40690003f,-2.28870007f,-0.54100003f,1.45580003f,1.18790002f,-0.13930000f,-0.93540004f,-0.01810005f,-0.09460002f,0.84559999f,0.37040000f,-0.11330001f,-0.07789998f,-0.09740003f,-0.40410001f,-0.52509996f,0.02099999f,-0.02549999f,0.08930000f,-0.22209997f,-0.78900000f,-1.17479996f,-1.16269996f,0.29499997f,0.31670005f,-0.16119998f,-0.05950004f,-0.01930000f,-1.06889999f,-0.62349999f,0.76650002f,-0.51760003f,0.63260003f,0.06759998f,-0.40429999f,-0.43390002f,-0.37810000f,-0.36650002f,-0.05120000f,-0.42700000f,-0.94349998f,-0.34450003f,0.67659998f,1.40570000f,2.64750003f,0.87159998f,0.68000002f,0.01620000f,-1.08479998f,-1.43379997f,-0.51019999f,0.50239999f,-0.16169998f,-0.39389998f,-0.17230000f,-0.72770000f,0.05950002f,1.33260000f,1.64890003f,0.88329999f,1.56820001f,-0.55379996f,0.45910004f,0.46749998f,-0.30969999f,-1.18089998f,-0.84300001f,-0.91299999f,0.17200000f,-0.42670003f,-0.26950001f,-0.28509999f,0.32340001f,0.74070004f,-0.65700002f,-0.27039999f,1.06780003f,0.52040002f,-0.93560002f,-0.02140003f,-1.48159997f,0.43400004f,-1.10190002f,-0.48240002f,-0.80810001f,0.03170004f,-0.10180000f,-0.43330002f,0.41570001f,0.59130001f,0.14649998f,0.72049998f,0.90320000f,0.39040000f,0.63819999f,0.33940001f,1.04810002f,-0.18870001f,-1.13220008f,-0.68869999f,-0.01889998f,-0.32780001f,0.14680000f,-0.49340002f,0.71060001f,0.82160001f,-0.59830000f,-0.70460004f,0.94850005f,0.25920000f,-0.47150002f,-0.35130001f,-0.10910000f,-0.78720004f,-1.26869998f,-0.48140004f,0.41379994f,1.43120004f,1.35700001f,0.45030000f,-0.42789999f,0.24110001f,0.17309998f,0.11159997f,-0.99430001f,0.32260002f,0.59870002f,-1.46720000f,0.23800001f,0.70699999f,-0.55590004f,0.60130000f,1.88800008f,0.14370002f,0.33340001f,1.20330001f,1.21360003f,0.88419998f,0.44640001f,1.11900006f,-0.38440003f,-0.21730003f,0.16460001f,0.06570003f,0.84229999f,0.91430001f,-0.35699999f,-0.38629996f,1.03519998f,-0.37900004f,-0.26710000f,-0.81340002f,-0.79210000f,-0.03309997f,-0.71310000f,0.08659999f,0.91659999f,1.27830001f,0.78840002f,0.17269997f,-0.40679999f,-1.01430003f,-0.37710003f,0.87450005f,-0.32920000f,-0.52980004f,-1.00360000f,-0.93529998f,-0.49939999f,0.69819996f,-0.63220003f,0.31210001f,1.29459999f,-0.49409998f,-0.40730002f,-0.70860002f,0.02490000f,0.06230000f,-0.56510001f,0.13100000f,-0.23859999f,-0.29629999f,-0.04470000f,-0.20039999f,0.00220000f,0.69429999f,-0.41770002f,-0.81480000f,0.31930002f,-0.44919999f,0.66999999f,-0.04879999f,0.02650000f,-0.00050000f,-0.74679996f,0.77470002f,-0.55910000f,-0.74019998f,-0.80740001f,-0.89690001f,-0.62650000f,-0.67009997f,-1.00200000f,0.07299999f,-0.50719999f,0.39999998f,0.29090000f,0.35340000f,0.35469998f,1.11080000f,0.05769998f,1.18490000f,-0.94540001f,-0.74409997f,-0.06750002f,0.22270003f,0.22259996f,-1.12380004f,0.20250005f,0.78620004f,-0.96380006f,-1.53290005f,0.03059999f,-0.60719998f,-0.93499996f,-0.19400002f,-2.53189994f,-1.19960000f,-1.05230001f,0.63600003f,-0.13209992f,-1.78169999f,-1.43210005f,1.16279998f,1.17280001f,1.06919999f,-0.38710000f,0.96049997f,0.37779999f,-1.08600002f,-0.87150007f,0.70089998f,0.60890004f,-0.06909993f,-0.46749999f,-1.06160003f,1.28050005f,-0.22999999f,0.39019999f,0.11599996f,-0.44369999f,0.59390004f,-0.67380001f,-0.52490000f,0.54790001f,0.31639999f,-1.22350001f,-0.58950001f,-0.34010003f,-0.31700004f,-0.29479998f,-0.22390001f,0.07999999f,-0.58870003f,-0.12959998f,-0.49520001f,0.93850001f,0.50979999f,-1.04570001f,-0.19450005f,-0.33260001f,-0.92029999f,-0.75520001f,-0.20460004f,0.65210000f,0.50160000f,-1.59120001f,-0.70069999f,0.85539999f,0.47980004f,-0.03759997f,1.16820000f,0.64980000f,-0.26990000f,0.28070000f,0.22140001f,0.05560002f,-1.31989998f,0.55839998f,0.39119993f,-1.34850002f,-1.66859999f,-0.24260001f,0.63910002f,0.44089998f,-0.21859999f,0.16289999f,0.21090007f,0.54689999f,-1.21280005f,-0.53030002f,0.26979997f,0.76840001f,0.08700002f,-0.46080000f,0.70780000f,0.23230005f,-1.43350000f,-0.79790003f,-0.27749998f,0.92120000f,-0.04120000f,0.38240001f,-1.05149999f,-0.28080002f,-0.29640007f,-0.23250001f,1.34899999f,1.45080001f,-0.20060002f,-0.98830001f,-0.14960005f,-0.37930001f,-0.44209999f,0.22079999f,0.68180001f,0.67550003f,-0.76689999f,-1.32860004f,0.93700005f,0.09559996f,-1.36570003f,-0.21429997f,1.23870000f,0.35639998f,0.35910004f,-0.49689999f,1.07530003f,-0.43880005f,-2.20810003f,-0.59199999f,1.88350008f,-0.02380000f,-1.17400003f,-0.51060005f,0.72029999f,0.58770001f,1.45820000f,0.02640004f,1.82340005f,-0.19380001f,0.13410004f,-0.97790002f,-1.43490001f,0.47320003f,-0.30749999f,-0.60040002f,-0.10190002f,-0.33210000f,-0.48239998f,-0.19780001f,-0.08509999f,0.51860003f,0.27190002f,0.12810001f,0.68599998f,-0.37560004f,-1.14970004f,-0.81809995f,-0.14650000f,-0.07639999f,-1.01690002f,0.44900002f,-0.36860004f,0.21550001f,-0.22890005f,-0.62919999f,0.60480001f,-0.35269998f,-0.59509999f,-0.48270004f,-1.60920000f,-0.07630001f,0.01540002f,0.54209998f,0.43259998f,0.03790001f,0.44430001f,0.30330000f,-1.04219998f,0.43840003f,1.52740001f,0.46410004f,1.29980000f,-0.95420000f,0.35289997f,-0.15439998f,0.20950002f,-0.37400000f,1.04859998f,0.39870001f,0.54530000f,-1.00679998f,0.43149992f,-1.45969998f,-0.18210004f,-0.67609993f,0.42149997f,-0.96259997f,-0.73700002f,-0.63839995f,0.71909998f,0.05850000f,0.12920001f,0.08710001f,2.11640000f,1.26690008f,1.11990004f,-0.80700001f,-1.79530002f,0.29209999f,0.50490002f,0.36750003f,-1.08550003f,-0.48560006f,0.12799997f,-1.10820006f,-0.32470003f,-0.46780001f,0.52969999f,1.17410005f,1.20519996f,-1.53370001f,-0.30699994f,0.86130003f,0.47050000f,-0.55769998f,0.82219999f,-0.70229996f,-0.29879997f,-0.20879994f,0.61739998f,-0.71010000f,-0.23370003f,0.53489999f,1.19480004f,-1.14630001f,-0.58290006f,-1.18909996f,0.26789999f,-0.12989999f,-0.51340000f,0.42319998f,-1.16019996f,-1.41370000f,-0.64170000f,0.90959999f,-1.66570005f,-0.38860003f,-0.10830000f,0.34089999f,0.07850002f,0.61050003f,1.65469997f,0.53700002f,-0.02729999f,0.10440000f,1.40270001f,0.14730005f,0.57100002f,-0.38230001f,-0.21940002f,0.47970000f,0.57510004f,0.00550002f,1.10699998f,-0.08250001f,-0.81110003f,-0.69879998f,1.22860003f,-1.01189999f,-0.05280000f,0.59080001f,0.50060001f,-0.20510002f,-0.03789996f,-0.14600003f,-0.22290005f,0.42320003f,-0.25500001f,-0.35370003f,-0.38169998f,0.73630004f,0.61599999f,1.23650002f,0.65600004f,-0.52200002f,-0.34639998f,-0.83590001f,0.73119997f,-1.57259995f,0.08700001f,0.95480000f,-0.01450000f,-0.50649998f,-0.43879997f,-0.40459997f,0.47459999f,-0.26899999f,0.80739999f,0.47890004f,-0.59690001f,1.21559999f,-0.70950000f,1.39319997f,0.28850000f,0.06920002f,-0.07580002f,-1.51430001f,-0.06709999f,0.95780002f,-0.40150005f,0.95509999f,-0.21790001f,0.15630001f,-1.15539999f,-1.90429999f,-1.10429999f,-1.41739993f,-0.30390000f,0.01819996f,-0.11459998f,-0.11399999f,-1.10960005f,-0.01039996f,-0.06250000f,0.19859998f,1.18709999f,1.47639995f,-0.07340003f,1.68849997f,-0.00429999f,-1.28130000f,0.52200000f,0.73370001f,-1.27829998f,-0.34630003f,-0.84560002f,0.42660003f,0.86380001f,0.24149999f,0.56800002f,-1.02670001f,0.26690000f,-0.24769999f,-0.82230000f,0.64199998f,-1.01170002f,-0.05619999f,-2.18759996f,-0.87929993f,1.01839999f,0.65890000f,1.37459999f,0.39029997f,0.74659999f,0.52419999f,-0.73709997f,-0.48549999f,-2.75269994f,-0.21720001f,-0.25140000f,0.35299999f,-0.01740000f,0.63280000f,0.12960000f,-0.71799999f,-0.18210001f,-0.28859999f,0.28039999f,-0.09270002f,-0.34890001f,0.54310001f,-0.09040000f,-0.64840001f,0.73530002f,0.27079997f,0.43720000f,-1.54229998f,0.41180001f,-1.29279999f,0.33610001f,-0.31310004f,0.16520002f,-1.24730002f,-0.42890000f,0.37660000f,1.78639996f,0.56019997f,0.29709999f,-0.83070007f,0.26759997f,1.12689995f,0.34629998f,-0.63160003f,-0.50089995f,1.18910000f,-1.09659996f,-0.52320000f,0.43259998f,0.25990001f,0.52180001f,-0.36279995f,-0.74179999f,-1.10939994f,0.78929997f,0.24440000f,0.32690000f,-1.36240001f,0.29810001f,-0.91190005f,0.43150000f,-1.04520000f,0.73680002f,-0.18489999f,-0.20859999f,-0.43260001f,-0.07270000f,-0.07800004f,-0.77790003f,0.50319994f,-0.03380001f,-1.16200008f,-1.05150003f,-1.16580000f,1.15080000f,1.03520003f,0.04260004f,-0.93330001f,-0.68199998f,-1.06590004f,-1.97650003f,-1.16359996f,1.33530000f,0.10100000f,0.20669996f,0.71720001f,-0.58810001f,0.06870000f,0.66689999f,-0.22869999f,1.03700000f,0.54809997f,-0.96369999f,-0.50660003f,-0.67500000f,0.90679999f,-0.42099999f,0.02130001f,-0.48170000f,-0.00670002f,-0.38960001f,0.23530000f,-0.66469999f,0.27660003f,-0.09219999f,-0.00409999f,-1.41499995f,-0.56169995f,-0.77089996f,0.32370000f,-0.84689997f,-0.17670001f,-1.12519997f,0.26640004f,-1.03439994f,0.14450002f,0.21600002f,-0.62800003f,-0.14069998f,0.57789997f,-0.33739997f,-0.52479998f,0.46679999f,-0.48649999f,-0.31699999f,-0.16140002f,-0.06429998f,-0.53879997f,0.21920000f,0.86470001f,-0.45990002f,0.21690001f,0.39910000f,0.27870001f,0.05090000f,0.11960001f,0.14700001f,-0.46160001f,0.56200000f,-1.34709999f,0.21600002f,-0.49050000f,-1.38980001f,-1.05190002f,0.02389997f,-0.71780007f,-0.51590001f,0.00830007f,0.69160003f,-0.68830004f,-0.31620002f,0.16500001f,0.87750004f,0.55560002f,0.54750000f,0.40260003f,1.02059998f,1.04170003f,-1.14240002f,0.60129999f,1.11629999f,-0.21030001f,-0.66870002f,-0.23449998f,1.08169999f,-0.38779999f,-0.67010004f,-0.28649999f,-0.44620000f,0.44060001f,-0.04110001f,0.38549999f,-0.10210000f,0.12500001f,0.23260000f,0.59700001f,-0.07860002f,0.10850001f,-0.49520003f,-0.50030000f,-0.16700002f,-0.58970000f,-0.59100001f,-0.62320001f,-0.14419994f,-0.14539999f,1.46010000f,0.30879999f,1.90329993f,0.77090001f,0.02910001f,-0.67889998f,-0.23219994f,-0.68299999f,-1.92140003f,0.52519996f,0.76139999f,0.49810000f,-0.04389999f,0.25349997f,1.21090000f,0.69009999f,1.43710000f,0.07989995f,1.03540000f,1.40379998f,-0.81950002f,0.67659996f,0.41000002f,0.15250001f,-1.51899998f,-0.86610000f,-0.40550000f,0.64910001f,-0.46570002f,-0.18670000f,0.36229999f,-0.41930000f,-0.13679999f,0.27749999f,0.20919998f,-0.13790001f,0.27250000f,-0.16630003f,0.43729998f,-1.51209999f,-0.95770000f,0.52820000f,0.04609998f,0.48290001f,-1.14620000f,-0.13279998f,1.28290006f,-0.37139999f,-1.85830002f,-0.04050005f,0.76649999f,0.10790000f,0.01099997f,2.10800001f,0.23859999f,0.98690000f,-1.00310001f,-0.72159998f,1.16000001f,1.24359999f,-0.05900001f,1.11049994f,1.06450003f,-0.34899999f,1.09410002f,0.23610001f,0.13790000f,-0.18969999f,-0.17829995f,0.02530001f,1.05649994f,0.12630000f,-0.02140001f,0.22810000f,-0.77830003f,-0.36139999f,-0.38039996f,-0.83750000f,-0.20670002f,-0.17930005f,-0.11489998f,-0.55310001f,0.77419998f,0.73359997f,-0.65650000f,-0.58349997f,-0.01530001f,0.69839994f,0.33430002f,-0.63510001f,-1.48760001f,-0.99810000f,-0.17599999f,-0.62689999f,0.32350000f,0.95939999f,0.30579999f,-0.46829999f,-0.23549999f,-0.49239999f,-0.95309996f,-1.28100002f,-0.20579999f,-0.19600001f,0.22160000f,0.11309999f,0.42859995f,0.36209999f,-0.62189997f,-0.27450000f,0.50300002f,-1.04209998f,0.05270001f,-0.02870000f,-0.83469997f,1.46109998f,1.64249999f,0.61169998f,-0.10130001f,-0.76300001f,-0.32070000f,-0.58539998f,-0.93390002f,-1.61609998f,-0.05270002f,0.89569999f,-0.70359999f,0.65289999f,0.10150002f,-0.25390001f,0.50450001f,-1.19080004f,0.82630000f,0.47820001f,-0.36409999f,-0.43139999f,1.07449997f,0.59010000f,0.36920002f,0.43349999f,0.11219992f,0.39559998f,-1.12310002f,-0.17370001f,0.15760000f,0.15550002f,0.32439999f,-0.25480000f,0.20810002f,-0.00949996f,-0.51519999f,-1.12719995f,-0.24929999f,-0.00689997f,0.30290000f,-1.97490001f,-0.04530001f,0.64610000f,0.86120001f,0.45680000f,1.71539999f,0.81409994f,1.91240000f,-0.40440005f,0.23510001f,-1.24990002f,0.63530000f,-1.74630003f,-0.96670000f,-0.30170000f,-0.16879999f,0.44760001f,-0.95380005f,0.07340002f,-2.00270000f,-0.80269999f,-2.04129999f,-0.70920001f,-0.91630000f,-0.90020001f,-0.29820000f,-0.20770001f,-0.64010000f,-0.01390000f,0.65430003f,-0.21800001f,-0.26600003f,-1.52230002f,-1.06010000f,0.11919999f,0.21259999f,-0.85919998f,-0.33830002f,0.32150004f,-0.58379997f,0.36189998f,0.35610003f,0.27800001f,0.34309998f,-0.09130003f,-0.91049998f,0.01100003f,0.38770000f,0.32460004f,0.92549997f,1.10109998f,0.11430003f,-0.19460000f,0.05059999f,-0.52290001f,-0.24090000f,-0.90170000f,-0.21629994f,-0.43209999f,0.49589999f,0.15340001f,-0.44780001f,-0.01159998f,-0.83489996f,0.84960003f,0.89210001f,-1.09510000f,0.33010000f,-0.91889999f,-0.27090001f,-0.79729999f,0.89020000f,-0.27959998f,-0.29469999f,-1.08309998f,-0.56779998f,1.06549996f,0.71439999f,0.71569998f,0.91020002f,0.40320006f,0.22319998f,-0.02379996f,-1.01469998f,-0.02159999f,-1.15729997f,-1.76110001f,1.17829995f,0.37130001f,-0.33520004f,0.07240003f,0.24609998f,-1.43560002f,0.88280002f,-0.29079998f,-0.53680001f,-0.55370000f,0.00449999f,-0.05820000f,-0.23859999f,0.61789998f,-0.96270003f,-1.46910000f,-0.75560002f,-1.33260005f,0.62039996f,0.67679998f,-0.40669999f,0.03200000f,0.22179998f,1.46540001f,0.38820002f,0.21150001f,0.14849998f,0.77850000f,0.95769999f,-0.04660001f,-0.39810000f,0.51610004f,-0.42659998f,-1.02759999f,-0.76679999f,-0.91710000f,0.37960001f,-0.37210001f,0.84400003f,-1.67990001f,0.03090002f,-1.05120001f,0.33400001f,0.35540001f,-0.02340003f,-0.68330001f,0.94430001f,-0.46519996f,-0.56220001f,-0.96570000f,0.72500002f,0.19549998f,-0.25369996f,-0.18620001f,0.15390001f,0.81690005f,0.33139998f,-0.94310006f,0.39199995f,-0.19490005f,-0.48710000f,0.85070000f,0.24579999f,-0.62459999f,0.35869998f,-0.71159999f,-0.87780000f,0.38059999f,1.23059999f,-0.41560001f,0.13559999f,0.94250007f,0.47430001f,-0.67229998f,-0.60340004f,-1.08790001f,0.21100003f,0.45300000f,0.04469999f,0.51960001f,0.04440001f,-0.21480002f,-0.07730001f,0.19140000f,0.03640001f,-1.34510001f,-2.51830000f,-0.95750000f,0.21820000f,0.98540000f,0.18929997f,0.16990000f,0.76209998f,0.01599995f,-0.81280000f,-0.58359997f,0.00130000f,0.56710001f,-0.34829997f,-0.39870003f,0.02790001f,-0.04909998f,-0.40669998f,0.38460000f,0.71179999f,-0.46439998f,-0.29300000f,0.72009998f,-0.30169999f,0.75610002f,0.60520000f,-0.04660000f,0.27189999f,-0.55199998f,-0.42370001f,0.85520000f,-0.35630002f,1.21130003f,0.21430001f,0.03130001f,0.50960001f,-0.12719995f,1.36499998f,0.25690000f,0.79099999f,1.34010001f,0.78819998f,0.26549996f,-0.79580005f,-0.85360000f,0.01520000f,-0.84490001f,0.98919998f,0.64659999f,0.51939995f,0.11500000f,-1.21239996f,-0.84590000f,0.57190001f,-0.35779999f,-0.01560001f,1.31770001f,0.28660000f,0.78830002f,-0.56160001f,0.36180000f,-0.16520001f,0.32080003f,-0.58510003f,0.29200002f,-0.70550002f,0.62099999f,-0.66090003f,0.63640003f,-0.04959999f,-0.18720000f,-0.80130002f,0.03239998f,-0.50710000f,-1.81500004f,-2.43830002f,-2.60900001f,-1.79380000f,-0.75199999f,-1.94160003f,-1.40159999f,-0.05629998f,0.85020001f,-1.33569998f,0.43230000f,1.21519998f,1.17120000f,0.58699998f,1.71629999f,-0.15449997f,0.64019997f,0.09330000f,0.95580002f,-0.18350000f,-0.69210000f,-0.23199999f,-0.58069999f,-0.30990001f,-0.83830003f,0.03130001f,-0.78889999f,0.28330002f,-0.79930001f,0.33110001f,0.18439996f,0.10610001f,-0.48580000f,-0.48200003f,-0.21669999f,-0.82069999f,-0.52990005f,-1.46710001f,-1.21340002f,-0.49129997f,0.55379999f,0.42089999f,-0.61100003f,-0.33229997f,-0.95850000f,-1.79789998f,-0.00920000f,0.52770003f,-0.71280000f,0.80639997f,0.31210005f,-0.41149998f,-0.41059998f,0.89469997f,0.64679999f,0.65379997f,0.36990000f,-0.82729997f,0.68620002f,-1.09330004f,0.65800003f,-0.50830000f,0.50480000f,-0.37400001f,0.89700000f,-0.58450001f,0.64979998f,-0.04720001f,0.84660002f,0.06159998f,0.48429999f,-0.59240007f,0.01369998f,-0.99339995f,-0.40590003f,0.89999997f,0.20209998f,0.03000001f,0.50050000f,-0.12510000f,0.13540001f,0.17680001f,-0.19430000f,0.00450001f,-0.34120001f,0.59190002f,0.24549999f,0.67970003f,-1.09260001f,-1.79160002f,0.13849999f,1.12030001f,0.76840001f,0.14460000f,-0.89449999f,-0.31520001f,-0.78640001f,-0.51110001f,-0.09670000f,0.40229996f,0.18799998f,-0.96770002f,-0.15710000f,-0.83709998f,0.18100008f,0.53060000f,-0.12420000f,-0.10209998f,-0.14620001f,0.49750001f,-0.22960001f,0.28370000f,-0.29689999f,-0.22059991f,-0.41889999f,0.97480001f,0.39520002f,-0.16460002f,0.61419996f,-0.35690001f,-1.25180000f,-0.34370001f,0.73490000f,-0.12130001f,0.66489999f,0.21270000f,0.75809997f,0.81029998f,1.47459992f,0.82220001f,0.01420002f,-0.28130000f,-1.43880000f,-0.14140001f,0.09849999f,-0.00949997f,-0.27790000f,-1.06099998f,0.70510002f,-0.86389995f,0.74759999f,0.58040001f,-0.17830001f,-0.72619999f,-0.29740001f,-0.15910002f,0.75410000f,0.17349999f,0.31229999f,1.84359995f,0.80269999f,1.21159995f,0.32919998f,0.75359999f,-0.76810002f,-0.96170001f,0.15990002f,0.87940003f,-0.64579998f,-0.14790001f,-1.00000004f,-1.48500000f,0.62860005f,-0.03830001f,0.21679997f,-0.22690001f,-0.57450002f,-0.99510002f,-0.85829997f,0.70199999f,-0.59919999f,0.27780000f,0.99060000f,-0.58830001f,1.24160003f,0.56060003f,0.29619997f,-1.58089999f,-0.37100000f,-0.85299993f,-0.03670000f,-0.04889999f,-0.33420000f,0.86540000f,-0.40299999f,0.21540001f,0.49310002f,0.12220000f,-0.28420002f,1.17730005f,2.13750001f,1.16730003f,-0.32709999f,-0.12470002f,-0.28109994f,-0.44839996f,-1.51089998f,-1.80650003f,0.93709999f,0.78500000f,1.17949996f,0.28040001f,0.95309996f,1.24940002f,-0.16490002f,1.43160000f,0.03169999f,0.77150001f,0.25510001f,-1.51290000f,0.54889998f,-1.49630002f,-0.05069998f,-0.61530000f,0.91450001f,-0.26090005f,0.54500002f,-1.17670000f,-0.58309999f,-0.10299998f,-0.60829997f,0.44930002f,-0.04720002f,1.32010001f,0.72510001f,1.14580001f,-0.21849999f,-1.48780000f,0.31250005f,0.69110001f,0.47610004f,-0.41610000f,-0.09719998f,0.46120000f,0.20570002f,-0.97250001f,0.49570001f,-0.03039996f,0.81349995f,0.00199996f,0.03009999f,0.82570001f,-0.34589999f,0.02179998f,-0.83780000f,1.30229998f,0.66309997f,0.04269999f,0.35729998f,-0.64470000f,0.20470000f,-0.97789995f,0.20320003f,-0.71450000f,0.19870001f,-0.64659999f,0.44240000f,0.00329995f,0.63930000f,0.03500002f,-0.07020000f,1.69429998f,-0.63210005f,-1.07550004f,-0.56319996f,-0.44350000f,-0.12590004f,0.35750002f,0.19840000f,-1.18620003f,0.22139998f,0.52219999f,0.66269999f,-0.20769999f,0.37070003f,0.59109998f,-0.10739999f,-0.69110000f,0.59270001f,-0.00430000f,1.15900003f,-0.83310001f,-0.10340002f,-0.16910000f,0.09730001f,-0.68250000f,0.04300000f,-0.81589997f,-0.70150001f,1.00250003f,-0.03660000f,0.86050000f,-0.01289999f,-0.10839999f,0.16639999f,0.51190000f,0.29090000f,1.13770003f,-1.41350000f,-1.46750000f,0.13730004f,0.07860003f,0.20000002f,-1.05930000f,0.04950000f,0.48990002f,-0.16940004f,0.36900000f,-0.06410002f,0.87300000f,-0.78189997f,1.13480001f,0.61779999f,-1.44049998f,0.70839999f,-0.30939999f,-1.67000001f,-0.18230001f,0.49640001f,-0.20269998f,-0.19770002f,0.30889997f,0.55579999f,-0.16310001f,0.31790001f,-0.21930001f,-0.60940002f,0.09090001f,-0.16450001f,0.30710002f,-0.91669998f,0.04200003f,-0.00690004f,0.15970001f,0.45890001f,-0.25240001f,0.22540003f,-0.08039998f,0.64220003f,-0.23769998f,-0.91660001f,-0.69109996f,0.77890007f,1.29290006f,1.23140000f,0.33079999f,-0.07570001f,-0.43950000f,0.03399999f,-0.25390000f,-1.19300002f,1.36509996f,0.27839999f,-1.36539999f,-0.35889999f,0.20560001f,-1.16400002f,0.76869999f,-0.39960002f,-0.02580000f,1.08170000f,0.29090001f,0.99740001f,-0.27060002f,0.17060002f,0.57490000f,-0.33679999f,-0.02379999f,-0.92389998f,0.14720001f,0.63379994f,-0.57280003f,-0.38439999f,1.17979998f,0.47580000f,0.22079997f,0.66970001f,2.05919997f,1.77029998f,1.10249999f,1.61879994f,-0.03220002f,-1.35149997f,0.07089999f,1.22950000f,-0.16419999f,0.71990000f,-1.37419996f,-0.40479999f,-0.54839998f,-1.12609997f,-0.50879997f,-2.05139993f,1.33279997f,0.30770001f,0.20960002f,0.71339996f,-0.61600002f,0.08980000f,0.42610002f,-1.33069999f,1.01940003f,-0.34380002f,-0.38630003f,-0.91389999f,0.48040003f,-1.19400001f,0.00030001f,0.63220005f,-0.84129998f,-0.67449998f,-0.33210000f,-0.68470005f,1.13070001f,0.52259999f,-0.82780004f,-0.21450002f,1.02830001f,-0.11579999f,-0.40550001f,0.61829995f,-0.06709997f,-0.14490002f,0.85939998f,-0.27529994f,0.25019998f,0.47819999f,-0.80229999f,-0.77099998f,-0.56069997f,0.01390005f,-0.27660001f,1.48380003f,-0.60190002f,-0.30840000f,0.16510000f,-0.62849998f,0.63930000f,-1.30540000f,0.20390003f,0.22470001f,0.34250001f,1.32620004f,0.54640000f,-1.07670004f,-1.78669999f,-1.60239999f,-1.14229998f,-1.45550003f,0.29369996f,1.64960003f,1.97400005f,2.18760004f,1.61600001f,-0.80080000f,0.98289999f,1.22090001f,0.06149998f,0.46399999f,0.78320001f,0.71610002f,-1.42660002f,-1.03229999f,-0.59429999f,-1.37319999f,-0.39140001f,0.08340001f,0.35230001f,0.52070002f,-0.58380002f,0.83419999f,0.04090000f,1.49550000f,-0.04050001f,0.69510001f,0.00229999f,-0.79459997f,0.85700001f,-1.35790002f,-0.03249996f,-0.14899994f,-0.19739999f,-0.48709998f,0.42749997f,0.00050003f,0.63569998f,-0.86780001f,-0.41670001f,0.29770004f,2.10389998f,0.33750001f,-0.35370002f,1.19959997f,-0.07279999f,0.34339995f,-0.33939999f,1.31629996f,0.50859999f,0.85130000f,-1.22780000f,-0.45429999f,0.22009999f,0.22339995f,-0.19510000f,-0.72390002f,0.49930001f,-0.97420001f,0.27750002f,-1.07850003f,0.48090001f,0.12200001f,-0.15990000f,-0.04690000f,0.37330001f,-0.59090008f,-1.71720001f,-0.93799997f,0.43680000f,0.66339999f,0.38810003f,0.06359997f,0.41399997f,0.73330001f,0.56690002f,0.68220002f,0.76580001f,0.60240001f,-0.55220000f,0.32349999f,-0.13910001f,-0.70759998f,0.68630001f,-0.85060000f,-0.57020001f,0.32950002f,-0.47679999f,-0.75150000f,-0.52470000f,-0.02190002f,1.04030004f,-0.99400002f,0.05919999f,-1.30080001f,0.03259999f,-0.90420000f,-0.03179999f,-0.06449998f,-0.22420000f,-0.26209999f,-0.22279999f,0.77500000f,0.99100003f,0.28830001f,1.27779996f,1.21530000f,0.56979997f,0.25069998f,1.21889996f,0.31910000f,-0.08769997f,-0.16420000f,-0.57650005f,0.08760000f,0.25100003f,-0.44290002f,0.62959999f,0.37300002f,-1.06800002f,-0.32869997f,0.58170002f,0.15980002f,-0.35760002f,-0.64320001f,-0.00729999f,-1.54380004f,0.07300002f,-0.74450002f,1.26919999f,1.07279999f,0.79389998f,-0.00130003f,0.78470001f,0.49820000f,0.25040002f,-0.98420001f,0.20390001f,0.03990000f,0.04859998f,0.43450000f,-0.00580005f,0.47830000f,-0.88869998f,-0.21650000f,-0.29030003f,-0.03199999f,-1.15819998f,-0.83430000f,0.28170000f,0.52500003f,0.13710000f,0.21909998f,-0.63640001f,-0.73229995f,-0.36540000f,-0.03889999f,-0.21960003f,1.16189997f,1.23240001f,0.15890003f,0.76730005f,1.62020000f,-0.00199998f,0.55489998f,0.83549998f,-0.98310003f,0.42929999f,-0.22870002f,-1.09919999f,-0.19489997f,-0.10509999f,-0.39709995f,-0.04209996f,-0.06139999f,-0.24280004f,0.02450000f,-1.60699999f,-0.20810000f,-0.39439999f,-0.00940000f,0.32510002f,0.58380000f,0.71019999f,-0.01710000f,0.82189997f,-0.12030005f,-0.15860000f,0.07239999f,-0.16990000f,0.15790002f,-1.17720003f,0.24570005f,0.06290001f,0.61160002f,0.52940000f,0.20610002f,-1.22799999f,0.05569999f,-0.22520001f,0.86040001f,0.66119999f,0.80609999f,0.56889999f,-0.11990003f,0.35700000f,0.68160003f,0.98020002f,0.93070002f,-0.79260001f,0.19489999f,0.75000000f,0.16620000f,-0.24020003f,0.44310002f,-0.89230000f,0.22460000f,0.52320001f,0.80810002f,0.34249999f,-0.19530000f,0.61290001f,1.46469999f,1.16819999f,0.47399999f,0.47850005f,-1.87420000f,-0.80480006f,0.56489997f,0.69570003f,0.00090001f,1.85709998f,1.16319999f,0.44029998f,1.73070002f,-0.51719999f,-0.33979998f,0.13600004f,-1.74159998f,-2.05990003f,-1.18230001f,0.01020001f,-1.03429997f,0.79060005f,-0.36559998f,0.54459998f,0.30079999f,-0.07770001f,-0.33780000f,-0.84479997f,-1.27320001f,-0.42309998f,0.14099999f,0.05200000f,0.77460001f,-0.85680004f,-0.10270002f,-1.69639996f,-0.73640001f,0.36170000f,0.84329997f,-0.03379998f,0.48559999f,-0.72630000f,0.69039999f,0.47200001f,0.01249999f,0.20829999f,0.04049998f,-1.24530003f,-1.09820003f,-0.81720003f,1.53850001f,0.13290000f,1.55779997f,-0.25870000f,0.56099998f,0.04310001f,0.29250000f,0.37850001f,0.42870000f,0.90219996f,-0.33630003f,2.15369997f,0.76770001f,1.07409996f,0.48980000f,0.13730001f,0.15230000f,0.57959998f,0.03350000f,-0.27280002f,0.28690001f,-1.11169998f,0.73870000f,-0.35889997f,-1.17499999f,0.24259998f,0.02509998f,0.64200000f,0.44310000f,0.28110002f,-1.26340000f,-0.82819998f,0.50660001f,1.64489998f,-0.50190002f,-0.25910001f,-2.02579999f,0.50709999f,0.17229999f,-0.23630000f,0.07710001f,0.03679997f,-0.68560003f,-0.20110000f,-0.87560003f,0.75079998f,-0.15220002f,-1.19139995f,-0.15530001f,0.22499999f,0.13129998f,0.10370000f,-0.51460001f,-0.41520001f,-0.14960000f,-1.26139996f,-0.35770002f,-0.40170002f,0.03580001f,-1.87450000f,-0.11250001f,0.35719998f,0.90249999f,-0.52790001f,0.62610000f,-0.19430001f,-0.05899998f,1.39080000f,-0.56210000f,-0.33009999f,-0.79589999f,-1.18089999f,-1.35460000f,0.32979998f,-0.08820003f,-0.71339998f,-0.41219998f,0.67649998f,-0.75569997f,-0.77039996f,-0.70099999f,0.81889999f,1.30990005f,0.00039998f,1.26690003f,-0.00330000f,0.24399998f,-0.04710001f,0.00630002f,-0.20600000f,-0.06670001f,-0.53210001f,-0.08979998f,0.25750001f,0.62190004f,0.63859996f,0.01879999f,0.51979998f,-0.96310004f,-0.99970002f,-0.96599997f,-0.23329999f,-0.77630003f,-1.83590000f,-0.74690000f,-0.20500001f,0.21110000f,-0.08689999f,0.88330001f,1.00029998f,0.51639999f,-0.37300001f,0.96189999f,0.77540000f,0.08719999f,-0.37479998f,0.25610003f,0.78339999f,-1.63039999f,0.22870001f,-0.03699999f,-0.28130002f,1.21890001f,-0.18020001f,0.20310002f,0.18610003f,0.43390000f,-0.50930001f,-0.13750001f,0.06739999f,-0.41840001f,0.24450000f,-0.26530006f,-1.09800003f,-1.29249997f,-0.42600000f,-0.31559997f,1.23700002f,1.61040002f,0.10730003f,0.54530003f,-0.18200003f,-1.02509999f,1.06189998f,0.19440003f,0.04249998f,1.81979997f,-0.54239999f,0.38179999f,-0.93619998f,-0.51149999f,-0.45199999f,-1.15910003f,0.91450001f,-0.13759999f,0.46680001f,-0.61700001f,0.35190002f,0.43960002f,0.00799998f,0.56650003f,0.26020002f,0.45590000f,-0.31180001f,-1.05830003f,0.80630001f,0.51429999f,0.64350000f,0.25059999f,0.60850002f,-0.68470003f,-0.31170004f,-0.41129996f,1.27490003f,0.22640001f,-0.55800000f,-0.66730002f,0.61029998f,-0.81089998f,0.37869998f,-0.31730000f,0.92789999f,0.98840002f,-0.81930003f,1.09769999f,-0.06949999f,0.29809999f,0.13010000f,-0.77450001f,-0.16890000f,-1.67500002f,-0.45219998f,-0.22760002f,-0.72210003f,0.00909999f,0.35440003f,0.85650001f,-0.16800001f,1.89280001f,-1.15640001f,0.41849996f,-0.85350000f,0.91779998f,-0.23449995f,0.46649999f,-2.28150000f,-1.08750002f,0.75250000f,1.79830005f,1.16200000f,0.39900003f,-0.60539999f,-0.30880004f,-2.24399997f,-1.77159998f,0.37450001f,-1.13949999f,0.21420003f,0.18889999f,-0.69670002f,0.02910001f,-0.31129998f,0.85989997f,0.17600003f,-0.84020002f,0.36250000f,0.16130002f,0.74530003f,-0.97119998f,0.57710000f,-0.76239999f,0.23570000f,-0.52149999f,-0.02690000f,-0.36349999f,0.21860002f,0.53359998f,0.17600001f,0.08490004f,2.14950003f,1.49160000f,1.14809998f,0.20239996f,0.24550000f,0.51340001f,0.21910001f,0.12269999f,0.49939999f,-0.53280006f,-0.18009999f,0.46199999f,0.07890000f,-1.40899996f,0.52189997f,-0.40519998f,-0.58689999f,-0.34880000f,0.09880001f,-0.53709998f,1.06999998f,0.76640002f,-0.22630001f,0.41209998f,-0.19050001f,1.85189999f,-0.15310000f,-0.03190001f,-0.43620000f,-1.00770002f,0.16290000f,0.96890000f,-0.43340002f,0.19100001f,-0.52789999f,-0.24610000f,-0.54270001f,-0.35609996f,0.02099997f,-0.21950000f,-0.70989997f,0.30210001f,-0.07790001f,-0.79370000f,-1.11070000f,0.18060005f,-0.12949999f,-0.64240003f,-0.18869997f,1.70859995f,-0.20449999f,-0.06420000f,-0.14709999f,-1.43510001f,1.27759995f,1.25969999f,-1.20039996f,0.08279996f,1.24499997f,-0.91630000f,0.75800000f,-1.07260001f,0.76330003f,-1.38030004f,0.13330001f,-0.35780003f,-0.45350000f,0.14229998f,-0.19379998f,0.64209996f,-0.82000003f,0.27440000f,0.25180005f,0.03520000f,1.24760001f,0.88740001f,0.53300000f,-0.20430001f,1.08030004f,-0.17379999f,1.22779998f,0.39669999f,-0.07230001f,-0.55969996f,0.18899998f,-0.62599999f,-0.35309999f,-1.10759997f,-0.39179996f,-0.59450000f,-1.05650000f,-0.10870000f,-0.41629998f,0.71939999f,0.27359998f,-0.72890000f,0.27519999f,-1.12700002f,0.86709998f,-0.59180005f,1.30339998f,1.26029995f,-0.05280005f,1.51429996f,-0.56039998f,0.49559997f,-0.20149998f,-0.77160000f,-1.24520002f,-0.39910000f,-0.84340001f,-0.12000000f,0.24020000f,-0.33330001f,0.65150001f,-0.33559999f,-0.09960003f,0.18860000f,-1.28720001f,-0.21289998f,-0.79329999f,0.41879999f,-0.14400003f,0.77820001f,-0.03379996f,-0.70669999f,-1.31599998f,0.97669996f,-0.64909998f,0.39639994f,0.64049999f,0.14010001f,0.02980001f,0.80580000f,0.46489999f,0.75499998f,1.05119998f,1.27449997f,-0.74520000f,1.68849994f,-1.23989999f,0.78119997f,-0.74139998f,0.21660000f,0.25659999f,0.58739999f,0.19869997f,0.48269999f,0.92139996f,0.04130000f,0.93799997f,0.02599998f,1.65309997f,0.45879999f,1.43169994f,0.40439997f,1.12809996f,0.81279997f,-0.01799999f,0.07120000f,-0.11280003f,0.42259998f,1.21580001f,0.35650001f,0.26630001f,-0.10170001f,-0.31510002f,-0.23739999f,-0.97750000f,0.31540004f,-0.41760000f,-0.54660001f,-0.25270001f,-0.24100001f,-0.40060000f,0.43430007f,-0.90259995f,-0.71889995f,-0.31400000f,-0.13610002f,1.22479997f,0.42759999f,-0.12400001f,0.37510000f,0.32010002f,0.15429999f,1.12490003f,-0.10189997f,-0.22419998f,-0.41139999f,-0.20870000f,0.56060001f,-0.62880000f,-0.90060001f,1.06179998f,0.60609995f,0.20689999f,0.23770001f,-0.23290002f,-0.44979999f,0.33510002f,-0.04669999f,-0.13200000f,-0.52359998f,-1.11299997f,-1.66399998f,-0.25359999f,0.52309999f,0.10280000f,-0.70650001f,-0.16430002f,-1.42199998f,-0.50909999f,0.72850006f,-0.52909997f,-0.23990000f,-0.24369998f,-0.31980002f,0.88969994f,0.45409998f,-0.97880000f,0.02889999f,-0.57509994f,-0.31389999f,1.59020001f,0.42860003f,1.17520000f,-0.64880000f,0.17730002f,0.32490002f,0.85279999f,-0.03740001f,-0.32620002f,-0.06999998f,-0.66230001f,-0.40969999f,0.72029999f,-0.41189997f,-1.41809998f,-1.73440000f,-0.06290000f,-0.28509999f,1.76560002f,0.50079995f,0.15560001f,-0.34580000f,-0.09430001f,-1.01770001f,1.52989997f,0.99029999f,-1.05100000f,-0.28400001f,0.01049997f,0.86950000f,-0.34370006f,-0.05700001f,-1.02720000f,-0.36210001f,-0.77199998f,0.20759999f,0.45859997f,0.00050002f,0.32460003f,-0.22159999f,0.70319998f,-0.26339999f,-0.22059996f,-1.11509999f,1.34939998f,0.61189999f,-0.05629999f,-0.86760000f,-0.30850002f,-0.34489999f,-0.19539997f,-1.03239997f,-0.40560000f,-1.72520001f,-0.54889997f,-2.16710000f,0.27790000f,-0.30010002f,-0.04319999f,-1.65820000f,-0.34960003f,0.05290001f,0.17539997f,-0.24759999f,-1.30320000f,-0.64709999f,-0.89159997f,-0.22190001f,-0.29210005f,0.10159999f,-1.03189997f,-0.51350000f,0.67490001f,0.33180001f,0.95490000f,-0.77100000f,0.67780001f,0.45909994f,1.16180000f,-1.13220001f,-1.65960001f,-0.45179995f,-0.30240004f,1.34939998f,0.92990004f,0.20319998f,-0.30430001f,1.22919998f,-0.51950001f,0.65379998f,-0.42740000f,-1.25500001f,-0.21910000f,-0.98180000f,-0.38490000f,-1.01469999f,-0.09430000f,-1.11989997f,-0.35180001f,0.13029998f,-0.41750000f,0.93760001f,-0.06600003f,0.91290002f,0.10379997f,-1.27430000f,0.62840002f,-1.85879997f,0.36090000f,-0.12929997f,-0.69610002f,-1.36949998f,-0.98530000f,-0.80410000f,-0.68750005f,-1.30959999f,-0.88210003f,-1.39440002f,-0.28659997f,-0.17250000f,0.56430000f,0.52989997f,-0.54740000f,0.81119995f,0.39880000f,0.93590001f,0.40259996f,1.62619998f,0.44779999f,0.09059998f,0.25309998f,-0.58909997f,0.23379999f,-0.10569997f,-0.75329999f,0.31679999f,0.57950000f,0.13230000f,0.07500000f,-0.05820000f,0.31559998f,-0.93169998f,0.73209999f,-1.96669995f,0.79199999f,-0.86569995f,0.40990001f,-0.57629999f,0.98569996f,0.18829997f,0.57679997f,0.07390000f,0.02399997f,-0.98760002f,0.45349997f,0.99769997f,1.48119996f,1.61289998f,1.92919999f,0.35509998f,-0.00739999f,0.56490000f,-0.30810000f,-0.03350000f,0.59009998f,0.09550001f,-0.57889999f,-1.27519995f,-0.69609999f,-0.98909994f,0.08229999f,-0.53740000f,0.12220003f,-0.18030004f,0.12690000f,0.98660001f,-0.15420000f,-0.07179998f,-0.17359997f,-0.94350002f,-0.12359999f,-0.02160001f,0.19020000f,0.67490000f,1.45970001f,1.41679999f,0.70799999f,0.44050001f,0.16660000f,0.70450004f,0.36190011f,0.69590002f,-0.32459997f,0.52199997f,0.23549997f,-0.61970000f,0.17740000f,-1.36959999f,-0.06590000f,0.55840000f,-1.09990000f,-0.53969999f,0.18540001f,-1.68700000f,0.12630003f,-0.48649998f,0.01809998f,0.23329999f,0.00879999f,0.66040001f,0.07540001f,-0.00150000f,-0.31930000f,0.96699999f,-0.47850000f,0.56290002f,0.51210002f,-0.49420000f,0.31470000f,-0.43550001f,-0.38600004f,0.67530001f,1.20009997f,0.64689995f,-0.22120000f,-0.19509999f,-0.88059997f,0.11380008f,1.33970004f,0.79950000f,0.46189998f,-0.71350002f,-0.89599997f,0.37260001f,0.49039999f,-0.76259996f,0.10000000f,0.59809998f,-1.14299998f,0.21009999f,0.16220000f,-0.70329999f,-0.32130001f,1.19320000f,0.21820000f,1.53840000f,-0.60020003f,-0.07399998f,-0.18130000f,0.17159998f,0.05990000f,1.33940000f,-0.19240000f,-0.56799999f,0.38979999f,0.01930004f,1.43369998f,0.37090000f,-0.75880004f,-1.47290006f,-0.86150002f,-0.53110001f,0.04939997f,-0.09989997f,-0.30999998f,-1.31080000f,-0.31159999f,0.92459999f,0.09490001f,0.98629997f,0.43080001f,0.19920003f,0.19679999f,0.47529999f,-0.37450000f,1.37179998f,0.69219998f,0.00840001f,-1.11240000f,0.60659999f,-0.75430000f,0.84520002f,-0.26810003f,1.61910001f,-0.58320000f,0.54290000f,-0.51140001f,0.86610002f,0.43000001f,0.19980000f,0.59810001f,-0.18799998f,-1.19419995f,-0.09509997f,-0.53720003f,0.03970002f,0.08990001f,-0.00470001f,-1.20019999f,-0.40389997f,0.79970000f,0.39270004f,1.47470002f,-0.42840003f,0.06010001f,0.05720001f,-0.53469998f,1.19899997f,0.34830000f,-0.41230000f,-0.43799998f,0.69060000f,-0.11080004f,0.27339999f,0.24589998f,0.22150003f,-0.03960000f,0.38070004f,-0.40230000f,1.01579999f,0.37430000f,0.12359998f,0.17260001f,-0.66019998f,0.23580001f,-0.08690000f,0.14190000f,-0.25500001f,-0.22339995f,-0.12329998f,0.54899998f,0.37320001f,0.22730001f,-0.27920000f,0.37029996f,0.13020000f,-0.86129993f,-0.58980000f,1.32379998f,-1.42509999f,-0.78969997f,-0.42719999f,-1.59500003f,0.92390001f,1.23320005f,-0.46339996f,-0.92500003f,0.05319999f,0.72420003f,-0.97880000f,-0.53770003f,-0.24930001f,0.83789999f,1.86159995f,-0.62740003f,0.55749998f,1.37880001f,-0.02999998f,-0.35450001f,-0.70580004f,0.89510001f,-0.30280001f,-1.35060000f,-0.11489998f,0.45429998f,-0.22299998f,-0.45619996f,0.21810001f,-0.30860001f,-0.15609999f,-1.08790000f,-0.17300002f,0.03209998f,-0.53150000f,-0.26730003f,1.27660001f,-0.22920001f,0.10930002f,0.11770000f,-1.08100001f,-1.11770001f,0.08960004f,0.25379999f,0.92580001f,0.48900003f,-1.47049999f,-1.58960005f,2.06180004f,-0.02699999f,-0.19869998f,0.73210000f,0.28820003f,0.31189999f,1.34440003f,-0.11910001f,0.32660000f,1.16580001f,-1.30110001f,-0.70370002f,0.52860002f,-0.43909998f,-0.22779999f,0.24140001f,-0.07509998f,0.30720003f,-0.10129999f,-0.43150001f,0.04590000f,-1.36099999f,-0.63600000f,-0.09899994f,-0.53869997f,-0.48270000f,-1.09829998f,0.84070001f,-0.41239994f,-1.37549998f,-0.63809999f,-0.33910001f,0.97089998f,1.46380003f,0.44129998f,-0.40650000f,-1.46830005f,0.41539999f,-1.82290005f,2.04299999f,0.04419995f,0.27000001f,-0.59430004f,-1.52030002f,0.04750001f,-0.22530000f,0.20730002f,-0.95750000f,-0.61650001f,-1.74570001f,-0.08439999f,-1.10710006f,-0.08369998f,-1.00639996f,-0.60970000f,0.96510003f,0.42979999f,0.98419999f,0.26570000f,-0.13179999f,0.48729996f,-0.33780003f,-1.73759999f,-2.14289998f,0.10350001f,0.64150003f,0.73220000f,-1.03039997f,0.30579997f,1.21849996f,0.83519996f,-0.09410000f,0.79150000f,0.71009994f,-0.10380004f,-0.74150004f,0.69769999f,-0.07710002f,1.75540001f,-0.36980000f,0.61359996f,-0.02569999f,0.39899999f,-0.38730000f,-0.13550003f,-0.44430000f,-0.65420000f,0.33590008f,-0.14139999f,1.62969997f,0.63180000f,0.40480001f,0.05489999f,0.18889997f,0.00810000f,-1.55899994f,0.86120004f,0.16380002f,0.16829999f,-0.56600004f,0.60079998f,1.62070002f,-0.27669997f,-0.59339998f,-0.68699998f,-0.69910000f,0.42230001f,0.21170003f,1.47060002f,0.46870001f,0.20809999f,-1.77589997f,-0.72699997f,0.93070001f,0.04610002f,0.81589998f,0.31379997f,-0.46510001f,-0.09910002f,0.13619999f,0.55750000f,-0.08029999f,-0.39749999f,0.21810001f,0.32360000f,0.34479996f,0.25540002f,-0.54519999f,-0.36479999f,-0.35879998f,-0.29870001f,0.91110000f,-0.76169998f,-0.42969999f,1.03320000f,-0.24609997f,1.01120001f,-0.09260001f,0.70519998f,0.65090000f,-0.04179999f,-0.46179998f,-0.77630003f,-0.36360001f,-0.05070000f,-0.53170001f,1.97140001f,-0.17249999f,1.45460001f,-0.03550000f,0.73559998f,0.78579999f,0.12759998f,-0.53170002f,0.05689999f,0.56690001f,-0.08739998f,1.81350000f,0.82970002f,1.09430000f,0.59030000f,0.41809997f,0.65169999f,-0.09820001f,-0.62540002f,0.23840001f,0.05230001f,-0.29250000f,0.13300003f,-0.74270005f,1.59830001f,-0.04510001f,1.38340003f,0.76770002f,0.05439998f,-0.58860002f,-0.05869999f,0.62730004f,0.85280000f,0.29460000f,-0.24660001f,0.14119999f,1.30400001f,0.80219997f,0.08379996f,-0.67709999f,-0.25849997f,1.16939996f,-0.69659998f,-1.35189999f,0.53539995f,0.24499999f,0.32110003f,0.60939999f,-1.56389998f,0.55160002f,-0.24589999f,-0.60730002f,0.29119997f,0.00450000f,0.54360001f,-0.52020003f,-0.34419998f,0.30840001f,-1.07339999f,-0.33550001f,-1.12550004f,0.34260001f,0.64040003f,-0.67379998f,-1.35150002f,-0.52800004f,0.02640001f,-1.15210000f,-1.04530002f,0.62909998f,0.49970001f,0.98519996f,0.11560003f,-0.55330002f,0.25850000f,0.79110002f,0.28319995f,-0.39540000f,0.73450000f,0.19780002f,-0.12999999f,-0.25420002f,-1.24050004f,-0.15350000f,-0.11310001f,0.18350002f,0.00369999f,0.49790001f,-1.29990004f,-0.10799999f,-0.06040002f,-0.68510002f,0.99870000f,0.32680001f,0.49269996f,-0.52289998f,-0.05999999f,-0.15720000f,-1.04990004f,-0.20870000f,-0.34190000f,0.10940002f,0.20550000f,-1.69900001f,-1.82830002f,-0.43100003f,-1.11699999f,-0.23609999f,-0.05380001f,0.86199999f,0.73850002f,-0.00070002f,-0.11860002f,0.31070000f,-0.36130002f,0.64240002f,1.38449999f,-1.21100002f,1.14830003f,-0.26720002f,2.13340006f,-0.65320003f,0.74430004f,-0.13530004f,-0.23599996f,0.38330002f,-0.27580001f,-0.19450000f,-0.10770002f,0.13030001f,-1.31060001f,-0.77480003f,-1.03929997f,-0.98960000f,-2.08930001f,-1.57840003f,-0.66949997f,1.29370001f,1.98380005f,0.87270003f,0.65290000f,0.41070000f,0.98500000f,0.07949999f,2.33370000f,0.97019997f,1.18699999f,-0.86100000f,0.67830000f,-1.05180000f,-1.11910001f,0.31480001f,-1.12950002f,-0.58629998f,-0.89110004f,0.14230001f,-0.17440000f,0.73570001f,-1.27059997f,0.55900001f,-0.89250002f,0.40829999f,-0.79599996f,-0.32669998f,-0.32430001f,-0.48300000f,-0.08080007f,-1.20110001f,-1.62519999f,-0.13819998f,0.65760006f,1.67010001f,0.59949998f,0.17349998f,0.50650000f,0.24200003f,0.27919997f,-0.89409998f,-1.26739999f,1.12949994f,1.12280001f,-1.12190000f,-0.19840001f,0.74439997f,-1.00880002f,-0.66459998f,-0.33369998f,0.54339999f,-1.06929997f,-0.27890000f,-0.55970005f,-0.41450001f,-0.83449995f,0.38790002f,0.53380002f,-0.38370001f,0.59779999f,0.05309999f,-0.32719999f,-0.04540001f,-0.53879999f,0.32090000f,0.43320001f,-0.92379995f,-0.31240000f,1.07610000f,1.81960001f,0.36710002f,-0.70570001f,-0.95730001f,-1.21670000f,-0.55679999f,0.43000004f,0.35180000f,-0.12700004f,-0.39709995f,-0.73719997f,-0.80570001f,-0.30079997f,0.92799998f,0.09909998f,0.43449998f,0.75679999f,-0.71840000f,-0.45880001f,0.52819999f,-0.31529996f,0.93910002f,-1.12129999f,0.51010000f,-0.82010001f,0.37400000f,0.21979999f,-0.68850003f,-1.01490001f,0.64930002f,0.22830001f,-0.09010001f,0.12990005f,2.00900003f,1.20320000f,1.27030000f,0.77719999f,1.20209996f,0.41769997f,-1.36990000f,-0.66369998f,0.53440000f,-0.02410002f,-0.56740001f,0.39340002f,-0.05900003f,-0.96869998f,-0.18270000f,-0.77780001f,0.12160000f,0.11680000f,-0.22039999f,-0.97690002f,0.83669999f,0.73940003f,-0.14100000f,-1.29140005f,0.82540002f,-0.38940002f,0.07790000f,0.54790002f,-0.57590003f,-0.60090000f,0.94070005f,-0.09070002f,-0.33950001f,-1.06750001f,-0.29540001f,-0.01580000f,0.64710001f,0.22530002f,0.57599997f,0.76630001f,0.04030001f,-0.26599999f,0.55490000f,0.88370001f,0.07799998f,-0.10509999f,0.05190001f,0.71860002f,0.51999998f,1.37350000f,-0.54150003f,-0.12690003f,1.36490002f,1.13839999f,0.47990002f,-0.25410002f,1.30100001f,0.96779997f,-0.10240004f,1.70760003f,0.28550001f,1.00789998f,-1.57010003f,-1.60430002f,-1.35540000f,-0.69959997f,-0.72340001f,-1.09409999f,-0.50519995f,0.15320002f,-0.80610000f,0.81490001f,0.18059996f,0.02069998f,-0.12639996f,-0.19270001f,0.77660001f,0.56629999f,0.52500002f,0.16200001f,0.54699996f,0.26289999f,-0.93809998f,-0.76889999f,0.12259999f,0.72169997f,-0.37499998f,-1.13290000f,-0.32809998f,1.15689995f,0.39410002f,0.09709999f,-1.05170001f,-0.86300001f,-1.28000003f,-0.46630001f,-1.17129999f,-0.10609998f,-0.45200002f,-0.43550000f,-0.40430002f,2.18689998f,0.55250001f,1.57149999f,0.64290000f,1.05679998f,-0.75399998f,-0.54580000f,0.22580001f,-0.13960001f,0.81780001f,0.12199999f,1.83159998f,0.62379999f,0.89419996f,-0.00220000f,0.02800000f,-0.26899999f,0.20550005f,-0.90699999f,-0.58220000f,0.17220000f,-1.21559999f,1.52319997f,0.75139999f,-0.01560002f,-1.22409999f,0.06860001f,-0.45250001f,0.45379997f,-0.01289998f,-0.47339999f,0.26269997f,2.11340000f,-0.94159998f,1.78219998f,1.06799999f,1.26479998f,-0.07080000f,0.89559998f,-0.66590000f,1.04839999f,0.63969998f,0.04429999f,1.60169998f,0.36850001f,1.13629998f,0.74719998f,0.81819995f,0.33820000f,0.26880001f,-0.27900000f,1.11109998f,0.54410000f,0.76539999f,0.06670002f,0.36660000f,-0.16149997f,-0.93629998f,-0.62810000f,0.08569998f,1.20350001f,0.50080002f,-1.04139999f,-0.02399999f,0.04619998f,-0.56449999f,0.39229999f,1.33860000f,0.61050000f,-0.62540003f,0.41910002f,-0.16869999f,-0.05730000f,-0.05490002f,-1.62179999f,-0.19880000f,0.19959998f,0.03330001f,0.50380001f,-0.17739999f,-0.66290000f,0.36490004f,0.00270002f,-0.68100000f,-0.05340002f,-0.48889998f,-0.36870000f,0.29919998f,0.39970000f,0.29310000f,0.23089999f,0.53859998f,-0.89179998f,-0.34660001f,0.09480003f,0.86020000f,-0.87269996f,-0.42899999f,0.56260000f,0.11260000f,-1.18689999f,-0.62220000f,-0.80130000f,0.57749998f,-1.37380001f,0.20240000f,-1.28300000f,1.16639997f,-0.38390001f,0.16920000f,-0.26500002f,0.30540001f,-0.78389998f,-0.45739998f,-0.19640001f,-1.25510001f,-0.15190000f,-1.47249997f,-0.12140000f,-0.33240002f,0.08650000f,-1.09539998f,-0.24400000f,-0.05870000f,-0.34749999f,0.51829999f,0.04430005f,0.40770001f,0.74829993f,0.54169999f,0.72520001f,1.03000001f,0.15210002f,-0.79040000f,-0.14890000f,0.98589998f,1.14799997f,-0.96540000f,-0.23770000f,-1.64339999f,-0.48010003f,-0.39640002f,-1.19400001f,0.58130000f,-0.66750001f,0.40020001f,0.17609999f,0.05519999f,1.57660004f,-1.18690000f,-0.75420000f,0.63539997f,0.60399998f,-0.42990001f,0.57379999f,-0.28750004f,0.66560001f,0.30030001f,0.32189999f,1.24180001f,0.04020001f,0.20130005f,-0.30070000f,-0.05709999f,-0.29630002f,-0.44869999f,1.31009995f,1.07689995f,1.35839997f,1.09940002f,-0.91369998f,-0.65450001f,-0.28209994f,-0.84070001f,1.38430000f,-0.22649999f,-0.20820002f,0.02129997f,-0.17729997f,-0.57369997f,-0.65329999f,0.05599998f,0.53640003f,0.34410001f,-0.33590003f,-0.00230001f,-0.52630002f,-0.31470001f,-1.02010002f,-0.05440000f,0.51040004f,-0.21600000f,0.74149998f,-0.16980000f,0.66320004f,-0.22330001f,-0.01180002f,-0.26489999f,0.23199998f,-0.03790001f,0.29309998f,-0.06119999f,1.42140009f,1.56140004f,1.96220005f,0.48830004f,0.92320005f,0.86000000f,0.91729995f,0.06129999f,0.04699998f,-0.20259999f,-1.37390001f,-1.33440000f,-0.29099999f,-0.46040000f,-1.27620005f,-0.75899997f,-0.30239999f,0.25450001f,-1.19539999f,-0.67339999f,-0.30329999f,0.02520002f,-0.48470001f,0.43949999f,0.27070000f,0.80130001f,-1.62939999f,0.26970000f,-1.27100000f,0.57520001f,-0.86789999f,0.18490001f,-0.81109999f,0.24960003f,1.19640000f,0.50589996f,0.25330003f,1.63260000f,1.10789997f,0.25079999f,-0.44790007f,-0.50910003f,-1.15460006f,-0.56149998f,0.07730000f,-0.28259998f,-1.15139999f,-0.18430002f,0.47679998f,-0.10289999f,-1.41479997f,0.91830000f,-0.70319997f,0.78459998f,0.76060005f,-1.27039997f,0.55149999f,0.82240002f,-1.59919999f,0.98980000f,-1.07140000f,0.10000000f,-0.43860000f,0.37509999f,-1.37829998f,0.77190001f,-0.47429999f,0.29110000f,-0.70889999f,0.96880000f,0.08549998f,1.75079995f,1.52389996f,0.55109998f,-0.73240005f,-0.47420001f,0.02230000f,1.44999998f,0.89919998f,0.42520001f,0.83759998f,0.26589999f,-0.62889997f,-0.52420000f,-0.83339998f,0.85669999f,-0.11369997f,-0.49930000f,-0.42299998f,0.11119997f,-0.34649997f,0.35059998f,0.69720002f,-0.62040003f,-1.31290002f,0.80790003f,-0.27100001f,-0.38910001f,-0.08260003f,-0.49780001f,0.94100001f,0.34290000f,0.41720001f,0.13019999f,-0.51000002f,-1.63389999f,-1.23299999f,0.46520003f,0.10240000f,-0.28710000f,0.44750002f,-0.76599998f,-0.28729995f,0.87049998f,0.23589998f,0.18279997f,1.13940001f,-0.06400001f,-0.71740002f,0.59039999f,0.53270000f,-0.49600000f,-0.62590004f,-0.20909998f,0.49069997f,0.32999999f,0.36590001f,-0.73469997f,0.56549999f,-0.45760000f,1.64240000f,-0.51700001f,1.17440000f,-0.32120001f,0.99349998f,-0.33400000f,0.06960002f,-0.20780001f,0.25350001f,0.84280002f,-0.01570001f,-0.65780001f,-1.06529999f,-0.83480000f,-0.29009996f,-0.21840001f,-1.28979998f,-0.83399997f,-0.19979999f,-0.72860001f,-0.61570000f,1.79349995f,-0.08270001f,0.65169998f,1.49369998f,-0.69859998f,0.91459996f,0.83449996f,1.08829996f,-0.41939997f,0.12460000f,-0.05310000f,0.46590001f,0.37179999f,-1.17649998f,0.35480000f,0.80620001f,-0.38470000f,1.63950002f,-0.34500001f,1.74610003f,0.18459998f,0.06050000f,-0.07549996f,-1.70970004f,0.64430002f,0.21870006f,1.76599997f,1.83879998f,0.78390000f,0.86140006f,0.81720000f,-0.21009999f,0.20509994f,-0.06409998f,0.46290007f,0.56649999f,0.75770001f,-0.65170002f,-0.09630001f,-0.48229998f,-0.76159999f,0.29629997f,0.22940000f,0.89139999f,-0.86820001f,0.47519998f,0.20260001f,-2.09449998f,-0.22980000f,1.25960001f,0.39160000f,0.40020002f,0.36070000f,-0.98539998f,-0.00649998f,0.46189996f,-0.50119999f,1.32690000f,-0.21680001f,0.43119999f,0.31660000f,0.37069998f,0.26759998f,-0.19190002f,0.20830000f,0.20680000f,0.69350000f,0.03919999f,0.86219998f,-0.24260002f,0.61790000f,-0.18150000f,0.47079998f,0.81410002f,0.09990000f,-1.02019999f,-0.37770001f,-0.19279996f,-0.13450001f,0.25660001f,0.22850000f,-1.40040001f,-0.46820000f,0.40610001f,-0.57800000f,0.70690001f,0.68729999f,-0.57319999f,1.15199998f,0.35419999f,0.00670002f,-0.64619999f,0.19279999f,-0.70959997f,-0.05220004f,1.04890002f,0.44770001f,-0.21800000f,-0.67660000f,-0.02879999f,-0.81979999f,-0.17619999f,-1.00569998f,-0.46100001f,0.09460003f,-0.41770001f,0.23450002f,0.46020002f,-0.44149999f,0.01170001f,0.48039999f,-0.61190003f,-1.00380001f,-0.40570002f,1.01750001f,0.43279997f,-0.40780002f,0.08199997f,2.00630007f,-0.40560001f,0.36070000f,-0.21309997f,-0.22569996f,0.10110001f,-1.10850000f,-0.21569998f,-0.78349998f,0.21580003f,-1.76940003f,-1.58120001f,0.43670001f,-0.96699999f,-0.60300001f,-0.22899998f,0.42269998f,-0.53070001f,0.34100006f,-0.48370000f,0.79499999f,-0.30780001f,-0.37769996f,0.02749998f,0.02860001f,-0.65120002f,-0.68550000f,0.47900001f,0.33099996f,0.92680001f,1.30340001f,0.38950003f,-0.82389997f,-1.24440003f,0.83920000f,0.23599997f,-0.73540000f,1.78489999f,2.07989999f,0.45520003f,0.78480000f,0.44439998f,0.31450000f,-0.60990000f,-1.28519999f,-2.03060000f,-0.40399999f,1.31020000f,-1.06719999f,-0.04550003f,0.42170006f,0.79250001f,-0.02930004f,0.47229999f,-0.67240001f,-0.44620000f,-0.28769994f,-0.63590000f,1.87849993f,0.69219999f,-0.43150001f,0.47559999f,-0.80190005f,-0.19149998f,1.36420002f,0.22779995f,-0.81280002f,-1.06540000f,0.36270001f,1.00450001f,0.21220000f,0.00240001f,-0.84410000f,-1.02089999f,-0.46009999f,-0.83890002f,-0.63659998f,-0.39119999f,-0.38020001f,-0.83859999f,-0.04399999f,1.19430003f,0.21570000f,-0.14360001f,0.60689997f,0.23109997f,-0.72750000f,-0.63410001f,0.38009999f,-0.04480000f,-0.05719997f,-0.08479999f,0.84839999f,0.40770001f,-0.39560002f,0.02440000f,0.19160002f,-0.01940000f,0.69670003f,-0.34859997f,-0.41770000f,-1.76819998f,-1.13590000f,-0.66069992f,-0.35159999f,0.05129999f,-0.71890004f,0.77700000f,1.02270000f,-0.98849995f,0.45970000f,-0.82720002f,1.28280001f,-0.89160002f,1.15609998f,0.88050002f,0.66619999f,1.41349999f,-0.95660000f,-0.72539997f,0.61190000f,-1.30269995f,0.32090002f,-0.29539999f,-1.47279999f,-0.50939997f,-0.35989997f,-0.28729998f,0.20570002f,-0.26309999f,-0.99909995f,-0.14780000f,-0.50389999f,-0.07659999f,-1.04600001f,0.62119998f,0.38910000f,-0.64030000f,-0.17349999f,0.19720001f,0.70570001f,-0.32010001f,0.00499999f,0.01130003f,0.62299997f,-0.56219998f,-0.14290003f,-0.37140000f,-0.02470002f,-0.67690001f,0.32179998f,-0.23820002f,0.15529998f,-0.05110001f,0.66050001f,-1.00730001f,0.06970004f,-2.19679997f,-0.62690002f,-0.03130002f,-0.18820001f,0.23629999f,-0.46979997f,-0.34920001f,-0.03630002f,0.18160001f,-1.76689999f,-0.52349999f,-1.72869999f,-0.50020000f,-1.08969995f,0.67419995f,0.24940000f,-0.84490000f,-0.35630002f,0.57770000f,0.92780002f,0.72770000f,-0.53890000f,0.21020004f,0.56110003f,-0.80600001f,0.18710001f,0.57959998f,1.16700003f,-1.49769996f,-0.43459999f,0.58869993f,-1.53940002f,0.11130004f,1.10919998f,-0.22239999f,1.68759995f,-0.73639999f,0.49599998f,0.79230002f,-1.05820003f,-0.04800002f,-0.05249998f,-0.16419996f,-0.30410003f,-1.76539997f,-0.13629999f,0.56710004f,-0.71370004f,0.02980002f,-0.94140005f,-0.64970003f,0.59769999f,-0.32750000f,0.04359994f,-0.91869998f,-0.63059999f,-0.60230000f,0.98490000f,-0.11509997f,0.55870001f,-1.07930004f,-0.68599998f,0.55259999f,0.22620001f,0.28580001f,0.00740001f,-0.57749999f,-0.46220001f,0.60100001f,0.17980002f,-0.58270001f,-0.12260003f,0.40010002f,0.93540002f,0.24410003f,-0.69480003f,-0.05079998f,1.30440009f,0.08890004f,1.08900003f,0.25749999f,-0.43740002f,-0.28850002f,-1.18180002f,0.10319999f,-0.50040003f,-1.60200002f,-0.57680002f,-0.62089996f,-1.62650003f,0.45590001f,0.11470001f,0.90609998f,0.78230001f,0.05339999f,1.26999998f,-0.65899997f,-0.80809999f,0.30610004f,2.00119998f,-0.03969998f,-0.10139997f,0.45379993f,-1.18939999f,-0.48519999f,-0.90240000f,0.30970001f,0.17299998f,-0.23069997f,2.67139998f,-1.31610003f,-1.13980000f,-0.92780001f,1.82670004f,0.49159997f,1.49920002f,0.14849999f,-0.93470004f,-0.06220004f,2.41950005f,0.88909999f,0.08660002f,-0.15300000f,0.50450003f,0.24700000f,-1.16790000f,0.97189996f,-0.21860000f,0.57149999f,1.01880004f,-0.24910002f,-1.75280003f,0.76420002f,0.97800001f,0.04640001f,0.05039998f,0.57309998f,-0.89179997f,-0.21630002f,-0.81660002f,-1.01229999f,-0.07480003f,0.59950001f,0.25080002f,-1.04500001f,0.34639998f,0.70119996f,1.37850004f,0.78410006f,-0.07650006f,-0.86019998f,-0.66819998f,-0.87130000f,1.26510005f,0.49199998f,-0.77980002f,-0.02459993f,-2.91250013f,1.00779999f,0.06029999f,-0.46520000f,-0.02149999f,-0.89600001f,0.53139999f,0.02830000f,-0.24970004f,0.63100005f,1.44810003f,-1.65019999f,0.95560004f,-0.74319999f,-0.46760001f,-1.11950001f,-0.22180000f,0.14030003f,-1.24819999f,1.06019998f,-0.29040002f,-1.21579997f,-0.56780006f,-0.15740001f,0.64479999f,-0.17219996f,-0.72479999f,-0.17539997f,-0.34910000f,0.57410000f,0.41819998f,1.37210000f,-0.89420003f,0.36290004f,-0.16239999f,1.04160000f,-0.61540000f,-0.89289997f,-0.37030001f,-0.52599998f,-0.19399999f,-0.12929999f,-0.31549999f,-0.38799998f,0.00110002f,-0.76179999f,-0.33180002f,-0.24589997f,0.04530001f,0.16180001f,1.27479997f,0.17819999f,1.41339995f,-0.01550000f,1.59439996f,-0.69519998f,1.55459999f,0.37249999f,1.88939996f,-0.31269999f,0.14499997f,-0.22269998f,0.73259994f,0.68989998f,0.14519999f,-0.03309999f,-1.50000005f,-1.89960004f,2.00340006f,1.06900002f,-0.12570001f,-0.65870000f,0.83600003f,-1.21370002f,-1.05269997f,-0.37170002f,0.28289997f,-1.16950001f,0.22960002f,-0.02200000f,-0.51070002f,0.60360003f,-0.20799999f,-0.01989999f,0.70839999f,0.48760000f,1.53239995f,-0.68699998f,-0.69480002f,0.07250000f,-0.46140001f,1.17670002f,-0.48680001f,-1.37280000f,0.04100001f,0.46519999f,-0.65600001f,0.58640000f,-1.65140006f,-0.62329999f,0.37450004f,1.08940004f,-0.65070004f,-0.25470000f,0.63410002f,0.70719999f,-0.75560002f,-0.51840001f,0.50060002f,0.54509998f,-1.48579996f,0.88319997f,0.24069995f,1.02609999f,1.07959999f,0.43899999f,0.94339995f,-1.00189995f,0.56700002f,-2.15229992f,-0.81310001f,0.63650000f,0.63739999f,0.21340003f,0.54370004f,-0.66569999f,-1.39469997f,0.09149999f,-0.01460002f,-0.40259998f,-0.27089997f,-0.60100001f,0.66980004f,0.18920001f,-0.14629997f,0.40539998f,-1.59149996f,0.43690001f,0.32479993f,-0.69840005f,0.46510001f,1.10560000f,0.03839999f,-0.86329995f,-0.37180000f,0.64799998f,-1.37569999f,0.97079998f,-0.23279999f,0.91309996f,1.33659998f,0.51709998f,-0.19969998f,-0.51669997f,1.26429998f,-1.72449996f,-0.19940002f,-0.59259999f,-1.00470000f,-0.85270000f,-0.26190000f,-0.29590001f,-0.51780003f,-0.14530000f,0.83910003f,-0.37449997f,-0.90279996f,0.05590001f,-0.22300000f,-1.42150001f,-0.74060000f,0.28419997f,-0.16489999f,1.06179997f,0.17359999f,-1.40959997f,-1.19159991f,0.83200003f,-0.35970005f,-0.67400007f,1.27049997f,0.30730000f,0.63780000f,0.50779997f,0.70139999f,0.29089998f,0.66339998f,-0.64379997f,-1.38059997f,0.58979998f,0.54319996f,1.18359998f,0.06450002f,0.22750000f,0.84940004f,-0.79180000f,0.09060004f,0.01249997f,0.25680000f,-0.16079998f,-0.24709997f,0.29019998f,0.23389998f,0.08780000f,-0.21969999f,0.69799995f,-0.81960002f,0.15470002f,-0.32830003f,-1.17140001f,-0.23080000f,-1.08269997f,0.27989999f,1.20689996f,-0.08800001f,-0.48509999f,-0.23920002f,1.33529992f,0.87319997f,-0.54450000f,1.36949998f,-0.95839999f,-0.70669999f,-0.46379996f,-0.08909999f,0.56089997f,-0.21549998f,0.27030000f,0.36259999f,-0.07749998f,-0.19100001f,-0.14970000f,-1.71759999f,-0.28750000f,0.26730002f,0.74300000f,0.68240001f,0.83920001f,0.24569998f,0.05050003f,-1.55290003f,-1.38709998f,-0.60879994f,-0.48710000f,1.35789993f,0.45240000f,0.78310001f,1.02940001f,0.32479998f,-0.43880002f,-0.49769999f,-0.28750002f,1.00949999f,-0.76279995f,-0.64819998f,0.30239997f,0.98879997f,-0.46320000f,-0.51779998f,-0.00530000f,-0.76670000f,0.55910000f,-1.12419999f,0.85940001f,0.69090000f,0.22690000f,0.31160001f,1.25220001f,1.08050000f,0.94080001f,0.29500002f,0.97549998f,1.93260002f,-0.10869997f,-0.42769998f,-0.00610002f,1.26390001f,-0.51729999f,0.39520002f,1.58809996f,-0.08020001f,0.77899997f,1.03259995f,0.77450003f,-1.20079998f,-1.15010002f,0.43440000f,0.26090002f,-0.33779997f,0.45759998f,-0.87559999f,2.34859992f,-0.74390000f,1.96969995f,0.94950000f,0.48119997f,-1.04410000f,-0.33219996f,1.57899998f,-0.65970000f,-0.03490001f,-0.28140000f,0.64850005f,-0.45980000f,1.31120003f,-0.65779998f,-0.49579998f,-0.55090001f,0.70319998f,-0.00070000f,-0.27710002f,0.46650000f,0.24239999f,0.04979998f,-0.74999999f,0.72580003f,-2.04739996f,-0.74390005f,-0.30070003f,-0.46989998f,-1.16879995f,-0.68719998f,0.18740001f,1.21689996f,-0.02440000f,0.18289998f,0.27889999f,-0.16559999f,0.18629999f,0.09110001f,1.69939993f,-0.56229997f,-0.97249998f,0.53900001f,0.09710002f,1.49589993f,0.65099997f,1.15089999f,1.64250003f,0.42540002f,1.21060002f,0.39049999f,0.69930000f,0.42889999f,0.81690000f,0.52619998f,0.81350000f,0.51750001f,-0.33370000f,0.41660001f,0.36360001f,-0.92669998f,0.21319999f,-0.58620001f,0.40679996f,0.03050004f,0.55199998f,1.01729997f,0.94900001f,-0.04110002f,-0.39039993f,0.19609999f,-0.00630004f,-0.93840004f,1.29490001f,0.59840008f,-0.91230001f,-1.05159998f,-0.13200002f,0.27609996f,-0.24690002f,0.70700000f,0.91420004f,-0.30540003f,-0.17860001f,0.02520002f,-0.28280000f,-0.45059998f,0.56189999f,-0.70630004f,0.28180003f,0.64360000f,-0.34769997f,0.29849998f,-0.53200004f,0.29400001f,-0.29039999f,-0.33409997f,0.18500002f,-1.07980001f,-1.08239998f,1.28829998f,0.54939999f,-0.54199998f,1.19340003f,0.44429998f,0.76760001f,-0.11889997f,1.03960005f,0.36830004f,0.02120000f,0.58340001f,-0.68550000f,-0.81700000f,2.28000001f,1.39490002f,-0.13739999f,-1.04659999f,-1.26510004f,-0.04439998f,0.01930000f,0.14150001f,0.77770000f,-0.45439997f,-0.44729998f,0.03970000f,-0.67909999f,0.65350000f,0.15089995f,-0.71120003f,2.03660003f,-0.27500002f,-0.65579999f,-0.33220001f,0.07219997f,-0.49109997f,0.10599999f,1.13659997f,-0.04539997f,-1.74239999f,-1.27939999f,0.77919999f,-0.75800004f,-0.29189995f,-0.89640002f,-0.01789992f,-0.25739999f,0.75020004f,0.44350001f,-0.34680001f,0.48740001f,0.76499999f,-0.59390001f,-0.95939999f,0.34420003f,-1.47679998f,0.14850002f,-0.94439997f,-0.13190001f,-0.66130003f,-1.08369999f,0.71929997f,0.71549997f,0.00159999f,-0.17629999f,-0.31970000f,-0.21100001f,-0.18839997f,1.92700001f,-0.20660002f,0.78960001f,0.55969999f,0.17980003f,0.22259997f,-0.68319999f,-0.64049998f,0.07299999f,0.43549999f,0.51240002f,-0.63370001f,1.60960001f,0.51599997f,-1.07799997f,-0.75419999f,0.19569997f,0.89739996f,-0.91110005f,-1.13550004f,0.71260003f,-0.59770001f,-0.68730003f,0.04799999f,-0.81820001f,0.70330000f,0.77790001f,0.57419999f,0.56660002f,0.25449995f,-0.00940002f,-0.52810002f,-0.61960002f,0.25140000f,0.80720005f,0.55360000f,-0.77159997f,-0.38169999f,-0.63939997f,0.86479996f,-0.30020000f,-0.56269997f,-0.18039999f,0.51740001f,-0.65120002f,-0.19270000f,-1.22560001f,0.66680000f,-0.54790004f,-0.75379999f,-1.52260007f,-1.66539998f,-2.65860008f,-1.03179995f,0.17099997f,-0.23120001f,-0.93560004f,0.54300002f,-0.32080004f,0.14149998f,1.37769998f,-1.22780000f,0.95579999f,-1.78849998f,1.71940004f,-1.81560002f,-1.28580002f,-0.29400001f,0.89300003f,-0.67630001f,-0.48500000f,-0.35679999f,-1.51280003f,-0.36429996f,-0.27580003f,0.08200003f,0.32619997f,0.79760000f,1.56940000f,-0.28919998f,0.52559998f,0.37060001f,1.80100000f,-0.42269997f,0.48150001f,1.08330006f,0.93899997f,0.76210002f,-0.71299997f,0.06530004f,1.59010002f,0.50300000f,-0.47300003f,-0.43539999f,-1.25120004f,-0.23949998f,0.15100002f,-0.34950000f,-0.82450002f,-0.91270000f,0.32060000f,-0.73939998f,-1.02150001f,0.15800000f,1.17680000f,-0.94659998f,0.19990004f,0.17049999f,0.96679999f,-0.92550001f,1.31919998f,-0.70329996f,0.67679996f,0.57079997f,-0.25780000f,-0.60050000f,-0.98260004f,-0.16249996f,1.23099996f,-0.98039999f,-0.90930005f,-0.23320001f,-0.72580003f,0.33240004f,-1.16940003f,-0.63639999f,-0.45620002f,0.28360002f,-0.11500003f,-0.68999998f,-0.08040001f,-1.15479996f,-1.87829999f,0.60650000f,0.52350002f,-0.63659997f,0.42630003f,-1.46489999f,0.02409999f,-0.52620001f,-0.80900000f,-0.05269999f,-0.84839999f,0.13399999f,0.26090000f,-0.16410000f,0.08200001f,-0.71210002f,1.27540004f,-0.14870001f,-0.93730002f,-0.88570001f,-0.23250002f,-0.20780002f,0.58240000f,-0.51129997f,-0.04840001f,-0.65260000f,-0.23039999f,0.18750001f,-1.69289995f,-0.33990003f,0.04569994f,-0.91980004f,0.14660004f,0.29480006f,-0.35919998f,-0.68030000f,-0.08050000f,-0.65960000f,0.55750001f,-1.15100001f,-0.49399999f,0.35809994f,1.57559996f,-0.89499999f,0.35999999f,-0.94519997f,-1.09170000f,-0.20360001f,0.90030000f,0.35610000f,-0.89290001f,0.95279999f,-0.75120003f,-0.18329997f,-0.92540001f,-0.85249996f,-0.95809996f,-0.77319999f,1.46600002f,0.94700002f,-0.59530000f,-1.58069998f,1.27219996f,0.06349999f,1.26479996f,0.16650000f,-0.03489997f,-0.68339995f,0.61579998f,0.96739998f,-2.07559994f,-0.83269997f,-0.29409999f,-0.11559998f,-0.25229999f,0.72269998f,-0.48439999f,-0.64699994f,-0.09379999f,-1.22539992f,0.89739995f,-1.32659994f,-1.13639999f,0.09670000f,-0.51210001f,0.55389994f,0.98389999f,-0.25239998f,0.73540003f,-1.08289998f,-1.30450003f,0.23920000f,-0.17059999f,-0.71279999f,-0.69719999f,0.77889995f,0.63579995f,-0.77589998f,-0.33239999f,0.15660001f,-2.17019996f,-0.56520005f,0.08770002f,-0.32869995f,0.23489996f,0.70569996f,-0.43390003f,-0.00240001f,1.19879999f,-0.10910004f,-1.05439996f,-0.38269998f,-0.07230004f,0.04150002f,1.06650000f,0.94769998f,-0.20160002f,-0.40069998f,1.23229999f,0.46720001f,0.77090000f,1.29620002f,0.45409996f,0.33870001f,1.12630001f,-0.48509996f,-1.70880002f,-1.09100001f,-0.88800001f,-0.37350001f,-0.42590004f,1.47359997f,0.42320004f,0.54929999f,0.30350002f,1.23259999f,-1.87189994f,-0.72799998f,0.30869998f,-0.66639998f,0.70929999f,-0.25320001f,0.15240003f,0.16469996f,-2.06060002f,1.38049999f,-0.37539998f,1.05809997f,-0.50000003f,0.61480003f,2.13959998f,-1.14079998f,0.48879999f,-1.60669998f,-0.71150000f,0.47100000f,-0.90610004f,0.84249999f,0.01599997f,0.94369998f,-0.19860003f,1.00509999f,-0.04300002f,0.90600001f,-0.90430004f,-0.60689998f,-0.70139999f,1.23419993f,0.97979997f,-0.16310002f,1.35499998f,1.20350001f,0.96759996f,-0.65499998f,0.69080000f,0.89149996f,0.61399998f,0.17809998f,-0.53559996f,1.29899994f,0.48149999f,1.11879994f,-0.79699999f,0.66819997f,-0.73089996f,0.55249998f,-1.68929995f,1.50209996f,0.32830000f,-0.32489999f,-0.32280000f,0.37859996f,0.13779995f,-0.39619999f,-0.24259999f,-1.05690001f,-0.01279998f,-0.60730000f,-0.81230000f,0.01030000f,-0.40660002f,-0.19260000f,-0.28880002f,-0.27080003f,-0.26720002f,-0.03180001f,-1.03480000f,-0.81230001f,-0.87609998f,0.49190002f,0.30039997f,-0.88380001f,0.63519999f,0.43849999f,-0.60079998f,0.80529998f,0.27010006f,0.25930001f,0.55689998f,-0.78959998f,0.37260000f,-0.01370000f,0.82409999f,-0.14569999f,-0.16749999f,-0.59229999f,-0.05150001f,-0.30520000f,-0.93550004f,-0.38050001f,-0.03629999f,-0.26779999f,-0.39469999f,-0.64360001f,0.33940004f,-0.43890000f,0.28870001f,-0.43459999f,1.11280002f,1.13269998f,0.02720001f,-1.05739999f,0.52060003f,1.48619998f,0.78880003f,-0.56309999f,-0.36379998f,0.75620000f,-0.07940001f,-0.25400000f,-1.08860001f,0.64240001f,-0.11940000f,-0.12490000f,0.37820001f,1.06740003f,1.69300004f,1.35850007f,-1.20669997f,-0.93549998f,0.90490005f,1.56610001f,0.61180001f,-0.20340000f,-0.52810001f,0.28280001f,-0.19599999f,0.44940002f,-0.78680005f,-0.42879997f,-0.02630002f,-0.18879996f,-0.06279998f,0.71180002f,-0.43300003f,0.07819999f,0.58640003f,0.22489999f,1.10340004f,-0.46080000f,0.55200002f,-1.10339999f,0.68159999f,1.13859998f,0.25659997f,-0.52500002f,-0.78300002f,1.82340001f,-0.15380003f,-0.45750000f,-0.73450000f,-1.01980002f,-0.76880001f,-1.09360007f,1.59480002f,0.88819994f,0.41670002f,1.35109994f,2.47700005f,-0.16910001f,-0.85040000f,-0.49970003f,0.61090000f,0.07069997f,-0.08699998f,1.24709998f,-1.13609996f,1.86499995f,0.36600000f,1.07819999f,-1.51620003f,-0.77960000f,0.46700001f,0.53399999f,-1.61539999f,0.84249999f,-0.19759999f,0.54869999f,-0.18379997f,-0.15100002f,0.42540000f,-0.45919999f,0.62080002f,0.82309997f,-1.50079999f,-0.75599995f,0.44140002f,0.19300002f,2.04620005f,1.24970001f,-0.19680001f,-0.47919997f,-0.30310000f,-0.40970004f,0.81030008f,0.31840003f,0.60900000f,-0.94149999f,-0.65899999f,0.56480000f,-1.17830005f,-0.01799997f,0.62650005f,-0.70920002f,0.00589998f,0.65410002f,-0.71380000f,-1.31779996f,-0.20279999f,1.28259996f,0.87880001f,-0.67850000f,0.79559998f,-1.09839998f,-1.48080004f,0.79949998f,0.55400003f,-0.24999999f,0.80360003f,-0.70830005f,0.52570001f,-0.32600006f,-1.22220007f,-1.03700002f,1.11830002f,0.19350005f,-0.91810006f,-0.44200002f,0.68610007f,1.16669997f,1.12990005f,0.67619999f,0.00249996f,0.16320001f,0.96150002f,-0.87379997f,-0.97630000f,-0.57859998f,0.22240005f,0.14349999f,-0.36910002f,1.44100001f,-1.09550001f,0.66240003f,-1.30240002f,-0.48659999f,0.00899995f,-0.14869996f,0.60599995f,-0.64060001f,0.31900002f,1.14059999f,0.10200002f,0.06189999f,-0.41419998f,0.30859996f,-1.71330001f,-1.83669998f,-1.08500000f,-0.80640002f,-0.90160001f,-1.46010001f,0.25239999f,-0.81070004f,-0.88580003f,-1.12140004f,1.96340006f,0.17100001f,0.98619999f,-0.94999998f,0.96739999f,-0.03509997f,0.01870000f,0.00679997f,0.29949998f,0.36929998f,0.16100002f,0.51660001f,-1.06049999f,-1.18489993f,-1.36280003f,1.35260000f,-0.72080000f,0.08790000f,-1.08559998f,1.00699998f,-1.66599998f,-0.26969997f,0.00500000f,0.56350001f,-0.78579996f,1.07960009f,-1.00910006f,-1.13509999f,1.17880005f,0.81060001f,1.26740005f,1.34930006f,-0.68210002f,-0.73860002f,0.08360002f,0.20089996f,1.18740005f,-0.77330001f,0.14500005f,-0.60590002f,-0.92740002f,0.52840002f,-0.06679999f,0.05600001f,0.04530001f,-0.20480003f,0.01070000f,0.88810001f,-1.26540000f,-0.64490004f,0.54199998f,0.34060002f,0.59820003f,-0.23620002f,0.22199999f,-0.90960001f,-0.39819999f,1.02959999f,0.00160000f,-0.12089999f,0.44340002f,0.32509999f,0.74600003f,-0.27359995f,0.60820000f,0.26700003f,-1.05430005f,-0.29399996f,0.64940004f,1.07130003f,0.04079999f,0.78209999f,0.43589998f,-0.21810001f,0.46829998f,-1.45499996f,-0.31329999f,-0.09850002f,-0.87789999f,-0.04669999f,0.01809999f,0.16919999f,1.28349996f,-0.62729997f,-0.08949998f,0.63800001f,0.31380001f,0.51670002f,-0.00180000f,0.86439999f,-0.13220003f,0.29260001f,0.27340002f,0.47790000f,0.62100001f,-0.05929999f,0.96460000f,-0.37809999f,0.22780000f,-0.86649999f,0.42040000f,1.39459998f,0.31659997f,0.04409997f,0.10670001f,1.15690001f,-0.09810004f,-0.04270002f,-1.57799995f,-0.71119999f,-1.25980002f,0.07050002f,-1.09589996f,1.66499994f,-0.29289998f,0.94929997f,-0.25550000f,0.90589997f,0.44199997f,-0.18339996f,-0.54690000f,-0.83749996f,0.01160005f,0.54459999f,0.47789997f,1.17079999f,-0.13650002f,0.14680001f,-1.22590002f,0.13539998f,0.35849995f,-0.62349998f,0.95560010f,1.32810000f,-0.18639998f,0.58629999f,0.56359999f,-0.21170000f,0.52679998f,0.05929998f,1.33489994f,-0.13760001f,0.05850006f,0.26620006f,-1.76659997f,0.29660001f,0.65289995f,0.85079997f,-0.66569997f,1.27399996f,-0.45479998f,0.22939999f,0.66799997f,-0.77399997f,-0.52919996f,-1.30039995f,0.08139994f,-0.62419999f,-0.22919999f,-0.42510001f,-0.20380000f,0.94240001f,-0.75520007f,0.68980001f,-0.68760004f,0.44010000f,0.13809998f,-0.50639999f,-0.50829999f,-0.27000002f,-0.68029998f,-0.18210000f,0.22360001f,0.51789998f,1.27539998f,0.08529999f,0.79179999f,0.30839999f,-0.18529998f,1.28920001f,-0.85280000f,-0.93819998f,0.23170000f,0.03559999f,-0.46270000f,1.64799997f,-0.41719998f,0.96929998f,-0.97520000f,0.65229999f,-0.44389998f,0.23100001f,0.58969999f,-0.97180000f,0.33390002f,-0.06020002f,2.03740004f,-0.55409998f,-0.86280000f,0.34839996f,0.09459997f,0.92290000f,0.18800002f,0.92319996f,2.22999998f,1.32569999f,0.08560001f,0.89480000f,-1.61739997f,-0.98779994f,0.79879996f,-1.24930001f,1.04729998f,-0.60239997f,1.76649994f,2.65929999f,-0.87249999f,-0.44559998f,1.01899998f,-0.80169999f,-0.03650003f,-0.95109994f,1.89819999f,-1.07510000f,-1.60749999f,-0.02899998f,-0.06349999f,0.19189998f,-0.80899997f,-0.53969998f,-0.88910000f,-1.02029998f,-0.57579998f,-0.31609999f,-0.95160000f,-0.22270000f,0.14970000f,-0.41289998f,0.11410003f,0.89559997f,-0.32210009f,-1.44479999f,-0.54989996f,-0.17600001f,-0.40339996f,0.37780000f,0.54869997f,0.23709999f,-0.36029997f,0.12580001f,0.02909998f,0.42299997f,0.91210000f,-0.82079996f,0.09360001f,-0.82349998f,-0.12750001f,0.49759997f,0.62559999f,-0.03230001f,-0.24200000f,-0.35159998f,-0.21570003f,1.24349996f,-1.05309994f,0.68279996f,0.83810001f,0.89839998f,0.02709999f,-0.09440000f,0.09440001f,-0.67500001f,1.23780004f,0.63509998f,-0.62210000f,0.30899998f,1.46410002f,1.89979998f,0.10879995f,-1.64159997f,0.17599997f,0.27569996f,-0.08039999f,0.94850001f,-1.17359996f,-1.03800001f,1.41029992f,0.36190000f,-0.29509999f,-0.00930005f,-0.56569999f,0.02100000f,-0.77269996f,0.07520000f,0.99440001f,-0.92810000f,-0.44090000f,0.61589994f,0.93869999f,-0.22430003f,-1.28119997f,-0.01779999f,-0.97010001f,-0.98329999f,-0.80810000f,-0.62390001f,-0.65219998f,0.36929996f,0.04899997f,-0.15590002f,1.18830002f,0.62829996f,0.56269999f,0.05780002f,0.42800000f,0.18959999f,-1.40639996f,0.12609997f,-0.32179995f,-0.17170000f,-0.31059999f,-0.88299998f,0.34519998f,0.56189998f,0.22519997f,-0.19170004f,0.36430003f,-0.55550004f,0.34419999f,-0.14740001f,-1.13260004f,-1.67470000f,-0.03340001f,0.26330002f,-1.26250003f,-0.60380000f,1.44010002f,-0.02920002f,-0.84060003f,0.67689999f,0.79299999f,-0.18590001f,0.36830000f,-0.54390000f,0.80340000f,-0.56889999f,0.29680000f,-0.86440000f,-1.17119999f,0.61900002f,-0.52939997f,0.27319997f,-1.51219999f,-0.60389998f,-0.54320000f,0.62130001f,-0.41580002f,-0.55389999f,1.06259996f,0.28970001f,0.43079998f,0.21419999f,0.01249998f,0.65740002f,-1.54960007f,-1.83450000f,-0.70440001f,-1.07250001f,-0.77719996f,-0.33490004f,0.72429998f,0.90449996f,1.90210005f,0.54810002f,0.91149999f,-1.13570000f,0.51510000f,-1.08950001f,0.07169999f,0.17020001f,0.37699998f,0.65390000f,-0.67169994f,1.29340000f,-0.90720003f,-0.84459997f,-0.51100003f,-0.22179999f,-0.70800001f,0.84020001f,-0.26379999f,0.39110000f,-0.51600000f,0.88759998f,1.03439999f,-0.70599999f,1.22460003f,1.27039999f,1.02370003f,0.68680002f,0.03210000f,-0.43600000f,-1.68600008f,-2.29710008f,0.31180006f,-0.61710003f,0.45620000f,0.34669999f,0.69570002f,1.22600001f,-0.33560001f,0.16210000f,0.69889999f,-0.68390002f,0.64550002f,-0.17940000f,0.01789998f,0.83130001f,0.22200002f,0.36120002f,-0.84699999f,-0.85770001f,-0.14599999f,-0.34620001f,-1.58980004f,0.02820002f,-1.26300001f,1.17220002f,-1.46380001f,0.12709998f,0.23979999f,-0.94009999f,-0.11159999f,0.51719996f,-0.16880000f,1.54320002f,0.21179999f,0.71390006f,-1.38100004f,-0.10990001f,0.05860005f,-0.75440004f,-1.48990001f,0.35089998f,-0.60830003f,0.95420000f,0.75700000f,-0.45599998f,-1.06649999f,-0.67939999f,0.43590001f,-0.60560004f,-0.62610003f,1.08729999f,2.01389999f,-0.37019999f,-0.74350001f,-0.43269998f,1.05799996f,-0.58069998f,2.46679999f,-0.56340003f,0.14580001f,1.51460001f,-0.92719998f,0.44669996f,0.05299998f,-0.56649998f,1.51959996f,-1.46410003f,2.21520006f,1.55819999f,1.27910001f,0.61659998f,-0.59620000f,-0.52969999f,0.81130001f,0.66089999f,0.13910003f,0.12400001f,-1.32430005f,0.54629999f,-0.92130000f,1.58719999f,-0.10630001f,0.44940001f,0.46180000f,0.11160000f,-0.40869999f,0.53640000f,0.63439995f,-0.80919999f,0.35990003f,0.93919998f,-0.27819998f,-0.71350000f,-0.82899998f,-0.54349999f,-0.39879999f,0.47799999f,0.32320000f,-0.54519999f,-1.06520001f,-0.13460000f,-1.80100004f,0.40129998f,-0.87989998f,-1.14129995f,0.24580001f,-0.28050002f,-0.18880002f,1.10790003f,0.83720000f,0.57730004f,-2.51380003f,-1.51999996f,0.69630003f,-0.28169998f,-0.61980002f,-0.53350002f,-0.25030002f,0.63229999f,0.52870003f,-0.10199999f,-0.61670004f,-0.93080000f,1.16930001f,-0.62419999f,-0.11990006f,-0.48589996f,0.10280003f,1.01189995f,-0.16599996f,-0.23059999f,1.28740000f,-0.59519998f,0.05560002f,-0.24179999f,0.16640002f,1.19389998f,0.05840001f,-0.35489997f,0.23180003f,-1.02779999f,2.17930005f,1.39750001f,-0.91539999f,-0.50019996f,-1.17260000f,-0.60709998f,1.15510004f,1.24390003f,-2.42350008f,0.78039998f,-1.03899997f,0.57849998f,1.19040002f,-0.14620003f,-0.39190001f,-0.75519998f,0.99179999f,-1.41889995f,0.88359995f,-0.92409998f,0.60450001f,0.52569998f,0.82480001f,0.83550000f,0.80429999f,0.70660001f,0.35740003f,-0.61779999f,-0.38889999f,-1.11499997f,-0.74659996f,0.31810001f,-0.06210001f,0.53060000f,0.12409999f,-0.04970001f,-0.32019997f,-0.61960000f,-1.09849999f,0.50179996f,-1.33839996f,-0.07910004f,0.40440001f,0.32400001f,1.69159996f,0.77289996f,-0.04479998f,0.46579999f,-1.13039997f,1.09099996f,-0.66749998f,0.93629994f,0.99880000f,0.16009998f,1.11749995f,0.32609998f,0.17429999f,0.21840001f,-0.86579999f,0.33290000f,-0.80160003f,0.24380000f,0.44120000f,-0.69589995f,-1.50179996f,-1.21079996f,-0.97459997f,-1.23719995f,-1.16869997f,0.25489999f,0.39579997f,-0.14720000f,0.93249998f,0.78969998f,-1.37279993f,-0.06530000f,-0.25930000f,0.19739999f,-0.58579997f,-1.20079999f,0.51860000f,0.48929999f,-0.16930000f,0.82969999f,-0.44549995f,0.58419998f,-1.23359996f,0.66289999f,1.68339996f,-0.40930000f,0.51799996f,-1.25089994f,0.59549997f,-0.71330000f,-0.30170000f,-0.40580002f,-0.15600000f,0.57380000f,-0.52740003f,-0.42060000f,0.23009997f,-0.95189999f,0.33360003f,-0.16850000f,0.40429998f,-0.20769999f,0.00400001f,0.20460001f,0.49400000f,-0.55879998f,0.68129997f,-0.11310004f,-0.61979994f,0.53010002f,-0.34729999f,-0.32319994f,-0.30349998f,-0.95939995f,0.43560003f,-1.13219998f,-0.18929999f,0.02260000f,-0.15950000f,-0.83759998f,0.32139998f,-1.22239996f,1.15749993f,-0.87719994f,-0.50569999f,0.41819999f,0.38090000f,-0.39229998f,-0.11889996f,-0.01270000f,0.03800000f,1.00329997f,0.27039995f,-0.14160000f,-0.09290002f,-0.86069997f,-0.78669998f,1.86310000f,-0.42370001f,-2.05849994f,0.05760001f,0.52709998f,0.98089997f,0.46959999f,0.44679997f,-0.75800002f,-0.96799993f,-0.75589996f,-0.40749999f,-0.14559999f,0.31429999f,-1.37009991f,-0.15140000f,-0.27500000f,0.08940001f,0.49779996f,-0.28809999f,-0.89489997f,-0.39590001f,-0.73509994f,0.97639997f,0.50199999f,-0.37600002f,1.09340000f,0.54270002f,0.41030002f,0.12480001f,0.52569998f,-0.01710002f,0.80959999f,0.66329996f,-0.20339997f,-1.12980001f,-1.11290001f,1.00170000f,-0.32759995f,0.35509999f,1.60989995f,0.27629998f,0.36530001f,0.60369995f,-0.99380000f,-0.66929994f,0.91379996f,-0.11829998f,-0.40289998f,-0.96109997f,0.63020000f,-1.44069998f,1.13689999f,0.62080000f,0.55139998f,-0.49319998f,0.39569999f,-1.52669995f,0.88109998f,1.86549996f,0.19879999f,0.84360001f,0.59619999f,0.81330001f,0.47700001f,0.23560001f,0.65519999f,0.81910000f,0.26730001f,-0.07390005f,-0.27610000f,-0.97590002f,0.52920003f,0.41140001f,0.16400000f,0.03400000f,-1.79249993f,0.89459999f,1.30749997f,0.05639999f,-0.78139999f,-0.49669996f,-1.11660000f,0.26700002f,-0.65839999f,0.78529998f,-0.58479999f,-0.43410002f,-0.65119996f,-0.19359998f,0.05089998f,-0.17980002f,-0.43879997f,-0.48389998f,-0.25050000f,-0.32309999f,-0.54689997f,-0.09129994f,-0.08219999f,1.58260003f,0.76640000f,-0.41620004f,0.16380000f,-1.43980004f,-0.63789999f,0.04710001f,-0.36409999f,-1.18900002f,0.09540000f,-0.48199995f,0.16709998f,-1.27300000f,0.33980000f,0.90860002f,-0.79830000f,1.14859999f,-0.13100001f,0.09820002f,-0.13630002f,-0.03939995f,-1.12229990f,-0.97550006f,-0.37919999f,-0.17250006f,-1.09450001f,0.88040002f,-0.14729994f,0.84709999f,0.54660005f,-0.55400003f,0.14590000f,-2.16000006f,-1.42449998f,0.47860001f,-1.12380003f,-0.37520000f,-0.54740000f,-0.31800003f,-0.06019997f,-0.18309999f,-0.35940000f,0.95750001f,-0.72780001f,1.00450001f,0.36479997f,0.21219997f,0.25910003f,-0.49579998f,0.23880001f,-0.02819995f,-0.82140001f,0.31679999f,-0.39079998f,-0.59920002f,0.40080000f,0.01399998f,-0.28780001f,0.00100002f,-0.79129999f,-0.33240003f,-0.76160004f,1.90530000f,0.29670001f,0.12099997f,0.25970001f,1.40090001f,0.64329996f,0.91360002f,0.51940000f,0.16469999f,0.10639998f,0.52310001f,0.48379997f,-1.10879999f,0.66350000f,0.33420003f,0.14049998f,-1.27259998f,1.39959997f,0.40369999f,-0.36839999f,-1.41479997f,0.51159997f,-1.10079998f,0.16800002f,-0.19379997f,-1.02659999f,-0.01719998f,0.19430000f,0.16860003f,0.11969998f,-0.59759998f,-0.96060001f,1.17070003f,1.78189998f,-0.23240001f,-0.34120001f,-0.34239999f,-0.53360007f,1.35330006f,1.95290001f,-0.21419999f,0.98640002f,0.19629998f,0.74440000f,-0.22819999f,0.88919997f,-0.08060000f,0.07929997f,-0.31370002f,1.04380002f,-0.40979999f,0.81430005f,0.13490002f,-0.60849999f,-0.85610000f,0.68169995f,0.35340002f,-0.60939999f,-0.55059999f,0.53849999f,0.19600002f,0.34620001f,1.17379995f,-1.15029999f,1.09759994f,0.00989998f,-0.13460000f,0.18049999f,-0.25730002f,-0.35620001f,1.05290001f,1.25649996f,-1.29920003f,-0.58280000f,-0.95670000f,-0.99150003f,2.10920007f,1.20579999f,0.79440002f,0.08480002f,-1.27119996f,0.25609995f,-0.01520002f,0.61209997f,0.98989999f,-0.75540000f,-0.54140001f,0.44930002f,-1.38439999f,1.29500001f,-0.07029999f,-0.59379999f,1.16160001f,0.85069996f,-0.20099998f,-0.67869998f,-0.46540000f,0.49480001f,0.81599999f,0.65160000f,0.15499998f,-0.66210002f,0.52980002f,-0.95360001f,-0.08690000f,-0.73960002f,-0.02790003f,-0.43180004f,-1.20210005f,-0.45159998f,-0.92170000f,-1.43400001f,1.29250000f,0.24839997f,-0.65190004f,-0.45330002f,0.00480002f,0.41339996f,0.53419998f,0.09689999f,0.94620002f,-1.20580001f,-0.16920002f,-0.20650002f,-0.39540001f,0.50960002f,0.14150005f,0.97980000f,-1.54439998f,0.58489997f,-0.48040000f,-0.83649996f,-0.01700002f,0.36970001f,-0.69739998f,1.06089998f,-0.24880002f,-1.22959995f,0.76220000f,0.87100002f,-1.41920006f,0.32340000f,-0.69400001f,-0.85150000f,-0.43920003f,0.55089998f,-0.95460002f,-0.68130001f,0.97940001f,-0.00900004f,0.80570004f,0.26200003f,0.76780001f,-1.12230000f,-0.94069999f,-0.09130001f,0.93510000f,-0.09680001f,-0.31790001f,-0.37709999f,-1.10010000f,0.72390001f,0.15320000f,-0.70840001f,1.16899995f,0.23890003f,0.62440002f,0.92419995f,-0.05580000f,-0.43079996f,0.87099998f,0.50479999f,-0.21159999f,0.11540001f,-1.43359998f,0.22269999f,0.04740001f,1.24909998f,0.79840003f,0.46159999f,-0.88860003f,-1.77039999f,-0.35630002f,-0.14660007f,1.77340007f,1.29769999f,-1.33040005f,-0.50460001f,-0.93170003f,0.17230001f,-0.46639996f,1.32999994f,0.40040000f,-0.01189999f,0.55149997f,0.51829995f,0.52770002f,-0.84479998f,-0.26500002f,-0.21459996f,0.03040003f,-0.59189997f,-1.48660001f,0.30389997f,1.07860000f,0.44440000f,-0.34599998f,0.59059998f,1.21800001f,-0.52069995f,-0.94949997f,-0.66590001f,-1.50709994f,0.32769997f,0.95619995f,0.05029997f,-0.15239998f,1.04940003f,0.69649994f,-0.30570002f,-0.95279996f,0.07640001f,0.76009999f,0.11790001f,0.11769998f,1.24409995f,1.43659997f,0.52769995f,-1.37669997f,0.77419998f,0.80740000f,0.28079998f,-1.02119998f,-0.22479996f,1.77569997f,-0.35530001f,-0.09750001f,0.03790000f,0.90970000f,-0.06949999f,-0.60070004f,-0.60420001f,-0.49059999f,0.54859996f,1.68580003f,0.75650001f,-0.56090004f,1.37230000f,0.27359999f,0.22430002f,-1.28669998f,-0.53970002f,-0.56099999f,0.16760001f,0.83909998f,1.22069999f,-0.48460001f,-0.13930000f,-0.14980004f,0.46949999f,0.45029999f,-0.03759999f,-1.07240001f,0.68700001f,0.46690002f,0.60119998f,0.94090001f,0.39979994f,-1.16150000f,0.79110000f,0.65640001f,1.22220001f,0.79689999f,1.52300002f,0.94809998f,1.23970003f,0.01800000f,-0.20969998f,-1.19000002f,-0.67720002f,0.21750002f,-0.31070001f,-0.46190000f,0.75220002f,0.55840000f,-1.04590001f,0.45960005f,1.52939998f,-0.00950002f,-0.58500000f,0.54349998f,-0.63939999f,-0.09349998f,0.54020000f,0.51659997f,0.72449998f,-0.90920000f,1.01849999f,-1.65999997f,1.93439994f,0.29019997f,0.10800000f,1.01400001f,-1.48519999f,-0.31320000f,-0.79760001f,0.65889999f,-0.38410001f,1.42060000f,-0.09930000f,-1.19320002f,-1.07349999f,-0.51839999f,-0.50850001f,-0.82939997f,-0.63889998f,-0.00619997f,0.12139998f,0.57649998f,1.41660000f,-1.93579995f,-0.89060005f,-0.37180002f,-1.08030001f,-0.53689994f,0.60450001f,-0.04130003f,-0.35250001f,0.37799999f,1.45819995f,0.72419996f,-0.19650000f,-0.45789996f,0.82759995f,1.21949997f,-0.41740001f,-0.14369998f,0.09589996f,0.58199998f,-0.25919999f,0.52369998f,-0.16430002f,0.26740000f,0.04429997f,0.04460001f,-0.51789996f,-0.90100002f,-0.04250000f,0.95029998f,0.43750001f,0.41830001f,0.08100001f,-0.58190000f,-0.31240000f,0.73610002f,0.41590001f,0.08949999f,0.83939997f,0.61640000f,-1.15999996f,-0.19679993f,0.69730002f,-0.63049998f,0.04029998f,0.42589998f,0.13040000f,-1.51099996f,0.74549994f,0.11419997f,-0.28449997f,1.26789995f,-1.20699993f,-1.58529997f,0.44689999f,-0.23020000f,0.98389996f,1.13630000f,-0.45890001f,-0.90950002f,-0.72059996f,-1.38880003f,-0.80099999f,-1.14640001f,-0.43390000f,-0.76579999f,0.38929998f,0.50900000f,-0.66650000f,0.36210005f,0.04380000f,-0.24840001f,-1.58200001f,-0.20739995f,0.02120000f,0.28870001f,0.50310003f,0.60539997f,0.30139998f,-0.17679999f,1.15839999f,-1.23359999f,-1.31730002f,0.24789999f,-0.38329997f,0.24209998f,-0.10510001f,0.17959999f,0.06269999f,-0.19119999f,0.55459997f,-0.10749996f,-0.39710002f,0.22569997f,0.27879999f,0.06420001f,-0.65890001f,-1.94500005f,0.22369999f,-1.31540005f,0.74240000f,0.31650000f,-0.68380000f,-0.49580003f,-0.38520002f,-0.31059997f,-0.38510000f,1.36130001f,-0.34119996f,0.13940000f,0.24679998f,-1.21479999f,-0.60530000f,0.18560001f,0.20870001f,-0.30120001f,-0.88859997f,0.96240001f,1.21459997f,-1.06679995f,0.82490000f,1.19699999f,0.35930003f,-1.58410002f,-1.17869999f,0.44700002f,0.24780004f,-1.68600005f,-1.11399999f,0.84669999f,0.41100000f,-1.14340007f,0.63170001f,-0.06480001f,-0.64449997f,1.20819999f,-0.81429998f,0.10860000f,-0.04349998f,0.78330001f,-0.99970004f,-0.86309998f,0.37169999f,1.00290003f,-1.18529998f,-0.37620001f,-0.76689998f,-1.06380001f,1.28680000f,0.00460000f,-1.00310001f,-0.26379999f,1.10130000f,1.09599999f,-0.95459999f,-0.18080001f,0.87909999f,-0.75450001f,-0.29249999f,1.39780005f,0.27590001f,0.21710000f,-0.33349997f,-0.97540002f,0.25340004f,-0.40850000f,-0.55389996f,-0.65240002f,0.36910002f,0.45660002f,-0.38719999f,-0.97260005f,-0.01259998f,0.12280003f,-0.24129998f,1.51290001f,-0.83920000f,-0.17880003f,-0.92620000f,-0.67590000f,-0.67389999f,0.20119997f,0.24920000f,-0.06400002f,-0.67430001f,-0.35680001f,-0.02810000f,-0.41680001f,0.08940001f,0.48799999f,-0.25510001f,0.42740002f,-0.64470001f,-1.47630007f,-1.84400003f,-0.50400008f,-0.82710004f,-1.37340005f,-1.58740000f,0.04590002f,0.35599999f,1.23730006f,1.55790001f,-0.66790000f,-1.49240001f,0.05169999f,-1.04100003f,0.90730001f,-0.74209999f,-0.00570000f,-0.57119998f,-0.32119999f,1.04170000f,-0.32610002f,0.94100002f,0.00380001f,0.17840003f,-0.67240002f,1.14200001f,-0.94740004f,-0.59419994f,0.42460001f,0.84599999f,0.20060004f,0.59199998f,0.44520003f,-0.95840001f,0.05120000f,1.56130003f,0.98549996f,0.27020003f,-0.39799997f,-0.97379996f,1.97560004f,1.50870002f,-0.09609999f,-0.45159998f,0.06010000f,1.30369998f,-1.77920001f,0.12239999f,-0.85390002f,-1.04540000f,-0.39480000f,0.10020004f,-0.25980000f,0.85810002f,-0.16219999f,0.31159999f,0.99019997f,-0.19589998f,0.42760000f,-1.23730000f,0.55900000f,-0.56109996f,0.07340001f,0.96499997f,-0.61579997f,-1.02730000f,-0.09939997f,0.42569997f,0.22999998f,-0.74819996f,0.35159999f,-0.05749999f,-0.34789999f,-0.00889999f,-0.59510002f,0.04319993f,1.23820001f,0.81499997f,-0.09920002f,-0.55479997f,-1.13510004f,-0.40399998f,2.00510006f,-0.03800000f,0.29430000f,0.15060002f,-0.09489997f,0.21339998f,-0.34420000f,0.53980002f,0.08569999f,-0.78749998f,0.59340003f,-0.35159999f,-1.59770004f,0.15160001f,0.66999996f,-0.36669999f,0.09699997f,1.10430000f,-0.21580001f,-1.12949998f,-0.14820000f,-0.09839999f,0.41560000f,0.56680000f,0.36660002f,-0.51570003f,1.54870005f,0.65589997f,0.64320004f,0.20810001f,0.14950002f,-0.22020001f,-0.10460004f,0.37830001f,1.05600005f,0.58130005f,-0.56220003f,0.42690000f,-0.41200000f,1.19390003f,0.13220002f,0.80120001f,0.33909998f,0.29589998f,0.21610002f,0.17820002f,-0.75150004f,-0.55070001f,0.56330002f,0.41970001f,-0.98760000f,-0.26080000f,-0.84559998f,-0.13060002f,-1.23559996f,0.18699999f,1.15160002f,-0.83819997f,-0.12400000f,0.02839998f,-0.23220001f,-0.81899994f,0.11940000f,-0.72020005f,-0.88590002f,-1.13310006f,0.29250002f,0.27469998f,1.45260005f,0.63870002f,-0.12419996f,0.59710004f,0.83729995f,0.09449999f,-1.03659997f,-0.02789999f,0.53359998f,0.34389998f,-0.42220002f,-0.49989995f,0.30799997f,0.05300002f,-1.37639996f,0.69269999f,0.55419999f,-0.13270000f,-0.78649999f,-0.19270001f,-0.22570002f,-0.45860000f,-0.46660000f,0.06419996f,0.24119998f,-0.37419997f,-0.19979996f,0.05019999f,-0.02480001f,0.26790002f,0.96689998f,2.00719999f,0.28389998f,-1.61360001f,1.07210001f,0.12530004f,0.04520001f,-1.11530000f,0.54160001f,0.98060004f,1.12419993f,0.86929999f,0.69060003f,-0.01840003f,0.93009999f,-1.84109997f,0.41050000f,-1.61890001f,-0.52740001f,-1.41819994f,0.44529997f,-0.66719998f,0.18530000f,-0.44709998f,-0.49009997f,-0.41180002f,0.49799998f,-0.65739999f,-1.37949997f,-1.07739999f,0.09670004f,-0.58399998f,0.26350003f,-0.30759998f,-1.21250002f,-0.13350000f,0.19499998f,0.13770001f,-1.27169996f,-2.05939997f,-0.28170001f,0.46379996f,-1.02029996f,0.82739999f,-1.44059999f,-0.42820004f,0.22159996f,-0.22389998f,1.56679996f,-1.10199998f,-0.83879997f,-0.70009998f,0.49599999f,-0.23870001f,-0.06220001f,0.47989999f,-0.04440003f,1.16059999f,1.77909997f,0.00440001f,-0.65560001f,-1.10579996f,-2.06169998f,-0.50150000f,0.26820001f,-0.07809998f,-0.62900001f,-0.90979997f,-0.81299999f,-0.41320000f,-0.23870001f,-0.76260000f,-1.13269995f,-0.03790002f,0.56989998f,0.15130002f,-0.52809997f,0.82569995f,-0.50309998f,-0.13889999f,-0.36079998f,-0.49880001f,-0.43569997f,0.19540001f,-0.24649998f,0.31920001f,1.25529997f,0.00030000f,-1.24529997f,0.85339998f,0.79699999f,-0.07629998f,0.34589998f,-0.09550000f,-0.53459998f,0.84820001f,0.49859998f,-0.66260000f,0.00710002f,-0.27400001f,-0.78210000f,0.42029995f,1.12859999f,0.08240001f,-0.16079998f,0.29469999f,-0.63540001f,0.07989998f,-0.32949998f,1.42219998f,-1.29579999f,-1.32990000f,1.50379995f,1.38330000f,-0.33269999f,-0.97669998f,-0.04070000f,-0.36550001f,0.37719997f,1.32839998f,-0.38149998f,0.21169998f,0.58429998f,0.22429999f,1.05470001f,-0.04550004f,-0.68629997f,-0.71639998f,-0.22600001f,0.29779998f,-0.14919999f,0.54529998f,1.14320000f,1.26199998f,-0.08850002f,0.99809998f,1.13699997f,0.74629999f,-0.45499998f,0.53199999f,1.01209998f,-0.32919997f,-1.11009997f,0.61670001f,0.19029999f,-0.24090002f,1.45249993f,0.17190000f,-0.28859996f,0.08529999f,1.13119993f,0.89699997f,-0.90669996f,-0.98279998f,0.44719995f,-0.15190001f,-0.90909997f,0.80319997f,-0.04729999f,0.33729998f,-1.76699993f,0.96509995f,0.75719997f,0.40539998f,-0.89409999f,-0.35119994f,0.21359997f,-0.94679997f,-0.60799995f,0.22329998f,-0.43690003f,0.98259998f,0.26119998f,1.26610001f,-0.45130003f,-0.24789999f,-0.49680000f,-0.97650002f,-0.36180002f,-0.17869995f,0.51389999f,-0.72839999f,1.85169996f,0.07210000f,1.15870001f,0.33880000f,0.26859998f,-0.60690000f,-0.13580001f,1.70159995f,-0.38300000f,-0.87069997f,0.81549995f,-1.04540000f,-0.47679996f,-0.35720001f,-1.60449998f,0.65509999f,-1.02439998f,0.13420001f,0.60090000f,-0.57970000f,0.64649999f,0.30000001f,-0.02550000f,-0.16359998f,-1.51579999f,-0.88689998f,-0.74410000f,0.28399995f,1.36100000f,1.06280000f,0.10939996f,0.73910000f,-0.46310003f,1.27800000f,-0.16220001f,-0.43250000f,-1.34320001f,0.44710002f,0.68279997f,-0.37630000f,-1.27980001f,0.85779998f,-0.07300001f,-1.14969998f,-0.24439999f,-0.60650000f,-0.65650004f,0.38950000f,-0.79530002f,-0.25440003f,0.15250004f,1.23589999f,0.51990005f,0.21899998f,0.29740001f,1.39559998f,-1.49420001f,0.86640001f,1.42250003f,0.06719999f,-0.73840000f,0.44280000f,0.03810000f,1.10600002f,-1.25970001f,1.26960000f,0.58040001f,0.34990000f,0.18069998f,0.04419996f,-0.09359999f,-0.42719997f,1.17600002f,1.07080000f,0.34620004f,0.00989998f,0.75320001f,0.14369998f,0.21460000f,-0.56090000f,-0.02599999f,-0.41630002f,-0.36179999f,0.98690002f,1.60220002f,0.12270000f,1.48110006f,0.88720001f,1.50870001f,1.22000002f,0.81670001f,-0.16609998f,-0.97940001f,0.16220002f,0.49790001f,-0.18180000f,-2.10720000f,1.00769999f,-0.19580001f,1.13550000f,-0.04480000f,0.06450000f,-0.36880003f,-0.78080000f,0.46780004f,-0.23729999f,0.78099999f,0.12809999f,0.43880006f,0.00929997f,-0.63219995f,-0.50910001f,-0.04580000f,-1.18829999f,-0.32540002f,-0.27579999f,0.74619997f,-0.82330001f,1.97140003f,0.56060000f,0.08510001f,-0.11000001f,1.55150002f,0.59279998f,-0.06910003f,-0.35649999f,1.08410002f,0.51289998f,1.04780002f,0.71029999f,-0.83609999f,0.91319999f,0.52300003f,0.48189997f,-0.29760003f,0.58869999f,-0.06489996f,-0.06230000f,-0.43700001f,0.53769999f,-0.19480000f,-0.03270002f,-0.54559999f,-0.73479999f,-1.24719996f,0.60469997f,-0.66839998f,-1.13319997f,0.23119999f,0.17960000f,-0.63279998f,0.01620000f,-0.55759999f,-1.09620004f,-0.06160003f,0.01410000f,0.95730006f,0.41900007f,-1.82320004f,-0.36819999f,-0.00420000f,-0.05999998f,0.48870002f,0.09360000f,-0.18450000f,-0.17660001f,0.32000001f,0.02360005f,-0.70330002f,-0.53629999f,1.70420002f,-0.54519999f,-0.93670000f,0.18040000f,-0.20000003f,0.10299999f,-0.18039998f,0.40730001f,0.81259999f,-0.95159997f,-0.11340001f,0.15809997f,-0.16659999f,0.47010001f,1.04000001f,0.03819999f,-0.65819998f,0.09209999f,-0.29859997f,0.08770002f,-0.64280003f,-0.55500000f,-2.21630003f,-1.68260000f,0.65629998f,-0.18250000f,-1.94700001f,-0.97639997f,0.67019998f,-0.07070003f,0.27310005f,-0.51120000f,0.15909997f,-0.88780001f,0.92920000f,-0.62970000f,-0.44720002f,0.01850000f,1.43659999f,-0.90759999f,-1.25519999f,0.35159999f,0.36779997f,0.09229999f,-0.21760000f,0.18880002f,-0.35640000f,1.10169999f,-0.44099998f,-0.57879998f,-0.23120002f,0.67120000f,0.82659998f,-0.25330000f,-1.76139997f,-0.72609998f,0.25500002f,0.94979998f,-1.24250001f,-0.87430004f,-0.17230000f,-0.60810005f,0.06870001f,-1.38790004f,1.01440007f,1.72230002f,0.16980003f,-0.33079999f,-0.10210003f,0.41329998f,0.44330000f,0.58229998f,0.12969998f,0.49949999f,-0.80160001f,1.04010000f,0.50729998f,0.68920004f,-0.71349999f,0.65640000f,-0.13959995f,0.46089998f,-0.67519998f,0.86110000f,-1.16740000f,0.09120001f,-0.62339995f,0.46789997f,0.48879999f,-1.27119998f,-0.10080001f,0.10799995f,1.12350003f,0.07559998f,0.07140004f,0.05159997f,0.07269998f,1.07109994f,0.29720005f,-0.13589998f,-1.43220007f,-1.42080001f,-0.44870001f,-0.47120001f,0.43859997f,-1.27789995f,-0.43199999f,-0.25139997f,0.41269998f,-0.81729995f,0.73729997f,-1.22319994f,-0.13909998f,-0.24469998f,1.18949992f,0.03629999f,0.94250000f,0.83549999f,0.13679998f,0.53020000f,-0.05080000f,0.23799998f,1.24920000f,-0.43910001f,-0.60950000f,0.43799997f,-0.31640002f,1.08770002f,-0.42730000f,-0.51790001f,0.23189999f,0.77629997f,0.75279996f,0.62800001f,-1.39239998f,-1.16500000f,-0.02670001f,0.15699998f,0.56509997f,0.43499999f,-1.04849998f,1.03659998f,-0.46259997f,1.34089996f,0.76819998f,-0.13669999f,-0.78339998f,-0.39329999f,0.29340002f,1.03959994f,-0.08169999f,-0.46059996f,0.81160004f,-0.77790000f,-0.15889999f,-1.16090000f,0.16850004f,-0.90260002f,-0.29669999f,0.22939995f,1.43030004f,-0.49910001f,1.12170009f,0.63940004f,-1.44649996f,-0.22639998f,-0.99510001f,-1.31759999f,-0.59339998f,0.50320003f,0.50479995f,-1.47560000f,-0.36350000f,0.84130003f,-0.95630004f,-0.67459993f,0.48139997f,-0.62869996f,1.28039997f,-1.25779995f,1.09019998f,-1.36819998f,1.21490000f,-1.29250002f,-0.57269997f,-1.24580000f,0.76269998f,0.59119999f,-0.66530005f,0.45010001f,0.54750000f,0.29469998f,0.59570001f,-0.83459995f,-0.09869998f,-0.55649999f,-1.82250000f,0.56650001f,1.13420001f,-0.88649998f,1.45069999f,1.28969997f,0.65210002f,1.48160002f,-0.76850001f,-2.48529997f,-1.05349992f,-0.24209998f,2.18659994f,0.64970001f,1.10540000f,0.64400000f,-0.82699996f,0.53549999f,0.30970002f,-0.33480003f,0.49969994f,-1.91919990f,-0.44550000f,-0.24789999f,1.53629997f,-0.26640000f,-1.02190003f,-0.62960000f,0.48790006f,-0.04650001f,0.38059997f,-0.20229998f,-0.75080001f,-0.26200001f,0.16810000f,0.51680000f,0.32569997f,-0.33099999f,-1.80499999f,-0.60639998f,-0.20610000f,0.30309999f,-0.72169999f,-1.84890000f,0.32520002f,0.97490002f,0.23210001f,0.29870000f,-0.92989998f,-1.06140003f,1.13339994f,-0.99620000f,0.43509996f,-0.88249999f,-0.40330000f,-0.34139996f,0.23749999f,0.01139999f,-0.09959999f,0.46789998f,-1.04519998f,0.51789998f,1.34389998f,0.97690001f,1.46940000f,0.94700002f,0.08539994f,-0.16020000f,-0.10189997f,-0.45010001f,-0.81910001f,0.49429996f,1.31719995f,0.64730000f,0.21830001f,1.04969999f,-0.80789999f,-0.68210003f,-0.67929997f,0.06140002f,-0.74700001f,0.85729996f,1.23459992f,0.12899999f,-0.12839996f,-0.40529996f,0.80569998f,0.63559998f,-1.19900004f,1.58689999f,-0.46909996f,1.30879996f,0.37559999f,0.79139995f,1.66629997f,-0.30840000f,-1.50889995f,0.10700002f,0.38189998f,-0.13170001f,0.66030001f,0.72659997f,-0.13500001f,-0.22460000f,0.61340003f,0.65459998f,0.32619999f,0.95410001f,1.02419999f,1.11449998f,0.14579993f,0.64830000f,-0.26469999f,-0.77280000f,0.55669996f,0.57469998f,-0.38809998f,0.00079999f,1.11229996f,0.98399998f,0.82859998f,-0.04559997f,1.23219997f,-0.89779998f,-0.74849997f,0.38849996f,0.16480002f,-0.25830003f,-0.42800000f,0.62159996f,0.23859998f,0.64610000f,-0.10450002f,-0.11899997f,-0.33169997f,0.35520002f,0.74089999f,0.28170003f,-0.82630004f,-0.66069997f,-0.19179999f,0.13200000f,-0.40760004f,1.08680001f,0.82320000f,-0.10559994f,-0.17739998f,-2.70209991f,-0.02329997f,1.01499995f,1.23140000f,0.70489997f,0.01209998f,-0.61309994f,-1.17559996f,-0.76960000f,-0.56600000f,1.31399994f,-0.51740001f,-0.48300006f,0.31999999f,-0.64130001f,1.90390001f,-0.84920000f,-0.41300003f,0.54170002f,-0.25559998f,0.73869999f,0.00009999f,-0.17420001f,-0.73789999f,1.69390002f,-0.09130002f,0.33630001f,-0.45530006f,-1.38839998f,0.48010001f,-1.71259999f,-0.06350001f,0.28190002f,-0.08880001f,0.25140002f,-0.05649998f,1.82529995f,0.12080000f,0.08969999f,0.36359997f,0.80830001f,0.08349997f,-0.35009998f,-1.72860000f,-0.03199999f,0.02840000f,1.48220001f,-0.20330000f,0.54600001f,0.22579999f,-0.96940002f,-0.52269994f,-0.18920004f,0.11109999f,0.75820002f,-0.54700001f,0.67120001f,0.71699998f,-0.32169999f,0.29499996f,0.75890006f,-1.25210002f,0.21620003f,-0.08420003f,0.40219998f,0.72000002f,-0.37740000f,0.75900003f,0.00929999f,-0.13230001f,-0.09109998f,-1.69010002f,1.73369999f,-1.09659995f,0.25619996f,1.62560000f,0.58509994f,0.48859998f,-0.74589995f,-0.03710000f,-0.30309998f,-0.82839998f,0.17140000f,-1.69739998f,0.37270002f,-1.15570001f,0.62830003f,0.50770001f,-0.20839999f,0.63120003f,0.82110002f,-1.82700002f,1.14620002f,1.28570001f,-0.58069999f,-0.49530003f,-1.94610006f,0.54450005f,0.00059997f,0.24780000f,-0.06500003f,0.32750002f,-1.22240005f,0.45140006f,1.03269996f,-0.70980003f,-0.48680003f,-0.31930000f,-0.88469997f,-0.94109999f,-1.44429995f,2.13379995f,0.09679999f,-0.15630000f,-0.59599994f,-1.46909999f,0.05509998f,1.20549996f,0.31849994f,-2.21810000f,0.64900002f,1.05280003f,0.43040001f,-0.66520005f,1.02410002f,-1.52650001f,1.03299999f,1.56140001f,-0.17719998f,0.23770002f,0.65180002f,-1.08970005f,-0.01420003f,-0.26430004f,-0.82500001f,0.19090001f,-1.04079999f,1.18130003f,0.17000001f,-0.13519999f,-1.02710002f,0.11299999f,-0.57669999f,0.21670002f,-0.64549998f,-0.36520006f,1.24960001f,-1.09450006f,0.48720000f,0.35840002f,-0.31320000f,0.28670004f,-0.61220000f,-1.23690005f,1.71169999f,-1.31390002f,0.74990000f,0.27480000f,-0.91160000f,-0.20779999f,-0.60330000f,0.66749998f,-0.89209999f,-0.64070001f,-0.51540002f,0.29270000f,-1.06500002f,-0.06349998f,0.20980005f,-0.80170002f,0.14560002f,-0.87219999f,1.04609999f,-1.39400001f,0.99210001f,-0.93190002f,1.21920005f,-1.35480001f,1.24830002f,-0.21390001f,0.20800003f,-0.34839997f,0.26490000f,-0.76599995f,0.33309997f,-0.76880000f,1.30209992f,-1.09779999f,0.99669995f,-0.79649991f,0.76739996f,0.73720000f,-0.70340000f,1.00040000f,-1.00459999f,0.15450003f,0.37009998f,-1.32060006f,0.65030004f,1.68460005f,-0.19500000f,-1.47010003f,1.00800001f,0.77870001f,0.53709999f,-1.37270001f,-0.00210003f,0.09309997f,-0.49390004f,0.96770006f,-0.69850001f,-0.26590002f,-0.71620001f,0.31360003f,-0.02250001f,-0.05020002f,0.91610001f,-0.31450002f,0.92649995f,0.09759998f,1.80449995f,-0.20620000f,-1.54839999f,0.76600001f,0.24669999f,-0.91330001f,-0.39250002f,-0.06130001f,0.67569998f,-0.57170002f,0.19530000f,0.74700005f,-0.99660004f,-0.84270002f,-0.27890000f,0.50720001f,-0.51010001f,-1.00600000f,0.09539999f,-0.15239998f,0.97680000f,-1.23270001f,-0.10699999f,0.56309999f,-0.38999998f,0.72830001f,-0.26750001f,0.29299997f,0.33159997f,-1.18329996f,-0.74760000f,-0.10309998f,-0.86170003f,-0.37000002f,-0.82320000f,0.52919999f,-0.64230000f,1.32610002f,-0.04619997f,-0.08300000f,-0.04430001f,0.25950004f,1.71680003f,-0.93230002f,-0.48260000f,0.19050001f,0.77120004f,0.48480001f,-0.31649998f,-0.74930001f,-2.55470004f,0.82400003f,1.05770000f,0.98430007f,-0.62180000f,0.07620001f,0.35130002f,-0.83690003f,-0.21219999f,-0.08600001f,-0.85500001f,2.25979998f,0.21030000f,-1.36599996f,-0.85939998f,-0.18230003f,0.19129999f,-0.77409997f,0.36480001f,0.56529997f,-0.70290000f,1.06599997f,-0.39640000f,0.22890001f,1.05590000f,-1.35710001f,-1.16450002f,0.90919998f,-0.61749998f,1.14560000f,-0.80630001f,-0.40320001f,-1.55260004f,0.26379998f,-0.18570004f,0.27499998f,-1.45950000f,-0.46579998f,1.52580006f,-0.91310004f,-2.27330002f,-0.50950001f,0.08969997f,0.92610003f,-1.15350001f,0.30230003f,-0.71870000f,0.59599997f,0.53589997f,-1.09089997f,-0.82429997f,2.01409998f,0.05690002f,0.29650002f,-0.66999997f,1.91480001f,1.34440004f,0.61750004f,1.44010004f,-1.12809997f,0.49410000f,-0.13780001f,-1.10960000f,0.32330002f,0.22540000f,0.10049999f,-0.61640001f,2.80690005f,-0.35329998f,0.28410000f,-0.89710006f,0.09620002f,0.03640004f,-1.04579998f,0.74679997f,0.50069999f,-0.42660001f,0.64390004f,-0.11230000f,-0.97300006f,-0.40570004f,0.92550000f,0.95130000f,-0.63790002f,0.30250000f,0.34120003f,-0.37829997f,-0.03770002f,0.26229997f,-0.47130000f,1.34180000f,-1.31490000f,-0.65800000f,0.62259997f,-0.03769999f,-0.89789998f,-0.67510002f,-0.13149999f,-0.02429999f,-0.76340002f,-0.76880004f,0.54880002f,-0.08300001f,-1.27699999f,-0.14409999f,-0.18789997f,-1.11709995f,-1.04039999f,1.90080002f,-0.05270001f,0.45570002f,-0.51110005f,0.00200001f,-0.94080001f,0.75439999f,0.31970001f,-0.12479999f,0.55169997f,-0.69369999f,-0.33909995f,0.26940005f,-0.04410004f,0.95220001f,-0.12669998f,-0.09340000f,1.19830001f,-0.56200001f,0.62959996f,-2.15930003f,1.52189999f,-0.90310001f,2.23580004f,0.31920000f,-0.43939997f,1.17740003f,1.33670002f,0.76570001f,-0.02249999f,0.06750000f,-1.34160008f,0.82760004f,0.61569995f,0.34640002f,0.86699998f,0.04210001f,1.74900002f,0.86290000f,0.44370000f,-0.55450002f,1.74610003f,0.36420001f,0.94050000f,0.13430003f,0.19799994f,0.42779998f,0.67909996f,0.78479997f,-1.61150002f,0.72880001f,0.73870000f,0.16280000f,-1.51120002f,0.03510002f,0.59590001f,0.18639999f,0.74170002f,0.80100003f,1.68179998f,1.08429998f,-1.13639998f,-0.43190003f,1.11879997f,-1.35490001f,1.38799999f,-0.74270000f,0.99580002f,0.58490001f,1.45209999f,-0.48450007f,1.02339997f,-1.72020002f,-0.71000002f,0.23629998f,-0.64470006f,-0.22070004f,2.08769999f,-0.33320001f,-0.65629998f,-0.51220000f,-0.26399998f,0.05530000f,0.87329998f,-0.06880004f,-0.00539998f,0.24569998f,1.01310003f,-0.32780000f,-0.75880003f,-1.15920000f,0.39570000f,0.54700001f,1.05840001f,0.89959999f,0.61570002f,1.04710000f,0.10510002f,0.12090000f,-0.22569998f,0.05750002f,0.33219998f,-0.48869996f,-0.29090005f,-0.15079999f,-1.29650002f,1.50390001f,-1.86760002f,1.13379997f,-0.08759995f,-0.30100003f,0.53870000f,-1.28790000f,1.84789999f,0.45369999f,0.83770000f,0.02630001f,0.64610003f,0.50239999f,-1.91440001f,1.26559998f,0.35999998f,-0.16369997f,-1.01350001f,-0.43340003f,0.88640001f,0.20560001f,0.22450001f,-1.68270004f,-0.54140005f,-0.78039998f,1.03150000f,0.13070000f,-0.19439997f,0.08819999f,-0.59660001f,1.85100003f,-0.85090004f,0.98060000f,-0.00660001f,-1.04070001f,-1.01700006f,0.95190000f,-0.14050001f,0.54660003f,-0.73829999f,-1.22619996f,-0.25720001f,0.26139997f,0.53440004f,-0.10650001f,-0.61250000f,1.13660000f,-0.07360003f,0.57030001f,-1.38070000f,0.11689999f,2.01990004f,-0.39220001f,-1.18169998f,1.26299997f,0.55789999f,-0.71300001f,0.32700001f,-0.03839998f,-0.15859998f,0.18730002f,0.31110003f,0.51930000f,-0.64280004f,-0.69579999f,0.92620000f,-0.71370004f,0.51470001f,0.46189995f,-0.47400000f,0.37930001f,-1.30519998f,0.66289998f,0.38620002f,-0.29120004f,0.47019995f,0.29010000f,0.08170001f,0.64490001f,-1.31520004f,0.83149998f,-0.52959999f,0.06249999f,-0.82020001f,-0.35940004f,0.08040003f,-0.51530001f,0.72929999f,0.18850000f,-0.33230001f,0.11800002f,-0.25970001f,-0.83589997f,-1.07510004f,0.23780003f,-0.62760004f,1.62800004f,-0.03000001f,-0.13420003f,0.15129998f,-0.03860000f,0.15700001f,-0.64100001f,-0.27370000f,1.32469999f,-2.64490002f,0.34810000f,-0.07440000f,1.77929999f,1.11129998f,-0.81999998f,0.04829999f,0.49390002f,-0.19220002f,-0.38659999f,-0.45789999f,-0.70509999f,0.53920000f,-0.03240001f,-1.56109998f,0.86719998f,1.24570000f,-0.67160000f,0.27160000f,-0.32360000f,0.54680002f,0.12880002f,-1.18000002f,0.07899999f,0.17230000f,-0.18340000f,1.03480002f,0.51330001f,-0.09670002f,0.28240000f,0.23029999f,-0.94860004f,0.32890002f,-1.25910005f,1.17130006f,-0.47050000f,1.48119998f,0.19759995f,-0.30789997f,-1.43669993f,0.70039998f,0.21270004f,0.41859999f,-0.25830000f,0.77370001f,-0.51139999f,0.03949998f,-0.20970001f,1.07850002f,0.68090000f,0.48900000f,0.51290002f,-0.67310001f,0.30460001f,0.86470000f,-1.11080001f,-0.91070002f,0.17929999f,0.44039999f,-0.08989999f,0.72659999f,-1.96210001f,0.23479999f,-2.23490003f,0.10849999f,-0.17049997f,-1.14770004f,-0.58150002f,-0.25130000f,1.35120004f,-1.19120002f,0.99889997f,-0.36940001f,0.61600003f,-1.48460003f,0.27140000f,-1.89590004f,0.67260004f,-0.14550000f,0.04059999f,-1.10329999f,1.04339998f,-0.63239997f,0.49969999f,0.58950002f,-0.15190000f,0.36889997f,-0.18650001f,-1.50809998f,0.57249999f,1.02360000f,-0.34989998f,0.10319997f,0.94150002f,-0.85639999f,-0.21869999f,-0.91890004f,0.33700002f,-1.29670003f,-0.01789999f,-0.24309999f,1.03369999f,-0.32050002f,-0.55580002f,0.55650002f,-1.01389998f,-0.37749997f,-0.14819999f,-1.28130003f,0.84490002f,-1.12500001f,1.76369994f,-1.37819996f,0.93779996f,1.13849995f,0.74899996f,-0.89840000f,0.56900001f,-1.79469997f,0.34130001f,0.97930001f,-0.84140001f,0.23610000f,-0.50920001f,-0.38670000f,-0.41850000f,0.72999999f,-0.57330000f,0.34150000f,-0.28150001f,-0.52810000f,0.42440002f,-1.29830002f,0.74700003f,0.01569995f,0.56629997f,-1.03239996f,-0.51989997f,0.63229998f,1.12030003f,-1.01660000f,-0.14369999f,0.71230001f,0.81800001f,-0.32259999f,0.77390004f,0.04120001f,0.83720005f,-0.46120002f,-0.05869997f,1.58099997f,1.43250004f,-0.79240002f,0.19419995f,-0.93750001f,0.24580000f,0.59980004f,0.06040001f,0.99740007f,0.33529999f,0.00519999f,0.56279999f,1.53890000f,-2.31400005f,-0.52180002f,0.73530000f,-1.16540006f,0.63710000f,-0.57110003f,0.25670000f,-0.88050000f,-0.49100000f,-0.17530000f,0.22380001f,0.45919996f,-0.31870003f,-0.23089995f,-0.16960001f,0.39520001f,0.41729998f,-0.28009994f,0.91900001f,-0.40910000f,-0.95420001f,-0.70550000f,0.07940000f,-1.77419997f,0.26129998f,-0.15800003f,0.26920000f,-1.32999999f,0.91599999f,0.29649999f,-0.27700002f,-1.79230003f,-0.21679998f,0.26040004f,0.28590003f,-0.72609996f,-0.25769998f,0.17080006f,0.35649999f,0.01360002f,-0.24579998f,0.12969997f,1.22779998f,1.18630000f,0.52430002f,-1.05030000f,-0.48399999f,-0.44289994f,-0.61369997f,-0.58929996f,-1.06679995f,-0.80579999f,-0.24839999f,1.13830002f,0.71190002f,-0.83960000f,0.24850000f,-0.09740003f,0.23820000f,0.96860002f,-0.69380005f,0.20449998f,0.11020003f,-0.15219998f,2.49040001f,-0.17150001f,-1.31550002f,0.96890001f,1.41920003f,0.72629999f,-0.55000005f,-1.48280008f,-2.15800001f,1.28020008f,0.27650001f,0.47410005f,-0.11099996f,1.50909994f,0.98199994f,-1.79439997f,-0.21739999f,-0.33209997f,-0.61829999f,2.49160002f,0.12549996f,-1.36510003f,-1.05949999f,0.04270002f,-1.18109999f,-1.71620007f,-1.69040007f,1.21779999f,-0.67700001f,0.17519998f,0.13989995f,1.57470005f,1.25380005f,-1.29040004f,0.60100002f,-1.94780002f,-0.04329998f,-1.85930008f,2.00560009f,0.84819998f,0.52849999f,0.82269993f,-0.42999998f,0.96610008f,-2.71400005f,-0.67079998f,0.29300000f,-0.94149999f,-0.63079994f,-0.22530001f,0.66270004f,-0.41610001f,-0.32770002f,-0.24159999f,-0.03630002f,0.96569997f,-0.67880004f,-0.28519997f,-0.15909996f,-0.44379999f,-1.71459998f,1.16239996f,-0.57500001f,-0.19450003f,-0.98780002f,-0.67419997f,-0.38060000f,-1.19270001f,-1.95880001f,0.59319999f,0.21490003f,-1.62900000f,1.78139999f,-0.87660008f,-1.46119999f,-0.60580001f,1.40050005f,-1.14210002f,-0.01619997f,-1.75070002f,1.18170003f,0.87750003f,-0.89970000f,-1.44349999f,-0.36219995f,1.82179996f,0.58079997f,-0.33670003f,0.14679999f,0.59769997f,0.98949999f,0.01160002f,-0.03709996f,-0.39790001f,-0.83320000f,0.38060001f,-0.50590002f,1.35830007f,0.41110002f,-0.15300001f,0.74360003f,0.12319999f,-0.26090002f,0.54800003f,0.45800002f,-0.64390002f,-0.04560000f,-1.03300001f,0.13219997f,1.54550001f,-0.87650007f,0.52960004f,-1.03390003f,-0.02420001f,-0.05980001f,-0.24509999f,-1.57610003f,-0.07269998f,0.60830000f,0.31040003f,0.57799999f,-0.27589998f,-0.35300004f,-0.08950001f,-0.51960001f,0.06610005f,-0.71420000f,1.14519998f,0.35249999f,-0.70499998f,-0.44069998f,-0.64649999f,-0.15959999f,0.50679999f,-0.72470002f,0.60299996f,-1.36400001f,1.78600004f,1.14220006f,-0.31390002f,0.93320002f,0.30160001f,0.96340000f,-0.02510002f,0.20470000f,0.92269996f,0.19910001f,-0.36030003f,-1.15979995f,0.02690001f,-0.35029998f,1.65470005f,0.24819998f,0.26590003f,-1.19609997f,1.68230001f,-0.59760002f,-0.15600000f,-0.43900002f,-0.01750002f,-0.38400002f,1.33030001f,-0.54270004f,-2.25590002f,0.77049999f,0.42400001f,-0.53369999f,0.90410003f,0.91250003f,-0.25320002f,0.29250002f,-0.74930003f,1.13450006f,-1.09190007f,-0.05909995f,0.20010004f,0.75460001f,-0.43449999f,1.37210002f,0.19259999f,0.86319997f,0.21870001f,-0.41630001f,-0.63350000f,0.01999999f,0.14619999f,1.87279995f,-1.28029992f,-0.55120002f,0.56780002f,0.46689997f,1.29049999f,-0.42770001f,-0.02290001f,-0.61500001f,-0.33589999f,0.38460000f,-0.51720000f,-0.01659997f,-0.17789999f,-0.29060000f,-0.27719999f,-0.03050001f,1.73020003f,1.49390001f,-0.36990002f,-0.10260001f,1.25780002f,-0.51900002f,0.75630005f,-0.24000005f,0.12420003f,1.06869997f,-0.19489998f,1.58489997f,-1.20040006f,1.25959998f,0.67939996f,0.67139997f,1.26239999f,-0.55279995f,0.46960002f,-2.66119993f,1.65929999f,-1.00509998f,-0.37819995f,-0.56209999f,0.75839994f,-1.10450000f,-1.38470002f,0.32429999f,1.03610001f,-0.78069999f,0.56370001f,-0.01170001f,-1.27210000f,1.25870001f,-0.17040000f,0.18380001f,-0.98030000f,-0.58860001f,0.41309999f,0.60720004f,-0.62760002f,-0.39999998f,-1.05660002f,0.05749997f,0.98550004f,0.00060000f,0.00820002f,-0.32600004f,-0.49350002f,-0.25610001f,-0.17190001f,0.79259997f,-0.01510000f,-0.90979994f,-0.41259997f,1.29809993f,0.19809996f,1.12509998f,-0.97499998f,-1.73939998f,0.13220000f,0.85450000f,1.94240006f,-0.57060000f,0.26339997f,0.47290004f,0.56870005f,-0.01870000f,-2.62120006f,1.06450000f,-0.26020000f,-0.56780003f,0.19930002f,0.10780002f,0.47900000f,-1.60330007f,0.18440004f,-1.38890002f,-0.77750002f,-0.78960003f,0.42890005f,1.39940001f,-0.02089999f,1.78240004f,0.27690002f,-1.62919993f,1.78750003f,-0.29780001f,-1.57960001f,-0.53190001f,-0.45290000f,1.04939996f,-1.12690002f,-0.43110004f,1.26920008f,-0.54020000f,2.00520003f,-0.18089999f,-1.28230001f,1.03650000f,0.62380001f,-0.06359998f,-0.18449999f,-0.07329999f,1.20390000f,0.14990002f,-1.17940003f,0.67190002f,0.16580004f,-1.46390000f,1.30760004f,-0.83699999f,0.65310001f,-0.92100001f,0.97060000f,-0.83070001f,0.99130001f,-1.77430003f,0.61850006f,-0.23890002f,0.23829999f,-0.15369999f,-0.05669997f,-0.10610000f,0.13200001f,-1.07339997f,1.43399997f,-0.80669995f,1.29139998f,-1.04009994f,-0.74179997f,-1.84479998f,1.84269998f,-0.18700003f,-0.78860007f,0.57020005f,-0.48410000f,0.05879998f,0.40470002f,0.17230000f,-1.35310002f,0.50179999f,0.09049999f,-0.19809999f,-0.29730000f,-0.04979999f,0.01970003f,-0.72059999f,-0.49010001f,0.85250001f,-0.54210002f,0.49750003f,0.56110002f,0.35759999f,0.15310003f,0.34070000f,-0.24829999f,2.29210001f,-1.54000005f,-0.58029995f,-0.00709999f,0.34039995f,-0.47740001f,1.02320000f,0.20279999f,0.05219999f,0.32800003f,-1.09889998f,0.80290002f,-0.71329999f,-0.82520001f,1.17510001f,0.65250001f,0.76690001f,-1.50680004f,0.56459999f,0.10480003f,-0.59670004f,-0.12570000f,-0.39500001f,1.16390002f,-0.69169997f,-0.82779998f,-0.79069999f,0.98760001f,0.39770001f,-1.12470000f,-0.96149995f,0.18170004f,-0.79809997f,0.36819999f,-0.35780002f,-0.07099997f,0.73770002f,-1.65030003f,-0.17430002f,-0.46470001f,-2.06440002f,0.78650001f,-0.42999998f,0.35749998f,-0.99270003f,1.31620000f,0.89260000f,-0.60249997f,0.66110003f,-0.89470000f,0.64360008f,-1.69400002f,1.10020001f,0.25429998f,-0.66490001f,-0.47920003f,0.80740002f,1.68569999f,-0.14730002f,0.13849997f,0.95030004f,-0.34740005f,0.71400002f,0.44700003f,-0.18259998f,0.31199998f,0.02009999f,0.20610001f,-0.12679999f,-0.45320002f,0.20659999f,-0.14889998f,-0.81880002f,0.90089998f,-0.64930003f,0.53090003f,-0.47190000f,-0.02780001f,-0.17629998f,-0.21390002f,0.27499999f,-1.19919997f,0.58809998f,-0.29240002f,0.10730001f,-0.87720005f,-0.18200000f,-0.28960003f,0.00810002f,0.18560000f,0.02170002f,-0.66650000f,-0.47910001f,0.83270004f,1.43340001f,0.78250004f,-1.58719999f,1.41409999f,0.31490001f,0.61579995f,1.03969998f,-0.33180002f,-0.05770000f,0.50340000f,0.09860000f,-1.94799995f,-0.55930000f,-0.72850001f,0.32440002f,-0.14730000f,-0.15680000f,0.03629997f,-1.57830005f,0.41060001f,-0.73200000f,-1.21810006f,-1.26240004f,0.08179999f,-0.64740002f,0.04040003f,0.99240002f,-0.36050000f,-0.55570002f,-1.79320010f,-0.04039999f,-0.50670001f,-0.66609999f,-1.61630005f,0.34860004f,0.61810003f,0.81750000f,-0.11460002f,-0.36679996f,0.40720002f,-0.33900000f,1.41710003f,0.34710002f,0.60939996f,0.19489998f,0.21570002f,-0.15569999f,-1.08379998f,-1.14120001f,0.90200001f,-0.48430000f,0.75559999f,0.59389999f,0.41480003f,1.89259999f,0.94160006f,1.46600005f,-2.24990003f,-0.44710004f,0.62259998f,-0.87480001f,0.05030005f,-0.35860004f,0.65269999f,0.87439997f,2.58330002f,0.62540003f,-0.21609999f,-1.58390008f,-1.48050002f,1.30390008f,0.03020003f,2.50910000f,1.53859996f,-1.68810000f,-0.25479997f,-0.04259999f,-1.59370004f,0.53389996f,1.67579999f,1.16890000f,-0.51770002f,0.88390001f,-0.82189999f,-0.25069999f,-1.04410000f,1.29370005f,-1.45280002f,-0.20140000f,-0.46700003f,-0.97370001f,0.62719998f,-0.09609998f,-0.54980000f,0.03229999f,0.08399996f,-1.13050003f,-0.04579997f,-0.91559998f,-0.91599999f,-0.30050002f,-1.05839999f,-0.32469997f,-0.01839999f,-0.91819999f,0.17230001f,0.43960001f,-1.48860005f,0.22439999f,-1.28610010f,0.13609997f,-0.13409991f,-0.99249995f,0.50980000f,-0.69389998f,0.49149999f,-0.45680000f,-0.65599997f,-0.41069998f,1.24969999f,0.53400000f,1.09230001f,-0.46849997f,-0.46089997f,0.81300001f,-0.68929999f,-0.38729997f,0.99240002f,0.71020003f,-0.41339999f,0.07620002f,1.62920000f,0.58420004f,-1.10610001f,2.05350000f,-0.05880002f,-0.01749996f,-0.02159995f,0.58649999f,1.43650005f,0.40889997f,-0.64670003f,0.21440000f,0.99220003f,-0.64059997f,-0.71010001f,-0.08899998f,0.23089994f,1.68859997f,-0.77199999f,-0.37089998f,-0.79299997f,-0.73390000f,0.71049997f,1.25610000f,0.23839993f,0.15189998f,-0.57849999f,-1.25850001f,0.27510002f,0.33660001f,-0.77300000f,-1.50760001f,1.26359998f,-0.76539998f,0.53120003f,0.98950003f,-0.79650002f,-0.68370001f,2.21220003f,-1.16609997f,0.18930007f,-1.57110001f,2.52189997f,0.20209998f,0.30430002f,-2.20279993f,0.20900000f,0.63239998f,-1.08989997f,-0.21089998f,-0.01210002f,-0.70970003f,0.59390006f,-0.64480003f,1.26370000f,0.35600002f,-0.54530002f,0.67410002f,0.79640002f,0.18030001f,-0.45980001f,-0.02409999f,0.71840002f,0.63490002f,0.33819999f,-0.58490005f,0.68359999f,-1.41410001f,0.72130002f,-1.34030001f,0.01929999f,-0.56900000f,-0.44599999f,-0.10340003f,-0.74430002f,-0.15980000f,1.88190002f,-0.81990000f,0.52729995f,0.03680004f,-0.52120001f,-0.83229997f,-0.48890002f,0.60620002f,-1.53969998f,0.05430000f,0.49399996f,0.66650003f,0.20940002f,0.38589998f,-0.03520001f,0.18360001f,-0.22110000f,0.16020001f,-1.04300000f,0.13320000f,0.72849998f,-0.91189997f,0.94150006f,-0.53330001f,-0.06160002f,0.15879999f,0.67890000f,-1.53690001f,0.50110002f,-0.74320001f,0.74600004f,0.89309998f,-0.66569997f,0.67520001f,-1.42070007f,-0.99529997f,-0.46730001f,1.99859995f,0.07169996f,-0.17309999f,0.02620001f,-1.22769996f,0.69170006f,-0.91399999f,0.24270000f,-1.20279999f,-0.42290001f,-0.85650003f,0.00570000f,0.21749999f,0.47400002f,0.57390000f,-0.86840004f,0.77750004f,0.34740003f,0.21470001f,0.68389999f,0.19120004f,-0.98909999f,0.61870001f,-0.14400001f,0.29590002f,0.78480001f,-1.10080002f,1.43830007f,-1.43520005f,1.03460003f,-0.84220003f,-0.20459998f,-0.53120001f,0.07820000f,-0.33670000f,0.18579999f,0.66089998f,0.61350000f,0.78240002f,0.20309999f,-1.67370000f,1.48710004f,-1.22769997f,-0.93720002f,-0.74319999f,0.46909998f,0.79150004f,0.30049999f,-0.43310001f,0.58830004f,-1.14230002f,-1.84700006f,0.03849998f,0.79080005f,-0.87280001f,1.01909999f,-0.26159997f,0.88659997f,0.53229999f,-0.93480001f,1.42280004f,-1.85080006f,0.44810000f,0.20230001f,1.83420004f,0.70660000f,-0.60500004f,0.02299999f,-0.01590000f,-1.16460003f,-1.14919998f,-1.17789996f,1.29439997f,-1.22500002f,1.05869995f,0.17270001f,1.09929997f,2.54600003f,-1.51649997f,-1.26050000f,-0.45979994f,-0.28560001f,-0.14520000f,0.15040000f,-0.02050002f,0.28360002f,0.47849999f,-0.97070000f,0.68329999f,0.45030000f,-0.25890000f,0.62400002f,0.23419999f,-0.35420003f,-0.25500003f,-0.09559999f,1.07130002f,0.27430000f,-0.13680001f,0.59150002f,0.10650001f,-0.35310000f,0.22620000f,0.31909998f,-0.55890003f,1.55460006f,-1.77950000f,1.21440003f,-0.15569998f,0.49309999f,0.25279996f,-0.41099998f,-0.62259997f,0.12910001f,-0.16080000f,0.44829999f,1.33789997f,1.00359997f,-0.38289999f,-0.09409996f,-0.72270003f,0.42279998f,-0.10499999f,-0.10660003f,-0.09110000f,0.93430001f,-0.61150005f,-1.46910000f,0.52369999f,2.01570000f,0.10450004f,0.04669995f,-0.39659999f,0.19369999f,-0.56450001f,-0.84050001f,1.11460006f,-0.65400007f,-0.17949996f,0.61990000f,0.02320003f,-0.63640006f,-0.24759998f,1.12269998f,0.16390003f,0.35629998f,-1.11949995f,-1.73210000f,0.32590001f,0.83499997f,2.17749993f,-1.35269998f,-1.03229994f,0.83509999f,0.97520001f,-1.48429999f,0.90610001f,0.69569998f,0.61290002f,-0.54150001f,0.89860000f,-0.67850003f,-0.19189998f,1.80320001f,-0.73250001f,-0.64260003f,1.05559998f,-0.50100003f,-0.58440003f,1.34690006f,-0.94159999f,-1.61040001f,-0.78140000f,-0.23579995f,-0.46330001f,0.38770000f,-0.41849998f,0.18219997f,0.05800001f,0.62240004f,0.16440000f,-0.35519998f,-0.45719999f,0.25559997f,-0.78069996f,1.19840000f,0.12880003f,1.03799997f,-0.25980002f,0.46730000f,-0.01439998f,0.17309996f,0.47609997f,-0.36920001f,0.17470003f,0.56460004f,-0.17129997f,0.73829998f,-1.71100005f,-0.73450004f,-0.88359997f,0.16339999f,0.34749996f,0.30580001f,0.97840001f,0.16169995f,0.79959999f,-0.51120003f,-0.98760000f,0.60490005f,-0.98049998f,1.52909998f,0.15590002f,-0.07620003f,-0.75580000f,-0.21980000f,-0.92540001f,-0.27239998f,-1.07129999f,-1.01130000f,-0.80890000f,1.39150000f,0.24830004f,-0.91379999f,0.78210001f,-0.53220003f,0.93080001f,-1.38710001f,-0.86799997f,-0.85629997f,0.12559999f,-0.07409999f,0.13440003f,0.51200004f,-2.17450000f,-0.02429996f,-1.38069997f,-1.16299996f,-0.11669999f,1.15169998f,0.02149999f,0.13200002f,-0.48789998f,-0.75419997f,-0.85259998f,0.88120000f,-1.28659997f,-0.04929999f,-0.66379996f,0.37570003f,0.83800002f,-0.90619996f,0.29980001f,-0.58669999f,-0.02760001f,-0.53160002f,0.42570004f,-0.49130005f,0.54299996f,0.79829999f,1.17169995f,-0.80639995f,-0.74809997f,-0.47459995f,0.63829994f,-0.90440002f,0.00180003f,0.50350005f,0.04159998f,0.75679997f,0.88039998f,0.79909996f,-0.19949999f,-0.42590001f,-0.63040002f,-0.30149992f,-0.29939998f,0.52819999f,0.72820001f,-0.92600001f,-0.43829999f,-1.22119992f,-0.85520000f,0.20649999f,0.41289998f,0.26409999f,-0.38850002f,-0.33329992f,1.94810000f,-0.92030000f,-0.43979999f,0.51100001f,-0.32349999f,-0.24610000f,1.11610003f,-1.58600002f,0.17689995f,0.41169999f,2.21590003f,1.15480003f,-0.82889999f,-0.88319996f,0.89039999f,-0.52710001f,0.47030000f,1.24690001f,0.14529998f,-0.40070003f,-0.05389999f,0.67760008f,-0.36349998f,-0.43560002f,0.84259998f,-0.15439996f,-0.23859995f,0.61689997f,0.73109999f,-1.15290001f,0.29539999f,-0.54029994f,-0.48900000f,-0.27200000f,1.04980002f,-1.39899998f,-0.94480004f,-0.35170002f,-1.47390001f,1.37120003f,-0.01520000f,-0.36489997f,0.04050001f,-0.92760002f,-1.24150001f,1.62920000f,-0.22120004f,-2.08450003f,0.46720006f,-0.13579998f,1.72810003f,0.23169999f,-0.29850002f,-0.65480001f,-0.36519999f,-0.12740002f,1.27539999f,1.45960003f,1.13729998f,0.73290000f,0.85240001f,-1.06879999f,-0.59679996f,0.78819998f,0.42479997f,0.59369996f,1.05759999f,-1.16229994f,-0.82939997f,0.41489997f,0.36239999f,1.07690001f,1.08020000f,-0.65769997f,1.32389999f,-0.12000000f,-0.52839999f,0.14990000f,1.04050000f,-1.13929999f,0.18640001f,-0.64320005f,2.01900004f,1.01599996f,0.77719997f,0.47640000f,0.03850007f,-0.40709999f,1.66249999f,1.06919998f,0.28020002f,-0.46360000f,-0.44390002f,-1.59480002f,0.21320001f,-0.12459999f,0.95580001f,-0.34000008f,1.44869997f,-0.38439997f,0.09610004f,-0.62450004f,0.81969999f,-0.03689999f,0.14509999f,0.74180001f,1.78460003f,-0.08500001f,1.11650000f,-0.96810003f,-0.56120005f,0.61270006f,-0.05790001f,-0.07349999f,0.22010005f,-1.59750005f,-0.24370003f,0.53100001f,0.69009996f,0.44019999f,-1.68399998f,0.19000002f,-0.36589996f,-0.38169997f,-0.86080002f,-0.18509997f,0.49469996f,0.38670002f,0.48049996f,0.04179998f,0.34500000f,0.28559998f,-0.29709999f,0.55380000f,-0.12930000f,0.52620002f,0.54929998f,-0.74100002f,0.92039999f,-0.73089998f,0.63669997f,-0.42360001f,-0.87829996f,-0.21800002f,-0.32579999f,0.24769998f,-1.45770001f,-0.13260004f,-1.26719998f,-0.33800000f,0.24590005f,0.37120001f,0.53569999f,0.45670003f,0.23440006f,-0.37510002f,0.91350002f,0.67159995f,0.03429998f,-0.81070003f,-0.23759998f,-1.31309999f,0.96920000f,-0.41399998f,1.12329997f,-0.19009997f,-0.23599998f,-0.43089997f,0.68210000f,-0.06600003f,0.52380003f,1.00310002f,0.09940000f,-1.68630000f,1.26269997f,-0.91369998f,0.08599997f,-0.01840000f,-0.95190000f,1.02260000f,-0.64710003f,0.96190003f,-0.75240001f,-0.20880002f,-1.10710001f,0.26960002f,0.88830001f,-0.01809998f,1.16309997f,0.24900001f,-0.86899996f,0.89259997f,-0.31329997f,0.36699997f,-1.30089993f,0.45669996f,-0.35709999f,-1.29839999f,0.05080001f,0.94170002f,-0.56470001f,0.48230003f,0.28070000f,0.38719997f,-0.55489999f,-0.08089999f,-0.22580001f,-0.50540003f,-0.10599999f,0.64760000f,-0.57889999f,-0.34899997f,-0.36380001f,0.02419999f,0.24819997f,-0.52290001f,1.56970004f,0.39280000f,0.05310000f,0.31950004f,0.17359998f,-1.07619998f,1.32590003f,-0.85900000f,1.38539998f,0.03720000f,-1.98709994f,0.62179998f,0.47570001f,1.11309999f,-0.00259999f,0.26320005f,-1.85930000f,-0.43379992f,0.29849996f,-0.79499997f,1.45889993f,1.28239997f,-0.46469998f,-0.89359999f,-0.71220000f,0.78720000f,-0.35790001f,0.00329999f,0.00340000f,-0.49420003f,-0.50799999f,0.45680003f,-0.41610000f,-0.59640001f,-0.17390000f,-0.49780000f,0.85949998f,-0.20480002f,0.62610000f,0.39879999f,-0.24189999f,-0.04329997f,-0.01840001f,-0.41529998f,0.63709998f,-0.31689999f,-0.98139994f,0.53569997f,-0.20990000f,0.70859999f,0.35630000f,-0.09010001f,0.27010001f,0.03600005f,-1.55349999f,1.28660003f,-0.06200003f,-0.89320000f,-0.45789999f,0.37670003f,-0.19410000f,1.40860001f,0.03220002f,-0.37720002f,0.35830001f,-0.39970000f,-0.08480000f,1.55799998f,-0.07999997f,-2.06290002f,0.09170000f,1.01650000f,-0.62630002f,0.24600000f,-1.64330005f,0.07199999f,-0.16819999f,0.71750000f,-0.68460002f,-0.15229999f,-1.36970001f,-0.01539996f,-0.11389999f,2.14619996f,-0.54669995f,-0.32950001f,-1.09389993f,-1.04810004f,0.85610000f,1.11139998f,-0.50849997f,0.13330000f,-0.65929998f,-1.57409998f,-1.10460001f,-0.00490003f,-0.65480001f,-0.21939996f,-0.94200002f,0.88399998f,-0.40610000f,-0.12549999f,-0.61140001f,-0.00530003f,-0.22929999f,0.09350002f,0.37020003f,-0.76560000f,0.87110003f,-0.21910002f,0.07829997f,-0.09070001f,0.16720003f,-0.36440000f,-0.06880002f,0.07840002f,0.00120000f,0.85580002f,-0.08380000f,-1.10589996f,1.13899998f,1.04329999f,-0.21890003f,-0.16409999f,0.07590004f,-0.17319997f,-0.23530001f,1.31810000f,-0.30270005f,0.91850001f,-0.96870001f,-0.28709997f,-0.63560005f,1.88010005f,-0.88680000f,-1.09210002f,0.74480004f,-1.10570006f,0.41490001f,0.92410004f,-0.55600002f,-0.99730002f,0.47760001f,-0.16000004f,0.82459999f,0.66630002f,-0.68790002f,-0.10540000f,-0.91079998f,0.74190001f,-0.31369998f,-0.32360006f,0.43059995f,0.63710001f,-0.12140001f,0.84349996f,-0.90790001f,1.68569998f,-0.21709998f,-0.65590002f,-0.95400004f,1.26890004f,0.33630003f,-0.61909999f,0.27269999f,1.29310003f,1.43270004f,-0.04720003f,-1.09519999f,-0.59230003f,-2.04200003f,-0.08480001f,1.94660006f,0.06570000f,-0.97960003f,1.27200001f,1.17830003f,-0.38820000f,0.14850004f,0.76950000f,-0.84380000f,2.04579996f,0.07799998f,-1.09260000f,-0.10460001f,1.13479996f,0.71989999f,-1.80519997f,-0.39509998f,1.65349999f,-1.26970004f,0.76360000f,0.21939999f,-0.84780003f,-0.42580003f,0.93170002f,-0.41300001f,1.21580000f,-0.51469999f,-0.03620000f,-0.03270002f,0.53500005f,-0.19800003f,0.47359998f,-0.22640001f,-0.26090004f,0.28639999f,0.21320000f,-1.39670005f,-0.48690001f,0.08779998f,0.59329996f,1.24460004f,1.07600005f,-1.18380000f,0.11640000f,-0.00520002f,-0.26189999f,0.12119999f,0.63370001f,-0.81680005f,0.99260000f,0.00950000f,-0.70160003f,0.90219999f,0.12599997f,-0.07690001f,-0.12359998f,-0.06960001f,-0.12510003f,-1.85350003f,1.21359999f,0.69870003f,-0.31869999f,0.95820004f,-1.17920004f,-0.02309999f,0.12590001f,1.25570004f,-0.64890007f,0.17200004f,-0.76120006f,1.89520005f,1.40910002f,-1.17449997f,0.02330006f,-0.95100002f,-0.21649996f,1.39440002f,-0.05840001f,1.00680001f,0.71869995f,1.82390001f,-0.32630000f,0.20970003f,-0.05910008f,0.05749997f,0.10950000f,-0.30040000f,-1.01179998f,-0.41209997f,0.50369999f,-0.37400000f,0.28540004f,0.15750005f,1.14759997f,0.84800004f,-0.97350003f,-0.96310000f,0.43779999f,0.26820003f,0.40349997f,-0.36649999f,0.60650003f,1.16979999f,0.56319999f,-0.32950007f,0.91280000f,-2.75090001f,-1.21719998f,0.22040002f,0.33670002f,-1.34429997f,-0.14649999f,1.09509995f,0.32169998f,-0.84509998f,0.15620001f,0.47450000f,0.76949996f,-0.62380003f,0.16630004f,-0.90039998f,0.30079998f,-0.55279999f,-0.10509996f,-0.37739997f,0.39949993f,-1.02449999f,0.58439994f,0.13939999f,0.09620002f,1.20229998f,-1.62840002f,-0.98530004f,0.71109999f,-0.41079999f,1.31960001f,0.65970004f,-1.40370003f,-1.02780005f,1.20799997f,0.35620002f,-0.25240002f,-1.21370002f,-0.82390002f,2.16790004f,0.26899998f,-0.42539999f,0.92140002f,-0.94280001f,-0.01030000f,-0.43140003f,-0.99719997f,-0.81689997f,0.92840000f,0.63549999f,-1.06029997f,0.02880002f,0.32619997f,-0.01170001f,0.28069998f,-0.25300001f,-0.69149999f,0.79150001f,-0.78990006f,-0.71990002f,-0.31880003f,-0.74750002f,-0.46970000f,-0.96489999f,0.52480002f,0.20400005f,-0.17870002f,0.25830000f,0.73310000f,-1.38210003f,-1.22390001f,-1.04389999f,-0.84739999f,-0.54039996f,-1.46079998f,-0.14129999f,1.69750008f,0.98419999f,-0.66880005f,-0.97150001f,0.28110000f,-0.00220001f,0.61270002f,-1.07359999f,0.37130000f,-0.90880000f,0.80520000f,-0.05249998f,-1.65409999f,-1.00629999f,1.16799999f,0.74350001f,0.03900000f,-0.40310004f,-0.38249999f,-1.79190000f,-0.52850002f,-1.39740001f,-0.53210004f,0.22900002f,-0.83829999f,0.20440002f,0.65839994f,-0.48310002f,0.55550004f,0.42119997f,1.16610004f,0.12279996f,0.11279994f,0.24580001f,-0.96589998f,-0.86199996f,-0.60169999f,1.73789994f,-0.57830001f,-0.96930000f,2.05450004f,-1.09250002f,0.16200001f,0.97009998f,-1.87810003f,1.31039999f,1.73410004f,-0.49599999f,-1.12190002f,0.45240000f,1.13470002f,-0.67669999f,-1.38850003f,-0.72870000f,-0.13790001f,-0.81520000f,1.14740004f,0.10990001f,-0.32680003f,-1.10410000f,0.50929999f,-0.03149999f,-0.90070002f,-0.51390001f,0.28100002f,0.17049998f,-0.91970001f,1.22039994f,-0.65289997f,0.19089998f,-0.00590003f,-0.17199997f,-0.53930003f,0.31810003f,-0.36100001f,-0.47999997f,-0.47770000f,0.82730003f,-0.42990001f,0.20370001f,1.06240003f,-0.27919999f,-0.70110003f,1.02090004f,-0.24900002f,0.48160000f,1.18900004f,-0.67300001f,-1.65970006f,0.18440000f,0.03580002f,0.08240000f,-0.39850002f,-0.87070004f,0.31010003f,-0.45399999f,0.25789999f,0.39200005f,-0.52660005f,-1.24220002f,0.25810003f,0.20139999f,-0.73489999f,-0.00490000f,0.68450000f,0.59279997f,-0.86150004f,0.06429999f,-0.94760001f,0.88110001f,-0.18580002f,0.44030002f,-0.22380001f,-0.34650000f,0.10260001f,-0.34820001f,1.70150000f,0.00480002f,-1.15210000f,0.48899999f,-1.24520003f,0.01849999f,1.04170002f,-0.74130002f,-0.89770000f,-0.67420001f,0.58340000f,-1.31630004f,0.40940001f,-2.17640003f,0.24120002f,-0.66730002f,0.19870002f,1.55420004f,-0.61830003f,0.85020004f,0.20990001f,0.68120000f,1.02050000f,0.10140000f,-0.10140001f,-0.26029998f,-1.09069999f,-0.79890002f,0.50310002f,-0.71910001f,0.53670003f,0.00060000f,0.34730002f,-0.16420000f,0.73399995f,-0.16430000f,-2.14230001f,1.09139998f,0.73660001f,0.16049999f,-1.09139998f,0.62929997f,0.61619997f,-0.11700000f,-0.40510000f,0.53620002f,-0.88370004f,-0.76679997f,0.48190003f,0.29330002f,-0.06370002f,0.40060004f,0.36940000f,0.16580000f,-0.41310000f,0.77300002f,-0.01070001f,0.59160004f,-0.33250005f,1.78359995f,-0.73809995f,-0.61420002f,0.73129998f,0.46959998f,-0.29789999f,-0.62309996f,-0.79759996f,0.80369998f,-0.04410002f,0.94790003f,-0.03559998f,0.13920000f,-1.43500002f,-0.08110000f,2.02600002f,-0.83589999f,0.10380001f,0.43729999f,-1.21740003f,0.49559999f,0.87990004f,-0.12689996f,-0.24109998f,-0.07320001f,0.21510005f,1.58139996f,-0.34950001f,-0.66930001f,0.01489999f,-1.00670000f,0.11230002f,0.55290004f,-0.66380003f,0.31759999f,-1.26499992f,-0.82239995f,0.63530004f,0.23919993f,1.05839999f,-0.07520003f,-0.65760002f,0.46909999f,-1.23249999f,-0.19930000f,1.06680002f,0.07870000f,-0.40799999f,0.67839999f,-0.33569997f,0.63210000f,-0.01769999f,0.38589999f,0.46869996f,-0.12469998f,0.02360004f,-0.08360005f,-0.23190001f,-0.07550001f,0.56970005f,0.42659999f,0.61810002f,0.12310000f,0.80349999f,-0.28130001f,-0.66780001f,-0.09669996f,-0.36910005f,0.29090001f,0.33030002f,-0.41600004f,0.92500004f,-0.39550006f,0.36040000f,-0.65559999f,0.90739998f,-0.24979997f,-1.63140002f,-0.79029996f,0.77550001f,1.92749996f,-0.83550002f,1.61910003f,-0.63660004f,1.23460004f,-0.24700002f,0.56720002f,0.56010001f,-0.42390000f,-0.38710003f,0.06309999f,0.22710004f,0.33470000f,0.41639997f,1.30729998f,-1.06029996f,-0.62469999f,1.44540001f,-0.05569998f,-1.51819999f,-0.71339999f,1.71490001f,0.83129999f,-1.55449997f,-0.96570000f,1.04539998f,-1.44330004f,0.98500002f,-0.66329997f,0.00200003f,2.10090007f,-1.15200002f,0.65940002f,-1.56220002f,1.09970001f,-0.26610001f,-0.07520003f,-0.11369997f,-0.69739995f,0.23270006f,0.51759998f,1.19760004f,-0.89500003f,-0.53339995f,1.10110003f,0.42240000f,0.55240003f,-0.39539997f,1.09060003f,-0.21710000f,-0.78120002f,-0.22239997f,-1.13829998f,-0.35570003f,0.60320000f,-0.52490001f,0.19910001f,-1.28569998f,0.26850003f,-0.23759999f,-0.23439998f,0.36559997f,0.48490001f,0.93260000f,0.97210001f,-1.70169995f,0.87450003f,-0.35810004f,-0.63969997f,0.01969998f,-0.79610002f,0.66219999f,-0.49520001f,1.79510001f,0.35780001f,0.59480001f,-0.51310003f,0.14040005f,-0.50569999f,-0.68539996f,-0.96740000f,-0.17260000f,0.15800000f,-0.02120004f,-1.25670003f,1.64790002f,-0.29360001f,0.34860001f,-0.13470000f,-0.65780002f,0.32399998f,0.31830004f,-1.47059996f,-0.06269996f,-0.95879998f,0.86910000f,-0.20240001f,0.10680001f,-0.11199999f,-0.60180001f,-0.75870000f,0.52290000f,-0.52210000f,-1.12030002f,-1.40460000f,1.07570001f,0.31220000f,-0.49370001f,-0.22209999f,-0.43160003f,0.52850002f,-0.44290000f,-0.97860003f,-1.13399997f,-2.00269998f,-0.89409999f,1.03409999f,0.93220000f,-1.57850001f,-0.97009999f,-1.01910001f,-0.46790000f,0.16519999f,0.06260007f,-1.31029998f,1.61479998f,-0.84760000f,-0.52599995f,-0.70059996f,0.24190001f,-0.84430001f,0.83270000f,-0.30019999f,-0.13769998f,-1.29010003f,0.71579999f,-0.31409998f,0.23229999f,0.35079999f,1.43940001f,-0.16089997f,-0.79579997f,1.04670002f,-0.59680001f,-0.38220000f,-0.20159998f,-0.10879998f,1.61900005f,0.83849999f,-0.40270006f,-1.59840003f,0.16550004f,0.10389998f,0.88830000f,0.85260001f,-1.04810000f,-0.14149998f,0.10490003f,0.37570001f,-1.55360000f,-1.25840002f,1.32610000f,0.41609998f,0.45229997f,-0.20280002f,-1.17760000f,0.75710000f,0.62879998f,0.33620001f,-0.26230001f,0.17830000f,-0.30159998f,-0.25790000f,0.68730001f,0.03910001f,-1.29589998f,-0.92469999f,1.58399996f,-0.15200000f,-0.85139997f,0.67199998f,-0.28430001f,0.82300002f,-0.52270003f,1.11559999f,0.08839999f,0.19350002f,-0.74970000f,1.57340001f,0.32579997f,-0.26639999f,0.87050000f,0.40090000f,-2.18920001f,0.40820000f,0.15259999f,1.35570000f,0.24179995f,0.79179998f,-0.63300000f,0.52860000f,0.60499997f,0.07860000f,-1.16339999f,0.23999999f,1.91999997f,1.36460002f,-0.68750001f,0.64450003f,-0.93449999f,-0.10029998f,-1.68110003f,-1.12240003f,-0.99550000f,-0.28139998f,0.23339995f,-0.38739999f,-0.12309997f,-1.50850001f,-1.07669996f,-0.20909997f,-0.94949999f,0.97910003f,-1.68020004f,1.77620006f,-0.13179994f,-0.40879996f,0.42830003f,0.64939993f,-0.39270003f,-0.62410004f,0.82789996f,0.69830003f,-0.14210001f,0.75910003f,-0.27559999f,0.76610004f,-0.57780005f,-0.33380002f,-0.79189992f,-1.61589998f,1.10219998f,0.77429999f,-1.49180000f,0.04740001f,-0.12600002f,0.19269999f,-0.63889996f,-0.09199997f,-1.07360005f,-0.87800004f,1.00390003f,-0.49650003f,-0.56260000f,0.13179996f,0.66260003f,-1.40749997f,0.75870003f,0.16399997f,-0.62769995f,-1.44079998f,1.93680001f,0.60749995f,-0.45890003f,-1.23709996f,0.01189997f,0.85710002f,-0.13590004f,0.59810002f,-1.39760004f,-0.56200003f,0.11810000f,-0.90920003f,0.11010002f,-1.01930002f,0.50490002f,-0.39220001f,-0.62490002f,-0.92690003f,0.23490001f,0.30500004f,-0.30589998f,1.48530003f,-0.21260001f,1.82130006f,-0.35539999f,0.71710000f,-0.34920001f,1.16110000f,0.35650000f,-1.13399998f,-1.47310003f,-0.55939994f,0.20910005f,-0.55650003f,1.03350004f,-0.34520003f,1.27600008f,-1.14679998f,-0.04130000f,0.43779998f,0.77120002f,-0.26359999f,-0.84310001f,0.02659998f,0.15890001f,-0.69970002f,-0.43909999f,0.78759997f,0.77630002f,0.32060000f,-0.02739999f,0.71830000f,-2.00720003f,-0.54740002f,-0.46070000f,1.70240003f,-0.41960002f,0.06690000f,0.35870000f,0.56560002f,-0.43490002f,-0.09880000f,-0.07450001f,-0.91730004f,0.10680006f,-0.89070001f,-0.92619997f,0.84989998f,1.68819996f,-0.33420004f,0.19720002f,-0.41909996f,-0.50980002f,0.84510000f,-0.44960002f,1.16309997f,-1.93859997f,-0.47349998f,0.04519999f,0.68900001f,-1.57559998f,1.28859999f,1.43690000f,-0.00569999f,-1.12700001f,0.85900001f,-0.40240000f,0.36299998f,0.47400000f,-1.14320003f,0.14730002f,-0.31560000f,1.08440002f,0.64929998f,0.02279999f,-0.95430001f,0.10440003f,0.02619999f,0.27910001f,0.49479999f,0.20270001f,-1.32669996f,0.34819999f,-0.26389998f,0.14589998f,-0.26969999f,0.63959998f,-0.20969997f,-1.13480000f,-0.27340000f,0.85540001f,0.34969996f,0.15850000f,0.44530001f,0.56919997f,0.22550004f,-0.47789998f,0.27679997f,-0.76200004f,0.52590001f,0.51920000f,-1.07500001f,0.16780002f,-0.01890002f,-0.55849999f,-1.29990005f,-0.44859998f,-0.77979999f,-0.24940003f,0.35380002f,0.48750001f,0.42350004f,-0.68950003f,0.07460003f,0.26479998f,-0.05840001f,0.54390001f,-0.33359999f,-1.84590001f,-0.94240001f,0.38420000f,1.75879996f,-1.33180001f,-0.29339998f,0.50640001f,-0.26409998f,0.99250000f,0.38589999f,0.17329998f,-0.29380001f,0.94899999f,-0.64480000f,-0.57900001f,0.08420001f,1.68109999f,-0.64579999f,-0.81199999f,0.62079999f,0.56190000f,-0.71179998f,-0.43079996f,0.32220002f,-0.05790003f,-0.85579999f,0.74680001f,-0.63650000f,-0.06720003f,-1.36489998f,0.54680001f,-0.21379999f,-0.62179999f,-0.36640004f,1.05339999f,0.28370002f,0.62939998f,0.68830001f,-0.23830000f,-0.91649996f,1.10969995f,-0.08169999f,-1.31419996f,-0.21119994f,0.44619999f,-0.37040002f,1.29679996f,0.62170002f,-0.42659997f,-0.47360006f,-0.06410001f,-0.49670000f,1.23230002f,-0.63960000f,-0.31819999f,0.20350001f,0.41409997f,0.23730002f,-1.00109999f,0.56420003f,-0.01180003f,1.69020001f,0.82600002f,0.04920001f,0.71190001f,-0.98430003f,0.81820002f,-1.06410005f,-0.51639999f,0.92170004f,0.09810000f,-0.69090000f,1.27400002f,0.80429995f,1.31530002f,-1.43599994f,1.89330002f,-0.97619996f,1.01459998f,-2.16109999f,-1.18539995f,-0.03289997f,0.92039998f,-1.24940001f,0.24560002f,-0.38000002f,-1.13749997f,0.52500000f,0.08869995f,-0.34909999f,1.81300004f,-0.78550000f,-0.28120002f,0.50080004f,-0.42520000f,-0.91049999f,-1.10199997f,-0.23159996f,0.31700000f,0.96779998f,-0.77619997f,-1.09589998f,-0.78619997f,-0.56780000f,0.07430003f,0.21930000f,-0.31170000f,-0.28860002f,-0.53589999f,-0.51940001f,0.74349999f,-1.01300001f,1.40580001f,0.42550000f,-0.86809997f,0.79980002f,0.27769999f,-1.02220001f,0.53190000f,-0.88060003f,-0.72250004f,0.50280000f,-0.16240004f,0.08169999f,0.94450000f,-0.00750001f,0.88150004f,0.35179997f,-1.54890005f,-0.80090003f,0.75480001f,-0.46020003f,0.32089999f,0.95479999f,0.34230001f,-0.06670001f,0.01769997f,0.09019997f,-1.05550002f,0.31129997f,1.67640002f,0.13739999f,-0.46760001f,0.23219994f,0.25920003f,0.81500000f,0.77740002f,1.72590003f,0.33500001f,0.94680001f,0.24710005f,1.65230008f,-0.61050001f,0.83520004f,0.71020003f,1.28150007f,1.07380004f,0.07499997f,1.55730002f,-1.70080005f,1.04920006f,0.44209998f,0.15530005f,-0.91960004f,1.79490008f,2.44680005f,0.49630001f,-0.63679999f,-0.51619999f,-0.25390001f,-0.00420000f,-0.19410003f,-0.71449997f,-0.64400000f,0.77699994f,1.19459998f,-2.61390001f,-0.42299999f,0.57749997f,-0.56790004f,-0.48100000f,-1.22770000f,0.74829999f,0.12610001f,-0.16779999f,2.68790002f,-1.75949999f,-0.54150001f,1.27839999f,-0.02900000f,-0.97000002f,-1.51030000f,-0.72819997f,0.93790000f,0.85250002f,1.59440001f,2.09489999f,-1.07369997f,-1.34719997f,0.33310000f,-0.69980003f,-1.03559997f,0.26759999f,0.65749999f,-0.47359998f,-0.54319998f,-0.85240000f,-0.11330000f,-0.95350004f,0.75250000f,-0.00279996f,-0.46999997f,1.46619999f,0.10720003f,-1.70529999f,1.50420005f,-0.31150004f,0.52830000f,-0.69169998f,0.89700000f,-0.12190003f,-0.71750003f,0.16050000f,-0.37540001f,-0.76630000f,-0.15669997f,0.87949995f,-1.09570000f,0.07680000f,1.07510001f,0.31309997f,-0.84330002f,-0.63380000f,0.15040001f,-0.43400003f,0.33820000f,0.06740002f,-0.61800000f,-0.70110000f,-0.10240003f,-0.38859998f,0.17840003f,-0.08660000f,0.66779999f,0.12410002f,-0.82030000f,0.36740000f,0.34090001f,-0.29930004f,-0.05500002f,1.07230001f,-0.54740003f,0.17729997f,-0.43740004f,0.70080002f,-0.76360001f,1.05349996f,-0.68459999f,1.79560000f,0.67630000f,-1.38459997f,0.00059996f,1.08749998f,1.97160003f,-0.04060009f,0.22710002f,0.25629998f,-0.89080001f,0.25739999f,-0.54320002f,0.24239997f,-1.04160006f,-0.11060003f,1.69950001f,0.16769996f,0.58020004f,0.32509995f,1.15569999f,0.30929998f,-0.44220006f,0.39500000f,-0.86820001f,1.29309998f,0.55789997f,-1.09249998f,0.85079999f,0.23950000f,0.42360002f,-0.99399998f,-0.18029998f,0.70569999f,0.26660005f,-0.52410002f,-0.56460001f,1.53279998f,-0.13340003f,0.48460002f,0.70049997f,-0.56999996f,0.86009999f,-1.02859999f,0.52100000f,1.11160004f,0.10750001f,-1.09150003f,0.70740000f,0.61219992f,0.55640000f,0.60419997f,1.16770001f,-0.23080003f,-0.24599998f,0.37569997f,1.04080000f,-0.73710002f,-0.46590000f,0.55550000f,0.66160002f,0.15960000f,0.52090001f,-0.30340005f,1.35609997f,0.04629998f,0.59949996f,-1.25739997f,0.35499998f,-0.38170001f,0.17030001f,-0.27600005f,-0.63470004f,0.22770002f,0.02719998f,-1.68260005f,-0.71070004f,0.99350002f,1.00690003f,0.34870000f,-0.95359995f,0.85990006f,-0.06880003f,0.66659997f,0.26960000f,-1.20240004f,0.16839999f,-0.74979998f,-0.82679998f,-0.49219998f,1.52110002f,0.13600004f,0.94789999f,-0.68019999f,1.35889997f,0.05199998f,-0.44529998f,0.45340000f,-0.42779996f,-0.35590001f,1.09490001f,1.29710003f,0.39280002f,-0.54470003f,0.82979999f,-0.64770004f,1.55859999f,-0.73220002f,0.91720002f,1.36830003f,-1.72150000f,-0.55720003f,0.93480001f,-1.28720005f,0.71270004f,-0.19790002f,0.99060000f,-0.75540001f,-0.59100005f,-0.57019998f,-0.45479999f,-0.71760003f,-0.77620001f,-0.23369998f,0.42240001f,-0.57000004f,1.12310002f,1.23260002f,1.90499998f,-0.53290003f,-0.19260001f,-0.70570002f,-1.77159998f,-0.20540000f,-0.88369998f,0.17150003f,0.89629997f,1.67160004f,-0.46230002f,-1.85730007f,0.49530005f,-1.01520001f,0.66889997f,1.72520005f,-1.03830002f,0.93250002f,-0.36730000f,0.24089999f,0.21750000f,-1.97210004f,0.02260002f,-1.67119998f,0.07890005f,1.19860006f,0.12779999f,1.06559999f,-0.67920001f,0.43559999f,0.29940001f,-0.84700001f,0.28149999f,-2.16029999f,-0.89170000f,1.00629999f,-0.83980000f,-1.24130001f,-0.83790001f,-0.59320005f,-1.56659996f,0.73849999f,-0.69299999f,-0.79440000f,-0.07210004f,0.39439998f,0.85590003f,0.29960004f,-0.71080000f,0.18760002f,0.42919996f,1.64760004f,-1.20269996f,0.82890003f,-1.43869999f,-0.23189999f,0.06129997f,1.33220006f,-0.29860004f,-0.43170002f,0.56139998f,1.79350000f,-0.21740002f,0.22849998f,-1.76380003f,-0.26100002f,0.35650001f,0.65530000f,-1.37420002f,-1.02959999f,-1.56849999f,-0.94750003f,-0.13149999f,0.15950000f,-0.39689996f,-0.17500002f,-1.29679997f,-0.58800002f,-0.54880005f,-0.47040003f,0.63649999f,1.39740004f,-1.46710000f,1.08230005f,-0.59670003f,0.12719998f,-0.34049998f,0.57830001f,-0.09330001f,0.99070003f,-0.42599998f,0.69510007f,0.04489996f,-1.40260007f,-0.86410001f,-0.21500002f,-1.89160007f,-0.94850002f,-1.11929999f,0.84730004f,0.80500001f,0.14370002f,-1.24180002f,-1.01150000f,-0.74570006f,-1.64870004f,0.08370002f,0.71030000f,1.57659996f,0.86449999f,1.17339996f,0.38340002f,1.75949994f,1.00850002f,1.68099999f,0.85329999f,1.86589995f,-0.27910000f,-0.82400002f,-1.60010003f,0.90380001f,-0.92220000f,-0.20809998f,-0.81320000f,-0.21870001f,-1.38330002f,0.10159999f,-1.25650004f,-0.04419996f,-1.19069999f,0.17079999f,-1.00429997f,0.44920000f,-0.71009998f,0.35300001f,-0.83740000f,-0.41659998f,-1.08099999f,0.57090004f,-0.92379996f,0.23660004f,0.21820003f,2.09209999f,0.28660001f,1.64289997f,-0.89060002f,0.44930001f,0.76330001f,-0.92410001f,-1.14150003f,-0.46700003f,0.66610000f,-0.92899997f,-1.00240001f,0.82140004f,-1.34800002f,0.41500004f,0.00889998f,0.65400002f,-0.32370001f,0.36890002f,1.06970006f,-0.40180001f,0.17090000f,-0.94509999f,1.30910005f,0.66589999f,-0.97060002f,-0.78709998f,-0.10859999f,-0.60950003f,-0.25660000f,0.93530003f,0.64490002f,-1.51240003f,-0.33990000f,-0.31919998f,0.37540002f,-0.72419997f,1.24090004f,0.19490004f,0.17149999f,1.66200001f,0.66330003f,0.67770001f,-0.13069999f,0.24590000f,0.11400001f,-0.38359998f,0.50610001f,-0.28369999f,-0.03360005f,-0.75969997f,0.84609999f,0.47710003f,0.43280008f,0.51519998f,0.96950004f,0.04949997f,0.02959994f,-0.40859999f,-0.44760004f,-1.49820003f,-0.30660002f,-0.02399999f,-0.53060002f,-0.22050001f,1.29140002f,-1.09099996f,-0.54950000f,0.38750000f,0.05150003f,1.13010006f,-0.71140000f,-0.29590003f,-0.44930000f,1.13970007f,0.22750005f,-0.76250002f,-0.57270000f,-0.02440006f,-0.02099998f,0.38820003f,0.65160002f,-0.83840004f,0.62400002f,1.02870000f,0.50339999f,-1.33540002f,0.60479995f,0.03390003f,1.46590002f,0.51119999f,-0.56080000f,-0.98559999f,-0.19999999f,0.72879999f,-1.19799999f,0.41729999f,-0.18870002f,-1.40210003f,0.13010000f,-0.26530003f,0.55190001f,0.35780000f,-1.51010002f,-0.63490002f,0.86640000f,-1.34769998f,0.68320000f,0.05400000f,-0.72020001f,-0.17810002f,0.37769999f,-0.92619996f,-0.23300005f,0.36019999f,-0.18179995f,-0.07250001f,-0.76320001f,0.19859998f,0.27050003f,-0.11620000f,1.13289998f,0.01600001f,-0.31499996f,0.31989999f,1.10920000f,0.04229997f,-0.65230009f,-0.18059996f,1.76550002f,0.23719998f,-1.41159998f,-0.14259999f,0.25400000f,2.20470004f,0.60130005f,0.91240003f,-0.48660001f,0.32110002f,-0.15820001f,-1.05219999f,0.32190000f,0.44029999f,-0.37610002f,-1.05259998f,1.47350005f,-1.29440000f,1.11730002f,-1.67710008f,-0.46529999f,0.93859997f,-0.09899998f,-0.35300000f,-0.04940001f,0.45120000f,0.00130000f,0.46940000f,0.35560002f,-0.18339998f,-0.40779995f,1.83770003f,0.61629996f,-0.54689998f,-1.02329998f,0.40290000f,0.80860001f,-0.51140000f,0.18030002f,1.53419999f,-0.71000001f,-1.20700000f,0.52739996f,-0.86129995f,-0.28999997f,-0.35589999f,0.48780002f,0.51460003f,-0.39790002f,-0.64140005f,0.63430001f,0.32289999f,-0.83340002f,0.46150000f,-0.96799999f,0.94579997f,0.23130005f,-0.21040002f,0.11760000f,0.57860002f,-0.77940003f,1.02260002f,-1.04640002f,-0.30729998f,0.33419996f,0.17849998f,0.63949996f,-0.79700000f,-1.96860002f,0.49600003f,0.08850002f,-0.30630001f,0.87079998f,-0.75550000f,0.69469999f,-0.90080002f,0.67710000f,-1.26880003f,1.00280000f,0.54349999f,1.67750004f,1.14150003f,-0.49369997f,2.21430003f,0.77410004f,0.51220002f,-0.30299997f,-0.18580003f,-0.10879998f,0.08530004f,0.59860001f,0.00350007f,1.30770004f,-1.01160002f,0.99430002f,-0.15319999f,0.93270002f,-1.43790002f,1.31840002f,0.82770001f,-0.54220002f,-0.07120000f,0.38040003f,-0.63180002f,-0.70309997f,0.44880000f,0.24230003f,-0.32879997f,-0.71969997f,1.14159999f,-0.83079998f,0.00520001f,-0.38270000f,0.74759999f,-0.28729995f,1.32639999f,0.76500000f,0.63559997f,-0.69980000f,-0.40970005f,0.64500001f,-1.02350004f,0.38880001f,0.03050000f,0.96230005f,-1.27280002f,1.25720001f,-1.65129999f,0.69149997f,-1.23640000f,-0.18790002f,-0.01030000f,-0.08380001f,-0.25959996f,0.68689999f,-0.31490000f,-0.70180001f,0.41540004f,0.47510007f,0.84250002f,0.63190005f,0.78519997f,0.21749999f,0.37120000f,0.01000002f,0.03549999f,0.59920001f,-0.50039998f,0.04470002f,1.99130003f,0.58430004f,1.65209998f,0.70630002f,1.41400001f,0.12100002f,0.81710000f,0.23670002f,0.41000001f,-0.13950001f,0.84429998f,-0.94390005f,-1.30360001f,-1.11300002f,-1.78960004f,-1.35190002f,-0.74219999f,0.00310005f,1.06050001f,1.06029999f,0.84610005f,1.76340000f,-0.40749999f,-0.03249998f,-0.41320000f,-0.29740001f,-0.06129995f,-0.08620002f,-0.84839992f,0.64980001f,-0.24360001f,0.83890004f,0.71410001f,-0.21940000f,0.29749999f,0.11369997f,0.39420005f,0.70820002f,-0.97230001f,0.18239996f,0.05870001f,0.56070003f,-0.90999998f,-0.89500002f,-0.39620002f,-0.38190004f,0.25700001f,-0.53320004f,-0.66800000f,-0.78080003f,-2.07490003f,0.32690001f,0.57649999f,-0.40270004f,-0.09469999f,0.09229999f,0.97900004f,0.35700002f,0.12860000f,-0.36850003f,-1.26439997f,0.08579999f,-0.02130001f,0.50259999f,-0.11660002f,-0.99229999f,-0.19779998f,-0.51660004f,-0.99809993f,-0.13429999f,0.30980000f,1.32520004f,-1.39370002f,0.95900003f,-1.12070000f,-1.01510000f,0.51249999f,1.01840003f,-0.64190001f,0.35409995f,0.16330005f,1.51170007f,-1.09470001f,0.35100003f,-1.14820001f,-0.61129998f,-0.80409999f,0.28850005f,1.10050003f,0.34159996f,-1.87060002f,0.26370002f,-0.31170002f,-0.85200006f,0.34850004f,1.63790002f,1.25580004f,0.16630000f,1.35680002f,0.05110000f,-0.16909999f,-0.76269999f,-0.27219999f,0.36910000f,0.02390000f,0.42020000f,-0.27769997f,-0.78660002f,-0.93019999f,-1.13180005f,0.33549998f,-0.82650002f,0.64260000f,1.23340001f,-0.45820001f,-0.59840001f,0.49060000f,0.18600001f,-1.15360000f,-2.32540004f,-0.66970001f,0.00650003f,0.72290002f,0.56349998f,0.41479999f,0.38489998f,-0.52440002f,-0.51390000f,0.11979999f,-0.07120000f,0.77729997f,-1.06919999f,-0.74580001f,0.60019998f,-1.42049994f,-0.69199998f,0.41870000f,0.00500002f,0.48110001f,-0.53510004f,-0.70350001f,-0.09090001f,0.91570002f,0.43770000f,0.10629998f,0.80830002f,-0.80690000f,0.53450000f,0.30600000f,-0.91310007f,1.41780005f,0.12640001f,0.44010003f,1.02520005f,0.71420002f,1.31660001f,-0.50809997f,0.49510000f,1.08450000f,0.57439996f,0.27199999f,-0.39130003f,0.50649999f,0.30750002f,-0.63520003f,0.65640000f,-0.04840000f,-1.03340002f,-0.22439997f,0.21110000f,0.59450001f,0.87330002f,1.26970003f,0.64710002f,1.52470000f,0.50600001f,0.77440001f,0.95350003f,0.50129998f,1.20260000f,0.57960004f,-0.19240003f,0.86860005f,-0.51040001f,0.54230000f,-1.90100010f,0.97770007f,-0.05739999f,-0.51390002f,-1.39740006f,-0.47809999f,-0.59890002f,-0.98280003f,-2.04900004f,-0.85920004f,-1.84200004f,0.71169997f,-1.19180003f,-0.38669999f,-0.47139999f,0.57270003f,-1.01440001f,-0.29669997f,0.27920000f,0.80770002f,0.22080000f,1.33670000f,0.79569996f,0.43329999f,-0.97990001f,0.08309996f,-0.45010002f,-0.42210000f,1.50389999f,-0.39599999f,0.26000002f,-0.93420001f,-0.83710006f,-0.30019996f,-0.35769998f,-0.71110001f,-0.16319998f,0.51549997f,1.16050002f,-0.28289999f,-0.67999999f,-0.22710000f,-0.94630003f,-1.04670003f,-1.28160000f,-1.54089998f,-0.73429996f,0.16579999f,0.59070001f,-0.92930003f,-0.58039998f,-0.82230000f,-1.57500001f,-0.22119996f,0.77690003f,1.61629999f,0.40590000f,1.96809998f,0.61120001f,1.21879998f,0.07550002f,1.08309998f,-0.26339999f,0.54800001f,0.56939999f,1.00519998f,-2.22090001f,0.10570000f,1.54390004f,-0.82809999f,-1.41110002f,0.23930003f,-0.35150000f,0.77870000f,-0.77820002f,-0.86460000f,0.62420001f,0.77460001f,-0.15280000f,0.77140004f,-0.52710000f,0.81450004f,-0.69960000f,0.35799999f,0.76299999f,0.76660001f,-0.60200001f,-0.22430006f,-0.09550000f,-0.89590002f,0.12990001f,0.21299999f,0.55590004f,-0.71060003f,0.85490003f,-1.37020002f,-0.01140005f,-0.01949999f,0.20039998f,-0.67370001f,-0.28950003f,0.97270001f,0.16120000f,-0.19909999f,-0.57070000f,0.19360003f,-0.50810001f,1.15660004f,1.72960006f,-0.38450002f,-1.31190002f,0.85370000f,0.01309999f,0.57410000f,0.26920004f,1.03130002f,0.67690000f,-1.44229999f,-0.24560002f,-0.09719997f,-1.14299999f,-0.89149999f,-0.59760001f,-0.27269997f,-1.35060002f,-1.81330000f,0.52110000f,-0.20530003f,-1.01420001f,1.13899997f,-1.14620001f,2.04410002f,-1.17040000f,0.93099995f,-0.11239999f,-0.30589998f,0.44640000f,1.26760000f,0.40830002f,0.54520001f,0.06399997f,-0.15220001f,0.54179998f,-1.86230001f,0.30869993f,-0.28439999f,-0.94409997f,0.02729999f,-0.18880000f,0.99080000f,1.35470000f,0.22960002f,-0.88670001f,1.00479999f,-0.96450001f,0.27059996f,1.03620002f,-1.72020006f,-0.46070004f,0.45860005f,-0.42300001f,-0.06289994f,0.39869998f,-0.56310004f,0.20230003f,0.47079999f,0.41419998f,-1.08999997f,-0.62460003f,-0.29840004f,-0.35409999f,0.88380006f,0.08230000f,-0.46609998f,0.25310003f,0.93879997f,-0.33810004f,-0.89269994f,0.68210005f,0.53760000f,1.00109996f,0.91629997f,0.49930003f,-1.58730003f,0.23760001f,-1.84889998f,-0.37940003f,-1.03140005f,0.49350001f,0.40789997f,-0.42960000f,0.61519993f,0.73430002f,0.01430006f,-0.63170002f,-0.39579999f,-0.87570003f,1.34960001f,-0.60850003f,1.12970007f,0.29809999f,0.21340009f,0.48959998f,-0.65789998f,-0.32620001f,-0.16740001f,-0.44650002f,0.19849998f,-1.10340004f,-0.82360000f,-0.96990005f,-0.34710002f,0.08700004f,-0.99230003f,0.93319998f,0.18050002f,1.57590004f,-0.05730006f,-0.84910002f,0.39200001f,0.22539995f,-0.89160000f,1.50809999f,-0.91120002f,0.30399996f,-0.36360001f,0.60030000f,-0.53479998f,-0.23650002f,-1.60500001f,0.15499999f,-0.01289998f,-0.92780003f,0.52970005f,-0.58070005f,0.64490002f,-0.30920001f,0.96610005f,-0.77500001f,1.39419996f,-1.22019999f,1.66330001f,-0.79020002f,1.21560004f,-1.15330000f,-0.54519999f,1.01700000f,-0.12510004f,-0.86340001f,-0.82890003f,0.37969997f,-0.44280000f,-0.17050005f,-1.02969999f,1.26380001f,-1.53090002f,0.47199991f,-0.43630003f,0.46200004f,0.85699999f,-0.59210002f,0.11270001f,-0.55560001f,-0.38420004f,0.74790002f,-0.29169997f,-0.44550002f,-0.19360000f,-0.89490002f,-1.40300006f,0.19420001f,0.18279999f,-0.06450001f,-0.44060001f,0.27530002f,-1.04700003f,-0.34140001f,0.17209997f,-0.45640001f,0.68010002f,-0.58370003f,1.64740003f,1.25230005f,-0.93189998f,0.76650002f,0.29519999f,-0.33730003f,0.67160003f,0.96460002f,0.24669998f,-0.37630000f,-0.61650000f,0.78989998f,0.57039997f,0.26699999f,-1.56070007f,-0.28980003f,-0.89220002f,0.70600002f,0.96980006f,-0.44120000f,0.77050002f,-0.17079998f,1.02310000f,0.03260003f,1.85030003f,-0.06580007f,-0.32500006f,-0.63230003f,1.37760001f,0.53449998f,0.44260004f,1.18730006f,1.33620004f,0.06840000f,0.33269999f,1.06740005f,1.03559999f,0.43500002f,0.31350001f,0.59570003f,0.45670001f,-0.78250000f,1.09570001f,1.43769998f,-0.34070000f,-0.37110001f,0.23219994f,-1.03330002f,0.35919998f,-0.78630004f,0.28810001f,-0.04700000f,-0.94930003f,-0.25690004f,0.07469999f,-0.64780002f,-0.71309998f,0.41350008f,-0.54940006f,-0.23090001f,0.44820002f,-0.03080000f,0.47360002f,-0.20940001f,-0.05589996f,-0.20249997f,-1.49199999f,-0.67739994f,0.72960004f,0.92270004f,0.21490000f,0.53640002f,1.10029999f,0.00940002f,1.03859999f,-0.72490001f,-0.94709998f,0.74820001f,-1.23759999f,-0.34120000f,-1.18669999f,0.37410001f,-0.48239999f,-0.90960000f,-0.97820002f,-1.65630005f,1.40010000f,0.42740000f,0.95560000f,0.09050000f,-0.06609997f,0.36650003f,-0.61790002f,1.03390001f,-1.61439998f,-0.33359999f,-0.23520001f,-0.16670000f,0.41860000f,1.07490000f,1.02399998f,0.46979996f,1.15070000f,1.92629999f,0.44150003f,0.60929998f,0.31050002f,0.18819999f,0.91509997f,0.26240001f,0.49119999f,0.39920000f,0.38180000f,-0.27320003f,0.33209998f,-0.76730004f,-0.90319999f,1.00070002f,-0.67329998f,0.38650000f,0.12230004f,-0.77720000f,0.75369994f,-0.41690000f,0.01820001f,0.00559997f,-0.90289996f,0.72700008f,-0.01600005f,0.37599998f,-0.98799996f,-0.24709997f,-0.88520000f,-0.13399997f,1.21569999f,-0.44540002f,-0.35680001f,-0.30099997f,-1.88400000f,0.68290004f,0.03559999f,-0.65000005f,-0.18790000f,0.74900002f,-1.77519997f,-1.42360002f,-0.18280004f,0.56180001f,0.07029998f,-0.13610005f,0.57769999f,1.20860003f,-0.85129997f,-0.12150000f,-0.38770002f,-0.50390000f,-0.50979998f,0.35610000f,1.50620004f,0.36520002f,-0.11849997f,-0.54239999f,0.00550003f,0.01940000f,-1.29900002f,0.18850001f,-0.43830002f,-0.09329998f,1.24910005f,0.79150001f,-0.21280003f,-1.59990003f,-0.60190000f,-0.83039997f,-1.58240002f,-0.03020001f,0.86680006f,1.65180006f,1.15580005f,1.72290004f,-0.32900000f,-0.09080003f,-0.69350000f,-0.10479999f,-0.27440003f,-0.39960000f,-0.43549999f,-1.11680000f,-1.15309999f,1.03190000f,-1.17069998f,-1.06090001f,0.13940003f,0.06810001f,0.84770000f,0.49930003f,0.58409999f,-0.55660001f,1.62429998f,1.00930000f,0.79120002f,0.27150000f,-0.73989996f,0.57280004f,-1.27619999f,-0.07909994f,0.82160001f,-0.12340002f,0.52769997f,0.70340000f,1.18819998f,0.77359997f,-0.26510003f,-0.30660001f,0.44430004f,1.92800002f,0.85450001f,1.06940001f,-0.04249999f,0.15750000f,-0.18630000f,-0.37270003f,0.03230000f,0.16930000f,-0.38249997f,0.17660001f,-0.53090002f,0.16450000f,0.44399996f,-0.36150000f,-0.33720000f,-0.11340001f,-0.86210001f,0.81570005f,-1.12030004f,-0.37430003f,0.28070000f,0.39610001f,-0.39380000f,-0.29079999f,-1.07020009f,-1.44090004f,-0.32170000f,0.35480002f,-0.46189998f,0.05510001f,-1.15460002f,0.34250001f,0.81750002f,0.51720000f,0.44630002f,0.87180003f,0.33769996f,-0.68170004f,-1.17990000f,-0.34150001f,-0.65819998f,1.20660003f,0.33560005f,0.16869999f,0.76360001f,0.56580000f,0.80999999f,-0.69710002f,-0.60460000f,0.30019999f,-0.81680001f,-0.55310009f,0.78689999f,0.74879994f,-1.86679998f,-0.10570001f,0.40430000f,0.34670002f,-0.00280001f,-2.16779997f,0.78430004f,-0.36810003f,-0.25269998f,-0.05070001f,-1.62490002f,0.68090000f,-0.11879999f,0.12850000f,-0.44870003f,0.56770002f,1.56730000f,-0.60659999f,0.00590000f,-0.72110001f,1.31840001f,-0.63069998f,0.56110001f,-0.45620001f,0.95110002f,0.28780002f,-0.46949999f,0.96880000f,-0.56509997f,0.34179999f,0.35250001f,0.13719995f,-0.47010001f,-0.67610002f,-0.25250000f,1.18290002f,-1.04610001f,-0.83600002f,0.24690001f,0.20590007f,-0.19760001f,0.40569999f,-0.60960004f,0.63600002f,-0.62110002f,1.06720002f,0.15260001f,0.15809999f,0.00470002f,0.39249998f,-0.57140000f,-1.18899999f,0.80419998f,-1.05730001f,0.46240004f,0.67730000f,-1.49939999f,-0.00450001f,0.69750001f,-0.52120000f,1.10520001f,-0.66500004f,0.71110000f,0.02640001f,0.41410001f,0.95230005f,-1.19849999f,-0.81729998f,1.51049997f,0.45040001f,-0.41140002f,0.57929999f,-1.07010000f,-0.07259998f,-0.10640003f,-0.77140004f,-0.71969998f,-0.50920002f,0.21760002f,-0.33220001f,-0.57220001f,0.53300001f,-1.56250006f,0.94500000f,-0.74189999f,-0.24600005f,-1.60230005f,-0.67520002f,-0.08430003f,0.03590002f,0.13789999f,-0.15670000f,-0.41920002f,-0.47190002f,0.14320000f,-1.12910005f,1.87140006f,-1.42490005f,1.66290003f,-0.12489999f,0.22060005f,-0.39590001f,-0.08679997f,0.25639999f,0.47870000f,-0.11030003f,0.42210000f,1.20720002f,-1.44460007f,0.20619995f,-0.86410001f,-0.17990000f,-0.95470001f,1.41759998f,-0.97340000f,0.05050002f,0.89999998f,-0.42869998f,2.92700000f,1.32660007f,0.42410005f,-0.38090004f,-0.56440001f,0.33079998f,0.24810001f,0.17410005f,0.39290002f,1.41990001f,-1.89779999f,1.92420003f,-1.56500000f,0.59069999f,-1.02380006f,-1.08670003f,1.98110000f,0.76840004f,-0.38249996f,1.60989999f,-0.86080002f,-1.80989995f,1.27170001f,-0.24689998f,0.52860003f,-0.11799993f,1.62119999f,-0.36480007f,-0.76810000f,-2.56439994f,-0.22540001f,-0.37649993f,1.16490008f,-1.28330001f,-1.29890001f,-0.49360002f,-1.44690000f,0.38979999f,-0.52979998f,-0.66720000f,0.04619999f,0.46509999f,-1.03160003f,1.01630002f,1.39629999f,-0.95850000f,0.20179996f,-0.73590000f,0.11650002f,-0.51870000f,0.41979999f,-0.04679999f,-0.01670000f,0.08919998f,-0.53429998f,-1.23010005f,-1.42420002f,0.07819994f,0.19710004f,0.22049996f,0.10599997f,0.62889999f,-0.43280001f,-0.20780002f,-0.12949998f,-0.63049997f,0.96389997f,1.32989998f,0.45360005f,0.62170000f,0.98920003f,-0.49160001f,-0.20599997f,-0.18219998f,1.02450002f,0.07870002f,0.32300001f,1.27299999f,0.73700006f,-0.45740000f,-0.42929997f,0.31390001f,0.39299993f,-0.57669998f,0.98709999f,1.02190004f,-1.29120001f,0.86480001f,-1.20620003f,0.19160003f,0.37079998f,0.73780001f,-0.06970001f,0.30079998f,0.28020003f,0.16140000f,-0.97199998f,-0.89939998f,0.29000003f,-0.44270000f,1.60240001f,0.34750000f,-0.70710000f,-1.71279997f,-1.09250003f,-0.01280003f,-0.50919999f,-0.99830002f,-2.12600003f,0.86649998f,-0.77609998f,0.29580000f,1.19640002f,-0.47070001f,-0.07590003f,1.31290003f,0.44400003f,0.72020004f,0.81390005f,2.41550002f,0.71400001f,0.36059996f,-0.04189999f,0.66740000f,-1.10669999f,-0.41519999f,0.56250000f,-0.22890002f,0.79800000f,-0.55890000f,-0.26420000f,-1.22990000f,-0.71469999f,0.36280000f,-0.57649998f,-0.47820001f,0.18180000f,1.11579999f,0.96070000f,-0.50900002f,0.96060003f,-0.65250004f,1.33730003f,1.40570003f,0.28079999f,-0.06690002f,0.42340003f,0.79640003f,-0.11670000f,-0.86730004f,0.03110005f,-0.63869998f,1.38870006f,1.01510000f,0.64159999f,0.37799996f,-0.78140005f,-0.72280001f,0.03069999f,-0.40750002f,-0.69620003f,-1.59960001f,0.07349999f,0.01550001f,-1.13019999f,-0.77470001f,0.59450001f,-0.05119998f,0.25310001f,0.35590000f,-0.54159999f,0.18169999f,-0.72230002f,0.50730002f,0.10529995f,-0.20330000f,-1.61829998f,0.59330000f,-0.02600000f,-0.69940003f,1.61060001f,-0.09070002f,0.30460003f,0.13650002f,0.04459999f,-0.10059995f,-0.59650002f,-0.08600002f,-1.17829999f,-0.19389999f,-0.57560001f,-0.71440002f,0.46369998f,-0.17580001f,0.37570000f,1.01450004f,1.53570000f,0.24879998f,0.14420004f,-0.27290002f,0.04240000f,-0.43930001f,-0.27179999f,-1.24010005f,-0.48069999f,0.23630002f,-1.22320001f,-0.81950004f,-1.42520003f,0.24960001f,-0.46320002f,-0.13140003f,-0.37939999f,0.41380001f,-0.51710002f,0.84490002f,0.67700002f,0.10079999f,0.84180003f,0.83330004f,0.43289999f,1.00180006f,-1.13040001f,-0.38350000f,-0.32039998f,0.45140002f,-0.62290000f,0.43090003f,-0.43320003f,-0.05560002f,0.91030002f,1.28800004f,0.31939998f,-0.57370004f,-1.04210002f,0.58570002f,-1.46199999f,0.31760001f,1.35199997f,1.06840001f,2.31709998f,0.36650003f,0.75240001f,-0.71050001f,-0.53220003f,0.29760003f,0.59559998f,0.54170001f,-2.00240002f,0.14470002f,-0.77720001f,-1.95900003f,0.18510001f,-1.07360006f,0.61319998f,-0.52000000f,1.71389999f,1.09650003f,-0.38080002f,-2.29700006f,-0.33459999f,-0.64399998f,-0.06399998f,-1.78260003f,-0.66140002f,0.42880004f,1.89330006f,1.54050002f,1.31349998f,-0.90900007f,0.34869995f,-1.53819999f,-0.33219997f,-0.71200003f,-1.15089999f,-0.84610000f,-0.97889998f,0.33769999f,-0.83189997f,-0.04710000f,-0.07030000f,-1.14750002f,0.17439999f,-0.48720003f,0.45890003f,1.01760003f,-1.20470001f,1.17700002f,-0.68990000f,0.50450001f,-0.53489999f,0.20720001f,-0.46629999f,0.53940000f,0.64019999f,-0.15679998f,0.89680002f,1.78810004f,-0.43569996f,0.86270000f,-0.83589999f,0.08070000f,0.35260001f,0.21220000f,-0.39199999f,0.27280001f,-0.41400005f,0.21380002f,0.69770000f,0.00560000f,0.97910001f,0.01780002f,-0.59109998f,0.89850003f,0.71940001f,-1.00859999f,1.38890000f,1.30850001f,-0.01239995f,-0.95409998f,-0.21740001f,-1.91720005f,2.11559998f,0.25879998f,-0.04539999f,0.30800002f,-1.40980002f,-0.96620006f,1.29429999f,-0.35660002f,0.07220001f,-0.28430004f,0.27950000f,-0.02089999f,1.13569997f,0.20299996f,-0.09070001f,-0.98300002f,-0.33069997f,0.04380003f,-0.56919999f,-1.06910002f,1.30340000f,0.01580000f,-0.76899997f,0.47029998f,-1.44599997f,-1.25680001f,-1.39169999f,-0.08690000f,-0.38789997f,1.12370002f,0.35050000f,-1.15379999f,1.09299996f,1.30100002f,0.57649997f,2.05529998f,-1.79450000f,0.15269997f,0.12970000f,-0.37709999f,-0.73450001f,0.75999999f,0.55640003f,-0.13360003f,0.77309998f,-1.02899998f,1.00330001f,0.72890005f,0.80970000f,0.23980001f,0.04670002f,-0.56770004f,-0.28929997f,-0.09439998f,-0.24540001f,0.86030002f,-0.71880000f,0.97000002f,-0.44540002f,0.93360002f,-0.70670002f,-0.15580000f,0.66050001f,-0.31699996f,0.27360000f,0.12850002f,-1.00670003f,0.20300000f,-0.88839999f,0.33449999f,-0.23509997f,-0.62409996f,0.64000003f,0.58849998f,-0.32110001f,0.99779996f,-0.91819998f,1.19049999f,0.34650004f,-0.26350001f,1.04939997f,-0.82599996f,-0.42400001f,0.35009998f,-1.50979999f,0.05390000f,-1.20439998f,-1.20190001f,-0.63650001f,0.21220001f,-0.71379995f,-0.81810000f,-0.50289996f,-0.47620001f,1.05050000f,-1.09500000f,0.93679997f,-1.08949999f,1.32399999f,-0.74049997f,0.68199999f,-0.41109997f,-0.46230003f,-0.91310000f,0.47629996f,-0.57750000f,-0.84189998f,0.81069996f,-0.24120001f,0.25719999f,-1.03760000f,0.94299992f,-0.83609997f,1.23749997f,0.00330000f,1.15999994f,-0.11400000f,-0.83980001f,0.55490005f,-0.76699998f,-0.24630000f,0.27870001f,-0.34209999f,-0.33590002f,0.18440003f,-1.14280002f,0.53629992f,0.30190002f,1.12839996f,0.05470003f,1.16009999f,0.15740002f,-0.72330005f,-0.28770000f,0.41009997f,-0.71530003f,1.29040005f,0.56419997f,-0.98779996f,1.29729998f,-1.74069998f,-0.14090003f,-1.45600001f,-1.25489999f,0.89230003f,-0.13130003f,0.29330001f,0.47980004f,-1.25180003f,-1.05770000f,0.39940002f,-0.77859997f,1.38829998f,0.47610001f,0.67509999f,0.02470004f,1.57060003f,-0.64139999f,-0.65709998f,0.87840001f,-0.01109998f,-0.00480001f,1.32400001f,-1.29280002f,-0.49430007f,-0.55930002f,0.10530004f,0.35560000f,0.07119994f,-0.08639997f,-0.31120001f,0.33480001f,-0.12940000f,-0.04300004f,1.00960003f,-0.60020004f,0.22460000f,-0.11870000f,-0.75329998f,0.84930000f,0.13660001f,-1.11850000f,0.54820001f,-0.78049997f,0.34459999f,0.55230004f,-1.10010000f,0.27539995f,0.10730001f,0.26560002f,1.16250002f,0.19920000f,-1.32420001f,-0.43950002f,-0.39719999f,0.98390003f,0.33910001f,0.66520000f,-0.09289998f,-1.08610001f,-0.51860005f,0.45520001f,0.14709998f,-1.05010000f,1.35449996f,-0.36079997f,0.95540005f,0.72040001f,-0.81650000f,-0.47990001f,1.04919997f,-0.50020000f,0.73630005f,0.08079999f,0.10620000f,-0.22700008f,-0.09019999f,-0.52110000f,-1.34119999f,-0.23629996f,0.54639998f,0.63700000f,-0.27380000f,-0.02350002f,-1.06169997f,1.29799999f,1.13659999f,0.78610006f,1.74810000f,0.28700001f,1.40320003f,0.02540002f,0.00650002f,0.31770001f,1.52970001f,-0.52380000f,-0.34680001f,-0.25170004f,-0.40059999f,1.72470000f,-1.57229998f,0.35509999f,0.42889998f,0.46090004f,-0.34760000f,0.66119999f,0.03350002f,-0.67280004f,0.69590001f,-1.25790002f,0.07900003f,-1.46849993f,1.11810001f,0.31499998f,0.08619998f,-1.76839998f,0.25160002f,0.06090002f,-0.16480000f,0.76549999f,-0.13820002f,0.34819993f,2.15920004f,0.02990002f,0.65330003f,-0.44610001f,0.37109996f,0.78960001f,-0.30650001f,-0.13809999f,-0.57119996f,-1.14570003f,-0.60490003f,0.97840003f,0.13309998f,0.11750000f,-0.48130001f,1.33430004f,0.46990002f,-0.23160002f,-0.43159999f,0.27840005f,-0.22249995f,0.99780002f,0.11300003f,0.31759997f,0.79920003f,0.02520001f,1.21370001f,-0.43769997f,0.18660001f,-0.03180000f,-0.61939994f,0.19359997f,-0.35219995f,-0.30160002f,0.00170002f,0.66260002f,0.36010000f,-0.77190004f,1.00630002f,-0.69730005f,1.39740002f,0.70329998f,-0.80039999f,0.59730000f,-1.47299997f,0.53720001f,-0.20669999f,-0.62460003f,-0.10200005f,-0.85240001f,0.21450000f,-0.23830002f,-0.20090000f,-0.71550004f,-1.69730002f,-0.53869997f,-1.37659996f,0.10260002f,0.21840002f,-0.44440001f,-0.49680001f,-0.69320002f,-1.19129997f,-0.22949999f,-1.31219997f,-0.57130001f,-0.82739997f,0.56189999f,-1.11129991f,0.06709999f,-1.04279996f,-0.58719999f,0.38080000f,0.59960002f,0.35609998f,0.98770001f,-0.11520000f,0.56810000f,-0.49169998f,1.02460000f,-1.89579997f,0.01639998f,-0.86859997f,1.45750002f,-0.27880001f,0.89299999f,0.19079996f,0.51969996f,0.22879999f,0.26149997f,-1.64439999f,-0.02670001f,-0.38529995f,1.37470001f,0.20370005f,1.31880000f,-0.82649997f,-0.36689998f,0.16479998f,-0.42430000f,-0.02329999f,0.70890002f,-0.78580002f,0.21049997f,0.43199992f,0.41289998f,1.37859996f,-0.35359999f,-0.61129999f,0.45110003f,-0.74180005f,-0.38650001f,0.94060000f,-0.09890003f,-0.26239997f,0.42640007f,-1.39990002f,-0.67619997f,-0.23990001f,-1.10100002f,0.87269998f,1.05910000f,0.14910001f,0.74460001f,0.81860000f,0.34410000f,0.81200004f,0.11090006f,-0.64239997f,-0.53849997f,0.19889999f,0.54400000f,0.44939998f,0.83090001f,0.77080000f,-0.69629998f,-0.07099999f,-0.11059998f,0.45790000f,1.10000001f,0.17129997f,-0.55510004f,-0.52850005f,0.45260002f,-0.34439999f,-1.98870003f,0.78470000f,0.70939999f,-0.37510000f,-0.09590001f,0.82029999f,-1.22690004f,0.53620003f,0.15050006f,-0.51610002f,0.87970003f,0.17949997f,0.03019999f,1.08150001f,0.90349998f,-0.18760000f,-0.28430001f,0.71269998f,-0.39289998f,1.05210003f,1.31560005f,-0.50029999f,0.09789998f,0.83709999f,-1.10070001f,-0.70220000f,-0.21769999f,-0.47699998f,0.21840001f,0.66110001f,-0.16040000f,-0.12609999f,-0.51650001f,-0.58540002f,1.29300001f,1.27120001f,0.05850002f,1.48859997f,0.97749998f,-0.07429994f,-0.12690000f,0.24689999f,-0.91430004f,1.57340000f,0.88660001f,-0.39119997f,-0.00309998f,1.18600001f,1.50140000f,0.99439997f,-0.56440007f,-0.87030004f,-0.96400002f,0.07349998f,0.37880000f,1.07719998f,-0.09980001f,-1.49579999f,-0.55379999f,1.11399996f,0.69050001f,1.97629997f,0.38380002f,1.00309999f,-0.19649998f,0.50120000f,0.73550000f,1.01219998f,-0.38769999f,-0.47520003f,-0.94540002f,0.16759999f,-1.04990003f,0.50740002f,-2.08940004f,1.75640000f,0.53539999f,0.03680001f,-1.45260004f,0.93550004f,-0.40070001f,0.38829999f,1.34870005f,0.08059999f,-1.22839998f,0.70520004f,0.01720000f,1.27410000f,-0.11080003f,0.23250001f,-0.77659999f,0.68940000f,0.98050003f,0.09690004f,1.20990003f,1.17170000f,0.13710000f,0.98940000f,-0.89210001f,1.11789995f,0.20999999f,-0.72309998f,0.62660002f,-1.31239998f,-0.76250002f,-0.29140003f,-0.04160000f,0.53920000f,1.00960000f,-0.07260000f,0.23259994f,-0.17620000f,1.70889998f,-1.03269998f,-1.47289996f,1.35719997f,1.58159998f,-0.76009999f,-0.34500003f,0.48399997f,-0.17130001f,-0.86690003f,1.50110000f,-0.98149999f,-0.59870003f,0.12149997f,1.29880004f,0.24490005f,-1.02669999f,1.12439999f,1.18900006f,0.23150001f,-0.07160000f,-0.75429997f,-0.42750004f,0.00440001f,0.22490003f,0.19190001f,0.29140002f,-0.20310004f,0.38980004f,0.09760001f,0.51460000f,-0.18269995f,1.01639998f,0.25909998f,0.93600004f,0.26789995f,-0.98770005f,-0.49049997f,0.36290004f,0.33210000f,-0.07240003f,-0.76229995f,-0.39649996f,-1.73530006f,0.42990001f,0.34879998f,-0.67570002f,-0.12300006f,0.14729999f,-0.67820004f,0.84950001f,-0.44599999f,0.11540000f,1.21959999f,0.35610001f,-0.19689997f,0.29209999f,-0.23789998f,-0.06840003f,0.02020003f,-0.43570002f,0.00500000f,0.51970002f,-0.98480001f,0.87120002f,-0.18069999f,-0.40620003f,0.12709997f,0.01260002f,-0.02850001f,0.39320001f,0.06970000f,1.28000001f,-0.34760002f,-1.06559998f,0.81880000f,-0.38890000f,-0.08159997f,1.87390006f,1.15790002f,1.09600004f,0.42120002f,0.15870001f,-0.49270003f,0.70819999f,0.93870004f,-0.13330001f,-0.16569996f,-1.05700003f,-0.02119999f,0.48630002f,-0.74659996f,0.10449998f,0.73470001f,-0.04059999f,0.65270008f,0.03819999f,0.52140004f,-0.51620001f,0.29439996f,0.13560003f,-0.31650001f,0.00830000f,0.36839999f,0.26270000f,0.03709999f,-0.83430003f,-0.75760001f,1.52230002f,-0.95440003f,0.30669999f,0.04730000f,-1.33000004f,0.27970003f,0.13639999f,0.04560002f,-0.15079995f,0.73430000f,0.46029997f,-0.10769999f,-0.98890003f,-1.51630001f,0.10169999f,-0.31129996f,-0.08159999f,-0.08460000f,1.12030001f,-1.08430003f,0.86770001f,-1.13110001f,-0.67610004f,0.43080000f,-0.62119998f,-0.21510002f,-0.58699998f,0.45489996f,0.73220001f,-1.20199996f,0.90329998f,0.38780004f,0.58850004f,0.78840002f,2.37749999f,-0.58960002f,-0.43480007f,0.42610001f,1.20949996f,-0.51199998f,-1.73449993f,0.78529999f,-0.48329996f,-1.72060002f,-0.23290001f,0.59579998f,0.58520004f,0.12410000f,-1.02320002f,-0.31810004f,0.28470000f,0.02009999f,0.65290001f,0.48720004f,-1.17930002f,0.13379997f,0.18510001f,0.06690003f,0.00049994f,-0.26729999f,-0.07560000f,0.32400005f,0.15270000f,-0.17069998f,0.27920001f,-0.33210001f,-0.21060001f,0.25399998f,-0.00250001f,-0.85619996f,0.12530004f,0.88079994f,-1.29000004f,-0.14710000f,0.68380000f,-0.13440000f,0.39390001f,-0.09410001f,0.51739997f,0.27059998f,-0.69360004f,-1.90580004f,-0.32920004f,-1.44440001f,0.12109998f,-1.43139997f,-0.56970000f,1.05180004f,0.08000001f,-0.20380002f,0.27140000f,0.61050001f,-1.38620005f,0.63200003f,-1.05970000f,0.65800000f,-0.87479999f,0.67979997f,0.53480005f,-0.19619999f,0.34369999f,-1.03730005f,-0.17740000f,-0.43690000f,0.76749995f,-0.15910004f,0.40089993f,-0.42480002f,0.00439998f,-0.04990001f,-0.38449999f,-0.94579997f,0.37599999f,1.49800002f,0.36070001f,-1.67800007f,0.23249999f,-2.82840000f,0.37589998f,-1.77220000f,-0.96410005f,0.74620003f,-0.32009999f,-0.90640003f,-0.24600005f,-0.12420001f,-0.59049994f,0.32780004f,0.21690006f,-0.08170000f,0.36949998f,-1.18640003f,-0.52900001f,-0.46639997f,-0.01369999f,-0.92950000f,-0.83710000f,1.03780004f,2.06550004f,0.53229998f,-0.54620002f,-0.46959997f,0.18389999f,-0.80339998f,-0.41550000f,0.35889998f,0.39560002f,0.29990004f,0.38480000f,0.51280001f,0.14130002f,0.56860004f,0.98840001f,-0.98489997f,0.47790000f,-0.10990000f,0.37730004f,0.25279998f,-0.53840005f,0.66000001f,-0.40170002f,-0.24529996f,-0.03510002f,-1.19969998f,-0.50849999f,-2.02279999f,-0.02329996f,0.80720002f,-0.46880003f,-0.89820005f,-0.55010002f,0.89720000f,-0.74210004f,-0.96410000f,0.12290001f,-1.17740003f,0.44379999f,0.18829999f,-0.73050003f,0.15449996f,0.09639999f,-0.87210000f,-0.11329999f,0.27120001f,-0.00800001f,1.30970000f,1.00890002f,-1.43190004f,-0.06789998f,-0.14090000f,-0.21260000f,0.42610001f,0.73360006f,-0.91740004f,0.82870002f,-0.36360003f,-1.05580004f,1.29350003f,-0.95970004f,-0.83520002f,-0.55890000f,0.19479999f,0.11170002f,-1.16200004f,-0.33490000f,-0.88110002f,-0.37710000f,0.16939999f,-1.18070002f,-0.45420005f,-0.16480000f,1.53360001f,-0.30820000f,0.71980001f,-0.70289999f,0.05839999f,1.13360001f,-0.06089997f,0.45660002f,-0.63890000f,-0.32889999f,0.19569999f,0.27719999f,1.07920004f,-1.49210008f,2.51620006f,0.68780000f,0.89270005f,-0.83290004f,0.18530005f,-0.05719999f,-0.63160004f,0.46360001f,-0.59810003f,-0.60900002f,0.28090000f,-0.25089999f,1.03200000f,-0.75440003f,-0.80360001f,-1.20130002f,0.28310001f,1.05780002f,1.15780005f,0.69220001f,-0.22999999f,0.36570002f,0.37710003f,-0.39169998f,1.10950001f,0.91089997f,-1.08589997f,-1.06460000f,-0.85239999f,0.43959998f,-0.87089993f,-0.15499999f,0.54189998f,0.43920002f,-1.27330002f,-0.82660007f,0.48690002f,-0.18920000f,-0.83389999f,1.44200005f,-1.05510005f,0.18869998f,-0.63889997f,0.93690000f,-0.84519999f,-1.48920001f,-1.00820004f,-0.90810000f,-1.52549998f,-0.13379994f,0.20190004f,1.24150001f,-1.00559999f,0.12799999f,0.11250001f,-0.22490000f,-0.31329999f,-0.66559999f,-1.14209999f,0.83749996f,-0.10249999f,0.27630000f,0.11829996f,-0.93849999f,0.20769995f,-0.06220001f,0.07950002f,0.92610002f,0.00080003f,-0.55870002f,-0.46950007f,0.35210000f,-0.94989994f,-0.74320000f,0.28289999f,0.41050003f,0.41929999f,0.00509998f,0.12180002f,-0.06540001f,-0.60740000f,-0.41180003f,-0.24580000f,-0.88519999f,-0.35059999f,0.86190004f,1.57990005f,0.49699999f,-0.69930001f,-0.81230000f,-0.85980001f,-0.69060000f,0.47960004f,0.61370003f,-0.42630001f,-0.72240003f,-1.76350002f,-0.36370001f,-1.42549999f,-0.75880000f,-0.95219997f,0.98580004f,0.25470002f,-0.85120004f,0.60810002f,0.29240000f,0.14000003f,1.37870006f,-1.13760002f,1.25610006f,-0.91530003f,0.81050000f,0.17189998f,0.35360000f,-1.19489999f,-0.61280004f,0.60080001f,0.53240002f,-0.02889995f,1.61710006f,-0.40189996f,0.96010001f,-0.16160000f,0.99769998f,0.23629998f,-1.27440006f,-0.75059998f,0.47840006f,-0.48310001f,-0.58370002f,-1.60039999f,-0.96770000f,-2.42799998f,-0.44210000f,-1.69190000f,0.78100003f,-0.22390001f,-0.84880001f,-0.42870002f,0.40649998f,-0.29069999f,0.70860001f,0.28209997f,0.43179993f,-1.23549997f,-0.01730001f,0.45379995f,-0.03890002f,-1.25390000f,0.25210001f,1.00739995f,-0.56080003f,-1.43509999f,1.12130000f,-2.13420003f,0.11740000f,-0.46499996f,0.23670003f,1.47900006f,-0.43260002f,0.10150004f,-0.82170001f,0.81300000f,-0.30510001f,-0.14949999f,0.84890002f,1.62640000f,0.02580005f,-0.23970001f,0.32319998f,0.03209998f,0.08960000f,-0.13430002f,-0.27220002f,0.84609999f,0.43350002f,-0.81989999f,0.19619998f,-1.00080003f,-0.87499999f,-0.43289999f,0.49950004f,0.12170000f,-1.68500003f,0.60899999f,0.00599996f,-0.47979996f,-1.70930001f,0.75529998f,-0.32229995f,1.10080001f,0.31630001f,0.53910001f,-1.00460000f,0.36900003f,-0.76480004f,-1.65389998f,-0.72440001f,-0.70350002f,0.08300000f,-0.47290003f,0.46080000f,0.44050004f,0.81100001f,-1.39260002f,-0.54490000f,0.75649995f,-1.14429998f,0.32519996f,0.04810003f,-0.76740000f,-0.02660002f,-0.50409998f,0.00239998f,-1.03020000f,-0.68769997f,1.05830000f,1.23069995f,-0.22169998f,0.64719995f,-0.27019998f,-0.20380003f,0.31460002f,1.28330003f,0.29789999f,1.16980005f,0.17860001f,-1.00530001f,-1.40280003f,0.39629998f,-1.92459996f,-1.00160002f,-1.11700001f,0.13190001f,-0.02680000f,-0.27580001f,-1.16559999f,-0.61670003f,1.55599999f,-1.13790000f,0.51439998f,-1.23460000f,0.39659996f,-0.65789998f,0.53520001f,-0.25150000f,-0.02140000f,-0.71160002f,0.05599999f,-0.72260000f,-1.25439998f,1.28979995f,-0.53139997f,1.00969996f,0.05219996f,-0.25220002f,-0.49329997f,1.42109999f,-0.49450000f,0.55529999f,0.44529997f,0.42399996f,-1.36480003f,-0.54490002f,0.69670000f,0.17450000f,-0.30250004f,0.98380000f,-0.03109996f,-0.36889998f,1.51280001f,-0.01570001f,-0.73989999f,-0.12390002f,1.11630003f,0.27400001f,0.08700007f,0.18639998f,-0.99180005f,0.32920002f,-0.32479999f,0.56110001f,0.12839997f,-0.36560000f,0.14869998f,-0.87529999f,-0.38500003f,0.03720003f,-1.33440001f,0.88899999f,1.30360001f,-0.83539996f,-0.02210003f,-0.21460002f,-0.12799995f,-0.00170002f,0.42479999f,0.90659996f,0.62100003f,0.49110003f,0.50920000f,1.14350000f,0.44160003f,-0.51490000f,-0.14930000f,1.16999999f,0.14800001f,-0.69179998f,1.04429998f,0.51219997f,-0.58310001f,0.60350001f,-0.11000000f,0.02380000f,0.79480001f,-0.14569999f,0.66000000f,0.31060001f,-0.13059999f,0.14549998f,0.37180002f,-0.98300001f,0.39000001f,-0.79459997f,0.47880001f,-0.05109998f,-0.61740001f,-0.49560003f,-0.33569998f,-0.17339998f,-0.19300000f,0.50250000f,-0.48109999f,0.31289999f,1.31030001f,0.12470000f,-0.33019993f,0.37840000f,-0.22859996f,-0.13900001f,-0.80370001f,-0.39260005f,-0.54269996f,-0.88810003f,-0.40240004f,0.37670001f,-0.27619999f,0.09110001f,-0.59650004f,-0.59320000f,1.36999998f,-0.75100001f,1.47620002f,-1.49260002f,2.23420002f,0.13900001f,-0.79379998f,-0.11140004f,-0.67740000f,-0.90020001f,1.41849998f,-0.77940002f,-0.54119999f,-0.97020005f,-0.53670000f,1.56709997f,-1.81540003f,-0.97209996f,-0.03379997f,0.86589999f,1.11180003f,-0.66020000f,-0.46919999f,-0.31220003f,-0.74869998f,-0.09409998f,-0.65319996f,-0.26340002f,0.10169994f,0.97490002f,0.01559997f,0.39479999f,1.19040002f,0.49250002f,-0.31689998f,1.18930003f,0.50350003f,-0.53440001f,-0.08340000f,1.78860005f,1.00240000f,-0.52300005f,-1.08200004f,0.08700001f,-2.08349999f,0.44050003f,-0.53849996f,1.15790003f,0.56900000f,-0.02299996f,0.27599997f,0.36319998f,0.09939998f,-0.21369998f,0.36809998f,0.29620002f,-0.31210004f,1.54580003f,-1.48850001f,-1.65120007f,0.32880002f,-0.02389998f,-0.10580006f,-1.05120003f,0.43280003f,0.68830004f,-0.64460003f,-1.25570005f,-0.30180004f,-0.49400006f,-0.18200000f,0.13400004f,1.64260008f,1.25660003f,1.39590005f,0.82290005f,0.93560004f,0.42759998f,0.19859999f,0.23720001f,0.20009999f,0.55010000f,0.62700000f,-0.21889998f,-0.12670000f,-0.39560002f,-1.68629994f,-0.57220002f,-0.25949998f,-0.47010003f,-0.17419998f,1.51309998f,-0.12849997f,0.00510001f,-0.88760002f,-1.22880003f,0.63559998f,1.62270002f,-1.71400000f,1.17810003f,-1.19660000f,0.18609998f,-0.17599997f,0.29680005f,-0.36499999f,-0.18179998f,0.46090002f,0.97850000f,-0.05649997f,1.17060001f,-0.68979999f,-0.03120002f,-1.63640002f,-0.46589999f,-1.48190003f,-0.80280000f,-0.43310000f,-0.56750003f,-1.52759997f,-0.26950001f,-1.78899994f,-0.96470001f,-0.73779999f,0.67569998f,-0.68149997f,-0.64440001f,-0.83309999f,-0.48590001f,0.85800001f,1.18950003f,-1.27159999f,1.36370004f,-1.10570003f,1.13960000f,-0.36009998f,0.29120002f,-1.08259998f,0.52970000f,-0.40700001f,1.01260003f,-0.05110003f,0.83150001f,-1.39619999f,1.17979999f,0.33250000f,0.54259998f,-1.29550002f,-0.53080000f,-0.49249998f,1.18270002f,-0.15069998f,0.36190000f,-0.88000000f,0.87240003f,-0.12400001f,-0.59950004f,0.27190000f,0.63550004f,-0.01169999f,0.41690001f,1.05419999f,-0.72560000f,-0.23069999f,0.34610000f,0.96600002f,0.70290002f,-1.28959999f,-0.44240000f,0.17879997f,0.69050002f,-0.51790003f,-1.49510004f,0.94100001f,0.08609998f,0.47710000f,0.22520001f,0.11759997f,-1.48930005f,-1.22910000f,0.35710007f,-0.56240001f,-0.65660004f,0.80469999f,-0.28049999f,0.44380002f,0.80340001f,0.08329999f,0.29749997f,0.83030001f,-0.50689998f,1.13119998f,0.57410001f,0.15780000f,-0.86309997f,0.25979998f,0.63639998f,0.06720003f,0.24880000f,0.47359997f,-1.23530002f,0.24429999f,-0.91290005f,1.75540001f,-0.58930002f,1.12270000f,-0.18410002f,1.17009999f,0.25019999f,-0.03359997f,-1.07800002f,0.50240002f,0.81580002f,0.51779998f,-0.35250001f,0.29319998f,-0.61180001f,1.34389998f,0.15909998f,-0.54940001f,-0.97539999f,0.60719998f,-0.22230001f,-0.29149999f,1.42890000f,0.02840001f,-0.48569998f,0.32940002f,-0.01929998f,-0.29390000f,-0.93860000f,-0.32440002f,0.16790002f,-1.48899999f,0.16779998f,-0.42190002f,-0.19000002f,-1.07999999f,-0.30880004f,0.35509998f,-0.30370002f,1.18640000f,0.08059999f,1.53330002f,-0.08760001f,0.35130000f,1.66460006f,-2.20050002f,-0.93489997f,0.31510006f,1.40230002f,1.22210003f,0.88700000f,1.88430002f,1.03540001f,0.79499999f,0.64269997f,0.36919999f,-0.06319998f,-1.02300000f,0.75640005f,0.71859996f,-0.55660001f,-0.51299999f,0.52359998f,-1.47809997f,-0.41019994f,-0.05890002f,-0.87070004f,0.73079996f,0.17250000f,0.02179999f,-0.37220001f,-0.78179999f,-1.39019997f,0.35770003f,0.42459999f,0.67780000f,0.43199999f,-1.01089999f,-1.06419997f,0.92210000f,1.11079998f,0.63380003f,-0.45269999f,-0.29860001f,0.14640000f,-0.04470002f,0.53370000f,-0.40600003f,0.83850001f,0.84430001f,-0.82460001f,1.14930000f,0.49549999f,-1.50800004f,0.24759999f,-0.79769997f,0.12529999f,0.11469999f,-0.15910000f,0.40080003f,0.70210001f,-0.46589998f,0.44730000f,-0.19550001f,-0.38400001f,-0.33610004f,-0.42200000f,0.26509995f,-0.03429999f,0.31280000f,0.32790002f,-0.60690000f,-0.35139995f,-0.07260002f,0.35980002f,0.03790001f,0.12079999f,0.84720001f,0.77299999f,0.77079996f,-0.61569998f,1.00860000f,-0.01799999f,1.13700000f,-0.64239999f,0.88830001f,0.79400003f,0.91390008f,-1.21140003f,1.95910004f,0.44530004f,0.38470005f,1.13370001f,-1.70489998f,0.52219999f,-0.88210003f,1.13400004f,-1.81590002f,0.60000000f,-0.66330006f,1.23590009f,-0.72370003f,1.77450005f,-0.93719998f,-0.42469995f,1.02119998f,1.11560004f,0.44550001f,-1.24389998f,1.05450002f,-0.15579996f,1.19619999f,-1.72930004f,-0.29359992f,-0.94969994f,-1.66070003f,-0.03680001f,-1.01469998f,0.13750001f,1.01550001f,-0.12189998f,2.36010003f,-1.35690000f,-1.24160001f,1.47330002f,-0.81439996f,-0.32069999f,0.58109993f,-1.12550001f,1.75550005f,1.17350003f,-1.00779997f,0.61509998f,-0.03950003f,-0.52120000f,-0.32320001f,-0.45270000f,0.36609998f,0.78130000f,0.60430000f,-0.18579999f,-1.55850003f,-1.79749998f,0.23640001f,1.21629999f,-0.05669997f,-0.45750004f,0.83319999f,-0.16260002f,0.03529999f,-2.25489997f,1.46010005f,-0.42350001f,0.60920000f,-0.13759998f,0.58459998f,-0.32440003f,-1.03950003f,0.31970001f,-0.15570001f,-0.48280002f,-0.18549999f,0.50519996f,-0.10460001f,1.04280003f,-1.48540002f,-0.25310005f,0.59420001f,-0.46870001f,0.03520002f,0.20610001f,-0.22750000f,-0.81610003f,1.16860002f,-0.67440000f,-0.50070001f,-1.72610000f,1.31620004f,1.27380002f,-0.16110001f,-0.41750002f,-0.05950002f,-0.46680000f,0.33080000f,1.63499999f,-0.94760002f,-0.01770002f,0.60189997f,0.51510000f,0.53479995f,0.19099999f,-0.43840004f,-0.00700003f,-0.49050002f,1.55020002f,0.36680000f,-0.50929999f,0.74569996f,0.79840002f,-0.61029997f,0.46689995f,0.01860008f,-0.48470002f,0.57590003f,0.15900002f,-0.75780000f,0.60509997f,-0.75180000f,0.23669998f,0.52100002f,0.81290001f,0.35140003f,0.53870004f,0.07029996f,1.52579999f,-0.88860003f,0.34450001f,0.10500001f,-0.23219992f,0.72229997f,-0.70870001f,-0.23299999f,-1.10269997f,0.53430003f,-0.03609999f,-0.14019998f,0.18229998f,0.64040004f,-0.05010000f,-0.39270001f,1.22870002f,0.79559997f,0.86640003f,1.58589999f,0.75250002f,-0.27450001f,0.09340001f,-0.04730003f,0.03510003f,0.46119999f,0.40380001f,-0.76240002f,0.78569999f,-0.22949995f,1.20729997f,-0.46209994f,-0.07490005f,-0.00819999f,-0.41850001f,0.74690000f,0.23149999f,-1.02569997f,-0.94310001f,1.14410002f,-0.62689995f,-0.22620000f,-1.17849992f,0.39439995f,-0.06789997f,0.26700000f,-0.39209999f,0.57760000f,-0.39269999f,-0.46820001f,-0.27950001f,-0.69570003f,1.16630003f,-0.16340000f,-1.18650004f,-0.11790003f,0.43560003f,0.76329999f,-1.24069999f,-0.64560000f,1.59779998f,0.81079999f,0.30370002f,0.05969997f,-1.41039998f,-0.41659997f,-0.72219998f,-0.24939998f,0.37339999f,-0.93490001f,0.60480000f,-0.26210000f,0.28600001f,0.14730000f,-0.24889996f,0.61029999f,-0.22530004f,0.60800002f,1.47470008f,-0.74000004f,-0.99210002f,1.86800001f,-0.72949999f,0.19200001f,0.97230003f,0.34270004f,0.92809996f,-0.82289997f,-0.05639999f,0.23019999f,-0.13500000f,0.51960000f,-0.47010002f,-0.95380003f,-0.59840001f,-1.50900001f,-0.13710004f,-1.17900002f,1.25529998f,1.34069999f,-0.70780002f,0.66149999f,0.39930002f,-1.10690005f,-0.56310002f,-0.14070001f,-0.26650000f,0.90440000f,0.12979996f,-0.86649999f,-0.67960000f,-0.09710001f,0.32800001f,-0.26710001f,0.48640000f,0.21499999f,-0.74020002f,1.15669998f,0.28589996f,1.97889999f,0.43130001f,0.23660004f,0.15090001f,-1.38119999f,-0.53409999f,-1.04870001f,-0.44149999f,0.19619997f,0.51069993f,-0.50660001f,-1.18429999f,-0.60500000f,1.28149997f,0.51420001f,0.47130000f,1.07860001f,0.38830001f,0.23199999f,-0.97849999f,-1.30190000f,-1.70660001f,0.32830001f,-0.53060001f,0.74630001f,-0.26290000f,-0.95019998f,-1.20339999f,0.63660000f,0.57809999f,-0.00169999f,-1.05320005f,-0.00749995f,0.24419999f,-1.87210000f,-0.75229998f,-0.76590001f,0.44940001f,-0.66459997f,1.13680002f,-0.94770002f,-0.87659999f,-0.08710006f,1.46989999f,0.60300000f,0.33970000f,0.38250000f,-0.32619997f,0.79200005f,1.03889998f,0.24530002f,0.38950001f,1.75699999f,0.08020006f,0.79200004f,0.29379997f,0.63440005f,-0.39749998f,0.04490002f,0.03719999f,0.04220002f,0.08210002f,0.61700002f,0.68530000f,-0.62360002f,-1.18990003f,0.54400000f,1.43000002f,-0.15810001f,0.72330006f,-0.84060002f,1.41220004f,0.28770000f,0.99869998f,-0.08689999f,-0.78200000f,-1.46349998f,0.87800001f,-0.43290005f,0.44580002f,0.20009996f,-0.94520002f,1.08340004f,0.45159997f,0.67900000f,0.94900000f,1.62460001f,1.21290001f,0.67209999f,-0.42789999f,0.36470002f,0.42009999f,-0.31510003f,-0.42069998f,0.30999999f,0.09790002f,0.37009998f,0.03839999f,0.22789999f,0.20529998f,0.07150002f,0.72230000f,0.05650000f,0.10139999f,0.20019998f,1.37910001f,-0.13780000f,0.02109999f,1.27170000f,-0.30270000f,1.54749994f,0.35109998f,2.29069993f,-0.36840003f,1.93109999f,-0.14040001f,2.25989995f,-0.45779999f,-0.24020000f,-0.73239998f,-0.92369999f,-0.99419995f,-0.61239998f,-1.10729998f,-0.93469998f,-0.74120000f,-0.80400001f,-1.38979995f,-1.14599999f,0.30140000f,0.30429999f,-0.33129998f,0.45270002f,1.29780001f,-0.67389999f,-0.26539999f,0.56640000f,-0.78030002f,-0.04730000f,-0.31590003f,0.51370003f,0.65710001f,1.75739999f,1.03699997f,1.99299995f,0.73340003f,0.15939999f,-0.64150002f,-1.43840001f,1.15130001f,-0.12710002f,0.12549998f,-0.21330000f,0.36100001f,-1.16300000f,-0.68859999f,-0.40520000f,1.17479999f,-0.08410003f,0.49630002f,0.83810004f,0.02499997f,0.29249998f,0.57320001f,1.73150004f,0.14579999f,-0.96880000f,-0.26070000f,0.97560000f,0.25680000f,-0.11210000f,0.36300001f,-0.10559998f,-0.28010000f,-0.16720000f,0.49030002f,-0.61200001f,-1.42680002f,0.60679997f,0.30000002f,-1.39989999f,0.35139999f,-1.25999998f,0.03769996f,-0.42139999f,-1.68720003f,0.61299999f,-1.22329996f,0.45980004f,1.21839994f,0.26710000f,-0.17739999f,-0.03010000f,-0.34529998f,0.02730003f,-1.94450003f,-0.28860008f,1.21789995f,1.00310003f,0.96490001f,-0.30389999f,1.25250002f,-0.27390000f,-0.60430003f,0.27960000f,1.29840004f,0.53990005f,0.98469997f,-1.24069999f,-0.47429998f,0.05029999f,-0.30390000f,-0.27510000f,-0.31340000f,0.87850001f,-0.00250002f,-1.43020001f,0.64250001f,-1.66389997f,-0.43150006f,0.33470003f,0.03980003f,-0.56579999f,-1.15200002f,1.25380001f,0.32250000f,-1.38300001f,-0.54620001f,0.49840000f,-0.26080002f,0.82290000f,-0.36179999f,-0.85970000f,1.02500003f,0.43140006f,-2.06610003f,-0.50180010f,-0.79860004f,0.34280001f,1.19750000f,-0.60779999f,1.38499998f,0.05100000f,-0.64240002f,-0.77680003f,0.17110004f,1.05740005f,1.02089996f,-0.85629997f,1.31770002f,-1.12920000f,0.43539998f,-1.12949995f,0.83979999f,-0.40069998f,-1.53200002f,0.61210001f,1.44980005f,-1.28289999f,-0.10850007f,-0.53509998f,1.92210008f,0.10269996f,0.19880001f,-0.17899999f,-0.20119999f,-0.86360005f,0.62720001f,-0.77279999f,-0.06400001f,0.94999999f,-0.51710001f,-0.54310001f,0.69900000f,0.25660003f,0.73880004f,0.34560004f,0.65070002f,0.10600001f,-1.41979997f,-0.06719999f,0.85339999f,0.26520002f,-0.34189998f,-0.14990001f,-0.04270000f,-0.72749997f,-1.15440000f,-0.74239998f,-0.48150004f,1.77710001f,-1.03629999f,-0.07980001f,1.64850000f,0.05379998f,-0.80100001f,-0.41460000f,-0.35740002f,-1.20820001f,0.15670004f,-0.25089998f,-0.11010001f,0.97640000f,0.66519999f,0.75600002f,-0.68220000f,-0.71780005f,-0.32940001f,-0.38850001f,-0.85630005f,0.10719997f,-0.24680003f,0.03069999f,-0.23350004f,-1.40629999f,-0.06519997f,0.65680002f,-0.64200001f,0.23860000f,-0.49559999f,0.05360000f,0.31399998f,0.27910001f,0.50109996f,-0.26809999f,-0.51729998f,0.09870004f,1.52020006f,0.95639998f,-0.37370002f,0.16879997f,-0.00479999f,-1.09530001f,0.15320001f,-0.47459999f,-1.88190000f,0.65059998f,-1.95440001f,-0.24730003f,-1.46960002f,0.18650000f,0.67300000f,-1.46990004f,-0.23900001f,0.34640000f,1.25120002f,0.38490001f,1.37999998f,0.48030003f,0.92290000f,0.53460002f,1.14760004f,0.07860002f,-1.05779996f,1.05120001f,1.10369999f,-0.17580000f,-0.67089999f,0.25370000f,2.08390004f,-0.76080000f,0.36630000f,-1.22220002f,0.08950005f,0.81629999f,-1.34310003f,-0.45270000f,0.11300001f,1.22250002f,-0.90830000f,0.05629998f,0.54929999f,0.37290003f,-0.14550002f,-1.06020005f,-0.59530002f,-0.22000001f,0.00650002f,-0.77289998f,-1.48650002f,0.70179999f,0.13259997f,-0.33379999f,0.93810006f,0.71010004f,1.04940003f,0.91990001f,1.09629999f,-0.50269999f,-0.09599996f,0.62970000f,1.50869998f,-0.03630001f,-0.03819999f,-0.55739998f,0.52780005f,-0.37760000f,-0.37940007f,-0.69719998f,-0.79790000f,0.40910000f,0.41460000f,-0.42490004f,1.30820000f,-0.69929998f,-1.36519998f,1.17380000f,0.38490001f,-0.30810002f,-0.41379999f,-0.68530001f,-0.44179999f,-0.93500002f,0.17400002f,0.03010002f,-0.72679997f,-1.07360002f,0.19529998f,-1.11330002f,-0.40010006f,0.27669997f,0.55869999f,1.16619996f,0.10430004f,0.64120002f,0.18440005f,0.22300005f,-0.99770000f,0.07610003f,0.44889996f,-1.18660004f,-0.98490002f,0.94130003f,-0.41890002f,0.61190003f,1.26960003f,-0.66300002f,-1.06630001f,0.83780000f,0.28369998f,-0.34199998f,-0.07650000f,-0.76330001f,0.73389999f,-0.86020001f,1.57000000f,0.75140002f,-0.46409997f,-0.94719995f,-0.31430001f,-0.00260003f,-0.88000002f,1.32580001f,0.05290001f,-0.41130005f,-0.02070004f,0.60349999f,0.19259994f,1.27039997f,1.62780003f,0.87029999f,-1.27979998f,0.05180002f,-0.63370000f,-0.52489999f,-0.74389998f,0.30550004f,-0.12040001f,-0.04310001f,0.24749999f,0.22969999f,0.33569999f,-0.28940001f,-1.09300001f,0.23410003f,0.84320002f,-0.41770001f,0.51770002f,0.64790002f,0.56630000f,-0.34680000f,0.20939999f,0.44889995f,-0.62310002f,-0.16420001f,1.40869999f,0.36600001f,0.40020004f,-1.05169996f,-0.30749996f,1.09330002f,0.80530000f,1.62360001f,-0.27629997f,0.36920001f,0.60460001f,0.22440002f,-0.38330007f,0.30899995f,1.88730002f,1.32649999f,-0.54690000f,0.35169999f,-0.29520003f,1.41810004f,1.43700003f,-0.97810002f,-0.69640000f,0.02200002f,0.28480000f,-0.37630000f,-0.13229999f,0.43800000f,-0.50440004f,0.32190000f,0.40159999f,1.95690001f,-0.43079999f,1.63180003f,0.03080000f,-0.22679996f,0.09090003f,-0.30990000f,0.15520000f,-0.24899999f,-0.06209999f,0.58089996f,-1.19420002f,0.54350001f,0.16590004f,-0.94750001f,0.12529998f,0.09440001f,-0.05119999f,-0.33080000f,0.26610000f,0.39510001f,-0.46129999f,0.33549999f,-0.25310002f,-0.66459998f,-0.11020001f,0.04029998f,0.26800004f,-0.56750002f,0.21560002f,0.15130001f,-0.65010000f,0.23980000f,0.31700001f,0.61860000f,0.54869997f,-0.50870000f,-1.32599998f,-1.39649996f,-0.37789998f,-0.07949999f,0.05220001f,-0.47509998f,0.79200001f,-0.88980001f,-0.78450000f,-0.23699998f,0.81509996f,0.36259999f,0.08690000f,0.62089999f,-0.64430000f,-1.50480004f,0.28029999f,-0.50190001f,0.68310000f,0.76690001f,0.76510001f,-0.91170000f,0.70140005f,0.12439998f,0.34590002f,1.13920002f,1.39750005f,0.39799999f,-0.74609999f,0.88000003f,1.14780002f,-0.39700002f,-0.32290000f,-0.02989999f,0.77200002f,-1.27490001f,0.96700001f,-0.40770001f,-0.63329999f,0.36640001f,0.94229999f,1.48720002f,-0.77470001f,0.99629998f,-0.06280003f,-0.20950003f,0.72049998f,-0.05100008f,0.29699998f,0.34869998f,-0.37510000f,-0.89220004f,-0.67130000f,-0.25139999f,-0.37089998f,-0.65490002f,-1.39940000f,0.39020000f,-0.14690000f,0.47270001f,0.09400001f,0.44490002f,0.82559998f,-0.03040000f,-0.18270001f,-0.37759998f,0.59880003f,0.16179997f,-0.40760001f,-0.10869998f,0.58100001f,1.46170000f,1.48759998f,2.19639998f,-0.30339999f,1.05019996f,1.11570000f,0.22669999f,0.43429999f,-0.74500004f,-0.20180002f,0.71620000f,-0.89730001f,-0.02680001f,-0.06399998f,0.53710001f,0.12290004f,0.43680003f,0.65799998f,0.16500002f,0.56590001f,0.48269998f,-0.85039999f,0.28129995f,-0.28410000f,1.01660002f,1.00490002f,0.06259999f,0.63120001f,0.09020001f,0.32490002f,0.07820000f,0.26660003f,-0.03240000f,-0.69890001f,2.07330001f,1.60060007f,0.37159990f,-2.37950006f,0.15380002f,0.28910001f,0.82800003f,-0.28850003f,1.60880000f,0.31680005f,-0.10820002f,0.09029997f,-0.43769999f,0.56290003f,-0.46640001f,1.30420003f,0.35210003f,0.16830007f,-0.70280001f,-0.39510002f,-0.34910005f,1.22740002f,0.54570007f,-0.64829999f,0.38060000f,-0.81450001f,0.00190000f,-0.04039999f,0.18160000f,0.83290001f,1.23690004f,0.02719995f,-1.21030003f,0.02710001f,0.25319999f,-0.20660000f,1.12799999f,-0.89720003f,0.23550001f,-0.26990001f,0.22950003f,0.81909997f,-0.21309998f,-2.05450007f,-0.13049995f,0.75080006f,1.02319998f,0.57820001f,0.79890002f,-0.39289999f,-1.54710003f,-1.03390000f,0.20089998f,0.93149995f,0.55450000f,1.61289997f,0.16720004f,1.59679995f,1.37190000f,0.79420005f,0.65280003f,-0.56759997f,0.37150000f,-0.33850002f,-0.66670001f,-1.88020001f,-0.88450003f,-1.30289998f,-0.58130001f,0.01429996f,-0.36539999f,0.10000005f,0.99739997f,-0.99480003f,0.61789998f,0.50420002f,0.61839999f,-1.10389999f,-0.40530000f,-0.44889998f,0.19330002f,0.36840000f,0.45379999f,0.53339999f,0.17640000f,-1.31039996f,-0.56460001f,1.30590000f,-0.05769997f,0.39739999f,-0.61610003f,-2.01180002f,-0.07099998f,0.92349997f,0.71469999f,1.11200001f,1.36500001f,0.51269998f,-0.56880002f,-1.08209994f,0.64830001f,0.81620000f,0.65920002f,1.45500001f,-0.90900001f,-0.70230003f,-0.33450000f,-0.11449997f,-0.58310003f,-0.56580002f,1.36729998f,-0.38689995f,-0.67819998f,0.00269994f,-1.15190000f,0.52870003f,0.29400002f,-0.74410004f,-1.24740001f,-0.86350001f,1.75010000f,-0.26619996f,0.01230000f,-0.78680004f,0.53670001f,-0.36110000f,-1.03449999f,-0.27750004f,0.16669999f,1.64220003f,0.48440001f,1.13360004f,-1.26790003f,-0.71470004f,0.79520002f,0.53460000f,0.18859998f,0.55320004f,0.71130003f,0.38149996f,-1.59030004f,-0.96990005f,-0.41020002f,-1.62310003f,0.40400006f,1.52180005f,-0.11540006f,0.26740001f,-1.17690001f,-0.30009998f,-1.22829999f,-1.64630009f,0.19500005f,-0.07920000f,1.36070002f,-0.43290000f,0.58709999f,-2.19399999f,-0.16180003f,-0.19949997f,0.79650003f,-0.86259998f,-0.56110001f,-0.51770000f,0.52199999f,0.13169995f,0.48699999f,0.61000003f,0.86880000f,0.50389994f,-0.95560003f,-0.45880003f,0.05929999f,-1.08319999f,-0.41080001f,-0.57100001f,0.08690000f,-0.67310003f,-1.05130003f,-0.49960000f,-1.09740000f,-0.15670001f,0.20190002f,0.77490005f,0.02009996f,-0.34269999f,0.53169998f,1.26920002f,-0.79860001f,-1.22400003f,-0.94029995f,0.26800001f,-0.59600004f,-0.60380008f,-0.19980000f,0.66640002f,-0.35290001f,0.36650000f,0.43480003f,-0.85900002f,-0.45700004f,0.99589999f,0.64620002f,1.21880001f,0.92700007f,0.17300007f,-0.32780003f,0.05979998f,-0.19700000f,1.09110004f,0.34910003f,0.04049998f,-0.84020001f,-0.78460002f,-0.23910002f,-1.05600001f,0.38759994f,-1.13490002f,-1.15179997f,-0.69710006f,-0.27529999f,0.88070004f,-0.36249999f,-0.81670005f,0.52110001f,-0.02980000f,0.05240000f,-1.05430003f,-0.76060001f,-1.38910000f,-0.19679999f,-0.42720000f,0.97040003f,-0.37380001f,-0.07090001f,0.96130003f,-0.30590002f,0.79159998f,-0.03799999f,-0.35330000f,-0.93410002f,-0.89790005f,-1.82320002f,0.21130002f,0.45340004f,-1.36840000f,-0.85920000f,0.55710001f,-1.10660003f,-0.77180001f,-0.52030000f,1.24690001f,-0.49900000f,-0.31520001f,0.13810001f,-0.41450002f,0.20980001f,0.19600000f,-0.27420000f,0.04569997f,0.50319998f,0.12509998f,-0.76130002f,0.25700002f,1.07490000f,-0.20830001f,0.34550003f,-0.24270003f,1.20760002f,1.43819998f,1.61700003f,-0.69340002f,0.23729999f,-0.46020001f,0.68359995f,0.69040002f,-0.95910002f,-0.30750001f,-0.18140000f,-1.07230002f,-0.20380000f,0.07589997f,-0.21180004f,0.15620005f,1.16750005f,-0.60989999f,-0.89839999f,0.87759999f,-0.32939999f,0.47570002f,-0.28379999f,0.63930004f,-0.76060003f,-1.31490001f,0.65460001f,-0.95260000f,-0.63449999f,-0.46870003f,-0.12909999f,-0.56320004f,1.68689996f,0.30740000f,0.67870003f,-0.72799997f,-1.95099996f,-1.04009999f,-1.56369999f,-0.48620001f,-0.45090000f,-0.94639998f,0.33599996f,1.75200001f,-1.08430000f,0.48989999f,-0.48750000f,1.03490000f,-0.33270003f,-0.53129998f,0.35400004f,0.02670000f,0.31830001f,-1.13589996f,-0.20099997f,0.03339996f,0.73670002f,1.52280000f,-0.68380001f,-1.25729999f,0.84119999f,-0.49650004f,0.22550003f,1.43420004f,-1.00590002f,-1.43350006f,1.26540004f,-0.01890004f,0.86239999f,-0.82050000f,0.00150003f,0.38979999f,0.46600003f,1.58210000f,1.59989996f,-0.08310001f,-0.96170002f,-0.14989999f,-0.31800000f,-0.53549999f,-0.73900000f,0.73430000f,-0.51449999f,-1.06140001f,-0.13170001f,0.13330003f,1.06930004f,1.81880000f,0.72699997f,-0.97810000f,0.88540005f,-0.23229998f,-0.33160006f,-0.15170000f,-0.35960001f,-0.28710000f,1.22890001f,-0.30690000f,0.50500001f,0.26709997f,0.03490003f,-0.17920002f,-0.94040004f,-0.78380003f,-2.39500001f,0.53420003f,-1.39930003f,0.36879999f,-0.40870006f,1.62320000f,1.13309996f,-1.07930004f,0.02149999f,-1.19500001f,0.01890000f,-0.35370002f,-0.06140005f,0.42649997f,-0.89890005f,-0.42630000f,0.43960001f,0.38380000f,0.92249999f,0.29430002f,1.23310005f,-0.51039997f,-0.81400000f,0.23859999f,0.29230000f,1.12020002f,-0.27410004f,-0.13010001f,0.29400000f,0.33730003f,-0.43370001f,-0.48819997f,-0.00530001f,-0.93480002f,0.91800001f,-0.38340002f,-0.69320000f,-0.51890001f,-1.64620001f,-0.50609998f,-1.32470000f,-0.51409998f,-1.62629994f,0.32400002f,-2.14639997f,-0.59570002f,-1.00120002f,0.20939999f,-0.04150002f,1.39420001f,0.37319997f,-0.36890003f,-0.68140001f,0.90989998f,-0.43910002f,0.60959997f,0.04389997f,-0.20749998f,1.19690003f,0.83819996f,-0.90970000f,-0.42359997f,1.18610001f,-0.37790005f,-0.10539998f,-0.01400001f,-0.14620001f,0.67040001f,-0.45300000f,-0.67640002f,0.10509999f,-0.94770004f,0.95930006f,0.27559998f,0.07670000f,0.31169999f,0.88120000f,0.62040000f,0.90339999f,-0.55070000f,-0.47629998f,-0.58660001f,-0.46960001f,-0.00670002f,-0.47860000f,-0.11869997f,1.11190005f,0.08070000f,0.78680004f,-0.16030000f,0.35279999f,0.87360002f,0.33330001f,-0.60419999f,-0.14929998f,-0.05670000f,0.62550003f,0.42900000f,-0.42760002f,-0.43720002f,0.65730001f,0.34790000f,0.49860001f,0.02330000f,-0.28330001f,0.01820000f,0.09200000f,0.85920003f,-0.05429998f,-1.02010001f,0.06880003f,0.97890003f,1.21239999f,-0.49950001f,-1.32999995f,1.00119998f,-0.52479999f,-0.64849998f,0.27510001f,1.43230004f,-0.27820001f,0.28480005f,-0.70850001f,-0.80970000f,0.82820001f,-1.21130003f,-0.15960003f,-0.49960000f,0.62580002f,-0.26800004f,-0.32000004f,0.07300000f,0.07789999f,-1.57160003f,0.08380001f,0.59760001f,0.35050001f,-0.08840000f,-0.48350002f,0.97030001f,0.49280003f,0.22270001f,0.15920000f,0.12380006f,1.45960002f,-0.35379999f,0.24269997f,1.99500003f,-0.62920003f,-0.57080003f,-0.94959998f,1.38790005f,-0.23170002f,-0.91780001f,-0.16090001f,-0.11429999f,1.19220005f,-1.20999999f,0.21899998f,-1.67819999f,-0.66030002f,-0.15950000f,0.04609999f,0.21149999f,0.43039998f,2.20589998f,0.44130009f,1.07810004f,-0.22050001f,1.89059997f,0.39840003f,-0.15090000f,0.01079999f,-0.75550001f,-0.37150001f,-0.69160005f,-0.95070003f,-1.34299995f,0.33909997f,0.75400002f,-1.74629995f,1.54210001f,0.62079998f,-0.19290000f,-0.06440002f,-0.57110001f,-0.52639998f,-0.39790001f,1.07719998f,-0.39909995f,-0.08429999f,0.39370000f,-0.02670000f,0.01570001f,-0.02980000f,-1.60640002f,0.15219998f,-1.36180003f,0.08059998f,-0.12529999f,0.44230001f,0.70659997f,0.97480005f,-0.44100002f,0.48720002f,0.53850000f,-0.00769999f,0.95559999f,0.06680002f,-0.71560006f,-1.00500005f,-0.85260004f,-0.46090001f,0.18000002f,0.23380000f,0.12230002f,-0.06299999f,0.33059998f,-0.20309999f,1.51050004f,-0.08780000f,-0.61540004f,-0.55840001f,0.56610004f,-0.32730002f,0.52910003f,-1.34500001f,-0.89350002f,1.61720003f,0.72250000f,0.67290002f,0.97560003f,-1.31529998f,-0.74120001f,-0.64020006f,0.56780005f,-0.38839999f,0.47559998f,1.91090002f,-0.01829999f,-0.80230002f,1.10950001f,0.66170001f,-0.12979992f,1.28180004f,0.35939997f,-0.74640004f,-2.22810002f,-0.03500001f,0.53570001f,0.57340001f,-0.58029993f,-0.86799998f,0.85790003f,1.10759999f,-1.28209998f,-0.03870003f,-0.84900007f,2.40260002f,-0.14109995f,0.67509996f,1.78790007f,0.57939993f,-0.99450000f,-0.98080002f,1.40419999f,0.48350001f,-0.07149998f,0.47890001f,-0.36270001f,0.47579999f,0.84469999f,0.18150002f,-1.26609997f,0.03419997f,-2.04870004f,-0.70800002f,-0.29400001f,-0.30800000f,0.55679996f,-0.14629999f,0.15269997f,-0.80930000f,-0.23579999f,0.22550000f,1.12459997f,0.39290002f,-0.66879999f,-0.55129998f,0.39380000f,-0.12949994f,0.94719998f,-0.59589999f,-0.29550001f,-0.19829997f,0.10290001f,-0.28449999f,1.55280000f,0.39099994f,-0.25439998f,1.32290001f,-0.66409994f,-1.62130003f,0.53659999f,0.26169998f,0.98979998f,0.83840003f,-0.76099992f,-1.34830003f,-0.72560000f,0.37179998f,0.30760006f,0.57920000f,-1.10109996f,0.21430002f,-0.81209999f,-0.04320001f,0.76900003f,0.26620000f,0.63799999f,1.06200003f,-0.08880002f,-0.84960000f,-0.02359999f,0.55479997f,-1.12419999f,1.00139998f,-0.09550002f,-0.67960000f,0.11940001f,0.09440003f,0.59049996f,0.72369999f,-1.01769999f,0.34140003f,1.38880000f,0.43839998f,-0.40970002f,-0.49370001f,0.31959998f,1.04540003f,-1.29199999f,0.66529998f,0.42649999f,-0.07060000f,0.08540006f,-0.17430000f,-0.97850000f,0.32070002f,-0.71439997f,0.35840004f,0.98279995f,-0.72580004f,-0.34370002f,0.98019999f,0.19210000f,0.54590000f,-0.24679996f,0.32240002f,-0.70339999f,-0.41120003f,-0.40850002f,-0.36329999f,0.09740002f,-0.15760000f,-0.14619998f,0.72050000f,0.34420001f,0.05519999f,0.08220000f,0.87210001f,-0.10860001f,0.14870000f,-0.03589998f,-0.93549996f,0.52940003f,-1.42409998f,0.13120000f,-1.14559998f,0.38700002f,-0.08890001f,0.00480002f,0.90659997f,1.22540000f,-1.37930005f,0.44439997f,-0.44350002f,0.50779997f,-0.08760002f,0.56680000f,0.86050001f,-0.09790001f,-0.28220003f,-0.62239996f,0.01910003f,0.42229999f,1.01010000f,1.47620001f,-0.74700000f,0.60990004f,0.23950000f,-0.53010000f,0.53809999f,0.27259998f,-0.60500002f,-1.38350001f,0.47960001f,-0.28340004f,-0.43750005f,0.33420002f,0.50099996f,0.10020000f,-1.05059998f,-0.22200000f,-0.96989998f,-1.41449998f,-0.98610001f,-0.29360005f,0.57969996f,1.13700002f,1.34550000f,0.55130000f,-0.50060004f,0.76959997f,-0.21960002f,0.02000000f,0.36480000f,0.10180004f,-0.39689997f,-1.47900000f,-0.39069998f,-0.60090003f,-0.09429999f,0.06519999f,-0.35290000f,0.89900005f,-0.62480004f,-0.09240000f,0.43670001f,-0.46170001f,-0.31750003f,-1.10500003f,0.96340003f,0.23420001f,0.68040003f,0.42219999f,0.29470000f,0.44280003f,-1.21020001f,-0.57740001f,-2.31670002f,-0.23429998f,-2.01260000f,0.45850000f,-0.03780004f,0.25650000f,-0.22310000f,0.39399999f,0.45610000f,1.23190001f,-0.03420005f,0.84180000f,0.64310002f,0.66070000f,0.19870000f,-0.84740001f,0.67170003f,1.05440001f,0.46320002f,0.71010000f,-0.21420002f,-0.32170002f,0.86050004f,1.87760004f,-1.28750003f,-0.50180000f,-0.56350002f,0.18550000f,0.47380000f,0.20830004f,-0.61370004f,-0.35880000f,1.77199994f,0.91809999f,2.92229999f,-1.43860002f,0.55270002f,-0.59519998f,-1.67299996f,-0.88929995f,-0.18710002f,0.75569999f,1.05780005f,-1.22779996f,-1.20070000f,-1.23950002f,-0.45089999f,0.56100005f,-1.04510000f,0.29469997f,-0.99410002f,-1.71409999f,-1.57379999f,-0.55189998f,0.85330005f,-0.74230000f,-0.71690003f,-0.16890003f,-0.38019998f,0.00060000f,0.11719999f,-0.58130000f,0.11560000f,1.12940000f,-0.77110000f,0.27380007f,-0.34239995f,0.03639998f,-0.04130000f,0.46209999f,-0.53550001f,-0.52860000f,-0.74879999f,0.21699999f,0.35329998f,0.42250005f,-0.38820001f,-0.02270001f,0.83420004f,0.10930002f,0.55739999f,0.58319997f,0.69259998f,0.22710001f,0.63020000f,-0.42020000f,0.09570000f,0.87490000f,-0.51500001f,1.59950001f,0.36040000f,0.63490003f,-0.37830001f,-0.90890000f,0.43630001f,-0.15420000f,0.54110000f,1.10730002f,-0.86630000f,0.36620001f,0.64589998f,0.27140001f,0.13730000f,-0.13119998f,-0.01909991f,0.06420001f,-0.68779996f,-0.25520003f,1.50389998f,1.03349999f,1.14150004f,-1.21069999f,-0.60869995f,0.69610002f,-1.35380001f,0.61829997f,-0.91260002f,-0.24940000f,0.29840002f,-1.42179999f,-0.19890000f,0.79549996f,-0.84010005f,-0.35680000f,-0.02960001f,-0.36290001f,0.33230000f,-0.73350004f,0.41090004f,-0.42100000f,-0.50310000f,0.77669999f,-0.01900000f,-0.30700000f,0.61959999f,0.52410000f,-0.59200000f,0.73440003f,0.58939994f,-1.15880006f,-1.88839998f,0.76680001f,0.32900005f,-0.21700001f,-0.64620001f,-1.18900002f,0.08100006f,0.09709999f,0.62490001f,0.31029998f,-0.07700001f,-0.82800002f,-0.50080003f,-0.99119997f,-0.95830001f,-0.20029997f,0.15510000f,-0.45760004f,0.02329998f,-1.09520000f,0.34989999f,-0.24460002f,0.19050003f,0.44430004f,0.56960000f,-0.40730001f,0.34940000f,0.48050001f,0.20850004f,1.47990001f,-0.26659999f,1.35799995f,-0.35379998f,-0.66010004f,-0.34370000f,0.21620001f,0.66030000f,-0.15460003f,-0.45920001f,0.17579997f,-2.05899996f,-0.13820004f,-1.10539990f,0.75270001f,0.79110001f,-0.34249999f,0.08970001f,-1.04020000f,0.03569999f,-0.25410004f,0.81010000f,0.43400000f,-0.17069998f,-0.26680005f,0.69649998f,1.09769998f,-0.26940001f,0.77969999f,0.23239999f,0.02699999f,-0.68279998f,-0.37810000f,-0.59810002f,-0.25479997f,0.34540002f,1.15989997f,-1.12339998f,-0.80740002f,-0.80489999f,0.42129994f,-0.68760000f,0.29130000f,-0.20930001f,0.41439999f,-0.56679999f,0.18560000f,-1.87709995f,-0.42040004f,-0.62759991f,-1.12410004f,-0.08719995f,1.17039999f,0.25859999f,1.44799999f,0.55030002f,-0.30249999f,-0.38940001f,0.99129999f,0.29029998f,1.91330000f,0.65000007f,0.23200000f,-0.28339998f,-0.27149999f,-1.00700000f,-0.00749997f,0.22339999f,-0.51300000f,-0.14630000f,-1.42630006f,-0.64470004f,0.12830001f,0.54349998f,0.81230001f,0.37480002f,-0.81639999f,-0.50810000f,0.68060000f,0.99839999f,-0.02519999f,0.84060000f,-1.08620006f,-0.25160000f,0.37390005f,0.05990001f,-0.13069996f,1.17329996f,-0.68740003f,1.31640003f,0.59759998f,-1.49950000f,0.83830000f,0.58359999f,-0.86589999f,0.16899999f,0.73839999f,-0.52700002f,1.33810001f,-0.26099995f,0.92729999f,0.53450001f,-1.34559994f,-0.19620001f,0.10469999f,0.34170001f,0.31629999f,0.06830000f,-1.67080001f,-0.28760004f,-0.70049999f,0.08869999f,0.53619997f,0.00139997f,-2.19850001f,0.78710000f,1.11129999f,0.48469998f,0.56910001f,0.85269997f,-1.78050003f,0.01520001f,-0.13899997f,-0.24609999f,-0.10890004f,-1.01860004f,-0.54359998f,-0.19709998f,0.12559996f,0.92169998f,-1.17240002f,0.01119999f,-0.91779998f,-0.87920004f,0.56169998f,0.45920002f,-0.00800002f,-0.06870003f,-0.96929999f,-0.24340000f,-0.19699999f,0.50940002f,1.07530002f,0.07240000f,-0.94060000f,-0.36100001f,-0.23339999f,0.63989999f,0.56469996f,0.90919999f,0.55630006f,0.76419998f,1.07330002f,-1.39110002f,0.30020000f,0.35849998f,-0.72860002f,0.50019998f,0.85800001f,-1.72759998f,-1.44790004f,0.22420004f,-0.03590001f,-0.19080001f,0.08940005f,-1.58110000f,0.41279999f,0.92040000f,0.09900001f,-0.86200002f,0.34530002f,-0.71229999f,-0.35479997f,0.96120001f,0.56800001f,0.67309999f,-1.52749999f,0.15440000f,0.22600000f,0.52640000f,-0.81050000f,0.25740000f,-0.90580002f,-0.17630004f,0.16449996f,0.51199998f,-0.00399998f,1.49820000f,-1.60929999f,1.00819996f,1.27120003f,0.68779999f,-1.17140000f,0.41809998f,-0.61840005f,-0.09809999f,0.95270001f,-0.68449998f,0.83930001f,-0.04950002f,-0.00269997f,-0.61880001f,-1.46140004f,-0.74710000f,0.85799995f,0.96909999f,1.26660005f,0.14000004f,-0.74070003f,-0.83640001f,0.67279997f,1.76280004f,0.56870003f,0.56580000f,-1.21680001f,0.14460004f,-0.17779997f,0.66350002f,0.03670000f,0.04869999f,-0.46640002f,0.86659999f,0.91780007f,-0.06110002f,0.06870001f,0.13650002f,-1.01070003f,1.01040003f,-0.01069998f,0.30299998f,1.31590001f,-0.71930002f,0.54270002f,0.21680004f,0.09900000f,0.51980001f,0.72659998f,-0.60079997f,1.29889999f,-0.10059995f,0.84139996f,0.86009999f,-0.39870000f,-0.06730003f,-1.29779999f,-0.00600002f,0.00460002f,-0.91950003f,0.79629995f,0.05899997f,0.11019994f,1.52959999f,0.41390002f,1.58229998f,0.59690000f,-0.21070005f,-0.54399998f,0.26759999f,0.27850000f,-0.48310000f,-0.44909998f,0.16470000f,-1.34270000f,0.54670002f,0.00910000f,0.13720000f,-0.73760002f,-0.42629999f,0.05119997f,-0.83929998f,-0.08569997f,-1.58349996f,-0.37709999f,-1.74309997f,1.42849997f,-0.21549998f,-0.26030002f,0.05790000f,-0.24420002f,0.05020001f,-0.61909999f,0.10250000f,1.23269998f,0.57229999f,0.26420000f,0.44530001f,0.30759995f,1.35269997f,0.30020001f,1.59259997f,0.32750000f,0.96490000f,-0.15829999f,0.87310003f,0.01330001f,-0.80130001f,0.49180003f,-0.67860002f,-1.06410004f,0.48670001f,-0.70000003f,0.08809998f,0.91159998f,-0.38010000f,0.24980001f,-0.58999996f,-0.44160000f,0.81880000f,-0.41480000f,-0.58449997f,-0.75150001f,-0.73710001f,0.09649997f,1.55409991f,-0.23079999f,1.81379993f,0.14729999f,0.84490005f,-0.64889997f,-0.79919998f,0.53299999f,-0.61520003f,-0.53019997f,0.33110005f,-1.33039996f,-0.25699997f,-0.51829997f,-0.81489999f,0.72889999f,0.82319999f,-0.09849999f,-0.08269998f,-0.01760000f,-0.62090000f,0.93880002f,-0.27690001f,-0.81920001f,0.71289999f,-0.85280002f,-0.44720001f,-0.57200007f,-0.01270002f,-0.37380001f,0.94890003f,-0.07209998f,0.16850001f,-0.52659998f,-0.45649998f,-0.59820002f,-0.09610000f,0.43289998f,0.36299996f,-0.10570001f,-0.99110000f,-0.03499999f,-0.20399998f,-0.30520000f,-0.61900001f,0.09410000f,-0.95630002f,-0.63169997f,-0.06389995f,0.08530001f,0.41550001f,-0.54080000f,-0.06050001f,0.38410004f,-0.96510002f,-1.01369999f,0.98370002f,1.01660002f,0.04750000f,0.40960003f,-0.32590001f,-1.34359999f,0.78250000f,-0.00110003f,0.19480002f,-0.47049998f,-1.82179995f,0.56160004f,-1.00410000f,-0.07899999f,0.26260000f,-0.35989998f,-1.11829994f,1.16109998f,-0.44120003f,-0.61970006f,-0.68819998f,0.99989997f,-0.73950004f,-0.57940001f,0.18699999f,0.14220000f,-0.30530000f,0.89969999f,-0.29680000f,-0.30550000f,0.69860000f,-0.13050000f,0.23979999f,1.11960004f,-0.05460003f,0.19469999f,-0.20389998f,0.26940003f,-0.11890002f,0.00560000f,0.38990000f,-0.42490002f,-0.36949999f,-0.16500001f,0.99799999f,-0.53820002f,1.59589995f,-0.31680000f,0.34780003f,-0.44799999f,0.02310000f,-0.17510000f,0.58979999f,0.21839996f,-0.29700001f,0.06449999f,-1.27960001f,-0.96259996f,-1.61680002f,0.15139996f,-0.86320001f,-0.86039999f,-1.24930003f,-0.40289999f,-0.56080000f,0.59689999f,0.35540002f,0.84859997f,0.64050001f,0.78750000f,-0.87210002f,0.11239999f,-0.14239998f,0.14330002f,0.25030001f,-0.68950000f,0.11919999f,-0.58360003f,-0.54850000f,0.98480005f,0.93979999f,-1.03600004f,-0.23480001f,1.40810003f,-1.07780000f,-1.13050004f,-1.39199992f,2.09179999f,0.42129997f,-2.53830002f,-0.04489995f,0.75439997f,-0.90179999f,-1.04080000f,0.02880000f,-1.87960000f,0.29229996f,0.40230004f,0.37660006f,-1.38020002f,-0.32110005f,1.20979998f,-0.22369998f,-0.91150003f,1.23470002f,1.73549998f,0.16240003f,1.07719992f,-1.25740002f,-0.12039995f,1.00170003f,0.46250000f,-0.49880000f,-0.68259994f,0.83000002f,1.14219996f,-0.82119998f,0.78229997f,-1.60469996f,-0.14260005f,0.43070002f,1.09500008f,-0.73720003f,-0.47140003f,0.71160001f,-0.37579997f,-1.10409998f,0.13639997f,1.39220004f,-0.28640002f,0.15080001f,-0.06359999f,-0.76750001f,-0.79150003f,0.20550002f,-0.81529999f,0.93650000f,-0.42689997f,-0.85270002f,-0.18490003f,-0.32980001f,0.30470000f,-0.14920001f,-0.04819999f,0.70100001f,0.90110002f,-0.53350002f,1.45109999f,-0.05049999f,-0.19419995f,1.09470004f,-0.78850001f,-0.52650001f,-0.19069998f,0.07929999f,0.26079999f,-0.83650004f,-0.09580002f,-1.20479999f,1.25560002f,0.76040000f,0.02820004f,-0.28590004f,-2.14770010f,-0.05830001f,-1.61239999f,-1.36290006f,-0.92480000f,0.51820001f,-0.78150000f,-0.57920003f,0.93990001f,0.19770001f,1.65390005f,0.60630003f,-0.10390000f,0.79810002f,-0.72590002f,0.19500000f,0.26969999f,0.83840001f,-0.28770003f,-0.56850000f,-0.72930003f,-0.93850003f,-0.34920000f,0.56430002f,-0.35970001f,0.63219998f,-0.47900000f,0.72739999f,1.61660005f,-0.93630001f,-1.63530004f,-0.76509998f,-0.96370004f,0.85200004f,0.77250003f,0.36410000f,-0.71860000f,1.09060002f,-0.77509999f,-1.33230004f,-0.63539999f,-0.41710002f,0.67940004f,0.76120005f,-0.14040001f,0.04559998f,0.49259999f,1.15179999f,-0.77839995f,0.68260005f,0.88640003f,0.98930000f,0.06419995f,-1.37560002f,0.56049999f,0.12700001f,-0.07770001f,-0.83079998f,1.09099997f,0.50300000f,-0.26229999f,-0.22190001f,-0.01080008f,-0.73749998f,-1.84550006f,-0.77349992f,1.39310001f,-0.34729998f,-0.85180002f,-0.51769994f,1.49669999f,0.59059998f,-0.64239998f,0.56400003f,0.63419996f,0.68679999f,0.03369997f,-0.43770001f,0.91270004f,0.27280006f,-1.01049999f,-0.32860001f,-0.27430001f,0.28300000f,0.84130004f,-0.64450003f,-0.00870000f,-0.02859999f,-0.34140005f,-0.77270004f,-0.53249999f,1.05610000f,0.70100000f,0.19010002f,0.41499998f,-0.60610001f,-0.61030000f,-0.17649998f,-0.26659996f,-0.82289995f,-0.94220003f,1.70369998f,1.32100005f,-0.25390004f,0.08789998f,-0.90899998f,-0.70940002f,0.14180005f,-0.28300002f,-1.10170002f,0.35980001f,0.62300003f,0.16910001f,0.83340004f,-0.49199999f,0.42109998f,1.12739998f,0.81930003f,-0.77439996f,-1.20190005f,-0.46960003f,-0.45500004f,0.07939993f,-0.80820002f,0.08789997f,-0.69229999f,0.03019998f,-0.42019999f,0.00680004f,0.38240000f,0.74930000f,0.35180004f,0.37470000f,-0.60819995f,0.41269997f,-0.53819997f,0.44830002f,-0.48309998f,0.75599999f,0.12829999f,-0.12370000f,-1.07949996f,0.13749997f,0.53420001f,0.10080001f,-0.51049999f,-0.92040004f,1.13080000f,-0.44550002f,1.11950001f,1.67710002f,0.65050003f,-0.11169997f,-0.79380001f,0.60190001f,1.42080004f,0.85599997f,-1.41460001f,0.75939999f,0.20620000f,0.74189995f,0.83239998f,0.19400001f,1.70629999f,-0.13950000f,-0.57780002f,-0.01520002f,0.58100001f,0.72450000f,0.19890000f,0.02519998f,0.28700002f,1.27550000f,-0.41090002f,-0.63580001f,0.55440001f,1.11490004f,-0.16230001f,-1.32469999f,1.00500001f,1.69590003f,0.78840000f,1.50379998f,0.30729997f,-0.84750000f,-1.13710001f,0.76060002f,-0.02449999f,-0.60369999f,-0.32119996f,0.89229999f,0.91600000f,-1.06080001f,-0.07130004f,0.84029997f,1.57579997f,1.14000002f,0.56770000f,-0.64860005f,-0.42240002f,0.55140001f,-0.22110001f,-0.99020001f,0.25099999f,0.40010003f,-0.28600000f,0.23040000f,0.24230000f,-0.39310002f,0.03120002f,-0.15590002f,0.40410002f,1.17290002f,-0.36170002f,0.02610002f,0.56730001f,-0.34730002f,-0.63190006f,-0.25290000f,0.12059997f,1.30420002f,0.30599999f,0.51679999f,-0.32950002f,-0.53729999f,-0.01030000f,0.87530003f,0.57280003f,-0.38520002f,0.63440002f,-0.18759998f,-0.00059999f,0.49710000f,0.39870003f,0.61870000f,1.50500004f,-0.10480000f,-0.64570003f,-0.22580002f,-0.62950002f,0.42260003f,0.35240000f,0.94190006f,-0.28920002f,-0.12819996f,0.61089999f,-0.25100002f,0.98410003f,-0.13990002f,-0.51270001f,-0.55890003f,-0.27340001f,0.53950002f,0.44079998f,-0.02900000f,-0.89749997f,0.76689999f,-1.14480003f,-0.03560001f,-0.20909999f,-1.16510003f,-0.09069998f,-0.06600000f,0.66690001f,-0.79980000f,-1.32040006f,1.01769999f,-0.89650006f,-0.01870003f,-0.38680006f,0.16009999f,0.95750001f,-0.13909999f,0.05990003f,-0.96160002f,-0.72030001f,0.20830002f,0.21420002f,0.29670003f,0.16900002f,-0.22170003f,0.37759999f,-0.31680002f,-0.61860000f,-0.31900000f,0.22030000f,0.44719999f,-0.20750001f,1.13940000f,1.02390002f,1.71529996f,1.42130001f,-0.22430004f,-0.33439999f,0.45779998f,-0.09510000f,-0.21920000f,-0.42999996f,-0.25279998f,0.74469995f,-0.65929999f,-0.29460000f,0.59439999f,0.43499999f,0.80650001f,1.87360002f,0.18509996f,0.35219997f,0.34759999f,1.07209998f,-0.91829996f,-0.88249999f,0.01069999f,-0.58300000f,-0.82239999f,0.99939997f,0.91169999f,-1.00420000f,-0.65300001f,-0.06479999f,0.10660000f,0.45410001f,0.26540000f,0.34609999f,-0.82110003f,-1.07419999f,-0.04080000f,0.25389997f,-1.23050001f,0.17269994f,0.65749999f,-0.08920003f,0.83909999f,0.00480000f,-0.63470003f,0.20840000f,1.10980000f,0.65720001f,-0.97839996f,0.47479999f,0.35820005f,-0.59019997f,-0.48790004f,-0.77450002f,0.48659998f,0.68959998f,-0.26289999f,0.32340000f,0.23949998f,0.15920000f,-0.48920005f,-0.58550000f,-0.40540003f,-0.20700000f,0.24810001f,-0.58760000f,-1.16550001f,1.33870002f,1.00190001f,-0.98710002f,-0.20250000f,0.04829998f,-0.01540003f,-0.96170005f,-0.23340000f,-1.04160000f,-0.26709997f,-1.30999995f,0.22509997f,0.78570001f,0.78440001f,0.87280003f,0.05010000f,1.09680002f,0.73950000f,1.13650001f,0.34289997f,0.79079999f,0.72419998f,0.04419999f,-1.53470001f,0.36810001f,1.15300000f,-0.05000003f,-0.03840000f,-0.41660000f,0.01860001f,-0.62410001f,-0.15229997f,-0.23560004f,-1.62330007f,1.09850004f,0.40680000f,-1.13250002f,-0.49520004f,0.65560000f,-0.30709999f,0.90079998f,-0.23099996f,-1.03849996f,0.82249998f,0.61850001f,-0.52449995f,-0.82020000f,0.19539997f,1.34389995f,0.92610006f,-1.57370002f,-0.51650004f,0.54320004f,0.31469996f,1.79990002f,0.84650001f,-0.89020004f,1.70280008f,0.60450005f,1.67650002f,-0.59140000f,0.97490001f,0.97560004f,-0.31169999f,-0.84970000f,0.88360001f,-0.28850000f,-1.28680003f,-0.58290004f,-0.91250005f,-0.02580002f,-1.98960001f,-0.01650001f,0.39919999f,0.32710002f,-0.95780002f,-1.09150001f,1.01710002f,-0.31269998f,-2.17120007f,1.23800004f,0.24150002f,1.84279999f,-1.29989999f,0.51800003f,1.13800005f,0.98979996f,-0.82460003f,-0.27629999f,0.41409999f,0.40170000f,0.90460004f,-1.51149999f,0.58759999f,0.97799999f,0.23019999f,0.59460002f,-1.27660002f,-0.64530005f,0.10879992f,0.22309999f,0.82469999f,-0.18269999f,-1.58269998f,0.07479999f,0.39599997f,-0.76079998f,1.17120002f,0.45540004f,1.20070000f,0.13360003f,0.50370000f,-1.00309999f,-0.05470000f,1.11540001f,-1.46800005f,-0.29419998f,0.46599998f,-0.81599994f,1.20440002f,-0.97619998f,0.16479995f,-1.21580000f,-1.34590002f,-0.73510000f,0.29869996f,0.26890001f,-0.67720002f,0.80430000f,0.40529999f,0.53400000f,-0.32610005f,0.08650000f,-0.05259999f,-0.03840001f,0.10520001f,0.13109999f,0.24270002f,-0.38050000f,0.70379996f,-1.43939999f,0.02970001f,0.50550002f,0.51330001f,-0.69330000f,0.21739995f,-0.46500000f,0.17759999f,-0.91220002f,0.19899998f,-1.61079994f,0.16809998f,-0.00529998f,1.28160000f,-1.17410000f,-0.84550002f,-1.02759994f,0.18249995f,0.07120001f,0.60140000f,-0.06440002f,0.69009998f,0.92050004f,-0.90989997f,-1.09630002f,-0.46150001f,1.22260001f,0.87490003f,-0.98510000f,-0.32939997f,-0.25520002f,0.19429998f,-0.28410001f,0.23670001f,0.33529999f,0.92830001f,0.01010002f,0.77009998f,-0.48370001f,-1.28069996f,0.59930000f,-0.01490002f,-0.01779999f,-0.79119998f,-0.27360002f,0.05819999f,-1.79019999f,-0.16080002f,0.22160001f,0.50520000f,0.64169999f,-1.03979999f,0.38380002f,0.40519999f,0.35029999f,-0.72589999f,0.34290000f,-0.79109997f,-0.76710003f,-0.91840000f,-0.01790002f,-0.00319996f,-0.41089999f,-1.04560002f,0.63299997f,0.76319998f,-0.97459999f,-1.29989997f,0.30910002f,-0.16589998f,0.82050000f,-0.54680001f,-0.39460001f,-0.64759998f,0.91100000f,0.71139998f,-0.44119999f,-1.10179996f,0.49199999f,0.58709997f,0.83529998f,0.46660000f,0.69779996f,-0.50889998f,0.55469998f,0.75020000f,-0.44810002f,0.10720003f,0.24560001f,-1.02690000f,-0.53260001f,0.95049999f,0.06440004f,0.43100006f,-0.16880002f,0.27860002f,0.26579999f,0.06510002f,0.12780000f,0.20430001f,-0.25740000f,1.38259997f,1.66810002f,-0.52329998f,-0.80620003f,-0.15290006f,-0.20059998f,-1.52660003f,-0.41140003f,-1.31150002f,0.29169999f,-1.72910002f,-0.77190002f,0.91720000f,0.13120000f,-0.14999999f,-0.52379992f,0.18429997f,2.02869998f,-0.13739998f,1.24340000f,0.86580005f,0.51149997f,-1.20090004f,-1.15050001f,1.13270001f,-0.59149998f,-0.93060001f,-0.34579996f,0.51440002f,-0.66390002f,0.89249995f,0.91840001f,0.83050000f,0.91030002f,-0.18119996f,-0.42040001f,-1.45980003f,-0.09879999f,-0.87440000f,-0.39309999f,-0.22970001f,0.62419999f,0.92060001f,-0.00430002f,-1.12319999f,0.30710002f,1.49410003f,-0.43099998f,-0.96750003f,0.34630001f,0.99120000f,-0.16939999f,-0.18849999f,0.51220000f,0.02700000f,-0.15670001f,0.10309997f,-0.90840002f,-0.94940000f,-0.07120003f,0.28559998f,-0.51619999f,0.80360002f,-2.12399998f,-0.61880000f,-0.31830000f,-1.11530004f,0.79340001f,-1.38270002f,0.31970001f,-0.49880002f,0.23950001f,-0.58799998f,0.58269997f,-1.11679998f,1.26560001f,-0.97380000f,0.10210000f,-0.39929997f,-0.41559998f,-0.97550002f,-1.59580001f,-0.59609998f,-0.46660001f,-0.88920001f,-1.08380001f,0.13280003f,1.08710003f,0.73509999f,-0.38870001f,-0.91090002f,-0.21659996f,-0.67600002f,-0.23290001f,-0.31100001f,0.10090001f,0.22689999f,0.14730002f,-0.27850003f,0.38539999f,-0.75240000f,1.23269998f,0.62989996f,0.35090005f,0.01890000f,-0.60569997f,0.99690000f,0.56549998f,1.38000002f,0.24379999f,-0.76280001f,0.53050003f,-0.60039997f,-0.50679999f,0.52519995f,0.52180001f,0.30190000f,1.31499999f,-0.07150001f,0.68419998f,1.11610001f,1.30460001f,-0.46059994f,0.50870002f,-1.02030000f,0.11290000f,0.39289998f,-0.67169999f,-0.86099999f,0.13810000f,-0.36450000f,0.61020001f,0.14459998f,-0.75789999f,-0.71190002f,-0.75989995f,0.92049998f,-0.46890001f,-0.73139999f,-1.31069998f,0.95220001f,-0.58469999f,0.18589997f,0.06079998f,0.05099999f,-0.32930000f,0.63139999f,0.42520003f,0.65160001f,1.78990001f,1.04059999f,1.11760000f,0.06759999f,0.45209999f,0.22050001f,1.49340001f,0.82470000f,0.54590000f,0.24769998f,-0.34400001f,-1.35690005f,1.63840004f,0.90130000f,-0.80740001f,0.68479999f,0.16660000f,-0.44069998f,0.24149999f,0.37220000f,-0.67510000f,-0.76820000f,-1.77750000f,0.60509998f,0.35559996f,0.74120000f,0.78620001f,-1.15389999f,-0.41860000f,0.09149998f,0.85450004f,0.08420002f,-0.42079997f,-0.32239999f,0.18239998f,-1.26780001f,0.91240004f,1.25230000f,0.48609999f,-0.59890000f,-0.51669999f,-0.59500001f,-0.72530001f,0.68839998f,-0.17790002f,0.10049999f,-0.01610000f,0.76570004f,-0.27770001f,0.47910002f,0.28629999f,-0.40489998f,0.06690001f,0.70180002f,0.36519996f,-0.88920000f,0.48500002f,1.03259999f,0.39260001f,0.28010001f,-0.00229997f,-0.91679998f,-1.06649997f,0.85929999f,-0.45489996f,-0.72719997f,-0.52179999f,0.65349998f,0.63859998f,-0.21949994f,-1.04990002f,0.25999999f,-1.24870003f,0.00800000f,-0.62560000f,0.14599995f,-0.49490002f,-0.14979997f,-0.16540002f,-0.26420000f,0.16930002f,1.58799998f,1.09870000f,1.02859998f,-1.48870000f,0.10080003f,-0.44020004f,-0.13419997f,-0.45600003f,-1.34740005f,0.56410004f,-0.72390003f,0.36689998f,0.79200000f,0.66809996f,-0.98779999f,0.34940003f,-1.40750000f,-1.46899996f,-0.34859998f,-1.64739999f,-0.06510000f,-1.73709996f,-0.00149999f,0.71549996f,-0.20100001f,1.05690001f,0.22749999f,-1.24790003f,-0.17250000f,-1.27090002f,0.18559999f,-1.17020004f,0.47659996f,1.12640004f,-1.24769995f,0.35490004f,1.04940000f,0.01970002f,-0.50109999f,-0.47080000f,-0.78900003f,0.08610001f,0.52249999f,-1.00809999f,-0.00819998f,-0.03830003f,0.48580003f,0.41910000f,0.01890001f,-0.11759996f,0.09320002f,0.76309999f,-0.63510002f,0.67859997f,-0.64079999f,-0.62929997f,0.31560001f,0.41649997f,-0.84060004f,-0.36199996f,0.65400003f,0.89620001f,-0.87189997f,-0.90750002f,-1.21310002f,0.26089999f,-0.39690002f,0.40460000f,0.80130004f,-1.18230000f,-1.36409998f,0.11299999f,-0.10610004f,-0.50320001f,-0.07059998f,0.65770001f,0.56570001f,0.01610000f,0.47140001f,-0.15430000f,-0.74439996f,0.76570000f,1.20720000f,-0.21149999f,-0.54109999f,-0.03310002f,0.40460000f,0.00369996f,0.52990001f,-0.90320000f,-0.24809998f,0.33719998f,-0.84110004f,-0.41570003f,1.16390000f,0.19340001f,-0.80419999f,0.54440005f,0.78219999f,-0.31659999f,0.41269998f,-0.78110002f,1.51620001f,0.60070004f,-0.05339995f,-0.91050004f,2.41130006f,0.47550006f,-0.40469996f,0.33850001f,0.84950003f,0.80940002f,0.12800002f,-0.39170001f,0.82130003f,0.52160002f,-0.39890003f,-0.40080002f,-0.69299994f,1.25810004f,1.20620003f,-0.57200001f,0.07859997f,-0.03970004f,-1.67910004f,0.08830003f,0.36380001f,0.58720000f,-1.18030007f,2.09920001f,0.03400006f,-0.08529999f,0.23379996f,-0.45740002f,0.12549995f,1.17270001f,0.63400001f,0.96890004f,1.03410000f,-1.80820003f,1.07740002f,0.06890003f,-0.95760004f,1.02299998f,1.37579998f,-0.86650000f,-0.84480003f,-0.50170004f,0.57060000f,0.67060000f,-1.65639999f,-0.20970000f,0.08139999f,0.43120001f,0.33429995f,-1.40000001f,-1.19160001f,0.76440000f,0.50390000f,-0.61610001f,0.81690004f,0.51350001f,-3.03400002f,0.62220004f,1.10869998f,0.02009999f,-0.02949997f,1.33150005f,0.52630006f,-0.32600000f,1.08000004f,0.25010000f,-0.01650001f,-1.47820003f,0.36380000f,1.05760005f,-0.50410000f,0.05840000f,-0.20999997f,-0.95220002f,-0.30180000f,-0.59940002f,0.46940000f,0.79740004f,-1.13190000f,-0.13790003f,0.45139998f,-0.24300000f,0.38100000f,0.22330000f,-0.89380002f,-0.11640002f,0.85119997f,-0.03139995f,0.81630003f,1.19689999f,-1.54820005f,-0.02550000f,0.93210003f,-0.19220001f,0.59210002f,0.29480000f,-0.93880008f,-1.31279999f,0.58930003f,0.27670001f,-1.59329999f,-1.37030005f,-1.20740001f,-0.23469996f,-0.62029999f,0.53899999f,-1.11170003f,0.24099997f,0.60140002f,-0.71329996f,-0.60950002f,1.10910002f,0.19169998f,0.81870001f,0.48310002f,-0.20040002f,1.52950000f,0.09510003f,0.84129998f,-0.71750002f,-1.23959995f,0.92479998f,0.84179999f,0.38149999f,0.00329998f,-0.57720006f,-0.19590001f,-1.74299999f,0.78489999f,-1.13309998f,-0.32580000f,1.39629998f,-0.00709996f,0.19169996f,0.77020004f,0.69880001f,-0.32629993f,-0.86720001f,0.26430000f,0.49950000f,-0.40749995f,-0.30350001f,-1.08380005f,0.37639997f,-0.31050000f,-0.48170000f,-0.21559999f,0.09019999f,-0.30820000f,0.56550000f,-0.33570000f,-0.32330000f,0.62970000f,0.78410003f,0.54570000f,0.09900000f,-0.32600000f,0.61069998f,-1.66840001f,0.58830000f,0.39939997f,0.72559997f,-0.65970000f,-0.53599995f,1.24930001f,0.61939998f,0.19340005f,0.29349999f,-0.24279998f,1.29149991f,-1.21610000f,0.21009999f,0.49700000f,-0.91259999f,0.65439996f,0.31280000f,0.36050002f,0.81910003f,-1.14990001f,-0.37610001f,0.88490000f,-0.22240000f,-1.37810003f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_3d_1item_large_5o3i_padded_uneven_filter_uneven_data_dilation_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{1,3,8,8,8};
    Shape shape_b{5,3,2,3,4};
    Shape shape_r{1,5,17,23,17};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{1,1,1},        // move_strides
                                                                  Strides{1,1,1},        // filter_dilation
                                                                  CoordinateDiff{2,1,2}, // below_pads
                                                                  CoordinateDiff{1,2,3}, // above_pads
                                                                  Strides{2,3,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.56569999f,-0.06849998f,-1.71099996f,0.15210003f,-0.56169997f,0.65789999f,-0.81270001f,0.04860000f,-0.38360001f,-0.63200000f,1.16259999f,-0.55250005f,2.10670000f,-0.46900001f,0.77880002f,0.27390001f,0.02430000f,0.08599999f,-0.79339997f,-0.48730000f,-0.18710002f,-0.14130000f,-1.26619998f,-0.60210000f,-0.18499998f,-0.66879999f,1.53749999f,0.13969999f,1.42940001f,0.92770002f,0.47800001f,0.77930001f,0.52819998f,0.36980000f,0.83519999f,0.22829997f,-0.80940001f,0.26659999f,1.90230001f,0.85000001f,-0.41119999f,-0.16880000f,0.00609999f,-0.77600001f,1.03480003f,1.25400003f,0.32759997f,-0.79880003f,-0.64250002f,0.59090001f,-0.18410003f,-0.73619999f,-0.02380001f,-1.09900000f,-1.28200001f,0.14970005f,0.17719999f,-1.04399998f,0.33310000f,1.17910002f,-0.29309999f,1.38340003f,-0.04239996f,0.71780002f,-0.61730001f,-1.32510003f,-0.81190001f,-0.25909998f,0.13859999f,0.11720001f,0.04110000f,0.42990003f,0.76210001f,0.11830000f,0.28690001f,1.03530000f,0.60990003f,0.94100002f,0.10330001f,0.64899996f,0.02169999f,-0.85569997f,-0.89150003f,0.69320001f,0.15050000f,0.05629999f,0.61840003f,1.09270000f,-0.11710000f,0.36910000f,0.07169998f,0.54149996f,0.61710001f,-0.19999999f,0.93149999f,1.03299998f,-0.25029998f,-0.40940001f,0.77890002f,-0.12719999f,-0.27649998f,0.56860001f,0.03550001f,-0.49090002f,1.41590002f,0.55269999f,-0.06910004f,-1.39319999f,-0.72309998f,-0.53899998f,-0.22319995f,-0.63069999f,0.19859997f,-1.21970001f,-1.92140001f,0.66139998f,0.17859998f,0.55559998f,0.69699998f,0.02660000f,1.41539998f,1.13830001f,-0.45440000f,-0.23830001f,0.35210003f,0.11760000f,1.05929999f,0.23280001f,0.31819996f,-0.11110002f,-0.58709997f,0.05440000f,0.46669997f,0.66690000f,-0.11659999f,0.08510000f,-0.54250000f,-0.50080000f,0.37739998f,-0.26020002f,0.53410003f,0.22210004f,-1.36770002f,-1.07190005f,1.00629998f,0.31850000f,0.58210002f,1.81310001f,-0.13440000f,-0.04909999f,-0.22370001f,0.91259998f,-0.39810001f,0.47950000f,-0.03530000f,1.42860001f,0.19590001f,0.29750001f,0.95630002f,0.40130000f,-0.66990000f,0.68509999f,-0.83440000f,-1.65610000f,0.57830001f,-1.67580004f,-0.12289996f,-2.04570003f,0.62169999f,-0.85990001f,-0.11500000f,0.71960000f,0.36900002f,-0.33590000f,-0.09230000f,0.35390000f,-0.32580000f,-0.28430000f,-0.06270002f,-0.84520000f,0.23309998f,-0.98770006f,0.08310000f,-1.54500001f,-0.03280003f,-0.29100002f,0.03479999f,-0.17490002f,-0.41980004f,-0.74940000f,1.06900002f,-0.36890000f,-0.07190002f,-1.12780001f,-1.10950002f,0.01720004f,0.61690000f,0.64920002f,0.07639999f,0.68140006f,0.92210002f,-0.63090001f,-0.25459999f,-0.47379999f,-0.20369998f,-0.81249998f,-1.37159996f,0.12980004f,-0.73929998f,0.44660000f,-1.05860003f,-0.22360002f,-0.52140000f,0.84390000f,0.54500002f,0.40639998f,-0.56439999f,0.35719999f,-1.06570003f,0.18830001f,-0.55520001f,-0.61620000f,-0.73599997f,-0.63470000f,-0.45000003f,-0.37970001f,-1.16960001f,-0.48690000f,-0.63519997f,0.29180001f,0.07140000f,0.79400001f,-1.00829998f,-0.08680001f,-0.56250001f,-0.16009999f,-0.56420000f,-0.24650000f,0.06370002f,-0.11570000f,-1.57399995f,-1.09150000f,0.04660002f,1.04660000f,0.02579997f,0.71140000f,-0.27760001f,0.24109998f,-1.20029997f,-0.98050001f,-0.27579996f,1.19860002f,-0.19119999f,-0.80100000f,-0.38750001f,-0.24670000f,1.07279999f,-1.06160000f,-0.34599998f,-0.40839998f,-0.21599996f,-0.25639996f,-0.70479998f,-0.90639997f,0.88219997f,-1.53950003f,0.21909998f,-0.94580002f,1.03700001f,0.41340001f,-0.81160001f,-0.12509999f,-0.23029999f,-1.41759998f,-0.67529997f,-0.62369996f,-0.25769999f,0.45330000f,-0.46440001f,-0.49480000f,-0.31660001f,-1.74390000f,-0.41250000f,-1.12609997f,0.02620001f,0.30850000f,-0.40240000f,-0.06359997f,-0.26830000f,-0.03190000f,-0.03950001f,0.45080001f,-0.34080001f,-0.33870002f,1.52280003f,0.83749996f,-0.45060003f,-0.67260003f,-0.04420000f,-0.16029999f,0.59699999f,0.58850004f,-0.73379996f,-1.36259996f,-0.57980000f,0.82239999f,0.09190000f,-0.11609998f,-0.38160000f,-0.72270001f,-0.55429999f,-0.30329995f,0.93670003f,-1.28869998f,-1.10420000f,0.03359999f,-0.01830000f,0.82119998f,0.50489998f,0.94049999f,-0.24080002f,-0.00340000f,1.19479997f,0.13040001f,-0.47860000f,-0.05930001f,0.64460002f,0.09989999f,1.21619997f,-0.23970000f,-0.22670000f,-0.30110001f,0.22880000f,0.38310001f,-0.39710003f,0.14740002f,-0.51939998f,-0.29369998f,0.30399999f,0.14600000f,0.27400000f,0.04879999f,0.31700002f,0.07240000f,-0.17120001f,-0.45369998f,0.19630001f,-0.04540001f,1.33169999f,0.66719999f,-0.77409999f,-0.26240001f,0.05849998f,0.75180003f,-1.00709999f,-1.26470002f,0.27779998f,-0.03100000f,0.32330000f,-0.37700001f,-0.17140002f,0.23059999f,0.47109998f,1.43070000f,-0.43859998f,0.66710002f,-0.23809999f,-0.94629997f,-0.48779998f,-0.55629997f,0.67430001f,0.53370003f,0.01389999f,0.69999995f,0.44950000f,-0.37810001f,-0.02590001f,0.69219999f,0.40870001f,0.86430001f,0.41270001f,0.15720002f,-0.09740000f,-0.10280000f,-0.17679999f,-0.22029996f,-0.29120000f,0.65259997f,-0.00850000f,-0.38240001f,-0.21840001f,0.35130000f,-1.13209997f,-0.08529997f,-0.08830001f,-0.45700005f,-1.50490000f,-1.24739999f,-1.24699999f,-0.41119998f,0.91949996f,0.55299997f,2.09890003f,1.06820001f,1.32420002f,1.35650006f,0.66420001f,0.18720000f,0.00899999f,-0.69149996f,0.02300000f,1.00359999f,0.21590000f,0.26630000f,0.98889999f,-0.39219998f,-0.13799998f,0.24879996f,-0.50489997f,0.07589997f,-0.36589998f,-1.05610000f,-0.71740004f,0.11400001f,-0.40240001f,0.71400001f,-0.20720001f,0.83070001f,0.14200003f,0.36189997f,-0.37670001f,1.19360001f,0.59930002f,-0.22929999f,0.33000000f,-1.67980001f,-0.02210000f,-0.50500003f,-0.34950002f,-0.26910000f,0.20580002f,0.23199999f,0.79830000f,-0.04090002f,0.02260004f,1.70340006f,2.00550005f,0.33880001f,0.05780004f,1.20100001f,-0.02900002f,0.31700002f,0.85780002f,0.51900000f,0.09569992f,-1.66130004f,0.08460004f,0.83410003f,0.72820000f,-0.17510000f,-0.50970002f,0.46290000f,-0.69149999f,-1.03750004f,-0.29430000f,0.38379998f,0.38689999f,0.22260003f,-0.93990000f,-1.38650000f,1.11330002f,-0.92339999f,-0.98600000f,-0.12230000f,0.38210000f,-0.35589999f,-0.65689999f,0.75370002f,0.18069997f,-0.48400003f,-0.36119998f,0.02520002f,0.20600002f,0.07790000f,0.05570000f,-0.29950001f,-0.63009999f,-0.04880000f,1.56330004f,0.04559999f,0.92770000f,-0.05340001f,-0.45649999f,1.01300006f,2.60970002f,1.08109998f,-0.90040001f,-0.27699997f,0.64400004f,1.55730002f,0.80780001f,0.77500000f,0.19060001f,0.91149999f,0.23280001f,0.90390006f,1.04779998f,-0.31669999f,-0.16109998f,-0.25499998f,-0.65170000f,0.84739998f,-0.38430003f,-0.79639999f,-0.34260001f,-0.79449997f,-0.81549997f,-0.21089999f,-0.59639999f,-0.01240002f,-1.57249999f,-0.65129999f,0.73289999f,0.51239996f,0.64399997f,-0.24389999f,-0.14990001f,-0.63650000f,0.69030003f,-0.71220000f,-0.13390001f,-0.37870002f,0.08689999f,-0.43840000f,0.34520002f,-0.80380002f,-0.44070001f,1.59700000f,-1.00510002f,1.95830005f,-0.57790004f,1.95020002f,-0.56400001f,0.92350000f,-0.32800000f,0.92540001f,0.13909995f,-0.37250001f,-0.05599999f,-0.60000002f,-1.35200006f,0.01599998f,0.66529998f,0.29039999f,0.97710006f,-0.26079999f,-0.49699999f,-0.58570006f,-0.07450000f,-0.27640001f,-0.49719998f,-0.05950000f,0.53680000f,-0.09369996f,-0.29740001f,-0.25690002f,0.93370001f,0.50680002f,-0.36300000f,-0.48499998f,-0.80579998f,0.25289995f,0.33660002f,0.60310001f,-0.66919998f,1.25089998f,-0.03379999f,0.38820000f,-0.48730002f,-0.15539999f,0.30339998f,-0.51500001f,0.38289998f,-0.27580000f,0.83770003f,0.25030000f,0.90210001f,-0.02839999f,0.87169997f,-0.62880001f,0.43159997f,-0.50230001f,1.01700003f,-0.15600002f,0.30900002f,-0.61420005f,-0.97800000f,0.15900001f,-0.61830000f,-0.41380004f,-1.15140002f,-1.15180001f,0.21720000f,0.16630005f,1.06070001f,-0.28640000f,-0.72429998f,-0.13789993f,-0.44589998f,-0.58379999f,-0.65360001f,-0.44540000f,-0.60569998f,-0.30029999f,0.24090001f,0.61280002f,-0.10440000f,0.54439999f,1.26200003f,-0.61610002f,1.12259998f,0.38519999f,0.56639996f,-0.73049999f,0.01649993f,0.42410001f,0.55260000f,-0.10330000f,0.53410000f,0.33510000f,-0.42040001f,0.78330002f,0.03099999f,-0.10729999f,-0.51380000f,-0.75460002f,-0.17239999f,0.59099995f,-0.56290001f,1.61940001f,-0.10480001f,1.05150002f,-0.60820002f,-0.84800002f,0.42840002f,-0.27850001f,-0.67720001f,-1.74379997f,-1.89039998f,-0.64829999f,0.17970002f,-0.55859998f,0.32009998f,-0.16290000f,0.17219997f,-1.32720000f,-1.58719998f,-0.53830001f,-0.37089994f,-0.86599997f,-0.84870001f,-0.10939999f,0.30340000f,0.10940000f,0.66059998f,1.62319999f,-0.81989998f,0.22069999f,-0.16739997f,-1.42219998f,0.78270000f,0.01149998f,0.66099999f,1.85569999f,-0.72080001f,1.33619997f,0.35200001f,-0.88760002f,0.12830000f,0.14370000f,0.23210000f,-0.27230001f,0.18550000f,0.17050000f,0.08170002f,-0.31029999f,-1.59650000f,0.25620001f,0.45320001f,0.22540001f,0.57070001f,-0.28670000f,0.12190001f,0.06819997f,0.23860004f,0.32520000f,-0.95099999f,-0.16710001f,-0.28230001f,0.23130001f,0.38259998f,0.82890004f,0.17840005f,0.72609994f,-0.05260003f,0.64569999f,0.67320000f,0.04600001f,-0.04599996f,-0.58899999f,-0.96020001f,-1.41839999f,0.30099999f,0.26319998f,0.32220001f,-0.48329999f,-0.14940001f,-0.87650000f,-0.20579999f,0.31290005f,-2.40919996f,0.00569998f,0.29030003f,0.10509999f,0.55069999f,0.51099998f,0.04969999f,0.21969998f,1.39889999f,-0.11680000f,-0.53719998f,0.80900000f,-0.42240002f,0.17860001f,0.35870001f,0.25180001f,0.53100000f,-0.73400000f,-0.13549999f,-1.10110001f,-0.17879999f,0.70009998f,-0.17530000f,-0.16710000f,0.18610000f,-0.12370004f,0.31380000f,-0.83649998f,0.11649999f,-0.44160001f,-0.03149997f,0.93990000f,0.28670002f,0.74130000f,-0.15370000f,-0.05739996f,0.85310000f,-0.11739999f,-0.11660000f,-0.49279999f,0.42800001f,0.20329998f,-0.93850006f,-0.51550004f,-0.17440002f,0.70000000f,-0.74189999f,-0.10350002f,0.19519997f,0.19250000f,0.17749998f,-0.02910000f,-0.62299997f,-1.46889999f,0.44939999f,0.30259999f,-0.66779997f,-0.38529999f,1.32999999f,0.34269999f,-0.24140001f,0.08080003f,0.76240000f,-1.53309998f,0.90249999f,-0.16560002f,1.25709999f,0.32809999f,2.07949998f,-0.15020000f,1.28869999f,-0.25630004f,1.48039999f,0.32980001f,0.36069997f,0.43170004f,-0.85709999f,-0.28400001f,-1.56320001f,-0.33849999f,0.73740001f,0.19579998f,1.84889995f,0.74859999f,1.22569999f,0.25180002f,0.84330001f,0.04300000f,0.75809999f,0.93800000f,-0.28610002f,0.54299998f,-0.57120003f,-0.33210003f,-0.70240000f,-0.44240001f,-0.43319998f,-1.13970001f,1.15290000f,1.73650003f,0.36539997f,-0.80460002f,-0.63130002f,0.45679999f,1.30799997f,1.51590003f,0.08359998f,-0.25389999f,-1.72840002f,-0.27550000f,0.21360000f,-0.38700002f,-1.04019999f,0.51779998f,-0.66400002f,-0.00030005f,0.03540003f,-0.50759999f,-0.69660000f,-0.96850000f,-1.12400001f,0.83080002f,0.33190002f,-0.04780001f,0.32219999f,-0.57300001f,0.03570000f,0.12739999f,0.61219999f,-1.30060003f,0.22200000f,-0.32539999f,0.17159998f,0.21389997f,0.21770000f,0.05580002f,-0.16010002f,1.50749998f,0.70629999f,0.15459997f,-0.32020001f,-0.45219998f,-0.83340001f,-0.88100001f,-0.21100001f,-1.29839999f,-0.51500001f,-0.32380001f,-0.27840000f,-1.17050003f,-0.25140001f,0.26110002f,-0.01249999f,-1.15790001f,-1.05960000f,1.14849998f,1.39789999f,-0.19150002f,0.47050000f,0.39769993f,0.19859997f,-0.24169995f,0.96470003f,-0.40440003f,-0.14300000f,-0.75080003f,0.01890004f,-0.51320002f,0.44450004f,-0.11140001f,-0.08089998f,-1.81279999f,0.07050004f,-0.03209999f,-0.43870000f,-1.19839996f,-0.42469998f,-0.73210002f,-1.92889996f,-0.22910000f,-0.73860001f,-0.83800001f,0.65890007f,-0.48609999f,0.18410005f,-0.44009999f,0.42770004f,-0.56599999f,0.33130004f,0.29439999f,0.77789996f,-0.24070001f,0.09610001f,-0.06710001f,-0.81839996f,-0.34290001f,0.31039999f,0.11700000f,0.42490000f,-0.02449998f,0.10229998f,0.22969997f,1.33580001f,1.66519997f,0.47570001f,-0.60239998f,-1.26739994f,0.45179997f,0.74369998f,0.21159996f,0.81900004f,1.57500004f,-0.35359995f,-0.29159999f,-0.76940001f,-0.39610001f,-0.55050000f,-0.11869998f,0.12100000f,0.52680001f,0.66520001f,-0.88109998f,-0.12840000f,-2.26479996f,0.28570000f,-0.06950002f,-0.07630004f,-0.87579998f,0.92720000f,-0.98199997f,-0.47570000f,-0.80360001f,-0.01880001f,0.63160001f,0.77130000f,0.21649997f,0.70749999f,-1.04280001f,-0.16969999f,-1.47279995f,-0.19409999f,-0.14500003f,0.61729998f,-0.73689996f,0.50370001f,-0.52969998f,-0.41669999f,-0.32699998f,-0.30430000f,-0.43760001f,-0.41119998f,-0.91560002f,-1.11100003f,0.42399998f,0.78180003f,0.19360004f,0.40959999f,-0.84880003f,-1.26870002f,-0.68109994f,0.09789997f,1.41750003f,0.20960002f,-0.62489999f,0.30150000f,0.89449998f,0.12620000f,-0.00070000f,0.30959997f,-0.35700003f,0.45199995f,0.94330000f,-0.18380000f,0.03340001f,-0.49560002f,0.79310000f,-0.37249998f,-0.26410000f,0.09970003f,-0.03860001f,-0.72169998f,-0.00879999f,1.03970000f,-0.51770001f,0.13929997f,-0.44790001f,-0.24230001f,0.47409999f,-0.46640000f,-0.53930000f,-0.51250002f,-0.08729998f,-1.07109996f,-0.08839998f,-0.23579999f,0.33350000f,0.31780002f,0.27110001f,0.74819997f,0.39160000f,-0.04699999f,0.47320002f,0.50370006f,-0.12289999f,-0.86080002f,-0.56870001f,-0.77990001f,-0.21400001f,0.48590001f,-0.76860001f,0.40250002f,0.17210004f,-0.49720000f,-1.58200001f,0.89699996f,0.94940000f,0.17289998f,0.33679999f,1.37369997f,0.42409998f,0.27780004f,-1.26020002f,-0.89060002f,-0.03849995f,0.70220001f,1.79050001f,0.20810000f,1.02970001f,0.64340000f,1.23819997f,-0.89810000f,0.34139994f,0.13100001f,-0.07070000f,0.55330000f,-0.87830001f,-0.00839998f,-1.08949997f,-1.06450002f,0.79030004f,0.24100002f,0.83539998f,0.51620001f,0.28730001f,-0.04720000f,0.73739995f,-0.01260000f,-0.23670000f,0.09829998f,0.44959997f,0.28669999f,0.18560002f,0.18010001f,0.02020002f,-0.79680000f,-0.21169998f,0.38889999f,0.73019997f,0.27429999f,-0.57879999f,0.49649999f,-0.40990000f,-0.94390000f,-0.35010000f,0.33670001f,0.68189999f,-0.26010001f,0.43940000f,0.15459998f,1.67339998f,0.55619996f,0.49300001f,0.28710000f,-0.73619998f,0.24020002f,0.02960000f,-1.26219997f,-0.20369999f,-0.59529998f,-0.86600002f,-0.07629998f,0.45000001f,1.51770002f,-0.66650002f,0.73680003f,0.63740000f,-0.59800002f,0.26530002f,-0.21339998f,-0.44510000f,0.25159999f,0.13349999f,-0.74199997f,-0.43360000f,-0.05559999f,-0.44050000f,0.53850003f,0.42360002f,1.20280000f,0.20330000f,0.63960002f,0.14620001f,0.35750000f,0.87090003f,0.84660001f,0.91409999f,-0.07260000f,-0.06790002f,-1.22139995f,-1.02880001f,-0.29099998f,-0.32870002f,0.72310001f,0.48469999f,0.95089997f,0.95179999f,0.44360001f,0.45330002f,-1.23470001f,-0.15170000f,-0.06780000f,0.43620002f,0.82020003f,-0.73600000f,0.34809999f,-1.22199998f,0.73479998f,-0.07220000f,0.00370001f,0.89390004f,-1.01619999f,0.58910005f,-0.55339998f,-1.10399999f,-0.02339998f,-1.67230002f,0.26690000f,0.55959999f,0.69650001f,-1.05360001f,-0.54200000f,-1.20619999f,-0.20519999f,-0.69209996f,0.21770002f,0.83290002f,0.17730000f,1.07590000f,0.33240000f,-0.56300002f,-0.22540000f,-0.62220000f,-0.32080000f,-1.06410004f,0.84659996f,1.70179997f,1.81339997f,0.70759999f,0.69360003f,0.07309997f,0.34769997f,0.14739998f,1.87689999f,0.61609999f,0.48369996f,0.37660000f,-0.81490001f,-0.25380003f,-0.78400003f,-0.39519999f,0.00760002f,-1.08699998f,-0.87919995f,0.27159996f,-0.59989998f,0.34039999f,-0.94999997f,0.02649997f,-0.33340000f,0.32039998f,0.37619999f,-0.82089998f,-0.06220001f,0.02630005f,-0.69010001f,0.10480000f,0.94160002f,0.21240000f,0.08419998f,-0.20419996f,-0.54420001f,0.70950000f,0.09979999f,0.21850001f,0.40750002f,-0.48240001f,-0.59640001f,-0.34090001f,-0.02990001f,-0.23150001f,0.03720001f,0.06009997f,-0.46680002f,0.81200002f,-0.73770001f,0.11459998f,1.04740006f,0.50490002f,0.29409998f,-0.24560004f,0.53460003f,1.90330001f,1.85260001f,-0.43779998f,-0.25340003f,-1.43520002f,-1.24250002f,-0.41850001f,-0.41720004f,-1.49420003f,-1.10359998f,0.79349998f,-1.42190000f,-0.38010001f,0.37150003f,-0.57310000f,-1.03369999f,0.21950001f,-0.37360000f,-1.48930000f,0.56550002f,-0.97930000f,0.71589999f,0.72680001f,0.64420001f,0.40739999f,-0.26140000f,1.22100000f,-1.20300002f,0.49280004f,-0.75030003f,0.08180003f,-1.18130004f,0.11500001f,-0.72600002f,0.57850002f,-0.28070002f,-0.56860001f,-0.36859998f,0.04930002f,0.11199998f,-0.58170000f,0.99649997f,-0.18900000f,0.73950002f,-0.27799999f,-0.17239996f,0.05330000f,-0.45109993f,0.35770003f,-0.66969998f,-0.39910000f,1.05210001f,1.97160001f,-0.21320000f,0.31370000f,0.46990001f,1.02199995f,-0.69809998f,0.54390009f,0.41870001f,0.22280000f,-1.22780001f,0.65309998f,-0.18450000f,-0.04540000f,-0.99160002f,0.39999998f,-0.19360000f,-0.93929996f,-0.75740000f,-0.24479999f,-1.27139997f,0.26610001f,-0.68979997f,-0.89700000f,0.06189994f,0.25960001f,-0.00219999f,-0.00309999f,0.46660001f,0.97260000f,-0.04519999f,0.30589999f,-1.03359999f,0.92089998f,-0.26850001f,2.03359999f,-0.16270000f,0.94750000f,-0.35559998f,1.44019998f,-1.07010002f,0.45779998f,0.07800000f,0.36400001f,0.75490004f,1.59199999f,0.79560000f,1.04109999f,0.65570001f,-0.67759995f,-0.52779999f,-0.79940000f,-0.50289994f,0.80879996f,0.21690000f,0.48840004f,0.48850009f,-1.14139994f,-0.83039995f,-0.37660000f,-0.04179999f,-0.47700001f,-0.04419999f,0.51620000f,-0.50610000f,-0.33090001f,0.39810000f,-0.15850002f,-0.45089998f,1.98599994f,-0.16230001f,0.30600000f,-0.67070001f,0.49929994f,0.05890002f,-0.27880006f,0.11530000f,0.48630001f,-0.74260001f,0.32219999f,-0.68519999f,0.64610001f,0.41060001f,-0.91320003f,-0.57759999f,0.11690002f,0.92320002f,0.05490000f,0.61540000f,-0.22919999f,0.12859997f,0.00120000f,0.86150001f,0.17220000f,-0.58300000f,-0.60830003f,-0.53360004f,-0.57590005f,0.84519996f,0.29800000f,-1.43899996f,-0.69239997f,0.02750001f,-0.69120006f,-0.84720001f,-1.09219998f,0.42970002f,0.83180004f,0.44750001f,0.10860004f,0.85930000f,0.50919998f,-0.49879999f,0.67009999f,0.18790003f,0.08269996f,0.86240001f,-0.43669997f,-0.80490003f,1.35379998f,1.07310005f,-0.33170001f,1.64539999f,-0.72030001f,-0.62530004f,-0.26079999f,0.54419998f,0.04640000f,-0.80939999f,0.72919998f,-0.52260001f,0.14650001f,-0.75840004f,-0.28609999f,0.77820004f,0.21499998f,0.51570001f,-0.76910002f,0.24520000f,-1.11090000f,0.37369998f,-0.84630000f,0.46560000f,-0.48259996f,-0.20280000f,0.35350000f,-0.20869999f,-0.67169995f,-1.15349998f,-2.24860002f,-0.78130000f,0.99150002f,0.54150001f,0.89759999f,-0.29790005f,-0.16430000f,-0.02130000f,0.17589997f,-0.77470005f,0.21159996f,0.97590000f,0.56619999f,0.19659999f,1.03519996f,0.38010001f,0.33009997f,-0.58999998f,-0.06879999f,0.32399999f,0.49680001f,0.50459998f,-0.07769999f,-0.35870000f,-0.44330000f,1.06979997f,-0.01969999f,-0.98089998f,-0.17289997f,0.12890000f,-0.30969999f,1.00119999f,-0.24560001f,0.46930003f,-0.11140002f,-0.93769999f,0.11740002f,-0.14990003f,-0.52250000f,0.58949999f,-0.32080000f,-0.15540001f,0.75440002f,0.42680001f,0.09430000f,-1.39860003f,0.46620003f,-0.65150003f,-0.01389998f,-0.27829999f,-1.44500000f,-1.12410001f,-0.52559999f,0.66000000f,0.81419996f,-0.97319998f,-0.31409997f,-0.63039998f,-0.01779999f,1.08400000f,0.73130003f,0.45360000f,0.18609998f,0.71270003f,0.70760000f,1.07949997f,0.46370000f,1.02710000f,-0.64259999f,-0.16019999f,0.28500000f,-0.71459999f,-0.27089998f,0.28659999f,0.02620000f,-0.43960000f,-0.19290002f,0.64730000f,-0.13220000f,-1.28210001f,0.16840000f,-0.59820001f,0.07130001f,0.06600001f,0.50649999f,-0.91630001f,0.24310001f,-0.10320000f,1.48549997f,0.13310000f,0.65540002f,0.10040000f,-1.07100003f,0.26300003f,-0.57320003f,-0.62060001f,0.56980001f,-0.39300002f,1.21800003f,0.96780005f,1.38860003f,0.58720000f,-1.41959998f,-0.91510002f,-0.61810001f,-1.09919999f,-0.23050000f,-0.75659997f,0.29360000f,0.59770001f,1.22090003f,1.41229999f,-0.31089997f,0.55540002f,-0.66570002f,-0.46920000f,-0.17380000f,0.33420000f,-0.28680003f,0.12050003f,-0.08219998f,0.79759996f,1.81919996f,-0.34359999f,1.41069999f,-0.90299999f,-1.03700001f,-0.07339999f,-1.36419999f,-0.17729999f,-0.59550001f,0.10800000f,0.89340001f,-0.19340000f,1.22270001f,-0.48020001f,0.50030001f,-1.41110003f,0.33970003f,-0.45069998f,-0.93880001f,0.29530006f,0.29350002f,2.07820000f,0.49820000f,1.84650001f,-0.56939999f,0.48029998f,0.54749999f,-1.26160000f,0.34190000f,-1.00560003f,-0.23919999f,-1.53579999f,-0.69560000f,-0.28169996f,-1.00450000f,0.86000004f,-0.07219997f,1.20569998f,0.50130001f,0.89259999f,-0.15509999f,-0.18350002f,0.08899999f,-1.04419997f,-0.39449999f,0.11759998f,0.36330000f,-0.43460002f,-0.04480000f,0.52080003f,-0.48910002f,-0.42130001f,-0.63590003f,-0.29399997f,1.05320000f,1.04710001f,-0.17229999f,-0.27820000f,0.79310000f,0.95090000f,0.32590002f,-0.66230003f,-0.21599998f,-0.27569997f,1.13100004f,0.78340002f,1.43239999f,0.25620001f,-1.07570003f,-0.51750002f,-1.31619997f,-0.06429999f,0.08250001f,0.22360001f,-0.60300001f,-0.33160000f,0.22210000f,-0.55030000f,-0.82930001f,-0.28350000f,1.65229997f,0.40620002f,-0.15120005f,-0.12180000f,-1.62969998f,-0.54350001f,-0.54649995f,0.08930001f,0.30079996f,0.72500001f,-0.17100000f,0.16749999f,0.42309998f,-0.05990001f,0.07120000f,-0.10630000f,-0.92180000f,-1.53830004f,0.90789999f,-0.06950000f,1.22040002f,0.50219999f,0.96639996f,1.02409998f,-0.31540003f,-0.33010000f,-0.18899999f,0.48120002f,0.66540000f,-0.69770001f,-0.30560002f,0.84710002f,0.53460001f,0.78920001f,-0.76880000f,1.49090000f,-0.17550000f,0.59980001f,-0.35619997f,-0.33220000f,-0.10959998f,-0.48559996f,-0.94800003f,0.41800004f,0.33730000f,0.30179997f,-1.12550003f,-1.09400002f,0.61400001f,0.33020000f,-0.19339998f,0.73539999f,0.56130000f,0.45959998f,0.76120000f,0.14949997f,0.42139998f,0.57890002f,-0.38270001f,0.90780002f,0.38920001f,-0.20100002f,-0.32380001f,-0.19589998f,0.33660000f,0.31939998f,0.34830000f,-0.54390000f,0.07869997f,0.89980001f,0.27950001f,-0.99669998f,0.14520001f,-0.89179999f,-0.15359999f,-0.64469997f,-1.11779999f,-1.30710001f,-0.66470004f,0.95500002f,0.34929999f,0.11340001f,0.35890000f,-0.75319998f,0.55950000f,0.07150001f,0.58640000f,0.25450001f,-1.37909998f,0.51530000f,-0.31859999f,1.03919999f,0.22889998f,1.09999999f,0.34789998f,-0.37810002f,0.96700002f,0.23500001f,-1.14160001f,0.48759999f,-1.12800000f,0.05700002f,-0.34310001f,-0.12730000f,-1.03159997f,-0.61159999f,-0.47630000f,-0.35369999f,-0.86600001f,-0.32890000f,-0.50499997f,-0.62900000f,-0.03390000f,0.19480000f,-1.18010001f,-0.06090001f,-0.68659999f,-0.21730000f,0.85620000f,1.68269999f,-0.13730001f,-0.68920000f,-0.98070000f,-0.63400003f,0.19760000f,0.57430003f,1.17860004f,-0.74470000f,-0.91979999f,-1.16580000f,0.24559999f,0.41489998f,0.43439998f,0.69090000f,0.08890000f,-0.63780000f,0.62310004f,-1.42050003f,-0.36590000f,-1.34169999f,0.49979999f,1.43960002f,0.71049998f,2.75580004f,0.91249996f,0.48059994f,-0.87849998f,-0.15759998f,-1.27049999f,-0.40419995f,0.18950001f,-0.11369998f,0.33809999f,-0.91240006f,-0.32220002f,-0.61459997f,0.17400001f,1.35190001f,0.66430000f,1.36599998f,0.46010001f,-0.62379999f,-0.64349999f,-0.21559994f,-0.51900000f,0.73050001f,0.46330000f,0.23759999f,0.18770000f,-0.06529999f,0.68130002f,1.44500000f,0.33960004f,-1.50020002f,-0.11800000f,0.83830000f,0.20899999f,-0.46219995f,-0.11549996f,-1.21960000f,-0.97970002f,0.11360002f,0.52200002f,1.08390005f,-0.40659999f,-0.27639999f,0.12890000f,-0.95749998f,0.31939999f,0.58729999f,-0.53340004f,0.17600000f,1.28289998f,0.81889999f,-1.30240003f,-0.23700001f,-1.21640001f,0.08479996f,0.52179998f,1.15319998f,1.32349999f,0.64180002f,-0.34160004f,0.03040001f,0.53359996f,0.39969999f,0.25409999f,-0.24450000f,-0.00660003f,0.32700001f,-1.73919999f,-0.95730000f,-0.55519997f,-0.25809998f,0.22770000f,0.68530001f,0.08079997f,0.60630002f,-0.80800001f,-0.25280000f,-0.38270000f,-0.75800002f,1.13390002f,0.72459999f,0.10000001f,-0.72369998f,-0.92570000f,-0.91659999f,1.35379999f,0.02239999f,-0.03270006f,0.00770002f,1.66689998f,1.07119998f,0.54039997f,0.56170000f,-0.64380000f,0.49370001f,-0.19489999f,0.76830000f,1.05060000f,0.15699998f,0.70369998f,0.73049999f,-1.16230000f,1.26460000f,-0.94530001f,0.44349997f,-0.89909995f,0.86190001f,-0.43899999f,-0.85860000f,0.14419999f,-0.98939999f,0.22180001f,0.04029998f,0.67020000f,-0.17520004f,0.19949999f,0.40630002f,-0.18839999f,0.97600000f,0.05459999f,1.53289996f,0.54590001f,0.88379998f,0.60469999f,-0.07990002f,0.20559998f,-0.28699999f,-0.09930000f,0.00170004f,-1.02819996f,-1.14679996f,0.43720002f,-0.16090006f,-1.04049999f,0.25419996f,0.37299998f,0.06979996f,-0.98040001f,0.11560000f,-0.62490000f,0.52960001f,0.86960002f,-0.02450000f,-0.53170000f,-0.50470002f,-0.12890002f,0.16820001f,-1.47320003f,-0.45889998f,0.73489998f,-1.15959999f,0.88180001f,0.56350000f,1.82679999f,-0.24200001f,1.30680003f,-1.02950002f,0.58780004f,0.73530002f,0.22129998f,-0.56779999f,-0.38870001f,-0.09429998f,-1.19449997f,-0.83970000f,1.34099997f,-0.10100001f,1.16590000f,0.29019999f,1.43239996f,0.22890000f,0.65690006f,-0.38089999f,0.64730003f,0.41950001f,0.03419997f,-0.35680000f,-0.19059999f,-0.26300000f,0.34310001f,-0.94069997f,-1.26090001f,-1.73340002f,-1.23090000f,-1.82949998f,-0.72110001f,0.55020003f,0.35729999f,1.09679997f,0.02389994f,-0.18199998f,-0.27760003f,0.45459999f,0.48519996f,-1.18559999f,-0.92699996f,0.38899999f,0.70090001f,0.38459998f,0.01950000f,1.30300000f,-0.07469998f,-0.73829998f,0.43079999f,0.30430004f,0.39109997f,-0.22529997f,0.06990001f,-0.98109998f,0.48139998f,-0.29769999f,-0.18089999f,1.03569997f,-0.76699997f,0.75020003f,-0.57150000f,0.09439999f,-1.01080001f,-0.40430001f,0.66940000f,-0.06249999f,1.09250000f,-0.15439999f,0.83250000f,-0.13240002f,0.68570002f,-0.36410000f,-0.67900001f,0.01740000f,0.55800002f,0.79900001f,1.42070000f,0.29569993f,-0.31850001f,-0.78460006f,-1.41880003f,-0.81360001f,-0.05289999f,0.43900008f,1.31250002f,0.68680000f,-0.02000003f,-0.08979998f,0.08360002f,0.78220002f,0.11350000f,0.21700000f,-0.99489996f,0.97959998f,-0.32439994f,0.83609998f,-0.25629999f,-0.04780000f,0.98070000f,-0.96029999f,0.77959997f,0.09790000f,-0.29130001f,-0.57540000f,0.58039999f,-0.39719999f,-1.51330001f,0.25250000f,0.21730001f,-0.82379998f,1.04570002f,-0.82080000f,0.19420000f,0.21530000f,-0.27520001f,0.49240001f,-0.50200000f,-0.48490003f,0.80690003f,0.02049997f,-0.49670002f,-0.77219999f,0.41120001f,1.28210003f,-0.31020001f,0.13150000f,-0.89530004f,1.32559997f,0.99129997f,1.28730000f,0.89240001f,0.68849998f,0.95109999f,-0.48219998f,0.23350000f,1.34590002f,0.77570001f,-0.72729999f,-0.09390000f,0.81339999f,0.86710004f,0.40330001f,-0.05660000f,0.13750005f,-0.27120003f,-0.14689997f,-0.55899999f,-0.30040002f,-0.75889997f,-0.57029998f,-0.30719998f,-1.13479999f,0.51899997f,0.10949998f,-0.21909999f,-1.00260001f,-0.36910001f,0.94350001f,-0.05589999f,-0.36430002f,-0.28749998f,-0.15049999f,-0.59630001f,-0.54450001f,0.69620000f,-0.12580000f,0.22299999f,-0.07560001f,0.07209998f,0.11389999f,-0.73750000f,0.42800003f,-0.54990003f,-0.57040001f,1.19070000f,-0.48420001f,0.90950001f,-0.53050002f,-0.26539998f,0.05059999f,-1.33129997f,-0.81249998f,-0.74140000f,-0.98910002f,-0.93880002f,-1.51940003f,-1.55310003f,-1.66710003f,0.50120001f,0.45469999f,-0.54000001f,-0.29229998f,-0.75490000f,-0.68619997f,0.36060003f,0.11639999f,-0.63489999f,0.13140001f,0.67329998f,0.68209999f,0.68590000f,0.95729998f,1.01309998f,0.20730000f,0.96560001f,0.13989999f,-0.26630001f,-0.18279999f,0.64679998f,-0.08629999f,0.75129998f,0.86920002f,-1.12870003f,1.05000001f,0.22680001f,1.58990002f,0.58970001f,-0.71560002f,0.46410002f,-1.72450007f,0.06830000f,-0.76869997f,0.09030000f,-0.98940000f,0.26090003f,0.54489998f,-0.19980000f,0.31099999f,0.93520000f,-0.95410003f,-0.58510002f,0.18399999f,-0.08079998f,1.09169997f,0.14880000f,1.12120004f,-0.10910004f,-1.41789999f,-1.51610000f,-0.79409998f,0.70250002f,1.39620002f,1.46960001f,0.30970000f,0.04660000f,0.05750001f,0.11440001f,-0.05470000f,-0.14879999f,1.67680001f,-0.48360003f,-0.10109999f,1.10299998f,-1.26430004f,0.62009998f,0.67420003f,-1.04289998f,-0.71579999f,-0.17079999f,-0.49830000f,0.06290000f,-0.15270001f,-0.47489996f,0.00629999f,-0.14069999f,-0.10100002f,0.27460005f,0.39350002f,-0.33750000f,-1.05060003f,0.21580001f,0.01280000f,0.98750002f,0.62960001f,0.51270001f,-0.07060000f,-0.03369998f,-0.28200003f,0.18900003f,0.55490004f,1.15090001f,1.46450000f,-0.50020002f,-0.91230000f,0.68360001f,-0.10050005f,-2.39249999f,-1.21439995f,-0.40579998f,-0.42039998f,1.06089997f,0.11050003f,0.67460004f,-0.50040000f,-0.94660003f,-0.76480000f,-0.34919998f,-0.17430001f,-1.29700001f,0.35089999f,0.64910002f,0.87499999f,0.01770002f,-0.35940001f,0.27899997f,0.36960000f,1.11099999f,-0.16870005f,1.00969999f,0.45590000f,-0.00330002f,-0.28520000f,0.61280000f,0.00490001f,0.43360001f,0.16270000f,-0.37830002f,0.39960000f,0.34630000f,-0.78340000f,0.50790000f,-1.78919999f,0.67610002f,-0.15929993f,0.27699999f,-0.53980000f,-0.45480000f,0.84819999f,-0.34020000f,0.83250000f,-0.37080003f,1.07779997f,0.63509999f,-0.06950002f,-0.74650001f,-0.45110001f,-0.91080000f,0.59740001f,1.58990001f,1.63309999f,1.17399998f,1.41869999f,1.65119997f,0.44569999f,0.72890001f,-0.28609999f,-0.29899998f,0.54710002f,-0.36940000f,0.19600000f,0.25799999f,0.28269999f,0.18819999f,0.43950000f,-0.93899998f,-1.77749999f,-0.01860002f,-0.47249992f,-0.68309998f,-1.33550000f,-0.22129999f,-0.44750001f,0.06410001f,0.45849999f,0.61550001f,-0.43770005f,0.16980006f,0.27740000f,-1.17189998f,0.91210001f,-0.88810000f,0.43300001f,-1.35340001f,0.47630002f,-1.92200004f,0.71350004f,-0.20170002f,-0.52300002f,-0.61069999f,0.23460000f,0.00900001f,-0.95490000f,-2.00440002f,-0.72239995f,0.44449998f,0.51919995f,1.14389997f,1.21159997f,0.71459998f,-0.25740006f,-0.37289997f,0.14280000f,1.24930004f,1.08480002f,-0.78189999f,-0.61440002f,-0.23830001f,0.10639999f,0.51210000f,-1.03149998f,0.75559999f,0.27790000f,-1.20789995f,-0.30219999f,-0.55189997f,0.76229997f,-0.78489995f,-0.14100001f,-0.94590001f,0.01510000f,-0.22180001f,0.21170001f,-0.69009999f,0.09819999f,0.28520002f,-0.24729999f,0.96109996f,-0.25439999f,0.89729998f,0.16739998f,0.55400001f,1.64860002f,-0.33360000f,2.04040000f,1.74209999f,1.39880000f,-0.90520003f,0.25900002f,0.67320002f,-0.02950005f,-0.31159999f,0.02569999f,0.16539999f,-0.66960000f,0.33080001f,-0.54869999f,-0.04269999f,1.26159999f,0.17560002f,0.90079998f,0.88540001f,0.17270000f,-0.27319999f,-0.32419997f,0.52670001f,-0.08550006f,0.13929997f,0.46599998f,0.16569999f,-0.22120002f,-0.01440002f,0.86799998f,0.74870001f,-0.51450000f,-0.37940000f,0.01429998f,0.07859999f,1.88369998f,1.90349998f,-0.72800003f,-0.40739999f,-0.95290002f,0.17259999f,-0.28470001f,-0.69020000f,0.11630002f,-0.02239999f,-1.70100000f,-0.45599997f,0.14070002f,-0.91189999f,-0.21920000f,0.61310001f,-1.29749997f,0.22430003f,0.36740003f,-1.48700000f,-0.85880000f,-0.77649999f,0.55440000f,0.69590001f,-0.26100000f,0.38310002f,-0.47800001f,0.25950002f,0.26450001f,0.03519999f,0.08710000f,0.85170002f,0.22000000f,0.34259999f,0.52979998f,-0.28010004f,-0.66090002f,0.01120003f,-0.23830000f,0.35170000f,-0.13369999f,-0.04879998f,-0.10909999f,0.42540000f,-0.41040000f,-0.18919999f,1.17959998f,0.43420000f,-0.36239999f,0.68790005f,0.77419998f,-0.06040002f,0.33490003f,-0.60689997f,1.08040000f,1.22219998f,-0.39960001f,-0.45549996f,0.35510000f,-0.81379999f,-0.37620000f,-0.31139999f,-0.92180000f,0.77329998f,0.77039999f,-0.65630000f,-1.15430000f,-0.46509998f,-2.27140002f,0.02830001f,-0.40769996f,0.23390002f,1.54300000f,0.36700002f,-1.67730002f,0.37880001f,-1.18460001f,0.09360000f,-0.22680000f,0.28769999f,0.49449997f,0.29780001f,-1.28949998f,-0.12509999f,-0.91110001f,0.17620000f,0.87080002f,0.25400002f,0.64129993f,0.49890001f,-2.01349999f,-0.54270000f,-0.65500000f,-0.23050000f,0.10960000f,-0.36430003f,0.51680001f,1.17990000f,0.56910001f,-0.92770001f,0.06640004f,0.42960003f,0.60870002f,0.11350000f,0.60489999f,-0.30570002f,0.56130000f,0.11990001f,0.26970005f,-0.41860001f,0.35910003f,0.06320001f,-0.36490001f,0.06300003f,-0.04800002f,0.50850005f,-0.41460003f,-1.04400000f,0.00019998f,0.32569999f,0.94750001f,0.64229995f,-0.65120005f,0.67350003f,1.34620000f,0.85750003f,0.42740001f,0.49550000f,0.30310001f,0.40020004f,0.13520000f,0.58590000f,0.47960002f,-0.78439994f,0.00050001f,0.63719996f,1.24860002f,0.18339998f,0.06169998f,0.72810003f,0.89160002f,-0.06290000f,0.42400002f,-0.23440000f,-0.01350000f,0.37669999f,1.13810001f,-0.18509998f,-0.65010001f,-0.30649998f,-0.50200001f,-0.90959999f,-0.72909999f,0.17389998f,0.61260000f,0.85519998f,-0.85730003f,-0.07300000f,0.48520003f,-0.58779998f,-0.73010001f,0.78029998f,-0.13730000f,1.34560000f,0.65030001f,0.59740002f,-0.30250002f,0.04789999f,-0.43820000f,-0.40190000f,1.07930000f,-0.10099998f,1.32360001f,-0.62310001f,-0.77100000f,1.03059999f,0.67180001f,-0.41700000f,1.25389998f,0.37129999f,0.07289996f,0.17820001f,-1.29349999f,-0.64350001f,-0.17989999f,-0.28200000f,1.15380001f,0.18370000f,0.84489997f,0.15390000f,-0.59249998f,0.10860000f,0.71579999f,0.06300001f,0.49179999f,0.12840000f,0.83540001f,0.95810002f,-0.26619999f,-0.31370000f,0.07810000f,0.61660001f,-0.12589999f,-1.22930001f,0.06570003f,1.12080003f,0.43519999f,0.53409996f,-0.96900002f,0.65880002f,-0.04889998f,0.35700002f,-1.30890002f,-0.54980000f,0.72430002f,-0.56380001f,-0.06250001f,0.19350000f,0.81010000f,0.64790000f,-0.23740002f,-0.34910002f,0.63540005f,-0.52080001f,-0.47089999f,-1.57399999f,-1.04229998f,-1.50049997f,0.17080000f,-1.77130003f,0.45170001f,-0.11360003f,0.15690000f,0.15010001f,0.12120000f,0.07579998f,-0.04879999f,-0.84639999f,0.15060000f,-0.59270002f,-0.30810002f,-0.56349998f,-0.90330000f,-0.73869999f,-0.37020000f,-0.84840000f,-0.38730001f,0.46869999f,0.75490001f,1.14149999f,1.09559998f,0.63329999f,0.76399998f,-0.03069998f,0.95360003f,-0.25470000f,-0.24480003f,0.76890000f,0.55010000f,0.02760001f,0.58610002f,-0.74239999f,-0.56490000f,0.68370001f,-0.34089999f,-0.99659997f,-0.63009996f,-0.43099999f,-1.76929999f,-0.03239999f,-1.65990000f,1.05860003f,-0.17350001f,-0.94990002f,-0.40390001f,-0.03449997f,-1.54880001f,0.61039998f,0.08080001f,0.13549999f,0.99309999f,0.13210000f,0.21920000f,0.61859999f,-0.75630002f,0.36330000f,-0.64380004f,0.57790000f,-0.02650002f,-0.14300001f,-0.39340001f,0.26930001f,-0.74070001f,0.05359999f,0.51690000f,0.27740001f,0.12120001f,0.08910000f,-0.80100001f,-1.09630001f,1.07940001f,-0.11759998f,0.19789996f,-0.49230003f,1.40699996f,1.04910004f,0.00670000f,-0.91070000f,-0.36970003f,0.11570001f,0.67529998f,-1.11160007f,-0.47090001f,0.53230000f,0.60190006f,0.81480001f,-0.56900001f,1.50640002f,-0.53949999f,0.79910000f,-1.41780001f,0.86479999f,0.59300001f,0.81450001f,0.27589998f,1.31449998f,0.05320002f,1.14030004f,-0.94630003f,-0.78309997f,1.03890000f,0.43090004f,0.05640001f,0.81900001f,0.22180000f,1.34129999f,0.26899999f,1.24209999f,0.76129999f,1.04099997f,0.32830000f,0.70700002f,-0.04050001f,0.25660003f,-0.45790001f,-0.38429997f,0.41630001f,-0.06560000f,0.25790001f,0.21820000f,0.15020001f,-1.05389998f,-0.70840000f,-0.83989997f,0.48230001f,-0.35460004f,1.85079997f,0.67349995f,-0.94299999f,-1.47670001f,1.06510001f,0.70680002f,-0.24140005f,-0.05770001f,0.55939999f,0.40339998f,0.17989998f,0.76879999f,1.45529996f,-0.52530000f,0.79210001f,0.38930000f,-0.36589996f,0.27609996f,0.18560003f,0.48489998f,-0.44490003f,-0.12229999f,1.08469998f,-0.79649998f,-0.42709999f,0.18550000f,-0.31189998f,-0.93720001f,0.26750004f,0.31480000f,-0.33480002f,0.88300001f,0.40130001f,-0.54550001f,0.10000002f,-0.05110002f,-1.12760002f,0.38630000f,0.33180001f,0.33890000f,0.05560001f,-0.66270001f,0.28440001f,-0.49550002f,0.10660001f,1.08910005f,1.76580002f,0.06489999f,-0.08559999f,0.59419999f,0.41420000f,1.28990001f,1.93859999f,-1.24170001f,-0.47370001f,-0.01120000f,0.24400000f,-0.22159998f,-0.58990002f,-0.09659999f,0.11220000f,-0.89180000f,-0.35239998f,-0.71169999f,-0.07950000f,0.29750000f,-0.24980000f,-0.31390000f,-0.80289995f,-1.26530000f,0.08730001f,-0.67949998f,0.22769999f,0.48170001f,0.48329999f,-0.17069998f,-0.04170001f,-0.04790001f,0.52300000f,0.01969999f,1.03900001f,-0.21889999f,-0.13360000f,-0.35850001f,0.84690002f,-0.70450001f,2.13480005f,-0.01310001f,0.31700001f,0.16380002f,-0.47300001f,-0.67500003f,1.19630002f,-0.44940002f,0.92950002f,0.23080000f,0.32519996f,0.38570002f,0.48220002f,-0.34340001f,-0.44539996f,0.56720006f,0.03570000f,0.54760004f,0.47970001f,0.24930003f,1.20440002f,0.19209993f,-1.65170001f,-0.86549998f,-0.71750002f,-0.62539999f,0.07060000f,-0.73449999f,0.72779999f,0.64939997f,-0.46089999f,-0.72209998f,0.21379997f,-0.76250000f,0.64400001f,-0.51659999f,-0.00970002f,1.19129999f,-0.83649997f,-0.40759999f,1.23779998f,-0.04990000f,0.75290000f,0.39020000f,0.00920001f,-0.36990002f,0.05180003f,0.29259995f,-0.10360000f,0.74570002f,0.43490000f,1.44330002f,-0.39240004f,-0.68199998f,0.78800005f,0.55039998f,-0.06340000f,0.16079999f,-0.02040001f,-0.38750001f,0.14620000f,0.21860001f,0.77220005f,1.17560006f,0.33250001f,-0.33569998f,0.39540009f,2.23730000f,0.58810001f,-0.40000004f,-0.29559999f,1.95480004f,0.89090003f,0.19510002f,-0.92930000f,-0.30020001f,-0.28220000f,0.41090000f,-1.03210000f,-0.63330002f,0.88049998f,-0.40310004f,-1.14870000f,0.60869996f,0.31109998f,0.79399998f,-0.78260000f,-0.62240000f,0.35209998f,0.38989999f,0.24680000f,0.58959998f,-0.22450000f,-0.00190001f,0.43690000f,-0.24760000f,0.19939999f,-0.32930002f,-0.19640000f,0.09090000f,0.07860001f,0.60660001f,-1.14559999f,0.18390001f,-1.05580002f,0.20620001f,0.81830000f,-0.03460001f,-0.43180000f,0.53220001f,-1.09400000f,0.67820002f,0.06580002f,-1.20910004f,-1.61930002f,-1.03700002f,-0.55170002f,-0.43579999f,0.65969999f,0.63079999f,0.68530001f,0.40679994f,0.13489998f,0.40090003f,-0.03569999f,-0.83940000f,0.50970000f,0.55319998f,0.20099999f,1.15950000f,0.34130000f,-0.04809999f,0.54780000f,-0.04070001f,0.59440000f,-0.37150000f,-0.67229997f,0.60340000f,-1.21229998f,-0.45720001f,0.80759999f,0.36450000f,0.00669999f,-0.00600001f,-0.65299998f,0.93480003f,-0.49110003f,0.83210002f,0.16590000f,-0.08160000f,-0.10220000f,-0.28390001f,0.29580000f,0.69580002f,-0.92870003f,0.08040000f,-0.61069999f,0.08150001f,-0.39340000f,0.82669998f,-0.48120002f,1.28050004f,0.98320003f,-0.05080002f,-0.49590001f,0.21269999f,0.13620001f,-0.15809999f,-0.82560003f,0.00949999f,0.01900003f,-0.93350000f,-0.35540002f,-1.44789998f,-0.12099998f,-0.33319997f,0.60910002f,-0.92980002f,-0.68979998f,0.20470001f,0.05480000f,0.33389999f,-0.17040000f,0.05450000f,0.86489999f,0.00710000f,-0.35040001f,1.11979999f,-0.25959995f,-0.64790001f,-0.14270000f,-0.33899996f,0.13880000f,-0.18080004f,0.02650001f,1.06470001f,0.05690001f,-0.13820000f,0.99459998f,-0.73460000f,1.92270003f,-0.43080001f,2.33370003f,-0.64190004f,0.03090000f,0.15150002f,0.64810002f,-0.65700003f,1.35150003f,0.08050000f,0.48429999f,0.22380000f,-0.79600000f,0.98560004f,1.33830000f,1.52460001f,0.40840001f,0.78950003f,0.68079998f,0.25200003f,-0.65860002f,-0.78960002f,0.66490003f,0.95690002f,-0.27640002f,0.19690003f,0.47260000f,-0.58640000f,0.09430001f,0.08380000f,-0.38439999f,-0.50699998f,-0.55800003f,-0.65189996f,0.17230000f,-0.32150001f,1.12109999f,-0.05499999f,-0.17990001f,-0.18840000f,0.05410002f,-0.74490000f,0.35989999f,0.61429998f,0.58539998f,-0.15850000f,-0.36450000f,-0.51220000f,0.62590001f,-1.48410002f,0.46180000f,-0.85249999f,0.70540002f,-0.45809999f,-0.00130001f,-0.30780001f,0.63500001f,-1.19920001f,-0.07729998f,-1.71020006f,0.68730005f,1.38649998f,-0.42420001f,0.03099997f,-0.70570003f,0.66010000f,0.95590000f,0.93049998f,0.85529998f,1.94199999f,2.04370001f,0.71520000f,-0.19810003f,0.06819997f,-0.39340003f,-0.60469997f,0.00809996f,0.91489998f,0.49600001f,-0.05849997f,-0.45299997f,0.43370002f,-0.60640000f,-1.02370000f,-0.26589999f,-0.88389997f,-0.72340001f,-1.08679997f,0.57800000f,-0.49790001f,0.28919997f,0.00840002f,0.20530004f,-1.42220001f,0.05399997f,1.55130002f,-0.25649999f,-0.15290005f,-0.34410001f,-0.38749997f,-1.91280000f,-0.56569997f,-0.84539996f,0.47580000f,-1.71669996f,-1.86670001f,0.04690006f,-0.58969999f,0.69980004f,-0.81160003f,0.22390004f,-0.34540000f,1.78719999f,0.31630001f,0.40050002f,-0.38039999f,-1.11859995f,-1.00120000f,-0.36220001f,-0.06450001f,-1.01889993f,-1.03210000f,1.14920006f,0.08180000f,1.46100000f,-0.03750000f,0.92410006f,0.21860003f,1.02119997f,0.85220000f,0.34420000f,0.27440001f,0.45099999f,1.19950004f,-0.94929998f,-0.67040002f,-0.12640002f,-0.44940001f,-0.66690001f,1.53280003f,0.45279999f,-0.87620003f,-0.76520002f,0.83190002f,-0.62180002f,-0.96660002f,0.16799998f,0.90960002f,-0.13230004f,-0.47319999f,0.93020002f,-0.41210001f,0.17150000f,-0.97880008f,-0.45869998f,-1.38169999f,0.49990001f,0.88900002f,0.12130000f,-1.02940002f,-0.48890000f,0.19300005f,-1.39780001f,-0.67100002f,-0.43160000f,-0.34750001f,-0.07940000f,-0.38910006f,-0.22650001f,-1.72580002f,-0.53520001f,-0.27999997f,-0.18590001f,0.59269995f,0.43540000f,-1.03149995f,-1.09560002f,0.84190002f,-0.37780000f,-0.21129998f,-0.38880002f,0.60959998f,0.21630000f,0.51459999f,-0.57970004f,-1.58680000f,0.91040001f,1.08460000f,0.71060001f,-0.42190000f,0.39390001f,-0.33699995f,-1.50289999f,-0.02770000f,1.38390000f,0.96419994f,-0.24260001f,-1.37100000f,-0.65580002f,1.00080000f,-0.80800000f,-0.56120004f,-2.64620001f,-0.79229998f,-0.34659999f,0.30659999f,-1.00050003f,1.71040000f,-0.00900005f,-0.35990000f,-0.57250005f,-0.51679997f,0.33640001f,0.31570000f,-0.03079998f,-0.09489997f,1.45539999f,-0.45020003f,-1.23599995f,-0.58720000f,0.30029998f,0.38189999f,-0.53050003f,0.41610001f,-1.07750005f,-0.03380000f,-0.53969998f,-0.21490002f,0.91779996f,0.29059999f,0.40129999f,-0.07079998f,0.45419997f,0.19770000f,-0.22210000f,-0.33490001f,0.35570000f,0.44910000f,-0.03040002f,1.22430000f,0.22230000f,-0.26270002f,-0.07440002f,1.63310000f,-0.95949998f,0.11120001f,0.42890002f,1.15130002f,-0.90649999f,0.23480003f,-1.20970002f,0.05590000f,-0.81340002f,-0.38749999f,-0.23509997f,-0.79259998f,-0.37279998f,-0.43489998f,-0.78089998f,-2.23280003f,0.70410001f,-1.09369998f,-0.87949998f,-1.03430000f,0.09530002f,-2.56530005f,-0.23000000f,-1.54490003f,-0.28450000f,-0.19989997f,0.10950000f,0.03580002f,-0.20480000f,-0.03610004f,-0.03870001f,-1.50259998f,-0.24190001f,-0.10610001f,-0.39579998f,-0.98080000f,-0.31649999f,-1.54110002f,-0.78190001f,-0.56079999f,-0.34910000f,0.08229999f,0.76589999f,0.60639997f,-0.72450003f,-0.25110004f,1.43990001f,0.80090002f,-1.13389996f,-1.35250000f,-0.25560001f,1.50839996f,0.08450000f,-0.19109998f,-0.21279998f,0.38849999f,-0.50530000f,-0.48660002f,0.09050001f,0.06610001f,0.67780000f,-1.16590002f,-0.43169997f,-0.60310000f,0.37770006f,-0.27800003f,-0.68770004f,-0.09290000f,1.86659997f,0.83049999f,1.22770000f,0.10070001f,1.14329998f,-0.66939999f,-0.35620001f,0.24339999f,0.64609997f,0.03249998f,0.53770007f,-0.25760000f,0.76010000f,0.10110001f,0.03030002f,0.03930000f,1.19109996f,0.85959999f,0.82239998f,0.17160001f,0.29410000f,-0.46879999f,-0.09700000f,-0.24150000f,0.41419999f,-0.03060001f,-2.08850001f,-1.39700004f,0.23170000f,0.35300001f,1.12280005f,-1.17779997f,-0.88299999f,-0.06980000f,1.59169998f,0.49030001f,1.05859994f,0.71729995f,0.55360004f,1.04470004f,-0.50520000f,-0.60379999f,0.82520002f,-0.99710000f,-0.12500002f,1.41290000f,0.17299997f,1.05460001f,0.56869999f,-0.38440005f,-0.37270002f,1.48509998f,-1.05079996f,-0.24259999f,-0.15460004f,-1.52740001f,0.51370002f,-1.01300002f,-0.29800001f,-0.55450001f,-0.53710000f,0.65420001f,0.13250000f,0.10879998f,0.51130002f,-0.38230000f,0.15119999f,1.20899998f,0.46739999f,0.32319998f,0.66809997f,-0.85280002f,0.32140000f,-0.23120002f,0.03900000f,0.41300000f,0.96680002f,-1.14240000f,-0.62239999f,-0.59680002f,-0.15720000f,-0.21849997f,0.10310001f,0.05540002f,0.13610005f,-1.26420002f,-1.39060005f,-0.07700000f,0.18330002f,0.56970000f,0.37819999f,0.41569996f,-0.47420000f,0.34580000f,-0.84099999f,-0.93850000f,-0.12400000f,0.59839997f,0.47709998f,0.75169997f,0.01479996f,0.07640002f,-0.55119999f,-0.36960003f,-0.09360002f,0.03510001f,0.51050001f,-0.74679999f,0.54210000f,-0.12880001f,-0.12239999f,-0.93089999f,0.16270002f,-0.22629999f,-0.13390001f,0.21740000f,-0.75579997f,-0.72900000f,-0.37749998f,-0.54309999f,-0.40159999f,0.17569999f,0.74370001f,0.07530000f,0.96199997f,0.30369999f,-0.21039998f,-0.29069998f,1.09070000f,-0.72160001f,0.89370001f,1.22359998f,0.96190003f,-0.37590000f,-1.16999998f,0.31790000f,-0.02960002f,0.18160002f,-0.61930002f,-0.09299999f,0.04019996f,-0.49580000f,0.20680000f,0.55599998f,0.36569998f,1.97989999f,-0.33310001f,1.28930003f,1.09450003f,0.60710001f,-0.16099998f,-1.76139998f,-1.17239999f,-0.54059997f,-0.32889999f,0.01690000f,-0.41239999f,1.16459999f,-0.54800001f,0.49080001f,0.57890001f,1.23560001f,0.63740001f,0.89780001f,0.88470002f,-0.40590004f,0.03940001f,-1.12149995f,-1.01990000f,0.49860001f,-0.12000000f,0.83259999f,-0.22520000f,1.11539999f,-0.10680000f,0.29560002f,-0.00460000f,-0.64060001f,-1.95759999f,-0.30249998f,0.22710001f,0.34759997f,-2.22139998f,-1.17059996f,0.91710003f,1.92310004f,0.65830004f,1.01980000f,0.93700004f,0.38670002f,1.68589999f,1.17129999f,0.41540002f,0.09080000f,-0.15670000f,-0.79639996f,0.26530002f,0.75919999f,-0.21300001f,-0.36079997f,0.60349997f,-0.99979999f,-1.08589998f,0.26659998f,-2.19620001f,0.27370000f,0.68810001f,-0.43380003f,-0.84309998f,-0.01459999f,-0.37700002f,0.12100001f,-0.39950003f,0.66519998f,-0.40330001f,0.54520006f,-0.18850002f,0.64770002f,-0.02289999f,0.13179995f,-0.55830002f,-0.69600000f,0.11920002f,-0.75650005f,0.15620000f,-0.39519999f,-0.01680000f,0.44050002f,0.54630000f,-0.52470004f,-1.30240005f,-1.44000002f,-0.65710000f,-0.46840003f,0.32090003f,1.02260001f,-0.23640006f,-2.34730003f,-0.59419997f,0.03890004f,0.12349997f,-0.35660002f,1.11910004f,0.75440001f,0.51019999f,-0.42529999f,1.27669999f,0.68519998f,-0.24399998f,0.84470004f,-1.04269999f,0.39380000f,1.40420000f,-0.34650002f,-1.08329998f,-0.11820000f,0.93040001f,-0.85900000f,-0.92980000f,-0.54620000f,0.31330001f,-0.30329998f,0.39979995f,-0.39490000f,1.52990003f,-0.23340001f,0.44819999f,-0.19160000f,1.83970003f,-0.48830003f,0.72670002f,0.04199997f,-0.11359996f,-0.19129999f,-0.28070001f,0.35350001f,0.11540002f,0.42720000f,-1.15600001f,-0.27050003f,-1.29270000f,-0.19669991f,0.94620001f,1.27550001f,0.51989999f,-0.38270000f,-0.85300003f,-1.76200002f,-0.71700005f,0.32590004f,0.98070001f,1.04429995f,-0.03100001f,-0.73060003f,0.46599998f,0.40779996f,-0.44690004f,-0.84199999f,1.35750000f,-0.34509999f,-0.92930003f,0.52300000f,1.29140000f,0.65409998f,1.22359999f,-1.45999998f,0.28600000f,0.14640003f,-1.48969997f,0.56020000f,0.86670005f,-0.10270002f,-0.70649998f,-0.43830001f,0.16030002f,0.36179999f,-0.45080001f,0.07390001f,-0.29790000f,0.41519998f,-0.54090001f,1.59910004f,-0.83450001f,0.56040001f,-0.30550000f,0.52810002f,-1.20040005f,1.42980004f,-0.24960001f,1.03950004f,-0.26060000f,0.38260002f,0.74360003f,-0.39399998f,0.38900001f,0.25720001f,0.30559998f,-0.71960001f,0.48370004f,-0.84749996f,-0.80679998f,-0.42649996f,0.56610001f,-1.74390001f,-0.59569996f,-0.60760000f,-0.33579999f,-0.32200001f,-0.25200000f,0.02029998f,-0.71209996f,-0.57969999f,0.66480000f,-0.47950001f,-0.97239997f,0.73890001f,0.37280000f,-0.08190000f,-0.09679999f,-0.15930001f,-0.19970000f,0.43189999f,0.13630001f,0.83210001f,-0.01810000f,-0.15350000f,-0.75850002f,0.25530003f,-0.58560001f,-0.14259998f,-0.40300006f,0.52389998f,0.67020004f,0.59650001f,-0.81739998f,0.24610000f,-0.78440001f,0.05240000f,-1.72189998f,0.28020000f,-0.01849999f,0.54550000f,0.24759999f,0.30479997f,-0.04879998f,1.03860005f,0.78600007f,0.86150001f,0.07929995f,-0.20399997f,1.70229998f,0.93399996f,0.26550000f,-0.60550001f,-0.65789997f,-0.12330003f,-0.12950002f,0.20619998f,0.03080000f,0.10720001f,-1.14909999f,-0.92150000f,-0.65919998f,0.61820000f,-1.45920005f,-0.20690001f,1.38660000f,-0.18790000f,-0.84359996f,0.42919997f,-0.12550000f,0.13950001f,-1.15069997f,0.13669999f,0.21830002f,0.28859999f,-0.14840001f,0.66750001f,0.76580002f,-1.24130002f,0.18470002f,-0.02080001f,0.23169996f,0.68580004f,0.24760000f,-1.32829999f,0.15480001f,0.84109998f,-0.66710000f,1.71890002f,-0.56820003f,1.04750003f,-0.07580004f,-1.21120005f,-1.61930004f,0.36759997f,0.19219999f,0.95960006f,0.17830001f,-0.25320008f,-0.70359998f,1.05690001f,1.26020001f,1.55399996f,1.43519996f,0.18380002f,0.49490008f,-0.19810000f,-0.42760000f,-0.35400000f,0.66870000f,1.50990004f,-0.23190004f,-0.15709998f,0.63569999f,-0.20420003f,-0.53440002f,1.53589998f,-0.77469998f,-1.68629999f,-0.12779997f,-0.36480000f,-0.72830000f,0.37059998f,0.02800001f,0.39579999f,0.14259999f,-0.69170001f,-0.50059999f,0.53880002f,-0.20280000f,0.23050000f,0.27149998f,-0.64040002f,-0.85589999f,-0.00400000f,0.14869999f,0.49190001f,0.36020000f,-0.13640001f,-0.83679999f,0.37080002f,-0.34250001f,0.37280001f,-1.60159996f,-0.77569999f,0.13560000f,0.34289998f,0.22569998f,-0.69240000f,-1.69759996f,-0.83739995f,-0.79409999f,-0.84430005f,0.19949995f,0.17010002f,0.13190002f,0.51870002f,1.11939999f,0.91299997f,-0.39180001f,0.23450001f,-0.58219999f,0.42449999f,0.18170002f,0.64809996f,0.81279997f,-0.22230000f,-0.53110002f,0.91970002f,0.62850000f,-0.40680003f,0.94290001f,-0.76269997f,-1.11590001f,0.31309999f,-0.76749997f,0.20740001f,0.49610001f,-1.17539999f,0.81330003f,-0.14030000f,-0.65580000f,-0.15050002f,-0.61200002f,0.14970001f,0.07550001f,-0.08690001f,0.11880000f,-0.62789997f,0.48320001f,-1.41760000f,0.39960002f,-0.54700001f,0.22100004f,1.17050003f,0.41450001f,1.75840002f,0.82929999f,-0.31549997f,-0.64710003f,-2.05739999f,-0.50929996f,0.36970002f,1.04870001f,-0.02480000f,0.22119999f,0.38759999f,0.38419995f,0.30860002f,0.44120000f,0.74709999f,-0.19400001f,-0.82630000f,-0.09910000f,0.04880001f,0.48610000f,-0.56470000f,-0.71719998f,0.28439999f,-0.13919999f,-0.76889999f,-0.01479999f,-0.58519997f,0.39859998f,-1.02099996f,0.08860000f,-0.29780000f,-0.59710001f,0.84870000f,0.45309999f,0.69429998f,1.23369998f,-0.04460001f,0.24220000f,-0.02910000f,0.35600000f,-0.36270000f,0.91049999f,0.59310003f,-0.58860003f,-0.02039998f,-0.47670000f,-0.80650001f,0.41670004f,0.03099998f,0.97419998f,-0.05280000f,-0.18299998f,-0.64470000f,-0.53469998f,-0.47660000f,0.29710001f,0.29700000f,0.25509996f,0.90719999f,-0.35520006f,0.23939999f,0.14060002f,-0.40230001f,0.77540002f,0.18580001f,-0.38989998f,-0.26319996f,-0.22910001f,-0.81440002f,-0.45160003f,-0.27330001f,-0.08270002f,0.56209998f,0.89480003f,0.12880003f,-1.34709996f,-0.21500000f,-0.92129999f,-1.65440004f,0.35250005f,0.43180003f,1.22450001f,0.41449998f,0.80830000f,0.76129997f,-0.26780002f,0.36460000f,-0.56730002f,0.94450005f,-0.52450002f,0.13200002f,0.69510001f,-1.85950003f,1.46230000f,0.05549999f,-0.35950005f,1.01250002f,0.35030000f,1.35670001f,0.09940000f,-0.14409999f,-0.36160001f,0.27320004f,-0.48190001f,1.13340005f,-0.13060000f,-0.30960000f,-0.07189998f,-1.69080001f,-0.26229999f,-0.64919998f,-0.28849999f,0.47240004f,0.51310002f,0.78460000f,0.51040001f,-0.13970003f,0.23869998f,-0.71140000f,-0.77479996f,-0.83569997f,-1.00080000f,-0.43710000f,-0.74729998f,0.60900004f,0.07309999f,-0.46159998f,-0.21940000f,-0.69979998f,0.17300000f,-1.01389997f,-0.74300000f,0.23949999f,-0.14469998f,-0.30610002f,0.27040002f,0.76059998f,1.01189998f,0.75749998f,1.89149996f,0.10560000f,1.36799999f,1.17369999f,-0.82240005f,-0.05550000f,-1.15499998f,1.06899999f,-0.04889999f,-0.69430001f,0.62570001f,-0.54380000f,0.57660000f,-0.15819999f,0.16410002f,-0.24979998f,0.64480000f,-0.33259997f,-0.18460002f,0.23120001f,-1.64279999f,-0.75550000f,-1.03749996f,-0.19969999f,-0.18619998f,-0.57759999f,0.30820002f,-0.04239999f,-0.04770000f,0.56930001f,0.07239998f,0.82449998f,-0.68320000f,-0.52639995f,-1.22440000f,0.28909998f,0.59499997f,-0.09960004f,-0.38209993f,-0.19939996f,-1.18649998f,-1.63540001f,-0.43919998f,0.31560001f,1.14389997f,-0.13590000f,-0.73829997f,-0.78299998f,-0.49570001f,-1.77320001f,-0.17140002f,-0.90680001f,1.37820000f,1.47499998f,1.25549998f,-0.21049998f,0.29260000f,-0.51250000f,0.42199997f,0.09619994f,-0.04289999f,1.35449998f,-0.34380000f,-0.24709999f,-0.49190001f,-0.85709999f,-0.65280001f,-0.19139998f,0.16980000f,-0.00550004f,0.53900000f,-1.32589997f,-0.95579999f,-0.81839999f,-0.25189999f,-0.44140000f,-0.05190001f,0.94739997f,0.48600000f,0.71799999f,0.63460001f,-0.79609999f,0.59120002f,-0.35280003f,-1.78690003f,0.02600000f,0.19470001f,-0.00380002f,-0.19160004f,2.22860002f,0.57670001f,-0.22600000f,1.21169996f,-0.61490002f,-0.96390000f,-0.12989991f,-0.63639999f,0.15160002f,-0.95869999f,0.32740002f,0.77119999f,-0.90780003f,-0.20720001f,0.52380000f,1.52540003f,-0.79569997f,1.14820004f,-0.48799994f,-1.92739999f,1.20439999f,-0.07290001f,0.70820000f,-0.01309996f,0.10540000f,0.04769999f,-0.27750000f,0.48599997f,-0.21120000f,-0.27119996f,0.05830000f,1.65070000f,0.66060002f,0.24369998f,0.41590001f,-0.68030003f,0.08809998f,-0.15200004f,0.31100001f,-1.00139995f,-0.34559998f,0.57990001f,-0.48159999f,-0.71660001f,0.85129999f,1.44669997f,0.45610001f,-1.64049998f,-0.73169999f,0.54669998f,-0.24360003f,-1.38389997f,-0.88310002f,0.25790003f,0.56570004f,-0.92549997f,-1.30280000f,0.09249999f,-0.50610001f,-0.02690001f,-0.94480002f,-0.30069998f,0.89650003f,0.94369999f,0.09930001f,-0.03969998f,0.95369999f,1.35719998f,-0.65669999f,-0.31500002f,0.22990002f,1.64749999f,0.54449998f,-0.35170001f,0.53989997f,0.14159999f,-0.07949998f,0.14559999f,0.80649998f,0.41840000f,0.32589999f,-0.52479999f,-0.53640000f,-0.02950001f,-1.16279997f,-0.73050000f,-0.33409997f,0.17450001f,-0.07760002f,-0.37679999f,-0.27499999f,-0.26260000f,-0.32340000f,-1.06220001f,-1.16709999f,-0.38200000f,0.57029997f,0.26910001f,-0.91009999f,-1.43929997f,0.30900001f,-0.49290000f,0.23759997f,-0.95529999f,0.45220003f,-0.43410000f,0.54599997f,-0.10160001f,0.46360000f,0.15239999f,0.56109998f,-0.37770004f,-0.73579998f,0.49129999f,0.41169998f,0.73650000f,0.12479999f,1.65679996f,0.49909998f,1.62399998f,-0.05300004f,1.59320001f,0.59439999f,1.24079996f,-0.35620002f,0.67040003f,-0.18030001f,-0.77579999f,-0.66460000f,0.49780000f,-0.08160000f,0.89079997f,0.06390002f,0.50940000f,0.24280000f,0.87290001f,0.15439999f,0.78350000f,0.63290001f,0.44720000f,0.10469999f,0.51400001f,0.16820000f,-0.01889999f,-0.34959998f,-1.21709995f,0.30229998f,-0.50300000f,-0.53949998f,0.11529999f,1.28019998f,0.62529997f,0.84359997f,-1.39439997f,-0.31579999f,0.06810004f,0.36500000f,-0.43959999f,0.48940002f,-0.35340000f,-0.14910000f,0.47380001f,-1.48169996f,-0.48900000f,-0.59399999f,-1.15380000f,-0.85190001f,0.50050005f,-0.79710002f,0.83700001f,-1.28859998f,-0.69460000f,-0.87789998f,0.14440001f,-1.67400003f,0.06760000f,-0.59180000f,-0.18209999f,-1.45489992f,-1.03909998f,-0.07690000f,-0.58830001f,-0.25529999f,0.33150000f,-0.71050006f,0.13179999f,-0.85310000f,-0.82639999f,-0.96759997f,-0.19249998f,-1.07400001f,-0.25020001f,-0.06920000f,-0.00840000f,1.26390006f,0.16439999f,-0.95090004f,-1.15880000f,-1.25780005f,-0.86590001f,-0.44700001f,0.54289996f,-0.08980002f,1.54399999f,1.15320000f,0.02359998f,-0.19540001f,-0.72190002f,-0.03390000f,0.89380003f,0.82240000f,-0.70280002f,1.36389999f,-0.12740001f,0.82580000f,0.11460002f,0.11779999f,0.27450000f,0.02290000f,0.84500001f,-0.58329999f,-0.31940000f,-0.18649999f,0.12010001f,-0.48729999f,-0.44999999f,0.28760000f,-0.59680000f,0.04089999f,-0.03600002f,-0.90870001f,0.26610002f,-1.15380002f,0.50110003f,-1.35940005f,-0.13249997f,-0.11930001f,-0.48470003f,2.03090003f,-0.24650001f,0.08250001f,0.90170003f,-0.37630001f,0.06720000f,-0.69750000f,-0.61800000f,-0.85480002f,-0.94210003f,-0.65590001f,-0.03770000f,0.34640003f,0.51990000f,0.15970008f,0.49570002f,-1.05360002f,-1.38969999f,-1.14880000f,-1.69430001f,0.95360001f,0.51030006f,0.90160004f,0.39880000f,0.51909998f,0.32140001f,-0.04000001f,-0.21240000f,-0.39809998f,0.13969999f,-0.97760001f,0.48530000f,-0.70340001f,0.47629998f,2.13979998f,0.31950000f,1.06880001f,-0.47110005f,0.47119997f,-0.05379999f,-0.94940002f,-0.89290000f,0.35860002f,-0.35030003f,0.43989999f,-0.87689999f,0.58880001f,-1.95249996f,0.62050000f,-0.45710002f,-0.86090002f,0.22890003f,-0.12880000f,1.12319998f,-0.37850001f,-0.51950001f,0.52320002f,-0.73050001f,0.09729999f,0.23670001f,-0.11220001f,-0.51140000f,-1.14120001f,-0.53569998f,-0.96520003f,0.50479999f,-0.25370004f,-2.11629999f,-1.51869998f,-0.53379999f,-0.47809998f,-1.36439999f,-1.30929998f,0.30880002f,0.52119999f,-0.97699998f,0.93599996f,-0.06099999f,0.67899998f,0.57149999f,0.55169998f,-0.21109994f,0.89309996f,0.37879998f,-0.06650000f,0.62200000f,0.22950000f,1.18709997f,0.16819999f,0.17209998f,0.09139999f,-0.33139999f,-0.49049999f,-0.38330000f,-0.15150001f,-0.65660000f,0.76629999f,0.35919999f,1.23640001f,0.12310001f,-0.01250001f,-0.78480001f,-0.68330003f,0.17360000f,0.81409999f,0.29009998f,-0.11479995f,0.24840000f,-0.78749999f,0.03810001f,-0.56499998f,0.51099999f,-1.04609999f,-0.04929997f,0.30029997f,-0.30039998f,0.55849998f,-1.00080007f,-2.38559997f,-1.57509996f,-0.47240000f,-1.11500003f,-0.58580006f,-0.53449997f,1.08420000f,0.66119997f,-0.59379999f,-0.07919997f,-0.83570000f,0.11659999f,-0.00300001f,0.22370000f,1.56209997f,0.92960000f,0.52410002f,-0.09040001f,0.06019996f,1.18249999f,1.51109998f,-0.78490001f,1.00100001f,0.05700000f,-1.03259998f,0.55920001f,-0.43720002f,0.34550001f,0.10940000f,-0.73840001f,0.58700001f,0.02890002f,0.55670002f,-0.65410000f,0.16560003f,-0.83580001f,-0.52240003f,1.71030001f,-0.24319998f,1.11260000f,-0.16500001f,-0.18400003f,0.73760001f,-0.55880000f,-0.23509999f,-0.07070001f,-0.53920006f,0.14119999f,0.68940005f,1.35430001f,0.01939997f,0.95830005f,1.47489998f,0.00199995f,0.46749999f,0.27880000f,-1.22540004f,-1.20289997f,-0.88039996f,-0.20860000f,-0.23529999f,-0.02250000f,1.07729999f,-0.37809998f,-0.88240001f,0.56840000f,0.31140000f,-0.28489997f,-0.54459997f,-1.46779998f,-0.59399997f,0.54520000f,1.23709997f,1.04270004f,-0.41200000f,0.65579994f,0.73830000f,0.00869998f,0.86680003f,-0.06789998f,-0.58760001f,-0.07270001f,-0.46400000f,0.42540001f,-0.44620002f,-0.49920000f,0.17249998f,0.41010002f,0.16419997f,-0.33530002f,-0.49120000f,0.44040000f,-0.79649998f,0.30240001f,0.00849997f,0.01440004f,1.01440003f,1.01259997f,-0.91880000f,-1.44360002f,0.02289998f,-0.25460007f,-1.97490000f,-1.92839999f,0.31520001f,0.17000002f,-1.07590000f,-1.79690002f,-0.39020001f,0.03279999f,0.12749998f,-0.75410000f,0.86359999f,-0.10569997f,-1.46819998f,0.94629997f,0.38500001f,0.76190000f,0.28110001f,0.23760000f,1.17539999f,0.02619998f,0.55069997f,0.82859999f,0.36289998f,-0.12400001f,0.07720002f,0.18239998f,-0.03820001f,-0.29469997f,0.22830000f,-0.94509998f,0.41340001f,-0.38259999f,0.83609999f,-1.11629999f,0.45160001f,-1.30230001f,0.93720002f,-0.51150003f,0.12879999f,-1.08069999f,0.30000002f,-0.51600002f,-1.10910006f,-1.55900003f,-1.15699999f,0.19810000f,0.85849998f,0.40160000f,-0.61760002f,0.47739997f,-0.06610002f,0.31319999f,-0.22570002f,1.32439999f,0.24050000f,-0.02190003f,-0.17380001f,0.57640003f,0.49720000f,0.41919999f,-0.17020000f,0.88920002f,-0.42749999f,-1.00159997f,1.00559996f,0.24440002f,0.05249997f,0.14260000f,0.12649999f,-0.44889999f,0.37839998f,0.29119997f,-0.34150000f,-0.51929999f,0.09380000f,-0.51620001f,0.42409997f,-0.68940001f,0.18589999f,-0.20720000f,-0.36110002f,0.35050000f,1.07960003f,-0.83220002f,1.02390003f,-0.81120001f,0.39459999f,-0.03599999f,0.70270000f,-0.68240003f,1.24980003f,-0.21720001f,0.54200001f,-0.87310001f,-2.33789995f,-1.18129996f,-0.73700000f,0.08090001f,0.83690000f,0.97820001f,-0.17360001f,-0.12390004f,-1.79579999f,-1.38729999f,-0.26959996f,0.25860003f,-0.86520002f,-0.30599997f,-0.04539999f,-0.11199999f,0.30869998f,-0.36139996f,0.66679997f,0.12779998f,-0.51980000f,-0.27589998f,0.61340000f,-0.10819996f,-0.08299996f,0.37759998f,0.45980000f,0.08230000f,0.47369998f,-0.48600000f,0.65999999f,0.07240000f,0.20319999f,0.51760000f,0.77490001f,0.98810000f,-0.19879996f,-1.46809998f,-0.04669995f,-1.68559996f,0.53899998f,-0.42349998f,-0.13059999f,0.69900002f,0.54630000f,-1.63640002f,-0.00090002f,-1.02519999f,-0.61669998f,-0.00720003f,0.25730001f,-0.16130002f,-0.20419999f,-1.43369997f,-0.64890000f,-1.05039999f,-0.67010001f,0.12430002f,-0.45530000f,-0.54499998f,-0.27970000f,-1.50010001f,-0.52490001f,-0.73209996f,-0.63449999f,0.56979997f,0.13489999f,-0.33980000f,0.17770001f,0.38390004f,0.35310001f,-1.89780005f,-1.64340000f,-0.62340000f,-0.87209999f,1.09759998f,-0.31820002f,1.72659994f,0.80229998f,-0.14630001f,0.29330001f,0.83369997f,-0.02360001f,-0.78670000f,0.36080001f,0.26680003f,-0.17409999f,0.26639999f,-0.92520002f,-0.80520004f,1.05760003f,-0.44030001f,2.25460001f,-1.20039997f,0.81360002f,-0.24080002f,0.42790002f,0.24450002f,0.59530000f,-0.64120000f,-0.87229997f,0.09460002f,-0.80400000f,-0.60300002f,-0.20289998f,-1.00730001f,1.05280005f,-0.00669999f,1.69499999f,0.72400000f,1.03549999f,0.41719998f,1.32279995f,0.71749999f,-0.04169999f,-0.36290001f,-0.10639998f,-0.22970000f,-0.46530000f,-0.08920000f,1.41609999f,-0.79010000f,-0.17729998f,0.41540002f,0.88689997f,-1.14880001f,0.47300003f,1.33910002f,0.68989997f,-0.58550003f,-0.73890001f,1.22560002f,-0.41550002f,-0.74940000f,-0.76779999f,0.53910000f,-0.45669999f,1.50870000f,0.13319997f,0.15529997f,0.57750002f,1.99670000f,-0.31759999f,0.49620001f,0.38370004f,0.50409997f,0.11310002f,-1.65950006f,0.16720000f,-0.28990000f,0.24890000f,-0.79600002f,0.08280001f,0.86619997f,0.72640000f,0.35920000f,0.38610000f,1.21359997f,0.68500001f,0.16570000f,0.07249999f,0.08549991f,0.36899999f,-1.40960001f,-0.81030003f,-0.00210003f,-0.08680000f,-1.02539998f,-0.47870000f,0.46380000f,-0.57460000f,-0.87529999f,0.75639999f,1.37770002f,0.31060004f,-1.53640003f,-1.74390003f,-0.57329999f,0.26209999f,0.83470000f,-1.43910002f,-0.30039998f,-0.19019996f,0.97490001f,-0.25430002f,1.12410000f,-0.37020000f,0.47919999f,-0.36089999f,0.16930001f,1.19850000f,0.35740001f,-0.49660001f,0.31670000f,0.49870001f,-0.15810002f,1.59550004f,-0.32710004f,0.34560000f,0.26350001f,2.30150003f,0.20770001f,1.44669999f,0.18480000f,0.01090002f,0.26260002f,0.53009997f,-0.15420001f,-0.36100000f,-0.29689998f,-0.13899995f,-0.39300001f,1.04240000f,0.34000001f,0.41040004f,0.28090002f,1.70769999f,0.96210002f,0.50919997f,0.31589999f,0.32900001f,1.20810004f,0.18440000f,-1.10670006f,-0.01329998f,1.25440003f,0.05930002f,0.35409998f,-0.59839996f,0.27820002f,-1.41509998f,-1.46689999f,-0.56879996f,-0.39290001f,0.96569996f,1.07610002f,0.38899996f,-0.03380001f,1.21350003f,0.45260000f,-0.54820003f,-1.03810002f,0.97540003f,-0.46889998f,0.59749998f,-1.07419999f,0.78019999f,-0.59950000f,0.45899997f,-0.11540003f,-1.45389998f,0.31209998f,-0.66989999f,0.30040002f,0.48290000f,-0.13880004f,-0.01120000f,-1.11719999f,0.02240000f,-0.54580000f,0.14320000f,-1.24399997f,-0.78520000f,-0.88179999f,-0.33309999f,-0.78959996f,-0.53999999f,1.06939999f,0.18259999f,1.20119998f,0.46180000f,0.34050001f,0.59560001f,1.07590001f,0.56550003f,0.13769998f,1.07249999f,0.45519995f,0.21759999f,-0.29820000f,-0.26479999f,-0.02940000f,0.34120000f,0.02159999f,-1.34760003f,0.56030001f,0.70800000f,0.36490003f,-0.17730000f,-0.77739999f,-0.29349998f,-0.77239997f,-1.04929999f,-0.67549998f,-0.29579999f,-0.09379999f,-0.63479999f,0.08469999f,0.11280000f,0.90309999f,1.08319998f,-0.26470001f,0.13750000f,0.59649998f,0.15910003f,0.21330001f,0.34310001f,0.43070001f,0.32480000f,0.07649999f,0.58219996f,0.24539999f,-0.20820001f,0.05050000f,0.16730000f,0.24399999f,0.34719997f,0.23080001f,-0.52039997f,0.32029999f,0.15420001f,0.25520001f,-0.84690001f,-0.45130000f,1.04500000f,-0.59400001f,0.49940000f,-0.37310001f,0.07070004f,1.11940003f,1.79970002f,-0.80469998f,-1.74560006f,0.30169993f,2.67790000f,1.28760002f,-1.36639998f,-0.89009999f,0.12780001f,0.87930000f,-0.10890003f,2.05480002f,-0.60560001f,-0.06239999f,0.57939994f,0.07269999f,0.41910001f,0.48169996f,-0.07889998f,-1.25340002f,-1.07090001f,1.36450004f,1.21300002f,-0.68419998f,-0.64420001f,0.51820003f,0.05940000f,0.99920002f,0.13240001f,-0.24329998f,0.47620000f,0.07970000f,0.74090001f,-0.31860005f,0.28449999f,0.04910003f,-0.08310002f,0.93299997f,1.00350001f,-0.01970000f,-0.46119998f,0.13260004f,-0.12269999f,-0.18519998f,-0.81940000f,-1.64599999f,-1.17130000f,0.05819999f,0.11020001f,0.72629994f,0.69289999f,-0.02609999f,-0.72910000f,-0.33459999f,-0.35180001f,0.77530000f,0.45530001f,1.10000003f,0.12650000f,-0.13289999f,0.09579999f,1.48930001f,-0.51180007f,-0.54160002f,0.71919997f,-1.10759996f,0.46110001f,-0.02089999f,-0.14529999f,0.09860000f,-0.46760004f,-0.50330003f,0.86869999f,0.84829999f,0.77140001f,0.26000000f,-0.24609999f,-0.00670000f,-1.33680003f,-0.87150002f,0.46950001f,-0.30630000f,0.95409999f,0.14959999f,0.01909996f,0.22730001f,-0.37480000f,-0.16240000f,0.94689999f,1.11790001f,0.03460000f,0.48140001f,-0.21219999f,-0.03720000f,-0.26590001f,-0.51389998f,-0.61190003f,-1.37629999f,-0.43520001f,-1.36720000f,-0.33840002f,-0.73080002f,-1.24850000f,-0.46229995f,0.06829998f,-1.34860004f,-1.25200001f,-1.40269996f,-0.30179993f,0.67519998f,0.59179996f,0.53240001f,0.53409999f,-0.67609999f,-0.12609996f,0.66780000f,-0.16509996f,0.03750001f,0.88449995f,0.93329999f,0.19820005f,-0.63970002f,0.49479998f,1.41230001f,-0.75769998f,0.10179997f,0.27009999f,-0.35209996f,0.09100000f,-0.58520003f,-0.58020003f,-0.32280001f,-0.34150000f,1.14590003f,-1.20220002f,1.02320002f,-1.49050001f,0.26340001f,-1.03580000f,0.44870002f,0.45719998f,-0.41440001f,-1.18280000f,0.09600002f,0.46649998f,-0.59970003f,-1.31300001f,-0.33900000f,-1.65470001f,-1.12210001f,0.56490000f,0.42610001f,1.74509998f,1.06879997f,1.14109998f,1.99329998f,1.74419997f,0.51649998f,-0.73789997f,0.04969998f,-0.10759999f,0.15100001f,0.50790002f,-0.22669999f,-0.63270004f,0.57750000f,0.20190002f,0.05619998f,0.06470000f,-0.17020000f,-0.96699999f,-1.24409995f,-1.81089997f,0.66019996f,-0.00690000f,-0.34229996f,-1.29749999f,0.22009999f,0.36190000f,-0.60689998f,0.59360001f,-0.52610001f,0.33389999f,0.19780004f,0.45020001f,-0.82270000f,0.32229999f,-0.66500000f,-0.18350001f,0.38660001f,-0.67640005f,0.38880004f,-0.22469999f,0.46329999f,-0.16080001f,0.32300002f,0.07560001f,1.65169999f,0.99859997f,0.48269998f,0.09990004f,1.37380001f,0.05319993f,0.06649997f,0.51520001f,0.75039998f,-0.12920009f,-1.97470007f,-0.55199998f,0.07100002f,-0.41040003f,-1.20560002f,-0.75379999f,-0.00489998f,0.23529998f,-0.71709999f,-0.63750002f,0.56260000f,0.68060000f,-0.61119996f,-0.88499999f,-0.24990001f,1.06790002f,-0.24299997f,-1.01830000f,0.51350002f,1.10960000f,0.05510001f,-0.21070000f,0.92070000f,0.71819999f,0.19950000f,0.75890002f,-0.36360001f,-1.57670002f,0.13330001f,0.68240002f,0.35629999f,-1.03780003f,0.46210004f,-1.05020004f,0.69650002f,-0.13649998f,0.83650001f,-0.96950001f,0.24180000f,-0.98500001f,0.18180000f,0.13579999f,-0.52439998f,-0.17099998f,0.43090000f,-0.38709999f,-1.18750006f,-0.98840005f,-0.56089999f,1.05540004f,0.48069998f,0.51770000f,0.30070005f,1.95930002f,0.52559996f,0.54889998f,0.30859997f,0.25999999f,-0.25960000f,1.24770001f,-0.19340001f,-1.99280001f,1.44640000f,1.26390003f,-0.70810001f,0.39460000f,0.62589999f,-0.97600000f,-0.56910003f,0.62240001f,0.26520000f,-0.58549999f,-0.13130001f,-0.76729999f,0.57400001f,-0.52400002f,-0.03990001f,0.09400001f,1.04500003f,-0.65790002f,0.98309997f,-0.79040000f,0.21049998f,-0.07940000f,0.90629997f,-0.00510001f,-0.53849996f,0.33170000f,-0.91059997f,0.19140001f,0.03749999f,0.57920003f,-0.33700000f,-0.96760005f,-0.20950001f,0.24720005f,-0.18149999f,-0.75970001f,-1.82069996f,-1.01419996f,-0.75970001f,-1.58080002f,-1.45179999f,-0.78869995f,0.89079999f,1.89050001f,1.43370002f,0.99959998f,0.44229999f,0.71230002f,-0.17610001f,-0.61540002f,1.10060001f,0.42770001f,0.39619996f,-0.01699999f,0.24739997f,1.38639997f,1.56319997f,-0.73149998f,0.61860000f,-1.10790000f,-1.55459996f,0.41640000f,-0.87779999f,0.11990002f,-0.15500000f,0.39690001f,-0.31710002f,0.49200002f,-0.13519999f,0.30170001f,-0.09770000f,0.69239999f,0.16709999f,0.19080000f,0.14550001f,-0.31240000f,0.37950001f,0.31229998f,-0.31800000f,0.19749998f,0.79070005f,0.96130004f,1.31470004f,0.30699999f,1.03910002f,0.85250000f,0.93639997f,0.06799998f,-0.01310000f,0.35179998f,0.03700001f,0.31179999f,-0.76010004f,0.31419997f,0.34170002f,0.20900003f,-0.15639997f,-0.14070000f,-0.60519999f,-0.83580002f,-0.85679996f,-0.63010000f,0.09480002f,-0.81439996f,0.05310000f,0.41839999f,-0.16680000f,0.30929999f,0.83059999f,0.17090002f,-0.64610002f,0.69799998f,-0.07339999f,-0.19980004f,-0.71370002f,0.54640003f,-1.85750003f,0.41220002f,0.75039997f,0.19050000f,0.98580001f,-0.64530003f,-0.04889998f,0.21249998f,0.88570004f,0.34620005f,-0.42080003f,-0.69800002f,0.24220000f,0.50100002f,-0.69850002f,-0.51870000f,0.58410005f,0.46300000f,0.92329999f,0.61490001f,0.86269999f,-0.14959993f,0.22030003f,0.34730001f,-0.27860008f,-0.34780001f,2.20670005f,2.14600001f,-1.10649998f,-1.39569999f,0.10090003f,0.39100001f,0.29979999f,0.17200000f,-1.28680001f,-0.03590001f,0.61529997f,-0.40230002f,1.07339996f,-0.16559998f,-1.07990003f,-0.54719998f,1.36930004f,-0.49109999f,-1.65829999f,0.51489998f,0.24589999f,0.04910000f,-0.18210001f,0.64220000f,-0.35300005f,-0.05639997f,0.44540000f,-1.41269996f,0.30130001f,-0.74069999f,-0.00299999f,0.64980000f,-0.06870002f,0.10030005f,0.81510002f,0.57530001f,-0.26980001f,0.00369999f,-0.17700000f,0.23500000f,-1.19970006f,-2.31530008f,-2.23880003f,-0.29310000f,0.43930001f,0.88050000f,1.35519995f,0.55020001f,-0.02910002f,-0.59250003f,-0.16529998f,2.24909999f,1.00620001f,0.41580003f,-0.11639998f,-0.23449999f,-0.25159999f,0.79000000f,0.20839999f,1.48640002f,-0.55430000f,-0.68049996f,-0.25789998f,-1.29079995f,0.69839999f,0.26140001f,-0.73680000f,0.41850002f,0.07439996f,0.36030000f,-0.22709999f,-0.28850004f,-0.06160000f,0.19579999f,-0.19630000f,0.08490006f,0.57340003f,-0.23360001f,0.27890000f,-0.63839998f,0.90250000f,-0.46460001f,0.38320001f,-1.36440001f,0.04130005f,0.38849999f,1.15130002f,-0.17590005f,2.08930000f,-0.31710000f,1.76420001f,0.24220000f,1.04659997f,-0.12430001f,0.43639999f,-0.32789999f,0.38740000f,0.53059999f,0.73110000f,0.42959999f,1.33070002f,0.70250002f,1.60910000f,0.37010001f,1.40400004f,0.27330001f,0.92399999f,0.38660000f,0.18390001f,0.40460000f,-0.64009998f,-0.20699999f,-0.80169997f,0.42820001f,0.40720000f,-0.14120001f,-1.63460000f,-0.81070002f,1.67409999f,0.25990003f,0.12340002f,0.76240002f,0.65689995f,-0.57000002f,-0.46080003f,-0.26130001f,0.57550001f,-1.22070003f,0.49770000f,-1.02730003f,0.21620004f,-0.83820002f,0.26960000f,-0.89080002f,-1.06690001f,0.96830000f,0.38079998f,0.29940001f,0.73150002f,1.27549997f,-0.93170003f,-0.26140000f,-0.08880000f,-1.36250001f,-0.44029999f,-1.12890000f,-0.21320000f,-1.09530002f,-0.31480000f,-0.00200001f,-0.25390000f,0.60580001f,0.79390000f,0.71909999f,0.80160000f,0.64709997f,-0.29390003f,0.07140002f,-0.22650001f,0.69989998f,1.96810001f,-0.29029999f,-1.81349999f,-0.28619998f,0.43039998f,1.13049999f,0.45300001f,-0.06639996f,0.18260001f,-0.66979999f,-1.73290004f,0.11050001f,1.96420001f,0.78499999f,-0.53500001f,-1.22790002f,-0.57089998f,0.61639999f,0.39350003f,-0.26440002f,-0.23300002f,0.09519999f,0.67769999f,0.94149998f,-0.23160000f,1.03990001f,0.19100000f,-0.45909998f,-0.27469997f,-0.14019996f,0.51680005f,-0.11480000f,-1.37190004f,0.07769999f,0.78589996f,0.25820001f,-0.63439995f,-0.05730000f,0.37609997f,0.83499999f,-0.55559999f,-0.04279999f,-0.54540001f,-0.05899998f,-0.37469994f,-0.29710000f,0.80049994f,0.12499999f,-0.99400000f,-0.55710001f,-0.40710000f,-0.13889999f,-0.39959997f,-1.35340002f,-0.52879997f,0.09920000f,0.62289998f,0.15920000f,0.26549999f,0.72700001f,-0.20800007f,-0.60110000f,-0.72430002f,-1.27460001f,1.59620001f,0.66949999f,0.61490000f,0.31530000f,1.03640000f,0.41079999f,0.51649995f,-0.33200003f,-0.35549998f,0.43150001f,-1.06119999f,-0.29229998f,-0.81140000f,0.08300000f,-0.36390004f,1.06950004f,-0.64570002f,1.65360002f,0.81250000f,0.44709998f,-0.09569999f,-0.83410001f,-0.13020001f,-0.97139996f,-0.32360000f,0.57480001f,0.09260000f,0.69610001f,-0.15530002f,1.17060001f,-0.20210002f,1.30870004f,0.16760001f,0.69830001f,0.97000000f,0.15919996f,0.31569999f,-0.28910001f,-0.20829997f,-0.76150000f,-0.64940000f,-0.89580003f,-1.79079999f,0.28010002f,-0.13409998f,0.27539997f,-0.60589999f,0.05050000f,0.43750000f,0.16939997f,-0.45259999f,-0.27309997f,-0.09649999f,-0.12420000f,0.16310000f,0.39030000f,0.59170000f,0.59719998f,1.53139996f,-0.23710005f,1.42589998f,0.46479998f,1.13819996f,-0.34180002f,0.66350000f,-0.26880000f,0.75180000f,-0.09620002f,-0.23809999f,0.47770000f,-0.20960003f,-0.19820000f,0.31650000f,-0.46450000f,0.63109999f,-0.35990001f,0.25720003f,0.09000000f,0.53699999f,0.10629999f,0.62630002f,-0.20360000f,0.69899999f,-0.08310000f,-0.50559998f,-0.02879999f,-0.45440000f,-0.10800000f,-0.12989999f,-1.07080003f,0.43890003f,0.56870004f,1.23810000f,0.68510004f,-1.08600006f,-1.85710001f,1.18210000f,1.09930002f,-0.40709998f,-1.49020001f,-0.41890003f,-0.16110001f,1.30660000f,0.45340002f,-0.46830003f,0.28050000f,-0.18310002f,0.56909999f,-0.80379998f,0.93630001f,0.04840001f,1.06439999f,-1.09089999f,0.98250001f,1.43519999f,0.58509999f,0.27999998f,0.96569995f,-0.50360000f,0.83279999f,-0.27930001f,-0.66730002f,0.29820002f,0.47540001f,0.37000002f,1.52109999f,0.14280000f,1.59909997f,-0.04699998f,0.06770002f,0.40109999f,0.27709995f,0.12039999f,0.14070000f,-0.08370001f,0.34999998f,0.06519998f,0.07420000f,-0.02880000f,0.28029999f,0.84180002f,-0.15600005f,0.29789999f,0.01449999f,-1.12739997f,-1.37599995f,0.02490003f,0.32449998f,-0.88220003f,-0.03289998f,0.68690000f,-0.19259999f,0.55710003f,-0.64799999f,-0.41710001f,-1.12740002f,-0.30970000f,-0.40309998f,0.62139998f,0.35290001f,0.55109997f,0.44739996f,-0.27040001f,0.91950001f,1.32889998f,-0.12130001f,-0.44910002f,0.97050001f,-0.60320004f,0.46620002f,-1.04900001f,-0.37490001f,-1.23480002f,-0.17180001f,1.38209994f,0.18040000f,-0.22700003f,-0.34510000f,-0.55129996f,-0.30569999f,0.01779999f,-0.12700000f,-1.00530002f,-0.01250001f,-0.90280003f,-0.21400000f,-1.14180000f,-0.86300001f,-0.69519999f,-0.47040001f,-0.39360000f,-0.65010002f,-0.12319999f,-0.55550002f,0.32630004f,-0.35150002f,0.35099998f,0.06300001f,0.72950004f,-0.03269999f,0.99660001f,0.53310002f,-0.32760004f,0.10779998f,0.81740001f,0.66040002f,-0.78969999f,0.33300000f,0.50920000f,0.53140001f,0.24500001f,0.08490002f,-0.60690001f,0.22080000f,0.76800000f,1.15870000f,0.07359999f,0.38299997f,-0.49340001f,-0.22960000f,-0.47890001f,-0.51740001f,0.30869998f,-1.22790000f,-0.04859999f,-0.35970000f,0.15030001f,-0.35079999f,-0.11870000f,0.63739999f,0.79040002f,0.55819997f,0.88030001f,0.05240001f,-0.09870002f,0.55770000f,0.12900000f,-0.58399999f,0.06619998f,-0.45499998f,-0.13999999f,1.11920004f,0.14780000f,0.28299993f,-0.17090001f,-0.36240003f,1.10229995f,0.80519996f,0.79790000f,1.25190003f,1.84410005f,1.99900006f,1.00860001f,-0.01280001f,0.88690002f,0.31950000f,1.01670002f,0.79559998f,-0.31169999f,0.31050004f,-1.63169998f,0.70359998f,0.25900005f,-0.37700000f,0.22880001f,-1.17129999f,-1.13429998f,-0.73370002f,-1.10440002f,0.59769997f,-0.66100003f,0.08679999f,-0.48069999f,0.02040000f,-1.10459999f,0.34230000f,-0.62010002f,1.00070003f,-0.26380002f,1.07770002f,-0.71060002f,0.45400003f,0.02369998f,0.56400002f,0.65880002f,-0.23580001f,0.20909999f,0.71709999f,-0.36730002f,-1.69210002f,0.41880003f,-0.13700001f,-0.25080000f,-1.21299999f,-1.02779999f,-0.81620002f,-0.93389999f,-0.93759999f,-0.20570001f,-0.52010005f,-0.75290000f,1.70680000f,1.66760002f,1.28249998f,0.16060003f,-0.54100002f,-0.27460005f,0.06020000f,0.42260000f,0.06470000f,0.33530000f,0.93240000f,0.15819999f,1.35379999f,-0.32759995f,-0.08359998f,0.13579997f,1.02130002f,-0.66180001f,-0.61320001f,-0.12260000f,0.46029995f,0.04750003f,-1.62819999f,0.21190000f,0.09450002f,-0.08949999f,-0.18439999f,0.30539996f,0.42639999f,0.13610003f,0.15190001f,0.51649998f,-0.48270001f,0.41860000f,-0.03030000f,0.42760000f,0.12160000f,-0.60260000f,-0.33059999f,-0.36780005f,-0.15480001f,0.70950003f,1.52060004f,0.76120004f,-0.50330002f,-0.36650002f,-0.03139996f,1.44139999f,0.54240000f,-0.57399997f,-0.81309997f,-0.40130000f,-1.37430005f,-0.80150002f,0.46030003f,0.72960002f,0.49889994f,-1.14820004f,-0.62140000f,-0.80219999f,1.52209997f,-0.26370002f,-0.75310000f,1.02109999f,0.10339998f,-0.06010002f,0.02860001f,0.38789997f,1.05550000f,1.10000001f,-1.61829997f,-0.04789999f,0.90900002f,-1.50460000f,-0.04370000f,1.08290002f,-0.11130000f,0.01429999f,0.22249996f,-0.01050001f,0.06140002f,0.03180000f,-0.63090000f,-0.02280001f,-0.59190002f,0.07610001f,-0.82480002f,0.92710004f,-0.82860003f,0.97850003f,-0.40420003f,-0.34500001f,0.03000000f,-0.74520002f,-0.58370003f,-1.42100004f,-1.15200001f,-0.81309994f,0.35260001f,0.70079999f,0.18919999f,1.20450002f,0.34070001f,0.80569999f,0.88570001f,0.12799999f,1.91069999f,1.23880000f,0.20749999f,-0.22540000f,0.28760001f,1.05859997f,1.09989996f,-0.62260000f,1.04449999f,-0.41959998f,-0.94979999f,-0.70809999f,-1.25650002f,0.12220001f,-1.32549999f,0.63719998f,0.03810001f,-0.36650000f,-0.14180003f,-0.15589999f,-0.29830000f,-0.33190001f,0.14939999f,-1.03440001f,0.63210000f,-1.51640001f,0.90040001f,-1.13530001f,0.20579999f,-0.87289999f,0.29400001f,-1.20260000f,0.19000002f,-0.85330001f,0.17950001f,0.43610000f,-0.22980002f,0.17450002f,-0.39290001f,-0.70650001f,-0.73150003f,-0.39440004f,-1.07460006f,0.27989999f,0.10280002f,0.17319998f,-0.22520002f,-0.11819998f,0.36470002f,0.31610002f,0.24879997f,-0.08189998f,-0.24089998f,-0.52570001f,-0.48160000f,-0.10220000f,0.47990001f,-0.15830000f,1.09749996f,0.10440003f,-0.05650003f,0.19029998f,0.15559999f,-0.38479999f,-0.37509999f,-0.76129999f,0.59789998f,-0.86429998f,0.29189999f,0.75019998f,-0.17540000f,0.34000000f,0.34970001f,0.41280000f,-0.38329997f,0.00699999f,-1.51959998f,0.57150001f,-0.96549997f,0.89300001f,-0.58360002f,-0.29220002f,0.04579997f,0.63220000f,-0.86369997f,0.05629999f,-1.02650001f,-0.08160000f,0.53050002f,-0.24700001f,0.54750000f,0.57300005f,0.78620004f,1.56850002f,0.66120001f,-0.34280008f,0.93699996f,1.20269998f,-0.07890003f,-1.24210003f,-0.23730004f,-0.51450002f,0.29850000f,0.93450001f,0.12000000f,0.11400000f,0.63210002f,-0.95730002f,-0.04889999f,-0.80009999f,-2.36050000f,1.43229998f,-0.42279993f,-0.63260001f,-0.07120000f,0.89180000f,0.24419997f,-0.02880001f,0.54780004f,-0.52380001f,-1.31550002f,0.18300001f,0.14980001f,-0.56089997f,0.30050000f,-0.56319997f,-0.07780000f,-0.62159999f,0.32829999f,0.23500000f,0.02290000f,-1.02120000f,0.13530000f,0.68630001f,-0.68200003f,0.63030003f,-0.78330003f,0.09029999f,-0.03420000f,0.61950002f,0.99480002f,0.96949999f,0.51579994f,-0.53810000f,-0.60160004f,-0.78050001f,-1.12099996f,-0.38950000f,-0.84370006f,-0.26090003f,-0.20980000f,-0.91420001f,-0.98840000f,-1.80820000f,-0.96430001f,-0.79990002f,-0.32799999f,-0.91949999f,0.63389999f,-0.87659994f,0.81689997f,-0.26189997f,0.29359996f,1.50029996f,0.63520002f,-0.28349999f,-0.05040001f,1.04330001f,0.16949999f,0.46950000f,0.21070002f,0.05859997f,0.06340000f,0.85520002f,-0.09560000f,0.31780002f,0.13590000f,-0.15010001f,-0.33040001f,0.59900003f,0.68070003f,0.29359999f,0.25889999f,-0.34540002f,-0.84950000f,0.15930001f,0.28210001f,-0.26030000f,0.46519997f,-0.47160001f,1.04050001f,-0.66950003f,0.04319999f,-0.66890003f,-0.54600001f,-0.08149998f,1.63170000f,0.88540000f,1.28969997f,-0.09420000f,-0.37900000f,0.44540004f,0.64430002f,0.39379999f,0.05719999f,0.62370003f,-0.47099997f,-0.48359996f,0.31390001f,0.44740000f,0.91640002f,-0.70279999f,-0.09710002f,-0.11660001f,0.41760004f,0.12959997f,0.35259997f,-0.95539999f,-1.13420003f,0.41980000f,-0.11429998f,-0.41920001f,-0.23550004f,0.02940002f,0.62859997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.57699999f,0.40199998f,-0.28559998f,-0.52479997f,0.08830003f,-0.21140001f,-0.05070001f,-0.86759997f,-0.60119999f,-1.74099994f,-1.26479999f,-0.00200000f,-0.08910006f,1.81279999f,0.81540003f,0.36740001f,0.53530000f,0.00789999f,-0.23810000f,-0.94539993f,-0.39050001f,0.09630001f,-0.15439998f,0.65789998f,0.22459999f,-0.57319995f,0.25149997f,-0.50709998f,0.51420000f,0.53449996f,0.46310002f,-0.14160002f,-0.91680000f,-0.20540000f,0.62459999f,0.63039996f,-0.12070000f,-1.57310003f,0.36799995f,0.59189996f,0.30150001f,-0.32820002f,-0.17689998f,-1.33090005f,-1.15489998f,0.36820007f,-0.12220001f,0.33240001f,-0.59700001f,0.31690003f,-0.23530001f,0.41420002f,-0.20699999f,-1.18420002f,1.84109996f,0.69380002f,0.32950002f,-0.54509999f,-0.48909998f,-0.26260003f,0.22540001f,0.55660003f,-0.59079998f,0.92480003f,-0.26280004f,-0.90030001f,-0.65879999f,-0.75370000f,-0.36109998f,-1.15139998f,-0.67289997f,1.14110000f,-0.74000002f,-1.45819997f,-0.44829997f,-0.91020001f,0.61510001f,0.86200000f,-0.57969997f,0.30529997f,-0.05760000f,1.06290001f,-1.13829998f,0.14559999f,-0.77629999f,-1.06799999f,-0.89769999f,0.34129997f,-0.26530001f,-0.12779999f,-0.50950000f,-0.33760000f,0.23409997f,-0.64269997f,-0.32069997f,-0.31210001f,0.16260000f,0.49460000f,0.28229998f,0.59689999f,-0.56560000f,0.05710000f,-1.05880001f,0.23650003f,0.35280002f,0.81709997f,0.86359997f,0.47219997f,-0.63630001f,-0.53699993f,-0.81759994f,0.44850003f,1.15630000f,0.46479999f,-1.66879998f,0.16260003f,0.02559999f,0.62579997f,0.93699997f,-1.21139997f,-0.17139999f,0.43359995f,-0.06789998f,-0.06430002f,0.95019996f,-1.48929995f,-0.52090000f,-1.12619992f,1.18419998f,-0.92120002f,0.26979998f,-0.95229999f,-1.69739996f,0.68279995f,-0.02399999f,0.55549996f,-0.65399998f,-0.64849998f,-0.18250000f,-0.46980003f,0.05579999f,1.22940004f,-0.44669997f,-1.22779999f,-0.07490003f,-0.31120002f,0.94169998f,1.08320001f,1.37600002f,0.26690002f,1.25789999f,0.75129999f,0.43460000f,-0.46000000f,-0.43920000f,0.13699997f,0.61720000f,0.78510002f,-1.77979998f,-0.48630001f,0.62919994f,0.53309998f,1.70809997f,-0.17559995f,1.15560001f,0.71459999f,1.43879994f,-0.47409996f,0.34819999f,0.11869997f,-0.04199999f,0.29869997f,0.67150000f,0.45290002f,0.22149999f,-1.15210002f,0.54980002f,1.82419999f,0.10719998f,0.31400003f,-0.67420000f,-1.27229998f,0.12930000f,-0.33550002f,0.02190001f,-1.29759995f,-0.01320000f,-0.18000000f,0.56070000f,-0.14770000f,0.97760003f,0.29180000f,1.09280002f,0.66780001f,-0.59780006f,0.64060000f,-0.35450003f,1.02599996f,-0.37390005f,0.62159997f,1.03990002f,0.59590001f,0.34530000f,0.17850001f,0.92760000f,-0.47000001f,-1.14019997f,-0.25129998f,0.37860005f,-0.45410000f,-0.51430003f,0.82849999f,-0.78509999f,1.11439997f,0.98979998f,1.60379997f,1.10960002f,-0.02349999f,-0.06420002f,-0.05020000f,-0.31559999f,-0.20219997f,0.91399998f,-0.85089994f,-0.01990001f,-0.18949998f,-0.32710001f,0.62790000f,-0.05619999f,0.45409999f,-1.28779998f,1.19859995f,0.07620007f,0.18169996f,-0.78840000f,0.05809999f,-0.14480001f,0.13970001f,0.67919999f,1.49019998f,0.68380002f,-0.48390002f,-0.08699999f,0.53530002f,-0.87090000f,0.73280004f,0.43809996f,1.35390000f,1.36139999f,-0.20120004f,0.76390000f,0.82150000f,-0.55390000f,-0.02179998f,-0.29950001f,1.06739998f,-0.71549996f,-0.43350001f,0.41889998f,-0.40529997f,-0.44910000f,0.45370001f,-0.36150000f,-0.19969996f,0.10199999f,-0.22950003f,0.93329997f,-0.58410001f,-0.53049997f,1.21369999f,-0.78880000f,-0.99489999f,0.55929997f,-0.85630001f,1.02809999f,0.76309997f,-0.18499997f,0.32309997f,-1.32269994f,0.85129999f,-0.35680001f,-0.89589997f,1.11429996f,-0.36849999f,0.55549998f,-0.72589999f,-0.13030000f,1.06959998f,-0.28050000f,0.26940000f,-0.31570001f,0.23599999f,-0.09430002f,-0.71479998f,0.06510005f,-1.15299998f,0.36300002f,-0.12740000f,-0.02340002f,0.27750000f,-0.08610003f,0.71200000f,0.80389998f,0.09010004f,-0.95419999f,-0.26320000f,0.01779999f,0.84659998f,0.42720002f,-0.31540000f,-1.38949999f,-0.51679997f,1.43890002f,-0.74089998f,-1.62729997f,0.01500001f,-0.50910000f,0.77190003f,1.51279998f,-0.89799995f,-0.88939998f,0.29199999f,0.75079998f,0.38110000f,0.38070000f,-0.16759999f,-0.22329999f,-1.18979995f,0.82449995f,-1.26979994f,1.01029996f,-0.87939995f,-0.67319999f,0.27789999f,-0.28779998f,0.98899995f,-1.10440000f,0.89669999f,0.73119998f,0.35359998f,0.77099999f,-0.21200003f,0.11260001f,-0.01440001f,-0.07809999f,-0.54500001f,-0.36859999f,-1.03360000f,-0.47150001f,0.96970000f,0.14399999f,-0.12430000f,-0.33780000f,1.13030002f,-0.16049999f,-0.72109998f,-0.17260000f,-0.05600000f,0.91889999f,0.49170000f,-0.38309997f,-0.66410001f,-0.37189999f,0.14219998f,0.86239996f,1.29069999f,-0.63599996f,-0.73669997f,0.18769996f,-0.25420000f,-1.60729993f,-0.29439996f,0.06999996f,0.22639995f,0.64499998f,-0.30009997f,-0.14860000f,-0.58299999f,-0.02520001f,-0.52670000f,0.66439997f,1.41189997f,-0.59689998f,-0.33220000f,-0.41499997f,0.63859997f,-0.78299996f,-1.10759997f,0.55480001f,1.00399999f,0.53539998f,-0.47450000f,-0.22979999f,0.11410000f,-0.11070001f,-0.42810000f,0.31360000f,-1.13130000f,-0.65739997f,-0.08240000f,-1.52020001f,0.72230001f,0.02039997f,0.59510001f,0.94460004f,0.84110002f,-0.21190002f,0.90280001f,0.44450000f,1.19679996f,0.23590000f,0.41159999f,-0.68670000f,0.32599998f,0.18600001f,1.21079997f,-0.07739999f,0.30020004f,-0.48680002f,-1.64559999f,0.22240000f,-1.24020000f,0.78009999f,-0.15539998f,-0.57330000f,-0.33040001f,0.47640000f,-0.39190007f,-0.96419996f,0.21290000f,0.40830002f,-0.24200005f,1.48490007f,0.06789997f,0.03029999f,-0.05260002f,1.19520004f,1.93080004f,-1.24340007f,-0.48969999f,1.16180006f,1.27420003f,-0.29980002f,-1.36550003f,0.95790001f,1.16180001f,0.48820001f,-0.94280001f,1.06220000f,-0.74470004f,0.79780002f,0.18450005f,0.80930002f,0.30700000f,-0.16290000f,-0.22729998f,-0.51710001f,-0.76880003f,0.35990000f,0.73569999f,0.46300002f,0.12470001f,-0.76260000f,0.72169998f,0.06020001f,-0.05620000f,-1.03440001f,-0.36230000f,0.03399998f,0.03150000f,0.31860000f,-1.17070001f,1.64040002f,0.68190001f,0.49240002f,-0.34320002f,-0.15410003f,1.52390007f,1.13190002f,-1.12250003f,-0.87960001f,-0.30489996f,0.47299998f,1.40820001f,0.89409996f,-0.20980005f,1.38129998f,-0.83970000f,-0.51690000f,1.03980001f,-0.08530003f,-0.59819999f,-0.64829998f,1.02270002f,0.09729999f,0.69520000f,0.58240001f,0.17600001f,-0.19290001f,0.52760000f,-1.33049996f,1.28399999f,0.89560002f,-0.01499999f,-0.54880001f,-0.03180001f,-0.55970003f,0.81430001f,0.72629999f,-0.00489998f,0.40200000f,-1.56799997f,-0.40600002f,0.18000003f,0.16840001f,0.66559999f,0.51959999f,0.61119999f,-0.42710001f,0.75200000f,-0.46909996f,0.37540001f,1.15849997f,-1.06299995f,-0.40019999f,-0.58619999f,0.06690000f,0.22150001f,0.84370005f,0.34880002f,-0.90280005f,-0.44930002f,1.76020006f,0.56120004f,-1.30620004f,-0.30159999f,-1.75920005f,-0.72120001f,-0.76830005f,-0.06610005f,-2.07440005f,-1.57900003f,0.01659999f,-0.27210003f,0.39750001f,0.10729998f,-0.07500000f,0.84570004f,-0.29350000f,-1.23760003f,0.04540001f,1.33880002f,-0.88030002f,0.66550004f,-0.03000003f,0.48399999f,-0.05770003f,0.48440000f,-0.48960003f,-0.35630002f,0.49939998f,-0.42900000f,-0.87820002f,-0.19740001f,-0.17960002f,0.20470002f,0.42580001f,-1.05140002f,-0.33240001f,0.73210001f,-0.11059998f,1.10699999f,-0.01440001f,-0.18139996f,-0.21299998f,1.25229997f,0.10700002f,-0.24809998f,0.80510003f,-0.69870003f,0.04060000f,0.02839998f,0.89070002f,-0.52510005f,-0.45510001f,-1.17410003f,-1.64210004f,0.00210005f,-0.60170002f,-1.96320005f,-1.17159999f,-0.01180000f,0.16640000f,-0.47530002f,-0.53620001f,-0.51289998f,-0.30629997f,-0.73530002f,0.20680003f,-0.52460002f,-0.02510002f,-1.12540002f,0.14610001f,-0.20710000f,0.58959995f,0.41040003f,1.26760004f,-0.25920000f,-0.18050003f,-0.19820000f,-0.06990000f,-0.34290000f,-0.74920000f,1.25679996f,0.54629999f,0.80379998f,-0.56200000f,0.27659997f,0.16750003f,-0.96160001f,1.26620000f,-1.72379998f,-0.08680001f,-0.25360000f,0.58110001f,0.34540000f,-0.26329999f,0.18039999f,0.26070000f,0.34130000f,-0.47970004f,-0.79949999f,-1.30110002f,-1.05770000f,0.55230002f,1.37399999f,-0.10230001f,1.20200005f,-1.08110005f,-0.98339999f,-1.61720004f,-2.01370002f,0.82210002f,0.91060001f,0.06650001f,0.31550005f,-0.86059999f,-0.17510002f,-1.22599997f,0.31350003f,-0.40459999f,-0.30599999f,0.52010002f,0.34280001f,-1.03870002f,0.31929997f,-1.33890001f,0.23840000f,-0.36850000f,-0.11780001f,0.43150004f,-0.24600000f,-0.68810000f,-0.38439997f,0.31379994f,-0.01789998f,0.14099997f,0.92179998f,1.61599999f,-0.87370000f,0.75479999f,-0.14380001f,-0.12860002f,0.31390003f,-0.68580000f,1.23730000f,0.89160000f,-1.35229999f,0.44859999f,0.36119998f,-0.12950000f,-1.09770003f,-0.47130002f,0.58120001f,-0.11410004f,1.24500005f,2.47850002f,0.00059996f,0.50099998f,0.45070002f,-0.28010002f,-0.53360004f,-0.11890002f,0.27069998f,-1.06419999f,-0.24700001f,-0.10500000f,-0.11570000f,0.67260002f,-0.16410001f,-1.36990000f,1.13269999f,0.21390002f,0.63530001f,-0.62869999f,-0.58340003f,-0.47200001f,0.36870000f,1.19720001f,-0.44309998f,-0.86170000f,-0.29829998f,0.74720000f,-0.12599999f,0.02450000f,0.01759999f,0.42290000f,0.59640003f,0.32899999f,1.39519996f,-1.53440000f,0.90359998f,0.55320000f,-0.62539999f,0.14060000f,-0.78800004f,-0.31719995f,-0.13920001f,0.07309999f,-0.55880000f,0.07200000f,-0.56200001f,-0.95520004f,-0.84280004f,1.07390002f,0.25659998f,1.03010005f,-0.13959999f,-0.94609999f,0.32270001f,0.59700000f,0.70449999f,-0.66359998f,-0.14269999f,2.12590002f,1.17950003f,-0.90290004f,-0.73909999f,-0.19350002f,0.34430002f,0.34919999f,-0.81540002f,0.63680000f,-0.34860002f,0.58420003f,1.22400002f,-0.02579998f,-0.69630000f,-0.08840000f,0.01440000f,0.01090001f,-1.06249999f,0.11139998f,0.75240000f,-0.79400002f,0.49049999f,-0.00919999f,0.29940001f,-0.38939998f,-0.13130000f,-0.90359998f,-0.31470001f,0.29479997f,0.06110000f,0.69299998f,-0.27990000f,0.73199999f,0.36699998f,0.10080001f,-1.22500001f,-0.32139999f,0.52920002f,-0.19800000f,0.14519995f,-0.76349999f,-0.74109994f,-0.43320001f,-0.60609997f,0.81019997f,-0.93539998f,-0.40170000f,0.36969999f,-0.04390001f,1.95219993f,1.18709997f,0.77119996f,1.36910002f,-0.71200000f,-1.42880000f,0.32960002f,1.98439995f,-0.85279995f,-0.86659996f,-0.27199999f,0.19549998f,0.39169998f,0.44349998f,0.09859999f,0.09190003f,1.02029994f,-0.15269998f,0.50459997f,-0.22399999f,-0.46609998f,-0.23679999f,-0.37999997f,0.34380001f,-1.50780001f,-0.03930001f,0.50950004f,0.40600000f,0.02019999f,-0.57509999f,-1.13130000f,-0.59100001f,0.77710005f,-0.18150001f,1.46460004f,-0.38580000f,-0.07909995f,0.68859997f,0.83939999f,0.48780001f,-0.11100000f,1.52989994f,0.22019998f,0.51090000f,0.78390001f,-0.29040002f,-1.63909999f,0.44200001f,0.17760001f,-0.25709998f,1.11610000f,-1.88249999f,-1.09650001f,0.22999996f,0.63540000f,0.04559998f,-0.53940002f,1.01789996f,1.10570000f,-0.39960003f,-0.57810001f,-0.46079999f,0.00740000f,-1.05429995f,0.59850001f,-1.09610000f,-0.07810001f,-0.43420001f,-0.13380001f,0.10210000f,0.95219999f,0.87319996f,-0.59839997f,0.36900000f,-1.04640001f,0.81310003f,-1.00360003f,-0.22290001f,-0.74810002f,0.96550001f,-0.93950000f,-1.54889999f,-0.31690002f,0.76020000f,-0.87069996f,-0.05109993f,0.00929996f,0.37249994f,0.20129998f,0.70390003f,0.09200000f,0.49200000f,-2.19709999f,-1.53640002f,-0.50040000f,0.27170001f,-1.81129997f,-0.98340000f,0.76259994f,-0.60949996f,-0.48119995f,0.15610001f,-0.03190004f,-0.13000001f,0.67270000f,-0.70539994f,-0.29159999f,-0.51580001f,-1.02519999f,0.63689997f,-0.73440000f,1.36260000f,-0.59200001f,0.04169998f,-0.59009998f,1.98849997f,-1.03579997f,-0.54879998f,-1.44639994f,1.31159991f,-0.86069998f,0.32660006f,-1.20079998f,-0.66640002f,-0.58039999f,-0.17940001f,-0.37169999f,0.35299999f,-1.10950004f,0.50039999f,0.64980000f,1.08149996f,0.81199995f,1.01020000f,-0.48070001f,0.87219997f,-0.59760007f,1.14059995f,1.19189997f,0.21610000f,0.53970002f,-0.02010000f,-0.10060000f,0.24489998f,-0.99139999f,1.64049997f,1.08709999f,1.26119997f,1.76909997f,0.33659999f,-1.74439993f,1.38339996f,0.68409996f,1.98489995f,0.45089998f,0.29350003f,0.97850003f,-0.66420000f,-1.08720000f,-0.75250000f,-0.65150002f,-0.05729999f,-0.25949996f,0.28459998f,-0.30480000f,0.26169997f,-0.71289998f,0.11280003f,-0.71209997f,0.49439997f,-0.33369996f,0.18259995f,-1.05679997f,-0.30970001f,0.29359998f,-0.32129999f,-0.53939998f,0.62420005f,-0.52939998f,-0.93209999f,0.66029997f,0.40409998f,-0.26669998f,0.99890005f,0.82460000f,0.01759994f,0.61730001f,-1.10310005f,0.41149996f,0.42379997f,0.02460001f,-0.68939999f,-0.21000000f,0.38560002f,-1.55969997f,-0.69949999f,0.53229996f,-0.34830005f,0.51340001f,1.48620002f,-0.79419998f,-0.50940003f,0.30119998f,-0.54749999f,1.75119997f,1.17190001f,-0.18349999f,-1.10559998f,0.34860000f,0.84629999f,-0.20939998f,0.32469999f,0.13340001f,0.49580000f,0.92109994f,-0.29159997f,-0.25770000f,-0.16030005f,0.76690000f,-0.69429999f,1.18220001f,0.62380002f,-0.13290002f,-1.18029998f,-0.37149997f,0.12880000f,0.02699999f,0.70619996f,0.00839998f,0.90060000f,0.92690003f,-0.41730000f,0.15649999f,-0.37810000f,-0.63620001f,-0.11809999f,-0.70320003f,-0.56679998f,0.45540003f,-0.42169998f,-1.49119997f,-0.14380000f,0.21160000f,0.08870000f,-0.33240002f,1.05499999f,1.90049997f,-0.32220003f,-0.10840001f,-1.29089998f,-1.93499999f,-0.16979999f,0.73469998f,-0.02899999f,0.42850001f,-1.39019993f,0.13760001f,0.85749993f,-0.19810003f,0.20040001f,0.29390000f,1.03239993f,-0.55739996f,1.39129993f,0.34659996f,-0.67919997f,-0.01070000f,-0.36049996f,-0.52510000f,1.07329999f,0.42520001f,0.20230001f,-0.48949999f,0.70589997f,1.56689997f,-0.14900001f,-0.72079999f,-0.24829999f,0.95699998f,0.12559999f,0.95310001f,-0.12860002f,-0.64419997f,-0.39439996f,0.06239996f,0.72739999f,0.16779999f,0.65590000f,-0.37560000f,-0.39430003f,-0.12680000f,-0.52840001f,-0.92450001f,-0.54790000f,-0.40880002f,-0.22620000f,0.70019998f,1.20259994f,-0.19269999f,0.13520001f,0.24009998f,0.43750000f,0.07109998f,-0.32089999f,-0.51969998f,-0.16699999f,-0.47059999f,-1.73869998f,-0.18250000f,1.01319998f,-0.34160000f,-0.08960000f,1.03189994f,-1.47699997f,1.79609994f,0.10870000f,-0.00389997f,1.01069997f,-0.34970000f,-0.15279999f,-0.44409997f,0.22569999f,-0.75129997f,0.00779999f,-0.20449999f,-0.26040000f,-0.17740001f,0.87920000f,-0.25680001f,-0.26520001f,-0.42120001f,0.50699999f,0.76960001f,0.46700000f,1.11089998f,1.12159998f,-0.27650004f,0.65220000f,-0.89300005f,-0.88570000f,-0.68629999f,-0.54790002f,0.23360000f,0.36450000f,1.27400002f,0.34840002f,-0.70420001f,0.75310001f,0.68730002f,0.55409997f,1.26229998f,-0.35759997f,-0.88279997f,0.57979995f,-0.32360004f,0.32239999f,0.42230001f,0.08070000f,0.23180001f,0.81030002f,0.55370004f,-0.47539998f,-1.16329999f,-0.64769999f,-0.41450000f,0.19229998f,-0.19800002f,0.17850001f,-0.62619998f,0.94579997f,-0.86049999f,1.15649998f,0.06620002f,-0.54759997f,0.88889999f,-0.98989997f,0.68210000f,-0.83799998f,-0.77520003f,-0.39059997f,0.19350001f,0.11130004f,0.19259996f,-1.31160000f,1.58949998f,0.03529999f,0.47970002f,-0.50100000f,0.20220002f,0.30879999f,0.15809997f,1.23160000f,0.37099998f,0.77420001f,-0.03790001f,-0.87440001f,-0.46800003f,-1.04130000f,-0.11579999f,1.03809997f,-0.52799995f,-0.76379998f,-0.48460000f,-0.78599999f,-0.13799997f,-0.15220002f,-1.96179996f,0.42829998f,-1.31319996f,0.70800000f,0.84720000f,-0.59420000f,0.87680000f,0.29520001f,-0.13319999f,-1.88060005f,-1.34780002f,0.39190004f,1.05910000f,-0.09590001f,-0.65990003f,0.91520004f,1.15699998f,0.53940002f,1.44550003f,0.77350001f,0.43150006f,-1.00850001f,-0.04929993f,-1.09960006f,-1.30040001f,-0.15000001f,0.94590002f,0.10489999f,0.16129998f,0.50640000f,-1.21379999f,0.62249998f,-0.14059999f,1.27669999f,0.26159999f,0.03610002f,-1.00930003f,-0.86009999f,1.31380000f,-1.52020002f,-0.13760000f,-0.63380002f,-0.27749999f,-0.44719996f,1.28230000f,0.25460001f,-0.69120001f,0.73580003f,0.71859998f,-0.19939996f,-0.17440000f,0.96540001f,-1.14299999f,1.21240001f,-0.46360001f,-0.38860001f,0.25379999f,0.34000000f,0.51840002f,1.03780003f,1.72920009f,1.49670008f,-0.04089998f,0.83190006f,1.39240005f,1.02920004f,-0.91529997f,-0.01729996f,1.12619997f,1.31519994f,-0.05039994f,1.29500002f,-1.28070006f,-0.40550001f,0.84910004f,0.75890000f,0.02900004f,-1.41480006f,-0.26339996f,0.34200002f,-0.43089997f,-1.27670003f,-0.00449996f,0.50560003f,-0.01600002f,-0.95839997f,1.22849999f,0.37029995f,-0.46399998f,-0.11249994f,-0.00820001f,-0.79120004f,0.54180001f,-0.85759999f,1.32260001f,-0.55790003f,0.89219997f,-0.21830000f,1.33560000f,-0.69940001f,-0.10040000f,1.17379995f,1.51200000f,-1.03789996f,0.64979999f,0.02209997f,1.05520000f,0.74220000f,0.44420003f,-0.38640001f,-0.10470002f,0.71330007f,-0.15500001f,-0.71370001f,-0.65370005f,-1.22550000f,0.25929998f,-1.30080002f,-1.69499998f,-0.61680001f,-0.69750006f,-1.66760000f,-1.26040003f,-0.20689999f,0.30380002f,0.04990000f,0.12560003f,0.21190000f,-0.75380004f,0.80899999f,0.90690002f,0.66899998f,1.44499996f,-0.58549997f,-0.59779997f,-0.55410002f,0.62869997f,0.39809998f,0.92749998f,0.14800002f,0.07020001f,0.26820004f,-0.54370001f,-0.46390000f,0.43130001f,-0.92959997f,0.40519996f,-1.24739999f,0.34160002f,0.14419997f,-0.40219997f,0.01819998f,1.28669996f,-1.17359997f,0.31960002f,-1.00040000f,0.96340001f,0.95539999f,-0.80459999f,0.60800000f,0.26009999f,0.71360003f,0.96079998f,0.67900004f,-0.65230002f,-0.90620001f,-0.77330003f,-0.10999998f,0.50120002f,0.64900001f,-1.13300003f,-2.10780003f,-1.47840002f,-0.53960003f,0.72260004f,-0.29350001f,0.43850001f,0.48999998f,-0.11790000f,-0.64249999f,-0.59700003f,0.60359997f,-0.62020002f,0.62030004f,0.16190002f,-0.05040006f,-1.13750001f,0.04840001f,-0.57179999f,1.36000003f,0.12250001f,-1.26580001f,0.94600000f,0.38050000f,0.51820000f,-0.78390000f,0.63400001f,-0.43620000f,-1.43299997f,0.94840001f,0.87839999f,-0.58409998f,-0.15820004f,-0.23239999f,-0.86340004f,0.92400000f,-0.60840001f,0.57000001f,-0.00499998f,0.09419998f,-0.49519999f,-0.36089999f,-0.61580000f,-1.12200002f,-0.75829997f,-1.11380003f,-0.39230000f,1.51200007f,0.54820003f,0.99150003f,0.00829998f,-0.11960002f,-0.36610000f,1.73459999f,0.92690003f,-1.49240003f,-1.03400000f,0.63230001f,0.51069996f,-0.07390000f,1.52030001f,-0.65559999f,-0.03950001f,-0.59069997f,-1.49930002f,0.29729999f,0.13219999f,0.37560001f,0.26850004f,0.09040000f,-0.54869999f,-0.02680000f,0.84050001f,-0.40200003f,-0.27380001f,0.72529999f,0.31810000f,-0.90180003f,-0.23159997f,1.72380000f,0.06540000f,0.03199999f,0.14219997f,-1.26680001f,-0.50009999f,-0.20420002f,0.03320001f,-0.13879998f,-1.04839999f,-0.49319998f,1.27619999f,-0.04099999f,-0.47099999f,-0.75760001f,-0.42760000f,-1.22650001f,-0.47940003f,-0.78430001f,-0.02849997f,0.98330001f,-0.66270000f,-0.25629999f,0.21729999f,0.73580000f,0.68310003f,-0.30060000f,1.08760005f,0.63800000f,0.52630004f,0.75670004f,-0.18020002f,0.72109996f,-0.21189999f,-0.04979997f,0.02100001f,0.65409999f,-0.29040000f,-0.15490000f,-0.23230000f,-0.33600000f,-0.04499999f,-1.07730001f,0.39160000f,-0.14030001f,1.08400004f,0.05820000f,-0.02620000f,0.54710000f,-1.44700000f,-0.18429998f,0.43379998f,0.09640000f,0.04940000f,-0.08650001f,0.83399998f,0.17120000f,1.15479998f,-0.37519999f,-0.48399999f,0.68439997f,-0.03499997f,-0.89380001f,-0.03700000f,-0.07500001f,-0.45610003f,0.42930004f,0.49010000f,-1.09930002f,-0.08230001f,-0.39550004f,-0.59909999f,-0.87279998f,-1.95440001f,0.18060002f,-0.21280003f,0.71560005f,1.35480000f,-1.00110006f,0.57759998f,0.08309999f,-0.07660002f,0.58280001f,0.36930000f,0.54960001f,0.93429999f,-0.63169999f,-0.13700000f,-1.18160001f,0.07979997f,-0.16289999f,-0.15879997f,1.11050002f,0.04530001f,0.63270000f,0.76500004f,-0.31890001f,-0.94310002f,-0.10380000f,0.69100000f,-0.91820000f,-0.24990001f,0.62719996f,-0.36139998f,-0.26660002f,0.37500001f,-1.21660001f,0.83319999f,0.01000001f,-0.07070001f,0.24439999f,-0.30080001f,0.79519997f,0.07760002f,0.80040000f,0.08429999f,-0.01720000f,0.60030002f,1.48910000f,-0.18770001f,-0.56980000f,-1.02050001f,0.20459998f,-1.96339995f,-2.07849997f,-0.65549996f,0.16970000f,-0.82659997f,0.75410000f,0.37229999f,0.64219999f,0.04579999f,-0.48600000f,0.26639998f,-0.83359998f,0.88289997f,-0.22420002f,0.44390000f,0.30769997f,-0.79139996f,0.48469998f,-0.41229993f,-0.11570002f,0.81200000f,0.36220000f,0.23210001f,1.32919997f,0.30879996f,-0.74639998f,0.21890000f,-1.01519997f,0.26840001f,-0.72669996f,-0.27339998f,0.14110001f,0.39970003f,0.79659997f,-0.13420006f,0.32069999f,-0.47690002f,0.74469999f,0.05159998f,0.19320001f,-0.37930000f,-0.48020000f,0.66850003f,-0.02650000f,-0.44299999f,-1.68709992f,-0.83969998f,-0.07489996f,1.56850002f,0.48559994f,0.06989997f,0.66249997f,-1.21149999f,1.28870001f,0.91020002f,0.41909999f,-0.52830000f,0.56100001f,1.08430001f,-0.65599999f,-1.01950000f,-1.35309992f,-0.50150003f,-0.12189993f,0.50909999f,1.21839997f,0.45069997f,0.57049998f,-0.20239997f,-0.47729997f,-0.46389999f,0.09499999f,-0.88649999f,-0.03769999f,0.66630001f,-0.94850000f,-0.05120003f,-0.58629998f,-0.71219995f,-1.65260002f,-0.31510000f,-1.21770003f,0.29660000f,-0.65470000f,0.23020000f,0.72629999f,-0.91970000f,-0.19600001f,-0.24450002f,-0.15809998f,-0.23460000f,-0.22080000f,0.46479999f,-0.10960002f,0.18430000f,-0.40580001f,0.14630000f,-0.33640000f,1.34639999f,0.58420003f,1.36859995f,0.51220000f,-0.59919999f,-0.02680000f,-0.94039996f,-1.24719997f,0.53150000f,1.44149999f,0.21199998f,-1.75540001f,0.69860000f,0.98860000f,0.35850005f,1.10659998f,0.37220000f,-0.12359998f,0.12180000f,-0.05860002f,-0.60869997f,-0.25920000f,-1.39739994f,0.35390002f,-0.20710001f,0.52280000f,-0.20910003f,0.20219999f,-0.38810000f,-0.89119998f,0.16029999f,-0.25019997f,-0.53220000f,0.16819999f,1.14730000f,0.33570000f,0.92340001f,0.22940000f,0.66780002f,0.61709999f,0.66920002f,-0.40539999f,-1.04980001f,0.18219997f,0.22150000f,1.03169998f,0.85079998f,0.42510000f,-0.38700001f,0.66280000f,1.38279999f,-0.30759999f,-0.41509998f,-0.76509998f,-0.22190000f,-0.45559999f,0.47910000f,-1.27550003f,-0.49740005f,0.49919998f,0.67000000f,1.18879997f,0.44920000f,0.09020000f,-0.33480000f,0.45990002f,1.00109998f,0.30929998f,-0.23970001f,-0.10049998f,-0.40230001f,0.52240000f,-0.33079998f,1.44689995f,-0.52180001f,0.95089999f,1.24500002f,0.53089997f,-0.19279999f,0.30099998f,-0.92799998f,0.05270001f,0.69480000f,1.10510002f,0.73010000f,0.38969999f,0.71200001f,-0.80550006f,-0.72159999f,-0.76050000f,-0.44530003f,0.61370002f,-0.15519998f,-0.66450000f,-0.84360000f,-0.35180001f,-0.06160002f,0.19509999f,0.11270000f,0.12220003f,0.79720000f,1.00710000f,-0.05280002f,-1.84689999f,-0.21800000f,-0.29600004f,-0.35829996f,1.99510002f,-1.10219999f,0.07619994f,0.00909996f,-0.40229998f,0.19020000f,-0.75879997f,0.20240001f,0.24890001f,-0.23649998f,-0.77029999f,-0.26169999f,-0.64380001f,0.19320003f,-1.18889997f,0.28730001f,0.13860004f,0.97979993f,0.05250000f,1.04279996f,1.64659994f,-0.98069996f,0.40349999f,-1.05629996f,-0.61279999f,-0.12629999f,-0.73379997f,-0.91489998f,0.02699999f,1.32020002f,-0.36099996f,-0.67799997f,0.56809999f,0.86569997f,0.39420000f,0.98640002f,0.35240001f,-0.76810005f,0.42059999f,-0.65660003f,0.75710001f,0.15020000f,0.30040002f,-0.75820000f,0.99640003f,0.88960004f,-1.38629995f,-1.12350002f,0.32820000f,1.12749998f,0.56150001f,0.86750000f,-0.77289998f,-1.41409999f,0.37290000f,-0.66910002f,1.15300002f,1.93549998f,0.36079999f,0.20080000f,-0.69249997f,1.08269998f,-0.76060002f,-1.45470000f,-0.10119999f,0.65309998f,1.21069995f,0.13670002f,0.09469997f,-0.31450003f,-0.02990000f,-0.63829997f,0.87119996f,-0.76879997f,1.44629994f,-0.31840001f,0.52120000f,-0.00119998f,-1.39640002f,0.53090000f,0.27259999f,0.52990000f,0.35439999f,-0.67099998f,-1.63069999f,-1.23949998f,-0.29619999f,-0.73619995f,-1.52969999f,-0.29990000f,0.04950001f,0.43119997f,0.79939999f,0.27310000f,-0.43440001f,1.26509997f,0.45380002f,0.53870001f,0.95769998f,-1.29589998f,-0.63900002f,0.22580000f,0.34320003f,-0.82499994f,-1.27510003f,1.14039999f,0.73370005f,0.94779997f,0.37699999f,-0.11820000f,-0.47900000f,0.58120001f,0.35090001f,0.68689999f,-1.18179996f,0.74839997f,-0.72199999f,0.49639999f,1.95369999f,-1.07409998f,-0.17690004f,-0.88269994f,0.96479996f,-0.69029998f,-0.03899999f,-0.71670000f,-0.76159998f,-0.22689999f,1.03259999f,0.61929999f,-0.27669995f,0.21670005f,-1.22449997f,-0.92589997f,-0.93819998f,-0.02769998f,-0.85349999f,-0.53750000f,-1.26580002f,-0.87680001f,-0.16290002f,0.54810001f,-0.31709997f,0.20480003f,-0.14660000f,1.15239998f,-0.20349998f,-1.07049996f,-1.36669996f,-0.33600001f,-0.74190000f,-1.13729997f,-1.17779997f,0.52759995f,-1.03480001f,0.02119999f,-0.08010000f,-0.60169998f,-0.20069997f,1.06800000f,-0.64059999f,-0.91489999f,1.07199995f,0.00539998f,-0.45109996f,0.26209996f,-0.97979996f,0.95599997f,-0.66539996f,-0.52220000f,0.33150000f,1.18569998f,-0.28110001f,0.91740000f,-0.20650000f,-0.32870000f,-0.08599999f,0.63919997f,-0.24559999f,-0.12870001f,1.01150001f,-0.67989999f,0.05220000f,-1.14910000f,-0.33740002f,-0.25799996f,-1.61159999f,-0.02440002f,-0.26650000f,0.46480001f,-0.01359997f,0.27370001f,1.22840000f,-0.97870000f,-0.26350000f,-0.37089999f,0.53910000f,-0.09540004f,-0.58279997f,0.53579998f,0.49850000f,1.92399998f,-0.75650000f,0.46799995f,-0.01270002f,-1.11600000f,-0.39480000f,0.08739998f,-0.74539999f,-0.41240001f,0.19060001f,0.34679999f,0.33270000f,0.22639998f,2.78680005f,1.64729997f,-0.13830006f,0.30180001f,-1.85290003f,-1.07099998f,-0.98640001f,-1.27570002f,-0.09650000f,0.23349996f,-0.26850001f,-0.99230004f,-0.17910002f,0.88339999f,0.60920003f,0.64380001f,0.65550000f,-1.47940000f,0.81029999f,1.29840004f,-0.96410000f,0.93349997f,-1.43990000f,-0.46259999f,0.26679999f,0.64650001f,0.58909999f,-0.52330001f,0.59140000f,0.57070003f,0.48430001f,-0.80140003f,0.00750000f,0.12119999f,-0.06500003f,-1.02950000f,-0.59680004f,-0.56179997f,0.13179999f,0.73970000f,-0.03760001f,1.13199999f,-0.94780001f,-0.06609999f,-0.25419998f,0.42729999f,0.68020001f,-0.42489998f,0.64600001f,-0.06660001f,0.41340000f,0.04559998f,-0.40420004f,-0.40690000f,-0.58570003f,-0.68360000f,-0.25200006f,0.87720003f,1.12409998f,1.39440003f,0.88490003f,-0.71020003f,0.28180002f,-0.32770000f,-0.59690001f,0.18620002f,-0.00670003f,0.30920000f,0.31430002f,0.00079998f,0.54820003f,0.78199998f,0.41920000f,0.79699998f,-0.89910001f,0.93410002f,-0.86949999f,0.15599999f,0.98130002f,-0.14449998f,-0.62080002f,-0.01400002f,0.21629999f,0.77270002f,-0.84710000f,-1.23260001f,0.73720000f,-1.22340000f,0.45379999f,-0.27439999f,0.34570000f,1.59900000f,-0.84380000f,-0.26519999f,0.01119998f,0.50700001f,-0.39039998f,-0.34379998f,1.14609998f,-0.45499999f,-0.44549999f,0.04490000f,-0.94650004f,0.19169999f,-0.58800001f,-0.19779998f,0.28160000f,0.11960002f,-0.24630003f,-0.36549996f,0.19620002f,-0.92749995f,-0.67610002f,-0.03809997f,-1.56940004f,-0.85790002f,-0.35600001f,-0.58350001f,0.20650000f,1.45320002f,-0.72769998f,-0.16640000f,-0.69759998f,-0.23090001f,-0.65699999f,0.56340000f,-1.25190000f,-0.58680004f,-0.62629999f,1.20720003f,-0.73700002f,0.88270000f,-0.57050001f,-0.37310001f,-0.01010000f,-0.37330000f,-0.15360004f,-0.04899997f,0.90579997f,0.04949999f,0.27279998f,-0.33020000f,-0.42140001f,-0.25139999f,0.21440001f,-0.13190002f,-0.79180002f,0.39010001f,-0.23780000f,0.56140001f,0.30500000f,0.08070000f,-0.58060002f,-0.80000006f,0.21719994f,-0.29099998f,-1.12490001f,1.36140005f,-0.63820007f,1.54220004f,1.41970007f,0.00029997f,-0.33789996f,-1.06780000f,-0.31379998f,0.55790004f,0.85969998f,0.36380001f,0.24919997f,-0.15030004f,0.53180000f,-0.10620001f,-0.88570002f,-0.17320003f,-1.08800003f,1.62030002f,0.82520002f,0.22820003f,0.10239997f,-1.13589998f,0.23290002f,-0.31369997f,-0.47780000f,0.66789998f,-0.17580000f,0.51430000f,0.94139999f,0.73780000f,-0.45289996f,-0.42980001f,1.01609997f,-1.01659997f,-0.17240000f,-0.98799999f,-1.39410000f,0.19679998f,-0.28909997f,0.96979998f,0.71159997f,0.10520000f,0.21099998f,-0.04400000f,-0.32100000f,-0.09410003f,-0.28710003f,0.98729999f,1.47440002f,0.20560000f,-0.16270000f,0.28030003f,-2.00580010f,-0.86880001f,0.19350002f,-0.06889996f,0.08149999f,-1.23050004f,-0.23590000f,-0.43370000f,-0.96860005f,-1.10340003f,0.69930000f,0.93000004f,0.28030000f,-1.70530004f,0.55580001f,1.33279999f,-0.89960000f,0.98410003f,-1.08659998f,-0.83070003f,-0.52659999f,-0.28070001f,0.35000000f,1.28620001f,0.10270001f,0.33280001f,-0.38640000f,0.19170001f,-0.09679999f,0.00270000f,0.68480003f,-0.64060000f,-1.22240003f,-0.10969999f,1.04559997f,0.16530004f,0.43979999f,0.26529998f,-1.57539997f,0.72760001f,-1.68060002f,-0.37759998f,-0.13000001f,0.34560001f,-0.18030000f,-0.87790003f,-0.99270003f,-0.01950003f,-0.37280004f,1.12630003f,-0.29199998f,-0.20070002f,0.50460002f,1.90020002f,0.98849993f,-0.25919999f,0.35119997f,-0.43280000f,0.42019997f,0.14240001f,-0.01490000f,0.17609999f,0.94870003f,0.01529997f,0.31319999f,0.26540000f,-1.06140002f,0.23930002f,0.48410007f,0.41999998f,-1.48210002f,1.26089998f,0.71560003f,0.78290000f,0.32859999f,0.37959998f,-0.56690001f,0.17310000f,-0.12660001f,-1.57860000f,0.82940000f,-0.61899999f,-0.41429997f,0.03460002f,-0.38920001f,0.33420000f,0.28379999f,0.01520000f,-0.22669998f,-0.52479999f,0.27859997f,0.21880002f,0.03570001f,0.39580001f,-0.08790000f,0.22090000f,-1.33690007f,-1.48060000f,1.90150003f,1.71310000f,0.99890003f,0.49450002f,2.14470004f,1.21539998f,0.54240004f,0.51740005f,0.36940004f,0.37970004f,0.26449997f,0.60229999f,0.01509999f,0.16440001f,-1.05259999f,-0.52999996f,-0.39580000f,-1.05930001f,0.76770000f,-0.78569998f,0.51269997f,-0.62750003f,0.74170001f,-0.11100000f,-0.13409995f,-0.03439998f,0.02999999f,0.19290002f,0.12710001f,-0.32210000f,-0.54120001f,-0.40749995f,1.14179999f,0.80639999f,1.01100002f,-0.99710000f,-0.03919998f,0.28789996f,-0.19999998f,-1.29609998f,0.59820000f,-0.28700001f,-0.50920001f,0.41839998f,0.68459999f,-0.90169997f,0.45680000f,0.29609999f,0.19079999f,0.38860000f,0.21619998f,0.40849999f,0.09889997f,-1.23829994f,-0.05069999f,0.18310001f,0.02449999f,-0.38519998f,1.73699996f,0.56299996f,-0.96779997f,1.18389999f,1.05299999f,-0.18719999f,-0.14090001f,0.14379997f,-1.33409994f,1.44829994f,-0.67549999f,0.83740000f,-0.60270002f,0.37420004f,0.57559998f,1.13609998f,-0.88699997f,1.00189995f,0.98740000f,0.77569997f,-0.73749997f,-0.09879998f,-0.04720001f,-0.35769999f,-0.97080000f,-0.78430000f,0.03139998f,0.69749998f,0.18210001f,-0.36770001f,-0.64880000f,-1.58669999f,0.11089998f,1.65150002f,-0.21719999f,0.56620002f,-0.22110000f,0.32950000f,-0.36060000f,-0.38480001f,-0.19510001f,-0.07800000f,0.59299998f,-0.46619998f,-0.00059997f,-0.48989998f,-0.46430000f,-0.52320000f,1.69009994f,0.79420004f,-0.34589997f,0.37530000f,-1.11419999f,-1.66969998f,-0.75209999f,0.30999997f,-0.17720000f,-0.10869998f,-0.93939998f,1.53469997f,-1.12389997f,-1.07680000f,-0.39829997f,-0.13120001f,-0.31199999f,1.50549999f,-0.87199998f,-0.75069999f,-1.18319995f,0.41599997f,-0.55989998f,-0.33130001f,0.33280000f,0.74639999f,0.11390000f,0.54719999f,-0.17100003f,0.33840001f,0.17299999f,0.18559999f,-0.55800002f,0.82870000f,0.40179998f,1.02470000f,0.39309995f,-0.57049996f,-0.47879996f,0.40939999f,0.48289999f,1.07770001f,0.89439999f,0.39590001f,0.38720000f,0.60759998f,-1.00319997f,0.16690002f,1.27769995f,1.58569999f,0.29360005f,1.45339998f,-0.56500001f,-0.46399995f,-1.08329995f,0.34110003f,1.83789998f,1.00879998f,0.04510002f,-0.01499999f,-0.47259999f,0.07120000f,-0.54809999f,-0.25799997f,-0.82399998f,0.47539997f,1.15319999f,-0.20650000f,-0.65230002f,-0.76999996f,-1.38949999f,-0.80909994f,0.33389998f,0.79619997f,0.12419999f,0.48900000f,-0.86240000f,-0.02569998f,0.31199999f,-0.71530005f,-0.53910001f,0.02509999f,0.41579995f,-0.49760006f,0.32349999f,-0.61480003f,1.04240001f,-0.47190001f,-0.35579999f,-0.85070002f,0.45299996f,-0.20750005f,0.58110001f,-0.44200003f,0.04690000f,-0.24180001f,0.54069998f,-0.09850001f,0.14660002f,0.75170000f,1.02299997f,-0.70199999f,0.97370004f,-0.16199998f,0.80989997f,1.21859996f,0.25679998f,-0.54110003f,0.63450000f,1.05039999f,0.44360000f,0.63970001f,0.30910000f,0.18210002f,-0.76239999f,-0.22519998f,0.21669995f,0.22140002f,-0.29350001f,-1.32359997f,0.77569997f,-0.70509999f,0.09589998f,-0.00799999f,0.44269996f,-1.32929997f,1.40009998f,0.10000001f,0.49269999f,0.20999999f,0.72890000f,0.56200001f,0.23270001f,0.30970000f,0.51279999f,-0.22409999f,-0.68610000f,-1.06149998f,-0.41769997f,-0.39500001f,-0.36100002f,0.47929998f,0.60119998f,-0.45809997f,-1.00799998f,-0.43440000f,-0.43940000f,-0.20839997f,1.15089998f,0.17229997f,0.50320000f,-0.77139998f,-1.00100000f,-0.69339999f,-0.54350000f,-0.20799998f,1.15360000f,0.51009996f,-0.93330000f,-0.85509995f,0.11730000f,-0.04060001f,0.39929998f,-0.12170000f,-1.37039998f,1.20969998f,0.50279998f,0.69269999f,-0.26169999f,-0.04679998f,0.29019998f,-0.45969997f,0.65729998f,-0.01470001f,0.40570000f,0.00369999f,-1.47169997f,0.34160000f,1.14959998f,0.13819998f,0.71400000f,0.63329999f,0.43490002f,-0.26920000f,-0.08580000f,0.46770001f,0.15050000f,-0.60780002f,0.71660000f,0.35350003f,0.23740000f,1.24220001f,-0.46089999f,0.52840001f,0.43629998f,1.32100002f,0.43910001f,-0.06659999f,0.37110003f,0.28210001f,0.04289999f,-0.17440001f,-0.41709998f,0.83979999f,0.71939998f,-0.55490000f,0.94699997f,1.49820002f,-0.80069999f,-0.68850002f,0.22910003f,-0.28019992f,-0.36160000f,-1.09270001f,-0.14529999f,-1.41399999f,0.13820001f,-0.01360000f,0.04020000f,-0.49549999f,0.75359997f,0.39960001f,0.68939997f,-0.22630001f,-0.24289999f,0.50779998f,-1.31029994f,1.10469998f,-0.91429999f,-0.88720001f,-0.24149999f,-0.22800000f,-0.70940000f,0.53279997f,-0.00590002f,1.15240000f,0.27919995f,1.35210001f,0.68790001f,-0.06019998f,-0.72750001f,0.62930000f,0.25139998f,0.65880000f,0.74149999f,0.09950000f,-0.81250000f,-0.16910000f,-0.41580001f,1.47639997f,0.21910005f,1.94769996f,0.28140000f,1.43100002f,-0.45909997f,0.11010001f,0.76940001f,0.99049999f,-0.03020000f,1.21999999f,-0.08339998f,-0.72759996f,-0.47700000f,0.34359998f,0.72369998f,-0.80389997f,0.31860000f,-0.83419999f,-0.39929999f,-0.62599996f,-1.32819998f,0.03230002f,-1.27320000f,0.03120001f,1.06360000f,-0.13760000f,-0.61880001f,-0.49729998f,-1.52089997f,0.39779999f,0.55840000f,0.41429997f,-0.48419998f,-1.51020002f,-0.84570000f,-0.44959998f,-1.00859998f,-1.67070000f,-0.49690001f,0.34320001f,-0.30489999f,-0.20789998f,-0.78020001f,-0.32499996f,-0.76420003f,-0.26200003f,0.78479997f,-0.25150007f,0.31450000f,-0.63020002f,0.17440000f,0.33240001f,-0.65959998f,-0.53029999f,0.68339998f,-0.25340001f,-0.51949995f,0.49900001f,-1.21130001f,-0.39400005f,-0.31680005f,1.37850000f,0.02039995f,-1.87750003f,1.03200001f,1.35550002f,0.54230001f,1.25010001f,-0.21350000f,0.07559999f,-0.79929996f,1.07479999f,-0.88759999f,-1.12299998f,0.08979999f,0.02469999f,0.47349997f,1.30529998f,-0.18660000f,0.19290001f,0.35210001f,-0.97439995f,0.56389999f,-0.21970000f,0.26429998f,-0.43340001f,0.11770000f,-0.01119999f,-0.93719999f,0.76830001f,0.46990000f,-0.01530002f,0.39579998f,0.10460006f,0.54850002f,-0.81570004f,0.40520003f,0.83419997f,-0.31000002f,0.34509999f,0.34239999f,-1.24340000f,0.04180001f,-0.66040002f,0.49000002f,-0.26720003f,-0.86540000f,-2.04080001f,0.48720000f,-0.09780000f,-1.22309997f,-1.53100001f,1.47929996f,-0.19779997f,-0.01649997f,0.12620002f,-0.27240000f,0.56440001f,-0.46519998f,0.74660001f,0.43380000f,0.02639995f,0.90760005f,0.13570000f,-1.14249999f,0.25470000f,0.34049996f,1.15669995f,0.60210002f,0.48250003f,0.86400003f,0.47070001f,-0.24990000f,-0.09909997f,0.35600002f,0.38600002f,-0.06930002f,-0.80960000f,0.67390000f,-0.77160002f,0.76770001f,1.27550004f,0.30569996f,-0.54610000f,0.40260000f,-1.01280001f,-0.34550000f,-0.25460002f,0.04080002f,0.26140002f,-0.44289999f,-0.41060001f,0.21259997f,0.65979999f,0.29720000f,-0.17340000f,-0.06359997f,-0.09680002f,-0.41900000f,0.69709997f,1.93260000f,-1.04799996f,0.72060000f,0.24539997f,0.12579999f,-0.70209999f,-0.05100002f,0.26099999f,-0.17460001f,-0.51220002f,-1.09040004f,0.80240001f,0.72479996f,-2.43030006f,-0.96669999f,-1.34570003f,-0.80780010f,1.31160004f,-0.01860004f,0.67560001f,1.40959999f,-2.44130009f,-1.63170002f,-0.27100002f,-0.47750003f,-0.33980001f,-0.54279999f,0.51789997f,0.30769997f,0.44150002f,1.41550006f,-0.91640001f,-0.04110002f,0.35820000f,-1.74759998f,1.61560001f,1.28169999f,-0.27500000f,0.98880003f,-1.31830001f,-0.45890001f,-0.03250000f,0.32960000f,-0.35139998f,0.85989998f,-0.44100000f,-0.97209995f,-0.08240005f,1.23330000f,0.16539999f,0.87490002f,0.35740000f,-0.25870002f,-0.95920003f,-0.93239997f,0.11939996f,1.03530001f,0.38260000f,0.08250000f,-0.38000001f,-0.30999998f,-0.44190003f,0.88590006f,1.21480003f,-1.62060002f,-1.58730001f,0.65700001f,-0.41310004f,-0.40430001f,-0.79440005f,0.67550008f,0.08460002f,-0.02619998f,-0.96360002f,-0.63310003f,-0.65590002f,0.04970000f,-0.19500000f,0.86770002f,0.33369997f,0.17240003f,0.14490002f,-0.01949999f,-0.17760000f,0.91689997f,0.31779998f,0.90520003f,-0.10270004f,0.29300001f,0.44729999f,0.26970002f,0.60780003f,-0.17530000f,0.32319999f,0.14260001f,0.37000000f,-0.52240000f,-0.69140000f,-0.16220000f,1.30029999f,-2.03159998f,0.28569999f,-0.21759995f,-0.23879998f,-1.44799999f,0.39819998f,-1.40280003f,-0.22520000f,-0.42860002f,0.16740001f,-0.54570001f,0.90510002f,0.43800000f,-1.50940006f,-0.93939998f,0.26889998f,-0.31520000f,1.08080004f,0.28420000f,0.82780002f,1.41600001f,-1.00620002f,-0.97450001f,1.53690003f,0.24800000f,0.01650000f,0.27100002f,0.25759999f,0.21389998f,-0.03560000f,0.94990002f,-1.29020000f,-0.81029999f,-0.11000001f,-0.80480000f,0.82810000f,0.58860001f,0.05150001f,0.08459999f,-0.39810002f,-1.00560000f,0.88370002f,0.59390001f,-0.24220000f,0.67419998f,-0.67240002f,-1.08199998f,0.20379997f,0.37070001f,0.41340000f,0.13470000f,0.03480001f,-0.11940002f,-0.05100001f,-0.85139999f,-0.38459999f,1.10689999f,-0.01199999f,-0.97940000f,-0.39240000f,0.09690000f,-0.71660004f,0.20899998f,-0.22290006f,0.03630001f,-0.24700000f,0.64590001f,0.54950002f,-1.38090004f,-1.48480000f,-0.97960001f,0.03660000f,-0.17000003f,0.80809998f,-0.84730004f,0.84290003f,-0.18770001f,-0.39030001f,-0.05110003f,-0.32480000f,0.61720001f,-0.11320001f,0.17050000f,0.24869999f,-0.26929999f,0.55630001f,-0.75440002f,0.90040001f,0.02970001f,-0.57400001f,-0.38980000f,0.47610004f,-0.86070000f,-0.84920003f,-0.19870001f,1.03420001f,-0.12439999f,-0.35489999f,-0.23299999f,0.16919999f,-0.20420001f,-0.82389998f,-0.94960001f,1.24590000f,0.57380000f,-0.40300000f,2.09679996f,-0.23259997f,1.04419997f,0.28359999f,0.75860002f,0.17400000f,-0.31130003f,-0.60449998f,0.25159998f,-1.50000002f,-0.53310006f,-0.79970005f,-0.99710010f,0.26720000f,-0.06590002f,-1.12650004f,-0.15870001f,-1.18710004f,-0.84350007f,1.48820004f,0.26390000f,-0.39700000f,-0.30299998f,0.42320000f,0.50290001f,0.62939999f,0.63180001f,0.35839996f,-0.11099999f,0.50149997f,-0.24280001f,0.65670002f,0.91430002f,-0.55300004f,0.09520000f,0.36580001f,-1.10250003f,0.65640001f,0.72560001f,-0.16429999f,0.64360000f,-0.36399998f,0.49849997f,-0.17820002f,0.70970001f,-0.78620001f,0.73560002f,0.34520002f,-0.72700000f,-0.48240003f,0.85800002f,0.14980000f,0.58110000f,-0.31199998f,-0.63610001f,-0.52760000f,0.11760000f,0.08940001f,-0.05740001f,-0.03969999f,1.40600004f,0.76710000f,0.25880002f,0.38209996f,1.70240004f,0.97320000f,1.15110004f,0.10120003f,-0.03649995f,1.05260009f,-0.31199998f,-0.86290002f,-0.43260001f,-0.68640003f,0.38180001f,0.43330005f,0.29420000f,-0.98850000f,1.11919999f,0.05630001f,0.95789998f,-0.64850001f,0.98520001f,-0.63800004f,0.07260002f,0.95050001f,-0.49609998f,-0.45470004f,-0.53010004f,0.60420003f,0.57050002f,-0.54350001f,-0.39320000f,0.29299999f,0.24500003f,-0.35920002f,-0.61419997f,0.54860000f,-0.14699997f,-1.13300000f,-0.19879996f,-0.34040001f,0.70819999f,-0.70780002f,-0.93160001f,1.28549999f,-0.69600002f,-0.25619999f,1.18720000f,-0.43120001f,-1.12919998f,0.19630000f,0.34530002f,-0.91560003f,-0.96229999f,-0.56380001f,-1.58929998f,-0.63009996f,0.80850001f,-1.65939997f,-2.29649998f,1.04160000f,0.89439998f,0.44180001f,0.70470001f,0.30679998f,0.52369994f,-1.11669992f,0.52689998f,-0.34410000f,-0.55389999f,-0.60869996f,1.44049998f,-1.82949993f,0.55950000f,-1.47410000f,-0.08600002f,-0.21489997f,0.59130000f,0.29869998f,-0.44799999f,0.08119999f,0.05100000f,1.47550003f,0.59790001f,0.09170004f,0.81090001f,0.26189997f,-0.24739999f,0.33660004f,0.52179997f,0.45980001f,-0.74830001f,0.91960004f,-0.84090001f,-0.54589999f,-0.59990001f,0.42220004f,-0.06610000f,0.23020001f,-0.75669994f,0.28780005f,0.79959995f,0.28999995f,0.05879999f,-1.39749998f,-0.11209998f,1.26050002f,-0.28760007f,-0.37680004f,-1.74909996f,-0.42049997f,0.02749998f,-0.91949998f,-0.34119999f,-0.41170001f,-0.56189997f,-1.11759997f,0.73029998f,0.75829998f,0.56789999f,-0.31730002f,-0.97479994f,-0.57459998f,0.71919996f,0.67490000f,-0.77839998f,0.44029999f,-0.82209998f,1.75090000f,-1.26889999f,-0.36400002f,-0.64469999f,0.75659995f,1.09539997f,0.24370001f,-0.52520000f,0.22439998f,0.63870001f,1.25670001f,0.63509999f,1.13650002f,-0.69760001f,-0.33769998f,-0.21559995f,-0.28130001f,0.90019999f,-0.31479995f,-1.15030000f,-0.35329999f,1.57660002f,-0.24280003f,-2.23500002f,1.12270000f,0.57790004f,0.50880000f,-0.36090001f,0.55140002f,1.15339999f,0.58339996f,-0.81710000f,0.34159998f,0.91679999f,-1.55609995f,-1.38809999f,0.28900001f,0.84820001f,-0.02790004f,-0.31309997f,-0.91389996f,0.47070000f,-0.87900000f,-1.26479999f,0.65379999f,-1.37709997f,1.75459995f,0.49359999f,-0.45999998f,0.30849997f,-0.92629997f,-1.03060000f,0.26080006f,0.92559998f,0.35310000f,-0.35160001f,-0.45370000f,0.23199998f,0.22650000f,-0.38629999f,0.48390002f,0.35319999f,0.07550001f,0.87770000f,1.62759997f,-0.03199998f,-0.08209999f,0.55810000f,1.57100001f,0.66100001f,1.15220003f,0.23890001f,0.16099999f,0.45579998f,-0.36649999f,0.24149998f,-0.12369999f,0.05540004f,0.50330004f,1.34369994f,-0.70950000f,-0.57109994f,0.09960001f,0.76210002f,0.22860005f,0.39730003f,-0.13819997f,-0.62919999f,-1.30070000f,-0.19830001f,0.81310000f,-0.32090001f,-0.10150002f,-1.07079994f,0.35610001f,-0.37149999f,0.55159997f,-0.66619997f,-1.35719999f,-0.53499996f,1.46819996f,-0.46419999f,-0.31210000f,-0.79459999f,-0.44560003f,-0.43609999f,-0.26219999f,-0.14719998f,-0.45720001f,-0.24260002f,-1.10250001f,0.03380000f,-0.22230004f,0.40710000f,-0.13369997f,-1.59299998f,-0.22469999f,0.08489997f,-0.47789998f,-0.27939997f,-0.86979998f,0.18980003f,-0.19070000f,-0.68219999f,0.01499999f,0.97119999f,-0.63180003f,-1.37930003f,-0.05579996f,0.95750005f,-1.00949998f,-2.28459998f,0.77039997f,0.95519995f,-0.76059995f,0.30869999f,-0.57639998f,0.96149999f,-0.70899999f,-0.97219999f,-0.29569998f,0.16710000f,-0.39550000f,0.86949998f,-1.52139996f,0.72140001f,-0.77920002f,-0.71339999f,0.00730001f,0.18089999f,0.37019998f,-0.90889997f,0.57369999f,1.12699996f,-0.11130000f,0.70719996f,-0.31789998f,0.50519999f,1.76730002f,0.08580004f,-0.96140002f,-0.73330001f,-0.74100002f,0.68199999f,0.04719999f,0.24000002f,-1.51310000f,-0.83369999f,-0.77059995f,0.55859996f,-0.10880007f,1.10499999f,0.88750001f,0.42920002f,1.05400002f,-1.60309997f,-1.41120000f,-0.52560000f,-0.31330003f,0.83300003f,1.36460001f,-0.04230001f,-1.24430000f,0.77509998f,1.08519998f,1.10829993f,0.06850001f,1.90549999f,0.31589999f,0.23080002f,-0.05739999f,-0.10939999f,-1.40550000f,0.47760006f,0.58140000f,0.34549999f,0.31950003f,0.93659994f,-1.22499999f,0.69739998f,0.67250002f,-0.61280001f,0.51309996f,-0.48290000f,-0.49499992f,-0.30890001f,-1.34800002f,-0.15039999f,0.14159998f,1.57140001f,-0.78199998f,0.20020004f,-0.34340000f,0.09989999f,0.51529998f,0.27890000f,-0.25730001f,1.24150006f,0.00220000f,-0.64400003f,0.30009999f,-0.48960002f,-0.80679998f,-0.29459997f,-0.38190000f,0.40240000f,-1.30879995f,-0.11200000f,-1.18429998f,-1.28249998f,-0.15379998f,0.10989999f,0.17469998f,1.25409996f,-1.41949999f,-0.79529998f,0.26969997f,-0.92670002f,0.26870000f,0.49420001f,-0.38719998f,-0.14850000f,-0.43400001f,-0.24590000f,-0.95039996f,0.97669995f,-0.34499999f,-0.58069996f,1.11759993f,0.41650002f,0.07059995f,-0.01150005f,0.15560001f,0.35940003f,0.45439999f,-0.09709999f,-0.75739997f,0.47439998f,-0.55489999f,-0.05280000f,-1.24790002f,-0.54990000f,-1.33870003f,0.07420001f,-0.02760002f,0.64739999f,1.00689999f,-0.36849999f,0.12280001f,-0.54650000f,0.49590001f,-0.99599996f,-0.14419996f,-1.07879999f,-0.41759999f,-0.31980001f,-1.11420001f,0.30799999f,0.93669995f,0.47359999f,-0.09890000f,1.10360001f,2.42010000f,-0.47600000f,-0.95379997f,-0.48579998f,-0.77399996f,-1.23999995f,-0.83549998f,-1.26839996f,-0.11540001f,-0.35080000f,-0.22920000f,0.43849997f,-0.21830000f,0.42829996f,0.01329999f,0.53380001f,-0.27479999f,0.82629998f,0.37599997f,-0.94619995f,0.82309998f,-1.34049996f,-0.10100002f,-0.94479995f,0.71799996f,-0.46299999f,0.86719999f,-0.12940001f,-0.86829999f,-0.53689999f,-0.54919999f,0.60449999f,-0.68420000f,-0.99390002f,-0.31409997f,-1.06619998f,0.84759999f,-0.31510001f,0.97680005f,-1.83350002f,0.34860000f,0.81370002f,0.70180000f,0.18850000f,0.53260002f,-0.47599997f,1.86979996f,0.54599998f,0.45559998f,-0.28389999f,1.78419999f,-0.05910002f,0.89260000f,0.55809997f,1.29680001f,-1.40129998f,-0.05080001f,0.20519995f,-1.50120000f,0.31000002f,-0.34540000f,-0.32250000f,-0.01220001f,0.82039996f,0.71900002f,-2.26570008f,-1.25940000f,-0.44360002f,-0.85010005f,1.25420004f,1.48580004f,-1.39950003f,-0.91139998f,1.86640007f,2.21910008f,-0.96910005f,-0.02859998f,1.05850005f,1.04850000f,-0.06080001f,-0.21969998f,-0.51260002f,1.27690000f,-1.53160003f,-1.03250000f,0.58230000f,0.47869999f,-0.00710000f,-0.10670001f,-0.49619999f,-0.89480001f,-0.02609999f,0.03900004f,-0.34290002f,-0.70340004f,0.59810000f,0.32330000f,0.19780001f,-0.95109999f,0.03179997f,0.93040003f,0.73360001f,0.72279998f,-0.65739999f,-1.18610000f,1.67460002f,0.44790000f,1.37500000f,-1.17670002f,1.01240002f,0.89589999f,0.35300003f,-0.45420001f,0.50900005f,-1.01180003f,-1.17330001f,-0.38500001f,0.65079998f,-0.05570000f,-0.43310002f,-0.71180007f,-1.10170003f,-1.45640005f,-1.70100002f,0.72720005f,1.60489999f,1.59220001f,0.15859998f,-0.17830003f,0.01079997f,-1.09440000f,-1.21390001f,-0.26080003f,0.56870003f,0.52080000f,-0.14500003f,-0.06630003f,0.82130001f,-0.68820001f,-0.10899998f,0.11889998f,0.24329999f,0.75979999f,-1.59010000f,0.24589997f,0.84290003f,-0.11750000f,-0.21510001f,1.20440000f,1.11640000f,0.03280001f,0.09359999f,-0.82699999f,0.20750001f,-1.00160001f,-0.22269996f,0.16480003f,1.24769998f,0.39040001f,-0.76540000f,0.16659996f,-0.39310000f,-0.63920002f,0.05190001f,0.38190001f,-0.65969999f,-0.09019998f,-0.20779998f,0.09589998f,0.19589997f,1.31960000f,-2.31820004f,-1.23190003f,0.82969999f,0.81339996f,-1.59650006f,0.20410001f,-1.34210010f,-0.08620003f,0.11710001f,0.03390001f,-0.01099998f,0.34570000f,-0.30590000f,-0.39100000f,0.65970001f,0.43030003f,-0.34010002f,0.53600000f,-0.61940002f,-0.86140000f,0.50590002f,1.18190005f,-1.14640000f,0.08900002f,-0.60840000f,-0.92660004f,-0.24689999f,-0.39700000f,-0.09820000f,0.64789999f,0.94059999f,-0.02440001f,0.46659998f,-0.50669998f,0.40919999f,1.43549999f,1.22459996f,-1.04559997f,0.51399994f,0.63400001f,1.57239999f,0.10810003f,0.83900001f,0.15299998f,-0.35450001f,0.55330001f,0.98630000f,0.28300005f,0.26640000f,0.81860003f,2.07400005f,0.67420000f,-0.88239998f,0.46550003f,0.03479997f,1.39460000f,0.25719998f,0.13199999f,0.79650004f,0.13399998f,0.30650001f,0.51229998f,0.24340000f,0.46830000f,-1.05160003f,0.57840002f,0.44580003f,0.16810003f,-1.68650001f,0.24199997f,0.55889998f,0.87339999f,-0.58699999f,0.61700001f,0.59410002f,-0.42459998f,-0.37230000f,-0.51550001f,0.40869998f,0.33200002f,-0.74859999f,1.18340001f,0.39719998f,0.59279999f,-0.93590000f,-0.07179995f,0.66289997f,-1.43779997f,-0.04749999f,-0.38619999f,-0.81969998f,0.66499997f,-0.60319999f,0.48819999f,0.26549999f,0.31820002f,0.92879999f,-0.26990001f,0.42029999f,-0.37730002f,-0.23640001f,0.27660003f,-0.21940003f,-1.90700003f,0.17210002f,0.34909999f,-0.29489995f,0.42030000f,-1.62770008f,-0.95570007f,0.19270001f,-0.09470004f,-0.71700001f,-1.50460002f,-0.35640003f,-0.17980000f,0.09710001f,1.34340003f,-0.41110000f,-0.92190001f,0.31489999f,0.49310002f,1.13109999f,0.51289997f,0.31319997f,0.66590004f,0.27909996f,-0.53160002f,0.55660002f,-0.07500001f,0.65499998f,-0.36070000f,-0.54459999f,0.23380001f,-1.26900003f,-0.14089998f,-0.77299994f,0.80089998f,-0.34699996f,-0.15729999f,-0.62979996f,0.46409996f,-0.37560001f,0.79820005f,0.22820001f,-0.29880001f,0.06900000f,0.74180000f,1.15680002f,0.61800002f,0.74380004f,0.27249999f,-0.34269998f,-1.05480003f,-0.20509996f,0.70010005f,0.72030008f,-0.78330005f,-1.26660003f,0.27650002f,0.12839999f,1.07690003f,1.25309999f,-0.20260000f,-0.85360000f,-0.00149997f,-0.57630001f,-0.64400000f,0.12599999f,-0.36979999f,0.90220000f,-0.61489996f,-0.60890003f,-0.88519999f,0.03900001f,-0.40980004f,-0.23199998f,1.12140001f,-0.28840001f,0.41509999f,0.20920000f,2.09699998f,-1.05909998f,0.53439999f,0.16079998f,-0.92719997f,-0.07899999f,0.82340000f,-0.31719997f,0.81659999f,-0.43100004f,-0.79099999f,1.10890001f,0.36400001f,-0.30130001f,0.08380001f,-0.38040000f,-0.68080002f,0.79540006f,-0.04060000f,0.46340005f,-0.38770002f,-0.71360004f,0.22349996f,-1.06160003f,-0.51649999f,0.53760001f,1.17910001f,1.41140001f,0.97729999f,1.48700003f,1.41000001f,0.18520002f,0.39180003f,0.62830000f,0.17699997f,1.02180004f,0.06810000f,0.59809999f,1.65390002f,-0.33119998f,-0.49969998f,-0.55509998f,-0.57749998f,0.26100000f,-1.30229999f,0.69240000f,-0.52420001f,0.22280002f,0.08740000f,-0.27260000f,0.42080000f,-1.12099998f,-0.35690000f,-1.60040002f,0.42179998f,-0.49980005f,-0.71999995f,1.80819997f,0.42119999f,1.06679999f,-0.07100001f,1.08340000f,-0.59730000f,0.58240001f,-0.75680000f,0.02839999f,0.10859999f,-0.27499998f,-1.75369995f,-0.03480001f,-1.43530002f,0.34159995f,-0.53810001f,-0.18670000f,-0.49900002f,-1.08320000f,1.91619997f,1.00410001f,1.12350001f,0.81670000f,-0.48660001f,-0.38390000f,-0.50539999f,-0.35789999f,-1.18650000f,-1.52819999f,0.14869997f,0.66509999f,0.99249996f,0.96380000f,0.38799999f,-0.41990001f,0.49860001f,0.47950003f,0.44639999f,-1.01809999f,0.13540001f,-0.14210002f,-0.87579997f,0.64480000f,-0.52220000f,0.15720000f,0.18840004f,-0.29310000f,0.01660002f,-0.99330001f,-0.15910000f,-1.20600003f,-0.29510000f,0.40259998f,1.34410000f,1.44580001f,0.75849999f,0.27880002f,-1.27370009f,-0.19040001f,-0.90570001f,-0.13740000f,-0.06320000f,-0.53390002f,0.64619998f,-1.07590003f,-0.60290004f,-1.30050000f,-0.47620001f,0.55920002f,1.10020000f,0.16700002f,-0.76349997f,-0.39280002f,0.20129995f,0.09780002f,-0.77790000f,0.75020000f,1.42770000f,0.71399996f,-0.01690001f,0.65469996f,0.73280000f,-0.46219999f,0.70420000f,-0.70790000f,1.34710000f,-0.04500003f,-1.15650001f,0.97499998f,-1.27210000f,1.18979999f,0.30750004f,0.52559997f,-0.12320000f,0.26239997f,-0.88499999f,0.67670000f,-0.41540001f,0.34810001f,-0.40499998f,-0.09069999f,-1.04549995f,-0.76519999f,0.54179999f,0.76390000f,0.58680000f,0.59019999f,0.79659997f,1.01779997f,-0.46909999f,-0.55189998f,-0.40900001f,0.12940000f,-1.52019993f,-0.71539999f,-1.37649995f,-0.29660000f,-1.60109995f,0.18019994f,0.06330004f,0.73750004f,0.51179997f,0.99399994f,0.05349998f,-0.70649998f,-0.95279997f,0.07629999f,-0.45740000f,-0.31570000f,-0.97829995f,0.16100001f,-0.13940000f,-0.31440000f,0.98439996f,0.19789997f,0.82779999f,0.92199998f,1.45909993f,-0.22750000f,0.72059996f,-0.06950001f,0.38179999f,-0.88909997f,0.20170000f,1.17279998f,-0.12400001f,-0.46259999f,0.36120004f,-0.26780001f,1.16020001f,0.22289998f,0.62920001f,0.42810000f,-0.34509997f,0.85319998f,0.64059994f,0.00209999f,1.02160004f,0.77789999f,-0.45340003f,-0.09859997f,-0.91049998f,-0.28740000f,0.17740000f,-0.09460000f,0.10400003f,-0.21729998f,-0.41209999f,-0.69069999f,-1.89529997f,0.56889994f,1.61029992f,0.08430001f,1.27299999f,-0.94699998f,-0.77929997f,0.08059999f,-0.77060003f,0.41940000f,1.05629998f,-0.56709998f,1.07769996f,-1.08809997f,0.43670001f,-0.93230000f,-0.90669999f,0.28539999f,-0.95179999f,1.94899994f,0.13170005f,0.58669998f,-0.24300002f,1.06869997f,-0.32989997f,0.61539999f,0.23999998f,0.04079998f,0.46319999f,0.93029998f,-0.32119997f,0.62780006f,-0.35150000f,-0.93520003f,-0.12740000f,-0.23450002f,-0.67039997f,-1.89720002f,0.05070000f,0.43830000f,0.72030002f,1.07000000f,0.99409999f,-0.18400007f,0.24279999f,0.31080001f,-0.47049996f,-0.59139997f,-1.20829997f,0.37389999f,0.21789996f,-1.30610001f,-0.79669997f,-0.14610002f,1.70299998f,1.71600003f,0.93600000f,-0.72539993f,-0.19070000f,0.42659992f,0.44620000f,0.36790004f,-0.39499998f,-0.83849999f,-0.77059995f,0.00869997f,0.26919998f,0.96610000f,-0.16130000f,-1.35340001f,0.28600003f,1.85919998f,-0.18999997f,-0.49480002f,-0.75219993f,-1.84189999f,1.23979998f,0.08560003f,0.79979999f,0.77399998f,0.20039998f,0.01830002f,-0.85739999f,-0.19750001f,1.59519999f,-0.61209997f,-0.61609993f,0.53449996f,1.24739997f,0.22440000f,-0.61750003f,0.40619997f,1.13470000f,-0.12909998f,-0.60049997f,-0.27760000f,0.52920001f,0.05359998f,-1.37580001f,0.85839998f,1.39869999f,-2.05539991f,-0.61389999f,0.12859994f,0.76369998f,-0.64170002f,-0.08760004f,0.31799999f,-0.22809999f,-1.00039996f,0.69649999f,-0.27740002f,-0.22030002f,0.13259997f,-1.02809999f,-0.31099998f,0.50769999f,-0.45819999f,-1.19569998f,0.24320002f,1.29699994f,1.19969995f,-0.98249996f,0.87150000f,0.62710002f,0.57689996f,-1.38449996f,0.97989997f,1.24959997f,0.28459998f,0.57419999f,0.59749999f,-0.26079996f,-0.67259998f,-0.72739999f,0.75529999f,-0.44559997f,-1.02479999f,-0.41039999f,-0.52979998f,-0.71480001f,-1.00890002f,-0.03270001f,-0.70019999f,-0.50250000f,-0.48380001f,-0.27460002f,0.84440001f,-0.83279999f,-0.75690003f,-0.07890000f,0.04580000f,-1.65069990f,-0.63060000f,-0.39889999f,-0.05550001f,-0.57980002f,0.41959994f,-0.23179999f,-0.15899999f,0.18399996f,0.83339994f,-0.09320000f,0.16880000f,0.96879997f,-0.13439998f,0.40240001f,1.14479995f,-0.75329997f,-0.88629999f,0.37010000f,0.46579999f,0.89269995f,-0.13840000f,0.48169996f,0.10700005f,0.96159995f,-0.10160000f,0.37349997f,0.52960001f,-0.11380001f,0.81539995f,1.13229998f,-0.01029999f,0.67710001f,-0.52130001f,-0.43549998f,0.54590000f,0.19860002f,0.94830001f,1.76749998f,0.04190001f,-0.04160000f,0.68489999f,0.64279999f,0.65280001f,0.50560000f,0.16040000f,1.10279996f,-0.37840002f,-0.41889997f,-0.83039996f,-0.37959998f,0.49649998f,-1.16799997f,1.52309996f,1.33919998f,-0.82809995f,-0.12750000f,0.45980000f,-0.25669995f,0.75139999f,-0.24339999f,-0.06679999f,-0.26500000f,0.83159994f,0.05380000f,-0.16879997f,0.71120000f,-0.88559998f,0.60159998f,-0.32029999f,-0.58410002f,0.10070003f,-0.86129999f,-0.13209997f,1.08459998f,0.02409999f,-0.51980000f,-0.27339999f,-0.53920000f,-0.20079999f,0.40750000f,-1.38000006f,0.62530003f,0.27979997f,-1.22959999f,0.38750002f,-1.08230001f,-0.77010002f,0.17819998f,1.34740005f,0.35879995f,0.38860001f,0.46749998f,-0.74850002f,0.50530002f,-0.29470000f,0.17720000f,0.75590000f,0.56620006f,-1.76770001f,0.24479999f,-0.55100000f,0.22279998f,0.30370000f,-0.73859998f,0.39809997f,-1.76380000f,0.82200001f,-0.35220000f,-0.07559997f,1.12660002f,-0.24760001f,0.17500000f,-0.22650001f,-0.00829999f,0.09850002f,-0.07249994f,0.40590003f,0.25940004f,1.45010007f,1.23680005f,-0.73030002f,0.95830003f,-1.01260006f,-1.23690001f,-0.04139998f,-1.02250000f,-0.00160002f,-1.08890002f,0.27620005f,0.25730001f,-0.10070000f,0.27149998f,-0.44669998f,-0.55180002f,-0.13379999f,-0.79560002f,0.39150003f,1.43860003f,-0.94770000f,-0.06330001f,-1.07110000f,-0.18670005f,-0.32029998f,-0.19149998f,0.22430001f,0.68550000f,0.71940004f,-0.30819999f,0.08660003f,-0.46380002f,0.87660002f,-0.09210001f,0.73300002f,-0.58330002f,0.08279994f,-0.09549997f,-0.25080002f,0.57020000f,-0.30640002f,-0.25779999f,-1.25720000f,0.87880001f,-0.81499999f,-0.45390001f,0.63470001f,1.55490000f,1.37190001f,0.96400001f,-0.08729994f,1.22730001f,0.26250001f,-0.30990004f,-0.04289997f,-1.74590005f,-1.08070000f,-0.79259999f,-0.61179997f,0.53270000f,-0.08009999f,0.14300002f,0.41550004f,0.21990002f,-0.82220000f,-0.23239999f,-0.50880000f,-0.45189998f,-0.34730001f,-0.28989998f,1.29830003f,-1.27850000f,1.02499998f,-1.11829997f,0.08249998f,-0.90479999f,-0.65680000f,0.05240003f,0.15050000f,-0.43379999f,-0.42870001f,0.55979999f,-0.69639998f,-0.19480000f,-0.44740001f,-0.01380004f,-0.74269997f,-1.33320002f,0.17240000f,0.41679998f,0.09410004f,-0.04000002f,0.58899998f,0.79279999f,-0.71889999f,0.03579999f,0.19709999f,0.40030000f,-0.39990000f,1.01650003f,-0.56560005f,0.70310001f,0.57470003f,-0.63219996f,0.14750005f,-0.43430000f,-1.43710008f,-0.73869999f,0.20390001f,-0.01389993f,-0.74980007f,-1.92340003f,0.53760003f,0.61889999f,0.05590001f,0.28600001f,-0.40329999f,-0.05260000f,-0.67130000f,-1.29520002f,-0.00350001f,1.05969993f,-0.27530000f,1.01590004f,-1.07829997f,-0.14900001f,-1.35590000f,-0.32279998f,-0.01750003f,0.50369999f,0.61380001f,-0.26229999f,1.33919998f,-0.14500001f,1.52019999f,-0.03969998f,-0.33919995f,0.52759995f,-1.84519999f,-0.48069999f,0.77259995f,-0.23879995f,-0.22140001f,0.02739997f,-0.60139997f,0.91530001f,-0.62939998f,-0.43290000f,-0.27400002f,0.53059998f,0.22209996f,1.34670002f,1.38060003f,-0.96610002f,-1.24430000f,2.28150010f,0.47689997f,-1.38370003f,0.18139997f,-0.91140005f,-0.53870007f,0.93740003f,0.18059995f,-1.41730003f,-1.49219998f,-0.20420001f,-1.05339998f,0.65259999f,-0.19440002f,-0.30769999f,-0.11329999f,-0.28900002f,-1.26430004f,1.52750002f,2.03790007f,-0.18750002f,-0.26129996f,0.29689996f,-0.20830008f,-0.01990000f,0.70730005f,-0.72859998f,0.64040000f,1.01579999f,-0.36169999f,0.39560001f,-1.08800000f,-0.35459999f,1.38489999f,-0.76679999f,-0.87530001f,-0.75080007f,0.47460002f,0.30700000f,0.69159998f,-0.83160001f,-0.79389996f,-0.30920004f,0.58109999f,-0.25290000f,0.00010001f,-1.14300003f,0.14060004f,0.94439999f,1.91679999f,0.83320000f,-0.78579998f,-0.02079993f,-0.45720002f,-1.01249999f,-0.67490001f,-0.61939997f,0.97500000f,0.12880003f,-0.63220002f,-0.39329996f,-0.47430001f,-1.19070002f,0.79019999f,0.82700000f,0.64660000f,-1.48579999f,0.07840001f,1.50359997f,-1.58510000f,-0.24240002f,-0.75779999f,0.55150001f,-0.66630000f,-0.38080001f,-0.07399998f,0.48650000f,-0.88080000f,0.45540001f,-0.05459996f,0.63329998f,-0.23020001f,-0.45860000f,0.94019999f,-1.24159998f,-0.87920001f,0.28319997f,0.44819998f,-0.16499998f,-0.78900001f,0.71489999f,0.17020001f,-1.17009998f,-0.07460000f,0.54270000f,0.36860004f,-0.41560006f,-1.00230000f,-0.01080000f,0.50889999f,2.16270000f,0.97699999f,0.32550000f,-0.54729997f,0.97550006f,0.10710003f,0.77560002f,-0.21049996f,0.06500002f,-0.42610000f,0.36140003f,0.50160003f,-0.77110001f,-0.46409999f,-0.66500002f,0.14600001f,0.14330000f,-1.26760000f,0.33040000f,0.13550000f,-0.17589999f,-0.20060004f,0.44480003f,0.01290002f,0.07229998f,0.27749997f,0.45370002f,0.14780001f,0.09060000f,-0.66230000f,0.51419999f,0.28510002f,0.46959999f,0.07410000f,0.04079999f,-0.98099998f,-1.03479997f,0.24599998f,-0.46219995f,-0.50890001f,-1.48299997f,0.16679998f,-0.45099996f,-0.20830000f,-0.15200000f,-0.11340001f,0.31550001f,-1.25930000f,-0.82769994f,0.24419996f,1.00110001f,-0.61579999f,-0.37819998f,-1.14950003f,-0.26110007f,0.07369995f,0.21719997f,-1.30430003f,-0.19249996f,-1.22580005f,-0.84940004f,0.22540001f,0.12160000f,-0.94819996f,-0.07359998f,-0.94469997f,-0.32989998f,-0.35350000f,-0.04069999f,-0.24900004f,1.04709999f,0.05169997f,-0.56040000f,-0.41889998f,0.83500003f,-1.20130000f,0.06180000f,-0.15000000f,-0.40020001f,0.22240001f,-0.45249997f,1.35939995f,0.28709998f,1.41699999f,-0.34119998f,-0.40779999f,1.07089996f,-0.22620003f,-0.05039997f,1.38999996f,-0.65789996f,0.05179996f,0.77579999f,0.42280000f,0.51500001f,0.24320001f,-0.13500001f,-0.57640001f,0.23460001f,1.82569998f,0.19909996f,-0.34119998f,0.17259998f,0.00680003f,-2.09029995f,-1.42360000f,0.55429995f,1.38210001f,-0.12180002f,-0.41260003f,-0.05589998f,-0.46569996f,-0.45459998f,-0.45480001f,0.50160001f,0.34800000f,0.67189997f,0.65999995f,-0.10129996f,0.13279998f,-0.70609993f,-1.12989997f,0.18540000f,1.63039998f,0.40079997f,-0.60469999f,0.54349999f,0.21320003f,-0.60869998f,0.23119995f,-0.53049999f,0.21660001f,0.04200000f,-0.03770001f,1.88250005f,-0.76740000f,-0.45240001f,-1.17290000f,-1.61230000f,-0.92139999f,-1.74369998f,-0.85440000f,0.19799999f,-0.06410000f,-0.38799997f,-0.49620001f,0.64140000f,-0.06090001f,0.00619998f,0.50910000f,1.22960005f,-2.12289999f,-1.11390004f,-1.77849998f,-1.77850000f,-0.22060000f,0.13920000f,1.06479993f,0.52460000f,-0.65669995f,-0.69159999f,0.47349995f,1.54219997f,-0.78519998f,-1.21649997f,0.71090000f,0.87270001f,-0.11900001f,-0.33130002f,-0.60839998f,0.75479999f,-0.20079999f,0.52600000f,0.08659999f,1.37939997f,-1.31429995f,-1.06099995f,-0.13760000f,0.82129997f,-0.32380000f,0.22480000f,-0.53229997f,-0.80279996f,-1.34589999f,0.07629999f,-0.43920004f,-0.15119997f,-0.70229998f,-0.13979999f,-1.00150004f,-0.47579998f,0.11920007f,0.79990001f,0.55110001f,0.01850002f,0.99770004f,0.37799999f,0.42870000f,0.23790001f,-0.95240000f,0.63650001f,0.85420001f,0.11540002f,-0.83430001f,-0.01940000f,1.18289997f,0.36420000f,-0.19119996f,0.50280001f,1.42590001f,0.34959997f,-0.50090001f,-0.59229997f,0.23900000f,-0.13620001f,-0.56520000f,-0.22659997f,0.72149998f,0.36339997f,-0.82649997f,0.14000000f,-0.50140003f,0.83979999f,0.61790002f,-0.18009997f,-0.23950001f,0.70219999f,0.20380000f,-0.51929997f,-0.35320001f,0.13619999f,0.05199999f,0.31830000f,0.75959997f,0.27549996f,0.17080003f,-0.67080001f,-0.69330000f,1.50000007f,0.44770001f,-0.34670003f,-0.78740000f,-0.64010000f,-0.39820002f,-0.63690006f,-0.38119998f,-1.22020001f,-0.45599998f,-1.08470001f,-0.22750000f,0.42760000f,-0.25150000f,-1.20480001f,0.56410004f,2.12220002f,-1.57629998f,-0.97570002f,-0.65110003f,-0.73620001f,-0.31509999f,0.84139999f,-0.34999998f,-1.36420002f,-0.07099997f,0.55490001f,0.57879999f,1.20289999f,0.28459998f,-1.44699998f,0.44840003f,0.93310002f,-0.48010002f,-0.65080006f,0.75340000f,0.20560001f,0.25810002f,0.56460002f,0.19629998f,-0.12029999f,0.09560000f,-0.55130001f,0.66310000f,0.44480001f,0.41509999f,0.35400000f,0.53130003f,0.41670000f,-0.45260004f,0.78540000f,0.62340000f,0.94159997f,0.95649998f,0.26319999f,1.46540002f,0.84959997f,-0.10600003f,-0.32259996f,-1.16169999f,-1.10379998f,-0.00289997f,-0.28480000f,-0.50820000f,0.25530000f,1.59930000f,0.92019997f,-0.80270003f,0.80549999f,1.08040001f,0.07079999f,0.48419999f,-1.04969997f,-0.48160000f,-0.15670001f,-0.41430001f,0.24230001f,-0.41219999f,-0.31359997f,-0.09159999f,0.13789999f,-0.89810000f,0.78179998f,0.57420002f,0.22939999f,-1.21100000f,0.64889997f,0.02180003f,0.01799999f,-0.80909999f,1.21649995f,0.20560002f,0.35050000f,1.31439996f,-1.67809995f,-0.09840002f,-0.77519998f,-0.13860000f,-0.70690002f,0.12829999f,0.03480001f,-0.31609999f,0.04890003f,-0.04960000f,0.33280000f,0.32319999f,-0.20040001f,0.05380000f,0.12350001f,0.17370001f,-1.12810003f,0.50119997f,-0.01110004f,0.20939999f,-0.48840001f,1.18800000f,0.39210003f,0.43369999f,-0.57159996f,0.20020000f,0.11800000f,0.06020000f,-0.42359998f,0.10529999f,-0.30189999f,-0.33119999f,0.76879996f,1.03639994f,-0.20910001f,0.61499999f,0.81090000f,-0.51000000f,0.38259999f,-0.87740000f,-0.08160002f,-1.47159994f,0.14359998f,-0.90319996f,-0.33970000f,-0.07199999f,-0.42639998f,0.17799999f,-0.74849999f,1.05569997f,0.52030000f,0.60619997f,-0.84159995f,0.17399999f,-0.77940000f,-1.10750000f,-0.84820002f,-0.75370000f,0.72099995f,-0.45890008f,0.63810000f,-0.81929999f,0.67770000f,0.85440003f,-0.33139997f,-2.22070005f,0.19969997f,1.78329998f,-0.21719998f,-0.50260000f,-0.37190001f,-0.92020002f,-0.28900001f,1.04899997f,0.75879995f,-0.35060000f,0.85249999f,-0.33380002f,2.03169999f,2.58540001f,-1.08720004f,-2.55580002f,2.04239997f,1.67189999f,-1.07019993f,-0.03739999f,-0.46820000f,-0.38899998f,0.28569998f,1.10760001f,0.17559996f,0.46940000f,0.42029996f,-1.51359992f,0.81249996f,0.36920002f,0.26599995f,-1.36390004f,-0.44729994f,1.41320003f,-0.35190000f,-1.80820000f,-0.07689998f,1.19679998f,-0.05430001f,1.08660001f,1.21970002f,0.12640004f,-0.62190000f,-1.11539996f,-0.65529996f,-0.74629999f,0.34140000f,0.54730001f,-0.07640002f,-0.13489996f,-1.13260003f,0.42739999f,-0.71970003f,0.47649999f,0.18859999f,0.15160000f,1.02960002f,-0.91449999f,-0.33350002f,-0.69809998f,-0.48270001f,-0.13480000f,-0.09109999f,-0.01279996f,0.09470003f,0.16800001f,-0.56160000f,0.57240001f,-0.45210002f,1.40709998f,1.64629999f,0.14900000f,0.07210000f,1.40659997f,-0.87929999f,1.15209999f,1.13089999f,-0.55999997f,1.09229993f,-1.11819995f,-0.28999999f,0.28560001f,-0.19210001f,-0.12009997f,-0.38330000f,0.48309996f,-0.65169998f,0.71639995f,-0.34639999f,0.09700000f,0.29009999f,1.26830001f,-0.58219998f,0.53330000f,-1.25120000f,0.17570002f,-0.54170002f,-1.76560003f,-0.08619998f,1.78340003f,-1.25140000f,0.06879996f,-1.13310001f,-0.22659994f,-0.19580000f,-0.46250002f,0.24730000f,-0.06150001f,-0.11180004f,-0.71559996f,0.74939995f,0.64509998f,1.33759995f,0.01930000f,0.83020002f,-0.76129999f,-0.08940003f,0.11709998f,0.39760000f,0.20680002f,1.06639998f,0.39640000f,0.28520002f,-0.24510001f,-0.00940000f,-1.34000007f,-0.01659997f,1.18710003f,0.99730005f,1.50250005f,0.32180006f,1.26530005f,0.36970001f,-0.40499997f,0.30699998f,2.12960002f,1.07819996f,-0.69809998f,0.35840003f,0.40250000f,0.48650002f,-0.15279999f,1.20850006f,-0.77530000f,-1.45830005f,-0.38279998f,-1.35620000f,0.10560000f,-0.18799999f,0.96499999f,0.50780002f,1.04979998f,-1.24390001f,1.12959997f,1.04899999f,-0.10559997f,-0.75659999f,-0.27990001f,-0.28430000f,0.72919999f,-0.07389999f,2.00660002f,-0.88020000f,0.10740002f,0.16809996f,-1.05859997f,-0.12680002f,0.02480002f,0.41249998f,-0.50899996f,-0.65299999f,0.59279999f,-0.40730000f,0.71379999f,0.11579999f,-0.06290002f,0.28150001f,0.49929999f,0.24269999f,-1.12100004f,1.35140007f,0.67569999f,-0.60000005f,-0.84680002f,0.30019998f,0.98060000f,-1.81240011f,-1.32620005f,0.85820002f,1.27210003f,-0.97150004f,-1.01899999f,0.75610000f,0.86690001f,0.19229999f,-0.83049999f,0.86569999f,0.27269996f,0.65960002f,0.11700007f,0.25109997f,1.00160001f,-0.30560004f,0.04900002f,-0.53890003f,-0.07500002f,-0.37150000f,0.01510000f,-0.79190000f,-0.10660000f,-1.23940000f,0.00130000f,-0.68699997f,0.50220000f,-1.24340000f,-0.86270000f,-0.25660001f,0.66739999f,-0.71140001f,-0.72699999f,1.12960001f,0.80120002f,0.34359999f,-0.83279999f,0.27399999f,0.57330000f,-0.27860000f,0.44600003f,-1.21790003f,-0.21170005f,1.03149998f,1.16230006f,0.68400006f,-0.29470001f,-1.27840000f,1.06570005f,1.22000004f,0.30750000f,-1.00490003f,1.67100008f,0.32670000f,-0.13040002f,-0.04760003f,-0.43340001f,-1.19280002f,0.63309999f,1.22650006f,0.25870002f,-0.80480007f,-0.94599999f,-0.50219999f,-0.10589999f,0.38860000f,0.15030001f,-0.91120000f,0.45910001f,-0.24910000f,1.21790002f,0.87480002f,0.20409999f,0.39620000f,-0.61040000f,0.38459999f,0.50019999f,-0.82979996f,0.22899998f,-0.54010002f,0.11540001f,0.51129999f,-0.44660001f,-0.70269999f,-0.59280000f,0.74410000f,-1.56920000f,-0.53410003f,-0.78160000f,-0.12599998f,-0.65980003f,0.20980002f,0.38050002f,-1.79110007f,-1.51560004f,-0.33579997f,-0.17850001f,-1.14830004f,-0.30929997f,0.43180001f,0.08850006f,-1.08790005f,-1.54589997f,0.13949999f,0.61799995f,1.52490006f,1.60209999f,0.23529999f,0.66339999f,-0.05529999f,0.52650001f,-0.78940003f,0.55039997f,0.01730004f,0.51160001f,-0.87119999f,-0.25080004f,-1.24679998f,-0.00669997f,-0.50450001f,-0.29739997f,1.00350000f,-0.58900002f,0.89580001f,0.70220000f,-0.25900000f,-0.96700000f,-0.53320002f,1.47470003f,-0.44160000f,-0.41730001f,0.99139997f,-0.08259998f,-0.09420000f,-0.36100000f,0.20479998f,0.68040000f,0.65020002f,0.34270000f,0.15300002f,-0.69180001f,-0.37150003f,-0.46389999f,0.28329998f,-0.01799998f,0.26299998f,0.56490002f,1.18949997f,-0.02700001f,-0.09220002f,0.14940000f,-0.45560000f,0.86870002f,0.25500000f,-1.41560001f,-1.57310001f,0.05920003f,-0.12970000f,0.40660000f,0.42400001f,0.69910002f,-0.66469999f,1.03059999f,-0.13220001f,0.57319998f,-0.25840000f,0.01329999f,-0.29970000f,0.35369998f,0.14249997f,-0.00640000f,0.72969999f,-0.39030000f,0.17270000f,0.61700001f,0.58130001f,-0.09060000f,0.28429999f,0.82900002f,0.18839997f,0.40100000f,-0.36819999f,0.01820000f,0.14509999f,-0.45539997f,0.19769999f,-0.78100000f,-0.72179998f,-1.17879999f,1.26659998f,-0.36340000f,-0.34110000f,0.06830001f,0.60370005f,0.79550006f,-0.70939998f,-0.59599998f,-0.07200000f,-1.55440004f,-1.44510005f,0.05750000f,0.84810006f,-1.00950002f,-0.71640000f,0.53259995f,1.24480001f,0.51899996f,-0.03999998f,0.22650006f,0.65030002f,0.65260000f,0.04380003f,0.54359998f,-0.40000001f,-0.38230000f,0.85799999f,2.12750004f,-0.05020000f,-2.30300007f,0.80569999f,1.76940004f,0.59089997f,-1.21580002f,0.54000005f,0.17690001f,-0.57589998f,-0.49430002f,-0.32540000f,-0.50080000f,-1.07799998f,0.89789997f,-1.55219996f,0.57750001f,-0.64600000f,-0.18959997f,0.44200006f,0.52159995f,-1.32120004f,0.37320003f,1.06119999f,-1.22169998f,0.06579998f,0.30029998f,0.16440003f,-0.58240009f,-1.40420001f,0.13989997f,0.05850001f,0.57310003f,1.16509998f,0.41639998f,0.57479998f,-0.64140006f,-1.08370005f,0.71520003f,-0.26210005f,-0.61919998f,-0.66710001f,-0.17770000f,-0.26680000f,-1.03890003f,-0.30310000f,-1.03960002f,-0.29509997f,0.02579999f,-0.11300000f,0.51100000f,0.09140002f,-0.18790003f,-0.32109998f,0.15239999f,-0.20390003f,0.77790000f,1.04220000f,0.49430003f,-0.01170000f,0.04100000f,-0.50729999f,0.38920001f,0.01010002f,0.58779999f,0.19120001f,0.50679999f,-0.13600002f,-0.31840003f,-0.26729998f,0.11919999f,0.57660001f,-1.79439997f,0.46890000f,-1.14339999f,-0.10820000f,-0.00560000f,0.00810000f,-0.78159999f,-0.56219999f,0.94460003f,-1.83709996f,-1.19780001f,0.36579997f,-0.50529997f,1.11399996f,0.46579996f,0.50410003f,-0.58999997f,-1.16509994f,-0.03919999f,-1.18930000f,-0.46320004f,0.24039999f,0.95739999f,-0.85239996f,-0.08600003f,-0.92049995f,0.20010000f,-0.04029996f,0.72079997f,0.37840001f,0.21800002f,-0.89969997f,0.30840001f,-1.46449997f,-1.14419999f,-0.16010003f,0.46780001f,0.28499997f,1.00079999f,0.14759998f,0.52200000f,0.96040000f,0.89830001f,0.68499999f,0.82710001f,0.09210002f,0.60390002f,1.19919998f,-0.23709996f,-1.94350001f,0.08339997f,-0.26430004f,0.28320000f,-0.09559994f,-0.90830001f,0.12010003f,-0.31030002f,0.67240000f,0.29090001f,0.22320000f,0.14610001f,-0.43519999f,1.15169997f,1.01070001f,-1.30489994f,-1.67409999f,1.30929995f,0.28879999f,0.41590001f,-0.27389998f,-0.17450003f,1.79039996f,-0.89860001f,-1.14460002f,0.28819999f,-0.34840001f,0.52369999f,-0.60550000f,0.70009999f,0.35789997f,-0.02049998f,-1.21579999f,-0.14859996f,1.19349999f,-0.11230003f,-1.55359994f,0.35059998f,0.15740000f,-0.22350002f,0.97040000f,-0.45750000f,-0.51480001f,1.11830000f,0.24559998f,-0.63180002f,0.08590001f,-0.86890001f,0.70299997f,0.35149997f,0.50590000f,0.74610002f,0.72120000f,-0.91780005f,-0.67119999f,0.31270003f,-0.09890001f,0.89020002f,0.22610001f,-0.57060000f,-0.82199992f,0.66810001f,0.19919996f,-1.09240000f,1.22829997f,0.89559997f,0.56320000f,0.77079999f,-0.44110000f,0.29849998f,0.46909994f,-0.74099999f,-0.05329996f,1.44750005f,-0.57840001f,-1.26010001f,-1.43369996f,-1.22479997f,0.30669997f,0.44319999f,0.37669999f,-0.40119997f,0.59199995f,-0.88269996f,0.59549997f,-0.85740002f,1.40769998f,0.83289999f,-0.62219994f,0.23690001f,-0.53369998f,0.01039999f,-0.07249998f,0.08640000f,0.44890002f,0.84759997f,-0.10850003f,0.15470001f,-0.53129999f,-0.53320000f,-0.22330000f,-0.96560001f,0.41800005f,-1.16330002f,0.09320001f,-0.91120001f,-2.13620002f,0.19909997f,-0.23110002f,0.22990000f,0.22059999f,-0.19750001f,0.64650000f,0.19779996f,-0.44860004f,0.21199999f,0.34390000f,-0.22789999f,-0.48079996f,-1.22210000f,-0.53430002f,-1.88289998f,-1.36020003f,1.10939995f,0.31280001f,0.87199998f,1.20489997f,0.58549999f,-0.35059998f,1.68999993f,-0.10869996f,0.64869997f,0.43999998f,-0.63579998f,0.83850000f,-1.64359997f,0.43819998f,-1.48979999f,-0.09700000f,-0.02120000f,0.88670002f,0.69619996f,-0.88959996f,0.36849999f,-0.22620000f,0.58320003f,-0.76159998f,0.45910005f,-0.84390000f,-1.11530001f,-0.42090001f,-0.33399997f,-0.39360000f,-0.37550000f,-1.01559999f,0.07280003f,-0.53650001f,0.06919999f,0.46619999f,0.11590000f,0.21980001f,0.11859999f,-1.43649997f,-0.21579998f,-2.10789998f,-0.27470005f,-0.42110001f,-0.31940001f,-0.25190002f,0.58789995f,-0.66339999f,-0.26890000f,-0.78259997f,0.32459998f,-0.06329999f,-0.39639998f,0.30759999f,0.23359999f,0.05670000f,0.00390001f,0.09780001f,0.06039999f,0.83049996f,1.04510003f,0.73919994f,-0.13650000f,0.40329996f,0.66140000f,-0.57909999f,0.57699997f,-0.28610001f,0.22120000f,0.51089998f,-0.35440000f,0.32299999f,0.36000001f,-1.05750007f,-0.41709997f,-0.90950001f,-1.39839997f,1.05970006f,-1.05249996f,-1.91800000f,-0.01670003f,0.84350001f,0.22850000f,-0.39789998f,-0.46529998f,-1.12820000f,-0.44290002f,0.56550003f,0.04500000f,-0.20760001f,0.44470002f,-0.41360000f,0.14320006f,0.72530005f,-2.59539991f,-0.84520002f,0.78779995f,-0.21889998f,-0.42049997f,0.89220000f,-0.79840003f,-0.60790005f,0.75379999f,1.06100001f,-0.37300000f,-0.63150002f,0.67020000f,-0.03429999f,-0.09699999f,0.85499998f,-1.67929997f,-0.59330006f,-0.18139997f,1.81779997f,0.26799998f,-1.68389993f,0.92889997f,0.14620000f,0.73459999f,1.29310002f,-0.47310003f,-0.28320002f,-0.42880000f,-0.85799997f,0.35540004f,-0.76909996f,0.31750004f,0.03050000f,0.63289998f,0.08980000f,-0.12989995f,-0.06450000f,-0.28480001f,0.79620001f,0.65030000f,0.70110001f,1.11460003f,0.16960000f,0.82210003f,0.10340000f,-0.48159997f,-1.21119992f,-0.35119999f,-0.46579997f,0.87589997f,-1.07959997f,-1.32199998f,-0.19620003f,1.37429997f,0.57499999f,-0.28809999f,0.59730001f,0.88549998f,-0.19810000f,0.49590003f,-0.73080001f,-1.35400001f,-1.35279994f,-0.18670003f,-0.70439996f,0.54299996f,0.51149997f,-0.51389998f,0.82589996f,0.09429998f,1.01849996f,0.46630002f,0.72989999f,-0.78889999f,0.58699998f,0.21519999f,-0.11810001f,0.16879999f,-0.26779999f,0.06660001f,-0.17750000f,0.52050000f,-0.48260004f,-0.10509999f,-0.71970002f,0.29440002f,-0.77520005f,0.52100000f,-0.79260001f,-0.46840001f,0.42130003f,-0.14200000f,-0.53210001f,0.53009995f,0.98110000f,0.38660000f,0.11779999f,-0.00500002f,0.07119998f,0.62609999f,0.40220003f,0.35500000f,-0.82300002f,0.83130003f,0.74800002f,0.97589997f,1.15209999f,-0.66129999f,-0.68410001f,1.24319997f,0.57820001f,-0.04700001f,-0.49090001f,0.56470000f,-0.20720001f,1.22839999f,0.18500002f,0.06140002f,-0.30180001f,0.08080002f,-1.18709996f,1.13049996f,0.54170002f,-0.52430003f,-0.15100002f,-0.49559999f,0.78450002f,-0.23390004f,-1.01759998f,-0.18280000f,0.68489999f,-0.30070000f,0.85170001f,-1.11220000f,-0.34580003f,0.22030002f,0.00839997f,0.14600000f,1.27299999f,-0.66449998f,1.51560002f,-1.32030004f,1.35000005f,-0.69050002f,0.48000002f,0.76840001f,0.18180001f,0.74339999f,1.06280001f,-1.39490002f,0.63419997f,-0.43439998f,-1.19879998f,0.89809996f,-0.16199999f,0.29210002f,0.00580000f,0.19910000f,0.02080006f,-1.30810002f,-0.55039997f,-0.24220002f,-0.68700000f,-0.18120000f,0.11590000f,-1.09930006f,-0.52370001f,-0.83630005f,-1.02770001f,-1.71810004f,-0.48460001f,1.07929997f,-0.21360005f,-0.68969997f,-0.35540001f,0.86710003f,-0.53870002f,0.51910003f,0.97870004f,0.33610001f,0.58140005f,-0.54710000f,0.54150000f,-1.01720000f,0.06030001f,-0.74070001f,1.22020002f,-0.63070002f,-1.76920000f,0.34799998f,0.92199999f,0.32640000f,-0.76010000f,1.28349999f,0.50969998f,0.44820002f,-0.45290001f,-0.54970002f,-0.07779998f,0.24759996f,0.15030003f,-0.21220001f,0.47560001f,0.27159996f,0.30590001f,0.61780001f,-0.13949999f,-1.28519998f,0.92219998f,-1.16119994f,-0.01470002f,0.65880005f,-1.21910000f,0.56600001f,0.25409999f,-0.33130003f,2.06030004f,1.88320001f,-1.13680001f,-1.71769997f,-0.10479998f,-0.19630003f,-0.53330001f,-0.64280000f,0.26260002f,-0.22079998f,-1.44010002f,-1.61860003f,1.08630001f,2.27800001f,-0.57470004f,-0.60130000f,0.66640000f,-0.46850002f,0.39280002f,-0.04670000f,-0.47710000f,0.74659998f,0.47210000f,0.39630000f,-0.02559999f,0.19049996f,-0.79589999f,-0.07439997f,0.15899999f,0.51660003f,0.27249999f,-0.52720001f,-0.79530002f,0.88939998f,0.01800000f,-1.60059998f,-0.52619999f,1.30309997f,-1.48319997f,0.11120001f,-0.29380001f,-0.14939998f,-0.65340003f,-0.38160000f,0.33239998f,1.22269998f,0.52239998f,-1.36109999f,0.71420000f,0.53520000f,0.23530001f,-0.30730002f,-0.43449995f,-1.26610004f,-1.82159998f,0.14140003f,0.40669999f,0.34880000f,0.90150000f,1.65850007f,1.91080004f,2.27670010f,0.95080005f,-0.41689997f,-0.74879998f,-0.11480001f,-0.32820004f,-0.24439999f,0.79589999f,-1.28010000f,0.11290000f,-0.54940001f,0.06710000f,0.56060001f,-0.57239996f,0.73820000f,-1.10640004f,0.76740002f,-1.53840005f,0.43110002f,0.93190002f,0.19119998f,0.44020000f,0.67349999f,-0.50559999f,-0.84879999f,-0.17270000f,-0.26859999f,0.87360001f,0.24580000f,-0.13110001f,1.22580003f,-0.06030002f,1.46340005f,-0.88850002f,0.01300002f,-0.52060003f,-2.02819998f,0.92349997f,-0.60039998f,-0.35459997f,0.30290002f,1.05050001f,0.61920006f,1.75390002f,0.81040005f,-0.08530001f,-0.61229993f,0.57890003f,0.13430002f,0.49430002f,0.34040003f,1.03620003f,1.42250001f,-0.39300001f,-0.36229997f,-0.54710002f,-0.66290001f,-0.04589999f,-0.63599998f,-0.19920000f,-0.69260004f,-0.52959999f,0.29290002f,-0.56850001f,0.06489997f,0.26520002f,-0.42189999f,0.31440001f,-0.04290002f,-0.04589998f,0.21220001f,-0.73430000f,0.20040000f,-0.11480000f,-0.40770000f,0.70360001f,-0.71670001f,0.16340003f,-0.94439999f,-0.83299997f,0.56149999f,-0.34779996f,-0.44910000f,0.58280001f,-0.13560001f,0.46379999f,-0.76689999f,-0.35360002f,0.41449999f,-0.12100000f,0.14040001f,-0.30670001f,-0.18750003f,-1.05830007f,0.79890001f,1.38699998f,3.34960008f,2.27610002f,-1.17440001f,-0.87659998f,1.18820000f,0.34780002f,0.27990000f,-0.77769998f,-0.65580004f,0.31910000f,0.49620003f,0.46930001f,-0.03710001f,-0.30389997f,0.80370001f,-0.15249995f,1.44940003f,-1.81750005f,0.52740002f,1.01540002f,-0.56190001f,-0.28390000f,0.40269999f,-0.36360002f,-0.28170002f,1.03830005f,0.07740000f,-0.61690003f,0.16100000f,0.08000000f,-0.64820001f,0.65850002f,0.90280000f,-0.63400000f,0.72879999f,-1.65150000f,-1.15799999f,1.34049996f,-0.39439996f,-1.17239999f,-0.47899998f,0.27950000f,0.02280002f,0.09700001f,0.44100002f,-0.13710001f,0.05869999f,2.16090001f,1.83019997f,0.07859997f,0.76380000f,0.19579998f,-0.94839995f,0.13000003f,0.20440006f,-1.35720008f,-1.12230001f,-0.81060006f,-0.53490004f,-0.88610004f,0.17090005f,-0.22010002f,-0.18789998f,0.65389998f,-1.08670000f,0.82979998f,0.72779998f,-0.91949998f,-0.82700000f,-0.65929998f,0.85599998f,-0.53319999f,0.73370004f,-1.04030005f,0.60199999f,-0.36330000f,0.48210002f,-0.98449999f,-0.64720002f,-0.67560002f,0.34179999f,0.56020000f,-1.06369999f,0.22279997f,-0.60199997f,-0.14059999f,0.35839998f,-0.42460000f,-0.66250001f,-0.69360002f,0.98130002f,-0.04900001f,-0.18079996f,1.24199999f,-0.29760000f,0.76820001f,0.42000000f,0.17040001f,-0.21559999f,-0.73550000f,-0.98720005f,-0.93060002f,0.49450002f,-0.28950006f,0.39239999f,-0.72690005f,-0.96770002f,-0.33429999f,1.11190006f,0.99390002f,-1.43470004f,-0.29780000f,0.03000003f,-0.19149998f,-0.17420000f,0.38589998f,-0.64470001f,0.46450005f,0.01659999f,-0.46200002f,0.65419998f,0.25020001f,0.77720001f,0.79070002f,0.44920002f,-0.77630004f,0.32330000f,1.10390001f,-0.38420000f,-0.61910003f,0.19100001f,-0.43810000f,-1.03500003f,0.25760000f,-0.09620002f,0.41860001f,-1.12140001f,0.54220000f,-1.83979998f,-0.05180000f,0.26220004f,0.08290001f,0.34760002f,-0.36210001f,-0.14619998f,0.61220001f,0.43140001f,-0.07650001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.39049999f,1.36479999f,0.96269999f,-0.25770001f,1.24870000f,0.68349997f,0.12069998f,1.70599999f,-0.50820001f,0.05250005f,-1.40160001f,-1.80410004f,-1.74230004f,-0.99899999f,-0.49919997f,-0.55059998f,1.45690005f,0.46959999f,-1.36489999f,0.46499999f,-0.21080000f,0.62389999f,0.07109999f,0.60179998f,-0.82159999f,-0.26460000f,0.16159999f,-0.60460001f,1.67030004f,-0.72739998f,0.55640000f,-0.62780001f,-0.94959999f,-0.20289997f,0.24029998f,-1.57749998f,0.66900003f,0.11279997f,-0.09460001f,-1.91640001f,0.10429999f,-1.27960006f,-1.00080004f,0.63130000f,0.06439999f,-0.05690002f,-0.36540003f,1.34090007f,1.91560008f,-0.84510001f,0.62050001f,0.13840001f,0.35010004f,0.61299999f,-1.15370001f,-0.14190000f,-0.28440000f,1.41910004f,-1.27140005f,-0.19759999f,0.67170003f,-1.16130002f,-0.36179999f,0.92860002f,2.28250008f,-0.94870005f,-0.25250000f,0.18709999f,0.47240001f,-1.27450002f,0.42210000f,0.90540001f,-0.02980001f,-1.31379999f,0.46340002f,0.20940003f,-0.38549999f,-0.19799997f,-1.48990003f,0.00260002f,-0.32419999f,-0.52760004f,0.22209998f,-0.06109998f,0.33900002f,1.09220004f,-1.32940004f,-1.34850003f,0.57839999f,-0.07269996f,-0.10900002f,1.25080001f,-1.61019998f,0.65769996f,0.74540000f,0.39380003f,-0.45200000f,1.37490002f,-1.95830002f,-1.18489999f,0.51329996f,-0.75759998f,-1.14690003f,-2.59050002f,0.17640003f,0.90680005f,0.30340002f,0.38670000f,-0.37120002f,0.13180000f,0.49480002f,0.51050006f,0.55239999f,0.00489998f,-0.34549996f,-1.58539998f,1.27020005f,-0.11550000f,-0.07439998f,-0.51480001f,1.19440002f,-0.10189999f,-0.82010002f,-0.60479999f,-0.09249999f,0.19610001f,-1.11009996f,-0.14769999f,-0.22609999f,-0.53059997f,0.29109995f,1.42560001f,-0.36490001f,0.24310002f,0.09269999f,-0.59249999f,0.09800001f,0.14219996f,-0.80720003f,0.91130003f,-0.26000000f,-0.79080002f,-0.24240002f,2.03630004f,0.08380002f,-0.08039995f,0.59610002f,-1.07310001f,-0.37990001f,0.01460003f,0.41470001f,-1.17499998f,-0.18729998f,-0.29850000f,-1.00870005f,-0.92510002f,0.23710001f,-0.20390002f,0.35279999f,0.40970003f,0.08460002f,-1.65810007f,-0.33949998f,0.51510002f,-0.56650003f,2.69150006f,-0.13169998f,0.53790007f,-0.02599998f,1.58270000f,-0.43800000f,1.11740003f,-0.42149999f,0.20660000f,-0.36610002f,-0.78230000f,-0.18500000f,1.57430000f,-0.29780002f,0.19369998f,1.05230000f,-0.97089999f,1.05560007f,0.11629990f,1.41219999f,-1.21579998f,0.31550003f,0.27099997f,0.86350006f,1.62919999f,0.12080003f,0.30509997f,0.42660002f,0.21580000f,0.09610001f,-0.09040001f,-1.12820006f,-1.82720003f,0.79000003f,-0.28529998f,-0.63260002f,0.07620000f,0.23230000f,0.24220000f,0.93950000f,1.30949998f,-0.69890006f,0.44279999f,1.19190002f,0.28519996f,0.22089998f,-0.70300004f,-0.97770000f,-1.99620001f,1.18170004f,0.28750002f,0.59580000f,-0.00280003f,1.35070003f,0.38309999f,-0.06869998f,-0.30440000f,0.08740000f,0.78009996f,-0.48919999f,0.40840000f,0.24669999f,1.01190001f,0.98449997f,0.72149997f,0.27369999f,0.07760000f,-0.23260001f,-0.01280002f,-0.62930000f,0.72710004f,-0.07020003f,0.34489999f,-0.48630002f,0.38999999f,-0.01240003f,1.08860000f,0.63569998f,-0.03890000f,0.96709999f,0.59430005f,0.73560000f,0.21370002f,-0.23419999f,0.24830000f,-0.03689999f,-0.29910004f,-0.28390000f,0.85150002f,0.87650001f,1.06909999f,0.55879992f,0.46450000f,0.73249997f,-1.18269999f,1.54880005f,0.95109999f,0.08110000f,0.35069997f,-0.15730005f,0.94379999f,-0.18180003f,-0.52439998f,1.04300004f,1.59750002f,0.38009998f,-1.40760004f,0.27580001f,-0.13070002f,0.93389998f,0.43689996f,0.11129996f,-1.59659998f,-0.66700000f,0.60599999f,0.94099998f,0.22469998f,1.45470001f,0.46789995f,0.77259998f,-1.78739998f,-0.97640000f,0.96779999f,0.38539998f,-0.35870002f,0.56770002f,0.13440000f,-1.08569998f,1.09370003f,0.17249995f,0.38269996f,0.37880006f,1.55970000f,-0.94490001f,-0.36390001f,0.36429997f,-1.26860002f,-0.30030002f,-0.19180002f,0.90079998f,-0.55319999f,0.05690000f,0.25160001f,0.07090000f,0.58120005f,-0.46590000f,1.07260001f,1.07570001f,0.51430000f,-1.04540004f,-0.87770002f,0.06540001f,-0.76730005f,0.95030000f,0.25389996f,-0.30509994f,-0.22959999f,-0.86540000f,0.16960001f,0.02069999f,0.04339999f,-0.84300000f,-0.00970000f,-1.28939993f,-1.38509996f,0.68939998f,1.00069998f,0.17580000f,0.32620000f,0.27440003f,-0.17079998f,-0.19980004f,0.34069998f,0.74180000f,-0.74239999f,-0.66200002f,0.01460002f,-0.04609999f,-1.18460001f,-0.18779999f,-0.55020005f,-0.98600001f,1.39899997f,0.16449999f,-0.67319998f,0.63409998f,0.54789999f,0.92020000f,-1.18519997f,-0.53590004f,1.64180002f,-0.11399996f,-0.08099999f,0.42170003f,0.47720001f,-0.78950000f,-0.00970000f,-0.77790001f,-0.50239998f,0.68750001f,-0.38200002f,0.16439999f,0.68029999f,0.99730001f,-0.38170001f,-0.47310001f,0.79700001f,0.32580001f,-1.54110004f,0.56100000f,-0.71400000f,-0.22110000f,0.01800001f,0.11480002f,0.21910000f,-0.74860000f,0.09760002f,-0.95180000f,-0.41319999f,0.72069999f,-0.31620001f,-0.03880002f,-0.41579996f,0.01109999f,1.08569999f,-0.34880000f,0.33310000f,-0.51269998f,0.26159998f,-0.79130004f,0.21549999f,-0.20470002f,-0.76859999f,-0.66939999f,0.11519999f,-0.52000001f,0.64029999f,1.04650003f,0.10620001f,1.37780007f,0.17830001f,-0.03150001f,-0.07520000f,0.18180001f,-0.31089997f,-0.84349997f,0.28519996f,1.40389996f,-0.82490003f,0.55100001f,-0.97059998f,-0.15080001f,0.59719998f,0.70719991f,0.93970004f,0.06659999f,0.35730002f,-1.78299998f,0.89800003f,-0.79109998f,0.01310000f,0.43419998f,-0.91189999f,-0.96310002f,0.26660000f,0.94130001f,-1.03839999f,0.51140003f,0.21400001f,-1.17800003f,0.89980004f,1.04390005f,-0.28040002f,-1.26950005f,-0.13230000f,0.37910002f,-0.67670004f,0.65740000f,-0.20139999f,-0.25060003f,0.81920004f,1.35940005f,-0.01119999f,-0.37020002f,0.45450002f,-0.69900005f,0.38670007f,0.45849999f,-0.81280005f,0.80850001f,-0.64590001f,0.76250003f,-0.68370004f,1.06440003f,-0.13179997f,1.33930001f,-1.23090004f,0.40440005f,-0.44619998f,1.64640003f,-1.35549999f,1.38720003f,-0.36580002f,-0.95649999f,-1.28260000f,-0.35370002f,1.62659999f,-1.49520002f,-0.09270000f,0.82830002f,0.99739998f,0.04040000f,0.61130003f,0.14489998f,-0.34280002f,0.29080001f,-0.87120000f,-0.38300002f,0.47660001f,-0.82879999f,-0.09620003f,-0.09220002f,-0.70749998f,-0.74960005f,1.36590001f,-0.48100001f,-0.23380000f,0.64150000f,0.71230001f,0.56649998f,0.41060003f,0.34250001f,-0.48509998f,-0.21039998f,1.57910000f,-0.54139998f,0.71269998f,-0.55330000f,1.49070004f,-0.01830001f,0.81650002f,0.43419998f,-1.00780000f,0.61920001f,-0.63579998f,-1.14960003f,1.82169999f,0.74059999f,-0.99249999f,-1.57409994f,0.21790008f,-0.16380001f,1.18430001f,-0.53630003f,-1.17989999f,0.59299996f,1.11550005f,0.07849998f,1.96899998f,-0.69630001f,-0.57049998f,-0.84249995f,-0.01300000f,-0.16409998f,0.71399999f,-0.48270004f,0.52650003f,1.27370006f,-0.36600002f,-1.63420005f,1.15060002f,-0.56370002f,-0.49020000f,1.58000001f,-1.21260001f,-0.33019997f,-0.47590001f,1.06349999f,-0.79179999f,-0.25850000f,0.35130000f,-0.09880002f,0.36250003f,-0.14130000f,-0.78950005f,-0.88850003f,0.52310002f,0.68600002f,0.48160001f,0.63470003f,-0.11070002f,-0.43300000f,0.57529999f,-0.40850004f,-0.07770001f,-0.64880000f,-0.13800002f,0.19780002f,0.75360000f,-0.91500003f,-0.38230000f,0.26309998f,0.61160000f,-1.46520003f,0.66720001f,0.59169998f,-0.63909996f,0.85960003f,-0.37649995f,0.57199998f,-0.76479999f,0.78819999f,-1.00789994f,-0.27280000f,-0.75920002f,-0.38959998f,0.87560002f,-0.68010000f,0.40009999f,-0.31920000f,-0.95760002f,0.39360002f,0.96960002f,0.11490001f,-0.39070005f,0.25470004f,1.03560002f,-0.83510002f,-0.08899999f,-0.07400000f,0.28149999f,-0.73549999f,0.90769999f,-0.84380003f,0.38960000f,-0.34660002f,-0.62930002f,1.04040005f,-0.61280002f,1.07170001f,-1.23870002f,0.67600003f,-0.45379995f,-0.43960003f,-0.25809999f,-0.02670000f,-0.34910002f,0.62000001f,-0.69270001f,0.96279997f,-0.47450003f,1.05079999f,-0.18910001f,1.03839998f,0.77800000f,-0.70380002f,1.37560000f,-0.91509998f,-0.80590003f,-1.30779993f,0.45520003f,0.28410001f,-0.15830000f,-0.05380002f,-0.12829999f,0.74870000f,-0.31919999f,-1.30820000f,0.48850001f,0.43300000f,-0.66759999f,0.28170000f,-0.57770001f,0.83329999f,-0.49000000f,-0.74760001f,0.25530001f,1.30420001f,-0.40579999f,-0.84670000f,0.19919998f,-0.17679999f,-0.38560000f,-1.32770003f,0.37160004f,0.06129998f,-1.15640001f,1.11090000f,-0.90280006f,1.16030004f,-0.05300003f,-1.24019999f,0.94970003f,-1.02480002f,-0.81020002f,-0.30249999f,-0.38760002f,0.77690003f,0.89160000f,-0.34589999f,0.77139995f,-0.74479998f,-0.45120001f,-0.98189998f,-0.07230001f,-0.38740005f,2.27249996f,0.14459998f,0.77220002f,0.40350001f,-1.08499999f,-0.91189999f,-0.48110000f,-0.41310000f,1.45529996f,0.05390000f,-0.46750001f,0.13090001f,-0.46880001f,-0.49380001f,0.66560003f,-0.34080001f,-0.74120001f,-0.43680001f,0.28210001f,-0.15220000f,0.64519998f,0.31780002f,0.35020003f,0.01259999f,-0.69760000f,0.91820000f,-0.29450002f,0.27970002f,0.13900000f,-0.16689999f,0.52529999f,-1.26070001f,1.64910001f,-0.70690000f,1.27419998f,0.34400001f,-0.41310001f,0.43360003f,-0.70049999f,0.05390000f,-1.49850004f,0.50340002f,0.02620000f,0.15300001f,-0.50410001f,-0.49669998f,0.96170002f,-1.10930001f,-1.39349994f,0.56110001f,0.11499999f,1.60269991f,1.22030000f,-0.26890001f,-0.40409998f,0.03460001f,0.36889999f,-0.23360004f,-0.76799999f,-0.05659999f,0.17500000f,-0.18340003f,0.01460002f,0.36600000f,-0.25310001f,0.12950002f,0.58030000f,-0.97720001f,0.65740001f,0.71390000f,-0.88400000f,-0.72719999f,-0.05540000f,1.63050003f,-0.54149999f,-1.20540003f,1.08070000f,-0.39850001f,0.40750003f,-0.39220001f,0.07100000f,-0.05540000f,0.51850001f,-0.74130001f,0.13460003f,0.96500001f,-0.77470002f,0.40000000f,-0.20139999f,0.61929999f,-0.79230005f,-0.49900001f,0.47130001f,-0.20550000f,0.08700002f,-0.23920000f,-1.52009996f,1.31050001f,-0.06510003f,0.55000001f,-0.53990000f,-1.64899995f,-0.34049997f,0.57239999f,0.87689995f,-0.65109997f,-0.33420000f,0.80769992f,1.18559998f,-1.26020002f,0.26870002f,0.11280001f,0.28660003f,-2.78950003f,-1.10489995f,0.12969998f,-0.33520002f,-0.59779999f,0.09800003f,-1.44980001f,-2.23860002f,-1.18940000f,-0.87439996f,0.19620003f,0.75810004f,2.08430002f,0.67120000f,0.04399996f,-0.62460000f,1.36499999f,-0.60370001f,-0.44479995f,-0.69879997f,0.19640004f,-1.37189997f,0.48719998f,-0.74840003f,1.87130001f,-0.06939999f,0.28339998f,-0.35419998f,-1.35289999f,-0.05799998f,-0.24800000f,1.12880000f,-0.91350000f,1.11890001f,0.29750006f,-1.06440004f,-0.20430002f,-0.46829995f,1.38130004f,-0.84850000f,0.08550002f,-0.06630002f,0.04640001f,0.37870002f,0.87540002f,1.62280002f,-0.39080000f,0.31140004f,0.38820002f,0.09600002f,0.23470005f,-1.28329999f,-0.42489999f,2.00990006f,0.98470005f,-0.88260001f,-0.73829995f,-0.11660001f,0.65970004f,1.63280003f,1.26760001f,-0.32130002f,-0.36920003f,-0.47490002f,0.80860000f,0.18619999f,0.17760000f,0.64009996f,-0.29409999f,-0.93749999f,0.15590004f,-0.59660003f,0.28039999f,0.01280004f,-0.66899998f,-1.14309999f,-0.40339997f,-0.30750003f,0.44889998f,1.50049999f,0.44739999f,-0.40460002f,0.74040000f,1.05720004f,0.03959999f,1.31440003f,1.32790000f,0.72080001f,-0.13370001f,1.01140001f,1.02560002f,0.98140000f,-1.18889997f,0.84220001f,0.57039996f,0.86099999f,0.08560009f,1.46890003f,-1.31160003f,0.37060001f,0.49059998f,0.93010000f,-1.02650006f,1.08939999f,-0.80640006f,1.24980001f,-0.31390003f,-0.12480000f,-1.95160001f,1.27580006f,1.55649999f,0.04560000f,-0.15490001f,1.08570003f,0.35739997f,-0.17919999f,1.06990004f,-0.82480002f,0.07880000f,0.14679997f,0.18760003f,-0.56420004f,-0.71370001f,-0.13950003f,1.44239999f,0.06979997f,-2.27029994f,-0.62819996f,0.65069997f,0.44070000f,-0.70340000f,0.80469996f,-0.76810001f,0.46320003f,0.64930003f,-1.59340003f,-0.25270002f,-0.40899999f,-1.07690000f,0.30729996f,-0.55790001f,-0.40129995f,0.83619997f,-0.74710000f,-1.01429998f,-0.31620001f,-0.48929998f,-0.57880002f,0.04349999f,0.16050001f,0.89580001f,-0.27910001f,-1.53120002f,-0.09159995f,-1.20309998f,0.49110000f,-0.06690002f,2.29879999f,0.06159994f,-0.09999996f,-1.33739997f,0.88970000f,-1.02030001f,0.69799999f,0.97380001f,2.35790004f,0.45049999f,-0.49670000f,-0.03440000f,0.45329998f,0.57620001f,0.18530003f,-0.36969998f,-0.61880000f,0.36120001f,0.16539995f,1.78459995f,0.14319999f,0.22250002f,0.27999999f,0.65649999f,-2.00200000f,-0.07480000f,0.24079998f,0.69749999f,0.28840000f,0.47280004f,0.44510001f,0.53840001f,-0.65509996f,0.52269999f,-0.01860000f,-0.04710003f,-0.19250003f,0.35240000f,-0.47120004f,0.61070000f,-0.39530000f,-1.71580000f,0.26489999f,-0.18600002f,-0.67050000f,0.48420002f,0.60310001f,-0.78700001f,-1.45460001f,-1.38710003f,1.50650002f,1.36990003f,-0.87470009f,0.31019999f,-0.17780007f,-0.75530000f,-0.40189998f,0.17129998f,-0.28180001f,0.50690004f,-0.60019998f,0.15320000f,-0.49020000f,0.28960000f,0.00810000f,1.98559997f,0.52820001f,-1.70619998f,-0.84849999f,1.00960000f,1.18400003f,0.54929997f,0.52579995f,0.32990000f,-0.27300002f,-0.82500000f,0.43860000f,0.07390002f,-0.72329998f,-0.99859998f,0.68799996f,-1.54880001f,1.17950000f,1.35650003f,-0.98269998f,0.66559998f,-0.38680003f,-1.52870004f,0.73920001f,-0.27080001f,-0.36220000f,-0.72620001f,1.55500001f,0.37570004f,-1.13910000f,-0.28550000f,-0.22880000f,-0.51910006f,1.14670002f,2.44300005f,0.16140001f,-0.54740005f,-1.12910004f,-1.22170002f,-0.23020000f,0.36830000f,-0.91650002f,-0.34129999f,0.02520002f,0.07310002f,-2.09000000f,-0.42889998f,1.16900001f,0.51499998f,0.07460003f,-0.25029997f,-1.24630007f,0.00809997f,0.64170003f,0.58349998f,0.50580003f,-0.83400000f,0.16760002f,-0.88130001f,0.03670001f,-0.51749999f,1.44799996f,-0.14289999f,-0.76579998f,-0.08159997f,-1.02789999f,-0.31810006f,-1.91820001f,0.79120000f,0.24610000f,0.51479999f,0.11499999f,0.08850002f,0.78360000f,0.10460001f,0.87190000f,-0.81300000f,0.42559999f,-0.44320004f,-0.63449999f,0.36440000f,0.13600000f,-0.19119999f,-1.12730005f,1.03060004f,1.29700001f,-0.65030000f,-0.37619999f,-0.08730002f,0.93699999f,0.56609998f,1.06660001f,0.43019997f,-0.78890003f,-1.35080001f,0.18150006f,0.30610001f,-0.24840001f,-0.85350004f,0.69880000f,0.02770000f,-0.09369997f,-0.58780001f,-0.72780002f,0.71350000f,0.02669999f,-0.73290000f,0.51049999f,-0.78649999f,0.02279999f,0.86149999f,0.56769998f,-0.93369999f,-1.50630000f,0.74070003f,-0.28460001f,0.52630003f,-0.98000004f,-0.93420003f,0.72589997f,-0.09740002f,-0.05459995f,-0.05980002f,-0.10770003f,-0.80430001f,-0.17370000f,-0.04540000f,-0.20130001f,0.33479999f,0.48250003f,0.71379999f,-0.83320000f,0.88150000f,-0.84110002f,-1.51320002f,0.92370004f,0.89659998f,1.48410000f,-0.56780005f,0.24509999f,-0.69830005f,-0.51959998f,0.50460005f,-0.36730001f,-0.23959999f,-0.12350003f,0.52850000f,0.96030000f,0.49660000f,0.78860004f,0.00139999f,0.22350002f,-0.00009999f,-0.88829999f,0.03170001f,0.75529997f,1.52899996f,0.53319997f,0.36259999f,-0.77209998f,-1.21220003f,0.10550005f,-0.49189999f,-0.33879998f,0.41880001f,-0.76790005f,1.08190001f,-0.64270002f,0.54830003f,1.31359998f,0.01480001f,0.12529999f,0.13950001f,-0.10410000f,0.03820000f,0.05739999f,1.21790000f,-0.37879998f,1.41820003f,-0.70000001f,-0.56810003f,0.28600001f,-0.68880003f,0.13520000f,0.31939999f,-0.60000000f,-0.07369999f,1.77429997f,-0.51180002f,-0.43129996f,0.00160000f,-0.23850002f,0.24829995f,1.26949997f,0.24060004f,0.11250000f,-1.91429991f,-0.84710001f,-0.34879993f,0.40079997f,0.76159999f,0.11010000f,-1.86940004f,0.86019999f,1.27940005f,-0.92870002f,-0.87690001f,-0.35500000f,-0.32560002f,-0.03510001f,1.16450002f,-0.62480002f,0.44740001f,-0.41320002f,-0.33639999f,0.59009999f,0.00939998f,-0.25179999f,-0.94439999f,1.06720004f,0.33320003f,-0.43220003f,0.47870001f,-0.12179999f,0.35029998f,0.12800001f,1.42230004f,-0.97750005f,0.54640003f,-1.18300006f,-0.19499999f,0.13269996f,0.01270003f,0.00300000f,-0.97600002f,0.42179999f,-0.64919998f,-1.44169996f,0.58740003f,-0.03319997f,0.53049999f,-0.97970001f,0.78020001f,-0.40279999f,-0.80819999f,0.54060001f,-0.61540003f,1.55239996f,-1.07700004f,1.67570003f,-0.24260002f,-0.44119997f,-0.34480000f,-0.00589999f,-0.40040004f,-0.70780003f,0.35930001f,0.33410001f,-0.46430002f,-2.07129999f,0.61709999f,0.98199998f,-1.09939999f,-0.32919996f,-0.30650004f,-0.51930006f,-0.77049997f,0.90600004f,-0.97950004f,0.75700004f,-1.38080006f,1.07440004f,-0.60120000f,1.04830006f,-1.22940003f,0.45640002f,0.47040002f,1.70080002f,-1.12029999f,0.79500000f,-0.64080003f,1.68729999f,-0.32989998f,0.78580005f,-0.56010004f,0.39170001f,0.09599997f,-0.17279998f,2.06499992f,-1.56239998f,0.92529998f,-0.36609999f,1.01329993f,-0.23989999f,0.30210002f,-0.00859999f,-0.83160000f,-0.36439996f,1.67269994f,-0.09290003f,-0.53460000f,1.07560004f,0.14909999f,-0.02050000f,0.12040005f,-0.32000003f,-0.13780003f,0.39150003f,1.13129998f,-0.55099998f,-0.27509998f,-0.66519999f,0.34359998f,-0.00639999f,-0.24820004f,-0.06179998f,1.42470001f,-0.97459999f,-0.22299999f,-0.34220003f,0.69790003f,0.54809999f,0.00809998f,1.14300004f,-0.33030001f,-0.16760000f,-0.12069999f,0.26280000f,-0.70670002f,0.93430001f,-0.60150002f,1.09510004f,-0.36019998f,-0.68200001f,-0.36759997f,-0.50430003f,0.40330001f,-0.47180001f,2.15470002f,-0.35889999f,0.58779999f,-1.51919994f,-0.69649996f,0.07870001f,1.13189997f,-0.29779999f,1.01789999f,-1.08509996f,0.82680003f,-1.33329996f,-0.42479998f,-0.85649998f,0.07430001f,0.95239997f,-0.20660000f,0.07260001f,0.05579998f,-0.91650002f,0.83519998f,0.47379999f,-0.13699998f,0.87200004f,-0.42090003f,-0.48290001f,0.53160004f,-0.70690005f,0.45530004f,0.51620002f,-0.75790000f,0.08890000f,0.32810000f,0.08030001f,-0.77970005f,0.14080001f,1.04860000f,-0.32760000f,-0.32729999f,-0.35789997f,-0.50220004f,-0.07790003f,0.92330005f,-1.68650007f,0.84130005f,0.30280002f,0.00460000f,-0.32560001f,0.28920001f,0.20570000f,0.34140001f,-0.53020005f,1.53029998f,0.56699998f,0.55069999f,-1.55489999f,-1.32639994f,0.53460003f,2.34179994f,0.22189999f,-0.85280001f,-0.43090000f,-1.02479999f,1.67170002f,-0.96839999f,0.03520000f,-0.32359999f,0.23760000f,0.67860000f,0.49310002f,-0.33070000f,-0.32380001f,-0.16369999f,-0.31910001f,0.38420001f,0.74960003f,-0.69480002f,0.81250003f,0.93410002f,0.14109999f,-2.09620001f,1.11299997f,0.86090000f,-0.55400000f,-0.86249999f,0.65910001f,-1.34619997f,-0.84380001f,0.08499998f,-0.34060001f,0.53680000f,0.65620002f,-0.89380004f,0.35670004f,-0.23840000f,-0.44940004f,-0.47209999f,0.89370002f,0.52060000f,-0.11580000f,0.04229999f,0.14299998f,-0.81509999f,-0.48529991f,-1.80539998f,-0.29130003f,1.47190000f,1.07189997f,0.41839998f,-0.26190000f,-0.83750001f,-0.56949999f,0.06579995f,1.00969997f,-0.78879999f,-0.27629996f,0.80070000f,-0.50229999f,0.26010000f,0.99620002f,0.41190001f,-0.62160001f,0.50290003f,-0.21889999f,0.06899999f,0.11699999f,-0.58039998f,0.23859998f,-0.54519999f,-0.66519999f,0.00179999f,0.33570000f,0.33020001f,-0.48860001f,0.34050000f,-0.75659999f,0.95820000f,-2.10700002f,0.06820004f,-0.52620003f,-0.19340002f,1.11850001f,-0.43360000f,0.06260000f,-0.86910000f,0.65790001f,0.31840001f,0.23149999f,0.01160001f,-0.06470000f,-0.10830001f,0.82930004f,0.13420000f,0.34950002f,-0.96869993f,-1.15730000f,-1.02559999f,-0.34350000f,1.12699997f,-0.29139999f,-0.17219998f,-0.56549999f,0.42969996f,1.53830001f,0.19339996f,-0.32729999f,-1.09689999f,-0.17880000f,0.86970000f,0.11670000f,0.66590003f,-0.15720001f,0.68160000f,-0.30479998f,0.58259999f,-0.43229999f,-0.32959999f,0.52510001f,-0.56620002f,0.42900004f,-0.25930000f,-0.06690000f,0.02189998f,-0.56730000f,0.66050003f,-1.08370003f,0.46980001f,0.43020000f,0.10250001f,-0.36500000f,-0.35660002f,-0.09650002f,-0.81310001f,1.13880003f,-1.63170004f,0.36310005f,0.06879998f,-0.27499999f,1.49360002f,-0.46139999f,1.08130003f,-0.65700003f,-0.08130003f,-0.82160002f,1.09630002f,-0.15359999f,-1.28219996f,-0.14199997f,0.68279994f,1.32829995f,0.67840002f,-1.16799996f,-0.28240000f,-1.75719998f,0.07650003f,0.39650000f,-0.64919999f,0.37829999f,0.77200001f,0.24459996f,-0.10620000f,-0.13200004f,2.00660003f,0.93319998f,0.02240002f,2.36690003f,0.43319997f,0.08749992f,-1.79320006f,-1.03690000f,-1.09780000f,0.63209999f,-0.81080001f,-0.66150000f,-0.61510003f,0.62389998f,0.50650001f,0.45780000f,-0.57559998f,0.26450002f,-0.04670006f,0.95339998f,-1.52670000f,-0.55020002f,0.77620006f,0.30779998f,0.78540001f,-0.97670001f,-0.20039995f,-1.53220000f,1.56219998f,0.17200000f,-0.59260002f,0.70009998f,1.25209999f,-1.54530001f,-0.21570007f,1.39050000f,-1.22200004f,1.48990000f,0.26780002f,-0.42359996f,0.77650001f,-0.98030002f,-0.92470003f,-0.87980000f,0.01480001f,0.31250000f,0.30520002f,-0.59470001f,0.81870001f,-0.57420001f,-0.86880005f,-0.15320001f,-0.34790003f,-0.14330000f,0.55209999f,-0.22820001f,0.11439998f,-0.43600002f,-1.50430002f,1.27020003f,-0.08519998f,0.25790004f,0.68970005f,0.65739999f,0.14870000f,0.15670002f,-0.57539999f,0.01290007f,-0.31239998f,0.89420002f,-0.67340001f,0.64809993f,0.84209998f,-0.04650000f,0.80879998f,0.06140003f,0.11730003f,-0.58010004f,0.25050000f,-0.79209997f,-0.78629998f,-0.16690002f,0.67480001f,-0.22410004f,0.68520001f,-0.43750001f,-0.53180001f,-0.84100002f,-0.54620001f,-0.05250000f,-0.74450000f,1.03390001f,-0.65379997f,0.26239999f,0.98569998f,-0.08419997f,-0.55539998f,0.77670003f,-0.89390004f,-0.85800001f,-0.10579999f,-1.07730001f,-2.27350004f,-1.23900001f,-0.00129997f,-0.35289996f,0.68640003f,1.51180006f,1.09379997f,-0.95490002f,-1.01400004f,0.89600004f,0.59000002f,-0.74970002f,-0.95810000f,-0.50909999f,1.29600004f,-0.54519999f,1.90090000f,-0.42530002f,0.38010002f,-0.32699999f,-0.44880000f,-0.10799997f,-2.00449997f,-0.56030000f,1.03250003f,0.37929998f,-0.61280001f,-0.78089998f,0.98369996f,1.25400001f,-0.83969999f,-0.47289998f,-0.37790003f,1.46569999f,-0.42670001f,0.28620000f,0.73149998f,0.10120000f,-0.03550002f,0.81610002f,-0.85110001f,0.66629999f,-0.10169998f,1.36920003f,-0.52670001f,0.31810001f,-0.13750000f,-0.56989999f,0.20260000f,-0.18670000f,0.07189999f,-0.07170003f,0.96669997f,0.60730001f,0.20509997f,0.30880000f,-0.24330003f,0.11760000f,1.00360000f,-0.87150001f,-0.69110003f,-1.14470007f,-0.18100000f,0.84080002f,0.35289999f,0.91760002f,-0.18439999f,0.63470001f,-0.42760001f,-0.55110003f,0.76659998f,-0.02960001f,0.42049999f,0.66719998f,0.31399998f,-0.15620004f,-0.25000003f,1.63430004f,-0.21440002f,0.07789997f,0.77830000f,-0.82310001f,0.58610000f,0.10189998f,-0.35999998f,0.06570001f,-0.83559999f,0.46009998f,-1.54490002f,-0.91370000f,0.17579998f,-1.88240002f,1.23269998f,-0.24819997f,1.66329999f,1.37700001f,-0.92109998f,0.66069998f,-0.82910000f,-0.24250001f,-0.14279997f,0.55350004f,2.43310002f,-0.66700006f,-0.52829998f,-0.72969996f,-0.49160002f,-1.16889999f,0.24199999f,0.74599996f,-0.69130003f,1.64680002f,-1.67860001f,-0.63790000f,-0.03390002f,-0.27689999f,0.92250001f,0.57180001f,-1.45710001f,0.44360003f,0.60759997f,1.44769999f,-0.54319998f,-1.05880001f,0.50910006f,-1.57540001f,0.36710000f,-0.15999999f,0.21459996f,-0.39850004f,0.21090003f,0.41660000f,-0.62429999f,-0.04359999f,0.63090001f,0.25089999f,0.03320000f,-1.48360002f,0.35690002f,0.97799996f,-1.31390003f,1.53720003f,0.50880003f,-0.36740002f,0.74719999f,-0.74680000f,-0.88669998f,-0.17130006f,-2.16050004f,0.50199999f,-0.18720000f,-0.77730002f,-0.53759997f,0.24170004f,0.52990001f,0.69320004f,-1.39950006f,-0.41400000f,1.81120002f,0.84659999f,0.10779995f,-0.09549997f,-1.53970001f,-0.90590000f,-1.61170006f,0.99540005f,0.40600000f,0.01580004f,-0.36479999f,0.41629999f,-0.27599998f,-1.33360002f,0.21970003f,1.71740001f,-0.13019999f,-0.88720003f,0.21229998f,0.18029996f,1.16750000f,1.01829998f,0.25989999f,0.37800004f,-0.61279997f,-0.14420004f,0.09200000f,-0.52120003f,0.31870002f,-0.97880002f,-0.69040000f,-1.11040000f,-0.34590001f,-0.18999999f,1.30840002f,0.66520002f,-1.61990002f,0.44120000f,0.10589998f,-0.17070002f,-0.57359998f,0.25130002f,-0.82829999f,0.33200000f,-0.26909999f,-1.43640002f,-0.85160000f,-0.58769998f,1.36650002f,0.41390001f,-0.65640000f,0.75110004f,-1.80310001f,-0.63450001f,-0.50250000f,-0.61889996f,-0.43529995f,-0.22729996f,1.22080000f,0.16210000f,0.90020001f,0.01320000f,1.38440001f,-0.07370001f,-0.62699999f,-0.15859998f,-0.37510001f,-0.49340001f,0.51960003f,-1.27310000f,-0.11439995f,-0.13269994f,0.43449998f,-0.73140000f,-0.51540000f,0.36220002f,-0.74750000f,0.56790001f,-0.96260002f,0.79760002f,1.38190001f,-0.57650002f,0.63830001f,-0.03809998f,0.61570000f,-0.76870003f,-0.89039999f,1.26789998f,0.44170002f,0.13080001f,0.13469999f,0.09489999f,-0.17810001f,0.50980001f,0.78150001f,1.21069999f,2.04220000f,-0.67209994f,0.67510005f,-0.09100000f,-0.16209998f,-1.89650000f,-0.37949997f,0.16489997f,1.12150003f,-1.62500006f,-0.84660004f,-1.30980003f,0.85570002f,1.16200002f,0.38199999f,-0.89980001f,0.48460002f,-0.83120007f,0.37659998f,-0.78539998f,-0.78969997f,0.83370001f,-0.37830000f,-0.42179995f,-1.19109997f,0.26000000f,-1.12260005f,1.31170003f,0.09419998f,-1.20579998f,-0.68549998f,0.57429998f,0.46849999f,-0.06410000f,-0.12230001f,-0.91529999f,-0.23950001f,-0.75760002f,-1.30850002f,0.40550000f,-0.68679999f,0.73099998f,0.55810003f,-0.54120005f,-0.09419998f,-0.19230000f,0.13539999f,0.77250001f,-0.08190001f,-0.82270000f,-0.05580000f,-0.54560000f,0.12690003f,-0.63000001f,0.38109998f,-1.83839997f,0.22789998f,0.71220001f,1.65369994f,0.40259997f,0.00089995f,-1.21370000f,-0.20309998f,-0.75730002f,1.62099995f,0.05370000f,-0.47299998f,-0.10690000f,0.92420004f,-0.34650000f,0.18229999f,0.94470002f,-0.49930000f,0.20319999f,-0.77090003f,-0.29269998f,0.63780001f,-0.25649999f,0.03330001f,-0.26540000f,-0.07390003f,-0.09960000f,0.29930003f,-0.73330004f,0.96849998f,-0.63629999f,0.40379994f,0.17380001f,-0.49810001f,0.12899998f,-0.44740001f,0.47030003f,-0.07750000f,0.58470002f,0.09430000f,0.43480001f,-0.66730004f,-0.33279999f,1.02900005f,-0.66930004f,0.62380000f,-0.80199999f,1.38710001f,1.12079993f,-1.42540005f,1.03849998f,-1.07100001f,0.57860000f,0.89260001f,-1.08959998f,1.09420002f,-0.56819998f,0.92230000f,-1.40959999f,-0.92939999f,-0.46159998f,0.64110002f,0.84699996f,-0.03249999f,-1.53190003f,1.27140002f,-0.38320000f,0.41830002f,-0.18349999f,-0.19530000f,0.63809999f,-0.92299998f,-0.15990001f,-0.07770001f,-0.03300001f,0.24049999f,-0.78970000f,-0.30260004f,0.81060001f,-0.17649999f,-0.68480005f,0.99280005f,0.27549996f,1.11030004f,-0.13430001f,0.51460002f,0.37819997f,-1.12200000f,0.80960000f,-0.20200001f,0.77250003f,-0.17770000f,0.24450004f,0.35069999f,0.47250000f,0.32880001f,-0.50580001f,0.16660000f,0.18529998f,0.24289995f,0.84300000f,-1.36389995f,0.49570003f,-1.39539996f,-0.32759998f,-0.61030002f,1.18879997f,1.38789995f,-1.57519999f,-0.38589997f,1.50450002f,0.31129998f,0.47030002f,-1.23769997f,0.05510000f,-0.38940003f,0.64880002f,0.37480001f,-0.62710000f,0.65060001f,-0.24520000f,0.58250000f,0.35820001f,-0.03149998f,0.49130000f,-0.94110004f,1.00520002f,0.08989999f,-0.22359999f,0.59960000f,-0.63389999f,-0.62150003f,0.17370003f,0.29860000f,-0.63970001f,-0.16550000f,-0.46930002f,-0.49640001f,0.00719997f,-1.15869999f,-0.14040003f,-1.42750003f,0.58330002f,0.34410003f,0.37500000f,-0.38140000f,-0.14880001f,-0.64320001f,0.08300000f,-1.45979999f,0.51969998f,-0.43699999f,0.47839997f,-0.15880002f,0.93229998f,-0.64610006f,1.12830000f,-0.82080002f,0.01780002f,-0.78130003f,0.87570002f,-0.06720001f,-0.32389998f,0.40790000f,-0.56489998f,0.10250000f,1.28239999f,-1.03469999f,-0.23009997f,-0.44420001f,0.04619998f,0.44170004f,0.79880000f,0.91960002f,0.04489999f,0.56969999f,-1.80120000f,0.56329999f,-0.18960000f,-0.55320000f,0.65690000f,-0.40949999f,0.51069999f,-0.52350001f,-0.12330002f,0.35630000f,-0.48800004f,0.83060005f,-1.03090006f,0.16629999f,-0.17169994f,-0.29130002f,-0.95199999f,-0.15629997f,1.01950000f,-0.15949999f,1.34200001f,-0.04830000f,-0.08920001f,-0.29439995f,-0.29320001f,-0.43500000f,1.67540001f,0.05070000f,1.36820000f,-2.07480000f,-0.58970005f,0.68620002f,-1.29589999f,0.98189999f,-1.62219996f,-0.11630003f,1.18800002f,0.33109998f,0.56670000f,-0.48480000f,0.03750000f,-0.37070000f,0.05649998f,1.15540004f,-0.88640003f,-0.04119999f,0.89999999f,-0.01770005f,-0.12809997f,0.25450004f,-0.65520004f,-0.39480002f,0.53130001f,0.77270001f,0.66840002f,-0.15799999f,0.23380001f,0.34050000f,0.09470001f,1.43220003f,-0.75410004f,-0.67960002f,0.55520000f,-0.16540000f,-0.35689998f,-0.51519998f,-0.50620004f,-0.02650000f,1.19120003f,-0.98830002f,1.07800003f,-1.25609999f,0.34620002f,-0.89620004f,-0.72700001f,-0.19369999f,0.26729997f,0.97520002f,-0.21170002f,-0.44080000f,1.36090000f,-1.99970001f,-0.36430001f,0.70690002f,1.03779996f,1.53159998f,-0.76280001f,0.18070002f,-0.79449994f,-0.48120000f,-0.68860000f,0.11780000f,-0.88790001f,0.91820002f,1.04819999f,-0.13249998f,0.21100001f,0.25170000f,-1.81470002f,0.98000000f,0.04990001f,-0.41790003f,-0.89129998f,0.49509999f,0.35949999f,-0.68530000f,0.67860001f,-0.77190000f,-0.66470004f,1.35530004f,-0.33970003f,0.36420000f,-1.09860002f,-0.13410001f,-0.96280001f,0.15670003f,1.51800004f,-0.24669998f,0.86529996f,0.62590004f,1.06859998f,-0.09940001f,0.71500002f,-0.34620002f,-0.17240000f,0.03640000f,0.45449997f,-0.63159996f,0.39269998f,-0.90669997f,0.10169999f,-0.26730001f,-1.34780000f,-0.26519997f,1.66600006f,0.03969995f,0.02110001f,-0.74600002f,0.44930001f,-0.33759997f,0.66230000f,-0.18149999f,-0.07299999f,-0.89069999f,-0.13520001f,0.35160002f,-0.34610003f,-1.14129998f,0.45409998f,0.91540000f,0.22300000f,-0.97500002f,0.84670001f,-0.84850000f,0.41030000f,0.82600000f,-0.22529999f,-0.51829999f,-0.02390002f,-0.56719998f,-0.22619998f,-0.46520002f,-1.02790003f,1.05369999f,0.03160000f,1.00419999f,-0.32670001f,-0.23610002f,-0.36199999f,0.54510003f,0.28150001f,0.85310003f,-0.56450000f,-0.15290001f,-0.37740002f,0.51230000f,1.14539999f,-0.92139999f,-0.97510001f,-0.08759998f,0.59039995f,0.41349999f,0.43079999f,0.17210000f,0.21139998f,-1.52720000f,0.50079996f,0.50820000f,0.82320000f,-0.95019999f,-0.28359999f,-0.19740000f,1.07479995f,0.10150000f,-1.51010006f,0.97070000f,0.12169997f,-0.39919999f,-0.16430004f,-0.45609998f,-2.10320004f,-1.93710002f,0.49750003f,0.98069999f,-1.57130008f,-2.21720000f,0.26030006f,1.07530004f,-0.26109998f,0.30040000f,0.34039998f,0.48000002f,0.82750000f,-0.09740001f,-0.22130000f,-0.34439995f,-1.08499999f,2.29070001f,-0.40510001f,-1.07409999f,-1.36140002f,2.64449999f,0.86009997f,-1.23160000f,-0.64319996f,-0.14739999f,0.02460003f,0.92820003f,0.41230001f,0.96749999f,-1.39430000f,0.23809998f,-0.61730001f,0.09080001f,0.64750001f,0.15849999f,-0.77339997f,1.00030002f,-0.11429998f,1.18910000f,-0.08980003f,-0.37580001f,0.86630001f,0.13949999f,-0.08840002f,-0.32910003f,-0.74780004f,-0.01309999f,1.15670004f,-0.04129997f,-0.59470000f,-0.59629998f,-0.41840000f,1.67350006f,2.42909999f,0.33809998f,-0.86020001f,0.17669999f,0.19409998f,0.15369998f,-1.01500002f,-0.66160001f,1.00440003f,0.48760001f,-1.08650001f,0.42020001f,-0.19680000f,-0.48280001f,0.84040002f,-0.24570000f,-2.47649997f,0.06890003f,0.42619998f,0.82659998f,-0.34099998f,-0.50180000f,0.73540000f,-0.11720003f,-0.11200001f,-0.85609997f,0.32960000f,-0.77670004f,-1.16230000f,1.43820001f,0.51419998f,-1.04620001f,0.70710000f,-2.13860001f,0.42489997f,0.19719995f,-1.54670005f,1.28490003f,0.35259999f,-0.58709999f,0.31840000f,0.26300000f,-0.33299999f,-0.16239997f,-0.74690000f,1.48339998f,0.15699994f,-0.35419997f,-0.17720001f,1.35010004f,0.19210001f,0.63430005f,-1.57130004f,0.82440000f,0.65039996f,0.16020002f,0.36970000f,0.85280002f,0.36160001f,-0.10100003f,0.63719999f,-0.58659995f,-0.53609996f,0.89939998f,0.76389998f,-0.71020004f,1.31450003f,-1.61449999f,-0.14460001f,0.90440006f,-0.53209996f,0.29699995f,1.08539998f,-0.77810002f,0.65430000f,-0.32570001f,-0.17710000f,0.41480002f,-0.75340004f,-0.81900002f,0.34190001f,0.61920002f,-2.10290002f,-1.48890004f,-0.19040004f,-0.69829996f,-0.85560003f,-0.74540001f,-0.59990004f,-1.76520005f,0.63550001f,-0.50970001f,-0.24260000f,0.49450005f,-0.39100003f,-1.31890002f,1.08039999f,0.30549999f,-0.74380000f,-2.82080005f,0.68190007f,0.50740009f,0.67700004f,-2.09670005f,-0.69260003f,-1.14260005f,0.77790003f,0.03090000f,-0.28260001f,0.26420000f,-0.56850000f,-0.55160002f,0.27010003f,0.04510000f,0.21749997f,0.54249997f,0.75040002f,0.59080004f,-1.28750004f,-1.17699998f,1.49850002f,0.41990000f,-0.08209998f,-0.39350001f,0.20700000f,-0.40840002f,0.03470001f,-0.82620003f,-1.54540004f,1.76180002f,0.02359999f,-0.13079996f,0.54790001f,-0.28210002f,0.22070001f,0.35789998f,-0.54950002f,0.31550003f,0.44070002f,-1.34210002f,-0.66360001f,1.04559999f,-0.23989999f,-0.54590000f,-0.97970005f,1.67620002f,0.91559998f,-0.43370000f,0.55440000f,-0.47770002f,0.19870002f,-1.18830000f,-0.34049999f,0.18479999f,-0.33640001f,-0.96140002f,0.01630001f,0.88690003f,-0.21700000f,-1.31300002f,0.27259999f,-0.41289995f,-0.16909997f,0.39889997f,0.12509997f,-0.18760000f,0.30129999f,-0.04749999f,-0.85980000f,0.26340004f,-0.84539999f,0.96509997f,0.84759998f,-1.27539997f,-0.66539999f,1.08470001f,-0.65350000f,0.00749999f,-1.31760002f,-0.46960002f,-0.08830000f,-0.06759999f,-0.06030002f,-0.86830001f,0.77500002f,-0.14389999f,0.31769998f,-0.12390001f,0.45580003f,1.84410002f,0.72990003f,1.25259999f,-0.71270000f,0.81590002f,-0.31400000f,-0.29029998f,1.63320006f,-0.15189999f,-0.35740000f,-0.33430002f,0.79200000f,-0.66380004f,-1.24620000f,0.82470003f,1.67900006f,2.05900001f,0.46459993f,0.52599999f,0.35900001f,0.60430000f,0.82280003f,0.61340002f,-1.16350002f,0.17420002f,0.14729999f,-0.08880000f,-0.12039998f,-0.27889999f,1.47469997f,0.75249999f,-1.27560001f,-0.35479998f,-1.17489998f,0.44180000f,0.31079998f,1.03049997f,-0.82940004f,1.10420002f,0.67450001f,-0.68520000f,0.14709999f,-0.81219999f,0.20579999f,-1.67569998f,-0.25410003f,-0.85510003f,-0.40320001f,0.70720002f,0.18570000f,-0.65280001f,0.38390000f,-1.72660002f,-0.56990001f,0.86389998f,-0.54409999f,-0.60350002f,-0.94319997f,0.67080004f,-0.58870002f,1.62330002f,-1.30050003f,1.46740005f,0.53590005f,1.65470007f,-0.74530005f,-0.58900003f,0.14950002f,1.13450006f,-0.73960001f,0.91960003f,-0.13750000f,-0.72350001f,-0.00580000f,0.15129999f,0.41910000f,-0.48519998f,0.99860004f,-0.29360001f,1.32880003f,-1.71700003f,-0.47359999f,1.34520003f,0.66430002f,-0.85850005f,0.67320001f,-0.66269999f,0.16870001f,0.60230000f,-0.64700000f,-0.43070002f,0.97520002f,-0.08639999f,-0.83840000f,0.33780001f,-0.25870000f,0.18070003f,-1.48800003f,-0.78310002f,0.15819998f,-0.29249996f,1.65689998f,0.03189999f,-0.29449995f,0.30780000f,-0.45090001f,-1.16110004f,-0.34460000f,0.05550002f,-1.72340004f,0.09170004f,-0.53749998f,-0.88939996f,-1.23020003f,-0.55269998f,1.23730004f,0.07820004f,-1.23340003f,1.05300002f,-0.30960003f,-1.36310006f,-1.43130009f,-0.35910000f,1.19790002f,-0.33760000f,0.81230002f,-1.10190002f,-0.44459998f,-0.73989998f,0.86710002f,-0.47649998f,-0.99649998f,-0.63329998f,0.35989998f,-0.69800001f,0.01150003f,-1.15290003f,1.83920001f,1.51389998f,-0.81329997f,-0.62640002f,0.05310001f,0.60289998f,-1.47339999f,0.83270005f,-1.46880004f,-0.08799997f,-0.55670005f,1.31680004f,-0.30720004f,-0.06650000f,-1.36350000f,1.21040001f,-0.00279998f,0.54960003f,-0.64680003f,-0.26040002f,0.47250000f,0.06080000f,1.16999997f,0.11060005f,-0.12379998f,-1.47429997f,0.30280002f,-0.24650002f,0.76719998f,0.44159997f,-1.19390002f,-0.76329999f,0.72309997f,0.85930003f,-0.09820001f,-2.23639993f,0.48330001f,0.27729999f,-0.18460000f,-1.05860001f,-0.09570002f,0.84430001f,-0.91070000f,-0.21959999f,0.11440000f,-1.23560000f,0.42290000f,1.50219998f,-1.52849999f,-0.29409998f,-0.46340003f,0.57290000f,0.07920001f,-0.71570001f,0.52200001f,0.61120001f,-0.06539999f,1.87790004f,-0.25710000f,-0.19060003f,0.06200000f,0.10029999f,0.65310002f,1.51030002f,-1.47700002f,0.51990000f,-0.70120003f,0.75670001f,-0.32600000f,-0.35680001f,0.09540001f,0.20810001f,-0.29640002f,0.14880004f,0.94139999f,1.11290001f,-0.71380002f,0.53010000f,-0.52260001f,-0.25399999f,-0.34999994f,-0.47840000f,-0.26120000f,0.46290000f,1.39529994f,-0.29439999f,0.26599999f,-0.60310001f,0.52589998f,0.01080000f,-0.39130000f,-0.29259999f,1.30769998f,-0.17059999f,-1.21260001f,0.25320000f,0.17880000f,-1.12350001f,0.62760003f,-0.85889999f,0.87960001f,0.40700000f,-0.49560001f,0.00030002f,0.58220001f,-0.68690000f,0.17940000f,0.56020002f,-0.28550003f,-0.01609999f,-0.43009999f,0.54470004f,0.53040002f,0.22270003f,0.20159996f,-0.19829997f,-0.22530004f,0.12970000f,0.28880000f,0.33060002f,-0.69690002f,-0.23280001f,-0.52140003f,0.13920002f,1.25649998f,-1.17779998f,0.27510002f,-0.21230000f,-0.80619997f,-0.00439999f,1.27430007f,-1.14040002f,1.64820002f,-1.64880002f,-0.21499999f,1.31129999f,-0.86540001f,-0.14189999f,0.45150000f,-0.39730001f,0.12690000f,-0.75770004f,0.14240002f,1.03600000f,-0.30460000f,-1.20200003f,0.15050001f,0.75110003f,-0.17830001f,0.10279999f,0.34920001f,-0.17320000f,0.26939999f,0.79050002f,0.43690004f,-0.35130002f,0.59360003f,-0.24330002f,0.33530004f,0.30020000f,-0.11320002f,0.37050004f,0.71900004f,-0.15039998f,1.19700002f,-0.71450002f,0.56610002f,-0.89610002f,0.77400000f,0.14070002f,0.96180003f,-1.73500004f,0.49980003f,-0.53910001f,-0.09640000f,0.00600002f,-1.52740000f,0.72850001f,0.87199998f,0.16510003f,-1.23429998f,2.82100000f,-0.71419998f,-0.50229999f,-2.37809997f,1.73310002f,0.52560000f,0.56450000f,-1.23609995f,-0.60910002f,-0.56689999f,0.15070000f,1.80800002f,-0.21119998f,-0.52220001f,0.55990002f,-0.08700001f,-0.17970000f,-0.62329999f,0.41489999f,0.30660001f,0.32610000f,-0.95900002f,0.14890000f,1.24310002f,-0.29769999f,-0.92610001f,0.92929999f,0.13580000f,-0.03800002f,-1.19290001f,0.08660000f,-0.63670002f,-0.28630000f,-0.27280001f,0.03670002f,0.34739999f,-0.28620001f,0.71490001f,0.52630001f,0.07560000f,-0.23900001f,-0.99550001f,0.30060001f,0.49370001f,-0.46959999f,0.43369999f,0.23540003f,-1.66200003f,0.32850001f,0.16289998f,0.12099998f,0.16370002f,-0.46000001f,-0.67040000f,0.88979999f,0.47310000f,0.05019999f,0.63919999f,-0.85229998f,-0.78120000f,0.56739999f,0.15530000f,1.17780002f,-0.70319999f,-0.24540000f,0.17230000f,1.01420001f,0.02570000f,-1.10250002f,0.63470000f,0.60100003f,-0.33749999f,0.08769996f,-0.96970000f,-0.19630000f,-0.69840002f,0.63510003f,-1.02640003f,0.39550000f,0.03730001f,-0.76690004f,0.23530000f,-0.10200000f,-0.22890002f,-0.55829999f,0.95620002f,-0.49810000f,-0.20340001f,-0.08790001f,-1.44830001f,1.07990001f,-0.80050002f,1.49550005f,-0.55560004f,-0.34610001f,-0.38399998f,0.92310000f,-1.08340001f,0.20470000f,-0.28670000f,-0.24980001f,0.60280000f,0.21399999f,0.02400001f,-1.05199999f,-0.92459995f,-1.03459996f,0.78899996f,-0.53290001f,1.59519994f,0.64870002f,0.02589999f,0.04890000f,-0.20809999f,-0.42930001f,0.23890000f,-0.88279999f,0.65890000f,-0.93859998f,1.16240003f,-0.51719999f,-0.88990003f,0.23850000f,0.13610000f,-0.71000000f,1.33020002f,-0.60880000f,-0.62190001f,0.84670001f,0.68700000f,0.41620001f,1.05310001f,0.43380002f,0.35779999f,0.68440004f,-0.53530005f,-0.21980001f,-0.81570003f,0.46870003f,0.81320002f,0.25890003f,-0.12990004f,-0.16760002f,-0.79990001f,0.51690002f,-0.16119999f,-0.71800000f,0.98160001f,-0.52779999f,1.00700004f,-1.11639993f,2.12770001f,-1.18070000f,-0.00350000f,-1.35699998f,0.06470002f,0.68600002f,0.62350003f,-1.37530002f,1.51169999f,-0.19230001f,-0.75430000f,-0.21339998f,0.07170000f,-1.43050003f,1.14210002f,-0.17939998f,-0.03390002f,-1.24590002f,0.47599999f,1.39170003f,-0.42460000f,-0.22840000f,0.64579999f,-0.33419999f,0.64750001f,-0.82330003f,0.03870001f,0.61309998f,0.16390006f,-0.82620004f,0.55580004f,0.56730002f,-0.21890000f,0.66019999f,0.63660003f,1.32540001f,-0.28900002f,-0.31390000f,-0.02070003f,-0.42850000f,-0.53840003f,0.75180004f,0.61750001f,0.02589997f,0.67590005f,-1.06840001f,0.03539998f,-0.80620002f,-0.37069999f,0.55230001f,-0.42610000f,0.71720002f,-0.44090000f,0.84789999f,-0.37510000f,-0.18530002f,0.32109998f,-2.21470001f,0.80860004f,1.64959999f,0.96649998f,0.03969999f,-1.74999995f,1.16109999f,2.36709999f,-0.31689999f,-0.36160000f,1.07359997f,2.27490002f,0.48699998f,0.79630002f,-1.91810007f,0.72800008f,1.02439996f,-0.46730008f,-1.66520000f,-1.38669998f,-0.96700002f,-0.40760000f,0.73130003f,0.15200001f,-0.95780004f,0.60589998f,0.33700000f,0.83229999f,-1.65770003f,0.44949995f,0.19190004f,-0.29920003f,-1.28819996f,-1.09690000f,0.74490002f,0.45989999f,1.07030002f,-0.98709999f,-0.43519999f,-0.40690000f,0.48109999f,-0.66259996f,-0.54440002f,1.87200001f,0.24520003f,-0.61609998f,1.27130001f,-0.78650002f,-1.36830004f,1.56140003f,1.56590007f,-0.22929999f,0.85229999f,1.31370007f,1.70830006f,-1.20110003f,0.30890001f,0.05180000f,-0.29900000f,1.63250004f,0.59329996f,-0.45470001f,0.96680004f,-0.25689998f,-1.50450001f,1.57060002f,2.76460007f,-0.71570005f,0.72540000f,0.25559996f,1.28080006f,-1.62010004f,-0.33889999f,0.80840002f,0.06520001f,-0.50350000f,0.55190001f,0.84819997f,0.73410003f,-0.88960005f,0.48129998f,0.17700004f,-0.11869998f,-1.06860005f,-0.25630003f,-0.48289995f,-0.16940001f,0.49259997f,0.16439998f,-0.51440000f,0.26240004f,0.03430001f,-0.30499994f,1.94880005f,-0.34540000f,0.19030000f,-1.32110001f,-0.62520002f,0.00640000f,-1.59170002f,0.75710002f,0.88160005f,-0.59640003f,0.01679999f,-1.15069998f,0.14249995f,1.02650000f,-0.61760002f,1.39140002f,1.35269999f,-0.27960005f,-0.43449996f,0.78300004f,-1.44680005f,1.22940004f,-0.72380003f,1.30820005f,1.04960004f,-1.46029997f,-0.21489997f,1.14840001f,-0.05450006f,-0.20920001f,-0.31269999f,-1.05590001f,0.31079999f,-0.65950001f,1.53290000f,-0.14600001f,0.04610001f,0.18240000f,1.23160004f,-0.06010001f,0.26450002f,-0.00310006f,-0.04040001f,-0.64269996f,-0.52549996f,-0.31719995f,0.31130001f,0.91580001f,-0.88430001f,0.23250002f,0.46230001f,0.44740001f,-0.39110001f,0.86439999f,-0.02309997f,0.17099998f,0.63100002f,1.20920002f,-1.31130001f,0.38539997f,1.49460001f,0.82229997f,0.12240003f,1.29020003f,-0.57170001f,1.01550001f,0.20449999f,-0.24630002f,-0.65120002f,1.04770002f,0.62000002f,-0.21650000f,1.07499999f,0.53509999f,-0.03299998f,0.90129999f,2.25520001f,0.37529995f,-0.18659999f,1.49910002f,1.77500005f,0.53169999f,0.38600004f,-0.29420001f,0.83149999f,0.46789999f,-1.29430000f,-0.15399999f,-0.00209997f,0.39370001f,0.22329994f,1.35420001f,-2.13109996f,0.16540002f,0.87799999f,0.76709999f,-1.39910005f,1.14580002f,-0.46760005f,1.07480001f,0.23290000f,-0.07230000f,-0.19529999f,0.06900000f,1.70000004f,-0.07370000f,0.10759998f,-0.99719997f,0.68420003f,-0.30780005f,-1.29349999f,-0.77760001f,-0.89130001f,1.50499997f,0.10160000f,0.47230002f,0.83280000f,-0.71329999f,0.23250006f,0.67109999f,1.33640004f,-1.26330007f,-0.15439999f,1.00489998f,-0.09120000f,-1.16369996f,-1.44159998f,-0.52749999f,-0.30809999f,0.21790000f,1.09729999f,-0.62890000f,0.34589999f,-0.94140001f,-0.04360001f,-0.64609998f,-0.81419999f,-0.43490000f,-0.17780002f,-0.20669995f,-0.35080001f,0.21189995f,0.82830000f,0.71800002f,-1.05789995f,-0.50769997f,-0.82240000f,0.02060002f,-1.10969999f,0.61829998f,0.47209999f,0.09899998f,-0.85219996f,0.39579998f,0.60550002f,-0.24849998f,0.41889998f,-1.38920003f,-0.79649999f,-0.23429997f,0.08769998f,-0.38389996f,-0.48240001f,-0.05340000f,-0.60689994f,0.00000002f,-1.37200004f,-0.04860002f,0.90300002f,0.61209997f,0.41669999f,-0.08309997f,-1.86220006f,-1.55300007f,0.24780000f,-0.29529997f,-0.68959993f,-0.08929994f,-0.39940000f,-1.31559996f,0.19710003f,-0.52580000f,1.31949997f,-0.03480000f,1.68870009f,0.21840000f,-0.77219999f,0.82660000f,0.87100000f,-0.76920003f,1.21600005f,-0.16819998f,-0.01800009f,0.43589999f,-0.21879996f,-1.47489997f,0.79329997f,0.49390001f,-0.39589996f,0.84250003f,-1.29450004f,0.43480002f,0.37400001f,-0.03390000f,1.21200001f,0.51580000f,0.95010000f,-0.18659999f,-0.98119999f,1.48949997f,0.10900005f,0.21599998f,0.57509997f,0.47720006f,0.04500003f,-0.39140002f,0.12760000f,-0.44530000f,0.15650000f,0.24099999f,2.14180001f,1.13239999f,0.20009997f,-1.33820002f,-1.01860000f,0.00240000f,1.57710002f,0.38559998f,0.52069996f,-0.00229997f,-0.51830000f,-1.55230006f,0.68770004f,0.24340003f,-0.48789998f,-0.15080002f,0.08959999f,-1.94259997f,-0.22559999f,1.00359998f,0.52749998f,0.69199998f,0.22899999f,-0.76030001f,-0.67720000f,0.11169997f,0.66569998f,1.29539999f,0.52479998f,-1.18189998f,-1.06079999f,0.27500003f,-0.19459998f,-0.44829998f,-0.42040008f,-1.27069999f,-0.55670003f,-1.00470005f,0.53279997f,-1.42060005f,0.88950002f,1.83050001f,-0.14839998f,1.29660000f,-0.70520000f,0.90430000f,0.20639998f,0.31720001f,0.61900000f,0.24640000f,-0.99340001f,-0.88249999f,-0.39389998f,-1.75380006f,-1.02930000f,-0.40590002f,1.73250000f,2.36740001f,-0.20320000f,0.60670001f,-0.22300002f,0.92340001f,-0.08249999f,0.42900003f,-0.76280002f,-0.01460001f,-1.00000002f,0.12220000f,0.09430001f,-1.36799998f,1.23900003f,-0.29290000f,-0.33539996f,-0.59189999f,-1.04690004f,0.48749996f,-0.21389998f,0.18650000f,-0.99119997f,-0.36369998f,0.05220001f,-0.82060000f,0.77860001f,-0.12940001f,0.04410002f,-0.90450000f,0.52619997f,-0.69310003f,1.09300001f,-1.05620003f,-0.35220000f,-0.35689997f,1.92550002f,-1.23710001f,1.75440005f,-0.26320002f,0.28070000f,1.24740006f,0.12729998f,0.23010001f,-0.21180000f,0.88080000f,-1.15779995f,-0.03900003f,-0.05670001f,1.76689994f,-0.78840000f,-0.33580000f,0.18160003f,0.02399998f,-0.55289998f,0.48169993f,1.53610003f,0.97779997f,0.28160001f,-0.91150000f,0.27140001f,-0.72089999f,-0.05610000f,1.79500003f,-0.76030000f,-0.84490001f,0.43739999f,-0.56160000f,-0.58160000f,1.66710003f,-0.28220001f,-1.08480004f,0.08830001f,0.77520002f,-0.67630002f,-1.76680004f,0.20159998f,0.75090003f,-0.80860004f,0.63240000f,-0.72380006f,-0.68350000f,0.32210000f,-0.36860001f,-0.08849998f,0.12389996f,-0.23790005f,-0.04429998f,-0.56290001f,0.04920001f,-1.55990006f,1.27560005f,-0.28900000f,1.49670005f,-0.54120004f,0.66970001f,-0.19179998f,0.32659992f,1.15109999f,-1.37499998f,0.43660004f,0.60130001f,-1.24630003f,0.56929996f,1.19930002f,-2.06830000f,-0.78299998f,-0.34210001f,1.96859997f,-1.01170002f,0.41049998f,1.00510003f,0.36789999f,-0.25010001f,-0.54290004f,-1.01190001f,-0.04980000f,-0.37640001f,1.06360003f,-0.71890002f,1.16780000f,0.15760002f,-1.67860001f,0.50479999f,0.59310002f,-0.47930002f,0.71350002f,-0.43779999f,-0.82560002f,1.06600002f,0.53240004f,-0.46240001f,0.06610001f,0.06950001f,1.13740003f,0.33739998f,-0.75150002f,0.58840000f,-2.00550003f,0.63390003f,-0.16940002f,-0.47160002f,1.25230001f,-0.47690000f,-0.62470006f,0.54930004f,0.15109997f,0.88020003f,0.59180002f,-0.35749998f,0.31420001f,-0.29190001f,1.76720001f,0.08750003f,-0.02310004f,-0.41449997f,-0.46360000f,-1.56919997f,0.06660003f,0.11510003f,1.10649999f,0.45209998f,-0.86290002f,0.04159997f,-0.11270000f,-0.77450001f,0.10619999f,-0.01689999f,-0.58340000f,0.72089999f,-0.60840000f,-0.98980000f,-0.44280002f,1.76640000f,-1.37629998f,-0.77830000f,-0.03690001f,0.66789999f,-1.33010002f,0.40630004f,-0.94700005f,0.10280001f,0.19220000f,0.70400003f,-0.39049999f,0.50159998f,-0.67720002f,0.94740002f,0.25850001f,0.47009998f,-1.11690000f,-0.18420002f,-0.22569998f,1.17260002f,-0.95450002f,0.28950001f,-0.69960004f,0.13310000f,0.11839998f,0.05140001f,0.46960000f,-0.13319996f,-1.03639998f,-0.11860003f,1.32579998f,-0.04629996f,-0.38779999f,0.29870003f,-0.32710003f,-1.07329998f,1.27599996f,-0.56239999f,0.06189996f,0.61890003f,0.58489997f,0.11670000f,0.41119999f,-0.04540000f,-1.15790003f,-0.18640001f,0.66319999f,-0.44380000f,-0.33739997f,-0.28230004f,-0.39459999f,0.91789999f,0.77439999f,0.19770002f,-0.43139999f,0.68489999f,-0.52259999f,-0.04930002f,0.11069998f,-0.33530001f,0.50540001f,-0.53049999f,1.24310001f,-0.81250002f,1.51380007f,0.06759997f,-0.54230001f,1.06010002f,-0.04420002f,0.02270001f,-0.83830001f,-0.48630000f,0.52080002f,-0.43260001f,0.64319999f,-0.59139999f,-0.52200001f,-0.13469998f,-0.17649995f,-0.26320004f,-0.37660000f,1.22659997f,1.52979997f,-0.11830001f,0.49790003f,-0.89919995f,0.34859998f,-0.44960001f,-1.99349997f,0.67410000f,-0.14950001f,1.20189994f,-0.16860000f,1.09830003f,-0.79919999f,-1.05110004f,1.05300002f,0.20909999f,0.61780001f,-0.27769998f,0.15239999f,-0.72860002f,0.69710000f,-0.26369996f,-0.19380003f,0.08119993f,-0.59859997f,1.17960005f,-0.97070002f,0.44940000f,-0.78640003f,-1.12000006f,0.49540003f,-0.18990002f,0.66780002f,-0.11229996f,0.82930000f,-1.57050005f,0.54190002f,0.66410004f,0.43159997f,1.03029999f,0.64740004f,-0.07059997f,-0.21810001f,-0.51030003f,0.53320004f,0.66799996f,0.56679999f,-0.32010003f,-0.10630004f,-0.04230000f,0.65180003f,1.22809996f,-1.45330001f,-0.42759998f,-1.37939993f,1.01990000f,0.21460002f,0.83720000f,-1.37719993f,0.97120003f,-0.86770002f,-0.08000000f,0.94450000f,-0.98940000f,-0.57279998f,-0.01260003f,0.47129999f,0.27670000f,-0.10070003f,0.31980000f,0.59500007f,-0.47570004f,-1.15760005f,0.61490002f,-0.15169999f,0.03890001f,0.07810001f,-0.14640002f,0.55820002f,-1.64420003f,0.45830003f,-0.63470003f,0.94980001f,0.40319998f,-0.93619998f,-0.32770001f,-0.25659994f,-1.01080007f,0.09390000f,0.81080002f,-0.36700001f,0.02970002f,0.23050000f,-0.33720001f,1.04010001f,-0.01840000f,-1.10889997f,0.42859998f,-0.06999999f,1.93609992f,0.52029995f,0.42469999f,-2.14579997f,-0.33019997f,-0.24240001f,1.87679997f,0.40809996f,-0.05710000f,-0.26599997f,-1.60249996f,0.44530000f,0.80249997f,0.27750000f,-0.13279999f,0.87110000f,-0.55619998f,0.75800001f,0.98139998f,0.23450004f,-0.57170001f,-0.54819999f,-0.29890000f,-0.57550002f,0.25210002f,-0.52940002f,-0.09399999f,0.21839998f,-0.62680000f,0.38819999f,-0.63630000f,0.84030003f,-0.45510000f,1.12590005f,-0.21810003f,0.26070004f,-0.58340002f,-0.88499999f,0.31159999f,-0.82480001f,1.57950002f,-0.91110000f,0.64119999f,-0.70680001f,0.87660000f,-0.07680000f,0.60600002f,-0.53240002f,0.25560005f,-1.25599998f,1.22930003f,-0.45469999f,-1.02210000f,-0.28249999f,-1.23959998f,-0.11810004f,0.03840001f,0.80629996f,0.15460002f,0.12409997f,-0.54539999f,1.02599993f,-0.36700000f,0.83939998f,-0.55690001f,-0.14199996f,1.67480005f,0.76679998f,-1.19060005f,0.66269998f,-1.33850005f,-0.72060001f,-1.05709999f,-1.71380001f,-0.47810000f,-0.43009999f,1.66620006f,1.36760006f,0.21900000f,-0.31060001f,-0.45950004f,-0.03800001f,-1.37810000f,-0.27039998f,0.74730001f,-0.60660001f,0.92430000f,0.00969997f,0.67839998f,0.22909999f,1.27770004f,-0.29999998f,-0.88330000f,0.14640004f,-1.29430003f,-0.32630001f,0.45680004f,-0.06890001f,-0.62679999f,0.78829997f,-0.45339998f,0.78400002f,0.85680005f,0.07950000f,0.61970002f,1.31650000f,-0.05740002f,-0.29590000f,-0.08090002f,-0.10510004f,-0.78950002f,0.12030003f,-0.42729999f,-0.24860007f,-1.15670002f,0.10610000f,0.55320003f,-0.17099997f,1.27550004f,-1.23450007f,0.64220003f,-0.95040006f,-0.24360006f,0.16229995f,-0.37960006f,0.87270007f,0.20139996f,0.46930002f,-0.93660002f,-2.01270006f,-0.77040000f,0.47730005f,0.05320000f,-0.09720003f,-0.61490001f,-0.09920000f,-0.50640002f,-0.09969998f,-0.76640003f,0.97150006f,0.11780001f,0.19819993f,1.73449999f,-0.51440002f,-0.03610000f,1.37660001f,-0.19770004f,-0.12299999f,-1.04709999f,0.96430000f,-0.27259997f,0.37420000f,0.32469998f,-0.50000001f,0.85229995f,-0.53970001f,1.42830000f,-1.21680004f,1.33869997f,-0.14979997f,0.27900000f,0.30089998f,-0.13960000f,0.06430001f,0.92300000f,0.33750000f,0.08789999f,0.01079999f,-0.22730006f,0.10849997f,-0.85549998f,0.55789995f,-1.33100004f,-1.35440005f,-1.18329999f,1.16619998f,0.78830000f,-0.15770005f,-0.06219999f,1.23130001f,0.61799998f,0.03679998f,-1.39730003f,-0.62760000f,0.21950003f,0.16179999f,0.37499999f,-0.36280002f,0.29740004f,-1.19249998f,2.26669998f,0.00689997f,-0.53470003f,0.16940001f,0.62099996f,1.17269996f,-1.35359999f,-0.43500002f,1.06940000f,-0.15530002f,0.55950001f,0.80530000f,1.19670000f,0.37990004f,1.39510004f,-1.17889999f,0.30220001f,-0.14290005f,-2.35370001f,1.80270004f,-0.05619999f,0.27930000f,-0.16810003f,0.33490004f,-0.09779996f,-0.15300004f,-0.83130000f,0.14149999f,1.16670001f,0.25470000f,1.20340002f,0.84499997f,-0.69950002f,-0.43029994f,-1.83810002f,0.72769999f,1.76499999f,0.43479994f,-0.57850007f,-0.20199997f,0.25140001f,-1.39920000f,-0.74639998f,0.09210002f,-0.34280000f,-0.34550001f,0.14359999f,-0.61870001f,0.91040000f,0.40459994f,1.20139998f,0.77130002f,-0.39129997f,-0.73439998f,-0.46970004f,1.11139996f,1.19359998f,0.31799997f,-0.05680000f,0.16800002f,-0.92609997f,0.28499999f,-1.03239997f,0.76559999f,0.05369998f,-0.27520000f,0.82260003f,0.72800003f,-1.96090006f,-1.03070004f,1.61289999f,-0.50750005f,-0.90609995f,0.78329997f,-1.49550004f,-1.40170002f,1.23560001f,-0.29450003f,0.06800000f,0.94410002f,0.97210002f,0.06310001f,0.35530000f,0.06679999f,-2.21070004f,-1.01550001f,0.23490002f,-0.58020005f,-0.72990003f,-0.01459998f,0.97420007f,-1.42850004f,1.88329998f,0.54619996f,-0.62780000f,0.36520001f,-1.57499999f,0.12300001f,-0.06340000f,-0.35059999f,1.28129998f,0.38889998f,-0.65709996f,-0.93289998f,1.28700007f,-0.81250000f,-0.60790004f,1.12910000f,-0.31689997f,0.56610004f,0.30769998f,-0.09170007f,-0.18660000f,-1.25819999f,0.48050003f,-0.05240004f,-0.50780002f,-0.86339998f,0.12679999f,1.93149997f,-0.77950001f,0.40320003f,-0.07589999f,0.76910002f,-0.25660000f,-0.39860002f,-0.89170000f,1.61960000f,0.26370002f,0.36270001f,0.08280003f,-0.11069997f,-0.46859999f,0.64890000f,0.83779999f,0.66869999f,-0.80310003f,-1.19250000f,1.07579998f,0.44969995f,-0.71390003f,-1.13820003f,0.42310000f,1.16070003f,0.38179999f,-1.79270003f,0.51120001f,-0.68160004f,0.49530000f,-0.16509995f,-0.85599997f,-1.23389997f,-0.16280000f,2.18309996f,0.12859998f,-0.75899999f,0.25559997f,1.45729999f,0.37769996f,-1.12649999f,-0.52939999f,1.26319998f,-0.13730001f,-0.83100002f,0.79540004f,0.49450003f,0.73429999f,0.61250000f,-1.14320000f,-0.34790002f,0.71609998f,-0.76519998f,-0.00100004f,-0.76129996f,-0.09909998f,-1.09270000f,0.27069996f,-0.72919996f,0.19700000f,-0.09720000f,0.99400003f,1.22259999f,-0.87570003f,0.61520001f,-0.91470000f,-0.39700003f,0.15179999f,-0.60099999f,-1.84189997f,-0.13769996f,-0.64410002f,-1.56060002f,-1.35900002f,0.12590006f,-0.34540000f,-0.27100000f,-0.46220003f,0.18380000f,-0.14420000f,0.12850000f,0.18880000f,-0.58599999f,-0.26509996f,-0.15599998f,1.31269996f,-0.67470001f,0.02410000f,-1.10780000f,1.52730002f,-0.31910001f,-0.24290002f,-1.11889999f,0.44480003f,-0.34100001f,-0.73220000f,1.12970001f,1.13439998f,0.53630005f,1.20210002f,-0.06899999f,0.59239999f,-0.27970002f,-0.57620003f,-0.14269998f,0.64809999f,1.20670001f,0.53489997f,-0.20039999f,0.54160001f,-0.68200001f,0.17580000f,1.14889997f,2.04619995f,0.05740000f,1.29960004f,-0.00840004f,-0.81120004f,-0.88189996f,-0.34700001f,1.94660003f,1.48320000f,1.41589997f,-0.08630007f,-0.57680000f,0.52640001f,0.93660003f,0.01920000f,0.69960003f,0.34659999f,-0.83020002f,0.47019995f,-0.47150000f,0.09369998f,1.22509997f,1.09130001f,-0.70099999f,0.26110005f,-1.55079999f,0.40259998f,1.25579998f,0.97559997f,-0.73300004f,0.82780001f,-0.54660001f,0.32980001f,1.08030004f,-1.19830009f,-0.35779998f,-0.43830004f,-0.50489998f,-0.10260000f,-0.00379999f,0.47709999f,-0.61700004f,1.56950006f,-0.03270001f,0.36130002f,-0.59800004f,-0.62640001f,0.27979998f,-0.36870002f,1.03920004f,-0.82660000f,0.89119998f,0.81549998f,-1.80150002f,1.58930001f,-1.28950003f,1.05439999f,1.07089998f,-0.09040000f,0.51249999f,-1.08279992f,0.58280001f,-1.29259997f,-0.38509999f,-0.68520003f,0.26680000f,1.00529999f,0.05700000f,0.15290003f,0.50119998f,-0.72400003f,0.31110000f,-0.29790001f,0.13900000f,-0.19690004f,0.22330000f,0.77460003f,-0.67840002f,0.75320002f,0.12360001f,-1.28460006f,1.02560003f,0.22690002f,0.49780000f,-0.69029999f,-0.12390004f,-0.66129999f,-0.53980002f,0.42480002f,-0.71190002f,0.94600004f,-0.21829999f,1.08020007f,0.08249998f,-1.27970003f,0.18090000f,-1.78750005f,1.10990006f,-0.42990000f,0.58890002f,-0.15439999f,0.33559998f,-1.10890002f,0.18040003f,-0.99990001f,0.39730000f,-0.40660000f,0.74689997f,-1.13089997f,1.58830000f,0.81529998f,0.46749996f,-0.12169998f,-0.59789998f,0.69309998f,-0.51970003f,-0.03499996f,-0.94689997f,-0.22070000f,0.54899998f,-0.34710000f,0.20840003f,0.53919999f,-0.13860000f,0.99650000f,-0.47339999f,1.20280000f,0.20849998f,0.11250000f,-0.03179999f,-0.26560000f,0.78479999f,-0.25839998f,-0.89410000f,0.56059999f,0.71269999f,-0.93670002f,0.58630002f,-0.14180002f,-0.95029999f,-0.21549998f,-0.68830002f,0.65920001f,-0.29959999f,-0.03170000f,-1.07780000f,-0.00250001f,-0.28040001f,-0.61300001f,-0.88960000f,-0.07530000f,0.74320002f,-0.19740000f,0.19699998f,1.81029992f,-0.34530002f,0.72699998f,-1.15539996f,0.62059997f,-0.60920005f,1.72779994f,-1.64409997f,-0.34569997f,0.26240000f,0.80389997f,-0.63260001f,-0.45970000f,-0.56580000f,1.10289997f,-0.14390000f,-0.22659999f,-0.45560002f,0.29079996f,-1.00930001f,0.20590005f,-0.51610004f,0.98550002f,0.74390001f,0.02669992f,0.40080006f,0.55770005f,-0.15700003f,-1.01610003f,0.72920001f,0.04230001f,0.46439999f,0.44630001f,-0.92690002f,1.40480002f,-1.12910003f,0.99260005f,0.07179995f,-0.57070000f,0.98819998f,-1.62700003f,-0.27429997f,-0.91049997f,-0.32460006f,-0.58529999f,0.88440003f,-1.24230002f,0.37170001f,0.28860000f,-0.05660001f,-1.11039998f,0.94629997f,-0.61570000f,1.10519995f,1.80679997f,0.34709999f,0.31969999f,-0.10639993f,-2.41850003f,-0.28879998f,0.31009996f,2.09409997f,0.07069997f,-1.33099996f,-0.01139998f,-0.35009999f,0.00700000f,0.69350000f,-0.94399999f,0.90710003f,-0.10230002f,-1.85730003f,0.69980000f,0.93410004f,0.00010001f,-1.37030003f,1.12930004f,0.12670003f,-0.99880000f,2.04180000f,-0.64039999f,-0.67950002f,0.73510005f,0.61940000f,-0.69599999f,0.01859998f,-0.82220005f,0.17390001f,0.69820003f,0.22330001f,0.22340002f,-0.70060005f,0.86370008f,1.12510000f,0.02680001f,0.28179994f,0.00999998f,-1.34420005f,0.59700005f,-1.05610000f,-0.17279998f,0.41700000f,-0.70780001f,-0.45520002f,1.48669996f,0.07170000f,-0.17760000f,1.57830003f,-0.99120000f,-1.27279997f,-0.08739997f,1.08599998f,-0.75750001f,1.39680002f,0.32769999f,-1.06000003f,-0.65979999f,0.02040000f,-0.13519999f,-0.46750001f,0.08890001f,0.16800001f,1.46170000f,-0.65599999f,-0.68829996f,1.12769998f,0.61079997f,-0.11549996f,-0.82570002f,0.64760001f,1.52080002f,-0.14649999f,-1.29070001f,0.93199998f,0.21810002f,0.32850000f,-0.61100003f,0.15950002f,0.83590001f,-1.18010002f,-0.70390001f,0.43049996f,-0.00640000f,-0.28320001f,-1.53900001f,0.62020001f,-0.09259998f,-0.45910003f,-1.45889999f,0.20370000f,0.20200001f,0.20280001f,1.39890001f,-1.49779999f,-0.28169996f,-0.38899996f,0.10089997f,0.70599995f,-1.16730002f,1.93259999f,-0.73290003f,-0.21599997f,-0.00060003f,0.59699999f,-0.38540003f,-0.12579998f,-1.14240000f,0.83409999f,-0.08680000f,-0.41870003f,0.25200001f,-0.91350000f,0.36729999f,1.12560000f,-0.32320000f,-0.91159999f,1.26019998f,-0.03390000f,0.71959999f,-0.42910001f,0.94760000f,-0.26300000f,0.74990000f,-0.27400001f,0.29480000f,-0.67010000f,-0.18270000f,-0.86520001f,-0.17019998f,1.02909999f,-0.62050001f,-0.37610001f,0.75120000f,-0.55860000f,0.24849998f,-0.51509999f,0.85500000f,-0.45519997f,0.51560000f,-0.61640000f,0.02820000f,0.48580003f,1.01420002f,-0.80960002f,-0.03149998f,-0.81339997f,0.14999998f,0.87769998f,0.89389994f,-0.24040003f,0.12999998f,-0.24810000f,-0.40409998f,0.76819995f,0.37330003f,-0.57509999f,-1.16529996f,-0.12420000f,0.39040001f,-0.10660000f,-0.22819999f,-0.30389998f,-0.02930004f,-0.47060000f,-0.86779997f,-0.10470004f,0.79210001f,-0.47279999f,1.17639997f,-0.96439997f,-0.73970000f,0.09579999f,0.16779999f,-0.67440000f,0.53460002f,-0.55580001f,-0.40399998f,-0.65460000f,-0.40409999f,-1.10180002f,1.03180003f,0.38659999f,0.69110001f,0.28470002f,-0.28390005f,-1.12300000f,-0.46830002f,0.01940000f,0.62890003f,-0.01319999f,-0.28420001f,-0.24600001f,-0.04740000f,1.03699997f,-1.44479998f,-0.01949998f,-0.90780002f,1.07829994f,1.00760001f,0.57790001f,0.02730003f,-0.89519994f,-0.61230000f,0.25229994f,-0.51009999f,1.34909997f,0.17540001f,-0.77160000f,0.53560001f,-0.13600000f,-0.41520000f,0.13029999f,0.60149998f,0.96359995f,-0.15110000f,1.35450000f,1.05309998f,0.57270002f,0.22729995f,0.22709995f,-0.66630000f,0.32990000f,0.86209997f,1.64579999f,-0.22940000f,-0.22429998f,-0.00369997f,-0.01620000f,0.04740003f,-0.78709999f,0.30929996f,0.95249997f,-0.95159999f,0.64329998f,-0.75980001f,0.45519996f,1.21760001f,-0.37640001f,-0.09370004f,1.30359999f,-0.80669999f,0.09639998f,0.07659998f,0.14030003f,-0.62770003f,1.65750004f,0.25550000f,-0.08320000f,1.39050005f,0.16260002f,0.69140001f,-0.23120002f,-0.77400000f,0.39420000f,0.46130001f,-2.21399996f,-0.45630000f,1.26559995f,-0.00939999f,-0.19189996f,0.99609999f,0.15939999f,1.25610004f,0.27150000f,1.96890003f,0.35789997f,0.17389999f,-2.54050005f,-1.01319997f,-1.54630000f,0.21650006f,-0.90160001f,-1.46009997f,0.67749998f,1.10850003f,0.26880000f,0.33269998f,-0.28920004f,0.08840001f,-0.28010002f,-0.39510003f,-1.34730002f,0.25030000f,1.00940001f,-0.30520004f,0.86750003f,-1.27880000f,0.04440002f,-1.08579999f,-0.21809995f,0.13970002f,-0.57070000f,-1.06939999f,0.11880001f,0.76279998f,0.23580000f,0.18009998f,-1.02550002f,-0.99409999f,-0.21649998f,-0.70360008f,-1.69010004f,0.62710005f,0.19269999f,-0.24340001f,-1.23760004f,1.01210006f,1.27850006f,-0.48170002f,-0.16000001f,0.79290002f,0.45540001f,-0.81610000f,-1.54410000f,-0.58359999f,-0.42339999f,-0.58459998f,-1.49420003f,0.33370003f,0.32630002f,-1.35960001f,-1.36940002f,1.44610005f,1.92930006f,-0.16870000f,-0.37110003f,1.25290001f,0.73809999f,-0.54610000f,-0.43999999f,1.32460001f,-0.53909999f,-0.16870001f,-0.09069999f,0.31100003f,-1.02069997f,0.36560001f,-0.52020003f,0.40870003f,0.07940006f,-0.81630006f,0.44720000f,-0.16579998f,0.46780003f,0.18459996f,0.53789998f,-0.31980000f,-1.39430000f,-0.24200002f,1.05690000f,-0.31999999f,-0.41980004f,0.00259996f,0.87570004f,0.34870002f,0.15589998f,-0.73870001f,-0.38950000f,0.15980001f,-1.14410007f,-1.60840006f,0.57590000f,-0.93690000f,0.30860000f,-0.49170004f,-0.12469998f,0.81880006f,0.59599998f,-0.37650008f,0.30750003f,1.11280004f,-1.80100005f,-0.76140002f,-0.24740005f,-0.30780002f,-1.64510003f,-1.74590003f,-0.42649995f,-0.48149998f,-0.40530002f,0.50080000f,-0.35000000f,0.41440000f,-0.68839996f,-1.53509999f,0.43179998f,1.05580001f,0.08129997f,-0.56340006f,0.63050007f,-0.81420000f,0.58110000f,0.00959998f,0.46900003f,-1.18049999f,0.46650003f,-1.00099999f,-0.21010000f,-0.25170004f,-1.20380003f,0.82360005f,0.40950002f,-0.73490005f,-0.98210003f,0.99180002f,0.49780001f,-0.07420000f,-0.39930001f,1.19670002f,0.37760002f,0.11790000f,1.17010003f,-1.31720003f,0.07159999f,-0.57880000f,-0.31590000f,1.75840006f,-0.28540004f,-1.10420006f,-0.65500000f,2.00930006f,1.40039999f,0.79249996f,-0.46840004f,0.55590001f,1.23979997f,-1.29150001f,0.68160006f,-1.10180000f,-0.72279999f,0.72910002f,0.37180000f,-0.73210000f,-0.42159998f,1.25610000f,1.05830000f,-0.69840004f,0.29319999f,-0.75269999f,0.27879998f,0.51799996f,1.12159997f,0.02589999f,-0.20570001f,-0.17490000f,-0.72819998f,-0.32949998f,-0.12219997f,0.40900002f,-0.41930003f,0.20219999f,-0.96660000f,1.09050001f,-0.77460000f,0.35559999f,-0.47949998f,0.16719999f,-0.51809998f,-0.24949999f,-0.38680003f,-1.29940001f,0.79330001f,-0.35869999f,-0.75780001f,-0.71190001f,-0.61450002f,-0.39719999f,0.50220004f,0.61030004f,0.60310005f,-0.25979998f,0.88129999f,-0.21080000f,0.34780001f,-0.42269998f,-0.16359999f,-0.89130002f,0.52450000f,-0.74420000f,-1.41050002f,-0.36760000f,1.15750001f,0.04540000f,-0.17540000f,-0.03819999f,-1.17690002f,0.12370001f,-0.43589996f,0.08020004f,-0.08300001f,0.53359999f,0.04099999f,0.02290000f,0.13780003f,-0.40349997f,1.42739995f,0.28589996f,-0.77799997f,-0.33990000f,-0.19409997f,1.03399996f,-0.60519998f,0.21680001f,-0.31429999f,-1.49479999f,-1.10279998f,0.74639997f,-1.16510000f,-1.70770000f,1.05930002f,0.43710001f,-0.90690002f,-1.43080003f,0.07349998f,1.08709999f,0.39759999f,-0.63530001f,-0.08580000f,-1.07690005f,-1.31010001f,-0.82200000f,-1.46920000f,0.21210001f,-0.54129999f,1.45600006f,0.49890004f,-0.52409995f,-1.64370002f,-0.26110008f,0.96330001f,2.02680003f,0.16069997f,-1.51220002f,-0.49000002f,0.71270005f,-1.37460001f,1.55579996f,0.69879997f,0.02950001f,0.23730001f,-0.08499999f,-0.64889996f,-0.89990008f,0.79660000f,1.26770010f,-0.78199998f,-2.24180001f,-0.06620000f,1.11829999f,-0.08270004f,-1.26080005f,0.80740004f,-0.05419997f,1.02940001f,0.79570002f,0.09739997f,0.69239999f,-0.51929998f,-0.39040004f,0.09020001f,0.40660001f,-1.30370003f,-1.03600000f,-0.24330005f,-1.46840001f,-0.16520000f,-0.08310000f,1.17060004f,1.27540002f,-0.16379999f,1.11530000f,-1.75290003f,0.21060002f,-0.56539999f,-0.90580005f,0.70530000f,0.62930000f,-0.51219998f,-2.34890002f,-0.58909999f,-0.88550000f,0.97860004f,0.06660000f,0.35400001f,0.51180002f,-0.47400005f,0.23589999f,0.23910002f,-0.75929999f,0.10700000f,-0.48719999f,0.33670004f,0.50920002f,-0.32610003f,0.04770001f,1.26420000f,0.19950001f,-0.25010000f,-0.67119999f,-0.29550000f,0.08090000f,-0.63290003f,-0.05409999f,-0.24319999f,-0.33960001f,0.21029998f,-0.81810000f,0.46029997f,-1.08740004f,-0.59500000f,0.13339998f,0.53560005f,-0.39630003f,-0.69720002f,-0.34469998f,0.03090003f,-0.43770002f,0.81029999f,-0.08820000f,-1.52270000f,0.42870000f,-1.00439998f,0.83209999f,-0.83170000f,0.25160000f,0.67099994f,1.01399992f,-2.03670000f,1.17710006f,-0.04880003f,0.82189997f,-0.92200000f,-0.64999997f,0.50030002f,0.75059995f,0.05110001f,-0.35360003f,0.29820003f,0.84460001f,-0.95550003f,-1.09340000f,0.60669999f,-0.79499999f,1.06210000f,-1.46770000f,0.56770000f,1.15569999f,-0.69320000f,-0.30629999f,0.44790000f,-0.01550001f,-0.57380000f,-0.65560003f,-0.26600000f,0.25840003f,-1.74960008f,0.20890002f,-0.21840001f,0.46360002f,0.71910002f,0.28050000f,0.47800003f,1.47499999f,-0.16560002f,0.15530000f,-0.18130000f,0.41070002f,-0.67560002f,0.65050001f,0.36420000f,-2.04920005f,0.09110001f,-0.68439999f,1.23839996f,0.26009998f,1.01749995f,0.42799999f,-0.42069998f,-0.46809997f,-1.23019994f,2.20209995f,0.22069997f,-1.91199996f,-0.42649996f,0.37509998f,1.10749996f,0.07960000f,-0.40320000f,0.79150000f,-0.33480001f,0.16250000f,0.75450005f,0.56039999f,-1.29420003f,0.74970003f,1.21150005f,-0.13760002f,-0.79430004f,-0.20989999f,1.31840003f,-0.71880003f,-0.46460001f,0.11240000f,-0.19390002f,0.74110002f,0.46670000f,0.73680003f,-0.80620002f,0.50890001f,-0.48900004f,0.62160005f,0.02349998f,0.02309997f,-0.00410001f,-0.19589999f,-0.22320002f,-0.80360005f,0.26490002f,0.01830000f,-0.55930001f,-0.56120001f,0.25939999f,0.36819999f,1.21230000f,-1.54999998f,0.54540003f,-0.15129999f,-0.40500004f,-0.96959998f,0.21309998f,0.98360004f,-1.16330002f,-0.91299999f,0.26110000f,1.49899998f,-0.55490001f,0.08739999f,0.04540000f,0.26140002f,-0.22519999f,-0.05970005f,0.48300003f,1.19060008f,-0.61290005f,-1.18390003f,0.84900004f,0.15889999f,0.50400001f,-0.96390003f,0.47130001f,0.25030005f,0.76070001f,-0.41190002f,0.90490003f,0.04100001f,0.51400002f,-1.26910005f,-0.23369997f,0.76810004f,-0.85220007f,-0.42520003f,0.32090003f,-0.77640003f,-0.03310000f,0.53460004f,0.63870005f,-0.41540002f,0.87330003f,-0.49910004f,0.65670004f,-0.12300001f,0.22600001f,1.62230001f,-1.22779998f,-1.92170001f,-0.41400000f,0.62490002f,2.22229996f,-0.81700005f,-0.83690001f,-0.23780000f,0.87070001f,0.92430002f,-0.71610003f,1.18940002f,-0.77209999f,-0.60710002f,-0.52479998f,0.20010000f,1.42590005f,-0.14480000f,-1.26450006f,0.33450002f,1.37290004f,-0.51469999f,0.26099996f,-0.30529997f,1.20600002f,-0.42070002f,-1.07940002f,0.69420001f,-1.36610001f,0.14859998f,0.73780003f,-0.65090003f,-0.09090000f,-0.08710003f,-0.82760001f,0.77980004f,-0.12850000f,0.17139998f,-0.89450002f,-0.55710001f,-0.28029996f,-0.50700006f,-0.95659999f,0.33620003f,-0.87199999f,-0.08609996f,1.73240000f,-0.49770002f,1.07070001f,-0.41120000f,-0.34740001f,-0.17039996f,0.16260000f,-0.02920000f,0.45260000f,-0.54980000f,-1.40540000f,0.14090002f,0.34509995f,1.88019995f,-1.11020000f,-0.81919995f,-0.22779996f,-0.66910004f,1.08200003f,0.50269997f,0.08900000f,-0.28920000f,-0.25230001f,-0.11009997f,-0.84120002f,0.46060001f,-0.67890001f,0.25550000f,-0.40620000f,-0.03950000f,0.06620000f,0.94930001f,0.26400000f,-1.36480003f,0.91740002f,0.71449999f,-0.18319997f,0.40480001f,0.27820003f,0.95610002f,-0.31720000f,0.94709999f,-0.45450001f,1.11329999f,-0.05820001f,-0.03250002f,0.37970000f,-0.39990000f,0.18249999f,-0.90340001f,1.24790003f,-0.45970001f,0.28590001f,-0.53659998f,-0.62260002f,0.43980005f,-0.74890001f,0.64070003f,-1.09009998f,0.54740003f,0.27270000f,0.60669998f,0.05939998f,0.67089997f,-0.58269997f,0.24799999f,0.24260002f,0.12429998f,-0.57650000f,0.39260000f,-1.12629994f,0.08330000f,-0.61420002f,1.09710000f,-0.71930000f,0.39749999f,0.22339997f,0.10350002f,0.22450000f,0.38630000f,0.02800006f,-0.80360004f,-0.97830007f,0.85950004f,1.93650001f,-1.17789999f,-0.99300000f,0.60669999f,-0.70970001f,0.14930000f,0.48210006f,0.81359999f,0.10060001f,1.28060003f,-1.47989999f,0.65730002f,0.09060004f,-0.18230004f,-0.70580008f,1.13690008f,1.31540003f,-1.05380001f,-0.86460003f,-0.05460000f,0.63800003f,-0.23260004f,-1.18339998f,0.44710002f,0.73889998f,0.44159999f,1.92239998f,-1.89229994f,-1.02969998f,-0.83539993f,1.82820001f,-1.02110001f,-0.00369997f,-0.45859994f,0.33230002f,-0.52080006f,-0.68589999f,1.10749997f,-0.02660000f,0.28810000f,0.18710001f,-1.29040002f,0.67609999f,-0.60089997f,0.01429997f,0.74780000f,-0.36799999f,-0.59890001f,0.10790001f,-0.16610000f,0.33729999f,0.37570000f,0.44560002f,0.20550000f,-0.12729999f,-0.91150001f,-0.18730002f,-1.84620005f,-0.17359998f,0.61830001f,-0.36279999f,1.53519998f,-0.12910000f,0.08159999f,0.29620004f,-0.45850004f,1.13210003f,-0.16430002f,0.99090003f,-0.91320000f,0.05160000f,-0.31290000f,1.24100003f,-1.00350006f,-0.12010000f,-1.08539998f,0.05520000f,-0.20309996f,0.40429996f,0.68819998f,0.88079999f,-0.03699999f,-1.07910001f,2.14120001f,-0.32910003f,0.06980002f,-1.59939995f,0.08240000f,-0.35719999f,-0.94470001f,0.73770006f,1.34910004f,0.41539997f,-0.93650007f,-1.05240000f,-1.87159998f,0.07990005f,-0.04020004f,-0.57339998f,-0.10090001f,-0.45579995f,0.79100004f,-0.29970000f,-2.00080004f,-0.60799999f,-0.93010002f,-0.06600000f,-1.53399998f,-1.02309999f,0.30440005f,0.12860001f,1.63129997f,-0.07310002f,-0.63959996f,-0.84759998f,-0.28489997f,-0.21250000f,-1.09760001f,-0.85270000f,0.80760003f,-1.13530001f,0.91390003f,-1.05800000f,-0.26700001f,0.50020000f,0.02559999f,0.09150001f,-0.07280001f,0.99109999f,0.08509998f,-1.28499996f,0.67500001f,0.45799998f,-0.42749998f,-2.03729999f,-0.96350000f,0.51039997f,-0.43179996f,0.53710004f,0.99080003f,0.62750000f,0.30359995f,0.90880002f,-0.09740004f,0.25200003f,0.55859997f,0.78970004f,0.51290001f,0.12310000f,-1.32259999f,-1.38360001f,-1.44349997f,0.67370005f,1.05820010f,0.81860001f,0.31389999f,-1.20070007f,0.25840001f,-0.09080002f,0.88510001f,0.21699996f,0.95509999f,-0.21700001f,0.22680002f,-0.90400001f,0.59620000f,1.58869998f,-0.30600001f,-0.42350000f,-0.01469999f,-1.26540000f,-1.63389998f,0.82960002f,0.48709999f,1.23310003f,-1.63700002f,-0.90000003f,0.83950001f,0.33940002f,-0.70890002f,-1.33099999f,-0.20320002f,-0.68780000f,-0.04650004f,-1.04740005f,1.09220003f,1.02640000f,-0.39649999f,-0.32610004f,0.39630004f,1.01290003f,-0.87070002f,-1.00830001f,2.15100000f,0.11189998f,-1.91099998f,-1.82269998f,0.57270000f,-0.06390002f,1.08690001f,-0.75780007f,0.54480002f,1.38410002f,-1.83800004f,-0.30359998f,1.75510000f,0.84890000f,-0.43880001f,-0.13220001f,-0.77449995f,0.00770002f,1.08489994f,0.40369997f,0.61620000f,-0.07659998f,-0.61319999f,-0.01129999f,0.45060000f,0.42630000f,-0.00930002f,-0.37280005f,-0.60499993f,-0.49279998f,0.06739996f,1.00260000f,-0.48570002f,0.75630001f,-1.19810000f,0.86860003f,0.05440004f,0.03739997f,0.20750000f,-0.07799996f,1.37160003f,-0.62360001f,1.17620005f,-0.81570001f,0.15540001f,0.44200001f,-1.15210001f,-0.63830001f,-1.03289999f,0.37790000f,-0.76790001f,0.12590000f,0.59589999f,-1.03390003f,0.31400002f,-0.11110000f,1.14210008f,-0.29730001f,0.98050008f,0.18289998f,-0.35950001f,-1.22780005f,-1.95580001f,-1.81650001f,-0.45409997f,1.20350001f,-0.04460000f,1.01969996f,0.37649997f,0.29679998f,0.17689999f,-0.34559999f,-0.64109999f,-0.78840000f,-0.41160002f,-1.02900000f,-0.48939999f,0.42150002f,-0.26160002f,2.14740001f,-0.41850002f,-0.78649997f,-0.58839997f,-0.00350000f,0.30160002f,0.21800000f,0.49660000f,-0.36749996f,1.30730002f,-0.34569996f,0.04119996f,-0.67399996f,0.44820000f,0.57840002f,0.21229997f,0.08760000f,0.44990001f,-0.05670002f,0.13339999f,-0.21479999f,0.20250000f,0.88770001f,-0.38380000f,0.29380003f,-1.06790005f,-0.33630000f,-2.39280003f,-0.13759996f,-0.16829999f,0.90650002f,-1.02020002f,0.13730001f,-0.02600003f,-0.41580005f,-0.53830000f,0.18060000f,0.23670002f,-0.21480001f,-0.36669999f,-0.50400001f,0.45600000f,-0.66480000f,1.73379999f,-0.46430003f,-0.05470001f,-0.80569998f,-0.19929998f,-0.77250001f,0.06870002f,-0.47449999f,0.94739999f,0.62299998f,-0.24210002f,0.01840001f,-0.63260003f,-0.24410000f,-0.10870000f,-0.21680003f,0.63200000f,-1.37320006f,0.08709997f,1.61990002f,-0.09040000f,-1.21329998f,-1.31680000f,0.60510000f,-0.24979997f,1.12600002f,0.01780003f,-0.69020002f,0.48970002f,-0.11230000f,-0.17430000f,-1.11980001f,0.91210006f,0.07680004f,-0.07300003f,0.17740001f,-0.79800000f,-2.64130002f,-0.57159997f,1.73190003f,0.07160000f,-1.70880002f,0.30130006f,-0.56060002f,0.03920000f,0.44770002f,0.25240001f,0.12820001f,-0.51590000f,-1.18709997f,-1.52749998f,-0.53769996f,-0.42589996f,2.38269995f,-0.11560005f,-1.02469997f,-0.38109998f,0.79399999f,-0.37219999f,0.33230001f,-0.88290000f,-0.35740001f,0.47930003f,1.22480001f,-1.20540001f,0.22949999f,1.06589997f,-0.33710000f,0.11030002f,0.11510001f,0.90419995f,-1.10870001f,0.97930006f,-0.13000000f,0.04509999f,-0.54280000f,1.07070001f,0.64460000f,0.24900003f,1.10080003f,-0.65809999f,-0.15299999f,0.42110002f,0.20349999f,0.13449998f,0.14609997f,-1.02559999f,-0.10770001f,0.06970002f,-0.49990004f,-0.88210002f,0.12930000f,1.37820003f,1.49700001f,0.85990003f,0.70819999f,-0.49790002f,-0.43959999f,-0.59539995f,-0.41389995f,0.42110000f,-0.22039999f,0.51499995f,0.61259995f,0.30830000f,-0.80979999f,1.38780000f,0.81070000f,-0.64450002f,0.22700003f,-0.73610004f,0.28669998f,0.15889998f,0.97080000f,-0.47350002f,0.37509999f,-0.91170004f,0.65980003f,-0.04090001f,-1.14800002f,-0.37140002f,-1.16020002f,-1.82710003f,0.75079999f,0.05060005f,-0.89750002f,0.39650001f,0.78140002f,0.13720003f,-0.96940001f,0.32310001f,0.27200000f,-0.89580006f,-0.57120002f,0.53330001f,-0.37110001f,-1.57700005f,-0.54210000f,-1.89859999f,0.45110005f,0.89580007f,0.06510001f,-0.28370001f,0.29150001f,-0.12649996f,0.08089999f,0.23079999f,1.15970003f,-0.03800000f,1.09210001f,0.22789999f,-0.15270000f,-0.40110003f,0.83650003f,0.40120003f,0.31799999f,-0.39500000f,-0.70210001f,-1.01630000f,-0.14629999f,0.32870003f,0.50479997f,0.30069998f,-0.97040001f,0.67270001f,0.62249999f,-1.02970003f,0.87609999f,-0.85560002f,0.28639999f,1.03160002f,0.02529996f,0.59180006f,0.51179999f,0.11720005f,1.43850002f,-0.49450003f,-0.12419998f,0.26669999f,-0.03179997f,0.46710002f,0.51690002f,-0.95800000f,-0.51530000f,0.00700000f,0.01089998f,1.62039997f,0.48419997f,-0.07340001f,0.16950004f,-1.98259995f,1.38300005f,-0.83730004f,1.14480000f,-0.28740005f,0.00210001f,0.19340001f,-0.61160000f,0.18670001f,-0.06320000f,0.52720000f,-0.38720000f,0.23010001f,-0.20380000f,-0.13259998f,-0.03700000f,0.65840000f,-0.81430000f,-1.48340001f,0.96359999f,0.72270002f,-0.26129999f,0.51120001f,0.28719999f,-0.65040002f,-0.03220002f,-0.01149999f,-0.19670000f,-0.58780001f,0.18270000f,-0.92590002f,0.10100001f,0.01809998f,-0.59160000f,-0.60740005f,1.20610003f,0.75210002f,0.77520000f,-0.92180000f,-0.48070004f,0.12340003f,-0.54750003f,0.95350004f,0.49000001f,-0.43959999f,0.49539999f,0.26469998f,0.12879998f,-1.09209997f,-0.31329995f,1.12409997f,-0.11270006f,0.35430002f,-0.40690000f,2.12049996f,-1.55699995f,-1.65120001f,-0.59279994f,-0.14390001f,1.57419999f,0.02270000f,2.32140001f,-0.96180000f,-1.52599999f,0.75649999f,0.29299999f,0.26840000f,0.67749999f,-0.10259998f,1.01440004f,0.05810000f,-1.99770003f,0.72350004f,1.31840001f,-0.60179999f,-0.26310000f,-0.38520002f,1.21180000f,-0.85280004f,-0.04769997f,0.82000001f,-0.54500001f,0.99560001f,-0.32269999f,0.27930001f,-1.00159999f,0.06209998f,-1.24310004f,0.58870007f,0.02149996f,-0.89540003f,1.18650003f,-0.43320002f,-0.15070001f,-1.11760000f,1.02509998f,1.12219996f,-0.02950000f,-0.45329999f,1.06429999f,-0.63159997f,-0.05039999f,-0.86759995f,0.20400000f,0.88090000f,-0.88919999f,-1.62389998f,-0.31810003f,1.11110000f,-0.12590001f,0.65369998f,-0.03050000f,0.59990001f,0.48330001f,-0.89030004f,0.60580001f,-0.34209999f,0.11720000f,-0.60950002f,-0.38920000f,0.32280001f,-0.72350004f,0.11220001f,0.06849998f,-1.43580001f,1.41670001f,0.68049998f,0.03430002f,-0.54100001f,0.27079996f,-1.24739999f,0.63150001f,-1.13739999f,-0.03169999f,0.62540000f,-0.67200000f,1.52800004f,-1.29700006f,1.54060005f,-0.47450004f,0.22520002f,1.62730003f,0.02020001f,0.51990001f,-0.76660001f,0.48999999f,-0.40450008f,1.17820000f,-0.52700001f,-0.85899994f,-0.31499997f,-0.52289999f,-0.33920002f,-0.24980002f,-0.08309998f,0.68969997f,0.91090000f,1.09689996f,0.61189996f,-0.34579995f,0.22710000f,-1.48179993f,-0.07370000f,0.28850002f,0.08730000f,0.34690000f,0.56919998f,-1.42700003f,1.38489999f,0.13090001f,0.47979998f,-0.69800001f,0.35720000f,0.28840000f,-0.00170002f,-0.24830000f,0.18370000f,0.05340000f,0.07570000f,-0.12190000f,-0.73990003f,-0.13009999f,-0.63760005f,-0.47419999f,0.68470000f,-0.20809995f,0.17439998f,-0.39569998f,-0.28740000f,0.52710003f,-0.67640002f,0.81360002f,0.17340000f,-0.18749998f,0.23550000f,-0.61650001f,0.19979999f,-0.74500004f,0.74110000f,-0.69760005f,1.60469996f,-0.61720005f,0.58540001f,-0.28330000f,-0.29359998f,-0.71629999f,-0.11359999f,-0.51509998f,1.19469995f,0.08839999f,0.84679998f,-0.18860000f,-0.59469998f,0.13280000f,-1.00700004f,0.60250003f,-0.42800000f,-0.01360001f,1.46320006f,-0.62460005f,-2.24920001f,1.48360000f,1.85830001f,-0.36629998f,-0.76760000f,0.90149999f,-0.95610004f,0.69370001f,0.44130003f,-0.65980004f,-0.59390003f,0.88270008f,-0.33550003f,-0.43179996f,1.60110003f,-1.41360005f,0.42689997f,1.19290003f,0.56199999f,-0.14800004f,-1.29699999f,0.40079999f,-0.76330002f,0.25600002f,0.89250005f,-0.47430004f,0.34880001f,0.13280000f,0.47940003f,-1.61240002f,-0.65629995f,-1.03840002f,0.77310004f,1.81889991f,-0.45660003f,0.35439998f,0.57089993f,-0.37849994f,-0.27340002f,0.06090002f,-1.22540002f,-0.25849999f,0.63060003f,0.38349999f,-0.06620000f,0.87000003f,-0.59410003f,0.34570000f,0.28269999f,-0.12800000f,0.16629999f,0.35220004f,0.74469999f,-0.79370003f,0.49810001f,0.82090000f,-0.26639999f,0.39400001f,-0.41500001f,-0.23940000f,-0.45330002f,1.01870000f,-0.89930002f,0.88759998f,-0.46130001f,0.09880000f,0.01819998f,-1.07469999f,0.10969997f,-0.66529999f,0.65170002f,-0.39530001f,0.06950001f,-0.90800002f,-0.86060004f,0.03680002f,-0.56550003f,0.20210001f,-0.88439998f,0.71650001f,0.80219996f,-1.23029999f,1.43799994f,0.31139995f,0.52499996f,-1.16100000f,0.43440005f,-0.12780004f,0.52210002f,-0.32779999f,-0.49819999f,-1.55900002f,0.66780000f,0.02859999f,0.94949998f,-0.00870000f,-0.05749999f,0.61280002f,-0.67770003f,0.48220004f,-0.25099999f,0.04109999f,0.55380000f,0.46470003f,-0.68110003f,0.45160000f,0.52290003f,-0.62710004f,-0.62550004f,0.13940000f,0.83830002f,-0.90360002f,-0.54180001f,0.62080001f,-0.96980004f,0.48220005f,-0.37790002f,0.74730003f,0.02909996f,1.24040004f,-1.28420003f,0.31280002f,0.23810005f,-0.57300004f,0.64720002f,0.37330000f,0.55060004f,-0.34470003f,-0.37659998f,0.40860000f,0.15999999f,0.42510001f,-0.71050003f,-1.10929998f,1.83480004f,-0.30150001f,1.39369996f,-1.31780000f,-1.23169999f,-1.51679995f,0.85690003f,0.78519999f,-0.47460002f,-0.07020000f,0.74900002f,-0.39569997f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.29970000f,0.66869999f,0.19040002f,0.95280001f,-1.13429999f,0.77090001f,-0.44390000f,0.50020000f,-0.29899999f,-0.40720001f,-0.37790001f,-1.50190005f,0.57409999f,-1.37670003f,1.47750002f,-0.39199999f,0.67840002f,0.42989998f,-0.46539996f,-0.51439998f,-1.36709997f,1.12709999f,0.06530004f,0.08840002f,0.81740001f,-0.38199998f,1.24679998f,0.46439998f,1.10249998f,0.16239999f,0.23969996f,-0.98870004f,-0.87730004f,-0.45909999f,0.11020001f,-0.74800001f,0.73950002f,0.60099998f,-0.99910001f,-0.78240001f,0.32229999f,-0.72330004f,-1.45960006f,-0.24200002f,-0.55880002f,-0.52290001f,-0.20550001f,0.51930005f,2.08220008f,-0.54970000f,0.23920000f,-0.14360001f,-0.41670004f,1.23210004f,-0.44970002f,0.14159998f,-0.52050002f,1.39210002f,-1.20130005f,1.00130003f,-0.80610003f,0.56140003f,0.81950005f,-1.64010002f,1.00720003f,-0.66010003f,0.39750001f,-0.81630005f,0.33730000f,0.44560003f,-0.85590002f,-0.98890001f,0.43549998f,-0.32100003f,-0.84789999f,0.71689997f,-0.41380002f,1.02890000f,-1.03060003f,-1.56210002f,1.31890001f,0.71590007f,-0.07949999f,-0.59250001f,1.09360004f,0.36000002f,-0.42340004f,-2.27260002f,0.15029999f,0.35620005f,0.04880000f,0.59740001f,-1.16679999f,0.30299997f,-0.01429998f,0.38340004f,0.54430002f,0.95970004f,-0.73790003f,-1.09809998f,0.24439997f,-0.63949999f,0.72010001f,-0.93620000f,0.05989996f,-0.24359997f,0.86130002f,0.21849997f,-0.29210001f,-0.29230002f,0.39940000f,0.86520003f,-1.37179998f,0.30449998f,0.10309997f,-0.98520000f,1.34290001f,-0.52329999f,0.64990001f,-0.72980001f,-0.79140008f,0.96870000f,0.23110000f,-1.37749999f,-0.30089997f,0.46210000f,-0.05900005f,-0.15189999f,-1.48939997f,0.78609998f,0.00679998f,0.61700001f,-0.33010006f,-0.52740000f,0.26739998f,-0.83549999f,0.05999999f,0.00089998f,-1.35930004f,0.47930001f,-0.14660000f,-1.01290003f,0.27769997f,1.22620003f,-0.45379998f,0.84340003f,0.47670005f,-0.01139997f,0.62320002f,1.04380001f,0.76770007f,-0.50710000f,0.42730002f,0.19450000f,-0.51160002f,-0.24590000f,-0.03020000f,0.06090002f,0.14910002f,-0.19460001f,0.21540001f,-0.88150002f,0.15100002f,0.43039995f,0.52140003f,0.35660002f,0.15520001f,0.83400000f,-0.13939998f,0.93699999f,-0.36799999f,0.46420000f,0.47389999f,0.02250002f,-0.36930003f,0.48769996f,-0.08339996f,0.32180007f,0.61529997f,-0.89710001f,0.14080001f,-2.07870002f,-0.03269996f,-0.33720000f,-0.29110003f,-0.58030000f,-0.78109996f,1.06759998f,0.53020005f,1.66379998f,-0.08709997f,0.96229999f,0.53240004f,0.87670000f,0.89410001f,-0.49280001f,-0.05060006f,-1.70250002f,0.77310000f,0.19500002f,-0.16409999f,0.72290001f,0.25860001f,0.50040001f,-1.20189997f,1.17669998f,-1.16660001f,1.17400004f,-1.21120001f,0.85680000f,-0.62409998f,-0.75390005f,1.15560002f,-1.14400003f,1.45730004f,-0.07269998f,0.75379999f,0.57630002f,-0.16380000f,0.19809999f,0.09160002f,0.29180001f,0.13070007f,0.87960000f,-1.36320000f,0.84120002f,-0.11339995f,0.57060000f,1.00470001f,-0.42770004f,-0.58630002f,-0.68250003f,-0.42390000f,-0.96209999f,-0.94240001f,0.24350004f,0.27350001f,-0.15300001f,0.23029997f,0.39960002f,1.03969995f,0.80350000f,0.44509999f,-0.85850001f,1.33060000f,0.45140004f,0.90940000f,0.78550004f,0.80190000f,0.93750000f,0.03190002f,-1.06950003f,0.62239998f,0.46510002f,0.43069999f,-0.92299997f,0.81259997f,-0.32049994f,-0.00210003f,0.20650002f,0.87660001f,-0.88239998f,1.57690003f,-2.13400005f,0.80780001f,-0.19040000f,-0.55440003f,1.34350002f,0.39560002f,-0.18119996f,0.63649999f,-1.22880004f,0.60940000f,0.16860003f,0.08779999f,0.92270001f,-0.34710003f,-0.89889996f,0.01980001f,-1.45279996f,2.03270001f,-0.53219997f,0.35660003f,0.94660000f,-0.87010003f,-0.76790000f,-0.73379998f,0.52480002f,1.17690001f,-0.35380002f,0.49730001f,0.22380001f,-0.66740000f,0.55000003f,-1.12000001f,0.53379996f,0.41570006f,1.10300001f,-0.19190001f,-0.59190001f,0.32690001f,-0.76140004f,-0.10160001f,0.23859998f,0.33959999f,-0.90059999f,0.11430000f,0.09490000f,0.14500001f,-0.53510002f,0.91209999f,0.91550004f,-1.62389999f,0.99429998f,-1.38580001f,-0.61470002f,0.74940000f,-0.02340001f,0.01490005f,-0.29450002f,0.77260004f,-0.38960000f,-0.06179999f,0.09150000f,-0.24559999f,-0.25500002f,0.93719999f,-0.63019999f,-1.58660001f,0.55580004f,0.11740006f,1.55219997f,0.26459998f,-0.14430001f,-0.94360000f,-0.10480001f,1.30829995f,-0.71060001f,0.38900000f,-0.13060002f,-0.89850001f,0.09490000f,0.22860003f,-0.55270001f,-0.58550000f,-0.49880005f,-1.34740002f,0.40379999f,-0.03180001f,-0.34209998f,0.86029997f,0.20429999f,0.85340000f,-1.07319999f,-0.20380004f,0.88240002f,-0.32649996f,0.46849999f,-0.36769999f,1.03860002f,-0.58680002f,0.50770000f,-1.11350002f,0.89110001f,0.22060000f,-0.56029998f,0.72459999f,-0.68720000f,0.33619999f,-0.17509999f,0.19800003f,-0.54910003f,-0.03899998f,-0.30050001f,0.21649999f,0.06260000f,-1.16740000f,0.26729997f,0.04580000f,0.92679996f,-0.67240001f,-0.42229996f,-0.10140001f,-0.64189998f,0.79910000f,0.18240004f,-0.13100001f,-0.27460005f,0.58810003f,0.97890004f,-0.02910001f,0.35599998f,-1.22260000f,0.51480002f,-0.33669999f,0.51219997f,-0.70680003f,0.69950001f,-0.78560001f,-0.43739996f,0.00739999f,-0.85240001f,1.45180003f,-0.73650001f,1.18990007f,-0.49640004f,0.40650000f,0.04540001f,0.85969998f,-0.74510000f,0.84950000f,-0.11220002f,-0.45410004f,-1.24780001f,-0.21370002f,-0.96780000f,-0.39619997f,0.85280001f,-1.02879997f,1.62120008f,-0.25349998f,1.00700001f,1.23280003f,0.70380000f,0.05570000f,0.26420000f,0.18270003f,0.02619995f,-0.04080000f,-0.64900002f,-0.16999999f,-0.05090004f,-1.00610005f,-1.21510003f,0.77499999f,-1.43760001f,-0.66170001f,0.73810001f,1.62840005f,1.01670003f,-0.42980001f,0.65539999f,0.30280000f,-1.16290005f,0.90290002f,0.81800007f,-0.33520007f,-0.71820001f,1.04650001f,0.69710003f,0.02270001f,1.06120008f,-1.76650002f,0.81510004f,-0.82860003f,-1.46650007f,-0.18219998f,-0.45100002f,0.07209998f,1.30720000f,0.51780000f,0.54220003f,1.12590005f,1.61210002f,0.79480001f,0.67670002f,1.22820005f,-0.64040002f,0.06850000f,-0.13009998f,0.06699998f,-1.00660004f,-1.40460004f,0.59250004f,0.72880004f,-0.01049999f,-0.70010001f,-1.72870001f,-0.95810000f,0.92750003f,-0.50539996f,0.56739999f,0.28859998f,-0.07720001f,-0.05910005f,0.43430005f,0.58830000f,0.27470000f,0.84480000f,-1.17289997f,-0.67120001f,0.16009999f,-0.84479997f,-0.60600000f,1.37860006f,-0.06890008f,0.30359998f,-0.47319997f,-0.58970001f,-0.19319999f,-0.44489996f,-0.11090001f,0.66020000f,-1.25490000f,-1.75360006f,1.47920001f,0.33619998f,0.94389999f,0.86630001f,-0.45569999f,0.46950006f,2.07040004f,-0.13280001f,-0.76560004f,0.28580002f,0.49950005f,1.19360003f,0.96620001f,0.09920003f,-0.32190002f,0.09520006f,0.47790005f,1.71490004f,1.25479999f,-0.10300000f,-0.24280000f,-0.09880001f,-0.27649999f,-0.77630005f,-0.76429999f,0.40560002f,-0.31370000f,-0.50730003f,0.32170001f,0.46160001f,-0.27779997f,0.37840004f,0.45530000f,-0.32679998f,1.06349999f,0.39010004f,0.60710001f,-0.05889998f,0.19020000f,-0.36599999f,0.95610003f,-0.51610000f,0.52610004f,-0.45740002f,-0.25020001f,0.04010002f,0.66010001f,-0.85610002f,-0.78490001f,1.13149997f,-0.49510006f,1.48500006f,-1.26790005f,1.84450001f,-0.40310004f,0.79680002f,-0.78449999f,0.59950004f,-0.72910003f,-0.51240003f,0.12130000f,-0.26040001f,-1.66070005f,-0.49920002f,0.35230000f,0.31129998f,2.05190002f,-0.02210002f,0.85350002f,-0.22720005f,1.80349998f,0.09979997f,0.27109999f,1.04829999f,0.80700000f,1.40619997f,-0.00099999f,1.37979999f,-0.08160000f,1.20420000f,-0.02470000f,-0.62310002f,-1.12110000f,-1.08420003f,0.72600003f,-0.22180000f,-0.21020000f,0.97830000f,0.24460000f,0.31480000f,-0.68679998f,-1.51040001f,0.37589999f,-0.36889999f,0.15759999f,-1.02210007f,1.14500005f,-0.50120000f,1.14660000f,1.08430003f,0.75439997f,0.25630003f,0.15579997f,-0.67520005f,0.92590003f,-0.54760002f,0.46490002f,-0.67930004f,-0.84229999f,0.51630000f,-0.64670003f,-0.26690002f,-0.86960000f,-0.16030000f,0.40260003f,1.13230002f,1.03010001f,0.19809995f,-0.69380003f,0.95500000f,-0.20649999f,0.09630001f,-0.44750001f,0.12890000f,0.87479998f,-0.03360002f,1.18039995f,0.83259998f,-0.13320001f,0.81350001f,0.79459997f,-0.21409998f,1.84819999f,-0.29209999f,1.31910000f,0.31020000f,-0.37900000f,0.31110001f,0.24179998f,0.11509998f,0.65380001f,0.14540001f,-1.08670003f,1.27820004f,-0.47699998f,0.03400001f,-0.11369998f,-1.16150000f,-0.68460000f,0.36769994f,-1.10360007f,1.89300003f,-0.74120003f,1.32250002f,0.59130002f,-1.02650000f,-0.64650001f,-0.05410002f,-0.28330001f,-1.25839997f,-0.57590001f,-0.57379998f,0.69370000f,-0.60200002f,-0.36970000f,-0.42380001f,0.07229998f,-0.92150000f,0.15579999f,-0.16549999f,1.12000001f,-0.77400003f,-1.21050001f,-0.23889996f,-0.07919999f,-0.09130001f,0.48840001f,0.00770000f,0.46760001f,-0.34070001f,0.41319997f,0.51609999f,0.20170002f,1.31819998f,-0.58570001f,-0.41240002f,-0.43250000f,-0.18870002f,-0.13660002f,-0.07220000f,0.04619999f,-0.84719997f,0.29600001f,0.02020001f,-0.01040000f,-0.93000003f,0.12020001f,1.08420006f,-2.24719999f,-1.47270004f,0.54520000f,-0.11430000f,0.68770000f,1.06510003f,-0.04919999f,-0.73380002f,0.89570004f,1.07260002f,-0.94799999f,-0.04990001f,-0.33370002f,0.67050000f,0.70580001f,0.62970004f,-0.33220000f,-1.01510000f,-0.05669999f,0.52100003f,0.80630002f,0.18420000f,-0.25889999f,-0.27489999f,-0.41529999f,-0.64350000f,-0.04380001f,-0.26940000f,-0.34450000f,0.62150002f,-0.44040000f,-0.65080000f,-0.40570001f,-0.59150002f,-1.34739999f,0.85399998f,-0.33790000f,-0.22409999f,1.14139995f,0.84289999f,0.28389999f,-1.07930001f,0.44589999f,0.40770000f,-0.44079994f,0.83699999f,0.04950000f,0.02560001f,-0.05890002f,0.34350000f,0.95550003f,-0.46940000f,0.99420005f,-1.53610000f,-0.94870000f,0.66979998f,-0.50690000f,-0.27659999f,0.04860003f,0.15129996f,0.41449997f,-0.56659997f,0.53099998f,-0.26670003f,0.62200001f,1.01580003f,-0.07529997f,0.70520002f,-0.76720001f,-0.53410000f,0.27040000f,0.04640001f,-0.02730000f,-0.45269999f,0.53149999f,0.32419998f,-1.56500004f,-0.70410002f,-0.18310000f,-0.19010000f,-0.55100000f,-0.17400005f,-1.21520000f,0.87829998f,-0.68440000f,-0.02579998f,-0.48490001f,-0.09570000f,-1.33400000f,0.68129994f,-1.16389998f,1.67950000f,0.91650006f,-0.44650001f,0.82640001f,-0.50880003f,-0.29809997f,1.56230001f,0.23809998f,0.37219995f,-0.29699999f,0.52739996f,-0.27769999f,1.26999999f,-0.03590003f,0.67339994f,0.30410001f,0.02839998f,-1.33850001f,-1.85889999f,-0.16259996f,0.09040004f,0.62080002f,-0.82560000f,1.00110000f,-0.30679992f,-0.60130002f,0.19350001f,-0.18829999f,0.97110005f,-0.62560001f,-0.91789998f,-0.65440001f,0.74930002f,-0.22669998f,1.42620001f,1.17700002f,-0.20330000f,0.47980003f,1.09520003f,0.28979998f,-0.66889999f,0.91149999f,0.37370003f,-0.20590001f,-0.27750001f,0.78739998f,-0.64479999f,0.12169996f,0.97930005f,-1.10150000f,1.15410002f,-1.29180002f,0.83140004f,-1.38910005f,0.33260001f,0.48340000f,0.07290001f,0.80980000f,-0.84410002f,-1.86190004f,0.29370003f,1.27620001f,-0.61690000f,-0.46800003f,0.24880001f,-1.61750001f,0.39980003f,0.50610003f,0.74850003f,-0.56489998f,1.22030001f,0.49900003f,-0.60559999f,1.66960002f,-0.59600001f,0.99029997f,0.16120000f,0.58149997f,-0.78380001f,1.13519998f,0.91230001f,-0.29599999f,-1.44879997f,1.22760002f,0.33989999f,0.50990001f,0.37020005f,1.63780002f,-0.69420002f,0.46470002f,-1.12899998f,1.00649998f,-1.81700003f,0.81420000f,-1.44160001f,0.76519999f,-1.06109999f,-0.09430001f,-0.52030007f,0.38440003f,-0.02549999f,1.10069999f,-1.80300000f,0.68580000f,-0.00850003f,0.22880001f,-0.05270001f,-0.13959999f,0.48890004f,1.50010002f,-0.04369997f,0.69000001f,0.44790002f,0.53440001f,0.43440000f,0.84010000f,-0.83720000f,-0.53229996f,-1.16939994f,1.75669997f,-0.40259998f,-0.02489998f,-0.76850003f,0.34850003f,0.39140003f,-0.27470004f,-0.98180000f,0.19189999f,-1.34189999f,0.35869999f,0.53689999f,0.78910002f,1.08629998f,0.19979999f,-1.01339996f,0.76009998f,-0.49899999f,-0.65420002f,1.25069998f,0.19460002f,0.84220001f,0.04510000f,-0.97900002f,1.03649997f,-1.12150000f,1.39710001f,0.93790000f,-0.51939993f,0.14929997f,0.83109997f,-0.83330000f,1.26630001f,-0.62130004f,1.33300002f,0.64790002f,0.18010004f,0.64990000f,-0.73900002f,-0.10010001f,0.23409995f,0.08990000f,-0.35990001f,-0.91910001f,-2.29519993f,0.18029999f,0.60289997f,-0.11889999f,-0.57119999f,-0.61720002f,-0.58659998f,-0.62940002f,-1.36680003f,-0.77589997f,0.21230001f,0.78560001f,0.82950000f,-0.17849996f,0.47700002f,1.05020001f,-1.33549996f,-0.31100001f,0.98620000f,0.33700003f,0.07189996f,0.78390000f,-0.23130005f,0.67709999f,-0.57520000f,-0.71310002f,0.15349999f,-0.29870002f,-0.96040000f,-0.74950000f,0.68350004f,-1.24360005f,-0.61190001f,0.22469998f,0.38990004f,0.26480003f,0.95259998f,-1.43369998f,-0.68070007f,1.35500005f,-0.37610002f,0.53290003f,-0.63640002f,1.23479998f,-0.50799999f,0.18610001f,-0.01869997f,0.52339999f,0.87220003f,0.67500003f,0.53009997f,-0.62970003f,-1.29259996f,-0.83479996f,1.78239999f,1.46350002f,-1.03720005f,-0.60269997f,-0.46180004f,0.39799995f,-0.62639997f,-0.31460001f,-0.16580001f,-1.28869998f,0.53479999f,-0.66530003f,0.20230000f,2.22450004f,-0.41559999f,-0.16500005f,-0.37940003f,-1.78500005f,0.07180000f,-0.47650002f,-0.74770000f,-0.61580001f,1.20830001f,-0.46859993f,-0.67210001f,-0.17209999f,0.75209998f,-0.09969997f,0.42480002f,1.17960001f,-0.57409995f,-0.18280004f,-0.29970006f,-1.09340002f,0.70230003f,-0.48410001f,0.31600001f,-0.02659996f,-0.55760002f,-0.39269999f,0.10899996f,-0.23849999f,0.44040001f,0.09809998f,-0.78020003f,-0.70359996f,0.17850007f,-0.49580002f,0.87249999f,0.98320002f,0.50269998f,-0.48940002f,0.91320000f,-0.67840001f,0.18489994f,0.36880002f,1.10780001f,-0.02060001f,-0.74220001f,-0.23749999f,-1.36779998f,0.15719997f,-1.18670002f,0.00870000f,0.47849999f,0.28760000f,-0.21449999f,0.10970002f,1.28739999f,-0.32469998f,1.17479999f,-0.01360000f,-0.52780002f,-1.01860006f,-0.73270000f,0.02840000f,-0.45710002f,0.76199997f,-0.86370000f,1.41550004f,-0.19700001f,0.52540004f,0.54580001f,-1.20970001f,0.65530000f,-0.12700000f,0.85220000f,-0.83829998f,-0.69830005f,0.50549997f,-0.75380000f,0.59920003f,0.07600000f,-0.80310004f,0.21269998f,-0.00880004f,-1.19889998f,1.15260001f,-1.17660002f,-0.97699996f,1.19559998f,-0.29089997f,-0.10929998f,-0.47769996f,0.35790000f,1.18029998f,0.37089999f,0.18229999f,-1.03120001f,0.05330000f,0.81150002f,-0.14809998f,-0.25060003f,-1.17030002f,0.24930000f,1.01959999f,0.66240004f,0.43369997f,0.57899997f,-0.74970002f,-0.54860003f,-0.40340001f,-0.39000000f,-0.34920002f,0.37020005f,1.02720001f,-0.21629999f,1.34460002f,0.71720000f,-0.54260000f,0.39570000f,0.92470001f,-0.43779994f,0.64279998f,-0.43510000f,-1.06440004f,1.70170002f,-0.95180002f,1.12570003f,0.05940000f,-0.71310002f,1.05850002f,-0.96299999f,0.63600000f,-0.05689999f,-0.35080002f,-1.02440006f,0.19160000f,-1.20129995f,-0.28290000f,-0.18609997f,0.90409998f,1.26559999f,-1.16360001f,0.80060000f,-1.38710002f,-0.69109999f,0.73860001f,-1.56659998f,0.69290000f,-0.25920000f,0.24760000f,-0.55019998f,0.24750001f,-1.16220000f,0.70590000f,-0.47480001f,1.56000003f,-1.54809998f,0.47850002f,-0.91770002f,1.15180003f,0.15549996f,1.03950000f,0.04690001f,0.09080000f,-0.20010000f,-1.71040007f,1.17840002f,-1.65840002f,0.44380000f,0.67810001f,1.77129999f,-0.63069996f,0.34880003f,-1.29339999f,0.22130000f,-0.83740000f,1.51250002f,0.04859998f,0.37729995f,1.05899998f,-0.82920007f,0.21389996f,-0.38640001f,0.30000001f,-0.29279998f,0.96410003f,-1.03599994f,-0.35500000f,0.60199999f,0.79030002f,-0.05839999f,-0.24289999f,-0.83889999f,0.11400002f,0.95240001f,0.14690000f,1.41550002f,-0.23430001f,0.69580004f,0.53640002f,0.61640001f,0.52799999f,0.25819997f,-0.36709998f,0.20060000f,0.14700000f,-1.36470005f,0.40550002f,0.84040003f,-0.98920004f,0.36650000f,-0.75790000f,-1.23240006f,0.28540001f,0.31950001f,0.10659997f,-1.16360006f,1.12180004f,-0.68880001f,-0.03730001f,1.42630005f,0.41519999f,0.23189998f,0.17789999f,0.80820002f,1.46260001f,0.48900004f,-0.59050003f,-0.69960001f,-1.10200001f,-1.17450002f,-0.77930002f,-0.16410005f,-0.97680003f,0.32539999f,0.91619999f,-0.07160002f,1.16939998f,0.64109999f,0.47579998f,0.22169999f,0.88539997f,0.49679998f,-0.34089998f,0.58460003f,0.49399998f,0.00359999f,1.16029998f,1.00910005f,1.01289996f,-0.34070000f,0.62440000f,-1.37840000f,-0.97960003f,-0.42000003f,0.20320005f,-1.27010004f,-0.80470002f,-0.44510001f,-0.05069996f,-0.52290005f,-0.28550002f,-0.78069997f,-0.27360001f,-0.26630002f,-1.45200000f,0.71789996f,-0.61230004f,0.55520002f,-0.80299998f,-0.17089993f,-1.08770000f,-0.77589996f,-0.45799999f,-0.48349997f,-1.09229999f,0.58210003f,1.35280000f,-0.02760004f,-0.27629995f,0.04210003f,0.39789998f,-0.43440001f,1.44260004f,0.57550002f,0.16070001f,0.00030000f,-0.89230002f,-0.65280000f,-0.23479999f,-1.32620000f,0.05890002f,1.03939995f,0.19669999f,0.83769997f,-0.49899997f,-0.75910000f,-0.01769998f,-0.46880004f,0.48400002f,0.84369996f,0.11040000f,0.91480000f,-0.22480001f,-0.22920000f,0.98279998f,1.13260003f,-0.05020002f,0.35090000f,0.33970000f,-2.10370001f,2.36699998f,0.57059998f,0.69600000f,0.02310000f,1.09999997f,-0.23619997f,0.10589999f,-1.07740004f,0.54470001f,0.76610004f,1.66800004f,0.73479998f,0.84679998f,0.85390000f,-0.79850001f,0.36719998f,-0.14679998f,1.38479997f,0.78979997f,0.83409999f,0.53010003f,1.68760001f,-0.83280001f,-0.13410000f,-0.24029998f,0.11290001f,0.59030001f,-0.12190000f,0.69620005f,-0.66539999f,-0.67129996f,1.06760001f,0.13840001f,-1.05930003f,1.36649998f,0.07509998f,-0.58510004f,0.37860003f,-0.66400003f,-0.24520001f,-0.21440002f,-0.28920000f,-0.79059999f,-0.73259999f,-0.39990003f,-0.29479999f,0.29659996f,0.65530000f,0.40120003f,-0.86989998f,-0.56780005f,1.11680003f,-0.50259999f,1.18810002f,0.82600005f,-0.33990004f,-0.83390001f,0.95320000f,1.12300003f,-0.81380001f,-0.93420001f,-0.52210003f,-1.13900000f,0.62340001f,0.51610000f,-1.30150004f,-0.27329999f,-0.03039996f,-0.49700002f,-0.40259999f,0.29349997f,0.11979999f,1.10410001f,0.89010003f,0.44090000f,0.54929999f,-0.21160000f,-0.64130000f,-0.19190002f,-0.32619998f,1.54290003f,1.19200000f,-0.68810004f,0.14939997f,-0.89260003f,-1.41150001f,0.37369999f,-0.91199999f,-0.81240000f,-0.11709997f,0.65970000f,-0.78199992f,-0.33769999f,-0.09580001f,0.98139996f,1.14580003f,0.05500002f,-1.14780005f,-0.22589996f,-0.88950000f,0.56389997f,1.47600005f,-0.57470001f,0.73300004f,-0.96440000f,0.64560001f,-0.53850000f,0.19729997f,-0.42799997f,0.20750000f,0.09250000f,0.08319999f,-0.75560000f,-0.31050002f,-1.88360004f,-0.00780000f,1.08450007f,-0.13870000f,0.70290000f,-0.97460003f,-0.27600001f,-0.41449999f,0.10339997f,-1.66560000f,-0.07410001f,0.97480002f,0.60489998f,0.05580000f,-0.60819998f,-0.69910003f,-0.90859998f,0.93419999f,-0.49620000f,-0.19459999f,0.43139999f,0.60730000f,0.90409998f,0.48770001f,0.95019997f,-0.49420002f,-0.45420002f,0.07040000f,-1.19370000f,-0.19970002f,-0.11680000f,1.15639997f,0.95489999f,0.67750005f,0.02710002f,-0.69159997f,0.42710002f,-0.49080004f,-0.99180001f,0.53540000f,-0.58220001f,-0.28380000f,-0.71250000f,0.74159998f,1.34490005f,-1.54150002f,0.41550003f,-0.69800004f,0.45440000f,-0.09180000f,-0.45700003f,-0.91590002f,-0.34829999f,0.18840000f,0.16189998f,-0.68660000f,0.43529999f,-0.56540000f,-0.18019998f,1.19750006f,0.48920002f,0.30109998f,-0.88510001f,0.35590003f,-0.23070000f,-0.61620001f,-0.87460001f,-0.50160002f,0.58010000f,0.91669998f,-0.64729998f,1.18619996f,-0.18970003f,-0.99810000f,0.61320000f,-1.34980002f,-0.08350001f,-0.11980002f,0.53030002f,1.16199998f,0.07300001f,1.22859998f,0.03100000f,0.85610005f,0.14899996f,0.00999999f,-0.01299996f,-1.17270002f,1.85359997f,-0.10860001f,1.09760003f,0.75250006f,-1.17970003f,0.58310004f,-1.01310004f,-0.35619999f,0.01530000f,-1.59800007f,1.31660004f,0.88570005f,1.13000002f,0.28969999f,-1.34260002f,-0.08030002f,-0.31749999f,0.08309998f,0.12640003f,0.40679997f,0.27599998f,0.02390000f,0.76610003f,0.16210001f,-0.48960001f,0.84350004f,-0.18530000f,0.36380001f,0.33849999f,0.65430002f,-0.21989996f,0.84130000f,-0.26639998f,1.25870001f,-1.11489996f,0.16839995f,-0.96870004f,-1.17350003f,0.49800004f,-0.38669999f,-0.13579999f,0.61180001f,-1.46230000f,0.27890000f,0.51000000f,0.17469998f,-1.55400001f,-0.11959998f,0.27940003f,0.01199999f,-0.14959993f,-0.16439999f,1.29370000f,1.25100002f,1.12779998f,-0.28100005f,0.90559998f,-0.61409999f,-0.77879995f,1.45219996f,0.22150000f,-0.54819998f,0.95129999f,-1.31830000f,-0.81690008f,0.45500002f,-0.88840003f,1.27530001f,0.85730003f,0.41620001f,0.50720000f,-0.09230001f,-1.04690001f,-0.16480002f,0.05210003f,-0.30390000f,0.34550003f,-0.27029999f,0.74160001f,0.01650001f,-0.34120004f,-0.46369999f,0.28510002f,-0.96059997f,0.85900001f,-0.55839998f,-0.41810004f,1.14399998f,-0.54990001f,0.65220001f,-0.72020001f,1.46450002f,0.33160003f,-0.43840000f,0.56710000f,-0.64170002f,-0.48479999f,0.18439998f,0.84589999f,-0.38060000f,0.41109997f,-0.08619993f,0.31019997f,0.74450001f,-0.57700000f,-1.30890004f,-0.02780001f,0.58479998f,-1.06980001f,-0.97740000f,-0.12419998f,-0.29770001f,0.84440001f,-0.03980006f,0.61300001f,-1.68950001f,0.12499998f,-1.39790000f,-0.01650002f,-0.25219996f,-1.19070001f,1.38490000f,-0.24069998f,-0.63780003f,0.07909999f,0.39170004f,0.54210002f,0.01730003f,-0.54640004f,-0.58190000f,0.08580002f,-1.01480005f,0.20440001f,-1.23260001f,1.36949999f,-0.53630000f,0.95960001f,0.52560000f,-0.23149997f,-0.12380002f,-0.66500006f,0.45990005f,-0.43509999f,-0.22810003f,0.30409996f,-0.63450000f,1.02710003f,-0.36029997f,1.34270002f,0.29259993f,0.02429995f,-0.75810001f,-0.59510000f,-0.66070002f,-0.53849996f,-0.41679999f,0.33549998f,1.30860001f,-0.71760001f,-0.38659999f,0.53780000f,0.69139999f,-0.60780004f,-0.94350000f,-0.39520004f,0.69480001f,-0.26920002f,0.22400001f,1.46949998f,-0.00549999f,0.48599997f,0.52190001f,-0.15630001f,-0.00720002f,0.41600000f,0.93310003f,-1.01350002f,0.78710001f,0.38090003f,-0.10220000f,0.80450000f,0.31250001f,0.47279999f,-0.88479995f,1.00979999f,-0.56479998f,0.60350000f,-0.61039999f,0.47950002f,-0.61140000f,-0.02209999f,0.22490000f,-0.01310000f,-0.73210004f,0.31560001f,0.26530001f,0.16230000f,0.58010001f,-0.21429999f,-0.71789995f,0.38709996f,-0.36139998f,0.25370000f,-0.11699999f,0.44060000f,-0.05600000f,0.38150000f,1.66230002f,-0.75689999f,0.00480003f,0.74820000f,-0.79769998f,-0.11100001f,-0.13620000f,-0.51829998f,-0.26429999f,-0.15159998f,1.22190004f,0.42830001f,0.19329999f,-1.06460006f,-1.51650002f,-0.63810004f,-2.03180005f,0.32010002f,0.31539999f,0.62609999f,0.97430001f,-0.25439999f,-0.10540002f,-0.46910001f,-0.08860001f,0.24029997f,0.89480003f,-0.11299995f,-0.30360004f,0.77839997f,-2.03320006f,2.29830004f,-0.50779997f,-0.59140002f,0.53310001f,-0.74919998f,0.45089998f,-0.61669999f,-0.03920002f,-0.24880003f,-0.19450000f,0.42690001f,0.25020000f,-1.87539996f,-0.24070001f,0.80529999f,0.19590000f,1.68079999f,-1.82300004f,-0.60880006f,0.24110002f,0.80640003f,0.09900002f,0.94820004f,-0.02820003f,-0.56770000f,0.86550000f,-0.52070001f,-0.29100000f,0.15299999f,0.18070001f,-0.47739997f,-1.13230001f,0.78640002f,0.73920000f,-1.49920003f,0.74680003f,1.78260003f,0.13240001f,0.88149999f,0.24569999f,-1.52869999f,0.10429997f,-1.87630004f,0.42960000f,0.26820002f,0.52730001f,0.17150002f,-0.68840000f,-0.02369999f,0.49040001f,0.00420000f,-0.86270000f,1.18900002f,-0.41439994f,0.62519999f,-0.49710002f,-1.44850004f,1.57490000f,-0.97510000f,1.00760003f,-0.09160000f,0.60900005f,-0.51130000f,-1.29700003f,0.76179997f,0.52619996f,-0.46739997f,-0.55090000f,0.99239998f,-0.52509994f,-0.58370001f,0.13279998f,0.81820002f,1.23229998f,-0.59270004f,-0.64980007f,-0.78789999f,0.45580000f,-0.78740003f,-0.67080003f,0.80080000f,-1.63410000f,-0.29910001f,-0.51589999f,-0.63370003f,-0.12950001f,0.18290002f,-0.35189998f,-1.03349998f,-0.53880000f,0.08589997f,-1.03219998f,-0.06149999f,0.34040004f,-0.31800000f,0.70230000f,0.50150000f,-1.08580002f,0.94959999f,-0.47119998f,0.96250003f,-0.51700001f,0.55560001f,-0.23579998f,-0.52050005f,-0.68580003f,0.28630001f,-0.68610001f,0.30450001f,0.26690002f,0.00579998f,0.23350000f,0.24529999f,-0.15640000f,0.42399998f,-0.30490003f,-0.52230001f,-0.88220000f,1.47649998f,-0.73629999f,0.69999997f,0.02550001f,0.48449998f,0.34990000f,-0.30190004f,-0.09920006f,-1.35769998f,0.20050001f,-0.36520001f,-0.08929998f,-0.18370004f,0.43380002f,1.86670003f,-1.19510001f,0.31650002f,-0.19760000f,-0.58859999f,-1.23100002f,-1.02220002f,-0.11580003f,0.04769998f,0.29200001f,-0.84420003f,-0.57510000f,0.54490000f,0.32610002f,0.55440001f,-0.84719997f,0.40550000f,0.51090002f,0.27010002f,-0.86840000f,-0.50700000f,-0.23980006f,-0.53630000f,-0.06899998f,0.14979998f,-0.87589999f,-0.28070002f,-0.44780005f,0.43950003f,-0.28799996f,0.56900000f,-0.88110001f,0.75270000f,1.33579998f,-1.02370001f,-0.01710001f,0.46080001f,1.19919996f,0.52580000f,0.20110001f,-0.16580000f,1.10820004f,0.09059998f,0.35069998f,0.94320001f,-0.70090001f,-0.46639999f,0.36400002f,0.86619999f,0.59939999f,0.35990001f,0.48000002f,-1.30670005f,1.13320004f,-0.57590001f,-0.99179998f,-0.92119998f,0.01989998f,1.34510005f,-0.87520001f,1.24150006f,-1.78429999f,0.64570000f,-0.36580002f,-1.07240003f,1.08490001f,0.70740000f,-0.88390002f,-0.32460002f,-1.30720002f,0.16639999f,-1.64280001f,-0.88280001f,0.58670008f,-0.70239999f,0.85990000f,-1.11060002f,-0.38790001f,-1.43520000f,-0.12490000f,0.06530000f,-0.69710000f,0.32009999f,-0.05790001f,-1.19900004f,-0.21600005f,-0.36730000f,-0.18659999f,0.51170001f,0.94810001f,0.45930000f,-0.10010003f,-0.70180000f,-0.47760003f,0.13300001f,-0.50920000f,0.63370003f,0.04270001f,-0.15780000f,0.93659999f,-0.90419997f,0.28440004f,-0.38570000f,1.45920006f,-0.94290001f,-0.72120005f,0.81860002f,-1.21270001f,1.16889999f,0.80650004f,0.33209998f,-0.51010002f,0.78040002f,0.64740002f,-1.23220001f,-0.98660004f,0.56130001f,0.33300003f,1.31370004f,-1.26640001f,-0.75640004f,-1.19530002f,-1.30650002f,0.47659997f,0.32710003f,1.43160001f,1.08000001f,0.73300000f,0.37419998f,0.63990000f,-0.21650002f,0.16700004f,0.23460002f,0.12870001f,-0.22760001f,-0.38640001f,-1.42750000f,-0.29130001f,-1.41120000f,0.25440001f,-0.55500000f,0.75070002f,0.59839995f,-0.88020001f,0.04529998f,0.72420002f,0.09010003f,-0.27530000f,0.20720001f,-0.22230000f,-0.68720001f,-0.38839996f,0.88390004f,-0.59170002f,0.94630005f,-0.04580002f,0.28890000f,0.01560002f,-0.45140000f,-0.78950000f,-0.23919998f,0.18549994f,0.74610001f,-1.10539999f,-1.25800006f,1.40660001f,0.78550003f,-0.14050000f,-1.46420002f,0.90270002f,0.14090001f,1.09990000f,0.86150000f,0.62219997f,1.16400000f,-0.29400001f,-0.28339999f,1.15660005f,-0.19119998f,-0.93930004f,-0.20839998f,0.95430005f,1.32310003f,0.42959999f,0.01719999f,-0.35990001f,0.23960001f,0.07209999f,0.43750000f,1.34129996f,-0.24870001f,0.79859998f,-0.47590000f,0.48300002f,0.28749998f,-0.10749996f,-0.20490001f,-0.40479999f,0.18350002f,0.51279999f,0.17050001f,0.51239999f,0.04280002f,0.96590004f,-0.84520000f,-1.18590002f,0.78390001f,-0.45450001f,0.47800000f,0.18890000f,0.44569999f,-0.37340004f,0.01760003f,0.95760005f,-0.58680004f,-0.37080002f,0.99590000f,-0.86130003f,0.97590002f,-0.79750001f,-0.71070001f,-0.11529999f,-1.00319999f,0.08569999f,-0.57350000f,-0.67600002f,-0.90250003f,-0.96280004f,-1.13010002f,-1.25510005f,-0.02729999f,0.03409999f,-0.43580002f,0.96759999f,-0.32300001f,0.29799999f,-0.07409999f,0.34870005f,1.19309998f,-0.38950003f,0.28059999f,-0.40670000f,-2.22910002f,-1.04050001f,-1.15249999f,0.09559998f,0.37230004f,1.38919999f,0.10910000f,-0.30760000f,0.18589996f,-0.20919999f,-0.08180002f,0.54060000f,-0.38670004f,0.56590003f,-1.53110004f,1.96340002f,0.83940002f,-0.41420001f,2.57200012f,-1.85730008f,-0.01300005f,-0.21239994f,-0.44069999f,-0.97200000f,-0.36469998f,0.20059996f,0.12600001f,0.13249999f,1.46280000f,-0.75600006f,0.41630000f,0.63160004f,0.96969998f,1.32440000f,-0.42520001f,0.44249999f,-1.80400003f,-1.30609999f,-1.33409999f,-0.90249998f,0.47500001f,1.21070004f,0.87130001f,0.37639999f,0.06330000f,-0.52270001f,-0.01779997f,-0.04569999f,-0.20790000f,0.40100001f,-0.90040003f,-0.31249998f,1.29730005f,1.16599999f,-0.22800002f,1.13439999f,-0.77359999f,-1.38900000f,-0.85250003f,-1.28679999f,0.40140001f,-0.11519999f,-0.37919997f,0.82120004f,-0.78740003f,-1.00450007f,0.63560006f,1.37300003f,-0.35010001f,-0.63520003f,0.14900003f,-1.45090005f,1.27320001f,0.22779999f,0.86639999f,1.88130006f,-0.19309999f,-0.18340002f,0.37320004f,0.15510006f,0.57550000f,0.70610005f,0.08210000f,-0.77639998f,0.11430002f,-0.52960003f,-2.12350004f,0.19700003f,-0.08659995f,0.14010000f,1.18040002f,0.41370002f,0.41170001f,-0.35460001f,-0.70380003f,0.12540000f,-0.49630000f,-0.40140001f,-1.33899998f,-0.38819998f,-0.43470000f,-0.10260002f,-0.57269999f,0.89249999f,-0.91469995f,-0.59240002f,-0.52050001f,0.11880001f,-1.07580000f,0.07060003f,0.46219999f,-0.03129999f,0.60799998f,0.31560001f,0.94560004f,0.12929998f,0.60570000f,0.32470002f,-0.06700001f,-0.21139998f,0.90910005f,-2.02750002f,-0.18690004f,-0.15579994f,1.11460006f,-1.03650003f,-0.15190002f,0.30899999f,-0.81150003f,0.81070000f,-0.48870003f,0.79379999f,0.77119998f,0.07259996f,-0.21990001f,-0.12919999f,-1.16680001f,0.05289999f,0.18890004f,1.61000005f,-0.02129993f,0.91699999f,0.79510001f,0.36659998f,0.95680001f,0.02900000f,0.23980000f,0.81919998f,1.46060001f,0.55010002f,0.00260000f,0.16980002f,-0.09090002f,-0.68549996f,-0.72520001f,-0.81459999f,0.59069999f,-0.37770000f,-0.43990003f,-0.37090000f,0.35140001f,0.28780000f,0.11640000f,0.67980001f,0.50300001f,-1.63260004f,0.53870006f,0.14249998f,-1.24229998f,0.03770001f,-0.71920002f,1.24400001f,-1.23149999f,0.53380004f,-1.68760003f,0.21530004f,-0.19350005f,0.46290001f,-0.79089997f,-0.75100003f,0.19920001f,-0.40809999f,-1.38460002f,0.52390003f,0.31020000f,-1.00099997f,0.91520001f,-0.04249999f,0.54209999f,-1.68390001f,-0.62219998f,-1.03860000f,0.89710006f,0.29300001f,-0.76400004f,-0.77679999f,-0.24089999f,0.00900001f,0.03209999f,-0.38280000f,0.74569998f,-0.87550003f,1.52980005f,-0.84730003f,0.47160004f,-1.40210005f,0.45580001f,-0.26769999f,0.40430007f,-0.62410002f,0.08749991f,-0.75109997f,1.58760003f,0.05130001f,-0.23280001f,0.21779998f,-0.39760002f,-0.07249997f,1.26940000f,-1.52400001f,1.05479996f,-0.59990001f,1.13949999f,0.35969994f,0.01360001f,-1.29740001f,1.08479996f,0.90930001f,-0.14370002f,-1.75350000f,-0.41520000f,0.38450001f,1.05640002f,0.57760003f,0.08369999f,-0.64750000f,0.51080000f,-0.57530003f,-0.40800000f,0.69050000f,-0.68129998f,-1.03409997f,2.15010003f,0.02150002f,0.83390000f,-0.50940002f,-0.13290003f,0.43730001f,-0.13070002f,-0.40839999f,0.47639999f,-1.06790005f,-0.12330002f,0.73410003f,-0.67460001f,0.56169999f,-0.20189998f,-0.18000005f,1.29470004f,-0.61669997f,0.67389999f,-0.99500004f,0.03149999f,-0.22839997f,0.11449998f,-0.48520000f,-0.32980000f,-0.69899998f,1.43140001f,-0.35810001f,-0.43300001f,0.83519999f,-0.41520001f,-0.83910001f,0.42660000f,-1.64969996f,-0.16929997f,0.39460001f,1.20950001f,0.10290002f,-0.10330000f,0.49060001f,0.34749998f,-0.06520000f,0.13350000f,0.03710002f,-0.68360002f,-0.76490002f,1.50910003f,0.50480000f,0.31120001f,0.94470003f,-1.34680003f,0.27169997f,-0.03230000f,-1.57840004f,1.39300004f,1.12510001f,-0.11319999f,0.87370001f,-0.16660000f,-0.70790002f,1.37009999f,-0.24860000f,0.20090005f,0.55009999f,-0.31570000f,0.08929996f,0.99090006f,-0.90620004f,1.60000002f,0.12150001f,-1.08559998f,0.73399999f,0.04260003f,0.24270000f,0.44310002f,0.30919999f,0.64129998f,-0.67790001f,-1.05949999f,-0.25570000f,-0.53830001f,0.37459999f,-0.95549997f,-0.31160003f,0.66579993f,-1.20970000f,-1.67080000f,1.09559999f,-0.13949996f,-0.18280003f,-0.14700000f,-0.36230000f,-0.58610001f,-0.20040002f,0.02990001f,-0.36400003f,-0.87380004f,0.80860000f,0.39090001f,-0.22180002f,-2.09980002f,-0.46850005f,-0.32859994f,0.15659998f,-1.71860004f,-0.13120004f,-1.38000006f,0.34250000f,-0.41150001f,0.45030000f,-0.66870003f,0.99830002f,0.08269999f,-0.57170000f,-0.40810003f,1.08650000f,-1.57150002f,1.71889998f,-0.96779999f,1.66790006f,-0.91610004f,0.37449996f,-1.14800003f,1.57690005f,-0.34110001f,0.43280002f,0.00599999f,0.64130002f,-1.02500002f,-1.45130001f,0.90630000f,0.84560000f,-0.75810001f,-0.31070011f,-0.17650000f,0.39329999f,-2.08850003f,0.14269999f,0.74710000f,0.18929996f,-1.29720001f,0.37500001f,-0.62130002f,-0.49009998f,-0.58660002f,-0.78280005f,0.99910002f,0.66170000f,-0.11419998f,0.60590000f,-0.60830002f,-0.51880000f,-0.32780001f,-0.71810002f,0.86410002f,0.02610002f,-1.25920003f,-0.28520003f,0.37790000f,-0.84379999f,0.64399998f,-0.12829999f,0.16950002f,0.68050001f,-0.51659998f,0.10749999f,0.06929999f,-0.74570001f,0.38449999f,0.23660002f,-1.08090000f,-0.13240003f,0.27729998f,-0.64890000f,0.94640002f,-0.17320000f,-0.59670001f,-0.10360002f,-0.96050003f,-0.15829997f,0.28180004f,-0.11570002f,0.81810001f,-0.08479999f,1.22049997f,-0.40680000f,-0.87360000f,0.71840000f,0.57380003f,0.26569998f,0.38259994f,-1.05689997f,0.43960001f,0.43159998f,-0.49310000f,-0.60450002f,0.09560001f,0.00709999f,-0.27849999f,-0.31330001f,-0.37630003f,1.23550002f,-0.49239999f,-0.05840002f,0.77430002f,-0.18919995f,2.40640000f,0.65440004f,1.37970000f,-0.10629999f,1.41610003f,0.47389999f,-0.34120000f,1.07840005f,-0.34960001f,0.35840000f,0.20230002f,-0.42339999f,-0.36960002f,0.47409998f,0.50680004f,0.07070003f,1.64030000f,-1.44419998f,1.59720001f,-1.82940002f,0.60070001f,0.13600000f,0.18619999f,-0.58180003f,-0.86050002f,0.41169999f,-0.22150000f,-0.59210001f,0.17640001f,0.84860000f,0.07439998f,-1.28180001f,-0.72979999f,-0.59729991f,0.67160002f,-1.47739999f,1.70069999f,-0.14320000f,0.00670002f,0.16270001f,0.19129999f,-0.35399998f,0.41440002f,0.41230002f,0.16730002f,-0.11270000f,-0.83490004f,0.41640002f,1.03420005f,-0.32300001f,0.17070000f,0.73490003f,-0.97300003f,-0.38700002f,0.36609999f,-0.75520000f,0.39720001f,-0.23300000f,0.33589998f,0.02590000f,0.83919999f,-0.57210003f,1.57900003f,-0.18859998f,0.92590005f,0.22999999f,-0.54710003f,-0.07390002f,1.05810005f,-0.51910001f,0.75140000f,-0.37630000f,0.08870000f,-0.23340001f,-1.20020002f,0.32139998f,-1.52589999f,-0.21349998f,-0.79420002f,-0.44890003f,-0.42520003f,-1.29420000f,-0.53499998f,0.99270001f,-0.57179999f,-0.75660004f,0.03899995f,-0.30209998f,0.41290000f,-0.28960001f,-0.49160004f,0.22790000f,-0.96860000f,-0.93100002f,-0.34789998f,0.01390000f,-1.19729997f,-1.27200003f,-0.62550001f,-0.38130003f,-0.62639999f,0.06319998f,0.20569998f,0.90750004f,-0.52140002f,-0.25210003f,-0.67580004f,0.47320001f,-0.69040001f,0.06619998f,-0.60329999f,0.29039997f,-0.92540002f,0.34589997f,-0.49279998f,0.45160000f,-0.47800000f,-0.00890001f,0.80270004f,-1.53600003f,-0.31360006f,0.14869996f,-0.82630001f,1.44910004f,-0.37430000f,1.03229999f,-0.26180002f,0.62579995f,-0.22399998f,0.33190000f,0.23719998f,-0.49810007f,-0.39959998f,1.35990001f,-0.16150001f,-0.46749997f,0.42390003f,0.82110007f,1.06589998f,-0.29090003f,-1.51020001f,0.36759997f,0.08190000f,1.49449998f,0.11049999f,0.33660005f,0.84800005f,-0.95289998f,1.46240005f,-0.34240002f,1.40840004f,-1.16520000f,-0.06329997f,0.89809996f,0.56299998f,-0.24939995f,0.00669998f,-0.06729999f,0.53229998f,0.34690001f,-0.03650004f,-0.36750000f,0.05040000f,0.50400002f,-1.46970001f,1.35480002f,-0.22390001f,-0.89970004f,-1.69090003f,0.80200005f,0.94639998f,-0.06370008f,0.49570001f,0.47990000f,-0.02399999f,0.28560000f,0.10889998f,0.50309999f,-0.10559998f,0.27519996f,-0.06490001f,-0.75750000f,0.31599999f,-0.52399998f,0.73520005f,1.64299997f,-0.07950001f,1.02319999f,-0.20860002f,-0.08100001f,0.14609999f,-0.07460001f,-0.99440000f,-0.28719998f,-0.11880003f,-0.70500001f,0.78870001f,0.14010001f,-0.42000001f,0.81470006f,-0.72490004f,-0.90080005f,-0.06219997f,-1.32610003f,0.58549999f,0.42120001f,-0.51499999f,0.11850003f,-0.35650002f,-0.39559999f,0.63800006f,1.20820003f,0.42659999f,0.34870001f,0.63930001f,-0.22070000f,0.68059999f,1.44759999f,-0.90820006f,-0.17929998f,0.10730004f,0.04500001f,-0.21709999f,-1.03350001f,-0.25769998f,-0.12740000f,0.23140000f,0.09570001f,-0.40410000f,-0.66459999f,-0.32950003f,0.72390000f,0.53429999f,0.31590003f,0.68509995f,0.01049999f,-0.58050005f,-1.15970002f,-0.19540001f,0.75030001f,0.93979999f,0.15010002f,0.62239998f,0.31040000f,-0.83770002f,1.10680000f,1.11700001f,-0.38299999f,-0.42609997f,0.54870000f,-1.35180007f,1.72450005f,-0.68249997f,0.37250000f,1.91030005f,-0.86600001f,-1.03840002f,1.28010003f,-0.96370004f,1.00150003f,0.60619999f,0.67199999f,1.17120000f,0.33910000f,-0.70059999f,-0.61299998f,1.60540003f,0.40590001f,2.02130004f,0.99760002f,0.16550002f,0.48590001f,-0.83080002f,-1.36110002f,1.02859999f,-0.29240002f,0.29880000f,-0.37370001f,0.69120001f,-0.84280003f,-1.03420000f,0.14839996f,0.74970001f,-0.31220001f,-1.63110001f,-1.25290000f,0.63670004f,-1.33019997f,-1.25720003f,-0.81700002f,-0.66290003f,-1.26660003f,0.21330000f,-0.60500000f,0.46180000f,0.06390002f,-0.50830002f,0.82090005f,-0.05220006f,-0.83950001f,0.80030000f,0.60060002f,1.34619998f,0.94859998f,-0.80759996f,0.46790002f,0.58659995f,1.10630006f,0.30310000f,0.57610003f,-0.32170000f,0.29979999f,0.28510001f,0.65020002f,0.81870004f,-0.28680001f,-0.07519997f,1.46460003f,2.21510003f,0.77190001f,-0.23900006f,-0.07339999f,1.68090008f,0.40659999f,0.31650000f,-0.40210005f,-0.34890002f,-0.07340001f,-0.52140000f,-1.03900002f,-0.05940001f,0.67320000f,0.50570002f,0.16510000f,0.29170000f,0.09919998f,-1.00859998f,-0.37830001f,-0.13210000f,0.09200001f,0.04520000f,-0.38950001f,-0.61080001f,-0.01940001f,-0.62379997f,0.40779998f,0.91650003f,0.21240001f,-0.16140000f,0.03050002f,-0.85660003f,0.42290001f,0.36280001f,-0.97289999f,1.31720005f,-1.34400002f,-0.77460003f,0.95309999f,0.36060002f,-0.22209999f,0.92920002f,-1.06820001f,0.83530000f,0.08449999f,-1.13740004f,-1.56150004f,-0.17050003f,-0.23910000f,-0.19769999f,0.59880002f,-0.43549998f,0.14279999f,-0.84880001f,0.21550002f,1.07180001f,0.28099999f,-1.13710001f,0.06010001f,-0.32819999f,-0.28530000f,-0.23929998f,-0.05730003f,-0.02400000f,-0.39149999f,-0.55460001f,0.13660000f,-0.05120000f,-0.33219998f,0.70430001f,0.40530001f,1.06050002f,1.91369996f,0.35440002f,1.88359997f,0.18290001f,1.18860000f,0.67180001f,-0.12300001f,0.70370002f,0.06820000f,-0.00860000f,0.69130002f,-0.24530000f,-0.34960002f,0.97000001f,0.34320001f,-0.38439998f,-1.53330006f,-0.04949996f,-1.02799999f,0.43029996f,-1.64270009f,1.42650005f,1.50280003f,0.28189997f,0.14160000f,0.22960000f,0.08660000f,-0.24820001f,-1.04120002f,0.03830002f,0.89780001f,-0.91320006f,0.20619997f,-1.22049999f,0.05140004f,-0.53199999f,0.83780003f,-0.37750000f,0.40160001f,-0.31340001f,-0.12739998f,-0.09300002f,0.16440001f,0.43239998f,-0.49769998f,0.05579995f,0.23110002f,-0.13630001f,-0.09190001f,0.24210001f,0.47350003f,0.26139997f,-0.88340000f,-0.18330002f,0.11139999f,-0.78419997f,-0.11059999f,0.08960003f,0.35939995f,-0.58440002f,1.28600002f,-0.83730002f,2.07870002f,0.18510000f,-0.08979998f,-0.04980000f,0.39710000f,-0.80240003f,1.04860003f,-0.14010000f,0.68009999f,0.92780003f,-0.76530000f,0.96490003f,1.08570000f,1.56200000f,0.50950000f,2.00610001f,1.04830000f,1.69580002f,-0.33030005f,-0.39530002f,0.31800003f,1.13620003f,0.05289998f,1.40210002f,0.78480001f,-0.62080001f,-0.16160000f,-0.21230000f,-0.54820001f,0.35979999f,-1.29489998f,-0.03230001f,-0.72899998f,-0.11250000f,-1.19659998f,-0.71060000f,-0.46770000f,-0.24790001f,-0.73199997f,0.59009998f,0.21290002f,-0.75840002f,0.12829997f,0.01040000f,-1.00380004f,-0.03199999f,1.07680006f,-1.47490003f,0.25320000f,-0.86900000f,0.69640001f,-0.77390002f,0.74830003f,-0.41350001f,0.43999998f,-0.71800000f,1.09230006f,-1.90920004f,-1.12790004f,1.75119998f,0.98480008f,-0.15090003f,-1.15580003f,0.24640000f,-0.08699998f,0.86940000f,-0.31389998f,1.48180002f,0.91260004f,0.73729998f,-0.92190001f,0.05920000f,-1.20300002f,-1.09450002f,-1.00560005f,1.00360006f,1.05069998f,0.03319998f,0.02989998f,-1.14649997f,1.23839999f,-0.61569997f,1.31600000f,-1.72119999f,1.02160000f,-0.13799999f,-0.13500004f,-0.38500005f,0.66620001f,-1.31539998f,-0.44170004f,-0.06970006f,-1.43260003f,0.93180003f,-0.44580000f,0.58040002f,0.60340001f,0.43800005f,-0.06950000f,-2.00889994f,1.76029997f,0.46360005f,-0.60279997f,1.08620003f,0.48850001f,-1.42909997f,0.63409999f,1.56209994f,0.77070004f,0.46330000f,-0.50160006f,-0.40290003f,-0.52730000f,0.44060000f,-0.44709998f,0.38030000f,1.52810005f,0.76090004f,-0.13840000f,1.16460003f,-0.54800002f,-1.09150003f,0.38020001f,2.14890006f,-0.93009999f,0.87029996f,0.70390005f,1.09680007f,-0.71530001f,0.17650002f,-0.23060000f,0.77410005f,-0.71280002f,0.81480002f,-0.53950000f,-0.18730003f,0.99090002f,0.19180004f,-0.78190003f,0.83010002f,-0.19529999f,1.21200003f,-2.03450005f,0.66780002f,-0.92880006f,0.17470002f,-0.27260002f,0.09490000f,-1.15320004f,0.62830002f,-0.04079995f,0.23310001f,0.87680002f,-0.80480003f,-1.77110004f,0.95970002f,1.04270008f,-0.92999999f,-0.76540000f,1.52350005f,0.57790003f,0.63600000f,-0.78280002f,0.56830003f,0.91860005f,0.37510005f,2.18380003f,0.00670000f,-0.09599997f,0.09700001f,-0.34770000f,0.34400001f,-0.52620000f,0.64880000f,0.54800007f,-0.69450001f,-0.12919999f,-0.78559998f,0.14529994f,0.36160000f,-1.09180001f,-1.47220002f,0.63559999f,0.37239996f,0.08590001f,-0.12640001f,-0.19980000f,0.67379998f,-0.21569998f,0.81560005f,-0.55240000f,1.16789999f,0.26000003f,-0.62360001f,-0.19540003f,0.21990000f,-0.43930001f,-0.16839997f,0.81650000f,0.78750005f,-0.12839995f,-1.32440003f,0.35379999f,-0.77910004f,0.24660002f,-0.39820003f,-0.79630001f,1.68079999f,-1.21890001f,-1.56270000f,0.49440002f,0.93689999f,0.05270002f,0.41830001f,-0.04000005f,0.48770001f,0.63470001f,0.00830000f,-0.43840001f,1.03650000f,-0.03829996f,0.40189999f,1.22970003f,1.32200005f,-1.15069999f,1.41589996f,1.19180005f,0.86679999f,0.25240005f,2.45700006f,-0.09869999f,1.32030002f,-0.37859999f,0.19519999f,-0.40840003f,0.16409999f,0.35810002f,1.02800003f,-1.40620002f,0.61959999f,0.13060000f,0.70799999f,-0.03039994f,1.29040000f,-1.56289999f,1.58450003f,-0.64449997f,0.73250000f,-0.35820001f,-0.04680000f,-0.10939999f,0.68480000f,-0.21249999f,-0.63519999f,-1.74399999f,1.31780001f,-0.32859995f,0.15469999f,-1.14829999f,-0.35809998f,-1.11819998f,1.36749998f,-1.43339998f,0.19860000f,-0.12440001f,0.52450002f,-0.29719999f,-0.57320001f,-0.11159998f,-0.29330001f,1.03890001f,-0.48260000f,0.04879996f,-0.17429999f,0.23350003f,-0.17600004f,-2.12169998f,-0.90620002f,-0.81410003f,-0.00380000f,0.19689998f,0.28760003f,0.53890001f,0.68189998f,0.11080003f,-0.35780000f,0.13789996f,-0.20400001f,0.86540002f,-1.60990002f,-0.57030000f,0.88639994f,-1.44050000f,0.97490000f,-0.73680001f,0.64760002f,0.60170002f,-1.26219999f,0.60089999f,-0.99130001f,-0.33750000f,-0.73949999f,-0.07109999f,1.00650006f,0.01480000f,-1.88840001f,1.30850002f,1.75299994f,-0.17789998f,0.29949997f,-0.56640001f,0.54879997f,-0.73170000f,0.04940000f,0.23800001f,0.32400002f,0.99689998f,0.65760001f,-0.53619997f,1.12649997f,0.09630000f,-0.96110000f,0.50730001f,-1.53050005f,0.07019998f,-0.30889995f,-0.39430002f,-1.06449996f,0.32899998f,-0.72569995f,0.50870005f,0.24380002f,-0.61100003f,0.54950001f,-0.98180001f,0.45330000f,0.03760000f,-0.79930003f,0.29260001f,-0.23250000f,-0.33830001f,-1.20640001f,2.02770001f,-0.97009997f,0.67799997f,-0.19179998f,-0.07610005f,-0.20970000f,1.14659999f,-0.04680000f,0.83290005f,0.54460001f,0.67390001f,-0.03949997f,1.63140004f,-0.32070005f,-0.94890004f,0.60230001f,1.85089995f,-1.39930003f,0.17249996f,-0.87559997f,-1.03340001f,0.83059998f,-1.04049999f,-0.57969997f,-0.69450004f,-0.62190001f,0.47320002f,-0.93669998f,2.14049998f,0.24230002f,0.43039999f,0.15729999f,-0.88299999f,0.27379999f,0.96350002f,-0.06770000f,0.97849997f,0.87250003f,-0.51749998f,-0.72700003f,0.01320001f,-0.44049999f,-0.41569999f,-0.39100000f,1.38230002f,-1.14169998f,0.75949998f,-1.52340002f,-0.35209999f,0.23769999f,0.74630003f,-0.50829998f,1.15910002f,-1.47810003f,-0.55840002f,0.56509998f,-0.59969999f,0.86790000f,0.06450001f,-0.72320002f,0.18799999f,-0.59369998f,0.07070005f,0.39040002f,1.58159999f,0.16679998f,0.10789999f,-0.24529997f,-0.62379997f,-0.18410001f,1.22850003f,1.26530004f,-0.01800002f,0.26759996f,-1.21859998f,-0.46320000f,0.90170000f,-1.18629999f,-0.55000007f,-1.82070001f,0.08779997f,-2.00840006f,0.14900000f,-0.55950004f,0.27630002f,2.44270000f,-0.30069998f,0.87060000f,-1.01669999f,0.75749999f,-0.65400001f,-0.11480000f,0.23920000f,-0.21460001f,1.29089998f,-1.48240002f,1.20800003f,-1.44450005f,1.04330000f,0.20790000f,-0.12759992f,1.18439999f,-0.53509997f,0.71440000f,-1.08760003f,0.21280000f,-0.34280000f,0.25900000f,-1.13419999f,0.17220000f,-0.75820002f,-0.42840001f,0.68479995f,-1.09530001f,0.78119996f,-0.18480002f,-1.64019997f,-0.36280003f,0.45850005f,-0.21940001f,-0.44749999f,1.01440001f,0.36109998f,0.06090002f,0.25460001f,0.69939998f,0.27960001f,0.70540000f,-0.10399999f,-1.94850005f,0.36270006f,-0.27919999f,0.38239995f,-1.82660003f,0.55140001f,-0.67969998f,-0.87650004f,0.73100004f,-1.82760006f,-0.94950000f,0.51919999f,1.76140005f,-0.99930001f,0.66030004f,-0.25200001f,-0.30890000f,-1.49929999f,0.58390002f,-0.08870000f,0.29599998f,-1.52470001f,-0.15540003f,0.76240006f,0.67950004f,0.24370001f,-0.74999996f,1.11610010f,-0.38200000f,1.17600000f,0.29660002f,0.36040000f,-0.03710001f,0.26400000f,-0.78719997f,1.14110000f,0.68670000f,0.78930005f,0.82440002f,0.13189997f,-1.36300000f,0.22130000f,1.92030003f,0.68250003f,-0.22260002f,1.31059998f,1.13710003f,0.55220004f,-0.43750000f,0.46260000f,-0.15879999f,-0.22720000f,0.73709999f,-0.54270008f,0.64370008f,-1.47280004f,0.74120002f,1.22580005f,-0.16920005f,-1.15840007f,-0.49489996f,-0.30119998f,-0.82550005f,-0.89810003f,-0.46730001f,-0.31070004f,0.21210001f,0.69020001f,-0.35710006f,-0.96990003f,-1.41230002f,0.66530001f,0.04399999f,1.02750002f,0.63309998f,-0.93580005f,-1.95010004f,0.14110001f,-0.14589998f,-1.22640002f,-0.49360001f,0.90470005f,0.75350002f,0.05600001f,1.42640002f,0.93700001f,1.32230000f,0.05870003f,0.09499999f,-0.98650001f,0.36280000f,-0.54559999f,-0.13889999f,1.21320002f,-0.68059995f,-0.14200000f,0.16270000f,-0.58500004f,0.14849997f,0.01000000f,-0.97919999f,-0.14040004f,-2.70700011f,1.80650004f,0.30410003f,-0.19540004f,-0.54180005f,1.82590002f,0.51189999f,0.92550004f,-0.74470004f,0.11190004f,0.75380002f,-0.93050001f,-0.79080001f,0.64140004f,1.28180005f,-1.16970001f,0.29699996f,-0.54159998f,1.32320004f,0.63729999f,1.02860002f,0.76490001f,0.61859999f,-0.61500005f,-0.47860002f,-0.41520003f,1.06450003f,0.58619999f,0.04639999f,0.37550002f,-0.88040001f,0.02589998f,-0.33590000f,0.29359999f,0.08250000f,0.22990000f,0.80860000f,0.24719998f,-0.32069998f,1.18409998f,0.89770001f,0.98330000f,0.13560001f,1.12689993f,0.50510000f,1.31869998f,0.93890006f,2.11839998f,0.08310000f,1.27740000f,-0.43900000f,-0.29320000f,0.24519997f,-0.55190000f,-0.18989998f,0.01100002f,-0.00960003f,-1.54160007f,1.38570004f,-0.74360001f,0.36480003f,-0.49139998f,0.17910000f,-1.72030007f,1.11740005f,-1.60450007f,1.17750004f,-0.46390000f,0.20250003f,0.79600001f,-0.18870000f,0.53720000f,-0.03430002f,0.00940001f,-0.49590000f,2.04100002f,-0.41660000f,-0.45599998f,-0.75359998f,0.95460003f,-1.31980004f,0.87420005f,-0.20669998f,0.30960001f,-0.61729998f,0.08900002f,-0.13449999f,0.94230000f,0.13289998f,-0.28639999f,0.76639996f,-0.23720000f,-0.12309996f,-0.59830002f,-1.92109995f,-0.51510000f,-0.88930001f,0.57689998f,0.05520003f,0.07170000f,0.71680000f,0.07480000f,0.83630002f,-1.09020001f,-0.98720003f,-0.55010000f,0.71590008f,-1.01670009f,-1.48940007f,1.30110002f,1.81400002f,-0.98849998f,0.80610003f,-0.54650000f,0.87600003f,-1.74739998f,-0.75290003f,0.15650001f,0.40150000f,-0.00110003f,-0.46930001f,0.05960005f,0.45190003f,0.24620002f,-0.32229999f,0.62670001f,0.21070002f,1.25450000f,-0.03630000f,0.34679999f,-1.20370000f,-1.02220000f,-1.07809999f,-0.16379999f,-0.00739999f,0.95980001f,-0.25940002f,1.00819999f,0.00050000f,-1.20879999f,-0.86570002f,-0.48910000f,-0.07299998f,-0.96209996f,0.36180000f,-1.56639995f,-0.49599999f,-0.08119998f,0.22850004f,0.10909998f,-0.11909999f,0.36199998f,-0.10800000f,-1.50960006f,1.28500005f,0.63990001f,-0.84830001f,1.45030007f,-0.25520003f,-0.77060006f,1.28420003f,1.52990003f,-1.71750000f,0.23349999f,0.35499996f,-0.46340002f,1.24140001f,-0.57070003f,0.90040003f,0.31979996f,-0.52370002f,-0.87090004f,0.22250000f,-0.55939999f,0.43200003f,-0.12500000f,0.36609997f,0.36240000f,0.64099998f,0.12900003f,1.18659999f,1.21509997f,0.34799999f,1.83750005f,0.19829999f,0.29630000f,0.40860000f,0.83910001f,1.54489997f,-0.17270002f,0.88360000f,-0.81459998f,-0.29969999f,1.06320002f,0.39640003f,-0.25120003f,1.45980001f,-0.05279999f,-0.53929998f,0.63610000f,-0.87679999f,-0.45130000f,0.03300000f,-0.14720001f,-0.92590002f,-0.55519997f,-0.78190002f,0.04679999f,0.36910000f,0.54009997f,0.32509998f,-0.93409997f,-0.93820002f,0.45080000f,-0.40030003f,0.72170000f,0.53870003f,-1.06600000f,0.33750000f,-0.54930001f,0.56020001f,-1.29640000f,-0.93719997f,-0.00429996f,-0.28219999f,0.23789999f,-0.47960001f,-1.69890001f,-0.49639998f,-0.66419998f,-0.86030005f,0.26860000f,0.66210001f,0.15619999f,0.02020001f,0.79550001f,-0.17919999f,-1.18749999f,-0.39310003f,-1.99129998f,-0.86580005f,-1.63910001f,-0.16309999f,-0.09700004f,1.49970001f,1.39919997f,0.29920000f,0.84789998f,0.23709999f,0.29860000f,-0.08600000f,-0.01239999f,-0.03140001f,0.00960001f,0.60619999f,1.74550004f,-1.19250000f,1.00480006f,-0.05080002f,1.51920006f,-0.58740000f,-1.79920003f,0.29410002f,-0.69360000f,-0.33930002f,-0.52810001f,-0.56019997f,0.48620001f,-1.36040000f,0.15780002f,-0.48780002f,0.07700003f,0.91180003f,-0.54110000f,1.49700005f,0.25509998f,-0.62300003f,-0.40710002f,-1.58280000f,0.39000001f,0.23360002f,0.32380003f,0.12880001f,-0.59649996f,0.09180001f,-1.12759998f,0.05200003f,-0.17360000f,0.20589998f,0.29050005f,-0.47340002f,0.65900003f,-1.41670002f,0.57220000f,-0.98800002f,-0.83370002f,0.78509997f,-1.28350000f,1.16019998f,-0.33829999f,1.09170004f,0.24490000f,0.12300003f,0.20400000f,-0.88640005f,-0.20390001f,-0.75820006f,0.31240005f,0.81230003f,0.54470003f,0.72280004f,0.54480000f,1.31309998f,-0.18420001f,-0.07690003f,-0.45220001f,-0.92710002f,-0.88460001f,0.30170003f,-0.60350001f,-0.25530000f,1.02050002f,-0.50680000f,-0.02340003f,-0.02309998f,-0.14750000f,0.66390002f,-0.70120002f,0.09029998f,0.76850004f,-0.03600004f,0.71960002f,0.77680000f,-0.11480003f,0.02899997f,0.43480000f,-1.43960003f,-0.35850006f,-1.32690002f,0.13989999f,0.14900004f,-0.28360001f,0.33600001f,-0.66410003f,0.16589999f,-0.90740003f,1.06310001f,-1.79280001f,0.53049999f,0.27050003f,-0.28630002f,0.87010006f,-1.33730007f,1.07490000f,-0.85460000f,0.68740003f,0.03160000f,0.38439998f,-0.33449998f,1.03970005f,0.07540002f,0.54900002f,0.52060001f,-1.53839997f,1.49800002f,-0.28800001f,0.22759997f,0.68300001f,-1.07360000f,1.82500000f,-0.42960004f,-0.38290006f,-0.70890001f,1.20359999f,-0.52459997f,0.23929996f,-0.20790001f,-0.37640003f,-0.39290000f,-0.57230005f,1.06790001f,-1.54300003f,0.74130001f,1.09460002f,0.73950000f,0.55199998f,-0.68780001f,0.88239998f,0.38730001f,-0.24990001f,-0.60849998f,0.68519999f,-1.40230001f,-0.13140000f,-0.22670001f,-0.21810002f,-0.46459996f,0.02010000f,-1.02039999f,0.78610001f,-0.08419994f,0.55769997f,-0.34840000f,0.23580000f,0.20910003f,0.24099999f,-0.99540003f,-0.22689999f,-0.17049997f,1.33150000f,1.16079995f,-0.03219999f,1.45730001f,-0.23500000f,0.03069998f,1.17429994f,-0.30979995f,-0.69880000f,-0.10559998f,0.65239998f,0.44170001f,-0.89539998f,0.44690001f,0.90169999f,0.75560000f,0.14820002f,1.36480001f,0.19850005f,1.97450003f,-0.04360001f,0.05840002f,0.14519995f,-2.01160001f,0.52740003f,1.18029997f,0.54810001f,0.16969997f,0.45650002f,-0.27589996f,-0.33750003f,-1.22849999f,-0.44769998f,1.33240002f,-1.57500001f,1.65220002f,-1.48170000f,-0.32570000f,0.60419994f,-0.88039999f,0.73360002f,0.88320001f,-0.42519995f,0.80150001f,-1.11200003f,-1.00950000f,1.54669999f,-0.62939999f,0.18120001f,-0.07809999f,-1.02929997f,0.98610000f,-1.23179994f,1.07770001f,0.87239993f,0.28870002f,-0.37059999f,-0.43900000f,-0.02619993f,-0.82350000f,-0.08980003f,1.38610001f,2.07209998f,-1.37010000f,-0.35250003f,-0.16770001f,0.14540001f,-0.83399999f,1.18490000f,-0.56320001f,-0.01300001f,0.94980002f,-0.13729998f,-1.48940006f,-1.45760006f,0.98850002f,-1.18140005f,0.17590003f,0.93010003f,-0.54470001f,-0.66980004f,0.82690000f,0.09619995f,-0.10700000f,0.22370000f,0.39320002f,0.66070003f,-1.32840000f,-0.47160003f,0.40689997f,-1.49580004f,1.39640003f,-0.18380002f,-0.50959998f,0.16600000f,0.66710000f,-0.17990003f,0.45950006f,-0.14800003f,0.55070003f,0.24999999f,-0.10150001f,-0.56109999f,-0.56480000f,0.89950000f,1.65140002f,0.00019999f,0.77599995f,-0.95880000f,-0.74019998f,0.34889997f,-0.67450002f,-0.12160003f,-0.99499996f,0.04370000f,0.89560001f,-0.88480003f,-0.12419998f,-0.31300002f,0.32790004f,-0.28870002f,-0.77350001f,-1.22489998f,0.82249996f,1.30749999f,-0.95020000f,0.08490001f,1.03049997f,0.89650001f,-0.68070002f,-0.81840002f,0.13489998f,0.86190002f,-0.11429998f,-0.21450001f,-0.82950002f,1.68829999f,-0.22429999f,-0.14059999f,0.47810000f,-0.44939998f,0.50090002f,-1.46130002f,0.42360000f,0.27720002f,-0.17340002f,-0.15320003f,0.06700003f,0.21060002f,0.22360001f,-0.76560002f,0.43079999f,1.11949997f,-1.10860000f,-1.11750000f,0.00980001f,0.33189999f,-0.02579998f,-0.16549997f,1.36319997f,0.60360006f,-0.81419998f,0.47580001f,0.51219998f,0.02999996f,-0.78649996f,0.96110002f,0.49249999f,-0.09350001f,0.28650004f,0.90650001f,0.05060000f,0.11440001f,-1.06389999f,-0.35380005f,0.31469998f,-1.42339998f,-0.51990005f,-1.00789998f,0.14429999f,-1.92810002f,-0.23100004f,-0.78189996f,-0.03240000f,-0.49080002f,-0.72590001f,0.25460001f,0.08279999f,0.15030000f,-0.60729999f,-0.12080001f,-0.27869999f,-0.90650000f,0.31079999f,-0.79569999f,0.44530000f,-1.10080000f,0.41869993f,-0.83769998f,0.86930002f,-0.08660000f,-0.39000003f,0.49930002f,1.37450002f,-0.52649998f,0.23650001f,0.26009998f,0.31869997f,0.39070001f,1.55309995f,-0.20790003f,0.93439999f,-0.66599999f,1.00989994f,0.19500001f,0.75980000f,-1.18990000f,-0.02020000f,0.38960001f,0.03769998f,0.47320001f,2.08229996f,-0.16329996f,1.39630001f,0.76530002f,-0.12929998f,0.19800001f,0.13370001f,-0.45329997f,1.86039997f,1.21230003f,0.45909998f,0.33040002f,1.12260004f,-0.30620001f,0.38960000f,-0.89919996f,1.13259999f,-0.44539999f,1.21460002f,-1.47570000f,-0.02210000f,-0.10540007f,0.14980002f,0.50960004f,1.16039998f,-0.53719993f,0.91449999f,-1.18080002f,0.35880000f,0.54420003f,0.11640000f,0.17140000f,0.66649998f,0.36990003f,-0.36419997f,-0.43249995f,0.87080000f,0.10299996f,0.93610001f,-1.61839998f,-0.48150000f,-0.56529993f,-0.14740001f,-0.51499999f,1.29749999f,-0.43239999f,-0.47040001f,-0.34560001f,-0.03959999f,-0.30040002f,0.09529998f,-0.12360001f,0.51259999f,-0.98739999f,-0.14910000f,-0.32220001f,-0.23920001f,0.58450000f,1.40580005f,-0.14530001f,0.19029998f,0.59250005f,-0.61850003f,-0.39379999f,0.12450003f,-0.46500005f,1.27310006f,0.35739999f,-1.78440003f,-1.32120000f,-1.80740004f,-0.97100000f,-0.45010001f,0.72330001f,-0.09470003f,1.09819998f,1.14590000f,0.19429996f,0.61300001f,-0.44870002f,-0.10099999f,0.59660004f,-0.16630000f,-0.16349999f,0.15380000f,-0.12939995f,0.64540000f,0.12730002f,0.09979999f,-0.05770001f,-0.07120001f,0.86469998f,-0.38079999f,1.19809998f,-0.10360003f,-0.22530001f,-0.31200001f,-1.55870002f,-0.29030002f,-1.25900000f,0.28519999f,0.53859999f,-0.66709999f,-0.31170003f,-0.87690000f,0.18750003f,-1.26620005f,0.62380004f,-0.55300003f,-1.46940005f,2.34680003f,-0.04360002f,0.54340005f,0.37860004f,0.03779996f,1.62110006f,-0.99880002f,-0.64150000f,-0.86200003f,-1.06100004f,-0.63180000f,-0.64890000f,0.15000003f,-0.91920000f,-0.44449996f,0.12190003f,-0.51600000f,0.52829999f,-0.70860000f,-0.82070004f,0.89380004f,0.26370003f,0.57460001f,-0.23830001f,0.47989999f,-0.57789999f,0.83799996f,-0.38550003f,-0.26569997f,-0.09140005f,-0.70479998f,-0.88810001f,-0.32569999f,0.82280001f,0.73710001f,-0.13210001f,0.92079997f,0.41020000f,0.25349998f,0.00629998f,0.01740001f,-1.03079998f,-0.31190000f,-0.17700003f,0.22770001f,-0.26660000f,0.88710000f,-1.36329994f,1.19040006f,-0.24020004f,-0.25360005f,0.30960007f,-1.02170001f,1.30599998f,-0.28460000f,-0.23249999f,0.17650002f,-0.62280002f,-0.33330000f,0.13790003f,-1.01729998f,-0.40329999f,-1.47910001f,-0.62079997f,-1.99059998f,-0.05120000f,-0.62210001f,-1.85630002f,-0.10410000f,-0.34469997f,0.49459997f,-0.95330001f,-1.07360001f,-0.01619997f,-0.22409999f,0.37029999f,0.71900001f,1.34609999f,0.60780005f,2.03359997f,-0.66990001f,0.25100002f,-1.23230003f,-1.11449997f,1.12020002f,0.58299997f,-0.84810002f,1.18300001f,0.42570001f,-1.10449994f,-0.35430000f,-1.00499998f,-0.60519999f,-0.53250000f,-0.51760001f,-1.38400005f,0.50790000f,-1.35820004f,1.70609999f,1.75250000f,0.09180001f,0.11220003f,-0.56070000f,-0.78110001f,1.26689999f,-0.34730005f,0.45260005f,1.43190002f,-1.06680000f,-0.17409998f,-0.75710000f,0.24630001f,-0.93490000f,0.44460004f,0.75200002f,0.31289998f,0.34699998f,-0.84870008f,-2.22220003f,-0.68800000f,-0.36729998f,-0.58960004f,-0.19020003f,0.24400002f,0.67439999f,-0.28109999f,0.20819999f,0.41080002f,0.54019997f,-0.52570000f,0.59400001f,0.44959999f,-0.53619998f,-0.95590004f,-1.55730003f,0.31719997f,-0.86060001f,0.27310003f,0.69479998f,-1.36030001f,0.22819995f,0.59499999f,-0.36180003f,0.20360000f,-0.93700001f,0.30560002f,0.45420000f,-0.67230000f,-0.67370003f,0.36220000f,0.93070004f,-0.46099999f,1.70090010f,-1.42630002f,-1.29820002f,1.42210001f,0.23499996f,1.19590003f,0.04400006f,0.11819997f,1.13840000f,-0.12690002f,0.02530002f,-0.26680001f,-1.42630002f,0.18020003f,0.95530003f,1.46100003f,-1.01990002f,0.12970001f,0.78050001f,0.33459996f,1.58260000f,0.49210001f,-0.69190004f,-1.03610000f,0.04659998f,0.30570001f,0.19090001f,-0.45969999f,-0.06350001f,-0.57470001f,-0.30450000f,0.72209997f,-0.49300002f,0.15580004f,0.39360000f,0.58079998f,-0.26670000f,-0.25430000f,-0.28150000f,0.05810001f,0.34469999f,-0.09179995f,0.45359999f,-1.11900005f,1.11450003f,1.35160005f,-1.17670002f,-0.56100001f,-0.01489998f,0.89280002f,-0.29650002f,-0.73470003f,0.66180002f,0.11160003f,0.34259995f,0.38830000f,-0.17449998f,0.09489998f,-0.50459998f,0.82710001f,0.58750000f,0.79410001f,0.51980000f,0.13209999f,-0.49860001f,-1.76969999f,-0.53860000f,-0.45330006f,-1.42110002f,-0.75150004f,0.13270002f,0.34259999f,-0.76420003f,-1.65290002f,-0.61019999f,-0.18749999f,0.64550002f,0.62450000f,0.27720003f,0.53809999f,-0.16069999f,-0.92950001f,0.04599998f,-0.34510001f,-1.33689994f,-0.21870001f,-1.19359996f,-1.00570002f,-1.33959996f,0.22750000f,-1.28419995f,-0.16560001f,-0.27120000f,0.22779999f,-0.86430006f,0.27700006f,0.27460001f,-1.08879999f,0.02800000f,-0.02939999f,0.93680001f,-0.66040000f,1.08680000f,-1.06100000f,1.01020004f,-0.18050005f,1.09089999f,-0.99849998f,0.51160003f,-0.58980003f,-0.86840005f,-1.14140002f,-0.49049999f,-0.08809999f,0.05050002f,0.52420002f,-1.42819998f,0.26840000f,-0.69350000f,0.20570000f,-1.07650002f,1.05020002f,-0.47780001f,-0.08300003f,-0.51940001f,0.30420002f,-0.18060000f,0.85119997f,1.23469998f,1.29219997f,0.56890004f,1.28519998f,-0.24720002f,0.26670003f,0.07320001f,0.26279999f,0.49790003f,1.51319993f,0.11769999f,1.03219999f,0.54480003f,0.72159999f,-0.08640000f,0.36439999f,0.29299998f,-1.41139999f,0.43890001f,-0.74020001f,-0.44750001f,-0.83180002f,1.05549999f,0.31339998f,0.49670005f,-1.12510003f,0.49330003f,-0.61209998f,0.63349998f,-1.08180005f,1.12480004f,-0.45640002f,0.48400001f,-0.43390002f,-1.86309998f,0.01859997f,-0.76380001f,-0.29679997f,0.76830003f,1.29330001f,-0.17100004f,0.80459998f,-1.31000002f,-0.61049999f,-0.47309996f,0.78040001f,-0.47840002f,1.02540002f,0.13740001f,0.14600000f,0.62890000f,0.43270001f,-0.78459995f,1.21849999f,-0.97659999f,1.32310000f,-0.81219998f,0.48789998f,-0.43439999f,0.80940004f,-1.52070005f,1.02800000f,-0.49199998f,0.49210001f,0.08339998f,0.24150001f,-0.63160000f,-0.23510000f,-0.86739997f,0.05159999f,-0.30819995f,0.66289999f,-1.02289993f,0.28860000f,0.59890004f,0.35010000f,-0.62430000f,0.87040003f,-0.57249992f,0.47949998f,0.55789999f,-0.61819996f,-0.38190001f,0.80979999f,-0.48380005f,0.58770002f,0.88180002f,-0.82549999f,2.14830002f,-0.25950000f,-0.39390003f,-0.45060004f,-1.98710000f,-0.01010002f,-0.55179996f,-1.17879999f,-0.95770001f,0.07879997f,0.34920001f,-0.02489997f,0.87209998f,0.08940002f,0.93270004f,-0.88809999f,1.43810003f,-1.38510001f,-0.38540003f,-0.47490006f,-1.43180000f,0.60269996f,-0.67349999f,0.36379997f,-0.70380000f,0.44719997f,0.43030003f,-0.53689997f,0.70629999f,-0.86180003f,0.07530000f,-0.65059998f,-0.05850001f,0.12770005f,0.56110004f,2.06529999f,0.61820001f,1.17109995f,-0.30210000f,0.15890000f,-0.45290000f,-0.32370003f,0.39880001f,-0.52759997f,-0.44159999f,-0.02679997f,0.99990001f,-0.19660002f,0.23489999f,-1.82910000f,-0.29200001f,-0.63949998f,-0.66850006f,-1.97990004f,0.34440002f,-0.35010000f,-0.00969998f,-0.91210000f,0.64810005f,1.90780008f,-0.36889999f,0.30159998f,0.65020002f,0.80600001f,0.70790000f,-0.68970000f,-0.12820000f,-1.32970002f,1.82940000f,-1.02740001f,0.46800003f,-0.69740001f,0.72569999f,0.30290006f,-0.72280002f,0.66110002f,0.26550002f,0.90840003f,-1.22130001f,0.37670000f,-0.01159999f,-0.59919999f,-0.31670003f,0.53599997f,1.42029995f,-1.25530000f,-0.20970004f,-0.25290001f,1.24979999f,-0.76060002f,-1.84530004f,0.87980002f,0.58990006f,-0.83380002f,-1.43060001f,1.19020003f,0.69970002f,-0.16220001f,-0.27879999f,-0.38550002f,-0.31420003f,-0.26079999f,-0.09549999f,-0.15410000f,0.44289996f,0.20499999f,0.17670001f,-0.31940001f,-1.17510005f,0.02630000f,-0.62380002f,-0.83190007f,-2.44460006f,0.11649999f,-1.22740000f,-0.10540000f,-1.10320004f,1.81510001f,0.31580003f,-0.69879996f,0.92840000f,-1.26790001f,-0.56310003f,0.75120001f,-0.14670000f,-0.78700003f,-1.10410006f,1.16980001f,-1.76800003f,1.22490001f,-0.67470000f,0.31570002f,0.39019999f,1.31779997f,-1.12339999f,-1.01799999f,-0.34030001f,-0.29850001f,1.45300002f,2.24980004f,-1.13160004f,-0.42780000f,0.69080002f,1.91200000f,-0.61340003f,0.68729991f,-0.66790002f,0.14310001f,-0.47820003f,-0.77709999f,-0.39820004f,-0.32570001f,1.36430006f,0.11260001f,-0.14380005f,-0.14120001f,0.39560002f,1.52189999f,0.21970000f,0.33929998f,0.58990002f,0.57320000f,-0.26459999f,0.14610005f,-0.92400002f,-0.37530001f,0.79709999f,0.12210004f,0.04710003f,-0.04860003f,0.33810000f,-0.00250000f,0.58970005f,1.13020001f,-0.63989999f,0.86600001f,-0.95440000f,-0.17850000f,0.61719999f,-0.27850001f,-0.05920000f,-0.01920000f,-0.44170001f,-0.08340001f,-1.19170003f,-0.39979999f,0.61800006f,0.18939998f,-1.30410001f,-0.46430003f,-0.56529995f,-0.13029997f,-0.39779999f,1.09440000f,1.70589999f,-1.07489997f,0.41460000f,-0.03840003f,-0.99930003f,0.78170001f,-0.10569999f,0.00539998f,-0.19869999f,-0.52940001f,0.88970004f,-0.48939999f,0.16270001f,-0.00109999f,0.23270000f,-0.10880001f,-0.44129998f,-0.37650001f,-1.05230002f,1.15359999f,-0.91079998f,-0.43450003f,-0.40070002f,0.52400001f,-0.23640001f,0.32900001f,-0.02679999f,0.52699998f,0.30960001f,-0.49390001f,0.08449999f,0.12670000f,-0.61559999f,0.79729997f,-0.40219999f,0.17010001f,-0.79990003f,0.88430000f,-0.52220000f,0.94640000f,-0.23050002f,-0.86650003f,-0.02840001f,-0.34990004f,-0.39219998f,-1.22209999f,0.65010001f,-0.21549999f,0.15969999f,0.49909997f,-0.45729999f,-0.16660001f,-0.12869999f,1.03320003f,-0.36060005f,-0.48670003f,-0.88389997f,-0.42680000f,-0.07820003f,-1.13250003f,0.89869999f,-0.92479998f,-0.12230002f,-1.32509999f,0.49499999f,-0.73639997f,-0.70300003f,0.87700005f,0.54810002f,-1.97720003f,-1.37290003f,1.21319996f,0.51160000f,-0.13390003f,0.66670000f,-0.28199999f,-0.69370002f,-0.37130001f,0.12839997f,-1.72290002f,2.48499998f,-0.01759995f,0.11070001f,-0.66520002f,1.52159999f,-0.81490002f,0.08609998f,0.39149998f,0.34900009f,0.29329998f,-0.99130002f,-0.57410000f,0.32070000f,0.19430002f,0.10010000f,0.64529997f,0.89119995f,-1.47109999f,-1.81440005f,-0.42989999f,1.83249999f,-0.89770000f,-1.12049998f,0.34939999f,-0.46629999f,-0.80570001f,0.58120000f,0.86089999f,-0.49230003f,0.29300003f,1.03360004f,0.04510003f,0.25170001f,-0.28870001f,-0.02199999f,-0.04459997f,-0.31640004f,0.16750001f,0.42000002f,-0.03370002f,-2.11080000f,0.01299995f,-1.22750001f,-0.03250001f,0.13719999f,-0.68090001f,0.37160003f,0.29760003f,-0.01570000f,-0.42050002f,0.16269999f,-0.78889999f,0.25240000f,-0.46570000f,-0.37760002f,0.92880003f,-1.51240005f,1.20150000f,-0.98890001f,1.38130004f,-0.05280000f,0.32510000f,0.72670002f,1.23810002f,-0.91630001f,1.31670000f,-0.09069998f,-0.26559999f,0.68149997f,-0.92200001f,0.82250000f,1.01750000f,-0.93820002f,0.40749996f,0.09609996f,-0.44890004f,-1.28040001f,-0.04380001f,-0.32459999f,0.30300001f,1.32220004f,-1.06819999f,-1.16920001f,0.73550001f,-1.14120001f,0.44250001f,-1.19120003f,0.67159998f,0.97630006f,-1.03190003f,-1.28710008f,1.53980002f,-1.01430000f,0.04950001f,-0.17400003f,-0.09569998f,-0.42960001f,-0.87480002f,-0.90530001f,-1.25129999f,0.60489997f,-1.15250003f,0.49789997f,-0.22310000f,-1.30510001f,-1.05220000f,-0.19430004f,-0.96670003f,0.16889998f,-1.06170000f,0.37580004f,0.54070001f,-0.05089998f,-0.10880002f,0.97270004f,0.61460001f,0.49000001f,1.77660000f,-0.19580003f,-0.51849999f,-0.52830003f,-1.96699996f,0.77059999f,-1.19039997f,-1.29599998f,-0.37210002f,0.89609999f,-0.07919998f,-0.03470000f,1.04979997f,0.30280002f,0.29140004f,-0.81750003f,-1.50980009f,-0.00319996f,-0.33989999f,-0.57690004f,1.54690005f,-1.39780003f,0.92130003f,-1.55580001f,0.13510000f,0.41529996f,0.93770002f,-1.51819998f,-1.15030001f,0.57409997f,-0.57980003f,-1.48710006f,-0.05570001f,-1.21340000f,-1.24490000f,0.52620005f,-0.82369999f,1.31510001f,-0.53710001f,0.67859998f,0.94480000f,1.75970000f,-0.32249999f,-1.02800002f,-0.31600002f,0.01030002f,0.11840000f,-0.73670000f,-0.76820001f,-1.06519999f,-0.08570000f,-1.26069998f,-1.09410004f,-1.37360000f,0.59030000f,-1.01569998f,-1.02770001f,0.30010003f,1.50920005f,0.78240003f,-0.71090000f,1.18729999f,0.50100000f,0.49160001f,-0.27039998f,1.53610005f,-0.75950003f,-0.17990002f,0.49420003f,1.87310005f,-0.88639999f,0.22640004f,-0.53880001f,1.10720001f,0.00430001f,-1.42080009f,0.50430007f,-0.10170001f,0.31080000f,-0.88520004f,0.65710003f,-0.46209998f,1.03420001f,0.01280000f,0.82930001f,0.37860003f,1.00620002f,-1.01870004f,0.03479997f,0.40520001f,0.33979996f,-0.37550003f,-1.49580007f,0.82090003f,-0.02649999f,-0.62590001f,-0.91050001f,0.17150000f,0.19300000f,-0.35310003f,-0.76450002f,0.69380004f,-0.34380000f,-0.99400005f,1.42249999f,0.78880001f,-0.84609999f,-0.64580002f,-0.51150000f,-0.06460002f,-1.10030002f,-1.13180005f,-2.14530000f,-0.06600000f,-1.18899998f,0.51679998f,-0.70690002f,1.21320003f,1.62160007f,-2.13410002f,-0.91810004f,1.11490003f,-0.27050000f,-0.42560000f,1.37990006f,-1.19920005f,-0.37240001f,0.33440001f,1.84210009f,-0.89800002f,1.49120004f,-1.10450001f,0.66619999f,0.70930002f,0.19329998f,-0.69100005f,-0.54519996f,-0.19579996f,-1.05010005f,-0.68980003f,-0.41620002f,0.52060003f,-0.86900001f,0.74290005f,0.25210004f,1.65800003f,-0.77970003f,0.17219997f,-0.29170000f,-0.65650000f,-0.40420001f,0.04080001f,0.28180001f,0.11040000f,-0.43909999f,0.20589996f,0.83890001f,1.20219998f,-0.91360000f,1.31459998f,0.97129998f,-0.37689996f,0.81480002f,-0.56749999f,-0.67510000f,0.11599998f,0.61579999f,0.97890003f,-0.23450000f,-0.86820005f,1.20160002f,0.32340002f,0.73339998f,-0.64830001f,0.18080000f,-0.73730003f,1.33939998f,-0.48040002f,-0.04699996f,0.08610000f,-1.26319999f,0.28970001f,-0.33560002f,0.78680002f,-0.38530004f,-0.81160006f,-0.11429998f,1.38860004f,-0.04870002f,0.08409995f,-1.60150001f,-0.06950000f,-0.53249999f,-0.89570004f,-1.11920000f,-0.05109998f,0.60980000f,0.76940007f,1.18970002f,-0.10009999f,-0.43760001f,0.16890001f,-0.25460002f,0.61500001f,0.20010000f,-0.18850000f,0.45019999f,-0.16209999f,0.34169998f,-0.20020000f,-0.56589998f,-0.85650002f,-0.51189999f,0.06140001f,-0.95649999f,-0.14370000f,-0.53900002f,0.05420000f,0.26240003f,-0.16450002f,-0.77710001f,0.10410000f,0.01429999f,-0.17559999f,-0.52030001f,0.68199999f,0.00580000f,0.30679999f,0.99470000f,-0.17229998f,0.15300001f,0.50179997f,0.57170004f,-0.01120002f,0.77630005f,0.73430002f,1.15220003f,0.48529999f,1.06390002f,0.65310000f,0.37770001f,0.20819999f,0.34779999f,0.47409999f,0.16279999f,0.22569999f,-1.05470003f,0.24640000f,0.97069998f,0.28320000f,0.04749998f,-0.74410000f,-0.05330003f,-0.96059997f,-0.53360000f,-0.30519999f,-0.65179999f,-1.53409999f,0.16910002f,-0.43749996f,0.11259999f,-0.05609998f,-0.30740001f,-1.37740002f,0.01740002f,0.76819993f,0.09729997f,0.07680000f,-0.18920002f,1.64930006f,-1.89580004f,0.03510000f,0.76599995f,0.16739999f,1.19489999f,1.68320004f,-0.78970000f,-1.98610010f,1.48480005f,2.03280009f,-1.21570005f,-0.65250001f,0.33700002f,0.05270003f,-0.53190003f,-1.13330001f,0.00550003f,-1.00130000f,0.71620002f,0.88919998f,1.22610001f,0.67770001f,-0.27700004f,0.54040001f,0.58350000f,0.34909998f,1.29660002f,1.11730002f,-0.51940001f,-1.04040000f,-0.18019996f,-0.20060000f,0.65050002f,0.49550002f,0.46800005f,0.76419998f,-0.39719996f,0.20899999f,-0.03450000f,-0.76340001f,0.47319997f,0.61280001f,-0.35189999f,-1.28780000f,-1.44990001f,-0.19540000f,-1.27420001f,0.06120000f,0.01299999f,0.66780001f,-0.84100008f,0.67120007f,0.02679999f,-1.19279996f,0.28530001f,-1.06389999f,0.05490002f,0.53289999f,-0.57960003f,0.30910005f,0.70470001f,0.59659998f,1.41530005f,-0.26950001f,-0.11420000f,0.24020000f,-0.67980005f,-1.69570008f,-0.95980002f,-0.40579999f,-0.36049995f,0.49910001f,0.15980001f,0.43620001f,-0.06030000f,-0.26520001f,0.45220004f,2.04840004f,0.58250002f,0.29949999f,0.20539998f,-0.10770000f,0.08199999f,0.74389999f,0.46830004f,-0.73099999f,0.53919999f,-1.16100003f,-0.99820002f,0.54829997f,-0.98550002f,1.28440002f,-0.73470005f,0.59740001f,-0.68970000f,0.45550001f,-0.99960001f,0.14009996f,-0.52080000f,-0.31550001f,-0.42160001f,-1.18230002f,0.03220002f,0.70480003f,1.01380003f,1.23739998f,0.07559995f,0.21330003f,-1.20750001f,-0.20160002f,0.03729998f,0.01649993f,-0.36560000f,1.79319997f,-0.14129997f,0.12989999f,0.19329999f,0.10939999f,0.62010003f,0.91219999f,0.57940002f,0.44070000f,0.74950002f,0.71440001f,-0.75809997f,0.89970000f,0.74629998f,-1.64399998f,-0.75340004f,-1.25439999f,-0.79130004f,0.06900006f,0.28520004f,0.51880001f,-0.52809999f,0.88070000f,-0.41869997f,0.23459999f,0.28280002f,0.65840002f,-0.23719998f,-0.03140002f,0.53670002f,-1.00620002f,0.47329998f,-1.53700000f,2.04199997f,0.16930008f,-0.35330001f,0.70690001f,-1.31540007f,0.41120000f,-0.75069998f,0.25660000f,0.11999999f,-0.05350001f,-0.96369999f,-0.16139999f,0.90950001f,-0.31300001f,0.31690000f,0.16909996f,0.37339991f,-1.11579998f,-0.54870001f,-0.76919997f,0.32750004f,1.34260003f,0.52190003f,-1.25400001f,-0.38200005f,0.97840000f,-0.13309998f,0.10949997f,-1.66099998f,-0.00670001f,-0.00950002f,0.15109999f,-0.44490005f,0.63260000f,0.58020000f,-0.77289999f,-0.06220003f,0.47430004f,1.32030003f,0.44480000f,0.38910001f,-0.72729999f,-0.56210002f,0.77229998f,-0.98540000f,0.94410000f,-0.18260000f,0.77730002f,0.14849999f,-0.17889997f,-0.55450004f,1.03850002f,0.85940005f,-1.50720002f,0.76370001f,-0.43880001f,-0.38440002f,-1.78630002f,0.84070002f,1.81179998f,-0.45350001f,-0.63460001f,-0.22560002f,-0.34480002f,-0.86909998f,-0.20980000f,0.28819999f,1.93380005f,-1.30200003f,-2.32190001f,1.12320002f,0.50560004f,0.40010001f,-0.13750003f,0.65800000f,-0.61020000f,0.75970001f,0.24790002f,-0.28450002f,-0.07970000f,-0.50399999f,0.92830004f,-1.15490002f,0.90090004f,-0.87030003f,-0.57870004f,0.82459998f,-2.46250000f,-0.39150002f,-0.67919998f,-0.23439999f,0.28740003f,-0.50040001f,-0.36980000f,0.93149998f,-0.18480000f,0.05460001f,0.34370002f,-0.47740003f,0.65980003f,-1.14830004f,-0.36360002f,-0.41420004f,-1.51710001f,0.84869994f,-0.74769998f,1.22190002f,0.11540001f,-0.18140000f,0.47579999f,1.50340001f,-1.01969997f,-0.04870000f,-0.26210000f,-0.05590000f,0.14530001f,-0.43529999f,0.72480004f,1.16610000f,0.67990002f,0.90349996f,-0.00700002f,-0.43970001f,-1.21639999f,0.24000000f,-0.52639999f,0.44459999f,-0.50580000f,-0.34849999f,0.71830001f,-1.12949998f,-0.34700004f,-0.72029997f,-0.31600000f,0.20640000f,-0.42500000f,-0.04170002f,0.62780002f,-0.11680002f,0.16479999f,0.11570002f,-0.26709999f,0.41530003f,-0.75390003f,0.23410003f,-1.10850002f,-0.57389999f,-0.16980006f,-0.48399997f,0.26250000f,-0.06249999f,-0.25410002f,0.54530000f,-1.29109999f,0.21969999f,-0.38550002f,-0.13140000f,0.52090002f,-0.02230000f,0.56259998f,0.14720004f,1.02580002f,0.58830001f,1.67349997f,0.20460001f,0.37539998f,-0.47359999f,0.86189999f,-0.19309998f,-0.54879997f,0.92270000f,0.15789999f,0.63550000f,0.16950000f,-0.60810001f,-0.76000003f,-0.00950000f,-0.77430001f,-1.01220002f,0.07040001f,-1.68620001f,-0.06300005f,1.40180000f,-1.33739998f,-0.97720002f,-0.53140000f,0.20980000f,-0.59969998f,0.34290001f,-0.36539996f,-0.33130000f,0.52510002f,0.42470001f,-1.30910006f,1.56100004f,-0.23509999f,-0.09449998f,0.36129999f,-1.27579998f,-0.64940002f,-0.10330003f,-0.34659994f,0.62709998f,-0.60239999f,0.34319997f,-0.01459997f,-0.41420002f,0.33260001f,-0.26220002f,0.03740000f,1.47409999f,-1.22940004f,-0.33390006f,-0.48410000f,-0.00420003f,1.14030002f,1.21340002f,0.51069993f,-0.57930006f,-0.69439995f,1.80770000f,-0.37859999f,-0.24450000f,-0.01860001f,-0.36770001f,0.44390003f,0.80560003f,-1.26219998f,-0.09390001f,0.23590001f,0.06959999f,0.25240000f,0.22789999f,0.07639997f,-0.71810001f,1.23930006f,-0.21999999f,0.16200001f,0.37890002f,0.31070001f,1.68260002f,0.33480004f,1.22310003f,0.14849998f,0.13370002f,-0.72570001f,0.87870000f,-1.45849995f,-0.06320002f,0.20069999f,0.04680004f,-0.45840000f,0.08680000f,-0.07870003f,0.26730001f,0.35350006f,1.45930005f,-1.18179999f,0.81140001f,-0.70010003f,-0.45239999f,-0.47570004f,0.73240002f,-0.69669995f,0.87759997f,1.46379997f,-0.02540000f,-0.13600002f,-0.09829998f,0.36510002f,0.42090000f,-0.75869999f,-0.57320001f,-0.85209999f,0.30090001f,0.35890003f,0.72290002f,-0.20740002f,0.55230000f,-0.91890005f,0.35780001f,0.03949999f,-0.03340000f,-1.24370002f,-0.26190004f,-2.05550001f,0.06559998f,0.11870006f,-0.55600001f,0.16960000f,0.83710001f,0.08030005f,-0.34630001f,0.85630000f,-0.12159999f,-0.37540003f,0.21970002f,-0.35280001f,0.71100002f,-1.06860005f,0.96270000f,-1.64840002f,1.84380004f,-0.26979996f,0.54590000f,0.26380001f,-0.53660003f,0.29240001f,-0.23790001f,0.23180001f,0.44839998f,0.07070001f,0.53350002f,0.07699998f,0.59210001f,-0.97240002f,0.44869998f,0.10689999f,0.24299994f,-1.08300005f,0.01039999f,-1.14939999f,-0.43600002f,0.81040003f,-0.75199997f,0.28469997f,-0.40250002f,-0.28369995f,-0.08039999f,0.67800004f,-1.42450001f,-0.61770002f,-0.13579998f,0.48000003f,-0.04440002f,0.64190001f,-0.81639999f,0.05380004f,-0.34710004f,0.66130003f,-0.67590004f,0.95320002f,-1.28310002f,1.57330006f,-1.44640003f,0.98130004f,-0.04270004f,-0.90450003f,-0.11389998f,-1.11609999f,0.85969999f,0.46999998f,0.69559999f,0.89900003f,1.65690006f,1.06310006f,1.06380001f,-1.25980000f,0.66360004f,-1.17640000f,0.43510001f,-0.41530000f,0.52570000f,0.12810001f,1.16389999f,-0.08719999f,0.56320000f,0.68209999f,0.60580001f,-0.11099998f,0.47369998f,-0.20530000f,-1.38219998f,-0.84489999f,-1.32449999f,0.55910002f,-0.38369994f,0.00859999f,0.81360002f,0.16880000f,-0.71050003f,1.02750004f,-0.84360003f,1.34150003f,-0.03410000f,0.12530004f,-1.44830006f,1.02930003f,1.04760003f,-0.49080004f,0.32350002f,0.75579997f,1.39830001f,-1.98270000f,-0.77840004f,0.03569998f,0.07430000f,-0.99680001f,0.20200000f,-0.47520001f,0.31080000f,-0.98320003f,0.69689999f,0.11699999f,-0.35609998f,1.16460003f,1.08600001f,1.54159999f,0.31009999f,-0.78420007f,-1.20020003f,-0.05769997f,-0.05589999f,-0.34460001f,-1.33259999f,0.67539995f,0.41589998f,-0.60499996f,-0.86369998f,-1.06290000f,0.01510000f,-0.14170001f,-0.85580003f,0.30049999f,1.45749999f,-0.83760000f,-0.49789999f,0.77499998f,0.40150001f,1.13140002f,-0.38740000f,0.56870003f,0.06679996f,-0.64830002f,0.62390001f,1.15470002f,0.23059997f,0.22350001f,0.38710001f,0.17910000f,0.75360002f,-0.58109999f,-0.36719999f,1.01870007f,-1.04550005f,-1.56570008f,1.04990004f,1.41290003f,0.65810001f,-1.22260001f,-0.15959998f,0.68460000f,1.16909999f,0.51629999f,-0.36950000f,-0.01950001f,-0.29749999f,-0.87360006f,-0.56880001f,0.92360000f,0.21259997f,-0.65690002f,-0.76490001f,0.26240001f,0.16659999f,-0.75169999f,0.27590002f,0.61950000f,-0.43149996f,0.35629999f,-0.41440000f,0.82360004f,0.27700000f,0.24380002f,0.69450001f,-0.78320003f,-0.32110001f,-0.68530002f,-1.97549996f,-0.11219999f,-0.88499999f,0.05060001f,0.45370001f,0.56379997f,-0.51770004f,0.53790003f,0.44690002f,-0.86780000f,-0.42999999f,-0.90600004f,-0.32370003f,-1.05930002f,-0.08980000f,-0.35680004f,1.47320007f,-0.38190007f,0.94220000f,-0.20069998f,-0.78730002f,-0.63700004f,-0.85930006f,-0.79050000f,0.26450000f,0.18120001f,0.10530001f,0.10509998f,0.40310004f,0.23220001f,-0.57469998f,0.88020006f,-1.19900001f,1.36910001f,0.63469997f,0.24419996f,0.00749999f,0.19250000f,0.09389999f,0.30060003f,-0.52820000f,-0.00009996f,-0.11420001f,-1.01959993f,-0.16960000f,-0.77939995f,0.54559999f,-0.35219998f,-0.22930000f,0.38059999f,-0.29230001f,0.33170000f,0.20790001f,-0.13359999f,-0.26280000f,-0.03389999f,-0.70640000f,0.45019997f,-0.89289999f,0.64350002f,-0.64910003f,0.90549998f,-0.77839999f,0.12990001f,-1.09600000f,0.50370001f,-0.97410001f,-0.32079999f,0.63599998f,-0.04210002f,0.24580003f,-0.55710001f,-0.63460002f,-1.34300002f,-0.46620002f,-2.16710002f,0.00660001f,-0.48119999f,0.06299999f,-0.76790000f,-0.19089999f,-0.44979998f,-0.01879998f,-0.86319999f,-0.10229997f,0.11490000f,-0.36030002f,0.08990000f,-0.37670001f,0.28200000f,-1.52240002f,0.78260001f,-0.69880000f,-1.06720004f,0.52449999f,0.07619999f,-1.11439997f,-0.80249998f,-0.25539998f,-0.04050002f,-0.83899993f,0.57360003f,-0.53489997f,-0.15830000f,0.63860001f,0.54200001f,0.26410002f,-0.21929998f,0.92230006f,-2.10200001f,0.02769998f,-0.67709996f,0.65130004f,-0.45270005f,0.71850001f,0.11209999f,0.15539996f,-0.25489996f,1.03060003f,-1.39090003f,-0.68210005f,0.48280002f,-0.12550001f,0.65260002f,0.51660005f,0.42470000f,-0.00799993f,0.63800005f,-2.10299999f,0.42480000f,0.81309998f,0.11749994f,-1.19610004f,-0.15230001f,-0.71880001f,-0.18300003f,0.24060003f,0.25060002f,0.12570001f,-0.14809998f,-0.58850001f,0.21650000f,-0.15320000f,0.67740000f,-0.20550000f,0.16790000f,-0.23710003f,-0.37049995f,-0.07160000f,0.14310003f,0.09760002f,0.37680000f,0.77970002f,1.54050001f,0.25810000f,1.18240002f,-0.73879998f,0.18439999f,-0.68769997f,0.56479999f,-0.62609998f,-0.94980002f,0.95959999f,1.29390002f,-0.92389999f,-0.34390002f,0.89900001f,0.01829997f,0.53990005f,-0.66480001f,0.01360001f,-1.50390007f,0.89900003f,0.63670004f,0.82750000f,-0.88529997f,-0.83780000f,-0.96709999f,-0.36239998f,-0.52000000f,-0.65260002f,-1.21270005f,-0.28540001f,0.65190000f,-0.71290003f,0.01860000f,-1.67360004f,-0.27730001f,-0.51409999f,0.21050001f,0.06580000f,-0.60770004f,-0.42460001f,0.67640001f,-0.59490000f,-0.83410003f,-0.89480002f,-1.03179999f,-1.75760001f,1.02800003f,-0.72459996f,-0.47050001f,0.53010000f,0.35690005f,0.21950000f,0.01290000f,0.67659999f,0.08360001f,0.36700001f,0.48590001f,0.21350004f,-0.30690001f,0.04989999f,0.72160002f,1.31710005f,0.29359997f,0.75750001f,-1.18160000f,-0.41990003f,0.21300000f,0.09850000f,0.09889996f,-0.96330004f,1.02800001f,-0.72400003f,0.01860002f,-0.33080005f,-0.47710003f,0.32810000f,1.59190005f,0.70870002f,1.26029998f,-0.02530001f,-0.51180004f,0.36870003f,0.63080003f,-0.13209999f,-0.18170002f,1.05050001f,-0.05159998f,0.30970000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.08100000f,-1.20089996f,0.30109998f,0.44840003f,1.12190002f,0.43930004f,0.44380000f,-0.20559997f,0.08340000f,0.13469998f,-0.12299999f,0.64389993f,-1.07840002f,-0.52480006f,-1.36510005f,-0.88130002f,0.33350001f,1.05299996f,-1.12339996f,0.44579998f,0.98260003f,0.70159993f,-0.16680000f,-0.15970001f,-1.28680000f,-0.69019996f,-0.56110007f,-0.65799998f,0.62359995f,-0.34889996f,0.06720002f,0.18440002f,0.59190003f,0.00479999f,0.47570000f,1.10590002f,-0.91210001f,0.15080002f,1.16240003f,1.19970003f,-0.42629998f,0.00560000f,-0.07720001f,0.53449994f,1.01020005f,0.56470003f,0.64120003f,0.21069997f,-0.72080004f,0.80480004f,-0.49540001f,-0.37250000f,-2.03300002f,0.14789996f,0.03679996f,-0.91120003f,-2.04960000f,0.30849997f,-0.39890003f,-0.15600001f,0.05629999f,-1.07570004f,1.33240003f,0.88050006f,-0.21119997f,-0.22550002f,-0.08369999f,0.45200002f,1.30039999f,-1.28450006f,-0.10770003f,0.56190004f,1.62820000f,-0.50789998f,0.15649999f,0.43639999f,-0.83190001f,-0.61390000f,-1.00449997f,1.67620006f,0.41859997f,-1.98900007f,0.21640003f,0.10340000f,0.88210000f,-0.34640000f,-0.05929993f,0.60350004f,0.25009998f,0.74619999f,0.89499999f,-0.06850002f,1.68109999f,-0.37279994f,0.87120000f,1.13790002f,0.01910005f,-1.23420003f,0.31460006f,-0.06179999f,-0.40990000f,0.80129999f,-0.78910004f,0.46919997f,-0.08489998f,-0.48840001f,-0.41610001f,-0.57330003f,-0.41560002f,-1.31469997f,0.19649998f,0.93779996f,0.15940000f,-1.15520003f,-0.18150001f,-1.10030003f,0.34940000f,0.20779998f,-0.44629999f,-0.33339996f,1.85710003f,0.70689999f,-0.50240001f,-0.74719996f,-0.86180001f,1.26800000f,-0.61859997f,0.11770000f,0.76259999f,0.83970002f,-1.32370001f,1.70980001f,0.81019999f,-0.25270002f,0.30590001f,-0.71669997f,-0.36499999f,-0.73440001f,0.22359998f,-0.41210003f,0.66820003f,0.31980002f,-0.78810000f,-1.27390006f,0.65629997f,0.00190001f,0.00860001f,0.55500001f,0.17739999f,-0.64709997f,-0.56500002f,0.78350000f,-0.08970001f,0.10550000f,1.01509998f,-0.26919998f,0.45860000f,-0.37270002f,0.00080005f,0.92800005f,1.60479999f,-0.88670001f,-0.93809999f,-0.35310002f,-0.99080001f,0.97420001f,-1.13990002f,-0.15730000f,-1.31389997f,0.49709999f,-0.93099998f,0.81450000f,-0.37210000f,0.14260001f,-0.21960000f,0.10570001f,-1.30870002f,0.13929996f,0.43830001f,-0.42529997f,1.78950000f,0.89790006f,1.09719998f,-0.74099999f,1.21209995f,-0.03769999f,-0.09820001f,0.46760000f,-0.08930004f,-1.02440001f,0.40630000f,-0.02469997f,-0.91420002f,-0.95870006f,-1.20710000f,-0.55390002f,-0.44099995f,0.73930001f,-0.31910001f,0.86910003f,0.31720003f,-0.39850002f,-0.31830000f,-0.42260001f,0.74610003f,0.15330005f,0.17249998f,0.48150005f,0.95910003f,0.33950001f,0.67760001f,-0.64390004f,-0.81390004f,-0.48350005f,-0.05280001f,-0.29969998f,-0.42510003f,-0.45380000f,0.82620002f,-0.18110001f,0.06910000f,-0.13100004f,-1.21290001f,0.90749997f,0.63640006f,0.63099996f,-0.05830002f,0.25399998f,-0.76890002f,0.32800000f,1.42540002f,-0.15900006f,-0.03049997f,0.11420002f,0.28000002f,0.47110000f,-0.45310001f,-0.06350001f,0.48110000f,-1.01539999f,-1.08950002f,-0.66970002f,-0.21840000f,1.83859998f,0.45770003f,-0.20309997f,-0.42579999f,-1.25109999f,-0.92830005f,-1.15059999f,-0.56500003f,1.38180001f,0.77830004f,-0.63739999f,-0.79010002f,0.68210001f,0.19230001f,0.87319999f,-0.02860001f,-0.72070002f,-0.14459997f,0.55000001f,1.20090005f,0.85270003f,0.05530002f,0.85850000f,-0.89130003f,-0.63300003f,-0.04659998f,0.81040001f,0.89420001f,-0.07799999f,0.40159998f,-0.14230000f,-0.41280002f,-1.11919999f,0.04180000f,-0.25029998f,-0.02510002f,0.69700002f,1.62729996f,0.29180000f,0.43579998f,-0.97570002f,0.04870000f,0.54390003f,-1.16250001f,-0.50820003f,0.54850002f,-0.05750001f,-0.12570002f,0.40790001f,1.17000000f,-0.74950000f,2.06119997f,1.39790005f,-0.18630001f,-1.30190003f,-0.10699998f,-0.38370000f,-0.59190001f,0.99900001f,-0.69929997f,-1.10380000f,-0.58200002f,0.80699999f,0.04860000f,-0.05870000f,-0.30810001f,-1.65970000f,-0.39660003f,0.91630003f,0.61900004f,0.29950000f,0.16129999f,-0.64320002f,-0.05320001f,0.75479997f,0.21229998f,-0.52630000f,0.22530001f,0.92379997f,-0.61759999f,0.02339999f,-0.15779998f,0.34419999f,-1.66750004f,-0.02679998f,0.95630007f,-0.05059999f,-0.92800005f,1.36279998f,0.01979999f,0.03429999f,1.49130003f,-0.13739999f,-0.72370000f,-1.16949999f,0.43119999f,-0.44359998f,-0.06100001f,0.32409997f,0.47490001f,0.31760003f,-0.41640001f,-0.17679998f,0.26310001f,0.25149995f,1.38770001f,0.52350002f,-0.80009998f,0.35649999f,-0.06000001f,0.39030002f,-0.58849996f,-1.30460005f,0.21289995f,-0.22550000f,-0.86730000f,-0.35790003f,-0.61090003f,0.02959999f,-0.02470003f,-0.36900000f,0.87899999f,-0.62530001f,-0.28489997f,0.78589999f,-0.24360000f,-0.27730000f,0.27100008f,1.12150003f,1.14269999f,-0.68599999f,0.52899998f,-0.48399999f,-0.29879999f,0.00519997f,-0.01329999f,0.32909999f,-1.17779998f,0.20800003f,0.13050001f,-0.07429999f,0.68959996f,-0.92030000f,0.26279999f,0.90210004f,-0.64410003f,-0.20680005f,-0.47079996f,-0.23490000f,-0.51199999f,0.66689998f,0.52540002f,1.18199998f,0.43810000f,0.42910001f,0.40739997f,1.08059997f,0.90119997f,0.84310000f,-0.05050000f,-1.47130000f,-1.44660002f,-2.13270002f,-0.11779999f,-0.41849999f,-0.98480000f,-1.14829996f,-0.79579997f,-0.33120001f,-1.17430000f,0.03390000f,-0.17790000f,-0.49079998f,0.69120001f,0.66379997f,1.24910002f,1.51990003f,1.22770000f,0.18919999f,0.31220000f,-0.58140002f,-0.53740002f,-0.38000003f,-1.08650003f,0.22490003f,0.81340000f,-0.96360005f,-0.99810000f,0.03369999f,-0.60680002f,-0.33400000f,-0.92320004f,0.63380001f,0.46319999f,-0.50899999f,-0.00540000f,0.76690003f,0.26120000f,-0.78900002f,-0.33440001f,0.03569998f,-0.15020000f,-1.78470000f,-0.95100001f,-0.17340001f,-0.57779999f,0.62800001f,-1.07190002f,-0.46830003f,-0.54220006f,0.46760003f,1.33089999f,-0.38220003f,1.40440003f,0.12250000f,1.12390002f,-1.00670002f,-0.22150000f,-0.14249995f,-0.11899998f,-0.91810000f,-0.39040001f,-0.67720000f,0.90020001f,0.80100002f,-0.30119998f,1.47650005f,-0.55380002f,-0.69380003f,-0.69999998f,0.18470004f,-0.07430000f,-0.65830001f,0.28340001f,0.59509999f,-1.53580002f,-0.80700000f,1.05290000f,0.21229999f,-0.47240003f,-0.96960001f,-0.19349999f,0.37949999f,-0.12100000f,0.73280002f,-0.74590003f,-0.59500001f,-0.39109999f,-0.29030000f,0.48489998f,0.04449999f,-0.07439999f,-0.95229998f,-0.48410001f,-0.69659997f,-1.06500000f,0.59809998f,0.04009997f,0.50789996f,-0.68880003f,1.14419996f,-0.87340002f,0.27900003f,0.36469999f,-1.29659996f,-0.18969999f,-1.04079998f,0.94170005f,0.93819996f,-0.41630004f,-0.75250001f,0.43440000f,-0.47349995f,-0.61449998f,-0.44810000f,-0.12579998f,-1.20990000f,-0.75670002f,0.26790000f,-1.12750004f,0.44349994f,-0.33300003f,-0.00110001f,0.57629998f,0.34100002f,0.38900000f,-0.51200001f,0.10040000f,0.37370001f,-0.80590002f,0.41500003f,1.19490002f,-0.20220000f,0.74480004f,-0.51890003f,0.13440006f,-0.13890004f,0.63160001f,-0.10519998f,-0.77509998f,0.33469999f,0.29650000f,0.43930003f,-0.40730002f,-0.37660001f,-0.43620003f,1.66850003f,0.83480002f,-0.72609999f,-0.10330001f,-1.54860001f,-0.57549996f,-0.46219999f,-0.24249999f,-1.02369997f,-0.84879995f,0.01440001f,-0.39429996f,0.84750001f,0.93420002f,0.72610000f,-0.18620000f,0.24250002f,0.15109997f,0.68599999f,0.39690004f,0.40860003f,-0.29550001f,-1.53350003f,-0.90570000f,-2.10330007f,0.05069997f,-1.26950002f,-0.57400000f,-0.64680000f,0.60420001f,0.70380002f,-0.04159999f,0.41030002f,-0.04479999f,0.71630004f,0.02920000f,0.47270001f,-0.28260001f,-0.12530002f,-0.35330001f,-0.01409997f,0.62119998f,0.07090003f,-0.04830002f,0.05480000f,0.24020001f,1.38409997f,-0.16170000f,1.60239997f,0.22170001f,1.34659998f,0.57870001f,0.65029999f,-0.58130001f,-1.49140000f,-0.15779996f,-2.13299998f,-0.99440002f,-1.06779998f,0.20820000f,0.46930002f,0.09470000f,0.05920000f,-0.40109998f,-0.22579995f,-0.47009996f,-0.79460001f,-1.09580002f,0.28890002f,-0.53960002f,1.08150000f,0.14340001f,0.52269997f,-0.38040000f,-0.60280001f,-0.38550000f,-0.41310001f,-1.05300005f,0.06339999f,-0.01490000f,-0.00400002f,0.31910002f,0.48820000f,0.25139999f,0.33180000f,-0.81250004f,0.58810002f,1.52040002f,-0.83650000f,0.86650006f,0.02719998f,0.19700001f,0.21079999f,-1.29910004f,1.04490002f,0.93550001f,-0.46850001f,0.45159996f,1.02129999f,0.52649996f,-0.54090000f,-0.25610003f,-0.03260000f,1.69929996f,0.00820001f,1.88350001f,0.46120001f,0.04980003f,-0.51560001f,-1.46749998f,0.67419999f,0.78369998f,0.18929999f,1.12970000f,-0.90920003f,0.26510000f,-0.22360001f,0.20490002f,0.45510002f,-1.65439997f,-0.30239995f,-0.25680001f,-1.48150001f,0.32770000f,-1.07090004f,0.71829999f,0.08200000f,-1.40960002f,0.17060002f,0.55800001f,0.15850000f,-0.18900001f,0.18010001f,0.18630000f,-0.97210002f,0.07570001f,-0.62870002f,0.30049999f,1.10330000f,-0.77049998f,-0.10570000f,-0.38750000f,0.32400003f,0.07479997f,-0.50800001f,0.54640002f,0.17699999f,0.07580000f,-0.31770000f,-0.68860000f,-0.31690001f,-0.25920003f,0.07500002f,0.02680001f,1.94699993f,-0.07930001f,1.64229997f,0.10970000f,-0.73429999f,-0.04410001f,-0.77250005f,1.06529998f,-0.35400001f,-0.18520000f,-0.57360001f,-0.07160001f,-0.33749999f,-0.28619999f,-0.10280000f,0.38040003f,-1.85519996f,-0.24220000f,0.33200002f,-0.60449998f,0.60199999f,-0.03250001f,-0.12599999f,-0.38450004f,0.74259996f,0.82829998f,0.27740000f,0.76919999f,-0.64100002f,-0.65869999f,0.65350000f,-0.27900001f,-0.48290000f,-0.66610003f,0.06450000f,0.11809999f,0.35089998f,0.21450000f,-0.36489999f,-0.08220002f,0.30520000f,-0.34050000f,-0.23439997f,0.54990002f,0.27450000f,-1.06449998f,-0.59910001f,-0.84450000f,0.27059998f,-0.32239999f,0.54430000f,-1.06799999f,-0.93329999f,0.12919996f,0.34519999f,1.16309998f,-0.50209998f,0.49789999f,1.53160000f,0.87410001f,-0.04959999f,-0.30659998f,-0.38400002f,-0.54580000f,0.04250001f,0.50799999f,0.09149999f,0.70889998f,1.17990000f,-0.84419995f,0.19430002f,-0.22980000f,-0.87039999f,-0.49619997f,0.00250004f,0.24559996f,0.06269999f,0.57790002f,0.96440000f,0.63010003f,0.55469999f,-1.54130000f,-0.86460001f,-0.04730002f,0.89289997f,-0.29269998f,0.55649998f,-0.45160000f,0.55989998f,-0.80399999f,-0.55650004f,-0.99220001f,-0.15009995f,0.74180003f,-0.53199996f,0.58640000f,-1.49619999f,-1.21690004f,0.25400004f,0.29929996f,-0.61539998f,0.78820000f,-1.26869995f,-0.30470005f,-0.92029999f,0.95170000f,0.04730003f,0.30290001f,-0.13610000f,0.65760007f,0.44709996f,-0.97360004f,0.65359998f,-0.32129999f,-0.54080002f,0.65079997f,1.23970004f,0.58840002f,0.62079999f,-1.07050002f,1.23060001f,0.80810003f,1.20390003f,0.71910003f,-0.19189997f,-1.38450003f,-1.62480000f,0.21329998f,-0.56960002f,-0.83320004f,0.28950001f,-0.28470006f,-1.43760003f,-0.45400000f,0.75470003f,-1.51099999f,-0.48820002f,-0.31190002f,-0.53320001f,0.47500002f,0.96470004f,0.55230005f,0.94010004f,1.88950003f,0.13500004f,-0.65139997f,0.20159999f,-0.50399999f,-0.97890004f,0.26330006f,1.01700007f,0.80759997f,-2.09900006f,0.01170001f,0.29329999f,0.65840003f,0.96400004f,0.09469999f,-0.61170004f,-0.47000000f,1.06000003f,0.64679999f,-0.95000002f,-0.24860000f,0.33280002f,0.42020006f,-1.31080002f,0.12749999f,0.32940003f,0.75230004f,-0.93530000f,-0.40760002f,0.13400000f,2.48849996f,0.25930003f,0.18660003f,0.00429997f,0.64949999f,-0.52129996f,1.04460006f,-0.45230001f,0.54220000f,0.75200002f,0.65220002f,1.23230002f,-0.06070001f,0.17580002f,0.67310001f,0.47310000f,-1.21280000f,-1.19439996f,0.66569999f,1.00039996f,0.26960003f,-1.09599995f,-0.01850005f,-0.85030001f,0.63680002f,-0.59239999f,-0.61890006f,0.10140000f,-0.10550000f,0.05010003f,-0.70060004f,-0.49830000f,-0.75209998f,1.37650002f,-0.45529999f,-0.24629998f,0.42139999f,1.63129994f,-1.33209999f,1.16610001f,0.02520000f,0.59899999f,0.16890000f,0.09190005f,-0.55000001f,-0.02470003f,1.19100001f,0.21600001f,1.05010000f,-0.83609998f,-1.72319999f,-0.18340000f,0.62749998f,-0.39869998f,0.47369999f,1.36730004f,0.46190007f,-0.20049998f,-1.00880003f,-0.41580003f,-1.10420003f,-0.28149999f,-0.55340002f,-0.72690003f,0.34139997f,0.81379999f,-1.43159995f,0.04289998f,-0.72010004f,-0.28200002f,-0.99010005f,-0.54470006f,-0.85719997f,0.95090000f,0.07690000f,0.27090001f,0.49940002f,-0.07779999f,0.62999998f,0.65640002f,0.09680000f,1.44720004f,0.82589994f,-1.47799995f,0.86499997f,0.69949998f,0.34459997f,0.12280000f,0.94999998f,0.24190007f,-0.25010001f,-0.64930002f,0.55670000f,0.12380002f,-0.31290001f,-0.78790002f,-1.80289999f,-0.20270007f,0.99769998f,1.06460005f,-0.99159998f,-0.91390006f,-1.54540003f,-0.70610001f,-0.14800002f,1.24420003f,0.81710003f,-0.82589999f,0.33129999f,0.93320001f,0.58450003f,0.97150005f,0.48310004f,0.69919994f,-0.73210001f,-0.29749997f,0.26190000f,1.08849998f,1.00500003f,-0.51400000f,-0.48520004f,0.01509997f,-0.75280005f,-1.77609999f,0.10349999f,0.27559998f,-0.25650000f,-0.63979999f,-0.12540002f,-0.39799998f,0.34629993f,0.50010000f,-0.04629993f,-0.90829996f,1.07909999f,0.93639995f,-0.78730000f,-0.78510003f,0.37760001f,0.57609998f,-0.83079998f,-0.03460000f,0.77590001f,-0.20900000f,-0.34280001f,-0.89200001f,1.17140001f,0.44620000f,-0.36020002f,0.00110001f,-1.42890001f,-0.46310002f,0.67110001f,-0.27360005f,0.52360002f,-0.03659998f,-0.09169998f,-1.17450004f,0.24469994f,0.95240000f,0.29150001f,-0.15250001f,0.67520001f,0.16360001f,-0.18130000f,0.31940001f,-0.28559997f,0.05550000f,0.48419999f,-0.26550000f,0.40720001f,-0.61760001f,0.84820002f,0.59800004f,0.58129996f,-1.36209999f,-0.72600000f,0.32900000f,0.05219998f,1.43380007f,-0.60359996f,-1.37620003f,-0.37330002f,-0.65660002f,0.42150000f,1.08080001f,-1.15530002f,-0.22600000f,-0.98019997f,0.90590000f,-1.01549998f,-0.80760004f,0.36520005f,0.43520001f,0.11109998f,-0.23050001f,-0.98990000f,0.59049998f,-0.00070005f,0.12930001f,-0.02639999f,0.49170000f,0.35249999f,-0.45010000f,0.82449999f,-0.21559999f,-0.35339997f,-1.14610001f,1.12250001f,1.11620004f,-0.09760000f,0.15350001f,-0.25910001f,-0.12260002f,0.10730001f,-0.16689999f,-0.42990001f,1.03929998f,0.04980001f,-0.56969996f,0.34929999f,-0.00559998f,0.50989999f,-0.65130002f,-0.49840002f,-0.13190002f,-0.21770000f,0.85150002f,-0.21900000f,0.43079999f,1.15050003f,-1.13109999f,-1.00080000f,-1.27539998f,0.82330000f,1.04139996f,-0.70309998f,0.33639998f,-0.35600001f,0.22419999f,-0.88940003f,0.40440001f,0.36809999f,-1.32590000f,0.28620000f,0.30860002f,-0.17590001f,0.27840004f,0.70570004f,0.17489997f,0.62669999f,-1.31559997f,-1.30090000f,-1.29680000f,-0.38890004f,0.90849996f,0.79830004f,0.94129999f,0.62930002f,0.56929998f,0.43040003f,0.44970004f,-1.24940002f,-0.76390004f,-0.15090002f,0.04500001f,0.28030001f,0.63810001f,0.20390002f,0.72539999f,-0.72810002f,-0.59900001f,-0.73520000f,-0.79310003f,0.34240000f,-0.17710000f,0.17110001f,0.33989999f,-1.04220000f,0.74550001f,0.30040002f,1.24650006f,0.57079998f,0.51010004f,-0.02800003f,0.20680000f,0.67579995f,-0.46990001f,-0.72560001f,-0.66350000f,-1.01810000f,0.40120002f,0.74650000f,0.23820004f,1.37250000f,-0.78290001f,0.56819997f,0.78729999f,-0.87679999f,-0.18429999f,0.50449997f,-0.50389999f,0.58319999f,-0.30360003f,0.56449998f,0.06040000f,-0.08299999f,-1.77649994f,-1.16329997f,-2.35419995f,-0.45769996f,0.68150002f,0.33520000f,1.15680003f,1.01600000f,0.72840003f,1.23420003f,0.37759998f,0.64310001f,0.21640000f,1.33639998f,0.64439997f,1.39380002f,1.69569998f,0.58039996f,0.07579999f,0.10219999f,-1.68090000f,-1.27610000f,0.06880001f,-0.65039999f,-0.25319999f,0.15420001f,0.23249998f,-0.16220000f,-0.29660002f,-0.67250002f,0.25170003f,-0.25350001f,-0.73100001f,-0.28650002f,0.30140001f,0.11329999f,0.33520003f,1.62990004f,-0.40810002f,-0.08639997f,0.65320001f,-0.54539997f,-1.45680002f,-1.32619996f,-0.31589997f,0.36590001f,-0.28710002f,0.16930003f,-0.82020002f,-0.19009999f,0.24200001f,1.36410000f,1.38770000f,1.94740003f,0.00440004f,0.33900003f,0.18420000f,-0.08819997f,0.25469996f,0.10530000f,0.47909999f,-1.02550001f,-1.41910004f,0.04640001f,0.44590004f,-0.26380000f,-0.12369999f,-1.39530002f,-0.78550002f,0.07789998f,0.27560000f,0.46630000f,-0.45020003f,0.01220001f,-0.10059999f,1.06360003f,0.28299996f,-0.38479999f,0.34579999f,0.18369998f,-0.43670005f,0.26250003f,1.08880001f,-0.84150003f,-1.51770001f,0.62180001f,1.25049996f,-0.89250000f,0.10750003f,0.13339999f,-0.25810001f,-0.37790001f,1.95499998f,1.12709999f,2.45880001f,-0.01030002f,1.37509997f,1.07759998f,1.92279999f,-1.36669998f,-0.00199998f,0.07049996f,1.27189997f,-0.49599996f,1.52789998f,-0.96100005f,0.64530001f,0.10660000f,0.61360003f,0.23180004f,0.20400001f,0.34690004f,-0.49079997f,0.34000002f,-0.27630000f,0.47160003f,0.44960003f,0.00460001f,-1.71209998f,-0.34899998f,-0.32509997f,-1.11219999f,-0.81159999f,-1.03649998f,-0.39030002f,-0.87620003f,0.02939999f,0.04039999f,-0.97430001f,-0.23159998f,-0.12380002f,0.45490000f,0.18569998f,0.50800004f,-0.17380001f,-0.01110000f,-0.28690000f,0.34010001f,-0.28130004f,-0.98830001f,0.91389999f,0.52860001f,-0.28120000f,0.07629999f,-0.25629997f,-1.04139995f,-1.00549999f,-1.98949999f,-0.54649997f,0.14129996f,-0.25060000f,-0.39589997f,-0.69859997f,-1.72779997f,-1.32190000f,-1.79529998f,0.06439998f,0.54399998f,0.23610000f,1.02480001f,-0.16839999f,0.90609998f,-0.31320001f,0.02250001f,-0.14569999f,-1.26419998f,-1.73610000f,0.68579998f,-0.79840001f,0.17099999f,-0.59859999f,0.06500001f,-0.99069999f,-1.63980002f,-0.90740001f,0.23800000f,-0.28070001f,0.64780002f,0.28690002f,-0.02049998f,1.23950002f,-0.85690001f,-1.14079999f,1.41959999f,1.43570002f,-0.96680002f,-0.00669999f,0.46940001f,0.27239999f,-0.00880001f,-0.84410000f,-0.10520001f,-0.24000001f,-0.12800000f,1.18789999f,1.07629999f,1.42850002f,-0.29979999f,-1.25459996f,-0.16970002f,0.19019998f,0.80280003f,1.00629997f,0.21150001f,-1.51600003f,-1.33950000f,-1.17750003f,0.10189999f,-0.45339997f,-0.21359999f,-0.53490001f,0.21960000f,0.34979998f,0.53989998f,1.54420000f,0.19659998f,-1.64460001f,0.05849999f,0.72740002f,-1.04050004f,1.06990001f,0.73780003f,-0.38009999f,-0.40209997f,0.15119998f,-0.13760000f,-0.12250000f,0.22400000f,-0.68259999f,0.10880006f,0.56829995f,-0.45660005f,1.27070004f,0.30170001f,-0.95890001f,-0.39890002f,-0.05689999f,-0.41980000f,0.53250000f,-0.27130000f,-0.02689997f,0.79110002f,-0.15070001f,-0.54730000f,-0.11250000f,-1.30289995f,-0.01780000f,-1.21970000f,0.05290000f,1.41219998f,0.58740000f,0.64920001f,0.57990002f,-1.27080002f,0.04279998f,-0.49310003f,1.34089998f,0.52390001f,-1.02369999f,-0.78349996f,-0.06769999f,-0.17990000f,0.02199999f,-0.22900000f,-0.19090006f,-1.20430000f,0.06420004f,1.09030002f,0.22720002f,0.75320000f,1.02470002f,0.12680001f,1.18330002f,0.38129995f,0.71049996f,0.69500002f,0.70589998f,-0.46280000f,-0.51130000f,-0.85040001f,-0.37509997f,0.47869997f,-0.86890002f,1.12400002f,0.94709998f,-0.70020000f,-0.09029998f,0.37459999f,-0.16320001f,0.24590001f,0.26190000f,-0.84240001f,-1.37440007f,0.62610003f,0.49370000f,-0.51850002f,-1.50479995f,0.43470003f,-1.98419998f,0.16749998f,-0.16080003f,-0.43809997f,0.67529999f,-0.14629999f,0.64960000f,0.13609998f,1.39239996f,0.03339998f,-0.38149999f,0.22260000f,-0.39410001f,-0.02820000f,0.47860000f,-0.27610004f,0.46429998f,0.25649996f,-0.28599999f,1.21560003f,-0.15789999f,-0.68059999f,-0.61949998f,-0.58539998f,-0.82169998f,-0.37059997f,1.26290000f,0.36190001f,-0.60610002f,1.04110004f,0.28770002f,0.22820001f,-0.18760001f,0.14950000f,-0.71480002f,-0.04469999f,0.78519999f,1.12370003f,-0.51349999f,-0.16049999f,0.27259998f,-1.30870005f,0.69820002f,0.14789999f,-0.61710002f,0.62300003f,-0.15630002f,-0.05260001f,-0.04499998f,-0.55540000f,-0.39289999f,-0.86910000f,-0.10569997f,0.47099996f,0.59539999f,0.24880000f,0.02960003f,-1.96529997f,-0.39170001f,-0.79730002f,-0.53679999f,0.61039998f,-0.88320002f,0.94629996f,0.28680000f,0.85750001f,0.27600003f,0.07369998f,-0.71800003f,-1.19009997f,-0.77300000f,0.86229998f,-0.88560001f,1.08660001f,0.66710001f,-0.44789999f,1.12300007f,-0.41509997f,-0.29019998f,-1.10119998f,-1.44610002f,-0.21910002f,-0.88760002f,-0.30010001f,0.37980002f,0.91530001f,-0.01799999f,0.40960001f,0.26690003f,0.67980001f,0.36780005f,0.08230000f,0.62509997f,-0.50730000f,0.89040003f,-0.30399999f,1.81579996f,-0.10269999f,-0.81549997f,0.31389999f,0.64579999f,1.38050007f,-0.02160002f,-0.74860001f,0.04599998f,-0.74210001f,-0.71540002f,-0.87640001f,0.06250001f,0.62299997f,-1.25040001f,0.17640002f,-1.67969995f,1.15769998f,1.02599998f,-0.76669999f,-0.13470000f,0.00890000f,0.78459999f,-0.55679998f,-1.12890004f,1.02680003f,-1.38210000f,-0.35010005f,-0.09410001f,-0.83680001f,0.36340001f,0.89990003f,0.24720001f,-0.37610000f,1.19989998f,1.15070004f,0.45780004f,-0.89220002f,-0.42940001f,0.12310001f,0.52820001f,2.05050001f,0.13970002f,0.66989999f,0.07710001f,-1.49729999f,-0.55750005f,-0.44080003f,-0.02640001f,-1.48050002f,-0.26980001f,0.13670000f,-0.05770001f,-0.30290000f,0.50860002f,-0.14819997f,0.56730001f,-0.33350003f,1.62940003f,-0.66450001f,-0.20860002f,0.47579996f,-1.49930001f,0.57430000f,1.21110005f,0.81429998f,-0.84150001f,-0.27300001f,0.26420002f,0.23700003f,-0.36080001f,0.75849999f,-0.49230000f,-1.24490004f,0.19259999f,-0.03200002f,0.87670003f,0.74229998f,0.75169999f,2.14439999f,0.08340003f,-0.16679997f,-0.82209998f,0.43070000f,1.17060002f,-0.55089997f,-1.25260005f,0.73610001f,0.86050003f,0.44410002f,0.87069995f,-1.24310003f,-0.62030002f,-0.85660002f,-1.00650003f,-0.47250001f,-0.94009997f,0.55959999f,0.35900002f,0.01139999f,0.59939999f,0.01770001f,-0.78860004f,-0.41070001f,-0.72900002f,0.06050000f,-1.43279999f,-0.00590005f,-0.06770000f,0.34700004f,0.13840001f,-0.06829998f,0.58279998f,-0.69460001f,-0.26330003f,0.10189998f,0.66210001f,0.41970002f,-0.31019996f,-0.96250005f,1.34280001f,0.64630004f,-0.42710001f,-0.40510001f,-0.61020004f,1.09980001f,-0.02629998f,-0.74799999f,-0.39869999f,-0.59290000f,-1.41479999f,-0.18110000f,-0.87400001f,-0.79930005f,-1.28370004f,0.67700000f,-0.53199999f,0.13519999f,0.23710001f,-0.54510000f,0.17160001f,1.44619997f,-0.15580001f,-0.16509998f,0.68470000f,0.42690003f,0.69730002f,1.23300003f,0.56460003f,0.27750003f,0.12020003f,1.59320002f,-0.58910001f,-0.25970001f,0.08999999f,-1.00019998f,0.42429999f,-0.82819999f,0.96730001f,0.19699999f,-0.49079998f,0.31389998f,0.24420001f,-0.19040003f,0.94080001f,-0.52570002f,-0.77600004f,-1.77580000f,0.83030001f,0.37900001f,0.19540002f,0.77569997f,-0.48029999f,-0.03070001f,0.31070000f,0.94809999f,0.45180001f,-0.78169998f,-1.61730004f,0.57059999f,0.16610000f,-0.04859999f,1.71250008f,-1.15530001f,-0.40070005f,-0.08210002f,-0.02280000f,0.79080001f,-0.23819999f,0.66940001f,0.21400002f,-0.57940000f,-0.62810000f,0.94910000f,-1.13890000f,-0.09050000f,-1.43890003f,-0.79320004f,1.84320003f,0.11480002f,1.25710000f,0.34510002f,0.42019998f,-0.80670001f,-0.52640000f,-0.10560002f,-0.60550000f,0.24299999f,1.30020000f,0.52860002f,0.57789995f,-1.03670000f,0.72999998f,-0.53930006f,-1.74580001f,2.39160005f,-1.11469998f,0.08159996f,-1.15819995f,-1.48130002f,0.06720002f,-0.12769999f,1.37479998f,0.28320002f,0.01809998f,-0.30110000f,0.52350002f,1.11550005f,0.92090004f,-1.17410002f,-1.48550000f,0.81629999f,-0.25100002f,0.22880001f,-0.33519994f,-1.44810002f,-1.03029998f,-0.38340002f,-0.65520000f,1.49590003f,-0.58200001f,-0.03780001f,-0.47880003f,0.56469995f,-0.28930000f,-1.22630000f,0.79610002f,1.94919997f,-0.08789997f,0.20700001f,0.39299997f,-0.28370000f,0.56860002f,-0.65680005f,-0.76690004f,0.45279997f,-0.16260000f,-0.22060002f,-0.14560000f,-0.36979995f,0.85300003f,1.24120002f,-0.74460003f,-0.84959998f,1.84820002f,0.23890000f,-0.44510000f,-0.18659999f,-0.58630000f,0.64500000f,-0.15160006f,-0.32099999f,1.89640007f,-0.68809998f,-0.38080001f,-0.53680001f,-0.40860001f,-1.16390004f,0.65620000f,0.12560000f,0.57320001f,-0.07189999f,-0.63110001f,0.34779995f,0.96980003f,1.09349999f,-0.59000003f,0.46700000f,1.21980005f,0.86070001f,0.41450000f,0.53250002f,-0.56530000f,0.02090001f,0.21409998f,-1.03610002f,-0.48970000f,0.29440000f,-0.23589999f,0.04050001f,0.81990001f,-1.18380000f,-0.85960005f,-0.14190001f,0.06569995f,-0.93500000f,-0.62550000f,0.20109999f,-0.89239998f,0.51250000f,-0.56660001f,0.46380002f,0.21269999f,0.81200001f,-0.59810002f,-0.60750004f,-1.60059998f,-0.57909999f,-0.06469992f,-0.45880005f,0.22000004f,0.30720003f,0.55389999f,0.29490001f,1.15099998f,-0.31049999f,0.26529999f,0.43060000f,-0.11350001f,-1.04090000f,1.45860001f,-0.04830000f,0.06059999f,-0.42080000f,0.70889999f,0.50479999f,-0.05320001f,0.22710001f,-0.48390000f,-0.15119999f,0.87279998f,0.69690003f,-0.42089999f,-0.79080003f,0.80280000f,-0.99599999f,-0.23710001f,0.15339999f,0.37880003f,0.20840001f,-0.73219998f,0.47869999f,0.31190001f,1.17710000f,-0.42900000f,0.58710001f,-0.53890001f,0.15680001f,0.56060001f,0.47060000f,0.06050001f,0.41519999f,-2.24710000f,-0.53889996f,-0.11690003f,-0.37129998f,-0.74140002f,0.06580003f,0.92989996f,-1.35110000f,-0.46890005f,-0.99759998f,0.08870001f,0.72110002f,0.45850003f,-0.71749999f,-0.52270003f,0.47120000f,-0.80329999f,0.19850001f,-0.07500002f,0.31930000f,0.49610000f,0.56810001f,2.03259996f,0.97569998f,1.37539996f,0.70690000f,-0.96850004f,0.69369999f,0.10189996f,-0.37269998f,0.38389998f,0.16430000f,-0.04399998f,-0.43260001f,-0.75640001f,-1.04460004f,0.06409999f,-0.31200001f,-1.43849997f,0.26790005f,1.11200004f,0.75510002f,1.05999999f,1.51910003f,-0.11019999f,1.68690001f,0.35540001f,-0.52710001f,-0.11980001f,-0.28450000f,0.53180000f,-0.36680002f,-0.79179998f,0.63780001f,0.16950001f,1.05590001f,0.24920001f,-0.06999998f,-0.06180002f,0.14390001f,-0.64380003f,-0.72950001f,0.27360002f,-0.38730000f,0.30699999f,0.27479999f,-0.48580000f,0.73349996f,1.15820000f,0.77549993f,0.51340000f,-0.05750006f,-0.20839997f,0.17060002f,-0.73860001f,-0.73719998f,-0.77899999f,-1.14280002f,-0.22190000f,-1.01789997f,-0.69380002f,0.53959998f,0.21050000f,1.09890001f,0.50390004f,0.59170002f,0.43780002f,0.17659999f,0.45669998f,0.11950001f,-0.49670000f,0.32470002f,-0.22899997f,-0.16800000f,-1.04730003f,0.12089998f,0.11040001f,-1.29109999f,-0.31590000f,-0.02410001f,-0.65190002f,0.46120001f,0.68839999f,-0.69889999f,-0.20029999f,-0.30810002f,-0.35110001f,-0.06360000f,-1.30340005f,0.67290003f,0.67670001f,-1.18030001f,-0.27140000f,0.73510000f,0.86200002f,-1.03390002f,-0.84870001f,0.28650000f,0.46139997f,-0.31880000f,-1.10270004f,-0.93200000f,-1.87360000f,-1.15139997f,-0.96040000f,0.10510000f,1.42179997f,0.37229998f,0.54630001f,-0.35570001f,0.31460000f,-0.54680001f,-0.28319996f,-0.20329999f,-0.98760000f,1.08630000f,1.45410002f,1.17190003f,0.30470000f,0.06759999f,-0.56019998f,-0.57949999f,-1.55209998f,-0.17019993f,1.02349999f,0.02490000f,-1.12600001f,-0.01060002f,1.03730000f,-0.56970002f,-0.52870002f,-0.16370001f,0.07380000f,0.72800000f,0.09809999f,0.21380000f,0.34160000f,0.25430000f,0.08470001f,0.67570002f,0.16810001f,-0.57830002f,1.01700003f,1.18160004f,-0.49750003f,0.56880002f,0.02369999f,-0.38949999f,0.36810000f,-0.12550001f,-0.41560000f,0.07429993f,0.25930000f,1.02319998f,0.80810001f,0.70889999f,0.92350001f,0.05730001f,1.31570003f,0.11730004f,-0.39539999f,-0.38700001f,-0.67509998f,-0.55659999f,0.11990000f,-0.05899998f,0.68040000f,-0.34809997f,-0.14209999f,-0.45630000f,-0.68230000f,0.13419999f,-0.15930000f,0.54019997f,0.08989997f,0.55199999f,1.50780003f,0.64470003f,0.22370000f,-0.23650000f,-1.06340001f,-0.29370001f,-0.48210000f,-0.57580003f,-0.24919999f,0.47180002f,0.50650003f,-0.64150002f,-1.77110006f,0.38340004f,-0.15710001f,-0.13220000f,0.20310002f,0.64529999f,0.15879996f,0.49310001f,0.37680000f,-1.02770002f,-0.45380001f,-0.00200000f,-0.78510000f,-0.34749999f,0.48599998f,-0.00559998f,-0.54629997f,0.36880000f,-1.91710000f,0.71319999f,-0.37380001f,1.17579999f,0.59990000f,-0.63230001f,0.79019997f,-0.66520000f,0.37289999f,-0.05070000f,-0.21790001f,-0.86170003f,-1.50350000f,-1.58990001f,1.16300001f,-0.41340001f,0.67700000f,1.72090008f,0.07689996f,0.84029998f,0.41730001f,0.94259998f,-0.32539997f,0.73060004f,0.01770003f,-0.83989998f,-0.36030001f,-0.36829999f,0.19379999f,0.63249999f,-0.68610001f,-1.14530001f,0.39350002f,1.31070002f,-0.68850003f,0.00800001f,1.26310001f,0.56690001f,-0.42300001f,0.01600000f,-0.48420000f,-0.12529997f,0.06289996f,-0.18540001f,0.63580002f,-0.00070003f,-1.10220002f,0.13409997f,1.16449998f,0.64570003f,0.09570003f,-0.51580002f,-0.21150004f,0.63289997f,0.48410000f,0.88230002f,-0.03490002f,-1.99209997f,-0.08909999f,-2.02050002f,0.00160000f,-0.61320001f,0.73580001f,-0.55630002f,-0.85220004f,-0.07940003f,0.27189998f,0.79760001f,-0.05150004f,-1.19640000f,-0.45980000f,0.47329999f,-0.58580004f,1.50669998f,0.67010000f,0.22819999f,0.08909994f,0.02499999f,0.28079999f,-0.15700000f,0.57220002f,-0.49540001f,-0.60419999f,0.36870001f,-0.95630003f,0.59870002f,-0.03360000f,0.08999999f,-0.50780000f,-0.79310001f,0.04599996f,-0.42439999f,0.12290001f,-0.33700001f,-0.27889999f,0.03350000f,-0.51010000f,-0.80459998f,-1.94860000f,0.16000001f,-1.04799999f,1.17449999f,-0.06489998f,-0.85150003f,0.26129999f,0.16879997f,0.23759997f,-1.20889999f,-0.80470003f,-0.86799999f,0.07800002f,0.12830000f,0.29240002f,0.52570000f,0.97040001f,0.28920000f,-0.24340002f,-0.18710001f,0.52989998f,1.44010002f,-0.26879998f,1.08270000f,0.43800003f,0.27729999f,-0.20190001f,0.03730000f,-0.79719999f,-1.31550000f,-0.30090001f,-0.64090000f,-0.21960003f,-0.56630000f,1.15970002f,-0.71550004f,-0.01879997f,0.10779999f,-0.60899999f,-0.94180003f,0.12340002f,-0.23290006f,0.48740002f,0.82640002f,-0.96460003f,-0.76910001f,0.79600001f,0.66840000f,-0.31999999f,0.11219996f,-0.03660004f,0.40419999f,0.62119999f,1.52999999f,-0.01630000f,0.26880002f,1.09830001f,0.16019999f,0.46539999f,0.89789997f,-0.29840001f,-0.04780000f,0.34659999f,0.61199996f,0.18700000f,0.94230000f,-1.02770005f,-0.32500002f,0.55259999f,-0.55360000f,0.46730001f,0.79650000f,0.95730000f,0.04020000f,1.04530003f,0.01100001f,1.51410006f,0.86370002f,0.14239999f,-1.12120000f,0.01189999f,0.37390000f,-0.01860000f,-0.12670000f,-0.17509998f,0.44940000f,-0.63110002f,-0.56930002f,0.04770001f,-0.02569999f,1.11349995f,-1.09150001f,0.51400000f,0.39210000f,0.79100001f,-1.06269999f,-1.21900001f,-0.36380001f,-0.12180001f,0.20680001f,0.58499996f,1.05990003f,0.01449998f,-0.64320001f,-1.22419998f,0.15620002f,-1.64329999f,0.90649997f,-0.25460001f,0.96910000f,-2.10460001f,-0.08109998f,0.95830003f,-0.18409999f,-0.70399999f,0.22539999f,0.35210000f,0.05020001f,0.09459999f,0.03369999f,0.97720002f,-0.45959998f,0.49230001f,-0.14760000f,0.14359997f,1.24170002f,2.17209999f,0.01280001f,-0.08699997f,-1.40670002f,0.18539999f,0.11840000f,-0.64720001f,-0.03349999f,0.08620000f,0.44169999f,-0.41560001f,-1.41770000f,0.43999999f,-0.51260001f,-0.34990000f,0.34280000f,-0.96140000f,-0.96439996f,1.32390000f,0.07240001f,0.30800001f,0.39340000f,0.35820001f,0.76400001f,-0.32300001f,-0.52639999f,-0.08969999f,1.92480001f,-0.37779999f,0.15909997f,-0.52070003f,-0.55580000f,0.35470006f,1.44690000f,-0.21039999f,0.20799997f,-0.82460003f,0.76370000f,0.40569999f,-0.84160001f,-0.12360000f,-0.03029999f,0.29399999f,0.02610000f,-0.65780000f,0.59240000f,0.93890001f,-0.96240001f,0.27380002f,0.61730001f,-0.45230003f,1.67430002f,-0.65159995f,-0.31270001f,1.45950001f,-1.27210002f,-0.38940001f,0.25850001f,-0.65350001f,-0.06380000f,-1.54280000f,-0.47730002f,0.11829997f,0.51739999f,0.34209999f,-0.55720002f,-1.93280006f,0.07369996f,-2.28129999f,0.04729997f,1.81449997f,0.39530003f,-0.01790000f,-0.00510001f,-0.96659999f,0.46370000f,0.74199999f,-1.08340000f,0.35479999f,1.45860000f,-0.43780001f,-0.27339994f,1.43530002f,-0.75920001f,1.56649996f,-1.20239997f,-0.62390000f,2.64800005f,0.36319998f,-0.56069997f,0.59469998f,-0.52090000f,0.07569998f,-0.14570002f,0.72909999f,0.33250001f,0.30320005f,0.59310003f,-0.49050000f,-0.40190001f,-0.29079996f,0.05490002f,0.74770000f,1.15320000f,-0.72539996f,-0.17610002f,-0.55130001f,0.69330003f,-0.52960003f,0.52330002f,-0.23500001f,-0.98600002f,-0.75450005f,0.55209999f,0.54580000f,-1.04140002f,-0.84810005f,-1.11330004f,-0.26500001f,-0.95820006f,-0.50210001f,0.10369996f,-0.43600002f,-0.35460000f,-0.12530001f,0.27720000f,-0.40060002f,0.17939998f,-1.00620003f,-0.28489999f,1.68060003f,0.68379997f,-1.41450001f,0.40610003f,1.05580005f,0.58960000f,-0.23280004f,-1.46319999f,0.72719998f,0.75499999f,0.93920005f,-1.17330002f,0.10840001f,-0.58430000f,-0.11550001f,-0.01440000f,0.51290002f,-1.23340004f,0.04429999f,-0.09090001f,-0.93690001f,0.49999999f,-0.03200000f,0.33199999f,1.06410002f,-0.93180000f,-0.68580004f,0.91690001f,-0.01799996f,-0.63730002f,0.57979999f,-0.58470001f,0.31650002f,0.90380002f,0.97080002f,-0.02639999f,-0.38339997f,0.12309999f,-0.21010001f,-0.59400000f,1.33930000f,0.18540002f,-0.26630002f,-0.53580002f,-0.83149997f,0.46030000f,1.26499998f,-0.61069999f,0.47559999f,1.74100006f,-0.72120002f,-0.14179999f,-0.36550001f,-0.89200003f,-0.33629999f,-0.69200003f,-0.80609996f,1.38030002f,-0.02720001f,-0.74790004f,0.81689999f,0.12680002f,-1.50249999f,0.37449998f,-0.14219997f,0.19389999f,0.77360002f,0.06830002f,-0.10630000f,-0.04230001f,-0.11219999f,0.39010001f,-1.70230001f,-0.46500003f,0.81979999f,1.07070003f,1.06849997f,-0.76320003f,0.10590004f,-0.34599996f,0.30140004f,-1.24950004f,-0.68660003f,-1.27480002f,0.46500000f,-0.17390001f,-0.27070000f,0.74240001f,0.62720002f,0.17559998f,-0.73450002f,-0.22929999f,0.35800002f,-0.12969997f,0.80069998f,0.64530002f,0.54970000f,-1.12460000f,0.70920001f,1.24900001f,0.19840002f,-0.24370003f,-0.20790001f,-0.16139999f,1.19350002f,-0.54470001f,-0.41170002f,0.46040002f,0.41730007f,-0.06160002f,-1.07170003f,0.63149999f,0.06140005f,1.98809998f,-0.88220002f,0.41029999f,0.02469999f,0.63090003f,0.56340004f,0.58059998f,0.30899999f,0.16080000f,-0.42409999f,1.11810002f,0.45220003f,-0.83730004f,0.13849997f,0.56410002f,-0.06759999f,0.53790005f,-0.55499998f,-0.60320002f,0.72420000f,-0.66130003f,-0.72020002f,-0.34530001f,-1.44300000f,-0.01340002f,-1.94660003f,0.07979996f,-1.03420000f,0.49030001f,0.59899999f,-0.45050002f,-1.56680004f,-0.03730003f,-0.91149999f,0.60970000f,0.75049999f,-0.56880000f,0.49800001f,0.29770004f,1.63059996f,0.01610006f,1.70059998f,-0.08099997f,1.21449996f,0.07870003f,-0.96480003f,0.29050001f,1.51570003f,-0.65409999f,0.71959996f,0.29660000f,-0.55330002f,0.32300000f,-0.50329997f,-0.60690001f,-0.28860005f,0.78410002f,1.09700000f,-0.00399999f,0.35299998f,0.55539999f,1.16430003f,0.41560005f,-0.38029998f,-0.27640003f,0.14559998f,1.15680002f,-1.51370001f,-1.49700007f,0.30859998f,1.08960006f,0.20810001f,0.74440000f,-1.12960002f,-0.52460000f,-0.30339999f,-0.14890005f,-1.13060002f,-0.47849999f,0.54970002f,0.56419999f,-0.21089998f,1.79560005f,0.05200004f,-0.18840000f,-0.41670003f,-0.69729999f,-0.16580003f,-1.25560001f,-0.23650001f,-0.52029996f,-0.50660001f,-0.43679997f,-0.19160004f,0.75230003f,0.85290003f,-0.74590000f,-0.17420008f,-1.28159999f,0.71130004f,-0.47200000f,-0.55700006f,1.28659996f,0.56840006f,-0.88050002f,-0.40109997f,0.41490002f,-1.24109996f,0.09429999f,-1.53470001f,1.10479999f,-0.20830006f,0.00110001f,-1.75940003f,0.98220000f,-0.39360003f,-0.54189999f,-1.25139995f,-0.64250000f,-1.33039999f,0.00890000f,0.35570001f,-0.49309999f,0.80319998f,-0.60010003f,0.45560001f,1.01610001f,0.40280000f,1.51790001f,1.93090001f,1.14320001f,-0.66210003f,1.08630004f,2.02070000f,0.22249996f,-0.86400001f,0.14310000f,-0.12760000f,-0.32750001f,0.71920003f,1.25450003f,-1.12560005f,-0.69660002f,0.04060002f,-0.68700004f,0.01360002f,0.79170002f,-0.69600003f,-1.01380001f,0.78580003f,0.64890000f,-0.62050000f,-0.44260002f,0.31340001f,0.47490000f,-0.06950000f,1.14919999f,-1.15080000f,0.69329998f,0.03329999f,-0.02530001f,0.18290000f,-0.23609998f,-1.75379997f,-0.58039999f,0.16489999f,1.87069998f,0.39469999f,1.40070001f,0.76270001f,0.34199998f,0.01009999f,0.17069998f,0.49220004f,0.01500005f,-0.97410001f,-0.39850002f,-0.60609999f,0.25999999f,0.80030003f,-0.32139997f,-0.67490000f,-2.11089999f,-1.24989998f,0.49440000f,-0.24550000f,-0.08939999f,0.52070002f,0.38040001f,0.44890001f,-0.28040002f,-0.26739999f,-0.15139999f,-0.50230001f,0.05609999f,1.28940005f,-0.20820005f,0.09590000f,-0.29020001f,-1.71740003f,0.28960002f,0.85550001f,-0.77030002f,0.85140004f,0.44370000f,-0.31150000f,0.28290001f,-0.24340001f,-0.55900000f,-1.03129997f,0.30810000f,-0.39080003f,-1.39920002f,-0.31430003f,-1.23710000f,-0.53590002f,0.21749997f,-0.35360001f,0.09590003f,-0.11370006f,-0.55250000f,-0.26630002f,0.14590000f,0.10720001f,-0.69140001f,0.41899999f,-0.15579999f,-0.47159999f,-0.28050000f,-0.12859998f,-0.98260004f,-0.54399998f,-1.75980000f,-0.27010002f,0.33950002f,-0.00859999f,-0.58410004f,-0.07179999f,-0.76820002f,-0.26630001f,-0.53290000f,-0.36460001f,-0.84310004f,0.40860001f,0.46829999f,-0.83500002f,0.07970002f,0.18269998f,0.12590003f,-1.23140003f,-1.61440006f,1.23570004f,0.80350001f,-1.35700004f,-0.66050000f,0.39389999f,-0.11790000f,0.42330001f,-0.70109999f,-0.69180002f,-0.62250001f,0.05200001f,0.08229999f,-0.96530003f,-0.98479999f,-0.35250000f,-2.28749997f,-0.29530000f,-1.39399998f,-0.20219999f,-1.10269997f,0.29880002f,-2.01180002f,-0.12470000f,-0.76890002f,-0.01909999f,-0.35149998f,0.54530006f,-0.06850001f,-0.92490001f,0.26850001f,0.01770001f,1.19899996f,-0.62140007f,-0.78510003f,0.89580003f,1.38150001f,-0.15790000f,0.42769999f,0.50080000f,0.09200000f,0.54130002f,-0.41880000f,-0.31949998f,0.08759999f,0.55210001f,0.70610001f,-0.21549999f,0.19960001f,-0.75980003f,0.09120001f,0.22529998f,-0.27120000f,0.80300002f,-0.47480001f,-1.50900002f,0.61590001f,0.51499999f,-0.22940000f,-0.83259998f,0.91000002f,-0.43910001f,0.10220002f,0.16409998f,0.51009998f,0.42230001f,0.21969999f,-0.08390000f,0.13780001f,0.57069997f,-0.57180000f,-0.51249998f,1.02359999f,-0.29409999f,-0.12880000f,-0.07430001f,-0.04519999f,-0.07270001f,-0.28850003f,-0.03689999f,0.24980000f,0.29500000f,0.38820001f,0.31490001f,1.29130002f,-0.36279999f,0.03730000f,0.78350001f,-0.23019999f,-0.19140003f,0.76170000f,0.44630001f,0.75440000f,-0.67820004f,-0.85570002f,0.29260002f,-0.11670001f,-0.01830000f,-0.04230000f,0.11440000f,1.00940004f,-0.37520002f,-0.52930001f,0.83920001f,-0.01280000f,0.43520000f,1.40560001f,-0.66820001f,-0.12229999f,0.14090000f,-1.04110001f,0.07280000f,-0.63320001f,-0.05150000f,-0.37909999f,0.73500001f,0.17779999f,-0.47980001f,-1.13849998f,-0.51079997f,0.08550000f,0.10459998f,2.44039995f,-0.64560003f,1.77199997f,0.28470000f,0.66830004f,-0.73690003f,-0.48410003f,-0.54030001f,0.25870000f,0.30830000f,-0.10460001f,-0.01530002f,1.18270000f,0.10559998f,-1.50460001f,-0.70870001f,-1.26529994f,-0.75919996f,-0.64280001f,-1.71200003f,-0.22360001f,-0.81570002f,-0.09160001f,0.44699999f,-0.84900001f,0.28960005f,-0.40900005f,0.07230003f,-0.58970001f,-1.38600004f,0.94120003f,1.41130007f,-0.89480005f,-0.31180002f,0.19110001f,-0.75660001f,-0.13989999f,0.09800000f,0.19539999f,-0.25380001f,-1.42059998f,-0.59249999f,-1.52369998f,-0.82439999f,-0.87290001f,-1.45810001f,0.28590001f,-0.28270000f,-1.00160000f,-0.22390002f,-0.92800001f,-0.64780001f,0.87250000f,-0.28769998f,-0.16770000f,-0.64670000f,0.01180003f,-0.34870001f,-1.33700000f,-0.72199996f,-1.93430002f,0.15180000f,-1.55450002f,-1.00860004f,-0.00650000f,0.41500005f,-0.85830004f,-0.63090001f,-1.03170000f,0.30129996f,0.00519999f,0.23470000f,0.72510000f,0.16640002f,-0.05910001f,0.06070000f,-0.86220003f,-0.09249999f,0.19659999f,-0.86930001f,-1.05740002f,0.05430001f,-0.41280004f,0.20850003f,0.14439998f,0.52420000f,1.42920004f,-1.33510002f,-0.97940001f,0.70240000f,-0.11240000f,-0.43410002f,-0.53870002f,0.13279999f,0.20150002f,-1.08830001f,-0.72500000f,0.65680000f,-0.11309999f,0.97110001f,0.03120003f,0.11900004f,1.17840000f,-0.20479997f,-0.57639998f,-0.26050000f,-1.55770003f,1.07450002f,0.35570001f,1.31570003f,-0.03180001f,0.76910001f,0.42190003f,0.27540001f,-0.36130004f,0.11649999f,0.74709998f,1.50620003f,-0.85089998f,0.50960002f,1.80080005f,-0.40289996f,-0.48770001f,0.17070002f,0.74090001f,-0.61409998f,0.20740000f,0.88620000f,0.87060001f,-0.99009994f,0.69830000f,-0.44529998f,-0.86570003f,0.35859999f,0.59799999f,-0.34449998f,-0.10839999f,0.36059993f,-1.23100003f,-0.33210001f,-0.01730000f,0.40459999f,-2.03910000f,0.31190000f,1.16310002f,1.74759992f,-1.73360001f,-0.53300003f,-1.73860004f,0.62990003f,0.67989998f,0.20799999f,-1.00360001f,-0.03319997f,0.69769997f,-0.25909999f,0.51750003f,-0.26260001f,0.31690000f,0.06220003f,-0.36569996f,-1.56820005f,-0.10400008f,0.70360000f,-0.98290001f,0.20420004f,0.81130004f,0.23089997f,-0.41150005f,1.10820003f,-0.43059997f,-0.03360002f,-0.41710002f,1.04240004f,-0.26190001f,-0.20870000f,0.33300006f,1.36680004f,0.83809999f,-0.16899999f,-1.78970001f,-0.31300003f,0.97930003f,0.93120004f,-0.29939998f,-0.22950001f,0.89910007f,1.04900004f,0.29280001f,-0.66260001f,-0.53180001f,0.52020002f,0.63680000f,1.17140005f,-0.03410003f,-0.22450001f,0.52730003f,-1.97350004f,0.14379998f,2.38460007f,0.29799996f,-2.05640007f,-0.73929998f,0.38390002f,0.27990000f,-1.47550005f,0.90870005f,0.22480000f,0.65270000f,0.94610002f,0.13279999f,-2.00090007f,0.85250003f,0.78930004f,-0.37189997f,-0.58500003f,-1.07730001f,0.34740000f,-0.36890002f,-0.38850003f,1.47100000f,1.02190001f,0.13639997f,-1.33170001f,-0.63470005f,0.94680002f,0.65890004f,-1.74599996f,0.13739997f,-0.29390002f,-0.13430001f,-0.83130001f,0.52910001f,0.12990000f,0.48890001f,-0.97080002f,-1.14530001f,0.09540000f,0.30880003f,-0.57909995f,0.52500000f,1.13929997f,-0.71730001f,1.08639995f,-2.43310006f,0.81230002f,0.45640004f,1.27139999f,0.63210003f,0.83289998f,1.15920003f,-0.81750001f,-2.02910004f,-0.36689995f,0.94670004f,0.70929998f,-0.52600000f,-0.71700001f,0.54649999f,-0.45290000f,0.05910000f,-0.44289999f,-0.14430001f,1.29269999f,0.05310001f,0.45090000f,0.27770004f,-0.44700001f,-0.60370005f,1.71450000f,-0.27009997f,-0.62530001f,0.12030002f,0.75920003f,-0.56970000f,0.27480006f,-1.32450003f,0.27050000f,0.26629999f,-0.35050001f,-1.10459999f,0.01669999f,0.71710003f,0.77810001f,-0.82120003f,-0.32400001f,-1.12829997f,1.28009998f,1.08599999f,0.04110000f,-0.80990000f,1.00220000f,-0.73300001f,0.66500002f,-0.34800000f,-0.18220000f,1.01360001f,-0.92099998f,0.09389999f,1.08620005f,1.21119998f,-1.21060001f,1.65069998f,-0.00669997f,-0.20480003f,0.19070005f,1.71930000f,-0.65789999f,1.11019999f,-0.82360001f,0.66169999f,-0.28670000f,0.95159999f,0.92640002f,0.93080000f,-0.70670003f,1.10350004f,0.90150008f,-0.36939996f,-1.86930003f,-0.09970002f,1.27929998f,0.34710000f,0.22620003f,0.04019997f,0.81660001f,-0.36850000f,-0.81350002f,-0.52780000f,0.29940001f,0.17720001f,-0.68200001f,-0.48580003f,0.97300003f,0.63030000f,-1.24419999f,-0.17999999f,0.22379994f,-0.94049999f,-0.12169999f,0.15169999f,1.55680000f,-0.03499997f,0.52079999f,0.07790001f,-0.05579999f,0.64670000f,-0.23320001f,-1.85010008f,0.18190001f,1.36590006f,0.99289999f,-1.61360004f,-0.23529996f,0.90659998f,-0.48369997f,0.43339999f,-1.42969998f,0.34440002f,-0.73719995f,-0.49430003f,0.55389999f,0.66380001f,-0.06260002f,-1.72920003f,-0.71720003f,0.01929998f,-0.91290000f,1.10760003f,-0.71499996f,-1.07330002f,0.86739997f,1.52130001f,0.10160004f,0.39069998f,0.25469996f,0.30650000f,0.94420005f,-0.23709999f,0.38400003f,-0.70219993f,1.02540002f,0.57459998f,-0.85220003f,1.28979999f,-0.10910000f,-1.53590003f,-0.53560000f,-0.04980002f,-0.97320001f,-0.10470003f,-0.31139997f,-1.40989999f,-0.19010006f,-1.41390003f,0.61720001f,0.81799997f,-0.75010001f,-0.71640004f,-0.42140008f,-1.00409999f,1.87640006f,0.40360003f,-1.32980005f,-0.96140000f,0.15350000f,-0.52249993f,0.62570001f,1.64279995f,-0.12469998f,1.22520002f,-0.06879997f,0.06259997f,0.37680000f,1.57830000f,-0.40659998f,-0.49569998f,-1.05170002f,-0.95159996f,-0.14300000f,0.04550000f,0.78930000f,-0.29089995f,-1.09100001f,-1.37100003f,-0.65780005f,1.30759999f,0.76650004f,0.58100001f,0.13470000f,-0.06060001f,-0.18519995f,1.15690001f,0.95409999f,0.17030002f,0.40869999f,0.15160000f,0.70100000f,0.14750000f,0.77560004f,0.97530006f,-0.02650001f,-0.79740003f,-0.85870000f,-0.42500000f,0.38459999f,0.08600001f,0.63399999f,-0.60139999f,-0.45279998f,-0.36380003f,0.70920000f,0.78109998f,-0.33850001f,-0.02380001f,-0.78909995f,0.06460003f,0.20179997f,-0.73500007f,0.16970001f,-0.54169997f,-0.77999997f,0.48299999f,0.56530000f,-0.69550001f,0.19450001f,1.17160001f,-0.66940002f,0.32650000f,-0.05340004f,1.71960004f,0.39619999f,-0.99880000f,0.98040001f,-0.39389998f,1.29569999f,-0.55309999f,0.55560001f,0.09180000f,-0.37460000f,-0.04980000f,-0.56900003f,-0.02030006f,-0.78490000f,-0.03750003f,-0.91960002f,0.87259999f,0.39499999f,-0.56629997f,0.25859999f,-0.03039998f,0.18300000f,-0.50749998f,0.33490001f,0.95299998f,0.12320002f,0.83400000f,-0.23779999f,-0.45539997f,0.59859999f,-1.25209996f,0.43690002f,-0.10580000f,1.91020006f,-0.26480004f,-1.91240001f,0.06629999f,-0.53250000f,1.02330000f,-0.78850001f,-0.38839997f,0.17399996f,-0.43479999f,0.02579999f,0.22460002f,0.80229996f,-0.15790001f,1.64949997f,-0.29009997f,1.37449997f,0.58520000f,1.47060001f,-0.62410002f,0.97259999f,0.00829997f,1.83429995f,0.87139999f,0.51290002f,-0.77610000f,-1.86470003f,-0.15400000f,-0.63110001f,-0.94570003f,-0.85619997f,-0.22409998f,-0.52859999f,-1.83419999f,-0.92229999f,0.00250006f,0.08470006f,0.62250007f,-1.58580000f,-0.37259995f,1.43990000f,0.79669999f,0.65650001f,0.84750002f,-0.31140001f,-0.04800000f,0.01239998f,0.15130002f,-0.07809997f,1.18220007f,0.29979997f,-0.72190003f,0.36350003f,0.41490001f,-0.72470000f,-0.65250002f,1.51080003f,0.11379999f,-0.35000000f,0.64870001f,-0.09189999f,-0.13550001f,-0.54910001f,0.19059998f,1.06020000f,0.83010002f,-0.47609998f,-0.02949999f,-0.42040001f,0.00440000f,0.52650003f,0.15360001f,-0.10190000f,1.07010003f,0.93720000f,2.55770000f,-0.82140004f,1.10330002f,0.06510001f,0.67250003f,-0.46050000f,-0.22410006f,-0.87400005f,0.10500004f,-0.42350004f,-0.20740000f,0.03840004f,-0.12000004f,-0.90530004f,-0.96719998f,0.75600006f,-0.59570000f,-0.30119999f,-0.16759999f,0.08560001f,-0.31180001f,-0.75690002f,0.12280001f,0.00910005f,0.20469998f,0.26889999f,-0.53710001f,0.45500005f,-0.71810003f,-0.04259996f,0.52390000f,-0.42870000f,0.69140002f,-0.18010001f,-0.37470001f,-0.53329998f,-0.07389999f,0.24979998f,0.00640002f,0.95300002f,-0.23550002f,0.78430005f,-1.14150001f,-0.04570001f,0.00290002f,-0.81529996f,0.53850000f,-1.30890000f,-0.74750002f,-0.82509996f,-0.50449997f,0.65009999f,1.26350000f,0.45499997f,-0.21630000f,-0.58700005f,-1.55010002f,-0.01809996f,-0.62709999f,-0.71940002f,-1.13170002f,0.52879998f,-1.25740006f,0.21989996f,-0.18860005f,0.21149999f,0.93800001f,-1.07009998f,-0.84150000f,0.69580002f,0.56230001f,0.33700001f,0.88290002f,0.37040002f,0.87010002f,-0.57580003f,-0.83010002f,0.51040000f,0.79890002f,-0.61320001f,0.91190003f,-0.15300002f,-1.10330001f,0.59770000f,1.61310003f,-0.49320003f,0.15750002f,0.49190001f,0.17790000f,-0.16850000f,0.65880000f,-0.64240000f,0.07520001f,-0.47219999f,0.42509999f,-0.14880001f,1.20879997f,-1.34459999f,-0.05339999f,0.58469998f,1.14769994f,-0.92200002f,1.01469994f,-0.39410004f,1.44099999f,0.30610000f,1.06470003f,0.15660002f,0.29130001f,-0.45070001f,-1.03289998f,-0.25789997f,-0.64790000f,-1.38850003f,-0.23009997f,-1.30770001f,-1.37769999f,-0.88689999f,-0.37019998f,-1.28370004f,-1.46130002f,-1.78870004f,-0.06860002f,-0.77910003f,-0.14259999f,-0.48220002f,0.21170001f,-0.44730004f,0.11980001f,0.44529999f,-0.60160002f,-0.25109998f,-0.25949999f,-0.29650001f,-0.34780001f,-1.03640002f,0.37760002f,-0.02680001f,0.58729999f,0.71850000f,-0.41069998f,-0.51449997f,-0.05239999f,0.40370000f,-0.30970001f,1.05420000f,-0.22570002f,1.40849996f,0.60659998f,-0.20209992f,-0.46749998f,-1.74429998f,0.92229998f,-0.47000001f,0.31679999f,1.05349995f,0.19329999f,1.05239999f,0.44620001f,-0.83970000f,-0.00909998f,-0.26269995f,0.55440008f,-0.99610001f,-1.06080001f,1.24089996f,0.63619997f,0.53620001f,0.81939999f,0.19149998f,1.01410001f,-0.57499998f,0.83709998f,0.38690001f,-0.05030000f,0.07319999f,-0.46019998f,0.36500003f,-0.16110003f,0.10070003f,0.94480005f,-0.65700006f,-0.73570002f,0.37150004f,-0.82670000f,0.24379998f,0.88689999f,-1.16380000f,0.13310008f,-0.16120005f,-0.75570003f,0.22290001f,0.63339999f,1.48410002f,0.88640001f,0.31069999f,-0.58250001f,-0.27800001f,-0.88850003f,0.31569999f,-1.63779994f,-0.81180001f,-0.89699998f,-1.10729994f,-0.47269995f,-1.37390003f,-1.18499999f,0.04940000f,-0.18720000f,-1.08320002f,0.35140000f,0.12250001f,0.93680001f,1.63410006f,0.42040000f,-0.39820006f,1.11339994f,0.95069999f,-0.49019999f,0.85250000f,0.15749999f,-1.17040001f,-0.50449997f,-1.47260002f,-0.60950003f,-0.80860002f,0.03240000f,-0.89540001f,0.93980001f,1.03429999f,-0.74189999f,0.33260000f,-0.26489999f,-0.35150000f,1.22659999f,0.61560000f,-0.19659999f,0.65600003f,-0.34890000f,-1.34790003f,0.70830000f,0.24909999f,-0.72450000f,0.29060000f,0.80139997f,2.36569997f,0.44169999f,1.50529998f,0.55549999f,-0.71899997f,0.02599998f,0.56810000f,1.05230003f,1.74610002f,-0.26240001f,-0.96859997f,-0.36090001f,-0.34700000f,-0.02270000f,0.64489999f,-0.56899999f,-1.56099999f,-0.23459999f,0.66660001f,0.01049999f,0.83959995f,0.15639998f,-1.10490000f,0.31789999f,0.15369998f,-0.33470003f,1.25700002f,0.50910002f,-0.84610000f,0.66190002f,0.01560001f,-0.21990000f,-0.46820000f,-0.94500004f,0.19039999f,0.15150000f,-0.76050003f,0.01580000f,0.44869999f,-0.24600002f,0.94150002f,0.26289999f,-0.48910000f,-0.84730001f,0.19070001f,-0.15860005f,-0.11439997f,0.55580000f,-0.35460001f,-1.29449997f,-0.01630000f,-1.59560000f,-0.29239998f,-1.75320002f,-0.21999998f,-0.60730008f,-0.02290002f,1.55479997f,-0.28590002f,1.54569998f,0.56479997f,1.27269998f,0.63839999f,1.26699997f,0.01700000f,0.46720000f,0.84590000f,0.32429999f,1.30970000f,1.26560002f,0.68500000f,-0.91699998f,-0.60770000f,-0.87809998f,-0.10339996f,-0.49369998f,-0.56269999f,-0.44899999f,0.41380000f,-0.07620000f,0.75860002f,0.36300001f,0.29940000f,-0.74180003f,-0.19759997f,1.48180006f,2.08900004f,0.26610005f,1.30180003f,-0.16860000f,-0.39220000f,-0.38469999f,0.08019998f,-1.22540003f,-1.06020002f,0.18909999f,-0.81180000f,0.14280000f,0.52950002f,0.05150000f,0.78260004f,0.97640001f,-0.83000001f,0.44839998f,-1.25699997f,-0.26080002f,-0.22639999f,-0.50120002f,-0.43510001f,0.78750003f,0.49550002f,0.43320003f,0.11749998f,-1.07850003f,-0.46380002f,0.27630000f,0.59440001f,-0.23899999f,-0.40649998f,0.30439999f,0.11719998f,-0.40780004f,0.71180002f,-0.13339999f,-0.49230002f,0.84850002f,-1.16239995f,-1.29330001f,-0.58860000f,-0.29450003f,-1.15900002f,-0.27449999f,0.38490002f,1.43170004f,0.27850000f,0.82550001f,0.14690005f,0.46290002f,-0.16320000f,0.57200002f,-0.00620000f,1.77890001f,0.21969999f,-0.55610002f,0.74420001f,-0.28750000f,0.34160001f,-0.05470003f,-1.19920006f,0.14589996f,-0.39109999f,-0.48339999f,0.30460000f,-1.12569999f,-0.95740007f,-0.66009998f,-0.31240004f,-0.43859999f,1.34880005f,1.26320003f,-0.09709998f,0.61179996f,-0.01170001f,-1.42920002f,-0.59610006f,-0.49399997f,1.04690004f,-0.57019998f,0.18350001f,0.19880002f,-0.71989999f,-0.81009997f,-0.50619999f,-0.58780005f,0.04809997f,-2.12329999f,0.45950003f,-0.70610001f,0.26789996f,-0.95969996f,-0.90190001f,0.55110000f,-0.26809998f,-0.59370000f,-0.09330001f,0.16120001f,0.80150002f,0.73699999f,0.81260001f,0.19770003f,1.33599999f,-0.06439999f,2.29429997f,-0.26289998f,0.35409998f,0.36190000f,0.08150000f,0.29070000f,-0.36679996f,0.58669999f,1.13410000f,-0.34249999f,-0.36860000f,0.36199996f,0.16959999f,0.10410000f,-1.37319996f,0.14249996f,-1.97189994f,1.58670002f,0.13800000f,-0.01040001f,-0.53459999f,-0.18959999f,0.78759995f,-0.44820001f,-1.41469999f,-0.02210002f,0.25900002f,0.16750001f,0.68240001f,0.08740002f,0.58420002f,-0.61680001f,-0.52129992f,-1.70100001f,-1.19280001f,1.04419995f,-0.48650006f,0.55640003f,-1.46139994f,-1.20950001f,-1.01590004f,-0.58460004f,0.35910000f,1.17570001f,0.13639999f,0.58500002f,0.39880002f,0.07110002f,0.87659999f,-1.00109999f,0.18450003f,0.84719998f,0.07440003f,0.80790005f,0.29809996f,1.02220003f,0.80880005f,-0.73980001f,-0.90970002f,0.42629996f,-0.35489999f,-0.14299998f,-0.16229997f,1.00859999f,-0.37810002f,1.29249999f,-0.80440001f,0.31570000f,2.08180001f,-0.89280004f,-0.07719999f,-1.12289999f,0.58720003f,0.44429998f,-1.38680006f,-1.14619994f,0.97110000f,-0.26219998f,0.39859999f,1.35019999f,-0.55419997f,0.20670003f,0.06920000f,-1.14080002f,-0.76430005f,0.94220001f,0.12800002f,-0.52920009f,1.89790003f,0.58060000f,-0.58459998f,-0.12639999f,-0.15940005f,-1.17110003f,0.10620004f,-0.35320001f,-1.34899997f,0.52499999f,1.18110001f,0.82970004f,-0.11170002f,-1.13500003f,-0.94220002f,-0.05300000f,1.43199998f,-1.08140003f,-1.59769999f,0.12099999f,-0.29270002f,1.07240000f,0.26060002f,-0.46650003f,1.09399999f,-0.88629999f,-0.21180000f,1.03780000f,-0.36030001f,-1.45210006f,0.31360004f,0.32320000f,-1.41840001f,1.03040007f,0.80530001f,-0.78879996f,1.30269994f,1.52069998f,-0.21370007f,-0.45729996f,-0.80060000f,0.39600000f,0.38670002f,-1.01550003f,0.83919998f,1.49530002f,0.73080000f,-0.94609997f,-2.11099998f,0.42999997f,-0.54990003f,-0.67710003f,-1.36970000f,-0.15890000f,0.22490002f,0.06300002f,-1.25850002f,-0.13410004f,-0.08490000f,-2.01520002f,-0.32770002f,0.36219999f,-0.22860000f,-0.13179995f,1.18660001f,2.47909998f,-0.19259995f,-0.18149994f,0.59129999f,0.74270000f,-0.50650002f,0.09230004f,0.90110003f,1.28589998f,-0.57289999f,1.01820000f,-1.55000004f,-0.25550000f,1.06250004f,0.31529999f,-0.10770001f,-1.29810000f,1.36500001f,0.40509997f,-0.50880002f,-1.20240002f,0.14419999f,0.40700000f,0.63120002f,-1.69769999f,-0.33770004f,-0.12679996f,0.20720001f,-0.71590005f,-0.91710004f,0.32259997f,0.37230000f,0.37170001f,-0.68559998f,-1.25949998f,0.12790000f,-0.02289999f,0.48739998f,-1.14719999f,0.07100001f,0.02389999f,0.85249998f,-0.00900000f,0.31920001f,0.84190005f,0.00010004f,0.00090000f,0.51349998f,-0.46760000f,0.09880001f,0.73070000f,0.93169996f,-0.82909998f,0.38139998f,-0.34269998f,0.71090001f,-0.64240000f,0.04139997f,-0.56969999f,0.55540001f,-0.20060000f,-0.16300003f,-1.18470004f,-1.00319996f,-0.37400001f,0.12100002f,0.42719998f,-0.79179999f,0.08709996f,-1.04059996f,0.25369995f,-1.42639998f,0.65080000f,-0.47709996f,0.04889996f,-1.33189998f,0.33820001f,0.09820002f,0.43699999f,-0.19710001f,-0.78239999f,0.64580000f,-0.39579998f,-0.69859998f,-0.76830002f,0.39549996f,0.94059999f,0.70659999f,-0.66469999f,-1.13779999f,-0.34289999f,0.19520001f,-0.39860001f,0.48220003f,-0.30400000f,0.77760000f,-0.15489994f,0.40430000f,0.48390003f,0.54699999f,-0.20880001f,-0.42879998f,-0.53130001f,0.30610001f,-0.41219997f,1.19479998f,0.97060000f,-0.02160000f,-1.11380002f,0.21239998f,-0.62520000f,0.36340001f,0.33039995f,-1.31129995f,-0.31530000f,-0.42720003f,0.43670000f,-0.46899998f,1.52670001f,0.85620005f,0.61929995f,-0.38510001f,-0.37110004f,0.10480004f,1.43050000f,-0.70980000f,0.57639999f,-0.11019999f,0.20719999f,-0.01369999f,1.63650001f,1.23990005f,1.31170002f,1.01760002f,0.33930000f,0.63539999f,0.43690002f,-0.79649996f,-1.33609999f,-2.32040000f,-0.50139999f,-1.00750001f,0.11260000f,0.79800000f,0.02620000f,0.79790000f,-0.19859999f,-0.45210007f,-0.13080003f,0.45890001f,1.27920000f,0.45990002f,0.62410001f,1.23299999f,0.78560001f,0.63990002f,0.00419998f,-0.63230001f,-0.80610002f,-0.83190000f,0.29060005f,0.14580001f,-0.14219999f,-0.09619999f,-0.27440002f,0.68620002f,-0.27280002f,0.45510002f,-0.33580005f,-0.04889999f,1.47470005f,-0.60550006f,0.76610002f,-0.14789999f,-0.69550001f,0.87350001f,0.13010000f,-0.35830001f,-0.56770003f,0.11929998f,-0.25249998f,0.69640002f,0.16820004f,0.47140000f,1.07260003f,0.54989999f,1.26050000f,-0.54620002f,0.88149994f,0.34660000f,-0.23539999f,0.94540003f,-0.68600000f,-0.12680004f,-1.55940002f,-0.33160000f,-1.15610001f,0.25289998f,-0.06760004f,0.82399999f,-0.03999998f,1.03690005f,-0.07249999f,0.86300005f,-0.38549996f,-1.04140004f,0.55799996f,-1.14720005f,0.24940000f,0.67780001f,1.54600001f,1.33180004f,-0.26480002f,0.37599998f,0.74380001f,0.38869999f,-0.54749999f,-0.18800001f,0.32880001f,-0.52070001f,0.66660000f,1.63490001f,-0.74100000f,0.02930002f,1.15169999f,0.95610000f,-0.35570000f,-1.15770002f,1.11770002f,0.76050000f,-0.42250001f,1.29109997f,0.97259997f,1.59199997f,1.34729998f,0.18630001f,1.42099998f,0.37239995f,0.27189999f,-0.49900004f,0.07900000f,0.03009999f,0.03230001f,0.20890000f,0.99549998f,0.56539999f,0.02840000f,0.59609999f,0.28320004f,0.24770000f,-0.05899999f,0.80659996f,1.28049997f,0.56680003f,2.00810000f,1.29529996f,0.30879995f,-0.70089999f,-0.19640002f,0.50119999f,-0.74050000f,-0.58620001f,0.68090003f,0.51200001f,0.44400000f,0.43820000f,0.52519999f,-0.03010000f,0.63760001f,-0.05740000f,0.22480001f,-0.62829999f,0.14280001f,-0.08260001f,-0.29159998f,1.52940000f,1.31210003f,-0.63610000f,-0.53099997f,0.64860001f,-0.25410002f,-0.17430000f,0.80869997f,-0.40540000f,1.80709997f,-0.18120003f,1.99949999f,0.53460000f,-0.22409992f,0.49390008f,-1.84699996f,0.32779997f,0.45659995f,1.00210002f,0.74210002f,0.09459998f,-1.43909996f,-0.26879999f,-0.65310001f,0.06320001f,-1.05069999f,-0.86490000f,-1.01189999f,-1.45240000f,1.19699994f,-0.13810004f,0.74330000f,0.27449999f,-0.95679998f,0.42700004f,1.03319996f,-0.51010006f,0.95479999f,1.41220000f,-0.11700001f,0.32519999f,-0.29320002f,-1.04240001f,0.49760002f,0.12539998f,-0.10589998f,0.61470002f,-0.27800001f,-1.51500005f,-0.01259999f,0.96530003f,-0.37960004f,0.07660001f,-0.27589998f,-0.10359999f,-0.30690000f,0.01580000f,0.80500000f,-0.24980001f,0.23889997f,0.69299998f,1.02940001f,1.28409999f,-0.56570002f,-0.61189998f,0.84830002f,-1.01260001f,-1.51329999f,-0.78980009f,-0.89689999f,-0.17200000f,0.90600004f,-0.58520001f,-0.03240001f,-0.83450003f,-0.81500000f,-0.81580001f,-0.25589999f,-0.16420002f,0.06489999f,1.12270002f,0.74880001f,0.46890000f,1.13910003f,-0.23239993f,-0.10760000f,-0.41230002f,-1.40020000f,0.28710002f,-0.79649999f,0.26530000f,0.73080003f,-0.40260002f,-0.89770001f,0.20480001f,-0.14330001f,-0.18800002f,-0.98590001f,0.57420003f,1.84660000f,-0.60260000f,-0.51209998f,1.11000001f,1.02390002f,-0.51880001f,-1.05400000f,0.96100002f,0.82170001f,-0.00730000f,-0.36569999f,-0.10690001f,-0.87549995f,-0.74209998f,-0.27220003f,1.79229996f,1.40679997f,0.10170006f,0.00650001f,0.98550001f,0.18660001f,-0.22880000f,-0.58579999f,1.41729999f,0.17040001f,0.03380000f,0.23790001f,-0.95190003f,0.35979998f,0.26740001f,-0.75769997f,-0.32099999f,-0.20930002f,0.55340001f,0.97109999f,0.07749998f,-0.10439999f,0.43680004f,0.99110000f,0.14370000f,-0.34410004f,0.61449998f,0.68180001f,0.81899999f,0.01900001f,-0.26729996f,0.83750001f,0.06369998f,0.01280000f,-0.48440000f,-0.22629999f,0.14289998f,-0.04799998f,-0.76760004f,0.38950002f,0.39220002f,-0.68150001f,-0.89070003f,0.71370002f,0.21960000f,-0.29920002f,0.33430002f,0.72639998f,0.33910001f,-0.38690001f,0.58169997f,1.41349997f,0.66379997f,0.42549999f,-0.96679998f,0.62020001f,-0.55499996f,0.34989999f,-1.22679995f,0.07530002f,-0.99699997f,-0.06940000f,0.11280000f,-0.47960003f,0.31480001f,0.95260000f,-0.27339998f,0.42900001f,0.47409998f,0.50979999f,1.27649996f,1.60739998f,0.34409998f,1.42510002f,1.52209997f,1.01299998f,-0.04230001f,1.22490002f,0.14000001f,0.20580001f,-0.07800001f,-0.12079999f,1.09529999f,0.21059999f,0.10710002f,1.17910004f,-1.08130003f,-0.03179998f,0.17859999f,-0.55730001f,0.85710003f,1.64510004f,-0.64150003f,-0.07339999f,0.32360000f,-0.23040000f,-0.03120000f,0.32779998f,0.26790000f,1.12689998f,0.21629997f,1.97059997f,-0.74339999f,-0.20849996f,-0.81479995f,-0.71300002f,0.80839998f,1.46389994f,-0.54890001f,0.57309997f,-0.52660001f,-0.11539999f,0.06920000f,0.19020001f,-0.91710000f,-0.68179998f,-0.02079998f,-0.74630000f,-0.35679998f,0.85610000f,-0.73740005f,-0.95979997f,-1.33540001f,-1.03499999f,-0.53999996f,0.32520001f,-0.93790004f,-0.54220001f,-0.93600001f,-0.24500001f,-0.47320001f,-0.07930000f,1.46859999f,0.27280001f,0.46240002f,0.25680002f,-0.25069994f,0.68250000f,-0.35879996f,1.09559999f,2.18690003f,-0.24699996f,-0.03019999f,0.88100000f,-0.58989995f,-0.09230002f,0.08789996f,0.24250002f,-0.60220000f,1.42600003f,-0.54680000f,-0.55779997f,0.87629996f,-0.48849996f,0.77529994f,-0.51430007f,-0.75940004f,1.02000008f,0.37850003f,-0.04210004f,0.54999994f,-1.44769997f,-0.23069994f,0.14309998f,0.59749999f,-0.19030002f,-0.11260002f,0.85020005f,0.91650003f,-1.36060004f,-0.46519999f,-1.16420001f,-0.02880001f,0.72350001f,0.92089994f,1.23790000f,0.93710002f,-0.40559998f,0.46799998f,1.34150000f,0.11640001f,-1.07990000f,0.28650001f,0.95750004f,0.06420000f,0.00600004f,1.26870003f,0.52810002f,-0.52480000f,0.42169998f,-1.04379999f,-0.20090001f,-1.24990000f,-0.82609998f,0.43049999f,0.79849999f,-0.15539998f,-0.04459996f,0.41979999f,-0.39360002f,0.17950004f,-0.03670000f,-0.92580006f,-0.50780000f,-1.08340006f,-0.63129996f,0.29179998f,-0.84999996f,-0.50250000f,0.34700002f,0.61489998f,0.21049998f,0.32510002f,-0.47939999f,-0.56440001f,0.77229998f,-0.57200000f,-0.51580000f,1.05670002f,0.00980000f,-0.44980001f,0.05650000f,1.11670000f,-0.32620006f,0.19130003f,-0.15240001f,0.95290001f,-0.05960004f,-0.59140004f,0.31470004f,-0.14900000f,-0.85010001f,-0.72940003f,-0.28810001f,1.02279996f,-0.60880000f,-1.43200002f,-0.68300003f,0.57769996f,-0.08709997f,-0.18229998f,-1.02360003f,1.01520001f,0.67740006f,-0.78590000f,-0.15640002f,0.61680002f,1.13450004f,0.00470001f,-0.03030000f,-0.93859997f,1.32210001f,0.35350000f,-1.00550003f,-0.75899996f,1.65190003f,-0.87540002f,-0.93450000f,-0.48599997f,2.20730008f,0.63829998f,-1.78960005f,-0.06569999f,1.19770003f,0.62539998f,-0.84170002f,-0.15530000f,0.29139999f,-0.11950000f,-1.02320002f,0.94389996f,1.95620007f,-0.66279994f,-1.39420004f,-0.67740004f,-0.53140001f,0.04419999f,0.87320002f,-0.52390001f,-0.83230002f,0.11650001f,0.87540004f,-0.29120005f,1.22600001f,-0.05920000f,-1.65699999f,-0.19410002f,1.03830000f,-0.12710002f,0.72350001f,1.25280006f,-0.14699998f,-0.78740003f,1.27440002f,-0.01899999f,-0.77130004f,-0.86470005f,-0.01440003f,-0.63169999f,0.71309998f,-0.63320001f,0.84759998f,-0.97830001f,-0.75940001f,0.94020002f,-0.47909997f,0.60580001f,0.25049996f,-1.56700007f,-1.53000000f,1.32200002f,-0.14839999f,-1.25460007f,-0.57739997f,1.01740004f,-1.12340000f,0.75380000f,-0.62049999f,-0.20290001f,0.27270002f,0.96630003f,-1.45390004f,-0.65140006f,0.19800006f,0.54410003f,-0.05320002f,-0.03930000f,-1.12509993f,-1.11990001f,-0.87570005f,-0.43010002f,1.17939998f,0.39420000f,1.28280004f,0.18290002f,-0.58580002f,0.34400002f,0.71910004f,-0.13040002f,-0.69490005f,-0.46890002f,0.64460001f,0.24390005f,0.57979999f,0.78930002f,1.18010003f,-0.10689997f,-0.61770001f,-0.41260005f,-0.91380002f,-0.22470002f,0.39780001f,0.43620001f,1.49560007f,-0.61350004f,-0.82310005f,0.95520002f,1.10520005f,0.05879993f,-0.23799998f,-0.05180000f,0.82060000f,0.12119995f,-1.41970001f,-1.13319993f,-1.09420004f,0.47400004f,0.68780001f,0.71459999f,-0.08980001f,0.81250003f,0.71380004f,1.57890001f,-0.13359998f,1.14939999f,0.29010000f,0.06270001f,-0.42140000f,-0.08019999f,-0.16350000f,-0.32880001f,0.42619999f,-1.53220000f,0.01169997f,0.59330000f,0.67030003f,-0.60240004f,-0.61170004f,-0.39210002f,-1.56410000f,-0.10330000f,-0.26910000f,0.33280001f,-0.46119999f,0.20690000f,-0.56669999f,-0.25800000f,0.54630000f,0.34640002f,0.07549996f,-1.11280003f,-0.70549998f,0.07529999f,0.34000003f,0.09190003f,1.02890001f,-1.06509998f,0.70090000f,0.43200001f,1.00139998f,-0.12600000f,0.43679997f,-0.23400000f,-0.25119999f,1.25530001f,-0.83270000f,-0.41050004f,0.18879998f,0.47330004f,-0.39580000f,-0.72850000f,-0.20360001f,1.15670001f,-1.21449996f,-0.16270002f,-0.36999999f,-0.16510000f,0.10069999f,2.18470004f,0.51560004f,-2.09200007f,-0.01040008f,2.08440002f,1.50450004f,-0.48129996f,-0.76009999f,-0.19589999f,0.04120000f,1.58010000f,-0.52419999f,0.31749997f,-0.55170000f,-1.68180001f,-0.60060004f,0.64639997f,-0.20569999f,-2.34000001f,-0.00919998f,0.80269998f,-1.15400005f,-1.18650000f,1.29529999f,1.15640000f,-0.36569999f,-1.42780000f,0.82579999f,-0.76759995f,0.28529998f,0.99799997f,-0.23080002f,-0.56709997f,1.68250008f,0.40690003f,-2.28870007f,-0.54100003f,1.45580003f,1.18790002f,-0.13930000f,-1.05540004f,-0.15790000f,0.21430002f,0.26940001f,-1.05060003f,-0.93540004f,-0.01810005f,-0.09460002f,0.84559999f,0.37040000f,-0.11330001f,-0.07789998f,-0.09740003f,-0.40410001f,-0.52509996f,0.02099999f,-0.02549999f,1.42610003f,0.06470000f,-0.01879999f,0.87430005f,0.03700003f,0.43700002f,0.51880000f,-0.66070000f,0.33969997f,-0.28759998f,0.29360002f,0.52510000f,-0.86940002f,-0.45960002f,-0.48060008f,-0.71010003f,-0.32120004f,-0.40550001f,-0.32999999f,0.07970000f,0.16459997f,-0.81030005f,-1.57600000f,-1.06420004f,-0.63579992f,-0.09630000f,0.61389999f,0.95890004f,0.68729998f,-1.21510003f,-0.46589997f,0.59619996f,0.43439999f,0.98900004f,-0.60370000f,-0.07429999f,-0.12620000f,-0.58130000f,0.19500001f,0.13969994f,-0.27799997f,0.95009998f,-0.29009997f,1.35239996f,1.68749998f,1.39560001f,-0.41939997f,0.42540000f,0.38480002f,0.63410001f,-0.17960005f,0.59619999f,0.06410000f,0.76240000f,0.63600000f,-0.58939999f,0.08930000f,-0.22209997f,-0.78900000f,-1.17479996f,-1.16269996f,0.29499997f,0.31670005f,-0.16119998f,-0.05950004f,-0.01930000f,-1.06889999f,-0.62349999f,0.20519999f,-0.00900001f,-0.37350002f,-0.11400001f,0.24240000f,0.76650002f,-0.51760003f,0.63260003f,0.06759998f,-0.40429999f,-0.43390002f,-0.37810000f,-0.36650002f,-0.05120000f,-0.42700000f,-0.94349998f,-0.34450003f,0.84470000f,0.51050001f,-0.47590000f,-0.24540002f,-0.37800001f,0.67659998f,1.40570000f,2.64750003f,0.87159998f,0.68000002f,0.01620000f,-1.08479998f,-1.43379997f,-0.51019999f,0.50239999f,-0.16169998f,-0.39389998f,0.39059998f,0.25429999f,1.25410000f,0.15830000f,-1.03130001f,-0.17230000f,-0.72770000f,0.05950002f,1.33260000f,1.64890003f,0.88329999f,1.56820001f,-0.55379996f,0.45910004f,0.46749998f,-0.30969999f,-1.18089998f,0.28710001f,0.15580001f,-0.50209998f,0.20540001f,0.66429999f,-0.84300001f,-0.91299999f,0.17200000f,-0.42670003f,-0.26950001f,-0.28509999f,0.32340001f,0.74070004f,-0.65700002f,-0.27039999f,1.06780003f,0.52040002f,-0.50520001f,0.28200001f,0.41740001f,-0.12730001f,-0.47199999f,-0.93560002f,-0.02140003f,-1.48159997f,0.43400004f,-1.10190002f,-0.48240002f,-0.80810001f,0.03170004f,-0.10180000f,-0.43330002f,0.41570001f,0.59130001f,1.19530000f,0.16410000f,0.13200001f,1.14530002f,0.61759999f,0.14649998f,0.72049998f,0.90320000f,0.39040000f,0.63819999f,0.33940001f,1.04810002f,-0.18870001f,-1.13220008f,-0.68869999f,-0.01889998f,-0.32780001f,-1.09990004f,0.27020000f,0.18410000f,-0.42520001f,-0.87059999f,0.14680000f,-0.49340002f,0.71060001f,0.82160001f,-0.59830000f,-0.70460004f,0.94850005f,0.25920000f,-0.47150002f,-0.35130001f,-0.10910000f,-0.78720004f,-0.38130000f,-0.14460001f,0.15960001f,-0.46539999f,0.43490001f,-1.26869998f,-0.48140004f,0.41379994f,1.43120004f,1.35700001f,0.45030000f,-0.42789999f,0.24110001f,0.17309998f,0.11159997f,-0.99430001f,0.32260002f,-1.72000002f,-0.28329999f,-0.98550002f,-0.80680001f,0.85880000f,0.59870002f,-1.46720000f,0.23800001f,0.70699999f,-0.55590004f,0.60130000f,1.88800008f,0.14370002f,0.33340001f,1.20330001f,1.21360003f,0.88419998f,1.25270000f,0.08170001f,0.74630002f,-0.55340002f,-0.41530001f,0.44640001f,1.11900006f,-0.38440003f,-0.21730003f,0.16460001f,0.06570003f,0.84229999f,0.91430001f,-0.35699999f,-0.38629996f,1.03519998f,-0.37900004f,-0.14489999f,-0.12290003f,-0.81390000f,-1.09709999f,0.41900004f,-0.26710000f,-0.81340002f,-0.79210000f,-0.03309997f,-0.71310000f,0.08659999f,0.91659999f,1.27830001f,0.78840002f,0.17269997f,-0.40679999f,-1.01430003f,0.40029997f,-0.03420000f,0.63379999f,-0.01450001f,-0.69150003f,-0.37710003f,0.87450005f,-0.32920000f,-0.52980004f,-1.00360000f,-0.93529998f,-0.49939999f,0.69819996f,-0.63220003f,0.31210001f,1.29459999f,-0.49409998f,0.41520002f,-0.32210001f,-0.67300001f,-0.17640001f,0.02979999f,-0.40730002f,-0.70860002f,0.02490000f,0.06230000f,-0.56510001f,0.13100000f,-0.23859999f,-0.29629999f,-0.04470000f,-0.20039999f,0.00220000f,0.69429999f,-0.24230000f,-0.75269999f,0.31309998f,-0.44860001f,-1.20070002f,-0.41770002f,-0.81480000f,0.31930002f,-0.44919999f,0.66999999f,-0.04879999f,0.02650000f,-0.00050000f,-0.74679996f,0.77470002f,-0.55910000f,-0.74019998f,-1.63839998f,-0.15960000f,-0.87089999f,0.11550001f,-0.56740000f,-0.80740001f,-0.89690001f,-0.62650000f,-0.67009997f,-1.00200000f,0.07299999f,-0.50719999f,0.39999998f,0.29090000f,0.35340000f,0.35469998f,1.11080000f,0.46460003f,-0.46340000f,-0.15679999f,0.25420004f,0.03089999f,0.05769998f,1.18490000f,-0.94540001f,-0.74409997f,-0.06750002f,0.22270003f,0.22259996f,-1.12380004f,0.20250005f,0.78620004f,-0.96380006f,-1.53290005f,0.92260004f,0.81049999f,-0.34190001f,-0.09289996f,0.14540000f,0.03059999f,-0.60719998f,-0.93499996f,-0.19400002f,-2.53189994f,-1.19960000f,-1.05230001f,0.63600003f,-0.13209992f,-1.78169999f,-1.43210005f,1.16279998f,0.89119995f,0.05129999f,0.59559999f,1.37440004f,0.10530002f,1.17280001f,1.06919999f,-0.38710000f,0.96049997f,0.37779999f,-1.08600002f,-0.87150007f,0.70089998f,0.60890004f,-0.06909993f,-0.46749999f,-1.06160003f,-0.19169997f,0.56530001f,0.49890000f,-0.29420002f,-0.45699999f,1.28050005f,-0.22999999f,0.39019999f,0.11599996f,-0.44369999f,0.59390004f,-0.67380001f,-0.52490000f,0.54790001f,0.31639999f,-1.22350001f,-0.58950001f,0.39019998f,-0.20880000f,0.19440000f,-0.09590000f,1.23030000f,0.12350002f,0.08049996f,0.60809998f,-0.48029999f,0.83559996f,0.14930000f,0.17969997f,-0.17610003f,-0.53610002f,-0.36060001f,-1.85999999f,-0.54059999f,-1.92110000f,0.00160000f,-0.20910000f,-0.84280007f,0.24999997f,0.93240000f,0.10990003f,1.31710000f,-0.37059998f,-0.01759999f,0.17650001f,-0.85660003f,0.10010000f,0.55550000f,1.42899998f,0.09729999f,-0.25630002f,0.09329999f,-0.12310000f,-0.08720000f,-0.85350003f,0.06350003f,0.69510004f,0.69270005f,0.49570001f,0.35159998f,-1.12869999f,-1.10190003f,-0.94710005f,-1.21260004f,-0.58540006f,-0.63090002f,0.50780002f,0.70739999f,-0.73209999f,1.20569998f,-0.68280000f,0.31180003f,0.64970005f,-0.34010003f,-0.31700004f,-0.29479998f,-0.22390001f,0.07999999f,-0.58870003f,-0.12959998f,-0.49520001f,0.93850001f,0.50979999f,-1.04570001f,-0.19450005f,-1.34769993f,0.86560000f,-0.28739997f,0.34840000f,-0.63580000f,-0.33260001f,-0.92029999f,-0.75520001f,-0.20460004f,0.65210000f,0.50160000f,-1.59120001f,-0.70069999f,0.85539999f,0.47980004f,-0.03759997f,1.16820000f,1.51860001f,-0.37090000f,-0.90180004f,0.31790001f,0.18770000f,0.64980000f,-0.26990000f,0.28070000f,0.22140001f,0.05560002f,-1.31989998f,0.55839998f,0.39119993f,-1.34850002f,-1.66859999f,-0.24260001f,0.63910002f,0.20420004f,0.74290003f,0.07290001f,0.46300000f,0.24240003f,0.44089998f,-0.21859999f,0.16289999f,0.21090007f,0.54689999f,-1.21280005f,-0.53030002f,0.26979997f,0.76840001f,0.08700002f,-0.46080000f,0.70780000f,-1.28689998f,-0.48050004f,0.73610002f,0.09889999f,1.06780005f,0.23230005f,-1.43350000f,-0.79790003f,-0.27749998f,0.92120000f,-0.04120000f,0.38240001f,-1.05149999f,-0.28080002f,-0.29640007f,-0.23250001f,1.34899999f,1.17850007f,-0.54900000f,-1.34210006f,-0.96150003f,0.23550002f,1.45080001f,-0.20060002f,-0.98830001f,-0.14960005f,-0.37930001f,-0.44209999f,0.22079999f,0.68180001f,0.67550003f,-0.76689999f,-1.32860004f,0.93700005f,0.95720003f,-0.20739999f,0.31520001f,0.71080001f,1.92400004f,0.09559996f,-1.36570003f,-0.21429997f,1.23870000f,0.35639998f,0.35910004f,-0.49689999f,1.07530003f,-0.43880005f,-2.20810003f,-0.59199999f,1.88350008f,0.73169997f,-1.09740004f,0.35330000f,-0.07670000f,-1.68119997f,-0.02380000f,-1.17400003f,-0.51060005f,0.72029999f,0.58770001f,1.45820000f,0.02640004f,1.82340005f,-0.19380001f,0.13410004f,-0.97790002f,-1.43490001f,0.80450001f,0.50579998f,1.01580000f,0.47690001f,1.36080002f,0.47320003f,-0.30749999f,-0.60040002f,-0.10190002f,-0.33210000f,-0.48239998f,-0.19780001f,-0.08509999f,0.51860003f,0.27190002f,0.12810001f,0.68599998f,-1.50050001f,-0.66250000f,-0.08020001f,-0.47960001f,1.30100001f,-0.37560004f,-1.14970004f,-0.81809995f,-0.14650000f,-0.07639999f,-1.01690002f,0.44900002f,-0.36860004f,0.21550001f,-0.22890005f,-0.62919999f,0.60480001f,0.18050001f,0.63680001f,-0.66430000f,-0.01870000f,0.16819999f,-0.35269998f,-0.59509999f,-0.48270004f,-1.60920000f,-0.07630001f,0.01540002f,0.54209998f,0.43259998f,0.03790001f,0.44430001f,0.30330000f,-1.04219998f,-0.49030000f,-0.21860000f,0.06829999f,0.30160001f,0.63730006f,0.43840003f,1.52740001f,0.46410004f,1.29980000f,-0.95420000f,0.35289997f,-0.15439998f,0.20950002f,-0.37400000f,1.04859998f,0.39870001f,0.54530000f,0.01280000f,-0.27990001f,-0.05240000f,-0.41300001f,-0.14529999f,-1.00679998f,0.43149992f,-1.45969998f,-0.18210004f,-0.67609993f,0.42149997f,-0.96259997f,-0.73700002f,-0.63839995f,0.71909998f,0.05850000f,0.12920001f,0.41860000f,-0.15400000f,-0.36760000f,-0.24280001f,-0.07160004f,0.08710001f,2.11640000f,1.26690008f,1.11990004f,-0.80700001f,-1.79530002f,0.29209999f,0.50490002f,0.36750003f,-1.08550003f,-0.48560006f,0.12799997f,1.23750003f,0.52730004f,-0.57070002f,-0.01770000f,-0.93180005f,-1.10820006f,-0.32470003f,-0.46780001f,0.52969999f,1.17410005f,1.20519996f,-1.53370001f,-0.30699994f,0.86130003f,0.47050000f,-0.55769998f,0.82219999f,-0.68340001f,-0.45490001f,0.44410002f,-0.11780001f,-1.01430004f,-0.70229996f,-0.29879997f,-0.20879994f,0.61739998f,-0.71010000f,-0.23370003f,0.53489999f,1.19480004f,-1.14630001f,-0.58290006f,-1.18909996f,0.26789999f,0.13490004f,-0.18830001f,0.51300000f,0.02900002f,1.37330000f,-0.12989999f,-0.51340000f,0.42319998f,-1.16019996f,-1.41370000f,-0.64170000f,0.90959999f,-1.66570005f,-0.38860003f,-0.10830000f,0.34089999f,0.07850002f,-0.06029998f,-0.36179999f,-1.34150005f,-0.57930001f,0.00380000f,0.61050003f,1.65469997f,0.53700002f,-0.02729999f,0.10440000f,1.40270001f,0.14730005f,0.57100002f,-0.38230001f,-0.21940002f,0.47970000f,0.57510004f,0.80290003f,-0.08769998f,0.35840001f,0.09540005f,0.43400000f,0.00550002f,1.10699998f,-0.08250001f,-0.81110003f,-0.69879998f,1.22860003f,-1.01189999f,-0.05280000f,0.59080001f,0.50060001f,-0.20510002f,-0.03789996f,0.12979999f,-0.96720004f,0.56120000f,-0.12330000f,-1.42800002f,-0.14600003f,-0.22290005f,0.42320003f,-0.25500001f,-0.35370003f,-0.38169998f,0.73630004f,0.61599999f,1.23650002f,0.65600004f,-0.52200002f,-0.34639998f,0.57340001f,0.59150004f,-0.63950001f,0.39730002f,0.66270000f,-0.15160000f,-0.23229998f,-0.59270003f,-0.72690004f,-0.54000002f,-0.60230004f,-0.46370002f,-0.19150002f,-0.66380001f,-0.18980000f,0.47880002f,0.28469997f,-0.34800002f,-1.15089998f,0.59830001f,-0.48200001f,0.55700000f,-0.36230003f,-0.55709998f,-0.54369999f,-0.01500002f,0.54140000f,1.00640001f,-0.74740002f,-0.33770000f,-0.50779995f,0.11499999f,0.57920000f,0.20989999f,1.04969999f,-0.39809998f,0.21180000f,-0.48610000f,0.27650003f,1.30619998f,1.18169999f,1.51039998f,-0.41539998f,-1.27409998f,-1.12160000f,-1.09760001f,-1.00720004f,-0.25090004f,0.98779998f,0.16670002f,0.76719999f,-0.31729997f,-0.26220000f,-0.47960002f,0.33650002f,-1.48920001f,-0.18949998f,0.56260003f,0.56280001f,1.37289999f,0.84740001f,-0.58259995f,0.37210005f,-0.22429998f,-0.33719997f,-0.17120007f,0.59340001f,1.08260000f,2.01770001f,0.26450001f,0.77740000f,-0.09220002f,0.61140003f,0.20919999f,0.43360002f,0.06900000f,0.40790003f,0.41909998f,-0.79620001f,0.20990004f,0.75939999f,-0.85470002f,-0.99740000f,-0.24520000f,-1.14900004f,1.07500003f,0.91240003f,-0.61420001f,0.15589998f,0.09080000f,0.34049998f,0.19739999f,-0.31220000f,-0.76539997f,-0.02370002f,0.97939997f,0.55620000f,-1.27629999f,-1.48059999f,-0.00230000f,-1.84159993f,0.26240002f,0.51210004f,0.21630000f,1.33820003f,-0.69790003f,-0.25720000f,-0.95440004f,0.42739998f,-0.43100003f,-0.83159998f,-0.84180003f,0.29479998f,0.25950002f,0.79870001f,0.24020001f,0.55449994f,0.17469999f,-1.39420002f,0.69620001f,0.48080003f,-0.05490000f,0.01800000f,-0.22250001f,-0.53720000f,0.38610001f,0.08969999f,0.20380000f,-0.62940001f,-0.45939998f,0.55159998f,0.42680001f,-0.07330000f,-0.54810002f,0.86090002f,0.17150000f,-0.45210000f,0.46670002f,0.09790001f,-0.09580000f,1.00039999f,0.84409998f,-0.25110001f,-0.96479996f,-0.61509998f,-1.72989997f,0.03810000f,-0.77689999f,0.95990004f,-0.23800001f,-0.76610000f,-0.67620002f,-0.00079999f,1.32589996f,0.30850000f,0.87250002f,0.03960005f,-0.47950003f,-1.01350002f,1.17909999f,0.92809999f,0.42019998f,-0.40910001f,-0.33960001f,-0.18310001f,0.62499999f,-0.11480002f,0.11890005f,1.30270008f,-1.25880000f,-1.20960001f,0.25440001f,-0.25670000f,0.09560000f,0.90160001f,-0.06999998f,-0.13319996f,0.73779998f,-0.42290003f,0.14290000f,-0.47500003f,0.07160002f,-0.57120005f,-0.11929998f,-0.23070003f,-0.54309999f,0.79710001f,-0.90920002f,-0.90119999f,0.48460000f,0.18859999f,0.81270003f,-0.33879997f,0.04309999f,-0.92089995f,-0.40519999f,0.05589998f,-0.53610003f,1.17960001f,0.31760000f,2.01480003f,1.20850000f,0.73430003f,-0.84429998f,-2.19229996f,-0.24109999f,-1.28789998f,0.11059999f,0.77889995f,-0.01730002f,0.60600001f,0.92470000f,-0.48739998f,0.24720002f,-0.89760001f,-0.02349997f,-0.92260000f,-0.08409998f,1.00810000f,1.07470003f,1.53839999f,0.83080000f,-0.49490000f,0.03570000f,0.26500002f,-0.41910000f,0.47270002f,-0.07570003f,0.19190004f,0.62730002f,-0.16860001f,-0.51410002f,0.30960001f,-0.50570001f,0.37380000f,0.20449997f,-0.25790000f,0.88190002f,-0.41000002f,-0.24390000f,0.42270000f,0.45170000f,1.09469999f,1.13640001f,1.77460000f,1.07380002f,0.26479998f,-0.59479995f,0.38510001f,-0.41429996f,0.16019998f,0.57510000f,0.41909999f,1.20739996f,0.11429999f,-0.01650000f,-0.02080000f,-0.49019999f,0.18960001f,-0.07330002f,0.85950000f,0.72659998f,1.45700001f,1.39039998f,1.54749998f,0.08589998f,0.83959999f,-0.14989999f,1.01690001f,-0.29709999f,0.01790001f,0.70559999f,-0.18680003f,-0.07430001f,0.11239999f,-0.35220002f,-0.74730001f,0.24880000f,-1.18270005f,0.35380000f,-0.55220004f,-0.44669998f,1.34509999f,-0.71419999f,-0.97589998f,0.41950001f,-0.11479999f,0.27410001f,0.16790000f,0.12410000f,0.02030000f,-0.30230001f,-0.70450001f,-0.44280004f,-1.48100004f,-0.71360005f,0.60029994f,1.86750000f,1.95189996f,-0.92969998f,-1.09549999f,1.01560001f,-0.44999995f,0.70130001f,-0.50089996f,-0.83630003f,-0.08010001f,0.13400000f,0.66790003f,0.10589999f,0.55720002f,1.15590003f,-1.38210000f,0.45850000f,0.16150000f,0.49459998f,1.39210000f,0.83760002f,-0.27370005f,0.04219998f,1.11200000f,1.58580000f,-0.50710000f,0.28470000f,-0.14560001f,-0.58240002f,0.37380000f,-0.47810001f,-0.47279999f,0.67779999f,0.03640001f,0.14350000f,0.13400002f,0.03380000f,0.43319999f,1.20800007f,-0.36070002f,-0.17629999f,0.55180000f,0.24390000f,0.71260002f,0.56510002f,-0.14870000f,0.47609999f,0.65449998f,1.21849997f,0.52530000f,0.96509995f,1.01059997f,-0.00089997f,0.60050004f,-0.16719998f,-0.32520000f,-0.62419999f,0.02540000f,-0.37770002f,0.21470000f,1.46440000f,0.31120000f,1.12420003f,0.37070001f,-0.30040000f,-0.04640003f,-0.20129999f,-0.10910001f,1.14359995f,0.77869999f,-0.00330001f,0.65489997f,0.92060002f,-0.19770003f,-0.55470001f,-0.58550002f,-1.06390002f,-0.66820002f,0.26550001f,-0.34520001f,0.05920000f,0.57240002f,-0.20130001f,-0.38819999f,0.66250001f,0.22050002f,-0.97090003f,-0.55350002f,-0.19819998f,-0.75450001f,0.87240000f,0.10420000f,-0.61420001f,0.79160000f,-0.23940000f,-0.41249999f,0.15609998f,0.08600000f,0.40550004f,-0.88960001f,-0.42340001f,-0.74870002f,-0.34919999f,-1.22160001f,-0.03450000f,-2.41860000f,-0.84030002f,-0.51689998f,0.27690001f,0.85400002f,-1.06970001f,-0.27629999f,0.14360000f,0.20130004f,0.17109999f,1.05770002f,0.40420001f,-0.16949999f,0.57610003f,1.08110003f,-0.04320001f,0.79299995f,0.45000000f,-0.98230001f,0.47260000f,0.00770000f,-0.51150002f,-0.29080001f,-0.80810000f,-0.38820001f,-0.73760002f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_3d_2item_large_5o3i_padded_strided_uneven_filter_uneven_data_dilation_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,3,8,8,8};
    Shape shape_b{5,3,2,3,4};
    Shape shape_r{2,5,9,8,9};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{2,3,2},        // move_strides
                                                                  Strides{1,1,1},        // filter_dilation
                                                                  CoordinateDiff{2,1,2}, // below_pads
                                                                  CoordinateDiff{1,2,3}, // above_pads
                                                                  Strides{2,3,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.35130000f,-0.08529997f,-0.45700005f,-1.24739999f,-0.41119998f,0.55299997f,1.06820001f,1.35650006f,0.18720000f,0.79830000f,0.02260004f,2.00550005f,0.05780004f,-0.02900002f,0.85780002f,0.09569992f,0.08460004f,0.72820000f,1.01300006f,1.08109998f,-0.27699997f,1.55730002f,0.77500000f,0.91149999f,0.90390006f,-0.31669999f,-0.25499998f,-0.32800000f,0.13909995f,-0.05599999f,-1.35200006f,0.66529998f,0.97710006f,-0.49699999f,-0.07450000f,-0.49719998f,-0.61420005f,0.15900001f,-0.41380004f,-1.15180001f,0.16630005f,-0.28640000f,-0.13789993f,-0.58379999f,-0.44540000f,-0.67720001f,-1.89039998f,0.17970002f,0.32009998f,0.17219997f,-1.58719998f,-0.37089994f,-0.84870001f,0.30340000f,-0.16710001f,0.23130001f,0.82890004f,0.72609994f,0.64569999f,0.04600001f,-0.58899999f,-1.41839999f,0.26319998f,0.11649999f,-0.03149997f,0.28670002f,-0.15370000f,0.85310000f,-0.11660000f,0.42800001f,-0.93850006f,-0.17440002f,-1.06410004f,1.70179997f,0.70759999f,0.07309997f,0.14739998f,0.61609999f,0.37660000f,-0.25380003f,-0.39519999f,-0.73770001f,1.04740006f,0.29409998f,0.53460003f,1.85260001f,-0.25340003f,-1.24250002f,-0.41720004f,-1.10359998f,-0.27799999f,0.05330000f,0.35770003f,-0.39910000f,1.97160001f,0.31370000f,1.02199995f,0.54390009f,0.22280000f,0.75490004f,0.79560000f,0.65570001f,-0.52779999f,-0.50289994f,0.21690000f,0.48850009f,-0.83039995f,-0.04179999f,-0.60830003f,-0.57590005f,0.29800000f,-0.69239997f,-0.69120006f,-1.09219998f,0.83180004f,0.10860004f,0.50919998f,-0.20869999f,-1.15349998f,-0.78130000f,0.54150001f,-0.29790005f,-0.02130000f,-0.77470005f,0.97590000f,0.19659999f,-0.01389998f,-1.44500000f,-0.52559999f,0.81419996f,-0.31409997f,-0.01779999f,0.73130003f,0.18609998f,0.70760000f,0.96780005f,0.58720000f,-0.91510002f,-1.09919999f,-0.75659997f,0.59770001f,1.41229999f,0.55540002f,-0.46920000f,0.34310001f,-1.26090001f,-1.23090000f,-0.72110001f,0.35729999f,0.02389994f,-0.27760003f,0.48519996f,-0.92699996f,0.79900001f,0.29569993f,-0.78460006f,-0.81360001f,0.43900008f,0.68680000f,-0.08979998f,0.78220002f,0.21700000f,-0.89530004f,0.99129997f,0.89240001f,0.95109999f,0.23350000f,0.77570001f,-0.09390000f,0.86710004f,-0.05660000f,-0.53050002f,0.05059999f,-0.81249998f,-0.98910002f,-1.51940003f,-1.66710003f,0.45469999f,-0.29229998f,-0.68619997f,0.93520000f,-0.58510002f,-0.08079998f,0.14880000f,-0.10910004f,-1.51610000f,0.70250002f,1.46960001f,0.04660000f,0.55490004f,1.46450000f,-0.91230000f,-0.10050005f,-1.21439995f,-0.42039998f,0.11050003f,-0.50040000f,-0.76480000f,-0.37080003f,0.63509999f,-0.74650001f,-0.91080000f,1.58990001f,1.17399998f,1.65119997f,0.72890001f,-0.29899998f,-0.95490000f,-0.72239995f,0.51919995f,1.21159997f,-0.25740006f,0.14280000f,1.08480002f,-0.61440002f,0.10639999f,0.21820000f,-1.05389998f,-0.83989997f,-0.35460004f,0.67349995f,-1.47670001f,0.70680002f,-0.05770001f,0.40339998f,0.10660001f,1.76580002f,-0.08559999f,0.41420000f,1.93859999f,-0.47370001f,0.24400000f,-0.58990002f,0.11220000f,0.23080000f,0.38570002f,-0.34340001f,0.56720006f,0.54760004f,0.24930003f,0.19209993f,-0.86549998f,-0.62539999f,0.14620000f,0.77220005f,0.33250001f,0.39540009f,0.58810001f,-0.29559999f,0.89090003f,-0.92930000f,-0.28220000f,0.67820002f,-1.20910004f,-1.03700002f,-0.43579999f,0.63079999f,0.40679994f,0.40090003f,-0.83940000f,0.55319998f,0.98320003f,-0.49590001f,0.13620001f,-0.82560003f,0.01900003f,-0.35540002f,-0.12099998f,0.60910002f,-0.68979998f,0.98560004f,1.52460001f,0.78950003f,0.25200003f,-0.78960002f,0.95690002f,0.19690003f,-0.58640000f,0.08380000f,-0.70570003f,0.95590000f,0.85529998f,2.04370001f,-0.19810003f,-0.39340003f,0.00809996f,0.49600001f,-0.45299997f,-0.64060001f,-0.30249998f,0.34759997f,-1.17059996f,1.92310004f,1.01980000f,0.38670002f,1.17129999f,0.09080000f,0.54630000f,-1.30240005f,-0.65710000f,0.32090003f,-0.23640006f,-0.59419997f,0.12349997f,1.11910004f,0.51019999f,-0.27050003f,-0.19669991f,1.27550001f,-0.38270000f,-1.76200002f,0.32590004f,1.04429995f,-0.73060003f,0.40779996f,-0.26060000f,0.74360003f,0.38900001f,0.30559998f,0.48370004f,-0.80679998f,0.56610001f,-0.59569996f,-0.33579999f,0.54550000f,0.30479997f,1.03860005f,0.86150001f,-0.20399997f,0.93399996f,-0.60550001f,-0.12330003f,0.20619998f,-0.07580004f,-1.61930004f,0.19219999f,0.17830001f,-0.70359998f,1.26020001f,1.43519996f,0.49490008f,-0.42760000f,0.37280001f,-0.77569999f,0.34289998f,-0.69240000f,-0.83739995f,-0.84430005f,0.17010002f,0.51870002f,0.91299997f,0.22100004f,0.41450001f,0.82929999f,-0.64710003f,-0.50929996f,1.04870001f,0.22119999f,0.38419995f,0.44120000f,1.26390006f,-0.95090004f,-1.25780005f,-0.44700001f,-0.08980002f,1.15320000f,-0.19540001f,-0.03390000f,0.82240000f,-0.61800000f,-0.94210003f,-0.03770000f,0.51990000f,0.49570002f,-1.38969999f,-1.69430001f,0.51030006f,0.39880000f,0.09729999f,-0.11220001f,-1.14120001f,-0.96520003f,-0.25370004f,-1.51869998f,-0.47809998f,-1.30929998f,0.52119999f,0.03810001f,0.51099999f,-0.04929997f,-0.30039998f,-1.00080007f,-1.57509996f,-1.11500003f,-0.53449997f,0.66119997f,0.73760001f,-0.23509999f,-0.53920006f,0.68940005f,0.01939997f,1.47489998f,0.46749999f,-1.22540004f,-0.88039996f,0.30240001f,0.01440004f,1.01259997f,-1.44360002f,-0.25460007f,-1.92839999f,0.17000002f,-1.79690002f,0.03279999f,-1.10910006f,-1.15699999f,0.85849998f,-0.61760002f,-0.06610002f,-0.22570002f,0.24050000f,-0.17380001f,0.49720000f,-0.87310001f,-1.18129996f,0.08090001f,0.97820001f,-0.12390004f,-1.38729999f,0.25860003f,-0.30599997f,-0.11199999f,-0.26590001f,-0.61190003f,-0.43520001f,-0.33840002f,-1.24850000f,0.06829998f,-1.25200001f,-0.30179993f,0.59179996f,-0.59970003f,-0.33900000f,-1.12210001f,0.42610001f,1.06879997f,1.99329998f,0.51649998f,0.04969998f,0.15100001f,0.07560001f,0.99859997f,0.09990004f,0.05319993f,0.51520001f,-0.12920009f,-0.55199998f,-0.41040003f,-0.75379999f,0.18180000f,-0.52439998f,0.43090000f,-1.18750006f,-0.56089999f,0.48069998f,0.30070005f,0.52559996f,0.30859997f,0.57920003f,-0.96760005f,0.24720005f,-0.75970001f,-1.01419996f,-1.58080002f,-0.78869995f,1.89050001f,0.99959998f,0.79070005f,1.31470004f,1.03910002f,0.93639997f,-0.01310000f,0.03700001f,-0.76010004f,0.34170002f,-0.15639997f,-0.51870000f,0.46300000f,0.61490001f,-0.14959993f,0.34730001f,-0.34780001f,2.14600001f,-1.39569999f,0.39100001f,-1.19970006f,-2.23880003f,0.43930001f,1.35519995f,-0.02910002f,-0.16529998f,1.00620001f,-0.11639998f,-0.25159999f,1.11920004f,0.28299993f,-0.36240003f,0.80519996f,1.25190003f,1.99900006f,-0.01280001f,0.31950000f,0.79559998f,-0.25080000f,-1.02779999f,-0.93389999f,-0.20570001f,-0.75290000f,1.66760002f,0.16060003f,-0.27460005f,0.42260000f,1.52060004f,-0.50330002f,-0.03139996f,0.54240000f,-0.81309997f,-1.37430005f,0.46030003f,0.49889994f,-0.62140000f,-0.74520002f,-1.42100004f,-0.81309994f,0.70079999f,1.20450002f,0.80569999f,0.12799999f,1.23880000f,-0.22540000f,-0.39290001f,-0.73150003f,-1.07460006f,0.10280002f,-0.22520002f,0.36470002f,0.24879997f,-0.24089998f,-0.48160000f,-0.24700001f,0.57300005f,1.56850002f,-0.34280008f,1.20269998f,-1.24210003f,-0.51450002f,0.93450001f,0.11400000f,0.99480002f,0.51579994f,-0.60160004f,-1.12099996f,-0.84370006f,-0.20980000f,-0.98840000f,-0.96430001f,-0.32799999f,-0.66950003f,-0.66890003f,-0.08149998f,0.88540000f,-0.09420000f,0.44540004f,0.39379999f,0.62370003f,-0.48359996f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.47450000f,0.11410000f,-0.42810000f,-1.13130000f,-0.08240000f,0.72230001f,0.59510001f,0.84110002f,0.90280001f,-0.29980002f,0.95790001f,0.48820001f,1.06220000f,0.79780002f,0.80930002f,-0.16290000f,-0.51710001f,0.35990000f,1.02270002f,0.69520000f,0.17600001f,0.52760000f,1.28399999f,-0.01499999f,-0.03180001f,0.81430001f,-0.00489998f,0.39750001f,-0.07500000f,-0.29350000f,0.04540001f,-0.88030002f,-0.03000003f,-0.05770003f,-0.48960003f,0.49939998f,-0.51289998f,-0.73530002f,-0.52460002f,-1.12540002f,-0.20710000f,0.41040003f,-0.25920000f,-0.19820000f,-0.34290000f,-0.86059999f,-1.22599997f,-0.40459999f,0.52010002f,-1.03870002f,-1.33890001f,-0.36850000f,0.43150004f,-0.68810000f,-0.11570000f,-0.16410001f,1.13269999f,0.63530001f,-0.58340003f,0.36870000f,-0.44309998f,-0.29829998f,-0.12599999f,-0.19350002f,0.34919999f,0.63680000f,0.58420003f,-0.02579998f,-0.08840000f,0.01090001f,0.11139998f,-0.79400002f,0.19350001f,0.19259996f,1.58949998f,0.47970002f,0.20220002f,0.15809997f,0.37099998f,-0.03790001f,-0.46800003f,-0.15000001f,0.10489999f,0.50640000f,0.62249998f,1.27669999f,0.03610002f,-0.86009999f,-1.52020002f,-0.63380002f,0.02900004f,-0.26339996f,-0.43089997f,-0.00449996f,-0.01600002f,1.22849999f,-0.46399998f,-0.00820001f,0.54180001f,0.21190000f,0.80899999f,0.66899998f,-0.58549997f,-0.55410002f,0.39809998f,0.14800002f,0.26820004f,-0.46390000f,-0.11790000f,-0.59700003f,-0.62020002f,0.16190002f,-1.13750001f,-0.57179999f,0.12250001f,0.94600000f,0.51820000f,-0.07390000f,-0.65559999f,-0.59069997f,0.29729999f,0.37560001f,0.09040000f,-0.02680000f,-0.40200003f,0.72529999f,-0.18020002f,-0.21189999f,0.02100001f,-0.29040000f,-0.23230000f,-0.04499999f,0.39160000f,1.08400004f,-0.02620000f,0.58280001f,0.54960001f,-0.63169999f,-1.18160001f,-0.16289999f,1.11050002f,0.63270000f,-0.31890001f,-0.10380000f,-0.12870001f,-0.67989999f,-1.14910000f,-0.25799996f,-0.02440002f,0.46480001f,0.27370001f,-0.97870000f,-0.37089999f,0.65550000f,0.81029999f,-0.96410000f,-1.43990000f,0.26679999f,0.58909999f,0.59140000f,0.48430001f,0.00750000f,0.30920000f,0.00079998f,0.78199998f,0.79699998f,0.93410002f,0.15599999f,-0.14449998f,-0.01400002f,0.77270002f,0.20650000f,-0.72769998f,-0.69759998f,-0.65699999f,-1.25190000f,-0.62629999f,-0.73700002f,-0.57050001f,-0.01010000f,-0.15030004f,-0.10620001f,-0.17320003f,1.62030002f,0.22820003f,-1.13589998f,-0.31369997f,0.66789998f,0.51430000f,0.69930000f,0.28030000f,0.55580001f,-0.89960000f,-1.08659998f,-0.52659999f,0.35000000f,0.10270001f,-0.38640000f,0.17609999f,0.01529997f,0.26540000f,0.23930002f,0.41999998f,1.26089998f,0.78290000f,0.37959998f,0.17310000f,-1.05259999f,-0.39580000f,0.76770000f,0.51269997f,0.74170001f,-0.13409995f,0.02999999f,0.12710001f,-0.54120001f,-0.21970000f,-0.43340001f,-0.01119999f,0.76830001f,-0.01530002f,0.10460006f,-0.81570004f,0.83419997f,0.34509999f,0.35600002f,-0.06930002f,0.67390000f,0.76770001f,0.30569996f,0.40260000f,-0.34550000f,0.04080002f,-0.44289999f,-0.33980001f,0.51789997f,0.44150002f,-0.91640001f,0.35820000f,1.61560001f,-0.27500000f,-1.31830001f,-0.03250000f,0.04970000f,0.86770002f,0.17240003f,-0.01949999f,0.91689997f,0.90520003f,0.29300001f,0.26970002f,-0.17530000f,0.25759999f,-0.03560000f,-1.29020000f,-0.11000001f,0.82810000f,0.05150001f,-0.39810002f,0.88370002f,-0.24220000f,-0.05110003f,0.61720001f,0.17050000f,-0.26929999f,-0.75440002f,0.02970001f,-0.38980000f,-0.86070000f,-0.19870001f,0.42320000f,0.62939999f,0.35839996f,0.50149997f,0.65670002f,-0.55300004f,0.36580001f,0.65640001f,-0.16429999f,0.38180001f,0.29420000f,1.11919999f,0.95789998f,0.98520001f,0.07260002f,-0.49609998f,-0.53010004f,0.57050002f,-0.86829999f,-0.54919999f,-0.68420000f,-0.31409997f,0.84759999f,0.97680005f,0.34860000f,0.70180000f,0.53260002f,-0.06080001f,-0.51260002f,-1.53160003f,0.58230000f,-0.00710000f,-0.49619999f,-0.02609999f,-0.34290002f,0.59810000f,-1.09440000f,-0.26080003f,0.52080000f,-0.06630003f,-0.68820001f,0.11889998f,0.75979999f,0.24589997f,-0.11750000f,-0.01099998f,-0.30590000f,0.65970001f,-0.34010002f,-0.61940002f,0.50590002f,-1.14640000f,-0.60840000f,-0.24689999f,0.51229998f,0.46830000f,0.57840002f,0.16810003f,0.24199997f,0.87339999f,0.61700001f,-0.42459998f,-0.51550001f,-0.71700001f,-0.35640003f,0.09710001f,-0.41110000f,0.31489999f,1.13109999f,0.31319997f,0.27909996f,0.55660002f,-0.20260000f,-0.00149997f,-0.64400000f,-0.36979999f,-0.61489996f,-0.88519999f,-0.40980004f,1.12140001f,0.41509999f,0.62830000f,1.02180004f,0.59809999f,-0.33119998f,-0.55509998f,0.26100000f,0.69240000f,0.22280002f,-0.27260000f,0.40750000f,0.62530003f,-1.22959999f,-1.08230001f,0.17819998f,0.35879995f,0.46749998f,0.50530002f,0.17720000f,-0.10070000f,-0.44669998f,-0.13379999f,0.39150003f,-0.94770000f,-1.07110000f,-0.32029998f,0.22430001f,0.71940004f,0.21990002f,-0.23239999f,-0.45189998f,-0.28989998f,-1.27850000f,-1.11829997f,-0.90479999f,0.05240003f,-0.43379999f,0.05590001f,-0.40329999f,-0.67130000f,-0.00350001f,-0.27530000f,-1.07829997f,-1.35590000f,-0.01750003f,0.61380001f,-0.20420001f,0.65259999f,-0.30769999f,-0.28900002f,1.52750002f,-0.18750002f,0.29689996f,-0.01990000f,-0.72859998f,-0.47430001f,0.79019999f,0.64660000f,0.07840001f,-1.58510000f,-0.75779999f,-0.66630000f,-0.07399998f,-0.88080000f,-0.77110001f,-0.66500002f,0.14330000f,0.33040000f,-0.17589999f,0.44480003f,0.07229998f,0.45370002f,0.09060000f,-0.94819996f,-0.94469997f,-0.35350000f,-0.24900004f,0.05169997f,-0.41889998f,-1.20130000f,-0.15000000f,0.22240001f,0.29009999f,-0.58219998f,-1.25120000f,-0.54170002f,-0.08619998f,-1.25140000f,-1.13310001f,-0.19580000f,0.24730000f,-0.15279999f,-0.77530000f,-0.38279998f,0.10560000f,0.96499999f,1.04979998f,1.12959997f,-0.10559997f,-0.27990001f,0.75610000f,0.19229999f,0.86569999f,0.65960002f,0.25109997f,-0.30560004f,-0.53890003f,-0.37150000f,-0.79190000f,-0.43340001f,0.63309999f,0.25870002f,-0.94599999f,-0.10589999f,0.15030001f,0.45910001f,1.21790002f,0.20409999f,0.23529999f,-0.05529999f,-0.78940003f,0.01730004f,-0.87119999f,-1.24679998f,-0.50450001f,1.00350000f,0.89580001f,0.40660000f,0.69910002f,1.03059999f,0.57319998f,0.01329999f,0.35369998f,-0.00640000f,-0.39030000f,0.61700001f,0.65030002f,0.04380003f,-0.40000001f,0.85799999f,-0.05020000f,0.80569999f,0.59089997f,0.54000005f,-0.57589998f,-1.03890003f,-1.03960002f,0.02579999f,0.51100000f,-0.18790003f,0.15239999f,0.77790000f,0.49430003f,0.04100000f,0.68489999f,0.85170001f,-0.34580003f,0.00839997f,1.27299999f,1.51560002f,1.35000005f,0.48000002f,0.18180001f,-0.54710000f,-1.01720000f,-0.74070001f,-0.63070002f,0.34799998f,0.32640000f,1.28349999f,0.44820002f,-0.54970002f,0.66640000f,0.39280002f,-0.47710000f,0.47210000f,-0.02559999f,-0.79589999f,0.15899999f,0.27249999f,-0.79530002f,-0.24439999f,-1.28010000f,-0.54940001f,0.56060001f,0.73820000f,0.76740002f,0.43110002f,0.19119998f,0.67349999f,-0.04589999f,-0.19920000f,-0.52959999f,-0.56850001f,0.26520002f,0.31440001f,-0.04589998f,-0.73430000f,-0.11480000f,-0.03710001f,0.80370001f,1.44940003f,0.52740002f,-0.56190001f,0.40269999f,-0.28170002f,0.07740000f,0.16100000f,0.65389998f,0.82979998f,-0.91949998f,-0.65929998f,-0.53319999f,-1.04030005f,-0.36330000f,-0.98449999f,-0.67560002f,-0.17420000f,-0.64470001f,0.01659999f,0.65419998f,0.77720001f,0.44920002f,0.32330000f,-0.38420000f,0.19100001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.33310000f,0.26159998f,0.21549999f,-0.76859999f,0.11519999f,0.64029999f,0.10620001f,0.17830001f,-0.07520000f,0.65740000f,-0.25060003f,1.35940005f,-0.37020002f,-0.69900005f,0.45849999f,0.80850001f,0.76250003f,1.06440003f,0.71230001f,0.41060003f,-0.48509998f,1.57910000f,0.71269998f,1.49070004f,0.81650002f,-1.00780000f,-0.63579998f,-0.25850000f,-0.09880002f,-0.14130000f,-0.88850003f,0.68600002f,0.63470003f,-0.43300000f,-0.40850004f,-0.64880000f,0.28149999f,0.90769999f,0.38960000f,-0.62930002f,-0.61280002f,-1.23870002f,-0.45379995f,-0.25809999f,-0.34910002f,-0.17679999f,-1.32770003f,0.06129998f,1.11090000f,1.16030004f,-1.24019999f,-1.02480002f,-0.30249999f,0.77690003f,-0.29450002f,0.13900000f,0.52529999f,1.64910001f,1.27419998f,-0.41310001f,-0.70049999f,-1.49850004f,0.02620000f,-0.39850001f,-0.39220001f,-0.05540000f,-0.74130001f,0.96500001f,0.40000000f,0.61929999f,-0.49900001f,-0.20550000f,-0.64270002f,1.31359998f,0.12529999f,-0.10410000f,0.05739999f,-0.37879998f,-0.70000001f,0.28600001f,0.13520000f,-0.94439999f,0.33320003f,0.47870001f,0.35029998f,1.42230004f,0.54640003f,-0.19499999f,0.01270003f,-0.97600002f,0.75700004f,1.07440004f,1.04830006f,0.45640002f,1.70080002f,0.79500000f,1.68729999f,0.78580005f,0.39170001f,0.69790003f,0.00809998f,-0.33030001f,-0.12069999f,-0.70670002f,-0.60150002f,-0.36019998f,-0.36759997f,0.40330001f,0.08030001f,0.14080001f,-0.32760000f,-0.35789997f,-0.07790003f,-1.68650007f,0.30280002f,-0.32560001f,0.20570000f,-0.86249999f,-1.34619997f,0.08499998f,0.53680000f,-0.89380004f,-0.23840000f,-0.47209999f,0.52060000f,0.04229999f,-0.75659999f,-2.10700002f,-0.52620003f,1.11850001f,0.06260000f,0.65790001f,0.23149999f,-0.06470000f,0.82930004f,0.46980001f,0.10250001f,-0.35660002f,-0.81310001f,-1.63170004f,0.06879998f,1.49360002f,1.08130003f,-0.08130003f,-0.06410000f,-0.91529999f,-0.75760002f,0.40550000f,0.73099998f,-0.54120005f,-0.19230000f,0.77250001f,-0.82270000f,0.96849998f,0.40379994f,-0.49810001f,-0.44740001f,-0.07750000f,0.09430000f,-0.66730004f,1.02900005f,0.62380000f,-0.68480005f,0.27549996f,-0.13430001f,0.37819997f,0.80960000f,0.77250003f,0.24450004f,0.47250000f,-0.50580001f,-0.62150003f,0.29860000f,-0.16550000f,-0.49640001f,-1.15869999f,-1.42750003f,0.34410003f,-0.38140000f,-0.64320001f,0.51069999f,-0.12330002f,-0.48800004f,-1.03090006f,-0.17169994f,-0.95199999f,1.01950000f,1.34200001f,-0.08920001f,0.34050000f,1.43220003f,-0.67960002f,-0.16540000f,-0.51519998f,-0.02650000f,-0.98830002f,-1.25609999f,-0.89620004f,-0.66470004f,-0.33970003f,-1.09860002f,-0.96280001f,1.51800004f,0.86529996f,1.06859998f,0.71500002f,-0.17240000f,-0.56719998f,-0.46520002f,1.05369999f,1.00419999f,-0.23610002f,0.54510003f,0.85310003f,-0.15290001f,0.51230000f,0.05310001f,-1.47339999f,-1.46880004f,-0.55670005f,-0.30720004f,-1.36350000f,-0.00279998f,-0.64680003f,0.47250000f,0.61120001f,1.87790004f,-0.19060003f,0.10029999f,1.51030002f,0.51990000f,0.75670001f,-0.35680001f,0.20810001f,0.17940000f,-0.28550003f,-0.43009999f,0.53040002f,0.20159996f,-0.22530004f,0.28880000f,-0.69690002f,-0.52140003f,-0.24330002f,0.30020000f,0.37050004f,-0.15039998f,-0.71450002f,-0.89610002f,0.14070002f,-1.73500004f,-0.53910001f,0.13580000f,-1.19290001f,-0.63670002f,-0.27280001f,0.34739999f,0.71490001f,0.07560000f,-0.99550001f,0.49370001f,0.39550000f,-0.76690004f,-0.10200000f,-0.55829999f,-0.49810000f,-0.08790001f,1.07990001f,1.49550005f,-0.34610001f,0.68700000f,1.05310001f,0.35779999f,-0.53530005f,-0.81570003f,0.81320002f,-0.12990004f,-0.79990001f,-0.16119999f,-0.82620004f,0.56730002f,0.66019999f,1.32540001f,-0.31390000f,-0.42850000f,0.75180004f,0.02589997f,-1.06840001f,0.04410002f,0.52619997f,1.09300001f,-0.35220000f,1.92550002f,1.75440005f,0.28070000f,0.12729998f,-0.21180000f,0.63240000f,-0.68350000f,-0.36860001f,0.12389996f,-0.04429998f,0.04920001f,1.27560005f,1.49670005f,0.66970001f,0.53240004f,0.06610001f,1.13740003f,-0.75150002f,-2.00550003f,-0.16940002f,1.25230001f,-0.62470006f,0.15109997f,0.10280001f,0.70400003f,0.50159998f,0.94740002f,0.47009998f,-0.18420002f,1.17260002f,0.28950001f,0.13310000f,0.11069998f,0.50540001f,1.24310001f,1.51380007f,-0.54230001f,-0.04420002f,-0.83830001f,0.52080002f,0.64319999f,0.44940000f,-1.12000006f,-0.18990002f,-0.11229996f,-1.57050005f,0.66410004f,1.03029999f,-0.07059997f,-0.51030003f,0.55820002f,0.45830003f,0.94980001f,-0.93619998f,-0.25659994f,0.09390000f,-0.36700001f,0.23050000f,1.04010001f,-0.63630000f,-0.45510000f,-0.21810003f,-0.58340002f,0.31159999f,1.57950002f,0.64119999f,0.87660000f,0.60600002f,1.08030004f,-0.35779998f,-0.50489998f,-0.00379999f,-0.61700004f,-0.03270001f,-0.59800004f,0.27979998f,1.03920004f,-0.69029999f,-0.66129999f,0.42480002f,0.94600004f,1.08020007f,-1.27970003f,-1.78750005f,-0.42990000f,-0.15439999f,0.71269999f,0.58630002f,-0.95029999f,-0.68830002f,-0.29959999f,-1.07780000f,-0.28040001f,-0.88960000f,0.74320002f,0.44630001f,1.40480002f,0.99260005f,-0.57070000f,-1.62700003f,-0.91049997f,-0.58529999f,-1.24230002f,0.28860000f,0.61940000f,0.01859998f,0.17390001f,0.22330001f,-0.70060005f,1.12510000f,0.28179994f,-1.34420005f,-1.05610000f,0.21810002f,-0.61100003f,0.83590001f,-0.70390001f,-0.00640000f,-1.53900001f,-0.09259998f,-1.45889999f,0.20200001f,-0.67010000f,-0.86520001f,1.02909999f,-0.37610001f,-0.55860000f,-0.51509999f,-0.45519997f,-0.61640000f,0.48580003f,-0.40399998f,-0.40409999f,1.03180003f,0.69110001f,-0.28390005f,-0.46830002f,0.62890003f,-0.28420001f,-0.04740000f,-0.63290003f,-0.24319999f,0.21029998f,0.46029997f,-0.59500000f,0.53560005f,-0.69720002f,0.03090003f,0.81029999f,-0.65560003f,0.25840003f,0.20890002f,0.46360002f,0.28050000f,1.47499999f,0.15530000f,0.41070002f,0.65050001f,-0.19390002f,0.46670000f,-0.80620002f,-0.48900004f,0.02349998f,-0.00410001f,-0.22320002f,0.26490002f,-0.55930001f,0.04100001f,-1.26910005f,0.76810004f,-0.42520003f,-0.77640003f,0.53460004f,-0.41540002f,-0.49910004f,-0.12300001f,-0.09090000f,-0.82760001f,-0.12850000f,-0.89450002f,-0.28029996f,-0.95659999f,-0.87199999f,1.73240000f,1.07070001f,0.40480001f,0.95610002f,0.94709999f,1.11329999f,-0.03250002f,-0.39990000f,-0.90340001f,-0.45970001f,-0.53659998f,-0.70970001f,0.48210006f,0.10060001f,-1.47989999f,0.09060004f,-0.70580008f,1.31540003f,-0.86460003f,0.63800003f,-0.91150001f,-1.84620005f,0.61830001f,1.53519998f,0.08159999f,-0.45850004f,-0.16430002f,-0.91320000f,-0.31290000f,0.62249999f,0.87609999f,0.28639999f,0.02529996f,0.51179999f,1.43850002f,-0.12419998f,-0.03179997f,0.51690002f,-0.01149999f,-0.58780001f,-0.92590002f,0.01809998f,-0.60740005f,0.75210002f,-0.92180000f,0.12340003f,0.95350004f,1.21180000f,-0.04769997f,-0.54500001f,-0.32269999f,-1.00159999f,-1.24310004f,0.02149996f,1.18650003f,-0.15070001f,-0.54100001f,-1.24739999f,-1.13739999f,0.62540000f,1.52800004f,1.54060005f,0.22520002f,0.02020001f,-0.76660001f,-0.12190000f,-0.13009999f,-0.47419999f,-0.20809995f,-0.39569998f,0.52710003f,0.81360002f,-0.18749998f,-0.61650001f,-0.59390003f,-0.33550003f,1.60110003f,0.42689997f,0.56199999f,-1.29699999f,-0.76330002f,0.89250005f,0.34880001f,1.01870000f,0.88759998f,0.09880000f,-1.07469999f,-0.66529999f,-0.39530001f,-0.90800002f,0.03680002f,0.20210001f,-0.54180001f,-0.96980004f,-0.37790002f,0.02909996f,-1.28420003f,0.23810005f,0.64720002f,0.55060004f,-0.37659998f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.35599998f,0.51480002f,0.51219997f,0.69950001f,-0.43739996f,-0.85240001f,-0.73650001f,-0.49640004f,0.04540001f,0.30280000f,0.90290002f,-0.33520007f,1.04650001f,0.02270001f,-1.76650002f,-0.82860003f,-0.18219998f,0.07209998f,-0.60600000f,-0.06890008f,-0.47319997f,-0.19319999f,-0.11090001f,-1.25490000f,1.47920001f,0.94389999f,-0.45569999f,-0.36599999f,-0.51610000f,-0.45740002f,0.04010002f,-0.85610002f,1.13149997f,1.48500006f,1.84450001f,0.79680002f,-0.68679998f,0.37589999f,0.15759999f,1.14500005f,1.14660000f,0.75439997f,0.15579997f,0.92590003f,0.46490002f,0.14540001f,1.27820004f,0.03400001f,-1.16150000f,0.36769994f,1.89300003f,1.32250002f,-1.02650000f,-0.05410002f,0.29600001f,-0.01040000f,0.12020001f,-2.24719999f,0.54520000f,0.68770000f,-0.04919999f,0.89570004f,-0.94799999f,0.83699999f,0.02560001f,0.34350000f,-0.46940000f,-1.53610000f,0.66979998f,-0.27659999f,0.15129996f,-0.56659997f,-0.55019998f,-1.16220000f,-0.47480001f,-1.54809998f,-0.91770002f,0.15549996f,0.04690001f,-0.20010000f,1.17840002f,0.52799999f,-0.36709998f,0.14700000f,0.40550002f,-0.98920004f,-0.75790000f,0.28540001f,0.10659997f,1.12180004f,-1.37840000f,-0.42000003f,-1.27010004f,-0.44510001f,-0.52290005f,-0.78069997f,-0.26630002f,0.71789996f,0.55520002f,-0.22480001f,0.98279998f,-0.05020002f,0.33970000f,2.36699998f,0.69600000f,1.09999997f,0.10589999f,0.54470001f,-0.73259999f,-0.29479999f,0.65530000f,-0.86989998f,1.11680003f,1.18810002f,-0.33990004f,0.95320000f,-0.81380001f,0.98139996f,0.05500002f,-0.22589996f,0.56389997f,-0.57470001f,-0.96440000f,-0.53850000f,-0.42799997f,0.09250000f,1.15639997f,0.67750005f,-0.69159997f,-0.49080004f,0.53540000f,-0.28380000f,0.74159998f,-1.54150002f,-0.69800004f,0.03100000f,0.14899996f,-0.01299996f,1.85359997f,1.09760003f,-1.17970003f,-1.01310004f,0.01530000f,1.31660004f,0.59939999f,0.48000002f,1.13320004f,-0.99179998f,0.01989998f,-0.87520001f,-1.78429999f,-0.36580002f,1.08490001f,-0.90419997f,-0.38570000f,-0.94290001f,0.81860002f,1.16889999f,0.33209998f,0.78040002f,-1.23220001f,0.56130001f,-0.38839996f,-0.59170002f,-0.04580002f,0.01560002f,-0.78950000f,0.18549994f,-1.10539999f,1.40660001f,-0.14050000f,0.04280002f,-0.84520000f,0.78390001f,0.47800000f,0.44569999f,0.01760003f,-0.58680004f,0.99590000f,0.97590002f,0.54060000f,0.56590003f,1.96340002f,-0.41420001f,-1.85730008f,-0.21239994f,-0.97200000f,0.20059996f,0.13249999f,-0.37919997f,-0.78740003f,0.63560006f,-0.35010001f,0.14900003f,1.27320001f,0.86639999f,-0.19309999f,0.37320004f,0.31560001f,0.12929998f,0.32470002f,-0.21139998f,-2.02750002f,-0.15579994f,-1.03650003f,0.30899999f,0.81070000f,0.50300001f,0.53870006f,-1.24229998f,-0.71920002f,-1.23149999f,-1.68760003f,-0.19350005f,-0.79089997f,0.19920001f,0.36759997f,1.49449998f,0.33660005f,-0.95289998f,-0.34240002f,-1.16520000f,0.89809996f,-0.24939995f,-0.06729999f,-0.99440000f,-0.11880003f,0.78870001f,-0.42000001f,-0.72490004f,-0.06219997f,0.58549999f,-0.51499999f,-0.35650002f,0.31040000f,1.10680000f,-0.38299999f,0.54870000f,1.72450005f,0.37250000f,-0.86600001f,1.28010003f,1.00150003f,0.46180000f,-0.50830002f,-0.05220006f,0.80030000f,1.34619998f,-0.80759996f,0.58659995f,0.30310000f,-0.32170000f,0.40779998f,0.21240001f,0.03050002f,0.42290001f,-0.97289999f,-1.34400002f,0.95309999f,-0.22209999f,-1.06820001f,0.67180001f,0.70370002f,-0.00860000f,-0.24530000f,0.97000001f,-0.38439998f,-0.04949996f,0.43029996f,1.42650005f,-0.11059999f,0.35939995f,1.28600002f,2.07870002f,-0.08979998f,0.39710000f,1.04860003f,0.68009999f,-0.76530000f,-0.03199999f,-1.47490003f,-0.86900000f,-0.77390002f,-0.41350001f,-0.71800000f,-1.90920004f,1.75119998f,-0.15090003f,-0.10399999f,0.36270006f,0.38239995f,0.55140001f,-0.87650004f,-1.82760006f,0.51919999f,-0.99930001f,-0.25200001f,-0.15879999f,0.73709999f,0.64370008f,0.74120002f,-0.16920005f,-0.49489996f,-0.82550005f,-0.46730001f,0.21210001f,-0.14040004f,1.80650004f,-0.19540004f,1.82590002f,0.92550004f,0.11190004f,-0.93050001f,0.64140004f,-1.16970001f,-0.43900000f,0.24519997f,-0.18989998f,-0.00960003f,1.38570004f,0.36480003f,0.17910000f,1.11740005f,1.17750004f,0.07480000f,-1.09020001f,-0.55010000f,-1.01670009f,1.30110002f,-0.98849998f,-0.54650000f,-1.74739998f,0.15650001f,-0.10800000f,1.28500005f,-0.84830001f,-0.25520003f,1.28420003f,-1.71750000f,0.35499996f,1.24140001f,0.90040003f,-0.14720001f,-0.55519997f,0.04679999f,0.54009997f,-0.93409997f,0.45080000f,0.72170000f,-1.06600000f,-0.54930001f,0.60619999f,-1.19250000f,-0.05080002f,-0.58740000f,0.29410002f,-0.33930002f,-0.56019997f,-1.36040000f,-0.48780002f,-0.30040002f,-0.12360001f,-0.98739999f,-0.32220001f,0.58450000f,-0.14530001f,0.59250005f,-0.39379999f,-0.46500005f,0.28519999f,-0.66709999f,-0.87690000f,-1.26620005f,-0.55300003f,2.34680003f,0.54340005f,0.03779996f,-0.99880002f,-1.03079998f,-0.17700003f,-0.26660000f,-1.36329994f,-0.24020004f,0.30960007f,1.30599998f,-0.23249999f,-0.62280002f,-0.60519999f,-0.51760001f,0.50790000f,1.70609999f,0.09180001f,-0.56070000f,1.26689999f,0.45260005f,-1.06680000f,0.20360000f,0.30560002f,-0.67230000f,0.36220000f,-0.46099999f,-1.42630002f,1.42210001f,1.19590003f,0.11819997f,0.45359999f,1.11450003f,-1.17670002f,-0.01489998f,-0.29650002f,0.66180002f,0.34259995f,-0.17449998f,-0.50459998f,0.22779999f,0.27700006f,-1.08879999f,-0.02939999f,-0.66040000f,-1.06100000f,-0.18050005f,-0.99849998f,-0.58980003f,0.29299998f,0.43890001f,-0.44750001f,1.05549999f,0.49670005f,0.49330003f,0.63349998f,1.12480004f,0.48400001f,0.30300001f,-1.06819999f,0.73550001f,0.44250001f,0.67159998f,-1.03190003f,1.53980002f,0.04950001f,-0.09569998f,0.30280002f,-0.81750003f,-0.00319996f,-0.57690004f,-1.39780003f,-1.55580001f,0.41529996f,-1.51819998f,0.57409997f,-0.27039998f,-0.75950003f,0.49420003f,-0.88639999f,-0.53880001f,0.00430001f,0.50430007f,0.31080000f,0.65710003f,0.51679998f,1.21320003f,-2.13410002f,1.11490003f,-0.42560000f,-1.19920005f,0.33440001f,-0.89800002f,-1.10450001f,0.61579999f,-0.23450000f,1.20160002f,0.73339998f,0.18080000f,1.33939998f,-0.04699996f,-1.26319999f,-0.33560002f,0.05420000f,-0.16450002f,0.10410000f,-0.17559999f,0.68199999f,0.30679999f,-0.17229998f,0.50179997f,-0.01120002f,-0.18920002f,-1.89580004f,0.76599995f,1.19489999f,-0.78970000f,1.48480005f,-1.21570005f,0.33700002f,-0.53190003f,0.66780001f,0.67120007f,-1.19279996f,-1.06389999f,0.53289999f,0.30910005f,0.59659998f,-0.26950001f,0.24020000f,-0.08039999f,-1.42450001f,-0.13579998f,-0.04440002f,-0.81639999f,-0.34710004f,-0.67590004f,-1.28310002f,-1.44640003f,0.16880000f,1.02750004f,1.34150003f,0.12530004f,1.02930003f,-0.49080004f,0.75579997f,-1.98270000f,0.03569998f,-0.38740000f,0.06679996f,0.62390001f,0.23059997f,0.38710001f,0.75360002f,-0.36719999f,-1.04550005f,1.04990004f,0.05060001f,0.56379997f,0.53790003f,-0.86780000f,-0.90600004f,-1.05930002f,-0.35680004f,-0.38190007f,-0.20069998f,-0.26280000f,-0.70640000f,-0.89289999f,-0.64910003f,-0.77839999f,-1.09600000f,-0.97410001f,0.63599998f,0.24580003f,0.54200001f,-0.21929998f,-2.10200001f,-0.67709996f,-0.45270005f,0.11209999f,-0.25489996f,-1.39090003f,0.48280002f,-0.73879998f,-0.68769997f,-0.62609998f,0.95959999f,-0.92389999f,0.89900001f,0.53990005f,0.01360001f,0.89900003f,0.08360001f,0.48590001f,-0.30690001f,0.72160002f,0.29359997f,-1.18160000f,0.21300000f,0.09889996f,1.02800001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.23490000f,0.66689998f,1.18199998f,0.42910001f,1.08059997f,0.84310000f,-1.47130000f,-2.13270002f,-0.41849999f,-0.33440001f,-0.15020000f,-0.95100001f,-0.57779999f,-1.07190002f,-0.54220006f,1.33089999f,1.40440003f,1.12390002f,0.04449999f,-0.95229998f,-0.69659997f,0.59809998f,0.50789996f,1.14419996f,0.27900003f,-1.29659996f,-1.04079998f,0.29650000f,-0.40730002f,-0.43620003f,0.83480002f,-0.10330001f,-0.57549996f,-0.24249999f,-0.84879995f,-0.39429996f,1.38409997f,1.60239997f,1.34659998f,0.65029999f,-1.49140000f,-2.13299998f,-1.06779998f,0.46930002f,0.05920000f,0.45159996f,0.52649996f,-0.25610003f,1.69929996f,1.88350001f,0.04980003f,-1.46749998f,0.78369998f,1.12970000f,-0.31770000f,-0.31690001f,0.07500002f,1.94699993f,1.64229997f,-0.73429999f,-0.77250005f,-0.35400001f,-0.57360001f,-1.06449998f,-0.84450000f,-0.32239999f,-1.06799999f,0.12919996f,1.16309998f,0.49789999f,0.87410001f,-0.30659998f,0.78729999f,-0.18429999f,-0.50389999f,-0.30360003f,0.06040000f,-1.77649994f,-2.35419995f,0.68150002f,1.15680003f,-0.54539997f,-1.32619996f,0.36590001f,0.16930003f,-0.19009999f,1.36410000f,1.94740003f,0.33900003f,-0.08819997f,1.95499998f,2.45880001f,1.37509997f,1.92279999f,-0.00199998f,1.27189997f,1.52789998f,0.64530001f,0.61360003f,0.07629999f,-1.04139995f,-1.98949999f,0.14129996f,-0.39589997f,-1.72779997f,-1.79529998f,0.54399998f,1.02480001f,1.18789999f,1.42850002f,-1.25459996f,0.19019998f,1.00629997f,-1.51600003f,-1.17750003f,-0.45339997f,-0.53490001f,-1.30289995f,-1.21970000f,1.41219998f,0.64920001f,-1.27080002f,-0.49310003f,0.52390001f,-0.78349996f,-0.17990000f,-1.50479995f,-1.98419998f,-0.16080003f,0.67529999f,0.64960000f,1.39239996f,-0.38149999f,-0.39410001f,0.47860000f,-0.55540000f,-0.86910000f,0.47099996f,0.24880000f,-1.96529997f,-0.79730002f,0.61039998f,0.94629996f,0.85750001f,-0.80329999f,-0.07500002f,0.49610000f,2.03259996f,1.37539996f,-0.96850004f,0.10189996f,0.38389998f,-0.04399998f,0.73349996f,0.77549993f,-0.05750006f,0.17060002f,-0.73719998f,-1.14280002f,-1.01789997f,0.53959998f,1.09890001f,0.46139997f,-1.10270004f,-1.87360000f,-0.96040000f,1.42179997f,0.54630001f,0.31460000f,-0.28319996f,-0.98760000f,-0.12550001f,0.07429993f,1.02319998f,0.70889999f,0.05730001f,0.11730004f,-0.38700001f,-0.55659999f,-0.05899998f,-0.78510000f,0.48599998f,-0.54629997f,-1.91710000f,-0.37380001f,0.59990000f,0.79019997f,0.37289999f,-0.21790001f,-0.00070003f,0.13409997f,0.64570003f,-0.51580002f,0.63289997f,0.88230002f,-1.99209997f,-2.02050002f,-0.61320001f,-0.51010000f,-1.94860000f,-1.04799999f,-0.06489998f,0.26129999f,0.23759997f,-0.80470003f,0.07800002f,0.29240002f,0.11219996f,0.40419999f,1.52999999f,0.26880002f,0.16019999f,0.89789997f,-0.04780000f,0.61199996f,0.94230000f,-0.40109997f,-1.24109996f,-1.53470001f,-0.20830006f,-1.75940003f,-0.39360003f,-1.25139995f,-1.33039999f,0.35570001f,1.14919999f,0.69329998f,-0.02530001f,-0.23609998f,-0.58039999f,1.87069998f,1.40070001f,0.34199998f,0.17069998f,-0.24340001f,-1.03129997f,-0.39080003f,-0.31430003f,-0.53590002f,-0.35360001f,-0.11370006f,-0.26630002f,0.10720001f,-0.70109999f,-0.62250001f,0.08229999f,-0.98479999f,-2.28749997f,-1.39399998f,-1.10269997f,-2.01180002f,-0.76890002f,-0.83259998f,-0.43910001f,0.16409998f,0.42230001f,-0.08390000f,0.57069997f,-0.51249998f,-0.29409999f,-0.07430001f,-1.04110001f,-0.63320001f,-0.37909999f,0.17779999f,-1.13849998f,0.08550000f,2.44039995f,1.77199997f,0.66830004f,-0.25380001f,-0.59249999f,-0.82439999f,-1.45810001f,-0.28270000f,-0.22390002f,-0.64780001f,-0.28769998f,-0.64670000f,-0.11240000f,-0.53870002f,0.20150002f,-0.72500000f,-0.11309999f,0.03120003f,1.17840000f,-0.57639998f,-1.55770003f,0.80229996f,1.64949997f,1.37449997f,1.47060001f,0.97259999f,1.83429995f,0.51290002f,-1.86470003f,-0.63110001f,0.19059998f,0.83010002f,-0.02949999f,0.00440000f,0.15360001f,1.07010003f,2.55770000f,1.10330002f,0.67250003f,0.95300002f,0.78430005f,-0.04570001f,-0.81529996f,-1.30890000f,-0.82509996f,0.65009999f,0.45499997f,-0.58700005f,0.65880000f,0.07520001f,0.42509999f,1.20879997f,-0.05339999f,1.14769994f,1.01469994f,1.44099999f,1.06470003f,-0.51449997f,0.40370000f,1.05420000f,1.40849996f,-0.20209992f,-1.74429998f,-0.47000001f,1.05349995f,1.05239999f,0.63339999f,0.88640001f,-0.58250001f,-0.88850003f,-1.63779994f,-0.89699998f,-0.47269995f,-1.18499999f,-0.18720000f,0.29060000f,2.36569997f,1.50529998f,-0.71899997f,0.56810000f,1.74610002f,-0.96859997f,-0.34700000f,0.64489999f,-1.29449997f,-1.59560000f,-1.75320002f,-0.60730008f,1.55479997f,1.54569998f,1.27269998f,1.26699997f,0.46720000f,-0.01369999f,1.23990005f,1.01760002f,0.63539999f,-0.79649996f,-2.32040000f,-1.00750001f,0.79800000f,0.79790000f,-0.25249998f,0.16820004f,1.07260003f,1.26050000f,0.88149994f,-0.23539999f,-0.68600000f,-1.55940002f,-1.15610001f,1.29109997f,1.59199997f,0.18630001f,0.37239995f,-0.49900004f,0.03009999f,0.20890000f,0.56539999f,0.59609999f,0.80869997f,1.80709997f,1.99949999f,-0.22409992f,-1.84699996f,0.45659995f,0.74210002f,-1.43909996f,-0.65310001f,-0.24980001f,0.69299998f,1.28409999f,-0.61189998f,-1.01260001f,-0.78980009f,-0.17200000f,-0.58520001f,-0.83450003f,-0.36569999f,-0.87549995f,-0.27220003f,1.40679997f,0.00650001f,0.18660001f,-0.58579999f,0.17040001f,0.23790001f,0.33430002f,0.33910001f,0.58169997f,0.66379997f,-0.96679998f,-0.55499996f,-1.22679995f,-0.99699997f,0.11280000f,0.32779998f,1.12689998f,1.97059997f,-0.20849996f,-0.71300002f,1.46389994f,0.57309997f,-0.11539999f,0.19020001f,-0.58130000f,0.13969994f,0.95009998f,1.35239996f,1.39560001f,0.42540000f,0.63410001f,0.59619999f,0.76240000f,-0.24540002f,0.67659998f,2.64750003f,0.68000002f,-1.08479998f,-0.51019999f,-0.16169998f,0.39059998f,1.25410000f,-0.12730001f,-0.93560002f,-1.48159997f,-1.10190002f,-0.80810001f,-0.10180000f,0.41570001f,1.19530000f,0.13200001f,-0.46539999f,-1.26869998f,0.41379994f,1.35700001f,-0.42789999f,0.17309998f,-0.99430001f,-1.72000002f,-0.98550002f,-1.09709999f,-0.26710000f,-0.79210000f,-0.71310000f,0.91659999f,0.78840002f,-0.40679999f,0.40029997f,0.63379999f,-0.44860001f,-0.41770002f,0.31930002f,0.66999999f,0.02650000f,-0.74679996f,-0.55910000f,-1.63839998f,-0.87089999f,-0.09289996f,0.03059999f,-0.93499996f,-2.53189994f,-1.05230001f,-0.13209992f,-1.43210005f,0.89119995f,0.59559999f,-0.09590000f,0.12350002f,0.60809998f,0.83559996f,0.17969997f,-0.53610002f,-1.85999999f,-1.92110000f,-0.20910000f,-0.48610000f,1.30619998f,1.51039998f,-1.27409998f,-1.09760001f,-0.25090004f,0.16670002f,-0.31729997f,-0.47960002f,0.15589998f,0.34049998f,-0.31220000f,-0.02370002f,0.55620000f,-1.48059999f,-1.84159993f,0.51210004f,1.33820003f,-0.09580000f,0.84409998f,-0.96479996f,-1.72989997f,-0.77689999f,-0.23800001f,-0.67620002f,1.32589996f,0.87250002f,0.18859999f,-0.33879997f,-0.92089995f,0.05589998f,1.17960001f,2.01480003f,0.73430003f,-2.19229996f,-1.28789998f,0.45170000f,1.13640001f,1.07380002f,-0.59479995f,-0.41429996f,0.57510000f,1.20739996f,-0.01650000f,-0.49019999f,-0.70450001f,-1.48100004f,0.60029994f,1.95189996f,-1.09549999f,-0.44999995f,-0.50089996f,-0.08010001f,0.66790003f,0.47609999f,1.21849997f,0.96509995f,-0.00089997f,-0.16719998f,-0.62419999f,-0.37770002f,1.46440000f,1.12420003f,0.08600000f,-0.88960001f,-0.74870002f,-1.22160001f,-2.41860000f,-0.51689998f,0.85400002f,-0.27629999f,0.20130004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.02130001f,0.64600004f,0.58629996f,0.23190000f,0.52059997f,-0.47400003f,-0.36720000f,-0.56860005f,-0.13640000f,-0.29530000f,0.95509999f,0.15630001f,-1.90429999f,-1.41739993f,0.01819996f,-0.11399999f,0.01460002f,1.03059997f,-1.16470007f,-0.05619999f,-0.87929993f,0.65890000f,0.39029997f,0.52419999f,-0.48549999f,-1.07889990f,0.69920001f,-0.12490001f,-1.24730002f,0.37660000f,0.56019997f,-0.83070007f,1.12689995f,-0.63160003f,-0.14540001f,-0.02439999f,0.43549998f,0.50319994f,-1.16200008f,-1.16580000f,1.03520003f,-0.93330001f,-1.06590004f,-0.50069994f,-0.24919999f,-0.69440001f,-0.00409999f,-0.56169995f,0.32370000f,-0.17670001f,0.26640004f,0.14450002f,0.41960001f,-0.75639998f,-0.56410003f,-0.49050000f,-1.05190002f,-0.71780007f,0.00830007f,-0.68830004f,0.16500001f,-0.00790003f,-0.84699998f,-0.07220000f,0.47459995f,-0.13329996f,-0.17120003f,0.50080001f,0.31099999f,1.17890002f,1.15700000f,1.10399995f,0.35310001f,-0.54779996f,-1.91170001f,-1.38720008f,-0.64320003f,0.93490003f,2.02070003f,0.47279994f,0.04140001f,-0.02860000f,0.61789998f,-1.46910000f,-1.33260005f,0.67679998f,0.03200000f,1.46540001f,0.41349999f,-0.08539999f,-0.45950001f,-0.96570000f,0.19549998f,-0.18620001f,0.81690005f,-0.94310006f,-0.19490005f,-0.75430005f,-1.12379997f,-1.32390002f,-1.34510001f,-0.95750000f,0.98540000f,0.16990000f,0.01599995f,-0.58359997f,0.38819999f,0.53080001f,-0.06470001f,-0.12719995f,0.25690000f,1.34010001f,0.26549996f,-0.85360000f,-0.84490001f,0.83780000f,0.01279999f,0.46830001f,0.03239998f,-1.81500004f,-2.60900001f,-0.75199999f,-1.40159999f,0.85020001f,-0.22139997f,0.25900000f,-0.65880000f,-0.21669999f,-0.52990005f,-1.21340002f,0.55379999f,-0.61100003f,-0.95850000f,-0.41269997f,0.61939997f,-0.06869999f,-0.49919998f,-1.46240000f,-0.77320000f,-0.33459998f,-0.48999999f,-0.91919997f,-0.02289999f,0.66699997f,0.04430001f,2.18270000f,-1.22500007f,0.22970005f,1.34540002f,1.06650004f,-0.13929999f,-0.12159999f,-0.18999999f,0.28200001f,0.45890001f,0.22540003f,0.64220003f,-0.91660001f,0.77890007f,1.23140000f,-0.74530003f,-0.52840000f,0.58640000f,0.63379994f,-0.38439999f,0.47580000f,0.66970001f,1.77029998f,1.61879994f,-0.98160006f,0.08080001f,1.15010003f,-1.19400001f,0.63220005f,-0.67449998f,-0.68470005f,0.52259999f,-0.21450002f,1.74430000f,0.78419999f,0.30880003f,1.32620004f,-1.07670004f,-1.60239999f,-1.45550003f,1.64960003f,2.18760004f,1.11470003f,0.58479998f,0.75350000f,-1.35790002f,-0.14899994f,-0.48709998f,0.00050003f,-0.86780001f,0.29770004f,1.08469997f,0.40899997f,0.01210000f,-0.59090008f,-0.93799997f,0.66339999f,0.06359997f,0.73330001f,0.68220002f,0.90820002f,1.04899998f,0.53270000f,-1.37060000f,0.02170002f,-1.10360004f,0.28330004f,0.60820000f,0.40090000f,-0.82700003f,-0.95999999f,0.66490001f,1.13250002f,1.52170005f,1.51339999f,-0.02920000f,0.22669995f,0.77250000f,-0.16020002f,-1.16819997f,0.47660002f,0.62190004f,0.01879999f,-0.96310004f,-0.96599997f,-0.77630003f,-0.74690000f,-0.69940004f,0.12259998f,-0.05710000f,-0.41840001f,-0.26530006f,-1.29249997f,-0.31559997f,1.61040002f,0.54530003f,-0.25770009f,0.21579999f,1.32050004f,0.51429999f,0.25059999f,-0.68470003f,-0.41129996f,0.22640001f,-0.66730002f,0.57859999f,0.53859996f,0.17259998f,0.91779998f,0.46649999f,-1.08750002f,1.79830005f,0.39900003f,-0.30880004f,-1.60069995f,-0.25959999f,-0.42890002f,0.08490004f,1.49160000f,0.20239996f,0.51340001f,0.12269999f,-0.53280006f,-1.00409994f,-0.41340002f,0.64940001f,-0.24610000f,-0.35609996f,-0.21950000f,0.30210001f,-0.79370000f,0.18060005f,-0.98080001f,-0.99099994f,-0.82130002f,-1.00970003f,0.32809999f,0.37779995f,-0.22320001f,0.19680006f,-0.80720002f,-1.01229995f,-0.44739999f,0.32669999f,-0.50940001f,-0.75929996f,1.75620003f,-0.00430000f,1.08290004f,1.45979997f,0.99740002f,-0.34619996f,-1.20520000f,-1.36949998f,-0.80410000f,-1.30959999f,-1.39440002f,-0.17250000f,0.52989997f,0.25130003f,-0.47559998f,0.58100001f,-0.57629999f,0.18829997f,0.07390000f,-0.98760002f,0.99769997f,1.61289998f,1.50499995f,-0.07299999f,-0.27070000f,0.67490000f,1.41679999f,0.44050001f,0.70450004f,0.69590002f,0.52199997f,-0.00649999f,0.00860000f,0.76220003f,-0.43550001f,0.67530001f,0.64689995f,-0.19509999f,0.11380008f,0.79950000f,0.90129997f,0.74600000f,-0.32450003f,0.01930004f,0.37090000f,-1.47290006f,-0.53110001f,-0.09989997f,-1.31080000f,1.05320004f,0.97519997f,1.10300006f,-0.18799998f,-0.09509997f,0.03970002f,-0.00470001f,-0.40389997f,0.39270004f,0.36480001f,-0.09020000f,0.30130001f,0.16830005f,1.40819998f,-1.38010006f,-0.47219998f,1.52750004f,0.64069998f,1.10170002f,-0.50680001f,0.67240000f,-0.04999998f,-0.64119998f,-0.63140002f,-0.18229999f,-0.01090005f,0.10400009f,1.32489998f,-0.13399999f,1.05810005f,-1.07339999f,-1.12550004f,0.64040003f,-1.35150002f,0.02640001f,-1.04530002f,1.26770000f,-0.57099999f,0.16880000f,0.49269996f,-0.05999999f,-1.04990004f,-0.34190000f,0.20550000f,-1.82830002f,0.51720005f,1.07360000f,-0.43200001f,-1.31060001f,-1.03929997f,-2.08930001f,-0.66949997f,1.98380005f,0.65290000f,0.93710002f,0.07479999f,0.61140000f,-0.08080007f,-1.62519999f,0.65760006f,0.59949998f,0.50650000f,0.27919997f,-0.15159995f,-0.62439996f,-0.38400003f,0.43320001f,-0.31240000f,1.81960001f,-0.70570001f,-1.21670000f,0.43000004f,-0.29400002f,0.55459998f,-0.42780001f,0.12990005f,1.20320000f,0.77719999f,0.41769997f,-0.66369998f,-0.02410002f,-0.49640001f,0.02900000f,-1.62600005f,0.29589999f,0.87499999f,0.60190004f,-0.14890000f,0.96660005f,-0.03840003f,-0.73220000f,0.45719998f,-0.61820002f,0.06690004f,-0.16159996f,1.02359999f,-0.22469999f,1.30429998f,-1.24920002f,0.08469999f,0.14059999f,0.08320002f,0.23199998f,0.29309998f,1.42140009f,1.96220005f,0.92320005f,0.91729995f,0.65640004f,-0.31499997f,-0.11430001f,-0.81109999f,1.19640000f,0.25330003f,1.10789997f,-0.44790007f,-1.15460006f,0.90840001f,1.00619998f,0.43650000f,-0.70889999f,0.08549998f,1.52389996f,-0.73240005f,0.02230000f,0.89919998f,-0.34910001f,0.22199999f,-0.18140001f,-0.51000002f,-1.23299999f,0.10240000f,0.44750002f,-0.28729995f,0.23589998f,0.29270000f,0.64939997f,0.10890001f,-0.01570001f,-1.06529999f,-0.29009996f,-1.28979998f,-0.19979999f,-0.61570000f,0.69569994f,-0.62019998f,-1.27510003f,0.21870006f,1.83879998f,0.86140006f,-0.21009999f,-0.06409998f,0.56649999f,0.88060002f,0.17419999f,1.20410004f,0.35380002f,0.44130000f,1.56429996f,1.60629999f,-1.41150000f,-1.04219999f,-0.00129998f,0.03500000f,0.07850001f,1.08690001f,0.72639997f,0.27480000f,0.73989999f,0.70379994f,-0.16720000f,-0.00460010f,0.17919999f,-1.10190004f,0.00319997f,-1.14160001f,-1.28370000f,-0.14309999f,-0.65499999f,0.04840000f,-0.30649998f,0.49179998f,0.77220005f,-0.13900001f,-0.15900006f,0.73970002f,0.86459998f,1.48500007f,-0.37199998f,-0.24570003f,-0.75779996f,-0.40540001f,0.82209999f,-0.06739999f,-0.26139997f,0.70130005f,0.76789994f,1.55260002f,-0.24040002f,-0.56219999f,-0.87660001f,0.31150007f,0.64349997f,-0.01339997f,0.57729998f,-0.30670000f,-0.80229997f,1.39820000f,-0.02580000f,0.42320002f,-1.12840000f,-2.17050002f,-1.42609998f,-0.75950003f,0.81100003f,-0.81039997f,-0.44280001f,-0.84239998f,0.64630000f,0.67610000f,-0.24959999f,-0.19709995f,-0.37800002f,-0.93579999f,-0.54539999f,0.48000009f,-0.15619999f,0.80630004f,1.28649997f,-0.28820001f,0.90660003f,0.39479997f,0.31390005f,-1.08230004f,-0.81960008f,-1.14920000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.15770002f,1.01669998f,0.74390001f,0.00850000f,0.16129996f,-0.08059998f,-0.23619999f,-0.72599999f,-0.60140001f,-0.12209999f,-0.64970003f,-0.32750000f,-0.91869998f,-0.60230000f,-0.11509997f,-1.07930004f,0.43919999f,0.76949999f,-0.13939999f,-1.60200002f,-0.62089996f,0.45590001f,0.90609998f,0.05339999f,-0.65899997f,-0.53149994f,-0.36599998f,-0.27020002f,-0.15300000f,0.24700000f,0.97189996f,0.57149999f,-0.24910002f,0.76420002f,-0.62989997f,-0.66940000f,0.81039997f,1.00779999f,-0.46520000f,-0.89600001f,0.02830000f,0.63100005f,-1.65019999f,-1.23930003f,0.26980000f,0.08240000f,-0.89289997f,-0.52599998f,-0.12929999f,-0.38799998f,-0.76179999f,-0.24589997f,-0.66700000f,0.06940000f,-0.78909999f,-1.21370002f,-0.37170002f,-1.16950001f,-0.02200000f,0.60360003f,-0.01989999f,-0.26539999f,-0.74170000f,0.61179999f,-0.11940001f,-0.29609999f,-0.31020000f,-0.20370003f,0.47079999f,0.26929997f,1.67229997f,0.91279998f,-0.38530000f,-0.30210001f,-0.24479999f,-1.08000001f,-1.21820001f,0.06850001f,1.77659998f,1.10840000f,-0.31109999f,0.41790001f,-0.30540003f,0.02520002f,-0.45059998f,-0.70630004f,0.64360000f,0.29849998f,0.41790000f,-0.19770000f,-0.41269999f,-0.04439998f,0.14150001f,-0.45439997f,0.03970000f,0.65350000f,-0.71120003f,-0.82040000f,-0.80090002f,-0.29559999f,-1.47679998f,-0.94439997f,-0.66130003f,0.71929997f,0.00159999f,-0.31970000f,0.42110002f,0.12660000f,-0.66479999f,0.04799999f,0.70330000f,0.57419999f,0.25449995f,-0.52810002f,0.25140000f,0.17759998f,0.55680000f,0.32180000f,0.14149998f,-1.22780000f,-1.78849998f,-1.81560002f,-0.29400001f,-0.67630001f,-0.10729999f,-0.14629999f,-0.16479999f,-0.23949998f,-0.34950000f,-0.91270000f,-0.73939998f,0.15800000f,-0.94659998f,-0.45159997f,0.09469999f,-0.10320001f,-0.57210001f,-0.75409999f,-1.34939999f,-0.82090000f,-0.49370000f,-0.55910001f,0.29860001f,0.24770000f,0.36160001f,0.10679996f,-0.03720001f,-0.21110004f,1.01459999f,0.26129999f,0.53960002f,0.19370000f,0.24140002f,0.00220001f,-0.20340000f,0.28280001f,0.44940002f,-0.42879997f,-0.18879996f,0.71180002f,-0.19190001f,-0.26660000f,0.58440000f,-0.16910001f,-0.49970003f,0.07069997f,1.24709998f,1.86499995f,1.07819999f,0.20800002f,-0.81480001f,0.01179997f,0.31840003f,-0.94149999f,0.56480000f,-0.01799997f,-0.70920002f,0.65410002f,0.78300000f,0.63149998f,0.58119998f,0.67619999f,0.16320001f,-0.87379997f,-0.57859998f,0.14349999f,1.44100001f,1.49980001f,0.79040001f,0.25589996f,0.17100001f,-0.94999998f,-0.03509997f,0.00679997f,0.36929998f,0.51660001f,1.24699998f,0.44709999f,0.20130002f,-0.77330001f,-0.60590002f,0.52840002f,0.05600001f,-0.20480003f,0.88810001f,1.19600001f,0.64350001f,-0.20930001f,0.37250003f,-0.24259998f,-0.27839997f,-0.63620000f,0.26270000f,-0.00220000f,-0.88090000f,-0.90959999f,0.62639998f,1.13019999f,1.38710003f,1.02079998f,1.19699999f,0.45600000f,-0.15790000f,-0.60880002f,-0.70710000f,-0.18600001f,-0.02920002f,0.67689999f,-0.18590001f,-0.54390000f,-0.56889999f,-0.86440000f,-0.13750001f,-0.41090001f,0.35519999f,0.54810002f,-1.13570000f,-1.08950001f,0.17020001f,0.65390000f,1.29340000f,0.06900001f,-0.73790003f,0.48249998f,1.22600001f,0.16210000f,-0.68390002f,-0.17940000f,0.83130001f,0.36120002f,0.11039997f,0.46349999f,0.72679998f,0.95420000f,-0.45599998f,-0.67939999f,-0.60560004f,1.08729999f,-0.37019999f,-1.09050000f,-0.53059999f,-0.75140002f,0.54629999f,1.58719999f,0.44940001f,0.11160000f,0.53640000f,-0.80919999f,-0.51220002f,0.37590001f,0.18919997f,-0.28169998f,-0.53350002f,0.63229999f,-0.10199999f,-0.93080000f,-0.62419999f,-0.31649999f,-0.87969998f,0.02710000f,-0.55839999f,0.51430000f,0.82939999f,-0.79259998f,0.01200001f,-0.42989998f,-1.59059999f,-0.39830001f,-0.15250000f,-0.35220001f,0.65530003f,0.67440000f,0.82830004f,0.59800001f,0.67750000f,0.11470000f,0.26510000f,-0.77989997f,-1.42449998f,-1.12380003f,-0.54740000f,-0.06019997f,-0.35940000f,-0.72780001f,-0.38910001f,0.37020001f,0.01199999f,0.51940000f,0.10639998f,0.48379997f,0.66350000f,0.14049998f,1.39959997f,0.92319999f,0.16930001f,-0.23880001f,0.74440000f,0.88919997f,0.07929997f,1.04380002f,0.81430005f,-0.60849999f,0.01319998f,0.33130001f,0.09419998f,0.08480002f,0.25609995f,0.61209997f,-0.75540000f,0.44930002f,1.29500001f,0.65470002f,0.12500000f,-0.68670000f,-0.45330002f,0.41339996f,0.09689999f,-1.20580001f,-0.20650002f,0.50960002f,-0.01079998f,0.62360001f,0.08740001f,0.26200003f,-1.12230000f,-0.09130001f,-0.09680001f,-0.37709999f,0.72390001f,0.60760002f,0.13230001f,-0.41240000f,0.29359999f,0.12699998f,-0.45089999f,-0.45190003f,1.14929999f,1.09630002f,-0.14460003f,0.51700000f,0.01459999f,-0.22220000f,0.01280003f,-0.04839999f,0.15979999f,-0.58049997f,-0.16960000f,1.05599999f,0.44580001f,-0.01290001f,0.63170001f,-0.64449997f,-0.81429998f,-0.04349998f,-0.99970004f,0.37169999f,-0.74850003f,0.28190001f,0.86630000f,0.36910002f,-0.38719999f,-0.01259998f,-0.24129998f,-0.83920000f,-0.92620000f,0.19940000f,0.93840002f,-0.65380001f,-1.49240001f,-1.04100003f,-0.74209999f,-0.57119998f,1.04170000f,0.94100002f,0.03129998f,0.59819999f,0.61309998f,0.12239999f,-1.04540000f,0.10020004f,0.85810002f,0.31159999f,-0.19589998f,-1.01489998f,0.14340000f,0.42730002f,-0.03800000f,0.15060002f,0.21339998f,0.53980002f,-0.78749998f,-0.35159999f,0.68930002f,-0.11250000f,-0.32619999f,0.42690000f,1.19390003f,0.80120001f,0.29589998f,0.17820002f,-0.55070001f,-0.26270000f,-0.13370000f,-0.01169995f,-0.29210001f,0.73949997f,0.66429999f,0.96290004f,0.46450000f,0.14760004f,-0.46750000f,-0.65820000f,-0.68200000f,-0.58260001f,1.05360002f,0.16949999f,0.63660003f,0.23529997f,0.47690002f,-0.40160002f,0.18130000f,0.40510000f,0.86640001f,0.06719999f,0.44280000f,1.10600002f,1.26960000f,0.34990000f,-0.22810002f,0.65990001f,-0.43580001f,0.16220002f,-0.18180000f,1.00769999f,1.13550000f,0.06450000f,-0.78080000f,0.05310001f,0.58649999f,-0.37930001f,0.71029999f,0.91319999f,0.48189997f,0.58869999f,-0.06230000f,0.53769999f,0.47320002f,-0.21379999f,-0.12120001f,-0.17660001f,0.02360005f,-0.53629999f,-0.54519999f,0.18040000f,0.10299999f,0.65419998f,0.57009998f,-0.08300000f,-0.51120000f,-0.88780001f,-0.62970000f,0.01850000f,-0.90759999f,0.35159999f,-0.04230002f,0.25289999f,-0.48609998f,-0.33079999f,0.41329998f,0.58229998f,0.49949999f,1.04010000f,0.68920004f,-0.07070001f,0.60490000f,-0.12630001f,0.72420000f,0.89399998f,1.25119998f,0.64929998f,-0.34199998f,-1.00530001f,0.18679998f,0.60850001f,0.40809999f,0.71539999f,0.42469999f,0.19889997f,0.90890000f,0.35990000f,0.10309997f,-0.28229999f,-0.65840004f,0.01460001f,-0.94520000f,-0.61950001f,-0.76369999f,-0.75519999f,0.20970002f,-0.52210000f,0.10610000f,0.32889999f,0.10720000f,0.75710002f,-0.22620000f,0.01200000f,0.23760001f,-0.22330001f,0.56150003f,-1.28660002f,-0.66950001f,0.09600003f,-0.10960004f,0.67959999f,-0.46709997f,0.35219999f,1.10629999f,-0.23080003f,0.25379999f,-0.26210000f,-0.54719999f,-0.20519998f,0.05590001f,0.23289999f,0.51510002f,-0.44970001f,0.37090002f,0.28650001f,0.42169999f,-0.15450001f,-0.76450000f,-1.34629998f,-0.53839997f,-0.55889997f,-1.00700000f,0.18040000f,-0.96170000f,-0.48280000f,0.28219998f,0.39839998f,-0.18440001f,0.03490002f,-0.46050000f,-1.28820000f,-0.99339999f,-0.00940001f,0.85650002f,0.41369999f,0.10979998f,0.44419998f,0.93050000f,0.16620003f,-0.48910002f,0.93840001f,-1.04390002f,-1.06620002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.73770000f,0.02000000f,1.41420003f,-0.07050002f,-0.27640001f,0.01419995f,0.77920001f,0.16139999f,-0.02920000f,0.82650004f,1.69390002f,0.33630001f,-1.38839998f,-1.71259999f,0.28190002f,0.25140002f,-0.10290004f,1.06480001f,-0.50100002f,0.75890006f,0.21620003f,0.40219998f,-0.37740000f,0.00929999f,-0.09109998f,0.34250006f,1.37930004f,-0.64660002f,-1.94610006f,0.00059997f,-0.06500003f,-1.22240005f,1.03269996f,-0.48680003f,0.46780006f,0.41200001f,-0.30140004f,-0.01420003f,-0.82500001f,-1.04079999f,0.17000001f,-1.02710002f,-0.57669999f,-0.23899999f,-0.03880001f,-0.87220000f,0.20980005f,0.14560002f,1.04609999f,0.99210001f,1.21920005f,1.24830002f,0.70139999f,-0.83640002f,0.24590002f,0.53709999f,-0.00210003f,-0.49390004f,-0.69850001f,-0.71620001f,-0.02250001f,0.16460003f,-0.76880001f,-0.04720001f,0.14470000f,0.06730004f,0.77650001f,0.73740000f,0.43860000f,0.63400001f,0.61679997f,1.03430000f,0.17350001f,-0.82560000f,-1.50050000f,-0.69830002f,0.00370000f,0.85889998f,1.79610002f,0.41690000f,-0.19619997f,0.10990000f,0.20560001f,-1.68270004f,-0.78039998f,0.13070000f,0.08819999f,1.85100003f,0.89060002f,0.10480000f,0.04270001f,-0.71300001f,-0.03839998f,0.18730002f,0.51930000f,-0.69579999f,-0.71370004f,-0.71970001f,-0.81530002f,-0.94119998f,-0.83589997f,0.23780003f,1.62800004f,-0.13420003f,-0.03860000f,-0.64100001f,0.51300000f,0.67960003f,0.34540001f,0.07899999f,-0.18340000f,0.51330001f,0.28240000f,-0.94860004f,-1.25910005f,-0.01790002f,-0.27610002f,0.65480000f,-0.08989999f,-1.96210001f,-2.23490003f,-0.17049997f,-0.58150002f,1.35120004f,0.69470002f,0.72200001f,-0.59279999f,-0.21869999f,0.33700002f,-0.01789999f,1.03369999f,-0.55580002f,-1.01389998f,0.09199999f,1.00239999f,-0.68019999f,-0.86069997f,-0.57960001f,0.34230002f,0.11059999f,0.02010003f,-0.83259999f,-0.15740000f,0.70320000f,0.32300000f,1.85580000f,-0.87570004f,-0.01940000f,1.54840006f,0.69840001f,-0.39220001f,-0.76080004f,-0.71360001f,0.71680002f,0.91250003f,0.29250002f,1.13450006f,-0.05909995f,0.75460001f,1.37210002f,-0.96550005f,-0.85560002f,0.65239999f,1.49390001f,-0.10260001f,-0.51900002f,-0.24000005f,1.06869997f,1.58489997f,-0.28900001f,0.12640004f,0.64040001f,-0.58860001f,0.60720004f,-0.39999998f,0.05749997f,0.00060000f,-0.32600004f,1.89550003f,0.82830003f,-0.63760000f,0.10780002f,-1.60330007f,-1.38890002f,-0.78960003f,1.39940001f,1.78240004f,0.35319998f,0.19740000f,0.03509999f,-1.46390000f,-0.83699999f,-0.92100001f,-0.83070001f,-1.77430003f,-0.23890002f,0.43639999f,-0.03520000f,0.60690002f,-0.04979999f,-0.72059999f,0.85250001f,0.49750003f,0.35759999f,0.34070000f,0.67669999f,0.90860002f,0.41170001f,-1.03810002f,-0.41069998f,-0.98779999f,0.74270005f,1.10860003f,0.99660001f,-0.09630001f,-0.79650004f,-0.01960002f,0.25410001f,1.08050000f,0.62220001f,-0.76630002f,0.25030000f,0.81330000f,0.43460002f,-0.87480002f,0.62020003f,0.63490002f,-0.58490005f,-1.41410001f,-1.34030001f,-0.56900000f,-0.10340003f,-0.22680003f,0.06060000f,-0.81940003f,-0.53330001f,0.15879999f,-1.53690001f,-0.74320001f,0.89309998f,0.67520001f,0.76450000f,0.56480002f,0.99650003f,0.61870001f,0.29590002f,-1.10080002f,-1.43520005f,-0.84220003f,-0.53120001f,0.41279999f,0.22899999f,-0.62660006f,0.53229999f,1.42280004f,0.44810000f,1.83420004f,-0.60500004f,-0.01590000f,-0.53159999f,0.01290000f,-0.32940000f,-0.25500003f,1.07130002f,-0.13680001f,0.10650001f,0.22620000f,-0.55890003f,-2.11330003f,-1.03950004f,0.05159999f,0.10450004f,-0.39659999f,-0.56450001f,1.11460006f,-0.17949996f,0.02320003f,-0.49639998f,-0.87949998f,-0.95570001f,-1.13290001f,-0.29880004f,0.01540002f,-0.35649998f,0.32490003f,-0.22069997f,-0.26569994f,0.02910000f,0.53789999f,-0.65930002f,-1.47830002f,0.89570005f,0.25229999f,1.49180004f,1.41680000f,0.89730004f,-0.25479997f,-0.92949997f,-0.87829996f,-0.32579999f,-1.45770001f,-1.26719998f,0.24590005f,0.53569999f,0.07629998f,-0.38860002f,0.06300000f,-0.95190000f,-0.64710003f,-0.75240001f,-1.10710001f,0.88830001f,1.16309997f,1.12729999f,-0.10020000f,-0.61060000f,0.24819997f,1.56970004f,0.05310000f,0.17359998f,1.32590003f,1.38539998f,-0.18570003f,-0.31950000f,-0.05880000f,-0.17390000f,0.85949998f,0.62610000f,-0.24189999f,-0.01840001f,0.63709998f,1.05370000f,0.97270004f,0.19070001f,0.09170000f,-0.62630002f,-1.64330005f,-0.16819999f,-0.68460002f,-1.36970001f,1.18990003f,1.14190001f,0.82660003f,0.37020003f,0.87110003f,0.07829997f,0.16720003f,-0.06880002f,0.00120000f,-0.45939999f,-0.45560000f,0.55200002f,0.81990002f,1.85400000f,-0.89770005f,-1.02350002f,0.82350002f,0.51280000f,0.51210001f,-0.68070004f,0.66619999f,0.53960003f,-0.67300003f,-0.98969998f,-0.35280000f,0.49560002f,0.12160003f,0.59090000f,-0.57170000f,0.96010003f,-0.72870000f,-0.81520000f,0.10990001f,-1.10410000f,-0.03149999f,-0.51390001f,1.36000002f,-0.56630003f,-0.36470005f,0.18440000f,0.08240000f,-0.87070004f,-0.45399999f,0.39200005f,-1.24220002f,0.23620000f,0.89240004f,-0.19620000f,-0.67420001f,-1.31630004f,-2.17640003f,-0.66730002f,1.55420004f,0.85020004f,0.75820001f,-0.04820002f,0.23469999f,0.53620002f,-0.76679997f,0.29330002f,0.40060004f,0.16580000f,0.77300002f,0.12100002f,-0.59739999f,-0.48530004f,-0.12689996f,-0.07320001f,1.58139996f,-0.66930001f,-1.00670000f,0.55290004f,-0.14300002f,0.41180001f,-0.05939999f,-0.07550001f,0.42659999f,0.12310000f,-0.28130001f,-0.09669996f,0.29090001f,-0.59630001f,0.10230000f,-1.07930004f,-0.35270002f,-0.59200002f,-0.70980001f,-0.05200001f,0.68150005f,0.17490001f,0.62190003f,0.98010000f,0.03860002f,-0.19590001f,-0.62290000f,0.31089999f,-0.19360003f,0.54539996f,-1.29000002f,0.02500000f,-0.08280000f,-0.56270002f,-0.92690003f,0.30500004f,1.48530003f,1.82130006f,0.71710000f,1.16110000f,0.40430000f,-0.48460000f,-0.25880001f,-0.54740002f,1.70240003f,0.06690000f,0.56560002f,-0.09880000f,-0.91730004f,0.98069999f,1.26540001f,0.13030000f,-1.14320003f,-0.31560000f,0.64929998f,-0.95430001f,0.02619999f,0.49479999f,-0.63790000f,0.12430001f,-0.38860001f,-1.29990005f,-0.77979999f,0.35380002f,0.42350004f,0.07460003f,-0.05840001f,-0.29970002f,0.48540000f,0.12880001f,0.32220002f,-0.85579999f,-0.63650000f,-1.36489998f,-0.21379999f,-0.36640004f,-0.12430003f,-1.16380000f,-1.00110001f,0.56420003f,1.69020001f,0.04920001f,-0.98430003f,-1.06410005f,0.92170004f,0.72550000f,-0.17580000f,0.97650001f,0.37529998f,-0.03610002f,0.86949996f,1.36520002f,-1.29360001f,-1.16780002f,-0.90570003f,-0.48540001f,-0.52610001f,0.48580002f,1.29750001f,0.19169998f,0.48249998f,1.55990000f,0.19100001f,0.79739998f,0.76790000f,-1.01040005f,0.16779999f,-1.10080002f,-1.41760001f,0.18130000f,-0.12979999f,-0.25709996f,-0.62810002f,0.52430000f,0.17320000f,0.05629996f,0.89739999f,1.25600002f,1.82710005f,1.60010006f,0.65380008f,0.95110005f,-0.48349999f,-0.06980000f,-0.08510001f,-0.97900004f,0.46390006f,1.13369998f,0.67169999f,0.80420001f,0.07129994f,-0.19760004f,-0.53199999f,0.59400004f,1.37350003f,-0.16030003f,0.31640000f,-0.25289999f,-1.17940002f,0.83000003f,-0.06160001f,0.28490002f,-0.57959999f,-1.86100007f,-1.58210001f,-0.41349998f,0.88250001f,-0.69690001f,-0.07280000f,-0.54790003f,0.33839999f,0.87680001f,-0.27569998f,-0.19679996f,-0.12119998f,-0.66480002f,-0.04160004f,0.00930000f,-0.43880001f,0.98190002f,1.50919998f,-0.47440007f,0.43659999f,0.47720000f,-0.25620001f,-1.43270009f,-0.60280000f,-1.06520003f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.15399998f,-0.73399996f,-1.18469998f,0.69449998f,-0.54630000f,-0.24919994f,-0.25980001f,-0.22600000f,-0.15420000f,-1.36859998f,0.39280002f,0.82979999f,1.55859999f,0.91720002f,-1.72150000f,0.93480001f,0.35630005f,-0.56830002f,-0.58719999f,-0.46230002f,0.49530005f,0.66889997f,-1.03830002f,-0.36730000f,0.21750000f,0.00740000f,0.15059998f,0.95000000f,0.85590003f,-0.71080000f,0.42919996f,-1.20269996f,-1.43869999f,0.06129997f,-1.97390003f,0.31499999f,0.25700001f,-1.46710000f,-0.59670003f,-0.34049998f,-0.09330001f,-0.42599998f,0.04489996f,1.04360004f,1.00720003f,0.29019999f,-0.82400002f,0.90380001f,-0.20809998f,-0.21870001f,0.10159999f,-0.04419996f,1.36019996f,0.88740002f,-0.35180001f,0.82140004f,0.41500004f,0.65400002f,0.36890002f,-0.40180001f,-0.94509999f,-0.59040004f,0.58550003f,-0.52539998f,-0.37660001f,-0.54179999f,0.26720003f,0.39879999f,-0.07289999f,0.42689998f,-0.38649997f,-0.74640002f,0.50079998f,1.48820000f,0.32150002f,-0.60399994f,-0.71939997f,0.12560000f,-1.09640004f,-0.35110001f,-0.82970000f,-0.52679999f,0.29749999f,0.39420005f,-0.97230001f,0.05870001f,-0.90999998f,-0.39620002f,0.03830001f,0.32149999f,-0.26259999f,0.30980000f,-1.39370002f,-1.12070000f,0.51249999f,-0.64190001f,0.16330005f,-0.43480003f,1.36710003f,-0.05120000f,-0.27769997f,-0.93019999f,0.33549998f,0.64260000f,-0.45820001f,0.49060000f,-0.84010001f,-0.27060004f,0.00299999f,0.91570002f,0.10629998f,-0.80690000f,0.30600000f,1.41780005f,0.44010003f,-0.44360002f,-0.09959999f,-0.59659999f,0.50129998f,0.57960004f,0.86860005f,0.54230000f,0.97770007f,-0.51390002f,0.23960003f,0.48070000f,0.15760000f,-0.39599999f,-0.93420001f,-0.30019996f,-0.71110001f,0.51549997f,-0.28289999f,-0.52239996f,0.06669999f,0.92459997f,0.38370002f,0.62420006f,0.53730001f,0.99910001f,0.44679998f,1.23410002f,-0.64879996f,-0.56910001f,-0.68259998f,-0.09030001f,1.22560000f,0.70340001f,-0.95600003f,1.23280001f,0.15720000f,1.12370000f,-0.60820002f,-0.63819999f,0.35919998f,0.28810001f,-0.94930003f,0.07469999f,-0.71309998f,-0.54940006f,1.19700002f,-0.22879999f,-0.66959998f,-0.97820002f,1.40010000f,0.95560000f,-0.06609997f,-0.61790002f,-1.61439998f,0.08119996f,-0.76120002f,0.48619998f,0.12230004f,0.75369994f,0.01820001f,-0.90289996f,-0.01600005f,-0.98799996f,-0.97280007f,-0.35290004f,0.75079998f,-0.50979998f,1.50620004f,-0.11849997f,0.00550003f,-1.29900002f,-0.43830002f,0.32569998f,-0.83500002f,0.63479998f,0.13940003f,0.84770000f,0.58409999f,1.62429998f,0.79120002f,-0.73989996f,-0.24720004f,-1.03809998f,-0.97320001f,0.44399996f,-0.33720000f,-0.86210001f,-1.12030004f,0.28070000f,-0.39380000f,-0.47010001f,-1.06790004f,0.24619999f,0.34000001f,-0.46790004f,-1.11860000f,-0.81720000f,-0.26209999f,-0.48099999f,0.61590002f,0.75440003f,0.29879999f,-0.57570001f,-0.96140000f,0.58799993f,-0.51339994f,-0.99620000f,-0.77810000f,0.55309998f,1.48030004f,-0.12180000f,0.96060003f,1.33730003f,0.28079999f,0.42340003f,-0.11670000f,0.03110005f,0.32179998f,-0.66590000f,0.74940000f,-1.61829998f,-0.02600000f,1.61060001f,0.30460003f,0.04459999f,-0.59650002f,-0.90099999f,-0.24190000f,-0.18160002f,-0.37939999f,-0.51710002f,0.67700002f,0.84180003f,0.43289999f,-1.13040001f,-0.09950000f,-0.91510000f,0.45460001f,-2.00240002f,-0.77720001f,0.18510001f,0.61319998f,1.71389999f,-0.38080002f,1.66740002f,0.41240000f,0.55640000f,0.45890003f,-1.20470001f,-0.68990000f,-0.53489999f,-0.46629999f,0.64019999f,1.73460001f,-0.40369997f,0.54399999f,-0.21740001f,2.11559998f,-0.04539999f,-1.40980002f,1.29429999f,0.07220001f,1.08159999f,0.71530000f,0.29839999f,-0.53039998f,-0.54970001f,-1.41510005f,-0.30910002f,0.01109999f,0.57769997f,0.21460000f,1.19970003f,-0.21559998f,1.46479997f,0.05380001f,-1.25560005f,-0.85699999f,-1.02880002f,-0.88090001f,-0.01100004f,0.88450001f,0.47239997f,0.36010000f,1.00630002f,1.39740002f,-0.80039999f,-1.47299997f,-0.20669999f,0.95540003f,1.14120001f,0.59339997f,0.38080000f,0.35609998f,-0.11520000f,-0.49169998f,-1.89579997f,-0.86859997f,-1.16010001f,0.19509999f,0.70259999f,-0.61129999f,-0.74180005f,0.94060000f,-0.26239997f,-1.39990002f,-0.23990001f,1.27059999f,-0.38230000f,0.90539998f,-0.34439999f,0.78470000f,-0.37510000f,0.82029999f,0.53620003f,-0.51610002f,-1.83360002f,-0.39280004f,-0.07740001f,1.27120001f,1.48859997f,-0.07429994f,0.24689999f,1.57340000f,-0.39119997f,-1.47480000f,-0.35720001f,0.11599998f,0.16759999f,0.50740002f,1.75640000f,0.03680001f,0.93550004f,0.38829999f,-0.35010003f,-0.51309999f,-0.05080001f,0.06990003f,-0.12199998f,1.14680002f,0.69039998f,-1.04049999f,-0.30510002f,0.21430000f,0.77960004f,-0.11719999f,0.30140000f,1.26340003f,-0.49220005f,-0.94559994f,-0.79030001f,0.46530000f,0.20389999f,-0.31640002f,-0.03540002f,0.56860004f,-0.98489997f,-0.10990000f,0.25279998f,0.66000001f,-0.24529996f,-0.08329999f,1.01510003f,-0.01939998f,-1.43190004f,-0.14090000f,0.42610001f,-0.91740004f,-0.36360003f,1.29350003f,-0.02600000f,-0.91280006f,0.29200001f,1.07920004f,2.51620006f,0.89270005f,0.18530005f,-0.63160004f,-0.59810003f,0.38760000f,0.19920001f,-0.09800001f,-1.27330002f,0.48690002f,-0.83389999f,-1.05510005f,-0.63889997f,-0.84519999f,1.53209995f,1.00340000f,-0.14979999f,-0.46950007f,-0.94989994f,0.28289999f,0.41929999f,0.12180002f,-0.60740000f,0.07540002f,-1.12230002f,-0.15800000f,0.14000003f,-1.13760002f,-0.91530003f,0.17189998f,-1.19489999f,0.60080001f,-0.41319999f,-0.00990000f,-0.45599998f,-0.55270006f,-0.40210003f,0.28800000f,-0.84979998f,0.11439995f,-1.41050000f,-0.65749997f,-0.12579999f,-0.22339999f,1.57080001f,-0.22369999f,-0.08790000f,-0.62419996f,0.93649997f,-0.57630001f,0.07860000f,-0.47709999f,0.52700001f,-0.31210004f,-1.48850001f,0.32880002f,-0.10580006f,0.43280003f,-0.64460003f,1.45700000f,0.66929998f,0.57380000f,-0.12849997f,-0.88760002f,0.63559998f,-1.71400000f,-1.19660000f,-0.17599997f,-1.70820000f,-0.24130005f,0.65319998f,0.85800001f,-1.27159999f,-1.10570003f,-0.36009998f,-1.08259998f,-0.40700001f,-0.66410001f,-0.68800000f,0.41100001f,0.96600002f,-1.28959999f,0.17879997f,-0.51790003f,0.94100001f,0.47710000f,-0.26260000f,-0.66190000f,0.02300000f,0.24429999f,1.75540001f,1.12270000f,1.17009999f,-0.03359997f,0.50240002f,0.43629995f,-0.07670000f,0.24460001f,-1.07999999f,0.35509998f,1.18640000f,1.53330002f,0.35130000f,-2.20050002f,0.64039994f,-0.39210001f,0.20880001f,0.88700000f,0.52520001f,-1.28549999f,-0.25120006f,1.42600002f,0.71530000f,1.09580002f,-0.55790000f,0.46939999f,-1.05080001f,-0.68949998f,1.16879997f,-1.26269997f,-1.27350003f,0.15720000f,-2.11449997f,0.37279999f,0.05020003f,-0.88970002f,1.41469999f,0.25900001f,-0.15460000f,0.42929998f,0.12799995f,-0.21249998f,-0.27310001f,0.59240000f,-0.60819997f,-0.82270001f,-0.76070001f,-1.50460004f,0.82959996f,-0.68430002f,0.57800000f,0.93930001f,-0.46500000f,0.87779996f,-0.02249998f,-0.46990001f,0.57880006f,-0.57630003f,-0.12829998f,0.87790006f,1.24450000f,0.13200000f,-0.40320000f,-0.34110000f,0.95250002f,-0.98180003f,0.39480000f,0.48320002f,-1.28600004f,0.34789999f,0.24299999f,0.70170004f,1.73260006f,-0.10340003f,-1.12210000f,0.11689998f,1.36169998f,0.15990002f,1.26320002f,0.07539999f,-0.52170000f,1.33399997f,-0.46779999f,0.70179998f,0.56690005f,1.42830000f,1.93089998f,0.40989999f,-0.71459998f,0.18980004f,1.18530003f,-0.69449998f,-0.50660001f,1.43280002f,0.40620007f,-0.55750002f,0.69380008f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.52089996f,-1.09249996f,1.96829998f,-0.09589996f,-1.79940002f,0.65139996f,2.40499994f,1.39179998f,0.10240000f,2.04289997f,1.86800001f,0.19200001f,0.34270004f,-0.82289997f,0.23019999f,0.51960000f,-0.05139999f,0.51730001f,1.07160000f,1.15669998f,1.97889999f,0.23660004f,-1.38119999f,-1.04870001f,0.19619997f,2.60779998f,1.83120001f,-1.14079999f,-1.87210000f,-0.76590001f,-0.66459997f,-0.94770002f,-0.08710006f,0.60300000f,0.88289997f,0.95900000f,-0.95199997f,-0.84060002f,0.28770000f,-0.08689999f,-1.46349998f,-0.43290005f,0.20009996f,0.03690001f,0.54210002f,-0.36979997f,-0.13780000f,1.27170000f,1.54749994f,2.29069993f,1.93109999f,2.25989995f,0.67249997f,-0.37339999f,1.08829999f,1.75739999f,1.99299995f,0.15939999f,-1.43840001f,-0.12710002f,-0.21330000f,0.14119998f,-0.17759999f,0.34560000f,-0.58710000f,0.02810002f,1.89840002f,0.72420002f,0.44910001f,-0.71609997f,-0.44439997f,0.30169999f,-0.49729999f,-0.87249998f,0.28760002f,0.95220002f,0.87169996f,0.28569998f,0.47739998f,0.45530003f,-0.67209999f,0.46930000f,-0.76330001f,-0.86020001f,0.75140002f,-0.94719995f,-0.00260003f,1.32580001f,1.19930001f,0.42159999f,0.70149998f,0.64790002f,-0.34680000f,0.44889995f,-0.16420001f,0.36600001f,-1.05169996f,-0.79900003f,0.33250002f,0.44220001f,0.32190000f,1.95690001f,1.63180003f,-0.22679996f,-0.30990000f,-0.24899999f,0.42930000f,0.54060000f,0.44159999f,0.61860000f,-0.50870000f,-1.39649996f,-0.07949999f,-0.47509998f,-0.88980001f,-1.60540003f,-0.60930000f,0.56459999f,-0.02989999f,-1.27490001f,-0.40770001f,0.36640001f,1.48720002f,0.99629998f,1.81029999f,1.21770001f,-0.02559999f,-0.10869998f,1.46170000f,2.19639998f,1.05019996f,0.22669999f,-0.74500004f,0.77149995f,1.15599999f,-1.22239995f,-1.40769998f,1.14899999f,1.83039997f,0.75550000f,0.69530000f,0.01470004f,-0.22260000f,0.31279999f,0.71559998f,-0.14880002f,0.19920001f,-0.32899994f,0.79230001f,-0.25619997f,-0.65550002f,-1.08440001f,-1.33440003f,0.85799998f,1.07490000f,0.34550003f,1.20760002f,1.61700003f,0.23729999f,0.68359995f,-0.53370000f,-1.03050002f,0.47879999f,1.68689996f,0.67870003f,-1.95099996f,-1.56369999f,-0.45090000f,0.33599996f,1.48380000f,-0.05239999f,-0.84379998f,0.86239999f,0.00150003f,0.46600003f,1.59989996f,-0.96170002f,-0.31800000f,1.08960002f,0.45070001f,-1.47839995f,-2.39500001f,-1.39930003f,-0.40870006f,1.13309996f,0.02149999f,0.01890000f,-0.80250000f,-0.66870001f,-1.16049995f,-0.69320000f,-1.64620001f,-1.32470000f,-1.62629994f,-2.14639997f,-1.00120002f,-0.56669997f,-0.93699999f,1.23370002f,0.95930006f,0.07670000f,0.88120000f,0.90339999f,-0.47629998f,-0.46960001f,0.22239999f,0.04429999f,-0.27909999f,0.58420000f,-0.73340001f,-0.29790002f,0.89430002f,1.33380002f,1.32079996f,1.11689994f,-0.02510002f,-0.92019996f,-1.38090000f,-0.26680004f,-1.11309997f,-1.36869996f,0.21789999f,0.16769998f,0.85099996f,0.30470002f,0.23020000f,0.14870000f,-0.93549996f,-1.42409998f,-1.14559998f,-0.08890001f,0.90659997f,1.05649998f,-0.22470001f,-1.27919998f,-0.43750005f,0.50099996f,-1.05059998f,-0.96989998f,-0.98610001f,0.57969996f,2.18060001f,0.77720001f,-0.23749997f,0.68040003f,0.29470000f,-1.21020001f,-2.31670002f,-2.01260000f,-0.03780004f,0.16140002f,-0.55610001f,-1.13979997f,-0.61370004f,1.77199994f,2.92229999f,0.55270002f,-1.67299996f,-0.18710002f,1.74639999f,0.51319999f,-0.23080001f,-0.34239995f,-0.04130000f,-0.53550001f,-0.74879999f,0.35329998f,-0.38820001f,-2.57810000f,-1.62070003f,-0.97519997f,0.13730000f,-0.01909991f,-0.68779996f,1.50389998f,1.14150004f,-0.60869995f,0.63100002f,-0.15919999f,-0.32809998f,-0.69260000f,-0.83659997f,-0.52240000f,-0.66959998f,0.25960002f,0.90160000f,0.72290001f,1.02190004f,0.35989997f,-0.39599999f,-1.36109995f,-1.33020000f,0.59409998f,1.50769997f,0.50239999f,-0.10089996f,0.21190005f,0.00910001f,0.21680004f,0.51980001f,-0.60079997f,-0.10059995f,0.86009999f,-0.06730003f,-0.59360002f,0.19350000f,-0.91899997f,-0.83929998f,-1.58349996f,-1.74309997f,-0.21549998f,0.05790000f,0.05020001f,-0.35550002f,-0.04830000f,-0.79439998f,-0.58999996f,0.81880000f,-0.58449997f,-0.73710001f,1.55409991f,1.81379993f,-0.09029999f,-0.76330000f,-1.43559997f,-0.01270002f,0.94890003f,0.16850001f,-0.45649998f,-0.09610000f,0.36299996f,0.62299997f,0.79260001f,0.60350000f,0.19480002f,-1.82179995f,-1.00410000f,0.26260000f,-1.11829994f,-0.44120003f,0.59389997f,0.81010001f,-0.36700000f,0.99799999f,1.59589995f,0.34780003f,0.02310000f,0.58979999f,-0.29700001f,-1.50639999f,-0.92930000f,0.30259999f,1.53250000f,1.32009998f,0.59229998f,-1.16779997f,-0.95000001f,0.20039999f,-1.11510001f,-0.44980000f,0.06579999f,0.99659997f,0.14380002f,-0.98609999f,-0.29399999f,0.71219995f,0.23760003f,-0.84179996f,-1.05280001f,-0.08230000f,0.78840000f,0.30729997f,-1.13710001f,-0.02449999f,-0.32119996f,0.91600000f,0.32399998f,-0.06149999f,-0.56490000f,-0.63190006f,0.12059997f,0.30599999f,-0.32950002f,-0.01030000f,0.57280003f,-0.16229998f,0.01399999f,0.07699998f,0.44079998f,-0.89749997f,-1.14480003f,-0.20909999f,-0.09069998f,0.66690001f,-0.03949998f,-0.15870000f,-0.34669996f,1.02390002f,1.42130001f,-0.33439999f,-0.09510000f,-0.42999996f,0.74469995f,0.33910002f,-0.04939997f,-0.01950000f,-1.07419999f,0.25389997f,0.17269994f,-0.08920003f,0.00480000f,0.20840000f,0.67900001f,-0.25770002f,0.49339999f,0.04829998f,-0.96170005f,-1.04160000f,-1.30999995f,0.78570001f,0.87280003f,-0.52180002f,0.16420000f,0.86449998f,-0.99820000f,-2.75259999f,-2.65240000f,0.19569999f,0.10660001f,0.12119998f,2.64619996f,1.30089999f,0.84459998f,-0.41249997f,-0.76950001f,-1.20860003f,-0.02180005f,-0.94580001f,-0.59980003f,0.03680003f,-0.49720000f,-1.01810001f,-2.12399998f,-0.31830000f,0.79340001f,0.31970001f,0.23950001f,0.58269997f,-0.34739997f,-0.35890000f,-0.50460001f,0.38539999f,1.23269998f,0.35090005f,-0.60569997f,0.56549998f,0.24379999f,0.31269995f,1.04649997f,-0.72649998f,-0.75989995f,-0.46890001f,-1.31069998f,-0.58469999f,0.06079998f,-0.32930000f,-0.60680001f,-0.24640001f,-0.47380000f,-1.77750000f,0.35559996f,0.78620001f,-0.41860000f,0.85450004f,-0.42079997f,-1.00699996f,-0.13059999f,0.00780000f,0.39260001f,-0.00229997f,-1.06649997f,-0.45489996f,-0.52179999f,0.63859998f,-1.43209996f,-1.48779998f,0.14529997f,0.66809996f,0.34940003f,-1.46899996f,-1.64739999f,-1.73709996f,0.71549996f,0.23180000f,-0.71570000f,-0.37030004f,0.28119999f,-0.43829996f,-0.84670000f,-0.13230000f,-0.21269999f,-0.81820003f,-1.68549998f,-1.18620001f,-0.93849996f,-1.02289996f,1.28109999f,0.30650002f,-0.27280001f,1.97089996f,1.15120001f,1.34869997f,1.40210000f,0.06619997f,-0.09120005f,-0.19329997f,-0.89460000f,0.26659998f,1.23080003f,-0.68649997f,-0.82640000f,0.27949999f,-1.00560001f,0.36529994f,2.18569996f,1.51350000f,2.14739998f,0.76030006f,1.91550005f,2.28830006f,0.36430003f,0.64420000f,-1.47929996f,-2.05140001f,0.96039996f,1.55550001f,0.39409998f,-1.44620000f,0.33639994f,0.73829997f,0.29079998f,0.65700001f,1.60210000f,0.11829999f,-0.45060004f,-0.12320000f,-0.62189997f,-0.98369999f,-0.00030000f,-0.29609999f,0.44669997f,-0.01200003f,-0.72900002f,0.31870000f,0.01049998f,0.12719999f,0.17749997f,0.43889999f,-0.37739998f,0.47199999f,0.01980005f,-0.21719996f,0.38550002f,-0.23790004f,0.57969995f,-0.74940000f,-0.56470001f,0.62509997f,0.73729995f,-0.19240001f,-0.50910004f,0.13959994f,-1.19280001f,-0.74500003f,-0.19020004f,-0.31159998f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DO NOT EDIT THIS FILE. If you want to add new tests, you should edit
//  test/ref_generators/generate_convolution_ref.py and regenerate this file.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! DO NOT EDIT THIS FILE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!! THIS FILE IS AUTOGENERATED OUTSIDE OF THE BUILD PROCESS !!!!!!!!!!!!!!
TEST (${BACKEND_NAME}, convolution_3d_2item_large_5o3i_padded_strided_uneven_filter_uneven_data_dilation_filter_dilated_data_dilated)
{
    SKIP_TEST_FOR("GPU", "${BACKEND_NAME}");
    Shape shape_a{2,3,8,8,8};
    Shape shape_b{5,3,2,3,4};
    Shape shape_r{2,5,8,7,7};
    auto make_graph = [shape_a, shape_b] {
        auto A = make_shared<op::Parameter>(element::f32, shape_a);
        auto B = make_shared<op::Parameter>(element::f32, shape_b);
        return make_shared<Function>(make_shared<op::Convolution>(A, B,
                                                                  Strides{2,3,2},        // move_strides
                                                                  Strides{3,2,2},        // filter_dilation
                                                                  CoordinateDiff{2,1,2}, // below_pads
                                                                  CoordinateDiff{1,2,3}, // above_pads
                                                                  Strides{2,3,2}),       // data_dilation
                                     op::ParameterVector{A, B});
    };

    auto backend = runtime::Backend::create("${BACKEND_NAME}");
    auto function = make_graph();

    // Create some tensors for input/output
    auto a = backend->create_tensor(element::f32, shape_a);
    copy_data(a, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f,-0.87000000f,0.43000000f,-0.17000000f,0.95000000f,-0.96000000f,0.36000000f,-0.57000000f,0.57000000f,-0.47000000f,0.58000000f,0.35000000f,0.52000000f,0.23000000f,0.66000000f,-0.18000000f,0.54000000f,-0.78000000f,0.38000000f,0.34000000f,-0.73000000f,-0.74000000f,0.40000000f,-0.92000000f,-0.28000000f,0.21000000f,-0.20000000f,-0.47000000f,-0.12000000f,0.72000000f,-0.61000000f,-0.59000000f,0.53000000f,-0.10000000f,-0.06000000f,0.98000000f,0.87000000f,0.50000000f,0.34000000f,0.05000000f,0.30000000f,0.89000000f,-0.56000000f,0.45000000f,-0.02000000f,0.39000000f,-0.97000000f,0.34000000f,-0.43000000f,-0.82000000f,0.35000000f,0.32000000f,-0.31000000f,0.97000000f,-0.05000000f,0.47000000f,0.29000000f,-0.37000000f,-0.22000000f,-0.74000000f,-0.59000000f,-0.02000000f,-0.58000000f,0.59000000f,0.63000000f,0.06000000f,-0.34000000f,0.35000000f,-0.18000000f,-0.21000000f,0.07000000f,-0.09000000f,-0.53000000f,0.97000000f,0.34000000f,-0.90000000f,-0.17000000f,-0.85000000f,0.91000000f,-0.92000000f,0.80000000f,-0.97000000f,0.50000000f,0.84000000f,0.25000000f,-0.60000000f,0.39000000f,-0.57000000f,-0.32000000f,0.29000000f,0.68000000f,0.52000000f,-0.24000000f,0.40000000f,0.19000000f,0.85000000f,0.87000000f,-0.55000000f,-0.61000000f,-0.46000000f,-0.54000000f,0.69000000f,-0.58000000f,0.05000000f,0.79000000f,0.30000000f,-0.22000000f,0.02000000f,-0.77000000f,-0.15000000f,-0.47000000f,0.74000000f,-0.30000000f,0.02000000f,-0.71000000f,0.19000000f,0.34000000f,0.68000000f,0.85000000f,0.73000000f,-0.63000000f,0.27000000f,0.76000000f,0.73000000f,0.12000000f,0.36000000f,0.82000000f,0.18000000f,-0.49000000f,-0.27000000f,0.48000000f,0.96000000f,0.89000000f,-0.52000000f,0.16000000f,0.50000000f,0.01000000f,0.71000000f,0.53000000f,-0.24000000f,0.23000000f,-0.01000000f,-0.79000000f,-0.34000000f,-0.03000000f,0.04000000f,-0.44000000f,0.21000000f,-0.36000000f,-0.32000000f,0.40000000f,0.03000000f,-0.71000000f,-0.00000000f,-0.05000000f,0.74000000f,0.50000000f,0.16000000f,-0.22000000f,-0.72000000f,-0.99000000f,-0.29000000f,-0.60000000f,-0.74000000f,-0.49000000f,-0.33000000f,-0.40000000f,0.97000000f,-0.10000000f,-0.85000000f,-0.26000000f,-0.05000000f,-0.61000000f,-0.38000000f,0.52000000f,-0.87000000f,-0.23000000f,0.05000000f,0.03000000f,0.08000000f,0.66000000f,-0.07000000f,-0.70000000f,0.32000000f,-0.59000000f,0.99000000f,0.02000000f,0.79000000f,0.45000000f,-0.92000000f,-0.20000000f,-0.11000000f,0.35000000f,0.83000000f,0.65000000f,-0.44000000f,0.56000000f,0.67000000f,0.48000000f,-0.74000000f,0.94000000f,0.00000000f,-0.13000000f,-0.87000000f,0.99000000f,-0.18000000f,-0.40000000f,0.53000000f,0.00000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.20000000f,0.13000000f,0.24000000f,-0.19000000f,0.72000000f,0.61000000f,-0.96000000f,-0.43000000f,0.26000000f,-0.12000000f,-0.64000000f,-0.64000000f,0.72000000f,0.15000000f,-0.93000000f,0.36000000f,-0.88000000f,-0.56000000f,0.99000000f,0.74000000f,0.60000000f,0.82000000f,0.42000000f,0.45000000f,0.48000000f,-0.90000000f,0.29000000f,0.25000000f,-0.40000000f,-0.36000000f,-0.89000000f,-0.56000000f,0.84000000f,-0.71000000f,-0.43000000f,-0.72000000f,0.69000000f,0.73000000f,0.54000000f,-0.55000000f,0.62000000f,0.64000000f,-0.46000000f,-0.36000000f,-0.63000000f,-0.37000000f,0.63000000f,0.47000000f,-0.50000000f,0.05000000f,-0.07000000f,0.67000000f,-0.76000000f,-0.47000000f,0.24000000f,-0.01000000f,0.23000000f,0.10000000f,0.39000000f,-0.93000000f,0.14000000f,-0.85000000f,-0.13000000f,0.82000000f,0.24000000f,-0.62000000f,-0.47000000f,-0.10000000f,0.29000000f,-0.37000000f,0.94000000f,0.28000000f,0.88000000f,-0.23000000f,-0.14000000f,0.40000000f,0.35000000f,-0.34000000f,0.12000000f,0.93000000f,0.28000000f,-0.99000000f,-0.23000000f,-0.63000000f,0.24000000f,0.37000000f,-0.74000000f,-0.76000000f,-0.57000000f,0.29000000f,-0.31000000f,0.56000000f,-0.99000000f,0.06000000f,0.52000000f,0.41000000f,0.56000000f,0.80000000f,0.36000000f,0.05000000f,-0.01000000f,-0.58000000f,0.63000000f,-0.82000000f,-0.86000000f,0.86000000f,0.77000000f,-0.28000000f,-0.56000000f,-0.54000000f,-0.07000000f,0.12000000f,0.47000000f,0.71000000f,-0.01000000f,-0.92000000f,0.24000000f,-0.13000000f,-0.70000000f,0.22000000f,0.05000000f,-0.39000000f,-0.66000000f,-0.58000000f,-0.11000000f,0.90000000f,-0.29000000f,0.31000000f,-0.65000000f,0.48000000f,0.26000000f,-0.47000000f,0.75000000f,-0.13000000f,0.11000000f,-0.36000000f,0.11000000f,-0.62000000f,0.95000000f,-0.90000000f,-0.26000000f,0.22000000f,-0.46000000f,-0.20000000f,-0.41000000f,-0.59000000f,0.82000000f,-0.12000000f,0.48000000f,-0.02000000f,-0.95000000f,0.53000000f,-0.31000000f,-0.72000000f,-0.69000000f,0.82000000f,0.05000000f,-0.34000000f,-0.67000000f,0.39000000f,-0.92000000f,-0.88000000f,-0.15000000f,-0.67000000f,-0.00000000f,-0.69000000f,0.81000000f,0.49000000f,-0.10000000f,-0.44000000f,0.62000000f,-0.68000000f,0.23000000f,-0.74000000f,-0.00000000f,-0.25000000f,0.75000000f,-0.62000000f,0.54000000f,0.53000000f,0.34000000f,-0.67000000f,-0.64000000f,-0.56000000f,-0.80000000f,0.33000000f,-0.36000000f,-0.49000000f,0.02000000f,0.05000000f,-0.41000000f,-0.39000000f,-0.99000000f,0.30000000f,0.07000000f,0.91000000f,-0.92000000f,0.95000000f,0.03000000f,0.63000000f,0.34000000f,-0.93000000f,0.65000000f,-0.63000000f,-0.67000000f,-0.11000000f,0.97000000f,0.21000000f,-0.81000000f,0.85000000f,0.12000000f,0.86000000f,-0.44000000f,0.97000000f,-0.67000000f,-0.24000000f,-0.19000000f,0.56000000f,-0.95000000f,0.27000000f,-0.01000000f,0.35000000f,-0.34000000f,-0.19000000f,0.62000000f,-0.62000000f,0.65000000f,0.24000000f,0.48000000f,-0.64000000f,0.40000000f,-0.60000000f,0.69000000f,-0.83000000f,-0.50000000f,0.21000000f,0.75000000f,0.60000000f,0.36000000f,-0.36000000f,0.29000000f,-0.89000000f,-0.41000000f,-0.53000000f,-0.60000000f,0.06000000f,0.95000000f,0.08000000f,0.14000000f,0.77000000f,0.72000000f,-0.74000000f,-0.26000000f,-0.86000000f,-0.33000000f,-0.81000000f,0.89000000f,0.13000000f,-0.07000000f,0.06000000f,0.38000000f,-0.68000000f,0.92000000f,0.99000000f,0.31000000f,-0.58000000f,-0.82000000f,-0.07000000f,0.01000000f,0.19000000f,0.60000000f,0.12000000f,0.16000000f,0.65000000f,0.11000000f,0.35000000f,-0.97000000f,0.34000000f,0.52000000f,0.43000000f,0.59000000f,0.40000000f,0.71000000f,-0.00000000f,0.57000000f,0.26000000f,0.46000000f,0.52000000f,-0.59000000f,0.43000000f,0.96000000f,0.54000000f,-0.75000000f,-0.28000000f,0.00000000f,0.93000000f,-0.99000000f,-0.31000000f,-0.15000000f,-0.59000000f,0.53000000f,-0.03000000f,-0.94000000f,0.10000000f,0.82000000f,0.54000000f,0.57000000f,-0.28000000f,0.93000000f,0.91000000f,0.12000000f,-0.10000000f,0.39000000f,-0.26000000f,0.07000000f,-0.39000000f,-0.06000000f,0.90000000f,0.43000000f,0.51000000f,-0.77000000f,0.20000000f,0.84000000f,0.06000000f,-0.18000000f,-0.25000000f,0.95000000f,0.27000000f,0.46000000f,0.48000000f,0.66000000f,0.48000000f,-0.07000000f,0.21000000f,0.67000000f,0.88000000f,-0.44000000f,-0.58000000f,-0.77000000f,-0.28000000f,0.56000000f,-0.43000000f,-0.19000000f,-0.93000000f,0.20000000f,-0.64000000f,0.72000000f,-0.14000000f,0.81000000f,-0.04000000f,-0.75000000f,0.70000000f,0.74000000f,-0.38000000f,0.38000000f,-0.97000000f,-0.42000000f,-0.74000000f,0.85000000f,-0.72000000f,0.40000000f,0.70000000f,0.81000000f,-0.22000000f,-0.74000000f,-0.66000000f,-0.49000000f,-0.58000000f,0.02000000f,-0.13000000f,-0.39000000f,0.47000000f,-0.81000000f,-0.14000000f,0.32000000f,-0.57000000f,-0.99000000f,0.40000000f,-0.96000000f,-0.54000000f,0.71000000f,0.91000000f,0.55000000f,-0.18000000f,-0.16000000f,0.25000000f,-0.49000000f,-0.98000000f,-0.09000000f,-0.93000000f,0.72000000f,0.35000000f,-0.84000000f,-0.79000000f,-0.97000000f,0.17000000f,-0.28000000f,0.41000000f,0.51000000f,0.02000000f,0.30000000f,-0.18000000f,-0.93000000f,-0.77000000f,0.85000000f,-0.93000000f,0.95000000f,-0.82000000f,-0.37000000f,0.21000000f,0.62000000f,-0.94000000f,0.98000000f,0.47000000f,0.73000000f,-0.37000000f,-0.14000000f,-0.26000000f,0.28000000f,-0.09000000f,-0.96000000f,0.34000000f,0.60000000f,0.81000000f,-0.29000000f,0.17000000f,-0.07000000f,0.58000000f,0.00000000f,-0.15000000f,-0.97000000f,-0.15000000f,0.76000000f,-0.83000000f,0.66000000f,-0.21000000f,-0.01000000f,-0.51000000f,0.28000000f,0.96000000f,-0.08000000f,0.79000000f,-0.24000000f,0.45000000f,0.92000000f,0.37000000f,0.03000000f,-0.24000000f,-0.92000000f,-0.47000000f,-0.11000000f,0.03000000f,-0.15000000f,-0.45000000f,-0.84000000f,0.14000000f,0.06000000f,-0.32000000f,0.58000000f,0.80000000f,-0.36000000f,-0.70000000f,0.04000000f,-0.75000000f,0.05000000f,0.97000000f,-0.44000000f,-0.00000000f,-0.98000000f,-0.37000000f,0.77000000f,-0.55000000f,-0.84000000f,-0.08000000f,-0.97000000f,-0.40000000f,0.84000000f,0.35000000f,0.66000000f,-0.30000000f,0.86000000f,-0.44000000f,-0.79000000f,-0.28000000f,-0.40000000f,-0.53000000f,-0.58000000f,-0.31000000f,0.27000000f,0.25000000f,0.68000000f,-0.66000000f,0.01000000f,-0.13000000f,0.49000000f,-0.39000000f,-0.89000000f,-0.33000000f,0.38000000f,0.11000000f,-0.23000000f,0.27000000f,-0.50000000f,-0.20000000f,-0.90000000f,-0.25000000f,0.50000000f,0.13000000f,0.82000000f,0.40000000f,-0.43000000f,0.51000000f,0.75000000f,-0.96000000f,0.02000000f,-0.65000000f,0.95000000f,0.62000000f,-0.42000000f,0.71000000f,0.43000000f,0.42000000f,0.95000000f,-0.22000000f,-0.88000000f,0.90000000f,-0.73000000f,-0.35000000f,-0.28000000f,-0.36000000f,-0.49000000f,0.35000000f,0.04000000f,-0.86000000f,0.23000000f,-0.56000000f,0.11000000f,-0.70000000f,-0.68000000f,-0.59000000f,-0.97000000f,-0.61000000f,0.55000000f,-0.11000000f,-0.64000000f,0.14000000f,0.12000000f,-0.31000000f,-0.55000000f,-0.20000000f,0.39000000f,0.57000000f,-0.80000000f,0.66000000f,0.60000000f,-0.68000000f,0.31000000f,0.90000000f,0.12000000f,-0.88000000f,0.67000000f,0.86000000f,-0.00000000f,0.84000000f,-0.41000000f,0.78000000f,0.80000000f,-0.21000000f,-0.35000000f,-0.45000000f,-0.47000000f,0.56000000f,-0.01000000f,-0.23000000f,0.19000000f,-0.59000000f,0.64000000f,0.66000000f,-0.32000000f,-0.45000000f,-0.99000000f,0.08000000f,-0.05000000f,-0.03000000f,-0.71000000f,0.66000000f,0.93000000f,0.18000000f,-0.15000000f,-0.78000000f,0.91000000f,0.29000000f,-0.26000000f,-0.21000000f,-0.05000000f,0.11000000f,-0.92000000f,0.72000000f,0.43000000f,0.00000000f,-0.58000000f,-0.70000000f,0.58000000f,-0.73000000f,0.16000000f,0.67000000f,-0.44000000f,-0.24000000f,0.37000000f,0.64000000f,0.67000000f,0.00000000f,-0.34000000f,-0.48000000f,-0.68000000f,0.54000000f,0.80000000f,0.59000000f,0.50000000f,-0.89000000f,-0.26000000f,-0.11000000f,-0.72000000f,0.57000000f,0.46000000f,-0.85000000f,0.31000000f,0.89000000f,0.50000000f,0.73000000f,0.23000000f,0.29000000f,0.75000000f,-0.80000000f,0.36000000f,-0.56000000f,-0.62000000f,0.21000000f,-0.49000000f,-0.07000000f,0.17000000f,0.68000000f,-0.12000000f,0.17000000f,-0.31000000f,-0.09000000f,0.88000000f,0.33000000f,0.79000000f,0.99000000f,0.32000000f,0.56000000f,-0.43000000f,-0.56000000f,-0.70000000f,0.02000000f,0.23000000f,-0.95000000f,-0.87000000f,0.14000000f,0.33000000f,-0.26000000f,0.04000000f,0.25000000f,-0.87000000f,-0.64000000f,0.20000000f,0.27000000f,-0.44000000f,0.30000000f,-0.47000000f,0.24000000f,-0.40000000f,0.95000000f,-0.27000000f,0.74000000f,0.73000000f,0.01000000f,0.74000000f,-0.21000000f,0.24000000f,0.18000000f,-0.08000000f,-0.01000000f,0.63000000f,-0.32000000f,0.13000000f,0.11000000f,0.41000000f,0.24000000f,-0.82000000f,-0.89000000f,-0.85000000f,-0.51000000f,-0.62000000f,-0.77000000f,0.06000000f,-0.09000000f,-0.35000000f,-0.56000000f,0.82000000f,0.92000000f,-0.18000000f,0.06000000f,-0.28000000f,0.45000000f,0.69000000f,-0.58000000f,0.66000000f,-0.37000000f,-0.90000000f,-0.41000000f,-0.42000000f,-0.58000000f,-0.73000000f,0.92000000f,0.14000000f,-0.64000000f,0.53000000f,-0.42000000f,-0.38000000f,0.51000000f,-0.94000000f,-0.05000000f,-0.91000000f,-0.92000000f,-0.38000000f,-0.73000000f,0.56000000f,0.64000000f,-0.46000000f,-0.58000000f,0.91000000f,-0.15000000f,-0.28000000f,-0.71000000f,-0.36000000f,-0.89000000f,-0.21000000f,-0.87000000f,-0.97000000f,0.09000000f,-0.34000000f,-0.58000000f,-0.54000000f,0.77000000f,0.30000000f,0.70000000f,-0.38000000f,-0.70000000f,0.79000000f,0.44000000f,0.26000000f,0.77000000f,-0.49000000f,-0.29000000f,-0.61000000f,-0.62000000f,-0.56000000f,0.17000000f,0.78000000f,-0.67000000f,0.33000000f,0.35000000f,-0.47000000f,0.90000000f,0.40000000f,0.66000000f,-0.26000000f,-0.82000000f,-0.56000000f,-0.06000000f,0.08000000f,-0.91000000f,0.77000000f,0.49000000f,0.03000000f,0.80000000f,-0.06000000f,-0.19000000f,-0.44000000f,0.65000000f,0.21000000f,-0.13000000f,0.01000000f,-0.56000000f,0.48000000f,0.66000000f,0.64000000f,-0.71000000f,0.42000000f,0.89000000f,0.73000000f,0.65000000f,-0.38000000f,0.15000000f,0.16000000f,-0.47000000f,-0.94000000f,-0.79000000f,0.83000000f,0.97000000f,-0.49000000f,0.82000000f,0.42000000f,-0.64000000f,-0.23000000f,0.35000000f,-0.01000000f,0.97000000f,-0.84000000f,-0.50000000f,0.97000000f,-0.33000000f,0.22000000f,-0.52000000f,0.70000000f,0.30000000f,0.33000000f,0.26000000f,0.64000000f,0.38000000f,0.22000000f,-0.51000000f,0.95000000f,0.71000000f,0.50000000f,0.96000000f,0.10000000f,0.07000000f,-0.52000000f,-0.54000000f,-0.03000000f,-0.53000000f,-0.19000000f,-0.34000000f,-0.46000000f,0.74000000f,-0.16000000f,-0.53000000f,-0.84000000f,0.83000000f,-0.51000000f,0.10000000f,-0.61000000f,0.60000000f,-0.85000000f,-0.01000000f,0.69000000f,0.50000000f,-0.96000000f,0.77000000f,-0.83000000f,0.43000000f,0.21000000f,0.48000000f,0.72000000f,-0.18000000f,0.20000000f,-0.80000000f,0.19000000f,-0.14000000f,0.79000000f,-0.91000000f,0.91000000f,0.23000000f,0.23000000f,0.56000000f,0.92000000f,0.24000000f,0.15000000f,-0.12000000f,0.09000000f,-0.56000000f,0.89000000f,-0.03000000f,-0.87000000f,-0.23000000f,-0.68000000f,-0.75000000f,-0.42000000f,0.06000000f,0.29000000f,0.74000000f,0.14000000f,0.89000000f,0.02000000f,0.24000000f,0.77000000f,-0.79000000f,0.60000000f,-0.64000000f,0.22000000f,0.56000000f,0.51000000f,-0.25000000f,-0.52000000f,0.28000000f,-0.10000000f,0.82000000f,0.01000000f,-0.35000000f,-0.48000000f,0.55000000f,0.40000000f,-0.64000000f,-0.43000000f,0.65000000f,0.75000000f,-0.17000000f,-0.11000000f,0.29000000f,-0.77000000f,0.57000000f,-0.17000000f,0.71000000f,-0.49000000f,-0.95000000f,0.58000000f,0.22000000f,0.29000000f,0.06000000f,0.85000000f,-0.59000000f,-0.43000000f,0.43000000f,0.77000000f,0.16000000f,-0.42000000f,-0.85000000f,-0.43000000f,0.93000000f,0.44000000f,0.07000000f,0.29000000f,0.95000000f,0.53000000f,0.29000000f,-0.20000000f,-0.04000000f,0.29000000f,0.61000000f,0.11000000f,-0.98000000f,0.92000000f,-0.02000000f,0.71000000f,0.68000000f,-0.72000000f,-0.81000000f,0.22000000f,0.02000000f,0.84000000f,0.30000000f,0.16000000f,-0.09000000f,-0.61000000f,0.46000000f,0.72000000f,-0.31000000f,0.54000000f,0.83000000f,-0.85000000f,0.15000000f,-0.66000000f,-0.87000000f,0.77000000f,0.46000000f,0.22000000f,-0.72000000f,0.30000000f,0.64000000f,0.20000000f,0.83000000f,-0.33000000f,-0.77000000f,-0.65000000f,0.39000000f,0.30000000f,-0.97000000f,0.75000000f,0.68000000f,-0.69000000f,0.50000000f,0.36000000f,0.26000000f,-0.37000000f,-0.77000000f,0.99000000f,-0.80000000f,-0.35000000f,0.40000000f,0.07000000f,0.78000000f,0.06000000f,0.85000000f,0.34000000f,0.48000000f,0.49000000f,0.09000000f,0.47000000f,-0.38000000f,0.40000000f,-0.93000000f,-0.49000000f,0.18000000f,-0.59000000f,0.02000000f,0.26000000f,0.17000000f,-0.00000000f,0.21000000f,-0.94000000f,-0.35000000f,-0.27000000f,0.53000000f,-0.69000000f,0.15000000f,0.26000000f,0.80000000f,-0.56000000f,0.96000000f,-0.56000000f,0.11000000f,0.00000000f,0.07000000f,0.11000000f,-0.40000000f,0.76000000f,-0.83000000f,-0.81000000f,0.45000000f,0.42000000f,0.08000000f,0.27000000f,0.90000000f,0.27000000f,0.75000000f,-0.97000000f,0.34000000f,0.69000000f,-0.44000000f,0.48000000f,0.23000000f,0.00000000f,-0.07000000f,0.86000000f,0.50000000f,0.03000000f,0.08000000f,0.52000000f,-0.19000000f,-0.88000000f,0.26000000f,-0.25000000f,0.86000000f,-0.44000000f,0.41000000f,-0.48000000f,0.17000000f,0.54000000f,-0.64000000f,0.39000000f,0.10000000f,0.01000000f,-0.79000000f,-0.41000000f,0.29000000f,-0.30000000f,0.50000000f,-0.30000000f,-0.98000000f,-0.35000000f,-0.93000000f,0.69000000f,-0.46000000f,0.35000000f,-0.00000000f,0.27000000f,0.35000000f,0.69000000f,0.15000000f,0.15000000f,-0.49000000f,0.64000000f,-0.64000000f,-0.98000000f,0.05000000f,-0.37000000f,-0.26000000f,-0.41000000f,-0.18000000f,0.64000000f,0.76000000f,-0.79000000f,-0.70000000f,0.33000000f,0.16000000f,-0.69000000f,-0.08000000f,-0.32000000f,0.28000000f,-0.28000000f,0.27000000f,0.49000000f,0.15000000f,0.67000000f,-0.18000000f,-0.43000000f,0.76000000f,-0.25000000f,-0.12000000f,-0.93000000f,0.44000000f,0.59000000f,0.28000000f,0.60000000f,-0.74000000f,0.33000000f,-0.78000000f,0.64000000f,0.99000000f,-0.66000000f,0.91000000f,0.54000000f,-0.00000000f,-0.72000000f,-0.80000000f,0.03000000f,0.71000000f,0.55000000f,-0.05000000f,0.25000000f,-0.43000000f,-0.12000000f,-0.81000000f,-0.64000000f,-0.69000000f,-0.49000000f,0.69000000f,0.26000000f,0.79000000f,-0.53000000f,0.63000000f,0.79000000f,0.29000000f,-0.19000000f,0.17000000f,0.87000000f,-0.57000000f,0.79000000f,0.13000000f,0.28000000f,0.40000000f,0.24000000f,0.26000000f,-0.60000000f,0.18000000f,0.01000000f,0.69000000f,-0.74000000f,0.76000000f,0.28000000f,0.12000000f,-0.99000000f,-0.30000000f,-0.60000000f,-0.16000000f,-0.69000000f,0.05000000f,-0.46000000f,0.23000000f,0.41000000f,-0.08000000f,0.84000000f,-0.87000000f,-0.69000000f,0.14000000f,-0.39000000f,0.71000000f,0.68000000f,0.07000000f,0.62000000f,0.20000000f,-0.91000000f,-0.32000000f,-0.28000000f,0.62000000f,0.39000000f,0.38000000f,0.62000000f,-0.34000000f,0.81000000f,-0.88000000f,-0.50000000f,-0.90000000f,-0.01000000f,-0.92000000f,0.92000000f,0.59000000f,0.11000000f,0.07000000f,0.39000000f,-0.96000000f,-0.66000000f,-0.40000000f,-0.65000000f,-0.51000000f,0.33000000f,0.38000000f,-0.57000000f,-0.26000000f,-0.65000000f,0.17000000f,0.04000000f,0.98000000f,0.25000000f,-0.53000000f,0.27000000f,-0.58000000f,-0.34000000f,-0.15000000f,-0.76000000f,0.97000000f,-0.30000000f,0.79000000f,0.96000000f,0.16000000f,-0.59000000f,-0.59000000f,-0.26000000f,-0.67000000f,-0.22000000f,0.86000000f,0.78000000f,-0.73000000f,-0.81000000f,-0.58000000f,0.12000000f,-0.35000000f,-0.14000000f,0.96000000f,0.65000000f,0.90000000f,-0.19000000f,-0.56000000f,0.79000000f,-0.04000000f,-0.55000000f,0.54000000f,0.64000000f,-0.18000000f,-0.16000000f,-0.76000000f,-0.22000000f,0.48000000f,-0.22000000f,-0.95000000f,0.49000000f,0.71000000f,0.79000000f,-0.51000000f,-0.29000000f,-0.92000000f,0.06000000f,-0.57000000f,-0.51000000f,0.58000000f,0.76000000f,-0.42000000f,-0.04000000f,-0.67000000f,-0.13000000f,-0.68000000f,0.04000000f,0.34000000f,-0.15000000f,-0.50000000f,0.71000000f,-0.36000000f,-0.39000000f,0.07000000f,0.38000000f,0.24000000f,-0.91000000f,-0.18000000f,-0.40000000f,0.30000000f,-0.10000000f,0.96000000f,-0.64000000f,0.63000000f,-0.39000000f,-0.41000000f,0.65000000f,0.48000000f,-0.64000000f,-0.05000000f,-0.63000000f,0.90000000f,-0.86000000f,0.81000000f,-0.06000000f,-0.07000000f,0.33000000f,0.49000000f,-0.88000000f,-0.19000000f,0.72000000f,-0.66000000f,-0.92000000f,-0.98000000f,-0.66000000f,0.49000000f,0.27000000f,0.15000000f,-0.27000000f,0.43000000f,0.15000000f,0.31000000f,0.87000000f,0.16000000f,0.51000000f,-0.45000000f,-0.84000000f,0.67000000f,-0.35000000f,0.59000000f,-0.37000000f,-0.15000000f,0.11000000f,0.12000000f,0.75000000f,-0.06000000f,0.83000000f,0.41000000f,0.19000000f,-0.48000000f,0.81000000f,-0.23000000f,0.11000000f,0.91000000f,0.34000000f,-0.44000000f,-0.67000000f,0.91000000f,0.07000000f,0.23000000f,0.90000000f,-0.30000000f,-0.52000000f,0.65000000f,-0.68000000f,0.70000000f,-0.82000000f,0.44000000f,0.08000000f,0.05000000f,0.15000000f,-0.07000000f,0.34000000f,-0.42000000f,0.52000000f,-0.41000000f,-0.77000000f,-0.74000000f,0.81000000f,-0.12000000f,0.87000000f,0.63000000f,0.39000000f,0.34000000f,0.81000000f,-0.95000000f,0.55000000f,0.96000000f,-0.06000000f,0.24000000f,0.77000000f,0.09000000f,0.41000000f,-0.30000000f,-0.62000000f,0.92000000f,0.01000000f,-0.65000000f,0.26000000f,-0.35000000f,0.44000000f,-0.14000000f,-0.57000000f,-0.88000000f,-0.70000000f,-0.24000000f,-0.56000000f,0.70000000f,-0.84000000f,-0.13000000f,0.84000000f,-0.70000000f,-0.81000000f,-0.86000000f,0.66000000f,0.55000000f,-0.13000000f,-0.73000000f,-0.02000000f,0.26000000f,0.57000000f,-0.71000000f,-0.56000000f,-0.46000000f,-0.28000000f,0.09000000f,0.14000000f,0.14000000f,-0.07000000f,0.76000000f,0.46000000f,0.71000000f,0.56000000f,0.42000000f,-0.35000000f,-0.48000000f,-0.25000000f,-0.26000000f,0.72000000f,-0.69000000f,0.38000000f,-0.56000000f,0.65000000f,0.55000000f,0.87000000f,0.40000000f,-0.53000000f,0.68000000f,-0.52000000f,0.54000000f,-0.80000000f,-0.19000000f,-0.34000000f,0.96000000f,0.24000000f,-0.97000000f,-0.55000000f,-0.28000000f,0.62000000f,-0.28000000f,0.44000000f,-0.01000000f,-0.49000000f,0.73000000f,-0.29000000f,-0.47000000f,-0.72000000f,-0.35000000f,0.46000000f,0.30000000f,-0.83000000f,-0.15000000f,-0.74000000f,-0.02000000f,-0.01000000f,-0.58000000f,0.37000000f,-0.69000000f,-0.73000000f,-0.83000000f,-0.69000000f,0.53000000f,-0.72000000f,0.13000000f,0.52000000f,-0.40000000f,-0.97000000f,0.70000000f,-0.72000000f,-0.50000000f,-0.78000000f,0.78000000f,-0.71000000f,-0.16000000f,0.44000000f,0.70000000f,0.62000000f,0.93000000f,-0.11000000f,0.08000000f,0.94000000f,-0.27000000f,0.61000000f,0.24000000f,-0.64000000f,0.91000000f,0.70000000f,0.53000000f,-0.83000000f,-0.21000000f,-0.28000000f,0.71000000f,0.78000000f,-0.25000000f,-0.01000000f,-0.45000000f,-0.58000000f,0.36000000f,-0.28000000f,0.22000000f,0.88000000f,-0.90000000f,-0.03000000f,0.97000000f,0.26000000f,-0.93000000f,0.59000000f,0.98000000f,-0.15000000f,0.09000000f,0.51000000f,0.26000000f,0.21000000f,0.83000000f,0.24000000f,0.53000000f,-0.16000000f,0.99000000f,0.43000000f,0.75000000f,0.40000000f,-0.85000000f,0.62000000f,-0.40000000f,0.69000000f,-0.13000000f,0.02000000f,0.18000000f,0.61000000f,-0.39000000f,0.06000000f,-0.89000000f,-0.83000000f,-0.14000000f,-0.10000000f,0.86000000f,0.91000000f,0.64000000f,-0.80000000f,-0.83000000f,0.16000000f,-0.01000000f,-0.20000000f,0.26000000f,0.97000000f,-0.76000000f,0.25000000f,-0.42000000f,0.29000000f,0.63000000f,0.07000000f,0.03000000f,0.65000000f,-0.93000000f,0.91000000f,-0.44000000f,0.86000000f,0.81000000f,0.89000000f,0.85000000f,-0.11000000f,-0.59000000f,0.47000000f,-0.16000000f,0.00000000f,0.50000000f,-0.40000000f,-0.27000000f,-0.90000000f,0.36000000f,-0.10000000f,-0.10000000f,-0.69000000f,-0.12000000f,0.01000000f,0.88000000f,0.94000000f,0.54000000f,0.44000000f,0.16000000f,0.42000000f,0.32000000f,-0.00000000f,0.97000000f,0.96000000f,-0.03000000f,0.20000000f,0.59000000f,0.17000000f,-0.38000000f,0.23000000f,0.88000000f,0.82000000f,-0.02000000f,0.56000000f,0.02000000f,-0.17000000f,0.08000000f,-0.88000000f,0.91000000f,-0.95000000f,0.03000000f,-0.79000000f,0.03000000f,-0.54000000f,0.21000000f,0.07000000f,-0.28000000f,0.22000000f,0.95000000f,-0.72000000f,0.04000000f,0.03000000f,-0.32000000f,0.80000000f,-0.21000000f,-0.76000000f,-0.95000000f,-0.96000000f,-0.10000000f,0.80000000f,-0.76000000f,0.96000000f,-0.50000000f,0.33000000f,0.71000000f,-0.45000000f,0.00000000f,-0.52000000f,-0.94000000f,-0.79000000f,0.21000000f,0.71000000f,0.68000000f,-0.93000000f,-0.79000000f,-0.93000000f,-0.84000000f,0.78000000f,-0.60000000f,0.07000000f,-0.83000000f,-0.06000000f,-0.61000000f,-0.65000000f,0.36000000f,0.72000000f,0.14000000f,-0.18000000f,0.61000000f,-0.75000000f,-0.30000000f,-0.62000000f,-0.21000000f,0.52000000f,-0.27000000f,0.87000000f,-0.01000000f,0.10000000f,0.24000000f,0.89000000f,-0.89000000f,-0.67000000f,-0.79000000f,-0.83000000f,-0.45000000f,0.32000000f,-0.26000000f,0.76000000f,-0.01000000f,-0.36000000f,-0.64000000f,0.49000000f,-0.18000000f,0.74000000f,0.38000000f,0.36000000f,-0.62000000f,0.41000000f,0.69000000f,-0.07000000f,-0.34000000f,-0.99000000f,-0.00000000f,0.91000000f,-0.82000000f,0.00000000f,0.07000000f,0.19000000f,-0.79000000f,-0.62000000f,0.62000000f,-0.58000000f,-0.83000000f,-0.10000000f,0.83000000f,0.91000000f,-0.85000000f,-0.95000000f,0.93000000f,0.64000000f,0.43000000f,-0.95000000f,-0.43000000f,0.04000000f,-0.41000000f,0.14000000f,0.41000000f,-0.74000000f,-0.70000000f,0.76000000f,-0.53000000f,-0.13000000f,0.69000000f,0.51000000f,-0.39000000f,0.83000000f,0.18000000f,0.47000000f,-0.90000000f,0.28000000f,0.20000000f,-0.25000000f,0.95000000f,0.62000000f,0.08000000f,-0.00000000f,-0.56000000f,-0.68000000f,0.29000000f,-0.27000000f,-0.32000000f,-0.22000000f,0.83000000f,0.60000000f,0.44000000f,0.02000000f,0.61000000f,0.39000000f,0.03000000f,-0.33000000f,-0.57000000f,-0.01000000f,-0.59000000f,-0.38000000f,0.30000000f,-0.26000000f,-0.95000000f,-0.18000000f,-0.08000000f,-0.78000000f,0.00000000f,-0.51000000f,-0.72000000f,0.53000000f,0.37000000f,-0.50000000f,-0.87000000f,0.68000000f,-0.78000000f,0.17000000f,0.08000000f,-0.60000000f,-0.31000000f,0.06000000f,0.67000000f,-0.46000000f,-0.78000000f,0.68000000f,0.40000000f,-0.76000000f,0.65000000f,-0.43000000f,-0.60000000f,0.56000000f,0.59000000f,-0.65000000f,0.51000000f,-0.09000000f,-0.60000000f,-0.34000000f,0.19000000f,-0.03000000f,-0.10000000f,0.81000000f,-0.65000000f,-0.85000000f,-0.05000000f,-0.62000000f,-0.24000000f,0.52000000f,-0.33000000f,0.36000000f,-0.25000000f,0.96000000f,-0.76000000f,-0.68000000f,-0.43000000f,0.48000000f,0.76000000f,-0.60000000f,0.85000000f,-0.29000000f,0.61000000f,-0.30000000f,-0.68000000f,0.26000000f,0.08000000f,0.38000000f,0.07000000f,0.44000000f,0.73000000f,-0.92000000f,0.50000000f,0.81000000f,-0.37000000f,0.89000000f,-0.28000000f,-0.99000000f,0.28000000f,-0.63000000f,-0.65000000f,0.97000000f,0.84000000f,-0.86000000f,0.20000000f,-0.52000000f,0.78000000f,-0.16000000f,-0.06000000f,-0.23000000f,0.35000000f,-0.98000000f,0.57000000f,0.44000000f,-0.15000000f,0.06000000f,0.50000000f,-0.66000000f,-0.60000000f,-0.39000000f,-0.39000000f,0.75000000f,0.05000000f,0.17000000f,0.95000000f,-0.71000000f,-0.87000000f,-0.80000000f,0.19000000f,-0.60000000f,0.61000000f,0.95000000f,0.87000000f,-0.73000000f,-0.23000000f,-0.54000000f,0.11000000f,-0.99000000f,0.74000000f,-0.29000000f,-0.60000000f,-0.65000000f,0.46000000f,-0.97000000f,-0.49000000f,-0.74000000f,0.33000000f,-0.74000000f,0.06000000f,0.19000000f,0.08000000f,-0.70000000f,-0.32000000f,0.80000000f,0.44000000f,-0.34000000f,-0.26000000f,-0.39000000f,-0.10000000f,-0.84000000f,0.47000000f,-0.12000000f,-0.46000000f,0.16000000f,-0.05000000f,-0.34000000f,0.89000000f,-0.06000000f,0.11000000f,-0.06000000f,-0.24000000f,-0.59000000f,-0.00000000f,0.33000000f,0.32000000f,-0.38000000f,0.38000000f,0.10000000f,0.00000000f,-0.59000000f,0.77000000f,-0.17000000f,-0.63000000f,-0.87000000f,-0.34000000f,-0.95000000f,0.71000000f,-0.76000000f,-0.54000000f,-0.29000000f,-0.63000000f,-0.84000000f,-0.27000000f,0.57000000f,0.11000000f,-0.87000000f,-0.57000000f,-0.52000000f,0.34000000f,-0.51000000f,-0.32000000f,0.61000000f,-0.06000000f,0.97000000f,0.44000000f,0.34000000f,0.23000000f,0.38000000f,0.23000000f,0.22000000f,0.01000000f,-0.26000000f,-0.72000000f,0.27000000f,0.81000000f,-0.28000000f,0.68000000f,-0.80000000f,0.97000000f,0.74000000f,0.35000000f,-0.96000000f,-0.33000000f,0.89000000f,-0.82000000f,0.06000000f,-0.88000000f,0.42000000f,0.70000000f,-0.34000000f,0.56000000f,-0.67000000f,0.07000000f,0.22000000f,-0.36000000f,-0.42000000f,-0.20000000f,0.95000000f,0.52000000f,0.22000000f,0.75000000f,-0.30000000f,0.16000000f,0.57000000f,-0.52000000f,0.10000000f,-0.05000000f,0.00000000f,0.47000000f,0.45000000f,0.26000000f,-0.98000000f,-0.27000000f,-0.10000000f,-0.38000000f,-0.60000000f,0.39000000f,-0.74000000f,0.05000000f,0.98000000f,0.77000000f,-0.92000000f,-0.33000000f,0.86000000f,0.08000000f,-0.84000000f,-0.22000000f,0.40000000f,-0.98000000f,-0.50000000f,-0.55000000f,0.57000000f,0.89000000f,-0.43000000f,0.02000000f,-0.62000000f,0.36000000f,-0.60000000f,-0.74000000f,0.68000000f,0.56000000f,0.02000000f,-0.56000000f,-0.97000000f,0.62000000f,0.86000000f,-0.59000000f,0.94000000f,0.91000000f,-0.65000000f,0.94000000f,-0.28000000f,0.61000000f,0.33000000f,0.93000000f,0.64000000f,0.17000000f,0.54000000f,0.31000000f,-0.92000000f,0.89000000f,-0.68000000f,-0.51000000f,-0.84000000f,-0.56000000f,-0.92000000f,-0.96000000f,-0.16000000f,-0.56000000f,-0.84000000f,-0.02000000f,0.80000000f,-0.14000000f,0.87000000f,0.04000000f,0.38000000f,0.21000000f,0.64000000f,-0.97000000f,-0.39000000f,-0.49000000f,-0.12000000f,-0.30000000f,-0.51000000f,-0.25000000f,0.06000000f,0.53000000f,0.67000000f,-0.12000000f,-0.53000000f,-0.92000000f,0.96000000f,-0.01000000f,0.47000000f,0.51000000f,0.71000000f,0.30000000f,-0.63000000f,-0.98000000f,-0.26000000f,-0.22000000f,0.82000000f,0.56000000f,-0.13000000f,-0.22000000f,0.78000000f,0.91000000f,-0.21000000f,0.78000000f,0.42000000f,-0.86000000f,-0.47000000f,0.14000000f,0.23000000f,0.10000000f,-0.32000000f,-0.57000000f,-0.32000000f,0.84000000f,-0.57000000f,-0.15000000f,0.20000000f,0.85000000f,0.05000000f,-0.57000000f,0.83000000f,0.94000000f,0.50000000f,-0.74000000f,-0.04000000f,-0.80000000f,-0.86000000f,0.52000000f,-0.01000000f,-0.28000000f,0.28000000f,-0.53000000f,0.94000000f,0.50000000f,-0.82000000f,0.71000000f,-0.27000000f,-0.50000000f,-0.38000000f,-0.38000000f,-0.30000000f,0.52000000f,-0.14000000f,-0.25000000f,-0.89000000f,0.25000000f,-0.56000000f,-0.91000000f,-0.00000000f,-0.26000000f,0.92000000f,-0.75000000f,-0.36000000f,-0.30000000f,-0.72000000f,0.65000000f,-0.71000000f,-0.38000000f,0.92000000f,-0.48000000f,-0.76000000f,0.21000000f,0.40000000f,-0.52000000f,-0.01000000f,-0.90000000f,0.88000000f,-0.55000000f,-0.04000000f,-0.30000000f,-0.20000000f,0.60000000f,0.69000000f,-0.51000000f,-0.57000000f,0.90000000f,-0.37000000f,0.98000000f,-0.05000000f,0.73000000f,-0.79000000f,-0.63000000f,0.22000000f,0.13000000f,0.83000000f,0.34000000f,-0.10000000f,0.38000000f,0.94000000f,-0.44000000f,0.70000000f,-0.61000000f,0.85000000f,-0.20000000f,-0.00000000f,0.17000000f,-0.02000000f,-0.38000000f,-0.04000000f,-0.44000000f,0.68000000f,0.94000000f,0.51000000f,-0.72000000f,-0.38000000f,-0.63000000f,0.33000000f,0.28000000f,0.02000000f,-0.76000000f,0.59000000f,0.03000000f,0.47000000f,-0.71000000f,-0.30000000f,-0.67000000f,-0.61000000f,0.46000000f,0.88000000f,0.28000000f,0.25000000f,-0.59000000f,0.68000000f,0.99000000f,0.03000000f,0.34000000f,0.42000000f,-0.02000000f,-0.53000000f,-0.67000000f,0.10000000f,-0.79000000f,-0.05000000f,0.35000000f,0.98000000f,0.24000000f,0.60000000f,-0.07000000f,0.40000000f,0.91000000f,-0.44000000f,-0.88000000f,-0.56000000f,-0.74000000f,0.33000000f,-0.95000000f,-0.13000000f,0.10000000f,-0.36000000f,0.25000000f,0.64000000f,-0.19000000f,-0.03000000f,0.73000000f,0.93000000f,0.08000000f,-0.79000000f,0.16000000f,0.10000000f,-0.98000000f,0.78000000f,-0.93000000f,0.41000000f,0.95000000f,0.74000000f,0.33000000f,0.82000000f,0.08000000f,-0.81000000f,0.57000000f,-0.85000000f,-0.59000000f,0.70000000f,0.69000000f,-0.10000000f,-0.44000000f,-0.34000000f,-0.20000000f,-0.66000000f,0.65000000f,-0.25000000f,-0.05000000f,0.78000000f,0.65000000f,0.26000000f,-0.02000000f,-0.82000000f,0.01000000f,0.44000000f,0.68000000f,0.21000000f,0.96000000f,-0.27000000f,-0.02000000f,-0.16000000f,0.57000000f,-0.77000000f,-0.40000000f,0.16000000f,-0.51000000f,-0.58000000f,-0.65000000f,0.41000000f,0.19000000f,-0.83000000f,-0.47000000f,0.04000000f,-0.15000000f,-0.64000000f,0.36000000f,-0.43000000f,-0.44000000f,-0.35000000f,0.63000000f,0.33000000f,-0.15000000f,0.31000000f,0.69000000f,-0.79000000f,-0.74000000f,-0.56000000f,-0.94000000f,-0.18000000f,-0.40000000f,-0.42000000f,0.45000000f,0.70000000f,-0.68000000f,-0.92000000f,-0.76000000f,0.66000000f,0.47000000f,-0.68000000f,0.28000000f,-0.37000000f,-0.64000000f,-0.60000000f,0.67000000f,0.90000000f,-0.00000000f,0.13000000f,-0.60000000f,0.49000000f,-0.92000000f,0.76000000f,0.95000000f,-0.06000000f,0.32000000f,-0.23000000f,-0.02000000f,-0.55000000f,0.66000000f,0.27000000f,-0.32000000f,0.91000000f,0.38000000f,-0.33000000f,0.30000000f,-0.28000000f,-0.02000000f,-0.33000000f,0.50000000f,0.70000000f,-0.23000000f,-0.67000000f,-0.27000000f,-0.38000000f,-0.01000000f,-0.31000000f,0.84000000f,-0.10000000f,0.53000000f,-0.07000000f,-0.48000000f,-0.46000000f,0.60000000f,0.53000000f,-0.53000000f,-0.58000000f,0.48000000f,0.51000000f,-0.67000000f,0.68000000f,-0.08000000f,0.31000000f,0.50000000f,0.21000000f,0.44000000f,-0.66000000f,0.74000000f,-0.01000000f,0.97000000f,0.98000000f,0.69000000f,0.13000000f,-0.56000000f,0.64000000f,-0.51000000f,-0.33000000f,-0.31000000f,0.12000000f,0.25000000f,0.28000000f,-0.52000000f,0.54000000f,0.16000000f,0.38000000f,0.74000000f,0.87000000f,-0.67000000f,-0.99000000f,-0.91000000f,-0.42000000f,-0.56000000f,-0.48000000f,0.15000000f,-0.20000000f,-0.88000000f,0.53000000f,0.25000000f,0.47000000f,0.98000000f,-0.96000000f,-0.19000000f,0.50000000f,0.81000000f,0.13000000f,0.81000000f,-0.07000000f,0.44000000f,0.57000000f,0.37000000f,0.86000000f,-0.33000000f,0.68000000f,-0.86000000f,-0.27000000f,0.47000000f,-0.04000000f,-0.15000000f,-0.56000000f,0.35000000f,-0.41000000f,0.78000000f,-0.52000000f,0.15000000f,0.80000000f,0.80000000f,-0.98000000f,-0.33000000f,-0.43000000f,0.43000000f,0.38000000f,-0.52000000f,0.20000000f,-0.95000000f,-0.55000000f,0.50000000f,-0.53000000f,-0.54000000f,0.66000000f,0.19000000f,0.56000000f,0.70000000f,-0.55000000f,-0.96000000f,0.51000000f,-0.59000000f,-0.63000000f,0.64000000f,-0.59000000f,0.97000000f,-0.38000000f,0.81000000f,0.43000000f,-0.76000000f,0.26000000f,0.75000000f,-0.29000000f,-0.06000000f,-0.53000000f,-0.17000000f,-0.51000000f,-0.86000000f,-0.72000000f,-0.97000000f,-0.15000000f,0.05000000f,0.73000000f,-0.03000000f,-0.91000000f,-0.77000000f,0.71000000f,-0.82000000f,-0.78000000f,0.32000000f,-0.91000000f,-0.51000000f,0.33000000f,-0.02000000f,0.13000000f,0.83000000f,-0.42000000f,-0.30000000f,-0.07000000f,0.97000000f,0.77000000f,0.34000000f,-0.84000000f,0.24000000f,-0.45000000f,-0.21000000f,-0.81000000f,0.59000000f,-0.61000000f,0.57000000f,-0.53000000f,-0.64000000f,-0.38000000f,-0.86000000f,-0.65000000f,0.20000000f,-0.16000000f,-0.01000000f,-0.09000000f,0.66000000f,0.64000000f});
    auto b = backend->create_tensor(element::f32, shape_b);
    copy_data(b, vector<float>{-0.83000000f,0.21000000f,-0.45000000f,-0.22000000f,0.90000000f,0.99000000f,-0.06000000f,-0.31000000f,-0.80000000f,0.54000000f,-0.88000000f,0.13000000f,0.25000000f,0.88000000f,-0.25000000f,0.61000000f,0.99000000f,-0.75000000f,0.34000000f,0.02000000f,0.65000000f,-0.17000000f,-0.46000000f,-0.26000000f,0.75000000f,-0.09000000f,-0.11000000f,0.75000000f,-0.42000000f,-0.93000000f,-0.97000000f,-0.89000000f,0.15000000f,0.06000000f,-0.30000000f,-0.40000000f,-0.47000000f,-0.78000000f,-0.44000000f,-0.33000000f,-0.68000000f,-0.18000000f,0.08000000f,0.74000000f,-0.76000000f,-0.87000000f,-0.38000000f,0.74000000f,-0.23000000f,-0.25000000f,0.81000000f,0.65000000f,-0.14000000f,-0.14000000f,-0.67000000f,0.42000000f,-0.75000000f,0.12000000f,0.11000000f,0.40000000f,0.05000000f,-0.08000000f,0.27000000f,0.29000000f,0.95000000f,0.38000000f,0.63000000f,0.58000000f,0.67000000f,-0.62000000f,-0.51000000f,-0.24000000f,-0.18000000f,-0.12000000f,-0.40000000f,0.74000000f,0.11000000f,0.10000000f,0.55000000f,-0.94000000f,0.98000000f,0.72000000f,0.34000000f,0.92000000f,-0.31000000f,0.96000000f,-0.53000000f,-0.09000000f,0.05000000f,-0.32000000f,-0.50000000f,-0.96000000f,-0.49000000f,-0.71000000f,-0.96000000f,0.19000000f,0.57000000f,0.42000000f,-0.83000000f,0.52000000f,-0.87000000f,-0.13000000f,-0.58000000f,0.32000000f,-0.59000000f,-0.66000000f,0.66000000f,0.24000000f,0.09000000f,0.48000000f,0.39000000f,-0.20000000f,-0.88000000f,-0.46000000f,0.82000000f,-0.52000000f,0.05000000f,0.34000000f,0.06000000f,0.85000000f,0.18000000f,-0.62000000f,-0.25000000f,-0.82000000f,-0.21000000f,0.86000000f,0.04000000f,-0.54000000f,-0.63000000f,-0.67000000f,-0.19000000f,0.98000000f,0.59000000f,0.40000000f,0.96000000f,-0.89000000f,0.89000000f,0.52000000f,-0.36000000f,-0.65000000f,-0.07000000f,-0.80000000f,0.18000000f,0.21000000f,0.90000000f,-0.13000000f,-0.36000000f,-0.24000000f,0.98000000f,-0.09000000f,0.13000000f,-0.50000000f,0.39000000f,-0.47000000f,-0.07000000f,-0.06000000f,-0.44000000f,0.79000000f,-0.62000000f,-0.82000000f,-0.85000000f,-0.41000000f,-0.40000000f,0.97000000f,0.03000000f,0.29000000f,0.55000000f,-0.25000000f,0.71000000f,-0.55000000f,0.82000000f,-0.93000000f,-0.06000000f,-0.18000000f,-0.26000000f,-0.66000000f,0.13000000f,-0.68000000f,-0.19000000f,0.93000000f,0.59000000f,0.53000000f,-0.16000000f,-0.48000000f,-0.98000000f,0.71000000f,0.94000000f,0.51000000f,0.74000000f,0.91000000f,-0.27000000f,0.42000000f,-0.53000000f,-0.87000000f,0.26000000f,0.96000000f,-0.47000000f,0.66000000f,-0.98000000f,0.26000000f,0.92000000f,-0.61000000f,0.14000000f,0.61000000f,-0.68000000f,0.50000000f,0.10000000f,0.40000000f,-0.62000000f,-0.07000000f,-0.13000000f,-0.97000000f,-0.69000000f,0.95000000f,-0.86000000f,-0.74000000f,-0.29000000f,0.54000000f,-0.64000000f,-0.14000000f,-0.91000000f,0.66000000f,-0.70000000f,-0.20000000f,-0.26000000f,-0.30000000f,-0.19000000f,0.41000000f,0.88000000f,-0.05000000f,-0.48000000f,0.82000000f,-0.85000000f,-0.01000000f,0.09000000f,-0.10000000f,-0.68000000f,-0.07000000f,0.47000000f,-0.74000000f,0.10000000f,-0.76000000f,-0.98000000f,-0.92000000f,0.49000000f,-0.97000000f,-0.32000000f,0.23000000f,0.68000000f,0.41000000f,0.82000000f,-0.04000000f,0.41000000f,0.72000000f,0.33000000f,-0.83000000f,-0.55000000f,0.57000000f,-0.96000000f,0.85000000f,0.81000000f,0.66000000f,0.52000000f,-0.19000000f,-0.18000000f,-0.33000000f,-0.73000000f,0.55000000f,-0.69000000f,0.97000000f,0.50000000f,0.22000000f,-0.90000000f,0.21000000f,-0.50000000f,-0.92000000f,-0.61000000f,0.50000000f,-0.07000000f,0.59000000f,0.36000000f,-0.47000000f,0.50000000f,-0.61000000f,-0.75000000f,0.45000000f,-0.91000000f,-0.30000000f,0.25000000f,0.27000000f,0.91000000f,-0.28000000f,0.45000000f,-0.07000000f,0.63000000f,0.52000000f,-0.62000000f,0.48000000f,0.54000000f,-0.97000000f,0.33000000f,0.48000000f,-0.90000000f,-0.85000000f,-0.26000000f,0.95000000f,-0.00000000f,-0.39000000f,0.34000000f,0.02000000f,-0.29000000f,0.82000000f,0.17000000f,0.43000000f,-0.27000000f,-0.62000000f,0.62000000f,0.21000000f,0.96000000f,0.68000000f,0.09000000f,0.61000000f,0.40000000f,0.03000000f,0.15000000f,-0.85000000f,-0.36000000f,0.85000000f,-0.03000000f,0.36000000f,0.85000000f,0.85000000f,-0.91000000f,-0.87000000f,0.27000000f,0.09000000f,0.81000000f,0.20000000f,0.51000000f,0.96000000f,-0.93000000f,-0.19000000f,-0.64000000f,0.87000000f,0.41000000f,-0.03000000f,-0.24000000f,-0.12000000f,-0.71000000f,0.28000000f,-0.68000000f,0.45000000f,-0.62000000f,0.64000000f,0.18000000f,-0.00000000f,0.81000000f,-0.72000000f,-0.46000000f,-0.58000000f});
    auto result = backend->create_tensor(element::f32, shape_r);

    vector<float> expected_result{0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.94260001f,2.52870004f,-0.57100001f,1.28640001f,-1.10670000f,-0.92230005f,-1.12540003f,1.10610001f,-1.40430003f,0.37560004f,-1.07849998f,0.85619998f,0.32200002f,0.98310000f,0.42650001f,-0.60530002f,-1.47510003f,1.05810000f,-0.85440001f,0.70359998f,1.60949998f,-0.52480000f,0.25889999f,0.89179999f,1.40210004f,0.44999996f,-0.13240001f,-0.05290002f,-0.28530001f,0.30150000f,-1.57190002f,0.76729999f,0.70369997f,0.75729999f,-0.71190000f,0.48549999f,-1.36660000f,-0.09749996f,0.16540000f,0.23820001f,1.06040001f,-0.91680002f,-0.08460000f,0.74320002f,-0.35549999f,-0.51749998f,-1.14120000f,0.55069996f,-0.22529999f,-0.01190001f,-0.17499998f,-0.05610000f,0.40230002f,-1.05480004f,-0.86110002f,1.47100001f,-0.61890000f,-0.09859999f,-1.44390004f,0.95690002f,-2.46339999f,1.17899996f,-0.46399997f,0.65630001f,0.08240002f,0.19189995f,0.64100001f,1.88979998f,0.34109999f,-0.62000003f,0.17900002f,0.56719998f,-1.79699996f,1.42930002f,0.03980001f,1.23239999f,-0.88990001f,-0.28200000f,-0.88210004f,1.15970009f,0.47329997f,-0.89740002f,-0.79230001f,0.31600001f,0.03759998f,-1.13079998f,0.35760000f,-1.23230001f,0.82790000f,0.80140001f,-0.60830003f,0.02760001f,-0.45630003f,1.38210002f,1.02909997f,-0.64519998f,-0.65910000f,-0.27760001f,-0.32969997f,-0.01160002f,-0.42200004f,0.14810005f,1.72150000f,-0.78080005f,0.35760003f,1.23550002f,-0.75789999f,-0.51970003f,-0.74150000f,0.74100000f,-0.18080004f,0.36130003f,0.23470000f,-1.25250002f,0.54629998f,0.78739998f,-1.08840003f,0.81260005f,-0.72510006f,0.03759998f,2.13530005f,0.12039998f,0.07040001f,-1.97010005f,-0.48509997f,0.04130003f,1.05020001f,-1.77390000f,1.58410004f,-1.63340003f,1.26340003f,1.35230002f,0.38500002f,0.98700001f,-0.51860004f,-0.62630002f,0.54940007f,-1.34139998f,0.34610002f,-0.59420001f,-1.07150002f,0.53510003f,0.21490005f,-1.15030000f,-0.79410000f,-0.50949998f,-1.38130004f,1.14680005f,-0.44970003f,0.38910000f,0.23530001f,-1.90330004f,1.33820002f,-0.02060000f,-0.14510000f,0.23080000f,0.66830004f,0.58149998f,-0.04939995f,1.66790000f,-0.80850003f,-0.61010000f,0.81340000f,0.49549998f,1.41880002f,-0.24870003f,1.36290008f,-0.42110003f,-0.38290000f,0.25879996f,-0.23389998f,-0.28189999f,0.00220002f,-0.01250002f,-0.82949999f,-0.36300003f,0.67810001f,0.12100001f,0.10589999f,-1.18810002f,-1.07549999f,1.38650001f,0.53380001f,0.84890001f,1.27369999f,0.07769998f,1.69810007f,-0.14550004f,0.59690002f,0.50960002f,-1.37050000f,0.58680002f,-0.93380000f,-0.74490004f,-0.24779995f,0.15919999f,-0.46980001f,1.32780000f,-0.92849999f,1.24370001f,-1.82890007f,-0.14769997f,0.10089998f,-0.82480000f,2.19520002f,0.52539999f,1.17069998f,-0.48620000f,0.61130005f,-0.70479997f,0.53920002f,-1.36320002f,0.81410003f,0.23119997f,-0.87439997f,1.44540000f,-0.67310003f,-0.16129999f,-1.44750001f,1.16330001f,-0.30900004f,1.54060003f,-2.01859999f,-0.53159999f,-0.43610000f,1.02970001f,0.90240003f,-1.19950008f,0.46740007f,0.00539998f,0.23030004f,-1.35779999f,1.38480001f,-0.31710003f,-0.98140002f,0.09840002f,0.97790000f,-1.00979999f,0.46570002f,-0.66699995f,-0.85810004f,-1.55660003f,0.92010003f,-0.72049999f,0.05270001f,-0.39000003f,-0.92719998f,-1.30209999f,0.48440002f,-0.23860005f,1.22560002f,0.88070005f,0.33710001f,-0.17400001f,-0.95139997f,-0.06039998f,-1.73800003f,0.73970001f,-0.70310001f,-0.58960001f,0.48279998f,1.10240001f,0.92079998f,-1.42090000f,1.10809996f,-0.07370000f,-1.22550001f,1.24509999f,0.76870004f,-1.21029998f,0.95660003f,-1.29320003f,1.29779999f,-0.85350001f,1.27910003f,-2.02400001f,1.85379997f,-1.92160001f,1.46449999f,-1.45360004f,-0.79429999f,0.53180003f,-0.54139998f,0.71719999f,-0.90640001f,0.18030004f,-1.34410006f,-1.25520002f,0.56459999f,0.78180002f,-0.06160000f,-0.86470000f,1.86890002f,-0.33570004f,-0.43970002f,-0.99510004f,1.30610006f,-0.36110000f,-0.73160000f,-1.23209999f,-0.08820004f,1.70180001f,-1.24639998f,0.77830000f,-1.27699999f,0.09639998f,-1.37870003f,0.96950004f,-1.06050001f,0.42980002f,-0.35840003f,-0.26310000f,0.83350005f,-0.46940001f,0.15930002f,-0.11650001f,0.60850003f,-0.36370005f,-0.00720000f,0.94649995f,-0.04339998f,-0.20829997f,0.31410000f,-0.68500000f,0.92760002f,0.56059998f,0.53160000f,0.48340001f,0.46119998f,0.43620004f,0.41199997f,-0.78560002f,1.67910000f,-1.72620002f,2.64750011f,-2.82080009f,-0.86970005f,0.03250008f,-0.58239998f,0.24200004f,0.32930000f,1.36090004f,-0.26900001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-1.85780007f,-0.00800002f,2.02800008f,0.39549997f,0.25449996f,1.15300006f,0.88299995f,0.71060007f,0.05640001f,-0.22820002f,0.69219996f,1.12679996f,0.97009997f,0.24890005f,-0.23970001f,1.72180003f,-0.75989997f,-2.34100008f,-1.87570005f,-1.18920001f,-1.33870008f,-0.43670006f,0.79830004f,-0.41580006f,-2.24440004f,-2.33070002f,-1.26710005f,-0.75989997f,-1.08980003f,-2.20720002f,-0.33079998f,1.27690000f,-0.28340000f,-2.08750005f,-0.31839995f,-0.08190001f,-0.46190004f,2.06650005f,1.99699996f,0.03699995f,1.24199999f,-1.14850003f,-0.12470003f,0.53670000f,-0.47329998f,0.20520001f,0.32410005f,1.80819999f,0.91600006f,-1.97210006f,0.54790010f,-0.06210008f,0.50290000f,3.91790008f,0.33920000f,-0.43549995f,1.09090005f,2.69390013f,0.05740009f,0.41240002f,1.03010008f,0.59109993f,0.93649999f,-0.82059998f,-1.19330002f,-0.18610003f,-2.20770004f,-2.91900001f,-1.39860010f,0.09850005f,0.15070002f,-0.97170006f,-0.03119996f,0.01240004f,-2.59140009f,-1.69660002f,-0.32430000f,-0.75739996f,-0.43909997f,0.22240004f,1.30280004f,1.02349994f,-0.44429996f,-0.70420004f,-0.44980000f,-2.55620004f,-0.68819998f,0.76439999f,0.68980002f,0.68180002f,1.06430006f,-0.09939994f,0.83359998f,-0.91370000f,-1.77590001f,-1.91780000f,-0.47630005f,1.91390001f,1.64709999f,0.90039998f,-1.69640005f,-3.04030007f,-0.18679996f,-0.76920010f,0.25949999f,-1.20650007f,-1.23320001f,0.21829999f,1.75639996f,0.64289997f,0.99320006f,-0.91140002f,-0.14190003f,0.27210000f,0.04290001f,0.90660008f,-2.07540002f,-2.69190000f,-0.56049999f,0.46240000f,0.24639997f,-0.03130004f,1.88890005f,0.09110003f,-1.93199998f,0.28680005f,2.18670004f,1.17400000f,-0.72600004f,-0.16880003f,-1.13529998f,-1.19720003f,-0.70309999f,-0.88440005f,1.19060001f,-1.00270008f,0.41260002f,0.46860000f,0.48189997f,1.20679998f,-0.42660004f,0.42450005f,2.86920003f,2.68590007f,0.84579998f,0.40590005f,1.51260006f,0.61480002f,2.05800006f,-1.47110005f,0.16240000f,2.30800002f,1.41669998f,1.00180004f,-0.66480004f,-1.44350008f,-1.94810007f,-0.19230001f,-0.31260007f,0.25469999f,-0.26420008f,-0.61470003f,0.12590005f,-0.35460005f,-0.99819994f,0.04379998f,-0.50540000f,0.14110004f,0.29050003f,-0.21330005f,-0.64940000f,-0.14360000f,0.90580005f,1.43389997f,0.05640004f,0.19329999f,0.04539993f,-0.09169998f,-2.09970006f,-0.86419997f,-1.06270012f,0.84860002f,-1.49770000f,-0.43090007f,-0.20710008f,-1.23980010f,-1.73380008f,0.81009999f,-0.11390002f,0.46280000f,0.20490004f,1.84109998f,3.41540010f,0.63050001f,0.43660013f,-0.75960001f,-0.23369999f,-1.03180007f,-1.81880005f,0.84000008f,1.06179996f,-0.29789994f,1.25520002f,-2.20340010f,-0.55959996f,0.78379996f,-0.97890004f,-3.31750009f,1.66060008f,1.52139995f,-0.48369997f,-0.27130001f,-0.56330000f,0.31129992f,-1.28160007f,-0.86990012f,0.35820000f,1.08730007f,0.12649992f,3.11480012f,0.88450004f,0.91980003f,1.02999997f,0.62740000f,0.71890000f,-1.64750012f,0.74870005f,-1.35810003f,-2.23009998f,-0.81660002f,0.34799993f,1.43080003f,0.99230001f,0.20920002f,0.21560004f,-0.45279990f,-0.80300002f,-0.37149998f,0.14340005f,-0.99700002f,0.48610000f,-0.98210010f,0.91150003f,2.79270004f,1.75850002f,0.57940008f,0.39460006f,-0.35089998f,1.26620005f,0.68810006f,-1.26850004f,-2.42990007f,2.61050002f,2.58820006f,-0.43380001f,-1.05439999f,-1.20190001f,-1.05979999f,-0.28539997f,0.04029999f,1.82220002f,0.11740009f,-0.43149998f,-0.60780007f,-1.04929996f,-1.80050003f,1.16029999f,0.93680002f,1.02330001f,-1.56779997f,-0.51070006f,0.60240000f,0.27359992f,-1.54350003f,2.01940002f,1.26900002f,0.54020004f,-1.14330000f,-0.83970001f,0.09480007f,-1.16080006f,0.60699999f,2.11740002f,1.08950004f,0.39970004f,0.10490008f,-0.09989996f,-0.78470003f,-1.33229997f,-1.18660000f,0.73970001f,-0.99060014f,-1.60860006f,-0.58469999f,1.07370003f,1.77110006f,0.89800006f,-0.21859989f,1.60850001f,1.19630002f,1.72649999f,0.94200001f,0.61969999f,0.06440001f,-0.72070010f,-0.16479999f,-0.27420014f,-0.27589999f,-1.42570009f,1.05380003f,1.90260007f,-0.54150002f,0.41990007f,1.06980001f,-0.16809995f,-0.45229998f,-1.95970010f,-1.14169999f,0.12069997f,-0.34319996f,-2.01780003f,-1.12579998f,-0.22909999f,0.43360001f,1.38780000f,1.38269997f,0.43730000f,-0.45919996f,-1.49620006f,-0.21209994f,0.12550006f,-2.61850008f,0.63810011f,-2.45570007f,0.88989998f,1.90180000f,-0.75350009f,-2.28870005f,0.59590001f,1.77189998f,-0.24540008f,-1.54330004f,0.25120000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.01090002f,-1.19969999f,1.90450004f,-1.39999999f,0.41810001f,0.17960002f,-0.81660005f,0.14570001f,-1.17740004f,0.14750003f,0.45549994f,-2.09080000f,0.90410001f,0.34019997f,-0.60900001f,1.28420002f,0.39050004f,-2.73040008f,1.95540000f,0.04590004f,-0.65300001f,0.05400000f,0.44630001f,-1.40930002f,-0.06390000f,0.55420000f,0.32559998f,0.93760007f,-0.85969998f,-0.97629999f,1.14920002f,0.03959999f,-0.92990003f,0.20990000f,0.42480002f,-1.06410002f,1.08290004f,-0.91260000f,-0.46050002f,0.66309997f,0.16420001f,0.31400004f,0.30079997f,0.80590005f,-0.85590001f,0.03339999f,0.66710002f,0.17330004f,0.39309999f,-0.33819999f,0.78840002f,-1.35340006f,0.65430001f,1.07030003f,-0.27370000f,-1.30090004f,-0.53510000f,-0.79610005f,-0.96279997f,-1.25800005f,1.39399999f,-2.16680000f,0.17199993f,0.30400002f,0.40599993f,0.22090006f,-0.19390001f,-0.87920003f,0.85370000f,0.68610004f,-0.83370003f,-0.36950004f,1.79300000f,-0.07109994f,-1.41580009f,-0.04319997f,1.51440005f,-0.21610001f,0.02900004f,0.57960001f,-0.66190002f,1.13590002f,-0.32709997f,-0.87220002f,0.16940001f,-0.17500001f,0.09650003f,0.39689996f,-1.00249999f,-0.19579998f,-0.07400001f,1.14610003f,0.45389999f,-0.22409998f,-1.16089999f,0.03229999f,0.20670002f,0.14770000f,1.42030003f,-1.26590002f,-0.67320000f,0.48819997f,-0.05899996f,-0.01440001f,-0.30030000f,-1.58910002f,0.66360002f,0.76250002f,0.46419999f,-0.71800000f,-1.33560002f,0.70710001f,-0.52120001f,1.55550004f,0.49040001f,-0.10859998f,-0.28400001f,-0.63720005f,1.24040002f,0.49130003f,-0.77999998f,1.07799998f,0.79590001f,-0.88919998f,-1.07290002f,1.23550000f,0.46170003f,1.62390003f,-1.51510007f,0.63759998f,-0.05369996f,0.07459996f,0.48920002f,0.18769997f,1.82100003f,-1.23749999f,-1.21250003f,0.80240004f,-0.98520004f,1.23100000f,-0.15349998f,-0.57549996f,0.10689997f,0.50729997f,-1.26530001f,1.06050000f,0.40580000f,-0.39050000f,0.65210000f,-1.90369998f,0.12739997f,1.35170001f,-0.81869997f,-0.62260003f,1.30779997f,-0.64650000f,-1.57940002f,0.96440004f,1.05680002f,-1.28609998f,0.12739999f,0.75569998f,-0.47969999f,-0.47540000f,0.97740002f,-0.28080001f,1.09840004f,0.43889998f,0.89500002f,-1.12350001f,0.22500001f,0.10330002f,-0.59170002f,0.81270000f,0.66870000f,0.94600002f,0.21350002f,-0.29120001f,-0.40409999f,0.73979998f,-0.37520002f,-0.88169999f,-0.12399999f,0.06829999f,0.80850003f,-0.82329999f,-1.49820002f,1.60750002f,0.17300002f,-1.26610002f,0.25000001f,0.46480000f,1.60720001f,-0.56749998f,-0.87440003f,0.82989998f,0.44570000f,-2.56680001f,2.14670002f,-0.68150001f,-0.28820001f,-0.83640002f,-1.31940004f,-0.25450003f,-0.28409998f,1.61540002f,-1.84600003f,-0.37019997f,1.49810004f,-0.06060002f,-0.89719999f,0.96610000f,-1.35780001f,0.09690000f,0.39119998f,-1.94830001f,0.65600001f,-0.84610003f,0.20379999f,-0.33769999f,-0.30869998f,0.09329997f,1.41439999f,-0.91429997f,0.22019997f,-1.18140003f,0.35480003f,0.21350000f,-0.76109999f,0.31749997f,0.73149995f,0.31230001f,-0.77690000f,0.21759993f,0.38490005f,-0.24029999f,-1.45180007f,0.75720002f,-0.28999996f,1.53229999f,0.18929999f,-0.36079997f,-0.36309999f,0.06920000f,-1.00640000f,-0.64010000f,-0.09090004f,0.23879996f,0.02220000f,1.50790005f,-1.25440004f,-0.38330002f,0.67940001f,-0.05329999f,0.20419999f,0.29589997f,0.84640001f,0.76690001f,-0.26890002f,-0.28360003f,-0.19179999f,0.69530005f,-0.12060007f,0.86229999f,-0.22259993f,-0.59480005f,1.86280002f,-2.09459999f,-0.45100001f,0.72170001f,-1.76430001f,3.31450005f,-0.07499998f,0.59590002f,0.70880000f,1.19550003f,-1.24639998f,0.86719993f,0.56430003f,0.69080001f,-1.08740003f,0.63030001f,0.85880000f,-0.97159999f,1.00729999f,0.24019997f,0.47830000f,-0.34470003f,-1.16349998f,-0.35119997f,1.16799995f,-0.18790000f,-1.81929998f,0.67880000f,0.04959998f,0.35370005f,-1.91630003f,-1.22010001f,0.96569998f,1.68300000f,-1.39709999f,-0.88260001f,1.78990003f,-0.58599997f,0.84929999f,0.36280003f,0.53339997f,0.22550003f,0.80329997f,0.38890004f,0.43170008f,-1.00080009f,-0.15050000f,0.54830004f,0.52690002f,-0.29280002f,0.04829999f,1.36180002f,0.57880000f,-0.46729996f,-2.51350006f,0.56320003f,-0.43529997f,0.38770001f,-0.25620000f,-0.44390001f,0.70020001f,-0.60370000f,-0.27470002f,-1.31510001f,0.55339998f,1.10569996f,-0.62939993f,0.48810000f,-0.32330008f,1.81200007f,-0.94290003f,-1.20549999f,0.99520002f,-0.12370004f,-0.78570001f,0.54950002f,0.47140000f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.28169998f,0.20349994f,-2.00950005f,0.14969994f,-0.83510001f,0.31580004f,0.66000001f,-0.53149998f,0.75249998f,-0.64150000f,0.34690006f,1.12629995f,-1.59109998f,0.40890001f,-0.19160001f,-0.57170000f,-0.34329999f,1.19510003f,-0.67049994f,0.89710002f,0.72550004f,0.67520000f,1.40899998f,0.79289997f,-0.47210000f,0.05870002f,-0.26870001f,-0.25220001f,1.24839997f,2.20039998f,0.49030001f,-0.01500001f,1.56429998f,1.37560002f,0.78950000f,0.86750001f,0.02109999f,1.10299998f,-1.09770001f,0.26299998f,0.03669995f,-0.72979999f,-0.28159998f,-1.73320002f,0.37539998f,-0.26060002f,-0.15999999f,0.39999993f,-0.06909997f,0.07330000f,-0.01739994f,-0.07359997f,0.17430002f,0.03470000f,0.06870001f,1.95070001f,0.59079997f,1.92249996f,0.57299997f,1.34399999f,0.27610003f,1.25889999f,0.87130002f,-1.31609999f,-0.00979999f,-0.22980004f,-0.59719998f,0.92479998f,-0.11619999f,0.51659998f,-0.58839997f,1.05160003f,-0.12969998f,-0.96780006f,1.41810002f,0.06999996f,-1.66780001f,1.85770000f,-0.22470001f,-1.24500003f,0.59719996f,-1.61960000f,-0.55519997f,-0.21849999f,0.64909998f,-0.34779996f,0.16149999f,0.99950001f,0.57489996f,-0.28270002f,0.27639998f,-0.12710002f,-0.16490003f,-0.44680002f,1.49969995f,-0.20659999f,-0.66570002f,0.43269999f,-1.47720001f,0.97119997f,0.36480000f,-0.24609997f,0.15059998f,-0.01369998f,0.42429999f,-0.88140001f,-0.90129998f,-0.15759999f,-0.86320000f,0.05009999f,1.08099998f,-1.46889998f,0.95969998f,-0.31970001f,0.49489997f,0.95099998f,0.21170001f,0.26950004f,-0.03949998f,0.22289999f,-0.67320003f,-0.81020000f,-1.38260003f,0.29229997f,0.64970003f,-0.75019999f,-0.24340000f,-1.63340001f,1.72740002f,0.58370002f,-0.73960001f,-0.51180003f,-0.27910001f,-0.85229998f,-1.05309999f,0.18470001f,-0.28240001f,-1.73679997f,0.16020004f,-0.90700000f,1.01680002f,0.43229999f,-1.16669999f,0.03170001f,-0.75800002f,-0.66130001f,0.66240000f,-0.16770002f,0.11610001f,0.40769996f,0.59980003f,0.04760002f,0.28789996f,1.31339997f,-0.96699997f,0.77089997f,0.34479999f,0.24419997f,-0.87830002f,0.54009992f,0.15630002f,-0.90520000f,-0.29240003f,-1.51040005f,-0.70229996f,-1.17190002f,-3.07300004f,-0.26690001f,0.24410000f,0.66109999f,0.10950001f,-0.13170001f,-0.39969999f,-1.15160001f,0.08750001f,-0.23299998f,-0.68920003f,-0.26660000f,0.33610001f,2.02360004f,0.86470001f,1.85719999f,-0.15320000f,-0.47560003f,-0.01759998f,0.68879997f,0.07829999f,-0.47399998f,-0.33740002f,-0.01780001f,-1.52449996f,-1.53879999f,-1.38439996f,-0.10820003f,-0.28720001f,-1.53500000f,0.54630003f,2.28439997f,-0.87949991f,1.96450001f,0.91149998f,1.43940007f,0.91989999f,0.55140004f,0.68250000f,-1.39220001f,1.86080003f,0.00310003f,-0.74290002f,-0.92739999f,0.82029998f,0.38270002f,1.10640000f,1.17219996f,1.65830002f,2.21669998f,1.63830001f,1.05890001f,-0.59009999f,0.26529998f,-1.30490003f,-0.22640000f,-1.26009995f,0.15849997f,-0.07499997f,0.10239998f,-1.05360000f,-0.83019995f,-0.35019998f,-1.68089993f,0.00370002f,0.69129999f,-0.24920001f,1.49540004f,0.81719996f,-0.42209996f,1.44900000f,-0.08949997f,-1.45240007f,-2.61280000f,1.17229999f,0.42459999f,1.32459996f,0.54269998f,0.26819998f,1.00530001f,0.06890003f,-0.02689999f,-0.02650004f,-0.19430002f,0.98209996f,-1.06240000f,-0.70120002f,0.41009993f,-0.92510001f,-0.11099995f,0.48199998f,0.43040002f,1.31979997f,1.34540003f,0.57119999f,-0.79080002f,1.62509999f,-0.59979998f,-0.19920001f,0.70810002f,-0.35519997f,0.90869996f,-0.91330005f,-0.54690001f,-0.10180003f,-2.61409998f,0.69209993f,-0.37839999f,0.12159998f,-1.51549999f,1.07479994f,0.02530004f,-0.10180001f,0.44210001f,1.08880001f,-0.24949999f,-1.32279998f,-0.30070001f,-2.01089998f,-1.57369995f,-0.68009999f,1.77390001f,1.08759998f,0.35379998f,1.51620002f,0.52690000f,1.69949996f,1.00300000f,1.60370002f,0.02289997f,0.19799999f,0.28890001f,-2.32189996f,-1.35359995f,1.10109995f,-0.72730001f,-2.54330001f,-0.42920001f,-2.06159997f,0.63170005f,0.09070005f,0.88530002f,0.06410004f,0.03969995f,-0.90010002f,0.94110000f,-0.71130003f,-2.37390005f,-1.21620001f,0.35760001f,-0.90750001f,1.27590003f,-0.06050004f,1.12749997f,2.48900000f,-0.66439996f,0.52260000f,-0.35440000f,-0.00860001f,-0.15559999f,-0.75390002f,-0.48899999f,-0.80279998f,-0.54070002f,-2.26989996f,-0.60429996f,0.18119998f,-2.09579996f,0.81259998f,-1.18900000f,1.46430003f,0.95470002f,-1.02559998f,0.08490001f,-0.73930002f,-1.50700000f,-0.42120001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.42350003f,-0.66310003f,-1.73030004f,-1.10910004f,0.47780000f,0.18049996f,0.23430005f,-0.99130005f,-1.02500000f,0.24259997f,-0.26300002f,0.48800000f,-0.56120001f,-1.41900001f,0.33009999f,-1.12800003f,1.25480004f,1.51590004f,0.10740005f,-0.21100003f,-0.69290001f,1.22330003f,0.43470003f,0.37150003f,0.19159999f,-0.55680000f,0.00050003f,0.44529998f,0.18499999f,0.10499996f,1.78680003f,1.22390004f,-0.75529998f,-0.92960004f,0.93210002f,-0.97330003f,-0.28639998f,0.92579998f,0.25659999f,-0.55779995f,-1.04490003f,0.28359999f,-0.70820000f,-0.19380002f,-0.43140001f,0.54779998f,0.03199996f,-0.45339998f,0.32920002f,0.15730001f,-0.80750006f,-0.23599998f,-0.12300001f,-0.91650004f,1.83440007f,0.25390001f,1.24890002f,-0.68470005f,1.16030001f,-0.86910002f,0.23109998f,0.62939999f,-0.90789998f,-0.35670000f,-0.46090002f,0.17390000f,0.36450001f,0.09850000f,-1.13900001f,0.07059998f,1.79430004f,-1.04519999f,0.70180004f,1.01869995f,-0.40639999f,-0.15390001f,-0.34599999f,-1.18960006f,1.19280000f,0.72480002f,-1.54310002f,-0.09899998f,0.98640002f,-0.04680000f,-1.84740002f,1.76719999f,0.93229999f,-0.78089999f,0.59720000f,-1.08440005f,-0.40629999f,-0.51970004f,0.39540000f,0.45400000f,-1.60920002f,0.65900000f,1.22160002f,-0.67300004f,0.69590000f,0.17139999f,0.33410003f,0.68410005f,-1.02830006f,-0.92190000f,0.58380000f,0.49310000f,-0.96930001f,-1.52240007f,0.53090004f,0.19450000f,-0.21269999f,-0.01280002f,0.37249997f,0.35750001f,0.85830003f,-0.62350002f,1.50960009f,1.70700001f,-0.81500002f,-0.25499999f,-1.25040003f,-0.76259997f,0.21300001f,0.07999997f,1.55010000f,-0.08220002f,-0.99770007f,0.39600006f,0.24609997f,0.15530002f,1.17950001f,-0.48379997f,-0.85530004f,-0.58510002f,-1.62810002f,0.34140005f,0.48840000f,-0.05450005f,-0.53520003f,-0.80859999f,-0.43680002f,1.06710001f,-0.83520002f,-1.17250004f,1.17420005f,-0.26010002f,-0.41020002f,0.10299996f,-1.97340006f,0.86050005f,-0.79200004f,-0.28920000f,0.30450000f,-0.29349999f,-0.61740000f,0.77950005f,0.51319996f,-1.87100006f,0.48100005f,0.70059998f,-0.76380001f,0.38450001f,0.04579998f,-0.26959997f,-1.76980010f,-0.23079998f,0.39070000f,-1.58350004f,-0.33740000f,0.14540000f,0.01170002f,0.53710001f,0.67039999f,-1.54770001f,-0.20729998f,-0.99440002f,0.31300003f,0.70670003f,-0.12630001f,-0.37240002f,2.29400005f,0.27179998f,0.16320001f,-0.77519999f,-1.91530007f,0.70040008f,0.74129998f,-1.54100004f,-0.07479997f,-0.38440001f,0.22730000f,-1.00410003f,-1.67930005f,0.21520001f,1.70460003f,-0.40090002f,0.71310005f,-0.46490002f,0.99730003f,-0.89890004f,-0.05349996f,1.78900002f,-0.04870000f,0.68930005f,0.60030000f,-0.88629998f,-1.30250003f,0.95850003f,-0.10710000f,-0.33940000f,-0.33730003f,0.34010002f,1.11210000f,-1.35320001f,1.12260005f,0.89829998f,-0.30810001f,-0.71680004f,0.95580003f,-0.48200002f,-0.81019999f,-1.29770003f,-0.56570000f,1.20290000f,-0.28440000f,1.53810010f,-0.82430005f,-1.26500000f,1.43120002f,0.27730001f,-1.83460001f,0.93980002f,1.24479999f,-1.25750000f,0.56670002f,1.66389999f,-1.26070000f,0.03820001f,-0.30740000f,0.21039997f,-1.19130007f,1.06320003f,0.05700000f,-0.73500003f,0.63310000f,-0.33930001f,0.55200000f,1.89200007f,0.62839998f,-1.40360006f,-0.03759996f,0.57640000f,0.24410000f,-1.12939999f,1.99070003f,0.63919996f,0.41070002f,0.00479996f,0.37360004f,1.10609999f,0.13800001f,-0.01449998f,-1.19890001f,1.48420005f,0.75390000f,-0.46749997f,-0.23710001f,0.76760002f,-1.15290001f,0.38730003f,0.31869996f,-0.44660002f,-0.81119997f,-0.39229998f,-0.88010003f,1.31840002f,0.09029998f,0.48790006f,0.19339999f,0.03740002f,0.34520003f,0.53879999f,-0.24360000f,-0.82440003f,0.34480005f,-0.55160004f,-0.30739999f,0.42480001f,2.25940004f,0.17280002f,-1.73790006f,1.68630007f,0.89980000f,-0.75790001f,-0.42130004f,0.67600004f,0.32230002f,-0.72370003f,-0.46820001f,-0.87930002f,-0.25839999f,-0.79880004f,-1.11039999f,-0.42900002f,0.86120006f,-0.39400004f,0.33260005f,0.89620002f,-0.89459999f,1.01910000f,-0.42240005f,0.11570005f,0.37640000f,-1.01330002f,-0.45560003f,0.25960002f,0.58429998f,-0.58900001f,1.18660003f,0.09480001f,-0.25629999f,1.20029996f,-0.85020005f,-0.27000000f,-0.07120002f,-0.93250000f,-0.41589997f,0.36489999f,-0.38210000f,1.48740001f,-0.62010003f,-0.70199994f,-1.19640011f,1.10810007f,-1.26800007f,-0.49320001f,-0.34989995f,1.72980003f,1.00120001f,-1.27370001f,-0.06279999f,-0.18950002f,-1.43410002f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.30270002f,0.32629999f,1.01289997f,0.27300000f,-0.17370002f,0.01630004f,-0.86920003f,0.35320000f,-1.10970002f,1.66880003f,0.42840003f,-0.92380001f,-1.04200004f,-1.41330001f,0.02899997f,0.38630001f,0.28890001f,-0.66370000f,0.06220001f,-2.44530002f,0.38850000f,-0.11180001f,-0.72890002f,-0.45620001f,0.38630003f,-1.91610001f,0.53999998f,-0.66770004f,0.19539998f,-1.70549999f,0.10560000f,-0.46650002f,-0.21400000f,-0.25909998f,1.61360001f,-0.41970001f,0.00440003f,2.11799999f,-0.30769998f,-0.01389999f,-0.63690002f,-0.02709998f,0.64729998f,-1.82690002f,-0.33200000f,0.60010003f,0.39559999f,1.11440001f,-0.77029999f,1.51270004f,-1.40880008f,0.20060003f,0.25910001f,-1.94699999f,-0.19260000f,-0.00819999f,-0.43700001f,0.18700003f,-0.89480000f,-0.57590002f,0.00250001f,0.24739999f,-0.39099998f,-0.29040004f,-2.01030001f,1.14450003f,-0.54290000f,1.32359999f,-0.87330001f,-0.13420001f,-0.18539998f,1.38139999f,-0.10160001f,-0.23009997f,0.69199997f,0.72040004f,0.89210002f,0.44330002f,0.42799997f,-1.29650004f,0.61110001f,-1.70000002f,1.57650004f,-1.31940001f,-0.61160003f,-1.00949999f,-1.03980000f,0.67350002f,-0.79069999f,0.47519997f,-1.66860001f,-0.06500001f,-1.51640003f,0.90080004f,0.06649998f,0.85319999f,0.57099998f,0.07580002f,0.28670000f,-0.31910003f,-0.07939999f,-0.09599999f,-0.24609998f,0.17310006f,0.21869995f,0.38240000f,0.06059999f,2.15740001f,-0.29550001f,-0.06769994f,-0.05010002f,-1.24250001f,-1.11540003f,1.79610000f,-1.17669999f,0.46740000f,1.04270006f,-2.24280009f,-0.00869995f,1.08550005f,-0.84790001f,0.30060000f,-0.63169999f,0.39740002f,-0.16289996f,-0.05379999f,-0.03340000f,0.98110002f,0.08339998f,1.18390000f,0.93099999f,0.08830000f,0.00440004f,0.66479998f,-0.70520000f,-0.56040004f,-0.06939997f,-0.06530002f,-0.17429998f,-0.50129999f,-0.64870001f,1.25630003f,-1.58050006f,-1.17390001f,-0.94419998f,-0.36359997f,0.48450001f,0.74510002f,0.77190000f,1.56140002f,-0.76560003f,-0.13249999f,-0.65100003f,-0.02629997f,-1.07359997f,0.41259999f,-0.20000001f,0.32800003f,0.68550001f,-1.41570000f,0.00359995f,-0.51930000f,0.78150004f,0.91770003f,0.22219999f,0.13310002f,-0.45550002f,-0.08059999f,-1.02759999f,-1.36430003f,-1.53820003f,2.87630004f,-0.81420001f,0.94329996f,-0.73170001f,-0.67450003f,1.01370009f,-0.22700002f,-0.56219999f,-0.95689996f,1.62469999f,0.23040003f,0.21839995f,0.51509999f,0.07949997f,-0.22439999f,-0.04490004f,0.34190000f,0.04020000f,0.74120000f,-0.99050000f,-0.33239997f,-0.69000007f,-1.51669999f,0.08349995f,0.18589997f,-0.45260003f,0.70210001f,0.54529996f,-0.20340001f,-0.71669993f,-0.27829998f,-0.43370000f,0.06210000f,1.26559998f,0.07879998f,-1.14040001f,0.51440003f,-1.66589993f,0.27370003f,-0.94990003f,0.48360005f,0.56769999f,-0.65250000f,-0.78669994f,0.46939998f,0.18539999f,-0.35510003f,-0.16329999f,0.98800000f,0.59090000f,-0.31600000f,0.45080005f,-0.35450004f,0.51109999f,1.59300001f,-0.55710005f,0.98610002f,0.30699999f,-0.32999999f,-0.13019999f,-1.24510001f,1.22610000f,-0.06600002f,1.47330002f,0.16670000f,1.21310004f,0.78210000f,-1.36799999f,1.36220004f,0.45579998f,1.06270001f,0.00270001f,-0.61709999f,1.18480002f,-0.85159999f,1.01140003f,-0.08110000f,-1.60500001f,1.01049996f,-1.64669998f,1.93950003f,0.31120002f,-0.97210002f,-0.30350002f,-0.21460000f,-0.16570004f,-0.82410003f,0.60630001f,0.42209998f,0.99680002f,1.08810002f,-0.07490001f,0.14190005f,-0.43630001f,0.58820001f,-0.22480001f,-0.34730000f,0.21080001f,-0.24199997f,-1.45100000f,-0.37969998f,0.04929997f,0.59020002f,-1.70480000f,0.62430004f,-0.29410002f,0.22969996f,0.20370002f,-1.03229999f,-0.01699995f,0.76770002f,-0.50760000f,-0.55950004f,-1.36210000f,0.60980002f,-0.22180000f,1.25320005f,-0.04540002f,-0.65830001f,-1.10450003f,0.52480006f,-1.03740006f,-1.63969997f,-0.22260002f,-0.65250001f,-1.30030000f,1.24620003f,-0.73149999f,1.33510002f,0.36599998f,-1.56940002f,1.50320002f,-0.82250001f,0.74720001f,-1.11879997f,-0.89060001f,-0.93329997f,-0.37460002f,0.85160004f,0.22239999f,-1.60070000f,-0.19809997f,-0.00429999f,-0.85379999f,0.25319999f,-1.11260002f,-0.07789998f,0.12259995f,-0.97659999f,1.99479998f,-0.37609999f,0.14499999f,0.48319999f,1.32519997f,-0.09830000f,1.35389998f,-0.84749996f,2.25319998f,-0.69499998f,0.78469999f,0.70480004f,1.69570000f,-0.26770002f,0.27240004f,-0.31390001f,-0.01070002f,1.33460002f,0.03940002f,0.12590002f,-0.28230003f,1.67180001f,0.38849999f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.67760002f,1.13380003f,1.27510001f,-2.13930003f,-1.91689996f,-0.16410000f,-0.71480003f,-0.14880005f,0.80470006f,-0.02219993f,0.45030005f,-1.03650005f,0.39149996f,0.17789999f,-1.43360001f,-1.05120005f,1.25960004f,0.51349999f,1.24799997f,1.14739999f,1.22010002f,1.84200003f,2.38470001f,-1.10490004f,-1.06849997f,0.23650003f,-1.51070005f,-1.91120006f,-0.67989999f,-1.00149997f,-0.07279999f,0.66689997f,0.32269999f,0.03130004f,0.48780002f,0.46939996f,0.43450001f,-0.41490004f,-0.45010007f,0.35810008f,-0.04500006f,0.34690007f,-0.46870003f,0.14470000f,-0.38619996f,0.32889999f,-0.25390001f,0.06119999f,0.45590000f,0.87720001f,1.61959998f,-0.95049997f,-1.58460002f,-0.76130000f,0.23289997f,2.06000004f,0.88000002f,-0.13849996f,0.34860004f,0.71559996f,1.78720015f,-1.32000008f,-0.66649998f,-0.29500000f,-1.63829995f,-0.16039993f,0.57380005f,0.83990002f,-0.03180002f,-0.48719997f,0.37089996f,-0.87309998f,-0.76250005f,0.50350005f,1.02639994f,-1.77680006f,-1.33040005f,0.79880000f,0.60379999f,-3.78380010f,-2.39720001f,-2.37900005f,-0.84940005f,1.10060003f,-0.18550000f,1.63670009f,0.49670002f,0.86180003f,0.60150004f,-0.20140004f,-1.15480001f,-1.04860001f,-1.35000003f,-1.26460002f,-1.27440003f,0.10960001f,-0.20340002f,-0.90240000f,0.47210002f,0.37839999f,1.94290004f,1.61110012f,-0.79140001f,1.16090014f,1.32610000f,1.71240004f,0.17189995f,-1.55330000f,-0.63800006f,-0.50230003f,4.19100000f,2.58630000f,-0.04089998f,-0.36570005f,1.89420015f,0.74879999f,0.08560003f,-0.24749995f,0.12960000f,-0.40370001f,0.06789998f,0.64249992f,-1.87870002f,-1.91440004f,1.17750005f,1.92230002f,-0.08200001f,-2.57100009f,-2.12969994f,-1.49260004f,-1.13670001f,-0.68410009f,-0.31639997f,1.29060008f,0.54800002f,-0.25489997f,1.44290009f,-0.27110001f,0.73320003f,0.73809999f,1.48160002f,0.26609999f,-0.08649994f,-0.88120001f,0.11600007f,1.56440001f,1.18720000f,0.06380000f,0.12929999f,0.20649999f,-1.63440010f,-1.54339995f,0.56279998f,-0.48699999f,-0.06280002f,-0.16720002f,-1.08020005f,-3.49470000f,-1.24960006f,2.38880004f,2.30870004f,1.88500006f,1.74650001f,-0.11659999f,-1.99720006f,-1.45890003f,1.05180002f,-0.52870004f,-0.53590005f,2.11020000f,-0.01559999f,-0.99490001f,-1.36259996f,0.65650000f,-0.31900007f,-0.57440007f,0.91960002f,1.95200003f,0.45069996f,0.29060006f,0.57079998f,-2.02190009f,0.11150003f,-0.65289999f,-1.15010000f,1.10169998f,-0.43769997f,-0.85299998f,-0.40869992f,0.55930006f,-0.53800000f,0.12700008f,0.06050000f,-0.67029998f,-0.46119997f,-0.04900000f,-1.61280000f,-1.25419998f,0.17419999f,0.05860000f,-1.14850000f,-1.64919998f,-0.49890005f,0.10530004f,-1.09200002f,1.08579997f,0.19899997f,0.48579998f,0.28750001f,2.09590000f,-1.26100003f,0.32960002f,1.22890001f,-0.00090005f,0.83060002f,2.21600004f,0.27929998f,0.22520003f,-0.78700006f,0.10940000f,0.36719997f,-0.15360003f,0.58210005f,2.10190002f,-1.26650006f,-0.69409997f,-0.53090005f,-1.71410007f,-0.49230003f,-0.45650003f,-0.59570005f,-0.34419999f,0.27359999f,-1.59300004f,-0.17149999f,0.45509995f,-0.24520003f,0.28780002f,-0.73340003f,1.41210006f,2.25470003f,-2.08790010f,-0.93080002f,0.09299998f,0.67219996f,2.55340003f,-0.23380000f,-1.04810003f,-0.99249991f,-0.45390005f,-1.55000002f,-0.42850006f,0.33090002f,1.75990003f,0.75900003f,-1.42390005f,-0.07379994f,0.02400007f,-2.04290006f,-1.00770006f,-2.28510014f,-1.57980003f,-3.20900011f,-1.41489999f,1.60210008f,0.93949999f,2.80540005f,1.48289999f,-0.66220002f,0.90150015f,0.19740000f,-0.34679997f,0.02969997f,-0.14410000f,-0.75299998f,-0.18550006f,2.41520001f,-0.57610008f,0.10130004f,0.32660006f,0.19129996f,0.45750003f,1.02700004f,0.46849999f,1.32240002f,-0.04069998f,0.22420003f,-1.09830000f,-1.75890000f,-0.51670003f,0.69469999f,0.00289999f,2.46040007f,1.11980001f,-1.21770001f,-0.59220001f,-1.65500010f,1.22630008f,1.08130000f,0.42340006f,0.41399993f,-1.18770004f,1.06770001f,1.73900005f,2.08980004f,3.37910010f,0.02919999f,-0.85470003f,1.10250000f,-0.36240000f,1.19650002f,1.76250001f,0.27429995f,0.74570002f,1.07980001f,-0.29290004f,0.32829999f,-2.23250001f,0.15080005f,-0.16649998f,0.10490005f,-0.18040001f,-0.25969999f,-1.58720002f,-1.25590005f,-2.22999998f,-0.38430002f,-0.99249995f,-0.70370001f,-1.89680005f,-1.67859997f,0.45449997f,0.32580002f,-1.00050005f,0.58290003f,0.65990001f,0.95160001f,0.12819999f,-0.74110004f,1.58280000f,1.26669997f,-1.45540003f,-2.60780006f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,-0.66560000f,1.30049996f,0.25509999f,-1.04170002f,-0.05299998f,-0.35100002f,0.06349999f,-1.31520008f,0.31100006f,-0.51569998f,-0.56240006f,0.78389999f,0.85629996f,-0.29489998f,-0.48779999f,-0.12269998f,2.21130006f,-1.31330000f,0.33520001f,2.40440001f,-1.96370001f,1.49590003f,0.76380000f,-1.50950004f,1.30990003f,2.60500003f,-1.78030002f,0.24509999f,-0.91000002f,0.79110001f,-0.42010001f,-0.76620002f,-1.22650001f,-0.38279998f,-0.61490001f,0.30600000f,0.54290001f,-2.36970001f,1.07319998f,0.70200005f,-0.32260002f,0.81530001f,-0.79680001f,0.56159999f,-0.04569997f,-1.02640007f,-0.77089999f,-1.46700001f,0.94960001f,0.36460000f,1.87920003f,-1.25019998f,-0.74480003f,0.41749995f,0.03190003f,0.32390000f,0.11950001f,-0.53870003f,-0.64580002f,1.76850004f,0.76280003f,-0.68229999f,0.74089994f,-1.02729999f,-0.52430003f,-0.55499999f,0.93219997f,-0.61670001f,-0.21740001f,-0.02919999f,0.56769998f,-1.44849997f,-0.18889999f,1.75119998f,0.06430003f,-0.73610001f,-0.41660001f,1.78020002f,0.51610001f,-0.04080000f,0.01960000f,0.51789999f,-1.83760004f,0.66020001f,0.15520004f,1.17339997f,-1.10890000f,-0.47149999f,1.89089996f,-1.60120000f,0.28150002f,0.62359999f,1.13540002f,-1.33550000f,-0.14680002f,0.20719999f,-0.65900000f,-0.64140000f,-0.32060000f,-0.52160003f,0.90929998f,-1.39070002f,-1.74900004f,1.95450002f,-0.04309999f,-0.14769999f,-0.47900001f,-1.58320000f,-0.02839999f,0.14380002f,1.06950004f,0.51069999f,0.38780001f,-1.42280000f,1.93770000f,-1.12659996f,-1.34300004f,0.22690002f,0.18350000f,1.08000003f,2.58840003f,-0.19739999f,-1.30599998f,-2.27180007f,1.21240003f,0.50179999f,0.36839998f,-0.87679998f,0.91830002f,1.03930002f,-0.37540002f,-0.51679997f,1.22810003f,-0.25430001f,-1.27880010f,1.03210008f,-0.97970003f,-0.73810003f,0.29899999f,0.21720002f,0.93470000f,-0.51689999f,-0.03560002f,-0.43400001f,0.68380001f,0.45629997f,-0.22499999f,0.27650005f,1.39530003f,-0.53340005f,0.67010002f,0.43860003f,0.36830003f,0.13830000f,0.62410000f,0.31700004f,-0.07560004f,-0.98969999f,-0.02430000f,1.89480003f,-0.89989994f,1.22280003f,-0.21620000f,-0.56360003f,0.12210000f,1.83070006f,-0.30929999f,-0.16919997f,0.00019995f,1.12150007f,-1.54090005f,-2.02490001f,1.96310001f,-0.18500003f,0.21610002f,-0.13810002f,0.71870002f,-0.66040000f,0.06979999f,1.82480002f,-0.45079999f,0.18679996f,0.04100002f,0.17630002f,-0.34230006f,0.44109999f,-0.70839998f,-0.19530005f,1.46150000f,-1.46479998f,1.06809999f,1.01829999f,-0.97180001f,2.13379998f,0.44850001f,-1.60650003f,-0.39550001f,0.80639998f,0.82580002f,-0.24670001f,-0.61390002f,-0.49360002f,0.93359998f,0.59630002f,-0.59419999f,1.51959999f,0.17320003f,-2.13519999f,1.19369998f,0.23159998f,-0.28660002f,0.52749999f,-1.09420002f,0.25239997f,0.14500004f,-1.01359997f,0.17799998f,-0.43799998f,0.15710001f,-0.14090001f,-1.33070004f,0.33550002f,-0.12429998f,-0.94510000f,-0.17469999f,1.27690003f,0.31110000f,-1.11669999f,1.71690000f,-0.73580004f,-1.23009997f,0.89030000f,-1.84629999f,0.40760000f,-0.88410002f,-0.43240001f,0.00469999f,-0.23569998f,-0.18719999f,0.56910006f,-0.22880001f,-2.66640009f,0.83240003f,0.47360004f,-0.70780002f,2.27350004f,-2.75890004f,0.83230001f,1.42000000f,-0.56439999f,0.27439997f,-1.28040000f,-0.44490001f,1.35500005f,0.73210002f,-1.01360005f,1.31070006f,-0.28750002f,-1.09450004f,-0.13359999f,1.37530001f,-0.60490001f,-2.05120001f,0.76479999f,-0.00489999f,-0.65060002f,1.28279996f,-1.44370004f,-0.74170000f,0.70790001f,0.11389997f,0.16969997f,0.06560000f,-0.53090003f,-0.62189998f,1.09200000f,1.66520002f,-1.99050001f,0.14710000f,1.05490002f,-0.42990002f,-0.25309996f,0.45810001f,1.00529997f,0.65909999f,-0.06559995f,-0.61250006f,-1.77890005f,0.76419998f,1.31700003f,0.77970001f,-0.01989998f,0.27389999f,0.03659999f,0.19119999f,-1.23960007f,-0.06050001f,-0.46070000f,0.21670001f,-1.59690003f,0.15739999f,-0.36050001f,-1.04059998f,0.65879999f,-0.04319998f,1.37800000f,-1.50050002f,-0.49480003f,1.18830000f,-1.51049998f,0.84530002f,1.43349999f,-1.14520001f,1.27690002f,0.24309998f,0.74889998f,0.29360001f,-0.60849998f,-0.53970006f,1.41690003f,-1.41069998f,-0.03810004f,0.62000000f,-0.31920001f,0.19529999f,0.72110001f,-1.32409997f,1.14750002f,-0.82139999f,-1.85940003f,0.20370004f,0.52209995f,0.06980003f,0.04609998f,-0.70319998f,0.24090001f,0.97280004f,-1.65399996f,-1.04270006f,2.09780001f,0.74130004f,-1.74860004f,0.75170004f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.33610003f,0.90590004f,0.57049997f,1.20340000f,0.48690000f,0.25840004f,0.76010005f,2.11440001f,0.75079999f,-0.38190002f,-0.06960001f,-1.31469996f,1.56160004f,1.22879998f,0.62079999f,-1.20140001f,-2.60890002f,0.38539996f,-1.59499998f,-1.13559996f,1.20859993f,-1.52510002f,-1.46899998f,-0.34990000f,-1.23260000f,-1.32090001f,1.02550000f,0.98720000f,1.50709997f,0.79210000f,2.20019997f,2.22740000f,2.60779995f,1.57229995f,1.07129999f,1.42289998f,0.83850000f,1.54629996f,-0.44490001f,-0.36030000f,-1.23890003f,-0.34239999f,0.43590004f,0.72970004f,0.61060004f,1.20000004f,0.71790001f,0.43420002f,-0.75769997f,-0.78610000f,-0.40059998f,-0.31179999f,0.04600002f,1.16610011f,-0.51669999f,0.53299998f,-0.59430001f,0.34299997f,-0.06940000f,-1.59199999f,-0.54040002f,-1.05600003f,0.82670008f,2.09500000f,1.52930007f,0.49340000f,0.05770005f,0.47279998f,0.05350003f,0.19919999f,-0.68579998f,0.57529998f,-0.70490001f,-1.28509994f,-0.51170003f,0.00570000f,-0.62470000f,-1.97050001f,0.36649997f,1.05520005f,1.89420003f,1.41590005f,2.77650002f,0.89930001f,0.55639999f,0.52230003f,1.23909997f,0.46659998f,-0.96620000f,1.98889993f,0.17270002f,1.14040002f,0.72780004f,2.07149999f,1.71130001f,1.11990000f,0.87419999f,0.73780001f,0.53310002f,1.50570003f,0.05840002f,1.18359998f,1.06269996f,-1.39020001f,-0.38790006f,0.38950001f,-0.71310000f,1.33729998f,-0.56229998f,-1.21319997f,-1.14590002f,-1.00919997f,0.51560002f,0.77819997f,0.64349998f,-0.75920007f,0.61180002f,0.69250001f,-1.37949998f,-1.76040005f,-1.77069996f,0.70869992f,0.78760002f,0.85770000f,-1.47740001f,-1.42570001f,-0.56160001f,-0.72760001f,-0.48729998f,-2.10650002f,0.53650001f,-1.32990000f,-2.24129995f,0.48529999f,1.64730003f,-0.67080001f,0.13120000f,-0.26660000f,0.26170001f,-1.35010001f,-0.87190003f,-0.58490005f,0.81590003f,0.03620002f,0.68750003f,0.30359998f,0.91449997f,-0.39420001f,-1.25799999f,0.20539999f,-0.96020000f,0.88170001f,0.19749997f,0.23800002f,-0.55780001f,-1.47480000f,0.60180003f,0.72779999f,0.00300001f,-0.29929998f,0.11849995f,-0.85869999f,-1.49920005f,-0.55570001f,-1.11170001f,-1.15510001f,-0.47350003f,-1.58500001f,0.39400002f,0.19449999f,1.65060004f,0.82689994f,0.29110005f,1.64509996f,0.23049999f,-0.27139998f,-1.43450000f,-0.95019999f,-0.62560000f,-1.83229998f,-1.13490006f,-0.31619999f,0.65640001f,-0.47249997f,2.17660004f,-0.49119997f,0.60000003f,1.31400002f,0.11490002f,0.36429997f,-2.19299995f,-1.47729997f,0.13880001f,-1.00629996f,1.07020001f,2.16999998f,1.07389999f,0.10880004f,0.46990005f,0.83320000f,-0.74309999f,0.19550005f,0.34880002f,-1.05410001f,-1.18619999f,-1.31969997f,-0.88299995f,-0.15070000f,-2.13139990f,-0.79799998f,0.20180003f,-1.28499998f,0.21090000f,0.69669997f,0.20029995f,-0.02770007f,0.20059998f,1.58600000f,-1.02409997f,0.61060000f,1.04670001f,0.13029995f,0.05700000f,-0.10980005f,-0.73740001f,-0.27689999f,0.43560001f,-0.48069997f,-0.65100000f,1.59510002f,-0.52780001f,1.03790001f,1.71059995f,0.79120004f,2.30989996f,-0.03909999f,-0.72700002f,-0.54740004f,0.94120002f,0.01959996f,0.56099999f,1.33140001f,-0.71700002f,-1.72299998f,-0.24900002f,-1.06400001f,0.67739997f,-0.84880000f,-0.01819994f,0.60299997f,0.82940008f,0.34189999f,-0.03110003f,-1.56390005f,-0.42160003f,0.30800000f,-0.37500003f,1.02760004f,0.49309999f,0.55580001f,-0.24899999f,2.26320002f,0.82210003f,-0.39269996f,-0.13820001f,-0.40260001f,-0.15499997f,0.43580001f,0.07690000f,-0.73709997f,-0.83809999f,0.28680004f,0.18920001f,0.22879997f,0.22799997f,-1.65639998f,-0.03680002f,1.08779997f,0.11780000f,-0.85989998f,-0.91560002f,-0.94650003f,-2.25450000f,-0.67669995f,-0.41309999f,-0.84830001f,1.26180002f,-1.59700002f,-1.98800000f,-1.24599996f,-1.47109999f,-1.08570003f,1.61009998f,-0.15519999f,-0.53279996f,0.59870003f,-0.87549993f,0.98859999f,-0.28470003f,0.83140000f,-0.34020003f,1.13720002f,0.31659999f,-0.98059997f,-0.37070004f,-1.87979998f,0.73839999f,0.35110001f,-0.88340000f,-0.75870001f,-2.42509998f,-1.02599997f,-0.94099999f,-1.74369999f,-0.57369999f,0.20140002f,0.03909998f,-0.69519999f,1.77930001f,-1.12579998f,0.73399998f,-0.30749996f,-0.02619999f,0.72010001f,0.54050001f,0.31150001f,1.28159994f,-1.54619996f,-0.22110002f,0.75550003f,-0.81039998f,-0.64870000f,-0.52479999f,-0.20400000f,-0.37150005f,-1.84119999f,-0.48909998f,0.38809994f,-0.24389994f,-2.24880000f,-0.37750005f,0.51469998f,-0.77800001f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,1.70819999f,-0.70470001f,-0.91959996f,0.17130000f,2.17200004f,-0.47710004f,-0.32939999f,0.54180000f,0.12559999f,0.20380000f,-0.64949998f,0.47959997f,-1.11740005f,1.37210004f,-1.28520002f,0.50730002f,-0.77089999f,-0.52059999f,0.00219993f,-0.14899996f,0.78790003f,-0.33330000f,-0.23299998f,0.96030005f,-0.27530004f,0.45630002f,1.15390000f,0.06480001f,0.21280000f,0.40180000f,0.66959996f,0.75580000f,0.36220001f,1.39570001f,-0.43590004f,0.19130002f,1.41070003f,0.01540000f,-0.94389997f,-0.26370004f,1.03070003f,0.27249999f,-0.05770003f,-0.36729998f,1.11990000f,-0.15699999f,0.21490003f,-1.38730003f,-0.63709999f,-0.74560006f,-1.63190001f,2.04080007f,-0.07280000f,-0.34090002f,0.96050000f,-0.47139999f,0.10160003f,0.59440001f,0.27909997f,-0.50960001f,-0.01619999f,0.96540003f,-0.38840001f,0.01019997f,2.13250005f,0.76340000f,-0.66959999f,-0.40520000f,-0.68210002f,0.78360002f,-0.06359999f,-0.06300001f,0.02640004f,-0.14490003f,-1.17169999f,0.37380004f,-0.07010003f,0.69090004f,-0.81240002f,1.63950005f,0.70270000f,1.51700006f,0.70649999f,0.05960000f,0.05100001f,0.34200000f,1.20320001f,0.60779999f,0.21140004f,-0.81310001f,1.03049999f,-0.89480002f,1.25980000f,1.61000001f,0.57050002f,0.20920003f,-0.66569999f,0.40300000f,0.01389997f,-0.81960001f,0.33050001f,-0.20590003f,0.51840000f,0.48029997f,-1.26290002f,0.63629999f,0.32610007f,-1.57170002f,-1.39789999f,0.08989998f,-1.21000006f,0.07690005f,0.54710000f,-0.22600000f,-1.29040002f,2.04860005f,-1.08230008f,-0.77310002f,1.32410004f,-0.55170002f,-1.11700007f,-0.50539999f,1.37930000f,0.97350001f,-0.84790002f,-1.52540005f,0.05220003f,0.51349997f,0.02509999f,-0.10899997f,-1.63580003f,0.08740001f,0.36849999f,-0.16799998f,-0.87570000f,1.20690001f,0.33340001f,-0.52590002f,-1.39800003f,0.18350000f,-0.16409996f,0.25999999f,-0.21980003f,1.13090002f,0.41269999f,0.60020002f,-0.05270003f,-0.37080003f,-0.45329999f,-0.86679999f,0.49770004f,0.58519997f,0.24000001f,1.01640003f,0.98790002f,1.39349998f,-1.12349998f,0.71100001f,-0.63360003f,-1.00090003f,1.00350002f,-0.33000000f,0.68080005f,-0.66940003f,-0.68990001f,-0.77720003f,-0.14900000f,0.92430002f,0.50950001f,-0.01900004f,1.64840005f,0.66470001f,-1.28290003f,-0.50520001f,0.80540004f,-0.59429995f,0.42730000f,-0.92570004f,-0.69509999f,1.11669999f,0.09210003f,-1.34970000f,-0.01919999f,-0.46869999f,-0.55349999f,1.60120002f,0.51849999f,-0.02819999f,0.26690000f,-0.82230003f,0.34150003f,0.79310000f,-0.68470002f,0.83450003f,0.76120000f,0.03040001f,1.03230007f,0.90230000f,-1.13090002f,0.09400007f,2.44960004f,0.88949995f,-1.04600002f,-0.43099998f,-0.13830000f,-1.75859999f,-0.06049997f,0.16639999f,0.29579999f,-0.82020003f,0.05150003f,1.07360003f,-1.90650006f,-1.12840001f,1.15649998f,0.33699995f,-0.81289998f,-0.98140001f,1.07860002f,0.50750002f,-1.42510003f,-0.79759999f,-0.11680007f,0.07450000f,0.71390006f,-1.25060002f,-0.13329998f,1.51510003f,-1.14549998f,-0.63750001f,1.45709998f,0.57180002f,0.47019996f,0.34800003f,-0.42870000f,-0.37040002f,0.16730002f,-0.80640002f,0.92590003f,0.66979996f,-1.21990000f,-0.45779996f,-0.03120000f,0.72600002f,-1.16520005f,-0.62770000f,1.36549999f,0.08169999f,0.35510002f,-0.45019999f,1.39230007f,0.62249996f,0.06969997f,-0.51800003f,-0.21090001f,1.39010005f,0.41939999f,-0.86080004f,0.88300004f,0.77470003f,0.29410005f,-0.82760004f,0.98100001f,0.65350000f,-0.33110000f,-0.58690003f,-0.02269998f,-0.21209999f,0.44020001f,-0.33890004f,0.12680000f,1.11519997f,-0.52470000f,-0.63939999f,0.48590000f,0.57859995f,-1.43250000f,0.23720002f,0.00529998f,0.43250001f,-0.08730000f,-0.32390004f,-0.33380001f,-1.46100003f,0.48330005f,0.92679999f,-0.67760001f,0.96950004f,-0.52119998f,-2.15830009f,0.20300001f,0.46679999f,-1.44260003f,1.60800001f,-0.58990001f,-0.06530001f,1.00740000f,-1.26930004f,-0.61680002f,0.48129995f,-1.13649999f,0.46270002f,0.28629997f,-1.13759998f,-0.56299999f,-0.30180003f,-0.21210001f,0.95690002f,-1.61929996f,0.80020002f,-0.51110003f,-1.43609998f,0.62320000f,-0.17820002f,-0.61889999f,-1.68890006f,0.64130004f,2.25600001f,-1.00000002f,0.50520003f,-0.68090003f,-0.59459998f,0.71710002f,0.25540001f,-0.36519999f,0.60620003f,-0.50970002f,1.35370000f,-0.40709999f,1.70380001f,1.06719999f,-1.55809997f,-2.08250009f,-0.95010001f,1.18990002f,-0.04840003f,-0.97720002f,-0.90159999f,0.33069999f,-0.11650000f,-0.94169997f,0.18189999f,-0.12390000f};

    backend->call(function, {result}, {a, b});
    EXPECT_TRUE(test::all_close<float>(vector<float>{expected_result}, read_vector<float>(result), 1.0e-4f, 1.0e-6f));
    // only test backprop for certain cases as it takes significant compute resources
    if(false) {
        EXPECT_TRUE(autodiff_numeric_compare<float>(backend, make_graph, {a, b}, .01f, .01f));
    }
}

// clang-format on
